prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4418
,p_default_id_offset=>0
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4418 - Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--
-- Application Export:
--   Application:     4418
--   Name:            Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Lists:                  3
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 2
--           Region:               1
--           Label:                1
--           List:                 1
--           Popup LOV:            1
--           Calendar:             3
--           Breadcrumb:           2
--           Button:               1
--           Report:               1
--         Plug-ins:             133
--       Globalization:
--         Messages:          13,405
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Builder, Wizard Messages and Native Plug-Ins')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A110306153261364541')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'N'
,p_checksum_salt_last_reset=>'20211020110857'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'zh-tw'
,p_flow_language_derived_from=>'SESSION'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(91645213681389498.4418)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'UNAVAILABLE'
,p_flow_unavailable_text=>'This application is currently unavailable.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_deep_linking=>'Y'
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'N'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020112720'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_global
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562090986404402217.4418)
,p_name=>'Spotlight \ Custom Entries - Global'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(48650898565635010.4418)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('\767B\51FA')
,p_list_item_link_target=>'&LOGOUT_URL.'
,p_list_text_01=>unistr('\767B\51FA Application Express')
,p_list_text_09=>'Y'
,p_list_text_10=>'logout exit quit :q'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(281916990329150760.4418)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('\4EE5\8A66\7B97\8868\5EFA\7ACB\61C9\7528\7A0B\5F0F')
,p_list_item_link_target=>'f?p=4000:56:&APP_SESSION.::NO:56,103,104,106,130,131,35,227,3020,3000,3001'
,p_list_text_01=>unistr('\532F\5165\60A8\7684 excel \6216 csv \6A94\6848\4E26\5EFA\7ACB\61C9\7528\7A0B\5F0F')
,p_list_text_09=>'Y'
,p_list_text_10=>'excel csv xsl xslx spreadsheet data paste load import'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(282255839842182292.4418)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Oracle APEX \9996\9801')
,p_list_item_link_target=>'f?p=4500:1000:&APP_SESSION.'
,p_list_text_10=>unistr('\9996\9801\958B\59CB')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(296033420364984683.4418)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('\700F\89BD\5B57\578B APEX \5716\793A')
,p_list_item_link_target=>'javascript:apex.navigation.openInNewWindow(''https://apex.oracle.com/fontapex'');'
,p_list_text_01=>unistr('\700F\89BD\5B57\578B APEX \5716\793A\3001\65B0\589E\4FEE\98FE\689D\4EF6\4EE5\53CA\8907\88FD\60A8\9700\8981\7684 CSS \6216 HTML.')
,p_list_text_09=>'Y'
,p_list_text_10=>'icons font apex library graphics'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_app_level
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562091518091404815.4418)
,p_name=>'Spotlight \ Custom Entries - App Level'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(562091727563404815.4418)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('\532F\51FA\61C9\7528\7A0B\5F0F')
,p_list_item_link_target=>'f?p=4000:4900:&SESSION.::NO:::'
,p_list_text_01=>unistr('\5C07\61C9\7528\7A0B\5F0F {APP_ID} \532F\51FA\6210 SQL \6A94\6848')
,p_list_text_09=>'Y'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(562093357853428158.4418)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('\672A\4F7F\7528\7684\6E05\55AE')
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_page_designer
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562092153904409717.4418)
,p_name=>'Spotlight \ Custom Entries - Page Designer'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14843831009863117.4418)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14859012524941040.4418)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(86380554411225400.4418)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_RICH_TEXT_EDITOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(91997339122572414.4418)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(99844881073888905.4418)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(146861159122292557.4418)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176128961688506820.4418)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176129003012506820.4418)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(183033629816949774.4418)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(460407779408652225.4418)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.APEX.STARRATING_MODERN'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(497671453666914719.4418)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_STAR_RATING'
,p_attribute_01=>'fa-star'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(592236161067709447.4418)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(631035363954639049.4418)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1082458703597614427.4418)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1082517678315623391.4418)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1765072678475712055.4418)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831649180083980462.4418)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831780276458994154.4418)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1832884277947217587.4418)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COLOR_PICKER'
,p_attribute_01=>'modern'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1840861033969283097.4418)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_DISPLAY_SELECTOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1917665913120940054.4418)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1990227023531717243.4418)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_CSS_CALENDAR'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/one_level_tabs
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(91626406749381989.4418)
,p_theme_id=>1
,p_name=>'One Level Tabs.zh-tw'
,p_internal_name=>'ONE_LEVEL_TABS'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td valign="top" class="t1Logo">#LOGO##REGION_POSITION_06#</td>',
'	<td valign="top" width="100%">#REGION_POSITION_07#</td>',
'    <td align="right" valign="top">#NAVIGATION_BAR##REGION_POSITION_08#</td>',
'  </tr>',
'</table>',
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="" height="70%">',
'  <tr>',
'    <td colspan="5" class="t1ParentTabHolder"><table border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#TAB_CELLS#</tr></table></td>',
'  </tr>',
'  <tr>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_left.png" alt="" /></td>',
'    <td class="t1topbarMiddle" valign="bottom"><table cellpadding="0" cellspacing="0" border="0" summary=""><tr><td height="50%"><br /></td></tr><tr><td height="50%">#REGION_POSITION_01#</td></tr></table></td>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_right.png" alt="" /></td>',
'  </tr>',
'<tr>',
'<td><br /></td>',
'<td class="t1PageCenter" colspan="2" valign="top" height="100%"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top" class="t1PageBody"><div class="t1messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BODY##REGION_POSITION_02##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_left.png" alt="" /></td>',
'    <td class="t1BotbarMiddle"><div id="t1user">&APP_USER.</div></td>',
'    <td class="t1BotbarMiddle"><div id="t1copy"><!-- Copyright Here --><span class="t1Customize">#CUSTOMIZE#</span></div></td>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_right.png" alt="" /></td>',
'  </tr>',
'</table>',
'<br />',
'#REGION_POSITION_05#',
'#FORM_CLOSE# ',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>'<div class="t1success">#SUCCESS_MESSAGE#</div>'
,p_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOn">#TAB_LABEL##TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_right.png" border="0" alt="" /></td>',
'',
''))
,p_non_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOff"><a href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_right.png" border="0" alt="" /></td>',
''))
,p_notification_message=>'<div class="t1notification">#MESSAGE#</div>'
,p_navigation_bar=>'<div class="t1NavigationBar">#BAR_BODY#</div>'
,p_navbar_entry=>'<a href="#LINK#" class="t1NavigationBar">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>1
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'12'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001488931349566.4418)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4418)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001517815349566.4418)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4418)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001699115349566.4418)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4418)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001740672349566.4418)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4418)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001820430349566.4418)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4418)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001949447349565.4418)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4418)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002088971349565.4418)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4418)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002117005349565.4418)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4418)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002264345349565.4418)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4418)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/printer_friendly
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(91626529080381989.4418)
,p_theme_id=>1
,p_name=>'Printer Friendly.zh-tw'
,p_internal_name=>'PRINTER_FRIENDLY'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top">',
'<div style="border:1px solid black;">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>',
'#BODY##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE##DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_theme_class_id=>5
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'3'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002343913349565.4418)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4418)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002490586349565.4418)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4418)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002552177349565.4418)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4418)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(91626823864381990.4418)
,p_template_name=>'Button'
,p_internal_name=>'BUTTON'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="t1Button" cellspacing="0" cellpadding="0" border="0"  summary="">',
'<tr>',
'<td class="t1L"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_left.gif" alt="" width="4" height="24" /></a></td>',
'<td class="t1C"><a href="#LINK#">#LABEL!HTML#</a></td>',
'<td class="t1R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_right.gif" width="4" height="24" alt="" /></a></td>',
'</tr>',
'</table>'))
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/region/reports_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(91632832228382001.4418)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ReportsRegion" id="#REGION_ID#">',
'<tr>',
'<td class="t1RegionHeader">#TITLE#</td>',
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>',
'</tr>',
'<tr>',
'<td class="t1Body" colspan="2">#BODY#</td>',
'</tr>',
'</table>'))
,p_page_plug_template_name=>'Reports Region'
,p_internal_name=>'REPORTS_REGION'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>1
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
,p_template_comment=>'Red Theme'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382691031344638.4418)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4418)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382773788344638.4418)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4418)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382895312344637.4418)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4418)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382923760344637.4418)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4418)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383001370344637.4418)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4418)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383101590344637.4418)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4418)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383260593344637.4418)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4418)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383343091344637.4418)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4418)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383417298344637.4418)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4418)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383590781344637.4418)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4418)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(91636711305382010.4418)
,p_list_template_current=>'<li class="t1current">#TEXT#</li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#">#TEXT#</a></li>'
,p_list_template_name=>'Vertical Unordered List with Bullets'
,p_internal_name=>'VERTICAL_UNORDERED_LIST_WITH_BULLETS'
,p_theme_id=>1
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="t1VerticalUnorderedListwithBullets">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/standard
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(91638400927382012.4418)
,p_row_template_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t1data">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#',
'<tr>',
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t1standard">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table><div class="t1CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>',
'</tr>',
'#PAGINATION#',
'</table>'))
,p_row_template_before_first=>'<tr #HIGHLIGHT_ROW#>'
,p_row_template_after_last=>'</tr>'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t1header">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_next_page_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_page_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>'
,p_next_set_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_set_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>1
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional_with_help
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(91641225667382016.4418)
,p_template_name=>'Optional with help'
,p_internal_name=>'OPTIONAL_WITH_HELP'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999"><a class="t1OptionalwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_before_label=>'<div class="t1InlineError">'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(91641730492382017.4418)
,p_name=>'Hierarchical Menu'
,p_internal_name=>'HIERARCHICAL_MENU'
,p_before_first=>'<ul class="t1HierarchicalMenu">'
,p_current_page_option=>'<li class="t1current">#NAME#</li>'
,p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>11
,p_start_with_node=>'CHILD_MENU'
,p_theme_id=>1
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumb_menu
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(91641814330382017.4418)
,p_name=>'Breadcrumb Menu'
,p_internal_name=>'BREADCRUMB_MENU'
,p_before_first=>'<div class="t1BreadcrumbMenu">'
,p_current_page_option=>'<span class="t1current">#NAME#</span>'
,p_non_current_page_option=>'<a href="#LINK#">#NAME#</a>'
,p_between_levels=>'&nbsp;&gt;&nbsp;'
,p_after_last=>'</div>'
,p_max_levels=>12
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(91642503902382024.4418)
,p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif'
,p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"'
,p_page_name=>'winlov'
,p_page_title=>unistr('\641C\5C0B\5C0D\8A71\65B9\584A')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#APEX_JAVASCRIPT#',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V2.css" type="text/css">',
'',
'#THEME_CSS#',
'</head>'))
,p_page_body_attr=>'onload="first_field()" style="margin:0;"'
,p_before_field_text=>'<div class="t1PopupHead">'
,p_filter_width=>'20'
,p_filter_max_width=>'100'
,p_find_button_text=>unistr('\641C\5C0B')
,p_close_button_text=>unistr('\95DC\9589')
,p_next_button_text=>unistr('\4E0B\4E00\6B65 >')
,p_prev_button_text=>unistr('< \4E0A\4E00\6B65')
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'400'
,p_height=>'450'
,p_result_row_x_of_y=>unistr('<br /><div style="padding:2px; font-size:8pt;">\8CC7\6599\5217  #FIRST_ROW# - #LAST_ROW#</div>')
,p_result_rows_per_pg=>500
,p_before_result_set=>'<div class="t1PopupBody">'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/small_calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91641910982382018.4418)
,p_cal_template_name=>'Small Calendar'
,p_internal_name=>'SMALL_CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#DY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallCalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#" class="t1SmallCalendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>'))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallWeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br />#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1SmallWeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallDayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL#" class="t1SmallDayCalendar">'
,p_daily_month_close_format=>'</table></td></tr></table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91642102481382020.4418)
,p_cal_template_name=>'Calendar'
,p_internal_name=>'CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t1Calendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendar">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar_alternative_1
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91642303533382020.4418)
,p_cal_template_name=>'Calendar, Alternative 1'
,p_internal_name=>'CALENDAR,_ALTERNATIVE_1'
,p_day_of_week_format=>'<th scope="col" valign="bottom" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarAlternative1Holder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t1CalendarAlternative1">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top" height="100" height="100">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarAlternative1Holder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendarAlternative1">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarAlternative1Holder"> <tr><td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td></tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendarAlternative1">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>2
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_options
begin
null;
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108888036079313278)
,p_name=>'2DCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('2D \67F1\72C0\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108890124872313279)
,p_name=>'2DCOLUMN_LINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('2D \67F1\72C0\6298\7DDA\5716')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108888182909313278)
,p_name=>'2DDOUGHNUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('2D \74B0\5708\5716')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108889906838313279)
,p_name=>'2DHSTACKED_PCT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C34\5E73\5806\758A 2D \67F1\72C0\5716 (\767E\5206\6BD4)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108888239250313278)
,p_name=>'2DLINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('2D \6298\7DDA\5716')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108888339377313278)
,p_name=>'2DPIE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('2D \5713\9905\5716')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108889778502313279)
,p_name=>'2DSTACKED_PCT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5806\758A 2D \67F1\72C0\5716 (\767E\5206\6BD4)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108888420780313278)
,p_name=>'3DCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('3D \67F1\72C0\5716')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108890083446313279)
,p_name=>'3DHSTACKED_PCT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C34\5E73\5806\758A 3D \67F1\72C0\5716 (\767E\5206\6BD4)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108888559344313278)
,p_name=>'3DPIE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('3D \5713\9905\5716')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108889805127313279)
,p_name=>'3DSTACKED_PCT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5806\758A 3D \67F1\72C0\5716 (\767E\5206\6BD4)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109657972535313876)
,p_name=>'4000.912.0.ITEMS.FOR.INSERT.INTO.AD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\8981\63D2\5165\300C\5C6C\6027\5B57\5178\300D\4E2D\7684\300C\9805\76EE\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109657796196313876)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\8981\66F4\65B0\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109658112993313876)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE.OF.AD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\7528\4EE5\66F4\65B0\300C\5C6C\6027\5B57\5178\300D\7684\300C\9805\76EE\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109658537179313877)
,p_name=>'4000.912.0.RC.FOR.INSERT.INTO.AD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\8981\63D2\5165\300C\5C6C\6027\5B57\5178\300D\4E2D\7684\300C\5831\8868\8CC7\6599\6B04\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109658713962313877)
,p_name=>'4000.912.0.RC.FOR.UPDATE.OF.AD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\7528\4EE5\66F4\65B0\300C\5C6C\6027\5B57\5178\300D\7684\300C\5831\8868\8CC7\6599\6B04\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109657606320313876)
,p_name=>'4000.912.REVIEW.N.ITEMS.FOR.UPDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\67E5 %0 \500B\8981\66F4\65B0\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109658319943313877)
,p_name=>'4000:912:0.RC.FOR.UPDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\8981\66F4\65B0\7684\300C\5831\8868\8CC7\6599\6B04\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109657847225313876)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.INSERT.INTO.AD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\67E5\8981\63D2\5165\300C\5C6C\6027\5B57\5178\300D\4E2D\7684 %0 \500B\300C\9805\76EE\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109658010605313876)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.UPDATE.OF.AD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\67E5\7528\4EE5\66F4\65B0\300C\5C6C\6027\5B57\5178\300D\7684 %0 \500B\300C\9805\76EE\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109658409730313877)
,p_name=>'4000:912:REVIEW.N.RC.FOR.INSERT.INTO.AD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\67E5\8981\63D2\5165\300C\5C6C\6027\5B57\5178\300D\4E2D\7684 %0 \500B\300C\5831\8868\8CC7\6599\6B04\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109658211772313877)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\67E5 %0 \500B\8981\66F4\65B0\7684\300C\5831\8868\8CC7\6599\6B04\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109658676120313877)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE.OF.AD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\67E5\7528\4EE5\66F4\65B0\300C\5C6C\6027\5B57\5178\300D\7684 %0 \500B\300C\5831\8868\8CC7\6599\6B04\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109450380098313714)
,p_name=>'4000_424_VALUE_MUST_BE_NUMERIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\5FC5\9808\662F\6578\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109435595095313702)
,p_name=>'4000_639_SEQ_MESG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<span class="fielddata"> \7121\6CD5\91CD\65B0\6392\5217, \56E0\70BA\300C\5340\57DF\300D\9806\5E8F\4E0D\662F\552F\4E00\7684.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109435657405313702)
,p_name=>'4000_641_SEQ_MESG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<span class="fielddata">\7121\6CD5\91CD\65B0\6392\5217, \56E0\70BA\300C\6309\9215\300D\9806\5E8F\4E0D\662F\552F\4E00\7684.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109435702944313702)
,p_name=>'4000_646_SEQ_MESG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<span class="fielddata">\7121\6CD5\91CD\65B0\6392\5217, \56E0\70BA\300C\5C0E\89BD\5217\300D\9806\5E8F\4E0D\662F\552F\4E00\7684.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109435825280313702)
,p_name=>'4000_749_SEQ_MESG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<span class="fielddata">\7121\6CD5\91CD\65B0\6392\5217, \56E0\70BA\300C\5340\57DF\9805\76EE\300D\9806\5E8F\4E0D\662F\552F\4E00\7684.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109504797899313754)
,p_name=>'4000_APPLICATION_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109019449961313385)
,p_name=>'4000_EDIT_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\61C9\7528\7A0B\5F0F: %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109409074232313682)
,p_name=>'4000_INVALID_DATE_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\65E5\671F\683C\5F0F\7121\6548.  \884C\4E8B\66C6\65E5\671F\683C\5F0F\5FC5\9808\662F YYYYMMDD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109455094863313717)
,p_name=>'4000_TREE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109504809800313754)
,p_name=>'4000_WORKSPACE_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340 ID')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109299401886313599)
,p_name=>'4050_106_ENTER_SCHEMA_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5EFA\7ACB\4E4B\65B0\7DB1\8981\7684\540D\7A31. \8ACB\9078\64C7\7DB1\8981\7684\5BC6\78BC, \7136\5F8C\9078\64C7\9810\8A2D\7684\8868\683C\7A7A\9593\548C\66AB\6642\8868\683C\7A7A\9593.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109299548777313599)
,p_name=>'4050_106_EXISTING_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\73FE\6709\7DB1\8981\7684\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109299624605313599)
,p_name=>'4050_106_WHEN_DONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210\5F8C, \6309\4E00\4E0B<strong>\4E0B\4E00\6B65</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109169780145313498)
,p_name=>'4050_110_DROP_TABLESPACES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\8868\683C\7A7A\9593\548C\76F8\95DC\7684\8CC7\6599\6A94: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109169608972313497)
,p_name=>'4050_110_DROP_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\8CC7\6599\5EAB\4F7F\7528\8005: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110033520845314167)
,p_name=>'4050_139_WEB_SERVICE_ACTIVITY_LOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \670D\52D9\6D3B\52D5\65E5\8A8C\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108881609152313273)
,p_name=>'4050_162_WEB_SOURCE_SYNC_LOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \540C\6B65\5316\65E5\8A8C\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108882457522313274)
,p_name=>'4050_182_AUTOMATION_LOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5316\65E5\8A8C\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109293311589313594)
,p_name=>'4050_19_LOG_ENTRIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\767C\4EBA\54E1\6D3B\52D5\65E5\8A8C\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108932288216313312)
,p_name=>'4050_31_LOG_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\767B\5165\5B58\53D6\65E5\8A8C\300D\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109292847631313594)
,p_name=>'4050_3_CHANGE_REQUESTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109292981344313594)
,p_name=>'4050_3_RUNTIME_REQUESTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A0B\5F0F\5BE6\969B\57F7\884C\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109292627300313594)
,p_name=>'4050_3_SERVICE_REQUESTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109295176937313596)
,p_name=>'4050_46_AD_HOC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300CSQL \547D\4EE4\8655\7406\5668\300D\6B77\53F2\8A18\9304\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109295001564313596)
,p_name=>'4050_46_CONTROL_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\63A7\5236\6A94\300D\57F7\884C\65E5\8A8C\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109294901805313595)
,p_name=>'4050_46_SCRIPT_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\547D\4EE4\6A94\6A94\6848\300D\57F7\884C\65E5\8A8C\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109295234467313596)
,p_name=>'4050_46_SQL_ARCHIVES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300CSQL \5B58\6A94\300D\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109296973192313597)
,p_name=>'4050_61_ACTIVE_LOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F5C\7528\4E2D\65E5\8A8C\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109297085266313597)
,p_name=>'4050_61_CURRENT_LOG_NO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\65E5\8A8C\7DE8\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109297144883313597)
,p_name=>'4050_61_CUR_LOG_TIME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\65E5\8A8C\6642\6233')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109297776170313598)
,p_name=>'4050_61_HOURS_UNTIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8DDD\96E2\4E0B\4E00\6B21\65E5\8A8C\5207\63DB\7684\6642\9593 (\5C0F\6642)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109297376804313597)
,p_name=>'4050_61_INTERVAL_DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5929\6578\9593\9694 (\5E38\6578)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109297645493313597)
,p_name=>'4050_61_NEXT_LOG_SWITCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5B9A\7684\4E0B\4E00\6B21\65E5\8A8C\5207\63DB, \91DD\5C0D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109298002721313598)
,p_name=>'4050_70_DEV_ACT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\767C\4EBA\54E1\6D3B\52D5\65E5\8A8C\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109298258050313598)
,p_name=>'4050_71_CLICK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F4\63A5\9023\7D50\65E5\8A8C\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109299016914313598)
,p_name=>'4050_75_AD_HOC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300CSQL \547D\4EE4\8655\7406\5668\300D\6B77\53F2\8A18\9304\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109298919671313598)
,p_name=>'4050_75_CTRL_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\63A7\5236\6A94\300D\57F7\884C\65E5\8A8C\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109298719158313598)
,p_name=>'4050_75_SCRIPT_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\547D\4EE4\6A94\6A94\6848\300D\57F7\884C\65E5\8A8C\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109299119154313599)
,p_name=>'4050_75_SQL_ARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300CSQL \5B58\6A94\300D\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109299286432313599)
,p_name=>'4050_82_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340 %1 \6709 %2 \500B\61C9\7528\7A0B\5F0F\548C %3 \500B\4F7F\7528\8005.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109299338373313599)
,p_name=>'4050_85_CLICK_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\9EDE\9078\8A08\6578\300D\65E5\8A8C\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109480449627313736)
,p_name=>'4050_PACKAGED_APPLICATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\751F\7522\529B\548C\7BC4\4F8B\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109480575298313736)
,p_name=>'4050_PACKAGED_WEBSHEETS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B Web \8A66\7B97\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109479781081313735)
,p_name=>'4050_WORKSPACE_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\8A08\6578')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109226821213313540)
,p_name=>'4350_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109226970066313540)
,p_name=>'4350_EDIT_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\61C9\7528\7A0B\5F0F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108946700424313323)
,p_name=>'4500 800 HD DBA'
,p_message_language=>'zh-tw'
,p_message_text=>'Oracle Database Express Edition 2 Day DBA.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108946826266313324)
,p_name=>'4500 800 HD DEV'
,p_message_language=>'zh-tw'
,p_message_text=>'Oracle Database Express Edition 2 Day Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108946689667313323)
,p_name=>'4500 800 HD HTMLDB'
,p_message_language=>'zh-tw'
,p_message_text=>'Oracle Application Express 2 Day Plus Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108946923755313324)
,p_name=>'4500 800 HD JAVA'
,p_message_language=>'zh-tw'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus Java Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108947084342313324)
,p_name=>'4500 800 HD NET'
,p_message_language=>'zh-tw'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus .NET Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108947111476313324)
,p_name=>'4500 800 HD PHP'
,p_message_language=>'zh-tw'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus PHP Developer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108947219083313324)
,p_name=>'4500 800 MSG DBA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E\4E00\822C\65E5\5E38\7684\7BA1\7406\5DE5\4F5C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108947387332313324)
,p_name=>'4500 800 MSG DEV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E\5982\4F55\5584\52A0\5229\7528 Oracle Database Express Edition \958B\767C\74B0\5883.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108947460515313324)
,p_name=>'4500 800 MSG HTMLDB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\4E00\7CFB\5217\7684\6559\5B78\8AB2\7A0B, \8AAA\660E\5982\4F55\7D44\5EFA\4EE5\8CC7\6599\5EAB\70BA\4E2D\5FC3\7684 Web \61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108947659640313324)
,p_name=>'4500 800 MSG JAVA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\6587\4EF6\63D0\4F9B\7684\6559\5B78\8AB2\7A0B\5305\542B\5982\4F55\4F7F\7528 Java \548C JDBC \4F86\9023\7DDA Oracle Database XE, \4EE5\53CA\5982\4F55\7528\4F86\958B\767C\5B58\53D6\53CA\4FEE\6539\8CC7\6599\7684\7C21\55AE Java \61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108947780293313324)
,p_name=>'4500 800 MSG NET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\6587\4EF6\8AAA\660E Oracle Data Provider for .NET \548C Oracle Developer Tools for Visual Studio .NET \7684\4E3B\8981\529F\80FD. \5B83\9010\6B65\5F15\5C0E\60A8\5B8C\6210\5B89\88DD\548C\8A2D\5B9A\7D44\614B\7684\5DE5\4F5C, \8AAA\660E\5982\4F55\4F7F\7528 Oracle Data Provider for .NET \548C Oracle Developer Tools for Visual Studio .NET \7D44\5EFA\57FA\672C\7684\61C9\7528\7A0B\5F0F, \4EE5\53CA\5982\4F55\5EFA\7ACB\4E26\4F7F\7528 PL/SQL \548C .NET \9810\5B58\7A0B\5E8F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108947529192313324)
,p_name=>'4500 800 MSG PHP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\6587\4EF6\63D0\4F9B\7684\6559\5B78\8AB2\7A0B\5305\542B\5982\4F55\4E0B\8F09\4E26\5B89\88DD Apache \548C Zend Core PHP \9A45\52D5\7A0B\5F0F, \5982\4F55\4F7F\7528 PHP \4F86\9023\7DDA Oracle Database XE, \4EE5\53CA\5982\4F55\4F7F\7528 PHP \4F86\958B\767C\5B58\53D6\53CA\4FEE\6539\8CC7\6599\7684\7C21\55AE\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108918253158313301)
,p_name=>'4500_1002_QB_CLONE_ALIAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108918184112313301)
,p_name=>'4500_1002_QB_CLONE_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108918417443313301)
,p_name=>'4500_1002_QB_CLONE_CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109350009656313637)
,p_name=>'4500_1002_QB_CLONE_DEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108918852716313302)
,p_name=>'4500_1002_QB_CLONE_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108918963508313302)
,p_name=>'4500_1002_QB_CLONE_GROUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44\4F9D\64DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108918376566313301)
,p_name=>'4500_1002_QB_CLONE_OBJECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108918769119313301)
,p_name=>'4500_1002_QB_CLONE_OUTPUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108918553198313301)
,p_name=>'4500_1002_QB_CLONE_SORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5E8F\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108918665618313301)
,p_name=>'4500_1002_QB_CLONE_SORT_ORDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5E8F\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108921436633313304)
,p_name=>'4500_1002_QB_JOIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108915293854313299)
,p_name=>'4500_1002_QB_JOIN_HINT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E00\4E0B\6B64\8655\53EF\9078\53D6\8981\7D50\5408\7684\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108921856623313304)
,p_name=>'4500_1002_QB_MAX_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\591A\53EF\4EE5\9078\53D6 60 \500B\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108915196137313299)
,p_name=>'4500_1002_QB_REMOVE_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108915078696313299)
,p_name=>'4500_1002_QB_SHOW_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A/\96B1\85CF\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108921507052313304)
,p_name=>'4500_1002_QB_TO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108914060451313298)
,p_name=>'4500_1220_SCRIPT_RESULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \7684\7D50\679C, \57F7\884C %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109170371826313498)
,p_name=>'4500_46_RET_TO_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8FD4\56DE\539F\59CB\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108929267215313310)
,p_name=>'4500_OBJECT_BROWSER_ONLY_N_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\524D %0 \500B\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109377688119313658)
,p_name=>'4500_SESS_EVENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109377594751313658)
,p_name=>'4500_SESS_KILOBYTES'
,p_message_language=>'zh-tw'
,p_message_text=>'KB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109377453785313658)
,p_name=>'4500_SESS_MEGABYTES'
,p_message_language=>'zh-tw'
,p_message_text=>'MB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108950085694313326)
,p_name=>'4500_UI_DEF_HINT_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7522\751F\5668\4F7F\7528\300C\4F7F\7528\8005\4ECB\9762\9810\8A2D\503C\300D\7522\751F\5340\57DF\548C\9805\76EE\7279\6027\7684\6700\521D\503C, \4EE5\63D0\4F9B\55AE\4E00\61C9\7528\7A0B\5F0F\4E2D\6216\591A\500B\61C9\7528\7A0B\5F0F\9593\591A\500B\9801\9762\7684\4E00\81F4\6027.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108980131583313350)
,p_name=>'4550_COOKIES_ENABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\61C9\7528\7A0B\5F0F\9700\8981\555F\7528 Cookie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108980095464313350)
,p_name=>'4550_JAVASCRIPT_ENABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\61C9\7528\7A0B\5F0F\9700\8981\555F\7528 JavaScript.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109407337607313680)
,p_name=>'ABOUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\65BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110100848381314232)
,p_name=>'ABOUT_TO_CREATE_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\78BA\8A8D\8981\5C07\4E0B\5217 %0 \4F4D\4F7F\7528\8005\65B0\589E\81F3\60A8\7684\5DE5\4F5C\5340.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109418830463313689)
,p_name=>'ACCEPTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\63A5\53D7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109386920961313665)
,p_name=>'ACCESSIBILITY_ASSIGNEE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F14\52A9\529F\80FD\6307\5B9A\5C0D\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109385049088313664)
,p_name=>'ACCESSIBILITY_IMPACT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F14\52A9\529F\80FD\5F71\97FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109387384808313665)
,p_name=>'ACCESSIBILITY_STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F14\52A9\529F\80FD\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110151757734314273)
,p_name=>'ACCESSIBILITY_TESTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F14\52A9\529F\80FD\5DF2\6E2C\8A66')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109060528811313416)
,p_name=>'ACCESS_CONTROL_ADMIN_AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\6B0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108926823302313308)
,p_name=>'ACCESS_CONTROL_ADMIN_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236\7BA1\7406\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109339261647313629)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\54E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109444193106313709)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE_DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7D66\61C9\7528\7A0B\5F0F\7BA1\7406\54E1\7684\89D2\8272.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108927095751313308)
,p_name=>'ACCESS_CONTROL_APP_ADMIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108927631543313308)
,p_name=>'ACCESS_CONTROL_APP_MODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108927567798313308)
,p_name=>'ACCESS_CONTROL_APP_MODE_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5982\4F55\63A7\5236\6B64\61C9\7528\7A0B\5F0F\7684\5B58\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108928626823313309)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8655\7406\8A2D\5B9A\61C9\7528\7A0B\5F0F\6A21\5F0F\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108928745456313309)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8A2D\5B9A\61C9\7528\7A0B\5F0F\6A21\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109060998903313416)
,p_name=>'ACCESS_CONTROL_CANNOT_DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\4E0D\80FD\5C07\81EA\5DF1\522A\9664.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109061048121313416)
,p_name=>'ACCESS_CONTROL_CANNOT_REMOVE_ADMIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\4E0D\80FD\79FB\9664\81EA\5DF1\7684\7BA1\7406\54E1\6B0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108926941358313308)
,p_name=>'ACCESS_CONTROL_CONFIRM_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109339116259313629)
,p_name=>'ACCESS_CONTROL_CONTRIB_AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\8207\6B0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109339378546313629)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109444260476313709)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE_DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7D66\61C9\7528\7A0B\5F0F\63D0\4F9B\8005\7684\89D2\8272.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109379816205313660)
,p_name=>'ACCESS_CONTROL_CREATE_APP_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\5EFA\7ACB\4E0B\5217\61C9\7528\7A0B\5F0F\8A2D\5B9A\503C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109339466391313629)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_ROLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\5EFA\7ACB\4E0B\5217\61C9\7528\7A0B\5F0F\5B58\53D6\89D2\8272:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108944261888313321)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\5EFA\7ACB\4E0B\5217\6388\6B0A\914D\7F6E:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109000081840313371)
,p_name=>'ACCESS_CONTROL_CREATE_PAGE_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\5B58\53D6\63A7\5236\9801\9762. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108999997527313371)
,p_name=>'ACCESS_CONTROL_CREATE_TABLE_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\5B58\53D6\63A7\5236\8868\683C. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109062308937313417)
,p_name=>'ACCESS_CONTROL_DUP_USERNAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\4E0D\80FD\8F38\5165\91CD\8907\7684\4F7F\7528\8005\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109060681858313416)
,p_name=>'ACCESS_CONTROL_EDIT_AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236 - \7DE8\8F2F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108928382312313309)
,p_name=>'ACCESS_CONTROL_FIND_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\67E5\8A62\689D\4EF6 (\6C92\6709\5927\5C0F\5BEB\4E4B\5206), \7136\5F8C\6309<strong>\57F7\884C</strong>\6309\9215.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108928427603313309)
,p_name=>'ACCESS_CONTROL_GET_APP_MODE_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\5F97\61C9\7528\7A0B\5F0F\7BA1\7406\6A21\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108928298207313309)
,p_name=>'ACCESS_CONTROL_LAST_CHANGED_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\6B21\8B8A\66F4\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108927905938313309)
,p_name=>'ACCESS_CONTROL_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108927199135313308)
,p_name=>'ACCESS_CONTROL_MODE1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8\70BA\5B8C\6574\5B58\53D6\6B0A, \4E0D\4F7F\7528\5B58\53D6\63A7\5236\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108927253934313308)
,p_name=>'ACCESS_CONTROL_MODE2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9650\5236\5B58\53D6. \50C5\5141\8A31\5B58\53D6\63A7\5236\6E05\55AE\4E2D\5B9A\7FA9\7684\4F7F\7528\8005\5B58\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108927370807313308)
,p_name=>'ACCESS_CONTROL_MODE3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\7528\552F\8B80. \7531\5B58\53D6\63A7\5236\6E05\55AE\63A7\5236\7DE8\8F2F\8207\7BA1\7406\6B0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108927453778313308)
,p_name=>'ACCESS_CONTROL_MODE4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\9650\7BA1\7406\5B58\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108928594788313309)
,p_name=>'ACCESS_CONTROL_NO_PRIV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\57F7\884C\5617\8A66\4E4B\52D5\4F5C\7684\6B0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108928140137313309)
,p_name=>'ACCESS_CONTROL_PRIV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109379707750313660)
,p_name=>'ACCESS_CONTROL_READER_AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95B1\8B80\8005\6B0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109379629479313659)
,p_name=>'ACCESS_CONTROL_READER_ROLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95B1\8B80\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109444306010313709)
,p_name=>'ACCESS_CONTROL_READER_ROLE_DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7D66\61C9\7528\7A0B\5F0F\95B1\8B80\8005\7684\89D2\8272.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108945015568313322)
,p_name=>'ACCESS_CONTROL_RPT_REGION_HEADER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\76F8\5C0D\65BC\6B64\61C9\7528\7A0B\5F0F\4E4B\8A8D\8B49\914D\7F6E\7684\4F7F\7528\8005\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108927787489313309)
,p_name=>'ACCESS_CONTROL_SET_APP_MODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\61C9\7528\7A0B\5F0F\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109026143689313390)
,p_name=>'ACCESS_CONTROL_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\5B58\53D6\63A7\5236\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109339579290313629)
,p_name=>'ACCESS_CONTROL_USE_AUTH_ROLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\73FE\6709\7684\5B58\53D6\63A7\5236\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108944936526313322)
,p_name=>'ACCESS_CONTROL_USE_AUTH_SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\73FE\6709\7684\6388\6B0A\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108944166704313321)
,p_name=>'ACCESS_CONTROL_USE_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\73FE\6709\7684\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109060773275313416)
,p_name=>'ACCESS_CONTROL_VIEW_AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236 - \6AA2\8996')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108947976487313324)
,p_name=>'ACCOUNT_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\5E33\6236.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109633648420313857)
,p_name=>'ACCOUNT_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E33\6236\529F\80FD\8868')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109367585006313650)
,p_name=>'ACKNOWLEDGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8A8D\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109367755967313650)
,p_name=>'ACKNOWLEDGED_NO_ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8A8D\53EF, \7121\9808\63A1\53D6\52D5\4F5C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109428235639313696)
,p_name=>'ACL_ADD_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110036809520314169)
,p_name=>'ACL_TABLE.ACCESS_DASHBOARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\5100\8868\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110036973239314169)
,p_name=>'ACL_TABLE.ACCESS_MONITOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\76E3\7763\6D3B\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110036412048314169)
,p_name=>'ACL_TABLE.ADD_MODIFY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E / \4FEE\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110036784723314169)
,p_name=>'ACL_TABLE.ADMIN_WHEN_RUNNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\61C9\7528\7A0B\5F0F\6642\9032\884C\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110035693580314169)
,p_name=>'ACL_TABLE.ADMIN_WITHIN_BUILDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\61C9\7528\7A0B\5F0F\7522\751F\5668\4E2D\9032\884C\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110036366341314169)
,p_name=>'ACL_TABLE.ANNOTATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A3B\89E3 (\6A94\6848\3001\6A19\8A18\3001\9644\8A3B)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110035338684314168)
,p_name=>'ACL_TABLE.APEX_AUTH_WO_ACL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\4F7F\7528\5B58\53D6\63A7\5236\6E05\55AE\9032\884C Application Express \5E33\6236\8A8D\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110035289907314168)
,p_name=>'ACL_TABLE.AUTH_WITH_ACL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\5B58\53D6\63A7\5236\6E05\55AE\8A8D\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110036083390314169)
,p_name=>'ACL_TABLE.EDIT_SQL_ACCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F SQL \5B58\53D6\548C\5EFA\8B70\7684\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110040075815314172)
,p_name=>'ACL_TABLE.INTRO_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\901A\904E\61C9\7528\7A0B\5F0F\8A8D\8B49\5F8C, \5373\7531\5B58\53D6\63A7\5236\6C7A\5B9A\4F7F\7528\8005\80FD\5920\5728\61C9\7528\7A0B\5F0F\5167\57F7\884C\54EA\4E9B\52D5\4F5C. \4E0B\8868\986F\793A\4E0D\540C\985E\578B\4E4B\4F7F\7528\8005\6240\80FD\57F7\884C\7684\529F\80FD (\6839\64DA\6B64\61C9\7528\7A0B\5F0F\5167\4F7F\7528\7684\8A8D\8B49\800C\5B9A).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110037014020314170)
,p_name=>'ACL_TABLE.MAINTAIN_ACL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DAD\8B77\5B58\53D6\63A7\5236\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110036134138314169)
,p_name=>'ACL_TABLE.RUN_AND_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\4E26\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110035851228314169)
,p_name=>'ACL_TABLE.UPDATE_APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\61C9\7528\7A0B\5F0F\7279\6027')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109653150839313872)
,p_name=>'ACTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110034741645314168)
,p_name=>'ACTION_MENU_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\529F\80FD\8868\8A2D\5B9A\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108956479953313332)
,p_name=>'ACTIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F5C\7528\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109346527458313634)
,p_name=>'ACTIVITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D3B\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109388203022313666)
,p_name=>'ACTIVITY_SUMMARY'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6D3B\52D5\6458\8981'),
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109588827409313821)
,p_name=>'ADDED_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110031179817314165)
,p_name=>'ADDED_TO_PURGE_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\65B0\589E\81F3\6C38\4E45\6E05\9664\6E05\55AE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109646066159313867)
,p_name=>'ADDITIONAL_INFORMATION_REQUESTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8981\6C42\984D\5916\8CC7\8A0A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109306358538313604)
,p_name=>'ADD_ARGUEMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\5F15\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109296790213313597)
,p_name=>'ADD_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109494070161313746)
,p_name=>'ADD_COLUMN_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\8CC7\6599\6B04 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109135956819313472)
,p_name=>'ADD_CONSTRAINT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\9650\5236\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109294814681313595)
,p_name=>'ADD_MORE...'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\5176\4ED6\9805\76EE...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109360625283313645)
,p_name=>'ADD_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109499144585313750)
,p_name=>'ADD_USER_INTERFACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\4F7F\7528\8005\4ECB\9762')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109502692922313752)
,p_name=>'ADJUST_PROVISIONED_SPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ABF\6574 %0 MB \7684\5DF2\4F48\5EFA\7684\7A7A\9593')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109293579779313594)
,p_name=>'ADMIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\54E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108882395592313273)
,p_name=>'ADMIN.WORKSPACE_BANNER_COLOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\5E5F\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108882132340313273)
,p_name=>'ADMIN.WORKSPACE_BANNER_ENABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\74B0\5883\6A19\5E5F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108882287191313273)
,p_name=>'ADMIN.WORKSPACE_BANNER_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\5E5F\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109301568346313601)
,p_name=>'ADMIN.WORKSPACE_BANNER_POS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\5E5F\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108940343439313318)
,p_name=>'ADMINISTRATOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\7BA1\7406\54E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109388078481313666)
,p_name=>'ADMINISTRATORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\54E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109300282143313600)
,p_name=>'ADMIN_EMAIL_MUST_BE_PROV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\63D0\4F9B\7BA1\7406\54E1\96FB\5B50\90F5\4EF6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109452511047313715)
,p_name=>'ADVISOR.CATEGORY.ACCESSIBILITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F14\52A9\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108962834598313337)
,p_name=>'ADVISOR.CATEGORY.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108963152446313337)
,p_name=>'ADVISOR.CATEGORY.PERFORMANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6548\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108963223312313337)
,p_name=>'ADVISOR.CATEGORY.QA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\54C1\8CEA\4FDD\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108962955106313337)
,p_name=>'ADVISOR.CATEGORY.SECURITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\5168\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108963381852313337)
,p_name=>'ADVISOR.CATEGORY.USABILITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\7528\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108963006739313337)
,p_name=>'ADVISOR.CATEGORY.WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109557521926313793)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.DA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE "%1" \53D7\5230\4FDD\8B77, \7121\6CD5\900F\904E AJAX \547C\53EB\8A2D\5B9A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109557656995313793)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE "%1" \53D7\5230\4FDD\8B77, \7121\6CD5\900F\904E AJAX \547C\53EB\8A2D\5B9A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109586921424313819)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE "%1" \53D7\5230\4FDD\8B77, \7121\6CD5\900F\904E AJAX \547C\53EB\8A2D\5B9A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108989269389313358)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_MISSING_SYS_PREFIX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\907A\6F0F SYS \7DB1\8981\524D\7F6E\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109693245530313916)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_WWV_FLOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('WWV_FLOW API \4F7F\7528\72C0\6CC1 (\6539\7528 APEX API)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109643585946313865)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IG_COLUMN_NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5340\57DF\4F86\6E90 SQL \6558\8FF0\53E5\300D\4E2D\6C92\6709\8CC7\6599\6B04 %0 \5B58\5728!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108972919596313345)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IR_FILTER_NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\4E92\52D5\5F0F\5831\8868\300D\8CC7\6599\6B04 %0 \4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108970668829313343)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108950900120313327)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_REGION_COLUMN_NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5340\57DF\4F86\6E90 SQL \6558\8FF0\53E5\300D\4E2D\6C92\6709\8CC7\6599\6B04 %0 \5B58\5728!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109723363850313940)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_TABFORM_COLUMN_NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5217\8868\5316\8868\55AE\300D\8CC7\6599\6B04 %0 \4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108970798751313343)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_WRONG_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\53EF\53C3\7167\70BA\61C9\7528\7A0B\5F0F\6216\9801\9762\9805\76EE\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110105923077314236)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_APP_PROC_AUTHORIZATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Ajax \56DE\547C\61C9\7528\7A0B\5F0F\8655\7406\4F5C\696D\672A\53D7\6388\6B0A\914D\7F6E\4FDD\8B77.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110105592101314236)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_PAGE_AUTHORIZATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\672A\53D7\6388\6B0A\914D\7F6E\4FDD\8B77.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108971647382313344)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_TARGET_AUTH_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\6A19\9801\9762 %1 (\5728\61C9\7528\7A0B\5F0F %0 \5167) \5C1A\672A\5B9A\7FA9\6388\6B0A\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110107211895314238)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_PARENT_PAGE_AUTH_DIFFERENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\7684\6388\6B0A\8207\7236\9805\9801\9762 %0 \7684\6388\6B0A "%1" \4E0D\540C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108971791356313344)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_TARGET_AUTH_DIFFERENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\6A19\9801\9762\4E0A\7684\6388\6B0A "%0" \8207 "%1" \4E0D\540C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108970233037313343)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108970106330313342)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_UNKNOWN_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\57F7\884C\9023\7D50\8B8A\6578\8A9E\6CD5\6AA2\67E5. \932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108970328353313343)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\53EF\4F7F\7528\9023\7D50\8B8A\6578\8A9E\6CD5\53C3\7167 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108972393452313344)
,p_name=>'ADVISOR.CHECK.BRANCH_SEQUENCE.MSG_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6\5206\652F\4E4B\524D\6709\7121\689D\4EF6\6027\5206\652F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110105398785314236)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_AUTOCOMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\81EA\52D5\5B8C\6210\300D\5728\542B\6709\5BC6\78BC\9805\76EE\7684\9801\9762\6703\8A2D\70BA\300C\958B\555F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110105476531314236)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_CACHE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5FEB\53D6\300D\5141\8A31\700F\89BD\5668\5FEB\53D6\6A5F\5BC6\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109905001585314075)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_FRAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5167\5D4C\65BC\6846\67B6\4E2D\300D\6703\8B93\61C9\7528\7A0B\5F0F\6613\906D\53D7 clickjacking \653B\64CA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109905124192314075)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_HTML_ESCAPING_MODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300CHTML \9041\96E2\6A21\5F0F\300D\50C5\80FD\9041\96E2\4E00\7D44\6709\9650\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108893624205313282)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_ITEM_OUTPUT_ESCAPING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\61C9\9041\96E2\7279\6B8A\5B57\5143\4EE5\907F\514D\8DE8\7DB2\7AD9\547D\4EE4\6A94 (XSS) \653B\64CA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109912179441314080)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_REFERRER_POLICY'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('HTTP "Referer" \8981\6C42\6A19\982D\53EF\80FD\6703\5C07\6A5F\5BC6\968E\6BB5\4F5C\696D\8CC7\8A0A\6D29\6F0F\7D66\7B2C\4E09\65B9.'),
unistr('\61C9\7528\7A0B\5F0F\61C9\5C07\300C\53C3\7167\4F4D\7F6E\539F\5247\300D\8A2D\70BA "strict-origin".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108909775106313295)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_ID_FOUND_IN_ATTRIBUTES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\300C\6309\9215\5C6C\6027\300D\4E2D\7684 ID \70BA\300C\52D5\614B\52D5\4F5C\300D(%0) \4E2D\53C3\7167\7684\6309\9215. '),
'',
unistr('\5728\300C\6309\9215\5C6C\6027\300D\4E2D\5B9A\7FA9 ID \6642, \5C07\5C0E\81F4\53C3\7167\6309\9215\7684\300C\52D5\614B\52D5\4F5C\300D\7121\6CD5\904B\4F5C. \8ACB\8003\616E\79FB\9664\6B64 ID, \56E0\70BA\6309\9215\9810\8A2D\5C07\6703\7522\751F ID.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108909813302313295)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_TEMPLATE_BUTTON_NO_BUTTON_ID'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\300C\52D5\614B\52D5\4F5C\300D(%0) \4E2D\53C3\7167\4E4B\67D0\500B\6309\9215\6240\4F7F\7528\7684\300C\6309\9215\6A23\677F\300D\672A\5305\62EC #BUTTON_ID# \66FF\4EE3\5B57\4E32.'),
'',
unistr('\6A23\677F:'),
'%1',
'',
unistr('\8ACB\8003\616E\65B0\589E #BUTTON_ID# \66FF\4EE3\5B57\4E32\81F3\6B64\6A23\677F, \6216\8005\5C07\6309\9215\6A23\677F\8B8A\66F4\70BA\5305\62EC #BUTTON_ID# \66FF\4EE3\5B57\4E32\7684\6309\9215\6A23\677F.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108913168012313297)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_ACTION_NOT_DEFINED_BY_DA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\52D5\614B\52D5\4F5C\300D(%0) \4E2D\53C3\7167\4E4B\67D0\500B\6309\9215\7684\300C\52D5\4F5C\300D\4E0D\662F\7531\300C\52D5\614B\52D5\4F5C\5B9A\7FA9\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108919228130313302)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_NO_BUTTON_DEFINED_FOR_DA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215 (%0) \542B\6709\300C\52D5\614B\52D5\4F5C\5B9A\7FA9\300D\7684\300C\52D5\4F5C\300D, \4F46\662F\6C92\6709\53C3\7167\6B64\6309\9215\7684\76F8\5C0D\61C9\300C\52D5\614B\52D5\4F5C\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108971390162313343)
,p_name=>'ADVISOR.CHECK.CLEAR_CACHE_PAGE_NUMBER.MSG_OTHER_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664\5FEB\53D6\9801\9762 %0 \4E0D\662F\76EE\524D\7684\9801\9762\6216\76EE\6A19\9801\9762 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108970016526313342)
,p_name=>'ADVISOR.CHECK.COLUMN_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110079126809314199)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_ATTRIBUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\5C6C\6027\503C\5DF2\88AB\53D6\4EE3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110081631862314201)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_COMPONENT_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\5143\4EF6\985E\578B\5DF2\88AB\53D6\4EE3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109557743274313793)
,p_name=>'ADVISOR.CHECK.DESC_AJAX_ITEMS_WITH_SSP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('AJAX \547C\53EB\4E2D\7684\53D7\4FDD\8B77\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108989151101313357)
,p_name=>'ADVISOR.CHECK.DESC_APEX_CODE_SMELL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A0B\5F0F\78BC\58DE\5473\9053 (APEX \5167\90E8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108968196090313341)
,p_name=>'ADVISOR.CHECK.DESC_APPL_PAGE_ITEM_REF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\9805\76EE\3001\9801\9762\9805\76EE\3001\8CC7\6599\6B04\6216\4E92\52D5\5F0F\5831\8868\7BE9\9078\7684\5BA3\544A\5F0F\53C3\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110105212239314236)
,p_name=>'ADVISOR.CHECK.DESC_AUTHORIZATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108967809968313341)
,p_name=>'ADVISOR.CHECK.DESC_BIND_VARIABLE_SYNTAX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\8B8A\6578\8A9E\6CD5\53C3\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108969200202313342)
,p_name=>'ADVISOR.CHECK.DESC_BRANCH_SEQUENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6\5206\652F\4E4B\524D\6709\7121\689D\4EF6\6027\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110105795492314236)
,p_name=>'ADVISOR.CHECK.DESC_BROWSER_SECURITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\5668\5B89\5168\6027\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108909688652313294)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_COMPATIBLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215\8207\300C\52D5\614B\52D5\4F5C\300D\4E0D\76F8\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108919065807313302)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_INCONSISTENT_REFS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\52D5\614B\52D5\4F5C\300D\8207\300C\6309\9215\300D\4E4B\9593\7684\53C3\7167\4E0D\4E00\81F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108968415697313341)
,p_name=>'ADVISOR.CHECK.DESC_CLEAR_CACHE_PAGE_NUMBER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664\5FEB\53D6\9801\78BC\7B49\65BC\76EE\6A19\6216\76EE\524D\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108967733411313341)
,p_name=>'ADVISOR.CHECK.DESC_COLUMN_SYNTAX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\8A9E\6CD5\53C3\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110079012959314199)
,p_name=>'ADVISOR.CHECK.DESC_DEPRECATED_ATTRIBUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\88AB\53D6\4EE3\7684\5C6C\6027\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108968713524313341)
,p_name=>'ADVISOR.CHECK.DESC_DML_PROCESSES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64F7\53D6\3001DML \4EE5\53CA MR* \8655\7406\4F5C\696D\6709\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108969154600313342)
,p_name=>'ADVISOR.CHECK.DESC_HARDCODED_APPLICATION_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\786C\5F0F\7DE8\78BC\7684\61C9\7528\7A0B\5F0F ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109364875310313648)
,p_name=>'ADVISOR.CHECK.DESC_HAS_HELP_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE\6709\8AAA\660E\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109452342132313715)
,p_name=>'ADVISOR.CHECK.DESC_HAS_PAGE_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6709\9801\9762\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109476558647313733)
,p_name=>'ADVISOR.CHECK.DESC_IMAGE_ITEM_HAS_ALT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5F71\50CF\9805\76EE\5DF2\5B9A\7FA9\5F71\50CF\66FF\4EE3\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109904877936314075)
,p_name=>'ADVISOR.CHECK.DESC_INSECURE_APPLICATION_DEFAULTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\9396\5B9A\61C9\7528\7A0B\5F0F\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108967953503313341)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\7167\7684\9805\76EE\5C6C\65BC\76EE\524D\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108968094439313341)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_TARGET_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\7167\7684\9805\76EE\662F\76EE\6A19\9801\9762\7684\9801\9762\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109453037594313716)
,p_name=>'ADVISOR.CHECK.DESC_ITEMS_NO_CONTEXT_CHANGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE\4E0D\6703\5F15\767C\975E\9810\671F\7684\5167\5BB9\8B8A\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109453752422313716)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_HAS_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE\6709\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108969456449313342)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_NAME_LENGTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\6216\5217\8868\5316\8868\55AE\8CC7\6599\6B04\540D\7A31\9577\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108968214240313341)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_ITEM_REF_AS_STRING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\4E32\5F62\5F0F\7684\9801\9762\9805\76EE\53C3\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108968335809313341)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_NUMBER_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\7167\7684\9801\78BC\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109452650817313716)
,p_name=>'ADVISOR.CHECK.DESC_REGION_HAS_ROW_HEADER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\6709\8CC7\6599\5217\6A19\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108969640349313342)
,p_name=>'ADVISOR.CHECK.DESC_REPORT_DEFAULT_ORDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\6709\9810\8A2D\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110105820579314236)
,p_name=>'ADVISOR.CHECK.DESC_SESSION_STATE_PROTECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D\72C0\614B\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108968834657313341)
,p_name=>'ADVISOR.CHECK.DESC_SQL_INJECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66FF\4EE3\8A9E\6CD5\7684\7528\6CD5\4E0D\6B63\78BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108967654985313341)
,p_name=>'ADVISOR.CHECK.DESC_SUBSTITUTION_SYNTAX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66FF\4EE3\8A9E\6CD5\53C3\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108968645115313341)
,p_name=>'ADVISOR.CHECK.DESC_TARGET_PAGE_AUTH_USABILITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\5143\4EF6\4E5F\8A2D\5B9A\76EE\6A19\9801\9762\6388\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109452865790313716)
,p_name=>'ADVISOR.CHECK.DESC_THEME_STYLE_IS_ACCESSIBLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\6A23\5F0F\5DF2\901A\904E\8F14\52A9\529F\80FD\6E2C\8A66')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109547612428313786)
,p_name=>'ADVISOR.CHECK.DESC_UI_INCLUDES_COMPATIBILITY_JS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762\5305\62EC\76F8\5BB9 JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108969393312313342)
,p_name=>'ADVISOR.CHECK.DESC_VALIDATION_ASSOCIATED_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\95DC\806F\7684\9805\76EE\6216\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108968511145313341)
,p_name=>'ADVISOR.CHECK.DESC_VALID_SQL_PLSQL_CODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6709\6548\7684 SQL \6216 PL/SQL \7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108969094606313342)
,p_name=>'ADVISOR.CHECK.DESC_VERIFY_CLOB_PROPERTY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49 Clob \7279\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108968996316313342)
,p_name=>'ADVISOR.CHECK.DESC_V_FUNCTION_IN_SQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \6558\8FF0\53E5\4E2D\4F7F\7528 V \51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108969576604313342)
,p_name=>'ADVISOR.CHECK.DESC_WHEN_BUTTON_PRESSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E0B\6309\9215\7684\53C3\7167\6309\9215\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108971940481313344)
,p_name=>'ADVISOR.CHECK.DML_PROCESSES.MSG_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8B6F\932F\8AA4 - %0 \6558\8FF0\53E5: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108972228197313344)
,p_name=>'ADVISOR.CHECK.HARDCODED_APPLICATION_ID.MSG_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\5305\542B\7684\76EE\524D\300C\61C9\7528\7A0B\5F0F ID\300D\70BA\786C\5F0F\7DE8\78BC\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109364761262313648)
,p_name=>'ADVISOR.CHECK.HAS_HELP_TEXT.MSG_NOT_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5B9A\7FA9\8AAA\660E\5167\5BB9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109452404423313715)
,p_name=>'ADVISOR.CHECK.HAS_PAGE_TITLE.MSG_NOT_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\6C92\6709\9801\9762\6A19\984C. \6709\610F\7FA9\7684\9801\9762\6A19\984C\5C0D\8F14\52A9\529F\80FD\975E\5E38\91CD\8981, \53EF\5354\52A9\4F7F\7528\8005\77AD\89E3\76EE\524D\9801\9762\7684\5167\5BB9\548C\76EE\7684.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109476693191313733)
,p_name=>'ADVISOR.CHECK.IMAGE_ITEM_HAS_ALT.MSG_NOT_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9805\76EE\907A\6F0F\5F71\50CF\5FC5\9808\63D0\4F9B\7684\66FF\4EE3\6587\5B57. \672C\9805\4F7F\7528\7684\826F\597D\6587\5B57, \61C9\6B63\78BA\63CF\8FF0\5F71\50CF\5167\5BB9, \4E26\4E14\4E0D\61C9\91CD\8907\9801\9762\4E0A\5DF2\986F\793A\65BC\5F71\50CF\5167\5BB9\4E2D\7684\4EFB\4F55\53EF\898B\8CC7\8A0A (\4EE5\907F\514D\767C\751F\91CD\8907). \6CE8\610F: \5982\679C\5F71\50CF\662F\7531\4F7F\7528\8005\63D0\4F9B, \4E5F\61C9\540C\6642\63D0\4F9B\5F71\50CF\66FF\4EE3\6587\5B57, \82E5\63D0\4F9B\9069\7576\7684\6307\5F15, \53EF\5354\52A9\4F7F\7528\8005\63D0\4F9B\9AD8\54C1\8CEA\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109904920712314075)
,p_name=>'ADVISOR.CHECK.INSECURE_APPLICATION_DEFAULTS.MSG_RUNTIME_API_USAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\7A0B\5F0F\5BE6\969B\57F7\884C API \7528\6CD5\300D\5141\8A31\60A8\4FEE\6539\61C9\7528\7A0B\5F0F\548C\5DE5\4F5C\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108970473693313343)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_PAGE.MSG_NOT_ITEM_OF_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\662F\9801\9762 %1 \4E2D\7684\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108970597266313343)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_TARGET_PAGE.MSG_NOT_ITEM_OF_TARGET_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\662F\76EE\6A19\9801\9762 %1 \4E2D\7684\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109453130744313716)
,p_name=>'ADVISOR.CHECK.ITEMS_NO_CONTEXT_CHANGE.MSG_CAUSES_CHANGE_OF_CONTEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\9805\76EE\7684\300C\9078\64C7\6642\7684\9801\9762\52D5\4F5C\300D\8A2D\5B9A\53EF\80FD\6703\8B93\4F7F\7528\8005\7684\5167\5BB9\767C\751F\672A\9810\671F\8B8A\66F4. \8ACB\8003\616E\5207\63DB\6210\300C\7121\300D, \4EE5\78BA\4FDD\4E0D\6703\767C\751F\5167\5BB9\8B8A\66F4, \4E26\5C07\6B64\529F\80FD\6539\70BA\4F7F\7528\300C\52D5\614B\52D5\4F5C\300D\6216\300C\968E\5C64\5F0F LOV\300D(\82E5\9700\8981\7559\5728\76F8\540C\9801\9762). \6216\8005, \4E5F\53EF\4EE5\8003\616E\5411\4F7F\7528\8005\63D0\4F9B\76F8\95DC\8CC7\8A0A, \8B93\5176\77E5\9053\5C07\6703\767C\751F\4EC0\9EBC\52D5\4F5C (\4F8B\5982\5728\6A19\7C64\4E2D\65B0\589E\300C\555F\52D5\65B0\9801\9762\300D). ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109476414972313733)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_NO_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\5FC5\9808\5B9A\7FA9\6A19\7C64. \5982\679C\60A8\504F\597D\4E0D\986F\793A\6A19\7C64\6587\5B57, \4ECD\61C9\5B9A\7FA9\6A19\7C64, \7136\5F8C\9078\53D6\300C\96B1\85CF\300D\6A19\7C64\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109453829404313716)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_PLACEHOLDER_BUT_NO_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9805\76EE\5B9A\7FA9\4E86\300C\503C\9810\7559\4F4D\7F6E\300D\503C, \4F46\6C92\6709\6A19\7C64. \60A8\4E0D\61C9\53EA\4F7F\7528\9810\7559\4F4D\7F6E\6587\5B57\4F5C\70BA\9805\76EE\7684\7C64\6A19, \56E0\70BA\9019\6A23\6703\7522\751F\8F14\52A9\529F\80FD\554F\984C. \82E5\8981\7372\5F97\66F4\4F73\7684\8F14\52A9\529F\80FD, \5FC5\9808\8981\5B9A\7FA9\9805\76EE\6A19\7C64. \5982\679C\60A8\504F\597D\4E0D\986F\793A\6A19\7C64\6587\5B57, \4ECD\61C9\5B9A\7FA9\6A19\7C64, \7136\5F8C\9078\53D6\300C\96B1\85CF\300D\6A19\7C64\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108972664701313344)
,p_name=>'ADVISOR.CHECK.ITEM_NAME_LENGTH.MSG_TOO_LONG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31\9577\5EA6\70BA %0 \500B\5B57\5143, \4F46\6700\591A\4E0D\53EF\8D85\904E 30 \500B\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108970871060313343)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \53EF\80FD\4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108970960995313343)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_WRONG_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \53EF\80FD\4E0D\662F\4E00\500B\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108971284576313343)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_CLEAR_CACHE_NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664\5FEB\53D6\9801\9762 %1 (\5728\61C9\7528\7A0B\5F0F %0 \5167) \4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108971035240313343)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 %0 \4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108971190305313343)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_TARGET_NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\6A19\9801\9762 %1 (\5728\61C9\7528\7A0B\5F0F %0 \5167) \4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109379940040313660)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_COL_TOGGLE_NOT_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8CC7\6599\6B04\5207\63DB\5340\57DF\4E2D\7684\8CC7\6599\6B04\90FD\6C92\6709\5C07\300C\4F5C\70BA\8CC7\6599\5217\6A19\982D\300D\8A2D\70BA\300C\662F\300D. \8CC7\6599\5217\6A19\982D\8CC7\6599\6B04\61C9\662F\6700\80FD\4EE3\8868\76EE\524D\8CC7\6599\5217\7684\8CC7\6599\6B04 (\4F8B\5982\5BA2\6236\8CC7\8A0A\5831\8868\4E2D\7684\5BA2\6236\540D\7A31).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109380052724313660)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_REFLOW_NOT_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\56DE\6D41\5831\8868\5340\57DF\4E2D\7684\8CC7\6599\6B04\90FD\6C92\6709\5C07\300C\4F5C\70BA\8CC7\6599\5217\6A19\982D\300D\8A2D\70BA\300C\662F\300D. \8CC7\6599\5217\6A19\982D\8CC7\6599\6B04\61C9\662F\6700\80FD\4EE3\8868\76EE\524D\8CC7\6599\5217\7684\8CC7\6599\6B04 (\4F8B\5982\5BA2\6236\8CC7\8A0A\5831\8868\4E2D\7684\5BA2\6236\540D\7A31).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109452782388313716)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_TABFORM_NOT_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\5217\8868\5316\8868\55AE\5340\57DF\4E2D\7684\8CC7\6599\6B04\90FD\6C92\6709\5C07\300C\4F5C\70BA\8CC7\6599\5217\6A19\982D\300D\8A2D\70BA\300C\662F\300D. \8CC7\6599\5217\6A19\982D\8CC7\6599\6B04\61C9\662F\6700\80FD\4EE3\8868\76EE\524D\8CC7\6599\5217\7684\8CC7\6599\6B04 (\4F8B\5982\5BA2\6236\8CC7\8A0A\8868\683C\4E2D\7684\5BA2\6236\540D\7A31). \6B64\8CC7\8A0A\6703\5728\5448\73FE\5217\8868\5316\8868\55AE\6642\4F7F\7528, \70BA\6BCF\500B\8CC7\6599\5217\7684\8868\55AE\6B04\4F4D\63D0\4F9B\552F\4E00\7684\6A19\7C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108972899722313345)
,p_name=>'ADVISOR.CHECK.REPORT_DEFAULT_ORDER.MSG_NO_DEFAULT_ORDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\6C92\6709\9810\8A2D\9806\5E8F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109905279323314075)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_BOOKMARK_CHECKSUM_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\66F8\7C64\96DC\6E4A\51FD\6578\300D\8A2D\70BA\820A\6709\6F14\7B97\6CD5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109905387216314075)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_APP_PROTECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\505C\7528\300C\968E\6BB5\4F5C\696D\72C0\614B\4FDD\8B77\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110105655960314236)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PAGE_PROTECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5177\6709\64F7\53D6\8655\7406\4F5C\696D\7684\9801\9762\4E0A, \60A8\61C9\8A72\4F7F\7528\300C\9801\9762\5B58\53D6\4FDD\8B77\300D, \4E26\5C0D\900F\904E URL \50B3\905E\7684\9805\76EE\555F\7528\4FDD\8B77.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108942478631313320)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PREPARE_URL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\5305\542B\4E0D\662F\900F\904E APEX_UTIL.PREPARE_URL \50B3\9001\7684 "f?p" URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108972003599313344)
,p_name=>'ADVISOR.CHECK.SQL_INJECTION.MSG_ITEM_SUBSTITUTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5075\6E2C\5230\53EF\80FD\7684 SQL \96B1\78BC\653B\64CA. SQL\3001PL/SQL \7A0B\5F0F\78BC\6216\8655\7406\4F5C\696D\8868\683C\540D\7A31\4E2D\7684\66FF\4EE3\8A9E\6CD5\4F7F\7528 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108969831455313342)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108969917605313342)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\53EF\4F7F\7528\66FF\4EE3\8A9E\6CD5\53C3\7167 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108971818356313344)
,p_name=>'ADVISOR.CHECK.TARGET_PAGE_AUTH_USABILITY.MSG_NO_AUTH_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\6A19\9801\9762 %1 (\5728\61C9\7528\7A0B\5F0F %0 \5167) \5DF2\5B9A\7FA9\6388\6B0A\914D\7F6E, \4F46\76EE\524D\7684\5143\4EF6\672A\5B9A\7FA9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109452954515313716)
,p_name=>'ADVISOR.CHECK.THEME_STYLE_IS_ACCESSIBLE.MSG_NOT_ACCESSIBLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\76EE\524D\7684\4E3B\984C\6A23\5F0F\5C1A\672A\901A\904E\8F14\52A9\529F\80FD\6E2C\8A66. \8ACB\5207\63DB\6210\300C\8F14\52A9\529F\80FD\5DF2\6E2C\8A66\300D\8A2D\70BA\300C\662F\300D\7684\4E3B\984C\6A23\5F0F, \6216\8005\82E5\76EE\524D\7684\4E3B\984C\6A23\5F0F\5DF2\901A\904E\6E2C\8A66, \8ACB\5C07\5176\300C\4E3B\984C\300D\8A2D\5B9A\503C\4E0B\7684\300C\8F14\52A9\529F\80FD\5DF2\6E2C\8A66\300D\5C6C\6027\8A2D\70BA\300C\662F\300D.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109547803319313786)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_JQUERY_MIGRATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762\5305\62EC jQuery Migrate. \79FB\8F49\81F3\65B0\7248\7684 jQuery \6642, jQuery Migrate \53EF\56DE\5FA9\5DF2\79FB\9664\7684 API, \4E26\65BC\700F\89BD\5668\4E3B\63A7\53F0\4E2D\4F7F\7528\4E86\5DF2\79FB\9664\6216\5DF2\88AB\53D6\4EE3\7684 API \6642\986F\793A\8B66\544A. \5176\4E2D\5305\62EC\60A8\61C9\7528\7A0B\5F0F\4E2D\6BCF\500B\9801\9762\4E0A\7684\984D\5916 JavaScript \6A94\6848. \70BA\4E86\5354\52A9\79FB\9664\9019\4E9B\5167\5BB9, \8ACB\8907\67E5 jQuery Migrate \5347\7D1A\6307\5357, \4EE5\77AD\89E3\5FC5\9808\8B8A\66F4\7684 API \8A73\7D30\8CC7\8A0A, \7136\5F8C\5728\78BA\8A8D\61C9\7528\7A0B\5F0F\4E0D\518D\4F7F\7528\9019\4E9B API \4E4B\5F8C, \5C07\300C\5305\62EC jQuery Migrate\300D\8A2D\70BA\300C\5426\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109547773276313786)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_LEGACY_JS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762\5305\62EC\5DF2\88AB\53D6\4EE3\6216\5DF2\4E0D\518D\652F\63F4\7684 JavaScript \51FD\6578. \5176\4E2D\5305\62EC\60A8 App \4E2D\6BCF\500B\9801\9762\4E0A\7684\984D\5916 JavaScript \6A94\6848. \70BA\4E86\5354\52A9\79FB\9664\9019\4E9B\5167\5BB9, \8ACB\8907\67E5\300C\7248\6B21\6CE8\610F\4E8B\9805\300D\4E2D\300C\5DF2\88AB\53D6\4EE3\7684\529F\80FD\300D\5C0F\7BC0, \60A8\53EF\4EE5\5728\6B64\627E\5230\5982\4F55\6AA2\67E5\5DF2\88AB\53D6\4EE3\6216\5DF2\4E0D\518D\652F\63F4\51FD\6578\4E4B\76F8\4F9D\6027\7684\6307\793A, \4E26\9032\4E00\6B65\57F7\884C\76F8\95DC\8655\7406, \8B93\60A8\7684 App \4E0D\518D\542B\6709\9019\4E9B\5167\5BB9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108972533419313344)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5B9A\7FA9\76F8\95DC\300C\9805\76EE\300D\6216\300C\8CC7\6599\6B04\300D, \4F46\300C\932F\8AA4\8A0A\606F\986F\793A\4F4D\7F6E\300D\9700\8981\5B83.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108972410866313344)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_EQUAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\95DC\300C\9805\76EE\300D\6216\300C\8CC7\6599\6B04\300D\8207\300C\9A57\8B49\8868\793A\5F0F 1\300D\4E2D\6307\5B9A\7684 "%0" \4E0D\540C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108971492366313343)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8B6F\932F\8AA4 - %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108971505865313344)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_NOT_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5B9A\7FA9 SQL \6216 PL/SQL \7A0B\5F0F\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108969785546313342)
,p_name=>'ADVISOR.CHECK.VERIFY_CLOB_PROPERTY.MSG_TOO_LONG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\5EA6\8D85\904E 32767 \500B\5B57\5143. \53EA\6703\6AA2\67E5\524D 32767 \500B\5B57\5143. \9577\5EA6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108972147558313344)
,p_name=>'ADVISOR.CHECK.V_FUNCTION_IN_SQL.MSG_CONTAINS_CALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \6558\8FF0\53E5\4E2D\5305\542B V/NV/DV \51FD\6578\547C\53EB (\53EF\80FD\6703\5C0E\81F4\6548\80FD\554F\984C).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108972739922313345)
,p_name=>'ADVISOR.CHECK.WHEN_BUTTON_PRESSED.MSG_NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\7167\7684\6309\9215\5DF2\4E0D\5B58\5728.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109352414931313639)
,p_name=>'AFTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E4B\5F8C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109299755718313599)
,p_name=>'AGREEMENT_MISSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\907A\6F0F\5408\7D04')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109093832235313441)
,p_name=>'ALIAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5225\540D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109696084822313919)
,p_name=>'ALLOW_APP_BUILDING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\7D44\5EFA\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109637467094313860)
,p_name=>'ALLOW_PACKAGED_APP_INS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5141\8A31\5B89\88DD\751F\7522\529B\548C\7BC4\4F8B\61C9\7528\7A0B\5F0F.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109539246074313780)
,p_name=>'ALLOW_RESTFUL_SERVICES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\4F7F\7528 RESTful \670D\52D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109696154620313919)
,p_name=>'ALLOW_SQL_WORKSHOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\4F7F\7528 SQL \5DE5\4F5C\5BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109696344378313919)
,p_name=>'ALLOW_TEAM_DEVELOPMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\4F7F\7528\5718\968A\958B\767C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109695959919313919)
,p_name=>'ALLOW_TO_BE_PURGED_YN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\5C07\5DE5\4F5C\5340\6C38\4E45\6E05\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109696210137313919)
,p_name=>'ALLOW_WEBSHEET_DEV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\4F7F\7528 Web \8A66\7B97\8868\958B\767C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109113041560313455)
,p_name=>'ALL_APPLICATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108930211238313310)
,p_name=>'ALL_APPLICATIONS_NULL_DISP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \5168\90E8 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108930037397313310)
,p_name=>'ALL_CATEGORIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108930378148313311)
,p_name=>'ALL_CATEGORIES_NULL_DISP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \6240\6709\985E\5225 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109698605624313921)
,p_name=>'ALL_MILESTONES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\91CC\7A0B\7891')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109478087272313734)
,p_name=>'ALL_RELEASES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\7248\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109117455543313458)
,p_name=>'ALL_STATIC_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\975C\614B\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109116013817313457)
,p_name=>'ALL_THEMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109716754247313935)
,p_name=>'ALL_TYPES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109717165394313935)
,p_name=>'ALL_TYPES_NULL_DISP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \6240\6709\985E\578B -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109113172931313455)
,p_name=>'ALL_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\4F7F\7528\8005')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110101019526314232)
,p_name=>'ALREADY_IN_ACL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\5DF2\7D93\6709 APEX \5E33\6236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110090951467314208)
,p_name=>'ALREADY_IN_WS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\5DF2\7D93\5728\5DE5\4F5C\5340\4E2D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110057309936314184)
,p_name=>'ALWAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\6210\7ACB')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109367358428313650)
,p_name=>'ANALYSIS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5206\6790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109367481117313650)
,p_name=>'ANALYZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309 %0 \5206\6790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109495089090313747)
,p_name=>'ANALYZE_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528 %0 \65B9\6CD5\5206\6790')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109114929945313457)
,p_name=>'ANONYMOUS_BLOCK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\533F\540D\5340\584A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108976057088313347)
,p_name=>'ANSWERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B54\6848')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108942180391313320)
,p_name=>'ANY_DEVELOPER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\4EFB\4F55\958B\767C\4EBA\54E1)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110143042445314266)
,p_name=>'APEX.ACTIVITY_BY_HOUR.APPCHANGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8B8A\66F4:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110142907959314266)
,p_name=>'APEX.ACTIVITY_BY_HOUR.HOUR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\6642:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110147007722314269)
,p_name=>'APEX.ACTIVITY_BY_HOUR.K'
,p_message_language=>'zh-tw'
,p_message_text=>'%0 K'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110143139983314266)
,p_name=>'APEX.ACTIVITY_BY_HOUR.PAGEVIEWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6AA2\8996: ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109899743690314071)
,p_name=>'APEX.API.RUNTIME_API_USAGE.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5DF2\7981\6B62 API \547C\53EB.'),
unistr('\8ACB\6D3D\8A62\60A8\7684\7BA1\7406\54E1.'),
unistr('\6709\95DC\6B64\672A\9810\671F\4E8B\4EF6\7684\8A73\7D30\8CC7\8A0A, \8ACB\900F\904E\9664\932F ID "%0" \4F86\53D6\5F97.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109001391828313372)
,p_name=>'APEX.ASSERT.DESUPPORTED_API'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Application Express \7248\672C %1 \5DF2\4E0D\518D\652F\63F4 API \547C\53EB "%0". \6709\95DC\6B64\672A\9810\671F\4E8B\4EF6\7684\8A73\7D30\8CC7\8A0A, \8ACB\900F\904E\9664\932F ID "%2" \4F86\53D6\5F97.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109377288147313658)
,p_name=>'APEX.AUTO_COMPLETE.NOT_IN_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\4E2D\6C92\6709 #LABEL# \5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109654417909313873)
,p_name=>'APEX.BRANCH.SHOW_ONLY_NOT_SUPPORTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\9001\51FA\6642\91CD\65B0\8F09\5165\300D\9801\9762\5C6C\6027\82E5\8A2D\70BA\300C\50C5\5728\6210\529F\6642\8F09\5165\300D, \5C31\4E0D\652F\63F4\300C\50C5\986F\793A\5206\652F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109119114185313460)
,p_name=>'APEX.BRANCH.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\5206\652F\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108908423100313294)
,p_name=>'APEX.COMPUTATION.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\904B\7B97\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109099269509313445)
,p_name=>'APEX.CONDITION.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\689D\4EF6\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109150750339313483)
,p_name=>'APEX.CONDITION.UNKNOWN_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\660E\7684\689D\4EF6\985E\578B "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108904423460313290)
,p_name=>'APEX.DATA.LOAD.INVALID_FILE_BROWSE_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\700F\89BD\9805\76EE %0 \5FC5\9808\4F7F\7528 APEX_APPLICATION_TEMP_FILES \8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108881836128313273)
,p_name=>'APEX.DATA.LOAD.MERGE_NOT_ALLOWED_FOR_COLLECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\96C6\5408\4E0D\652F\63F4\300C\5408\4F75\300D\8F09\5165\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110035007583314168)
,p_name=>'APEX.DATA.LOAD.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\70BA\300C\5408\4F75\300D\8F09\5165\985E\578B, \5247\8CC7\6599\8A2D\5B9A\6A94\4E2D\81F3\5C11\8981\6709\4E00\500B\4E3B\7D22\5F15\9375\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110034857182314168)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5256\6790\8F09\5165\4F86\6E90 SQL \67E5\8A62: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110034979893314168)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_RETURNS_WRONG_DATA_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\4F86\6E90 SQL \67E5\8A62\5FC5\9808\50B3\56DE VARCHAR2\3001CLOB \6216 BLOB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109312150890313609)
,p_name=>'APEX.DIALOG.PAGE.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\9806\5229\5448\73FE\300C\61C9\7528\7A0B\5F0F %0 \5C0D\8A71\65B9\584A\300D\9801\9762 %1.  \8ACB\78BA\5B9A\9801\9762 %1 \4E0A\4F7F\7528\4E4B\9801\9762\6A23\677F\7684\6A23\677F\985E\578B\70BA\300C\5C0D\8A71\65B9\584A\9801\9762\300D, \4E14\5DF2\5B9A\7FA9\9069\7576\7684 JavaScript \5C0D\8A71\65B9\584A\521D\59CB\5316\3001\5C0D\8A71\65B9\584A\95DC\9589\53CA\5C0D\8A71\65B9\584A\53D6\6D88\7A0B\5F0F\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110132007432314258)
,p_name=>'APEX.EMAIL.COPYRIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8457\4F5C\6B0A\6240\6709 &copy; %0, \4FDD\7559\4E00\5207\6B0A\5229.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110132841359314258)
,p_name=>'APEX.EMAIL.CREATE_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5DE5\4F5C\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110131976660314258)
,p_name=>'APEX.EMAIL.DISCLAIMER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\70BA\7CFB\7D71\7522\751F\8A0A\606F. \8ACB\52FF\56DE\8986\6B64\8A0A\606F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110140406123314264)
,p_name=>'APEX.EMAIL.ENVIRONMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\74B0\5883')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110151000158314272)
,p_name=>'APEX.EMAIL.GENERIC_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle Application Express \4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110133437071314259)
,p_name=>'APEX.EMAIL.GET_STARTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5165\9580')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110132108864314258)
,p_name=>'APEX.EMAIL.GREETING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \60A8\597D,')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110133120985314258)
,p_name=>'APEX.EMAIL.PASSWORD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110140594344314264)
,p_name=>'APEX.EMAIL.PREVENT_PURGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\6C38\4E45\6E05\9664\5DE5\4F5C\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110133312023314259)
,p_name=>'APEX.EMAIL.PURGE.BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\53EF\4EE5\6309\4E00\4E0B\4E0B\65B9\7684\6309\9215\4E26\4F9D\64DA\87A2\5E55\4E0A\7684\6307\793A\9032\884C\4F5C\696D, \8B93\60A8\7684\5DE5\4F5C\5340\4E0D\6703\88AB\6C38\4E45\6E05\9664. \5982\679C\60A8\672A\5728 %0 \5929\5167\9032\884C\6B64\4F5C\696D, \60A8\7684\5DE5\4F5C\5340\5C07\6703\81EA\52D5\88AB\79FB\9664.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110140271645314264)
,p_name=>'APEX.EMAIL.PURGE.FOOTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\60A8\5DF2\4E0D\518D\9700\8981\4F7F\7528\5DE5\4F5C\5340, \5C31\4E0D\9700\8981\63A1\53D6\52D5\4F5C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110140719549314264)
,p_name=>'APEX.EMAIL.PURGE.HEADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\5DE5\4F5C\5340\5373\5C07\88AB\6C38\4E45\6E05\9664!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110140087262314264)
,p_name=>'APEX.EMAIL.PURGE.INTRO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\5DE5\4F5C\5340 %0 \6700\8FD1\4E26\7121\4EFB\4F55\6D3B\52D5, \56E0\6B64\6392\5B9A\70BA\5C07\65BC\8FD1\671F\6C38\4E45\6E05\9664.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110139967452314264)
,p_name=>'APEX.EMAIL.PURGE.SUBJECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A! \60A8\7684\5DE5\4F5C\5340 "%0" \5373\5C07\88AB\6C38\4E45\6E05\9664.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110140326958314264)
,p_name=>'APEX.EMAIL.PURGE_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C38\4E45\6E05\9664\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110141030949314264)
,p_name=>'APEX.EMAIL.REQUEST_ACTION_REQ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\5B8C\6210\60A8\7684\5DE5\4F5C\5340\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110140825709314264)
,p_name=>'APEX.EMAIL.REQUEST_APPROVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\5DE5\4F5C\5340 "%0" \5DF2\5C31\7DD2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110141156924314264)
,p_name=>'APEX.EMAIL.REQUEST_APPROVE_2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\5DE5\4F5C\5340 "%0" \5DF2\7D93\6838\51C6!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110140961770314264)
,p_name=>'APEX.EMAIL.REQUEST_DECLINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\5DE5\4F5C\5340\8981\6C42\88AB\62D2\7D55.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110132790882314258)
,p_name=>'APEX.EMAIL.USERNAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110140600129314264)
,p_name=>'APEX.EMAIL.WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110132600541314258)
,p_name=>'APEX.EMAIL.WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110132215959314258)
,p_name=>'APEX.EMAIL.WS_REQ_APPR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\8981\6C42\5DF2\6838\51C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110132951599314258)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_FOOTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E00\4E0B\4E0B\65B9\7684\6309\9215\4EE5\5B8C\6210\6838\51C6\8655\7406\4F5C\696D, \4E26\8A2D\5B9A\60A8\7684\5BC6\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110132437302314258)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_INTRO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\5DE5\4F5C\5340\8981\6C42\5DF2\7D93\6838\51C6!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110133002207314258)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_FOOTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\6309\4E00\4E0B\4E0B\65B9\7684\6309\9215\4EE5\958B\59CB\9032\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110133243307314259)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_INTRO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\5DE5\4F5C\5340\5DF2\5C31\7DD2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110132383812314258)
,p_name=>'APEX.EMAIL.WS_REQ_DECL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\8981\6C42\88AB\62D2\7D55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110132551908314258)
,p_name=>'APEX.EMAIL.WS_REQ_DECL_INTRO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62B1\6B49, \60A8\7684\5DE5\4F5C\5340\8981\6C42\88AB\62D2\7D55.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108908809621313294)
,p_name=>'APEX.EXPORT.DOWNLOAD_NOT_SUPPORTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\9001\51FA\6642\91CD\65B0\8F09\5165\300D\9801\9762\5C6C\6027\82E5\8A2D\70BA\300C\50C5\5728\6210\529F\6642\8F09\5165\300D, \5C31\4E0D\652F\63F4\4E0B\8F09. \8ACB\5C07\300C\9001\51FA\6642\91CD\65B0\8F09\5165\300D\9801\9762\5C6C\6027\8B8A\66F4\70BA\300C\4E00\5F8B\6210\7ACB\300D\6216\4F7F\7528\6A19\982D\4E4B\524D\8655\7406\4F5C\696D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109442629809313707)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.QUEUED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6392\5165\4F47\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109442737403313708)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.SENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\50B3\9001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108938610423313317)
,p_name=>'APEX.FEEDBACK.FEEDBACK_ENTRIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108938799848313317)
,p_name=>'APEX.FEEDBACK.OPEN_FEEDBACK_ENTRIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F85\8655\7406\7684\610F\898B\56DE\994B\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108938830485313317)
,p_name=>'APEX.FEEDBACK.USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109277897130313583)
,p_name=>'APEX.GROUP.NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\7FA4\7D44 "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110112823105314243)
,p_name=>'APEX.HELP.VIEW_DOC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109020712001313386)
,p_name=>'APEX.HTTP.HEADER.DUPLICATE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('HTTP \6A19\982D %0 \50B3\9001\4E86\5169\6B21, \9019\6709\53EF\80FD\662F\653B\64CA.'),
'<ul>',
unistr('<li>\7B2C\4E00\500B\503C: "%1"</li>'),
unistr('<li>\7B2C\4E8C\500B\503C: "%2"</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109057921817313414)
,p_name=>'APEX.INSTANCE_ADMIN.BIPUB_OPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\5370\652F\63F4\5FC5\9808\662F STANDARD\3001ADVANCED\3001APEX_LISTENER\3001AOP \6216 NONE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109058094037313414)
,p_name=>'APEX.INSTANCE_ADMIN.FIRST_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664\7B2C\4E00\500B\4F48\5EFA\7684\7DB1\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108961345297313335)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\61C9\7528\7A0B\5F0F ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109477499941313734)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_EMAIL_ADDRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\96FB\5B50\90F5\4EF6\5730\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108953601807313329)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_HISTORY_DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\5FC5\9808\662F\96F6\6216\6B63\6574\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109058149482313414)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_PORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\9023\63A5\57E0\865F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109505101786313754)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\8A02\95B1 ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109058211633313414)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WALLET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\4E8B\5305\8DEF\5F91\5FC5\9808\5728\8868\55AE\6A94\6848\4E2D: <filesystempath>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109137152322313473)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\5DE5\4F5C\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109137065226313473)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\5DE5\4F5C\5340 ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109162499682313492)
,p_name=>'APEX.INSTANCE_ADMIN.LIMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\4E0D\5F97\5927\65BC %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109072845855313425)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REGEXP_MISMATCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\8655\7406\53C3\6578 "%0" \7684\503C "%1" \4E0D\7B26\5408\6B63\898F\8868\793A\5F0F "%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109072710917313425)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\8655\7406\53C3\6578 "%0" \5FC5\9808\6709\4E00\500B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109058392277313414)
,p_name=>'APEX.INSTANCE_ADMIN.PARM_NOTFOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\57F7\884C\8655\7406\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109501220560313751)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.APEX-AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108908514346313294)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.CLOUD_IDM-AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC (\50C5\7528\65BC\5DE5\4F5C\5340\4F7F\7528\8005\5E33\6236\5132\5B58\5340\57DF\8A8D\8B49)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109693650745313916)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.HEADER-AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC (\50C5\7528\65BC\5DE5\4F5C\5340\4F7F\7528\8005\5E33\6236\5132\5B58\5340\57DF\8A8D\8B49)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109586837640313819)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.LDAP-AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC (\50C5\7528\65BC\5DE5\4F5C\5340\4F7F\7528\8005\5E33\6236\5132\5B58\5340\57DF\8A8D\8B49)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108992815894313365)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SAML-AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC (\50C5\7528\65BC\5DE5\4F5C\5340\4F7F\7528\8005\5E33\6236\5132\5B58\5340\57DF\8A8D\8B49)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109216047541313532)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SOCIAL-AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC (\50C5\7528\65BC\5DE5\4F5C\5340\4F7F\7528\8005\5E33\6236\5132\5B58\5340\57DF\8A8D\8B49)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109501139566313751)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SSO-AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC (\50C5\7528\65BC\5DE5\4F5C\5340\4F7F\7528\8005\5E33\6236\5132\5B58\5340\57DF\8A8D\8B49)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109060248445313416)
,p_name=>'APEX.INSTANCE_ADMIN.PRINTSVR_PROTOCOL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\5370\4F3A\670D\5668\5354\5B9A\5FC5\9808\662F HTTP \6216 HTTPS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109060390720313416)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_DOES_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981\4E0D\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109060457059313416)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_RESTRICTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981\53D7\5230\9650\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108933770548313313)
,p_name=>'APEX.ISSUES.APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108933576207313313)
,p_name=>'APEX.ISSUES.APPLICATION_NO_LONGER_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\5DF2\4E0D\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109738429485313952)
,p_name=>'APEX.ISSUES.ASSIGN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109135389904313472)
,p_name=>'APEX.ISSUES.ATTACHMENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110065408164314189)
,p_name=>'APEX.ISSUES.CARDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5361\7247')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108939181324313317)
,p_name=>'APEX.ISSUES.CLOSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108935607915313315)
,p_name=>'APEX.ISSUES.COMMENTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\52A0\8A3B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108935546045313315)
,p_name=>'APEX.ISSUES.COMMENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A3B\89E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108939227355313317)
,p_name=>'APEX.ISSUES.COMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109320636835313615)
,p_name=>'APEX.ISSUES.CREATED_THIS_ISSUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\6B64\554F\984C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108910275726313295)
,p_name=>'APEX.ISSUES.DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108910079557313295)
,p_name=>'APEX.ISSUES.DELETE_COMMENT_CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78BA\5B9A\8981\5C07\6B64\8A3B\89E3\522A\9664?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109722882720313939)
,p_name=>'APEX.ISSUES.DELETE_ISSUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\554F\984C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108919925152313302)
,p_name=>'APEX.ISSUES.DELETE_ISSUE_CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78BA\5B9A\8981\522A\9664\6B64\554F\984C\55CE?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108937245427313316)
,p_name=>'APEX.ISSUES.DOCUMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108936157022313315)
,p_name=>'APEX.ISSUES.DOCUMENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108910130587313295)
,p_name=>'APEX.ISSUES.EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109850940123314036)
,p_name=>'APEX.ISSUES.EDIT_COMMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\8A3B\89E3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109851016738314036)
,p_name=>'APEX.ISSUES.EDIT_ISSUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\554F\984C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108934316048313314)
,p_name=>'APEX.ISSUES.ERR_APP_DOES_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\61C9\7528\7A0B\5F0F\4E0D\5B58\5728\65BC\6B64\5DE5\4F5C\5340\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108934710895313314)
,p_name=>'APEX.ISSUES.ERR_ATTEMPTING_TO_DELETE_COMMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5617\8A66\522A\9664\8A3B\89E3\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108934663031313314)
,p_name=>'APEX.ISSUES.ERR_COMMENT_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\8A3B\89E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108934931713313314)
,p_name=>'APEX.ISSUES.ERR_ISSUE_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\554F\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108935022688313314)
,p_name=>'APEX.ISSUES.ERR_MARKING_ISSUE_FOR_DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5617\8A66\5C07\554F\984C\6A19\793A\70BA\8981\522A\9664\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108934499186313314)
,p_name=>'APEX.ISSUES.ERR_PAGE_DOES_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\9801\9762\4E0D\5B58\5728\65BC\6B64\5DE5\4F5C\5340\6216\63D0\4F9B\7684\61C9\7528\7A0B\5F0F\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108934897964313314)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_DELETE_COMMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6388\6B0A\4F7F\7528\8005\522A\9664\6B64\8A3B\89E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108935199673313314)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_TO_DELETE_ISSUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6388\6B0A\4F7F\7528\8005\522A\9664\6B64\554F\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108934544009313314)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_VISIBILITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6388\6B0A\4F7F\7528\8005\8B8A\66F4\6B64\8A3B\89E3\7684\53EF\898B\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109944435104314103)
,p_name=>'APEX.ISSUES.FILE_SIZE_CHECK_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\6A94\6848\5927\5C0F\6642\767C\751F\554F\984C. \8ACB\6D3D\8A62\7CFB\7D71\7BA1\7406\54E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109944394121314103)
,p_name=>'APEX.ISSUES.FILE_SIZE_PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4E2D\4E00\500B\6A94\6848\5927\65BC %0 \500B\4F4D\5143\7D44\7684\6A94\6848\5927\5C0F\4E0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109944292614314103)
,p_name=>'APEX.ISSUES.FILE_SIZE_SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\5927\65BC %0 \500B\4F4D\5143\7D44\7684\6A94\6848\5927\5C0F\4E0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108910384840313295)
,p_name=>'APEX.ISSUES.HIDE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108937047078313316)
,p_name=>'APEX.ISSUES.IMAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108935994684313315)
,p_name=>'APEX.ISSUES.IMAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108933366225313313)
,p_name=>'APEX.ISSUES.ISSUE_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7CFB\7D71\4E2D\627E\4E0D\5230\7684\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108882717088313274)
,p_name=>'APEX.ISSUES.JS.ADD_NOTIFICATION_PREFS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\4F7F\7528\8005\7684\504F\597D\8A2D\5B9A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108935756972313315)
,p_name=>'APEX.ISSUES.JS.ATTACH_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9644\52A0\6A94\6848')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108935477468313314)
,p_name=>'APEX.ISSUES.JS.CLOSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8655\7406')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110069338370314192)
,p_name=>'APEX.ISSUES.JS.HEADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108936784528313315)
,p_name=>'APEX.ISSUES.JS.IS_EMPTY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F\7A7A\7684.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108936503556313315)
,p_name=>'APEX.ISSUES.JS.ONE_OF_THESE_FILES_IS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\4E9B\6A94\6848\5176\4E2D\4E4B\4E00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108935340684313314)
,p_name=>'APEX.ISSUES.JS.OPEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F85\8655\7406')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108937878952313316)
,p_name=>'APEX.ISSUES.JS.PERMANENTLY_DELETE_SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C38\4E45\522A\9664\9078\53D6\9805\76EE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109723736986313940)
,p_name=>'APEX.ISSUES.JS.PURGE_ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8\6C38\4E45\6E05\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108937767685313316)
,p_name=>'APEX.ISSUES.JS.RESINSTATE_SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6062\5FA9\9078\53D6\9805\76EE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108935833616313315)
,p_name=>'APEX.ISSUES.JS.RESPONSE_TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56DE\61C9\6A23\677F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108936654386313315)
,p_name=>'APEX.ISSUES.JS.SINGLE_TOO_LARGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\592A\5927\7121\6CD5\4E0A\50B3. <br>\6A94\6848\5FC5\9808\5C0F\65BC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108936993122313316)
,p_name=>'APEX.ISSUES.JS.SUPPORTED_FILE_TYPES_ARE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\652F\63F4\7684\6A94\6848\985E\578B\70BA: ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109919347292314085)
,p_name=>'APEX.ISSUES.JS.TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\56DE\61C9\6A23\677F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108936446593313315)
,p_name=>'APEX.ISSUES.JS.THIS_FILE_IS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\6A94\6848')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108936881801313316)
,p_name=>'APEX.ISSUES.JS.UNSUPPORTED_FILE_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\662F\652F\63F4\7684\6A94\6848\985E\578B.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109666255032313884)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.BUG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109666810941313885)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.DOCUMENTATIONISSUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\4EF6\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109666314998313885)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.ENHANCEMENTREQUEST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\589E\5F37\529F\80FD\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109666458758313885)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.FEATUREREQUEST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109666720132313885)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.INSTALLATIONISSUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\88DD\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109666691006313885)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.PERFORMANCEISSUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6548\80FD\554F\984C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109666599116313885)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.SECURITYISSUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\5168\6027\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109666938032313885)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.TRAININGISSUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A13\7DF4\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109667639190313886)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.ADMINISTRATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109667312081313885)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.CSSHTML'
,p_message_language=>'zh-tw'
,p_message_text=>'CSS / HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109667470455313886)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DAJAVASCRIPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B\52D5\4F5C / JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109667192422313885)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DATABASE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109667709175313886)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.EXTINTEGRATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\90E8\7CFB\7D71\6574\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109667222079313885)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.RESTINTEGRATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \6574\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109667526709313886)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.SECURITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\5168\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109667026516313885)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.UIUX'
,p_message_language=>'zh-tw'
,p_message_text=>'UI / UX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109666175208313884)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7D66\554F\984C\7684\985E\5225.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109665262029313883)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109666067542313884)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D7\554F\984C\5F71\97FF\7684\529F\80FD\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109665303965313884)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109665954130313884)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7D66\554F\984C\7684\91CD\8981\6027\7A0B\5EA6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109665416251313884)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8981\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109665889023313884)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\554F\984C\7684\6295\5165\7A0B\5EA6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109665567722313884)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6295\5165\7A0B\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109665787650313884)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\554F\984C\7684\9032\5EA6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109665641364313884)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109668144044313886)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.BACKLOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A4D\58D3\7684\6848\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109667861330313886)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.CRITICAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56B4\91CD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109667905949313886)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.IMPORTANT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109668094763313886)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.NORMAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109668218527313886)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.WILLNOTADDRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4E0D\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109668383500313886)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.EASY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F15\9B06\4FEE\6B63')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109668573998313887)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.LARGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5927\91CF\958B\767C\4EBA\529B\6295\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109668455198313887)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.MODERATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\5EA6\4EBA\529B\6295\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109668988120313887)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.CANNOTFIX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\4FEE\6B63')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109669055955313887)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.COMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109668751684313887)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.REQUIRESMOREINFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981\5176\4ED6\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109668893285313887)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WAITINGONTHIRDPARTY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B49\5F85\7B2C\4E09\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109668697637313887)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WORKINGONIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109679148015313897)
,p_name=>'APEX.ISSUES.LABEL_GROUP_DELETE_WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\300C\6A19\7C64\7FA4\7D44\300D\7684\4E00\6216\591A\500B\6210\54E1\5DF2\6307\5B9A\7D66\67D0\500B\554F\984C, \56E0\6B64\4E0D\80FD\522A\9664\6B64\7FA4\7D44.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108938958454313317)
,p_name=>'APEX.ISSUES.LAST_UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\6B21\66F4\65B0\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108935283389313314)
,p_name=>'APEX.ISSUES.MARKED_DUPLICATE_OF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6A19\793A\70BA\91CD\8907 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109723212160313939)
,p_name=>'APEX.ISSUES.MENU.ASSIGNEES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5C0D\8C61')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109723113574313939)
,p_name=>'APEX.ISSUES.MENU.LABELS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109723624993313940)
,p_name=>'APEX.ISSUES.MENU.MILESTONES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CC\7A0B\7891')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109723037276313939)
,p_name=>'APEX.ISSUES.MENU.STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\72C0\614B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108933167937313313)
,p_name=>'APEX.ISSUES.MILESTONES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\500B\91CC\7A0B\7891')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109669482161313888)
,p_name=>'APEX.ISSUES.MILESTONES.CODEFREEZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A0B\5F0F\78BC\51CD\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109669629445313888)
,p_name=>'APEX.ISSUES.MILESTONES.FINALRELEASE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\7D42\7248\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109669522094313888)
,p_name=>'APEX.ISSUES.MILESTONES.UIFREEZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('UI \51CD\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108937660485313316)
,p_name=>'APEX.ISSUES.NOTIFY.ADDED_A_COMMENT_TO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5DF2\5C07\8A3B\89E3\65B0\589E\81F3 %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108881757206313273)
,p_name=>'APEX.ISSUES.NOTIFY.HAS_CHANGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8B8A\66F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109686773182313905)
,p_name=>'APEX.ISSUES.NOTIFY.ISSUE_HAS_CHANGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340 %1 \4E2D\7684\554F\984C\7DE8\865F %0 \5DF2\8B8A\66F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109944146706314103)
,p_name=>'APEX.ISSUES.NO_LABLES_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C1A\672A\5B9A\7FA9\4EFB\4F55\6A19\7C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108939049961313317)
,p_name=>'APEX.ISSUES.OPEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F85\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108936323709313315)
,p_name=>'APEX.ISSUES.OTHER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108933894273313313)
,p_name=>'APEX.ISSUES.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108933677064313313)
,p_name=>'APEX.ISSUES.PAGE_NO_LONGER_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5DF2\4E0D\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110062905937314188)
,p_name=>'APEX.ISSUES.PURGE_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8\6C38\4E45\6E05\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109738594966313952)
,p_name=>'APEX.ISSUES.REMOVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108933413727313313)
,p_name=>'APEX.ISSUES.REMOVED_ASSOCIATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\79FB\9664\61C9\7528\7A0B\5F0F\548C\9801\9762\95DC\806F, \5F9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108934150086313313)
,p_name=>'APEX.ISSUES.REMOVED_THE_ATTACHMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\79FB\9664\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110037617746314170)
,p_name=>'APEX.ISSUES.REPLACE_COMMENT_CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\4EE5\6B64\6A23\677F\53D6\4EE3\60A8\76EE\524D\7684\8A3B\89E3\55CE?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110039662710314171)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\60A8\597D! '),
'',
unistr('\9019\662F\60A8\7684\7B2C\4E00\500B\554F\984C! \60A8\53EF\4EE5\5EFA\7ACB\554F\984C\4F86\8FFD\8E64\60A8\6240\6709 APEX \5C08\6848\7684\5DE5\4F5C\3001\529F\80FD\3001\932F\8AA4\53CA\610F\898B\56DE\994B!  \60A8\53EF\4EE5\4F7F\7528\7C21\6613\5F0F Markdown \70BA\554F\984C\65B0\589E\6A19\7C64\3001\65B0\589E\6307\5B9A\5C0D\8C61\3001\8A2D\5B9A\91CC\7A0B\7891, \751A\81F3\662F\5957\7528\683C\5F0F!  '),
'',
unistr('\4EE5\4E0B\662F\60A8\53EF\4EE5\4F7F\7528 Markdown \8655\7406\54EA\4E9B\4F5C\696D\7684\5FEB\901F\7BC4\4F8B:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110039504606314171)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B61\8FCE\4F7F\7528 Oracle APEX \4E2D\7684\5718\968A\958B\767C!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109738633391313952)
,p_name=>'APEX.ISSUES.SELECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \9078\53D6 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108934208588313314)
,p_name=>'APEX.ISSUES.SET_STATUS_TO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\72C0\614B\8A2D\70BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108910533176313295)
,p_name=>'APEX.ISSUES.SHOW_ACTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110039431221314171)
,p_name=>'APEX.ISSUES.SHOW_MORE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\66F4\591A\9805\76EE...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108933929467313313)
,p_name=>'APEX.ISSUES.SUBSCRIBED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8A02\95B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109944592862314103)
,p_name=>'APEX.ISSUES.SUMMARY_LINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340 %1 \4E2D\7684 %0 \6709 %2 \500B\65B0\7684\901A\77E5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109662773852313881)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7528\4F86\8A18\9304\932F\8AA4\7684\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109662688317313881)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109662586043313881)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**\9810\671F\7684\884C\70BA**'),
unistr('- \544A\8A34\6211\5011\60A8\8A8D\70BA\61C9\8A72\767C\751F\7684\60C5\6CC1.'),
'',
'',
unistr('**\76EE\524D\7684\884C\70BA**'),
unistr('- \544A\8A34\6211\5011\767C\751F\7684\60C5\6CC1.'),
'',
'',
unistr('**\53D7\5F71\97FF\8005**'),
unistr('- \544A\8A34\6211\5011\53D7\5F71\97FF\7684\4EBA/\7269. '),
'',
unistr('**\53EF\80FD\7684\89E3\6C7A\65B9\6848**'),
unistr('- \5982\679C\53EF\4EE5, \8ACB\63D0\8B70\60A8\8981\5982\4F55\4FEE\6B63\6B64\932F\8AA4.'),
'',
unistr('**\932F\8AA4\91CD\73FE\6B65\9A5F**'),
unistr('- \63D0\4F9B\4E00\7D44\6E05\695A\7684\932F\8AA4\91CD\73FE\6B65\9A5F, \5305\62EC\64F7\53D6\756B\9762\548C\7A0B\5F0F\78BC\7247\6BB5 (\5982\679C\9069\7528).'),
'1.',
'2.',
'3.',
'',
unistr('**\76F8\95DC\8CC7\8A0A**'),
unistr('- \767C\751F\932F\8AA4\6642, \60A8\6B63\5617\8A66\5B8C\6210\4EC0\9EBC. \932F\8AA4\53EA\767C\751F\5728\7279\5B9A\60C5\6CC1\4E0B, \6216\662F\4E00\5929\4E2D\7684\7279\5B9A\6642\9593\7B49\7B49.'),
'',
unistr('**\74B0\5883**'),
'',
unistr('- \7248\672C: '),
unistr('- \5E73\53F0: '),
unistr('- \5B50\7CFB\7D71:'),
'',
'______',
'',
unistr('_**\6CE8\610F:** \82E5\8981\5C07\554F\984C\8207\61C9\7528\7A0B\5F0F\548C (\6216) \9801\9762\5EFA\7ACB\95DC\806F, \8ACB\5148\8A18\9304\8A72\554F\984C, \7136\5F8C\4F7F\7528**\52D5\4F5C**\4E0B\62C9\5F0F\6E05\55AE\4F86\95DC\806F\61C9\7528\7A0B\5F0F\548C\9801\9762._')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109663885308313882)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\63D0\51FA\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109663735210313882)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\63D0\51FA\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109663941239313882)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5DF2\5728\9069\7576\7684\5916\90E8\7CFB\7D71\63D0\51FA**\932F\8AA4**.'),
'',
unistr('- \932F\8AA4\8FFD\8E64\7CFB\7D71: '),
unistr('- \932F\8AA4 ID: '),
unistr('- \932F\8AA4 URL: '),
'',
unistr('\8A3B\89E3:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109662923964313881)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7528\4F86\8A18\9304\529F\80FD\8981\6C42\7684\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109662891923313881)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD\8981\6C42\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109663040551313881)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**\529F\80FD\6458\8981**'),
unistr(' - \63D0\4F9B\4E00\500B\6BB5\843D\7684\529F\80FD\8981\6C42\4E00\822C\7E3D\89BD.'),
'',
'',
unistr('**\76F8\95DC\8CC7\8A0A**'),
unistr(' - \6B64\8981\6C42\662F\8207\7279\5B9A\60C5\6CC1\9084\662F\8655\7406\4F5C\696D\76F8\95DC? \4F8B\5982, "\6BCF\7576 [...] \6642, \6211\5C31\6703\6CAE\55AA"'),
'',
'',
unistr(' - \8ACB\63D0\4F9B\4EFB\4F55\652F\63F4\8CC7\8A0A, \5305\62EC\64F7\53D6\756B\9762\3001\4F7F\7528\6848\4F8B\7B49\7B49.'),
'',
'',
unistr('**\504F\597D\7684\89E3\6C7A\65B9\6848**'),
unistr('- \63D0\4F9B\60A8\60F3\8981\5BE6\884C\4E4B\505A\6CD5\7684\6E05\695A\63CF\8FF0.'),
'',
'',
unistr('**\66FF\4EE3\89E3\6C7A\65B9\6848**'),
unistr('- \63D0\4F9B\6240\8003\91CF\4E4B\66FF\4EE3\89E3\6C7A\65B9\6848\3001\529F\80FD\6216\6240\4F7F\7528\4E4B\56E0\61C9\63AA\65BD\7684\63CF\8FF0.'),
'',
'',
'______',
unistr('_**\6CE8\610F:** \82E5\8981\5C07\554F\984C\8207\61C9\7528\7A0B\5F0F\548C (\6216) \9801\9762\5EFA\7ACB\95DC\806F, \8ACB\5148\8A18\9304\554F\984C, \7136\5F8C\4F7F\7528**\52D5\4F5C**\4E0B\62C9\5F0F\6E05\55AE\4F86\95DC\806F\61C9\7528\7A0B\5F0F\548C\9801\9762._')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109664144216313882)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\63D0\51FA\529F\80FD\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109664008678313882)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\63D0\51FA\529F\80FD\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109664240529313883)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5DF2\5728\9069\7576\7684\5916\90E8\7CFB\7D71\63D0\51FA**\529F\80FD\8981\6C42**.'),
'',
unistr('- \529F\80FD\8FFD\8E64\7CFB\7D71: '),
unistr('- \529F\80FD ID: '),
unistr('- \529F\80FD\5B9A\7FA9 URL: '),
'',
unistr('\8A3B\89E3:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109665054257313883)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981\5F8C\7E8C\8FFD\8E64\52D5\4F5C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109664938094313883)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981\5F8C\7E8C\8FFD\8E64\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109665100612313883)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8ACB\57F7\884C\4E0B\5217\52D5\4F5C: '),
'',
'1.',
'2.',
'3.',
'4.',
'',
unistr('\8A3B\89E3: ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109663216453313882)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7528\4F86\8A62\554F\7A0B\5E8F\554F\984C\7684\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109663189190313882)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\4F55\9032\884C ...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109663322304313882)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**\554F\984C**'),
unistr('- \5118\53EF\80FD\7C21\8981\5730\9673\8FF0\60A8\7684\554F\984C\6216\8981\6C42.'),
'',
unistr('**\4E00\822C\76F8\95DC\8CC7\8A0A**'),
unistr('- \60A8\60F3\8981\505A\4EC0\9EBC? '),
'',
'',
unistr('- \60A8\67E5\770B\904E\54EA\4E9B\5176\4ED6\5730\65B9\6216\8207\54EA\4E9B\5176\4ED6\4EBA\54E1\806F\7E6B\4F86\5C0B\627E\7B54\6848? '),
'',
'',
unistr('**\74B0\5883** '),
unistr('\6B64\554F\984C\662F\5426\70BA\74B0\5883\3001\7A0B\5F0F\8A2D\8A08\8A9E\8A00\6216\5176\4ED6\9818\57DF\7279\5B9A\7684\554F\984C?'),
'',
'______',
unistr('_**\6CE8\610F:** \82E5\8981\5C07\554F\984C\8207\61C9\7528\7A0B\5F0F\548C (\6216) \9801\9762\5EFA\7ACB\95DC\806F, \8ACB\5148\8A18\9304\8A72\554F\984C, \7136\5F8C\4F7F\7528**\52D5\4F5C**\4E0B\62C9\5F0F\6E05\55AE\4F86\95DC\806F\61C9\7528\7A0B\5F0F\548C\9801\9762._')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109664721843313883)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\8003\5DF2\77E5\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109664690205313883)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\77E5\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109664831187313883)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7D93\904E\8907\67E5\4E4B\5F8C, \5224\65B7\9019\662F\5DF2\77E5\554F\984C, \8ACB\53C3\95B1\4E0B\65B9\8A73\7D30\8CC7\8A0A.'),
'',
unistr('- \932F\8AA4\8FFD\8E64\7CFB\7D71: '),
unistr('- \932F\8AA4 ID: '),
unistr('- \932F\8AA4 URL: '),
'',
unistr('\8A3B\89E3: ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109664433642313883)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42\5176\4ED6\8CC7\8A0A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109664333792313883)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981\5176\4ED6\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109664595938313883)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**\9700\8981\6B64\554F\984C\7684\5176\4ED6\8CC7\8A0A:**'),
'',
unistr('\8ACB\5728\4E0B\65B9\63D0\4F9B\8981\6C42\7684\8CC7\8A0A. \82E5\7121\6B64\8CC7\8A0A, \5C07\96E3\4EE5\9032\4E00\6B65\5206\985E\53CA\8655\7406\554F\984C.'),
'',
'',
unistr('\8A3B\89E3:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109663586560313882)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4E0D\6703\91DD\5C0D\6B64\554F\984C\63A1\53D6\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109663455213313882)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\63A1\53D6\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109663633659313882)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5728\4ED4\7D30\8003\91CF\4E4B\5F8C, **\5C07\4E0D\91DD\5C0D\6B64\554F\984C\63A1\53D6\9032\4E00\6B65\7684\52D5\4F5C**. '),
'',
unistr('\8A3B\89E3:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108937372666313316)
,p_name=>'APEX.ISSUES.TEXT_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108936222868313315)
,p_name=>'APEX.ISSUES.TEXT_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108933063526313313)
,p_name=>'APEX.ISSUES.THIS_ISSUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109687860872313907)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_ATTACHMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\65B0\589E\9644\4EF6 %0 \81F3 %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109686898801313905)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_LABELS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\65B0\589E %0 \81F3 %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109688435942313908)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_MILESTONES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\65B0\589E %0 \81F3 %1 %2				')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109687081403313906)
,p_name=>'APEX.ISSUES.TIMELINE.ASSIGNED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5C07 %0 \6307\5B9A\7D66 %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109687444786313906)
,p_name=>'APEX.ISSUES.TIMELINE.ASSOCIATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5C07 %0 \8207 %1 %2 \5EFA\7ACB\95DC\806F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108937545585313316)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_A_COMMENT_FOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7DE8\8F2F %0	%1 \7684\8A3B\89E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109135222911313472)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_ISSUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7DE8\8F2F\7684\554F\984C %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109688387460313908)
,p_name=>'APEX.ISSUES.TIMELINE.HIDDEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\554F\984C\5DF2\7D93\96B1\85CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109687213395313906)
,p_name=>'APEX.ISSUES.TIMELINE.MARKED_DUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5C07 %0 \6A19\793A\70BA %1 %2 \7684\91CD\8907\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109688276553313907)
,p_name=>'APEX.ISSUES.TIMELINE.OPENED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \7684\958B\555F\8005\70BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109687971461313907)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_ATTACHMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5C07\9644\4EF6 %0 \81EA %1 %2 \4E2D\79FB\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109686999201313906)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_LABELS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5C07 %0 \81EA %1 %2 \4E2D\79FB\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109688528735313908)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_MILESTONES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5C07 %0 \81EA %1 %2 \4E2D\79FB\9664 			')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109688094114313907)
,p_name=>'APEX.ISSUES.TIMELINE.STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5C07 %0 \7684\72C0\614B\8A2D\70BA %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109687623203313906)
,p_name=>'APEX.ISSUES.TIMELINE.SUBSCRIBED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8A02\95B1 %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109687117165313906)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSIGNED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\53D6\6D88\5C07 %0 \6307\5B9A\7D66 %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109687504463313906)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSOCIATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\79FB\9664\61C9\7528\7A0B\5F0F\548C\9801\9762\8207 %0 %1 \7684\95DC\806F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109687345136313906)
,p_name=>'APEX.ISSUES.TIMELINE.UNMARKED_DUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\53D6\6D88\5C07 %0 \6A19\793A\70BA %1 \7684\91CD\8907\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109687718615313907)
,p_name=>'APEX.ISSUES.TIMELINE.UNSUBSCRIBED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\53D6\6D88\8A02\95B1 %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109688131673313907)
,p_name=>'APEX.ISSUES.TIMELINE_MARKED_DUPLICATE_OF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%2 \5DF2\5C07 %0 %1 \6A19\793A\70BA\91CD\8907\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108933235962313313)
,p_name=>'APEX.ISSUES.UNASSIGNED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\53D6\6D88\6307\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108910446759313295)
,p_name=>'APEX.ISSUES.UNHIDE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88\96B1\85CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108934001926313313)
,p_name=>'APEX.ISSUES.UNSUBSCRIBED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\53D6\6D88\8A02\95B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109722958524313939)
,p_name=>'APEX.ISSUES.UPDATE_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108937165680313316)
,p_name=>'APEX.ISSUES.ZIP_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\58D3\7E2E\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108936006660313315)
,p_name=>'APEX.ISSUES.ZIP_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\58D3\7E2E\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108894381858313283)
,p_name=>'APEX.ITEM.GEOCODE.ERROR_DA_AFFECTED_ELEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\662F\300C\5730\7406\7DE8\78BC\5730\5740\300D\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110032619944314166)
,p_name=>'APEX.ITEM.NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\9805\76EE %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109923014477314088)
,p_name=>'APEX.PAGE.CHECKSUM.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\7E3D\548C\6AA2\9A57\9019\500B\7C21\55AE\7684\65B9\6CD5\53EF\5224\65B7\662F\5426\5728\5176\4ED6\4F4D\7F6E\90E8\7F72\76F8\540C\7684\9801\9762. \60A8\53EF\4EE5\6BD4\5C0D\9019\500B\7E3D\548C\6AA2\9A57\4EE5\5224\65B7\662F\5426\6709\76F8\7B26\7684\9805\76EE.	\6B64\7E3D\548C\6AA2\9A57\4E0D\6703\53CD\6620\6B64\9801\9762\4F7F\7528\7684\300C\5171\7528\7684\5143\4EF6\300D\8B8A\66F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110078676423314199)
,p_name=>'APEX.PAGE_NAME.ABOUT_THIS_APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\65BC\6B64\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110078426707314198)
,p_name=>'APEX.PAGE_NAME.CONFIGURATION_OPTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\614B\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110078572373314198)
,p_name=>'APEX.PAGE_NAME.THEME_STYLE_SELECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\4E3B\984C\6A23\5F0F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108911069737313296)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_FONTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\80FD\4F7F\7528\4E00\7A2E\5B57\578B\7684\7DCA\6E4A\5B57\578B\683C\5F0F (CFF) \5B57\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108911177890313296)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_TOP_DICTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\80FD\4F7F\7528\542B\4E00\500B\9802\5C64 DICT \7684\7DCA\6E4A\5B57\578B\683C\5F0F (CFF) \5B57\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108911240356313296)
,p_name=>'APEX.PDF.ERROR.CFF_NOT_TYPE2_CHARSTRINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\80FD\4F7F\7528 Type 2 CharString Format \7684\7DCA\6E4A\5B57\578B\683C\5F0F (CFF) \5B57\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108923485030313305)
,p_name=>'APEX.PDF.ERROR.FONT_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\5B57\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108923343098313305)
,p_name=>'APEX.PDF.ERROR.INVALID_CMAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\652F\63F4\683C\5F0F 4 \548C 12 cmap \8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108923776083313305)
,p_name=>'APEX.PDF.ERROR.INVALID_ORIENTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\9801\9762\65B9\5411.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108923549813313305)
,p_name=>'APEX.PDF.ERROR.NOT_INITIALIZED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PDF \672A\8D77\59CB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108923228034313305)
,p_name=>'APEX.PDF.ERROR.NO_CMAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5B57\578B\4E2D\627E\4E0D\5230\6709\6548\7684 cmap \5B50\8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108923658404313305)
,p_name=>'APEX.PDF.ERROR.NO_PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PDF \6C92\6709\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109358628744313643)
,p_name=>'APEX.PDF.INTERNAL_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB PDF \6A94\6848\6642\767C\751F\5167\90E8\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108929007912313310)
,p_name=>'APEX.PROCESS.INVALID_EDITABLE_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4F5C\696D "%0" \6307\5B9A\4E86\7121\6548\7684 (\975E\591A\91CD\8CC7\6599\5217) \53EF\7DE8\8F2F\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108917116859313300)
,p_name=>'APEX.PROCESS.NATIVE.GET_NEXT_OR_PREV_PK_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\5F97\4E0B\4E00\500B\6216\4E0A\4E00\500B\4E3B\7D22\5F15\9375\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109586639231313819)
,p_name=>'APEX.PROCESS.NATIVE.WEB_SERVICE.NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230 Web \670D\52D9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109124410555313464)
,p_name=>'APEX.PROCESS.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\8655\7406\4F5C\696D\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108943792317313321)
,p_name=>'APEX.QOS.REQUEST_LIMIT_REACHED'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7531\65BC\8CC7\6599\5EAB\968E\6BB5\4F5C\696D\8CC7\6E90\7684\9650\5236, Application Express \7121\6CD5\8655\7406\8981\6C42. \8ACB\7A0D\5F8C\518D\8A66.'),
'<p/>',
unistr('\6709\95DC\6B64\672A\9810\671F\4E8B\4EF6\7684\8A73\7D30\8CC7\8A0A, \8ACB\900F\904E\9664\932F ID "%0" \4F86\53D6\5F97.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108917995722313301)
,p_name=>'APEX.REMOTEDEPLOY.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\90E8\7F72\61C9\7528\7A0B\5F0F\6642\767C\751F\4E0B\5217\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108920627671313303)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F %0 \5DF2\9806\5229\90E8\7F72\81F3\9060\7AEF\4F3A\670D\5668.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108924301817313306)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F %0 \5DF2\9806\5229\90E8\7F72\81F3\9060\7AEF\4F3A\670D\5668\4EE5\4F5C\70BA %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109558857112313794)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\555F\7528 REST \7684 SQL \670D\52D9\8A8D\8B49\5931\6557.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108944017344313321)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED_FOR_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\5931\6557. \503C\6E05\55AE\4F7F\7528\53C3\7167\7121\6548 Web \8B49\660E\8CC7\6599\7684\300C\555F\7528 REST \7684 SQL\300D\8CC7\6599\4F86\6E90, \56E0\6B64\60A8\7121\6CD5\7DE8\8F2F\6B64 LOV \7684\8CC7\6599\6B04\8CC7\8A0A. \8ACB\6AA2\67E5\8A8D\8B49\8B49\660E\8CC7\6599. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110065148509314189)
,p_name=>'APEX.REMOTESQL.COMMUNICATION_FAILURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\901A\8A0A\5931\6557. \547C\53EB\503C\6E05\55AE\6240\53C3\7167\7684\300C\555F\7528 REST \7684 SQL\300D\8CC7\6599\4F86\6E90\6642\767C\751F\554F\984C, \9019\5C07\4F7F\60A8\7121\6CD5\7DE8\8F2F LOV \7684\8CC7\6599\6B04\8CC7\8A0A. \8ACB\6AA2\67E5\300C\555F\7528 REST \7684 SQL\300D\8CC7\6599\4F86\6E90\662F\5426\6B63\78BA\904B\4F5C, \4EE5\53CA\5C0D\61C9\7684\8A8D\8B49\8B49\660E\8CC7\6599\662F\5426\6B63\78BA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109560124370313799)
,p_name=>'APEX.REMOTESQL.REMOTE_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9060\7AEF\4F3A\670D\5668\4E0A\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109534901664313777)
,p_name=>'APEX.REMOTESQL.SERVER_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\555F\7528 ORDS REST \7684\6307\5B9A SQL \57F7\884C\8655\7406.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109140715818313476)
,p_name=>'APEX.REMOTESQL.SERVER_SENT_REDIRECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F3A\670D\5668\5DF2\50B3\9001\91CD\65B0\5C0E\5411\81F3: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109435266925313702)
,p_name=>'APEX.REMOTESQL.SQL_STATEMENT_TOO_LONG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \6558\8FF0\53E5\9577\5EA6\8D85\904E 32.767 \500B\4F4D\5143\7D44.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109453969002313716)
,p_name=>'APEX.REMOTESQL.TEST_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6B61\8FCE\4F7F\7528 Application Express! \60A8\76EE\524D\4EE5 #USER# \8EAB\5206\9032\884C\9023\7DDA.'),
unistr('\672C\6A5F\8CC7\6599\5EAB\6642\6233\70BA: #SYSDATE#.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109679032970313897)
,p_name=>'APEX.REST.DEFAULT_SCHEMA_WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\6B63\5728\7DE8\8F2F\5DE5\4F5C\5340\9810\8A2D\7DB1\8981\7684\5225\540D. \8A2D\5B9A\6B64\5225\540D\6703\4E00\4F75\8B8A\66F4\5DE5\4F5C\5340\5C64\7D1A\7684\300C\8DEF\5F91\524D\7F6E\78BC\300D. \9019\6703\5F71\97FF\60A8\53EF\80FD\5DF2\5B9A\7FA9\4E4B\4EFB\4F55 APEX \578B RESTful \670D\52D9\7684 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109432980277313700)
,p_name=>'APEX.SC.REFERENCES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\53C3\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109670390433313888)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109670444372313889)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \61C9\7528\7A0B\5F0F\516C\7528\7A0B\5F0F \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109677882052313896)
,p_name=>'APEX.SEARCH.GO_TO_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\81F3\9801\9762')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109677705678313896)
,p_name=>'APEX.SEARCH.GO_TO_SHARED_COMPONENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D\5F80\5171\7528\7684\5143\4EF6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109670505572313889)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7522\751F\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109670639274313889)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER_TASKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7522\751F\5668\5DE5\4F5C > ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109670734115313889)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109670806712313889)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C \61C9\7528\7A0B\5F0F\9805\76EE \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109670911360313889)
,p_name=>'APEX.SEARCH.SC.APP_LOGIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\908F\8F2F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109671055988313889)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109671174055313889)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C \5B89\5168\6027\8A8D\8B49\914D\7F6E \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109671206946313889)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109671324202313889)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C \5B89\5168\6027\6388\6B0A\914D\7F6E \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109671472131313889)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109671549001313890)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C \5C0E\89BD\8DEF\5F91 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109671649807313890)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\5EFA\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109671766460313890)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C \7D44\5EFA\9078\9805 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109671845518313890)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109671955200313890)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C \5143\4EF6\8A2D\5B9A\503C \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109672008272313890)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109672141882313890)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C \61C9\7528\7A0B\5F0F\904B\7B97 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109672236235313890)
,p_name=>'APEX.SEARCH.SC.CREATE_APPLICATION_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109672396014313890)
,p_name=>'APEX.SEARCH.SC.CREATE_AUTHENTICATION_SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\8A8D\8B49\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109672482056313891)
,p_name=>'APEX.SEARCH.SC.CREATE_BUILD_OPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\7D44\5EFA\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109672547708313891)
,p_name=>'APEX.SEARCH.SC.CREATE_COMPUTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109672694910313891)
,p_name=>'APEX.SEARCH.SC.CREATE_EMAIL_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\96FB\5B50\90F5\4EF6\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109672749105313891)
,p_name=>'APEX.SEARCH.SC.CREATE_PLUG-IN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB Plug-in')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109672896514313891)
,p_name=>'APEX.SEARCH.SC.CREATE_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109672982948313891)
,p_name=>'APEX.SEARCH.SC.CREATE_WEB_CREDENTIALS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB Web \8B49\660E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109673016916313891)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109673199320313891)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C \8CC7\6599\8F09\5165\5B9A\7FA9 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109673212557313891)
,p_name=>'APEX.SEARCH.SC.DATA_SOURCES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109673366386313891)
,p_name=>'APEX.SEARCH.SC.DEFINITION_ATTRIBUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B9A\7FA9\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109673476177313892)
,p_name=>'APEX.SEARCH.SC.EMAIL_TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109673581380313892)
,p_name=>'APEX.SEARCH.SC.LAYOUTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\7248\9762\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109673608551313892)
,p_name=>'APEX.SEARCH.SC.LAYOUTS_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C \5831\8868\7248\9762\914D\7F6E \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109673700657313892)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\820A\6709 Web \670D\52D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109673894854313892)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C \820A\6709 Web \670D\52D9 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109673923744313892)
,p_name=>'APEX.SEARCH.SC.LISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109674059079313892)
,p_name=>'APEX.SEARCH.SC.LISTS_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C \4E00\822C\5C0E\89BD\6E05\55AE \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109674144695313892)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109674262952313892)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C \503C\6E05\55AE \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109674348767313892)
,p_name=>'APEX.SEARCH.SC.NAVIGATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109674433703313893)
,p_name=>'APEX.SEARCH.SC.OTHER_COMPONENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109674588872313893)
,p_name=>'APEX.SEARCH.SC.PLUG-INS'
,p_message_language=>'zh-tw'
,p_message_text=>'Plug-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109674683640313893)
,p_name=>'APEX.SEARCH.SC.PLUG-INS_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C Plug-in \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109674787661313893)
,p_name=>'APEX.SEARCH.SC.PROCESSES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109674894666313893)
,p_name=>'APEX.SEARCH.SC.PROCESSES_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C \61C9\7528\7A0B\5F0F\8655\7406\4F5C\696D \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109674913694313893)
,p_name=>'APEX.SEARCH.SC.QUERIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109675073942313893)
,p_name=>'APEX.SEARCH.SC.QUERIES_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C \5831\8868\67E5\8A62 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109675113297313893)
,p_name=>'APEX.SEARCH.SC.REPORTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109675221309313893)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528 REST \7684 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109675314407313893)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C \555F\7528 REST \7684 SQL \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109675475200313893)
,p_name=>'APEX.SEARCH.SC.SECURITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\5168\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109675586303313894)
,p_name=>'APEX.SEARCH.SC.SESSION_STATE_PROTECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D\72C0\614B\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109675629862313894)
,p_name=>'APEX.SEARCH.SC.SET_APPLICATION_SESSION_STATE_PROTECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\61C9\7528\7A0B\5F0F\72C0\614B\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109675859008313894)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5171\7528\7684\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109675990466313894)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109676006522313894)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6377\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109676109978313894)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C \6377\5F91 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109676207612313894)
,p_name=>'APEX.SEARCH.SC.TABS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64 (\820A\6709)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109676305636313894)
,p_name=>'APEX.SEARCH.SC.TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109676433107313894)
,p_name=>'APEX.SEARCH.SC.TEMPLATES_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C UI \6A23\677F \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109676585753313894)
,p_name=>'APEX.SEARCH.SC.THEMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109676685457313895)
,p_name=>'APEX.SEARCH.SC.THEMES_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C UI \4E3B\984C \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109676738406313895)
,p_name=>'APEX.SEARCH.SC.UI'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109676845400313895)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \8B49\660E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109676963277313895)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C \5B89\5168\6027 Web \8B49\660E\8CC7\6599 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109677060544313895)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \8CC7\6599\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109677140519313895)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3: \5171\7528\7684\5143\4EF6 \005C REST \8CC7\6599\4F86\6E90 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109677223244313895)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \5DE5\4F5C\5BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109677364541313895)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109677425306313895)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728 SQL \5DE5\4F5C\5BA4\4E2D\5EFA\7ACB %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109677518400313895)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.SCRIPT_EDITOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\547D\4EE4\6A94\7DE8\8F2F\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109677640195313896)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.TASKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \5DE5\4F5C\5BA4\5DE5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110136447059314261)
,p_name=>'APEX.SESSION_STATE.DB_COLUMN_SOURCE_USED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE %0 \662F\4EE5\300C\8CC7\6599\5EAB\8CC7\6599\6B04\300D\70BA\57FA\790E, \4F46\662F\300C\4F7F\7528\7684\4F86\6E90\300D\5C6C\6027\8A2D\70BA\300C\53EA\6709\7576\968E\6BB5\4F5C\696D\72C0\614B\7684\76EE\524D\503C\662F\7A7A\503C\6642\300D. \9019\5341\5206\5371\96AA, \53EF\80FD\6703\5728\6AA2\8996\548C\5132\5B58\591A\7B46\8A18\9304\6642\5C0E\81F4\610F\5916\8986\5BEB\8CC7\6599. \8ACB\4E00\5F8B\5C07\300C\4F7F\7528\7684\4F86\6E90\300D\8A2D\70BA\300C\6C38\9060, \53D6\4EE3\968E\6BB5\4F5C\696D\4E2D\4EFB\4F55\73FE\6709\7684\503C\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110073715082314195)
,p_name=>'APEX.SESSION_STATE.DISABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\505C\7528\5B58\53D6\968E\6BB5\4F5C\696D\72C0\614B, \5DF2\5C01\9396\5617\8A66\8B80\53D6/\5BEB\5165.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108957139842313332)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5617\8A66\5728\986F\793A\8655\7406\671F\9593, \5132\5B58\968E\6BB5\4F5C\696D\4E2D\7684\9805\76EE %0. \9805\76EE\64C1\6709\300C\50C5\9650\5167\90E8\300D\4FDD\8B77.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108949967572313326)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5617\8A66\5728\63A5\53D7\8655\7406\671F\9593, \5132\5B58\968E\6BB5\4F5C\696D\4E2D\7684\9805\76EE %0. \9805\76EE\64C1\6709\300C\50C5\9650\5167\90E8\300D\4FDD\8B77, \6216\8005\4E0D\662F\53EF\516C\5E03\7684\8868\55AE\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108949744255313326)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION2_FOR_DEVELOPERS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\91DD\5C0D\8981\6C42\3001\6E05\9664\5FEB\53D6\3001\5F15\6578\540D\7A31\4EE5\53CA\5F15\6578\503C (%0) \904B\7B97\7684\7E3D\548C\6AA2\9A57, \8207\50B3\9001\81F3\986F\793A\7A0B\5E8F (%1) \7684\7E3D\548C\6AA2\9A57\4E0D\7B26.'),
'',
unistr('\6CE8\610F: \4E00\822C\4F7F\7528\8005\6703\6536\5230\4E0D\540C\7684\932F\8AA4\8A0A\606F.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108949231212313326)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION_FOR_DEVELOPERS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5617\8A66\5728\9032\884C\986F\793A\8655\7406\6642\5132\5B58\968E\6BB5\4F5C\696D\72C0\614B\4E2D\7684\9805\76EE %0. \9805\76EE\4FDD\8B77\5C64\7D1A\70BA:'),
'  %1',
'',
unistr('\672A\50B3\5165\7E3D\548C\6AA2\9A57, \6216\50B3\5165\7684\7E3D\548C\6AA2\9A57\9069\7528\65BC\4FDD\8B77\5C64\7D1A\70BA "%2" \7684\9805\76EE.'),
'',
unistr('\6CE8\610F: \4E00\822C\4F7F\7528\8005\6703\6536\5230\4E0D\540C\7684\932F\8AA4\8A0A\606F.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109124233541313464)
,p_name=>'APEX.SESSION_STATE.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1022 \7121\6CD5\5132\5B58\5C6C\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108893800051313282)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_SDO_GEOMETRY_TO_GEOJSON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5C07 SDO_GEOMETRY \503C\8F49\63DB\6210 GeoJSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108891356896313280)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_TEXT_TO_SDO_GEOMETRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5C07\6587\5B57\8F49\63DB\6210 SDO_GEOMETRY \7269\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108892545336313281)
,p_name=>'APEX.SPATIAL.INVALID_GEOJSON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \672A\5305\542B\6709\6548\7684 GeoJSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108908177134313293)
,p_name=>'APEX.TABULAR_FORM.COLUMN_DEFAULT_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97\8CC7\6599\6B04 #COMPONENT_NAME# \7684\9810\8A2D\503C\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108909021191313294)
,p_name=>'APEX.TABULAR_FORM.MRD.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\300C\522A\9664\591A\91CD\8CC7\6599\5217\300D\8655\7406\4F5C\696D\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109151267114313484)
,p_name=>'APEX.TABULAR_FORM.MRU.FCS_MISSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\63D0\4F9B\5FC5\8981\7684\7E3D\548C\6838\67E5\8CC7\6599\6B04 ("FCS")')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109151458614313484)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_PRIM_KEY_VALS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\63D0\4F9B\4E3B\7D22\5F15\9375\503C, \81F3\5C11\5FC5\9808\63D0\4F9B\4E00\500B\8CC7\6599\5217\624D\80FD\9032\884C\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109152299304313484)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_SEC_KEY_VALS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\63D0\4F9B\8B58\5225\4E4B\6B21\8981\7D22\5F15\9375\8CC7\6599\6B04\7684\6B21\8981\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109291815901313593)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_VALUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5217\8868\5316\8868\55AE\4E2D\627E\4E0D\5230\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109151158532313484)
,p_name=>'APEX.TABULAR_FORM.MRU.PRIM_KEY_COL_NOT_SPECIFIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6307\5B9A\4E3B\7D22\5F15\9375\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109152116904313484)
,p_name=>'APEX.TABULAR_FORM.MRU.SEC_KEY_COL_NOT_IN_SELECT_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\6B21\8981\7D22\5F15\9375\8CC7\6599\6B04\4E0D\5728\9078\53D6\7684\67E5\8A62\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109151047473313484)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_NAME_NOT_SPECIFIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6307\5B9A\300C\8868\683C\540D\7A31\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109150993819313483)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_OWNER_NOT_SPECIFIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6307\5B9A\300C\8868\683C\64C1\6709\8005\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109172121732313499)
,p_name=>'APEX.TABULAR_FORM.MRU.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\300C\66F4\65B0\591A\91CD\8CC7\6599\5217\300D\8655\7406\4F5C\696D\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108932337134313312)
,p_name=>'APEX.THEMES.COPY_THEME_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8907\88FD\61C9\7528\7A0B\5F0F "%1" \4E2D\7684\4E3B\984C "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110129911514314256)
,p_name=>'APEX.THEMES.INCOMPATIBLE_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\532F\5165\7684\4E3B\984C\8207\76EE\524D\7684\4E3B\984C\4E0D\76F8\5BB9.'),
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110112005655314242)
,p_name=>'APEX.THEMES.INVALID_THEME_NUMBER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\7DE8\865F\7121\6548, \6216\8005\4E3B\984C\4E0D\662F\76EE\524D\7684 UI \4E3B\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110072851157314194)
,p_name=>'APEX.TREE.ID_AND_PARENT_ID_COLUMNS_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8981\6709\4E3B\7D22\5F15\9375\8CC7\6599\6B04\548C\7236\9805\7D22\5F15\9375\8CC7\6599\6B04, \624D\80FD\904B\7B97\968E\5C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110072989178314195)
,p_name=>'APEX.TREE.NODE_LEVEL_AND_STATUS_COLUMNS_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\672A\904B\7B97\968E\5C64, \5FC5\9808\8981\6709\7BC0\9EDE\5C64\7D1A\8CC7\6599\6B04\548C\7BC0\9EDE\72C0\614B\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110091282660314208)
,p_name=>'APEX.UI.APPEARANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\89C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109850205468314036)
,p_name=>'APEX.UI.AUTO_MODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109064768150313419)
,p_name=>'APEX.UI.DARK_MODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DF1\8272\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109064854644313419)
,p_name=>'APEX.UI.DISABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109850166333314036)
,p_name=>'APEX.UI.LIGHT_MODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DFA\8272\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109493604505313746)
,p_name=>'APEX.UI_TYPE.CLIENT_DETECTION.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\5F9E\4E0B\65B9\6E05\55AE\4E2D\9078\53D6\4E00\500B\4F7F\7528\8005\4ECB\9762:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109495957520313747)
,p_name=>'APEX.UI_TYPE.CLIENT_DETECTION.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 - \9078\53D6\4F7F\7528\8005\4ECB\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109035417609313397)
,p_name=>'APEX.USER.CHECK_SGID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6388\6B0A\7684\5B58\53D6 (\672A\8A2D\5B9A\5B89\5168\6027\7FA4\7D44\5957\88DD\7A0B\5F0F\8B8A\6578).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109035800785313398)
,p_name=>'APEX.USER.FETCH_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\64F7\53D6\5C0B\627E\4F7F\7528\8005\8CC7\8A0A. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109021601001313387)
,p_name=>'APEX.USER.NOT_ADMIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005 %0 \9700\8981\6709 ADMIN \6B0A\9650\624D\80FD\57F7\884C\9019\9805\4F5C\696D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109035730984313398)
,p_name=>'APEX.USER.NO_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005 %0 \5C1A\672A\63D0\4F9B\96FB\5B50\90F5\4EF6\5730\5740.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108991543144313359)
,p_name=>'APEX.USER.UNAUTHORIZED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6388\6B0A\7684\5B58\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109035652127313398)
,p_name=>'APEX.USER.USER_DOES_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005 %0 \4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108950674246313327)
,p_name=>'APEX.VALIDATION.INVALID_EDITABLE_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49 "%0" \6307\5B9A\4E86\7121\6548\7684 (\975E\591A\91CD\8CC7\6599\5217) \53EF\7DE8\8F2F\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109124316598313464)
,p_name=>'APEX.VALIDATION.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\9A57\8B49\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110074197459314195)
,p_name=>'APEX.WEBSRC.CANNOT_PARSE_DATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Application Express \7121\6CD5\5F9E %0 \985E\578B\7684\56DE\61C9\8CC7\6599\904B\7B97\8CC7\6599\8A2D\5B9A\6A94.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109540847577313781)
,p_name=>'APEX.WEBSRC.DATAPROFILE.MANY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109540779699313781)
,p_name=>'APEX.WEBSRC.DATAPROFILE.ONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110060707398314186)
,p_name=>'APEX.WEBSRC.FILTER_EXPR_INVALID_JSON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078\8868\793A\5F0F\4E0D\662F\6709\6548\7684 JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110053937993314181)
,p_name=>'APEX.WEBSRC.FILTER_NOT_SUPPORTED_BY_ORDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle REST Data Services \4E0D\652F\63F4\7BE9\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109432823082313700)
,p_name=>'APEX.WEBSRC.HTTP.PAGINATION_PARAMETER_CONFLICT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\9801 URL \53C3\6578 "%0" \8207 REST \4F86\6E90\53C3\6578\885D\7A81.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109535729607313777)
,p_name=>'APEX.WEBSRC.HTTP200'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP 200: \6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109535885588313777)
,p_name=>'APEX.WEBSRC.HTTP201'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP 201: \5DF2\5EFA\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109535200840313777)
,p_name=>'APEX.WEBSRC.HTTP400'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP 400: \7121\6548\7684\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109535010812313777)
,p_name=>'APEX.WEBSRC.HTTP401'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP 401: \672A\6388\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109535306286313777)
,p_name=>'APEX.WEBSRC.HTTP403'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP 403: \7981\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109535109261313777)
,p_name=>'APEX.WEBSRC.HTTP404'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP 404: \627E\4E0D\5230')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109535421987313777)
,p_name=>'APEX.WEBSRC.HTTP405'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP 405: \65B9\6CD5\4E0D\5141\8A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108893174507313282)
,p_name=>'APEX.WEBSRC.HTTP407'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP 407: \9700\8981\4EE3\7406\4E3B\6A5F\8A8D\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108893418279313282)
,p_name=>'APEX.WEBSRC.HTTP409'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP 409: \767C\751F\885D\7A81')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108893294963313282)
,p_name=>'APEX.WEBSRC.HTTP412'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP 412: \5148\6C7A\689D\4EF6\5931\6557')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108893303052313282)
,p_name=>'APEX.WEBSRC.HTTP428'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP 428: \5FC5\9808\8981\6709\5148\6C7A\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109535547300313777)
,p_name=>'APEX.WEBSRC.HTTP500'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP 500: \5167\90E8\4F3A\670D\5668\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109535667077313777)
,p_name=>'APEX.WEBSRC.HTTP502'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP 502: \7121\6548\7684\9598\9053')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110074597155314196)
,p_name=>'APEX.WEBSRC.HTTP503'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP 503: \670D\52D9\7121\6CD5\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110074613231314196)
,p_name=>'APEX.WEBSRC.HTTP504'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP 504: \9598\9053\903E\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109916702548314084)
,p_name=>'APEX.WEBSRC.HTTP_ERROR_OCCURRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \4F86\6E90\50B3\56DE HTTP \932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109534838650313777)
,p_name=>'APEX.WEBSRC.MODULE_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230 REST \8CC7\6599\4F86\6E90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109090648556313438)
,p_name=>'APEX.WEBSRC.NO_ARRAY_SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\9078\53D6\5668 "%0" \672A\9078\53D6\8981\8996\70BA\8868\683C\7684\7269\4EF6\9663\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109090727370313439)
,p_name=>'APEX.WEBSRC.NO_SINGLE_ROW_SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\9078\53D6\5668 "%0" \672A\9078\53D6\8981\8996\70BA\55AE\4E00\8CC7\6599\5217\7684\7269\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108896389202313284)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D85\904E REST \8CC7\6599\4F86\6E90\901F\7387\9650\5236 (%1 \79D2\5167 %0 \500B\8981\6C42).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108885318937313276)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED_CANNOT_WAIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D85\904E REST \8CC7\6599\4F86\6E90\901F\7387\9650\5236 (%1 \79D2\5167 %0 \500B\8981\6C42), \9700\8981\7684\7B49\5F85\6642\9593\904E\9577.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109916662495314084)
,p_name=>'APEX.WEBSRC.REQUIRED_PARAM_MISSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\63D0\4F9B "%1" \985E\578B\4E4B\5FC5\8981 REST \4F86\6E90 IN \53C3\6578 "%0" \7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109834626152314024)
,p_name=>'APEX.WEBSRC.RESPONSE_BODY_TOO_LARGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56DE\61C9\4E3B\9AD4\592A\5927, \56E0\6B64\7121\6CD5\986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109500003836313750)
,p_name=>'APEX.WEBSRC.SMALL_ORDS2_FIXED_PAGE_SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\820A\6709 ORDS REST \670D\52D9\4F7F\7528\5C0F\578B\56FA\5B9A\9801\9762\5927\5C0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108899939532313287)
,p_name=>'APEX.WEBSRC.SYNC.API_CALL_COMMENT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('-- \6B64 API \547C\53EB\6703\57F7\884C ALTER TABLE \6558\8FF0\53E5, \4EE5\52D5\614B\65B9\5F0F\5C07\8868\683C'),
unistr('-- \8CC7\6599\6B04\540C\6B65\81F3 REST \8CC7\6599\4F86\6E90\7684\8CC7\6599\8A2D\5B9A\6A94. '),
unistr('-- \5982\679C\7121\6CD5\4F7F\7528 ALTER TABLE \8B8A\66F4\8CC7\6599\6B04\8CC7\6599\985E\578B, \5C07\6703\767C\51FA'),
unistr('-- \932F\8AA4\8A0A\606F.'),
'--'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108898860031313286)
,p_name=>'APEX.WEBSRC.SYNC.CANNOT_SYNC_TABLE_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\81EA\52D5\5957\7528\8CC7\6599\8A2D\5B9A\6A94\8B8A\66F4, \5FC5\9808\624B\52D5\8ABF\6574\672C\6A5F\8868\683C\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108900004275313287)
,p_name=>'APEX.WEBSRC.SYNC.DDL_CALL_COMMENT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('-- \5C07\6703\5728 %0 \57F7\884C:'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108898056054313285)
,p_name=>'APEX.WEBSRC.SYNC.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5408\4F75\540C\6B65\5316\65B9\6CD5\898F\5B9A\9700\5728\8CC7\6599\8A2D\5B9A\6A94\4E2D\5B9A\7FA9\4E3B\7D22\5F15\9375.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108898391601313286)
,p_name=>'APEX.WEBSRC.SYNC.NO_COMMON_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672C\6A5F\8868\683C\548C\8CC7\6599\8A2D\5B9A\6A94\6C92\6709\901A\7528\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108884917686313275)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_ABORTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5DF2\4E2D\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108898584909313286)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_FAILURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5931\6557')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108898614769313286)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_INCOMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5B8C\6210 (\8D85\904E\8981\6C42\9650\5236)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108898781894313286)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_JOB_ALREADY_RUNNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5DF2\5728\57F7\884C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108885809797313276)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_RUNNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108885981564313276)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SCHEDULED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6392\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108898457835313286)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108898193816313285)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540C\6B65\5316\6B65\9A5F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108898247817313286)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL_COPY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 (\65B0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109382989009313662)
,p_name=>'APEX.WEBSRC.TEST_OPERATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E2C\8A66\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109454005121313717)
,p_name=>'APEX.WEBSRC.TIMEOUT_EXCEEDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64F7\53D6\6240\6709 REST \4F86\6E90\8CC7\6599\6642\903E\6642.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109429974466313697)
,p_name=>'APEX.WEBSRC.TOO_MANY_NEXT_PAGE_REQUESTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\672C\6A5F SQL \7BE9\9078\689D\4EF6\9700\8981\5411 REST \670D\52D9\63D0\51FA\592A\591A\300C\4E0B\4E00\9801\300D\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109499984662313750)
,p_name=>'APEX.WEBSRC.UNKNOWN_ORDS2_FIXED_PAGE_SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\820A\6709 ORDS REST \670D\52D9\7684\56FA\5B9A\9801\9762\5927\5C0F\4E0D\660E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109206356110313525)
,p_name=>'APEXAPP.BRANCH.ADMIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\9801\9762\7684\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109180862997313506)
,p_name=>'APEXAPP.BREADCRUMB.DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109202475535313522)
,p_name=>'APEXAPP.BUILD_OPTION.COMMENTED_OUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8A2D\70BA\8A3B\89E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109186922264313511)
,p_name=>'APEXAPP.BUTTON.ADD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109187296904313511)
,p_name=>'APEXAPP.BUTTON.ADD_ENTITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109187616924313511)
,p_name=>'APEXAPP.BUTTON.ADD_MULTIPLE_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\591A\500B\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109187774651313511)
,p_name=>'APEXAPP.BUTTON.ADD_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109187861376313511)
,p_name=>'APEXAPP.BUTTON.ADD_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109186658493313510)
,p_name=>'APEXAPP.BUTTON.APPLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528\8B8A\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109186731727313510)
,p_name=>'APEXAPP.BUTTON.CANCEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109186824805313510)
,p_name=>'APEXAPP.BUTTON.CLOSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109186582036313510)
,p_name=>'APEXAPP.BUTTON.CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109175880084313502)
,p_name=>'APEXAPP.BUTTON.DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109187014632313511)
,p_name=>'APEXAPP.BUTTON.DELETE_CHECKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\52FE\9078\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109187117595313511)
,p_name=>'APEXAPP.BUTTON.EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109187339790313511)
,p_name=>'APEXAPP.BUTTON.FINISH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109175616182313502)
,p_name=>'APEXAPP.BUTTON.GO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109176389411313503)
,p_name=>'APEXAPP.BUTTON.LOAD_DATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109187477994313511)
,p_name=>'APEXAPP.BUTTON.LOGIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109176018628313502)
,p_name=>'APEXAPP.BUTTON.NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109175931154313502)
,p_name=>'APEXAPP.BUTTON.PREVIOUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109175797083313502)
,p_name=>'APEXAPP.BUTTON.RESET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109176159013313502)
,p_name=>'APEXAPP.BUTTON.SAVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109176233997313502)
,p_name=>'APEXAPP.BUTTON.SUBMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109187919355313511)
,p_name=>'APEXAPP.BUTTON.SUBMIT_FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109187558930313511)
,p_name=>'APEXAPP.BUTTON.VIEW_DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\8A73\7D30\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109180702839313506)
,p_name=>'APEXAPP.CHART.LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109199972345313520)
,p_name=>'APEXAPP.CHART.SERIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \6578\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109192376117313515)
,p_name=>'APEXAPP.COLUMN.ACL_ROLES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109180595129313506)
,p_name=>'APEXAPP.COLUMN.ACTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109191374453313514)
,p_name=>'APEXAPP.COLUMN.ACTIVITY_BY_HOUR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F9D\5C0F\6642\5340\5206\7684\6D3B\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109190681464313513)
,p_name=>'APEXAPP.COLUMN.APPLICATION_SESSIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\968E\6BB5\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109180445447313506)
,p_name=>'APEXAPP.COLUMN.ATTACHMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109179691447313505)
,p_name=>'APEXAPP.COLUMN.AUTOMATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109190201021313513)
,p_name=>'APEXAPP.COLUMN.AVG_ELAPSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E73\5747\7D93\6B77\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109189657696313513)
,p_name=>'APEXAPP.COLUMN.COMPONENT_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109191288436313514)
,p_name=>'APEXAPP.COLUMN.CONTEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\95DC\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109188599165313512)
,p_name=>'APEXAPP.COLUMN.CURRENT_STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109188270174313511)
,p_name=>'APEXAPP.COLUMN.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109190523656313513)
,p_name=>'APEXAPP.COLUMN.DISTINCT_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\540C\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109179419971313505)
,p_name=>'APEXAPP.COLUMN.EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109189386834313512)
,p_name=>'APEXAPP.COLUMN.ELAPSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D93\6B77\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109192239571313514)
,p_name=>'APEXAPP.COLUMN.ENDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109189941495313513)
,p_name=>'APEXAPP.COLUMN.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109179583008313505)
,p_name=>'APEXAPP.COLUMN.ERRORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109192141050313514)
,p_name=>'APEXAPP.COLUMN.ERROR_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109188065654313511)
,p_name=>'APEXAPP.COLUMN.FEATURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109180189077313505)
,p_name=>'APEXAPP.COLUMN.FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109179914828313505)
,p_name=>'APEXAPP.COLUMN.FILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\63D0\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109192573967313515)
,p_name=>'APEXAPP.COLUMN.FILED_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\51FA\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109191066015313514)
,p_name=>'APEXAPP.COLUMN.FULL_PAGE_VIEWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6574\9801\9762\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109189857557313513)
,p_name=>'APEXAPP.COLUMN.IR_SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('IR \641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109188618730313512)
,p_name=>'APEXAPP.COLUMN.LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109188956203313512)
,p_name=>'APEXAPP.COLUMN.LAST_ACTIVITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\6B21\6D3B\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109190192295313513)
,p_name=>'APEXAPP.COLUMN.MAX_ELAPSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\9577\7D93\6B77\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109190303136313513)
,p_name=>'APEXAPP.COLUMN.MEDIAN_ELAPSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\9593\503C\6B77\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109191734428313514)
,p_name=>'APEXAPP.COLUMN.MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109191892402313514)
,p_name=>'APEXAPP.COLUMN.MESSAGE_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A0A\606F\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109190026192313513)
,p_name=>'APEXAPP.COLUMN.MIN_ELAPSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\77ED\7D93\6B77\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109191654776313514)
,p_name=>'APEXAPP.COLUMN.MOST_RECENT'
,p_message_language=>'zh-tw'
,p_message_text=>'Most_Recent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109189719706313513)
,p_name=>'APEXAPP.COLUMN.NUM_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\6578\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109191177946313514)
,p_name=>'APEXAPP.COLUMN.OCCURRENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FA\73FE\6B21\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109189448351313512)
,p_name=>'APEXAPP.COLUMN.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109191466548313514)
,p_name=>'APEXAPP.COLUMN.PAGE_EVENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109189568884313512)
,p_name=>'APEXAPP.COLUMN.PAGE_MODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109189084143313512)
,p_name=>'APEXAPP.COLUMN.PAGE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109190796712313513)
,p_name=>'APEXAPP.COLUMN.PAGE_VIEWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109190907681313513)
,p_name=>'APEXAPP.COLUMN.PARTIAL_PAGE_VIEWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\90E8\5206\9801\9762\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109191982708313514)
,p_name=>'APEXAPP.COLUMN.PK_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\9375  \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109180094111313505)
,p_name=>'APEXAPP.COLUMN.RATING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A55\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109192489917313515)
,p_name=>'APEXAPP.COLUMN.REASON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\539F\56E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109180290445313505)
,p_name=>'APEXAPP.COLUMN.RESPONSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56DE\61C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109191526062313514)
,p_name=>'APEXAPP.COLUMN.ROWS_FETCHED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64F7\53D6\7684\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109179808391313505)
,p_name=>'APEXAPP.COLUMN.SCHEDULED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6392\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109179785998313505)
,p_name=>'APEXAPP.COLUMN.STARTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109188151940313511)
,p_name=>'APEXAPP.COLUMN.STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109192091089313514)
,p_name=>'APEXAPP.COLUMN.SUCCESSFUL_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F\7684\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109189210390313512)
,p_name=>'APEXAPP.COLUMN.TIMESTAMP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\6233')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109190835625313513)
,p_name=>'APEXAPP.COLUMN.TOTAL_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\7E3D\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109188426809313512)
,p_name=>'APEXAPP.COLUMN.UPDATED_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109188353620313512)
,p_name=>'APEXAPP.COLUMN.UPDATED_ON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109189164745313512)
,p_name=>'APEXAPP.COLUMN.USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109188831185313512)
,p_name=>'APEXAPP.COLUMN.USERNAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109180392088313506)
,p_name=>'APEXAPP.COLUMN.USER_AGENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4EE3\7406\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109188739884313512)
,p_name=>'APEXAPP.COLUMN.VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109190400984313513)
,p_name=>'APEXAPP.COLUMN.WEIGHTED_PERFORMANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52A0\6B0A\6548\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109173006196313500)
,p_name=>'APEXAPP.DA.AFTER_CLOSE_DIALOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\8A71\65B9\584A\5DF2\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109185982833313510)
,p_name=>'APEXAPP.DA.CANCEL_BUTTON.DIALOG_CANCEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88\5C0D\8A71\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109186414064313510)
,p_name=>'APEXAPP.DA.CHANGE_FILTERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4\7BE9\9078')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109186080215313510)
,p_name=>'APEXAPP.DA.CREATE_BUTTON.DIALOG_CLOSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6309\9215 - \5C0D\8A71\65B9\584A\5DF2\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109186111809313510)
,p_name=>'APEXAPP.DA.EDIT_REPORT.DIALOG_CLOSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\5831\8868 - \5C0D\8A71\65B9\584A\5DF2\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109186247347313510)
,p_name=>'APEXAPP.DA.PERFORM_SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109186351453313510)
,p_name=>'APEXAPP.DA.REFRESH_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6574\7406\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109175543156313502)
,p_name=>'APEXAPP.DATA_LOAD.CHAR_SET_ITEM_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\5B57\5143\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109175134790313502)
,p_name=>'APEXAPP.ITEM.ACL_ROLES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109198760649313519)
,p_name=>'APEXAPP.ITEM.ACL_ROLES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\555F\7528\5B58\53D6\63A7\5236, \7BA1\7406\54E1\5C31\80FD\9650\5236\5DF2\8A8D\8B49\4F7F\7528\8005\5C0D\67D0\4E9B\61C9\7528\7A0B\5F0F\529F\80FD\7684\5B58\53D6. \6B64\61C9\7528\7A0B\5F0F\652F\63F4\4E0B\5217 3 \7A2E\89D2\8272: \95B1\8B80\8005\3001\63D0\4F9B\8005\4EE5\53CA\7BA1\7406\54E1.<p>'),
'<ul>',
unistr('  <li><strong>\95B1\8B80\8005</strong>: \5C0D\6240\6709\8CC7\8A0A\6709\552F\8B80\5B58\53D6\6B0A, \800C\4E14\53EF\4EE5\6AA2\8996\5831\8868.</li>'),
unistr('  <li><strong>\63D0\4F9B\8005</strong>: \53EF\5EFA\7ACB\3001\7DE8\8F2F\53CA\522A\9664\8CC7\8A0A, \4EE5\53CA\6AA2\8996\5831\8868.</li>'),
unistr('  <li><strong>\7BA1\7406\54E1</strong>: \9664\4E86\5177\5099\300C\63D0\4F9B\8005\300D\6B0A\9650\4E4B\5916, \9084\80FD\57F7\884C\61C9\7528\7A0B\5F0F\7D44\614B\8A2D\5B9A.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109198519967313519)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EFB\4F55\5DF2\8A8D\8B49\7684\4F7F\7528\8005\90FD\53EF\4EE5\5B58\53D6\6B64\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109198665686313519)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\5B58\53D6\63A7\5236\6E05\55AE\6703\5B9A\7FA9\6240\6709\4F7F\7528\8005, \8ACB\9078\64C7<strong>\5426</strong>; \5982\679C\6709\4E0D\5728\5B58\53D6\63A7\5236\6E05\55AE\7684\4F7F\7528\8005, \4F46\6703\4F7F\7528\6B64\61C9\7528\7A0B\5F0F\8005, \8ACB\9078\64C7<strong>\662F</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109196890326313518)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\4F7F\7528\7684\65E5\671F/\6578\5B57\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109196980117313518)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\662F\8981\63D0\4F9B\81EA\8A02\683C\5F0F\906E\7F69, \9084\662F\4F7F\7528\6A19\6E96\683C\5F0F\906E\7F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109199371061313520)
,p_name=>'APEXAPP.ITEM.ATTACHMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109198389782313519)
,p_name=>'APEXAPP.ITEM.AUTOMATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109197008770313518)
,p_name=>'APEXAPP.ITEM.CHAR_SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\5B57\5143\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109195805391313517)
,p_name=>'APEXAPP.ITEM.COPY_PASTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\4E26\8CBC\4E0A\5206\9694\7684\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109197154340313518)
,p_name=>'APEXAPP.ITEM.CURRENCY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E63\5225\7B26\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109197235941313518)
,p_name=>'APEXAPP.ITEM.CURRENCY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\60A8\7684\8CC7\6599\5305\542B\570B\969B\5E63\5225\7B26\865F, \8ACB\5728\6B64\8655\8F38\5165\865F. \4F8B\5982, \5982\679C\60A8\7684\8CC7\6599\5305\542B "&euro;1,234.56" \6216 "&yen;1,234.56", \8ACB\8F38\5165 "&euro;" \6216 "&yen;".  \5426\5247, \8CC7\6599\5C07\7121\6CD5\6B63\78BA\8F09\5165.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109195555857313517)
,p_name=>'APEXAPP.ITEM.DATA_LOAD_IMPORT_FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\5165\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109197590501313518)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\6578\9EDE\7B26\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109197641582313518)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5C0F\6578\9EDE\7B26\865F\53EF\5340\9694\6574\6578\548C\6578\5B57\7684\5C0F\6578\90E8\5206.</p>'),
unistr('<p> \4EFB\4F55\5B57\5143\7686\53EF\7576\6210\5C0F\6578\9EDE\7B26\865F. \6307\5B9A\7684\5B57\5143\5FC5\9808\662F\55AE\4F4D\5143\7D44, \800C\4E14\5C0F\6578\9EDE\7B26\865F\5FC5\9808\8207\7FA4\7D44\5340\9694\7B26\865F\4E0D\540C. \5B57\5143\53EF\4EE5\662F\7A7A\683C, \4F46\4E0D\80FD\662F\6578\5B57\5B57\5143\6216\4E0B\5217\4EFB\4E00\5B57\5143:</p>'),
'<ul class="noIndent">',
unistr('<li>\52A0\865F (+)</li>'),
unistr('<li>\9023\5B57\865F (-)</li> '),
unistr('<li>\5C0F\65BC\7B26\865F (<)</li>'),
unistr('<li>\5927\65BC\7B26\865F (>)</li> '),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109174741381313501)
,p_name=>'APEXAPP.ITEM.DISPLAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109199471524313520)
,p_name=>'APEXAPP.ITEM.ENABLE_ATTACHEMENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109196114305313517)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\754C\7B26\865F (\9078\64C7\6027)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109175064382313501)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5206\754C\5B57\5143. \60A8\53EF\4EE5\4F7F\7528\6B64\5B57\5143\4F86\5340\5206\8CC7\6599\503C\7684\958B\59CB\548C\7D50\675F\754C\9650. \5982\679C\60A8\6307\5B9A\5206\754C\5B57\5143,\300C\8CC7\6599\5DE5\4F5C\5BA4\300D\6703\5FFD\7565\8CC7\6599\503C\958B\59CB\548C\7D50\675F\754C\9650\524D\9762\7684\7A7A\767D\5B57\5143. \60A8\4E5F\53EF\4EE5\4F7F\7528\6B64\9078\9805\4F86\542B\62EC\4F7F\7528\6307\5B9A\4E4B\5206\754C\5B57\5143\7684\8CC7\6599\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109199269535313520)
,p_name=>'APEXAPP.ITEM.EXPERIENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D93\9A57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109196592700313518)
,p_name=>'APEXAPP.ITEM.FAILED_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5931\6557\7684\8CC7\6599\5217:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109175216120313502)
,p_name=>'APEXAPP.ITEM.FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109199510305313520)
,p_name=>'APEXAPP.ITEM.FILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\63D0\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109195691978313517)
,p_name=>'APEXAPP.ITEM.FILE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109195772419313517)
,p_name=>'APEXAPP.ITEM.FILE_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\4E0A\50B3\7684\6A94\6848\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109196223839313517)
,p_name=>'APEXAPP.ITEM.FIRST_ROW.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\8CC7\6599\7684\7B2C\4E00\5217\662F\8CC7\6599\6B04\540D\7A31, \8ACB\9078\53D6\6B64\65B9\584A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109197381096313518)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44\5340\9694\7B26\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109197437118313518)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7FA4\7D44\5340\9694\7B26\865F\662F\4E00\500B\5340\9694\6574\6578\7FA4\7D44\7684\5B57\5143, \4F8B\5982\986F\793A\5343\4F4D\8207\767E\842C\4F4D.</p>'),
unistr('<p>\4EFB\4F55\5B57\5143\7686\53EF\7576\6210\7FA4\7D44\5340\9694\7B26\865F. \6307\5B9A\7684\5B57\5143\5FC5\9808\662F\55AE\4F4D\5143\7D44, \800C\4E14\7FA4\7D44\5340\9694\7B26\865F\5FC5\9808\8207\5176\4ED6\5C0F\6578\9EDE\7B26\865F\4E0D\540C. \5B57\5143\53EF\4EE5\662F\7A7A\683C, \4F46\4E0D\80FD\662F\6578\5B57\5B57\5143\6216\4E0B\5217\4EFB\4E00\5B57\5143:</p>'),
'<ul class="noIndent">',
unistr('<li>\52A0\865F (+)</li>'),
unistr('<li>\9023\5B57\865F (-)</li> '),
unistr('<li>\5C0F\65BC\7B26\865F (<)</li>'),
unistr('<li>\5927\65BC\7B26\865F (>)</li> '),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109196335371313518)
,p_name=>'APEXAPP.ITEM.INSERTED_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D2\5165\7684\8CC7\6599\5217:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109175375223313502)
,p_name=>'APEXAPP.ITEM.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109174960525313501)
,p_name=>'APEXAPP.ITEM.PASSWORD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109199692585313520)
,p_name=>'APEXAPP.ITEM.RATING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A55\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109195303290313517)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A18\4F4F\4F7F\7528\8005\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109195497418313517)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\5982\679C\60A8\9078\53D6\6B64\6838\53D6\65B9\584A, \61C9\7528\7A0B\5F0F\5C07\6703\5728\540D\70BA "LOGIN_USERNAME_COOKIE" \7684\6C38\4E45\700F\89BD\5668 Cookie \5132\5B58\60A8\7684\4F7F\7528\8005\540D\7A31.'),
unistr('\7576\60A8\4E0B\6B21\524D\5F80\767B\5165\9801\9762\6642,'),
unistr('\4FBF\6703\4EE5\9019\500B\503C\81EA\52D5\586B\5165\4F7F\7528\8005\540D\7A31\6B04\4F4D.'),
'</p>',
'<p>',
unistr('\5982\679C\60A8\53D6\6D88\9078\53D6\6B64\6838\53D6\65B9\584A, \4E26\4E14\5DF2\7D93\5728 Cookie \4E2D\5132\5B58\60A8\7684\4F7F\7528\8005\540D\7A31,'),
unistr('\5247\61C9\7528\7A0B\5F0F\5C07\6703\4EE5\7A7A\767D\503C\8986\5BEB\6B64 Cookie.'),
unistr('\60A8\4E5F\53EF\4EE5\4F7F\7528\700F\89BD\5668\7684\958B\767C\4EBA\54E1\5DE5\5177, \5B8C\5168\79FB\9664\6B64 Cookie.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109199750017313520)
,p_name=>'APEXAPP.ITEM.RESPONSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56DE\61C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109196620689313518)
,p_name=>'APEXAPP.ITEM.REVIEW_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\8981\8B93\8CC7\6599\5217\8907\67E5:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109174577966313501)
,p_name=>'APEXAPP.ITEM.SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109174620752313501)
,p_name=>'APEXAPP.ITEM.SEARCH.PLACEHOLDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109195965563313517)
,p_name=>'APEXAPP.ITEM.SEPARATOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\9694\7B26\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109196036317313517)
,p_name=>'APEXAPP.ITEM.SEPARATOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8CC7\6599\6B04\5340\9694\7B26\865F\5B57\5143. \8ACB\4F7F\7528 <code>\005Ct</code> \4F5C\70BA Tab \5340\9694\7B26\865F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109196731942313518)
,p_name=>'APEXAPP.ITEM.SHOW_ADVANCED_SETTINGS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\8CC7\6599\8F09\5165\7684\9032\968E\8A2D\5B9A\503C: \8CA8\5E63\7B26\865F\3001\5C0F\6578\9EDE\7B26\865F\3001\6A94\6848\7DE8\78BC\6216\65E5\671F\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109198404934313519)
,p_name=>'APEXAPP.ITEM.STARTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109175449167313502)
,p_name=>'APEXAPP.ITEM.STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109198013928313519)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\4E3B\984C\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109198171957313519)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52FE\9078\5F8C, \4E00\822C\4F7F\7528\8005\5C31\53EF\4EE5\4F7F\7528\300C\81EA\8A02\300D\9023\7D50, \9078\64C7\6240\9700\7684\4E3B\984C\6A23\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109197853361313519)
,p_name=>'APEXAPP.ITEM.THEME_STYLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\684C\9762\4E3B\984C\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109197960163313519)
,p_name=>'APEXAPP.ITEM.THEME_STYLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\4E3B\984C\6A23\5F0F\6703\5957\7528\81F3\6240\6709\4F7F\7528\8005.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109197720829313519)
,p_name=>'APEXAPP.ITEM.TIMEFRAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\9593\7BC4\570D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109196470886313518)
,p_name=>'APEXAPP.ITEM.UPDATED_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\7684\8CC7\6599\5217:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109174850040313501)
,p_name=>'APEXAPP.ITEM.USERNAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109198824406313519)
,p_name=>'APEXAPP.ITEM.USERNAMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109199095759313520)
,p_name=>'APEXAPP.ITEM.USERNAMES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4EE5\9017\865F\3001\5206\865F\6216\7A7A\767D\5B57\5143\5340\9694\7684\4F7F\7528\8005\540D\7A31. \73FE\6709\6216\91CD\8907\7684\4F7F\7528\8005\540D\7A31\5C07\6703\81EA\52D5\5FFD\7565.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109198905129313519)
,p_name=>'APEXAPP.ITEM.USERNAMES.PLACEHOLDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\6B64\8655\8F38\5165\4F7F\7528\8005\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109199122184313520)
,p_name=>'APEXAPP.ITEM.USERNAME_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109199837407313520)
,p_name=>'APEXAPP.ITEM.USER_AGENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4EE3\7406\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109198275077313519)
,p_name=>'APEXAPP.ITEM.VIEW_AS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109177565192313503)
,p_name=>'APEXAPP.LIST.ACCESS_CONTROL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109177427412313503)
,p_name=>'APEXAPP.LIST.ACTIVITY_REPORTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D3B\52D5\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109202140159313522)
,p_name=>'APEXAPP.LIST.APP_ADMINISTRATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109177336778313503)
,p_name=>'APEXAPP.LIST.APP_CONFIGURATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7D44\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109177738260313504)
,p_name=>'APEXAPP.LIST.EMAIL_REPORTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109177653497313503)
,p_name=>'APEXAPP.LIST.FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109202023289313522)
,p_name=>'APEXAPP.LIST.HOME_NAVIGATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5C0E\89BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109177865105313504)
,p_name=>'APEXAPP.LIST.JOB_REPORTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109201906831313522)
,p_name=>'APEXAPP.LIST.NAVIGATION_BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109202258549313522)
,p_name=>'APEXAPP.LIST.NAVIGATION_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\529F\80FD\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109177235736313503)
,p_name=>'APEXAPP.LIST.USER_INTERFACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109202375805313522)
,p_name=>'APEXAPP.LIST_ENTRY.APP_ADMIN.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109178025054313504)
,p_name=>'APEXAPP.LIST_ENTRY.HOME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109178121955313504)
,p_name=>'APEXAPP.LIST_ENTRY.LOGOUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109177952547313504)
,p_name=>'APEXAPP.LIST_ENTRY.STEP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B65\9A5F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109200150442313520)
,p_name=>'APEXAPP.LOV.RPT_MAX_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\9801\7684\5831\8868\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109201694364313521)
,p_name=>'APEXAPP.LOV_ENTRY.ACKNOWLEDGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8A8D\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109201019160313521)
,p_name=>'APEXAPP.LOV_ENTRY.CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\5716\8868\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109201859036313522)
,p_name=>'APEXAPP.LOV_ENTRY.CLOSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109200372462313520)
,p_name=>'APEXAPP.LOV_ENTRY.COPY_PASTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\4E26\8CBC\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109200629935313521)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\61C9\7528\7A0B\5F0F\6A19\6E96\683C\5F0F\906E\7F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109200742085313521)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_CUSTOM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\5DF2\4E0A\50B3\8CC7\6599\6B04\81EA\8A02\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109201132610313521)
,p_name=>'APEXAPP.LOV_ENTRY.EMAIL_ADDRESSES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\5730\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109200803514313521)
,p_name=>'APEXAPP.LOV_ENTRY.END_USER_THEME_SELECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\4E00\822C\4F7F\7528\8005\9078\64C7\4E3B\984C\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109200448150313521)
,p_name=>'APEXAPP.LOV_ENTRY.FIRST_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C\4E00\500B\8CC7\6599\5217\542B\6709\8CC7\6599\6B04\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109201470825313521)
,p_name=>'APEXAPP.LOV_ENTRY.NEGATIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\597D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109201374942313521)
,p_name=>'APEXAPP.LOV_ENTRY.NEUTRAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\666E\901A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109201530806313521)
,p_name=>'APEXAPP.LOV_ENTRY.NO_ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109201753554313521)
,p_name=>'APEXAPP.LOV_ENTRY.OPEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\555F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109201211954313521)
,p_name=>'APEXAPP.LOV_ENTRY.POSITIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\597D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109200992178313521)
,p_name=>'APEXAPP.LOV_ENTRY.REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\5831\8868\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109200533898313521)
,p_name=>'APEXAPP.LOV_ENTRY.SHOW_ADVANCED_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\9032\968E\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109200280467313520)
,p_name=>'APEXAPP.LOV_ENTRY.UPLOAD_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\50B3\4F7F\7528\9017\865F (*.csv) \6216 Tab \5340\9694\7684\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109204261700313523)
,p_name=>'APEXAPP.PAGE.ACTIVITY_DASHBOARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D3B\52D5\5100\8868\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109178781902313504)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\591A\500B\4F7F\7528\8005 - \6B65\9A5F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109178955011313504)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\591A\500B\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109203860960313523)
,p_name=>'APEXAPP.PAGE.ADMIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109203925067313523)
,p_name=>'APEXAPP.PAGE.ADMIN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7BA1\7406\9801\9762\53EF\8B93\61C9\7528\7A0B\5F0F\64C1\6709\8005 (\7BA1\7406\54E1) \8A2D\5B9A\61C9\7528\7A0B\5F0F, \4E26\7DAD\8B77\7528\65BC\6574\500B\61C9\7528\7A0B\5F0F\7684\4E00\822C\8CC7\6599.'),
unistr('\9078\53D6\5176\4E2D\4E00\500B\53EF\7528\8A2D\5B9A\503C\5F8C, \7BA1\7406\54E1\5C31\80FD\8B8A\66F4\61C9\7528\7A0B\5F0F\7684\986F\793A\65B9\5F0F\548C (\6216) \4E00\822C\4F7F\7528\8005\53EF\7528\7684\529F\80FD.</p>'),
unistr('<p>\6B64\9801\9762\50C5\4F9B\7BA1\7406\54E1\5B58\53D6.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109204468633313523)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5316\65E5\8A8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109204597832313524)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\9801\9762\63D0\4F9B\4E92\52D5\5F0F\7684\81EA\52D5\5316\65E5\8A8C\5831\8868.</p>'),
unistr('<p>\8907\67E5\5148\524D\81EA\52D5\5316\57F7\884C\7684\76F8\95DC\8A18\9304\8CC7\8A0A. \6B64\65E5\8A8C\9664\4E86\6240\8655\7406\8CC7\6599\5217\7684\76F8\95DC\8A73\7D30\8CC7\8A0A (\6210\529F\8207\767C\751F\932F\8AA4) \4E4B\5916, \4E5F\5305\542B\958B\59CB\8207\7D50\675F\6642\6233. \5411\4E0B\5C55\958B\81F3\300C\8A0A\606F\300D\5373\53EF\67E5\770B\6240\8655\7406\8CC7\6599\5217\7684\500B\5225\8A0A\606F.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109204174262313523)
,p_name=>'APEXAPP.PAGE.CONFIGURATION_SETTINGS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7D44\614B\8A2D\5B9A\503C\53EF\8B93\60A8\5C07\7279\5B9A\529F\80FD\8A2D\70BA\4E00\822C\8005\53EF\4EE5\4F7F\7528 (\555F\7528) \6216\4E0D\53EF\4F7F\7528 (\505C\7528).</p>'),
unistr('<p>\5982\679C\7279\5B9A\529F\80FD\5C1A\672A\5B8C\5168\6E96\5099\5C31\7DD2\6216\9700\8981\66AB\6642\79FB\9664, \8ACB\6309\4E00\4E0B<strong>\505C\7528</strong>.'),
unistr('\5982\679C\529F\80FD\5DF2\53EF\4F9B\4F7F\7528, \53EA\8981\6309\4E00\4E0B<strong>\555F\7528</strong>\5373\53EF.</p>'),
unistr('<p><em><strong>\6CE8\610F:</strong> \6B64\8655\6240\505A\7684\8B8A\66F4\4E0D\6703\53CD\6620\5728\4E00\822C\4F7F\7528\8005\76EE\524D\57F7\884C\7684\61C9\7528\7A0B\5F0F\4E2D. \4E00\822C\4F7F\7528\8005\767B\51FA\4E26\91CD\65B0\767B\5165\5F8C, \7CFB\7D71\624D\6703\547C\53EB\5DF2\4FEE\6B63\7684\529F\80FD\8A2D\5B9A\503C.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109205564935313524)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\5B58\53D6\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109205609898313524)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\4EFB\4F55\9069\7576\7684\5DF2\8A8D\8B49\4F7F\7528\8005.<br>'),
unistr('\5982\679C\9078\53D6<strong>\5426</strong>, \5247\53EA\6709\6307\5B9A\7684\4F7F\7528\8005\80FD\5920\5B58\53D6\6B64\61C9\7528\7A0B\5F0F, \9019\9EBC\505A\6709\52A9\65BC\63D0\9AD8\61C9\7528\7A0B\5F0F\7684\5B89\5168\6027.'),
unistr('\4E0D\904E, \5047\5982\61C9\7528\7A0B\5F0F\7684\4F7F\7528\8005\6578\91CF\5F88\591A\4E14\96E3\4EE5\7DAD\8B77, \5EFA\8B70\60A8\9078\64C7<strong>\662F</strong>, \4E26\53EA\8F38\5165\61C9\7528\7A0B\5F0F\7BA1\7406\54E1\548C\63D0\4F9B\8005 (\9078\64C7\6027).<br>'),
unistr('\5982\679C\60A8\9078\53D6<strong>\662F</strong>, \9084\5FC5\9808\9078\53D6\8981\5982\4F55\8655\7406\4E0D\5728\4F7F\7528\8005\6E05\55AE\4E2D\7684\4F7F\7528\8005.</p>'),
unistr('<p>\9078\53D6\5FC5\9808\63D0\4F9B\96FB\5B50\90F5\4EF6\5730\5740\6216\4F7F\7528\8005\540D\7A31 (\4EFB\4F55\6587\6578\5B57\503C).<br>'),
unistr('\4E00\822C\4F86\8AAA, \5982\679C\61C9\7528\7A0B\5F0F\63A1\7528 (\6216\5C07\8A2D\70BA\63A1\7528) Oracle Access Manager \6216 SSO \7B49\96C6\4E2D\5F0F\8A8D\8B49\914D\7F6E, \8ACB\52D9\5FC5\5C07\6B64\8A2D\5B9A\8A2D\70BA<strong>\96FB\5B50\90F5\4EF6\5730\5740</strong>.</p>'),
unistr('<p><em><strong>\6CE8\610F:</strong> \6B64\61C9\7528\7A0B\5F0F\652F\63F4\4E0B\5217 3 \7A2E\5B58\53D6\5C64\7D1A: \95B1\8B80\8005\3001\63D0\4F9B\8005\548C\7BA1\7406\54E1.'),
'<ul>',
unistr('  <li><strong>\95B1\8B80\8005</strong>: \5177\5099\6240\6709\8CC7\8A0A\7684\552F\8B80\5B58\53D6, \800C\4E14\53EF\4EE5\6AA2\8996\5831\8868.</li>'),
unistr('  <li><strong>\63D0\4F9B\8005</strong>: \53EF\5EFA\7ACB\3001\7DE8\8F2F\53CA\522A\9664\8CC7\8A0A\53CA\6AA2\8996\5831\8868.</li>'),
unistr('  <li><strong>\7BA1\7406\54E1</strong>: \4E0D\4F46\5177\5099\300C\63D0\4F9B\8005\300D\529F\80FD, \9084\80FD\5B58\53D6\61C9\7528\7A0B\5F0F\7684\300C\7BA1\7406\300D\5340\6BB5\4EE5\57F7\884C\61C9\7528\7A0B\5F0F\7D44\614B.</li>'),
'</ul>',
'</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109205024284313524)
,p_name=>'APEXAPP.PAGE.ERROR_LOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\932F\8AA4\65E5\8A8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109205158945313524)
,p_name=>'APEXAPP.PAGE.ERROR_LOG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9019\500B\9801\9762\63D0\4F9B\6B64\61C9\7528\7A0B\5F0F\8A18\9304\7684\6240\6709\672A\9810\671F\932F\8AA4\7684\4E92\52D5\5F0F\5831\8868.</p>'),
unistr('<p>\6309\4E00\4E0B\8CC7\6599\6B04\6A19\984C\5373\53EF\6392\5E8F\4E26\7BE9\9078\8CC7\6599; \6309\4E00\4E0B<strong>\52D5\4F5C</strong>\6309\9215\53EF\81EA\8A02\986F\793A\7684\8CC7\6599\6B04\53CA\57F7\884C\591A\7A2E\5176\4ED6\9032\968E\529F\80FD. \6309\4E00\4E0B<strong>\91CD\8A2D</strong>\6309\9215\5373\53EF\5C07\4E92\52D5\5F0F\5831\8868\91CD\8A2D\56DE\9810\8A2D\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109205817969313525)
,p_name=>'APEXAPP.PAGE.FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109205960962313525)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109206054545313525)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p><strong>\555F\7528\9644\4EF6</strong> - \5982\679C\555F\7528, \4F7F\7528\8005\5C07\53EF\4E0A\50B3\652F\6301\610F\898B\56DE\994B\7684\9644\4EF6.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109178889698313504)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SUBMITTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9001\51FA\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109178514799313504)
,p_name=>'APEXAPP.PAGE.GLOBAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\57DF\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109178221973313504)
,p_name=>'APEXAPP.PAGE.HOME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109202975229313522)
,p_name=>'APEXAPP.PAGE.HOME.HELP.FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\5728\61C9\7528\7A0B\5F0F\7684\4EFB\4F55\9801\9762\4E2D, \6309\4E00\4E0B\5C0E\89BD\5217\7684\300C\610F\898B\56DE\994B\300D\5716\793A ( <span class="fa fa-comment-o" aria-hidden="true"></span> ), \5373\53EF\7559\4E0B\8981\7D66\61C9\7528\7A0B\5F0F\7BA1\7406\54E1\7684\610F\898B\56DE\994B.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109202749269313522)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIDE_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\9019\662F\61C9\7528\7A0B\5F0F\7684\9996\9801. \60A8\53EF\4EE5\6309\4E00\4E0B\5361\7247\6216\4F7F\7528\9801\9762\5074\908A\7684\5C0E\89BD\529F\80FD\8868, \4F86\5B58\53D6\61C9\7528\7A0B\5F0F\7684\4E0D\540C\9801\9762.</p>')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109203306370313523)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIGNOUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6309\4E00\4E0B\5C0E\89BD\5217\4E0A\7684\540D\7A31\4E0B\62C9\5F0F\6E05\55AE, \5373\53EF\767B\51FA\61C9\7528\7A0B\5F0F.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109203208025313523)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TIMEZONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6309\4E00\4E0B\5C0E\89BD\5217\4E2D\7684\4F7F\7528\8005\529F\80FD\8868 ( <span class="fa fa-user" aria-hidden="true"></span> ), \5373\53EF\66F4\65B0\6642\5340\504F\597D\8A2D\5B9A\53CA\767B\51FA\61C9\7528\7A0B\5F0F.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109202688469313522)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109202893967313522)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TOP_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\9019\662F\61C9\7528\7A0B\5F0F\7684\9996\9801. \60A8\53EF\4EE5\6309\4E00\4E0B\5361\7247\6216\4F7F\7528\9801\9762\9802\7AEF\7684\5C0E\89BD\529F\80FD\8868, \4F86\5B58\53D6\61C9\7528\7A0B\5F0F\7684\4E0D\540C\9801\9762.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109203177347313523)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6309\4E00\4E0B\9801\9762\53F3\4E0A\89D2\5C0E\89BD\5217\4E2D\7684\4F7F\7528\8005\529F\80FD\8868 ( <span class="fa fa-user" aria-hidden="true"></span> ), \5373\53EF\5B58\53D6\4F7F\7528\8005\8A2D\5B9A\6A94\53CA\767B\51FA\61C9\7528\7A0B\5F0F.<br>'),
unistr('\4F9D\5E8F\6309\4E00\4E0B<strong>\6AA2\8996\6211\7684\8A2D\5B9A\6A94</strong>\548C<strong>\66F4\65B0\8A2D\5B9A\6A94</strong>, \5373\53EF\8F38\5165\500B\4EBA\8A73\7D30\8CC7\8A0A\53CA\4E0A\50B3\76F8\7247\6216\5927\982D\8CBC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109203061313313522)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER_TIMEZONE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6309\4E00\4E0B\5C0E\89BD\5217\4E2D\7684\4F7F\7528\8005\529F\80FD\8868 ( <span class="fa fa-user" aria-hidden="true"></span> ), \5373\53EF\5B58\53D6\60A8\7684\4F7F\7528\8005\8A2D\5B9A\6A94\3001\66F4\65B0\6642\5340\504F\597D\8A2D\5B9A\53CA\767B\51FA\61C9\7528\7A0B\5F0F.<br>'),
unistr('\4F9D\5E8F\6309\4E00\4E0B<strong>\6AA2\8996\6211\7684\8A2D\5B9A\6A94</strong>\548C<strong>\66F4\65B0\8A2D\5B9A\6A94</strong>, \5373\53EF\8F38\5165\500B\4EBA\8A73\7D30\8CC7\8A0A\53CA\4E0A\50B3\76F8\7247\6216\5927\982D\8CBC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109203587338313523)
,p_name=>'APEXAPP.PAGE.IG.HELP.EDITABLE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\76F4\63A5\5728\6B64\4E92\52D5\5F0F\65B9\683C\5167\63D2\5165\3001\66F4\65B0\53CA\522A\9664\8CC7\6599.<br>'),
unistr('  \82E5\8981\63D2\5165\65B0\8CC7\6599\5217, \8ACB\6309\4E00\4E0B\300C\65B0\589E\8CC7\6599\5217\300D\6309\9215.<br>'),
unistr('  \5728\5132\5B58\683C\4E2D\6309\5169\4E0B\6216\6309\4E00\4E0B<strong>\7DE8\8F2F</strong>\6309\9215, \5373\53EF\66F4\65B0\8CC7\6599\503C, \65B9\6CD5\8207\5728\8A66\7B97\8868\4E2D\7DE8\8F2F\8CC7\6599\76F8\4F3C.</p>'),
'',
unistr('<p>\4F7F\7528\5831\8868\9802\7AEF\7684\300C\8CC7\6599\5217\52D5\4F5C\300D\529F\80FD\8868 (<span class="fa fa-bars" aria-hidden="true"></span>) \53EF\8907\88FD\3001\522A\9664\3001\91CD\65B0\6574\7406\6216\56DE\5FA9\9078\53D6\7684\8CC7\6599\5217.<br> '),
unistr('  \60A8\4E5F\53EF\4EE5\4F7F\7528\500B\5225\8CC7\6599\5217\7684\300C\8CC7\6599\5217\52D5\4F5C\300D\529F\80FD\8868, \5B58\53D6\55AE\4E00\8CC7\6599\5217\6AA2\8996\6216\65B0\589E\8CC7\6599\5217.</p>'),
'',
unistr('<p>\82E5\8981\5C0B\627E\8CC7\6599, \8ACB\5728\300C\641C\5C0B\300D\5C0D\8A71\65B9\584A\4E2D\8F38\5165\641C\5C0B\8A5E; \4E5F\53EF\4EE5\6309\4E00\4E0B\8CC7\6599\6B04\6A19\984C\4F86\9650\5236\50B3\56DE\7684\8A18\9304.</p>'),
'',
unistr('<p>\82E5\8981\57F7\884C\591A\7A2E\529F\80FD, \53EF\4EE5\6309\4E00\4E0B<strong>\52D5\4F5C</strong>\6309\9215, \5305\62EC\9078\53D6\986F\793A/\96B1\85CF\7684\8CC7\6599\6B04, \8207\5176\986F\793A\9806\5E8F\4EE5\53CA\57F7\884C\591A\7A2E\8CC7\6599\548C\683C\5F0F\529F\80FD.  \60A8\4E5F\53EF\4EE5\4F7F\7528\5716\8868\9078\9805\5B9A\7FA9\8CC7\6599\7684\5176\4ED6\6AA2\8996.</p>'),
'',
unistr('<p>\82E5\8981\5132\5B58\81EA\8A02\9805\76EE, \8ACB\9078\53D6\5831\8868, \6216\8005\6309\4E00\4E0B\300C\4E0B\8F09\300D\4F86\5378\8F09\8CC7\6599.<p>'),
'',
unistr('<p>\5982\9700\5176\4ED6\8CC7\8A0A, \8ACB\6309\4E00\4E0B\300C\52D5\4F5C\300D\529F\80FD\8868\5E95\7AEF\7684\300C\8AAA\660E\300D.</p> '),
'',
unistr('<p>\6309\4E00\4E0B<strong>\91CD\8A2D</strong>\6309\9215\5373\53EF\5C07\4E92\52D5\5F0F\65B9\683C\91CD\8A2D\56DE\9810\8A2D\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109203657866313523)
,p_name=>'APEXAPP.PAGE.IG.HELP.READONLY'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\82E5\8981\5C0B\627E\8CC7\6599, \8ACB\5728\300C\641C\5C0B\300D\5C0D\8A71\65B9\584A\4E2D\8F38\5165\641C\5C0B\8A5E; \60A8\4E5F\53EF\4EE5\6309\4E00\4E0B\8CC7\6599\6B04\6A19\984C\4F86\9650\5236\50B3\56DE\7684\8A18\9304.</p>'),
'',
unistr('<p>\6309\4E00\4E0B<strong>\52D5\4F5C</strong>\6309\9215\53EF\57F7\884C\591A\7A2E\529F\80FD, \5305\62EC\9078\53D6\986F\793A / \96B1\85CF\7684\8CC7\6599\6B04, \53CA\5176\986F\793A\9806\5E8F\8207\57F7\884C\591A\7A2E\8CC7\6599\8207\683C\5F0F\529F\80FD.  \60A8\9084\53EF\4EE5\4F7F\7528\5716\8868\9078\9805\5B9A\7FA9\8CC7\6599\7684\5176\4ED6\6AA2\8996.</p>'),
'',
unistr('<p>\82E5\8981\5132\5B58\81EA\8A02\9805\76EE, \8ACB\9078\53D6\300C\5831\8868\300D; \60A8\4E5F\53EF\4EE5\6309\4E00\4E0B\300C\4E0B\8F09\300D\4F86\5378\8F09\8CC7\6599.<p>'),
'<br>',
unistr('<p>\5982\9700\5176\4ED6\8CC7\8A0A, \8ACB\6309\4E00\4E0B\300C\52D5\4F5C\300D\529F\80FD\8868\5E95\90E8\7684\300C\8AAA\660E\300D.</p>'),
'',
unistr('<p>\6309\4E00\4E0B<strong>\91CD\8A2D</strong>\6309\9215\5373\53EF\5C07\4E92\52D5\5F0F\5831\8868\91CD\8A2D\56DE\9810\8A2D\503C.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109203446076313523)
,p_name=>'APEXAPP.PAGE.IR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\82E5\8981\5C0B\627E\8CC7\6599, \8ACB\5728\300C\641C\5C0B\300D\5C0D\8A71\65B9\584A\4E2D\8F38\5165\641C\5C0B\8A5E; \60A8\4E5F\53EF\4EE5\6309\4E00\4E0B\8CC7\6599\6B04\6A19\984C\4F86\9650\5236\50B3\56DE\7684\8A18\9304.</p>'),
'',
unistr('<p>\6309\4E00\4E0B<strong>\52D5\4F5C</strong>\6309\9215\53EF\57F7\884C\591A\7A2E\529F\80FD, \5305\62EC\9078\53D6\986F\793A / \96B1\85CF\7684\8CC7\6599\6B04\53CA\5176\986F\793A\9806\5E8F\8207\57F7\884C\591A\7A2E\8CC7\6599\8207\683C\5F0F\529F\80FD.  \60A8\9084\53EF\4EE5\4F7F\7528\300C\5716\8868\300D\3001\300C\7FA4\7D44\65B9\5F0F\300D\548C\300C\6A1E\7D10\5206\6790\8868\300D\9078\9805\5B9A\7FA9\8CC7\6599\7684\5176\4ED6\6AA2\8996.</p>'),
'',
unistr('<p>\5982\679C\60A8\60F3\5132\5B58\81EA\8A02\9078\53D6\5831\8868, \8ACB\6309\4E00\4E0B\300C\4E0B\8F09\300D\4EE5\5378\8F09\8CC7\6599. \8ACB\5728\300C\8A02\95B1\300D\4E0B\65B9\8F38\5165\60A8\7684\96FB\5B50\90F5\4EF6\5730\5740\548C\6642\9593\7BC4\570D, \4EE5\4FBF\5B9A\671F\50B3\9001\8CC7\6599\7D66\60A8.<p>'),
'',
unistr('<p>\5982\9700\5176\4ED6\8CC7\8A0A, \8ACB\6309\4E00\4E0B\300C\52D5\4F5C\300D\529F\80FD\8868\5E95\90E8\7684\300C\8AAA\660E\300D.</p>'),
'',
unistr('<p>\6309\4E00\4E0B<strong>\91CD\8A2D</strong>\6309\9215\5373\53EF\5C07\4E92\52D5\5F0F\5831\8868\91CD\8A2D\56DE\9810\8A2D\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109178371793313504)
,p_name=>'APEXAPP.PAGE.LOGIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\5165\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109178470660313504)
,p_name=>'APEXAPP.PAGE.LOGIN.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 - \767B\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109205200114313524)
,p_name=>'APEXAPP.PAGE.LOG_MESSAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\8A8C\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109206145255313525)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109206247625313525)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E00\822C\4F7F\7528\8005\53EF\4EE5\5728\61C9\7528\7A0B\5F0F\7684\4EFB\4F55\4E00\822C\9801\9762\4E2D\8F38\5165\610F\898B\56DE\994B.</p>'),
unistr('<p>\6B64\5831\8868\986F\793A\5DF2\8F38\5165\7684\610F\898B\56DE\994B\3001\7BA1\7406\54E1\8F38\5165\7684\4EFB\4F55\56DE\61C9\548C\610F\898B\56DE\994B\72C0\614B.</p>'),
unistr('<p>\6309\4E00\4E0B\300C\7DE8\8F2F\300D\5716\793A (\9EC3\8272\925B\7B46) \5373\53EF\8F38\5165\56DE\61C9\6216\66F4\65B0\610F\898B\56DE\994B\72C0\614B.</p>'),
unistr('<p><em><strong>\6CE8\610F:</strong> \5982\679C\60A8\5DF2\5B9A\7FA9\610F\898B\56DE\994B\6536\4EF6\8005, \7CFB\7D71\4E5F\6703\5C07\9001\51FA\7684\610F\898B\56DE\994B\900F\904E\96FB\5B50\90F5\4EF6, \50B3\9001\5230\610F\898B\56DE\994B\6536\4EF6\8005\6E05\55AE\4E2D\7684\96FB\5B50\90F5\4EF6\5730\5740.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109205357625313524)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\4F7F\7528\8005\5B58\53D6\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109205447529313524)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9019\500B\9801\9762\986F\793A\61C9\7528\7A0B\5F0F\4F7F\7528\8005\548C\6240\6388\4E88\5B58\53D6\5C64\7D1A\7684\5831\8868.</p>'),
unistr('<p>\6309\4E00\4E0B\8CC7\6599\6B04\6A19\984C, \5373\53EF\6392\5E8F\4E26\7BE9\9078\8CC7\6599; \6309\4E00\4E0B<strong>\52D5\4F5C</strong>\6309\9215, \5373\53EF\81EA\8A02\986F\793A\7684\8CC7\6599\6B04\53CA\57F7\884C\591A\7A2E\5176\4ED6\9032\968E\529F\80FD.<br>'),
unistr('\6309\4E00\4E0B<strong>\91CD\8A2D</strong>\6309\9215, \5373\53EF\5C07\4E92\52D5\5F0F\5831\8868\91CD\8A2D\56DE\9810\8A2D\503C.</p>'),
unistr('<p>\6309\4E00\4E0B\300C\7DE8\8F2F\300D\5716\793A (\9EC3\8272\925B\7B46), \5373\53EF\7DE8\8F2F\4F7F\7528\8005\8A73\7D30\8CC7\8A0A\548C\5B58\53D6\5C64\7D1A\6216\522A\9664\4F7F\7528\8005.</p>'),
unistr('<p>\6309\4E00\4E0B\5831\8868\9802\7AEF\7684<strong>\65B0\589E\4F7F\7528\8005</strong>, \5373\53EF\65B0\589E\4F7F\7528\8005\53CA\5176\5B58\53D6\5C64\7D1A.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109205725137313524)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS_FORM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\6B64\8868\55AE\4E2D\8F38\5165\4F7F\7528\8005\3001\4F7F\7528\8005\96FB\5B50\90F5\4EF6\5730\5740\4E26\8A2D\5B9A\5176\5B58\53D6\5C64\7D1A.'),
unistr('\9019\500B\5728<em>\8A2D\5B9A\5B58\53D6\63A7\5236</em>\5E95\4E0B\5B9A\7FA9\7684\8A2D\5B9A\503C\6703\6C7A\5B9A\4F7F\7528\8005\540D\7A31\5FC5\9808\4F7F\7528\96FB\5B50\90F5\4EF6\5730\5740\6216\4EFB\4F55\6587\6578\5B57\503C.</p>'),
unistr('<p>\6B64\61C9\7528\7A0B\5F0F\652F\63F4\4E0B\5217 3 \500B\5B58\53D6\5C64\7D1A: \95B1\8B80\8005\3001\63D0\4F9B\8005\548C\7BA1\7406\54E1.</p>'),
'<ul>',
unistr('  <li><strong>\95B1\8B80\8005</strong>: \5177\5099\6240\6709\8CC7\8A0A\7684\552F\8B80\5B58\53D6, \800C\4E14\53EF\4EE5\6AA2\8996\5831\8868.</li>'),
unistr('  <li><strong>\63D0\4F9B\8005</strong>: \53EF\5EFA\7ACB\3001\7DE8\8F2F\53CA\522A\9664\8CC7\8A0A\53CA\6AA2\8996\5831\8868.</li>'),
unistr('  <li><strong>\7BA1\7406\54E1</strong>: \4E0D\4F46\5177\5099\300C\63D0\4F9B\8005\300D\529F\80FD, \9084\80FD\5B58\53D6\61C9\7528\7A0B\5F0F\7684\300C\7BA1\7406\300D\5340\6BB5\4EE5\57F7\884C\61C9\7528\7A0B\5F0F\7D44\614B.</li>'),
'</ul>',
unistr('<p>\7DE8\8F2F\73FE\6709\4F7F\7528\8005\6642, \60A8\53EF\4EE5\9396\5B9A\5C0D\65B9\7684\5E33\6236, \907F\514D\4ED6\5011\5B58\53D6\61C9\7528\7A0B\5F0F.</p>'),
unistr('<p><em><strong>\6CE8\610F:</strong>   \5982\679C\4F7F\7528 Oracle Application Express \5E33\6236, \5728\6B64\8655\8F38\5165\7684\4F7F\7528\8005\4E5F\5FC5\9808\7531\5DE5\4F5C\5340\7BA1\7406\54E1\5B9A\7FA9\70BA\4E00\822C\4F7F\7528\8005, \4E14\5DE5\4F5C\5340\7BA1\7406\54E1\4E5F\53EF\4EE5\8A2D\5B9A\4ED6\5011\7684\5BC6\78BC.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109203738354313523)
,p_name=>'APEXAPP.PAGE.MD.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\5831\8868\9801\9762\6703\5728\9801\9762\5074\908A\986F\793A\9078\53D6\5668\4E2D\7684\4E3B\8981\8A18\9304. '),
unistr('  \9078\53D6\4E00\7B46\8A18\9304\5373\53EF\67E5\770B\4E3B\8981\8A18\9304\548C\5B9A\7FA9\7684\6240\6709\660E\7D30\8A18\9304.<br> '),
unistr('  \6309\4E00\4E0B\7DE8\8F2F\5716\793A ( <span class="fa fa-pencil-square-o" aria-hidden="true"></span> ) \5373\53EF\7DE8\8F2F\4E3B\8981\8A18\9304.'),
unistr('  \81F3\65BC\660E\7D30\8A18\9304, \6309\4E00\4E0B\6BCF\500B\8CC7\6599\5217\958B\982D\8655\7684\925B\7B46\5716\793A, \5373\53EF\7DE8\8F2F\8A72\7B46\8A18\9304.</p>'),
unistr('<p>\82E5\8981\9650\5236\9078\53D6\5668\4E2D\986F\793A\7684\8CC7\6599, \8ACB\5728\641C\5C0B\5C0D\8A71\65B9\584A\4E2D\8F38\5165\641C\5C0B\8A5E.</p>'),
'',
unistr('<p>\82E5\8981\65B0\589E\4E3B\8981\8A18\9304, \8ACB\6309\4E00\4E0B\9801\9762\9802\7AEF\7684<strong>\5EFA\7ACB</strong>.'),
unistr('  \81F3\65BC\660E\7D30\8A18\9304, \8ACB\6309\4E00\4E0B\660E\7D30\5340\57DF\9802\7AEF\7684\52A0\865F\5716\793A (+), \5373\53EF\65B0\589E\660E\7D30\8A18\9304.</p>'),
'',
unistr('<p>\6309\4E00\4E0B\9801\9762\9802\7AEF\7684<strong>\91CD\8A2D</strong>\5373\53EF\5C07\9801\9762\91CD\8A2D\56DE\9810\8A2D\503C, \56E0\800C\79FB\9664\5148\524D\5B9A\7FA9\7684\6240\6709\641C\5C0B\8A5E.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109204841288313524)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6548\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109204995856313524)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9019\500B\9801\9762\63D0\4F9B\9801\9762\6548\80FD\548C\4F7F\7528\6B21\6578\7684\4E92\52D5\5F0F\5831\8868. \6B64\5831\8868\662F\4F9D<strong>\52A0\6B0A\6548\80FD</strong> (\4E2D\9593\503C\7D93\6B77\6642\9593\8207\9801\9762\6AA2\8996\6B21\6578\7684\4E58\7A4D) \6392\5E8F.</p>'),
unistr('<p>\8996\9700\8981\9078\53D6\9801\9762\9802\7AEF\7684\5831\8868\6642\9593\7BC4\570D (\9810\8A2D\503C = 1 \5929).<br>'),
unistr('\6309\4E00\4E0B\8CC7\6599\6B04\6A19\984C, \5373\53EF\6392\5E8F\4E26\7BE9\9078\8CC7\6599; \6309\4E00\4E0B<strong>\52D5\4F5C</strong>\6309\9215, \5373\53EF\81EA\8A02\986F\793A\7684\8CC7\6599\6B04\53CA\57F7\884C\591A\7A2E\5176\4ED6\9032\968E\529F\80FD. \6309\4E00\4E0B<strong>\91CD\8A2D</strong>\6309\9215, \5373\53EF\5C07\4E92\52D5\5F0F\5831\8868\91CD\8A2D\56DE\9810\8A2D\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109204649398313524)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109204795209313524)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9019\500B\9801\9762\63D0\4F9B\6700\8FD1\9801\9762\6AA2\8996\72C0\6CC1\7684\4E92\52D5\5F0F\5831\8868.</p>'),
unistr('<p>\8996\9700\8981\9078\53D6\9801\9762\9802\7AEF\7684\5831\8868\6642\9593\7BC4\570D (\9810\8A2D\503C = 1 \5929).<br>'),
unistr('\6309\4E00\4E0B\8CC7\6599\6B04\6A19\984C\5373\53EF\6392\5E8F\4E26\7BE9\9078\8CC7\6599; \6309\4E00\4E0B<strong>\52D5\4F5C</strong>\6309\9215\53EF\81EA\8A02\986F\793A\7684\8CC7\6599\6B04\53CA\57F7\884C\591A\7A2E\5176\4ED6\9032\968E\529F\80FD. \6309\4E00\4E0B<strong>\91CD\8A2D</strong>\6309\9215\5373\53EF\5C07\4E92\52D5\5F0F\5831\8868\91CD\8A2D\56DE\9810\8A2D\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109204043615313523)
,p_name=>'APEXAPP.PAGE.THEME_SELECTOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\7528\65BC\986F\793A\61C9\7528\7A0B\5F0F\7684\9810\8A2D\8272\5F69\914D\7F6E.</p>'),
unistr('<p>\52FE\9078<strong>\5141\8A31\4E00\822C\4F7F\7528\8005\9078\64C7\4E3B\984C\6A23\5F0F</strong>\5F8C, \6BCF\500B\4F7F\7528\8005\53EA\8981\6309\4E00\4E0B\9996\9801\5DE6\4E0B\89D2\7684<em>\81EA\8A02</em>\9023\7D50, \5373\53EF\5F9E\53EF\7528\7684\4E3B\984C\6A23\5F0F\4E2D\9078\53D6\6240\9700\6A23\5F0F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109178679079313504)
,p_name=>'APEXAPP.PAGE.TOP_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5E38\4F7F\7528\7684\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109204386169313523)
,p_name=>'APEXAPP.PAGE.TOP_USERS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\5831\8868\548C\5716\8868\4F86\67E5\770B\6307\5B9A\6642\9593\7BC4\570D\5167\9801\9762\6AA2\8996\6B21\6578\6700\591A\7684\4F7F\7528\8005.</p>'),
unistr('<p>\9078\53D6\9801\9762\9802\7AEF\7684\5831\8868\6642\9593\7BC4\570D (\9810\8A2D\503C = 1 \5929) \4E26\9078\64C7\5831\8868\548C\5716\8868\5716\793A.</p>'),
unistr('<p>\5982\679C\60A8\4F7F\7528\7684\662F\4E92\52D5\5F0F\5831\8868, \8ACB\4F7F\7528\641C\5C0B\6B04\4F4D\6216\9078\53D6<strong>\4F7F\7528\8005</strong>\8CC7\6599\6B04\6A19\984C, \4EE5\9078\53D6\7279\5B9A\4F7F\7528\8005. \60A8\53EA\8981\6309\4E00\4E0B<strong>\52D5\4F5C</strong>\6309\9215, \5373\53EF\57F7\884C\986F\793A / \96B1\85CF\8CC7\6599\6B04\3001\6BCF\9801\8CC7\6599\5217\6578\548C\7BE9\9078\7B49\591A\7A2E\529F\80FD. \6309\4E00\4E0B<strong>\91CD\8A2D</strong>\6309\9215\5373\53EF\5C07\4E92\52D5\5F0F\5831\8868\91CD\8A2D\56DE\9810\8A2D\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109194753872313516)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4F7F\7528\8005\65B0\589E\81F3\5B58\53D6\63A7\5236\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109194851493313516)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\5DF2\65B0\589E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109193028715313515)
,p_name=>'APEXAPP.PROCESS.CLEAR_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664\9801\9762\5FEB\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109176614807313503)
,p_name=>'APEXAPP.PROCESS.CLOSE_DIALOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589\5C0D\8A71\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109194656480313516)
,p_name=>'APEXAPP.PROCESS.CREATE_COLLECTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\96C6\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109176945281313503)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109177025858313503)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B\5DF2\522A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109194500131313516)
,p_name=>'APEXAPP.PROCESS.DML_FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\8868\55AE %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109195239269313517)
,p_name=>'APEXAPP.PROCESS.GET_FILE_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\5F97\6A94\6848 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109194217120313516)
,p_name=>'APEXAPP.PROCESS.GET_LOG_DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\5F97\65E5\8A8C\8A73\7D30\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109193586046313515)
,p_name=>'APEXAPP.PROCESS.GET_NEXT_PREV_PK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\5F97\4E0B\4E00\500B\6216\4E0A\4E00\500B\4E3B\7D22\5F15\9375\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109192964653313515)
,p_name=>'APEXAPP.PROCESS.GET_USERNAME_COOKIE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\5F97\4F7F\7528\8005\540D\7A31 Cookie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109192600616313515)
,p_name=>'APEXAPP.PROCESS.IG_DML'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 - \5132\5B58\4E92\52D5\5F0F\65B9\683C\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109194475744313516)
,p_name=>'APEXAPP.PROCESS.INIT_FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D77\59CB\8868\55AE %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109193462988313515)
,p_name=>'APEXAPP.PROCESS.LEGACY_FORM_DML.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\5DF2\8655\7406.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109176778717313503)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109193626000313515)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\5931\6557')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109176874423313503)
,p_name=>'APEXAPP.PROCESS.REPLY_TO_FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56DE\8986\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109176461400313503)
,p_name=>'APEXAPP.PROCESS.RESET_PAGINATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D\5206\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109192708547313515)
,p_name=>'APEXAPP.PROCESS.RESET_RPT_SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D\5831\8868\641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109176577828313503)
,p_name=>'APEXAPP.PROCESS.SET_ACL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\5B58\53D6\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109194355234313516)
,p_name=>'APEXAPP.PROCESS.SET_ACL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236\8A2D\5B9A\503C\5DF2\5132\5B58.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109194049351313516)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109194130312313516)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\614B\9078\9805\5DF2\66F4\65B0. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109195181966313517)
,p_name=>'APEXAPP.PROCESS.SET_FEEDBACK_OPTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109192891272313515)
,p_name=>'APEXAPP.PROCESS.SET_USERNAME_COOKIE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\4F7F\7528\8005\540D\7A31 Cookie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109194952836313516)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109195012472313517)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9001\51FA\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109193176366313515)
,p_name=>'APEXAPP.PROCESS.TABFORM_DELETE.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664 #MRD_COUNT# \500B\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109193288517313515)
,p_name=>'APEXAPP.PROCESS.TABFORM_PLSQL.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5957\7528\66F4\65B0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109193319765313515)
,p_name=>'APEXAPP.PROCESS.TABFORM_UPDATE_INSERT.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\65B0 #MRU_COUNT# \500B\8CC7\6599\5217, \5DF2\63D2\5165 #MRI_COUNT# \500B\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109193999599313516)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\4E00\822C\4F7F\7528\8005\6A23\5F0F\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109177114885313503)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\5916\89C0\8A2D\5B9A\503C\5DF2\5132\5B58.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109193704037313516)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\4E3B\984C\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109193874373313516)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\5916\89C0\8A2D\5B9A\503C\5DF2\5132\5B58.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109183430847313508)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109183307919313508)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_ACTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109185167107313509)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_CONFIG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236\7D44\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109183519572313508)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_INFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ACL \8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109183118840313508)
,p_name=>'APEXAPP.REGION.ACTIVITY_REPORTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D3B\52D5\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109174130433313501)
,p_name=>'APEXAPP.REGION.ADMIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109182953074313508)
,p_name=>'APEXAPP.REGION.APP_CONFIGURATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7D44\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109184940535313509)
,p_name=>'APEXAPP.REGION.AUTOMATION_EXECUTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5316\57F7\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109173239856313500)
,p_name=>'APEXAPP.REGION.BREADCRUMB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109182056744313507)
,p_name=>'APEXAPP.REGION.BUTTONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109174033199313501)
,p_name=>'APEXAPP.REGION.COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109182800273313508)
,p_name=>'APEXAPP.REGION.CONFIGURATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109183233301313508)
,p_name=>'APEXAPP.REGION.CONFIG_APPEARANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\5916\89C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109173589440313500)
,p_name=>'APEXAPP.REGION.DASHBOARD_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109182486284313507)
,p_name=>'APEXAPP.REGION.DATA_LOAD_FAILED_RECORDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5931\6557\7684\8A18\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109182583366313507)
,p_name=>'APEXAPP.REGION.DATA_LOAD_JUST_CHANGED_RECORDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A18\9304\5DF2\88AB\5176\4ED6\4F7F\7528\8005\8B8A\66F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109182309314313507)
,p_name=>'APEXAPP.REGION.DATA_LOAD_PROGRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\7CBE\9748\9032\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109173892559313501)
,p_name=>'APEXAPP.REGION.DEFAULT.MAX_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\5831\8868\7684\8CC7\6599\5217\6578\76EE\4E0A\9650\70BA %0 \500B\8CC7\6599\5217.  \8ACB\5957\7528\7BE9\9078\4F86\6E1B\5C11\60A8\67E5\8A62\4E2D\7684\8A18\9304\6578\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109173720841313501)
,p_name=>'APEXAPP.REGION.DEFAULT.NO_DATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109183988887313508)
,p_name=>'APEXAPP.REGION.EMAIL_REPORTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109185340319313509)
,p_name=>'APEXAPP.REGION.EXCEPTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7570\5E38\72C0\6CC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109183696397313508)
,p_name=>'APEXAPP.REGION.FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109174471956313501)
,p_name=>'APEXAPP.REGION.FEEDBACK_SUBMITTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9001\51FA\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109184686262313509)
,p_name=>'APEXAPP.REGION.FILTERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109185864161313510)
,p_name=>'APEXAPP.REGION.FORM_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE\9805\76EE\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109173638134313500)
,p_name=>'APEXAPP.REGION.FORM_ON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \76F8\95DC\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109185713314313510)
,p_name=>'APEXAPP.REGION.HIDDEN_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109184176628313508)
,p_name=>'APEXAPP.REGION.HOURLY_PAGE_EVENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\5C0F\6642\7684\9801\9762\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109182230763313507)
,p_name=>'APEXAPP.REGION.INFORMATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109184038582313508)
,p_name=>'APEXAPP.REGION.JOB_REPORTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109183746938313508)
,p_name=>'APEXAPP.REGION.LANGUAGE_SELECTOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00\9078\53D6\5668')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109184467040313509)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\65B0\6D3B\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109184543437313509)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY.NO_DATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\6D3B\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109182664216313507)
,p_name=>'APEXAPP.REGION.MASTER_RECORDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\8A18\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109185008093313509)
,p_name=>'APEXAPP.REGION.MESSAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109184228070313509)
,p_name=>'APEXAPP.REGION.MOST_ACTIVE_PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5E38\4F7F\7528\4E2D\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109173998299313501)
,p_name=>'APEXAPP.REGION.NAVIGATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5C0E\89BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109173434868313500)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9078\53D6\8A18\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109182788218313507)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED.NO_DATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9078\53D6\8A18\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109185531339313510)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\6709\6548\7684\4F7F\7528\8005\5B58\5728 - \9801\9762\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109185665645313510)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST.SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\4EFB\4F55\6709\6548\7684\65B0\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109184363466313509)
,p_name=>'APEXAPP.REGION.RECENT_ERRORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\8FD1\767C\751F\7684\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109173371853313500)
,p_name=>'APEXAPP.REGION.REGION_DISPLAY_SELECTOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\986F\793A\9078\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109174295431313501)
,p_name=>'APEXAPP.REGION.REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109173140177313500)
,p_name=>'APEXAPP.REGION.SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109184729033313509)
,p_name=>'APEXAPP.REGION.TOP_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5E38\4F7F\7528\7684\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109184801044313509)
,p_name=>'APEXAPP.REGION.TOP_USERS_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5E38\4F7F\7528\7684\4F7F\7528\8005\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109174306377313501)
,p_name=>'APEXAPP.REGION.USERS_TO_ADD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\65B0\589E %0 \540D\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109183855661313508)
,p_name=>'APEXAPP.REGION.USER_COUNTS_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\6578\76EE\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109183073584313508)
,p_name=>'APEXAPP.REGION.USER_INTERFACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109185472833313509)
,p_name=>'APEXAPP.REGION.VALID_USERS_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6709\6548\7684\4F7F\7528\8005\5B58\5728 - \9801\9762\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109185223864313509)
,p_name=>'APEXAPP.REGION.WIZARD_CONTAINER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7CBE\9748\5BB9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109182160409313507)
,p_name=>'APEXAPP.REGION.WIZARD_PROGRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7CBE\9748\9032\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109202594270313522)
,p_name=>'APEXAPP.RELEASE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7248\6B21 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109200040614313520)
,p_name=>'APEXAPP.SHORTCUT.GET_NEXT_PREV_PK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78BA\5B9A\8981\96E2\958B\6B64\9801\9762\4E14\4E0D\5132\5B58\55CE?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109180662183313506)
,p_name=>'APEXAPP.SUCCESS_MSG.ROWS_UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\65B0 %0 \500B\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109181874424313507)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81F3\5C11\8981\6709\4E00\9805\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109181931250313507)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\63D0\4F9B\610F\898B\56DE\994B\6216\60A8\7684\7D93\9A57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109181691730313506)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664\672C\8EAB\7684\7BA1\7406\54E1\8EAB\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109181765048313507)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7121\6CD5\79FB\9664\672C\8EAB\7684\7BA1\7406\54E1\89D2\8272.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109181157642313506)
,p_name=>'APEXAPP.VALIDATION.COLUMN.DATE.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#COLUMN_HEADER# \5FC5\9808\662F\6709\6548\7684\65E5\671F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109180943735313506)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NOT_NULL.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165 #COLUMN_HEADER# \503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109181087650313506)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NUMERIC.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#COLUMN_HEADER# \5FC5\9808\662F\6578\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109181228086313506)
,p_name=>'APEXAPP.VALIDATION.COLUMN.TIMESTAMP.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#COLUMN_HEADER# \5FC5\9808\662F\6709\6548\7684\6642\6233\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109179251555313505)
,p_name=>'APEXAPP.VALIDATION.DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5FC5\9808\662F\6709\6548\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109181459662313506)
,p_name=>'APEXAPP.VALIDATION.ITEM.DATE.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \5FC5\9808\662F\6709\6548\7684\65E5\671F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109181315695313506)
,p_name=>'APEXAPP.VALIDATION.ITEM.NOT_NULL.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165 #LABEL# \503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109181549044313506)
,p_name=>'APEXAPP.VALIDATION.ITEM.TIMESTAMP.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \5FC5\9808\662F\6709\6548\7684\6642\6233.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109179098189313504)
,p_name=>'APEXAPP.VALIDATION.NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109179150258313505)
,p_name=>'APEXAPP.VALIDATION.NUMERIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5FC5\9808\662F\6578\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109179382928313505)
,p_name=>'APEXAPP.VALIDATION.TIMESTAMP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5FC5\9808\662F\6709\6548\7684\6642\6233')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110096583714314213)
,p_name=>'APEXDEV.IG.COLUMN_NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\52D5\614B\52D5\4F5C ''#COMPONENT_NAME#'' \6307\5B9A\7684\4E92\52D5\5F0F\65B9\683C\8CC7\6599\6B04 ''%0'' \4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110096708013314213)
,p_name=>'APEXDEV.IG.DML.COMPLEX_VIEW_LOCK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\8CC7\6599\5217\9396\5B9A\6642, \8655\7406\4F5C\696D ''%0'' \767C\751F ''%1. \8655\7406\4F5C\696D\82E5\4F7F\7528 instead-of \89F8\767C\7A0B\5F0F\5C0D\8907\96DC\8996\89C0\8868\767C\51FA SELECT FOR UPDATE \4EE5\9396\5B9A\8CC7\6599\5217, \5C31\53EF\80FD\6703\767C\751F\6B64\932F\8AA4. \8ACB\5C07\8655\7406\4F5C\696D\5C6C\6027\300C\9396\5B9A\8CC7\6599\5217\300D\8A2D\70BA\300C\5426\300D\6216\300CPL/SQL \7A0B\5F0F\78BC\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110096685615314213)
,p_name=>'APEXDEV.IG.DML.VIRTUAL_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C DML \547D\4EE4\6642, \8655\7406\4F5C\696D ''%0'' \767C\751F ''%1''. \8CC7\6599\6B04\82E5\662F\4EE5\805A\7E3D\6216 SQL \8868\793A\5F0F\70BA\57FA\790E, \5C31\53EF\80FD\6703\767C\751F\6B64\932F\8AA4. \8ACB\5C07\8CC7\6599\6B04\5C6C\6027\300C\50C5\4F9B\67E5\8A62\300D\8A2D\70BA\300C\662F\300D, \4EE5\4FBF\4E0D\5728 INSERT \548C UPDATE \6558\8FF0\53E5\4E2D\5305\62EC\6B64\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109718357513313936)
,p_name=>'APEXDEV.IG.MASTER_DETAIL_COLUMN_NOT_POPULATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\660E\7D30\8CC7\6599\6B04 ''%0'' \672A\5305\542B\503C. \8ACB\78BA\5B9A\5728\76F8\5C0D\61C9\7684\4E3B\8981\5340\57DF\8655\7406\4F5C\696D\4E4B\5F8C\57F7\884C\8655\7406\4F5C\696D ''%1''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110078866434314199)
,p_name=>'APEXDEV.IG.NO_MASTER_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\65B9\683C ''%0'' \672A\5B9A\7FA9\4E3B\8981\660E\7D30\95DC\4FC2\6240\9700\7684\4E3B\8981\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109493292515313745)
,p_name=>'APEXDEV.IG.NO_PK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\65B9\683C ''%0'' \672A\5B9A\7FA9\9032\884C\7DE8\8F2F\6216\4E3B\8981\660E\7D30\95DC\4FC2\6240\9700\7684\4E3B\7D22\5F15\9375\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110056276915314183)
,p_name=>'APEXDEV.IG.RELOAD_ON_SUBMIT_EDITABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\70BA\300C\53EF\7DE8\8F2F\4E92\52D5\5F0F\65B9\683C\300D,\300C\9001\51FA\6642\91CD\65B0\8F09\5165\300D\9801\9762\5C6C\6027\5FC5\9808\8A2D\70BA\300C\50C5\5728\6210\529F\6642\8F09\5165\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110027235281314162)
,p_name=>'APEXDEV.PE.CODE_EDITOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A0B\5F0F\78BC\7DE8\8F2F\5668: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110027333740314163)
,p_name=>'APEXDEV.PE.COLLAPSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110027450085314163)
,p_name=>'APEXDEV.PE.COLOR_PICKER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69\9078\64C7\5668: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110027585056314163)
,p_name=>'APEXDEV.PE.EDIT_COMPONENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\5143\4EF6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110027658250314163)
,p_name=>'APEXDEV.PE.ERROR_POSTFIX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr(' (\932F\8AA4)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110027738063314163)
,p_name=>'APEXDEV.PE.EXPAND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C55\958B %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110027193718314162)
,p_name=>'APEXDEV.PE.FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110027896895314163)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\4EFB\4F55\7D50\679C.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110027989579314163)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH_COMMON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\4EFB\4F55\7D50\679C. \8ACB\6309\4E00\4E0B\4E0A\65B9\7684\300C\5168\90E8\986F\793A\300D\6309\9215\4EE5\5617\8A66\641C\5C0B\6240\6709\7279\6027.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110028021635314163)
,p_name=>'APEXDEV.PE.FILTER_PROPERTIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078\7279\6027')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110028174764314163)
,p_name=>'APEXDEV.PE.INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 (\7121\6548)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110028273565314163)
,p_name=>'APEXDEV.PE.LIST_OF_VALUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110028361784314163)
,p_name=>'APEXDEV.PE.NO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5426')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110028499179314163)
,p_name=>'APEXDEV.PE.NO_COMMON_PROPERTIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7684\5143\4EF6\6C92\6709\5171\540C\7279\6027.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110029608155314164)
,p_name=>'APEXDEV.PE.NO_COMPONENTS_SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\672A\9078\53D6\4EFB\4F55\5143\4EF6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110028587044314163)
,p_name=>'APEXDEV.PE.PICK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110028634039314163)
,p_name=>'APEXDEV.PE.PIN_FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56FA\5B9A\7BE9\9078')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110028729058314164)
,p_name=>'APEXDEV.PE.QUICK_PICK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FEB\901F\9078\64C7: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110028827643314164)
,p_name=>'APEXDEV.PE.QUICK_PICK.CLEAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664\9078\64C7\9805\76EE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110028900498314164)
,p_name=>'APEXDEV.PE.REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\8981')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110029050587314164)
,p_name=>'APEXDEV.PE.SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110029110788314164)
,p_name=>'APEXDEV.PE.SELECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \9078\53D6 -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110029290188314164)
,p_name=>'APEXDEV.PE.VALUE_VARIES_POSTFIX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr(' (\503C\4E0D\56FA\5B9A)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110029369511314164)
,p_name=>'APEXDEV.PE.WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110029440246314164)
,p_name=>'APEXDEV.PE.WARNING_POSTFIX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr(' (\8B66\544A)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110029555752314164)
,p_name=>'APEXDEV.PE.YES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110056351627314183)
,p_name=>'APEXDEV.TABFORM.RELOAD_ON_SUBMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\70BA\300C\5217\8868\5316\8868\55AE\300D,\300C\9001\51FA\6642\91CD\65B0\8F09\5165\300D\9801\9762\5C6C\6027\5FC5\9808\8A2D\70BA\300C\4E00\5F8B\6210\7ACB\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109835943316314025)
,p_name=>'APEXIG_MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5305\542B\591A\500B\4E92\52D5\5F0F\65B9\683C, \56E0\6B64\5FC5\9808\6307\5B9A\5340\57DF\975C\614B ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109061174302313416)
,p_name=>'APEXIR_3D'
,p_message_language=>'zh-tw'
,p_message_text=>'3D'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109171696954313499)
,p_name=>'APEXIR_ADD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109653833812313873)
,p_name=>'APEXIR_ADD_SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\8A02\95B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109310606955313608)
,p_name=>'APEXIR_AGGREGATE_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\805A\7E3D\986F\793A\65BC\6BCF\500B\63A7\5236\5206\6BB5\4E4B\5F8C\8207\5831\8868\7D50\5C3E\8655.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109226523370313540)
,p_name=>'APEXIR_AGG_COUNT_DISTINCT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\7570\8A08\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109172093874313499)
,p_name=>'APEXIR_AGG_MODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110054044351314181)
,p_name=>'APEXIR_AREA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109651666357313871)
,p_name=>'APEXIR_BLACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9ED1\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109172307479313499)
,p_name=>'APEXIR_CALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\4E8B\66C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109278272400313583)
,p_name=>'APEXIR_COLUMN_HEADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110086231757314204)
,p_name=>'APEXIR_DAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109206514561313525)
,p_name=>'APEXIR_DELETE_CHECKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\52FE\9078\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109310937395313608)
,p_name=>'APEXIR_DELETE_CONFIRM_JS_DIALOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\57F7\884C\6B64\522A\9664\52D5\4F5C\55CE?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109289950979313592)
,p_name=>'APEXIR_DISABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109061383772313417)
,p_name=>'APEXIR_DISPLAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109039056572313400)
,p_name=>'APEXIR_DONUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\74B0\5708\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108910683604313295)
,p_name=>'APEXIR_DOWNLOAD_DATA_ONLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109061200676313416)
,p_name=>'APEXIR_DO_NOT_AGGREGATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \4E0D\805A\7E3D -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110037270953314170)
,p_name=>'APEXIR_EDIT_ALTERNATIVE_DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\66FF\4EE3\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109289813254313592)
,p_name=>'APEXIR_ENABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109310741277313608)
,p_name=>'APEXIR_FLASHBACK_ERROR_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\57F7\884C\5012\6EAF\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109640918941313863)
,p_name=>'APEXIR_FUNCTION_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\8CC7\6599\6B04 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109651751595313871)
,p_name=>'APEXIR_GRAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7070\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109038818542313400)
,p_name=>'APEXIR_HIGHLIGHT_WHEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\793A\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109586759478313819)
,p_name=>'APEXIR_LABEL_PREFIX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64\524D\7F6E\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109642760229313864)
,p_name=>'APEXIR_MANAGE_SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\6309\4E00\4E0B<a href=''%0''>\6B64\8655</a>\4F86\7BA1\7406\60A8\7684\8A02\95B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109311552517313608)
,p_name=>'APEXIR_MORE_DATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109056940884313413)
,p_name=>'APEXIR_NEW_CATEGORY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \65B0\985E\5225 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109206607544313525)
,p_name=>'APEXIR_NO_AGGREGATION_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5B9A\7FA9\805A\7E3D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109134775091313471)
,p_name=>'APEXIR_NO_COLUMN_INFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\8CC7\6599\6B04\8CC7\8A0A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109206799833313525)
,p_name=>'APEXIR_NO_COMPUTATION_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5B9A\7FA9\904B\7B97.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110086175790314204)
,p_name=>'APEXIR_NO_END_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \6C92\6709\7D50\675F\65E5\671F -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110139895982314263)
,p_name=>'APEXIR_PIVOT_ROW_COLUMN_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\9078\53D6\5176\4ED6\8CC7\6599\5217\8CC7\6599\6B04.  \6B64\8CC7\6599\5217\8CC7\6599\6B04\4E2D\7684 HTML \8868\793A\5F0F\6216\9023\7D50\5305\542B\5B9A\7FA9\70BA\6A1E\7D10\5206\6790\8868\6216\805A\7E3D\8CC7\6599\6B04\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109171771257313499)
,p_name=>'APEXIR_REMOVE_AGGREGATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664\805A\7E3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109540483127313781)
,p_name=>'APEXIR_REPORT_DISPLAY_COLUMN_LIMIT_REACHED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\4E2D\986F\793A\8CC7\6599\6B04\7684\6578\76EE\5DF2\9054\4E0A\9650. \8ACB\6309\4E00\4E0B\300C\52D5\4F5C\300D\529F\80FD\8868\4E0B\7684\300C\9078\53D6\8CC7\6599\6B04\300D, \5C07\5831\8868\986F\793A\8CC7\6599\6B04\6E05\55AE\6700\5C0F\5316.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109145946781313480)
,p_name=>'APEXIR_ROW_ORDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108909965312313295)
,p_name=>'APEXIR_RPT_DISP_COL_EXCEED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\4E2D\986F\793A\8CC7\6599\6B04\7684\6578\76EE\5DF2\9054\4E0A\9650. \8ACB\6309\4E00\4E0B\300C\52D5\4F5C\300D\529F\80FD\8868\4E0B\7684\300C\9078\53D6\8CC7\6599\6B04\300D, \5C07\5831\8868\986F\793A\8CC7\6599\6B04\6E05\55AE\6700\5C0F\5316.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109206462665313525)
,p_name=>'APEXIR_SAVE_AS_DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53E6\5B58\70BA\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109038991329313400)
,p_name=>'APEXIR_SELECT_CATEGORY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \9078\53D6\985E\5225 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109311656985313608)
,p_name=>'APEXIR_SELECT_COLUMNS_FOOTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D93\904E\904B\7B97\7684\8CC7\6599\6B04\524D\9762\6703\52A0\4E0A **.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110086061451314204)
,p_name=>'APEXIR_SELECT_SORT_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('-  \9078\53D6\6392\5E8F\8CC7\6599\6B04 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109311438270313608)
,p_name=>'APEXIR_SELECT_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110085974086314204)
,p_name=>'APEXIR_SORT_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5E8F\8CC7\6599\6B04 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109640895566313863)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING_UNIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\55AE\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109310878202313608)
,p_name=>'APEXIR_UNAUTHORIZED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6388\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109288125681313591)
,p_name=>'APEXIR_UNIQUE_COLUMN_HEADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\8CC7\6599\6B04\6A19\984C\300D\5FC5\9808\662F\552F\4E00\7684.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110086364726314204)
,p_name=>'APEXIR_WEEK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108907278074313293)
,p_name=>'APEX_ADMIN_SERVICES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Application Express \7BA1\7406\670D\52D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110037538191314170)
,p_name=>'APEX_AUTHENTICATION.NOT_CONFIGURED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\66FF\6B64\61C9\7528\7A0B\5F0F\8A2D\5B9A\8A8D\8B49.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109349820369313637)
,p_name=>'APEX_SAMPLE_LOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\5217\8CC7\6599\5EAB\7269\4EF6\5C07%0\81F3\9078\53D6\7684\7DB1\8981\4E2D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109349906110313637)
,p_name=>'APEX_SAMPLE_LOAD_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229%0\4E0B\5217\8CC7\6599\5EAB\7269\4EF6:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109725027260313941)
,p_name=>'APEX_SCROLL_DOWN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5411\4E0B\6372\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109725141847313941)
,p_name=>'APEX_SCROLL_TO_TOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6372\52D5\81F3\9802\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108913396129313297)
,p_name=>'APEX_WIZARD_FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110037161554314170)
,p_name=>'APEX_WS_EDIT_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109504962564313754)
,p_name=>'APEX_WS_INVALID_OBJECTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110090395710314207)
,p_name=>'APEX_WS_NO_PEER_PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\5C0D\7B49\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110040420072314172)
,p_name=>'APEX_WS_SETUP_CREATE_OBJ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\5EFA\7ACB\7684\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110040674910314172)
,p_name=>'APEX_WS_SETUP_DELETE_TABLES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8868\683C\522A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110040819025314172)
,p_name=>'APEX_WS_SETUP_DROP_OBJECTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109659804445313878)
,p_name=>'APEX_WS_SETUP_DROP_TABLES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109659145320313877)
,p_name=>'APEX_WS_SETUP_MSG1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5728 <strong>%0</strong> \7DB1\8981\4E2D\5EFA\7ACB\9019\4E9B\7269\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110040949230314172)
,p_name=>'APEX_WS_SETUP_MSG10'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<strong>%0</strong> \7DB1\8981\4E2D\5DF2\6709\9019\4E9B\7269\4EF6\5B58\5728, \4E14\7531\5176\4ED6\5DE5\4F5C\5340\4F7F\7528. \82E5\7E7C\7E8C\7684\8A71, \6703\540C\6642\5C07 <strong>%0</strong> \64C1\6709\7684\73FE\6709\300CWeb \8A66\7B97\8868\300D\7269\4EF6\8207\6B64\5DE5\4F5C\5340\95DC\806F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110041063669314172)
,p_name=>'APEX_WS_SETUP_MSG11'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\9078\53D6\7528\65BC\9019\4E9B\7269\4EF6\7684\7DB1\8981:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110041121613314172)
,p_name=>'APEX_WS_SETUP_MSG12'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\4F7F\7528\7684\73FE\6709\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110041929562314173)
,p_name=>'APEX_WS_SETUP_MSG13'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4F7F\7528\4E0B\5217\8CC7\8A0A\91CD\8907\4F7F\7528\300CWeb \8A66\7B97\8868\300D\8CC7\6599\5EAB\7269\4EF6.  \8ACB\78BA\8A8D\60A8\7684\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109659270916313878)
,p_name=>'APEX_WS_SETUP_MSG2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\8981\65B0\7DB1\8981\4E2D\5EFA\7ACB\300CWeb \8A66\7B97\8868\300D\7269\4EF6, \8ACB\4F7F\7528<a href=%0>\8981\6C42\8CC7\6599\5EAB\7DB1\8981</a>\7CBE\9748.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109659310332313878)
,p_name=>'APEX_WS_SETUP_MSG3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\300CWeb \8A66\7B97\8868\300D\9700\8981\4E0B\5217\7269\4EF6:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109659485040313878)
,p_name=>'APEX_WS_SETUP_MSG5'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4F7F\7528\4E0B\5217\8CC7\8A0A\5EFA\7ACB Web \8A66\7B97\8868\8CC7\6599\5EAB\7269\4EF6.  \8ACB\78BA\8A8D\60A8\7684\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109659557547313878)
,p_name=>'APEX_WS_SETUP_MSG6'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\5EFA\7ACB\7684\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109659638479313878)
,p_name=>'APEX_WS_SETUP_MSG7'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5373\5C07\79FB\9664\300CWeb \8A66\7B97\8868\300D\8CC7\6599\5EAB\7269\4EF6.  \9019\5C07\6703\522A\9664\300CWeb \8A66\7B97\8868\300D\8CC7\6599\5EAB\7269\4EF6\4EE5\53CA\5305\542B\60A8\5DE5\4F5C\5340\4E2D\300CWeb \8A66\7B97\8868\300D\5143\4EF6\7684\5167\90E8\8CC7\6599.  \8981\7E7C\7E8C\55CE?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109659947150313878)
,p_name=>'APEX_WS_SETUP_MSG8'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\66F4\6B63\4E0B\5217\7121\6548\7684\7269\4EF6, \624D\80FD\6B63\78BA\57F7\884C\300CWeb \8A66\7B97\8868\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110040526667314172)
,p_name=>'APEX_WS_SETUP_MSG9'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5373\5C07\79FB\9664\6B64\5DE5\4F5C\5340\7684\300CWeb \8A66\7B97\8868\300D\5B9A\7FA9. \5C07\4E0D\6703\522A\9664\5176\4ED6\5DE5\4F5C\5340\4E5F\4F7F\7528\7684\300CWeb \8A66\7B97\8868\300D\8CC7\6599\5EAB\7269\4EF6. \5C07\6703\522A\9664\8207\6B64\5DE5\4F5C\5340\95DC\806F\7684\8A18\9304. \8981\7E7C\7E8C\55CE?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109660091047313878)
,p_name=>'APEX_WS_SETUP_OBJECT_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7269\4EF6\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109660138227313879)
,p_name=>'APEX_WS_SETUP_OBJECT_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7269\4EF6\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109659710951313878)
,p_name=>'APEX_WS_SETUP_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110040336209314172)
,p_name=>'APEX_WS_SETUP_USE_EXISTING_OBJ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\4F7F\7528\7684\73FE\6709\7269\4EF6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108962640666313336)
,p_name=>'APPLICACTION_COMPUTATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108962541095313336)
,p_name=>'APPLICACTION_PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109498780583313749)
,p_name=>'APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109559762160313799)
,p_name=>'APPLICATION BUILDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7522\751F\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109414440719313686)
,p_name=>'APPLICATION COMPUTATION CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\904B\7B97\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109417240759313688)
,p_name=>'APPLICATION IMAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109414513587313686)
,p_name=>'APPLICATION PROCESS CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8655\7406\4F5C\696D\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109345584852313634)
,p_name=>'APPLICATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109480016088313736)
,p_name=>'APPLICATIONS_INITCAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109388638926313666)
,p_name=>'APPLICATION_ACTIVITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\6D3B\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109426670757313695)
,p_name=>'APPLICATION_ALIAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109424767279313694)
,p_name=>'APPLICATION_DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108907080910313292)
,p_name=>'APPLICATION_DEVELOPMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\958B\767C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109425649750313694)
,p_name=>'APPLICATION_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109385462308313664)
,p_name=>'APPLICATION_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7DE8\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109285301725313588)
,p_name=>'APPLICATION_ID_RESERVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4FDD\7559\7684\300C\61C9\7528\7A0B\5F0F ID\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109285241276313588)
,p_name=>'APPLICATION_ID_VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\61C9\7528\7A0B\5F0F ID\300D\5FC5\9808\662F\6B63\6574\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109700079712313922)
,p_name=>'APPLICATION_IMAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109454783030313717)
,p_name=>'APPLICATION_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108988564817313357)
,p_name=>'APPLICATION_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108957462326313332)
,p_name=>'APPLICATION_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109426579210313695)
,p_name=>'APPLICATION_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110089926750314207)
,p_name=>'APPLICATION_NAMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109536415658313778)
,p_name=>'APPLICATION_OVERRIDE_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8986\5BEB ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109424254374313693)
,p_name=>'APPLICATION_OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110089844325314207)
,p_name=>'APPLICATION_PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109063934512313418)
,p_name=>'APPLICATION_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109424420950313693)
,p_name=>'APPLICATION_STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109500375593313751)
,p_name=>'APPLICATION_VERSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108922169159313304)
,p_name=>'APPLICATION_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109373035551313654)
,p_name=>'APPROVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6838\51C6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109430804664313698)
,p_name=>'APP_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110092477814314209)
,p_name=>'APP_TEMPLATE_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108955352475313331)
,p_name=>'APP_TYPE_DATABASE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108955472287313331)
,p_name=>'APP_TYPE_PACKAGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\751F\7522\529B\6216\7BC4\4F8B\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109451636205313715)
,p_name=>'APP_TYPE_PACKAGED_WS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B Web \8A66\7B97\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108955215278313331)
,p_name=>'APP_TYPE_WEBSHEET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \8A66\7B97\8868\61C9\7528\7A0B\5F0F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109372551641313654)
,p_name=>'ARCHIVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5B58\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108957712480313333)
,p_name=>'ARCHIVELOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\8A8C\5B58\6A94\529F\80FD: \958B\555F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109208652656313527)
,p_name=>'ARGUMENTS_MUST_HAVE_CHECKSUM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F15\6578\5FC5\9808\8981\6709\7E3D\548C\6AA2\9A57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109296231109313596)
,p_name=>'ARGUMENT_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F15\6578\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109296465353313597)
,p_name=>'ARGUMENT_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F15\6578\985E\578B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109366782007313650)
,p_name=>'ASAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5118\5FEB')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109364078199313648)
,p_name=>'ASSIGNED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6307\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109061518827313417)
,p_name=>'ASSIGNEE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5C0D\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110112194914314242)
,p_name=>'ASSIGN_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109117553091313459)
,p_name=>'ASSOCIATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\95DC\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109063147667313418)
,p_name=>'ASSOCIATED_FEATURES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\95DC\529F\80FD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109393889196313670)
,p_name=>'ATTACHMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9644\4EF6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110119989732314248)
,p_name=>'AT_RISK_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5177\98A8\96AA')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109089016111313437)
,p_name=>'AUTH.CONFIRM_MIGRATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5373\5C07\5C07\6B64\61C9\7528\7A0B\5F0F\7684\81EA\8A02\8A8D\8B49\9078\9805\79FB\8F49\81F3\8A8D\8B49\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109088591871313437)
,p_name=>'AUTH.CURRENT_AUTH_METHOD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8A8D\8B49\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109088929425313437)
,p_name=>'AUTH.CUSTOM_AUTH_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\8A8D\8B49\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109088679039313437)
,p_name=>'AUTH.LOGIN_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\5165\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109088828580313437)
,p_name=>'AUTH.LOGIN_URL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\5165 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109088720389313437)
,p_name=>'AUTH.NONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109094038839313441)
,p_name=>'AUTHENTICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109415427159313687)
,p_name=>'AUTHENTICATION FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109415126894313686)
,p_name=>'AUTHENTICATION SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109109074068313452)
,p_name=>'AUTHENTICATION.CONFIRM_DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5373\5C07\522A\9664\61C9\7528\7A0B\5F0F %0 \7684\67D0\4E00\500B\8A8D\8B49\914D\7F6E. \5982\679C\61C9\7528\7A0B\5F0F\76EE\524D\4E0D\662F\4F7F\7528 SCHEME \8A8D\8B49, \6216\8005\914D\7F6E\4E0D\662F\76EE\524D\7684\8A8D\8B49\914D\7F6E, \5247\522A\9664\914D\7F6E\5C0D\61C9\7528\7A0B\5F0F\4F5C\696D\5C07\7121\5F71\97FF. \5982\679C\61C9\7528\7A0B\5F0F\76EE\524D\4F7F\7528 SCHEME \8A8D\8B49, \4E26\4E14\9019\662F\76EE\524D\7684\8A8D\8B49\914D\7F6E, \90A3\9EBC\61C9\7528\7A0B\5F0F\5C07\6703\7E7C\7E8C\4F7F\7528 SCHEME \8A8D\8B49\57F7\884C, \4F46\662F\6709\4E00\500B\9810\8A2D\8A8D\8B49\914D\7F6E. \9019\5C07\6703\4F7F\7528\4EE5 Open Door \8B49\660E\8CC7\6599\9A57\8B49\7684\5167\5EFA\767B\5165\9801\9762 (\4EA6\5373, \4EFB\4F55\4EBA\90FD\80FD\57F7\884C\61C9\7528\7A0B\5F0F). ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109111043422313454)
,p_name=>'AUTHENTICATION.MAKE_CURRENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E00\4E0B\300C\8B8A\6210\76EE\524D\7684\300D\6309\9215, \8B93\60A8\7684\61C9\7528\7A0B\5F0F\4F7F\7528\6B64\8A8D\8B49\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109587018322313819)
,p_name=>'AUTHENTICATION_NAME.NATIVE_APEX_ACCOUNTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Application Express \5E33\6236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108903699595313290)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CLOUD_IDM'
,p_message_language=>'zh-tw'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109587117280313819)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CUSTOM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109587453702313820)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\8A8D\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109587209785313819)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DB_ACCOUNTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\5E33\6236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109848896913314035)
,p_name=>'AUTHENTICATION_NAME.NATIVE_HTTP_HEADER_VARIABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP \6A19\982D\8B8A\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109587674276313820)
,p_name=>'AUTHENTICATION_NAME.NATIVE_IAS_SSO'
,p_message_language=>'zh-tw'
,p_message_text=>'Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109587366849313820)
,p_name=>'AUTHENTICATION_NAME.NATIVE_LDAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('LDAP \76EE\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109587501117313820)
,p_name=>'AUTHENTICATION_NAME.NATIVE_OPEN_DOOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Open Door \8B49\660E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108881512769313273)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SAML'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SAML \767B\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108932188036313312)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SOCIAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\793E\7FA4\767B\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109455749986313718)
,p_name=>'AUTHENTICATION_SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109415020825313686)
,p_name=>'AUTHORIZATION SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108903774710313290)
,p_name=>'AUTHORIZATION_NAME.NATIVE_CLOUD_IDM'
,p_message_language=>'zh-tw'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108922361403313304)
,p_name=>'AUTHORIZATION_NAME.NATIVE_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Exists SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108922453282313304)
,p_name=>'AUTHORIZATION_NAME.NATIVE_FUNCTION_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\5E03\6797\503C\7684 PL/SQL \51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109277920165313583)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_IN_GROUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\89D2\8272\6216\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109278034045313583)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_NOT_IN_GROUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\4F7F\7528\89D2\8272\6216\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108922523610313304)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_EQUALS_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F 1 \4E2D\7684\9805\76EE\503C\7B49\65BC\8868\793A\5F0F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108922665255313304)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F 1 \4E2D\7684\9805\76EE\4E0D\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108922745254313305)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F 1 \4E2D\7684\9805\76EE\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108922829469313305)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_NOT_EQUALS_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F 1 \4E2D\7684\9805\76EE\503C\4E0D\7B49\65BC\8868\793A\5F0F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108922938645313305)
,p_name=>'AUTHORIZATION_NAME.NATIVE_NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('NOT Exists SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108923011408313305)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_EQUALS_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F 1 \7684\504F\597D\8A2D\5B9A\503C\7B49\65BC\8868\793A\5F0F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108923132310313305)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_NOT_EQUALS_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F 1 \7684\504F\597D\8A2D\5B9A\503C\4E0D\7B49\65BC\8868\793A\5F0F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108974266718313346)
,p_name=>'AUTHZ_CACHE_PER_PAGE_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A55\4F30\6BCF\4E00\500B\9801\9762\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108974305602313346)
,p_name=>'AUTHZ_CACHE_PER_SESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\4E00\500B\968E\6BB5\4F5C\696D\8A55\4F30\4E00\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108926077057313307)
,p_name=>'AUTH_ACCOUNT_EXPIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E33\6236\5931\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108925910449313307)
,p_name=>'AUTH_ACCOUNT_LOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E33\6236\5DF2\9396\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108926395704313307)
,p_name=>'AUTH_ATTEMPTS_EXCEEDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8D85\904E\767B\5165\5617\8A66\6B21\6578\4E0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108926434873313307)
,p_name=>'AUTH_INTERNAL_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\660E\7684\5167\90E8\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108926210585313307)
,p_name=>'AUTH_PASSWORD_FIRST_USE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C\4E00\6B21\4F7F\7528\5BC6\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108926147659313307)
,p_name=>'AUTH_PASSWORD_INCORRECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC\4E0D\6B63\78BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108925763476313307)
,p_name=>'AUTH_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5E38, \9806\5229\8A8D\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108925802752313307)
,p_name=>'AUTH_UNKNOWN_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\660E\7684\4F7F\7528\8005\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109020661226313386)
,p_name=>'AUTH_UNKNOWN_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\660E\7684\5DE5\4F5C\5340\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109030747663313394)
,p_name=>'AUTH_UNKNOWN_WORKSPACE_COLON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\660E\7684\5DE5\4F5C\5340\540D\7A31: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109151784478313484)
,p_name=>'AUTOCOMMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\78BA\8A8D\300D\6558\8FF0\53E5\4E0D\9069\7528, \6703\81EA\52D5\78BA\8A8D\6240\6709\6558\8FF0\53E5.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109849856120314035)
,p_name=>'AUTOMATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109849909075314035)
,p_name=>'AUTOMATION_ACTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5316\52D5\4F5C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109480630630313736)
,p_name=>'AUTOPROVISION_MODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F48\5EFA\6A21\5F0F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108901241511313288)
,p_name=>'AUTO_FIRST_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C\4E00\500B\9805\76EE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109502130701313752)
,p_name=>'AVAILABILITY_INIT_CAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\7528\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108930491646313311)
,p_name=>'AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109637003892313860)
,p_name=>'AVAILABLE_TO_DEVELOPERS_ONLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\6709\958B\767C\4EBA\54E1\53EF\4EE5\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109636988004313860)
,p_name=>'AVAILABLE_WITH_EDIT_LINKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\900F\904E\958B\767C\4EBA\54E1\5DE5\5177\5217\63D0\4F9B\4F7F\7528')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109389433328313667)
,p_name=>'AVERAGE_RENDER_TIME_SECONDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E73\5747\5448\73FE\6642\9593 (\79D2)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109370913093313653)
,p_name=>'BAR_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\689D\5716')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109688769155313908)
,p_name=>'BASIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57FA\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108944397024313321)
,p_name=>'BASIC_DEVELOPER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57FA\672C\958B\767C\4EBA\54E1')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109352379855313639)
,p_name=>'BEFORE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110095244658314212)
,p_name=>'BEFORE LIST ENTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\9805\76EE\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110111208843314241)
,p_name=>'BEFORE_FIRST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C\4E00\500B\4E4B\524D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109418321426313689)
,p_name=>'BIND_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109417736292313688)
,p_name=>'BIND_VARIABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\8B8A\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109417869508313688)
,p_name=>'BIND_VARIABLE_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\8B8A\6578\6A19\7C64')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109432397610313699)
,p_name=>'BLACK_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9ED1\8272\6587\5B57')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108907677602313293)
,p_name=>'BLANK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\767D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109393041238313670)
,p_name=>'BLOB_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('BLOB \8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109538150032313779)
,p_name=>'BLOB_DOWNLOAD_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108956382863313331)
,p_name=>'BLOB_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Blob \683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109538500015313779)
,p_name=>'BLOB_FORMAT_ATTACHMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109538281969313779)
,p_name=>'BLOB_FORMAT_DOWNLOAD'
,p_message_language=>'zh-tw'
,p_message_text=>'DOWNLOAD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109538302470313779)
,p_name=>'BLOB_FORMAT_IMAGE'
,p_message_language=>'zh-tw'
,p_message_text=>'IMAGE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109538496859313779)
,p_name=>'BLOB_FORMAT_INLINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5D4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109394046163313670)
,p_name=>'BLOB_FORMAT_MASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('BLOB \683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109393508091313670)
,p_name=>'BLOB_LAST_UPDATED_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('BLOB \4E0A\6B21\66F4\65B0\6642\9593\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109392954983313670)
,p_name=>'BLOB_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('BLOB \8868\683C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109432245012313699)
,p_name=>'BLUE_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\85CD\8272\6587\5B57')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109409484880313682)
,p_name=>'BRANCH CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\652F\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108978036475313349)
,p_name=>'BRANCHES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\652F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109172565620313500)
,p_name=>'BREADCRUMB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109353084532313639)
,p_name=>'BREADCRUMB LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109353162342313639)
,p_name=>'BREADCRUMB LONG NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\5B8C\6574\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109172604660313500)
,p_name=>'BREADCRUMBS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109441136143313706)
,p_name=>'BREADCRUMB_ENTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109454939668313717)
,p_name=>'BREADCRUMB_ENTRY_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\9805\76EE: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109285635598313589)
,p_name=>'BREADCRUMB_PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109360513797313645)
,p_name=>'BREADCRUMB_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109034619288313397)
,p_name=>'BREADCRUMB_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\5C0E\89BD\8DEF\5F91.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109355663992313641)
,p_name=>'BROWSE_ICON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\5716\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109355436309313641)
,p_name=>'BROWSE_PACKAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\5957\88DD\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109296086699313596)
,p_name=>'BROWSE_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\8868\683C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108887306867313277)
,p_name=>'BU.APPLICATION_ACLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F ACL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108883626360313274)
,p_name=>'BU.APPLICATION_COMPUTATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108931977732313312)
,p_name=>'BU.APPLICATION_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5099\4EFD\61C9\7528\7A0B\5F0F\6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108883746752313275)
,p_name=>'BU.APPLICATION_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108883901864313275)
,p_name=>'BU.APPLICATION_PROCESSES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108931685900313312)
,p_name=>'BU.APPLICATION_RESTORED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F %0 \5DF2\5F9E\4FEE\8A02\7248\672C %1 \56DE\5FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108883579608313274)
,p_name=>'BU.APPLICATION_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109694475927313917)
,p_name=>'BU.APP_PROPS_MODIFIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7279\6027: \5DF2\4FEE\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109437706096313704)
,p_name=>'BU.AUTHENTICATION_SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108884670976313275)
,p_name=>'BU.AUTHENTICATION_SCHEMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108884762236313275)
,p_name=>'BU.AUTHORIZATION_SCHEMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108886397795313277)
,p_name=>'BU.BREADCRUMBS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108886443444313277)
,p_name=>'BU.BREADCRUMB_TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108883827382313275)
,p_name=>'BU.BUILD_OPTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\5EFA\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108886644507313277)
,p_name=>'BU.BUTTON_TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108886513546313277)
,p_name=>'BU.CALENDAR_TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\4E8B\66C6\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109437559944313703)
,p_name=>'BU.COMPONENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109848700075314035)
,p_name=>'BU.COMPONENTS_DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5DF2\522A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109848692882314034)
,p_name=>'BU.COMPONENTS_MODIFIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5DF2\4FEE\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109848535345314034)
,p_name=>'BU.COMPONENTS_NEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA %0 \9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108885055780313276)
,p_name=>'BU.COMPONENT_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108891578975313281)
,p_name=>'BU.CREDENTIALS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B49\660E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108887853931313278)
,p_name=>'BU.DATA_LOADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108895704832313284)
,p_name=>'BU.DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5DF2\522A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108895875904313284)
,p_name=>'BU.DEVELOPERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\767C\4EBA\54E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108885289568313276)
,p_name=>'BU.EMAIL_TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108932023500313312)
,p_name=>'BU.IN_PROGRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5728\5099\4EFD\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108886941448313277)
,p_name=>'BU.LABEL_TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109437913870313704)
,p_name=>'BU.LAST_BACKUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\6B21\5099\4EFD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109437478972313703)
,p_name=>'BU.LAST_UPDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\6B21\66F4\65B0: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108884069013313275)
,p_name=>'BU.LISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108886813962313277)
,p_name=>'BU.LIST_TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108931784585313312)
,p_name=>'BU.LOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9396\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108884309797313275)
,p_name=>'BU.LOVS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108887216783313277)
,p_name=>'BU.LOV_TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('LOV \6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108891463785313280)
,p_name=>'BU.MESSAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108895686037313284)
,p_name=>'BU.MODIFIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5DF2\4FEE\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108884590138313275)
,p_name=>'BU.NAVIGATION_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\529F\80FD\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109437650300313703)
,p_name=>'BU.NEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA %0 \9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108886277639313276)
,p_name=>'BU.PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109848479038314034)
,p_name=>'BU.PAGES_DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5DF2\522A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109848381570314034)
,p_name=>'BU.PAGES_MODIFIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5DF2\4FEE\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109848298985314034)
,p_name=>'BU.PAGES_NEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA %0 \9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108884482451313275)
,p_name=>'BU.PLUGINS'
,p_message_language=>'zh-tw'
,p_message_text=>'Plug-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108886702733313277)
,p_name=>'BU.REGION_TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108891742935313281)
,p_name=>'BU.REMOTE_SERVERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664\4F3A\670D\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108887687743313277)
,p_name=>'BU.REPORT_LAYOUTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\7248\9762\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108887136561313277)
,p_name=>'BU.REPORT_TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109392725720313669)
,p_name=>'BU.RESTORED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56DE\5FA9\7684\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108922062513313304)
,p_name=>'BU.RESTORED_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\5DF2\5F9E\5099\4EFD\4FEE\8A02\7248\672C %0 \56DE\5FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108885749594313276)
,p_name=>'BU.REST_ENABLED_SQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528 REST \7684 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108887540916313277)
,p_name=>'BU.SHARED_QUERIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5171\7528\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108885145604313276)
,p_name=>'BU.SHORTCUTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6377\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108885434082313276)
,p_name=>'BU.STATIC_APPLICATION_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\61C9\7528\7A0B\5F0F\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108885577645313276)
,p_name=>'BU.STATIC_WORKSPACE_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\5DE5\4F5C\5340\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108928952949313310)
,p_name=>'BU.SUMMARY_NOT_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\5F97\8B8A\66F4\6458\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108887093785313277)
,p_name=>'BU.TABS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108885660907313276)
,p_name=>'BU.TEXT_MESSAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108884281279313275)
,p_name=>'BU.THEMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108887452105313277)
,p_name=>'BU.TREES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108931892181313312)
,p_name=>'BU.UNLOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89E3\9664\9396\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108884164131313275)
,p_name=>'BU.USER_INTERFACES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762\5C6C\6027')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108884864355313275)
,p_name=>'BU.WEB_CREDENTIALS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \8B49\660E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108887718742313278)
,p_name=>'BU.WEB_SERVICES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \670D\52D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108891692932313281)
,p_name=>'BU.WEB_SOURCES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \8CC7\6599\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108911575673313296)
,p_name=>'BUFFER CACHE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE9\885D\5340\5FEB\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109367293182313650)
,p_name=>'BUG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109390558613313668)
,p_name=>'BUGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109411920030313684)
,p_name=>'BUGS_ASSIGNED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6307\5B9A\7684\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109449164273313713)
,p_name=>'BUGS_ASSIGNED_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6307\5B9A\7684\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108940176660313318)
,p_name=>'BUGS_CLOSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\89E3\6C7A\7684\932F\8AA4 (%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109717632974313935)
,p_name=>'BUGS_PERCENT_CLOSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\5DF2\8655\7406\767E\5206\6BD4 (%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109449215671313713)
,p_name=>'BUGS_UNASSIGNED_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6307\5B9A\7684\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109449317020313713)
,p_name=>'BUGS_WITHOUT_FIXBY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\4FEE\6B63\5B8C\6210\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109718021923313936)
,p_name=>'BUG_FEEDBACK_DASH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4: %1 \500B\5DF2\8655\7406, \5171 %0 \500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110116567039314246)
,p_name=>'BUG_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109405663208313679)
,p_name=>'BUILD QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108895419330313283)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVA'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108895366252313283)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVASCRIPT'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108895206342313283)
,p_name=>'BUILDER.CODE_LANGUAGE.PLSQL'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108895503315313283)
,p_name=>'BUILDER.CODE_LANGUAGE.PYTHON'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108895106561313283)
,p_name=>'BUILDER.CODE_LANGUAGE.SQL'
,p_message_language=>'zh-tw'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109499706608313750)
,p_name=>'BUILDER.PLUGINS'
,p_message_language=>'zh-tw'
,p_message_text=>'Plug-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109497102399313748)
,p_name=>'BUILDER.UNSUPPORTED_COMPONENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('[\4E0D\652F\63F4]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109696457723313919)
,p_name=>'BUILDER_NOTIFICATION_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109101210181313446)
,p_name=>'BUILD_OPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\5EFA\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109546747918313785)
,p_name=>'BUILD_OPTION_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\5EFA\9078\9805: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110115201025314245)
,p_name=>'BUILD_STATUS_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\5EFA\72C0\614B: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109547518656313786)
,p_name=>'BUILD_VERSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7F6E\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109443068609313708)
,p_name=>'BUILT_IN_REPORT_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5EFA\7684\5831\8868\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109351640760313638)
,p_name=>'BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109539833066313780)
,p_name=>'BUTTON.ADD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108919708693313302)
,p_name=>'BUTTON.DA.INVALID.BUTTON_ATTR_CONTAIN_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\4E4B\6309\9215\7684\300C\6309\9215\5C6C\6027\300D\4E0D\53EF\5305\542B ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108919678343313302)
,p_name=>'BUTTON.DA.INVALID.NOT_DEFINED_BY_DA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7684\6309\9215\5FC5\9808\662F\4E00\500B\300C\52D5\4F5C\300D\8A2D\70BA\300C\52D5\614B\52D5\4F5C\5B9A\7FA9\300D\7684\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108919879521313302)
,p_name=>'BUTTON.DA.INVALID.TEMPLATE_NO_BUTTON_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7684\6309\9215\4F7F\7528\672A\5305\542B #BUTTON_ID# \66FF\4EE3\5B57\4E32\7684\300C\6309\9215\6A23\677F\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109539664852313780)
,p_name=>'BUTTON.DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108978271687313349)
,p_name=>'BUTTON.INVALID.ACTION.REDIRECT_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108956904049313332)
,p_name=>'BUTTON.INVALID.ACTION.REPORT_QRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\5831\8868\67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108955060557313330)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9664\975E\300C\6309\9215\8981\6C42\4F86\6E90\985E\578B\300D\70BA\300C\4E00\5F8B\662F\7A7A\503C\300D, \5426\5247\5FC5\9808\66FF\6240\6709\300C\6309\9215\8981\6C42\4F86\6E90\985E\578B\300D\6307\5B9A\300C\6309\9215\8981\6C42\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108955756907313331)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\6309\9215\8981\6C42\4F86\6E90\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108978311521313349)
,p_name=>'BUTTON.INVALID.ACTION.URL_TARGET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A URL \76EE\6A19.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108921754306313304)
,p_name=>'BUTTON.INVALID.BUTTON_ATTR_HAS_ID_WHEN_DA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\52D5\4F5C\300D\70BA\300C\52D5\614B\52D5\4F5C\5B9A\7FA9\300D\6642,\300C\6309\9215\5C6C\6027\300D\4E0D\53EF\5305\542B ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108979446364313350)
,p_name=>'BUTTON.INVALID.STYLE.IMAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\5F71\50CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108979525040313350)
,p_name=>'BUTTON.INVALID.STYLE.NO_STYLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\6A23\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108979393021313350)
,p_name=>'BUTTON.INVALID.STYLE.TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108921656996313304)
,p_name=>'BUTTON.INVALID.TEMPLATE_NO_BUTTON_ID_WHEN_DA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\6309\9215\6A23\5F0F\300D\70BA\300C\4EE5\6A23\677F\70BA\57FA\790E\7684\6309\9215\300D\4E14\300C\52D5\4F5C\300D\70BA\300C\52D5\614B\52D5\4F5C\5B9A\7FA9\300D\6642, \6240\9078\7684\300C\6309\9215\6A23\677F\300D\5FC5\9808\5305\542B #BUTTON_ID# \66FF\4EE3\5B57\4E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108909579850313294)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_AFFECTED_ELEMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\522A\9664\6309\9215, \56E0\70BA\6B64\6309\9215\5DF2\5728\300C\52D5\614B\52D5\4F5C\300D\4E2D\88AB\53C3\7167 (\9801\9762: %0, \52D5\614B\52D5\4F5C: ''%1'', \52D5\4F5C: ''%2'', \5C6C\6027:\300C\53D7\5F71\97FF\7684\5143\7D20\300D).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108909449758313294)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_WHEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\522A\9664\6309\9215, \56E0\70BA\6B64\6309\9215\5DF2\5728\300C\52D5\614B\52D5\4F5C\300D\4E2D\88AB\53C3\7167 (\9801\9762: %0, \52D5\614B\52D5\4F5C: ''%1'', \5C6C\6027:\300C\6642\6A5F\300D).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109539769100313780)
,p_name=>'BUTTON.SUBMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109535900952313777)
,p_name=>'BUTTON.TEMPLATE.JAVASCRIPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\7528\65BC "onclick" \5C6C\6027\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109539131740313780)
,p_name=>'BUTTON.TEMPLATE.LINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\7528\65BC "href" \5C6C\6027\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108978164558313349)
,p_name=>'BUTTONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109418773816313689)
,p_name=>'BUTTON_ATTRIBUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110115097249314244)
,p_name=>'BUTTON_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109423074806313692)
,p_name=>'BUTTON_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215\6A23\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108975448603313347)
,p_name=>'BYTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\5143\7D44')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109366866952313650)
,p_name=>'BY_NEXT_PATCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\4E0B\500B\4FEE\6B63\7A0B\5F0F\4FEE\6B63')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109366989767313650)
,p_name=>'BY_NEXT_RELEASE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\4E0B\500B\7248\6B21\4FEE\6B63')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110189617061314304)
,p_name=>'CA.ABOUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\65BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110155941195314277)
,p_name=>'CA.ABOUT.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\65BC\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110155863164314277)
,p_name=>'CA.ABOUT.PAGE.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5167\542B\4E00\500B\95DC\65BC\6B64\61C9\7528\7A0B\5F0F\9801\9762, \5167\5BB9\4E3B\8981\5305\62EC\61C9\7528\7A0B\5F0F\63CF\8FF0\3001\61C9\7528\7A0B\5F0F\7248\672C\4EE5\53CA\9801\6578.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109078888042313430)
,p_name=>'CA.ABOUT.PAGE.HELP.CONTENT.CONTAINER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5BB9\5BB9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110189888848314304)
,p_name=>'CA.ABOUT.THIS.APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\65BC\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110189906070314305)
,p_name=>'CA.ABOUT.THIS.APPLICATION.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\53EF\4EE5\5728\9019\88E1\8F38\5165\95DC\65BC\6B64\61C9\7528\7A0B\5F0F\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110189567795314304)
,p_name=>'CA.ABOUT.THIS.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\65BC\6B64\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110200786198314316)
,p_name=>'CA.ABOUT.THIS.PREVIEW.RELEASE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\65BC\6B64\9810\89BD\767C\884C\7248\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109038729478313400)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664\672C\8EAB\7684\7BA1\7406\54E1\8EAB\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109038636899313400)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7121\6CD5\79FB\9664\672C\8EAB\7684\7BA1\7406\54E1\89D2\8272.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110156220662314277)
,p_name=>'CA.ACCESS.CONTROL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110192134576314306)
,p_name=>'CA.ACCESS.CONTROL.ACTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110181698576314296)
,p_name=>'CA.ACCESS.CONTROL.CONFIGURATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236\7D44\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110154606073314275)
,p_name=>'CA.ACCESS.CONTROL.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\4EE5\89D2\8272\70BA\57FA\790E\7684\4F7F\7528\8005\6388\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110156333311314277)
,p_name=>'CA.ACCESS.CONTROL.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\61C9\7528\7A0B\5F0F\5167\4F75\5165\4EE5\89D2\8272\70BA\57FA\790E\7684\4F7F\7528\8005\8A8D\8B49.'),
unistr('\4F7F\7528\8005\53EF\4EE5\5B9A\7FA9\70BA\7BA1\7406\54E1\3001\63D0\4F9B\8005\6216\95B1\8B80\8005.'),
unistr('\60A8\53EF\4EE5\63A5\8457\5B9A\7FA9\4E0D\540C\89D2\8272\7684\5B58\53D6\6B0A, \4EE5\900F\904E\61C9\7528\7A0B\5F0F\5B58\53D6\4E0D\540C\7684\5143\4EF6, \4F8B\5982\9801\9762\3001\529F\80FD\8868\9805\76EE\3001\5340\57DF\3001\8CC7\6599\6B04\3001\9805\76EE\53CA\6309\9215\7B49\7B49.</p>'),
unistr('<p>\5305\62EC\4E0B\5217\5143\4EF6:'),
'<ul>',
unistr('<li>\5177\6709\5B58\53D6\63A7\5236\529F\80FD\9023\7D50\7684\7BA1\7406\9801\9762\5340\57DF</li>'),
unistr('<li>\7BA1\7406\5B58\53D6\63A7\5236\7684\4F7F\7528\8005\8868\683C</li>'),
unistr('<li>\8A2D\5B9A\5DF2\8A8D\8B49\4F7F\7528\8005\5B58\53D6\5C64\7D1A\7684\7D44\614B\9801\9762</li>'),
unistr('<li>\6307\5B9A\4F7F\7528\8005\540D\7A31\662F\5426\70BA\96FB\5B50\90F5\4EF6\5730\5740\7684\7D44\614B\9801\9762</li>'),
unistr('<li>\5831\544A\8207\7DE8\8F2F\4F7F\7528\8005\5B58\53D6\6B0A\7684\7BA1\7406\4F7F\7528\8005\5B58\53D6\9801\9762</li>'),
unistr('<li>\53EF\65B0\589E\55AE\4E00\4F7F\7528\8005\529F\80FD\7684\65B0\589E\4F7F\7528\8005\9801\9762</li>'),
unistr('<li>\53EF\65B0\589E\591A\500B\4F7F\7528\8005\529F\80FD\7684\65B0\589E\591A\500B\4F7F\7528\8005\9801\9762 (\53EA\9069\7528\65BC\96FB\5B50\90F5\4EF6\4F7F\7528\8005\540D\7A31)</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110180555223314296)
,p_name=>'CA.ACCESS.ROLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110181269598314296)
,p_name=>'CA.ACCESS.ROLE.ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\89D2\8272 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109010348294313379)
,p_name=>'CA.ACCESS.ROLES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110180632884314296)
,p_name=>'CA.ACCOUNT.LOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E33\6236\5DF2\9396\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109038228414313399)
,p_name=>'CA.ACKNOWLEDGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8A8D\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110191998850314306)
,p_name=>'CA.ACL.INFORMATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ACL \8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110192669883314307)
,p_name=>'CA.ACL.NOT.ADMIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4E0D\662F\7BA1\7406\54E1, \56E0\6B64\6B0A\9650\4E0D\8DB3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110192776490314307)
,p_name=>'CA.ACL.NOT.AUTHORIZED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5C1A\672A\53D6\5F97\5B58\53D6\6B0A\6216\60A8\7684\5E33\6236\88AB\9396\5B9A, \56E0\6B64\7121\6B0A\6AA2\8996\6B64\61C9\7528\7A0B\5F0F. \8ACB\6D3D\8A62\61C9\7528\7A0B\5F0F\7BA1\7406\54E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110192834753314307)
,p_name=>'CA.ACL.NOT.CONTRIBUTOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4E0D\662F\63D0\4F9B\8005, \6B0A\9650\4E0D\8DB3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110182341421314297)
,p_name=>'CA.ACL.SAVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236\8A2D\5B9A\503C\5DF2\5132\5B58.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110187018118314302)
,p_name=>'CA.ACTION.BUTTON.HTML'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\6309\9215 HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110185976571314302)
,p_name=>'CA.ACTION.LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110186020899314302)
,p_name=>'CA.ACTION.LINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110188666318314304)
,p_name=>'CA.ACTION.LINK.HTML'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\9023\7D50 HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110174134477314291)
,p_name=>'CA.ACTION.PROCESSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\5DF2\8655\7406.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110179670454314295)
,p_name=>'CA.ACTIVITY.BY.HOUR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F9D\5C0F\6642\5340\5206\7684\6D3B\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110212819987314325)
,p_name=>'CA.ACTIVITY.DASHBOARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D3B\52D5\5100\8868\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110156448364314277)
,p_name=>'CA.ACTIVITY.REPORTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D3B\52D5\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110155638932314277)
,p_name=>'CA.ACTIVITY.REPORTING.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\62EC\4F7F\7528\8005\6D3B\52D5\548C\932F\8AA4\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110156528959314277)
,p_name=>'CA.ACTIVITY.REPORTING.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5167\542B\4E00\822C\4F7F\7528\8005\61C9\7528\7A0B\5F0F\6D3B\52D5\7684\6578\500B\5831\8868. \53EF\4F9B\5224\65B7\6700\6D3B\8E8D\7684\4F7F\7528\8005\3001\6700\5E38\4F7F\7528\7684\9801\9762\3001\9801\9762\6548\80FD\4EE5\53CA\767C\751F\7684\932F\8AA4, \8B93\60A8\66F4\52A0\77AD\89E3\61C9\7528\7A0B\5F0F\7684\4F7F\7528\72C0\6CC1\53CA\9700\8981\6539\5584\7684\5340\57DF.</p>'),
unistr('<p>\5305\62EC\4E0B\5217\5831\8868:'),
'<ul>',
unistr('<li>\6700\5E38\4F7F\7528\7684\4F7F\7528\8005\5831\8868</li>'),
unistr('<li>\61C9\7528\7A0B\5F0F\932F\8AA4\65E5\8A8C\5831\8868</li>'),
unistr('<li>\9801\9762\6548\80FD (\4F9D\9801\9762\5340\5206\7684\6D3B\52D5\548C\6548\80FD)</li>'),
unistr('<li>\4F9D\9801\9762\5340\5206\7684\61C9\7528\7A0B\5F0F\6D3B\52D5\5831\8868</li>'),
unistr('<li>\9801\9762\6AA2\8996\660E\7D30\5831\8868</li>'),
'',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109402646534313677)
,p_name=>'CA.ACTUAL.START.DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BE6\969B\958B\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110191895231314306)
,p_name=>'CA.ADD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110187212803314303)
,p_name=>'CA.ADD.EMAIL.TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\96FB\5B50\90F5\4EF6\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110203727706314318)
,p_name=>'CA.ADD.MULTI.USERS.STEP.2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\591A\500B\4F7F\7528\8005 - \6B65\9A5F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110190140442314305)
,p_name=>'CA.ADD.NEW.WIDGET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110173195247314290)
,p_name=>'CA.ADD.NOTIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110078710527314199)
,p_name=>'CA.ADD.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110181397107314296)
,p_name=>'CA.ADD.USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110204147925314319)
,p_name=>'CA.ADD.USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110158077555314279)
,p_name=>'CA.ADDING.PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110158538752314279)
,p_name=>'CA.ADDING.PAGES.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6309\4E00\4E0B<strong>\65B0\589E\9801\9762</strong>\5373\53EF\65B0\589E\61C9\7528\7A0B\5F0F\7684\9801\9762. \7136\5F8C\9078\53D6\4E00\7A2E\9801\9762\985E\578B (\4F8B\5982\7A7A\767D\3001\5716\8868\3001\8868\55AE\3001\5831\8868\7B49) \4E26\5B9A\7FA9\5176\5C6C\6027. \60A8\53EF\80FD\4E5F\9700\8981\6307\5B9A\6709\6548\7684\8868\683C\6216\8996\89C0\8868, \6216\8005\4F7F\7528 SQL \5DE5\4F5C\5BA4\6E96\5099\5DE5\4F5C\5340\7684\8CC7\6599\5EAB\7269\4EF6.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110188025645314303)
,p_name=>'CA.ADDITIONAL.HTML.TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\968E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109401947100313676)
,p_name=>'CA.ADDITIONAL.INFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\984D\5916\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110181032405314296)
,p_name=>'CA.ADDRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5730\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110161262702314281)
,p_name=>'CA.ADMIN.ACCESS.CONTROL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110161841913314282)
,p_name=>'CA.ADMIN.ACCESS.CONTROL.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\70BA\6B64\61C9\7528\7A0B\5F0F\7684\5DF2\8A8D\8B49\4F7F\7528\8005\8A2D\5B9A\5B58\53D6\5C64\7D1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110160311526314280)
,p_name=>'CA.ADMIN.ACTIVITY.REPORTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D3B\52D5\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110161352198314281)
,p_name=>'CA.ADMIN.ADD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110163013163314282)
,p_name=>'CA.ADMIN.ADMINISTRATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110161786785314281)
,p_name=>'CA.ADMIN.ADMINISTRATORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\54E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109435106748313702)
,p_name=>'CA.ADMIN.APP.CONFIGURATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7D44\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109534720264313777)
,p_name=>'CA.ADMIN.APP.USER_INTERFACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110196613254314309)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110196714852314310)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110159900830314280)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\4E3B\984C\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110160001954314280)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\9810\8A2D\61C9\7528\7A0B\5F0F\5916\89C0\8207\611F\89BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110159611163314280)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\614B\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110159544345314280)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\6216\505C\7528\61C9\7528\7A0B\5F0F\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110160653435314281)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\932F\8AA4\65E5\8A8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110160781985314281)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\61C9\7528\7A0B\5F0F\8A18\9304\7684\932F\8AA4\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110160144286314280)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110160214897314280)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\61C9\7528\7A0B\5F0F\540D\7A31\548C\7C21\8981\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110159753462314280)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110159803526314280)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DAD\8B77\61C9\7528\7A0B\5F0F\66F4\65B0\7684\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110159258920314279)
,p_name=>'CA.ADMIN.CONFIGURATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110161689230314281)
,p_name=>'CA.ADMIN.CONTRIBUTORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110211673108314324)
,p_name=>'CA.ADMIN.DASHBOARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5100\8868\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110211508101314324)
,p_name=>'CA.ADMIN.DASHBOARD.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\61C9\7528\7A0B\5F0F\6D3B\52D5\5EA6\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110164712218314284)
,p_name=>'CA.ADMIN.DEFAULT.TZ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\6642\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110164808144314284)
,p_name=>'CA.ADMIN.DEFAULT.TZ.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\6B64\61C9\7528\7A0B\5F0F\7684\9810\8A2D\6642\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110162537118314282)
,p_name=>'CA.ADMIN.EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110164921947314284)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110165003479314284)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\662F\5426\50B3\9001\96FB\5B50\90F5\4EF6\4EE5\53CA\56DE\8986\7684\5C0D\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110162022321314282)
,p_name=>'CA.ADMIN.FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110162396968314282)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110162415741314282)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\662F\5426\5141\8A31\9644\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110162146082314282)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110162281931314282)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7531\61C9\7528\7A0B\5F0F\4F7F\7528\8005\9001\51FA\7684\6240\6709\610F\898B\56DE\994B\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110162661827314282)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110162772867314282)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\6B64\61C9\7528\7A0B\5F0F\4F7F\7528\7684\96FB\5B50\90F5\4EF6\6A23\677F HTML \548C CSS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110159385956314280)
,p_name=>'CA.ADMIN.NOTIFICATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110159478612314280)
,p_name=>'CA.ADMIN.NOTIFICATIONS.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\9996\9801\986F\793A\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110197311321314310)
,p_name=>'CA.ADMIN.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110079420165314199)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5316\65E5\8A8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110079545950314199)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\61C9\7528\7A0B\5F0F\8A18\9304\7684\81EA\52D5\5316\57F7\884C\548C\8A0A\606F\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110160883080314281)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6548\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110160947410314281)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F9D\61C9\7528\7A0B\5F0F\9801\9762\5340\5206\7684\6D3B\52D5\548C\6548\80FD\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110161080388314281)
,p_name=>'CA.ADMIN.PAGE.VIEWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110161166249314281)
,p_name=>'CA.ADMIN.PAGE.VIEWS.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F9D\4F7F\7528\8005\5340\5206\7684\6BCF\500B\9801\9762\6AA2\8996\5831\8868 (\5305\62EC\5B58\53D6\65E5\671F\548C\7D93\6B77\6642\9593)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110161549429314281)
,p_name=>'CA.ADMIN.READERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95B1\8B80\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110204878180314319)
,p_name=>'CA.ADMIN.SEND.EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\9001\96FB\5B50\90F5\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110204977880314319)
,p_name=>'CA.ADMIN.SEND.EMAIL.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\6B64\61C9\7528\7A0B\5F0F\50B3\9001\4EE5\6A23\677F\70BA\57FA\790E\7684\96FB\5B50\90F5\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110160469687314280)
,p_name=>'CA.ADMIN.TOP.USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5E38\4F7F\7528\7684\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110160531141314281)
,p_name=>'CA.ADMIN.TOP.USERS.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4F7F\7528\8005\805A\7E3D\7684\9801\9762\6AA2\8996\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110161414937314281)
,p_name=>'CA.ADMIN.USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110161917336314282)
,p_name=>'CA.ADMIN.USERS.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4\5B58\53D6\63A7\5236\8A2D\5B9A\503C\4E26\505C\7528\5B58\53D6\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110162893301314282)
,p_name=>'CA.ADMIN.VIEW.LOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\65E5\8A8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110162949539314282)
,p_name=>'CA.ADMIN.VIEW.LOG.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\6B64\61C9\7528\7A0B\5F0F\50B3\9001\7684\96FB\5B50\90F5\4EF6\65E5\8A8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109170435912313498)
,p_name=>'CA.ADVANCED'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>\9032\968E</strong> - \5C55\958B\67E5\770B\9032\968E\9078\9805.'),
'    <ul>',
unistr('      <li><strong>\8A2D\70BA\9996\9801</strong> - \5C07\6B64\9801\9762\8A2D\70BA\61C9\7528\7A0B\5F0F\9996\9801.<br>'),
unistr('      &nbsp;&nbsp;&nbsp;\5148\524D\5B9A\7FA9\70BA\9996\9801\7684\4EFB\4F55\9801\9762\5C07\6703\88AB\66F4\65B0.</li>'),
unistr('      <li><strong>\8A2D\70BA\7BA1\7406\9801\9762</strong> - \5C07\6B64\9801\9762\65B0\589E\81F3\300C\7BA1\7406\300D\9801\9762, \800C\4E0D\662F\61C9\7528\7A0B\5F0F\4E2D\7684\4E00\822C\9801\9762. \6309\4E00\4E0B\4E3B\529F\80FD\8868\4E2D\7684\300C\7BA1\7406\300D, \7136\5F8C\5F9E\300C\61C9\7528\7A0B\5F0F\7BA1\7406\300D\6E05\55AE\9078\53D6, \5373\53EF\5B58\53D6\6B64\9801\9762.<br>'),
unistr('        <em><strong>\6CE8\610F:</strong> \9801\9762\4E0D\53EF\540C\6642\70BA\9996\9801\53C8\4F4D\65BC\7BA1\7406\9801\9762\4E4B\4E0B.</em></li>'),
'      &nbsp;<br>',
unistr('      <li><strong>\9801\9762\8AAA\660E</strong> - \8F38\5165\8981\65B0\589E\81F3\9801\9762\8AAA\660E\5167\5BB9\7684\6587\5B57.</li>'),
'    </ul>',
'  </li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109057533062313414)
,p_name=>'CA.ADVANCED.PAGE_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>\9032\968E</strong> - \53EF\5C55\958B\4EE5\67E5\770B\9032\968E\9078\9805.'),
'    <ul>',
unistr('      <li><strong>\9801\9762\8AAA\660E</strong> - \53EF\8F38\5165\8981\65B0\589E\81F3\9801\9762\8AAA\660E\6587\5B57\4E2D\7684\6587\5B57.</li>'),
'    </ul>',
'  </li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110197752323314310)
,p_name=>'CA.ADVANCED.SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\968E\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110197811656314310)
,p_name=>'CA.ADVANCED.SETTINGS.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8A2D\5B9A\5176\4ED6\5B9A\7FA9\3001\5B89\5168\6027\4EE5\53CA\5168\7403\5316\8A2D\5B9A\503C.  \5EFA\7ACB\61C9\7528\7A0B\5F0F\6642\53EF\4EE5\5957\7528\9019\4E9B\8A2D\5B9A\503C, \4E5F\53EF\4EE5\5728\61C9\7528\7A0B\5F0F\5EFA\7ACB\4E4B\5F8C\7DE8\8F2F.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110199779842314312)
,p_name=>'CA.ADVANCED.SETTINGS.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8ACB\95B1\8B80\6BCF\500B\8A2D\5B9A\7684\9805\76EE\8AAA\660E (<span class="fa fa-question-circle" aria-hidden="true"></span>) \4EE5\77AD\89E3\8A73\7D30\8CC7\8A0A.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110205564458314320)
,p_name=>'CA.AFTER.ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110186901155314302)
,p_name=>'CA.AFTER.ROWS.HTML'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\4E4B\5F8C HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110190081520314305)
,p_name=>'CA.ALL.COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110186101766314302)
,p_name=>'CA.ALLOW.OPT.OUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\9078\64C7\9000\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109395583544313672)
,p_name=>'CA.ALLOW.RUNS.IN.RESTRICTED.MODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\4EE5\9650\5236\6A21\5F0F\57F7\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110179597314314295)
,p_name=>'CA.APP.ERROR.LOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\932F\8AA4\65E5\8A8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110175462867314292)
,p_name=>'CA.APP.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109445596321313710)
,p_name=>'CA.APP.SETTING.ACL_ENABLED.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F\5426\958B\555F\5B58\53D6\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109445612698313710)
,p_name=>'CA.APP.SETTING.ACL_SCOPE.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7D66\4E0D\5728\5B58\53D6\63A7\5236\6E05\55AE\4E2D\7684\5DF2\8A8D\8B49\4F7F\7528\8005\7684\9810\8A2D\5B58\53D6\5C64\7D1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110175877883314292)
,p_name=>'CA.APP.SETTINGS.UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8A2D\5B9A\503C\5DF2\66F4\65B0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110175658299314292)
,p_name=>'CA.APP.SUBTITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C21\8981\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110175782363314292)
,p_name=>'CA.APP.SUBTITLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\9019\88E1\8F38\5165\7684\6587\5B57\6703\986F\793A\5728\61C9\7528\7A0B\5F0F\9996\9801\7684\61C9\7528\7A0B\5F0F\540D\7A31\4E0B\65B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110165152937314284)
,p_name=>'CA.APPEARANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\89C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110165265778314284)
,p_name=>'CA.APPEARANCE.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\5B9A\7FA9\61C9\7528\7A0B\5F0F (\542B\5C0E\89BD\6240\5728\4F4D\7F6E) \7684\9810\8A2D\8272\5F69\914D\7F6E (\4E3B\984C\6A23\5F0F) \4EE5\53CA\7528\65BC\61C9\7528\7A0B\5F0F\7684\9810\8A2D\5716\793A.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110184683588314300)
,p_name=>'CA.APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110171717783314289)
,p_name=>'CA.APPLICATION.APPEARANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\5916\89C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110165778901314284)
,p_name=>'CA.APPLICATION.ICON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\5716\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110165855353314285)
,p_name=>'CA.APPLICATION.ICON.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6309\4E00\4E0B<strong>\9078\64C7\65B0\5716\793A</strong>\5373\53EF\9078\53D6\5716\793A\8272\5F69\548C\5176\4E2D\4E00\500B\53EF\7528\7684\5716\793A. \9078\53D6\7684\9805\76EE\6703\986F\793A\5728\61C9\7528\7A0B\5F0F\7684\9996\9801\4E2D.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110166166497314285)
,p_name=>'CA.APPLICATION.ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110166226132314285)
,p_name=>'CA.APPLICATION.ID.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8F38\5165\61C9\7528\7A0B\5F0F\552F\4E00\7684\6578\5B57 ID. \6B64\6B04\4F4D\5305\542B\9810\8A2D\6703\81EA\52D5\7522\751F\7684 ID.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110185208386314301)
,p_name=>'CA.APPLICATION.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110177467684314293)
,p_name=>'CA.APPLICATION.SESSIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\968E\6BB5\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110156090872314277)
,p_name=>'CA.APPLICATION.SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110154987076314276)
,p_name=>'CA.APPLICATION.SETTINGS.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\61C9\7528\7A0B\5F0F\540D\7A31\548C\7C21\8981\63CF\8FF0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110156161669314277)
,p_name=>'CA.APPLICATION.SETTINGS.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5141\8A31\61C9\7528\7A0B\5F0F\7BA1\7406\54E1\66F4\65B0\4E0D\540C\7684\8A2D\5B9A\503C, \4F8B\5982\61C9\7528\7A0B\5F0F\540D\7A31\53CA\63CF\8FF0\3001\9810\8A2D\6642\5340\7B49\7B49.</p>'),
unistr('<p>\5305\62EC\4E0B\5217\5143\4EF6:'),
'<ul>',
unistr('<li>\7BA1\7406\9801\9762\6E05\55AE\9805\76EE\548C\8868\55AE</li>'),
unistr('<li>\8A2D\5B9A\61C9\7528\7A0B\5F0F\540D\7A31</li>'),
unistr('<li>\8A2D\5B9A\9996\9801\4E3B\8996\89BA\5340\5B50\6A19\984C</li>'),
unistr('<li>\4F7F\7528\610F\898B\56DE\994B\6642\8A2D\5B9A\610F\898B\56DE\994B\63A5\6536\8005</li>'),
unistr('<li>\8A2D\5B9A\61C9\7528\7A0B\5F0F\9810\8A2D\6642\5340</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110210613379314323)
,p_name=>'CA.APPLICATIONITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110212436400314325)
,p_name=>'CA.APPLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110214288403314326)
,p_name=>'CA.APPLY.APP.DEFAULTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528\61C9\7528\7A0B\5F0F\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110170991431314288)
,p_name=>'CA.APPLY.CHANGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528\8B8A\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110212211262314325)
,p_name=>'CA.APPLY.FILTERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109532893776313775)
,p_name=>'CA.APP_BANNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5EFA\7ACB\61C9\7528\7A0B\5F0F\7CBE\9748 %0 \5EFA\7ACB\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109534138067313776)
,p_name=>'CA.APP_SETTING.SAVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110216481238314328)
,p_name=>'CA.ATTACHMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109272300671313574)
,p_name=>'CA.ATTACHMENT.COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9644\4EF6\8A08\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110216520769314328)
,p_name=>'CA.ATTACHMENT.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9644\4EF6\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109272232501313574)
,p_name=>'CA.ATTACHMENT.SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9644\4EF6\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110212585735314325)
,p_name=>'CA.ATTR.DEFAULT.DUPLICATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7D93\5B9A\7FA9\9019\500B %0 \7684\5C6C\6027\9810\8A2D\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110181767158314296)
,p_name=>'CA.AUTH.USER.MAY.ACCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EFB\4F55\5DF2\8A8D\8B49\7684\4F7F\7528\8005\90FD\53EF\4EE5\5B58\53D6\6B64\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110166917417314285)
,p_name=>'CA.AUTHENTICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110167008866314285)
,p_name=>'CA.AUTHENTICATION.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\9078\53D6\4F7F\7528\8005\5728\61C9\7528\7A0B\5F0F\4E2D\7684\8A8D\8B49\65B9\5F0F.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109398241296313674)
,p_name=>'CA.AUTO.DROP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\522A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110080130795314200)
,p_name=>'CA.AUTOMATION_EXECUTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5316\57F7\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110178117646314294)
,p_name=>'CA.AVG.ELAPSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E73\5747\7D93\6B77\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109442827207313708)
,p_name=>'CA.BACK.TO.JOBS.REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8FD4\56DE\5DE5\4F5C\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109273028069313575)
,p_name=>'CA.BCC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\4EF6\526F\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110205409919314320)
,p_name=>'CA.BEFORE.ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110186869229314302)
,p_name=>'CA.BEFORE.ROWS.HTML'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\4E4B\524D HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110188391266314303)
,p_name=>'CA.BEGIN.ROW.TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\4E4B\524D\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110163601849314283)
,p_name=>'CA.BLANK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\7A7A\767D\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110163760243314283)
,p_name=>'CA.BLANK.DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5EFA\7ACB\4E00\500B\7A7A\767D\9801\9762\4F5C\70BA\9810\7559\4F4D\7F6E. \5EFA\7ACB\61C9\7528\7A0B\5F0F\4E4B\5F8C, \5C31\53EF\4EE5\5F9E\300C\9801\9762\8A2D\8A08\5DE5\5177\300D\5FEB\901F\5EFA\7ACB\9801\9762\4E0A\7684\5340\57DF.</p>'),
unistr('<p>\8F38\5165\4E0B\5217\5C6C\6027:</p>'),
'<ul>',
unistr('  <li><strong>\9801\9762\540D\7A31</strong> (\5FC5\8981) - \8F38\5165\6B64\9801\9762\7684\540D\7A31.</li>'),
unistr('  <li><strong>\8A2D\5B9A\5716\793A</strong> - \9078\53D6\6B64\9801\9762\5728\5C0E\89BD\529F\80FD\8868\4E2D\7684\986F\793A\5716\793A.</li>'),
unistr('<!--  <li><strong>\5305\62EC\9801\9762\5C0E\89BD</strong> - \52FE\9078\6B64\9078\9805\5373\53EF\4EE5\5361\7247\6E05\55AE\65B9\5F0F\986F\793A\61C9\7528\7A0B\5F0F\4E2D\5B9A\7FA9\7684\6240\6709\5176\4ED6\9801\9762.<br>'),
unistr('      &nbsp;&nbsp;&nbsp;\6B64\9078\9805\4E00\822C\7528\65BC\61C9\7528\7A0B\5F0F\9996\9801.</li>'),
'-->',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110197090748314310)
,p_name=>'CA.BLUEPRINT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\85CD\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110197196268314310)
,p_name=>'CA.BLUEPRINT.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\85CD\5716\6703\4EE5 JSON \683C\5F0F\5217\51FA\61C9\7528\7A0B\5F0F\5B9A\7FA9.</p>'),
unistr('<p>\7B2C\4E00\6B21\9032\5165\6B64\756B\9762\6642, \76EE\524D\7684\61C9\7528\7A0B\5F0F\5B9A\7FA9\6703\8F49\63DB\6210 JSON \6587\4EF6\4E26\986F\793A. \60A8\53EF\4EE5\7DE8\8F2F\6B64\6587\4EF6\4EE5\66F4\65B0\61C9\7528\7A0B\5F0F\7279\6027, \7136\5F8C\6309\4E00\4E0B<strong>\5957\7528\85CD\5716</strong>\4EE5\8B8A\66F4\76EE\524D\7684\61C9\7528\7A0B\5F0F\8A73\7D30\8CC7\8A0A.</p>'),
'<p>&nbsp;</p>',
unistr('<p>\5982\679C\60A8\9700\8981\5EFA\7ACB\5927\91CF\7684\76F8\4F3C\9801\9762, \53EF\4EE5\8907\88FD\4E00\500B\9801\9762\7684\76F8\95DC JSON \7A0B\5F0F\78BC\4E26\9032\884C\591A\6B21\8CBC\4E0A, \7136\5F8C\5C0D JSON \9032\884C\4E9B\8A31\8ABF\6574, \9019\6703\6BD4\91DD\5C0D\6BCF\500B\9801\9762\624B\52D5\4F7F\7528<strong>\65B0\589E\9801\9762</strong>\5FEB\5F97\8A31\591A.</p>'),
unistr('<p>\6309\4E00\4E0B<strong>\8F09\5165\4E0A\4E00\500B\85CD\5716</strong>, \53EF\4F7F\7528\4E4B\524D\7522\751F\4E4B\61C9\7528\7A0B\5F0F\7684\5B9A\7FA9\4F86\53D6\4EE3\85CD\5716. \60A8\53EF\4EE5\5229\7528\6B64\65B9\5F0F, \5728\518D\6B21\7522\751F\61C9\7528\7A0B\5F0F\4E4B\524D\5148\65B0\589E\5176\4ED6\9801\9762\3001\8B8A\66F4\529F\80FD\6216\5FAE\8ABF\8A2D\5B9A\503C, \8F15\9B06\5730\91CD\8907\9032\884C\61C9\7528\7A0B\5F0F\8A2D\8A08.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110185784948314301)
,p_name=>'CA.BODY1.TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672C\65871 \6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110185884341314301)
,p_name=>'CA.BODY2.TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672C\65872 \6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110205807164314320)
,p_name=>'CA.BOTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8C\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110172177099314289)
,p_name=>'CA.BRANCH.TO.ADMIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\9801\9762\7684\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109169036213313497)
,p_name=>'CA.BUTTON.BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110171825730314289)
,p_name=>'CA.BUTTONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110164366134314283)
,p_name=>'CA.CALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\884C\4E8B\66C6\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110164432234314283)
,p_name=>'CA.CALENDAR.DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5EFA\7ACB\4E00\500B\986F\793A\884C\4E8B\66C6\7684\9801\9762.</p>'),
unistr('<p>\8F38\5165\4E0B\5217\5C6C\6027:</p>'),
'<ul>',
unistr('  <li><strong>\9801\9762\540D\7A31</strong> (\5FC5\8981) - \8F38\5165\6B64\9801\9762\7684\540D\7A31.</li>'),
unistr('  <li><strong>\8A2D\5B9A\5716\793A</strong> - \9078\53D6\6B64\9801\9762\5728\5C0E\89BD\529F\80FD\8868\4E2D\7684\986F\793A\5716\793A.</li>'),
unistr('  <li><strong>\8868\683C\6216\8996\89C0\8868</strong> (\5FC5\8981) - \9078\53D6\884C\4E8B\66C6\7684\8CC7\6599\5EAB\7269\4EF6.</li>'),
unistr('  <li><strong>\986F\793A\8CC7\6599\6B04</strong> (\5FC5\8981) - \5F9E\8868\683C\6216\8996\89C0\8868\4E2D\9078\53D6\884C\4E8B\66C6\4E8B\4EF6\4E2D\6240\8981\986F\793A\7684\8CC7\6599\6B04.</li>'),
unistr('  <li><strong>\958B\59CB\65E5\671F\8CC7\6599\6B04</strong> (\5FC5\8981) - \5F9E\8868\683C\6216\8996\89C0\8868\4E2D\9078\53D6\7576\4F5C\884C\4E8B\66C6\4E8B\4EF6\958B\59CB\65E5\671F\7684\65E5\671F\8CC7\6599\6B04.</li>'),
unistr('  <li><strong>\7D50\675F\65E5\671F\8CC7\6599\6B04</strong> - \5F9E\8868\683C\6216\8996\89C0\8868\4E2D\9078\53D6\7576\4F5C\884C\4E8B\66C6\4E8B\4EF6\7D50\675F\65E5\671F\7684\65E5\671F\8CC7\6599\6B04.<br>'),
unistr('      &nbsp;&nbsp;&nbsp;\5982\679C\6307\5B9A\7D50\675F\65E5\671F, \5C07\6703\986F\793A\6301\7E8C\4E00\6BB5\6642\9593\7684\4E8B\4EF6. </li>'),
unistr('  <li><strong>\986F\793A\6642\9593</strong> - \9078\53D6<strong>\662F</strong>\5373\53EF\986F\793A\4E8B\4EF6\7684\6642\9593\90E8\5206, \540C\6642\555F\7528\6BCF\9031\548C\6BCF\65E5\884C\4E8B\66C6\6AA2\8996. \9078\53D6<strong>\5426</strong>\5C31\53EA\6703\986F\793A\4E8B\4EF6\65E5\671F.</li>'),
'  </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110170887738314288)
,p_name=>'CA.CANCEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110172752251314290)
,p_name=>'CA.CANCEL.DIALOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88\5C0D\8A71\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109150085648313483)
,p_name=>'CA.CANCEL.MODAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88\5F37\5236\56DE\61C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110182601709314297)
,p_name=>'CA.CANNOT.REMOVE.ADMIN.RIGHTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7121\6CD5\76F4\63A5\5F9E\81EA\5DF1\7684\8A18\9304\4E2D\79FB\9664\7BA1\7406\6B0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110213438460314325)
,p_name=>'CA.CARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\5361\7247\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110213354593314325)
,p_name=>'CA.CARD.DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5EFA\7ACB\4E00\500B\986F\793A\5361\7247\7684\9801\9762.</p>'),
unistr('<p>\8F38\5165\4E0B\5217\5C6C\6027:</p>'),
'<ul>',
unistr('  <li><strong>\9801\9762\540D\7A31</strong> (\5FC5\8981) - \8F38\5165\6B64\9801\9762\7684\540D\7A31.</li>'),
unistr('  <li><strong>\8A2D\5B9A\5716\793A</strong> - \9078\53D6\6B64\9801\9762\5728\5C0E\89BD\529F\80FD\8868\4E2D\7684\986F\793A\5716\793A.</li>'),
unistr('  <li><strong>\8868\683C\6216\8996\89C0\8868</strong> (\5FC5\8981) - \9078\53D6\5361\7247\7684\8CC7\6599\5EAB\7269\4EF6.</li>'),
unistr('  <li><strong>\5361\7247\6A19\984C</strong> (\5FC5\8981) - \5F9E\8868\683C\6216\8996\89C0\8868\4E2D\9078\53D6\8981\4F5C\70BA\5361\7247\6A19\984C\7684\8CC7\6599\6B04.</li>'),
unistr('  <li><strong>\63CF\8FF0\8CC7\6599\6B04</strong> (\5FC5\8981) - \5F9E\8868\683C\6216\8996\89C0\8868\4E2D\9078\53D6\8981\4F5C\70BA\5361\7247\63CF\8FF0\7684\8CC7\6599\6B04.</li>'),
unistr('  <li><strong>\5176\4ED6\6587\5B57\8CC7\6599\6B04</strong> - \5F9E\8868\683C\6216\8996\89C0\8868\4E2D\9078\53D6\4F5C\70BA\5361\7247\6B21\8981\63CF\8FF0\7684\8CC7\6599\6B04.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110211992109314324)
,p_name=>'CA.CARDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5361\7247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110212038997314324)
,p_name=>'CA.CARDS.VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5361\7247\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109273197581313575)
,p_name=>'CA.CC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\526F\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109533510279313776)
,p_name=>'CA.CHANGE_FILTERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110163499214314283)
,p_name=>'CA.CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\5716\8868\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110163560327314283)
,p_name=>'CA.CHART.DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5EFA\7ACB\4E00\500B\986F\793A\5340\57DF\5716\3001\9577\689D\5716\3001\6298\7DDA\5716\6216\5713\9905\5716\7684\9801\9762.</p>'),
unistr('<p>\8F38\5165\4E0B\5217\5C6C\6027:</p>'),
'<ul>',
unistr('  <li><strong>\9801\9762\540D\7A31</strong> (\5FC5\8981) - \8F38\5165\6B64\9801\9762\7684\540D\7A31.</li>'),
unistr('  <li><strong>\8A2D\5B9A\5716\793A</strong> - \9078\53D6\6B64\9801\9762\5728\5C0E\89BD\529F\80FD\8868\4E2D\7684\986F\793A\5716\793A.</li>'),
unistr('  <li><strong>\5716\8868\985E\578B</strong> - \9078\53D6\8981\986F\793A\7684\5716\8868\985E\578B [<strong>\5340\57DF\5716</strong>\3001<strong>\9577\689D\5716</strong>\3001<strong>\6298\7DDA\5716</strong>\3001<strong>\5713\9905\5716</strong>].</li>'),
unistr('  <li><strong>\8868\683C\6216\8996\89C0\8868</strong> (\5FC5\8981) - \9078\53D6\5716\8868\7684\8CC7\6599\5EAB\7269\4EF6.</li>'),
unistr('  <li><strong>\6A19\7C64\8CC7\6599\6B04</strong> (\5FC5\8981) - \5F9E\8868\683C\6216\8996\89C0\8868\4E2D\9078\53D6\8981\4F5C\70BA\5716\8868\6A19\7C64\7684\8CC7\6599\6B04.</li>'),
unistr('  <li><strong>\503C\805A\7E3D</strong> - \9078\53D6\503C\8CC7\6599\6B04\7684\986F\793A\6216\805A\7E3D\65B9\5F0F<br>'),
unistr('      &nbsp;&nbsp;&nbsp;[\8CC7\6599\6B04\503C\3001\7E3D\548C\3001\8A08\6578].</li>'),
unistr('  <li><strong>\503C\8CC7\6599\6B04</strong> (\5FC5\8981) - \5F9E\8868\683C\6216\8996\89C0\8868\4E2D\9078\53D6\7528\65BC\8A08\7B97\986F\793A\4E4B\5716\8868\503C\7684\6578\503C\8CC7\6599\6B04.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110163879031314283)
,p_name=>'CA.CHART.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<h3>\7BC4\4F8B</h3>'),
unistr('<p>\8907\67E5\7BC4\4F8B\4EE5\77AD\89E3\4F7F\7528\4E0D\540C<strong>\5F59\7E3D</strong>\985E\578B\7684\65B9\5F0F:</p>'),
unistr('<p><strong>\7BC4\4F8B 1:</strong> \91DD\5C0D\6BCF\500B\54E1\5DE5\986F\793A\7BA1\7406\8005\7684\54E1\5DE5\4EBA\6578\7684\300C\54E1\5DE5\300D\5716\8868.'),
'<code><ul>',
unistr('  <li>\8868\683C\6216\8996\89C0\8868 - \9078\53D6 EMP.</li>'),
unistr('  <li>\6A19\7C64\8CC7\6599\6B04 - \9078\53D6 ENAME.</li>'),
unistr('  <li>\5F59\7E3D - \9078\53D6<u><strong>\8CC7\6599\6B04\503C</strong></u>.</li>'),
unistr('  <li>\503C\8CC7\6599\6B04 - \9078\53D6 MGR.</li>'),
'</ul></code>',
'</p>',
unistr('<p><strong>\7BC4\4F8B 2:</strong> \986F\793A\542B\6709\6BCF\500B\5DE5\4F5C\7E3D\85AA\8CC7\7684\300C\54E1\5DE5\300D\5716\8868.'),
'<code><ul>',
unistr('  <li>\8868\683C\6216\8996\89C0\8868 - \9078\53D6 EMP.</li>'),
unistr('  <li>\6A19\7C64\8CC7\6599\6B04 - \9078\53D6 JOB.</li>'),
unistr('  <li>\5F59\7E3D - \9078\53D6<u><strong>\7E3D\548C</strong></u>.</li>'),
unistr('  <li>\503C\8CC7\6599\6B04 - \9078\53D6 SAL.</li>'),
'</ul></code>',
'</p>',
unistr('<p><strong>\7BC4\4F8B 3:</strong> \986F\793A\542B\6709\6BCF\500B\90E8\9580\4E2D\54E1\5DE5\6578\76EE\7684\300C\54E1\5DE5\300D\5716\8868.'),
'<code><ul>',
unistr('  <li>\8868\683C\6216\8996\89C0\8868 - \9078\53D6 EMP.</li>'),
unistr('  <li>\6A19\7C64\8CC7\6599\6B04 - \9078\53D6 DEPTNO.</li>'),
unistr('  <li>\5F59\7E3D - \9078\53D6<u><strong>\8A08\6578</strong></u>.</li>'),
unistr('  <li>\503C\8CC7\6599\6B04 - \9078\53D6 EMPNO.</li>'),
'</ul></code>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109400214618313675)
,p_name=>'CA.CLIENT.ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110216699518314328)
,p_name=>'CA.CLOSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109038115057313399)
,p_name=>'CA.CLOSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110214689519314326)
,p_name=>'CA.COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110191633989314306)
,p_name=>'CA.COLUMN.1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110191722390314306)
,p_name=>'CA.COLUMN.2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110179029312314294)
,p_name=>'CA.COLUMN.ALIAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110210483734314323)
,p_name=>'CA.COMMENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A3B\89E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110176781269314293)
,p_name=>'CA.COMPONENT.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110181554762314296)
,p_name=>'CA.CONFIG.ACCESS.CONTROL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\5B58\53D6\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110171956615314289)
,p_name=>'CA.CONFIG.APPEARANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\5916\89C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110172084332314289)
,p_name=>'CA.CONFIG.APPEARANCE.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\61C9\7528\7A0B\5F0F\5916\89C0\662F\7531\4E3B\984C\6A23\5F0F\5B9A\7FA9.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110175309164314292)
,p_name=>'CA.CONFIG.OPTION.UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\614B\9078\9805\5DF2\66F4\65B0. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110157268023314278)
,p_name=>'CA.CONFIGURATION.SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\614B\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110155548876314277)
,p_name=>'CA.CONFIGURATION.SETTINGS.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\6216\505C\7528\61C9\7528\7A0B\5F0F\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110157320008314278)
,p_name=>'CA.CONFIGURATION.SETTINGS.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8B93\61C9\7528\7A0B\5F0F\7BA1\7406\54E1\80FD\5920\555F\7528\6216\505C\7528\61C9\7528\7A0B\5F0F\5167\7684\7279\5B9A\529F\80FD. \9078\53D6\7684\529F\80FD\82E5\9700\8981\518D\7D93\904E\958B\767C\624D\80FD\63D0\4F9B\7D66\4E00\822C\4F7F\7528\8005\4F7F\7528, \6B64\529F\80FD\5C31\975E\5E38\5BE6\7528.<br>'),
unistr('\6B64\529F\80FD\4E5F\53EF\4EE5\62D3\5C55\81F3\61C9\7528\7A0B\5F0F\7279\5B9A\529F\80FD. \958B\767C\4EBA\54E1\82E5\5B9A\7FA9\984D\5916\7684\7D44\5EFA\9078\9805\4E26\4E14\5C07\5B83\5011\8207\61C9\7528\7A0B\5F0F\7684\7279\5B9A\529F\80FD\95DC\806F\7684\8A71, \5C31\53EF\4EE5\5C07\9019\4E9B\7D44\5EFA\9078\9805\52A0\5230\7BA1\7406\54E1\7684\7D44\614B\8A2D\5B9A\503C. \4F8B\5982, \5728\300C\5BA2\6236\8FFD\8E64\5668\5957\88DD\61C9\7528\7A0B\5F0F\300D\5167, \7BA1\7406\54E1\53EF\4EE5\958B\555F\6216\95DC\9589\50CF\806F\7D61\4EBA\3001\8CC7\6599\8F09\5165\3001\5730\7406\4F4D\7F6E\7B49\7B49\7684\529F\80FD.'),
'</p>',
unistr('<p>\5305\62EC\4E0B\5217\5143\4EF6:'),
'<ul>',
unistr('<li>\53EF\4EE5\555F\7528\53CA\505C\7528\61C9\7528\7A0B\5F0F\529F\80FD</li>'),
unistr('<li>\5141\8A31\90E8\7F72\9078\64C7\6027\529F\80FD\7684\4F7F\7528\529F\80FD</li>'),
unistr('<li>\652F\63F4\5C07\76F8\95DC\61C9\7528\7A0B\5F0F\8A2D\5B9A\503C\5206\7D44</li>'),
unistr('<li>\61C9\7528\7A0B\5F0F\958B\767C\4EBA\54E1\53EF\4EE5\4F7F\7528\7D44\5EFA\9078\9805\63A7\5236\5143\4EF6</li>'),
unistr('<li>\53EF\5F9E\7BA1\7406\9801\9762\57F7\884C\4E0A\8FF0\52D5\4F5C</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109395135670313671)
,p_name=>'CA.CONNECT.CREDENTIAL.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7DDA\8B49\660E\8CC7\6599\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109395209281313671)
,p_name=>'CA.CONNECT.CREDENTIAL.OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7DDA\8B49\660E\8CC7\6599\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110061672616314187)
,p_name=>'CA.CONTEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\95DC\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110182048416314297)
,p_name=>'CA.CONTRIBUTOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109402154562313677)
,p_name=>'CA.CPU.USED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\7684 CPU')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110190518519314305)
,p_name=>'CA.CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110195630344314309)
,p_name=>'CA.CREATE.ADMIN.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\7BA1\7406\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110193273240314307)
,p_name=>'CA.CREATE.APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110194340913314308)
,p_name=>'CA.CREATE.APP.COMP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110193693964314307)
,p_name=>'CA.CREATE.APP.ICON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F\5716\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110194216481314308)
,p_name=>'CA.CREATE.APP.ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110194455717314308)
,p_name=>'CA.CREATE.APP.PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110070725991314193)
,p_name=>'CA.CREATE.APP.SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110200502414314316)
,p_name=>'CA.CREATE.APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109444025760313709)
,p_name=>'CA.CREATE.APP_ROLES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110193874957314307)
,p_name=>'CA.CREATE.AUTH.SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6388\6B0A\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110194612809314308)
,p_name=>'CA.CREATE.BLANK.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\7A7A\767D\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110193711027314307)
,p_name=>'CA.CREATE.BUILD.OPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\7D44\5EFA\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110195010605314308)
,p_name=>'CA.CREATE.CALENDAR.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\884C\4E8B\66C6\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110206832229314321)
,p_name=>'CA.CREATE.CARDS.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5361\7247\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110194887492314308)
,p_name=>'CA.CREATE.CHART.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5716\8868\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110195379945314309)
,p_name=>'CA.CREATE.CR.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\4E00\822C\5831\8868\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110194923009314308)
,p_name=>'CA.CREATE.DASHBOARD.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5100\8868\677F\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110193142963314307)
,p_name=>'CA.CREATE.END'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110214188107314326)
,p_name=>'CA.CREATE.FACETED_SEARCH.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\591A\9762\5411\641C\5C0B\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110195908713314309)
,p_name=>'CA.CREATE.FEATURES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110211404628314324)
,p_name=>'CA.CREATE.FILTERED.CONTENT.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\7D93\904E\7BE9\9078\7684\5167\5BB9\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110194702996314308)
,p_name=>'CA.CREATE.FORM.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\8868\55AE\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110193374723314307)
,p_name=>'CA.CREATE.GLOBAL.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5168\57DF\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110195581892314309)
,p_name=>'CA.CREATE.HOMEPAGE.NAV.LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\9996\9801\5C0E\89BD\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110195410307314309)
,p_name=>'CA.CREATE.IG.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\4E92\52D5\5F0F\65B9\683C\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110195233676314308)
,p_name=>'CA.CREATE.IR.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\4E92\52D5\5F0F\5831\8868\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108904645228313291)
,p_name=>'CA.CREATE.MAP.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5730\5716\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110200283180314316)
,p_name=>'CA.CREATE.MD.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\4E3B\8981\660E\7D30\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110194031196314308)
,p_name=>'CA.CREATE.NAV.BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5C0E\89BD\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110197269536314310)
,p_name=>'CA.CREATE.PAGE.GROUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\9801\9762\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110195869600314309)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\7FFB\8B6F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110195701580314309)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION.V'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C %0 \7684\7FFB\8B6F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110195152492314308)
,p_name=>'CA.CREATE.REPORT.FORM.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5831\8868\548C\8868\55AE\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110200448161314316)
,p_name=>'CA.CREATE.SAVE_BLUE.PRINT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\85CD\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110194190555314308)
,p_name=>'CA.CREATE.SHORT.CUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6377\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110194545373314308)
,p_name=>'CA.CREATE.SIGN.IN.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\767B\5165\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108904343563313290)
,p_name=>'CA.CREATE.SMART_FILTERS.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\667A\6167\578B\7BE9\9078\689D\4EF6\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110193023461314307)
,p_name=>'CA.CREATE.START'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110193467054314307)
,p_name=>'CA.CREATE.SUP.OBJ.SCRIPTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\652F\63F4\7269\4EF6\547D\4EE4\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110193906499314308)
,p_name=>'CA.CREATE.TEXT.MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6587\5B57\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110206900663314321)
,p_name=>'CA.CREATE.TIMELINE.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6642\9593\8868\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110214338265314326)
,p_name=>'CA.CREATE.WIZARD.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\7CBE\9748\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110174628402314291)
,p_name=>'CA.CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6642\9593')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110174709314314291)
,p_name=>'CA.CREATED.BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110163168513314282)
,p_name=>'CA.CREATING.APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F ...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109395811295313672)
,p_name=>'CA.CREDENTIAL.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B49\660E\8CC7\6599\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109402053738313676)
,p_name=>'CA.CREDENTIAL.OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B49\660E\8CC7\6599\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110175240726314292)
,p_name=>'CA.CURRENT.STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110196230498314309)
,p_name=>'CA.CUSTOM.QRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109485098043313739)
,p_name=>'CA.CUSTOM.THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\81EA\8A02\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109485182914313739)
,p_name=>'CA.CUSTOM.THEME.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5C07\7CBE\9748\5207\63DB\70BA\4F7F\7528\81EA\8A02\4E3B\984C, \800C\975E\901A\7528\4E3B\984C.</p>'),
'',
unistr('<p>\9078\53D6\61C9\7528\7A0B\5F0F\7684\5DE5\4F5C\5340\4E3B\984C. \5982\679C\4E3B\984C\652F\63F4\4E3B\984C\6A23\5F0F, \5247\540C\6642\53EF\9078\53D6\6A23\5F0F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109149713078313483)
,p_name=>'CA.CUSTOM_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\4E3B\984C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110196880185314310)
,p_name=>'CA.DASHBOARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\5100\8868\677F\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110060697835314186)
,p_name=>'CA.DASHBOARD.CHART.N'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110196980908314310)
,p_name=>'CA.DASHBOARD.DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5EFA\7ACB\4E00\500B\542B\6709\591A\500B\5716\8868\7684\5100\8868\677F\9801\9762.</p>'),
unistr('<p>\8F38\5165\4E0B\5217\5C6C\6027:</p>'),
'<ul>',
unistr('  <li><strong>\9801\9762\540D\7A31</strong> (\5FC5\8981) - \8F38\5165\6B64\9801\9762\7684\540D\7A31.</li>'),
unistr('  <li><strong>\8A2D\5B9A\5716\793A</strong> - \9078\53D6\6B64\9801\9762\5728\5C0E\89BD\529F\80FD\8868\4E2D\7684\986F\793A\5716\793A.</li>'),
'  </ul>',
'</ul>',
'&nbsp;<br>',
unistr('<p>\6BCF\500B\5716\8868 (\5716\8868 1\3001\5716\8868 2\3001\5716\8868 3 \4EE5\53CA\5716\8868 4) \6703\6839\64DA<em>\7BC4\4F8B\8CC7\6599</em>\9810\8A2D\70BA\4E0D\540C\7684\5716\8868\985E\578B. '),
unistr('  \56E0\6B64\60A8\4E0D\9700\8981\8F38\5165\4EFB\4F55\9032\4E00\6B65\7684\8A73\7D30\8CC7\8A0A\5373\53EF\65B0\589E\6B64\9801\9762.'),
unistr('  \4F46\662F, \60A8\53EF\4EE5\5C07\9810\8A2D\503C\53D6\4EE3\70BA\81EA\5DF1\9078\64C7\7684\503C\4F86\81EA\8A02\6BCF\500B\5716\8868.<br>'),
unistr('  \82E5\8981\81EA\8A02\5716\8868, \8ACB\8F38\5165\4E0B\5217\5C6C\6027:</p>'),
'<ul>',
unistr('  <li><strong>\5716\8868\540D\7A31</strong> (\5FC5\8981) - \8F38\5165\5716\8868\7684\540D\7A31.</li>'),
unistr('  <li><strong>\5716\8868\985E\578B</strong> - \9078\53D6\8981\986F\793A\7684\5716\8868\985E\578B [<strong>\5340\57DF\5716</strong>\3001<strong>\9577\689D\5716</strong>\3001<strong>\6298\7DDA\5716</strong>\3001<strong>\5713\9905\5716</strong>].</li>'),
unistr('  <li><strong>\8868\683C\6216\8996\89C0\8868</strong> (\5FC5\8981) - \9078\53D6\5716\8868\7684\8CC7\6599\5EAB\7269\4EF6.</li>'),
unistr('  <li><strong>\6A19\7C64\8CC7\6599\6B04</strong> (\5FC5\8981) - \5F9E\8868\683C\6216\8996\89C0\8868\4E2D\9078\53D6\8981\4F5C\70BA\5716\8868\6A19\7C64\7684\8CC7\6599\6B04.</li>'),
unistr('  <li><strong>\503C\805A\7E3D</strong> - \9078\53D6\503C\8CC7\6599\6B04\7684\986F\793A\6216\805A\7E3D\65B9\5F0F<br>'),
unistr('      &nbsp;&nbsp;&nbsp;[\8CC7\6599\6B04\503C\3001\7E3D\548C\3001\8A08\6578].</li>'),
unistr('  <li><strong>\503C\8CC7\6599\6B04</strong> (\5FC5\8981) - \5F9E\8868\683C\6216\8996\89C0\8868\4E2D\9078\53D6\7528\65BC\8A08\7B97\986F\793A\4E4B\5716\8868\503C\7684\6578\503C\8CC7\6599\6B04.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110207541175314321)
,p_name=>'CA.DATATYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110208683173314322)
,p_name=>'CA.DATEFORMATMASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F\683C\5F0F\906E\7F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110175970037314292)
,p_name=>'CA.DEFAULT.TIME.ZONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\6642\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110176097058314292)
,p_name=>'CA.DEFAULT.TIME.ZONE.UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\6642\5340\5DF2\66F4\65B0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110197617856314310)
,p_name=>'CA.DEFAULTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\5C6C\6027\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110197996221314310)
,p_name=>'CA.DEFAULTS.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64 JSON \6587\4EF6\53EF\4F9B\7CBE\7D30\63A7\5236\7522\751F\7684\5831\8868\548C\8868\55AE\8CC7\6599\6B04\540D\7A31\3001\683C\5F0F\906E\7F69\7B49\7B49.  \60A8\4E5F\53EF\4EE5\5B9A\7FA9\503C\6E05\55AE\548C\5176\4ED6\5171\7528\5143\4EF6. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110213963249314326)
,p_name=>'CA.DEFAULTS.LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110214013053314326)
,p_name=>'CA.DEFAULTS.LOV.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\65B0\589E\503C\6E05\55AE (LOV) \5C6C\6027. LOV \53EF\5728\8868\683C\8CC7\6599\6B04\5B9A\7FA9\4E2D\4F7F\7528.</p>'),
unistr('<p>\8F38\5165\4E0B\5217\5C6C\6027:'),
'  <ul>',
unistr('    <li><strong>\540D\7A31</strong> (\5FC5\8981) - \8F38\5165\503C\6E05\55AE\7684\540D\7A31.</li>'),
unistr('    <li><strong>\985E\578B</strong> - \9078\53D6\503C\6E05\55AE\985E\578B [\7D50\69CB\5316\3001\52D5\614B\3001\975C\614B].<br>'),
unistr('      \82E5\70BA<u>\7D50\69CB\5316</u>\985E\578B - '),
'      <ul>',
unistr('          <li><strong>\8868\683C</strong> (\5FC5\8981) - \9078\53D6\503C\6E05\55AE\6240\4F9D\64DA\7684\8868\683C\6216\8996\89C0\8868.</li>'),
unistr('          <li><strong>\986F\793A\8CC7\6599\6B04</strong> (\5FC5\8981) - \9078\53D6\8981\5C0D\4E00\822C\4F7F\7528\8005\986F\793A\7684\8CC7\6599\6B04.</li>'),
unistr('          <li><strong>\7D22\5F15\9375\8CC7\6599\6B04</strong> (\5FC5\8981) - \9078\53D6\8981\50B3\56DE\7684\8CC7\6599\6B04\503C. \9019\901A\5E38\662F\8868\683C\7684\4E3B\7D22\5F15\9375.</li>'),
'      </ul>',
'      &nbsp;<br>',
unistr('      \82E5\70BA<u>\52D5\614B</u>\985E\578B -'),
'      <ul>',
unistr('          <li><strong>SQL \67E5\8A62</strong> (\5FC5\8981) - \8F38\5165\50B3\56DE\5169\500B\503C (\986F\793A\503C\548C\50B3\56DE\503C) \7684\6709\6548 SQL select \6558\8FF0\53E5.</li>'),
'      </ul>',
'      &nbsp;<br>',
unistr('      \82E5\70BA<u>\975C\614B</u>\985E\578B -'),
'      <ul>',
unistr('          <li><strong>\975C\614B\503C\6E05\55AE</strong> (\5FC5\8981) - \8F38\5165\683C\5F0F\5982\4E0B\7684\6709\6548\975C\614B\6E05\55AE:'),
'          <ul>',
unistr('            <li><code>STATIC2:Display1;Value1,Display2;Value2,...</code><br>\6E05\55AE\4F9D\8F38\5165\9806\5E8F\986F\793A</li>'),
unistr('            <li><code>STATIC:Display1;Value1,Display2;Value2,...</code><br>\6E05\55AE\4F9D\5B57\6BCD\9806\5E8F\6392\5217</li>'),
unistr('            <li><code>STATIC2|STATIC:Value1,Value2,...</code><br>\986F\793A\503C\8207\50B3\56DE\503C\76F8\540C</li>'),
'          </ul>',
'      </ul>',
'    </li>',
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110215131136314327)
,p_name=>'CA.DEFAULTS.REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110215262372314327)
,p_name=>'CA.DEFAULTS.REPORT.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7DE8\8F2F\6240\6709\5831\8868\7684\5C6C\6027.</p>'),
unistr('<p>\8F38\5165\4E0B\5217\5C6C\6027:'),
'  <ul>',
unistr('    <li><strong>\6BCF\9801\8CC7\6599\5217\6578</strong> - \8F38\5165\9810\8A2D\8981\986F\793A\7684\5831\8868\8CC7\6599\5217\6578.</li>'),
unistr('    <li><strong>\5206\9801\65B9\6CD5</strong> - \9078\53D6\986F\793A\5831\8868\5206\9801\7684\65B9\5F0F.</li>'),
unistr('    <li><strong>\6578\503C\683C\5F0F\906E\7F69</strong> - \8F38\5165\8981\5957\7528\81F3\6578\5B57\8CC7\6599\6B04\548C\9805\76EE\7684\683C\5F0F\906E\7F69.</li>'),
unistr('    <li><strong>\65E5\671F\683C\5F0F\906E\7F69</strong> - \8F38\5165\8981\5957\7528\81F3\65E5\671F\8CC7\6599\6B04\548C\9805\76EE\7684\683C\5F0F\906E\7F69.</li>'),
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110214926177314326)
,p_name=>'CA.DEFAULTS.TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110214794593314326)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\8CC7\6599\6B04\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110214815187314326)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7DE8\8F2F\6240\9078\8868\683C\8CC7\6599\6B04\7684\5C6C\6027.</p>'),
unistr('<p>\8F38\5165\4E0B\5217\5C6C\6027:'),
'  <ul>',
unistr('    <li><strong>\8868\683C</strong> (\50C5\4F9B\986F\793A) - \95DC\806F\7684\8868\683C.</li>'),
unistr('    <li><strong>\8CC7\6599\6B04</strong> (\50C5\4F9B\986F\793A) - \70BA\5176\5B9A\7FA9\5C6C\6027\7684\8CC7\6599\6B04.</li>'),
unistr('    <li><strong>\6A19\7C64</strong> - \8F38\5165\5831\8868\6A19\984C\548C\8868\55AE\6A19\7C64\4E2D\6240\8981\4F7F\7528\7684\6A19\7C64.</li>'),
unistr('    <li><strong>\8868\55AE\63A7\5236\9805</strong> - \9078\53D6\8868\55AE\8981\4F7F\7528\7684\9805\76EE\985E\578B.</li>'),
unistr('    <li><strong>\503C\6E05\55AE</strong> - \9078\53D6\8981\7528\4F86\9069\7576\5730\986F\793A\4F7F\7528\8005\6613\8A18\540D\7A31\7684\73FE\6709\503C\6E05\55AE.</li>'),
unistr('    <li><strong>\683C\5F0F\906E\7F69</strong> - \6839\64DA\8CC7\6599\6B04\985E\578B (\6587\5B57\3001\6578\5B57\3001\65E5\671F\7B49) \8F38\5165\9069\7576\7684\683C\5F0F\906E\7F69.</li>'),
unistr('    <li><strong>\975C\614B\9810\8A2D\503C</strong> - \8F38\5165\8CC7\6599\6B04\7684\6587\5B57\9810\8A2D\503C.</li>'),
unistr('    <li><strong>\5305\62EC\5728\8868\55AE\4E0A</strong> - \8868\55AE\82E5\61C9\8A72\5305\542B\6B64\8CC7\6599\6B04, \8ACB\6309\4E00\4E0B\300C\662F\300D.</li>'),
unistr('    <li><strong>\5305\62EC\5728\5831\8868\4E0A</strong> - \5831\8868\82E5\61C9\8A72\5305\542B\6B64\8CC7\6599\6B04, \8ACB\6309\4E00\4E0B\300C\662F\300D.</li>'),
unistr('    <li><strong>\5FC5\8981</strong> - \5982\679C\5FC5\9808\5728\8868\55AE\7684\9019\500B\8CC7\6599\6B04\4E2D\8F38\5165\8CC7\6599, \8ACB\6309\4E00\4E0B\300C\662F\300D.</li>'),
unistr('    <li><strong>\8AAA\660E</strong> - \8F38\5165\65B0\589E\81F3\9805\76EE\8AAA\660E\5C6C\6027\7684\8AAA\660E\6587\5B57.</li>'),
'  </ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110215082007314327)
,p_name=>'CA.DEFAULTS.TABLE.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7DE8\8F2F\6240\9078\8868\683C\7684\5C6C\6027.</p>'),
unistr('<p>\8F38\5165\4E0B\5217\5C6C\6027:'),
'  <ul>',
unistr('    <li><strong>\8868\683C</strong> (\50C5\4F9B\986F\793A) - \95DC\806F\7684\8868\683C.</li>'),
unistr('    <li><strong>\6A19\7C64 (\55AE\6578)</strong> (\5FC5\8981) - \8F38\5165\8981\5728\8868\55AE\9801\9762\4E0A\4F7F\7528\7684\6A19\7C64.</li>'),
unistr('    <li><strong>\6A19\7C64 (\8907\6578)</strong> (\5FC5\8981) - \8F38\5165\8981\5728\5340\57DF\6A19\984C\548C\9801\9762\540D\7A31\4E2D\4F7F\7528\7684\6A19\7C64.</li>'),
unistr('    <li><strong>\4E3B\8981\986F\793A\8CC7\6599\6B04</strong> - \9078\53D6\8981\986F\793A\7684\7B2C\4E00\500B\8CC7\6599\6B04, \4F8B\5982\5728\5361\7247\5340\57DF\4E2D.</li>'),
unistr('    <li><strong>\6B21\8981\986F\793A\8CC7\6599\6B04</strong> - \9078\53D6\8981\986F\793A\7684\7B2C\4E8C\500B\8CC7\6599\6B04, \4F8B\5982\5728\5361\7247\5340\57DF\4E2D.</li>'),
unistr('    <li><strong>\4E3B\7D22\5F15\9375\8CC7\6599\6B04</strong> - \9078\53D6\8868\683C\7684\552F\4E00\4E3B\7D22\5F15\9375\8CC7\6599\6B04.</li>'),
unistr('    <li><strong>\63CF\8FF0</strong> - \8F38\5165\8868\683C\7684\63CF\8FF0.</li>'),
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109395626578313672)
,p_name=>'CA.DEFERRED.DROP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EF6\7DE9\7684\522A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110209296732314322)
,p_name=>'CA.DEFINITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110192996512314307)
,p_name=>'CA.DEINSTALL.COMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89E3\9664\5B89\88DD\5B8C\6210.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110173245635314290)
,p_name=>'CA.DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110192584715314306)
,p_name=>'CA.DELETE.CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\57F7\884C\6B64\522A\9664\52D5\4F5C\55CE?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110158848341314279)
,p_name=>'CA.DELETE.PAGE.CONFIRM.MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78BA\5B9A\8981\522A\9664\6B64\9801\9762\55CE?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110183054743314297)
,p_name=>'CA.DELETE.PHOTO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\76F8\7247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110173929208314291)
,p_name=>'CA.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110191105269314305)
,p_name=>'CA.DESKTOP.NAVIGATION.BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110191062123314305)
,p_name=>'CA.DESKTOP.NAVIGATION.MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\529F\80FD\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110172291788314289)
,p_name=>'CA.DESKTOP.THEME.STYLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\684C\9762\4E3B\984C\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110172315035314289)
,p_name=>'CA.DESKTOP.THEME.STYLE.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\4E3B\984C\6A23\5F0F\6703\5957\7528\81F3\6240\6709\4F7F\7528\8005.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109396048981313672)
,p_name=>'CA.DESTINATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\7684\5730')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109396128079313672)
,p_name=>'CA.DESTINATION.OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\7684\5730\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109149834303313483)
,p_name=>'CA.DIALOG.BUTTONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\8A71\65B9\584A\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110187572997314303)
,p_name=>'CA.DISPATCH.EMAILS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767C\9001\96FB\5B50\90F5\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110206090006314320)
,p_name=>'CA.DISPATCH.EMAILS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C7A\5B9A\662F\5426\61C9\5F9E\96FB\5B50\90F5\4EF6\67B6\69CB\9001\51FA\96FB\5B50\90F5\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110173740966314290)
,p_name=>'CA.DISPLAY.FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\81EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110173696502314290)
,p_name=>'CA.DISPLAY.SEQUENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110173883381314291)
,p_name=>'CA.DISPLAY.UNTIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\81F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110207787708314321)
,p_name=>'CA.DISPLAYCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110177308298314293)
,p_name=>'CA.DISTINCT .USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\540C\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110190665942314305)
,p_name=>'CA.DOWNLOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110197524625314310)
,p_name=>'CA.DRAG.TO.REORDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62D6\66F3\4EE5\91CD\65B0\6392\5217\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109170565676313498)
,p_name=>'CA.DRILL.DOWN.LINK'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr('  <li><strong>\5411\4E0B\5C55\958B\9023\7D50</strong> - \5C55\958B\5373\53EF\67E5\770B\7528\65BC\5B9A\7FA9\5411\4E0B\5C55\958B\9023\7D50\7684\5C6C\6027.'),
'&nbsp;<br>',
unistr('    <em><strong>\6CE8\610F:</strong> \76EE\524D\7684\9801\9762\662F\4EE5\8868\683C\6216\8996\89C0\8868\70BA\57FA\790E\4E14\5831\8868\985E\578B\70BA\300C\4E92\52D5\5F0F\5831\8868\300D, \540C\6642\60A8\5DF2\5B9A\7FA9\5831\8868 (\4E92\52D5\5F0F\5831\8868) \6216\4E3B\8981\660E\7D30 (\4E3B\8981\660E\7D30) \9801\9762\6642, \624D\6703\986F\793A\5411\4E0B\5C55\958B\9023\7D50.</em>'),
'  <ul>',
unistr('    <li><strong>\9023\7D50\8CC7\6599\6B04</strong> - \9078\53D6\5728\5831\8868\4E2D\5C07\8B8A\6210\9023\7D50\8CC7\6599\6B04\7684\8CC7\6599\6B04.</li>'),
unistr('    <li><strong>\9023\7D50\7D22\5F15\9375</strong> - \9078\53D6\9023\7D50\7D22\5F15\9375 (\5916\4F86\7D22\5F15\9375) \8CC7\6599\6B04, \7528\4EE5\8B58\5225\9023\7D50\76EE\6A19\9801\9762\4E2D\7684\7279\5B9A\8A18\9304.</li>'),
unistr('    <li><strong>\9023\7D50\81F3\9801\9762</strong> - \9078\53D6\9023\7D50\7684\5C0E\89BD\76EE\6A19\5831\8868\6216\8868\55AE\9801\9762.</li>'),
unistr('    <li><strong>\76EE\6A19\7D22\5F15\9375</strong> - \5F9E\9023\7D50\7684\5C0E\89BD\76EE\6A19\6216\4F5C\70BA\57FA\790E\7684\5831\8868\9801\9762\8868\683C\9078\53D6\76EE\6A19\7D22\5F15\9375 (\4E3B\7D22\5F15\9375) \8CC7\6599\6B04.'),
'  </ul>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110176426515314292)
,p_name=>'CA.ELAPSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D93\6B77\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110159046500314279)
,p_name=>'CA.EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\67B6\69CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110205635941314320)
,p_name=>'CA.EMAIL.ADDRESSES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\5730\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110215607254314327)
,p_name=>'CA.EMAIL.DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110158952969314279)
,p_name=>'CA.EMAIL.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\8A2D\5B9A\53CA\50B3\9001\96FB\5B50\90F5\4EF6\7684\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110159178963314279)
,p_name=>'CA.EMAIL.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\542B\62EC\5F9E\60A8\7684\61C9\7528\7A0B\5F0F\50B3\9001\96FB\5B50\90F5\4EF6\7684\529F\80FD. \53EF\4F7F\7528\96FB\5B50\90F5\4EF6\7BC4\4F8B\6A23\677F, \50B3\9001\5C08\696D\7684\96FB\5B50\90F5\4EF6\7D66\4F7F\7528\8005. \50B3\9001\7684\96FB\5B50\90F5\4EF6\90FD\6703\8A18\9304\4E0B\4F86, \8B93\7BA1\7406\54E1\80FD\5920\8FFD\8E64\96FB\5B50\90F5\4EF6\6D3B\52D5.</p>'),
unistr('<p>\5305\62EC\4E0B\5217\5143\4EF6:'),
'<ul>',
unistr('<li>\53EF\64F4\5145\7684 HTML \96FB\5B50\90F5\4EF6\6A23\677F\7CFB\7D71</li>'),
unistr('<li>\53EF\900F\904E APEX \5957\88DD\7A0B\5F0F\50B3\9001\90F5\4EF6\7684 PL/SQL \5957\88DD\7A0B\5F0F</li>'),
unistr('<li>\96FB\5B50\90F5\4EF6\6D3B\52D5\548C\72C0\614B\7684\8A18\9304\529F\80FD</li>'),
unistr('<li>\7BA1\7406\6A23\677F\7684\7BA1\7406 UI</li>'),
unistr('<li>\6AA2\8996\96FB\5B50\90F5\4EF6\65E5\8A8C\7684\7BA1\7406 UI</li>'),
unistr('<li>\50B3\9001\96FB\5B50\90F5\4EF6\7684\7BA1\7406 UI</li>'),
'</ul>',
'</p>',
unistr('<p><em>\6CE8\610F: \9078\53D6\300C\610F\898B\56DE\994B\300D\6642\624D\6703\555F\7528\6B64\529F\80FD</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110211334895314324)
,p_name=>'CA.EMAIL.FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\5BC4\4EF6\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110186531179314302)
,p_name=>'CA.EMAIL.LOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\65E5\8A8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110216269713314327)
,p_name=>'CA.EMAIL.P10940.EMAIL.DETAILS.REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165\96FB\5B50\90F5\4EF6\8A2D\5B9A\503C\8A73\7D30\8CC7\8A0A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110215756309314327)
,p_name=>'CA.EMAIL.P10940.EMAILS.FROM.INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5BC4\4EF6\8005\5730\5740\300D\4E0D\662F\6709\6548\7684\96FB\5B50\90F5\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110207231577314321)
,p_name=>'CA.EMAIL.P11030.EMAILS.FROM.INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5BC4\4EF6\8005\5730\5740\300D\4E0D\662F\6709\6548\7684\96FB\5B50\90F5\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110206498229314320)
,p_name=>'CA.EMAIL.PROCESSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\5DF2\8655\7406.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109273417134313575)
,p_name=>'CA.EMAIL.REPORTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109445765650313710)
,p_name=>'CA.EMAIL.REPORTING.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6392\5165\4F47\5217\7B49\5F85\50B3\9001\53CA\5DF2\7D93\50B3\9001\7684\6240\6709\96FB\5B50\90F5\4EF6\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110187459625314303)
,p_name=>'CA.EMAIL.SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110187889694314303)
,p_name=>'CA.EMAIL.SETTINGS.UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\8A2D\5B9A\503C\5DF2\66F4\65B0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110211745200314324)
,p_name=>'CA.EMAIL.STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110187944173314303)
,p_name=>'CA.EMAIL.TEMPLATE.DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\6A23\677F\8A73\7D30\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109694100608313917)
,p_name=>'CA.EMAIL.TEMPLATE.SUBJECT_EXAMPLE.SO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5B9A\7684 #SERVICE_NAME# \505C\6A5F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109492428097313745)
,p_name=>'CA.EMAIL2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110186477011314302)
,p_name=>'CA.EMAILS.SENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\9001\7684\96FB\5B50\90F5\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110215870254314327)
,p_name=>'CA.ENABLE.ATTACHMENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109401144026313676)
,p_name=>'CA.ENABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109398315612313674)
,p_name=>'CA.END.DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110188560009314303)
,p_name=>'CA.END.ROW.TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\4E4B\5F8C\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110079862200314199)
,p_name=>'CA.ENDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110203517861314318)
,p_name=>'CA.ENTER.USERNAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\6B64\8655\8F38\5165\4F7F\7528\8005\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110177086962314293)
,p_name=>'CA.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110179325238314295)
,p_name=>'CA.ERROR.BACKTRACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\8FFD\8E64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110179222275314295)
,p_name=>'CA.ERROR.CODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\4EE3\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110178512301314294)
,p_name=>'CA.ERROR.MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109402808335313677)
,p_name=>'CA.ERROR.NUMBER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\7DE8\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109401819735313676)
,p_name=>'CA.ERRORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110080097098314200)
,p_name=>'CA.ERROR_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109398776846313674)
,p_name=>'CA.EVENT.CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109398805954313674)
,p_name=>'CA.EVENT.QUEUE.AGENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6\4F47\5217\4EE3\7406\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109398993056313674)
,p_name=>'CA.EVENT.QUEUE.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6\4F47\5217\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109399066650313674)
,p_name=>'CA.EVENT.QUEUE.OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6\4F47\5217\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109398631403313674)
,p_name=>'CA.EVENT.RULE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6\898F\5247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110203811647314318)
,p_name=>'CA.EXCEPTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7570\5E38\72C0\6CC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110216743435314328)
,p_name=>'CA.EXPERIENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D93\9A57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109400880470313676)
,p_name=>'CA.FAILURE.COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5931\6557\8A08\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110175087274314291)
,p_name=>'CA.FEATURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109849601341314035)
,p_name=>'CA.FEATURE.ABOUT_PAGE.APP_VERSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109849799567314035)
,p_name=>'CA.FEATURE.ABOUT_PAGE.PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109533994535313776)
,p_name=>'CA.FEATURE.ACL.ADD_USERS_TO_ACL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4F7F\7528\8005\65B0\589E\81F3\5B58\53D6\63A7\5236\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109533745509313776)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.ADD.NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D\5F80\4E0B\4E00\6B65')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109533807146313776)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.CREATE_COLLECTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\96C6\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109533604762313776)
,p_name=>'CA.FEATURE.ACL.USER.EDIT.CANNOT_CHANGE_LAST_ADMIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8B8A\66F4\6700\5F8C\4E00\500B\7BA1\7406\54E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109849347779314035)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.LAST_ACTIVITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\6B21\6D3B\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109533401813313776)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.NO_ACTIVITY_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\6D3B\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109849505197314035)
,p_name=>'CA.FEATURE.EXCEPTION.REASON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\539F\56E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109534034477313776)
,p_name=>'CA.FEATURE.FEEDBACK.AT_LEAST_ONE_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81F3\5C11\8981\6709\4E00\9805\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109534308913313776)
,p_name=>'CA.FEATURE.FEEDBACK.GET_FILE_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\5F97\6A94\6848 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109532943699313775)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\4E3B\984C\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109533093765313775)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE_USER_PREF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\4E00\822C\4F7F\7528\8005\6A23\5F0F\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109849472270314035)
,p_name=>'CA.FEATURE.USERNAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110163228567314283)
,p_name=>'CA.FEATURES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110163352560314283)
,p_name=>'CA.FEATURES.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\529F\80FD\300D\63D0\4F9B\61C9\7528\7A0B\5F0F\5C64\7D1A\529F\80FD, \800C\4E14\901A\5E38\53EA\80FD\5728\61C9\7528\7A0B\5F0F\5167\65B0\589E\4E00\6B21. \8ACB\9078\64C7\61C9\7528\7A0B\5F0F\8981\5305\62EC\7684\529F\80FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110157176715314278)
,p_name=>'CA.FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110155121819314276)
,p_name=>'CA.FEEDBACK.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\4F7F\7528\8005\63D0\4F9B\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110157095098314278)
,p_name=>'CA.FEEDBACK.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D0\4F9B\4E00\822C\4F7F\7528\8005\5C07\4E00\822C\8A3B\89E3\53CD\61C9\7D66\61C9\7528\7A0B\5F0F\7BA1\7406\54E1\548C\958B\767C\4EBA\54E1\6642\6240\63A1\7528\7684\6A5F\5236. \5F35\8CBC\9805\76EE\5305\62EC\6709\7528\7684\968E\6BB5\4F5C\696D\72C0\614B\8CC7\8A0A, \53EF\5E6B\52A9\5224\65B7\4E00\822C\4F7F\7528\8005\5F9E\4F55\8655\50B3\9001\610F\898B\56DE\994B. \63D0\4F9B\9019\6A23\65B9\4FBF\7684\610F\898B\56DE\994B\7BA1\9053, \52A0\5F37\4E86\4F7F\7528\8005\793E\7FA4\8207\61C9\7528\7A0B\5F0F\64C1\6709\8005\4E4B\9593\7684\6E9D\901A, \85C9\6B64\4FC3\9032\4E00\822C\4F7F\7528\8005\7684\6EFF\610F\5EA6.</p>'),
unistr('<p>\5305\62EC\4E0B\5217\5143\4EF6:'),
'<ul>',
unistr('<li>\4E00\822C\4F7F\7528\8005\6309\4E00\4E0B\5C0E\89BD\5217\5716\793A\5373\53EF\7559\4E0B\610F\898B\56DE\994B\7684\529F\80FD</li>'),
unistr('<li>\6AA2\8996\8207\66F4\65B0\610F\898B\56DE\994B\7684\7BA1\7406\5831\8868</li>'),
unistr('<li>\610F\898B\56DE\994B\6703\64F7\53D6\4F7F\7528\8005\3001\65E5\671F\548C\6642\9593\53CA\4F7F\7528\8005\4EE3\7406\7A0B\5F0F\8CC7\8A0A</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110217158732314328)
,p_name=>'CA.FEEDBACK.OR_EXPERIENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\63D0\4F9B\610F\898B\56DE\994B\6216\60A8\7684\7D93\9A57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110216146089314327)
,p_name=>'CA.FEEDBACK.RECIPIENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6536\4EF6\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110215578689314327)
,p_name=>'CA.FEEDBACK.SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110184589530314300)
,p_name=>'CA.FEEDBACK.SETTINGS.UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B\8A2D\5B9A\503C\5DF2\66F4\65B0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110216361318314328)
,p_name=>'CA.FEEDBACK.SUBMITTED.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9001\51FA\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109398410409313674)
,p_name=>'CA.FILE.WATCHER.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\76E3\8996\5668\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109398533939313674)
,p_name=>'CA.FILE.WATCHER.OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\76E3\8996\5668\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109056688662313413)
,p_name=>'CA.FILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\63D0\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109056735257313413)
,p_name=>'CA.FILED.BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\51FA\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110211828341314324)
,p_name=>'CA.FILTER.REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110188982037314304)
,p_name=>'CA.FILTERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110214504338314326)
,p_name=>'CA.FINISH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110183230076314298)
,p_name=>'CA.FIRST.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109395402359313671)
,p_name=>'CA.FLAGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65D7\6A19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110164697126314284)
,p_name=>'CA.FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\8868\55AE\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110164593067314284)
,p_name=>'CA.FORM.DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5EFA\7ACB\4E00\500B\986F\793A\8868\55AE\9801\9762\7684\9801\9762, \8B93\4E00\822C\4F7F\7528\8005\53EF\4EE5\7DAD\8B77\8CC7\6599.</p>'),
unistr('<p>\8F38\5165\4E0B\5217\5C6C\6027:</p>'),
'<ul>',
unistr('  <li><strong>\9801\9762\540D\7A31</strong> (\5FC5\8981) - \8F38\5165\6B64\9801\9762\7684\540D\7A31.</li>'),
unistr('  <li><strong>\8A2D\5B9A\5716\793A</strong> - \9078\53D6\6B64\9801\9762\5728\5C0E\89BD\529F\80FD\8868\4E2D\7684\986F\793A\5716\793A.</li>'),
unistr('  <li><strong>\8868\683C</strong> (\5FC5\8981) - \9078\53D6\8868\55AE\7684\8868\683C.</li>'),
unistr('<li><strong>\5305\62EC\5831\8868</strong> (\5FC5\8981) - \9078\53D6\6B64\9078\9805\5373\53EF\5EFA\7ACB\5831\8868\548C\8868\55AE. \7B2C\4E00\9801\6703\662F\4E92\52D5\5F0F\5831\8868. \6BCF\500B\8CC7\6599\5217\90FD\6703\6709\8868\55AE\9023\7D50, \8B93\4F7F\7528\8005\53EF\66F4\65B0\8A18\9304. </li>'),
'  &nbsp;<br>',
unistr('<li><strong>\9032\968E</strong> - \5C55\958B\5373\53EF\67E5\770B\9032\968E\9078\9805.'),
'     <ul>',
unistr('      <li><strong>\9801\9762\8AAA\660E</strong> - \8F38\5165\8981\65B0\589E\81F3\9801\9762\8AAA\660E\5167\5BB9\4E2D\7684\6587\5B57.</li>'),
'      </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109169193789313497)
,p_name=>'CA.FORM.ITEM.REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE\9805\76EE\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110190807368314305)
,p_name=>'CA.FORM.ON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \76F8\95DC\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110203379244314318)
,p_name=>'CA.FORM.TYPE.NOT.VALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8868\55AE\985E\578B\4E0D\662F\4E00\500B\6709\6548\7684\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110209735182314323)
,p_name=>'CA.FORMATMASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F\906E\7F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110208745745314322)
,p_name=>'CA.FORMCONTROL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE\63A7\5236\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110174495380314291)
,p_name=>'CA.FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110187658760314303)
,p_name=>'CA.FROM.ADDRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC4\4EF6\8005\5730\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110211215824314324)
,p_name=>'CA.FROM.ADDRESS.EMAIL.SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5BC4\4EF6\8005\5730\5740\300D\96FB\5B50\90F5\4EF6\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110207125251314321)
,p_name=>'CA.FROM.EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC4\4EF6\8005\96FB\5B50\90F5\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110207043312314321)
,p_name=>'CA.FROM.WHO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC4\4EF6\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109900061591314071)
,p_name=>'CA.FS.SEARCH.TABLE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110177992178314294)
,p_name=>'CA.FULL.PAGE.VIEWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6574\9801\9762\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110186627974314302)
,p_name=>'CA.FULL.TEMPLATE.HTML'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6574\6A23\677F HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110208222557314322)
,p_name=>'CA.FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110157568168314278)
,p_name=>'CA.GLOBAL.SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\57DF\641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110155304248314276)
,p_name=>'CA.GLOBAL.SEARCH.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\61C9\7528\7A0B\5F0F\641C\5C0B\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110157434040314278)
,p_name=>'CA.GLOBAL.SEARCH.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5141\8A31\4F7F\7528\8005\641C\5C0B\61C9\7528\7A0B\5F0F\5167\7D22\5F15\9375\8868\683C\6216\8996\89C0\8868\4E2D\7684\6587\5B57. \9032\968E\641C\5C0B\9801\9762\5305\62EC\7BE9\9078, \65B9\4FBF\4F7F\7528\8005\7E2E\5C0F\641C\5C0B\7D50\679C.<br>'),
unistr('\9019\9805\5F37\5927\7684\529F\80FD\9700\8981\9032\4E00\6B65\7684\958B\767C\624D\80FD\5B9A\7FA9 SQL (\6839\64DA\63D0\4F9B\7684\7BC4\4F8B).</p>'),
unistr('<p>\5305\62EC\4E0B\5217\5143\4EF6:'),
'<ul>',
unistr('<li>\5728\6A19\982D\5217\986F\793A\641C\5C0B\5716\793A</li>'),
unistr('<li>\5305\62EC\5177\6709\5074\908A\5217\7BE9\9078\7684\8A73\7D30\8CC7\8A0A\641C\5C0B\7D50\679C\9801\9762</li>'),
unistr('<li>\9700\8981\958B\767C\4EBA\54E1\5BE6\884C\5B9A\7FA9\61C9\7528\7A0B\5F0F\641C\5C0B\7684 SQL</li>'),
unistr('<li>\542B\6709\8AAA\660E\7528\7684\7BC4\4F8B\8CC7\6599</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109400102512313675)
,p_name=>'CA.GLOBAL.UID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\57DF\552F\4E00 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109532509941313775)
,p_name=>'CA.GLOBAL_PAGE.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\57DF\9801\9762 - \684C\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109149929922313483)
,p_name=>'CA.GO.TO.ADMIN.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D\5F80\7BA1\7406\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110164124837314283)
,p_name=>'CA.GRID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\4E92\52D5\5F0F\65B9\683C\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110164242850314283)
,p_name=>'CA.GRID.DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5EFA\7ACB\4E00\500B\986F\793A\70BA\4E92\52D5\5F0F\65B9\683C\7684\9801\9762, \9019\8207\8A66\7B97\8868\76F8\4F3C. \5982\679C\53EF\7DE8\8F2F, \4F7F\7528\8005\5C31\53EF\76F4\63A5\5728\9801\9762\4E0A\7DE8\8F2F\591A\500B\8CC7\6599\5217 (\4EA6\5373\555F\7528\300C\5141\8A31\7DE8\8F2F\300D).</p>'),
unistr('<p>\8F38\5165\4E0B\5217\5C6C\6027:</p>'),
'<ul>',
unistr('  <li><strong>\9801\9762\540D\7A31</strong> (\5FC5\8981) - \8F38\5165\6B64\9801\9762\7684\540D\7A31.</li>'),
unistr('  <li><strong>\8A2D\5B9A\5716\793A</strong> - \9078\53D6\6B64\9801\9762\5728\5C0E\89BD\529F\80FD\8868\4E2D\7684\986F\793A\5716\793A.</li>'),
unistr('  <li><strong>\67E5\8A62\985E\578B</strong> - \9078\53D6\5831\8868\7684\4F86\6E90 [<strong>\8868\683C\6216\8996\89C0\8868</strong>\6216 <strong>SQL \67E5\8A62</strong>].<br>'),
unistr('    <strong>\8868\683C\6216\8996\89C0\8868</strong>:'),
'    <ul>',
unistr('      <li><strong>\8868\683C\6216\8996\89C0\8868</strong> (\5FC5\8981) - \9078\53D6\65B9\683C\7684\8CC7\6599\5EAB\7269\4EF6.</li>'),
'    </ul>',
unistr('    <strong>SQL \67E5\8A62</strong>:'),
'    <ul>',
unistr('      <li><strong>SQL \67E5\8A62</strong> (\5FC5\8981) - \8F38\5165\50B3\56DE\4E0D\540C\8CC7\6599\6B04\7684\6709\6548 SQL \6558\8FF0\53E5.</li>'),
'    </ul>',
'  </li>',
unistr('  <li><strong>\65B9\683C\985E\578B</strong> - \9078\53D6\4F7F\7528\8005\662F\5426\80FD\5728\65B9\683C\4E2D\7DE8\8F2F\8CC7\6599\5217 [<strong>\5141\8A31\7DE8\8F2F</strong>\6216<strong>\552F\8B80</strong>]. \82E5\8981\555F\7528\7DE8\8F2F, \8ACB\9078\53D6<strong>\5141\8A31\7DE8\8F2F</strong>.</li>'),
'  &nbsp;<br>',
unistr('  <em><strong>\8B66\544A:</strong> \5982\679C\9078\53D6\7684\67E5\8A62\985E\578B\662F <strong>SQL \67E5\8A62</strong>, \52A0\4E0A\65B9\683C\985E\578B\70BA<strong>\5141\8A31\7DE8\8F2F</strong>, \800C\4E14\60A8\7684\67E5\8A62\7D50\5408\4E86\5169\500B\6216\66F4\591A\8868\683C\7684\8A71, \7576\4F7F\7528\8005\5617\8A66\53CA\66F4\65B0\8A18\9304\6642, \7522\751F\7684\4E92\52D5\5F0F\65B9\683C\5C07\6703\5931\6557.'),
unistr('\6B64\5916, \5982\679C\9078\53D6\7684\65B9\683C\985E\578B\662F<strong>\5141\8A31\7DE8\8F2F</strong>, \4E14\67E5\8A62 (\6216\9078\53D6\4E86\8868\683C\6216\8996\89C0\8868) \4F7F\7528\7684\8996\89C0\8868\7121\6CD5\66F4\65B0\7684\8A71, \7576\4F7F\7528\8005\5617\8A66\53CA\66F4\65B0\8A18\9304\6642, \7522\751F\7684\4E92\52D5\5F0F\65B9\683C\4E5F\5C07\6703\5931\6557.</em><br>'),
'  </li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110189410307314304)
,p_name=>'CA.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110079630237314199)
,p_name=>'CA.HELP.ACTIVITY.REPORTING.AUTOMATIONS.LOG'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\9801\9762\63D0\4F9B\4E92\52D5\5F0F\7684\81EA\52D5\5316\65E5\8A8C\5831\8868.</p>'),
unistr('<p>\8907\67E5\5148\524D\81EA\52D5\5316\57F7\884C\7684\76F8\95DC\8A18\9304\8CC7\8A0A. \6B64\65E5\8A8C\9664\4E86\6240\8655\7406\8CC7\6599\5217\7684\76F8\95DC\8A73\7D30\8CC7\8A0A (\6210\529F\8207\767C\751F\932F\8AA4) \4E4B\5916, \4E5F\5305\542B\958B\59CB\8207\7D50\675F\6642\6233. \5411\4E0B\5C55\958B\81F3\300C\8A0A\606F\300D\5373\53EF\67E5\770B\6240\8655\7406\8CC7\6599\5217\7684\500B\5225\8A0A\606F.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110181807516314296)
,p_name=>'CA.HELP.ALLOW.OTHER.USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\5B58\53D6\63A7\5236\6E05\55AE\6703\5B9A\7FA9\6240\6709\4F7F\7528\8005, \8ACB\9078\64C7<strong>\5426</strong>; \5982\679C\6709\4E0D\5728\5B58\53D6\63A7\5236\6E05\55AE\7684\4F7F\7528\8005, \4F46\6703\4F7F\7528\6B64\61C9\7528\7A0B\5F0F\8005, \8ACB\9078\64C7<strong>\662F</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110175550987314292)
,p_name=>'CA.HELP.APP.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6574\500B\61C9\7528\7A0B\5F0F\90FD\6703\4F7F\7528\6B64\8655\8F38\5165\7684\6587\5B57, \5C24\5176\662F\51FA\73FE\5728\6BCF\500B\9801\9762\7684\5DE6\4E0A\89D2\8655. \6B64\8B8A\66F4\6703\5728\7BA1\7406\54E1\5B8C\6210\8B8A\66F4\6642\7ACB\5373\751F\6548, \4F46\5176\4ED6\4F7F\7528\8005\53EA\6703\5728\9032\884C\65B0\7684\968E\6BB5\4F5C\696D (\4F8B\5982\4E0B\6B21\767B\5165\6642) \6642\770B\5230\9019\500B\8B8A\66F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110170168397314288)
,p_name=>'CA.HELP.HOME.FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\5728\61C9\7528\7A0B\5F0F\7684\4EFB\4F55\9801\9762\4E2D, \6309\4E00\4E0B\5C0E\89BD\5217\7684\300C\610F\898B\56DE\994B\300D\5716\793A ( <span class="fa fa-comment-o" aria-hidden="true"></span> ), \5373\53EF\7559\4E0B\8981\7D66\61C9\7528\7A0B\5F0F\7BA1\7406\54E1\7684\610F\898B\56DE\994B.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110169880817314288)
,p_name=>'CA.HELP.HOME.MAIN.SIDE.MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\9019\662F\61C9\7528\7A0B\5F0F\7684\9996\9801. \60A8\53EF\4EE5\6309\4E00\4E0B\5361\7247\6216\4F7F\7528\9801\9762\5074\908A\7684\5C0E\89BD\529F\80FD\8868, \4F86\5B58\53D6\61C9\7528\7A0B\5F0F\7684\4E0D\540C\9801\9762.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110170037071314288)
,p_name=>'CA.HELP.HOME.MAIN.TOP.MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\9019\662F\61C9\7528\7A0B\5F0F\7684\9996\9801. \60A8\53EF\4EE5\6309\4E00\4E0B\5361\7247\6216\4F7F\7528\9801\9762\9802\7AEF\7684\5C0E\89BD\529F\80FD\8868, \4F86\5B58\53D6\61C9\7528\7A0B\5F0F\7684\4E0D\540C\9801\9762.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110170251555314288)
,p_name=>'CA.HELP.HOME.SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\5728\6B64\9801\9762\7684<strong>\641C\5C0B\61C9\7528\7A0B\5F0F</strong>\6B04\4F4D\8F38\5165\641C\5C0B\8A5E, \6216\5728\4EFB\4F55\9801\9762\6309\4E00\4E0B\5C0E\89BD\5217\4E0A\7684\300C\641C\5C0B\300D\5716\793A ( <span class="fa fa-search" aria-hidden="true"></span> ), \5373\53EF\641C\5C0B\61C9\7528\7A0B\5F0F\4E2D\7684\5B57\8A5E.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110170570532314288)
,p_name=>'CA.HELP.HOME.SIGN.OUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6309\4E00\4E0B\5C0E\89BD\5217\4E0A\7684\540D\7A31\4E0B\62C9\5F0F\6E05\55AE, \5373\53EF\767B\51FA\61C9\7528\7A0B\5F0F.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110170484419314288)
,p_name=>'CA.HELP.HOME.TIME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6309\4E00\4E0B\5C0E\89BD\5217\4E2D\7684\4F7F\7528\8005\529F\80FD\8868 ( <span class="fa fa-user" aria-hidden="true"></span> ), \5373\53EF\66F4\65B0\6642\5340\504F\597D\8A2D\5B9A\53CA\767B\51FA\61C9\7528\7A0B\5F0F.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110169956831314288)
,p_name=>'CA.HELP.HOME.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110170635419314288)
,p_name=>'CA.HELP.HOME.USER'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6309\4E00\4E0B\9801\9762\53F3\4E0A\89D2\5C0E\89BD\5217\4E2D\7684\4F7F\7528\8005\529F\80FD\8868 ( <span class="fa fa-user" aria-hidden="true"></span> ), \5373\53EF\5B58\53D6\4F7F\7528\8005\8A2D\5B9A\6A94\53CA\767B\51FA\61C9\7528\7A0B\5F0F.<br>'),
unistr('\4F9D\5E8F\6309\4E00\4E0B<strong>\6AA2\8996\6211\7684\8A2D\5B9A\6A94</strong>\548C<strong>\66F4\65B0\8A2D\5B9A\6A94</strong>, \5373\53EF\8F38\5165\500B\4EBA\8A73\7D30\8CC7\8A0A\53CA\4E0A\50B3\76F8\7247\6216\5927\982D\8CBC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110170399993314288)
,p_name=>'CA.HELP.HOME.USER.TIME'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6309\4E00\4E0B\5C0E\89BD\5217\4E2D\7684\4F7F\7528\8005\529F\80FD\8868 ( <span class="fa fa-user" aria-hidden="true"></span> ), \5373\53EF\5B58\53D6\60A8\7684\4F7F\7528\8005\8A2D\5B9A\6A94\3001\66F4\65B0\6642\5340\504F\597D\8A2D\5B9A\53CA\767B\51FA\61C9\7528\7A0B\5F0F.<br>'),
unistr('\4F9D\5E8F\6309\4E00\4E0B<strong>\6AA2\8996\6211\7684\8A2D\5B9A\6A94</strong>\548C<strong>\66F4\65B0\8A2D\5B9A\6A94</strong>, \5373\53EF\8F38\5165\500B\4EBA\8A73\7D30\8CC7\8A0A\53CA\4E0A\50B3\76F8\7247\6216\5927\982D\8CBC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110196498900314309)
,p_name=>'CA.HELP.IG.PAGE.READONLY'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\82E5\8981\5C0B\627E\8CC7\6599, \8ACB\5728\300C\641C\5C0B\300D\5C0D\8A71\65B9\584A\4E2D\8F38\5165\641C\5C0B\8A5E; \60A8\4E5F\53EF\4EE5\6309\4E00\4E0B\8CC7\6599\6B04\6A19\984C\4F86\9650\5236\50B3\56DE\7684\8A18\9304.</p>'),
'',
unistr('<p>\6309\4E00\4E0B<strong>\52D5\4F5C</strong>\6309\9215\53EF\57F7\884C\591A\7A2E\529F\80FD, \5305\62EC\9078\53D6\986F\793A / \96B1\85CF\7684\8CC7\6599\6B04, \53CA\5176\986F\793A\9806\5E8F\8207\57F7\884C\591A\7A2E\8CC7\6599\8207\683C\5F0F\529F\80FD.  \60A8\9084\53EF\4EE5\4F7F\7528\5716\8868\9078\9805\5B9A\7FA9\8CC7\6599\7684\5176\4ED6\6AA2\8996.</p>'),
'',
unistr('<p>\82E5\8981\5132\5B58\81EA\8A02\9805\76EE, \8ACB\9078\53D6\300C\5831\8868\300D; \60A8\4E5F\53EF\4EE5\6309\4E00\4E0B\300C\4E0B\8F09\300D\4F86\5378\8F09\8CC7\6599.<p>'),
'<br>',
unistr('<p>\5982\9700\5176\4ED6\8CC7\8A0A, \8ACB\6309\4E00\4E0B\300C\52D5\4F5C\300D\529F\80FD\8868\5E95\90E8\7684\300C\8AAA\660E\300D.</p>'),
'',
unistr('<p>\6309\4E00\4E0B<strong>\91CD\8A2D</strong>\6309\9215\5373\53EF\5C07\4E92\52D5\5F0F\5831\8868\91CD\8A2D\56DE\9810\8A2D\503C.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110196340262314309)
,p_name=>'CA.HELP.IG.PAGE.UPDATABLE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\76F4\63A5\5728\6B64\4E92\52D5\5F0F\65B9\683C\5167\63D2\5165\3001\66F4\65B0\53CA\522A\9664\8CC7\6599.<br>'),
unistr('  \82E5\8981\63D2\5165\65B0\8CC7\6599\5217, \8ACB\6309\4E00\4E0B\300C\65B0\589E\8CC7\6599\5217\300D\6309\9215.<br>'),
unistr('  \5728\5132\5B58\683C\4E2D\6309\5169\4E0B\6216\6309\4E00\4E0B<strong>\7DE8\8F2F</strong>\6309\9215, \5373\53EF\66F4\65B0\8CC7\6599\503C, \65B9\6CD5\8207\5728\8A66\7B97\8868\4E2D\7DE8\8F2F\8CC7\6599\76F8\4F3C.</p>'),
'',
unistr('<p>\4F7F\7528\5831\8868\9802\7AEF\7684\300C\8CC7\6599\5217\52D5\4F5C\300D\529F\80FD\8868 (<span class="fa fa-bars" aria-hidden="true"></span>) \53EF\8907\88FD\3001\522A\9664\3001\91CD\65B0\6574\7406\6216\56DE\5FA9\9078\53D6\7684\8CC7\6599\5217.<br> '),
unistr('  \60A8\4E5F\53EF\4EE5\4F7F\7528\500B\5225\8CC7\6599\5217\7684\300C\8CC7\6599\5217\52D5\4F5C\300D\529F\80FD\8868, \5B58\53D6\55AE\4E00\8CC7\6599\5217\6AA2\8996\6216\65B0\589E\8CC7\6599\5217.</p>'),
'',
unistr('<p>\82E5\8981\5C0B\627E\8CC7\6599, \8ACB\5728\300C\641C\5C0B\300D\5C0D\8A71\65B9\584A\4E2D\8F38\5165\641C\5C0B\8A5E; \4E5F\53EF\4EE5\6309\4E00\4E0B\8CC7\6599\6B04\6A19\984C\4F86\9650\5236\50B3\56DE\7684\8A18\9304.</p>'),
'',
unistr('<p>\82E5\8981\57F7\884C\591A\7A2E\529F\80FD, \53EF\4EE5\6309\4E00\4E0B<strong>\52D5\4F5C</strong>\6309\9215, \5305\62EC\9078\53D6\986F\793A/\96B1\85CF\7684\8CC7\6599\6B04, \8207\5176\986F\793A\9806\5E8F\4EE5\53CA\57F7\884C\591A\7A2E\8CC7\6599\548C\683C\5F0F\529F\80FD.  \60A8\4E5F\53EF\4EE5\4F7F\7528\5716\8868\9078\9805\5B9A\7FA9\8CC7\6599\7684\5176\4ED6\6AA2\8996.</p>'),
'',
unistr('<p>\82E5\8981\5132\5B58\81EA\8A02\9805\76EE, \8ACB\9078\53D6\5831\8868, \6216\8005\6309\4E00\4E0B\300C\4E0B\8F09\300D\4F86\5378\8F09\8CC7\6599.<p>'),
'',
unistr('<p>\5982\9700\5176\4ED6\8CC7\8A0A, \8ACB\6309\4E00\4E0B\300C\52D5\4F5C\300D\529F\80FD\8868\5E95\7AEF\7684\300C\8AAA\660E\300D.</p> '),
'',
unistr('<p>\6309\4E00\4E0B<strong>\91CD\8A2D</strong>\6309\9215\5373\53EF\5C07\4E92\52D5\5F0F\65B9\683C\91CD\8A2D\56DE\9810\8A2D\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110169790841314287)
,p_name=>'CA.HELP.IR.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\82E5\8981\5C0B\627E\8CC7\6599, \8ACB\5728\300C\641C\5C0B\300D\5C0D\8A71\65B9\584A\4E2D\8F38\5165\641C\5C0B\8A5E; \60A8\4E5F\53EF\4EE5\6309\4E00\4E0B\8CC7\6599\6B04\6A19\984C\4F86\9650\5236\50B3\56DE\7684\8A18\9304.</p>'),
'',
unistr('<p>\6309\4E00\4E0B<strong>\52D5\4F5C</strong>\6309\9215\53EF\57F7\884C\591A\7A2E\529F\80FD, \5305\62EC\9078\53D6\986F\793A / \96B1\85CF\7684\8CC7\6599\6B04\53CA\5176\986F\793A\9806\5E8F\8207\57F7\884C\591A\7A2E\8CC7\6599\8207\683C\5F0F\529F\80FD.  \60A8\9084\53EF\4EE5\4F7F\7528\300C\5716\8868\300D\3001\300C\7FA4\7D44\65B9\5F0F\300D\548C\300C\6A1E\7D10\5206\6790\8868\300D\9078\9805\5B9A\7FA9\8CC7\6599\7684\5176\4ED6\6AA2\8996.</p>'),
'',
unistr('<p>\5982\679C\60A8\60F3\5132\5B58\81EA\8A02\9078\53D6\5831\8868, \8ACB\6309\4E00\4E0B\300C\4E0B\8F09\300D\4EE5\5378\8F09\8CC7\6599. \8ACB\5728\300C\8A02\95B1\300D\4E0B\65B9\8F38\5165\60A8\7684\96FB\5B50\90F5\4EF6\5730\5740\548C\6642\9593\7BC4\570D, \4EE5\4FBF\5B9A\671F\50B3\9001\8CC7\6599\7D66\60A8.<p>'),
'',
unistr('<p>\5982\9700\5176\4ED6\8CC7\8A0A, \8ACB\6309\4E00\4E0B\300C\52D5\4F5C\300D\529F\80FD\8868\5E95\90E8\7684\300C\8AAA\660E\300D.</p>'),
'',
unistr('<p>\6309\4E00\4E0B<strong>\91CD\8A2D</strong>\6309\9215\5373\53EF\5C07\4E92\52D5\5F0F\5831\8868\91CD\8A2D\56DE\9810\8A2D\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110204359766314319)
,p_name=>'CA.HELP.MD.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\5831\8868\9801\9762\6703\5728\9801\9762\5074\908A\986F\793A\9078\53D6\5668\4E2D\7684\4E3B\8981\8A18\9304. '),
unistr('  \9078\53D6\4E00\7B46\8A18\9304\5373\53EF\67E5\770B\4E3B\8981\8A18\9304\548C\5B9A\7FA9\7684\6240\6709\660E\7D30\8A18\9304.<br> '),
unistr('  \6309\4E00\4E0B\7DE8\8F2F\5716\793A ( <span class="fa fa-pencil-square-o" aria-hidden="true"></span> ) \5373\53EF\7DE8\8F2F\4E3B\8981\8A18\9304.'),
unistr('  \81F3\65BC\660E\7D30\8A18\9304, \6309\4E00\4E0B\6BCF\500B\8CC7\6599\5217\958B\982D\8655\7684\925B\7B46\5716\793A, \5373\53EF\7DE8\8F2F\8A72\7B46\8A18\9304.</p>'),
unistr('<p>\82E5\8981\9650\5236\9078\53D6\5668\4E2D\986F\793A\7684\8CC7\6599, \8ACB\5728\641C\5C0B\5C0D\8A71\65B9\584A\4E2D\8F38\5165\641C\5C0B\8A5E.</p>'),
'',
unistr('<p>\82E5\8981\65B0\589E\4E3B\8981\8A18\9304, \8ACB\6309\4E00\4E0B\9801\9762\9802\7AEF\7684<strong>\5EFA\7ACB</strong>.'),
unistr('  \81F3\65BC\660E\7D30\8A18\9304, \8ACB\6309\4E00\4E0B\660E\7D30\5340\57DF\9802\7AEF\7684\52A0\865F\5716\793A (+), \5373\53EF\65B0\589E\660E\7D30\8A18\9304.</p>'),
'',
unistr('<p>\6309\4E00\4E0B\9801\9762\9802\7AEF\7684<strong>\91CD\8A2D</strong>\5373\53EF\5C07\9801\9762\91CD\8A2D\56DE\9810\8A2D\503C, \56E0\800C\79FB\9664\5148\524D\5B9A\7FA9\7684\6240\6709\641C\5C0B\8A5E.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110167721809314286)
,p_name=>'CA.HELP.P10000.ADMINISTRATION.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7BA1\7406\9801\9762\53EF\8B93\61C9\7528\7A0B\5F0F\64C1\6709\8005 (\7BA1\7406\54E1) \8A2D\5B9A\61C9\7528\7A0B\5F0F, \4E26\7DAD\8B77\7528\65BC\6574\500B\61C9\7528\7A0B\5F0F\7684\4E00\822C\8CC7\6599.'),
unistr('\9078\53D6\5176\4E2D\4E00\500B\53EF\7528\8A2D\5B9A\503C\5F8C, \7BA1\7406\54E1\5C31\80FD\8B8A\66F4\61C9\7528\7A0B\5F0F\7684\986F\793A\65B9\5F0F\548C (\6216) \4E00\822C\4F7F\7528\8005\53EF\7528\7684\529F\80FD.</p>'),
unistr('<p>\6B64\9801\9762\50C5\4F9B\7BA1\7406\54E1\5B58\53D6.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110168974041314287)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.CONFIGURE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\4EFB\4F55\9069\7576\7684\5DF2\8A8D\8B49\4F7F\7528\8005.<br>'),
unistr('\5982\679C\9078\53D6<strong>\5426</strong>, \5247\53EA\6709\6307\5B9A\7684\4F7F\7528\8005\80FD\5920\5B58\53D6\6B64\61C9\7528\7A0B\5F0F, \9019\9EBC\505A\6709\52A9\65BC\63D0\9AD8\61C9\7528\7A0B\5F0F\7684\5B89\5168\6027.'),
unistr('\4E0D\904E, \5047\5982\61C9\7528\7A0B\5F0F\7684\4F7F\7528\8005\6578\91CF\5F88\591A\4E14\96E3\4EE5\7DAD\8B77, \5EFA\8B70\60A8\9078\64C7<strong>\662F</strong>, \4E26\53EA\8F38\5165\61C9\7528\7A0B\5F0F\7BA1\7406\54E1\548C\63D0\4F9B\8005 (\9078\64C7\6027).<br>'),
unistr('\5982\679C\60A8\9078\53D6<strong>\662F</strong>, \9084\5FC5\9808\9078\53D6\8981\5982\4F55\8655\7406\4E0D\5728\4F7F\7528\8005\6E05\55AE\4E2D\7684\4F7F\7528\8005.</p>'),
unistr('<p>\9078\53D6\5FC5\9808\63D0\4F9B\96FB\5B50\90F5\4EF6\5730\5740\6216\4F7F\7528\8005\540D\7A31 (\4EFB\4F55\6587\6578\5B57\503C).<br>'),
unistr('\4E00\822C\4F86\8AAA, \5982\679C\61C9\7528\7A0B\5F0F\63A1\7528 (\6216\5C07\8A2D\70BA\63A1\7528) Oracle Access Manager \6216 SSO \7B49\96C6\4E2D\5F0F\8A8D\8B49\914D\7F6E, \8ACB\52D9\5FC5\5C07\6B64\8A2D\5B9A\8A2D\70BA<strong>\96FB\5B50\90F5\4EF6\5730\5740</strong>.</p>'),
unistr('<p><em><strong>\6CE8\610F:</strong> \6B64\61C9\7528\7A0B\5F0F\652F\63F4\4E0B\5217 3 \7A2E\5B58\53D6\5C64\7D1A: \95B1\8B80\8005\3001\63D0\4F9B\8005\548C\7BA1\7406\54E1.'),
'<ul>',
unistr('  <li><strong>\95B1\8B80\8005</strong>: \5177\5099\6240\6709\8CC7\8A0A\7684\552F\8B80\5B58\53D6, \800C\4E14\53EF\4EE5\6AA2\8996\5831\8868.</li>'),
unistr('  <li><strong>\63D0\4F9B\8005</strong>: \53EF\5EFA\7ACB\3001\7DE8\8F2F\53CA\522A\9664\8CC7\8A0A\53CA\6AA2\8996\5831\8868.</li>'),
unistr('  <li><strong>\7BA1\7406\54E1</strong>: \4E0D\4F46\5177\5099\300C\63D0\4F9B\8005\300D\529F\80FD, \9084\80FD\5B58\53D6\61C9\7528\7A0B\5F0F\7684\300C\7BA1\7406\300D\5340\6BB5\4EE5\57F7\884C\61C9\7528\7A0B\5F0F\7D44\614B.</li>'),
'</ul>',
'</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110169170785314287)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.USERS.FORM'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\6B64\8868\55AE\4E2D\8F38\5165\4F7F\7528\8005\3001\4F7F\7528\8005\96FB\5B50\90F5\4EF6\5730\5740\4E26\8A2D\5B9A\5176\5B58\53D6\5C64\7D1A.'),
unistr('\9019\500B\5728<em>\8A2D\5B9A\5B58\53D6\63A7\5236</em>\5E95\4E0B\5B9A\7FA9\7684\8A2D\5B9A\503C\6703\6C7A\5B9A\4F7F\7528\8005\540D\7A31\5FC5\9808\4F7F\7528\96FB\5B50\90F5\4EF6\5730\5740\6216\4EFB\4F55\6587\6578\5B57\503C.</p>'),
unistr('<p>\6B64\61C9\7528\7A0B\5F0F\652F\63F4\4E0B\5217 3 \500B\5B58\53D6\5C64\7D1A: \95B1\8B80\8005\3001\63D0\4F9B\8005\548C\7BA1\7406\54E1.</p>'),
'<ul>',
unistr('  <li><strong>\95B1\8B80\8005</strong>: \5177\5099\6240\6709\8CC7\8A0A\7684\552F\8B80\5B58\53D6, \800C\4E14\53EF\4EE5\6AA2\8996\5831\8868.</li>'),
unistr('  <li><strong>\63D0\4F9B\8005</strong>: \53EF\5EFA\7ACB\3001\7DE8\8F2F\53CA\522A\9664\8CC7\8A0A\53CA\6AA2\8996\5831\8868.</li>'),
unistr('  <li><strong>\7BA1\7406\54E1</strong>: \4E0D\4F46\5177\5099\300C\63D0\4F9B\8005\300D\529F\80FD, \9084\80FD\5B58\53D6\61C9\7528\7A0B\5F0F\7684\300C\7BA1\7406\300D\5340\6BB5\4EE5\57F7\884C\61C9\7528\7A0B\5F0F\7D44\614B.</li>'),
'</ul>',
unistr('<p>\7DE8\8F2F\73FE\6709\4F7F\7528\8005\6642, \60A8\53EF\4EE5\9396\5B9A\5C0D\65B9\7684\5E33\6236, \907F\514D\4ED6\5011\5B58\53D6\61C9\7528\7A0B\5F0F.</p>'),
unistr('<p><em><strong>\6CE8\610F:</strong>   \5982\679C\4F7F\7528 Oracle Application Express \5E33\6236, \5728\6B64\8655\8F38\5165\7684\4F7F\7528\8005\4E5F\5FC5\9808\7531\5DE5\4F5C\5340\7BA1\7406\54E1\5B9A\7FA9\70BA\4E00\822C\4F7F\7528\8005, \4E14\5DE5\4F5C\5340\7BA1\7406\54E1\4E5F\53EF\4EE5\8A2D\5B9A\4ED6\5011\7684\5BC6\78BC.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110169000792314287)
,p_name=>'CA.HELP.P10110.ACCESS.CONTROL.USERS.REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9019\500B\9801\9762\986F\793A\61C9\7528\7A0B\5F0F\4F7F\7528\8005\548C\6240\6388\4E88\5B58\53D6\5C64\7D1A\7684\5831\8868.</p>'),
unistr('<p>\6309\4E00\4E0B\8CC7\6599\6B04\6A19\984C, \5373\53EF\6392\5E8F\4E26\7BE9\9078\8CC7\6599; \6309\4E00\4E0B<strong>\52D5\4F5C</strong>\6309\9215, \5373\53EF\81EA\8A02\986F\793A\7684\8CC7\6599\6B04\53CA\57F7\884C\591A\7A2E\5176\4ED6\9032\968E\529F\80FD.<br>'),
unistr('\6309\4E00\4E0B<strong>\91CD\8A2D</strong>\6309\9215, \5373\53EF\5C07\4E92\52D5\5F0F\5831\8868\91CD\8A2D\56DE\9810\8A2D\503C.</p>'),
unistr('<p>\6309\4E00\4E0B\300C\7DE8\8F2F\300D\5716\793A (\9EC3\8272\925B\7B46), \5373\53EF\7DE8\8F2F\4F7F\7528\8005\8A73\7D30\8CC7\8A0A\548C\5B58\53D6\5C64\7D1A\6216\522A\9664\4F7F\7528\8005.</p>'),
unistr('<p>\6309\4E00\4E0B\5831\8868\9802\7AEF\7684<strong>\65B0\589E\4F7F\7528\8005</strong>, \5373\53EF\65B0\589E\4F7F\7528\8005\53CA\5176\5B58\53D6\5C64\7D1A.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110182548170314297)
,p_name=>'CA.HELP.P10120.ACCESS.ROLE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\555F\7528\5B58\53D6\63A7\5236, \7BA1\7406\54E1\5C31\80FD\9650\5236\5DF2\8A8D\8B49\4F7F\7528\8005\5C0D\67D0\4E9B\61C9\7528\7A0B\5F0F\529F\80FD\7684\5B58\53D6. \6B64\61C9\7528\7A0B\5F0F\652F\63F4\4E0B\5217 3 \7A2E\89D2\8272: \95B1\8B80\8005\3001\63D0\4F9B\8005\4EE5\53CA\7BA1\7406\54E1.<p>'),
'<ul>',
unistr('  <li><strong>\95B1\8B80\8005</strong>: \5C0D\6240\6709\8CC7\8A0A\6709\552F\8B80\5B58\53D6\6B0A, \800C\4E14\53EF\4EE5\6AA2\8996\5831\8868.</li>'),
unistr('  <li><strong>\63D0\4F9B\8005</strong>: \53EF\5EFA\7ACB\3001\7DE8\8F2F\53CA\522A\9664\8CC7\8A0A, \4EE5\53CA\6AA2\8996\5831\8868.</li>'),
unistr('  <li><strong>\7BA1\7406\54E1</strong>: \9664\4E86\5177\5099\300C\63D0\4F9B\8005\300D\6B0A\9650\4E4B\5916, \9084\80FD\57F7\884C\61C9\7528\7A0B\5F0F\7D44\614B\8A2D\5B9A.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110203453028314318)
,p_name=>'CA.HELP.P10140_PRELIM_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4EE5\9017\865F\3001\5206\865F\6216\7A7A\767D\5B57\5143\5340\9694\7684\4F7F\7528\8005\540D\7A31. \73FE\6709\6216\91CD\8907\7684\4F7F\7528\8005\540D\7A31\5C07\6703\81EA\52D5\5FFD\7565.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110167968897314286)
,p_name=>'CA.HELP.P10200.CONFIGURATION.SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7D44\614B\8A2D\5B9A\503C\53EF\8B93\60A8\5C07\7279\5B9A\529F\80FD\8A2D\70BA\4E00\822C\8005\53EF\4EE5\4F7F\7528 (\555F\7528) \6216\4E0D\53EF\4F7F\7528 (\505C\7528).</p>'),
unistr('<p>\5982\679C\7279\5B9A\529F\80FD\5C1A\672A\5B8C\5168\6E96\5099\5C31\7DD2\6216\9700\8981\66AB\6642\79FB\9664, \8ACB\6309\4E00\4E0B<strong>\505C\7528</strong>.'),
unistr('\5982\679C\529F\80FD\5DF2\53EF\4F9B\4F7F\7528, \53EA\8981\6309\4E00\4E0B<strong>\555F\7528</strong>\5373\53EF.</p>'),
unistr('<p><em><strong>\6CE8\610F:</strong> \6B64\8655\6240\505A\7684\8B8A\66F4\4E0D\6703\53CD\6620\5728\4E00\822C\4F7F\7528\8005\76EE\524D\57F7\884C\7684\61C9\7528\7A0B\5F0F\4E2D. \4E00\822C\4F7F\7528\8005\767B\51FA\4E26\91CD\65B0\767B\5165\5F8C, \7CFB\7D71\624D\6703\547C\53EB\5DF2\4FEE\6B63\7684\529F\80FD\8A2D\5B9A\503C.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110168087426314286)
,p_name=>'CA.HELP.P10300.THEME.SELECTOR'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\7528\65BC\986F\793A\61C9\7528\7A0B\5F0F\7684\9810\8A2D\8272\5F69\914D\7F6E.</p>'),
unistr('<p>\52FE\9078<strong>\5141\8A31\4E00\822C\4F7F\7528\8005\9078\64C7\4E3B\984C\6A23\5F0F</strong>\5F8C, \6BCF\500B\4F7F\7528\8005\53EA\8981\6309\4E00\4E0B\9996\9801\5DE6\4E0B\89D2\7684<em>\81EA\8A02</em>\9023\7D50, \5373\53EF\5F9E\53EF\7528\7684\4E3B\984C\6A23\5F0F\4E2D\9078\53D6\6240\9700\6A23\5F0F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110168697882314287)
,p_name=>'CA.HELP.P10400.ACTIVITY.REPORTING.ERROR.LOG'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9019\500B\9801\9762\63D0\4F9B\6B64\61C9\7528\7A0B\5F0F\8A18\9304\7684\6240\6709\672A\9810\671F\932F\8AA4\7684\4E92\52D5\5F0F\5831\8868.</p>'),
unistr('<p>\6309\4E00\4E0B\8CC7\6599\6B04\6A19\984C\5373\53EF\6392\5E8F\4E26\7BE9\9078\8CC7\6599; \6309\4E00\4E0B<strong>\52D5\4F5C</strong>\6309\9215\53EF\81EA\8A02\986F\793A\7684\8CC7\6599\6B04\53CA\57F7\884C\591A\7A2E\5176\4ED6\9032\968E\529F\80FD. \6309\4E00\4E0B<strong>\91CD\8A2D</strong>\6309\9215\5373\53EF\5C07\4E92\52D5\5F0F\5831\8868\91CD\8A2D\56DE\9810\8A2D\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110168509356314287)
,p_name=>'CA.HELP.P10500.ACTIVITY.REPORTING.TOP.USERS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\5831\8868\548C\5716\8868\4F86\67E5\770B\6307\5B9A\6642\9593\7BC4\570D\5167\9801\9762\6AA2\8996\6B21\6578\6700\591A\7684\4F7F\7528\8005.</p>'),
unistr('<p>\9078\53D6\9801\9762\9802\7AEF\7684\5831\8868\6642\9593\7BC4\570D (\9810\8A2D\503C = 1 \5929) \4E26\9078\64C7\5831\8868\548C\5716\8868\5716\793A.</p>'),
unistr('<p>\5982\679C\60A8\4F7F\7528\7684\662F\4E92\52D5\5F0F\5831\8868, \8ACB\4F7F\7528\641C\5C0B\6B04\4F4D\6216\9078\53D6<strong>\4F7F\7528\8005</strong>\8CC7\6599\6B04\6A19\984C, \4EE5\9078\53D6\7279\5B9A\4F7F\7528\8005. \60A8\53EA\8981\6309\4E00\4E0B<strong>\52D5\4F5C</strong>\6309\9215, \5373\53EF\57F7\884C\986F\793A / \96B1\85CF\8CC7\6599\6B04\3001\6BCF\9801\8CC7\6599\5217\6578\548C\7BE9\9078\7B49\591A\7A2E\529F\80FD. \6309\4E00\4E0B<strong>\91CD\8A2D</strong>\6309\9215\5373\53EF\5C07\4E92\52D5\5F0F\5831\8868\91CD\8A2D\56DE\9810\8A2D\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110168748959314287)
,p_name=>'CA.HELP.P10510.ACTIVITY.REPORTING.PERFORMANCE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9019\500B\9801\9762\63D0\4F9B\9801\9762\6548\80FD\548C\4F7F\7528\6B21\6578\7684\4E92\52D5\5F0F\5831\8868. \6B64\5831\8868\662F\4F9D<strong>\52A0\6B0A\6548\80FD</strong> (\4E2D\9593\503C\7D93\6B77\6642\9593\8207\9801\9762\6AA2\8996\6B21\6578\7684\4E58\7A4D) \6392\5E8F.</p>'),
unistr('<p>\8996\9700\8981\9078\53D6\9801\9762\9802\7AEF\7684\5831\8868\6642\9593\7BC4\570D (\9810\8A2D\503C = 1 \5929).<br>'),
unistr('\6309\4E00\4E0B\8CC7\6599\6B04\6A19\984C, \5373\53EF\6392\5E8F\4E26\7BE9\9078\8CC7\6599; \6309\4E00\4E0B<strong>\52D5\4F5C</strong>\6309\9215, \5373\53EF\81EA\8A02\986F\793A\7684\8CC7\6599\6B04\53CA\57F7\884C\591A\7A2E\5176\4ED6\9032\968E\529F\80FD. \6309\4E00\4E0B<strong>\91CD\8A2D</strong>\6309\9215, \5373\53EF\5C07\4E92\52D5\5F0F\5831\8868\91CD\8A2D\56DE\9810\8A2D\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110168804158314287)
,p_name=>'CA.HELP.P10520.ACTIVITY.REPORTING.VIEWS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9019\500B\9801\9762\63D0\4F9B\6700\8FD1\9801\9762\6AA2\8996\72C0\6CC1\7684\4E92\52D5\5F0F\5831\8868.</p>'),
unistr('<p>\8996\9700\8981\9078\53D6\9801\9762\9802\7AEF\7684\5831\8868\6642\9593\7BC4\570D (\9810\8A2D\503C = 1 \5929).<br>'),
unistr('\6309\4E00\4E0B\8CC7\6599\6B04\6A19\984C\5373\53EF\6392\5E8F\4E26\7BE9\9078\8CC7\6599; \6309\4E00\4E0B<strong>\52D5\4F5C</strong>\6309\9215\53EF\81EA\8A02\986F\793A\7684\8CC7\6599\6B04\53CA\57F7\884C\591A\7A2E\5176\4ED6\9032\968E\529F\80FD. \6309\4E00\4E0B<strong>\91CD\8A2D</strong>\6309\9215\5373\53EF\5C07\4E92\52D5\5F0F\5831\8868\91CD\8A2D\56DE\9810\8A2D\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110167852538314286)
,p_name=>'CA.HELP.P10600.NOTIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F5C\7528\4E2D\7684\901A\77E5\6703\986F\793A\5728\9996\9801\4E0A.</p>'),
unistr('<p>\6B64\5831\8868\6703\986F\793A\5DF2\5B9A\7FA9\7684\901A\77E5\53CA\5176\986F\793A\671F\9593.</p>'),
unistr('<p>\6309\4E00\4E0B\300C\7DE8\8F2F\300D\5716\793A (\9EC3\8272\925B\7B46) \5373\53EF\7DE8\8F2F\73FE\6709\901A\77E5; \6309\4E00\4E0B<strong>\65B0\589E\901A\77E5</strong>\5373\53EF\63D2\5165\65B0\901A\77E5.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110168151488314286)
,p_name=>'CA.HELP.P10700.APPLICATION.SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\61C9\7528\7A0B\5F0F\7684\540D\7A31\548C\7C21\8981\63CF\8FF0.</p>'),
unistr('<p>\61C9\7528\7A0B\5F0F\540D\7A31\6703\986F\793A\5728\9996\9801\4E2D. \7C21\8981\63CF\8FF0\6703\986F\793A\5728\61C9\7528\7A0B\5F0F\540D\7A31\4E0B\65B9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110168313889314286)
,p_name=>'CA.HELP.P10920.FEEDBACK.REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E00\822C\4F7F\7528\8005\53EF\4EE5\5728\61C9\7528\7A0B\5F0F\7684\4EFB\4F55\4E00\822C\9801\9762\4E2D\8F38\5165\610F\898B\56DE\994B.</p>'),
unistr('<p>\6B64\5831\8868\986F\793A\5DF2\8F38\5165\7684\610F\898B\56DE\994B\3001\7BA1\7406\54E1\8F38\5165\7684\4EFB\4F55\56DE\61C9\548C\610F\898B\56DE\994B\72C0\614B.</p>'),
unistr('<p>\6309\4E00\4E0B\300C\7DE8\8F2F\300D\5716\793A (\9EC3\8272\925B\7B46) \5373\53EF\8F38\5165\56DE\61C9\6216\66F4\65B0\610F\898B\56DE\994B\72C0\614B.</p>'),
unistr('<p><em><strong>\6CE8\610F:</strong> \5982\679C\60A8\5DF2\5B9A\7FA9\610F\898B\56DE\994B\6536\4EF6\8005, \7CFB\7D71\4E5F\6703\5C07\9001\51FA\7684\610F\898B\56DE\994B\900F\904E\96FB\5B50\90F5\4EF6, \50B3\9001\5230\610F\898B\56DE\994B\6536\4EF6\8005\6E05\55AE\4E2D\7684\96FB\5B50\90F5\4EF6\5730\5740.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110184407815314300)
,p_name=>'CA.HELP.P10940.COMMA.SEP.EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\96FB\5B50\90F5\4EF6\5730\5740\6E05\55AE (\4EE5\9017\865F\5340\9694)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110168406810314286)
,p_name=>'CA.HELP.P10940.FEEDBACK.SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p><strong>\555F\7528\9644\4EF6</strong> - \5982\679C\555F\7528, \4F7F\7528\8005\5C07\53EF\4E0A\50B3\652F\6301\610F\898B\56DE\994B\7684\9644\4EF6.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110169454854314287)
,p_name=>'CA.HELP.P11000.EMAIL.TEMPLATES.REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\9801\9762\5217\51FA\5DF2\5B9A\7FA9\7684\96FB\5B50\90F5\4EF6\6A23\677F, \4EE5\53CA\6A23\677F\5728\5DF2\50B3\9001\96FB\5B50\90F5\4EF6\4E2D\53C3\7167\7684\6B21\6578.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110169273612314287)
,p_name=>'CA.HELP.P11010.EMAIL.LOG'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\9801\9762\5217\51FA\5DF2\50B3\9001\7684\96FB\5B50\90F5\4EF6.</p>'),
unistr('<p>\6309\4E00\4E0B\300C\653E\5927\93E1\300D\5716\793A\5373\53EF\6AA2\8996\5DF2\50B3\9001\96FB\5B50\90F5\4EF6\7684\8A73\7D30\8CC7\8A0A.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110169332714314287)
,p_name=>'CA.HELP.P11020.EMAIL.TEMPLATES.FORM.EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\4E0B\5217\6B04\4F4D\4E2D\8F38\5165\503C, \4EE5\5B9A\7FA9\96FB\5B50\90F5\4EF6\6A23\677F:</p>'),
'<ul>',
unistr('  <li><strong>\6A23\677F\540D\7A31</strong> (\5FC5\8981) - \8F38\5165\6709\610F\7FA9\7684\6A23\677F\540D\7A31.</li>'),
unistr('  <li><strong>HTML \6A23\677F</strong> (\5FC5\8981) - \8F38\5165\5EFA\69CB\50B3\9001\7D66\6536\4EF6\8005\4E4B\96FB\5B50\90F5\4EF6\7684 HTML \7A0B\5F0F\78BC, \4EE5\50B3\905E HTML \578B\7684\96FB\5B50\90F5\4EF6.'),
unistr('    \66FF\4EE3\503C\5305\62EC:'),
'    <ul>',
unistr('        <li><strong>#APP_NAME#</strong> - \5C07\53D6\4EE3\70BA\61C9\7528\7A0B\5F0F\7684\540D\7A31</li>'),
unistr('        <li><strong>#BODY1#</strong> - \5C07\53D6\4EE3\70BA\50B3\5165\7684 p_body1_text \503C</li> '),
unistr('        <li><strong>#TABLE#</strong> - \5C07\53D6\4EE3\70BA\50B3\5165\7684 p_table_content \503C, \4F7F\7528\8868\683C\958B\555F HTML\3001\8868\683C\8CC7\6599\5217 HTML \4EE5\53CA\8868\683C\95DC\9589 HTML</li> '),
unistr('        <li><strong>#BODY2#</strong> - \5C07\53D6\4EE3\70BA\50B3\5165\7684 p_body2_text \503C</li> '),
unistr('        <li><strong>#ACTION#</strong> - \5C07\53D6\4EE3\70BA\50B3\5165\7684 p_action_label \548C p_action_link \503C, \4F7F\7528\300C\52D5\4F5C\9023\7D50\300D\6A23\677F</li>'),
'     </ul></li>',
unistr('  <li><strong>\7D14\6587\5B57\6A23\677F</strong> (\5FC5\8981) - \8F38\5165\5EFA\69CB\96FB\5B50\90F5\4EF6\7684\7D14\6587\5B57, \4EE5\50B3\9001\96FB\5B50\90F5\4EF6\7D66\4E0D\63A5\53D7 HTML \578B\96FB\5B50\90F5\4EF6\7684\6536\4EF6\8005.  \9019\4F7F\7528\7684\66FF\4EE3\503C\8207 HTML \6A23\677F\76F8\540C, \53EA\4E0D\904E #TABLE# \548C #ACTION# \5C07\6703\5448\73FE\70BA\7D14\6587\5B57.</li>'),
'<ul>',
unistr('<p>\53E6\6709\5176\4ED6 HTML \6A23\677F\53EF\7528\4F86\5EFA\7ACB\66F4\9032\968E\7684\96FB\5B50\90F5\4EF6.  \9019\4E9B\5305\62EC:</p>'),
'<ul>',
unistr('  <li><strong>\8CC7\6599\5217\4E4B\524D</strong> - \8F38\5165\53D6\4EE3 HTML \6A23\677F\4E2D\4E4B #TABLE# \7684 HTML.  \53EA\6709\5728\50B3\9001 p_table_content \6642\624D\6703\4F7F\7528.</li>'),
unistr('  <li><strong>\8CC7\6599\5217\6A23\677F</strong> - \8F38\5165\5448\73FE\8868\683C\4E4B\6BCF\500B\8CC7\6599\5217\7684 HTML.  \9019\5305\62EC\4F7F\7528 #LABEL# \548C #VALUE# \66FF\4EE3\503C\7684 row open/close \548C data open/close.    \53EA\6709\5728\50B3\9001 p_table_content \6642\624D\6703\4F7F\7528.</li>'),
unistr('  <li><strong>\8CC7\6599\5217\4E4B\5F8C</strong> - \8F38\5165\7D50\675F table \6216 div \7684 HTM.  \53EA\6709\5728\50B3\9001 p_table_content \6642\624D\6703\4F7F\7528.</li>'),
unistr('  <li><strong>\52D5\4F5C\9023\7D50 HTML</strong> - \8F38\5165\53D6\4EE3 HTML \6A23\677F\4E2D\4E4B #ACTION# \7684 HTML.  \61C9\5305\542B #ACTION_LINK# \548C #ACTION_TEXT#.  \53EA\6709\5728\50B3\9001 p_action_label \548C p_action_link \6642\624D\6703\4F7F\7528.</li>'),
'</ul>',
unistr('<p><em><strong>\6CE8\610F:</strong> \53EF\4EE5\4F7F\7528<strong>\9810\8A2D\6A23\677F</strong>\4E2D\7684\9805\76EE\4F5C\70BA\7BC4\4F8B\4F86\958B\767C\81EA\5DF1\7684\6A23\677F. \6B64\9810\8A2D\6A23\677F\4F7F\7528\5168\90E8\7684\66FF\4EE3\8B8A\6578, \60A8\53EF\4EE5\9078\64C7\662F\5426\8981\5728\81EA\5DF1\7684\96FB\5B50\90F5\4EF6\6A23\677F\4E2D\4F7F\7528.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110169563544314287)
,p_name=>'CA.HELP.P11030.EMAIL.SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\5176\4E2D\4E00\500B<strong>\767C\9001\96FB\5B50\90F5\4EF6</strong>\9078\9805, \4EE5\555F\7528\6216\505C\7528\50B3\9001\96FB\5B50\90F5\4EF6.</p>'),
unistr('<p>\8F38\5165\61C9\7528\7A0B\5F0F\554F\984C\7684\4E3B\8981\806F\7D61\4EBA\96FB\5B50\90F5\4EF6\5730\5740\4F5C\70BA<strong>\96FB\5B50\90F5\4EF6\5BC4\4EF6\8005</strong>.  \9019\500B\503C\53EF\4EE5\5728\4F7F\7528\96FB\5B50\90F5\4EF6\529F\80FD\6642\4F7F\7528\6216\8986\5BEB.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110187708982314303)
,p_name=>'CA.HELP.P11030.EMAILS.FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\662F\5C07\7528\65BC\50B3\9001\96FB\5B50\90F5\4EF6\7684\5BC4\4EF6\8005\5730\5740. \9019\500B\503C\53EF\4EE5\5728\4F7F\7528\96FB\5B50\90F5\4EF6\529F\80FD\6642\8986\5BEB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110205048841314319)
,p_name=>'CA.HELP.P11060.SEND.EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\586B\5165\4E0B\5217\9805\76EE\4E26\6309\4E00\4E0B\300C\50B3\9001\96FB\5B50\90F5\4EF6\300D.  \6240\6709\50B3\9001\7684\96FB\5B50\90F5\4EF6\90FD\6703\8A18\9304\5230\96FB\5B50\90F5\4EF6\65E5\8A8C\4E2D.'),
'    <ul>',
unistr('        <li><strong>\5BC4\4EF6\8005</strong> - \5982\679C\96FB\5B50\90F5\4EF6\8A2D\5B9A\503C\4E2D\8A2D\5B9A\4E86\300C\5BC4\4EF6\8005\5730\5740\300D, \8A72\96FB\5B50\90F5\4EF6\5730\5740\5C31\6703\662F\4E00\500B\5BC4\4EF6\8005\9078\9805.  \5982\679C\6B64\61C9\7528\7A0B\5F0F\4F7F\7528\300C\96FB\5B50\90F5\4EF6\5730\5740\300D\4F5C\70BA\4F7F\7528\8005\540D\7A31, \60A8\4FBF\53EF\4EE5\9078\64C7\5F9E\60A8\7684\96FB\5B50\90F5\4EF6\50B3\9001\96FB\5B50\90F5\4EF6.  \6700\5F8C, \60A8\4E00\5F8B\53EF\4EE5\5C07\300C\5BC4\4EF6\8005\300D\8A2D\70BA\548C\300C\6536\4EF6\8005\300D\76F8\540C.</li>'),
unistr('        <li><strong>\6536\4EF6\8005</strong> - \5982\679C\6B64\61C9\7528\7A0B\5F0F\4F7F\7528\300C\96FB\5B50\90F5\4EF6\5730\5740\300D\4F5C\70BA\4F7F\7528\8005\540D\7A31, \60A8\4FBF\53EF\4EE5\9078\64C7\5C07\96FB\5B50\90F5\4EF6\50B3\9001\7D66\300C\96FB\5B50\90F5\4EF6\5730\5740\300D\548C (\6216)\300C\4F7F\7528\8005\300D.</li>'),
unistr('        <li><strong>\96FB\5B50\90F5\4EF6\5730\5740</strong> - \5C07\6536\5230\6B64\96FB\5B50\90F5\4EF6\7684\96FB\5B50\90F5\4EF6\5730\5740\6E05\55AE (\4F7F\7528\9017\865F\5340\9694). \4E0D\6703\5305\542B\7121\6548\7684\96FB\5B50\90F5\4EF6\5730\5740.</li>'),
unistr('        <li><strong>\89D2\8272</strong> - \50B3\9001\96FB\5B50\90F5\4EF6\7D66\6240\9078\89D2\8272\7684\6240\6709\4F7F\7528\8005, \6216\50B3\9001\7D66\6240\6709\5B9A\7FA9\7684\4F7F\7528\8005.  \9078\53D6\6E05\55AE\5305\62EC\89D2\8272\6E05\55AE\53CA\8A72\89D2\8272\5167\7684\4F7F\7528\8005\6578\76EE.</li>'),
unistr('        <li><strong>\6A23\677F</strong> - \9078\53D6\7528\4F86\5EFA\7ACB\96FB\5B50\90F5\4EF6\672C\6587\7684\96FB\5B50\90F5\4EF6\6A23\677F.</li>'),
unistr('        <li><strong>\4E3B\65E8</strong> - \96FB\5B50\90F5\4EF6\7684\4E3B\65E8.</li>'),
unistr('        <li><strong>\96FB\5B50\90F5\4EF6\672C\6587</strong> - \8981\7D0D\5165\4F5C\70BA\96FB\5B50\90F5\4EF6\672C\6587\7684\6587\5B57.</li>'),
unistr('        <li><strong>\5141\8A31\9078\64C7\9000\51FA</strong> - \90E8\5206\96FB\5B50\90F5\4EF6\662F\7121\8AD6\4F7F\7528\8005\662F\5426\9078\64C7\4E0D\63A5\6536\96FB\5B50\90F5\4EF6\90FD\61C9\8A72\50B3\9001. \9019\985E\96FB\5B50\90F5\4EF6\5305\62EC\6545\969C\8A0A\606F\7B49. \6B64\65D7\6A19\8B58\5225\662F\5426\5141\8A31\4E0D\50B3\9001\6B64\96FB\5B50\90F5\4EF6, \9084\662F\7121\8AD6\4F7F\7528\8005\7684\504F\597D\8A2D\5B9A\70BA\4F55\90FD\61C9\8A72\50B3\9001\6B64\96FB\5B50\90F5\4EF6.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110206750781314320)
,p_name=>'CA.HELP.P11060.SEND.EMAIL.NO.ACL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\586B\5165\4E0B\5217\9805\76EE\4E26\6309\4E00\4E0B\300C\50B3\9001\96FB\5B50\90F5\4EF6\300D.  \6240\6709\50B3\9001\7684\96FB\5B50\90F5\4EF6\90FD\6703\8A18\9304\5230\96FB\5B50\90F5\4EF6\65E5\8A8C\4E2D.'),
'    <ul>',
unistr('        <li><strong>\5BC4\4EF6\8005</strong> - \5982\679C\96FB\5B50\90F5\4EF6\8A2D\5B9A\503C\4E2D\8A2D\5B9A\4E86\300C\5BC4\4EF6\8005\5730\5740\300D, \8A72\96FB\5B50\90F5\4EF6\5730\5740\5C07\6703\662F\5BC4\4EF6\8005\7684\9078\9805\4E4B\4E00.  \5426\5247, \60A8\53EF\4EE5\5C07\300C\5BC4\4EF6\8005\300D\8A2D\70BA\548C\300C\6536\4EF6\8005\300D\76F8\540C.</li>'),
unistr('        <li><strong>\96FB\5B50\90F5\4EF6\5730\5740</strong> - \5C07\6536\5230\6B64\96FB\5B50\90F5\4EF6\7684\96FB\5B50\90F5\4EF6\5730\5740\6E05\55AE (\4F7F\7528\9017\865F\5340\9694). \767C\73FE\7684\7121\6548\96FB\5B50\90F5\4EF6\5730\5740\5C07\4E0D\6703\5305\542B\5728\5167.</li>'),
unistr('        <li><strong>\6A23\677F</strong> - \9078\53D6\7528\4F86\5EFA\7ACB\96FB\5B50\90F5\4EF6\672C\6587\7684\96FB\5B50\90F5\4EF6\6A23\677F.</li>'),
unistr('        <li><strong>\4E3B\65E8</strong> - \96FB\5B50\90F5\4EF6\7684\4E3B\65E8.</li>'),
unistr('        <li><strong>\96FB\5B50\90F5\4EF6\672C\6587</strong> - \8981\5305\542B\4F5C\70BA\96FB\5B50\90F5\4EF6\672C\6587\7684\6587\5B57.</li>'),
unistr('        <li><strong>\5141\8A31\9078\64C7\9000\51FA</strong> - \90E8\5206\96FB\5B50\90F5\4EF6\7121\8AD6\4F7F\7528\8005\662F\5426\9078\64C7\4E0D\63A5\6536\96FB\5B50\90F5\4EF6\90FD\5FC5\9808\50B3\9001. \6545\969C\8A0A\606F\7B49\5747\70BA\9019\985E\96FB\5B50\90F5\4EF6. \6B64\65D7\6A19\8B58\5225\662F\5426\5141\8A31\9078\64C7\9000\51FA\6B64\96FB\5B50\90F5\4EF6, \6216\662F\5426\7121\8AD6\4F7F\7528\8005\504F\597D\8A2D\5B9A\70BA\4F55\90FD\5FC5\9808\50B3\9001.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110168212140314286)
,p_name=>'CA.HELP.P12000.TIME.ZONE.SUPPORT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\70BA\6B64\61C9\7528\7A0B\5F0F\7684\6240\6709\4F7F\7528\8005\9078\53D6\9810\8A2D\6642\5340.</p>'),
unistr('<p>\500B\5225\4F7F\7528\8005\53EA\8981\6309\4E00\4E0B\4F7F\7528\8005\540D\7A31 (\4F4D\65BC\53F3\4E0A\89D2) \4E26\9078\53D6<strong>\504F\597D\8A2D\5B9A</strong>, \5373\53EF\8986\5BEB\9019\9805\8A2D\5B9A. \6B64\5916, \4F7F\7528\8005\4E5F\53EF\4EE5\6309\4E00\4E0B\986F\793A\5728\9996\9801\5E95\90E8\7684\6642\5340\9023\7D50\4F86\8B8A\66F4\9019\9805\8A2D\5B9A.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110184125913314300)
,p_name=>'CA.HELP.P2000.PROFILE.PHOTO.DOWNLOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\7528\65BC\4E0B\8F09\8A2D\5B9A\6A94\76F8\7247, \7121\6CD5\76F4\63A5\900F\904E UI \5B58\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110183878868314300)
,p_name=>'CA.HELP.P20000.USER.PROFILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\4F7F\7528\8005\8A2D\5B9A\6A94\300D\9801\9762\53EF\8B93\60A8\5728\87A2\5E55\4E0A\8F15\9B06\67E5\770B\4F7F\7528\8005\7684\76F8\95DC\8CC7\8A0A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110183557201314298)
,p_name=>'CA.HELP.P20030.PHOTO.UPLOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\4E0A\50B3\6B63\65B9\5F62\7684\76F8\7247, \5426\5247\53EF\80FD\6703\626D\66F2\8B8A\5F62. \5EFA\8B70\5F71\50CF\5927\5C0F\70BA 250x250 \50CF\7D20.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110169671158314287)
,p_name=>'CA.HELP.P20200.USER.PROFILE.MODAL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\8868\55AE\53EF\8B93\60A8\66F4\65B0\500B\4EBA\8A73\7D30\8CC7\8A0A\53CA\4E0A\50B3\76F8\7247\6216\5927\982D\8CBC.</p>'),
unistr('<p>\82E5\8981\4E0A\50B3\5F71\50CF, \8ACB\6309\4E00\4E0B<strong>\700F\89BD</strong>\6216\5C07\5F71\50CF\62D6\653E\5230\6309\9215\4E0A.<br>'),
unistr('\8ACB\4E0A\50B3\6B63\65B9\5F62\7684\76F8\7247, \5426\5247\53EF\80FD\6703\626D\66F2\8B8A\5F62. \5EFA\8B70\7684\5F71\50CF\5927\5C0F\70BA 250x250 \50CF\7D20.</p>'),
unistr('<p>\6309\4E00\4E0B<strong>\522A\9664\76F8\7247</strong>\5373\53EF\5C07\5F71\50CF\522A\9664.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110189799688314304)
,p_name=>'CA.HELP.P20210.ABOUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\53EF\4EE5\5F9E\6B64\9801\9762\5B58\53D6\6240\6709\61C9\7528\7A0B\5F0F\8AAA\660E\6587\5B57.\300C\6587\4EF6\300D\5340\57DF\4E2D\7684\9023\7D50\6703\63D0\4F9B\66F4\591A\6B64\61C9\7528\7A0B\5F0F\529F\80FD\7684\6DF1\5165\8AAA\660E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110170772114314288)
,p_name=>'CA.HELP.P20400.APP.PREF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\53EF\4EE5\5728\6B64\9801\9762\4E2D\8A2D\5B9A\5E33\6236\7684\61C9\7528\7A0B\5F0F\504F\597D\8A2D\5B9A. \504F\597D\8A2D\5B9A\6703\5F71\97FF\6642\5340\7B49\591A\500B\61C9\7528\7A0B\5F0F\5C64\9762. \82E5\8981\77AD\89E3\5404\500B\504F\597D\8A2D\5B9A\7684\529F\80FD, \8ACB\6309\4E00\4E0B\9805\76EE\5C64\7D1A\8AAA\660E\5716\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109273593534313575)
,p_name=>'CA.HELP.P20500.EMAIL.REPORTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6B64\5831\8868\986F\793A\5DF2\6392\5165\4F47\5217\7B49\5F85\50B3\9001\53CA\5DF2\7D93\50B3\9001\7684\6240\6709\96FB\5B50\90F5\4EF6.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109395075999313671)
,p_name=>'CA.HELP.P20600.JOB.REPORTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6B64\5831\8868\5305\62EC\9078\64C7\53D7\6B64\61C9\7528\7A0B\5F0F\76E3\7763\7684\6240\6709\5DE5\4F5C.  \6309\4E00\4E0B\5DE5\4F5C\540D\7A31\5373\53EF\6AA2\8996\6BCF\500B\5DE5\4F5C\7684\8A73\7D30\8CC7\8A0A.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109401694802313676)
,p_name=>'CA.HELP.P20610.JOB.RUN.DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6B64\5831\8868\5305\542B\95DC\65BC\9078\64C7\53D7\6B64\61C9\7528\7A0B\5F0F\76E3\7763\7684\5DE5\4F5C\57F7\884C\8A73\7D30\8CC7\8A0A.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110155075466314276)
,p_name=>'CA.HELP.PAGE.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\95DC\65BC\6B64\61C9\7528\7A0B\5F0F\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110171409692314289)
,p_name=>'CA.HELP.RECEIVE.EMAILS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\60A8\4E0D\60F3\6536\5230\5F9E\9019\500B\61C9\7528\7A0B\5F0F\50B3\9001\7684\96FB\5B50\90F5\4EF6, \8ACB\5C07\6B64\9078\9805\8A2D\70BA\300C\5426\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110204501106314319)
,p_name=>'CA.HELP.SEARCH.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\641C\5C0B\5C0D\8A71\65B9\584A\4E2D\8F38\5165\641C\5C0B\8A5E\4E26\6309\4E00\4E0B<strong>\641C\5C0B</strong>.<br>'),
unistr('\6309\4E00\4E0B\4EFB\4F55\7D50\679C\6A19\984C\5373\53EF\700F\89BD\81F3\7279\5B9A\8A18\9304.</p>'),
unistr('<p>\82E5\8981\9650\5236\641C\5C0B, \8ACB\53D6\6D88\52FE\9078\4E00\6216\591A\500B\4F86\6E90, \5373\53EF\5C07\8A72\5831\8868\81EA\641C\5C0B\7D50\679C\4E2D\79FB\9664.</p>'),
unistr('<p>\6309\4E00\4E0B<strong>\91CD\8A2D</strong>\5373\53EF\79FB\9664\76EE\524D\7684\641C\5C0B\8A5E\4E26\52FE\9078\6240\6709\4F86\6E90.</p> ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110171290180314289)
,p_name=>'CA.HELP.TIME.ZONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\6574\500B\61C9\7528\7A0B\5F0F\4E2D\4F7F\7528\7684\504F\597D\6642\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109169445372313497)
,p_name=>'CA.HIDDEN.ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110191352721314306)
,p_name=>'CA.HOME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110197464683314310)
,p_name=>'CA.HOME.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110212796788314325)
,p_name=>'CA.HOURLY.PAGE.EVENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\5C0F\6642\7684\9801\9762\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109272627419313574)
,p_name=>'CA.HTML.BODY.SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \5167\6587\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110188158048314303)
,p_name=>'CA.HTML.TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110184800024314301)
,p_name=>'CA.IN.PROGRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\884C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110208974088314322)
,p_name=>'CA.INCLUDEONFORMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\62EC\5728\8868\55AE\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110208888414314322)
,p_name=>'CA.INCLUDEONREPORTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\62EC\5728\5831\8868\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110193572647314307)
,p_name=>'CA.INSTALL.SUP.OBJ.SCRIPTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\88DD\652F\63F4\7269\4EF6\547D\4EE4\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109395762865313672)
,p_name=>'CA.INSTANCE.ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\8655\7406 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109396988179313673)
,p_name=>'CA.INSTANCE.STICKINESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\8655\7406\505C\6EEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110167235144314286)
,p_name=>'CA.INTRO.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B61\8FCE\4F7F\7528\6B64\96F2\7AEF\9650\5B9A\7684\9810\89BD, \4EE5\5168\65B0\53CA\66F4\5F37\5927\7684\65B9\5F0F\5EFA\7ACB\529F\80FD\66F4\52A0\5B8C\5584\7684\61C9\7528\7A0B\5F0F. \6A19\6E96\7684\300C\5EFA\7ACB\61C9\7528\7A0B\5F0F\7CBE\9748\300D\53EA\80FD\8B93\60A8\9078\53D6\8981\7522\751F\7684\9801\9762, \800C\6B64\7CBE\9748\53EF\5FEB\901F\5C07\6578\500B\5176\4ED6\529F\80FD\9810\5148\8F09\5165\61C9\7528\7A0B\5F0F.</p>'),
unistr('<p>\4F7F\7528\6B64\7CBE\9748\6240\7522\751F\7684\61C9\7528\7A0B\5F0F\5C07\66F4\5177\652F\63F4\6027, \4E14\9084\53EF\4EE5\5305\62EC\6240\9078\529F\80FD\7684\300C\652F\63F4\7269\4EF6\300D, \4F8B\5982\5B58\53D6\63A7\5236\3001\96FB\5B50\90F5\4EF6\67B6\69CB\3001\610F\898B\56DE\994B\7B49\7B49.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110167409279314286)
,p_name=>'CA.INTRO.HOWTO.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9996\5148, \8F38\5165\61C9\7528\7A0B\5F0F\540D\7A31. \63A5\8457, \65B0\589E\4E00\6216\591A\500B\61C9\7528\7A0B\5F0F\7684\9801\9762. \52FE\9078\60F3\8981\5305\62EC\7684\529F\80FD. \9078\64C7\61C9\7528\7A0B\5F0F\5916\89C0, \7136\5F8C\8907\67E5\8A2D\5B9A\503C.<br>'),
unistr('\53EA\8981\9019\6A23 - \518D\6309\4E00\4E0B<strong>\5EFA\7ACB\61C9\7528\7A0B\5F0F</strong>, \60A8\5C31\5B8C\6210\4E86!</p>'),
unistr('<p>\6309\4E00\4E0B<strong>\6AA2\8996\85CD\5716</strong>\5373\53EF\91CD\8907\4F7F\7528\5148\524D\7522\751F\4E4B\61C9\7528\7A0B\5F0F\7684\6A21\578B, \6216\5FEB\901F\8907\88FD\9801\9762.</p>'),
unistr('<p><em><strong>\6CE8\610F:</strong> \6BCF\500B\5340\6BB5\548C\6BCF\500B\300C\65B0\589E\9801\9762\300D\5747\5305\62EC\8A73\7D30\7684\8AAA\660E, \4EE5\9032\4E00\6B65\5354\52A9\60A8\4F5C\696D.</em></p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110167372107314286)
,p_name=>'CA.INTRO.HOWTO.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\4F55\4F7F\7528\6B64\7CBE\9748')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110200985665314316)
,p_name=>'CA.INTRO.KNOWN.ISSUES.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\767C\884C\6642\767C\73FE\7684\91CD\5927\554F\984C\5982\4E0B:'),
'<ol>',
unistr('  <li>\300C\5F9E\85CD\5716\5EFA\7ACB\61C9\7528\7A0B\5F0F\7CBE\9748\300D\672A\7FFB\8B6F.</li>'),
unistr('  <li>\4F7F\7528\6B64\7CBE\9748\7522\751F\7684\5DF2\7FFB\8B6F\61C9\7528\7A0B\5F0F\53EA\6709\5C40\90E8\7FFB\8B6F.</li>'),
unistr('  <li>\300C\5831\8868\5411\4E0B\5C55\958B\300D\53EA\80FD\5411\4E0B\5C55\958B\4E00\500B\8CC7\6599\6B04.</li>'),
unistr('  <li>\7121\6CD5\7522\751F\7BE9\9078\5831\8868\9801\9762.</li>'),
unistr('  <li>\96FB\5B50\90F5\4EF6\529F\80FD\63D0\4F9B\4F4E\968E\7684 API, \4F46\662F\9084\672A\5305\542B\8F03\9AD8\968E\7684\96FB\5B50\90F5\4EF6\529F\80FD.</li>'),
unistr('  <li>\5F9E\53C3\7167\907A\6F0F\8868\683C\7684\85CD\5716\7522\751F\61C9\7528\7A0B\5F0F\5C07\6703\5931\6557.</li>'),
unistr('  <li>\9032\968E\8A2D\5B9A\503C - \65E5\671F\683C\5F0F\4E0D\6703\5957\7528\81F3\7522\751F\7684\61C9\7528\7A0B\5F0F.</li>'),
'</ol>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110200882691314316)
,p_name=>'CA.INTRO.KNOWN.ISSUES.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\77E5\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110167638519314286)
,p_name=>'CA.INTRO.RELEASE.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\767C\884C\6642\9593: %0.</p>'),
'',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110167513105314286)
,p_name=>'CA.INTRO.RELEASE.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7248\6B21\8A73\7D30\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110167149217314285)
,p_name=>'CA.INTRO.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\85CD\5716\5EFA\7ACB\61C9\7528\7A0B\5F0F\7CBE\9748 {\50C5\9650\96F2\7AEF\9810\89BD}')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110178702872314294)
,p_name=>'CA.IP.ADDRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('IP \4F4D\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110176978869314293)
,p_name=>'CA.IR.SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('IR \641C\5C0B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110179995159314295)
,p_name=>'CA.IR.SEARCHES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('IR \641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110207335751314321)
,p_name=>'CA.ITEMNAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109399719598313675)
,p_name=>'CA.JOB.ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109401246258313676)
,p_name=>'CA.JOB.CLASS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109400354833313675)
,p_name=>'CA.JOB.CREATOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5EFA\7ACB\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109401428987313676)
,p_name=>'CA.JOB.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109397959114313673)
,p_name=>'CA.JOB.PRIORITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\512A\5148\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109394941115313671)
,p_name=>'CA.JOB.REPORTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109435085635313701)
,p_name=>'CA.JOB.REPORTING.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\652F\63F4\6B64\61C9\7528\7A0B\5F0F\7684\5DE5\4F5C\72C0\614B\548C\57F7\884C\8A73\7D30\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109401574936313676)
,p_name=>'CA.JOB.RUN.DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\57F7\884C\8A73\7D30\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109400413874313675)
,p_name=>'CA.JOB.STYLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109400532918313675)
,p_name=>'CA.JOB.SUBNAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5B50\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109399832378313675)
,p_name=>'CA.JOB.TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109396566052313672)
,p_name=>'CA.JOB.WEIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\52A0\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110207839406314321)
,p_name=>'CA.KEYCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D22\5F15\9375\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110209620858314323)
,p_name=>'CA.LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110208196306314322)
,p_name=>'CA.LABELCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110209840900314323)
,p_name=>'CA.LABELPLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64 (\8907\6578)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110209502205314323)
,p_name=>'CA.LABELSINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64 (\55AE\6578)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110166330263314285)
,p_name=>'CA.LANGUAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110166430902314285)
,p_name=>'CA.LANGUAGE.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\61C9\7528\7A0B\5F0F\7684\4E3B\8981\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110200350913314316)
,p_name=>'CA.LANGUAGE.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\4E3B\8981\8A9E\8A00\6C7A\5B9A\5728\61C9\7528\7A0B\5F0F\7522\751F\5668\4E2D\7522\751F\4E4B\9801\9762\548C\5143\4EF6\7684\986F\793A\8A9E\8A00. \82E5\9078\53D6\591A\500B\7FFB\8B6F, \53EF\8B93\4E00\822C\4F7F\7528\8005\9078\64C7\61C9\7528\7A0B\5F0F\5BE6\969B\57F7\884C\6642\7684\8A9E\8A00.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109532790678313775)
,p_name=>'CA.LANGUAGE_SELECTOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00\9078\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110183321937314298)
,p_name=>'CA.LAST.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\59D3\6C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109400667522313675)
,p_name=>'CA.LAST.RUN.DURATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\6B21\57F7\884C\6301\7E8C\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109400724542313676)
,p_name=>'CA.LAST.START.DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\6B21\958B\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110213144528314325)
,p_name=>'CA.LATEST.ACTIVITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\65B0\6D3B\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110209093868314322)
,p_name=>'CA.LISTOFVALUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110204457556314319)
,p_name=>'CA.LOAD.BLUEPRINT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\85CD\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109403027150313677)
,p_name=>'CA.LOG.DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A18\9304\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109403171773313677)
,p_name=>'CA.LOG.ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\8A8C ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109397231450313673)
,p_name=>'CA.LOGGING.LEVEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\8A8C\8A18\9304\5C64\7D1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110080443520314200)
,p_name=>'CA.LOG_MESSAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\8A8C\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109170626875313498)
,p_name=>'CA.LOOKUP.COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>\67E5\5C0B\8CC7\6599\6B04</strong> - \5C55\958B\4EE5\67E5\770B\5B9A\7FA9\5C0D\5176\4ED6\8868\683C\67E5\5C0B\7684\5C6C\6027. \4F7F\7528\67E5\5C0B\8CC7\6599\6B04\53EF\4F7F\7528\986F\793A\8CC7\6599\6B04\4F86\53D6\4EE3 ID, \4F8B\5982\986F\793A\90E8\9580\540D\7A31\800C\975E\90E8\9580\7DE8\865F.<br>'),
unistr('<em><strong>\6CE8\610F:</strong> \76EE\524D\7684\9801\9762\662F\4EE5\8868\683C\6216\8996\89C0\8868\70BA\57FA\790E, \4E14\5177\6709\5176\4ED6\8868\683C\7684\5916\4F86\7D22\5F15\9375\9650\5236\689D\4EF6\6642, \624D\6703\986F\793A\67E5\5C0B\8CC7\6599\6B04.'),
'  <ul>',
unistr('    <li><strong>\67E5\5C0B\7D22\5F15\9375</strong> - \9078\53D6\8981\8B8A\66F4\70BA\8F38\51FA\986F\793A\8CC7\6599\6B04\7684\8CC7\6599\6B04.</li>'),
unistr('    <li><strong>\986F\793A\8CC7\6599\6B04</strong> - \9078\53D6\8981\986F\793A\7684\8CC7\6599\6B04 (\5F9E\67E5\5C0B\8868\683C).</li>'),
'    &nbsp;<br>',
unistr('    <em><strong>\6CE8\610F:</strong> \8ACB\50C5\9078\53D6\5177\6709\5176\4ED6\8868\683C\53C3\7167 (\4F7F\7528\5916\4F86\7D22\5F15\9375) \7684\8CC7\6599\6B04.</em></li>'),
'  </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110187368966314303)
,p_name=>'CA.MANAGE.EMAIL.TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\96FB\5B50\90F5\4EF6\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110185321277314301)
,p_name=>'CA.MANAGE.FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110181452217314296)
,p_name=>'CA.MANAGE.USER.ACCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\4F7F\7528\8005\5B58\53D6\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110213763938314326)
,p_name=>'CA.MASTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\4E3B\8981\660E\7D30\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110213867461314326)
,p_name=>'CA.MASTER.DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5EFA\7ACB\4E00\500B\986F\793A\4E3B\8981-\660E\7D30\9801\9762\7684\9801\9762, \8B93\4E00\822C\4F7F\7528\8005\53EF\4EE5\6AA2\8996\53CA\7DAD\8B77\8CC7\6599.<br>'),
'&nbsp;</p>',
unistr('<p>\8F38\5165\4E0B\5217\5C6C\6027:</p>'),
'<ul>',
unistr('  <li><strong>\9801\9762\540D\7A31</strong> (\5FC5\8981) - \8F38\5165\6B64\9801\9762\7684\540D\7A31.</li>'),
unistr('  <li><strong>\8A2D\5B9A\5716\793A</strong> - \9078\53D6\6B64\9801\9762\5728\5C0E\89BD\529F\80FD\8868\4E2D\7684\986F\793A\5716\793A.</li>'),
unistr('  <li><strong>\9801\9762\985E\578B</strong> - \9078\53D6\9801\9762\985E\578B [\4E26\6392\3001\5806\758A].<br>'),
unistr('    <strong>\4E26\6392</strong>: <br>'),
unistr('<em>\904B\7528\4E26\6392\7248\9762\914D\7F6E\548C\542B\6709\5F37\5236\56DE\61C9\7DE8\8F2F\8996\7A97\4E4B\5831\8868\5340\57DF\7684\55AE\4E00\9801\9762\4E3B\8981-\660E\7D30.</em>'),
'    <ul>',
unistr('      <li><strong>\8868\683C</strong> (\5FC5\8981) - \9078\53D6\9801\9762\7684\4E3B\8981\8868\683C.</li>'),
unistr('      <li><strong>\4E3B\8981\986F\793A\8CC7\6599\6B04</strong> (\5FC5\8981) - \9078\53D6\8981\5728\4E3B\8981\8A18\9304\6E05\55AE\4E2D\986F\793A\7684\8CC7\6599\6B04.</li>'),
unistr('      <li><strong>\6B21\8981\986F\793A\8CC7\6599\6B04</strong> (\5FC5\8981) - \9078\53D6\8981\5728\4E3B\8981\8A18\9304\6E05\55AE\4E2D\300C\4E3B\8981\986F\793A\8CC7\6599\6B04\300D\5E95\4E0B\986F\793A\7684\63CF\8FF0\6027\8CC7\6599\6B04.</li>'),
unistr('      <li><strong>\660E\7D30\8868\683C 1</strong> (\5FC5\8981) - \9078\53D6\9801\9762\7684\7B2C\4E00\500B\660E\7D30\8868\683C.</li>'),
unistr('      <li><strong>\660E\7D30\8868\683C 2</strong> - \9078\53D6\9801\9762\7684\7B2C\4E8C\500B\660E\7D30\8868\683C.</li>'),
unistr('      <li><strong>\660E\7D30\8868\683C 3</strong> - \9078\53D6\9801\9762\7684\7B2C\4E09\500B\660E\7D30\8868\683C.</li>'),
unistr('      <li><strong>\660E\7D30\8868\683C 4</strong> - \9078\53D6\9801\9762\7684\7B2C\56DB\500B\660E\7D30\8868\683C.</li>'),
'    </ul>',
unistr('   <strong>\5806\758A</strong>: <br>'),
unistr('<em>\904B\7528\53EF\7DE8\8F2F\4E92\52D5\5F0F\65B9\683C\7684\55AE\4E00\9801\9762\4E3B\8981-\660E\7D30.</em>'),
'    <ul>',
unistr('      <li><strong>\8868\683C</strong> (\5FC5\8981) - \9078\53D6\53EF\7DE8\8F2F\4E92\52D5\5F0F\65B9\683C\7684\4E3B\8981\8868\683C.</li>'),
unistr('      <li><strong>\660E\7D30\8868\683C</strong> (\5FC5\8981) - \9078\53D6\9801\9762\7684\660E\7D30\8868\683C.</li>'),
unistr('      <em><strong>\6CE8\610F:</strong> \4F7F\7528\6B64\7CBE\9748\6642, \53EA\80FD\65B0\589E\4E00\500B\660E\7D30\8868\683C (\53EF\7DE8\8F2F\4E92\52D5\5F0F\65B9\683C). \4F46\5728\7522\751F\5F8C, \53EF\8F15\9B06\65B0\589E\5176\4ED6\660E\7D30\8868\683C.</em>'),
'    </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109532617830313775)
,p_name=>'CA.MASTER_RECORDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\8A18\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110177672834314293)
,p_name=>'CA.MAX.ELAPSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\9577\7D93\6B77\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109397705419313673)
,p_name=>'CA.MAX.FAILURES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5931\6557\6B21\6578\4E0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109397389121313673)
,p_name=>'CA.MAX.RUN.DURATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\6301\7E8C\6642\9593\4E0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109397869363313673)
,p_name=>'CA.MAX.RUNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\6B21\6578\4E0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110208075903314321)
,p_name=>'CA.MAXIMUMROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\6578\76EE\4E0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110211082052314324)
,p_name=>'CA.MAXIMUMWIDTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5927\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110201632052314317)
,p_name=>'CA.MD.ADD.FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110202027700314317)
,p_name=>'CA.MD.ADD.ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110201532349314317)
,p_name=>'CA.MD.APPLY.FILTERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110202450278314317)
,p_name=>'CA.MD.DATE.VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110202505988314317)
,p_name=>'CA.MD.DATE.VALUE.2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F\503C 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110201756302314317)
,p_name=>'CA.MD.EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110201146861314316)
,p_name=>'CA.MD.FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110201061596314316)
,p_name=>'CA.MD.FILTERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110202103987314317)
,p_name=>'CA.MD.NO.FILTERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110201482120314317)
,p_name=>'CA.MD.NO.RECORD.SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9078\53D6\8A18\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110201373074314316)
,p_name=>'CA.MD.NO.RECORDS.FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\8A18\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110201910793314317)
,p_name=>'CA.MD.ROWS.DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5DF2\522A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110201879430314317)
,p_name=>'CA.MD.ROWS.UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5DF2\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110201295129314316)
,p_name=>'CA.MD.SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110202293829314317)
,p_name=>'CA.MD.VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110202374063314317)
,p_name=>'CA.MD.VALUE.2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110177195490314293)
,p_name=>'CA.MEDIAN.ELAPSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\9593\503C\6B77\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110186215107314302)
,p_name=>'CA.MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110080213173314200)
,p_name=>'CA.MESSAGE_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A0A\606F\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110210517953314323)
,p_name=>'CA.METRIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EA6\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110178015306314294)
,p_name=>'CA.MIN.ELAPSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\77ED\7D93\6B77\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110180886614314296)
,p_name=>'CA.MOBILE.PHONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\52D5\96FB\8A71\865F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110176632082314293)
,p_name=>'CA.MODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110190469828314305)
,p_name=>'CA.MORE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110180078520314295)
,p_name=>'CA.MOST RECENT'
,p_message_language=>'zh-tw'
,p_message_text=>'Most_Recent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110212936978314325)
,p_name=>'CA.MOST.ACTIVE.PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5E38\4F7F\7528\4E2D\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109170795947313498)
,p_name=>'CA.MULTIPLE.REPORTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\591A\4EFD\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109170894412313498)
,p_name=>'CA.MULTIPLE.REPORTS.DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\52FE\9078\4E00\6216\591A\500B\8868\683C\6216\8996\89C0\8868\540D\7A31. \6216\8005, \6309\4E00\4E0B\6A19\982D\4E2D\7684\6838\53D6\65B9\584A\4EE5\9078\53D6\6216\53D6\6D88\9078\53D6\5217\51FA\7684\6240\6709\8CC7\6599\5EAB\7269\4EF6.</p>'),
unistr('<p>\5C07\6703\70BA\52FE\9078\7684\6BCF\500B\8CC7\6599\5EAB\7269\4EF6\65B0\589E\4E00\500B\542B\6709\4E92\52D5\5F0F\5831\8868\7684\9801\9762.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110174078331314291)
,p_name=>'CA.MUST.BE.VALID.TIMESTAMP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \5FC5\9808\662F\6709\6548\7684\6642\6233.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110210304700314323)
,p_name=>'CA.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110165558372314284)
,p_name=>'CA.NAVIGATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110165655008314284)
,p_name=>'CA.NAVIGATION.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\9078\53D6\8981\5728\61C9\7528\7A0B\5F0F\7684\5074\908A\9084\662F\61C9\7528\7A0B\5F0F\7684\9802\7AEF\986F\793A\529F\80FD\8868.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110217029994314328)
,p_name=>'CA.NEGATIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\597D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110216945796314328)
,p_name=>'CA.NEUTRAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\666E\901A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110203081129314318)
,p_name=>'CA.NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109397594275313673)
,p_name=>'CA.NEXT.RUN.DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\6B21\57F7\884C\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109396479294313672)
,p_name=>'CA.NLS.ENV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('NLS \74B0\5883')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109485457834313740)
,p_name=>'CA.NO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110184942090314301)
,p_name=>'CA.NO.ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110196580098314309)
,p_name=>'CA.NO.HELP.AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\6C92\6709\76F8\95DC\8AAA\660E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109169512217313497)
,p_name=>'CA.NO.VALID.USER.EXIST.PAGEINFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\6709\6548\7684\4F7F\7528\8005\5B58\5728 - \9801\9762\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110204072124314318)
,p_name=>'CA.NO.VALID.USER.FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\4EFB\4F55\6709\6548\7684\65B0\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110200116609314316)
,p_name=>'CA.NONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110181128094314296)
,p_name=>'CA.NOTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9644\8A3B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110156648546314277)
,p_name=>'CA.NOTIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110155433189314276)
,p_name=>'CA.NOTIFICATION.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\9996\9801\986F\793A\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110156774953314277)
,p_name=>'CA.NOTIFICATION.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8B93\61C9\7528\7A0B\5F0F\7BA1\7406\54E1\80FD\5920\6307\5B9A\5C07\5728\61C9\7528\7A0B\5F0F\9996\9801\4E0A\5411\6240\6709\4E00\822C\4F7F\7528\8005\986F\793A\7684\8B66\793A (\9EC3\8272) \6216\932F\8AA4 (\7D05\8272). \9019\9805\529F\80FD\5C0D\65BC\5C07\91CD\8981\8CC7\8A0A\50B3\9001\5230\4E00\822C\4F7F\7528\8005\793E\7FA4\975E\5E38\5BE6\7528.</p>'),
unistr('<p>\5305\62EC\4E0B\5217\5143\4EF6:<ul>'),
unistr('<li>\80FD\5920\5B9A\7FA9\901A\77E5</li>'),
unistr('<li>\5728\61C9\7528\7A0B\5F0F\9996\9801\4E0A\986F\793A\901A\77E5</li>'),
unistr('<li>\80FD\5920\63A7\5236\901A\77E5\986F\793A\7684\6642\9593</li>'),
unistr('<li>\652F\63F4\4EE5\8272\5F69\5340\5206\901A\77E5\7684\985E\578B</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110173372274314290)
,p_name=>'CA.NOTIFICATION.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110176809552314293)
,p_name=>'CA.NUM.ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\6578\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109399650824313675)
,p_name=>'CA.NUMBER.OF.ARGUMENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F15\6578\6578\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109396274555313672)
,p_name=>'CA.NUMBER.OF.DESTINATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\7684\5730\6578\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110208595593314322)
,p_name=>'CA.NUMBERFORMATMASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6578\5B57\683C\5F0F\906E\7F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110178304740314294)
,p_name=>'CA.OCCURRENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FA\73FE\6B21\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110217247292314328)
,p_name=>'CA.ONE.ADMIN.REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9664\975E\6709\53E6\4E00\4F4D\7BA1\7406\54E1, \5426\5247\60A8\7121\6CD5\57F7\884C\6B64\52D5\4F5C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110185155473314301)
,p_name=>'CA.OPEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F85\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110158136107314279)
,p_name=>'CA.ORGANIZING.PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\7E54\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110158422985314279)
,p_name=>'CA.ORGANIZING.PAGES.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F9D\5E0C\671B\5728\61C9\7528\7A0B\5F0F\4E2D\986F\793A\7684\9806\5E8F\6392\5217\9801\9762. <br>'),
unistr('\82E5\60F3\91CD\65B0\6392\5217\6E05\55AE\4E2D\9801\9762\7684\9806\5E8F, \8ACB\6309\4F4F\6BCF\500B\9801\9762\6E05\55AE\7D50\5C3E\8655\7684<em>\62D6\66F3\4EE5\91CD\65B0\6392\5217\9801\9762</em>\5716\793A ( <span class="fa fa-bars" aria-hidden="true"></span> ), \7136\5F8C\5C07\8A72\9801\9762\4E0A\4E0B\62D6\653E.</p>'),
unistr('<p>\9996\9801\4E00\5F8B\6703\512A\5148\986F\793A, \800C\4E14\4E0D\80FD\91CD\65B0\6392\5217.<br>'),
unistr('\7BA1\7406\9801\9762\4E00\5F8B\6703\986F\793A\5728\6E05\55AE\5E95\7AEF, \800C\5B83\5011\7684\9806\5E8F\6703\6C7A\5B9A\9019\4E9B\9801\9762\5728\300C\7BA1\7406\300D\9801\9762\4E4B\300C\61C9\7528\7A0B\5F0F\7BA1\7406\300D\6E05\55AE\4E2D\7684\986F\793A\9806\5E8F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109401746609313676)
,p_name=>'CA.OUTPUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109402956593313677)
,p_name=>'CA.OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110176508880314293)
,p_name=>'CA.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110179738571314295)
,p_name=>'CA.PAGE.EVENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110192211378314306)
,p_name=>'CA.PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8AAA\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110178886632314294)
,p_name=>'CA.PAGE.ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109534484608313776)
,p_name=>'CA.PAGE.MD.EDIT_MASTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\4E3B\8981\8A18\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109534694550313776)
,p_name=>'CA.PAGE.MD.PERFORM_SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110176138460314292)
,p_name=>'CA.PAGE.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110191577033314306)
,p_name=>'CA.PAGE.NAVIGATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5C0E\89BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110178245154314294)
,p_name=>'CA.PAGE.PERFORMANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6548\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110203172892314318)
,p_name=>'CA.PAGE.TYPE.NOT.VALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\985E\578B "%0" \4E0D\662F\4E00\500B\6709\6548\7684\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110177537384314293)
,p_name=>'CA.PAGE.VIEWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110158673310314279)
,p_name=>'CA.PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110158731166314279)
,p_name=>'CA.PAGES.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5B9A\7FA9\521D\59CB\61C9\7528\7A0B\5F0F\6240\8981\5305\62EC\7684\9801\9762. \60A8\81F3\5C11\5FC5\9808\5148\5B9A\7FA9\4E00\500B\9801\9762\5F8C, \624D\80FD\5EFA\7ACB\61C9\7528\7A0B\5F0F.</p>'),
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\6B64\7CBE\9748\5EFA\7ACB\4E0D\9650\6578\76EE\7684\9801\9762, \4EE5\64B0\5BEB\61C9\7528\7A0B\5F0F. \5EFA\7ACB\61C9\7528\7A0B\5F0F\4E4B\5F8C, \53EF\4F7F\7528\300C\5EFA\7ACB\9801\9762\7CBE\9748\300D\65B0\589E\66F4\591A\9801\9762.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110208434529314322)
,p_name=>'CA.PAGINATIONMETHOD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\9801\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110177807979314294)
,p_name=>'CA.PARTIAL.PAGE.VIEWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\90E8\5206\9801\9762\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110183607749314298)
,p_name=>'CA.PHOTO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\7247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110184249241314300)
,p_name=>'CA.PHOTO.DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\7247\5DF2\522A\9664.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110183749986314298)
,p_name=>'CA.PHOTO.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\7247\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110183485446314298)
,p_name=>'CA.PHOTO.UPLOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\7247\4E0A\50B3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110080336575314200)
,p_name=>'CA.PK_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\9375  \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110188215557314303)
,p_name=>'CA.PLAIN.TEXT.TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D14\6587\5B57\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110216808330314328)
,p_name=>'CA.POSITIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\597D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110171061523314288)
,p_name=>'CA.PREFERENCES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110214410864314326)
,p_name=>'CA.PREVIOUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110209124760314322)
,p_name=>'CA.PRIMARYDISPLAYCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\986F\793A\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110210067239314323)
,p_name=>'CA.PRIMARYKEYCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110210147830314323)
,p_name=>'CA.PRIMARYPARENTTABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\7236\9805\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110178445229314294)
,p_name=>'CA.PROCEDURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110171624020314289)
,p_name=>'CA.PROCESS.EMAIL.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\504F\597D\8A2D\5B9A\5DF2\66F4\65B0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109534216045313776)
,p_name=>'CA.PROCESS.FETCH_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64F7\53D6\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110080588890314200)
,p_name=>'CA.PROCESS.GET_LOG_DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\5F97\65E5\8A8C\8A73\7D30\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110172851523314290)
,p_name=>'CA.PROCESS.THEME.PREFERENCE.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\5916\89C0\8A2D\5B9A\503C\5DF2\5132\5B58.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110171547890314289)
,p_name=>'CA.PROCESS.TIME.ZONE.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\5340\504F\597D\8A2D\5B9A\5DF2\66F4\65B0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110184093781314300)
,p_name=>'CA.PROFILE.PHOTO.DOWNLOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\6A94\76F8\7247\4E0B\8F09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109399954657313675)
,p_name=>'CA.PROGRAM.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A0B\5F0F\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109400044943313675)
,p_name=>'CA.PROGRAM.OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A0B\5F0F\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108912987311313297)
,p_name=>'CA.PWA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\88DD\6F38\9032\5F0F Web App')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108912853175313297)
,p_name=>'CA.PWA.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B93\60A8\7684\61C9\7528\7A0B\5F0F\53EF\9032\884C\5B89\88DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108913014816313297)
,p_name=>'CA.PWA.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\300C\6F38\9032\5F0F Web App\300D\8A2D\8A08\70BA\529F\80FD\5B8C\6574\3001\53EF\9760\53CA\53EF\5B89\88DD\7684 Web \61C9\7528\7A0B\5F0F.\300C\6F38\9032\5F0F Web App\300D\5C31\50CF\662F\5E73\53F0\7279\5B9A\61C9\7528\7A0B\5F0F.</p>'),
unistr('<p>\82E5\555F\7528\6B64\9078\9805, \5C07\6703:</p>'),
'<ul>',
unistr('<li>\65B0\589E\5C0E\89BD\5217\9805\76EE:\300C\5B89\88DD\61C9\7528\7A0B\5F0F\300D</li>'),
unistr('<li>\5141\8A31\4F7F\7528\8005\5728\88DD\7F6E\4E0A\5B89\88DD\6B64 APEX \61C9\7528\7A0B\5F0F</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108908947345313294)
,p_name=>'CA.PWA.INSTALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\88DD\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110209475265314322)
,p_name=>'CA.QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109396768139313672)
,p_name=>'CA.RAISE.EVENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F15\767C\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109038414612313400)
,p_name=>'CA.RATING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A55\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110181906964314297)
,p_name=>'CA.READERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95B1\8B80\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110171306148314289)
,p_name=>'CA.RECEIVE.EMAILS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63A5\6536\96FB\5B50\90F5\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110213022184314325)
,p_name=>'CA.RECENT.ERRORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\8FD1\767C\751F\7684\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109849111431314035)
,p_name=>'CA.RECENT.ERRORS.LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109849203513314035)
,p_name=>'CA.RECENT.ERRORS.VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110173550001314290)
,p_name=>'CA.RED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D05\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110187192165314302)
,p_name=>'CA.REFERENCED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\53C3\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109533329907313775)
,p_name=>'CA.REFRESH.ADMIN_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6574\7406\7BA1\7406\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109150613914313483)
,p_name=>'CA.REFRESH.ON.DIALOG.CLOSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\8A71\65B9\584A\95DC\9589\6642\91CD\65B0\6574\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109534506565313776)
,p_name=>'CA.REFRESH_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6574\7406\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110173031051314290)
,p_name=>'CA.REGION.BUTTONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110172904105314290)
,p_name=>'CA.REGION.FORM.ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE\9805\76EE\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110178954972314294)
,p_name=>'CA.REGION.ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110190944407314305)
,p_name=>'CA.RELEASE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7248\6B21 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110158241628314279)
,p_name=>'CA.REMOVING.PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110158379570314279)
,p_name=>'CA.REMOVING.PAGES.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6309\4E00\4E0B<strong>\7DE8\8F2F</strong>\4EE5\9078\53D6\9801\9762; \7136\5F8C\6309\4E00\4E0B<strong>\522A\9664\9801\9762</strong>, \4EE5\79FB\9664\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109401314905313676)
,p_name=>'CA.REPEAT.INTERVAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8907\9593\9694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109273214334313575)
,p_name=>'CA.REPLY.TO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56DE\8986')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110164028557314283)
,p_name=>'CA.REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\5831\8868\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110163922821314283)
,p_name=>'CA.REPORT.DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5EFA\7ACB\4E00\500B\986F\793A\70BA\4E92\52D5\5F0F\5831\8868\6216\4E00\822C\5831\8868\7684\9801\9762.</p>'),
unistr('<p>\8F38\5165\4E0B\5217\5C6C\6027:</p>'),
'<ul>',
unistr('  <li><strong>\9801\9762\540D\7A31</strong> (\5FC5\8981) - \8F38\5165\6B64\9801\9762\7684\540D\7A31.</li>'),
unistr('  <li><strong>\8A2D\5B9A\5716\793A</strong> - \9078\53D6\6B64\9801\9762\5728\5C0E\89BD\529F\80FD\8868\4E2D\7684\986F\793A\5716\793A.</li>'),
unistr('  <li><strong>\67E5\8A62\985E\578B</strong> - \9078\53D6\5831\8868\7684\4F86\6E90 [<strong>\8868\683C\6216\8996\89C0\8868</strong>\6216 <strong>SQL \67E5\8A62</strong>]:<br>'),
unistr('    <strong>\8868\683C\6216\8996\89C0\8868</strong>:'),
'    <ul>',
unistr('      <li>\8868\683C\6216\8996\89C0\8868 (\5FC5\8981) - \9078\53D6\5831\8868\7684\8CC7\6599\5EAB\7269\4EF6.</li>'),
unistr('      <li>\5305\62EC\8868\55AE - \9078\53D6\5373\53EF\5305\62EC\4E00\500B\9023\7D50\7684\8868\55AE\9801\9762, \4F9B\4F7F\7528\8005\7DAD\8B77\8868\683C\503C.</li>'),
'    </ul>',
unistr('    <strong>SQL \67E5\8A62</strong>:'),
'    <ul>',
unistr('      <li>SQL \67E5\8A62 (\5FC5\8981) - \8F38\5165\50B3\56DE\4E0D\540C\8CC7\6599\6B04\7684\6709\6548 SQL \6558\8FF0\53E5.</li>'),
'    </ul>',
'  </li>',
unistr('  <li><strong>\5831\8868\985E\578B</strong> - \9078\53D6\5831\8868\985E\578B (<strong>\4E92\52D5\5F0F\5831\8868</strong>\6216<strong>\4E00\822C\5831\8868</strong>).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110155787213314277)
,p_name=>'CA.REPORT.N.WITH.FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\542B\8868\55AE\7684 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110038378011314170)
,p_name=>'CA.REPORT.TABLE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110212109189314324)
,p_name=>'CA.REPORT.VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110210756064314323)
,p_name=>'CA.REPORTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109402705924313677)
,p_name=>'CA.REQ.START.DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42\7684\958B\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110210957496314324)
,p_name=>'CA.REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110189008629314304)
,p_name=>'CA.RESET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110185071616314301)
,p_name=>'CA.RESOLVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\89E3\6C7A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110184722921314301)
,p_name=>'CA.RESPONSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56DE\61C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109398089551313673)
,p_name=>'CA.RESTART.ON.FAILURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5931\6557\6642\91CD\65B0\555F\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109398160361313674)
,p_name=>'CA.RESTART.ON.RECOVERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FA9\539F\6642\91CD\65B0\555F\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109395309490313671)
,p_name=>'CA.RESTARTABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\91CD\65B0\555F\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109397624596313673)
,p_name=>'CA.RETRY.COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A66\8A08\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110205908052314320)
,p_name=>'CA.ROLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110179113881314294)
,p_name=>'CA.ROW.NUMBER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\7DE8\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110188499173314303)
,p_name=>'CA.ROW.TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110205329196314319)
,p_name=>'CA.ROW.TEMPLATE.HTML'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\6A23\677F HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110206617573314320)
,p_name=>'CA.ROWS.CONTENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110179812905314295)
,p_name=>'CA.ROWS.FETCHED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64F7\53D6\7684\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110208339704314322)
,p_name=>'CA.ROWSPERPAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\9801\8CC7\6599\5217\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109400982138313676)
,p_name=>'CA.RUN.COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\8A08\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109402588284313677)
,p_name=>'CA.RUN.DURATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\6301\7E8C\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109397430540313673)
,p_name=>'CA.SCHEDULE.LIMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\7A0B\9650\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109399442680313675)
,p_name=>'CA.SCHEDULE.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\7A0B\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109399554369313675)
,p_name=>'CA.SCHEDULE.OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\7A0B\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109399336027313674)
,p_name=>'CA.SCHEDULE.TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\7A0B\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110166523149314285)
,p_name=>'CA.SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110166615397314285)
,p_name=>'CA.SCHEMA.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\9078\53D6\8CC7\6599\5EAB\7DB1\8981, \5176\4E2D\5132\5B58\4E86\60A8\8981\5728\6B64\61C9\7528\7A0B\5F0F\4E2D\4F7F\7528\7684\8CC7\6599\5EAB\7269\4EF6.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110207422776314321)
,p_name=>'CA.SCOPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\570D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110189109131314304)
,p_name=>'CA.SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110189286092314304)
,p_name=>'CA.SEARCH.APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110189325401314304)
,p_name=>'CA.SEARCH.DIALOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\5C0D\8A71\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110212338521314325)
,p_name=>'CA.SEARCH.FILTERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110196027802314309)
,p_name=>'CA.SEARCH.HIDDEN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6B64\9801\9762\4E0D\6703\986F\793A\7A31\70BA\300C\5DF2\641C\5C0B\8868\683C\300D\7684\300C\5171\7528\5143\4EF6\300D\6E05\55AE.'),
'',
unistr('\6240\6709\6700\521D\5F9E\300C\5EFA\7ACB\61C9\7528\7A0B\5F0F\300D\7CBE\9748\7522\751F\7684\4E92\52D5\5F0F\5831\8868\9801\9762\90FD\6703\81EA\52D5\52A0\5230\6B64\6E05\55AE\4E2D. '),
unistr('\82E5\8981\5C07\81EA\5DF1\7684\8868\683C\52A0\5230\6B64\6E05\55AE\4E2D, \8ACB\700F\89BD\81F3\300C\5171\7528\5143\4EF6\300D, \9078\53D6\300C\6E05\55AE\300D, \7136\5F8C\6309\4E00\4E0B\300C\5DF2\641C\5C0B\8868\683C\300D.'),
unistr('  \8F38\5165\4E0B\5217\5C6C\6027:'),
unistr('    \9805\76EE: \6E05\55AE\9805\76EE\6A19\7C64 - \8F38\5165\8868\683C\7684\986F\793A\540D\7A31.'),
unistr('    \76EE\6A19: \9801\9762 - \9078\53D6\8981\700F\89BD\7684\9069\7576\9801\9762 (\6700\597D\662F\4E92\52D5\5F0F\5831\8868)'),
unistr('    \76EE\6A19: \6E05\9664\5FEB\53D6 - \8F38\5165\9700\8981\6E05\9664\7684\6240\6709\9801\9762 (\4E00\822C\548C\300C\9801\9762\300D\4E0B\8F38\5165\7684\6578\5B57\76F8\540C).'),
unistr('       \82E5\662F\700F\89BD\81F3\300C\4E92\52D5\5F0F\5831\8868\300D\9801\9762, \8ACB\65B0\589E CIR,RIR \4EE5\6E05\9664\4EFB\4F55\73FE\6709\7684\7BE9\9078\7B49\7B49.'),
unistr('    \76EE\6A19: \8A2D\5B9A\9019\4E9B\9805\76EE - \9078\53D6 (\6216\8F38\5165) \8981\586B\5165\7684\9069\7576\9801\9762\9805\76EE.'),
unistr('       \82E5\662F\700F\89BD\81F3\300C\4E92\52D5\5F0F\5831\8868\300D\9801\9762, \8ACB\8F38\5165 IR_[COLUMN_NAME].'),
unistr('    \76EE\6A19: \4F7F\7528\9019\4E9B\503C - \8F38\5165 =PK='),
unistr('    \4F7F\7528\8005\5B9A\7FA9\5C6C\6027: 1 - \8F38\5165\8981\641C\5C0B\5167\5BB9\7684\8868\683C\540D\7A31 (\5927\5BEB\5B57\6BCD).'),
unistr('    \4F7F\7528\8005\5B9A\7FA9\5C6C\6027: 2 - \8F38\5165\4E3B\8981\8CC7\6599\6B04\540D\7A31 (\5927\5BEB\5B57\6BCD).'),
unistr('    \4F7F\7528\8005\5B9A\7FA9\5C6C\6027: 3 (\9078\64C7\6027) -  \8981\641C\5C0B\7684\8CC7\6599\6B04\6E05\55AE (\4F7F\7528\9017\865F\5340\9694).'),
unistr('       \82E5\672A\6307\5B9A\4EFB\4F55\8CC7\6599\6B04, \5247\6703\641C\5C0B\6240\6709\6587\5B57 (varchar2) \548C\5B57\5143\5927\578B\7269\4EF6 (clob) \8CC7\6599\6B04.'),
'',
unistr('\6CE8\610F: \5982\679C\5217\51FA\4E00\500B\4EE5\4E0A\7684\8868\683C, \5247\53EA\6703\5C0D\4F7F\7528\8005\986F\793A\53EF\641C\5C0B\7684\8868\683C\6E05\55AE.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110188881463314304)
,p_name=>'CA.SEARCH.RESULTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\7D50\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110209949471314323)
,p_name=>'CA.SECONDARYDISPLAYCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B21\8981\986F\793A\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110185476977314301)
,p_name=>'CA.SELECTED.TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7684\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109272502134313574)
,p_name=>'CA.SEND.BEGIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\9001\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109272994563313574)
,p_name=>'CA.SEND.COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\9001\8A08\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109272486835313574)
,p_name=>'CA.SEND.END'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\9001\7D50\675F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109272897079313574)
,p_name=>'CA.SEND.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\9001\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110215938293314327)
,p_name=>'CA.SEND.FEEDBACK.EMAILS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\9001\96FB\5B50\90F5\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110216079772314327)
,p_name=>'CA.SEND.FEEDBACK.EMAILS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C7A\5B9A\6536\5230\65B0\610F\898B\56DE\994B\6642\662F\5426\61C9\50B3\9001\96FB\5B50\90F5\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110212637118314325)
,p_name=>'CA.SEND.FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC4\4EF6\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110205164188314319)
,p_name=>'CA.SEND.TO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6536\4EF6\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110190701746314305)
,p_name=>'CA.SERIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \6578\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109402457032313677)
,p_name=>'CA.SESSION.ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110207616783314321)
,p_name=>'CA.SESSIONSTATEPROTECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D\72C0\614B\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110165955092314285)
,p_name=>'CA.SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110166051176314285)
,p_name=>'CA.SETTINGS.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6307\5B9A\7528\65BC\7522\751F\61C9\7528\7A0B\5F0F\7684\8A2D\5B9A\503C.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110190303761314305)
,p_name=>'CA.SHOW.ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109150166690313483)
,p_name=>'CA.SHOW.HIDE.SCOPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A/\96B1\85CF\7BC4\570D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110191406238314306)
,p_name=>'CA.SHOW.TIMEZONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\6642\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110191207625314305)
,p_name=>'CA.SIGN.IN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110192496216314306)
,p_name=>'CA.SIGN.OUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109402349672313677)
,p_name=>'CA.SLAVE.PID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50D5\7AD9 PID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109396384041313672)
,p_name=>'CA.SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110203215997314318)
,p_name=>'CA.SOURCE.TYPE.NOT.VALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\4F86\6E90\985E\578B\4E0D\662F\4E00\500B\6709\6548\7684\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110196152296314309)
,p_name=>'CA.SOURCES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109399265227313674)
,p_name=>'CA.START.DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110079769361314199)
,p_name=>'CA.STARTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109401064420313676)
,p_name=>'CA.STATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110210853662314323)
,p_name=>'CA.STATICDEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110175131479314291)
,p_name=>'CA.STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109397038803313673)
,p_name=>'CA.STOP.ON.WINDOW.CLOSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8996\7A97\95DC\9589\6642\505C\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109397130759313673)
,p_name=>'CA.STORE.OUTPUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\653E\5340\8F38\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110185674225314301)
,p_name=>'CA.SUBJECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\65E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110184387404314300)
,p_name=>'CA.SUBMIT.FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110079991183314199)
,p_name=>'CA.SUCCESSFUL_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F\7684\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110207903681314321)
,p_name=>'CA.SUGGESTEDVISULIZATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\8B70\7684\8996\89BA\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110199873938314312)
,p_name=>'CA.SUPPORTING.OBJECTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\652F\63F4\7684\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110199993082314312)
,p_name=>'CA.SUPPORTING.OBJECTS.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\5728\5B89\88DD\547D\4EE4\6A94\4E2D\8F38\5165\7A0B\5F0F\78BC, \901A\5E38\7528\65BC\5EFA\7ACB\6216\64CD\63A7\8CC7\6599\5EAB\7269\4EF6, \6216\662F\5C0D\73FE\6709\8A18\9304\57F7\884C\63D2\5165/\66F4\65B0/\522A\9664. \5728\89E3\9664\5B89\88DD\547D\4EE4\6A94\4E2D\8F38\5165\7A0B\5F0F\78BC, \901A\5E38\7528\65BC\79FB\9664 (\522A\9664) \8CC7\6599\5EAB\7269\4EF6. \9019\4E9B\547D\4EE4\6A94\5C07\6703\4F75\5165\652F\63F4\7269\4EF6, \4EE5\4FBF\60A8\532F\51FA\61C9\7528\7A0B\5F0F\6642\6703\5728\6E2C\8A66\548C\751F\7522\74B0\5883\4E2D\57F7\884C\76F8\540C\7684\66F4\65B0.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110200007781314312)
,p_name=>'CA.SUPPORTING.OBJECTS.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\5B89\88DD\547D\4EE4\6A94\4E2D\8F38\5165\532F\5165\61C9\7528\7A0B\5F0F\5F8C\6703\57F7\884C\7684\6709\6548 SQL \548C (\6216) PL/SQL \6558\8FF0\53E5.</p>'),
unistr('<p>\5982\679C\4E5F\8981\5728\76EE\524D\7684\74B0\5883\4E2D\57F7\884C\9019\4E9B\6558\8FF0\53E5, \800C\4E0D\662F\53EA\5728\5C07\61C9\7528\7A0B\5F0F\532F\5165\5176\4ED6\74B0\5883\6642\57F7\884C, \8ACB\6309\4E00\4E0B<strong>\5EFA\7ACB\61C9\7528\7A0B\5F0F\6642\57F7\884C</strong>.</p>'),
unistr('<p>\5728\89E3\9664\5B89\88DD\547D\4EE4\6A94\4E2D\8F38\5165\61C9\7528\7A0B\5F0F\81EA\61C9\7528\7A0B\5F0F\7522\751F\5668\522A\9664\5F8C\6703\57F7\884C\7684\6709\6548 SQL \548C (\6216) PL/SQL \6558\8FF0\53E5.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109396628721313672)
,p_name=>'CA.SYSTEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7CFB\7D71')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110209378968314322)
,p_name=>'CA.TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110166702417314285)
,p_name=>'CA.TABLE.PREFIX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67B6\69CB\7269\4EF6\524D\7F6E\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110166859151314285)
,p_name=>'CA.TABLE.PREFIX.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\4F9B\61C9\7528\7A0B\5F0F\4F7F\7528\7684\7269\4EF6\524D\7F6E\78BC. \90E8\5206\529F\80FD\6703\5728\5176\5EFA\7ACB\7684\8CC7\6599\5EAB\7269\4EF6\52A0\4E0A\6B64\524D\7F6E\78BC (\5305\62EC\5957\88DD\7A0B\5F0F\548C\8868\683C).</p>'),
unistr('<p>\8B66\544A: \8ACB\78BA\5B9A\8F38\5165\672A\7531\5176\4ED6\61C9\7528\7A0B\5F0F\4F7F\7528\7684\552F\4E00\524D\7F6E\78BC. \5982\679C\4E0D\662F\975E\552F\4E00\7684, \5EFA\7ACB\61C9\7528\7A0B\5F0F\6642\53EF\80FD\6703\767C\751F\932F\8AA4, \800C\4E14\7121\6CD5\6B63\5E38\904B\4F5C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110210206343314323)
,p_name=>'CA.TABLECOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110205262582314319)
,p_name=>'CA.TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110188720095314304)
,p_name=>'CA.TEMPLATE.EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\6A23\677F\540D\7A31\5DF2\7D93\88AB\4F7F\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110185520705314301)
,p_name=>'CA.TEMPLATE.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110174219524314291)
,p_name=>'CA.TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109272758035313574)
,p_name=>'CA.TEXT.BODY.SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\5167\6587\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110186738267314302)
,p_name=>'CA.TEXT.TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110172491828314289)
,p_name=>'CA.THEME.PREFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\4E3B\984C\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110172609675314290)
,p_name=>'CA.THEME.PREFERENCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52FE\9078\5F8C, \4E00\822C\4F7F\7528\8005\5C31\53EF\4EE5\4F7F\7528\300C\81EA\8A02\300D\9023\7D50, \9078\64C7\6240\9700\7684\4E3B\984C\6A23\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110172523371314290)
,p_name=>'CA.THEME.PREFERENCE.LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\4E00\822C\4F7F\7528\8005\9078\64C7\4E3B\984C\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110156812409314278)
,p_name=>'CA.THEME.SELECTOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\4E3B\984C\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110155264264314276)
,p_name=>'CA.THEME.SELECTOR.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\9810\8A2D\61C9\7528\7A0B\5F0F\5916\89C0\8207\611F\89BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110156931416314278)
,p_name=>'CA.THEME.SELECTOR.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8B93\7BA1\7406\54E1\80FD\5920\9078\53D6\61C9\7528\7A0B\5F0F\7684\9810\8A2D\8272\5F69\914D\7F6E (\4E3B\984C\6A23\5F0F). \7BA1\7406\54E1\4E5F\53EF\4EE5\9078\64C7\8B93\4E00\822C\4F7F\7528\8005\80FD\5920\9078\64C7\81EA\5DF1\7684\4E3B\984C\6A23\5F0F. \4E00\822C\4F7F\7528\8005\53EA\8981\6309\4E00\4E0B\9996\9801\5E95\7AEF\7684<em>\81EA\8A02</em>\6309\9215, \7136\5F8C\5F9E\53EF\7528\7684\4E3B\984C\6A23\5F0F\4E2D\9078\53D6\5373\53EF. \4F8B\5982, \6709\8996\529B\969C\7919\7684\4F7F\7528\8005\53EF\4EE5\9078\64C7\4F7F\7528\5177\6709\66F4\9AD8\8272\5F69\5C0D\6BD4\7684 <em>Vista</em> \4E3B\984C\6A23\5F0F.</p>'),
unistr('<p>\5305\62EC\4E0B\5217\5143\4EF6:'),
'<ul>',
unistr('<li>\7BA1\7406\54E1\53EF\4EE5\5B9A\7FA9\9810\8A2D\4E3B\984C\6A23\5F0F</li>'),
unistr('<li>\8B93\4E00\822C\4F7F\7528\8005\80FD\5920\9078\53D6\4E0D\540C\7684\4E3B\984C\6A23\5F0F</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110165397581314284)
,p_name=>'CA.THEME.STYLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110165431209314284)
,p_name=>'CA.THEME.STYLE.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\7528\65BC\986F\793A\61C9\7528\7A0B\5F0F\7684\9810\8A2D\4E3B\984C\6A23\5F0F.</p>'),
unistr('<p>\6A23\5F0F\53EF\5FEB\901F\5730\8B8A\66F4\70BA\53E6\4E00\500B\9810\5148\5B9A\7FA9\7684\6A23\5F0F, \6216\7522\751F\5F8C\518D\4FEE\6539\7684\6A23\5F0F. \82E5\8981\8B8A\66F4\6A23\5F0F, \8ACB\57F7\884C\61C9\7528\7A0B\5F0F, \7136\5F8C\6309\4E00\4E0B\300C\958B\767C\4EBA\54E1\300D\5DE5\5177\5217\4E2D\7684<strong>\4E3B\984C\6372\52D5\5668</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110179471439314295)
,p_name=>'CA.TIME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110171130506314289)
,p_name=>'CA.TIME.ZONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110157974111314278)
,p_name=>'CA.TIME.ZONE.SUPPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\5340\652F\63F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110154899599314276)
,p_name=>'CA.TIME.ZONE.SUPPORT.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\9810\8A2D\503C\548C\4F7F\7528\8005\6642\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110157620877314278)
,p_name=>'CA.TIME.ZONE.SUPPORT.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5141\8A31\4E00\822C\4F7F\7528\8005\8A2D\5B9A\81EA\5DF1\7684\672C\5730\6642\5340. \9019\9805\529F\80FD\5F88\91CD\8981, \82E5\61C9\7528\7A0B\5F0F\8868\683C\4F7F\7528\4E86\6642\5340\611F\77E5\7684\8CC7\6599\985E\578B (\4F8B\5982\672C\5730\6642\5340\7684\6642\6233), \5982\6B64\4E00\4F86\5831\8868\548C\8CC7\6599\9805\76EE\4FBF\6703\53CD\6620\4E00\822C\4F7F\7528\8005\7684\6240\5728\4F4D\7F6E.</p>'),
unistr('<p>\5305\62EC\4E0B\5217\5143\4EF6:'),
'<ul>',
unistr('<li>\5141\8A31\7BA1\7406\54E1\8A2D\5B9A\9810\8A2D\6642\5340</li>'),
unistr('<li>\5141\8A31\4E00\822C\4F7F\7528\8005\9078\53D6\81EA\5DF1\7684\6642\5340\504F\597D\8A2D\5B9A</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110213234220314325)
,p_name=>'CA.TIMEFRAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\9593\7BC4\570D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110213564143314325)
,p_name=>'CA.TIMELINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\6642\9593\8868\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110213652162314326)
,p_name=>'CA.TIMELINE.DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5EFA\7ACB\4E00\500B\986F\793A\6642\9593\8868\7684\9801\9762, \9019\5C0D\986F\793A\66F4\65B0\7279\5225\6709\7528.</p>'),
unistr('<p>\8F38\5165\4E0B\5217\5C6C\6027:</p>'),
'<ul>',
unistr('  <li><strong>\9801\9762\540D\7A31</strong> (\5FC5\8981) - \8F38\5165\6B64\9801\9762\7684\540D\7A31.</li>'),
unistr('  <li><strong>\8A2D\5B9A\5716\793A</strong> - \9078\53D6\6B64\9801\9762\5728\5C0E\89BD\529F\80FD\8868\4E2D\7684\986F\793A\5716\793A.</li>'),
unistr('  <li><strong>\8868\683C\6216\8996\89C0\8868</strong> (\5FC5\8981) - \9078\53D6\6642\9593\8868\7684\8CC7\6599\5EAB\7269\4EF6.</li>'),
unistr('  <li><strong>\4F7F\7528\8005\540D\7A31</strong> (\5FC5\8981) - \5F9E\8868\683C\6216\8996\89C0\8868\4E2D\9078\53D6\7576\4F5C\6642\9593\8868\9805\76EE\4E4B\986F\793A\4F7F\7528\8005\7684\8CC7\6599\6B04.</li>'),
unistr('  <li><strong>\65E5\671F</strong> (\5FC5\8981) - \5F9E\8868\683C\6216\8996\89C0\8868\4E2D\9078\53D6\7576\4F5C\6642\9593\8868\9805\76EE\65E5\671F\7684\8CC7\6599\6B04.</li>'),
unistr('  <li><strong>\4E8B\4EF6\540D\7A31</strong> (\5FC5\8981) - \5F9E\8868\683C\6216\8996\89C0\8868\4E2D\9078\53D6\7576\4F5C\6642\9593\8868\9805\76EE\6A19\984C\7684\8CC7\6599\6B04.</li>'),
unistr('  <li><strong>\63CF\8FF0</strong> - \5F9E\8868\683C\6216\8996\89C0\8868\4E2D\9078\53D6\7576\4F5C\6642\9593\8868\9805\76EE\63CF\8FF0\7684\8CC7\6599\6B04.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110176358779314292)
,p_name=>'CA.TIMESTAMP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\6233')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110180913572314296)
,p_name=>'CA.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109273388662313575)
,p_name=>'CA.TO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6536\4EF6\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110180199583314295)
,p_name=>'CA.TOP.USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5E38\4F7F\7528\7684\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110180287394314295)
,p_name=>'CA.TOP.USERS.CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5E38\4F7F\7528\7684\4F7F\7528\8005\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110177708358314293)
,p_name=>'CA.TOTAL.ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\7E3D\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110182147956314297)
,p_name=>'CA.TREAT.AUTH.USERS.NO.IN.ACL.AS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5728\5B58\53D6\63A7\5236\6E05\55AE\4E2D\7684\4F7F\7528\8005\9810\8A2D\89D2\8272:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110174315756314291)
,p_name=>'CA.TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109484876730313739)
,p_name=>'CA.UI.DEFAULTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109484901494313739)
,p_name=>'CA.UI.DEFAULTS.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\4F7F\7528\8005\4ECB\9762\8A2D\5B9A\503C\7684\9810\8A2D\503C, \4F8B\5982\6BCF\9801\7684\8CC7\6599\5217\6578\76EE\53CA\65B0\589E\503C\6E05\55AE\5B9A\7FA9. \5728\61C9\7528\7A0B\5F0F\4E2D\7522\751F\5143\4EF6\6642, \6703\4F7F\7528\9019\4E9B\8A2D\5B9A\503C. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110174517591314291)
,p_name=>'CA.UNTIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F4\5230')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109533106771313775)
,p_name=>'CA.UPDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110183972252314300)
,p_name=>'CA.UPDATE.PROFILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\8A2D\5B9A\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110174813444314291)
,p_name=>'CA.UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110174907893314291)
,p_name=>'CA.UPDATED.BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110176213905314292)
,p_name=>'CA.USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110202799250314318)
,p_name=>'CA.USER.ADD_MULTIPLE_1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\591A\500B\4F7F\7528\8005 - \6B65\9A5F 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110202898565314318)
,p_name=>'CA.USER.ADD_MULTIPLE_2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\591A\500B\4F7F\7528\8005 - \6B65\9A5F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110202984597314318)
,p_name=>'CA.USER.ADD_MULTIPLE_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\591A\500B\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110178606166314294)
,p_name=>'CA.USER.AGENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4EE3\7406\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110192096424314306)
,p_name=>'CA.USER.COUNTS.REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\6578\76EE\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110180422678314295)
,p_name=>'CA.USER.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110182948873314297)
,p_name=>'CA.USER.PROFILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\8A2D\5B9A\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110157868197314278)
,p_name=>'CA.USER.PROFILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\8A2D\5B9A\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110154796782314275)
,p_name=>'CA.USER.PROFILES.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\4F7F\7528\8005\66F4\65B0\81EA\5DF1\7684\8A2D\5B9A\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110157773453314278)
,p_name=>'CA.USER.PROFILES.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5141\8A31\4E00\822C\4F7F\7528\8005\8F38\5165\95DC\65BC\81EA\5DF1\7684\5176\4ED6\8CC7\8A0A (\5305\62EC\5716\7247\6216\5927\982D\8CBC), \5C07\4ED6\5011\7684\5E33\6236\500B\4EBA\5316.</p>'),
unistr('<p>\5305\62EC\4E0B\5217\5143\4EF6:'),
'<ul>',
unistr('<li>\8A2D\5B9A\4E00\822C\4F7F\7528\8005\8A2D\5B9A\6A94\7684\8A2D\5B9A\9801\9762</li>'),
unistr('<li>\4E0A\50B3\5716\7247 / \5927\982D\8CBC\7684\529F\80FD</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110183162796314298)
,p_name=>'CA.USERNAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110182206426314297)
,p_name=>'CA.USERNAME.FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110203655785314318)
,p_name=>'CA.USERNAMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109492394086313745)
,p_name=>'CA.USERNAME_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110204230073314319)
,p_name=>'CA.USERS.ADDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\5DF2\65B0\589E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110205701331314320)
,p_name=>'CA.USERS.BY.ROLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F9D\89D2\8272\5340\5206\7684\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110186304620314302)
,p_name=>'CA.USERS.INCLUDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\542B\7684\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110203991519314318)
,p_name=>'CA.USERS.TO.ADD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\65B0\589E\7684\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110182415515314297)
,p_name=>'CA.USRENAME.FORMAT.UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31\683C\5F0F\5DF2\66F4\65B0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109169390046313497)
,p_name=>'CA.VALID.USER.EXIST.PAGEINFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6709\6548\7684\4F7F\7528\8005\5B58\5728 - \9801\9762\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110198088017314311)
,p_name=>'CA.VALIDATION.APP.ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\61C9\7528\7A0B\5F0F ID\300D\5DF2\7D93\5B58\5728, \6216\662F\4FDD\7559\4F9B\5176\4ED6\61C9\7528\7A0B\5F0F\4F7F\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109439616522313705)
,p_name=>'CA.VALIDATION.APP.NAME.NOT.NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\61C9\7528\7A0B\5F0F\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110206350228314320)
,p_name=>'CA.VALIDATION.EMAIL.REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\63D0\4F9B\96FB\5B50\90F5\4EF6\5730\5740\4EE5\50B3\9001\96FB\5B50\90F5\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110206119641314320)
,p_name=>'CA.VALIDATION.EMAIL.ROLE.REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\63D0\4F9B\96FB\5B50\90F5\4EF6\5730\5740\6216\9078\53D6\4E00\7D44\4F7F\7528\8005\4EE5\50B3\9001\96FB\5B50\90F5\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110206292934314320)
,p_name=>'CA.VALIDATION.ROLE.REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\9078\53D6\4E00\7D44\4F7F\7528\8005\4EE5\50B3\9001\96FB\5B50\90F5\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110198152467314311)
,p_name=>'CA.VALIDATION.TABLE.PREFIX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\524D\7F6E\78BC\4E0D\80FD\8D85\904E 6 \500B\5B57\5143, \5FC5\9808\4EE5\5B57\6BCD\70BA\958B\982D, \800C\4E14\53EA\80FD\5305\542B\5B57\6BCD\3001\6578\5B57\4EE5\53CA\5E95\7DDA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110198263138314311)
,p_name=>'CA.VALIDATION.TABLE.PREFIX.USED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\8F38\5165\5176\4ED6\8868\683C\524D\7F6E\78BC. \4E0B\5217\8CC7\6599\5EAB\7269\4EF6\5DF2\7D93\5B58\5728: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110182866708314297)
,p_name=>'CA.VERIFY.EMAIL.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31\4E0D\662F\6709\6548\7684\96FB\5B50\90F5\4EF6\5730\5740\683C\5F0F. \8ACB\6CE8\610F\4E0B\65B9\7684\61C9\7528\7A0B\5F0F\4F7F\7528\8005\540D\7A31\683C\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110182785795314297)
,p_name=>'CA.VERIFY.EMAIL.FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\96FB\5B50\90F5\4EF6\5730\5740\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110180324258314295)
,p_name=>'CA.VIEW.AS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110200628319314316)
,p_name=>'CA.VIEW.BLUEPRINT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\85CD\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110190213520314305)
,p_name=>'CA.VIEW.DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\8A73\7D30\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110206584008314320)
,p_name=>'CA.VIEW.EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\96FB\5B50\90F5\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110192314516314306)
,p_name=>'CA.VIEW.MY.PROFILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\6211\7684\8A2D\5B9A\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110177213301314293)
,p_name=>'CA.WEIGHTED.PERFORMANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52A0\6B0A\6548\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110211147125314324)
,p_name=>'CA.WIDTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110215334532314327)
,p_name=>'CA.WIZARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\7CBE\9748\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109169213934313497)
,p_name=>'CA.WIZARD.CONTAINER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7CBE\9748\5BB9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110215403610314327)
,p_name=>'CA.WIZARD.DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5EFA\7ACB\4E00\500B\7576\4F5C\7CBE\9748\7684\9801\9762\96C6\5408. \7CBE\9748\901A\5E38\7528\65BC\8F38\5165\591A\500B\6B65\9A5F\7684\8CC7\6599.</p>'),
unistr('<p>\8F38\5165\4E0B\5217\5C6C\6027:</p>'),
'<ul>',
unistr('  <li><strong>\7CBE\9748\540D\7A31</strong> (\5FC5\8981) - \8F38\5165\6B64\9801\9762\7684\540D\7A31.</li>'),
unistr('  <li><strong>\8A2D\5B9A\5716\793A</strong> - \9078\53D6\6B64\9801\9762\5728\5C0E\89BD\529F\80FD\8868\4E2D\7684\986F\793A\5716\793A.</li>'),
unistr('  <li><strong>\9801\9762\6A21\5F0F</strong> (\5FC5\8981) - \9078\53D6\7CBE\9748\6B65\9A5F\662F\8981\986F\793A\70BA\5F37\5236\56DE\61C9\9801\9762\9084\662F\4E00\822C\9801\9762. \8ACB\9078\53D6<strong>\5F37\5236\56DE\61C9\9801\9762</strong>\6216<strong>\5B8C\6574\9801\9762</strong>.</li>'),
unistr('  <li><strong>\6B65\9A5F 1 ... 8</strong> - \8F38\5165\7CBE\9748\5404\6B65\9A5F\7684\9801\9762\540D\7A31.<br><em><strong>\6CE8\610F:</strong> \8F38\5165\524D\9762\5404\6B65\9A5F\7684\540D\7A31\5F8C, \7CFB\7D71\5C31\6703\986F\793A 5 - 8 \6B65\9A5F.</em></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110180724376314296)
,p_name=>'CA.WORK.PHONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\53F8\96FB\8A71\865F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110173497363314290)
,p_name=>'CA.YELLOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9EC3\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109485370991313740)
,p_name=>'CA.YES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109038373890313400)
,p_name=>'CACHED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5FEB\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108941554273313319)
,p_name=>'CACHE_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\5FEB\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108929183695313310)
,p_name=>'CALENDAR.CHECK.AJAX_DELETE_NOT_ENABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\522A\9664\8CC7\6599\300D\529F\80FD\76EE\524D\505C\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108914174523313298)
,p_name=>'CALENDAR.CHECK.AJAX_INSERT_NOT_ENABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\8CC7\6599\529F\80FD\76EE\524D\505C\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108914279305313298)
,p_name=>'CALENDAR.CHECK.AJAX_UPDATE_NOT_ENABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\8CC7\6599\529F\80FD\76EE\524D\505C\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109067094681313421)
,p_name=>'CALENDAR.NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109066970967313421)
,p_name=>'CALENDAR.PREVIOUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108953361683313329)
,p_name=>'CALENDAR_EASY_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C21\6613\884C\4E8B\66C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109971296079314123)
,p_name=>'CALENDAR_ENTRY_EDIT_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\884C\4E8B\66C6\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108902681458313289)
,p_name=>'CALENDAR_POPUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \7684\884C\4E8B\66C6\5373\73FE\5F0F\8996\7A97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109034022929313396)
,p_name=>'CALENDAR_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\884C\4E8B\66C6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109423644319313693)
,p_name=>'CALENDAR_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\820A\6709\884C\4E8B\66C6\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108953254223313329)
,p_name=>'CALENDAR_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\4E8B\66C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109286683202313589)
,p_name=>'CAL_TEMPLATE_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5617\8A66\5F9E\61C9\7528\7A0B\5F0F %0 \8907\88FD\6A23\677F ID \70BA %1 \7684\6A23\677F\6642, \627E\4E0D\5230\884C\4E8B\66C6\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109425091489313694)
,p_name=>'CANCEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108909192163313294)
,p_name=>'CARD_ACTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5361\7247\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109657086283313875)
,p_name=>'CASCADING STYLE SHEETS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\5C64\5F0F\6A23\5F0F\8868')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109504421082313754)
,p_name=>'CHANGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110081523236314201)
,p_name=>'CHANGE_AUTHENTICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4\8A8D\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109420326542313690)
,p_name=>'CHANGE_DATABASE_SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4\8CC7\6599\5EAB\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109420156621313690)
,p_name=>'CHANGE_REQUEST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109633834941313858)
,p_name=>'CHANGE_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4\5DE5\4F5C\5340')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109393668215313670)
,p_name=>'CHARACTER_SET_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\5143\96C6\8CC7\6599\6B04')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109115221798313457)
,p_name=>'CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108897970100313285)
,p_name=>'CHART.CHART_QUERY_SYNTAX_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\6548\7684\5716\8868\67E5\8A62: %0<br><br> \8ACB\4F7F\7528\4E0B\5217\8A9E\6CD5:'),
'<pre>',
'SELECT LINK, LABEL, VALUE',
'FROM   ...',
'</pre>',
'<table class="instructiontext">',
'<tr><td>LINK</td><td>URL</td></tr>',
unistr('<tr><td>LABEL</td><td>\9577\689D\4E0A\7684\6587\5B57</td></tr>'),
unistr('<tr><td>VALUE</td><td>\5B9A\7FA9\9577\689D\5927\5C0F\7684\6578\5B57\8CC7\6599\6B04</td></tr>'),
'</table>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109062840241313418)
,p_name=>'CHART.DIAL_CHART_QUERY_SYNTAX_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\6548\7684\5716\8868\67E5\8A62.<br /><br /> \8ACB\4F7F\7528\4E0B\5217\8A9E\6CD5: <pre> SELECT VALUE, MAX, (LOW), (HIGH) VALUE FROM ... </pre>'),
'<table class="instructiontext">',
'<tr>',
'<td>VALUE</td>',
unistr('<td>\5B9A\7FA9\8A08\91CF\503C\7684\6578\503C\8CC7\6599\6B04.</td>'),
'</tr>',
'<tr>',
'<td>MAX</td>',
unistr('<td>\5B9A\7FA9\6700\5927\8A08\91CF\503C\7684\6578\503C\8CC7\6599\6B04.</td>'),
'</tr>',
'<tr>',
unistr('<td>LOW (\9078\64C7\6027)</td>'),
unistr('<td>\5B9A\7FA9\4E0A\4E00\500B\6700\5C0F\8A08\91CF\503C\7684\6578\503C\8CC7\6599\6B04.</td>'),
'</tr>',
'<tr>',
unistr('<td>HIGH (\9078\64C7\6027)</td>'),
unistr('<td>\5B9A\7FA9\4E0A\4E00\500B\6700\5927\8A08\91CF\503C\7684\6578\503C\8CC7\6599\6B04.</td>'),
'</tr>',
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109129633683313468)
,p_name=>'CHART.INVALID_CHART_TYPE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\5716\8868\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108897855471313285)
,p_name=>'CHART.INVALID_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\6CD5\5256\6790 SQL \67E5\8A62!'),
'<p>%0</p>',
unistr('\67D0\4E9B\7279\5B9A\67E5\8A62\53EA\6709\5728\60A8\7684\61C9\7528\7A0B\5F0F\57F7\884C\6642\624D\80FD\57F7\884C, \5982\679C\60A8\67E5\8A62\7684\8A9E\6CD5\6B63\78BA, \90A3\60A8\53EF\4EE5\4E0D\9700\9A57\8B49\5C31\5C07\67E5\8A62\5132\5B58\8D77\4F86 (\8ACB\53C3\95B1\67E5\8A62\4F86\6E90\4E0B\65B9\7684\9078\9805).')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110121175616314249)
,p_name=>'CHART_DEGREES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109371164007313653)
,p_name=>'CHART_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108929624563313310)
,p_name=>'CHART_SERIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868\6578\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109416859702313688)
,p_name=>'CHART_SERIES_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%1 \7684\5716\8868\6578\5217\932F\8AA4 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109025844395313390)
,p_name=>'CHART_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\5716\8868.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109374958316313656)
,p_name=>'CHECKSUM_REQUIRED_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981\7E3D\548C\6AA2\9A57 - \61C9\7528\7A0B\5F0F\5C64\7D1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109208088477313526)
,p_name=>'CHECKSUM_REQUIRED_SESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981\7E3D\548C\6AA2\9A57 - \968E\6BB5\4F5C\696D\5C64\7D1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109207952169313526)
,p_name=>'CHECKSUM_REQUIRED_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981\7E3D\548C\6AA2\9A57 - \4F7F\7528\8005\5C64\7D1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109207832449313526)
,p_name=>'CHECKSUM_REQUIRED_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981\7E3D\548C\6AA2\9A57 - \61C9\7528\7A0B\5F0F\5C64\7D1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110121988415314250)
,p_name=>'CHECK_ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8\52FE\9078')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109360492515313645)
,p_name=>'CLASSIC_CALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\884C\4E8B\66C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109363180662313647)
,p_name=>'CLASSIC_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109061668481313417)
,p_name=>'CLASSIC_REPORT_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\5831\8868\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109360830973313645)
,p_name=>'CLASSIC_TREE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\6A39\72C0\7D50\69CB')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109358727055313643)
,p_name=>'CLEAN_UP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664\9801\9762')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108924454529313306)
,p_name=>'CLEAR_COMMAND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664\547D\4EE4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109368071947313651)
,p_name=>'CLOSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109413687993313685)
,p_name=>'CLOSED_LAST_7_DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904E\53BB 7 \5929\7684\5DF2\8655\7406\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109166784010313495)
,p_name=>'CLOSE_WINDOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589\8996\7A97')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109902118210314073)
,p_name=>'CODE_EDITOR.ACCESSIBILITY_MODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F14\52A9\529F\80FD\6A21\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110198332571314311)
,p_name=>'CODE_EDITOR.CLOSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110199315342314311)
,p_name=>'CODE_EDITOR.FIND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0B\627E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110199200979314311)
,p_name=>'CODE_EDITOR.HINT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5B8C\6210')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110026962941314162)
,p_name=>'CODE_EDITOR.INDENTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E2E\6392')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110198622938314311)
,p_name=>'CODE_EDITOR.INDENT_SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E2E\6392\5927\5C0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110198877441314311)
,p_name=>'CODE_EDITOR.INDENT_WITH_TABS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Tab \5B57\5143\63D2\5165\7A7A\683C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109902217195314073)
,p_name=>'CODE_EDITOR.ITEM_DOES_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE %0 \4E0D\5B58\5728')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109903334178314074)
,p_name=>'CODE_EDITOR.MINIMAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\5730\5716')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109903279894314074)
,p_name=>'CODE_EDITOR.MINIMAP_CONDITIONAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D85\904E 100 \884C\6642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110202689005314317)
,p_name=>'CODE_EDITOR.QUERY_BUILDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\8A62\7522\751F\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110199404695314312)
,p_name=>'CODE_EDITOR.REDO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\505A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110199097361314311)
,p_name=>'CODE_EDITOR.SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110198961753314311)
,p_name=>'CODE_EDITOR.SHOW_LINE_NUMBERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\884C\865F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110198403579314311)
,p_name=>'CODE_EDITOR.SHOW_RULER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5C3A\898F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109903199130314074)
,p_name=>'CODE_EDITOR.SUGGESTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5EFA\8B70')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110198761945314311)
,p_name=>'CODE_EDITOR.TAB_SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Tab \5B57\5143\5927\5C0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110198544769314311)
,p_name=>'CODE_EDITOR.THEMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109903017170314074)
,p_name=>'CODE_EDITOR.THEME_AUTOMATIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109902927541314074)
,p_name=>'CODE_EDITOR.THEME_DARK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DF1\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109902731741314073)
,p_name=>'CODE_EDITOR.THEME_HIGH_CONTRAST_DARK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DF1\8272\9AD8\5C0D\6BD4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109902879938314073)
,p_name=>'CODE_EDITOR.THEME_LIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\660E\4EAE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109902666438314073)
,p_name=>'CODE_EDITOR.TRANSFORM_CODE_CASE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F49\63DB\4EE3\78BC\6848\4F8B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110199573077314312)
,p_name=>'CODE_EDITOR.UNDO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9084\539F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109902489893314073)
,p_name=>'CODE_EDITOR.UTIL_OFF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109902539301314073)
,p_name=>'CODE_EDITOR.UTIL_ON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\555F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110199106275314311)
,p_name=>'CODE_EDITOR.VALIDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110199658451314312)
,p_name=>'CODE_EDITOR.VALIDATION_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\6210\529F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109902305663314073)
,p_name=>'CODE_EDITOR.WHITESPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\7A7A\767D\5B57\5143')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109305829944313604)
,p_name=>'COLLAPSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF ')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108937462455313316)
,p_name=>'COLOR_PALETTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69\9078\76E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109126883396313465)
,p_name=>'COLOR_PALETTE_ANALOGIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109126434460313465)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\88DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109127059276313466)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY_COLORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\88DC\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109126931721313466)
,p_name=>'COLOR_PALETTE_MONOTONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\55AE\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109126585330313465)
,p_name=>'COLOR_PALETTE_SPLIT_COMPLEMENTARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\5272\4E92\88DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109126710872313465)
,p_name=>'COLOR_PALETTE_TETRADE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56DB\5206\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109126699492313465)
,p_name=>'COLOR_PALETTE_TRIADE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E09\5206\6CD5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110114811503314244)
,p_name=>'COLUMN_DISPLAY_NAME_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\540D\7A31: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109298333003313598)
,p_name=>'COLUMN_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109486550390313741)
,p_name=>'COM.ORACLE.APEX.ACL_ALL_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\5DF2\8A8D\8B49\7684\4F7F\7528\8005\90FD\53EF\4EE5\5B58\53D6\6B64\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109486640821313741)
,p_name=>'COM.ORACLE.APEX.ACL_ONLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\6709\61C9\7528\7A0B\5F0F\5B58\53D6\63A7\5236\6E05\55AE\4E2D\5B9A\7FA9\7684\4F7F\7528\8005\53EF\4EE5\5B58\53D6\6B64\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109486770762313741)
,p_name=>'COM.ORACLE.APEX.ACL_SETTING_VALUE_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9810\671F\7684\5B58\53D6\63A7\5236\8A2D\5B9A\503C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108930507643313311)
,p_name=>'COMING_SOON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8FD1\671F\63A8\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109298892152313598)
,p_name=>'COMMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A3B\89E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109167836969313496)
,p_name=>'COMPILE_FAILURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8B6F\5931\6557, \884C <a href="javascript:goToLine(''%0'')">%0</a> (%2)<br />%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109499020605313750)
,p_name=>'COMPILE_FAILURE_TRIGGER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8B6F\5931\6557, \884C %0 (%2). \767C\751F\7DE8\8B6F\932F\8AA4\7684\884C\865F\8207\7B2C\4E00\500B BEGIN \6558\8FF0\53E5\6709\95DC. \9019\53EA\6703\5F71\97FF\8CC7\6599\5EAB\89F8\767C\7A0B\5F0F\7684\7DE8\8B6F.<br />%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109167751287313496)
,p_name=>'COMPILE_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\7DE8\8B6F PL/SQL \7A0B\5F0F\78BC (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109365484389313649)
,p_name=>'COMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109372447517313654)
,p_name=>'COMPLETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109379348816313659)
,p_name=>'COMPLETE_NO_ISSUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210 / \6C92\6709\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109414169836313686)
,p_name=>'COMPONENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109542214631313782)
,p_name=>'COMPONENT_NAME_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6\540D\7A31: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109733297122313948)
,p_name=>'COMPONENT_NOT_ENABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\555F\7528\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109029425765313393)
,p_name=>'COMPONENT_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\5143\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110112580931314242)
,p_name=>'COMPONENT_SUMMARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6\6458\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108977913455313349)
,p_name=>'COMPUTATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109436337828313702)
,p_name=>'COMP_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5B89\88DD\61C9\7528\7A0B\5F0F\5143\4EF6.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109168308894313496)
,p_name=>'CONDITIONAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\689D\4EF6\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109284006796313587)
,p_name=>'CONDITIONS_POPUP_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5373\73FE\5F0F\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109358278006313643)
,p_name=>'CONDITIONS_SHORTCUT_ALWAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109089862505313438)
,p_name=>'CONDITIONS_SHORTCUT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109089253160313437)
,p_name=>'CONDITIONS_SHORTCUT_EXPRESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109089347450313437)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_E_VAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE / \8CC7\6599\6B04=\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109089441283313438)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE / \8CC7\6599\6B04\4E0D\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109903428534314074)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE/\8CC7\6599\6B04\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109089934145313438)
,p_name=>'CONDITIONS_SHORTCUT_NEVER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\4E0D\6210\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109090015186313438)
,p_name=>'CONDITIONS_SHORTCUT_NONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109089675188313438)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_IN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\542B\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109089785835313438)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_NOT_IN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5305\542B\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109089517108313438)
,p_name=>'CONDITIONS_SHORTCUT_REQ_E_E1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42=e1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109100941992313446)
,p_name=>'CONDITION_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\689D\4EF6\985E\578B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109321260138313616)
,p_name=>'CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108890387322313280)
,p_name=>'CONFIRM.2_PAGE_MASTER_DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('2 \9801\4E3B\8981\660E\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108890206879313279)
,p_name=>'CONFIRM.3_PAGE_MASTER_DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('3 \9801\4E3B\8981\660E\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109075783468313427)
,p_name=>'CONFIRM.ACTUAL_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BE6\969B\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109365274531313648)
,p_name=>'CONFIRM.AGG_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\8CC7\6599\6B04\805A\7E3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109365338221313649)
,p_name=>'CONFIRM.AGG_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\4F7F\7528\7684\805A\7E3D\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109073168243313425)
,p_name=>'CONFIRM.APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109086692996313435)
,p_name=>'CONFIRM.APPLICATION_ALIAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109086796293313436)
,p_name=>'CONFIRM.APPLICATION_DEFAULT_LANG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109086512588313435)
,p_name=>'CONFIRM.APPLICATION_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108983522076313353)
,p_name=>'CONFIRM.ARRAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\544A\7D50\679C\6A39\72C0\7D50\69CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108983640817313353)
,p_name=>'CONFIRM.ARRAY_PARMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\544A\7D50\679C\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109086849432313436)
,p_name=>'CONFIRM.AUTHENTICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109540367151313781)
,p_name=>'CONFIRM.BRANCH_TO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\5230\5206\652F\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109289514935313592)
,p_name=>'CONFIRM.BREAK_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\6BB5\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109075544671313427)
,p_name=>'CONFIRM.BUTTON_BRANCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \6309\9215\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109075473875313427)
,p_name=>'CONFIRM.BUTTON_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \6309\9215\986F\793A\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108910814457313295)
,p_name=>'CONFIRM.CALENDAR_ENABLE_AJAX_DATA_ADD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\65B0\589E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108910725931313295)
,p_name=>'CONFIRM.CALENDAR_ENABLE_DRAG_AND_DROP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\62D6\653E\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109488879010313742)
,p_name=>'CONFIRM.CANCEL_BRANCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109540151704313781)
,p_name=>'CONFIRM.CANCEL_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88\6309\9215\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109532288345313775)
,p_name=>'CONFIRM.CASE_SENSITIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6709\5927\5C0F\5BEB\4E4B\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109166234213313495)
,p_name=>'CONFIRM.CHANGE_INTERACTIVE_RPT_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\8B8A\66F4\300C\4E92\52D5\5F0F\5831\8868\300D\67E5\8A62.  \5982\679C\60A8\79FB\9664\67E5\8A62\4E2D\7684\8CC7\6599\6B04, \5C07\6703\4E00\4F75\505C\7528\53C3\7167\9019\4E9B\8CC7\6599\6B04\7684\73FE\6709\7BE9\9078\3001\6A19\793A\898F\5247\4EE5\53CA\5176\4ED6\5831\8868\8A2D\5B9A\503C. \8ACB\78BA\8A8D\60A8\7684\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109076604959313428)
,p_name=>'CONFIRM.CHART_AXIS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868\5EA7\6A19\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109425497962313694)
,p_name=>'CONFIRM.CHART_DIAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A08\91CF\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109425533409313694)
,p_name=>'CONFIRM.CHART_DIALSWEEP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A08\91CF\5716 (\6307\793A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109077333993313429)
,p_name=>'CONFIRM.CHART_HORIZONTAL_BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C34\5E73\9577\689D\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109077578052313429)
,p_name=>'CONFIRM.CHART_LINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6298\7DDA\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109076855213313428)
,p_name=>'CONFIRM.CHART_NUMBER_MASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6578\5B57\906E\7F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109077409194313429)
,p_name=>'CONFIRM.CHART_PIE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\9905\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109076563732313428)
,p_name=>'CONFIRM.CHART_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109076774990313428)
,p_name=>'CONFIRM.CHART_SCALE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\6578\4F4D\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109077669414313429)
,p_name=>'CONFIRM.CHART_SCATTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6563\5E03\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109077198058313428)
,p_name=>'CONFIRM.CHART_SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109077019761313428)
,p_name=>'CONFIRM.CHART_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109076923778313428)
,p_name=>'CONFIRM.CHART_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109077220850313428)
,p_name=>'CONFIRM.CHART_VERTICAL_BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5782\76F4\9577\689D\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108983785186313353)
,p_name=>'CONFIRM.COLLECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66AB\6642\7D50\679C\96C6\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109073939673313426)
,p_name=>'CONFIRM.COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109289316472313591)
,p_name=>'CONFIRM.COLUMN_HEADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109452011785313715)
,p_name=>'CONFIRM.COLUMN_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109489050891313742)
,p_name=>'CONFIRM.COLUMN_NAMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109086295385313435)
,p_name=>'CONFIRM.COL_HEAD_SORTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8CC7\6599\6B04\6A19\984C\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109210208018313528)
,p_name=>'CONFIRM.COPY_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\8907\88FD\61C9\7528\7A0B\5F0F.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109084864930313434)
,p_name=>'CONFIRM.COPY_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\8907\88FD\9801\9762.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109074465320313426)
,p_name=>'CONFIRM.CREATE.NEW.TABSET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\5EFA\7ACB "%0" \6B64\65B0\9801\7C64\96C6, \4E26\7531\6B64\9801\9762\4F7F\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109086495895313435)
,p_name=>'CONFIRM.CREATE_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5EFA\7ACB\61C9\7528\7A0B\5F0F.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109078950523313430)
,p_name=>'CONFIRM.CREATE_CALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5EFA\7ACB\884C\4E8B\66C6\9801\9762.   \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109082163585313432)
,p_name=>'CONFIRM.CREATE_DRILL_DOWN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5EFA\7ACB\5411\4E0B\5C55\958B\5831\8868\9801\9762.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109135009527313472)
,p_name=>'CONFIRM.CREATE_DYNAMIC_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5EFA\7ACB\300C\4E92\52D5\5F0F\5831\8868\300D\9801\9762. \8ACB\78BA\8A8D\60A8\6240\9078\64C7\7684\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109085134826313434)
,p_name=>'CONFIRM.CREATE_EASY_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5EFA\7ACB\5831\8868\9801\9762.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110093528342314210)
,p_name=>'CONFIRM.CREATE_FLOW_APP_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\8207\76EE\524D\5DE5\4F5C\5340\4E2D\73FE\6709\300C\8CC7\6599\5EAB\300D\61C9\7528\7A0B\5F0F\76F8\540C\7684 ID \4F86\5EFA\7ACB\300C\8CC7\6599\5EAB\300D\61C9\7528\7A0B\5F0F. \5C07\6703\522A\9664\73FE\6709\7684\300C\8CC7\6599\5EAB\300D\61C9\7528\7A0B\5F0F, \4E26\4EE5\65B0\7684\300C\8CC7\6599\5EAB\300D\61C9\7528\7A0B\5F0F\53D6\4EE3. \8ACB\78BA\8A8D\60A8\7684\9078\64C7. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109448967258313713)
,p_name=>'CONFIRM.CREATE_FORM_AND_LIST_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5EFA\7ACB\8868\55AE\548C\6E05\55AE\6AA2\8996\9801\9762.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109364900212313648)
,p_name=>'CONFIRM.CREATE_FORM_AND_REPORT_WITH_ANALYSIS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\5EFA\7ACB\8868\55AE\548C\5177\6709\5206\6790\9801\9762\7684\5831\8868\9801\9762. \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109078575759313429)
,p_name=>'CONFIRM.CREATE_FORM_ON_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5728 SQL \67E5\8A62\5EFA\7ACB\8868\55AE.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109078480787313429)
,p_name=>'CONFIRM.CREATE_FORM_ON_SP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5728\9810\5B58\7A0B\5E8F\5EFA\7ACB\8868\55AE.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109078390966313429)
,p_name=>'CONFIRM.CREATE_FORM_ON_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5728\8868\683C\9801\9762\5EFA\7ACB\8868\55AE.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108954054552313330)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5728 Web \670D\52D9\53C3\7167\9801\9762\5EFA\7ACB\8868\55AE.   \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108994267139313366)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS_RPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5728 Web \670D\52D9\53C3\7167\9801\9762\5EFA\7ACB\8868\55AE\548C\5831\8868.   \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109392595142313669)
,p_name=>'CONFIRM.CREATE_MAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\4F86\5EFA\7ACB\300C\5730\5716\300D\9801\9762. \8ACB\78BA\8A8D\60A8\9078\64C7\7684\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108887928238313278)
,p_name=>'CONFIRM.CREATE_MASTER_DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5EFA\7ACB\4E3B\8981\660E\7D30\9801\9762. \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109080176332313431)
,p_name=>'CONFIRM.CREATE_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5EFA\7ACB\5C0E\89BD\8DEF\5F91\5340\57DF\548C\5C0E\89BD\8DEF\5F91\9078\9805.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109371299774313653)
,p_name=>'CONFIRM.CREATE_MODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109078107662313429)
,p_name=>'CONFIRM.CREATE_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5EFA\7ACB\9801\9762.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110142517399314266)
,p_name=>'CONFIRM.CREATE_PAGE_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110142672329314266)
,p_name=>'CONFIRM.CREATE_PAGE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\9801\9762\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109080936659313431)
,p_name=>'CONFIRM.CREATE_QUERY_AND_UPDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5EFA\7ACB\8868\55AE\548C\5831\8868\9801\9762.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110089487000314206)
,p_name=>'CONFIRM.CREATE_REGION_PLUGIN_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5EFA\7ACB\9801\9762.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109084973062313434)
,p_name=>'CONFIRM.CREATE_REPORT_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5EFA\7ACB\5831\8868\9801\9762.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109078618259313430)
,p_name=>'CONFIRM.CREATE_SIMPLE_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5EFA\7ACB\300CHTML \9577\689D\5716\9801\9762\300D.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109084547062313434)
,p_name=>'CONFIRM.CREATE_SUMMARY_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5EFA\7ACB\6458\8981\9801\9762. \6309\300C\65B0\589E\5176\4ED6\9805\76EE\300D\6309\9215\53EF\65B0\589E\5176\4ED6\9801\9762\548C (\6216) \5340\57DF\7684\9805\76EE. \6309\300C\5B8C\6210\300D\53EF\5EFA\7ACB\6458\8981\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109078763722313430)
,p_name=>'CONFIRM.CREATE_SVG_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5EFA\7ACB SVG \5716\8868\9801\9762.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109078088559313429)
,p_name=>'CONFIRM.CREATE_TABULAR_FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5EFA\7ACB\5217\8868\5316\8868\55AE.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109079250681313430)
,p_name=>'CONFIRM.CREATE_TREE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\4F86\5EFA\7ACB\6A39\72C0\7D50\69CB\9801\9762. \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109078294013313429)
,p_name=>'CONFIRM.CREATE_WIZARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5EFA\7ACB\7CBE\9748.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110093441006314210)
,p_name=>'CONFIRM.CREATE_WS_APP_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\8207\76EE\524D\5DE5\4F5C\5340\4E2D\73FE\6709\300CWeb \8A66\7B97\8868\300D\61C9\7528\7A0B\5F0F\76F8\540C\7684 ID \4F86\5EFA\7ACB\300CWeb \8A66\7B97\8868\300D\61C9\7528\7A0B\5F0F. \5C07\6703\522A\9664\73FE\6709\7684\300CWeb \8A66\7B97\8868\300D\61C9\7528\7A0B\5F0F, \4E26\4EE5\65B0\7684\300CWeb \8A66\7B97\8868\300D\61C9\7528\7A0B\5F0F\53D6\4EE3. \8ACB\78BA\8A8D\60A8\7684\9078\64C7. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109286020859313589)
,p_name=>'CONFIRM.CSV_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110030126136314165)
,p_name=>'CONFIRM.DATA_LOAD_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\5B9A\7FA9\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110100590893314232)
,p_name=>'CONFIRM.DATA_LOAD_NAME_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4F7F\7528\73FE\6709\7684\8868\683C\67E5\5C0B\548C\8F49\63DB\898F\5247\91CD\65B0\5EFA\7ACB\6B64\300C\8CC7\6599\8F09\5165\5B9A\7FA9\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109532379983313775)
,p_name=>'CONFIRM.DATA_LOAD_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109079044249313430)
,p_name=>'CONFIRM.DATE_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109371303720313653)
,p_name=>'CONFIRM.DEFAULT_AUTH_SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\8A8D\8B49\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109077964989313429)
,p_name=>'CONFIRM.DELETE_PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109082855079313433)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\660E\7D30 %0 \986F\793A\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108890736191313280)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\660E\7D30\986F\793A\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109084461593313434)
,p_name=>'CONFIRM.DETAIL_MENU_COL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\660E\7D30\5C0E\89BD\8DEF\5F91\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109083631938313433)
,p_name=>'CONFIRM.DETAIL_ORDER_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\660E\7D30\8868\683C %0 \9806\5E8F\4F9D\64DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109082351694313432)
,p_name=>'CONFIRM.DETAIL_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\660E\7D30\9801\9762 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108890669164313280)
,p_name=>'CONFIRM.DETAIL_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\660E\7D30\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109082637829313432)
,p_name=>'CONFIRM.DETAIL_TABLE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\660E\7D30\8868\683C\540D\7A31 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109082492490313432)
,p_name=>'CONFIRM.DETAIL_TAB_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\660E\7D30\9801\7C64\6A19\7C64 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109489350409313742)
,p_name=>'CONFIRM.DISPLAY_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\50B3\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109076050229313428)
,p_name=>'CONFIRM.DISPLAY_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109451790212313715)
,p_name=>'CONFIRM.DISPLAY_COLUMN_2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\50B3\8CC7\6599\6B04 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109451815045313715)
,p_name=>'CONFIRM.DISPLAY_COLUMN_3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\50B3\8CC7\6599\6B04 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109080314087313431)
,p_name=>'CONFIRM.DISPLAY_POINT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110150139676314271)
,p_name=>'CONFIRM.EDIT_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110150272458314272)
,p_name=>'CONFIRM.EDIT_PAGE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\9801\9762\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109275964030313581)
,p_name=>'CONFIRM.ENABLE_CSV_OUTPUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSV \8F38\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109276604779313582)
,p_name=>'CONFIRM.ENABLE_PRINT_OUTPUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\5370\8F38\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109277223298313582)
,p_name=>'CONFIRM.ENABLE_SORTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\8CC7\6599\6B04\6A19\984C\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109323197891313617)
,p_name=>'CONFIRM.EXISTING_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\5728\73FE\6709\7BA1\7406\9801\9762\65B0\589E\4E00\500B\5340\57DF:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109488919116313742)
,p_name=>'CONFIRM.FINISH_BRANCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109081434865313432)
,p_name=>'CONFIRM.FORM_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109081534688313432)
,p_name=>'CONFIRM.FORM_PAGE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE\9801\9762\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109081715573313432)
,p_name=>'CONFIRM.FORM_PAGE_TAB_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE\9801\9762\9801\7C64\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109081672904313432)
,p_name=>'CONFIRM.FORM_PAGE_TAB_SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE\9801\9762\9801\7C64\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109371411970313653)
,p_name=>'CONFIRM.IMPORT_SHARED_COMPONENTS_FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\5165\5171\7528\5143\4EF6\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109718268050313936)
,p_name=>'CONFIRM.INCLUDE_CUSTOM_CALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\62EC\81EA\8A02\884C\4E8B\66C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108890926493313280)
,p_name=>'CONFIRM.INCLUDE_MASTER_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\5305\62EC\4E3B\8981\5831\8868?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109084136545313434)
,p_name=>'CONFIRM.INC_BREAD_CRUMB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\62EC\5C0E\89BD\8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109075235188313427)
,p_name=>'CONFIRM.INFORMATION_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\8A0A\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109075337182313427)
,p_name=>'CONFIRM.INFORMATION_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\8A0A\9810\8A2D\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108954281048313330)
,p_name=>'CONFIRM.INPUT_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108983952909313353)
,p_name=>'CONFIRM.INPUT_REGION_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE\5340\57DF\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108983891095313353)
,p_name=>'CONFIRM.INPUT_REGION_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE\5340\57DF\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109077712748313429)
,p_name=>'CONFIRM.INSERT_PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D2\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109075068236313427)
,p_name=>'CONFIRM.ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109489273501313742)
,p_name=>'CONFIRM.KEY_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109488186261313742)
,p_name=>'CONFIRM.KEY_COLUMN_1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\5C0B\7D22\5F15\9375\8CC7\6599\6B04 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109488280273313742)
,p_name=>'CONFIRM.KEY_COLUMN_2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D22\5F15\9375\8CC7\6599\6B04 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109488376755313742)
,p_name=>'CONFIRM.KEY_COLUMN_3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D22\5F15\9375\8CC7\6599\6B04 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109079119989313430)
,p_name=>'CONFIRM.LABEL_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109451944411313715)
,p_name=>'CONFIRM.LOOKUP_OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\5C0B\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109489169340313742)
,p_name=>'CONFIRM.LOOKUP_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\5C0B\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108891092030313280)
,p_name=>'CONFIRM.MASTER_DETAIL_LAYOUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\660E\7D30\7248\9762\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108890521821313280)
,p_name=>'CONFIRM.MASTER_DISPLAY_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\986F\793A\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108890835686313280)
,p_name=>'CONFIRM.MASTER_SORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\4E3B\8981\8A18\9304\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108890459319313280)
,p_name=>'CONFIRM.MASTER_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109289450937313592)
,p_name=>'CONFIRM.MAXIMUM_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\6578\76EE\4E0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109285814748313589)
,p_name=>'CONFIRM.MAX_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\9801\8CC7\6599\5217\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109142159798313477)
,p_name=>'CONFIRM.MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109080673971313431)
,p_name=>'CONFIRM.MENU_LINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109084254866313434)
,p_name=>'CONFIRM.MENU_ROOT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\6839\76EE\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109080446446313431)
,p_name=>'CONFIRM.MENU_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109080711382313431)
,p_name=>'CONFIRM.MENU_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108956731112313332)
,p_name=>'CONFIRM.MIGRATE_HTML_TO_HTML5'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\5C07\6B64 HTML \5716\8868\5347\7D1A\70BA\65B0\7684 HTML5 \5716\8868. \8ACB\78BA\8A8D\60A8\7684\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110109156956314240)
,p_name=>'CONFIRM.MIGRATE_JSTREE_TO_APEXTREE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\5C07 jsTree \5347\7D1A\70BA\65B0\7684\300C\6A39\72C0\7D50\69CB\300D. \8ACB\78BA\8A8D\60A8\7684\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109066847227313421)
,p_name=>'CONFIRM.MIGRATE_SVG_RESTRICTION'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5347\7D1A SVG \5716\8868\7684\9650\5236\5982\4E0B:  '),
'<ul>',
'<li>',
unistr('\53EA\6703\79FB\8F49\5EA7\6A19\8EF8\683C\5F0F\5B57\4E32\4E2D\5B9A\7FA9\7684\6578\5B57\683C\5F0F.  \5C07\5FFD\7565\65E5\671F\548C\6642\9593\683C\5F0F.'),
'</li>',
'<li>',
unistr('\5C07\79FB\8F49\542B\6709\4E0B\5217\9805\76EE\7684\6578\5B57\683C\5F0F\5143\7D20:'),
'<br />',
unistr('0,9,D,G,, (\9017\865F),. (\53E5\865F),$,C,L,FM'),
'</li>',
'<li>',
unistr('Flash \5716\8868\4E2D\6BCF\500B\6578\5217\7684\6A19\7C64\5C07\81EA\6BCF\500B\6578\5217\7684\8CC7\6599\6B04\5225\540D\884D\751F.  '),
unistr('SVG \5716\8868\4E2D\6BCF\500B\6578\5217\7684\6A19\7C64\5247\662F\81EA\300C\6578\5217\540D\7A31\300D\5C6C\6027\884D\751F.'),
'</li>',
'<li>',
unistr('\300CFlash \8A08\91CF\300D\5716\8868\6703\986F\793A\5BE6\969B\7684\503C\800C\975E\767E\5206\6BD4.'),
'</li>',
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109030839241313394)
,p_name=>'CONFIRM.MIGRATE_SVG_TO_HTML5'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\5C07 SVG \5716\8868\5347\7D1A\70BA HTML5 \5716\8868.  \8ACB\78BA\8A8D\60A8\7684\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110089247371314206)
,p_name=>'CONFIRM.NAVIGATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109087105266313436)
,p_name=>'CONFIRM.NAV_BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109700549080313922)
,p_name=>'CONFIRM.NAV_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\529F\80FD\8868\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109382759064313662)
,p_name=>'CONFIRM.NEW_ADMIN_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\5217\9801\9762\5C07\6703\65B0\589E\70BA\65B0\7684\7BA1\7406\9801\9762:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109166434249313495)
,p_name=>'CONFIRM.NEW_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109075853454313427)
,p_name=>'CONFIRM.NEW_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109539965739313780)
,p_name=>'CONFIRM.NEXT_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\4E0B\4E00\6B65\6309\9215\300D\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109074382800313426)
,p_name=>'CONFIRM.NO.TABSET.SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9078\53D6\6B64\9801\9762\7684\9801\7C64\96C6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109074900312313427)
,p_name=>'CONFIRM.NO_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108954344437313330)
,p_name=>'CONFIRM.OUTPUT_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\51FA\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109076281573313428)
,p_name=>'CONFIRM.OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109073213395313425)
,p_name=>'CONFIRM.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109086954253313436)
,p_name=>'CONFIRM.PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109073356267313425)
,p_name=>'CONFIRM.PAGE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109074282301313426)
,p_name=>'CONFIRM.PAGE_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109082710827313433)
,p_name=>'CONFIRM.PARENT_DISPLAY_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\986F\793A\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109080817827313431)
,p_name=>'CONFIRM.PARENT_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\5C0E\89BD\8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109084374290313434)
,p_name=>'CONFIRM.PARENT_MENU_COL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\5C0E\89BD\8DEF\5F91\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109082962641313433)
,p_name=>'CONFIRM.PARENT_ORDER_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\8868\683C\6392\5217\9806\5E8F\4F9D\64DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109082211489313432)
,p_name=>'CONFIRM.PARENT_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109082579979313432)
,p_name=>'CONFIRM.PARENT_TABLE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\8868\683C\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109074844265313426)
,p_name=>'CONFIRM.PARENT_TAB_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\9801\7C64\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109074783223313426)
,p_name=>'CONFIRM.PARENT_TAB_SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\9801\7C64\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109166125911313495)
,p_name=>'CONFIRM.PARSING_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5256\6790\7DB1\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109172818997313500)
,p_name=>'CONFIRM.PARTIAL_REFRESH_CALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6574\7406\90E8\5206\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109540057131313780)
,p_name=>'CONFIRM.PREVIOUS_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\4E0A\4E00\6B65\6309\9215\300D\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109074167769313426)
,p_name=>'CONFIRM.PRIMARY_KEY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109081842819313432)
,p_name=>'CONFIRM.PRIMARY_KEY_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109286164590313589)
,p_name=>'CONFIRM.PRINT_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\51FA\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109289621901313592)
,p_name=>'CONFIRM.PRINT_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\5370\9023\7D50\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109286299251313589)
,p_name=>'CONFIRM.PRINT_OUTPUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\5217\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109076180498313428)
,p_name=>'CONFIRM.PROCESS_OPTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4F5C\696D\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109285944257313589)
,p_name=>'CONFIRM.REGION_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109075152905313427)
,p_name=>'CONFIRM.REGION_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109073480588313425)
,p_name=>'CONFIRM.REGION_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109080242341313431)
,p_name=>'CONFIRM.REGION_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109166390656313495)
,p_name=>'CONFIRM.REMOVED_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664\7684\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109081907750313432)
,p_name=>'CONFIRM.REPORT_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109305962678313604)
,p_name=>'CONFIRM.REPORT_IMPLEMENTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\5BE6\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109081038192313431)
,p_name=>'CONFIRM.REPORT_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109081175910313431)
,p_name=>'CONFIRM.REPORT_PAGE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\9801\9762\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109081393881313431)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\9801\9762\9801\7C64\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109081256343313431)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\9801\9762\9801\7C64\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108984170936313353)
,p_name=>'CONFIRM.REPORT_REGION_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\5340\57DF\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108984062043313353)
,p_name=>'CONFIRM.REPORT_REGION_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\5340\57DF\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109085210703313434)
,p_name=>'CONFIRM.REPORT_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108986603707313355)
,p_name=>'CONFIRM.ROW_VERSION_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\7248\672C\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109085497528313435)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D: HTML (\6A19\6E96)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109085710480313435)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME11'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D: \5916\89C0 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109085884011313435)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME12'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D: \5916\89C0 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109165985289313495)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME13'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D: \5916\89C0 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109166055095313495)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME14'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D: \5916\89C0 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108984605240313354)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME15'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D: \5916\89C0 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109085571688313435)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D: \5782\76F4\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109085964259313435)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME21'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\51FA: CSV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109086058504313435)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME22'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\51FA: XML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109085657520313435)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D: \5782\76F4\5831\8868, \5916\89C0 1 (\5305\62EC\7A7A\503C\8CC7\6599\6B04)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109165792601313495)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D: \5782\76F4\5831\8868, \5916\89C0 2 (\6392\9664\7A7A\503C\8CC7\6599\6B04)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109165827295313495)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME5'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D: \91CD\76F4\5831\8868, \5916\89C0 2 (\5305\62EC\7A7A\503C\8CC7\6599\6B04)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109489455308313743)
,p_name=>'CONFIRM.RULE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\898F\5247\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109489686681313743)
,p_name=>'CONFIRM.RULE_SEQUENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109489711420313743)
,p_name=>'CONFIRM.RULE_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\898F\5247\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108929361476313310)
,p_name=>'CONFIRM.RUN_SCRIPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\57F7\884C\4E0B\5217\547D\4EE4\6A94.  \8ACB\78BA\8A8D\60A8\7684\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109080573709313431)
,p_name=>'CONFIRM.SEQUENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109085334872313434)
,p_name=>'CONFIRM.SORT_OPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5E8F\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109076462491313428)
,p_name=>'CONFIRM.SQL_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109172777362313500)
,p_name=>'CONFIRM.STANDARD_CALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109320849517313615)
,p_name=>'CONFIRM.STARTING_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\5F9E\4EE5\4E0B\9801\9762\958B\59CB\5EFA\7ACB\591A\500B\9801\9762:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109076333290313428)
,p_name=>'CONFIRM.STORED_PROCEDURE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\5B58\7A0B\5E8F\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109167615847313496)
,p_name=>'CONFIRM.STORED_PROCEDURE_OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\5B58\7A0B\5E8F\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109540217092313781)
,p_name=>'CONFIRM.SUBMIT_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210\6309\9215\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110104550916314235)
,p_name=>'CONFIRM.SUBSCRIBE_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109075675549313427)
,p_name=>'CONFIRM.SUGGESTED_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\8B70\7684\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109365073886313648)
,p_name=>'CONFIRM.TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C/\8996\89C0\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109365150670313648)
,p_name=>'CONFIRM.TABLE_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\8CC7\6599\6B04\5F59\7E3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109551359418313789)
,p_name=>'CONFIRM.TABLE_LOOKUPS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\67E5\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109073881788313426)
,p_name=>'CONFIRM.TABLE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109073705775313426)
,p_name=>'CONFIRM.TABLE_OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109651442117313871)
,p_name=>'CONFIRM.TABLE_RULE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F49\63DB\898F\5247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109489802807313743)
,p_name=>'CONFIRM.TABLE_RULES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F49\63DB\898F\5247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109166683499313495)
,p_name=>'CONFIRM.TABLE_VIEW_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C/\8996\89C0\8868\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109166592878313495)
,p_name=>'CONFIRM.TABLE_VIEW_OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C/\8996\89C0\8868\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109087023680313436)
,p_name=>'CONFIRM.TABS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109074612949313426)
,p_name=>'CONFIRM.TABSET.INCOMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A, \9801\7C64\96C6\8CC7\8A0A\4E0D\5B8C\6574.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109073601216313426)
,p_name=>'CONFIRM.TAB_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109085097475313434)
,p_name=>'CONFIRM.TAB_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109073568820313426)
,p_name=>'CONFIRM.TAB_SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109086185481313435)
,p_name=>'CONFIRM.TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109079835983313430)
,p_name=>'CONFIRM.TREE_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\5177\6709\5373\73FE\5F0F\503C\6E05\55AE\7684\65B0\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109079521348313430)
,p_name=>'CONFIRM.TREE_MAX_LEVEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C64\7D1A\4E0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109079320496313430)
,p_name=>'CONFIRM.TREE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109079735503313430)
,p_name=>'CONFIRM.TREE_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109079921713313430)
,p_name=>'CONFIRM.TREE_SQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EE5\300CSQL \67E5\8A62\300D\70BA\57FA\790E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109079681208313430)
,p_name=>'CONFIRM.TREE_START'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\6A39\72C0\7D50\69CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109080057600313431)
,p_name=>'CONFIRM.TREE_STATIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109079479438313430)
,p_name=>'CONFIRM.TREE_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109087206036313436)
,p_name=>'CONFIRM.UI_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109087397680313436)
,p_name=>'CONFIRM.UI_THEME1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\85CD\8272\548C\9EC3\8910\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109087441227313436)
,p_name=>'CONFIRM.UI_THEME2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D05\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109087553046313436)
,p_name=>'CONFIRM.UI_THEME4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D77\85CD\548C\7070\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109087609444313436)
,p_name=>'CONFIRM.UI_THEME5'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A44\6B16\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109087760801313436)
,p_name=>'CONFIRM.UI_THEME6'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6697\7D05\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109087804644313436)
,p_name=>'CONFIRM.UI_THEME7'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C21\55AE\85CD\8272\548C\9EC3\8910\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109087950767313436)
,p_name=>'CONFIRM.UI_THEME8'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\85CD\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109088007082313437)
,p_name=>'CONFIRM.UI_THEME_NONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109074083568313426)
,p_name=>'CONFIRM.UPDATEABLE_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\66F4\65B0\7684\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109077808215313429)
,p_name=>'CONFIRM.UPDATE_PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109074509119313426)
,p_name=>'CONFIRM.USE.EXISTING.TABSET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\5C07\6703\4F7F\7528\73FE\6709\7684\9801\7C64\96C6 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108954167215313330)
,p_name=>'CONFIRM.WEB_SERVICE_REF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \670D\52D9\53C3\7167, \4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109082086863313432)
,p_name=>'CONFIRM.WHERE_CLAUSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Where \5B50\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109355531766313641)
,p_name=>'CONFIRMATION_ICON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78BA\8A8D\5716\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109365819790313649)
,p_name=>'CONFIRMED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109366107707313649)
,p_name=>'CONFIRMED_BY_QA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7531 QA \78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109286483519313589)
,p_name=>'CONFIRM_BREAK_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\6BB5\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109286333654313589)
,p_name=>'CONFIRM_PRINT_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\5370\683C\5F0F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109393798166313670)
,p_name=>'CONTENT_DISPOSITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5BB9\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109426413761313695)
,p_name=>'CONTENT_SERVED_IN_KBYTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\7684\5167\5BB9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110204663325314319)
,p_name=>'CONTRIBUTORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\8005')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110119243995314248)
,p_name=>'COPY.PAGE.NEW_STATIC_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\975C\614B ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109165535683313494)
,p_name=>'COPY_ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109030641509313394)
,p_name=>'COPY_APP_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7D93\8907\88FD\60A8\7684\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109144978556313479)
,p_name=>'COPY_BUTTON.EXECUTION_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C copy_button \6642\767C\751F\932F\8AA4: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109210870241313528)
,p_name=>'COPY_DEPLOYMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\7269\4EF6\5B9A\7FA9\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109005742302313375)
,p_name=>'COPY_EXISTING_APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109449735217313713)
,p_name=>'COPY_FEATURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\529F\80FD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109210497047313528)
,p_name=>'COPY_FROM_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\4F86\6E90\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109591346530313823)
,p_name=>'COPY_FROM_APP_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\6A23\677F\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109210516224313528)
,p_name=>'COPY_FROM_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\4F86\6E90\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109034489876313397)
,p_name=>'COPY_LIST_ENTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\6E05\55AE\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109145396559313479)
,p_name=>'COPY_NAMED_LOV.EXECUTION_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C copy_named_lov \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109145264804313479)
,p_name=>'COPY_NAMED_LOV.NOT_FOUND_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\300C\503C\6E05\55AE\300DID "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109145159842313479)
,p_name=>'COPY_NAMED_LOV.NUMERIC_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\503C\6E05\55AE\300DID "%0" \4E0D\662F\6578\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109431235489313698)
,p_name=>'COPY_PAGE.COPY_FROM_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\4F86\6E90\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109431319142313698)
,p_name=>'COPY_PAGE.COPY_TO_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\76EE\6A19\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109430396429313698)
,p_name=>'COPY_PAGE.SELECT_AUTHORIZATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \9078\53D6\6388\6B0A -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109430235197313698)
,p_name=>'COPY_PAGE.SELECT_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \9078\53D6\6E05\55AE -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109430103936313698)
,p_name=>'COPY_PAGE.SELECT_NAMED_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \9078\53D6\503C\6E05\55AE -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109494583925313746)
,p_name=>'COPY_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07 %0 \8907\88FD\5230\8868\683C %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109210633635313528)
,p_name=>'COPY_TO_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\76EE\6A19\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109210774948313528)
,p_name=>'COPY_TO_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\76EE\6A19\540D\7A31')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109117397192313458)
,p_name=>'CORE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6838\5FC3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109560340996313800)
,p_name=>'CREATE APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109560459451313800)
,p_name=>'CREATE OBJECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109449498870313713)
,p_name=>'CREATED_LAST_7_DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904E\53BB 7 \5929\5EFA\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109005861948313375)
,p_name=>'CREATE_APP_FROM_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\61C9\7528\7A0B\5F0F\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110032919458314166)
,p_name=>'CREATE_APP_WIZ.CANDLE_CHARTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('K \7DDA\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110032790548314166)
,p_name=>'CREATE_APP_WIZ.COL_CHARTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('2D \548C 3D \67F1\72C0\3001\9577\689D\548C\5806\758A\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110033410190314167)
,p_name=>'CREATE_APP_WIZ.GAUGE_CHARTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A08\91CF\548C\8A08\91CF\767E\5206\6BD4\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110032842837314166)
,p_name=>'CREATE_APP_WIZ.PIE_CHARTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('2D \548C 3D \5713\9905\548C\74B0\5708\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110033167425314167)
,p_name=>'CREATE_APP_WIZ.PROJECTGANTT_CHARTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C08\6848\7518\7279\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110033342545314167)
,p_name=>'CREATE_APP_WIZ.RANGE_CHARTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('2D \548C 3D \7BC4\570D\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110033265015314167)
,p_name=>'CREATE_APP_WIZ.RESOURCEGANTT_CHARTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6E90\7518\7279\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110033089631314166)
,p_name=>'CREATE_APP_WIZ.SCATTER_CHARTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6563\5E03\6A19\8A18\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109110717115313453)
,p_name=>'CREATE_CONDITION.AND'
,p_message_language=>'zh-tw'
,p_message_text=>'AND'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109110528416313453)
,p_name=>'CREATE_CONDITION.ARROW_DOWN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5411\4E0B\7BAD\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109110641302313453)
,p_name=>'CREATE_CONDITION.ARROW_RIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5411\53F3\7BAD\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109110300541313453)
,p_name=>'CREATE_CONDITION.COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109110471086313453)
,p_name=>'CREATE_CONDITION.CONDITIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109110828728313454)
,p_name=>'CREATE_CONDITION.OR'
,p_message_language=>'zh-tw'
,p_message_text=>'OR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109110920547313454)
,p_name=>'CREATE_CONDITION.PREVIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\89BD\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109450102382313714)
,p_name=>'CREATE_DEMO_APP.GRANT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E00\4E0B\4E0B\65B9\7684\300C\6388\4E88\6B0A\9650\300D\6309\9215,  \5C07\9019\4E9B\6B0A\9650\6388\4E88 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109449956533313713)
,p_name=>'CREATE_DEMO_APP.NO_CREATE_PRIV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \6C92\6709 CREATE TABLE, CREATE VIEW, CREATE TRIGGER, CREATE SEQUENCE \6216 CREATE PROCEDURE \6B0A\9650, \56E0\6B64\7121\6CD5\5B89\88DD\793A\7BC4\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109450077134313714)
,p_name=>'CREATE_DEMO_APP.NO_EXEC_PRIV'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('%0 \6C92\6709 CTX_DOC \548C CTX_DDL \7684\57F7\884C\6B0A\9650, \56E0\6B64\7121\6CD5\5B89\88DD\300C\7E3D\7D71\5C31\8077\6F14\8AAA\300D\793A\7BC4.  \8ACB\4EE5\5177\6709\6B0A\9650\7684\4F7F\7528\8005\8EAB\5206\57F7\884C\4E0B\5217\6388\6B0A: '),
'<pre>',
'GRANT EXECUTE ON CTXSYS.CTX_DDL TO %0; ',
'GRANT EXECUTE ON CTXSYS.CTX_DOC TO %0;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109693975479313917)
,p_name=>'CREATE_DIALOG_CLOSED_DA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6309\9215 - \5C0D\8A71\65B9\584A\5DF2\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108926793902313308)
,p_name=>'CREATE_DYNAMIC_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\52D5\614B\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109167465646313496)
,p_name=>'CREATE_DYNAMIC_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\52D5\614B\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108904792190313291)
,p_name=>'CREATE_FLOW.CLOUD_IDM'
,p_message_language=>'zh-tw'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108943877522313321)
,p_name=>'CREATE_FLOW.DBACCOUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\5E33\6236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109585043888313818)
,p_name=>'CREATE_FLOW.HTMLDB_AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Application Express \8A8D\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109450517396313714)
,p_name=>'CREATE_FLOW.LDAP'
,p_message_language=>'zh-tw'
,p_message_text=>'LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110089351295314206)
,p_name=>'CREATE_FLOW.NAVIGATION_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\529F\80FD\8868\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109585121786313818)
,p_name=>'CREATE_FLOW.NO_AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\8A8D\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109584799542313818)
,p_name=>'CREATE_FLOW.NO_TABS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109584877166313818)
,p_name=>'CREATE_FLOW.ONE_LEVEL_TABS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5C64\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109450623013313714)
,p_name=>'CREATE_FLOW.SSO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\55AE\4E00\767B\5165 (SSO)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109584907499313818)
,p_name=>'CREATE_FLOW.TWO_LEVEL_TABS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5169\5C64\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109005669642313375)
,p_name=>'CREATE_FROM_SPREADSHEET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EE5\8A66\7B97\8868\5EFA\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108899318792313286)
,p_name=>'CREATE_GLOBAL_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\9078\53D6\7684\9801\9762\6A23\677F\5167\5305\542B\5168\57DF\9801\9762\5143\4EF6\4E4B\5340\57DF\7684\986F\793A\4F4D\7F6E, \5C31\6703\5728\6240\6709\9801\9762\4E2D\986F\793A\5168\57DF\9801\9762\5143\4EF6.  \4E0D\904E, \60A8\53EF\4EE5\4F7F\7528\300C\689D\4EF6\6027\986F\793A\300D\5C6C\6027\4F86\6291\5236\986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109136014611313472)
,p_name=>'CREATE_INDEX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\7D22\5F15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109309387893313607)
,p_name=>'CREATE_ITEM_WIZ.NO_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\76F8\95DC\7684\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109117069165313458)
,p_name=>'CREATE_NEW_LOGIN_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\65B0\767B\5165\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109112433460313455)
,p_name=>'CREATE_PACKAGE.BACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56DE\5230\300C\5EFA\7ACB\8868\683C\7CBE\9748\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109111957275313454)
,p_name=>'CREATE_PACKAGE.BROWSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\5957\88DD\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109111804883313454)
,p_name=>'CREATE_PACKAGE.CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\88DD\7A0B\5F0F "%0" \5DF2\7D93\5728 "%1" \7DB1\8981\4E2D\5EFA\7ACB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109112581199313455)
,p_name=>'CREATE_PACKAGE.FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\8868\683C "%0" \5931\6557.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109112391006313455)
,p_name=>'CREATE_PACKAGE.HOME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109112147019313455)
,p_name=>'CREATE_PACKAGE.RETURN_TO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8FD4\56DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109112215609313455)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL&nbsp;\5DE5\4F5C\5BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109112024897313454)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP_HOME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \5DE5\4F5C\5BA4\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109107612159313451)
,p_name=>'CREATE_PAGE_ITEM.NO_ITEM_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109107258092313451)
,p_name=>'CREATE_PAGE_ITEM.PAGE_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109107544243313451)
,p_name=>'CREATE_PAGE_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109107336472313451)
,p_name=>'CREATE_PAGE_ITEM.REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109107451891313451)
,p_name=>'CREATE_PAGE_ITEM.SET_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E00\4E0B\4EE5\8A2D\5B9A\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109105364472313449)
,p_name=>'CREATE_PROCESS.PAGE_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109105487814313449)
,p_name=>'CREATE_PROCESS.REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109111784737313454)
,p_name=>'CREATE_TABLE.HOME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109111545017313454)
,p_name=>'CREATE_TABLE.RETURN_TO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8FD4\56DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109111414829313454)
,p_name=>'CREATE_TABLE.RUN_SCRIPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\547D\4EE4\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109111101657313454)
,p_name=>'CREATE_TABLE.SCRIPT_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5728 SQL \547D\4EE4\6A94\5132\5B58\5340\57DF\4E2D\5EFA\7ACB\8868\683C %0 \7684\5EFA\7ACB\8868\683C\547D\4EE4\6A94.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109111209141313454)
,p_name=>'CREATE_TABLE.SCRIPT_REPOSITORY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D\5F80\300C\547D\4EE4\6A94\5132\5B58\5340\57DF\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109111603282313454)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL&nbsp;\5DE5\4F5C\5BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109111322703313454)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP_HOME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \5DE5\4F5C\5BA4\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109540905197313781)
,p_name=>'CREATE_TABULAR_FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\8868\5316\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110107191913314237)
,p_name=>'CREATE_TO_DO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5F85\8FA6\4E8B\9805')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109495181711313747)
,p_name=>'CREATE_TRIGGER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\89F8\767C\7A0B\5F0F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109441475055313706)
,p_name=>'CREATE_WS_OBJ_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB Web \8A66\7B97\8868\8CC7\6599\5EAB\7269\4EF6.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109395972321313672)
,p_name=>'CREDENTIAL.OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B49\660E\8CC7\6599\64C1\6709\8005')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109360372807313645)
,p_name=>'CSS_CALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\4E8B\66C6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109283788876313587)
,p_name=>'CURRENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109352817009313639)
,p_name=>'CURRENT ENTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109352568364313639)
,p_name=>'CURRENT FORM ELEMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8868\55AE\5143\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109127167337313466)
,p_name=>'CURRENT ITEM HELP TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9805\76EE\8AAA\660E\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109352658166313639)
,p_name=>'CURRENT ITEM IDENTIFICATION NUMBER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9805\76EE ID \865F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109352777085313639)
,p_name=>'CURRENT ITEM LABEL NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9805\76EE\6A19\7C64\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109408443780313681)
,p_name=>'CURRENT TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109093740567313441)
,p_name=>'CURRENT_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109100546711313446)
,p_name=>'CURRENT_IMAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109634035701313858)
,p_name=>'CURRENT_ITEM_CONTAINER_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\4EE5\5728\5305\88DD\76EE\524D\6B04\4F4D\4E4B\5BB9\5668\5143\7D20\4F7F\7528\7684 ID, \65BC\300C\5728\6A19\7C64\548C\9805\76EE\4E4B\524D\300D\5C6C\6027\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110111881456314242)
,p_name=>'CURRENT_ITEM_HELP_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\9805\76EE\8AAA\660E\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109062249722313417)
,p_name=>'CURRENT_MILESTONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\91CC\7A0B\7891')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109099663774313445)
,p_name=>'CURRENT_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109377170438313658)
,p_name=>'CURRENT_PAGE_CONTAINS_NO_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\6C92\6709\5305\542B\4EFB\4F55\9805\76EE.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109348410858313636)
,p_name=>'CUSTOMIZE LINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109908057370314077)
,p_name=>'CUSTOM_APPLICATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108925687615313307)
,p_name=>'CUSTOM_AUTH_SCHEME_DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\767C\4EBA\54E1\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109140828649313476)
,p_name=>'CUSTOM_AUTH_SSO_GENERIC_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109062426179313417)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\4F5C\70BA\60A8\5728\6B64\968E\6BB5\4F5C\696D\4E4B\4F7F\7528\8005 ID \7684\5B57\4E32.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109062568072313417)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\60A8\7684 %0 \4F7F\7528\8005\540D\7A31\548C\5BC6\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109062632856313417)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\60A8\7684\4F7F\7528\8005\540D\7A31\548C\5BC6\78BC, \4F9B LDAP \4E3B\6A5F\9032\884C\9A57\8B49: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109062772154313418)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\60A8\7684\8CC7\6599\5EAB\7DB1\8981\4F7F\7528\8005\540D\7A31\548C\5BC6\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109718536661313936)
,p_name=>'CUSTOM_CALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\8F09\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109723523091313940)
,p_name=>'CUSTOM_CALENDAR.END_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109723428025313940)
,p_name=>'CUSTOM_CALENDAR.START_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\65E5\671F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109496032600313747)
,p_name=>'DA.SET_VALUE.SQL.HELP_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C True \52D5\4F5C\662F\8A2D\5B9A\985E\578B\70BA SQL \6558\8FF0\53E5\7684\8A2D\5B9A\503C, \90A3\9EBC\60A8\5FC5\9808\4EE5\8207 SQL \6558\8FF0\53E5\7684\8CC7\6599\6B04\9806\5E8F\76F8\540C\7684\9806\5E8F\5B9A\7FA9\300C\53D7\5F71\97FF\7684\5143\7D20\300D. \60A8\4E4B\524D\5B9A\7FA9\7684 SQL \6558\8FF0\53E5\70BA:</p>'),
'<pre>%0</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109293650193313595)
,p_name=>'DATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109559927341313799)
,p_name=>'DATA WORKSHOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5DE5\4F5C\5BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109148769072313482)
,p_name=>'DATA.LOAD.ALL_COL_MAPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8\7684 %0 \500B\8CC7\6599\6B04\90FD\5DF2\81EA\52D5\5C0D\61C9\81F3 %1 \8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109149564289313482)
,p_name=>'DATA.LOAD.APPEND_INCOMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C <code>%0</code> \4E2D\7684\8CC7\6599\5DF2\9644\52A0 <b id="incompl_success_row_count"></b> \500B\65B0\8CC7\6599\5217. <b class="u-danger-text" id="incompl_fail_row_count"></b> \500B\8CC7\6599\5217\88AB\62D2\7D55.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109149144389313482)
,p_name=>'DATA.LOAD.APPEND_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C <code>%0</code> \4E2D\7684\8CC7\6599\5DF2\9644\52A0 <b id="success_row_count"></b> \500B\65B0\8CC7\6599\5217!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109149316213313482)
,p_name=>'DATA.LOAD.APPEND_WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C <code>%0</code> \4E2D\7684\8CC7\6599\5DF2\9644\52A0 <b id="err_success_row_count"></b> \500B\65B0\8CC7\6599\5217. <b class="u-danger-text" id="err_fail_row_count"></b> \500B\8CC7\6599\5217\88AB\62D2\7D55.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108901836543313288)
,p_name=>'DATA.LOAD.CHOOSE_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\6A94\6848')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108896477462313284)
,p_name=>'DATA.LOAD.COLUMN_MAPPING_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\8CC7\6599\6B04\5C0D\61C9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108939437012313318)
,p_name=>'DATA.LOAD.CONFIGURATION_SAVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\614B\5DF2\5132\5B58!')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108901479969313288)
,p_name=>'DATA.LOAD.DATA_PROFILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8A2D\5B9A\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108901550933313288)
,p_name=>'DATA.LOAD.DATA_PROFILE_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8A2D\5B9A\6A94\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108900851087313288)
,p_name=>'DATA.LOAD.DATA_SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109148803481313482)
,p_name=>'DATA.LOAD.DEFINE_COL_MAPPING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\5B9A\7FA9\8CC7\6599\6B04\5C0D\61C9, \4EE5\4FBF\5C07\6B64\8CC7\6599\8F09\5165 %0 \8868\683C\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108901307588313288)
,p_name=>'DATA.LOAD.DEFINITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108901709833313288)
,p_name=>'DATA.LOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6A94\6848\62D6\653E\5230\6B64\8655, \6216')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108901653022313288)
,p_name=>'DATA.LOAD.FILE_FORMATS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\652F\63F4\7684\683C\5F0F\70BA csv\3001xlsx\3001txt\3001xml\3001json')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109557914831313794)
,p_name=>'DATA.LOAD.JOB_INTERMITTENTLY_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\5DE5\4F5C\57F7\884C\610F\5916\505C\6B62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109500816024313751)
,p_name=>'DATA.LOAD.JOB_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340 %0 \4E2D\7684\8CC7\6599\8F09\5165\5DE5\4F5C: \8F09\5165\8868\683C %1 \4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108901029434313288)
,p_name=>'DATA.LOAD.LOADED_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\7684\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109148986485313482)
,p_name=>'DATA.LOAD.MAP_REMAINING_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\81EA\52D5\5C07 %1 \500B\4E2D\7684 %0 \500B\8CC7\6599\6B04\5C0D\61C9\81F3 %2 \8868\683C. \8ACB\8A2D\5B9A\5176\9918\7684 %3 \500B\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109539029296313780)
,p_name=>'DATA.LOAD.PASTED_DATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CBC\4E0A\7684\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109149604943313482)
,p_name=>'DATA.LOAD.REPLACE_INCOMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C <code>%0</code> \4E2D\7684\8CC7\6599\5DF2\7531 <b id="incompl_success_row_count"></b> \500B\65B0\8CC7\6599\5217\53D6\4EE3. <b class="u-danger-text" id="incompl_fail_row_count"></b> \500B\8CC7\6599\5217\88AB\62D2\7D55.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109149200006313482)
,p_name=>'DATA.LOAD.REPLACE_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C <code>%0</code> \4E2D\7684\8CC7\6599\5DF2\7531 <b id="success_row_count"></b> \500B\65B0\8CC7\6599\5217\53D6\4EE3!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109149427204313482)
,p_name=>'DATA.LOAD.REPLACE_WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C <code>%0</code> \4E2D\7684\8CC7\6599\5DF2\7531 <b id="err_success_row_count"></b> \500B\65B0\8CC7\6599\5217\53D6\4EE3. <b class="u-danger-text" id="err_fail_row_count"></b> \500B\8CC7\6599\5217\88AB\62D2\7D55.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109149042110313482)
,p_name=>'DATA.LOAD.SELECT_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\9078\53D6\8981\8F09\5165\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108881903149313273)
,p_name=>'DATA.LOAD.SUPPORTED_FORMATS_N'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\652F\63F4\7684\683C\5F0F\70BA %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108900904348313288)
,p_name=>'DATA.LOAD.UPLOAD_A_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\50B3\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108901113857313288)
,p_name=>'DATA.LOAD.XLSX_WORKSHEET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('XLSX \5DE5\4F5C\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110101211609314232)
,p_name=>'DATABASE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109560541004313800)
,p_name=>'DATABASE BROWSER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\700F\89BD\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110046387900314176)
,p_name=>'DATABASE.DEMO.SAMPLE.APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B\8CC7\6599\5EAB\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110101369877314232)
,p_name=>'DATABASE_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108945372110313322)
,p_name=>'DATABASE_APPLICATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108960956047313335)
,p_name=>'DATABASE_APPS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109436151709313702)
,p_name=>'DATABASE_APP_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5B89\88DD\61C9\7528\7A0B\5F0F <strong>%0</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109338870707313629)
,p_name=>'DATABASE_LINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109388340489313666)
,p_name=>'DATABASE_OBJECT_COUNTS_BY_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F9D\7269\4EF6\985E\578B\5340\5206\7684\8CC7\6599\5EAB\7269\4EF6\6578\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109391520707313669)
,p_name=>'DATABASE_ROLE_PRIVILEGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\89D2\8272\6B0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108956616385313332)
,p_name=>'DATABASE_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109490342080313743)
,p_name=>'DATA_GRID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\65B9\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110036245030314169)
,p_name=>'DATA_GRIDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\65B9\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110036647582314169)
,p_name=>'DATA_GRID_DATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\65B9\683C\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110023186659314160)
,p_name=>'DATA_LOAD.ADVANCED_SETTINGS_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\9032\968E\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109036322590313398)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\4F7F\7528\7684\65E5\671F/\6578\5B57\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109036416022313398)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\662F\8981\63D0\4F9B\81EA\8A02\683C\5F0F\906E\7F69, \9084\662F\4F7F\7528\6A19\6E96\683C\5F0F\906E\7F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108957064624313332)
,p_name=>'DATA_LOAD.CHARSET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\5B57\5143\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109549736406313788)
,p_name=>'DATA_LOAD.COLUMN_NAMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109434286944313701)
,p_name=>'DATA_LOAD.COLUMN_NAME_ALIASES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109689114063313909)
,p_name=>'DATA_LOAD.CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5C07\8CC7\6599\4E0A\50B3\81F3\60A8\7684\8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109694690651313918)
,p_name=>'DATA_LOAD.COPY_PASTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\4E26\8CBC\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109683567724313902)
,p_name=>'DATA_LOAD.COPY_PASTE_TEXTAREA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\4E26\8CBC\4E0A\5206\9694\7684\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110065644193314189)
,p_name=>'DATA_LOAD.CURRENCY_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E63\5225\7B26\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110065759509314190)
,p_name=>'DATA_LOAD.CURRENCY_ITEM_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\60A8\7684\8CC7\6599\5305\542B\570B\969B\5E63\5225\7B26\865F, \8ACB\5728\6B64\8655\8F38\5165\865F. \4F8B\5982, \5982\679C\60A8\7684\8CC7\6599\5305\542B "&euro;1,234.56" \6216 "&yen;1,234.56", \8ACB\8F38\5165 "&euro;" \6216 "&yen;".  \5426\5247, \8CC7\6599\5C07\7121\6CD5\6B63\78BA\8F09\5165.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108961739495313336)
,p_name=>'DATA_LOAD.DATA_LOADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110023276772314160)
,p_name=>'DATA_LOAD.DATE_FORMAT_APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\61C9\7528\7A0B\5F0F\6A19\6E96\683C\5F0F\906E\7F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110023375866314160)
,p_name=>'DATA_LOAD.DATE_FORMAT_CUSTOM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\5DF2\4E0A\50B3\8CC7\6599\6B04\81EA\8A02\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110066944123314190)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5C0F\6578\9EDE\7B26\865F\53EF\5340\9694\6574\6578\548C\6578\5B57\7684\5C0F\6578\90E8\5206.</p>'),
unistr('<p> \4EFB\4F55\5B57\5143\7686\53EF\7576\6210\5C0F\6578\9EDE\7B26\865F. \6307\5B9A\7684\5B57\5143\5FC5\9808\662F\55AE\4F4D\5143\7D44, \800C\4E14\5C0F\6578\9EDE\7B26\865F\5FC5\9808\8207\7FA4\7D44\5340\9694\7B26\865F\4E0D\540C. \5B57\5143\53EF\4EE5\662F\7A7A\683C, \4F46\4E0D\80FD\662F\6578\5B57\5B57\5143\6216\4E0B\5217\4EFB\4E00\5B57\5143:</p>'),
'<ul class="noIndent">',
unistr('<li>\52A0\865F (+)</li>'),
unistr('<li>\9023\5B57\865F (-)</li> '),
unistr('<li>\5C0F\65BC\7B26\865F (<)</li>'),
unistr('<li>\5927\65BC\7B26\865F (>)</li> '),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110066049181314190)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\6578\9EDE\7B26\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109064931244313419)
,p_name=>'DATA_LOAD.DECIMAL_CHAR_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \8868\683C\8CC7\6599\6B04\5982\679C\6709\5B9A\7FA9\7FA4\7D44\5340\9694\7B26\865F, \5C31\5FC5\9808\540C\6642\5B9A\7FA9\5C0F\6578\9EDE\7B26\865F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109434483129313701)
,p_name=>'DATA_LOAD.DISPLAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109500978224313751)
,p_name=>'DATA_LOAD.DUPLICATE_MAPPING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\591A\500B\4F86\6E90\8CC7\6599\6B04\5C0D\61C9\81F3 %0 \8868\683C\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109832368928314022)
,p_name=>'DATA_LOAD.FAILED_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5931\6557\7684\8CC7\6599\5217:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110047723508314177)
,p_name=>'DATA_LOAD.FAILED_RECORD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5931\6557\7684\8A18\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110065296275314189)
,p_name=>'DATA_LOAD.FILE_NAME_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\4E0A\50B3\7684\6A94\6848\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109691769055313913)
,p_name=>'DATA_LOAD.FIRST_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C\4E00\500B\8CC7\6599\5217\542B\6709\8CC7\6599\6B04\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110065300169314189)
,p_name=>'DATA_LOAD.FIRST_ROW_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\8CC7\6599\7684\7B2C\4E00\5217\662F\8CC7\6599\6B04\540D\7A31, \8ACB\9078\53D6\6B64\65B9\584A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110065594857314189)
,p_name=>'DATA_LOAD.GLOBALIZATION_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\7403\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110065991653314190)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7FA4\7D44\5340\9694\7B26\865F\662F\4E00\500B\5340\9694\6574\6578\7FA4\7D44\7684\5B57\5143, \4F8B\5982\986F\793A\5343\4F4D\8207\767E\842C\4F4D.</p>'),
unistr('<p>\4EFB\4F55\5B57\5143\7686\53EF\7576\6210\7FA4\7D44\5340\9694\7B26\865F. \6307\5B9A\7684\5B57\5143\5FC5\9808\662F\55AE\4F4D\5143\7D44, \800C\4E14\7FA4\7D44\5340\9694\7B26\865F\5FC5\9808\8207\5176\4ED6\5C0F\6578\9EDE\7B26\865F\4E0D\540C. \5B57\5143\53EF\4EE5\662F\7A7A\683C, \4F46\4E0D\80FD\662F\6578\5B57\5B57\5143\6216\4E0B\5217\4EFB\4E00\5B57\5143:</p>'),
'<ul class="noIndent">',
unistr('<li>\52A0\865F (+)</li>'),
unistr('<li>\9023\5B57\865F (-)</li> '),
unistr('<li>\5C0F\65BC\7B26\865F (<)</li>'),
unistr('<li>\5927\65BC\7B26\865F (>)</li> '),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110065802295314190)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44\5340\9694\7B26\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109832189007314022)
,p_name=>'DATA_LOAD.INSERTED_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D2\5165\7684\8CC7\6599\5217:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110062793254314187)
,p_name=>'DATA_LOAD.IR_MAX_ROW_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\67E5\8A62\50B3\56DE #MAX_ROW_COUNT# \500B\4EE5\4E0A\7684\8CC7\6599\5217, \8ACB\7BE9\9078\8CC7\6599, \78BA\4FDD\53D6\5F97\5B8C\6574\7684\7D50\679C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109433194152313700)
,p_name=>'DATA_LOAD.JUSTCHANGED_RECORD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A18\9304\5DF2\88AB\5176\4ED6\4F7F\7528\8005\8B8A\66F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109056370308313413)
,p_name=>'DATA_LOAD.LABEL_CASE_SENSITIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6709\5927\5C0F\5BEB\4E4B\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109056225566313413)
,p_name=>'DATA_LOAD.LABEL_UNIQUE_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\552F\4E00\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109655271919313874)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\5931\6557')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109655348869313874)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\5DF2\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109679321367313897)
,p_name=>'DATA_LOAD.LOAD_TO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\5165\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109488526031313742)
,p_name=>'DATA_LOAD.MAPPING_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B65\9A5F 2 - \9801\9762\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110113652123314243)
,p_name=>'DATA_LOAD.NO_PREVIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\63D0\4F9B\6A94\6848\9810\89BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110064461797314189)
,p_name=>'DATA_LOAD.OPTIONAL_ENCLOSE_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\754C\7B26\865F (\9078\64C7\6027)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110026637725314162)
,p_name=>'DATA_LOAD.PROGRESS_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\7CBE\9748\9032\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109488701913313742)
,p_name=>'DATA_LOAD.RESULTS_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B65\9A5F 4 - \9801\9762\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109434348527313701)
,p_name=>'DATA_LOAD.RETURN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8FD4\56DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109432658036313700)
,p_name=>'DATA_LOAD.REVIEW_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\8981\8B93\8CC7\6599\5217\8907\67E5:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109546878076313785)
,p_name=>'DATA_LOAD.RULES_PLSQL_EXPRESSION_EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'to_char(sysdate)',
'',
'my_func (',
'    p_1 => :SAL,',
'    p_2 => :COMM)',
'',
unistr('\5176\4E2D SAL \548C COMM \70BA\5DF2\4E0A\50B3\8CC7\6599\7684\8CC7\6599\6B04\540D\7A31'),
unistr('\800C my_func \70BA\50B3\56DE\503C\7684\51FD\6578, \8A72\503C\6703\6210\70BA\5B9A\7FA9\6B64\8F49\63DB\898F\5247'),
unistr('\4E4B\8CC7\6599\6B04\7684\65B0\503C.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109547040217313786)
,p_name=>'DATA_LOAD.RULES_PLSQL_FUNCTION_EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_result number;',
'begin',
'    l_result := :SAL * :COMM;',
'    return l_result;',
'end;',
'',
unistr('\50B3\56DE\7684\7D50\679C\5C07\662F\5B9A\7FA9\6B64\8F49\63DB\898F\5247\4E4B\8CC7\6599\6B04\7684\65B0\503C.'),
'',
unistr(':SAL \548C :COMM \6307\7684\662F\5DF2\4E0A\50B3\8CC7\6599\7684 SAL \548C COMM \8CC7\6599\6B04\540D\7A31.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109546956834313785)
,p_name=>'DATA_LOAD.RULES_SQL_QUERY_EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select depno',
' from dept',
'where dname = :DEPTNAME',
'  and loc   = :LOC',
'',
unistr('\5176\4E2D :DEPNAME \548C :LOC \6307\7684\662F\5DF2\4E0A\50B3\8CC7\6599\7684 DEPNAME \548C LOC \8CC7\6599\6B04\540D\7A31.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109073041531313425)
,p_name=>'DATA_LOAD.SAME_GROUP_DECIMAL_CHARS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728 %0 \8868\683C\8CC7\6599\6B04\4E2D, \4E0D\53EF\5C07\76F8\540C\5B57\5143\540C\6642\5B9A\7FA9\70BA\7FA4\7D44\5340\9694\7B26\865F\548C\5C0F\6578\9EDE\7B26\865F. \8ACB\8F38\5165\4E0D\540C\7684\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110064245389314188)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8CC7\6599\6B04\5340\9694\7B26\865F\5B57\5143. \8ACB\4F7F\7528 <code>\005Ct</code> \4F5C\70BA Tab \5340\9694\7B26\865F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110064320417314189)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\9694\7B26\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109434566582313701)
,p_name=>'DATA_LOAD.SEQUENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110022955956314159)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\9032\968E\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110023019301314160)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\8CC7\6599\8F09\5165\7684\9032\968E\8A2D\5B9A\503C: \8CA8\5E63\7B26\865F\3001\5C0F\6578\9EDE\7B26\865F\3001\6A94\6848\7DE8\78BC\6216\65E5\671F\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109699222311313921)
,p_name=>'DATA_LOAD.SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109488432354313742)
,p_name=>'DATA_LOAD.SOURCE_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B65\9A5F 1 - \9801\9762\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110101570074314233)
,p_name=>'DATA_LOAD.TAB_SEPARTOR_NOTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\005Ct \4EE3\8868 tab)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110063018423314188)
,p_name=>'DATA_LOAD.UNIQUE_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\552F\4E00\8CC7\6599\6B04 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109832276022314022)
,p_name=>'DATA_LOAD.UPDATED_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\7684\8CC7\6599\5217:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110142860894314266)
,p_name=>'DATA_LOAD.UPLOADED_NULL_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\4E0A\50B3\7A7A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109694532873313917)
,p_name=>'DATA_LOAD.UPLOAD_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\50B3\4F7F\7528\9017\865F (*.csv) \6216 Tab \5340\9694\7684\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109699447437313921)
,p_name=>'DATA_LOAD.UPLOAD_RESULTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\7D50\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109699308651313921)
,p_name=>'DATA_LOAD.VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\9A57\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109488679518313742)
,p_name=>'DATA_LOAD.VALIDATION_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B65\9A5F 3 - \9801\9762\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109492787326313745)
,p_name=>'DATA_LOAD_WIZARD_CREATED_SUCCESSFULLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\8CC7\6599\8F09\5165\7CBE\9748\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109655421606313874)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599/\8868\683C\5C0D\61C9\5931\6557')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109655578040313874)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\5DF2\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109361539914313646)
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\4E0A\50B3\8CC7\6599\6B04\5C0D\61C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109086368896313435)
,p_name=>'DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\985E\578B: \8CC7\6599\6B04 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108948173295313325)
,p_name=>'DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\6578\9EDE\7B26\865F: \8CC7\6599\6B04 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108948380503313325)
,p_name=>'DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F\906E\7F69: \8CC7\6599\6B04 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108948244281313325)
,p_name=>'DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44\5340\9694\7B26\865F: \8CC7\6599\6B04 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108948530733313325)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAP_TO_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\61C9\81F3: \8CC7\6599\6B04 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109135404634313472)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAX_LENGTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\5EA6\4E0A\9650: \8CC7\6599\6B04 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108948428153313325)
,p_name=>'DATA_WORKSHOP.CONFIGURE.UNMAPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \672A\5C0D\61C9\7684\8CC7\6599\6B04 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109481603920313737)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\9805\76EE %1 \8F38\5165\7684\300C\6A19\793A\65E5\671F\300D\5C6C\6027\503C %0 \4E0D\7B26\5408 %2 \683C\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109486805957313741)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID_RELATIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\9805\76EE %1 \8F38\5165\7684\300C\6A19\793A\65E5\671F\300D\5C6C\6027\503C %0 \4E0D\662F\76F8\5C0D\65E5\671F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109481810782313737)
,p_name=>'DATEPICKER.MAX_DATE_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\9805\76EE %1 \8F38\5165\7684\300C\6700\5927\65E5\671F\300D\5C6C\6027\503C %0 \4E0D\7B26\5408 %2 \683C\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109487046919313741)
,p_name=>'DATEPICKER.MAX_DATE_INVALID_RELATIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\9805\76EE %1 \8F38\5165\7684\300C\6700\5927\65E5\671F\300D\5C6C\6027\503C %0 \4E0D\662F\76F8\5C0D\65E5\671F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108899111013313286)
,p_name=>'DATEPICKER.MAX_STATIC_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\9805\76EE %1 \8F38\5165\7684\300C\975C\614B\503C\4E0A\9650\300D\5C6C\6027\503C %0 \8207 %2 \683C\5F0F\4E0D\7B26.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109481739103313737)
,p_name=>'DATEPICKER.MIN_DATE_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\9805\76EE %1 \8F38\5165\7684\300C\6700\5C0F\65E5\671F\300D\5C6C\6027\503C %0 \4E0D\7B26\5408 %2 \683C\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109486988961313741)
,p_name=>'DATEPICKER.MIN_DATE_INVALID_RELATIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\9805\76EE %1 \8F38\5165\7684\300C\6700\5C0F\65E5\671F\300D\5C6C\6027\503C %0 \4E0D\662F\76F8\5C0D\65E5\671F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108899096855313286)
,p_name=>'DATEPICKER.MIN_STATIC_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\9805\76EE %1 \8F38\5165\7684\300C\975C\614B\503C\4E0B\9650\300D\5C6C\6027\503C %0 \8207 %2 \683C\5F0F\4E0D\7B26.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109588977960313821)
,p_name=>'DATE_ADDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110033654945314167)
,p_name=>'DATE_OF_LAST_RUN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle APEX \8CC7\6599\5EAB\5DE5\4F5C\8207\4E0A\6B21\57F7\884C\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109411432958313684)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5230\9054\6700\7D42\91CC\7A0B\7891')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109411506725313684)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE_OF_RELASE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5230\9054\7248\6B21 %0 \7684\6700\7D42\91CC\7A0B\7891')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109486224629313740)
,p_name=>'DA_NAME.NATIVE_ADD_CLASS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110039065252314171)
,p_name=>'DA_NAME.NATIVE_ALERT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\793A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110037886461314170)
,p_name=>'DA_NAME.NATIVE_CANCEL_EVENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110039266080314171)
,p_name=>'DA_NAME.NATIVE_CLEAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110039193635314171)
,p_name=>'DA_NAME.NATIVE_CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108878517555313271)
,p_name=>'DA_NAME.NATIVE_DIALOG_CANCEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88\5C0D\8A71\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108878675503313271)
,p_name=>'DA_NAME.NATIVE_DIALOG_CLOSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589\5C0D\8A71\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109030531530313394)
,p_name=>'DA_NAME.NATIVE_DISABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109030483970313394)
,p_name=>'DA_NAME.NATIVE_ENABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110030781647314165)
,p_name=>'DA_NAME.NATIVE_EXECUTE_PLSQL_CODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C PL/SQL \7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109030346993313394)
,p_name=>'DA_NAME.NATIVE_HIDE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109406771940313680)
,p_name=>'DA_NAME.NATIVE_JAVASCRIPT_CODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C JavaScript \7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109660934430313879)
,p_name=>'DA_NAME.NATIVE_REFRESH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6574\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109486310408313740)
,p_name=>'DA_NAME.NATIVE_REMOVE_CLASS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664\985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109486424269313740)
,p_name=>'DA_NAME.NATIVE_SET_CSS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109643844656313865)
,p_name=>'DA_NAME.NATIVE_SET_FOCUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\7126\9EDE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109406621043313680)
,p_name=>'DA_NAME.NATIVE_SET_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109030264809313394)
,p_name=>'DA_NAME.NATIVE_SHOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109643925333313865)
,p_name=>'DA_NAME.NATIVE_SUBMIT_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109625403436313851)
,p_name=>'DA_NAME.NATIVE_TREE_COLLAPSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF\6A39\72C0\7D50\69CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109625311446313851)
,p_name=>'DA_NAME.NATIVE_TREE_EXPAND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C55\958B\6A39\72C0\7D50\69CB')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108927807985313309)
,p_name=>'DBACCOUNT_AUTH_SCHEME_DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\5E33\6236')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109403339974313677)
,p_name=>'DB_COLS_CASE_SEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\8868\683C\8207\8CC7\6599\6B04\540D\7A31\6709\5927\5C0F\5BEB\4E4B\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109503012300313753)
,p_name=>'DB_OBJECT_CREATION_EXCEPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\7269\4EF6\5EFA\7ACB\7570\5E38\72C0\6CC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108941486004313319)
,p_name=>'DB_PRODUCT_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>'Oracle Database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110091779658314209)
,p_name=>'DB_SERVICES_ALIAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110088484034314206)
,p_name=>'DB_SERVICES_ALL_MIMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709 Mime')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110091427505314208)
,p_name=>'DB_SERVICES_CREATE_HANDLER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\8655\7406\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110088734403314206)
,p_name=>'DB_SERVICES_CREATE_METHOD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110088554456314206)
,p_name=>'DB_SERVICES_CREATE_PARAMETER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110088634939314206)
,p_name=>'DB_SERVICES_CREATE_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110095660027314212)
,p_name=>'DB_SERVICES_DB_SERVICES_MODULE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('RESTful \670D\52D9\6A21\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110091332529314208)
,p_name=>'DB_SERVICES_HANDLER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110096145230314212)
,p_name=>'DB_SERVICES_HANDLER_BIND_VARIABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\7A0B\5F0F\9023\7D50\8B8A\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110068503571314191)
,p_name=>'DB_SERVICES_HANDLER_METHOD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\7A0B\5F0F\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110096474448314213)
,p_name=>'DB_SERVICES_HANDLER_SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\7A0B\5F0F\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110068656546314192)
,p_name=>'DB_SERVICES_HANDLER_SRC_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\7A0B\5F0F\4F86\6E90\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110088279192314205)
,p_name=>'DB_SERVICES_METHOD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110095762215314212)
,p_name=>'DB_SERVICES_MODULE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A21\7D44\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110096299869314213)
,p_name=>'DB_SERVICES_MODULE_URI'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A21\7D44 URI \524D\7F6E\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110088850991314206)
,p_name=>'DB_SERVICES_NO_SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110088117267314205)
,p_name=>'DB_SERVICES_PARAMETER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110095987488314212)
,p_name=>'DB_SERVICES_RESTFUL_SERVICES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('RESTful \670D\52D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110088352168314206)
,p_name=>'DB_SERVICES_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110096383600314213)
,p_name=>'DB_SERVICES_TEMPLATE_URI'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('URI \6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110068474583314191)
,p_name=>'DB_SERVICES_URI'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D71\4E00\8CC7\6E90\8B58\5225\9805 (URI)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110095497589314212)
,p_name=>'DB_SERVICES_URI_PRIFIX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('URI \524D\7F6E\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110095587822314212)
,p_name=>'DB_SERVICES_URI_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('URI \6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110068755455314192)
,p_name=>'DB_SERVICE_QUERY_ONE_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\8A62\4E00\500B\8CC7\6599\5217')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109312644329313609)
,p_name=>'DEBUG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9664\932F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109419044807313689)
,p_name=>'DECLINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\62D2\7D55')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110141303138314265)
,p_name=>'DEFAULT_DIALOGBTNR_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5C0D\8A71\65B9\584A\6309\9215\5340\57DF\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110141260499314265)
,p_name=>'DEFAULT_DIALOGR_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5C0D\8A71\65B9\584A\5167\5BB9\5340\57DF\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109656174249313874)
,p_name=>'DEFAULT_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109298415879313598)
,p_name=>'DEFAULT_TABLESPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\8868\683C\7A7A\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109300085723313599)
,p_name=>'DEFAULT_TABLESPACE_INIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\8868\683C\7A7A\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109548523850313787)
,p_name=>'DEFAULT_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\6A23\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108923897547313305)
,p_name=>'DEFINED_BY_DA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B\52D5\4F5C\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109714829731313933)
,p_name=>'DEFINED_TABS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\61C9\7528\7A0B\5F0F\6709 %0 \500B\7D44\7E54\70BA %1 \500B\9801\7C64\96C6\7684\9801\7C64, \4E14\5DF2\5B9A\7FA9 %2 \500B\7236\9805\9801\7C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109167312857313496)
,p_name=>'DEFINE_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B9A\7FA9\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109348599089313636)
,p_name=>'DEFINITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B9A\7FA9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109500704226313751)
,p_name=>'DEINSTALLATION_SCRIPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89E3\9664\5B89\88DD\547D\4EE4\6A94')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109019047970313385)
,p_name=>'DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110035766743314169)
,p_name=>'DELETE_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109541083339313781)
,p_name=>'DELETE_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109533205630313775)
,p_name=>'DELETE_LINK_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108951080147313327)
,p_name=>'DELETE_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\57F7\884C\6B64\522A\9664\52D5\4F5C\55CE?')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108975337226313347)
,p_name=>'DEMO.COLLECT.DESCR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\53EF\4EE5\5229\7528\300C\96C6\5408\5C55\793A\300D\5132\5B58\53EF\65BC Oracle APEX \968E\6BB5\4F5C\696D\5167\4F7F\7528\4E4B\8CC7\6599\7684\8CC7\6599\5217. \6B64\8CC7\6599\5EAB\61C9\7528\7A0B\5F0F\793A\7BC4\8AAA\660E\5982\4F55\4F7F\7528 PL/SQL \4F86\5EFA\7ACB\53CA\7BA1\7406\61C9\7528\96C6\5408\7684\968E\6BB5\4F5C\696D\72C0\614B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108975153567313346)
,p_name=>'DEMO.SAMPLE.APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108975290139313347)
,p_name=>'DEMO.SAMPLE.APP.DESCR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Product Portal \662F\4E00\500B\5F37\8ABF\901A\7528\8A2D\8A08\6982\5FF5\7684\7BC4\4F8B\61C9\7528\7A0B\5F0F. \5176\4E2D\5305\62EC\5BA2\6236\3001\7522\54C1\4EE5\53CA\8A02\55AE\7684\5C08\7528\9801\9762, \4E26\4E14\793A\7BC4\5831\8868\3001\5716\8868\3001\884C\4E8B\66C6\3001\5730\5716\4EE5\53CA\6A39\72C0\7D50\69CB\7684\7528\6CD5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109369412073313652)
,p_name=>'DEMONSTRABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\793A\7BC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109096113267313442)
,p_name=>'DEMO_APPLICATION.ABOUT_BUSINESS_LOOK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5065\5168\5831\8868\8207\5206\9801\6982\5FF5\7684\7BC4\4F8B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109095884046313442)
,p_name=>'DEMO_APPLICATION.ABOUT_PETSTORE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528 %0 \5EFA\7ACB\7684\7DDA\4E0A\5132\5B58\7BC4\4F8B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109096556083313443)
,p_name=>'DEMO_APPLICATION.ABOUT_PRESIDENTIAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\77AD\89E3\4F7F\7528 Oracle Text \8207 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109096947305313443)
,p_name=>'DEMO_APPLICATION.ABOUT_PROJ_TRACKING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528 %0 \5EFA\7ACB\4E4B\61C9\7528\7A0B\5F0F\7684\5C08\6848\72C0\614B\8FFD\8E64\7BC4\4F8B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109096352999313443)
,p_name=>'DEMO_APPLICATION.ABOUT_WEBSERVICES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B78\7FD2\4F7F\7528 Web \670D\52D9\8207 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109094785475313441)
,p_name=>'DEMO_APPLICATION.ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109092669094313440)
,p_name=>'DEMO_APPLICATION.APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109092308334313440)
,p_name=>'DEMO_APPLICATION.BASIC_LEXER'
,p_message_language=>'zh-tw'
,p_message_text=>'BASIC_LEXER'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109096032584313442)
,p_name=>'DEMO_APPLICATION.BUSINESS_LOOK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F01\696D\9801\9762\5916\89C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109094808659313442)
,p_name=>'DEMO_APPLICATION.COLLECTION_SHOWCASE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96C6\5408\5C55\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109092444033313440)
,p_name=>'DEMO_APPLICATION.CONTEXT_INDEX'
,p_message_language=>'zh-tw'
,p_message_text=>'CONTEXT INDEX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109091891251313439)
,p_name=>'DEMO_APPLICATION.CREATE_BASIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5373\5C07\5EFA\7ACB\300C\57FA\672C\7BC4\4F8B\793A\7BC4\61C9\7528\7A0B\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109090408460313438)
,p_name=>'DEMO_APPLICATION.CREATE_BUSINESS_LOOK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5373\5C07 (\91CD\65B0) \5EFA\7ACB\4F01\696D\9801\9762\5916\89C0\300C\793A\7BC4\61C9\7528\7A0B\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109091981962313439)
,p_name=>'DEMO_APPLICATION.CREATE_COLLECTION_SHOWCASE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5373\5C07\5EFA\7ACB\300C\96C6\5408\5C55\793A\793A\7BC4\61C9\7528\7A0B\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109092085185313439)
,p_name=>'DEMO_APPLICATION.CREATE_OR_RECREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\7DB1\8981 %0 \5EFA\7ACB\6216\91CD\65B0\5EFA\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109090334246313438)
,p_name=>'DEMO_APPLICATION.CREATE_WEB_SERVICES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\793A\7BC4 Web \670D\52D9\7684\7BC4\4F8B\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109090583333313438)
,p_name=>'DEMO_APPLICATION.CREATE_WORLDCUP_MANIA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5373\5C07\5EFA\7ACB\300CWorldCup Mania \793A\7BC4\61C9\7528\7A0B\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108931539841313311)
,p_name=>'DEMO_APPLICATION.DEINSTALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109094542306313441)
,p_name=>'DEMO_APPLICATION.DEMO_APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\793A\7BC4\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109092987130313440)
,p_name=>'DEMO_APPLICATION.FREE_SPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5927\7D04\6709 %0 MB \7684\53EF\7528\7A7A\9593.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109095363785313442)
,p_name=>'DEMO_APPLICATION.INSTALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\88DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109095092450313442)
,p_name=>'DEMO_APPLICATION.INSTALLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5B89\88DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109227009283313540)
,p_name=>'DEMO_APPLICATION.INSTALL_DEMO_APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5373\5C07\5B89\88DD\300C\7BC4\4F8B\61C9\7528\7A0B\5F0F\300D, \5B83\6703\793A\7BC4 %0 \7684\4E3B\8981\529F\80FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109095915377313442)
,p_name=>'DEMO_APPLICATION.INSTALL_NOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7ACB\5373\5B89\88DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109094922197313442)
,p_name=>'DEMO_APPLICATION.LEARN_ABOUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\77AD\89E3 %0 \8CFC\7269\8ECA\6982\5FF5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109536062040313777)
,p_name=>'DEMO_APPLICATION.LOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9396\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109092732833313440)
,p_name=>'DEMO_APPLICATION.NEED_7M'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\7E3D\7D71\5C31\8077\6F14\8AAA\793A\7BC4\300D\5927\7D04\9700\8981 7 MB \7684\53EF\7528\78C1\789F\7A7A\9593, \800C\4E14\53EF\80FD\9700\8981 2 \5206\9418\7684\6642\9593\624D\80FD\5B89\88DD\5230\60A8\7684\7DB1\8981.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109226743007313540)
,p_name=>'DEMO_APPLICATION.NOT_ENOUGH_SPACE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\9593\4E0D\8DB3, \7121\6CD5\5EFA\7ACB\6B64\793A\7BC4.  \8ACB\81F3\7BA1\7406\9801\9762, \524D\5F80\4F48\5EFA\670D\52D9, \7136\5F8C\6309\4E00\4E0B\9023\7D50\4F86\8981\6C42\984D\5916\7684\5132\5B58. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109095274970313442)
,p_name=>'DEMO_APPLICATION.NOT_INSTALLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5B89\88DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109091262245313439)
,p_name=>'DEMO_APPLICATION.OBJECT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109090131831313438)
,p_name=>'DEMO_APPLICATION.OBJECT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109091155252313439)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109092267720313440)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7269\4EF6\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109090217082313438)
,p_name=>'DEMO_APPLICATION.OBJECT_NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109090846592313439)
,p_name=>'DEMO_APPLICATION.OBJECT_RECREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\91CD\65B0\5EFA\7ACB\4E0B\5217\8CC7\6599\5EAB\7269\4EF6 (\5982\679C\5B58\5728)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109091007096313439)
,p_name=>'DEMO_APPLICATION.OBJECT_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7269\4EF6\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109091720291313439)
,p_name=>'DEMO_APPLICATION.PACKAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\88DD\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109095750943313442)
,p_name=>'DEMO_APPLICATION.PETSTORE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BF5\7269\5E97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109096442685313443)
,p_name=>'DEMO_APPLICATION.PRESIDENTIAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\7D71\5C31\8077\6F14\8AAA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109096704261313443)
,p_name=>'DEMO_APPLICATION.PROJECT_TRACKING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C08\6848\8FFD\8E64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109303938041313602)
,p_name=>'DEMO_APPLICATION.RE_INSTALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5B89\88DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109095181609313442)
,p_name=>'DEMO_APPLICATION.RUN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109090977276313439)
,p_name=>'DEMO_APPLICATION.SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109091593684313439)
,p_name=>'DEMO_APPLICATION.SEQUENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109094616566313441)
,p_name=>'DEMO_APPLICATION.STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109091334775313439)
,p_name=>'DEMO_APPLICATION.TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109094466800313441)
,p_name=>'DEMO_APPLICATION.TABLE_SUMMARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\793A\7BC4\61C9\7528\7A0B\5F0F\5B89\88DD\72C0\614B\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109091642604313439)
,p_name=>'DEMO_APPLICATION.TRIGGER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89F8\767C\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109536185136313778)
,p_name=>'DEMO_APPLICATION.UNLOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89E3\9664\9396\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108956884814313332)
,p_name=>'DEMO_APPLICATION.UPDATE_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\7528\7684\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110114446920314244)
,p_name=>'DEMO_APPLICATION.WEBSHEET_OBJECT_VALIDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\66F4\6B63\4E0B\5217\7121\6548\7684\7269\4EF6, \624D\80FD\6B63\78BA\57F7\884C\300CWeb \8A66\7B97\8868\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109096281416313443)
,p_name=>'DEMO_APPLICATION.WEB_SERVICES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \670D\52D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109093031619313440)
,p_name=>'DEMO_APPLICATION.WILL_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\672A\91CD\65B0\5EFA\7ACB\6B64\793A\7BC4, \53EF\80FD\6703\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109038099677313399)
,p_name=>'DEMO_FLOW.CREATED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\9593\4E0D\8DB3, \7121\6CD5\5EFA\7ACB\6B64\793A\7BC4.  \8ACB\81F3\7BA1\7406\9801\9762, \7136\5F8C\6309\4E00\4E0B\300C\8981\6C42\8B8A\66F4\76EE\524D\7684\670D\52D9\300D\9023\7D50\4F86\8981\6C42\984D\5916\7684\5132\5B58.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109037954332313399)
,p_name=>'DEMO_FLOW.CREATED_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB %0 \793A\7BC4\61C9\7528\7A0B\5F0F.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109693358481313916)
,p_name=>'DEPRECATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\88AB\53D6\4EE3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108989083789313357)
,p_name=>'DERIVED$'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884D\751F\7684\8CC7\6599\6B04')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109369388520313652)
,p_name=>'DESIRABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109442127089313707)
,p_name=>'DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\660E\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109498866174313749)
,p_name=>'DETAILS_FOR_ALT_TAG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A73\7D30\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109442288537313707)
,p_name=>'DETAIL_2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\660E\7D30 2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108940421210313318)
,p_name=>'DEVELOPER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\767C\4EBA\54E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109504277159313754)
,p_name=>'DEVELOPERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\767C\4EBA\54E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109388911523313667)
,p_name=>'DEVELOPER_ACTIVITY_SUMMARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\767C\4EBA\54E1\6D3B\52D5\6458\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109412796572313684)
,p_name=>'DEVELOPER_SUMMARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\767C\4EBA\54E1\6458\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108897226451313285)
,p_name=>'DEVELOPER_TOOLBAR_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109406008608313679)
,p_name=>'DEVELOPER_TOOLBAR_APP_CUSTOMIZATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109562170258313801)
,p_name=>'DEVELOPER_TOOLBAR_CLEAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109562063573313801)
,p_name=>'DEVELOPER_TOOLBAR_COPY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109910457155314079)
,p_name=>'DEVELOPER_TOOLBAR_CUSTOMIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109588305122313820)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9664\932F (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109587809843313820)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\9664\932F\5C64\7D1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109588036118313820)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\8A0A (\9810\8A2D\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109588145413313820)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL6'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8FFD\8E64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109588289874313820)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL9'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6574\8FFD\8E64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108897377167313285)
,p_name=>'DEVELOPER_TOOLBAR_EDIT_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C %0 \9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109551243367313789)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8F09\5165\6642\767C\751F\4E00\6216\591A\500B\932F\8AA4. \8ACB\958B\555F\700F\89BD\5668\7684 JavaScript \4E3B\63A7\53F0, \4EE5\67E5\770B\9019\4E9B\932F\8AA4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109551405292313789)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS_BTN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \932F\8AA4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109910560507314079)
,p_name=>'DEVELOPER_TOOLBAR_LOGO_EDITOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\6A19\8A8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109625042795313851)
,p_name=>'DEVELOPER_TOOLBAR_NO_BUILDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\529F\80FD\9700\8981\958B\555F\300CApplication Express \61C9\7528\7A0B\5F0F\7522\751F\5668\300D\8996\7A97. \8981\5728\6B64\8996\7A97\4E2D\958B\555F\300C\7522\751F\5668\300D\55CE?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109621166711313848)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\767C\4EBA\54E1\5DE5\5177\5217\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109622891652313850)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_AUTO_HIDE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\96B1\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109623006773313850)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_DISPLAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109622937222313850)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_ICONS_ONLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\986F\793A\5716\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109623239530313850)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_BOTTOM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E95\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109623103179313850)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_LEFT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9760\5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109623371068313850)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_RIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9760\53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109624621737313851)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_TOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9802\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109557191376313793)
,p_name=>'DEVELOPER_TOOLBAR_PAGE_INFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109557371108313793)
,p_name=>'DEVELOPER_TOOLBAR_PERF_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6548\80FD\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109621254688313848)
,p_name=>'DEVELOPER_TOOLBAR_QUICK_EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FEB\901F\7DE8\8F2F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109557235127313793)
,p_name=>'DEVELOPER_TOOLBAR_SHOW_PERF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\9801\9762\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110122140001314250)
,p_name=>'DEVELOPER_TOOLBAR_THEME_ROLLER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\6372\52D5\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109622754327313850)
,p_name=>'DEVELOPER_TOOLBAR_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\767C\4EBA\54E1\5DE5\5177\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109363630317313647)
,p_name=>'DEVELOPMENT_TASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\767C\5DE5\4F5C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109531918943313774)
,p_name=>'DIAL_CHART_ALERT_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109531843700313774)
,p_name=>'DIAL_CHART_HIGH_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9AD8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109531753107313774)
,p_name=>'DIAL_CHART_LOW_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4E\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108881094937313272)
,p_name=>'DICTIONARY.APEX_APPL_PAGE_ITEM_GROUPS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108963428383313337)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108965820901313339)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108965974456313339)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTHORIZATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108965049133313338)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BC_ENTRIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108964935848313338)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BREADCRUMBS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110151566889314273)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BUILD_OPTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\5EFA\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108964659492313338)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_COMPUTATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108964840360313338)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108965158042313338)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108965212874313339)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LIST_ENTRIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108965322282313339)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOVS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108914644561313298)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108965416212313339)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_ENTRIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108965513859313339)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_NAV_BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108963574786313337)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108964517129313338)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BRANCHES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108963938972313338)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BUTTONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109338306992313628)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHARTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109338564779313629)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_A'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EA7\6A19\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109338462461313628)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_S'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6578\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108964281739313338)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_COMP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109005119720313375)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109005298182313375)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA_ACTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B\52D5\4F5C - \52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108964071422313338)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('IR \5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108964142137313338)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR_COL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108963730877313337)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108964470002313338)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_PROC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108963661719313337)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REGIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109904673611314075)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REG_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108963827262313337)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_RPT_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110086661714314204)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_TREES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108964344757313338)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_VAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108965608952313339)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PARENT_TABS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108964780559313338)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PROCESSES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110112358358314242)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_LAYOUTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\7248\9762\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110112614711314243)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QRY_STMTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\67E5\8A62 SQL \6558\8FF0\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110112253994314242)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QUERIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110061340470314186)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108966022849313339)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SHORTCUTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6377\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108961516200313336)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_STATIC_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108967533303313340)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUBSTITUTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66FF\4EE3\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110151213304314272)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJECTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\652F\63F4\7684\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110151337477314272)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_BOPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\652F\63F4\7684\7269\4EF6\7D44\5EFA\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108967323715313340)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_CHCK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\652F\63F4\7269\4EF6\9A57\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108967476423313340)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_SCR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\652F\63F4\7269\4EF6\547D\4EE4\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108965710146313339)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TABS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108966432919313340)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108966595299313340)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108966636724313340)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_CALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\4E8B\66C6\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109029906879313393)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_GRID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\683C\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108966700099313340)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108966893136313340)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108966947283313340)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108967088019313340)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_POPUPLOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5373\73FE\5F0F LOV \6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108967124788313340)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108967272927313340)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108966330000313339)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108954908299313330)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108902720002313289)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_STYLES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109394102284313670)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANSLATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108948712939313325)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_DYNAMIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B\7FFB\8B6F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108948895207313325)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_REPOS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\7FFB\8B6F\7684\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108966264090313339)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TREES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108966186128313339)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_WEB_SERVICES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \670D\52D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110078232232314198)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_ROLES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110078382743314198)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109433399804313700)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USER_ROLES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236\4F7F\7528\8005\89D2\8272\6307\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108891864925313281)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108892020045313281)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATION_ACTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5316 - \52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110114120786314244)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_CONCATENATED_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E32\63A5\7684\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108919386890313302)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_LOADS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109345887704313634)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5256\6790\8A2D\5B9A\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109345997558313634)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILE_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5256\6790\8A2D\5B9A\6A94\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110129521686314256)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DEVELOPER_COMMENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\767C\4EBA\54E1\8A3B\89E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110093230592314210)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_EMAIL_TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109651324856313871)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109645611822313866)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109645716905313866)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_LOOKUPS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\8868\683C\67E5\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109645858488313866)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_RULES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\8868\683C\8F49\63DB\898F\5247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108909206784313294)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CALENDARS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\4E8B\66C6\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108908282295313293)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5361\7247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108908361950313293)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARD_ACTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5361\7247\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109622286561313849)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\65B9\683C\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109622344371313849)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109622472302313849)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COL_GROUPS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108883250229313274)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAPS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5730\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108883321934313274)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAP_LAYERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5730\5716\5716\5C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108981198831313351)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGINS'
,p_message_language=>'zh-tw'
,p_message_text=>'Plug-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108981215306313351)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTRIBUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109392688533313669)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTR_VALUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109036102245313398)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_EVENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108983352981313353)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109442441817313707)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ITEM_FILTERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078\904B\7B97\5B50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110151415296314273)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110092162713314209)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_STD_ATTRS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Plug-In \6A19\6E96\5C6C\6027\63CF\8FF0\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109345739231313634)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_REMOTE_SQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528 REST \7684 SQL \4F3A\670D\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109904558368314075)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110151151531314272)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GROUPS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F\9078\9805\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110067473383314191)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GRP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F\9078\9805\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110120664317314249)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_PAGE_DP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110120763312314249)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_REGION_DP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109034530101313397)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_THEME_DISPLAY_POINTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\986F\793A\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108961450217313336)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_USER_INTERFACES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109346495721313634)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_COMP_PARAMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6 REST \4F86\6E90\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109346159792313634)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_MODULES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \8CC7\6599\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109346201275313634)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_OPERATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \4F86\6E90\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109346399822313634)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_PARAMETERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \4F86\6E90\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109346065641313634)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SERVERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \4F86\6E90\9060\7AEF\4F3A\670D\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108892331902313281)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SYNC_STEPS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \540C\6B65\5316\6B65\9A5F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108892209520313281)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_LOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5316\65E5\8A8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108892439908313281)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_MSG_LOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5316\8A0A\606F\65E5\8A8C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110094826703314211)
,p_name=>'DISABLED_NEXT_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\505C\7528\4E0B\4E00\9801\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110094798705314211)
,p_name=>'DISABLED_PREVIOUS_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\505C\7528\4E0A\4E00\9801\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109495429428313747)
,p_name=>'DISABLE_TRIGGER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528\89F8\767C\7A0B\5F0F %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109100839645313446)
,p_name=>'DISPLAY_CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109101048229313446)
,p_name=>'DISPLAY_CONDITION_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\689D\4EF6\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109541137278313781)
,p_name=>'DISPLAY_ORDER_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\9806\5E8F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108987333588313356)
,p_name=>'DISPLAY_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110150848393314272)
,p_name=>'DISPLAY_VALUE.N'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\503C: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110090173505314207)
,p_name=>'DISTINCT_PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\540C\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110090247954314207)
,p_name=>'DISTINCT_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\540C\4F7F\7528\8005')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108914369949313298)
,p_name=>'DML_FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('DML \8868\55AE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109208502418313527)
,p_name=>'DO NOT UPDATE PAGE ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>'DO_NOT_UPDATE_PAGE_ITEMS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109384785148313663)
,p_name=>'DOC_IMPACT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\4EF6\5F71\97FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109385940535313664)
,p_name=>'DOC_STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\4EF6\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109386143559313664)
,p_name=>'DOC_WRITER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\4EF6\4F5C\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109273774729313575)
,p_name=>'DOWN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5411\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109393912039313670)
,p_name=>'DOWNLOAD_LINK_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09\9023\7D50\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109208252555313526)
,p_name=>'DO_NOT_UPDATE_APPLICATION_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\66F4\65B0\61C9\7528\7A0B\5F0F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109208307151313526)
,p_name=>'DO_NOT_UPDATE_DATA_ENTRY_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\66F4\65B0\8CC7\6599\8F38\5165\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109208440338313526)
,p_name=>'DO_NOT_UPDATE_DISPLAY_ONLY_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\66F4\65B0\50C5\4F9B\986F\793A\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109208175581313526)
,p_name=>'DO_NOT_UPDATE_PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\66F4\65B0\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109208917040313527)
,p_name=>'DO_NOT_UPDATE_PAGE_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\66F4\65B0\9801\9762\9805\76EE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109070916836313424)
,p_name=>'DRAG_AND_DROP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62D6\653E\529F\80FD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108978734591313349)
,p_name=>'DRILLDOWN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5411\4E0B\5C55\958B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108978695200313349)
,p_name=>'DRILLUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5411\4E0A\6536\5408')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109116285668313458)
,p_name=>'DRIVEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\5411')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109495288730313747)
,p_name=>'DROP TRIGGER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\89F8\767C\7A0B\5F0F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109494386404313746)
,p_name=>'DROP_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\8CC7\6599\6B04 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109641785248313863)
,p_name=>'DS_ACCESS_METHOD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109641525161313863)
,p_name=>'DS_BIND_VARIABLE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\8B8A\6578\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109641967497313863)
,p_name=>'DS_HANDLER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109642303533313864)
,p_name=>'DS_ITEMS_PER_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\9801\984C\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109642173717313864)
,p_name=>'DS_MIME_TYPES_ALLOWED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\7684 MIME \985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109642251498313864)
,p_name=>'DS_ORIGINS_ALLOWED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\7684\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109641828915313863)
,p_name=>'DS_PARAMETER_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\6578\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109642422531313864)
,p_name=>'DS_SECURITY_CONSTRAINT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\5168\6027\9650\5236\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109641661868313863)
,p_name=>'DS_SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109642063742313863)
,p_name=>'DS_SOURCE_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F86\6E90\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109642578377313864)
,p_name=>'DS_URI_PREFIX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('URI \524D\7F6E\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109641285577313863)
,p_name=>'DS_URI_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('URI \6A23\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110112725742314243)
,p_name=>'DUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5230\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109385793191313664)
,p_name=>'DUE_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5230\671F\65E5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109366248736313649)
,p_name=>'DUPLICATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8907')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110090878811314208)
,p_name=>'DUPLICATE_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\4E2D\6709\91CD\8907\7684\4F7F\7528\8005')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108903186080313289)
,p_name=>'DYNAMIC ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108903097986313289)
,p_name=>'DYNAMIC ACTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108913202918313297)
,p_name=>'DYNAMIC_FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109019131818313385)
,p_name=>'DYNAMIC_HTML'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109069841472313423)
,p_name=>'DYNAMIC_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108896264326313284)
,p_name=>'DYNAMIC_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B\53C3\7167')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109165613528313495)
,p_name=>'EASY_REPORT.INVALID_CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\6240\65B0\589E\7684\689D\4EF6\9020\6210\67E5\8A62\7121\6548.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108907782447313293)
,p_name=>'EDIT PAGE GROUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\9801\9762\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109426380442313695)
,p_name=>'EDITOR_EXIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\60A8\9078\64C7\300C\78BA\5B9A\300D, \5C07\6703\5931\53BB\672A\5132\5B58\7684\8B8A\66F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108939719314313318)
,p_name=>'EDIT_ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\5168\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109166848622313495)
,p_name=>'EDIT_ALL_PAGE_DEFINITION_ATTRIBUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\6240\6709\9801\9762\5B9A\7FA9\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109421243551313691)
,p_name=>'EDIT_ALL_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\6B64\5340\57DF\4E2D\7684\6240\6709\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109351974000313638)
,p_name=>'EDIT_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109440904535313706)
,p_name=>'EDIT_ATTRIBUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110035945973314169)
,p_name=>'EDIT_AUTHENTICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\8A8D\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109430702795313698)
,p_name=>'EDIT_COMPONENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109441089093313706)
,p_name=>'EDIT_COMPONENT_DEF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\5143\4EF6\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109532443812313775)
,p_name=>'EDIT_LINK_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109440856313313706)
,p_name=>'EDIT_LIST_DEV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\6E05\55AE\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110104780414314235)
,p_name=>'EDIT_LOCK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\9396\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109312486637313609)
,p_name=>'EDIT_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109168920351313497)
,p_name=>'EDIT_PAGE_ATTRIBUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\9801\9762\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109699874477313922)
,p_name=>'EDIT_PROFILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\8A2D\5B9A\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109717251464313935)
,p_name=>'EDIT_PROFILE.USER_NO_PRIV_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005 0% \6C92\6709\66F4\65B0\53E6\4E00\4F4D\4F7F\7528\8005\4E4B\8CC7\8A0A\7684\6B0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109430532945313698)
,p_name=>'EDIT_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109505060255313754)
,p_name=>'EDIT_REPORTING_TIMEFRAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\5831\8868\6642\9593\7BC4\570D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109430636461313698)
,p_name=>'EDIT_REPORT_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\5831\8868\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109694062075313917)
,p_name=>'EDIT_REPORT_DIALOG_CLOSED_DA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\5831\8868 - \5C0D\8A71\65B9\584A\5DF2\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109420509428313690)
,p_name=>'EDIT_SYSTEM_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\7CFB\7D71\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109655991316313874)
,p_name=>'EDIT_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109442361749313707)
,p_name=>'EDIT_THIS_ATTRIBUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\6B64\5C6C\6027')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109294737505313595)
,p_name=>'ELAPSED_TIME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D93\6B77\6642\9593')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109373332449313655)
,p_name=>'EMAIL.TEMPLATE.FOOTER_EXAMPLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<a href="#MY_APPLICATION_LINK#">\5B58\53D6\300C\6211\7684\61C9\7528\7A0B\5F0F\300D\53CA\7BA1\7406\60A8\7684\96FB\5B50\90F5\4EF6\504F\597D\8A2D\5B9A</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109380291542313660)
,p_name=>'EMAIL.TEMPLATE.HEADER_EXAMPLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<b style="font-size: 24px;">\6211\7684\61C9\7528\7A0B\5F0F</b>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109494704025313746)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.EV'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>#INVITEE# \60A8\597D,</strong><br>'),
'<br>',
unistr('\9019\662F\60A8\53D7\9080\6D3B\52D5\5373\5C07\5230\4F86\7684\63D0\9192.  \8ACB\53C3\95B1\4E0B\9762\7684\6D3B\52D5\8A73\7D30\8CC7\8A0A:<br>'),
'<br>',
'<table width="100%">',
'  <tr>',
unistr('    <th align="left">\53EC\96C6\4EBA</th>'),
'    <td>#ORGANIZER#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\6D3B\52D5\65E5\671F</th>'),
'    <td>#EVENT_DATE#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\958B\59CB\6642\9593</th>'),
'    <td>#START_TIME#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\6301\7E8C\6642\9593</th>'),
'    <td>#DURATION#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">\5730\9EDE</th>'),
'    <td>#LOCATION#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">URL</th>',
'    <td><a href="#URL_LINK#">#URL_NAME#</a></td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">\9644\8A3B</th>'),
'    <td>#NOTES#</td>',
'  </tr>',
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109373284245313655)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.OD'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>#CUSTOMER_NAME#</strong> \60A8\597D,<br>'),
'<br>',
unistr('\611F\8B1D\60A8\7684\8A02\8CFC!<br>'),
'<br>',
unistr('<strong>\8A02\55AE\8A73\7D30\8CC7\8A0A</strong><br>'),
'<br>',
'<table width="100%">',
'  <tr>',
unistr('    <th align="left">\8A02\8CFC\65E5\671F</th>'),
'    <td>#ORDER_DATE#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\8A02\55AE\7DE8\865F</th>'),
'    <td>#ORDER_NUMBER#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\6536\8CA8\5730\9EDE</th>'),
'    <td>#SHIP_TO#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">\6536\8CA8\5730\5740</th>'),
'    <td>',
'      #SHIPPING_ADDRESS_LINE_1#<br>',
'      #SHIPPING_ADDRESS_LINE_2#',
'    </td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">\8A02\8CFC\9805\76EE</th>'),
'    <td>#ITEMS_ORDERED#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\8A02\55AE\91D1\984D\7E3D\8A08</th>'),
'    <td>#ORDER_TOTAL#</td>',
'  </tr>',
'</table>',
'<br>',
'<br>',
unistr('\9700\8981\8B8A\66F4\60A8\7684\8A02\55AE\55CE? \8ACB<a href="#ORDER_URL#">\5728\6B64\7BA1\7406\60A8\7684\8A02\55AE #ORDER_NUMBER#.</a>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109694339209313917)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.SO'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('#SERVICE_USER# \60A8\597D,<br>'),
'<br>',
unistr('\8ACB\6CE8\610F, \60A8\7684\670D\52D9 #SERVICE_NAME# \8FD1\671F\5C07\9032\884C\6392\5B9A\7684\505C\6A5F.<br>'),
unistr('\672C\6B21\505C\6A5F\6392\5B9A\65BC #OUTAGE_START# \958B\59CB, \9810\8A08 #OUTAGE_DURATION# #OUTAGE_TIMEFRAME# \7121\6CD5\63D0\4F9B\670D\52D9.<br>'),
'<br>',
unistr('\672C\6B21\6392\5B9A\7684\505C\6A5F\671F\9593\5C07\6703\9032\884C\4EE5\4E0B\4F5C\696D:<br>'),
'#OUTAGE_REASON#<br>',
'<br>',
'<br>',
unistr('\5982\5C0D\672C\6B21\505C\6A5F\6709\4EFB\4F55\554F\984C, \8ACB\6D3D\8A62 #OUTAGE_CONTACT#.<br>'),
'<br>',
unistr('\611F\8B1D\60A8\7684\8AD2\89E3,<br>'),
'#SERVICE_TEAM#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109693779078313916)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.EV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D3B\52D5\63D0\9192: #EVENT_NAME#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109693846354313917)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.OD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\55AE (#ORDER_NUMBER#) \5DF2\78BA\8A8D!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109494946258313747)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.EV'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('#INVITEE# \60A8\597D,'),
'',
unistr('\6B64\96FB\5B50\90F5\4EF6\662F\70BA\4E86\63D0\9192\60A8, \60A8\5DF2\548C\5373\5C07\9032\884C\7684\6D3B\52D5\5EFA\7ACB\95DC\806F.'),
'',
unistr('\6D3B\52D5\65E5\671F: #EVENT_DATE#'),
unistr('\958B\59CB\6642\9593: #START_TIME#'),
unistr('\6301\7E8C\6642\9593:   #DURATION#'),
unistr('\53EC\96C6\4EBA:  #ORGANIZER#'),
unistr('\5730\9EDE:   #LOCATION#'),
'URL:        #URL_NAME# (#URL_LINK#)',
unistr('\9644\8A3B:      #NOTES#'),
'',
unistr('\5728\6B64\6AA2\8996\5176\4ED6\6D3B\52D5\8A73\7D30\8CC7\8A0A: #EVENT_LINK#')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109494856538313746)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.OD'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('#CUSTOMER_NAME# \60A8\597D,'),
'',
unistr('\611F\8B1D\60A8\7684\8A02\8CFC!'),
'',
unistr('\8A02\55AE\8A73\7D30\8CC7\8A0A'),
'--------------------------------------------------------------------------------',
unistr('  \8A02\8CFC\65E5\671F:       #ORDER_DATE#'),
unistr('  \8A02\55AE\7DE8\865F:     #ORDER_NUMBER#'),
unistr('  \6536\8CA8\5730\9EDE:          #SHIP_TO#'),
unistr('  \6536\8CA8\5730\5740: #SHIPPING_ADDRESS_LINE_1#'),
'                    #SHIPPING_ADDRESS_LINE_2#',
unistr('  \8A02\8CFC\9805\76EE:    #ITEMS_ORDERED#'),
unistr('  \8A02\55AE\91D1\984D\7E3D\8A08:      #ORDER_TOTAL#'),
'--------------------------------------------------------------------------------',
'',
unistr('\9700\8981\8B8A\66F4\60A8\7684\8A02\55AE\55CE? \8ACB\5728\6B64\7BA1\7406\60A8\7684\8A02\55AE #ORDER_NUMBER#: #ORDER_URL#')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109694246387313917)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.SO'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('#SERVICE_USER# \60A8\597D,'),
'',
unistr('\8ACB\6CE8\610F, \60A8\7684\670D\52D9 #SERVICE_NAME# \8FD1\671F\5C07\9032\884C\6392\5B9A\7684\505C\6A5F.'),
unistr('\672C\6B21\505C\6A5F\6392\5B9A\65BC #OUTAGE_START# \958B\59CB, \9810\8A08 #OUTAGE_DURATION# #OUTAGE_TIMEFRAME# \7121\6CD5\63D0\4F9B\670D\52D9.'),
'',
unistr('\672C\6B21\6392\5B9A\7684\505C\6A5F\671F\9593\5C07\6703\9032\884C\4EE5\4E0B\4F5C\696D:'),
'#OUTAGE_REASON#',
'',
unistr('\5982\5C0D\672C\6B21\505C\6A5F\6709\4EFB\4F55\554F\984C, \8ACB\6D3D\8A62 #OUTAGE_CONTACT#.'),
'',
unistr('\611F\8B1D\60A8\7684\8AD2\89E3,'),
'#SERVICE_TEAM#',
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109424551112313693)
,p_name=>'ENABLE_DEBUGGING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\9664\932F\529F\80FD (\662F\6216\5426)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109495326181313747)
,p_name=>'ENABLE_TRIGGER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\89F8\767C\7A0B\5F0F %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108941976218313320)
,p_name=>'ENCRYPTION_INPUT_TOO_LONG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\52A0\5BC6\7684\503C\9577\5EA6\4E0D\80FD\8D85\904E 4000 \500B\4F4D\5143\7D44.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108940565280313318)
,p_name=>'END_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109363320866313647)
,p_name=>'ENHANCEMENT_REQUEST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\589E\5F37\529F\80FD\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109717936706313936)
,p_name=>'ENHANCEMENT_REQUEST_DASH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\589E\5F37\529F\80FD\8981\6C42: %1 \500B\5DF2\8655\7406, \5171 %0 \500B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109365758366313649)
,p_name=>'ENTERED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8F38\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108906938108313292)
,p_name=>'ENTER_WEBSHEETS_CREDENTIALS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\300CWeb \8A66\7B97\8868\300D\8B49\660E\8CC7\6599.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109353565531313640)
,p_name=>'ENTRY LINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109353417412313640)
,p_name=>'ENTRY TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\6587\5B57')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109408874373313682)
,p_name=>'ERROR PAGE TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\8A0A\606F\9801\9762\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109271956272313574)
,p_name=>'ERRORPAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767C\751F\932F\8AA4\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109421593605313691)
,p_name=>'ERRORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109354776073313640)
,p_name=>'ERROR_ICON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\5716\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110111788757314242)
,p_name=>'ERROR_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\8A0A\606F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109346936610313635)
,p_name=>'ESCAPED_COL_TOO_LARGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<br><strong>\300C\9041\96E2\8CC7\6599\300D\8D85\904E\5141\8A31\7684\9650\5236, \5DF2\5C07\7D50\679C\6E1B\70BA 32k</strong>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109115436558313457)
,p_name=>'ESCAPE_SC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9041\96E2\7279\6B8A\5B57\5143')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109387138868313665)
,p_name=>'ESTIMATED_EFFORT_IN_HOURS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\4F30\5DE5\4F5C (\5C0F\6642)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109641447998313863)
,p_name=>'ETAG_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ETAG \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109641315280313863)
,p_name=>'ETAG_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ETAG \985E\578B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109363827342313647)
,p_name=>'EVENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109698472387313920)
,p_name=>'EVENT.APEX.APEXAFTERREFRESH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6574\7406\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109698738432313921)
,p_name=>'EVENT.APEX.APEXBEFOREPAGESUBMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\9801\9762\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109698388820313920)
,p_name=>'EVENT.APEX.APEXBEFOREREFRESH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6574\7406\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109700938680313922)
,p_name=>'EVENT.BROWSER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\5668\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109162042219313492)
,p_name=>'EVENT.BROWSER.APEXDOUBLETAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9EDE\5169\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109162265747313492)
,p_name=>'EVENT.BROWSER.APEXPAN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E73\79FB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109162198924313492)
,p_name=>'EVENT.BROWSER.APEXPRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109162362333313492)
,p_name=>'EVENT.BROWSER.APEXSWIPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6ED1\904E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109161978969313492)
,p_name=>'EVENT.BROWSER.APEXTAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9EDE\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109697865299313920)
,p_name=>'EVENT.BROWSER.CHANGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109697142757313919)
,p_name=>'EVENT.BROWSER.CLICK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E00\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109697235695313920)
,p_name=>'EVENT.BROWSER.DBLCLICK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\5169\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109696632315313919)
,p_name=>'EVENT.BROWSER.FOCUSIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\5F97\7126\9EDE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109696550694313919)
,p_name=>'EVENT.BROWSER.FOCUSOUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5931\53BB\7126\9EDE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109698040787313920)
,p_name=>'EVENT.BROWSER.KEYDOWN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E0B\6309\9375')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109698158363313920)
,p_name=>'EVENT.BROWSER.KEYPRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4F4F\6309\9375')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109698293998313920)
,p_name=>'EVENT.BROWSER.KEYUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\653E\958B\6309\9375')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109696799112313919)
,p_name=>'EVENT.BROWSER.LOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\8CC7\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109697307313313920)
,p_name=>'EVENT.BROWSER.MOUSEDOWN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\6ED1\9F20\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109697655516313920)
,p_name=>'EVENT.BROWSER.MOUSEENTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6ED1\9F20\9032\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109697763829313920)
,p_name=>'EVENT.BROWSER.MOUSELEAVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6ED1\9F20\96E2\958B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109697569713313920)
,p_name=>'EVENT.BROWSER.MOUSEMOVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6ED1\9F20\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109697492435313920)
,p_name=>'EVENT.BROWSER.MOUSEUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\653E\958B\6ED1\9F20\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108905933410313292)
,p_name=>'EVENT.BROWSER.ORIENTATIONCHANGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\5411\8B8A\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109704259305313925)
,p_name=>'EVENT.BROWSER.READY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109696844492313919)
,p_name=>'EVENT.BROWSER.RESIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\8ABF\6574\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109696900964313919)
,p_name=>'EVENT.BROWSER.SCROLL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6372\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108906019277313292)
,p_name=>'EVENT.BROWSER.SCROLLSTART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6372\52D5\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108906163586313292)
,p_name=>'EVENT.BROWSER.SCROLLSTOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6372\52D5\7D50\675F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109697976463313920)
,p_name=>'EVENT.BROWSER.SELECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108905124214313291)
,p_name=>'EVENT.BROWSER.SWIPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6ED1\904E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108905287936313291)
,p_name=>'EVENT.BROWSER.SWIPELEFT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5411\5DE6\6ED1\904E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108905325239313291)
,p_name=>'EVENT.BROWSER.SWIPERIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5411\53F3\6ED1\904E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108904975202313291)
,p_name=>'EVENT.BROWSER.TAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9EDE\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108905056374313291)
,p_name=>'EVENT.BROWSER.TAPHOLD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9EDE\9078\4E26\6309\4F4F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109697083228313919)
,p_name=>'EVENT.BROWSER.UNLOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5378\8F09\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108905745180313291)
,p_name=>'EVENT.BROWSER.VCLICK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\865B\64EC\9EDE\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108905848715313291)
,p_name=>'EVENT.BROWSER.VMOUSECANCEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89F8\78B0\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108905400471313291)
,p_name=>'EVENT.BROWSER.VMOUSEDOWN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89F8\78B0\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108905502112313291)
,p_name=>'EVENT.BROWSER.VMOUSEMOVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89F8\78B0\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108905606272313291)
,p_name=>'EVENT.BROWSER.VMOUSEUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89F8\78B0\7D50\675F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109701134194313923)
,p_name=>'EVENT.COMPONENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108901906646313289)
,p_name=>'EVENT.CUSTOM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108902031043313289)
,p_name=>'EVENT.CUSTOM.CUSTOM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109701024324313922)
,p_name=>'EVENT.FRAMEWORK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67B6\69CB\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109278300324313583)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSECANCELDIALOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\8A71\65B9\584A\5DF2\95DC\9589\6216\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109430443367313698)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSEDIALOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\8A71\65B9\584A\5DF2\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110119687606314248)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERREFRESH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6574\7406\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110119783288314248)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREPAGESUBMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\9801\9762\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110119595547314248)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREREFRESH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6574\7406\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109348686428313636)
,p_name=>'EVENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109385837123313664)
,p_name=>'EVENT_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CC\7A0B\7891\7DE8\865F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109426780142313695)
,p_name=>'EXACT_SUBS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\5168\76F8\540C\7684\66FF\4EE3\9805\76EE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109540507153313781)
,p_name=>'EXAMPLE_1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109540698242313781)
,p_name=>'EXAMPLE_2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110040799348314172)
,p_name=>'EXAMPLE_OF_XML_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\662F XML \8CC7\6599\5EAB\8CC7\6599\6B04\5167\6240\542B\8CC7\6599\7684\7BC4\4F8B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110090780033314208)
,p_name=>'EXAMPLE_URI'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B URI')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109496483131313748)
,p_name=>'EXCLUDE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5305\62EC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109476097508313733)
,p_name=>'EXISTING_SCHEMA_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\73FE\6709\7684\7DB1\8981\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109418006464313689)
,p_name=>'EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108973314906313345)
,p_name=>'EXISTS_SQL_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('EXISTS SQL \67E5\8A62')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109688699531313908)
,p_name=>'EXPANDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\64F4\5145')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110086531930314204)
,p_name=>'EXPAND_ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8\5C55\958B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109038586627313400)
,p_name=>'EXPIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904E\671F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109352138794313639)
,p_name=>'EXPLAIN PLAN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E\8A08\756B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109348990774313636)
,p_name=>'EXPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109657248187313876)
,p_name=>'EXPORT REPOSITORY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\51FA\5132\5B58\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109431082638313698)
,p_name=>'EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5176\4ED6\5DE5\4F5C\5340\6216\61C9\7528\7A0B\5F0F\532F\51FA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109431165884313698)
,p_name=>'EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\76EE\524D\7684\5DE5\4F5C\5340\532F\51FA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109500442156313751)
,p_name=>'EXPORT_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\51FA\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109504678677313754)
,p_name=>'EXPORT_PKG_APP_FOR_DEPLOYMENT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\60A8\53EF\4EE5\4F7F\7528\9019\4E9B\9023\7D50\4F86\4E0B\8F09\6B64\61C9\7528\7A0B\5F0F\8207\5176\76F8\5C0D\61C9\7684\8CC7\6599\5EAB\652F\63F4\7269\4EF6, \4EE5\90E8\7F72\65BC\4E0D\540C\7684 Oracle APEX \5B89\88DD\4E2D.  \4E0B\8F09\7684\6A94\6848\5C07\662F\53EF\4EE5\5F9E SQL*Plus\3001SQL Developer \57F7\884C\7684\300CSQL \547D\4EE4\6A94\300D, \6216\662F Oracle APEX \5167\7684\300CSQL \547D\4EE4\6A94\300D.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109500594429313751)
,p_name=>'EXPORT_SUPPORTING_OBJECTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\51FA\652F\63F4\7684\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109349240628313636)
,p_name=>'EXPORT_TYPES.APP_EXPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\51FA\61C9\7528\7A0B\5F0F  ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109349434405313637)
,p_name=>'EXPORT_TYPES.CSS_EXPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\51FA\968E\5C64\5F0F\6A23\5F0F\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109349617403313637)
,p_name=>'EXPORT_TYPES.FILE_EXPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\51FA\975C\614B\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109349550573313637)
,p_name=>'EXPORT_TYPES.IMAGE_EXPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\51FA\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109349386909313636)
,p_name=>'EXPORT_TYPES.PAGE_EXPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\51FA\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109349759210313637)
,p_name=>'EXPORT_TYPES.SCRIPT_FILE_EXPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\51FA\547D\4EE4\6A94\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109345614182313634)
,p_name=>'EXPORT_TYPES.UI_DEFAULTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762\9810\8A2D\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109276790120313582)
,p_name=>'F4000.APPLICATION_COMPUTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109274791867313580)
,p_name=>'F4000.APPLICATION_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109276536219313582)
,p_name=>'F4000.APPLICATION_PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109091492967313439)
,p_name=>'F4000.APPLICATION_RESERVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('3000 \5230 8999 \4E4B\9593\7684\61C9\7528\7A0B\5F0F ID \70BA\4FDD\7559\7684 ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108974536976313346)
,p_name=>'F4000.APP_EXPORT_CURR_WS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\61C9\7528\7A0B\5F0F\662F\5F9E\76EE\524D\7684\5DE5\4F5C\5340\532F\51FA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108974626860313346)
,p_name=>'F4000.APP_EXPORT_NON_CURR_WS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\61C9\7528\7A0B\5F0F\662F\5F9E\5176\4ED6\5DE5\4F5C\5340\532F\51FA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109908366290314078)
,p_name=>'F4000.APP_PRINT_CREDENTIALS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F %0 \9060\7AEF\5217\5370\4F3A\670D\5668\8B49\660E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109908141933314077)
,p_name=>'F4000.APP_REMOTE_PRINT_SERVER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F %0 \9060\7AEF\5217\5370\4F3A\670D\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109276475364313582)
,p_name=>'F4000.BRANCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109290309128313592)
,p_name=>'F4000.BRANCH_FROM_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\9801\9762\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109290574748313592)
,p_name=>'F4000.BRANCH_TO_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\5230\5206\652F\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109276058231313581)
,p_name=>'F4000.BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109417077466313688)
,p_name=>'F4000.BUTTON.ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109029845095313393)
,p_name=>'F4000.CALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\4E8B\66C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109152350458313485)
,p_name=>'F4000.CALENDAR_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\4E8B\66C6\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109290943039313593)
,p_name=>'F4000.COLUMN_ATTRIBUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110054977847314182)
,p_name=>'F4000.COLUMN_NAME_RESERVED_WORD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\8CC7\6599\6B04\540D\7A31\662F\4E00\500B Oracle \4FDD\7559\5B57.  \8ACB\9078\64C7\5176\4ED6\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109418493026313689)
,p_name=>'F4000.COPY_LIST_ENTRY_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\6E05\55AE\9805\76EE: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109304280747313603)
,p_name=>'F4000.DYNAMIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108988793956313357)
,p_name=>'F4000.DYNAMIC ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108974433391313346)
,p_name=>'F4000.EXPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109306421754313604)
,p_name=>'F4000.FIX_ME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\884C\4FEE\6B63')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109303852105313602)
,p_name=>'F4000.FOR_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9069\7528\65BC\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109303788199313602)
,p_name=>'F4000.FOR_USER_SESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7528\65BC\4F7F\7528\8005\968E\6BB5\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109290681510313592)
,p_name=>'F4000.FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109092573171313440)
,p_name=>'F4000.HEADER_VALIDATION1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D\5FC5\9808\5305\542B <strong>&lt;head&gt;</strong> \548C <strong>&lt;/head&gt;</strong> \6A19\8A18.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109092807972313440)
,p_name=>'F4000.HEADER_VALIDATION2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<strong>#HEAD#</strong> \66FF\4EE3\5B57\4E32\5FC5\9808\986F\793A\5728 <strong>&lt;head&gt;</strong> \548C <strong>&lt;/head&gt;</strong> \6A19\8A18\4E4B\9593.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109361429277313645)
,p_name=>'F4000.INVALID_FILE_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848 "%0" \7684\985E\578B\7121\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109275781423313581)
,p_name=>'F4000.ITEM_DISPLAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109275898474313581)
,p_name=>'F4000.ITEM_READ_ONLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\552F\8B80\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108921161495313303)
,p_name=>'F4000.LEGACY_SQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\820A\6709 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109444436411313709)
,p_name=>'F4000.LINK_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109308990954313606)
,p_name=>'F4000.LIST_INITCAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109277167097313582)
,p_name=>'F4000.LIST_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108921047444313303)
,p_name=>'F4000.LOCAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672C\6A5F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109277426801313582)
,p_name=>'F4000.LOV_ENTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109290702393313592)
,p_name=>'F4000.MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109277300701313582)
,p_name=>'F4000.MENU_OPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109320736113313615)
,p_name=>'F4000.MUST_SELECT_AT_LEAST_ONE_TO_COPY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81F3\5C11\5FC5\9808\9078\53D6\4E00\500B\9805\76EE\4F86\8907\88FD\6216\8A02\95B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109276835291313582)
,p_name=>'F4000.NAVIGATION_BAR_ENTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\5217\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109207525135313526)
,p_name=>'F4000.NAVIGATION_BAR_ICON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\5217\5716\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109274672218313580)
,p_name=>'F4000.NO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109304374588313603)
,p_name=>'F4000.NOT_REFERENCED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\53C3\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109288862677313591)
,p_name=>'F4000.NO_DATA_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110114283855314244)
,p_name=>'F4000.P1.APP_DOES_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\5DE5\4F5C\5340\4E2D\6C92\6709\61C9\7528\7A0B\5F0F %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109715175454313933)
,p_name=>'F4000.P1000.UPDATE_CHECK_DISABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\66F4\65B0\6AA2\67E5\300D\5DF2\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109313530068313610)
,p_name=>'F4000.P104.PARENT_TAB_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\9801\7C64\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108977290628313348)
,p_name=>'F4000.P111.CANCEL_BUTTON_BRANCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88\6309\9215\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108976818773313348)
,p_name=>'F4000.P111.CANCEL_BUTTON_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88\6309\9215\986F\793A\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108977396498313348)
,p_name=>'F4000.P111.FINISH_BUTTON_BRANCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210\6309\9215\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108976901014313348)
,p_name=>'F4000.P111.FINISH_BUTTON_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210\6309\9215\986F\793A\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108977174929313348)
,p_name=>'F4000.P111.NEXT_BUTTON_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\6B65\6309\9215\986F\793A\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108977034326313348)
,p_name=>'F4000.P111.PREVIOUS_BUTTON_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\6B65\6309\9215\986F\793A\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109313603487313610)
,p_name=>'F4000.P112.TREE_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109313779324313610)
,p_name=>'F4000.P119.GO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109313820880313610)
,p_name=>'F4000.P130.USING_SAME_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8207\73FE\6709\61C9\7528\7A0B\5F0F\76F8\540C\7684\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110116782253314246)
,p_name=>'F4000.P135.COPY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110118424317314247)
,p_name=>'F4000.P149.PUBLISH_AUTHORIZATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\767C\5E03 <strong>%0</strong>. \9019\6703\91CD\65B0\6574\7406\4E0B\5217\300C\6388\6B0A\914D\7F6E\300D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110118709872314247)
,p_name=>'F4000.P149.PUBLISH_BREADCRUMB_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\767C\5E03 <strong>%0</strong>. \9019\6703\91CD\65B0\6574\7406\4E0B\5217\300C\5C0E\89BD\8DEF\5F91\6A23\677F\300D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110118884428314247)
,p_name=>'F4000.P149.PUBLISH_BUTTON_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\767C\5E03 <strong>%0</strong>. \9019\6703\91CD\65B0\6574\7406\4E0B\5217\300C\6309\9215\6A23\677F\300D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110118933563314247)
,p_name=>'F4000.P149.PUBLISH_CALENDAR_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\767C\5E03 <strong>%0</strong>. \9019\6703\91CD\65B0\6574\7406\4E0B\5217\300C\884C\4E8B\66C6\6A23\677F\300D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108900530834313287)
,p_name=>'F4000.P149.PUBLISH_DATA_LOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\767C\5E03 <strong>%0</strong>. \9019\6703\91CD\65B0\6574\7406\4E0B\5217\8CC7\6599\8F09\5165\5B9A\7FA9:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110118341925314247)
,p_name=>'F4000.P149.PUBLISH_FIELD_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\767C\5E03 <strong>%0</strong>. \9019\6703\91CD\65B0\6574\7406\4E0B\5217\300C\6A19\7C64\6A23\677F\300D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110118123381314247)
,p_name=>'F4000.P149.PUBLISH_LIST_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\767C\5E03 <strong>%0</strong>. \9019\6703\91CD\65B0\6574\7406\4E0B\5217\300C\6E05\55AE\6A23\677F\300D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110117811546314247)
,p_name=>'F4000.P149.PUBLISH_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\767C\5E03 <strong>%0</strong>. \9019\6703\91CD\65B0\6574\7406\4E0B\5217\300C\6578\503C\6E05\55AE\300D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110118690929314247)
,p_name=>'F4000.P149.PUBLISH_NAVBAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\767C\5E03 <strong>%0</strong>. \9019\6703\91CD\65B0\6574\7406\4E0B\5217\300C\5C0E\89BD\5217\9805\76EE\300D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110117913712314247)
,p_name=>'F4000.P149.PUBLISH_PAGE_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\767C\5E03 <strong>%0</strong>. \9019\6703\91CD\65B0\6574\7406\4E0B\5217\300C\9801\9762\6A23\677F\300D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110119012381314248)
,p_name=>'F4000.P149.PUBLISH_PLUGIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\767C\5E03 <strong>%0</strong>. \9019\6703\91CD\65B0\6574\7406\4E0B\5217 Plug-in:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110119192959314248)
,p_name=>'F4000.P149.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\767C\5E03 <strong>%0</strong>. \9019\6703\91CD\65B0\6574\7406\4E0B\5217\300C\5373\73FE\5F0F\6578\503C\6E05\55AE\6A23\677F\300D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110118014969314247)
,p_name=>'F4000.P149.PUBLISH_REGION_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\767C\5E03 <strong>%0</strong>. \9019\6703\91CD\65B0\6574\7406\4E0B\5217\300C\5340\57DF\6A23\677F\300D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110118283392314247)
,p_name=>'F4000.P149.PUBLISH_REPORT_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\767C\5E03 <strong>%0</strong>. \9019\6703\91CD\65B0\6574\7406\4E0B\5217\300C\5831\8868\6A23\677F\300D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110118543869314247)
,p_name=>'F4000.P149.PUBLISH_SHORTCUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\767C\5E03 <strong>%0</strong>. \9019\6703\91CD\65B0\6574\7406\4E0B\5217\300C\6377\5F91\300D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109477160317313734)
,p_name=>'F4000.P149.PUBLISH_WEB_SRC_MODULE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\767C\5E03 <strong>%0</strong>. \9019\6703\91CD\65B0\6574\7406\4E0B\5217 REST \8CC7\6599\4F86\6E90:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109321568817313616)
,p_name=>'F4000.P158.COPY_OF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \7684\8907\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110116684156314246)
,p_name=>'F4000.P1701.LOOKUP_DEFINITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\5C0B\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110114359486314244)
,p_name=>'F4000.P1704.REGION_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109092134827313440)
,p_name=>'F4000.P19.VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81F3\5C11\5FC5\9808\6307\5B9A\4E00\500B\9805\76EE, \624D\80FD\5EFA\7ACB\975E\7A7A\503C\9A57\8B49.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110026511302314162)
,p_name=>'F4000.P1935.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \61C9\7528\7A0B\5F0F\5217\5370\4F3A\670D\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109738349337313952)
,p_name=>'F4000.P2.UPDATE_EXPORT_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\9810\8A2D\532F\51FA\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109850011431314036)
,p_name=>'F4000.P203.ACTION='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109357767844313643)
,p_name=>'F4000.P203.COMMENT='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A3B\89E3=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109355841958313641)
,p_name=>'F4000.P203.COMP.MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7528\65BC\57F7\884C\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110123147017314251)
,p_name=>'F4000.P203.CONCATENATED_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E32\63A5\7684\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109356479651313642)
,p_name=>'F4000.P203.DISPVAL='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\503C=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110123094086314251)
,p_name=>'F4000.P203.FILE='
,p_message_language=>'zh-tw'
,p_message_text=>'file='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109356184552313642)
,p_name=>'F4000.P203.ICONBAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109356697092313642)
,p_name=>'F4000.P203.LOV='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE =')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109356338590313642)
,p_name=>'F4000.P203.LOVDATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109356289736313642)
,p_name=>'F4000.P203.NAME='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109355717528313641)
,p_name=>'F4000.P203.PAGE.MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7528\65BC\986F\793A\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109357665312313643)
,p_name=>'F4000.P203.PAGEBRANCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109356776085313642)
,p_name=>'F4000.P203.PGTEMP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109356023776313641)
,p_name=>'F4000.P203.PROC.MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7528\65BC\57F7\884C\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109355919308313641)
,p_name=>'F4000.P203.PROCESSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5728\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109356500912313642)
,p_name=>'F4000.P203.RETVAL='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\503C=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110119392556314248)
,p_name=>'F4000.P2222.REPARENT_LIST_ENTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D\6E05\55AE\9805\76EE\7236\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109151977584313484)
,p_name=>'F4000.P254.VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81F3\5C11\5FC5\9808\6307\5B9A\4E00\500B\8981\5EFA\7ACB\7684\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109274394211313575)
,p_name=>'F4000.P277.WORKSPACE_NOT_CREATED_ALREADY_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\5DF2\7D93\5B58\5728, \56E0\6B64\4E0D\6703\518D\5EFA\7ACB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109274468939313576)
,p_name=>'F4000.P277.WORKSPACE_WILL_BE_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\5EFA\7ACB\5DE5\4F5C\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110120104373314248)
,p_name=>'F4000.P291.VIEW_LOCK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\9396\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109152013708313484)
,p_name=>'F4000.P295.VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81F3\5C11\5FC5\9808\6307\5B9A\4E00\500B\8981\5EFA\7ACB\7684\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110120290348314248)
,p_name=>'F4000.P337.PAGE_UNLOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\5DF2\89E3\9664\9396\5B9A\6B64\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109683645691313902)
,p_name=>'F4000.P371.POPUP_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5373\73FE\5F0F LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109314283447313610)
,p_name=>'F4000.P374.POS.1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109314367536313610)
,p_name=>'F4000.P374.POS.2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109314496617313610)
,p_name=>'F4000.P374.POS.3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109314547302313610)
,p_name=>'F4000.P374.POS.4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108912431029313297)
,p_name=>'F4000.P374.POS.5'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109481303009313737)
,p_name=>'F4000.P374.POS.6'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109481490520313737)
,p_name=>'F4000.P374.POS.7'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109481512733313737)
,p_name=>'F4000.P374.POS.8'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109314669345313611)
,p_name=>'F4000.P381_XBUTTON_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('DML \548C\5206\9801\6309\9215\9700\8981\7279\5B9A\6309\9215\540D\7A31, \53C3\7167\8AAA\660E\5167\5BB9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110116890512314246)
,p_name=>'F4000.P386.CLASS_MATCHES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 (\985E\5225\76F8\7B26\9805\76EE)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109314726851313611)
,p_name=>'F4000.P4001.AUTH_HOME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110123466356314251)
,p_name=>'F4000.P4001.ORIGINAL_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\539F\59CB\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109314895685313611)
,p_name=>'F4000.P4001.SUBSTITUTION_STR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66FF\4EE3\5B57\4E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109314926409313611)
,p_name=>'F4000.P4001.SUBSTITUTION_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66FF\4EE3\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109288200553313591)
,p_name=>'F4000.P4017.HELP_REGION_SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<font class="instructiontext">\4F7F\7528\4EE5\4E0B\8A9E\6CD5\547C\53EB\6642, \6B64\5340\57DF\5C07\986F\793A\76EE\524D\9801\9762\7684\9801\9762\548C\9805\76EE\8AAA\660E:<br>'),
'<pre><escape sc>f?p=&AMP;APP_ID.:Page:Session:&APP_PAGE_ID.</pre></font>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109315026811313611)
,p_name=>'F4000.P4039.FORM_ON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \76F8\95DC\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109315124843313611)
,p_name=>'F4000.P404.VALUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109039292674313400)
,p_name=>'F4000.P4045.BRANCH='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\652F=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109307399683313605)
,p_name=>'F4000.P4045.BUTTON='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108929969341313310)
,p_name=>'F4000.P4045.CHART_SERIES='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868\6578\5217=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109307530963313605)
,p_name=>'F4000.P4045.COMPUTATION='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109306916902313605)
,p_name=>'F4000.P4045.ICON_SUBTEXT='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A\8AAA\660E\6587\5B57=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109306816294313605)
,p_name=>'F4000.P4045.IMAGE='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109307407128313605)
,p_name=>'F4000.P4045.ITEM='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109307020013313605)
,p_name=>'F4000.P4045.LIST='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109039387727313400)
,p_name=>'F4000.P4045.MENU_OPTION='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\9805\76EE=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109307228977313605)
,p_name=>'F4000.P4045.PAGE='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109307646937313605)
,p_name=>'F4000.P4045.PROCESS='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4F5C\696D=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108929885368313310)
,p_name=>'F4000.P4045.REGION='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109304499561313603)
,p_name=>'F4000.P4045.REQUIRED_BY_EVERY_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7684\6BCF\4E00\500B\9801\9762\90FD\9700\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109306599739313604)
,p_name=>'F4000.P4045.REQUIRED_TO_DISPLAY_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109306617399313605)
,p_name=>'F4000.P4045.REQUIRED_TO_RUN_APP_COMPUTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109306732329313605)
,p_name=>'F4000.P4045.REQUIRED_TO_RUN_APP_PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109307887947313605)
,p_name=>'F4000.P4045.TAB_NAME='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64\540D\7A31=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109307980414313606)
,p_name=>'F4000.P4045.TAB_SET='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64\96C6=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109307117579313605)
,p_name=>'F4000.P4045.TEXT='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109307744250313605)
,p_name=>'F4000.P4045.VALIDATION='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109316812149313612)
,p_name=>'F4000.P420.CSV_EXPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109317405519313613)
,p_name=>'F4000.P420.CVS'
,p_message_language=>'zh-tw'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109316444712313612)
,p_name=>'F4000.P420.DEFAULT_LOOK1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5916\89C0 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109316568099313612)
,p_name=>'F4000.P420.DEFAULT_LOOK2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5916\89C0 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109316619755313612)
,p_name=>'F4000.P420.DEFAULT_LOOK3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5916\89C0 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109316740727313612)
,p_name=>'F4000.P420.DEFAULT_LOOK4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5916\89C0 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109315579728313611)
,p_name=>'F4000.P420.EXTERNAL_PAGINATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\5916\90E8\5EFA\7ACB\7684\5206\9801\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109316371522313612)
,p_name=>'F4000.P420.HTML_STD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \6A19\6E96\5916\89C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109317016514313612)
,p_name=>'F4000.P420.LOOK1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\89C0 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109317107509313612)
,p_name=>'F4000.P420.LOOK2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\89C0 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109317236383313613)
,p_name=>'F4000.P420.LOOK3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\89C0 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109317379412313613)
,p_name=>'F4000.P420.LOOK4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\89C0 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109316050957313612)
,p_name=>'F4000.P420.ROWS_X_TO_Y'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\7BC4\570D X \5230 Y')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109315755044313611)
,p_name=>'F4000.P420.ROW_RANGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6E05\55AE\4E2D\7684\8CC7\6599\5217\7BC4\570D 1-15 16-30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109316259813313612)
,p_name=>'F4000.P420.SEARCH_ENGINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\5F15\64CE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109315847324313612)
,p_name=>'F4000.P420.SEARCH_ENGINE_123'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\5F15\64CE 1,2,3,4 (\8A2D\5B9A\57FA\672C\5206\9801)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109316152325313612)
,p_name=>'F4000.P420.SELECT_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109315350544313611)
,p_name=>'F4000.P420.SET_DEFAULTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109315475314313611)
,p_name=>'F4000.P420.TURN_OFF_PAGINATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589\5206\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109315956463313612)
,p_name=>'F4000.P420.USE_PAGINATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\5206\9801\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109317504569313613)
,p_name=>'F4000.P420.XML'
,p_message_language=>'zh-tw'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109316958449313612)
,p_name=>'F4000.P420.XML_EXPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\51FA XML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109317675360313613)
,p_name=>'F4000.P422.GEN_LINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7522\751F\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109315624302313611)
,p_name=>'F4000.P429.ROWS_X_TO_Y'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\7BC4\570D X \5230 Y (\542B\4E0B\4E00\500B\548C\4E0A\4E00\500B\9023\7D50)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110142742374314266)
,p_name=>'F4000.P4311.P371.ALWAYS_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109441637529313707)
,p_name=>'F4000.P4311.P371.DB_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109441836075313707)
,p_name=>'F4000.P4311.P371.PLSQL_EXP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109441960261313707)
,p_name=>'F4000.P4311.P371.PLSQL_FUNC_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109441744488313707)
,p_name=>'F4000.P4311.P371.SQL_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109441549097313706)
,p_name=>'F4000.P4311.P371.STATIC_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109317718090313613)
,p_name=>'F4000.P4314_XBUTTON_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('DML \6309\9215\9700\8981\6709\7279\5B9A\6309\9215\540D\7A31, \53C3\7167\8AAA\660E\5167\5BB9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108984347984313354)
,p_name=>'F4000.P4450.ACTION_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5728\61C9\7528\7A0B\5F0F %0 \4E2D\5EFA\7ACB\65B0 Plug-in.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108984221666313354)
,p_name=>'F4000.P4450.ACTION_REPLACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\53D6\4EE3\61C9\7528\7A0B\5F0F %0 \4E2D\73FE\6709\7684 Plug-in.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109317813921313613)
,p_name=>'F4000.P4651.HTML_W_SHORTCUTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\542B\6709\6377\5F91\7684 HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109318009912313613)
,p_name=>'F4000.P4651.PLSQL'
,p_message_language=>'zh-tw'
,p_message_text=>'PLSQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109308771539313606)
,p_name=>'F4000.P4656.DEFAULT_BUTTON_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\6309\9215\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109029714743313393)
,p_name=>'F4000.P4656.DEFAULT_CALENDAR_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\884C\4E8B\66C6\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110139085129314263)
,p_name=>'F4000.P4656.DEFAULT_CHART_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5716\8868\5340\57DF\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109029546700313393)
,p_name=>'F4000.P4656.DEFAULT_DIALOG_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5C0D\8A71\65B9\584A\9801\9762\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110139143996314263)
,p_name=>'F4000.P4656.DEFAULT_FORM_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\8868\55AE\5340\57DF\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110139527438314263)
,p_name=>'F4000.P4656.DEFAULT_IRR_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\4E92\52D5\5F0F\5831\8868\5340\57DF\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109308682759313606)
,p_name=>'F4000.P4656.DEFAULT_LABEL_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\6A19\7C64\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110139234303314263)
,p_name=>'F4000.P4656.DEFAULT_LISTR_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\6E05\55AE\5340\57DF\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109308514177313606)
,p_name=>'F4000.P4656.DEFAULT_LIST_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\6E05\55AE\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110139762857314263)
,p_name=>'F4000.P4656.DEFAULT_MENUR_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5C0E\89BD\8DEF\5F91\5340\57DF\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109308813876313606)
,p_name=>'F4000.P4656.DEFAULT_MENU_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5C0E\89BD\8DEF\5F91\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110138892439314263)
,p_name=>'F4000.P4656.DEFAULT_NAV_BAR_LIST_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5C0E\89BD\5217\6E05\55AE\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110138536942314262)
,p_name=>'F4000.P4656.DEFAULT_NAV_LIST_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5C0E\89BD\529F\80FD\8868\6E05\55AE\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110138378410314262)
,p_name=>'F4000.P4656.DEFAULT_OPTION_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\9078\64C7\6027\6A19\7C64\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109308269132313606)
,p_name=>'F4000.P4656.DEFAULT_PAGE_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\9801\9762\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109308347338313606)
,p_name=>'F4000.P4656.DEFAULT_REGION_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5340\57DF\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110139352564314263)
,p_name=>'F4000.P4656.DEFAULT_REPORTR_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5831\8868\5340\57DF\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109308412369313606)
,p_name=>'F4000.P4656.DEFAULT_REPORT_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5831\8868\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110138447458314262)
,p_name=>'F4000.P4656.DEFAULT_REQUIRED_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5FC5\8981\6A19\7C64\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110138738325314263)
,p_name=>'F4000.P4656.DEFAULT_SIDE_NAV_LIST_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5074\908A\5C0E\89BD\529F\80FD\8868\6E05\55AE\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110139480480314263)
,p_name=>'F4000.P4656.DEFAULT_TABFORM_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5217\8868\5316\8868\55AE\5340\57DF\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110138606850314263)
,p_name=>'F4000.P4656.DEFAULT_TOP_NAV_LIST_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\9802\7AEF\5C0E\89BD\529F\80FD\8868\6E05\55AE\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110139662973314263)
,p_name=>'F4000.P4656.DEFAULT_WIZARD_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\7CBE\9748\5340\57DF\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109308136505313606)
,p_name=>'F4000.P4656.ERROR_PAGE_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\932F\8AA4\9801\9762\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110138932264314263)
,p_name=>'F4000.P4656.LOGIN_PAGE_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\767B\5165\9801\9762\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109308026946313606)
,p_name=>'F4000.P4656.PRINT_MODE_PAGE_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5217\5370\6A21\5F0F\9801\9762\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109315261741313611)
,p_name=>'F4000.P4703.REPORT_ON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \76F8\95DC\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109311831713313608)
,p_name=>'F4000.P4717.ALERT_INFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\793A\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109312027268313609)
,p_name=>'F4000.P4717.NEW_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109311794174313608)
,p_name=>'F4000.P4717.REGION_MUST_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\81F3\5C11\5FC5\9808\5148\5EFA\7ACB\4E00\500B\5340\57DF\5F8C, \624D\80FD\5EFA\7ACB\9801\9762\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109311982711313608)
,p_name=>'F4000.P4717.USE_WIZARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\7CBE\9748\4F86\5EFA\7ACB\65B0\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109313272766313610)
,p_name=>'F4000.P4719.ALPHABETIC_SORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\6309\5B57\6BCD\9806\5E8F\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109313409745313610)
,p_name=>'F4000.P4719.BIND_VAR_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B 4: \542B\9023\7D50\8B8A\6578\7684\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109313389390313610)
,p_name=>'F4000.P4719.CREATION_SORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\5EFA\7ACB\9806\5E8F\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109312922984313609)
,p_name=>'F4000.P4719.D_R_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B 2: \5177\6709\76F8\540C\986F\793A\503C\548C\50B3\56DE\503C\7684\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109405734015313679)
,p_name=>'F4000.P4719.INLINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B 5: \67E5\8A62\5305\542B\5167\5D4C\67E5\8A62, \5FC5\9808\78BA\5B9A SQL \6558\8FF0\53E5\4E2D\7684\7B2C\4E00\500B FROM \5B50\53E5\4E0D\662F\5167\5D4C\67E5\8A62\7684\4E00\90E8\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109312887809313609)
,p_name=>'F4000.P4719.SQL_QUERY_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B 1: \4EE5 SQL \67E5\8A62\70BA\57FA\790E\7684\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109313172672313609)
,p_name=>'F4000.P4719.STATIC_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B 3: \975C\614B\6E05\55AE\7BC4\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109313033809313609)
,p_name=>'F4000.P4719.USE_ALIAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\540C\4E00\8CC7\6599\6B04\7528\65BC\986F\793A\503C\548C\50B3\56DE\503C\6642, \8ACB\4F7F\7528\8CC7\6599\6B04\5225\540D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108983253268313353)
,p_name=>'F4000.P4719.YN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\300C\662F\300D/\300C\5426\300D, \50B3\56DE Y \548C N')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109318643429313614)
,p_name=>'F4000.P4728.AFTER_PROCESSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109318399316313613)
,p_name=>'F4000.P4728.BEFORE_COMPUTATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109318513637313614)
,p_name=>'F4000.P4728.BEFORE_PROCESSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109318438427313613)
,p_name=>'F4000.P4728.BEFORE_VALIDATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108989696690313358)
,p_name=>'F4000.P4731.ADD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109318763097313614)
,p_name=>'F4000.P4731.APPLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108986535543313355)
,p_name=>'F4000.P4731.DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109318998261313614)
,p_name=>'F4000.P4731.FINISH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109318816105313614)
,p_name=>'F4000.P4731.SUBMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109319187550313614)
,p_name=>'F4000.P4735_RP_ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\6B64\7A0B\5E8F\6642, \5C07\6703\91CD\8A2D\6B64\61C9\7528\7A0B\5F0F\4E2D\4E4B\6240\6709\9801\9762\7684\5206\9801.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109331213266313623)
,p_name=>'F4000.P4738.REGEXP_WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A: \60A8\9078\64C7\9A57\8B49\300C\6B63\898F\8868\793A\5F0F\300D\985E\578B, \4F46\662F\60A8\7684\8CC7\6599\5EAB\7248\672C\4E0D\652F\63F4\6B64\985E\9A57\8B49.  \9019\9805\9A57\8B49\4E00\5F8B\6703\50B3\56DE true.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110068153601314191)
,p_name=>'F4000.P4761.TRANSLATIONS_NOT_USED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\672A\555F\7528\6B64\61C9\7528\7A0B\5F0F\7684\7FFB\8B6F. \8ACB\53C3\95B1<a href="%0">\5168\7403\5316\5C6C\6027</a>\4E2D\7684<em>\61C9\7528\7A0B\5F0F\8A9E\8A00\884D\751F\7684\4F86\6E90</em>\8A2D\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110130348054314256)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_IDLE_SEC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\8A2D\5B9A\300C\968E\6BB5\4F5C\696D\9592\7F6E\6642\9593\4E0A\9650\300D\6642, \5C07\6703\4F7F\7528\5DE5\4F5C\5340\5C64\7D1A\6216\57F7\884C\8655\7406\5C64\7D1A\503C (\76EE\524D\70BA %0 \79D2).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110130423061314256)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_LENGTH_SEC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\8A2D\5B9A\300C\968E\6BB5\4F5C\696D\9577\5EA6\4E0A\9650\300D\6642, \5C07\6703\4F7F\7528\5DE5\4F5C\5340\5C64\7D1A\6216\57F7\884C\8655\7406\5C64\7D1A\503C (\76EE\524D\70BA %0 \79D2).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110120847598314249)
,p_name=>'F4000.P593.NEW_BRANCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109431950018313699)
,p_name=>'F4000.P598.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\4E9B\5143\4EF6\662F\5F9E\4E0D\540C\7684\61C9\7528\7A0B\5F0F\6216\5F9E\4E0D\540C\5DE5\4F5C\5340\4E2D\7684\61C9\7528\7A0B\5F0F\532F\51FA. \7121\6CD5\5728\6B64\61C9\7528\7A0B\5F0F\4E2D\5B89\88DD\9019\4E9B\5143\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109435908998313702)
,p_name=>'F4000.P612.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\4E9B\6A94\6848\662F\5F9E\4E0D\540C\7684\5DE5\4F5C\5340\532F\51FA\7684. \7121\6CD5\5728\6B64\5DE5\4F5C\5340\4E2D\5B89\88DD\9019\4E9B\6A94\6848.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110120995150314249)
,p_name=>'F4000.P622.TO_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\6A19\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110121717292314250)
,p_name=>'F4000.P623.COPY_OPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\9078\9805: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110121858493314250)
,p_name=>'F4000.P623.EXISTING_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\73FE\6709\503C\6E05\55AE: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109372809665313654)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\662F\5F9E\4E0D\540C\7684\61C9\7528\7A0B\5F0F\6216\5F9E\4E0D\540C\5DE5\4F5C\5340\7684\61C9\7528\7A0B\5F0F\532F\51FA. \7121\6CD5\5728\6B64\61C9\7528\7A0B\5F0F\4E2D\5B89\88DD\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109274218138313575)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\5F9E\5176\4ED6\5DE5\4F5C\5340\4E2D\7684\61C9\7528\7A0B\5F0F\532F\51FA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109274151990313575)
,p_name=>'F4000.P67.EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\5F9E\76EE\524D\5DE5\4F5C\5340\4E2D\7684\61C9\7528\7A0B\5F0F\532F\51FA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109693182022313915)
,p_name=>'F4000.P67.PAGE_LOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\76EE\524D\88AB\9396\5B9A.  \60A8\7121\6CD5\5728\9396\5B9A\7684\9801\9762\9032\884C\532F\5165.  \8ACB\89E3\9664\9396\5B9A\9801\9762, \7136\5F8C\518D\5B89\88DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110119444306314248)
,p_name=>'F4000.P712.CLEAR_PARENT_ENTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664\7236\9805\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110121295843314249)
,p_name=>'F4000.P765.SELECT_PARAM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\53C3\6578 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109093112282313440)
,p_name=>'F4000.P818.VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81F3\5C11\5FC5\9808\9078\53D6\4E00\500B\8981\8907\88FD\7684\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110121420766314249)
,p_name=>'F4000.P875.HTTP_HEADER_VAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP \6A19\982D %0 \7684\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110121325154314249)
,p_name=>'F4000.P875.INPUT_PARAM_VAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53C3\6578 %0 \7684\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110121688860314250)
,p_name=>'F4000.P876.DELETE_HEADER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\6A19\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110121521791314249)
,p_name=>'F4000.P876.DELETE_PARAM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\53C3\6578: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109320929391313615)
,p_name=>'F4000.P904.REQUIRED_STYLE_SHEET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8981\6709\6A23\5F0F\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109290055631313592)
,p_name=>'F4000.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109304680847313603)
,p_name=>'F4000.PAGE_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109276107489313581)
,p_name=>'F4000.PAGE_COMPUTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109030904239313394)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\52D5\614B\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108891944227313281)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION_ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\52D5\614B\52D5\4F5C - \52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109274878141313581)
,p_name=>'F4000.PAGE_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108894175064313282)
,p_name=>'F4000.PAGE_ITEM_GROUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109309029421313606)
,p_name=>'F4000.PAGE_MAYBE_PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109290198816313592)
,p_name=>'F4000.PAGE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109276291170313582)
,p_name=>'F4000.PAGE_PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109304567919313603)
,p_name=>'F4000.PAGE_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109304786588313603)
,p_name=>'F4000.PAGE_VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9A57\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109277076379313582)
,p_name=>'F4000.PARENT_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109291090295313593)
,p_name=>'F4000.POPUP_LOV_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5373\73FE\5F0F\503C\6E05\55AE\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109908292894314077)
,p_name=>'F4000.PRINT_CREDENTIALS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9060\7AEF\5217\5370\4F3A\670D\5668\8B49\660E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109291665943313593)
,p_name=>'F4000.PUBLISH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\5E03')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109275692212313581)
,p_name=>'F4000.REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109904703556314075)
,p_name=>'F4000.REGION_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109290279202313592)
,p_name=>'F4000.RELATED_PAGES_AND_COMPONENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\95DC\9801\9762\548C\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109908447812314078)
,p_name=>'F4000.REMOTE_DATABASE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528 REST \7684 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109405575133313679)
,p_name=>'F4000.REPORT_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108921222337313303)
,p_name=>'F4000.REST_ENABLED_SQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528 REST \7684 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109291584455313593)
,p_name=>'F4000.SEED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109276977669313582)
,p_name=>'F4000.STANDARD_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\6E96\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109304169740313603)
,p_name=>'F4000.STATIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109290817983313593)
,p_name=>'F4000.TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109291129352313593)
,p_name=>'F4000.TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109134926700313472)
,p_name=>'F4000.TEMPLATE_NAME_ALREADY_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F\540D\7A31 %0 \5DF2\7D93\5B58\5728. \8ACB\8F38\5165\65B0\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109093288326313440)
,p_name=>'F4000.TEMPLATE_NAME_MAND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\6A23\677F\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109291372082313593)
,p_name=>'F4000.THEME_IMPORT_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\5728\61C9\7528\7A0B\5F0F %0 \4E2D\5EFA\7ACB\65B0\4E3B\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109291470254313593)
,p_name=>'F4000.THEME_IMPORT_REPLACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\53D6\4EE3\61C9\7528\7A0B\5F0F %0 \4E2D\73FE\6709\7684\4E3B\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109290493305313592)
,p_name=>'F4000.TO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109277592291313583)
,p_name=>'F4000.UNKNOWN_APPLICATION_ELEMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\660E\7684\61C9\7528\7A0B\5F0F\5143\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109291748942313593)
,p_name=>'F4000.UPDATEABLE_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\66F4\65B0\7684\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109416920233313688)
,p_name=>'F4000.UTILITIES.INFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\7528\7A0B\5F0F\5305\62EC\6240\9078\61C9\7528\7A0B\5F0F\5167\6240\6709\9801\9762\7684\300C\65B9\683C\7DE8\8F2F\300D\9801\9762\548C\300C\5831\8868\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109276301094313582)
,p_name=>'F4000.VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108921327983313303)
,p_name=>'F4000.WEB_SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \8CC7\6599\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109908511663314078)
,p_name=>'F4000.WEB_SRC_MODULE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \8CC7\6599\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109274525880313576)
,p_name=>'F4000.YES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109350694363313637)
,p_name=>'F4000_4738_DATE_MMDDYYY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F MMDDYYY')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109504344720313754)
,p_name=>'F4000_APPLICATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109056478907313413)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\8868\683C\4E2D\7684\4E00\500B\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109309475629313607)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\70BA\8CC7\6599\5EAB\8868\683C\4E2D\7684\4E00\500B\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109321036817313615)
,p_name=>'F4000_BUTTON_POS_NOT_IN_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\6309\9215\4F4D\7F6E\4E0D\5728\60A8\7684\5340\57DF\6A23\677F\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110057024330314183)
,p_name=>'F4000_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109321357535313616)
,p_name=>'F4000_CLOSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109337985249313628)
,p_name=>'F4000_COPY_AND_SUBSCRIBE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\4E26\8A02\95B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109321609198313616)
,p_name=>'F4000_DATE_NOT_REC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8FA8\8B58\65E5\671F\683C\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108989334533313358)
,p_name=>'F4000_F1500_LOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9396\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109420771872313691)
,p_name=>'F4000_HELP_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109503486514313753)
,p_name=>'F4000_LOV_NAME_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\503C\6E05\55AE\300D\540D\7A31 %0 \5DF2\7D93\5B58\5728. \8ACB\8F38\5165\65B0\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109344573936313633)
,p_name=>'F4000_NONE_SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9078\53D6\4EFB\4F55\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109300805873313600)
,p_name=>'F4000_NO_APP_ASSOC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\76F8\95DC\7684\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108932614528313312)
,p_name=>'F4000_OFF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108932526636313312)
,p_name=>'F4000_ON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\555F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108992901882313365)
,p_name=>'F4000_P122_CAL_TEMPL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\7167\6B64\6A23\677F\7684\884C\4E8B\66C6\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109373756189313655)
,p_name=>'F4000_P128.VIEW_PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\6B64\985E\578B\7684\9801\9762')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109102241480313447)
,p_name=>'F4000_P173_NO_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9805\76EE\6C92\6709\8AAA\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109094287684313441)
,p_name=>'F4000_P1_AUTHENTICATION_HOME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109094169212313441)
,p_name=>'F4000_P1_EDIT_THIS_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\6B64\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109109710440313453)
,p_name=>'F4000_P232_RESET_CSS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D CSS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109715251081313934)
,p_name=>'F4000_P295_PAGE_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5DF2\5728\6B64\61C9\7528\7A0B\5F0F\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108989736812313358)
,p_name=>'F4000_P295_PAGE_MUST_BE_NUMERIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5FC5\9808\662F\6578\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108989858549313358)
,p_name=>'F4000_P295_PAGE_MUST_BE_POSITIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5FC5\9808\662F\6B63\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108989986588313358)
,p_name=>'F4000_P295_PAGE_MUST_BE_WHOLE_NUMBER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5FC5\9808\662F\6574\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109422088805313691)
,p_name=>'F4000_P3005.IMPORT_AUTHORIZATION SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\5165\6388\6B0A\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109371570885313653)
,p_name=>'F4000_P3005.IMPORT_AUTH_SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\5165\8A8D\8B49\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109422112458313692)
,p_name=>'F4000_P3005.IMPORT_NAVBAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\5165\5C0E\89BD\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109371627283313653)
,p_name=>'F4000_P3005.IMPORT_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\5165\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109319504049313614)
,p_name=>'F4000_P33_REGION_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\8868\5316\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109350333558313637)
,p_name=>'F4000_P3890_AUTHENTICATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8A8D\8B49!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109350472019313637)
,p_name=>'F4000_P3890_AUTH_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\5931\6557!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109342231309313631)
,p_name=>'F4000_P395_NO_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109322894375313617)
,p_name=>'F4000_P4001_UNAVAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7121\6CD5\4F7F\7528\6B64\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109071779409313424)
,p_name=>'F4000_P430_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109071841458313424)
,p_name=>'F4000_P430_DATE2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F, \5F48\6027: %0 \8207\4EFB\4F55\5340\9694\7B26\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109072576418313425)
,p_name=>'F4000_P430_DATE2_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8FA8\8B58\65E5\671F\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109072435049313425)
,p_name=>'F4000_P430_DATE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F\7684\683C\5F0F\5FC5\9808\662F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109071222409313424)
,p_name=>'F4000_P430_IP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('IP \4F4D\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109072089335313424)
,p_name=>'F4000_P430_IP_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('IP \4F4D\5740\7121\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109071343882313424)
,p_name=>'F4000_P430_PHONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\8A71\865F\78BC, \7F8E\570B: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109071492141313424)
,p_name=>'F4000_P430_PHONE2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\8A71\865F\78BC, \7F8E\570B\4E0D\56FA\5B9A: 999.999.9999, (999)-999-9999, 999 999 9999 \7B49...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109072290403313425)
,p_name=>'F4000_P430_PHONE2_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8FA8\8B58\96FB\8A71\865F\78BC\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109072162315313424)
,p_name=>'F4000_P430_PHONE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\8A71\865F\78BC\7684\683C\5F0F\5FC5\9808\662F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109071135203313424)
,p_name=>'F4000_P430_URL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('URL: http(s)://domain/path/doc.(pdf)(html)(\7B49\7B49...)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109071997471313424)
,p_name=>'F4000_P430_URL_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109071522491313424)
,p_name=>'F4000_P430_ZIP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\90F5\905E\5340\865F: 99999')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109071615874313424)
,p_name=>'F4000_P430_ZIP2'
,p_message_language=>'zh-tw'
,p_message_text=>'ZIP + 4: 99999-9999'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109072347361313425)
,p_name=>'F4000_P430_ZIP_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\90F5\905E\5340\865F\7684\683C\5F0F\5FC5\9808\662F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109002611375313373)
,p_name=>'F4000_P4495.COPIED_FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\61C9\7528\7A0B\5F0F\8907\88FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109002730638313373)
,p_name=>'F4000_P4495.MASTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\662F\6B64\8A8D\8B49\914D\7F6E\7684\4E3B\672C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109002927493313373)
,p_name=>'F4000_P4495.NO_SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8A8D\8B49\914D\7F6E\6C92\6709\8A02\6236.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109002895165313373)
,p_name=>'F4000_P4495.REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1\6B64\8A8D\8B49\914D\7F6E\7684\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109057667432313414)
,p_name=>'F4000_P4495_LOV_NO_SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \6C92\6709\914D\7F6E -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109318155613313613)
,p_name=>'F4000_P4701_PAGE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109322972550313617)
,p_name=>'F4000_P4705_FORM_ON_A_PROC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\5B58\7A0B\5E8F\76F8\95DC\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109318290806313613)
,p_name=>'F4000_P4710_PAGE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109322205315313616)
,p_name=>'F4000_P4717_DISPLAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109322106696313616)
,p_name=>'F4000_P4717_HIDDEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109321860386313616)
,p_name=>'F4000_P4734_CLEAR_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664\9805\76EE\5FEB\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109321764182313616)
,p_name=>'F4000_P4734_CLEAR_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664\9801\9762\5FEB\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109344850397313633)
,p_name=>'F4000_P4734_RESET_PAG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D\5206\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109322050991313616)
,p_name=>'F4000_P4734_SET_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528 PL/SQL \51FD\6578\4E3B\9AD4\4F86\8A2D\5B9A\300C\9805\76EE\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109321953866313616)
,p_name=>'F4000_P4734_STATIC_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\975C\614B\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109319083634313614)
,p_name=>'F4000_P4735_INITIALIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5FEB\53D6\5728\76EE\524D\61C9\7528\7A0B\5F0F\4E2D\7684\6240\6709\9801\9762\9805\76EE\5C07\6703\4EE5\7A7A\503C\8D77\59CB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109322626339313617)
,p_name=>'F4000_P4737_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109322323815313616)
,p_name=>'F4000_P4737_ITEM_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975E\7A7A\503C\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109322413633313616)
,p_name=>'F4000_P4737_ITEM_NOT_ZERO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\662F\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109322533467313617)
,p_name=>'F4000_P4737_PLSQL_EXP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109350835649313638)
,p_name=>'F4000_P4738_DATE_DDMMYYYY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F DDMMYYYY')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109350738552313638)
,p_name=>'F4000_P4738_PHONE_NUM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\8A71\865F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110089139362314206)
,p_name=>'F4000_P473_DATABASE_OBJECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109319295000313614)
,p_name=>'F4000_P4759_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\700F\89BD\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109319354963313614)
,p_name=>'F4000_P4785_REGION_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\4E8B\66C6 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109057857260313414)
,p_name=>'F4000_P4790_DATE_TIMESTAMP_NOTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\5305\542B\300C\65E5\671F\300D\6216\300C\6642\6233\300D\8CC7\6599\6B04)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109537609246313779)
,p_name=>'F4000_P4790_SYNTAX_HEADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\6CD5: select id, name, date from ...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109537930428313779)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528 ROWID \865B\64EC\8CC7\6599\6B04\7684\7BC4\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109538048840313779)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\4F86\6E90\8868\683C\300C\4E3B\7D22\5F15\9375\300D\7684\7BC4\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109537747423313779)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('1. \60A8\81F3\5C11\5FC5\9808\5305\542B\5169\500B\8CC7\6599\6B04, \4E14\5176\4E2D\4E00\500B\5FC5\9808\662F DATE \8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109537843739313779)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('2. \7B2C\4E00\500B\8CC7\6599\6B04\5FC5\9808\662F\7528\65BC\7BA1\7406\8CC7\6599\64CD\63A7\8A9E\8A00 (DML) \4F5C\696D\7684\4E3B\7D22\5F15\9375\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109319430996313614)
,p_name=>'F4000_P4810_PAGE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109432549765313700)
,p_name=>'F4000_P48_MANIFEST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6\532F\51FA\8CC7\8A0A\6E05\55AE    ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109373650086313655)
,p_name=>'F4000_P497.VIEW_PAGE_DEF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\9801\9762\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109319683152313614)
,p_name=>'F4000_P5100_PAGE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6458\8981\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109338225749313628)
,p_name=>'F4000_P52_TAB_LINK_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E00\4E0B\4F86\8A2D\5B9A\9801\7C64\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109592344040313823)
,p_name=>'F4000_P643_NO_PARENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A23\677F\652F\63F4\5169\5C64\9801\7C64, \4F46\6A19\6E96\9801\7C64\4E26\672A\6307\5B9A\7236\9805\9801\7C64\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109592247240313823)
,p_name=>'F4000_P643_NO_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\4EFB\4F55\9801\7C64, \6B64\9801\9762\5C07\4E0D\6703\986F\793A\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109592012866313823)
,p_name=>'F4000_P643_ONE_LVL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\5C07\986F\793A\4E00\5C64\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109592479207313823)
,p_name=>'F4000_P643_PAGE_NO_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\542B\9801\7C64\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109592595003313823)
,p_name=>'F4000_P643_PAGE_NO_TAB_TTL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\5171\6709 %0 \500B\9801\9762\672A\5B9A\7FA9\9801\7C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109591916646313823)
,p_name=>'F4000_P643_TAB_DISPLAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109592113190313823)
,p_name=>'F4000_P643_TWO_LVL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\5C07\986F\793A\5169\5C64\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110039851024314171)
,p_name=>'F4000_P78_UPGRADE_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>Oracle APEX %0 \5DF2\53EF\4F7F\7528.</strong> \60A8\7684\57F7\884C\8655\7406\5C07\65BC <strong>%1</strong> \81EA\52D5\5347\7D1A. \60A8\7684\57F7\884C\8655\7406\7BA1\7406\54E1\53EF\4EE5\5728\6B64\65E5\671F\4E4B\524D, \96A8\6642\65BC\300C\7BA1\7406\670D\52D9\300D\8D77\59CB\672C\6B21\5347\7D1A.</p>'),
unistr('<p>\8ACB\53C3\95B1<a href="%2" target="_blank" rel="noreferrer">\516C\544A</a>, \4EE5\77AD\89E3 Oracle APEX %0 \7684\65B0\529F\80FD\548C\589E\5F37\529F\80FD.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110039717617314171)
,p_name=>'F4000_P78_UPGRADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<strong>\60A8\7684 %0 \57F7\884C\8655\7406\6B63\5728\5347\7D1A\70BA\66F4\65B0\7248\6B21.</strong> \5347\7D1A\671F\9593, \60A8\7684\61C9\7528\7A0B\5F0F\5C07\6709\4E00\6BB5\6642\9593\7121\6CD5\8B8A\66F4. \61C9\7528\7A0B\5F0F\548C %0 \958B\767C\74B0\5883\7684\5B58\53D6\5C07\88AB\4E2D\65B7\5927\7D04 %1 \5206\9418.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109001587750313372)
,p_name=>'F4000_P801_ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109002467753313373)
,p_name=>'F4000_P801_ACTIVATE1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B93\6B64\914D\7F6E\8B8A\6210\76EE\524D\7684\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109002559773313373)
,p_name=>'F4000_P801_ACTIVATE2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\6210\76EE\524D\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109057458810313414)
,p_name=>'F4000_P801_CURRENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109002278477313373)
,p_name=>'F4000_P801_DEACTIVATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\72C0\614B\8B8A\66F4\6210\975E\4F5C\7528\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109001043293313372)
,p_name=>'F4000_P801_DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A73\7D30\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109001180794313372)
,p_name=>'F4000_P801_DETAILS_BI1'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5167\5EFA\968E\6BB5\4F5C\696D\7BA1\7406\908F\8F2F --  \5167\5EFA\767B\5165\9801\9762\4EE5\53CA\5C07\4F7F\7528\8005\8207\5167\90E8\300Ccookie \4F7F\7528\8005\300D\5E33\6236\5132\5B58\5340\57DF\9032\884C\8A8D\8B49.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109001203882313372)
,p_name=>'F4000_P801_DETAILS_OBS1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\65B9\6CD5\5DF2\7D93\88AB SCHEME \8A8D\8B49\53D6\4EE3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109055487943313412)
,p_name=>'F4000_P801_EDIT_DEPRECATED1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\5DF2\88AB\53D6\4EE3\7684\8A8D\8B49\5C6C\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109055506894313412)
,p_name=>'F4000_P801_EDIT_DEPRECATED2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\88AB\53D6\4EE3\7684\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109055633772313412)
,p_name=>'F4000_P801_EDIT_DEPRECATED3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6216\7DAD\6301\4E0D\8B8A, \76F4\5230\60A8\6E96\5099\5C07\8A8D\8B49\65B9\6CD5\8B8A\66F4\6210 %0 \70BA\6B62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109055981720313413)
,p_name=>'F4000_P801_EDIT_DEPRECATED4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\6216\591A\500B\5DF2\88AB\53D6\4EE3\7684\8A8D\8B49\5C6C\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109056123677313413)
,p_name=>'F4000_P801_EDIT_DEPRECATED5'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6216\5C07\5B83\5011\79FB\8F49\81F3\8A8D\8B49\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109055152387313412)
,p_name=>'F4000_P801_FLOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109002180299313372)
,p_name=>'F4000_P801_MANAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\4EE5\4E0A\7684\5831\8868\4F86\7BA1\7406\8A8D\8B49\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109000927169313372)
,p_name=>'F4000_P801_METHOD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109057376769313414)
,p_name=>'F4000_P801_NO_EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\7121\6CD5\7DE8\8F2F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109002382675313373)
,p_name=>'F4000_P801_PAREN_CURRENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\76EE\524D\4F5C\7528\4E2D)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109055209866313412)
,p_name=>'F4000_P801_PAREN_DEPRECATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\5DF2\88AB\53D6\4EE3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109002086597313372)
,p_name=>'F4000_P801_PAREN_NONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\7121)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109001422326313372)
,p_name=>'F4000_P801_PUBLIC_PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\7528\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109001695459313372)
,p_name=>'F4000_P801_REVIEW1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6AA2\8996\6216\7DE8\8F2F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109001705312313372)
,p_name=>'F4000_P801_REVIEW2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6216\5728\6D41\7A0B\5C6C\6027\9801\9762\7DE8\8F2F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109001805377313372)
,p_name=>'F4000_P801_REVIEW3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\6D41\7A0B\7684\968E\6BB5\4F5C\696D\7BA1\7406\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109001953416313372)
,p_name=>'F4000_P801_REVIEW4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\5C6C\6027\9801\9762\4E2D\7684\9019\500B\61C9\7528\7A0B\5F0F, \6216\8005\4F7F\7528\4EE5\4E0A\7684\5831\8868\4F86\5EFA\7ACB\53CA\7BA1\7406\7576\60A8\5C07\8A8D\8B49\65B9\6CD5\8B8A\66F4\6210 %0 \6642, \6240\80FD\4F7F\7528\7684\8A8D\8B49\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109055708651313412)
,p_name=>'F4000_P801_REVIEW5'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6AA2\8996\6216\7DE8\8F2F\968E\6BB5\4F5C\696D\7BA1\7406\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109056092471313413)
,p_name=>'F4000_P801_REVIEW6'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6AA2\8996\6216\7DE8\8F2F\9019\4E9B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109055302875313412)
,p_name=>'F4000_P801_SCHEME_CONVERT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \8A8D\8B49\662F\88AB\53D6\4EE3\7684\65B9\6CD5. \6211\5011\5EFA\8B70\60A8\6309\4E00\4E0B\6B64\61C9\7528\7A0B\5F0F\4E4B\5176\4E2D\4E00\500B\8A8D\8B49\914D\7F6E\7684\300C\8B8A\6210\76EE\524D\7684\300D \9023\7D50 (\5982\4E0A\6240\793A), \6216\8005\5EFA\7ACB\65B0\7684\8A8D\8B49\914D\7F6E, \7136\5F8C\5C07\5B83\8B8A\6210\76EE\524D\7684\8A8D\8B49\914D\7F6E. INTERNAL-SETUP \8A8D\8B49\914D\7F6E\7684\529F\80FD\76F8\7576\65BC %0 \65B9\6CD5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109055836572313413)
,p_name=>'F4000_P801_SCHEME_DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\4F7F\7528\8A8D\8B49\914D\7F6E\4F86\63A7\5236\4F7F\7528\8005\8A8D\8B49\4EE5\53CA\60A8\61C9\7528\7A0B\5F0F\4E4B\968E\6BB5\4F5C\696D\7BA1\7406\7684\6240\6709\5176\4ED6\65B9\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109319975577313615)
,p_name=>'F4000_P805_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5728\4E0A\4E00\500B\6B65\9A5F\4E2D\6307\5B9A\9801\9762\611F\6E2C\51FD\6578. \6B64\51FD\6578\5C07\6703\8CA0\8CAC\6BCF\500B\9801\9762\7684\968E\6BB5\4F5C\696D\9A57\8B49, \56E0\6B64\4E0D\9700\5728\6B64\8655\8F38\5165\968E\6BB5\4F5C\696D\9A57\8B49\51FD\6578. \5982\679C\9019\4E0D\662F\60A8\60F3\8981\7684, \60A8\53EF\4EE5\56DE\5230\7CBE\9748\7684\5148\524D\6B65\9A5F\4F86\4F5C\8B8A\66F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109058468240313414)
,p_name=>'F4000_P806_BUILTIN_LOGIN_PG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5EFA\7684\767B\5165\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109058826887313415)
,p_name=>'F4000_P806_NONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109058543138313414)
,p_name=>'F4000_P806_PAGE_IN_THIS_FLOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\61C9\7528\7A0B\5F0F\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109058763789313415)
,p_name=>'F4000_P806_SSO_SERVER'
,p_message_language=>'zh-tw'
,p_message_text=>'Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109058671239313415)
,p_name=>'F4000_P806_URL'
,p_message_language=>'zh-tw'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109058932627313415)
,p_name=>'F4000_P808_AUTH_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528 %0 \5E33\6236\4F7F\7528\8005\540D\7A31\548C\5BC6\78BC\4F86\8A8D\8B49.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108944792823313322)
,p_name=>'F4000_P808_DBAUTH_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8CC7\6599\5EAB\5E33\6236\4F7F\7528\8005\540D\7A31\548C\5BC6\78BC\4F86\8A8D\8B49.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109059014266313415)
,p_name=>'F4000_P808_NO_VERIFY_CRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\8981\9A57\8B49\8B49\660E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109059248497313415)
,p_name=>'F4000_P808_USE_CUSTOM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\6211\7684\81EA\8A02\51FD\6578\4F86\8A8D\8B49.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109059149802313415)
,p_name=>'F4000_P808_USE_LDAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528 LDAP \4F3A\670D\5668\4F86\8A8D\8B49.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109323060844313617)
,p_name=>'F4000_P80_NO_PAGE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \6C92\6709\9801\9762\540D\7A31 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109003672194313374)
,p_name=>'F4000_P811_AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109004431188313374)
,p_name=>'F4000_P811_C_DOMAIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Cookie \7DB2\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109004262591313374)
,p_name=>'F4000_P811_C_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Cookie \540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109004356260313374)
,p_name=>'F4000_P811_C_PATH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Cookie \8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108941870972313319)
,p_name=>'F4000_P811_C_SECURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\5168')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109003471902313373)
,p_name=>'F4000_P811_INV_SESS_TGT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\968E\6BB5\4F5C\696D\76EE\6A19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109003978031313374)
,p_name=>'F4000_P811_LDAP_DN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('LDAP \641C\5C0B\57FA\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109004003504313374)
,p_name=>'F4000_P811_LDAP_EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F LDAP \4F7F\7528\8005\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109003797114313374)
,p_name=>'F4000_P811_LDAP_HOST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('LDAP \4E3B\6A5F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109003875886313374)
,p_name=>'F4000_P811_LDAP_PORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('LDAP \9023\63A5\57E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109004533889313374)
,p_name=>'F4000_P811_LOGOUT_URL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\51FA URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109003120119313373)
,p_name=>'F4000_P811_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109003057001313373)
,p_name=>'F4000_P811_PAREN_BUILTIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\5167\5EFA)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109004669213313374)
,p_name=>'F4000_P811_PAREN_DBAUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\8CC7\6599\5EAB\8A8D\8B49)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109003260903313373)
,p_name=>'F4000_P811_PG_SENTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\611F\6E2C\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109004104872313374)
,p_name=>'F4000_P811_POST_AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\5F8C\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109003562709313374)
,p_name=>'F4000_P811_PRE_AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\524D\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109003377473313373)
,p_name=>'F4000_P811_SESS_VERIFY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D\9A57\8B49\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109059463742313415)
,p_name=>'F4000_P815_COPY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\70BA\73FE\6709\8A8D\8B49\914D\7F6E\7684\8907\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109059533721313415)
,p_name=>'F4000_P815_GALLERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\914D\7F6E\5EAB\7684\9810\5148\8A2D\5B9A\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109059313640313415)
,p_name=>'F4000_P815_SCRATCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\914D\7F6E\5EAB\7684\9810\5148\8A2D\5B9A\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109017224550313384)
,p_name=>'F4000_P817_REFRESH_AUTH_SCHEME_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6574\7406\8A8D\8B49\914D\7F6E\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109004803993313375)
,p_name=>'F4000_P819_AUTH_METHOD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109072672363313425)
,p_name=>'F4000_P819_CURR_WARN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A: \60A8\5373\5C07\522A\9664\6B64\61C9\7528\7A0B\5F0F\7684\76EE\524D\8A8D\8B49\914D\7F6E!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109005098721313375)
,p_name=>'F4000_P819_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109004761973313374)
,p_name=>'F4000_P819_FLOW_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109004908653313375)
,p_name=>'F4000_P819_SCHEME_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\914D\7F6E\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109060098029313416)
,p_name=>'F4000_P820_MY_PARTNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle Application Server Single Sign-On (\6211\7684\61C9\7528\7A0B\5F0F\70BA\5925\4F34\61C9\7528\7A0B\5F0F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109059696947313415)
,p_name=>'F4000_P820_SHOW_ACCOUNT_CRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\767B\5165\9801\9762\548C\4F7F\7528 %0 \5E33\6236\8B49\660E\8CC7\6599')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109059758672313415)
,p_name=>'F4000_P820_SHOW_BUILTIN_PG_OPEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\300C\5167\5EFA\7684\767B\5165\9801\9762\300D\548C\300C\4F7F\7528 Open Door \8B49\660E\8CC7\6599\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109059861561313415)
,p_name=>'F4000_P820_SHOW_USE_LDAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\767B\5165\9801\9762\548C\4F7F\7528 LDAP \76EE\9304\8B49\660E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109059926850313416)
,p_name=>'F4000_P820_SSO_HTMLDB_PARTNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle Application Server Single Sign-On (%0 \5F15\64CE\70BA\5925\4F34\61C9\7528\7A0B\5F0F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109005381834313375)
,p_name=>'F4000_P822_CURR_METHOD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8A8D\8B49\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109017372847313384)
,p_name=>'F4000_P826_CREATE1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\55AE\4E00\767B\5165 (\50C5\4F9B Oracle \4F7F\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109017498563313384)
,p_name=>'F4000_P826_CREATE2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle Application Server Single Sign-On (%0 \70BA\5925\4F34\61C9\7528\7A0B\5F0F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109017541284313384)
,p_name=>'F4000_P826_CREATE3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle Application Server Single Sign-On (\6211\7684\61C9\7528\7A0B\5F0F\70BA\5925\4F34\61C9\7528\7A0B\5F0F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109017687610313384)
,p_name=>'F4000_P826_CREATE4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5EFA\767B\5165\9801\9762: \4F7F\7528 %0 \5E33\6236\8B49\660E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109040185409313401)
,p_name=>'F4000_P826_CREATE4A'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA\7684\767B\5165\9801\9762: \4F7F\7528 %0 \5E33\6236\8B49\660E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109040224293313401)
,p_name=>'F4000_P826_CREATE4B'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\73FE\6709\7684\767B\5165\9801\9762: \4F7F\7528 %0 \5E33\6236\8B49\660E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109017716790313384)
,p_name=>'F4000_P826_CREATE5'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5EFA\767B\5165\9801\9762: Open Door \8B49\660E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109017813523313384)
,p_name=>'F4000_P826_CREATE6'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5EFA\767B\5165\9801\9762: \4F7F\7528 LDAP \76EE\9304\8B49\660E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109039965355313401)
,p_name=>'F4000_P826_CREATE6A'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA\7684\767B\5165\9801\9762: \4F7F\7528 LDAP \76EE\9304\8B49\660E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109040016919313401)
,p_name=>'F4000_P826_CREATE6B'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\73FE\6709\7684\767B\5165\9801\9762: \4F7F\7528 LDAP \76EE\9304\8B49\660E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109017940980313384)
,p_name=>'F4000_P826_CREATE7'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\8A8D\8B49\914D\7F6E\5EAB\7684\8A8D\8B49\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109060125353313416)
,p_name=>'F4000_P826_NEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109096841740313443)
,p_name=>'F4000_P88_FLASHBACK_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \7684\9084\539F\529F\80FD\4F7F\7528\7A31\70BA\300C\5012\6EAF\67E5\8A62\300D\7684\5167\5EFA\8CC7\6599\5EAB\529F\80FD, \8B93\60A8\80FD\5920\67E5\8A62\5728\7279\5B9A\6642\9593\5EFA\7ACB\7684\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109096641907313443)
,p_name=>'F4000_P88_SELECT_TIME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\8FD4\56DE\7684\6642\9593, \7136\5F8C\6309\4E00\4E0B\300C\5957\7528\300D, \5373\53EF\5C07\4F86\6E90\5BEB\56DE\5340\57DF\7DE8\8F2F\9801\9762\4E26\95DC\9589\6B64\5C0D\8A71\65B9\584A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109097068572313443)
,p_name=>'F4000_P88_UNDO_RETENTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\8CC7\6599\5EAB\53C3\6578 "UNDO_RETENTION", \60A8\53EA\80FD\9084\539F\524D %0 \500B\5C0F\6642\5167\6240\767C\751F\7684\8B8A\66F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109097545089313443)
,p_name=>'F4000_P92_CONFIRM_CREATE_STD_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78BA\8A8D\5728\61C9\7528\7A0B\5F0F\4E2D\5EFA\7ACB\6A19\6E96\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109097965139313444)
,p_name=>'F4000_P92_NEW_TABSET_WILL_BE_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\5EFA\7ACB\65B0\7684\9801\7C64\96C6 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109097831878313444)
,p_name=>'F4000_P92_PAGE_WILL_USE_EXISTNG_TABSET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 %0 \5C07\6703\4F7F\7528\73FE\6709\7684\9801\7C64\96C6 "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109097623257313444)
,p_name=>'F4000_P92_TABSET_INFO_INCOMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A, \9801\7C64\96C6\8CC7\8A0A\4E0D\5B8C\6574.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109539319252313780)
,p_name=>'F4000_P975_VALUE_FOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \7684\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109321464966313616)
,p_name=>'F4000_PREV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\6B65')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109309767490313607)
,p_name=>'F4000_QUICK_APP_FINISH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E00\4E0B<strong>\5B8C\6210</strong>\4F86\5EFA\7ACB\6216\64F4\5145\60A8\7684\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109309551248313607)
,p_name=>'F4000_QUICK_APP_OPT_DISP1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\62EC\5C0E\89BD\8DEF\5F91\5C0E\89BD\5354\52A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109309602255313607)
,p_name=>'F4000_QUICK_APP_OPT_DISP2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5831\8868\9801\9762\4E2D\96B1\85CF\4E3B\7D22\5F15\9375')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109455269306313717)
,p_name=>'F4000_SHORTCUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6377\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109215854511313532)
,p_name=>'F4000_SVG_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SVG \5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109321129648313615)
,p_name=>'F4000_TOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9802\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109420892723313691)
,p_name=>'F4000_TREE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109536286606313778)
,p_name=>'F4000_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108973187579313345)
,p_name=>'F4000_WS_ENTIRE_RESPONSE_DOC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6574\4EFD\56DE\61C9\6587\4EF6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108983108856313353)
,p_name=>'F400_P107_STEP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B65\9A5F %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108953858316313330)
,p_name=>'F4050.ACCEPTED'
,p_message_language=>'zh-tw'
,p_message_text=>'DELETE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109537563872313779)
,p_name=>'F4050.ACCEPTED_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\63A5\53D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109407504749313681)
,p_name=>'F4050.ACTION_ASSIGN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6703\5C07\7DB1\8981\6307\5B9A\7D66\5DE5\4F5C\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109407643876313681)
,p_name=>'F4050.ACTION_NO_ASSIGN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\6703\5C07\7DB1\8981\6307\5B9A\7D66\5DE5\4F5C\5340, \539F\56E0\5982\4E0B:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109407127816313680)
,p_name=>'F4050.ADDITIONAL_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6\7DB1\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109302338855313601)
,p_name=>'F4050.ADJUST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ABF\6574')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109301640086313601)
,p_name=>'F4050.ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109537045056313778)
,p_name=>'F4050.APPROVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6838\51C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108957614273313332)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_DISPLAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7D93\6838\51C6\60A8\7684\5DE5\4F5C\5340\8981\6C42, \4E26\5DF2\5C07\8B49\660E\8CC7\6599\5BC4\81F3\8A3B\518A\671F\9593\60A8\63D0\4F9B\7684\96FB\5B50\90F5\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109375786022313657)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7D93\6838\51C6\60A8\5C0D\5E33\6236\7684\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109375645184313656)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6838\51C6: %0 \7684\5E33\6236\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109376196254313657)
,p_name=>'F4050.APPROVE_ADD_STORAGE_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6838\51C6\60A8\5C0D\5DE5\4F5C\5340 %1 \4E2D\984D\5916 %0 MB \5132\5B58\7684\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109536701839313778)
,p_name=>'F4050.ASSIGNED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6307\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110048081752314177)
,p_name=>'F4050.AUTOMATIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109536605907313778)
,p_name=>'F4050.AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110128235263314255)
,p_name=>'F4050.BROKEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\65B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110128673536314255)
,p_name=>'F4050.CHAIN_STALLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\93C8\7D50\64F1\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109376511736313657)
,p_name=>'F4050.CHANGE_APPROVED_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6838\51C6\8B8A\66F4\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109376678598313657)
,p_name=>'F4050.CHANGE_DENIED_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\62D2\7D55\8B8A\66F4\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110128199482314255)
,p_name=>'F4050.COMPLETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109407204026313680)
,p_name=>'F4050.CREATE_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\5EFA\7ACB\7DB1\8981.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109537117088313778)
,p_name=>'F4050.DECLINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\62D2\7D55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109376058959313657)
,p_name=>'F4050.DECLINED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\62D2\7D55: %0 \7684\5E33\6236\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109376422478313657)
,p_name=>'F4050.DENY_ADD_STORAGE_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\62D2\7D55\60A8\5C0D\5DE5\4F5C\5340 %1 \4E2D\984D\5916 %0 MB \5132\5B58\7684\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109376234499313657)
,p_name=>'F4050.DENY_NEW_SCHEMA_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\62D2\7D55\60A8\5C0D\5DE5\4F5C\5340 %1 \4E2D\8CC7\6599\5EAB\7DB1\8981 %0 \7684\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109376354620313657)
,p_name=>'F4050.DENY_REMOVE_SERVICE_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\62D2\7D55\60A8\5C0D\5DE5\4F5C\5340 %0 \7D42\6B62\670D\52D9\7684\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110127800358314254)
,p_name=>'F4050.DISABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108953738461313329)
,p_name=>'F4050.EMAIL_CLICK_ON_LINK'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8ACB\6309\4E00\4E0B\4E0B\65B9\7684\9023\7D50\4F86\5B8C\6210\6838\51C6\7A0B\5E8F. \5B8C\6210\4E4B\5F8C, \60A8\5C07\6703\5728\5F8C\7E8C\7684\96FB\5B50\90F5\4EF6\6536\5230\60A8\7684\5DE5\4F5C\5340\8B49\660E\8CC7\6599.'),
'',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109375995169313657)
,p_name=>'F4050.EMAIL_GETSTARTED'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8ACB\6309\4E00\4E0B\4E0B\65B9\7684\9023\7D50\4EE5\958B\59CB\9032\884C.'),
'',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110128337209314255)
,p_name=>'F4050.FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5931\6557')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108981452576313351)
,p_name=>'F4050.HTML_EMAIL_CLICK_ON_LINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\6309\4E00\4E0B<a href=''%0''>\9019\88E1</a>, \5B8C\6210\6838\51C6\8655\7406\4F5C\696D\4E26\63A5\6536\60A8\7684\8B49\660E\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109291938018313593)
,p_name=>'F4050.INFORMATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109303122871313602)
,p_name=>'F4050.INSTALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\88DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109537279757313778)
,p_name=>'F4050.IN_PROGRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\884C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109301941356313601)
,p_name=>'F4050.NO_ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109320065539313615)
,p_name=>'F4050.P23.USE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110131309318314257)
,p_name=>'F4050.P3.UPDATE_CHECK_DISABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\505C\7528\6574\500B\57F7\884C\8655\7406\7684\300C\66F4\65B0\6AA2\67E5\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109320109824313615)
,p_name=>'F4050.P39_OPEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\555F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109407003138313680)
,p_name=>'F4050.PRIMARY_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\7DB1\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109302229038313601)
,p_name=>'F4050.PROVISION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F48\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109375499746313656)
,p_name=>'F4050.PROV_CHANGE_REQ_APPROVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6838\51C6\8B8A\66F4\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109375338818313656)
,p_name=>'F4050.PROV_SCHEMA_REQ_APPROVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7D93\6838\51C6\60A8\5C0D\5DE5\4F5C\5340 %1 \4E2D\4E4B\8CC7\6599\5EAB\7DB1\8981 %0 \7684\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110128421389314255)
,p_name=>'F4050.REMOTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9060\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109537378602313778)
,p_name=>'F4050.REQUESTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109301459695313601)
,p_name=>'F4050.RESET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109375550829313656)
,p_name=>'F4050.RESTRICTED_ADMIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A: \8981\6C42\7684\7DB1\8981\662F Oracle \9810\8A2D\7DB1\8981\6216\56E0\70BA\7DB2\7AD9\7279\5B9A\539F\5247\800C\6709\6240\9650\5236. \4E0D\80FD\5C07\9650\5236\7684\7DB1\8981\6307\5B9A\7D66\5DE5\4F5C\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110127933019314255)
,p_name=>'F4050.RETRY SCHEDULED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A66\6392\5B9A\7684\5DE5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109407461718313681)
,p_name=>'F4050.REUSE_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\91CD\8907\4F7F\7528\73FE\6709\7684\7DB1\8981.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110128045865314255)
,p_name=>'F4050.RUNNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110127768912314254)
,p_name=>'F4050.SCHEDULED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6392\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109375175683313656)
,p_name=>'F4050.SCHEMA_ASSIGNED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A: \8981\6C42\7684\7DB1\8981\5DF2\7D93\6307\5B9A\7D66\4E00\6216\591A\500B\5DE5\4F5C\5340. \6838\51C6\6B64\8981\6C42\4E4B\524D, \8ACB\5148\78BA\5B9A\5B89\5168\6027\539F\5247\5141\8A31\8B93\591A\500B\5DE5\4F5C\5340\5B58\53D6\76F8\540C\7684\7DB1\8981.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109375056671313656)
,p_name=>'F4050.SCHEMA_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A: \8981\6C42\7684\7DB1\8981\5DF2\7D93\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109407715412313681)
,p_name=>'F4050.SCHEMA_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981\4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109407927745313681)
,p_name=>'F4050.SCHEMA_RESERVED_NO_WARN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981\662F\4FDD\7559\7684\7DB1\8981, \4E0D\80FD\6307\5B9A\7D66\5DE5\4F5C\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109375257007313656)
,p_name=>'F4050.SCHEMA_RESTRICTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A: \8981\6C42\7684\7DB1\8981\56E0\70BA\662F Oracle \9810\8A2D\7DB1\8981\6216\7531\65BC\7DB2\7AD9\7279\5B9A\539F\5247\800C\53D7\5230\9650\5236. \5982\679C\60A8\7E7C\7E8C\6307\5B9A\6B64\7DB1\8981\7D66\5DE5\4F5C\5340, \8A72\5DE5\4F5C\5340\7684\958B\767C\4EBA\54E1\5C07\5177\6709\7DB1\8981\7684\5B8C\6574\5B58\53D6\6B0A. \6838\51C6\6B64\8981\6C42\4E4B\524D, \8ACB\5148\78BA\5B9A\6B64\52D5\4F5C\7B26\5408\60A8\7DB2\7AD9\7684\5B89\5168\6027\539F\5247.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109407842701313681)
,p_name=>'F4050.SCHEMA_RESTRICTED_NO_WARN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981\53D7\5230\5B89\5168\6027\539F\5247\7684\9650\5236. \4E0D\80FD\5C07\9650\5236\7684\7DB1\8981\6307\5B9A\7D66\5DE5\4F5C\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109376710290313657)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7D42\6B62\670D\52D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109376854123313657)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\958B\767C\670D\52D9 "%0" \5DF2\7D93\7D42\6B62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110128580704314255)
,p_name=>'F4050.SUCCEEDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109536816839313778)
,p_name=>'F4050.SUSPENDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66AB\505C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109536989476313778)
,p_name=>'F4050.TERMINATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D42\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109537414343313778)
,p_name=>'F4050.TERMINATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7D42\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110127618904314254)
,p_name=>'F4050.TERMINATION_IN_PROGRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5728\7D42\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109302590870313601)
,p_name=>'F4050.VIEW_REQUEST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109302979489313602)
,p_name=>'F4050.WORKSPACE_EXPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\532F\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109068984183313422)
,p_name=>'F4050.WORKSPACE_HOME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109069059800313422)
,p_name=>'F4050.WORKSPACE_LOGIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\767B\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109372721552313654)
,p_name=>'F4050.WSID_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56E0\70BA\76F8\540C ID \7684\5DE5\4F5C\5340\5DF2\7D93\5B58\5728, \5C07\4E0D\6703\5EFA\7ACB\5DE5\4F5C\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109372681121313654)
,p_name=>'F4050.WSNAME_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56E0\70BA\76F8\540C\540D\7A31\7684\5DE5\4F5C\5340\5DF2\7D93\5B58\5728, \5C07\4E0D\6703\5EFA\7ACB\5DE5\4F5C\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109145539818313479)
,p_name=>'F4050.WS_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340 %0 \5DF2\5EFA\7ACB\65BC %1, \5DF2\5C07\78BA\8A8D\5BC4\81F3\8A3B\518A\671F\9593\60A8\63D0\4F9B\7684\96FB\5B50\90F5\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108974766395313346)
,p_name=>'F4050.WS_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\5DF2\7D93\5B58\5728, \56E0\6B64\4E0D\6703\518D\5EFA\7ACB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108974898638313346)
,p_name=>'F4050.WS_TOBE_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\5EFA\7ACB\5DE5\4F5C\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109209958189313528)
,p_name=>'F4050_EMAIL_BODY_NEW_PASSWORD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5BC6\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109209827757313528)
,p_name=>'F4050_EMAIL_BODY_PASSWORD_CHANGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8B8A\66F4\4F7F\7528\8005 %0 \7684\5E33\6236\5BC6\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109209782257313528)
,p_name=>'F4050_EMAIL_SUBJECT_PASSWORD_CHANGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\5BC6\78BC\5DF2\7D93\8B8A\66F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110092839863314210)
,p_name=>'F4050_P158_INTRO_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\63A7\5236 %0 \662F\5C07\5728\63D0\4F9B\4E0B\4E00\500B\7248\6B21\6642\7ACB\5373\5347\7D1A, \9084\662F\6700\9577\5C07\5347\7D1A\5EF6\7DE9 %1 \5929.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110092957667314210)
,p_name=>'F4050_P158_UPGRADE_NOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E00\4E0B\300C\7ACB\5373\5347\7D1A\300D\5373\53EF\958B\59CB\5347\7D1A\4F5C\696D, \4E0D\9700\7B49\5230 %0 \624D\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110092564203314210)
,p_name=>'F4050_P3_SYSTEM_UP_TO_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7CFB\7D71\5DF2\662F\6700\65B0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110092664005314210)
,p_name=>'F4050_P3_UPGRADE_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<a href="%2" target="_blank" rel="noreferrer">\6709\53EF\7528\7684</a> %0 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110091634931314209)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_N'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7576\65B0\7684 %0 \7248\6B21\53EF\4F9B\4F7F\7528\5F8C, \60A8\7684\57F7\884C\8655\7406\5C07\6703<strong>\7ACB\5373</strong>\5347\7D1A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110092326974314209)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_P'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\57F7\884C\8655\7406\5C07\65BC <strong>%0</strong> \81EA\52D5\5347\7D1A. \6309\4E00\4E0B\9F52\8F2A\5716\793A\5373\53EF\7ACB\5373\5347\7D1A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110091573950314208)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_Y'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\57F7\884C\8655\7406\6709 %0 \9805\5347\7D1A\88AB<strong>\5EF6\7DE9</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109633596089313857)
,p_name=>'F4050_P3_UPGRADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \76EE\524D\6B63\5728\5347\7D1A\81F3 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108961636442313336)
,p_name=>'F4050_P74_PROVISION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\9810\8A2D\8868\683C\7A7A\9593 %1 (\4F7F\7528\8CC7\6599\6A94 %2) \5EFA\7ACB\8CC7\6599\5EAB\4F7F\7528\8005 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108978492392313349)
,p_name=>'F4050_P74_PROVISION1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\54E1 %1 \4F48\5EFA\7684\5DE5\4F5C\5340 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109110240371313453)
,p_name=>'F4050_SHOW_ALL_WORKSPACES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5168\90E8\5DE5\4F5C\5340')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109101585152313446)
,p_name=>'F4300.COL_LENGTH_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\9577\5EA6\4E0D\80FD\662F\7A7A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109101480238313446)
,p_name=>'F4300.COL_LENGTH_NOT_ZERO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\9577\5EA6\4E0D\80FD\70BA 0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109101763721313447)
,p_name=>'F4300.COL_NAMES_NOT_LONGER_THAN_30'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31\7684\9577\5EA6\4E0D\80FD\8D85\904E %0 \500B\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109101832765313447)
,p_name=>'F4300.COL_NAMES_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31\4E0D\80FD\662F\7A7A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109102348110313447)
,p_name=>'F4300.F4500.NAME_ALREADY_USED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<strong>%0</strong> \5DF2\7D93\88AB\73FE\6709\7684\7269\4EF6\4F7F\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109102585927313447)
,p_name=>'F4300.F4500.NOT_VALID_SEQ_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<strong>%0</strong> \4E0D\662F\6709\6548\7684\9806\5E8F\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109101191263313446)
,p_name=>'F4300.F4500.TABLE_ALREADY_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\540D\7A31\5DF2\7D93\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109102102641313447)
,p_name=>'F4300.NOT_VALID_PK_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<strong>%0</strong> \4E0D\662F\6709\6548\7684\4E3B\7D22\5F15\9375\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109320246695313615)
,p_name=>'F4300.P180_FILE_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>'DOS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109291239307313593)
,p_name=>'F4300.SPREADSHEET_IMPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\5165\8A66\7B97\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109102008991313447)
,p_name=>'F4300.TABLE_NAMES_NOT_LONGER_THAN_30'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\540D\7A31\5FC5\9808\5C0F\65BC %0 \500B\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109112780820313455)
,p_name=>'F4300_INSTRUCT_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C\4E00\5217\70BA\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109438590596313704)
,p_name=>'F4300_TEXT_IMPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\5165\6587\5B57')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109138590537313474)
,p_name=>'F4350.APPLICATION_OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109301298959313600)
,p_name=>'F4350.AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\53EF\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109301099588313600)
,p_name=>'F4350.CHANGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109476103540313733)
,p_name=>'F4350.CONFIRM_SCHEMA_EXISTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\5C07\73FE\6709\7DB1\8981 %0 \6307\5B9A\7D66\60A8\7684\5DE5\4F5C\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109476200041313733)
,p_name=>'F4350.CONFIRM_SCHEMA_NEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\5EFA\7ACB\7DB1\8981 %0 \4E26\6307\5B9A\7D66\60A8\7684\5DE5\4F5C\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109300734520313600)
,p_name=>'F4350.CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109144602560313479)
,p_name=>'F4350.CREATING_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5DE5\4F5C\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109301134531313600)
,p_name=>'F4350.CURRENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\76EE\524D\4F5C\7528\4E2D)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109139048869313475)
,p_name=>'F4350.CURRENT_TIME_ON_SERVER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\6642\9593 (\4F3A\670D\5668)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109138884736313474)
,p_name=>'F4350.CURRENT_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109300979465313600)
,p_name=>'F4350.DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109145751022313480)
,p_name=>'F4350.DISABLE.WORK.PROV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66AB\6642\505C\7528\5EFA\7ACB\5DE5\4F5C\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109138409516313474)
,p_name=>'F4350.HOST_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\7DB1\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109300454078313600)
,p_name=>'F4350.INSERTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\63D2\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109138944774313475)
,p_name=>'F4350.LANGUAGE_PREFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109138331327313474)
,p_name=>'F4350.LAST_DDL_TIME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\6B21\7522\751F DDL \7684\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109622127539313849)
,p_name=>'F4350.LAST_PATCH_TIME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\6B21\4FEE\6B63\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108945240578313322)
,p_name=>'F4350.MORE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9084\6709 %0 \500B...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109622004012313849)
,p_name=>'F4350.PATCH_VERSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4FEE\6B63\7A0B\5F0F\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109138161868313474)
,p_name=>'F4350.PRODUCT_BUILD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7522\54C1\5EFA\7F6E\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109669925858313888)
,p_name=>'F4350.RESET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109138227341313474)
,p_name=>'F4350.SCHEMA_COMPATIBILITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981\76F8\5BB9\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108945103340313322)
,p_name=>'F4350.TRANSLATED_APPLICATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(+%0 \7FFB\8B6F\7684\61C9\7528\7A0B\5F0F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109300662642313600)
,p_name=>'F4350.UNKNOWN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109300571093313600)
,p_name=>'F4350.UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109138639254313474)
,p_name=>'F4350.WORKSPACE_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109138785339313474)
,p_name=>'F4350.WORKSPACE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109846830935314033)
,p_name=>'F4350_AJAX'
,p_message_language=>'zh-tw'
,p_message_text=>'AJAX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109846732627314033)
,p_name=>'F4350_AUTHENTICATION_CALLBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\56DE\547C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109302154822313601)
,p_name=>'F4350_CLICKTHRU_LOG_ENTRIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F4\63A5\9023\7D50\65E5\8A8C\9805\76EE:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109302036548313601)
,p_name=>'F4350_DEV_LOG_ENTRIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\767C\4EBA\54E1\6D3B\52D5\65E5\8A8C\9805\76EE:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109302625565313601)
,p_name=>'F4350_DISTINCT_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\968E\6BB5\4F5C\696D\4E2D\4E0D\540C\7684\4F7F\7528\8005 = %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109303035928313602)
,p_name=>'F4350_NO_USER_SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9078\53D6\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109303374813313602)
,p_name=>'F4350_PREFS_EXISTS_FOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340 "%2" \4E2D\7684 %1 \4F7F\7528\8005\5DF2\7D93\6709 %0 \504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108919597509313302)
,p_name=>'F4350_PREFS_EXISTS_FOR2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%1 \4F4D\4F7F\7528\8005\5171\6709 %0 \500B\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109301881957313601)
,p_name=>'F4350_RESET_PREFS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\60F3\4E0D\4F7F\7528\4EFB\4F55\9810\5148\8A2D\5B9A\503C\4F86\57F7\884C\61C9\7528\7A0B\5F0F, \8ACB\91CD\8A2D\60A8\7684\504F\597D\8A2D\5B9A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108976577816313348)
,p_name=>'F4350_RESET_SESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\60A8\4E0D\60F3\4F7F\7528\9810\5148\8A2D\5B9A\503C\57F7\884C\60A8\7684\61C9\7528\7A0B\5F0F, \8ACB\91CD\8A2D\60A8\7684\968E\6BB5\4F5C\696D\72C0\614B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109303464431313602)
,p_name=>'F4350_SELECTED_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7684\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109302764879313601)
,p_name=>'F4350_SESSIONS_OLDER_THAN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D85\904E %0 \5929\7684\968E\6BB5\4F5C\696D = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109302849729313602)
,p_name=>'F4350_SESSIONS_OLDER_THAN_MINS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D85\904E %0 \5206\9418\7684\968E\6BB5\4F5C\696D = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109301371113313600)
,p_name=>'F4350_SESSION_STATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\968E\6BB5\4F5C\696D\7531 %0 \8B58\5225, \800C\4E14\5305\542B %1 \500B\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109304065664313602)
,p_name=>'F4350_SQL'
,p_message_language=>'zh-tw'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109303229231313602)
,p_name=>'F4350_SUMMARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6458\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109302404970313601)
,p_name=>'F4350_TOTAL_SESSIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340 "%0" \7684\968E\6BB5\4F5C\696D\7E3D\6578\662F %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108919409531313302)
,p_name=>'F4350_TOTAL_SESSIONS2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D\7E3D\8A08: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109303506098313602)
,p_name=>'F4350_USER_HAS_X_PREFS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005 %0 \6709 %1 \504F\597D\8A2D\5B9A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109301768701313601)
,p_name=>'F4350_USER_PREFS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\4F7F\7528\8005 %0 \8A2D\5B9A\4E86 %1 \500B\504F\597D\8A2D\5B9A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109303643084313602)
,p_name=>'F4350_WORKSPACE_SCHEMAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\7DB1\8981')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109306172352313604)
,p_name=>'F4500.DISPLAY_SEQ_IN_FORM_NUMERIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5728\8868\55AE\4E2D\986F\793A\9806\5E8F\300D\5FC5\9808\662F\6578\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109306292791313604)
,p_name=>'F4500.DISPLAY_SEQ_IN_REPORT_NUMERIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5728\5831\8868\4E2D\986F\793A\9806\5E8F\300D\5FC5\9808\662F\6578\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109109689575313453)
,p_name=>'F4500.DUP_ARG_NAMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F15\6578\540D\7A31 <strong>%0</strong> \5728\6B64\51FD\6578\4E2D\4F7F\7528\4E00\6B21\4EE5\4E0A.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109309291364313606)
,p_name=>'F4500.EXECUTION_ORDER_MAND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\57F7\884C\9806\5E8F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109309145807313606)
,p_name=>'F4500.EXECUTION_ORDER_NUMERIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\57F7\884C\9806\5E8F\300D\5FC5\9808\662F\6578\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109292081724313593)
,p_name=>'F4500.FIND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0B\627E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109320480093313615)
,p_name=>'F4500.HIDE_SQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109292476974313594)
,p_name=>'F4500.MAGNIFY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\653E\5927')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109292392882313594)
,p_name=>'F4500.MOVE_COLUMN_DOWN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8CC7\6599\6B04\5411\4E0B\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109292284185313594)
,p_name=>'F4500.MOVE_COLUMN_UP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8CC7\6599\6B04\5F80\4E0A\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109103385949313448)
,p_name=>'F4500.NEED_UNIQUE_EXECUTION_ORDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\552F\4E00\7684\57F7\884C\9806\5E8F\865F\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108904557869313291)
,p_name=>'F4500.NEW_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\65B0\589E\7684\65B0\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109102979089313448)
,p_name=>'F4500.NOT_VALID_OBJECT_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<strong>%0</strong> \4E0D\662F\6709\6548\7684\7269\4EF6\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109102763374313447)
,p_name=>'F4500.NOT_VALID_TABLE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<strong>%0</strong> \4E0D\662F\6709\6548\7684\8868\683C\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109292141683313593)
,p_name=>'F4500.NO_IMAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109292537970313594)
,p_name=>'F4500.NULLABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\4EE5\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109405842791313679)
,p_name=>'F4500.P40.PREVIOUS.RUNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5148\524D\7684\57F7\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109109199415313452)
,p_name=>'F4500.P602.DUP_COL_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31 <strong>%0</strong> \5728\6B64\8868\683C\4E2D\4F7F\7528\4E00\6B21\4EE5\4E0A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109109563335313453)
,p_name=>'F4500.P602.ENTER_AT_LEAST_ONE_COL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81F3\5C11\5FC5\9808\8F38\5165\4E00\500B\8CC7\6599\6B04\7684\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109109465658313452)
,p_name=>'F4500.P602.INVALID_COL_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31 <strong>%0</strong> \7121\6548.<br />')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109109225117313452)
,p_name=>'F4500.P602.INVALID_PRECISION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04 <strong>%0</strong> \7684\7CBE\78BA\5EA6\7121\6548.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109109355517313452)
,p_name=>'F4500.P602.INVALID_SCALE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04 <strong>%0</strong> \7684\5C0F\6578\4F4D\6578\7121\6548.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108959643727313334)
,p_name=>'F4500.P602.SCALE_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\8CC7\6599\6B04 <strong>%0</strong> \7684\5C0F\6578\4F4D\6578.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109320509727313615)
,p_name=>'F4500.P99.CREATE_SYNONYM_ON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\540C\7FA9\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109320317594313615)
,p_name=>'F4500.SHOW_SQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109103003959313448)
,p_name=>'F4500.TABLE_NOT_FOUND_IN_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\7DB1\8981 <strong>%1</strong> \4E2D\627E\4E0D\5230\8868\683C <strong>%0</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108908657063313294)
,p_name=>'F4500.WARNING_STATEMENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109305291339313603)
,p_name=>'F4500_BROKEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\65B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109305755691313604)
,p_name=>'F4500_BYTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\5143\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109305692750313604)
,p_name=>'F4500_CARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109305027863313603)
,p_name=>'F4500_CHECK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109297596007313597)
,p_name=>'F4500_CLICK_POP_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E00\4E0B\4F86\7522\751F\67E5\8A62\6B04\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109305552782313604)
,p_name=>'F4500_COST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109296837745313597)
,p_name=>'F4500_CREATE_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\4F5C\696D\6210\529F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110074901320314196)
,p_name=>'F4500_DICTIONARY_OBJECTS_WO_DEFAULTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\9810\8A2D\503C\7684\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110074870719314196)
,p_name=>'F4500_DICTIONARY_OBJECTS_W_DEFAULTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5177\6709\9810\8A2D\503C\7684\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109296108408313596)
,p_name=>'F4500_DROP_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\4F5C\696D\6210\529F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108948690247313325)
,p_name=>'F4500_FOREIGN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\4F86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109210122604313528)
,p_name=>'F4500_FOREIGN_KEY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\4F86\7D22\5F15\9375')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109109955789313453)
,p_name=>'F4500_NATIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\539F\751F\6A94\6848\683C\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109295813574313596)
,p_name=>'F4500_NOT_AVAIL_EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\7DE8\8F2F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109305352744313604)
,p_name=>'F4500_NOT_AVAIL_SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109305114341313603)
,p_name=>'F4500_OF'
,p_message_language=>'zh-tw'
,p_message_text=>'/'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109305433451313604)
,p_name=>'F4500_OPTIMIZER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\4F73\5316\8655\7406\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109297829202313598)
,p_name=>'F4500_OP_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F5C\696D\6210\529F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109285510348313589)
,p_name=>'F4500_P1000_NO_WS_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\5DE5\4F5C\5340\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109438484488313704)
,p_name=>'F4500_P101_NO_VARCHAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709 VARCHAR \8CC7\6599\6B04\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108982856764313352)
,p_name=>'F4500_P1023_PARSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5728\5256\6790\547D\4EE4\6A94 - \8ACB\7A0D\5019.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108929559014313310)
,p_name=>'F4500_P10_NUM_STMTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6558\8FF0\53E5\6578\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109171377921313499)
,p_name=>'F4500_P10_ON_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\9593\70BA %0, \57F7\884C\8005\70BA %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109293217120313594)
,p_name=>'F4500_P10_PARAMETERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\60A8\7684\547D\4EE4\6A94\4E2D\6709\53C3\6578, \8ACB\5728\57F7\884C\4E4B\524D\5148\5B9A\7FA9\5B83\5011.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108929452774313310)
,p_name=>'F4500_P10_SCRIPT_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\547D\4EE4\6A94\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109171216651313499)
,p_name=>'F4500_P10_SCRIPT_SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\547D\4EE4\6A94\5927\5C0F (\4F4D\5143\7D44)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109167518579313496)
,p_name=>'F4500_P10_UPDATED_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109293454121313594)
,p_name=>'F4500_P10_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109452175984313715)
,p_name=>'F4500_P115.CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\532F\5165\4E0B\5217\547D\4EE4\6A94. \8ACB\78BA\8A8D\60A8\7684\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109452222491313715)
,p_name=>'F4500_P115.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\532F\5165\7684\547D\4EE4\6A94\8D85\904E\5132\5B58\5141\8A31\7684\4E0A\9650.  \8ACB\806F\7D61 %0 \7BA1\7406\54E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109453231705313716)
,p_name=>'F4500_P115.SCRIPTS_TO_INSTALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\532F\5165\7684\547D\4EE4\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109293918140313595)
,p_name=>'F4500_P11_NO_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109293700252313595)
,p_name=>'F4500_P11_NUM'
,p_message_language=>'zh-tw'
,p_message_text=>'Num'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109273614475313575)
,p_name=>'F4500_P1224_VIEW_OUTPUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\8F38\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109354574471313640)
,p_name=>'F4500_P129_BROWSE_SEQ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109354691494313640)
,p_name=>'F4500_P129_NO_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\9806\5E8F\4F5C\696D\672A\6210\529F, \539F\56E0\5982\4E0B:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109354481764313640)
,p_name=>'F4500_P129_SEQUENCE_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5728 "%1" \7DB1\8981\4E2D\5EFA\7ACB\9806\5E8F "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109294184961313595)
,p_name=>'F4500_P12_STATEMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6558\8FF0\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109354997465313641)
,p_name=>'F4500_P130_BROWSE_DB_SYN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\8CC7\6599\5EAB\540C\7FA9\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109355198611313641)
,p_name=>'F4500_P130_CREATE_NOT_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\540C\7FA9\5B57\4F5C\696D\672A\6210\529F, \539F\56E0\5982\4E0B:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109354872640313641)
,p_name=>'F4500_P130_SYNONYM_CREATE_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5728 "%1" \7DB1\8981\4E2D\5EFA\7ACB\540C\7FA9\5B57 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109355285967313641)
,p_name=>'F4500_P132_CREATE_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5957\88DD\7A0B\5F0F\672A\6210\529F, \539F\56E0\5982\4E0B:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109355349808313641)
,p_name=>'F4500_P132_PACKAGE_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\88DD\7A0B\5F0F "%0" \5DF2\7D93\5728 "%1" \7DB1\8981\4E2D\5EFA\7ACB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109136926920313473)
,p_name=>'F4500_P24_SAVE_TO_WORKSHEET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\81F3\5DE5\4F5C\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109294424171313595)
,p_name=>'F4500_P25_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F9D\64DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109294326802313595)
,p_name=>'F4500_P25_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109294240775313595)
,p_name=>'F4500_P25_FILE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108950344537313327)
,p_name=>'F4500_P2610_EXPIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904E\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108950416985313327)
,p_name=>'F4500_P2610_EXPIRED_AND_LOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904E\671F\4E26\9396\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108950230365313326)
,p_name=>'F4500_P2610_LOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9396\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108950119338313326)
,p_name=>'F4500_P2610_OPEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\555F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109354330612313640)
,p_name=>'F4500_P402_OPERATION_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F5C\696D\672A\6210\529F, \539F\56E0\5982\4E0B:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109331472208313623)
,p_name=>'F4500_P51_NOT_AVAIL_INSERT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\63D2\5165\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109354269919313640)
,p_name=>'F4500_P54_BROWSE_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\8CC7\6599\5EAB\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109353977959313640)
,p_name=>'F4500_P54_NOT_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6AA2\8996\4F5C\696D\672A\6210\529F, \539F\56E0\5982\4E0B:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109354018014313640)
,p_name=>'F4500_P54_SQL_WORKSHOP_HOME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \5DE5\4F5C\5BA4\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109354161613313640)
,p_name=>'F4500_P54_VIEW_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5728 "%1" \7DB1\8981\4E2D\5EFA\7ACB\6AA2\8996 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109322719333313617)
,p_name=>'F4500_P553_GET_COLUMN_COMMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\5F97\8CC7\6599\6B04\8A3B\89E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109480381030313736)
,p_name=>'F4500_P602_IDENTITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B58\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108981398716313351)
,p_name=>'F4500_P602_NO_DATATYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6307\5B9A %0 \7684\8CC7\6599\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109295918551313596)
,p_name=>'F4500_P68_TABLE_OP_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\4F5C\696D\6210\529F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109293015974313594)
,p_name=>'F4500_P6_STATEMENT_CNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\6A94\6848\6709 %0 \500B\6558\8FF0\53E5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109293109814313594)
,p_name=>'F4500_P6_USER_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\5DF2\5B9A\7FA9\4E0B\5217\7684 %0 \500B\53C3\6578:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109110136539313453)
,p_name=>'F4500_PARSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5256\6790\6B64\547D\4EE4\6A94.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109304809590313603)
,p_name=>'F4500_PRIMARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108913762895313298)
,p_name=>'F4500_REFERENTIAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109110037217313453)
,p_name=>'F4500_TEXT_FILE_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6587\4EF6\7576\6210\6587\5B57\6AA2\8996.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109304972374313603)
,p_name=>'F4500_UNIQUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\552F\4E00')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110154358050314275)
,p_name=>'F4550.STATIC_FILES_NOT_CONFIGURED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\74B0\5883\4E2D\7684\300C\975C\614B\6A94\6848\300D\7D44\614B\767C\751F\554F\984C. \8ACB\53C3\95B1 Application Express Installation Guide \4E2D\7684 "Configuring Static File Support" \5C0F\7BC0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109497721726313749)
,p_name=>'F4550.WELCOME_TO_APEX_ADB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B61\8FCE\4F7F\7528 Oracle APEX! \8ACB\4F7F\7528\60A8\81EA\6CBB\5F0F\8CC7\6599\5EAB\7684\7BA1\7406\54E1 (ADMIN) \5BC6\78BC\767B\5165.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110150427661314272)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\6536\5230\6B64\96FB\5B50\90F5\4EF6\7684\539F\56E0\662F\60A8\8981\6C42 Oracle APEX \5DE5\4F5C\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110150351717314272)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981\57F7\884C\52D5\4F5C: %0 \7684\5E33\6236\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109374032489313655)
,p_name=>'F4700.EMAIL_NOTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\7528\4F86\4EE5\96FB\5B50\90F5\4EF6\50B3\9001\60A8\7684\8B49\660E\8CC7\6599)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109374219171313655)
,p_name=>'F4700.EXISTING_SCHEMA_HINT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\8F38\5165\60A8 Oracle Database \7684\8CC7\6599\5EAB\7DB1\8981.  \70BA\4E86\5B89\5168\4E0A\7684\7406\7531, \5C07\4E0D\6703\63D0\4F9B\503C\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109374100320313655)
,p_name=>'F4700.NEW_SCHEMA_HINT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\8F38\5165\5E0C\671B\5728\60A8\7684\5DE5\4F5C\5340\5EFA\7ACB\7684 Oracle Database \7DB1\8981\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109373443047313655)
,p_name=>'F4700.P26_JUSTIFY_RESTRICTED_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8ACB\5728\4E0B\65B9\7684\63CF\8FF0\4E2D, \89E3\91CB\8981\6C42\9650\5236\7DB1\8981\7684\7406\7531.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109373522419313655)
,p_name=>'F4700.P26_JUSTIFY_SHARED_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\5728\4E0B\65B9\7684\63CF\8FF0\4E2D, \89E3\91CB\8981\6C42\5DF2\7531\4E00\6216\591A\500B\5176\4ED6\5DE5\4F5C\5340\4F7F\7528\4E2D\4E4B\7DB1\8981\7684\7406\7531.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109373922149313655)
,p_name=>'F4700.P26_WARN_RESTRICTED_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A: \60A8\8981\6C42\7684\7DB1\8981\56E0\5B89\5168\4E0A\7684\7406\7531\800C\6709\9650\5236. %0 \7BA1\7406\54E1\53EF\80FD\62D2\7D55\60A8\5C07\6B64\7DB1\8981\6307\5B9A\7D66\60A8\5DE5\4F5C\5340\7684\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109373810032313655)
,p_name=>'F4700.P26_WARN_SHARED_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A: \60A8\8981\6C42\7684\7DB1\8981\5DF2\7531\5176\4ED6\5DE5\4F5C\5340\4F7F\7528. %0 \7BA1\7406\54E1\53EF\80FD\62D2\7D55\60A8\5C07\6B64\7DB1\8981\6307\5B9A\7D66\60A8\5DE5\4F5C\5340\7684\8981\6C42. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109370819620313653)
,p_name=>'F4700.SCHEMA_RESTRICTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\70BA\5DE5\4F5C\5340\8981\6C42\7684\65B0\7DB1\8981\662F Oracle \9810\8A2D\7DB1\8981\6216\56E0\7DB2\7AD9\7684\5B89\5168\6027\7406\7531\800C\6709\6240\9650\5236, \56E0\6B64\7121\6CD5\6307\5B9A\7D66\5DE5\4F5C\5340. \5982\679C\9019\9055\53CD\60A8\7DB2\7AD9\7684\5B89\5168\6027\539F\5247, \7DB2\7AD9\7BA1\7406\54E1\6703\62D2\7D55\60A8\7684\4F48\5EFA\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109370748840313653)
,p_name=>'F4700.SCHEMA_USED_BY_WORKSPACES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\70BA\5DE5\4F5C\5340\8981\6C42\7684\7DB1\8981\5DF2\6307\5B9A\7D66 %0 \500B\5DE5\4F5C\5340. \5982\679C\9019\9055\53CD\60A8\7DB2\7AD9\7684\5B89\5168\6027\539F\5247, \7DB2\7AD9\7BA1\7406\54E1\6703\62D2\7D55\60A8\7684\4F48\5EFA\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108946075615313323)
,p_name=>'F4700P1_A'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle APEX \63D0\4F9B Oracle Database \548C\61C9\7528\700F\89BD\5668\958B\767C\5DE5\5177\7684\5B58\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108946155481313323)
,p_name=>'F4700P1_B'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EE5\5BA3\544A\65B9\5F0F\7D44\5EFA Web \61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108946295549313323)
,p_name=>'F4700P1_C'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\4E26\7BA1\7406\8CC7\6599\5EAB\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108946345237313323)
,p_name=>'F4700P1_D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8FFD\8E64\91CC\7A0B\7891\3001\932F\8AA4\3001\529F\80FD\4EE5\53CA\5DE5\5177<')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110084866199314203)
,p_name=>'F4750.P209.DB_APP_USER_SETUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5B89\88DD\61C9\7528\7A0B\5F0F. \4F46\70BA\4E86\642D\914D Application Express \5E33\6236\8A8D\8B49\4F86\57F7\884C\61C9\7528\7A0B\5F0F, \60A8\5FC5\9808\8A2D\5B9A Application Express \4F7F\7528\8005\5E33\6236.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110084937729314203)
,p_name=>'F4750.P209.WEBSHEET_ADMIN_SETUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5B89\88DD\300CWeb \8A66\7B97\8868\300D. \4F46\70BA\4E86\642D\914D Application Express \5E33\6236\8A8D\8B49\4F86\57F7\884C\300CWeb \8A66\7B97\8868\300D, \60A8\5FC5\9808\8A2D\5B9A Application Express \7BA1\7406\54E1\5E33\6236.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109438658582313704)
,p_name=>'F4750.VERSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7248\672C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110108961585314240)
,p_name=>'F4850.P1.SCHEMA_DOES_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\91CD\8A2D\7BC4\4F8B RESTful \670D\52D9\8CC7\6599: \7DB1\8981 <code>%0</code> \4E0D\5B58\5728.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109683719183313902)
,p_name=>'F4900_P11_AUTH_TYPE_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\61C9\7528\7A0B\5F0F\4F7F\7528 %0 \8A8D\8B49\914D\7F6E.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109718191086313936)
,p_name=>'FACETED_SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\591A\9762\5411\641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109691576522313913)
,p_name=>'FACETED_SEARCH.INVALID.SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7CBE\9748\7121\6CD5\4F7F\7528\5831\8868\4F86\6E90\5EFA\7ACB\591A\9762\5411\641C\5C0B.  \6C92\6709\8CC7\6599\6B04\53EF\4F9B\641C\5C0B.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109503334616313753)
,p_name=>'FAILURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5931\6557')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109294657888313595)
,p_name=>'FAILURES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5931\6557')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109369084384313651)
,p_name=>'FDASH1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \529F\80FD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109410549000313683)
,p_name=>'FEATURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110129388026314256)
,p_name=>'FEATURE OWNERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109083063979313433)
,p_name=>'FEATURE.ABOUT_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\65BC\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109083752181313433)
,p_name=>'FEATURE.ABOUT_PAGE.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\65BC\6B64\61C9\7528\7A0B\5F0F\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109083149195313433)
,p_name=>'FEATURE.ACCESS_CONTROL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109083869461313433)
,p_name=>'FEATURE.ACCESS_CONTROL.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\61C9\7528\7A0B\5F0F\5167\4F75\5165\4EE5\89D2\8272\70BA\57FA\790E\7684\4F7F\7528\8005\8A8D\8B49, \4E26\7BA1\7406\5C0D\61C9\7528\7A0B\5F0F\89D2\8272\7684\4F7F\7528\8005\540D\7A31\5C0D\61C9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109083256804313433)
,p_name=>'FEATURE.ACTIVITY_REPORTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D3B\52D5\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109083907366313433)
,p_name=>'FEATURE.ACTIVITY_REPORTING.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\542B\4E00\822C\4F7F\7528\8005\6D3B\52D5\7684\6578\500B\5831\8868\548C\5716\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109083319820313433)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\614B\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109084767175313434)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\61C9\7528\7A0B\5F0F\7BA1\7406\54E1\555F\7528\6216\505C\7528\61C9\7528\7A0B\5F0F\5167\8207 Application Express \7D44\5EFA\9078\9805\95DC\806F\7684\7279\5B9A\529F\80FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109382822019313662)
,p_name=>'FEATURE.CREATE_BUILD_OPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\5EFA\7ACB\4E0B\5217\7D44\5EFA\9078\9805:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109443570521313708)
,p_name=>'FEATURE.EMAIL_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109443604687313708)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIOTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\542B APEX_SEND() \96FB\5B50\90F5\4EF6\4F47\5217\5831\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109500222920313751)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\542B\986F\793A\8981\50B3\9001\7684\96FB\5B50\90F5\4EF6\5831\8868, \4EE5\53CA\5DF2\7D93\50B3\9001\7684\96FB\5B50\90F5\4EF6\65E5\8A8C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109083435673313433)
,p_name=>'FEATURE.FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109084069151313433)
,p_name=>'FEATURE.FEEDBACK.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\4E00\822C\4F7F\7528\8005\5C07\4E00\822C\8A3B\89E3\53CD\61C9\7D66\61C9\7528\7A0B\5F0F\7BA1\7406\54E1\548C\958B\767C\4EBA\54E1\6642\6240\63A1\7528\7684\6A5F\5236.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109443714040313709)
,p_name=>'FEATURE.JOB_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109443898392313709)
,p_name=>'FEATURE.JOB_REPORT.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\542B\8CC7\6599\5EAB\5DE5\4F5C\5831\8868, \6B64\5831\8868\5177\5099\5411\4E0B\5C55\958B\7279\5B9A\5DE5\4F5C\4EE5\67E5\770B\984D\5916\8A73\7D30\8CC7\8A0A\7684\80FD\529B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109083533731313433)
,p_name=>'FEATURE.THEME_STYLE_SELECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\4E3B\984C\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109084693314313434)
,p_name=>'FEATURE.THEME_STYLE_SELECTION.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\7BA1\7406\54E1\9078\53D6\61C9\7528\7A0B\5F0F\7684\9810\8A2D\8272\5F69\914D\7F6E (\4E3B\984C\6A23\5F0F). \7BA1\7406\54E1\4E5F\53EF\4EE5\9078\64C7\5141\8A31\4E00\822C\4F7F\7528\8005\9078\64C7\81EA\5DF1\7684\4E3B\984C\6A23\5F0F. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109390703041313668)
,p_name=>'FEATURES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109698850956313921)
,p_name=>'FEATURES_100_PCT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('100% \5B8C\6210\7684\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109447932380313712)
,p_name=>'FEATURES_100_PERCENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('100% \5B8C\6210\7684\529F\80FD (%0/%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109413189158313685)
,p_name=>'FEATURES_80_PCT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210 80% \7684\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108941190874313319)
,p_name=>'FEATURES_AT_LEAST_80'
,p_message_language=>'zh-tw'
,p_message_text=>' %0 >= 80%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108939942926313318)
,p_name=>'FEATURES_COMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD\5B8C\6210 (%0 / %1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108941032468313319)
,p_name=>'FEATURES_COMPLETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5DF2\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109701310114313923)
,p_name=>'FEATURES_FOR_RELEASE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7248\6B21 %0 \7684\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109448198703313712)
,p_name=>'FEATURES_PAST_DUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\903E\671F (%0/%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109717420071313935)
,p_name=>'FEATURES_PERCENT_COMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD\5B8C\6210\767E\5206\6BD4 (%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109448047030313712)
,p_name=>'FEATURES_WITH_DATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767C\751F\65E5\671F (%0/%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109480234873313736)
,p_name=>'FEATURE_CONFIGURATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD\7D44\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109386201149313665)
,p_name=>'FEATURE_CONTRIBUTOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109447882258313712)
,p_name=>'FEATURE_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD\8A08\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109694871347313918)
,p_name=>'FEATURE_DASH_01'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\529F\80FD, %1 \500B\5DF2\5B8C\5168\5B8C\6210, \5171 %2 \500B\7248\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109694951438313918)
,p_name=>'FEATURE_DASH_02'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\6700\4E0A\5C64\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109695003012313918)
,p_name=>'FEATURE_DASH_03'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\6C92\6709\5230\671F\65E5, %1 \500B\5DF2\903E\671F\4E14\5B8C\6210\5EA6\4F4E\65BC 80%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109695121889313918)
,p_name=>'FEATURE_DASH_04'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\529F\80FD\5DF2\5B8C\6210, %1 \500B\5247\5C1A\672A\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109698539921313921)
,p_name=>'FEATURE_DASH_05'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0% \7684\529F\80FD\5DF2 100% \5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109384564012313663)
,p_name=>'FEATURE_DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109385566711313664)
,p_name=>'FEATURE_DESIRABILITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\8981\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110116432126314245)
,p_name=>'FEATURE_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109384133576313663)
,p_name=>'FEATURE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109384239643313663)
,p_name=>'FEATURE_OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109385270050313664)
,p_name=>'FEATURE_PRIORITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\512A\5148\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109385355838313664)
,p_name=>'FEATURE_STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109385198091313664)
,p_name=>'FEATURE_TAGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\8A18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110129434808314256)
,p_name=>'FEATURE_WITHOUT_OWNERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6307\5B9A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110131871899314257)
,p_name=>'FEEBACK.LOGGED.AS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8A18\9304 %0 \4E26\6307\5B9A\7D66 %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109410407984313683)
,p_name=>'FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109426075910313694)
,p_name=>'FEEDBACK_ATTRIBUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\63D0\4F9B\8981\8A18\9304\5728\610F\898B\56DE\994B\4E2D\7684\8CC7\8A0A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109496590869313748)
,p_name=>'FEEDBACK_DASHBOARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B\5100\8868\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109390388176313668)
,p_name=>'FEEDBACK_ENTRIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108940261613313318)
,p_name=>'FEEDBACK_ENTRIES_CLOSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%2 \500B\610F\898B\56DE\994B\9805\76EE\5F85\8655\7406 (%0 \500B\5DF2\8655\7406)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109425808951313694)
,p_name=>'FEEDBACK_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\60A8\7684\610F\898B\56DE\994B, \7136\5F8C\6309\300C\9001\51FA\610F\898B\56DE\994B\300D\6309\9215.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109717731424313935)
,p_name=>'FEEDBACK_PERCENT_CLOSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B\5DF2\8655\7406\767E\5206\6BD4 (%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109421086022313691)
,p_name=>'FEEDBACK_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\610F\898B\56DE\994B\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109425959044313694)
,p_name=>'FEEDBACK_TYPE_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\6307\5B9A\60A8\63D0\4F9B\4E4B\610F\898B\56DE\994B\7684\985E\578B.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109588719080313821)
,p_name=>'FILENAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109393432545313670)
,p_name=>'FILENAME_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\540D\7A31\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109636158653313859)
,p_name=>'FILENAME_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\540D\7A31: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109391970349313669)
,p_name=>'FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110071437786314193)
,p_name=>'FILES_WITH_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109391418183313669)
,p_name=>'FILES_WITH_COUNT_AND_SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\6A94\6848, \4F7F\7528 %1K')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110116235951314245)
,p_name=>'FILE_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108919109207313302)
,p_name=>'FILE_TOO_BIG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\6587\5B57\6A94\56E0\592A\5927\800C\7121\6CD5\7DE8\8F2F. \82E5\8981\8B8A\66F4\5176\5167\5BB9, \60A8\5FC5\9808\5728\60A8\7684\672C\6A5F\6A5F\5668\4E0A\7DE8\8F2F\8A72\6A94\6848, \7136\5F8C\518D\4E0A\50B3\4E00\6B21.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108953569111313329)
,p_name=>'FILE_UPLOAD_NOSESSION_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\6709\6548\7684\968E\6BB5\4F5C\696D\5B58\5728, \5DF2\4E0A\50B3\4E00\6216\591A\500B\6A94\6848.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108953421152313329)
,p_name=>'FILE_UPLOAD_TOOMANYFILES_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8981\6C42\4E2D\4E0A\50B3\7684\6A94\6848\6578\76EE\5927\65BC\9801\9762\4E0A\5B9A\7FA9\7684\6A94\6848\9805\76EE\985E\578B\6578\76EE.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109443957505313709)
,p_name=>'FIND_MY_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0B\627E\6211\7684\5DE5\4F5C\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108924507428313306)
,p_name=>'FIND_TABLES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0B\627E\8868\683C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110151664461314273)
,p_name=>'FINISH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109296512168313597)
,p_name=>'FIRST_ENTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C\4E00\500B\9805\76EE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109449611590313713)
,p_name=>'FIXBY_PAST_DUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4FEE\6B63\5B8C\6210\65E5\671F\903E\671F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109366057413313649)
,p_name=>'FIXED_IN_DEVELOPMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\65BC\958B\767C\4E2D\4FEE\6B63')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109384346642313663)
,p_name=>'FOCUS_AREA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\9EDE\5340\57DF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109167069976313496)
,p_name=>'FOOTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\5C3E\6587\5B57')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108906257031313292)
,p_name=>'FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110114952552314244)
,p_name=>'FORMAT_MASK_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F\906E\7F69: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109448260277313712)
,p_name=>'FORM_AND_LIST_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE\8207\6E05\55AE\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109448369050313712)
,p_name=>'FORM_AND_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\542B\8868\55AE\7684\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109284260526313588)
,p_name=>'FORM_ON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E2D\7684\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109025763953313390)
,p_name=>'FORM_ON_A_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\76F8\95DC\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109427586452313696)
,p_name=>'FORM_QUERY_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\67E5\8A62\7684\76F8\95DC\8868\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109427843367313696)
,p_name=>'FORM_REPORT_WS_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB Web \670D\52D9\53C3\7167\76F8\95DC\8868\55AE\548C\5831\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109425185984313694)
,p_name=>'FORM_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\8868\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109427657451313696)
,p_name=>'FORM_SUMMARY_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\6458\8981\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109427228326313695)
,p_name=>'FORM_TABLE_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\8868\683C\7684\76F8\95DC\8868\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109427726755313696)
,p_name=>'FORM_WS_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB Web \670D\52D9\53C3\7167\76F8\95DC\8868\55AE.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108974932664313346)
,p_name=>'FORWARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\9801')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109484730163313739)
,p_name=>'FROM_ATTRIBUTE_DICTIONARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\6027\5B57\5178')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109113229382313455)
,p_name=>'FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109374549126313656)
,p_name=>'FUNCTIONALLY_COMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109364387830313648)
,p_name=>'FUNCTIONAL_IMPLEMENTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD\5BE6\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109168613698313497)
,p_name=>'FUNCTION_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109114654166313456)
,p_name=>'FUNCTION_BODY_RETURNING_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109424873199313694)
,p_name=>'FUNCTION_RETURNING_REF_CURSOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\300C\53C3\7167\6E38\6A19\300D\7684 PL/SQL \51FD\6578\4E3B\9AD4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109417960361313689)
,p_name=>'FUNC_BODY_RETURNING_BOOLEAN	'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\5E03\6797\503C\7684 PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108973706889313345)
,p_name=>'FUNC_RET_BOOLEAN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\5E03\6797\503C\7684 PL/SQL \51FD\6578')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109411690990313684)
,p_name=>'FUTURE_MILESTONES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\4F86\7684\91CC\7A0B\7891\6578')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110064158239314188)
,p_name=>'GANTT_BASELINEDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57FA\6E96\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110064021341314188)
,p_name=>'GANTT_BASELINEEND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57FA\6E96\7D50\675F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110063957302314188)
,p_name=>'GANTT_BASELINESTART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57FA\6E96\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109417595269313688)
,p_name=>'GANTT_CHART.END_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109417419168313688)
,p_name=>'GANTT_CHART.START_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109651515005313871)
,p_name=>'GANTT_CHART.TASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110063624013314188)
,p_name=>'GANTT_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110063539311314188)
,p_name=>'GANTT_END'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110063713360314188)
,p_name=>'GANTT_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110063850738314188)
,p_name=>'GANTT_PROGRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110063389987314188)
,p_name=>'GANTT_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110063476609314188)
,p_name=>'GANTT_START'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109848991460314035)
,p_name=>'GATHER_TABLE_STATS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6536\96C6\8868\683C\7D71\8A08\8CC7\6599')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109367189162313650)
,p_name=>'GENERAL_COMMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\8A3B\89E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109717837235313935)
,p_name=>'GENERAL_COMMENT_DASH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\8A3B\89E3: %1 \500B\5DF2\8655\7406, \5171 %0 \500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108978817693313349)
,p_name=>'GENERATED_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8868\683C\662F\4F7F\7528\8868\683C\7CBE\9748\5EFA\7ACB\7684.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109063223425313418)
,p_name=>'GENERIC.CHANGES_SAVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5132\5B58\8B8A\66F4\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109373100759313654)
,p_name=>'GET_STATIC_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6216\7DE8\8F2F\975C\614B\7684\300C\503C\6E05\55AE\300D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109386466591313665)
,p_name=>'GLOBALIZATION_ASSIGNEE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\7403\5316\6307\5B9A\5C0D\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109384628836313663)
,p_name=>'GLOBALIZATION_IMPACT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\7403\5316\5F71\97FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109387459578313665)
,p_name=>'GLOBALIZATION_STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\7403\5316\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108907461337313293)
,p_name=>'GLOBAL_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\57DF\9801\9762')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109432041303313699)
,p_name=>'GRAY_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7070\8272\6587\5B57')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109406935605313680)
,p_name=>'GRID_DEBUG_OFF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF\7248\9762\914D\7F6E\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109406810713313680)
,p_name=>'GRID_DEBUG_ON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\7248\9762\914D\7F6E\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109005548252313375)
,p_name=>'GRID_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\683C\6A23\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109349093276313636)
,p_name=>'GROUPS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109541597861313782)
,p_name=>'GROUP_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109166952777313495)
,p_name=>'HEADER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D\6587\5B57')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109541393548313781)
,p_name=>'HEADING_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110111974992314242)
,p_name=>'HELP_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109115046605313457)
,p_name=>'HELP_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E\5167\5BB9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109210096516313528)
,p_name=>'HIDDEN_AND_PROTECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF\4E26\53D7\4FDD\8B77')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109368251007313651)
,p_name=>'HIGHLY_DESIRABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9AD8\5EA6\9700\8981')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110070923409314193)
,p_name=>'HIGH_CONTRAST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9AD8\5C0D\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109832532685314022)
,p_name=>'HIGH_CONTRAST_TOGGLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9AD8\5C0D\6BD4\5207\63DB')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109348815093313636)
,p_name=>'HISTORY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B77\53F2\8A18\9304')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109424609011313693)
,p_name=>'HOME_LINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9996\9801\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108903335313313290)
,p_name=>'HOME_NAV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle APEX \9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108956124063313331)
,p_name=>'HOME_PAGE_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109142089374313477)
,p_name=>'HORIZONTAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C34\5E73')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108888652986313278)
,p_name=>'HORIZONTAL2DCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C34\5E73 2D \67F1\72C0\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108888754803313278)
,p_name=>'HORIZONTAL3DCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C34\5E73 3D \67F1\72C0\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108888871804313278)
,p_name=>'HORIZONTALRANGE2DCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C34\5E73\7BC4\570D 2D \67F1\72C0\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108888921067313278)
,p_name=>'HORIZONTALRANGE3DCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C34\5E73\7BC4\570D 3D \67F1\72C0\5716')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110111387266314242)
,p_name=>'HOT_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\71B1\9215\6A23\677F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108946547791313323)
,p_name=>'HR_ACCOUNT_UNLOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HR \5E33\6236\5DF2\89E3\9664\9396\5B9A.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109116110961313458)
,p_name=>'HTML'
,p_message_language=>'zh-tw'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109135173395313472)
,p_name=>'HTMLWITHSHORTCUTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \8207\6377\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109134864756313471)
,p_name=>'HTML_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108977485553313348)
,p_name=>'HTML_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108986882871313356)
,p_name=>'HTML_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109167261723313496)
,p_name=>'HTML_HEADER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \6A19\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108986941076313356)
,p_name=>'HTML_SLASH_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML/\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109114756387313456)
,p_name=>'HTML_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108987012180313356)
,p_name=>'HTML_TEXT_WITH_SHORTCUTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \6587\5B57 (\542B\6377\5F91)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110111505966314242)
,p_name=>'ICON_CSS_CLASSES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A CSS \985E\5225')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110047262065314177)
,p_name=>'IE6_COMPATIBLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EE3\8868\4E3B\984C\8207 IE 6 \76F8\5BB9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109454329837313717)
,p_name=>'IG_ALLOW_EDITING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\7DE8\8F2F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109454494198313717)
,p_name=>'IG_READ_ONLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\552F\8B80')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109116334858313458)
,p_name=>'IMAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109657185872313876)
,p_name=>'IMAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109100756362313446)
,p_name=>'IMAGE_ATTRIBUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109424039151313693)
,p_name=>'IMAGE_PREFIX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF\524D\7F6E\78BC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109361960593313646)
,p_name=>'IMPORT FROM APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\61C9\7528\7A0B\5F0F\532F\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110123252441314251)
,p_name=>'IMPORT_APP_NEW_SUBSTRING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66FF\4EE3\5B57\4E32 %0 \7684\65B0\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109591867423313823)
,p_name=>'IMPORT_APP_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\532F\5165\7684\6A94\6848\4F4D\65BC<a href="%0">\532F\51FA\5132\5B58\5340\57DF</a>\4E2D.  \9664\975E\60A8\8A08\756B\91CD\65B0\5B89\88DD\5B83, \5426\5247\8ACB\4E88\4EE5\79FB\9664.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109297485406313597)
,p_name=>'IN/OUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165/\8F38\51FA')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108913974242313298)
,p_name=>'INACTIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975E\4F5C\7528\4E2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109496344078313748)
,p_name=>'INCLUDE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\62EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110115803305314245)
,p_name=>'INCLUDE_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\62EC: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109113305793313455)
,p_name=>'INDEX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D22\5F15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109493774019313746)
,p_name=>'INDEX_NOUN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D22\5F15')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109057769623313414)
,p_name=>'INITCAP_REFRESH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6574\7406')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109271790359313574)
,p_name=>'INLINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5D4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110061240484314186)
,p_name=>'INLINE_HELP_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5D4C\8AAA\660E\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109271601564313573)
,p_name=>'INLINE_NOTIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5D4C\8207\901A\77E5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109417697919313688)
,p_name=>'INPUT_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\985E\578B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109114081715313456)
,p_name=>'INSERT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D2\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109503123555313753)
,p_name=>'INSERT_EXCEPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D2\5165 wwv_flow_companies \4E2D\767C\751F\7570\5E38\72C0\6CC1:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109433778838313700)
,p_name=>'INSTALLER.APPLICATION_CSS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSS (\61C9\7528\7A0B\5F0F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109433530505313700)
,p_name=>'INSTALLER.APPLICATION_IMAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF (\61C9\7528\7A0B\5F0F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109433975032313701)
,p_name=>'INSTALLER.APPLICATION_STATIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\6A94\6848 (\61C9\7528\7A0B\5F0F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108942830778313320)
,p_name=>'INSTALLER.BUILD_OPTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\5EFA\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109000311962313371)
,p_name=>'INSTALLER.BUILD_OPTIONS_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\53EF\4EE5\9078\64C7\5305\62EC\4E0B\5217\7684\7D44\5EFA\9078\9805.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108942705403313320)
,p_name=>'INSTALLER.CONFIGURATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\66FF\4EE3\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109000224823313371)
,p_name=>'INSTALLER.CONFIGURATION_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\53EF\4EE5\70BA\61C9\7528\7A0B\5F0F\8A2D\5B9A\4E0B\5217\5C6C\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108943049059313320)
,p_name=>'INSTALLER.CONFIRMATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\88DD\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109000554133313371)
,p_name=>'INSTALLER.CONFIRMATION_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\78BA\8A8D\8981\5B89\88DD\6B64\61C9\7528\7A0B\5F0F\7684\652F\63F4\7269\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108943421384313321)
,p_name=>'INSTALLER.CONFIRM_DEINSTALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89E3\9664\5B89\88DD\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108918083054313301)
,p_name=>'INSTALLER.DEINSTALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89E3\9664\5B89\88DD\547D\4EE4\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108943568319313321)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89E3\9664\5B89\88DD\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109000803329313372)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89E3\9664\5B89\88DD\5B8C\6210.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109287704308313590)
,p_name=>'INSTALLER.ERROR.IN_CHECK'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\57F7\884C\5B89\88DD\6AA2\67E5 "%0" \6642\767C\751F\932F\8AA4:'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109287807781313590)
,p_name=>'INSTALLER.ERROR.IN_SCRIPT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\57F7\884C\5B89\88DD\547D\4EE4\6A94 "%0" \6642\767C\751F\932F\8AA4:'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108942663470313320)
,p_name=>'INSTALLER.EXISTENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\5728\6027\6AA2\67E5\5931\6557')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108943265700313321)
,p_name=>'INSTALLER.FAILURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C\7E8C\5B89\88DD\5931\6557')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109000706377313371)
,p_name=>'INSTALLER.FAILURE_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\88DD\8CC7\6599\5EAB\7269\4EF6\548C\7A2E\7C7D\8CC7\6599\5931\6557.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109350109426313637)
,p_name=>'INSTALLER.INSTALL_FAILURE_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\5B89\88DD\7A0B\5F0F\5075\6E2C\5230\6B64\61C9\7528\7A0B\5F0F\7684\652F\63F4\7269\4EF6\4E4B\524D\5DF2\7D93\5B89\88DD. \5FC5\9808\5148\900F\904E SQL \5DE5\4F5C\5BA4\79FB\9664\9019\4E9B\7269\4EF6, \624D\80FD\5B89\88DD\6B64\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108943381108313321)
,p_name=>'INSTALLER.LICENSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108938558544313317)
,p_name=>'INSTALLER.SCRIPT.FAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108938419808313317)
,p_name=>'INSTALLER.SCRIPT.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108943162629313320)
,p_name=>'INSTALLER.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C\7E8C\5B89\88DD\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109000641061313371)
,p_name=>'INSTALLER.SUCCESS_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7D93\5B89\88DD\60A8\61C9\7528\7A0B\5F0F\7684\652F\63F4\7269\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109039623136313401)
,p_name=>'INSTALLER.UPGRADE_CONFIRM_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\78BA\8A8D\8981\5347\7D1A\6B64\61C9\7528\7A0B\5F0F\7684\652F\63F4\7269\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109039547329313400)
,p_name=>'INSTALLER.UPGRADE_FAILURE_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\61C9\7528\7A0B\5F0F\7684\652F\63F4\7269\4EF6\5347\7D1A\5931\6557.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109039142739313400)
,p_name=>'INSTALLER.UPGRADE_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\5B89\88DD\7A0B\5F0F\5075\6E2C\5230\6B64\61C9\7528\7A0B\5F0F\7684\652F\63F4\7269\4EF6\4E4B\524D\5DF2\7D93\5B89\88DD.  \6B64\7CBE\9748\5C07\5F15\5C0E\60A8\5B8C\6210\5347\7D1A\9019\4E9B\652F\63F4\7269\4EF6\7684\6B65\9A5F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109039477454313400)
,p_name=>'INSTALLER.UPGRADE_SUCCESS_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7D93\5347\7D1A\60A8\61C9\7528\7A0B\5F0F\7684\652F\63F4\7269\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108942923171313320)
,p_name=>'INSTALLER.VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109000489888313371)
,p_name=>'INSTALLER.VALIDATION_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\57F7\884C\4E0B\5217\9A57\8B49\4F86\78BA\4FDD\60A8\7684\7CFB\7D71\8207\6B64\61C9\7528\7A0B\5F0F\76F8\5BB9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108942570875313320)
,p_name=>'INSTALLER.WELCOME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B61\8FCE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109000160927313371)
,p_name=>'INSTALLER.WELCOME_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\61C9\7528\7A0B\5F0F\5B89\88DD\7A0B\5F0F\6703\6307\5F15\60A8\5EFA\7ACB\8CC7\6599\5EAB\7269\4EF6\548C\7A2E\7C7D\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109433683481313700)
,p_name=>'INSTALLER.WORKSPACE_CSS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSS (\5DE5\4F5C\5340)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109433433491313700)
,p_name=>'INSTALLER.WORKSPACE_IMAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF (\5DE5\4F5C\5340)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109433811277313701)
,p_name=>'INSTALLER.WORKSPACE_STATIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\6A94\6848 (\5DE5\4F5C\5340)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108930837256313311)
,p_name=>'INSTALL_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\88DD\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109434031773313701)
,p_name=>'INSTALL_SAMPLE_APPS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\88DD\7BC4\4F8B\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109831993435314022)
,p_name=>'INSTANCE_ADMIN_HOME_NAV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle APEX \7BA1\7406\670D\52D9\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109481255541313737)
,p_name=>'INSTANCE_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\8655\7406\8A2D\5B9A\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109383214552313662)
,p_name=>'INST_RUNNING_IN_MAN_MODE_4050'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\57F7\884C\8655\7406\76EE\524D\4EE5\624B\52D5\4F48\5EFA\6A21\5F0F\57F7\884C, \56E0\6B64\4E0D\63A5\53D7\670D\52D9\8981\6C42')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109476393074313733)
,p_name=>'INSUFFICIENT_INSTALL_SPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\9593\4E0D\8DB3, \7121\6CD5\5B89\88DD\6B64\61C9\7528\7A0B\5F0F.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109364428144313648)
,p_name=>'INTEGRATION_COMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6574\5408\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109369611672313652)
,p_name=>'INTEGRATION_SIGNOFF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6574\5408\7C3D\6838')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109360127022313645)
,p_name=>'INTERACTIVE_GRID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\65B9\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109135859836313472)
,p_name=>'INTERACTIVE_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109389695641313667)
,p_name=>'INTERACTIVE_REPORT_SEARCHES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\5831\8868\641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108954894249313330)
,p_name=>'INTERNAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108907182469313293)
,p_name=>'INTERNAL_ADMINISTRATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\90E8\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108956558332313332)
,p_name=>'INTERNAL_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\90E8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109283845425313587)
,p_name=>'INVALID_APPLICATION_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165\4E00\500B\6709\6548\7684\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108913811655313298)
,p_name=>'INVALID_APP_ARCHIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\4E0D\662F\6709\6548\7684\61C9\7528\7A0B\5F0F\5B58\6A94.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109284337123313588)
,p_name=>'INVALID_GROUP_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165\4E00\500B\6709\6548\7684\7FA4\7D44\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108975619384313347)
,p_name=>'INVALID_OBJECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7269\4EF6 %0 \7121\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109637538413313860)
,p_name=>'INVALID_PAGE_GROUP_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165\6709\6548\7684\9801\9762\7FA4\7D44\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110152148470314273)
,p_name=>'INVALID_POSITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\4F4D\7F6E [\672A\5448\73FE]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109502872481313752)
,p_name=>'INVALID_SCHEMA_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\7DB1\8981\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109416626753313688)
,p_name=>'INVALID_SORT_ORDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\9805\76EE\503C\5FC5\7136\662F\6578\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110100901036314232)
,p_name=>'INVALID_USERS_NOT_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\6CE8\610F, %0 \500B\5B57\4E32\70BA\7121\6548\7684\4F7F\7528\8005\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109502765617313752)
,p_name=>'INVALID_WORKSPACE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\5DE5\4F5C\5340\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109443300765313708)
,p_name=>'INVALID_WS_OBJ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684 Web \8A66\7B97\8868\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109441250310313706)
,p_name=>'INVALID_WS_OBJ_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\6B63\7121\6548\7684 Web \8A66\7B97\8868\7269\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109443482839313708)
,p_name=>'INVALID_WS_OBJ_WARNING_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\300CWeb \8A66\7B97\8868\300D\61C9\7528\7A0B\5F0F\6642\6240\9700\7684\8CC7\6599\5EAB\7269\4EF6\7121\6548\6216\4E0D\5B58\5728.  \8ACB\6D3D\8A62\60A8\7684\300C\5DE5\4F5C\5340\7BA1\7406\54E1\300D.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108889059735313279)
,p_name=>'INVERSE2DLINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53CD\5411 2D \6298\7DDA\5716')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109365964191313649)
,p_name=>'IN_PROGRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\884C\4E2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109061728510313417)
,p_name=>'IR_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\5831\8868\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109310169870313607)
,p_name=>'IR_DEVELOPER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\767C\4EBA\54E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109310088318313607)
,p_name=>'IR_END_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109310424960313607)
,p_name=>'IR_INTERACTIVE_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109286570749313589)
,p_name=>'IR_ONLY_ONE_PER_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\500B\9801\9762\4E2D\53EA\80FD\986F\793A\4E00\500B\4E92\52D5\5F0F\5831\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109310265980313607)
,p_name=>'IR_SAVE_ONLY_FOR_DEV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\5C0D\8A71\65B9\584A\50C5\4F9B\958B\767C\4EBA\54E1\4F7F\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109309966127313607)
,p_name=>'IR_SAVE_REPORT_STAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\5831\8868 *')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109310339241313607)
,p_name=>'IR_SAVE_STAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58 *')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110115483622314245)
,p_name=>'IR_SUBSCRIPTION_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F: %0\3001\9801\9762: %1\3001\8A02\95B1\8005: %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109429224011313697)
,p_name=>'IR_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\300C\4E92\52D5\5F0F\5831\8868\300D\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109310515741313607)
,p_name=>'IR_UNITS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\55AE\4F4D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109850649656314036)
,p_name=>'ISSUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\554F\984C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109298159658313598)
,p_name=>'IS_WRAPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\63DB\884C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109409390576313682)
,p_name=>'ITEM CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108987237784313356)
,p_name=>'ITEM NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108954536062313330)
,p_name=>'ITEM.BUTTONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110136158109314261)
,p_name=>'ITEM_COLUMN_SPAN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\9805\76EE\8CC7\6599\6B04\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108974008568313346)
,p_name=>'ITEM_EXP1_EQ_EXP2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F 1 \4E2D\7684\9805\76EE\503C\7B49\65BC\8868\793A\5F0F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108974190682313346)
,p_name=>'ITEM_EXP1_NE_EXP2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F 1 \4E2D\7684\9805\76EE\503C\4E0D\7B49\65BC\8868\793A\5F0F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108973646990313345)
,p_name=>'ITEM_IN_EXP1_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F 1 \4E2D\7684\9805\76EE\4E0D\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108973577852313345)
,p_name=>'ITEM_IN_EXP1_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F 1 \4E2D\7684\9805\76EE\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110114686539314244)
,p_name=>'ITEM_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109031732164313395)
,p_name=>'ITEM_NAME.DATE_PICKER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F\9078\64C7\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109031807886313395)
,p_name=>'ITEM_NAME.HIDDEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109374659650313656)
,p_name=>'ITEM_NAME.NATIVE_AUTO_COMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\542B\81EA\52D5\5B8C\6210\529F\80FD\7684\300C\6587\5B57\6B04\4F4D\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109660330920313879)
,p_name=>'ITEM_NAME.NATIVE_CHECKBOX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6838\53D6\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110030019578314164)
,p_name=>'ITEM_NAME.NATIVE_COLOR_PICKER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69\9078\64C7\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109489981760313743)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F\9078\64C7\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109652565065313872)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_CLASSIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F\9078\64C7\5668 (\4E00\822C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108899214096313286)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_HTML5'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F\9078\64C7\5668 (HTML5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109694717565313918)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_IMAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109654083306313873)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_ONLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109693578379313916)
,p_name=>'ITEM_NAME.NATIVE_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\700F\89BD...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110029883148314164)
,p_name=>'ITEM_NAME.NATIVE_HIDDEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109700437271313922)
,p_name=>'ITEM_NAME.NATIVE_LIST_MANAGER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\7BA1\7406\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109716687593313935)
,p_name=>'ITEM_NAME.NATIVE_MARKDOWN_EDITOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Markdown \7DE8\8F2F\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109644483158313865)
,p_name=>'ITEM_NAME.NATIVE_NUMBER_FIELD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6578\5B57\6B04\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109645960750313866)
,p_name=>'ITEM_NAME.NATIVE_PASSWORD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109653227012313872)
,p_name=>'ITEM_NAME.NATIVE_POPUP_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5373\73FE\5F0F LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109660243098313879)
,p_name=>'ITEM_NAME.NATIVE_RADIOGROUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\9215\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109406103539313680)
,p_name=>'ITEM_NAME.NATIVE_RICH_TEXT_EDITOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Rich Text \7DE8\8F2F\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109652614026313872)
,p_name=>'ITEM_NAME.NATIVE_SELECT_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109654693645313873)
,p_name=>'ITEM_NAME.NATIVE_SHUTTLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F80\8FD4\5207\63DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108920391694313303)
,p_name=>'ITEM_NAME.NATIVE_SLIDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6ED1\687F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109031944237313395)
,p_name=>'ITEM_NAME.NATIVE_STOP_AND_START_HTML_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\6B62\53CA\555F\52D5\65B9\683C\7248\9762\914D\7F6E (\5DF2\88AB\53D6\4EE3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109408134537313681)
,p_name=>'ITEM_NAME.NATIVE_TEXTAREA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110029970956314164)
,p_name=>'ITEM_NAME.NATIVE_TEXT_FIELD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\6B04\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108920047092313302)
,p_name=>'ITEM_NAME.NATIVE_YES_NO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F/\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108981556976313351)
,p_name=>'ITEM_NAME.PLUGIN'
,p_message_language=>'zh-tw'
,p_message_text=>'Plug-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109032022131313395)
,p_name=>'ITEM_NAME.POPUP_LIST_OF_VALUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5373\73FE\5F0F\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109669327524313887)
,p_name=>'ITEM_NAME.STAR_RATING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\7D1A\8A55\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109032137438313395)
,p_name=>'ITEM_NAME.TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110069544031314192)
,p_name=>'ITEM_POST_TEXT_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\5F8C\7E8C\6587\5B57\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110069441790314192)
,p_name=>'ITEM_PRE_TEXT_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\524D\7F6E\6587\5B57\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109434651479313701)
,p_name=>'ITEM_ROW_2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109434787721313701)
,p_name=>'ITEM_ROW_3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109434806655313701)
,p_name=>'ITEM_ROW_4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109434985694313701)
,p_name=>'ITEM_ROW_5'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109644392862313865)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MAX_VALUE_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\9805\76EE %1 \8F38\5165\7684\6700\5927\503C %0 \4E0D\662F\6578\503C. \5982\679C\503C\5305\542B\5C0F\6578\4F4D\6578, \8ACB\6307\5B9A\53E5\865F\4F5C\70BA\5C0F\6578\5340\9694\7B26\865F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109644249925313865)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MIN_VALUE_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\9805\76EE %1 \8F38\5165\7684\6700\5C0F\503C %0 \4E0D\662F\6578\503C. \5982\679C\503C\5305\542B\5C0F\6578\4F4D\6578, \8ACB\6307\5B9A\53E5\865F\4F5C\70BA\5C0F\6578\5340\9694\7B26\865F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108920206656313303)
,p_name=>'ITEM_TYPE.ATTRIBUTE.STEP_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\9805\76EE %1 \8F38\5165\7684\9593\9694\503C %0 \4E0D\662F\6578\503C. \5982\679C\503C\5305\542B\5C0F\6578\4F4D\6578, \8ACB\6307\5B9A\53E5\865F\4F5C\70BA\5C0F\6578\5340\9694\7B26\865F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108981917369313352)
,p_name=>'ITEM_TYPE.BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108982062933313352)
,p_name=>'ITEM_TYPE.FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\700F\89BD...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108982128634313352)
,p_name=>'ITEM_TYPE.HIDDEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108982212050313352)
,p_name=>'ITEM_TYPE.HIDDEN_PROTECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF\4E26\53D7\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108982330639313352)
,p_name=>'ITEM_TYPE.POPUP_COLOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5373\73FE\5F0F\8272\5F69\9078\64C7\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108982409394313352)
,p_name=>'ITEM_TYPE.TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\6B04\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108982542257313352)
,p_name=>'ITEM_TYPE.TEXT_DISABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\6B04\4F4D (\505C\7528, \4E0D\5132\5B58\72C0\614B)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108982656612313352)
,p_name=>'ITEM_TYPE.TEXT_DISABLED_AND_SAVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\6B04\4F4D (\505C\7528, \5132\5B58\72C0\614B)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108982721571313352)
,p_name=>'ITEM_TYPE.TEXT_WITH_ENTER_SUBMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\6B04\4F4D (\6309 Enter \6642\4E00\5F8B\9001\51FA\9801\9762)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109359986344313644)
,p_name=>'JET_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JET \5716\8868')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109295323284313596)
,p_name=>'JOB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109361156674313645)
,p_name=>'JQM COLUMN TOGGLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\5207\63DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109361010286313645)
,p_name=>'JQM REFLOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56DE\6D41\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109436629382313703)
,p_name=>'JQM_FOOTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109436566848313703)
,p_name=>'JQM_HEADER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109363020210313647)
,p_name=>'JQM_LIST_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\6AA2\8996')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109360228531313645)
,p_name=>'JSTREE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Javascript \6A39\72C0\7D50\69CB')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109386349702313665)
,p_name=>'JUSTIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7406\7531')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109850781798314036)
,p_name=>'LABELS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110136087571314261)
,p_name=>'LABEL_COLUMN_SPAN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\6A19\7C64\8CC7\6599\6B04\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110129680499314256)
,p_name=>'LABEL_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\9805\76EE\6A19\7C64 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109423104904313692)
,p_name=>'LABEL_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109088152320313437)
,p_name=>'LABEL_TEMPLATE.COPIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\61C9\7528\7A0B\5F0F\8907\88FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109088249038313437)
,p_name=>'LABEL_TEMPLATE.MASTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\662F\6B64\6A23\677F\7684\4E3B\672C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109088413223313437)
,p_name=>'LABEL_TEMPLATE.NO_SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\8A02\95B1\6B64\6A23\677F\7684\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109088311214313437)
,p_name=>'LABEL_TEMPLATE.REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1\6B64\6A23\677F\7684\6A19\7C64\6A23\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108931306998313311)
,p_name=>'LANGUAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109389158184313667)
,p_name=>'LAST_CHANGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\6B21\8B8A\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109296604261313597)
,p_name=>'LAST_ENTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\500B\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109392058728313669)
,p_name=>'LAST_LOGIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\6B21\767B\5165\6642\9593')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108908748018313294)
,p_name=>'LAYOUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 - \7248\9762\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108945704699313323)
,p_name=>'LAYOUT.AFTER_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\9AD4\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109285038976313588)
,p_name=>'LAYOUT.AFTER_ERROR_HEADER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\932F\8AA4\8A0A\606F\9801\9762\6A19\982D\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109284742591313588)
,p_name=>'LAYOUT.AFTER_FOOTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\5C3E\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109351071476313638)
,p_name=>'LAYOUT.AFTER_HEADER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109699609836313921)
,p_name=>'LAYOUT.AFTER_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109634248071313858)
,p_name=>'LAYOUT.AFTER_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109634663694313858)
,p_name=>'LAYOUT.AFTER_LABEL_AND_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\6A19\7C64\548C\9805\76EE\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109036067578313398)
,p_name=>'LAYOUT.AFTER_LOGIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109275584984313581)
,p_name=>'LAYOUT.AFTER_PROCESSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109284528331313588)
,p_name=>'LAYOUT.AFTER_REGIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5340\57DF\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109284854923313588)
,p_name=>'LAYOUT.AFTER_SUBMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108945689152313323)
,p_name=>'LAYOUT.BEFORE_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\9AD4\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109275241735313581)
,p_name=>'LAYOUT.BEFORE_COMPUTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109285138291313588)
,p_name=>'LAYOUT.BEFORE_ERROR_FOOTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\932F\8AA4\8A0A\606F\9801\9762\8868\5C3E\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109284609905313588)
,p_name=>'LAYOUT.BEFORE_FOOTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\5C3E\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109275166298313581)
,p_name=>'LAYOUT.BEFORE_HEADER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109699506830313921)
,p_name=>'LAYOUT.BEFORE_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109634174494313858)
,p_name=>'LAYOUT.BEFORE_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109634547975313858)
,p_name=>'LAYOUT.BEFORE_LABEL_AND_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\6A19\7C64\548C\9805\76EE\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109275418142313581)
,p_name=>'LAYOUT.BEFORE_PROCESSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109284414664313588)
,p_name=>'LAYOUT.BEFORE_REGIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5340\57DF\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109275383322313581)
,p_name=>'LAYOUT.BEFORE_VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109344734630313633)
,p_name=>'LAYOUT.BRANCHES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109026780063313391)
,p_name=>'LAYOUT.BUTTON.ABOVE_BOX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\584A\4E0A\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109026878833313391)
,p_name=>'LAYOUT.BUTTON.BELOW_BOX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\584A\4E0B\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109026900593313391)
,p_name=>'LAYOUT.BUTTON.BOTTOM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E95\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109027030924313391)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CHANGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109027101616313391)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CLOSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109027297083313391)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_COPY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109027351489313391)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109027445402313391)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109027502773313392)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109027648627313392)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EXPAND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64F4\5145\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109027750556313392)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\500B\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109027813680313392)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_PREVIOUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\500B\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109027977241313392)
,p_name=>'LAYOUT.BUTTON.TOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9802\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109267971928313571)
,p_name=>'LAYOUT.CHANGE_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109338633694313629)
,p_name=>'LAYOUT.CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109487458782313741)
,p_name=>'LAYOUT.CHART_SERIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6578\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109267160358313570)
,p_name=>'LAYOUT.CLOSE_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109267602027313571)
,p_name=>'LAYOUT.COPY_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109267395599313570)
,p_name=>'LAYOUT.CREATE2_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Create2 \6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108899472719313287)
,p_name=>'LAYOUT.CUSTOM_POSITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109487194678313741)
,p_name=>'LAYOUT.DA_EVENT_FALSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\507D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109487208978313741)
,p_name=>'LAYOUT.DA_EVENT_TRUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\771F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109267540745313570)
,p_name=>'LAYOUT.DELETE_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109704020415313925)
,p_name=>'LAYOUT.EMPTY_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\767D\6A19\7C64 - #0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110111688664314242)
,p_name=>'LAYOUT.ERROR_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109267236013313570)
,p_name=>'LAYOUT.EXPAND_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C55\958B\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109209296805313527)
,p_name=>'LAYOUT.FUNCTION_RETURNING_SQL_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109487581468313741)
,p_name=>'LAYOUT.GLOBAL_PAGE_REGION_PREFIX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\57DF\9801\9762: ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109267457502313570)
,p_name=>'LAYOUT.HELP_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109699736065313921)
,p_name=>'LAYOUT.HELP_LINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\8AAA\660E\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109704165778313925)
,p_name=>'LAYOUT.HIDDEN_FIELD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF - #0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109209148239313527)
,p_name=>'LAYOUT.HTML_TEXT_ESCAPE_SC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \6587\5B57\9041\96E2\7279\6B8A\5B57\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110061175289314186)
,p_name=>'LAYOUT.INLINE_HELP_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5D4C\8AAA\660E\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110069703437314192)
,p_name=>'LAYOUT.ITEM_POST_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\5F8C\7E8C\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110069611026314192)
,p_name=>'LAYOUT.ITEM_PRE_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\524D\7F6E\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109267771972313571)
,p_name=>'LAYOUT.NEXT_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\500B\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109344684099313633)
,p_name=>'LAYOUT.NOREGION_AT_DISP_POINT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\4F4D\7F6E\4E0A\6C92\6709\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109487631099313741)
,p_name=>'LAYOUT.NO_REGION_ASSIGNED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\300C\5340\57DF\300D\7684\300C\9801\9762\9805\76EE\300D\548C\300C\6309\9215\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109377379220313658)
,p_name=>'LAYOUT.ON_DEMAND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Ajax \56DE\547C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109634450762313858)
,p_name=>'LAYOUT.ON_ERROR_AFTER_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\6A19\7C64\4E4B\5F8C\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109634373593313858)
,p_name=>'LAYOUT.ON_ERROR_BEFORE_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\9801\7C64\4E4B\524D\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109277627784313583)
,p_name=>'LAYOUT.ON_NEW_INSTANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\65B0\57F7\884C\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109277767995313583)
,p_name=>'LAYOUT.ON_SUBMIT_BEFORE_COMPUTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\9001\51FA\6642\548C\904B\7B97\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109267887437313571)
,p_name=>'LAYOUT.PREVIOUS_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\500B\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109487857940313741)
,p_name=>'LAYOUT.PROCESSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5728\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108876886307313269)
,p_name=>'LAYOUT.REGION_POS_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109487967614313741)
,p_name=>'LAYOUT.REGION_POS_BODY_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\9AD4 (#0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109488056767313742)
,p_name=>'LAYOUT.REGION_POS_NUMBER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E #0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109487394644313741)
,p_name=>'LAYOUT.REPORT_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109490230925313743)
,p_name=>'LAYOUT.RUN_JAVASCRIPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109209392771313527)
,p_name=>'LAYOUT.SIMPLE_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C21\55AE\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109209637378313527)
,p_name=>'LAYOUT.STRUCTURED_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\69CB\5316\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109490158947313743)
,p_name=>'LAYOUT.SUBMIT_AS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\70BA "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109361619199313646)
,p_name=>'LAYOUT.SUB_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B50\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109209581950313527)
,p_name=>'LAYOUT.SVG_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SVG \5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108994335987313366)
,p_name=>'LAYOUT.T_#APEX_CSS#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('&PRODUCT_NAME. \4F7F\7528\7684\968E\5C64\5F0F\6A23\5F0F\8868\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108994707887313367)
,p_name=>'LAYOUT.T_#APEX_JAVASCRIPT#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('&PRODUCT_NAME. \4F7F\7528\7684 JavaScript \6A94\6848\8207\7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110113708753314243)
,p_name=>'LAYOUT.T_#APPLICATION_CSS#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762\5C64\7D1A\4E0A\5B9A\7FA9\7684\968E\5C64\5F0F\6A23\5F0F\8868\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108994915397313367)
,p_name=>'LAYOUT.T_#APPLICATION_JAVASCRIPT#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762\5C64\7D1A\4E0A\5B9A\7FA9\7684 JavaScript \6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109440436374313706)
,p_name=>'LAYOUT.T_#DIALOG_ATTRIBUTES#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\8A71\65B9\584A\5C6C\6027, \7528\4F86\5B9A\7FA9\7121\6CD5\4EE5\5BA3\544A\65B9\5F0F\652F\63F4\7684\5C0D\8A71\65B9\584A\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110062858141314187)
,p_name=>'LAYOUT.T_#DIALOG_CSS_CLASSES#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\8A71\65B9\584A CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109440088651313705)
,p_name=>'LAYOUT.T_#DIALOG_HEIGHT#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\8A71\65B9\584A\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109440247072313705)
,p_name=>'LAYOUT.T_#DIALOG_MAX_WIDTH#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\8A71\65B9\584A\5BEC\5EA6\4E0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109440130385313705)
,p_name=>'LAYOUT.T_#DIALOG_WIDTH#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\8A71\65B9\584A\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110134540736314260)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_NAV_LABEL#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C55\958B/\96B1\85CF\5C0E\89BD\7684\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110134617795314260)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_SIDE_COL_LABEL#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C55\958B/\96B1\85CF\5074\908A\8CC7\6599\6B04\7684\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110104078120314235)
,p_name=>'LAYOUT.T_#FAVICONS#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Favicon HTML \7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108994668940313367)
,p_name=>'LAYOUT.T_#GENERATED_CSS#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6\5373\6642\5EFA\7ACB\7684\968E\5C64\5F0F\6A23\5F0F\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108995023439313367)
,p_name=>'LAYOUT.T_#GENERATED_JAVASCRIPT#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6\5373\6642\5EFA\7ACB\7684 JavaScript \7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109440309307313706)
,p_name=>'LAYOUT.T_#IS_MODAL#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\8A71\65B9\584A\9801\9762\6A21\5F0F (\4F8B\5982, ''true'' \4EE3\8868\5F37\5236\56DE\61C9, ''false'' \4EE3\8868\975E\5F37\5236\56DE\61C9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108994591203313366)
,p_name=>'LAYOUT.T_#PAGE_CSS#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5C64\7D1A\4E0A\5B9A\7FA9\7684\968E\5C64\5F0F\6A23\5F0F\8868\6A94\6848\8207\5167\5D4C\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108988208938313357)
,p_name=>'LAYOUT.T_#PAGE_CSS_CLASSES#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109643636771313865)
,p_name=>'LAYOUT.T_#PAGE_JAVASCRIPT#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5C64\7D1A\4E0A\5B9A\7FA9\7684 JavaScript \6A94\6848\8207\7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108906471967313292)
,p_name=>'LAYOUT.T_#PAGE_STATIC_ID#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\975C\614B ID (\4F8B\5982 ''P100'')')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108902836837313289)
,p_name=>'LAYOUT.T_#PAGE_TRANSITION#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7528\4F86\700F\89BD\65B0\9801\9762\7684\8F49\63DB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109439977898313705)
,p_name=>'LAYOUT.T_#PAGE_URL#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108902945310313289)
,p_name=>'LAYOUT.T_#POPUP_TRANSITION#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7528\4F86\958B\555F\5373\73FE\5F0F\8996\7A97\7684\8F49\63DB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109443129423313708)
,p_name=>'LAYOUT.T_#REQUESTED_URL#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\5668\8981\6C42\7684\9801\9762 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110113988700314244)
,p_name=>'LAYOUT.T_#SIDE_GLOBAL_NAVIGATION_LIST#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\529F\80FD\8868 (\5074\908A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108994491997313366)
,p_name=>'LAYOUT.T_#TEMPLATE_CSS#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F\4E2D\5B9A\7FA9\7684\968E\5C64\5F0F\6A23\5F0F\8868\6A94\6848\8207\5167\5D4C\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108994845128313367)
,p_name=>'LAYOUT.T_#TEMPLATE_JAVASCRIPT#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F\4E2D\5B9A\7FA9\7684 JavaScript \6A94\6848\8207\7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108995153285313367)
,p_name=>'LAYOUT.T_#THEME_CSS#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\5C64\7D1A\4E0A\6240\5B9A\7FA9\7684\968E\5C64\5F0F\6A23\5F0F\8868\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110122775176314250)
,p_name=>'LAYOUT.T_#THEME_JAVASCRIPT#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\5C64\7D1A\4E0A\5B9A\7FA9\7684 JavaScript \6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110122828819314251)
,p_name=>'LAYOUT.T_#THEME_STYLE_CSS#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\6A23\5F0F\5C64\7D1A\4E0A\5B9A\7FA9\7684\968E\5C64\5F0F\6A23\5F0F\8868\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110113848646314243)
,p_name=>'LAYOUT.T_#TOP_GLOBAL_NAVIGATION_LIST#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\529F\80FD\8868 (\9802\7AEF)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109440521165313706)
,p_name=>'LAYOUT.T_#TRIGGERING_ELEMENT#'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89F8\767C\5143\7D20 (\4F8B\5982, \76EE\524D\7684 DOM \5143\7D20)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109053515830313411)
,p_name=>'LAYOUT.T_ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109643718934313865)
,p_name=>'LAYOUT.T_AFFECTED_ELEMENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D7\5F71\97FF\7684\5143\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109050540559313409)
,p_name=>'LAYOUT.T_ALT_APPLICATION_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109046523784313406)
,p_name=>'LAYOUT.T_ALT_ARROW_DOWN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109050102001313408)
,p_name=>'LAYOUT.T_ALT_BODY_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\9AD4\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109045907474313405)
,p_name=>'LAYOUT.T_ALT_BRANCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109046606064313406)
,p_name=>'LAYOUT.T_ALT_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109049281214313408)
,p_name=>'LAYOUT.T_ALT_CHANGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109048395602313407)
,p_name=>'LAYOUT.T_ALT_CLOSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109050609187313409)
,p_name=>'LAYOUT.T_ALT_COMPANY_IMG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109045785565313405)
,p_name=>'LAYOUT.T_ALT_COMPUTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109048955449313407)
,p_name=>'LAYOUT.T_ALT_COPY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109048119836313407)
,p_name=>'LAYOUT.T_ALT_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109048216779313407)
,p_name=>'LAYOUT.T_ALT_CREATE2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109048841074313407)
,p_name=>'LAYOUT.T_ALT_DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109047913661313407)
,p_name=>'LAYOUT.T_ALT_EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109048075530313407)
,p_name=>'LAYOUT.T_ALT_EXPAND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C55\958B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109048605308313407)
,p_name=>'LAYOUT.T_ALT_FORM_CLOSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109048539574313407)
,p_name=>'LAYOUT.T_ALT_FORM_OPEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE\958B\555F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109049724306313408)
,p_name=>'LAYOUT.T_ALT_GLOBAL_NOTIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\57DF\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109048759589313407)
,p_name=>'LAYOUT.T_ALT_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109046729298313406)
,p_name=>'LAYOUT.T_ALT_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109049589901313408)
,p_name=>'LAYOUT.T_ALT_NAV_BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109049081057313408)
,p_name=>'LAYOUT.T_ALT_NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109049669360313408)
,p_name=>'LAYOUT.T_ALT_NOTIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109050480966313409)
,p_name=>'LAYOUT.T_ALT_PARENT_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109049130686313408)
,p_name=>'LAYOUT.T_ALT_PREVIOUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109045631988313405)
,p_name=>'LAYOUT.T_ALT_PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109045584562313405)
,p_name=>'LAYOUT.T_ALT_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109048450008313407)
,p_name=>'LAYOUT.T_ALT_REGION_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109050278785313408)
,p_name=>'LAYOUT.T_ALT_REGION_POSITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109047863280313407)
,p_name=>'LAYOUT.T_ALT_REGION_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109050328111313408)
,p_name=>'LAYOUT.T_ALT_STD_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109049949140313408)
,p_name=>'LAYOUT.T_ALT_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109049880376313408)
,p_name=>'LAYOUT.T_ALT_TEMPLATE_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109050039190313408)
,p_name=>'LAYOUT.T_ALT_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109045853204313405)
,p_name=>'LAYOUT.T_ALT_VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\9A57\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109045459137313405)
,p_name=>'LAYOUT.T_ALT_WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109490858750313744)
,p_name=>'LAYOUT.T_AUTHORIZATION_SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110111190227314241)
,p_name=>'LAYOUT.T_BC_LABEL_ESC_SC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\6A19\7C64 (\9041\96E2 HTML \5B57\5143)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109701414553313923)
,p_name=>'LAYOUT.T_BIND_EVENT_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('When \4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109051013095313409)
,p_name=>'LAYOUT.T_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108938304835313317)
,p_name=>'LAYOUT.T_BRANCH2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109043845293313404)
,p_name=>'LAYOUT.T_BRANCHING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\652F\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109492203541313745)
,p_name=>'LAYOUT.T_BRANCH_ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\652F\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109028372191313392)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\652F\5230\50B3\56DE\9801\9762\7684\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109028445129313392)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_URL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\652F\5230\50B3\56DE URL \7684\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109028020969313392)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_ACCEPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\5230\5206\652F\9801\9762\63A5\53D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109028144850313392)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_IDENTIFIED_BY_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\5230\7531\9805\76EE\8B58\5225\7684\5206\652F\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109054076167313411)
,p_name=>'LAYOUT.T_BRANCH_TO_PG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D\5F80\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109028563140313392)
,p_name=>'LAYOUT.T_BRANCH_TO_PLSQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\652F\5230 PL/SQL \7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109028228136313392)
,p_name=>'LAYOUT.T_BRANCH_TO_URL_IDENTIFIED_BY_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\5230\7531\9805\76EE\8B58\5225\7684\5206\652F URL')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109490924496313744)
,p_name=>'LAYOUT.T_BUILD_OPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\5EFA\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109042554499313403)
,p_name=>'LAYOUT.T_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109053943514313411)
,p_name=>'LAYOUT.T_BUTTON2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109491642110313744)
,p_name=>'LAYOUT.T_BUTTON_ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109669839955313888)
,p_name=>'LAYOUT.T_BUTTON_EXECUTE_VAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\9A57\8B49\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109047433146313406)
,p_name=>'LAYOUT.T_BUTTON_W_NO_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\9644\5E36\5340\57DF\7684\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109492013581313744)
,p_name=>'LAYOUT.T_CHART_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109491989931313744)
,p_name=>'LAYOUT.T_COLUMN_HEADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110110973454314241)
,p_name=>'LAYOUT.T_COMPONENT_CSS_CLASSES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6 CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109042733108313403)
,p_name=>'LAYOUT.T_COMPUTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109054662595313412)
,p_name=>'LAYOUT.T_COMPUTATION2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109042857392313403)
,p_name=>'LAYOUT.T_COMPUTATION_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 0 \4E0D\652F\63F4\904B\7B97.  \6BCF\500B\9801\9762\7684\904B\7B97\61C9\8A72\7531\61C9\7528\7A0B\5F0F\5C64\7D1A\904B\7B97\4F86\8655\7406.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109491332279313744)
,p_name=>'LAYOUT.T_COMPUTATION_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109053604623313411)
,p_name=>'LAYOUT.T_CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109490620396313743)
,p_name=>'LAYOUT.T_CONDITION_EXPR1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109490719095313743)
,p_name=>'LAYOUT.T_CONDITION_EXPR2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109490520587313743)
,p_name=>'LAYOUT.T_CONDITION_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\689D\4EF6\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109040867557313401)
,p_name=>'LAYOUT.T_COPY_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109040626239313401)
,p_name=>'LAYOUT.T_CREATE_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110109056166314240)
,p_name=>'LAYOUT.T_CURRENT_PROGRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\884D\751F\81EA <em>APEX.CURRENT_PROGRESS</em> \5167\90E8\6587\5B57\8A0A\606F (\9810\8A2D\70BA<em>\76EE\524D\9032\5EA6</em>).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109051516940313409)
,p_name=>'LAYOUT.T_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109053810226313411)
,p_name=>'LAYOUT.T_DISPLAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109491770456313744)
,p_name=>'LAYOUT.T_DISPLAY_AS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109042328558313403)
,p_name=>'LAYOUT.T_DISPLAY_PT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\9EDE:&nbsp;')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110039995554314172)
,p_name=>'LAYOUT.T_DYNAMIC_ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109040728548313401)
,p_name=>'LAYOUT.T_EDIT_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108938209651313317)
,p_name=>'LAYOUT.T_EDIT_PAGE_IN_BUILDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7522\751F\5668\4E2D\7684\7DE8\8F2F\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109025993249313390)
,p_name=>'LAYOUT.T_EDIT_REGION_ATTRIBUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\5340\57DF\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109026578094313391)
,p_name=>'LAYOUT.T_ERROR_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\8A0A\606F\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109053704870313411)
,p_name=>'LAYOUT.T_EXP'
,p_message_language=>'zh-tw'
,p_message_text=>'exp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109045386225313405)
,p_name=>'LAYOUT.T_FLOW_NO_BRANCHING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109045036946313404)
,p_name=>'LAYOUT.T_FLOW_NO_COMPUTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109044878237313404)
,p_name=>'LAYOUT.T_FLOW_NO_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9078\53D6\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109045180670313405)
,p_name=>'LAYOUT.T_FLOW_NO_PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109044963770313404)
,p_name=>'LAYOUT.T_FLOW_NO_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109045243689313405)
,p_name=>'LAYOUT.T_FLOW_NO_VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\9A57\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109051168780313409)
,p_name=>'LAYOUT.T_FOOTER_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\5C3E\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109052499846313410)
,p_name=>'LAYOUT.T_FORM_CLOSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \8868\55AE\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109051948151313410)
,p_name=>'LAYOUT.T_FORM_OPEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \8868\55AE\958B\555F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109051473806313409)
,p_name=>'LAYOUT.T_FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109043343179313403)
,p_name=>'LAYOUT.T_GLOBAL_PAGE_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\57DF\9801\9762\4E0D\652F\63F4\5206\652F\3001\904B\7B97\3001\8655\7406\4F5C\696D\6216\9A57\8B49.  \6BCF\500B\9801\9762\7684\904B\7B97\548C\8655\7406\4F5C\696D\61C9\8A72\7531\61C9\7528\7A0B\5F0F\5C64\7D1A\904B\7B97\548C\8655\7406\4F5C\696D\4F86\8655\7406.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109703830192313925)
,p_name=>'LAYOUT.T_GRID_COLUMN_NO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\683C\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109422737422313692)
,p_name=>'LAYOUT.T_GRID_COLUMN_SPAN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\683C\8CC7\6599\6B04\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109050993609313409)
,p_name=>'LAYOUT.T_HEADER_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109026315063313391)
,p_name=>'LAYOUT.T_INLINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5D4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109026229525313391)
,p_name=>'LAYOUT.T_INLINE_PLUS_NOTIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5D4C+\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109041553842313402)
,p_name=>'LAYOUT.T_INVALID_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109042673615313403)
,p_name=>'LAYOUT.T_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109374715884313656)
,p_name=>'LAYOUT.T_ITEM2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109047759426313406)
,p_name=>'LAYOUT.T_ITEM_EXCEEDS_MAX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\8A08\6578\8D85\904E 200 \4E0A\9650\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109491810220313744)
,p_name=>'LAYOUT.T_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108912071535313296)
,p_name=>'LAYOUT.T_LISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110095328835314212)
,p_name=>'LAYOUT.T_LIST_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\552F\4E00\6E05\55AE ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109026609073313391)
,p_name=>'LAYOUT.T_LOCATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109070649175313423)
,p_name=>'LAYOUT.T_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108911999024313296)
,p_name=>'LAYOUT.T_MENUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109703902109313925)
,p_name=>'LAYOUT.T_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109054268424313411)
,p_name=>'LAYOUT.T_NAVIGATE_TO_PG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109044518488313404)
,p_name=>'LAYOUT.T_NAV_BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109369797370313652)
,p_name=>'LAYOUT.T_NAV_LISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\529F\80FD\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109028945915313393)
,p_name=>'LAYOUT.T_NEVER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\4E0D\6210\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109422450287313692)
,p_name=>'LAYOUT.T_NEW_GRID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\65B0\7DB2\683C\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109422611772313692)
,p_name=>'LAYOUT.T_NEW_GRID_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\65B0\7DB2\683C\8CC7\6599\6B04\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109422537016313692)
,p_name=>'LAYOUT.T_NEW_GRID_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\65B0\7DB2\683C\8CC7\6599\5217\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109050812524313409)
,p_name=>'LAYOUT.T_NO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109028605045313392)
,p_name=>'LAYOUT.T_NONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109026408833313391)
,p_name=>'LAYOUT.T_NOTIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109052015280313410)
,p_name=>'LAYOUT.T_NOTIFICATION_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\901A\77E5\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109043905444313404)
,p_name=>'LAYOUT.T_NO_BRANCHING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 "%0" \6C92\6709\5206\652F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109047502019313406)
,p_name=>'LAYOUT.T_NO_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 "%0" \6C92\6709\6309\9215.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109047636046313406)
,p_name=>'LAYOUT.T_NO_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 "%0" \6C92\6709\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108912242811313296)
,p_name=>'LAYOUT.T_NO_LISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\4F7F\7528\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109070779879313423)
,p_name=>'LAYOUT.T_NO_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\4F7F\7528\5171\7528\7684\503C\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108912313654313296)
,p_name=>'LAYOUT.T_NO_MENUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\4F7F\7528\5C0E\89BD\8DEF\5F91.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109044673254313404)
,p_name=>'LAYOUT.T_NO_NAV_BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F "%0" \6C92\6709\5C0E\89BD\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109043092349313403)
,p_name=>'LAYOUT.T_NO_ONLOAD_COMPUTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 "%0" \6C92\6709 onLoad \904B\7B97.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109043261275313403)
,p_name=>'LAYOUT.T_NO_ONLOAD_PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 "%0" \6C92\6709 onLoad \8655\7406\4F5C\696D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109043460876313403)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_COMPUTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 "%0" \6C92\6709 onSubmit \904B\7B97.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109043713050313404)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 "%0" \6C92\6709 onSubmit \8655\7406\4F5C\696D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109040409795313401)
,p_name=>'LAYOUT.T_NO_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9078\53D6\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109044145329313404)
,p_name=>'LAYOUT.T_NO_PARENT_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\7236\9805\5C64\7D1A\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109042455546313403)
,p_name=>'LAYOUT.T_NO_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 "%0" \6C92\6709\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109044431218313404)
,p_name=>'LAYOUT.T_NO_TAB_SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 %0 \6C92\6709\9801\7C64\96C6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109070837371313424)
,p_name=>'LAYOUT.T_NO_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\4F7F\7528\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109043624162313403)
,p_name=>'LAYOUT.T_NO_VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 "%0" \6C92\6709\9A57\8B49.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109026019969313390)
,p_name=>'LAYOUT.T_NUMBER_OF_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109040545603313401)
,p_name=>'LAYOUT.T_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109041355855313402)
,p_name=>'LAYOUT.T_PAGE_ALIAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109041905534313402)
,p_name=>'LAYOUT.T_PAGE_AUTHENTICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109041746261313402)
,p_name=>'LAYOUT.T_PAGE_AUTHORIZATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109052264957313410)
,p_name=>'LAYOUT.T_PAGE_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109052344778313410)
,p_name=>'LAYOUT.T_PAGE_BODY_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\4E3B\9AD4\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109041819201313402)
,p_name=>'LAYOUT.T_PAGE_BUILD_OPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\5EFA\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109051896197313410)
,p_name=>'LAYOUT.T_PAGE_HEAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A19\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109041101689313402)
,p_name=>'LAYOUT.T_PAGE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109041095324313402)
,p_name=>'LAYOUT.T_PAGE_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109051656609313409)
,p_name=>'LAYOUT.T_PAGE_ONLOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8F09\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109042006883313402)
,p_name=>'LAYOUT.T_PAGE_PUBLIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109042121924313402)
,p_name=>'LAYOUT.T_PAGE_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109041687396313402)
,p_name=>'LAYOUT.T_PAGE_TABSET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\6E96\9801\7C64\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109041461992313402)
,p_name=>'LAYOUT.T_PAGE_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109041243375313402)
,p_name=>'LAYOUT.T_PAGE_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109051764517313410)
,p_name=>'LAYOUT.T_PAGE_TITLE2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109044054981313404)
,p_name=>'LAYOUT.T_PARENT_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109043191904313403)
,p_name=>'LAYOUT.T_PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109054570550313412)
,p_name=>'LAYOUT.T_PROCESS2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109042950044313403)
,p_name=>'LAYOUT.T_PROCESS_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 0 \4E0D\652F\63F4\8655\7406\4F5C\696D.  \6BCF\500B\9801\9762\7684\8655\7406\4F5C\696D\61C9\8A72\7531\61C9\7528\7A0B\5F0F\5C64\7D1A\8655\7406\4F5C\696D\4F86\8655\7406.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109492120917313744)
,p_name=>'LAYOUT.T_PROCESS_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4F5C\696D\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109054165460313411)
,p_name=>'LAYOUT.T_REDIRECT_TO_PG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D\5F80\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109051396104313409)
,p_name=>'LAYOUT.T_REFERENCED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\53C3\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110111056147314241)
,p_name=>'LAYOUT.T_REFERENCED_FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\7167\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109042294620313402)
,p_name=>'LAYOUT.T_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109054922512313412)
,p_name=>'LAYOUT.T_REGION2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109363223209313647)
,p_name=>'LAYOUT.T_REGION_ATTRIBUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108902488687313289)
,p_name=>'LAYOUT.T_REGION_CSS_CLASSES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109362072310313646)
,p_name=>'LAYOUT.T_REGION_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\552F\4E00\7684\5340\57DF ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109421333517313691)
,p_name=>'LAYOUT.T_REGION_POS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109052573451313410)
,p_name=>'LAYOUT.T_REGION_POS1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109356907935313642)
,p_name=>'LAYOUT.T_REGION_POS10'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109357076950313642)
,p_name=>'LAYOUT.T_REGION_POS11'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E 11')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109357138970313642)
,p_name=>'LAYOUT.T_REGION_POS12'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E 12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109357290500313642)
,p_name=>'LAYOUT.T_REGION_POS13'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E 13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109357370545313642)
,p_name=>'LAYOUT.T_REGION_POS14'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E 14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109357454677313642)
,p_name=>'LAYOUT.T_REGION_POS15'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E 15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109357523124313643)
,p_name=>'LAYOUT.T_REGION_POS16'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E 16')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109052645567313410)
,p_name=>'LAYOUT.T_REGION_POS2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109052733454313410)
,p_name=>'LAYOUT.T_REGION_POS3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109052888454313410)
,p_name=>'LAYOUT.T_REGION_POS4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109052972974313410)
,p_name=>'LAYOUT.T_REGION_POS5'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109053083677313410)
,p_name=>'LAYOUT.T_REGION_POS6'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109053188602313411)
,p_name=>'LAYOUT.T_REGION_POS7'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109053238702313411)
,p_name=>'LAYOUT.T_REGION_POS8'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109356888137313642)
,p_name=>'LAYOUT.T_REGION_POS9'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109362182821313646)
,p_name=>'LAYOUT.T_REGION_STATIC_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\975C\614B ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109703736782313925)
,p_name=>'LAYOUT.T_REGION_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109028867182313392)
,p_name=>'LAYOUT.T_STANDARD_CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\6E96\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109044222168313404)
,p_name=>'LAYOUT.T_STD_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\6E96\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109051277570313409)
,p_name=>'LAYOUT.T_SUBSTITUTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66FF\4EE3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109362874709313647)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_ENTRY_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B50\5340\57DF - \6A19\982D\9805\76EE\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109362936968313647)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B50\5340\57DF - \6A19\982D\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109362746970313646)
,p_name=>'LAYOUT.T_SUB_PLUG_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B50\5340\57DF - \6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109362593294313646)
,p_name=>'LAYOUT.T_SUB_REGIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B50\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109362631344313646)
,p_name=>'LAYOUT.T_SUB_REGION_HEADERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B50\5340\57DF\6A19\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109362429565313646)
,p_name=>'LAYOUT.T_SUB_REGION_HEADER_ENTRIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B50\5340\57DF\6A19\982D\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109362276292313646)
,p_name=>'LAYOUT.T_SUB_REGION_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B50\5340\57DF\7684\975C\614B ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109362350880313646)
,p_name=>'LAYOUT.T_SUB_REGION_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B50\5340\57DF\7684\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109052179715313410)
,p_name=>'LAYOUT.T_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108911783256313296)
,p_name=>'LAYOUT.T_TABULAR_FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\8868\5316\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109044338490313404)
,p_name=>'LAYOUT.T_TAB_SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109049341838313408)
,p_name=>'LAYOUT.T_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109069966724313423)
,p_name=>'LAYOUT.T_TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109046481639313406)
,p_name=>'LAYOUT.T_TITLE_CREATE_BRANCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109046901147313406)
,p_name=>'LAYOUT.T_TITLE_CREATE_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109046189813313405)
,p_name=>'LAYOUT.T_TITLE_CREATE_COMPUTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109047109145313406)
,p_name=>'LAYOUT.T_TITLE_CREATE_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109046254533313405)
,p_name=>'LAYOUT.T_TITLE_CREATE_PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109046037917313405)
,p_name=>'LAYOUT.T_TITLE_CREATE_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109046346094313405)
,p_name=>'LAYOUT.T_TITLE_CREATE_VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\9A57\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109047063214313406)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109047283613313406)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\6309\9215\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109047314075313406)
,p_name=>'LAYOUT.T_TITLE_EDIT_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109046803235313406)
,p_name=>'LAYOUT.T_TITLE_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109491508832313744)
,p_name=>'LAYOUT.T_TRIGGERING_CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('When \689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109491491481313744)
,p_name=>'LAYOUT.T_TRIGGERING_ELEMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('When \5143\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109028731205313392)
,p_name=>'LAYOUT.T_UNCONDITIONAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\689D\4EF6\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109043540226313403)
,p_name=>'LAYOUT.T_VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109054455466313412)
,p_name=>'LAYOUT.T_VALIDATION2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109669768381313888)
,p_name=>'LAYOUT.T_VALIDATION_ALWAYS_EXEC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\57F7\884C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109491108420313744)
,p_name=>'LAYOUT.T_VALIDATION_EXPR1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\8868\793A\5F0F 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109491203830313744)
,p_name=>'LAYOUT.T_VALIDATION_EXPR2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\8868\793A\5F0F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109491051932313744)
,p_name=>'LAYOUT.T_VALIDATION_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109040961743313401)
,p_name=>'LAYOUT.T_VIEW_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109490489814313743)
,p_name=>'LAYOUT.T_WHEN_BUTTON_PRESSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E0B\6309\9215\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109050797870313409)
,p_name=>'LAYOUT.T_YES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109209404771313527)
,p_name=>'LAYOUT.UPDATABLE_SQL_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\66F4\65B0\7684 SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109171423976313499)
,p_name=>'LAYOUT.USE_APP_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109487716731313741)
,p_name=>'LAYOUT.VALIDATING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5728\9A57\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109168455005313497)
,p_name=>'LAYOUT_NEVER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\4E0D\6210\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109211132380313529)
,p_name=>'LAYOUT_RUN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109415614187313687)
,p_name=>'LDAP USERNAME EDIT FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('LDAP \4F7F\7528\8005\540D\7A31\7DE8\8F2F\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108928079116313309)
,p_name=>'LDAP_AUTH_SCHEME_DESC'
,p_message_language=>'zh-tw'
,p_message_text=>'LDAP'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108946416834313323)
,p_name=>'LEARN MORE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\77AD\89E3\5176\4ED6\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109064379510313419)
,p_name=>'LEARN_MORE_APEX_HOME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\77AD\89E3\6709\95DC Oracle APEX \7684\8A73\7D30\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109064109144313419)
,p_name=>'LEARN_MORE_APP_BUILDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\77AD\89E3\6709\95DC\61C9\7528\7A0B\5F0F\7522\751F\5668\7684\8A73\7D30\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109072903547313425)
,p_name=>'LEARN_MORE_PAGE_DESIGNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\77AD\89E3\6709\95DC\300C\9801\9762\8A2D\8A08\5DE5\5177\300D\7684\8A73\7D30\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109064216922313419)
,p_name=>'LEARN_MORE_PROD_APPS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\77AD\89E3\6709\95DC\300C\751F\7522\529B\61C9\7528\7A0B\5F0F\300D\7684\8A73\7D30\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109064099471313418)
,p_name=>'LEARN_MORE_SQL_WORKSHOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\77AD\89E3\6709\95DC SQL \5DE5\4F5C\5BA4\7684\8A73\7D30\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109669149387313887)
,p_name=>'LEARN_WEBSHEETS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E00\4E0B\6B64\8655\5373\53EF\77AD\89E3\300CWeb \8A66\7B97\8868\300D\76F8\95DC\8CC7\8A0A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109478263329313734)
,p_name=>'LEFT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9760\5DE6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110122684882314250)
,p_name=>'LEGACY_CALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\820A\6709\884C\4E8B\66C6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108953156237313329)
,p_name=>'LINES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DDA\689D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109718453770313936)
,p_name=>'LINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108988901675313357)
,p_name=>'LINK$'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109390196746313668)
,p_name=>'LINKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110116181924314245)
,p_name=>'LINK_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109495752738313747)
,p_name=>'LINK_TO_THIS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\6B64 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109309874228313607)
,p_name=>'LINK_TO_THIS_PAGE_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\81F3\6B64\9801\9762\9805\76EE %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109115950428313457)
,p_name=>'LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109414638265313686)
,p_name=>'LIST ITEM CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\9805\76EE\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109411185175313683)
,p_name=>'LIST OF VALUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108984497684313354)
,p_name=>'LISTVIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109448464436313712)
,p_name=>'LISTVIEW_FORM_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\300C\8868\55AE\300D\548C\300C\6E05\55AE\6AA2\8996\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109454823827313717)
,p_name=>'LIST_ENTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110154576686314275)
,p_name=>'LIST_ENTRY_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\9805\76EE\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109442908963313708)
,p_name=>'LIST_INITCAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109559353256313799)
,p_name=>'LIST_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109359813288313644)
,p_name=>'LIST_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109423279231313692)
,p_name=>'LIST_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109135668203313472)
,p_name=>'LIST_TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109171129081313499)
,p_name=>'LIST_UTILIZATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\4F7F\7528\72C0\6CC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109448792044313713)
,p_name=>'LIST_VIEW_ATTRIBUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\6AA2\8996\9801\9762\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109449008002313713)
,p_name=>'LIST_VIEW_PAGE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\6AA2\8996\9801\9762\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109448663055313712)
,p_name=>'LIST_VIEW_PAGE_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\6AA2\8996\9801\9762')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110101664456314233)
,p_name=>'LOAD_DATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\8CC7\6599')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109498148265313749)
,p_name=>'LOCK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9396\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109586168402313819)
,p_name=>'LOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9396\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109283908575313587)
,p_name=>'LOCKED BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9396\5B9A\8005: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110104477900314235)
,p_name=>'LOCKED_DATE_BY_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%1 \5DF2\9396\5B9A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110104646757314235)
,p_name=>'LOCK_SCRIPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9396\5B9A\547D\4EE4\6A94')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109296353264313596)
,p_name=>'LOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\8A8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109424100429313693)
,p_name=>'LOGGING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\8A8C\8A18\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109492545276313745)
,p_name=>'LOGIN.REMEMBER_USERNAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A18\4F4F\4F7F\7528\8005\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109492611295313745)
,p_name=>'LOGIN.REMEMBER_USERNAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\5982\679C\60A8\9078\53D6\6B64\6838\53D6\65B9\584A, \61C9\7528\7A0B\5F0F\5C07\6703\5728\540D\70BA "LOGIN_USERNAME_COOKIE" \7684\6C38\4E45\700F\89BD\5668 Cookie \5132\5B58\60A8\7684\4F7F\7528\8005\540D\7A31.'),
unistr('\7576\60A8\4E0B\6B21\524D\5F80\767B\5165\9801\9762\6642,'),
unistr('\4FBF\6703\4EE5\9019\500B\503C\81EA\52D5\586B\5165\4F7F\7528\8005\540D\7A31\6B04\4F4D.'),
'</p>',
'<p>',
unistr('\5982\679C\60A8\53D6\6D88\9078\53D6\6B64\6838\53D6\65B9\584A, \4E26\4E14\5DF2\7D93\5728 Cookie \4E2D\5132\5B58\60A8\7684\4F7F\7528\8005\540D\7A31,'),
unistr('\5247\61C9\7528\7A0B\5F0F\5C07\6703\4EE5\7A7A\767D\503C\8986\5BEB\6B64 Cookie.'),
unistr('\60A8\4E5F\53EF\4EE5\4F7F\7528\700F\89BD\5668\7684\958B\767C\4EBA\54E1\5DE5\5177, \5B8C\5168\79FB\9664\6B64 Cookie.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109423902108313693)
,p_name=>'LOGIN_URL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\5165 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109423831693313693)
,p_name=>'LOGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\8A8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109910234652314079)
,p_name=>'LOGO.DEFAULT.IMAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\8A2D\5B9A\5F71\50CF.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109910311148314079)
,p_name=>'LOGO.DEFAULT.TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\6A19\8A8C\6587\5B57')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109908723855314078)
,p_name=>'LOGO.EDITOR.APP.GROUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\6A19\8A8C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109909269245314078)
,p_name=>'LOGO.FILE.SIZE.EXCEEDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\6A94\6848\8D85\904E\5141\8A31\7684 %0 \9650\5236')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109909706500314079)
,p_name=>'LOGO.LABEL.CUSTOM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\53EF\4EE5\5728\300C\61C9\7528\7A0B\5F0F\7522\751F\5668\300D\4E2D\8A2D\5B9A\81EA\8A02\6A19\8A8C\6A19\8A18.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109909654905314078)
,p_name=>'LOGO.LABEL.DRAG_AND_DROP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62D6\653E\6A94\6848\6216\6309\4E00\4E0B\4EE5\9032\884C\9078\53D6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109909567654314078)
,p_name=>'LOGO.LABEL.IMAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109909807802314079)
,p_name=>'LOGO.LABEL.NONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\61C9\7528\7A0B\5F0F\5C07\4E0D\6703\986F\793A\6A19\8A8C.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109909420773314078)
,p_name=>'LOGO.LABEL.TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109909309319314078)
,p_name=>'LOGO.LABEL.TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109910046078314079)
,p_name=>'LOGO.MSG.IMAGE_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\6A19\8A8C\985E\578B\9700\6709\6A19\8A8C\5F71\50CF.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109910108821314079)
,p_name=>'LOGO.MSG.SAVE_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\8A8C\5DF2\9806\5229\5132\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109909924742314079)
,p_name=>'LOGO.MSG.TEXT_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\6A19\8A8C\985E\578B\9700\6709\6A19\8A8C\6587\5B57.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109909141765314078)
,p_name=>'LOGO.WRONG.MIME.TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\5141\8A31\4F7F\7528\5F71\50CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110090585589314208)
,p_name=>'LOG_FEEDBACK_AS_BUG_CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\611F\8B1D\60A8\7684\610F\898B\56DE\994B, \6211\5011\5DF2\91DD\5C0D\6B64\554F\984C\5EFA\7ACB\4E86\4E00\500B\932F\8AA4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110092071875314209)
,p_name=>'LOG_FEEDBACK_AS_FEATURE_CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\611F\8B1D\60A8\7684\610F\898B\56DE\994B, \6211\5011\6703\8003\616E\5728\5F8C\7E8C\7248\6B21\4E2D\5BE6\884C\9019\9805\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109715300804313934)
,p_name=>'LOG_FEEDBACK_AS_ISSUE_CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\611F\8B1D\60A8\7684\610F\898B\56DE\994B, \6211\5011\5DF2\5728\7CFB\7D71\4E2D\8A18\9304\554F\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110092233243314209)
,p_name=>'LOG_FEEDBACK_AS_TODO_CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\611F\8B1D\60A8\7684\610F\898B\56DE\994B, \6211\5011\5DF2\5EFA\7ACB\4E86\4E00\9805\5DE5\4F5C\4F86\89E3\6C7A\6B64\554F\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110120032033314248)
,p_name=>'LOG_IN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109297223582313597)
,p_name=>'LOG_INTERVAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\8A8C\9593\9694')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109411079991313683)
,p_name=>'LOV ITEM CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE\9805\76EE\689D\4EF6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109368934059313651)
,p_name=>'LOW_PRIORITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4E\512A\5148\9806\5E8F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108912193129313296)
,p_name=>'MANAGE PAGE GROUPS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\9801\9762\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109560830171313800)
,p_name=>'MANAGE SERVICE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\670D\52D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109560636466313800)
,p_name=>'MANAGE USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109560081974313799)
,p_name=>'MANAGE WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\5DE5\4F5C\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109504551537313754)
,p_name=>'MANAGE_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109126129986313465)
,p_name=>'MANAGE_UNASSIGNED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\672A\6307\5B9A\9805\76EE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108943640769313321)
,p_name=>'MANUAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\624B\52D5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108882013129313273)
,p_name=>'MAP_LAYER='
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\5C64=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108883478263313274)
,p_name=>'MAP_LAYERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5730\5716\5716\5C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109029366353313393)
,p_name=>'MAP_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\5730\5716.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109368193801313651)
,p_name=>'MARQUEE_FEATURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8DD1\99AC\71C8\529F\80FD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109442053028313707)
,p_name=>'MASTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109427315286313695)
,p_name=>'MASTERDETAIL_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\4E3B\8981\660E\7D30\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108880732828313272)
,p_name=>'MASTER_DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\660E\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108880910202313272)
,p_name=>'MASTER_DETAIL_DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \660E\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108880834557313272)
,p_name=>'MASTER_DETAIL_EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109493895723313746)
,p_name=>'MATERIALIZED_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BE6\9AD4\5316\8996\89C0\8868')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109389567929313667)
,p_name=>'MAXIMUM_RENDER_TIME_SECONDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\9577\5448\73FE\6642\9593 (\79D2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109480731650313736)
,p_name=>'MAXIMUM_SESSION_IDLE_TIME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D\9592\7F6E\6642\9593\4E0A\9650 (\79D2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109480845347313736)
,p_name=>'MAXIMUM_SESSION_LENGTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D\9577\5EA6\4E0A\9650 (\79D2)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109063892737313418)
,p_name=>'MAY_NOT_DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5141\8A31\522A\9664\542B\76F8\95DC\529F\80FD\7684\91CC\7A0B\7891.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108956085617313331)
,p_name=>'MEMORY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A18\61B6\9AD4:')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109114342401313456)
,p_name=>'MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109414772336313686)
,p_name=>'MENU ITEM CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\9805\76EE\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109423579391313693)
,p_name=>'MENU_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\6A23\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109656646953313875)
,p_name=>'MIGRATION FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\8F49\6A94\6848')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109410634149313683)
,p_name=>'MILESTONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CC\7A0B\7891')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109390624095313668)
,p_name=>'MILESTONES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CC\7A0B\7891')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109846934724314033)
,p_name=>'MILLISECONDS_MS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BEB\79D2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109393343596313670)
,p_name=>'MIME_TYPE_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('MIME \985E\578B\8CC7\6599\6B04')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109366606281313650)
,p_name=>'MINIMAL_IMPACT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F15\5FAE\5F71\97FF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108931103290313311)
,p_name=>'MIN_VERSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5C0F\7248\672C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110091172374314208)
,p_name=>'MISSING_AT_SIGN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\907A\6F0F @ \7B26\865F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109314162683313610)
,p_name=>'MODEL_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C %0 \9801')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109368317493313651)
,p_name=>'MODERATELY_DESIRABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\5EA6\9700\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109366528631313649)
,p_name=>'MODERATE_IMPACT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\5EA6\5F71\97FF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109053391122313411)
,p_name=>'MODIFIED_ATTRIBUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\4FEE\6539\904E\7684\5C6C\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109494171920313746)
,p_name=>'MODIFY_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4FEE\6539\8CC7\6599\6B04 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109293846726313595)
,p_name=>'MONITOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76E3\7763')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109560701924313800)
,p_name=>'MONITOR ACTIVITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76E3\7763\6D3B\52D5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109419993048313690)
,p_name=>'MORE_DOT_DOT_DOT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6...')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109389041007313667)
,p_name=>'MOST_ACTIVE_APPLICATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\6700\5E38\4F7F\7528\4E2D\7684\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109384034855313663)
,p_name=>'MOST_RECENT_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\8FD1\767C\751F\7684\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109684623388313903)
,p_name=>'MOST_RECENT_FILE_UPLOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\65B0\7684\6A94\6848\662F %1 \65BC %2 \4E0A\50B3\7684 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109152489032313485)
,p_name=>'MRU.ERROR_IN_MRU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('MRU \767C\751F\932F\8AA4: \8CC7\6599\5217= %0, %1, %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109151380648313484)
,p_name=>'MRU.INVALID_PRIM_KEY_COL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\4E3B\7D22\5F15\9375\8CC7\6599\6B04\4E0D\5728\9078\53D6\7684\67E5\8A62\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109152582561313485)
,p_name=>'MRU.LOST_UPDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\4E2D\7684\76EE\524D\8CC7\6599\7248\672C\81EA\4F7F\7528\8005\8D77\59CB\66F4\65B0\8655\7406\4F5C\696D\5F8C\5DF2\7D93\8B8A\66F4. \76EE\524D\7684\7E3D\548C\6AA2\9A57 = "%0", \9805\76EE\7E3D\548C\6AA2\9A57 = "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109150810448313483)
,p_name=>'MRU.NO_ROWS_TO_PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\8981\8655\7406\7684\8CC7\6599\5217')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109068709101313422)
,p_name=>'MUST_BE_XSL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\78BA\5B9A\5831\8868\7248\9762\914D\7F6E\6A94\6848\7684\985E\578B\662F XSL-FO, \526F\6A94\540D\70BA ''.xsl''.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108977638827313348)
,p_name=>'MY_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6211\7684\9801\9762')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110090078505314207)
,p_name=>'NAMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109498010929313749)
,p_name=>'NAVBAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109410840917313683)
,p_name=>'NAVBAR ITEM CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\5217\9805\76EE\689D\4EF6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110093649303314210)
,p_name=>'NAVIGATE_GO_TO_TOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D\5F80\6700\4E0A\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109408737386313682)
,p_name=>'NAVIGATION BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109423741038313693)
,p_name=>'NAVIGATION_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108911804977313296)
,p_name=>'NAVIGATION_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\9801')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108903291883313290)
,p_name=>'NAV_APP_BUILDER_HOME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\81F3\61C9\7528\7A0B\5F0F\7522\751F\5668\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110129877598314256)
,p_name=>'NAV_BAR_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BE6\884C: \6E05\55AE %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110129767155314256)
,p_name=>'NAV_BAR_TRADITIONAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BE6\884C: \4E00\822C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109379020155313659)
,p_name=>'NEEDS_REVIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981\8907\67E5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109372159633313654)
,p_name=>'NEED_INFORMATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981\8CC7\8A0A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109390252742313668)
,p_name=>'NEWS_ENTRIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\805E\9805\76EE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110123583585314251)
,p_name=>'NEW_BIND_VARIABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\8B8A\6578 %0 \7684\65B0\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109133162922313470)
,p_name=>'NEW_EMAIL_ADDRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8 Application Express \5E33\6236\7684\65B0\96FB\5B50\90F5\4EF6\5730\5740.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109367601220313650)
,p_name=>'NEW_FEATURE_REQUEST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\529F\80FD\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109299892807313599)
,p_name=>'NEW_OR_EXISTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\7684\6216\73FE\6709\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109475912259313733)
,p_name=>'NEW_SCHEMA_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\7DB1\8981\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109383304613313662)
,p_name=>'NEW_SERVICE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA\670D\52D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109114281877313456)
,p_name=>'NEW_TABSET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\9801\7C64\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110108818612314240)
,p_name=>'NEW_TOP_LEVEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \672A\9078\53D6\7236\9805 - ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109420260135313690)
,p_name=>'NEW_WORKSPACE_REQUEST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA\5DE5\4F5C\5340\8981\6C42')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109428420346313696)
,p_name=>'NO CORRESPONDING REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\5C0D\61C9\7684\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109361712474313646)
,p_name=>'NO PRIMARY KEY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\6C92\6709\5B9A\7FA9\4E3B\7D22\5F15\9375. \5EFA\7ACB\5177\6709\8868\55AE\7684\5831\8868\6642\5FC5\9808\8981\6709\4E3B\7D22\5F15\9375. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108957852922313333)
,p_name=>'NOARCHIVELOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\8A8C\5B58\6A94\529F\80FD: \95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109352915340313639)
,p_name=>'NON CURRENT ENTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975E\76EE\524D\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109408506348313681)
,p_name=>'NON CURRENT TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975E\76EE\524D\7684\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109413041192313685)
,p_name=>'NONE_SPECIFIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6307\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109100694398313446)
,p_name=>'NON_CURRENT_IMAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975E\76EE\524D\7684\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109477630468313734)
,p_name=>'NON_PACKAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('-\975E\751F\7522\529B\6216\7BC4\4F8B\61C9\7528\7A0B\5F0F-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109368838167313651)
,p_name=>'NORMAL_PRIORITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\512A\5148\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110090682995314208)
,p_name=>'NOT AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110116028660314245)
,p_name=>'NOTE_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9644\8A3B: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109271816578313574)
,p_name=>'NOTIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109365506131313649)
,p_name=>'NOT_A_BUG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\662F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110122513442314250)
,p_name=>'NOT_CURRENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975E\76EE\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109368583546313651)
,p_name=>'NOT_DESIRABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\9700\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109418117337313689)
,p_name=>'NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108973427987313345)
,p_name=>'NOT_EXISTS_SQL_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('NOT EXISTS SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109365658095313649)
,p_name=>'NOT_FEASIBLE_TO_FIX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\4FEE\6B63')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109497856235313749)
,p_name=>'NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110129265985314256)
,p_name=>'NOT_FUNCTIONALLY_COMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210\5EA6\4F4E\65BC 80%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109430983966313698)
,p_name=>'NOT_INSTALLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5B89\88DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109114195925313456)
,p_name=>'NOT_IN_DATA_DICT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5728\300C\8CC7\6599\5B57\5178\300D\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109369260090313652)
,p_name=>'NOT_PRIORITIZED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6392\5B9A\512A\5148\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109367019205313650)
,p_name=>'NOT_PRORITIZED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6392\5B9A\512A\5148\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109413217511313685)
,p_name=>'NOT_PROVIDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\63D0\4F9B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109688931092313909)
,p_name=>'NOT_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\9700\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109371934478313654)
,p_name=>'NOT_STARTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109450415346313714)
,p_name=>'NOT_VALID_VIEW_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<strong>%0</strong> \4E0D\662F\6709\6548\7684\6AA2\8996\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108930649769313311)
,p_name=>'NO_APPLICATIONS_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109434178070313701)
,p_name=>'NO_APPLICATION_SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9078\53D6\4EFB\4F55\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109208751079313527)
,p_name=>'NO_ARGUMENTS_ALLOWED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5141\8A31\5F15\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109364662713313648)
,p_name=>'NO_ASSIGNED_PRIORITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6307\5B9A\512A\5148\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108976403597313348)
,p_name=>'NO_AUTHORIZATION_SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\6388\6B0A\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109413421047313685)
,p_name=>'NO_AVAIL_JOBS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\53EF\7528\7684\8CC7\6599\5EAB\5DE5\4F5C\4F47\5217\8655\7406\4F5C\696D. \8ACB\806F\7D61\60A8\7684<br>\7BA1\7406\54E1\589E\52A0 JOB_QUEUE_PROCESSES \521D\59CB\5316\53C3\6578, <br>\6216\7B49\5019\5176\4ED6\5DE5\4F5C\5B8C\6210.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109287383199313590)
,p_name=>'NO_BREADCRUMB_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\4E3B\984C\4E2D\627E\4E0D\5230\5C0E\89BD\8DEF\5F91\6A23\677F. \81F3\5C11\8981\6709\4E00\500B\5C0E\89BD\8DEF\5F91\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109287410544313590)
,p_name=>'NO_BUTTON_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\4E3B\984C\4E2D\627E\4E0D\5230\6309\9215\6A23\677F. \81F3\5C11\8981\6709\4E00\500B\6309\9215\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109286933579313590)
,p_name=>'NO_CALENDAR_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\4E3B\984C\4E2D\627E\4E0D\5230\884C\4E8B\66C6\6A23\677F. \81F3\5C11\8981\6709\4E00\500B\884C\4E8B\66C6\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109062936110313418)
,p_name=>'NO_DATE_SPECIFIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6307\5B9A\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109312734479313609)
,p_name=>'NO_DEBUG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\9664\932F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108924890268313306)
,p_name=>'NO_DEVELOPER_PRIV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\958B\767C\4EBA\54E1\6B0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108986234062313355)
,p_name=>'NO_DISPLAY_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \4E0D\986F\793A -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108941337363313319)
,p_name=>'NO_FEATURES_TARGETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\76EE\6A19\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109284991507313588)
,p_name=>'NO_HELP_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\9805\76EE\6C92\6709\53EF\4F7F\7528\7684\8AAA\660E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110149958631314271)
,p_name=>'NO_ICON_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\4EFB\4F55\5716\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109035133647313397)
,p_name=>'NO_IMAGES_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109272194575313574)
,p_name=>'NO_IMAGE_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109116509636313458)
,p_name=>'NO_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109478198372313734)
,p_name=>'NO_JOB_QUEUE_PROCESSES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\555F\7528\8CC7\6599\5EAB\5DE5\4F5C\4F47\5217\8655\7406\4F5C\696D.  \8ACB\806F\7D61\60A8\7684<br>\7BA1\7406\54E1\8A2D\5B9A JOB_QUEUE_PROCESSES \521D\59CB\5316\53C3\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109287087892313590)
,p_name=>'NO_LABEL_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\4E3B\984C\4E2D\627E\4E0D\5230\6A19\7C64\6A23\677F. \81F3\5C11\8981\6709\4E00\500B\6A19\7C64\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109018754564313385)
,p_name=>'NO_LAYOUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9078\53D6\4EFB\4F55\300C\5831\8868\7248\9762\914D\7F6E\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109287228835313590)
,p_name=>'NO_LIST_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\4E3B\984C\4E2D\627E\4E0D\5230\6E05\55AE\6A23\677F. \81F3\5C11\8981\6709\4E00\500B\6E05\55AE\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109367878431313650)
,p_name=>'NO_LONGER_AN_ISSUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\518D\662F\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108976221545313347)
,p_name=>'NO_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109411738797313684)
,p_name=>'NO_MILESTONES_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5B9A\7FA9\91CC\7A0B\7891')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109638444570313861)
,p_name=>'NO_NAVIGATION_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\986F\793A\5C0E\89BD\529F\80FD\8868\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109018627758313385)
,p_name=>'NO_PAGE_DEV_PRIV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\767C\4EBA\54E1\6C92\6709\5728\6B64\9801\9762\5EFA\7ACB\5143\4EF6\7684\6B0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109287645405313590)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5617\8A66\8907\88FD\4E3B\984C, \4F46\5728\61C9\7528\7A0B\5F0F %0 \4E2D\627E\4E0D\5230\9801\9762\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109286709038313590)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\4E3B\984C\4E2D\627E\4E0D\5230\9801\9762\6A23\677F. \81F3\5C11\8981\6709\4E00\500B\9801\9762\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109210332164313528)
,p_name=>'NO_PARENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\7236\9805\5C0E\89BD\8DEF\5F91\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109658823350313877)
,p_name=>'NO_PARENT_TABS_HAVE_BEEN_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C1A\672A\5B9A\7FA9\7236\9805\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109419816345313690)
,p_name=>'NO_PENDING_REQUESTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\64F1\7F6E\4E2D\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109287582115313590)
,p_name=>'NO_POPUP_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\4E3B\984C\4E2D\627E\4E0D\5230\5373\73FE\5F0F\503C\6E05\55AE\6A23\677F. \5FC5\9808\8981\6709\4E00\500B\5373\73FE\5F0F\503C\6E05\55AE\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109369142282313651)
,p_name=>'NO_PRIORITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\512A\5148\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109456194577313718)
,p_name=>'NO_REGION_POSITION_IN_PAGE_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\5340\57DF\4F4D\7F6E\4E0D\5728\60A8\7684\9801\9762\6A23\677F\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109286881040313590)
,p_name=>'NO_REGION_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\4E3B\984C\4E2D\627E\4E0D\5230\5340\57DF\6A23\677F. \81F3\5C11\8981\6709\4E00\500B\5340\57DF\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109287167759313590)
,p_name=>'NO_REPORT_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\4E3B\984C\4E2D\627E\4E0D\5230\5831\8868\6A23\677F. \81F3\5C11\8981\6709\4E00\500B\5831\8868\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108976371979313347)
,p_name=>'NO_SHORTCUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\6377\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109371806007313654)
,p_name=>'NO_STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109420468372313690)
,p_name=>'NO_SYSTEM_MESSAGE_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5B9A\7FA9\7CFB\7D71\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109714717598313933)
,p_name=>'NO_TABS_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C1A\672A\66FF\6B64\61C9\7528\7A0B\5F0F\5B9A\7FA9\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109659066898313877)
,p_name=>'NO_TABS_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109656213334313875)
,p_name=>'NO_TABS_HAVE_BEEN_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C1A\672A\5B9A\7FA9\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109658999776313877)
,p_name=>'NO_TABS_SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9078\53D6\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110090499594314207)
,p_name=>'NO_TAGS_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\6A19\8A18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109116418842313458)
,p_name=>'NO_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109208812074313527)
,p_name=>'NO_URL_ACCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709 URL \5B58\53D6\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109700751020313922)
,p_name=>'NO_WHITE_LIST_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5FC5\9808\5148\5B9A\7FA9\5141\8A31\7684\8868\683C\6E05\55AE, \624D\80FD\5920\4F7F\7528 SQL \6A19\8A18.  \9019\662F\57FA\65BC\5B89\5168\8003\91CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109366346803313649)
,p_name=>'NO_WORKAROUND_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\56E0\61C9\63AA\65BD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109112666735313455)
,p_name=>'NULL_IN_PAREN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\7A7A\503C)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109497221070313748)
,p_name=>'NUMBER_OF_FEEDBACK_ENTRIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109450272984313714)
,p_name=>'NUMBER_OF_USERS_FILING_FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108941229845313319)
,p_name=>'NUM_TOTAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \7E3D\8A08')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109348778081313636)
,p_name=>'OBJECTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109644101085313865)
,p_name=>'OBJECTS_WITHOUT_DEFAULTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\9810\8A2D\503C\7684\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109644024498313865)
,p_name=>'OBJECTS_WITH_DEFAULTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5177\6709\9810\8A2D\503C\7684\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110115661018314245)
,p_name=>'OBJECT_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7269\4EF6: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109437064698313703)
,p_name=>'OB_CASCADE_DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\758A\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109378308434313658)
,p_name=>'OB_CHECK_CON_NN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\6AA2\67E5\9650\5236\689D\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108932472978313312)
,p_name=>'OB_COMPILE_ERRORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109438102832313704)
,p_name=>'OB_CONSTRAINT_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9650\5236\689D\4EF6\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109438215634313704)
,p_name=>'OB_CONS_INFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04/\6AA2\67E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109378109464313658)
,p_name=>'OB_CONS_NAME_NN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\9650\5236\689D\4EF6\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109378555905313659)
,p_name=>'OB_CONS_NAME_USED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7D93\4F7F\7528\9650\5236\689D\4EF6\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109436741947313703)
,p_name=>'OB_FK_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\4F86\7D22\5F15\9375')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109377729266313658)
,p_name=>'OB_FK_NAME_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\5916\4F86\7D22\5F15\9375\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109378429195313659)
,p_name=>'OB_FK_NAME_USED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5916\4F86\7D22\5F15\9375\300D\540D\7A31\5DF2\7D93\88AB\4F7F\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109436813395313703)
,p_name=>'OB_FK_REFERENCED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\7167\7684\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109436966132313703)
,p_name=>'OB_FK_REFERENCED_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\7167\7684\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109378053722313658)
,p_name=>'OB_FK_REF_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\9078\53D6\300C\5916\4F86\7D22\5F15\9375\300D\53C3\7167\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109377926987313658)
,p_name=>'OB_FK_REF_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\9078\53D6\300C\5916\4F86\7D22\5F15\9375\300D\53C3\7167\8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109377838972313658)
,p_name=>'OB_FK_SEL_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\9078\53D6\300C\5916\4F86\7D22\5F15\9375\300D\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109498537671313749)
,p_name=>'OB_POSITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109438358624313704)
,p_name=>'OB_SELECT_DATATYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \9078\53D6\8CC7\6599\985E\578B -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109437144861313703)
,p_name=>'OB_SET_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109378284596313658)
,p_name=>'OB_UK_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\5C0D\552F\4E00\7D22\5F15\9375\6307\5B9A\8CC7\6599\6B04.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109847172940314033)
,p_name=>'ODG.API.START'
,p_message_language=>'zh-tw'
,p_message_text=>'%0  START'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109847087637314033)
,p_name=>'ODG.API.UNHANDLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \672A\8655\7406\7684\7570\5E38\72C0\6CC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109847215732314033)
,p_name=>'ODG.API.UNHANDLED_BUILTIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\8655\7406\7684\5167\5EFA data_source: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109848078545314034)
,p_name=>'ODG.BLUEPRINT.BLUEPRINT_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\6216\672A\5EFA\7ACB\85CD\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108899638044313287)
,p_name=>'ODG.BLUEPRINT.DATA_SOURCE_NAME_26'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\4F86\6E90\540D\7A31\7684\9577\5EA6\5FC5\9808\5728 26 \500B\5B57\5143\4EE5\5167.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108899561263313287)
,p_name=>'ODG.BLUEPRINT.ERROR_IMPORTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\5165\6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109847991492314034)
,p_name=>'ODG.BLUEPRINT.ERR_INSERT_SELECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB INSERT-SELECT SQL \6558\8FF0\53E5\6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109847455739314034)
,p_name=>'ODG.BLUEPRINT.ERR_JSON_DATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \53D6\5F97 JSON \8CC7\6599. URL: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109848191850314034)
,p_name=>'ODG.BLUEPRINT.INSERT_INTO_SCRIPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('INSERT INTO \547D\4EE4\6A94:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108899838972313287)
,p_name=>'ODG.BLUEPRINT.INVALID_BUILTIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\5167\5EFA\8CC7\6599\4F86\6E90: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109847806484314034)
,p_name=>'ODG.BLUEPRINT.JSON_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4: JSON \8CC7\6599\70BA\7A7A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109847519863314034)
,p_name=>'ODG.BLUEPRINT.NOT_VALID_OBJECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\662F\6709\6548\7684\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109847648142314034)
,p_name=>'ODG.BLUEPRINT.NO_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4: \672A\8981\6C42\4EFB\4F55\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109847337669314034)
,p_name=>'ODG.BLUEPRINT.TO_MANY_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42\7684\8CC7\6599\5217\592A\591A, \5141\8A31\7684\8CC7\6599\5217\6578\76EE\4E0A\9650\70BA %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109847747488314034)
,p_name=>'ODG.BLUEPRINT.UNEXPECTED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165 %0 \6642\767C\751F\672A\9810\671F\7684\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108899792319313287)
,p_name=>'ODG.BLUEPRINT.VALUE_Y_N'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5FC5\9808\662F Y \6216 N')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108977586277313348)
,p_name=>'ONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108930183086313310)
,p_name=>'ONLY_INSTALLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\9650\5DF2\5B89\88DD\9805\76EE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109167159265313496)
,p_name=>'ON_LOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\6642')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109367960604313651)
,p_name=>'OPEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F85\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109413590652313685)
,p_name=>'OPENED_LAST_7_DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904E\53BB 7 \5929\7684\5F85\8655\7406\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109412628550313684)
,p_name=>'OPEN_BUGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F85\8655\7406\7684\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109412366397313684)
,p_name=>'OPEN_FEATURES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F85\8655\7406\7684\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109646149164313867)
,p_name=>'OPEN_PROCESSING_FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\555F, \6B63\5728\8655\7406\610F\898B\56DE\994B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109412591717313684)
,p_name=>'OPEN_TO_DOS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F85\8655\7406\7684\5F85\8FA6\4E8B\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109019782892313386)
,p_name=>'OPEN_WEBSHEET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\555F Web \8A66\7B97\8868 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109353707364313640)
,p_name=>'OPTIONAL ATTRIBUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\6027\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110133984926314259)
,p_name=>'OPTIONAL ICON CSS CLASSES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\6027\5716\793A CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109353694876313640)
,p_name=>'OPTIONAL IMAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\6027\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109353801521313640)
,p_name=>'OPTIONAL IMAGE ATTRIBUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\6027\5F71\50CF\5C6C\6027')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109656758709313875)
,p_name=>'ORACLE FORMS'
,p_message_language=>'zh-tw'
,p_message_text=>'Oracle Forms'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110061555976314186)
,p_name=>'ORDS_BASED_PRINTING_DESUPPORTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EE5 Oracle REST Data Services \70BA\57FA\790E\7684\5217\5370\529F\80FD\5728 Oracle APEX 19.1 \4E2D\5DF2\88AB\53D6\4EE3\4E14\4E0D\518D\652F\63F4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108911637800313296)
,p_name=>'OTHER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109657355525313876)
,p_name=>'OTHER WORKSPACE FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6\5DE5\4F5C\5340\6A94\6848')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109406254568313680)
,p_name=>'OTN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7532\9AA8\6587\5168\7403\958B\767C\8005\6280\8853\7DB2\8DEF (OTN)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109406355556313680)
,p_name=>'OTN_FORUM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7532\9AA8\6587\5168\7403\958B\767C\8005\6280\8853\7DB2\8DEF (OTN) \8A0E\8AD6\8AD6\58C7')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109536309762313778)
,p_name=>'OVERRIDE_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8986\5BEB ID')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110112420744314242)
,p_name=>'OVERVIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\89BD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109093970208313441)
,p_name=>'OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108940916387313319)
,p_name=>'OWNERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64C1\6709\8005')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109317989492313613)
,p_name=>'P4000.P4651.SQL_QUERY.FUNC_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62\51FD\6578. \4E3B\9AD4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109455569571313718)
,p_name=>'P4001_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109068364575313422)
,p_name=>'P4111_USED_ON_PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\522A\9664\6B64 LOV. \56E0\70BA\5B83\5DF2\88AB\7528\65BC %0 \9801\9762.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109418273132313689)
,p_name=>'P4316_BIND_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\9805\76EE (\8F38\5165\9805\76EE\540D\7A31)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110067015194314190)
,p_name=>'P473_NEEDS_REFRESH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\80FD\9700\8981\91CD\65B0\6574\7406.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110069843072314192)
,p_name=>'P4905_BUTTON_ALT_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\90E8\7F72\4F3A\670D\5668')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109344486115313633)
,p_name=>'P58_BROWSE_SEQ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\8CC7\6599\5EAB\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109340428654313630)
,p_name=>'P58_NO_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\8CC7\6599\5EAB\9023\7D50\4F5C\696D\5931\6557, \539F\56E0\5982\4E0B:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109340520934313630)
,p_name=>'P58_SEQUENCE_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5728 "%1" \7DB1\8981\4E2D\5EFA\7ACB\8CC7\6599\5EAB\9023\7D50 "%0".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109113406368313455)
,p_name=>'PACKAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\88DD\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109288024017313590)
,p_name=>'PACKAGED_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\751F\7522\529B\6216\7BC4\4F8B\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108950728925313327)
,p_name=>'PACKAGED_APPLICATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\751F\7522\529B\548C\7BC4\4F8B\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109499893938313750)
,p_name=>'PACKAGED_APP_INSTALL_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\88DD\61C9\7528\7A0B\5F0F\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109331171397313623)
,p_name=>'PACKAGE_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\88DD\7A0B\5F0F\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109477532151313734)
,p_name=>'PACKAGE_GLOBALS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('-\5168\57DF-')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109095453790313442)
,p_name=>'PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109415899319313687)
,p_name=>'PAGE COMPUTATION CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\904B\7B97\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109496168274313748)
,p_name=>'PAGE HEADER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A19\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109408335861313681)
,p_name=>'PAGE HEADER, BODY, AND FOOTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A19\982D, \4E3B\9AD4, \53CA\8868\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109416185268313687)
,p_name=>'PAGE ITEM DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\9801\9762\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109416393118313687)
,p_name=>'PAGE ITEM DISPLAY CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE\986F\793A\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109416504660313687)
,p_name=>'PAGE ITEM LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109416293407313687)
,p_name=>'PAGE ITEM POST COMPUTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE\5F8C\7E8C\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109416437040313687)
,p_name=>'PAGE ITEM READ-ONLY DISPLAY CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE\552F\8B80\986F\793A\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109416055606313687)
,p_name=>'PAGE ITEM SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109331518187313623)
,p_name=>'PAGE ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109409179068313682)
,p_name=>'PAGE PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109409252265313682)
,p_name=>'PAGE PROCESS CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8655\7406\4F5C\696D\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109415902998313687)
,p_name=>'PAGE VALIDATION CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9A57\8B49\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109345432797313634)
,p_name=>'PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109559502101313799)
,p_name=>'PAGE_ATTRIBUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109390001227313668)
,p_name=>'PAGE_EVENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109426250620313695)
,p_name=>'PAGE_EVENTS_FOR_LAST_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\4E8B\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110142473213314265)
,p_name=>'PAGE_FINDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\641C\5C0B\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108904853970313291)
,p_name=>'PAGE_GROUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109425702030313694)
,p_name=>'PAGE_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\61C9\7528\7A0B\5F0F\5167\7684\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109590900378313822)
,p_name=>'PAGE_ID_LOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 %0 \88AB\9396\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109591061836313822)
,p_name=>'PAGE_ID_UNLOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 %0 \5DF2\89E3\9664\9396\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109436248647313702)
,p_name=>'PAGE_INSTALL_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5B89\88DD\61C9\7528\7A0B\5F0F\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109332092938313624)
,p_name=>'PAGE_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109542124798313782)
,p_name=>'PAGE_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109376913206313657)
,p_name=>'PAGE_LOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9396\5B9A\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109285486834313589)
,p_name=>'PAGE_LOCKED_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5DF2\9396\4F4F\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109405969001313679)
,p_name=>'PAGE_NAME_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\9801\9762\90FD\5FC5\9808\8981\6709\9801\9762\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109389862961313667)
,p_name=>'PAGE_POSTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5F35\8CBC\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109559687291313799)
,p_name=>'PAGE_PROCESSES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108941628497313319)
,p_name=>'PAGE_PROCESSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109427038354313695)
,p_name=>'PAGE_PROTECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109106960821313451)
,p_name=>'PAGE_REGION.LIST_ITEM_SEQ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109107190117313451)
,p_name=>'PAGE_REGION.LIST_ITEM_TARGET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\6A19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109107049870313451)
,p_name=>'PAGE_REGION.LIST_ITEM_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109106795727313450)
,p_name=>'PAGE_REGION.LIST_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109106888918313451)
,p_name=>'PAGE_REGION.LIST_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109106647574313450)
,p_name=>'PAGE_REGION.QUERY_HIDE_SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109106559526313450)
,p_name=>'PAGE_REGION.QUERY_SHOW_SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109106331622313450)
,p_name=>'PAGE_REGION.TREE_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109106199084313450)
,p_name=>'PAGE_REGION.TREE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109106489011313450)
,p_name=>'PAGE_REGION.TREE_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109106297913313450)
,p_name=>'PAGE_REGION.TREE_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109029103908313393)
,p_name=>'PAGE_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\9801\9762 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109408233958313681)
,p_name=>'PAGE_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109377031145313657)
,p_name=>'PAGE_UNLOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\89E3\9664\9396\5B9A\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109389945326313667)
,p_name=>'PAGE_VIEWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6AA2\8996')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109385662825313664)
,p_name=>'PARENT_FEATURE_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\529F\80FD\7DE8\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109495816453313747)
,p_name=>'PARENT_REPORT_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\5831\8868\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109657556798313876)
,p_name=>'PARENT_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109655889197313874)
,p_name=>'PARENT_TABS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109100117067313445)
,p_name=>'PARENT_TAB_SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\9801\7C64\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109100274688313446)
,p_name=>'PARENT_TAB_SET_NEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\7236\9805\9801\7C64\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109100315003313446)
,p_name=>'PARENT_TAB_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\9801\7C64\6587\5B57')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109656570534313875)
,p_name=>'PARRENT_TAB_SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\9801\7C64\96C6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108944819978313322)
,p_name=>'PARSING_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5256\6790\7DB1\8981')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108941708448313319)
,p_name=>'PARTIAL_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\90E8\5206\9801\9762')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108925025814313306)
,p_name=>'PASSWORD_EXPIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC\904E\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108912784531313297)
,p_name=>'PASSWORD_MUST_BE_CHANGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8B8A\66F4\6B64\5E33\6236\7684\5BC6\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108924976304313306)
,p_name=>'PASSWORD_VALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC\6709\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108932736748313312)
,p_name=>'PASSWORD_WITH_SUBMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC (\6309 Enter \6642\9001\51FA)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109449580963313713)
,p_name=>'PAST_DUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\903E\671F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109539410012313780)
,p_name=>'PATH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8DEF\5F91')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109698903121313921)
,p_name=>'PCT_CLOSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8655\7406\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109695217535313918)
,p_name=>'PCT_GRAPH_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767E\5206\6BD4\7684\5716\5F62\683C\5F0F, 0 \5230 100 \9593\7684\6574\6578')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109608088398313838)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109608182116313838)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109944615016314104)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109944709299314104)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109610077281313840)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109610179054313840)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109944879583314104)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109944960170314104)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109610475693313840)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109610578723313840)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109610635863313840)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109610760641313840)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109845291452314032)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109845353107314032)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110081916088314201)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5316\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110082010792314201)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5316\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109614237086313843)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109614385990313843)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109610876005313840)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109610992432313841)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109945097728314104)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109945125976314104)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109609449320313839)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109609586137313840)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109610232392313840)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\5EFA\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109610302934313840)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\5EFA\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109613083067313842)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109613184322313842)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109609069965313839)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109609195974313839)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109609629647313840)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\820A\6709\884C\4E8B\66C6\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109609773097313840)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\820A\6709\884C\4E8B\66C6\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109925430765314090)
,p_name=>'PE.COMPONEN.TYPE.CARD.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109925541959314090)
,p_name=>'PE.COMPONEN.TYPE.CARD.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109925639606314090)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109925750959314090)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109627689959313853)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109627705164313853)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109615856364313844)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109615974205313844)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109616009672313844)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109616197027313845)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109705217883313926)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109705361717313926)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109912201023314080)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109912388570314080)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109611896068313841)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\820A\6709\8CC7\6599\8F09\5165\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109611933045313841)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\820A\6709\8CC7\6599\8F09\5165\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109613486952313842)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109613509263313843)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109613213485313842)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109613399831313842)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109169887091313498)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109169987188313498)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109845519396314032)
,p_name=>'PE.COMPONEN.TYPE.FACET.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9762\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109845605986314032)
,p_name=>'PE.COMPONEN.TYPE.FACET.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9762\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109916881812314084)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9762\5411\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109916922700314084)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9762\5411\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109917087241314084)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6838\53D6\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109917165695314084)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6838\53D6\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109608833378313839)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B04\4F4D\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109608906975313839)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B04\4F4D\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109456314996313718)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109456438043313718)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109456703509313718)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109456884736313719)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109456503151313718)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109456641618313718)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109456955914313719)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109457001676313719)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109923626360314089)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\5B58\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109924372588314089)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\5B58\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109614443185313843)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109614569360313843)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109615002186313844)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109615132796313844)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109614876312313844)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109614967391313844)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109705096099313926)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109705126408313926)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109614657513313843)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\5B58\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109614767116313843)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\5B58\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109503703131313753)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109503831578313753)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109503531329313753)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EA7\6A19\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109503602636313753)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EA7\6A19\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109503930428313753)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6578\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109504027935313753)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6578\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110074329337314196)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110074409687314196)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109611011405313841)
,p_name=>'PE.COMPONEN.TYPE.LIST.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109611175293313841)
,p_name=>'PE.COMPONEN.TYPE.LIST.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109945297856314104)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109945346014314104)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109609281081313839)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109609351918313839)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109611278252313841)
,p_name=>'PE.COMPONEN.TYPE.LOV.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109611361391313841)
,p_name=>'PE.COMPONEN.TYPE.LOV.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109945470257314104)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109945517410314104)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109851345775314036)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\5C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109851496579314036)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\5C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109851518742314037)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109851667935314037)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109851158959314036)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109851277749314036)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109612661363313842)
,p_name=>'PE.COMPONEN.TYPE.PAGE.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109612757085313842)
,p_name=>'PE.COMPONEN.TYPE.PAGE.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109613868020313843)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109613958588313843)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109612413795313842)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109612556312313842)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109311029807313608)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109311180838313608)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109614090742313843)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109614148493313843)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109615628669313844)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57FA\672C\8A8D\8B49\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109615703659313844)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57FA\672C\8A8D\8B49\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109615231487313844)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('In \53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109615378561313844)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('In \53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109615441247313844)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Out \53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109615580115313844)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Out \53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109608415535313839)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109608565820313839)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109946016855314105)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>'Plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109946129254314105)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>'Plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109612864690313842)
,p_name=>'PE.COMPONEN.TYPE.REGION.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109612972653313842)
,p_name=>'PE.COMPONEN.TYPE.REGION.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109904030323314074)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109904101693314074)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109840751508314029)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109840880157314029)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109608647630313839)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109608711511313839)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109551870223313789)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109551918814313789)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109332406669313624)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9060\7AEF\8CC7\6599\5EAB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109332571689313624)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528 REST \7684 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109712233238313931)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\7248\9762\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109712333298313931)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\7248\9762\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109609879772313840)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\5831\8868\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109609951551313840)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\5831\8868\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109278480537313583)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109278588079313583)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109278609339313583)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109278758192313583)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109278891278313583)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6838\53D6\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109278922522313584)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6838\53D6\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109945697999314104)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6377\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109945715425314104)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6377\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109612034701313841)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\6E96\9801\7C64\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109612160550313841)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\6E96\9801\7C64\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109618070468313846)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109618185101313846)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109618210331313846)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109618371995313846)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109705490495313926)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109705574112313926)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109608205099313839)
,p_name=>'PE.COMPONEN.TYPE.THEME.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109608375108313839)
,p_name=>'PE.COMPONEN.TYPE.THEME.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109945809358314104)
,p_name=>'PE.COMPONEN.TYPE.TREE.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109945928138314104)
,p_name=>'PE.COMPONEN.TYPE.TREE.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109612274462313842)
,p_name=>'PE.COMPONEN.TYPE.USER_INTERFACE.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109612340822313842)
,p_name=>'PE.COMPONEN.TYPE.USER_INTERFACE.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109613617465313843)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109613752270313843)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109611425440313841)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \670D\52D9\53C3\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109611521535313841)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \670D\52D9\53C3\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109611615590313841)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \670D\52D9\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109611753929313841)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \670D\52D9\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110081080234314200)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57FA\672C\8A8D\8B49\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110081122028314200)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57FA\672C\8A8D\8B49\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110081277090314200)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP \8868\982D\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110081304446314201)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTTP \8868\982D\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110080652712314200)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('In \53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110080735336314200)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('In \53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110080854506314200)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Out \53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110080914103314200)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Out \53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109445846545313710)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \8CC7\6599\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109445937361313710)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \8CC7\6599\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109556530069313793)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \4F86\6E90\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109556676653313793)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \4F86\6E90\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109551675242313789)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \4F86\6E90\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109551786476313789)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \4F86\6E90\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109556708901313793)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \4F86\6E90\4F5C\696D\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109556820132313793)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \4F86\6E90\4F5C\696D\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109556977755313793)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \4F86\6E90\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109557000937313793)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \4F86\6E90\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109446053528313710)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \4F86\6E90\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109446196244313710)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \4F86\6E90\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109567402312313805)
,p_name=>'PE.DISPLAY_GROUP.ACTIONS_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\529F\80FD\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110082104914314201)
,p_name=>'PE.DISPLAY_GROUP.ADDITIONAL_CODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6\7A0B\5F0F\78BC\57F7\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109228866448313542)
,p_name=>'PE.DISPLAY_GROUP.ADVANCED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\968E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109229116816313542)
,p_name=>'PE.DISPLAY_GROUP.AFFECTED_ELEMENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D7\5F71\97FF\7684\5143\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109506181404313755)
,p_name=>'PE.DISPLAY_GROUP.ANIMATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\756B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109230138890313543)
,p_name=>'PE.DISPLAY_GROUP.APPEARANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\89C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109227372745313541)
,p_name=>'PE.DISPLAY_GROUP.ATTRIBUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108877006050313269)
,p_name=>'PE.DISPLAY_GROUP.AUDIT_INFORMATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A3D\6838\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109228911613313542)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109946371965314105)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION_SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109624995393313851)
,p_name=>'PE.DISPLAY_GROUP.AUTOMATIC_REFRESH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\91CD\65B0\6574\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109230069244313543)
,p_name=>'PE.DISPLAY_GROUP.BEHAVIOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\70BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109600057572313829)
,p_name=>'PE.DISPLAY_GROUP.BLOB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('BLOB \5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109926090959314090)
,p_name=>'PE.DISPLAY_GROUP.BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109602341209313834)
,p_name=>'PE.DISPLAY_GROUP.BREAK_FORMATTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\6BB5\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109635047429313858)
,p_name=>'PE.DISPLAY_GROUP.CALENDAR_STATE_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\4E8B\66C6\72C0\614B\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109925841955314090)
,p_name=>'PE.DISPLAY_GROUP.CARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109591537346313823)
,p_name=>'PE.DISPLAY_GROUP.CASCADING_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\5C64\5F0F\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109626536951313852)
,p_name=>'PE.DISPLAY_GROUP.CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110096942009314213)
,p_name=>'PE.DISPLAY_GROUP.CLIENT_SIDE_CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110082220170314201)
,p_name=>'PE.DISPLAY_GROUP.CODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109628210962313853)
,p_name=>'PE.DISPLAY_GROUP.COLORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109705941179313926)
,p_name=>'PE.DISPLAY_GROUP.COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109704367430313925)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109562270832313801)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FORMATTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109705875011313926)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_HEADINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109505423227313754)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_MAPPING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\5C0D\61C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109227430481313541)
,p_name=>'PE.DISPLAY_GROUP.COMMENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A3B\89E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109228797723313542)
,p_name=>'PE.DISPLAY_GROUP.COMPUTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109227641506313541)
,p_name=>'PE.DISPLAY_GROUP.CONFIGURATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109139139721313475)
,p_name=>'PE.DISPLAY_GROUP.CONFIRMATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109637670013313860)
,p_name=>'PE.DISPLAY_GROUP.CONTROLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63A7\5236\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109227786380313541)
,p_name=>'PE.DISPLAY_GROUP.CSS'
,p_message_language=>'zh-tw'
,p_message_text=>'CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109324331911313618)
,p_name=>'PE.DISPLAY_GROUP.CUSTOMIZATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109628039167313853)
,p_name=>'PE.DISPLAY_GROUP.DAILY_WEEKLY_CALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\548C\9031\884C\4E8B\66C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109946448539314105)
,p_name=>'PE.DISPLAY_GROUP.DATABASE_SESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\968E\6BB5\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109626622711313852)
,p_name=>'PE.DISPLAY_GROUP.DATAGRID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\65B9\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109505309572313754)
,p_name=>'PE.DISPLAY_GROUP.DATA_CURSOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6E38\6A19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109229265210313542)
,p_name=>'PE.DISPLAY_GROUP.DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109591401451313823)
,p_name=>'PE.DISPLAY_GROUP.DEPENDING_ON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109567599770313805)
,p_name=>'PE.DISPLAY_GROUP.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109567619982313805)
,p_name=>'PE.DISPLAY_GROUP.DETAIL_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A73\7D30\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109636218953313859)
,p_name=>'PE.DISPLAY_GROUP.DIALOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\8A71\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109567772611313805)
,p_name=>'PE.DISPLAY_GROUP.DOWNLOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109628315088313854)
,p_name=>'PE.DISPLAY_GROUP.DRAG_AND_DROP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62D6\653E\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109506046917313755)
,p_name=>'PE.DISPLAY_GROUP.DUAL_Y_AXES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96D9 Y \5EA7\6A19\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109457243660313719)
,p_name=>'PE.DISPLAY_GROUP.EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109589557929313821)
,p_name=>'PE.DISPLAY_GROUP.EDIT_AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\6388\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109229331482313542)
,p_name=>'PE.DISPLAY_GROUP.ELEMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109457172776313719)
,p_name=>'PE.DISPLAY_GROUP.ENABLE_USER_TO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B93\4F7F\7528\8005\53EF\4EE5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109635124155313858)
,p_name=>'PE.DISPLAY_GROUP.ENTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109227596408313541)
,p_name=>'PE.DISPLAY_GROUP.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109227849346313541)
,p_name=>'PE.DISPLAY_GROUP.ERROR_HANDLING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109228691007313542)
,p_name=>'PE.DISPLAY_GROUP.EXECUTION_OPTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109595951852313826)
,p_name=>'PE.DISPLAY_GROUP.EXPORT_PRINTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\51FA/\5217\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109602452005313834)
,p_name=>'PE.DISPLAY_GROUP.EXTERNAL_PROCESSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\90E8\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109850389933314036)
,p_name=>'PE.DISPLAY_GROUP.GANTT_START_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109626455412313852)
,p_name=>'PE.DISPLAY_GROUP.GANTT_TIMELINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\9593\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110048192444314177)
,p_name=>'PE.DISPLAY_GROUP.GANTT_VIEWPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\57E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109626040455313852)
,p_name=>'PE.DISPLAY_GROUP.GAUGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CF\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109227955725313541)
,p_name=>'PE.DISPLAY_GROUP.HEADER_AND_FOOTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D\548C\8868\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109602624933313834)
,p_name=>'PE.DISPLAY_GROUP.HEADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109228066220313541)
,p_name=>'PE.DISPLAY_GROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109229478553313542)
,p_name=>'PE.DISPLAY_GROUP.HELP_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109228178857313541)
,p_name=>'PE.DISPLAY_GROUP.HTML_HEADER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \6A19\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109926296178314090)
,p_name=>'PE.DISPLAY_GROUP.ICON_AND_BADGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A\8207\6A19\8A18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109567864603313805)
,p_name=>'PE.DISPLAY_GROUP.ICON_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109227178055313540)
,p_name=>'PE.DISPLAY_GROUP.IDENTIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B58\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109228224618313541)
,p_name=>'PE.DISPLAY_GROUP.JAVASCRIPT'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109229574947313542)
,p_name=>'PE.DISPLAY_GROUP.LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109230250965313543)
,p_name=>'PE.DISPLAY_GROUP.LAYOUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7248\9762\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109625589833313852)
,p_name=>'PE.DISPLAY_GROUP.LEGEND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109505529906313754)
,p_name=>'PE.DISPLAY_GROUP.LINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DDA\689D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109582616647313816)
,p_name=>'PE.DISPLAY_GROUP.LINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109689575196313909)
,p_name=>'PE.DISPLAY_GROUP.LIST_ENTRIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109229659471313542)
,p_name=>'PE.DISPLAY_GROUP.LIST_OF_VALUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109628166611313853)
,p_name=>'PE.DISPLAY_GROUP.LIST_VIEW_CALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B70\7A0B\6AA2\8996\884C\4E8B\66C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110057992739314184)
,p_name=>'PE.DISPLAY_GROUP.LOCAL_POST_PROCESSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672C\6A5F\5F8C\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109323799159313617)
,p_name=>'PE.DISPLAY_GROUP.LOGIN_PROCESSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\5165\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109505755682313755)
,p_name=>'PE.DISPLAY_GROUP.MAJOR_TICKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\523B\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109851841491314037)
,p_name=>'PE.DISPLAY_GROUP.MAP_LAYER_ZOOM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E2E\653E\7B49\7D1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109851779002314037)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5730\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109852346268314037)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_FEATURE_INFO_WINDOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\8A0A\8996\7A97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109851900423314037)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_INIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D77\59CB\4F4D\7F6E\8207\7E2E\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109852148154314037)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_CLUSTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9EDE\53E2\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109852012191314037)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_FEATURE_STYLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9EDE\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109852268476314037)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_ROW_SELECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\6307\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109625657381313852)
,p_name=>'PE.DISPLAY_GROUP.MARGIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\908A\754C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109505609559313755)
,p_name=>'PE.DISPLAY_GROUP.MARKER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\8A18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109651167128313871)
,p_name=>'PE.DISPLAY_GROUP.MASTER_DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\660E\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109926300311314091)
,p_name=>'PE.DISPLAY_GROUP.MEDIA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5A92\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109602565655313834)
,p_name=>'PE.DISPLAY_GROUP.MESSAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109505826471313755)
,p_name=>'PE.DISPLAY_GROUP.MINOR_TICKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B21\8981\523B\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109627802737313853)
,p_name=>'PE.DISPLAY_GROUP.MONTHLY_CALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6708\884C\4E8B\66C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109030199036313393)
,p_name=>'PE.DISPLAY_GROUP.MULTIPLE_VALUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\591A\500B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109359423303313644)
,p_name=>'PE.DISPLAY_GROUP.MULTI_SERIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\591A\6578\5217\5716\8868\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109946549745314105)
,p_name=>'PE.DISPLAY_GROUP.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109370053296313652)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110134028057314259)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\529F\80FD\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109713978376313933)
,p_name=>'PE.DISPLAY_GROUP.OUTPUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109505289623313754)
,p_name=>'PE.DISPLAY_GROUP.OVERVIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\89BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109705735148313926)
,p_name=>'PE.DISPLAY_GROUP.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109706179791313926)
,p_name=>'PE.DISPLAY_GROUP.PAGE_FOOTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8868\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109706096073313926)
,p_name=>'PE.DISPLAY_GROUP.PAGE_HEADER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A19\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109567996712313805)
,p_name=>'PE.DISPLAY_GROUP.PAGINATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109587990647313820)
,p_name=>'PE.DISPLAY_GROUP.PARAMETER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109457483873313719)
,p_name=>'PE.DISPLAY_GROUP.PERFORMANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6548\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109323846609313617)
,p_name=>'PE.DISPLAY_GROUP.POST_LOGOUT_URL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\51FA\5F8C URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109620484643313848)
,p_name=>'PE.DISPLAY_GROUP.PRIMARY_KEY_SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\7D22\5F15\9375\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109705613248313926)
,p_name=>'PE.DISPLAY_GROUP.PRINTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109946292098314105)
,p_name=>'PE.DISPLAY_GROUP.QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109229796842313542)
,p_name=>'PE.DISPLAY_GROUP.QUICK_PICKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FEB\901F\9078\64C7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109228353117313541)
,p_name=>'PE.DISPLAY_GROUP.READ_ONLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\552F\8B80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109323922345313618)
,p_name=>'PE.DISPLAY_GROUP.REAL_APPLICATION_SECURITY'
,p_message_language=>'zh-tw'
,p_message_text=>'Real Application Security'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109069173432313422)
,p_name=>'PE.DISPLAY_GROUP.REFERENCE_LINES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\8003\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109589051671313821)
,p_name=>'PE.DISPLAY_GROUP.REFRESH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6574\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109332674612313624)
,p_name=>'PE.DISPLAY_GROUP.REMOTE_CACHE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9060\7AEF\5FEB\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109548249177313786)
,p_name=>'PE.DISPLAY_GROUP.SEARCH_BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109926123190314090)
,p_name=>'PE.DISPLAY_GROUP.SECONDARY_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B21\8981\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109228403815313541)
,p_name=>'PE.DISPLAY_GROUP.SECURITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\5168\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109625774394313852)
,p_name=>'PE.DISPLAY_GROUP.SERIES_COLOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6578\5217\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109228529760313541)
,p_name=>'PE.DISPLAY_GROUP.SERVER_CACHE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F3A\670D\5668\5FEB\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110096814300314213)
,p_name=>'PE.DISPLAY_GROUP.SERVER_SIDE_CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F3A\670D\5668\7AEF\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109946650469314105)
,p_name=>'PE.DISPLAY_GROUP.SESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109324068506313618)
,p_name=>'PE.DISPLAY_GROUP.SESSION_COOKIE_ATTRIBUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D Cookie \5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109324154352313618)
,p_name=>'PE.DISPLAY_GROUP.SESSION_NOT_VALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D\7121\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109227291403313541)
,p_name=>'PE.DISPLAY_GROUP.SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109568123786313805)
,p_name=>'PE.DISPLAY_GROUP.SINGLE_ROW_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\55AE\4E00\8CC7\6599\5217\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109568046208313805)
,p_name=>'PE.DISPLAY_GROUP.SORTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109229873528313542)
,p_name=>'PE.DISPLAY_GROUP.SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109324263511313618)
,p_name=>'PE.DISPLAY_GROUP.SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109925905886314090)
,p_name=>'PE.DISPLAY_GROUP.SUB_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B50\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109583513702313817)
,p_name=>'PE.DISPLAY_GROUP.SUCCESS_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109279063647313584)
,p_name=>'PE.DISPLAY_GROUP.SUGGESTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\8B70')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110134149353314259)
,p_name=>'PE.DISPLAY_GROUP.TABS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108961806744313336)
,p_name=>'PE.DISPLAY_GROUP.THRESHOLDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81E8\754C\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109505916085313755)
,p_name=>'PE.DISPLAY_GROUP.TICK_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\523B\5EA6\6A19\7C64')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109840221751314028)
,p_name=>'PE.DISPLAY_GROUP.TIME_SCALE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\9593\7BC4\570D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109626361172313852)
,p_name=>'PE.DISPLAY_GROUP.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109457334167313719)
,p_name=>'PE.DISPLAY_GROUP.TOOLBAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\5177\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109626259522313852)
,p_name=>'PE.DISPLAY_GROUP.TOOLTIP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\5177\63D0\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109619252767313847)
,p_name=>'PE.DISPLAY_GROUP.UI_DEFAULTS_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('UI \9810\8A2D\503C\53C3\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109229995534313542)
,p_name=>'PE.DISPLAY_GROUP.VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109626126672313852)
,p_name=>'PE.DISPLAY_GROUP.VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109627931414313853)
,p_name=>'PE.DISPLAY_GROUP.WEEKLY_CALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9031\884C\4E8B\66C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109229017403313542)
,p_name=>'PE.DISPLAY_GROUP.WHEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\6A5F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109625867904313852)
,p_name=>'PE.DISPLAY_GROUP.X_AXIS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('X \8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109625920755313852)
,p_name=>'PE.DISPLAY_GROUP.Y_AXIS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Y \8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109552081094313789)
,p_name=>'PE.DISPLAY_GROUP.ZOOM_SCALE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E2E\653E\6BD4\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109459145191313720)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\7528\4F86\9650\5236\8AB0\80FD\5920\65B0\589E\8CC7\6599\5217\7684\6388\6B0A\914D\7F6E.'),
unistr('\82E5\8981\8B93\4E00\822C\4F7F\7528\8005\65B0\589E\8CC7\6599\5217, \8A72\4F7F\7528\8005\7684\9019\500B\6388\6B0A\914D\7F6E\5FC5\9808\8A55\4F30\70BA TRUE.'),
unistr('\5982\679C\672A\63D0\4F9B\6388\6B0A\914D\7F6E, \5247\4EFB\4F55\4F7F\7528\8005\90FD\53EF\4EE5\5728\6B64\4E92\52D5\5F0F\65B9\683C\4E2D\65B0\589E\8CC7\6599\5217.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109459003313313720)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109462165533313723)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\300C\65B0\589E\300D\6309\9215\7684\66FF\4EE3\6A19\7C64. \9810\8A2D\6A19\7C64\662F<em>\65B0\589E\8CC7\6599\5217</em>.</p>'),
unistr('        <p>\4F8B\5982, \91DD\5C0D\5728\5176\4E2D\7DAD\8B77\54E1\5DE5\7684\4E92\52D5\5F0F\65B9\683C, \8F38\5165 <em>Add Employee</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109462021412313722)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\6309\9215\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109460391210313721)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\5728\4E92\52D5\5F0F\65B9\683C\76EE\524D\672A\50B3\56DE\4EFB\4F55\8A18\9304\6642\65B0\589E\8CC7\6599\5217.'),
unistr('        \56E0\70BA\4E00\5F8B\6703\986F\793A\81F3\5C11\4E00\7B46\8A18\9304, \6240\4EE5\4E0D\6703\986F\793A<em>\627E\4E0D\5230\8CC7\6599</em>\8A0A\606F.</p>'),
unistr('        <p>\6CE8\610F - \5982\679C\672A\5C0D\5DF2\65B0\589E\7684\8A18\9304\9032\884C\4EFB\4F55\66F4\65B0, \5247\5728\5132\5B58\5340\57DF\6642\4E0D\6703\9032\884C\63D2\5165.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109460254311313721)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\767D\6642\65B0\589E\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109943887339314103)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\65B0\589E\81F3\6B64\9762\5411\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109918835573314085)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\65B0\589E\81F3\6B64\9762\5411\7FA4\7D44\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109475508054313732)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\65B0\589E\81F3\6B64\5143\4EF6\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.</p>'),
unistr('        <p>\6CE8\610F: \7576\4E92\52D5\5F0F\65B9\683C\70BA\53EF\7DE8\8F2F\6642, \6B64\7279\6027\53EF\7528\65BC\4FEE\6539\5C0D\61C9\9805\76EE\7684\6A23\5F0F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109920543012314086)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\65B0\589E\81F3\6B64\5143\4EF6\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.</p>'),
unistr('        <p>\6CE8\610F: \9019\4E9B CSS \985E\5225\5C07\6703\5957\7528\81F3 HTML \8868\55AE\5143\7D20\6A19\8A18.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109282492721313586)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\65B0\589E\81F3\6B64\7BE9\9078\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109283187677313587)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\65B0\589E\81F3\6B64\7BE9\9078\7FA4\7D44\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109919903290314086)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5C07 CSS \985E\5225 <code>articlenumber</code> \548C <code>highlight</code> \65B0\589E\81F3\5143\4EF6\7684 HTML \6A19\8A18</dt>'),
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109919846425314086)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5143\4EF6\8981\5305\542B\7684\5176\4ED6 CSS \985E\5225 (\4EE5\7A7A\683C\5340\9694).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109919750580314086)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109262205873313566)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\53D7\6B64\52D5\4F5C\5F71\97FF\7684\6309\9215.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109262106961313566)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110097894788314214)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\53D7\6B64\52D5\4F5C\5F71\97FF\7684\4E00\6216\591A\500B\8CC7\6599\6B04.'),
unistr('\82E5\6709\591A\500B\8CC7\6599\6B04, \8ACB\4F7F\7528\9017\865F\5340\9694\6BCF\500B\8CC7\6599\6B04\540D\7A31.'),
unistr('<p>\60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\8CC7\6599\6B04\6E05\55AE\4E2D\6311\9078.'),
unistr('\5982\679C\5F9E\6E05\55AE\4E2D\6311\9078, \4E14\540C\6642\9593\5DF2\7D93\6709\8F38\5165\7684\6587\5B57\7684\8A71, \5C07\6703\5728\73FE\6709\6587\5B57\7684\7D50\5C3E\52A0\4E0A\4E00\500B\9017\865F, \5F8C\9762\518D\63A5\8457\5F9E\6E05\55AE\50B3\56DE\7684\8CC7\6599\6B04\540D\7A31.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110097752253314214)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109262602630313567)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165 DOM \7269\4EF6 (<code>document</code>\3001<code>window</code>) \6216 DOM \7269\4EF6\7684 <em>id</em> (<code>myElementID</code>) \4F5C\70BA\53D7\6B64\52D5\4F5C\5F71\97FF\7684\5143\7D20.</p>'),
unistr('<p>\6CE8\610F: <em>DOM \7269\4EF6</em>\5DF2\7D93\88AB\53D6\4EE3, \61C9\8A72\53D6\4EE3\70BA <em>JavaScript \8868\793A\5F0F</em>\6216 <em>jQuery \9078\53D6\5668</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109262596006313567)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('DOM \7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109262466451313567)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\53D7\6B64\52D5\4F5C\5F71\97FF\7684\4E00\6216\591A\500B\9801\9762\9805\76EE.'),
unistr('\82E5\6709\591A\500B\9805\76EE, \8ACB\4F7F\7528\9017\865F\5340\9694\6BCF\500B\9805\76EE\540D\7A31.'),
unistr('<p>\60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\5F9E\53EF\7528\9805\76EE\7684\6E05\55AE\6311\9078.'),
unistr('\82E5\60A8\5F9E\6E05\55AE\4E2D\6311\9078\4F46\76EE\524D\5DF2\7D93\6709\8F38\5165\7684\6587\5B57, \5247\6703\5728\73FE\6709\6587\5B57\7684\7D50\5C3E\52A0\4E0A\9017\865F, \9017\865F\5F8C\7DCA\63A5\8457\6E05\55AE\50B3\56DE\7684\9805\76EE\540D\7A31.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109262334002313567)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110094252997314211)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\50B3\56DE\700F\89BD\5668\4E4B <code>window</code> DOM \7269\4EF6\7684\53C3\7167.</dt>'),
'<dd><code>window</code></dd>',
unistr('<dt>\50B3\56DE\700F\89BD\5668\4E4B <code>document</code> DOM \7269\4EF6\7684\53C3\7167.</dt>'),
'<dd>document</dd>',
unistr('<dt>jQuery \9078\53D6\5668\6703\9078\53D6\985E\5225\70BA ''alert'' \7684\6240\6709 DIV \5143\7D20, \7136\5F8C\50B3\56DE\542B\6709\6240\6709\5176\7236\9805\7684 jQuery \7269\4EF6.</dt>'),
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110094176506314211)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8981\8A55\4F30\7684 JavaScript \8868\793A\5F0F, \4EE5\50B3\56DE\55AE\4E00 DOM \7269\4EF6\3001DOM \7269\4EF6\9663\5217\6216\662F jQuery \7269\4EF6, \4F5C\70BA\53D7\6B64\52D5\4F5C\5F71\97FF\7684\5143\7D20.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110094095955314211)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109752623853313963)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\9078\53D6 DOM ID \70BA <code>my_id</code> \7684\9801\9762\5143\7D20</dt>'),
'<dd><pre>#my_id</pre></dd>',
unistr('<dt>\9078\53D6\542B\6709 <code>my_class</code> \985E\5225\7684\6240\6709\9801\9762\5143\7D20</dt>'),
'<dd><pre>.my_class</pre></dd>',
unistr('<dt>\9078\53D6\4F5C\70BA\8F38\5165\9805\7684\6240\6709\9801\9762\5143\7D20</dt>'),
'<dd><pre>input</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109262824842313567)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165 jQuery \9078\53D6\5668\8A9E\6CD5, \4EE5\50B3\56DE\4E00\6216\591A\500B\53D7\6B64\52D5\4F5C\5F71\97FF\7684\9801\9762\5143\7D20. jQuery \7A0B\5F0F\5EAB\63D0\4F9B\5F37\5927\7684\9078\53D6\5668\8A9E\6CD5, \8B93\60A8\80FD\5920\8F15\6613\5B58\53D6\9801\9762\4E0A\7684\4E00\6216\591A\500B\5143\7D20.</p>'),
unistr('<p>\5982\9700\9078\53D6\5668\8A9E\6CD5\7684\8A73\7D30\8CC7\8A0A, \8ACB\53C3\95B1\4F4D\65BC <a rel="noreferrer" target="_blank" href="http://docs.jquery.com">jQuery homepage</a> \7684\5B98\65B9\6587\4EF6.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109262705628313567)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('jQuery \9078\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109262020172313566)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\53D7\6B64\52D5\4F5C\5F71\97FF\7684\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109261976568313566)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109261807422313566)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5982\4F55\5B9A\7FA9\57F7\884C\6B64\52D5\4F5C\6642\53D7\5F71\97FF\7684\9801\9762\5143\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109751406656313962)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109751582833313962)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\6703\5F71\97FF\60A8\9078\53D6\7684\6309\9215.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110097196164314213)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110097216436314213)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\52D5\4F5C\6703\5F71\97FF\60A8\8F38\5165\7684\4E00\6216\591A\500B\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109751892659313962)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('DOM \7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109751939909313962)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\6703\5F71\97FF\60A8\8F38\5165\7684\300CDOM \7269\4EF6\300D\6216 DOM ID \6240\8B58\5225\7684\9801\9762\5143\7D20.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109752414255313962)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109752506169313963)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\52D5\4F5C\6703\5F71\97FF\8D77\59CB\4E8B\4EF6\7684\9801\9762\5143\7D20, \5728\67D0\4E9B\60C5\6CC1\4E0B\53EF\80FD\8207\300C\89F8\767C\5143\7D20\300D\4E0D\540C.</p>'),
unistr('<p>\5728\6B64\9032\968E\7D44\614B\4E2D, \6307\5B9A\7684\89F8\767C\5143\7D20\4E00\822C\662F\8655\7406\5176\6240\6709\5B50\5143\7D20 (\4F8B\5982\8A72\5340\57DF\4E2D\7684\9801\9762\9805\76EE) \5F15\767C\4E4B\4E8B\4EF6\7684\5BB9\5668\5143\7D20 (\4F8B\5982\5340\57DF).'),
unistr('\60A8\53EF\4EE5\4F7F\7528\6B64\9078\64C7\9805\76EE\985E\578B\5728\89F8\767C\4E8B\4EF6\7684\5B50\5143\7D20 (\800C\975E\5BB9\5668\5143\7D20) \57F7\884C\52D5\4F5C.'),
unistr('\4F8B\5982, \82E5\60A8\6709\4E00\500B\5B9A\7FA9\60A8\9801\9762\4E2D\67D0\500B\5340\57DF\4E4B<strong>\8B8A\66F4</strong>\4E8B\4EF6\7684\52D5\614B\52D5\4F5C, \8A72\52D5\4F5C\6703\5F71\97FF\8B8A\66F4\4E4B\5340\57DF\4E2D\7684\5BE6\969B\9805\76EE.</p>'),
unistr('<p>\5C31\5B9A\7FA9\5F71\97FF\8A31\591A\9801\9762\5143\7D20\7684\884C\70BA\800C\8A00, \4F7F\7528<em>\4E8B\4EF6\4F86\6E90</em>\6703\662F\66F4\6709\6548\7387\7684\65B9\5F0F.'),
unistr('\5BB9\5668\5143\7D20\64F7\53D6\5B50\5143\7D20\5F15\767C\4E4B\4E8B\4EF6\7684\80FD\529B\7531\4E8B\4EF6\985E\578B\6240\6C7A\5B9A.'),
unistr('\4E0B\5217\4E8B\4EF6\985E\578B\652F\63F4\6B64\529F\80FD:</p>'),
'<ul>',
unistr('  <li><strong>\91CD\65B0\6574\7406\5F8C</strong> (apexafterrefresh)</li>'),
unistr('  <li><strong>\91CD\65B0\6574\7406\524D</strong> (apexbeforerefresh)</li>'),
unistr('  <li><strong>\8B8A\66F4</strong> (change)</li>'),
unistr('  <li><strong>\6309\4E00\4E0B</strong> (click)</li>'),
unistr('  <li><strong>\6309\5169\4E0B</strong> (dblclick)</li>'),
unistr('  <li><strong>\53D6\5F97\7126\9EDE</strong> (focus)</li>'),
unistr('  <li><strong>\6309\4E0B\6309\9375</strong> (keydown)</li>'),
unistr('  <li><strong>\6309\4F4F\6309\9375</strong> (keypress)</li>'),
unistr('  <li><strong>\653E\958B\6309\9375</strong> (keyup)</li>'),
unistr('  <li><strong>\5931\53BB\7126\9EDE</strong> (blur)</li>'),
unistr('  <li><strong>\6309\4E0B\6ED1\9F20\6309\9215</strong> (mousedown)</li>'),
unistr('  <li><strong>\653E\958B\6ED1\9F20\6309\9215</strong> (mouseup)</li>'),
unistr('  <li><strong>\6ED1\9F20\79FB\52D5</strong> (mousemove)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109751290307313962)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109751351941313962)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\6703\5F71\97FF\60A8\8F38\5165\7684\4E00\6216\591A\500B\9801\9762\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110093892961314211)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110093945856314211)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\6703\5F71\97FF\4F7F\7528\60A8\8F38\5165\4E4B\300CJavaScript \8868\793A\5F0F\300D\6240\50B3\56DE\7684\9801\9762\5143\7D20.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109752002340313962)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('jQuery \9078\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109752156409313962)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\6703\5F71\97FF\4F7F\7528\60A8\8F38\5165\4E4B jQuery \9078\53D6\5668\8A9E\6CD5\6240\50B3\56DE\7684\9801\9762\5143\7D20.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109751690922313962)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109751757853313962)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\6703\5F71\97FF\60A8\9078\53D6\7684\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109752224262313962)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89F8\767C\5143\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109752357970313962)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\6703\5F71\97FF\89F8\767C\52D5\614B\52D5\4F5C\7684\9801\9762\5143\7D20\6216\5143\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109261763205313566)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109374374064313655)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\805A\7E3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109374480802313656)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\503C\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110024625659314161)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\95DC\806F\4E4B\5716\8868\503C\8CC7\6599\6B04\7684\805A\7E3D\65B9\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110026133478314162)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8FD1\4F3C\76F8\7570\8A08\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110026285186314162)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\76F8\7570\503C\7684\8FD1\4F3C\6578\76EE. \5728\8655\7406\5927\91CF\8CC7\6599\6642, \6B64\805A\7E3D\65B9\5F0F\660E\986F\7684\6BD4<em>\76F8\7570\8A08\6578</em>\5FEB\4E86\8A31\591A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110025153600314161)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E73\5747\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110025239704314161)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\503C\8CC7\6599\6B04\7684\5E73\5747\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110024784385314161)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A08\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110024856050314161)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\8A18\9304\7B46\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110025943733314162)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\7570\8A08\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110026005268314162)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\76F8\7570\503C\7684\78BA\5BE6\6578\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110025735368314161)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5927\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110025800977314162)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\6700\5927\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110025324200314161)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\9593\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110025483841314161)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\4E2D\9593\7684\6578\5B57 (\6703\5FFD\7565\7A7A\503C). \6B64\805A\7E3D\65B9\5F0F\6700\9069\5408\50B3\56DE\4E2D\9593\6578\5B57\7684\9023\7E8C\5206\5E03\6A21\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110025546142314161)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5C0F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110025605562314161)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\6700\5C0F\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110024976617314161)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\548C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110025041304314161)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\503C\8CC7\6599\6B04\7684\7E3D\8A08.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110024569100314161)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\805A\7E3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109241101445313551)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\591A\6B21\9001\51FA\76F8\540C\7684\9801\9762.'),
unistr('\4F7F\7528\6B64\529F\80FD\907F\514D\91CD\8907\63D2\5165\76F8\540C\7684\8868\683C.'),
unistr('\7576\4E00\822C\4F7F\7528\8005\6309\4E00\4E0B\700F\89BD\5668\7684\4E0A\4E00\9801\6309\9215\5F8C\518D\6B21\9001\51FA\9801\9762, \6216\8005\6309\4E00\4E0B\700F\89BD\5668\7684\91CD\65B0\8F09\5165\6309\9215\6642, \5C31\6703\767C\751F\6B64\72C0\6CC1.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109742749525313955)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.N.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5426 - \7981\6B62\91CD\65B0\516C\5E03\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109742877722313955)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.Y.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F - \53EF\4EE5\91CD\65B0\516C\5E03\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109241065510313551)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\91CD\8907\7684\9801\9762\9001\51FA\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109570950740313808)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5728\300C\55AE\4E00\8A18\9304\6AA2\8996\300D\4E2D\662F\5426\8981\96B1\85CF\7A7A\503C\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109570825167313808)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\9664\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109571184059313808)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5728\300C\55AE\4E00\8A18\9304\6AA2\8996\300D\4E2D\662F\5426\53EA\986F\793A\76EE\524D\986F\793A\7684\8CC7\6599\6B04. \5982\679C\6307\5B9A<strong>\95DC\9589</strong>,\300C\55AE\4E00\8A18\9304\6AA2\8996\300D\4E2D\53EF\80FD\6703\4E00\4F75\986F\793A\672A\986F\793A\7684\5831\8868\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109571074638313808)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\9650\986F\793A\7684\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109565021347313803)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\805A\7E3D\6B64\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109564973716313803)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\805A\7E3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109565404528313803)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5728\5716\8868\5167\4F7F\7528\6B64\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109565366818313803)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109565259625313803)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5728\4ED6\5011\5B9A\7FA9\7684\904B\7B97\8CC7\6599\6B04\4E2D\4F7F\7528\6B64\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109565194588313803)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109564818488313803)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5728\63A7\5236\5206\6BB5\4E2D\4F7F\7528\6B64\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109564789615313803)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63A7\5236\5206\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109564463434313803)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\7BE9\9078\6B64\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109564320029313803)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109565602310313803)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\4F9D\64DA\6B64\8CC7\6599\6B04\9032\884C\7FA4\7D44.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109565595032313803)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44\4F9D\64DA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109564044360313802)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\96B1\85CF\6B64\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109563913051313802)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109564649793313803)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\6A19\793A\6B64\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109564593921313803)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108877851984313270)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\80FD\5728\6B64\5831\8868\5167\5B9A\7FA9\6A1E\7D10\5206\6790\8868\660E\7D30.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108877708234313270)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A1E\7D10\5206\6790\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109578928099313814)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5C07\5176\76EE\524D\7684\5831\8868\5B9A\7FA9\5132\5B58\6210<em>\516C\7528</em>\5831\8868.</p>'),
unistr('<p>\516C\7528\5831\8868\6703\986F\793A\5728\300C\641C\5C0B\5217\300D\7684\53EF\7528\5831\8868\9078\53D6\6E05\55AE\4E2D, \4E26\4E14\6240\6709\4F7F\7528\8005\90FD\53EF\4EE5\770B\898B.'),
unistr('\300C\52D5\4F5C\300D\529F\80FD\8868\4E0A\7684\9019\500B\9078\9805\50C5\4F9B\5DF2\8A8D\8B49\7684\4F7F\7528\8005\4F7F\7528, \5982\679C\60A8\4E00\4F75\586B\5165<strong>\5132\5B58\516C\7528\5831\8868\6388\6B0A</strong>, \5247\6703\6709\9032\4E00\6B65\9650\5236.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109578836505313813)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\516C\7528\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109578782155313813)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5C07\5176\76EE\524D\7684\5831\8868\5B9A\7FA9\5132\5B58\6210<em>\5C08\7528</em>\5831\8868.</p>'),
unistr('<p>\5C08\7528\5831\8868\6703\986F\793A\5728\300C\641C\5C0B\5217\300D\7684\53EF\7528\5831\8868\9078\53D6\6E05\55AE\4E2D, \4E26\4E14\53EA\6709\5132\5B58\5831\8868\7684\4F7F\7528\8005\53EF\4EE5\770B\898B, \4F46\524D\63D0\662F\4ED6\5011\5FC5\9808\5DF2\7D93\904E\8A8D\8B49.'),
unistr('\300C\52D5\4F5C\300D\529F\80FD\8868\4E0A\7684\9019\500B\9078\9805\50C5\4F9B\5DF2\8A8D\8B49\7684\4F7F\7528\8005\4F7F\7528.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109578666874313813)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109579158723313814)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5132\5B58\5831\8868\985E\5225.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109579077425313814)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\5831\8868\985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109564273130313803)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\6392\5E8F\6B64\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109564185628313802)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109465832834313725)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\8981\5728\5C0D\8A71\65B9\584A\548C\300C\55AE\4E00\8CC7\6599\5217\6AA2\8996\300D\4E2D\4F7F\7528\7684\66FF\4EE3\6A19\7C64.'),
unistr('        \6A19\984C\5305\542B\672A\6B63\78BA\986F\793A\7684\984D\5916\683C\5F0F (\4F8B\5982 HTML \6A19\8A18) \6642, \6703\4F7F\7528\66FF\4EE3\6A19\7C64.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109465732240313725)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66FF\4EE3\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109342613331313631)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\8981\4E00\5F8B\57F7\884C\6B64\9A57\8B49.'),
unistr('\5982\679C\8A2D\70BA<strong>\958B\555F</strong>, \5247\7121\8AD6\91DD\5C0D\9001\51FA\9801\9762\7684\6309\9215\6240\5B9A\7FA9\7684<em>\57F7\884C\9A57\8B49</em>\8A2D\5B9A\503C\70BA\4F55, \90FD\5C07\4E00\5F8B\8A55\4F30\6B64\9A57\8B49.'),
unistr('\5982\679C\8A2D\70BA<strong>\95DC\9589</strong>, \5247\53EA\6709\7576\89F8\767C\6309\9215\7684<em>\57F7\884C\9A57\8B49</em>\8A2D\5B9A\503C\70BA<strong>\958B\555F</strong>\6642, \624D\6703\8A55\4F30\6B64\9A57\8B49.</p>'),
unistr('<p>\6CE8\610F: \6B64\9A57\8B49\4E5F\662F\5FC5\9808\5148\7B26\5408\6307\5B9A\7684\689D\4EF6, \624D\6703\9032\884C\8A55\4F30.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109342520671313631)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\57F7\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109508762798313757)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\662F\5426\5728\5716\8868\4E0A\7684\8CC7\6599\8B8A\66F4\6642\986F\793A\52D5\756B. \5982\679C\81EA\52D5\91CD\65B0\6574\7406\5716\8868\3001\6309\4E00\4E0B\5716\4F8B\9805\76EE\6642\57F7\884C\96B1\85CF\548C\986F\793A\884C\70BA, \6216\900F\904E\67D0\500B\81EA\8A02 JavaScript \7A0B\5F0F\78BC\6216\300C\52D5\614B\52D5\4F5C\300D\4EE5\7A0B\5F0F\8A2D\8A08\65B9\5F0F\66F4\65B0\5716\8868\8CC7\6599, \8CC7\6599\53EF\80FD\6703\8B8A\66F4.</p>'),
unistr('        <p><strong>\5411\5DE6\6ED1\52D5</strong>\548C<strong>\5411\53F3\6ED1\52D5</strong>\9078\9805\4E0D\9069\7528\65BC\8A08\91CF\5716.</p>  ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109508861669313757)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109639348875313861)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528\5716\8868\7684 Oracle JET \5DF2\5B9A\7FA9\9810\8A2D\52D5\756B\8A2D\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109509127536313757)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109648892089313869)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8B8A\66F4\6642\4E0D\6703\5728\5716\8868\5957\7528\52D5\756B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109508912190313757)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5411\5DE6\6ED1\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109648643264313869)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8B8A\66F4\5F8C\8CC7\6599\5143\7D20\6703\5411\5DE6\6ED1\52D5. \9019\9805\8A2D\5B9A\4E0D\9069\7528\65BC\7518\7279\5716.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109509040969313757)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5411\53F3\6ED1\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109648757217313869)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8B8A\66F4\5F8C\8CC7\6599\5143\7D20\6703\5411\53F3\6ED1\52D5. \9019\9805\8A2D\5B9A\4E0D\9069\7528\65BC\7518\7279\5716.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109508604658313757)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8B8A\66F4\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109508123425313756)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\4E00\958B\59CB\986F\793A\5716\8868\6642\6240\4F7F\7528\7684\52D5\756B\985E\578B.</p>'),
unistr('        <p><strong>Alpha \503C\6DE1\5165</strong>\548C<strong>\7E2E\653E</strong>\9078\9805\4E0D\9069\7528\65BC\8A08\91CF\5716.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109508357993313757)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Alpha \503C\6DE1\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109639025632313861)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\958B\59CB\986F\793A\6642\8B93\5716\8868\9010\6F38\6DE1\5165. \9019\9805\8A2D\5B9A\4E0D\9069\7528\65BC\7518\7279\5716.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109508290075313756)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109638921940313861)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528\5716\8868\7684 Oracle JET \5DF2\5B9A\7FA9\9810\8A2D\52D5\756B\8A2D\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109508553283313757)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109639231259313861)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\958B\59CB\986F\793A\6642\4E0D\5C07\4EFB\4F55\52D5\756B\5957\7528\81F3\5716\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109508469811313757)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E2E\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109639168500313861)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\958B\59CB\986F\793A\6642\653E\5927\5716\8868. \9019\9805\8A2D\5B9A\4E0D\9069\7528\65BC\7518\7279\5716.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109508056191313756)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109920639256314086)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\65B0\589E\81F3\6B64\5143\4EF6\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109943761875314103)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\65B0\589E\81F3\6B64\5143\4EF6\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109921477657314087)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\60F3\8981\65B0\589E\81F3\60A8\5831\8868\7684\5176\4ED6 CSS \985E\5225 (\4EE5\7A7A\683C\5340\9694). \60A8\7684\5831\8868\6A23\677F\5FC5\9808\5305\62EC <code>#COMPONENT_CSS_CLASSES#</code> \66FF\4EE3\5B57\4E32.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109475320380313732)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\65B0\589E\81F3\6B64\5143\4EF6\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.</p>'),
'',
unistr('        <p>\6CE8\610F: \9019\4E9B CSS \985E\5225\5C07\6703\5957\7528\81F3\4E92\52D5\5F0F\65B9\683C\4E2D\7684\5132\5B58\683C. \82E5\8981\5C07 CSS \985E\5225\5957\7528\81F3\5C0D\61C9\7684\9805\76EE, \8ACB\67E5\770B\300C\9032\968E\300D\7FA4\7D44\5E95\4E0B\7684\300CCSS \985E\5225\300D\7279\6027.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109920377104314086)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\65B0\589E\81F3\6B64\5143\4EF6\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109920453366314086)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\65B0\589E\81F3\6B64\9805\76EE\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.<p/>'),
unistr('        <p>\6B64\7279\6027\53EF\7528\65BC\4FEE\6539\9805\76EE\7684\6A23\5F0F (\662F\6A23\677F\9078\9805\4E4B\5916\7684\53E6\4E00\7A2E\65B9\5F0F), \6216\8005\8B93\60A8\80FD\4EE5\8F03\7C21\55AE\7684\65B9\5F0F\900F\904E JavaScript \9078\53D6\6B64\9805\76EE.</p>'),
unistr('        <p>\6CE8\610F: \82E5\8981\5728 HTML \8868\55AE\5143\7D20\6A19\8A18\5957\7528 CSS \985E\5225, \8ACB\53C3\95B1\300C\9032\968E\300D\7FA4\7D44\7684\300CCSS \985E\5225\300D\7279\6027.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109920726205314086)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\65B0\589E\81F3\6B64\5143\4EF6\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109921665372314087)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\65B0\589E\81F3\6B64\5143\4EF6\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109921569891314087)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\60F3\8981\65B0\589E\81F3\60A8\5831\8868\7684\5176\4ED6 CSS \985E\5225 (\4EE5\7A7A\683C\5340\9694). \60A8\7684\5831\8868\6A23\677F\5FC5\9808\5305\62EC <code>#COMPONENT_CSS_CLASSES#</code> \66FF\4EE3\5B57\4E32.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109920239522314086)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5C07 CSS \985E\5225 <code>articlenumber</code> \548C <code>highlight</code> \65B0\589E\81F3\5143\4EF6</dt>'),
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109920153542314086)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\65B0\589E\81F3\6B64\5143\4EF6\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109920035612314086)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108879378344313271)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\6B64\61C9\7528\7A0B\5F0F\7684\7BC4\570D. \5982\679C &PRODUCT_NAME. \968E\6BB5\4F5C\696D\662F\7531\591A\500B\61C9\7528\7A0B\5F0F\5171\7528, \800C\4E14\6240\6709\61C9\7528\7A0B\5F0F\7684\9805\76EE\503C\90FD\61C9\8A72\76F8\540C, \8ACB\9078\53D6<strong>\5168\57DF</strong>.'),
unistr('\5426\5247, \8ACB\9078\53D6<strong>\61C9\7528\7A0B\5F0F</strong> (\9019\662F\9810\8A2D\7BC4\570D).</p>'),
unistr('<p>\5982\679C\61C9\7528\7A0B\5F0F\7684\8A8D\8B49\5177\6709\76F8\540C\7684<em>\968E\6BB5\4F5C\696D Cookie \5C6C\6027</em>, \5373\53EF\5171\7528\76F8\540C\7684\968E\6BB5\4F5C\696D.'),
unistr('\9019\4E9B\61C9\7528\7A0B\5F0F\4E2D\7684\61C9\7528\7A0B\5F0F\9805\76EE\7684\7BC4\570D\5C6C\6027\7686\9808\76F8\540C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109774516664313979)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.APP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109774649025313979)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.GLOBAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108879284448313271)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\570D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109525342455313769)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5C07\76EE\524D\6578\5217\6307\5B9A\7D66\5716\8868\4E0A\6240\5448\73FE\7684 Y2 \8EF8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109525258223313769)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7D66 Y2 \8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109343241982313632)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8207\6B64\9801\9762\8655\7406\5143\4EF6\95DC\806F\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109343137006313632)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\95DC\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109343032267313632)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\5C07\986F\793A\6B64\9A57\8B49\932F\8AA4\8A0A\606F\7684\9805\76EE.'),
unistr('\5982\679C\60A8\9078\53D6\67D0\500B\9805\76EE, \800C<em>\932F\8AA4\8A0A\606F\986F\793A\4F4D\7F6E</em>\5305\62EC\300C\5167\5D4C\65BC\6B04\4F4D\4E2D\300D, \932F\8AA4\8A0A\606F\5C07\6703\986F\793A\5728\6307\5B9A\9805\76EE\7684\6A19\7C64\4E0B\65B9.'),
unistr('\5982\679C<em>\932F\8AA4\8A0A\606F\986F\793A\4F4D\7F6E</em>\672A\5305\62EC\300C\5167\5D4C\65BC\6B04\4F4D\4E2D\300D, \6B64\5C6C\6027\5C31\4E0D\6703\5F71\97FF\932F\8AA4\8A0A\606F\7684\986F\793A.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109342936113313632)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\95DC\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109946789694314105)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.LOV.NATIVE_CUSTOM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109325065166313618)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\914D\7F6E\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109270636439313573)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\4E00\500B\8981\5957\7528\81F3\9801\9762\7684\6388\6B0A\914D\7F6E. \6388\6B0A\914D\7F6E\5728\61C9\7528\7A0B\5F0F\5C64\7D1A\5B9A\7FA9, \53EF\4EE5\5957\7528\81F3\61C9\7528\7A0B\5F0F\5167\7684\8A31\591A\5143\7D20.</p>'),
unistr('<p>\7CFB\7D71\6703\91DD\5C0D\6BCF\500B\61C9\7528\7A0B\5F0F\968E\6BB5\4F5C\696D\8A55\4F30\4E00\6B21\6388\6B0A\914D\7F6E (\5EFA\7ACB\968E\6BB5\4F5C\696D\6642), \6216\91DD\5C0D\6BCF\500B\9801\9762\6AA2\8996\8A55\4F30\4E00\6B21. \5982\679C\9078\53D6\7684\6388\6B0A\914D\7F6E\8A55\4F30\70BA <strong>TRUE</strong>, \5C31\6703\986F\793A\9801\9762\4E26\4E14\53D7\5176\4ED6\5B9A\7FA9\4E4B\689D\4EF6\7684\7BA1\5236. \5982\679C\8A55\4F30\70BA <strong>FALSE</strong>, \5C31\4E0D\6703\986F\793A\9801\9762\4F46\986F\793A\932F\8AA4\8A0A\606F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109240349309313550)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\63A7\5236\6B64\5143\4EF6\7684\6388\6B0A\914D\7F6E. \6B64\6388\6B0A\5FC5\9808\8A55\4F30\70BA TRUE, \624D\80FD\5448\73FE\6216\57F7\884C\6B64\5143\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109240254299313550)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109231225573313543)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\8981\5957\7528\7684\6388\6B0A\914D\7F6E. \652F\63F4\4E0B\5217\6388\6B0A\985E\578B:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\6839\64DA\60A8\61C9\7528\7A0B\5F0F\7D44\614B\7684\4E0D\540C, \6B64\8655\53EF\80FD\53E6\6709\5176\4ED6\6388\6B0A\985E\578B Plug-in \53EF\4EE5\4F7F\7528.'),
unistr('\9019\4E9B\52D5\4F5C\5C07\986F\793A\70BA<em>&lt;\6211\7684 Plug-in&gt; [Plug-in]</em>.'),
unistr('\4E0B\5217 Plug-in \5B89\88DD\5728\6B64\61C9\7528\7A0B\5F0F\5171\7528\5143\4EF6\5167:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109231187263313543)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110083156287314202)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\51FD\6578\4E3B\9AD4\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110083429529314202)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110083389299314202)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110083238452314202)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110083522923314202)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110083097515314202)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110084355448314203)
,p_name=>'PE.PROPERTY.AUTO5N_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\57F7\884C\81EA\52D5\5316\6642\6240\8A55\4F30\7684\8CC7\6599\4F86\6E90. \81EA\52D5\5316\53EF\4EE5\8868\683C\3001SQL \67E5\8A62\6216\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578\70BA\4F9D\64DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110084293631314203)
,p_name=>'PE.PROPERTY.AUTO5N_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110084158615314202)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110084057296314202)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\57F7\884C\81EA\52D5\5316\6642\6240\8A55\4F30\7684\8CC7\6599\4F86\6E90. \81EA\52D5\5316\53EF\4EE5\8868\683C\3001SQL \67E5\8A62\6216\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578\70BA\4F9D\64DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110083937066314202)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110083853925314202)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110083769827314202)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\57F7\884C\81EA\52D5\5316\6642\6240\8A55\4F30\7684\8CC7\6599\4F86\6E90. \81EA\52D5\5316\53EF\4EE5\8868\683C\3001SQL \67E5\8A62\6216\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578\70BA\4F9D\64DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110083618335314202)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110084518492314203)
,p_name=>'PE.PROPERTY.AUTO5N_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\57F7\884C\81EA\52D5\5316\6642\6240\8A55\4F30\7684\8CC7\6599\4F86\6E90. \81EA\52D5\5316\53EF\4EE5\8868\683C\3001SQL \67E5\8A62\6216\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578\70BA\4F9D\64DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110084404010314203)
,p_name=>'PE.PROPERTY.AUTO5N_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110082677192314201)
,p_name=>'PE.PROPERTY.AUTOMATION_ADDL_PLSQL_CODE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110082513183314201)
,p_name=>'PE.PROPERTY.AUTOMATION_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110082410491314201)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\57F7\884C\81EA\52D5\5316\6642\6240\8A55\4F30\7684\8CC7\6599\4F86\6E90. \81EA\52D5\5316\53EF\4EE5\8868\683C\3001SQL \67E5\8A62\6216\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578\70BA\4F9D\64DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110082361766314201)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F86\6E90\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110082975078314202)
,p_name=>'PE.PROPERTY.AUTO_ACTION_CODE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110082890379314202)
,p_name=>'PE.PROPERTY.AUTO_ACTION_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\52D5\4F5C\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110082737488314201)
,p_name=>'PE.PROPERTY.AUTO_ACTION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109381639655313661)
,p_name=>'PE.PROPERTY.AUTO_DETECT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\662F\5426\8981\81EA\52D5\5075\6E2C\9069\7576\7684\4F7F\7528\8005\4ECB\9762.'),
unistr('\5982\679C<strong>\958B\555F</strong>\81EA\52D5\5075\6E2C, \5C07\6703\6839\64DA\6240\4F7F\7528\88DD\7F6E\7684\5927\5C0F, \5C07\4F7F\7528\8005\81EA\52D5\91CD\65B0\5C0E\5411\81F3\6700\9069\5408\7684\767B\5165\9801\9762\6216\9996\9801.'),
unistr('\7CFB\7D71\6703\4F7F\7528\300C\5A92\9AD4\67E5\8A62\300D\4F86\5224\65B7\8981\986F\793A\7684\5C0D\61C9\4F7F\7528\8005\4ECB\9762.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109381552744313661)
,p_name=>'PE.PROPERTY.AUTO_DETECT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\5075\6E2C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109527305607313771)
,p_name=>'PE.PROPERTY.AXIS_MAX.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5EA7\6A19\8EF8\7684\6700\5927\503C. \6839\64DA\8CC7\6599\9032\884C\7684\81EA\52D5\8A08\7B97\6703\9810\8A2D\662F\7A7A\503C.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109527255322313771)
,p_name=>'PE.PROPERTY.AXIS_MAX.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5927\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109527109248313770)
,p_name=>'PE.PROPERTY.AXIS_MIN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5EA7\6A19\8EF8\7684\6700\5C0F\503C. \6839\64DA\8CC7\6599\9032\884C\7684\81EA\52D5\8A08\7B97\6703\9810\8A2D\662F\7A7A\503C.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109527083684313770)
,p_name=>'PE.PROPERTY.AXIS_MIN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5C0F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109528156489313771)
,p_name=>'PE.PROPERTY.AXIS_POSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5716\8868\6A19\7C64\7684\4F4D\7F6E.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109528246970313771)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.AUTO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109528626086313772)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.BOTTOM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109528427048313771)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.END.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109528313756313771)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.START.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109528576278313771)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.TOP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109528069787313771)
,p_name=>'PE.PROPERTY.AXIS_POSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109550545449313788)
,p_name=>'PE.PROPERTY.AXIS_SCALING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5EA7\6A19\8EF8\523B\5EA6. \50C5\9069\7528\65BC\6578\503C\8EF8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109550616418313788)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LINEAR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DDA\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109550706141313788)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LOG.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\8A8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109550484872313788)
,p_name=>'PE.PROPERTY.AXIS_SCALING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\523B\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109527975529313771)
,p_name=>'PE.PROPERTY.AXIS_STEP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4E3B\8981\523B\5EA6\6A19\8A18\4E4B\9593\7684\589E\91CF. \6839\64DA\8CC7\6599\9032\884C\7684\81EA\52D5\8A08\7B97\6703\9810\8A2D\662F\7A7A\503C. \50C5\9069\7528\65BC\6642\9593\548C\6578\503C\8EF8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109527898278313771)
,p_name=>'PE.PROPERTY.AXIS_STEP.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D1A\8DDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109934832294314097)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7576\4F5C\6A19\8A18\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109934700538314097)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\8A18\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109935053349314097)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\65B0\589E\81F3\6B64\5143\4EF6\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109934926507314097)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\8A18 CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109935383040314097)
,p_name=>'PE.PROPERTY.BADGE_LABEL.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\986F\793A\96FB\5F71\8A55\6BD4</dt>'),
unistr('    <dd>\6A19\8A18\8CC7\6599\6B04\53EF\4EE5\662F\300C\8A55\6BD4\300D\8CC7\6599\6B04, \6A19\8A18\6A19\7C64\5247\53EF\4EE5\662F\300C\661F\865F\300D</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109935207784314097)
,p_name=>'PE.PROPERTY.BADGE_LABEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\63CF\8FF0\6A19\8A18\503C\7684\6A19\8A18\6A19\7C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109935105204314097)
,p_name=>'PE.PROPERTY.BADGE_LABEL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\8A18\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109630394002313855)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\884C\4E8B\66C6\5F9E\4F55\6642\958B\59CB. \9078\53D6\6B64\9078\9805\6703\5EFA\7ACB\8DE8\6574\500B\9593\9694 (\4F8B\5982, \4E00\500B\6708) \7684\884C\4E8B\66C6.</p>'),
'<ul>',
unistr('<li>\5982\679C\300C\5728\9593\9694\958B\59CB\8655\958B\59CB\300D\8A2D\70BA<strong>\958B\555F</strong>, \7576\65E5\671F\662F 6 \6708 15 \65E5, \800C\986F\793A\70BA\6BCF\6708\6642, \7522\751F\7684\884C\4E8B\66C6\5C31\6703\5F9E 6 \6708 1 \65E5\5230 6 \6708 30 \65E5.</li>'),
unistr('<li>\5982\679C\300C\5728\9593\9694\958B\59CB\8655\958B\59CB\300D\8A2D\70BA<strong>\95DC\9589</strong>, \7576\65E5\671F\70BA 6 \6708 15 \65E5, \800C\986F\793A\70BA\6BCF\6708\6642, \7522\751F\7684\884C\4E8B\66C6\5C31\6703\5F9E 6 \6708 15 \65E5\5230 6 \6708 30 \65E5.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109630265502313855)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\9593\9694\958B\59CB\8655\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109601659162313833)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5132\5B58\60A8\60F3\8981\986F\793A\4E4B BLOB \5167\5BB9\7684\8868\683C\4E2D\9078\53D6\5B57\5143\96C6\8CC7\6599\6B04. \5982\679C\6240\9078\8CC7\6599\6B04\7684\8CC7\6599\985E\578B\932F\8AA4, \5C07\4E0D\6703\986F\793A\5F71\50CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109601588227313833)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\5143\96C6\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109600601874313833)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5132\5B58\60A8\60F3\8981\986F\793A\4E4B BLOB \5167\5BB9\7684\8868\683C\4E2D\9078\53D6 BLOB \8CC7\6599\6B04. \5982\679C\6240\9078\8CC7\6599\6B04\7684\8CC7\6599\985E\578B\932F\8AA4, \5C07\4E0D\6703\986F\793A\5F71\50CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109600543613313833)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('BLOB \8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109601476032313833)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6A94\6848\540D\7A31\8CC7\6599\6B04, \6B64\8CC7\6599\6B04\4F86\81EA\5132\5B58\60A8\60F3\8981\986F\793A\4E4B BLOB \5167\5BB9\7684\8868\683C. \5982\679C\6240\9078\8CC7\6599\6B04\7684\8CC7\6599\985E\578B\932F\8AA4, \5C07\4E0D\6703\986F\793A\5F71\50CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109601341275313833)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\540D\7A31\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109601812836313834)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5132\5B58\60A8\60F3\8981\986F\793A\4E4B BLOB \5167\5BB9\7684\8868\683C\4E2D\9078\53D6\4E0A\6B21\66F4\65B0\6642\9593\8CC7\6599\6B04. \5982\679C\60A8\5DF2\7D93\6709\4E00\500B\542B\6709\76F8\95DC\89F8\767C\7A0B\5F0F\4F86\7DAD\8B77\65E5\671F\7684 <code>UPDATED</code> \8CC7\6599\6B04, \5C31\53EF\4EE5\4F7F\7528\6B64\8CC7\6599\6B04, \800C\4E0D\9700\8981\7279\5225\91DD\5C0D\4E0A\6B21\66F4\65B0\5F71\50CF\7684\6642\9593\5B9A\7FA9\4E00\500B\65B0\7684\8CC7\6599\6B04. \4E0D\904E, \5982\679C\5B9A\671F\66F4\65B0\7684\5C0D\8C61\662F BLOB \5167\5BB9\4EE5\5916\7684\8CC7\6599\6B04, \5247\6703\5C0D\5F71\50CF\5FEB\53D6\7522\751F\8CA0\9762\5F71\97FF. \5982\679C\6240\9078\8CC7\6599\6B04\7684\8CC7\6599\985E\578B\932F\8AA4, \5C07\4E0D\6703\986F\793A\5F71\50CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109601759331313834)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\6B21\66F4\65B0\6642\9593\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109601268848313833)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5132\5B58\60A8\60F3\8981\986F\793A\4E4B BLOB \5167\5BB9\7684\8868\683C\4E2D\9078\53D6 MIME \985E\578B\8CC7\6599\6B04. \5982\679C\6240\9078\8CC7\6599\6B04\7684\8CC7\6599\985E\578B\932F\8AA4, \5C07\4E0D\6703\986F\793A\5F71\50CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109601104269313833)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('MIME \985E\578B\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109600868818313833)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5132\5B58\60A8\60F3\8981\986F\793A\4E4B BLOB \5167\5BB9\7684\8868\683C\4E2D\9078\53D6\7B2C\4E00\500B\4E3B\7D22\5F15\9375\8CC7\6599\6B04. \5982\679C\6B64\8868\683C\7684\4E3B\7D22\5F15\9375\6709\5169\500B\4EE5\4E0A\7684\8CC7\6599\6B04, \60A8\5C31\5FC5\9808\9078\53D6 <code>ROWID</code> \8CC7\6599\6B04. \5982\679C\6240\9078\8CC7\6599\6B04\7684\8CC7\6599\985E\578B\932F\8AA4, \5C07\4E0D\6703\986F\793A\5F71\50CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109600728122313833)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109601059030313833)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\6709\7576\60A8\8868\683C\7684\4E3B\7D22\5F15\9375\6709\5169\500B\8CC7\6599\6B04\6642, \624D\53EF\9078\53D6\7B2C\4E8C\500B\4E3B\7D22\5F15\9375\8CC7\6599\6B04. \5982\679C\60A8\9078\53D6\4E86 <code>ROWID</code> \4F5C\70BA\7B2C\4E00\500B\4E3B\7D22\5F15\9375\8CC7\6599\6B04, \5C31\4E0D\61C9\8A72\7522\751F\6B64\8CC7\6599\6B04. \5982\679C\6240\9078\8CC7\6599\6B04\7684\8CC7\6599\985E\578B\932F\8AA4, \5C07\4E0D\6703\986F\793A\5F71\50CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109600954254313833)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109600411514313833)
,p_name=>'PE.PROPERTY.BLOB_TABLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\5132\5B58\60A8\60F3\8981\986F\793A\4E4B BLOB \5167\5BB9\7684\8868\683C\540D\7A31.'),
unistr('\60A8\53EF\4EE5\8F38\5165\8868\683C\540D\7A31\6216\5F9E\53EF\7528\8868\683C\7684\6E05\55AE\4E2D\9078\64C7.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109600388281313832)
,p_name=>'PE.PROPERTY.BLOB_TABLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109600296335313832)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7DB1\8981, \6B64\7DB1\8981\64C1\6709\5132\5B58\60A8\60F3\8981\986F\793A\4E4B BLOB \5167\5BB9\7684\8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109600122572313832)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109930419216314093)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\5143\4EF6\662F\4F7F\7528\4E00\500B\8CC7\6599\6B04\9084\662F\9032\968E\683C\5F0F (\4F7F\7528 HTML \8868\793A\5F0F\548C\652F\63F4\7684\66FF\4EE3\5B57\4E32) \986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109930357330314093)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\968E\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109930608265314094)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7576\4F5C\4E3B\9AD4\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109930597256314094)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109931187648314094)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\65B0\589E\81F3\6B64\5143\4EF6\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109931093531314094)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109239909697313550)
,p_name=>'PE.PROPERTY.BODY_HEADER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\5728\57F7\884C\4E2D\9801\9762\7684\5340\57DF\4E4B\524D\986F\793A\7684\6587\5B57\6216 HTML.'),
unistr('\60A8\5728\6B64\8655\8F38\5165\7684\6587\5B57\6703\986F\793A\5728\9801\9762\6A23\677F <code>#BODY#</code> \66FF\4EE3\5B57\4E32\4E4B\524D.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109239861081313550)
,p_name=>'PE.PROPERTY.BODY_HEADER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\9AD4\6A19\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109930912253314094)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\8B8A\66F4\80CC\666F\8207\6587\5B57\8272\5F69</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\4F7F\7528\6A19\984C 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>\4F7F\7528\4F86\81EA SQL \67E5\8A62\7684\52D5\614B\985E\5225</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \6B64\7BC4\4F8B\4E2D\7684 <code>&COLUMN_CLASS.</code> \8207 <code>&EMPLOYEE_STATUS.</code> \66FF\4EE3\9805\76EE\70BA\5831\8868 SQL \67E5\8A62\4E2D\9078\53D6\7684\8CC7\6599\6B04.</dd>'),
unistr('  <dt>\6E38\6A19\505C\7559\6642\986F\793A\5F71\50CF\8207\5DE5\5177\63D0\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109930873416314094)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5728\6B64\8CC7\6599\6B04\4E2D\986F\793A\7684 HTML \8868\793A\5F0F. \82E5\8981\4EE5 HTML \683C\5F0F\986F\793A\8CC7\6599\6B04\503C, \8ACB\4F7F\7528 <code>&COLUMN.</code> \8A9E\6CD5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109930791631314094)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109621585077313849)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5305\62EC\5728\5206\652F\9023\7D50\5167\7684\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109621408120313849)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110019829061314157)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\51FD\6578\4E3B\9AD4\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110020199374314158)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110020052185314157)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110019979467314157)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110020295972314158)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110019758095314157)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109595225153313825)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\5305\542B\91CD\65B0\5C0E\5411\76EE\6A19\9801\78BC\6216 URL \7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.'),
unistr('\60A8\53EF\4EE5\85C9\7531\547C\53EB\9801\9762, \6216\85C9\7531\7B2C\4E00\6B21\8F09\5165\9801\9762\6642\7684\8655\7406\4F5C\696D, \8A2D\5B9A\6B64\9805\76EE.'),
unistr('\6307\5B9A\9805\76EE\53EF\4EE5\70BA\5F9E\8A31\591A\5176\4ED6\9801\9762\547C\53EB\7684\9801\9762, \63D0\4F9B\4E00\500B\52D5\614B\8A2D\5B9A\5206\652F\7684\8F15\9B06\65B9\5F0F.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109595147059313825)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110021002872314158)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\91CD\65B0\5C0E\5411\76EE\6A19\9801\78BC\6216 URL \7684 Java \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110020954408314158)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110020863103314158)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110020703786314158)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\91CD\65B0\5C0E\5411\76EE\6A19\9801\78BC\6216 URL \7684 JavaScript \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110020664321314158)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109341548408313631)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\5206\652F\7684\91CD\65B0\5C0E\5411\76EE\7684\5730\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109341436030313631)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109341792515313631)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5206\652F\6240\57F7\884C\7684 PL/SQL \7A0B\5F0F\78BC. \6B64 PL/SQL \7A0B\5E8F\8CA0\8CAC\547C\53EB\5FC5\8981\7684 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109341697341313631)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110020515486314158)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110020445366314158)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\91CD\65B0\5C0E\5411\76EE\6A19\9801\78BC\6216 URL \7684 PL/SQL \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110020380523314158)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109341118579313630)
,p_name=>'PE.PROPERTY.BRANCH_POINT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\9801\9762\5448\73FE\6216\8655\7406\671F\9593, \6B64\5206\652F\7684\57F7\884C\9EDE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109763088870313971)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110052649524314180)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406: \5728\57F7\884C\8655\7406\4E4B\5F8C\5EFA\7ACB\5206\652F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109762729130313970)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110052360974314180)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406: \5728\9001\51FA\9801\9762\5F8C, \4F46\57F7\884C\904B\7B97\3001\9A57\8B49\53CA\8655\7406\4E4B\524D\5EFA\7ACB\5206\652F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109763131891313971)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110052755591314180)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE: \5728\9801\9762\5448\73FE\4E4B\524D\5EFA\7ACB\5206\652F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109762913574313970)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5728\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110052593828314180)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406: \5728\57F7\884C\8655\7406\4E4B\524D\5EFA\7ACB\5206\652F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109762873988313970)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5728\9A57\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110052412988314180)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406: \5728\57F7\884C\9A57\8B49\4E4B\524D\5EFA\7ACB\5206\652F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109341032346313630)
,p_name=>'PE.PROPERTY.BRANCH_POINT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\9EDE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110021264111314158)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\91CD\65B0\5C0E\5411\76EE\6A19\9801\78BC\6216 URL \7684 Python \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110021112884314158)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109340915138313630)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\8981\57F7\884C\7684\9801\9762\5206\652F\985E\578B.</p>'),
'<dl>',
unistr('<dt>\91CD\65B0\5C0E\5411\5206\652F</dt>'),
unistr('<dd>&PRODUCT_NAME. \6703\5C07\65B0\7684\9801\9762\6216 URL \50B3\56DE\7D66\700F\89BD\5668, \4EE5\5728\986F\793A\7D50\679C\9801\9762\4E4B\524D\5148\57F7\884C\65B0\7684\8981\6C42.'),
unistr('\4E3B\8981\7684\512A\9EDE\662F\56E0\700F\89BD\5668\4F4D\5740\5305\542B\5B8C\6574\7684\9801\9762 URL, \6240\4EE5\4E00\822C\4F7F\7528\8005\53EF\4EE5\91CD\65B0\6574\7406\9801\9762\537B\53C8\4E0D\6703\907A\5931\76F8\95DC\8CC7\8A0A\74B0\5883.'),
unistr('\7F3A\9EDE\5247\662F\700F\89BD\5668\6703\57F7\884C\984D\5916\7684\8981\6C42\4F86\986F\793A\9801\9762.</dd>'),
unistr('<dt>\50C5\986F\793A\5206\652F</dt>'),
unistr('<dd>&PRODUCT_NAME. \6703\5728\8655\7406\76EE\524D\7684\9801\9762\6642\7ACB\5373\5448\73FE\65B0\7684\9801\9762, \800C\4E0D\57F7\884C\53E6\4E00\500B\8981\6C42.'),
unistr('\9019\9EBC\505A\7684\512A\9EDE\662F\700F\89BD\5668\4E0D\9700\8981\57F7\884C\984D\5916\7684\8981\6C42.'),
unistr('\4E3B\8981\7684\7F3A\9EDE\5247\662F\700F\89BD\5668\4F4D\5740\6703\662F <code>wwv_flow.accept</code>.'),
unistr('\56E0\70BA\700F\89BD\5668\4F4D\5740\4E0D\662F\5B8C\6574\7684\9801\9762 URL, \6240\4EE5\5982\679C\4E00\822C\4F7F\7528\8005\91CD\65B0\6574\7406\9801\9762, \700F\89BD\5668\5C07\6703\8981\6C42\91CD\65B0\50B3\9001\8CC7\6599.</dd>'),
'</dl>',
unistr('<p>Oracle \5EFA\8B70\60A8\9078\53D6\5176\4E2D\4E00\7A2E\91CD\65B0\5C0E\5411\5206\652F\985E\578B, \4EE5\63D0\4F9B\8F03\4F73\7684\4E00\822C\4F7F\7528\8005\9AD4\9A57.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109762123783313970)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_PAGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\9801\9762\7684\51FD\6578 (\50C5\986F\793A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109762203328313970)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_URL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE URL \7684\51FD\6578 (\91CD\65B0\5C0E\5411)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109762648083313970)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_ACCEPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8655\7406 {\4E0D\662F\5171\540C}')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109762495605313970)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_IDENT_BY_ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\8B58\5225\7684\9801\9762 (\50C5\986F\793A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109762063653313970)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_STEP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 (\50C5\986F\793A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109762530346313970)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_URL_IDENT_BY_ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\8B58\5225\7684 URL (\91CD\65B0\5C0E\5411)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109762357344313970)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \7A0B\5E8F [\820A\6709]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109761923269313970)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6216 URL (\91CD\65B0\5C0E\5411)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109340881371313630)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108879166800313271)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8207\6B64\5C0E\89BD\8DEF\5F91\4E00\8D77\4F7F\7528\7684\5C0E\89BD\8DEF\5F91\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108879093887313271)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109607214098313838)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\986F\793A\5206\9694\8CC7\6599\5217\6642, \5728\5206\6BB5\8CC7\6599\6B04\4E4B\5F8C\986F\793A\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109607175274313838)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109606824283313837)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\986F\793A\5206\9694\8CC7\6599\5217\6642, \5728\5206\6BB5\8CC7\6599\6B04\4E4B\524D\986F\793A\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109606770878313837)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109617564923313846)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\5206\9694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109618749384313847)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\5206\9694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109606036105313837)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\5C07\591A\5C11\5831\8868\8CC7\6599\6B04\4F75\5165\5206\6BB5\683C\5F0F\4E2D. \8CC7\6599\6B04\5FC5\9808\662F\5F9E\5831\8868\4E2D\986F\793A\7684\7B2C\4E00\500B\8CC7\6599\6B04\958B\59CB\7684\9023\7E8C\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109785087376313987)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C\4E00\500B\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109785178941313987)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C\4E00\500B\548C\7B2C\4E8C\500B\8CC7\6599\6B04')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109785276377313987)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2:3.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C\4E00\500B, \7B2C\4E8C\500B\548C\7B2C\4E09\500B\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109605924589313837)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\6BB5\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109606245681313837)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5831\8868\5206\6BB5\7684\986F\793A\683C\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109785505570313988)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5206\6BB5\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109785613937313988)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\55AE\4E00\5831\8868\4E2D\7684\6BCF\500B\5206\6BB5\4E0D\91CD\8907\6A19\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109785398518313987)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\6BB5\6642\91CD\8907\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109785446054313988)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\5C07\986F\793A\70BA\6578\500B\5B50\5831\8868, \6BCF\500B\5206\6BB5\7686\91CD\8907\4E00\6B21\6A19\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109606191473313837)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109606638464313837)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5728\5831\8868\5206\6BB5\986F\793A\7684\6587\5B57. \60A8\53EF\4EE5\4F7F\7528 <code>#SUM_COLUMN_HEADER#</code> \66FF\4EE3\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109606555759313837)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\5206\6BB5\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109607097922313838)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\986F\793A\5831\8868\5206\9694\6642, \5206\6BB5\8CC7\6599\6B04\7684\6587\5B57. \60A8\53EF\4EE5\4F7F\7528 <code>#COLUMN_VALUE#</code> \66FF\4EE3\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109606966025313838)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\5206\6BB5\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109606490736313837)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\91DD\5C0D\5831\8868\5206\6BB5\986F\793A\7684\91CD\8907\6A19\984C\6587\5B57. \60A8\53EF\4EE5\4F7F\7528 <code>#COLUMN_VALUE#</code> \66FF\4EE3\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109606370403313837)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8907\6A19\984C\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109616747087313845)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110057862537314184)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\61C9\7528\7A0B\5F0F\5B89\5168\6027\5C6C\6027\4E2D\5B9A\7FA9\7684\8A2D\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109241984080313552)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\82E5\555F\7528\5FEB\53D6\529F\80FD, \700F\89BD\5668\5373\53EF\5C07\60A8\61C9\7528\7A0B\5F0F\9801\9762\7684\5167\5BB9\5132\5B58\65BC\5FEB\53D6\4E2D (\540C\6642\5728\8A18\61B6\9AD4\548C\78C1\789F\4E2D).'),
unistr('\5982\679C\4F7F\7528\8005\6309\4E00\4E0B\700F\89BD\5668\7684\300C\4E0A\4E00\9801\300D\6309\9215, \901A\5E38\6703\5F9E\5FEB\53D6\4E2D\8F09\5165\9801\9762, \800C\4E0D\662F\5F9E\4F3A\670D\5668.'),
unistr('\5982\679C\505C\7528\5FEB\53D6, \5247\6703\6307\793A\700F\89BD\5668\4E0D\8981\5132\5B58\9801\9762\5167\5BB9, \800C\662F\91CD\65B0\5F9E\4F3A\670D\5668\8981\6C42\9801\9762\5167\5BB9.</p>'),
unistr('<p>\5F9E\5B89\5168\89C0\9EDE\800C\8A00, Oracle \5EFA\8B70\60A8\505C\7528\5FEB\53D6,\9019\6A23\700F\89BD\5668\5C31\4E0D\6703\5132\5B58\6A5F\5BC6\8CC7\6599, \800C\4E14\4E00\5F8B\6703\5728 URL \8B8A\66F4\6642\8981\6C42\9801\9762.'),
unistr('\5426\5247, \751A\81F3\53EF\80FD\767C\751F\5728\767B\51FA\4E4B\5F8C\518D\56DE\5230\700F\89BD\5668\6B77\53F2\8A18\9304\6642, \53EF\4EE5\67E5\770B\5148\524D\968E\6BB5\4F5C\696D\6240\5FEB\53D6\4E4B\5167\5BB9\7684\60C5\6CC1.'),
unistr('\505C\7528\700F\89BD\5668\5FEB\53D6\4E5F\53EF\9632\6B62\4F7F\7528\91CD\65B0\6574\7406\90E8\5206\9801\9762\7684\9801\9762 (\4F8B\5982,\4E92\52D5\5F0F\5831\8868) \767C\751F\4E0D\6613\5BDF\89BA\7684\4E0A\4E00\9801\6309\9215\554F\984C.</p>'),
unistr('<p>\5982\679C\6B64\5C6C\6027\8A2D\70BA<strong>\5DF2\505C\7528</strong>, &PRODUCT_NAME. \5C07\6703\50B3\9001 HTTP \6A19\982D <em>cache-control: no-store</em> \6307\793A\700F\89BD\5668\4E0D\8981\5FEB\53D6\9801\9762\5167\5BB9\5728\78C1\789F\6216\8A18\61B6\9AD4\4E2D.'),
unistr('\5982\679C\8A2D\70BA<strong>\61C9\7528\7A0B\5F0F\9810\8A2D\503C</strong>, \5C07\5F9E\61C9\7528\7A0B\5F0F\7684<em>\700F\89BD\5668\5FEB\53D6</em>\5C6C\6027\53D6\5F97\7A0B\5F0F\5BE6\969B\57F7\884C\6642\7684\503C.</p>'),
unistr('<p>\6CE8\610F: \6B64\529F\80FD\9700\8981\652F\63F4 HTTP \6A19\982D\56DE\61C9\8B8A\6578 <code>cache-control</code> \7684\65B0\7248\700F\89BD\5668.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109745124215313957)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.N.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109745044313313957)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.Y.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\555F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109241809560313551)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD\5668\5FEB\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110126783366314254)
,p_name=>'PE.PROPERTY.BUILD_OPTION.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>1. \60A8\6B63\5728\958B\767C\5C07\6703\6709\8A31\591A\5B89\88DD\9805\7684\61C9\7528\7A0B\5F0F.'),
unistr('                                        \6B64\5916, \6BCF\500B\5B89\88DD\9805\53EF\9078\64C7\555F\7528\6216\505C\7528\7279\5B9A\7684\61C9\7528\7A0B\5F0F\529F\80FD.'),
unistr('                                        \4F7F\7528\300C\7D44\5EFA\9078\9805\300D, \60A8\53EF\4EE5\958B\767C\4E00\500B\61C9\7528\7A0B\5F0F, \800C\4E14\5728\61C9\7528\7A0B\5F0F\5B89\88DD\5F8C, \53EF\4EE5\5C07\7D44\5EFA\9078\9805\8A2D\5B9A\6210\5305\62EC\6216\4E0D\5305\62EC\95DC\806F\7684\61C9\7528\7A0B\5F0F\529F\80FD.'),
unistr('                                        \60A8\4E5F\53EF\4EE5\4F7F\7528 API \5728\61C9\7528\7A0B\5F0F\5167\516C\958B\6B64\529F\80FD.'),
unistr('                                        \5982\6B64, \5177\5099\6B0A\9650\7684\4E00\822C\4F7F\7528\8005\5373\53EF\9078\64C7\555F\7528\6216\505C\7528\61C9\7528\7A0B\5F0F\529F\80FD.</p>'),
unistr('                                      <p>2. \60A8\6B63\5728\958B\767C\5C1A\672A\5B8C\6210\7684\529F\80FD, \56E0\6B64\4E0D\60F3\8B93\4E00\822C\4F7F\7528\8005\898B\5230.'),
unistr('									    \4F7F\7528\300C\7D44\5EFA\9078\9805\300D, \60A8\5C31\53EF\4EE5\5728\5C07\61C9\7528\7A0B\5F0F\5EFA\7F6E\5230\6E2C\8A66\548C\751F\7522\74B0\5883\5F8C, \505C\7528\61C9\7528\7A0B\5F0F\7684\9019\9805\529F\80FD.'),
unistr('									    \6B64\65B9\6CD5\7684\512A\9EDE\662F\4ECD\7136\53EF\4EE5\90E8\7F72\61C9\7528\7A0B\5F0F, \4F46\4E0D\8981\5305\62EC\672A\5B8C\6210\7684\529F\80FD.</p>'),
unistr('                                      <p>3. \60A8\6B63\5728\79FB\9664\8A8D\70BA\61C9\7528\7A0B\5F0F\4E0D\9700\8981\7684\529F\80FD, \4F46\4E0D\78BA\5B9A\9019\662F\4E0D\662F\5B89\5168\7684\4F5C\696D.'),
unistr('									    \5728\6B64\60C5\6CC1\4E0B, \60A8\53EF\4EE5\4F7F\7528\300C\7D44\5EFA\9078\9805\300D\5F9E\6839\672C\4E0A\300C\62FF\6389\300D\7279\5B9A\529F\80FD.'),
unistr('									    \82E5\5728\90E8\7F72\6642\8A8D\70BA\79FB\9664\7684\529F\80FD\662F\5FC5\8981\7684, \53EF\4EE5\5C07\5B83\6062\5FA9.'),
unistr('									    \5982\679C\8A8D\5B9A\6B64\529F\80FD\4E26\975E\5FC5\8981, \5C31\53EF\4EE5\653E\5FC3\5730\5C07\5B83\81EA\61C9\7528\7A0B\5F0F\4E2D\79FB\9664.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109242112332313552)
,p_name=>'PE.PROPERTY.BUILD_OPTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\6B64\5143\4EF6\7684\7D44\5EFA\9078\9805.</p>'),
unistr('                                     <p>\300C\7D44\5EFA\9078\9805\300D\53EF\8B93\60A8\5728\5B89\88DD\61C9\7528\7A0B\5F0F\5F8C, \6216\5728\7A0B\5F0F\5BE6\969B\57F7\884C\6642\900F\904E API (APEX_UTIL.SET_BUILD_OPTION_STATUS), \6709\689D\4EF6\5730\555F\7528\6216\505C\7528\61C9\7528\7A0B\5F0F\5143\4EF6\548C\529F\80FD.<br>'),
unistr('                                       \60A8\53EF\4EE5\4F7F\7528\300C\7D44\5EFA\9078\9805\300D\8A2D\5B9A\662F\5426\5728\7A0B\5F0F\5BE6\969B\57F7\884C\61C9\7528\7A0B\5F0F\4E2D\5305\62EC\6B64\5143\4EF6:</p>'),
unistr('                                     <p><strong>\5305\62EC</strong> - \555F\7528\4E26\5305\542B\5728\61C9\7528\7A0B\5F0F\4E2D.</p>'),
unistr('									 <p><strong>\4E0D\5305\62EC</strong> - \505C\7528\4E14\4E0D\5305\542B\5728\61C9\7528\7A0B\5F0F\4E2D.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109242076260313552)
,p_name=>'PE.PROPERTY.BUILD_OPTION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\5EFA\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109230615974313543)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\5143\4EF6\7684\7D44\5EFA\9078\9805\72C0\614B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109739068120313952)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5305\62EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109739170315313952)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('&PRODUCT_NAME. \5F15\64CE\6703\5C07\6B64\5143\4EF6\7576\4F5C\4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109738834930313952)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\62EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109738974414313952)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('&PRODUCT_NAME. \5F15\64CE\6703\5728\7A0B\5F0F\5BE6\969B\57F7\884C\6642, \5C07\6B64\5143\4EF6\7576\6210\61C9\7528\7A0B\5F0F\5B9A\7FA9\7684\4E00\90E8\5206.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109230514512313543)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109344268870313633)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6309\4E00\4E0B\6B64\6309\9215\6642\6240\8981\57F7\884C\7684\52D5\4F5C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109764847810313972)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B\52D5\4F5C\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109764967666313972)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\9001\51FA\9801\9762\6216\91CD\65B0\5C0E\5411\81F3\5176\4ED6\9801\9762. \6309\9215\7684\884C\70BA\6539\7528\300C\52D5\614B\52D5\4F5C\300D\5B9A\7FA9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109765230638313972)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109765330132313972)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\4E0B\4E00\9801.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109765476415313972)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109765535993313972)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\4E0A\4E00\9801.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109764430449313972)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\4E0D\540C\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109764535427313972)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\91CD\65B0\5C0E\5411\81F3\4E0D\540C\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762, \800C\4E14\53EF\4EE5\9078\64C7\4F7F\7528\5176\4ED6\5C6C\6027\70BA\76EE\6A19\9801\9762\91CD\8A2D\5206\9801\3001\8A2D\5B9A\8981\6C42\503C\3001\6E05\9664\5FEB\53D6\53CA\8A2D\5B9A\9805\76EE\503C.</p>'),
unistr('<p>\6CE8\610F: \5FC5\9808\5728\76EE\6A19\61C9\7528\7A0B\5F0F\555F\7528\6DF1\5C64\9023\7D50\529F\80FD, \624D\80FD\91CD\65B0\5C0E\5411\81F3\4E0D\540C\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762. \82E5\8981\555F\7528\6DF1\5C64\9023\7D50\529F\80FD, \8ACB\524D\5F80\61C9\7528\7A0B\5F0F\7684<em>\5B89\5168\6027</em>\5C6C\6027\4E26\555F\7528<em>\6DF1\5C64\9023\7D50</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109764289198313971)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\6B64\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109764347345313972)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\76EE\524D\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762, \4E26\4F7F\7528\9078\64C7\6027\7684\5176\4ED6\5C6C\6027\5728\76EE\6A19\9801\9762\4E0A\91CD\8A2D\5206\9801\3001\8A2D\5B9A\8981\6C42\503C\3001\6E05\9664\5FEB\53D6\8207\8A2D\5B9A\9805\76EE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109764617215313972)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109764720757313972)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\60A8\6307\5B9A\7684\76EE\6A19 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109765057118313972)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109765166477313972)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\5B8C\6574\7684\91CD\65B0\6574\7406\9801\9762\4EE5\91CD\8A2D\9801\9762, \800C\975E\57F7\884C\300C\91CD\65B0\6574\7406\90E8\5206\9801\9762 (PPR)\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109764016902313971)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109764188510313971)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\7B49\65BC\300C\6309\9215\540D\7A31\300D\7684 REQUEST \503C\9001\51FA\76EE\524D\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109344193785313633)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109247527233313556)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\6309\4E00\4E0B\6B64\6309\9215\6642\57F7\884C\7684 SQL \4F5C\696D\985E\578B.'),
unistr('\6B64\9078\9805\53EF\7528\4F86\89F8\767C\5167\5EFA\300C\81EA\52D5\8CC7\6599\5217\8655\7406 (DML)\300D\5167\6307\5B9A\7684\8CC7\6599\5EAB\52D5\4F5C.'),
unistr('\82E5\672A\9078\53D6\985E\578B, \8CC7\6599\5EAB\8655\7406\5C07\6839\64DA REQUEST \503C\4F86\57F7\884C, \9019\500B\503C\662F\6839\64DA\70BA\6B64\6309\9215\5B9A\7FA9\7684<strong>\6309\9215\540D\7A31</strong>\4F86\8A2D\5B9A.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109759091774313967)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.DELETE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL DELETE \52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109758843224313967)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.INSERT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL INSERT \52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109758995534313967)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.UPDATE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL UPDATE \52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109247411408313556)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109942207214314102)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\4E00\500B\53EF\4F9B\5B9A\7FA9\6B64\6309\9215\5916\89C0\7684\6309\9215\986F\793A\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109942538271314102)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109942643968314102)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\986F\793A\5716\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109942338228314102)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109942482346314102)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\986F\793A\6309\9215\6A19\7C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109942798718314102)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\8207\5716\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109942876624314102)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\6309\9215\6A19\7C64\65C1\908A\986F\793A\5716\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109942116037314102)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110044088699314174)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\91DD\5C0D\986F\793A\5713\9215\7FA4\7D44\6216\4E00\7D44\6838\53D6\65B9\584A\4E4B\500B\5225\9078\9805\7684 HTML \8868\683C\5132\5B58\683C, \8F38\5165\8981\5728\8A72 HTML \8868\683C\5132\5B58\683C\4E4B\5F8C\986F\793A\7684\5176\4ED6\5C6C\6027.'),
unistr('\60A8\53EF\4EE5\5305\542B HTML\3001JavaScript \548C\6377\5F91.</p>'),
unistr('<p>\60A8\53EF\4EE5\53C3\7167\4EE5\4E0B\66FF\4EE3\5B57\4E32:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>\53D6\5F97\8207\6B64\9801\9762\9805\76EE\76F8\95DC\7684 HTML \8868\55AE\5143\7D20\540D\7A31.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>\53D6\5F97\76EE\524D\9801\9762\9805\76EE\7684\540D\7A31.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110043925817314174)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C\7E8C\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110043882798314174)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\91DD\5C0D\986F\793A\5713\9215\7FA4\7D44\6216\4E00\7D44\6838\53D6\65B9\584A\4E4B\500B\5225\9078\9805\7684 HTML \8868\683C\5132\5B58\683C, \8F38\5165\8981\5728\8A72 HTML \8868\683C\5132\5B58\683C\4E4B\524D\986F\793A\7684\5176\4ED6\5C6C\6027.'),
unistr('\60A8\53EF\4EE5\5305\542B HTML\3001JavaScript \548C\6377\5F91.</p>'),
unistr('<p>\60A8\53EF\4EE5\53C3\7167\4EE5\4E0B\66FF\4EE3\5B57\4E32:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>\53D6\5F97\8207\6B64\9801\9762\9805\76EE\76F8\95DC\7684 HTML \8868\55AE\5143\7D20\540D\7A31.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>\53D6\5F97\76EE\524D\9801\9762\9805\76EE\7684\540D\7A31.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110043767062314174)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D\7F6E\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109247383708313556)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\82E5\5DF2\9001\51FA\9801\9762\4E14\6B64\5C6C\6027\8A2D\70BA<strong>\958B\555F</strong>, \4FBF\6703\5728\4F3A\670D\5668\7AEF\57F7\884C\70BA\9801\9762\5B9A\7FA9\7684\6240\6709\9A57\8B49\8207\5167\5EFA\9A57\8B49 (\4F8B\5982\5FC5\8981\3001\6709\6548\6578\5B57\6216\6709\6548\65E5\671F).'),
unistr('\6B64\5916, \82E5\61C9\7528\7A0B\5F0F\7684<em>\76F8\5BB9\6027\6A21\5F0F</em>\8A2D\70BA <strong>5.1</strong> \6216\4EE5\4E0A, &PRODUCT_NAME. \9084\6703\57F7\884C\5F9E\5C6C\7AEF\9A57\8B49, \4F8B\5982\5FC5\8981\7684\9805\76EE. \8ACB\53C3\95B1\300C\7248\6B21\6CE8\610F\4E8B\9805\300D\4E2D\7684\300C\76F8\5BB9\6027\6A21\5F0F\300D, \77AD\89E3\9032\4E00\6B65\7684\8A73\7D30\8CC7\8A0A.'),
unistr('\9664\975E\6240\6709\554F\984C\5747\5DF2\4FEE\6B63, \5426\5247\4E0D\6703\9001\51FA\9801\9762.</p>'),
unistr('<p>\82E5\8A2D\70BA<strong>\95DC\9589</strong>, \5247\4E0D\6703\57F7\884C\5B9A\7FA9\7684\9A57\8B49, \4E5F\4E0D\6703\57F7\884C\5167\5EFA\9A57\8B49.'),
unistr('\82E5\8981\5FFD\7565\6B64\8A2D\5B9A\4E26\57F7\884C\7279\5B9A\9A57\8B49, \8ACB\4FEE\6539\9A57\8B49\4E26\5C07\9A57\8B49\5C6C\6027<strong>\4E00\5F8B\57F7\884C</strong>\8A2D\70BA<strong>\958B\555F</strong>.</p>'),
unistr('<p>\5C0D\65BC\4E0D\61C9\57F7\884C\5927\90E8\5206\9A57\8B49\7684\300C\522A\9664\300D\6216\300C\53D6\6D88\300D\7B49\6309\9215, \6B64\5C6C\6027\7279\5225\6709\7528.'),
unistr('\82E5\9805\76EE\662F\7A7A\503C\6216\932F\8AA4\985E\578B, \901A\5E38\4E0D\61C9\963B\6B62\4F7F\7528\8005\57F7\884C\6B64\985E\52D5\4F5C.'),
unistr('\4E0D\904E, \5982\679C\53EA\6709\6388\6B0A\7684\4F7F\7528\8005\53EF\4EE5\57F7\884C\67D0\4E9B\52D5\4F5C (\50CF\662F\300C\522A\9664\300D), \5247\61C9\5C07\5C0D\61C9\7684\9A57\8B49\5C6C\6027<strong>\4E00\5F8B\57F7\884C</strong>\8A2D\70BA<strong>\958B\555F</strong>, \6216\662F\78BA\8A8D\6309\9215\672C\8EAB\5B9A\7FA9\4E86\9069\7576\7684\689D\4EF6, \53EA\6709\6388\6B0A\7684\4F7F\7528\8005\624D\80FD\770B\898B\6309\9215.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109247224588313555)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\9A57\8B49\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109943673974314103)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5448\73FE\6B64\6309\9215\6642, \8981\4F7F\7528<strong>\4E00\822C</strong>\6216<strong>\71B1\9215</strong>\6309\9215.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109246942590313555)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5448\73FE\6B64\6309\9215\6642, \8981\4F7F\7528<strong>\4E00\822C</strong>\6216<strong>\71B1\9215</strong>\6309\9215\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109246808637313555)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\71B1\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109943467568314103)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\986F\793A\5728\6309\9215\4E0A\7684\6587\5B57. \5982\679C\6309\9215\986F\793A\985E\578B\70BA\5716\793A, \5247\6B64\6587\5B57\6703\8B8A\6210\5716\793A\5F71\50CF\7684 ALT \6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109260263331313565)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\6309\9215\662F\6587\5B57, \8ACB\8F38\5165\8981\986F\793A\5728\6309\9215\4E0A\7684\6587\5B57. \5982\679C\6309\9215\662F\5F71\50CF, \5247\6B64\6587\5B57\6703\8B8A\6210\5F71\50CF\7684 ALT \6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109260138574313565)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109271196058313573)
,p_name=>'PE.PROPERTY.BUTTON_NAME.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7528\4F86\53C3\7167\88AB\6309\4E00\4E0B\4E4B\6309\9215\7684\540D\7A31. \9001\51FA\9801\9762\6642, REQUEST \503C\5C07\8A2D\70BA\6B64\6309\9215\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109260079049313565)
,p_name=>'PE.PROPERTY.BUTTON_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\4F86\5728\5F8C\7E8C\9801\9762\8655\7406\4E2D\8B58\5225\6B64\6309\9215\7684\540D\7A31.'),
unistr('\9001\51FA\9801\9762\6642, \6309\6B64\6309\9215\6703\5C07 REQUEST \503C\8A2D\70BA\8F38\5165\7684\540D\7A31.</p>'),
unistr('<p>\6309\9215\540D\7A31\4E0D\9700\8981\662F\76F8\540C\9801\9762\6216\76F8\540C\5340\57DF\4E2D\552F\4E00\7684\540D\7A31.'),
unistr('\60A8\53EF\4EE5\5B9A\7FA9\5177\6709\76F8\540C\6309\9215\540D\7A31\7684\591A\500B\6309\9215, \6309\9019\4E9B\6309\9215\6642\6703\8A2D\5B9A\76F8\540C\7684 REQUEST \503C.'),
unistr('\5982\6B64\5728\5B9A\7FA9\5177\6709\4E0D\540C<strong>\6309\9215\6A19\7C64</strong>\6216\689D\4EF6\4F46\662F\5FC5\9808\57F7\884C\76F8\540C\9801\9762\8655\7406\7684\591A\500B\6309\9215\6642, \53EA\8981\8A55\4F30\5171\540C\7684 REQUEST \503C\5373\53EF.</p>'),
unistr('<p>\82E5\5C07\6309\9215\547D\540D\70BA <code>FLOW_RESET_BUTTON</code>, \5247\6309\9215\6703\91CD\8A2D\76EE\524D\9801\9762, \800C\4E0D\6703\9001\51FA\9801\9762.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109259942495313565)
,p_name=>'PE.PROPERTY.BUTTON_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110043489282314174)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E0B\6B64\6309\9215\5F8C\5C07\6703\9001\51FA\9801\9762, \4E26\5C07\9801\9762\8981\6C42\8A2D\6210\9019\500B\503C. \5982\679C\9019\500B\503C\662F\7A7A\503C\4E14<em>\8981\6C42\4F86\6E90\985E\578B</em>\70BA<em>\975C\614B\503C</em>, \5247\6703\4F7F\7528\300C\6309\9215\540D\7A31\300D\4F5C\70BA\8981\6C42\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110043359078314174)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110041310942314173)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\6703\8B58\5225\5305\542B\5728\8981\6C42\4F86\6E90\5C6C\6027\4E2D\7684\8868\793A\5F0F\985E\578B. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110043163390314174)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110043255376314174)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\662F\7A7A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110041671320314173)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110041764106314173)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5728<em>\8CC7\6599\5EAB\8CC7\6599\6B04</em>\4E2D\8F38\5165\7684\8CC7\6599\6B04\503C, \8A72\503C\5F9E\5167\5EFA\64F7\53D6\8CC7\6599\5217\8655\7406\4F5C\696D\4E2D\64F7\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110042529006314173)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110042686670314173)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\57F7\884C\8F38\5165\4E4B <em>PL/SQL \8868\793A\5F0F</em>\7684\7D50\679C\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110042757420314174)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110042822402314174)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B <em>PL/SQL \51FD\6578\4E3B\9AD4</em>\50B3\56DE\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110041852788314173)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110042094395314173)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\9078\53D6<em>\9805\76EE</em>\4E4B\968E\6BB5\4F5C\696D\72C0\614B\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110042917167314174)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110043065711314174)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\8F38\5165\7684<em>\504F\597D\8A2D\5B9A</em>\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110042116977314173)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62 (\50B3\56DE\55AE\4E00\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110042248016314173)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B <em>SQL \67E5\8A62</em>\50B3\56DE\7684\7B2C\4E00\500B\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110042369708314173)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62 (\50B3\56DE\4F7F\7528\5192\865F\5340\9694\7684\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110042490923314173)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B <em>SQL \67E5\8A62</em>\50B3\56DE\7684\55AE\4E00\503C (\4F7F\7528\55AE\4E00\5192\865F\5340\9694), \8A72\503C\6703\4E32\63A5\5404\8CC7\6599\5217\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110041476199314173)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110041517982314173)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5728<em>\975C\614B\503C</em>\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110041202762314172)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42\4F86\6E90\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109247164146313555)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E00\4E0B\300C\76EE\6A19\300D\4EE5\547C\53EB\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A. \60A8\53EF\4EE5\8F38\5165\6309\4E00\4E0B\6B64\6309\9215\6642\8981\547C\53EB\7684\76EE\6A19. \8ACB\53EA\91DD\5C0D\6309\4E00\4E0B\6642\4E0D\6703\547C\53EB\9801\9762\8655\7406\7684\6309\9215\8F38\5165\76EE\6A19 (\4F8B\5982,\300C\53D6\6D88\300D\6309\9215).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109247089297313555)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\6A19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109246743349313555)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\4E00\500B\53EF\4F9B\5B9A\7FA9\6B64\6309\9215\4E4B\5916\89C0\7684\6309\9215\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109246602587313555)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109922910413314088)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9810\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109944086744314103)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\672A\5132\5B58\8B8A\66F4\6AA2\67E5\5728\9801\9762\5C64\7D1A\555F\7528, \6309\4E00\4E0B\6309\9215\5F8C\6703\6AA2\67E5\672A\5132\5B58\7684\8B8A\66F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109922668863314088)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7576\4F7F\7528\8005\6309\4E00\4E0B\6309\9215\4EE5\5617\8A66\96E2\958B\6709\5C1A\672A\5132\5B58\4E4B\8B8A\66F4\7684\9801\9762\6642, \662F\5426\5C0D\4F7F\7528\8005\767C\51FA\8B66\544A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109922755961314088)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\6AA2\67E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109925370601314090)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E00\4E0B\6309\9215\5F8C\5C07\4E0D\6703\57F7\884C\672A\5132\5B58\8B8A\66F4\6AA2\67E5. \9019\9805\8A2D\5B9A\61C9\8A72\7528\65BC\300C\53D6\6D88\300D\3001\300C\522A\9664\300D\4EE5\53CA\300C\5957\7528\8B8A\66F4\300D\6309\9215.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109922510756314088)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5132\5B58\8B8A\66F4\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109973266314314124)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\8A55\4F30\6240\8F38\5165\8868\793A\5F0F\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109973654076314124)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109973567840314124)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109973430300314124)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109973783993314125)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109973355868314124)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109973181799314124)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109975268313314126)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\51FD\6578\4E3B\9AD4\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109975583511314126)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109975414510314126)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109975358446314126)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109975607279314126)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109975148541314126)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109248783666313557)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5728\6B64\689D\4EF6\4F7F\7528\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\5F9E\53EF\7528\9805\76EE\7684\6E05\55AE\4E2D\6311\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109248626279313556)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109250163768313558)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5728\6B64\689D\4EF6\4F7F\7528\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\5F9E\53EF\7528\9805\76EE\7684\6E05\55AE\4E2D\6311\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109250092667313557)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109974873505314125)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CJava \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109974744958314125)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109976488886314126)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\689D\4EF6\5E03\6797\503C\7684 Java \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109976316593314126)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109974610989314125)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109974589427314125)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CJavaScript \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109974459040314125)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109976226547314126)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109976132655314126)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\689D\4EF6\5E03\6797\503C\7684 JavaScript \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109976081027314126)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109248914135313557)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\503C\6E05\55AE (\4F7F\7528\5192\865F (:) \5340\9694).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109248878980313557)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109249330658313557)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300C\9801\78BC\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109249267677313557)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109249545331313557)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300C\9801\78BC\300D\6E05\55AE (\4F7F\7528\9017\865F\5340\9694).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109249495813313557)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109974365314314125)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109974253790314125)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CPL/SQL \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109974121182314125)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109975982111314126)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109975821857314126)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\689D\4EF6\5E03\6797\503C\7684 PL/SQL \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109975743233314126)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109249102266313557)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\6B64\689D\4EF6\6307\5B9A\503C\9032\884C\6BD4\8F03\7684\300C\4F7F\7528\8005\504F\597D\8A2D\5B9A\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109249000443313557)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109975019965314125)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CPython \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109974906892314125)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109976664639314127)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\689D\4EF6\5E03\6797\503C\7684 Python \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109976566727314127)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109974048132314125)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\70BA\4E3B\7BA1\4E14\5176\90E8\9580\4F4D\65BC\829D\52A0\54E5\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109973919223314125)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CSQL \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109973864191314125)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110127245459314254)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\6AA2\67E5\54E1\5DE5\662F\5426\7DE8\5236\5728\90E8\9580 30, \5982\6709\4E00\6216\591A\500B\8CC7\6599\5217\5B58\5728\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\6AA2\67E5\54E1\5DE5\662F\5426\7DE8\5236\5728\90E8\9580 40, \5982\7121\4EFB\4F55\8CC7\6599\5217\5B58\5728\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109248358319313556)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684 SQL \67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109248290720313556)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109249760887313557)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\6587\5B57\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109249684563313557)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109250309334313558)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\503C (\5305\542B <code>&ITEM.</code> \66FF\4EE3\5B57\4E32).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109250249159313558)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109330719218313623)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\5C0D\5340\57DF\9032\884C\5FEB\53D6\6642, \6240\5FC5\9808\7B26\5408\7684\689D\4EF6\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109248142074313556)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\500B\689D\4EF6. \5982\679C\689D\4EF6\50B3\56DE <strong>TRUE</strong>, \5C31\6703\5F9E\5FEB\53D6\986F\793A\9801\9762. \5982\679C\689D\4EF6\50B3\56DE <strong>FALSE</strong>, \5247\4EE5\52D5\614B\65B9\5F0F\5448\73FE\9801\9762\800C\4E0D\5F9E\5FEB\53D6\64F7\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109813401809314008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\6210\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109954950003314111)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4E00\5F8B\5448\73FE\5143\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109812057822314007)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF\700F\89BD\5668\70BA Microsoft Internet Explorer 7.0 \6216\66F4\65B0\7684\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109812188794314007)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF\700F\89BD\5668\70BA XHTML / CSS \529F\80FD\700F\89BD\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109811944140314007)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF\700F\89BD\5668\70BA Mozilla\3001Netscape 6.x/7x \6216\66F4\65B0\7684\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109812291260314007)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF\700F\89BD\5668\70BA\5176\4ED6\700F\89BD\5668 (\6216\66F4\820A\7684\7248\672C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109810676756314006)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\5305\542B\5728\9805\76EE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109812687040314008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8A9E\8A00 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109958593008314113)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\76EE\524D\4F7F\7528\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\8A9E\8A00\57F7\884C\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109812398725314008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8A9E\8A00\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109958736989314114)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\76EE\524D\4F7F\7528\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\5176\4E2D\4E00\7A2E\8A9E\8A00\57F7\884C\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109812513542314008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8A9E\8A00 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109958625209314114)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\76EE\524D\672A\4F7F\7528\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\8A9E\8A00\57F7\884C\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109812497735314008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8A9E\8A00\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109958816692314114)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\76EE\524D\4E0D\662F\4F7F\7528\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\5176\4E2D\4E00\7A2E\8A9E\8A00\57F7\884C\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109809880407314006)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762 = \9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109957373835314113)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\7B49\65BC\60A8\5728<em>\9801\9762</em>\4E2D\8F38\5165\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109810023762314006)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\5728\9017\865F\5340\9694\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109957546164314113)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\5728\60A8\65BC<em>\9801\9762</em>\4E2D\8F38\5165\7684\6E05\55AE (\4EE5\9017\865F\5340\9694) \4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109809945238314006)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762 != \9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109957426238314113)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\4E0D\7B49\65BC\60A8\5728<em>\9801\9762</em>\4E2D\8F38\5165\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109810156763314006)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\4E0D\5728\9017\865F\5340\9694\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109957675113314113)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\4E0D\5728\60A8\65BC<em>\9801\9762</em>\4E2D\8F38\5165\7684\6E05\55AE (\4EE5\9017\865F\5340\9694) \4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109812797833314008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: DAD_NAME = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109812812055314008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: DAD_NAME != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109811574471314007)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5167\5D4C\9A57\8B49\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109958384152314113)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\986F\793A\5167\5D4C\9A57\8B49\932F\8AA4, \63A5\8457\9001\51FA\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109810930047314007)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109810782371314006)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109810882971314006)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109811022902314007)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109807564523314004)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109955043654314111)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62\50B3\56DE\4E00\6216\591A\500B\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109972952466314124)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109973074412314124)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F\8A55\4F30\70BA TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109807735334314004)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109955276767314111)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\4E3B\9AD4\50B3\56DE TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109813113752314008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109813296261314008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109811259102314007)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762/\5340\57DF\975E\552F\8B80')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109958049185314113)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\9069\7528, \9801\9762\548C\7236\9805\5340\57DF\6703\6B63\5E38\986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109811166953314007)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762/\5340\57DF\70BA\552F\8B80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109957925205314113)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\9069\7528, \9801\9762\6216\7236\9805\5340\57DF\7684\300C\552F\8B80\300D\689D\4EF6\6703\8A55\4F30\70BA TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109809024521314005)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\5305\542B\7A7A\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109956549539314112)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\6C92\6709\7A7A\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109809333487314005)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\70BA\6587\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109956846120314112)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\70BA\6587\6578\5B57, \50C5\5305\542B\5B57\6BCD\8207\6578\5B57\4E14\6C92\6709\7279\6B8A\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109808512150314005)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109956034682314112)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\975E\7A7A\767D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109809249071314005)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\70BA\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109956735396314112)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\4E0D\662F\6578\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109808752492314005)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\70BA\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109956216613314112)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\4E0D\662F\6578\5B57\96F6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109808451347314005)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109955952306314112)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\70BA\7A7A\767D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109808871121314005)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\662F\7A7A\503C\6216\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109956385808314112)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\70BA\7A7A\767D\6216\6578\5B57\96F6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109809106960314005)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\70BA\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109956609730314112)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\662F\6578\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109808632173314005)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\70BA\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109956166793314112)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\662F\6578\5B57\96F6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109808939900314005)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\662F\7A7A\503C\4E5F\4E0D\70BA\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109956428005314112)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\975E\7A7A\767D\4E5F\4E0D\662F\6578\5B57\96F6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109811702488314007)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \5831\8868 (\78BA\5B9A\53EF\4EE5\986F\793A\4E0B\4E00\9801\6309\9215)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109811823221314007)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \5831\8868 (\78BA\5B9A\53EF\986F\793A\4E0A\4E00\9801\6309\9215)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109813382522314008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\4E0D\6210\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109811639009314007)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\986F\793A\5167\5D4C\9A57\8B49\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109958454318314113)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\672A\986F\793A\5167\5D4C\9A57\8B49\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109807647628314004)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\50B3\56DE\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109955158791314111)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62\672A\50B3\56DE\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109810431304314006)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\662F\300C\9069\7528\65BC\5370\8868\6A5F\300D\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109957765578314113)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\5DF2\5C07\76EE\524D\7684\9801\9762\5207\63DB\70BA\300C\9069\7528\65BC\5370\8868\6A5F\300D\6A21\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109810532970314006)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\4E0D\662F\300C\9069\7528\65BC\5370\8868\6A5F\300D\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109957893013314113)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\5C1A\672A\5C07\76EE\524D\7684\9801\9762\5207\63DB\70BA\300C\9069\7528\65BC\5370\8868\6A5F\300D\6A21\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109807897067314004)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109955385658314111)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8981\6C42\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109808004416314004)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109955575394314111)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8981\6C42\5305\542B\5728\60A8\65BC<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109807903601314004)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109955460851314111)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8981\6C42\4E0D\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109808148257314004)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109955668504314111)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8981\6C42\4E0D\5305\542B\5728\60A8\65BC<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109812969687314008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109813069053314008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109811325373314007)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\5DF2\8A8D\8B49 (\4E0D\662F\516C\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109958109920314113)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\5DF2\767B\5165\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109811429808314007)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\662F\516C\7528\4F7F\7528\8005 (\4F7F\7528\8005\672A\8A8D\8B49)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109958254643314113)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\672A\767B\5165\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109809643519314006)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\504F\597D\8A2D\5B9A = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109957154807314113)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7684<em>\504F\597D\8A2D\5B9A</em>\503C\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109809735050314006)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\504F\597D\8A2D\5B9A != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109957239254314113)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7684<em>\504F\597D\8A2D\5B9A</em>\503C\4E0D\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109809482897314005)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\5728\5192\865F\5340\9694\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109956960162314112)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\5B8C\5168\5305\542B\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109809592110314005)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\5728\5192\865F\5340\9694\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109957098719314112)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\4E0D\5B8C\5168\5305\542B\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109808223458314004)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109955733212314112)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109808390088314005)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109955810824314112)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\4E0D\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109810329775314006)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762 != \5DF2\9001\51FA\7684\9801\9762 (\5DF2\516C\5E03)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109810201716314006)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762 = \5DF2\9001\51FA\7684\9801\9762 (\5DF2\516C\5E03)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109248021962313556)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109248555067313556)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\689D\4EF6\505A\6BD4\8F03\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109248472150313556)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109249990381313557)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\503C (\5305\542B <code>&ITEM.</code> \66FF\4EE3\5B57\4E32).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109249825528313557)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110067816852314191)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5FEB\53D6\5167\5BB9\76F8\4F9D\7684\9805\76EE\6E05\55AE (\4F7F\7528\9017\865F\5340\9694).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110067791929314191)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\4F9D\65BC\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110061859663314187)
,p_name=>'PE.PROPERTY.CACHE_MODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6 &PRODUCT_NAME. \5F15\64CE\8981\5982\4F55\5FEB\53D6\5728\4F3A\670D\5668\7AEF\7684 HTML \6587\5B57. \5982\679C\53EF\4EE5\4F7F\7528\5FEB\53D6\529F\80FD, \5B83\5C07\6703\767C\51FA\5FEB\53D6\7684\7D50\679C\800C\4E0D\6703\91CD\65B0\904B\7B97. \9019\6A23\53EF\6E1B\5C11\4F3A\670D\5668\4E0A\7684\5927\91CF\904B\7B97\6642\9593. \6B64\529F\80FD\8207\700F\89BD\5668\7684\5FEB\53D6\529F\80FD\7121\95DC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110062150114314187)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110062285334314187)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5FEB\53D6\5167\5BB9, \4E26\7531\6240\6709\4F7F\7528\8005\4F7F\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110061947904314187)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110062010677314187)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\91DD\5C0D\6BCF\500B\8981\6C42\5FEB\53D6\53CA\904B\7B97\5167\5BB9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110062580109314187)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F9D\968E\6BB5\4F5C\696D\5FEB\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110062679653314187)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\91DD\5C0D\6BCF\500B\968E\6BB5\4F5C\696D\5FEB\53D6\5167\5BB9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110062330409314187)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F9D\4F7F\7528\8005\5FEB\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110062454152314187)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\91DD\5C0D\6BCF\4F4D\4F7F\7528\8005\5FEB\53D6\5167\5BB9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110061706423314187)
,p_name=>'PE.PROPERTY.CACHE_MODE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FEB\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109241788232313551)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5FEB\53D6\9801\9762\7684\6709\6548\6642\9593. \82E5\903E\6642\5230\671F, \5F8C\7E8C\9801\9762\8981\6C42\5C07\7121\6CD5\4F7F\7528\5FEB\53D6\7684\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109743134024313955)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('10 \79D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109743764421313956)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10800.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('3 \5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109744663401313957)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1209600.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('2 \9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109743871995313956)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.14400.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('4 \5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109744200788313956)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.172800.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('2 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109743476739313956)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1800.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('30 \5206\9418')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109743976173313956)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.21600.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('6 \5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109744787234313957)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.2419200.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('4 \9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109744393331313956)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.259200.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('3 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109744940134313957)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.31536000.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('1 \5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109744407298313956)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.345600.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('4 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109743506403313956)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.3600.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('1 \5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109744035051313956)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.43200.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('12 \5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109743239665313955)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.60.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('1 \5206\9418')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109743376306313956)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.600.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('10 \5206\9418')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109744588143313956)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.604800.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('1 \9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109744871202313957)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.6048000.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('10 \9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109743647858313956)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.7200.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('2 \5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109744111432313956)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.86400.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('1 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109241655044313551)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FEB\53D6\903E\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109788786637313990)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\986F\793A\8CC7\6599\6B04\503C</dt>'),
'<dd><pre>',
'#FIRST_NAME# <strong>#LAST_NAME#</strong>',
'</pre></dd>',
unistr('<dt>\5728\884C\4E8B\66C6\4E8B\4EF6\4E2D\986F\793A\5F71\50CF.</dt>'),
'<dd><pre>',
'&lt;img src="#IMAGE_NAME#"&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109634990113313858)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5728\884C\4E8B\66C6\5132\5B58\683C\4E2D\986F\793A\7684\81EA\8A02\6587\5B57. \60A8\53EF\4EE5\8F38\5165 HTML \8868\793A\5F0F\4E26\4F7F\7528 <code>#COLUMN_NAME#</code> \8A9E\6CD5\4F86\986F\793A\8CC7\6599\6B04\503C. \6B64\986F\793A\985E\578B\53EF\8B93\60A8\5728\986F\793A\756B\9762\4E2D\8F38\5165\591A\500B\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109634838868313858)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\986F\793A\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109629171718313854)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\542B\6709\4E00\822C\4F7F\7528\8005\76EE\524D\6240\898B\884C\4E8B\66C6\958B\59CB\65E5\671F\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.'),
unistr('\7576\4E00\822C\4F7F\7528\8005\9078\53D6\8981\700F\89BD\81F3\4E0A\4E00\500B\6216\4E0B\4E00\500B\671F\9593\6642, &PRODUCT_NAME. \5F15\64CE\4FBF\6703\4F7F\7528\6B64\9805\76EE.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109629009844313854)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109629726451313855)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5728\884C\4E8B\66C6\4E0A\986F\793A\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109788181930313989)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109788256110313990)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528<strong>\986F\793A\8CC7\6599\6B04</strong>\5C6C\6027\4F86\9078\53D6\8981\5728\884C\4E8B\66C6\5132\5B58\683C\4E2D\986F\793A\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109788314185313990)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109788422542313990)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B93\60A8\4F7F\7528 HTML \8868\793A\5F0F\8207\652F\63F4\7684\66FF\4EE3\5B57\4E32, \8F38\5165\81EA\8A02\7684\8CC7\6599\6B04\683C\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109788586400313990)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\986F\793A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109788630848313990)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\4E8B\66C6\5132\5B58\683C\4E2D\4E0D\6703\986F\793A\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109629696833313854)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109629356919313854)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\542B\6709\4E00\822C\4F7F\7528\8005\76EE\524D\6240\898B\884C\4E8B\66C6\7D50\675F\65E5\671F\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.'),
unistr('\7576\4E00\822C\4F7F\7528\8005\9078\53D6\8981\700F\89BD\81F3\4E0A\4E00\500B\6216\4E0B\4E00\500B\671F\9593\6642, &PRODUCT_NAME. \5F15\64CE\4FBF\6703\4F7F\7528\6B64\9805\76EE.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109629209154313854)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109628571463313854)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5448\73FE\884C\4E8B\66C6\6642\6240\8981\4F7F\7528\7684\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109628475550313854)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109629592134313854)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\542B\6709\4E00\822C\4F7F\7528\8005\76EE\524D\6240\898B\884C\4E8B\66C6\985E\578B\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109629461980313854)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109941941324314102)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6BCF\4E00\500B\9801\9762\8981\986F\793A\7684\5361\7247\6578\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109941852840314102)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\9801\5361\7247\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109940748950314101)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C7A\5B9A\5361\7247\4E0A\7684\6309\9215\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109940856362314101)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.PRIMARY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109940977580314101)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.SECONDARY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B21\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109940688803314101)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109939503603314100)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\8981\65B0\589E\81F3\5361\7247\5143\4EF6\7684\52D5\4F5C\985E\578B.</p>'),
unistr('<p>\60A8\53EF\4EE5\5B9A\7FA9\591A\500B\76F8\540C\985E\578B\7684\52D5\4F5C.  \4E0D\904E, \53EA\6709\6309\9215\52D5\4F5C\624D\6703\91CD\8907\5448\73FE.'),
unistr('\81F3\65BC\6240\6709\5176\4ED6\52D5\4F5C\985E\578B, \7B2C\4E00\500B TRUE \986F\793A\689D\4EF6\6703\5448\73FE, \5176\9918\7684\5247\6703\88AB\5FFD\7565.</p>'),
unistr('<p>\57F7\884C\689D\4EF6\82E5\8A2D\70BA\6AA2\67E5\6BCF\500B\8CC7\6599\5217, \5247\53EF\6839\64DA\8CC7\6599\6B04\503C\5B9A\7FA9\986F\793A\689D\4EF6.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109939606327314100)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109939782397314100)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\6309\9215\81F3\5361\7247.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109939883845314100)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6574\5361\7247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109939963704314100)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\65B0\589E\5B8C\6574\5361\7247\9023\7D50. \4E00\822C\4F86\8AAA, \5FC5\9808\5B9A\7FA9\5176\4E2D\4E00\500B\9019\7A2E\52D5\4F5C\985E\578B.'),
unistr('\82E5\5B9A\7FA9\591A\500B\52D5\4F5C\985E\578B, \8ACB\6839\64DA\8CC7\6599\6B04\503C\589E\52A0\986F\793A\689D\4EF6\4E26\8A2D\70BA\6AA2\67E5\6BCF\500B\8CC7\6599\5217.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109940432337314101)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5A92\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109940511475314101)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\65B0\589E\5361\7247\5A92\9AD4\9023\7D50. \4E00\822C\4F86\8AAA, \5FC5\9808\5B9A\7FA9\5176\4E2D\4E00\500B\9019\7A2E\52D5\4F5C\985E\578B.'),
unistr('\82E5\5B9A\7FA9\591A\500B\52D5\4F5C\985E\578B, \8ACB\6839\64DA\5361\7247\8CC7\6599\6B04\503C\589E\52A0\986F\793A\689D\4EF6\4E26\8A2D\70BA\6AA2\67E5\6BCF\500B\8CC7\6599\5217.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109940201871314100)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B50\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109940390929314100)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\65B0\589E\5361\7247\5B50\6A19\984C\9023\7D50. \4E00\822C\4F86\8AAA, \5FC5\9808\5B9A\7FA9\5176\4E2D\4E00\500B\9019\7A2E\52D5\4F5C\985E\578B.'),
unistr('\82E5\5B9A\7FA9\591A\500B\52D5\4F5C\985E\578B, \8ACB\6839\64DA\8CC7\6599\6B04\503C\589E\52A0\986F\793A\689D\4EF6\4E26\8A2D\70BA\6AA2\67E5\6BCF\500B\8CC7\6599\5217.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109940012055314100)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109940184382314100)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\65B0\589E\5361\7247\6A19\984C\9023\7D50. \4E00\822C\4F86\8AAA, \5FC5\9808\5B9A\7FA9\5176\4E2D\4E00\500B\9019\7A2E\52D5\4F5C\985E\578B.'),
unistr('\82E5\5B9A\7FA9\591A\500B\52D5\4F5C\985E\578B, \8ACB\6839\64DA\8CC7\6599\6B04\503C\589E\52A0\986F\793A\689D\4EF6\4E26\8A2D\70BA\6AA2\67E5\6BCF\500B\8CC7\6599\5217.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109939492283314100)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109928478339314092)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5728\6BCF\500B\500B\5225\5361\7247\5957\7528\7684 CSS \985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109928349887314092)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109933659805314096)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\986F\793A\6307\5411\53F3\908A\7684\7BAD\865F</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109933565503314096)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\65B0\589E\81F3\5143\4EF6\4E4B\5716\793A\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.</p>'),
unistr('        <p>\60A8\7684\4E3B\984C\82E5\4F7F\7528\300C\5B57\578B APEX\300D, \8ACB\8907\67E5<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F</a>\4EE5\6AA2\8996\53EF\7528\7684\5716\793A\548C\4FEE\98FE\689D\4EF6.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109933497507314096)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110034589634314168)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\986F\793A\6307\5411\53F3\908A\7684\7BAD\865F</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110034473574314168)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\65B0\589E\81F3\5143\4EF6\4E4B\5716\793A\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.</p>'),
unistr('        <p>\60A8\7684\4E3B\984C\82E5\4F7F\7528\300C\5B57\578B APEX\300D, \8ACB\8907\67E5<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F</a>\4EE5\6AA2\8996\53EF\7528\7684\5716\793A\548C\4FEE\98FE\689D\4EF6.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110034328211314168)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109926800970314091)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\7279\6027\6C7A\5B9A\9801\9762\4E0A\7684\5361\7247\6392\5217\65B9\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109927117762314091)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D6E\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109927258137314091)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7576\5361\7247\7121\6CD5\518D\5BB9\7D0D\65BC\756B\9762\7684\6C34\5E73\9577\5EA6\6642\4FBF\6703\63DB\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109926936627314091)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109927053231314091)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5361\7247\6392\5217\5728\8CC7\6599\6B04\65B9\683C\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109927302444314091)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C34\5E73 (\8CC7\6599\5217)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109927467876314091)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5361\7247\6703\5F7C\6B64\4E92\76F8\4EA4\758A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109926779435314091)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7248\9762\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109941147959314101)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6309\4E00\4E0B\6307\5B9A\52D5\4F5C\985E\578B\6642\6240\8981\57F7\884C\7684\52D5\4F5C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109941444479314101)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\4E0D\540C\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109941583894314101)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\91CD\65B0\5C0E\5411\81F3\4E0D\540C\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762, \800C\4E14\53EF\4EE5\9078\64C7\4F7F\7528\5176\4ED6\5C6C\6027\70BA\76EE\6A19\9801\9762\91CD\8A2D\5206\9801\3001\8A2D\5B9A\8981\6C42\503C\3001\6E05\9664\5FEB\53D6\53CA\8A2D\5B9A\9805\76EE\503C.</p>'),
unistr('<p>\6CE8\610F: \5FC5\9808\5728\76EE\6A19\61C9\7528\7A0B\5F0F\555F\7528\6DF1\5C64\9023\7D50\529F\80FD, \624D\80FD\91CD\65B0\5C0E\5411\81F3\4E0D\540C\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762. \82E5\8981\555F\7528\6DF1\5C64\9023\7D50\529F\80FD, \8ACB\524D\5F80\61C9\7528\7A0B\5F0F\7684<em>\5B89\5168\6027</em>\5C6C\6027\4E26\555F\7528<em>\6DF1\5C64\9023\7D50</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109941203599314101)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\6B64\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109941346147314101)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\76EE\524D\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762, \4E26\4F7F\7528\9078\64C7\6027\7684\5176\4ED6\5C6C\6027\5728\76EE\6A19\9801\9762\4E0A\91CD\8A2D\5206\9801\3001\8A2D\5B9A\8981\6C42\503C\3001\6E05\9664\5FEB\53D6\8207\8A2D\5B9A\9805\76EE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109941667032314101)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109941736721314101)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\60A8\6307\5B9A\7684\76EE\6A19 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109941069558314101)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110054268368314181)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5340\57DF\4F86\6E90\9078\53D6\7B2C\4E00\500B\4E3B\7D22\5F15\9375\8CC7\6599\6B04. \6B64\8868\683C\7684\4E3B\7D22\5F15\9375\82E5\6709\5169\500B\4EE5\4E0A\7684\8CC7\6599\6B04, \60A8\5FC5\9808\8981\9078\53D6 <code>ROWID</code> \8CC7\6599\6B04. \5340\57DF\82E5\8A2D\70BA\986F\793A\6372\52D5\5206\9801, \4FBF\6703\4F7F\7528\4E3B\7D22\5F15\9375\4F86\907F\514D\986F\793A\91CD\8907\7684\8CC7\6599\5217.  \5340\57DF\5982\679C\986F\793A BLOB \8CC7\6599\6B04\7684\5F71\50CF, \5247\6703\4F7F\7528\4E3B\7D22\5F15\9375\4F86\53D6\5F97\8A72\5F71\50CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110054111991314181)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110054610387314182)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5340\57DF\4F86\6E90\9078\53D6\7B2C\4E00\500B\4E3B\7D22\5F15\9375\8CC7\6599\6B04. \6B64\8868\683C\7684\4E3B\7D22\5F15\9375\82E5\6709\5169\500B\4EE5\4E0A\7684\8CC7\6599\6B04, \60A8\5FC5\9808\8981\9078\53D6 <code>ROWID</code> \8CC7\6599\6B04. \5340\57DF\82E5\8A2D\70BA\986F\793A\6372\52D5\5206\9801, \4FBF\6703\4F7F\7528\4E3B\7D22\5F15\9375\4F86\907F\514D\986F\793A\91CD\8907\7684\8CC7\6599\5217.  \5340\57DF\5982\679C\986F\793A BLOB \8CC7\6599\6B04\7684\5F71\50CF, \5247\6703\4F7F\7528\4E3B\7D22\5F15\9375\4F86\53D6\5F97\8A72\5F71\50CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110054592572314182)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110054491207314181)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F86\6E90\7684\4E3B\7D22\5F15\9375\82E5\6709\5169\500B\8CC7\6599\6B04\6642, \624D\9700\8981\9078\53D6\7B2C\4E8C\500B\4E3B\7D22\5F15\9375\8CC7\6599\6B04. \5982\679C\5728\7B2C\4E00\500B\4E3B\7D22\5F15\9375\8CC7\6599\6B04\9078\53D6\4E86 <code>ROWID</code>, \8ACB\52FF\586B\5165\6B64\8CC7\6599\6B04. \5340\57DF\82E5\8A2D\70BA\986F\793A\6372\52D5\5206\9801, \4FBF\6703\4F7F\7528\7B2C\4E8C\500B\4E3B\7D22\5F15\9375\4F86\907F\514D\986F\793A\91CD\8907\7684\8CC7\6599\5217.  \5340\57DF\5982\679C\986F\793A BLOB \8CC7\6599\6B04\7684\5F71\50CF, \5247\6703\4F7F\7528\7B2C\4E8C\500B\4E3B\7D22\5F15\9375\4F86\53D6\5F97\8A72\5F71\50CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110054348750314181)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110054870520314182)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F86\6E90\7684\4E3B\7D22\5F15\9375\82E5\6709\5169\500B\8CC7\6599\6B04\6642, \624D\9700\8981\9078\53D6\7B2C\4E8C\500B\4E3B\7D22\5F15\9375\8CC7\6599\6B04. \5982\679C\5728\7B2C\4E00\500B\4E3B\7D22\5F15\9375\8CC7\6599\6B04\9078\53D6\4E86 <code>ROWID</code>, \8ACB\52FF\586B\5165\6B64\8CC7\6599\6B04. \5340\57DF\82E5\8A2D\70BA\986F\793A\6372\52D5\5206\9801, \4FBF\6703\4F7F\7528\7B2C\4E8C\500B\4E3B\7D22\5F15\9375\4F86\907F\514D\986F\793A\91CD\8907\7684\8CC7\6599\5217.  \5340\57DF\5982\679C\986F\793A BLOB \8CC7\6599\6B04\7684\5F71\50CF, \5247\6703\4F7F\7528\7B2C\4E8C\500B\4E3B\7D22\5F15\9375\4F86\53D6\5F97\8A72\5F71\50CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110054792761314182)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109942083219314102)
,p_name=>'PE.PROPERTY.CARD_USES_BLOB_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5361\7247\4F7F\7528 BLOB \8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109594798910313825)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\503C\6E05\55AE\7684\8CC7\6599\5EAB\8CC7\6599\6B04\540D\7A31 (\5340\5206\5927\5C0F\5BEB), \6B64\540D\7A31\53EF\5229\7528\7236\9805\9762\5411\6216\7BE9\9078\503C\4F86\67E5\8A62\503C\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109594690060313825)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('LOV \8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110131647676314257)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\89F8\767C\91CD\65B0\6574\7406\6B64\503C\6E05\55AE\7684\8CC7\6599\6B04.'),
unistr('\82E5\6709\591A\500B\8CC7\6599\6B04, \8ACB\4F7F\7528\9017\865F\5340\9694\6BCF\500B\8CC7\6599\6B04\540D\7A31.'),
unistr('\60A8\53EF\4EE5\9375\5165\540D\7A31\6216\5F9E\53EF\7528\8CC7\6599\6B04\6E05\55AE\4E2D\6311\9078.'),
unistr('\5982\679C\5F9E\6E05\55AE\4E2D\6311\9078, \4E14\540C\6642\9593\5DF2\7D93\6709\8F38\5165\7684\6587\5B57\7684\8A71, \5C07\6703\5728\73FE\6709\6587\5B57\7684\7D50\5C3E\52A0\4E0A\4E00\500B\9017\865F, \5F8C\9762\518D\63A5\8457\5F9E\6E05\55AE\50B3\56DE\7684\8CC7\6599\6B04\540D\7A31.</p>'),
unistr('<p>\6BCF\7576\6B64\9801\9762\4E2D\4E4B\4EFB\4F55\6307\5B9A\7684\8CC7\6599\6B04\503C\8B8A\66F4\6642, \6B64\503C\6E05\55AE\5C31\6703\91CD\65B0\6574\7406.</p>'),
unistr('<p>\60A8\61C9\8A72\5728\6B64\503C\6E05\55AE SQL \67E5\8A62\7684 <em>where \5B50\53E5</em>\5167\4F7F\7528\6B64\5C6C\6027\4E2D\6307\5B9A\7684\8CC7\6599\6B04, \4EE5\9650\5236\50B3\56DE\7684\503C.</p>'),
unistr('<p>\4F8B\5982, \5047\8A2D\60A8\6709 Car Make \548C Model \8CC7\6599\6B04, \60A8\53EF\4EE5\5C07 Car Make \6307\5B9A\70BA Model \4E4B\503C\6E05\55AE\5B9A\7FA9\5167\7684\300C\968E\5C64\5F0F LOV \7236\9805\8CC7\6599\6B04\300D, \7136\5F8C\5728 where \5B50\53E5\5167\4F7F\7528 Car Make \4F86\5C0B\627E\8A72\503C\6E05\55AE.'),
unistr('\6BCF\7576 Car Make \8B8A\66F4\6642, Model \7684 LOV \5C31\6703\91CD\65B0\6574\7406, \800C\4E14\6E05\55AE\4E2D\53EA\6703\986F\793A\76EE\524D\6240\9078 Car Make \7684\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110131513875314257)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109594993598313825)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\89F8\767C\91CD\65B0\6574\7406\6B64\503C\6E05\55AE\7684\9762\5411.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109594886182313825)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\9762\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109281307267313585)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\89F8\767C\91CD\65B0\6574\7406\6B64\503C\6E05\55AE\7684\7BE9\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109281276152313585)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109246483115313555)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\89F8\767C\91CD\65B0\6574\7406\6B64\503C\6E05\55AE\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.'),
unistr('\82E5\6709\591A\500B\9805\76EE, \8ACB\4F7F\7528\9017\865F\5340\9694\6BCF\500B\9805\76EE\540D\7A31.'),
unistr('\60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\5F9E\53EF\7528\9805\76EE\7684\6E05\55AE\6311\9078.'),
unistr('\82E5\60A8\5F9E\6E05\55AE\4E2D\6311\9078\4F46\76EE\524D\5DF2\7D93\6709\8F38\5165\7684\6587\5B57, \5247\6703\5728\73FE\6709\6587\5B57\7684\7D50\5C3E\52A0\4E0A\9017\865F, \9017\865F\5F8C\7DCA\63A5\8457\6E05\55AE\50B3\56DE\7684\9805\76EE\540D\7A31.</p>'),
unistr('<p>\53EA\8981\6B64\9801\9762\4E0A\4EFB\4F55\6307\5B9A\7684\9805\76EE\503C\8B8A\66F4\6642, \6B64\503C\6E05\55AE\4FBF\6703\91CD\65B0\6574\7406.</p>'),
unistr('<p>\60A8\61C9\8A72\5728\6B64\503C\6E05\55AE SQL \67E5\8A62 <em>where \5B50\53E5</em>\5167\4F7F\7528\6B64\5C6C\6027\4E2D\6307\5B9A\7684\9801\9762\9805\76EE, \4F86\9650\5236\50B3\56DE\7684\503C.</p>'),
unistr('<p>\4F8B\5982, \82E5\6709\300C\8ECA\5EE0\300D\8207\300C\578B\865F\300D\7684\9801\9762\9805\76EE, \60A8\53EF\4EE5\5C07\300C\8ECA\5EE0\300D\6307\5B9A\70BA\968E\5C64\5F0F LOV \7236\9805\4E26\5217\51FA\300C\578B\865F\300D\7684\503C\6E05\55AE\5B9A\7FA9, \7136\5F8C\5728 where \5B50\53E5\4E2D\4F7F\7528\300C\8ECA\5EE0\300D\4F86\5C0B\627E\8A72\503C\6E05\55AE.'),
unistr('\53EA\8981\300C\8ECA\5EE0\300D\8B8A\66F4,\300C\578B\865F\300D\7684 LOV \4E5F\6703\91CD\65B0\6574\7406, \4E14\6E05\55AE\53EA\6703\986F\793A\76EE\524D\9078\53D6\7684\300C\8ECA\5EE0\300D\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109246320130313555)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109591736474313823)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6B64\503C\6E05\55AE\7684\91CD\65B0\6574\7406\689D\4EF6.</p>'),
unistr('<p>\82E5\8A2D\70BA<strong>\958B\555F</strong>, \5247\53EA\6709\6240\6709\7684<em>\968E\5C64\5F0F LOV \7236\9805\9805\76EE</em>\5747\4E0D\662F\7A7A\503C\6642, \624D\6703\57F7\884C\53D6\5F97\65B0\503C\7684\91CD\65B0\6574\7406\547C\53EB.'),
unistr('\82E5\6709\4E00\500B\9805\76EE\662F\7A7A\503C, \5C31\6703\5047\8A2D LOV \67E5\8A62\4E0D\6703\50B3\56DE\4EFB\4F55\8CC7\6599\5217.'),
unistr('\5728\6B64\72C0\6CC1\4E0B, \4FBF\6703\6E05\9664\700F\89BD\5668\4E2D\7684\9078\53D6\6E05\55AE\9805\76EE, \800C\4E0D\6703\57F7\884C\91CD\65B0\6574\7406.</p>'),
unistr('<p>\82E5\8A2D\70BA<strong>\95DC\9589</strong>, \5C07\4E00\5F8B\57F7\884C\91CD\65B0\6574\7406.'),
unistr('\53EA\6709\7576\60A8\5C0D\6B64\503C\6E05\55AE SQL \67E5\8A62 <em>where \5B50\53E5</em>\4E2D\53EF\4EE5\662F\7A7A\503C\7684<em>\968E\5C64\5F0F LOV \7236\9805\9805\76EE</em>\6709\7279\6B8A\7684\8655\7406\65B9\5F0F\6642, \624D\4F7F\7528\6B64\9078\9805.'),
unistr('\82E5\672A\9069\7576\8655\7406\53EF\4EE5\662F\7A7A\503C\7684\9801\9762\9805\76EE, \4FBF\6703\57F7\884C\4E0D\6703\50B3\56DE\4EFB\4F55\8CC7\6599\5217\7684\4E0D\5FC5\8981\91CD\65B0\6574\7406\547C\53EB.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109591640915313823)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981\7236\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108877204783313270)
,p_name=>'PE.PROPERTY.CHANGED_BY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\6700\5F8C\66F4\65B0\6B64\5C6C\6027\4E4B\958B\767C\4EBA\54E1\7684\4F7F\7528\8005\8B49\660E\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108877124701313270)
,p_name=>'PE.PROPERTY.CHANGED_BY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108877457886313270)
,p_name=>'PE.PROPERTY.CHANGED_ON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\6B64\5C6C\6027\4E0A\6B21\66F4\65B0\7684\6642\9593.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108877393114313270)
,p_name=>'PE.PROPERTY.CHANGED_ON.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109627232020313853)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\5716\8868\7684\9AD8\5EA6 (\50CF\7D20). \9AD8\5EA6\5B9A\7FA9\4E86\5716\8868\5340\57DF\7684\56FA\5B9A\9AD8\5EA6. \6216\8005, \82E5\8981\555F\7528\5716\8868\9AD8\5EA6\7684\81EA\52D5\91CD\65B0\8ABF\6574\5927\5C0F\529F\80FD, \8ACB\5C07\6B64\9805\76EE\7559\767D.'),
unistr('\9AD8\5EA6\5C07\6703\4F9D\64DA\700F\89BD\5668\7684\9AD8\5EA6\8ABF\6574.</p>'),
unistr('<p>\4F9D\7167\9810\8A2D, \5728\4F7F\7528\300CjQuery Mobile \667A\6167\578B\624B\6A5F\300D\4F7F\7528\8005\4ECB\9762\7684\9801\9762\4E0A\5EFA\7ACB\7684\5716\8868\4E26\6C92\6709\8A2D\5B9A\9AD8\5EA6\503C, \800C\662F\6703\6839\64DA\8981\5448\73FE\5716\8868\7684\88DD\7F6E\6B63\78BA\5730\91CD\65B0\8ABF\6574\5927\5C0F\4F86\7B26\5408\8A72\88DD\7F6E.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109627195572313853)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109627318007313853)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.UNIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109651074984313870)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\5716\8868\7684\6700\5927\5BEC\5EA6 (\50CF\7D20). \6700\5927\5BEC\5EA6\5B9A\7FA9\4E86\5716\8868\5340\57DF\7684\56FA\5B9A\5BEC\5EA6.'),
unistr('\6216\8005, \82E5\8981\555F\7528\5716\8868\5BEC\5EA6\7684\81EA\52D5\8ABF\6574\5927\5C0F\529F\80FD, \8ACB\5C07\6B64\9805\76EE\7559\767D. \5BEC\5EA6\6703\81EA\52D5\8A2D\70BA\8A72\5340\57DF\7684 100%.</p>'),
unistr('<p>\4F9D\7167\9810\8A2D, \5728\4F7F\7528 jQuery Mobile \667A\6167\578B\624B\6A5F\4F7F\7528\8005\4ECB\9762\7684\9801\9762\4E0A\5EFA\7ACB\7684\5716\8868\4E26\6C92\6709\8A2D\5B9A\5BEC\5EA6\503C, \800C\662F\6703\6839\64DA\8981\5448\73FE\5716\8868\7684\88DD\7F6E\6B63\78BA\5730\8ABF\6574\5927\5C0F\4F86\7B26\5408\8A72\88DD\7F6E.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109645400545313866)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5927\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109645556937313866)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.UNIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109624198902313851)
,p_name=>'PE.PROPERTY.CHART_TITLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5716\8868\9802\7AEF\6240\8981\986F\793A\7684\6A19\984C.  \5982\679C\662F\7518\7279\5716, \9019\500B\503C\53EA\7528\65BC\5B9A\7FA9\53EF\5B58\53D6\7684\5716\8868\6A19\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109624042370313850)
,p_name=>'PE.PROPERTY.CHART_TITLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109852590616314037)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8CC7\6599\7684\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109852653292314037)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672C\6A5F\8CC7\6599\5EAB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109852799287314038)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6E90\81EA\672C\6A5F\8CC7\6599\5EAB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109853252582314038)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109853305122314038)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6E90\81EA\5340\57DF\4F86\6E90\5B9A\7FA9\4E2D\6307\5B9A\7684\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109852890082314038)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528 REST \7684 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109852973916314038)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6E90\81EA\9023\7DDA\4F7F\7528\300C\555F\7528 REST \7684 SQL\300D\5B9A\7FA9\7684\9060\7AEF\8CC7\6599\5EAB. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109853089752314038)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109853144684314038)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\4F7F\7528 REST \8CC7\6599\4F86\6E90\5B9A\7FA9\7684 RESTful Web \670D\52D9\53D6\5F97\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109852404195314037)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109617830238313846)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\5831\8868\8CC7\6599\6B04\7684\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109775694973313980)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('* \65E5\671F\9078\64C7\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109775510148313980)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('* \65E5\671F\9078\64C7\5668 (\4E00\822C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109775480358313980)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('* \986F\793A\70BA\6587\5B57 (\5132\5B58\72C0\614B)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109775144385313980)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09 BLOB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109952502819314109)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8CC7\6599\6B04\986F\793A\70BA\9023\7D50\4EE5\4E0B\8F09\6A94\6848.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109775369311313980)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF\7684\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109952776557314109)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\986F\793A\8CC7\6599\6B04, \4F46\53EF\53C3\7167\8A72\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109776190959313980)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('* \96B1\85CF\7684\6B04\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109775050028313980)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5F71\50CF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109952413027314109)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8CC7\6599\6B04\986F\793A\70BA\5F71\50CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109774995440313979)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109952387984314109)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8CC7\6599\6B04\986F\793A\70BA\9023\7D50.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109775200563313980)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767E\5206\6BD4\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109952692570314109)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8CC7\6599\6B04\986F\793A\70BA\767E\5206\6BD4\5716\8868. \64F7\53D6\7684\503C\5FC5\9808\4ECB\65BC 0 \5230 100 \4E4B\9593.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109774792978313979)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D14\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109952132470314109)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\8CC7\6599\6B04\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109774858285313979)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D14\6587\5B57 (\4EE5\503C\6E05\55AE\70BA\57FA\790E)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109952238044314109)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5F9E\6307\5B9A\503C\6E05\55AE\50B3\56DE\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109776263759313980)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('* \5373\73FE\5F0F LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109776303719313981)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('* \5373\73FE\5F0F\9375\503C LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109776091989313980)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('* \5713\9215\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110023650493314160)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Rich Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110023728467314160)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528 HTML \6216 Markdown \5448\73FE\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109776541755313981)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('* \8CC7\6599\5217\9078\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109775941424313980)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('* \9078\53D6\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109776471109313981)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('* \7C21\55AE\6838\53D6\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109775725120313980)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('* \6587\5B57\6B04\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109775839313313980)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('* \6587\5B57\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109617790591313846)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109617421132313846)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\5206\9801 (\986F\793A\6240\6709\8CC7\6599\5217)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109618601217313847)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\5206\9801 (\986F\793A\6240\6709\8CC7\6599\5217)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109603809557313835)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\8981\5728\6B64\5831\8868\4E2D\4F7F\7528\7684\5206\9801\985E\578B.'),
unistr('\4E00\822C\800C\8A00, \5831\8868\4E2D\76EE\524D\986F\793A\7684\53EA\662F\7D50\679C\7684\5B50\96C6.'),
unistr('\5206\9801\6703\63D0\4F9B\4F7F\7528\8005\6709\95DC\7D50\679C\96C6\5167\8CC7\6599\5217\6578\76EE\548C\76EE\524D\4F4D\7F6E\7684\8CC7\8A0A. \5206\9801\4E5F\6703\5B9A\7FA9\7528\4F86\700F\89BD\81F3\4E0B\4E00\9801\6216\4E0A\4E00\9801\7684\9023\7D50\6216\6309\9215\7684\6A23\5F0F.</p>'),
unistr('<p>\5206\9801\53EF\4EE5\986F\793A\5728\5831\8868\7684\4E0A\65B9\6216\4E0B\65B9 (\6216\4E0A\4E0B\65B9\90FD\986F\793A), \4E5F\53EF\4EE5\7F6E\65BC\5DE6\908A\6216\53F3\908A.</p>'),
unistr('<p>\60A8\4E5F\53EF\4EE5\4F7F\7528\7C21\5316\7684\5206\9801\6A23\5F0F\4F86\6539\9032\6548\80FD, \4F8B\5982 <strong>\8CC7\6599\5217\7BC4\570D X \5230 Y (\542B\4E0B\4E00\500B\548C\4E0A\4E00\500B\9023\7D50)</strong>.'),
unistr('\4F7F\7528\300CX \5230 Y, \5171 Z \500B\300D\5F62\5F0F\7684\5206\9801\985E\578B\6642, \6703\9700\8981 &PRODUCT_NAME. \5F15\64CE\57F7\884C\5169\500B\67E5\8A62\4F86\50B3\56DE\7D50\679C.'),
unistr('\4E00\500B\67E5\8A62\8CA0\8CAC\64F7\53D6\8981\986F\793A\7684\76EE\524D\8A18\9304, \53E6\4E00\500B\67E5\8A62\8CA0\8CAC\53D6\5F97\8981\5728\5206\9801\63A7\5236\9805\4E2D\986F\793A\7684\8A18\9304\7E3D\6578.'),
unistr('\5982\679C\5831\8868\662F\4EE5\6975\5927\7684\8CC7\6599\96C6\70BA\57FA\790E\6216\6709\6975\8017\8CBB CPU \8CC7\6E90\7684\67E5\8A62 (\4F8B\5982, \6709\5F88\591A\975E\6700\4F73\7684\8868\683C\7D50\5408\6216\8017\8CBB\8CC7\6E90\7684\689D\4EF6), \9019\9805\984D\5916\7684\67E5\8A62\53EF\80FD\6703\589E\52A0\4E00\4E9B\8655\7406\6642\9593, \800C\5C0E\81F4\9700\8981\82B1\8F03\9577\7684\6642\9593\624D\80FD\5448\73FE\5831\8868.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109784255981313987)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.COMPUTED_BUT_NOT_DISPLAYED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\5916\90E8\5EFA\7ACB\7684\5206\9801\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109784394870313987)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.NEXT_PREVIOUS_LINKS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\7BC4\570D X \5230 Y (\542B\4E0B\4E00\500B\548C\4E0A\4E00\500B\9023\7D50)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109783682734313986)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\7BC4\570D X \5230 Y (\6C92\6709\5206\9801)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109783709144313986)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\7BC4\570D X \5230 Y, \5171 Z \500B (\6C92\6709\5206\9801)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109783936699313986)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\7BC4\570D 1-15 16-30  (\542B\8A2D\5B9A\5206\9801)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109784039104313986)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_IN_SELECT_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6E05\55AE\4E2D\7684\8CC7\6599\5217\7BC4\570D 1-15 16-30 (\542B\5206\9801)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109783805735313986)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_WITH_LINKS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\7BC4\570D X \5230 Y, \5171 Z \500B (\6709\5206\9801)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109784170145313986)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.SEARCH_ENGINE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\5F15\64CE 1,2,3,4 (\8A2D\5B9A\57FA\672C\5206\9801)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109603754597313835)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109573385139313809)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\300C\5716\793A\6AA2\8996\300D\4E2D\6BCF\4E00\8CC7\6599\5217\8981\986F\793A\7684\5716\793A\6578\76EE. \503C\70BA 5 \6642, \8868\793A\6BCF\4E00\5831\8868\8CC7\6599\5217\986F\793A 5 \500B\5716\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109771767143313977)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.1.D'
,p_message_language=>'zh-tw'
,p_message_text=>'1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109771879402313977)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.2.D'
,p_message_language=>'zh-tw'
,p_message_text=>'2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109771996141313977)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.3.D'
,p_message_language=>'zh-tw'
,p_message_text=>'3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109772076866313977)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.4.D'
,p_message_language=>'zh-tw'
,p_message_text=>'4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109772174163313977)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.5.D'
,p_message_language=>'zh-tw'
,p_message_text=>'5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109772261564313977)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.6.D'
,p_message_language=>'zh-tw'
,p_message_text=>'6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109772365870313978)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.7.D'
,p_message_language=>'zh-tw'
,p_message_text=>'7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109772455696313978)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.8.D'
,p_message_language=>'zh-tw'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109772521697313978)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.9.D'
,p_message_language=>'zh-tw'
,p_message_text=>'9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109573233000313809)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\4E00\8CC7\6599\5217\7684\8CC7\6599\6B04\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109563848013313802)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8CC7\6599\6B04\986F\793A\5C0D\9F4A\65B9\5F0F. \8ACB\6CE8\610F, \60A8\6240\9078\53D6\7684\5C0D\9F4A\65B9\5F0F\5FC5\9808\662F\6240\9078\5831\8868\6A23\677F\652F\63F4\7684\65B9\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109767821887313974)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7F6E\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109767735821313974)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109767901060313974)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109563723182313802)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\5C0D\9F4A\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109620190395313848)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\9810\8A2D\7684\8CC7\6599\6B04\503C\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109787783499313989)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.FUNCTION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109787624915313989)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109620016668313848)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109475019191313732)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.COMPONENT_PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7FA4\7D44\6A19\984C\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109563073487313802)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5831\8868\8CC7\6599\6B04\6A19\984C\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109562997105313802)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108992752177313365)
,p_name=>'PE.PROPERTY.COLUMN_IS_SORTABLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109901940790314073)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\5167\542B\552F\4E00\7D22\5F15\9375\4EE5\8B58\5225\8CC7\6599\5217\7684\8CC7\6599\6B04. \53EF\4F7F\7528\6B64\65B9\5F0F\63D0\4F9B\4E3B\7D22\5F15\9375\503C\7D66\81EA\8A02 JavaScript \7A0B\5F0F\78BC\6216\5C0D\61C9\4E8B\4EF6\8655\7406\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109901822564314073)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109562478952313801)
,p_name=>'PE.PROPERTY.COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\5831\8868\8CC7\6599\6B04\7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109562396587313801)
,p_name=>'PE.PROPERTY.COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109617651562313846)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\905E\589E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109619051505313847)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\905E\589E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109598182800313828)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\8CC7\6599\6B04\662F\5426\8981\4EE5\300C\905E\6E1B\300D\9806\5E8F\6392\5E8F. \5982\679C\672A\6307\5B9A, \5C31\6703\4EE5\300C\905E\589E\300D\9806\5E8F (\9810\8A2D\503C) \6392\5E8F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109780906987313984)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.LOV.DESC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\905E\6E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109598062735313828)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109597980556313828)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\6B64\8CC7\6599\6B04\7684\6392\5E8F\9806\5E8F.'),
unistr('\6BCF\500B\8CC7\6599\6B04\90FD\61C9\8A72\6709\4E00\500B\552F\4E00\7684\9806\5E8F\4F86\6B63\78BA\6392\5217\5831\8868\8F38\51FA.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109780179124313983)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.1.D'
,p_message_language=>'zh-tw'
,p_message_text=>'1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109780235593313983)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.2.D'
,p_message_language=>'zh-tw'
,p_message_text=>'2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109780378130313984)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.3.D'
,p_message_language=>'zh-tw'
,p_message_text=>'3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109780496755313984)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.4.D'
,p_message_language=>'zh-tw'
,p_message_text=>'4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109780586475313984)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.5.D'
,p_message_language=>'zh-tw'
,p_message_text=>'5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109780679585313984)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.6.D'
,p_message_language=>'zh-tw'
,p_message_text=>'6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109780712688313984)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.7.D'
,p_message_language=>'zh-tw'
,p_message_text=>'7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109780834684313984)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.8.D'
,p_message_language=>'zh-tw'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109597843887313827)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109562645719313801)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5831\8868\8CC7\6599\6B04\7684\8CC7\6599\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109562595649313801)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109596312340313826)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\8CC7\6599\6B04\5BEC\5EA6 (\50CF\7D20).'),
unistr('\5728\700F\89BD\5668\4E2D\986F\793A\5831\8868\6642, \8ACB\4F7F\7528\6B64\5C6C\6027.'),
unistr('\8ACB\6CE8\610F, \6240\9078\53D6\7684\5831\8868\6A23\677F\5FC5\9808\652F\63F4\8A2D\5B9A\8CC7\6599\6B04\5BEC\5EA6.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109596279432313826)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\683C\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109626764010313852)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.UNIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109231066812313543)
,p_name=>'PE.PROPERTY.COMMENTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\5728\6B64\8655\8F38\5165\958B\767C\4EBA\54E1\8A3B\89E3\6216\9644\8A3B. \9019\4E9B\8A3B\89E3\53EA\6703\986F\793A\65BC\61C9\7528\7A0B\5F0F\7522\751F\5668\5167, \57F7\884C\61C9\7528\7A0B\5F0F\6642\4E00\5F8B\4E0D\6703\986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109230999178313543)
,p_name=>'PE.PROPERTY.COMMENTS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A3B\89E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109928247908314092)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5728\6B64\5143\4EF6\5957\7528\7684 CSS \985E\5225. \6B64\985E\5225\5C07\5957\7528\81F3\5361\7247\5BB9\5668.  \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109928120117314092)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109988256489314135)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\8A55\4F30\6240\8F38\5165\8868\793A\5F0F\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109988628902314135)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109988569298314135)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109988454531314135)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109988744472314135)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109988325933314135)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109988181858314135)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109990251687314136)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\51FD\6578\4E3B\9AD4\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109990566611314137)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109990466489314137)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109990332139314137)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109990633507314137)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109990139793314136)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109235050832313546)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\904B\7B97\7522\751F\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\5F9E\53EF\7528\9805\76EE\7684\6E05\55AE\4E2D\6311\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109234992358313546)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109235808903313547)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\9805\76EE\503C\53EF\7522\751F\904B\7B97\9805\76EE\7684\9805\76EE. \60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\5F9E\53EF\7528\9805\76EE\7684\6E05\55AE\4E2D\6311\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109235723165313547)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109989866136314136)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\63D0\4F9B\503C\4EE5\7522\751F\904B\7B97\9805\76EE\7684 Java \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109989737974314136)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109991424980314137)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\503C\4EE5\7522\751F\904B\7B97\9805\76EE\7684 Java \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109991301070314137)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109989624647314136)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1\5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109989542120314136)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\63D0\4F9B\503C\4EE5\7522\751F\904B\7B97\9805\76EE\7684 JavaScript \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109989431845314136)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109991226497314137)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109991140298314137)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\503C\4EE5\7522\751F\904B\7B97\9805\76EE\7684 JavaScript \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109991064826314137)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109989395842314136)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1\5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109989236931314136)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\63D0\4F9B\503C\4EE5\7522\751F\904B\7B97\9805\76EE\7684 PL/SQL \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109989152495314136)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109990910116314137)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109990877018314137)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\503C\4EE5\7522\751F\904B\7B97\9805\76EE\7684 PL/SQL \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109990703572314137)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109236418882313547)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\9801\9762\5448\73FE\6216\8655\7406\671F\9593, \6B64\904B\7B97\7684\57F7\884C\9EDE.'),
unistr('\6700\5E38\898B\7684\904B\7B97\9EDE\662F<strong>\9001\51FA\5F8C</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109748453337313959)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5340\57DF\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110049822182314178)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE: \5728\5340\57DF\5448\73FE\4E4B\5F8C\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109748675481313960)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\5C3E\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110050017918314178)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE: \5728\8868\5C3E\5448\73FE\4E4B\5F8C\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109748251211313959)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D\4E4B\5F8C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110049645673314178)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE: \5728\6A19\982D\5448\73FE\4E4B\5F8C\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109748732584313960)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110050129929314179)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406: \5728\9801\9762\9001\51FA\5F8C, \4F46\8655\7406\9801\9762\4E4B\524D\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109748399945313959)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5340\57DF\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110049711558314178)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE: \5728\5340\57DF\5448\73FE\4E4B\524D\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109748590375313960)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\5C3E\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110049958786314178)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE: \5728\8868\5C3E\5448\73FE\4E4B\524D\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109748194766313959)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110049523415314178)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE: \5728\9801\9762\5448\73FE\4E4B\524D\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109748029351313959)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\968E\6BB5\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110049469498314178)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\65B0\7684\968E\6BB5\4F5C\696D\7522\751F\5F8C\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109236376481313547)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\9EDE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109236042635313547)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\503C\53EF\7528\4EE5\7522\751F\904B\7B97\9805\76EE\7684\300C\4F7F\7528\8005\504F\597D\8A2D\5B9A\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109235916915313547)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109990068799314136)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\63D0\4F9B\503C\4EE5\7522\751F\904B\7B97\9805\76EE\7684 Python \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109989969766314136)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109991659001314137)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\503C\4EE5\7522\751F\904B\7B97\9805\76EE\7684 Python \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109991548608314137)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109954832777314111)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\63D0\4F9B\503C\4EE5\7522\751F\904B\7B97\9805\76EE\7684 SQL \67E5\8A62. \82E5\7D50\679C\5305\542B\591A\500B\8CC7\6599\5217, \5247\6BCF\500B\8CC7\6599\5217\7684\503C\6703\5F62\6210\4EE5\55AE\4E00\5192\865F\5340\9694\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109954792133314111)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109989086608314136)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\70BA\4E3B\7BA1\4E14\5176\90E8\9580\4F4D\65BC\829D\52A0\54E5\5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109988993370314136)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\63D0\4F9B\503C\4EE5\7522\751F\904B\7B97\9805\76EE\7684 SQL \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109988842642314135)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109235684228313547)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\63D0\4F9B\503C\4EE5\7522\751F\904B\7B97\9805\76EE\7684 SQL \67E5\8A62. \82E5\7D50\679C\5305\542B\591A\500B\8CC7\6599\5217, \5247\53EA\6703\50B3\56DE\7B2C\4E00\500B\8CC7\6599\5217\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109235573294313547)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109235498434313547)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7528\4F86\7522\751F\904B\7B97\9805\76EE\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109235394374313546)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109235203628313546)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\4E0B\5217\6E05\55AE\4E2D\7684\904B\7B97\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109971391681314123)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109971408398314123)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\57F7\884C\8F38\5165\4E4B<em>\8868\793A\5F0F</em>\7684\7D50\679C\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109747598288313959)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109949915204314107)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B<em>\51FD\6578\4E3B\9AD4</em>\50B3\56DE\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109747893463313959)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109949603542314107)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\9078\53D6<em>\9805\76EE</em>\4E4B\968E\6BB5\4F5C\696D\72C0\614B\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109747695600313959)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62 (\50B3\56DE\55AE\4E00\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109949799802314107)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B <em>SQL \67E5\8A62</em>\50B3\56DE\7684\7B2C\4E00\500B\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109747709384313959)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62 (\50B3\56DE\4F7F\7528\5192\865F\5340\9694\7684\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109949871039314107)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B <em>SQL \67E5\8A62</em>\50B3\56DE\7684\55AE\4E00\503C (\4F7F\7528\55AE\4E00\5192\865F\5340\9694), \8A72\503C\6703\4E32\63A5\5404\8CC7\6599\5217\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109747966549313959)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109950088923314107)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\8F38\5165\7684<em>\504F\597D\8A2D\5B9A</em>\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109747431968313959)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109949519188314107)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5728<em>\975C\614B\503C</em>\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109235116594313546)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109596141880313826)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\91DD\5C0D\6B64\8CC7\6599\6B04, \6307\5B9A\662F\5426\8981\9032\884C\7E3D\548C\904B\7B97\4E26\986F\793A\5728\5831\8868\7684\6700\5F8C.'),
unistr('\82E5\8207\5206\6BB5\8CC7\6599\6B04\642D\914D\4F7F\7528, \6703\986F\793A\7E3D\548C\7684\7E3D\8A08\548C\6BCF\9805\5206\9694\7684\7E3D\548C.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109596076430313826)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97\7E3D\548C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109980854598314130)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\8A55\4F30\6240\8F38\5165\8868\793A\5F0F\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109981207527314130)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109981157466314130)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109981053409314130)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109981320937314130)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109980975261314130)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109980744297314130)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109982832997314131)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\51FD\6578\4E3B\9AD4\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109983175679314131)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109983090978314131)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109982938573314131)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109983245760314131)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109982775922314131)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109268544028313571)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5728\6B64\689D\4EF6\4F7F\7528\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\5F9E\53EF\7528\9805\76EE\7684\6E05\55AE\4E2D\6311\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109268444614313571)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109269907036313572)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5728\6B64\689D\4EF6\4F7F\7528\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\5F9E\53EF\7528\9805\76EE\7684\6E05\55AE\4E2D\6311\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109269873781313572)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109982408154314131)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CJava \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109982300321314131)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109984081432314132)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\689D\4EF6\5E03\6797\503C\7684 Java \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109983967734314132)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109982242017314131)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109982165672314131)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CJavaScript \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109982068998314131)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109983847189314132)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109983769790314132)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\689D\4EF6\5E03\6797\503C\7684 JavaScript \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109983698426314132)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109268700914313571)
,p_name=>'PE.PROPERTY.CONDITION_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\503C\6E05\55AE (\4F7F\7528\5192\865F (:) \5340\9694).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109268604451313571)
,p_name=>'PE.PROPERTY.CONDITION_LIST.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109269134410313572)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300C\9801\78BC\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109269064236313572)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109269315207313572)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300C\9801\78BC\300D\6E05\55AE (\4F7F\7528\9017\865F\5340\9694).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109269222149313572)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109981932710314131)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109981881699314130)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CPL/SQL \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109981771759314130)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109983529249314132)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109983455978314132)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\689D\4EF6\5E03\6797\503C\7684 PL/SQL \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109983387609314131)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109268942367313571)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\6B64\689D\4EF6\6307\5B9A\503C\9032\884C\6BD4\8F03\7684\300C\4F7F\7528\8005\504F\597D\8A2D\5B9A\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109268847545313571)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109982651658314131)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CPython \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109982548998314131)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109984261883314132)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\689D\4EF6\5E03\6797\503C\7684 Python \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109984109358314132)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109981671248314130)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\70BA\4E3B\7BA1\4E14\5176\90E8\9580\4F4D\65BC\829D\52A0\54E5\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109981516484314130)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CSQL \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109981497811314130)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110127476828314254)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\6AA2\67E5\54E1\5DE5\662F\5426\7DE8\5236\5728\90E8\9580 30, \5982\6709\4E00\6216\591A\500B\8CC7\6599\5217\5B58\5728\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\6AA2\67E5\54E1\5DE5\662F\5426\7DE8\5236\5728\90E8\9580 40, \5982\7121\4EFB\4F55\8CC7\6599\5217\5B58\5728\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109268132181313571)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684 SQL \67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109268017308313571)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109269586964313572)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\6587\5B57\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109269413359313572)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109270115754313572)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\503C (\5305\542B <code>&ITEM.</code> \66FF\4EE3\5B57\4E32).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109270008594313572)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109643456787313865)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\555F\7528\6B64\52D5\4F5C\5FC5\9808\7B26\5408\7684\689D\4EF6\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109271091248313573)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\555F\7528\6B64\52D5\614B\52D5\4F5C\5FC5\9808\7B26\5408\7684\689D\4EF6\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109267099173313570)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\4E00\500B\5FC5\9808\7B26\5408\7684\689D\4EF6\985E\578B, \4EE5\8B93\6B64\5143\4EF6\9032\884C\5448\73FE\6216\8655\7406.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109825433970314017)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\6210\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109963054810314117)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4E00\5F8B\5448\73FE\5143\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109824077031314016)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF\700F\89BD\5668\70BA Microsoft Internet Explorer 7.0 \6216\66F4\65B0\7684\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109824166823314016)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF\700F\89BD\5668\70BA XHTML / CSS \529F\80FD\700F\89BD\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109823962693314016)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF\700F\89BD\5668\70BA Mozilla\3001Netscape 6.x/7x \6216\66F4\65B0\7684\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109824256500314016)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF\700F\89BD\5668\70BA\5176\4ED6\700F\89BD\5668 (\6216\66F4\820A\7684\7248\672C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109822628163314015)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\5305\542B\5728\9805\76EE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109824633528314017)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8A9E\8A00 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109966668356314119)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\76EE\524D\4F7F\7528\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\8A9E\8A00\57F7\884C\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109824356359314016)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8A9E\8A00\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109966845439314120)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\76EE\524D\4F7F\7528\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\5176\4E2D\4E00\7A2E\8A9E\8A00\57F7\884C\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109824538425314016)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8A9E\8A00 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109966731009314119)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\76EE\524D\672A\4F7F\7528\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\8A9E\8A00\57F7\884C\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109824490470314016)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8A9E\8A00\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109966983090314120)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\76EE\524D\4E0D\662F\4F7F\7528\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\5176\4E2D\4E00\7A2E\8A9E\8A00\57F7\884C\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109821892441314015)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762 = \9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109965497748314119)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\7B49\65BC\60A8\5728<em>\9801\9762</em>\4E2D\8F38\5165\7684\503C.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109822080863314015)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\5728\9017\865F\5340\9694\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109965635160314119)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\5728\60A8\65BC<em>\9801\9762</em>\4E2D\8F38\5165\7684\6E05\55AE (\4EE5\9017\865F\5340\9694) \4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109821997756314015)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762 != \9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109965527812314119)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\4E0D\7B49\65BC\60A8\5728<em>\9801\9762</em>\4E2D\8F38\5165\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109822114482314015)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\4E0D\5728\9017\865F\5340\9694\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109965767557314119)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\4E0D\5728\60A8\65BC<em>\9801\9762</em>\4E2D\8F38\5165\7684\6E05\55AE (\4EE5\9017\865F\5340\9694) \4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109824761158314017)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: DAD_NAME = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109824805185314017)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: DAD_NAME != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109823547635314016)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5167\5D4C\9A57\8B49\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109966436343314119)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\986F\793A\5167\5D4C\9A57\8B49\932F\8AA4, \63A5\8457\9001\51FA\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109822924682314015)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109822798125314015)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109822883706314015)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109823042750314015)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109819587509314013)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109963118275314117)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62\50B3\56DE\4E00\6216\591A\500B\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109980590634314130)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109980635397314130)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F\8A55\4F30\70BA TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109819746466314013)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109963376033314117)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\4E3B\9AD4\50B3\56DE TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109825196567314017)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109825279836314017)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109823219745314016)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762/\5340\57DF\975E\552F\8B80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109966107647314119)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\9069\7528, \9801\9762\548C\7236\9805\5340\57DF\6703\6B63\5E38\986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109823181010314015)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762/\5340\57DF\70BA\552F\8B80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109966001975314119)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\9069\7528, \9801\9762\6216\7236\9805\5340\57DF\7684\300C\552F\8B80\300D\689D\4EF6\6703\8A55\4F30\70BA TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109821043305314014)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\5305\542B\7A7A\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109964678875314118)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\6C92\6709\7A7A\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109821329507314014)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\70BA\6587\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109964910877314118)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\70BA\6587\6578\5B57, \50C5\5305\542B\5B57\6BCD\8207\6578\5B57\4E14\6C92\6709\7279\6B8A\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109820584656314014)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109964187853314118)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\975E\7A7A\767D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109821278969314014)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\70BA\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109964813236314118)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\4E0D\662F\6578\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109820712384314014)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\70BA\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109964388852314118)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\4E0D\662F\6578\5B57\96F6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109820494313314014)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109964009638314117)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\70BA\7A7A\767D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109820847369314014)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\662F\7A7A\503C\6216\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109964442744314118)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\70BA\7A7A\767D\6216\6578\5B57\96F6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109821154963314014)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\70BA\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109964796455314118)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\662F\6578\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109820642954314014)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\70BA\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109964273811314118)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\662F\6578\5B57\96F6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109820977786314014)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\662F\7A7A\503C\4E5F\4E0D\70BA\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109964535625314118)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\975E\7A7A\767D\4E5F\4E0D\662F\6578\5B57\96F6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109823742403314016)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \5831\8868 (\78BA\5B9A\53EF\4EE5\986F\793A\4E0B\4E00\9801\6309\9215)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109823848777314016)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \5831\8868 (\78BA\5B9A\53EF\986F\793A\4E0A\4E00\9801\6309\9215)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109825321917314017)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\4E0D\6210\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109967092491314120)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E00\5F8B\4E0D\5448\73FE\5143\4EF6.</p>'),
unistr('<p>\6CE8\610F: \5C07\689D\4EF6\8B8A\66F4\70BA<strong>\4E00\5F8B\4E0D\5448\73FE</strong>\5C07\79FB\9664\6240\6709\73FE\6709\689D\4EF6. \82E5\8981\66AB\6642\505C\7528\67D0\5143\4EF6, Oracle \5EFA\8B70\60A8\6539\7528<em>\7D44\5EFA\9078\9805</em>\5C6C\6027.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109823668067314016)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\986F\793A\5167\5D4C\9A57\8B49\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109966556609314119)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\672A\986F\793A\5167\5D4C\9A57\8B49\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109819696671314013)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\50B3\56DE\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109963257303314117)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62\672A\50B3\56DE\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109822481131314015)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\662F\300C\9069\7528\65BC\5370\8868\6A5F\300D\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109965847119314119)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\5DF2\5C07\76EE\524D\7684\9801\9762\5207\63DB\70BA\300C\9069\7528\65BC\5370\8868\6A5F\300D\6A21\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109822548718314015)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\4E0D\662F\300C\9069\7528\65BC\5370\8868\6A5F\300D\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109965917390314119)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\5C1A\672A\5C07\76EE\524D\7684\9801\9762\5207\63DB\70BA\300C\9069\7528\65BC\5370\8868\6A5F\300D\6A21\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109819869710314013)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109963425114314117)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8981\6C42\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109820079592314013)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109963654192314117)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8981\6C42\5305\542B\5728\60A8\65BC<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109819917324314013)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109963585722314117)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8981\6C42\4E0D\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109820181194314013)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109963754835314117)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8981\6C42\4E0D\5305\542B\5728\60A8\65BC<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109824914285314017)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109825001594314017)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109823398807314016)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\5DF2\8A8D\8B49 (\4E0D\662F\516C\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109966234654314119)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\5DF2\767B\5165\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109823411661314016)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\662F\516C\7528\4F7F\7528\8005 (\4F7F\7528\8005\672A\8A8D\8B49)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109966350520314119)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\672A\767B\5165\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109821669700314014)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\504F\597D\8A2D\5B9A = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109965208157314118)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7684<em>\504F\597D\8A2D\5B9A</em>\503C\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109821770520314014)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\504F\597D\8A2D\5B9A != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109965324301314118)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7684<em>\504F\597D\8A2D\5B9A</em>\503C\4E0D\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109821442259314014)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\5728\5192\865F\5340\9694\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109965002705314118)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\5B8C\5168\5305\542B\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109821579005314014)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\5728\5192\865F\5340\9694\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109965168879314118)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\4E0D\5B8C\5168\5305\542B\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109820221324314013)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109963801548314117)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109820313434314013)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109963935804314117)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\4E0D\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109822344752314015)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762 != \5DF2\9001\51FA\7684\9801\9762 (\5DF2\516C\5E03)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109822279747314015)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762 = \5DF2\9001\51FA\7684\9801\9762 (\5DF2\516C\5E03)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109266950984313570)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109268387513313571)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\689D\4EF6\505A\6BD4\8F03\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109268217997313571)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109269778223313572)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\503C (\5305\542B <code>&ITEM.</code> \66FF\4EE3\5B57\4E32).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109269623773313572)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109139342854313475)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\78BA\8A8D\63D0\793A\4EE5\4FDD\8B77\6B64\6309\9215\7684\884C\70BA. \6703\5728\6309\9215\88AB\9EDE\9078\5F8C\986F\793A\78BA\8A8D\5C0D\8A71\65B9\584A, \4F7F\7528\8005\5FC5\9808\5728\6B64\5148\9032\884C\78BA\8A8D\5F8C, \6309\9215\624D\6703\57F7\884C\672C\8EAB\7684\52D5\4F5C.</p>'),
unistr('<p>\9019\9805\529F\80FD\53EF\7528\4F86\78BA\4FDD\4F7F\7528\8005\4E0D\6703\610F\5916\57F7\884C\91CD\5927\52D5\4F5C, \4F8B\5982\522A\9664\8A18\9304.</p>'),
unistr('<p>\6CE8\610F: \5C0D\8A71\65B9\584A\4E2D\7684\78BA\8A8D\6309\9215\6703\5F9E\4E3B\8981\6309\9215\6A19\7C64\884D\751F\51FA\81EA\5DF1\7684\6A19\7C64.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109139219153313475)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109139682221313475)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<pre>&lt;strong&gt;\78BA\5B9A\8981&lt;&#x2F;strong&gt;\522A\9664\54E1\5DE5 &amp;P1_ENAME. \55CE?</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109139558910313475)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\78BA\8A8D\5C0D\8A71\65B9\584A\4E2D\6240\8981\986F\793A\7684\8A0A\606F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109139449689313475)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109140387483313476)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109139855316313475)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5C0D\8A71\65B9\584A\7684\6A23\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109140117897313475)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.DANGER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5371\96AA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109139917293313475)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.INFORMATION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109140240109313475)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.SUCCESS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109140063449313475)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.WARNING.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109139743034313475)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109602225829313834)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\53EF\7528\7684\6E05\55AE\4E2D\9078\53D6\5167\5BB9\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109781141452313984)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.ATTACHMENT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109781221771313984)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.INLINE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5D4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109602131267313834)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5BB9\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109327433555313620)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\968E\6BB5\4F5C\696D Cookie \7684 URL \7DB2\57DF\5C6C\6027.'),
unistr('\5982\679C\8981\6C42 URL \7684\7D50\5C3E\6BD4\8F03\8207\6307\5B9A\7684\7DB2\57DF\4E0D\76F8\7B26, \7CFB\7D71\5C31\4E0D\6703\5C07 Cookie \50B3\9001\7D66\700F\89BD\5668.'),
unistr('\9810\8A2D\503C\70BA\8981\6C42 URL \7684\4E3B\6A5F\540D\7A31.</p>'),
unistr('<p>\7576\60A8\60F3\8981\8B93\5177\6709\5171\540C\7DB2\57DF\7684\61C9\7528\7A0B\5F0F\4E4B\9593\5171\7528\968E\6BB5\4F5C\696D Cookie \6642, \53EF\4EE5\4F7F\7528\6B64\5C6C\6027\4F86\6307\5B9A\8F03\4E0D\53D7\9650\5236\7684\7DB2\57DF.'),
unistr('\4F8B\5982, \5982\679C\8F38\5165\4E86 <code>yahoo.com</code> \7DB2\57DF, <code>my.yahoo.com</code>\3001<code>sport.yahoo.com</code> \53CA <code>finance.yahoo.com</code> \4FBF\90FD\53EF\5B58\53D6\76F8\540C\7684 Cookie.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109327382360313620)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Cookie \7DB2\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109327090271313620)
,p_name=>'PE.PROPERTY.COOKIE_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\968E\6BB5\4F5C\696D Cookie \7684\540D\7A31, \5FC5\9808\8981\6709\6B64 Cookie \9023\540C URL \4E2D\7684\968E\6BB5\4F5C\696D ID, \624D\80FD\8B58\5225 &PRODUCT_NAME. \968E\6BB5\4F5C\696D.'),
unistr('\5982\679C\672A\6307\5B9A\968E\6BB5\4F5C\696D Cookie \540D\7A31, &PRODUCT_NAME. \5C07\6703\5229\7528\9810\8A2D\503C.</p>'),
unistr('<p>\53EA\8981\5728\591A\500B\61C9\7528\7A0B\5F0F\4E2D\8F38\5165\76F8\540C\7684 Cookie \540D\7A31, \4FBF\53EF\8B93\6BCF\500B\61C9\7528\7A0B\5F0F\90FD\4F7F\7528\76F8\540C\7684\968E\6BB5\4F5C\696D Cookie.'),
unistr('\56E0\6B64, \5F9E &PRODUCT_NAME. \61C9\7528\7A0B\5F0F\5C0D\53E6\4E00\500B &PRODUCT_NAME. \61C9\7528\7A0B\5F0F\767C\51FA URL \547C\53EB\6642, \53EA\8981 Cookie \540D\7A31\76F8\540C, \4F7F\7528\8005\5C31\4E0D\9700\8981\91CD\65B0\9032\884C\8A8D\8B49, \56E0\70BA\65B0\7684\61C9\7528\7A0B\5F0F\53EF\4EE5\5229\7528\73FE\6709\7684\968E\6BB5\4F5C\696D Cookie.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109326968372313620)
,p_name=>'PE.PROPERTY.COOKIE_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Cookie \540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109327256815313620)
,p_name=>'PE.PROPERTY.COOKIE_PATH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\968E\6BB5\4F5C\696D Cookie \7684 URL \8DEF\5F91\5C6C\6027.'),
unistr('\5982\679C\8981\6C42 URL \7684\958B\982D\8207\6307\5B9A\7684\8DEF\5F91\4E0D\76F8\7B26, \7CFB\7D71\5C31\4E0D\6703\5C07 Cookie \50B3\9001\7D66\700F\89BD\5668.'),
unistr('\9810\8A2D\503C\70BA\8981\6C42 URL \7684\8DEF\5F91.</p>'),
unistr('<p>\7576\60A8\60F3\8981\8B93 URL \8DEF\5F91\958B\982D\76F8\7B26\7684\61C9\7528\7A0B\5F0F\4E4B\9593\5171\7528\968E\6BB5\4F5C\696D Cookie \6642, \53EF\4EE5\4F7F\7528\6B64\5C6C\6027\4F86\6307\5B9A\8F03\4E0D\53D7\9650\5236\7684\8DEF\5F91.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109327167368313620)
,p_name=>'PE.PROPERTY.COOKIE_PATH.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Cookie \8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109747299365313959)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\6A19\6E96\6A94\6848\53C3\7167</dt>'),
'<dd><pre>/mycss/main.css</pre></dd>',
unistr('<dt>\91DD\5C0D\4E00\822C\9801\9762\6AA2\8996\5F9E /mycss/minified/ \8F09\5165\7E2E\5C0F\7684\6A94\6848 main.min.css \4EE5\53CA\5728\9664\932F\6A21\5F0F\5F9E /mycss/ \8F09\5165 main.css, \6216\8005\5F9E\61C9\7528\7A0B\5F0F\7522\751F\5668\57F7\884C\61C9\7528\7A0B\5F0F\6642\7684\6A19\6E96\6A94\6848\53C3\7167.</dt>'),
'<dd><pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre></dd>',
unistr('<dt>\689D\4EF6\6027\5A92\9AD4\67E5\8A62</dt>'),
'<dd><pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre></dd>',
unistr('<dt>\5728\53C3\7167\61C9\7528\7A0B\5F0F\7248\672C\4E4B URL \4E2D\4F7F\7528\67E5\8A62\5B57\4E32\7684\6A94\6848\53C3\7167, \5982\6B64\7576\61C9\7528\7A0B\5F0F\5347\7D1A\5F8C (\4E14\7248\672C\905E\589E), \7CFB\7D71\6703\6307\793A\700F\89BD\5668\4E00\5F8B\8F09\5165\65B0\6A94\6848, \4E26\5FFD\7565\6240\6709\5148\524D\5FEB\53D6\7684\6A94\6848.</dt>'),
'<dd><pre>/mycss/main.css?version=#APP_VERSION#</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109233838367313545)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\9801\9762\4E2D\8F09\5165\7684\968E\5C64\5F0F\6A23\5F0F\8868 (CSS) \6A94\6848 URL. \6BCF\500B URL \90FD\5FC5\9808\5404\81EA\7368\7ACB\4E00\884C.'),
unistr('\5982\679C\60A8\63D0\4F9B\7684\662F\7E2E\5C0F\7684\6A94\6848\7248\672C, \90A3\9EBC\60A8\53EF\4EE5\91DD\5C0D\4E00\822C\9801\9762\6AA2\8996\4F7F\7528\66FF\4EE3\5B57\4E32 <code>#MIN#</code> \6216 <code>#MIN_DIRECTORY#</code>, \5206\5225\5728\60A8\7684\6A94\6848 URL \4E2D\5305\62EC <code>.min</code> \6216 <code>minified/</code>, \82E5\662F\9801\9762\5728\9664\932F\6A21\5F0F\6AA2\8996\6216\5F9E\61C9\7528\7A0B\5F0F\7522\751F\5668\57F7\884C\61C9\7528\7A0B\5F0F\6642, \8ACB\4F7F\7528\7A7A\767D\5B57\4E32.'),
unistr('\5982\679C\60A8\60F3\8981\5728\6A94\6848 URL \4E2D\5305\62EC\61C9\7528\7A0B\5F0F\7684\7248\672C, \4E5F\53EF\4EE5\4F7F\7528\66FF\4EE3\5B57\4E32 <code>#APP_VERSION#</code>.</p>'),
unistr('<p>\60A8\5728\6B64\8655\8F38\5165\7684\6A94\6848 URL \6703\53D6\4EE3\9801\9762\6A23\677F\4E2D\7684 <code>#PAGE_CSS#</code> \66FF\4EE3\5B57\4E32.</p>'),
unistr('<p>\6CE8\610F: \60A8\4E0D\9700\8981\5305\62EC\958B\982D\6216\7D50\5C3E <code>link</code> \6A19\8A18. \53EA\8981\5305\62EC\6A94\6848 URL \5C31\53EF\4EE5\4E86.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109233721704313545)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109780017134313983)
,p_name=>'PE.PROPERTY.CSS_STYLE.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5C07\6B64\5C6C\6027\8A2D\70BA <code>color:#FF0000;</code> \6703\5C07\8CC7\6599\6B04\7684\6587\5B57\8272\5F69\8B8A\66F4\70BA\7D05\8272, \4E26\7522\751F\4E0B\5217 HTML</dt>'),
'<dd><pre>',
'&lt;span style="color:#FF0000"&gt;Sample Data&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109597568959313827)
,p_name=>'PE.PROPERTY.CSS_STYLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5728\6B64\8CC7\6599\6B04\7684\503C\5957\7528\7684 CSS \6A23\5F0F. \60A8\53EF\4EE5\8F38\5165 CSS \6A23\5F0F\6216\5F9E\53EF\7528\9805\76EE\7684\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109597456447313827)
,p_name=>'PE.PROPERTY.CSS_STYLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSS \6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109570506042313807)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\63CF\8FF0\8CC7\6599\503C\7684\958B\59CB\548C\7D50\675F\754C\9650\7684\5206\754C\5B57\5143. \9810\8A2D\7684\5206\754C\5B57\5143\662F\96D9\5F15\865F.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109570444899313807)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSV \5206\754C\7B26\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109605425925313836)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5C07\5831\8868\5167\5BB9\4E0B\8F09\6210 CSV \6A94\6848. \82E5\8981\555F\7528 <em>CSV \4E0B\8F09</em>, \60A8\5FC5\9808\4F7F\7528\542B\6709 <code>#CSV_LINK#</code> \66FF\4EE3\5B57\4E32\7684\5831\8868\6A23\677F, \4E26\5C07\6B64\9078\9805\8A2D\70BA<strong>\958B\555F</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109605304247313836)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528 CSV \532F\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109570394468313807)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8CC7\6599\6B04\5340\9694\7B26\865F. \5982\679C\672A\8F38\5165\4EFB\4F55\503C, \5C07\6703\4F9D\64DA\60A8\76EE\524D\7684 NLS \8A2D\5B9A\503C, \4F7F\7528\9017\865F\6216\5206\865F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109570217275313807)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSV \5340\9694\7B26\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109238377007313549)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\525B\9032\5165\9801\9762\6642, \7126\9EDE\662F\5426\653E\5728\6E38\6A19.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109740827010313954)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\7684\7B2C\4E00\500B\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109740965984313954)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6703\4F7F\7528 JavaScript (\7531 &PRODUCT_NAME. \5F15\64CE\6240\7522\751F) \5C07\6E38\6A19\7126\9EDE\653E\5728\9801\9762\7684\7B2C\4E00\500B\6B04\4F4D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109741083896313954)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\805A\7126\5728\6E38\6A19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109741133467313954)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7126\9EDE\4E0D\5728\6E38\6A19, \4E5F\4E0D\6703\7522\751F\4EFB\4F55 JavaScript.<br>'),
unistr('\5982\679C\7522\751F\7684 JavaScript \8207\81EA\8A02\7684 JavaScript \885D\7A81, \8ACB\9078\53D6\6B64\9078\9805.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109232912875313545)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E38\6A19\7126\9EDE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109331044797313623)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\5340\57DF\7684\986F\793A\5C6C\6027\662F\5426\53EF\4EE5\7531\4F7F\7528\8005\81EA\8A02.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109761882977313970)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.0.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\7121\6CD5\81EA\8A02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109761746365313969)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\81EA\8A02\8207\9810\8A2D\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109761644625313969)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\81EA\8A02\8207\9810\8A2D\4E0D\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109330930439313623)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\81EA\8A02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109330012201313622)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\6B64\5340\57DF\4E0B\65B9\986F\793A\4E4B\9023\7D50 (\7528\4F86\5B58\53D6\5340\57DF\81EA\8A02\9801\9762) \7684\6A19\7C64.'),
unistr('\53EA\6709\53EF\81EA\8A02\7684\5340\57DF\624D\6703\986F\793A\6B64\6A19\7C64.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109329905605313622)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109635587761313859)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\6B64\6309\9215\8981\5305\62EC\7684 HTML \6587\5B57:'),
'<ul>',
unistr('<li>\5C0D\65BC\985E\578B\70BA <strong>HTML \6309\9215</strong>\7684\6309\9215, \6B64\6587\5B57\5C07\6703\65B0\589E\81F3 HTML \5143\7D20\5B9A\7FA9.</li>'),
unistr('<li>\5C0D\65BC\4EE5\6A23\677F\70BA\57FA\790E\7684\6309\9215, \60A8\7684\6A23\677F\5FC5\9808\5305\62EC <code>#BUTTON_ATTRIBUTES#</code> \66FF\4EE3\5B57\4E32.</li>'),
'</ul>',
'<p>',
unistr('\60A8\53EF\4EE5\4F7F\7528\6B64\5C6C\6027\4F86\63A7\5236\5B9A\4F4D\9EDE</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109635732126313859)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\500B\503C\6703\53D6\4EE3\5831\8868\6A23\677F\66FF\4EE3\5B57\4E32 <code>#REPORT_ATTRIBUTES#</code>.  \5C07\53EA\6703\53D6\4EE3\5831\8868\6A23\677F\4E4B\300C\8CC7\6599\5217\4E4B\524D\300D\5C6C\6027\4E2D\7684 <code>#REPORT_ATTRIBUTES#</code> \66FF\4EE3\5B57\4E32.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109475657541313732)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5305\62EC\5728\8868\55AE\5143\7D20 HTML \6A19\8A18\4E2D\7684\5176\4ED6\5C6C\6027. \7CFB\7D71\6703\7522\751F <code>size</code> \548C <code>id</code> \5C6C\6027, \56E0\6B64\4E0D\9700\8981\63D0\4F9B\9019\4E9B\5C6C\6027. \5C0D\65BC <code>class</code> HTML \5C6C\6027, \6700\597D\662F\6539\7528\5C08\7528\7684 <em>CSS \985E\5225</em>\5C6C\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109635430377313859)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5305\62EC\5728\8868\55AE\5143\7D20 HTML \6A19\8A18\4E2D\7684\5176\4ED6\5C6C\6027. \7CFB\7D71\6703\7522\751F <code>size</code> \548C <code>id</code> \5C6C\6027, \56E0\6B64\4E0D\9700\8981\63D0\4F9B\9019\4E9B\5C6C\6027. \5C0D\65BC <code>class</code> HTML \5C6C\6027, \6700\597D\662F\6539\7528\5C08\7528\7684 <em>CSS \985E\5225</em>\5C6C\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109635638899313859)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\66FF\4EE3\5340\57DF\5C6C\6027\7684\503C. \9019\500B\503C\6703\66FF\4EE3\5305\542B <code>#REGION_ATTRIBUTES#</code> \66FF\4EE3\5B57\4E32\7684\5340\57DF\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109635832491313859)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\500B\503C\6703\53D6\4EE3\5831\8868\6A23\677F\66FF\4EE3\5B57\4E32 <code>#REPORT_ATTRIBUTES#</code>.  \5C07\53EA\6703\53D6\4EE3\5831\8868\6A23\677F\4E4B\300C\8CC7\6599\5217\4E4B\524D\300D\5C6C\6027\4E2D\7684 <code>#REPORT_ATTRIBUTES#</code> \66FF\4EE3\5B57\4E32.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109635376702313859)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\8981\5305\62EC\5728\9805\76EE\6A19\8A18\4E2D\7684\5176\4ED6\5C6C\6027 (\4EE5\7A7A\683C\5340\9694).'),
unistr('\91DD\5C0D HTML CLASS \5C6C\6027, Oracle \5EFA\8B70\60A8\4F7F\7528\5C08\7528\7684\300CCSS \985E\5225\300D\5C6C\6027.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109635201461313859)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109546637738313785)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\81EA\8A02\8CC7\6599\6B04\540D\7A31, \9019\53EF\7528\65BC\5B9A\7FA9\81EA\8A02\5DE5\5177\63D0\793A\6216\8981\7528\65BC\5716\8868\5143\7D20\7684\8CC7\6599\5EAB\578B\8272\5F69. \82E5\70BA\7BB1\5F62\5716, \6B64\8CC7\6599\6B04\4E0D\61C9\8207\9078\53D6\7684\300C\503C\300D\8CC7\6599\6B04\5C0D\61C9\76F8\7B26. \82E5\9078\53D6\7684\8CC7\6599\6B04\548C\300C\503C\300D\8CC7\6599\6B04\5C0D\61C9\76F8\7B26, \5716\8868\4E0A\5C07\4E0D\6703\4F7F\7528\81EA\8A02\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109546578980313785)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\8CC7\6599\6B04 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109236808754313548)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\63D0\4F9B\7684\5BA3\544A\5F0F\4E8B\4EF6\4E0D\8DB3, \8ACB\6307\5B9A\81EA\8A02 JavaScript \4E8B\4EF6\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109236732752313548)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109553328789313790)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8CC7\6599\5EAB\4F5C\696D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109553850746313791)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.DELETE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109553431039313790)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_COLLECTION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64F7\53D6\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109553559701313790)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_SINGLE_ROW.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64F7\53D6\55AE\4E00\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109553659523313790)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.INSERT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D2\5165\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109553742636313791)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.UPDATE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109553209990313790)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109791141106313992)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109631792602313856)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\884C\4E8B\66C6\4E2D\986F\793A\7684\8CC7\6599\8981\4F7F\7528\7684\80CC\666F\8272\5F69.</p>'),
unistr('<p>\8ACB\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A\8272\5F69. \5341\516D\9032\4F4D\8868\793A\6CD5\662F\4EE5 #xxyyzz (\4E00\500B # \5F8C\9762\8DDF\8457 3 \500B\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57) \4F86\5B9A\7FA9, \5176\4E2D xx\3001yy \53CA zz \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\96D9\5B57\5143\5341\516D\9032\4F4D\503C.'),
unistr('RGB \4EE3\78BC\662F\4EE5 RGB(xxx,xxx,xxx) \4F86\5B9A\7FA9, \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \7684\6578\5B57, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\55AE\4E00 8 \4F4D\5143\4F4D\5143\7D44\503C.</p>'),
unistr('<p>\5728\7DB2\969B\7DB2\8DEF\4E2D\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5373\53EF\627E\51FA\60A8\60F3\8981\4F7F\7528\4E4B\8272\5F69\7684\5C0D\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109631636819313856)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\80CC\666F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109066524228313420)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\5340\5206\5927\5C0F\5BEB\7684\8CC7\6599\6B04\540D\7A31, \4F5C\70BA\6B64\9805\76EE\503C\7684\4F86\6E90.</p>'),
unistr('<p>\6B64\8CC7\6599\6B04\5FC5\9808\5B58\5728\65BC\300C\8868\55AE\300D\5340\57DF\5167\7684\6307\5B9A\8CC7\6599\4F86\6E90\4E2D.'),
unistr('\8CC7\6599\6B04\540D\7A31\82E5\4E0D\5B58\5728\65BC\53C3\7167\7684\8868\683C\4E2D, \4FBF\6703\5728\7A0B\5F0F\5BE6\969B\57F7\884C\6642\767C\751F\932F\8AA4\4E14\4E0D\6703\8F09\5165\9801\9762.'),
unistr('\76F8\540C\5730, \82E5\672A\5B9A\7FA9\5167\5EFA\64F7\53D6\8CC7\6599\5217\8655\7406\4F5C\696D, \4E14\6709<strong>\8CC7\6599\5EAB\8CC7\6599\6B04</strong>\4F86\6E90\985E\578B\7684\9805\76EE, \4E5F\6703\767C\751F\932F\8AA4, \4E14\5617\8A66\5448\73FE\9801\9762\6642\4E0D\6703\8F09\5165\9801\9762.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109066431649313420)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109066302709313420)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\9801\9762\9805\76EE\7684\8868\55AE\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109066208670313420)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109831633970314022)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109631906509313856)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\884C\4E8B\66C6\4E2D\7684\8CC7\6599\8981\4F7F\7528\7684\8272\5F69.</p>'),
unistr('<p>\8ACB\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A\8272\5F69. \5341\516D\9032\4F4D\8868\793A\6CD5\662F\4EE5 #xxyyzz (\4E00\500B # \5F8C\9762\8DDF\8457 3 \500B\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57) \4F86\5B9A\7FA9, \5176\4E2D xx\3001yy \53CA zz \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\96D9\5B57\5143\5341\516D\9032\4F4D\503C.'),
unistr('RGB \4EE3\78BC\5B9A\7FA9\70BA RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \4E4B\9593\7684\6578\5B57, \5404\81EA\70BA\4E00\500B 8 \4F4D\5143\7684\4F4D\5143\7D44\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.</p>'),
unistr('<p>\8ACB\5F9E\7DB2\969B\7DB2\8DEF\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5C0B\627E\8207\60A8\60F3\4F7F\7528\4E4B\8272\5F69\540C\7B49\7684\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109631812239313856)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109471558150313730)
,p_name=>'PE.PROPERTY.DATA_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\57FA\790E\8CC7\6599\5EAB\8CC7\6599\6B04\7684\8CC7\6599\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110137903548314262)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BFILE.D'
,p_message_language=>'zh-tw'
,p_message_text=>'BFILE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110137730985314262)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BLOB.D'
,p_message_language=>'zh-tw'
,p_message_text=>'BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110137687813314262)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.CLOB.D'
,p_message_language=>'zh-tw'
,p_message_text=>'CLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110137037550314261)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.DATE.D'
,p_message_language=>'zh-tw'
,p_message_text=>'DATE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110137532614314262)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_D2S.D'
,p_message_language=>'zh-tw'
,p_message_text=>'INTERVAL DAY TO SECOND'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110137478583314262)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_Y2M.D'
,p_message_language=>'zh-tw'
,p_message_text=>'INTERVAL YEAR TO MONTH'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110136991067314261)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.NUMBER.D'
,p_message_language=>'zh-tw'
,p_message_text=>'NUMBER'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110137889453314262)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.ROWID.D'
,p_message_language=>'zh-tw'
,p_message_text=>'ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109137298086313473)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'zh-tw'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110137126714314261)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP.D'
,p_message_language=>'zh-tw'
,p_message_text=>'TIMESTAMP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110137327726314262)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_LTZ.D'
,p_message_language=>'zh-tw'
,p_message_text=>'TIMESTAMP WITH LOCAL TIME ZONE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110137285010314261)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_TZ.D'
,p_message_language=>'zh-tw'
,p_message_text=>'TIMESTAMP WITH TIME ZONE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110136877999314261)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.VARCHAR2.D'
,p_message_language=>'zh-tw'
,p_message_text=>'VARCHAR2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109471414813313730)
,p_name=>'PE.PROPERTY.DATA_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109628731971313854)
,p_name=>'PE.PROPERTY.DATE_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\8868\683C\6216\67E5\8A62\9078\53D6\5167\542B\8981\653E\5230\884C\4E8B\66C6\4E4B\65E5\671F\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109628684378313854)
,p_name=>'PE.PROPERTY.DATE_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109628969205313854)
,p_name=>'PE.PROPERTY.DATE_FORMAT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\5728\884C\4E8B\66C6\4E0A\986F\793A\6642\9593\6216\50C5\986F\793A\65E5\671F\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109628816381313854)
,p_name=>'PE.PROPERTY.DATE_FORMAT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109596707966313827)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\5728\6B64\8CC7\6599\6B04\7684\65E5\671F\9078\64C7\5668\5957\7528\7684\683C\5F0F\906E\7F69.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109777105242313981)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY.D'
,p_message_language=>'zh-tw'
,p_message_text=>'DD/MM/YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109776978664313981)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DASH.D'
,p_message_language=>'zh-tw'
,p_message_text=>'DD-MM-YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109777008331313981)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DOT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'DD.MM.YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109777756581313982)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI.D'
,p_message_language=>'zh-tw'
,p_message_text=>'DD/MM/YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109777578066313981)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DASH.D'
,p_message_language=>'zh-tw'
,p_message_text=>'DD-MM-YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109777609949313982)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DOT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'DD.MM.YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109777485688313981)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI.D'
,p_message_language=>'zh-tw'
,p_message_text=>'DD/MM/YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109777252087313981)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DASH.D'
,p_message_language=>'zh-tw'
,p_message_text=>'DD-MM-YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109777312263313981)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DOT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'DD.MM.YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109777837281313982)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR.D'
,p_message_language=>'zh-tw'
,p_message_text=>'DD-MON-RR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109778002511313982)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH24_MI.D'
,p_message_language=>'zh-tw'
,p_message_text=>'DD-MON-RR HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109777923020313982)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH_MI.D'
,p_message_language=>'zh-tw'
,p_message_text=>'DD-MON-RR HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109778125321313982)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY.D'
,p_message_language=>'zh-tw'
,p_message_text=>'DD-MON-YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109778391983313982)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH24_MI.D'
,p_message_language=>'zh-tw'
,p_message_text=>'DD-MON-YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109778232412313982)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH_MI.D'
,p_message_language=>'zh-tw'
,p_message_text=>'DD-MON-YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109778420323313982)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY.D'
,p_message_language=>'zh-tw'
,p_message_text=>'MM/DD/YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109778651960313982)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH24_MI.D'
,p_message_language=>'zh-tw'
,p_message_text=>'MM/DD/YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109778541006313982)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH_MI.D'
,p_message_language=>'zh-tw'
,p_message_text=>'MM/DD/YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109778760570313982)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD.D'
,p_message_language=>'zh-tw'
,p_message_text=>'RR-MON-DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109778980321313982)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH24_MI.D'
,p_message_language=>'zh-tw'
,p_message_text=>'RR-MON-DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109778815175313982)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH_MI.D'
,p_message_language=>'zh-tw'
,p_message_text=>'RR-MON-DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109776670628313981)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_DATE_FORMAT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\61C9\7528\7A0B\5F0F\65E5\671F\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109776745304313981)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_FORMAT_MASK.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\61C9\7528\7A0B\5F0F\683C\5F0F\906E\7F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109776887601313981)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_FORMAT_MASK.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\9805\76EE\683C\5F0F\906E\7F69')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109779096377313983)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_DOT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'YYYY.DD.MM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109779254781313983)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH24_MI_DOT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'YYYY.DD.MM HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109779135905313983)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH_MI_DOT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'YYYY.DD.MM HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109779319164313983)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD.D'
,p_message_language=>'zh-tw'
,p_message_text=>'YYYY-MM-DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109779704831313983)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI.D'
,p_message_language=>'zh-tw'
,p_message_text=>'YYYY-MM-DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109779852376313983)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI_SLASH.D'
,p_message_language=>'zh-tw'
,p_message_text=>'YYYY/MM/DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109779549950313983)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI.D'
,p_message_language=>'zh-tw'
,p_message_text=>'YYYY-MM-DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109779601041313983)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI_SLASH.D'
,p_message_language=>'zh-tw'
,p_message_text=>'YYYY/MM/DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109779442908313983)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_SLASH.D'
,p_message_language=>'zh-tw'
,p_message_text=>'YYYY/MM/DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109596645050313826)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F\906E\7F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109633021205313857)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E00\4E0B\300C\76EE\6A19\300D\4EE5\547C\53EB\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A. \60A8\53EF\4EE5\8F38\5165\6309\4E00\4E0B\73FE\6709\4E8B\4EF6\5916\7684\884C\4E8B\66C6\5132\5B58\683C\4F86\5EFA\7ACB\4E8B\4EF6\6642, \884C\4E8B\66C6\5C07\547C\53EB\7684\76EE\6A19\9023\7D50.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109632999356313857)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\76EE\6A19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109261271399313566)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\8981\57F7\884C\7684\52D5\4F5C. \652F\63F4\4E0B\5217\52D5\4F5C:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\6839\64DA\60A8\61C9\7528\7A0B\5F0F\7D44\614B\7684\4E0D\540C, \5728\6B64\8655\53EF\80FD\53E6\6709\5176\4ED6\52D5\614B\52D5\4F5C Plug-in.'),
unistr('\9019\4E9B\6703\986F\793A\70BA<em>&lt;\6211\7684 Plug-in&gt; [Plug-in]</em>.'),
unistr('\4E0B\5217 Plug-in \5B89\88DD\5728\6B64\61C9\7528\7A0B\5F0F\5171\7528\5143\4EF6\5167:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109261144607313566)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109584604245313818)
,p_name=>'PE.PROPERTY.DA_EVENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\53EF\7528\7684\6E05\55AE\4E2D\9078\53D6\9069\7576\7684\52D5\614B\52D5\4F5C\4E8B\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109584526153313818)
,p_name=>'PE.PROPERTY.DA_EVENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109947780723314106)
,p_name=>'PE.PROPERTY.DB_SESSION_CLEANUP.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664 PL/SQL \7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109947657010314106)
,p_name=>'PE.PROPERTY.DB_SESSION_INIT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\521D\59CB\5316 PL/SQL \7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109616687910313845)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110057714111314184)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\61C9\7528\7A0B\5F0F\5B89\5168\6027\5C6C\6027\4E2D\5B9A\7FA9\7684\8A2D\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109240728308313551)
,p_name=>'PE.PROPERTY.DEEP_LINKING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\5982\4F55\8655\7406\5C0D\6B64\9801\9762\7684\5916\90E8 URL \8981\6C42.'),
unistr('\5F9E\6B64\61C9\7528\7A0B\5F0F\5167\5C0D\6B64\9801\9762\7684\9801\9762\8981\6C42\4E0D\7B97\662F\6DF1\5C64\9023\7D50, \4E0D\53D7\6B64\5C6C\6027\7684\8A2D\5B9A\6240\63A7\5236.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109741764096313954)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109741803950313954)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C URL \672A\5305\542B\6709\6548\7684\968E\6BB5\4F5C\696D ID, &PRODUCT_NAME. \6703\555F\52D5\4E00\500B\65B0\7684\968E\6BB5\4F5C\696D, \4E26\5C07\4F7F\7528\8005\91CD\65B0\5C0E\5411\81F3\61C9\7528\7A0B\5F0F\9996\9801, \800C\975E\6B64\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109741542346313954)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\555F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109741637890313954)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5728 URL \4E2D\5C07\6B64\9801\9762\6307\5B9A\70BA\76EE\6A19\9801\9762, \6700\7D42\6703\91CD\65B0\5C0E\5411\81F3\6B64\9801\9762.<br>'),
unistr('\5982\679C\4F7F\7528\8005\5C1A\672A\7D93\904E\8A8D\8B49\4E14\9801\9762\4E0D\662F\516C\7528\7684, \7CFB\7D71\5C31\6703\63D0\793A\4F7F\7528\8005\767B\5165.'),
unistr('\9806\5229\767B\5165\61C9\7528\7A0B\5F0F\5F8C, \4F7F\7528\8005\6703\88AB\91CD\65B0\5C0E\5411\81F3\6B64\9801\9762.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109240656049313551)
,p_name=>'PE.PROPERTY.DEEP_LINKING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DF1\5C64\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109381812263313661)
,p_name=>'PE.PROPERTY.DEFAULT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\5C07\4F7F\7528\8005\4ECB\9762\8A2D\70BA\9810\8A2D\61C9\7528\7A0B\5F0F\4ECB\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109381719900313661)
,p_name=>'PE.PROPERTY.DEFAULT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109230874505313543)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\532F\51FA\6642\5957\7528\81F3\6B64\5143\4EF6\7684\9810\8A2D\7D44\5EFA\9078\9805. \532F\51FA\9078\9805\53EF\8986\5BEB\6B64\9078\9805.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109739232844313952)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5305\62EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110049205467314178)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\505C\7528\4E14\4E0D\5C6C\65BC\61C9\7528\7A0B\5F0F\7684\4E00\90E8\5206.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109739356580313952)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\62EC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110049308159314178)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\555F\7528\4E14\5C6C\65BC\61C9\7528\7A0B\5F0F\7684\4E00\90E8\5206.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109230761457313543)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\51FA\6642\9810\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109472370689313730)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5982\4F55\5224\65B7\6B64\8CC7\6599\6B04\7684\9810\8A2D\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109972389122314124)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109972426490314124)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B<em>\8868\793A\5F0F</em>\50B3\56DE\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109972500099314124)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109972671244314124)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B<em>\51FD\6578\4E3B\9AD4</em>\50B3\56DE\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109472699552313730)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109472721329313730)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\6240\9078\53D6<em>\9805\76EE</em>\4E4B\968E\6BB5\4F5C\696D\72C0\614B\50B3\56DE\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109473272273313731)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109473306157313731)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8A2D\5B9A\70BA\5F9E\8F38\5165\4E4B<em>\9806\5E8F</em>\50B3\56DE\7684\503C. \9019\662F\300C\7279\6B8A\300D\9810\8A2D\985E\578B: \6B64\985E\578B\6703\5728\4E92\52D5\5F0F\65B9\683C DML \8655\7406\4F5C\696D\4E2D\57F7\884C, <em>\4E0D\6703</em>\5728\9801\9762\8F09\5165\671F\9593\57F7\884C. \7576<strong>\63D2\5165\5F8C\50B3\56DE\4E3B\7D22\5F15\9375</strong>\7121\6CD5\4F7F\7528\6642, \4F7F\7528\6B64\985E\578B\81EA\52D5\7522\751F\4E3B\7D22\5F15\9375\503C, \4F8B\5982: \4F7F\7528\8996\89C0\8868\548C INSTEAD OF \89F8\767C\7A0B\5F0F\6216\8CC7\6599\5EAB\9023\7D50\6642. \9806\5E8F\540D\7A31\6709\5927\5C0F\5BEB\4E4B\5225; \4F7F\7528\96D9\5F15\865F\8868\793A\6DF7\5408\5927\5C0F\5BEB\7684\9806\5E8F\540D\7A31 ("mySequence").</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109472815709313731)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109472958249313731)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B <em>SQL \67E5\8A62</em>\50B3\56DE\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109473066672313731)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\5192\865F\5340\9694\6E05\55AE\7684 SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109473150438313731)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8A2D\70BA\5F9E\8F38\5165\4E4B <em>SQL \67E5\8A62</em>\50B3\56DE\7684\5192\865F\5340\9694\503C\6E05\55AE.</p>'),
unistr('        <p>\6CE8\610F - \8CC7\6599\6B04\986F\793A\70BA\6838\53D6\65B9\584A\3001\5713\9215\7FA4\7D44\6216\5F80\8FD4\5207\63DB\6642, \9700\8981\5192\865F\5340\9694\6E05\55AE.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109472409445313730)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109472584296313730)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA<em>\975C\614B</em>\503C\4E2D\6240\8F38\5165\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109472244235313730)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109995477791314140)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\8A55\4F30\6240\8F38\5165\8868\793A\5F0F\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109995863443314141)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109995712494314140)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109995663876314140)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109995914768314141)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109995545110314140)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109995390487314140)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109997475227314142)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\51FD\6578\4E3B\9AD4\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109997771372314142)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109997675590314142)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109997514309314142)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109997888100314142)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109997354597314142)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109620337497313848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\542B\6709\9810\8A2D\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109620258303313848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109997064154314141)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7522\751F\6B64\9805\76EE\503C\7684 Java \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109996952603314141)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109998618895314142)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\9805\76EE\503C\7684 Java \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109998558437314142)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109996861631314141)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1\5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109996775095314141)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7522\751F\6B64\9805\76EE\503C\7684 JavaScript \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109996610467314141)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109998486203314142)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109998376371314142)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\9805\76EE\503C\7684 JavaScript \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109998206373314142)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109996595921314141)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1\5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109996424584314141)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7522\751F\6B64\9805\76EE\503C\7684 PL/SQL \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109996315590314141)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109998114211314142)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109998026469314142)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\9805\76EE\503C\7684 PL/SQL \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109997989728314142)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109997256659314141)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7522\751F\6B64\9805\76EE\503C\7684 Python \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109997129593314141)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109998854791314143)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\9805\76EE\503C\7684 Python \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109998710057314143)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109473953065313731)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\8CC7\6599\6B04\4E4B\9810\8A2D\503C\7684\8CC7\6599\5EAB\9806\5E8F\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109473810148313731)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109996263478314141)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\70BA\4E3B\7BA1\4E14\5176\90E8\9580\4F4D\65BC\829D\52A0\54E5\5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109996109041314141)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7522\751F\6B64\9805\76EE\503C\7684 SQL \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109996069845314141)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109473530608313731)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\8CC7\6599\6B04\4E4B\9810\8A2D\503C\7684 SQL \67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109473438215313731)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109473707154313731)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\8CC7\6599\6B04\4E4B\9810\8A2D\5192\865F\5340\9694\503C\6E05\55AE\7684 SQL \67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109473643044313731)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62\5192\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109254473506313561)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\9805\76EE\7684\9810\8A2D\503C. \9805\76EE\7684\503C\82E5\4E0D\662F\5F9E\968E\6BB5\4F5C\696D\72C0\614B\884D\751F\4E14\4F86\6E90\503C\662F\7A7A\503C\6642, \5C31\6703\4F7F\7528\9810\8A2D\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109254342098313561)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109254275952313561)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\9805\76EE\7684\9810\8A2D\503C\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109971718419314123)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109971810691314123)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B<em>\8868\793A\5F0F</em>\50B3\56DE\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109971924075314123)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109972099554314123)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B<em>\51FD\6578\4E3B\9AD4</em>\50B3\56DE\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109065124815313419)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109065259136313419)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\6240\9078\53D6<em>\9805\76EE</em>\4E4B\968E\6BB5\4F5C\696D\72C0\614B\50B3\56DE\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109065760501313420)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109065812209313420)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8A2D\5B9A\70BA\5F9E\8F38\5165\4E4B<em>\9806\5E8F</em>\50B3\56DE\7684\503C. \9019\662F\300C\7279\6B8A\300D\9810\8A2D\985E\578B: \6B64\985E\578B\6703\5728\8868\55AE\5340\57DF DML \8655\7406\4F5C\696D\4E2D\57F7\884C, <em>\4E0D\6703</em>\5728\9801\9762\8F09\5165\671F\9593\57F7\884C. \7576<strong>\63D2\5165\5F8C\50B3\56DE\4E3B\7D22\5F15\9375</strong>\7121\6CD5\4F7F\7528\6642, \4F7F\7528\6B64\985E\578B\81EA\52D5\7522\751F\4E3B\7D22\5F15\9375\503C, \4F8B\5982: \4F7F\7528\8996\89C0\8868\548C INSTEAD OF \89F8\767C\7A0B\5F0F\6216\8CC7\6599\5EAB\9023\7D50\6642. \9806\5E8F\540D\7A31\6709\5927\5C0F\5BEB\4E4B\5225.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109065346630313419)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109065418800313420)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B <em>SQL \67E5\8A62</em>\50B3\56DE\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109065579257313420)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\5192\865F\5340\9694\6E05\55AE\7684 SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109065638333313420)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8A2D\70BA\5F9E\8F38\5165\4E4B <em>SQL \67E5\8A62</em>\50B3\56DE\7684\5192\865F\5340\9694\503C\6E05\55AE.</p>'),
unistr('        <p>\6CE8\610F - \8CC7\6599\6B04\986F\793A\70BA\6838\53D6\65B9\584A\3001\5713\9215\7FA4\7D44\6216\5F80\8FD4\5207\63DB\6642, \9700\8981\5192\865F\5340\9694\6E05\55AE.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109756581477313966)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109065002337313419)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA<em>\975C\614B</em>\503C\4E2D\6240\8F38\5165\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109254176962313561)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109483947375313739)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5B9A\7FA9\6B64\4E92\52D5\5F0F\65B9\683C\7684\5716\8868.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109483824089313739)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B9A\7FA9\5716\8868\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109459568523313721)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\7528\4F86\9650\5236\8AB0\80FD\5920\522A\9664\8CC7\6599\5217\7684\6388\6B0A\914D\7F6E.'),
unistr('		\82E5\8981\8B93\4E00\822C\4F7F\7528\8005\522A\9664\8CC7\6599\5217, \8A72\4F7F\7528\8005\7684\9019\500B\6388\6B0A\914D\7F6E\5FC5\9808\8A55\4F30\70BA TRUE.'),
unistr('		\5982\679C\672A\63D0\4F9B\6388\6B0A\914D\7F6E, \5247\4EFB\4F55\4F7F\7528\8005\90FD\53EF\4EE5\5728\6B64\4E92\52D5\5F0F\65B9\683C\4E2D\522A\9664\8CC7\6599\5217.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109459453004313721)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109592912576313824)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\689D\4EF6\6AA2\67E5\53E6\4E00\500B\9762\5411\6216\7BE9\9078\4E2D\7684\503C, \4EE5\63A7\5236\662F\5426\986F\793A\76EE\524D\7684\9762\5411\6216\7BE9\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109593036547313824)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B49\65BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109593108091313824)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5<em>\9762\5411\6216\7BE9\9078</em>\4E2D\7684\503C\662F\5426\7B49\65BC\6307\5B9A\7684<em>\503C</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109593472215313824)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109593555485313824)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5<em>\9762\5411\6216\7BE9\9078</em>\4E2D\7684\503C\662F\5426\5728\6307\5B9A\7684<em>\6E05\55AE</em>\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109593282688313824)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\7B49\65BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109593347688313824)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5<em>\9762\5411\6216\7BE9\9078</em>\4E2D\7684\503C\662F\5426\4E0D\7B49\65BC\6307\5B9A\7684<em>\503C</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109593653555313824)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5728\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109593722638313824)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5<em>\9762\5411\6216\7BE9\9078</em>\4E2D\7684\503C\662F\5426\4E0D\5728\6307\5B9A\7684<em>\6E05\55AE</em>\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109594094802313824)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109594101180313825)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5<em>\9762\5411\6216\7BE9\9078</em>\4E2D\7684\503C\662F\5426\4E0D\662F\7A7A\7684.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109593821741313824)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109593985332313824)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5<em>\9762\5411\6216\7BE9\9078</em>\4E2D\7684\503C\662F\4E0D\662F\7A7A\7684.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109592864956313824)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109594538511313825)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\503C\6E05\55AE (\4F7F\7528\9017\865F\5340\9694).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109594487549313825)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109594361112313825)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109594212200313825)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109592759925313824)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5FC5\9808\52FE\9078\7684\95DC\806F\9762\5411, \6C7A\5B9A\662F\5426\61C9\986F\793A\76EE\524D\7684\9762\5411.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109592638763313823)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9762\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109918208950314085)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5FC5\9808\52FE\9078\7684\95DC\806F\6838\53D6\65B9\584A, \6C7A\5B9A\662F\5426\61C9\986F\793A\76EE\524D\7684\6838\53D6\65B9\584A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109918103996314085)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6838\53D6\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109280769323313585)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5FC5\9808\52FE\9078\7684\95DC\806F\7BE9\9078, \6C7A\5B9A\662F\5426\61C9\986F\793A\76EE\524D\7684\7BE9\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109280612096313585)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109280946254313585)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5FC5\9808\52FE\9078\7684\95DC\806F\6838\53D6\65B9\584A, \6C7A\5B9A\662F\5426\61C9\986F\793A\76EE\524D\7684\6838\53D6\65B9\584A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109280826424313585)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6838\53D6\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109832803027314023)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('$$$ DJP \76EE\524D\70BA\96B1\85CF\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109623759906313850)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884D\751F\7684\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110138236170314262)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\300C\4E92\52D5\5F0F\5831\8868\300D\7684\63CF\8FF0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109567334709313805)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8CC7\6599\6B04\7FA4\7D44\7684\63CF\8FF0. \6B64\63CF\8FF0\4E00\5F8B\4E0D\5C0D\4E00\822C\4F7F\7528\8005\986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109234887524313546)
,p_name=>'PE.PROPERTY.DESCRIPTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\63CF\8FF0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109234710843313546)
,p_name=>'PE.PROPERTY.DESCRIPTION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109773230505313978)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;/table&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109575514212313811)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\986F\793A\5728\5831\8868\8CC7\6599\5217\4E4B\5F8C\7684 HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109575423129313811)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109773034128313978)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;table&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109575139697313811)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\986F\793A\5728\5831\8868\8CC7\6599\5217\4E4B\524D\7684 HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109575054092313811)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109474837891313732)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\555F\7528\300C\8A73\7D30\6AA2\8996\300D. \82E5\9078\53D6<strong>\958B\555F</strong>, \5C31\6703\5728\4E92\52D5\5F0F\5831\8868\7684\300C\641C\5C0B\300D\5217\6216\4E92\52D5\5F0F\65B9\683C\7684\300C\6AA2\8996\300D\6309\9215\589E\52A0\300C\6AA2\8996\8A73\7D30\8CC7\8A0A\300D\5716\793A, \8B93\4F7F\7528\8005\53EF\4EE5\5B58\53D6\6B64\6AA2\8996.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109574987062313811)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\555F\7528\300C\8A73\7D30\6AA2\8996\300D. \82E5\9078\53D6<strong>\958B\555F</strong>, \5C31\6703\5728\4E92\52D5\5F0F\5831\8868\7684\300C\641C\5C0B\300D\5217\6216\4E92\52D5\5F0F\65B9\683C\7684\300C\6AA2\8996\300D\6309\9215\589E\52A0\300C\6AA2\8996\8A73\7D30\8CC7\8A0A\300D\5716\793A, \8B93\4F7F\7528\8005\53EF\4EE5\5B58\53D6\6B64\6AA2\8996.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109574874043313810)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110135737218314260)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;&ENAME_LABEL.:&lt;/td&gt;&lt;td&gt;&ENAME.&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;&JOB_LABEL.:&lt;/td&gt;&lt;td&gt;&JOB.&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110135851488314260)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\300C\8A73\7D30\6AA2\8996\300D\4E2D\8F38\5165\5831\8868\8CC7\6599\5217\4E3B\9AD4.</p>'),
unistr('<p>\53EF\4EE5\4F7F\7528\4E0B\5217\66FF\4EE3\5B57\4E32:'),
'<ul>',
unistr('<li><code>&&lt;COLUMN_NAME&gt;.</code> - \8CC7\6599\6B04\540D\7A31\66FF\4EE3\5B57\4E32.</li>'),
unistr('<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code> - \8CC7\6599\6B04\6A19\7C64\66FF\4EE3\5B57\4E32.</li>'),
unistr('<li><code>&APEX$ROW_ID.</code> - \8CC7\6599\5217\7684\8A18\9304 ID.</li>'),
unistr('<li><code>&APEX$ROW_INDEX.</code> - \8A18\9304\986F\793A\5E8F\865F.</li>'),
unistr('<li><code>&APEX$ROW_STATE_CLASSES.</code> - \8A18\9304\72C0\614B, \4F8B\5982 <code>is-inserted</code> \6216 <code>is-deleted</code>.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109773111695313978)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;#ENAME_LABEL#:&lt;/td&gt;&lt;td&gt;#ENAME#&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;#JOB_LABEL#:&lt;/td&gt;&lt;td&gt;#JOB#&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109575387787313811)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\300C\8A73\7D30\6AA2\8996\300D\4E2D\5831\8868\8CC7\6599\5217\7684\4E3B\9AD4. \53EF\4F7F\7528 <code>#COLUMN_NAME#</code> \66FF\4EE3\5B57\4E32\4F5C\70BA\8CC7\6599\6B04\540D\7A31\548C\8CC7\6599\6B04\6A19\7C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109575266227313811)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\6BCF\500B\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109234671245313546)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>&PRODUCT_NAME. \4E2D\652F\63F4\7684\5C0D\8A71\65B9\584A\53D6\6C7A\65BC\9801\9762\7684\4F7F\7528\8005\4ECB\9762.'),
unistr('\6709\4E00\7D44\5DF2\5BA3\544A\652F\63F4\7684\5C0D\8A71\65B9\584A\5C6C\6027: <em>\9AD8\5EA6\3001\5BEC\5EA6\8207\6700\5927\5BEC\5EA6</em>.'),
unistr('\82E5\8981\5B9A\7FA9\5C0D\8A71\65B9\584A\984D\5916\7684\5C6C\6027, \8ACB\5728\9017\865F\5340\9694\6E05\55AE\4E2D\8F38\5165\540D\7A31/\503C\7D44.</p>'),
unistr('<p>\5728\6B64\9805\76EE\4E2D\8F38\5165\7684\503C\6703\53D6\4EE3\9801\9762\6A23\677F\5C64\7D1A\4E4B\5C0D\8A71\65B9\584A\521D\59CB\5316\7A0B\5F0F\78BC\4E2D\7684\66FF\4EE3\5B57\4E32 <code>#DIALOG_ATTRIBUTES#</code>.</p>'),
unistr('<p>\5C0D\65BC\4F7F\7528\300C\684C\9762\300D\4F7F\7528\8005\4ECB\9762\7684\9801\9762, \6703\4F7F\7528 jQuery UI \5C0D\8A71\65B9\584A\5C0F\5DE5\5177.'),
unistr('\5C0D\65BC\4F7F\7528 jQuery Mobile \667A\6167\578B\624B\6A5F\4F7F\7528\8005\4ECB\9762\7684\9801\9762, \6703\4F7F\7528 jQuery Mobile \5C0D\8A71\65B9\584A\5C0F\5DE5\5177.</p>'),
unistr('<p>\4F8B\5982, \4F7F\7528\300C\684C\9762\300D\4F7F\7528\8005\4ECB\9762\7684\5C0D\8A71\65B9\584A\9801\9762\53EF\5B9A\7FA9\4E0B\5217\5C6C\6027: <code>resizable:true, draggable:true</code></p>'),
unistr('<p>\5982\9700\53EF\7528\5C6C\6027\7684\8A73\7D30\8CC7\8A0A, \8ACB\53C3\95B1 <a rel="noreferrer" target="_blank" href="http://api.jqueryui.com/dialog/">jQuery UI \5C0D\8A71\65B9\584A\5C0F\5DE5\5177\6587\4EF6</a> \8207 <a rel="noreferrer" target="_blank" href="http://api.jqueryui.com/dialog/">jQuery Mobile \5C0D\8A71\65B9\584A\5C0F\5DE5\5177\6587\4EF6</a>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109234519546313546)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109925103289314090)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\6B64\5C0D\8A71\65B9\584A\7531\5176\4ED6\5C0D\8A71\65B9\584A\958B\555F, \4E14\61C9\91CD\8907\4F7F\7528\76F8\540C\7684\5C0D\8A71\65B9\584A\8996\7A97, \8ACB\9078\53D6<strong>\958B\555F</strong>.'),
unistr('\4F8B\5982, \5982\679C\6B64\5C0D\8A71\65B9\584A\5C6C\65BC\591A\500B\9801\9762\5C0D\8A71\65B9\584A\7CBE\9748\7684\4E00\90E8\5206, \4E14\60A8\60F3\91CD\8907\4F7F\7528\7CBE\9748\6BCF\500B\6B65\9A5F\7684\5C0D\8A71\65B9\584A\8996\7A97.<p><p>'),
unistr('\5982\679C\6B64\5C0D\8A71\65B9\584A\7531\5176\4ED6\5C0D\8A71\65B9\584A\958B\555F, \4E14\61C9\5728\65B0\5C0D\8A71\65B9\584A\8996\7A97\4E2D\958B\555F, \8ACB\9078\53D6<strong>\95DC\9589</strong>. \4F8B\5982, \7576\6B64\5C0D\8A71\65B9\584A\70BA\5F37\5236\56DE\61C9, '),
unistr('\4E14\60A8\60F3\5728\7236\9805\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A\8996\7A97\4E2D\958B\555F.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109925042738314090)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\93C8\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109636420453313859)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\65B0\589E\81F3\6B64\5143\4EF6\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109636306696313859)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109324942133313618)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\5C0D\8A71\65B9\584A\7684\9AD8\5EA6 (\50CF\7D20), \4F8B\5982 <strong><em>500</em></strong>.'),
unistr('\8F38\5165\7684\503C\5C07\6703\53D6\4EE3\9801\9762\6A23\677F\4E4B\5C0D\8A71\65B9\584A\521D\59CB\5316\7A0B\5F0F\78BC\4E2D\7684 <code>#DIALOG_HEIGHT#</code> \66FF\4EE3\5B57\4E32.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109324883220313618)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109234483160313546)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\5C0D\8A71\65B9\584A\7684\6700\5927\5BEC\5EA6 (\50CF\7D20).'),
unistr('\5728\6B64\9805\76EE\4E2D\8F38\5165\7684\503C\6703\53D6\4EE3\9801\9762\6A23\677F\4E4B\5C0D\8A71\65B9\584A\521D\59CB\5316\7A0B\5F0F\78BC\4E2D\7684\66FF\4EE3\5B57\4E32 <code>#DIALOG_MAX_WIDTH#</code>.</p>'),
unistr('<p>\5C0D\65BC\4F7F\7528 jQuery Mobile \667A\6167\578B\624B\6A5F\4F7F\7528\8005\4ECB\9762\7684\9801\9762, \6700\5927\5BEC\5EA6\70BA <strong><em>500</em></strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109234340868313546)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5927\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109616329093313845)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109369969855313652)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8ACB\9078\53D6\4E00\500B\4F9B\7528\65BC\5B9A\7FA9\6B64\9801\9762\4E4B\5916\89C0\548C\7248\9762\914D\7F6E\7684\5C0D\8A71\65B9\584A\6A23\677F.</p>'),
unistr('        <p>\5C0D\8A71\65B9\584A\6A23\677F\5B9A\7FA9\65BC\61C9\7528\7A0B\5F0F\4E3B\984C\4E2D.'),
unistr('        \5C0D\8A71\65B9\584A\9801\9762\5EFA\7ACB\4E4B\5F8C, \6B64\6A23\677F\5C31\6703\81EA\52D5\8A2D\70BA<em>\4E3B\984C\9810\8A2D\503C</em>, \5C07\6703\4F7F\7528\76EE\524D\4E3B\984C\4E2D\5B9A\7FA9\7684\9810\8A2D\9801\9762\6A23\677F\4F86\5448\73FE\9801\9762.'),
unistr('        \5728\6B64\8655\6240\505A\7684\9078\64C7\6703\8986\5BEB\9810\8A2D\5C0D\8A71\65B9\584A\6A23\677F.</p>'),
unistr('        <p>\300C\901A\7528\4E3B\984C\300D\63D0\4F9B\4E0B\5217\5C0D\8A71\65B9\584A\6A23\677F:'),
'          <dl>',
unistr('            <dt>\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A</dt>'),
unistr('              <dd>\9069\7528\65BC\591A\6578\7684\5C0D\8A71\65B9\584A\4F7F\7528\6848\4F8B.</dd>'),
unistr('            <dt>\7CBE\9748\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A</dt>'),
unistr('              <dd>\63D0\4F9B\7CBE\7C21\7684\4F7F\7528\8005\4ECB\9762, \9069\7528\65BC\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A\7CBE\9748\3001\8B66\793A\3001\901A\77E5\6216\5C0F\578B\8868\55AE.</dd>'),
'          </dl>',
unistr('          \53E6\8ACB\53C3\95B1: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109369817786313652)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\8A71\65B9\584A\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109234249673313546)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\5C0D\8A71\65B9\584A\7684\5BEC\5EA6 (\50CF\7D20\6216\767E\5206\6BD4).'),
unistr('\5728\6B64\9805\76EE\4E2D\8F38\5165\7684\503C\6703\53D6\4EE3\9801\9762\6A23\677F\4E4B\5C0D\8A71\65B9\584A\521D\59CB\5316\7A0B\5F0F\78BC\4E2D\7684\66FF\4EE3\5B57\4E32 <code>#DIALOG_WIDTH#</code>.</p>'),
unistr('<p>\5728\4F7F\7528\300C\684C\9762\300D\4F7F\7528\8005\4ECB\9762\7684\9801\9762\4E2D, \503C\7684\8A2D\5B9A\55AE\4F4D\70BA\50CF\7D20, \4F8B\5982 <strong><em>500</em></strong>.'),
unistr('\4E0D\904E, \5C0D\65BC\4F7F\7528 jQuery Mobile \667A\6167\578B\624B\6A5F\4F7F\7528\8005\4ECB\9762\7684\9801\9762, \503C\7684\8A2D\5B9A\55AE\4F4D\70BA\767E\5206\6BD4, \4F8B\5982 <strong><em>80%</em></strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109234165699313546)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109552208995313789)
,p_name=>'PE.PROPERTY.DIRECTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\53C3\6578\7684\65B9\5411.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109552300152313790)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.IN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109552543853313790)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.IN_OUT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165/\8F38\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109552400000313790)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.OUT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109552198040313789)
,p_name=>'PE.PROPERTY.DIRECTION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109598380937313828)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\4F7F\7528\6B64\8CC7\6599\6B04\4F86\6392\5E8F\5831\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109598232677313828)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109629936890313855)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\5728\884C\4E8B\66C6\5132\5B58\683C\4E2D\986F\793A\7684\55AE\4E00\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109629898556313855)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109245606222313554)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67D0\500B\9805\76EE\53EF\80FD\6709\4E00\500B\6307\5B9A\503C\6E05\55AE\5B9A\7FA9\4E2D\6240\6C92\6709\7684\968E\6BB5\4F5C\696D\72C0\614B\503C. \8ACB\9078\53D6\6B64\503C\6E05\55AE\662F\5426\986F\793A\6B64\984D\5916\7684\968E\6BB5\4F5C\696D\72C0\614B\503C. \5982\679C\9078\64C7\4E0D\986F\793A\6B64\984D\5916\7684\968E\6BB5\4F5C\696D\72C0\614B\503C, \4E14\503C\6E05\55AE\5B9A\7FA9\4E2D\6C92\6709\7B26\5408\7684\503C, \5247\503C\6E05\55AE\4E2D\7B2C\4E00\500B\503C\5C07\662F\9078\53D6\7684\503C\53CA\986F\793A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109245517910313554)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\984D\5916\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109245819275313554)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7528\65BC\6B64\9805\76EE\7684\503C\6E05\55AE\662F\5426\5728\6E05\55AE\9802\7AEF\986F\793A\7A7A\503C\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109245777079313554)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109288475872313591)
,p_name=>'PE.PROPERTY.DISPLAY_POINT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\986F\793A\6B64\5143\4EF6\7684\4F4D\7F6E. \4F4D\7F6E\662F\5F9E\9069\7576\9801\9762\6216\5340\57DF\6A23\677F\986F\793A\4F4D\7F6E\884D\751F\800C\4F86.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109288394584313591)
,p_name=>'PE.PROPERTY.DISPLAY_POINT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109943507455314103)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\6B64\52D5\4F5C\7684\986F\793A\9806\5E8F.'),
unistr('\9019\53EF\7528\4F86\8A55\4F30\986F\793A\689D\4EF6\4E26\4EE5\5B9A\7FA9\7684\9806\5E8F\5448\73FE\52D5\4F5C.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109475292416313732)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\8CC7\6599\6B04\7684\986F\793A\9806\5E8F. \9806\5E8F\8A2D\5B9A\503C\6C7A\5B9A\6B64\8CC7\6599\6B04\5728\5340\57DF\5167\76F8\5C0D\65BC\5176\4ED6\8CC7\6599\6B04\7684\986F\793A\4F4D\7F6E.</p>'),
unistr('<p>\6CE8\610F: \5982\679C\76F8\540C\5340\57DF\5167\7684\5169\500B\8CC7\6599\6B04\5177\6709\76F8\540C\7684\9806\5E8F\503C, \7576\61C9\7528\7A0B\5F0F\532F\51FA\4E26\532F\5165\5176\4ED6\74B0\5883 (\50CF\662F\6E2C\8A66\6216\751F\7522\74B0\5883) \6642, \53EF\80FD\6703\4EE5\4E0D\540C\9806\5E8F\986F\793A.'),
unistr('\82E5\8981\78BA\4FDD\4E00\81F4\6027, Oracle \5EFA\8B70\70BA\6BCF\500B\9805\76EE\6307\5B9A\552F\4E00\7684\5E8F\865F, \6216\81F3\5C11\70BA\76F8\540C\5340\57DF\5167\7684\9805\76EE\6307\5B9A\552F\4E00\7684\5E8F\865F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109567288294313805)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\8CC7\6599\6B04\7FA4\7D44\7684\986F\793A\9806\5E8F. \6B64\9806\5E8F\6C7A\5B9A\8CC7\6599\6B04\7FA4\7D44\5728\8A73\7D30\6AA2\8996\4E2D\7684\986F\793A\9806\5E8F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109901034850314072)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\5716\5C64\7684\986F\793A\9806\5E8F. \9806\5E8F\8A2D\5B9A\6C7A\5B9A\4E86\5730\5716\5716\5C64\5F7C\6B64\4E4B\9593\7684\986F\793A\9806\5E8F. \6578\5B57\8F03\5927\7684\5716\5C64\6703\986F\793A\5728\6578\5B57\8F03\5C0F\7684\5716\5C64\4E4B\4E0A.</p>'),
unistr('<p>\6CE8\610F: \5169\500B\5730\5716\5716\5C64\7684\9806\5E8F\503C\5982\679C\76F8\540C, \7576\61C9\7528\7A0B\5F0F\532F\51FA\4E26\532F\5165\5176\4ED6\74B0\5883 (\50CF\662F\6E2C\8A66\6216\751F\7522\74B0\5883) \5F8C, \53EF\80FD\6703\4EE5\4E0D\540C\9806\5E8F\986F\793A.'),
unistr('\82E5\8981\78BA\4FDD\4E00\81F4\6027, Oracle \5EFA\8B70\70BA\6BCF\500B\5716\5C64\6307\5B9A\552F\4E00\7684\5E8F\865F, \6216\81F3\5C11\70BA\76F8\540C\5730\5716\5340\57DF\5167\7684\5716\5C64\6307\5B9A\552F\4E00\7684\5E8F\865F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109264092666313568)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\9805\76EE\7684\986F\793A\9806\5E8F. \9806\5E8F\548C\5176\4ED6\7248\9762\914D\7F6E\8A2D\5B9A\503C\6C7A\5B9A\4E86\6B64\9805\76EE\5728\5340\57DF\5167\76F8\5C0D\65BC\5176\4ED6\9805\76EE\7684\986F\793A\4F4D\7F6E.</p>'),
unistr('<p>\6CE8\610F: \82E5\76F8\540C\5340\57DF\5167\4E4B\5169\500B\9805\76EE\7684\9806\5E8F\503C\76F8\540C, \7576\61C9\7528\7A0B\5F0F\532F\51FA\4E26\532F\5165\5176\4ED6\74B0\5883 (\50CF\662F\6E2C\8A66\6216\751F\7522\74B0\5883) \5F8C, \53EF\80FD\6703\4EE5\4E0D\540C\9806\5E8F\986F\793A. \82E5\8981\78BA\4FDD\4E00\81F4\6027, Oracle \5EFA\8B70\70BA\6BCF\500B\9805\76EE\6307\5B9A\552F\4E00\7684\5E8F\865F, \6216\81F3\5C11\70BA\76F8\540C\5340\57DF\5167\7684\9805\76EE\6307\5B9A\552F\4E00\7684\5E8F\865F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109263946999313568)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110085120493314203)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\7528\4F86\9650\5236\8AB0\80FD\5920\4E0B\8F09\7684\6388\6B0A\914D\7F6E.'),
unistr('		\82E5\8981\8B93\4E00\822C\4F7F\7528\8005\4E0B\8F09, \8A72\4F7F\7528\8005\7684\9019\500B\6388\6B0A\914D\7F6E\5FC5\9808\8A55\4F30\70BA TRUE.</p>'),
unistr('		<p>\6CE8\610F - \82E5\672A\63D0\4F9B\6388\6B0A\914D\7F6E, \6240\6709\4F7F\7528\8005\5747\53EF\4E0B\8F09.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110085075851314203)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109607754111313838)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A CSV \4E0B\8F09\6A94\6848\7684\540D\7A31. \5982\679C\672A\6307\5B9A\540D\7A31, \5C07\6703\4F7F\7528\5340\57DF\540D\7A31\5F8C\9762\52A0\4E0A .csv \526F\6A94\540D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109618849634313847)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A CSV \4E0B\8F09\6A94\6848\7684\540D\7A31. \5982\679C\672A\6307\5B9A\540D\7A31, \5C07\6703\4F7F\7528\5340\57DF\540D\7A31\5F8C\9762\52A0\4E0A .csv \526F\6A94\540D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109602856303313834)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4E0B\8F09\4E4B\6587\4EF6\7684\540D\7A31. \8ACB\52FF\6307\5B9A\526F\6A94\540D, \7CFB\7D71\6703\81EA\52D5\52A0\4E0A\526F\6A94\540D. \5982\679C\5C07\6B64\5C6C\6027\7559\767D, \5247\6703\4F7F\7528\5340\57DF\540D\7A31\4F5C\70BA\6A94\6848\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109602725032313834)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109570106727313807)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6AA2\67E5\4F7F\7528\8005\53EF\4F7F\7528\4F55\7A2E\4E0B\8F09\683C\5F0F\4F86\4E0B\8F09\76EE\524D\986F\793A\7684\8CC7\6599\6B04.</p>')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109770554194313976)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_language=>'zh-tw'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109770629066313976)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_language=>'zh-tw'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109770760444313976)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109845404115314032)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Excel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109570096323313807)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109605607125313837)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\547C\53EB CSV \4E0B\8F09\7684\9023\7D50\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109605507485313836)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109602069117313834)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\9801\9762\4E0A\7684\4E0B\8F09\9023\7D50\8981\4F7F\7528\7684\6587\5B57. \4E00\822C\4F7F\7528\8005\53EF\4EE5\4F7F\7528\6B64\9023\7D50\4F86\4E0B\8F09 BLOB \5167\5BB9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109601915804313834)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109633433493313857)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\53EF\9650\5236\8AB0\6709\6B0A\900F\904E\62D6\653E\66F4\65B0\73FE\6709\884C\4E8B\66C6\4E8B\4EF6\7684\6388\6B0A\914D\7F6E.'),
unistr('\5982\679C\6307\5B9A\4E86\6388\6B0A\914D\7F6E, \6B64\6388\6B0A\914D\7F6E\5C31\5FC5\9808\8A55\4F30\70BA TRUE, \7CFB\7D71\624D\80FD\8655\7406\62D6\653E\52D5\4F5C.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109633382056313857)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109792098182313992)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\81EA\8A02\8655\7406\4F5C\696D</dt>'),
'<dd><pre>',
'declare',
'    l_date_value        varchar2(32767) := apex_application.g_x01;',
'    l_primary_key_value varchar2(32767) := apex_application.g_x02;',
'begin',
'    update emp',
'       set hiredate = to_date(l_date_value, ''YYYYMMDD HH24MISS'')',
'     where rowid    = l_primary_key_value;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109633268136313857)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B9A\7FA9\62D6\653E\300C\884C\4E8B\66C6\300D\9805\76EE\6642\8981\57F7\884C\7684\8655\7406\4F5C\696D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109633175196313857)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109474116276313731)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8907\88FD\8A18\9304\6642, \662F\5426\61C9\8A72\5C07\8CC7\6599\6B04\9810\8A2D\70BA\73FE\6709\8CC7\6599\6B04\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109474018624313731)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\672C\73FE\6709\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109272028975313574)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\52FE\9078\652F\63F4\7684\8CC7\6599\64CD\63A7\8A9E\8A00 (DML) \4F5C\696D. \6B64\8655\7406\4F5C\696D\6703\6839\64DA\6309\9215\7684<strong>\8CC7\6599\5EAB\52D5\4F5C</strong>\5C6C\6027\57F7\884C DML \4F5C\696D\4EE5\9001\51FA\9801\9762. \5982\679C\672A\8A2D\5B9A\6B64\5C6C\6027, \4F5C\696D\5C07\7531\6309\9215\8981\6C42\503C\6C7A\5B9A, \8A72\503C\5C07\4F9D\64DA\6309\9215\540D\7A31\8A2D\5B9A, \5982\4E0B\6240\793A:</p>'),
'<ul>',
unistr('<li><strong>\65B0\589E\8CC7\6599\5217</strong>\7531\4EE5\4E0B\8981\6C42\503C\89F8\767C: INSERT\3001CREATE\3001CREATE_AGAIN\3001CREATEAGAIN</li>'),
unistr('<li><strong>\66F4\65B0\8CC7\6599\5217</strong>\7531\4EE5\4E0B\8981\6C42\503C\89F8\767C: SAVE\3001APPLY CHANGES\3001UPDATE\3001UPDATE ROW\3001CHANGE\3001APPLY\3001APPLY%CHANGES%\3001GET_NEXT%\3001GET_PREV%</li>'),
unistr('<li><strong>\522A\9664\8CC7\6599\5217</strong>\7531\4EE5\4E0B\8981\6C42\503C\89F8\767C: DELETE\3001REMOVE\3001DELETE ROW\3001DROP</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109458456082313720)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52FE\9078\6B64\4E92\52D5\5F0F\65B9\683C\5141\8A31\7684\8CC7\6599\64CD\63A7\4F5C\696D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109458712352313720)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.D.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109458580693313720)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.I.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109458621515313720)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.U.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109458334666313720)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\7684\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109458999447313720)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\4E00\500B\8CC7\6599\6B04, \5176\8CC7\6599\6B04\503C\6307\51FA\662F\5426\53EF\4EE5\66F4\65B0\548C (\6216) \522A\9664\8CC7\6599\5217. \5141\8A31\7684\503C\70BA:'),
'        <dl>',
'          <dt>U</dt>',
unistr('            <dd>\53EF\4EE5\66F4\65B0\8CC7\6599\5217</dd>'),
'          <dt>D</dt>',
unistr('            <dd>\53EF\4EE5\522A\9664\8CC7\6599\5217</dd>'),
'          <dt>UD</dt>',
unistr('            <dd>\53EF\4EE5\66F4\65B0\6216\522A\9664\8CC7\6599\5217</dd>'),
'        </dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109458849791313720)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\7684\8CC7\6599\5217\4F5C\696D\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109250609585313558)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6 HTML \8868\683C\5132\5B58\683C\5167\9805\76EE\7684\5C0D\9F4A\65B9\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109754228031313964)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\9593\4E0B\5074')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109754309881313964)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\9593\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109754486330313964)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\9593\4E0A\5074')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109754137742313964)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109754695890313964)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE6\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109754765740313964)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE6\5074\7F6E\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109754868702313964)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE6\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109754509834313964)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9760\5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109755026448313964)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53F3\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109755183953313965)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53F3\5074\7F6E\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109755203652313965)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53F3\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109754944057313964)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9760\53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109246581537313555)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\9F4A\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109251286581313558)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6587\5B57\5340\3001\5F80\8FD4\5207\63DB\3001\8907\9078\6E05\55AE, \4EE5\53CA\4EFB\4F55\652F\63F4\300C\542B\9AD8\5EA6\5C6C\6027\300D\5C6C\6027\7684 Plug-in \9805\76EE\985E\578B\7684\9AD8\5EA6 (\9069\7576\7684\8CC7\6599\5217\6578).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109251174332313558)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109636753750313860)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.UNIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109251021309313558)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4F7F\7528\8005\53EF\5728\6B64\9805\76EE\4E2D\9375\5165\7684\5B57\5143\6578\4E0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109250961780313558)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\5EA6\4E0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109636845903313860)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.UNIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\500B\5B57\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109251614704313559)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\986F\793A\5713\9215\7FA4\6216\4E00\7D44\6838\53D6\65B9\584A\500B\5225\9078\9805\7684 HTML \8868\683C\5132\5B58\683C, \8F38\5165\5176\4ED6\5C6C\6027 (\4EE5\7A7A\683C\5340\9694).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109251563071313559)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\9805 HTML \5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109252090655313559)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\91DD\5C0D\986F\793A\5713\9215\7FA4\7D44\6216\4E00\7D44\6838\53D6\65B9\584A\4E4B\500B\5225\9078\9805\7684 HTML \8868\683C\5132\5B58\683C, \8F38\5165\8981\5728\8A72 HTML \8868\683C\5132\5B58\683C\4E4B\5F8C\986F\793A\7684\5176\4ED6\5C6C\6027.'),
unistr('\60A8\53EF\4EE5\5305\542B HTML\3001JavaScript \548C\6377\5F91.</p>'),
unistr('<p>\60A8\53EF\4EE5\53C3\7167\4EE5\4E0B\66FF\4EE3\5B57\4E32:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>\53D6\5F97\8207\6B64\9801\9762\9805\76EE\76F8\95DC\7684 HTML \8868\55AE\5143\7D20\540D\7A31.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>\53D6\5F97\76EE\524D\9801\9762\9805\76EE\7684\540D\7A31.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109251922093313559)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C\7E8C\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109251863153313559)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\91DD\5C0D\986F\793A\5713\9215\7FA4\7D44\6216\4E00\7D44\6838\53D6\65B9\584A\4E4B\500B\5225\9078\9805\7684 HTML \8868\683C\5132\5B58\683C, \8F38\5165\8981\5728\8A72 HTML \8868\683C\5132\5B58\683C\4E4B\524D\986F\793A\7684\5176\4ED6\5C6C\6027.'),
unistr('\60A8\53EF\4EE5\5305\542B HTML\3001JavaScript \548C\6377\5F91.</p>'),
unistr('<p>\60A8\53EF\4EE5\53C3\7167\4EE5\4E0B\66FF\4EE3\5B57\4E32:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>\53D6\5F97\8207\6B64\9801\9762\9805\76EE\76F8\95DC\7684 HTML \8868\55AE\5143\7D20\540D\7A31.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>\53D6\5F97\76EE\524D\9801\9762\9805\76EE\7684\540D\7A31.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109251746973313559)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D\7F6E\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109251487279313559)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\672A\8F38\5165\9805\76EE\503C\6642\8981\5728\9805\76EE\4E2D\986F\793A\7684\63D0\793A\6587\5B57. \4E00\65E6\5728\9805\76EE\4E2D\8F38\5165\6587\5B57, \5373\79FB\9664\63D0\793A\6587\5B57.</p>'),
unistr('<p>\6B64\9810\7559\4F4D\7F6E\5C6C\6027\6703\6307\5B9A\7C21\77ED\7684\63D0\793A\4F86\63CF\8FF0\9801\9762\9805\76EE\7684\9810\671F\503C.'),
unistr('\6B64\985E\63D0\793A\53EF\7528\4F86\63D0\4F9B\7BC4\4F8B\503C\3001\9810\671F\683C\5F0F\7684\7BC4\4F8B\6216\662F\6307\793A (\4F8B\5982: \641C\5C0B\6A19\984C\3001\63CF\8FF0\8207\6A19\8A18).'),
unistr('\6B64\5C6C\6027\50C5\4F9B\8F14\52A9\529F\80FD\4F7F\7528, \4E0D\61C9\7528\4F86\53D6\4EE3\9069\7576\5B9A\7FA9\4E14\6709\610F\7FA9\7684\6A19\7C64.</p>'),
unistr('<p><strong>\6CE8\610F:</strong> \6B64\70BA HTML5 \529F\80FD, \53EA\9069\7528\65BC\65B0\7248\7684\700F\89BD\5668! \820A\7248\7684\700F\89BD\5668\4E0D\6703\986F\793A\6B64\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109251348514313558)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\9810\7559\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109250854677313558)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\986F\793A\6B64\9805\76EE\4F7F\7528\7684\8868\55AE\5143\7D20\5BEC\5EA6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109250777932313558)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109636658502313860)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.UNIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\500B\5B57\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109771629985313977)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@abc.com</code></li>',
'<li><code>&amp;MY_APP_EMAIL_FROM.</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109572989690313809)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\5F9E\6B64\5831\8868\50B3\9001\96FB\5B50\90F5\4EF6\6642, \8981\4F5C\70BA<em>\5BC4\4EF6\8005</em>\5730\5740\7684\6709\6548\96FB\5B50\90F5\4EF6\5730\5740. \91DD\5C0D\300C\96FB\5B50\90F5\4EF6\300D\985E\578B\7684\300C\4E0B\8F09\300D\548C\91DD\5C0D\300C\8A02\95B1\300D, \90FD\6703\5F9E\6B64\5831\8868\50B3\9001\96FB\5B50\90F5\4EF6.</p>'),
unistr('<p>\503C\53EF\4EE5\662F\5305\542B\6709\6548\96FB\5B50\90F5\4EF6\5730\5740\7684\6587\5B57\5B57\4E32, \6216\662F\4F7F\7528\66FF\4EE3\8A9E\6CD5\5728\61C9\7528\7A0B\5F0F\4E2D\5B9A\7FA9\7684\975C\614B\66FF\4EE3\53C3\7167.'),
unistr('\4E0D\5EFA\8B70\4F7F\7528\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE\66FF\4EE3\65B9\5F0F, \56E0\70BA\5B83\53EA\5C0D\96FB\5B50\90F5\4EF6\4E0B\8F09\6709\4F5C\7528, \800C\6703\5C0E\81F4\6240\6709\8A02\95B1\96FB\5B50\90F5\4EF6\5931\6557, \56E0\70BA\4E26\7121\6CD5\5728\6709\6548\7684\968E\6BB5\4F5C\696D\4E4B\5916\5B58\53D6\9019\4E9B\9805\76EE.'),
unistr('\8A02\95B1\662F\76F4\63A5\5F9E &PRODUCT_NAME. \5F15\64CE\50B3\9001, \800C\4E0D\662F\5F9E\4F7F\7528\8005\968E\6BB5\4F5C\696D\50B3\9001.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109572884496313809)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\5BC4\4EF6\8005\5730\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109484595154313739)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\4F7F\7528\6B64\8CC7\6599\6B04\63A7\5236\5206\6BB5\53CA\805A\7E3D.</p>'),
unistr('        <p>\6CE8\610F - \82E5\5141\8A31\9032\884C\9019\4E9B\4F5C\696D, \53EF\80FD\6703\5C0E\81F4\6548\80FD\554F\984C, \7279\5225\662F\5C0D\65BC\5927\578B\8CC7\6599\96C6\6216\672A\63D0\4F9B\9069\7576\8CC7\6599\6B04\7D22\5F15\6642.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109484439210313739)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63A7\5236\5206\6BB5/\805A\7E3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109462919863313723)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\4F7F\7528\5176\4E2D\4E00\7A2E\6307\5B9A\7684\4E0B\8F09\683C\5F0F\4F86\4E0B\8F09\5831\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109462829324313723)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109467002343313726)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\7BE9\9078\6B64\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109466952537313726)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109483701414313738)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\91DD\5C0D\6B64\4E92\52D5\5F0F\65B9\683C\4F7F\7528\5012\6EAF\67E5\8A62.</p>'),
unistr('<p>\5012\6EAF\67E5\8A62\904B\7528\300COracle \5012\6EAF\6280\8853\300D\548C\300C\8CC7\6599\5EAB\6642\9593\9EDE\5FA9\539F\300D\4F86\6AA2\8996\5B58\5728\65BC\5148\524D\6642\9593\9EDE\7684\8CC7\6599. \4F7F\7528\8005\53EA\80FD\67E5\8A62\6B64\8CC7\6599, \4E0D\80FD\5012\8F49\4EFB\4F55\8CC7\6599\8B8A\66F4. \9019\9805\6280\8853\904B\7528 RMAN \5099\4EFD, \56E0\6B64\4F7F\7528\8005\53EF\4EE5\9806\5229\57F7\884C\591A\4E45\4EE5\524D\6642\9593\9EDE\7684\5012\6EAF\67E5\8A62, \53D6\6C7A\65BC Oracle Database \5167\4E0A\6B21\5207\63DB\91CD\505A\65E5\8A8C\6A94\7684\6642\9593.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109483660134313738)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5012\6EAF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109484356214313739)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\96B1\85CF\6B64\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109484251139313739)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109463508323313723)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\96FB\5B50\90F5\4EF6\50B3\9001\5167\542B\9644\4EF6\5F62\5F0F\7684\5831\8868\4E0B\8F09.</p>'),
unistr('<p>\96FB\5B50\90F5\4EF6\50C5\9069\7528\65BC\7D93\904E\8A8D\8B49\7684\4F7F\7528\8005, \800C\4E14\57F7\884C\8655\7406\7BA1\7406\54E1\5FC5\9808\5728\300C&PRODUCT_NAME. \7BA1\7406\670D\52D9\300D\61C9\7528\7A0B\5F0F\5167\8A2D\5B9A SMTP.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109463424267313723)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EE5\96FB\5B50\90F5\4EF6\50B3\9001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109712562514313931)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\555F\7528\5831\8868\5217\5370\529F\80FD. \5982\679C\9078\53D6<strong>\958B\555F</strong>, \4F7F\7528\8005\5373\53EF\4E0B\8F09\591A\7A2E\4E0D\540C\683C\5F0F (PDF\3001Microsoft Word\3001Microsoft Excel \548C HTML) \7684\5831\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109712428105313931)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\555F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109462348070313723)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5C07\5176\76EE\524D\7684\5831\8868\5B9A\7FA9\5132\5B58\6210<em>\516C\7528</em>\5831\8868.</p>'),
unistr('		<p>\516C\7528\5831\8868\6703\986F\793A\5728\300C\5DE5\5177\5217\300D\7684\53EF\7528\5831\8868\9078\53D6\6E05\55AE\4E2D, \4E26\4E14\6240\6709\4F7F\7528\8005\90FD\53EF\4EE5\770B\898B.<p>'),
unistr('		<p>\6CE8\610F - \9019\500B\9078\9805\50C5\4F9B\5DF2\8A8D\8B49\7684\4F7F\7528\8005\4F7F\7528, \5982\679C\60A8\4E00\4F75\586B\5165<strong>\5132\5B58\516C\7528\5831\8868\6388\6B0A</strong>, \5247\6703\6709\9032\4E00\6B65\9650\5236.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109462264927313723)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\516C\7528\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109472107000313730)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\4F7F\7528\6B64\8CC7\6599\6B04\6392\5E8F.</p>'),
unistr('        <p>\6CE8\610F - \82E5\5141\8A31\9032\884C\6392\5E8F\4F5C\696D, \53EF\80FD\6703\5C0E\81F4\6548\80FD\554F\984C, \7279\5225\662F\5C0D\65BC\5927\578B\8CC7\6599\96C6\6216\672A\63D0\4F9B\9069\7576\8CC7\6599\6B04\7D22\5F15\6642.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109472050097313730)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109462757775313723)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5B9A\7FA9\6B64\5831\8868\7684\8A02\95B1\8A2D\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109462649192313723)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109259451619313564)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6B64\9805\76EE\5132\5B58\5728\968E\6BB5\4F5C\696D\72C0\614B\4E2D\6642\662F\5426\8981\52A0\5BC6.'),
unistr('\82E5\9805\76EE\5167\5BB9\5305\542B\6A5F\5BC6\8CC7\6599, \5247\7576\503C\5132\5B58\5728 &PRODUCT_NAME. \968E\6BB5\4F5C\696D\72C0\614B\7BA1\7406\8868\683C\4E2D\6642\61C9\4E88\4EE5\52A0\5BC6.'),
unistr('\5426\5247, \4EFB\4F55\53EA\8981\5177\6709 &PRODUCT_NAME. \63CF\8FF0\8CC7\6599\8868\683C\8B80\53D6\6B0A\9650\7684\4EBA\90FD\53EF\4EE5\64B0\5BEB\67E5\8A62\4F86\64F7\53D6\6B64\6A5F\5BC6\8CC7\6599.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109259353147313564)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5132\5B58\65BC\968E\6BB5\4F5C\696D\72C0\614B\4E2D\7684\503C\52A0\5BC6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109630983696313855)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\9031\884C\4E8B\66C6\4E0A\6240\986F\793A\7684\4E00\9031\6700\5F8C\4E00\5929.'),
unistr('\60A8\53EF\4EE5\4F7F\7528\6B64\5C6C\6027\7D50\5408<strong>\958B\59CB\65E5</strong>\4F86\9650\5236\6240\986F\793A\7684\4E00\9031\5929\6B21, \6216\662F\9078\53D6<strong>\958B\59CB\65E5</strong>\503C\7684\524D\4E00\5929\4F86\986F\793A\5168\90E8\4E03\5929.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109790249613313991)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109790335599313991)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\4E00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109790466735313991)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\4E8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109790500283313991)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\4E09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109790610940313991)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\56DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109790709712313992)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\4E94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109790822913313992)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\516D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109630861195313855)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109631576155313856)
,p_name=>'PE.PROPERTY.END_TIME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\4F5C\70BA\9031\548C\65E5\884C\4E8B\66C6\4E4B\986F\793A\7126\9EDE\7684\7D50\675F\5C0F\6642.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109631416161313856)
,p_name=>'PE.PROPERTY.END_TIME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109632859715313857)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E00\4E0B\300C\76EE\6A19\300D\4EE5\547C\53EB\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A. \60A8\53EF\4EE5\8F38\5165\884C\4E8B\66C6\5C07\547C\53EB\4EE5\6AA2\8996\73FE\6709\4E8B\4EF6\4E4B\8A73\7D30\8CC7\8A0A\7684\76EE\6A19\9023\7D50.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109632755688313857)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6\76EE\6A19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109233040734313545)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\61C9\7528\7A0B\5F0F\5167\767C\751F\932F\8AA4\6642, \8981\547C\53EB\7684 PL/SQL \51FD\6578\540D\7A31.'),
unistr('\60A8\53EF\4EE5\4F7F\7528\6B64\51FD\6578\4F86\8655\7406\5404\7A2E\932F\8AA4\4EE3\78BC, \5305\62EC\4F86\81EA Oracle Database \7684\932F\8AA4, \4E26\4F9D\7167\9700\6C42\5C07\9019\985E\932F\8AA4\8A18\9304\5728\60A8\5B9A\7FA9\7684\81EA\8A02\8868\683C\4E2D.'),
unistr('\51FD\6578\53EF\5305\542B\908F\8F2F\4EE5\4FBF\4FEE\6539\932F\8AA4\8A0A\606F\8207\986F\793A\4F4D\7F6E, \5C07 Oracle Database \932F\8AA4\8F49\63DB\70BA\4F7F\7528\8005\6613\65BC\7406\89E3\7684\8A0A\606F.'),
unistr('\4F8B\5982, \60A8\53EF\4EE5\5728 <code>DEMO_CUSTOMERS</code> \64F7\53D6\552F\4E00\7D22\5F15\9375\9055\898F, \4E26\5C07 <code>ORA-00001</code> \8A0A\606F\53D6\4EE3\70BA\6B64\6587\5B57:\300C\81EA\8A02\540D\7A31\300D\5FC5\9808\662F\552F\4E00\540D\7A31.'),
unistr('\5F9E\300C\5957\88DD\61C9\7528\7A0B\5F0F\300D\5B89\88DD\300C\7BC4\4F8B\8CC7\6599\5EAB\61C9\7528\7A0B\5F0F\300D\6703\5EFA\7ACB <code>SAMPLE_PKG</code> \5957\88DD\7A0B\5F0F, \5176\4E2D\5305\542B\4E86 <code>demo_error_handling</code> \51FD\6578.'),
unistr('\6B64\932F\8AA4\8655\7406\51FD\6578\7BC4\4F8B\5305\542B\8A73\76E1\7684\8A3B\89E3, \65B9\4FBF\60A8\4F5C\70BA\81EA\884C\5B9A\7FA9\51FD\6578\7684\57FA\790E.</p>'),
unistr('<p>\8F38\5165\7684\51FD\6578\540D\7A31\53EF\4EE5\53C3\7167\8CC7\6599\5EAB\4E2D\7684\5957\88DD\7A0B\5F0F\51FD\6578\6216\7368\7ACB\51FD\6578. \4F8B\5982:'),
'<pre>',
'log_apex_error',
'</pre>',
'</p>',
unistr('<p>\7576\53C3\7167\8CC7\6599\5EAB PL/SQL \5957\88DD\7A0B\5F0F\6216\7368\7ACB\51FD\6578\6642, \60A8\53EF\4EE5\4F7F\7528 <code>#OWNER#</code> \66FF\4EE3\5B57\4E32\4F86\53C3\7167\76EE\524D\61C9\7528\7A0B\5F0F\7684\5256\6790\7DB1\8981. \4F8B\5982:'),
'<pre>#OWNER#.log_apex_error</pre>',
'</p>',
unistr('<p>\82E5\5728\9801\9762\6307\5B9A\932F\8AA4\8655\7406\51FD\6578, \8A72\9801\9762\5C07\4F7F\7528\6B64\51FD\6578, \800C\975E\6309\7167\6B64\61C9\7528\7A0B\5F0F\5C64\7D1A\7684\8A2D\5B9A.</p>'),
unistr('<p>\300C\932F\8AA4\8655\7406\51FD\6578\300D\5FC5\9808\5BE6\884C\4E0B\5217\4ECB\9762:'),
'<pre>',
'function &lt;name of function> (',
'    p_error in apex_error.t_error )',
'    return apex_error.t_error_result',
'</pre>',
'</p>',
unistr('<p>\8ACB\53C3\95B1 API Reference \624B\518A, \77AD\89E3\5957\88DD\7A0B\5F0F <code>apex_error</code> \7684\63CF\8FF0.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109242697651313552)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\8655\7406\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109949204543314107)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.APP_COMPUTATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\904B\7B97\5931\6557\6642\6240\8981\986F\793A\7684\932F\8AA4\8A0A\606F.'),
unistr('    \4F7F\7528 <code>#SQLERRM#</code> \4F5C\70BA\904B\7B97\5931\6557\6240\7522\751F\4E4B SQL \932F\8AA4\8A0A\606F\7684\66FF\4EE3\5B57\4E32.</p>'),
unistr('    <p>\904B\7B97\539F\672C\61C9\8A72\4E00\5F8B\6210\529F, \53EA\6709\56E0\70BA\672A\9810\671F\7684\932F\8AA4\624D\6703\5931\6557.'),
unistr('    \4E0D\5EFA\8B70\5BE6\884C\7D93\5E38\5931\6557\4E14\5229\7528\6B64\932F\8AA4\8A0A\606F\4F5C\70BA\5047\9A57\8B49\7684\904B\7B97.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109270886197313573)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_COMPUTATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\904B\7B97\5931\6557\6642\6240\8981\986F\793A\7684\932F\8AA4\8A0A\606F.'),
unistr('    \4F7F\7528 <code>#SQLERRM#</code> \4F5C\70BA\904B\7B97\5931\6557\6240\7522\751F\4E4B SQL \932F\8AA4\8A0A\606F\7684\66FF\4EE3\5B57\4E32.</p>'),
unistr('    <p>\904B\7B97\539F\672C\61C9\8A72\4E00\5F8B\6210\529F, \53EA\6709\56E0\70BA\672A\9810\671F\7684\932F\8AA4\624D\6703\5931\6557.'),
unistr('    \4E0D\5EFA\8B70\5BE6\884C\7D93\5E38\5931\6557\4E14\5229\7528\6B64\932F\8AA4\8A0A\606F\4F5C\70BA\5047\9A57\8B49\7684\904B\7B97.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109584409703313817)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\8655\7406\4F5C\696D\7684\932F\8AA4\8A0A\606F.'),
unistr('\82E5\767C\751F\7121\6CD5\8655\7406\7684\7570\5E38\72C0\6CC1, \5247\986F\793A\6B64\8A0A\606F. \5728\932F\8AA4\8655\7406\505C\6B62\5F8C, \6703\9032\884C\5012\56DE\4E26\986F\793A\932F\8AA4\8A0A\606F.</p>'),
unistr('<p>\6CE8\610F: \82E5\5DF2\5B9A\7FA9<strong>\767C\751F\932F\8AA4\7684\9801\9762</strong>\4F5C\70BA\932F\8AA4\986F\793A\4F4D\7F6E, \5247\9810\8A2D\6703\986F\793A SQL \932F\8AA4\8A0A\606F (sqlerrm), \56E0\6B64\4E0D\9700\8981\5728\60A8\7684\932F\8AA4\5167\5BB9\4E2D\52A0\4E0A <code>#SQLERRM#</code>.</p>'),
unistr('<p>\932F\8AA4\8A0A\606F\53EF\5305\62EC\4E0B\5217\66FF\4EE3\5B57\4E32:</p>'),
'<dl>',
'  <dt><code>#SQLERRM_TEXT#</code></dt>',
unistr('  <dd>\932F\8AA4\8A0A\606F\7684\5167\5BB9 (\4E0D\542B\932F\8AA4\7DE8\865F).</dd>'),
'  <dt><code>#SQLERRM#</code></dt>',
unistr('  <dd>\5B8C\6574\7684\932F\8AA4\8A0A\606F.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110143642851314266)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165 #LABEL# \503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109231485201313544)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8ACB\8F38\5165\9A57\8B49\672A\901A\904E\6642\6240\8981\986F\793A\7684\6587\5B57.</p>'),
unistr('<p>\60A8\53EF\4EE5\4F7F\7528 <code>#LABEL#</code> \4F5C\70BA\95DC\806F\9801\9762\9805\76EE\4E4B\6A19\7C64\7684\9810\7559\4F4D\7F6E, \6216\4F7F\7528 <code>#COLUMN_HEADER#</code> \4F5C\70BA\95DC\806F\4E4B\53EF\7DE8\8F2F\5340\57DF\8CC7\6599\6B04\7684\6A19\984C. \932F\8AA4\986F\793A\4F4D\7F6E\82E5\8A2D\70BA\300C\767C\751F\932F\8AA4\7684\9801\9762\300D, \5C31\4E0D\652F\63F4\9810\7559\4F4D\7F6E.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109231323083313544)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109342800616313632)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\6B64\9A57\8B49\7684\932F\8AA4\8A0A\606F\986F\793A\4F4D\7F6E.'),
unistr('\9A57\8B49\932F\8AA4\8A0A\606F\6703\986F\793A\5728\500B\5225\7684\932F\8AA4\9801\9762\4E2D, \6216\662F\5167\5D4C\5728\73FE\6709\7684\9801\9762\4E2D.'),
unistr('\5167\5D4C\932F\8AA4\8A0A\606F\6703\986F\793A\5728<em>\76F8\95DC\9805\76EE</em>\6A19\7C64\4E0B\65B9\548C (\6216)\300C\901A\77E5\300D\5340\57DF\4E2D, \60A8\53EF\4EE5\5728\9801\9762\6A23\677F\4E2D\5B9A\7FA9.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109763420106313971)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5D4C\65BC\901A\77E5\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109763386567313971)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5D4C\65BC\6B04\4F4D\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109763261461313971)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD_AND_NOTIFICATION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5D4C\65BC\6B04\4F4D\8207\901A\77E5\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109763523801313971)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767C\751F\932F\8AA4\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109342734662313632)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109259693436313565)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\82E5\8981\907F\514D\8DE8\7DB2\7AD9\547D\4EE4\6A94 (XSS) \653B\64CA, \8ACB\4E00\5F8B\5C07\6B64\5C6C\6027\8A2D\70BA<strong>\958B\555F</strong>.'),
unistr('\82E5\9700\8981\5448\73FE\5132\5B58\5728\9801\9762\9805\76EE\6216\503C\6E05\55AE\9805\76EE\4E2D\7684 HTML \6A19\8A18, \53EF\5C07\6B64\65D7\6A19\8A2D\70BA<strong>\95DC\9589</strong>.'),
unistr('\5728\6B64\72C0\6CC1\4E0B, \61C9\63A1\53D6\984D\5916\7684\63AA\65BD\4F86\78BA\4FDD\6B64\985E\6B04\4F4D\5728\8F38\5165\6642\53CA\5132\5B58\4E4B\524D, \90FD\6703\9069\7576\5730\9041\96E2\4F7F\7528\8005\7684\8F38\5165\5167\5BB9.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109259565053313564)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9041\96E2\7279\6B8A\5B57\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109231697644313544)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6388\6B0A\914D\7F6E\7B2C\4E00\6B21\5728\968E\6BB5\4F5C\696D\4E2D\4F7F\7528\6642\6703\9032\884C\8A55\4F30.'),
unistr('\9078\53D6\9069\7576\7684\8A55\4F30\9EDE, \4EE5\6C7A\5B9A\6307\5B9A\6388\6B0A\7684\5F8C\7E8C\4F7F\7528\662F\5F9E\8A18\61B6\9AD4\53D6\5F97\7D50\679C, \9084\662F\91CD\65B0\8A55\4F30\6388\6B0A\914D\7F6E.</p>'),
'#LOV_VALUES#',
unistr('<p>\9810\8A2D\503C<em>\6BCF\4E00\500B\968E\6BB5\4F5C\696D\4E00\6B21</em>\662F\6700\6709\6548\7387\7684\8A2D\5B9A.'),
unistr('\82E5\6388\6B0A\6AA2\67E5\53D6\6C7A\65BC\8B8A\66F4\7684\968E\6BB5\4F5C\696D\72C0\614B, \6216\662F\5176\4ED6\5728\6574\500B\968E\6BB5\4F5C\696D\4E2D\6703\52A0\4EE5\8B8A\52D5\7684\56E0\7D20, \5247\61C9\9078\64C7\5176\4ED6\503C.'),
unistr('\9078\9805<em>\6BCF\4E00\500B\5143\4EF6\4E00\6B21</em>\8207<em>\4E00\5F8B\8A55\4F30 (\4E0D\5FEB\53D6)</em> \63D0\4F9B\5176\4ED6\53EF\5B9A\7FA9\4EE5\4F9B\6388\6B0A\914D\7F6E\4F7F\7528\7684\53C3\6578.'),
unistr('\5728\6388\6B0A Plug-in \4E2D, \60A8\53EF\4EE5\4F7F\7528 <em>t_authorization</em> \53C3\6578\7684 <em>component.type</em>\3001<em>component.id</em> \8207 <em>component.name</em> \5C6C\6027.'),
unistr('\5C0D\65BC\5167\5EFA\7684<em>\5B58\5728 SQL \67E5\8A62</em>\8207<em>\51FD\6578\4E3B\9AD4</em>\914D\7F6E\985E\578B, \53EF\4F7F\7528\5C0D\7B49\7684\9023\7D50\8B8A\6578 <em>:APP_COMPONENT_TYPE</em>\3001<em>:APP_COMPONENT_ID</em> \8207 <em>:APP_COMPONENT_NAME</em>.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109739803363313953)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\4E00\500B\5143\4EF6\4E00\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109739969855313953)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\7167\6388\6B0A\914D\7F6E\7684\6BCF\500B\5143\4EF6\8A55\4F30\4E00\6B21, \4F46\662F\5C07\7D50\679C\5132\5B58\5728\968E\6BB5\4F5C\696D\4E2D. \5448\73FE\914D\7F6E\6216\8655\7406\914D\7F6E\7684\9032\4E00\6B65\8981\6C42\5247\4F7F\7528\8A18\61B6\9AD4\4E2D\7684\7D50\679C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109739645795313953)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\4E00\500B\9801\9762\6AA2\8996\4E00\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109739747415313953)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6BCF\500B\8655\7406\904E\7684\8981\6C42\90FD\8A55\4F30\4E00\6B21. \5982\679C\9801\9762\4E2D\6709\8D85\904E\4E00\500B\5143\4EF6\53C3\7167\6388\6B0A\914D\7F6E, \5C31\4F7F\7528\8A18\61B6\9AD4\4E2D\7684\7D50\679C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109739451091313952)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\4E00\500B\968E\6BB5\4F5C\696D\4E00\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109739509746313953)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\8A55\4F30\4E00\6B21, \7136\5F8C\4F7F\7528\8A18\61B6\9AD4\4E2D\7684\7D50\679C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109740097038313953)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\8A55\4F30 (\4E0D\5FEB\53D6)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109740108299313953)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\8A55\4F30\6388\6B0A\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109231507756313544)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A55\4F30\9EDE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109236632920313548)
,p_name=>'PE.PROPERTY.EVENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\89F8\767C\52D5\614B\52D5\4F5C\7684\4E8B\4EF6.'),
unistr('\5982\9700\7279\5B9A\4E8B\4EF6\7684\76F8\95DC\8CC7\8A0A, \8ACB\53C3\95B1<em>\61C9\7528\7A0B\5F0F\7522\751F\5668\4F7F\7528\624B\518A</em>\4E2D\7684\76F8\95DC\5C0F\7BC0.</p>'),
unistr('\4E8B\4EF6\5206\985E\6210\4E0B\5217\985E\578B:'),
'<dl>',
unistr('  <dt>\700F\89BD\5668\4E8B\4EF6</dt>'),
unistr('    <dd>\6A19\6E96\700F\89BD\5668\4E8B\4EF6.</dd>'),
unistr('  <dt>\67B6\69CB\4E8B\4EF6</dt>'),
unistr('    <dd>\67B6\69CB\4E8B\4EF6\5F9E Application Express \67B6\69CB\5167\89F8\767C.</dd>'),
unistr('  <dt>\5143\4EF6\4E8B\4EF6</dt>'),
unistr('    <dd>\60A8\7684\61C9\7528\7A0B\5F0F\6709\53EF\89F8\767C\81EA\8A02\4E8B\4EF6\7684\5143\4EF6\6642\624D\53EF\4EE5\4F7F\7528. \9019\4E9B\4E8B\4EF6\5F9E\60A8\61C9\7528\7A0B\5F0F\4E2D\5B89\88DD\7684\539F\751F\5143\4EF6\6216 Plug-in \5143\4EF6\89F8\767C.</dd>'),
unistr('  <dt>\81EA\8A02\4E8B\4EF6</dt>'),
unistr('    <dd>\4EFB\4F55\5F9E\60A8\7684\61C9\7528\7A0B\5F0F\89F8\767C\7684\81EA\8A02\4E8B\4EF6.</dd>'),
'</dl>',
unistr('<p>\6CE8\610F: \986F\793A\7684\4E8B\4EF6\6703\6839\64DA\9801\9762\4E4B\76EE\524D\7684\300C\4F7F\7528\8005\4ECB\9762\300D\985E\578B\800C\6709\6240\4E0D\540C.'),
unistr('\5982\679C\60A8\60F3\9078\53D6\5C0D\61C9\4E0D\540C\985E\578B\7684\4E8B\4EF6, \60A8\53EF\4EE5\9078\64C7\9078\53D6<strong>\986F\793A\4E0D\652F\63F4\7684\9805\76EE</strong>,'),
unistr('\4EE5\986F\793A\6240\6709\4E8B\4EF6 (\5305\62EC\672A\5C0D\61C9\76EE\524D\985E\578B\7684\4E8B\4EF6).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109236546634313547)
,p_name=>'PE.PROPERTY.EVENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109260898360313565)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\4E8B\4EF6\7684\7BC4\570D, \6C7A\5B9A\4F55\6642\8981\518D\6B21\6216\9023\7E8C\8A55\4F30\4E8B\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109750494584313961)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109750507547313961)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4E8B\4EF6\8655\7406\7A0B\5F0F\9023\7D50\81F3\76EE\524D\9801\9762\6709\6548\671F\5167\7684\89F8\767C\5143\7D20, \4F46\82E5\900F\904E\300C\91CD\65B0\6574\7406\90E8\5206\9801\9762 (PPR)\300D\66F4\65B0\89F8\767C\5143\7D20, \5C31\4E0D\518D\9023\7D50.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109750618013313961)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109750786128313961)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4E8B\4EF6\8655\7406\7A0B\5F0F\9023\7D50\81F3\76EE\524D\9801\9762\6709\6548\671F\5167\7684\89F8\767C\5143\7D20, \4E0D\8AD6\662F\5426\70BA\900F\904E\300C\91CD\65B0\6574\7406\90E8\5206\9801\9762 (PPR)\300D\91CD\65B0\5EFA\7ACB\7684\89F8\767C\5143\7D20.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109750814998313961)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109750974013313961)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\5C07\4E8B\4EF6\8655\7406\7A0B\5F0F\9023\7D50\81F3\89F8\767C\5143\7D20\4E00\6B21. \8981\5230\9801\9762\5B8C\5168\91CD\65B0\6574\7406\904E\5F8C, \624D\6703\518D\5EA6\89F8\767C\52D5\614B\52D5\4F5C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109260762114313565)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6\7BC4\570D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110068347499314191)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\5728\7FFB\8B6F\6642\6392\9664\6B64\6A19\984C. \6B64\5C6C\6027\53EA\6709\5728\5C07\61C9\7528\7A0B\5F0F\7FFB\8B6F\6210\53E6\4E00\7A2E\8A9E\8A00\6642\624D\6709\4F5C\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110068255667314191)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FFB\8B6F\6642\6392\9664\6B64\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109901567209314073)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\6B64\5716\5C64\689D\4EF6\7684\57F7\884C\6B21\6578.'),
unistr('\5982\679C\5728\689D\4EF6\4E2D\53C3\7167<em>\8CC7\6599\6B04</em>, \5C31\5FC5\9808\6307\5B9A<strong>\91DD\5C0D\6BCF\500B\8CC7\6599\5217</strong>, \624D\80FD\91DD\5C0D\5716\5C64\67E5\8A62\7684\6BCF\500B\8CC7\6599\5217\8A55\4F30\689D\4EF6.'),
unistr('\5426\5247, \8A2D\70BA<strong>\4E00\6B21</strong>, \53EA\5C0D\8A72\5340\57DF\9032\884C\4E00\6B21\9A57\8B49\8A55\4F30.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109343626129313632)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\6B64\53EF\7DE8\8F2F\5340\57DF\9A57\8B49\7684\57F7\884C\6B21\6578.'),
unistr('\5982\679C\60A8\5728\689D\4EF6\4E2D\53C3\7167<em>\8CC7\6599\6B04</em>, \5C31\5FC5\9808\6307\5B9A<strong>\91DD\5C0D\6BCF\500B\8CC7\6599\5217</strong>, \624D\80FD\91DD\5C0D\53EF\7DE8\8F2F\5340\57DF\7684\6BCF\500B\8CC7\6599\5217\9032\884C\689D\4EF6\8A55\4F30.'),
unistr('\5426\5247, \8ACB\8A2D\70BA<strong>\4E00\6B21</strong>, \53EA\70BA\8A72\5340\57DF\9032\884C\4E00\6B21\9A57\8B49\8A55\4F30.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109763952876313971)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.N.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109763842515313971)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.Y.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\6BCF\500B\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109343538544313632)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109474386149313732)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\6B64\552F\8B80\689D\4EF6\7684\57F7\884C\6642\6A5F.</p>'),
unistr('        <p>\5982\679C\60A8\5728\552F\8B80\689D\4EF6\4E2D\53C3\7167<em>\8CC7\6599\6B04</em>, \5C31\5FC5\9808\6307\5B9A<strong>\91DD\5C0D\6BCF\500B\8CC7\6599\5217</strong>, \624D\80FD\91DD\5C0D\300C\4E92\52D5\5F0F\65B9\683C\300D\4E2D\7684\6BCF\500B\8CC7\6599\5217\9032\884C\689D\4EF6\8A55\4F30.'),
unistr('		\5426\5247, \8ACB\8A2D\70BA<strong>\4E00\6B21</strong>, \53EA\70BA\8A72\5340\57DF\9032\884C\4E00\6B21\689D\4EF6\8A55\4F30.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109474526224313732)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109590371469313822)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\5C0D\6574\500B\5340\57DF\8A55\4F30\4E00\6B21\552F\8B80\689D\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109474495734313732)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\6BCF\500B\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109590292558313822)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\55AE\7368\8A55\4F30\6BCF\500B\8CC7\6599\5217\7684\552F\8B80\689D\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109474232037313731)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109343402742313632)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\6B64\53EF\7DE8\8F2F\5340\57DF\9A57\8B49\7684\57F7\884C\7BC4\570D.'),
unistr('\5982\679C\8981\91DD\5C0D\53EF\7DE8\8F2F\5340\57DF\4E2D\7684\65B0\8CC7\6599\5217\548C\66F4\65B0\904E\7684\8CC7\6599\5217\8A55\4F30\6B64\9A57\8B49, \8ACB\9078\53D6<strong>\91DD\5C0D\5DF2\5EFA\7ACB\548C\5DF2\4FEE\6539\7684\8CC7\6599\5217</strong>.'),
unistr('\5982\679C\8981\91DD\5C0D\6BCF\500B\9001\51FA\7684\8CC7\6599\5217\8A55\4F30\6B64\9A57\8B49, \8ACB\9078\53D6<strong>\6240\6709\9001\51FA\7684\8CC7\6599\5217</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109763757552313971)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.N.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\9001\51FA\7684\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109763679247313971)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.Y.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\5DF2\5EFA\7ACB\548C\5DF2\4FEE\6539\7684\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109343360054313632)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\7BC4\570D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109236272093313547)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6B64\5143\4EF6\7684\9806\5E8F. \6B64\9806\5E8F\5C07\6C7A\5B9A\57F7\884C\9806\5E8F.</p>'),
unistr('<p>\6CE8\610F: \5982\679C\5169\500B\5143\4EF6\5177\6709\76F8\540C\7684\9806\5E8F\503C, \7576\61C9\7528\7A0B\5F0F\532F\51FA\4E26\532F\5165\5176\4ED6\74B0\5883\6642, \57F7\884C\9806\5E8F\53EF\80FD\6703\4E0D\540C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109236106639313547)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110059868265314185)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\82E5\70BA ORDS REST \670D\52D9, \6703\7BE9\9664 "sal" \5C6C\6027\5C0F\65BC 3000 \7684\6240\6709\8A18\9304.</dt>'),
'<dd><pre>',
'{"sal": {"$lt": 3000}}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110059782439314185)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\8981\50B3\9001\81F3\5916\90E8 REST \670D\52D9\7684\7BE9\9078\8868\793A\5F0F. \6B64\8868\793A\5F0F\5C07\4F9D\539F\6A23\50B3\9001\81F3\9060\7AEF\4F3A\670D\5668. \8A9E\6CD5\8996 REST \8CC7\6599\4F86\6E90\7684\985E\578B\800C\5B9A. \4F8B\5982, Oracle REST Data Services (ORDS) \61C9\4F7F\7528 JSON \8A9E\6CD5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110059642834314185)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\90E8\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110060191141314186)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\82E5\70BA ORDS REST \670D\52D9, \5148\4F9D "job" \5C6C\6027\905E\589E, \518D\4F9D "ename" \905E\6E1B\6392\5E8F.</dt>'),
'<dd><pre>',
'{"job": "asc", "ename": "desc"}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110060054946314185)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\8981\50B3\9001\81F3\5916\90E8 REST \670D\52D9\7684\6392\5E8F\4F9D\64DA\8868\793A\5F0F. \6B64\8868\793A\5F0F\5C07\4F9D\539F\6A23\50B3\9001\81F3\9060\7AEF\4F3A\670D\5668. \8A9E\6CD5\8996 REST \8CC7\6599\4F86\6E90\7684\985E\578B\800C\5B9A. \4F8B\5982, Oracle REST Data Services (ORDS) \61C9\4F7F\7528 JSON \8A9E\6CD5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110059938027314185)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\90E8\6392\5E8F\4F9D\64DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109607946873313838)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\70BA\6B64\5831\8868\555F\7528\5916\90E8\5F8C\8655\7406.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109607852482313838)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109607694370313838)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4E00\822C\4F7F\7528\8005\6309\4E00\4E0B\5373\53EF\547C\53EB\5916\90E8\8655\7406\5F15\64CE\7684\9023\7D50\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109607565849313838)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109607420526313838)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7528\4F86\9032\884C\6B64\5831\8868\4E4B\5F8C\8655\7406\7684\4F3A\670D\5668 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109607388199313838)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109917416394314084)
,p_name=>'PE.PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\6838\53D6\65B9\584A\95DC\806F\7684\9762\5411\7FA4\7D44.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109917358327314084)
,p_name=>'PE.PROPERTY.FACET_GROUP.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9762\5411\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109845838964314032)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\503C\6E05\55AE\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109846542788314033)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\7570\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109846661518314033)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE\662F\4EE5\7528\9014\70BA\9078\53D6\76F8\7570\8CC7\6599\6B04\503C\7684\81EA\52D5\7522\751F\67E5\8A62\70BA\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109972799132314124)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684\51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109972878022314124)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\52D5\614B\300D\503C\6E05\55AE\662F\4EE5\60A8\8F38\5165\4E4B\300C\51FD\6578\4E3B\9AD4\300D\6240\50B3\56DE\7684\300CSQL \67E5\8A62\300D\70BA\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109845972353314032)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5171\7528\7684\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109846096973314033)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE\662F\4EE5\300C\5171\7528\7684\5143\4EF6\300D\4E2D\5B9A\7FA9\7684\9810\5148\5B9A\7FA9\503C\6E05\55AE\70BA\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109846144225314033)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109846261977314033)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\52D5\614B\300D\503C\6E05\55AE\662F\4EE5\60A8\8F38\5165\7684\300CSQL \67E5\8A62\300D\70BA\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109846317785314033)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109846447121314033)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\975C\614B\300D\503C\6E05\55AE\662F\4EE5\60A8\8F38\5165\7684\6587\5B57\503C\70BA\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109845755287314032)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109690774193313912)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6307\5B9A\9762\5411\662F\5426\53EF\96B1\85CF.  \82E5\8A2D\70BA<strong>\958B\555F</strong>, \9762\5411\5DE6\908A\6703\986F\793A\4E00\500B\5207\63DB\958B\95DC, \7528\4EE5\96B1\85CF/\986F\793A\5176\6E05\55AE\9805\76EE. \82E5\8A2D\70BA<strong>\95DC\9589</strong>, \5247\6703\4E00\5F8B\986F\793A\9762\5411\8207\5176\6E05\55AE\9805\76EE.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109690649252313911)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\96B1\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110109484071314240)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6307\5B9A\662F\5426\8981\8A08\7B97\9762\5411\6216\7BE9\9078\7684\6E05\55AE\9805\76EE\6578. \4F7F\7528\6B64\9078\9805\6703\5F71\97FF\6548\80FD.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110109315510314240)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A08\7B97\8A08\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109917646656314084)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5982\4F55\7D50\5408\6B64\7FA4\7D44\5167\7684\7BE9\9078\689D\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109917902492314084)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('AND (\4EA4\96C6)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109918082150314085)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4F7F\7528 "AND" \7D50\5408\7BE9\9078\689D\4EF6; \56E0\6B64\7D50\679C\6703\662F\6240\6709\500B\5225\7BE9\9078\689D\4EF6\7684\4EA4\96C6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109917799317314084)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('OR (\806F\96C6)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109917841479314084)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4F7F\7528 "OR" \7D50\5408\7BE9\9078\689D\4EF6; \56E0\6B64\7D50\679C\6703\662F\500B\5225\7BE9\9078\689D\4EF6\7684\806F\96C6\7D44\5408.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109917584842314084)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\5408\7BE9\9078\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109690111940313911)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6307\5B9A\662F\5426\8981\5141\8A31\5F9E\5C6C\7AEF\7BE9\9078\9762\5411\6216\7BE9\9078\7684\6E05\55AE\9805\76EE.  \82E5\8A2D\70BA<strong>\958B\555F</strong>, \641C\5C0B\6B04\4F4D\6703\5448\73FE\5728\6E05\55AE\9805\76EE\4E0A\65B9, \8B93\4E00\822C\4F7F\7528\8005\80FD\5920\7BE9\9078\6E05\55AE.</p>')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109690036257313910)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109918692935314085)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6307\5B9A\662F\5426\4E00\958B\59CB\5C31\986F\793A\5716\8868. \53EA\5728\300C\591A\9762\5411\641C\5C0B\300D\7684\5340\57DF\7279\6027\300C\986F\793A\5716\8868\300D\8A2D\70BA\300C\9078\53D6\5668\300D\6642\624D\80FD\5957\7528\6B64\7279\6027. \6B64\7279\6027\7684\8B8A\66F4\53EF\80FD\4E0D\6703\7ACB\5373\986F\73FE, \56E0\70BA\700F\89BD\5668\968E\6BB5\4F5C\696D\6703\4FDD\7559\4F7F\7528\8005\986F\793A\7684\4E00\7D44\5716\8868. \82E5\8981\67E5\770B\8B8A\66F4\6B64\7279\6027\7684\6548\679C, \8ACB\4F7F\7528\9023\7D50\300C\91CD\8A2D\5340\57DF\300D\5FEB\53D6\63A7\5236\9078\9805 (\4F8B\5982\4F7F\7528\7CBE\9748\7522\751F\7684\300C\91CD\8A2D\300D\6309\9215) \91CD\8A2D\5831\8868.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109918563231314085)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\958B\59CB\986F\793A\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109690914827313912)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6307\5B9A\4E00\958B\59CB\662F\5426\61C9\4EE5\96B1\85CF\72C0\614B\5448\73FE\9762\5411. \6B64\7279\6027\7684\8B8A\66F4\53EF\80FD\7121\6CD5\7ACB\5373\986F\73FE, \56E0\70BA\700F\89BD\5668\968E\6BB5\4F5C\696D\6703\6301\7E8C\4FDD\6301\5C55\958B\72C0\614B. \82E5\8981\67E5\770B\8B8A\66F4\6B64\7279\6027\7684\6548\679C, \8ACB\4F7F\7528\9023\7D50\300C\91CD\8A2D\5340\57DF\300D\5FEB\53D6\63A7\5236\9078\9805 (\4F8B\5982\4F7F\7528\7CBE\9748\7522\751F\7684\300C\91CD\8A2D\300D\6309\9215) \91CD\8A2D\5831\8868.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109690801367313912)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\958B\59CB\96B1\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109923587807314089)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6C7A\5B9A\9810\8A2D\662F\5426\986F\793A\9762\5411. \6B64\7279\6027\7684\8B8A\66F4\53EF\80FD\7121\6CD5\7ACB\5373\986F\73FE, \56E0\70BA\700F\89BD\5668\968E\6BB5\4F5C\696D\6703\7DAD\6301\986F\793A\72C0\614B. \82E5\8981\67E5\770B\8B8A\66F4\6B64\7279\6027\7684\6548\679C, \8ACB\4F7F\7528\9023\7D50\300C\91CD\8A2D\5340\57DF\300D\5FEB\53D6\63A7\5236\9078\9805 (\4F8B\5982\4F7F\7528\7CBE\9748\7522\751F\7684\300C\91CD\8A2D\300D\6309\9215) \91CD\8A2D\5831\8868.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109923417948314088)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\958B\59CB\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109691145461313912)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\9762\5411\7684\6700\5927\9AD8\5EA6 (\50CF\7D20).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109691007297313912)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5927\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109691251708313912)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.UNIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109033412576313396)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7BE9\9078\6642\5982\4F55\7D50\5408\500B\5225\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109033714898313396)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('AND (\4EA4\96C6)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109033854293313396)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4F7F\7528 "AND" \7D50\5408\503C; \56E0\6B64\7D50\679C\6703\662F\6240\6709\500B\5225\503C\7684\4EA4\96C6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109033511344313396)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('OR (\806F\96C6)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109033642259313396)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4F7F\7528 "OR" \7D50\5408\503C; \56E0\6B64\7D50\679C\6703\662F\500B\5225\503C\7684\806F\96C6\7D44\5408.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109033321524313396)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078\689D\4EF6\7D44\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109033027761313396)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\4E00\822C\5B57\5143:</dt>'),
'<dd><pre>,</pre></dd>',
'<dd><pre>:</pre></dd>',
unistr('<dt>\63A7\5236\5B57\5143:</dt>'),
unistr('<dd>Tab \5B57\5143 (<em>ASCII: 9</em>) <pre>\005Ct</pre></dd>'),
unistr('<dd>\63DB\884C\5B57\5143 (<em>ASCII: 10</em>) <pre>\005Cn</pre></dd>'),
unistr('<dt>\5176\4ED6\5B57\5143:</dt>'),
unistr('<dd>\4F7F\7528 ''\005Cxxxx'' \683C\5F0F\7684 Unicode \7DE8\78BC\503C, \5176\4E2D ''xxxx'' \662F UCS-2 \7DE8\78BC\683C\5F0F\4E2D\5B57\5143\7684\5341\516D\9032\4F4D\503C.</dd>'),
unistr('<dd>\6A19\984C\958B\982D (<em>ASCII: 1</em>) <pre>\005C0001</pre></dd>'),
'<dd>"@"-Symbol (<em>ASCII: 64</em>) <pre>\0040</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109032940053313396)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6307\5B9A\5340\9694\503C\8207\503C\4E4B\9593\7684\5B57\5143. \8ACB\6CE8\610F, \4E0D\652F\63F4 <strong>"</strong> (\96D9\5F15\865F) \548C <strong>\005C</strong> (\53CD\659C\7DDA) \5B57\5143\4F5C\70BA\300C\503C\5206\9694\7B26\865F\300D, \4E5F\4E0D\652F\63F4\4F7F\7528 <strong>\005Cxxxx</strong> \683C\5F0F.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109032839610313395)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\9694\7B26\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109033212646313396)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TRIM_SPACE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\662F\5426\79FB\9664\5206\5272\5F8C\500B\5225\503C\7684\524D\5C0E\8207\5C3E\96A8\7A7A\767D\5B57\5143.</p>'),
'<pre>',
'APEX:SQL:Spatial :Oracle TEXT: Data Warehouse',
'APEX :SQL:Data Warehouse',
'</pre>',
'<dl>',
unistr('<dt>\82E5<em>\505C\7528</em>\79FB\9664\7A7A\767D\5B57\5143, \4E0B\5217\500B\5225\503C\7684\8A08\7B97\65B9\5F0F\70BA:</dt>'),
'<dd><pre>',
'"APEX":            1',
'"APEX ":           1',
'"SQL":             2',
'"Spatial":         1',
'"Oracle TEXT":     1',
'"Data Warehouse":  1',
'" Data Warehouse": 1',
'</pre></dd>',
unistr('<dt>\82E5<em>\555F\7528</em>\79FB\9664\7A7A\767D\5B57\5143, \4E0B\5217\500B\5225\503C\7684\8A08\7B97\65B9\5F0F\70BA:</dt>'),
'<dd><pre>',
'"APEX":            2',
'"SQL":             2',
'"Spatial":         1',
'"Oracle TEXT":     1',
'"Data Warehouse":  2',
'</pre></dd>',
unistr('<p>\8ACB\6CE8\610F, \79FB\9664\7A7A\767D\5B57\5143\53EF\80FD\6703\56B4\91CD\5F71\97FF\5230\67E5\8A62\6548\80FD. \91DD\5C0D\8F03\5927\578B\7684\8CC7\6599\96C6, \8ACB\8003\616E\6539\7528\8CC7\6599\6E05\9664.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109033185055313396)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TRIM_SPACE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664\7A7A\767D\5B57\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109034188599313396)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109034292092313396)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\4E0D\5305\542B\591A\500B\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109282666329313586)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109282748210313586)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\4E0D\5305\542B\591A\500B\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109032334437313395)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6C7A\5B9A\300C\4F86\6E90\8CC7\6599\6B04\300D\662F\5426\5305\542B\591A\500B\503C, \4EE5\53CA\9019\4E9B\503C\7684\7DE8\78BC\65B9\5F0F.</p><p><em>\552F\6709 Oracle 12.2 \6216\66F4\65B0\7248\672C\7684\8CC7\6599\5EAB\624D\652F\63F4\591A\91CD\503C\9762\5411\6216\7BE9\9078\689D\4EF6. \82E5\5728 12.1 \8CC7\6599\5EAB\4E2D\5B9A\7FA9\591A\91CD\503C\9762\5411\6216\7BE9\9078\689D\4EF6, &PRODUCT_NAME. \5C07\6703\767C\51FA\7A0B\5F0F\5BE6\969B\57F7\884C\932F\8AA4.</em></p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109032645812313395)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.JSON_ARRAY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JSON \9663\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109032707706313395)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.JSON_ARRAY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\300C\4F86\6E90\300D\8CC7\6599\6B04\5305\542B\7D14\91CF\503C\7684 JSON \9663\5217. \5982\679C\6B64\8CC7\6599\6B04\5305\542B\7121\6548\7684 JSON \8A9E\6CD5, &PRODUCT_NAME. \5C07\6703\767C\51FA\932F\8AA4\8A0A\606F.</p><pre>["APEX", "SQL", "PL/SQL"]</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109032463596313395)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.SEPARATED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\9694\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109032501368313395)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.SEPARATED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8CC7\6599\6B04\5305\542B\5340\9694\5F62\5F0F\7684\503C\6E05\55AE.</p><pre>APEX,SQL,PL/SQL</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109032285037313395)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109918473945314085)
,p_name=>'PE.PROPERTY.FC_SHOW_CHART.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6307\5B9A\662F\5426\8981\5728\9762\5411\65C1\986F\793A\6309\9215, \4EE5\5141\8A31\4F7F\7528\8005\986F\793A\9762\5411\6E05\55AE\9805\76EE\8A08\6578\7684\5716\8868. \53EA\5728\300C\591A\9762\5411\641C\5C0B\300D\7684\5340\57DF\7279\6027\300C\986F\793A\5716\8868\300D\672A\8A2D\5B9A\70BA\300C\5426\300D\6642\624D\80FD\4F7F\7528\6B64\7279\6027.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109918376625314085)
,p_name=>'PE.PROPERTY.FC_SHOW_CHART.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109689957825313910)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6307\5B9A\662F\5426\8981\986F\793A\9762\5411\6216\7BE9\9078\7684\6E05\55AE\9805\76EE\51FA\73FE\6B21\6578.  \82E5\8A2D\70BA<strong>\958B\555F</strong>, \8A08\6578\6703\986F\793A\5728\6E05\55AE\9805\76EE\65C1\7684\62EC\5F27\4E2D. \4F8B\5982 KING (3).</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109689830875313910)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\8A08\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109690584115313911)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6307\5B9A\8981\986F\793A\7684\9762\5411\6E05\55AE\9805\76EE\6578\4E0A\9650.  \82E5\6307\5B9A\503C, \4E14\6E05\55AE\5305\542B\7684\9805\76EE\8D85\904E\6B64\9805\76EE\6578\6642, \6E05\55AE\7684\5E95\90E8\5C07\6703\6709\4E00\500B<strong>\986F\793A\66F4\591A\9805\76EE</strong>\9023\7D50. \82E5\672A\6307\5B9A\503C, \5C07\6703\986F\793A\6240\6709\6E05\55AE\9805\76EE.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109690482732313911)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\7684\9805\76EE\6578\4E0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109690347807313911)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6307\5B9A\662F\5426\8981\5728\9762\5411\6216\7BE9\9078\7684\6E05\55AE\4E2D\512A\5148\986F\793A\4EFB\4F55\9078\53D6\7684\6E05\55AE\9805\76EE. \8207\9762\5411\95DC\806F\7684\503C\6E05\55AE\82E5\5B9A\7FA9\7FA4\7D44, \5C31\4E0D\9069\7528\6B64\5C6C\6027.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109690292566313911)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5148\986F\793A\9078\53D6\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109319866020313614)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\6392\5E8F\9762\5411\6216\7BE9\9078\7684\6E05\55AE\9805\76EE. \82E5\8A2D\70BA<strong>\958B\555F</strong>, \5C07\6703\4F9D\8A08\6578\905E\6E1B\6392\5E8F\6E05\55AE\9805\76EE. \82E5\8A2D\70BA<strong>\95DC\9589</strong>, \5247\6703\6309\7167\503C\6E05\55AE\5B9A\7FA9\7684\9806\5E8F\986F\793A\6E05\55AE\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109319746792313614)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F9D\8A08\6578\905E\6E1B\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109923306445314088)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\986F\793A\6216\96B1\85CF\9762\5411. \53EA\8981\81F3\5C11\6709\4E00\500B\9762\5411\958B\555F\6B64\9078\9805, \4FBF\6703\65B0\589E\300C\66F4\591A\9762\5411\300D\6309\9215, \8B93\60A8\9078\64C7\8981\986F\793A\6216\96B1\85CF\7684\9762\5411. \672A\986F\793A\7684\9762\5411\6C92\6709\4EFB\4F55\53EF\8A08\7B97\7684\6548\80FD\6210\672C.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109923260635314088)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5207\63DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110109624481314240)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6307\5B9A\5982\4F55\91DD\5C0D\9762\5411\6216\7BE9\9078\986F\793A\96F6\8A08\6578\7684\6E05\55AE\9805\76EE.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110109933233314240)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110110084349314241)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\986F\793A\6240\6709\9805\76EE, \4F46\505C\7528\7121\6CD5\7BE9\9078\7684\9805\76EE.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110109751625314240)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110109800312314240)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\53EA\986F\793A\53EF\7BE9\9078\7684\6E05\55AE\9805\76EE.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110110100564314241)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5728\6700\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110110293969314241)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\986F\793A\6240\6709\9805\76EE, \4F46\505C\7528\7121\6CD5\7BE9\9078\7684\9805\76EE, \800C\4E14\5C07\5B83\5011\986F\793A\5728\9762\5411\6216\7BE9\9078\6E05\55AE\7684\6700\5F8C\9762. \95DC\806F\7684\300C\5171\7528\7684\503C\6E05\55AE\300D\82E5\4F7F\7528\7FA4\7D44\529F\80FD, \4FBF\6703\5FFD\7565\6B64\9078\9805.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110109583681314240)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96F6\8A08\6578\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109243086291313552)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5305\542B\6B64\6A19\7C64\4E4B HTML \8868\683C\5132\5B58\683C\4F7F\7528\7684\5176\4ED6\5C6C\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109242945626313552)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\5132\5B58\683C\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109598999616313828)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\5448\73FE\5217\8868\5316\8868\55AE\6B04\4F4D\6642\6240\8981\4F7F\7528\7684\6B04\4F4D\6A23\677F. \82E5\672A\9078\53D6\6A23\677F, \5C07\4F7F\7528\9810\8A2D\8F14\52A9\529F\80FD\76F8\5BB9\6A19\7C64\4F86\5448\73FE\6B04\4F4D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109619127327313847)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\5448\73FE\5217\8868\5316\8868\55AE\6B04\4F4D\6642\6240\8981\4F7F\7528\7684\6B04\4F4D\6A23\677F. \82E5\672A\9078\53D6\6A23\677F, \5C07\4F7F\7528\9810\8A2D\8F14\52A9\529F\80FD\76F8\5BB9\6A19\7C64\4F86\5448\73FE\6B04\4F4D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109242805608313552)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8ACB\9078\53D6\4E00\500B\4F9B\7528\65BC\5B9A\7FA9\6B64\9805\76EE\6A19\7C64\4E4B\5916\89C0\548C\7248\9762\914D\7F6E\7684\6A19\7C64\6A23\677F.</p>'),
unistr('        <p>\6A19\7C64\6A23\677F\5B9A\7FA9\65BC\61C9\7528\7A0B\5F0F\4E3B\984C\4E2D.'),
unistr('        \9805\76EE\5EFA\7ACB\4E4B\5F8C, \6B64\6A23\677F\5C31\6703\81EA\52D5\8A2D\70BA\76EE\524D\4E3B\984C\4E2D\5B9A\7FA9\7684\9810\8A2D\9805\76EE\6A23\677F.</p>'),
unistr('        <p>\8A31\591A\4E3B\984C\90FD\5305\542B\53EF\7528\65BC\986F\793A\5FC5\8981\3001\9078\64C7\6027\4EE5\53CA\96B1\85CF\4E4B\6A19\7C64\7684\6A19\7C64\6A23\677F.<br>'),
unistr('        \300C\901A\7528\4E3B\984C\300D\63D0\4F9B\4E0B\5217\6A19\7C64\6A23\677F:'),
'          <dl>',
unistr('            <dt>\96B1\85CF</dt>'),
unistr('              <dd>\756B\9762\4E2D\82E5\4E0D\61C9\8A72\986F\793A\6A19\7C64\6642, \8ACB\4F7F\7528\6B64\9805. \8ACB\6CE8\610F,\300C\8F14\52A9\6280\8853\300D\4ECD\7136\53EF\4EE5\6717\8B80\6A19\7C64.'),
unistr('              \82E5\70BA\6838\53D6\65B9\584A\9805\76EE\5247\6703\5FFD\7565\96B1\85CF, \56E0\70BA\6838\53D6\65B9\584A\5F8C\65B9\5FC5\9808\986F\793A\6A19\7C64.</dd>'),
unistr('            <dt>\9078\64C7\6027</dt>'),
unistr('              <dd>\82E5\70BA\9078\64C7\6027\8868\55AE\9805\76EE, \8ACB\4F7F\7528\6B64\9805. \6A19\7C64\5C07\986F\793A\65BC\9805\76EE\7684\65C1\908A.</dd>'),
unistr('            <dt>\9078\64C7\6027 - \4E0A\65B9</dt>'),
unistr('              <dd>\82E5\70BA\9078\64C7\6027\8868\55AE\9805\76EE, \8ACB\4F7F\7528\6B64\9805. \6A19\7C64\5C07\986F\793A\65BC\9805\76EE\4E0A\65B9.</dd>'),
unistr('            <dt>\9078\64C7\6027 - \6D6E\52D5</dt>'),
unistr('              <dd>\82E5\70BA\9078\64C7\6027\8868\55AE\9805\76EE, \8ACB\4F7F\7528\6B64\9805. \6A19\7C64\5C07\986F\793A\65BC\8F38\5165\9805\76EE\5167\90E8, \7576\8F38\5165\6B04\4F4D\5305\542B\503C\6642\6703\81EA\52D5\7E2E\6E1B.</dd>'),
unistr('            <dt>\5FC5\8981</dt>'),
unistr('              <dd>\6B64\6A19\7C64\6A23\677F\6703\5728\6A19\7C64\65C1\986F\793A\4E00\500B\7D05\8272\661F\865F, \9069\7528\65BC\9700\8981\4F7F\7528\8005\8F38\5165\7684\8868\55AE\9805\76EE.  \6A19\7C64\5C07\986F\793A\65BC\9805\76EE\7684\65C1\908A.</dd>'),
unistr('            <dt>\5FC5\8981 - \4E0A\65B9</dt>'),
unistr('              <dd>\6B64\6A19\7C64\6A23\677F\6703\5728\6A19\7C64\65C1\986F\793A\4E00\500B\7D05\8272\661F\865F, \9069\7528\65BC\9700\8981\4F7F\7528\8005\8F38\5165\7684\8868\55AE\9805\76EE.  \6A19\7C64\5C07\986F\793A\65BC\9805\76EE\4E0A\65B9. \60A8\53EF\4EE5\4F7F\7528\9805\76EE\6A23\677F\4F86\5B9A\7FA9\4E3B\984C\7684\4F7F\7528\8005\4ECB\9762\5C6C\6027, \4E26\5728\8A31\591A\9801\9762\9805\76EE\9593\5171\7528\8A72\5B9A\7FA9.</dd>'),
unistr('            <dt>\5FC5\8981 - \6D6E\52D5</dt>'),
unistr('              <dd>\6B64\6A19\7C64\6A23\677F\6703\5728\6A19\7C64\65C1\986F\793A\4E00\500B\7D05\8272\661F\865F, \9069\7528\65BC\9700\8981\4F7F\7528\8005\8F38\5165\7684\8868\55AE\9805\76EE.  \6A19\7C64\5C07\986F\793A\65BC\8F38\5165\9805\76EE\5167\90E8, \7576\8F38\5165\6B04\4F4D\5305\542B\503C\6642\6703\81EA\52D5\7E2E\6E1B. \60A8\53EF\4EE5\4F7F\7528\9805\76EE\6A23\677F\5C07\4F7F\7528\8005\4ECB\9762\5C6C\6027\5B9A\7FA9\6210\70BA\4E3B\984C\7684\4E00\90E8\5206, \4E26\5728\8A31\591A\9801\9762\9805\76EE\4E4B\9593\5171\7528\8A72\5B9A\7FA9.</dd>'),
'          </dl>',
unistr('          \53E6\8ACB\53C3\95B1: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109242728042313552)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110056007654314183)
,p_name=>'PE.PROPERTY.FILTER_DATA_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078\8CC7\6599\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109470072077313728)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\4E00\822C\4F7F\7528\8005\5728\8CC7\6599\6B04\7BE9\9078\4E2D\8F38\5165\6587\5B57\6642, \662F\5426\57F7\884C\5B8C\5168\76F8\7B26\7684\641C\5C0B.'),
unistr('      \5982\679C\8A2D\70BA<strong>\95DC\9589</strong>, \7BE9\9078\5C07\6703\57F7\884C\5305\542B\641C\5C0B, \800C\975E\7B49\65BC\641C\5C0B.</p>'),
unistr('      <p>\4F8B\5982, \540D\70BA TAGS \7684\8CC7\6599\6B04, \7B49\540C\65BC TAGS = ''<<value>>''. \5982\679C\300C\5B8C\5168\76F8\7B26\300D\8A2D\70BA<strong>\95DC\9589</strong>, \5247\7B49\540C\65BC TAGS LIKE ''%<<value>>%''. ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109469993616313728)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\5168\76F8\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109468493715313727)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6B64\8CC7\6599\6B04\662F\5426\4E00\5F8B\9700\8981\7BE9\9078.</p>'),
unistr('        <p>\6CE8\610F - \4E0D\8AD6\4E92\52D5\5F0F\65B9\683C\5C6C\6027\4E2D\7684<strong>\9700\8981\8F38\5165\7BE9\9078</strong>\9078\9805\70BA\4F55, \4E00\5F8B\9700\8981\6709\6B64\7279\5B9A\8CC7\6599\6B04\7684\7BE9\9078, \624D\6703\50B3\56DE\4EFB\4F55\8CC7\6599.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109468314584313727)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109468679005313727)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5728\4F7F\7528\8005\6309\4E00\4E0B\8CC7\6599\6B04\6A19\982D\6216\7BE9\9078\5C0D\8A71\65B9\584A\6642, \5982\4F55\884D\751F\7BE9\9078\7684\503C\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109468972523313728)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\540C\7684\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109469043482313728)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D VARCHAR2 \548C NUMBER \8CC7\6599\6B04\986F\793A\4E0D\540C\7684\8CC7\6599\6B04\503C. DATE \548C TIMESTAMP \8CC7\6599\6B04\6703\4F7F\7528\5167\5EFA\9810\5148\5B9A\7FA9\7684\65E5\671F\7BC4\570D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110055063353314182)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110055135654314182)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\884D\751F\81EA\503C\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109468789106313727)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109468899681313728)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\505C\7528\7BE9\9078\4E2D\6240\986F\793A\7684\4EFB\4F55\503C.'),
unistr('        \6B64\9078\9805\9069\7528\65BC\5927\578B\8CC7\6599\6B04 (\4E00\822C\5177\6709\8D85\904E 50 \500B\5B57\5143\7684\5927\90E8\5206\503C) \6216\6E05\55AE\6975\4E0D\9069\7528\65BC\9078\53D6\7279\5B9A\8A18\9304\6642.'),
unistr('        \76F8\53CD\5730, \4E00\822C\4F7F\7528\8005\53EF\4EE5\53EA\8F38\5165\5C40\90E8\503C, \7136\5F8C\6AA2\8996\7D50\679C.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109469744252313728)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109469857645313728)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\884D\751F\81EA\53EF\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109469329421313728)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5171\7528\7684\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109469499055313728)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\884D\751F\81EA\73FE\6709\503C\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109469166719313728)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109469232181313728)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\884D\751F\81EA SQL \67E5\8A62\5B9A\7FA9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109469594784313728)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109469678791313728)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\884D\751F\81EA\975C\614B\503C\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109468519052313727)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('LOV \985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109467278793313726)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\4E00\822C\4F7F\7528\8005\53EF\4EE5\7528\65BC\6B64\8CC7\6599\6B04\7684\7BE9\9078\904B\7B97\5B50.</p>'),
unistr('        <p>\6839\64DA\8CC7\6599\96C6\548C\8CC7\6599\6B04\7D22\5F15\5927\5C0F, \60A8\53EF\80FD\9078\64C7\505C\7528\7279\5B9A\7BE9\9078\904B\7B97\5B50\4EE5\907F\514D\4E00\822C\4F7F\7528\8005\7684\6548\80FD\554F\984C.'),
unistr('        \7279\5B9A\904B\7B97\5B50\53EF\80FD\6703\5C0E\81F4\5B8C\6574\8868\683C\6383\63CF, \800C\975E\4F7F\7528\8CC7\6599\6B04\7D22\5F15.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109638577953313861)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\542B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109638609559313861)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7BE9\9078\6703\50B3\56DE\5305\542B\7BE9\9078\503C\7684\8CC7\6599\6B04\503C\7D50\679C.'),
unistr('        &PRODUCT_NAME. \5C07\5728 where \5B50\53E5\4E2D\4F7F\7528 <code>column LIKE <strong>%</strong>filtervalue<strong>%</strong></code>.</p>'),
unistr('        <p>\6CE8\610F - \6B64\904B\7B97\5B50\5C07\5C0E\81F4\7121\6CD5\4F7F\7528\4EFB\4F55\7684\8CC7\6599\6B04\7D22\5F15, \56E0\800C\5C0E\81F4\9808\9032\884C\5B8C\6574\8868\683C\6383\63CF.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109467492712313726)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5340\5206\5927\5C0F\5BEB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109590093983313822)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7BE9\9078\6703\50B3\56DE\8CC7\6599\6B04\503C\7D50\679C, \800C\4E14\4E0D\8003\616E\8CC7\6599\6B04\503C\548C\7BE9\9078\503C\7684\5DEE\7570.'),
unistr('        &PRODUCT_NAME. \5C07\5728 where \5B50\53E5\4E2D\4F7F\7528 <code>UPPER(column) <em>operator</em> UPPER(filtervalue)</code>.</p>'),
unistr('        <p>\6CE8\610F - \82E5\540C\6642\5C0D\8CC7\6599\6B04\548C\7BE9\9078\503C\57F7\884C UPPER, \5C07\6703\7121\6CD5\4F7F\7528\4EFB\4F55\8CC7\6599\6B04\7D22\5F15, \4F46\4F7F\7528 UPPER(<em>column</em>) \4E4B\4EE5\51FD\6578\70BA\57FA\790E\7684\8CC7\6599\6B04\7D22\5F15\9664\5916.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109467303432313726)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\898F\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109590196788313822)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7BE9\9078\6703\6839\64DA\8F38\5165\7684\6B63\898F\8868\793A\5F0F\4F86\50B3\56DE\7D50\679C.</p>'),
unistr('        <p>\6CE8\610F - \4F7F\7528 REGEXP \904B\7B97\5B50\5341\5206\8907\96DC, \800C\4E14\4E00\822C\50C5\4F9B\9032\968E\4F7F\7528\8005\4F7F\7528. \9019\985E\904B\7B97\5B50\53EF\80FD\6703\5C0E\81F4\6975\5DEE\7684\6548\80FD.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109638758234313861)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\982D\70BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109638866479313861)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7BE9\9078\6703\50B3\56DE\4EE5\7BE9\9078\503C\70BA\958B\982D\7684\8CC7\6599\6B04\503C\7D50\679C.'),
unistr('        &PRODUCT_NAME. \5C07\5728 where \5B50\53E5\4E2D\4F7F\7528 <code>column LIKE filtervalue<strong>%</strong></code>.</p>'),
unistr('        <p>\6CE8\610F - \6B64\904B\7B97\5B50\53EF\4EE5\4F7F\7528\53EF\7528\7684\8CC7\6599\6B04\7D22\5F15. {\8ACB\6AA2\95B1<strong>\4E0D\5340\5206\5927\5C0F\5BEB</strong>\4EE5\77AD\89E3\4F8B\5916}.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109467135084313726)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6548\80FD\5F71\97FF\904B\7B97\5B50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109467642257313727)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\7528\4F86\5132\5B58\8CC7\6599\6B04\503C\5167\6587\5B57\7684\5927\5C0F\5BEB.</p>'),
unistr('        <p>\5982\679C\8CC7\6599\6B04\53EF\4EE5\6307\5B9A\70BA\4E00\5F8B\5927\5BEB (\4F8B\5982 <em>Username</em>) \6216\4E00\5F8B\5C0F\5BEB, \5247\53EF\80FD\6703\6539\5584\7BE9\9078\7D50\679C\7684\64F7\53D6\6548\80FD.'),
unistr('          \5982\679C\9078\53D6<strong>\5927\5BEB</strong>\6216<strong>\5C0F\5BEB</strong>, \5247\641C\5C0B\4E00\5F8B\6703\5728\57F7\884C\641C\5C0B\6642\5340\5206\5927\5C0F\5BEB.</p>'),
unistr('        <p>\6CE8\610F - \5982\679C\9078\53D6\300C\6DF7\5408\300D, \5247\4E00\822C\4F7F\7528\8005\53EF\4EE5\5728\300C\641C\5C0B\300D\548C\300C\7BE9\9078\300D\5C0D\8A71\65B9\584A\4E2D\6307\5B9A<strong>\6709\5927\5C0F\5BEB\4E4B\5225</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109467955275313727)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\5BEB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109468065638313727)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9069\7528\65BC\8CC7\6599\6B04\503C\4E00\5F8B\4EE5\5C0F\5BEB\5132\5B58\6642.'),
unistr('        &PRODUCT_NAME. \5C07\5728 where \5B50\53E5\4E2D\4F7F\7528 <code>column <em>operator</em> LOWER(filtervalue)</code>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109468147640313727)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DF7\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109468221647313727)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9069\7528\65BC\8CC7\6599\6B04\503C\4EE5\6DF7\5408\5927\5C0F\5BEB\65B9\5F0F\5132\5B58\6642. <strong>\4E0D\5340\5206\5927\5C0F\5BEB</strong>\904B\7B97\5B50\7684\8A2D\5B9A\5C07\6C7A\5B9A\4F7F\7528\7684 where \5B50\53E5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109467786021313727)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5927\5BEB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109467849678313727)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9069\7528\65BC\8CC7\6599\6B04\503C\4E00\5F8B\4EE5\5927\5BEB\5132\5B58\6642.'),
unistr('        &PRODUCT_NAME. \5C07\5728 where \5B50\53E5\4E2D\4F7F\7528 <code>column <em>operator</em> UPPER(filtervalue)</code>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109467591662313726)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\5927\5C0F\5BEB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109261651118313566)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\52D5\4F5C\662F\5426\65BC\521D\59CB\5316\6642\89F8\767C.</p>'),
unistr('        							<p>\521D\59CB\5316\7684\610F\7FA9\6703\8996\300C\52D5\614B\52D5\4F5C\300D\5B9A\7FA9\7684\65B9\5F0F\800C\6709\4E9B\5FAE\4E0D\540C. \5C0D\65BC\5B9A\7FA9\5728'),
unistr('        							\300C\4E92\52D5\5F0F\65B9\683C\300D\8CC7\6599\6B04\89F8\767C\7684\300C\52D5\614B\52D5\4F5C\300D, \9019\8868\793A\52D5\4F5C\662F\5426\5728\555F\7528\300C\4E92\52D5\5F0F\65B9\683C\300D'),
unistr('        							\8CC7\6599\5217\9032\884C\7DE8\8F2F\6642\89F8\767C. \5C0D\65BC\5176\4ED6\6240\6709\300C\52D5\614B\52D5\4F5C\300D, \9019\8868\793A\52D5\4F5C\662F\5426\5728'),
unistr('        							\9801\9762\8F09\5165\6642\89F8\767C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109261538273313566)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\521D\59CB\5316\6642\89F8\767C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109261497135313566)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\89F8\767C\6B64\52D5\4F5C, \9078\53D6 <strong>True</strong> (True \52D5\4F5C) \8868\793A\7B26\5408\89F8\767C\5143\7D20\689D\4EF6\6642\89F8\767C, \6216\9078\53D6 <strong>False</strong> (False \52D5\4F5C) \8868\793A\4E0D\7B26\5408\689D\4EF6\6642\89F8\767C.</p>'),
unistr('<p>\6CE8\610F: \82E5\672A\6307\5B9A\689D\4EF6, \53EA\6703\89F8\767C <strong>True</strong> \52D5\4F5C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109751183092313961)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.FALSE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\507D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109751035647313961)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.TRUE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\771F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109261386863313566)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6\7D50\679C\5982\4E0B\6642\89F8\767C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110135283522314260)
,p_name=>'PE.PROPERTY.FIXED_HEADER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\60A8\8981\5C07\5831\8868\7684\8CC7\6599\6B04\6A19\982D\56FA\5B9A\81F3<strong>\9801\9762</strong>\9802\7AEF\9084\662F<strong>\5340\57DF</strong>\9802\7AEF, \8B93\4F7F\7528\8005\5782\76F4\6372\52D5\5831\8868\6642\4ECD\7136\53EF\4EE5\770B\5230\8CC7\6599\6B04\6A19\982D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110136220023314261)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110136361032314261)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\56FA\5B9A\5831\8868\6A19\982D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110135493512314260)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110135666126314260)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5831\8868\6A19\982D\56FA\5B9A\81F3\9801\9762\7684\9802\7AEF. \4F7F\7528\8005\5782\76F4\6372\52D5\9801\9762\6642, \5831\8868\6A19\982D\5C07\6703\7DAD\6301\56FA\5B9A\5728\9801\9762\7684\9802\7AEF. \7576\5831\8868\662F\9801\9762\7684\4E3B\8981\5167\5BB9\6642, <strong>\9801\9762</strong>\5C64\7D1A\7684\56FA\5B9A\6A19\984C\76F8\7576\6709\7528. \7576\5340\57DF\5728\5C0D\8A71\65B9\584A\4E2D\6642, \4E0D\652F\63F4\6B64\8A2D\5B9A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110135344885314260)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110135581852314260)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5831\8868\6A19\982D\56FA\5B9A\81F3\76EE\524D\5340\57DF\7684\9802\7AEF. \4F7F\7528\8005\5728\5340\57DF\5167\5782\76F4\6372\52D5\6642, \5831\8868\6A19\982D\5C07\7E7C\7E8C\56FA\5B9A\5728\5340\57DF\7684\9802\7AEF. <strong>\5340\57DF</strong>\5C64\7D1A\7684\56FA\5B9A\6A19\984C\5C0D\65BC\5167\542B\591A\500B\5340\6216\7684\9801\9762 (\4F8B\5982\5100\8868\677F\9801\9762) \975E\5E38\5BE6\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110135158393314260)
,p_name=>'PE.PROPERTY.FIXED_HEADER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56FA\5B9A\81F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110136608219314261)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5831\8868\7684\9AD8\5EA6\4E0A\9650 (\50CF\7D20).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110136509885314261)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\9AD8\5EA6\4E0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110136722805314261)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.UNIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109644673985313865)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5831\8868\7684\56FA\5B9A\9AD8\5EA6 (\50CF\7D20).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109644520087313865)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56FA\5B9A\5831\8868\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109644793857313866)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.UNIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109461133579313722)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\986F\793A\8CC7\6599\5217\9AD8\5EA6\56FA\5B9A\7684\4E92\52D5\5F0F\65B9\683C.</p>'),
unistr('        <p>\82E5\8A2D\70BA<em>\662F</em>, \5C07\6703\5728\8CC7\6599\7D50\5C3E\986F\793A\7701\7565\7B26\865F (...), \4EE3\8868\8CC7\6599\6B04\7121\6CD5\986F\793A\6240\6709\8CC7\6599.'),
unistr('        \82E5\8A2D\70BA<em>\5426</em>, \5247\6703\8996\9700\8981\5C07\8CC7\6599\6298\70BA\591A\884C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109461062112313722)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56FA\5B9A\8CC7\6599\5217\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109330576161313623)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7DCA\63A5\5728\4E3B\9AD4\5167\5BB9\4E4B\5F8C (\4EA6\5373, \5340\57DF\6A23\677F\4E2D\7684 <code>#BODY#</code> \4E4B\5F8C) \986F\793A\7684\5340\57DF\8868\5C3E.'),
unistr('\60A8\53EF\4EE5\4F7F\7528 <code>#TIMING#</code> \66FF\4EE3\5B57\4E32\4E5F\53EF\4EE5\4F7F\7528\6377\5F91\4F86\986F\793A\5448\73FE\5340\57DF\6240\4F7F\7528\7684\6642\9593.</p>'),
unistr('<p>\82E5\70BA\5831\8868\5340\57DF, \60A8\53EF\4EE5\4F7F\7528\4E0B\5217\5206\9801\66FF\4EE3\5B57\4E32:</p>'),
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
unistr('    <dd>\986F\793A\5831\8868\5F15\64CE\6240\64F7\53D6\7684\8CC7\6599\5217\6578\76EE (\9801\9762\5927\5C0F). \60A8\53EF\4EE5\4F7F\7528\9019\4E9B\66FF\4EE3\5B57\4E32\5C0D\4F7F\7528\8005\986F\793A\81EA\8A02\7684\8A0A\606F.</dd>'),
'  <dt><code>#TOTAL_ROWS#</code></dt>',
unistr('    <dd>\986F\793A\7B26\5408\7528\65BC\5831\8868\4E4B SQL \67E5\8A62\7684\8CC7\6599\5217\7E3D\6578. \4F8B\5982,\300C\8CC7\6599\5217 X - Y, \5171 Z \500B\300D\4E2D\7684 Z</dd>'),
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
unistr('    <dd>\300C\8CC7\6599\5217 X - Y, \5171 Z \500B\300D\4E2D\7684 X</dd>'),
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
unistr('    <dd>\300C\8CC7\6599\5217 X - Y, \5171 Z \500B\300D\4E2D\7684 Y</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109240182676313550)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\9801\9762\6A23\677F\8868\5C3E\4E4B\524D\986F\793A\7684\6587\5B57\6216 HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109240095450313550)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\5C3E\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109779947417313983)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5C07\6B64\5C6C\6027\8A2D\70BA <code>fielddatabold</code> \5C07\6703\7522\751F\4E0B\5217 HTML</dt>'),
'<dd><pre>',
'&lt;span class="fielddatabold"&gt;Sample Data&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109597377080313827)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\5728\6B64\8CC7\6599\6B04\7684\503C\5957\7528\7684 CSS \985E\5225. \60A8\53EF\4EE5\8F38\5165 CSS \985E\5225\6216\5F9E\53EF\7528\9805\76EE\7684\6E05\55AE\4E2D\9078\64C7.</p>'),
unistr('<p>\6B64\985E\5225\9810\8A2D\6703\5305\62EC\5728\6240\6709\7684 &PRODUCT_NAME. \9801\9762\4E2D, \4E26\4E14\542B\6709 <code>''.fielddatabold{font-size: 10pt; font-weight: bold; color: #000000;}''</code> \5B9A\7FA9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109597223959313827)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109598835454313828)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\5728\6B64\8CC7\6599\6B04\5957\7528\7684\683C\5F0F\906E\7F69.'),
unistr('    \60A8\53EF\4EE5\9375\5165\683C\5F0F\906E\7F69, \6216\8005\5F9E\9810\5148\5B9A\7FA9\7684\6E05\55AE\4E2D\6311\9078 (\6839\64DA\986F\793A\7684\683C\5F0F\906E\7F69\5448\73FE\7BC4\4F8B\9078\64C7).</p>'),
unistr('    <p>\8ACB\6CE8\610F, \6578\5B57\683C\5F0F\906E\7F69\53EA\80FD\5957\7528\81F3\5305\542B\6578\5B57\7684\8CC7\6599\6B04, \65E5\671F\683C\5F0F\906E\7F69\53EA\80FD\5957\7528\81F3\5305\542B\65E5\671F\7684\8CC7\6599\6B04.'),
unistr('    \5426\5247, \7576\8A18\9304\7684\503C\7121\6CD5\4F7F\7528\6307\5B9A\7684\683C\5F0F\906E\7F69\8F49\63DB\6642, \5C31\6703\767C\751F\7A0B\5F0F\5BE6\969B\57F7\884C\932F\8AA4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109618907532313847)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\5728\6B64\8CC7\6599\6B04\5957\7528\7684\683C\5F0F\906E\7F69.'),
unistr('    \60A8\53EF\4EE5\9375\5165\683C\5F0F\906E\7F69, \6216\8005\5F9E\9810\5148\5B9A\7FA9\7684\6E05\55AE\4E2D\6311\9078 (\6839\64DA\986F\793A\7684\683C\5F0F\906E\7F69\5448\73FE\7BC4\4F8B\9078\64C7).</p>'),
unistr('    <p>\8ACB\6CE8\610F, \6578\5B57\683C\5F0F\906E\7F69\53EA\80FD\5957\7528\81F3\5305\542B\6578\5B57\7684\8CC7\6599\6B04, \65E5\671F\683C\5F0F\906E\7F69\53EA\80FD\5957\7528\81F3\5305\542B\65E5\671F\7684\8CC7\6599\6B04.'),
unistr('    \5426\5247, \7576\8A18\9304\7684\503C\7121\6CD5\4F7F\7528\6307\5B9A\7684\683C\5F0F\906E\7F69\8F49\63DB\6642, \5C31\6703\767C\751F\7A0B\5F0F\5BE6\969B\57F7\884C\932F\8AA4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109244848719313554)
,p_name=>'PE.PROPERTY.FORMAT_MASK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\5728\6B64\5143\4EF6\5957\7528\7684\683C\5F0F\906E\7F69.'),
unistr('   \60A8\53EF\4EE5\9375\5165\683C\5F0F\906E\7F69, \6216\8005\5F9E\9810\5148\5B9A\7FA9\7684\683C\5F0F\906E\7F69\6E05\55AE\4E2D\6311\9078 (\6839\64DA\986F\793A\7684\683C\5F0F\906E\7F69\5448\73FE\7BC4\4F8B\9078\64C7).</p>'),
unistr('   <p>\8ACB\6CE8\610F, \6578\5B57\683C\5F0F\906E\7F69\53EA\80FD\5957\7528\81F3\5305\542B\6578\5B57\7684\5143\4EF6, \65E5\671F\683C\5F0F\906E\7F69\53EA\80FD\5957\7528\81F3\5305\542B\65E5\671F\7684\5143\4EF6.'),
unistr('    \5426\5247, \7576\5143\4EF6\7684\503C\7121\6CD5\4F7F\7528\6307\5B9A\7684\683C\5F0F\906E\7F69\8F49\63DB\6642, \5C31\6703\767C\751F\7A0B\5F0F\5BE6\969B\57F7\884C\932F\8AA4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109244791770313554)
,p_name=>'PE.PROPERTY.FORMAT_MASK.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F\906E\7F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109245029232313554)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\8981\5957\7528\81F3\6B64\5143\4EF6\7684\65E5\671F\683C\5F0F\906E\7F69.'),
unistr('\60A8\53EF\4EE5\9375\5165\683C\5F0F\906E\7F69, \6216\8005\5F9E\9810\5148\5B9A\7FA9\7684\683C\5F0F\906E\7F69\6E05\55AE\4E2D\6311\9078 (\6839\64DA\986F\793A\7684\683C\5F0F\906E\7F69\5448\73FE\7BC4\4F8B\9078\64C7).'),
unistr('\60A8\4E5F\53EF\4EE5\4F7F\7528\66FF\4EE3\8A9E\6CD5\53C3\7167\61C9\7528\7A0B\5F0F\6216\9801\9762\9805\76EE\7684\52D5\614B\683C\5F0F\906E\7F69.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109244937840313554)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F\906E\7F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109245263094313554)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\8981\5957\7528\81F3\6B64\5143\4EF6\7684\6578\5B57\683C\5F0F\906E\7F69.'),
unistr('\60A8\53EF\4EE5\9375\5165\683C\5F0F\906E\7F69, \6216\8005\5F9E\9810\5148\5B9A\7FA9\7684\683C\5F0F\906E\7F69\6E05\55AE\4E2D\6311\9078 (\6839\64DA\986F\793A\7684\683C\5F0F\906E\7F69\5448\73FE\7BC4\4F8B\9078\64C7).'),
unistr('\60A8\4E5F\53EF\4EE5\4F7F\7528\66FF\4EE3\8A9E\6CD5\53C3\7167\61C9\7528\7A0B\5F0F\6216\9801\9762\9805\76EE\7684\683C\5F0F\906E\7F69.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109245108066313554)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F\906E\7F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109241505385313551)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\662F\5426\505C\7528\6B64\9801\9762\7684\81EA\52D5\5B8C\6210. \503C<strong>\958B\555F</strong>\5C0D\6B64\9801\9762\4E0D\6703\6709\5F71\97FF. <strong>\95DC\9589</strong>\503C\6703\5728 FORM \6A19\8A18\4E2D\7522\751F\4E0B\5217 HTML:'),
'<pre>',
'autocomplete="off"',
'</pre>',
unistr('<p>\6CE8\610F: \4E0D\540C\700F\89BD\5668\53EF\80FD\5C0D\9075\5F9E\6216\5FFD\7565 <code>autocomplete="off"</code> \7684\6642\6A5F\6709\4E0D\540C\7684\898F\5247. \56E0\6B64\5C07\6B64\9805\76EE\8A2D\70BA <strong>Off</strong> \6642, \8ACB\7279\5225\7262\8A18\53EF\80FD\6703\767C\751F\9019\7A2E\60C5\5F62, \4E26\5728\60A8\7684\76EE\6A19\700F\89BD\5668\4E2D\9032\884C\6E2C\8A66.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109743082368313955)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.OFF.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109742920532313955)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.ON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\555F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109241499639313551)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE\81EA\52D5\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108952908237313329)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\65BC\5B9A\7FA9\5716\8868\6A19\7C64\7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108952886291313329)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109595806177313826)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\4E00\822C\5831\8868\8CC7\6599\6B04\7684\6578\76EE\4E0A\9650.'),
unistr('\4F7F\7528\4E00\822C\8CC7\6599\6B04\540D\7A31\7684\5831\8868\53EA\6709\5728\7A0B\5F0F\5BE6\969B\57F7\884C\6642\624D\6703\88AB\5256\6790, \56E0\6B64\7DE8\8F2F\5831\8868\6642, \4E26\4E0D\6703\77E5\9053\8CC7\6599\6B04\7684\6578\76EE.</p>'),
unistr('<p>\5831\8868\8CC7\6599\6B04\7684\6578\76EE\4E0A\9650\61C9\8A72\8207\9810\671F\7684\5831\8868\8CC7\6599\6B04\6578\76EE\76F8\7B26.'),
unistr('\5982\679C\5BE6\969B\6578\76EE\8F03\5C0F, \5C31\6703\4EE5\5BE6\969B\7684\8CC7\6599\6B04\6578\76EE\5448\73FE\5831\8868.'),
unistr('\4E0D\904E, \5982\679C\5BE6\969B\6578\76EE\5927\65BC\4E0A\9650, \5247\6703\5728\7A0B\5F0F\5BE6\969B\57F7\884C\6642\986F\793A\932F\8AA4\8A0A\606F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109595792239313826)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\8CC7\6599\6B04\8A08\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109382613526313662)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\76EE\524D\4F7F\7528\8005\4ECB\9762\7684\5168\57DF\9801\9762 (\5982\679C\5C1A\672A\5B9A\7FA9).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109382512863313662)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\57DF\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110043539310314174)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109616863273313845)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109617148165313845)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109243851291313553)
,p_name=>'PE.PROPERTY.GRID_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\67D0\500B\7279\5B9A\7684\7248\9762\914D\7F6E\8CC7\6599\6B04. \82E5\8981\81EA\52D5\6C7A\5B9A\4E0B\4E00\500B\53EF\4EE5\986F\793A\5143\4EF6\7684\7248\9762\914D\7F6E\8CC7\6599\6B04, \8ACB\4F7F\7528<strong>\81EA\52D5</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109243754503313553)
,p_name=>'PE.PROPERTY.GRID_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109244638103313554)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\91DD\5C0D\7248\9762\914D\7F6E\8CC7\6599\6B04\8A2D\5B9A\7684\5176\4ED6\5C6C\6027. \9019\500B\503C\6703\53D6\4EE3\7248\9762\914D\7F6E\8CC7\6599\6B04\6A23\677F\4E2D\7684 <code>#ATTRIBUTES#</code> \66FF\4EE3\9810\7559\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109244528922313553)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109943070738314102)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109927628999314091)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\6B64\5143\4EF6\4F54\7528\7684\7248\9762\914D\7F6E\8CC7\6599\6B04\6578\76EE. \82E5\8981\5E73\8861\540C\4E00\8CC7\6599\5217\4E2D\6240\6709\5143\4EF6\7684\53EF\7528\7248\9762\914D\7F6E\8CC7\6599\6B04, \8ACB\4F7F\7528\300C\81EA\52D5\300D.</p>'),
'<dl>',
unistr('  <dt>\81EA\52D5</dt>'),
unistr('    <dd>\5361\7247\6703\5177\5099\521D\59CB\5BEC\5EA6, \7576\5361\7247\7121\6CD5\518D\5B8C\6574\5BB9\7D0D\65BC\756B\9762\5BEC\5EA6\6642, \4FBF\6703\81EA\52D5\63DB\884C\81F3\65B0\7684\8CC7\6599\5217.</dd>'),
unistr('  <dt>2\30013\30014\30015 \500B\8CC7\6599\6B04</dt>'),
unistr('    <dd>\5361\7247\5C07\6839\64DA\6240\9078\6BCF\4E00\884C\7684\8CC7\6599\6B04\6578\76EE\9032\884C\6392\5217.  \7248\9762\914D\7F6E\53EF\4F9D\64DA\6AA2\8996\57E0\5BEC\5EA6\6E1B\5C11\8CC7\6599\6B04\6578\76EE.</dd>'),
unistr('  <dt>\60A8\53EF\4EE5\8A2D\5B9A CSS \8B8A\6578\4F86\6307\5B9A\5361\7247\5BEC\5EA6.</dt>'),
unistr('    <dd>\4F8B\5982, \52A0\5165\4E0B\5217\7A0B\5F0F\78BC\7247\6BB5, \5373\53EF\5C07\5361\7247\5BEC\5EA6\8A2D\6210 320px: <pre>:root {'),
'  --a-cv-item-width: 320px;',
'}</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109927762819314092)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('2 \500B\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109927865665314092)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.3.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('3 \500B\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109927945247314092)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.4.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('4 \500B\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109928030173314092)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.5.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('5 \500B\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109927548942314091)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\683C\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110138192709314262)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\5957\7528\81F3\5305\542B\6B64\5340\57DF\4E4B\7248\9762\914D\7F6E\8CC7\6599\6B04\7684 CSS \985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.</p>'),
unistr('        <p>\60A8\53EF\4EE5\4F7F\7528\6B64\7279\6027, \96A8\6AA2\8996\57E0\5927\5C0F\7684\8B8A\66F4, \5C0D\5340\57DF\4E4B\7248\9762\914D\7F6E\8CC7\6599\6B04\7684\56DE\61C9\6027\548C\7248\9762\914D\7F6E\63D0\4F9B\7CBE\7D30\7684\63A7\5236.'),
unistr('        \5C0D\65BC\300C\901A\7528\4E3B\984C\300D\61C9\7528\7A0B\5F0F, \60A8\53EF\4EE5\4F7F\7528\8A31\591A CSS \4FEE\98FE\689D\4EF6\4F86\64F4\5145\9801\9762\5143\4EF6. \8ACB\8907\67E5\300C\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F\300D\7684\300C\53C3\8003\8CC7\6599\300D\6BB5\843D\4EE5\77AD\89E3\8A73\7D30\8CC7\8A0A.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110138031161314262)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04 CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110043632937314174)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109616905521313845)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109617238424313845)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109244269131313553)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\5143\4EF6\4F54\7528\7684\7248\9762\914D\7F6E\8CC7\6599\6B04\6578\76EE. \82E5\8981\5E73\8861\540C\4E00\8CC7\6599\5217\4E2D\6240\6709\5143\4EF6\7684\53EF\7528\7248\9762\914D\7F6E\8CC7\6599\6B04, \8ACB\4F7F\7528<strong>\81EA\52D5</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109244130954313553)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110135017760314260)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A23\677F\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110134932893314260)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6A19\7C64\4F54\7528\7684\7248\9762\914D\7F6E\8CC7\6599\6B04\6578\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110134845202314260)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64\8CC7\6599\6B04\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109244065779313553)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\5143\4EF6\986F\793A\5728\4E0B\4E00\500B\8CC7\6599\6B04\4E2D, \6216\986F\793A\5728\8207\524D\4E00\500B\5143\4EF6\76F8\540C\7684\8CC7\6599\6B04\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109243948493313553)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109243458543313553)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\5143\4EF6\662F\8981\4EE5\65B0\7684\7248\9762\914D\7F6E\986F\793A, \9084\662F\4EE5\524D\4E00\500B\5143\4EF6\7684\7248\9762\914D\7F6E\986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109243309504313553)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\65B0\7248\9762\914D\7F6E\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109243646223313553)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\5143\4EF6\986F\793A\5728\524D\4E00\500B\5143\4EF6\7684\4E0B\4E00\500B\8CC7\6599\5217\4E0A, \6216\986F\793A\5728\76F8\540C\7684\8CC7\6599\5217\4E0A.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109243557541313553)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\65B0\8CC7\6599\5217\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109901771592314073)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\5957\7528\81F3\5305\542B\6B64\5340\57DF\4E4B\7248\9762\914D\7F6E\8CC7\6599\5217\7684 CSS \985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.</p>'),
unistr('        <p>\60A8\53EF\4EE5\4F7F\7528\6B64\7279\6027, \96A8\6AA2\8996\57E0\5927\5C0F\7684\8B8A\66F4, \5C0D\5340\57DF\4E4B\7248\9762\914D\7F6E\8CC7\6599\5217\7684\56DE\61C9\6027\548C\7248\9762\914D\7F6E\63D0\4F9B\7CBE\7D30\7684\63A7\5236.'),
unistr('        \5C0D\65BC\300C\901A\7528\4E3B\984C\300D\61C9\7528\7A0B\5F0F, \60A8\53EF\4EE5\4F7F\7528\8A31\591A CSS \4FEE\98FE\689D\4EF6\4F86\64F4\5145\9801\9762\5143\4EF6. \8ACB\8907\67E5\300C\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F\300D\7684\300C\53C3\8003\8CC7\6599\300D\6BB5\843D\4EE5\77AD\89E3\8A73\7D30\8CC7\8A0A.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109901667576314073)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217 CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109244404721313553)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\5143\4EF6\8981\4F54\7528 HTML \8868\683C\4E2D\591A\5C11\500B\8CC7\6599\5217. \5143\4EF6\6703\986F\793A\5728 HTML \8868\683C\4E2D. \6B64\5C6C\6027\6C7A\5B9A\6B64\5143\4EF6\8868\683C\5132\5B58\683C\4E2D <em>ROWSPAN</em> \5C6C\6027\6240\7528\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109244361920313553)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109520940100313766)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7528\65BC\5B9A\7FA9\5716\8868\5716\4F8B\6578\5217\540D\7A31\7C21\77ED\63CF\8FF0\6027\81EA\8A02\5DE5\5177\63D0\793A\7684\8CC7\6599\6B04\540D\7A31. \82E5\70BA\7BB1\5F62\5716, \6B64\8CC7\6599\6B04\4E0D\61C9\8207\9078\53D6\7684\300C\503C\300D\8CC7\6599\6B04\5C0D\61C9\76F8\7B26. \82E5\9078\53D6\7684\8CC7\6599\6B04\548C\300C\503C\300D\8CC7\6599\6B04\5C0D\61C9\76F8\7B26, \5716\8868\4E0A\5C07\4E0D\6703\5448\73FE\5716\4F8B\5DE5\5177\63D0\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109520864797313766)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\4F8B\5DE5\5177\63D0\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109521187977313766)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7528\65BC\5B9A\7FA9\5716\8868 X \8EF8\6A19\7C64\7C21\77ED\63CF\8FF0\6027\81EA\8A02\5DE5\5177\63D0\793A\7684\8CC7\6599\6B04\540D\7A31. \82E5\70BA\7BB1\5F62\5716, \6B64\8CC7\6599\6B04\4E0D\61C9\8207\9078\53D6\7684\300C\503C\300D\8CC7\6599\6B04\5C0D\61C9\76F8\7B26. \82E5\9078\53D6\7684\8CC7\6599\6B04\548C\300C\503C\300D\8CC7\6599\6B04\5C0D\61C9\76F8\7B26, \5716\8868\4E0A\5C07\4E0D\6703\5448\73FE\6A19\7C64\5DE5\5177\63D0\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109521044613313766)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64\5DE5\5177\63D0\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109595642528313826)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\662F\5426\8981\5F9E SQL \67E5\8A62\884D\751F\8CC7\6599\6B04\5B9A\7FA9.'),
unistr('\9019\9EBC\505A\6703\9700\8981 &PRODUCT_NAME. \5256\6790\67E5\8A62.'),
unistr('\5982\679C\60A8\4E0D\5E0C\671B\6B64\6642\5256\6790\67E5\8A62, \8ACB\4F7F\7528\4E00\822C\8CC7\6599\6B04\4EE5\7522\751F\9810\7559\4F4D\7F6E\8CC7\6599\6B04\5B9A\7FA9.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109595553016313826)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\4E00\822C\8CC7\6599\6B04\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109330487155313622)
,p_name=>'PE.PROPERTY.HEADER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\986F\793A\5728\5340\57DF\9802\7AEF (\4EA6\5373, <code>#BODY#</code> \5167\5BB9\4E4B\524D) \7684 HTML \6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109239760109313550)
,p_name=>'PE.PROPERTY.HEADER_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\7DCA\63A5\5728\9801\9762\6A19\982D\4E4B\5F8C\4F46\5728\4E3B\9AD4\5167\5BB9\4E4B\524D\986F\793A\7684\6587\5B57\6216 HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109239663153313550)
,p_name=>'PE.PROPERTY.HEADER_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109603035883313835)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\5982\4F55\5B9A\7FA9\60A8\5831\8868\7684\6A19\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109781736749313985)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109781836734313985)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B93\60A8\81EA\884C\8F38\5165\6A19\984C. \6A19\984C\4E00\958B\59CB\7684\9810\8A2D\503C\6703\4F9D\64DA\8CC7\6599\6B04\540D\7A31\67E5\8A62\800C\5B9A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109781904411313985)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109782077009313985)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\50B3\56DE\5192\865F\5340\9694\540D\7A31\6E05\55AE\7684 PL/SQL \51FD\6578\5EFA\7ACB\6A19\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109782127397313985)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109782208067313985)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\7684\5831\8868\5C07\7121\5831\8868\6A19\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109781362893313984)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109781436639313984)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\8CC7\6599\6B04\540D\7A31\7684\67E5\8A62\7522\751F\6A19\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109781501527313984)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.D'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('\8CC7\6599\6B04\540D\7A31 (InitCap)')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109781617426313985)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\8CC7\6599\6B04\540D\7A31\7684\67E5\8A62\7522\751F\6A19\984C, \4E26\5C07\9996\5B57\6BCD\8F49\63DB\70BA\5927\5BEB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109602947025313834)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109563692255313802)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6A19\984C\5C0D\9F4A\65B9\5F0F. \8ACB\6CE8\610F, \60A8\6240\9078\53D6\7684\5C0D\9F4A\65B9\5F0F\5FC5\9808\662F\6240\9078\5831\8868\6A23\677F\652F\63F4\7684\65B9\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109767575079313974)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7F6E\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109767490911313974)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109767632584313974)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109563515913313802)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\9F4A\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109782306854313985)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\6839\64DA DEPT \8868\683C\63D0\4F9B\5831\8868\7684\6A19\984C</dt>'),
'<dd><pre>return ''Deptno:DName:Loc'';</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109603232345313835)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\50B3\56DE\4EE5\5192\865F\5340\9694\4E4B\8CC7\6599\6B04\6A19\984C\5B57\4E32\7684 PL/SQL \51FD\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109603158171313835)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109474902223313732)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\4F7F\7528\6B64\5C6C\6027\8F38\5165\4E92\52D5\5F0F\65B9\683C\7684\8AAA\660E\5167\5BB9. \5728\300C\52D5\4F5C\529F\80FD\8868\300D\8AAA\660E\4E0B, \6703\986F\793A\6240\8F38\5165\7684\8AAA\660E\5167\5BB9\8207\9810\8A2D\8AAA\660E\5167\5BB9.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109475866165313733)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\8CC7\6599\6B04\7684\8AAA\660E\5167\5BB9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109617931704313846)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\9805\76EE\7684\8AAA\660E\5167\5BB9. \60A8\53EF\4EE5\4F7F\7528\8AAA\660E\5167\5BB9\63D0\4F9B\6B04\4F4D\5C64\7D1A\7684\76F8\95DC\5167\5BB9\8AAA\660E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109242546976313552)
,p_name=>'PE.PROPERTY.HELP_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\5C6C\6027\8F38\5165\76EE\524D\9801\9762\7684\8AAA\660E\5167\5BB9. \9801\9762\5C64\7D1A\8AAA\660E\53EF\4EE5\4F7F\7528\4EE5\4E0B\8A9E\6CD5\4F86\652F\63F4\6377\5F91:</p>'),
'<pre>"SHORTCUT_NAME"</pre>',
unistr('<p>\9810\8A2D\4E0D\6703\986F\793A\9801\9762\8AAA\660E\6587\5B57. \4E0D\904E, \60A8\53EF\4EE5\5FEB\901F\5730\958B\767C\8AAA\660E\7CFB\7D71\4F86\986F\793A\6B64\6587\5B57.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109242460652313552)
,p_name=>'PE.PROPERTY.HELP_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109496907445313748)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\5C6C\6027\8F38\5165\76EE\524D\9801\9762\7684\8AAA\660E\5167\5BB9. \9801\9762\5C64\7D1A\8AAA\660E\53EF\4EE5\4F7F\7528\4EE5\4E0B\8A9E\6CD5\4F86\652F\63F4\6377\5F91:</p>'),
'<pre>"SHORTCUT_NAME"</pre>',
unistr('<p>\9810\8A2D\4E0D\6703\986F\793A\9801\9762\8AAA\660E\6587\5B57. \4E0D\904E, \60A8\53EF\4EE5\5FEB\901F\5730\958B\767C\8AAA\660E\7CFB\7D71\4F86\986F\793A\6B64\6587\5B57.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109496866671313748)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109279154613313584)
,p_name=>'PE.PROPERTY.HIDDEN_PARENT_REGION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109904247218314074)
,p_name=>'PE.PROPERTY.HIDDEN_REGION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109516807713313763)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\8981\5728\6309\4E00\4E0B\5716\4F8B\9805\76EE\6642\57F7\884C\7684\96B1\85CF\548C\986F\793A\884C\70BA.'),
unistr('        \4F8B\5982, \53D6\6D88\9078\53D6\5716\4F8B\9805\76EE\5C07\6703\5728\5716\8868\4E0A\96B1\85CF\5176\76F8\95DC\806F\8CC7\6599\6578\5217.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109516926002313763)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109640556189313862)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr(' \6B64\5716\8868\5C07\7121\6CD5\555F\7528\96B1\85CF\53CA\986F\793A\884C\70BA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109517111133313763)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\91CD\65B0\8ABF\6574\6BD4\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109640789269313863)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr(' \5716\8868\5EA7\6A19\8EF8\4E0D\6703\91CD\65B0\8ABF\6574\6BD4\4F8B. \9019\6A23\4E00\4F86, \4F7F\7528\8005\5C31\80FD\5C08\6CE8\65BC\76F8\95DC\8CC7\8A0A\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109517079966313763)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\8ABF\6574\6BD4\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109640612336313862)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr(' \5716\8868\5EA7\6A19\8EF8\6703\96A8\8457\53EF\898B\8CC7\6599\4E4B\6700\5927\503C\548C\6700\5C0F\503C\7684\589E\6E1B\800C\91CD\65B0\8ABF\6574\6BD4\4F8B. \5982\679C\6578\5217\7684\503C\6703\5927\5E45\8B8A\52D5, \5C31\76F8\7576\9069\5408\4F7F\7528\9019\9805\529F\80FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109516794086313763)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF\548C\986F\793A\884C\70BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109597732865313827)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\8981\5728\5831\8868\8CC7\6599\6B04\4E2D\6A19\793A\7684\6587\5B57\5B57\4E32.'),
unistr('\82E5\6709\591A\500B\6A19\793A\6587\5B57, \8ACB\4F7F\7528\4EE5\9017\865F\5340\9694\7684\6E05\55AE.'),
unistr('\60A8\4E5F\53EF\4EE5\4F7F\7528 <code>&amp;ITEM.</code> \8A9E\6CD5\4F86\53C3\7167\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.'),
unistr('\4F8B\5982, \60A8\53EF\4EE5\6A19\793A\5728\641C\5C0B\6B04\4F4D\4E2D\8F38\5165\7684\5B57\4E32.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109597674658313827)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\793A\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109382084147313661)
,p_name=>'PE.PROPERTY.HOME_URL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4F7F\7528\8005\4ECB\9762\7684\61C9\7528\7A0B\5F0F\9996\9801.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109381945629313661)
,p_name=>'PE.PROPERTY.HOME_URL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9996\9801 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109260437115313565)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\9078\53D6\6B64\6309\9215\5728\6307\5B9A\6A23\677F\4F4D\7F6E\4E2D\7684\6C34\5E73\5C0D\9F4A\65B9\5F0F.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109758669428313967)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9760\5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109758779701313967)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9760\53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109260311376313565)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C34\5E73\5C0D\9F4A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109769513984313975)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\8B8A\66F4\80CC\666F\8207\6587\5B57\8272\5F69</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">#EMPLOYEE_STATUS#&lt;/span></pre></dd>',
unistr('  <dt>\4F7F\7528\6A19\984C 2</dt>'),
'    <dd><pre>&lt;h2>#EMPLOYEE_NAME#&lt;/h2></pre></dd>',
unistr('  <dt>\4F7F\7528\4F86\81EA SQL \67E5\8A62\7684\52D5\614B\985E\5225</dt>'),
'    <dd><pre>&lt;span class="#COLUMN_CLASS#">#EMPLOYEE_STATUS#&lt;/span></pre><br>',
unistr('    \6B64\7BC4\4F8B\4E2D\7684 <code>#COLUMN_CLASS#</code> \8207 <code>#EMPLOYEE_STATUS#</code> \66FF\4EE3\9805\76EE\70BA\5831\8868 SQL \67E5\8A62\4E2D\9078\53D6\7684\8CC7\6599\6B04.</dd>'),
unistr('  <dt>\6E38\6A19\505C\7559\6642\986F\793A\5F71\50CF\8207\5DE5\5177\63D0\793A</dt>'),
'    <dd><pre>&lt;img src="#IMAGE_NAME#" title="#EMPLOYEE_NAME#"&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109566253619313804)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5728\6B64\8CC7\6599\6B04\4E2D\986F\793A\7684 HTML \8868\793A\5F0F. \82E5\8981\4EE5 HTML \683C\5F0F\986F\793A\8CC7\6599\6B04\503C, \8ACB\4F7F\7528 <code>#COLUMN#</code> \8A9E\6CD5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109566147859313804)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109239377660313550)
,p_name=>'PE.PROPERTY.HTML_HEADER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\53D6\4EE3\9801\9762\6A23\677F\6A19\982D\4E2D <code>#HEAD#</code> \66FF\4EE3\5B57\4E32\7684\6587\5B57.'),
unistr('\5728\6B64\8655\8F38\5165\7684\503C\6703\63D2\5165\5230 HTML <code>&lt;head&gt;</code> \6A19\8A18\4E4B\5F8C. \60A8\53EF\4EE5\4F7F\7528\6B64\9801\9762\5C6C\6027\4F86\65B0\589E\9801\9762\7279\5B9A\63CF\8FF0\6A19\8A18.'),
'</p>',
unistr('<p>\6CE8\610F: JavaScript \7A0B\5F0F\78BC\6216\968E\5C64\5F0F\6A23\5F0F\8868\61C9\8A72\65B0\589E\81F3\5C08\7528 JavaScript \548C CSS \5C6C\6027.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109239212047313549)
,p_name=>'PE.PROPERTY.HTML_HEADER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \6A19\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109933166336314095)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\53EF\50B3\56DE\5716\793A\5F71\50CF\4F86\6E90 BLOB \7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109933050918314095)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109932967648314095)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7576\4F5C\5716\793A\5F71\50CF\4F86\6E90\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109932812138314095)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109281639131313586)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\7528\4EE5\8B58\5225\6B64\9762\5411\4E4B\5716\793A\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.</p>'),
unistr('        <p>\60A8\7684\4E3B\984C\82E5\4F7F\7528\300C\5B57\578B APEX\300D, \8ACB\8907\67E5<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F</a>\4EE5\6AA2\8996\53EF\7528\7684\5716\793A\548C\4FEE\98FE\689D\4EF6.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109281715680313586)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\7528\4EE5\8B58\5225\6B64\9762\5411\4E4B\5716\793A\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.</p>'),
unistr('        <p>\60A8\7684\4E3B\984C\82E5\4F7F\7528\300C\5B57\578B APEX\300D, \8ACB\8907\67E5<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F</a>\4EE5\6AA2\8996\53EF\7528\7684\5716\793A\548C\4FEE\98FE\689D\4EF6.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109281810935313586)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\7528\4EE5\8B58\5225\6B64\9762\5411\4E4B\5716\793A\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.</p>'),
unistr('        <p>\60A8\7684\4E3B\984C\82E5\4F7F\7528\300C\5B57\578B APEX\300D, \8ACB\8907\67E5<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F</a>\4EE5\6AA2\8996\53EF\7528\7684\5716\793A\548C\4FEE\98FE\689D\4EF6.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110060508929314186)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\65B0\589E\81F3\5143\4EF6\4E4B\5716\793A\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.</p>'),
unistr('        <p>\60A8\7684\4E3B\984C\82E5\4F7F\7528\300C\5B57\578B APEX\300D, \8ACB\8907\67E5<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F</a>\4EE5\6AA2\8996\53EF\7528\7684\5716\793A\548C\4FEE\98FE\689D\4EF6.</p>'),
unistr('        <p>\6CE8\610F: \6B64\5716\793A\5C07\986F\793A\65BC\9805\76EE\4E4B\5167, \800C\975E\6A19\7C64\7684\4E00\90E8\5206.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110060455575314186)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\65B0\589E\81F3\5143\4EF6\4E4B\5716\793A\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.</p>'),
unistr('        <p>\60A8\7684\4E3B\984C\82E5\4F7F\7528\300C\5B57\578B APEX\300D, \8ACB\8907\67E5<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F</a>\4EE5\6AA2\8996\53EF\7528\7684\5716\793A\548C\4FEE\98FE\689D\4EF6.</p>'),
unistr('        <p>\6CE8\610F: \6B64\5716\793A\5C07\986F\793A\65BC\9805\76EE\4E4B\5167, \800C\975E\6A19\7C64\7684\4E00\90E8\5206.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109282047816313586)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\7528\4EE5\8B58\5225\6B64\7BE9\9078\4E4B\5716\793A\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.</p>'),
unistr('        <p>\60A8\7684\4E3B\984C\82E5\4F7F\7528\300C\5B57\578B APEX\300D, \8ACB\8907\67E5<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F</a>\4EE5\6AA2\8996\53EF\7528\7684\5716\793A\548C\4FEE\98FE\689D\4EF6.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109282941196313587)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\7528\4EE5\8B58\5225\6B64\7BE9\9078\4E4B\5716\793A\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.</p>'),
unistr('        <p>\60A8\7684\4E3B\984C\82E5\4F7F\7528\300C\5B57\578B APEX\300D, \8ACB\8907\67E5<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F</a>\4EE5\6AA2\8996\53EF\7528\7684\5716\793A\548C\4FEE\98FE\689D\4EF6.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109283314587313587)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\7528\4EE5\8B58\5225\6B64\7BE9\9078\4E4B\5716\793A\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.</p>'),
unistr('        <p>\60A8\7684\4E3B\984C\82E5\4F7F\7528\300C\5B57\578B APEX\300D, \8ACB\8907\67E5<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F</a>\4EE5\6AA2\8996\53EF\7528\7684\5716\793A\548C\4FEE\98FE\689D\4EF6.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109919690422314086)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\986F\793A\6307\5411\53F3\908A\7684\7BAD\865F</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109919538939314086)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\65B0\589E\81F3\5143\4EF6\4E4B\5716\793A\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.</p>'),
unistr('        <p>\60A8\7684\4E3B\984C\82E5\4F7F\7528\300C\5B57\578B APEX\300D, \8ACB\8907\67E5<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F</a>\4EE5\6AA2\8996\53EF\7528\7684\5716\793A\548C\4FEE\98FE\689D\4EF6.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109919480866314086)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109934634018314096)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\6587\5B57\63CF\8FF0\5716\793A, \7528\65BC\5DE5\5177\63D0\793A\548C\5F71\50CF\7684\66FF\4EE3\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109934510529314096)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109933385436314096)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5716\793A\5F71\50CF\4F86\6E90\7684 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109933268359314095)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109933815300314096)
,p_name=>'PE.PROPERTY.ICON_POSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C7A\5B9A\5361\7247\6A19\982D\4E2D\7684\5716\793A\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109934371128314096)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109934451534314096)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5716\793A\5C0D\9F4A\6A19\982D\7684\7D50\675F\4F4D\7F6E (\901A\5E38\70BA\53F3\5074).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109934191911314096)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109934220140314096)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5716\793A\5C0D\9F4A\6A19\982D\7684\958B\59CB\4F4D\7F6E (\901A\5E38\70BA\5DE6\5074).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109933929587314096)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9760\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109934031386314096)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5716\793A\986F\793A\5728\6A19\982D\4E0A\65B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109933768877314096)
,p_name=>'PE.PROPERTY.ICON_POSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109943110516314102)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\5716\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109932239976314095)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5361\7247\5143\4EF6\6A19\982D\4E2D\986F\793A\7684\5716\793A\4F86\6E90.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109932713144314095)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.BLOB.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF BLOB \8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109932588674314095)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A\985E\5225\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109932301003314095)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.INITIALS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E2E\5BEB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109932464170314095)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A\985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109932637052314095)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109932178189314095)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109463861288313724)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="&APEX$ROW_URL!ATTR."&gt;&lt;img src="&EMP_IMG!ATTR." title="&ENAME!ATTR." alt="&ENAME!ATTR."&gt;&lt;br&gt;&ENAME.&lt;/a&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109463704620313724)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('</p>\8F38\5165\300C\5716\793A\6AA2\8996\300D\7684\81EA\8A02\8CC7\6599\6B04 HTML.</p>'),
unistr('<p>\53EF\4EE5\4F7F\7528\4E0B\5217\66FF\4EE3\5B57\4E32:'),
'<ul>',
unistr('<li><code>&&lt;COLUMN_NAME&gt;.</code> - \8CC7\6599\6B04\540D\7A31\66FF\4EE3\5B57\4E32.</li>'),
unistr('<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code> - \8CC7\6599\6B04\6A19\7C64\66FF\4EE3\5B57\4E32.</li>'),
unistr('<li><code>&APEX$ROW_ID.</code> - \8CC7\6599\5217\7684\8A18\9304 ID.</li>'),
unistr('<li><code>&APEX$ROW_INDEX.</code> - \8A18\9304\986F\793A\5E8F\865F.</li>'),
unistr('<li><code>&APEX$ROW_URL.</code> - \53C3\7167\6307\5B9A\7684\9023\7D50\76EE\6A19.</li>'),
unistr('<li><code>&APEX$ROW_STATE_CLASSES.</code> - \8A18\9304\72C0\614B, \4F8B\5982 <code>is-inserted</code> \6216 <code>is-deleted</code>.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109463640230313724)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\5716\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109772990362313978)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="#EMP_LINK#"&gt;&lt;img src="#EMP_IMG#" title="#ENAME#" alt="#ENAME#"&gt;&lt;br&gt;#ENAME#&lt;/a&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109574736028313810)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\300C\5716\793A\6AA2\8996\300D\7684\8CC7\6599\6B04\9023\7D50. \8ACB\8996\9700\8981\4F7F\7528 <code>#COLUMN_NAME#</code> \66FF\4EE3\5B57\4E32\4F5C\70BA\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109574673447313810)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109474773043313732)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\555F\7528\300C\5716\793A\6AA2\8996\300D. \82E5\9078\53D6<strong>\958B\555F</strong>, \5C31\6703\5728\4E92\52D5\5F0F\5831\8868\7684\300C\641C\5C0B\300D\5217\6216\4E92\52D5\5F0F\65B9\683C\7684\300C\6AA2\8996\300D\6309\9215\589E\52A0\300C\6AA2\8996\5716\793A\300D\5716\793A, \8B93\4F7F\7528\8005\53EF\4EE5\5B58\53D6\6B64\6AA2\8996.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109573158077313809)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\555F\7528\300C\5716\793A\6AA2\8996\300D. \82E5\9078\53D6<strong>\958B\555F</strong>, \5C31\6703\5728\4E92\52D5\5F0F\5831\8868\7684\300C\641C\5C0B\300D\5217\6216\4E92\52D5\5F0F\65B9\683C\7684\300C\6AA2\8996\300D\6309\9215\589E\52A0\300C\6AA2\8996\5716\793A\300D\5716\793A, \8B93\4F7F\7528\8005\53EF\4EE5\5B58\53D6\6B64\6AA2\8996.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109573072404313809)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109574393078313810)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5F71\50CF\7684 HTML ALT \6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109574228908313810)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML ALT \6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109574561720313810)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5F71\50CF\7684 HTML TITLE \6A19\8A18.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109574462402313810)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML TITLE \6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109465009261313725)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7528\65BC HTML IMG \6A19\8A18\7684\5716\793A\5F71\50CF\5C6C\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109464983460313725)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109464442431313724)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\53EF\50B3\56DE\5716\793A\5F71\50CF\4F86\6E90 BLOB \7684\4E92\52D5\5F0F\65B9\683C\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109464325184313724)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109464821616313724)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\53EF\50B3\56DE\5716\793A\5F71\50CF\4F86\6E90 CSS \985E\5225\7684\4E92\52D5\5F0F\65B9\683C\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109464717178313724)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109464047330313724)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\53EF\4FDD\7559\5716\793A\5F71\50CF\4F86\6E90\7684\8CC7\6599\6B04\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109464213414313724)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.CSS_CLASSES.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109464121209313724)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.URL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('URL \4E2D\7684\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109463983601313724)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109464668695313724)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\53EF\50B3\56DE\5716\793A\5F71\50CF\4F86\6E90 URL \7684\4E92\52D5\5F0F\65B9\683C\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109464597021313724)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109574144884313810)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165 HTML IMG \6A19\8A18\6240\4F7F\7528\7684\5F71\50CF\5C6C\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109574024407313810)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109772703311313978)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\6AA2\67E5 <code>IMAGE</code> \8CC7\6599\6B04</dt>'),
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109573781023313810)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\50B3\56DE\5F71\50CF\4F86\6E90\7684\5831\8868\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109573605670313810)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF\4F86\6E90\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109772867404313978)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\6AA2\67E5 <code>ENAME</code> \8CC7\6599\6B04</dt>'),
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109573990759313810)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\50B3\56DE\5F71\50CF\6A19\7C64\7684\5831\8868\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109573889967313810)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109447161575313711)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\6AA2\67E5 <code>ENAME</code> \8CC7\6599\6B04</dt>'),
'<dd><pre>',
'select empno,',
'       ename,',
'       job,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109447083557313711)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\50B3\56DE\5F71\50CF\6A19\7C64\7684\5831\8868\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109446968948313711)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109465455477313725)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\6BCF\500B<strong>\9023\7D50\76EE\6A19</strong>\986F\793A\76F8\95DC\806F\7684 HTML \5C6C\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109465306471313725)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109772626044313978)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\6AA2\67E5 <code>LINK</code> \8CC7\6599\6B04</dt>'),
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109573569700313810)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\50B3\56DE\5716\793A\4E4B\9023\7D50\76EE\6A19\7684\5831\8868\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109573432137313809)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110000653475314144)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\51FD\6578\4E3B\9AD4\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110000947660314144)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110000863257314144)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110000703181314144)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110001020791314144)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110000544039314144)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110001888417314145)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\50B3\56DE SQL \67E5\8A62\7684 Java \51FD\6578\4E3B\9AD4, \4EE5\7522\751F\6B64\503C\6E05\55AE.</p>'),
unistr('<p>SQL \67E5\8A62\50C5\9700\8981\50B3\56DE\4E00\500B\8CC7\6599\6B04. \5982\679C\67E5\8A62\50B3\56DE\591A\500B\8CC7\6599\6B04, \5247\53EA\6703\5728\7BE9\9078\641C\5C0B\4E2D\4F7F\7528\7B2C\4E00\500B\8CC7\6599\6B04.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110001748514314145)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 Java \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110001673115314145)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\986F\793A\90E8\9580\540D\7A31, \8A2D\5B9A\90E8\9580\7DE8\865F</dt>'),
'<dd><pre>',
'return "select dname as d from dept order by 1";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110001547984314145)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\50B3\56DE SQL \67E5\8A62\7684 JavaScript \51FD\6578\4E3B\9AD4, \4EE5\7522\751F\6B64\503C\6E05\55AE.</p>'),
unistr('<p>SQL \67E5\8A62\50C5\9700\8981\50B3\56DE\4E00\500B\8CC7\6599\6B04. \5982\679C\67E5\8A62\50B3\56DE\591A\500B\8CC7\6599\6B04, \5247\53EA\6703\5728\7BE9\9078\641C\5C0B\4E2D\4F7F\7528\7B2C\4E00\500B\8CC7\6599\6B04.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110001406652314144)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 JavaScript \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110001351930314144)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\50B3\56DE\90E8\9580\540D\7A31:</dt>'),
'<dd><pre>',
'begin',
'    return ''select dname as d from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110001254459314144)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578\4E3B\9AD4, \4EE5\7522\751F\6B64\503C\6E05\55AE.</p>'),
unistr('<p>SQL \67E5\8A62\50C5\9700\8981\50B3\56DE\4E00\500B\8CC7\6599\6B04. \5982\679C\67E5\8A62\50B3\56DE\591A\500B\8CC7\6599\6B04, \5247\53EA\6703\5728\7BE9\9078\641C\5C0B\4E2D\4F7F\7528\7B2C\4E00\500B\8CC7\6599\6B04.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110001137711314144)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110002027341314145)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\50B3\56DE SQL \67E5\8A62\7684 Python \51FD\6578\4E3B\9AD4, \4EE5\7522\751F\6B64\503C\6E05\55AE.</p>'),
unistr('<p>SQL \67E5\8A62\50C5\9700\8981\50B3\56DE\4E00\500B\8CC7\6599\6B04. \5982\679C\67E5\8A62\50B3\56DE\591A\500B\8CC7\6599\6B04, \5247\53EA\6703\5728\7BE9\9078\641C\5C0B\4E2D\4F7F\7528\7B2C\4E00\500B\8CC7\6599\6B04.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110001977188314145)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 Python \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109470320136313729)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>'<pre>Cow,Dog,Cat,Lion</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109470230896313729)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\975C\614B\6E05\55AE\7684\503C\6E05\55AE (\4F7F\7528\9017\865F\5340\9694).</p>'),
unistr('        <p>\6CE8\610F -\300C\975C\614B\503C\300D\5C07\4E00\5F8B\4EE5\6307\5B9A\7684\9806\5E8F\986F\793A, \800C\4E0D\662F\4F9D\5B57\6BCD\9806\5E8F\986F\793A.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109470186147313729)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109466026176313725)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\6B64\8CC7\6599\6B04\7684\7FA4\7D44. \7FA4\7D44\7528\4F86\5728\7DB2\683C\548C\300C\55AE\4E00\8CC7\6599\5217\6AA2\8996\300D\4E2D\5C07\8CC7\6599\6B04\95DC\806F\5728\4E00\8D77.</p>'),
unistr('        <p>\6CE8\610F - \5C55\958B\300C\5448\73FE\300D\6A39\72C0\7D50\69CB\5167\7684\300C\5C6C\6027\300D\8CC7\6599\593E, \4E26\5728\300C\8CC7\6599\6B04\7FA4\7D44\300D\4E0A\6309\4E00\4E0B\6ED1\9F20\53F3\9375, \4F86\65B0\589E\7FA4\7D44\4EE5\5EFA\7ACB\65B0\7684\7FA4\7D44.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109465925251313725)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109470587063313729)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\8CC7\6599\6B04\503C\6240\4F9D\64DA\7684\4F86\6E90\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109470666595313729)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109470732982313729)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5728<em>\8CC7\6599\5EAB\8CC7\6599\6B04</em>\4E2D\8F38\5165\7684\8CC7\6599\6B04\503C, \8A72\503C\64F7\53D6\81EA\5340\57DF\4F86\6E90\300CSQL \67E5\8A62\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109471091939313729)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.NONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109471133899313729)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.NONE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\503C\4E0D\662F\64F7\53D6\81EA\4EFB\4F55\4F86\6E90. \4F8B\5982, APEX$ROW_SELECTOR \548C APEX$ROW_ACTION \8CC7\6599\6B04\6C92\6709\4F86\6E90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109470889925313729)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109470912958313729)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B <em>SQL \8868\793A\5F0F</em>\50B3\56DE\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109470433253313729)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109463106116313723)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6AA2\67E5\4F7F\7528\8005\53EF\4F7F\7528\4F55\7A2E\4E0B\8F09\683C\5F0F\4F86\4E0B\8F09\76EE\524D\986F\793A\7684\8CC7\6599\6B04.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109463270704313723)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_language=>'zh-tw'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109463341549313723)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_language=>'zh-tw'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109621384422313849)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108906656167313292)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109463042070313723)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109465215137313725)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E00\4E0B\300C\9023\7D50\76EE\6A19\300D\4EE5\547C\53EB\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A. \60A8\53EF\4EE5\8F38\5165\8981\5728\6309\4E00\4E0B\6B64\5716\793A\6642\547C\53EB\7684\81EA\8A02\76EE\6A19.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109465142171313725)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\76EE\6A19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109461331351313722)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\6B64\5831\8868\7684\5206\9801\985E\578B. \5831\8868\4E2D\901A\5E38\4E0D\6703\986F\793A\6240\6709\5831\8868\8CC7\6599\5217.'),
unistr('		\82E5\8981\986F\793A\5176\4ED6\8CC7\6599\5217, \4E00\822C\4F7F\7528\8005\53EF\4EE5\4F7F\7528\63D0\4F9B\7684\5206\9801.</p>'),
unistr('		<p>\5206\9801\6703\5C0D\4E00\822C\4F7F\7528\8005\63D0\4F9B\7D50\679C\96C6\5167\6240\986F\793A\8CC7\6599\5217\6578\76EE\548C\76EE\524D\4F4D\7F6E\7684\76F8\95DC\8CC7\8A0A.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109461547364313722)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SCROLL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6372\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109589904517313821)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SCROLL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E00\958B\59CB\6703\986F\793A\8DB3\4EE5\586B\6EFF\300C\4E92\52D5\5F0F\65B9\683C\300D\4E4B\9AD8\5EA6\7684\8CC7\6599\5217\6578\76EE.'),
unistr('        \96A8\8457\4E00\822C\4F7F\7528\8005\6372\52D5, \6703\986F\793A\5176\4ED6\8CC7\6599\5217, \8996\9700\8981\5F9E\4F3A\670D\5668\53D6\5F97\66F4\591A\8CC7\6599.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109461455410313722)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SET.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109589882658313821)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6839\64DA<em>\6BCF\9801\8CC7\6599\5217\6578</em>\4E2D\6307\5B9A\7684\6578\5B57, \5C07\6703\986F\793A\7B2C\4E00\500B\8CC7\6599\5217.'),
unistr('        \5982\679C\6709\5176\4ED6\8CC7\6599\5217, \5247\6703\5C07\63A7\5236\9805\65B0\589E\81F3\5831\8868\8868\5C3E, \4EE5\8B93\4E00\822C\4F7F\7528\8005\524D\5F8C\700F\89BD\8CC7\6599\5217\96C6.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109461214500313722)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110131406643314257)
,p_name=>'PE.PROPERTY.IG_REGION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\65B9\683C\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109924803421314089)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\9810\5B58\5831\8868\7684\5225\540D. \60A8\53EF\4EE5\4F7F\7528\6B64\5225\540D\70BA\6B64\7279\5B9A\9810\5B58\5831\8868\5B9A\7FA9\8F03\6709\610F\7FA9\7684 URL \9023\7D50. \6B64\9023\7D50\53EF\7528\4F86\5F9E\61C9\7528\7A0B\5F0F\4E2D\7684\5176\4ED6\4F4D\7F6E\9032\884C\76F4\63A5\9023\7D50.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109923870300314089)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109924901848314090)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\9810\5B58\5831\8868\985E\5225, \6B64\985E\5225\898F\5B9A\6B64\5831\8868\5728\300C\5831\8868\300D\9078\53D6\6E05\55AE\5167\7684\986F\793A\4F4D\7F6E. \6B64\5C6C\6027\50C5\4F9B\6AA2\8996\800C\7121\6CD5\88AB\66F4\65B0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109924004482314089)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66FF\4EE3\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109924544757314089)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\5747\53EF\9078\53D6\958B\767C\4EBA\54E1\5132\5B58\7684\5F8C\7E8C\5831\8868\7248\9762\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109923961606314089)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109924447946314089)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\6703\986F\793A\958B\767C\4EBA\54E1\5132\5B58\7684\5831\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109924287813314089)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C08\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109924723247314089)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\6709\5132\5B58\5831\8868\7248\9762\914D\7F6E\7684\4E00\822C\4F7F\7528\8005\53EF\4EE5\9078\53D6\8A72\5831\8868\7248\9762\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109924122388314089)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109924656148314089)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\5176\4ED6\4E00\822C\4F7F\7528\8005\5747\53EF\9078\53D6\4E00\822C\4F7F\7528\8005\5132\5B58\7684\5831\8868\7248\9762\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109923777834314089)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\898B\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109466265197313726)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7FA4\7D44\7528\4F86\986F\793A\6B64\8CC7\6599\6B04\7684\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109466304385313726)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8C\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109466416260313726)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44\5C07\6703\540C\6642\986F\793A\5728\5831\8868\6A19\984C\548C\300C\55AE\4E00\8CC7\6599\5217\6AA2\8996\300D\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109466700425313726)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109466814356313726)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44\53EA\6703\986F\793A\5728\5831\8868\6A19\984C\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109466566997313726)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\55AE\4E00\8CC7\6599\5217\6AA2\8996')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109466619666313726)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44\53EA\6703\986F\793A\5728\300C\55AE\4E00\8CC7\6599\5217\6AA2\8996\300D\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109466120110313725)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\7FA4\7D44 - ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109329821733313622)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\5F71\50CF HTML \4E2D\6240\5305\62EC\7684\5F71\50CF\6A19\8A18\5C6C\6027. \9019\53EF\4EE5\7528\65BC\9AD8\5EA6\3001\5BEC\5EA6\6216\5F71\50CF ALT \6587\5B57 (\5982\679C\5F71\50CF\70BA\975E\88DD\98FE\578B\5F71\50CF) \4E4B\985E\7684\5C6C\6027.</p>'),
unistr('<p>\6CE8\610F: \5982\679C\5F71\50CF\6A19\8A18\5C6C\6027\4E2D\672A\5B9A\7FA9 ALT, &PRODUCT_NAME. \9810\8A2D\6703\5C07\5F71\50CF\5448\73FE\70BA\88DD\98FE\578B\5F71\50CF (\4F8B\5982, ALT \6A19\8A18\70BA\7A7A\767D).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109329732220313622)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF\6A19\8A18\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109598537905313828)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5C07\5831\8868\532F\51FA\6210 CSV \6216\9032\884C\5217\5370\6642\662F\5426\8981\5305\62EC\6B64\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109598410752313828)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\62EC\5728\532F\51FA/\5217\5370\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110110427881314241)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\5728\503C\6E05\55AE\7684\9802\7AEF\5305\62EC\7A7A\503C\9078\9805.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110110387861314241)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\62EC\7A7A\503C\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109450916466313714)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\61C9\9078\53D6\865B\64EC\8CC7\6599\6B04 ROWID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109450851400313714)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\62EC ROWID \8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109568344089313806)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\641C\5C0B\5217\6703\986F\793A\5728\5831\8868\7684\4E0A\65B9.  \5982\679C\5305\62EC\641C\5C0B\5217, \60A8\4E5F\53EF\4EE5\5B8C\5168\81EA\8A02\8981\986F\793A\7684\529F\80FD.</p>'),
unistr('\641C\5C0B\5217\53EF\4EE5\5305\62EC\4E0B\5217\5143\4EF6:'),
'<dl>',
unistr('  <dt>\641C\5C0B\6B04\4F4D</dt>'),
unistr('    <dd>\986F\793A\641C\5C0B\5217\4E2D\7528\4F86\8F38\5165\641C\5C0B\689D\4EF6\7684\6587\5B57\6B04\4F4D.</dd>'),
unistr('  <dt>\641C\5C0B\5668\4E0B\62C9\5F0F\6E05\55AE</dt>'),
unistr('    <dd>\5167\5D4C\5728<em>\641C\5C0B\6B04\4F4D</em>\5167, \6703\986F\793A\4E00\500B\5DF2\986F\793A\8CC7\6599\6B04\7684\4E0B\62C9\5F0F\6E05\55AE. \5982\679C\9078\53D6\4E86\67D0\500B\8CC7\6599\6B04, \5C07\53EA\6703\4F9D\64DA\6240\9078\8CC7\6599\6B04\4E2D\7684\503C\57F7\884C\641C\5C0B.</dd>'),
unistr('  <dt>\5831\8868\9078\53D6\6E05\55AE</dt>'),
unistr('    <dd>\986F\793A\4F7F\7528\8005\6240\6709\53EF\7528\5831\8868\7684\6E05\55AE, \5305\62EC\4E3B\8981\3001\66FF\4EE3\3001\516C\7528\53CA\5C08\7528\5831\8868. \53EA\6709\7576\4F7F\7528\8005\53EF\4EE5\5B58\53D6\4E3B\8981\5831\8868\4EE5\5916\7684\5831\8868\6642, \624D\6703\986F\793A\6B64\6E05\55AE.</dd>'),
unistr('  <dt>\6BCF\9801\8CC7\6599\5217\6578\9078\53D6\5668</dt>'),
unistr('    <dd>\986F\793A\7528\4F86\9078\53D6\6BCF\9801\8981\986F\793A\4E4B\8CC7\6599\5217\6578\76EE\7684\9078\53D6\6E05\55AE.</dd>'),
unistr('  <dt>\52D5\4F5C\529F\80FD\8868</dt>'),
unistr('    <dd>\986F\793A\300C\52D5\4F5C\300D\529F\80FD\8868\6309\9215, \6B64\529F\80FD\8868\4E00\822C\5305\62EC\4E00\7D44\5B8C\6574\7684\9078\9805. \9019\4E9B\9078\9805\53EF\8B93\4E00\822C\4F7F\7528\8005\6839\64DA\60A8\63D0\4F9B\7684\529F\80FD\81EA\8A02\5831\8868.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109568296370313806)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\62EC\641C\5C0B\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109239172676313549)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>&PRODUCT_NAME. \901A\5E38\9700\8981\7279\5B9A\7684 JavaScript \548C CSS \6A94\6848.'),
unistr('\5C0D\65BC\67D0\4E9B\61C9\7528\7A0B\5F0F (\4F8B\5982\884C\52D5\88DD\7F6E\61C9\7528\7A0B\5F0F), \60A8\53EF\80FD\6703\4E0D\5E0C\671B\5728\9801\9762\4E0A\5305\542B\9019\4E9B\6A94\6848.</p>'),
unistr('<p>\82E5\8981\5305\542B\6A19\6E96 &PRODUCT_NAME. \8207 JavaScript \6A94\6848, \8ACB\9078\53D6<strong>\958B\555F</strong>. \82E5\4E0D\8981\5728 HTML \6A19\982D\4E2D\5305\542B\9019\4E9B\6A94\6848, \8ACB\9078\53D6<strong>\95DC\9589</strong>.</p>'),
unistr('<p>\4E0D\5305\542B\9019\4E9B\6A94\6848\5C0D\65BC\61C9\7528\7A0B\5F0F\53EF\80FD\6709\4E0D\826F\5F71\97FF, \53EF\80FD\6703\4F7F\5F97\61C9\7528\7A0B\5F0F\505C\6B62\904B\4F5C.'),
unistr('\56E0\6B64, \53EA\5EFA\8B70\9032\968E\958B\767C\4EBA\54E1\505C\7528\6B64\5C6C\6027.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109239068546313549)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\62EC\6A19\6E96 JavaScript \548C CSS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109860827192314043)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\5167\542B\8D77\59CB\5730\5716\4F4D\7F6E\7684\8CC7\6599\6B04\4F5C\70BA GeoJSON \9EDE\7269\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109860701069314043)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('GeoJSON \8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109860602694314043)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\5167\542B\8D77\59CB\5730\5716\4F4D\7F6E\7684 SDO_GEOMETRY \8CC7\6599\6B04\4F5C\70BA\9EDE\7269\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109860554148314043)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E7E\4F55\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109859869584314043)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7528\65BC\8D77\59CB\5730\5716\4F4D\7F6E\7684\8CC7\6599\6B04\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109860111751314043)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109860264791314043)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('GeoJSON, \70BA VARCHAR2 \6216 CLOB \8CC7\6599\6B04\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109860313781314043)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D93\5EA6/\7DEF\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109860479677314043)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D93\5EA6\548C\7DEF\5EA6, \70BA\5169\500B NUMBER \8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109859937493314043)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'zh-tw'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109860062832314043)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle SDO_GEOMETRY \985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109859703170314043)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E7E\4F55\8CC7\6599\6B04\8CC7\6599\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109858795860314042)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\662F\5426\5C07\5730\5716\653E\5230\700F\89BD\5668\76EE\524D\4F4D\7F6E\7684\4E2D\592E. \5982\679C\555F\7528, \800C\4E14\700F\89BD\5668\80FD\5920\5B58\53D6\76EE\524D\7684\4F4D\7F6E, \9019\9805\8A2D\5B9A\7684\512A\5148\9806\5E8F\6703\9AD8\65BC\300C\975C\614B\503C\300D\3001\300CSQL \67E5\8A62\300D\6216\300C\6839\64DA\7A7A\9593\7D50\679C\300D\6240\8A2D\5B9A\7684\8D77\59CB\4F4D\7F6E.</p><p>\9019\53EA\9069\7528\65BC APEX \968E\6BB5\4F5C\696D\5167\7B2C\4E00\6B21\7684\9801\9762\8F09\5165. \8A72\5730\5716\9801\9762\5728 APEX \968E\6BB5\4F5C\696D\4E2D\91CD\65B0\700F\89BD\6642, \6703\5C07\5176\653E\5230\5B83\6700\5F8C\4E00\500B\4F4D\7F6E\7684\4E2D\592E.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109858694435314042)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\700F\89BD\5668\53D6\5F97\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109861216163314044)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\5167\542B\8D77\59CB\5730\5716\4F4D\7F6E\7DEF\5EA6\7684\8CC7\6599\6B04. \50B3\56DE\503C\5FC5\9808\5728 -90 \5230 90 \4E4B\9593.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109861190958314044)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D77\59CB\7DEF\5EA6\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109859480496314042)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8D77\59CB\5730\5716\4F4D\7F6E\7684\7DEF\5EA6. \4F7F\7528 -90 (\5357\65B9) \5230 90 (\5317\65B9) \4E4B\9593\7684\503C, \4EE5 "." \4F5C\70BA\5C0F\6578\9EDE\7B26\865F. \7BC4\4F8B: <strong>45.5</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109859390494314042)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DEF\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109861041785314043)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\5167\542B\8D77\59CB\5730\5716\4F4D\7F6E\7D93\5EA6\7684\8CC7\6599\6B04. \50B3\56DE\503C\5FC5\9808\5728 -180 \5230 180 \4E4B\9593.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109860932217314043)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D77\59CB\7D93\5EA6\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109859231948314042)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8D77\59CB\5730\5716\4F4D\7F6E\7684\7D93\5EA6. \4F7F\7528 -180 (\897F\65B9) \5230 180 (\6771\65B9) \4E4B\9593\7684\503C, \4EE5 "." \4F5C\70BA\5C0F\6578\9EDE\7B26\865F. \7BC4\4F8B: <strong>100.5</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109859198151314042)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D93\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109859045495314042)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5\4E0B\67E5\8A62\50B3\56DE NUMBER \8CC7\6599\6B04\4EE5\6C7A\5B9A\8D77\59CB\5730\5716\4F4D\7F6E\548C\7E2E\653E\7B49\7D1A:</p>'),
'<pre>',
'select -133.5 longituide,',
'         35.2 latitude,',
'            3 zoom',
'  from sys.dual',
'</pre>',
unistr('<p>\4EE5\4E0B\67E5\8A62\50B3\56DE SDO_GEOMETRY \8CC7\6599\6B04\4EE5\6C7A\5B9A\8D77\59CB\5730\5716\4F4D\7F6E, \50B3\56DE NUMBER \8CC7\6599\6B04\4EE5\6C7A\5B9A\7E2E\653E\7B49\7D1A.</p>'),
'<pre>',
'select sdo_geometry( 2001,                                 -- 2 dimensional point',
'                     4326,                                 -- longitude/latitude (WGS84)',
'                     sdo_point_type( -133.5, 35.2, null ), -- concrete coordinates',
'                     null,                                 -- not used for points',
'                     null                                  -- not used for points',
'       )                   as geometry,',
'       3                   as zoom',
'  from sys.dual',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109858965344314042)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7528\65BC\6C7A\5B9A\8D77\59CB\5730\5716\4F4D\7F6E\548C\7E2E\653E\7B49\7D1A\7684 SQL \67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109858803393314042)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109857916012314041)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5982\4F55\70BA\65B0 APEX \968E\6BB5\4F5C\696D\6216\5728\5730\5716\5340\57DF\7D93\904E<strong>\6E05\9664</strong>\6216<strong>\91CD\8A2D</strong>\4F5C\696D\4E4B\5F8C, \6C7A\5B9A\5176\8D77\59CB\7684\5730\5716\4F4D\7F6E\8207\7E2E\653E\7B49\7D1A. \5728 APEX \968E\6BB5\4F5C\696D\5167, \5730\5716\5340\57DF\6703\8A18\4F4F\6240\6709\9801\9762\8981\6C42\7684\76EE\524D\4F4D\7F6E\8207\7E2E\653E\7B49\7D1A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109858441119314042)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\7A7A\9593\7D50\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109858502340314042)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5730\5716\5B9A\4F4D\4EE5\986F\793A\5716\5C64\67E5\8A62\7D50\679C. <em>\8ACB\6CE8\610F, \5982\679C\9078\64C7 GeoJSON \4F5C\70BA\5716\5C64\5E7E\4F55\8CC7\6599\6B04\985E\578B, \5247\4E0D\652F\63F4\6B64\9078\9805</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109858273325314041)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109858349085314041)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\70BA\8D77\59CB\5730\5716\4F4D\7F6E\63D0\4F9B\50B3\56DE\503C\7684 SQL \67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109858044438314041)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109858170751314041)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\70BA\8D77\59CB\5730\5716\4F4D\7F6E\63D0\4F9B\975C\614B\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109857849142314041)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109861452871314044)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\5167\542B\8D77\59CB\7E2E\653E\7B49\7D1A\7684\8CC7\6599\6B04. \50B3\56DE\503C\5FC5\9808\5728 1 \5230 18 \4E4B\9593.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109861308389314044)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D77\59CB\7E2E\653E\7B49\7D1A\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109859621188314042)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8D77\59CB\7684\7E2E\653E\7B49\7D1A. \4F7F\7528 1 \5230 18 \4E4B\9593\7684\6574\6578\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109859565482314042)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E2E\653E\7B49\7D1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109747330073313959)
,p_name=>'PE.PROPERTY.INLINE_CSS.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5C07 CSS \985E\5225 <code>display_only</code> \8A2D\70BA\7C97\9AD4</dt>'),
'<dd><pre>',
'.display_only {',
'  font-weight: bold;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109234034559313546)
,p_name=>'PE.PROPERTY.INLINE_CSS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\9801\9762\4E0A\4F7F\7528\7684\300C\968E\5C64\5F0F\6A23\5F0F\8868 (CSS)\300D\7A0B\5F0F\78BC.'),
unistr('\5982\679C\8981\5728\591A\500B\9801\9762\4E0A\4F7F\7528\76F8\540C\7684 CSS, \8ACB\8003\616E\5C07\7A0B\5F0F\78BC\653E\5165\5916\90E8\6A94\6848\4EE5\907F\514D\91CD\8907, \4E26\5229\7528\700F\89BD\5668\975C\614B\6A94\6848\5FEB\53D6.</p>'),
unistr('<p>\60A8\5728\6B64\8655\8F38\5165\7684\7A0B\5F0F\78BC\6703\53D6\4EE3\9801\9762\6A23\677F\4E2D\7684 <code>#PAGE_CSS#</code> \66FF\4EE3\5B57\4E32.</p>'),
unistr('<p>\6CE8\610F: \60A8\4E0D\9700\8981\5305\62EC\958B\59CB\6216\7D50\675F\7684 <code>style</code> \6A19\8A18. \53EA\9700\8981\5305\62EC\968E\5C64\5F0F\6A23\5F0F\8868\7A0B\5F0F\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109233951175313545)
,p_name=>'PE.PROPERTY.INLINE_CSS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5D4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109242389974313552)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\9801\9762\767C\751F\932F\8AA4\6642\986F\793A\7684\932F\8AA4\8A0A\606F. \6B64\932F\8AA4\8A0A\606F\6703\66FF\4EE3\9801\9762\6A23\677F\4E2D\7684 <code>#NOTIFICATION_MESSAGE#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109242269034313552)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5D4C\932F\8AA4\901A\77E5\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110060351812314186)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\9805\76EE\7684\5167\5D4C\8AAA\660E\5167\5BB9. \9805\76EE\6703\7ACB\5373\986F\793A\6B64\8AAA\660E\5167\5BB9, \53EF\7528\65BC\63D0\4F9B\6B04\4F4D\5C64\7D1A\7684\76F8\95DC\5167\5BB9\8AAA\660E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110060208935314186)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5D4C\8AAA\660E\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109325895192313619)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\7576\968E\6BB5\4F5C\696D\7121\6548\6642, \8981\5C07 &PRODUCT_NAME. \91CD\65B0\5C0E\5411\81F3\4F55\8655.'),
unistr('\7576<strong>\611F\6E2C\51FD\6578</strong>\6216<strong>\9A57\8B49\51FD\6578</strong>\5C0D\4E00\822C\9801\9762\8981\6C42 (\800C\975E\5C0D Ajax \8981\6C42) \50B3\56DE FALSE \6642, \5C31\6703\767C\751F\6B64\60C5\6CC1.</p>'),
unistr('<p>\6CE8\610F: \5982\679C\4F7F\7528\7684\662F<strong>\81EA\8A02</strong>\8A8D\8B49\914D\7F6E\985E\578B, \5247\4E5F\53EF\4EE5\5229\7528\8A8D\8B49\914D\7F6E\4E2D\7684<strong>\611F\6E2C\51FD\6578</strong>\5C6C\6027.'),
unistr('\4EE5 Plug-in \8A8D\8B49\914D\7F6E\985E\578B\4F86\8AAA, \9019\662F\7531 Plug-in \958B\767C\4EBA\54E1\5728<strong>\968E\6BB5\4F5C\696D\611F\6E2C\51FD\6578\540D\7A31</strong>\56DE\547C\4E2D\5B9A\7FA9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109760389372313968)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5EFA\7684\767B\5165\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109760486626313969)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3 &PRODUCT_NAME. \6240\63D0\4F9B <code>wwv_flow_custom_auth_std.login_page</code> \4E2D\5B9A\7FA9\7684 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109760141662313968)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\5165\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109760238658313968)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\61C9\7528\7A0B\5F0F\5C6C\6027\4E2D\5B9A\7FA9\7684\767B\5165 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109760531348313969)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109760667803313969)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\60A8\8F38\5165\7684 URL, \4F8B\5982 <code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109325724970313619)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\968E\6BB5\4F5C\696D\91CD\65B0\5C0E\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109326038405313619)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7576\968E\6BB5\4F5C\696D\611F\6E2C\51FD\6578\50B3\56DE FALSE \6642, \8981\5C07 &PRODUCT_NAME. \91CD\65B0\5C0E\5411\81F3\54EA\500B URL. \9019\4E00\822C\6703\662F\767B\5165\9801\9762\6216\55AE\4E00\767B\5165\5165\53E3\7DB2\7AD9\7684 URL. \4F8B\5982, f?p=&amp;APP_ID.:101:&amp;SESSION')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109325967857313619)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\968E\6BB5\4F5C\696D URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109567013099313805)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\5B9A\7FA9\8CC7\6599\6B04\503C\986F\793A\65B9\5F0F\7684\76F8\95DC\8CC7\6599\6B04\986F\793A\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109767037094313974)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09 BLOB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109951331383314108)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8CC7\6599\6B04\986F\793A\70BA\9023\7D50\4EE5\4E0B\8F09\6A94\6848.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109767309043313974)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF\7684\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109951634859314109)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\986F\793A\8CC7\6599\6B04, \4F46\53EF\53C3\7167\8A72\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109766946313313973)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.IMAGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109951260056314108)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8CC7\6599\6B04\986F\793A\70BA\5F71\50CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109766875250313973)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.LINK.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109951135281314108)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.LINK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8CC7\6599\6B04\986F\793A\70BA\9023\7D50.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109767128384313974)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767E\5206\6BD4\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109951400340314108)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8CC7\6599\6B04\986F\793A\70BA\767E\5206\6BD4\5716\8868. \64F7\53D6\7684\503C\5FC5\9808\4ECB\65BC 0 \5230 100 \4E4B\9593.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109766676428313973)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D14\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109950907377314108)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\8CC7\6599\6B04\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109766702980313973)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D14\6587\5B57 (\4EE5\503C\6E05\55AE\70BA\57FA\790E)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109951059361314108)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5F9E\6307\5B9A\503C\6E05\55AE\50B3\56DE\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110023462570314160)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.RICH_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Rich Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110023508907314160)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.RICH_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528 HTML \6216 Markdown \5448\73FE\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109767259142313974)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.STRIP_HTML.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664 HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109951599176314109)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.STRIP_HTML.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\79FB\9664 HTML \6A19\8A18\548C\9041\96E2\7279\6B8A\5B57\5143\5F8C\7684\8CC7\6599\6B04\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109566964028313805)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109651226588313871)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\82E5\8981\50B3\56DE\90E8\9580\540D\7A31:</dt>'),
'<dd><pre>select dname from dept order by 1</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109585316978313818)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\9700\8981\50B3\56DE\4E00\500B\8CC7\6599\6B04\7684 SQL \67E5\8A62. \5982\679C\67E5\8A62\50B3\56DE\591A\500B\8CC7\6599\6B04, \503C\6E05\55AE\4E2D\53EA\6703\4F7F\7528\7B2C\4E00\500B\8CC7\6599\6B04.</p>'),
unistr('<p>\8F38\5165 SQL \67E5\8A62\53EF\4EE5\6539\9032\67D0\4E9B\5831\8868\7684\6548\80FD, \6216\53EF\4EE5\7528\4F86\9650\5236\986F\793A\7684\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109585210091313818)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109704703971313925)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\4E00\4EFD\5B9A\7FA9\7684\5177\540D\503C\6E05\55AE. \8CC7\6599\6B04\7BE9\9078\53EA\6703\4F7F\7528\52D5\614B\503C\6E05\55AE\67E5\8A62\7684\7B2C\4E00\500B\8CC7\6599\6B04\6216\975C\614B\503C\6E05\55AE\7684\986F\793A\503C\4F86\7BE9\9078\5831\8868\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109704673099313925)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5177\540D\7684 LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109565805767313804)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\5982\4F55\884D\751F\5831\8868\8CC7\6599\6B04\4E0B\62C9\5F0F\6E05\55AE\4E2D\63D0\4F9B\7684\7BE9\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109768842886313975)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\5177\540D\7684\503C\6E05\55AE\7BE9\9078\5B8C\5168\76F8\7B26\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109768936013313975)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5177\540D\7684\503C\6E05\55AE\884D\751F\503C\6E05\55AE, \4EE5\5EFA\7ACB\7B49\65BC\7BE9\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109769012427313975)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\5177\540D\7684\503C\6E05\55AE\7BE9\9078\5305\542B\7684\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109769124573313975)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5177\540D\7684\503C\6E05\55AE\884D\751F\503C\6E05\55AE, \4EE5\5EFA\7ACB\5305\542B\7BE9\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109768612371313975)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\5B9A\7FA9\7684\503C\6E05\55AE\7BE9\9078\5305\542B\7684\6587\5B57')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109768726977313975)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5B9A\7FA9\7684\503C\6E05\55AE SQL \67E5\8A62\884D\751F\503C\6E05\55AE, \4EE5\5EFA\7ACB\5305\542B\7BE9\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109768276269313974)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\8CC7\6599\6B04\985E\578B\9810\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109768370948313975)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('STRING \8207 NUMBER \8CC7\6599\6B04\53EF\5F9E\4E0D\540C\7684\8CC7\6599\6B04\503C\884D\751F\503C\6E05\55AE. DATE \8CC7\6599\6B04\5F9E\9810\5148\5B9A\7FA9\7684\65E5\671F\7BC4\570D\884D\751F\503C\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109768099143313974)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109768171759313974)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\63D0\4F9B\7D66\6B64\5831\8868\7684\8CC7\6599\6B04\7BE9\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109768432864313975)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\5B9A\7FA9\7684\503C\6E05\55AE\7BE9\9078\5B8C\5168\76F8\7B26\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109768596735313975)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5B9A\7FA9\7684\503C\6E05\55AE SQL \67E5\8A62\884D\751F\503C\6E05\55AE, \4EE5\5EFA\7ACB\7B49\65BC (\5B8C\5168\76F8\7B26) \7BE9\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109565729508313804)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109566848320313804)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\8CC7\6599\6B04\7684\7FA4\7D44. \60A8\53EF\4EE5\4F7F\7528\7FA4\7D44, \5728\300C\55AE\4E00\8CC7\6599\5217\6AA2\8996\300D\4E2D\4EE5\908F\8F2F\7FA4\7D44\65B9\5F0F\986F\793A\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109566764481313804)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109570758556313807)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\6B64\5831\8868\7684\9023\7D50\8CC7\6599\6B04\985E\578B.'),
unistr('\5982\679C\9078\53D6\9023\7D50\8CC7\6599\6B04, \5B83\5C07\4E00\5F8B\986F\793A\70BA\5831\8868\4E2D\7684\7B2C\4E00\500B\8CC7\6599\6B04, \4E14\7121\6CD5\88AB\4F7F\7528\8005\96B1\85CF.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109771073243313977)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\81F3\81EA\8A02\76EE\6A19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109771135436313977)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\6703\6839\64DA\60A8\8F38\5165\7684\76EE\6A19 URL \800C\88AB\5C0E\81F3\5176\4ED6\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109771266377313977)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\9664\9023\7D50\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109771313424313977)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\8CC7\6599\6B04\4E0D\6703\986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109770847438313976)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\81F3\55AE\4E00\8CC7\6599\5217\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109770958034313977)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\6703\88AB\5C0E\81F3\986F\793A\6307\5B9A\8CC7\6599\5217\4E4B\8CC7\6599\6B04\503C\7684\9801\9762. \8981\986F\793A\54EA\4E9B\8CC7\6599\6B04\53CA\5176\986F\793A\7684\65B9\5F0F\5247\662F\7531\5404\7A2E\5831\8868\8207\8CC7\6599\6B04\5C6C\6027\6240\63A7\5236.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109570686955313807)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109617309445313846)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.COMPONENT_PROPERTY.IR_ATTRIBUTES.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109568564896313806)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\6B64\5831\8868\7684\5206\9801\985E\578B. \901A\5E38\9801\9762\4E0A\53EA\6703\986F\793A\7279\5B9A\6578\76EE\7684\5831\8868\8CC7\6599\5217.'),
unistr('\82E5\8981\5305\62EC\5176\4ED6\8CC7\6599\5217, \61C9\7528\7A0B\5F0F\4E00\822C\4F7F\7528\8005\5FC5\9808\700F\89BD\81F3\5831\8868\7684\4E0B\4E00\9801.</p>'),
unistr('<p>\5206\9801\6703\5C0D\4E00\822C\4F7F\7528\8005\63D0\4F9B\7D50\679C\96C6\5167\8CC7\6599\5217\6578\76EE\548C\76EE\524D\4F4D\7F6E\7684\76F8\95DC\8CC7\8A0A.</p>'),
unistr('<p>\5206\9801\53EF\4EE5\986F\793A\5728\5831\8868\7684\4E0A\65B9\6216\4E0B\65B9 (\6216\4E0A\4E0B\65B9\90FD\986F\793A), \4E5F\53EF\4EE5\7F6E\65BC\5DE6\908A\6216\53F3\908A.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109769821382313976)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\7BC4\570D X \5230 Y')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109769767131313976)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\7BC4\570D X \5230 Y, \5171 Z \500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109568490430313806)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109583059796313816)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\9810\5B58\5831\8868\7684\5225\540D. \60A8\53EF\4EE5\4F7F\7528\6B64\5225\540D\70BA\6B64\7279\5B9A\9810\5B58\5831\8868\5B9A\7FA9\8F03\6709\610F\7FA9\7684 URL \9023\7D50. \6B64\9023\7D50\53EF\7528\4F86\5F9E\61C9\7528\7A0B\5F0F\4E2D\7684\5176\4ED6\4F4D\7F6E\9032\884C\76F4\63A5\9023\7D50.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109582946088313816)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109583446900313817)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\9810\5B58\5831\8868\985E\5225, \6B64\985E\5225\898F\5B9A\6B64\5831\8868\5728\300C\5831\8868\300D\9078\53D6\6E05\55AE\5167\7684\986F\793A\4F4D\7F6E. \6B64\5C6C\6027\50C5\4F9B\6AA2\8996\800C\7121\6CD5\88AB\66F4\65B0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109773450693313978)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66FF\4EE3\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109951886367314109)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\5747\53EF\9078\53D6\958B\767C\4EBA\54E1\5132\5B58\7684\5F8C\7E8C\5831\8868\7248\9762\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109773334192313978)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109951774314314109)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\6703\986F\793A\958B\767C\4EBA\54E1\5132\5B58\7684\5831\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109773676089313979)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C08\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109952046612314109)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\6709\5132\5B58\5831\8868\7248\9762\914D\7F6E\7684\4E00\822C\4F7F\7528\8005\53EF\4EE5\9078\53D6\8A72\5831\8868\7248\9762\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109773552034313978)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109951984786314109)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\5176\4ED6\4E00\822C\4F7F\7528\8005\5747\53EF\9078\53D6\4E00\822C\4F7F\7528\8005\5132\5B58\7684\5831\8868\7248\9762\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109583388049313817)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\898B\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109417397047313688)
,p_name=>'PE.PROPERTY.IS_EDITABLE.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\7DE8\8F2F\6B64\8868\55AE\5340\57DF.</p>'),
unistr('        <p>\6CE8\610F - \8868\55AE\5340\57DF\82E5\8A2D\70BA\53EF\7DE8\8F2F, \7CFB\7D71\5C31\6703\81EA\52D5\5EFA\7ACB\8655\7406\4F5C\696D\4F86\8655\7406\8CC7\6599\5217.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109458212931313720)
,p_name=>'PE.PROPERTY.IS_EDITABLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\7DE8\8F2F\6B64\4E92\52D5\5F0F\65B9\683C.</p>'),
unistr('        <p>\6CE8\610F - \4E92\52D5\5F0F\65B9\683C\82E5\8A2D\70BA\53EF\7DE8\8F2F, \7CFB\7D71\5C31\6703\81EA\52D5\5EFA\7ACB\8655\7406\4F5C\696D\4F86\8655\7406\8CC7\6599\5217.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109458189117313720)
,p_name=>'PE.PROPERTY.IS_EDITABLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110056168656314183)
,p_name=>'PE.PROPERTY.IS_GLOBAL_PAGE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F\5168\57DF\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109471995175313730)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8CC7\6599\6B04\662F\5426\70BA\57FA\790E\8868\683C\7684\5176\4E2D\4E00\500B\4E3B\7D22\5F15\9375\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109471830730313730)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\7D22\5F15\9375')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109471784628313730)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\4E0D\8B93\8CC7\6599\6B04\9032\884C DML \4F5C\696D.</p>'),
unistr('        <p>\82E5\8A2D\70BA<strong>\958B\555F</strong>, &PRODUCT_NAME. \5C07\4E0D\6703\5728\57F7\884C\300C\4E92\52D5\5F0F\65B9\683C - \81EA\52D5\8CC7\6599\5217\8655\7406 (DML)\300D\6642\4F7F\7528\8CC7\6599\6B04.'),
unistr('        \4F8B\5982, \4E0D\8981\5305\62EC\5176\5B9A\7FA9\5305\542B\4E32\63A5\3001\5167\90E8\9078\53D6\3001\51FD\6578\547C\53EB\7684\8CC7\6599\6B04, \6216\662F\4EE5\8868\793A\5F0F\70BA\57FA\790E\4E4B\53EF\66F4\65B0\8996\89C0\8868\4E2D\7684\8CC7\6599\6B04.</p>'),
unistr('        <p>INSERT \6216 UPDATE \6558\8FF0\53E5\4E2D\9700\8981\5305\62EC\4E4B\6240\6709\8CC7\6599\6B04\7684\9019\500B\9078\9805\90FD\5FC5\9808\8A2D\70BA<strong>\95DC\9589</strong>.</p>'),
unistr('        <p>\6CE8\610F: \9664\975E<strong>\958B\555F</strong>\6B64\9078\9805, \5426\5247\300C\81EA\52D5\8CC7\6599\5217\8655\7406\300D\4E2D<u>\4E5F\6703</u>\5305\62EC<em>\50C5\986F\793A</em>\985E\578B\7684\8CC7\6599\6B04.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109471666193313730)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\4F9B\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109552773279313790)
,p_name=>'PE.PROPERTY.IS_STATIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\53C3\6578\53EA\80FD\4F7F\7528\975C\614B\503C\8A2D\5B9A\4E00\6B21, \6216\53EF\4EE5\5728\5143\4EF6\5C64\7D1A\52A0\4EE5\8986\5BEB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109552686055313790)
,p_name=>'PE.PROPERTY.IS_STATIC.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109904429840314075)
,p_name=>'PE.PROPERTY.IS_VISIBLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\986F\793A\6216\96B1\85CF\6B64\8CC7\6599\6B04. \5373\4F7F\96B1\85CF, \8CC7\6599\6B04\4E00\5F8B\53EF\4EE5\4F7F\7528\66FF\4EE3\8A9E\6CD5 <code>&amp;COLUMN_NAME.</code>\9032\884C\53C3\7167.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109904316580314075)
,p_name=>'PE.PROPERTY.IS_VISIBLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109444867328313709)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7528\65BC\6B64\5716\8868\4E0A\5B9A\7FA9\9AD8\503C\7684\8CC7\6599\6B04\540D\7A31. \82E5\672A\9078\53D6\8CC7\6599\6B04, \5247\7BB1\5F62\5716\7684\6700\9AD8\503C\5C07\6703\4EE5\6B64\8CC7\6599\96C6\70BA\4F9D\64DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109444698911313709)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9AD8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109444718770313709)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7528\65BC\6B64\5716\8868\4E0A\5B9A\7FA9\4F4E\503C\7684\8CC7\6599\6B04\540D\7A31. \82E5\672A\9078\53D6\8CC7\6599\6B04, \5247\7BB1\5F62\5716\7684\6700\4F4E\503C\5C07\6703\4EE5\6B64\8CC7\6599\96C6\70BA\4F9D\64DA. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109444525360313709)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109519760401313765)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7528\65BC\6B64\5716\8868\4E0A\5B9A\7FA9\6536\76E4\50F9\7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109519637153313765)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6536\76E4\50F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109519339319313765)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\6B64\5716\8868\9AD8\503C\7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109519238785313765)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9AD8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109521389922313766)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\5716\8868 x \8EF8\6A19\7C64\7684\8CC7\6599\6B04\540D\7A31. \82E5\70BA\80A1\7968\5206\6790\5716, \8CC7\6599\6B04\7684\8CC7\6599\985E\578B\5FC5\9808\70BA\300C\65E5\671F/\6642\6233\300D, \624D\80FD\5448\73FE\6642\9593\8EF8\4E0A\7684\80A1\7968\8CC7\8A0A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109521235636313766)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109350575043313637)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.COMPONENT_PROPERTY.JET_CHART_SERIES.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'font-size:14px;color:white;</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109526764124313770)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8F38\5165 CSS \6A23\5F0F\5B57\4E32, \4EE5\5B9A\7FA9\5716\8868\7684\6A19\7C64\6A23\5F0F.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109526685449313770)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSS \6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109550985140313789)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5C0D\65BC\7BC4\570D\6578\5217, \5982\679C\63D0\4F9B\5169\500B\503C\7684\9663\5217, \7B2C\4E00\548C\7B2C\4E8C\500B\503C\5C07\5206\5225\5957\7528\81F3\4F4E\9EDE\548C\9AD8\9EDE. <strong>\5207\7247\5916\5074</strong>\503C\50C5\9069\7528\65BC\5713\9905\5716.'),
unistr('        <strong>\6A19\8A18\4E0A\65B9</strong>\3001<strong>\6A19\8A18\4E0B\65B9</strong>\3001<strong>\6A19\8A18\4E4B\524D</strong>\548C<strong>\6A19\8A18\4E4B\5F8C</strong>\503C\50C5\9069\7528\65BC\6298\7DDA\5716\3001\5340\57DF\5716\3001\6563\5E03\5716\548C\6CE1\6CE1\5716\6578\5217. <strong>\9577\689D\908A\7DE3\5167\5074</strong>\548C<strong>\9577\689D\908A\7DE3\5916\5074</strong>\503C'),
unistr('        \50C5\9069\7528\65BC\975E\6975\6027\9577\689D\5716\6578\5217. \5806\758A\9577\689D\5716\4E0D\652F\63F4<strong>\9577\689D\908A\7DE3\5916\5074</strong>. <strong>\958B\59CB</strong>\503C\50C5\9069\7528\65BC\6C34\5E73\548C\5782\76F4\72C0\614B\8A08\91CF\91CF\8868\5716. \6B64\5716\8868\76EE\524D\5C1A\672A\4F9D\64DA\7E6A\5716\5340\5167\7684\6A19\7C64\8ABF\6574\7248\9762\914D\7F6E, \6216\8655\7406\6A19\7C64\4E4B\9593\7684\91CD\758A\60C5\5F62.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109525707666313769)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5716\8868\6A19\7C64\7684\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109525901031313770)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.ABOVEMARKER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\8A18\4E0A\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109526205392313770)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AFTERMARKER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\8A18\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109526532828313770)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AUTO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109526174416313770)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BEFOREMARKER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\8A18\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109526065734313770)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BELOWMARKER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\8A18\4E0B\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109525886831313770)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.CENTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7F6E\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109526338969313770)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.INSIDEBAREDGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\689D\908A\7DE3\5167\5074')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109550389654313788)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.NONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109526430950313770)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDEBAREDGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\689D\908A\7DE3\5916\5074')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109550277868313788)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDESLICE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5207\7247\5916\5074')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108986116269313355)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.START.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109525657259313769)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109525509122313769)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\61C9\8A72\5728\5716\8868\4E0A\5448\73FE\6A19\7C64. \6B64\8A2D\5B9A\9069\7528\65BC\8A08\91CF\5716\4E0A\5EA6\91CF\503C\7684\53EF\898B\6027. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109525493668313769)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109519123550313764)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\6B64\5716\8868\4F4E\503C\7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109519030836313764)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109520711929313766)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\6B64\5716\8868\6700\5927\503C\7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109520623495313766)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5927\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109622623438313850)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\6B64\5716\8868\6700\5C0F\503C\7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109622549404313849)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5C0F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109519525989313765)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7528\65BC\6B64\5716\8868\4E0A\5B9A\7FA9\958B\76E4\50F9\7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109519411827313765)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\76E4\50F9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109521583726313766)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7528\65BC\5B9A\7FA9\5716\8868\8CC7\6599\9EDE\7C21\77ED\63CF\8FF0\6027\81EA\8A02\5DE5\5177\63D0\793A\7684\8CC7\6599\6B04\540D\7A31. \82E5\8981\5728\5716\8868\8CC7\6599\9EDE\4E0A\5448\73FE\5DE5\5177\63D0\793A, \8ACB\78BA\5B9A\5716\8868\5DE5\5177\63D0\793A\5C6C\6027<strong>\986F\793A</strong>\5FC5\9808\8A2D\70BA<strong>\958B\555F</strong>. \82E5\70BA\7BB1\5F62\5716, \6B64\8CC7\6599\6B04\4E0D\61C9\8207\9078\53D6\7684\300C\503C\300D\8CC7\6599\6B04\5C0D\61C9\76F8\7B26. \82E5\9078\53D6\7684\8CC7\6599\6B04\548C\300C\503C\300D\8CC7\6599\6B04\5C0D\61C9\76F8\7B26, \5716\8868\4E0A\5C07\4E0D\6703\5448\73FE\81EA\8A02\5DE5\5177\63D0\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109521451441313766)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\5DE5\5177\63D0\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109520549619313765)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7528\65BC\5B9A\7FA9\6B64\5716\8868\4E0A\76EE\6A19\503C\7684\8CC7\6599\6B04\540D\7A31. \8A2D\5B9A\6642, \503C\5C6C\6027\6703\5B9A\7FA9\5207\7247\5167\7684\586B\6EFF\5340\57DF, \800C\4E14\9019\4EE3\8868\6574\500B\5207\7247\7684\503C. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109520445302313765)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\6A19\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109518929014313764)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7528\65BC\6B64\5716\8868\4E0A\5B9A\7FA9\503C\7684\8CC7\6599\6B04\540D\7A31. \82E5\70BA\7BB1\5F62\5716, \6B64\8CC7\6599\6B04\5C07\7528\65BC\5B9A\7FA9\6578\503C\8CC7\6599\96C6\7684\6700\5C0F\503C\3001\56DB\5206\4F4D\6578\3001\4E2D\9593\503C\548C\6700\5927\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109518837307313764)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109519992124313765)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\6B64\5716\8868\6210\4EA4\91CF\7684\8CC7\6599\6B04\540D\7A31. \63D0\4F9B\503C\6642, \6703\5728 y2 \5EA7\6A19\8EF8\4E0A\986F\793A\6210\4EA4\91CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109519820801313765)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\4EA4\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109520189236313765)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\6B64\5716\8868 x \503C\7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109520002634313765)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>'X'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109520367304313765)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\6B64\5716\8868 y \503C\7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109520222691313765)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109517783252313763)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7528\65BC\6B64\5716\8868\4E0A\5B9A\7FA9 z \503C\7684\8CC7\6599\6B04\540D\7A31. z \503C\5B9A\7FA9\6CE1\6CE1\5716\7684\6CE1\6CE1\534A\5F91\3001\7BB1\5F62\5716\9805\76EE\7684\5BEC\5EA6\4EE5\53CA\9577\689D\5716\6216\7D44\5408\5716\7684\9577\689D\5BEC\5EA6. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109517684273313763)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>'Z'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109329259342313622)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\5728\4E3B\8981\5340\57DF\5167\5BB9\7684\4E0A\65B9\6216\4E0B\65B9\986F\793A\5340\57DF\5143\4EF6 (\5B50\5340\57DF\3001\9805\76EE\3001\6309\9215).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109761442669313969)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.ABOVE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5BB9\4E0A\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109761582421313969)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.BELOW.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5BB9\4E0B\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109329167150313621)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109263893977313568)
,p_name=>'PE.PROPERTY.ITEM_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\9805\76EE\7684\540D\7A31. \9805\76EE\540D\7A31\5FC5\9808\662F\6709\6548\7684 Oracle ID. \5EFA\8B70\9805\76EE\540D\7A31\4E0D\8981\8D85\904E 30 \500B\4F4D\5143\7D44, \5982\6B64\624D\80FD\5728 SQL \67E5\8A62\4E2D\5C07\9805\76EE\540D\7A31\7576\4F5C\9023\7D50\8B8A\6578\4F7F\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109263765169313568)
,p_name=>'PE.PROPERTY.ITEM_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109475145815313732)
,p_name=>'PE.PROPERTY.ITEM_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\6B64\8CC7\6599\6B04\7684\5448\73FE\65B9\5F0F. \4EE5\4E0B\662F\652F\63F4\7684\8CC7\6599\6B04\985E\578B:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\8996\60A8\7684\61C9\7528\7A0B\5F0F\7D44\614B\800C\5B9A, \6B64\8655\53EF\80FD\6703\63D0\4F9B\60A8\5176\4ED6\8CC7\6599\6B04\985E\578B Plug-in.'),
unistr('\9019\4E9B\6703\986F\793A\70BA <em>&lt;My Plug-in&gt; [Plug-in]</em>.'),
unistr('\4E0B\5217 Plug-in \6703\5B89\88DD\5728\6B64\61C9\7528\7A0B\5F0F\7684\5171\7528\5143\4EF6\4E2D:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109263442734313567)
,p_name=>'PE.PROPERTY.ITEM_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5982\4F55\5448\73FE\6B64\9805\76EE. \652F\63F4\4E0B\5217\9805\76EE\985E\578B:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\6839\64DA\60A8\61C9\7528\7A0B\5F0F\7D44\614B\7684\4E0D\540C, \6B64\8655\53EF\80FD\53E6\6709\5176\4ED6\9805\76EE\985E\578B Plug-in.'),
unistr('\9019\4E9B\6703\986F\793A\70BA<em>&lt;\6211\7684 Plug-in&gt; [Plug-in]</em>.'),
unistr('\4E0B\5217 Plug-in \5B89\88DD\5728\6B64\61C9\7528\7A0B\5F0F\5171\7528\5143\4EF6\5167:</p>'),
'#CUSTOM_PLUGINS#'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109263314074313567)
,p_name=>'PE.PROPERTY.ITEM_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109922825010314088)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9810\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109943928890314103)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\672A\5132\5B58\8B8A\66F4\6AA2\67E5\5728\9801\9762\5C64\7D1A\555F\7528, \6AA2\67E5\6703\5305\62EC\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109922373716314088)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\672A\5132\5B58\8B8A\66F4\6AA2\67E5\662F\5426\5305\62EC\9801\9762\9805\76EE, \7576\4F7F\7528\8005\5617\8A66\96E2\958B\6709\5C1A\672A\5132\5B58\4E4B\8B8A\66F4\7684\9801\9762\6642, \672A\5132\5B58\8B8A\66F4\6AA2\67E5\6703\5C0D\4F7F\7528\8005\767C\51FA\8B66\544A. \67D0\4E9B\9805\76EE\53EF\80FD\4E26\4E0D\9700\8981\6AA2\67E5 (\4F8B\5982\4E0D\662F\4EE5\8CC7\6599\5EAB\8CC7\6599\6B04\70BA\57FA\790E\7684\9805\76EE, \50CF\662F\641C\5C0B\9805\76EE), \56E0\6B64\53EF\4EE5\8A2D\70BA\5FFD\7565.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109922423602314088)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FFD\7565')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109925260091314090)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5132\5B58\7684\8B8A\66F4\6AA2\67E5\6703\5FFD\7565\5C0D\9805\76EE\7684\8B8A\66F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109922290848314088)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5132\5B58\8B8A\66F4\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110067125456314191)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.toolbar = false;',
'    return options;',
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109485693843313740)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4E00\500B\53EF\64F7\53D6\300C\4E92\52D5\5F0F\65B9\683C\300D\7684\7D44\614B\7269\4EF6\3001\4FEE\6539\7269\4EF6\4E26\50B3\56DE\8A72\7269\4EF6\7684 JavaScript \51FD\6578. \9019\53EF\4EE5\9032\4E00\6B65\81EA\8A02\300C\4E92\52D5\5F0F\65B9\683C\300D\5916\89C0\3001\529F\80FD\8207\884C\70BA (\5305\62EC\5DE5\5177\5217\3001\529F\80FD\8868\4EE5\53CA\52D5\4F5C).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110067232068314191)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.features = options.features || {};',
'    options.features.sort = false;',
'    return options;',
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109621987709313849)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4E00\500B\53EF\64F7\53D6\8CC7\6599\6B04\7684\7D44\614B\7269\4EF6\3001\4FEE\6539\7269\4EF6\4E26\50B3\56DE\8A72\7269\4EF6\7684 JavaScript \51FD\6578. \9019\53EF\4EE5\9032\4E00\6B65\81EA\8A02\8CC7\6599\6B04\7684\5916\89C0\3001\529F\80FD\8207\884C\70BA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110067338913314191)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.JET_CHART.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ){',
unistr('    // \8A2D\5B9A\8CC7\6599\64F7\53D6\5F8C\8981\547C\53EB\7684\56DE\547C\51FD\6578, \4EE5\4FBF\64CD\63A7\6578\5217'),
'    options.dataFilter = function( data ) {',
'        data.series[ 0 ].color = "#00FF00";',
'        return data;',
'    };',
unistr('    // \8A2D\5B9A\5716\8868\521D\59CB\5316\9078\9805'),
'    options.type = "line";',
'    return options;',
'}</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109531385408313774)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8F38\5165\7528\4EE5\81EA\8A02\5716\8868\7684 JavaScript \7A0B\5F0F\78BC.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110067903412314191)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'  options.advancedOption = true;',
'  return options;',
'}',
'</pre>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109465655561313725)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8F38\5165\4E00\500B\53EF\64F7\53D6\5143\4EF6\7684\7D44\614B\7269\4EF6\3001\4FEE\6539\7269\4EF6\4E26\50B3\56DE\8A72\7269\4EF6\7684 JavaScript \51FD\6578. \9019\53EF\4EE5\9032\4E00\6B65\81EA\8A02\5143\4EF6\7684\5916\89C0\3001\529F\80FD\8207\884C\70BA.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109465591638313725)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \521D\59CB\5316\7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109836670186314026)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5716\8868\4E3B\8981\548C\6B21\8981\5EA7\6A19\8EF8\7684\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109837385890314026)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.BOTTOM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E95\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109837215304314026)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.TOP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9802\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109836506748314026)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EA7\6A19\8EF8\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109840149864314028)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5716\8868\5EA7\6A19\8EF8\4F7F\7528\7684\6642\9593\523B\5EA6. \5FC5\9808\63D0\4F9B\6642\9593\523B\5EA6, \624D\80FD\6B63\78BA\5448\73FE\7518\7279\5716. \82E5\672A\9078\53D6\300C\7E2E\653E\6BD4\4F8B\300D\9078\9805, \5247\5C07\4EE5\9019\9805\6642\9593\523B\5EA6\9032\884C\7E2E\653E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109838217123314027)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.DAYS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109838109867314027)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.HOURS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109837865835314026)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MINUTES.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\9418')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109838686737314027)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MONTHS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109838898125314027)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.QUARTERS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B63')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109837793964314026)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.SECONDS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109838429651314027)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.WEEKS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109839081005314027)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.YEARS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109840080967314028)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\6578\4F4D\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109506336941313755)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5716\8868\985E\578B. \5716\8868\985E\578B\6703\5224\65B7\7528\4F86\5448\73FE\5716\8868\7684\8996\89BA\5316.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109506409930313755)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109647196217313867)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\5716\9069\7528\65BC\6BD4\8F03\4E00\6BB5\6642\9593\4E4B\7D2F\8A08\503C\7684\8DA8\52E2, \4F8B\5982\92B7\552E\8DA8\52E2\7684\660E\7D30.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109506530424313755)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\689D\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109647261585313868)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\689D\5716\9069\7528\65BC\6BD4\8F03\6240\6709\985E\5225\6216\4E00\6BB5\6642\9593\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109428020236313696)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BB1\5F62\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109428129540313696)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BB1\5F62\5716\5C0D\65BC\5206\6790\8CC7\6599\5206\5E03\53CA\986F\793A\6578\503C\8CC7\6599\7FA4\7D44\4E2D\7684\6700\5C0F\503C\3001\56DB\5206\4F4D\6578\3001\4E2D\9593\503C\548C\6700\5927\503C, \975E\5E38\5BE6\7528. \7BB1\5F62\5716\53C8\7A31\70BA\76D2\9B1A\5716.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109506639000313755)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6CE1\6CE1\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109647338638313868)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6CE1\6CE1\5716\4F7F\7528 x\3001y \4EE5\53CA z \503C\4F86\5B9A\7FA9\8CC7\6599\9805\76EE, \9069\7528\65BC\6AA2\8996 3 \500B\7DAD\5EA6\4E4B\9593\7684\95DC\4FC2. \7B2C 3 \500B\7DAD\5EA6\4EE5\6CE1\6CE1\7684\5927\5C0F\8868\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109506765216313755)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\5408\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109647491400313868)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D44\5408\5716\53EF\5728\540C\4E00\4EFD\5716\8868\4E0A\986F\793A\9577\689D\3001\6298\7DDA\4EE5\53CA\5340\57DF\6578\5217. \6700\5E38\898B\7684\4F7F\7528\60C5\6CC1\70BA\6298\7DDA\642D\914D\9577\689D\6216\6298\7DDA\642D\914D\5806\758A\9577\689D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109506820630313755)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\72C0\614B\5100\8868\91CF\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109647540048313868)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\72C0\614B\8A08\91CF\91CF\8868\4E3B\8981\7528\65BC\986F\793A\67D0\500B\5EA6\91CF\503C\7684\6700\5C0F\548C\6700\5927\53EF\80FD\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109541969499313782)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\74B0\5708\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109647696875313868)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\74B0\5708\5716\6307\7684\662F\4E2D\9593\6709\4E00\500B\5713\5B54\7684\5713\9905\5716, \9069\7528\65BC\5448\73FE\5404\90E8\5206\4F54\6574\9AD4\7684\60C5\6CC1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109506918091313755)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6F0F\6597\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109647779527313868)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6F0F\6597\5716\9069\7528\65BC\6AA2\8996\8655\7406\4F5C\696D\968E\6BB5 (\4F8B\5982\92B7\552E\8655\7406\4F5C\696D\968E\6BB5) \7684\8CC7\6599. \6F0F\6597\5207\5272\5716\7684\5340\57DF\8207\76F8\5C0D\61C9\968E\6BB5\7684\503C\6210\6BD4\4F8B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109837020823314026)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7518\7279\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109837150252314026)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7518\7279\5716\9069\7528\65BC\986F\793A\5176\4E2D\4EE5\9577\689D\6307\793A\5DE5\4F5C\958B\59CB\8207\7D50\675F\65E5\671F\7684\5C08\6848\6392\7A0B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109507063560313756)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6298\7DDA\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109647862021313868)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6298\7DDA\5716\9069\7528\65BC\5448\73FE\4E00\6BB5\6642\9593\4E4B\4E00\7D44\503C\7684\8DA8\52E2\53CA\6BD4\8F03\6240\6709\6578\5217\4E2D\7684\9019\4E9B\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109507136248313756)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6298\7DDA\5340\57DF\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109647962954313868)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6298\7DDA\5340\57DF\5716\8207\6298\7DDA\5716\76F8\540C, \4F46\6BCF\689D\7DDA\7684\4E0B\65B9\6703\586B\5165\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109507244749313756)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\9905\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109648071828313868)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\9905\5716\9069\7528\65BC\5448\73FE\5404\90E8\5206\4F54\6574\9AD4\7684\60C5\6CC1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109541608196313782)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6975\5EA7\6A19\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109648167113313868)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6975\5EA7\6A19\5716\5206\5225\6709\4E00\500B\653E\5C04\72C0 y \8EF8\548C\4E00\500B\5207\7DDA x \8EF8. \6975\5EA7\6A19\5716\53EF\4EE5\5448\73FE\70BA\9577\689D\5716\3001\6298\7DDA\5716\3001\5340\57DF\5716\3001\7D44\5408\5716\3001\6563\5E03\5716\6216\6CE1\6CE1\5716\6578\5217\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109340660285313630)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91D1\5B57\5854\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109340704493313630)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91D1\5B57\5854\5716\5C0D\65BC\8996\89BA\5316\968E\5C64\3001\6BD4\4F8B\548C\57FA\65BC\57FA\790E\7684\95DC\4FC2\3001\6D41\7A0B\6B65\9A5F\3001\7D44\7E54\5C64\7D1A\6216\4E3B\984C\76F8\4E92\9023\7DDA\975E\5E38\6709\7528. \91D1\5B57\5854\5F62\5207\7247\7684\5340\57DF\8207\76F8\5C0D\61C9\968E\6BB5\7684\503C\6210\6BD4\4F8B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109541704940313782)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96F7\9054\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109648279891313868)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96F7\9054\5716\70BA\5177\5099\591A\908A\5F62\7DB2\683C\5F62\72C0 (\800C\4E0D\662F\5713\5F62) \7684\6975\5EA7\6A19\5716, \652F\63F4\6298\7DDA\5716\548C\5340\57DF\5716\6578\5217\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109541823316313782)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\570D\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109648339069313868)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\570D\5716\4F7F\7528\9577\689D\6216\5340\57DF\4F86\986F\793A\5404\500B\9805\76EE\7684\6700\5927\503C\548C\6700\5C0F\503C (\9AD8\503C/\4F4E\503C).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109507340846313756)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6563\5E03\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109648452392313868)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6563\5E03\5716\4F7F\7528 x \548C y \503C\4F86\5B9A\7FA9\8CC7\6599\9805\76EE, \9069\7528\65BC\6AA2\8996 2 \500B\7DAD\5EA6\4E4B\9593\7684\95DC\4FC2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109507459715313756)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\80A1\7968\5206\6790\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109648587415313869)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\80A1\7968\5206\6790\5716\9069\7528\65BC\986F\793A\6642\9593\8EF8\4E0A\67D0\4E00\6A94\80A1\7968\7684\76F8\95DC\8CC7\8A0A. \80A1\7968\5206\6790\5716\7684\7279\9EDE\70BA K \7DDA\5716\7684<strong>\80A1\7968\5448\73FE\65B9\5F0F</strong>\7279\6027, \53EF\4F9B\986F\793A\80A1\50F9\7684\958B\76E4\50F9\3001\6536\76E4\50F9\3001\6700\9AD8\50F9\4EE5\53CA\6700\4F4E\50F9\8CC7\8A0A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109506296563313755)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109445047735313710)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\591A\6578\5217\5716\8868\8CC7\6599\4E2D\7684\9593\8DDD\61C9\8A2D\70BA\96F6\503C\6216\7A7A\503C.</p>'),
unistr('        <p>\8A2D\70BA<strong>\958B\555F</strong>\6642, \6703\5C07\8CC7\6599\4E2D\7684\9593\8DDD\7576\6210\96F6\4F86\8655\7406.  \5C31\6298\7DDA\5716\800C\8A00, \9019\6703\78BA\4FDD\5C07\7DDA\689D\5448\73FE\70BA\5BE6\7DDA. \5C31\300C\5806\758A\6A19\7C64\300D\8A2D\70BA\300C\958B\555F\300D\7684\5806\758A\9577\689D\5716\800C\8A00, \9019\6703\78BA\4FDD\5448\73FE\6BCF\500B\5806\758A\7684\5806\758A\6A19\7C64.</p>'),
unistr('        <p>\8A2D\70BA<strong>\95DC\9589</strong>\6642, \6703\5C07\8CC7\6599\4E2D\7684\9593\8DDD\7576\6210\7A7A\503C\4F86\8655\7406. \5C31\6298\7DDA\5716\800C\8A00, \6703\5C07\7DDA\689D\5448\73FE\70BA\6298\7DDA, \5176\4E2D\4EE5\9593\8DDD\4EE3\8868\7A7A\503C\8CC7\6599\9EDE.<p>'),
unistr('        <p>\6B64\8A2D\5B9A\5C07\5957\7528\81F3\652F\63F4\5448\73FE\70BA\9577\689D\5716\548C\6298\7DDA\5716\7684\591A\6578\5217\5716\8868\985E\578B, \4F8B\5982\9577\689D\5716\3001\6298\7DDA\5716\3001\6298\7DDA\5340\57DF\5716\3001\7D44\5408\5716\3001\5340\57DF\5716\3001\6975\5EA7\6A19\5716\3001\96F7\9054\5716\53CA\6563\5E03\5716.  \9810\8A2D\503C\70BA<strong>\958B\555F</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109444992372313710)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\9593\8DDD\5448\73FE\70BA\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109509301535313757)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\662F\5426\5728\5716\8868\4E0A\555F\7528\8CC7\6599\6E38\6A19.'),
unistr('        \8CC7\6599\9805\76EE\82E5\96E3\4EE5\700F\89BD, \8CC7\6599\6E38\6A19\662F\5DE5\5177\63D0\793A\7684\6700\4F73\66FF\4EE3\9805\76EE, \7279\5225\662F\91DD\5C0D\89F8\63A7\88DD\7F6E.<p/>'),
unistr('        <p>\82E5\8A2D\70BA<strong>\81EA\52D5</strong>, \5728\89F8\63A7\88DD\7F6E\4E0A\53EA\6703\91DD\5C0D\6298\7DDA\5716\6216\5340\57DF\5716\986F\793A\8CC7\6599\6E38\6A19.<p/>'),
unistr('        <p>\6CE8\610F - \5DE5\5177\63D0\793A\82E5\70BA\7A7A\503C, \800C\4E14\5728\6975\5EA7\6A19\5716\4E0D\4E88\652F\63F4, \5C31\4E0D\6703\986F\793A\8CC7\6599\6E38\6A19.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109509405933313757)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109648972088313869)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5716\8868\5957\7528 Oracle JET \5B9A\7FA9\7684\9810\8A2D\8CC7\6599\6E38\6A19\986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109509672832313758)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109649194445313869)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\986F\793A\8CC7\6599\6E38\6A19.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109509555416313757)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109649091827313869)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\986F\793A\8CC7\6599\6E38\6A19.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109509260869313757)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E38\6A19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109509895181313758)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5716\8868\4E0A\8CC7\6599\6E38\6A19\7684\884C\70BA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109509937236313758)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109639442311313862)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528\5716\8868\7684 Oracle JET \5DF2\5B9A\7FA9\9810\8A2D\8CC7\6599\6E38\6A19\884C\70BA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109510076386313758)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E73\6ED1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109649272427313869)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8CC7\6599\6E38\6A19\6703\96A8\8457\6ED1\9F20/\89F8\78B0\9806\66A2\79FB\52D5, \6BCF\7576\8CC7\6599\6E38\6A19\505C\99D0\5728\8CC7\6599\5143\7D20\7684\4EFB\4F55\90E8\5206 (\4E0D\9650\65BC\7279\5B9A\8CC7\6599\9EDE), \5C31\6703\986F\793A\5DE5\5177\63D0\793A. \6703\6709\4E00\500B\6307\793A\5668, \8B58\5225\76EE\524D\9078\53D6\7684\8CC7\6599\5143\7D20.</p>'),
unistr('        <p>\6CE8\610F - \82E5\8981\5B8C\5168\4F7F\7528\6B64\8996\89BA\5316\529F\80FD, \8ACB\5C07<strong>\6E38\6A19</strong>\8A2D\70BA<strong>\662F</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109510175399313758)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CBC\9F4A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109649370629313869)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6ED1\9F20/\89F8\78B0\79FB\52D5\6E38\6A19\505C\99D0\5728\5716\8868\4E0A\6642, \8CC7\6599\6E38\6A19\6703\8CBC\9F4A (\8DF3\8E8D) \81F3\8CC7\6599\5143\7D20, \800C\4E14\6BCF\7576\8CC7\6599\6E38\6A19\505C\99D0\5728\8CC7\6599\5143\7D20\4E0A, \5C31\6703\986F\793A\5DE5\5177\63D0\793A. \6703\6709\4E00\500B\6307\793A\5668, \8B58\5225\76EE\524D\9078\53D6\7684\8CC7\6599\5143\7D20.</p>'),
unistr('        <p>\6CE8\610F - \82E5\8981\5B8C\5168\4F7F\7528\6B64\8996\89BA\5316\529F\80FD, \8ACB\5C07<strong>\6E38\6A19</strong>\8A2D\70BA<strong>\662F</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109509791767313758)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\70BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109359650748313644)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\61C9\81EA\52D5\586B\6EFF\591A\6578\5217\5716\8868\8CC7\6599\4E2D\7684\9593\8DDD.  \6B64\8A2D\5B9A\4E0D\9069\7528\65BC\55AE\4E00\6578\5217\5716\8868\6216\4EE5\4E0B\5716\8868\985E\578B: \6CE1\6CE1\5716\3001\74B0\5708\5716\3001\6F0F\6597\5716\3001\7518\7279\5716\3001\5713\9905\5716\3001\91D1\5B57\5854\5716\3001\6563\5E03\5716\53CA\80A1\7968\5206\6790\5716.  \8A2D\70BA<strong>\958B\555F</strong>\6642, \5C07\6703\5C0D\5716\8868\8CC7\6599\5957\7528 Oracle Application Express 5.1.3 \4E2D\5C0E\5165\7684\8CC7\6599\5BC6\5316\908F\8F2F.  \8A2D\70BA<strong>\95DC\9589</strong>\6642, \5C07\4E0D\6703\586B\6EFF\8CC7\6599\4E2D\7684\9593\8DDD, \800C\53EF\80FD\5C0E\81F4\5448\73FE\4E0D\6E96\78BA\7684\5716\8868. \9810\8A2D\503C\70BA<strong>\958B\555F</strong>.  ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109359503798313644)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5716\8868\8CC7\6599\586B\5165\9593\9694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110073594974314195)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8F38\5165\8981\5728\7518\7279\5716\7684\57FA\6E96\5217\5957\7528\7684 CSS \985E\5225. \82E5\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694. \60A8\53EF\4EE5\4F7F\7528 <code>&COLUMN_VALUE.</code> \66FF\4EE3\9805\76EE.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110073448570314195)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57FA\6E96 CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109843769445314031)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\57FA\6E96\7D50\675F\65E5\671F\7684\8CC7\6599\6B04\540D\7A31. \57FA\6E96\7D50\675F\65E5\671F\662F\5DE5\4F5C\7684\539F\59CB\8A08\756B\7D50\675F\65E5\671F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109843673570314031)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57FA\6E96\7D50\675F\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109843531610314031)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\57FA\6E96\958B\59CB\65E5\671F\7684\8CC7\6599\6B04\540D\7A31. \57FA\6E96\958B\59CB\65E5\671F\662F\5DE5\4F5C\7684\539F\59CB\8A08\756B\958B\59CB\65E5\671F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109843481641314031)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57FA\6E96\958B\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109841982713314030)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\7D50\675F\65E5\671F\7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109841847746314029)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\65E5\671F\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109842108226314030)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\7D50\675F\65E5\671F\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109842085329314030)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\65E5\671F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109841189418314029)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\7D50\675F\65E5\671F\7684\4F86\6E90. \5FC5\9808\63D0\4F9B\7D50\675F\65E5\671F, \624D\80FD\5920\5448\73FE\5716\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109841332582314029)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109841449394314029)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA<em>\7D50\675F\65E5\671F\8CC7\6599\6B04</em>\4E2D\8F38\5165\7684\8CC7\6599\6B04\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109841617742314029)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109841775413314029)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\6240\9078<em>\7D50\675F\65E5\671F\9805\76EE</em>\7684\968E\6BB5\4F5C\696D\72C0\614B\503C.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109841259218314029)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\65E5\671F\4F86\6E90\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109843992288314031)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\5DE5\4F5C\9032\5EA6\7684\8CC7\6599\6B04\540D\7A31. \9032\5EA6\503C\5FC5\9808\5728 0 \8207 1 \4E4B\9593.  \5982\679C\503C\7121\6548, \5C07\4E0D\6703\986F\793A\9032\5EA6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109843869572314031)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110073333414314195)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8F38\5165\8981\5728\7518\7279\5716\7684\9032\5EA6\5217\5957\7528\7684 CSS \985E\5225. \82E5\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694. \60A8\53EF\4EE5\4F7F\7528 <code>&COLUMN_VALUE.</code> \66FF\4EE3\9805\76EE.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110073229246314195)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\5EA6 CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109842349182314030)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\8CC7\6599\5217 ID \7684\8CC7\6599\6B04\540D\7A31. \5982\679C\60F3\8981\5728\6BCF\4E00\8CC7\6599\5217\5448\73FE\591A\9805\5DE5\4F5C, \5C31\9700\8981\8CC7\6599\5217 ID. \672A\5B9A\7FA9\4EFB\4F55\8CC7\6599\5217 ID \8CC7\6599\6B04\5C0D\61C9\6642, \6BCF\9805\5DE5\4F5C\5C07\4EE5\6BCF\4E00\8CC7\6599\5217\4E00\9805\5DE5\4F5C\7684\65B9\5F0F\5448\73FE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109842280214314030)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109842583429314030)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\8CC7\6599\5217\540D\7A31\7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109842438737314030)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109841070308314029)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\958B\59CB\65E5\671F\7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109840925082314029)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\65E5\671F\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109850520308314036)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\958B\59CB\65E5\671F\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109841514564314029)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\65E5\671F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109837562662314026)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\958B\59CB\65E5\671F\7684\4F86\6E90. \5FC5\9808\63D0\4F9B\958B\59CB\65E5\671F, \624D\80FD\5920\5448\73FE\5716\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109840388516314028)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109840497608314028)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA<em>\958B\59CB\65E5\671F\8CC7\6599\6B04</em>\4E2D\8F38\5165\7684\8CC7\6599\6B04\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109840546984314029)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109840688849314029)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\6240\9078<em>\958B\59CB\65E5\671F\9805\76EE</em>\7684\968E\6BB5\4F5C\696D\72C0\614B\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109837467998314026)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\65E5\671F\4F86\6E90\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110073139391314195)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8F38\5165\8981\5728\7518\7279\5716\7684\5DE5\4F5C\5217\5957\7528\7684 CSS \985E\5225. \82E5\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694. \60A8\53EF\4EE5\4F7F\7528 <code>&COLUMN_VALUE.</code> \66FF\4EE3\9805\76EE.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110073028463314195)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109843303939314031)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\5DE5\4F5C\7D50\675F\65E5\671F\7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109843234220314030)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\7D50\675F\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109842747874314030)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\5DE5\4F5C ID \7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109842615467314030)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109842971769314030)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\5DE5\4F5C\540D\7A31\7684\8CC7\6599\6B04\540D\7A31. \672A\5B9A\7FA9\4EFB\4F55\8CC7\6599\5217\540D\7A31\8CC7\6599\6B04\5C0D\61C9\6642, \5DE5\4F5C\540D\7A31\5C07\7528\4F86\4F5C\70BA\5716\8868\8CC7\6599\5217\8EF8\4E0A\7684\8CC7\6599\5217\6A19\7C64. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109842840925314030)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109843121994314030)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\5DE5\4F5C\958B\59CB\65E5\671F\7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109843003637314030)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\958B\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110053700822314181)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\6AA2\8996\57E0\7D50\675F\65E5\671F\7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110048700504314178)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\65E5\671F\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110053891941314181)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\6AA2\8996\57E0\7D50\675F\65E5\671F\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110048557920314177)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\65E5\671F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110053416695314181)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\6AA2\8996\57E0\7D50\675F\65E5\671F\7684\4F86\6E90. \6AA2\8996\57E0\662F\4E00\500B\65E5\671F\7BC4\570D, \5B9A\7FA9\4E4B\5F8C\53EF\4EE5\63A7\5236\5716\8868\5448\73FE\5F8C\7684\6700\521D\7E2E\653E\6BD4\4F8B. \5716\8868\5C07\6703\7E2E\653E\6210\6307\5B9A\7684\65E5\671F\7BC4\570D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110048944763314178)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110053534057314181)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA<em>\7D50\675F\65E5\671F\8CC7\6599\6B04</em>\4E2D\8F38\5165\7684\8CC7\6599\6B04\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110049145488314178)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110053690611314181)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\6240\9078<em>\7D50\675F\65E5\671F\9805\76EE</em>\7684\968E\6BB5\4F5C\696D\72C0\614B\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110048462125314177)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\65E5\671F\4F86\6E90\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110053226015314181)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\6AA2\8996\57E0\958B\59CB\65E5\671F\7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110048635476314177)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\65E5\671F\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110053367848314181)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\6AA2\8996\57E0\958B\59CB\65E5\671F\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110048387159314177)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\65E5\671F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110052915835314180)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\7518\7279\5716\6AA2\8996\57E0\958B\59CB\65E5\671F\7684\4F86\6E90. \6AA2\8996\57E0\662F\4E00\500B\65E5\671F\7BC4\570D, \5B9A\7FA9\4E4B\5F8C\53EF\4EE5\63A7\5236\5716\8868\5448\73FE\5F8C\7684\6700\521D\7E2E\653E\6BD4\4F8B. \5716\8868\5C07\6703\7E2E\653E\6210\6307\5B9A\7684\65E5\671F\7BC4\570D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110048893741314178)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110053047447314181)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA<em>\958B\59CB\65E5\671F\8CC7\6599\6B04</em>\4E2D\8F38\5165\7684\8CC7\6599\6B04\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110049000037314178)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110053141591314181)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\6240\9078<em>\958B\59CB\65E5\671F\9805\76EE</em>\7684\968E\6BB5\4F5C\696D\72C0\614B\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110048204174314177)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\65E5\671F\4F86\6E90\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108952582868313328)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5713\5F62\65B9\5411\72C0\614B\8A08\91CF\91CF\8868\5716\7684\89D2\5EA6\7BC4\570D (\4EE5\5EA6\70BA\55AE\4F4D). \89D2\5EA6\7BC4\570D\662F\5713\5F62\65B9\5411\7684\5BE6\969B\89D2\5EA6. \6B63\503C\8868\793A\9806\6642\91DD\65B9\5411\89D2\5EA6.  \8CA0\503C\8868\793A\9006\6642\91DD\65B9\5411\89D2\5EA6. \60A8\53EF\4EE5\5728\4EFB\4F55\89D2\5EA6\7E6A\88FD\5713\578B\91CF\8868, \4E26\6839\64DA\9078\64C7\7684\89D2\5EA6\8B8A\66F4\5176\5F62\72C0. \91CF\8868\7684\5F62\72C0\53D6\6C7A\65BC<strong>\958B\59CB\89D2\5EA6</strong>\548C<strong>\89D2\5EA6\7BC4\570D</strong>\9019\5169\500B\8A2D\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108952343984313328)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89D2\5EA6\7BC4\570D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108951964467313328)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6307\793A\5668\8207\7E6A\5716\5340\7684\76F8\5C0D\539A\5EA6\6BD4\4F8B.  \9810\8A2D\503C\70BA 1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108951848480313328)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\793A\5668\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108952025863313328)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EE5\5713\5F62\65B9\5411\6307\5B9A\72C0\614B\8A08\91CF\91CF\8868\5716\7684\5167\534A\5F91, \5B9A\7FA9\65B9\5F0F\70BA\5F9E\91CF\8868\7684\4E2D\5FC3\5230\6307\793A\5668\548C\7E6A\5716\5340\6700\5167\7DE3\7684\8DDD\96E2. \6709\6548\503C\70BA\5F9E 0 \5230 1 \7684\767E\5206\6BD4\6216\6BD4\4F8B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108952157679313328)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\534A\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108951579197313328)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\5448\73FE\7684\72C0\614B\8A08\91CF\91CF\8868\5716\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108951241550313327)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.CIRCULAR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108951330787313327)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C34\5E73')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108951487877313328)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5782\76F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108951196756313327)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108951711783313328)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\5448\73FE\72C0\614B\8A08\91CF\91CF\8868\5716\7684\7E6A\5716\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108951611272313328)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\7E6A\5716\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109065920043313420)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108962134328313336)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\65BC\986F\793A\72C0\614B\8A08\91CF\91CF\8868\5716\7E6A\5716\5340\7684\8272\5F69. \60A8\53EF\4EE5\4F7F\7528 <code>&COLUMN_VALUE.</code> \66FF\4EE3\9805\76EE. \5716\8868\5C1A\672A\5B9A\7FA9\81E8\754C\503C\8272\5F69\6642\624D\6703\5957\7528\6B64\8272\5F69.</p>'),
unistr('<p>\8272\5F69\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\6307\5B9A. \5341\516D\9032\4F4D\8868\793A\6CD5\5B9A\7FA9\70BA #xxyyzz (# \5F8C\9762\63A5\8457 3 \7D44\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57), \5176\4E2D xx\3001yy \548C zz \70BA\5169\500B\5B57\5143\7684\5341\516D\9032\4F4D\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.'),
unistr('RGB \4EE3\78BC\5B9A\7FA9\70BA RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F 0 \5230 255 \4E4B\9593\7684\6578\5B57, \5404\81EA\70BA\4E00\500B 8 \4F4D\5143\7684\4F4D\5143\7D44\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.</p>'),
unistr('<p>\8ACB\5F9E\7DB2\969B\7DB2\8DEF\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5C0B\627E\60F3\4F7F\7528\4E4B\8272\5F69\7684\540C\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108962037714313336)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E6A\88FD\5340\57DF\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108952496023313328)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5713\5F62\65B9\5411\72C0\614B\8A08\91CF\91CF\8868\5716\7684\958B\59CB\89D2\5EA6 (\4EE5\5EA6\70BA\55AE\4F4D). \6B63\503C\8868\793A\958B\59CB\89D2\5EA6\70BA\9806\6642\91DD\65B9\5411. \8CA0\503C\8868\793A\958B\59CB\89D2\5EA6\70BA\9006\6642\91DD\65B9\5411. \60A8\53EF\4EE5\5728\4EFB\4F55\89D2\5EA6\7E6A\88FD\5713\578B\91CF\8868, \4E26\6839\64DA\9078\64C7\7684\89D2\5EA6\8B8A\66F4\5176\5F62\72C0. \91CF\8868\7684\5F62\72C0\53D6\6C7A\65BC<strong>\958B\59CB\89D2\5EA6</strong>\548C<strong>\89D2\5EA6\7BC4\570D</strong>\9019\5169\500B\8A2D\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108952238426313328)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\89D2\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109836934964314026)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\5728\5716\8868\4E0A\986F\793A\6C34\5E73\683C\7DDA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109836282790314025)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\6C34\5E73\683C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109510353629313758)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\8981\5728\66AB\7559\65BC\5716\8868\7684\8CC7\6599\9805\76EE\4E0A\65B9\6642\5957\7528\7684\884C\70BA.<p/>'),
unistr('        \9078\53D6<strong>\958B\555F</strong>, \5728\76EE\524D\672A\66AB\7559\6642\8B93\6240\6709\8CC7\6599\9805\76EE\8B8A\6697, \4E26\4E14\50C5\6A19\793A\66AB\7559\4F4D\7F6E\7684\76EE\524D\8CC7\6599\9805\76EE.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109510203724313758)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66AB\7559\6642\8B8A\6697')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110098066299314214)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\9078\53D6\5716\8868\7684\8D77\59CB\7E2E\653E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110098119975314214)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110098213910314214)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\521D\7E2E\653E\6210\9069\5408\5716\8868\7E6A\5716\5340\7684\7B2C\4E00\500B\8CC7\6599\9EDE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110098368159314214)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5F8C\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110098475781314214)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\521D\7E2E\653E\6210\9069\5408\5716\8868\7E6A\5716\5340\7684\6700\5F8C\4E00\500B\8CC7\6599\9EDE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110098556928314214)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110098691472314214)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528\8D77\59CB\7E2E\653E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110097988256314214)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D77\59CB\7E2E\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109483517673313738)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109226203325313540)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\65BC\986F\793A\6307\5B9A\5C6C\6027\7684\5B57\578B\8272\5F69.</p>'),
unistr('<p>\6307\5B9A\8272\5F69\6642, \662F\4F7F\7528\5341\516D\9032\4F4D\8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A. \5341\516D\9032\4F4D\8868\793A\6CD5\662F\4EE5 #xxyyzz (\4E00\500B # \5F8C\9762\8DDF\8457 3 \500B\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57) \4F86\5B9A\7FA9, \5176\4E2D xx\3001yy \53CA zz \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\96D9\5B57\5143\5341\516D\9032\4F4D\503C.'),
unistr('RGB \4EE3\78BC\662F\4EE5 RGB(xxx,xxx,xxx) \4F86\5B9A\7FA9, \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \7684\6578\5B57, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\55AE\4E00 8 \4F4D\5143\4F4D\5143\7D44\503C.</p>'),
unistr('<p>\5728\7DB2\969B\7DB2\8DEF\4E2D\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5373\53EF\627E\51FA\60A8\60F3\8981\4F7F\7528\4E4B\8272\5F69\7684\5C0D\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109223282132313538)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109224882535313539)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B57\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109223492753313538)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109223367766313538)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109223585620313538)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109223601118313538)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109223899730313538)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109223707176313538)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109223982059313538)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109224057450313538)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109224170634313538)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109224246362313538)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109224320871313538)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109224504330313539)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109224489757313539)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109224690747313539)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109224736694313539)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109222986761313537)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109225376851313539)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B57\578B\5927\5C0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109225521856313539)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.10.D'
,p_message_language=>'zh-tw'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109225618414313539)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.12.D'
,p_message_language=>'zh-tw'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109225794667313539)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.14.D'
,p_message_language=>'zh-tw'
,p_message_text=>'14'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109225878794313540)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.16.D'
,p_message_language=>'zh-tw'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109225934532313540)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.18.D'
,p_message_language=>'zh-tw'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109226006704313540)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.20.D'
,p_message_language=>'zh-tw'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109226111567313540)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.22.D'
,p_message_language=>'zh-tw'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109225401637313539)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.8.D'
,p_message_language=>'zh-tw'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109223136363313538)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109224966776313539)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B57\578B\6A23\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109225151015313539)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\659C\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109225089925313539)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109225209775313539)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\659C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109223092993313537)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109033931809313396)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5713\9905\5716\5207\7247\4E0A\7684\6A19\7C64\986F\793A\65B9\5F0F. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110077543017314198)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64 - \767E\5206\6BD4 ( \503C )')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110078021922314198)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6A19\7C64\5C07\7528\4EE5\4E0B\683C\5F0F\986F\793A\6A19\7C64\3001\503C\548C\767E\5206\6BD4\8CC7\8A0A: \6A19\7C64 - \767E\5206\6BD4 ( \503C ). \4F8B\5982, <strong>\932F\8AA4 - 15% ( 18 )</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110077682393314198)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767E\5206\6BD4 ( \503C )')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110078199160314198)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\4F9D\64DA\6240\9078\53D6\7684\300C\503C\300D\8CC7\6599\6B04\5C0D\61C9, \6A19\7C64\5C07\986F\793A\70BA\6578\503C. \4F8B\5982, <strong>15% ( 18 )</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110077217310314198)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110077775901314198)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\4F9D\64DA\6240\9078\53D6\7684\300C\6A19\7C64\300D\8CC7\6599\6B04\5C0D\61C9, \5C07\5728\5716\8868\7684\5207\7247\4E0A\986F\793A\6A19\7C64. \4F8B\5982, <strong>\932F\8AA4</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109421847743313691)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64 - \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109421997321313691)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6A19\7C64\5C07\7528\4EE5\4E0B\683C\5F0F\986F\793A\6A19\7C64\548C\503C\8CC7\8A0A: \6A19\7C64 - \503C. \4F8B\5982, <strong>\932F\8AA4 - 18</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110077350427314198)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110077868848314198)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\4F9D\64DA\6240\9078\53D6\7684\300C\503C\300D\8CC7\6599\6B04\5C0D\61C9, \6A19\7C64\5C07\986F\793A\70BA 0% \5230 100% \4E4B\9593\7684\503C. \503C\70BA\5716\8868\4E2D\6240\793A\7E3D\8A08\503C\7684\767E\5206\6BD4. \4F8B\5982, <strong>15%</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110077449197314198)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110077930575314198)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\4F9D\64DA\6240\9078\53D6\7684\300C\503C\300D\8CC7\6599\6B04\5C0D\61C9, \6A19\7C64\5C07\986F\793A\70BA\6578\503C.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110077105011314198)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109483499809313738)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109220254148313535)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\65BC\986F\793A\6307\5B9A\5C6C\6027\7684\5B57\578B\8272\5F69.</p>'),
unistr('<p>\6307\5B9A\8272\5F69\6642, \662F\4F7F\7528\5341\516D\9032\4F4D\8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A. \5341\516D\9032\4F4D\8868\793A\6CD5\662F\4EE5 #xxyyzz (\4E00\500B # \5F8C\9762\8DDF\8457 3 \500B\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57) \4F86\5B9A\7FA9, \5176\4E2D xx\3001yy \53CA zz \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\96D9\5B57\5143\5341\516D\9032\4F4D\503C.'),
unistr('RGB \4EE3\78BC\662F\4EE5 RGB(xxx,xxx,xxx) \4F86\5B9A\7FA9, \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \7684\6578\5B57, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\55AE\4E00 8 \4F4D\5143\4F4D\5143\7D44\503C.</p>'),
unistr('<p>\5728\7DB2\969B\7DB2\8DEF\4E2D\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5373\53EF\627E\51FA\60A8\60F3\8981\4F7F\7528\4E4B\8272\5F69\7684\5C0D\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109219824388313535)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109219907925313535)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B57\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109220424857313536)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109220330566313536)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109220555802313536)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109220686729313536)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109220816566313536)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109220760538313536)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109220971796313536)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109221076154313536)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109221164236313536)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109221277591313536)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109221366025313536)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109221557354313536)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109221406942313536)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109221607598313536)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109221773207313537)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109219557699313535)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109220187368313535)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B57\578B\5927\5C0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109222225358313537)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.10.D'
,p_message_language=>'zh-tw'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109222346822313537)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.12.D'
,p_message_language=>'zh-tw'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109222472236313537)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.14.D'
,p_message_language=>'zh-tw'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109222598348313537)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.16.D'
,p_message_language=>'zh-tw'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109222652262313537)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.18.D'
,p_message_language=>'zh-tw'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109222789412313537)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.20.D'
,p_message_language=>'zh-tw'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109222829019313537)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.22.D'
,p_message_language=>'zh-tw'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109222154170313537)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.8.D'
,p_message_language=>'zh-tw'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109219778028313535)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109220063064313535)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B57\578B\6A23\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109221960016313537)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\659C\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109221825254313537)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109222023456313537)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\659C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109219684744313535)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109069795053313423)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>\9017\865F\5340\9694\7684\8272\5F69\6E05\55AE:</dt>'),
'<dd><pre>',
'<strong>red,yellow,blue</strong>',
'</pre></dd>',
unistr('<dt>\9017\865F\5340\9694\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE\6E05\55AE, \4F7F\7528\4EE5\4E0B\8A9E\6CD5\50B3\56DE\8272\5F69:</dt>'),
'<dd><pre>',
unistr('<code>&amp;ITEM.</code>. \4F8B\5982, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>'),
'</pre></dd>',
unistr('<dt>\9017\865F\5340\9694\7684\8CC7\6599\6B04\6E05\55AE, \4F7F\7528\4EE5\4E0B\8A9E\6CD5\50B3\56DE\8272\5F69:</dt>'),
'<dd><pre>',
unistr('<code>&amp;COLUMN_NAME.</code>. \4F8B\5982, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109069696037313423)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\7528\65BC\5728\72C0\614B\8A08\91CF\91CF\8868\5716\4E0A\5448\73FE\4EE5\8B58\5225\53C3\8003\7DDA\7684\8272\5F69.'),
unistr('\5982\6709\591A\500B\53C3\8003\7DDA, \8ACB\4F7F\7528\9017\865F\5340\9694\7684\6E05\55AE.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109069360514313422)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109069508171313423)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>\9017\865F\5340\9694\7684\975C\614B\6578\503C\6E05\55AE:</dt>'),
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
unistr('<dt>\9017\865F\5340\9694\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE\6E05\55AE, \4F7F\7528\4EE5\4E0B\8A9E\6CD5\50B3\56DE\6578\503C:</dt>'),
'<dd><pre>',
unistr('<code>&amp;ITEM.</code>. \4F8B\5982, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>'),
'</pre></dd>',
unistr('<dt>\9017\865F\5340\9694\7684\8CC7\6599\6B04\6E05\55AE, \4F7F\7528\4EE5\4E0B\8A9E\6CD5\50B3\56DE\6578\503C:</dt>'),
'<dd><pre>',
unistr('<code>&amp;COLUMN_NAME.</code>. \4F8B\5982, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109069425067313423)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\7528\65BC\5728\72C0\614B\8A08\91CF\91CF\8868\5716\4E0A\5448\73FE\4EE5\8B58\5225\53C3\8003\7DDA\7684\6578\5B57.'),
unistr('\5982\6709\591A\500B\53C3\8003\7DDA, \8ACB\4F7F\7528\9017\865F\5340\9694\7684\6E05\55AE.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109069230155313422)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109836761898314026)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\5728\5716\8868\4E0A\5448\73FE\8CC7\6599\5217\6A19\7C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109836441954314026)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\8CC7\6599\5217\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109521873196313766)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109521704214313766)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\65BC\986F\793A\6B64\5716\8868\6578\5217\4E4B\8CC7\6599\9805\76EE\7684\8272\5F69. \60A8\53EF\4EE5\4F7F\7528 <code>&COLUMN_VALUE.</code> \66FF\4EE3\9805\76EE. \82E5\70BA\72C0\614B\8A08\91CF\91CF\8868\8868, \6B64\8272\5F69\5C07\6703\5957\7528\81F3\6307\793A\5668, \4F46\82E5\5DF2\5B9A\7FA9\81E8\754C\503C, \4E14<strong>\81E8\754C\503C\986F\793A</strong>\5C6C\6027\8A2D\70BA<strong>\6307\793A\5668\4E0A</strong>\6642\9664\5916.</p>'),
unistr('<p>\8272\5F69\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\6307\5B9A. \5341\516D\9032\4F4D\8868\793A\6CD5\5B9A\7FA9\70BA #xxyyzz (# \5F8C\9762\63A5\8457 3 \7D44\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57), \5176\4E2D xx\3001yy \548C zz \70BA\5169\500B\5B57\5143\7684\5341\516D\9032\4F4D\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.'),
unistr('RGB \4EE3\78BC\5B9A\7FA9\70BA RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F 0 \5230 255 \4E4B\9593\7684\6578\5B57, \5404\81EA\70BA\4E00\500B 8 \4F4D\5143\7684\4F4D\5143\7D44\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.</p>'),
unistr('<p>\8ACB\5F9E\7DB2\969B\7DB2\8DEF\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5C0B\627E\60F3\4F7F\7528\4E4B\8272\5F69\7684\540C\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109521614302313766)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109447680164313712)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109447444099313711)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\65BC\986F\793A\7BB1\5F62\5716\6578\5217 q2 \5340\6BB5\7684\8272\5F69. \60A8\53EF\4EE5\4F7F\7528 <code>&COLUMN_VALUE.</code> \66FF\4EE3\9805\76EE.</p>'),
unistr('<p>\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A\8272\5F69. \5341\516D\9032\4F4D\8868\793A\6CD5\5B9A\7FA9\70BA #xxyyzz (# \5F8C\9762\63A5\8457 3 \7D44\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57), \5176\4E2D xx\3001yy \548C zz \70BA\5169\500B\5B57\5143\7684\5341\516D\9032\4F4D\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.'),
unistr('RGB \4EE3\78BC\5B9A\7FA9\70BA RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \4E4B\9593\7684\6578\5B57, \5404\81EA\70BA\4E00\500B 8 \4F4D\5143\7684\4F4D\5143\7D44\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.</p>'),
unistr('<p>\8ACB\5F9E\7DB2\969B\7DB2\8DEF\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5C0B\627E\8207\60A8\60F3\4F7F\7528\4E4B\8272\5F69\540C\7B49\7684\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109447257292313711)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Q2 \8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109447746719313712)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109447545959313712)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\65BC\986F\793A\7BB1\5F62\5716\6578\5217 q3 \5340\6BB5\7684\8272\5F69. \60A8\53EF\4EE5\4F7F\7528 <code>&COLUMN_VALUE.</code> \66FF\4EE3\9805\76EE.</p>'),
unistr('<p>\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A\8272\5F69. \5341\516D\9032\4F4D\8868\793A\6CD5\5B9A\7FA9\70BA #xxyyzz (# \5F8C\9762\63A5\8457 3 \7D44\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57), \5176\4E2D xx\3001yy \548C zz \70BA\5169\500B\5B57\5143\7684\5341\516D\9032\4F4D\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.'),
unistr('RGB \4EE3\78BC\5B9A\7FA9\70BA RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \4E4B\9593\7684\6578\5B57, \5404\81EA\70BA\4E00\500B 8 \4F4D\5143\7684\4F4D\5143\7D44\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.</p>'),
unistr('<p>\8ACB\5F9E\7DB2\969B\7DB2\8DEF\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5C0B\627E\8207\60A8\60F3\4F7F\7528\4E4B\8272\5F69\540C\7B49\7684\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109447352568313711)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Q3 \8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109442563763313707)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5716\8868\6578\5217\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109429465841313697)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.AREA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109429510725313697)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BAR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\689D\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109429305320313697)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BOXPLOT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BB1\5F62\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109429604664313697)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6298\7DDA\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109429790499313697)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINEWITHAREA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6298\7DDA\5340\57DF\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109429878129313697)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109543889509313783)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COLUMN_MAPPING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6578\5217\985E\578B\8CC7\6599\6B04\5C0D\61C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109544096417313783)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5716\8868\6578\5217\985E\578B. \60A8\4E5F\53EF\4EE5\5EFA\7ACB\5728\540C\4E00\8CC7\6599\7E6A\5716\4E0A\7D50\5408\4E0D\540C\985E\578B\4E4B\6578\5217\7684\5716\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109544141014313783)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109544633865313784)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREARANGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\7BC4\570D\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109544258549313783)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BAR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\689D\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109544564940313784)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BARRANGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\689D\7BC4\570D\5716')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109544349663313784)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6298\7DDA\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109544470548313784)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINEWITHAREA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6298\7DDA\5340\57DF\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109543908140313783)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109545269800313784)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5716\8868\6578\5217\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109545359936313784)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109545979757313785)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREARANGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\7BC4\570D\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109545409788313784)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BAR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\689D\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109545821455313785)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BARRANGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\689D\7BC4\570D\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109545791868313785)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BUBBLE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6CE1\6CE1\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109545592575313784)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6298\7DDA\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109833045548314023)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINEWITHAREA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6298\7DDA\5340\57DF\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109545656480313785)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.SCATTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6563\5E03\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109545198722313784)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109546160253313785)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5716\8868\6578\5217\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109546298349313785)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109546330032313785)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREARANGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\7BC4\570D\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109546488274313785)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.LINE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6298\7DDA\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109546027848313785)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109544802001313784)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5716\8868\6578\5217\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109545097116313784)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.AREARANGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\7BC4\570D\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109544940149313784)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.BARRANGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\689D\7BC4\570D\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109544708936313784)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109526901495313770)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\5716\8868\4E0A\5448\73FE\5EA7\6A19\8EF8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109526897173313770)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5EA7\6A19\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109068234720313422)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\5716\8868\7684\5DE5\5177\63D0\793A\4E2D\986F\793A\57FA\6E96\8CC7\8A0A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109067619839313421)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\57FA\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109068017754313421)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\5716\8868\7684\5DE5\5177\63D0\793A\4E2D\986F\793A\7D50\675F\65E5\671F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109067463988313421)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\7D50\675F\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109068198786313422)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\5716\8868\7684\5DE5\5177\63D0\793A\4E2D\986F\793A\9032\5EA6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109067536084313421)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\9032\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109067728931313421)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\5716\8868\7684\5DE5\5177\63D0\793A\4E2D\986F\793A\8CC7\6599\5217\8CC7\8A0A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109067112099313421)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109067957640313421)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\5716\8868\7684\5DE5\5177\63D0\793A\4E2D\986F\793A\958B\59CB\65E5\671F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109067314149313421)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\958B\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108952718311313329)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\61C9\8A72\5728\5716\8868\4E0A\5448\73FE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108952635401313329)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109067855192313421)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\5716\8868\7684\5DE5\5177\63D0\793A\4E2D\986F\793A\6A19\7C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109067269549313421)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109515128852313762)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\61C9\8A72\5728\5716\8868\4E0A\5448\73FE\5DE5\5177\63D0\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109515034201313762)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109515772661313762)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\5728\5716\8868\7684\5DE5\5177\63D0\793A\4E2D\986F\793A\503C. \503C\884D\751F\81EA\60A8\7684\5716\8868\67E5\8A62, \4E26\986F\793A\5728\5716\8868\8CC7\6599\7684\65C1\908A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109515683450313762)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109850465226314036)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\5716\8868\7684\503C\6216\6A19\7C64, \9078\53D6\591A\6578\5217\5716\8868\8CC7\6599\7684\5716\8868\6392\5E8F\9806\5E8F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109835081817314024)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64 - \905E\589E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109835420906314025)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\4F9D X \8EF8\6A19\7C64\905E\589E\9806\5E8F\6392\5217\5716\8868. \6B64\70BA\9810\8A2D\7684\6392\5E8F\9806\5E8F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109835147532314024)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64 - \905E\6E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109835592859314025)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\4F9D X \8EF8\6A19\7C64\905E\6E1B\9806\5E8F\6392\5217\5716\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109834823492314024)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C - \905E\589E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109835255272314025)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\4F9D\905E\589E\9806\5E8F (1, 2, 3, ...) \6392\5217\5716\8868. \9019\9805\8A2D\5B9A\53EA\9069\7528\65BC\5713\9905\5716\3001\55AE\4E00\6578\5217\9577\689D\5716/\6298\7DDA\5716/\5340\57DF\5716, \6216\662F\5806\758A\9577\689D\5716/\5340\57DF\5716. \968E\5C64\5F0F\7FA4\7D44\5EA7\6A19\8EF8\5247\4E0D\5957\7528\6392\5E8F\8A2D\5B9A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109834982485314024)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C - \905E\6E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109835308974314025)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\4F9D\905E\6E1B\9806\5E8F (10, 9, 8, ...) \6392\5217\5716\8868. \9019\9805\8A2D\5B9A\53EA\9069\7528\65BC\5713\9905\5716\3001\55AE\4E00\6578\5217\9577\689D\5716/\6298\7DDA\5716/\5340\57DF\5716, \6216\662F\5806\758A\9577\689D\5716/\5340\57DF\5716. \968E\5C64\5F0F\7FA4\7D44\5EA7\6A19\8EF8\5247\4E0D\5957\7528\6392\5E8F\8A2D\5B9A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109834782720314024)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5E8F\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109680282114313898)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109680170145313898)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\65BC\986F\793A\6307\5B9A\5C6C\6027\7684\5B57\578B\8272\5F69.</p>'),
unistr('<p>\6307\5B9A\8272\5F69\6642, \662F\4F7F\7528\5341\516D\9032\4F4D\8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A. \5341\516D\9032\4F4D\8868\793A\6CD5\662F\4EE5 #xxyyzz (\4E00\500B # \5F8C\9762\8DDF\8457 3 \500B\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57) \4F86\5B9A\7FA9, \5176\4E2D xx\3001yy \53CA zz \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\96D9\5B57\5143\5341\516D\9032\4F4D\503C.'),
unistr('RGB \4EE3\78BC\662F\4EE5 RGB(xxx,xxx,xxx) \4F86\5B9A\7FA9, \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \7684\6578\5B57, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\55AE\4E00 8 \4F4D\5143\4F4D\5143\7D44\503C.</p>'),
unistr('<p>\5728\7DB2\969B\7DB2\8DEF\4E2D\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5373\53EF\627E\51FA\60A8\60F3\8981\4F7F\7528\4E4B\8272\5F69\7684\5C0D\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109679782322313898)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109679814405313898)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B57\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109681590082313900)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109681477305313900)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109681600852313900)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109681778014313900)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109681939648313901)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109681885433313901)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109682016885313901)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109682163257313901)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109682215610313901)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109682330236313901)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109682493549313901)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109682643157313901)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109682571333313901)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109682740619313901)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109682855220313902)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109679480925313897)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109680020532313898)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B57\578B\5927\5C0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109680453760313899)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.10.D'
,p_message_language=>'zh-tw'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109680526129313899)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.12.D'
,p_message_language=>'zh-tw'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109680647252313899)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.14.D'
,p_message_language=>'zh-tw'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109680784649313899)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.16.D'
,p_message_language=>'zh-tw'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109680805688313900)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.18.D'
,p_message_language=>'zh-tw'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109680926145313900)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.20.D'
,p_message_language=>'zh-tw'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109681073034313900)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.22.D'
,p_message_language=>'zh-tw'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109680379867313899)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.8.D'
,p_message_language=>'zh-tw'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109679619906313897)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109679926693313898)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B57\578B\6A23\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109681256303313900)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\659C\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109681117402313900)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109681362607313900)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\659C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109679577105313897)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109844166664314031)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7518\7279\5716\5DE5\4F5C\6A19\7C64\7684\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109844425839314031)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109844895332314032)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\6A19\7C64\4F4D\65BC\7518\7279\5716\5DE5\4F5C\5217\7684\7D50\5C3E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109844581604314031)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\90E8\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109844919059314032)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\6A19\7C64\4F4D\65BC\7518\7279\5716\5DE5\4F5C\5217\7684\5167\90E8\4E2D\592E\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109844700721314032)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\90E8\7D50\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109845105768314032)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\6A19\7C64\4F4D\65BC\7518\7279\5716\5DE5\4F5C\5217\7684\5167\90E8\7D50\5C3E\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109844620389314032)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\90E8\958B\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109845090895314032)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\6A19\7C64\4F4D\65BC\7518\7279\5716\5DE5\4F5C\5217\7684\5167\90E8\958B\982D\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109844285180314031)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109844324597314031)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\6A19\7C64\4F4D\65BC\7518\7279\5716\5DE5\4F5C\5217\7684\958B\982D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109844085309314031)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\6A19\7C64\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108981032397313351)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>\9017\865F\5340\9694\7684\8272\5F69\6E05\55AE:</dt>'),
'<dd><pre>',
'<strong>red,yellow,blue</strong>',
'</pre></dd>',
unistr('<dt>\9017\865F\5340\9694\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE\6E05\55AE, \4F7F\7528\4EE5\4E0B\8A9E\6CD5\50B3\56DE\8272\5F69:</dt>'),
'<dd><pre>',
unistr('<code>&amp;ITEM.</code>. \4F8B\5982, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>'),
'</pre></dd>',
unistr('<dt>\9017\865F\5340\9694\7684\8CC7\6599\6B04\6E05\55AE, \4F7F\7528\4EE5\4E0B\8A9E\6CD5\50B3\56DE\8272\5F69:</dt>'),
'<dd><pre>',
unistr('<code>&amp;COLUMN_NAME.</code>. \4F8B\5982, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108980957626313351)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\7528\65BC\5728\72C0\614B\8A08\91CF\91CF\8868\5716\4E0A\5448\73FE\4EE5\8B58\5225\81E8\754C\503C\4E0A\9650\7684\8272\5F69.'),
unistr('\5982\6709\591A\500B\81E8\754C\503C, \8ACB\4F7F\7528\9017\865F\5340\9694\7684\6E05\55AE.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108962335810313336)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109066013188313420)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\81E8\754C\503C\5728\72C0\614B\8A08\91CF\91CF\8868\5716\4E0A\7684\986F\793A\65B9\5F0F. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108980421018313351)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108980525010313351)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\81E8\754C\503C (\4F7F\7528<strong>\81E8\754C\503C</strong>\5C6C\6027\5B9A\7FA9) \90FD\6703\986F\793A\5728\5716\8868\7684\7E6A\5716\5340\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108980747415313351)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\9650\76EE\524D\7684\81E8\754C\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108980834673313351)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\81E8\754C\503C (\4F7F\7528<strong>\81E8\754C\503C</strong>\5C6C\6027\5B9A\7FA9) \6703\986F\793A\5728\5716\8868\7684\7E6A\5716\5340\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108980615252313351)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\793A\5668\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109066198430313420)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\81E8\754C\503C (\4F7F\7528<strong>\81E8\754C\503C</strong>\5C6C\6027\5B9A\7FA9) \6703\986F\793A\5728\5716\8868\7684\6307\793A\5668\4E0A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108980363983313351)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108980235978313350)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>\9017\865F\5340\9694\7684\975C\614B\6578\503C\6E05\55AE:</dt>'),
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
unistr('<dt>\9017\865F\5340\9694\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE\6E05\55AE, \4F7F\7528\4EE5\4E0B\8A9E\6CD5\50B3\56DE\6578\503C:</dt>'),
'<dd><pre>',
unistr('<code>&amp;ITEM.</code>. \4F8B\5982, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>'),
'</pre></dd>',
unistr('<dt>\9017\865F\5340\9694\7684\8CC7\6599\6B04\6E05\55AE, \4F7F\7528\4EE5\4E0B\8A9E\6CD5\50B3\56DE\6578\503C:</dt>'),
'<dd><pre>',
unistr('<code>&amp;COLUMN_NAME.</code>. \4F8B\5982, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108962205126313336)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\7528\65BC\5728\72C0\614B\8A08\91CF\91CF\8868\5716\4E0A\5448\73FE\4EE5\8B58\5225\81E8\754C\503C\4E0A\9650\7684\6578\5B57.'),
unistr('\5982\6709\591A\500B\81E8\754C\503C, \8ACB\4F7F\7528\9017\865F\5340\9694\7684\6E05\55AE.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108961908451313336)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109483391596313738)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109219490127313535)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\65BC\986F\793A\6307\5B9A\5C6C\6027\7684\5B57\578B\8272\5F69.</p>'),
unistr('<p>\6307\5B9A\8272\5F69\6642, \662F\4F7F\7528\5341\516D\9032\4F4D\8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A. \5341\516D\9032\4F4D\8868\793A\6CD5\662F\4EE5 #xxyyzz (\4E00\500B # \5F8C\9762\8DDF\8457 3 \500B\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57) \4F86\5B9A\7FA9, \5176\4E2D xx\3001yy \53CA zz \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\96D9\5B57\5143\5341\516D\9032\4F4D\503C.'),
unistr('RGB \4EE3\78BC\662F\4EE5 RGB(xxx,xxx,xxx) \4F86\5B9A\7FA9, \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \7684\6578\5B57, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\55AE\4E00 8 \4F4D\5143\4F4D\5143\7D44\503C.</p>'),
unistr('<p>\5728\7DB2\969B\7DB2\8DEF\4E2D\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5373\53EF\627E\51FA\60A8\60F3\8981\4F7F\7528\4E4B\8272\5F69\7684\5C0D\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109216482554313533)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109218068170313534)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B57\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109216656361313533)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109216514811313533)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109216783299313533)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109216892388313533)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109217053144313533)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109216927393313533)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109217142657313533)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109217261837313533)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109217311743313533)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109217424065313533)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109217599494313533)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109217781209313534)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109217601908313533)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109217818694313534)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109217960693313534)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109216191487313532)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109218599984313534)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B57\578B\5927\5C0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109218739820313534)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.10.D'
,p_message_language=>'zh-tw'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109218834187313534)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.12.D'
,p_message_language=>'zh-tw'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109218989809313534)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.14.D'
,p_message_language=>'zh-tw'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109219064731313535)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.16.D'
,p_message_language=>'zh-tw'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109219164706313535)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.18.D'
,p_message_language=>'zh-tw'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109219215775313535)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.20.D'
,p_message_language=>'zh-tw'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109219382347313535)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.22.D'
,p_message_language=>'zh-tw'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109218678347313534)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.8.D'
,p_message_language=>'zh-tw'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109216391860313533)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109218165509313534)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B57\578B\6A23\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109218380063313534)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\659C\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109218272278313534)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109218421734313534)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\659C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109216255341313532)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109510518896313758)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5716\8868\4E2D\6240\8981\986F\793A\7684\6642\9593\8EF8\985E\578B. \9019\9805\8A2D\5B9A\5C07\6703\4EE5\6642\9593\524D\5F8C\9806\5E8F\81EA\52D5\5448\73FE\5716\8868\8CC7\6599, \5982\679C\60A8\7684\8CC7\6599\9700\8981\4EE5\6642\9593\524D\5F8C\53CD\5411\9806\5E8F\4F86\9032\884C\5448\73FE, \8ACB\52FF\4F7F\7528\6B64\8A2D\5B9A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109510668084313758)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109639523241313862)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\6240\5448\73FE\7684\8CC7\6599, \5957\7528\5716\8868\7684 Oracle JET \5DF2\5B9A\7FA9\9810\8A2D\6642\9593\8EF8\8A2D\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109510784999313758)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109639693969313862)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5C07\4EFB\4F55\6642\9593\8EF8\985E\578B\8A2D\5B9A\503C\5957\7528\81F3\5716\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109510879614313758)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109639757555313862)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6642\9593\8EF8\985E\578B\8A2D\5B9A\503C\5957\7528\81F3\5716\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109510907288313758)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DF7\5408\983B\7387')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109549899829313788)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868\5EA7\6A19\8EF8\4E0A\4EE5\6DF7\5408\983B\7387\986F\793A\7684\6642\9593\503C. \7531\65BC\8CC7\6599\7684\6642\9593\503C\53EF\80FD\6703\6539\8B8A, \56E0\6B64\4E0D\652F\63F4\5806\758A\8655\7406.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109549954301313788)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7565\904E\9593\8DDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109550003003313788)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\8AD6\8CC7\6599\4E2D\662F\5426\5B58\5728\4EFB\4F55\6642\9593\9593\9694, \90FD\6703\4EE5\56FA\5B9A\9593\9694\5448\73FE\5716\8868\5EA7\6A19\8EF8\4E0A\986F\793A\7684\6642\9593\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109510487146313758)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\9593\8EF8\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109483289842313738)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109215607373313532)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\65BC\986F\793A\6307\5B9A\5C6C\6027\7684\5B57\578B\8272\5F69.</p>'),
unistr('<p>\6307\5B9A\8272\5F69\6642, \662F\4F7F\7528\5341\516D\9032\4F4D\8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A. \5341\516D\9032\4F4D\8868\793A\6CD5\662F\4EE5 #xxyyzz (\4E00\500B # \5F8C\9762\8DDF\8457 3 \500B\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57) \4F86\5B9A\7FA9, \5176\4E2D xx\3001yy \53CA zz \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\96D9\5B57\5143\5341\516D\9032\4F4D\503C.'),
unistr('RGB \4EE3\78BC\662F\4EE5 RGB(xxx,xxx,xxx) \4F86\5B9A\7FA9, \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \7684\6578\5B57, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\55AE\4E00 8 \4F4D\5143\4F4D\5143\7D44\503C.</p>'),
unistr('<p>\5728\7DB2\969B\7DB2\8DEF\4E2D\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5373\53EF\627E\51FA\60A8\60F3\8981\4F7F\7528\4E4B\8272\5F69\7684\5C0D\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109215523533313532)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109215225684313532)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B57\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109213850546313531)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109213760494313530)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109213951296313531)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109214079264313531)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109214222312313531)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109214101927313531)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109214310417313531)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109214443303313531)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109214505355313531)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109214689423313531)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109214758647313531)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109214963742313531)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109214837600313531)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109215068530313532)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109215180289313532)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109212343128313529)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109215437432313532)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B57\578B\5927\5C0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109213006303313530)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.10.D'
,p_message_language=>'zh-tw'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109213106554313530)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.12.D'
,p_message_language=>'zh-tw'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109213287496313530)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.14.D'
,p_message_language=>'zh-tw'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109213396110313530)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.16.D'
,p_message_language=>'zh-tw'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109213472879313530)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.18.D'
,p_message_language=>'zh-tw'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109213576628313530)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.20.D'
,p_message_language=>'zh-tw'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109213665860313530)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.22.D'
,p_message_language=>'zh-tw'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109212956532313530)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.8.D'
,p_message_language=>'zh-tw'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109212511769313530)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109215328204313532)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B57\578B\6A23\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109212767483313530)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\659C\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109212615895313530)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109212827071313530)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\659C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109212416576313530)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109836815239314026)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\5728\5716\8868\4E0A\986F\793A\5782\76F4\683C\7DDA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109836321869314025)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5782\76F4\683C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109550827165313788)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5716\8868\7684\7E2E\653E\548C\6372\52D5\884C\70BA. <strong>\5373\6642</strong>\884C\70BA\8868\793A\5716\8868\5728\88AB\64CD\63A7\7684\540C\6642\5C07\6703\6301\7E8C\7684\66F4\65B0,'),
unistr('        \800C<strong>\5EF6\9072</strong>\5247\8868\793A\66F4\65B0\6703\7B49\5230\7E2E\653E/\6372\52D5\52D5\4F5C\5B8C\6210\4E4B\5F8C\518D\9032\884C. <strong>\5373\6642</strong>\7E2E\653E\548C\6372\52D5\96D6\7136\63D0\4F9B\6700\4F73\7684\4E00\822C\4F7F\7528\8005\9AD4\9A57, \4F46\4E26\4E0D\4FDD\8B49'),
unistr('        \5927\578B\8CC7\6599\96C6\6216\5F9E\5C6C\7AEF\7DE9\6162\74B0\5883\7684\5448\73FE\6548\80FD\6216\53EF\7528\6027. \5982\679C\6548\80FD\662F\95DC\9375, \5247\61C9\8A72\6539\7528<strong>\5EF6\9072</strong>\7E2E\653E\548C\6372\52D5.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109511121178313759)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\5716\8868\7684\7E2E\653E\548C\6372\52D5\884C\70BA.'),
unistr('        \7E2E\653E\548C\6372\52D5\53EF\8B93\4E00\822C\4F7F\7528\8005\4F7F\7528\624B\52E2 (\4F8B\5982, \5728\7E6A\5716\5340\4E0A\9032\884C\62D6\66F3\3001\4F7F\7528\6ED1\9F20\6EFE\8F2A, \6216\5169\6307\634F\5408) \4F86\91CD\65B0\8ABF\6574\6240\986F\793A\7684\503C, \4E26\5728\5716\8868\5167\9032\884C\700F\89BD\4EE5\986F\793A\4E0D\540C\7684\5716\8868\503C.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109511324388313759)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EF6\9072')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109590519572313822)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\8CC7\6599\986F\793A\9032\884C\7684\8B8A\66F4\5C07\6703\7B49\5230\7E2E\653E/\6372\52D5\52D5\4F5C\5B8C\6210\4E4B\5F8C\624D\6703\751F\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109511406244313759)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\5EF6\9072\6372\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109590640338313822)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\8CC7\6599\986F\793A\9032\884C\7684\8B8A\66F4\5C07\6703\7B49\5230\6372\52D5\52D5\4F5C\5B8C\6210\4E4B\5F8C\624D\6703\751F\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109511539529313759)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5373\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109590730769313822)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\300C\5373\6642\300D\884C\70BA\8868\793A\5728\64CD\63A7\5716\8868\6642\9084\662F\6703\6301\7E8C\66F4\65B0\5716\8868.'),
unistr('        \91DD\5C0D\5927\578B\8CC7\6599\96C6\6216\6162\901F\5F9E\5C6C\7AEF\74B0\5883, \5EFA\8B70\9078\53D6<strong>\5EF6\9072</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109511673023313759)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\5373\6642\6372\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109590806148313822)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\300C\50C5\5373\6642\6372\52D5\300D\884C\70BA\8868\793A\5728\6372\52D5\5716\8868\6642\9084\662F\6703\6301\7E8C\66F4\65B0\5716\8868.'),
unistr('        \91DD\5C0D\5927\578B\8CC7\6599\96C6\6216\6162\901F\5F9E\5C6C\7AEF\74B0\5883, \8ACB\8003\616E\9078\53D6<strong>\50C5\5EF6\9072\6372\52D5</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109511272066313759)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109590480103313822)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\505C\7528\5716\8868\7684\7E2E\653E\548C\6372\52D5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109511086940313759)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E2E\653E\8207\6372\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110055388140314182)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5716\8868\7684\7E2E\653E\65B9\5411.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110055494303314182)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5169\500B\5EA7\6A19\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110055528346314182)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540C\6642\5728 x \8EF8\548C y \8EF8\65B9\5411\9032\884C\7E2E\653E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110055616545314182)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('X \8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110055794597314182)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\5728 x \8EF8\65B9\5411\9032\884C\7E2E\653E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110055814645314183)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Y \8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110055949784314183)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\5728 y \8EF8\65B9\5411\9032\884C\7E2E\653E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110055283649314182)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E2E\653E\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109839584144314028)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5141\8A31\5C07\5716\8868\523B\5EA6\7E2E\653E\81F3\5929.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109838313891314027)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109839480256314028)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5141\8A31\5C07\5716\8868\523B\5EA6\7E2E\653E\81F3\5C0F\6642.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109838001095314027)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109839300761314028)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5141\8A31\5C07\5716\8868\523B\5EA6\7E2E\653E\81F3\5206\9418.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109837963085314027)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\9418')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109839778848314028)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5141\8A31\5C07\5716\8868\523B\5EA6\7E2E\653E\81F3\6708.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109838756876314027)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109839809923314028)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5141\8A31\5C07\5716\8868\523B\5EA6\7E2E\653E\81F3\5B63.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109838951263314027)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B63')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109839288030314028)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5141\8A31\5C07\5716\8868\523B\5EA6\7E2E\653E\81F3\79D2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109837697323314026)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109839648697314028)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5141\8A31\5C07\5716\8868\523B\5EA6\7E2E\653E\81F3\9031.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109838515022314027)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109839955641314028)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5141\8A31\5C07\5716\8868\523B\5EA6\7E2E\653E\81F3\5E74.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109839142452314027)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109643198512313864)
,p_name=>'PE.PROPERTY.JS_CONDITION.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\63A7\5236\662F\5426\89F8\767C\52D5\4F5C\7684\5F9E\5C6C\7AEF\689D\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109238297845313549)
,p_name=>'PE.PROPERTY.JS_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\63A7\5236\662F\8981\89F8\767C True \9084\662F False \52D5\4F5C\7684\5F9E\5C6C\7AEF\689D\4EF6. \82E5\689D\4EF6'),
unistr('                                  \8A55\4F30\70BA True, \5C31\89F8\767C True \52D5\4F5C, \82E5\689D\4EF6\8A55\4F30\70BA False, \5C31\89F8\767C False \52D5\4F5C.'),
unistr('                                  \82E5\672A\6307\5B9A\689D\4EF6, \5C31\53EA\6703\89F8\767C True \52D5\4F5C.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109749347063313960)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110106052552314236)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\6240\9078<em>\9805\76EE</em>\7684\503C\662F\5426\7B49\65BC\6307\5B9A\7684<em>\503C</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109749500731313960)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE > \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110106218987314236)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\6240\9078<em>\9805\76EE</em>\7684\503C\662F\5426\5927\65BC\6307\5B9A\7684<em>\503C</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109749665896313960)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE >= \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110106307436314237)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\6240\9078<em>\9805\76EE</em>\7684\503C\662F\5426\5927\65BC\6216\7B49\65BC\6307\5B9A\7684<em>\503C</em>.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109750172920313961)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\5728\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110106812596314237)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\6240\9078<em>\9805\76EE</em>\7684\503C\662F\5426\5728\6307\5B9A\7684<em>\6E05\55AE</em>\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109750325383313961)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110107088002314237)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A55\4F30\6307\5B9A\7684\300CJavaScript \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109749749846313960)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE < \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110106415041314237)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\6240\9078<em>\9805\76EE</em>\7684\503C\662F\5426\5C0F\65BC\6307\5B9A\7684<em>\503C</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109749824387313960)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE <= \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110106557563314237)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\6240\9078<em>\9805\76EE</em>\7684\503C\662F\5426\5C0F\65BC\6216\7B49\65BC\6307\5B9A\7684<em>\503C</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109749450785313960)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110106105650314236)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\6240\9078<em>\9805\76EE</em>\7684\503C\662F\5426\4E0D\7B49\65BC\6307\5B9A\7684<em>\503C</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109750281874313961)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\5728\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110106929846314237)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\6240\9078<em>\9805\76EE</em>\7684\503C\662F\5426\4E0D\5728\6307\5B9A\7684<em>\6E05\55AE</em>\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109750005864313961)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110106795677314237)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\9078\53D6\7684<em>\9805\76EE</em>\662F\5426\975E\7A7A\767D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109749909919313961)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110106699466314237)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\9078\53D6\7684<em>\9805\76EE</em>\662F\5426\7A7A\767D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109238170808313549)
,p_name=>'PE.PROPERTY.JS_CONDITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110107437928314238)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\6B64\689D\4EF6\4E2D\4F7F\7528\7684\8CC7\6599\6B04.</p>'),
unistr('<p>\6CE8\610F: \5728\5927\591A\6578\60C5\6CC1\4E0B, \9019\5FC5\9808\662F<em>\6642\6A5F > \8CC7\6599\6B04</em>\4E2D\6307\5B9A\7684\8CC7\6599\6B04,'),
unistr('\56E0\6B64\9810\8A2D\70BA\6B64\8CC7\6599\6B04. \4E0D\904E, \60A8\6709\53EF\80FD\6703\60F3\8981\4EE5\5176\4ED6\8CC7\6599\6B04\4F5C\70BA\689D\4EF6,'),
unistr('\4F8B\5982\4EE5 EMP \8868\683C\70BA\57FA\790E\7684\300C\4E92\52D5\5F0F\65B9\683C\300D\70BA\4F8B, \82E5\60A8\60F3\5728 <code>SAL</code> \8B8A\66F4\6642\89F8\767C\67D0\500B\52D5\614B\52D5\4F5C'),
unistr('(\524D\63D0\70BA <code>JOB</code> \7B49\65BC <em>SALESMAN</em>), \60A8\53EF\4EE5\5C07\6B64\5C6C\6027\8B8A\66F4\70BA <code>JOB</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110102014007314233)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110108713338314240)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\689D\4EF6\4E2D\662F\8981\4F7F\7528<em>\9805\76EE</em>\9084\662F<em>\8CC7\6599\6B04</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110097553845314214)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.COLUMN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110097479062314213)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110097374366314213)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109643202967313864)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8F38\5165\6B64\689D\4EF6\4E2D\4F7F\7528\7684\9801\9762\9805\76EE. \60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\8005\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\6311\9078.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109643074548313864)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8F38\5165\6B64\689D\4EF6\4E2D\4F7F\7528\7684\9801\9762\9805\76EE. \60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\8005\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\6311\9078.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110107596660314238)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\6B64\689D\4EF6\4E2D\4F7F\7528\7684\9801\9762\9805\76EE. \60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\8005\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\6311\9078.</p>'),
unistr('<p>\6CE8\610F: \5728\5927\591A\6578\60C5\6CC1\4E0B, \9019\5FC5\9808\662F <em>When \9805\76EE</em>\4E2D\6307\5B9A\7684\9805\76EE,'),
unistr('\56E0\6B64\9810\8A2D\70BA\6B64\9805\76EE. \4E0D\904E, \60A8\6709\53EF\80FD\6703\60F3\8981\4EE5\5176\4ED6\9801\9762\9805\76EE\4F5C\70BA\689D\4EF6,'),
unistr('\4F8B\5982\4EE5 EMP \8868\683C\70BA\57FA\790E\7684\8868\55AE\70BA\4F8B, \82E5\60A8\60F3\5728 <code>P2_SAL</code> \8B8A\66F4\6642\89F8\767C\67D0\500B\52D5\614B\52D5\4F5C'),
unistr('(\524D\63D0\70BA <code>P2_JOB</code> \7B49\65BC <em>SALESMAN</em>), \60A8\53EF\4EE5\5C07\6B64\5C6C\6027\8B8A\66F4\70BA <code>P2_JOB</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110097687376314214)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110107389514314238)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\4E2D\4F7F\7528\7684\9801\9762\9805\76EE. \60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\8005\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\6311\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110101961351314233)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109643300791313864)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\63A7\5236\662F\5426\89F8\767C\52D5\4F5C\7684\5F9E\5C6C\7AEF\689D\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110102277776314233)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\63A7\5236\662F\8981\89F8\767C True \9084\662F False \52D5\4F5C\7684\5F9E\5C6C\7AEF\689D\4EF6. \82E5\689D\4EF6'),
unistr('                                  \8A55\4F30\70BA True, \5C31\89F8\767C True \52D5\4F5C, \82E5\689D\4EF6\8A55\4F30\70BA False, \5C31\89F8\767C False \52D5\4F5C.'),
unistr('                                  \82E5\672A\6307\5B9A\689D\4EF6, \5C31\53EA\6703\89F8\767C True \52D5\4F5C.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110102358504314233)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE / \8CC7\6599\6B04 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110107685615314239)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\6240\9078<em>\9805\76EE</em>\6216<em>\8CC7\6599\6B04</em>\7684\503C\662F\5426\7B49\65BC\6307\5B9A\7684<em>\503C</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110102562322314233)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE / \8CC7\6599\6B04 > \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110107815408314239)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\6240\9078<em>\9805\76EE</em>\6216<em>\8CC7\6599\6B04</em>\7684\503C\662F\5426\5927\65BC\6307\5B9A\7684<em>\503C</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110102639075314233)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE / \8CC7\6599\6B04 >= \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110107925355314239)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\6240\9078<em>\9805\76EE</em>\6216<em>\8CC7\6599\6B04</em>\7684\503C\662F\5426\5927\65BC\6216\7B49\65BC\6307\5B9A\7684<em>\503C</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110103134277314234)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE / \8CC7\6599\6B04\5728\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110108407792314239)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\6240\9078<em>\9805\76EE</em>\6216<em>\8CC7\6599\6B04</em>\7684\503C\662F\5426\5728\6307\5B9A\7684<em>\6E05\55AE</em>\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110103303590314234)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110108606728314239)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A55\4F30\6307\5B9A\7684\300CJavaScript \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110102772188314233)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE / \8CC7\6599\6B04 < \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110108085993314239)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\6240\9078<em>\9805\76EE</em>\6216<em>\8CC7\6599\6B04</em>\7684\503C\662F\5426\5C0F\65BC\6307\5B9A\7684<em>\503C</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110102891340314234)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE / \8CC7\6599\6B04 <= \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110108114590314239)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\6240\9078<em>\9805\76EE</em>\6216<em>\8CC7\6599\6B04</em>\7684\503C\662F\5426\5C0F\65BC\6216\7B49\65BC\6307\5B9A\7684<em>\503C</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110102403937314233)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE / \8CC7\6599\6B04 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110107775507314239)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\6240\9078<em>\9805\76EE</em>\6216<em>\8CC7\6599\6B04</em>\7684\503C\662F\5426\4E0D\7B49\65BC\6307\5B9A\7684<em>\503C</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110103293297314234)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE / \8CC7\6599\6B04\4E0D\5728\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110108561996314239)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\6240\9078<em>\9805\76EE</em>\6216<em>\8CC7\6599\6B04</em>\7684\503C\662F\5426\4E0D\5728\6307\5B9A\7684<em>\6E05\55AE</em>\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110103015785314234)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE / \8CC7\6599\6B04\4E0D\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110108390315314239)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\9078\53D6\7684<em>\9805\76EE</em>\6216<em>\8CC7\6599\6B04</em>\662F\5426\975E\7A7A\767D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110102996155314234)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE / \8CC7\6599\6B04\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110108219839314239)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\9078\53D6\7684<em>\9805\76EE</em>\6216<em>\8CC7\6599\6B04</em>\662F\5426\7A7A\767D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110102171124314233)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109642927775313864)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\8981\91DD\5C0D\6B64\689D\4EF6\8A55\4F30\7684\300CJavaScript \8868\793A\5F0F\300D.'),
unistr('\7A0B\5F0F\78BC\53EF\4EE5\5B58\53D6\4E0B\5217\52D5\614B\52D5\4F5C\76F8\95DC\5C6C\6027:</p>'),
'<dl>',
'  <dt>this.triggeringElement</dt>',
unistr('    <dd>\89F8\767C\52D5\614B\52D5\4F5C\4E4B\5143\7D20\7684 DOM \7269\4EF6\53C3\7167.</dd>'),
'  <dt>this.browserEvent</dt>',
unistr('    <dd>\89F8\767C\4E8B\4EF6\7684\4E8B\4EF6\7269\4EF6. \6CE8\610F: \8F09\5165\6642, \9019\7B49\65BC ''load''.</dd>'),
'  <dt>this.data</dt>',
unistr('    <dd>\53EF\4EE5\5F9E\4E8B\4EF6\8655\7406\7A0B\5F0F\50B3\9001\7684\9078\64C7\6027\984D\5916\8CC7\6599.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109642875963313864)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110103982109314234)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\8981\91DD\5C0D\6B64\689D\4EF6\8A55\4F30\7684\300CJavaScript \8868\793A\5F0F\300D.'),
unistr('\7A0B\5F0F\78BC\53EF\4EE5\5B58\53D6\4E0B\5217\52D5\614B\52D5\4F5C\76F8\95DC\5C6C\6027:</p>'),
'<dl>',
'  <dt>this.triggeringElement</dt>',
unistr('    <dd>\89F8\767C\52D5\614B\52D5\4F5C\4E4B\5143\7D20\7684 DOM \7269\4EF6\53C3\7167.</dd>'),
'  <dt>this.browserEvent</dt>',
unistr('    <dd>\89F8\767C\4E8B\4EF6\7684\4E8B\4EF6\7269\4EF6. \6CE8\610F: \8F09\5165\6642, \9019\7B49\65BC ''load''.</dd>'),
'  <dt>this.data</dt>',
unistr('    <dd>\53EF\4EE5\5F9E\4E8B\4EF6\8655\7406\7A0B\5F0F\50B3\9001\7684\9078\64C7\6027\984D\5916\8CC7\6599.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110103852063314234)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110101846801314233)
,p_name=>'PE.PROPERTY.JS_COND_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\503C\6E05\55AE (\4F7F\7528\9017\865F\5340\9694).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110101715914314233)
,p_name=>'PE.PROPERTY.JS_COND_LIST.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110103712701314234)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\6E2C\8A66\4E4B\689D\4EF6\7684\503C\6E05\55AE (\4F7F\7528\9017\865F\5340\9694).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110103612970314234)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110142324940314265)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110142263267314265)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110103563335314234)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\6E2C\8A66\4E4B\689D\4EF6\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110103423623314234)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109238997970313549)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\5C07\5728\8F09\5165\9801\9762\6642\57F7\884C\7684 JavaScript \7A0B\5F0F\78BC.'),
unistr('\6B64\7A0B\5F0F\78BC\6703\5728 &PRODUCT_NAME. \7522\751F\7684 JavaScript \7A0B\5F0F\78BC\4E4B\5F8C\57F7\884C.</p>'),
unistr('<p>\60A8\5728\6B64\8655\8F38\5165\7684\7A0B\5F0F\78BC\6703\53D6\4EE3\9801\9762\6A23\677F\4E2D\7684 <code>#GENERATED_JAVASCRIPT#</code> \66FF\4EE3\5B57\4E32.</p>'),
unistr('<p>\6CE8\610F: \60A8\4E0D\9700\8981\6DFB\52A0\4EFB\4F55\958B\59CB\6216\7D50\675F\7684 <code>script</code> \6A19\8A18, \53EA\9700\8981\8F38\5165 JavaScript \7A0B\5F0F\78BC\5C31\53EF\4EE5\4E86.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109238848143313549)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\9801\9762\6642\57F7\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109741279352313954)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\6A19\6E96\6A94\6848\53C3\7167</dt>'),
'<dd><pre>/myjs/main.js</pre></dd>',
unistr('<dt>\91DD\5C0D\4E00\822C\9801\9762\6AA2\8996\5F9E <code>/myjs/minified/</code> \8F09\5165\7E2E\5C0F\7684\6A94\6848 <code>main.min.js</code> \4EE5\53CA\5728\9664\932F\6A21\5F0F\5F9E <code>/myjs/</code> \8F09\5165 <code>main.js</code>, \6216\8005\5F9E\61C9\7528\7A0B\5F0F\7522\751F\5668\57F7\884C\61C9\7528\7A0B\5F0F\6642\7684\6A19\6E96\6A94\6848\53C3\7167.</dt>'),
'<dd><pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre></dd>',
unistr('<dt>\5982\679C\4E5F\6703\900F\904E RequireJS require \547C\53EB\4F7F\7528\7A0B\5F0F\5EAB, \8ACB\4F7F\7528\6B64\8A9E\6CD5. define \540D\7A31\5FC5\9808\8207 requirejs.config \8DEF\5F91\4E2D\4F7F\7528\7684\76F8\540C, \800C\503C\5FC5\9808\662F\7A0B\5F0F\5EAB\986F\793A\7684\5168\57DF\7B26\865F. \9019\53EA\6709\5728\4F7F\7528 RequireJS \6642\9069\7528. \5982\6B64\53EF\907F\514D RequireJS \91CD\65B0\8F09\5165\8A72\7A0B\5F0F\5EAB.</dt>'),
'<dd><pre>[define hammerjs=Hammer]/myjs/hammer.js</pre></dd>',
unistr('<dt>\5982\679C\6A94\6848\76F8\4F9D\65BC RequireJS, \8ACB\4F7F\7528\6B64\8A9E\6CD5. \9019\6703\81EA\52D5\65BC\6B64\6A94\6848\4E4B\524D\5148\884C\8F09\5165 RequireJS.</dt>'),
'<dd><pre>[require requirejs]/myjs/main.js</pre></dd>',
unistr('<dt>\5982\679C\6A94\6848\76F8\4F9D\65BC Oracle JET, \8ACB\4F7F\7528\6B64\8A9E\6CD5. \9019\6703\81EA\52D5\65BC\6B64\6A94\6848\4E4B\524D\5148\884C\8F09\5165 RequireJS \548C Oracle JET RequireJS \7D44\614B.</dt>'),
'<dd><pre>[require jet]/myjs/main.js</pre></dd>',
unistr('<dt>\5728\53C3\7167\61C9\7528\7A0B\5F0F\7248\672C\4E4B URL \4E2D\4F7F\7528\67E5\8A62\5B57\4E32\7684\6A94\6848\53C3\7167, \5982\6B64\7576\61C9\7528\7A0B\5F0F\5347\7D1A\5F8C (\4E14\7248\672C\905E\589E), \7CFB\7D71\6703\6307\793A\700F\89BD\5668\4E00\5F8B\8F09\5165\65B0\6A94\6848, \4E26\5FFD\7565\6240\6709\5148\524D\5FEB\53D6\7684\6A94\6848.</dt>'),
'<dd><pre>/myjs/main.js?version=#APP_VERSION#</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109238511632313549)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\9801\9762\4E2D\8F09\5165\4E4B\7A0B\5F0F\78BC\7684 JavaScript \6A94\6848 URL. \6BCF\500B URL \90FD\5FC5\9808\5404\81EA\7368\7ACB\4E00\884C.'),
unistr('\5982\679C\60A8\63D0\4F9B\7684\662F\7E2E\5C0F\7684\6A94\6848\7248\672C, \90A3\9EBC\60A8\53EF\4EE5\91DD\5C0D\4E00\822C\9801\9762\6AA2\8996\4F7F\7528\66FF\4EE3\5B57\4E32 <code>#MIN#</code> \6216 <code>#MIN_DIRECTORY#</code>, \5206\5225\5728\60A8\7684\6A94\6848 URL \4E2D\5305\62EC <code>.min</code> \6216 <code>minified/</code>, \82E5\662F\9801\9762\5728\9664\932F\6A21\5F0F\6AA2\8996\6216\5F9E\61C9\7528\7A0B\5F0F\7522\751F\5668\57F7\884C\61C9\7528\7A0B\5F0F\6642, \8ACB\4F7F\7528\7A7A\767D\5B57\4E32.'),
unistr('\5982\679C\60A8\60F3\8981\5728\6A94\6848 URL \4E2D\5305\62EC\61C9\7528\7A0B\5F0F\7684\7248\672C, \4E5F\53EF\4EE5\4F7F\7528\66FF\4EE3\5B57\4E32 <code>#APP_VERSION#</code>.</p>'),
unistr('<p>\60A8\5728\6B64\8655\8F38\5165\7684 JavaScript \6A94\6848 URL \6703\53D6\4EE3\9801\9762\6A23\677F\4E2D\7684 <code>#PAGE_JAVASCRIPT#</code> \66FF\4EE3\5B57\4E32.</p>'),
unistr('<p>\6CE8\610F: \60A8\4E0D\9700\8981\5305\62EC\958B\982D\6216\7D50\5C3E <code>script</code> \6A19\8A18. \53EA\8981\6307\5B9A URL \5C31\53EF\4EE5\4E86.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109238474769313549)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109238725337313549)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\5728\6B64\9801\9762\53C3\7167\7684 JavaScript \7A0B\5F0F\78BC (\4F8B\5982, \51FD\6578\6216\5168\57DF\8B8A\6578\5BA3\544A).'),
unistr('\82E5\8981\53C3\7167\6377\5F91, \8ACB\4F7F\7528 <code>"SHORTCUTNAME"</code>.'),
unistr('\5982\679C\5728\591A\500B\9801\9762\9700\8981\76F8\540C\7684 JavaScript, \8ACB\8003\616E\5C07\5B83\653E\5165\5916\90E8 JavaScript \6A94\6848\4EE5\907F\514D\91CD\8907, \4EE5\53CA\5229\7528\975C\614B\6A94\6848\7684\700F\89BD\5668\5FEB\53D6.</p>'),
unistr('<p>\60A8\5728\6B64\8655\8F38\5165\7684\7A0B\5F0F\78BC\6703\53D6\4EE3\9801\9762\6A23\677F\4E2D\7684 <code>#PAGE_JAVASCRIPT#</code> \66FF\4EE3\5B57\4E32.</p>'),
unistr('<p>\6CE8\610F: \60A8\4E0D\9700\8981\5305\62EC\958B\59CB\6216\7D50\675F\7684 <code>script</code> \6A19\8A18. \53EA\9700\8981\5305\62EC JavaScript \7A0B\5F0F\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109238675334313549)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\548C\5168\57DF\8B8A\6578\5BA3\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110079399855314199)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\9762\5411\7684\6A19\7C64.'),
unistr('    \53EA\6709\7576\9762\5411\986F\793A\6642, \6A19\7C64\624D\6703\986F\793A\5728\9801\9762\4E0A. \985E\578B<strong>\641C\5C0B</strong>\7684\6A19\7C64\5728\8996\89BA\4E0A\662F\96B1\85CF\7684, \4F46\53EF\4F9B\8F14\52A9\6280\8853\4F7F\7528.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109918792444314085)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('~\8F38\5165\9762\5411\7FA4\7D44\7684\6A19\7C64.~')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109918913571314085)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\9762\5411\7684\6A19\7C64.'),
unistr('    \53EA\6709\7576\9762\5411\986F\793A\6642, \6A19\7C64\624D\6703\986F\793A\5728\9801\9762\4E0A. \985E\578B<strong>\641C\5C0B</strong>\7684\6A19\7C64\5728\8996\89BA\4E0A\662F\96B1\85CF\7684, \4F46\53EF\4F9B\8F14\52A9\6280\8853\4F7F\7528.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109281977827313586)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7BE9\9078\7684\6A19\7C64.'),
unistr('    \53EA\6709\7576\7BE9\9078\986F\793A\6642, \6A19\7C64\624D\6703\986F\793A\5728\9801\9762\4E0A. \985E\578B<strong>\641C\5C0B</strong>\7684\6A19\7C64\5728\8996\89BA\4E0A\662F\96B1\85CF\7684, \4F46\53EF\4F9B\8F14\52A9\6280\8853\4F7F\7528.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109282881362313587)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('~\8F38\5165\7BE9\9078\7FA4\7D44\7684\6A19\7C64.~')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109283269025313587)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7BE9\9078\7684\6A19\7C64.'),
unistr('    \53EA\6709\7576\7BE9\9078\986F\793A\6642, \6A19\7C64\624D\6703\986F\793A\5728\9801\9762\4E0A. \985E\578B<strong>\641C\5C0B</strong>\7684\6A19\7C64\5728\8996\89BA\4E0A\662F\96B1\85CF\7684, \4F46\53EF\4F9B\8F14\52A9\6280\8853\4F7F\7528.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109264419414313568)
,p_name=>'PE.PROPERTY.LABEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\9801\9762\9805\76EE\7684\6B04\4F4D\6A19\7C64.'),
unistr('\53EA\6709\5728\9805\76EE\986F\793A\6642, \9801\9762\4E0A\624D\6703\986F\793A\6A19\7C64.'),
unistr('\8996\6A19\7C64\7684\5C0D\9F4A\8207\986F\793A\65B9\5F0F\800C\5B9A, \6A19\7C64\6703\986F\793A\5728\81EA\5DF1\7684 HTML \8868\683C\5132\5B58\683C\4E2D, \6216\5728\76F8\540C\7684\5132\5B58\683C\4E2D.</p>'),
unistr('<p>\9805\76EE\6A19\7C64\53EF\4EE5\4F7F\7528 <code>"SHORTCUT_NAME"</code> \8A9E\6CD5\4F86\5305\542B\6377\5F91.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109264320258313568)
,p_name=>'PE.PROPERTY.LABEL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109264618972313568)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\6A19\7C64\5C0D\9F4A\65B9\5F0F. \6A19\7C64\53EF\4EE5\986F\793A\5728\9805\76EE\7684\4E0A\65B9, \4E0B\65B9\6216\5DE6\65B9.'),
unistr('\6A19\7C64\986F\793A\5728\8868\55AE\5143\7D20\7684\65C1\908A\6642, \6703\4F54\7528\81EA\5DF1\7684 HTML \8868\683C\5132\5B58\683C.'),
unistr('\900F\904E\8B8A\66F4\6B64\6A19\7C64\7684\5C0D\9F4A\65B9\5F0F, \60A8\53EF\4EE5\63A7\5236\8868\683C\5132\5B58\683C\5167\6A19\7C64\7684\4F4D\7F6E.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109752784274313963)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.ABOVE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\65B9 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109752803525313963)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.BELOW.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109753095815313963)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\9593\4E0B\5074')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109753175114313963)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\9593\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109753232826313963)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\9593\4E0A\5074')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109752968337313963)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109753444772313963)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE6\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109753508818313963)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE6\5074\7F6E\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109753670572313963)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE6\4E0A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109753317669313963)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9760\5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109753879228313964)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53F3\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109753936033313964)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53F3\5074\7F6E\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109754074083313964)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53F3\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109753795797313963)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9760\53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109264532548313568)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\9F4A\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110081847571314201)
,p_name=>'PE.PROPERTY.LAZY_LOADING.COMPONENT_PROPERTY.CARD.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\8F09\5165\5340\57DF, \800C\4E0D\7BA1\8A72\5340\57DF\7684\8CC7\6599.</p>'),
unistr('        <p>\6307\5B9A\9072\7DE9\8F09\5165\6642, \9664\975E\8F09\5165\8CC7\6599, \5426\5247\6703\7ACB\5373\5448\73FE\9801\9762 (\5176\986F\793A\7A7A\7684\5340\57DF).'),
unistr('        \4E00\822C, \9664\975E\6240\6709\9801\9762\90FD\5DF2\8F09\5165\4E26\6E96\5099\597D\9032\884C\5448\73FE, \5426\5247\4E0D\6703\986F\793A\9801\9762.'),
unistr('        \56E0\6B64, \4E0D\4F7F\7528\9072\7DE9\8F09\5165\6642, \5982\679C\8F09\5165\67D0\500B\5340\57DF\7684\6240\6709\8CC7\6599\9700\8981 5 \79D2\9418\7684\6642\9593, \5247\4E00\822C\4F7F\7528\8005\5FC5\9808\5148\7B49\5F85 5 \79D2, \624D\6703\958B\59CB\5448\73FE\9801\9762.</p>'),
unistr('        <p>\6CE8\610F - \53EA\61C9\8A72\5C0D\9700\8981\5927\91CF\6642\9593\8F09\5165\7684\8CC7\6599\96C6\4F7F\7528\9072\7DE9\8F09\5165, \56E0\70BA\9019\6703\589E\52A0\8CC7\6599\5EAB\5FEB\901F\8F09\5165\4E4B\5340\57DF\7684\4E0D\5FC5\8981\8655\7406\8CA0\8377.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109460726238313721)
,p_name=>'PE.PROPERTY.LAZY_LOADING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\8F09\5165\5340\57DF, \800C\4E0D\7BA1\8A72\5340\57DF\7684\8CC7\6599.</p>'),
unistr('        <p>\6307\5B9A\9072\7DE9\8F09\5165\6642, \9664\975E\8F09\5165\8CC7\6599, \5426\5247\6703\7ACB\5373\5448\73FE\9801\9762 (\5176\986F\793A\7A7A\7684\5340\57DF).'),
unistr('        \4E00\822C, \9664\975E\6240\6709\9801\9762\90FD\5DF2\8F09\5165\4E26\6E96\5099\597D\9032\884C\5448\73FE, \5426\5247\4E0D\6703\986F\793A\9801\9762.'),
unistr('        \56E0\6B64, \4E0D\4F7F\7528\9072\7DE9\8F09\5165\6642, \5982\679C\8F09\5165\67D0\500B\5340\57DF\7684\6240\6709\8CC7\6599\9700\8981 5 \79D2\9418\7684\6642\9593, \5247\4E00\822C\4F7F\7528\8005\5FC5\9808\5148\7B49\5F85 5 \79D2, \624D\6703\958B\59CB\5448\73FE\9801\9762.</p>'),
unistr('        <p>\6CE8\610F - \53EA\61C9\8A72\5C0D\9700\8981\5927\91CF\6642\9593\8F09\5165\7684\8CC7\6599\96C6\4F7F\7528\9072\7DE9\8F09\5165, \56E0\70BA\9019\6703\589E\52A0\8CC7\6599\5EAB\5FEB\901F\8F09\5165\4E4B\5340\57DF\7684\4E0D\5FC5\8981\8655\7406\8CA0\8377.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109460652989313721)
,p_name=>'PE.PROPERTY.LAZY_LOADING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9072\7DE9\8F09\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109900438221314072)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\53EF\6309\5716\4F8B\4E2D\7684\5716\5C64\540D\7A31\4F86\5207\63DB\5716\5C64\7684\53EF\898B\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109900391630314072)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\96B1\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109900650437314072)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\5716\5C64\5728\5716\4F8B\4E2D\7684\986F\793A\5716\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109900529812314072)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109516143236313762)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5716\8868\5716\4F8B\7684\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109516293881313762)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.AUTO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109516500682313763)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.BOTTOM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E95\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109516401268313763)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.END.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109516339131313762)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.START.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109516665406313763)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.TOP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9802\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109516073911313762)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109515901897313762)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\61C9\8A72\5728\5716\8868\4E0A\5448\73FE\5716\4F8B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109515888271313762)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109900813151314072)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.COMPONENT_PROPERTY.MAP_REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5716\4F8B\7684\6A19\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109627055835313853)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8981\986F\793A\5728\5716\8868\5716\4F8B\9802\7AEF\7684\6A19\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109626998020313853)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109522001980313767)
,p_name=>'PE.PROPERTY.LINE_STYLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8981\5728\5716\8868\4E0A\5448\73FE\7684\7DDA\689D\6A23\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109522263632313767)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DASHED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\865B\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109522180010313767)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DOTTED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9EDE\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109522308891313767)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.SOLID.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BE6\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109521956551313766)
,p_name=>'PE.PROPERTY.LINE_STYLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109522873189313767)
,p_name=>'PE.PROPERTY.LINE_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8981\5728\5716\8868\4E0A\5448\73FE\7684\7DDA\689D\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109522976753313767)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.AUTO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109523213869313767)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSEGMENTED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7F6E\4E2D\5206\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109523062334313767)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSTEPPED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7F6E\4E2D\968E\68AF\72C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109523100973313767)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CURVED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F2\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109523518489313768)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.NONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109523485932313768)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.SEGMENTED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109523341977313768)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STEPPED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\68AF\72C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109523662654313768)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STRAIGHT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F4\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109522767046313767)
,p_name=>'PE.PROPERTY.LINE_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109522561658313767)
,p_name=>'PE.PROPERTY.LINE_WIDTH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8981\5728\5716\8868\4E0A\5448\73FE\7684\7DDA\689D\5BEC\5EA6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109522479177313767)
,p_name=>'PE.PROPERTY.LINE_WIDTH.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109522609827313767)
,p_name=>'PE.PROPERTY.LINE_WIDTH.UNIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109769666691313976)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5728\65B0\8996\7A97\4E2D\958B\555F\9023\7D50</dt>'),
'<dd><pre>target="_blank"</pre></dd>',
unistr('<dt>\6E38\6A19\505C\7559\6642\986F\793A\5DE5\5177\63D0\793A</dt>'),
unistr('<dd><pre>title="\6309\4E00\4E0B\4F86\9032\884C\7DE8\8F2F"</pre></dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109566685627313804)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5305\62EC\5728 <code>&lt;a href=...&gt;</code> \6A19\8A18\4E2D\7684\5176\4ED6\8CC7\6599\6B04\9023\7D50\5C6C\6027 (\5305\62EC\9023\7D50\76EE\6A19\3001\985E\5225\6216\6A23\5F0F).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109566586402313804)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109572388678313809)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\8207\300C\9023\7D50\8CC7\6599\6B04\300D\5EFA\7ACB\95DC\806F\7684\6388\6B0A\914D\7F6E. \6B64\6388\6B0A\914D\7F6E\5FC5\9808\8A55\4F30\70BA TRUE, \624D\80FD\5728\5831\8868\4E2D\5448\73FE\300C\9023\7D50\8CC7\6599\6B04\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109572295917313809)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109984630326314132)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\8A55\4F30\6240\8F38\5165\8868\793A\5F0F\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109985036936314133)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109984918208314133)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109984879479314133)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109985112345314133)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109984709917314133)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109984594720314132)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109986672861314134)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\51FD\6578\4E3B\9AD4\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109986927770314134)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109986832660314134)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109986795521314134)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109987015922314134)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109986573815314134)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109580977821313815)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5728\6B64\689D\4EF6\4F7F\7528\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\5F9E\53EF\7528\9805\76EE\7684\6E05\55AE\4E2D\6311\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109580872516313815)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109582362965313816)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5728\6B64\689D\4EF6\4F7F\7528\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\5F9E\53EF\7528\9805\76EE\7684\6E05\55AE\4E2D\6311\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109582292307313816)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109986282356314134)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CJava \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109986198311314134)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109987828894314135)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\689D\4EF6\5E03\6797\503C\7684 Java \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109987759545314135)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109986050847314134)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109985992578314133)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CJavaScript \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109985867338314133)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109987660014314135)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109987585279314135)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\689D\4EF6\5E03\6797\503C\7684 JavaScript \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109987484989314134)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109581162755313815)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\503C\6E05\55AE (\4F7F\7528\5192\865F (:) \5340\9694).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109581009980313815)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109581593025313815)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300C\9801\78BC\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109581413073313815)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109581792516313816)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300C\9801\78BC\300D\6E05\55AE (\4F7F\7528\9017\865F\5340\9694).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109581660150313816)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109985795659314133)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109985684891314133)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CPL/SQL \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109985503306314133)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109987395312314134)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109987202860314134)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\689D\4EF6\5E03\6797\503C\7684 PL/SQL \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109987198062314134)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109581348219313815)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\6B64\689D\4EF6\6307\5B9A\503C\9032\884C\6BD4\8F03\7684\300C\4F7F\7528\8005\504F\597D\8A2D\5B9A\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109581202611313815)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109986441898314134)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CPython \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109986359573314134)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109988073227314135)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\689D\4EF6\5E03\6797\503C\7684 Python \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109987902274314135)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109985452956314133)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\70BA\4E3B\7BA1\4E14\5176\90E8\9580\4F4D\65BC\829D\52A0\54E5\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109985344303314133)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CSQL \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109985249501314133)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110127572230314254)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\6AA2\67E5\54E1\5DE5\662F\5426\7DE8\5236\5728\90E8\9580 30, \5982\6709\4E00\6216\591A\500B\8CC7\6599\5217\5B58\5728\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\6AA2\67E5\54E1\5DE5\662F\5426\7DE8\5236\5728\90E8\9580 40, \5982\7121\4EFB\4F55\8CC7\6599\5217\5B58\5728\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109580566056313815)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684 SQL \67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109580486204313815)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109581976833313816)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\6587\5B57\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109581824223313816)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109582585580313816)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\503C (\5305\542B <code>&ITEM.</code> \66FF\4EE3\5B57\4E32).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109582437208313816)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109580323852313815)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\4E00\500B\5FC5\9808\7B26\5408\7684\689D\4EF6\985E\578B, \4EE5\8B93\6B64\9023\7D50\9032\884C\5448\73FE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109831483384314022)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\6210\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109967174951314120)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4E00\5F8B\5448\73FE\5143\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109830029108314021)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF\700F\89BD\5668\70BA Microsoft Internet Explorer 7.0 \6216\66F4\65B0\7684\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109830114215314021)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF\700F\89BD\5668\70BA XHTML / CSS \529F\80FD\700F\89BD\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109829983995314020)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF\700F\89BD\5668\70BA Mozilla\3001Netscape 6.x/7x \6216\66F4\65B0\7684\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109830251922314021)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF\700F\89BD\5668\70BA\5176\4ED6\700F\89BD\5668 (\6216\66F4\820A\7684\7248\672C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109828603366314020)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\5305\542B\5728\9805\76EE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109830649606314021)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8A9E\8A00 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109970771257314122)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\76EE\524D\4F7F\7528\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\8A9E\8A00\57F7\884C\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109830310959314021)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8A9E\8A00\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109970917383314123)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\76EE\524D\4F7F\7528\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\5176\4E2D\4E00\7A2E\8A9E\8A00\57F7\884C\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109830505501314021)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8A9E\8A00 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109970866682314122)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\76EE\524D\672A\4F7F\7528\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\8A9E\8A00\57F7\884C\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109830468167314021)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8A9E\8A00\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109971001571314123)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\76EE\524D\4E0D\662F\4F7F\7528\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\5176\4E2D\4E00\7A2E\8A9E\8A00\57F7\884C\61C9\7528\7A0B\5F0F.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109827879059314019)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762 = \9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109969594052314122)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\7B49\65BC\60A8\5728<em>\9801\9762</em>\4E2D\8F38\5165\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109828021342314019)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\5728\9017\865F\5340\9694\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109969710203314122)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\5728\60A8\65BC<em>\9801\9762</em>\4E2D\8F38\5165\7684\6E05\55AE (\4EE5\9017\865F\5340\9694) \4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109827981153314019)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762 != \9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109969612877314122)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\4E0D\7B49\65BC\60A8\5728<em>\9801\9762</em>\4E2D\8F38\5165\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109828101610314019)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\4E0D\5728\9017\865F\5340\9694\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109969849955314122)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\4E0D\5728\60A8\65BC<em>\9801\9762</em>\4E2D\8F38\5165\7684\6E05\55AE (\4EE5\9017\865F\5340\9694) \4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109830734042314021)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: DAD_NAME = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109830833375314021)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: DAD_NAME != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109829554331314020)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5167\5D4C\9A57\8B49\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109970559573314122)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\986F\793A\5167\5D4C\9A57\8B49\932F\8AA4, \63A5\8457\9001\51FA\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109828953789314020)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109828753185314020)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109828856574314020)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109829020815314020)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109825574013314017)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109967254152314120)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62\50B3\56DE\4E00\6216\591A\500B\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109984378928314132)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109984469194314132)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F\8A55\4F30\70BA TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109825745908314017)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109967492220314120)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\4E3B\9AD4\50B3\56DE TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109831190043314021)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109831217035314021)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109829270199314020)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762/\5340\57DF\975E\552F\8B80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109970229100314122)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\9069\7528, \9801\9762\548C\7236\9805\5340\57DF\6703\6B63\5E38\986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109829125037314020)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762/\5340\57DF\70BA\552F\8B80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109970130739314122)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\9069\7528, \9801\9762\6216\7236\9805\5340\57DF\7684\300C\552F\8B80\300D\689D\4EF6\6703\8A55\4F30\70BA TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109827045577314018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\5305\542B\7A7A\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109968777676314121)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\6C92\6709\7A7A\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109827337628314019)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\70BA\6587\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109969094068314121)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\70BA\6587\6578\5B57, \50C5\5305\542B\5B57\6BCD\8207\6578\5B57\4E14\6C92\6709\7279\6B8A\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109826573264314018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109968285682314121)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\975E\7A7A\767D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109827273376314018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\70BA\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109968917590314121)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\4E0D\662F\6578\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109826727424314018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\70BA\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109968486380314121)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\4E0D\662F\6578\5B57\96F6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109826418394314018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109968191595314120)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\70BA\7A7A\767D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109826865746314018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\662F\7A7A\503C\6216\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109968541905314121)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\70BA\7A7A\767D\6216\6578\5B57\96F6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109827150954314018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\70BA\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109968895724314121)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\662F\6578\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109826686107314018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\70BA\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109968309581314121)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\662F\6578\5B57\96F6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109826977623314018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\662F\7A7A\503C\4E5F\4E0D\70BA\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109968661128314121)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\975E\7A7A\767D\4E5F\4E0D\662F\6578\5B57\96F6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109829703056314020)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \5831\8868 (\78BA\5B9A\53EF\4EE5\986F\793A\4E0B\4E00\9801\6309\9215)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109829879783314020)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \5831\8868 (\78BA\5B9A\53EF\986F\793A\4E0A\4E00\9801\6309\9215)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109831350946314022)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\4E0D\6210\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109971144932314123)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E00\5F8B\4E0D\5448\73FE\5143\4EF6.</p>'),
unistr('<p>\6CE8\610F: \5C07\689D\4EF6\8B8A\66F4\70BA<strong>\4E00\5F8B\4E0D\5448\73FE</strong>\5C07\79FB\9664\6240\6709\73FE\6709\689D\4EF6. \82E5\8981\66AB\6642\505C\7528\67D0\5143\4EF6, Oracle \5EFA\8B70\60A8\6539\7528<em>\7D44\5EFA\9078\9805</em>\5C6C\6027.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109829686518314020)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\986F\793A\5167\5D4C\9A57\8B49\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109970611970314122)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\672A\986F\793A\5167\5D4C\9A57\8B49\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109825681670314017)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\50B3\56DE\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109967383570314120)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62\672A\50B3\56DE\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109828424125314019)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\662F\300C\9069\7528\65BC\5370\8868\6A5F\300D\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109969977619314122)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\5DF2\5C07\76EE\524D\7684\9801\9762\5207\63DB\70BA\300C\9069\7528\65BC\5370\8868\6A5F\300D\6A21\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109828519374314019)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\4E0D\662F\300C\9069\7528\65BC\5370\8868\6A5F\300D\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109970086919314122)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\5C1A\672A\5C07\76EE\524D\7684\9801\9762\5207\63DB\70BA\300C\9069\7528\65BC\5370\8868\6A5F\300D\6A21\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109825815553314017)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109967556473314120)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8981\6C42\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109826052566314018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109967789419314120)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8981\6C42\5305\542B\5728\60A8\65BC<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109825953999314018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109967664694314120)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8981\6C42\4E0D\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109826144124314018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109967873732314120)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8981\6C42\4E0D\5305\542B\5728\60A8\65BC<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109830907656314021)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109831073703314021)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109829310486314020)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\5DF2\8A8D\8B49 (\4E0D\662F\516C\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109970351262314122)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\5DF2\767B\5165\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109829482124314020)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\662F\516C\7528\4F7F\7528\8005 (\4F7F\7528\8005\672A\8A8D\8B49)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109970444634314122)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\672A\767B\5165\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109827621791314019)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\504F\597D\8A2D\5B9A = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109969342893314121)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7684<em>\504F\597D\8A2D\5B9A</em>\503C\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109827732677314019)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\504F\597D\8A2D\5B9A != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109969468655314121)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7684<em>\504F\597D\8A2D\5B9A</em>\503C\4E0D\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109827440073314019)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\5728\5192\865F\5340\9694\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109969199606314121)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\5B8C\5168\5305\542B\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109827535468314019)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\5728\5192\865F\5340\9694\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109969232876314121)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\4E0D\5B8C\5168\5305\542B\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109826278077314018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109967929979314120)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109826384950314018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109968092210314120)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\4E0D\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109828372701314019)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762 != \5DF2\9001\51FA\7684\9801\9762 (\5DF2\516C\5E03)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109828207546314019)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762 = \5DF2\9001\51FA\7684\9801\9762 (\5DF2\516C\5E03)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109580223399313815)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\689D\4EF6\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109580753805313815)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\689D\4EF6\505A\6BD4\8F03\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109580683838313815)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109582120706313816)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\503C (\5305\542B <code>&ITEM.</code> \66FF\4EE3\5B57\4E32).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109582079358313816)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109713867150313932)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\5831\8868\5340\57DF\4E0B\65B9\7684\6A19\6E96\5217\5370\9023\7D50, \6216\8005\4F7F\7528\6309\9215, \5217\5370\5831\8868\5340\57DF. \82E5\8981\4F7F\7528\6309\9215, \8ACB\79FB\9664\9023\7D50\6A19\7C64, \7136\5F8C\4F7F\7528\300C\5217\5370 URL\300D\4E2D\986F\793A\7684 URL \4F5C\70BA\6309\9215\76EE\6A19, \5728\60A8\7684\9801\9762\4E2D\5EFA\7ACB\4E00\500B\6309\9215.</p>'),
unistr('<p>\4F7F\7528\6309\9215\5217\5370\5831\8868\5340\57DF\6642, \53EF\8A2D\5B9A\968E\6BB5\4F5C\696D\72C0\614B. \5982\679C\60A8\8A08\756B\652F\63F4\5217\5370\591A\7A2E\4E0D\540C\7684\8F38\51FA\683C\5F0F (Word\3001Excel\3001PDF \7B49\7B49), \800C\4E14\60F3\8981\986F\793A\9078\9805\6309\9215\3001\9078\9805\9023\7D50\6216\9078\9805\5F71\50CF, \9019\5C31\975E\5E38\6709\7528. \82E5\8981\9019\9EBC\505A, \8ACB\4F7F\7528\81EA\9805\76EE\9078\9805\884D\751F\7684\8F38\51FA\683C\5F0F, \4E26\4E14\5728\60A8\7684\300C\5217\5370 URL\300D\4E2D\5305\542B\9805\76EE\540D\7A31\548C\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109942971855314102)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.IG_SAVED_REPORT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6AA2\8996\6B64\9810\5B58\5831\8868\7684 URL \9023\7D50. \6B64\5C6C\6027\50C5\4F9B\6AA2\8996\800C\7121\6CD5\88AB\66F4\65B0.</p>'),
unistr('    <p>\6B64\5C6C\6027\53EF\8B93\60A8\5FEB\901F\8907\88FD\986F\793A\7684 URL. \6B64 URL \53EF\7528\4F86\5F9E\61C9\7528\7A0B\5F0F\4E2D\7684\5176\4ED6\4F4D\7F6E\76F4\63A5\9023\7D50\81F3\6B64\7279\5B9A\9810\5B58\5831\8868.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109714473915313933)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\5831\8868\5340\57DF\4E0B\65B9\7684\6A19\6E96\5217\5370\9023\7D50, \6216\8005\4F7F\7528\6309\9215, \5217\5370\5831\8868\5340\57DF. \82E5\8981\4F7F\7528\6309\9215, \8ACB\79FB\9664\9023\7D50\6A19\7C64, \7136\5F8C\4F7F\7528\300C\5217\5370 URL\300D\4E2D\986F\793A\7684 URL \4F5C\70BA\6309\9215\76EE\6A19, \5728\60A8\7684\9801\9762\4E2D\5EFA\7ACB\4E00\500B\6309\9215.</p>'),
unistr('<p>\4F7F\7528\6309\9215\5217\5370\5831\8868\5340\57DF\6642, \53EF\8A2D\5B9A\968E\6BB5\4F5C\696D\72C0\614B. \5982\679C\60A8\8A08\756B\652F\63F4\5217\5370\591A\7A2E\4E0D\540C\7684\8F38\51FA\683C\5F0F (Word\3001Excel\3001PDF \7B49\7B49), \800C\4E14\60F3\8981\986F\793A\9078\9805\6309\9215\3001\9078\9805\9023\7D50\6216\9078\9805\5F71\50CF, \9019\5C31\975E\5E38\6709\7528. \82E5\8981\9019\9EBC\505A, \8ACB\4F7F\7528\81EA\9805\76EE\9078\9805\884D\751F\7684\8F38\51FA\683C\5F0F, \4E26\4E14\5728\60A8\7684\300C\5217\5370 URL\300D\4E2D\5305\542B\9805\76EE\540D\7A31\548C\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109583241583313817)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6AA2\8996\6B64\9810\5B58\5831\8868\7684 URL \9023\7D50. \6B64\5C6C\6027\50C5\4F9B\6AA2\8996\800C\7121\6CD5\88AB\66F4\65B0.</p>'),
unistr('<p>\6B64\5C6C\6027\53EF\8B93\60A8\5FEB\901F\8907\88FD\986F\793A\7684 URL. \6B64 URL \53EF\7528\4F86\5F9E\61C9\7528\7A0B\5F0F\4E2D\7684\5176\4ED6\4F4D\7F6E\76F4\63A5\9023\7D50\81F3\6B64\7279\5B9A\9810\5B58\5831\8868.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109583191479313817)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\7BC4\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109572178552313808)
,p_name=>'PE.PROPERTY.LINK_ICON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\9023\7D50\6240\4F7F\7528\7684 HTML. \60A8\53EF\4EE5\4F7F\7528\5F71\50CF\6A19\8A18\4F86\986F\793A\5F71\50CF, \6216\5F9E\9810\8A2D\5F71\50CF\6E05\55AE\4E2D\9078\64C7.  \5982\679C\672A\5B9A\7FA9, \5C07\6703\4F7F\7528 <code>#IMAGE_PREFIX#ws/small_page.gif</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109572036635313808)
,p_name=>'PE.PROPERTY.LINK_ICON.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\5716\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109582847501313816)
,p_name=>'PE.PROPERTY.LINK_TARGET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6309\4E00\4E0B\300C\76EE\6A19\300D\5373\53EF\547C\53EB\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A. \60A8\53EF\4EE5\8F38\5165\9EDE\9078\300C\9023\7D50\8CC7\6599\6B04\300D\5F8C\6240\8981\547C\53EB\7684\81EA\8A02\76EE\6A19.</p>'),
unistr('        <p>\8ACB\4F9D\64DA\60A8\7684\9700\6C42, \5728\300C\9023\7D50\7522\751F\5668 - \76EE\6A19\300D\4E2D\9078\53D6\9069\7576\7684\985E\578B:'),
'        <dl>',
unistr('        <dt>\6B64\61C9\7528\7A0B\5F0F\7684\9801\9762</dt>'),
unistr('        <dd>\8ACB\8F38\5165\4E0B\5217\5404\9805:'),
'        <ul>',
unistr('        <li>\9801\9762 - \8F38\5165\8981\700F\89BD\7684\9801\78BC\6216\9801\9762\5225\540D. \60A8\4E5F\53EF\4EE5\5F9E\9078\53D6\6E05\55AE\4E2D\9078\53D6\9801\78BC.</li>'),
unistr('        <li>\8A2D\5B9A\9805\76EE: \540D\7A31 - \8F38\5165\6216\9078\53D6\8981\8A2D\5B9A\81F3\968E\6BB5\4F5C\696D\72C0\614B\7684\9801\9762\9805\76EE (<code>P3_ID</code>)\3001\61C9\7528\7A0B\5F0F\9805\76EE (<code>LAST_PAGE</code>) \6216\4E92\52D5\5F0F\5831\8868\7BE9\9078 (<code>IR_EMPNO</code>).</li>'),
unistr('        <li>\8A2D\5B9A\9805\76EE: \503C - \8F38\5165\6216\9078\53D6\5831\8868\8CC7\6599\6B04 (<code>#ID#</code>)\3001\8F38\5165\61C9\7528\7A0B\5F0F\6216\9801\9762\9805\76EE (<code>&P2_EMPNO.</code>), \6216\8005\8F38\5165\4E00\500B\975C\614B\503C (<code>2</code>).</li>'),
unistr('        <li>\6E05\9664\5FEB\53D6 - \8F38\5165\8981\6E05\9664\7684\9801\78BC (<code>2,3</code>)\3001\9805\76EE (<code>P3_EMPNO,LAST_PAGE</code>) \4EE5\53CA\5831\8868\8A2D\5B9A\503C\6E05\55AE (\4F7F\7528\9017\865F\5340\9694). \82E5\8981\91CD\8A2D\5831\8868\7684\5206\9801, \8ACB\8F38\5165 <code>RP</code>. \82E5\8981\6E05\9664\6216\91CD\8A2D\4E92\52D5\5F0F\5831\8868\8A2D\5B9A\503C, \8ACB\8F38\5165 <code>CIR</code> \6216 <code>RIR</code>.</li>'),
unistr('        <li>\91CD\8A2D\5206\9801 - \9078\53D6\300C\662F\300D\5373\53EF\91DD\5C0D\76EE\6A19\9801\9762\4E0A\7684\5831\8868, \5C07\5206\9801\91CD\8A2D\56DE\7B2C\4E00\7D44\8A18\9304. \5176\4F5C\7528\5C31\50CF\5728\300C\6E05\9664\5FEB\53D6\300D\4E2D\50B3\9001 <code>RP</code> \4E00\6A23.</li>'),
unistr('        <li>\9032\968E: \8981\6C42 - \8F38\5165\8981\4F7F\7528\7684\8981\6C42.</li>'),
'        </ul>',
'        </dd>',
unistr('        <dt>\4E0D\540C\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762</dt>'),
unistr('        <dd>\8F38\5165\8207\300C\6B64\61C9\7528\7A0B\5F0F\7684\9801\9762\300D\6240\5217\76F8\540C\7684\5C6C\6027, \53E6\5916\52A0\4E0A\300C\61C9\7528\7A0B\5F0F\300D\7684\61C9\7528\7A0B\5F0F ID \6216\61C9\7528\7A0B\5F0F\5225\540D.</dd>'),
'        <dt>URL</dt>',
unistr('        <dd>\8F38\5165 URL</dd>'),
'        </dl></p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109582757495313816)
,p_name=>'PE.PROPERTY.LINK_TARGET.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\6A19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109901220117314072)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\9EDE\9078\5730\5716\7269\4EF6\5F8C\6240\8981\57F7\884C\7684\52D5\4F5C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109517975755313764)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\5728\6309\4E00\4E0B\5716\8868\6642\57F7\884C\7684\52D5\4F5C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109477284246313734)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\7B2C\4E00\500B\8CC7\6599\6B04\50B3\56DE\7684 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109477350763313734)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3 SQL \67E5\8A62\4E2D\7B2C\4E00\500B\8CC7\6599\6B04\50B3\56DE\7684\76EE\6A19 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109518285808313764)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\4E0D\540C\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109518326725313764)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\91CD\65B0\5C0E\5411\81F3\4E0D\540C\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762, \800C\4E14\53EF\4EE5\9078\64C7\4F7F\7528\5176\4ED6\5C6C\6027\70BA\76EE\6A19\9801\9762\91CD\8A2D\5206\9801\3001\8A2D\5B9A\8981\6C42\503C\3001\6E05\9664\5FEB\53D6\53CA\8A2D\5B9A\9805\76EE\503C.</p>'),
unistr('<p>\6CE8\610F: \5FC5\9808\5728\76EE\6A19\61C9\7528\7A0B\5F0F\555F\7528\6DF1\5C64\9023\7D50\529F\80FD, \624D\80FD\91CD\65B0\5C0E\5411\81F3\4E0D\540C\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762. \82E5\8981\555F\7528\6DF1\5C64\9023\7D50\529F\80FD, \8ACB\524D\5F80\61C9\7528\7A0B\5F0F\7684<em>\5B89\5168\6027</em>\5C6C\6027\4E26\555F\7528<em>\6DF1\5C64\9023\7D50</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109518006915313764)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\6B64\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109518179434313764)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\76EE\524D\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762, \4E26\4F7F\7528\9078\64C7\6027\7684\5176\4ED6\5C6C\6027\5728\76EE\6A19\9801\9762\4E0A\91CD\8A2D\5206\9801\3001\8A2D\5B9A\8981\6C42\503C\3001\6E05\9664\5FEB\53D6\8207\8A2D\5B9A\9805\76EE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109518493611313764)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109518544292313764)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\60A8\6307\5B9A\7684\76EE\6A19 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109517871164313764)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109566420147313804)
,p_name=>'PE.PROPERTY.LINK_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\986F\793A\70BA\9023\7D50\7684 HTML \5167\5BB9. \8ACB\4F7F\7528\5F71\50CF\6A19\8A18\4F86\986F\793A\5F71\50CF, \6216\8005\5F9E\9810\8A2D\5F71\50CF\6E05\55AE\4E2D\9078\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109566327284313804)
,p_name=>'PE.PROPERTY.LINK_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108878938582313271)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\4E00\500B\7528\4F86\5B9A\7FA9\6B64\6E05\55AE\5916\89C0\548C\7248\9762\914D\7F6E\7684\6A23\677F.</p>'),
unistr('        <p>\6E05\55AE\6A23\677F\5B9A\7FA9\65BC\61C9\7528\7A0B\5F0F\4E3B\984C\4E2D.'),
unistr('        \5EFA\7ACB\6E05\55AE\5340\57DF\4E4B\5F8C, \4FBF\6703\81EA\52D5\5C07\6B64\6A23\677F\8A2D\70BA\76EE\524D\4E3B\984C\4E2D\5B9A\7FA9\7684\9810\8A2D\6E05\55AE\6A23\677F.</p>'),
unistr('        <p>\300C\901A\7528\4E3B\984C\300D\63D0\4F9B\4E0B\5217\6E05\55AE\6A23\677F:'),
'          <dl>',
unistr('            <dt>\6A19\8A18\6E05\55AE</dt>'),
unistr('            <dt>\5361\7247</dt>'),
unistr('            <dt>\9023\7D50\6E05\55AE</dt>'),
unistr('            <dt>\5A92\9AD4\6E05\55AE</dt>'),
unistr('            <dt>\529F\80FD\8868\5217</dt>'),
unistr('            <dt>\5373\73FE\5F0F\529F\80FD\8868</dt>'),
unistr('            <dt>\5C0E\89BD\5217</dt>'),
unistr('            <dt>\5074\908A\5C0E\89BD\529F\80FD\8868</dt>'),
unistr('            <dt>\9801\7C64</dt>'),
unistr('            <dt>\9802\7AEF\5C0E\89BD\529F\80FD\8868</dt>'),
unistr('            <dt>\7CBE\9748\9032\5EA6</dt>'),
'          </dl>',
unistr('          \53E6\8ACB\53C3\95B1: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108878803417313271)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109946940903314105)
,p_name=>'PE.PROPERTY.LIST_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6E05\55AE\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109947460869314106)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109947592907314106)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\52D5\614B\300D\6E05\55AE\662F\4EE5\60A8\8F38\5165\4E4B\300CPL/SQL \51FD\6578\4E3B\9AD4\300D\6240\50B3\56DE\7684\300CSQL \67E5\8A62\300D\70BA\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109947238907314105)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109947350102314105)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\52D5\614B\300D\6E05\55AE\662F\4EE5\60A8\8F38\5165\7684\300CSQL \67E5\8A62\300D\70BA\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109947008772314105)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109947120912314105)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\975C\614B\300D\6E05\55AE\662F\4EE5\60A8\8F38\5165\7684\6587\5B57\503C\70BA\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109946803123314105)
,p_name=>'PE.PROPERTY.LIST_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109632306168313856)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\300C\8B70\7A0B\6AA2\8996\300D\4E2D\8981\986F\793A\7684\7E3D\5929\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109632285329313856)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5929\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109632429800313857)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.UNIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109632163770313856)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\986F\793A\300C\6E05\55AE\6AA2\8996\300D\7684\65E5\671F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109791665184313992)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109791732780313992)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\60A8\8F38\5165\7684\5929\6578\986F\793A\884C\4E8B\66C6\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109791205989313992)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\6708\4EFD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109791321592313992)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\76EE\524D\6708\4EFD\7684\884C\4E8B\66C6\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109791442246313992)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672C\5E74\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109791599255313992)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\76EE\524D\5E74\5EA6\7684\884C\4E8B\66C6\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109632049726313856)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109382285753313662)
,p_name=>'PE.PROPERTY.LOGIN_URL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4F7F\7528\8005\4ECB\9762\7684\61C9\7528\7A0B\5F0F\767B\5165\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109382134876313661)
,p_name=>'PE.PROPERTY.LOGIN_URL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\5165 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109326667401313620)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5728\767B\51FA\5F8C\8981\5C07 &PRODUCT_NAME. \91CD\65B0\5C0E\5411\81F3\4F55\8655.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109760739476313969)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109760884157313969)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\61C9\7528\7A0B\5F0F\5C6C\6027\4E2D\5B9A\7FA9\7684\300C\9996\9801\9023\7D50\300D\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109760911417313969)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109761071543313969)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\60A8\8F38\5165\7684 URL, \4F8B\5982 <code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109326562685313620)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\51FA\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109459730010313721)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\4FDD\8B77\8CC7\6599, \4F7F\5176\4E0D\81F3\65BC\767C\751F\907A\5931\66F4\65B0\7684\65B9\5F0F.'),
unistr('		\7576\5169\4F4D\6216\66F4\591A\4F4D\4F7F\7528\8005\5617\8A66\66F4\65B0\76F8\540C\8CC7\6599\6642\5C31\6703\767C\751F\907A\5931\66F4\65B0, \800C\4E14\6700\5F8C\7684\66F4\65B0\6703\8986\5BEB\7B2C\4E00\4F4D\4F7F\7528\8005\6240\505A\7684\66F4\65B0\4EE5\5132\5B58\8B8A\66F4.'),
unistr('		\70BA\907F\514D\767C\751F\9019\7A2E\60C5\6CC1, \66F4\65B0\53EF\4EE5\6AA2\67E5\8CC7\6599\5EAB\4E2D\73FE\6709\7684\8CC7\6599\6B04\503C\8207\539F\5148\67E5\8A62\8A18\9304\6642\6240\64F7\53D6\7684\503C.</p>'),
unistr('		<p>\4F8B\5982:'),
'          <ol>',
unistr('            <li>\4F7F\7528\8005 A \67E5\8A62\54E1\5DE5 (EMP) \8A18\9304.</li>'),
unistr('		    <li>\4F7F\7528\8005 B \67E5\8A62\76F8\540C\7684\54E1\5DE5\8A18\9304.</li>'),
unistr('		    <li>\4F7F\7528\8005 B \66F4\65B0 EMPNO = 7839 \7684\54E1\5DE5\8A73\7D30\8CC7\8A0A, \4E26\5C07\8B8A\66F4\5957\7528 (\78BA\8A8D) \81F3\8CC7\6599\5EAB.</li>'),
unistr('		    <li>\4F7F\7528\8005 A \66F4\65B0 EMPNO = 7839 \7684\54E1\5DE5\8A73\7D30\8CC7\8A0A, \4E26\5617\8A66\5C07\8B8A\66F4\5957\7528\81F3\8CC7\6599\5EAB.</li>'),
'          </ol>',
unistr('          \5982\679C\4F7F\7528\8005 A \9806\5229\66F4\65B0\76F8\540C\7684\8A18\9304, \4F7F\7528\8005 B \6240\505A\7684\8B8A\66F4\5C31\6703\907A\5931.</p>'),
unistr('         <p>\7576\4F7F\7528\8005 A \5617\8A66\5132\5B58\8A72\54E1\5DE5\8A18\9304\6642, \8CC7\6599\5EAB\4E2D\7684\8CC7\6599\6703\8207\4F7F\7528\8005 A \539F\5148\67E5\8A62\7684\8CC7\6599\4E0D\540C.'),
unistr('		  \5728\4EE5\4E0A\7684\6B65\9A5F 1 \4E2D, \53EF\4EE5\64F7\53D6\4F7F\7528\8005 A \539F\5148\67E5\8A62\7684\8CC7\6599\6B04\503C.'),
unistr('		  \63A5\8457\5728\4EE5\4E0A\7684\6B65\9A5F 4 \4E2D, \53EF\4EE5\5C07\503C\8207\8CC7\6599\5EAB\4E2D\76EE\524D\7684\503C\505A\6BD4\8F03.'),
unistr('		  \7531\65BC\4F7F\7528\8005 B \5728\6B65\9A5F 3 \66F4\65B0\4E86\8CC7\6599\5EAB\503C, \56E0\6B64\9019\9805\6BD4\8F03\6703\5F15\767C\4F7F\7528\8005 A \7684\932F\8AA4.'),
unistr('		  \9019\6703\8B93\4E00\4F4D\4F7F\7528\8005\7121\6CD5\8986\5BEB\53E6\4E00\4F4D\4F7F\7528\8005\5C0D\76F8\540C\8CC7\6599\5217\6240\505A\7684\8B8A\66F4.</p>'),
unistr('		  <p>\6CE8\610F - \552F\6709\5728\76F8\5C0D\61C9\7684\8655\7406\4F5C\696D (\4E92\52D5\5F0F\65B9\683C - \81EA\52D5\8CC7\6599\5217\8655\7406 (DML)) \555F\7528<strong>\9632\6B62\907A\5931\66F4\65B0</strong>\6642, \624D\6703\4F7F\7528\300C\907A\5931\66F4\65B0\985E\578B\300D.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109459992985313721)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\7248\672C\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109589774615313821)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\60A8\7684\8CC7\6599\5EAB\8868\683C\5305\62EC\6BCF\6B21\8A18\9304\66F4\65B0 (\6700\597D\662F\900F\904E\8CC7\6599\5EAB\89F8\767C\7A0B\5F0F) \6642\5C31\6703\905E\589E\7684\8CC7\6599\6B04, \5247\53EF\4EE5\4F7F\7528\6B64\8CC7\6599\6B04, \800C\975E\904B\7B97\7E3D\548C\6AA2\9A57.'),
unistr('        \5982\679C\60A8\7684\4E92\52D5\5F0F\65B9\683C\66F4\65B0\591A\500B\8868\683C\4E2D\7684\8CC7\6599, \8ACB\52FF\4F7F\7528\6B64\9078\9805.</p>'),
unistr('        <p>\6CE8\610F - \5340\57DF\7684\300CSQL \4F86\6E90\300D\4E2D\5FC5\9808\5305\62EC\8CC7\6599\5217\7248\672C\8CC7\6599\6B04.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109459829067313721)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109589681586313821)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6700\521D\67E5\8A62\8CC7\6599\6642, \7CFB\7D71\5C07\6703\904B\7B97\6BCF\500B\8CC7\6599\5217\7684\7E3D\548C\6AA2\9A57\503C.'),
unistr('        \7E3D\548C\6AA2\9A57\7684\904B\7B97\65B9\5F0F\70BA\5C07\6240\6709\53EF\66F4\65B0\7684\8CC7\6599\6B04\90FD\4E32\63A5\6210\4E00\500B\5B57\4E32, \7136\5F8C\7522\751F\552F\4E00\503C.'),
unistr('        \5728\78BA\8A8D\66F4\65B0\904E\7684\8A18\9304\6642, \6703\5C07\6B64\7E3D\548C\6AA2\9A57\8207\76EE\524D\8CC7\6599\5EAB\8A18\9304\7684\7E3D\548C\6AA2\9A57\503C\505A\6BD4\8F03.'),
unistr('        \5982\679C\5169\500B\503C\4E0D\76F8\540C, \5C31\6703\767C\51FA\932F\8AA4.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109459618073313721)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\907A\5931\66F4\65B0\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109999037079314143)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\51FD\6578\4E3B\9AD4\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109999368929314143)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109999263767314143)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109999120749314143)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109999467825314143)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109998900103314143)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110000262808314144)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\50B3\56DE\300CSQL \67E5\8A62\300D\4EE5\586B\5165\6B64\503C\6E05\55AE\7684 Java \51FD\6578\4E3B\9AD4. \4E00\822C\800C\8A00, \503C\6E05\55AE\67E5\8A62\7684\5F62\5F0F\70BA:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\6BCF\500B\9078\53D6\7684\8CC7\6599\6B04\90FD\5FC5\9808\5177\6709\552F\4E00\7684\540D\7A31\6216\5225\540D. Oracle \5EFA\8B70\60A8\5728\6240\6709\5305\62EC SQL \8868\793A\5F0F\7684\8CC7\6599\6B04\4F7F\7528\5225\540D.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110000110783314144)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 Java \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110000031988314143)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\986F\793A\90E8\9580\540D\7A31, \8A2D\5B9A\90E8\9580\7DE8\865F</dt>'),
'<dd><pre>',
'return "select dname as d, deptno as r from dept order by 1";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109999941194314143)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\50B3\56DE\300CSQL \67E5\8A62\300D\4EE5\586B\5165\6B64\503C\6E05\55AE\7684 JavaScript \51FD\6578\4E3B\9AD4. \4E00\822C\800C\8A00, \503C\6E05\55AE\67E5\8A62\7684\5F62\5F0F\70BA:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\6BCF\500B\9078\53D6\7684\8CC7\6599\6B04\90FD\5FC5\9808\5177\6709\552F\4E00\7684\540D\7A31\6216\5225\540D. Oracle \5EFA\8B70\60A8\5728\6240\6709\5305\62EC SQL \8868\793A\5F0F\7684\8CC7\6599\6B04\4F7F\7528\5225\540D.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109999873092314143)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 JavaScript \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109595433537313826)
,p_name=>'PE.PROPERTY.LOV_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\503C\6E05\55AE\7684\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109595397080313826)
,p_name=>'PE.PROPERTY.LOV_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109324515578313618)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7576\6B64\9801\9762\4E2D\4EFB\4F55\6307\5B9A\4E4B\300C\968E\5C64\5F0F LOV \7236\9805\9805\76EE\300D\7684\503C\767C\751F\8B8A\66F4\6642, \8981\8A2D\5B9A\81F3\968E\6BB5\4F5C\696D\72C0\614B\7684\8CC7\6599\6B04\3001\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.'),
unistr('\82E5\6709\591A\500B\9805\76EE, \8ACB\4F7F\7528\9017\865F\5340\9694\6BCF\500B\9805\76EE\540D\7A31.'),
unistr('\60A8\53EF\4EE5\9375\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\6311\9078.'),
unistr('\5982\679C\5F9E\6E05\55AE\4E2D\6311\9078, \4E14\540C\6642\9593\5DF2\7D93\6709\8F38\5165\7684\6587\5B57\7684\8A71, \5C07\6703\5728\73FE\6709\6587\5B57\7684\7D50\5C3E\52A0\4E0A\4E00\500B\9017\865F, \5F8C\9762\518D\63A5\8457\5F9E\6E05\55AE\50B3\56DE\7684\9805\76EE\540D\7A31.</p>'),
unistr('<p>\60A8\61C9\8A72\5728\6B64\503C\6E05\55AE\300CSQL \67E5\8A62\300D\7684 <em>where \5B50\53E5</em>\5167\4F7F\7528\6B64\5C6C\6027\4E2D\6307\5B9A\7684\9801\9762\9805\76EE, \4EE5\9650\5236\50B3\56DE\7684\503C.</p>'),
unistr('<p>\6CE8\610F: \7CFB\7D71\6703\81EA\52D5\50B3\8F38<em>\968E\5C64\5F0F LOV \7236\9805\9805\76EE</em>\4E2D\5B9A\7FA9\7684\9801\9762\9805\76EE, \56E0\6B64\4E0D\9700\8981\518D\8F38\5165\5230\6B64\5C6C\6027\4E2D.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109324416749313618)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\9001\51FA\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109999737747314143)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\986F\793A\90E8\9580\540D\7A31, \8A2D\5B9A\90E8\9580\7DE8\865F</dt>'),
'<dd><pre>',
'begin',
'    return ''select dname as d, deptno as r from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109999685242314143)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\50B3\56DE\300CSQL \67E5\8A62\300D\4EE5\586B\5165\6B64\503C\6E05\55AE\7684 PL/SQL \51FD\6578\4E3B\9AD4. \4E00\822C\800C\8A00, \503C\6E05\55AE\67E5\8A62\7684\5F62\5F0F\70BA:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\6BCF\500B\9078\53D6\7684\8CC7\6599\6B04\90FD\5FC5\9808\5177\6709\552F\4E00\7684\540D\7A31\6216\5225\540D. Oracle \5EFA\8B70\60A8\5728\6240\6709\5305\62EC SQL \8868\793A\5F0F\7684\8CC7\6599\6B04\4F7F\7528\5225\540D.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109999525067314143)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110000483825314144)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\50B3\56DE\300CSQL \67E5\8A62\300D\4EE5\586B\5165\6B64\503C\6E05\55AE\7684 Python \51FD\6578\4E3B\9AD4. \4E00\822C\800C\8A00, \503C\6E05\55AE\67E5\8A62\7684\5F62\5F0F\70BA:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\6BCF\500B\9078\53D6\7684\8CC7\6599\6B04\90FD\5FC5\9808\5177\6709\552F\4E00\7684\540D\7A31\6216\5225\540D. Oracle \5EFA\8B70\60A8\5728\6240\6709\5305\62EC SQL \8868\793A\5F0F\7684\8CC7\6599\6B04\4F7F\7528\5225\540D.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110000304136314144)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 Python \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110063212426314188)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\7522\751F\6B64\503C\6E05\55AE\7684 SQL \67E5\8A62\5B9A\7FA9. \4E00\822C\800C\8A00, \503C\6E05\55AE\67E5\8A62\7684\5F62\5F0F\70BA:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\6BCF\500B\9078\53D6\7684\8CC7\6599\6B04\90FD\5FC5\9808\5177\6709\552F\4E00\7684\540D\7A31\6216\5225\540D. Oracle \5EFA\8B70\60A8\5728\6240\6709\5305\542B SQL \8868\793A\5F0F\7684\8CC7\6599\6B04\90FD\4F7F\7528\5225\540D.</p>'),
unistr('<p>\6CE8\610F: \5B9A\7FA9\5373\73FE\5F0F LOV \9805\76EE\985E\578B\6642, \5982\679C\60A8\60F3\8981\5728\5373\73FE\5F0F\9805\76EE\4E2D\986F\793A\591A\500B\8CC7\6599\6B04, \5C31\5FC5\9808\6539\70BA\5728\5171\7528\7684\5143\4EF6\4E2D\4F7F\7528\5FC5\8981\7684\984D\5916\63CF\8FF0\8CC7\6599'),
unistr('\4F86\5B9A\7FA9\60A8\7684\503C\6E05\55AE. \5167\5D4C\7684\503C\6E05\55AE\53EA\80FD\7528\4F86\986F\793A\5373\73FE\5F0F LOV \7684\55AE\4E00\8CC7\6599\6B04.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109919083750314085)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\7522\751F\6B64\503C\6E05\55AE\7684 SQL \67E5\8A62\5B9A\7FA9. \4E00\822C\800C\8A00, \503C\6E05\55AE\67E5\8A62\7684\5F62\5F0F\70BA:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\6BCF\500B\9078\53D6\7684\8CC7\6599\6B04\90FD\5FC5\9808\5177\6709\552F\4E00\7684\540D\7A31\6216\5225\540D. Oracle \5EFA\8B70\60A8\5728\6240\6709\5305\542B SQL \8868\793A\5F0F\7684\8CC7\6599\6B04\90FD\4F7F\7528\5225\540D.</p>'),
unistr('<p>\6CE8\610F: \5B9A\7FA9\5373\73FE\5F0F LOV \9805\76EE\985E\578B\6642, \5982\679C\60A8\60F3\8981\5728\5373\73FE\5F0F\9805\76EE\4E2D\986F\793A\591A\500B\8CC7\6599\6B04, \5C31\5FC5\9808\6539\70BA\5728\5171\7528\7684\5143\4EF6\4E2D\4F7F\7528\5FC5\8981\7684\984D\5916\63CF\8FF0\8CC7\6599'),
unistr('\4F86\5B9A\7FA9\60A8\7684\503C\6E05\55AE. \5167\5D4C\7684\503C\6E05\55AE\53EA\80FD\7528\4F86\986F\793A\5373\73FE\5F0F LOV \7684\55AE\4E00\8CC7\6599\6B04.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110079279984314199)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\7522\751F\6B64\503C\6E05\55AE\7684 SQL \67E5\8A62\5B9A\7FA9. \4E00\822C\800C\8A00, \503C\6E05\55AE\67E5\8A62\7684\5F62\5F0F\70BA:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\6BCF\500B\9078\53D6\7684\8CC7\6599\6B04\90FD\5FC5\9808\5177\6709\552F\4E00\7684\540D\7A31\6216\5225\540D. Oracle \5EFA\8B70\60A8\5728\6240\6709\5305\542B SQL \8868\793A\5F0F\7684\8CC7\6599\6B04\90FD\4F7F\7528\5225\540D.</p>'),
unistr('<p>\6CE8\610F: \5B9A\7FA9\5373\73FE\5F0F LOV \9805\76EE\985E\578B\6642, \5982\679C\60A8\60F3\8981\5728\5373\73FE\5F0F\9805\76EE\4E2D\986F\793A\591A\500B\8CC7\6599\6B04, \5C31\5FC5\9808\6539\70BA\5728\5171\7528\7684\5143\4EF6\4E2D\4F7F\7528\5FC5\8981\7684\984D\5916\63CF\8FF0\8CC7\6599'),
unistr('\4F86\5B9A\7FA9\60A8\7684\503C\6E05\55AE. \5167\5D4C\7684\503C\6E05\55AE\53EA\80FD\7528\4F86\986F\793A\5373\73FE\5F0F LOV \7684\55AE\4E00\8CC7\6599\6B04.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110063134689314188)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\7522\751F\6B64\503C\6E05\55AE\7684 SQL \67E5\8A62\5B9A\7FA9. \4E00\822C\800C\8A00, \503C\6E05\55AE\67E5\8A62\7684\5F62\5F0F\70BA:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\6BCF\500B\9078\53D6\7684\8CC7\6599\6B04\90FD\5FC5\9808\5177\6709\552F\4E00\7684\540D\7A31\6216\5225\540D. Oracle \5EFA\8B70\60A8\5728\6240\6709\5305\542B SQL \8868\793A\5F0F\7684\8CC7\6599\6B04\90FD\4F7F\7528\5225\540D.</p>'),
unistr('<p>\6CE8\610F: \5B9A\7FA9\5373\73FE\5F0F LOV \9805\76EE\985E\578B\6642, \5982\679C\60A8\60F3\8981\5728\5373\73FE\5F0F\9805\76EE\4E2D\986F\793A\591A\500B\8CC7\6599\6B04, \5C31\5FC5\9808\6539\70BA\5728\5171\7528\7684\5143\4EF6\4E2D\4F7F\7528\5FC5\8981\7684\984D\5916\63CF\8FF0\8CC7\6599'),
unistr('\4F86\5B9A\7FA9\60A8\7684\503C\6E05\55AE. \5167\5D4C\7684\503C\6E05\55AE\53EA\80FD\7528\4F86\986F\793A\5373\73FE\5F0F LOV \7684\55AE\4E00\8CC7\6599\6B04.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109282145743313586)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\7522\751F\6B64\503C\6E05\55AE\7684 SQL \67E5\8A62\5B9A\7FA9. \4E00\822C\800C\8A00, \503C\6E05\55AE\67E5\8A62\7684\5F62\5F0F\70BA:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\6BCF\500B\9078\53D6\7684\8CC7\6599\6B04\90FD\5FC5\9808\5177\6709\552F\4E00\7684\540D\7A31\6216\5225\540D. Oracle \5EFA\8B70\60A8\5728\6240\6709\5305\542B SQL \8868\793A\5F0F\7684\8CC7\6599\6B04\90FD\4F7F\7528\5225\540D.</p>'),
unistr('<p>\6CE8\610F: \5B9A\7FA9\5373\73FE\5F0F LOV \9805\76EE\985E\578B\6642, \5982\679C\60A8\60F3\8981\5728\5373\73FE\5F0F\9805\76EE\4E2D\986F\793A\591A\500B\8CC7\6599\6B04, \5C31\5FC5\9808\6539\70BA\5728\5171\7528\7684\5143\4EF6\4E2D\4F7F\7528\5FC5\8981\7684\984D\5916\63CF\8FF0\8CC7\6599'),
unistr('\4F86\5B9A\7FA9\60A8\7684\503C\6E05\55AE. \5167\5D4C\7684\503C\6E05\55AE\53EA\80FD\7528\4F86\986F\793A\5373\73FE\5F0F LOV \7684\55AE\4E00\8CC7\6599\6B04.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109283473633313587)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\7522\751F\6B64\503C\6E05\55AE\7684 SQL \67E5\8A62\5B9A\7FA9. \4E00\822C\800C\8A00, \503C\6E05\55AE\67E5\8A62\7684\5F62\5F0F\70BA:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\6BCF\500B\9078\53D6\7684\8CC7\6599\6B04\90FD\5FC5\9808\5177\6709\552F\4E00\7684\540D\7A31\6216\5225\540D. Oracle \5EFA\8B70\60A8\5728\6240\6709\5305\542B SQL \8868\793A\5F0F\7684\8CC7\6599\6B04\90FD\4F7F\7528\5225\540D.</p>'),
unistr('<p>\6CE8\610F: \5B9A\7FA9\5373\73FE\5F0F LOV \9805\76EE\985E\578B\6642, \5982\679C\60A8\60F3\8981\5728\5373\73FE\5F0F\9805\76EE\4E2D\986F\793A\591A\500B\8CC7\6599\6B04, \5C31\5FC5\9808\6539\70BA\5728\5171\7528\7684\5143\4EF6\4E2D\4F7F\7528\5FC5\8981\7684\984D\5916\63CF\8FF0\8CC7\6599'),
unistr('\4F86\5B9A\7FA9\60A8\7684\503C\6E05\55AE. \5167\5D4C\7684\503C\6E05\55AE\53EA\80FD\7528\4F86\986F\793A\5373\73FE\5F0F LOV \7684\55AE\4E00\8CC7\6599\6B04.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109834528436314024)
,p_name=>'PE.PROPERTY.LOV_SQL.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\986F\793A\90E8\9580\540D\7A31, \8A2D\5B9A\90E8\9580\7DE8\865F</dt>'),
'<dd><pre>',
'select dname  as d,',
'       deptno as r',
'  from dept',
' order by 1',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109585589785313818)
,p_name=>'PE.PROPERTY.LOV_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\7522\751F\6B64\503C\6E05\55AE\7684 SQL \67E5\8A62\5B9A\7FA9. \4E00\822C\800C\8A00, \503C\6E05\55AE\67E5\8A62\7684\5F62\5F0F\70BA:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\6BCF\500B\9078\53D6\7684\8CC7\6599\6B04\90FD\5FC5\9808\5177\6709\552F\4E00\7684\540D\7A31\6216\5225\540D. Oracle \5EFA\8B70\60A8\5728\6240\6709\5305\62EC SQL \8868\793A\5F0F\7684\8CC7\6599\6B04\7686\4F7F\7528\5225\540D.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109585404994313818)
,p_name=>'PE.PROPERTY.LOV_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109585987813313819)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\975C\614B\503C\6E05\55AE\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109585838759313819)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109585757001313818)
,p_name=>'PE.PROPERTY.LOV_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\503C\6E05\55AE\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109972178872314123)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684\51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109972266159314124)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\52D5\614B\300D\503C\6E05\55AE\662F\4EE5\60A8\8F38\5165\4E4B\300C\51FD\6578\4E3B\9AD4\300D\6240\50B3\56DE\7684\300CSQL \67E5\8A62\300D\70BA\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109457549394313719)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5171\7528\7684\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109457652918313719)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE\662F\4EE5\300C\5171\7528\7684\5143\4EF6\300D\4E2D\5B9A\7FA9\7684\9810\5148\5B9A\7FA9\503C\6E05\55AE\70BA\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109457725699313719)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109457836161313719)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\52D5\614B\300D\503C\6E05\55AE\662F\4EE5\60A8\8F38\5165\7684\300CSQL \67E5\8A62\300D\70BA\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109774300578313979)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109774492822313979)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\975C\614B\300D\503C\6E05\55AE\662F\4EE5\60A8\8F38\5165\7684\6587\5B57\503C\70BA\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109585641821313818)
,p_name=>'PE.PROPERTY.LOV_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109254000129313560)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\968E\6BB5\4F5C\696D\72C0\614B\7684\7DAD\8B77\65B9\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109211566981313529)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\9805\8981\6C42 (\50C5\9650\8A18\61B6\9AD4)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109211621074313529)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5C07\72C0\614B\5B58\5165\8CC7\6599\5EAB. \72C0\614B\53EA\80FD\5728\8655\7406\76EE\524D\8981\6C42\6642\4F7F\7528. \7576 AJAX \8981\6C42\9700\8981\4F7F\7528\9805\76EE\6642, \8ACB\52D9\5FC5\900F\904E\300C\8981\9001\51FA\7684\9801\9762\9805\76EE\300D\50B3\9001\9805\76EE\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109756468914313966)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\4F4D\4F7F\7528\8005 (\78C1\789F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110050935396314179)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\85C9\7531\5C07\503C\5B58\5165\8CC7\6599\5EAB\7684\65B9\6CD5\7DAD\8B77\4F7F\7528\8005, \4EE5\9054\5230\80FD\8DE8\968E\6BB5\4F5C\696D\5B58\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109756353549313965)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\4E00\968E\6BB5\4F5C\696D (\78C1\789F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110050857343314179)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\85C9\7531\5C07\503C\5B58\5165\8CC7\6599\5EAB\7684\65B9\6CD5\7DAD\8B77\6BCF\9805\968E\6BB5\4F5C\696D, \4EE5\9054\5230\80FD\8DE8\8981\6C42\5B58\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109253900773313560)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DAD\8B77\968E\6BB5\4F5C\696D\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109211882105313529)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\968E\6BB5\4F5C\696D\72C0\614B\7684\7DAD\8B77\65B9\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109211918203313529)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\9805\8981\6C42 (\50C5\9650\8A18\61B6\9AD4)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109212007735313529)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5C07\72C0\614B\5B58\5165\8CC7\6599\5EAB. \72C0\614B\53EA\80FD\5728\8655\7406\76EE\524D\8981\6C42\6642\4F7F\7528. \7576 AJAX \8981\6C42\9700\8981\4F7F\7528\9805\76EE\6642, \8ACB\52D9\5FC5\900F\904E\300C\8981\9001\51FA\7684\9801\9762\9805\76EE\300D\50B3\9001\9805\76EE\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109212163600313529)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\4E00\968E\6BB5\4F5C\696D (\78C1\789F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109212214412313529)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\85C9\7531\5C07\503C\5B58\5165\8CC7\6599\5EAB\7684\65B9\6CD5\7DAD\8B77\6BCF\9805\968E\6BB5\4F5C\696D, \4EE5\9054\5230\80FD\8DE8\8981\6C42\5B58\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109211743915313529)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DAD\8B77\968E\6BB5\4F5C\696D\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109528840872313772)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\662F\5426\5448\73FE\4E3B\8981\523B\5EA6\6A19\8A18.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109528931532313772)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.AUTO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109529113729313772)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.OFF.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109529014437313772)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.ON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109528705278313772)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109873958718314053)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109873862025314053)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\7528\65BC\986F\793A\9EDE\53E2\96C6\7684\586B\5165\8272\5F69.'),
unistr('<p>\53EF\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\6307\5B9A\8272\5F69. \5341\516D\9032\4F4D\8868\793A\6CD5\5B9A\7FA9\65B9\5F0F\70BA #xxyyzz (# \5F8C\9762\63A5\8457 3 \7D44\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57), \5176\4E2D xx\3001yy \548C zz \70BA\5169\500B\5B57\5143\7684\5341\516D\9032\4F4D\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.'),
unistr('RGB \4EE3\78BC\5B9A\7FA9\65B9\5F0F\70BA RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F 0 \5230 255 \4E4B\9593\7684\6578\5B57, \5404\81EA\70BA\4E00\500B 8 \4F4D\5143\7684\4F4D\5143\7D44\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.</p>'),
unistr('<p>\8ACB\5728\7DB2\969B\7DB2\8DEF\4E0A\641C\5C0B ''HTML Color Codes'', \4EE5\7372\5F97\60F3\4F7F\7528\4E4B\8272\5F69\7684\540C\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109873769994314053)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\586B\5165\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109873108972314052)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7528\65BC\986F\793A\9EDE\53E2\96C6\7684\5716\793A CSS \985E\5225.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109873088377314052)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109872979833314052)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7528\65BC\986F\793A\9EDE\53E2\96C6\7684\5F71\50CF URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109872820414314052)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109873333246314052)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7528\65BC\986F\793A\9EDE\53E2\96C6\7684 SVG \5F62\72C0. \8ACB\5F9E\9810\5148\5B9A\7FA9\7684\5F62\72C0\4E2D\9078\64C7, \6216\8005\8F38\5165<em>\81EA\8A02 SVG \5F62\72C0</em>\7684\540D\7A31 (\5728<strong>\81EA\8A02 SVG \6A23\5F0F</strong>\5730\5716\5340\57DF\5C6C\6027\4E2D\6307\5B9A). \82E5\6307\5B9A\7684\540D\7A31\4E0D\5728\9810\8A2D\6216\81EA\8A02 SVG \6A23\5F0F\6E05\55AE\4E2D\6642, \5C07\6703\4F7F\7528<strong>\9810\8A2D\6A19\8A18</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109906836438314076)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\6A5F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109914660757314082)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109911469888314080)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109915910133314083)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109906932373314076)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\5F62\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109914885802314082)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109873553664314053)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109914713877314082)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109906703417314076)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109914567286314082)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109907071889314077)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76BA\7709')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109914950799314082)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109907196413314077)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62BF\5634')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109915049974314082)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109907264736314077)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FAE\7B11')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109915129375314082)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109911934758314080)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E09\89D2\65D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109916473419314083)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109912095871314080)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\71D5\5C3E\65D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109916509769314083)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109907626075314077)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC3\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109915606309314083)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109911548143314080)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109916089248314083)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109907747765314077)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E94\908A\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109915730224314083)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109907464670314077)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\5F62\5716\91D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109915451807314083)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109907588186314077)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\5F62\5716\91D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109915587749314083)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109911770118314080)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7167\8000')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109916212121314083)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109911638561314080)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\659C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109916176394314083)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109907322637314077)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\5F62\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109915348563314083)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109873410965314052)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109915257692314082)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109911896759314080)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8857\666F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109916357511314083)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109873626845314053)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E09\89D2\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109915830617314083)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109873232720314052)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F62\72C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109907900979314077)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\986F\793A\9EDE\53E2\96C6\6642 SVG \5F62\72C0\7684\7E2E\653E\4FC2\6578. \6700\5927\6BD4\4F8B\70BA <strong>10</strong>, \5730\5716\5143\4EF6\6703\5C07\503C\56DB\6368\4E94\5165\81F3\7B2C\4E00\500B\5C0F\6578\4F4D\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109907876379314077)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F62\72C0\6BD4\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109877145427314055)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4EE5\50CF\7D20\70BA\55AE\4F4D\7684\53E2\96C6\534A\5F91. \6307\5B9A\7684\503C\82E5\70BA <strong>80</strong>, \5247\6703\5C07 80 \500B\50CF\7D20\4EE5\5167\7684\9EDE'),
unistr('\805A\7E3D\6210\4E00\500B\9EDE\53E2\96C6.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109877043600314055)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53E2\96C6\534A\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109877270256314055)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.UNIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50CF\7D20')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109897950845314070)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7576\6E38\6A19\505C\99D0\5728\5730\5716\53E2\96C6\6A19\8A18\4E0A\6642\8981\986F\793A\70BA\5DE5\5177\63D0\793A\7684 HTML \8868\793A\5F0F. \82E5\8981\53C3\7167\5716\5C64\540D\7A31\548C\53E2\96C6\4E2D\7684\5730\5716\7269\4EF6\6578\76EE, \8ACB\4F7F\7528 <strong>&LAYER.</strong> \548C <strong>&COUNT.</strong> \9810\7559\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109897816498314070)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\5177\63D0\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109863443494314045)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\8981\653E\5728\5730\5716\672B\5C3E\7684\8457\4F5C\6B0A\8072\660E. \82E5\662F\7A7A\7684, \5C07\6703\66FF\6240\4F7F\7528\7684\80CC\666F\5730\5716\7522\751F\8072\660E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109863384550314045)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8457\4F5C\6B0A\8072\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109865114683314046)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'[',
'    {',
'        "name": "MyCamera",',
'        "width": 20,',
'        "height": 20,',
'        "paint-order": "stroke",',
'        "viewBox": "0 0 20 20",',
'        "elements": [',
'            {',
'                "type": "path",',
'                "d": "M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1'
||'.1 2.5 2.5S11.4 11 10 11z"',
'            }',
'        ]',
'    },',
'    {',
'        "name": "MyCompany",',
'        "width": 20,',
'        "height": 20,',
'        :',
'    }',
']</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109865070083314046)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D0\4F9B\53EF\4F5C\70BA\5730\5716\6A19\8A18\4E4B\81EA\8A02 SVG \5F62\72C0\7684\5B9A\7FA9. \6B64\8655\5B9A\7FA9\7684\6A23\5F0F\53EF\4EE5\7576\4F5C\9EDE\5716\5C64\5167\7684 <strong>SVG \5F62\72C0</strong> \5C6C\6027.</p>'),
unistr('<p>SVG \5F62\72C0\7684\5BEC\5EA6\548C\9AD8\5EA6\5FC5\9808\70BA <strong>20</strong>. \6B64\6A19\8A18\6703\653E\7F6E\5728\5730\5716\4E0A, \8B93\5716\5F62\5E95\90E8\7684\4E2D\5FC3 (SVG \5EA7\6A19\70BA <strong>10</strong>, <strong>20</strong>) \6307\5411\5730\5716\7269\4EF6.</p>'),
'<svg aria-labelledby="prop1526_SvgTitle" role="img" xmlns="http://www.w3.org/2000/svg" width="100px" height="100px" paint-order="stroke" viewBox="-5 -5 30 40">',
unistr('<title id="prop1526_SvgTitle">SVG \6A19\8A18\7684\5BEC\5EA6\8207\9AD8\5EA6\70BA 20, \4E14\6307\5411\5730\5716\4F4D\7F6E (x=10, y=20).</title>'),
'<path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/>',
'<rect x="0" y="0" width="20" height="20" style="stroke-dasharray:1 1;fill:none;stroke-width:0.5;stroke:black;"/>',
'<line x1="7" y1="17" x2="13" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<line x1="13" y1="17" x2="7" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<text x="10" y="30" text-anchor="middle" style="font: 6px Sans-Serif; fill: red;">[10 20]</text>',
'</svg>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109864999681314046)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02 SVG \6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109895653169314068)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\50B3\56DE\6C7A\5B9A\62C9\4F38\591A\908A\5F62\9AD8\5EA6\503C\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109895515930314068)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62C9\4F38\503C\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109897331558314070)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6C7A\5B9A\62C9\4F38\591A\908A\5F62\9AD8\5EA6\7684\55AE\4F4D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109897603150314070)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.FOOT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82F1\544E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109897546799314070)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.KM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\91CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109897462649314070)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.M.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\5C3A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109897793733314070)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.MILE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82F1\54E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109897254256314070)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\55AE\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109869807845314050)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109869726762314050)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\586B\5165\8272\5F69.'),
unistr('<p>\53EF\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\6307\5B9A\8272\5F69. \5341\516D\9032\4F4D\8868\793A\6CD5\5B9A\7FA9\65B9\5F0F\70BA #xxyyzz (# \5F8C\9762\63A5\8457 3 \7D44\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57), \5176\4E2D xx\3001yy \548C zz \70BA\5169\500B\5B57\5143\7684\5341\516D\9032\4F4D\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.'),
unistr('RGB \4EE3\78BC\5B9A\7FA9\65B9\5F0F\70BA RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F 0 \5230 255 \4E4B\9593\7684\6578\5B57, \5404\81EA\70BA\4E00\500B 8 \4F4D\5143\7684\4F4D\5143\7D44\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.</p>'),
unistr('<p>\8ACB\5728\7DB2\969B\7DB2\8DEF\4E0A\641C\5C0B ''HTML Color Codes'', \4EE5\7372\5F97\60F3\4F7F\7528\4E4B\8272\5F69\7684\540C\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109869686752314050)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\586B\5165\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109878696280314056)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\5716\5C64\662F\5426\4F7F\7528<em>\8272\5F69\914D\7F6E</em>. \8272\5F69\914D\7F6E\662F\4E00\4EFD\8272\5F69\6E05\55AE. \4F9D\64DA\67D0\500B\503C\3001\6700\5C0F\503C\8207\6700\5927\503C, \5730\5716\5C0F\5DE5\5177\5C07\6703\5F9E\8A72\6E05\55AE\4E2D\9078\64C7\6B64\7269\4EF6\7684\5BE6\969B\986F\793A\8272\5F69.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109878540613314056)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8272\5F69\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110031447799314165)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>\8272\5F69\6E05\55AE, \7BC4\570D\5F9E\7D05\8272\5230\767D\8272</dt>'),
unistr('    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>\8272\5F69\6E05\55AE, \7BC4\570D\5F9E\85CD\8272\5230\9ED1\8272</dt>'),
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109878839675314056)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\5716\5C64\7684\81EA\8A02<em>\8272\5F69\914D\7F6E</em>. \8272\5F69\914D\7F6E\662F\4E00\4EFD\8272\5F69\6E05\55AE. \4F9D\64DA\67D0\500B\503C\3001\6700\5C0F\503C\8207\6700\5927\503C, \5730\5716\5C0F\5DE5\5177\5C07\6703\5F9E\8A72\6E05\55AE\4E2D\9078\64C7\6B64\7269\4EF6\7684\5BE6\969B\986F\793A\8272\5F69.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109878707054314056)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\8272\5F69\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109879097409314057)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\50B3\56DE\503C\7684\8CC7\6599\6B04, \4EE5\5F9E\914D\7F6E\4E2D\6C7A\5B9A\986F\793A\8272\5F69.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109878973200314056)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69\503C\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109870011144314050)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\586B\5165\4E0D\900F\660E\5EA6. \7BC4\570D\5F9E\96F6 (\5B8C\5168\900F\660E) \5230 1.0 (\4E0D\900F\660E).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109869945163314050)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\586B\5165\4E0D\900F\660E\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109879210185314057)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\50B3\56DE\503C\7684\8CC7\6599\6B04, \4EE5\5F9E\914D\7F6E\4E2D\6C7A\5B9A\986F\793A\8272\5F69. \82E5\672A\9078\53D6\8CC7\6599\6B04, \5247\53EA\6703\4F9D\64DA\9EDE\5BC6\5EA6\6C7A\5B9A\986F\793A\8272\5F69.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109879120230314057)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109875012233314054)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8CC7\8A0A\8996\7A97\4F7F\7528\8CC7\6599\6B04\9084\662F\9032\968E\683C\5F0F (\4F7F\7528 HTML \8868\793A\5F0F\548C\652F\63F4\7684\66FF\4EE3\5B57\4E32) \986F\793A. \7576\6309\4E00\4E0B\5730\5716\4E0A\7684\7269\4EF6\6642, \8CC7\8A0A\8996\7A97\5C07\6703\986F\793A\70BA\5373\73FE\5F0F\8996\7A97.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109874988507314054)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\968E\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109875439555314054)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7576\4F5C\8CC7\8A0A\8996\7A97\4E3B\9AD4\7684\8CC7\6599\6B04. \7576\6309\4E00\4E0B\5730\5716\4E0A\7684\7269\4EF6\6642, \8CC7\8A0A\8996\7A97\5C07\6703\986F\793A\70BA\5373\73FE\5F0F\8996\7A97.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109875328872314054)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\9AD4\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109875980388314054)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5448\73FE\8CC7\8A0A\5373\73FE\5F0F\8996\7A97\6642\6240\8981\4F7F\7528\7684 CSS \985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109875850532314054)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109875724617314054)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\8B8A\66F4\80CC\666F\8207\6587\5B57\8272\5F69</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\4F7F\7528\6A19\984C 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>\4F7F\7528\4F86\81EA SQL \67E5\8A62\7684\52D5\614B\985E\5225</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \6B64\7BC4\4F8B\4E2D\7684 <code>&COLUMN_CLASS.</code> \8207 <code>&EMPLOYEE_STATUS.</code> \66FF\4EE3\9805\76EE\70BA\5831\8868 SQL \67E5\8A62\4E2D\9078\53D6\7684\8CC7\6599\6B04.</dd>'),
unistr('  <dt>\6E38\6A19\505C\7559\6642\986F\793A\5F71\50CF\8207\5DE5\5177\63D0\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109875634814314054)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6309\4E00\4E0B\7A7A\9593\7269\4EF6\5F8C\8981\986F\793A\70BA\8CC7\8A0A\5373\73FE\5F0F\8996\7A97\7684 HTML \8868\793A\5F0F. \82E5\8981\4EE5 HTML \683C\5F0F\986F\793A\8CC7\6599\6B04\503C, \8ACB\4F7F\7528 <code>&COLUMN.</code> \8A9E\6CD5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109875574584314054)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109875284991314054)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7576\4F5C\8CC7\8A0A\8996\7A97\6A19\984C\7684\8CC7\6599\6B04. \7576\6309\4E00\4E0B\5730\5716\4E0A\7684\7269\4EF6\6642, \8CC7\8A0A\8996\7A97\5C07\6703\986F\793A\70BA\5373\73FE\5F0F\8996\7A97.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109875194368314054)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109898868166314071)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\4F8B\6216\5DE5\5177\63D0\793A\4E2D\7684\986F\793A\6A19\7C64. \82E5\672A\6307\5B9A, \5C07\4F7F\7528<strong>\540D\7A31</strong>\5C6C\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109898654288314070)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\5716\5C64\5728\5716\4F8B\4E2D\548C\5DE5\5177\63D0\793A\5167\6240\4F7F\7528\7684\6A19\7C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109898569034314070)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109898462170314070)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109898387713314070)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\6A19\8A18\586B\5165\8272\5F69.'),
unistr('<p>\53EF\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\6307\5B9A\8272\5F69. \5341\516D\9032\4F4D\8868\793A\6CD5\5B9A\7FA9\65B9\5F0F\70BA #xxyyzz (# \5F8C\9762\63A5\8457 3 \7D44\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57), \5176\4E2D xx\3001yy \548C zz \70BA\5169\500B\5B57\5143\7684\5341\516D\9032\4F4D\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.'),
unistr('RGB \4EE3\78BC\5B9A\7FA9\65B9\5F0F\70BA RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F 0 \5230 255 \4E4B\9593\7684\6578\5B57, \5404\81EA\70BA\4E00\500B 8 \4F4D\5143\7684\4F4D\5143\7D44\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.</p>'),
unistr('<p>\8ACB\5728\7DB2\969B\7DB2\8DEF\4E0A\641C\5C0B ''HTML Color Codes'', \4EE5\7372\5F97\60F3\4F7F\7528\4E4B\8272\5F69\7684\540C\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109898210013314070)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\586B\5165\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109898121300314070)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\586B\5165\4E0D\900F\660E\5EA6. \7BC4\570D\5F9E\96F6 (\5B8C\5168\900F\660E) \5230 1.0 (\4E0D\900F\660E).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109898038830314070)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\586B\5165\4E0D\900F\660E\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109895910127314069)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109895824947314069)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\7B46\89F8\8272\5F69.'),
unistr('<p>\53EF\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\6307\5B9A\8272\5F69. \5341\516D\9032\4F4D\8868\793A\6CD5\5B9A\7FA9\65B9\5F0F\70BA #xxyyzz (# \5F8C\9762\63A5\8457 3 \7D44\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57), \5176\4E2D xx\3001yy \548C zz \70BA\5169\500B\5B57\5143\7684\5341\516D\9032\4F4D\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.'),
unistr('RGB \4EE3\78BC\5B9A\7FA9\65B9\5F0F\70BA RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F 0 \5230 255 \4E4B\9593\7684\6578\5B57, \5404\81EA\70BA\4E00\500B 8 \4F4D\5143\7684\4F4D\5143\7D44\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.</p>'),
unistr('<p>\8ACB\5728\7DB2\969B\7DB2\8DEF\4E0A\641C\5C0B ''HTML Color Codes'', \4EE5\7372\5F97\60F3\4F7F\7528\4E4B\8272\5F69\7684\540C\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109895763349314068)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B46\89F8\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109896146341314069)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7B46\89F8\5BEC\5EA6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109896097736314069)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B46\89F8\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109876134824314054)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\5C07\5340\57DF\4F86\6E90\4E2D\7684\8CC7\6599\5217\6307\5B9A\5230\6B64\5716\5C64\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109876089678314054)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109876349863314055)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B<strong>\8CC7\6599\5217\6307\5B9A\8CC7\6599\6B04</strong><em>\503C</em>, \4EE5\5C07\5340\57DF\4F86\6E90\4E2D\7684\8CC7\6599\5217\6307\5B9A\7D66\6B64\5716\5C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109876299102314054)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\5716\5C64\7684\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109869338728314050)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109869297187314050)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\7B46\89F8\8272\5F69.'),
unistr('<p>\53EF\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\6307\5B9A\8272\5F69. \5341\516D\9032\4F4D\8868\793A\6CD5\5B9A\7FA9\65B9\5F0F\70BA #xxyyzz (# \5F8C\9762\63A5\8457 3 \7D44\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57), \5176\4E2D xx\3001yy \548C zz \70BA\5169\500B\5B57\5143\7684\5341\516D\9032\4F4D\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.'),
unistr('RGB \4EE3\78BC\5B9A\7FA9\65B9\5F0F\70BA RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F 0 \5230 255 \4E4B\9593\7684\6578\5B57, \5404\81EA\70BA\4E00\500B 8 \4F4D\5143\7684\4F4D\5143\7D44\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.</p>'),
unistr('<p>\8ACB\5728\7DB2\969B\7DB2\8DEF\4E0A\641C\5C0B ''HTML Color Codes'', \4EE5\7372\5F97\60F3\4F7F\7528\4E4B\8272\5F69\7684\540C\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109869188738314049)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B46\89F8\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109876590764314055)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7B46\89F8\6A23\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109876839982314055)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DASHED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\865B\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109876791756314055)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOTTED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9EDE\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109876925262314055)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOT_DASHED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9EDE\865B\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109876682150314055)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.SOLID.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BE6\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109876490361314055)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B46\89F8\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109869593884314050)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7B46\89F8\5BEC\5EA6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109869448309314050)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B46\89F8\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109874149591314053)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5DE5\5177\63D0\793A\4F7F\7528\8CC7\6599\6B04\9084\662F\9032\968E\683C\5F0F (\4F7F\7528 HTML \8868\793A\5F0F\548C\652F\63F4\7684\66FF\4EE3\5B57\4E32) \986F\793A. \7576\6E38\6A19\505C\99D0\5728\5730\5716\4E0A\7684\7269\4EF6\6642, \4FBF\6703\986F\793A\6B64\5DE5\5177\63D0\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109874016405314053)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\968E\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109874344151314053)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7576\4F5C\5DE5\5177\63D0\793A\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109874278114314053)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109874831736314053)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5448\73FE\5DE5\5177\63D0\793A\6642\6240\8981\4F7F\7528\7684 CSS \985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109874782963314053)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109874689903314053)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\8B8A\66F4\80CC\666F\8207\6587\5B57\8272\5F69</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\4F7F\7528\6A19\984C 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>\4F7F\7528\4F86\81EA SQL \67E5\8A62\7684\52D5\614B\985E\5225</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \6B64\7BC4\4F8B\4E2D\7684 <code>&COLUMN_CLASS.</code> \8207 <code>&EMPLOYEE_STATUS.</code> \66FF\4EE3\9805\76EE\70BA\5831\8868 SQL \67E5\8A62\4E2D\9078\53D6\7684\8CC7\6599\6B04.</dd>'),
unistr('  <dt>\6E38\6A19\505C\7559\6642\986F\793A\5F71\50CF\8207\5DE5\5177\63D0\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109874513161314053)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7576\6E38\6A19\505C\99D0\5728\5730\5716\7269\4EF6\4E0A\6642\8981\986F\793A\70BA\5DE5\5177\63D0\793A\7684 HTML \8868\793A\5F0F. \82E5\8981\4EE5 HTML \683C\5F0F\986F\793A\8CC7\6599\6B04\503C, \8ACB\4F7F\7528 <code>&COLUMN.</code> \8A9E\6CD5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109874419230314053)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109868426322314049)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\5730\5716\4E0A\986F\793A\4E4B GeoJSON \7269\4EF6\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109868347109314049)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('GeoJSON \8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109868662250314049)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SDO_GEOMETRY \8CC7\6599\6B04, \50B3\56DE\5730\5716\4E0A\986F\793A\7684\5E7E\4F55\7269\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109868581901314049)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E7E\4F55\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109867044321314048)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5E7E\4F55\8CC7\6599\6B04\7684\8CC7\6599\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109867363290314048)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109867463817314048)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('GeoJSON, \70BA VARCHAR2 \6216 CLOB \985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109867592023314048)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D93\5EA6/\7DEF\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109867645148314048)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D93\5EA6\548C\7DEF\5EA6, \70BA\5169\500B NUMBER \8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109867192156314048)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'zh-tw'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109867261527314048)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle SDO_GEOMETRY \985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109866910721314048)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E7E\4F55\8CC7\6599\6B04\8CC7\6599\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109867809265314049)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5E7E\4F55\8CC7\6599\6B04\7684\8CC7\6599\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109867943990314049)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109868066980314049)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('GeoJSON, \70BA VARCHAR2 \6216 CLOB \985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109868163635314049)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D93\5EA6/\7DEF\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109868255060314049)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D93\5EA6\548C\7DEF\5EA6, \70BA\5169\500B NUMBER \8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109867780021314048)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E7E\4F55\8CC7\6599\6B04\8CC7\6599\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109866845256314048)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\790E\8868\683C\82E5\542B\6709\7A7A\9593\7D22\5F15, \4E14\5730\5716\5C0F\5DE5\5177\61C9\4F7F\7528\6B64\7D22\5F15\5F9E\8CC7\6599\5EAB\64F7\53D6\8CC7\6599\5217\6642, \8ACB\555F\7528\6B64\53C3\6578. \5728\6B64\60C5\6CC1\4E0B, \5C0F\5DE5\5177<em>\53EA\6703</em>\5F9E\8CC7\6599\5EAB\64F7\53D6\76EE\524D\5730\5716\8996\7A97\7684\8CC7\6599\5217. \8CC7\6599\4F86\6E90\82E5\5305\542B\5927\91CF\8CC7\6599\5217\6642, \9019\63D0\4F9B\4E86\6548\80FD\512A\52E2.</p><p>\60A8\53EF\4EE5\5728 SQL \5DE5\4F5C\5BA4\7684 SDO_GEOMETRY \8CC7\6599\6B04\4E0A\5EFA\7ACB\7A7A\9593\7D22\5F15.</p>'),
unistr('<p>\8ACB\6CE8\610F, \4EE5\4E0B\60C5\6CC1<em>\4E0D\6703</em>\4F7F\7528\7A7A\9593\7D22\5F15:</p>'),
'<ul>',
unistr('<li>\4E00\500B\4EE5\4E0A\7684\5716\5C64\53C3\7167<strong>\5340\57DF\4F86\6E90</strong>\4F5C\70BA\5176\8CC7\6599\4F86\6E90.</li>'),
unistr('<li>\5730\5716\8996\7A97\592A\5927, \4F8B\5982\6A6B\8DE8\8D85\904E\534A\500B\4E16\754C\7684\60C5\5F62.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109866739562314048)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\7A7A\9593\7D22\5F15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109869073582314049)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('NUMBER \8CC7\6599\6B04, \5167\542B\8981\5728\5730\5716\4E0A\986F\793A\7684\7A7A\9593\7269\4EF6\7DEF\5EA6. \50B3\56DE\503C\5FC5\9808\5728 -90 \5230 90 \4E4B\9593.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109868934030314049)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DEF\5EA6\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109884638054314060)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\5176\4E2D\4E00\500B\9810\5148\5B9A\7FA9\7684\767C\6563\8272\5F69\914D\7F6E. \9019\4E9B\8272\5F69\914D\7F6E\90FD\9069\5408\7528\65BC\8996\89BA\5316\767C\6563\503C, \9806\5E8F\5F9E\4E00\500B\6975\7AEF\503C\5230\53E6\4E00\500B\6975\7AEF\503C. \9019\4E9B\8272\5F69\914D\7F6E\4F86\81EA\65BC cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub \4E0A\7684 CARTOcolor</a>).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109884731898314061)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ECD\7DA0\8272\5230\73AB\7470\7C89')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109884822550314061)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109885965523314061)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5927\5730\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109886074247314061)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109884947578314061)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79CB\5929\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109885040247314061)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109885177633314061)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5674\6CC9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109885285318314061)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109885579416314061)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\85CD\7DA0\8272\5230\73AB\7470\7C89')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109885633781314061)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109885360032314061)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109885445508314061)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109885720485314061)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\71B1\5E36\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109885862966314061)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109884522504314060)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\914D\7F6E\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109886214723314062)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\5176\4E2D\4E00\500B\9810\5148\5B9A\7FA9\7684\5B9A\6027\8272\5F69\914D\7F6E. \9019\4E9B\8272\5F69\914D\7F6E\90FD\9069\5408\7528\65BC\8996\89BA\5316\76F8\7570\503C. \9019\4E9B\8272\5F69\914D\7F6E\4F86\81EA\65BC cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub \4E0A\7684 CARTOcolor</a>).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109886350195314062)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EFF\53E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109886467890314062)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109886559341314062)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C97\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109886636351314062)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109886754247314062)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C89\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109886847814314062)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109886974711314062)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A1C\93E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109887006461314062)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109887173670314062)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\5168')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109887241614314062)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109887303633314062)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9BAE\8C54')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109887432545314062)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109886115840314062)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\914D\7F6E\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109880686483314058)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\5176\4E2D\4E00\500B\9810\5148\5B9A\7FA9\7684\5FAA\5E8F\8272\5F69\914D\7F6E. \9019\4E9B\8272\5F69\914D\7F6E\90FD\9069\5408\7528\65BC\8996\89BA\5316\5FAA\5E8F\503C, \9806\5E8F\5F9E\4F4E\503C\5230\9AD8\503C. \9019\4E9B\8272\5F69\914D\7F6E\4F86\81EA\65BC cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub \4E0A\7684 CARTOcolor</a>).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109882175501314059)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\85CD\8272\5230\7DA0\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109882277051314059)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109882760737314059)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\85CD\8272\5230\9EC3\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109882864081314059)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109884311771314060)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8910\8272\5230\9EC3\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109884444286314060)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109880777732314058)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9152\7D05\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109880845756314058)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109880972572314058)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9152\7D05\8272\5230\9EC3\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109881004099314058)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109882391873314059)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DF1\8584\8377\7DA0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109882424466314059)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109882516366314059)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FE0\7DA0\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109882681823314059)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109883970677314060)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D2B\7D05\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109884090719314060)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109881980735314059)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8584\8377\7DA0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109882002539314059)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109881371233314058)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A58\8272\5230\9EC3\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109881435081314058)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109881501700314058)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6843\7D05\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109881602848314058)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109881785476314058)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C89\7D05\8272\5230\9EC3\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109881829510314059)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109883338708314060)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D2B\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109883425269314060)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109883503935314060)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D2B\8272\5230\6A58\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109883694549314060)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109881145101314058)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D05\8272\5230\6A58\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109881257303314058)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109883714610314060)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\843D\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109883820229314060)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109884152189314060)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DF1\65E5\843D\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109884230968314060)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109882930472314059)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\85CD\7DA0\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109883006331314059)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109883105729314059)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\85CD\7DA0\8272\5230\7DA0\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109883202581314059)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109880503024314058)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\914D\7F6E\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109899280687314071)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109899327417314071)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A HTML \8272\5F69 (#rrggbb) \6E05\55AE, \4EE5\9017\865F\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109879897077314057)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\8272\5F69\914D\7F6E\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109880126627314057)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767C\6563')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109880294568314057)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8272\5F69\914D\7F6E\9069\5408\7528\4F86\8996\89BA\5316\767C\6563\503C, \9806\5E8F\5F9E\4E00\500B\6975\7AEF\503C\5230\53E6\4E00\500B\6975\7AEF\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109880336359314057)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B9A\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109880414928314058)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8272\5F69\914D\7F6E\9069\5408\7528\4F86\8996\89BA\5316\76F8\7570\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109879990536314057)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FAA\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109880079484314057)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8272\5F69\914D\7F6E\9069\5408\7528\4F86\8996\89BA\5316\5FAA\5E8F\503C, \9806\5E8F\5F9E\4F4E\503C\5230\9AD8\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109879739436314057)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110031871061314166)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>\8272\5F69\6E05\55AE, \7BC4\570D\5F9E\7D05\8272\5230\767D\8272</dt>'),
unistr('    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>\8272\5F69\6E05\55AE, \7BC4\570D\5F9E\85CD\8272\5230\9ED1\8272</dt>'),
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109895474974314068)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\71B1\529B\5716\5716\5C64\7684\81EA\8A02<em>\8272\5F69\914D\7F6E</em>. \8272\5F69\914D\7F6E\662F\4E00\4EFD\8272\5F69\6E05\55AE. \4F9D\64DA\67D0\500B\503C\3001\6700\5C0F\503C\8207\6700\5927\503C, \5730\5716\5C0F\5DE5\5177\5C07\6703\5F9E\8A72\6E05\55AE\4E2D\9078\64C7\6B64\7269\4EF6\7684\5BE6\969B\986F\793A\8272\5F69.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109895364400314068)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\8272\5F69\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109892432552314066)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\5176\4E2D\4E00\500B\9810\5148\5B9A\7FA9\7684\767C\6563\8272\5F69\914D\7F6E. \9019\4E9B\8272\5F69\914D\7F6E\90FD\9069\5408\7528\65BC\8996\89BA\5316\767C\6563\503C, \9806\5E8F\5F9E\4E00\500B\6975\7AEF\503C\5230\53E6\4E00\500B\6975\7AEF\503C. \9019\4E9B\8272\5F69\914D\7F6E\4F86\81EA\65BC cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub \4E0A\7684 CARTOcolor</a>).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109892566412314066)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ECD\7DA0\8272\5230\73AB\7470\7C89')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109892697339314066)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109893707949314067)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5927\5730\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109893822006314067)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109892714455314066)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79CB\5929\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109892807079314066)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109892905654314066)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5674\6CC9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109893053713314066)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109893380939314067)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\85CD\7DA0\8272\5230\73AB\7470\7C89')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109893470681314067)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109893165265314067)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109893272639314067)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109893591099314067)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\71B1\5E36\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109893631877314067)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109892300973314066)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\914D\7F6E\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109894064899314067)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\5176\4E2D\4E00\500B\9810\5148\5B9A\7FA9\7684\5B9A\6027\8272\5F69\914D\7F6E. \9019\4E9B\8272\5F69\914D\7F6E\90FD\9069\5408\7528\65BC\8996\89BA\5316\76F8\7570\503C. \9019\4E9B\8272\5F69\914D\7F6E\4F86\81EA\65BC cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub \4E0A\7684 CARTOcolor</a>).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109894140957314067)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EFF\53E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109894234205314067)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109894364269314068)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C97\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109894400918314068)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109894522463314068)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C89\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109894688127314068)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109894772252314068)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A1C\93E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109894881376314068)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109894958310314068)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\5168')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109895052657314068)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109895164704314068)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9BAE\8C54')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109895262119314068)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109893994334314067)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\914D\7F6E\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109888426300314063)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\5176\4E2D\4E00\500B\9810\5148\5B9A\7FA9\7684\5FAA\5E8F\8272\5F69\914D\7F6E. \9019\4E9B\8272\5F69\914D\7F6E\90FD\9069\5408\7528\65BC\8996\89BA\5316\5FAA\5E8F\503C, \9806\5E8F\5F9E\4F4E\503C\5230\9AD8\503C. \9019\4E9B\8272\5F69\914D\7F6E\4F86\81EA\65BC cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub \4E0A\7684 CARTOcolor</a>).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109889978161314064)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\85CD\8272\5230\7DA0\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109890078406314064)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109890500084314065)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\85CD\8272\5230\9EC3\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109890682920314065)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109892155342314066)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8910\8272\5230\9EC3\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109892205306314066)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109888521328314063)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9152\7D05\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109888609040314063)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109888759465314063)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9152\7D05\8272\5230\9EC3\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109888822174314063)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109890185028314064)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DF1\8584\8377\7DA0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109890216001314064)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109890334459314065)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FE0\7DA0\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109890473005314065)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109891797921314066)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D2B\7D05\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109891890268314066)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109889707996314064)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8584\8377\7DA0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109889834964314064)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109889167525314064)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A58\8272\5230\9EC3\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109889254399314064)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109889325963314064)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6843\7D05\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109889496471314064)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109889596117314064)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C89\7D05\8272\5230\9EC3\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109889692310314064)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109891184573314065)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D2B\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109891279619314065)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109891326652314065)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D2B\8272\5230\6A58\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109891407230314065)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109888979983314063)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D05\8272\5230\6A58\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109889038130314064)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109891592710314065)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\843D\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109891639317314066)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109891972610314066)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DF1\65E5\843D\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109892088110314066)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109890791797314065)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\85CD\7DA0\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109890879780314065)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109890998502314065)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\85CD\7DA0\8272\5230\7DA0\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109891042045314065)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109888360507314063)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\914D\7F6E\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109899408687314071)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109899598252314071)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A HTML \8272\5F69 (#rrggbb) \6E05\55AE, \4EE5\9017\865F\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109887649270314063)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\8272\5F69\914D\7F6E\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109887986869314063)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767C\6563')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109888051046314063)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8272\5F69\914D\7F6E\9069\5408\7528\4F86\8996\89BA\5316\767C\6563\503C, \9806\5E8F\5F9E\4E00\500B\6975\7AEF\503C\5230\53E6\4E00\500B\6975\7AEF\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109888107370314063)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B9A\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109888209273314063)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8272\5F69\914D\7F6E\9069\5408\7528\4F86\8996\89BA\5316\76F8\7570\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109887733386314063)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FAA\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109887849451314063)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8272\5F69\914D\7F6E\9069\5408\7528\4F86\8996\89BA\5316\5FAA\5E8F\503C, \9806\5E8F\5F9E\4F4E\503C\5230\9AD8\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109887529657314062)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109877489004314055)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\5716\5C64\7684\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109878181283314056)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\71B1\529B\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109878266083314056)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9EDE\7269\4EF6, \986F\793A\70BA\71B1\529B\5716. \82E5\8981\986F\793A\9EDE\7269\4EF6\7684\5BC6\5EA6\6642, \71B1\529B\5716\975E\5E38\6709\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109877737639314056)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DDA\689D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109877844015314056)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DDA\689D\7269\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109877559681314055)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9EDE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109877641298314055)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9EDE\7269\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109877930656314056)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\591A\908A\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109878009621314056)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\591A\908A\5F62\7269\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109878381554314056)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62C9\4F38\591A\908A\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109878445984314056)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62C9\4F38\591A\908A\5F62\70BA 3D \7269\4EF6. \4F9D\7D50\679C\8CC7\6599\6B04\7684\503C\6C7A\5B9A\9AD8\5EA6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109877356429314055)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\5C64\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109879607013314057)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8B93\6B64\5716\5C64\7DAD\6301\53EF\898B\7684\6700\5927\7E2E\653E\7B49\7D1A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109879545559314057)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5927\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109879420169314057)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8B93\6B64\5716\5C64\8B8A\70BA\53EF\898B\7684\6700\5C0F\7E2E\653E\7B49\7D1A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109879357976314057)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5C0F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109868884582314049)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('NUMBER \8CC7\6599\6B04, \5167\542B\8981\5728\5730\5716\4E0A\986F\793A\7684\7A7A\9593\7269\4EF6\7D93\5EA6. \50B3\56DE\503C\5FC5\9808\5728 -180 \5230 180 \4E4B\9593.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109868707709314049)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D93\5EA6\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109872797872314052)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F\5426\5C07\5730\5716\4E0A\5728\540C\4E00\8655\7684\9EDE\53E2\96C6\5728\4E00\8D77.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109872687219314052)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109870279892314050)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5982\4F55\986F\793A\9EDE\7269\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109870535019314050)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109870675870314050)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\70BA\5716\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109870390023314050)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.D'
,p_message_language=>'zh-tw'
,p_message_text=>'SVG'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109870431958314050)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\70BA SVG \5F62\72C0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109870128463314050)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109872278839314052)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7528\65BC\986F\793A\9EDE\7269\4EF6\7684 SVG \5F62\72C0. \8ACB\5F9E\9810\5148\5B9A\7FA9\7684\5F62\72C0\9078\64C7, \6216\8005\8F38\5165<em>\81EA\8A02 SVG \5F62\72C0</em>\7684\540D\7A31 (\5728<strong>\81EA\8A02 SVG \6A23\5F0F</strong>\5730\5716\5340\57DF\5C6C\6027\4E2D\6307\5B9A). \82E5\672A\6307\5B9A\540D\7A31, \6216\6307\5B9A\7684\540D\7A31\4E0D\5728\9810\8A2D\6216\81EA\8A02 SVG \5F62\72C0\6E05\55AE\4E2D, \5C07\6703\4F7F\7528<strong>\9810\8A2D</strong>\5F62\72C0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109905552973314075)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\6A5F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109912555830314081)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109910776267314079)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109913818898314081)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109905641548314076)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\5F62\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109912736100314081)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109872487615314052)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109912677153314081)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109905407610314075)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109912472614314080)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109905713932314076)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76BA\7709')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109912819486314081)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109905803186314076)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62BF\5634')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109912901223314081)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109905949434314076)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FAE\7B11')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109913085075314081)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109911206456314080)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E09\89D2\65D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109914367292314082)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109911363907314080)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\71D5\5C3E\65D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109914494345314082)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109906382344314076)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC3\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109913500324314081)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109910875636314079)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109913949899314082)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109906437752314076)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E94\908A\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109913694242314081)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109906147348314076)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\5F62\5716\91D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109913349588314081)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109906266706314076)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\5F62\5716\91D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109913465369314081)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109911067570314080)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7167\8000')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109914186239314082)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109910985669314079)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\659C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109914065589314082)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109906094396314076)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\5F62\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109913238779314081)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109872340426314052)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109913111575314081)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109911180984314080)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8857\666F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109914256358314082)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109872501787314052)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E09\89D2\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109913734457314081)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109872110164314052)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F62\72C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109906661283314076)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A SVG \5F62\72C0\7684\7E2E\653E\4FC2\6578. \6BD4\4F8B\4E0A\9650\70BA <strong>10</strong>. \5982\679C\4F7F\7528\7684\8CC7\6599\6B04\66FF\4EE3\9805\76EE\503C\5927\65BC <strong>10</strong>, \7CFB\7D71\4FBF\6703\5C07\8A0A\606F\5BEB\5165 JavaScript \4E3B\63A7\53F0, \7136\5F8C\4EE5 <strong>10</strong> \70BA\6BD4\4F8B\4FC2\6578\4F86\986F\793A\6A19\8A18. \5730\5716\5143\4EF6\6703\5C07\503C\56DB\6368\4E94\5165\81F3\7B2C\4E00\500B\5C0F\6578\4F4D\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109906525364314076)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F62\72C0\6BD4\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109871647702314051)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5167\542B\5716\793A CSS \985E\5225\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109871533984314051)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109872088565314051)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F5C\70BA\5716\793A\4F86\6E90\7684 CSS \985E\5225.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109871924899314051)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109871866160314051)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5F71\50CF\4F86\6E90\7684 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109871796751314051)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109870869053314051)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5728\5730\5716\4E0A\986F\793A\9EDE\7684\5716\793A\4F86\6E90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109871126229314051)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A\985E\5225\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109871233936314051)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\6BCF\500B\8CC7\6599\5217\4F7F\7528\500B\5225\7684 CSS \985E\5225.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109870996428314051)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A\985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109871002023314051)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\6240\6709\8CC7\6599\5217\4F7F\7528\975C\614B CSS \985E\5225.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109871378575314051)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109871426442314051)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7528\4EE5\986F\793A\9EDE\7684\5F71\50CF URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109870759283314051)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109861683762314044)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\6216\505C\7528\5176\4ED6\5730\5716\5C0F\5DE5\5177\529F\80FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109862736204314045)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\5F97\700F\89BD\5668\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109862881948314045)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\700F\89BD\5668\53D6\5F97\4F7F\7528\8005\76EE\524D\7684\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109862965696314045)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\5F62\5DE5\5177')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109863091949314045)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\53EF\4F7F\7528\300C\5713\5F62\5DE5\5177\300D\5728\5730\5716\4E0A\7E6A\88FD\5713\5F62. \7E6A\88FD\5B8C\6210\5F8C\6703\89F8\767C\4E8B\4EF6, \4EE5\4FBF\900F\904E\52D5\614B\52D5\4F5C\6216 JavaScript \7A0B\5F0F\78BC\8655\7406\8A72\5713\5F62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109863194742314045)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8DDD\96E2\5DE5\5177')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109863286105314045)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\4E00\822C\4F7F\7528\8005\6E2C\91CF\5730\5716\4E0A\9EDE\4E4B\9593\7684\8DDD\96E2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109862580963314045)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\9650\5730\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109862623074314045)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\9650\5730\5716\6372\52D5\529F\80FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109861706630314044)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6ED1\9F20\6EFE\8F2A\7E2E\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109861801846314044)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\6ED1\9F20\6EFE\8F2A\9032\884C\7E2E\653E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109862338754314044)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\89BD\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109862439988314044)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\53F3\4E0B\65B9\986F\793A\5168\89BD\5716.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109861900797314044)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\77E9\5F62\7E2E\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109862056237314044)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5730\5716\4E0A\7E6A\88FD\77E9\5F62, \53EF\5C07\5730\5716\7E2E\653E\81F3\8A72\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109862113170314044)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BD4\4F8B\5C3A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109862252237314044)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5730\5716\4E0A\986F\793A\6BD4\4F8B\5C3A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109861557730314044)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109866561031314048)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5730\5716\5340\57DF\7684\9AD8\5EA6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109866465703314047)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109866632433314048)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.UNIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109864895375314046)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\65B0\589E\81F3\5716\4F8B\7684 CSS \985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109864752197314046)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109864609648314046)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7528\65BC\986F\793A\5716\4F8B\5143\7D20\7684 jQuery \9078\53D6\5668.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109864590701314046)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109863847365314045)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5716\4F8B\7684\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109864128009314046)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109864250021314046)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\7D50\5C3E\4F4D\7F6E\986F\793A\5716\4F8B (\901A\5E38\5728\5730\5716\4E0B\65B9).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109864303513314046)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109864447348314046)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7528\65BC\986F\793A\5716\4F8B\5143\7D20\7684 jQuery \9078\53D6\5668.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109863905548314046)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109864084842314046)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\958B\59CB\4F4D\7F6E\986F\793A\5716\4F8B (\901A\5E38\5728\5730\5716\4E0A\65B9).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109863745547314045)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109898706664314071)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110031682885314166)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\986F\793A\5716\5C64\8A0A\606F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109865374167314047)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\986F\793A\5730\5716\5716\5C64\300C\627E\4E0D\5230\8CC7\6599\300D\548C\300C\627E\5230\5176\4ED6\8CC7\6599\300D\7B49\8A0A\606F\7684\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109865410334314047)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109865515059314047)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5730\5716\4E0A\65B9\986F\793A\8A0A\606F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109865620760314047)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109865703725314047)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5730\5716\4E0B\65B9\986F\793A\8A0A\606F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109865881794314047)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109865998599314047)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7528\65BC\986F\793A\8A0A\606F\5143\7D20\7684 jQuery \9078\53D6\5668.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109865217729314047)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A0A\606F\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109866126725314047)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7528\65BC\986F\793A\8A0A\606F\5143\7D20\7684 jQuery \9078\53D6\5668.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109866083679314047)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A0A\606F\9078\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109863646187314045)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\986F\793A\5716\4F8B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109863539937314045)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109866326082314047)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\9078\64C7\4E86\67D0\500B\9801\9762\9805\76EE, \5730\5716\5340\57DF\4E00\5F8B\6703\4EE5\6B64\9805\76EE\7684\503C\8207 GeoJSON \683C\5F0F\7DAD\6301\4F4F\76EE\524D\7684\5730\5716\5B9A\754C\6846. \9019\5C0D\65BC\5C07\5730\5716\9023\63A5\81F3\5176\4ED6 APEX \5143\4EF6 (\4F8B\5982, \4E00\822C\5831\8868\6216\4E92\52D5\5F0F\5831\8868) \975E\5E38\5BE6\7528: \5176\4ED6\5143\4EF6\53EF\4EE5\4F7F\7528\5B9A\754C\6846\9805\76EE\7684\5167\5BB9\4F86\57F7\884C\7A7A\9593\67E5\8A62, \4EE5\53CA\986F\793A\53EA\5728\5730\5716\4E0A\53EF\898B\7684\8CC7\6599.</p>'),
unistr('<p>\4E00\4E9B\5730\5716\79FB\52D5\6216\7E2E\653E\7B49\7D1A\8B8A\66F4\5F8C\7684\5B9A\754C\6846\9805\76EE\5167\5BB9\7BC4\4F8B:</p>'),
'<pre>',
'{',
'  "type": "Polygon",',
'  "coordinates": [[',
'                    [-5.499,46.380],',
'                    [ 8.187,46.380],',
'                    [ 8.187,49.550],',
'                    [-5.499,49.550],',
'                    [-5.499,46.380]]]',
'}',
'</pre>',
'<p>',
unistr('\82E5\8981\5C07\5730\5716\9023\63A5\81F3\5831\8868\5340\57DF, \53EF\4F7F\7528<strong>\91CD\65B0\6574\7406</strong>\52D5\614B\52D5\4F5C. \53EF\4EE5\5C0D\5831\8868\5340\57DF\5957\7528\7A7A\9593\7BE9\9078\689D\4EF6, \4EE5\53EA\986F\793A\5730\5716\4E0A\4E5F\53EF\898B\7684\7D50\679C.</p>'),
unistr('<p>\5831\8868\67E5\8A62\7BC4\4F8B:</p>'),
'<pre>',
'select [column1],',
'       [column2],',
'       ...',
'  from ...',
' where sdo_anyinteract(',
'           [geometry-column],',
'           sdo_util.from_geojson( :[item-name-of-bounding-box-item] )',
'       ) = ''TRUE''',
'   and ...',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109866224809314047)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B9A\754C\6846\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109896371411314069)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6BD4\4F8B\5C3A\548C\8DDD\96E2\5DE5\5177\6240\4F7F\7528\7684\55AE\4F4D\7CFB\7D71.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109896663690314069)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82F1\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109896757591314069)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\82F1\5236\7CFB\7D71.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109896825930314069)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\9805\76EE\884D\751F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109896977406314069)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE\503C\884D\751F\55AE\4F4D\7CFB\7D71.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109896409939314069)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109896508404314069)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\516C\5236\7CFB\7D71.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109896288371314069)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\55AE\4F4D\7CFB\7D71')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109897143151314069)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5167\542B\7684\503C\53EF\4F5C\70BA\5730\5716\55AE\4F4D\7CFB\7D71\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE: <strong>METRIC</strong> (<strong>M</strong>) \6216 <strong>IMPERIAL</strong> (<strong>I</strong>).')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109897017116314069)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\55AE\4F4D\7CFB\7D71\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109523861730313768)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\61C9\8A72\5728\5716\8868\7684\8CC7\6599\9805\76EE\4E0A\5448\73FE\6A19\8A18.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109523914205313768)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.AUTO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109524129245313768)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.OFF.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109524015898313768)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.ON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109523741291313768)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109524345532313768)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\5728\5716\8868\8CC7\6599\9805\76EE\4E0A\5448\73FE\4E4B\6A19\8A18\7684\5F62\72C0. \53EA\6709\7BC4\570D\6578\5217\624D\652F\63F4<strong>\81EA\52D5</strong>. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109524463873313768)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.AUTO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109524522876313769)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109524671658313769)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.DIAMOND.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\83F1\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109524770256313769)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.HUMAN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EBA\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109524812984313769)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.PLUS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52A0\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109524981506313769)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.SQUARE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109550127600313788)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.STAR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109525065045313769)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEDOWN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5012\4E09\89D2\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109525150303313769)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEUP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\4E09\89D2\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109524242275313768)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F62\72C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109640267810313862)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\6B64\8CC7\6599\6B04\662F\5340\57DF\8A2D\5B9A\503C\4E2D<strong>\4E3B\8981\5340\57DF</strong>\8A2D\5B9A\6240\6307\5B9A\4E4B\4E3B\8981\4E92\52D5\5F0F\65B9\683C\5340\57DF\7684\5916\4F86\7D22\5F15\9375\8CC7\6599\6B04, \8ACB\5F9E\4E3B\8981\8868\683C\4E2D\9078\53D6\76F8\5C0D\61C9\7684\4E3B\7D22\5F15\9375\8CC7\6599\6B04.</p>'),
unistr('        <p>\4F8B\5982, \82E5\4E3B\8981\5340\57DF\70BA DEPT, \4E14\6B64\4E92\52D5\5F0F\65B9\683C\70BA EMP, \5247\60A8\5C07\5F9E EMP \4E92\52D5\5F0F\65B9\683C\5167\9078\53D6 DEPTNO \8CC7\6599\6B04, \7136\5F8C\5F9E\300C\4E3B\8981\8CC7\6599\6B04\300D\7684 DEPT \8CC7\6599\6B04\6E05\55AE\4E2D\9078\53D6 DEPTNO \8CC7\6599\6B04.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109640151527313862)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109458053031313719)
,p_name=>'PE.PROPERTY.MASTER_REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\6B64\660E\7D30\5340\57DF\6240\5C6C\7684\4E3B\8981\5340\57DF.<br>'),
unistr('        \6B64\5340\57DF\662F\8207\9019\500B\9801\9762\4E4B\53E6\4E00\500B\5340\57DF\5177\6709\4E3B\8981-\660E\7D30\95DC\4FC2\7684\660E\7D30\5340\57DF\6642, \61C9\8A72\8A2D\5B9A\6B64\9805\76EE.</p>'),
unistr('        <p>\70BA\4E86\8B93\4E3B\8981-\660E\7D30\95DC\4FC2\6B63\78BA\904B\4F5C, \8ACB\9078\53D6\6B64\5340\57DF\4E2D\70BA\4E3B\8981\5340\57DF\4E4B\5916\4F86\7D22\5F15\9375\7684\8CC7\6599\6B04, \4E26\76F8\61C9\5730\6307\5B9A<strong>\4E3B\8981\8CC7\6599\6B04</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109457906152313719)
,p_name=>'PE.PROPERTY.MASTER_REGION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109569959792313807)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\300C\6BCF\9801\8CC7\6599\5217\6578\300D\9078\53D6\5668\4E2D\8981\986F\793A\7684\6578\76EE\4E0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109569819361313807)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\9801\8CC7\6599\5217\6578\4E0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109901408822314072)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\5C0D\6B64\5716\5C64\8655\7406\7684\8CC7\6599\5217\6578\76EE\4E0A\9650. \9019\53EF\4EE5\7576\4F5C\662F\9632\6B62\5728\5730\5716\4E0A\4E0B\8F09\592A\591A\7A7A\9593\7269\4EF6\4E26\986F\793A\7684\63AA\65BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109569144407313806)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\67E5\8A62\53EF\8655\7406\7684\8CC7\6599\5217\6578\76EE\4E0A\9650. \82E5\6240\8981\8655\7406\7684\8CC7\6599\5217\6578\76EE\4E0A\9650\8D85\904E\6B64\9650\5236, \5C07\6703\986F\793A\932F\8AA4\8A0A\606F\800C\975E\8CC7\6599.'),
unistr('\82E5\8981\5B9A\7FA9\81EA\8A02\8A0A\606F, \8ACB\5728<strong>\627E\5230\5176\4ED6\8CC7\6599</stron>\4E2D\6307\5B9A\8A0A\606F.</p>'),
unistr('<p>\6B64\5C6C\6027\4E3B\8981\7528\65BC\4FDD\8B77\57F7\884C\52D5\4F5C\7684\4E00\822C\4F7F\7528\8005, \4F8B\5982\91DD\5C0D\6975\5927\578B\8868\683C\6216\8996\89C0\8868\4E2D\7684\6240\6709\8A18\9304\57F7\884C\6392\5E8F\6216\805A\7E3D, \53EF\80FD\6703\5C0E\81F4\6548\80FD\4E0D\4F73.'),
unistr('\767C\751F\6B64\60C5\6CC1\6642\5FC5\9808\5148\589E\52A0\5176\4ED6\7BE9\9078\4EE5\6E1B\5C11\8655\7406\7684\8A18\9304\7B46\6578.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109569006980313806)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\8655\7406\7684\8CC7\6599\5217\4E0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109935531287314097)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\5143\4EF6\662F\4F7F\7528\4E00\500B\8CC7\6599\6B04\9084\662F\9032\968E\683C\5F0F (\4F7F\7528 HTML \8868\793A\5F0F\548C\652F\63F4\7684\66FF\4EE3\5B57\4E32) \986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109935412695314097)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\968E\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109943363826314103)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109937971693314099)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6C7A\5B9A\5A92\9AD4\7684\5916\89C0\6BD4\4F8B.'),
unistr('<strong>\81EA\52D5</strong>: \4F7F\7528\6700\9069\5927\5C0F, \4EE5\4FDD\7559\539F\59CB\5A92\9AD4\5927\5C0F.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109938087619314099)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109938140065314099)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528\6B63\65B9\5F62\5916\89C0\6BD4\4F8B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109938234220314099)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BEC\87A2\5E55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109938332684314099)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528\5BEC\87A2\5E55\5916\89C0\6BD4\4F8B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109937835810314099)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\89C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109936988280314098)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\53EF\50B3\56DE\5A92\9AD4\4F86\6E90 BLOB \7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109936867576314098)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('BLOB \8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109939193406314100)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\65B0\589E\81F3\6B64\5143\4EF6\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109939081933314100)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109939378298314100)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\6587\5B57\63CF\8FF0\5A92\9AD4, \7528\65BC\5DE5\5177\63D0\793A\548C\5F71\50CF\7684\66FF\4EE3\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109939269398314100)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109937125468314098)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C7A\5B9A\5361\7247\4E0A\5A92\9AD4\5143\4EF6\7684\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109937632719314099)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7576\6210\80CC\666F\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109937757830314099)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5A92\9AD4\986F\793A\70BA\5361\7247\80CC\666F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109937406741314098)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109937556675314098)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5A92\9AD4\986F\793A\5728\5361\7247\4E3B\9AD4\5167.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109937222430314098)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109937334499314098)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5A92\9AD4\986F\793A\5728\5361\7247\6A19\982D\7684\524D\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109937084443314098)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109935885875314097)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\8B8A\66F4\80CC\666F\8207\6587\5B57\8272\5F69</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\4F7F\7528\6A19\984C 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>\4F7F\7528\4F86\81EA SQL \67E5\8A62\7684\52D5\614B\985E\5225</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \6B64\7BC4\4F8B\4E2D\7684 <code>&COLUMN_CLASS.</code> \8207 <code>&EMPLOYEE_STATUS.</code> \66FF\4EE3\9805\76EE\70BA\5831\8868 SQL \67E5\8A62\4E2D\9078\53D6\7684\8CC7\6599\6B04.</dd>'),
unistr('  <dt>\6E38\6A19\505C\7559\6642\986F\793A\5F71\50CF\8207\5DE5\5177\63D0\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109935753319314097)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5728\6B64\8CC7\6599\6B04\4E2D\986F\793A\7684 HTML \8868\793A\5F0F. \82E5\8981\4EE5 HTML \683C\5F0F\986F\793A\8CC7\6599\6B04\503C, \8ACB\4F7F\7528 <code>&COLUMN.</code> \8A9E\6CD5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109935695980314097)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109938547969314099)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C7A\5B9A\5A92\9AD4\5143\4EF6\5167\5A92\9AD4\5927\5C0F\7684\8ABF\6574\65B9\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109938829809314099)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DB5\84CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109938913756314100)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ABF\6574\5927\5C0F, \8B93\5A92\9AD4\586B\6EFF\5A92\9AD4\986F\793A\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109938667365314099)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B26\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109938785942314099)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ABF\6574\5927\5C0F, \8B93\5A92\9AD4\53EF\5305\542B\5728\5A92\9AD4\986F\793A\5340\57DF\5167.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109938443303314099)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ABF\6574\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109943250099314103)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\5A92\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109936063437314097)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5A92\9AD4\4F86\6E90\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109936370616314098)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.BLOB.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('BLOB \8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109936210154314098)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.DYNAMIC_URL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('URL \8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109936148663314097)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.STATIC_URL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109935965677314097)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109233619341313545)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165 Internet \5A92\9AD4\985E\578B. Internet \5A92\9AD4\985E\578B\662F\300C\7DB2\969B\7DB2\8DEF\300D\4E0A\6A94\6848\683C\5F0F\7684\5169\500B\90E8\5206 ID.'),
unistr('\5A92\9AD4\985E\578B\81F3\5C11\6709\5169\500B\90E8\5206: \985E\578B\548C\5B50\985E\578B, \4EE5\53CA\4E00\6216\591A\500B\9078\64C7\6027\53C3\6578.'),
unistr('\5728\5448\73FE\9801\9762\6642, \6703\5728 Content-Type HTTP \6A19\982D\4E2D\4F7F\7528\6B64\5A92\9AD4\985E\578B.</p>'),
unistr('<p>\9801\9762\5C64\6B21\5A92\9AD4\985E\578B\6703\8986\5BEB\61C9\7528\7A0B\5F0F\5C64\6B21\5A92\9AD4\985E\578B.'),
unistr('\5982\679C\9801\9762\5C64\6B21\548C\61C9\7528\7A0B\5F0F\5C64\6B21\7684\5A92\9AD4\985E\578B\90FD\662F <code>NULL</code>, \5247\6703\4F7F\7528 <code>text/html</code> \5A92\9AD4\985E\578B.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109233551665313545)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5A92\9AD4\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109936599222314098)
,p_name=>'PE.PROPERTY.MEDIA_URL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5A92\9AD4\4F86\6E90\7684 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109936416128314098)
,p_name=>'PE.PROPERTY.MEDIA_URL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109936703387314098)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7576\4F5C\5A92\9AD4\4F86\6E90\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109936653372314098)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('URL \8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109529788338313772)
,p_name=>'PE.PROPERTY.MINOR_STEP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B21\8981\523B\5EA6\6A19\8A18\4E4B\9593\7684\589E\91CF. \6839\64DA\8CC7\6599\9032\884C\7684\81EA\52D5\8A08\7B97\6703\9810\8A2D\662F\7A7A\503C. \50C5\9069\7528\65BC\6578\503C\8EF8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109529601878313772)
,p_name=>'PE.PROPERTY.MINOR_STEP.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D1A\8DDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109529585131313772)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5448\73FE\6B21\8981\523B\5EA6\6A19\8A18.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109529402206313772)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109529315232313772)
,p_name=>'PE.PROPERTY.MIN_STEP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4E3B\8981\523B\5EA6\6A19\8A18\4E4B\9593\7684\6700\5C0F\589E\91CF. \9019\4E00\822C\662F\7528\4F86\9632\6B62\9593\65B7\6E2C\91CF\7684\5C0F\6578\8EF8\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109529280544313772)
,p_name=>'PE.PROPERTY.MIN_STEP.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5C0F\7D1A\8DDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109949313612314107)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.APP_PROCESS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\958B\767C\4EBA\54E1\5BB9\6613\8B58\5225\7684\61C9\7528\7A0B\5F0F\8655\7406\4F5C\696D\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109330805324313623)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.AUTHENTICATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\61C9\7528\7A0B\5F0F\958B\767C\4EBA\54E1\7528\4F86\53C3\7167\6B64\8A8D\8B49\914D\7F6E\7684\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109270353012313573)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.AUTHORIZATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8B58\5225\6B64\6388\6B0A\914D\7F6E\7684\552F\4E00\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109344023577313632)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BRANCH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\958B\767C\4EBA\54E1\5BB9\6613\8B58\5225\7684\5206\652F\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109380998416313661)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\5C0E\89BD\8DEF\5F91\6A23\677F\7684\63CF\8FF0\6027\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109270283337313572)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BUILD_OPTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\7D44\5EFA\9078\9805\7684\540D\7A31. \7D44\5EFA\9078\9805\662F\9810\5148\5B9A\7FA9\7684\8A2D\5B9A\503C, \6C7A\5B9A\662F\5426\555F\7528\61C9\7528\7A0B\5F0F\5167\7684\5143\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109380692839313660)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\6309\9215\6A23\677F\7684\63CF\8FF0\6027\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109381035258313661)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\884C\4E8B\66C6\6A23\677F\7684\63CF\8FF0\6027\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109270945711313573)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\52D5\614B\52D5\4F5C\7684\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109380707541313660)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\9805\76EE\6A23\677F\7684\63CF\8FF0\6027\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109567195511313805)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8CC7\6599\6B04\7FA4\7D44\7684\540D\7A31.  \6B64\540D\7A31\6703\5728\8A73\7D30\6AA2\8996\4E2D\986F\793A\70BA\5340\57DF\6A19\982D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109380863083313660)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.LIST_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\6E05\55AE\6A23\677F\7684\63CF\8FF0\6027\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109900902096314072)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\5143\4EF6\7684\63CF\8FF0\6027\540D\7A31. \5728\5730\5716\5340\57DF\4E0A\986F\793A\6A19\7C64\82E5\9700\4F7F\7528 HTML \6216\66FF\4EE3\9805\76EE, \8ACB\4F7F\7528<strong>\6A19\7C64</strong>\5C6C\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109270400398313573)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\76EE\524D\9801\9762\7684\540D\7A31. \6B64\540D\7A31\8207\9801\78BC\548C\6A19\984C, \7686\7528\65BC\8A31\591A &PRODUCT_NAME. \9801\9762\548C\5831\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109270797895313573)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_GROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\9801\9762\7FA4\7D44\7684\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109271557766313573)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\958B\767C\4EBA\54E1\5BB9\6613\8B58\5225\7684\9801\9762\8655\7406\4F5C\696D\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109380418129313660)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\7279\5B9A\9801\9762\6A23\677F\7684\63CF\8FF0\6027\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109380569974313660)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REGION_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\5340\57DF\6A23\677F\7684\63CF\8FF0\6027\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109381136356313661)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\5831\8868\6A23\677F\7684\63CF\8FF0\6027\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109380358573313660)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.THEME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\4E3B\984C\7684\7C21\77ED\63CF\8FF0\6027\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109381220327313661)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.USER_INTERFACE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\4F7F\7528\8005\4ECB\9762\7684\540D\7A31. \6B64\540D\7A31\6703\986F\793A\5728\7CBE\9748\4E2D, \4F8B\5982\300C\5EFA\7ACB\4E3B\984C\7CBE\9748\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109343728230313632)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.VALIDATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\9A57\8B49\540D\7A31. \6B64\540D\7A31\61C9\8A72\662F\63CF\8FF0\6027\7684\540D\7A31, \8B93\958B\767C\4EBA\54E1\53EF\4EE5\8F15\9B06\8B58\5225\8981\6AA2\67E5\7684\689D\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109230469307313543)
,p_name=>'PE.PROPERTY.NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\5143\4EF6\7684\63CF\8FF0\6027\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109230322622313543)
,p_name=>'PE.PROPERTY.NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109245411935313554)
,p_name=>'PE.PROPERTY.NAMED_LOV.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\73FE\6709\503C\6E05\55AE\7684\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109245372154313554)
,p_name=>'PE.PROPERTY.NAMED_LOV.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109857363153314041)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\5730\5716\4E0A\7684\5C0E\89BD\5217\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109857625822314041)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109857745685314041)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5730\5716\7684\7D50\5C3E\4F4D\7F6E (\901A\5E38\70BA\5730\5716\7684\53F3\5074) \986F\793A\5C0E\89BD\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109857419245314041)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109857582500314041)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5730\5716\7684\958B\59CB\4F4D\7F6E (\901A\5E38\70BA\5730\5716\7684\5DE6\5074) \986F\793A\5C0E\89BD\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109857210803314041)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\5217\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109856565268314040)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\4F7F\7528\7684\5C0E\89BD\5217\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109857090532314041)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E2E\653E\8207\6307\5357\91DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109857165809314041)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\63A7\5236\9805\548C\6307\5357\91DD\9032\884C\7E2E\653E, \4EE5\63A7\5236\5730\5716\65B9\5411.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109856698556314040)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109856745963314040)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\5C0E\89BD\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109856887012314040)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\9650\7E2E\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109856950199314041)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\653E\5927\53CA\7E2E\5C0F\63A7\5236\9805.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109856418693314040)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110113531107314243)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\986F\793A\5C0E\89BD\529F\80FD\8868\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109370440827313652)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\9801\9762\4E0A\5C0E\89BD\6240\4F7F\7528\7684\5C0E\89BD\529F\80FD\8868\6E05\55AE.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109370340396313652)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110113087524314243)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\9801\9762\4E2D\5C0E\89BD\529F\80FD\8868\6E05\55AE\7684\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110113279001314243)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.SIDE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5074\908A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110113106913314243)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.TOP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9802\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110112945937314243)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109370691493313653)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8207\6B64\9801\9762\4E0A\7684\5C0E\89BD\529F\80FD\8868\6E05\55AE\642D\914D\4F7F\7528\7684\5C0E\89BD\529F\80FD\8868\6E05\55AE\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109370573876313652)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110113488265314243)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\9078\53D6\4F9B\7528\65BC\81EA\8A02\6B64\5C0E\89BD\6E05\55AE\4E4B\4F7F\7528\8005\4ECB\9762\7684\6A23\677F\9078\9805.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110113337503314243)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109926688759314091)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\986F\793A\6307\5411\53F3\908A\7684\7BAD\865F</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109926549886314091)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\65B0\589E\81F3\5143\4EF6\4E4B\5716\793A\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.</p>'),
unistr('        <p>\60A8\7684\4E3B\984C\82E5\4F7F\7528\300C\5B57\578B APEX\300D, \8ACB\8907\67E5<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F</a>\4EE5\6AA2\8996\53EF\7528\7684\5716\793A\548C\4FEE\98FE\689D\4EF6.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109926448727314091)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\8CC7\6599\5716\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110110761585314241)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5728\6B64\6E05\55AE\9802\7AEF\7684\6E05\55AE\7A7A\503C\9078\9805\5167\986F\793A\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109919130850314085)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5728\6B64\6E05\55AE\9802\7AEF\7684\6E05\55AE\7A7A\503C\9078\9805\5167\986F\793A\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109282249387313586)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5728\6B64\6E05\55AE\9802\7AEF\7684\6E05\55AE\7A7A\503C\9078\9805\5167\986F\793A\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109283521741313587)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5728\6B64\6E05\55AE\9802\7AEF\7684\6E05\55AE\7A7A\503C\9078\9805\5167\986F\793A\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109246034126313555)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5728\6B64\6E05\55AE\9802\7AEF\7684\6E05\55AE\7A7A\503C\9078\9805\4E2D\986F\793A\7684\6587\5B57. \5448\73FE\9805\76EE\6642\82E5\503C\662F\7A7A\503C, \4E5F\6703\986F\793A\6B64\503C. \82E5\60A8\672A\8F38\5165\4EFB\4F55\6587\5B57, \5247\6703\5728\6E05\55AE\4E2D\986F\793A\7A7A\767D\884C, \4E26\5728\5448\73FE\6642\986F\793A\7A7A\767D\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109245989380313554)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\503C\986F\793A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109246287000313555)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5728\6B64\503C\6E05\55AE\4E2D\9078\53D6\7A7A\503C\503C\6642\8981\50B3\56DE\7684\503C. \82E5\60A8\672A\63D0\4F9B\503C, \5247\5F9E\6B64\6E05\55AE\9078\53D6\7A7A\503C\503C\9078\9805\6642, \9805\76EE\503C\5C07\7DAD\6301\7A7A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109246131905313555)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\503C\50B3\56DE\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109604413739313836)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6BCF\4E00\5831\8868\9801\9762\8981\986F\793A\7684\5831\8868\8CC7\6599\5217\6578\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109604345128313836)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\6578\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109604675916313836)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5176\503C\7528\4F86\6307\5B9A\6BCF\4E00\5831\8868\9801\9762\8981\986F\793A\4E4B\5831\8868\8CC7\6599\5217\6578\76EE\7684\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109604575172313836)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109604262567313835)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\5982\4F55\8F38\5165\6B64\5831\8868\7684\8CC7\6599\5217\6578\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109784598239313987)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\9805\76EE\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109784420594313987)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109604134341313835)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\6578\76EE\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109241311925313551)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4F7F\7528\8005\5617\8A66\57F7\884C\7B2C\4E8C\6B21\9801\9762\9001\51FA\6642\7684 URL \76EE\6A19. &PRODUCT_NAME. \6703\986F\793A\932F\8AA4\8A0A\606F\4EE5\53CA\6B64 URL \7684\9023\7D50, \8B93\4F7F\7528\8005\53EF\4EE5\7E7C\7E8C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109241219587313551)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\91CD\8907\7684\9801\9762\9001\51FA\9805\76EE\524D\5F80\6B64 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109632618046313857)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8981\8B93\9801\9762\6216 URL \53D6\4EE3\76EE\524D\7684\9801\9762, \6216\5728\5C0D\8A71\65B9\584A\4E2D\958B\555F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109791984067313992)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.P.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\8A71\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109791867090313992)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.W.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540C\4E00\500B\8996\7A97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109632556623313857)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\958B\555F\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109556443521313793)
,p_name=>'PE.PROPERTY.OPERATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109445334970313710)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\82E5\8981\5B58\53D6 <code>employee</code> \8868\683C, \8ACB\5617\8A66\4F7F\7528 <code>emp_department_ix</code> \7D22\5F15</dt>'),
'<dd><pre>INDEX (employees emp_department_ix)</pre></dd>',
unistr('<dt>\5728 SQL \67E5\8A62\5167\555F\7528 <code>WITH plsql_declarations</code> \5B50\53E5\7684\4F7F\7528</dt>'),
'<dd><pre>WITH_PLSQL</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109445227580313710)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\57F7\884C SQL \67E5\8A62\6642, \65B0\589E\81F3\9802\5C64\6558\8FF0\53E5\7684 Oracle \6700\4F73\5316\8655\7406\7A0B\5F0F\63D0\793A.'),
unistr('        \63D0\793A\70BA\6700\4F73\5316\8655\7406\7A0B\5F0F\7684\6307\793A. \7DE8\5BEB SQL \6642, \60A8\6216\8A31\77E5\9053\5C0D\6700\4F73\5316\8655\7406\7A0B\5F0F\800C\8A00\70BA\4E0D\660E\8CC7\6599\4E4B\8CC7\6599\7684\76F8\95DC\8CC7\8A0A. \63D0\793A\53EF\8B93\60A8\9032\884C\6C7A\7B56 (\6B63\5E38\662F\7531\6700\4F73\5316\8655\7406\7A0B\5F0F\9032\884C\6C7A\7B56),'),
unistr('        \4F46\6709\6642\5019\6703\8B93\6700\4F73\5316\8655\7406\7A0B\5F0F\9078\64C7\5176\8996\70BA\8F03\9AD8\8655\7406\6210\672C\7684\8A08\756B.</p>'),
unistr('        <p>\8209\4F8B\4F86\8AAA, \60A8\53EF\80FD\77E5\9053\5C0D\65BC\7279\5B9A\67E5\8A62\4F86\8AAA, \67D0\500B\7279\5B9A\7D22\5F15\66F4\5177\9078\64C7\6027. \76F8\5C0D\65BC\6700\4F73\5316\8655\7406\7A0B\5F0F\7684\9078\64C7, \60A8\5C31\53EF\4EE5\6839\64DA\6B64\8CC7\8A0A, \9078\64C7\66F4\6709\6548\7387\7684\57F7\884C\8A08\756B.'),
unistr('        \5728\6B64\60C5\6CC1\4E0B, \4F7F\7528\63D0\793A\53EF\5F37\5236\6700\4F73\5316\8655\7406\7A0B\5F0F\4F7F\7528\6B64\6700\4F73\7684\57F7\884C\8A08\756B.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109445128150313710)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\4F73\5316\8655\7406\7A0B\5F0F\63D0\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110117792890314247)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\4E00\500B\4F7F\7528 Oracle Text \7D22\5F15\7DE8\88FD\8CC7\6599\6B04\7D22\5F15\7684\8CC7\6599\6B04.</p>'),
unistr('<p>\300C\8CC7\6599\5217\641C\5C0B\300D\6703\6839\64DA\8F38\5165\7684 Oracle Text \904B\7B97\5B50\50B3\56DE\7D50\679C, \4F46\524D\63D0\70BA\5DF2\70BA\8CC7\6599\6B04\5EFA\7ACB\76F8\5C0D\61C9\7684 Oracle Text \7D22\5F15.'),
unistr('\552F\6709\7576\5FC5\8981\7684\7D22\5F15\5B58\5728, \800C\4E14\4E00\822C\4F7F\7528\8005\719F\6089\5982\4F55\4F7F\7528 Oracle Text \641C\5C0B\904B\7B97\5B50\6642, \624D\61C9\8A72\555F\7528\6B64\9078\9805.'),
unistr('\82E5\8981\7C21\5316\4E00\822C\4F7F\7528\8005\4F7F\7528 Oracle Text \7684\8A9E\6CD5, \60A8\53EF\4EE5\5728\300C\5171\7528\5143\4EF6\300D\4E2D\70BA\300C\4E92\52D5\5F0F\65B9\683C\300D\7684 <em>Oracle Text PL/SQL \51FD\6578\540D\7A31</em>\5143\4EF6\8A2D\5B9A\6307\5B9A\4E00\500B\51FD\6578.<br>'),
unistr('\8ACB\53C3\95B1 <a rel="noreferrer" target="_blank" href="https://docs.oracle.com/en/database/oracle/oracle-database/19/ccapp/index.html">Oracle Text Application Developers Guide</a>.</p>'),
unistr('<p>\6CE8\610F - \4E00\822C\4F7F\7528\8005\82E5\6B63\78BA\8F38\5165 Oracle Text \904B\7B97\5B50, \641C\5C0B\6548\80FD\6703\66F4\512A\8D8A.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110117609338314246)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle Text \7D22\5F15\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109949034503314107)
,p_name=>'PE.PROPERTY.ORDS_CLEANUP_CODE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664\7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109948976450314107)
,p_name=>'PE.PROPERTY.ORDS_INIT_CODE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\521D\59CB\5316\7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109507627379313756)
,p_name=>'PE.PROPERTY.ORIENTATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\5716\8868\7684\65B9\5411.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109507714154313756)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C34\5E73')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109638332995313861)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C34\5E73\986F\793A\5716\8868\7684\8CC7\6599\9805\76EE. \4F8B\5982, \5C07\6703\6C34\5E73\986F\793A\9577\689D\5716\4E0A\7684\9577\689D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109638193283313861)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5782\76F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109638202797313861)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5782\76F4\986F\793A\5716\8868\7684\8CC7\6599\9805\76EE. \4F8B\5982, \5C07\6703\5782\76F4\986F\793A\9577\689D\5716\4E0A\7684\9577\689D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109507569779313756)
,p_name=>'PE.PROPERTY.ORIENTATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109517574139313763)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5728\5716\8868\4E0A\5448\73FE\7684\7E3D\89BD\6372\8EF8\9AD8\5EA6, \55AE\4F4D\53EF\70BA\50CF\7D20 (\4F8B\5982 50px) \6216\767E\5206\6BD4 (\4F8B\5982 15%).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109517488328313763)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109517390829313763)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\61C9\8A72\5728\5716\8868\4E0A\5448\73FE\7E3D\89BD\6372\8EF8.'),
unistr('        \76EE\524D\53EA\6709\5782\76F4\9577\689D\5716\3001\6298\7DDA\5716\3001\5340\57DF\5716\3001\6298\7DDA\5340\57DF\5716\3001\80A1\7968\5206\6790\5716\548C\7D44\5408\5716\652F\63F4\6B64\9078\9805.</p>'),
unistr('        <p>\6CE8\610F - \5FC5\9808\555F\7528<strong>\7E2E\653E\548C\6372\52D5</strong>\9078\9805, \624D\6703\986F\793A\7E3D\89BD\6372\8EF8.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109517284062313763)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109370213440313652)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8986\5BEB\9810\8A2D\7684\300C\4F7F\7528\8005\4ECB\9762\300D\5C64\7D1A\5C0E\89BD. \60A8\53EF\4EE5\4F7F\7528\6B64\9078\9805\8B93\76EE\524D\7684\9801\9762\4E0D\5177\5099\5C0E\89BD\529F\80FD, \6216\70BA\76EE\524D\7684\9801\9762\9078\64C7\66FF\4EE3\7684\5C0E\89BD (\4F8B\5982\5728\61C9\7528\7A0B\5F0F\5B50\6BB5\843D\7684\5468\570D\63D0\4F9B\4E0D\540C\7684\5C0E\89BD).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109370195366313652)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8986\5BEB\4F7F\7528\8005\4ECB\9762\5C64\7D1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109240978338313551)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\9801\9762\8981\5BE6\884C\7684\968E\6BB5\4F5C\696D\72C0\614B\4FDD\8B77\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109742153589313955)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F15\6578\5FC5\9808\8981\6709\7E3D\548C\6AA2\9A57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109742269984313955)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C Request\3001Clear Cache \6216 Name/Value Pair \5F15\6578\51FA\73FE\5728 URL \4E2D, \5C31\5FC5\9808\4E00\4F75\63D0\4F9B\7E3D\548C\6AA2\9A57.<br>'),
unistr('\7E3D\548C\6AA2\9A57\985E\578B\5FC5\9808\8207\4F5C\70BA\5F15\6578\50B3\9001\7684\6240\6709\9805\76EE\4E4B\6700\56B4\683C\7684<em>\968E\6BB5\4F5C\696D\72C0\614B\4FDD\8B77</em>\5C6C\6027\76F8\5BB9.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109742506226313955)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709 URL \5B58\53D6\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109742671420313955)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\6CD5\4F7F\7528 URL \5B58\53D6\9801\9762.<br>'),
unistr('\4E0D\904E, \9801\9762\53EF\4EE5\662F<em>\9023\7D50\5230\5206\652F\9801\9762</em>\5206\652F\985E\578B\7684\76EE\6A19, \56E0\70BA\9019\4E26\975E\57F7\884C URL \91CD\65B0\5C0E\5411.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109741921764313954)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\9650\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109742098550313955)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\4F7F\7528 URL \4F86\8981\6C42\9801\9762, \800C\4E0D\8AD6\662F\5426\5177\6709\968E\6BB5\4F5C\696D\72C0\614B\5F15\6578, \4E5F\4E0D\9700\8981\6709\7E3D\548C\6AA2\9A57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109742339601313955)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\652F\63F4\5F15\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109742493535313955)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\4F7F\7528 URL \4F86\8981\6C42\9801\9762, \4F46 URL \4E0D\80FD\5305\542B Request\3001Clear Cache \6216 Name/Value Pair \5F15\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109240809797313551)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5B58\53D6\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109231890222313544)
,p_name=>'PE.PROPERTY.PAGE_ALIAS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\6B64\9801\9762\7684\6587\6578\5B57\5225\540D. \60A8\53EF\4EE5\4F7F\7528\6B64\5225\540D (\800C\975E\9801\78BC) \4F86\53C3\7167\9801\9762.'),
unistr('\4F8B\5982, \5982\679C\60A8\5728\61C9\7528\7A0B\5F0F 100 \7684\7B2C\4E00\9801\4E2D\4F5C\696D, \60A8\53EF\4EE5\5EFA\7ACB\4E00\500B\7A31\70BA <code>home</code> \7684\5225\540D.'),
unistr('\4E4B\5F8C, \60A8\53EF\4EE5\4F7F\7528\4EE5\4E0B\7684 f?p \8A9E\6CD5, \5F9E\5176\4ED6\9801\9762\5B58\53D6\6B64\9801\9762:'),
'<pre>f?p=100:home</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109231759897313544)
,p_name=>'PE.PROPERTY.PAGE_ALIAS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109240508454313550)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\6B64\9801\9762\70BA\516C\7528\6216\70BA\9700\8981\8A8D\8B49.'),
unistr('\5982\679C\9801\9762\88AB\6307\5B9A\6210\516C\7528, \5247\4EFB\4F55\5B58\53D6\9801\9762\7684\4F7F\7528\8005\7686\53EF\6AA2\8996\9801\9762.'),
unistr('\61C9\7528\7A0B\5F0F\7684\9801\9762\611F\6E2C\51FD\6578, \53EF\80FD\6703\5B58\53D6\6B64\9801\9762\5C6C\6027\4EE5\78BA\8A8D\4E0D\9700\8981\4E8B\524D\8A8D\8B49\4FBF\53EF\6AA2\8996\9801\9762.'),
unistr('\8A8D\8B49\914D\7F6E\7684\9801\9762\611F\6E2C\51FD\6578\5BE6\884C\6703\6C7A\5B9A\6B64\5C6C\6027\662F\5426\6709\4EFB\4F55\4F5C\7528.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109741301085313954)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.N.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9700\8981\8A8D\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109741409973313954)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.Y.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\662F\516C\7528\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109240453665313550)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109232040279313544)
,p_name=>'PE.PROPERTY.PAGE_GROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\8981\8207\6B64\9801\9762\7522\751F\95DC\806F\7684\9801\9762\7FA4\7D44.'),
unistr('\9801\9762\7FA4\7D44\4E0D\6703\5F71\97FF\529F\80FD, \4F46\662F\53EF\4EE5\5354\52A9\958B\767C\4EBA\54E1\7BA1\7406\61C9\7528\7A0B\5F0F\7684\9801\9762.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109231902726313544)
,p_name=>'PE.PROPERTY.PAGE_GROUP.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109239504535313550)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\66FF\4EE3\60A8\9801\9762\6A23\677F\4E4B <code>#ONLOAD#</code> \66FF\4EE3\5B57\4E32\7684\6587\5B57.'),
unistr('\82E5\8981\4F7F\7528\9019\9805\529F\80FD, \60A8\7684\9801\9762\6A23\677F\5FC5\9808\8981\542B\62EC <code>#ONLOAD#</code> \66FF\4EE3\5B57\4E32.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109239441017313550)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 HTML \4E3B\9AD4\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109232234888313544)
,p_name=>'PE.PROPERTY.PAGE_MODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\6B64\9801\9762\7684\9801\9762\6A21\5F0F.</p>'),
'#LOV_VALUES#',
unistr('<p>\8ACB\6CE8\610F, \76EE\524D\7684\61C9\7528\7A0B\5F0F\4E3B\984C\5305\542B\9810\8A2D<em>\5C0D\8A71\65B9\584A\9801\9762\6A23\677F</em>\6642, \624D\53EF\4EE5\9078\53D6<em>\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A</em>\548C<em>\975E\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A</em>\9078\9805.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109740469661313953)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109740595240313953)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9801\9762\986F\793A\70BA\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A.<br>'),
unistr('\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A\662F\4F4D\65BC\6AA2\8996\57E0\4E2D\7684\91CD\758A\8996\7A97, \5B83\6703\7DAD\6301\5728\4F5C\7528\4E2D\53CA\4F7F\7528\4E2D\72C0\614B, \76F4\5230\4E00\822C\4F7F\7528\8005\96B1\85CF (\95DC\9589) \6B64\5C0D\8A71\65B9\584A\70BA\6B62.'),
unistr('\5728\5C0D\8A71\65B9\584A\95DC\9589\4E4B\524D, \76F8\95DC\9801\9762\6703\5448\73FE\7070\8272\4E14\4E00\822C\4F7F\7528\8005\7121\6CD5\8207\9801\9762\7684\5176\4ED6\5167\5BB9\4E92\52D5.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109740685398313953)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975E\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109740767605313954)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9801\9762\986F\793A\70BA\975E\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A.<br>'),
unistr('\975E\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A\662F\4F4D\65BC\6AA2\8996\57E0\4E2D\7684\91CD\758A\8996\7A97, \4E00\822C\4F7F\7528\8005\53EF\4EE5\8207\6B64\5C0D\8A71\65B9\584A\4EE5\53CA\555F\52D5\6B64\5C0D\8A71\65B9\584A\7684\9801\9762\5167\5BB9\9032\884C\4E92\52D5.'),
unistr('\7576\4E0D\9700\8981\4F7F\7528\8981\6C42\7684\8CC7\8A0A\5373\53EF\7E7C\7E8C\4F5C\696D\6642, \53EF\4EE5\4F7F\7528\975E\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A, \5DE5\4F5C\4FBF\53EF\65BC\8996\7A97\958B\555F\671F\9593\5728\5176\4ED6\5730\65B9\7E7C\7E8C\9032\884C.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109740208094313953)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109740317073313953)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\986F\793A\70BA\4E00\822C &PRODUCT_NAME. \61C9\7528\7A0B\5F0F\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109232120522313544)
,p_name=>'PE.PROPERTY.PAGE_MODE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110081752619314201)
,p_name=>'PE.PROPERTY.PAGE_NAVIGATION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109440785413313706)
,p_name=>'PE.PROPERTY.PAGE_PROCESS_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\8981\57F7\884C\7684\8655\7406\4F5C\696D\985E\578B. \4EE5\4E0B\662F\652F\63F4\7684\8655\7406\4F5C\696D\985E\578B:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\8996\60A8\7684\61C9\7528\7A0B\5F0F\7D44\614B\800C\5B9A, \6B64\8655\53EF\80FD\6703\63D0\4F9B\60A8\5176\4ED6\8655\7406\4F5C\696D\985E\578B Plug-in.'),
unistr('\9019\4E9B\6703\986F\793A\70BA <em>&lt;My Plug-in&gt; [Plug-in]</em>.'),
unistr('\4E0B\5217 Plug-in \6703\5B89\88DD\5728\6B64\61C9\7528\7A0B\5F0F\7684\5171\7528\5143\4EF6\5167:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109263635669313568)
,p_name=>'PE.PROPERTY.PAGE_PROCESS_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110064859410314189)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\50B3\56DE\503C\4F5C\70BA\6B64\53C3\6578\4F86\6E90\7684 PL/SQL \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110064795554314189)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110064666085314189)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4F5C\70BA\6B64\53C3\6578\4F86\6E90\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110064594498314189)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110065041842314189)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\4F5C\70BA\6B64\53C3\6578\76EE\7684\5730\7684\4E00\6216\591A\500B\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \82E5\6709\591A\500B\9805\76EE, \8ACB\4F7F\7528\9017\865F\5340\9694\6BCF\500B\9805\76EE\540D\7A31.</p>'),
unistr('<p>\60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\53D6.'),
unistr('\5982\679C\5F9E\6E05\55AE\4E2D\9078\64C7, \4E14\540C\6642\9593\5DF2\7D93\6709\8F38\5165\7684\6587\5B57\7684\8A71, \5C07\6703\5728\73FE\6709\6587\5B57\7684\7D50\5C3E\52A0\4E0A\4E00\500B\9017\865F, \5F8C\9762\518D\63A5\8457\5F9E\6E05\55AE\50B3\56DE\7684\9805\76EE\540D\7A31.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110064907735314189)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110066281821314190)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\53EF\7528\7684\6E05\55AE\4E2D\9078\53D6\53C3\6578\7684\4F86\6E90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110066702279314190)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110066870522314190)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B <em>PL/SQL \51FD\6578\4E3B\9AD4</em>\50B3\56DE\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110066322765314190)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110066439477314190)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\9078\53D6<em>\9805\76EE</em>\4E4B\968E\6BB5\4F5C\696D\72C0\614B\7684\503C.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110066503688314190)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110066668131314190)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5728<em>\975C\614B\503C</em>\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110066130880314190)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109588516348313821)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\53C3\6578\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109588488017313820)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109616202967313845)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109232459761313544)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8ACB\9078\53D6\4E00\500B\4F9B\7528\65BC\5B9A\7FA9\6B64\9801\9762\4E4B\5916\89C0\548C\7248\9762\914D\7F6E\7684\6A23\677F.</p>'),
unistr('        <p>\9801\9762\6A23\677F\5B9A\7FA9\65BC\61C9\7528\7A0B\5F0F\4E3B\984C\4E2D.'),
unistr('        \9801\9762\5EFA\7ACB\4E4B\5F8C, \6B64\6A23\677F\5C31\6703\81EA\52D5\8A2D\70BA<em>\4E3B\984C\9810\8A2D\503C</em>, \5C07\4F7F\7528\76EE\524D\4E3B\984C\4E2D\5B9A\7FA9\7684\9810\8A2D\9801\9762\6A23\677F\4F86\5448\73FE\9801\9762.'),
unistr('        \5728\6B64\8655\6240\505A\7684\9078\64C7\6703\8986\5BEB\9810\8A2D\7684\9801\9762\6A23\677F.</p>'),
unistr('        <p>\8A31\591A\4E3B\984C\90FD\5305\542B\5177\7279\5B9A\7528\9014\7684\9801\9762\6A23\677F, \4F8B\5982\7528\65BC\986F\793A\542B\5074\908A\8CC7\6599\6B04\7684\5167\5BB9\3001\767B\5165\9801\9762\3001\5C0D\8A71\65B9\584A\9801\9762\7B49\7B49.<br>'),
unistr('        \300C\901A\7528\4E3B\984C\300D\63D0\4F9B\4E0B\5217\9801\9762\6A23\677F:'),
'          <dl>',
unistr('            <dt>\6A19\6E96</dt>'),
unistr('              <dd>\9810\8A2D\7684\9801\9762\6A23\677F. \9069\7528\65BC\9996\9801\3001\5100\8868\677F\3001\5927\578B\5831\8868\4EE5\53CA\5176\4ED6\9700\8981\4F7F\7528\5927\5E45\756B\9762\7684\7248\9762\914D\7F6E.</dd>'),
unistr('            <dt>\5DE6\5074\8CC7\6599\6B04</dt>'),
unistr('              <dd>\63D0\4F9B\5DE6\5074\986F\793A\4F4D\7F6E, \9069\7528\65BC\641C\5C0B\548C\7BE9\9078\9801\9762.</dd>'),
unistr('            <dt>\53F3\5074\8CC7\6599\6B04</dt>'),
unistr('              <dd>\63D0\4F9B\53EF\96B1\85CF\7684\53F3\5074\986F\793A\4F4D\7F6E, \9069\7528\65BC\986F\793A\52D5\4F5C\5C0E\5411\7684\63A7\5236\9805, \4F8B\5982\6309\9215\6216\6E05\55AE.</dd>'),
unistr('            <dt>\5DE6\5074\548C\53F3\5074\8CC7\6599\6B04</dt>'),
unistr('              <dd>\63D0\4F9B\5DE6\5074\8CC7\6599\6B04\548C\53EF\96B1\85CF\7684\53F3\5074\8CC7\6599\6B04, \9069\7528\65BC\6975\8907\96DC\7684\9801\9762.</dd>'),
unistr('            <dt>\767B\5165</dt>'),
unistr('              <dd>\50C5\9069\7528\65BC\61C9\7528\7A0B\5F0F\767B\5165\9801\9762.</dd>'),
unistr('            <dt>\8DD1\99AC\71C8</dt>'),
unistr('              <dd>\63D0\4F9B\53EF\96B1\85CF\7684\53F3\5074\8CC7\6599\6B04, \4EE5\53CA\5305\542B\4E3B\8981\8CC7\8A0A\7684\6A19\984C\5217\5340\57DF.'),
unistr('              \6B64\9801\9762\6A23\677F\9069\7528\65BC\986F\793A\542B\6709\6578\4EFD\76F8\95DC\5831\8868\6216\8CC7\6599\7684\55AE\4E00\8A18\9304.'),
unistr('              \8DD1\99AC\71C8\901A\5E38\7528\65BC\986F\793A\5148\5F9E\5831\8868\9078\53D6\4E00\7B46\4E3B\8981\8A18\9304\6642\7684\300C\4E3B\8981-\660E\7D30\300D\95DC\4FC2. </dd>'),
unistr('            <dt>\6700\5C0F (\7121\5C0E\89BD)</dt>'),
unistr('              <dd>\9069\5408\6975\7C21\55AE\7684\9801\9762\3001\514D\8CAC\8072\660E\3001\55AE\9801\61C9\7528\7A0B\5F0F\6216\4E0D\9700\8981\5C0E\89BD\7684\60C5\6CC1.</dd>'),
'          </dl>',
unistr('          \53E6\8ACB\53C3\95B1: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109232353338313544)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109616437635313845)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110057414672314184)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\4E3B\984C\9810\8A2D\503C\4E2D\5B9A\7FA9\7684\8A2D\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109233229533313545)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\700F\89BD\81F3\65B0\9801\9762\6216\9001\51FA\9801\9762\6642\6240\4F7F\7528\7684\8F49\63DB.</p>'),
unistr('<p>\4E0D\652F\63F4 3D \8F49\63DB\7684\820A\7248\700F\89BD\5668\7121\6CD5\4F7F\7528\5927\90E8\5206\7684\8F49\63DB.'),
unistr('\4E0D\652F\63F4 3D \7684\88DD\7F6E (\4F8B\5982 Android 2.x) \9810\8A2D\6703\5C07\6240\6709\8F49\63DB\985E\578B\9000\56DE\5230\6DE1\5165.'),
unistr('\8ACB\53C3\95B1 jQuery Mobile \6587\4EF6\77AD\89E3\5176\4ED6\8A73\7D30\8CC7\8A0A.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109745376418313957)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FADE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DE1\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109745466594313957)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FLIP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FFB\8F49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109745525057313957)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FLOW.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D41\7A0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109745220644313957)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.NONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109745671263313957)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.POP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8DF3\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109745718382313957)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6ED1\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109745887464313957)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEDOWN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5411\4E0B\6ED1\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109745903277313958)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEFADE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6ED1\52D5\6DE1\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109746078459313958)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEUP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5411\4E0A\6ED1\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109746193730313958)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.TURN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65CB\8F49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109233119796313545)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8F49\63DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109921351257314087)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\7576\4F7F\7528\8005\5617\8A66\96E2\958B\6709\5C1A\672A\5132\5B58\4E4B\8B8A\66F4\7684\9801\9762\6642, \662F\5426\5C0D\4F7F\7528\8005\767C\51FA\8B66\544A.'),
unistr('        \82E5\57F7\884C\9019\9805\6AA2\67E5,\300C\9801\9762\9805\76EE\300D\548C\300C\6309\9215\300D\4E5F\63D0\4F9B\66F4\7D30\90E8\7684\63A7\5236\53CA\5176\4E2D\6240\5305\62EC\7684\5167\5BB9.'),
unistr('        \5C0D\65BC\300C\6309\9215\300D, \60A8\53EF\4EE5\6307\5B9A\6309\4E00\4E0B\6309\9215\662F\5426\5C07\57F7\884C\6AA2\67E5.'),
unistr('        \5C0D\65BC\300C\9801\9762\9805\76EE\300D, \60A8\53EF\4EE5\6307\5B9A\6AA2\67E5\61C9\8A72\5305\62EC\9084\662F\5FFD\7565\5C0D\9805\76EE\7684\8B8A\66F4 (\8ACB\53C3\95B1<em>\672A\5132\5B58\8B8A\66F4\8B66\544A</em>\5C6C\6027\4EE5\77AD\89E3\4E8C\8005\7684\8A73\7D30\8CC7\8A0A).</p>'),
unistr('        <p>\6CE8\610F: \9019\9805\6AA2\67E5\4E0D\9069\7528\65BC\4E00\822C\4F7F\7528\8005\95DC\9589\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A\9801\9762\7684\60C5\6CC1.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109921285278314087)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5132\5B58\8B8A\66F4\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109568717314313806)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5831\8868\5206\9801\7684\986F\793A\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109769934528313976)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_LEFT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B - \5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109770001527313976)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_RIGHT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B - \53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109770369334313976)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_LEFT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\8207\4E0B - \5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109770445745313976)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_RIGHT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\8207\4E0B - \53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109770197637313976)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_LEFT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A - \5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109770224506313976)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_RIGHT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A - \53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109568656759313806)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110081414997314201)
,p_name=>'PE.PROPERTY.PARAMETER_ID.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\6578 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109552908124313790)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\53C3\6578\662F\5426\70BA\5FC5\8981\4E14\5FC5\9808\52A0\4EE5\8A2D\5B9A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109552815483313790)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109553130692313790)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\53C3\6578\7684\9810\8A2D\6216\975C\614B\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109553036830313790)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109288739930313591)
,p_name=>'PE.PROPERTY.PARENT_REGION.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\7236\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109247756629313556)
,p_name=>'PE.PROPERTY.PARENT_REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5C07\986F\793A\6B64\5340\57DF\7684\7236\9805\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109247644400313556)
,p_name=>'PE.PROPERTY.PARENT_REGION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109604093185313835)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\8981\4F7F\7528\300C\91CD\65B0\6574\7406\90E8\5206\9801\9762 (PPR)\300D\4F86\66F4\65B0\5831\8868\986F\793A.</p>'),
unistr('\5982\679C\4E00\822C\4F7F\7528\8005\57F7\884C\4E86\67D0\500B\52D5\4F5C (\4F8B\5982, \5206\9801\8981\6C42\6216\9078\53D6\65B0\7684\6392\5E8F\8CC7\6599\6B04), \7CFB\7D71\5C31\5FC5\9808\91CD\65B0\6574\7406\76EE\524D\7684\5831\8868\8CC7\6599\5217. \5C07\6B64\5C6C\6027\8A2D\70BA<strong>\958B\555F</strong>\6642, \53EA\6703\91CD\65B0\6574\7406\5831\8868\5340\57DF. \5C07\6B64\5C6C\6027\8A2D\70BA<strong>\95DC\9589</strong>\6642, \5247\6703\91CD\65B0\6574\7406\6574\500B\9801\9762.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109603930712313835)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6574\7406\90E8\5206\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109781084261313984)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109599556106313829)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\5716\8868\8981\4F7F\7528\7684\80CC\666F\8272\5F69.</p>'),
unistr('<p>\6307\5B9A\8272\5F69\6642, \662F\4F7F\7528\5341\516D\9032\4F4D\8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A. \5341\516D\9032\4F4D\8868\793A\6CD5\662F\4EE5 #xxyyzz (\4E00\500B # \5F8C\9762\8DDF\8457 3 \500B\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57) \4F86\5B9A\7FA9, \5176\4E2D xx\3001yy \53CA zz \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\96D9\5B57\5143\5341\516D\9032\4F4D\503C.'),
unistr('RGB \4EE3\78BC\662F\4EE5 RGB(xxx,xxx,xxx) \4F86\5B9A\7FA9, \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \7684\6578\5B57, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\55AE\4E00 8 \4F4D\5143\4F4D\5143\7D44\503C.</p>'),
unistr('<p>\5728\7DB2\969B\7DB2\8DEF\4E2D\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5373\53EF\627E\51FA\60A8\60F3\8981\4F7F\7528\4E4B\8272\5F69\7684\5C0D\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109599452174313829)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\80CC\666F\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109599957013313829)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\9577\689D\5716\7684\5BEC\5EA6 (\50CF\7D20).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109599889441313829)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\689D\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109626879923313852)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.UNIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109831530491314022)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109599773880313829)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\5716\8868\8981\4F7F\7528\7684\524D\666F\8272\5F69.</p>'),
unistr('<p>\6307\5B9A\8272\5F69\6642, \662F\4F7F\7528\5341\516D\9032\4F4D\8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A. \5341\516D\9032\4F4D\8868\793A\6CD5\662F\4EE5 #xxyyzz (\4E00\500B # \5F8C\9762\8DDF\8457 3 \500B\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57) \4F86\5B9A\7FA9, \5176\4E2D xx\3001yy \53CA zz \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\96D9\5B57\5143\5341\516D\9032\4F4D\503C.'),
unistr('RGB \4EE3\78BC\662F\4EE5 RGB(xxx,xxx,xxx) \4F86\5B9A\7FA9, \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \7684\6578\5B57, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\55AE\4E00 8 \4F4D\5143\4F4D\5143\7D44\503C.</p>'),
unistr('<p>\5728\7DB2\969B\7DB2\8DEF\4E2D\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5373\53EF\627E\51FA\60A8\60F3\8981\4F7F\7528\4E4B\8272\5F69\7684\5C0D\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109599614066313829)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D\666F\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109511833217313759)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\4F54\6574\500B\5713\9905\5716\7684\6BD4\4F8B, \4F4E\65BC\8A72\503C\7684\5207\7247\5C07\805A\7E3D\5230\300C\5176\4ED6\300D\5207\7247. \6709\6548\503C\7BC4\570D\5F9E 0 (\9810\8A2D\503C) \5230 1</p>'),
unistr('        <p>\4F8B\5982, \503C 0.15 \6703\5C07\5C0F\65BC 15% \7684\6240\6709\5713\9905\5716\5207\7247\805A\7E3D\5230\300C\5176\4ED6\300D\5207\7247.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109511731504313759)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\9905\5716\5176\4ED6\81E8\754C\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109542429556313782)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5728\9078\64C7\5713\9905\5716\5340\6BB5\5F8C\6240\5957\7528\7684\6548\679C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109542589365313782)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.EXPLODE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C55\958B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109542727556313782)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109542601813313782)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHTANDEXPLODE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\793A\548C\5C55\958B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109542349878313782)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\9905\5716\9078\53D6\6548\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109620841534313848)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\63D0\4F9B\4E3B\7D22\5F15\9375\503C\7684 PL/SQL \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109620752708313848)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109621026429313848)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4E3B\7D22\5F15\9375\7684\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109620977201313848)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109620695923313848)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\4E3B\7D22\5F15\9375\7684\4F86\6E90\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109787919804313989)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.F.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109788020849313989)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.S.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\73FE\6709\7684\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109787836889313989)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.T.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\73FE\6709\7684\89F8\767C\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109620536690313848)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109704916085313925)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\7528\4F86\53D6\4EE3\81EA\52D5\7522\751F\4E4B\67E5\8A62\7684 SQL \67E5\8A62 (\9078\53D6\4E0D\540C\7684\8CC7\6599\6B04\503C). SQL \67E5\8A62\9700\8981\50B3\56DE\4E00\500B\8CC7\6599\6B04. \8F38\5165 SQL \67E5\8A62\53EF\4EE5\6539\9032\67D0\4E9B\5831\8868\7684\6548\80FD.  \7576\4F7F\7528\8005\9EDE\9078\8CC7\6599\6B04\6A19\982D\6642\5C31\6703\986F\793A\6B64\503C\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109704807924313925)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109704558585313925)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5982\4F55\884D\751F\5831\8868\8CC7\6599\6B04\4E0B\62C9\5F0F\6E05\55AE\7BE9\9078\7684\503C\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109792916852313993)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\5177\540D\7684\503C\6E05\55AE\7BE9\9078\5B8C\5168\76F8\7B26\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109793079337313993)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5177\540D\7684\503C\6E05\55AE\884D\751F\503C\6E05\55AE, \4EE5\5EFA\7ACB\7B49\65BC\7BE9\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109793168176313993)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\5177\540D\7684\503C\6E05\55AE\7BE9\9078\5305\542B\7684\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109793221915313993)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5177\540D\7684\503C\6E05\55AE\884D\751F\503C\6E05\55AE, \4EE5\5EFA\7ACB\5305\542B\7BE9\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109792758022313993)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\5B9A\7FA9\7684\503C\6E05\55AE\7BE9\9078\5305\542B\7684\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109792874188313993)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5B9A\7FA9\7684\503C\6E05\55AE SQL \67E5\8A62\884D\751F\503C\6E05\55AE, \4EE5\5EFA\7ACB\5305\542B\7BE9\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109792330625313993)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\8CC7\6599\6B04\985E\578B\9810\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109792467297313993)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('STRING \8207 NUMBER \8CC7\6599\6B04\53EF\5F9E\4E0D\540C\7684\8CC7\6599\6B04\503C\884D\751F\503C\6E05\55AE. DATE \8CC7\6599\6B04\5F9E\9810\5148\5B9A\7FA9\7684\65E5\671F\7BC4\570D\884D\751F\503C\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109792196863313993)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109792295429313993)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528\503C\6E05\55AE\7684\7BE9\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109792553568313993)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\5B9A\7FA9\7684\503C\6E05\55AE\7BE9\9078\5B8C\5168\76F8\7B26\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109792633554313993)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5B9A\7FA9\7684\503C\6E05\55AE SQL \67E5\8A62\884D\751F\503C\6E05\55AE, \4EE5\5EFA\7ACB\7B49\65BC\7BE9\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109704433446313925)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109949486464314107)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.APP_PROCESS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\57F7\884C\7684 PL/SQL \7A0B\5F0F\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109558737557313794)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5728\9060\7AEF\8CC7\6599\5EAB\4E0A\57F7\884C\7684 PL/SQL \7A0B\5F0F\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109558638940313794)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7522\751F HTML \8F38\51FA\7684 PL/SQL \7A0B\5F0F\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109325487885313619)
,p_name=>'PE.PROPERTY.PLSQL_CODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\8A8D\8B49\914D\7F6E\5167\4F7F\7528\7684 PL/SQL \4F86\6E90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109325373253313619)
,p_name=>'PE.PROPERTY.PLSQL_CODE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109558182122313794)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8655\7406\4F5C\696D\7684\57F7\884C\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109558207128313794)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672C\6A5F\8CC7\6599\5EAB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109558397743313794)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \7A0B\5F0F\78BC\6703\5728\672C\6A5F\8CC7\6599\5EAB\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109558429603313794)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528 REST \7684 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109558546276313794)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \7A0B\5F0F\78BC\6703\5728\4F7F\7528\300C\555F\7528 REST \7684 SQL\300D\5B9A\7FA9\9023\7DDA\7684\9060\7AEF\8CC7\6599\5EAB\57F7\884C. ')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109558005641313794)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109439870970313705)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6 Plug-in \8981\986F\793A\5728\4F7F\7528\8005\4ECB\9762\7684\54EA\500B\985E\5225\5E95\4E0B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109765864219313973)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.COMPONENT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109765913059313973)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EFFECT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6548\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109766031450313973)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EXECUTE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109766116310313973)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.INIT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D77\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109766247342313973)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.MISC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109766322929313973)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NAVIGATION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109766498388313973)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NOTIFICATION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109766549897313973)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.STYLE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109439770691313705)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110091958629314209)
,p_name=>'PE.PROPERTY.PLUGIN_INIT_JAVASCRIPT_CODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8F38\5165\53EF\57F7\884C\7684 JavaScript \7A0B\5F0F\78BC. \6CE8\610F: \6B64\9078\9805\7684\5BE6\969B\4F5C\7528\6703\56E0\76EE\524D\7684 Plug-in \800C\4E0D\540C.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110091854591314209)
,p_name=>'PE.PROPERTY.PLUGIN_INIT_JAVASCRIPT_CODE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \521D\59CB\5316\7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109616563808313845)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110057552367314184)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\4E3B\984C\9810\8A2D\503C\4E2D\5B9A\7FA9\7684\8A2D\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109233408133313545)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\958B\555F\5373\73FE\5F0F\8996\7A97\6642\4F7F\7528\7684\8F49\63DB.</p>'),
unistr('<p>\4E0D\652F\63F4 3D \8F49\63DB\7684\820A\7248\700F\89BD\5668\5C07\7121\6CD5\4F7F\7528\5927\90E8\5206\7684\8F49\63DB.'),
unistr('\6839\64DA\9810\8A2D, \4E0D\652F\63F4 3D \7684\88DD\7F6E (\4F8B\5982 Android 2.x) \6703\5C07\6240\6709\8F49\63DB\985E\578B\9000\56DE\5230\6DE1\5165.'),
unistr('\5982\9700\8A73\7D30\8CC7\8A0A, \8ACB\53C3\95B1 jQuery Mobile \6587\4EF6.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109746347824313958)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FADE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DE1\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109746469912313958)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FLIP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FFB\8F49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109746555856313958)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FLOW.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D41\7A0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109746222415313958)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.NONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109746665803313958)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.POP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8DF3\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109746783284313958)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6ED1\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109746838383313958)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEDOWN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5411\4E0B\6ED1\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109746924640313958)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEFADE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6ED1\52D5\6DE1\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109747074711313958)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEUP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5411\4E0A\6ED1\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109747192495313958)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.TURN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65CB\8F49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109233398844313545)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5373\73FE\5F0F\8F49\63DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109326447594313619)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\9032\884C\8A8D\8B49\6B65\9A5F (\767B\5165\8B49\660E\8CC7\6599\9A57\8B49) \4E4B\5F8C, &PRODUCT_NAME. \767B\5165\7A0B\5E8F (\767B\5165 API) \8981\57F7\884C\4E4B\7A0B\5E8F\7684\540D\7A31.'),
unistr('\767B\5165\7A0B\5E8F\6703\5728\57F7\884C\4E00\822C\767B\5165\7A0B\5E8F\4EFB\52D9 (\5305\62EC\8A2D\5B9A Cookie \53CA\8A3B\518A\968E\6BB5\4F5C\696D) \4E4B\5F8C, \4F46\5728\91CD\65B0\5C0E\5411\81F3\60F3\8981\7684\61C9\7528\7A0B\5F0F\9801\9762\4E4B\524D, \57F7\884C\6B64\7A0B\5F0F\78BC.'),
unistr('\53EF\4EE5\5728\300CPL/SQL \7A0B\5F0F\78BC\300D\5C6C\6027\4E2D\6216\5728\8CC7\6599\5EAB\4E2D\5B9A\7FA9\6B64\7A0B\5E8F.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109326310406313619)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\5F8C\7A0B\5E8F\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109253825950313560)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165 PL/SQL \8868\793A\5F0F\4F86\91CD\65B0\5B9A\7FA9\9805\76EE\7684\503C.</p>'),
unistr('<p> \4F8B\5982, \5982\679C\6B64\9805\76EE\7684\540D\7A31\70BA <code>P1_X</code>, \90A3\9EBC\60A8\53EF\4EE5\4F7F\7528 <code>UPPER(:P1_X)</code>\3001<code>INITCAP(:P2_Y)</code>\3001<code>MIN(:P1_X, :P2_Y - 200)</code>\3001<code>NVL(:P1_X, :P2_Y)</code> \7B49\5F8C\7E8C\904B\7B97\8868\793A\5F0F, \6216 <code>my_func(:P1_X)</code> \7684\51FD\6578\547C\53EB, \8A2D\5B9A\6B64\9805\76EE\7684\6700\7D42\503C.'),
unistr('\6CE8\610F: \9019\4E9B\7BC4\4F8B\793A\7BC4\8868\793A\5F0F\53EF\4EE5\53C3\7167\76EE\524D\7684\9805\76EE, \6216\662F\53C3\7167\968E\6BB5\4F5C\696D\72C0\614B\4E2D\7684\5176\4ED6\9805\76EE.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109253748078313560)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C\7E8C\8A08\7B97\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109326891211313620)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5728 &PRODUCT_NAME. \6E05\9664\4F7F\7528\8005\968E\6BB5\4F5C\696D\4E4B\5F8C, \8981\5C07\61C9\7528\7A0B\5F0F\91CD\65B0\5C0E\5411\81F3\54EA\500B URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109326738730313620)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\51FA\5F8C URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110003878853314146)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\51FD\6578\4E3B\9AD4\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110004184507314146)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110004010995314146)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110003953141314146)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110004290187314146)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110003736271314146)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110005098666314147)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165 Java \51FD\6578\4E3B\9AD4, \5176\4E2D\50B3\56DE\7684 SQL \67E5\8A62\5C07\8F49\63DB\64F7\53D6\81EA Web \4F86\6E90\7684\8CC7\6599. Java \51FD\6578\4E3B\9AD4\50B3\56DE\7684 SQL \67E5\8A62\5FC5\9808\5F9E #APEX$SOURCE_DATA# \865B\64EC\8868\683C\9078\53D6, \4E26\8B80\53D6\8CC7\6599\8A2D\5B9A\6A94\4E2D\7684\8CC7\6599\6B04. \6B64\8655\4E0D\652F\63F4\4F7F\7528 SQL WITH \5B50\53E5\7684\5B50\67E5\8A62\627F\88FD\529F\80FD. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110004945850314147)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 Java \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110004819732314147)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\9078\53D6 EMPNO\3001ENAME \4EE5\53CA SAL \8CC7\6599\6B04, \4E26\7BE9\9664 SAL \5C0F\65BC 3000 \7684\6240\6709\8CC7\6599\5217.</dt>'),
'<dd><pre>',
'return "select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110004701934314147)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165 JavaScript \51FD\6578\4E3B\9AD4, \5176\4E2D\50B3\56DE\7684 SQL \67E5\8A62\5C07\8F49\63DB\64F7\53D6\81EA Web \4F86\6E90\7684\8CC7\6599. JavaScript \51FD\6578\4E3B\9AD4\50B3\56DE\7684 SQL \67E5\8A62\5FC5\9808\5F9E #APEX$SOURCE_DATA# \865B\64EC\8868\683C\9078\53D6, \4E26\8B80\53D6\8CC7\6599\8A2D\5B9A\6A94\4E2D\7684\8CC7\6599\6B04. \6B64\8655\4E0D\652F\63F4\4F7F\7528 SQL WITH \5B50\53E5\7684\5B50\67E5\8A62\627F\88FD\529F\80FD. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110004619006314147)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 JavaScript \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110059340332314185)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5C07\6700\65B0\50F1\7528\7684\986F\793A\5728\6700\524D\9762, \5C1A\672A\50F1\7528\7684\6392\5728\6700\5F8C\9762. \5982\679C\65E5\671F\76F8\7B49, \5247\4F9D\90E8\9580\7DE8\865F\6392\5E8F.</dt>'),
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110059214214314185)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\4E00\6216\591A\500B\4EE5\9017\865F\5340\9694\7684\8CC7\6599\6B04\540D\7A31 (\5305\62EC\6307\4EE4), \4EE5\5B9A\7FA9\8A18\9304\7684\64F7\53D6\9806\5E8F.</p>'),
unistr('        <p>\6307\4EE4\5305\62EC:'),
'          <ul>',
unistr('            <li>ASC - \4EE5\905E\589E\9806\5E8F\50B3\56DE\8CC7\6599\6B04</li>'),
unistr('            <li>DESC - \4EE5\905E\6E1B\9806\5E8F\50B3\56DE\8CC7\6599\6B04</li>'),
unistr('            <li>NULLS FIRST - \5148\50B3\56DE\6C92\6709\503C\7684\8CC7\6599\6B04, \518D\50B3\56DE\542B\6709\503C\7684\8CC7\6599\6B04</li>'),
unistr('            <li>NULLS LAST - \5148\50B3\56DE\542B\6709\503C\7684\8CC7\6599\6B04, \518D\50B3\56DE\6C92\6709\503C\7684\8CC7\6599\6B04</li>'),
'          </ul>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110059160428314185)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5217\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110004512901314147)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\9078\53D6 EMPNO\3001ENAME \4EE5\53CA SAL \8CC7\6599\6B04, \4E26\7BE9\9664 SAL \5C0F\65BC 3000 \7684\6240\6709\8CC7\6599\5217.</dt>'),
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110004499809314147)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165 PL/SQL \51FD\6578\4E3B\9AD4, \5176\4E2D\50B3\56DE\7684 SQL \67E5\8A62\5C07\8F49\63DB\64F7\53D6\81EA Web \4F86\6E90\7684\8CC7\6599. PL/SQL \51FD\6578\4E3B\9AD4\50B3\56DE\7684 SQL \67E5\8A62\5FC5\9808\5F9E #APEX$SOURCE_DATA# \865B\64EC\8868\683C\9078\53D6, \4E26\8B80\53D6\8CC7\6599\8A2D\5B9A\6A94\4E2D\7684\8CC7\6599\6B04. \6B64\8655\4E0D\652F\63F4\4F7F\7528 SQL WITH \5B50\53E5\7684\5B50\67E5\8A62\627F\88FD\529F\80FD. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110004301224314147)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110005219780314147)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165 Python \51FD\6578\4E3B\9AD4, \5176\4E2D\50B3\56DE\7684 SQL \67E5\8A62\5C07\8F49\63DB\64F7\53D6\81EA Web \4F86\6E90\7684\8CC7\6599. Python \51FD\6578\4E3B\9AD4\50B3\56DE\7684 SQL \67E5\8A62\5FC5\9808\5F9E #APEX$SOURCE_DATA# \865B\64EC\8868\683C\9078\53D6, \4E26\8B80\53D6\8CC7\6599\8A2D\5B9A\6A94\4E2D\7684\8CC7\6599\6B04. \6B64\8655\4E0D\652F\63F4\4F7F\7528 SQL WITH \5B50\53E5\7684\5B50\67E5\8A62\627F\88FD\529F\80FD. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110005192161314147)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 Python \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110060836215314186)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\9078\53D6 EMPNO\3001ENAME \4EE5\53CA SAL \8CC7\6599\6B04, \4E26\7BE9\9664 SAL \5C0F\65BC 3000 \7684\6240\6709\8CC7\6599\5217.</dt>'),
'<dd><pre>',
'select EMPNO, ENAME, SAL',
'  from #APEX$SOURCE_DATA#',
' where SAL < 3000',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110059503460314185)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7528\65BC\8F49\63DB\5F9E REST \8CC7\6599\4F86\6E90\64F7\53D6\4E4B\8CC7\6599\7684 SQL \67E5\8A62. \5F9E\865B\64EC\8868\683C #APEX$SOURCE_DATA# \9078\53D6\4E26\6307\5B9A\8CC7\6599\8A2D\5B9A\6A94\4E2D\7684\8CC7\6599\6B04. \6B64\8655\4E0D\652F\63F4\4F7F\7528 SQL WITH \5B50\53E5\7684\5B50\67E5\8A62\627F\88FD\529F\80FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110059438333314185)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110059086238314185)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\53EA\5305\62EC\6709\7D93\7406\6216\5F9E\4E8B\696D\52D9\4EBA\54E1\5DE5\4F5C\7684\54E1\5DE5.</dt>'),
'<dd><pre>',
'( MGR is not null or JOB = ''SALESMAN'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110058966872314185)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7528\4EE5\9650\5236\64F7\53D6\4E4B\8A18\9304\7684\6709\6548 SQL where \689D\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110058894102314185)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Where \5B50\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109326231866313619)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\9001\51FA\767B\5165\9801\9762\4E4B\5F8C\4E14\5728\57F7\884C\8B49\660E\8CC7\6599\9A57\8B49\4E4B\524D, \6240\8981\57F7\884C\4E4B\7A0B\5E8F\7684\540D\7A31.'),
unistr('\53EF\4EE5\5728\300CPL/SQL \7A0B\5F0F\78BC\300D\5C6C\6027\4E2D\6216\5728\8CC7\6599\5EAB\5167\5B9A\7FA9\6B64\7A0B\5E8F.</p>'),
unistr('<p>\5728 &PRODUCT_NAME. \5916\9032\884C\4F7F\7528\8005\8B49\660E\8CC7\6599\6AA2\67E5\7684\8A8D\8B49\914D\7F6E\4E00\822C\4E0D\6703\57F7\884C\300C\8A8D\8B49\524D\300D\7A0B\5E8F.'),
unistr('\7BC4\4F8B\5305\62EC <em>HTTP \6A19\982D\8B8A\6578</em>\3001<em>Oracle Application Server Single Sign-On</em>, \4EE5\53CA\4F7F\7528 <code>apex_authentication.post_login</code> (\800C\975E <code>apex_authentication.login</code>) \7684\81EA\8A02\8A8D\8B49\914D\7F6E.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109326136452313619)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\524D\7A0B\5E8F\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109630163785313855)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\542B\6709\8868\683C\4E4B\4E3B\7D22\5F15\9375\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109630058483313855)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109794798356313994)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109707709113313928)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\4F86\986F\793A\6307\5B9A\5C6C\6027\7684\6846\7DDA\8272\5F69.</p>'),
unistr('<p>\8ACB\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A\8272\5F69. \5341\516D\9032\4F4D\8868\793A\6CD5\662F\4EE5 #xxyyzz (\4E00\500B # \5F8C\9762\8DDF\8457 3 \500B\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57) \4F86\5B9A\7FA9, \5176\4E2D xx\3001yy \53CA zz \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\96D9\5B57\5143\5341\516D\9032\4F4D\503C.'),
unistr('RGB \4EE3\78BC\5B9A\7FA9\70BA RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \4E4B\9593\7684\6578\5B57, \5404\81EA\70BA\4E00\500B 8 \4F4D\5143\7684\4F4D\5143\7D44\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.</p>'),
unistr('<p>\8ACB\5F9E\7DB2\969B\7DB2\8DEF\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5C0B\627E\8207\60A8\60F3\4F7F\7528\4E4B\8272\5F69\540C\7B49\7684\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109707668950313927)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6846\7DDA\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109707566711313927)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8868\683C\6846\7DDA\7684\5BEC\5EA6 (\50CF\7D20).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109707424398313927)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6846\7DDA\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109831858870314022)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109710974835313930)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\4F86\986F\793A\6B64\5143\4EF6\80CC\666F\7684\8272\5F69.</p>'),
unistr('<p>\8ACB\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A\8272\5F69. \5341\516D\9032\4F4D\8868\793A\6CD5\5B9A\7FA9\70BA #xxyyzz (# \5F8C\9762\63A5\8457 3 \7D44\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57), \5176\4E2D xx\3001yy \548C zz \70BA\5169\500B\5B57\5143\7684\5341\516D\9032\4F4D\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.'),
unistr('RGB \4EE3\78BC\5B9A\7FA9\70BA RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \4E4B\9593\7684\6578\5B57, \5404\81EA\70BA\4E00\500B 8 \4F4D\5143\7684\4F4D\5143\7D44\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.</p>'),
unistr('<p>\8ACB\5F9E\7DB2\969B\7DB2\8DEF\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5C0B\627E\8207\60A8\60F3\4F7F\7528\4E4B\8272\5F69\540C\7B49\7684\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109710853160313930)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\80CC\666F\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109796833926313996)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109710746132313930)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\4F86\986F\793A\6B64\5143\4EF6\7684\8272\5F69.</p>'),
unistr('<p>\8ACB\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A\8272\5F69. \5341\516D\9032\4F4D\8868\793A\6CD5\5B9A\7FA9\70BA #xxyyzz (# \5F8C\9762\63A5\8457 3 \7D44\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57), \5176\4E2D xx\3001yy \548C zz \70BA\5169\500B\5B57\5143\7684\5341\516D\9032\4F4D\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.'),
unistr('RGB \4EE3\78BC\5B9A\7FA9\70BA RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \4E4B\9593\7684\6578\5B57, \5404\81EA\70BA\4E00\500B 8 \4F4D\5143\7684\4F4D\5143\7D44\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.</p>'),
unistr('<p>\8ACB\5F9E\7DB2\969B\7DB2\8DEF\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5C0B\627E\8207\60A8\60F3\4F7F\7528\4E4B\8272\5F69\540C\7B49\7684\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109710655502313930)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109710138205313929)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\5143\4EF6\7684\5B57\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109796580216313996)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109796326911313996)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109796474964313996)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109710024386313929)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109710516110313930)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\5143\4EF6\7684\5B57\578B\5927\5C0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109710497492313930)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109710366324313930)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\5143\4EF6\7684\5B57\578B\7C97\7D30.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109796702265313996)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C97\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109796680979313996)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109710270508313929)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\7C97\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109831781078314022)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109709945178313929)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\4F86\986F\793A\6B64\5143\4EF6\80CC\666F\7684\8272\5F69.</p>'),
unistr('<p>\8ACB\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A\8272\5F69. \5341\516D\9032\4F4D\8868\793A\6CD5\5B9A\7FA9\70BA #xxyyzz (# \5F8C\9762\63A5\8457 3 \7D44\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57), \5176\4E2D xx\3001yy \548C zz \70BA\5169\500B\5B57\5143\7684\5341\516D\9032\4F4D\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.'),
unistr('RGB \4EE3\78BC\5B9A\7FA9\70BA RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \4E4B\9593\7684\6578\5B57, \5404\81EA\70BA\4E00\500B 8 \4F4D\5143\7684\4F4D\5143\7D44\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.</p>'),
unistr('<p>\8ACB\5F9E\7DB2\969B\7DB2\8DEF\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5C0B\627E\8207\60A8\60F3\4F7F\7528\4E4B\8272\5F69\540C\7B49\7684\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109709893839313929)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\80CC\666F\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109796226433313996)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109709701873313929)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\4F86\986F\793A\6B64\5143\4EF6\7684\8272\5F69.</p>'),
unistr('<p>\8ACB\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A\8272\5F69. \5341\516D\9032\4F4D\8868\793A\6CD5\5B9A\7FA9\70BA #xxyyzz (# \5F8C\9762\63A5\8457 3 \7D44\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57), \5176\4E2D xx\3001yy \548C zz \70BA\5169\500B\5B57\5143\7684\5341\516D\9032\4F4D\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.'),
unistr('RGB \4EE3\78BC\5B9A\7FA9\70BA RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \4E4B\9593\7684\6578\5B57, \5404\81EA\70BA\4E00\500B 8 \4F4D\5143\7684\4F4D\5143\7D44\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.</p>'),
unistr('<p>\8ACB\5F9E\7DB2\969B\7DB2\8DEF\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5C0B\627E\8207\60A8\60F3\4F7F\7528\4E4B\8272\5F69\540C\7B49\7684\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109709682328313929)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109709157272313929)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\5143\4EF6\7684\5B57\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109795916415313995)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109795739853313995)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109795895910313995)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109709074112313929)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109709500922313929)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\5143\4EF6\7684\5B57\578B\5927\5C0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109709498133313929)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109709397940313929)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\5143\4EF6\7684\5B57\578B\7C97\7D30.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109796166371313995)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C97\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109796090355313995)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109709212261313929)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\7C97\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109598720679313828)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5217\5370\5831\8868\6642\7528\4F86\8ABF\6574\6B64\8CC7\6599\6B04\5927\5C0F\7684\8CC7\6599\6B04\5BEC\5EA6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109598675738313828)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\5370\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109713549533313932)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\5B9A\7FA9\8CC7\6599\6B04\5BEC\5EA6\503C\7684\55AE\4F4D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109798326887313997)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.PERCENTAGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109798419327313997)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.POINTS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9EDE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109713498250313932)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BEC\5EA6\55AE\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109712786646313931)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\4E0B\8F09\4E4B\6587\4EF6\7684\540D\7A31. \5982\679C\7559\767D, \6703\4F7F\7528\5340\57DF\540D\7A31\7576\4F5C\6A94\6848\540D\7A31.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109712623952313931)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109707340656313927)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\9801\9762\7684\9AD8\5EA6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109707215469313927)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109714175408313933)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\4E0B\8F09\9023\7D50\7684\6587\5B57. \82E5\8981\5C07\9023\7D50\53D6\4EE3\70BA\5176\4ED6\5C0E\89BD\5143\4EF6 (\4F8B\5982\6309\9215), \8ACB\5C07\6B64\6B04\4F4D\7559\767D. \60A8\53EF\4EE5\4F7F\7528\4E0B\5217\8A9E\6CD5, \4F7F\7528 URL \4F5C\70BA\76EE\6A19, \8A2D\5B9A\5176\4ED6\5143\4EF6\4F86\555F\52D5\5217\5370\8655\7406\4F5C\696D:</p>'),
'<p><pre>f?p=&amp;APP_ID.:&amp;SESSION.:FLOW_XMLP_OUTPUT_R[REGION_ID]</pre></p>',
unistr('<p><strong>\6CE8\610F</strong>: \8ACB\5C07\4EE5\4E0A\5B57\4E32\4E2D\7684 <code>[REGION_ID]</code> \53D6\4EE3\70BA\60A8\7684\5340\57DF ID.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109714029398313933)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109706729340313927)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\9801\9762\7684\65B9\5411.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109794217222313994)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A6B\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109794177204313994)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F4\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109706693072313927)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109713610245313932)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\9805\76EE\884D\751F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109714294879313933)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\9805\76EE\884D\751F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109712959598313931)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5831\8868\8F38\51FA\683C\5F0F. \60A8\4E5F\53EF\4EE5\9078\64C7\4F7F\7528\9805\76EE\6307\5B9A\8F38\51FA\683C\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109798146654313997)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.HTM.D'
,p_message_language=>'zh-tw'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109797899000313997)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.PDF.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109797979553313997)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.RTF.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Word'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109798068543313997)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XLS.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Excel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109798238074313997)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XML.D'
,p_message_language=>'zh-tw'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109712800753313931)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109713119616313932)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\4FDD\7559\683C\5F0F\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\542B\62EC<em>\9078\53D6\6E05\55AE</em>\9801\9762\9805\76EE, \4F9B\4F7F\7528\8005\5728\7A0B\5F0F\5BE6\969B\57F7\884C\6642\9078\53D6\8F38\51FA\683C\5F0F. \6709\6548\503C\5305\62EC</p>'),
'<dl>',
'<dt>PDF</dt>',
unistr('<dd>\5728 PDF \9810\89BD\5668\958B\555F\6587\4EF6</dd>'),
'<dt>RTF</dt>',
unistr('<dd>\5728 Microsoft Word \958B\555F\6587\4EF6</dd>'),
'<dt>XLS</dt>',
unistr('<dd>\5728 Microsoft Excel \958B\555F\6587\4EF6</dd>'),
'<dt>HTM</dt>',
unistr('<dd>\5C07\6587\4EF6\4E0B\8F09\70BA HTML \6A94\6848</dd>'),
'<dt>XML</dt>',
unistr('<dd>\5C07\6587\4EF6\4E0B\8F09\70BA XML \6A94\6848</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109713020041313932)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109711997965313931)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\9801\9762\8868\5C3E\7684\5C0D\9F4A\65B9\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109797621783313997)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7F6E\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109797578756313997)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109797793862313997)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109711874132313931)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\9F4A\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109797451504313996)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109711764358313931)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\4F86\986F\793A\6B64\5143\4EF6\7684\8272\5F69.</p>'),
unistr('<p>\8ACB\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A\8272\5F69. \5341\516D\9032\4F4D\8868\793A\6CD5\5B9A\7FA9\70BA #xxyyzz (# \5F8C\9762\63A5\8457 3 \7D44\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57), \5176\4E2D xx\3001yy \548C zz \70BA\5169\500B\5B57\5143\7684\5341\516D\9032\4F4D\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.'),
unistr('RGB \4EE3\78BC\5B9A\7FA9\70BA RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \4E4B\9593\7684\6578\5B57, \5404\81EA\70BA\4E00\500B 8 \4F4D\5143\7684\4F4D\5143\7D44\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.</p>'),
unistr('<p>\8ACB\5F9E\7DB2\969B\7DB2\8DEF\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5C0B\627E\8207\60A8\60F3\4F7F\7528\4E4B\8272\5F69\540C\7B49\7684\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109711697070313930)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109711199686313930)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\5143\4EF6\7684\5B57\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109797112926313996)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109796992874313996)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109797024342313996)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109711076579313930)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109711538809313930)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\5143\4EF6\7684\5B57\578B\5927\5C0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109711440370313930)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109711324894313930)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\5143\4EF6\7684\5B57\578B\7C97\7D30.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109797367842313996)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C97\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109797288252313996)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109711228262313930)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\7C97\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109712119165313931)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6587\4EF6\4E4B\8868\5C3E\6BB5\843D\4E2D\6240\8981\986F\793A\7684\6587\5B57. \82E5\8981\986F\793A\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE\7684\503C, \8ACB\4F7F\7528 <code>&amp;ITEM_NAME.</code> \8A9E\6CD5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109712038759313931)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8868\5C3E\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109708774158313928)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\9801\9762\6A19\982D\7684\5C0D\9F4A\65B9\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109795587165313995)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7F6E\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109795431909313995)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109795652690313995)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109708616915313928)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\9F4A\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109795311454313995)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109708593525313928)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\4F86\986F\793A\6B64\5143\4EF6\7684\8272\5F69.</p>'),
unistr('<p>\8ACB\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A\8272\5F69. \5341\516D\9032\4F4D\8868\793A\6CD5\5B9A\7FA9\70BA #xxyyzz (# \5F8C\9762\63A5\8457 3 \7D44\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57), \5176\4E2D xx\3001yy \548C zz \70BA\5169\500B\5B57\5143\7684\5341\516D\9032\4F4D\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.'),
unistr('RGB \4EE3\78BC\5B9A\7FA9\70BA RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \4E4B\9593\7684\6578\5B57, \5404\81EA\70BA\4E00\500B 8 \4F4D\5143\7684\4F4D\5143\7D44\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.</p>'),
unistr('<p>\8ACB\5F9E\7DB2\969B\7DB2\8DEF\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5C0B\627E\8207\60A8\60F3\4F7F\7528\4E4B\8272\5F69\540C\7B49\7684\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109708413859313928)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109707959880313928)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\5143\4EF6\7684\5B57\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109795054470313995)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109794813242313995)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109794928430313995)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109707838360313928)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109708329732313928)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\5143\4EF6\7684\5B57\578B\5927\5C0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109708281683313928)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109708177146313928)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\5143\4EF6\7684\5B57\578B\7C97\7D30.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109795259130313995)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C97\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109795135130313995)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109708081400313928)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\578B\7C97\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109708927626313928)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6587\4EF6\4E4B\6A19\982D\6BB5\843D\4E2D\6240\8981\986F\793A\7684\6587\5B57. \82E5\8981\986F\793A\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE\7684\503C, \8ACB\4F7F\7528 <code>&amp;ITEM_NAME.</code> \8A9E\6CD5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109708829119313928)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A19\982D\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109706521672313927)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5831\8868\9801\9762\5927\5C0F. \82E5\8981\81EA\884C\8F38\5165\9801\9762\5BEC\5EA6\548C\9AD8\5EA6, \8ACB\9078\53D6<strong>\81EA\8A02</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109793900841313994)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'zh-tw'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109793823147313994)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'zh-tw'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109794037919313994)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109793664124313994)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109793539247313994)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109793703452313994)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109706401721313927)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5927\5C0F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109706939863313927)
,p_name=>'PE.PROPERTY.PRINT_UNITS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\6307\5B9A\9801\9762\5BEC\5EA6\548C\9AD8\5EA6\7684\55AE\4F4D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109794598221313994)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.CENTIMETERS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109794389931313994)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.INCHES.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82F1\540B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109794463143313994)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.MILLIMETERS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\91D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109794679573313994)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.POINTS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9EDE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109706899724313927)
,p_name=>'PE.PROPERTY.PRINT_UNITS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\55AE\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109706384304313927)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5217\5370\6587\4EF6\7684\5167\5BB9\914D\7F6E. \5167\5BB9\914D\7F6E\662F MIME \5354\5B9A\7684\64F4\5145, \6307\793A\700F\89BD\5668\5982\4F55\986F\793A\6587\4EF6. \5982\679C\9078\53D6<strong>\9644\4EF6</strong>, \700F\89BD\5668\6703\5C07\6A94\6848\5132\5B58\5728\78C1\789F, \800C\4E0D\662F\4EE5\5167\5D4C\65B9\5F0F\986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109793383397313993)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.ATTACHMENT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109793412517313993)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.INLINE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5D4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109706283998313926)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\6A94\6848\7684\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109707182381313927)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\9801\9762\7684\5BEC\5EA6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109707094279313927)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109066729208313420)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\9801\9762\9805\76EE\7684\8868\55AE\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109066677608313420)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109584025171313817)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7576\8655\7406\4F5C\696D\7121\6CD5\9806\5229\5B8C\6210\6642, \6B64\8655\7406\4F5C\696D\932F\8AA4\8A0A\606F\7684\986F\793A\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109773997412313979)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5D4C\65BC\901A\77E5\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109774092340313979)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4F5C\696D\932F\8AA4\8A0A\606F\986F\793A\5728\300C\901A\77E5\300D\5340\57DF\4E2D (\5B9A\7FA9\65BC\9801\9762\6A23\677F\4E2D)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109774108114313979)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767C\751F\932F\8AA4\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109774291662313979)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4F5C\696D\932F\8AA4\8A0A\606F\986F\793A\5728\932F\8AA4\9801\9762\4E0A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109583932644313817)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109247943669313556)
,p_name=>'PE.PROPERTY.PROCESS_POINT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\9801\9762\5448\73FE\6216\8655\7406\671F\9593, \6B64\8655\7406\4F5C\696D\7684\57F7\884C\9EDE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109759585534313968)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5340\57DF\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110051439885314179)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE: \5728\5340\57DF\5448\73FE\4E4B\5F8C\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109759719756313968)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\5C3E\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110051636697314180)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE: \5728\9801\9762\5448\73FE\4E4B\5F8C\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109759362870313968)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110051290303314179)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE: \5728\6A19\982D\5448\73FE\4E4B\5F8C\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109759948376313968)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5728\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110051894187314180)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406: \5728\57F7\884C\9A57\8B49\548C\904B\7B97\4E4B\5F8C, \57F7\884C\9801\9762\8655\7406\6642\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109759415357313968)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5340\57DF\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110051311934314179)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE: \5728\5340\57DF\5448\73FE\4E4B\524D\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109759625422313968)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\5C3E\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110051598448314180)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE: \5728\8868\5C3E\5448\73FE\4E4B\524D\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109759277161313968)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110051102657314179)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE: \5728\9801\9762\5448\73FE\4E4B\524D\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109760012714313968)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Ajax \56DE\547C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110051957658314180)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7531 apex.server JavaScipt API \547C\53EB\6642\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109759165596313968)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\968E\6BB5\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110051010191314179)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\65B0\7684\968E\6BB5\4F5C\696D\7522\751F\5F8C\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109759821375313968)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110051700791314180)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406: \5728\9801\9762\9001\51FA\5F8C, \4F46\57F7\884C\904B\7B97\3001\9A57\8B49\53CA\9801\9762\8655\7406\4E4B\524D\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109247802016313556)
,p_name=>'PE.PROPERTY.PROCESS_POINT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\9EDE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109584218049313817)
,p_name=>'PE.PROPERTY.PROCESS_REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\8207\6B64\8655\7406\4F5C\696D\76F8\95DC\806F\7684\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109584164880313817)
,p_name=>'PE.PROPERTY.PROCESS_REGION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\7DE8\8F2F\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109462597574313723)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\7528\4F86\9650\5236\8AB0\80FD\5920\5132\5B58\516C\7528\5831\8868\5B9A\7FA9\7684\6388\6B0A\914D\7F6E.'),
unistr('		\82E5\8981\8B93\4E00\822C\4F7F\7528\8005\5132\5B58\516C\7528\5831\8868, \8A72\4F7F\7528\8005\7684\9019\500B\6388\6B0A\914D\7F6E\5FC5\9808\8A55\4F30\70BA TRUE.</p>'),
unistr('		<p>\6CE8\610F - \5982\679C\672A\63D0\4F9B\4EFB\4F55\6388\6B0A\914D\7F6E, \5247\4EFB\4F55\4F7F\7528\8005\5747\53EF\5132\5B58\516C\7528\5831\8868.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109462448341313723)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\516C\7528\5831\8868\6388\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109832728990314023)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('$$$ DJP \76EE\524D\70BA\96B1\85CF\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109623467351313850)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\8CC7\6599\6B04\67E5\8A62 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109255086515313561)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7B2C\4E00\500B<strong>\5FEB\901F\9078\64C7</strong>\7684\6A19\7C64. \6B64\6A19\7C64\662F\61C9\7528\7A0B\5F0F\4E00\822C\4F7F\7528\8005\6240\898B\5230\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109254940861313561)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109255477313313561)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7B2C\4E8C\500B<strong>\5FEB\901F\9078\64C7</strong>\7684\6A19\7C64. \6B64\6A19\7C64\662F\61C9\7528\7A0B\5F0F\4E00\822C\4F7F\7528\8005\6240\898B\5230\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109255364773313561)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109255821832313562)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7B2C\4E09\500B<strong>\5FEB\901F\9078\64C7</strong>\7684\6A19\7C64. \6B64\6A19\7C64\662F\61C9\7528\7A0B\5F0F\4E00\822C\4F7F\7528\8005\6240\898B\5230\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109255742401313562)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109256268866313562)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7B2C\56DB\500B<strong>\5FEB\901F\9078\64C7</strong>\7684\6A19\7C64. \6B64\6A19\7C64\662F\61C9\7528\7A0B\5F0F\4E00\822C\4F7F\7528\8005\6240\898B\5230\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109256126924313562)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109256681462313562)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7B2C\4E94\500B<strong>\5FEB\901F\9078\64C7</strong>\7684\6A19\7C64. \6B64\6A19\7C64\662F\61C9\7528\7A0B\5F0F\4E00\822C\4F7F\7528\8005\6240\898B\5230\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109256515309313562)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109257088371313563)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7B2C\516D\500B<strong>\5FEB\901F\9078\64C7</strong>\7684\6A19\7C64. \6B64\6A19\7C64\662F\61C9\7528\7A0B\5F0F\4E00\822C\4F7F\7528\8005\6240\898B\5230\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109256968713313563)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64 6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109257420428313563)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7B2C\4E03\500B<strong>\5FEB\901F\9078\64C7</strong>\7684\6A19\7C64. \6B64\6A19\7C64\662F\61C9\7528\7A0B\5F0F\4E00\822C\4F7F\7528\8005\6240\898B\5230\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109257370375313563)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64 7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109257826143313563)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7B2C\516B\500B<strong>\5FEB\901F\9078\64C7</strong>\7684\6A19\7C64. \6B64\6A19\7C64\662F\61C9\7528\7A0B\5F0F\4E00\822C\4F7F\7528\8005\6240\898B\5230\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109257799572313563)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64 8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109258212924313563)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7B2C\4E5D\500B<strong>\5FEB\901F\9078\64C7</strong>\7684\6A19\7C64. \6B64\6A19\7C64\662F\61C9\7528\7A0B\5F0F\4E00\822C\4F7F\7528\8005\6240\898B\5230\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109258122254313563)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109258690047313564)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7B2C\5341\500B<strong>\5FEB\901F\9078\64C7</strong>\7684\6A19\7C64. \6B64\6A19\7C64\662F\61C9\7528\7A0B\5F0F\4E00\822C\4F7F\7528\8005\6240\898B\5230\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109258571995313564)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109254895133313561)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\6BCF\500B<strong>\5FEB\901F\9078\64C7</strong>\9023\7D50\986F\793A\95DC\806F\7684 HTML \5C6C\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109254705146313561)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109255247478313561)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\7B2C\4E00\500B<strong>\5FEB\901F\9078\64C7</strong>\95DC\806F\7684\503C.  \7576\4F7F\7528\8005\6309\4E00\4E0B\6B64\5FEB\901F\9078\64C7\6642, \6B64\503C\5C07\53D6\4EE3\73FE\6709\9805\76EE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109255178070313561)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109255666867313562)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\7B2C\4E8C\500B<strong>\5FEB\901F\9078\64C7</strong>\95DC\806F\7684\503C. \7576\4F7F\7528\8005\6309\4E00\4E0B\6B64\5FEB\901F\9078\64C7\6642, \6B64\503C\5C07\53D6\4EE3\73FE\6709\9805\76EE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109255598549313562)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109256093238313562)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\7B2C\4E09\500B<strong>\5FEB\901F\9078\64C7</strong>\95DC\806F\7684\503C.  \7576\4F7F\7528\8005\6309\4E00\4E0B\6B64\5FEB\901F\9078\64C7\6642, \6B64\503C\5C07\53D6\4EE3\73FE\6709\9805\76EE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109255984004313562)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109256442463313562)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\7B2C\56DB\500B<strong>\5FEB\901F\9078\64C7</strong>\95DC\806F\7684\503C.  \7576\4F7F\7528\8005\6309\4E00\4E0B\6B64\5FEB\901F\9078\64C7\6642, \6B64\503C\5C07\53D6\4EE3\73FE\6709\9805\76EE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109256381692313562)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109256899781313562)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\7B2C\4E94\500B<strong>\5FEB\901F\9078\64C7</strong>\95DC\806F\7684\503C.  \7576\4F7F\7528\8005\6309\4E00\4E0B\6B64\5FEB\901F\9078\64C7\6642, \6B64\503C\5C07\53D6\4EE3\73FE\6709\9805\76EE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109256788220313562)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109257286976313563)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\7B2C\516D\500B<strong>\5FEB\901F\9078\64C7</strong>\95DC\806F\7684\503C. \7576\4F7F\7528\8005\6309\4E00\4E0B\6B64\5FEB\901F\9078\64C7\6642, \6B64\503C\5C07\53D6\4EE3\73FE\6709\9805\76EE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109257113198313563)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C 6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109257652475313563)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\7B2C\4E03\500B<strong>\5FEB\901F\9078\64C7</strong>\95DC\806F\7684\503C.  \7576\4F7F\7528\8005\6309\4E00\4E0B\6B64\5FEB\901F\9078\64C7\6642, \6B64\503C\5C07\53D6\4EE3\73FE\6709\9805\76EE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109257580114313563)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C 7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109258083400313563)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\7B2C\516B\500B<strong>\5FEB\901F\9078\64C7</strong>\95DC\806F\7684\503C.  \7576\4F7F\7528\8005\6309\4E00\4E0B\6B64\5FEB\901F\9078\64C7\6642, \6B64\503C\5C07\53D6\4EE3\73FE\6709\9805\76EE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109257907214313563)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C 8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109258476491313564)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\7B2C\4E5D\500B<strong>\5FEB\901F\9078\64C7</strong>\95DC\806F\7684\503C.  \7576\4F7F\7528\8005\6309\4E00\4E0B\6B64\5FEB\901F\9078\64C7\6642, \6B64\503C\5C07\53D6\4EE3\73FE\6709\9805\76EE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109258348818313564)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109258895484313564)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\7B2C\5341\500B<strong>\5FEB\901F\9078\64C7</strong>\95DC\806F\7684\503C.  \7576\4F7F\7528\8005\6309\4E00\4E0B\6B64\5FEB\901F\9078\64C7\6642, \6B64\503C\5C07\53D6\4EE3\73FE\6709\9805\76EE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109258727153313564)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109596961392313827)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\5713\9215\7FA4\7D44\8CC7\6599\6B04\8981\986F\793A\7684\8CC7\6599\6B04\6578\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109596845327313827)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\6578\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109328064392313621)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\300CReal Application Security \52D5\614B\89D2\8272\300D\7684\6E05\55AE (\4EE5\5192\865F\5340\9694), \4F8B\5982:'),
'<pre>',
'DB_EMP:DB_DEPT',
'</pre></p>',
unistr('<p>&PRODUCT_NAME. \6703\900F\904E <em>sys.dbms_xs_sessions.assign_user</em> \7684 <em>enable_dynamic_roles</em> \53C3\6578\50B3\9001\9019\4E9B\89D2\8272, \5728\767B\5165\6642\555F\7528\5B83\5011.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109327946317313621)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109327825031313621)
,p_name=>'PE.PROPERTY.RAS_MODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\5728\6B64\61C9\7528\7A0B\5F0F\4E2D\4F7F\7528 Oracle Real Application Security (RAS) \7684\65B9\5F0F.</p>'),
unistr('<p>\5982\679C\555F\7528\300CRAS \6A21\5F0F\300D, \8ACB\78BA\5B9A\4F7F\7528\8005\5FC5\9808\80FD\5920\5B58\53D6\61C9\7528\7A0B\5F0F\7684\7DB1\8981\7269\4EF6.'),
unistr('\4F8B\5982, \4EE5<strong>\5916\90E8\4F7F\7528\8005</strong>\70BA\4F8B, \60A8\53EF\4EE5\5C07\8CC7\6599\5EAB\6B0A\9650\6388\4E88 <em>RAS \52D5\614B\61C9\7528\7A0B\5F0F\89D2\8272</em>, \7136\5F8C\5728\6B64\8A8D\8B49\914D\7F6E\4E2D\5C07\5176\8A2D\5B9A\70BA<em>\52D5\614B\89D2\8272</em>.'),
unistr('\60A8\4E5F\53EF\4EE5\900F\904E\547C\53EB <em>apex_authorization.enable_dynamic_groups</em> \4F86\555F\7528\89D2\8272, \4F8B\5982\5728\8A8D\8B49\5F8C\7A0B\5E8F\5167.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109761145025313969)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110052013166314180)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\4E2D\672A\4F7F\7528 Real Application Security.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109761242779313969)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\90E8\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110052144464314180)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('&PRODUCT_NAME. \6703\5047\8A2D\6240\6709\4F7F\7528\8005\90FD\662F\5167\90E8\4F7F\7528\8005, \4E26\4E14\901A\904E <em>is_external</em> \53C3\6578\50B3\9001 <em>false</em> \5230 <em>sys.dbms_xs_sessions.assign_user</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109761334324313969)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\90E8\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110052201394314180)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('&PRODUCT_NAME. \6703\901A\904E <em>is_external</em> \53C3\6578\50B3\9001 <em>true</em> \5230 <em>sys.dbms_xs_sessions.assign_user</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109327722018313620)
,p_name=>'PE.PROPERTY.RAS_MODE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('RAS \6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109328257213313621)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\300CReal Application Security \547D\540D\7A7A\9593\6A23\677F\300D\7684\6E05\55AE (\4EE5\5192\865F\5340\9694), \4F8B\5982:'),
'<pre>',
'NS1:NS2',
'</pre></p>',
unistr('<p>&PRODUCT_NAME. \6703\900F\904E <em>sys.dbms_xs_sessions.assign_user</em> \7684 <em>namespaces</em> \53C3\6578\50B3\9001\9019\4E9B\547D\540D\7A7A\9593, \5728\767B\5165\6642\555F\7528\5B83\5011.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109328199745313621)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\547D\540D\7A7A\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109977043023314127)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\8A55\4F30\6240\8F38\5165\8868\793A\5F0F\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109977459041314127)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109977372745314127)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109977288481314127)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109977596184314127)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109977186090314127)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109976918431314127)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109979080056314128)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\51FD\6578\4E3B\9AD4\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109979343309314129)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109979212409314129)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109979152079314128)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109979439591314129)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109978976001314128)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109265200508313569)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5728\6B64\689D\4EF6\4F7F\7528\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\5F9E\53EF\7528\9805\76EE\7684\6E05\55AE\4E2D\6311\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109265191056313569)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109266615686313570)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5728\6B64\689D\4EF6\4F7F\7528\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\5F9E\53EF\7528\9805\76EE\7684\6E05\55AE\4E2D\6311\9078.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109266560324313570)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109978623746314128)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CJava \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109978569225314128)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109980239597314129)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\689D\4EF6\5E03\6797\503C\7684 Java \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109980196064314129)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109978448720314128)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109978339492314128)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CJavaScript \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109978270343314128)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109980054402314129)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109979975793314129)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\689D\4EF6\5E03\6797\503C\7684 JavaScript \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109979850581314129)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109265470333313569)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\503C\6E05\55AE (\4F7F\7528\5192\865F (:) \5340\9694).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109265300805313569)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109265800444313569)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300C\9801\78BC\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109265753080313569)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109266002758313569)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300C\9801\78BC\300D\6E05\55AE (\4F7F\7528\9017\865F\5340\9694).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109265943567313569)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109978174983314128)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109978011914314128)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CPL/SQL \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109977959885314128)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109979754027314129)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109979662499314129)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\689D\4EF6\5E03\6797\503C\7684 PL/SQL \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109979573849314129)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109265681735313569)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\6B64\689D\4EF6\6307\5B9A\503C\9032\884C\6BD4\8F03\7684\300C\4F7F\7528\8005\504F\597D\8A2D\5B9A\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109265599520313569)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109978805800314128)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CPython \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109978782071314128)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109980446138314129)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\6B64\689D\4EF6\5E03\6797\503C\7684 Python \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109980303008314129)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109977821550314128)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\70BA\4E3B\7BA1\4E14\5176\90E8\9580\4F4D\65BC\829D\52A0\54E5\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109977714212314127)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\300CSQL \8868\793A\5F0F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109977615597314127)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110127330349314254)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\6AA2\67E5\54E1\5DE5\662F\5426\7DE8\5236\5728\90E8\9580 30, \5982\6709\4E00\6216\591A\500B\8CC7\6599\5217\5B58\5728\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\6AA2\67E5\54E1\5DE5\662F\5426\7DE8\5236\5728\90E8\9580 40, \5982\7121\4EFB\4F55\8CC7\6599\5217\5B58\5728\5247\9806\5229\50B3\56DE:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109264816047313568)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684 SQL \67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109264798936313568)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109266230686313570)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\6587\5B57\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109266178156313569)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109266857939313570)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\503C (\5305\542B <code>&ITEM.</code> \66FF\4EE3\5B57\4E32).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109266787859313570)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109475729547313733)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\4E00\500B\5FC5\9808\7B26\5408\7684\689D\4EF6\985E\578B, \4EE5\4FBF\8B93\6B64\5143\4EF6\4EE5\552F\8B80\65B9\5F0F\5448\73FE.'),
unistr('\82E5\672A\9078\53D6\4EFB\4F55\689D\4EF6, \5C07\4EE5\6B63\5E38\65B9\5F0F\5448\73FE\9805\76EE.'),
unistr('\552F\8B80\9805\76EE\5C07\4F7F\7528\8207\300C\50C5\986F\793A\300D\9805\76EE\76F8\540C\7684\8A2D\5B9A\503C\4F86\5448\73FE.</p>'),
unistr('<p>\6CE8\610F: \5C07\689D\4EF6\985E\578B\8A2D\5B9A\70BA<strong>\4E00\5F8B\4E0D\6210\7ACB</strong>, \6703\4E00\5F8B\5C07\9805\76EE\5448\73FE\70BA\53EF\8F38\5165\7684\6B04\4F4D.'),
unistr('\6B64\8A2D\5B9A\5C07\6703\8986\5BEB\5340\57DF\6216\9801\9762\5C64\6B21\4E0A\7684\4EFB\4F55\552F\8B80\689D\4EF6\8A2D\5B9A.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108879765564313271)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\4E00\500B\5FC5\9808\7B26\5408\7684\689D\4EF6\985E\578B, \4EE5\4FBF\8B93\6B64\5143\4EF6\4EE5\552F\8B80\65B9\5F0F\5448\73FE.'),
unistr('\82E5\672A\9078\53D6\4EFB\4F55\689D\4EF6, \5C07\4EE5\6B63\5E38\65B9\5F0F\5448\73FE\9805\76EE.'),
unistr('\552F\8B80\9805\76EE\5C07\4F7F\7528\8207\300C\50C5\986F\793A\300D\9805\76EE\76F8\540C\7684\8A2D\5B9A\503C\4F86\5448\73FE.</p>'),
unistr('<p>\6CE8\610F: \5C07\689D\4EF6\985E\578B\8A2D\5B9A\70BA<strong>\4E00\5F8B\4E0D\6210\7ACB</strong>, \6703\4E00\5F8B\5C07\9805\76EE\5448\73FE\70BA\53EF\8F38\5165\7684\6B04\4F4D.'),
unistr('\6B64\8A2D\5B9A\5C07\6703\8986\5BEB\5340\57DF\6216\9801\9762\5C64\6B21\4E0A\7684\4EFB\4F55\552F\8B80\689D\4EF6\8A2D\5B9A.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109330653972313623)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\8B93\6B64\5340\57DF\5C07\9801\9762\9805\76EE\5448\73FE\70BA\552F\8B80\6240\5FC5\9808\7B26\5408\7684\689D\4EF6\985E\578B.'),
unistr('\82E5\672A\9078\53D6\689D\4EF6, \5C31\6703\4EE5\6B63\5E38\65B9\5F0F\5448\73FE\9801\9762\9805\76EE.</p>'),
unistr('<p>\6CE8\610F: \82E5\60F3\8981\8B93\6B64\5340\57DF\4E2D\7684\9801\9762\9805\76EE (\4F8B\5982\641C\5C0B\6B04\4F4D) \4E0D\8AD6\6B64\689D\4EF6\7684\8A55\4F30\7D50\679C\70BA\4F55, \4E00\5F8B\5448\73FE\70BA\53EF\8F38\5165\7684\9801\9762\9805\76EE, \8ACB\5C07\8A72\9801\9762\9805\76EE\7684\552F\8B80\689D\4EF6\8A2D\70BA\300C\4E00\5F8B\4E0D\6210\7ACB\300D\4EE5\8986\5BEB\5340\57DF\8A2D\5B9A\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109250520244313558)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\4E00\500B\5FC5\9808\7B26\5408\7684\689D\4EF6\985E\578B, \4EE5\4FBF\8B93\6B64\9801\9762\4EE5\552F\8B80\65B9\5F0F\5448\73FE\9801\9762\9805\76EE. \82E5\672A\9078\53D6\4EFB\4F55\689D\4EF6, \5C07\4EE5\6B63\5E38\65B9\5F0F\5448\73FE\9801\9762\9805\76EE.'),
unistr('\7CFB\7D71\6703\5728\57F7\884C\8655\7406\9EDE\70BA<em>\6A19\982D\4E4B\524D</em>\7684\8655\7406\4F5C\696D\4E4B\5F8C\8A55\4F30\6B64\552F\8B80\689D\4EF6.</p>'),
unistr('<p>\6CE8\610F: \82E5\60F3\8981\8B93\7279\5B9A\5340\57DF\7684\67D0\4E9B\9801\9762\9805\76EE (\4F8B\5982\641C\5C0B\6B04\4F4D) \6216\6240\6709\9801\9762\9805\76EE\4E00\5F8B\5448\73FE\70BA\53EF\8F38\5165\7684\9801\9762\9805\76EE, \4E26\5FFD\7565\6B64\689D\4EF6\7684\8A55\4F30\65B9\5F0F, \8ACB\5C07\9019\4E9B\5340\57DF/\9801\9762\9805\76EE\7684\552F\8B80\689D\4EF6\8A2D\70BA<strong>\4E00\5F8B\4E0D\6210\7ACB</strong>, \4EE5\8986\5BEB\7236\9805\8A2D\5B9A.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109819425681314013)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\6210\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109958961212314114)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6\5C07\4E00\5F8B\5448\73FE\70BA\552F\8B80.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109818006482314012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF\700F\89BD\5668\70BA Microsoft Internet Explorer 7.0 \6216\66F4\65B0\7684\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109818179790314012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF\700F\89BD\5668\70BA XHTML / CSS \529F\80FD\700F\89BD\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109817993750314012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF\700F\89BD\5668\70BA Mozilla\3001Netscape 6.x/7x \6216\66F4\65B0\7684\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109818237929314012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\7AEF\700F\89BD\5668\70BA\5176\4ED6\700F\89BD\5668 (\6216\66F4\820A\7684\7248\672C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109816660883314011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\5305\542B\5728\9805\76EE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109818611522314012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8A9E\8A00 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109962559201314116)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\76EE\524D\4F7F\7528\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\8A9E\8A00\57F7\884C\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109818314306314012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8A9E\8A00\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109962704496314117)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\76EE\524D\4F7F\7528\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\5176\4E2D\4E00\7A2E\8A9E\8A00\57F7\884C\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109818587047314012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8A9E\8A00 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109962670484314116)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\76EE\524D\672A\4F7F\7528\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\8A9E\8A00\57F7\884C\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109818435501314012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\8A9E\8A00\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109962804842314117)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\76EE\524D\4E0D\662F\4F7F\7528\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\5176\4E2D\4E00\7A2E\8A9E\8A00\57F7\884C\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109815855974314010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762 = \9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109961350295314115)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\7B49\65BC\60A8\5728<em>\9801\9762</em>\4E2D\8F38\5165\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109816043200314010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\5728\9017\865F\5340\9694\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109961575379314116)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\5728\60A8\65BC<em>\9801\9762</em>\4E2D\8F38\5165\7684\6E05\55AE (\4EE5\9017\865F\5340\9694) \4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109815905995314010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762 != \9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109961452975314116)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\4E0D\7B49\65BC\60A8\5728<em>\9801\9762</em>\4E2D\8F38\5165\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109816145575314010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\4E0D\5728\9017\865F\5340\9694\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109961632132314116)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\4E0D\5728\60A8\65BC<em>\9801\9762</em>\4E2D\8F38\5165\7684\6E05\55AE (\4EE5\9017\865F\5340\9694) \4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109818703432314012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: DAD_NAME = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109818839858314012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: DAD_NAME != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109817508606314011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5167\5D4C\9A57\8B49\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109962307240314116)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\986F\793A\5167\5D4C\9A57\8B49\932F\8AA4, \63A5\8457\9001\51FA\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109816920388314011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109816783319314011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109816823415314011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109817077393314011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109813532734314008)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109959034952314114)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62\50B3\56DE\4E00\6216\591A\500B\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109976732288314127)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109976890759314127)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F\8A55\4F30\70BA TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109813764800314009)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109959298355314114)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\4E3B\9AD4\50B3\56DE TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109819183604314013)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109819291140314013)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109817247870314011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762/\5340\57DF\975E\552F\8B80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109962055722314116)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\9069\7528, \9801\9762\548C\7236\9805\5340\57DF\6703\6B63\5E38\986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109817130416314011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762/\5340\57DF\70BA\552F\8B80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109961938063314116)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\9069\7528, \9801\9762\6216\7236\9805\5340\57DF\7684\300C\552F\8B80\300D\689D\4EF6\6703\8A55\4F30\70BA TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109815060095314010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\5305\542B\7A7A\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109960590353314115)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\6C92\6709\7A7A\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109815339090314010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\70BA\6587\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109960805549314115)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\70BA\6587\6578\5B57, \50C5\5305\542B\5B57\6BCD\8207\6578\5B57\4E14\6C92\6709\7279\6B8A\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109814583485314009)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109960080424314115)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\975E\7A7A\767D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109815247761314010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\70BA\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109960736848314115)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\4E0D\662F\6578\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109814732050314009)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\70BA\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109960288571314115)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\4E0D\662F\6578\5B57\96F6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109814417884314009)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109959965939314114)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\70BA\7A7A\767D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109814802006314009)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\662F\7A7A\503C\6216\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109960380380314115)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\70BA\7A7A\767D\6216\6578\5B57\96F6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109815110855314010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\70BA\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109960697043314115)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\662F\6578\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109814683163314009)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\70BA\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109960136563314115)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\662F\6578\5B57\96F6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109814981880314009)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\662F\7A7A\503C\4E5F\4E0D\70BA\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109960497288314115)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\975E\7A7A\767D\4E5F\4E0D\662F\6578\5B57\96F6.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109817796158314012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \5831\8868 (\78BA\5B9A\53EF\4EE5\986F\793A\4E0B\4E00\9801\6309\9215)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109817854634314012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \5831\8868 (\78BA\5B9A\53EF\986F\793A\4E0A\4E00\9801\6309\9215)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109819397798314013)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\4E0D\6210\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109962979084314117)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6B63\5E38\5448\73FE\5143\4EF6, \5373\4F7F\7236\9805\5143\4EF6\689D\4EF6\70BA\552F\8B80.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109817615924314011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\986F\793A\5167\5D4C\9A57\8B49\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109962419913314116)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\672A\986F\793A\5167\5D4C\9A57\8B49\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109813601496314009)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\50B3\56DE\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109959186910314114)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62\672A\50B3\56DE\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109816497333314011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\662F\300C\9069\7528\65BC\5370\8868\6A5F\300D\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109961719651314116)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\5DF2\5C07\76EE\524D\7684\9801\9762\5207\63DB\70BA\300C\9069\7528\65BC\5370\8868\6A5F\300D\6A21\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109816520766314011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762\4E0D\662F\300C\9069\7528\65BC\5370\8868\6A5F\300D\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109961870090314116)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\5C1A\672A\5C07\76EE\524D\7684\9801\9762\5207\63DB\70BA\300C\9069\7528\65BC\5370\8868\6A5F\300D\6A21\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109813880645314009)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109959347718314114)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8981\6C42\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109814006527314009)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109959563975314114)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8981\6C42\5305\542B\5728\60A8\65BC<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109813937066314009)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109959475779314114)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8981\6C42\4E0D\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109814172324314009)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109959645560314114)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8981\6C42\4E0D\5305\542B\5728\60A8\65BC<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109818968483314012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109819096157314012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109817395432314011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\5DF2\8A8D\8B49 (\4E0D\662F\516C\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109962178865314116)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\5DF2\767B\5165\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109817483347314011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\662F\516C\7528\4F7F\7528\8005 (\4F7F\7528\8005\672A\8A8D\8B49)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109962275981314116)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\4F7F\7528\8005\672A\767B\5165\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109815604400314010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\504F\597D\8A2D\5B9A = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109961190617314115)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7684<em>\504F\597D\8A2D\5B9A</em>\503C\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109815717477314010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\504F\597D\8A2D\5B9A != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109961218808314115)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7684<em>\504F\597D\8A2D\5B9A</em>\503C\4E0D\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109815433760314010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\5728\5192\865F\5340\9694\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109960905517314115)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\5B8C\5168\5305\542B\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109815524315314010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\5728\5192\865F\5340\9694\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109961079571314115)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\4E0D\5B8C\5168\5305\542B\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109814258008314009)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109959777030314114)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109814316288314009)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109959815317314114)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6<em>\9805\76EE</em>\7684\503C\4E0D\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109816320983314010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762 != \5DF2\9001\51FA\7684\9801\9762 (\5DF2\516C\5E03)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109816222458314010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\9801\9762 = \5DF2\9001\51FA\7684\9801\9762 (\5DF2\516C\5E03)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109250463922313558)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109265044118313569)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8207\689D\4EF6\505A\6BD4\8F03\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109264910342313569)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109266476866313570)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\689D\4EF6\7684\503C (\5305\542B <code>&ITEM.</code> \66FF\4EE3\5B57\4E32).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109266390493313570)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109756693234313966)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>'<pre>bgcolor="#FF0000"</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109259093116313564)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5728\552F\8B80\6A21\5F0F\4E0B\986F\793A\6642, \5305\542B\5728\9805\76EE HTML \8868\683C\5132\5B58\683C\6A19\8A18 <code>&lt;td&gt;</code> \7684\5C6C\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109258965834313564)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\552F\8B80 HTML \5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109543617179313783)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5716\8868\66F4\65B0\7684\9593\9694\79D2\6578. \4E0D\5EFA\8B70\4F7F\7528\5F88\77ED\7684\66F4\65B0\9593\9694 (\4F8B\5982 2 \79D2), \56E0\70BA\9019\53EF\80FD\6703\9020\6210\56B4\91CD\7684\8CC7\6599\5EAB\6548\80FD\554F\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109543540562313783)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9593\9694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109543765351313783)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.UNIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109271320633313573)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5C07\986F\793A\6B64\6309\9215\7684\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109288637856313591)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\7236\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108879629397313271)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5C07\986F\793A\6B64\9805\76EE\7684\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109288540668313591)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\7236\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109264294988313568)
,p_name=>'PE.PROPERTY.REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8207\6B64\5143\4EF6\95DC\806F\7684\5340\57DF. \986F\793A\6B64\5143\4EF6\6642, \5B83\6703\986F\793A\5728\6307\5B9A\7684\5340\57DF\5167, \4E26\986F\793A\65BC\8207\6B64\5340\57DF\5167\7684\5176\4ED6\5143\4EF6\76F8\5C0D\7684\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109264138368313568)
,p_name=>'PE.PROPERTY.REGION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109329482548313622)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\60F3\8981\5C07\6B64\5340\57DF\5305\62EC\5728\300C\5340\57DF\986F\793A\9078\53D6\5668\300D\4E2D, \8ACB\6307\5B9A<strong>\958B\555F</strong>.'),
unistr('\53EA\6709\7576\9801\9762\4E0A\5DF2\5B9A\7FA9<em>\5340\57DF\986F\793A\9078\53D6\5668</em>\5340\57DF\985E\578B\4E26\4E14\53EF\4F9B\6AA2\8996\6642, \624D\53EF\4F7F\7528\5C6C\6027.</p>'),
unistr('<p>\7576\4F7F\7528\8005\6309\4E00\4E0B\300C\5340\57DF\986F\793A\9078\53D6\5668\300D\4E2D\6240\5305\62EC\7684\5340\57DF\540D\7A31\6642, \5C07\53EA\6703\986F\793A\9078\53D6\7684\5340\57DF, \6240\6709\5176\4ED6\5217\51FA\7684\5340\57DF\5247\6703\96B1\85CF.'),
unistr('\300C\5340\57DF\986F\793A\9078\53D6\5668\300D\5167\7684\7B2C\4E00\500B\9805\76EE\662F<em>\5168\90E8\986F\793A</em>, \53EF\8B93\4F7F\7528\8005\986F\793A\6240\6709\53EF\7528\7684\5340\57DF\800C\4E0D\50C5\50C5\662F\5148\524D\9078\53D6\7684\5340\57DF.</p>'),
unistr('<p>\5982\679C\6839\64DA\5340\57DF\689D\4EF6\7121\6CD5\986F\793A\67D0\500B\5340\57DF,\300C\5340\57DF\986F\793A\9078\53D6\5668\300D\5167\7684\5340\57DF\6E05\55AE\4E2D\5C31\4E0D\6703\5305\62EC\8A72\5340\57DF.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109329312816313622)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\986F\793A\9078\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109330278600313622)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578, \4EE5\4F5C\70BA\6B64\5340\57DF\7684\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109330148523313622)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109328401955313621)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\9078\53D6\7684<em>\5340\57DF\985E\578B</em>, \8F38\5165\5340\57DF\4F86\6E90\6216\5167\5BB9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109328365668313621)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109329684451313622)
,p_name=>'PE.PROPERTY.REGION_IMAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\986F\793A\5728\5340\57DF\7684\5DE6\4E0A\65B9\4E4B\5F71\50CF\7684\53C3\7167. \7121\6CD5\63A7\5236\7528\4F86\986F\793A\6B64\5F71\50CF\7684\8868\683C\6A19\8A18.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109329501284313622)
,p_name=>'PE.PROPERTY.REGION_IMAGE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109623653090313850)
,p_name=>'PE.PROPERTY.REGION_PLAIN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\5143\4EF6\7684\6587\5B57\4F86\6E90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109623564407313850)
,p_name=>'PE.PROPERTY.REGION_PLAIN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109324749262313618)
,p_name=>'PE.PROPERTY.REGION_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\5143\4EF6\7684 SQL \4F86\6E90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109324619903313618)
,p_name=>'PE.PROPERTY.REGION_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109329048690313621)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\4E00\500B\7528\4F86\5B9A\7FA9\6B64\5340\57DF\4E4B\5916\89C0\548C\7248\9762\914D\7F6E\7684\5340\57DF\6A23\677F.</p>'),
unistr('        <p>\5340\57DF\6A23\677F\5B9A\7FA9\65BC\61C9\7528\7A0B\5F0F\4E3B\984C\4E2D.'),
unistr('        \5EFA\7ACB\5340\57DF\4E4B\5F8C, \4FBF\6703\81EA\52D5\5C07\6B64\6A23\677F\8A2D\70BA\76EE\524D\4E3B\984C\4E2D\5B9A\7FA9\7684\9810\8A2D\5340\57DF\6A23\677F.</p>'),
unistr('        <p>\8A31\591A\4E3B\984C\90FD\5305\542B\53EF\7528\65BC\986F\793A\5831\8868\3001\8868\55AE\3001\8B66\793A\3001\6309\9215\3001\53EF\96B1\85CF (\96B1\85CF/\986F\793A) \5167\5BB9\3001\767B\5165\8868\55AE\7B49\7684\5340\57DF\6A23\677F.<br>'),
unistr('        \300C\901A\7528\4E3B\984C\300D\63D0\4F9B\4E0B\5217\5340\57DF\6A23\677F:'),
'          <dl>',
unistr('            <dt>\8B66\793A</dt>'),
unistr('            <dt>\7A7A\767D\4F46\542B\6709\5C6C\6027</dt>'),
unistr('            <dt>\6309\9215\5BB9\5668</dt>'),
unistr('            <dt>\65CB\8F49\6728\99AC\5BB9\5668</dt>'),
unistr('            <dt>\53EF\96B1\85CF</dt>'),
unistr('            <dt>\5167\5BB9\5340\584A</dt>'),
unistr('            <dt>\82F1\96C4</dt>'),
unistr('            <dt>\5167\5D4C\5C0D\8A71\65B9\584A</dt>'),
unistr('            <dt>\5167\5D4C\5373\73FE\5F0F\8996\7A97</dt>'),
unistr('            <dt>\4E92\52D5\5F0F\5831\8868</dt>'),
unistr('            <dt>\767B\5165</dt>'),
unistr('            <dt>\6A19\6E96</dt>'),
unistr('            <dt>\9801\7C64\5BB9\5668</dt>'),
unistr('            <dt>\6A19\984C\5217</dt>'),
unistr('            <dt>\7CBE\9748\5BB9\5668</dt>'),
'          </dl>',
unistr('          \53E6\8ACB\53C3\95B1: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109328904016313621)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109440624942313706)
,p_name=>'PE.PROPERTY.REGION_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6B64\5340\57DF\7684\5448\73FE\65B9\5F0F. \4EE5\4E0B\662F\652F\63F4\7684\5340\57DF\985E\578B:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\8996\60A8\7684\61C9\7528\7A0B\5F0F\7D44\614B\800C\5B9A, \6B64\8655\53EF\80FD\6703\63D0\4F9B\60A8\5176\4ED6\5340\57DF\985E\578B Plug-in.'),
unistr('\9019\4E9B\6703\986F\793A\70BA <em>&lt;My Plug-in&gt; [Plug-in]</em>.'),
unistr('\4E0B\5217 Plug-in \6703\5B89\88DD\5728\6B64\61C9\7528\7A0B\5F0F\7684\5171\7528\5143\4EF6\5167:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109263554213313568)
,p_name=>'PE.PROPERTY.REGION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109702658843313924)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\8981\70BA\9019\500B\9A57\8B49\6E2C\8A66\7684\76F8\7B49\985E\578B. \4F9D\64DA\60A8\7684\9078\64C7\9805\76EE\800C\5B9A, \53EF\80FD\9700\8981\4E00\6216\591A\500B\5176\4ED6\5C6C\6027, \624D\80FD\5B8C\6574\5B9A\7FA9\9019\500B\9A57\8B49.</p>'),
unistr('<p>\5982\679C\9A57\8B49\901A\904E\76F8\7B49\6E2C\8A66, \6216\8A55\4F30\70BA TRUE, \5C07\4E0D\6703\986F\793A\9A57\8B49\932F\8AA4\8A0A\606F.'),
unistr('\5982\679C\9A57\8B49\672A\901A\904E\76F8\7B49\6E2C\8A66\3001\8A55\4F30\70BA FALSE \6216\50B3\56DE\975E\7A7A\767D\7684\6587\5B57\5B57\4E32, \5C31\6703\986F\793A\9A57\8B49\932F\8AA4\8A0A\606F.</p>'),
unistr('<p>\9A57\8B49\5931\6557\4E26\4E0D\6703\5C0E\81F4\505C\6B62\5F8C\7E8C\7684\9A57\8B49\8A55\4F30, \56E0\6B64\6BCF\500B\5F8C\7E8C\7684\9A57\8B49\53EF\80FD\6703\5F15\767C\5176\4ED6\7684\9A57\8B49\932F\8AA4\8A0A\606F. \5982\679C\60A8\60F3\8981\505C\6B62\57F7\884C\5F8C\7E8C\7684\9A57\8B49, \5C31\5FC5\9808\5C07\5176\4ED6\908F\8F2F\52A0\5230\7B2C\4E00\500B\5931\6557\7684\9A57\8B49\4E2D (\4F8B\5982\5C07\67D0\500B\9801\9762\9805\76EE\8A2D\6210\7279\5B9A\503C), \7136\5F8C\8996\9700\8981\5728\5F8C\7E8C\7684\9A57\8B49\4E0A\589E\5F37\689D\4EF6\6027\908F\8F2F. \5982\679C\4E00\6216\591A\500B\9A57\8B49\672A\901A\904E\8A55\4F30, \5C07\4E0D\6703\57F7\884C\5F8C\7E8C\7684\8655\7406\4F5C\696D\548C\5206\652F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109803317024314001)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109803489554314001)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C SQL \67E5\8A62\50B3\56DE\4E00\500B\6216\591A\500B\8CC7\6599\5217, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C SQL \67E5\8A62\672A\50B3\56DE\8CC7\6599\5217, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110010758530314151)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110010868064314151)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8868\793A\5F0F\8A55\4F30\70BA TRUE, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\8868\793A\5F0F\8A55\4F30\70BA FALSE, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109803944373314001)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\4E3B\9AD4 (\50B3\56DE\5E03\6797\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109804090013314001)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\51FD\6578\4E3B\9AD4\50B3\56DE TRUE, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\51FD\6578\4E3B\9AD4\50B3\56DE FALSE, \5247\5931\6557.<br>'),
unistr('\6CE8\610F: \51FD\6578\50B3\56DE\7684\7D50\679C\5FC5\9808\662F\5E03\6797\503C.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109804164492314001)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\4E3B\9AD4 (\50B3\56DE\932F\8AA4\6587\5B57)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109804239599314002)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\51FD\6578\4E3B\9AD4\50B3\56DE\7A7A\767D\5B57\4E32, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\51FD\6578\4E3B\9AD4\50B3\56DE\975E\7A7A\767D\5B57\4E32, \5247\5931\6557. \50B3\56DE\7684\5B57\4E32\6703\986F\793A\9A57\8B49\7684\932F\8AA4\8A0A\606F.<br>'),
unistr('\6CE8\610F: \51FD\6578\50B3\56DE\7684\7D50\679C\5FC5\9808\662F\6587\5B57\5B57\4E32.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109804999921314002)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\4E0D\5305\542B\7A7A\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109805055049314002)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8CC7\6599\6B04\503C\6C92\6709\7A7A\683C, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\8CC7\6599\6B04\503C\5305\542B\7A7A\683C, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109806940104314004)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\81F3\5C11\5305\542B\503C\4E2D\7684\4E00\500B\5B57\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109807091284314004)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8CC7\6599\6B04\503C\81F3\5C11\5305\542B\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\6587\5B57\7684\4E00\500B\5B57\5143, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\8CC7\6599\6B04\503C\4E0D\5305\542B\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\6587\5B57\7684\4EFB\4F55\5B57\5143, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109807119856314004)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\4E0D\5305\542B\503C\4E2D\7684\4EFB\4F55\5B57\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109807201245314004)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8CC7\6599\6B04\503C\4E0D\5305\542B\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\6587\5B57\7684\4EFB\4F55\5B57\5143, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\8CC7\6599\6B04\503C\81F3\5C11\5305\542B\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\6587\5B57\7684\4E00\500B\5B57\5143, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109806722895314003)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\50C5\5305\542B\5728\503C\4E2D\6307\5B9A\7684\5B57\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109806889586314003)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8CC7\6599\6B04\503C\50C5\5305\542B\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\6587\5B57\7684\5B57\5143, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\8CC7\6599\6B04\503C\5305\542B\4E0D\662F\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\6587\5B57\7684\4EFB\4F55\5B57\5143, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109805980169314003)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109806072262314003)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8CC7\6599\6B04\503C\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\8CC7\6599\6B04\503C\4E0D\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109806365088314003)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109806407746314003)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8CC7\6599\6B04\503C\5B8C\5168\5305\542B\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\8CC7\6599\6B04\503C\4E0D\5B8C\5168\5305\542B\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57, \5247\5931\6557.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109806199415314003)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109806281461314003)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8CC7\6599\6B04\503C\4E0D\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\8CC7\6599\6B04\503C\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109806522174314003)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109806628472314003)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8CC7\6599\6B04\503C\4E0D\5B8C\5168\5305\542B\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\8CC7\6599\6B04\503C\5B8C\5168\5305\542B\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109805195091314002)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\70BA\6587\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109805217278314002)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8CC7\6599\6B04\503C\70BA\6587\6578\5B57, \4EA6\5373\50C5\5305\542B\5B57\6BCD\8207\6578\5B57\4E14\6C92\6709\7279\6B8A\5B57\5143, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\8CC7\6599\6B04\503C\5305\542B\7279\6B8A\5B57\5143, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109805502225314003)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\70BA\6709\6548\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109805650075314003)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8CC7\6599\6B04\503C\70BA\6709\6548\65E5\671F, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\8CC7\6599\6B04\503C\4E0D\662F\6709\6548\65E5\671F, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109805357056314002)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\70BA\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109805418221314002)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8CC7\6599\6B04\503C\70BA\6578\5B57, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\8CC7\6599\6B04\503C\5305\542B\975E\6578\5B57\5B57\5143 (\5305\62EC\4E0D\662F\524D\5C0E\7A7A\683C\7684\7A7A\683C), \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109805788341314003)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\70BA\6709\6548\6642\6233')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109805851565314003)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8CC7\6599\6B04\503C\70BA\6709\6548\6642\6233, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\8CC7\6599\6B04\503C\4E0D\662F\6709\6548\6642\6233, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109804303529314002)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\4E0D\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109804404063314002)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8CC7\6599\6B04\503C\975E\7A7A\767D, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\8CC7\6599\6B04\503C\70BA\7A7A\767D, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109804509551314002)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\4E0D\662F\7A7A\503C\6216\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109804669777314002)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8CC7\6599\6B04\503C\975E\7A7A\767D\4E14\4E0D\662F\6578\5B57\96F6, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\8CC7\6599\6B04\503C\70BA\7A7A\767D\6216\70BA\6578\5B57\96F6, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109804780356314002)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\4E0D\70BA\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109804888525314002)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8CC7\6599\6B04\503C\4E0D\662F\6578\5B57\96F6, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\8CC7\6599\6B04\503C\70BA\6578\5B57\96F6, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109803518625314001)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\50B3\56DE\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109803603534314001)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C SQL \67E5\8A62\672A\50B3\56DE\8CC7\6599\5217, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C SQL \67E5\8A62\50B3\56DE\4E00\500B\6216\591A\500B\8CC7\6599\5217, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109803749549314001)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109803893551314001)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C PL/SQL \7A0B\5F0F\78BC\57F7\884C\6642\672A\7522\751F\932F\8AA4, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C PL/SQL \8868\793A\5F0F\57F7\884C\6642\7522\751F\932F\8AA4, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109807339162314004)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\7B26\5408\6B63\898F\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109807456065314004)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8CC7\6599\6B04\503C\7B26\5408\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6B63\898F\8868\793A\5F0F, \5247\901A\904E\9A57\8B49.'),
unistr('\5982\679C\8CC7\6599\6B04\503C\4E0D\7B26\5408\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6B63\898F\8868\793A\5F0F, \5247\5931\6557.<br>'),
unistr('\6CE8\610F: \6B63\898F\8868\793A\5F0F\53EF\8B93\60A8\4F7F\7528\6A19\6E96\8A9E\6CD5\6163\4F8B\4F86\641C\5C0B\5B57\4E32\4E2D\7684\6A23\5F0F, \800C\4E0D\53EA\662F\4F7F\7528\7C21\55AE\7684\5B57\5143\6BD4\8F03.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109702597870313924)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109703258821313924)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\9A57\8B49\7684\8CC7\6599\6B04\540D\7A31 (\5340\5206\5927\5C0F\5BEB). \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\7684\8CC7\6599\6B04\6E05\55AE\4E2D\9078\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109703127906313924)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110012673053314152)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\8A55\4F30\6240\8F38\5165\8868\793A\5F0F\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110013097615314153)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110012903152314153)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110012848551314153)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110013181918314153)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110012726653314152)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110012537798314152)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110014680065314154)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\51FD\6578\4E3B\9AD4\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110014904425314154)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110014814214314154)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110014730328314154)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110015099769314154)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110014521026314154)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110011012082314151)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\51FD\6578\4E3B\9AD4\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110011357304314151)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110011220830314151)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110011112050314151)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110011448942314152)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110010923091314151)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110014281401314154)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5B9A\7FA9\9A57\8B49\7684 Java \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110014164183314153)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110015846459314155)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\5E03\6797\503C\4F5C\70BA\6B64\9A57\8B49\57FA\790E\7684 Java \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110015725814314155)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110012229682314152)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\932F\8AA4\8A0A\606F\6587\5B57\7684 Java \51FD\6578\4E3B\9AD4, \4EE5\4F5C\70BA\6B64\9A57\8B49\7684\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110012136284314152)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\932F\8AA4\6587\5B57\7684 Java \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110014014323314153)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\7576\54E1\5DE5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1, \82E5\8981\901A\904E\9A57\8B49\800C\4E0D\7522\751F\932F\8AA4\8A0A\606F:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110013901892314153)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5B9A\7FA9\9A57\8B49\7684 JavaScript \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110013807521314153)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110015652998314154)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\7576\54E1\5DE5\7DE8\5236\5728\90E8\9580 30, \82E5\8981\901A\904E\9A57\8B49\800C\4E0D\7522\751F\932F\8AA4\8A0A\606F:</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110015591792314154)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\5E03\6797\503C\4F5C\70BA\6B64\9A57\8B49\57FA\790E\7684 JavaScript \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110015448556314154)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110012075719314152)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\7576\54E1\5DE5\7DE8\5236\5728\90E8\9580 30, \82E5\8981\901A\904E\9A57\8B49\800C\4E0D\7522\751F\6307\5B9A\7684\932F\8AA4\8A0A\606F:</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Employee is in Department " + apex.env.P2_DEPTNO + " and not Department 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110011948796314152)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\932F\8AA4\8A0A\606F\6587\5B57\7684 JavaScript \51FD\6578\4E3B\9AD4, \4EE5\4F5C\70BA\6B64\9A57\8B49\7684\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110011810094314152)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\932F\8AA4\6587\5B57\7684 JavaScript \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110127122779314254)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\7576\54E1\5DE5\7DE8\5236\5728\90E8\9580 30, \82E5\8981\901A\904E\9A57\8B49\800C\4E0D\7522\751F\6307\5B9A\7684\932F\8AA4:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109703022754313924)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\767C\751F\932F\8AA4\7684 PL/SQL \8868\793A\5F0F, \4EE5\4F5C\70BA\6B64\9A57\8B49\7684\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109702916847313924)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767C\751F\932F\8AA4\7684 PL/SQL \7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110013701107314153)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\7576\54E1\5DE5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1, \82E5\8981\901A\904E\9A57\8B49\800C\4E0D\7522\751F\932F\8AA4\8A0A\606F:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110013677330314153)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5B9A\7FA9\9A57\8B49\7684 PL/SQL \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110013575673314153)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110015301279314154)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\7576\54E1\5DE5\7DE8\5236\5728\90E8\9580 30, \82E5\8981\901A\904E\9A57\8B49\800C\4E0D\7522\751F\932F\8AA4\8A0A\606F:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110015267547314154)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\5E03\6797\503C\4F5C\70BA\6B64\9A57\8B49\57FA\790E\7684 PL/SQL \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110015137526314154)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110011772348314152)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\7576\54E1\5DE5\7DE8\5236\5728\90E8\9580 30, \82E5\8981\901A\904E\9A57\8B49\800C\4E0D\7522\751F\6307\5B9A\7684\932F\8AA4\8A0A\606F:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        return ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110011661625314152)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\932F\8AA4\8A0A\606F\6587\5B57\7684 PL/SQL \51FD\6578\4E3B\9AD4, \4EE5\4F5C\70BA\6B64\9A57\8B49\7684\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110011538291314152)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\932F\8AA4\6587\5B57\7684 PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110014428698314154)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5B9A\7FA9\9A57\8B49\7684 Python \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110014377555314154)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110016021827314155)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\5E03\6797\503C\4F5C\70BA\6B64\9A57\8B49\57FA\790E\7684 Python \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110015900743314155)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110012489908314152)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\932F\8AA4\8A0A\606F\6587\5B57\7684 Python \51FD\6578\4E3B\9AD4, \4EE5\4F5C\70BA\6B64\9A57\8B49\7684\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110012342507314152)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\932F\8AA4\6587\5B57\7684 Python \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109703612575313924)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B63\898F\8868\793A\5F0F, \4EE5\7528\4F86\6BD4\5C0D\70BA\6B64\9A57\8B49\6307\5B9A\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109703544858313924)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\898F\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110013411803314153)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\7576\54E1\5DE5\70BA\4E3B\7BA1\6216\90E8\9580\4F4D\65BC\829D\52A0\54E5, \82E5\8981\901A\904E\9A57\8B49\800C\4E0D\7522\751F\932F\8AA4\8A0A\606F:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110013360877314153)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5B9A\7FA9\9A57\8B49\7684 SQL \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110013246582314153)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110127098041314254)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\7576\54E1\5DE5\7DE8\5236\5728\90E8\9580 30, \82E5\8981\8B93<strong>\50B3\56DE\8CC7\6599\5217</strong>\901A\904E\9A57\8B49\800C\4E0D\7522\751F\932F\8AA4\8A0A\606F:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\7576\54E1\5DE5\7DE8\5236\5728\90E8\9580 40, \82E5\8981\8B93<strong>\4E0D\50B3\56DE\8CC7\6599\5217</strong>\901A\904E\9A57\8B49\800C\4E0D\7522\751F\932F\8AA4\8A0A\606F:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno <> 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109702877140313924)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5B9A\7FA9\6B64\9A57\8B49\7684 SQL \67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109702712614313924)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109703497569313924)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\503C, \4EE5\7528\4F86\548C\70BA\6B64\9A57\8B49\6307\5B9A\7684\8CC7\6599\6B04\503C\505A\6BD4\8F03.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109703395822313924)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109717072232313935)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110057650188314184)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E7C\627F\8A72\61C9\7528\7A0B\5F0F\5B9A\7FA9\7684\8A2D\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109716950746313935)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\6B64\5C6C\6027\63A7\5236 &PRODUCT_NAME. \662F\5426\61C9\8A72\652F\63F4\672A\5305\542B\968E\6BB5\4F5C\696D ID \7684\61C9\7528\7A0B\5F0F URL.'),
unistr('\5982\679C\555F\7528\91CD\65B0\7D50\5408\968E\6BB5\4F5C\696D, \7576 URL \672A\5305\542B\968E\6BB5\4F5C\696D ID \6642, &PRODUCT_NAME. \5C07\6703\5617\8A66\4F7F\7528\968E\6BB5\4F5C\696D Cookie \4F86\7D50\5408\73FE\6709\7684\968E\6BB5\4F5C\696D.'),
'</p>',
unistr('<p>\9650\5236\6027\66F4\9AD8\7684\57F7\884C\8655\7406\5C64\7D1A\8A2D\5B9A\6703\8986\5BEB\6B64\9801\9762\5C64\7D1A\503C.'),
'</p>',
unistr('<p><em><strong>\6CE8\610F:</em></strong> \555F\7528\91CD\65B0\7D50\5408\968E\6BB5\4F5C\696D\53EF\80FD\6703\8B93\60A8\7684\61C9\7528\7A0B\5F0F\51FA\73FE\5B89\5168\6F0F\6D1E,'),
unistr('\653B\64CA\8005\6709\53EF\80FD\85C9\6B64\63A5\7BA1\73FE\6709\7684\4E00\822C\4F7F\7528\8005\968E\6BB5\4F5C\696D.'),
unistr('\82E5\8981\77AD\89E3\8A73\7D30\8CC7\8A0A, \8ACB\53C3\95B1\300C\61C9\7528\7A0B\5F0F\7522\751F\5668\4F7F\7528\624B\518A\300D\4E2D\300C\7BA1\7406\61C9\7528\7A0B\5F0F\5B89\5168\6027\300D\7684<em>\91CD\65B0\7D50\5408\968E\6BB5\4F5C\696D</em>\5C0F\7BC0.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109798556836313997)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109798695127313997)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C URL \672A\542B\968E\6BB5\4F5C\696D ID, &PRODUCT_NAME. \6703\5EFA\7ACB\65B0\7684\968E\6BB5\4F5C\696D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109798755677313997)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\7528\968E\6BB5\4F5C\696D\555F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109798862279313997)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C URL \6307\5411\516C\7528\9801\9762\4E14\672A\542B\968E\6BB5\4F5C\696D ID, &PRODUCT_NAME. \5C07\6703\5617\8A66\4F7F\7528\66FF\8A72\61C9\7528\7A0B\5F0F\5EFA\7ACB\7684\73FE\6709\968E\6BB5\4F5C\696D Cookie.'),
unistr('\61C9\7528\7A0B\5F0F\82E5\540C\6642\5305\542B\516C\7528\9801\9762\548C\7D93\904E\8A8D\8B49\7684\9801\9762, \7CFB\7D71\6703\5728\4E00\822C\4F7F\7528\8005\8A8D\8B49\4E4B\5F8C\5B9A\7FA9\968E\6BB5\4F5C\696D ID.'),
unistr('\5982\679C\968E\6BB5\4F5C\696D\5C1A\672A\8A8D\8B49, &PRODUCT_NAME. \53EA\6703\900F\904E Cookie \9032\884C\7D50\5408.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109798967636313998)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\968E\6BB5\4F5C\696D\7686\555F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109799060169313998)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C URL \672A\542B\968E\6BB5\4F5C\696D ID, &PRODUCT_NAME. \6703\5617\8A66\4F7F\7528\70BA\8A72\61C9\7528\7A0B\5F0F\6240\5EFA\7ACB\7684\73FE\6709\968E\6BB5\4F5C\696D Cookie, \524D\63D0\662F\5FC5\9808\7B26\5408\4E0B\5217\689D\4EF6:</p>'),
'<p><ul>',
unistr('  <li>\61C9\7528\7A0B\5F0F\555F\7528\300C\968E\6BB5\4F5C\696D\72C0\614B\4FDD\8B77\300D, \4E14 URL \5305\542B\6709\6548\7684\7E3D\548C\6AA2\9A57.'),
unistr('    \5C0D\65BC\516C\7528\66F8\7C64, \9650\5236\6027\6700\9AD8\7684\9805\76EE\5C64\7D1A\4FDD\8B77\5FC5\9808\662F<em>\7121\9650\5236</em>\6216<em>\9700\8981\7E3D\548C\6AA2\9A57 - \61C9\7528\7A0B\5F0F\5C64\7D1A</em>.</li>'),
unistr('  <li>\6216\8005, URL \672A\5305\542B\6709\6548\8CA0\8F09 (\8981\6C42\53C3\6578\3001\6E05\9664\5FEB\53D6\6216\8CC7\6599\503C\7D44).</li>'),
'</ul></p>',
unistr('<p>\9019\9805\8A2D\5B9A\53E6\9808\5C07\61C9\7528\7A0B\5F0F\7684<em>\5167\5D4C\65BC\6846\67B6\4E2D</em>\8A2D\70BA<em>\5141\8A31\4F86\81EA\76F8\540C\4F86\6E90</em>\6216\8A2D\70BA<em>\62D2\7D55</em>.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109716840474313935)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\7D50\5408\968E\6BB5\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109644908870313866)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\9801\9762\9001\51FA\5F8C\91CD\65B0\8F09\5165\9801\9762\7684\6642\6A5F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109645063448313866)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\91CD\65B0\8F09\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109645168449313866)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\91CD\65B0\8F09\5165\9801\9762\4EE5\986F\793A\932F\8AA4\548C\6210\529F\8A0A\606F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109645224732313866)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\5728\6210\529F\6642\8F09\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109645318807313866)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B\986F\793A\932F\8AA4\800C\4E0D\91CD\65B0\8F09\5165\9801\9762, \4F46\6703\5728\9806\5229\8655\7406\5F8C\91CD\65B0\8F09\5165\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109644819024313866)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\6642\91CD\65B0\8F09\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110026304086314162)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110026436027314162)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5FEB\53D6\8CC7\6599, \800C\662F\6BCF\6B21\9032\884C\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109899048665314071)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109899110703314071)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5FEB\53D6\8CC7\6599, \800C\662F\6BCF\6B21\9032\884C\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109336438741313627)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109336571108313627)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5FEB\53D6\7D50\679C. \5F9E\9060\7AEF\8CC7\6599\5EAB\64F7\53D6\6BCF\500B\8981\6C42\7684\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109334631213313626)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6 &PRODUCT_NAME. \5F15\64CE\5FEB\53D6\672C\6A5F\8CC7\6599\5EAB\4E2D\8CC7\6599\7684\65B9\5F0F.'),
unistr('        \5982\679C\53EF\4EE5\4F7F\7528\5FEB\53D6\529F\80FD, \5143\4EF6\5C07\6703\4F9D\5FEB\53D6\7684\7D50\679C\5448\73FE, \800C\4E0D\662F\5F9E\9060\7AEF\8CC7\6599\5EAB\64F7\53D6.'),
unistr('        \5FEB\53D6\7684\7D50\679C\53EF\5927\5E45\63D0\5347\6548\80FD, \7279\5225\662F\672C\6A5F\8207\9060\7AEF\8CC7\6599\5EAB\4E4B\9593\6709\5EF6\9072\6642.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109334759685313626)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.ALL_USERS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\4F7F\7528\8005\9069\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109334837562313626)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.ALL_USERS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FEB\53D6\7D50\679C, \800C\4E14\4F9B\6240\6709\4F7F\7528\8005\4F7F\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109335113830313626)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.SESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F9D\968E\6BB5\4F5C\696D\5340\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109335244458313626)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.SESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\6BCF\500B\4F7F\7528\8005\968E\6BB5\4F5C\696D\5FEB\53D6\7D50\679C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109334913082313626)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.USER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F9D\4F7F\7528\8005\5340\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109335011358313626)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.USER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\6BCF\500B\4F7F\7528\8005\7684\6240\6709\968E\6BB5\4F5C\696D\5FEB\53D6\7D50\679C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109334570251313626)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FEB\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109335579399313626)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\8B93\8CC7\6599\5728\5FEB\53D6\5F8C\7684 15 \5206\9418\904E\671F</dt>'),
'  <dd><pre>15</pre></dd>',
unistr('<dt>\8B93\8CC7\6599\5728\6574\9EDE\6642\9593\904E\671F</dt>'),
'  <dd><pre>FREQ=HOURLY;BYMINUTE=0;BYSECOND=0</pre></dd>',
unistr('<dt>\8B93\8CC7\6599\5728\5348\591C\904E\671F</dt>'),
'  <dd><pre>FREQ=DAILY;BYHOUR=0;BYMINUTE=0;BYSECOND=0</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109335433748313626)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\5FEB\53D6\8CC7\6599\8B8A\6210\7121\6548\7684\6642\9593.'),
unistr('        \8ACB\63D0\4F9B\5206\9418\6578\6216 DBMS_SCHEDULER \884C\4E8B\66C6\5B57\4E32.</p>'),
unistr('        <p>\82E5\63D0\4F9B DBMS_SCHEDULER \884C\4E8B\66C6\5B57\4E32, \60A8\53EF\4EE5\5B9A\7FA9\8B93\5FEB\53D6\8CC7\6599\5728\6574\9EDE\6642\9593\3001\5348\591C\6216\5176\4ED6\7279\5B9A\9031\671F\6642\9593\9EDE\8B8A\6210\7121\6548.'),
unistr('        \8ACB\53C3\95B1 DBMS_SCHEDULER.EVALUATE_CALENDAR_STRING \7684\6587\4EF6\4EE5\77AD\89E3\8A73\7D30\8CC7\8A0A.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109335309087313626)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FEB\53D6\903E\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109572577403313809)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\6B64\4E92\52D5\5F0F\5831\8868\5340\57DF\7684\6587\6578\5B57\5225\540D.'),
unistr('\6B64\5225\540D\5728\61C9\7528\7A0B\5F0F\5167\5FC5\9808\662F\552F\4E00\7684.'),
unistr('\60A8\53EF\4EE5\5728\81EA\8A02 API \547C\53EB\4E2D\4F7F\7528\5225\540D\53C3\7167\4E92\52D5\5F0F\5831\8868\5340\57DF.'),
unistr('\4F8B\5982, \60A8\53EF\4EE5\64B0\5BEB\51FD\6578\4F86\67E5\8A62 <code>APEX_APPLICATION_PAGE_IR</code> \6AA2\8996\4E2D\7684 <code>ALIAS</code> \8CC7\6599\6B04, \4EE5\50B3\56DE <code>INTERACTIVE_REPORT_ID</code>.'),
unistr('\7531\65BC <code>INTERACTIVE_REPORT_ID</code> \503C\6709\53EF\80FD\5728\60A8\5C07\61C9\7528\7A0B\5F0F\532F\51FA\81F3\5176\4ED6\57F7\884C\8655\7406\6216\5F9E\5176\4ED6\57F7\884C\8655\7406\532F\5165\6642\8B8A\66F4, \56E0\6B64\4F7F\7528\5225\540D\53C3\7167\4E92\52D5\5F0F\5831\8868\5340\57DF\53EF\80FD\662F\8F03\4F73\7684\505A\6CD5.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109572480297313809)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109566060835313804)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\503C\6E05\55AE\65E5\671F\9650\5236.'),
unistr('\5728\5831\8868\8CC7\6599\6B04\4E0B\62C9\5F0F\6E05\55AE\7684\7BE9\9078\4E2D, \65E5\671F\8CC7\6599\6B04\7684\503C\6E05\55AE\53EF\4EE5\986F\793A\904E\53BB\6642\9593\3001\672A\4F86\6642\9593\6216\5169\8005\90FD\986F\793A.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109769223835313975)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.ALL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109769465270313975)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.FUTURE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\4F86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109769339494313975)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.PAST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904E\53BB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109565997468313804)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F\7BC4\570D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109572777161313809)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\5176\503C\5132\5B58\9810\5B58\5831\8868 ID \7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.'),
unistr('\4E92\52D5\5F0F\5831\8868\6703\4F7F\7528\6B64\9805\76EE\503C\9023\7D50\81F3\9810\5B58\5831\8868.'),
unistr('\4F8B\5982, \60A8\53EF\4EE5\5B9A\7FA9\542B\6709\9023\7D50\7684\9810\5B58\5831\8868\6E05\55AE, \5176\4E2D\4F7F\7528\5DF2\5B9A\7FA9\7684\9805\76EE\540D\7A31\548C\9810\5B58\5831\8868 ID \4F5C\70BA\5176\503C, \4EE5\9023\7D50\81F3\9810\5B58\7684\9810\8A2D\5831\8868\3001\516C\7528\5831\8868\6216\5C08\7528\5831\8868.'),
unistr('\9810\5B58\5831\8868 ID \53EF\5F9E <code>APEX_APPLICATION_PAGE_IR_RPT</code> \6AA2\8996\64F7\53D6\800C\5F97.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109572629501313809)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868 ID \9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109713732875313932)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5831\8868\7248\9762\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109714381706313933)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5831\8868\7248\9762\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109713377149313932)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5217\5370\5831\8868\6642\4F7F\7528\7684\5831\8868\7248\9762\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109713223890313932)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7248\9762\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109603662237313835)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\63A7\5236\6B64\5831\8868\4E4B\986F\793A\65B9\5F0F\7684\9810\5148\5B9A\7FA9\5831\8868\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109782894370313985)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML (\6A19\6E96)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109782998120313986)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6A19\6E96 HTML \8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109783075108313986)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\76F4\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109783177351313986)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\500B\5225\8CC7\6599\5217\986F\793A\6BCF\4E00\500B\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109783296848313986)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.D'
,p_message_language=>'zh-tw'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109783351617313986)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5831\8868\532F\51FA\6210 CSV \6A94\6848.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109783412933313986)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.D'
,p_message_language=>'zh-tw'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109783591218313986)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5831\8868\532F\51FA\6210 XML \6A94\6848.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109603568874313835)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109605899467313837)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\986F\793A\5728\5831\8868\7E3D\548C\503C\76F8\9130\4F4D\7F6E\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109605761902313837)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\7E3D\548C\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109599107051313828)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8ACB\9078\53D6\4E00\500B\4F9B\7528\65BC\5B9A\7FA9\6B64\4E00\822C\5831\8868\4E4B\5916\89C0\548C\7248\9762\914D\7F6E\7684\5831\8868\6A23\677F.</p>'),
unistr('        <p>\5831\8868\6A23\677F\5B9A\7FA9\65BC\61C9\7528\7A0B\5F0F\4E3B\984C\4E2D.'),
unistr('        \4E00\822C\5831\8868\5EFA\7ACB\4E4B\5F8C, \5C31\6703\81EA\52D5\5C07\6B64\6A23\677F\8A2D\70BA\76EE\524D\4E3B\984C\4E2D\5B9A\7FA9\7684\9810\8A2D\5831\8868\6A23\677F.</p>'),
unistr('        <p>\8A31\591A\4E3B\984C\90FD\5305\542B\4E00\822C\5831\8868\6A23\677F, \4F9B\7528\65BC\4EE5\8868\683C\3001\7D22\5F15\9375\503C\7D44\3001\641C\5C0B\7D50\679C\3001\5361\7247\7B49\4E4B\985E\7684\65B9\5F0F\986F\793A\8CC7\6599.'),
unistr('        \8ACB\6CE8\610F, \67D0\4E9B\5831\8868\6A23\677F (\4F8B\5982\5361\548C\641C\5C0B\7D50\679C) \662F\300C\4EE5\8CC7\6599\5217\70BA\57FA\790E\300D, \56E0\6B64\60A8\7684 SQL \67E5\8A62\61C9\8A72\50B3\56DE\6A23\677F\4E2D\66FF\4EE3\7684\4E00\7D44\7279\5B9A\8CC7\6599\6B04\5225\540D.<br>'),
unistr('        \300C\901A\7528\4E3B\984C\300D\63D0\4F9B\4E0B\5217\5831\8868\6A23\677F:'),
'          <dl>',
unistr('            <dt>\8B66\793A</dt>'),
unistr('              <dd>\5728\60A8\7684\9801\9762\4E2D\986F\793A\4EFB\610F\6578\76EE\7684\6C34\5E73\8B66\793A\6216\901A\77E5.</dd>'),
unistr('            <dt>\6A19\8A18\6E05\55AE</dt>'),
unistr('              <dd>\4EE5\985E\4F3C\5100\8868\677F\7684\4F7F\7528\8005\4ECB\9762\986F\793A\7D22\5F15\9375\503C\7D44.</dd>'),
unistr('            <dt>\5361\7247</dt>'),
unistr('              <dd>\4EE5\5361\7247\6216\5C0F\578B\5340\584A\65B9\5F0F\986F\793A\5831\8868\8CC7\6599, \9069\7528\65BC\5448\73FE\5404\7A2E\4E0D\540C\7684\8CC7\8A0A. \5361\7247\53EF\4EE5\900F\904E\300C\6A23\677F\9078\9805\300D\9032\884C\5927\5E45\81EA\8A02.</dd>'),
unistr('            <dt>\8A3B\89E3</dt>'),
unistr('              <dd>\986F\793A\8A3B\89E3\548C\5176\4ED6\8A0A\606F.</dd>'),
unistr('            <dt>\641C\5C0B\7D50\679C</dt>'),
unistr('              <dd>\986F\793A\641C\5C0B\5F15\64CE\6A23\5F0F\7684\641C\5C0B\7D50\679C</dd>'),
unistr('            <dt>\6A19\6E96</dt>'),
unistr('              <dd>\9019\662F\9810\8A2D\7684\5831\8868\6A23\677F, \4F9B\7528\65BC\4EE5\8868\683C\65B9\5F0F\986F\793A\8CC7\6599, \800C\4E14\53EF\4EE5\900F\904E\300C\6A23\677F\9078\9805\300D\9032\884C\5927\5E45\81EA\8A02.</dd>'),
unistr('            <dt>\6642\9593\8868</dt>'),
unistr('              <dd>\986F\793A\52D5\4F5C\7684\6642\9593\8868. \9069\5408\7528\5728\9996\9801\3001\8B8A\66F4\65E5\8A8C\4EE5\53CA\9700\8981\6700\8FD1\6D3B\52D5\4E4B\6D3B\52D5\994B\9001\7684\5176\4ED6\5340\57DF.</dd>'),
unistr('            <dt>\503C\5C6C\6027\7D44 - \8CC7\6599\6B04</dt>'),
unistr('              <dd>\986F\793A\4EE5\8CC7\6599\6B04\70BA\57FA\790E\4E4B\67E5\8A62\7684\7D22\5F15\9375-\503C\7D44. \5B83\4F7F\7528\8CC7\6599\6B04\6A19\982D\4F5C\70BA\6BCF\500B\9805\76EE\7684\6A19\7C64.</dd>'),
unistr('            <dt>\503C\5C6C\6027\7D44 - \8CC7\6599\5217</dt>'),
unistr('              <dd>\986F\793A\4EE5\8CC7\6599\5217\70BA\57FA\790E\4E4B\67E5\8A62\7684\7D22\5F15\9375-\503C\7D44. \5B83\4F7F\7528\7B2C\4E00\500B\8CC7\6599\6B04\4F5C\70BA\6A19\7C64, \7B2C\4E8C\500B\8CC7\6599\6B04\4F5C\70BA\503C.</dd>'),
'          </dl>',
unistr('          \53E6\8ACB\53C3\95B1: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\984C\7BC4\4F8B\61C9\7528\7A0B\5F0F</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109599018164313828)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109460931326313722)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9664\975E\5DF2\5728\5176\4E2D\4E00\500B\5831\8868\8CC7\6599\6B04\4E0A\5B9A\7FA9\81F3\5C11\4E00\500B\7BE9\9078, \5426\5247\6307\5B9A\662F\5426\9632\6B62\4E92\52D5\5F0F\65B9\683C\986F\793A\8CC7\6599.'),
unistr('		\6B64\9078\9805\7684\8A2D\8A08\76EE\7684\5728\65BC\9650\5236\6839\64DA\7BE9\9078\6240\50B3\56DE\7684\8CC7\6599\5217, \4F86\9650\5236\5F9E\6975\5927\578B\7684\8CC7\6599\96C6\8F09\5165\7684\8CC7\6599.</p>'),
unistr('		<p>\500B\5225\8CC7\6599\6B04\53EF\4EE5\555F\7528<strong>\9700\8981\8CC7\6599\6B04\7BE9\9078</strong>, \78BA\4FDD\8A72\8CC7\6599\6B04\9700\8981\7BE9\9078, \800C\6B64\9078\9805\8DE8\4EFB\4F55\8CC7\6599\6B04\90FD\53EA\9700\8981\4E00\500B\7BE9\9078.</p>'),
unistr('		<p>\6CE8\610F - \5982\679C\8A2D\5B9A\6B64\9078\9805, \4F46\76EE\524D\672A\5B9A\7FA9\4EFB\4F55\7BE9\9078, \5247\6703\986F\793A\4E00\5247\8A0A\606F, \8981\6C42\4F7F\7528\8005\8F38\5165\7BE9\9078.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109460863291313722)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109617001602313845)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\4EE5\5132\5B58\6240\6709\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109259813568313565)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\5982\4F55\9650\5236\53EF\5132\5B58\5728\968E\6BB5\4F5C\696D\72C0\614B\4E2D\7684\5B57\5143.'),
unistr('\82E5\4F7F\7528\8005\5617\8A66\5132\5B58\7684\8CC7\6599\4E0D\7B26\5408\6240\9078\5B57\5143\7684\9650\5236, &PRODUCT_NAME. \4FBF\6703\986F\793A\932F\8AA4\8A0A\606F.</p>'),
unistr('<p>\9650\5236\5B57\5143\53EF\52A0\5F37\61C9\7528\7A0B\5F0F\7684\5B89\5168\6027, \4E26\53EF\80FD\9632\6B62\8DE8\7DB2\7AD9\547D\4EE4\6A94 (XSS) \7684\653B\64CA.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109758102355313967)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62D2\7D55\6E05\55AE &<>"/;,*|=% \8207 --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109758246234313967)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5132\5B58\4E0B\5217\5B57\5143: &amp;\3001&lt;\3001&gt;\3001"\3001/\3001;\3001","\3001*\3001|\3001=\3001% \8207 "--" (PL/SQL \8A3B\89E3).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109758324354313967)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62D2\7D55\6E05\55AE &<>"/;,*|=% \6216 -- \8207\65B0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109758434797313967)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5132\5B58\4E0B\5217\5B57\5143: &amp;\3001&lt;\3001&gt;\3001"\3001/\3001;\3001","\3001*\3001|\3001=\3001%\3001"--", \4EE5\53CA\65B0\884C\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109757711061313967)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('a-Z\30010-9 \8207\7A7A\683C\70BA\5141\8A31\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109757812803313967)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\80FD\5132\5B58\5B57\5143 a-z\3001A-Z\30010-9 \8207\7A7A\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109757971062313967)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62D2\7D55\6E05\55AE HTML \547D\4EE4\5B57\5143 (<>")')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109758047385313967)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5132\5B58\4FDD\7559\7684 HTML \5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109758576172313967)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WORKSPACE_SCHEMA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\7DB1\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109259730574313565)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9650\5236\7684\5B57\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110023904377314160)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\5448\73FE\7684\5167\5BB9\9078\53D6\8F38\5165\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110024082921314160)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.D'
,p_message_language=>'zh-tw'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110024150710314160)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5BB9\5305\542B HTML \6A19\8A18, \5728\5448\73FE\6642\4E0D\6703\5957\7528\7279\6B8A\5B57\5143\9041\96E2. \8ACB\78BA\5B9A\8CC7\6599\5B89\5168\7121\865E\4E14\4E0D\542B\4E00\822C\4F7F\7528\8005\8F38\5165\7684\8CC7\6599, \4EE5\907F\514D\8DE8\7DB2\7AD9\547D\4EE4\6A94\6F0F\6D1E (XSS).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110024287244314160)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Markdown'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110024312293314160)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5BB9\5305\542B Markdown \6A19\8A18, \6703\5728\5448\73FE\524D\5C07\9019\4E9B\6A19\8A18\8F49\8B6F\70BA\5B89\5168\7684 HTML \6A19\8A18. \8F49\8B6F\773E\6240\5468\77E5\7684 Markdown \6A19\8A18\53EF<strong>\907F\514D</strong>\8DE8\7DB2\7AD9\547D\4EE4\6A94\6F0F\6D1E (XSS).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110023818438314160)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109460160175313721)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\5132\5B58\6240\66F4\65B0\8868\683C\4E4B\8CC7\6599\5217\7248\672C\7DE8\865F\7684\8CC7\6599\6B04. \6B64\8CC7\6599\6B04\5C07\6703\7528\65BC\907A\5931\66F4\65B0\6AA2\67E5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109460097656313721)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\7248\672C\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109583771990313817)
,p_name=>'PE.PROPERTY.RUN_PROCESS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\8655\7406\4F5C\696D\7684\57F7\884C\983B\7387.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109773871731313979)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.N.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\4E00\500B\9801\9762\9020\8A2A\4E00\6B21 (\9810\8A2D)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109773730200313979)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.Y.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\4E00\500B\968E\6BB5\4F5C\696D\4E00\6B21\6216\91CD\8A2D\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109583682287313817)
,p_name=>'PE.PROPERTY.RUN_PROCESS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109569506983313806)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\7528\4F86\9650\5236\8AB0\80FD\5920\5132\5B58\516C\7528\5831\8868\5B9A\7FA9\7684\6388\6B0A\914D\7F6E.'),
unistr('\82E5\8981\8B93\4E00\822C\4F7F\7528\8005\5132\5B58\516C\7528\5831\8868, \6B64\6388\6B0A\914D\7F6E\5FC5\9808\8A55\4F30\70BA TRUE.'),
unistr('\5982\679C\672A\63D0\4F9B\4EFB\4F55\6388\6B0A\914D\7F6E, \5247\4EFB\4F55\4F7F\7528\8005\5747\53EF\5132\5B58\5831\8868.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109569498274313806)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\516C\7528\5831\8868\6388\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109341993809313631)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\662F\5426\8981\5728\5206\652F\57F7\884C\4E4B\524D\5148\5C07\968E\6BB5\4F5C\696D\72C0\614B\4E2D\7684\503C\5132\5B58\81F3\8CC7\6599\5EAB.'),
unistr('\5982\679C\60A8\8981\700F\89BD\81F3\5176\4ED6\61C9\7528\7A0B\5F0F, \800C\8A72\61C9\7528\7A0B\5F0F\9700\8981\5B58\53D6\4F86\81EA\6B64\61C9\7528\7A0B\5F0F\7684\968E\6BB5\4F5C\696D\72C0\614B\503C\6642, \5C07\6B64\5C6C\6027\8A2D\70BA<strong>\958B\555F</strong>\5C31\76F8\7576\91CD\8981.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109341839914313631)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\884C\5206\652F\8655\7406\524D\5148\5132\5B58\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109328888687313621)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\4F5C\70BA\8986\5BEB\5256\6790\7DB1\8981\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.  \9019\50C5\9069\7528\65BC\5167\90E8\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109328772098313621)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981\8986\5BEB\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109948760715314106)
,p_name=>'PE.PROPERTY.SCHEME_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109948603587314106)
,p_name=>'PE.PROPERTY.SCHEME_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109947965105314106)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\9078\53D6\5957\7528\6B64\6388\6B0A\914D\7F6E\7684\65B9\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109948086860314106)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Exists SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109948136478314106)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\8A62\82E5\50B3\56DE\503C, \5247\6388\6B0A\901A\904E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109948495475314106)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\5E03\6797\503C\7684 PL/SQL \51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109948501457314106)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\5E03\6797\503C\7684 PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109948248299314106)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('NOT Exists SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109948388635314106)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\8A62\82E5\672A\50B3\56DE\4EFB\4F55\503C, \5247\6388\6B0A\901A\904E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109947878533314106)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\914D\7F6E\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109569780530313807)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\641C\5C0B\6309\9215\6A19\7C64\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109569605913313807)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\6309\9215\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109931364157314094)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\5143\4EF6\662F\4F7F\7528\4E00\500B\8CC7\6599\6B04\9084\662F\9032\968E\683C\5F0F (\4F7F\7528 HTML \8868\793A\5F0F\548C\652F\63F4\7684\66FF\4EE3\5B57\4E32) \986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109931259667314094)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\968E\683C\5F0F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109931577597314094)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7576\4F5C\6B21\8981\4E3B\9AD4\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109931433169314094)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109932065416314095)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\65B0\589E\81F3\6B64\5143\4EF6\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109931902907314095)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109931835555314094)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\8B8A\66F4\80CC\666F\8207\6587\5B57\8272\5F69</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\4F7F\7528\6A19\984C 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>\4F7F\7528\4F86\81EA SQL \67E5\8A62\7684\52D5\614B\985E\5225</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \6B64\7BC4\4F8B\4E2D\7684 <code>&COLUMN_CLASS.</code> \8207 <code>&EMPLOYEE_STATUS.</code> \66FF\4EE3\9805\76EE\70BA\5831\8868 SQL \67E5\8A62\4E2D\9078\53D6\7684\8CC7\6599\6B04.</dd>'),
unistr('  <dt>\6E38\6A19\505C\7559\6642\986F\793A\5F71\50CF\8207\5DE5\5177\63D0\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109931761008314094)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5728\6B64\8CC7\6599\6B04\4E2D\986F\793A\7684 HTML \8868\793A\5F0F. \82E5\8981\4EE5 HTML \683C\5F0F\986F\793A\8CC7\6599\6B04\503C, \8ACB\4F7F\7528 <code>&COLUMN.</code> \8A9E\6CD5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109931606699314094)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109327672752313620)
,p_name=>'PE.PROPERTY.SECURE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\82E5\6307\5B9A<strong>\958B\555F</strong>, \53EA\6709\5728\5354\5B9A\70BA HTTPS \6642, \624D\5141\8A31\5F9E\700F\89BD\5668\50B3\9001\968E\6BB5\4F5C\696D\7BA1\7406 Cookie. '),
unistr('\82E5\9078\53D6<strong>\95DC\9589</strong>, \5247\4E0D\8AD6\5354\5B9A\70BA HTTP \6216 HTTPS, \5747\5141\8A31\5F9E\700F\89BD\5668\50B3\9001\968E\6BB5\4F5C\696D\7BA1\7406 Cookie.</p>'),
unistr('<p>\5982\679C\5DF2\5728 Web \4F3A\670D\5668\4E0A\8A2D\5B9A SSL, \61C9\9078\53D6<strong>\958B\555F</strong>, \4EE5\85C9\7531\675C\7D55\672A\52A0\5BC6\7684 HTTP \6D41\91CF\4F86\52A0\5F37\61C9\7528\7A0B\5F0F\7684\5B89\5168\6027.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109327541453313620)
,p_name=>'PE.PROPERTY.SECURE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\5168')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109484182397313739)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\61C9\81EA\52D5\9078\53D6\7B2C\4E00\500B\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109484028379313739)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7B2C\4E00\500B\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109624291063313851)
,p_name=>'PE.PROPERTY.SERIES_CHART_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6578\5217\5716\8868\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109518762792313764)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5B9A\7FA9\591A\6578\5217\52D5\614B\67E5\8A62\7684\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109518681771313764)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6578\5217\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109259268043313564)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\968E\6BB5\4F5C\696D\72C0\614B\4FDD\8B77\5C64\7D1A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109756953068313966)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981\7E3D\548C\6AA2\9A57 - \61C9\7528\7A0B\5F0F\5C64\7D1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109757077708313966)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\85C9\7531\5305\62EC\5DE5\4F5C\5340\548C\61C9\7528\7A0B\5F0F\7279\5B9A\4E4B\7E3D\548C\6AA2\9A57\7684 URL \50B3\9001\9805\76EE\4F86\8A2D\5B9A\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109757570935313966)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9650\5236 - \7121\6CD5\5F9E\700F\89BD\5668\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109757698483313966)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E0D\53EF\4F7F\7528 URL \6216 POSTDATA \66F4\6539\9805\76EE.'),
unistr('\82E5\8981\5C07\8A2D\5B9A\9805\76EE\503C\7684\65B9\5F0F\9650\5236\5728\5167\90E8\8655\7406\4F5C\696D\3001\904B\7B97\7B49, \8ACB\9078\53D6\6B64\9078\9805.'),
unistr('\6B64\5C6C\6027\50C5\9069\7528\65BC\4E0D\662F\4F5C\70BA\8CC7\6599\8F38\5165\9805\76EE\7684\9805\76EE, \4E14\4E00\5F8B\6703\53D7\5230\76E3\7763, \5373\4F7F\505C\7528\300C\968E\6BB5\4F5C\696D\72C0\614B\4FDD\8B77\300D\4E5F\662F\5982\6B64.'),
unistr('\6B64\5C6C\6027\53EF\7528\65BC\5177\6709\4E0B\5217<strong>\986F\793A\65B9\5F0F</strong>\985E\578B\7684\9801\9762\9805\76EE\6216\61C9\7528\7A0B\5F0F\9805\76EE:'),
'<ul>',
unistr('  <li>\50C5\986F\793A (\5132\5B58\72C0\614B=\5426)</li>'),
unistr('  <li>\6587\5B57\6B04\4F4D (\5DF2\505C\7528, \4E0D\5132\5B58\72C0\614B)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109756720111313966)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\9650\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109756852327313966)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\85C9\7531 URL \6216\8868\55AE\50B3\9001\9805\76EE\4F86\8A2D\5B9A\9805\76EE. \4E0D\9700\8981\5C0D URL \9032\884C\7E3D\548C\6AA2\9A57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109757157164313966)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981\7E3D\548C\6AA2\9A57 - \4F7F\7528\8005\5C64\7D1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109757266360313966)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\85C9\7531\5305\62EC\5DE5\4F5C\5340\3001\61C9\7528\7A0B\5F0F\4EE5\53CA\4F7F\7528\8005\7279\5B9A\4E4B\7E3D\548C\6AA2\9A57\7684 URL \50B3\9001\9805\76EE\4F86\8A2D\5B9A\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109757384399313966)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981\7E3D\548C\6AA2\9A57 - \968E\6BB5\4F5C\696D\5C64\7D1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109757484656313966)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\85C9\7531\5305\62EC\968E\6BB5\4F5C\696D\7279\5B9A\4E4B\7E3D\548C\6AA2\9A57\7684 URL \50B3\9001\9805\76EE\4F86\8A2D\5B9A\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109259198601313564)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D\72C0\614B\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109281158463313585)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\6838\53D6\65B9\584A\95DC\806F\7684\7BE9\9078\7FA4\7D44.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109281089511313585)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110044406992314175)
,p_name=>'PE.PROPERTY.SHORTCUT_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109948865577314106)
,p_name=>'PE.PROPERTY.SHORTCUT_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110044509128314175)
,p_name=>'PE.PROPERTY.SHORTCUT_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109579999423313814)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\300C\641C\5C0B\5217\300D\5167\662F\5426\8981\5305\62EC<em>\52D5\4F5C</em>\529F\80FD\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109579899647313814)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\62EC\52D5\4F5C\529F\80FD\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109577193476313812)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5B9A\7FA9\6B64\5831\8868\7684\805A\7E3D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109577002629313812)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\805A\7E3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109562871453313802)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\8CC7\6599\6B04\662F\5426\9810\8A2D\986F\793A\65BC\5831\8868\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109562769788313801)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109577394396313812)
,p_name=>'PE.PROPERTY.SHOW_CHART.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5B9A\7FA9\6B64\5831\8868\7684\5716\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109577209912313812)
,p_name=>'PE.PROPERTY.SHOW_CHART.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109576956550313812)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5B9A\7FA9\6B64\5831\8868\7684\904B\7B97\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109576883420313812)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109576528690313812)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5B9A\7FA9\6B64\5831\8868\7684\63A7\5236\5206\6BB5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109576421022313812)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63A7\5236\5206\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109281517025313586)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\5728\76EE\524D\9762\5411\6E05\55AE\4E2D\6240\9078\503C\7684\65C1\908A\986F\793A\9762\5411\6A19\7C64. \5982\679C\9078\53D6\7684\503C\70BA\4E0D\8A00\81EA\660E\7684\5167\5BB9 (\4F8B\5982\8A02\55AE\72C0\614B), \8ACB\96B1\85CF\6B64\6A19\7C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109281478168313585)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\76EE\524D\9762\5411\7684\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109579526497313814)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\641C\5C0B\5217\5167\662F\5426\8981\5305\62EC\500B\5225\7684\4E0B\62C9\5F0F\8CC7\6599\5217\9078\53D6\5668.'),
unistr('\8ACB\52FF\540C\6642\9078\53D6\6B64\5C6C\6027\548C<strong>\6BCF\9801\8CC7\6599\5217\6578</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109579466200313814)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\9801\8CC7\6599\5217\6578\9078\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109578389571313813)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\4F7F\7528\5176\4E2D\4E00\7A2E\6307\5B9A\7684\4E0B\8F09\683C\5F0F\4F86\4E0B\8F09\5831\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109578273718313813)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109575722750313811)
,p_name=>'PE.PROPERTY.SHOW_FILTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5728\6B64\5831\8868\5B9A\7FA9\7BE9\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109575644832313811)
,p_name=>'PE.PROPERTY.SHOW_FILTER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109579327404313814)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\641C\5C0B\5217\5167\300C\641C\5C0B\300D\6B04\4F4D\7684\958B\982D\662F\5426\8981\5305\62EC\300C\641C\5C0B\5668\300D\4E0B\62C9\5F0F\6E05\55AE.'),
unistr('\300C\641C\5C0B\5668\300D\4E0B\62C9\5F0F\6E05\55AE\662F\4E00\500B\8CC7\6599\6B04\6E05\55AE, \53EF\8B93\4F7F\7528\8005\5C07\641C\5C0B\9650\5236\5728\7279\5B9A\7684\8CC7\6599\6B04.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109579279447313814)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\5668\4E0B\62C9\5F0F\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109577972815313813)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\91DD\5C0D\6B64\5831\8868\4F7F\7528\5012\6EAF\67E5\8A62.</p>'),
unistr('<p>\5012\6EAF\67E5\8A62\6703\5229\7528\300COracle \5012\6EAF\6280\8853\300D\8207\300C\8CC7\6599\5EAB\6642\9593\9EDE\5FA9\539F\300D\4F86\6AA2\8996\5B58\5728\65BC\5148\524D\6642\9593\9EDE\7684\8CC7\6599. \4F7F\7528\8005\53EA\80FD\67E5\8A62\6B64\8CC7\6599, \4F46\7121\6CD5\5012\8F49\4EFB\4F55\8CC7\6599\8B8A\66F4. \4F7F\7528\8005\53EF\4EE5\9806\5229\57F7\884C\5012\6EAF\67E5\8A62\56DE\5230\591A\4E45\4EE5\524D\7684\6642\9593\9EDE, \53D6\6C7A\65BC Oracle Database \5167\4E0A\6B21\5207\63DB\91CD\505A\65E5\8A8C\6A94\7684\6642\9593, \56E0\70BA\6B64\6280\8853\6703\5229\7528 RMAN \5099\4EFD.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109577842396313813)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5012\6EAF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109577774991313813)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5B9A\7FA9\6B64\5831\8868\7684\7FA4\7D44\4F9D\64DA\660E\7D30.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109577690379313813)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44\4F9D\64DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109515580071313762)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\61C9\8A72\5728\5716\8868\4E0A\6240\5448\73FE\7684\5DE5\5177\63D0\793A\4E2D\986F\793A\7FA4\7D44\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109515473691313762)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\7FA4\7D44\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109578525924313813)
,p_name=>'PE.PROPERTY.SHOW_HELP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\547C\53EB\4E92\52D5\5F0F\5831\8868\7684\5167\5EFA\8AAA\660E\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A.</p>'),
unistr('<p>\8AAA\660E\5C0D\8A71\65B9\584A\53EA\6703\986F\793A\53EF\4F9B\76EE\524D\4F7F\7528\8005\4F7F\7528\7684\9078\9805.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109578459312313813)
,p_name=>'PE.PROPERTY.SHOW_HELP.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109576757850313812)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5B9A\7FA9\6B64\5831\8868\7684\6A19\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109576694224313812)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109900217393314072)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\5716\5C64\76EE\524D\662F\5426\5728\5716\4F8B\4E2D\986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109900199837314072)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109577553821313813)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5B9A\7FA9\6B64\5831\8868\7684\8A02\95B1\8A2D\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109577473302313812)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109568998172313806)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7A7A\503C\8CC7\6599\6B04\7684\986F\793A\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109568866334313806)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\503C\986F\793A\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108877640021313270)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\80FD\5B9A\7FA9\6B64\5831\8868\7684\6A1E\7D10\5206\6790\8868\660E\7D30.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108877537952313270)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A1E\7D10\5206\6790\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109254615488313561)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\70BA\6B64\9801\9762\9805\76EE\986F\793A\5FEB\901F\9078\64C7.'),
unistr('\5FEB\901F\9078\64C7\8B93\4F7F\7528\8005\53EA\8981\6309\4E00\4E0B\5373\53EF\9078\53D6\9810\5148\5B9A\7FA9\7684\503C, \800C\4E0D\9700\8981\9375\5165\6587\5B57\6216\5F9E\53EF\7528\9078\9805\6E05\55AE\4E2D\9078\53D6.</p>'),
unistr('<p><em>\901A\7528</em>\8F38\5165\503C\82E5\6578\76EE\4E0D\591A\4E14\4E0D\9023\7E8C, \5247\53EF\6307\5B9A\5FEB\901F\9078\64C7.'),
unistr('\9805\76EE\6700\591A\53EF\5B9A\7FA9 10 \500B\5FEB\901F\9078\64C7.'),
unistr('\7576\9805\76EE\5177\6709\5197\9577\7684\53EF\7528\503C\9078\53D6\6E05\55AE\6642, \6B64\985E\7684\4F7F\7528\8005\5354\52A9\5C0D\65BC\5B9A\7FA9\9805\76EE\7279\5225\6709\7528.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109254521046313561)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5FEB\901F\9078\64C7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109580197565313814)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\641C\5C0B\5217\4E2D\662F\5426\8981\986F\793A\300C\5831\8868\300D\9078\53D6\6E05\55AE.</p>'),
unistr('<p>\53EA\6709\7576\4F7F\7528\8005\53EF\4EE5\5B58\53D6\4E3B\8981\5831\8868\4EE5\5916\7684\5831\8868\6642, \624D\6703\986F\793A\300C\5831\8868\300D\9078\53D6\6E05\55AE.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109580080625313814)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\9078\53D6\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109578102162313813)
,p_name=>'PE.PROPERTY.SHOW_RESET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5F9E\300C\52D5\4F5C\300D\529F\80FD\8868\91CD\8A2D\5176\5831\8868.</p>'),
unistr('<p>\91CD\8A2D\5831\8868\6703\56DE\5FA9\4F7F\7528\8005\6240\505A\7684\6216\547C\53EB URL \6240\6307\5B9A\7684\4E00\5207\81EA\8A02, \4E26\986F\793A\300C\4E3B\8981\5831\8868\300D.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109578042051313813)
,p_name=>'PE.PROPERTY.SHOW_RESET.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109576115239313811)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\8B8A\66F4\6B64\5831\8868\4E4B\986F\793A\7684\8CC7\6599\5217\6578\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109576012517313811)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\9801\8CC7\6599\5217\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109579732773313814)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\641C\5C0B\5217\5167\662F\5426\8981\5305\62EC\641C\5C0B\6B04\4F4D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109579632928313814)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\6B04\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109575991291313811)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\4F7F\7528\300C\52D5\4F5C\300D\529F\80FD\8868\4E2D\7684<strong>\9078\53D6\8CC7\6599\6B04</strong>\4F86\8B8A\66F4\6B64\5831\8868\4E2D\986F\793A\7684\8CC7\6599\6B04. \4F7F\7528\8005\53EF\4EE5\4F7F\7528\6B64\9078\9805\4F86\9078\53D6 (\6216\986F\793A)\3001\53D6\6D88\9078\53D6 (\6216\96B1\85CF) \53CA\91CD\65B0\6392\5217\591A\500B\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109575849297313811)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109515317295313762)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\61C9\8A72\5728\5716\8868\4E0A\6240\5448\73FE\7684\5DE5\5177\63D0\793A\4E2D\986F\793A\6578\5217\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109515258788313762)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\6578\5217\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109576363615313812)
,p_name=>'PE.PROPERTY.SHOW_SORT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\4E00\822C\4F7F\7528\8005\662F\5426\53EF\4EE5\5B9A\7FA9\6B64\5831\8868\7684\6392\5E8F\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109576206879313811)
,p_name=>'PE.PROPERTY.SHOW_SORT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109280523324313585)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8981\986F\793A\7BE9\9078\689D\4EF6\7684\6A19\7C64, \9084\662F\53EA\986F\793A\300C\5EFA\8B70\5B57\8A5E\300D\7684\503C. \5982\679C\5EFA\8B70\7684\503C\70BA\4E0D\8A00\81EA\660E\7684\5167\5BB9 (\4F8B\5982\8A02\55AE\72C0\614B), \8ACB\96B1\85CF\6B64\6A19\7C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109280478418313585)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109461985639313722)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\5831\8868\4E0A\65B9\986F\793A\5DE5\5177\5217. \5DE5\5177\5217\53EF\80FD\6703\5305\62EC\641C\5C0B\3001\5831\8868\985E\578B\3001\9810\5B58\5831\8868\3001\52D5\4F5C\3001\8B8A\66F4\548C\91CD\8A2D\529F\80FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109461866436313722)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109461757994313722)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\5728\5831\8868\8868\5C3E\4E2D\986F\793A\8CC7\6599\5217\7E3D\6578.<p/>'),
unistr('        <p>\6CE8\610F - \70BA\4E86\53D6\5F97\8CC7\6599\5217\7E3D\6578, \5FC5\9808\57F7\884C\5176\4ED6\67E5\8A62, \56E0\6B64\53EF\80FD\6703\5C0D\6548\80FD\9020\6210\59A8\7919, \7279\5225\662F\6975\5927\578B\7684\8CC7\6599\96C6.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109461636249313722)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\8CC7\6599\5217\7E3D\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109597173481313827)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\91DD\5C0D\300C\7C21\55AE\6838\53D6\65B9\584A\300D\986F\793A\985E\578B, \8ACB\8F38\5165\4E00\500B\503C\6216\5169\500B\4EE5\9017\865F\5340\9694\7684\503C.'),
unistr('\9078\53D6\6838\53D6\65B9\584A\6642, \6703\9001\51FA\7B2C\4E00\500B\503C. \5982\679C\6709\5B9A\7FA9\7B2C\4E8C\500B\503C, \5247\6703\5728\53D6\6D88\9078\53D6\6838\53D6\65B9\584A\6642\9001\51FA\8A72\503C.'),
'        p_examples           => q''~<dl>',
unistr('<dt>\9078\53D6\6642\6703\9001\51FA Yes, \53D6\6D88\9078\53D6\6642\6703\9001\51FA No.</dt>'),
'<dd><pre>',
'Yes,No',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109597016462313827)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6838\53D6\65B9\584A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109563451054313802)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5728\300C\55AE\4E00\8CC7\6599\5217\6AA2\8996\300D\4E2D\4F7F\7528\7684\8CC7\6599\6B04\6A19\7C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109563367489313802)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109605052912313836)
,p_name=>'PE.PROPERTY.SORT_NULLS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\65BC\555F\7528\8CC7\6599\6B04\6A19\984C\6392\5E8F\529F\80FD\7684\5831\8868\8CC7\6599\6B04, \8ACB\9078\53D6\542B\7A7A\503C\4E4B\8A18\9304\76F8\5C0D\65BC\4E0D\542B\7A7A\503C\4E4B\8A18\9304\7684\6392\5E8F\65B9\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109784682489313987)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109784709203313987)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\503C\7684\8A18\9304\5C07\986F\793A\5728\4EFB\4F55\975E\7A7A\503C\8CC7\6599\6B04\4E4B\524D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109784879458313987)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109784922810313987)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975E\7A7A\503C\7684\8A18\9304\5C07\986F\793A\5728\4EFB\4F55\7A7A\503C\8CC7\6599\6B04\4E4B\524D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109604954164313836)
,p_name=>'PE.PROPERTY.SORT_NULLS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5E8F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108878351595313270)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8207\6B64\9801\9762\95DC\806F\7684\5C0E\89BD\8DEF\5F91\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108878201059313270)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110110812619314241)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8F38\5165\4F5C\70BA\6B64\9762\5411\4F86\6E90\7684\8CC7\6599\5EAB\8CC7\6599\6B04\540D\7A31 (\5340\5206\5927\5C0F\5BEB).</p>')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109919278982314085)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8F38\5165\4F5C\70BA\6B64\9762\5411\4F86\6E90\7684\8CC7\6599\5EAB\8CC7\6599\6B04\540D\7A31 (\5340\5206\5927\5C0F\5BEB).</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109282543466313586)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8F38\5165\4F5C\70BA\6B64\7BE9\9078\4F86\6E90\7684\8CC7\6599\5EAB\8CC7\6599\6B04\540D\7A31 (\5340\5206\5927\5C0F\5BEB).</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109283614581313587)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8F38\5165\4F5C\70BA\6B64\7BE9\9078\4F86\6E90\7684\8CC7\6599\5EAB\8CC7\6599\6B04\540D\7A31 (\5340\5206\5927\5C0F\5BEB).</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109253426653313560)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\5340\5206\5927\5C0F\5BEB\7684\8CC7\6599\5EAB\8CC7\6599\6B04\540D\7A31, \4F5C\70BA\6B64\9805\76EE\503C\7684\4F86\6E90.</p>'),
unistr('<p>\6B64\8CC7\6599\6B04\5FC5\9808\5B58\5728\65BC\6B64\9801\9762\6240\5B9A\7FA9\4E4B\5167\5EFA\64F7\53D6\8CC7\6599\5217\8655\7406\4F5C\696D\4E2D\6307\5B9A\7684\8868\683C.'),
unistr('\82E5\8CC7\6599\5EAB\8CC7\6599\6B04\540D\7A31\4E0D\5B58\5728\65BC\53C3\7167\7684\8868\683C\4E2D, \5247\6703\767C\751F\932F\8AA4\4E14\4E0D\6703\8F09\5165\9801\9762.'),
unistr('\540C\6A23\5730, \82E5\672A\5B9A\7FA9\5167\5EFA\64F7\53D6\8CC7\6599\5217\8655\7406\4F5C\696D, \4E14\6709<strong>\8CC7\6599\5EAB\8CC7\6599\6B04</strong>\4F86\6E90\985E\578B\7684\9805\76EE, \5247\6703\767C\751F\932F\8AA4, \4E14\5617\8A66\5448\73FE\9801\9762\6642\4E0D\6703\8F09\5165\9801\9762.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109253325466313560)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109991814711314138)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\8A55\4F30\6240\8F38\5165\8868\793A\5F0F\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109992239886314138)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109992136323314138)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109992057067314138)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109992369001314138)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109991943215314138)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109991713271314138)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109689796982313910)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8207\6B64\300C\591A\9762\5411\641C\5C0B\300D\6216\300C\667A\6167\578B\7BE9\9078\689D\4EF6\300D\5340\57DF\95DC\806F\7684\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109689625332313910)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078\7684\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109993828757314139)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\51FD\6578\4E3B\9AD4\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109994159784314139)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109994087085314139)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109993978165314139)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109994268224314139)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109993706146314139)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109253258858313560)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4F5C\70BA\6B64\9805\76EE\503C\4F86\6E90\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\5F9E\53EF\7528\9805\76EE\7684\6E05\55AE\4E2D\6311\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109253175109313560)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110022623427314159)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\57F7\884C\7684 Java \7A0B\5F0F\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110022561978314159)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109993486886314139)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\7522\751F\503C\4F5C\70BA\6B64\9805\76EE\503C\4F86\6E90\7684 Java \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109993332154314139)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109995001515314140)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\50B3\56DE\503C\4F5C\70BA\6B64\9805\76EE\503C\4F86\6E90\7684 Java \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109994967691314140)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110022414785314159)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\70BA\7B26\5408\52A0\85AA\8CC7\683C\7684\54E1\5DE5\63D0\9AD8 3% \7684\85AA\8CC7:</dt>'),
'<dd><pre>',
'var rows;',
'',
'function needsSalaryRaise( empno ) {',
unistr('    // \7528\65BC\8A08\7B97\54E1\5DE5\662F\5426\9700\8981\52A0\85AA\7684\8907\96DC\908F\8F2F\9810\7559\4F4D\7F6E'),
'    return true;',
'}',
'',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'    if ( needsSalaryRaise( row.EMPNO )) {',
'      apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'    }',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110022383496314159)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\57F7\884C\7684 JavaScript \7A0B\5F0F\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110022222188314159)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109993213037314139)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1\5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109993199771314139)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\7522\751F\503C\4F5C\70BA\6B64\9805\76EE\503C\4F86\6E90\7684 JavaScript \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109993055675314139)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109994826510314140)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109994769090314140)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\50B3\56DE\503C\4F5C\70BA\6B64\9805\76EE\503C\4F86\6E90\7684 JavaScript \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109994658619314140)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108878101958313270)
,p_name=>'PE.PROPERTY.SOURCE_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\6E05\55AE\7684\4F86\6E90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108878035945313270)
,p_name=>'PE.PROPERTY.SOURCE_LIST.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109335734499313626)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8CC7\6599\7684\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109335898127313627)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672C\6A5F\8CC7\6599\5EAB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109335903332313627)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6E90\81EA\672C\6A5F\8CC7\6599\5EAB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109336099735313627)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528 REST \7684 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109336115446313627)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6E90\81EA\9023\7DDA\4F7F\7528\300C\555F\7528 REST \7684 SQL\300D\5B9A\7FA9\7684\9060\7AEF\8CC7\6599\5EAB. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109446279256313711)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110052881556314180)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\4F7F\7528 REST \8CC7\6599\4F86\6E90\5B9A\7FA9\7684 RESTful Web \670D\52D9\53D6\5F97\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109335661705313626)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109531498384313774)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4E0D\540C\7684\8981\6C42\5728\8B80\53D6\5716\8868\8CC7\6599\6642, \76EE\524D\9801\9762\4E2D\8981\8A2D\5B9A\81F3\968E\6BB5\4F5C\696D\72C0\614B\4E2D\7684\9801\9762\9805\76EE\6E05\55AE (\4EE5\9017\865F\5340\9694).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109898981137314071)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\76EE\524D\9801\9762\4E2D\7684\9801\9762\9805\76EE\6E05\55AE (\4EE5\9017\865F\5340\9694), \4EE5\4E0D\540C\7684\8981\6C42\64F7\53D6\5730\5716\8CC7\6599\6642, \6703\5C07\9019\4E9B\9805\76EE\8A2D\5B9A\81F3\968E\6BB5\4F5C\696D\72C0\614B\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109328607140313621)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\900F\904E\91CD\65B0\6574\7406\90E8\5206\9801\9762\4F86\91CD\65B0\6574\7406\5340\57DF\6642, \8981\8A2D\5B9A\81F3\968E\6BB5\4F5C\696D\72C0\614B\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.'),
unistr('\5982\679C\6709\591A\500B\9805\76EE, \8ACB\4EE5\9017\865F\5340\9694\6BCF\500B\9805\76EE\540D\7A31.'),
unistr('\60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\7684\6E05\55AE\4E2D\9078\64C7.'),
unistr('\5982\679C\5F9E\6E05\55AE\4E2D\9078\64C7\800C\53C8\5DF2\7D93\6709\8F38\5165\7684\6587\5B57, \7CFB\7D71\5C31\6703\5728\73FE\6709\6587\5B57\7684\7D50\5C3E\52A0\4E0A\9017\865F, \5F8C\9762\63A5\8457\5F9E\6E05\55AE\50B3\56DE\7684\9805\76EE\540D\7A31.</p>'),
unistr('<p>\60A8\53EF\4EE5\5728\9032\884C\5206\9801\6642 (\5982\679C<em>\555F\7528\91CD\65B0\6574\7406\90E8\5206\9801\9762</em>\8A2D\70BA<strong>\958B\555F</strong>), \6216\662F\4F7F\7528\300C\52D5\614B\52D5\4F5C\300D\4E2D\7684\300C\91CD\65B0\6574\7406\300D\52D5\4F5C, \900F\904E\91CD\65B0\6574\7406\90E8\5206\9801\9762\4F86\91CD\65B0\6574\7406\5340\57DF.</p>'),
unistr('\7136\5F8C\53EF\4EE5\5728\300C\5340\57DF\4F86\6E90\300DSQL \67E5\8A62\7684 <em>where \689D\4EF6</em>\4E2D\4F7F\7528\9019\4E9B\9801\9762\9805\76EE\4F86\9650\5236\67E5\8A62\7D50\679C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109328598426313621)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\9001\51FA\7684\9801\9762\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110022102157314159)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\70BA\7B26\5408\52A0\85AA\8CC7\683C\7684\54E1\5DE5\63D0\9AD8 3% \7684\85AA\8CC7:</dt>'),
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110022070649314159)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\57F7\884C\7684 PL/SQL \7A0B\5F0F\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110021937617314159)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109992940497314138)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1\5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109992809752314138)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\7522\751F\503C\4F5C\70BA\6B64\9805\76EE\503C\4F86\6E90\7684 PL/SQL \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109992751498314138)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109994548444314140)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109994407513314140)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\50B3\56DE\503C\4F5C\70BA\6B64\9805\76EE\503C\4F86\6E90\7684 PL/SQL \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109994390837314139)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110058118773314184)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\64F7\53D6\81F3\672C\6A5F\8CC7\6599\5EAB\4E2D\4E4B REST \4F86\6E90\8CC7\6599\7684\5F8C\7E8C\8655\7406\65B9\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110058664169314184)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110058759603314185)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165 PL/SQL \51FD\6578\4E3B\9AD4, \5176\4E2D\50B3\56DE\7684 SQL \67E5\8A62\5C07\8F49\63DB\6240\64F7\53D6\7684\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110058404958314184)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110058586302314184)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7528\4EE5\8F49\63DB\64F7\53D6\4E4B\8CC7\6599\7684 SQL \67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110058273734314184)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Where/Order By \5B50\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110058396955314184)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\52A0\4EE5\9650\5236\7684 where \548C (\6216) order by \5B50\53E5\4E26\6392\5217\64F7\53D6\7684\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110058071674314184)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109253688152313560)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4F5C\70BA\6B64\9805\76EE\503C\4F86\6E90\7684\300C\4F7F\7528\8005\504F\597D\8A2D\5B9A\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109253558460313560)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110022824720314159)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\57F7\884C\7684 Python \7A0B\5F0F\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110022756552314159)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109993613439314139)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\7522\751F\503C\4F5C\70BA\6B64\9805\76EE\503C\4F86\6E90\7684 Python \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109993541628314139)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109995259107314140)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\50B3\56DE\503C\4F5C\70BA\6B64\9805\76EE\503C\4F86\6E90\7684 Python \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109995180216314140)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109252834736313560)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4F5C\70BA\6B64\9805\76EE\503C\4F86\6E90\7684 SQL \67E5\8A62. \82E5\50B3\56DE\4E00\500B\4EE5\4E0A\7684\8CC7\6599\5217, \5247\6703\4F7F\7528\7B2C\4E00\500B\8CC7\6599\5217\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109252709562313559)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109253053989313560)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\4E00\6216\591A\500B\8CC7\6599\5217\4F5C\70BA\6B64\9805\76EE\503C\4F86\6E90\7684 SQL \67E5\8A62. \82E5\7D50\679C\5305\542B\591A\500B\8CC7\6599\5217, \5247\6BCF\500B\8CC7\6599\5217\7684\503C\6703\5F62\6210\4EE5\55AE\4E00\5192\865F\5340\9694\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109252973164313560)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110002241955314145)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\51FD\6578\4E3B\9AD4\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110002549023314145)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110002434021314145)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110002370882314145)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110002687153314145)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110002173822314145)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110003480949314146)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\5716\8868\6578\5217\4E4B SQL \67E5\8A62\7684 Java \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110003338127314146)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 Java \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110003278185314146)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\9078\53D6 EMPNO\3001ENAME \4EE5\53CA SAL \8CC7\6599\6B04, \4E26\7BE9\9664 SAL \5C0F\65BC 3000 \7684\6240\6709\8CC7\6599\5217.</dt>'),
'<dd><pre>',
'return "select EMPNO, ENAME, SAL from EMP where SAL < 3000";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110003154697314146)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\5716\8868\6578\5217\4E4B SQL \67E5\8A62\7684 JavaScript \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110003034649314146)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 JavaScript \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109334245973313625)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5C07\6700\65B0\50F1\7528\7684\986F\793A\5728\6700\524D\9762, \5C1A\672A\50F1\7528\7684\6392\5728\6700\5F8C\9762. \5982\679C\65E5\671F\76F8\7B49, \5247\4F9D\90E8\9580\7DE8\865F\6392\5E8F.</dt>'),
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109334142887313625)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\4E00\6216\591A\500B\4EE5\9017\865F\5340\9694\7684\8CC7\6599\6B04\540D\7A31 (\5305\62EC\6307\4EE4), \4EE5\5B9A\7FA9\8A18\9304\7684\64F7\53D6\9806\5E8F.</p>'),
unistr('        <p>\6307\4EE4\5305\62EC:'),
'          <ul>',
unistr('            <li>ASC - \4EE5\905E\589E\9806\5E8F\50B3\56DE\8CC7\6599\6B04</li>'),
unistr('            <li>DESC - \4EE5\905E\6E1B\9806\5E8F\50B3\56DE\8CC7\6599\6B04</li>'),
unistr('            <li>NULLS FIRST - \5148\50B3\56DE\6C92\6709\503C\7684\8CC7\6599\6B04, \518D\50B3\56DE\542B\6709\503C\7684\8CC7\6599\6B04</li>'),
unistr('            <li>NULLS LAST - \5148\50B3\56DE\542B\6709\503C\7684\8CC7\6599\6B04, \518D\50B3\56DE\6C92\6709\503C\7684\8CC7\6599\6B04</li>'),
'          </ul>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109334046113313625)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5217\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109333471395313625)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\64C1\6709\8868\683C\7684\7DB1\8981.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109333383697313625)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109446837640313711)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578, \4EE5\4F5C\70BA\6B64\5340\57DF\7684\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109446758883313711)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110002914569314145)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\9078\53D6 EMPNO\3001ENAME \4EE5\53CA SAL \8CC7\6599\6B04, \4E26\7BE9\9664 SAL \5C0F\65BC 3000 \7684\6240\6709\8CC7\6599\5217.</dt>'),
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from EMP where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110002811933314145)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\5716\8868\6578\5217\4E4B SQL \67E5\8A62\7684 PL/SQL \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110002738828314145)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110003605507314146)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\5716\8868\6578\5217\4E4B SQL \67E5\8A62\7684 Python \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110003560926314146)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684 Python \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109333626262313625)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6709\5927\5C0F\5BEB\4E4B\5225\7684\8868\683C\6216\8996\89C0\8868\540D\7A31. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109333570240313625)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109333070915313624)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8CC7\6599\7684\67E5\8A62\65B9\5F0F.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109446399989313711)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684\51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109446430742313711)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\57F7\884C\51FD\6578\4E3B\9AD4\6240\50B3\56DE\7684\300CSQL \67E5\8A62\300D\64F7\53D6\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109336294485313627)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109336357263313627)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6703\6839\64DA SQL \67E5\8A62\64F7\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109333144608313624)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C/\8996\89C0\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109333214378313625)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6703\6839\64DA\8868\683C\6216\8996\89C0\8868\64F7\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109332928173313624)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109333905167313625)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\53EA\5305\62EC\6709\7D93\7406\6216\5F9E\4E8B\696D\52D9\4EBA\54E1\5DE5\4F5C\7684\54E1\5DE5.</dt>'),
'<dd><pre>',
'( MGR is not null or JOB = ''SALESMAN'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109333814473313625)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7528\4EE5\9650\5236\64F7\53D6\4E4B\8A18\9304\7684\6709\6548 SQL where \689D\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109333750662313625)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Where \5B50\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109332854796313624)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\9060\7AEF\8CC7\6599\5EAB\4F3A\670D\5668.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109332756230313624)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9060\7AEF\4F3A\670D\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110021496979314158)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\7A0B\5F0F\78BC\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110021760317314159)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110021657600314159)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110021549296314159)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110021840795314159)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110021334432314158)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109647098566313867)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\82E5\8981\5C07\5169\500B\8CC7\6599\6B04\4E32\63A5\5728\4E00\8D77:</dt>'),
'<dd><pre>',
'FIRSTNAME || '' '' || LASTNAME',
'</pre></dd>',
unistr('<dt>\5305\542B\5167\90E8\9078\53D6:</dt>'),
'<dd><pre>',
'(select count(*) from emp e where e.deptno = DEPTNO)',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109471363507313729)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165 SQL \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109471204014313729)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109992624504314138)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\70BA\4E3B\7BA1\4E14\5176\90E8\9580\4F4D\65BC\829D\52A0\54E5\5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109992528779314138)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\7522\751F\503C\4F5C\70BA\6B64\9805\76EE\503C\4F86\6E90\7684 SQL \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109992422208314138)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109901192840314072)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.COMPONENT_PROPERTY.MAP_LAYER.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5\4E0B\67E5\8A62\50B3\56DE\7D93\5EA6\548C\7DEF\5EA6\503C\4F5C\70BA NUMBER \8CC7\6599\6B04:</p>'),
'<pre>',
'select lon,',
'       lat,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre>',
unistr('<p>\4EE5\4E0B\67E5\8A62\50B3\56DE\5BA2\6236\6240\5728\5730\9EDE\4F5C\70BA SDO_GEOMETRY \8CC7\6599\6B04:</p>'),
'<pre>',
'select cust_location,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109334420407313625)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\5143\4EF6\7684 SQL \4F86\6E90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109334307436313625)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109252675580313559)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4F5C\70BA\6B64\9805\76EE\503C\4F86\6E90\7684\975C\614B\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109252501628313559)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109252413189313559)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\6B64\9805\76EE\503C\4F5C\70BA\4F9D\64DA\7684\4F86\6E90\985E\578B.</p>'),
unistr('<p>\6CE8\610F: <strong>\4F86\6E90: \5DF2\4F7F\7528</strong>\82E5\8A2D\70BA<em>\53EA\6709\7576\968E\6BB5\4F5C\696D\72C0\614B\7684\76EE\524D\503C\662F\7A7A\503C\6642</em>, \5982\679C\6B64\9805\76EE\5DF2\6709\8A2D\5B9A\7684\968E\6BB5\4F5C\696D\72C0\614B\503C, \5C31\4E0D\6703\4F7F\7528\8A72\4F86\6E90.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109755575990313965)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109950888848314108)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6307\5B9A\503C, \56E0\6B64\8A2D\662F\7A7A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109755731841313965)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109950281941314108)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5728<em>\8CC7\6599\5EAB\8CC7\6599\6B04</em>\4E2D\8F38\5165\7684\8CC7\6599\6B04\503C, \8A72\503C\5F9E\5167\5EFA\64F7\53D6\8CC7\6599\5217\8655\7406\4F5C\696D\4E2D\64F7\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109971530190314123)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109971624795314123)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\57F7\884C\8F38\5165\4E4B<em>\8868\793A\5F0F</em>\7684\7D50\679C\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109756077563313965)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109950676752314108)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B<em>\51FD\6578\4E3B\9AD4</em>\50B3\56DE\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109756100207313965)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109950389765314108)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\9078\53D6<em>\9805\76EE</em>\4E4B\968E\6BB5\4F5C\696D\72C0\614B\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109756257156313965)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109950753055314108)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\8F38\5165\7684<em>\504F\597D\8A2D\5B9A</em>\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109755818758313965)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62 (\50B3\56DE\55AE\4E00\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109950415297314108)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B <em>SQL \67E5\8A62</em>\50B3\56DE\7684\7B2C\4E00\500B\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109755983176313965)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62 (\50B3\56DE\4F7F\7528\5192\865F\5340\9694\7684\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109950526498314108)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B <em>SQL \67E5\8A62</em>\50B3\56DE\7684\55AE\4E00\503C (\4F7F\7528\55AE\4E00\5192\865F\5340\9694), \8A72\503C\6703\4E32\63A5\5404\8CC7\6599\5217\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109755627050313965)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109950144184314108)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5728<em>\975C\614B\503C</em>\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109252363362313559)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109252226548313559)
,p_name=>'PE.PROPERTY.SOURCE_USED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\5F9E\968E\6BB5\4F5C\696D\72C0\614B\5FEB\53D6\4E4B\503C\8207\9805\76EE\4F86\6E90\503C\7684\512A\5148\9806\5E8F.</p>'),
unistr('<p>\5C0D\65BC\4F86\6E90\985E\578B\70BA<strong>\8CC7\6599\5EAB\8CC7\6599\6B04</strong>\7684\9805\76EE, \9664\975E\4E0D\8981\5728\9801\9762\662F\672C\8EAB\7684\5206\652F\9801\9762\6642, \8B93\76F8\95DC\806F\7684\8CC7\6599\5217\64F7\53D6\4F5C\696D\7522\751F\9805\76EE, \5426\5247\8ACB\9078\53D6<strong>\6C38\9060, \53D6\4EE3\968E\6BB5\4F5C\696D\4E2D\4EFB\4F55\73FE\6709\7684\503C</strong>.'),
unistr('\5C0D\65BC\5176\4ED6\4F86\6E90\985E\578B, \60A8\5FC5\9808\6839\64DA\9801\9762\7684\4F7F\7528\65B9\5F0F, \6C7A\5B9A\662F\8981\986F\793A\5148\524D\7684\4F86\6E90\503C, \6216\8005\70BA\6BCF\500B\9801\9762\6AA2\8996\91CD\65B0\5957\7528\4F86\6E90\985E\578B.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109755327618313965)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.NO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C38\9060, \53D6\4EE3\968E\6BB5\4F5C\696D\4E2D\4EFB\4F55\73FE\6709\7684\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109755402854313965)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.YES.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\6709\7576\968E\6BB5\4F5C\696D\72C0\614B\7684\76EE\524D\503C\662F\7A7A\503C\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109252124802313559)
,p_name=>'PE.PROPERTY.SOURCE_USED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109446651400313711)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\652F\63F4\64F7\53D6\96C6\5408\7684 REST \8CC7\6599\4F86\6E90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109446538624313711)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109531243048313774)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5206\5272\7684\96D9 Y \5716\4E2D, \6307\5B9A\63D0\4F9B\7D66 Y \8EF8\5B50\5716\7A7A\9593\7684\6BD4\4F8B. \6709\6548\503C\662F 0 \5230 1 \7684\6578\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109531196471313774)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\5272\5668\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109530778742313774)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\5C07\7E6A\5716\5340\5206\5272\6210\5169\500B\5340\6BB5, \8B93\6307\5B9A\7D66\4E0D\540C Y \8EF8\7684\8CC7\6599\7D44\51FA\73FE\5728\7E6A\5716\5340\7684\4E0D\540C\90E8\5206\4E2D. \80A1\7968\5206\6790\5716\4E0D\652F\63F4<strong>\5426</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109530844008313774)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.AUTO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109531083391313774)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.OFF.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109530944924313774)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.ON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109530697683313773)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109507917353313756)
,p_name=>'PE.PROPERTY.STACK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6307\5B9A\662F\5426\5C0D\8CC7\6599\9805\76EE\9032\884C\5806\758A\8655\7406.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109507882392313756)
,p_name=>'PE.PROPERTY.STACK.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5806\758A\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109132064876313469)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7D66\6B64\6578\5217\7684\5806\758A\985E\5225\540D\7A31. \4F9D\7167\9810\8A2D\503C, \6240\6709\6578\5217\90FD\6703\5408\4F75\5728\76F8\540C\7684\5806\758A. \82E5\8981\5C07\6B64\6578\5217\653E\5728\4E0D\540C\7684\5806\758A\4E2D, \8ACB\8A2D\5B9A\5806\758A\985E\5225. \60A8\53EF\4EE5\4F7F\7528 <code>&COLUMN_VALUE.</code> \66FF\4EE3\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109131923068313469)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5806\758A\985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109131844046313469)
,p_name=>'PE.PROPERTY.STACK_LABEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6307\5B9A\662F\5426\61C9\986F\793A\5806\758A\8CC7\6599\9805\76EE\7684\7E3D\8A08\503C. \50C5\9069\7528\65BC\9577\689D\5716.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109131786517313469)
,p_name=>'PE.PROPERTY.STACK_LABEL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5806\758A\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109232665337313544)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\9801\9762\8981\4F7F\7528\7684\6A19\6E96\9801\7C64\96C6. \6A19\6E96\9801\7C64\96C6\8207\7279\5B9A\7684\9801\78BC\95DC\806F. \60A8\53EF\4EE5\4F7F\7528\6A19\6E96\9801\7C64, \5C07\4F7F\7528\8005\9023\7D50\81F3\7279\5B9A\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109232572439313544)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\6E96\9801\7C64\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109630781743313855)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\9031\884C\4E8B\66C6\986F\793A\4E4B\4E00\9031\7684\7B2C\4E00\5929.'),
unistr('\60A8\53EF\4EE5\5C07\6B64\5C6C\6027\8207<strong>\7D50\675F\65E5</strong>\5408\7528, \4EE5\9650\5236\986F\793A\7684\4E00\9031\5929\6B21, \6216\8005\53EA\6307\5B9A\986F\793A\4E4B\4E00\9031\7684\7B2C\4E00\5929.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109789556326313991)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109789653150313991)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\4E00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109789755833313991)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\4E8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109789851071313991)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\4E09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109789970383313991)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\56DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109790093602313991)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\4E94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109790189228313991)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\516D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109630689606313855)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109630500224313855)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C7A\5B9A\6708\884C\4E8B\66C6\8981\5F9E\661F\671F\5E7E\958B\59CB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109788870462313990)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109788976321313990)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\4E00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109789077904313990)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\4E8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109789108714313990)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\4E09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109789225228313990)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\56DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109789302477313990)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\4E94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109789428561313990)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\661F\671F\516D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109630437297313855)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109631331483313856)
,p_name=>'PE.PROPERTY.START_TIME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\4F5C\70BA\9031\548C\65E5\884C\4E8B\66C6\4E4B\986F\793A\7126\9EDE\7684\958B\59CB\5C0F\6642.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109631283765313856)
,p_name=>'PE.PROPERTY.START_TIME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109261007933313566)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\6B64\52D5\614B\52D5\4F5C\4F7F\7528\7684 jQuery \9078\53D6\5668\975C\614B\5BB9\5668.'),
unistr('\60A8\53EF\4EE5\6539\5584\4E8B\4EF6\7BC4\570D\70BA<strong>\52D5\614B</strong>\4E4B\52D5\614B\52D5\4F5C\7684\6548\80FD.'),
unistr('\9019\5FC5\9808\662F\9801\9762\4E0A\7684\5143\7D20, \5143\7D20\672C\8EAB\4E0D\6703\91CD\65B0\5EFA\7ACB, \4F46\5305\542B\4F7F\7528\300C\91CD\65B0\6574\7406\90E8\5206\9801\9762 (PPR)\300D\91CD\65B0\5EFA\7ACB\7684\89F8\767C\5143\7D20.'),
unistr('\6B64\5143\7D20\53C3\7167\5FC5\9808\5B9A\7FA9\70BA jQuery \9078\53D6\5668.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109260962101313565)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\5BB9\5668 (jQuery \9078\53D6\5668)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109271280309313573)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\6309\9215\7684\975C\614B ID. \5982\679C\5B9A\7FA9, \6B64\975C\614B ID \5C07\4F5C\70BA\6309\9215\7684 ID. \975C\614B ID \5728\958B\767C\6309\9215\7684\81EA\8A02 JavaScript \884C\70BA\6642\975E\5E38\6709\7528. \5982\679C\672A\5B9A\7FA9\975C\614B ID, \6309\9215\5C07\6703\7522\751F\5167\90E8 ID.</p>'),
unistr('<p>\6CE8\610F: \6A23\677F\5FC5\9808\5305\62EC <code>#BUTTON_ID#</code> \66FF\4EE3\5B57\4E32, \624D\80FD\8B93\6309\9215\4F7F\7528\8F38\5165\7684\975C\614B ID.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109475453514313732)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8CC7\6599\6B04\7684\975C\614B ID. \975C\614B ID \5728\958B\767C\81EA\8A02 JavaScript \884C\70BA\6216\8CC7\6599\6B04\9805\76EE\7684\81EA\8A02\6A23\5F0F\6642\975E\5E38\5BE6\7528. \82E5\672A\5B9A\7FA9\975C\614B ID, \6703\4F7F\7528\5167\90E8 ID \4F5C\70BA\8CC7\6599\6B04\9805\76EE ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110152620134314274)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.IR_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8CC7\6599\6B04\7684\975C\614B ID. \5982\679C\5B9A\7FA9, \6B64\975C\614B ID \5C07\4F5C\70BA\5C0D\61C9\7684\8868\683C\6A19\982D (TH) \5132\5B58\683C ID, \4E14\4F5C\70BA\5C0D\61C9\7684\8868\683C\8CC7\6599 (TD) \5132\5B58\683C\7684 HEADERS \503C. \975C\614B ID \5728\958B\767C\81EA\8A02 JavaScript \884C\70BA\6216\8CC7\6599\6B04\7684\81EA\8A02\6A23\5F0F\6642\975E\5E38\6709\7528. \5982\679C\672A\5B9A\7FA9\975C\614B ID, \8868\683C\6703\7522\751F\9019\4E9B\5C6C\6027\503C\7684\5167\90E8 ID.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109531674545313774)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5716\8868\5EA7\6A19\8EF8\7684\975C\614B ID. \958B\767C\5716\8868\5EA7\6A19\8EF8\7684\81EA\8A02 JavaScript \884C\70BA\6642, \975C\614B ID \5341\5206\6709\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109531539280313774)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5716\8868\6578\5217\7684\975C\614B ID. \958B\767C\5716\8868\6578\5217\7684\81EA\8A02 JavaScript \884C\70BA\6642, \975C\614B ID \5341\5206\6709\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109330335014313622)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\5340\57DF\7684\975C\614B ID. \5982\679C\5DF2\5B9A\7FA9\6B64 ID, \5C07\6703\900F\904E <code>#REGION_STATIC_ID#</code> \66FF\4EE3\5B57\4E32\4F7F\7528\5B83\4F5C\70BA\5340\57DF\7684 ID; \70BA\5340\57DF\958B\767C\81EA\8A02 JavaScript \884C\70BA\6642, \9019\6703\76F8\7576\6709\7528. \5982\679C\672A\5B9A\7FA9\6B64 ID, \5340\57DF\5C07\6703\7522\751F\5167\90E8 ID.</p>'),
unistr('<p>\6CE8\610F: \6A23\677F\5FC5\9808\5305\62EC <code>#REGION_STATIC_ID#</code> \66FF\4EE3\5B57\4E32, \5340\57DF\624D\80FD\4F7F\7528\6240\8F38\5165\7684\975C\614B ID.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109260636326313565)
,p_name=>'PE.PROPERTY.STATIC_ID.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\5143\4EF6\7684\975C\614B ID. \5B9A\7FA9\6B64 ID \5C0D\958B\767C\5143\4EF6\7684\81EA\8A02 JavaScript \884C\70BA\5341\5206\6709\7528.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109260592679313565)
,p_name=>'PE.PROPERTY.STATIC_ID.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109542943960313783)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\5957\7528\81F3\6240\5448\73FE\80A1\7968\5206\6790\5716\7684\6578\5217\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109543070790313783)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.AREA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109543179509313783)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.BAR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\689D\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109543290177313783)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.CANDLESTICK.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('K \7DDA\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109543300760313783)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6298\7DDA\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109543410241313783)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINEWITHAREA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6298\7DDA\5340\57DF\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109542822456313782)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE\70BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109263032715313567)
,p_name=>'PE.PROPERTY.STOP_EXECUTION_ON_ERROR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\57F7\884C\76EE\524D\52D5\4F5C\6642\82E5\767C\751F\932F\8AA4, \662F\5426\505C\6B62\8655\7406\5176\4ED6\7684\6240\6709\64F1\7F6E\4E2D\52D5\4F5C.</p>'),
unistr('<p>\6CE8\610F: \7279\5B9A\52D5\4F5C\7684\57F7\884C\9806\5E8F\7531\6BCF\500B\52D5\4F5C\88AB\6307\5B9A\7684\9806\5E8F\6240\6C7A\5B9A. \82E5\8981\78BA\4FDD\4EE5\76F8\540C\9806\5E8F\57F7\884C\52D5\4F5C, Oracle \5EFA\8B70\6240\6709\300CTrue \52D5\4F5C\300D\8207\6240\6709\300CFalse \52D5\4F5C\300D\90FD\5FC5\9808\6709\552F\4E00\7684\5E8F\865F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109262951595313567)
,p_name=>'PE.PROPERTY.STOP_EXECUTION_ON_ERROR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767C\751F\932F\8AA4\6642\505C\6B62\57F7\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109340259613313630)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\5831\8868\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109340368048313630)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\5C07\4F7F\7528\4E00\822C\4F7F\7528\8005\8A2D\5B9A\7684<strong>\5EF6\4F38</strong>\5831\8868\8A2D\5B9A\4F86\5B9A\7FA9\662F\5426\5EF6\4F38\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109339745410313629)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5BE6\969B\756B\9762\8DB3\5920\6642\662F\5426\5EF6\4F38\8CC7\6599\6B04. ')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109340076528313630)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\5EF6\4F38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109340134007313630)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\8AD6\4E00\822C\4F7F\7528\8005\8A2D\5B9A\7684<strong>\5EF6\4F38</strong>\5831\8868\8A2D\5B9A\70BA\4F55, \5C07\4E00\5F8B\5EF6\4F38\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109339835529313629)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\5F8B\4E0D\5EF6\4F38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109339991877313630)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4E0D\6703\5EF6\4F38\8CC7\6599\6B04, \4E26\4E14\4E00\5F8B\4F7F\7528\6307\5B9A\7684\5BEC\5EA6. \6B64\9078\9805\5C0D\65BC\53EA\6709\7C21\77ED\5167\5BB9 (\4F8B\5982\662F/\5426\6216\6578\5B57) \7684\8CC7\6599\6B04\975E\5E38\6709\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109339604738313629)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EF6\4F38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109604836184313836)
,p_name=>'PE.PROPERTY.STRIP_HTML.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\8981\5F9E\539F\59CB\8CC7\6599\6B04\503C\79FB\9664 HTML \6A19\8A18.'),
unistr('\9019\5C0D\65BC\4F7F\7528 HTML \8868\793A\5F0F\3001\5728\8CC7\6599\6B04\9023\7D50\4E2D\4F7F\7528\6216\532F\51FA\6210 CSV \6A94\6848\7684\8CC7\6599\6B04\4F86\8AAA, \7279\5225\91CD\8981.</p>'),
unistr('<p>\5982\679C\60A8\662F\5F9E\5DF2\7D93\5305\542B HTML \6A19\8A18\7684\8CC7\6599\5EAB\9078\53D6\503C, \5247\90A3\4E9B\6A19\8A18\53EF\80FD\6703\5C0E\81F4\8207\91DD\5C0D\60A8\7684 HTML \8868\793A\5F0F\7522\751F\7684 HTML \6216\91DD\5C0D\8CC7\6599\6B04\9023\7D50\7522\751F\7684 URL \767C\751F\885D\7A81.'),
unistr('\532F\51FA\9019\985E\503C\6642, \73FE\6709\7684 HTML \6A19\8A18\6703\4EE5\7D14\6587\5B57\7684\5F62\5F0F\5305\62EC\5728\7522\751F\7684 CSV \6A94\6848\4E2D.'),
unistr('\5982\679C\555F\7528\6B64\9078\9805, \5C07\53EA\6703\4F7F\7528\60A8\8CC7\6599\6B04\503C\7684\5BE6\969B\8CC7\6599\90E8\5206.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109604743911313836)
,p_name=>'PE.PROPERTY.STRIP_HTML.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664 HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109460588340313721)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\9801\9762\8655\7406 (\4E00\822C\662F\900F\904E\81EA\8A02\6309\9215\6240\8D77\59CB (\4F8B\5982<strong>\6A19\793A\70BA\5DF2\5B8C\6210</strong>)) \6642\662F\5426\8981\7D0D\5165\5DF2\52FE\9078\7684\8CC7\6599\5217.'),
unistr('        \9019\4E9B\5DF2\52FE\9078\7684\8CC7\6599\5217\4E4B\5F8C\53EF\4EE5\7528\65BC\81EA\8A02\8655\7406\4F5C\696D\4E2D, \4EE5\57F7\884C\5FC5\8981\52D5\4F5C.</p>'),
unistr('        <p>\6CE8\610F - \5373\4F7F\672A\5C0D\9078\53D6\7684\8CC7\6599\5217\9032\884C\4EFB\4F55\66F4\65B0, \9084\662F\6703\8655\7406\8CC7\6599\5217. \4E00\822C\53EA\6703\8655\7406\5DF2\63D2\5165\3001\66F4\65B0\6216\522A\9664\7684\8CC7\6599\5217.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109460475333313721)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\5305\62EC\9078\53D6\7684\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109325224740313619)
,p_name=>'PE.PROPERTY.SUBSCRIBED_FROM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\60A8\8981\6B64\914D\7F6E\8A02\95B1\5176\8A8D\8B49\914D\7F6E\7684\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109325173221313618)
,p_name=>'PE.PROPERTY.SUBSCRIBED_FROM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1\4F86\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109929591204314093)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\5143\4EF6\662F\4F7F\7528\4E00\500B\8CC7\6599\6B04\9084\662F\9032\968E\683C\5F0F (\4F7F\7528 HTML \8868\793A\5F0F\548C\652F\63F4\7684\66FF\4EE3\5B57\4E32) \986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109929488613314093)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\968E\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109929744227314093)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7576\4F5C\5B50\6A19\984C\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109929655278314093)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109930239674314093)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\65B0\589E\81F3\6B64\5143\4EF6\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109930137087314093)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109930097780314093)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\8B8A\66F4\80CC\666F\8207\6587\5B57\8272\5F69</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\4F7F\7528\6A19\984C 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>\4F7F\7528\4F86\81EA SQL \67E5\8A62\7684\52D5\614B\985E\5225</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \6B64\7BC4\4F8B\4E2D\7684 <code>&COLUMN_CLASS.</code> \8207 <code>&EMPLOYEE_STATUS.</code> \66FF\4EE3\9805\76EE\70BA\5831\8868 SQL \67E5\8A62\4E2D\9078\53D6\7684\8CC7\6599\6B04.</dd>'),
unistr('  <dt>\6E38\6A19\505C\7559\6642\986F\793A\5F71\50CF\8207\5DE5\5177\63D0\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109929923785314093)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5728\6B64\8CC7\6599\6B04\4E2D\986F\793A\7684 HTML \8868\793A\5F0F. \82E5\8981\4EE5 HTML \683C\5F0F\986F\793A\8CC7\6599\6B04\503C, \8ACB\4F7F\7528 <code>&COLUMN.</code> \8A9E\6CD5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109929814227314093)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109584387313313817)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\8655\7406\4F5C\696D\7684\6210\529F\8A0A\606F.'),
unistr('\5982\679C\8655\7406\4F5C\696D\5728\57F7\884C\6642\672A\7522\751F\4EFB\4F55\932F\8AA4, \5247\6703\5728\7522\751F\4E4B\986F\793A\9801\9762\7684\901A\77E5\5340\6BB5\4E2D, \986F\793A\6B64\8655\7406\4F5C\696D\6210\529F\8A0A\606F.'),
unistr('\5982\679C\60A8\8981\900F\904E URL \91CD\65B0\5C0E\5411\4F86\5206\652F\5230\53E6\4E00\500B\9801\9762, \53EF\80FD\9700\8981\52FE\9078<em>\4FDD\7559\6210\529F\8A0A\606F</em>\5C6C\6027.</p>'),
unistr('<p>\91DD\5C0D\591A\8CC7\6599\5217\8655\7406\4F5C\696D, \53EF\4F7F\7528\4E0B\5217\66FF\4EE3\5B57\4E32\53D6\5F97\8655\7406\7684\8A18\9304\6578\76EE:</p>'),
'<ul>',
unistr('  <li>\63D2\5165: <code>#MRI_COUNT#</code></li>'),
unistr('  <li>\66F4\65B0: <code>#MRU_COUNT#</code></li>'),
unistr('  <li>\522A\9664: <code>#MRD_COUNT#</code></li>'),
'</ul>',
unistr('<p>\91DD\5C0D\300C\50B3\9001\96FB\5B50\90F5\4EF6\300D\8655\7406\4F5C\696D\985E\578B, \53EF\4F7F\7528\66FF\4EE3\5B57\4E32 <code>#TO#</code> \53D6\5F97\96FB\5B50\90F5\4EF6\7684\5730\5740.</p>'),
unistr('<p>Plug-in \4E5F\53EF\4EE5\4F7F\7528\5176\4ED6\66FF\4EE3\5B57\4E32. \8ACB\53C3\95B1 Plug-in \6587\4EF6\77AD\89E3\8A73\7D30\8CC7\8A0A.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109738726839313952)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\8655\7406\4F5C\696D\9806\5229\5B8C\6210\6642\8981\5728\300C\901A\77E5\300D\5340\57DF (\5B9A\7FA9\70BA\9801\9762\6A23\677F\7684\4E00\90E8\5206) \4E2D\986F\793A\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109583890910313817)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109280367407313585)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\4EE5\4F5C\70BA\5EFA\8B70\4F86\6E90\7684 SQL \67E5\8A62.</p>'),
unistr('<p>\6CE8\610F: \6240\50B3\56DE\503C\7684\9806\5E8F\6703\7528\65BC\6C7A\5B9A\986F\793A\9019\4E9B\503C\7684\9806\5E8F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109280291099313585)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109280135006313585)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\4EE5\9017\865F\5340\9694, \7528\4EE5\4F5C\70BA\5EFA\8B70\4F86\6E90\7684\975C\614B\503C\6E05\55AE.</p>'),
unistr('<p>\6CE8\610F: \6240\6307\5B9A\503C\7684\9806\5E8F\6703\7528\65BC\6C7A\5B9A\986F\793A\9019\4E9B\503C\7684\9806\5E8F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109280054972313584)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109282373912313586)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109283042951313587)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER_GROUP.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109279349787313584)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\5982\4F55\6C7A\5B9A\6B64\7BE9\9078\7684\5EFA\8B70.</p>'),
unistr('<p>\6CE8\610F: \63D0\4F9B\7684\503C\4ECD\7136\6703\91DD\5C0D\503C\6E05\55AE\7684\53EF\898B\9805\76EE\9032\884C\6AA2\67E5, \4E26\4E14\53EA\6709\5728\76F8\7B26\6642\624D\6703\4F7F\7528.'),
unistr('\5982\679C\627E\4E0D\5230\67D0\500B\503C, \5247\6703\7565\904E\4E26\6AA2\67E5\4E0B\4E00\500B\503C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109279476994313584)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109279510573313584)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\503C\6E05\55AE\4E2D\9078\64C7<strong>\7B2C\4E00\500B</strong>\53EF\898B\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109279846407313584)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109279910286313584)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6703\5F9E\8F38\5165\7684 <em>SQL \67E5\8A62</em>\50B3\56DE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109279649965313584)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109279773651313584)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EE5\9017\865F\5340\9694\7684\503C\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109279204482313584)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109548047214313786)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\986F\793A\5728\4E0B\8F09\6A94\6848\4E0A\9762\7684\6587\5B57. \60A8\53EF\4EE5\8F38\5165\6709\95DC\6A94\6848\4E2D\8CC7\6599\7684\8CC7\6599\5206\985E\3001\6CD5\5F8B\6216\8B66\544A\8A0A\606F.</p>'),
unistr('        <p> \6CE8\610F - \8F38\5165\7684\6587\5B57\5C07\6703\5305\542B\5728\6240\6709\5831\8868\4E0B\8F09\683C\5F0F\4E2D.  \82E5\555F\7528 CSV \4E0B\8F09, \5247\5B9A\7FA9\7684\6587\5B57\5C07\6703\4F7F CSV \6A94\6848\683C\5F0F\7121\6548.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109547950496313786)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\88DC\5145\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109563258623313802)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\60F3\8981\5728\300C\8A73\7D30\6AA2\8996\300D\4E2D\4F7F\7528\8CC7\6599\6B04\6A19\984C\6587\5B57\4F5C\70BA\6A19\7C64, \8ACB\6307\5B9A\6B64\5C6C\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109563153496313802)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8CC7\6599\6B04\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109618506407313846)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\6B64\300C\5217\8868\5316\8868\55AE\300D\8CC7\6599\6B04\7684\57FA\790E.</p>'),
unistr('<p>\9078\64C7\9805\76EE\6703\6C7A\5B9A\6B64\8CC7\6599\6B04\5728\300C\5217\8868\5316\8868\55AE\300D\5167\662F\5426\53EF\66F4\65B0.'),
unistr('\53EA\6709\7576\5DF2\5B9A\7FA9\591A\91CD\8CC7\6599\5217\66F4\65B0, \6216\5DF2\5BE6\884C PL/SQL \8655\7406\4F5C\696D\4F86\8655\7406\66F4\65B0\7684\8CC7\6599\6642, \624D\80FD\57F7\884C\66F4\65B0.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109785996377313988)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F\9078\64C7\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109954329749314111)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\65E5\671F\6216\4F7F\7528\65E5\671F\9078\53D6\5668\4F86\9078\53D6\65E5\671F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109785852871313988)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F\9078\64C7\5668 (\4E00\822C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109954401260314111)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\65E5\671F\6216\4F7F\7528\65E5\671F\9078\53D6\5668\4F86\9078\53D6\65E5\671F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109785777800313988)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D14\6587\5B57 (\5132\5B58\72C0\614B)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109953038005314110)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\8CC7\6599\6B04\503C, \4E26\5132\5B58\5728\968E\6BB5\4F5C\696D\72C0\614B\7684\503C\4E2D. \60A8\53EF\4EE5\5728\8655\7406\9801\9762\6642\4F7F\7528\6B64\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109787477257313989)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09 BLOB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109953469735314110)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8CC7\6599\6B04\986F\793A\70BA\9023\7D50\4EE5\4E0B\8F09\6A94\6848.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109786989387313989)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF\7684\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109954599811314111)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\986F\793A\8CC7\6599\6B04, \4F46\53EF\53C3\7167\8A72\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109786432373313988)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF\7684\8CC7\6599\6B04 (\5132\5B58\72C0\614B)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109954692347314111)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\986F\793A\8CC7\6599\6B04, \4F46\53EF\53C3\7167\8A72\8CC7\6599\6B04. \60A8\53EF\4EE5\5728\8655\7406\9801\9762\6642\4F7F\7528\6B64\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109787328571313989)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109953372189314110)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8CC7\6599\6B04\986F\793A\70BA\5F71\50CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109787270770313989)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109953260772314110)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8CC7\6599\6B04\986F\793A\70BA\9023\7D50.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109787558429313989)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767E\5206\6BD4\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109953537017314110)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8CC7\6599\6B04\986F\793A\70BA\767E\5206\6BD4\5716\8868. \64F7\53D6\7684\503C\5FC5\9808\4ECB\65BC 0 \5230 100 \4E4B\9593.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109787038017313989)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D14\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109952979504314110)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\8CC7\6599\6B04\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109787135371313989)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D14\6587\5B57 (\4EE5\503C\6E05\55AE\70BA\57FA\790E)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109953114042314110)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5F9E\6307\5B9A\503C\6E05\55AE\50B3\56DE\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109786503049313988)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5373\73FE\5F0F LOV (\986F\793A\50B3\56DE\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109954077105314110)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5373\73FE\5F0F\6E05\55AE\4E2D\7684\503C. \7CFB\7D71\6703\986F\793A\503C\6E05\55AE\7684\50B3\56DE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109786692282313988)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5373\73FE\5F0F LOV (\986F\793A\986F\793A\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109953991730314110)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5373\73FE\5F0F\6E05\55AE\4E2D\7684\503C. \7CFB\7D71\6703\986F\793A\503C\6E05\55AE\7684\986F\793A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109786381865313988)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\9215\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109954112522314110)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6307\5B9A\503C\6E05\55AE\4E2D\7684\55AE\4E00\5713\9215\7FA4\7D44.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109786844861313989)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\9078\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109952852309314109)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\6BCF\500B\8CC7\6599\5217\958B\982D\5305\542B\6838\53D6\65B9\584A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109786299999313988)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109953820929314110)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6307\5B9A\503C\6E05\55AE\4E2D\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109786759716313988)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C21\55AE\6838\53D6\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109954265160314110)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52FE\9078\6216\53D6\6D88\52FE\9078\55AE\4E00\6838\53D6\65B9\584A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109786084751313988)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\6B04\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109953662748314110)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\6587\5B57\6B04\4F4D\8F38\5165\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109786188980313988)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109953750471314110)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\6587\5B57\5340\57DF\6B04\4F4D\8F38\5165\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109618498324313846)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109341352387313631)
,p_name=>'PE.PROPERTY.TARGET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E00\4E0B\300C\76EE\6A19\300D\4EE5\547C\53EB\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A. \60A8\53EF\4EE5\8F38\5165\547C\53EB\6B64\5206\652F\6642\6240\8981\547C\53EB\7684\76EE\6A19.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109341287543313630)
,p_name=>'PE.PROPERTY.TARGET.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\6A19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109921861483314087)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\53EF\4F9B\81EA\8A02\6B64\5143\4EF6\4E4B\4F7F\7528\8005\4ECB\9762\7684\6A23\677F\9078\9805.</p>'),
unistr('<p>\60A8\4E5F\53EF\4EE5\5728\57F7\884C\61C9\7528\7A0B\5F0F\6642\4F7F\7528<strong>\5373\6642\6A23\677F\9078\9805</strong>\4F86\4FEE\6539\6A23\677F\9078\9805.'),
unistr('\60A8\53EF\4EE5\5229\7528\300C\5373\6642\6A23\677F\9078\9805\300D\5373\6642\81EA\8A02\60A8\7684\61C9\7528\7A0B\5F0F, \8B93\60A8\80FD\5920\9810\89BD\53CA\5957\7528\5404\7A2E\4E0D\540C\7684\9078\9805.'),
unistr('\82E5\8981\5B58\53D6\300C\5373\6642\6A23\677F\9078\9805\300D, \8ACB\5F9E\300C\61C9\7528\7A0B\5F0F\7522\751F\5668\300D\57F7\884C\61C9\7528\7A0B\5F0F, \7136\5F8C\6309\4E00\4E0B\958B\767C\4EBA\54E1\5DE5\5177\5217\4E2D\7684<em>\5FEB\901F\7DE8\8F2F</em>.'),
unistr('\5C07\6ED1\9F20\6E38\6A19\505C\99D0\65BC\67D0\500B\9801\9762\5143\4EF6 (\4F8B\5982\5340\57DF), \7136\5F8C\6309\4E00\4E0B\5DE6\4E0A\89D2\7684\6273\624B\5716\793A ( <span class="a-Icon icon-util" aria-hidden="true"></span> ).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109921782707314087)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109922067178314087)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\53EF\4F9B\81EA\8A02\6B64\5143\4EF6\4E4B\4F7F\7528\8005\4ECB\9762\7684\6A23\677F\9078\9805.</p>'),
unistr('<p>\60A8\4E5F\53EF\4EE5\5728\57F7\884C\61C9\7528\7A0B\5F0F\6642\4F7F\7528<strong>\5373\6642\6A23\677F\9078\9805</strong>\4F86\4FEE\6539\6A23\677F\9078\9805.'),
unistr('\60A8\53EF\4EE5\5229\7528\300C\5373\6642\6A23\677F\9078\9805\300D\5373\6642\81EA\8A02\60A8\7684\61C9\7528\7A0B\5F0F, \8B93\60A8\80FD\5920\9810\89BD\53CA\5957\7528\5404\7A2E\4E0D\540C\7684\9078\9805.'),
unistr('\82E5\8981\5B58\53D6\300C\5373\6642\6A23\677F\9078\9805\300D, \8ACB\5F9E\300C\61C9\7528\7A0B\5F0F\7522\751F\5668\300D\57F7\884C\61C9\7528\7A0B\5F0F, \7136\5F8C\6309\4E00\4E0B\958B\767C\4EBA\54E1\5DE5\5177\5217\4E2D\7684<em>\5FEB\901F\7DE8\8F2F</em>.'),
unistr('\5C07\6ED1\9F20\6E38\6A19\505C\99D0\65BC\67D0\500B\9801\9762\5143\4EF6 (\4F8B\5982\5340\57DF), \7136\5F8C\6309\4E00\4E0B\5DE6\4E0A\89D2\7684\6273\624B\5716\793A ( <span class="a-Icon icon-util" aria-hidden="true"></span> ).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109921985607314087)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109170192627313498)
,p_name=>'PE.PROPERTY.TEMPLATE_PLACEHOLDERS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\6A23\677F\5167\7684\9810\7559\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109170037063313498)
,p_name=>'PE.PROPERTY.TEMPLATE_PLACEHOLDERS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F\9810\7559\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109603408502313835)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\5831\8868\7684\6A23\677F\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109782662210313985)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\5148\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109782721144313985)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\76F4\63A5\95DC\806F\4EFB\4F55\4E3B\984C\7684\9810\5148\5B9A\7FA9\5831\8868\6A23\677F. \56E0\70BA\9019\4E9B\9810\5148\5B9A\7FA9\7684\6A23\677F\8207\60A8\7684\76EE\524D\4E3B\984C\4E4B\9593\6C92\6709\95DC\806F, \5373\4F7F\60A8\8B8A\66F4\61C9\7528\7A0B\5F0F\4E3B\984C, \60A8\7684\5831\8868\7248\9762\914D\7F6E\4ECD\6703\7DAD\6301\4E0D\8B8A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109782471724313985)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109782569944313985)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\6B64\9801\9762\4E4B\4F7F\7528\8005\4ECB\9762\7684\76EE\524D\4E3B\984C, \5728\5C0D\61C9\4E3B\984C\4E2D\53EF\7528\7684\5831\8868\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109603329984313835)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110110694888314241)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6839\64DA\6307\5B9A\7684<strong>\641C\5C0B\985E\578B</strong>, \8F38\5165\7528\65BC\6587\5B57\641C\5C0B\7684\4E00\500B\8CC7\6599\5EAB\8CC7\6599\6B04\540D\7A31\6216\4E00\4EFD\8CC7\6599\5EAB\8CC7\6599\6B04\540D\7A31\6E05\55AE.</p>'),
'<ul>',
unistr('  <li><strong>\8CC7\6599\5217\641C\5C0B</strong>: \8F38\5165\8981\7528\65BC\6587\5B57\641C\5C0B\7684\4EE5\9017\865F\5340\9694\4E14\70BA VARCHAR2 \985E\578B\7684\8CC7\6599\5EAB\8CC7\6599\6B04\540D\7A31 (\5340\5206\5927\5C0F\5BEB). \82E5\672A\6307\5B9A\8CC7\6599\6B04, \5C07\6703\81EA\52D5\4F7F\7528\6240\6709 VARCHAR2 \8CC7\6599\6B04.</li>'),
unistr('  <li><strong>Oracle Text</strong>: \8F38\5165\5305\542B Oracle Text \7D22\5F15\7684\8CC7\6599\5EAB\8CC7\6599\6B04\540D\7A31 (\5340\5206\5927\5C0F\5BEB).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110110535178314241)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109382406177313662)
,p_name=>'PE.PROPERTY.THEME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\8207\76EE\524D\4F7F\7528\8005\4ECB\9762\5EFA\7ACB\95DC\806F\7684\4E3B\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109382387595313662)
,p_name=>'PE.PROPERTY.THEME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109530320654313773)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\523B\5EA6\6A19\7C64\8207\7E6A\5716\5340\7684\76F8\5C0D\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109530531633313773)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.INSIDE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5074')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109530480325313773)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.OUTSIDE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\5074')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109530226331313773)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109529929639313773)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5448\73FE\523B\5EA6\6A19\7C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109529869892313772)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109530197257313773)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\5716\8868\662F\5426\81EA\52D5\5C07\6A19\7C64\65CB\8F49 90 \5EA6, \4EE5\5728\5EA7\6A19\8EF8\4E0A\653E\5165\66F4\591A\6A19\7C64.'),
unistr('        \65CB\8F49\53EA\6703\5957\7528\81F3\6C34\5E73\8EF8\7684\985E\5225\6A19\7C64.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109530052098313773)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65CB\8F49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109900727171314072)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8207\6A19\6E96\76F8\540C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110031584900314165)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DFA\8272\548C\6DF1\8272\6A21\5F0F\90FD\4F7F\7528\76F8\540C\7684\80CC\666F\5730\5716.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109855370932314039)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\6DF1\8272\6A21\5F0F\555F\7528\6642, \4F5C\70BA\80CC\666F\5730\5716\7684\78DA\584A\5C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109856296430314040)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle BI \4E16\754C\5730\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109856301814314040)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5 HERE Map \8CC7\6599\70BA\57FA\790E\7684\4E0D\9192\76EE\57FA\790E\5730\5716. \6B64\57FA\790E\5730\5716\6A23\5F0F\91DD\5C0D\8CC7\6599\63D0\4F9B\4F4D\7F6E\76F8\95DC\8CC7\8A0A, \540C\6642\8457\91CD\65BC\8CC7\6599\7684\8996\89BA\5316.</p>'),
unistr('<p>\6A23\5F0F\7DB1\8981\548C\5B9A\7FA9\7531 Oracle, USA \6240\63D0\4F9B.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109855877201314040)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('OpenStreetMap (\660E\4EAE\7248)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109855951941314040)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>\4EE5 OpenStreetMap \8CC7\6599\70BA\57FA\790E\7684\4E00\822C\7528\9014\57FA\790E\5730\5716. \6B64\57FA\790E\5730\5716\6A23\5F0F\91DD\5C0D\8CC7\6599\63D0\4F9B\8A73\7D30\7684\4F4D\7F6E\76F8\95DC\8CC7\8A0A.</p>'),
unistr('<p>\6A23\5F0F\7DB1\8981\548C\5B9A\7FA9\884D\751F\81EA "Mapbox Open Styles", \7531 KlokanTech.com \8207 OpenMapTiles \63D0\4F9B\8005\6240\63D0\4F9B. \7531 BSD/CC-BY \6388\6B0A\63D0\4F9B\6388\6B0A.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">\5728 GitHub \4E0A\6AA2\8996</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109855486043314039)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('OpenStreetMap (\6DF1\8272\7248)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109855517718314040)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>\4EE5 OpenStreetMap \8CC7\6599\70BA\57FA\790E\7684\4E0D\9192\76EE\6DFA\8272\57FA\790E\5730\5716. \6B64\57FA\790E\5730\5716\6A23\5F0F\8457\91CD\65BC\8CC7\6599\7684\8996\89BA\5316.</p>'),
unistr('<p>\6A23\5F0F\7DB1\8981\548C\5B9A\7FA9\884D\751F\81EA "Mapbox Open Styles", \7531 KlokanTech.com \8207 OpenMapTiles \63D0\4F9B\8005\6240\63D0\4F9B. \7531 BSD/CC-BY \6388\6B0A\63D0\4F9B\6388\6B0A. Stamen Design \88FD\5716\7531 CC0 \63D0\4F9B\6388\6B0A.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">\5728 GitHub \4E0A\6AA2\8996</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109855632702314040)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'OpenStreetMap Positron'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109855780322314040)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5 OpenStreetMap \8CC7\6599\70BA\57FA\790E\7684\4E0D\9192\76EE\6DF1\8272\57FA\790E\5730\5716. \6B64\57FA\790E\5730\5716\6A23\5F0F\8457\91CD\65BC\8CC7\6599\7684\8996\89BA\5316.</p>'),
unistr('<p>\6A23\5F0F\7DB1\8981\548C\5B9A\7FA9\884D\751F\81EA "Mapbox Open Styles", \7531 KlokanTech.com \8207 OpenMapTiles \63D0\4F9B\8005\6240\63D0\4F9B. \7531 BSD/CC-BY \6388\6B0A\63D0\4F9B\6388\6B0A. Stamen Design \88FD\5716\7531 CC0 \63D0\4F9B\6388\6B0A.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">\5728 GitHub \4E0A\6AA2\8996</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109856042983314040)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle \4E16\754C\5730\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109856197898314040)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5 HERE Map \8CC7\6599\70BA\57FA\790E\7684\4E00\822C\7528\9014\57FA\790E\5730\5716. \6B64\57FA\790E\5730\5716\6A23\5F0F\91DD\5C0D\8CC7\6599\63D0\4F9B\4F4D\7F6E\76F8\95DC\8CC7\8A0A, \540C\6642\8457\91CD\65BC\8CC7\6599\7684\8996\89BA\5316.</p>'),
unistr('<p>\6A23\5F0F\7DB1\8981\548C\5B9A\7FA9\7531 Oracle, USA \6240\63D0\4F9B.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109855276689314039)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DF1\8272\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109854122093314039)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\4F5C\70BA\80CC\666F\5730\5716\7684\78DA\584A\5C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109855068802314039)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle BI \4E16\754C\5730\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109855139281314039)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5 HERE Map \8CC7\6599\70BA\57FA\790E\7684\4E0D\9192\76EE\57FA\790E\5730\5716. \6B64\57FA\790E\5730\5716\6A23\5F0F\91DD\5C0D\8CC7\6599\63D0\4F9B\4F4D\7F6E\76F8\95DC\8CC7\8A0A, \540C\6642\8457\91CD\65BC\8CC7\6599\7684\8996\89BA\5316.</p>'),
unistr('<p>\6A23\5F0F\7DB1\8981\548C\5B9A\7FA9\7531 Oracle, USA \6240\63D0\4F9B.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109854684948314039)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('OpenStreetMap (\660E\4EAE\7248)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109854752165314039)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>\4EE5 OpenStreetMap \8CC7\6599\70BA\57FA\790E\7684\4E00\822C\7528\9014\57FA\790E\5730\5716. \6B64\57FA\790E\5730\5716\6A23\5F0F\91DD\5C0D\8CC7\6599\63D0\4F9B\8A73\7D30\7684\4F4D\7F6E\76F8\95DC\8CC7\8A0A.</p>'),
unistr('<p>\6A23\5F0F\7DB1\8981\548C\5B9A\7FA9\884D\751F\81EA "Mapbox Open Styles", \7531 KlokanTech.com \8207 OpenMapTiles \63D0\4F9B\8005\6240\63D0\4F9B. \7531 BSD/CC-BY \6388\6B0A\63D0\4F9B\6388\6B0A.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">\5728 GitHub \4E0A\6AA2\8996</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109854424293314039)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('OpenStreetMap (\6DF1\8272\7248)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109854501022314039)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5 OpenStreetMap \8CC7\6599\70BA\57FA\790E\7684\4E0D\9192\76EE\6DF1\8272\57FA\790E\5730\5716. \6B64\57FA\790E\5730\5716\6A23\5F0F\8457\91CD\65BC\8CC7\6599\7684\8996\89BA\5316.</p>'),
unistr('<p>\6A23\5F0F\7DB1\8981\548C\5B9A\7FA9\884D\751F\81EA "Mapbox Open Styles", \7531 KlokanTech.com \8207 OpenMapTiles \63D0\4F9B\8005\6240\63D0\4F9B. \7531 BSD/CC-BY \6388\6B0A\63D0\4F9B\6388\6B0A. Stamen Design \88FD\5716\7531 CC0 \63D0\4F9B\6388\6B0A.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">\5728 GitHub \4E0A\6AA2\8996</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109854225836314039)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'OpenStreetMap Positron'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109854395878314039)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5 OpenStreetMap \8CC7\6599\70BA\57FA\790E\7684\4E0D\9192\76EE\6DFA\8272\57FA\790E\5730\5716. \6B64\57FA\790E\5730\5716\6A23\5F0F\8457\91CD\65BC\8CC7\6599\7684\8996\89BA\5316.</p>'),
unistr('<p>\6A23\5F0F\7DB1\8981\548C\5B9A\7FA9\884D\751F\81EA "Mapbox Open Styles", \7531 KlokanTech.com \8207 OpenMapTiles \63D0\4F9B\8005\6240\63D0\4F9B. \7531 BSD/CC-BY \6388\6B0A\63D0\4F9B\6388\6B0A. Stamen Design \88FD\5716\7531 CC0 \63D0\4F9B\6388\6B0A.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">\5728 GitHub \4E0A\6AA2\8996</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109854830286314039)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle \4E16\754C\5730\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109854961197314039)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5 HERE Map \8CC7\6599\70BA\57FA\790E\7684\4E00\822C\7528\9014\57FA\790E\5730\5716. \6B64\57FA\790E\5730\5716\6A23\5F0F\91DD\5C0D\8CC7\6599\63D0\4F9B\4F4D\7F6E\76F8\95DC\8CC7\8A0A, \540C\6642\8457\91CD\65BC\8CC7\6599\7684\8996\89BA\5316.</p>'),
unistr('<p>\6A23\5F0F\7DB1\8981\548C\5B9A\7FA9\7531 Oracle, USA \6240\63D0\4F9B.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109854032145314038)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109853555738314038)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\4F7F\7528\7684\80CC\666F\5730\5716.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109853806181314038)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109853979713314038)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\7528\65BC\80CC\666F\5730\5716\7684\5730\5716\78DA\584A\5C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109853665988314038)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109853714959314038)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\9810\8A2D\80CC\666F\5730\5716\8A2D\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109853422769314038)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\80CC\666F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109631121433313856)
,p_name=>'PE.PROPERTY.TIME_FORMAT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\5982\4F55\986F\793A\6642\9593\683C\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109790900857313992)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.12HOUR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('12 \5C0F\6642\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109791082266313992)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.24HOUR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('24 \5C0F\6642\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109631057374313856)
,p_name=>'PE.PROPERTY.TIME_FORMAT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\9593\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110119838001314248)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5EA7\6A19\8EF8\7684\6A19\984C. \6B64\6A19\984C\61C9\63CF\8FF0\5716\8868\6B64\5EA7\6A19\8EF8\4E0A\986F\793A\7684\8CC7\8A0A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109270534988313573)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\986F\793A\5728\700F\89BD\5668\8996\7A97\6A19\984C\5217\7684\6A19\984C. &PRODUCT_NAME. \5F15\64CE\4F7F\7528\60A8\5728\6B64\6307\5B9A\7684\6A19\984C, \53D6\4EE3\7528\65BC\9801\9762\6A23\677F\7684 <code>#TITLE#</code> \66FF\4EE3\5B57\4E32. \6B64\6A19\984C\6703\63D2\5165\81F3 HTML \6A19\8A18 <code>&lt;TITLE&gt;</code> \548C <code>&lt;/TITLE&gt;</code> \4E4B\9593.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109271440291313573)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5340\57DF\6A19\984C. \5340\57DF\6A19\984C\53EA\6709\5B9A\7FA9\5728\5340\57DF\6A23\677F\6642, \624D\6703\986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109232876435313545)
,p_name=>'PE.PROPERTY.TITLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\9801\9762\6A19\984C. \9801\9762\6A19\984C\6703\986F\793A\5728\700F\89BD\5668\8996\7A97\7684\6A19\984C\5217\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109232783315313545)
,p_name=>'PE.PROPERTY.TITLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109928640385314092)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\6B64\5143\4EF6\662F\4F7F\7528\4E00\500B\8CC7\6599\6B04\9084\662F\9032\968E\683C\5F0F (\4F7F\7528 HTML \8868\793A\5F0F\548C\652F\63F4\7684\66FF\4EE3\5B57\4E32) \986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109928537908314092)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\968E\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109928838828314092)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\7576\4F5C\6A19\984C\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109928739610314092)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109929306691314093)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\65B0\589E\81F3\6B64\5143\4EF6\7684\985E\5225. \82E5\8981\65B0\589E\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109929233197314093)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109929168793314093)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\8B8A\66F4\80CC\666F\8207\6587\5B57\8272\5F69</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\4F7F\7528\6A19\984C 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>\4F7F\7528\4F86\81EA SQL \67E5\8A62\7684\52D5\614B\985E\5225</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \6B64\7BC4\4F8B\4E2D\7684 <code>&COLUMN_CLASS.</code> \8207 <code>&EMPLOYEE_STATUS.</code> \66FF\4EE3\9805\76EE\70BA\5831\8868 SQL \67E5\8A62\4E2D\9078\53D6\7684\8CC7\6599\6B04.</dd>'),
unistr('  <dt>\6E38\6A19\505C\7559\6642\986F\793A\5F71\50CF\8207\5DE5\5177\63D0\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109929068190314092)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\5728\6B64\8CC7\6599\6B04\4E2D\986F\793A\7684 HTML \8868\793A\5F0F. \82E5\8981\4EE5 HTML \683C\5F0F\986F\793A\8CC7\6599\6B04\503C, \8ACB\4F7F\7528 <code>&COLUMN.</code> \8A9E\6CD5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109928989921314092)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HTML \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109482189802313737)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52FE\9078\5DE5\5177\5217\4E2D\6240\8981\986F\793A\7684\5176\4ED6\63A7\5236\9805.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109482629781313738)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\529F\80FD\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109482722502313738)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\300C\52D5\4F5C\300D\529F\80FD\8868\6309\9215, \6B64\529F\80FD\8868\901A\5E38\5305\542B\4E00\7D44\5B8C\6574\7684\9078\9805. \4E00\822C\4F7F\7528\8005\53EF\6839\64DA\60A8\63D0\4F9B\7684\529F\80FD, \4F7F\7528\9019\4E9B\9078\9805\81EA\8A02\5831\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109482860335313738)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109482958311313738)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\300C\91CD\8A2D\300D\6309\9215. \6309\4E0B\6B64\6309\9215, \6240\6709\7684\81EA\8A02\9805\76EE (\4F8B\5982\7BE9\9078\689D\4EF6\3001\8CC7\6599\6B04\5BEC\5EA6\548C\9806\5E8F) \90FD\6703\88AB\79FB\9664, \800C\4E14\6703\5F9E\4F3A\670D\5668\91CD\65B0\8F09\5165\5831\8868\5B9A\7FA9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109483052109313738)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109483121105313738)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\986F\793A\300C\5132\5B58\300D\6309\9215. \6309\4E0B\6B64\6309\9215, \5247\53EA\6703\5132\5B58\6B64\4E92\52D5\5F0F\65B9\683C\7684\8B8A\66F4, \4E26\4E0D\9700\8981\5132\5B58\6574\500B\9801\9762.'),
unistr('        <p>\7576\4E92\52D5\5F0F\65B9\683C\53EF\4EE5\7DE8\8F2F, \800C\4E14\4E00\822C\4F7F\7528\8005\6709\6B0A\65B0\589E\3001\66F4\65B0\6216\522A\9664\6642, \624D\6703\986F\793A\5132\5B58\6309\9215.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109482258173313737)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\641C\5C0B\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109482313253313737)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\975E\6578\503C\8CC7\6599\6B04\7684\4E0B\62C9\5F0F\6E05\55AE. \82E5\9078\53D6\4E86\67D0\9805\8CC7\6599\6B04, \5247\53EA\6703\641C\5C0B\6240\9078\8CC7\6599\6B04\4E2D\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109482430255313737)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\6B04\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109482577502313737)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\641C\5C0B\5217\4E2D\986F\793A\7528\65BC\8F38\5165\641C\5C0B\689D\4EF6\7684\6587\5B57\6B04\4F4D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109482050890313737)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63A7\5236\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110044618327314175)
,p_name=>'PE.PROPERTY.TREE_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109949158115314107)
,p_name=>'PE.PROPERTY.TREE_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110044722084314175)
,p_name=>'PE.PROPERTY.TREE_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109586583047313819)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\793A\6B64\8CC7\6599\6B04\662F\5426\652F\63F4\6642\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109586437528313819)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\652F\63F4\6642\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109619848192313848)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\6B64\5831\8868\8CC7\6599\6B04\6240\53C3\7167\7684\8CC7\6599\6B04\540D\7A31.'),
unistr('\60A8\53EF\4EE5\4F7F\7528\6B64\5C6C\6027\5229\7528\300C\4F7F\7528\8005\4ECB\9762\9810\8A2D\503C\300D\6BD4\8F03\5404\500B\61C9\7528\7A0B\5F0F\7684\8CC7\6599\6B04\53C3\7167.'),
unistr('\6B64\53C3\7167\7684\7DAD\8B77\65B9\5F0F\662F\5728\7CBE\9748\8D77\59CB\6B64\53C3\7167\4E4B\5F8C, \4EE5\624B\52D5\65B9\5F0F\5728\4EFB\4F55\53EF\80FD\7684\6642\5019\9032\884C\7DAD\8B77.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109619715985313847)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109619686946313847)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\6B64\8CC7\6599\6B04\6240\53C3\7167\7684\8868\683C\6216\8996\89C0\8868.'),
unistr('\60A8\53EF\4EE5\4F7F\7528\6B64\5C6C\6027\5229\7528\300C\4F7F\7528\8005\4ECB\9762\9810\8A2D\503C\300D\6BD4\8F03\5404\500B\61C9\7528\7A0B\5F0F\7684\8CC7\6599\6B04\53C3\7167.'),
unistr('\6B64\53C3\7167\7684\7DAD\8B77\65B9\5F0F\662F\5728\7CBE\9748\8D77\59CB\6B64\53C3\7167\4E4B\5F8C, \4EE5\624B\52D5\65B9\5F0F\5728\4EFB\4F55\53EF\80FD\7684\6642\5019\9032\884C\7DAD\8B77.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109619588055313847)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109619418396313847)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\64C1\6709\53C3\7167\8868\683C\7684\7DB1\8981.'),
unistr('\60A8\53EF\4EE5\4F7F\7528\6B64\5C6C\6027\5229\7528\300C\4F7F\7528\8005\4ECB\9762\9810\8A2D\503C\300D\6BD4\8F03\5404\500B\61C9\7528\7A0B\5F0F\7684\8CC7\6599\6B04\53C3\7167.'),
unistr('\6B64\53C3\7167\7684\7DAD\8B77\65B9\5F0F\662F\5728\7CBE\9748\8D77\59CB\6B64\53C3\7167\4E4B\5F8C, \4EE5\624B\52D5\65B9\5F0F\5728\4EFB\4F55\53EF\80FD\7684\6642\5019\9032\884C\7DAD\8B77.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109619347312313847)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109571360336313808)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\4F7F\7528\9023\7D50\8CC7\6599\6B04\6642, \7528\4F86\8B58\5225\76EE\524D\8CC7\6599\5217\7684\8CC7\6599\6B04\985E\578B.'),
unistr('\9810\8A2D\6703\4F7F\7528 <strong>ROWID</strong> \4F86\552F\4E00\8B58\5225\5831\8868\4E2D\7684\8CC7\6599\5217. \4E0D\904E, \60A8\4E5F\53EF\4EE5\9078\53D6<strong>\552F\4E00\8CC7\6599\6B04</strong>\4EE5\4F7F\7528\53E6\4E00\500B\8CC7\6599\6B04.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109771597645313977)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.COLUMN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\552F\4E00\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109771422703313977)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.ROWID.D'
,p_message_language=>'zh-tw'
,p_message_text=>'ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109571233343313808)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\552F\4E00\8B58\5225\8CC7\6599\5217\7684\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109571540281313808)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\7528\4F86\552F\4E00\8B58\5225\6B64\5143\4EF6\4E4B\8CC7\6599\5217\7684\7B2C\4E00\500B\8CC7\6599\6B04.</p>'),
unistr('<p>\70BA\4E86\652F\63F4\56DE\6EAF\76F8\5BB9\6027, \53EF\7528\8CC7\6599\6B04\6E05\55AE\4E2D\4E5F\5305\62EC\4E86 <strong>ROWID</strong>.</p>'),
unistr('<p>\6CE8\610F: \5C0D\65BC<em>\9023\7D50\8CC7\6599\6B04</em>\5C6C\6027\8A2D\70BA<strong>\9023\7D50\81F3\55AE\4E00\8CC7\6599\5217\6AA2\8996</strong>\7684\4E92\52D5\5F0F\5831\8868, \53EA\80FD\9078\53D6\55AE\4E00\500B\552F\4E00\8CC7\6599\6B04. \5176\4ED6\5143\4EF6\5247\6700\591A\652F\63F4\9078\53D6\4E09\500B\8CC7\6599\6B04.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109571413088313808)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\552F\4E00\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109571764703313808)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\7528\4F86\552F\4E00\8B58\5225\6B64\5143\4EF6\4E4B\8CC7\6599\5217\7684\7B2C\4E8C\500B\8CC7\6599\6B04. \60A8\7684\8868\683C\82E5\6709\5169\500B\90E8\5206\7684\4E3B\7D22\5F15\9375, \8ACB\4F7F\7528\6B64\5C6C\6027.</p>'),
unistr('<p>\70BA\4E86\652F\63F4\56DE\6EAF\76F8\5BB9\6027, \53EF\7528\8CC7\6599\6B04\6E05\55AE\4E2D\4E5F\5305\62EC\4E86 <strong>ROWID</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109571654493313808)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\552F\4E00\8CC7\6599\6B04 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109571976949313808)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\7528\4F86\552F\4E00\8B58\5225\6B64\5143\4EF6\4E4B\8CC7\6599\5217\7684\7B2C\4E09\500B\8CC7\6599\6B04. \60A8\7684\8868\683C\82E5\6709\4E09\500B\90E8\5206\7684\4E3B\7D22\5F15\9375, \8ACB\4F7F\7528\6B64\5C6C\6027.</p>'),
unistr('<p>\70BA\4E86\652F\63F4\56DE\6EAF\76F8\5BB9\6027, \53EF\7528\8CC7\6599\6B04\6E05\55AE\4E2D\4E5F\5305\62EC\4E86 <strong>ROWID</strong>.</p>'),
unistr('<p>\6CE8\610F: \82E5\60A8\8868\683C\7684\4E3B\7D22\5F15\9375\4F7F\7528\4E09\500B\4EE5\4E0A\7684\8CC7\6599\6B04, \5247\5FC5\9808\4EE5 <strong>ROWID</strong> \552F\4E00\8B58\5225\8CC7\6599\5217.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109571894949313808)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\552F\4E00\8CC7\6599\6B04 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109459374263313720)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\7528\4F86\9650\5236\8AB0\80FD\5920\66F4\65B0\8CC7\6599\5217\7684\6388\6B0A\914D\7F6E.'),
unistr('\82E5\8981\8B93\4E00\822C\4F7F\7528\8005\66F4\65B0\8CC7\6599\5217, \8A72\4F7F\7528\8005\7684\9019\500B\6388\6B0A\914D\7F6E\5FC5\9808\8A55\4F30\70BA TRUE.'),
unistr('\5982\679C\672A\63D0\4F9B\6388\6B0A\914D\7F6E, \5247\4EFB\4F55\4F7F\7528\8005\90FD\53EF\4EE5\5728\6B64\4E92\52D5\5F0F\65B9\683C\4E2D\66F4\65B0\8CC7\6599\5217.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109459251241313720)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109346882725313635)
,p_name=>'PE.PROPERTY.USER_INTERFACE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\6B64\9801\9762\7684\4F7F\7528\8005\4ECB\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109346728261313635)
,p_name=>'PE.PROPERTY.USER_INTERFACE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109381452830313661)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\9801\9762\7684\4F7F\7528\8005\4ECB\9762\985E\578B. \5C0D\65BC\4E3B\8981\91DD\5C0D\684C\9762\4F7F\7528\800C\8A2D\8A08\7684\61C9\7528\7A0B\5F0F, \8ACB\9078\53D6<strong>\684C\9762</strong>. \82E5\70BA\5176\4ED6\4ECB\9762 (\4F8B\5982, \667A\6167\578B\624B\6A5F\6216\5E73\677F\96FB\8166), \8ACB\9078\53D6\5C0D\61C9\7684\4F7F\7528\8005\4ECB\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109765627166313973)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.LOV.DESKTOP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\684C\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109765767951313973)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.LOV.JQM_SMARTPHONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('jQuery Mobile \667A\6167\578B\624B\6A5F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109381334237313661)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109596592537313826)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6B64\8CC7\6599\6B04\662F\5426\4E5F\8981\986F\793A\5728\300C\8CC7\6599\5217\6A19\982D\300D\4E2D.'),
unistr('\5305\62EC\8CC7\6599\6B04\503C\53EF\4EE5\5728\5831\8868\4E2D\5448\73FE\8868\55AE\6B04\4F4D, \63D0\4F9B\66F4\597D\7684\8F14\52A9\529F\80FD.'),
unistr('\6307\5B9A\4E4B\5F8C, \5C31\6703\4F7F\7528\300C\8CC7\6599\5217\6A19\982D\300D\8207\300C\8CC7\6599\6B04\6A19\982D\300D\4E00\8D77\5448\73FE\5831\8868\4E2D\8868\55AE\6B04\4F4D\7684\6A19\7C64, \5176\683C\5F0F\70BA <code>''&lt;Column Header&gt; : &lt;Row Header&gt;''</code>.</p>'),
unistr('<p>\4F8B\5982, \5047\8A2D\60A8\5728 EMP \8868\683C\6709\4E00\500B\5831\8868\4E26\5B9A\7FA9 ENAME \8CC7\6599\6B04\4F5C\70BA\300C\8CC7\6599\5217\6A19\982D\300D. \5982\679C\67D0\500B\8CC7\6599\5217\7684 ENAME \662F ''JONES'', \5247\8A72\8CC7\6599\5217\4E2D Salary \6B04\4F4D\7684\6A19\7C64\5C07\6703\662F "Salary : JONES".'),
unistr('\9019\7A2E\65B9\6CD5\53EF\8B93\87A2\5E55\52A9\8B80\7A0B\5F0F\4F7F\7528\8005\4F9D\5831\8868\4E2D\7684\300C\8868\55AE\300D\6B04\4F4D\9032\884C\700F\89BD, \540C\6642\4ECD\7136\80FD\5920\77E5\9053\54EA\4E9B\8868\55AE\6B04\4F4D\8207\54EA\500B\8CC7\6599\5217\76F8\95DC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109596493408313826)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F5C\70BA\8CC7\6599\5217\6A19\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109624850839313851)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\70BA\300C\5716\793A\6AA2\8996\300D\5B9A\7FA9\81EA\8A02\9023\7D50. \6B64\9078\9805\5728\5B9A\7FA9\300C\5716\793A\6AA2\8996\300D\7684\5167\5BB9\65B9\9762\63D0\4F9B\8F03\5927\7684\5F48\6027, \5305\62EC\80FD\5920\4F7F\7528\4E00\500B\4EE5\4E0A\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109624788449313851)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109343973096313632)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\9A57\8B49\7684\76F8\95DC\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109343824140313632)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\7DE8\8F2F\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109342479540313631)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\8981\70BA\9019\500B\9A57\8B49\6E2C\8A66\7684\76F8\7B49\985E\578B. \4F9D\64DA\60A8\7684\9078\64C7\9805\76EE\800C\5B9A, \53EF\80FD\9700\8981\4E00\6216\591A\500B\5176\4ED6\5C6C\6027, \624D\80FD\5B8C\6574\5B9A\7FA9\9019\500B\9A57\8B49.</p>'),
unistr('<p>\5982\679C\9A57\8B49\901A\904E\76F8\7B49\6E2C\8A66, \6216\8A55\4F30\70BA TRUE, \5C07\4E0D\6703\986F\793A\9A57\8B49\932F\8AA4\8A0A\606F.'),
unistr('\5982\679C\9A57\8B49\672A\901A\904E\76F8\7B49\6E2C\8A66\3001\8A55\4F30\70BA FALSE \6216\50B3\56DE\975E\7A7A\767D\7684\6587\5B57\5B57\4E32, \5C31\6703\986F\793A\9A57\8B49\932F\8AA4\8A0A\606F.</p>'),
unistr('<p>\9A57\8B49\5931\6557\4E26\4E0D\6703\5C0E\81F4\505C\6B62\5F8C\7E8C\7684\9A57\8B49\8A55\4F30, \56E0\6B64\6BCF\500B\5F8C\7E8C\7684\9A57\8B49\53EF\80FD\6703\5F15\767C\5176\4ED6\7684\9A57\8B49\932F\8AA4\8A0A\606F. \5982\679C\60A8\60F3\8981\505C\6B62\57F7\884C\5F8C\7E8C\7684\9A57\8B49, \5C31\5FC5\9808\5C07\5176\4ED6\908F\8F2F\52A0\5230\7B2C\4E00\500B\5931\6557\7684\9A57\8B49\4E2D (\4F8B\5982\5C07\67D0\500B\9801\9762\9805\76EE\8A2D\6210\7279\5B9A\503C), \7136\5F8C\8996\9700\8981\5728\5F8C\7E8C\7684\9A57\8B49\4E0A\589E\5F37\689D\4EF6\6027\908F\8F2F. \5982\679C\4E00\6216\591A\500B\9A57\8B49\672A\901A\904E\8A55\4F30, \5C07\4E0D\6703\57F7\884C\5F8C\7E8C\7684\8655\7406\4F5C\696D\548C\5206\652F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109799191913313998)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109799207767313998)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C SQL \67E5\8A62\50B3\56DE\4E00\500B\6216\591A\500B\8CC7\6599\5217, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C SQL \67E5\8A62\672A\50B3\56DE\8CC7\6599\5217, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110005326933314147)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110005497884314147)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8868\793A\5F0F\8A55\4F30\70BA TRUE, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\8868\793A\5F0F\8A55\4F30\70BA FALSE, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109799751666313998)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\4E3B\9AD4 (\50B3\56DE\5E03\6797\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109799830429313998)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\51FD\6578\4E3B\9AD4\50B3\56DE TRUE, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\51FD\6578\4E3B\9AD4\50B3\56DE FALSE, \5247\5931\6557.<br>'),
unistr('\6CE8\610F: \51FD\6578\50B3\56DE\7684\7D50\679C\5FC5\9808\662F\5E03\6797\503C.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109799978822313998)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\4E3B\9AD4 (\50B3\56DE\932F\8AA4\6587\5B57)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109800043050313998)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\51FD\6578\4E3B\9AD4\50B3\56DE\7A7A\767D\5B57\4E32, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\51FD\6578\4E3B\9AD4\50B3\56DE\975E\7A7A\767D\5B57\4E32, \5247\5931\6557. \50B3\56DE\7684\5B57\4E32\6703\986F\793A\9A57\8B49\7684\932F\8AA4\8A0A\606F.<br>'),
unistr('\6CE8\610F: \51FD\6578\50B3\56DE\7684\7D50\679C\5FC5\9808\662F\6587\5B57\5B57\4E32.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109800727560313999)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\5305\542B\7A7A\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109800878795313999)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9805\76EE\503C\6C92\6709\7A7A\683C, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\9805\76EE\503C\5305\542B\7A7A\683C, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109802796207314000)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\81F3\5C11\5305\542B\503C\4E2D\7684\4E00\500B\5B57\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109802835749314001)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9805\76EE\503C\81F3\5C11\5305\542B\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\6587\5B57\7684\4E00\500B\5B57\5143, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\9805\76EE\503C\4E0D\5305\542B\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\6587\5B57\7684\4EFB\4F55\5B57\5143, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109802958340314001)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\5305\542B\503C\4E2D\7684\4EFB\4F55\5B57\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109803069732314001)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9805\76EE\503C\4E0D\5305\542B\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\6587\5B57\7684\4EFB\4F55\5B57\5143, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\9805\76EE\503C\81F3\5C11\5305\542B\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\6587\5B57\7684\4E00\500B\5B57\5143, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109802550051314000)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\50C5\5305\542B\5728\503C\4E2D\6307\5B9A\7684\5B57\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109802667795314000)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9805\76EE\503C\50C5\5305\542B\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\6587\5B57\7684\5B57\5143, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\9805\76EE\503C\5305\542B\4E0D\662F\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\6587\5B57\7684\4EFB\4F55\5B57\5143, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109801726096314000)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109801829045314000)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9805\76EE\503C\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\9805\76EE\503C\4E0D\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109802152992314000)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109802299734314000)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9805\76EE\503C\5B8C\5168\5305\542B\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\9805\76EE\503C\4E0D\5B8C\5168\5305\542B\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109801983816314000)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109802007019314000)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9805\76EE\503C\4E0D\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\9805\76EE\503C\7B49\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109802341334314000)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109802463067314000)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9805\76EE\503C\4E0D\5B8C\5168\5305\542B\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\9805\76EE\503C\5B8C\5168\5305\542B\65BC\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6587\5B57, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109800927211313999)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\70BA\6587\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109801031703313999)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9805\76EE\503C\70BA\6587\6578\5B57, \4EA6\5373\50C5\5305\542B\5B57\6BCD\8207\6578\5B57\4E14\6C92\6709\7279\6B8A\5B57\5143, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\9805\76EE\503C\5305\542B\7279\6B8A\5B57\5143, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109801319324313999)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\70BA\6709\6548\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109801446790313999)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9805\76EE\503C\70BA\6709\6548\65E5\671F, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\9805\76EE\503C\4E0D\662F\6709\6548\65E5\671F, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109801155108313999)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\70BA\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109801297634313999)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9805\76EE\503C\70BA\6578\5B57, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\9805\76EE\503C\5305\542B\975E\6578\5B57\5B57\5143 (\5305\62EC\4E0D\662F\524D\5C0E\7A7A\683C\7684\7A7A\683C), \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109801540827314000)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\70BA\6709\6548\6642\6233')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109801609519314000)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9805\76EE\503C\70BA\6709\6548\6642\6233, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\9805\76EE\503C\4E0D\662F\6709\6548\6642\6233, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109800186802313999)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109800240905313999)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9805\76EE\503C\975E\7A7A\767D, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\9805\76EE\503C\70BA\7A7A\767D, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109800355346313999)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\662F\7A7A\503C\6216\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109800439808313999)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9805\76EE\503C\975E\7A7A\767D\4E14\4E0D\662F\6578\5B57\96F6, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\9805\76EE\503C\70BA\7A7A\767D\6216\70BA\6578\5B57\96F6, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109800564058313999)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\4E0D\70BA\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109800620951313999)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9805\76EE\503C\4E0D\662F\6578\5B57\96F6, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C\9805\76EE\503C\70BA\6578\5B57\96F6, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109799314197313998)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\50B3\56DE\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109799469179313998)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C SQL \67E5\8A62\672A\50B3\56DE\8CC7\6599\5217, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C SQL \67E5\8A62\50B3\56DE\4E00\500B\6216\591A\500B\8CC7\6599\5217, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109799556647313998)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109799669832313998)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C PL/SQL \7A0B\5F0F\78BC\57F7\884C\6642\672A\7522\751F\932F\8AA4, \5247\901A\904E\9A57\8B49.<br>'),
unistr('\5982\679C PL/SQL \8868\793A\5F0F\57F7\884C\6642\7522\751F\932F\8AA4, \5247\5931\6557.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109803115141314001)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\7B26\5408\6B63\898F\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109803260518314001)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9805\76EE\503C\7B26\5408\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6B63\898F\8868\793A\5F0F, \5247\901A\904E\9A57\8B49.'),
unistr('\5982\679C\9805\76EE\503C\4E0D\7B26\5408\60A8\5728<em>\503C</em>\5C6C\6027\4E2D\8F38\5165\7684\6B63\898F\8868\793A\5F0F, \5247\5931\6557.<br>'),
unistr('\6CE8\610F: \6B63\898F\8868\793A\5F0F\53EF\8B93\60A8\4F7F\7528\6A19\6E96\8A9E\6CD5\6163\4F8B\4F86\641C\5C0B\5B57\4E32\4E2D\7684\6A23\5F0F, \800C\4E0D\53EA\662F\4F7F\7528\7C21\55AE\7684\5B57\5143\6BD4\8F03.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109342399991313631)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109527599709313771)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5EA7\6A19\8EF8\57FA\6E96\662F\5426\958B\59CB\65BC\8CC7\6599\7684\6700\5C0F\503C\6216\96F6. \50C5\9069\7528\65BC\6578\503C\8CC7\6599\8EF8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109527697473313771)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.MIN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5C0F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109527751669313771)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.ZERO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109527448263313771)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57FA\6E96\7E2E\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109559259416313799)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\96C6\5408\540D\7A31. \6B64\53C3\6578\503C\7684\4F86\6E90\5C07\6839\64DA\96C6\5408\4E2D\7B2C\4E00\500B\8CC7\6599\5217\7684 CLOB \8CC7\6599\6B04\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109559159074313795)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109513861297313761)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\8A2D\5B9A\5716\8868\683C\5F0F\6642\5C07\4F7F\7528\7684\5E63\5225.'),
unistr('        \8A72\503C\5FC5\9808\662F ISO 4217 \5B57\6BCD\5E63\5225\4EE3\78BC. \683C\5F0F\5982\679C\8A2D\70BA\5E63\5225, \4F46<strong>\5E63\5225</strong>\7279\6027\4E2D\672A\5B9A\7FA9\5E63\5225, \5C07\6703\5728\5448\73FE\5716\8868\6642, \81EA\52D5\5F9E\61C9\7528\7A0B\5F0F\8A9E\8A00\884D\751F\5E63\5225.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109513753750313761)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E63\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109639989477313862)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8981\5957\7528\81F3\5716\8868\4E0A\6578\503C\7684\5C0F\6578\4F4D\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109627512509313853)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\503C\6A19\7C64\4E2D\8981\4F7F\7528\7684\5C0F\6578\4F4D\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109627481774313853)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\6578\4F4D\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110016297947314155)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\8A55\4F30\6240\8F38\5165\8868\793A\5F0F\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110016647012314155)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110016503427314155)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110016429829314155)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110016783402314155)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110016396219314155)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110016188092314155)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109514230939313761)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5716\8868\4E0A\503C\7684\7E2E\653E\884C\70BA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109514419131313761)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.AUTO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109514788234313761)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.BILLION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5341\5104')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109514680098313761)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.MILLION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767E\842C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109514338011313761)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.NONE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109514905771313761)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.QUADRILLION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5343\5146')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109514552054313761)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.THOUSAND.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5343')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109514809892313761)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.TRILLION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5146')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109514170706313761)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F\7E2E\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109639857869313862)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\8981\5957\7528\81F3\5716\8868\503C\7684\683C\5F0F\985E\578B.'),
unistr('        <strong>\5C0F\6578</strong>\3001<strong>\767E\5206\6BD4</strong>\6216<strong>\5E63\5225</strong>\683C\5F0F\53EA\9069\7528\65BC\6578\503C.'),
unistr('        <strong>\65E5\671F</strong>\3001<strong>\6642\9593</strong>\4EE5\53CA<strong>\65E5\671F\6642\9593</strong>\683C\5F0F\53EA\9069\7528\65BC\5716\8868\4E0A\8A72\8CC7\6599\985E\578B\7684\503C.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109512258572313759)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\5728\5716\8868\503C\5957\7528\4E4B\683C\5F0F\7684\6578\503C\3001\65E5\671F\548C (\6216) \6642\9593\985E\578B.  \82E5\70BA\65E5\671F\548C (\6216) \6642\9593\683C\5F0F, \8ACB\78BA\5B9A\5716\8868\5C6C\6027<strong>\6642\9593\8EF8\985E\578B</strong>\8A2D\70BA\4E0B\5217\5176\4E2D\4E00\500B\503C (\4F9D\5716\8868\8CC7\6599\800C\5B9A): <strong>\555F\7528</strong>\3001<strong>\6DF7\5408\983B\7387</strong>\6216<strong>\7565\904E\9593\9694</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109513593874313760)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E63\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109650851933313870)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\6578\5B57\683C\5F0F\8A2D\70BA\5E63\5225, \5247\5E63\5225\7279\6027\5FC5\9808\8A2D\70BA\6307\5B9A\5728\8A2D\5B9A\6578\5B57\683C\5F0F\6642\8981\4F7F\7528\7684\5E63\5225.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109512669069313760)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F - \5B8C\6574\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109649768149313869)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\82E5\65E5\671F\70BA\5B8C\6574\683C\5F0F, \683C\5F0F\5316\5F8C\7684\65E5\671F\5C07\5305\542B\5B8C\6574\7684\5DE5\4F5C\65E5\540D\7A31 (EEEE)\3001\5E74\4EFD (y)\3001\5B8C\6574\7684\6708\4EFD\540D\7A31 (MMMM)\3001\65E5\6B21 (d). \4F8B\5982, Wednesday, January 6, 2016.'),
unistr('        \67D0\4E9B\8A9E\8A00\4E26\672A\4F7F\7528\5B8C\6574\7684\6708\4EFD\540D\7A31; \4F8B\5982, \65E5\6587\5C31\4F7F\7528\6578\503C\6708\4EFD\540D\7A31\6A23\5F0F.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109512561252313760)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F - \9577')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109649668914313869)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\65E5\671F\70BA\9577\683C\5F0F, \683C\5F0F\5316\5F8C\7684\65E5\671F\5C07\5305\542B\5E74\4EFD\3001\5B8C\6574\6708\4EFD\540D\7A31\3001\65E5\6B21. \4F8B\5982, January 6, 2016.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109512455771313760)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F - \4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109649551540313869)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\82E5\65E5\671F\70BA\6A19\6E96\683C\5F0F, \683C\5F0F\5316\5F8C\7684\65E5\671F\5C07\5305\542B\5E74\4EFD\3001\7E2E\5BEB\6708\4EFD\540D\7A31 (MMM)\3001\65E5\6B21. \4F8B\5982, Jan 6, 2016.'),
unistr('        \67D0\4E9B\8A9E\8A00\4E26\672A\4F7F\7528\7E2E\5BEB\6708\4EFD\540D\7A31, \56E0\6B64\6A19\6E96\683C\5F0F\5C07\5305\542B\6578\503C\6708\4EFD\540D\7A31 (MM/M).')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109512337232313759)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F - \77ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109649411063313869)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\65E5\671F\70BA\77ED\683C\5F0F, \683C\5F0F\5316\5F8C\7684\65E5\671F\5C07\5305\542B\5E74\4EFD\3001\6578\503C\6708\4EFD\540D\7A31 (MM/M)\3001\65E5\6B21. \4F8B\5982, 1/6/16.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109650509483313870)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F\6642\9593 - \5B8C\6574\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109650614492313870)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\82E5\65E5\671F\8207\6642\9593\70BA\5B8C\6574\683C\5F0F, \683C\5F0F\5316\5F8C\7684\65E5\671F\8207\6642\9593\5C07\5305\542B\5B8C\6574\7684\5DE5\4F5C\65E5\540D\7A31 (EEEE)\3001\5E74\4EFD (y)\3001\5B8C\6574\7684\6708\4EFD\540D\7A31 (MMMM)\3001\65E5\6B21 (d)\3001\5C0F\6642 (h/H)\3001\5206\9418 (mm)\3001\79D2 (ss) \4EE5\53CA\6642\5340 (zzzz). \4F8B\5982, Wednesday, January 6, 2016 7 h 30 min 21 s.'),
unistr('        \5C0F\6642\683C\5F0F\6703\8996\61C9\7528\7A0B\5F0F\8A9E\8A00\662F\5426\4F7F\7528 12 \5C0F\6642\5236\800C\5B9A.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109513325914313760)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F\6642\9593 - \9577')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109650499214313870)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\82E5\65E5\671F\8207\6642\9593\70BA\9577\683C\5F0F, \683C\5F0F\5316\5F8C\7684\65E5\671F\8207\6642\9593\5C07\5305\542B\5E74\4EFD\3001\5B8C\6574\7684\6708\4EFD\540D\7A31\3001\65E5\6B21\3001\6642\3001\5206\3001\79D2\4EE5\53CA\6642\5340 (z). \4F8B\5982, Jan 6, 2016 7:30:21 AM.'),
unistr('        \5C0F\6642\683C\5F0F\6703\8996\61C9\7528\7A0B\5F0F\8A9E\8A00\662F\5426\4F7F\7528 12 \5C0F\6642\5236\800C\5B9A.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109513256157313760)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F\6642\9593 - \4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109650370406313870)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\82E5\65E5\671F\8207\6642\9593\70BA\6A19\6E96\683C\5F0F, \683C\5F0F\5316\5F8C\7684\65E5\671F\8207\6642\9593\5C07\5305\542B\5E74\4EFD\3001\7E2E\5BEB\6708\4EFD\540D\7A31 (MMM)\3001\65E5\6B21\3001\6642\3001\5206\3001\79D2\4EE5\53CA\6642\5340 (z). \4F8B\5982, Jan 6, 2016 7:30:21 AM.'),
unistr('        \5C0F\6642\683C\5F0F\6703\8996\61C9\7528\7A0B\5F0F\8A9E\8A00\662F\5426\4F7F\7528 12 \5C0F\6642\5236\800C\5B9A.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109513104748313760)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F\6642\9593 - \77ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109650207100313870)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\82E5\65E5\671F\8207\6642\9593\70BA\77ED\683C\5F0F, \683C\5F0F\5316\5F8C\7684\65E5\671F\8207\6642\9593\5C07\5305\542B\5E74\4EFD\3001\6578\503C\6708\4EFD\540D\7A31 (MM/M)\3001\65E5\6B21\3001\6642\3001\5206. \4F8B\5982, 1/6/16 7:30 AM.'),
unistr('        \5C0F\6642\683C\5F0F\6703\8996\61C9\7528\7A0B\5F0F\8A9E\8A00\662F\5426\4F7F\7528 12 \5C0F\6642\5236\800C\5B9A.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109513434140313760)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\6578\4F4D\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109650746639313870)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\6578\5B57\7684\683C\5F0F\5177\6709\5C0F\6578, \5247\5FC5\9808\4EE5\8A9E\8A00\4E2D\6700\9069\7576\7684\7B26\865F\4F86\53D6\4EE3\5C0F\6578\9EDE\5B57\5143. \5728\82F1\6587\4E2D\662F\4F7F\7528\5C0F\6578\9EDE ("."), \4F46\8A31\591A\5176\4ED6\8A9E\8A00\662F\4F7F\7528\9017\865F (",").')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109513647927313760)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109650947232313870)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\6578\5B57\683C\5F0F\8A2D\70BA\767E\5206\6BD4, \5247\7CFB\7D71\6703\5C07\5716\8868\4E0A\7684\503C\4E58\4EE5 100, \4EE5\4FBF\5C07\5176\8A2D\70BA\767E\5206\6BD4\683C\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109513030666313760)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\9593 - \5B8C\6574\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109650107265313870)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\82E5\6642\9593\70BA\5B8C\6574\683C\5F0F, \683C\5F0F\5316\5F8C\7684\6642\9593\5C07\5305\542B\6642 (h/H)\3001\5206 (mm)\3001\79D2 (ss) \4EE5\53CA\6642\5340 (zzzz). \4F8B\5982, 7 h 30 min 21 s.'),
unistr('        \5C0F\6642\683C\5F0F\6703\8996\61C9\7528\7A0B\5F0F\8A9E\8A00\662F\5426\4F7F\7528 12 \5C0F\6642\5236\800C\5B9A.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109512994552313760)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\9593 - \9577')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109650055113313870)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\82E5\6642\9593\70BA\9577\683C\5F0F, \683C\5F0F\5316\5F8C\7684\6642\9593\5C07\5305\542B\6642\3001\5206\3001\79D2\4EE5\53CA\6642\5340. \4F8B\5982, 7:30:21 AM.'),
unistr('        \5C0F\6642\683C\5F0F\6703\8996\61C9\7528\7A0B\5F0F\8A9E\8A00\662F\5426\4F7F\7528 12 \5C0F\6642\5236\800C\5B9A.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109512802372313760)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\9593 - \4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109649900088313870)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\82E5\6642\9593\70BA\6A19\6E96\683C\5F0F, \683C\5F0F\5316\5F8C\7684\6642\9593\5C07\5305\542B\6642\3001\5206\3001\79D2. \4F8B\5982, 7:30:21 AM.'),
unistr('        \5C0F\6642\683C\5F0F\6703\8996\61C9\7528\7A0B\5F0F\8A9E\8A00\662F\5426\4F7F\7528 12 \5C0F\6642\5236\800C\5B9A.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109512763665313760)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\9593 - \77ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109649877393313870)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\82E5\6642\9593\70BA\77ED\683C\5F0F, \683C\5F0F\5316\5F8C\7684\6642\9593\5C07\5305\542B\6642\3001\5206. \4F8B\5982, 7:30 AM.'),
unistr('        \5C0F\6642\683C\5F0F\6703\8996\61C9\7528\7A0B\5F0F\8A9E\8A00\662F\5426\4F7F\7528 12 \5C0F\6642\5236\800C\5B9A.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109512197199313759)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110018282259314156)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\51FD\6578\4E3B\9AD4\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110018554268314156)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110018448084314156)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110018323477314156)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110018636334314156)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110018152279314156)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109556116438313792)
,p_name=>'PE.PROPERTY.VALUE_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\4F5C\70BA\6B64\53C3\6578\503C\4F86\6E90\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.'),
unistr('\60A8\53EF\4EE5\9375\5165\540D\7A31, \6216\5F9E\53EF\7528\9805\76EE\7684\6E05\55AE\4E2D\6311\9078.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109556010065313792)
,p_name=>'PE.PROPERTY.VALUE_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110017853767314156)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\7522\751F\503C\4F5C\70BA\6B64\53C3\6578\503C\4F86\6E90\7684 Java \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110017737859314156)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110019407175314157)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\50B3\56DE\503C\4F5C\70BA\6B64\53C3\6578\503C\4F86\6E90\7684 Java \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110019310820314157)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110017641185314156)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1\5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110017513793314156)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\7522\751F\503C\4F5C\70BA\6B64\53C3\6578\503C\4F86\6E90\7684 JavaScript \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110017478826314156)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110019220283314157)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110019112608314157)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\50B3\56DE\503C\4F5C\70BA\6B64\53C3\6578\503C\4F86\6E90\7684 JavaScript \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110019063017314157)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109512064834313759)
,p_name=>'PE.PROPERTY.VALUE_MIN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\5716\8868\7684\6700\5C0F\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109511990720313759)
,p_name=>'PE.PROPERTY.VALUE_MIN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5C0F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109640020984313862)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8981\5957\7528\81F3\5716\8868\4E0A\6578\503C\7684\6578\503C\6A23\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110131714224314257)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\4EE3\8868\83EF\6C0F\6EAB\5EA6\7684\6578\503C\6A23\5F0F, \4F8B\5982 15&deg;F:</dt>'),
'<dd><pre>',
'#&deg;F',
'</pre></dd>',
unistr('<dt>\4EE3\8868\7279\5B9A\683C\5F0F\6578\5B57\7684\6578\503C\6A23\5F0F, \4F8B\5982 12,30,00:</dt>'),
'<dd><pre>',
'##,##,##',
'</pre></dd>',
unistr('<dt>\4EE3\8868\516C\91D0\70BA\55AE\4F4D\6578\5B57\7684\6578\503C\6A23\5F0F:</dt>'),
'<dd><pre>',
'# mm',
'</pre></dd>',
unistr('<dt>\4EE3\8868\300C\6708\4EFD\5E74\5EA6\300D\683C\5F0F\65E5\671F\7684\65E5\671F\6A23\5F0F, \4F8B\5982 Jul 2016:</dt>'),
'<dd><pre>',
'MMM yyyy',
'</pre></dd>',
unistr('<dt>\4EE3\8868\300C\6708\4EFD\300D\683C\5F0F\65E5\671F\7684\65E5\671F\6A23\5F0F, \4F8B\5982 July:</dt>'),
'<dd><pre>',
'MMMM',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109514038842313761)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\9078\64C7\6027\7684\672C\5730\5316\6578\503C\6216\65E5\671F\6A23\5F0F, \6A23\5F0F\4E2D\4F7F\7528\7684\5B57\5143\5FC5\9808\7B26\5408\65E5\671F\6642\9593\683C\5F0F\7684 Unicode CLDR.'),
unistr('        \5982\679C\6307\5B9A, \9019\6703\8986\5BEB\9078\53D6\7684\683C\5F0F.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109513930222313761)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110017353425314156)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1\5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110017202339314156)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\7522\751F\503C\4F5C\70BA\6B64\53C3\6578\503C\4F86\6E90\7684 PL/SQL \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110017131398314155)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110018906663314157)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\7DE8\5236\5728\90E8\9580 30 \5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110018896304314157)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\50B3\56DE\503C\4F5C\70BA\6B64\53C3\6578\503C\4F86\6E90\7684 PL/SQL \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110018736263314157)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108985457555313354)
,p_name=>'PE.PROPERTY.VALUE_POSITION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\503C\5728\5716\8868\4E0A\7684\986F\793A\4F4D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108984831625313354)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108985521453313355)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\503C\5C07\6703\986F\793A\5728\5716\8868\7684\9810\8A2D\4F4D\7F6E, \4EA6\5373\7E6A\5716\5340\5916\5074.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108984970649313354)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7F6E\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108985615218313355)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\503C\5C07\6703\986F\793A\5728\5716\8868\6307\793A\5668\7684\4E2D\592E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108985025764313354)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\793A\5668\908A\7DE3\5167\5074')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108985775420313355)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\503C\5C07\6703\986F\793A\5728\5716\8868\6307\793A\5668\7684\908A\7DE3\5167\5074.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108985129555313354)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\793A\5668\908A\7DE3\5916\5074')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108985831526313355)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\503C\5C07\6703\986F\793A\5728\5716\8868\6307\793A\5668\7684\908A\7DE3\5916\5074.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108985239706313354)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E6A\5716\5340\5916\5074')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108985957893313355)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\503C\5C07\6703\986F\793A\5728\5716\8868\7684\7E6A\5716\5340\5916\5074.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108985363212313354)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\542B\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108986004375313355)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\5982\679C\5448\73FE\6A19\7C64, \503C\5C07\6703\548C\6A19\7C64\986F\793A\5728\540C\4E00\4F4D\7F6E. \82E5\672A\5448\73FE\6A19\7C64, \503C\5C07\6703\986F\793A\5728\5716\8868\7684\7E6A\5716\5340\5916\5074.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108984776822313354)
,p_name=>'PE.PROPERTY.VALUE_POSITION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109556351998313793)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4F5C\70BA\6B64\53C3\6578\503C\4F86\6E90\7684\300C\4F7F\7528\8005\504F\597D\8A2D\5B9A\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109556290091313792)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110018029333314156)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\7522\751F\503C\4F5C\70BA\6B64\53C3\6578\503C\4F86\6E90\7684 Python \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110017974409314156)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110019638095314157)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\50B3\56DE\503C\4F5C\70BA\6B64\53C3\6578\503C\4F86\6E90\7684 Python \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110019530731314157)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109555932336313792)
,p_name=>'PE.PROPERTY.VALUE_QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4F5C\70BA\6B64\53C3\6578\503C\4F86\6E90\7684 SQL \67E5\8A62. \82E5\50B3\56DE\4E00\500B\4EE5\4E0A\7684\8CC7\6599\5217, \5247\6703\4F7F\7528\7B2C\4E00\500B\8CC7\6599\5217\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109555867631313792)
,p_name=>'PE.PROPERTY.VALUE_QUERY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109243208657313552)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\82E5\8A2D\70BA<strong>\958B\555F</strong>, \4E14\53EF\898B\5230\9801\9762\9805\76EE, &PRODUCT_NAME. \5C07\6703\5728\9001\51FA\9801\9762\6642\81EA\52D5\57F7\884C\300C\4E0D\662F\7A7A\503C\300D\9A57\8B49.</p>'),
unistr('<p>\85C9\7531\5728\300C\5171\7528\5143\4EF6 > \6587\5B57\8A0A\606F\300D\4E2D\5B9A\7FA9\540D\70BA <strong>APEX.PAGE_ITEM_IS_REQUIRED</strong> \7684\8A0A\606F, \5373\53EF\5C07\9810\5148\5B9A\7FA9\7684\932F\8AA4\6587\5B57\53D6\4EE3\70BA\61C9\7528\7A0B\5F0F\7279\5B9A\932F\8AA4\8A0A\606F.</p>'),
unistr('<p>\8A0A\606F\7684\986F\793A\4F4D\7F6E\7531\61C9\7528\7A0B\5F0F\5C64\7D1A\8A2D\5B9A<strong>\9810\8A2D\932F\8AA4\986F\793A\4F4D\7F6E</strong>\5B9A\7FA9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109243154576313552)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110017093380314155)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\54E1\5DE5\82E5\70BA\4E3B\7BA1\4E14\5176\90E8\9580\4F4D\65BC\829D\52A0\54E5\5247\50B3\56DE YES:</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110016966397314155)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\53EF\7522\751F\503C\4F5C\70BA\6B64\53C3\6578\503C\4F86\6E90\7684 SQL \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110016886389314155)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109555715128313792)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4F5C\70BA\6B64\53C3\6578\503C\4F86\6E90\7684\975C\614B\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109555657089313792)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109638040599313861)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\503C\5728\5716\8868\4E0A\7684\986F\793A\65B9\5F0F (\4EE5\7E3D\8A08\503C\7684\6578\5B57\6216\767E\5206\6BD4\986F\793A).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109637875930313860)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109640314958313862)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\503C\5C07\6703\4EE5\6578\5B57\65B9\5F0F\986F\793A\5728\5716\8868\4E0A.</p> <p>\6CE8\610F: <strong>\683C\5F0F</strong>\5C6C\6027\53EA\80FD\7528\65BC\5C0D\5716\8868\4E0A\986F\793A\7684\6A19\7C64\548C\503C\5957\7528\81EA\8A02\5C0F\6578\6216\5E63\5225\683C\5F0F.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109637984004313860)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109640423705313862)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\503C\5C07\6703\4EE5 0% \5230 100% \4E4B\9593\7684\767E\5206\6BD4\65B9\5F0F\986F\793A.</p> <p>\6CE8\610F: <strong>\683C\5F0F</strong>\82E5\8A2D\70BA<strong>\767E\5206\6BD4</strong>, \5716\8868\4E0A\7684\503C\4FBF\6703\4E58\4EE5 100, \5C07\683C\5F0F\8A2D\70BA\767E\5206\6BD4. \5982\8981\4F7F\7528\300C\683C\5F0F\300D\5C6C\6027, \8ACB\78BA\5B9A\5C07\300C\6A19\7C64\985E\578B\300D\8A2D\70BA\6578\5B57.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109637786712313860)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109554193035313791)
,p_name=>'PE.PROPERTY.VALUE_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6B64\53C3\6578\7684\586B\5165\65B9\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109558905766313794)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96C6\5408 (CLOB)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109559099839313795)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\4F86\81EA\8F38\5165\4E4B<em>\96C6\5408</em>\4E2D\7B2C\4E00\500B\8CC7\6599\5217\7684 CLOB \8CC7\6599\6B04\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109836081639314025)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \4F86\6E90\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109836174029314025)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\5B9A\7FA9\70BA REST \8CC7\6599\4F86\6E90\5167\9810\8A2D\503C\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109554494195313791)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109554599867313791)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\9078\53D6<em>\9805\76EE</em>\4E4B\968E\6BB5\4F5C\696D\72C0\614B\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109555447082313792)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109555516040313792)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6307\5B9A\503C, \56E0\6B64\8A2D\662F\7A7A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109554854791313791)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_EXPRESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109554930512313791)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\57F7\884C\8F38\5165\4E4B <em>PL/SQL \8868\793A\5F0F</em>\7684\7D50\679C\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109555078232313791)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109555182661313792)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B <em>PL/SQL \51FD\6578\4E3B\9AD4</em>\50B3\56DE\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109555267403313792)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109555339295313792)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\8F38\5165\7684<em>\504F\597D\8A2D\5B9A</em>\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109554604900313791)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62 (\50B3\56DE\55AE\4E00\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109554756472313791)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5F9E\8F38\5165\4E4B <em>SQL \67E5\8A62</em>\50B3\56DE\7684\7B2C\4E00\500B\503C.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109554254298313791)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109554331573313791)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\5728<em>\975C\614B\503C</em>\4E2D\8F38\5165\7684\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109554019057313791)
,p_name=>'PE.PROPERTY.VALUE_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110007213296314149)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\8A55\4F30\6240\8F38\5165\8868\793A\5F0F\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110007652639314149)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110007590847314149)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110007424134314149)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110007770360314149)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110007365296314149)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110007168668314149)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110009283972314150)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\51FD\6578\4E3B\9AD4\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110009566160314150)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110009431555314150)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110009338425314150)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110009659325314150)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110009169183314150)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110005688649314148)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\57F7\884C\6240\8F38\5165\51FD\6578\4E3B\9AD4\7684\8A9E\8A00.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110005948148314148)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110005884259314148)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-tw'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110005766582314148)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110006060549314148)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110005597474314147)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109702075664313923)
,p_name=>'PE.PROPERTY.VAL_ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B64\9A57\8B49\4E2D\4F7F\7528\7684\67D0\500B\9801\9762\9805\76EE\6216\67D0\500B\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109701931195313923)
,p_name=>'PE.PROPERTY.VAL_ITEM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110008825033314150)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5B9A\7FA9\9A57\8B49\7684 Java \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110008702565314150)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110010406297314151)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\5E03\6797\503C\4F5C\70BA\6B64\9A57\8B49\57FA\790E\7684 Java \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110010343605314151)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Java \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110006875810314148)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\932F\8AA4\8A0A\606F\6587\5B57\7684 Java \51FD\6578\4E3B\9AD4, \4EE5\4F5C\70BA\6B64\9A57\8B49\7684\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110006769553314148)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\932F\8AA4\6587\5B57\7684 Java \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110008662925314150)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\7576\54E1\5DE5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1, \82E5\8981\901A\904E\9A57\8B49\800C\4E0D\7522\751F\932F\8AA4\8A0A\606F:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110008528340314150)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5B9A\7FA9\9A57\8B49\7684 JavaScript \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110008433624314150)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110010220537314151)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\7576\54E1\5DE5\7DE8\5236\5728\90E8\9580 30, \82E5\8981\901A\904E\9A57\8B49\800C\4E0D\7522\751F\932F\8AA4\8A0A\606F:</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110010135519314151)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\5E03\6797\503C\4F5C\70BA\6B64\9A57\8B49\57FA\790E\7684 JavaScript \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110010050906314151)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110006684289314148)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\7576\54E1\5DE5\7DE8\5236\5728\90E8\9580 30, \82E5\8981\901A\904E\9A57\8B49\800C\4E0D\7522\751F\6307\5B9A\7684\932F\8AA4\8A0A\606F:</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Employee is in Department " + apex.env.P2_DEPTNO + " and not Department 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110006559548314148)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\932F\8AA4\8A0A\606F\6587\5B57\7684 JavaScript \51FD\6578\4E3B\9AD4, \4EE5\4F5C\70BA\6B64\9A57\8B49\7684\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110006490298314148)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\932F\8AA4\6587\5B57\7684 JavaScript \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110126937639314254)
,p_name=>'PE.PROPERTY.VAL_PLSQL.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\7576\54E1\5DE5\7DE8\5236\5728\90E8\9580 30, \82E5\8981\901A\904E\9A57\8B49\800C\4E0D\7522\751F\6307\5B9A\7684\932F\8AA4:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109701839606313923)
,p_name=>'PE.PROPERTY.VAL_PLSQL.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\767C\751F\932F\8AA4\7684 PL/SQL \8868\793A\5F0F, \4EE5\4F5C\70BA\6B64\9A57\8B49\7684\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109701764673313923)
,p_name=>'PE.PROPERTY.VAL_PLSQL.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767C\751F\932F\8AA4\7684 PL/SQL \7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110008360785314149)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\7576\54E1\5DE5\7DE8\5236\5728\90E8\9580 30 \6216\70BA\4E3B\7BA1, \82E5\8981\901A\904E\9A57\8B49\800C\4E0D\7522\751F\932F\8AA4\8A0A\606F:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110008215971314149)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5B9A\7FA9\9A57\8B49\7684 PL/SQL \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110008108676314149)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110009982852314151)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\7576\54E1\5DE5\7DE8\5236\5728\90E8\9580 30, \82E5\8981\901A\904E\9A57\8B49\800C\4E0D\7522\751F\932F\8AA4\8A0A\606F:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110009872158314150)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\5E03\6797\503C\4F5C\70BA\6B64\9A57\8B49\57FA\790E\7684 PL/SQL \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110009724267314150)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110006346375314148)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\7576\54E1\5DE5\7DE8\5236\5728\90E8\9580 30, \82E5\8981\901A\904E\9A57\8B49\800C\4E0D\7522\751F\6307\5B9A\7684\932F\8AA4\8A0A\606F:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        return ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110006273258314148)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\932F\8AA4\8A0A\606F\6587\5B57\7684 PL/SQL \51FD\6578\4E3B\9AD4, \4EE5\4F5C\70BA\6B64\9A57\8B49\7684\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110006192795314148)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\932F\8AA4\6587\5B57\7684 PL/SQL \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110009086428314150)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5B9A\7FA9\9A57\8B49\7684 Python \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110008912347314150)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110010651531314151)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\5E03\6797\503C\4F5C\70BA\6B64\9A57\8B49\57FA\790E\7684 Python \51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110010538330314151)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Python \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110007042058314149)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\50B3\56DE\932F\8AA4\8A0A\606F\6587\5B57\7684 Python \51FD\6578\4E3B\9AD4, \4EE5\4F5C\70BA\6B64\9A57\8B49\7684\57FA\790E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110006950676314148)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\932F\8AA4\6587\5B57\7684 Python \51FD\6578\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109702468921313924)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6B63\898F\8868\793A\5F0F, \4EE5\7528\4F86\6BD4\5C0D\70BA\6B64\9A57\8B49\6307\5B9A\7684\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109702307978313923)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\898F\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110008081005314149)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\7576\54E1\5DE5\70BA\4E3B\7BA1\6216\90E8\9580\4F4D\65BC\829D\52A0\54E5, \82E5\8981\901A\904E\9A57\8B49\800C\4E0D\7522\751F\932F\8AA4\8A0A\606F:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110007984482314149)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5B9A\7FA9\9A57\8B49\7684 SQL \8868\793A\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110007864767314149)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110126893056314254)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\7576\54E1\5DE5\7DE8\5236\5728\90E8\9580 30, \82E5\8981\8B93<strong>\50B3\56DE\8CC7\6599\5217</strong>\901A\904E\9A57\8B49\800C\4E0D\7522\751F\932F\8AA4\8A0A\606F:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\7576\54E1\5DE5\7DE8\5236\5728\90E8\9580 40, \82E5\8981\8B93<strong>\4E0D\50B3\56DE\8CC7\6599\5217</strong>\901A\904E\9A57\8B49\800C\4E0D\7522\751F\932F\8AA4\8A0A\606F:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno <> 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109701699341313923)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5B9A\7FA9\6B64\9A57\8B49\7684 SQL \67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109701578404313923)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109702230142313923)
,p_name=>'PE.PROPERTY.VAL_VALUE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\503C, \4EE5\7528\4F86\8207\70BA\6B64\9A57\8B49\6307\5B9A\7684\9805\76EE\8CC7\6599\6B04\503C\6BD4\8F03.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109702116849313923)
,p_name=>'PE.PROPERTY.VAL_VALUE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109832956664314023)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5C07\61C9\7528\7A0B\5F0F\7684\4F7F\7528\6642\9593\9650\5236\70BA\7279\5B9A\7684\4E0A\73ED\6642\9593</dt>'),
'<dd><pre>',
'function check_business_hours return boolean',
'is',
'begin',
'    return to_char(to_char(sysdate, ''hh24:mi'')) between ''08:00'' and ''17:00'';',
'end check_business_hours;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109325667867313619)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\5728\9806\5229\50B3\56DE\968E\6BB5\4F5C\696D\611F\6E2C\4E4B\5F8C\6240\547C\53EB\7684\51FD\6578\540D\7A31.'),
unistr('\53EF\4EE5\5728\300CPL/SQL \7A0B\5F0F\78BC\300D\5C6C\6027\4E2D\6216\5728\8CC7\6599\5EAB\4E2D\5B9A\7FA9\6B64\51FD\6578.'),
unistr('\7D50\679C\5FC5\9808\662F\5E03\6797\503C, \5176\4E2D "True" \4EE3\8868\4F7F\7528\8005\901A\904E\9A57\8B49, "False" \4EE3\8868\4F7F\7528\8005\672A\901A\904E\9A57\8B49.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109325511773313619)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\51FD\6578\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109263265496313567)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6240\6709\64F1\7F6E\4E2D\52D5\4F5C\662F\5426\8981\7B49\5F85\76EE\524D\52D5\4F5C\7684\7D50\679C.'),
unistr('\82E5\64F1\7F6E\4E2D\52D5\4F5C\76F8\4F9D\65BC\6B64\52D5\4F5C\7684\7D50\679C, \8ACB\5C07\6B64\5C6C\6027\8A2D\70BA<strong>\958B\555F</strong>,'),
unistr('\6216\8005\82E5\7121\76F8\4F9D\6027\4E14\53EF\4EE5\975E\540C\6B65\57F7\884C\800C\7121\9808\7B49\5F85, \8ACB\8A2D\70BA<strong>\95DC\9589</strong>.</p>'),
unistr('<p>\6CE8\610F: \7279\5B9A\52D5\4F5C\7684\57F7\884C\9806\5E8F\7531\6BCF\500B\52D5\4F5C\88AB\6307\5B9A\7684\9806\5E8F\6240\6C7A\5B9A.'),
unistr('\82E5\8981\78BA\4FDD\4EE5\76F8\540C\9806\5E8F\57F7\884C\52D5\4F5C, Oracle \5EFA\8B70\6240\6709\300CTrue \52D5\4F5C\300D\8207\6240\6709\300CFalse \52D5\4F5C\300D\90FD\5FC5\9808\6709\552F\4E00\7684\5E8F\865F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109263107447313567)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B49\5F85\7D50\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109351251817313638)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A REST \8CC7\6599\4F86\6E90\662F\5426\6709\672C\6A5F\540C\6B65\5316\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109351149008313638)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \8CC7\6599\4F86\6E90\6709\540C\6B65\5316\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109553989502313791)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109351447945313638)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\8B93\6B64\9805\76EE\4F7F\7528\672C\6A5F\8868\683C (\53EF\5728 REST \8CC7\6599\4F86\6E90\7684<strong>\540C\6B65\5316</strong>\5340\6BB5\5167\8A2D\5B9A), \800C\4E0D\662F\9023\7DDA\81F3\5916\90E8 REST \670D\52D9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109351338850313638)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\540C\6B65\5316\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109237434839313548)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\89F8\767C\52D5\614B\52D5\4F5C\7684\6309\9215.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109237329674313548)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109342101851313631)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\60A8\60F3\8981\8B93\6B64\9801\9762\8655\7406\5143\4EF6\53EA\5728\6307\5B9A\7684\6309\9215\88AB\6309\4E0B\6642\624D\57F7\884C, \8ACB\5F9E\6E05\55AE\4E2D\9078\53D6\6309\9215. \60A8\53EF\4EE5\5C07\6B64\6309\9215\689D\4EF6\8207\5176\4ED6\689D\4EF6\5408\4F75, \4EE5\9032\4E00\6B65\7CBE\78BA\8ABF\6574\6B64\9801\9762\8655\7406\5143\4EF6\7684\57F7\884C\6642\6A5F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109342024699313631)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E0B\6309\9215\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110098839815314215)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\89F8\767C\52D5\614B\52D5\4F5C\7684\4E00\6216\591A\500B\8CC7\6599\6B04.'),
unistr('\82E5\6709\591A\500B\8CC7\6599\6B04, \8ACB\4F7F\7528\9017\865F\5340\9694\6BCF\500B\9805\76EE\540D\7A31.'),
unistr('\60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\8CC7\6599\6B04\6E05\55AE\4E2D\6311\9078.'),
unistr('\5982\679C\5F9E\6E05\55AE\4E2D\6311\9078, \4E14\540C\6642\9593\5DF2\7D93\6709\8F38\5165\7684\6587\5B57\7684\8A71, \5C07\6703\5728\73FE\6709\6587\5B57\7684\7D50\5C3E\52A0\4E0A\4E00\500B\9017\865F, \5F8C\9762\518D\63A5\8457\5F9E\6E05\55AE\50B3\56DE\7684\8CC7\6599\6B04\540D\7A31.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110098759101314215)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109237839481313548)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165 DOM \7269\4EF6 (<code>document</code>\3001<code>window</code>) \6216 DOM \7269\4EF6\7684 <em>id</em> (<code>myElementID</code>) \4F5C\70BA\89F8\767C\52D5\614B\52D5\4F5C\7684\5143\7D20.</p>'),
unistr('<p>\6CE8\610F: <em>DOM \7269\4EF6</em>\5DF2\7D93\88AB\53D6\4EE3, \61C9\8A72\53D6\4EE3\70BA <em>JavaScript \8868\793A\5F0F</em>\6216 <em>jQuery \9078\53D6\5668</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109237726919313548)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('DOM \7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109237686888313548)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\89F8\767C\52D5\614B\52D5\4F5C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.'),
unistr('\82E5\6709\591A\500B\9805\76EE, \8ACB\4F7F\7528\9017\865F\5340\9694\6BCF\500B\9805\76EE\540D\7A31.'),
unistr('\60A8\53EF\4EE5\9375\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\6311\9078.'),
unistr('\5982\679C\5F9E\6E05\55AE\4E2D\6311\9078, \4E14\540C\6642\9593\5DF2\7D93\6709\8F38\5165\7684\6587\5B57\7684\8A71, \5C07\6703\5728\73FE\6709\6587\5B57\7684\7D50\5C3E\52A0\4E0A\4E00\500B\9017\865F, \5F8C\9762\518D\63A5\8457\5F9E\6E05\55AE\50B3\56DE\7684\9805\76EE\540D\7A31.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109237591138313548)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110094576536314211)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\50B3\56DE\700F\89BD\5668\4E4B <code>window</code> DOM \7269\4EF6\7684\53C3\7167.</dt>'),
'<dd><code>window</code></dd>',
unistr('<dt>\50B3\56DE\700F\89BD\5668\4E4B <code>document</code> DOM \7269\4EF6\7684\53C3\7167.</dt>'),
'<dd><code>document</code></dd>',
unistr('<dt>jQuery \9078\53D6\5668\6703\9078\53D6\985E\5225\70BA ''alert'' \7684\6240\6709 DIV \5143\7D20, \7136\5F8C\50B3\56DE\542B\6709\6240\6709\5176\7236\9805\7684 jQuery \7269\4EF6.</dt>'),
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110094464726314211)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\8981\8A55\4F30\7684 JavaScript \8868\793A\5F0F, \4EE5\50B3\56DE\55AE\4E00 DOM \7269\4EF6\3001DOM \7269\4EF6\9663\5217\6216 jQuery \7269\4EF6, \4F5C\70BA\89F8\767C\52D5\614B\52D5\4F5C\7684\5143\7D20.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110094386964314211)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109749258869313960)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\9078\53D6 DOM ID \70BA <code>my_id</code> \7684\9801\9762\5143\7D20</dt>'),
'<dd><pre>#my_id</pre></dd>',
unistr('<dt>\9078\53D6\542B\6709 <code>my_class</code> \985E\5225\7684\6240\6709\9801\9762\5143\7D20</dt>'),
'<dd><pre>.my_class</pre></dd>',
unistr('<dt>\9078\53D6\4F5C\70BA\8F38\5165\9805\7684\6240\6709\9801\9762\5143\7D20</dt>'),
'<dd><pre>input</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109238048273313549)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165 jQuery \9078\53D6\5668\8A9E\6CD5, \4EE5\50B3\56DE\4E00\6216\591A\500B\9801\9762\5143\7D20\4F86\89F8\767C\52D5\614B\52D5\4F5C. jQuery \7A0B\5F0F\5EAB\63D0\4F9B\5F37\5927\7684\9078\53D6\5668\8A9E\6CD5, \8B93\60A8\80FD\5920\8F15\6613\5B58\53D6\9801\9762\4E0A\7684\4E00\6216\591A\500B\5143\7D20.</p>'),
unistr('<p>\5982\9700\9078\53D6\5668\8A9E\6CD5\7684\8A73\7D30\8CC7\8A0A, \8ACB\53C3\95B1\4F4D\65BC <a rel="noreferrer" target="_blank" href="http://docs.jquery.com">jQuery homepage</a> \7684\5B98\65B9\6587\4EF6.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109237971472313548)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('jQuery \9078\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109474659399313732)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165<strong>\53EF\8655\7406\7684\8CC7\6599\5217\4E0A\9650</strong>\9650\5236\8D85\904E\6642\6240\986F\793A\7684\6587\5B57\8A0A\606F.'),
unistr('\9810\8A2D\8A0A\606F\6703\6307\793A\4E00\822C\4F7F\7528\8005\65B0\589E\5176\4ED6\7BE9\9078, \4EE5\9650\5236\6240\8981\8655\7406\7684\8A18\9304\7B46\6578.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109619980285313848)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7576\67E5\8A62\50B3\56DE\7684\8CC7\6599\5217\6578\76EE\8D85\904E\8F38\5165\7684\8CC7\6599\5217\8A08\6578\4E0A\9650\6642, \6240\8981\986F\793A\7684\6587\5B57\8A0A\606F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109901389830314072)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5716\5C64\8D85\904E<strong>\53EF\8655\7406\7684\8CC7\6599\5217\4E0A\9650</strong>\9650\5236\5F8C, <strong>\8A0A\606F</strong>\5340\57DF\4E2D\6240\986F\793A\7684\6587\5B57\8A0A\606F. \8ACB\5C0D\5BE6\969B\64F7\53D6\7684\8CC7\6599\5217\6578\76EE\4F7F\7528 <strong>#MAX_ROW_COUNT#</strong> \66FF\4EE3\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109605270837313836)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6709\5176\4ED6\5831\8868\8CC7\6599\5217\5B58\5728\6642\8981\986F\793A\7684\6587\5B57\8A0A\606F.'),
unistr('\60A8\53EF\4EE5\4F7F\7528\6B64\65B9\6CD5\4F86\66FF\4EE3\5206\9801, \7279\5225\662F\7576\5831\8868\4E00\822C\53EA\6709\96E2\6563\8CC7\6599\96C6\7684\6642\5019.'),
unistr('\5982\679C\5831\8868\67E5\8A62\50B3\56DE\5176\4ED6\8CC7\6599\5217, \4FBF\53EF\4F7F\7528\6B64\8A0A\606F\4F86\8B66\793A\4E00\822C\4F7F\7528\8005\6709\7570\5E38\72C0\6CC1, \800C\975E\50C5\50C5\986F\793A\4E9B\5FAE\4E0D\540C\7684\5206\9801\63A7\5236\9805.'),
unistr('\60A8\7684\6587\5B57\8A0A\606F\53EF\4EE5\7ACB\5373\7D0D\5165\4E00\500B\300C\52D5\4F5C\547C\53EB\300D, \4EE5\4FBF\70BA\4E00\822C\4F7F\7528\8005\63D0\4F9B\5982\4F55\56DE\61C9\6B64\4E0D\5C0B\5E38\67E5\8A62\7D50\679C\7684\6307\5C0E, \4E26\4E14\53EF\4EE5\7D0D\5165\9801\9762\6216 URL \9023\7D50.</p>'),
unistr('<p>\4EE5\4E0B\662F\53EF\4EE5\5728\60A8\7684\8A0A\606F\4E2D\4F7F\7528\7684\5206\9801\66FF\4EE3\5B57\4E32:</p>'),
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
unistr('    <dd>\986F\793A\7684\8CC7\6599\5217\6578\76EE (\9801\9762\5927\5C0F)</dd>'),
'  <dt><code>#TOTAL_ROWS#</code></dt>',
unistr('    <dd>\300C\8CC7\6599\5217 X - Y, \5171 Z \500B\300D\4E2D\7684 "Z"</dd>'),
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
unistr('    <dd>\300C\8CC7\6599\5217 X - Y, \5171 Z \500B\300D\4E2D\7684 "X"</dd>'),
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
unistr('    <dd>\300C\8CC7\6599\5217 X - Y, \5171 Z \500B\300D\4E2D\7684 "Y"</dd>'),
'  <dt><code>#ROW_RANGES"</code></dt>',
unistr('    <dd>\986F\793A: \8CC7\6599\5217 1-15 16-30 30-32</dd>'),
'  <dt><code>#ROW_RANGES_IN_SELECT_LIST</code></dt>',
unistr('    <dd>\8207\8CC7\6599\5217\7BC4\570D\76F8\540C, \4F46\5728\9078\53D6\6E05\55AE\4E2D<dd>'),
'  <dt><code>#INTERNET_PAGINATION#</code></dt>',
unistr('    <dd>\9801\9762\96C6: 1 2 3 4 5 6</dd>'),
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109605193428313836)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\5230\5176\4ED6\8CC7\6599\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110078975458314199)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7576\5716\8868\67E5\8A62\672A\50B3\56DE\4EFB\4F55\8CC7\6599\5217\6642, \6240\8981\986F\793A\7684\6587\5B57\8A0A\606F. \5982\679C\7559\767D, Oracle JET \5C07\81EA\52D5\4F7F\7528\9810\8A2D\8A0A\606F:\300C\6C92\6709\8CC7\6599\53EF\4F9B\986F\793A\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110031721727314166)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\5716\5C64\67E5\8A62\672A\50B3\56DE\4EFB\4F55\8CC7\6599\5217\6642, <strong>\8A0A\606F</strong>\5340\6240\8981\986F\793A\7684\6587\5B57\8A0A\606F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109569366676313806)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7576\67E5\8A62\672A\50B3\56DE\4EFB\4F55\8CC7\6599\5217\6642, \6240\8981\986F\793A\7684\6587\5B57\8A0A\606F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109569241046313806)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\8CC7\6599\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109237223384313548)
,p_name=>'PE.PROPERTY.WHEN_REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\89F8\767C\52D5\614B\52D5\4F5C\7684\5340\57DF\540D\7A31.'),
unistr('\4F8B\5982, \9019\6709\53EF\80FD\662F\300C\4E92\52D5\5F0F\5831\8868\300D\5340\57DF (\642D\914D\300C\91CD\65B0\6574\7406\5F8C\300D\4E8B\4EF6\4F7F\7528), \7528\4EE5\5B9A\7FA9\6BCF\7576\5831\8868\91CD\65B0\6574\7406\6642\89F8\767C\7684\52D5\614B\52D5\4F5C.</p>'),
unistr('<p>\7576\60A8\8981\70BA\5340\57DF\4E2D\591A\500B\9801\9762\9805\76EE\5B9A\7FA9\985E\4F3C\7684\884C\70BA\6642, \4FBF\53EF\4F7F\7528\5340\57DF\89F8\767C\52D5\614B\52D5\4F5C. \4E0D\904E, \9019\53EA\9069\7528\65BC\7531\8A72\5340\57DF\5167\9805\76EE\5F15\767C\7684\7279\5B9A\4E8B\4EF6.'),
unistr('\5982\9700\652F\63F4\6B64\5B9A\7FA9\985E\578B\7684\4E8B\4EF6\6E05\55AE\4EE5\53CA\5982\4F55\5229\7528\7684\7BC4\4F8B, \8ACB\53C3\95B1\300C\52D5\4F5C\300D\9801\9762\4E2D\300C\4E8B\4EF6\7BC4\570D\300D\7684<em>\53D7\5F71\97FF\7684\5143\7D20</em> &gt; <em>\9078\64C7\985E\578B</em>\7684\9805\76EE\300C\8AAA\660E\300D.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109237173161313548)
,p_name=>'PE.PROPERTY.WHEN_REGION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109237084511313548)
,p_name=>'PE.PROPERTY.WHEN_TYPE.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7528\4F86\89F8\767C\4E8B\4EF6\7684\9801\9762\5143\7D20\6216\5EFA\69CB\7684\985E\578B. \5982\9700\4F7F\7528\7279\5B9A\9078\64C7\985E\578B\7684\7BC4\4F8B, \8ACB\53C3\95B1\76F8\95DC\5C6C\6027\7684\300C\8AAA\660E\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109748911504313960)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110050380923314179)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7531\6309\9215\89F8\767C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110097061053314213)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110050594322314179)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7531\4E00\6216\591A\500B\8CC7\6599\6B04\89F8\767C.'' );'),
'    --',
'    store_property_lov_values (',
'        p_property_id   => l_property_id,',
'        p_display_value => ''DOM Object'',',
'        p_return_value  => ''DOM_OBJECT'',',
'        p_is_deprecated => ''Y'',',
unistr('        p_help_text     => q''~<p>\7531 DOM \7269\4EF6 (<code>document</code>\3001<code>window</code>) \6216 DOM \7269\4EF6\7684 <em>id</em> (<code>myElementID</code>) \89F8\767C.</p>'),
unistr('        <p>\6CE8\610F: <em>DOM \7269\4EF6</em>\5DF2\4E0D\518D\4F7F\7528, \8ACB\6539\7528 <em>JavaScript \8868\793A\5F0F</em>\6216 <em>jQuery \9078\53D6\5668</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109748826528313960)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110050236187314179)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7531\4E00\6216\591A\500B\9801\9762\9805\76EE\89F8\767C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110093776965314211)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('JavaScript \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110050728823314179)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7531 JavaScript \8868\793A\5F0F\50B3\56DE\7684\9801\9762\5143\7D20\89F8\767C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109749133071313960)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('jQuery \9078\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110050617216314179)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7531 jQuery \9078\53D6\5668\50B3\56DE\7684\4E00\6216\591A\500B\9801\9762\5143\7D20\89F8\767C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109749047309313960)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110050418197314179)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7531\5340\57DF\89F8\767C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109236944073313548)
,p_name=>'PE.PROPERTY.WHEN_TYPE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109292716730313594)
,p_name=>'PENDING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64F1\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109383176945313662)
,p_name=>'PENDING_ENTRIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64F1\7F6E\4E2D\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109391844003313669)
,p_name=>'PENDING_REQUESTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64F1\7F6E\4E2D\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109413926233313685)
,p_name=>'PERCENT_CLOSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8655\7406\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109411820383313684)
,p_name=>'PERCENT_COMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109414057353313685)
,p_name=>'PERCENT_OPENED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F85\8655\7406\767E\5206\6BD4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109371088095313653)
,p_name=>'PIE_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\9905\5716')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109393188998313670)
,p_name=>'PKC1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04 1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109393239545313670)
,p_name=>'PKC2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04 2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110085445397314203)
,p_name=>'PKG.APP.AVAILABLE.TO.INSTALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\5B89\88DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110085576510314203)
,p_name=>'PKG.APP.AVAILABLE.TO.UPGRADE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\5347\7D1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110085633835314204)
,p_name=>'PKG.APP.EVENTS_FOR_LAST_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\751F\7522\529B/\7BC4\4F8B\61C9\7528\7A0B\5F0F\4E8B\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110089020638314206)
,p_name=>'PKG.APP.USER_ACTIVITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4F4D\4F7F\7528\8005 - %1 \500B\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110128748603314255)
,p_name=>'PKG_APP_INSTALL.PREREQ_CHECK_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E0B\5217\5148\6C7A\689D\4EF6\6AA2\67E5\5931\6557.  \5FC5\9808\89E3\6C7A\9019\4E9B\554F\984C, \624D\80FD\5920\7E7C\7E8C\5B89\88DD\6B64\61C9\7528\7A0B\5F0F\548C\5B83\7684\652F\63F4\7269\4EF6.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110128931537314255)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7269\4EF6\5B58\5728: <br />'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110128817134314255)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_REQUIRED_PRIVS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5FC5\8981\6B0A\9650: <br />'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110114079709314244)
,p_name=>'PKG_APP_USER_TYPE_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\6B64\9801\9762\4F86\63A7\5236 Application Express \5DE5\4F5C\5340\7BA1\7406\54E1\3001\61C9\7528\7A0B\5F0F\958B\767C\4EBA\54E1\548C\4E00\822C\4F7F\7528\8005\7684\5B58\53D6\6B0A.</p>'),
'',
unistr('<p><strong>\5DE5\4F5C\5340\7BA1\7406\54E1</strong>\53EF\4EE5\5B89\88DD\3001\79FB\9664\6216\5347\7D1A\61C9\7528\7A0B\5F0F, \4EE5\53CA\7BA1\7406\4F7F\7528\8005\5E33\6236\548C\958B\767C\670D\52D9.</p>'),
'',
unistr('<p><strong>\958B\767C\4EBA\54E1</strong>\53EF\4EE5\5B89\88DD\3001\79FB\9664\6216\5347\7D1A\61C9\7528\7A0B\5F0F.</p>'),
'',
unistr('<p><strong>\4E00\822C\4F7F\7528\8005</strong>\6C92\6709\958B\767C\6B0A\9650, \53EA\80FD\5B58\53D6\672A\4F7F\7528\5916\90E8\8A8D\8B49\914D\7F6E\7684\61C9\7528\7A0B\5F0F.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110085307379314203)
,p_name=>'PLEASE_SELECT_A_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\5F9E\4E0B\65B9\6E05\55AE\4E2D\9078\53D6\5DE5\4F5C\5340')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109355059958313641)
,p_name=>'PLSQL'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109168825485313497)
,p_name=>'PLSQL_EXPRESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PLSQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109421730533313691)
,p_name=>'PLSQL_FUNCTION_BODY_LOV_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EE5\50B3\56DE SQL \6558\8FF0\53E5\4E4B PL/SQL \51FD\6578\4E3B\9AD4\70BA\57FA\790E\7684\503C\6E05\55AE\5305\542B\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109114810450313457)
,p_name=>'PLSQL_PROCEDURE'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109361303065313645)
,p_name=>'PLSQL_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \5340\57DF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109656302527313875)
,p_name=>'PLUG-IN FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Plug-in \6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109634713285313858)
,p_name=>'PLUGIN'
,p_message_language=>'zh-tw'
,p_message_text=>'Plug-In'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110038992716314171)
,p_name=>'PLUGIN.CATEGORY.COMPONENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110038616427314171)
,p_name=>'PLUGIN.CATEGORY.EFFECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6548\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110038829400314171)
,p_name=>'PLUGIN.CATEGORY.EXECUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110089714181314207)
,p_name=>'PLUGIN.CATEGORY.INIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D77\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110038443072314170)
,p_name=>'PLUGIN.CATEGORY.MISC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110029787005314164)
,p_name=>'PLUGIN.CATEGORY.NAVIGATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110038708042314171)
,p_name=>'PLUGIN.CATEGORY.NOTIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110038583932314171)
,p_name=>'PLUGIN.CATEGORY.STYLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109588637114313821)
,p_name=>'PLUGIN.DEPRECATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr(' [\5DF2\88AB\53D6\4EE3]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109374818560313656)
,p_name=>'PLUGIN.DISPLAY_NAME_POSTFIX'
,p_message_language=>'zh-tw'
,p_message_text=>' [Plug-in]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109921189139314087)
,p_name=>'PLUGIN.LEGACY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr(' [\820A\6709]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109541278896313781)
,p_name=>'PLUGIN.TYPE.AUTHENTICATION_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\914D\7F6E\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108920940201313303)
,p_name=>'PLUGIN.TYPE.AUTHORIZATION TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A\914D\7F6E\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108988676324313357)
,p_name=>'PLUGIN.TYPE.DYNAMIC ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108988074001313356)
,p_name=>'PLUGIN.TYPE.ITEM TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109686218590313905)
,p_name=>'PLUGIN.TYPE.PROCESS TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108988189953313357)
,p_name=>'PLUGIN.TYPE.REGION TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109405459977313679)
,p_name=>'PLUGIN.TYPE.REPORT COLUMN TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110150615604314272)
,p_name=>'PLUGIN_LINK_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7576\60A8\6B63\5728\8F38\5165\4F7F\7528 <code>&amp;APP_ID.</code>\3001<code>&amp;SESSION.</code> \548C <code>&amp;DEBUG.</code> \66FF\4EE3\5B57\4E32\4EE5\53CA <code>&amp;COLUMN_NAME.</code> \8A9E\6CD5\7684 URL, \5728\76EE\6A19\9801\9762\4E0A\8A2D\5B9A\8CC7\6599\5217 ID \6216\4E3B\7D22\5F15\9375, \6216\662F\8A2D\5B9A\984D\5916\7684\5C6C\6027\503C.</p>'),
unistr('<p><strong>\7BC4\4F8B</strong></p>'),
'<p><pre>f?p=&amp;APP_ID.:10:&amp;SESSION.::&amp;DEBUG.:10:P10_EMPNO:&amp;EMPNO.</pre></p>',
unistr('<p>\5982\9700 <code>f?p</code> \8A9E\6CD5\7684\8A73\7D30\8CC7\8A0A, \8ACB\53C3\95B1\300CApplication Express Builder \4F7F\7528\624B\518A\300D.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109406598153313680)
,p_name=>'PLUGIN_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB Plug-in.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109738284865313952)
,p_name=>'PNONUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7F8E\570B\4EE5\5916\7684\54E1\5DE5\767E\5206\6BD4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109116635860313458)
,p_name=>'POPUP_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5373\73FE\5F0F\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109455121611313717)
,p_name=>'POPUP_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5373\73FE\5F0F\503C\6E05\55AE\6A23\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109415556453313687)
,p_name=>'POST AUTH PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\5F8C\8655\7406\4F5C\696D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109415364124313686)
,p_name=>'PRE AUTH PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\524D\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109298666997313598)
,p_name=>'PRECISION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7CBE\78BA\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109635997850313859)
,p_name=>'PREFERENCES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109107768090313451)
,p_name=>'PREFS_APPLY_PERMISSIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528\6B0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109108331443313452)
,p_name=>'PREFS_NOACTION_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\9700\8981\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109108020154313451)
,p_name=>'PREFS_REVOKE_PERMISSIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64A4\92B7\6B0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108973824318313345)
,p_name=>'PREF_EQ_EXP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F\4E2D\7684\504F\597D\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108973959449313346)
,p_name=>'PREF_NE_EXP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F 1 \7684\504F\597D\8A2D\5B9A\503C\4E0D\7B49\65BC\8868\793A\5F0F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109075992490313427)
,p_name=>'PRESENTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE\65B9\5F0F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109135579766313472)
,p_name=>'PRINT SERVER NOT CONFIGURED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7121\6CD5\4F7F\7528\5831\8868\5217\5370\529F\80FD, \56E0\70BA\672A\8A2D\5B9A\5217\5370\4F3A\670D\5668.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109383502371313663)
,p_name=>'PRINT_SERVER_ADVANCED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\968E (\9700\8981 Oracle BI Publisher)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109383614946313663)
,p_name=>'PRINT_SERVER_STANDARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\6E96')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109368789271313651)
,p_name=>'PRIORITIZED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6392\5B9A\512A\5148\9806\5E8F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109379292376313659)
,p_name=>'PROBLEMS_CORRECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\6B63\7684\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109379196428313659)
,p_name=>'PROBLEMS_IDENTIFIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B58\5225\7684\554F\984C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109113576236313456)
,p_name=>'PROCEDURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110027038660314162)
,p_name=>'PROCESS.NATIVE_DATA_LOADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108891164894313280)
,p_name=>'PROCESS.NATIVE_PLSQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\7A0B\5F0F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108891248628313280)
,p_name=>'PROCESS.NATIVE_SEND_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\9001\96FB\5B50\90F5\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108977821231313349)
,p_name=>'PROCESSES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108911351919313296)
,p_name=>'PROCESSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5728\8655\7406\60A8\7684\8981\6C42, \8ACB\7A0D\5019')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109700868032313922)
,p_name=>'PRODUCTION_DOWN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\751F\7522\74B0\5883\505C\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110101176898314232)
,p_name=>'PRODUCT_PORTAL'
,p_message_language=>'zh-tw'
,p_message_text=>'Product Portal'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110115950191314245)
,p_name=>'PROMPT_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\793A: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108930945467313311)
,p_name=>'PROVIDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108931050807313311)
,p_name=>'PROVIDER_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\8005\96FB\5B50\90F5\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109387978604313666)
,p_name=>'PROVISIONED'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5DF2\4F48\5EFA'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109502425244313752)
,p_name=>'PROVISIONED_SPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\73FE\6709\5DF2\4F48\5EFA\7684\7A7A\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109383725536313663)
,p_name=>'PROVISIONING_MODE_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F9D\5177\6709\96FB\5B50\90F5\4EF6\9A57\8B49\7684\4F7F\7528\8005\8981\6C42\5340\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109383906944313663)
,p_name=>'PROVISIONING_MODE_MANUAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\624B\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109383826954313663)
,p_name=>'PROVISIONING_MODE_REQUEST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F9D\4F7F\7528\8005\8981\6C42\5340\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109122135228313462)
,p_name=>'PROVISION_REQUEST.ADMIN_INFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\54E1\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109123180505313463)
,p_name=>'PROVISION_REQUEST.CREATE_TBLSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\5EFA\7ACB\8868\683C\7A7A\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109123307297313463)
,p_name=>'PROVISION_REQUEST.DATAFILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\7A7A\9593\7684\8CC7\6599\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109121924070313462)
,p_name=>'PROVISION_REQUEST.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109122321418313462)
,p_name=>'PROVISION_REQUEST.EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109123279236313463)
,p_name=>'PROVISION_REQUEST.FLOW_XXX'
,p_message_language=>'zh-tw'
,p_message_text=>'APEX_XXX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109121615604313462)
,p_name=>'PROVISION_REQUEST.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109121470774313461)
,p_name=>'PROVISION_REQUEST.NEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F48\5EFA\65B0\7684 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109122961802313463)
,p_name=>'PROVISION_REQUEST.NO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109122737497313462)
,p_name=>'PROVISION_REQUEST.REUSE_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8907\4F7F\7528\73FE\6709\7684\7DB1\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109122623846313462)
,p_name=>'PROVISION_REQUEST.SCHEMA_INFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109123078908313463)
,p_name=>'PROVISION_REQUEST.SCHEMA_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109121770343313462)
,p_name=>'PROVISION_REQUEST.SGID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109121873936313462)
,p_name=>'PROVISION_REQUEST.SYSTEM_ASSIGNED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7CFB\7D71\6307\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109122433777313462)
,p_name=>'PROVISION_REQUEST.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109122203671313462)
,p_name=>'PROVISION_REQUEST.USER_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109121539993313461)
,p_name=>'PROVISION_REQUEST.WORKSPACE_INFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109122811001313462)
,p_name=>'PROVISION_REQUEST.YES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109426928837313695)
,p_name=>'PROXY_SERVER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EE3\7406\4E3B\6A5F\4F3A\670D\5668')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109108839404313452)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\91CD\65B0\6574\7406\4E0B\5217\7684\9805\76EE\8AAA\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109108964254313452)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\6B63\78BA, \8ACB\6309\4E00\4E0B\300C\5168\90E8\91CD\65B0\6574\7406\300D. \5426\5247, \8ACB\6309\4E00\4E0B\300C\53D6\6D88\300D.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109732686903313947)
,p_name=>'PURGE.ADMINISTRATORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\54E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109728352076313944)
,p_name=>'PURGE.BEGIN_DELETE_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\522A\9664\5DE5\4F5C\5340 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109728136162313944)
,p_name=>'PURGE.BEGIN_DROP_TABLESPACE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\958B\59CB\522A\9664\5DE5\4F5C\5340 %1 \7684\8868\683C\7A7A\9593 %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109727733298313943)
,p_name=>'PURGE.BEGIN_DROP_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\522A\9664\5DE5\4F5C\5340 %1 \7684\4F7F\7528\8005 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109727363148313943)
,p_name=>'PURGE.BEGIN_PURGE_OF_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\6C38\4E45\6E05\9664\5DE5\4F5C\5340 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109732519412313947)
,p_name=>'PURGE.BYTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\5143\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109728610950313944)
,p_name=>'PURGE.DELETE_WORKSPACE_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\5DE5\4F5C\5340 %0 \6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109728289791313944)
,p_name=>'PURGE.DROP_TABLESPACE_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\5DE5\4F5C\5340 %1 \7684\8868\683C\7A7A\9593 %0 \6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109728057210313944)
,p_name=>'PURGE.DROP_USER_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\5DE5\4F5C\5340 %1 \7684\4F7F\7528\8005 %0 \6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109727176710313943)
,p_name=>'PURGE.EMAIL_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\89AA\611B\7684 Oracle APEX \4F7F\7528\8005,'),
'',
unistr('%1 \4E0A\7684\5DE5\4F5C\5340 %0 \6700\8FD1\4E26\7121\4EFB\4F55\6D3B\52D5.  \7CFB\7D71\76EE\524D\6392\5B9A\5C07\65BC %2 \6216\4E4B\5F8C, \5C07\60A8\6C92\6709\6D3B\52D5\7684\5DE5\4F5C\5340\6C38\4E45\6E05\9664.'),
'',
unistr('\82E5\4E0D\8981\79FB\9664\60A8\7684\5DE5\4F5C\5340, \8ACB\6309\4E00\4E0B\4E0B\65B9\7684 URL, \7136\5F8C\9078\64C7\4E0D\8981\6C38\4E45\6E05\9664\60A8\7684\5DE5\4F5C\5340.  \60A8\5FC5\9808\5728 %3 \5929\5167\57F7\884C\6B64\52D5\4F5C.  \82E5\5DF2\4E0D\9700\518D\4F7F\7528\6B64\5DE5\4F5C\5340, \5247\4E0D\9700\8981\63A1\53D6\4EFB\4F55\52D5\4F5C.'),
'',
unistr('\78BA\8A8D\9023\7D50:  %4')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109727228294313943)
,p_name=>'PURGE.EMAIL_SUBJECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C38\4E45\6E05\9664\7684 Oracle APEX \5DE5\4F5C\5340:   %1 \4E0A\7684\5DE5\4F5C\5340 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109728409562313944)
,p_name=>'PURGE.END_DELETE_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\522A\9664\5DE5\4F5C\5340 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110039372126314171)
,p_name=>'PURGE.END_DROP_TABLESPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\522A\9664\5DE5\4F5C\5340 %1 \7684\8868\683C\7A7A\9593 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109727948700313943)
,p_name=>'PURGE.END_DROP_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\522A\9664\5DE5\4F5C\5340 %1 \7684\4F7F\7528\8005 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109725283543313941)
,p_name=>'PURGE.LOG.ADD_TO_PURGE_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340 %0 \81F3\5C11\5DF2 %1 \5929\6C92\6709\4F5C\7528, \6B63\5C07\5B83\52A0\5230\6C38\4E45\6E05\9664\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109725325495313941)
,p_name=>'PURGE.LOG.REMOVE_FROM_PURGE_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56E0\6700\8FD1\6709\6D3B\52D5, \6B63\5C07\5DE5\4F5C\5340 %0 \81EA\6C38\4E45\6E05\9664\6E05\55AE\79FB\9664.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109725446352313942)
,p_name=>'PURGE.LOG.SENT_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\50B3\9001\96FB\5B50\90F5\4EF6\81F3 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109725826814313942)
,p_name=>'PURGE.MOVED_TO_PURGE_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5C07\5DE5\4F5C\5340 %0 \5F9E\4FDD\7559\6E05\55AE\79FB\52D5\81F3\6C38\4E45\6E05\9664\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109731797039313946)
,p_name=>'PURGE.REPORT_BYTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4D\5143\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109729199377313944)
,p_name=>'PURGE.REPORT_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A08\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109731631907313946)
,p_name=>'PURGE.REPORT_DATAFILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109731338692313946)
,p_name=>'PURGE.REPORT_SCHEMAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109729048066313944)
,p_name=>'PURGE.REPORT_STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109729452137313945)
,p_name=>'PURGE.REPORT_SUMMARY_DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\81EA\6C38\4E45\6E05\9664\6E05\55AE\79FB\9664 (\56E0\70BA\6700\8FD1\6709\6D3B\52D5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109730126637313945)
,p_name=>'PURGE.REPORT_SUMMARY_MOVED_TO_NEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\52A0\56DE\6C38\4E45\6E05\9664\6E05\55AE (\4E4B\524D\4FDD\7559, \4F46 %0 \5929\5167\6C92\6709\6D3B\52D5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109729875480313945)
,p_name=>'PURGE.REPORT_SUMMARY_NEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\8FD1\52A0\5230\6C38\4E45\6E05\9664\6E05\55AE (%0 \5929\5167\6C92\6709\6D3B\52D5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109730702673313946)
,p_name=>'PURGE.REPORT_SUMMARY_PURGED_TODAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\65BC\4ECA\5929\6C38\4E45\6E05\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109729638182313945)
,p_name=>'PURGE.REPORT_SUMMARY_RETAIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\4FDD\7559 (\7BA1\7406\54E1\8981\6C42\4E0D\5C07\5DE5\4F5C\5340\6C38\4E45\6E05\9664)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109730304110313945)
,p_name=>'PURGE.REPORT_SUMMARY_TO_BE_PURGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\65BC %0 \5929\5167\6C38\4E45\6E05\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109731437370313946)
,p_name=>'PURGE.REPORT_TABLESPACES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\7A7A\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109731213273313946)
,p_name=>'PURGE.REPORT_WORKSPACES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109730851607313946)
,p_name=>'PURGE.REPORT_WORKSPACES_REMAINING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4ECD\5B58\5728\7684\5DE5\4F5C\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109725632885313942)
,p_name=>'PURGE.SAVE_RESPONSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8A18\9304\96FB\5B50\90F5\4EF6 %0 \7684\56DE\61C9\503C: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109732365958313947)
,p_name=>'PURGE.SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109727488182313943)
,p_name=>'PURGE.SET_SCHEMA_STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\5DE5\4F5C\5340 %2 \5C07\7DB1\8981 %0 \7684\72C0\614B\8A2D\70BA %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109727545305313943)
,p_name=>'PURGE.SET_TABLESPACE_STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\5DE5\4F5C\5340 %2 \5C07\8868\683C\7A7A\9593 %0 \7684\72C0\614B\8A2D\70BA %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109737844696313951)
,p_name=>'PURGE.SUBJECT_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Application Express \6BCF\65E5\5DE5\4F5C\5340\6C38\4E45\6E05\9664\6458\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109732459864313947)
,p_name=>'PURGE.TABLESPACE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\7A7A\9593\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109732985989313947)
,p_name=>'PURGE.WORKSPACES_ADDED_BACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\52A0\56DE\6C38\4E45\6E05\9664\6E05\55AE\7684\5DE5\4F5C\5340 (\4E4B\524D\4FDD\7559, \4F46 %0 \5929\5167\6C92\6709\6D3B\52D5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109732862726313947)
,p_name=>'PURGE.WORKSPACES_NEWLY_ADDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\8FD1\52A0\5230\6C38\4E45\6E05\9664\6E05\55AE\7684\5DE5\4F5C\5340 (%0 \5929\5167\6C92\6709\6D3B\52D5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109731876676313946)
,p_name=>'PURGE.WORKSPACES_PURGED_SUMMARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C38\4E45\6E05\9664\7684\5DE5\4F5C\5340\6458\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109732098895313947)
,p_name=>'PURGE.WORKSPACES_PURGED_TODAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4ECA\5929\6C38\4E45\6E05\9664\7684\5DE5\4F5C\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109733053865313947)
,p_name=>'PURGE.WORKSPACES_REMOVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\81EA\6C38\4E45\6E05\9664\6E05\55AE\79FB\9664\7684\5DE5\4F5C\5340 (\56E0\70BA\6700\8FD1\6709\6D3B\52D5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109733112264313948)
,p_name=>'PURGE.WORKSPACES_RETAINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4FDD\7559\7684\5DE5\4F5C\5340 (\7BA1\7406\54E1\8981\6C42\4E0D\5C07\5DE5\4F5C\5340\6C38\4E45\6E05\9664)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109732795645313947)
,p_name=>'PURGE.WORKSPACES_TO_BE_PURGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\65BC %0 \5929\5167\6C38\4E45\6E05\9664\7684\5DE5\4F5C\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109732270214313947)
,p_name=>'PURGE.WORKSPACE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109728967672313944)
,p_name=>'PURGE.WORKSPACE_PURGE_COMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C38\4E45\6E05\9664\5DE5\4F5C\5340 %0 \5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110030892876314165)
,p_name=>'PURGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6C38\4E45\6E05\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110115566078314245)
,p_name=>'PURGE_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C38\4E45\6E05\9664: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109493086190313745)
,p_name=>'QB_ACTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('&nbsp;\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109170283421313498)
,p_name=>'QB_CREATE_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\8F38\5165\6709\6548\7684\67E5\8A62\4F86\67E5\770B\7D50\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109492838874313745)
,p_name=>'QB_DUPLICATE_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\300C\67E5\8A62\7522\751F\5668\300D\4E2D\7684\73FE\6709\67E5\8A62\6216\300CSQL \547D\4EE4\8655\7406\5668\300D\5DF2\4F7F\7528\6B64\540D\7A31.<br> '),
unistr('\8ACB\9078\53D6\4E00\500B\65B0\540D\7A31, \7136\5F8C\518D\5132\5B58\4E00\6B21.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109351510867313638)
,p_name=>'QB_NOTHING_TO_SAVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\53EF\5132\5B58\7684\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109331771290313623)
,p_name=>'QB_SAVE_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5132\5B58\67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109498331979313749)
,p_name=>'QB_TABLE_ACTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109498475381313749)
,p_name=>'QB_VIEW_ACTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109451103495313714)
,p_name=>'QB_WARN_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\300C\8996\89BA\67E5\8A62\7522\751F\5668\300D\7121\6CD5\958B\555F\76EE\524D\7684\67E5\8A62.<br>'),
unistr('\8ACB\6309\4E00\4E0B\300C\5EFA\7ACB\300D, \5C07\60A8\76EE\524D\7684\67E5\8A62\53D6\4EE3\70BA\65B0\7684\67E5\8A62, \6216\6309 Return \4FDD\7559\76EE\524D\7684\67E5\8A62.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109451001882313714)
,p_name=>'QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108976139361313347)
,p_name=>'QUERY BUILDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\8A62\7522\751F\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109143000716313478)
,p_name=>'QUERY.INVALID_NO_SELECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\67E5\8A62, \627E\4E0D\5230 select \6558\8FF0\53E5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108975985559313347)
,p_name=>'QUESTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\554F\984C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109695384517313918)
,p_name=>'QUICKPICK_NUMERIC_MASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6578\5B57\683C\5F0F\906E\7F69: 999G999G999G999G990')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109501307221313751)
,p_name=>'QUICKSQL.ABOUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\65BC Quick SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109501429441313751)
,p_name=>'QUICKSQL.ABOUT.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Quick SQL \63D0\4F9B\4E00\7A2E\53EF\5FEB\901F\5F9E\7E2E\6392\6587\5B57\6587\4EF6\7522\751F\5EFA\7ACB\95DC\806F\5F0F\8CC7\6599\6A21\578B\6240\9700\4E4B SQL \7684\65B9\5F0F. \6B64\5DE5\5177\7684\76EE\7684\662F\70BA\4E86\6E1B\5C11\5EFA\7ACB SQL \8868\683C\3001\89F8\767C\7A0B\5F0F\53CA\7D22\5F15\7D50\69CB\6240\9700\7684\6642\9593\548C\4ED8\51FA, \4E26\975E\8981\53D6\4EE3\8CC7\6599\6A21\578B, \7D14\7CB9\662F\4E00\7A2E\53EF\91DD\5C0D\7C21\55AE\7684\8868\683C\548C\8996\89C0\8868\5FEB\901F\958B\767C\547D\4EE4\6A94\7684\65B9\5F0F. SQL \7522\751F\4E4B\5F8C, \4FBF\53EF\4EE5\5C0D\5176\9032\884C\8ABF\6574\548C\64F4\5C55.</p>'),
'',
unistr('<p>\5E38\898B\4F7F\7528\6848\4F8B:'),
'<ul>',
unistr('  <li>\5FEB\901F\5EFA\7ACB\5065\5168\7684\8CC7\6599\6A21\578B</li>'),
unistr('  <li>\5C07 Quick SQL \7C21\6613\5F0F\8A9E\6CD5\53E6\5B58\70BA\6A21\578B, \4EE5\4FBF\5728\6A21\578B\8B8A\66F4\6642\91CD\8907\4F7F\7528, \6216\4F5C\70BA\6A23\677F\6A21\578B\4EE5\8FC5\901F\958B\59CB\4E0B\4E00\500B\6A21\578B\8A2D\8A08</li>'),
unistr('  <li>\8F15\9B06\7522\751F\96A8\6A5F\8CC7\6599</li>'),
unistr('  <li>\5229\7528\63D0\4F9B\7684\7BC4\4F8B\5B78\7FD2 SQL \5EFA\7ACB\8868\683C\3001\9078\53D6\3001\63D2\5165\3001\7DE8\88FD\7D22\5F15\3001\89F8\767C\3001PL/SQL \5957\88DD\7A0B\5F0F\4EE5\53CA\6AA2\8996\8A9E\6CD5</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109394221758313671)
,p_name=>'QUICKSQL.APEX_SETTING_PART1'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6B64\8A2D\5B9A\63A7\5236\7522\751F\7684\8A9E\6CD5\4EE5\652F\63F4\7A3D\6838\8CC7\6599\6B04.  \7279\5225\662F\5982\679C\555F\7528\7A3D\6838\8CC7\6599\6B04, \4FBF\6703\7522\751F\89F8\767C\7A0B\5F0F\4EE5\7DAD\8B77\5EFA\7ACB\8CC7\6599\5217\7684\4F7F\7528\8005\548C\4E0A\6B21\66F4\65B0\8CC7\6599\5217\7684\4F7F\7528\8005.  \555F\7528\6642, \5C07\4F7F\7528\4E0B\5217\51FD\6578:'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109394371709313671)
,p_name=>'QUICKSQL.APEX_SETTING_PART2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\555F\7528\6642, \5247\6703\4F7F\7528\4E0B\5217\51FD\6578:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109394422444313671)
,p_name=>'QUICKSQL.API_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\6240\6709\8868\683C\7522\751F\7528\65BC\5EFA\7ACB\3001\63D2\5165\3001\66F4\65B0\3001\522A\9664\53CA\67E5\8A62\7684 PL/SQL API.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109394529185313671)
,p_name=>'QUICKSQL.AUDITCOLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\6BCF\500B\5EFA\7ACB\7684\8868\683C\65B0\589E\984D\5916\7684 created\3001created_by\3001updated \53CA updated_by \8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109394610557313671)
,p_name=>'QUICKSQL.COMPRESS_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\6642, \6703\4EE5\58D3\7E2E\65B9\5F0F\5EFA\7ACB\6240\6709\8868\683C.  \9810\8A2D\70BA\4E0D\58D3\7E2E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109394739617313671)
,p_name=>'QUICKSQL.CREATEDBYCOL_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\7A3D\6838\8CC7\6599\6B04\6642, \7528\4F86\8FFD\8E64\5EFA\7ACB\8CC7\6599\5217\7684\4F7F\7528\8005\7684\9810\8A2D\8CC7\6599\6B04\662F CREATED_BY.  \4F7F\7528\6B64\8A2D\5B9A\503C\53EF\8986\5BEB\9810\8A2D\7A3D\6838\8CC7\6599\6B04\540D\7A31. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109394880872313671)
,p_name=>'QUICKSQL.CREATED_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\7A3D\6838\8CC7\6599\6B04\6642, \7528\4F86\8FFD\8E64\5EFA\7ACB\8CC7\6599\5217\7684\4F7F\7528\8005\7684\9810\8A2D\8CC7\6599\6B04\662F CREATED.  \4F7F\7528\6B64\8A2D\5B9A\503C\53EF\8986\5BEB\9810\8A2D\7A3D\6838\8CC7\6599\6B04\540D\7A31. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109396833047313673)
,p_name=>'QUICKSQL.DATE_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\6703\4F7F\7528 Oracle DATE \8CC7\6599\985E\578B\5EFA\7ACB DATE \8CC7\6599\6B04.  \4F7F\7528\6B64\8A2D\5B9A\53EF\8986\5BEB\6B64\9810\8A2D\503C.  \6709\6548\7684\503C\5305\62EC:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109399176980313674)
,p_name=>'QUICKSQL.DB_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\8A9E\6CD5\76F8\5BB9\7684\8CC7\6599\5EAB\7248\672C.  \6709\6548\7684\503C\5305\62EC:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109403508441313678)
,p_name=>'QUICKSQL.DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110071190814314193)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\90E8\9580\8207\54E1\5DE5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110071720777314194)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES_DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\4E00\500B DEPARTMENTS \8207 EMPLOYEES \8868\683C\4E14\5E36\6709 SQL \7D50\5408 VIEW \7684\7C21\6613\5F0F SQL \8A9E\6CD5.  \53E6\5916, \4F7F\7528 /INSERT \8A9E\6CD5\7522\751F\96A8\6A5F\8CC7\6599.  /NN \65B0\589E\4E86\4E00\500B NOT NULL SQL \8CC7\6599\6B04\689D\4EF6\9650\5236.  \4F7F\7528\7E2E\6392\6E05\55AE\5B9A\7FA9\8868\683C\3001\8CC7\6599\6B04\4EE5\53CA\5B50\9805\8868\683C.  \4E3B\7D22\5F15\9375\548C\5916\4F86\7D22\5F15\9375\8CC7\6599\6B04\6703\81EA\52D5\65B0\589E.  \60A8\4E0D\9700\8981\63D0\4F9B\4EFB\4F55\4E3B\7D22\5F15\9375\6216\5916\4F86\7D22\5F15\9375\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109323694059313617)
,p_name=>'QUICKSQL.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109402232594313677)
,p_name=>'QUICKSQL.DROP_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\542B\522A\9664\6BCF\500B\5DF2\5EFA\7ACB\8CC7\6599\5EAB\7269\4EF6\7684 SQL \547D\4EE4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110071389620314193)
,p_name=>'QUICKSQL.EMPLOYEESKILLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\54E1\5DE5\6280\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110071558941314194)
,p_name=>'QUICKSQL.EMPLOYEESKILLS.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\7E2E\6392\529F\80FD\5EFA\7ACB\4E00\500B DEPARTMENTS\3001EMPLOYEES \8207 SKILLS \8868\683C, \4EE5\6307\5B9A\7236\9805\548C\5B50\9805\8868\683C.  \4F7F\7528\7C21\6613\5F0F\8A9E\6CD5 VC255 \6307\5B9A SQL \8CC7\6599\985E\578B.  \4F7F\7528 /INSERT \8A9E\6CD5\7522\751F\96A8\6A5F\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109323450253313617)
,p_name=>'QUICKSQL.EXAMPLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109501729021313752)
,p_name=>'QUICKSQL.EXAMPLE_N'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109404268488313678)
,p_name=>'QUICKSQL.GENPK_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\70BA\6BCF\500B\8868\683C\81EA\52D5\7522\751F ID \4E3B\7D22\5F15\9375\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109501572242313751)
,p_name=>'QUICKSQL.GETTING_STARTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5165\9580')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109501674306313751)
,p_name=>'QUICKSQL.GETTING_STARTED.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\4E0D\542B\4EFB\4F55\7E2E\6392\7684\7236\9805\8868\683C\540D\7A31. \8F38\5165\7D71\4E00\7E2E\6392 2 \6216\591A\500B\7A7A\683C\7684\8868\683C\8CC7\6599\6B04. \4E00\822C\5EFA\8B70\4E0D\8981\6307\5B9A\4E3B\7D22\5F15\9375, \7CFB\7D71\6703\70BA\60A8\7522\751F. \53EA\8981\5728\7236\9805\8868\683C\5E95\4E0B\7E2E\6392\5B50\9805\8868\683C, \5373\53EF\5EFA\7ACB\7236\9805\5B50\9805\95DC\4FC2.</p>'),
'',
unistr('<p>\8CC7\6599\985E\578B\901A\5E38\6703\9810\8A2D\70BA VARCHAR2, \5982\679C\60A8\60F3\8981\4E0D\540C\7684\8CC7\6599\985E\578B, \8ACB\5728\8CC7\6599\6B04\540D\7A31\7D50\5C3E\65B0\589E\4E00\500B\7A7A\683C NUM\3001INT\3001DATE. \6839\64DA\8CC7\6599\6B04\540D\7A31\6240\542B\7684\82F1\6587\6587\5B57, \5728\6C92\6709\6307\5B9A\4EFB\4F55\8CC7\6599\985E\578B\7684\60C5\6CC1\4E0B, \7CFB\7D71\5C07\6703\5C0D\90E8\5206\8CC7\6599\6B04\540D\7A31\9032\884C\5408\7406\63A8\8AD6. \4F8B\5982, \8CC7\6599\6B04\5305\542B DATE \6642\6703\662F\65E5\671F\8CC7\6599\985E\578B, \6216\8CC7\6599\6B04\540D\7A31\5305\542B NUMBER \6216 NUM \6642\6703\662F\6578\5B57\8CC7\6599\985E\578B. \5982\679C\60A8\60F3\8981\6307\5B9A\7279\5B9A VARCHAR2 \9577\5EA6, \8ACB\8F38\5165 VCn, \5176\4E2D "n" \4EE3\8868 VARCHAR2 \7684\9577\5EA6. \6309\4E00\4E0B\300C\8A9E\6CD5\300D\6309\9215\5373\53EF\986F\793A\53EF')
||unistr('\7528\7684\8A9E\6CD5. \7269\4EF6\540D\7A31\5C07\6703\88AB\81EA\52D5\683C\5F0F\5316, \4EE5\5E95\7DDA\53D6\4EE3\7A7A\683C, \6240\4EE5\60A8\53EF\4EE5\5728\8CC7\6599\6B04\548C\8868\683C\540D\7A31\4F7F\7528\7A7A\683C.</p>'),
'',
unistr('<p>\6309\4E00\4E0B\300C\8A2D\5B9A\503C\300D\6309\9215\53EF\6AA2\8996\8A31\591A\7522\751F\9078\9805. \60A8\53EF\4EE5\81EA\52D5\65B0\589E\300C\4EBA\54E1\8CC7\6599\6B04\300D, \4F8B\5982\6307\5B9A\8CC7\6599\5217\7684\5EFA\7ACB\8005\6216\4E0A\6B21\66F4\65B0\8005, \4EE5\53CA\6642\9593. \60A8\53EF\4EE5\65B0\589E\6BCF\6B21\8CC7\6599\5217\66F4\65B0\6642, \81EA\52D5\4EE5 1 \70BA\55AE\4F4D\589E\91CF\7684\8CC7\6599\5217\9806\5E8F\8CC7\6599\6B04. \8CC7\6599\5217\9806\5E8F\53EF\4EE5\7528\4F86\7C21\5316\907A\5931\66F4\65B0\5075\6E2C. \4E5F\53EF\4EE5\7522\751F PL/SQL API, \70BA\6BCF\500B\8868\683C\63D0\4F9B\4E00\500B\5957\88DD\7A0B\5F0F, \63D0\4F9B\67E5\8A62\3001\63D2\5165\3001\66F4\65B0\53CA\522A\9664\8CC7\6599\5217\7684\7A0B\5E8F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110076419250314197)
,p_name=>'QUICKSQL.HELP.API'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7522\751F PL/SQL \5957\88DD\7A0B\5F0F API, \4EE5\67E5\8A62\3001\63D2\5165\3001\66F4\65B0\53CA\522A\9664\8868\683C\5167\7684\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110076588355314197)
,p_name=>'QUICKSQL.HELP.AUDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E Oracle \7A3D\6838\529F\80FD, \9810\8A2D\70BA AUDIT ALL ON [TABLE NAME].')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110076634789314197)
,p_name=>'QUICKSQL.HELP.AUDITCOLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5\65B0\589E UPDATED\3001UPDATED_BY\3001INSERTED \548C INSERTED_BY \8CC7\6599\6B04, \4EE5\53CA\65B0\589E\8A2D\5B9A\8CC7\6599\6B04\503C\7684\89F8\767C\7A0B\5F0F\908F\8F2F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110075854524314197)
,p_name=>'QUICKSQL.HELP.BETWEEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\8CC7\6599\6B04\65B0\589E\4E00\500B between \6AA2\67E5\9650\5236\689D\4EF6, \4F8B\5982 /between 1 and 100')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110075281280314196)
,p_name=>'QUICKSQL.HELP.CHECK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\4EE5\9017\865F\6216\7A7A\683C\5340\9694\7684\503C\5EFA\7ACB\4E00\500B\6AA2\67E5\9650\5236\689D\4EF6, \4F8B\5982 /check Yes, No')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109405355673313679)
,p_name=>'QUICKSQL.HELP.COLPREFIX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\6307\5B9A\8868\683C\7684\6240\6709\8CC7\6599\6B04\524D\9762\52A0\4E0A\9019\500B\503C.  \82E5\672A\63D0\4F9B, \5247\6703\65B0\589E\4E00\500B\5E95\7DDA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109445464794313710)
,p_name=>'QUICKSQL.HELP.COLUMN_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110076273141314197)
,p_name=>'QUICKSQL.HELP.COMMENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\65B9\62EC\5F27\6216\4F7F\7528\96D9\865B\7DDA\8A9E\6CD5\542B\62EC\8A3B\89E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110076777881314197)
,p_name=>'QUICKSQL.HELP.COMPRESSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4EE5\58D3\7E2E\65B9\5F0F\5EFA\7ACB\8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110075309099314196)
,p_name=>'QUICKSQL.HELP.CONSTANT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7522\751F\8CC7\6599\6642, \5C07\6B64\8CC7\6599\6B04\8A2D\70BA\5E38\6578\503C.  \4F8B\5982 /constant NYC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109908627711314078)
,p_name=>'QUICKSQL.HELP.DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\8CC7\6599\6B04\70BA\7A7A\503C, \5247\65B0\589E\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109405235237313679)
,p_name=>'QUICKSQL.HELP.FILE_DATATYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\4E00\500B BLOB \8CC7\6599\6B04, \4EE5\53CA\53EF\589E\5F37\900F\904E\700F\89BD\5668\4E0B\8F09\6A94\6848\80FD\529B\7684 _FILENAME\3001_CHARSET\3001_MIMETYPE\3001_LASTUPD \8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110076098210314197)
,p_name=>'QUICKSQL.HELP.FK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\4F86\7D22\5F15\9375\53C3\7167, \4F8B\5982 /references table_name.  \8ACB\6CE8\610F, \60A8\53EF\4EE5\53C3\7167\4E0D\662F\6A21\578B\4E4B\4E00\90E8\5206\7684\8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110075991778314197)
,p_name=>'QUICKSQL.HELP.HIDDEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528 select * from table \4E0D\6703\986F\793A\96B1\85CF\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109669253167313887)
,p_name=>'QUICKSQL.HELP.INDEX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\5C0D\95DC\806F\7684\8CC7\6599\6B04\5EFA\7ACB\975E\552F\4E00\7684\7D22\5F15.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110076836279314197)
,p_name=>'QUICKSQL.HELP.INSERT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7522\751F\542B\96A8\6A5F\8CC7\6599\7684 <strong>NN</strong> SQL INSERT \6558\8FF0\53E5, \4F8B\5982: /INSERT 20. (\6700\5927\503C = 1000)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110075628006314196)
,p_name=>'QUICKSQL.HELP.LOWER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F37\5236\8B93\8CC7\6599\6B04\503C\70BA\5C0F\5BEB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110076346051314197)
,p_name=>'QUICKSQL.HELP.NNN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('NNN \8B58\5225 1 \5230 32767 \4E4B\9593\7684\6578\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110075730202314197)
,p_name=>'QUICKSQL.HELP.NOTNULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\8CC7\6599\6B04\65B0\589E\4E00\500B\975E\7A7A\503C\9650\5236\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110076164836314197)
,p_name=>'QUICKSQL.HELP.PK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8CC7\6599\6B04\6307\5B9A\70BA\6B64\8868\683C\7684\4E3B\7D22\5F15\9375.  \5EFA\8B70\4E0D\8981\624B\52D5\6307\5B9A\4E3B\7D22\5F15\9375, \8B93\6B64\61C9\7528\7A0B\5F0F\81EA\52D5\5EFA\7ACB\4E3B\7D22\5F15\9375\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110077061409314197)
,p_name=>'QUICKSQL.HELP.REST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528 Oracle REST Data Services (ORDS) \7522\751F\555F\7528 REST \7684\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110076943557314197)
,p_name=>'QUICKSQL.HELP.SELECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\7522\751F\6BCF\500B\8868\683C\7684\8CC7\6599\4E4B\5F8C\7522\751F SQL SELECT \6558\8FF0\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109210908935313528)
,p_name=>'QUICKSQL.HELP.TABLE_UNIQUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7522\751F\8868\683C\5C64\7D1A\552F\4E00\9650\5236\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110075123766314196)
,p_name=>'QUICKSQL.HELP.UNIQUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\4E00\500B\552F\4E00\7684\9650\5236\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110075558531314196)
,p_name=>'QUICKSQL.HELP.UPPER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F37\5236\8B93\8CC7\6599\6B04\503C\70BA\5927\5BEB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110075469675314196)
,p_name=>'QUICKSQL.HELP.VALUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7522\751F\8CC7\6599\6642\6240\8981\4F7F\7528\7684\503C\6E05\55AE (\4F7F\7528\9017\865F\5340\9694). \4F8B\5982 /values 1, 2, 3, 4 \6216 /values Yes, No.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109504160583313753)
,p_name=>'QUICKSQL.IMPLEMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\8CC7\6599\5EAB\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109532005394313774)
,p_name=>'QUICKSQL.IMPLEMENT.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5B8C\6210\8F38\5165\300C\7C21\6613\5F0F Quick SQL\300D\4E26\5957\7528\9069\7576\8A2D\5B9A\503C\4E4B\5F8C, \5C31\53EF\4EE5\958B\59CB\4F7F\7528 SQL \5EFA\7ACB\8CC7\6599\5EAB\7269\4EF6, \4E26\4E14\4EE5\96A8\6A5F\8CC7\6599\586B\5165\8868\683C. \8ACB\4F9D\7167\4EE5\4E0B\6B65\9A5F\9032\884C:<br>'),
'<ol>',
unistr('  <li>\6309\4E00\4E0B<strong>\5132\5B58\6A21\578B</strong>, \5C07 Quick SQL \7C21\6613\5F0F\8A9E\6CD5\5132\5B58\70BA\6A21\578B, \4EE5\4F9B\65E5\5F8C\91CD\8907\4F7F\7528.</li>'),
unistr('  <li>\8F38\5165\6A21\578B\540D\7A31.</li>'),
unistr('  <li>\6309\4E00\4E0B<strong>\5132\5B58 SQL \547D\4EE4\6A94</strong>, \5C07\8F38\51FA\5132\5B58\70BA\547D\4EE4\6A94.</li>'),
unistr('  <li>\8F38\5165\547D\4EE4\6A94\540D\7A31.</li>'),
unistr('  <li>\6309\4E00\4E0B<strong>\8907\67E5\4E26\57F7\884C</strong>\4EE5\700F\89BD\81F3\300C\547D\4EE4\6A94\7DE8\8F2F\5668\300D.</li>'),
unistr('  <li>\5728\300C\547D\4EE4\6A94\7DE8\8F2F\5668\300D\5167, \8907\67E5\547D\4EE4\6A94\5167\5BB9\662F\5426\6B63\78BA.</li>'),
unistr('  <li>\6309\4E00\4E0B<strong>\57F7\884C</strong>\4EE5\5EFA\7ACB\8CC7\6599\5EAB\7269\4EF6.</li>'),
unistr('  <li>\5728\547D\4EE4\6A94\78BA\8A8D\9801\9762\4E2D, \6309\4E00\4E0B<strong>\7ACB\5373\57F7\884C</strong>.</li>'),
unistr('  <li>\5728\7D50\679C\9801\9762\4E2D\8907\67E5\8655\7406\7684\6558\8FF0\53E5 (\5305\542B\6210\529F\548C\767C\751F\932F\8AA4\7684\9805\76EE).<br>'),
unistr('  \82E5\56DE\5831\4EFB\4F55\932F\8AA4, \8ACB\700F\89BD\7D50\679C\9801\9762\4EE5\67E5\770B\7279\5B9A Oracle \932F\8AA4\8A0A\606F.</li>'),
unistr('  <li>\6216\8005, \6309\4E00\4E0B<strong>\5F9E\547D\4EE4\6A94\5EFA\7ACB\61C9\7528\7A0B\5F0F</strong>, \524D\5F80\300C\5EFA\7ACB\61C9\7528\7A0B\5F0F\7CBE\9748\300D, \6839\64DA\547D\4EE4\6A94\4E2D\6307\5B9A\7684\8868\683C\548C\8996\89C0\8868\81EA\52D5\7522\751F\9801\9762.</li>'),
'</ol>',
'</p>',
'',
unistr('<p><em><strong>\6CE8\610F:</strong> \5982\679C\65E5\5F8C\60F3\8981\66F4\65B0\76F8\540C\7684\7C21\6613\5F0F SQL, Oracle \5EFA\8B70\5C07\7C21\6613\5F0F SQL \4E0B\8F09\81F3\60A8\7684\96FB\8166. \5982\679C\6307\5B9A\4E86\4EFB\4F55\8A2D\5B9A\503C, \8ACB\700F\89BD\81F3\300COracle SQL \8F38\51FA\300D\7A97\683C\5E95\7AEF, \5C07\4EE5 <code># settings =</code> \70BA\958B\982D\7684\884C\8907\88FD\5230\300C\7C21\6613\5F0F Quick SQL\300D\7A97\683C\7684\9802\7AEF.<br>'),
unistr('\6309<strong>\4E0B\8F09</strong>\5373\53EF\5C07 SQL \6A94\6848\5132\5B58\81F3\60A8\7684\96FB\8166.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109403283205313677)
,p_name=>'QUICKSQL.LANGUAGE_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\6B64\8A9E\8A00\7522\751F\7528\65BC insert \6558\8FF0\53E5\7684\8CC7\6599.  \9810\8A2D\70BA\82F1\6587.  \652F\63F4\7684\8A9E\8A00\5305\62EC: ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109403466605313678)
,p_name=>'QUICKSQL.LONGID_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B58\5225\662F\5426\5728\8CC7\6599\5EAB\7269\4EF6\540D\7A31\4F7F\7528\8F03\9577 ID.  \555F\7528\8F03\9577 ID \6642, \5141\8A31\7684\7269\4EF6\540D\7A31\9577\5EA6\53EF\9054 128 \500B\5B57\5143.  \672A\555F\7528\6642, \7269\4EF6\540D\7A31\9577\5EA6\4E0A\9650\70BA 30 \500B\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109403626851313678)
,p_name=>'QUICKSQL.LONGVC_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5141\8A31\5728\8CC7\6599\5EAB\7269\4EF6\540D\7A31\4F7F\7528\8F03\9577 ID.  \8F03\9577 ID \5141\8A31\7684 VARCHAR2 \8CC7\6599\6B04\8CC7\6599\985E\578B\7684\9577\5EA6\4E0A\9650\70BA 32767 \500B\5B57\5143.  \672A\8A2D\5B9A\6642, VARCHAR2 \8CC7\6599\6B04\8CC7\6599\985E\578B\7684\9577\5EA6\4E0A\9650\70BA 4000 \500B\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109403742124313678)
,p_name=>'QUICKSQL.ONDELETE_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8A2D\5B9A\63A7\5236\5916\4F86\7D22\5F15\9375 ON DELETE \7684\8A2D\5B9A\503C.  \6709\6548\7684\503C\5305\62EC: ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109403807386313678)
,p_name=>'QUICKSQL.OVERRIDESETTINGS_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\6642, \900F\904E\4F7F\7528\8005\4ECB\9762\63A7\5236\53F0\8A2D\5B9A\7684\6240\6709\61C9\7528\7A0B\5F0F\8A2D\5B9A\503C\90FD\6703\88AB\5FFD\7565, \53EA\6703\4F7F\7528\547D\4EE4\6A94\4E2D\8A2D\5B9A\7684\8A2D\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109403914379313678)
,p_name=>'QUICKSQL.PK_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C7A\5B9A\4E3B\7D22\5F15\9375\7684\8A2D\5B9A\65B9\5F0F.  \60A8\53EF\4EE5\4F7F\7528 SYS_GUID\3001\8B58\5225\8CC7\6599\6B04\6216\9806\5E8F\4F86\8A2D\5B9A\4E3B\7D22\5F15\9375.  \6709\6548\503C\5305\62EC:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109404143057313678)
,p_name=>'QUICKSQL.PREFIXPKWITHTNAME_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8868\683C\540D\7A31\52A0\5728\4E3B\7D22\5F15\9375\8CC7\6599\5EAB\8868\683C\8CC7\6599\6B04\524D\9762.  \4F8B\5982 EMPLOYEE \8868\683C\7684\4E3B\7D22\5F15\9375\5C07\6703\662F EMPLOYEE_ID.  \672A\660E\78BA\8A2D\5B9A\6B64\540D\7A31\6642, \5EFA\7ACB\7684\4E3B\7D22\5F15\9375\8CC7\6599\6B04\5C07\6703\662F ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109404060592313678)
,p_name=>'QUICKSQL.PREFIX_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\7269\4EF6\524D\7F6E\78BC. \82E5\672A\63D0\4F9B, \5247\6703\9644\52A0\4E00\500B\5E95\7DDA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110071286574314193)
,p_name=>'QUICKSQL.PRODUCTSALES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7522\54C1\92B7\552E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110071852284314194)
,p_name=>'QUICKSQL.PRODUCTSALES_DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\4E00\500B\542B PRODUCTS\3001CUSTOMERS\3001CHANNELS\3001PROMOTIONS \4EE5\53CA SALES \8868\683C\4E4B\661F\72C0\7DB1\8981\7684\7C21\6613\5F0F\8A9E\6CD5.  SALES \8868\683C\5305\542B\5C0D\5176\4ED6\8868\683C\7684\5916\4F86\7D22\5F15\9375\53C3\7167.  \53E6\5916, \5EFA\7ACB\4E86\4E00\500B\7D50\5408\5168\90E8\4E4B 5 \500B\8868\683C\7684 SQL VIEW.  \518D\8005, \4E5F\7522\751F\4E86\96A8\6A5F\7BC4\4F8B\8CC7\6599.  \6578\503C\8CC7\6599\6B04\4F7F\7528 NUM \8A9E\6CD5\6307\5B9A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110071024202314193)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C08\6848\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110071668233314194)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT_DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\4E00\500B PROJECT_MANAGEMENT \548C\56DB\500B\660E\7D30\8868\683C.  \4F7F\7528 /VIEW \8A9E\6CD5\5EFA\7ACB\5169\500B\8996\89C0\8868.  \53E6\5916, \4F7F\7528 /CHECK \8A9E\6CD5\65B0\589E\8CC7\6599\5EAB CHECK \9650\5236\689D\4EF6.  \518D\8005, \4F7F\7528 #APEX \8A2D\5B9A\63A7\5236 SQL \8A9E\6CD5\7522\751F\7684\8A2D\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109404323733313678)
,p_name=>'QUICKSQL.RESETSETTINGS_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6240\6709\61C9\7528\7A0B\5F0F\8A2D\5B9A\503C\91CD\8A2D\70BA\9810\8A2D\503C.  \5305\542B\6B64\9078\9805\6642, \968E\6BB5\4F5C\696D\76EE\524D\4F5C\7528\4E2D\7684\61C9\7528\7A0B\5F0F\8A2D\5B9A\503C\5C07\6703\88AB\5FFD\7565.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109404472770313678)
,p_name=>'QUICKSQL.ROWKEY_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\70BA\6BCF\500B\5EFA\7ACB\7684\8868\683C\65B0\589E\4E00\500B\6703\7522\751F\6587\6578\5B57 ID \7684 ROW_KEY \8CC7\6599\6B04.  ROW_KEY \8CC7\6599\6B04\7684\503C\5C07\6703\7531\7522\751F\7684\8CC7\6599\5EAB\8868\683C\89F8\767C\7A0B\5F0F\908F\8F2F\8A2D\5B9A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109404646573313678)
,p_name=>'QUICKSQL.ROWVERSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\70BA\6BCF\500B\7522\751F\7684\8868\683C\65B0\589E\4E00\500B\6BCF\6B21\66F4\65B0\6703\4EE5 1 \70BA\55AE\4F4D\589E\91CF\7684 ROW_VERSION \8CC7\6599\6B04.  \555F\7528\6642, \6703\5728\66F4\65B0\6642\7522\751F\8CC7\6599\5EAB\8868\683C\89F8\767C\7A0B\5F0F\908F\8F2F, \4EE5\4FBF\5C07\8CC7\6599\5217\7248\672C\9032\884C\589E\91CF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109404763128313678)
,p_name=>'QUICKSQL.SCHEMA_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\7269\4EF6\540D\7A31\524D\9762\52A0\4E0A\7DB1\8981\540D\7A31.  \9810\8A2D\503C\4E0D\6703\5728\7269\4EF6\540D\7A31\524D\9762\52A0\4E0A\7DB1\8981.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109404581430313678)
,p_name=>'QUICKSQL.SECURITYGROUPID_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\70BA\6BCF\500B\8868\683C\65B0\589E\4E00\500B TENANT_ID \8CC7\6599\6B04, \4EE5\4FBF\652F\63F4\591A\79DF\7528\6236\61C9\7528\7A0B\5F0F.  \6B64\8CC7\6599\6B04\7684\503C\53EA\6703\65B0\589E\81F3\8A72\8868\683C, \9019\500B\503C\9808\7531\958B\767C\4EBA\54E1\7DAD\8B77.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109405119636313679)
,p_name=>'QUICKSQL.SEMANTICS_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\53EF\4EE5\9078\64C7\6C92\6709\8CC7\6599\6B04\8A9E\610F, \6216\662F BYTE \6216 CHAR \8A9E\610F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109323533379313617)
,p_name=>'QUICKSQL.SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109386748890313665)
,p_name=>'QUICKSQL.SETTINGS_DESC'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\8F38\5165\5167\5D4C\8A2D\5B9A\503C\4EE5\660E\78BA\8A2D\5B9A SQL \8A9E\6CD5\7522\751F\9078\9805. \6216\8005\53EF\4EE5\6309\4E00\4E0B\53F3\5074\7A97\683C\9802\7AEF\7684<strong>\8A2D\5B9A\503C</strong>, \4EE5\5BA3\544A\65B9\5F0F\8A2D\5B9A\7522\751F\9078\9805.</p>'),
'',
unistr('<p>\76F4\63A5\5728\300C\7C21\6613\5F0F Quick SQL\300D\7A97\683C\4E2D\8F38\5165\8A2D\5B9A\503C, \53EF\78BA\4FDD\842C\4E00\60A8\4E0B\8F09\4E86\547D\4EE4\6A94\4E4B\5F8C\53C8\5C07\5B83\8CBC\56DE\6642, \4E5F\80FD\4F7F\7528\76F8\540C\7684 SQL \7522\751F\9078\9805. \4F8B\5982\8F38\5165\4E0B\9762\7684\5167\5BB9, \5728\6240\6709\8868\683C\540D\7A31\524D\9762\52A0\4E0A TEST, \70BA OBE \7DB1\8981\7522\751F\8868\683C:<br>'),
'<code># settings = { prefix: "test", schema: "OBE" }</code>.<br>',
unistr('\6216\8005, \4EE5\4E0D\540C\884C\8F38\5165\6BCF\500B\8A2D\5B9A\503C, \4E5F\6703\5F97\5230\76F8\540C\7D50\679C:<br>'),
'<code># prefix: "test"<br>',
'# schema: "OBE"</code>',
'</p>',
unistr('<p><em><strong>\6CE8\610F:</strong> \8A2D\5B9A\503C\5FC5\9808\5F9E\65B0\7684\4E00\884C\958B\59CB, \4E26\4E14\4EE5 <code># settings = </code> (\8F38\5165\591A\500B\8A2D\5B9A\503C\6642) \6216 <code># </code> \70BA\958B\982D, \6BCF\884C\8F38\5165\4E00\500B\8A2D\5B9A\503C. \6240\6709\503C\5747\4E0D\5340\5206. \53EF\4EE5\4F7F\7528\62EC\865F\3001\7A7A\683C\548C\9017\865F\4EE5\4FBF\95B1\8B80, \4F46\662F\6703\88AB\5FFD\7565.  \82E5\8981\7522\751F\6240\6709\8A2D\5B9A\503C, \8ACB\4F7F\7528 <code># verbose: true</code>.</em> '),
'</p>',
'&nbsp;<br>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109323255279313617)
,p_name=>'QUICKSQL.SYNTAX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110093050047314210)
,p_name=>'QUICKSQL.TODOS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F85\8FA6\4E8B\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110093127120314210)
,p_name=>'QUICKSQL.TODOS_DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB ASSIGNEES \548C TODOS \8868\683C. \9019\662F\53EF\5FEB\901F\5EFA\7ACB\81EA\8A02\300C\5F85\8FA6\4E8B\9805\300D\7CFB\7D71\7684\8D77\9EDE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109404846575313679)
,p_name=>'QUICKSQL.UPDATEDBYCOL_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\6642, \7A3D\6838\8CC7\6599\6B04\6703\4F7F\7528\6B64\8A2D\5B9A\503C\8986\5BEB\9810\8A2D\7A3D\6838\8CC7\6599\6B04\540D\7A31. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109404929334313679)
,p_name=>'QUICKSQL.UPDATEDCOL_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\6642, \7A3D\6838\8CC7\6599\6B04\6703\4F7F\7528\6B64\8A2D\5B9A\503C\8986\5BEB\9810\8A2D\7A3D\6838\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109405031205313679)
,p_name=>'QUICKSQL.VERBOSE_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\986F\793A\6240\6709\8A2D\5B9A\503C, \800C\975E\53EA\6709\548C\9810\8A2D\503C\4E0D\540C\7684\8A2D\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109323372844313617)
,p_name=>'QUICKSQL.VIEW_SYNTAX_DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\78BA\5B9A\8996\89C0\8868\540D\7A31\672A\5305\542B\4EFB\4F55\7A7A\683C, \78BA\5B9A\8868\683C\540D\7A31\672A\5305\542B\4EFB\4F55\7A7A\683C.  \4F7F\7528\7A7A\683C\6216\9017\865F\5340\9694\8868\683C\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109532132196313775)
,p_name=>'QUICK_APP.LOAD_DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109171560347313499)
,p_name=>'QUICK_APP_ANALYSIS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\6790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109379491158313659)
,p_name=>'QUICK_APP_AVERAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E73\5747\503C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109054838588313412)
,p_name=>'QUICK_APP_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F9D %0 \5340\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109171910894313499)
,p_name=>'QUICK_APP_CHARTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109054703745313412)
,p_name=>'QUICK_APP_CHART_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309 %0 \7D71\8A08\7684\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109053488576313411)
,p_name=>'QUICK_APP_DETAIL_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A73\7D30\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109171884808313499)
,p_name=>'QUICK_APP_REPORTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109379517050313659)
,p_name=>'QUICK_APP_SUM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\548C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109547475092313786)
,p_name=>'QUICK_SQL'
,p_message_language=>'zh-tw'
,p_message_text=>'Quick SQL'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108889170416313279)
,p_name=>'RANGE2DCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\570D 2D \67F1\72C0\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108889211506313279)
,p_name=>'RANGE3DCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\570D 3D \67F1\72C0\5716')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110204759069314319)
,p_name=>'READERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95B1\8B80\8005')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110121059807314249)
,p_name=>'REASSIGN_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6307\5B9A\9805\76EE: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108912596674313297)
,p_name=>'REASSIGN_PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6307\5B9A\9801\9762')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109297998410313598)
,p_name=>'RECYCLE_BIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6E90\56DE\6536\7B52')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109501882541313752)
,p_name=>'REDIRECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109502094159313752)
,p_name=>'REDIRECT_BUTTON_WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\6309\9215\5C07\91CD\65B0\5C0E\5411\81F3\4E00\500B URL, \800C\4E14\53EF\80FD\9020\6210\7121\6CD5\9001\51FA\9801\9762.  \5982\679C\60A8\8981\8B93\6309\9215\9001\51FA\9801\9762, \8ACB\52FF\6307\5B9A\91CD\65B0\5C0E\5411\9801\9762\6216 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109168209101313496)
,p_name=>'REDIRECT_TO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109633925039313858)
,p_name=>'REDIRECT_TO_APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\61C9\7528\7A0B\5F0F %0, \7B2C %1 \9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109168101814313496)
,p_name=>'REDIRECT_TO_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\9801\9762 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108975723371313347)
,p_name=>'REDIRECT_TO_PAGE_IN_THIS_APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\6B64\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108975895139313347)
,p_name=>'REDIRECT_TO_URL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3 URL')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109349181326313636)
,p_name=>'REFERENCED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\53C3\7167')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108976714434313348)
,p_name=>'REGEN_VER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\7522\751F\9A57\8B49\78BC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109351725917313638)
,p_name=>'REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109496223926313748)
,p_name=>'REGION BUTTON POSITONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\6309\9215\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109415786072313687)
,p_name=>'REGION CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109408909714313682)
,p_name=>'REGION CONTENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108954677011313330)
,p_name=>'REGION.BUTTONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108977723310313349)
,p_name=>'REGIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109135783976313472)
,p_name=>'REGIONS_LIST_TEMPLATE_OVERRIDE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\6E05\55AE\6A23\677F\8986\5BEB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109360043898313644)
,p_name=>'REGION_DISPLAY_SELECTOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\986F\793A\9078\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108878461172313270)
,p_name=>'REGION_NAME.NATIVE_BREADCRUMB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109624323718313851)
,p_name=>'REGION_NAME.NATIVE_CALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\4E8B\66C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108896657649313284)
,p_name=>'REGION_NAME.NATIVE_CARDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5361\7247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109344321972313633)
,p_name=>'REGION_NAME.NATIVE_CSS_CALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\4E8B\66C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108920880221313303)
,p_name=>'REGION_NAME.NATIVE_DATA_UPLOAD_COLUMN_MAPPING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\4E0A\50B3\8CC7\6599\6B04\5C0D\61C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109358429497313643)
,p_name=>'REGION_NAME.NATIVE_DISPLAY_SELECTOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\986F\793A\9078\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109689058824313909)
,p_name=>'REGION_NAME.NATIVE_FACETED_SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\591A\9762\5411\641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109478320272313734)
,p_name=>'REGION_NAME.NATIVE_FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108879530892313271)
,p_name=>'REGION_NAME.NATIVE_HELP_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109485511924313740)
,p_name=>'REGION_NAME.NATIVE_IG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\65B9\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109599275376313828)
,p_name=>'REGION_NAME.NATIVE_IR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109338782776313629)
,p_name=>'REGION_NAME.NATIVE_JET_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110057112763314183)
,p_name=>'REGION_NAME.NATIVE_JQM_COLUMN_TOGGLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\5207\63DB\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108920741601313303)
,p_name=>'REGION_NAME.NATIVE_JQM_LIST_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110057273858314183)
,p_name=>'REGION_NAME.NATIVE_JQM_REFLOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56DE\6D41\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109624527566313851)
,p_name=>'REGION_NAME.NATIVE_JSTREE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108877986190313270)
,p_name=>'REGION_NAME.NATIVE_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110061006465314186)
,p_name=>'REGION_NAME.NATIVE_MAP_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5730\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109699082994313921)
,p_name=>'REGION_NAME.NATIVE_PLSQL'
,p_message_language=>'zh-tw'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109623908404313850)
,p_name=>'REGION_NAME.NATIVE_SIMPLE_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868 (HTML - LEGACY)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109595010816313825)
,p_name=>'REGION_NAME.NATIVE_SQL_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109699192858313921)
,p_name=>'REGION_NAME.NATIVE_STATIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109623867108313850)
,p_name=>'REGION_NAME.NATIVE_SVG_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868 (SVG - LEGACY)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109599333007313829)
,p_name=>'REGION_NAME.NATIVE_TABFORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\8868\5316\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109624481423313851)
,p_name=>'REGION_NAME.NATIVE_TREE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\6A39\72C0\7D50\69CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108878777447313271)
,p_name=>'REGION_NAME.NATIVE_URL'
,p_message_language=>'zh-tw'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109044793392313404)
,p_name=>'REGION_TEMPLATES_NO_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\6A23\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109363762535313647)
,p_name=>'REJECTED_OR_DUPLICATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62D2\7D55\6216\91CD\8907')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109384465969313663)
,p_name=>'RELEASE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7248\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108931294763313311)
,p_name=>'RELEASED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\767C\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109414311324313686)
,p_name=>'RELEASE_SUMMARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7248\6B21\6458\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109414282869313686)
,p_name=>'RELEASE_SUMMARY_FOR_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\7684\7248\6B21\6458\8981: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110089623684314206)
,p_name=>'REMOTE.MORE_INFORMATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110130780209314257)
,p_name=>'REMOTE.OWA_TOOLKIT_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981 PL/SQL Web \5DE5\5177\7A0B\5F0F %0 <a href="%1" target="_blank">[\5176\4ED6\8CC7\8A0A]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110130500989314256)
,p_name=>'REMOTE.PATCHSET_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4FEE\6B63\7A0B\5F0F\96C6 %0 \53EF\4F9B\4F7F\7528 <a href="%1" target="_blank">[\5176\4ED6\8CC7\8A0A]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110130640012314257)
,p_name=>'REMOTE.RELEASE_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle APEX %0 \53EF\4F9B\4F7F\7528 <a href="%1" target="_blank">[\5176\4ED6\8CC7\8A0A]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110089509240314206)
,p_name=>'REMOTE.SYSTEM_UP_TO_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7CFB\7D71\5DF2\662F\6700\65B0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110031037524314165)
,p_name=>'REMOVED_DUE_TO_ACTIVITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\56E0\6D3B\52D5\79FB\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108930708525313311)
,p_name=>'REMOVE_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109922189897314087)
,p_name=>'REMOVE_DB_PKG_APP_WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7CFB\7D71\5C07\79FB\9664\61C9\7528\7A0B\5F0F\5B9A\7FA9, \4EE5\53CA\6240\6709\5EFA\7ACB\7684\5168\90E8\652F\63F4\7269\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109430055299313698)
,p_name=>'REMOVE_WORKSPACE_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\79FB\9664\5DE5\4F5C\5340.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109494229224313746)
,p_name=>'RENAME_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8CC7\6599\6B04 %0 \91CD\65B0\547D\540D\70BA %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109494490811313746)
,p_name=>'RENAME_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8868\683C %0 \91CD\65B0\547D\540D\70BA %1')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109211356920313529)
,p_name=>'REORDER_BUTTONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6392\5217\5340\57DF\6309\9215')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109226417600313540)
,p_name=>'REORDER_NAVBAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6392\5217\5C0E\89BD\5217\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109211497851313529)
,p_name=>'REORDER_REGIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6392\5217\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109211093597313528)
,p_name=>'REORDER_REGION_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6392\5217\5340\57DF\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109226324320313540)
,p_name=>'REORDER_TABS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6392\5217\9801\7C64')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109331677146313623)
,p_name=>'REPORT COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110114729741314244)
,p_name=>'REPORT_ALIAS_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\5225\540D: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109331949868313624)
,p_name=>'REPORT_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109448518488313712)
,p_name=>'REPORT_COLUMNS_PAGE_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109423382897313692)
,p_name=>'REPORT_COLUMN_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\8CC7\6599\6B04\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109422935446313692)
,p_name=>'REPORT_FORM_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\300C\8868\55AE\300D\548C\300C\5831\8868\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109387760553313666)
,p_name=>'REPORT_GENERATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7522\751F\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109455480023313718)
,p_name=>'REPORT_LAYOUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\7248\9762\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109284130096313588)
,p_name=>'REPORT_ON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \76F8\95DC\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109448855045313713)
,p_name=>'REPORT_PAGE_ATTRIBUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\9801\9762\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109040379080313401)
,p_name=>'REPORT_QUERIES.VALID_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\8A62\6709\6548. \5DF2\5256\6790\9023\7D50\8B8A\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109455334017313717)
,p_name=>'REPORT_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109288928168313591)
,p_name=>'REPORT_QUERY_STEP1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B65\9A5F 1 - \4E0B\8F09 XML \6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109289038748313591)
,p_name=>'REPORT_QUERY_STEP2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B65\9A5F 2 - \8A2D\8A08\5831\8868\7248\9762\914D\7F6E\4E26\53E6\5B58\70BA RTF \6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109289256890313591)
,p_name=>'REPORT_QUERY_STEP2_XSL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B65\9A5F 2 - \4E0A\50B3 XSL-FO \6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109289178458313591)
,p_name=>'REPORT_QUERY_STEP3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B65\9A5F 3 - \4E0A\50B3 RTF \6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109421420723313691)
,p_name=>'REPORT_ROWS_FETCHED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64F7\53D6\7684\5831\8868\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109489591355313743)
,p_name=>'REPORT_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\5831\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109423486649313693)
,p_name=>'REPORT_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109428656948313696)
,p_name=>'REPORT_WS_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\300CWeb \670D\52D9\76F8\95DC\5831\8868\300D\9801\9762.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109345216029313633)
,p_name=>'REQUEST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109418929074313689)
,p_name=>'REQUESTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109683109489313902)
,p_name=>'REQUEST_CHANGE_DB_SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340 "%1" \7684 %0 \5DF2\8981\6C42\591A\589E\52A0 %2 \7684\8CC7\6599\5EAB\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109683001294313902)
,p_name=>'REQUEST_NEW_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5DF2\66FF\5927\5C0F\70BA %2 \7684\5DE5\4F5C\5340 "%1" \8981\6C42\65B0\7DB1\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109682931665313902)
,p_name=>'REQUEST_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \8981\6C42\5927\5C0F\70BA %2 \7684\65B0\5DE5\4F5C\5340 "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108932926563313313)
,p_name=>'REQUEST_WORKSPACE_EXISTING_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \8981\6C42\65B0\7684\5DE5\4F5C\5340 "%1"')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109372006561313654)
,p_name=>'RESEARCHING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7814\7A76\4E2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108907508467313293)
,p_name=>'RESET_4000'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108954490927313330)
,p_name=>'RESET_TO_NULL_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D\662F\7A7A\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108939325378313317)
,p_name=>'RESOURCE_MANAGER_CONSUMER_GROUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6E90\7BA1\7406\7A0B\5F0F\7528\6236\7FA4\7D44')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109637134764313860)
,p_name=>'RESTRICTED_ACCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9650\5236\5B58\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109207679066313526)
,p_name=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9650\5236 - \7121\6CD5\5F9E\700F\89BD\5668\8A2D\5B9A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109425255935313694)
,p_name=>'REST_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300CWeb \670D\52D9\53C3\7167\300D\5DF2\65B0\589E\81F3\61C9\7528\7A0B\5F0F %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109037258107313399)
,p_name=>'REST_WS.ALIASED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8A2D\5B9A\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109835864674314025)
,p_name=>'REST_WS.APEX_READ_ONLY'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>APEX RESTful \670D\52D9\76EE\524D\70BA\552F\8B80\6A21\5F0F.</p>'),
'',
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\76EE\524D\5B9A\7FA9\7684 APEX \578B RESTful \670D\52D9. \4F46\662F, Oracle \5EFA\8B70\60A8\6309<strong>\79FB\8F49\70BA ORDS RESTful \670D\52D9</strong>, \5C07\9019\4E9B\670D\52D9\79FB\8F49\81F3 ORDS.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109832411003314022)
,p_name=>'REST_WS.CURR_VESION_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\76EE\524D\57F7\884C\4E2D\7684 ORDS \7248\672C. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109036694591313398)
,p_name=>'REST_WS.DISABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109835792646314025)
,p_name=>'REST_WS.DROP_REST_WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\52D5\4F5C\5C07\6703\53D6\6D88\8A3B\518A\4E26\79FB\9664\6240\9078\7DB1\8981\7684\5168\90E8 ORDS REST \670D\52D9\5B9A\7FA9. \6B64\52D5\4F5C\7121\6CD5\9084\539F.</p>'),
'',
unistr('<p>\78BA\5B9A\8981\53D6\6D88\8A3B\518A\6B64\7DB1\8981\55CE?</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109285774527313589)
,p_name=>'REST_WS.DUPLICATE_PATH_PREFIX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7D93\70BA\53E6\4E00\500B\5DE5\4F5C\5340\5B9A\7FA9\4F7F\7528\9019\500B\503C\7684\300CAPEX \8DEF\5F91\524D\7F6E\78BC\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109347085688313635)
,p_name=>'REST_WS.DUPLICATE_SCHEMA_ALIAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53E6\4E00\500B\7DB1\8981\5DF2\7D93\4F7F\7528\6B64\7DB1\8981\5225\540D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109036523106313398)
,p_name=>'REST_WS.ENABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110072276731314194)
,p_name=>'REST_WS.ENABLED_OBJECT_COUNT_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\7684\7269\4EF6\7E3D\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109020316746313386)
,p_name=>'REST_WS.GLOB_MUST_BE_LAST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\57DF (*) \5B57\5143\53EA\80FD\4F5C\70BA\8DEF\7531\6A23\5F0F\7684\6700\5F8C\4E00\500B\5B57\5143, \800C\4E14\524D\9762\5FC5\9808\63A5\8457\5177\540D\53C3\6578\6216\6B63\659C\7DDA (/).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109685361043313904)
,p_name=>'REST_WS.HANDLER_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\8655\7406\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109685541888313904)
,p_name=>'REST_WS.HANDLER_DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\8655\7406\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109655014052313873)
,p_name=>'REST_WS.HANDLER_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\8A72\8981\6709\8655\7406\7A0B\5F0F ID, \4F46\537B\70BA\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109685451341313904)
,p_name=>'REST_WS.HANDLER_UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\65B0\8655\7406\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109020287869313386)
,p_name=>'REST_WS.INVALID_CHARS_IN_LITERAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\8DEF\7531\6A23\5F0F\7684\6587\5B57\90E8\5206\767C\73FE\7121\6548\7684\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109057170460313413)
,p_name=>'REST_WS.METADATA_ACCESS_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9700\8981\6388\6B0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110105180858314236)
,p_name=>'REST_WS.MIGRATION_CONFIRMATION'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding: 20px; font-size: 12px;">\82E5\6309\4E00\4E0B\300C\79FB\8F49\300D\6309\9215, \6703\5C07\6240\6709 APEX \5F0F REST \670D\52D9\7684\63CF\8FF0\8CC7\6599\90FD\8907\88FD\5230 ORDS. \73FE\6709 APEX \5F0F\670D\52D9\7684\5B9A\7FA9\5C07\7DAD\6301\4E0D\8B8A, \4F46\53EA\8981 ORDS \4E2D\6709\76F8\540C\7684\670D\52D9\5B58\5728, \5C31\4E0D\6703\57F7\884C. '),
'',
unistr('\5EFA\8B70\60A8\5728\79FB\8F49\4E4B\5F8C, \9A57\8B49\4E26\6E2C\8A66\79FB\8F49\5F8C\7684 ORDS \5F0F\670D\52D9. \9A57\8B49\4E4B\5F8C, \8ACB\532F\51FA\4E26\522A\9664 APEX \5F0F\670D\52D9.</div>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110105016722314235)
,p_name=>'REST_WS.MIGRATION_WARNING_18_2_PLUS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding:20px; font-size: 12px;"><p>APEX \5075\6E2C\5230\60A8\7684\5DE5\4F5C\5340\5305\542B 2 \500B\6216\66F4\591A\6709 NULL URI \524D\7F6E\78BC\7684 APEX \5F0F REST \6A21\7D44. ORDS \4E0D\5141\8A31\8D85\904E\4E00\500B\6A21\7D44\5177\6709\76F8\540C\7684\57FA\790E URI \524D\7F6E\78BC. </p>'),
'',
unistr('<p>\70BA\4E86\5C07\9019\4E9B\670D\52D9\79FB\8F49\81F3 ORDS, \5C07\5957\7528\4E0B\5217\898F\5247: </p>'),
'',
'<ul>',
unistr('<li>\6240\6709\53D7\5F71\97FF\7684\6A21\7D44\90FD\5C07\5408\4F75\6210\55AE\4E00\500B\540D\70BA <em><strong>merged.apex.rest.services</strong></em> \7684 ORDS \6A21\7D44.</li>'),
unistr('<li>\82E5 <strong><em>\4EFB\4E00\500B</em></strong>\76EE\524D\5408\4F75\4E2D\7684 APEX \5F0F\6A21\7D44\5DF2\767C\5E03, \65B0\7684\5408\4F75\6A21\7D44\4E5F<strong><em>\5C07\6703\767C\5E03</em></strong>.</li>'),
unistr('<li>\82E5\76EE\524D\5408\4F75\4E2D\7684 APEX \5F0F\6A21\7D44<strong><em>\90FD\672A</em></strong>\767C\5E03, \65B0\7684\5408\4F75\6A21\7D44<strong><em>\5C07\4E0D\6703\767C\5E03</em></strong>.</li>'),
unistr('<li>\76EE\524D\5408\4F75\4E2D APEX \5F0F\6A21\7D44\7684<strong><em>\6240\6709\89D2\8272</em></strong><strong><em>\5C07\6703\6307\5B9A\7D66\65B0\7684\5408\4F75\6A21\7D44</em></strong>.</li>'),
unistr('<li>\5408\4F75\6A21\7D44\7684<strong><em>\5206\9801\5927\5C0F</em></strong>\5C07\8A2D\70BA\5408\4F75\4E2D\6A21\7D44\7684<strong><em>\6700\5927\5206\9801\5927\5C0F</em></strong>.</li>'),
unistr('<li>\5982\679C\5177\6709 NULL \57FA\790E URI \7684 APEX \6A21\7D44\4E5F\64C1\6709\91CD\8907\7684\6A23\677F URI, \5C07\6703\51FA\73FE\4EE5\4E0B\60C5\6CC1:'),
'',
'<ul>',
unistr('<li>\6700\8FD1\66F4\65B0\7684\6A23\677F\5C07\4FDD\7559\91CD\8907\7684 URI</li>'),
unistr('<li>\6240\6709\5176\4ED6\6A23\677F\7684\524D\9762\5C07\52A0\4E0A dup001_* \524D\7F6E\78BC</li>'),
unistr('<li>\6A23\677F\7684\8A3B\89E3\5C07\5305\542B\539F\59CB\7684\6A21\7D44\540D\7A31 (\79FB\8F49\4F86\6E90) \548C\539F\59CB\7684\6A23\677F URI</li>'),
'</ul></li>',
'</ul>',
'</div>',
'<hr/>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110104988499314235)
,p_name=>'REST_WS.MIGRATION_WARNING_PRE_18_2'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding:20px; font-size: 12px;"><p>APEX \5075\6E2C\5230\60A8\7684\5DE5\4F5C\5340\5305\542B 2 \500B\6216\66F4\591A\6709 NULL URI \524D\7F6E\78BC\7684 APEX \5F0F REST \6A21\7D44. ORDS \4E0D\5141\8A31\8D85\904E\4E00\500B\6A21\7D44\5177\6709\76F8\540C\7684\57FA\790E URI \524D\7F6E\78BC. </p>'),
'',
unistr('<p>\76EE\524D\7121\6CD5\5C07\60A8\7684 APEX \5F0F REST \670D\52D9\79FB\8F49\81F3 ORDS. ORDS 18.2 \7248\958B\59CB\5C07\63D0\4F9B\79FB\8F49\529F\80FD.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110071949707314194)
,p_name=>'REST_WS.MODULE_COUNT_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A21\7D44\7E3D\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109684715444313903)
,p_name=>'REST_WS.MODULE_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\6A21\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109684942444313904)
,p_name=>'REST_WS.MODULE_DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\6A21\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109654843483313873)
,p_name=>'REST_WS.MODULE_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\8A72\8981\6709\6A21\7D44 ID, \4F46\537B\70BA\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109684823422313903)
,p_name=>'REST_WS.MODULE_UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\65B0\6A21\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109020041078313386)
,p_name=>'REST_WS.NAMED_PARAM_CONTAINS_INVALID_CHARS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8DEF\7531\6A23\5F0F\5167\7684\5177\540D\53C3\6578\5305\542B\7121\6548\7684\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109902049283314073)
,p_name=>'REST_WS.NOT_ORDS_ENABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\7DB1\8981\5C1A\672A\5728 ORDS RESTful \8CC7\6599\670D\52D9\8A3B\518A. \82E5\8981\8A3B\518A\6B64\7DB1\8981, \8ACB\6309\4E00\4E0B<strong>\5728 ORDS \8A3B\518A\7DB1\8981</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109020482903313386)
,p_name=>'REST_WS.NOT_URI_OR_ROUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('URI \4E0D\7B26\5408 URI \6216 ROUTE \6A23\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109020520161313386)
,p_name=>'REST_WS.NO_MORE_THAN_ONE_FORWARD_SLASH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\80FD\6709 1 \500B\4EE5\4E0A\7684\9023\7E8C\6B63\659C\7DDA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109019958196313386)
,p_name=>'REST_WS.NO_QUERY_STRING_IN_ROUTE_PATTERN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\80FD\5C0D\8DEF\7531\6A23\5F0F\4F7F\7528\67E5\8A62\5B57\4E32.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108923915799313305)
,p_name=>'REST_WS.NO_REST_IN_CDB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>APEX \76EE\524D\6B63\5728 CDB \4E2D\57F7\884C. \60A8\7121\6CD5\5728 CDB \4E2D\5B9A\7FA9 ORDS \578B REST \670D\52D9.</p><p>\60A8\53EF\4EE5\7E7C\7E8C\4F7F\7528 APEX \578B RESTful \670D\52D9.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109835696424314025)
,p_name=>'REST_WS.OLD_ORDS_VERSION'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\76EE\524D\5B89\88DD\7684 ORDS \7248\672C (%0) \4E0D\652F\63F4\5728 Application Express \555F\7528 ORDS \578B RESTful \670D\52D9\6642\6240\9700\7684\5168\90E8\529F\80FD. \81F3\5C11\5FC5\9808\5B89\88DD %1 \7248\672C.</p>'),
unistr('<p>\60A8\53EF\4EE5\7E7C\7E8C\4F7F\7528 APEX \578B RESTful \670D\52D9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109020153668313386)
,p_name=>'REST_WS.OPTIONAL_CHAR_MUST_BE_LAST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\6027 (?) \5B57\5143\53EA\80FD\4F5C\70BA\8DEF\7531\6A23\5F0F\7684\6700\5F8C\4E00\500B\5B57\5143, \800C\4E14\524D\9762\5FC5\9808\63A5\8457\5177\540D\53C3\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109018919882313385)
,p_name=>'REST_WS.ORDS_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\7CFB\7D71\627E\4E0D\5230\555F\7528\300CORDS REST \5DE5\4F5C\5BA4\300D\6240\9700\7684 ORDS_METADATA \7DB1\8981. \8ACB\53C3\95B1 Oracle REST Data Services Installation Guide \77AD\89E3\5B89\88DD\6B65\9A5F.</p> <p>\60A8\53EF\4EE5\7E7C\7E8C\4F7F\7528 APEX \5F0F RESTful \670D\52D9.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109037190387313399)
,p_name=>'REST_WS.PARTIALLY_SECURED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\90E8\5206\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109018879763313385)
,p_name=>'REST_WS.PLSQL_GATEWAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6B64\7CFB\7D71\76EE\524D\4F7F\7528 Oracle \7684\5167\5D4C PL/SQL \9598\9053. \60A8\5FC5\9808\5B89\88DD %0 \6216\66F4\65B0\7248\672C\7684 Oracle REST Data Services, \624D\80FD\555F\7528\5C0D ORDS REST \5DE5\4F5C\5BA4\7684\5B58\53D6.</p> <p>\60A8\53EF\4EE5\7E7C\7E8C\4F7F\7528 APEX \5F0F RESTful \670D\52D9.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110072078053314194)
,p_name=>'REST_WS.PRIVILEGE_COUNT_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B0A\9650\7E3D\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109685902999313905)
,p_name=>'REST_WS.PRIVILEGE_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\6B0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109686179864313905)
,p_name=>'REST_WS.PRIVILEGE_DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\6B0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109686065113313905)
,p_name=>'REST_WS.PRIVILEGE_UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\65B0\6B0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109036735334313398)
,p_name=>'REST_WS.PUBLISHED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\767C\5E03')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109037856848313399)
,p_name=>'REST_WS.RESET_SAMPLE_WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\52D5\4F5C\5C07\5728\76EE\524D\9078\53D6\7684\7DB1\8981\4E2D, \522A\9664\4E26\91CD\65B0\5EFA\7ACB <strong>oracle.example.hr</strong> \6A21\7D44\8207\76F8\95DC\8CC7\6599\5EAB\7269\4EF6. \6240\6709\5DF2\9032\884C\7684\8B8A\66F4\6216\65B0\589E\9805\76EE\90FD\5C07\6703\907A\5931, \800C\4E14\7121\6CD5\9084\539F.</p>'),
unistr('<p>\78BA\5B9A\8981\91CD\8A2D\7BC4\4F8B\670D\52D9\55CE?</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110072111598314194)
,p_name=>'REST_WS.ROLE_COUNT_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89D2\8272\7E3D\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109685630585313904)
,p_name=>'REST_WS.ROLE_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109685831050313904)
,p_name=>'REST_WS.ROLE_DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109685723803313904)
,p_name=>'REST_WS.ROLE_UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\65B0\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109057038666313413)
,p_name=>'REST_WS.SCHEMA_ACCESS_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109057217009313414)
,p_name=>'REST_WS.SCHEMA_ALIAS_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109832648301314022)
,p_name=>'REST_WS.SCRIPT_TOO_LONG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\50B3\7684\547D\4EE4\6A94\592A\5927. Application Express \7684\9650\5236\70BA 32MB (32767 \500B\4F4D\5143\7D44).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109036964594313399)
,p_name=>'REST_WS.SECURED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109654939606313873)
,p_name=>'REST_WS.SEQ_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\8A72\8981\6709\53C3\6578\9806\5E8F ID, \4F46\537B\70BA\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110072483199314194)
,p_name=>'REST_WS.SIMPLE_STATUS_FAILURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5931\6557')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110072313538314194)
,p_name=>'REST_WS.SIMPLE_STATUS_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110072599265314194)
,p_name=>'REST_WS.SIMPLE_STATUS_WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109685015837313904)
,p_name=>'REST_WS.TEMPLATE_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109685218776313904)
,p_name=>'REST_WS.TEMPLATE_DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109655145985313874)
,p_name=>'REST_WS.TEMPLATE_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\8A72\8981\6709\6A23\677F ID, \4F46\537B\70BA\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108955181402313331)
,p_name=>'REST_WS.TEMPLATE_MAY_NOT_BE_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('URI \6A23\677F\4E0D\53EF\70BA\7A7A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109685125738313904)
,p_name=>'REST_WS.TEMPLATE_UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\65B0\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109037454796313399)
,p_name=>'REST_WS.TREE_ENABLED_OBJECTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528\7684\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109037594367313399)
,p_name=>'REST_WS.TREE_MODULES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A21\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109037664939313399)
,p_name=>'REST_WS.TREE_PRIVILEGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109037734699313399)
,p_name=>'REST_WS.TREE_ROLES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110060912295314186)
,p_name=>'REST_WS.TREE_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('RESTful \8CC7\6599\670D\52D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109037332039313399)
,p_name=>'REST_WS.UNALIASED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\8A2D\5B9A\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109036821549313398)
,p_name=>'REST_WS.UNPUBLISHED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\767C\5E03')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109037002184313399)
,p_name=>'REST_WS.UNSECURED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\53D7\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109019833897313386)
,p_name=>'REST_WS.VARIABLE_SYNTAX_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\6216\591A\500B URI \8B8A\6578\7684\8A9E\6CD5\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109636020699313859)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5617\8A66\8F09\5165\7684\547D\4EE4\6A94\662F\4EE5 APEX \70BA\57FA\790E\7684 RESTful \670D\52D9\532F\51FA\9805\76EE. \4E0D\80FD\4F7F\7528 ORDS RESTful \670D\52D9\532F\5165\9801\9762\52A0\4EE5\8F09\5165.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109899688267314071)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE_APEX'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\60A8\5617\8A66\8F09\5165\7684\547D\4EE4\6A94\662F\4EE5 ORDS \70BA\57FA\790E\7684 RESTful \670D\52D9\532F\51FA\9805\76EE. \4E0D\80FD\4F7F\7528 APEX RESTful \670D\52D9\532F\5165\9801\9762\52A0\4EE5\8F09\5165.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110072659260314194)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\5230\526A\8CBC\7C3F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110072736622314194)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD_ARIA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5B8C\6574 URL \8907\88FD\5230\526A\8CBC\7C3F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110030908347314165)
,p_name=>'RETAINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\4FDD\7559')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109145607110313479)
,p_name=>'RETURN_TO_LOGIN_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8FD4\56DE %0 \767B\5165\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110150966438314272)
,p_name=>'RETURN_VALUE.N'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\503C: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109372322407313654)
,p_name=>'REVIEWING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\67E5\4E2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109633792997313857)
,p_name=>'ROLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89D2\8272')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109151809072313484)
,p_name=>'ROLLBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5012\56DE\300D\6558\8FF0\53E5\4E0D\9069\7528. \6703\81EA\52D5\78BA\8A8D\6240\6709\6558\8FF0\53E5.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109495641080313747)
,p_name=>'ROWS_IN_SECONDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%1 \79D2\5167\50B3\56DE %0 \500B\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108975522046313347)
,p_name=>'ROWS_RETURNED_IN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\50B3\56DE\65BC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109586358982313819)
,p_name=>'RUN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108900697145313288)
,p_name=>'RUN_AND_BUILD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\4E26\958B\767C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109351849135313638)
,p_name=>'RUN_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109589144133313821)
,p_name=>'RUN_APPLICATION_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\61C9\7528\7A0B\5F0F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109148534138313482)
,p_name=>'RUN_ONLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\57F7\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109591168148313822)
,p_name=>'RUN_PAGE_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\9801\9762: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108954761160313330)
,p_name=>'SAMPLE APPLICATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109548926422313787)
,p_name=>'SAMPLE_DS.COUNTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\570B\5BB6/\5730\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109549243940313787)
,p_name=>'SAMPLE_DS.COUNTRY.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\570B\5BB6/\5730\5340\3001\4EBA\53E3\548C\9996\90FD\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109136385548313473)
,p_name=>'SAMPLE_DS.EMP_DEPT'
,p_message_language=>'zh-tw'
,p_message_text=>'EMP / DEPT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109136450665313473)
,p_name=>'SAMPLE_DS.EMP_DEPT.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C EMP \548C DEPT \8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109549030620313787)
,p_name=>'SAMPLE_DS.F1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\7D1A\65B9\7A0B\5F0F\8CFD\8ECA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109549453056313787)
,p_name=>'SAMPLE_DS.F1.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\7D1A\65B9\7A0B\5F0F\8CFD\8ECA\4E16\754C\51A0\8ECD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110030229904314165)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5065\5EB7\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110030361578314165)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C21\5316\7684\75C5\60A3\56DE\5831\5065\5EB7\72C0\614B\66F4\65B0, \4EE5\4F9B\5065\5EB7\7167\8B77\63D0\4F9B\8005\4F7F\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109136531193313473)
,p_name=>'SAMPLE_DS.OEHR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('HR \8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109136695587313473)
,p_name=>'SAMPLE_DS.OEHR.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle Education \901A\7528\7684\4E00\822C HR \8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109589245331313821)
,p_name=>'SAMPLE_DS.ORDERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BA2\6236\8A02\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109589340207313821)
,p_name=>'SAMPLE_DS.ORDERS.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BA2\6236\3001\5546\5E97\3001\7522\54C1\548C\8A02\55AE\7684\96C6\5408. \6B64\8CC7\6599\96C6\5305\542B\7522\54C1\63CF\8FF0\7684 JSON \8CC7\6599\4EE5\53CA\5546\5E97\7684\7D93\7DEF\5EA6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109136174577313472)
,p_name=>'SAMPLE_DS.PROJECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C08\6848\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109136268413313473)
,p_name=>'SAMPLE_DS.PROJECT.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C08\6848\3001\91CC\7A0B\7891\3001\5DE5\4F5C\7B49\7684\96C6\5408. \6B64\8CC7\6599\96C6\5305\62EC\4E3B\8981-\660E\7D30\95DC\4FC2\548C\6709\7528\7684\5716\8868\6AA2\8996.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109136758403313473)
,p_name=>'SAMPLE_DS.TASKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\8A66\7B97\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109136821135313473)
,p_name=>'SAMPLE_DS.TASKS.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\542B\5DE5\4F5C\3001\65E5\671F\3001\72C0\614B\3001\6307\5B9A\5C0D\8C61\3001\6210\672C\53CA\9810\7B97\7B49\975E\6A19\6E96\5316\8CC7\6599\7684\55AE\4E00\8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109548876126313787)
,p_name=>'SAMPLE_DS.TENNIS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB2\7403')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109549340740313787)
,p_name=>'SAMPLE_DS.TENNIS.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5927\6EFF\8CAB\8CFD\4E8B\7537\5B50\7D44\8207\5973\5B50\7D44\51A0\8ECD\548C\4E9E\8ECD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109549156931313787)
,p_name=>'SAMPLE_DS.WORLD_CUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E16\754C\76C3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109549563448313788)
,p_name=>'SAMPLE_DS.WORLD_CUP.DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E16\754C\76C3\8DB3\7403\8CFD\7D50\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109432799748313700)
,p_name=>'SAMPLE_WEBSHEET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B Web \8A66\7B97\8868')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109419522171313690)
,p_name=>'SAVED_REPORTS.LINK_ALIAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109419618054313690)
,p_name=>'SAVED_REPORTS.LINK_EXAMPLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\7BC4\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109419746656313690)
,p_name=>'SAVED_REPORTS.MORE_SAVED_REPORTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6\9810\5B58\5831\8868...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109419221118313689)
,p_name=>'SAVED_REPORTS.PRIMARY_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109418554272313689)
,p_name=>'SAVED_REPORTS.PRIVATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C08\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109418697077313689)
,p_name=>'SAVED_REPORTS.PRIVATE.NOTIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C08\7528\8A02\95B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109419180168313689)
,p_name=>'SAVED_REPORTS.PUBLIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109419404350313690)
,p_name=>'SAVED_REPORTS.REPORT_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109419310417313690)
,p_name=>'SAVED_REPORTS.REPORT_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\985E\578B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109063578719313418)
,p_name=>'SC.BC.BCE_DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\5C0E\89BD\8DEF\5F91\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109063751580313418)
,p_name=>'SC.BC.BCE_INSERTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\5C0E\89BD\8DEF\5F91\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109063623826313418)
,p_name=>'SC.BC.BCE_UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\65B0\5C0E\89BD\8DEF\5F91\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109063495635313418)
,p_name=>'SC.BC.BC_DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\5C0E\89BD\8DEF\5F91.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109063343326313418)
,p_name=>'SC.BC.BC_UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\65B0\5C0E\89BD\8DEF\5F91.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109035360598313397)
,p_name=>'SC.LOV.IG_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\65B9\683C\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109035210827313397)
,p_name=>'SC.LOV.PAGE_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109391773583313669)
,p_name=>'SCHEMAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109503202427313753)
,p_name=>'SCHEMA_INSERT_EXCEPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('wwv_flow_companies \7DB1\8981\63D2\5165\7570\5E38\72C0\6CC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109502255792313752)
,p_name=>'SCHEMA_IS_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981 "%0" \53EF\4EE5\4F7F\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109502300839313752)
,p_name=>'SCHEMA_IS_NOT_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7121\6CD5\4F7F\7528\53CA\5EFA\7ACB\7DB1\8981 "%0", \56E0\70BA\5B83\8207\73FE\6709\7684\4F7F\7528\8005\885D\7A81.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109299997801313599)
,p_name=>'SCHEMA_PASSWORD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981\5BC6\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109116786120313458)
,p_name=>'SCHEMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110070829619314193)
,p_name=>'SCREEN_READER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\87A2\5E55\52A9\8B80\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109422826469313692)
,p_name=>'SCREEN_READER_TOGGLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\87A2\5E55\52A9\8B80\7A0B\5F0F\5207\63DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109453429074313716)
,p_name=>'SCRIPT_EXPORTED_FROM_FOREIGN_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\6A94\6848\662F\5F9E\5176\4ED6\5DE5\4F5C\5340 (%0) \532F\51FA\7684, \53EF\80FD\4F86\81EA\5176\4ED6 %1 \8CC7\6599\5EAB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110095097839314212)
,p_name=>'SCRIPT_NAME_LOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9396\5B9A\547D\4EE4\6A94 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110094931395314212)
,p_name=>'SCRIPT_NAME_UNLOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\89E3\9664\9396\5B9A\547D\4EE4\6A94 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110104168950314235)
,p_name=>'SCRIPT_NOT_LOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\547D\4EE4\6A94\672A\9396\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109380176331313660)
,p_name=>'SC_DESCRIBE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
unistr('\82E5\8981\8AAA\660E\7269\4EF6, \8ACB\5728\4E0A\9762\7684 <br><br> '),
'',
unistr('\547D\4EE4\7A97\683C\4E2D\8F38\5165 DESCRIBE &lt \7269\4EF6\540D\7A31 &gt, \7136\5F8C\6309\4E00\4E0B\300C\57F7\884C\300D.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109409667861313682)
,p_name=>'SC_NAME_NN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\67E5\8A62\540D\7A31\300D\4E0D\5F97\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109421606282313691)
,p_name=>'SC_NOT_VALID_OBJECT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre><br>',
unistr('\627E\4E0D\5230\8981\8AAA\660E\7684\7269\4EF6.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109412247079313684)
,p_name=>'SC_SC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975E\8996\89BA\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109346656738313634)
,p_name=>'SC_SQL_RUNNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \6558\8FF0\53E5\57F7\884C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109412172842313684)
,p_name=>'SC_VQ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8996\89BA\67E5\8A62')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110034650766314168)
,p_name=>'SEARCH_BAR_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\5217\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109454650203313717)
,p_name=>'SEARCH_FIELD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\6B04\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109300369153313600)
,p_name=>'SEARCH_NOT_ENABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\67E5\8A62\4E2D\6C92\6709 varchar \8CC7\6599\6B04.  \7121\6CD5\555F\7528\641C\5C0B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109289748531313592)
,p_name=>'SEARCH_NOT_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\53EF\641C\5C0B\7684 varchar \8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109454573897313717)
,p_name=>'SEARCH_PACKAGED_APPS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\751F\7522\529B\548C\7BC4\4F8B\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109849026046314035)
,p_name=>'SEARCH_RESULTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\7D50\679C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110036543227314169)
,p_name=>'SECTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\6BB5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109095509357313442)
,p_name=>'SECURITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\5168\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109386834267313665)
,p_name=>'SECURITY_ASSIGNEE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\5168\6027\6307\5B9A\5C0D\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109737755567313951)
,p_name=>'SECURITY_GROUP_ID_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5B89\5168\6027\7FA4\7D44 ID\300D(\60A8\7684\5DE5\4F5C\5340\8B58\5225) \7121\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109384970509313664)
,p_name=>'SECURITY_IMPACT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\5168\6027\5F71\97FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109426830759313695)
,p_name=>'SECURITY_SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109413377648313685)
,p_name=>'SECURITY_SCHEME.MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\80FD\662F\516C\7528\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109387286447313665)
,p_name=>'SECURITY_STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\5168\6027\72C0\614B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109412838043313685)
,p_name=>'SEE_ATTACHED_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\770B\9644\52A0\7684\5831\8868')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108948043660313324)
,p_name=>'SELECT_ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109294071547313595)
,p_name=>'SELECT_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108902552625313289)
,p_name=>'SELECT_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\8868\683C\4E2D\9078\53D6\4E00\500B\65E5\671F. \76EE\524D\7684\6708\4EFD = %0, \76EE\524D\7684\5E74\5EA6 = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109921010419314087)
,p_name=>'SELECT_DYNAMIC_ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\52D5\614B\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109105147467313449)
,p_name=>'SELECT_LABEL_TEMPLATE.THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109105007853313449)
,p_name=>'SELECT_LIST_TEMPLATE.THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109104914315313449)
,p_name=>'SELECT_PAGE_TEMPLATE.THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109104842927313449)
,p_name=>'SELECT_REGION_TEMPLATE.THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109105241591313449)
,p_name=>'SELECT_REPORT_TEMPLATE.THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110122013181314250)
,p_name=>'SELECT_ROW_C'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8CC7\6599\5217: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109557479075313793)
,p_name=>'SELECT_WORKSPACE_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\4E0B\65B9\9078\53D6\4E00\500B\5DE5\4F5C\5340, \4EE5\958B\555F Application Express \958B\767C\74B0\5883.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109481039123313736)
,p_name=>'SELF_SERVICE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52A9\670D\52D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109480981013313736)
,p_name=>'SELF_SERVICE_WITH_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5177\6709\96FB\5B50\90F5\4EF6\9A57\8B49\7684\81EA\52A9\670D\52D9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110094657973314211)
,p_name=>'SEPARATOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\9694\7B26\865F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109113610193313456)
,p_name=>'SEQUENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109542009421313782)
,p_name=>'SEQUENCE_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9806\5E8F: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108978975237313349)
,p_name=>'SERIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \6578\5217')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109383411181313662)
,p_name=>'SERVICE_CHANGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\670D\52D9\8B8A\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108926525549313308)
,p_name=>'SERVICE_LOGIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB2\7AD9\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109363563895313647)
,p_name=>'SERVICE_REQUEST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\670D\52D9\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109121230157313461)
,p_name=>'SERVICE_SIGNUP.ACCEPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\6709\5927\5C0F\5BEB\4E4B\5206\7684\300C\9A57\8B49\78BC\300D, \7136\5F8C\6309\4E00\4E0B<strong>\9001\51FA\8981\6C42</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109120156991313460)
,p_name=>'SERVICE_SIGNUP.ADMIN_INFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\54E1\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109121189959313461)
,p_name=>'SERVICE_SIGNUP.DB_SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109120027449313460)
,p_name=>'SERVICE_SIGNUP.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109120477556313461)
,p_name=>'SERVICE_SIGNUP.EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109120257707313461)
,p_name=>'SERVICE_SIGNUP.FIRST_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109119839338313460)
,p_name=>'SERVICE_SIGNUP.JUSTIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7406\7531')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109120385847313461)
,p_name=>'SERVICE_SIGNUP.LAST_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\59D3\6C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109119760882313460)
,p_name=>'SERVICE_SIGNUP.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109120920248313461)
,p_name=>'SERVICE_SIGNUP.NO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109120514292313461)
,p_name=>'SERVICE_SIGNUP.PHONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\8A71\865F\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109120708853313461)
,p_name=>'SERVICE_SIGNUP.REUSE_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8907\4F7F\7528\73FE\6709\7684\7DB1\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109120665354313461)
,p_name=>'SERVICE_SIGNUP.SCHEMA_INFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109121090047313461)
,p_name=>'SERVICE_SIGNUP.SCHEMA_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109119612370313460)
,p_name=>'SERVICE_SIGNUP.WORKSPACE_INFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109120813518313461)
,p_name=>'SERVICE_SIGNUP.YES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109312505829313609)
,p_name=>'SESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109415299562313686)
,p_name=>'SESSION VERIFY FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D\9A57\8B49\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108956216009313331)
,p_name=>'SESSIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109478967189313735)
,p_name=>'SESSION_MON_BUFFER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE9\885D\5340:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109478795275313735)
,p_name=>'SESSION_MON_CPU'
,p_message_language=>'zh-tw'
,p_message_text=>'CPU:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109478447461313735)
,p_name=>'SESSION_MON_CURRENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109478828716313735)
,p_name=>'SESSION_MON_DISK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78C1\789F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109478666555313735)
,p_name=>'SESSION_MON_ELAPSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D93\6B77\6642\9593:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109478507409313735)
,p_name=>'SESSION_MON_PREVIOUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\9801')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109039815798313401)
,p_name=>'SET_BINDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E2C\8A66\67E5\8A62\6642\5FC5\9808\8A2D\5B9A\6240\6709\9023\7D50\8B8A\6578\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108942023907313320)
,p_name=>'SET_FEATURE_DUE_DATE_TO_MILESTONE_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\7248\6B21 %2 \4E14\6307\5B9A\7D66 %1 \4E4B %0 \672A\5B8C\6210\529F\80FD\7684\5230\671F\65E5\8A2D\70BA\91CC\7A0B\7891\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109061894497313417)
,p_name=>'SET_MILESTONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\91CC\7A0B\7891')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108942393839313320)
,p_name=>'SET_MILESTONES_NOT_YET_SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\7121\91CC\7A0B\7891\7684\529F\80FD\8A2D\70BA\7248\6B21 %2 \4E14\6307\5B9A\7D66 %1 \4E4B %0 \672A\5B8C\6210\529F\80FD\7684\91CC\7A0B\7891 (%3).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108942247207313320)
,p_name=>'SET_MILESTONE_OF_INCOMPLETE_FEATURES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\7248\6B21 %2 \4E14\6307\5B9A\7D66 %1 \4E4B %0 \672A\5B8C\6210\529F\80FD\7684\91CC\7A0B\7891 (\5C0D\61C9\903E\671F\7684\91CC\7A0B\7891) \8B8A\66F4\70BA\91CC\7A0B\7891 (%3).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109061444879313417)
,p_name=>'SET_OPEN_FEATURES_M1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07 %0 \500B\5F85\8655\7406\529F\80FD\6307\5B9A\7D66\9078\53D6\7684\91CC\7A0B\7891.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109061954656313417)
,p_name=>'SET_OPEN_FEATURES_M2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07 %0 \500B\5F85\8655\7406\529F\80FD\5230\671F\65E5\8A2D\70BA\91CC\7A0B\7891\65E5\671F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110099130174314215)
,p_name=>'SET_PREFERENCES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\504F\597D\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109062157916313417)
,p_name=>'SET_RELEASE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\7248\6B21')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109477720247313734)
,p_name=>'SHARED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5171\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109656980412313875)
,p_name=>'SHARED COMPONENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5171\7528\7684\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109414988831313686)
,p_name=>'SHARED DYNAMIC LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5171\7528\7684\52D5\614B\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108911437260313296)
,p_name=>'SHARED POOL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5171\7528\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109414873584313686)
,p_name=>'SHARED STATIC LOV CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5171\7528\7684\975C\614B\503C\6E05\55AE\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108986427717313355)
,p_name=>'SHARED_COMPONENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5171\7528\7684\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109654272319313873)
,p_name=>'SHARED_VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5171\7528\7684\9A57\8B49')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109116887310313458)
,p_name=>'SHORTCUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6377\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109559432150313799)
,p_name=>'SHORTCUTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6377\5F91')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109366408836313649)
,p_name=>'SIGNIFICANT_IMPACT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56B4\91CD\5F71\97FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109369525684313652)
,p_name=>'SIGNIFICANT_PROGRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\8457\9032\5C55')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109115367979313457)
,p_name=>'SIMPLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C21\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109360926118313645)
,p_name=>'SIMPLE_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C21\55AE\5716\8868')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109438092213313704)
,p_name=>'SINCE_DATE_MASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('16 \5C0F\6642\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109497599891313749)
,p_name=>'SINCE_DAY_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('1 \5929\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109497489675313748)
,p_name=>'SINCE_HOUR_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('1 \5C0F\6642\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110117416721314246)
,p_name=>'SINCE_SHORT_DATE_MASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('16 \5C0F\6642\5167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109497661313313749)
,p_name=>'SINCE_WEEK_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('1 \9031\524D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108953033293313329)
,p_name=>'SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5927\5C0F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110073892159314195)
,p_name=>'SL.APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110069993241314192)
,p_name=>'SL.EDIT.PAGE.IN.APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\61C9\7528\7A0B\5F0F %1 \4E2D\7684\9801\9762 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110070079235314192)
,p_name=>'SL.GO.TO.APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D\5F80\61C9\7528\7A0B\5F0F %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109899823656314071)
,p_name=>'SL.MATCH.FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\5230 1 \500B\76F8\7B26\9805\76EE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109899901135314071)
,p_name=>'SL.N.MATCHES.FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\5230 %0 \500B\76F8\7B26\9805\76EE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109917273311314084)
,p_name=>'SL.NO.MATCH.FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\76F8\7B26\7684\9805\76EE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110073934193314195)
,p_name=>'SL.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109591227350313822)
,p_name=>'SL.PLACEHOLDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109636515830313859)
,p_name=>'SL.SEARCH.ALLAPPS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\5305\542B %0 \7684\6240\6709\61C9\7528\7A0B\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110070309564314193)
,p_name=>'SL.SEARCH.APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\6B64\61C9\7528\7A0B\5F0F\4EE5\5C0B\627E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109832082386314022)
,p_name=>'SL.SEARCH.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\81F3\5C11\8F38\5165\5169\500B\5B57\6BCD\4F86\9032\884C\641C\5C0B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110070280761314193)
,p_name=>'SL.SEARCH.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\9801\9762\4EE5\5C0B\627E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110070487758314193)
,p_name=>'SL.SEARCH.TEAM.DEV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\5718\968A\958B\767C\4EE5\5C0B\627E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110070503641314193)
,p_name=>'SL.SEARCH.USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\4F7F\7528\8005 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110070668907314193)
,p_name=>'SL.SEARCH.WP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\5DE5\4F5C\5340\4EE5\5C0B\627E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110070194068314193)
,p_name=>'SL.SHARED.COMP.APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \61C9\7528\7A0B\5F0F\7684\5171\7528\5143\4EF6')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109363427420313647)
,p_name=>'SOFTWARE_DEFECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8EDF\9AD4\7455\75B5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109368471552313651)
,p_name=>'SOMEWHAT_DESIRABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6709\4E9B\9700\8981')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109695807110313919)
,p_name=>'SOURCE_IDENTIFIER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F86\6E90 ID')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109502567396313752)
,p_name=>'SPACE_UTILIZATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\73FE\6709\7A7A\9593\4F7F\7528\72C0\6CC1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109352098576313638)
,p_name=>'SQL NOT AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\4F7F\7528 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109559851169313799)
,p_name=>'SQL WORKSHOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \5DE5\4F5C\5BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109495515794313747)
,p_name=>'SQL_COMMANDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \547D\4EE4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109390892875313668)
,p_name=>'SQL_COMMAND_HISTORY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \547D\4EE4\6B77\53F2\8A18\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109168702812313497)
,p_name=>'SQL_EXPRESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109429145489313697)
,p_name=>'SQL_INJECT_LINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109428837569313697)
,p_name=>'SQL_INJECT_PACKAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\88DD\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109428958080313697)
,p_name=>'SQL_INJECT_PROCEDURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109428764265313697)
,p_name=>'SQL_INJECT_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109429091979313697)
,p_name=>'SQL_INJECT_VAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109714537657313933)
,p_name=>'SQL_NOT_ENABLED_APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\61C9\7528\7A0B\5F0F\672A\555F\7528 SQL \8207 PL/SQL \5B58\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109714669547313933)
,p_name=>'SQL_NOT_ENABLED_INST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\57F7\884C\8655\7406\672A\555F\7528 SQL \8207 PL/SQL \5B58\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109114495847313456)
,p_name=>'SQL_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108920440163313303)
,p_name=>'SQL_QUERY_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\67E5\8A62, \627E\4E0D\5230 select \6558\8FF0\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109215978974313532)
,p_name=>'SQL_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109019376295313385)
,p_name=>'SQL_REPORT_WIZ.APPEND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9644\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109108100031313452)
,p_name=>'SQL_REPORT_WIZ.DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109108660140313452)
,p_name=>'SQL_REPORT_WIZ.DISABLE_SORT_COL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528\6392\5E8F\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109107825819313451)
,p_name=>'SQL_REPORT_WIZ.DISPLAY_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109108251411313452)
,p_name=>'SQL_REPORT_WIZ.PRIMARY_SORT_COL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\6392\5E8F\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109019296880313385)
,p_name=>'SQL_REPORT_WIZ.REPLACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\4EE3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109107909495313451)
,p_name=>'SQL_REPORT_WIZ.RETURN_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109108498009313452)
,p_name=>'SQL_REPORT_WIZ.SECONDARY_SORT_COL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B21\8981\6392\5E8F\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109108576757313452)
,p_name=>'SQL_REPORT_WIZ.SELECT_COL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109391006634313668)
,p_name=>'SQL_SCRIPTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \547D\4EE4\6A94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109390912085313668)
,p_name=>'SQL_SCRIPT_RESULTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \547D\4EE4\6A94\7D50\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109700612458313922)
,p_name=>'SQL_TAG_REF_NOT_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\5728\5141\8A31\7684\8868\683C\6E05\55AE\4E2D\5B9A\7FA9\4E0B\5217\8CC7\6599\5EAB\7269\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109391150949313668)
,p_name=>'SQL_WORKSHOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \5DE5\4F5C\5BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109171035041313498)
,p_name=>'SQL_WS.OB.DUPLICATE_ALIAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6\7269\4EF6\5DF2\4F7F\7528\6307\5B9A\7684\5225\540D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109170955577313498)
,p_name=>'SQL_WS.OB.INVALID_ALIAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\7684\7269\4EF6\5225\540D\7121\6548. \6709\6548\7684\5225\540D\53EA\80FD\5305\542B\5B57\6BCD\3001\6578\5B57\3001\5E95\7DDA\548C\865B\7DDA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109484617816313739)
,p_name=>'SQL_WS.OB.NOT_ORDS_ENABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\7DB1\8981\5C1A\672A\5728 ORDS RESTful \8CC7\6599\670D\52D9\8A3B\518A. \82E5\8981\8A3B\518A\6B64\7DB1\8981, \8ACB\700F\89BD\81F3 <strong>RESTful \670D\52D9 > ORDS Restful \670D\52D9</strong>, \7136\5F8C\6309\4E00\4E0B<strong>\5728 ORDS \8A3B\518A\7DB1\8981</strong>\6309\9215.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109499609159313750)
,p_name=>'SQL_WS.OB.NO_REST_IN_CDB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('APEX \76EE\524D\5728 CDB \4E2D\57F7\884C. \60A8\7121\6CD5\5728 CDB \4E2D\5B9A\7FA9 ORDS \578B REST \670D\52D9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109499479999313750)
,p_name=>'SQL_WS.OB.OLD_ORDS_VERSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\5B89\88DD\7684 ORDS \7248\672C (%0) \4E0D\652F\63F4\555F\7528 REST \4E4B\8CC7\6599\5EAB\7269\4EF6\9700\8981\7684\6240\6709\529F\80FD. \6700\5C11\5FC5\9808\5B89\88DD %1 \7248\672C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109499264970313750)
,p_name=>'SQL_WS.OB.ORDS_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7CFB\7D71\627E\4E0D\5230\555F\7528 ORDS RESTful \670D\52D9\6240\9700\7684 ORDS_METADATA \7DB1\8981. \8ACB\53C3\95B1 Oracle REST Data Services Installation Guide \77AD\89E3\5B89\88DD\6B65\9A5F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109499552393313750)
,p_name=>'SQL_WS.OB.ORDS_VERION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ORDS \7248\672C <strong>%0</strong>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109499383826313750)
,p_name=>'SQL_WS.OB.PLSQL_GATEWAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\7CFB\7D71\76EE\524D\4F7F\7528 Oracle \7684\5167\5D4C PL/SQL \9598\9053. \5FC5\9808\5B89\88DD %0 \6216\66F4\65B0\7248\672C\7684 Oracle REST Data Services, \624D\80FD\4F7F\7528\555F\7528 REST \7684\8CC7\6599\5EAB\7269\4EF6.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108889382795313279)
,p_name=>'STACKED2DCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5806\758A 2D \67F1\72C0\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108889450295313279)
,p_name=>'STACKED3DCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5806\758A 3D \67F1\72C0\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108889573218313279)
,p_name=>'STACKEDHORIZONTAL2DCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C34\5E73\5806\758A 2D \67F1\72C0\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108889605163313279)
,p_name=>'STACKEDHORIZONTAL3DCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C34\5E73\5806\758A 3D \67F1\72C0\5716')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109655771593313874)
,p_name=>'STANDARD _TABS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\6E96\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109657426621313876)
,p_name=>'STANDARD_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\6E96\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109095631212313442)
,p_name=>'STANDARD_TAB_SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\6E96\9801\7C64\96C6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108981840138313352)
,p_name=>'STATIC APPLICATION FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\61C9\7528\7A0B\5F0F\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108981766764313352)
,p_name=>'STATIC WORKSPACE FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\5DE5\4F5C\5340\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110152439018314273)
,p_name=>'STATICSEARCH.MINIMUM_LENGTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\8F38\5165\81F3\5C11\4E00\500B\95DC\9375\5B57, \4E14\6B64\95DC\9375\5B57\81F3\5C11\8981\6709\5169\500B\5B57\5143. ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110152548747314273)
,p_name=>'STATICSEARCH.NO_RESULTS_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\7B26\5408\60A8\641C\5C0B\67E5\8A62\7684\7D50\679C. ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109168532055313497)
,p_name=>'STATIC_ASSIGNMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\6307\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109501052848313751)
,p_name=>'STATIC_FILES_NO_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\95DC\806F\7684\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108912603933313297)
,p_name=>'STATIC_HTML'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108896147916313284)
,p_name=>'STATIC_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\53C3\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109359786245313644)
,p_name=>'STATIC_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109424303098313693)
,p_name=>'STATIC_SUBSTITUTION_STRINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B\66FF\4EE3\5B57\4E32')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110115149003314244)
,p_name=>'STATUS_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\72C0\614B: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109295558799313596)
,p_name=>'STATUS_MODIFIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4FEE\6539\7684\72C0\614B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109410901839313683)
,p_name=>'STD TAB CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\6E96\9801\7C64\689D\4EF6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110104221841314235)
,p_name=>'STEAL_LOCK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\7528\9396\5B9A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108955948444313331)
,p_name=>'STORAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58:')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109114591484313456)
,p_name=>'STRUCTURED_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\69CB\5316\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109215744139313532)
,p_name=>'STRUCTURED_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\69CB\5316\5831\8868')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109501965881313752)
,p_name=>'SUBMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109295498950313596)
,p_name=>'SUBMITTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9001\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109211218981313529)
,p_name=>'SUBMIT_AS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109421166307313691)
,p_name=>'SUBMIT_FEEDBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\610F\898B\56DE\994B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109353271180313639)
,p_name=>'SUBORDINATE CURRENT ENTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\65BC\76EE\524D\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109353391944313639)
,p_name=>'SUBORDINATE NON CURRENT ENTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\5C6C\65BC\975E\76EE\524D\7684\9805\76EE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110130016812314256)
,p_name=>'SUBSCRIBED_FROM.NONEXISTING_MASTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5B58\5728\7684\4E3B\8981\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110130276915314256)
,p_name=>'SUBSCRIBED_FROM.THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110130186505314256)
,p_name=>'SUBSCRIBED_FROM.THEME_REPOSITORY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\5132\5B58\5340\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109097794297313444)
,p_name=>'SUBSCRIBE_AUTHORIZATION.COPIED_FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\61C9\7528\7A0B\5F0F\8907\88FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109098075822313444)
,p_name=>'SUBSCRIBE_AUTHORIZATION.MASTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\662F\6B64\6388\6B0A\914D\7F6E\7684\4E3B\672C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109098299118313444)
,p_name=>'SUBSCRIBE_AUTHORIZATION.NO_SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\8A02\95B1\6B64\6388\6B0A\914D\7F6E\7684\6388\6B0A\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109098151598313444)
,p_name=>'SUBSCRIBE_AUTHORIZATION.REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1\6B64\6388\6B0A\914D\7F6E\7684\6388\6B0A\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108900175312313287)
,p_name=>'SUBSCRIBE_DATA_LOAD.COPIED_FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\61C9\7528\7A0B\5F0F\8907\88FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108900414374313287)
,p_name=>'SUBSCRIBE_DATA_LOAD.MASTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\662F\6B64\8CC7\6599\8F09\5165\5B9A\7FA9\7684\4E3B\8981\8907\672C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108900393995313287)
,p_name=>'SUBSCRIBE_DATA_LOAD.NO_SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\4EFB\4F55\8CC7\6599\8F09\5165\5B9A\7FA9\8A02\95B1\6B64\5B9A\7FA9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108900275253313287)
,p_name=>'SUBSCRIBE_DATA_LOAD.REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1\6B64\5B9A\7FA9\7684\8CC7\6599\8F09\5165\5B9A\7FA9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109097189456313443)
,p_name=>'SUBSCRIBE_ITEM_HELP.COPIED_FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\61C9\7528\7A0B\5F0F\8907\88FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109097221843313443)
,p_name=>'SUBSCRIBE_ITEM_HELP.MASTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\662F\6B64\9805\76EE\8AAA\660E\7684\4E3B\672C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109097419413313443)
,p_name=>'SUBSCRIBE_ITEM_HELP.NO_SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\8A02\95B1\6B64\9805\76EE\8AAA\660E\5167\5BB9\7684\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109097368375313443)
,p_name=>'SUBSCRIBE_ITEM_HELP.REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1\6B64\9805\76EE\8AAA\660E\6587\5B57\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109099716731313445)
,p_name=>'SUBSCRIBE_LOV.COPIED_FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\61C9\7528\7A0B\5F0F\8907\88FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109099825952313445)
,p_name=>'SUBSCRIBE_LOV.MASTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\662F\6B64\300C\503C\6E05\55AE\300D\7684\300C\4E3B\8981\300D\8907\672C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109100017023313445)
,p_name=>'SUBSCRIBE_LOV.NO_SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\300C\503C\6E05\55AE\300D\8A02\95B1\6B64\300C\503C\6E05\55AE\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109099990995313445)
,p_name=>'SUBSCRIBE_LOV.REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1\6B64\503C\6E05\55AE\7684\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108987834278313356)
,p_name=>'SUBSCRIBE_NAVBAR.COPIED_FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\61C9\7528\7A0B\5F0F\8907\88FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109101359094313446)
,p_name=>'SUBSCRIBE_NAVBAR.MASTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\662F\6B64\300C\5C0E\89BD\5217\300D\7684\4E3B\672C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109101908268313447)
,p_name=>'SUBSCRIBE_NAVBAR.NO_SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\8A02\95B1\6B64\300C\5C0E\89BD\5217\300D\7684\5C0E\89BD\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109101667493313447)
,p_name=>'SUBSCRIBE_NAVBAR.REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1\6B64\5C0E\89BD\5217\7684\5C0E\89BD\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108987401907313356)
,p_name=>'SUBSCRIBE_PLUGIN.COPIED_FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\61C9\7528\7A0B\5F0F\8907\88FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108987518618313356)
,p_name=>'SUBSCRIBE_PLUGIN.MASTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\662F\6B64 Plug-in \7684\300C\4E3B\8981\300D\8907\672C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108987799646313356)
,p_name=>'SUBSCRIBE_PLUGIN.NO_SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\8A02\95B1\6B64 Plug-in \7684 Plug-in.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108987658929313356)
,p_name=>'SUBSCRIBE_PLUGIN.REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1\6B64 Plug-in \7684 Plug-in')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109098528705313444)
,p_name=>'SUBSCRIBE_SHORTCUT.COPIED_FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\61C9\7528\7A0B\5F0F\8907\88FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109098789480313444)
,p_name=>'SUBSCRIBE_SHORTCUT.MASTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\662F\6B64\6377\5F91\7684\4E3B\672C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109099058691313445)
,p_name=>'SUBSCRIBE_SHORTCUT.NO_SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\8A02\95B1\6B64\6377\5F91\7684\6377\5F91.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109098976131313444)
,p_name=>'SUBSCRIBE_SHORTCUT.REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1\6B64\6377\5F91\7684\6377\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109093337218313440)
,p_name=>'SUBSCRIBE_TEMPLATE.COPIED_FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\61C9\7528\7A0B\5F0F\8907\88FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109093531470313441)
,p_name=>'SUBSCRIBE_TEMPLATE.MASTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\662F\6B64\6A23\677F\7684\4E3B\672C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109093632544313441)
,p_name=>'SUBSCRIBE_TEMPLATE.NO_SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\8A02\95B1\6B64\6A23\677F\7684\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109093419529313440)
,p_name=>'SUBSCRIBE_TEMPLATE.POPUP_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5373\73FE\5F0F\503C\6E05\55AE\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109104457583313449)
,p_name=>'SUBSCRIBE_TEMPLATE.REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1\6B64\6A23\677F\7684\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110068886781314192)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1\61C9\7528\7A0B\5F0F\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110111453948314242)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1\6A19\6E96\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110069209590314192)
,p_name=>'SUBSCRIBE_THEME.MASTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\662F\6B64\4E3B\984C\7684\300C\4E3B\8981\300D\8907\672C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110069126171314192)
,p_name=>'SUBSCRIBE_THEME.NO_SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\4E3B\984C\8A02\95B1\6B64\4E3B\984C. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110068942547314192)
,p_name=>'SUBSCRIBE_THEME.POPUP_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5373\73FE\5F0F\503C\6E05\55AE\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110069029585314192)
,p_name=>'SUBSCRIBE_THEME.REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1\6B64\4E3B\984C\7684\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109476705297313733)
,p_name=>'SUBSCRIBE_WEB_SRC.COPIED_FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\61C9\7528\7A0B\5F0F\8907\88FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109476894521313733)
,p_name=>'SUBSCRIBE_WEB_SRC.MASTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\662F\6B64 REST \8CC7\6599\4F86\6E90\7684\4E3B\8981\8907\672C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109477054294313734)
,p_name=>'SUBSCRIBE_WEB_SRC.NO_SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\4EFB\4F55 REST \8CC7\6599\4F86\6E90\8A02\95B1\6B64\4F86\6E90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109476918830313733)
,p_name=>'SUBSCRIBE_WEB_SRC.REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1\6B64\4F86\6E90\7684 REST \8CC7\6599\4F86\6E90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109103462285313448)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.COPIED_FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\61C9\7528\7A0B\5F0F\8907\88FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109104225213313449)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.MASTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\662F\6B64\6309\9215\6A23\677F\7684\300C\4E3B\8981\300D\8907\672C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109104628463313449)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.NO_SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\8A02\95B1\6B64\6309\9215\6A23\677F\7684\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109104545845313449)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1\6B64\6309\9215\6A23\677F\7684\6309\9215\6A23\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108931468320313311)
,p_name=>'SUBSTITUTION_STRING_USAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66FF\4EE3\5B57\4E32\4F7F\7528\65B9\5F0F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109332186842313624)
,p_name=>'SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109408670443313681)
,p_name=>'SUCCESS MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109294555078313595)
,p_name=>'SUCCESSES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109161234229313491)
,p_name=>'SUCCESS_MSG.CLUSTER_TRUNCATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53E2\96C6\88AB\622A\65B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109157532594313488)
,p_name=>'SUCCESS_MSG.CMD_EXECUTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\57F7\884C\547D\4EE4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109160322918313491)
,p_name=>'SUCCESS_MSG.CONTEXT_DROPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\76F8\95DC\8CC7\8A0A\74B0\5883.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109160594652313491)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\300C\8CC7\6599\5EAB\9023\7D50\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109160467664313491)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_DROPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\300C\8CC7\6599\5EAB\9023\7D50\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109161446918313491)
,p_name=>'SUCCESS_MSG.FUNCTION_ALTERED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\6539\51FD\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109156441015313488)
,p_name=>'SUCCESS_MSG.FUNCTION_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\51FD\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109159338897313490)
,p_name=>'SUCCESS_MSG.FUNCTION_DROPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\51FD\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109161091698313491)
,p_name=>'SUCCESS_MSG.INDEXTYPE_ALTERED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\6539\7D22\5F15\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109160222190313490)
,p_name=>'SUCCESS_MSG.INDEXTYPE_DROPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\7D22\5F15\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109156816368313488)
,p_name=>'SUCCESS_MSG.INDEX_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\7D22\5F15.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109159609161313490)
,p_name=>'SUCCESS_MSG.INDEX_DROPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\7D22\5F15.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109157116819313488)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\300C\5BE6\9AD4\5316\8996\89C0\8868\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109159799937313490)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_DROPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\5BE6\9AD4\5316\8996\89C0\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109161321406313491)
,p_name=>'SUCCESS_MSG.PACKAGE_ALTERED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\6539\5957\88DD\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109156630858313488)
,p_name=>'SUCCESS_MSG.PKG_BODY_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\300C\5957\88DD\7A0B\5F0F\4E3B\9AD4\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109156756643313488)
,p_name=>'SUCCESS_MSG.PKG_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\5957\88DD\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109158616605313489)
,p_name=>'SUCCESS_MSG.PKG_DROPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\5957\88DD\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109161598817313491)
,p_name=>'SUCCESS_MSG.PROCEDURE_ALTERED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\6539\7A0B\5E8F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109156544496313488)
,p_name=>'SUCCESS_MSG.PROCEDURE_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\7A0B\5E8F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109159461984313490)
,p_name=>'SUCCESS_MSG.PROCEDURE_DROPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\7A0B\5E8F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109157217493313488)
,p_name=>'SUCCESS_MSG.ROLE_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\89D2\8272.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109159873755313490)
,p_name=>'SUCCESS_MSG.ROLE_DROPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\89D2\8272.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109158000273313489)
,p_name=>'SUCCESS_MSG.ROWS_DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664 %0 \500B\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109157832686313489)
,p_name=>'SUCCESS_MSG.ROWS_INSERTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\63D2\5165 %0 \500B\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109157781607313489)
,p_name=>'SUCCESS_MSG.ROWS_UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\65B0 %0 \500B\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109161617544313492)
,p_name=>'SUCCESS_MSG.SEQ_ALTERED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\6539\9806\5E8F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109157308854313488)
,p_name=>'SUCCESS_MSG.SEQ_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\9806\5E8F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109159077937313490)
,p_name=>'SUCCESS_MSG.SEQ_DROPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\9806\5E8F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108883031324313274)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\5DF2\5EFA\7ACB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108882995267313274)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\5DF2\522A\9664.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108882878854313274)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\5DF2\66F4\65B0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108917825892313301)
,p_name=>'SUCCESS_MSG.STMT_PROCESSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8655\7406\6558\8FF0\53E5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109157481529313488)
,p_name=>'SUCCESS_MSG.SYNONYM_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\540C\7FA9\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109159994009313490)
,p_name=>'SUCCESS_MSG.SYNONYM_DROPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\540C\7FA9\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109159192297313490)
,p_name=>'SUCCESS_MSG.TABLE_ALTERED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\6539\8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109156009926313487)
,p_name=>'SUCCESS_MSG.TABLE_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109158527951313489)
,p_name=>'SUCCESS_MSG.TABLE_DROPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109160611727313491)
,p_name=>'SUCCESS_MSG.TABLE_RENAMED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\91CD\65B0\547D\540D\8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109161103728313491)
,p_name=>'SUCCESS_MSG.TABLE_TRUNCATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\88AB\622A\65B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109160996577313491)
,p_name=>'SUCCESS_MSG.TRIGGER_ALTERED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\6539\89F8\767C\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109156364962313488)
,p_name=>'SUCCESS_MSG.TRIGGER_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\89F8\767C\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109160073697313490)
,p_name=>'SUCCESS_MSG.TRIGGER_DROPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\89F8\767C\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109160851841313491)
,p_name=>'SUCCESS_MSG.TYPE_ALTERED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\6539\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109156967102313488)
,p_name=>'SUCCESS_MSG.TYPE_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109160132250313490)
,p_name=>'SUCCESS_MSG.TYPE_DROPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109161792087313492)
,p_name=>'SUCCESS_MSG.USER_ALTERED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\6539\4F7F\7528\8005.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109157038141313488)
,p_name=>'SUCCESS_MSG.USER_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\4F7F\7528\8005.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109158798923313489)
,p_name=>'SUCCESS_MSG.USER_DROPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\4F7F\7528\8005.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109160701185313491)
,p_name=>'SUCCESS_MSG.VIEW_ALTERED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\6539\6AA2\8996.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109156183109313487)
,p_name=>'SUCCESS_MSG.VIEW_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\6AA2\8996.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109158810478313489)
,p_name=>'SUCCESS_MSG.VIEW_DROPPED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\6AA2\8996.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109500614278313751)
,p_name=>'SUPPORTING_OBJECTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\652F\63F4\7684\7269\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110037397747314170)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DEF_CHANGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7269\4EF6\5B9A\7FA9\5DF2\8B8A\66F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110037405976314170)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7269\4EF6\5DF2\4E0D\5B58\5728.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109361229187313645)
,p_name=>'SVG CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SVG \5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109450785521313714)
,p_name=>'SVG PLUGIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\5B89\88DD SVG Viewer \4EE5\6AA2\8996\5716\8868.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108881379125313273)
,p_name=>'SW_EMPTY_SCRIPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7121\6CD5\7DE8\8F2F\7A7A\7684 SQL \547D\4EE4\6A94.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108881426955313273)
,p_name=>'SW_GREATER_THAN_30K'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7121\6CD5\7DE8\8F2F\5927\65BC 30,000 \500B\4F4D\5143\7D44\7684\547D\4EE4\6A94.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109113768271313456)
,p_name=>'SYNONYM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540C\7FA9\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109715045992313933)
,p_name=>'SYNONYM_IN_PAREN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\540C\7FA9\5B57)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109493997012313746)
,p_name=>'SYNONYM_NOUN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540C\7FA9\5B57')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109625140297313851)
,p_name=>'SYSTEM_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7CFB\7D71\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109295603365313596)
,p_name=>'SYSTEM_STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7CFB\7D71\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109295719814313596)
,p_name=>'SYSTEM_STATUS_MODIFIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4FEE\6539\7684\7CFB\7D71\72C0\614B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109113810598313456)
,p_name=>'TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109361881434313646)
,p_name=>'TABLE NOT FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\662F\6709\6548\7684\8868\683C\6216\8996\89C0\8868\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109391690268313669)
,p_name=>'TABLESPACES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\7A7A\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109112828884313455)
,p_name=>'TABLE_IN_PAREN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\8868\683C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109408023233313681)
,p_name=>'TABLE_NAME_TOO_LONG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\8868\683C\540D\7A31\300D%0 \8D85\904E\5141\8A31\7684\5927\5C0F.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109420970825313691)
,p_name=>'TABULAR_FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\8868\5316\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109427454758313696)
,p_name=>'TABULAR_FORM_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\5217\8868\5316\8868\55AE.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109108744183313452)
,p_name=>'TAB_MANAGER.WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A: \7236\9805\9801\7C64\76EE\6A19 "%0" \53C3\7167\4E0D\5B58\5728\7684\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109100404379313446)
,p_name=>'TAB_SEQUENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109099335304313445)
,p_name=>'TAB_SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109655632811313874)
,p_name=>'TAB_SETS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109099561022313445)
,p_name=>'TAB_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64\6587\5B57')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110116342113314245)
,p_name=>'TAG_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\8A18: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108940859676313319)
,p_name=>'TARGETED_FEATURES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\6A19\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110154435340314275)
,p_name=>'TARGET_PAGE_ID_OR_CUSTOM_URL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\6A19\9801\9762 ID \6216\81EA\8A02 URL')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109364511272313648)
,p_name=>'TASK_COMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5B8C\6210')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109388759392313666)
,p_name=>'TEAM_DEVELOPMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5718\968A\958B\767C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109094309199313441)
,p_name=>'TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110143553356314266)
,p_name=>'TEMPLATE.ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109348296473313636)
,p_name=>'TEMPLATE.AFTER_HEADER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109348309083313636)
,p_name=>'TEMPLATE.BEFORE_FOOTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\5C3E\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110143260739314266)
,p_name=>'TEMPLATE.COPY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\6A23\677F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110143493728314266)
,p_name=>'TEMPLATE.NEW_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA\6A23\677F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108876970840313269)
,p_name=>'TEMPLATE.PAGE_TMP_BDY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A23\677F\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109347972633313635)
,p_name=>'TEMPLATE.PAGE_TMP_BDY1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A23\677F\4E3B\9AD4 (1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109348058465313636)
,p_name=>'TEMPLATE.PAGE_TMP_BDY2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A23\677F\4E3B\9AD4 (2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109348140536313636)
,p_name=>'TEMPLATE.PAGE_TMP_BDY3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6A23\677F\4E3B\9AD4 (3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110143380108314266)
,p_name=>'TEMPLATE.PREVIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\89BD\6A23\677F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109347179434313635)
,p_name=>'TEMPLATE.T_REGION_POS09'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109347265633313635)
,p_name=>'TEMPLATE.T_REGION_POS10'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109347361634313635)
,p_name=>'TEMPLATE.T_REGION_POS11'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E 11')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109347448906313635)
,p_name=>'TEMPLATE.T_REGION_POS12'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E 12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109347583275313635)
,p_name=>'TEMPLATE.T_REGION_POS13'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E 13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109347674531313635)
,p_name=>'TEMPLATE.T_REGION_POS14'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E 14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109347794308313635)
,p_name=>'TEMPLATE.T_REGION_POS15'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E 15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109347811763313635)
,p_name=>'TEMPLATE.T_REGION_POS16'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F4D\7F6E 16')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109850895095314036)
,p_name=>'TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109481164326313736)
,p_name=>'TEMPLATE_APPLICATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108910964125313295)
,p_name=>'TEMPLATE_APP_INSTALL_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\300C\6A23\677F\61C9\7528\7A0B\5F0F\300D\5EFA\7ACB\61C9\7528\7A0B\5F0F\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109548154481313786)
,p_name=>'TEMPLATE_DRIVEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F\5C0E\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109479294738313735)
,p_name=>'TEMPLATE_OPTIONS.ADVANCED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\968E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109479173327313735)
,p_name=>'TEMPLATE_OPTIONS.COMMON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\901A\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109923143689314088)
,p_name=>'TEMPLATE_OPTIONS.DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109479062523313735)
,p_name=>'TEMPLATE_OPTIONS.GENERAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110040295239314172)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTIONS_DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5B9A\7FA9\4EFB\4F55\76F8\7B26\7684\6A23\677F\9078\9805.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110047910858314177)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTION_SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \672A\9078\53D6\9078\9805 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110024467261314161)
,p_name=>'TEMPLATE_OPTIONS.USE_TEMPLATE_DEFAULTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\6A23\677F\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110130854571314257)
,p_name=>'TEMPLATE_OPTIONS_MISMATCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F\9078\9805\4E0D\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110151959575314273)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\6A23\677F\5DF2\8A02\95B1\4E3B\8981\4E3B\984C\4E2D\7684\5C0D\61C9\6A23\677F. \82E5\8981\4FEE\6539\6B64\6A23\677F, \8ACB\7DE8\8F2F\4E3B\8981\6A23\677F, \7136\5F8C\91CD\65B0\6574\7406\4E3B\984C. \60A8\4E5F\53EF\4EE5\5EFA\7ACB\6B64\6A23\677F\7684\672C\6A5F\672A\8A02\95B1\8907\672C. \60A8\53EF\4EE5\7DE8\8F2F\672A\8A02\95B1\7684\6A23\677F, \4E14\4E0D\6703\56E0\4E3B\984C\91CD\65B0\6574\7406\800C\88AB\8986\5BEB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110151877035314273)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9019\662F\6B64\61C9\7528\7A0B\5F0F\7684\672C\6A5F\6A23\677F, \800C\4E14\5DF2\53D6\6D88\8A02\95B1. '),
unistr('\5DF2\8A02\95B1\95DC\806F\7684\4E3B\984C\6642, \7121\6CD5\8A02\95B1\500B\5225\6A23\677F.'),
unistr('\9664\4E86\5B9A\7FA9\672C\6A5F\6A23\677F\5916, \60A8\4E5F\53EF\4EE5\65B0\589E\6A23\677F\5230\4E3B\8981\4E3B\984C, \63A5\8457\4FBF\53EF\8F15\9B06\5730\5C07\6A23\677F\767C\9001\6216\63D0\53D6\5230\6B64\61C9\7528\7A0B\5F0F.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109105510998313450)
,p_name=>'TEMPLATE_UTILIZATION.DEFAULT_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\7167\70BA\61C9\7528\7A0B\5F0F\9810\8A2D\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109105774510313450)
,p_name=>'TEMPLATE_UTILIZATION.ERROR_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\7167\70BA\932F\8AA4\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109105917708313450)
,p_name=>'TEMPLATE_UTILIZATION.NOT_REFERENCED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\53C3\7167\6B64\9801\9762\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109106023751313450)
,p_name=>'TEMPLATE_UTILIZATION.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\6A23\677F\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109105869386313450)
,p_name=>'TEMPLATE_UTILIZATION.PAGE_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\7167\65BC\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109105603967313450)
,p_name=>'TEMPLATE_UTILIZATION.PRINTER_FRIENDLY_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\7167\70BA\9069\7528\65BC\5370\8868\6A5F\6A23\677F.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109300180718313599)
,p_name=>'TEMPORARY_TABLESPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66AB\6642\8868\683C\7A7A\9593')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109161866290313492)
,p_name=>'TEST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E2C\8A66')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109386658662313665)
,p_name=>'TESTING_ASSIGNEE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E2C\8A66\6307\5B9A\5C0D\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109384889452313663)
,p_name=>'TESTING_IMPACT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E2C\8A66\5F71\97FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109387063863313665)
,p_name=>'TESTING_STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E2C\8A66\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109453316447313716)
,p_name=>'TEST_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E2C\8A66\67E5\8A62')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109656812684313875)
,p_name=>'TEXT FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\6A94')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109055053635313412)
,p_name=>'THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108981625035313351)
,p_name=>'THEME FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109656426001313875)
,p_name=>'THEME IMAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110117505741314246)
,p_name=>'THEME.COMPATIBLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109908899775314078)
,p_name=>'THEME.SELECTOR.APP.GROUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109049455980313408)
,p_name=>'THEMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110152065144314273)
,p_name=>'THEME_IS_SUBSCRIBED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\5728\4E3B\984C\5C64\7D1A\5DF2\8A02\95B1\53E6\4E00\500B\4E3B\984C, \60A8\4FBF\7121\6CD5\53D6\6D88\8A02\95B1\5C6C\65BC\4E3B\984C\7684\500B\5225\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110152302759314273)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TO_TABS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\61C9\7528\7A0B\5F0F\4F7F\7528\6E05\55AE\5F0F\5C0E\89BD, \56E0\6B64\7121\6CD5\8F49\63DB\70BA\4F7F\7528\9801\7C64\5F0F\5C0E\89BD\7684\4E3B\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110152222085314273)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TWO_LEVEL_TABS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\61C9\7528\7A0B\5F0F\7121\6CD5\8F49\63DB\70BA\4F7F\7528\6E05\55AE\5F0F\5C0E\89BD\7684\4E3B\984C, \56E0\70BA\6B64\61C9\7528\7A0B\5F0F\4F7F\7528\5169\5C64\9801\7C64. \8ACB\66F4\65B0\61C9\7528\7A0B\5F0F, \4E26\8A2D\5B9A\76EE\524D\7684\9801\7C64\8A2D\5B9A\503C, \53EA\4F7F\7528\4E00\5C64\9801\7C64\5F8C, \624D\80FD\5207\63DB\4E3B\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109368654993313651)
,p_name=>'THEME_SWITCH.CANNOT_SWITCH_DESKTOP_TO_MOBILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\684C\9762\4E3B\984C\4E0D\80FD\5207\63DB\70BA\884C\52D5\88DD\7F6E\4E3B\984C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109275003091313581)
,p_name=>'THEME_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\985E\578B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110115759916314245)
,p_name=>'TITLE_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109363922591313647)
,p_name=>'TO DO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F85\8FA6\4E8B\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109410789160313683)
,p_name=>'TODO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F85\8FA6\4E8B\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109390498019313668)
,p_name=>'TODOS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F85\8FA6\4E8B\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108940026813313318)
,p_name=>'TODO_COMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5F85\8FA6\4E8B\9805\300D\5B8C\6210 (%0 / %1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109695493597313918)
,p_name=>'TODO_DASH_1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\9805\76EE, %1 \500B\958B\555F, %2 \500B\5DF2\5B8C\6210.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109695518316313918)
,p_name=>'TODO_DASH_2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\9805\76EE\5DF2\90E8\5206\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109695694170313918)
,p_name=>'TODO_DASH_3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\9805\76EE\5DF2\90E8\5206\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109389222217313667)
,p_name=>'TOP_TABLES_BY_ROW_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F9D\8CC7\6599\5217\6578\5340\5206\7684 %0 \500B\5E38\7528\8868\683C (\4F9D\7DB1\8981\5831\544A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109413853592313685)
,p_name=>'TOTAL_CLOSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8655\7406\7E3D\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109411313208313683)
,p_name=>'TOTAL_MILESTONES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CC\7A0B\7891\7E3D\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109413732927313685)
,p_name=>'TOTAL_OPENED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F85\8655\7406\7E3D\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109389393591313667)
,p_name=>'TOTAL_RENDER_ELAPSED_SECONDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE\6642\9593\7E3D\8A08 (\79D2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110031227400314165)
,p_name=>'TO_BE_PURGED_IN_NEXT_7_DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C38\4E45\6E05\9664 (\63A5\4E0B\4F86 7 \5929\5167)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109412439640313684)
,p_name=>'TO_DOS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F85\8FA6\4E8B\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109717551216313935)
,p_name=>'TO_DO_PERCENT_COMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F85\8FA6\4E8B\9805\5B8C\6210\767E\5206\6BD4 (%0/%1):')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109115833683313457)
,p_name=>'TREE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109538692389313779)
,p_name=>'TREE_EXAMPLES_EXISTING_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\73FE\6709\9805\76EE\958B\59CB\6A39\72C0\7D50\69CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109538797351313779)
,p_name=>'TREE_EXAMPLES_SQL_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA SQL \67E5\8A62\958B\59CB\6A39\72C0\7D50\69CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109538992620313780)
,p_name=>'TREE_EXAMPLES_START_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB\958B\59CB\503C\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109538891902313780)
,p_name=>'TREE_EXAMPLES_STATIC_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\975C\614B\503C\958B\59CB\6A39\72C0\7D50\69CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109029048755313393)
,p_name=>'TREE_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\6A39\72C0\7D50\69CB.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109113969372313456)
,p_name=>'TRIGGER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89F8\767C\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108990788986313359)
,p_name=>'TRIGGER.BUTTON_TAB_NAMES_NOT_EQUAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215\540D\7A31\4E0D\80FD\8207\73FE\6709\7684\9801\7C64\540D\7A31\76F8\540C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109496729913313748)
,p_name=>'TRIGGER.FLOWID_SGID_MISMATCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F ID \8207\76EE\524D\7684\5B89\5168\6027\7FA4\7D44 ID \4E0D\4E00\81F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108990648918313359)
,p_name=>'TRIGGER.SGID_RESERVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\5168\6027\7FA4\7D44 ID 20 \4FDD\7559\7D66\5DE5\4F5C\5340 ''ORACLE'' \4F7F\7528')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109494692265313746)
,p_name=>'TRUNCATE_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\622A\65B7\8868\683C %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109539529836313780)
,p_name=>'TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109541446074313781)
,p_name=>'TYPE_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109490092310313743)
,p_name=>'UI_DEF_CUSTOM_ITEM_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\9805\76EE\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109496693172313748)
,p_name=>'UI_DEF_VIEW_DB_COL_DEFN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\8CC7\6599\5EAB\8CC7\6599\6B04\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109383032680313662)
,p_name=>'UI_PAGE_SKIP_TO_CONTENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8DF3\81F3\4E3B\8981\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108903869863313290)
,p_name=>'UI_TYPE.DESKTOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\684C\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108903970008313290)
,p_name=>'UI_TYPE.JQM_SMARTPHONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\52D5\88DD\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108904061637313290)
,p_name=>'UI_TYPE.JQM_TABLET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('jQuery Mobile \5E73\677F\96FB\8166')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108904162803313290)
,p_name=>'UI_TYPE.PHONEGAP_JQM_SMARTPHONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PhoneGap \7684 jQuery Mobile \667A\6167\578B\624B\6A5F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108904288857313290)
,p_name=>'UI_TYPE.PHONEGAP_JQM_TABLET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PhoneGap \7684 jQuery Mobile \5E73\677F\96FB\8166')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109062001134313417)
,p_name=>'UNABLE_TO_DETERMINE_MS_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\6C7A\5B9A\91CC\7A0B\7891\65E5\671F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109433240783313700)
,p_name=>'UNASSIGNED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6307\5B9A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109456236536313718)
,p_name=>'UNAUTHENTICATED_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\8A8D\8B49\7684\4F7F\7528\8005')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109637313709313860)
,p_name=>'UNAVAILABLE_REDIRECT_TO_URL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\4F7F\7528 (\91CD\65B0\5C0E\5411\81F3 URL)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109637214611313860)
,p_name=>'UNAVAILABLE_STATUS_SHOWN_WITH_PLSQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\4F7F\7528 (\96A8 PL/SQL \986F\793A\7684\72C0\614B)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109371784593313653)
,p_name=>'UNDER_CONSIDERATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8003\91CF\4E2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108986792561313355)
,p_name=>'UNEXPIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\904E\671F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109498254764313749)
,p_name=>'UNLOCK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89E3\9664\9396\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109586275557313819)
,p_name=>'UNLOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89E3\9664\9396\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108950819418313327)
,p_name=>'UNLOCKED_APPLICATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89E3\9664\9396\5B9A\7684\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108947829548313324)
,p_name=>'UNLOCK_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89E3\9664\9396\5B9A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109207703764313526)
,p_name=>'UNRESTRICTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\9650\5236')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109162519699313492)
,p_name=>'UP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5411\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109115604900313457)
,p_name=>'UPDATEABLE_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\66F4\65B0\7684\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109695764190313918)
,p_name=>'UPDATED_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109145885004313480)
,p_name=>'UPDATED_ON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109548329008313787)
,p_name=>'UPDATE_APP_DISP_VERSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\81F3\61C9\7528\7A0B\5F0F\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109548432362313787)
,p_name=>'UPDATE_VERSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\81F3\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110047813315314177)
,p_name=>'UPGRADE_APP.UNSUPPORTED_DATE_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\662F\652F\63F4\7684\65E5\671F\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109718606478313936)
,p_name=>'UPGRADE_APPLICATION.INVALID_DATE_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\652F\63F4\8CC7\6599\683C\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110098961827314215)
,p_name=>'UPGRADE_CANDLESTICK_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5347\7D1A\4E4B\5F8C, \8ACB\78BA\5B9A\300C\6A19\7C64\8CC7\6599\6B04\300D\6578\5217\5C6C\6027\5C0D\61C9\81F3\300C\65E5\671F/\6642\6233\300D\8CC7\6599\6B04.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109115784393313457)
,p_name=>'URL'
,p_message_language=>'zh-tw'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109352216930313639)
,p_name=>'URL LINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('URL \9023\7D50')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109375805596313657)
,p_name=>'USERID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005 ID')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109392192519313669)
,p_name=>'USERS_AND_MOST_RECENT_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4F4D\4F7F\7528\8005, \6700\65B0\5EFA\7ACB\7684\4F7F\7528\8005 %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109497041826313748)
,p_name=>'USER_INTERFACE.NO_GLOBAL_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5B9A\7FA9\5168\57DF\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109386528465313665)
,p_name=>'USER_INTERFACE_ASSIGNEE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762\6307\5B9A\5C0D\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109386071837313664)
,p_name=>'USER_INTERFACE_IMPACT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762\5F71\97FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109387548049313666)
,p_name=>'USER_INTERFACE_STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\4ECB\9762\72C0\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109005443672313375)
,p_name=>'USER_TYPE_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\6B64\9801\9762\4F86\63A7\5236 Application Express \5DE5\4F5C\5340\7BA1\7406\54E1\3001\61C9\7528\7A0B\5F0F\958B\767C\4EBA\54E1\548C\4E00\822C\4F7F\7528\8005\7684\5B58\53D6\6B0A.</p>'),
'',
unistr('<p><strong>\5DE5\4F5C\5340\7BA1\7406\54E1</strong>\53EF\4EE5\5EFA\7ACB\53CA\4FEE\6539\61C9\7528\7A0B\5F0F\548C\8CC7\6599\5EAB\7269\4EF6, \4EE5\53CA\7BA1\7406\4F7F\7528\8005\5E33\6236\3001\7FA4\7D44\548C\958B\767C\670D\52D9.</p>'),
'',
unistr('<p><strong>\958B\767C\4EBA\54E1</strong>\53EF\4EE5\5EFA\7ACB\53CA\4FEE\6539\61C9\7528\7A0B\5F0F\548C\8CC7\6599\5EAB\7269\4EF6.</p>'),
'',
unistr('<p><strong>\4E00\822C\4F7F\7528\8005</strong>\6C92\6709\958B\767C\6B0A\9650, \53EA\80FD\5B58\53D6\672A\4F7F\7528\5916\90E8\8A8D\8B49\914D\7F6E\7684\61C9\7528\7A0B\5F0F.</p>'),
'',
unistr('<p><a target="_blank" href="%0/aeadm/managing-users-in-a-workspace.html">\77AD\89E3\5176\4ED6\8CC7\8A0A ...</a></p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109029622923313393)
,p_name=>'USER_TYPE_DESCRIPTION_CLOUD'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\6B64\9801\9762\63A7\5236 Application Express \4E00\822C\4F7F\7528\8005\7684\5B58\53D6\6B0A.</p>'),
'',
unistr('<p><strong>\4E00\822C\4F7F\7528\8005</strong>\4E0D\5177\6709\958B\767C\6B0A\9650, \56E0\6B64\53EA\80FD\5B58\53D6\672A\4F7F\7528\5916\90E8\8A8D\8B49\914D\7F6E\7684\61C9\7528\7A0B\5F0F.</p>'),
'',
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\8B58\5225\4E3B\63A7\53F0\4F86\7BA1\7406<strong>\5DE5\4F5C\5340\7BA1\7406\54E1</strong>\548C<strong>\958B\767C\4EBA\54E1</strong>. \53EA\8981\5DE5\4F5C\5340\7BA1\7406\54E1\6216\958B\767C\4EBA\54E1\767B\5165 Application Express, \7CFB\7D71\5C31\6703\5EFA\7ACB\300C\5F71\5B50\300D\5E33\6236. \60A8\53EF\4EE5\8996\9700\8981\79FB\9664\9019\4E9B\300C\5F71\5B50\300D\4F7F\7528\8005.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109117129037313458)
,p_name=>'USE_BUILTIN_LOGIN_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\5167\5EFA\7684\767B\5165\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109116987256313458)
,p_name=>'USE_PAGE_AS_LOGIN_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\9801\9762 %0 \70BA\767B\5165\9801\9762.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109479932561313736)
,p_name=>'USING_CLEAR_CACHE_AND_PAGE_LINKS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\60A8\53EF\4EE5\4F7F\7528<strong>\6E05\9664\5FEB\53D6</strong>\5C6C\6027\79FB\9664\4F7F\7528\9017\865F\5340\9694\4E4B\9801\9762\6E05\55AE\7684\968E\6BB5\4F5C\696D\72C0\614B.  \4E5F\53EF\4EE5\4F7F\7528\4E0B\5217\6E05\9664\5FEB\53D6\8A9E\6CD5:'),
'<ul>',
unistr('<li>RIR - \91CD\8A2D\4E92\52D5\5F0F\5831\8868</li>'),
unistr('<li>CIR - \6E05\9664\4E92\52D5\5F0F\5831\8868</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109502941067313753)
,p_name=>'USING_EXISTING_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\73FE\6709\7684\7DB1\8981')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110124666647314252)
,p_name=>'UTR.BUTTONS.CLOSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110124995134314252)
,p_name=>'UTR.BUTTONS.CODE_EDITOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A0B\5F0F\78BC\7DE8\8F2F\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110124857707314252)
,p_name=>'UTR.BUTTONS.MAXIMIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5927\5316')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110124768134314252)
,p_name=>'UTR.BUTTONS.MINIMIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5C0F\5316')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110126061360314253)
,p_name=>'UTR.CHANGE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4\300C\4E3B\984C\6A23\5F0F\300D\5C07\6703\91CD\8A2D\672A\5132\5B58\7684\8B8A\66F4. \6B64\4F5C\696D\7121\6CD5\9084\539F. \8981\7E7C\7E8C\55CE?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110153303212314274)
,p_name=>'UTR.CHANGE_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4\4E3B\984C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110124551057314252)
,p_name=>'UTR.COMMON.BASE_STYLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110124304147314252)
,p_name=>'UTR.COMMON.CANCEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110123737677314251)
,p_name=>'UTR.COMMON.CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78BA\8A8D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110153017864314274)
,p_name=>'UTR.COMMON.COPY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110124113626314252)
,p_name=>'UTR.COMMON.NO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5426')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110124237572314252)
,p_name=>'UTR.COMMON.OK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78BA\5B9A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110152953417314274)
,p_name=>'UTR.COMMON.SET_CURRENT_WHEN_READ_ONLY_PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr(' \60A8\5DF2\7D93\8B8A\66F4\552F\8B80\4E3B\984C. \82E5\4F7F\7528\5176\4F5C\70BA\76EE\524D\7684\4E3B\984C, \5C07\6703\6E05\9664\60A8\7684\8B8A\66F4. \78BA\5B9A\8981\7E7C\7E8C\9032\884C\55CE?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110124417668314252)
,p_name=>'UTR.COMMON.STYLE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\5F0F\540D\7A31')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110123803357314251)
,p_name=>'UTR.COMMON.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110153114810314274)
,p_name=>'UTR.COMMON.WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110124030914314252)
,p_name=>'UTR.COMMON.YES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110149693304314271)
,p_name=>'UTR.CONFIG_OUTPUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4E0B\5217\7A0B\5F0F\78BC\8CBC\5230 JS \4E3B\63A7\53F0, \5C07\76EE\524D\7684\7D44\614B\8F09\5165\300C\4E3B\984C\6372\52D5\5668\300D:')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110149749583314271)
,p_name=>'UTR.CONFIG_OUTPUT_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\4E3B\984C\6372\52D5\5668\300D\5FC5\9808\958B\555F, \4E14\76EE\524D\7684\6A23\5F0F\5FC5\9808\6709\6548, \624D\80FD\8F38\51FA\7D44\614B.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110037771306314170)
,p_name=>'UTR.CONTRAST_DIALOG.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\6BD4\5EA6:')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110131183950314257)
,p_name=>'UTR.CONTRAST_VALIDATION.FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5931\6557')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110133532643314259)
,p_name=>'UTR.CONTRAST_VALIDATION.LARGE_TEXT_NOTICE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\65BC 18pt \4EE5\4E0A\7684\6587\5B57\6216 14pt \4EE5\4E0A\7684\7C97\9AD4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110131286124314257)
,p_name=>'UTR.CONTRAST_VALIDATION.MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6839\64DA\300C\8272\5F69\5C0D\6BD4\300D\4E2D\7684\300CWeb \5167\5BB9\8F14\52A9\529F\80FD\6E96\5247 (WCAG) 2.0\300D, \5C0D\6B63\5E38\5927\5C0F\5B57\578B\57F7\884C\9A57\8B49')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110131091241314257)
,p_name=>'UTR.CONTRAST_VALIDATION.PASSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\901A\904E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110130942763314257)
,p_name=>'UTR.CONTRAST_VALIDATION.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69\5C0D\6BD4\8CC7\8A0A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110152849073314274)
,p_name=>'UTR.CURRENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110125871455314253)
,p_name=>'UTR.CUSTOM_CSS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02 CSS')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110125996432314253)
,p_name=>'UTR.CUSTOM_CSS.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\7A0B\5F0F\78BC\5C07\6703\5305\62EC\5728\6A23\5F0F\8868\7684\7D50\5C3E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110134741108314260)
,p_name=>'UTR.CUSTOM_CSS.WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64 CSS \7A0B\5F0F\78BC\6703\96B1\85CF\300C\4E3B\984C\6372\52D5\5668\300D\5C0D\8A71\65B9\584A. \5B83\4E0D\6703\88AB\5957\7528\81F3\9801\9762.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109715592209313934)
,p_name=>'UTR.DOWNLOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109715804966313934)
,p_name=>'UTR.DRAG_AND_DROP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62D6\653E\6A94\6848\6216\6309\4E00\4E0B\4EE5\9032\884C\9078\53D6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109716098849313934)
,p_name=>'UTR.ENABLE_LESS_COMPILATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528 LESS \7DE8\8B6F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110123951623314251)
,p_name=>'UTR.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110126425808314253)
,p_name=>'UTR.ERROR.CREATE_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\4E3B\984C\6A23\5F0F.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110134471564314259)
,p_name=>'UTR.ERROR.INPUT_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\4E00\6216\591A\500B CSS \6A94\6848 URL \6642\767C\751F\932F\8AA4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110126234837314253)
,p_name=>'UTR.ERROR.INVALID_STYLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\4E3B\984C\6A23\5F0F\7684 LESS \7A0B\5F0F\78BC\7121\6548.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110126626008314254)
,p_name=>'UTR.ERROR.LOAD_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8F09\5165\4E3B\984C\6A23\5F0F. \8ACB\78BA\5B9A\61C9\7528\7A0B\5F0F\7522\751F\5668\8996\7A97\4ECD\7136\958B\555F, \800C\4E14\60A8\7684\968E\6BB5\4F5C\696D\6709\6548.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110153204201314274)
,p_name=>'UTR.ERROR.SET_AS_CURRENT_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\4F7F\7528\9078\53D6\7684\4E3B\984C\4F5C\70BA\61C9\7528\7A0B\5F0F\7684\76EE\524D\4E3B\984C!')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110126145087314253)
,p_name=>'UTR.ERROR.UNSUPPORTED_STYLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\4E3B\984C\6A23\5F0F\4E0D\652F\63F4\81EA\8A02\300C\4E3B\984C\6372\52D5\5668\300D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110126331646314253)
,p_name=>'UTR.ERROR.UNSUPPORTED_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\4E3B\984C\6C92\6709\4E3B\984C\6A23\5F0F. \8ACB\9078\53D6\5177\6709\4E3B\984C\6A23\5F0F\7684\4E3B\984C\4EE5\4F7F\7528\300C\4E3B\984C\6372\52D5\5668\300D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110126548619314253)
,p_name=>'UTR.ERROR.UPDATE_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\66F4\65B0\4E3B\984C\6A23\5F0F.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110026714430314162)
,p_name=>'UTR.FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110133631616314259)
,p_name=>'UTR.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110133703525314259)
,p_name=>'UTR.HELP.P1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\4E3B\984C\6372\52D5\5668\300D\53EF\8B93\60A8\900F\904E\70BA\5404\7A2E\61C9\7528\7A0B\5F0F\5143\4EF6\6311\9078\8272\5F69\548C\8A2D\5B9A\6A23\5F0F, \8F15\9B06\81EA\8A02\61C9\7528\7A0B\5F0F\7684\4F7F\7528\8005\4ECB\9762. \61C9\7528\7A0B\5F0F\53EF\4EE5\5B9A\7FA9\4EFB\610F\6578\76EE\7684\4E3B\984C\6A23\5F0F, \4E0D\904E, \4E00\822C\4F7F\7528\8005\53EA\80FD\770B\5230\61C9\7528\7A0B\5F0F\300C\76EE\524D\300D\4F7F\7528\7684\4E3B\984C\6A23\5F0F.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110133847669314259)
,p_name=>'UTR.HELP.P2'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9032\884C\8B8A\66F4\5F8C, \53EF\4EE5\8F15\9B06\56DE\5FA9\5C6C\6027, \6309\4E0B\300C\91CD\8A2D\300D\6309\9215\4FBF\53EF\56DE\5FA9\6574\500B\4E3B\984C\6A23\5F0F, \6216\6309\4E0B\91CD\8A2D\5716\793A\4EE5\56DE\5FA9\7FA4\7D44\7684\4E3B\984C\6A23\5F0F. '),
'',
unistr('\5C0D\65BC\5141\8A31\9078\64C7\524D\666F\548C\80CC\666F\8272\5F69\7684\5C6C\6027, \5169\500B\8272\5F69\9078\64C7\9805\76EE\524D\9762\7684\6838\53D6\65B9\584A\4EE3\8868\6839\64DA\300CWeb \5167\5BB9\8F14\52A9\529F\80FD\6E96\5247 (WCAG) 2.0\300D\7684\8272\5F69\5C0D\6BD4\8CC7\8A0A. \8A08\7B97\5F8C\8F03\9AD8\7684\5C0D\6BD4\5206\6578\4EE3\8868\8A72\8272\5F69\7D44\5408\66F4\5BB9\6613\5B58\53D6.')))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109910674480314079)
,p_name=>'UTR.INLINE_EDITOR_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5D4C\7DE8\8F2F\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109435379867313702)
,p_name=>'UTR.LESS.ACCENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7279\9EDE\8272\5F69')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110145483385314268)
,p_name=>'UTR.LESS.ACTIONS_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\8CC7\6599\6B04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110148924588314271)
,p_name=>'UTR.LESS.ACTIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F5C\7528\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110149533558314271)
,p_name=>'UTR.LESS.ACTIVE_STATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F5C\7528\4E2D\72C0\614B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110147421971314269)
,p_name=>'UTR.LESS.BACKGROUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\80CC\666F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109435415510313702)
,p_name=>'UTR.LESS.BADGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\8A18')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110145385373314268)
,p_name=>'UTR.LESS.BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\9AD4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110145207255314268)
,p_name=>'UTR.LESS.BODY_ACCENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\6587\7279\9EDE\8272\5F69')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110149846266314271)
,p_name=>'UTR.LESS.BODY_CONTENT_MAX_WIDTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\9AD4\5167\5BB9\6700\5927\5BEC\5EA6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110146057094314268)
,p_name=>'UTR.LESS.BORDER_RADIUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6846\7DDA\534A\5F91')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110144155403314267)
,p_name=>'UTR.LESS.BUTTONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110147642979314270)
,p_name=>'UTR.LESS.COLOR_1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69 1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110148484527314270)
,p_name=>'UTR.LESS.COLOR_10'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69 10')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110116906093314246)
,p_name=>'UTR.LESS.COLOR_11'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69 11')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110117039065314246)
,p_name=>'UTR.LESS.COLOR_12'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69 12')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110117111006314246)
,p_name=>'UTR.LESS.COLOR_13'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69 13')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110117216525314246)
,p_name=>'UTR.LESS.COLOR_14'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69 14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110117389064314246)
,p_name=>'UTR.LESS.COLOR_15'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69 15')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110147774917314270)
,p_name=>'UTR.LESS.COLOR_2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69 2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110148585100314270)
,p_name=>'UTR.LESS.COLOR_3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69 3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110147874808314270)
,p_name=>'UTR.LESS.COLOR_4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69 4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110147967568314270)
,p_name=>'UTR.LESS.COLOR_5'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69 5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110148055293314270)
,p_name=>'UTR.LESS.COLOR_6'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69 6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110148143454314270)
,p_name=>'UTR.LESS.COLOR_7'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69 7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110148258242314270)
,p_name=>'UTR.LESS.COLOR_8'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69 8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110148368345314270)
,p_name=>'UTR.LESS.COLOR_9'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69 9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110144206040314267)
,p_name=>'UTR.LESS.CONTAINERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BB9\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110148661561314270)
,p_name=>'UTR.LESS.CONTAINER_BORDER_RADIUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BB9\5668\6846\7DDA\534A\5F91')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110146495075314269)
,p_name=>'UTR.LESS.DANGER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5371\96AA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110146813488314269)
,p_name=>'UTR.LESS.DISABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\505C\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110145734611314268)
,p_name=>'UTR.LESS.FOCUS_OUTLINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\9EDE\5927\7DB1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110147261837314269)
,p_name=>'UTR.LESS.FOREGROUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D\666F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110154053738314275)
,p_name=>'UTR.LESS.FORMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110143921339314267)
,p_name=>'UTR.LESS.GLOBAL_COLORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\57DF\8272\5F69')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110147574085314269)
,p_name=>'UTR.LESS.HEADER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110145109386314268)
,p_name=>'UTR.LESS.HEADER_ACCENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D\7279\9EDE\8272\5F69')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109437891417313704)
,p_name=>'UTR.LESS.HEADER_HEIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D\9AD8\5EA6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110146216558314268)
,p_name=>'UTR.LESS.HOT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\71B1\9215')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110149230318314271)
,p_name=>'UTR.LESS.HOVER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66AB\7559')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110149388823314271)
,p_name=>'UTR.LESS.HOVER_STATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66AB\7559\72C0\614B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110148844066314270)
,p_name=>'UTR.LESS.ICON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110146943415314269)
,p_name=>'UTR.LESS.INFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\8A0A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110145033009314268)
,p_name=>'UTR.LESS.INTERACTIVE_REPORTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\5831\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110154189349314275)
,p_name=>'UTR.LESS.ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110154226652314275)
,p_name=>'UTR.LESS.LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110144320558314267)
,p_name=>'UTR.LESS.LAYOUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7248\9762\914D\7F6E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110145954971314268)
,p_name=>'UTR.LESS.LEFT_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE6\5074\8CC7\6599\6B04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110145672753314268)
,p_name=>'UTR.LESS.LINK_COLOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\8272\5F69')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110147193773314269)
,p_name=>'UTR.LESS.MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110140145454314264)
,p_name=>'UTR.LESS.MENUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109481922986313737)
,p_name=>'UTR.LESS.MENU_ITEM_HOVER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD\8868\9805\76EE\66AB\7559\72C0\614B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110144494403314267)
,p_name=>'UTR.LESS.NAVIGATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110148754355314270)
,p_name=>'UTR.LESS.NAVIGATION_TREE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\6A39\72C0\7D50\69CB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110146102154314268)
,p_name=>'UTR.LESS.NORMAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110149095536314271)
,p_name=>'UTR.LESS.NOT_ACTIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975E\4F5C\7528\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110144792848314267)
,p_name=>'UTR.LESS.PALETTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\76E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110146321268314269)
,p_name=>'UTR.LESS.PRIMARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109311295293313608)
,p_name=>'UTR.LESS.PRIMARY_ACCENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\7279\9EDE\8272\5F69')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110144052977314267)
,p_name=>'UTR.LESS.REGIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110145894318314268)
,p_name=>'UTR.LESS.REGION_HEADER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110129015177314255)
,p_name=>'UTR.LESS.REPORTS_GRIDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\548C\65B9\683C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110046253303314176)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_BACKGROUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\9AD4\80CC\666F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110046191366314176)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_HEADER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\9AD4\6A19\982D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110046980876314176)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\6A21\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110047187348314177)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.COMPACT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7CBE\7C21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110047069145314176)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.STANDARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\6E96 (\9810\8A2D)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110030669750314165)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7248\9762\914D\7F6E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110034281592314167)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.CONTAINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\542B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110034004612314167)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.EDGE_TO_EDGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\7248\9762 (\9810\8A2D)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110034115496314167)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.FLOATING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D6E\52D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110030555720314165)
,p_name=>'UTR.LESS.RW.CLASSES.MODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A21\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110033806898314167)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DF1\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110033974685314167)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DF1\8272\4E3B\9AD4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110047382098314177)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DF1\8272 (\9810\8A2D)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110033790784314167)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\660E\4EAE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110047420915314177)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT_DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DFA\8272 (\9810\8A2D)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110030408963314165)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7522\54C1\7D44')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110045954996314176)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.BEIGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C73\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110045567079314175)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.LILAC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6DE1\7D2B\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110044975648314175)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.NEUTRAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\666E\901A (\9810\8A2D)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110045414379314175)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.OCEAN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6D77\6D0B\85CD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110045031372314175)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PEBBLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9D5D\5375\77F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110045285584314175)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\677E\7DA0\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110045894427314176)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PLUM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6885\7D05\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110045678040314176)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.ROSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\73AB\7470\7C89')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110045749311314176)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SIENNA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9EC3\8910\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110045158106314175)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5CA9\7070\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110045361180314175)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.TEAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\85CD\7DA0\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110046016356314176)
,p_name=>'UTR.LESS.RW.GROUP.APPEARANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\89C0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110044878423314175)
,p_name=>'UTR.LESS.RW.GROUP.CLASSES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Redwood \9078\9805')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109226647657313540)
,p_name=>'UTR.LESS.SCALE_LEVEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\6578\4F4D\6578')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109311345549313608)
,p_name=>'UTR.LESS.SECONDARY_ACCENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B21\8981\7279\9EDE\8272\5F69')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110149160935314271)
,p_name=>'UTR.LESS.SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9078\53D6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110149426085314271)
,p_name=>'UTR.LESS.SELECTED_STATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7684\72C0\614B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110146720461314269)
,p_name=>'UTR.LESS.SIMPLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C21\55AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110144509098314267)
,p_name=>'UTR.LESS.STATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DDE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110146651121314269)
,p_name=>'UTR.LESS.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110147310886314269)
,p_name=>'UTR.LESS.TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110145591368314268)
,p_name=>'UTR.LESS.TITLE_BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110146550663314269)
,p_name=>'UTR.LESS.WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110026848482314162)
,p_name=>'UTR.LOADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5728\8F09\5165...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109029217386313393)
,p_name=>'UTR.LOGO.ALT_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66FF\4EE3\6587\5B57')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109678963571313897)
,p_name=>'UTR.LOGO.CUSTOM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109678810278313897)
,p_name=>'UTR.LOGO.CUSTOM.MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\53EF\4EE5\5728\61C9\7528\7A0B\5F0F\7522\751F\5668\4E2D\7DE8\8F2F\6A19\8A8C\6A19\8A18')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109716550554313934)
,p_name=>'UTR.LOGO.ERROR_LOAD_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8F09\5165\6A19\8A8C\8CC7\6599. \8ACB\78BA\5B9A\61C9\7528\7A0B\5F0F\7522\751F\5668\8996\7A97\4ECD\7136\958B\555F, \800C\4E14\60A8\7684\968E\6BB5\4F5C\696D\6709\6548.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109678770813313897)
,p_name=>'UTR.LOGO.IMAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109718726389313936)
,p_name=>'UTR.LOGO.IMAGE_DEFAULT_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\8F09\5165\5F71\50CF.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109678617769313897)
,p_name=>'UTR.LOGO.IMAGE_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF\548C\6587\5B57')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109716130838313934)
,p_name=>'UTR.LOGO.MAX_FILESIZE_IN_KB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\9078\53D6\4E00\500B\5C0F\65BC %0KB \7684\6A94\6848')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109678535243313896)
,p_name=>'UTR.LOGO.NONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109716242172313934)
,p_name=>'UTR.LOGO.ONLY_IMAGE_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\5141\8A31\5F71\50CF\6A94')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109715439767313934)
,p_name=>'UTR.LOGO.SAVE_LOGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\6A19\8A8C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109716384655313934)
,p_name=>'UTR.LOGO.SET_LOGO_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5132\5B58\6A19\8A8C.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109716453720313934)
,p_name=>'UTR.LOGO.SET_LOGO_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\8A8C\5DF2\9806\5229\5132\5B58.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109678472018313896)
,p_name=>'UTR.LOGO.TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109678214128313896)
,p_name=>'UTR.LOGO.TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109678123386313896)
,p_name=>'UTR.LOGO.UPLOAD_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62D6\653E\6A94\6848\6216\6309\4E00\4E0B\4EE5\9032\884C\9078\53D6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109908905814314078)
,p_name=>'UTR.LOGO_EDITOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\6A19\8A8C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109715903368313934)
,p_name=>'UTR.ONLY_JSON_ALLOWED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\5141\8A31 JSON \6A94\6848')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110141721913314265)
,p_name=>'UTR.PALETTE_GENERATOR.ADJACENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\9130\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110141567813314265)
,p_name=>'UTR.PALETTE_GENERATOR.BASE_RGB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57FA\672C RGB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110153806755314275)
,p_name=>'UTR.PALETTE_GENERATOR.DUAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96D9\91CD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110141621727314265)
,p_name=>'UTR.PALETTE_GENERATOR.MONOCHROMATIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\55AE\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110142149131314265)
,p_name=>'UTR.PALETTE_GENERATOR.SEPARATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110141936411314265)
,p_name=>'UTR.PALETTE_GENERATOR.TETRAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56DB\5206\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110141831687314265)
,p_name=>'UTR.PALETTE_GENERATOR.TRIAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E09\5206\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110142095746314265)
,p_name=>'UTR.PALETTE_GENERATOR.WITH_COMPLEMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\542B\4E92\88DC\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109437245862313703)
,p_name=>'UTR.PENDING_LOGO_CHANGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5C1A\672A\5132\5B58\6A19\8A8C\8B8A\66F4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109437311843313703)
,p_name=>'UTR.PENDING_THEME_CHANGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5C1A\672A\5132\5B58\4E3B\984C\8B8A\66F4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110144985258314267)
,p_name=>'UTR.REDO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\505A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110125626409314253)
,p_name=>'UTR.RESET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110125712760314253)
,p_name=>'UTR.RESET.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78BA\5B9A\8981\91CD\8A2D CSS \55CE? \5C07\6703\907A\5931\6240\6709\8B8A\66F4. \6B64\4F5C\696D\7121\6CD5\9084\539F.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110153418623314274)
,p_name=>'UTR.RESET.STYLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D\6A23\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110125331238314253)
,p_name=>'UTR.SAVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110125478336314253)
,p_name=>'UTR.SAVE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\540D\7A31, \5C07\76EE\524D\7684\4E3B\984C\6A23\5F0F\91CD\65B0\547D\540D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110125555145314253)
,p_name=>'UTR.SAVE.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\66F4\65B0\4E3B\984C\6A23\5F0F!')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110125049853314252)
,p_name=>'UTR.SAVE_AS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53E6\5B58\65B0\6A94')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110125143380314252)
,p_name=>'UTR.SAVE_AS.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\65B0\4E3B\984C\6A23\5F0F\7684\540D\7A31.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110125201688314253)
,p_name=>'UTR.SAVE_AS.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\4E3B\984C\6A23\5F0F!')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110141458035314265)
,p_name=>'UTR.SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109909073267314078)
,p_name=>'UTR.SELECT_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\4E3B\984C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110152787782314274)
,p_name=>'UTR.SET_AS_CURRENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\76EE\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110153554775314274)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\70BA\76EE\524D\7684\4E3B\984C\6A23\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110153610809314274)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7684\4E3B\984C\73FE\5728\662F\61C9\7528\7A0B\5F0F\7684\76EE\524D\4E3B\984C.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110153721575314274)
,p_name=>'UTR.SET_AS_CURRENT_WHEN_READ_ONLY.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5DF2\7D93\8B8A\66F4\552F\8B80\4E3B\984C. \5982\679C\60A8\5C07\6B64\4E3B\984C\8A2D\70BA\61C9\7528\7A0B\5F0F\7684\300C\76EE\524D\300D\4E3B\984C, \5C07\6703\6E05\9664\60A8\7684\8B8A\66F4. \78BA\5B9A\8981\7E7C\7E8C\9032\884C\55CE?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109678034675313896)
,p_name=>'UTR.TABS.LOGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\8A8C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109677989458313896)
,p_name=>'UTR.TABS.THEME_STYLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\6A23\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110123627430314251)
,p_name=>'UTR.THEME_ROLLER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\984C\6372\52D5\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110134351163314259)
,p_name=>'UTR.TOOLBAR.BUTTONS.ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8\986F\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110134228465314259)
,p_name=>'UTR.TOOLBAR.BUTTONS.COMMON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5171\540C\9805\76EE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110150506610314272)
,p_name=>'UTR.TOOLBAR.BUTTONS.PALETTE_GENERATOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69\8F2A\76E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110144804903314267)
,p_name=>'UTR.UNDO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9084\539F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109715628433313934)
,p_name=>'UTR.UPLOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\50B3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109715702211313934)
,p_name=>'UTR.UPLOAD_CONFIG_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\50B3\7D44\614B\6A94')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109125588744313464)
,p_name=>'V.ALIAS_CONVERSION_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1812 \8F49\63DB\61C9\7528\7A0B\5F0F\5225\540D (%0) \6642\767C\751F\672A\9810\671F\7684\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110114583875314244)
,p_name=>'VALIDATION_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108906717890313292)
,p_name=>'VIEW ALL PAGE GROUPS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\6240\6709\9801\9762\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108906827477313292)
,p_name=>'VIEW ALL PAGE TYPES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\6240\6709\9801\9762\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109054354269313411)
,p_name=>'VIEWS2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109654722651313873)
,p_name=>'VIEW_DEBUG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\9664\932F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108929773260313310)
,p_name=>'VIEW_DETAILS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\8A73\7D30\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109498982447313750)
,p_name=>'VIEW_FOR_ALT_TAG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108924768824313306)
,p_name=>'VIEW_FOR_PRINTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\5370\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109683294488313902)
,p_name=>'VIEW_HISTORY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\6B77\53F2\8A18\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110073623313314195)
,p_name=>'VIEW_IN_BUILDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109112953937313455)
,p_name=>'VIEW_IN_PAREN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\6AA2\8996)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110104332668314235)
,p_name=>'VIEW_LOCK_HISTORY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\9396\5B9A\6B77\53F2\8A18\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110035116897314168)
,p_name=>'VIEW_OUTPUT_OF_XML_DEMO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64 SQL \67E5\8A62\4E3B\8981\7528\4F86\7522\751F\6309<strong>\6AA2\8996 XML</strong> \6309\9215\5F8C\986F\793A\7684 XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108907314216313293)
,p_name=>'VIEW_PAGES_OF_THIS_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\6B64\985E\578B\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109678301799313896)
,p_name=>'VIEW_PAGE_HISTORY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996 "%0" \9801\9762\8B8A\66F4\6B77\53F2\8A18\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109019513669313386)
,p_name=>'VIEW_USER_ACTIVITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\53F3\5217\9805\76EE\7684\6D3B\52D5: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109427156040313695)
,p_name=>'VPD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\865B\64EC\5C08\7528\8CC7\6599\5EAB (VPD)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109439129969313705)
,p_name=>'WAITING.APP_DEFINITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5728\5B89\88DD\61C9\7528\7A0B\5F0F...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110120363289314249)
,p_name=>'WAITING.APP_REMOVAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5728\79FB\9664\61C9\7528\7A0B\5F0F...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110120531337314249)
,p_name=>'WAITING.APP_UNLOCK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5728\89E3\9664\9396\5B9A\61C9\7528\7A0B\5F0F...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110120423671314249)
,p_name=>'WAITING.APP_UPDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5728\66F4\65B0\61C9\7528\7A0B\5F0F...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109439238472313705)
,p_name=>'WAITING.GENERIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109439304069313705)
,p_name=>'WAITING.SUPPORTING_OBJECTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\88DD\652F\63F4\7684\7269\4EF6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109548751731313787)
,p_name=>'WARNING_MISSING_CLASS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\76F8\7B26\985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109548647638313787)
,p_name=>'WARNING_MULTIPLE_MATCHES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\591A\500B\76F8\7B26\9805\76EE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108894021059313282)
,p_name=>'WEB.SOURCE.ADD_FROM_CATALOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\670D\52D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108895009759313283)
,p_name=>'WEB.SOURCE.SERVICE_FROM_CATALOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5F9E\76EE\9304\65B0\589E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108894859981313283)
,p_name=>'WEB.SOURCE.UNADD_FROM_CATALOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664\670D\52D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109360763806313645)
,p_name=>'WEBSHEET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \8A66\7B97\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109391312762313668)
,p_name=>'WEBSHEET ATTACHMENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \8A66\7B97\8868\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110100781599314232)
,p_name=>'WEBSHEET.ANYCO.SAMPLE.APP'
,p_message_language=>'zh-tw'
,p_message_text=>'AnyCo IT Department'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110100611845314232)
,p_name=>'WEBSHEET.ANYCO.SAMPLE.APP.DESCR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('AnyCo IT Department \5F37\8ABF\5982\4F55\5728\5171\7528\53CA\5831\544A\91CD\8981\5546\696D\8CC7\6599\7684 Web \5F0F\5167\5BB9\4F7F\7528\300CWeb \8A66\7B97\8868\300D\7684\529F\80FD\8207\529F\7528. \6B64\7BC4\4F8B Web \8A66\7B97\8868\61C9\7528\7A0B\5F0F\5305\542B\6578\500B\8CC7\6599\65B9\683C, \4E26\793A\7BC4\5982\4F55\5728\5167\5D4C\7684\5831\8868\548C\5716\8868\4E2D\542B\62EC\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110046418273314176)
,p_name=>'WEBSHEET.DEMO.SAMPLE.APP'
,p_message_language=>'zh-tw'
,p_message_text=>'Big Cats'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110046714163314176)
,p_name=>'WEBSHEET.DEMO.SAMPLE.APP.DESCR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Big Cats \5F37\8ABF\300CWeb \8A66\7B97\8868\300D\7684\8A31\591A\529F\80FD\8207\529F\7528, \5305\62EC\5167\5D4C\5F71\50CF\548C\9801\9762\9023\7D50.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108960853342313335)
,p_name=>'WEBSHEETS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \8A66\7B97\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109737241699313951)
,p_name=>'WEBSHEETS_FAQ_A1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300CWeb \8A66\7B97\8868\300D\61C9\7528\7A0B\5F0F\7531\7D50\5408\6587\5B57\8207\8CC7\6599\7684\7DB2\9801\7D44\6210.  \9019\4E9B\61C9\7528\7A0B\5F0F\90FD\662F\975E\5E38\52D5\614B\7684\61C9\7528\7A0B\5F0F, \4E14\7531\5176\4F7F\7528\8005\52A0\4EE5\5B9A\7FA9. \61C9\7528\7A0B\5F0F\5305\62EC\5C0E\89BD\63A7\5236\9805\3001\641C\5C0B\529F\80FD\4EE5\53CA\65B0\589E\8A3B\89E3 (\4F8B\5982\6A94\6848\3001\9644\8A3B\548C\6A19\8A18) \7684\80FD\529B. \60A8\53EF\4EE5\4F7F\7528\5B58\53D6\63A7\5236\6E05\55AE\548C\6578\7A2E\5167\5EFA\7684\8A8D\8B49\6A21\578B\4FDD\8B77\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109737378197313951)
,p_name=>'WEBSHEETS_FAQ_A2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \8A66\7B97\8868\61C9\7528\7A0B\5F0F\8B93\63D0\4F9B\8005\53EA\9700\4F7F\7528 Web \700F\89BD\5668, \5373\53EF\5FEB\901F\5EFA\7ACB\8CC7\8A0A\9801\9762, \5305\62EC\5831\8868\548C\5716\8868. \4F7F\7528\8005\53EF\4EE5\8F15\6613\5730\7DAD\8B77\6587\5B57\548C\672C\6A5F\8CC7\6599 (\7A31\70BA\8CC7\6599\65B9\683C), \4EE5\53CA\6AA2\8996 SQL \67E5\8A62\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109737438636313951)
,p_name=>'WEBSHEETS_FAQ_A3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \8A66\7B97\8868\61C9\7528\7A0B\5F0F\7684\529F\80FD\8207 WIKI \985E\4F3C, \4F46\4E3B\8981\662F\70BA\4E86\8B93\8CC7\6599\6574\5408\548C\986F\793A\6700\4F73\5316. \4F8B\5982, \60A8\53EF\4EE5\5B9A\7FA9\7528\4EE5\5132\5B58\5217\8868\5316\8CC7\8A0A\7684\8CC7\6599\65B9\683C\3001\91DD\5C0D\73FE\6709\8868\683C\5B9A\7FA9\4E00\4EFD\5831\8868, \6216\8005\4F7F\7528 SQL \6A19\8A18\5728\9801\9762\4E2D\986F\793A\8CC7\6599\5EAB\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109737555682313951)
,p_name=>'WEBSHEETS_FAQ_A4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\65B9\683C\662F\985E\4F3C\65BC\8A66\7B97\8868\7684\300CWeb \8A66\7B97\8868\300D\5143\4EF6, \53EF\4F9B\60A8\8F15\9B06\5730\7DAD\8B77\5217\8868\5316\8CC7\8A0A. \7136\800C, \6700\5927\7684\4E0D\540C\662F, \6240\6709\300CWeb \8A66\7B97\8868\300D\8CC7\6599\5747\96C6\4E2D\5132\5B58\65BC Oracle Database \5167, \800C\4E0D\662F\5132\5B58\65BC\672C\6A5F\6A94\6848\4E2D. \4F7F\7528\8CC7\6599\65B9\683C\6642, \60A8\53EF\4EE5\65B0\589E\8A3B\89E3 (\5305\62EC\6A94\6848\3001\9644\8A3B\3001\6A19\8A18\4EE5\53CA\9023\7D50) \5230\8CC7\6599\7684\6BCF\500B\8CC7\6599\5217. \9644\52A0\7684\6548\76CA\662F, \6240\6709\8CC7\6599\5747\53EF\4F7F\7528\61C9\7528\7A0B\5F0F\641C\5C0B\4F86\52A0\4EE5\641C\5C0B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109737986720313951)
,p_name=>'WEBSHEETS_FAQ_A5'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4F7F\7528\8005\53EF\4EE5\5229\7528 SQL \6A19\8A18, \5C07\5831\8868\5167\5D4C\5230\9801\9762\4E2D (\6839\64DA\91DD\5C0D\8CC7\6599\5EAB\8868\683C\64B0\5BEB\7684 SQL \6558\8FF0\53E5). \4F7F\7528\8005\53EF\4EE5\4F7F\7528 SQL, \76F4\63A5\5F9E\559C\611B\7684\8868\683C\64F7\53D6\8CC7\6599. \4F8B\5982, \82E5\8981\67E5\770B\5DF2\903E\671F\7684\6240\6709\5F85\8655\7406\932F\8AA4, \8ACB\4F7F\7528\4E0B\5217\6A19\8A18: '),
'<pre>[[SQL: select * from bugs where due_date < sysdate and status = ''OPEN'']] </pre>',
unistr('\7CFB\7D71\6703\5728\6BCF\6B21\6AA2\8996\9801\9762\6642\57F7\884C\6B64\67E5\8A62, \4EE5\63D0\4F9B\52D5\614B\8CC7\6599\800C\975E\4E00\822C\7684\5373\6642\5FEB\7167.  ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109737628511313951)
,p_name=>'WEBSHEETS_FAQ_A6'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Web \8A66\7B97\8868\61C9\7528\7A0B\5F0F\6709\52A9\65BC\5171\7528\5167\5BB9\53CA\63D0\4F9B\975E\6B63\5F0F\7684\57FA\672C\5831\8868.  Web \8A66\7B97\8868\61C9\7528\7A0B\5F0F\7684\6240\6709\7D50\69CB\8207\5167\5BB9\5747\7531\4F7F\7528\8005 (\4EA6\5373\63D0\4F9B\8005\548C\7BA1\7406\54E1) \6240\63A7\5236. \53CD\4E4B, \8CC7\6599\5EAB\61C9\7528\7A0B\5F0F\7684\7528\9014\5247\662F\8F03\6B63\5F0F\3001\8907\96DC\4E14\5C08\9580\7684\8CC7\6599\7DAD\8B77\548C\5831\8868\529F\80FD. \8CC7\6599\5EAB\61C9\7528\7A0B\5F0F\7684\7D50\69CB\7531\958B\767C\4EBA\54E1\63A7\5236, \4F46\5167\5BB9\901A\5E38\5247\7531\4E00\822C\4F7F\7528\8005\63A7\5236.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109736786289313950)
,p_name=>'WEBSHEETS_FAQ_Q1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F55\8B02 Web \8A66\7B97\8868?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109736903591313951)
,p_name=>'WEBSHEETS_FAQ_Q2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\70BA\4F55\8981\5EFA\7ACB\300CWeb \8A66\7B97\8868\300D\61C9\7528\7A0B\5F0F?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109737002817313951)
,p_name=>'WEBSHEETS_FAQ_Q3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300CWeb \8A66\7B97\8868\300D\61C9\7528\7A0B\5F0F\8207 WIKI \6709\4F55\4E0D\540C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109737145941313951)
,p_name=>'WEBSHEETS_FAQ_Q4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300CWeb \8A66\7B97\8868\300D\61C9\7528\7A0B\5F0F\662F\7DDA\4E0A\8A66\7B97\8868\55CE?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109738013848313951)
,p_name=>'WEBSHEETS_FAQ_Q5'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F55\8B02 SQL \6A19\8A18?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109736870465313950)
,p_name=>'WEBSHEETS_FAQ_Q6'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300CWeb \8A66\7B97\8868\300D\61C9\7528\7A0B\5F0F\8207\8CC7\6599\5EAB\61C9\7528\7A0B\5F0F\6709\4F55\4E0D\540C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109019689317313386)
,p_name=>'WEBSHEETS_NOT_INSTALLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5B89\88DD\5143\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110122491675314250)
,p_name=>'WEBSHEET_ACCESS_CONTROL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \8A66\7B97\8868\5B58\53D6\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110101452132314232)
,p_name=>'WEBSHEET_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \8A66\7B97\8868\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108945489584313322)
,p_name=>'WEBSHEET_APPLICATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \8A66\7B97\8868\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109688820352313908)
,p_name=>'WEBSHEET_APPLICATION_NOT_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F %0 \76EE\524D\7121\6CD5\4F7F\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109392494522313669)
,p_name=>'WEBSHEET_ATTACHMENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \8A66\7B97\8868\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109683395896313902)
,p_name=>'WEBSHEET_CONTENT_LAST_UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5BB9\4E0A\6B21\7531 %1 \65BC %0 \66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109683427572313902)
,p_name=>'WEBSHEET_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\7531 %1 \65BC %0 \5EFA\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110046804812314176)
,p_name=>'WEBSHEET_INSTALLATION_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5373\5C07\5B89\88DD\7BC4\4F8B\300CWeb \8A66\7B97\8868\300D\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110115380662314245)
,p_name=>'WEBSHEET_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \8A66\7B97\8868: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109675718719313894)
,p_name=>'WEBSHEET_LAST_UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\4E0A\6B21\7531 %1 \66F4\65B0\65BC %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109391226633313668)
,p_name=>'WEBSHEET_NON_BLOB_DATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \8A66\7B97\8868\975E BLOB \8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110086432728314204)
,p_name=>'WEBSHEET_OBJECTS_NOT_VALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \8A66\7B97\8868\7269\4EF6\7121\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109436080979313702)
,p_name=>'WEBSHEET_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5B89\88DD Web \8A66\7B97\8868\61C9\7528\7A0B\5F0F %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109700372035313922)
,p_name=>'WEBSHEET_TABLE_ACCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\5217\7269\4EF6\53EF\4F7F\7528 SQL \6A19\8A18\67E5\8A62\6216\7528\65BC\300C\5831\8868\300D\4E2D.  \82E5\7269\4EF6\540D\7A31\6709\5927\5C0F\5BEB\4E4B\5206, \53EF\4F7F\7528\96D9\5F15\865F\6307\5B9A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109389788715313667)
,p_name=>'WEBSHEET_VIEWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \8A66\7B97\8868\9801\9762\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109420694931313690)
,p_name=>'WEB_SERVICE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \670D\52D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109115125238313457)
,p_name=>'WEB_SERVICE_RESULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300CWeb \670D\52D9\300D\7D50\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108880545682313272)
,p_name=>'WEB_SOURCE.NATIVE_ADFBC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle Cloud Applications (SaaS) REST \670D\52D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108880338627313272)
,p_name=>'WEB_SOURCE.NATIVE_HTTP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C21\55AE HTTP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108880634512313272)
,p_name=>'WEB_SOURCE.NATIVE_OCI'
,p_message_language=>'zh-tw'
,p_message_text=>'Oracle Cloud Infrastructure (OCI)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108880435405313272)
,p_name=>'WEB_SOURCE.NATIVE_ORDS'
,p_message_language=>'zh-tw'
,p_message_text=>'Oracle REST Data Services'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108940669799313319)
,p_name=>'WELCOME_TEXT_4700_P1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\5B8C\6210\6B64\8A3B\518A\7CBE\9748, \4EE5\8981\6C42 Oracle APEX \5DE5\4F5C\5340.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109432192403313699)
,p_name=>'WHITE_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767D\8272\6587\5B57')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108973298718313345)
,p_name=>'WITHIN_NEXT_1_DAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63A5\4E0B\4F86 1 \5929\5167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110040134424314172)
,p_name=>'WITHIN_NEXT_X_DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63A5\4E0B\4F86 %0 \5929\5167')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109392258207313669)
,p_name=>'WITH_ADMIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\542B\7BA1\7406\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109115562607313457)
,p_name=>'WITH_SHORTCUTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5177\6709\6377\5F91')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109497934354313749)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\78BC\5DF2\5728\6B64\61C9\7528\7A0B\5F0F\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109497396640313748)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.RESERVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\78BC\5DF2\4FDD\7559.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109148649844313482)
,p_name=>'WIZAPI_DELETE_CHECKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\52FE\9078\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109025688899313390)
,p_name=>'WIZARD.BUILD_OPTION.COMMENTED_OUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8A2D\70BA\8A3B\89E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108883165984313274)
,p_name=>'WIZARD.CLEAR_CACHE_PROCESS_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D\9801\9762')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109920995914314087)
,p_name=>'WIZARD.CREATE.FS.CARD_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5361\7247\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108896560463313284)
,p_name=>'WIZARD.CREATE.PAGE.CARDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5361\7247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109724083225313940)
,p_name=>'WIZARD.CREATE.PAGE.CLASSIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\4E00\822C\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109689212408313909)
,p_name=>'WIZARD.CREATE.PAGE.FACETED_SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\591A\9762\5411\641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109724515699313941)
,p_name=>'WIZARD.CREATE.PAGE.FORMNLISTVIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\8868\55AE\8207\6E05\55AE\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109724934033313941)
,p_name=>'WIZARD.CREATE.PAGE.FORMONPROCEDURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\7A0B\5E8F\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109724874478313941)
,p_name=>'WIZARD.CREATE.PAGE.FORMONSQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB SQL \67E5\8A62\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109724739815313941)
,p_name=>'WIZARD.CREATE.PAGE.FORMONTABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110099065636314215)
,p_name=>'WIZARD.CREATE.PAGE.FORMONWEBSERVICE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB Web \670D\52D9\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108903469952313290)
,p_name=>'WIZARD.CREATE.PAGE.FS.FACET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9762\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109723930743313940)
,p_name=>'WIZARD.CREATE.PAGE.GRID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\4E92\52D5\5F0F\65B9\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109723888950313940)
,p_name=>'WIZARD.CREATE.PAGE.INTERACTIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\4E92\52D5\5F0F\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108894700123313283)
,p_name=>'WIZARD.CREATE.PAGE.MAP_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5730\5716\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109724183921313940)
,p_name=>'WIZARD.CREATE.PAGE.MD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\4E3B\8981\660E\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109724305271313940)
,p_name=>'WIZARD.CREATE.PAGE.REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109724454960313941)
,p_name=>'WIZARD.CREATE.PAGE.REPORTWFORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5167\542B\8868\55AE\7684\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108902374539313289)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\667A\6167\578B\7BE9\9078\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108903563794313290)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS.FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109724685220313941)
,p_name=>'WIZARD.CREATE.PAGE.TABULARFORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5217\8868\5316\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109724272911313940)
,p_name=>'WIZARD.CREATE.PAGE.WEBSERVICE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB Web \670D\52D9\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109068610926313422)
,p_name=>'WIZARD.CREATE_PAGE.UT.REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\7CBE\9748\9700\8981\4EE5\300C\901A\7528\4E3B\984C\300D\70BA\57FA\790E\7684\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108882698483313274)
,p_name=>'WIZARD.FORM.DML_PROCESS_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\8868\55AE %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108882524164313274)
,p_name=>'WIZARD.FORM.INIT_PROCESS_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D77\59CB\8868\55AE %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109479470399313735)
,p_name=>'WIZARD.FORM.QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109479316470313735)
,p_name=>'WIZARD.FORM.TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109493107940313745)
,p_name=>'WIZARD.IG.DML_PROCESS_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 - \5132\5B58\4E92\52D5\5F0F\65B9\683C\8CC7\6599')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109485968826313740)
,p_name=>'WIZARD.REPORT.CLASSIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109485816896313740)
,p_name=>'WIZARD.REPORT.GRID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\65B9\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109485787697313740)
,p_name=>'WIZARD.REPORT.INTERACTIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109486182695313740)
,p_name=>'WIZARD.REPORT.REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109486066696313740)
,p_name=>'WIZARD.REPORT.WEBSERVICE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \670D\52D9\76F8\95DC\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109089188370313437)
,p_name=>'WIZARD.VALIDATION.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165 #LABEL# \503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109409890232313682)
,p_name=>'WIZARD.VALIDATION.PAGE_LEVEL_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767C\751F\9A57\8B49\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109409757099313682)
,p_name=>'WIZARD.VALIDATION.TABFORM_COLUMN_IS_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165 #COLUMN_HEADER# \503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109443269096313708)
,p_name=>'WIZARD_PAGES_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\7CBE\9748\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110150039180314271)
,p_name=>'WIZARD_PROGRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7CBE\9748\9032\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109428595513313696)
,p_name=>'WIZARD_REPORT_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\5EFA\7ACB\300C\7CBE\9748\5831\8868\300D\9801\9762.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109117259299313458)
,p_name=>'WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109417132059313688)
,p_name=>'WORKSPACE IMAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109479660484313735)
,p_name=>'WORKSPACES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109388578975313666)
,p_name=>'WORKSPACE_APPLICATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109388835598313667)
,p_name=>'WORKSPACE_APPLICATION_ACTIVITY_SUMMARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\61C9\7528\7A0B\5F0F\6D3B\52D5\6458\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110031363721314165)
,p_name=>'WORKSPACE_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\5DE5\4F5C\5340\8A08\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109387871926313666)
,p_name=>'WORKSPACE_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109699985589313922)
,p_name=>'WORKSPACE_IMAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\5F71\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109480118435313736)
,p_name=>'WORKSPACE_INITCAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109298535096313598)
,p_name=>'WORKSPACE_INIT_CAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108957594424313332)
,p_name=>'WORKSPACE_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108926604334313308)
,p_name=>'WORKSPACE_LOGIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\767B\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109625279370313851)
,p_name=>'WORKSPACE_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109387601917313666)
,p_name=>'WORKSPACE_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109536537506313778)
,p_name=>'WORKSPACE_OVERRIDE_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\8986\5BEB ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109420063070313690)
,p_name=>'WORKSPACE_REQUEST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109388412894313666)
,p_name=>'WORKSPACE_SCHEMAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\7DB1\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108976654303313348)
,p_name=>'WORKSPACE_SIGNUP_SUCCESS_01'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8981\6C42\6838\51C6\4E4B\5F8C, \60A8\5C07\6703\6536\5230\555F\7528\5DE5\4F5C\5340\7684\96FB\5B50\90F5\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109479838039313736)
,p_name=>'WORKSPACE_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109392378931313669)
,p_name=>'WORKSPACE_WEBSHEETS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340 Web \8A66\7B97\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109388125595313666)
,p_name=>'WORKSPACE_WORKSPACE_SUMMARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5DE5\4F5C\5340\6458\8981')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109364111391313648)
,p_name=>'WORK_INITIATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8D77\59CB\5DE5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109364207160313648)
,p_name=>'WORK_PROGRESSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\9032\884C\4E2D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109372207447313654)
,p_name=>'WRITING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\5BEB\4E2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110035516062314168)
,p_name=>'WS.CAPABILITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110035484404314168)
,p_name=>'WS.READER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95B1\8B80\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109427955311313696)
,p_name=>'WSDL_SUCCESS_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300CWeb \670D\52D9\53C3\7167\300D\5DF2\65B0\589E\81F3\61C9\7528\7A0B\5F0F %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108917078915313300)
,p_name=>'WS_ACCESS_CONTROL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109661040439313879)
,p_name=>'WS_ADD_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110099283858314215)
,p_name=>'WS_ADD_FILE_NOT_ENOUGH_SPACE_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\9593\4E0D\8DB3, \7121\6CD5\65B0\589E\6A94\6848. \8ACB\81F3\300C\7BA1\7406\300D\9801\9762, \524D\5F80\300C\7BA1\7406\670D\52D9\300D, \7136\5F8C\6309\4E00\4E0B\300C\8981\6C42\66F4\591A\5132\5B58\300D\4F86\8981\6C42\984D\5916\7684\5132\5B58.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109684410328313903)
,p_name=>'WS_ADD_LINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109719353840313937)
,p_name=>'WS_ADD_NEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109684598339313903)
,p_name=>'WS_ADD_NOTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\9644\8A3B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109683975904313903)
,p_name=>'WS_ADD_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109684310722313903)
,p_name=>'WS_ADD_TAGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\6A19\8A18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109728586277313944)
,p_name=>'WS_ADD_VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\9A57\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108916864572313300)
,p_name=>'WS_ADMINISTRATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109660626665313879)
,p_name=>'WS_ALIAS_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\5225\540D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108909307610313294)
,p_name=>'WS_ALIAS_NOT_VALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5225\540D\5FC5\9808\662F\6587\6578\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108920565663313303)
,p_name=>'WS_ALIAS_TOO_LONG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5225\540D\592A\9577. \9650\5236\70BA 255 \500B\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109725538784313942)
,p_name=>'WS_ALL_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109719487701313937)
,p_name=>'WS_ANNOTATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A3B\89E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108916980446313300)
,p_name=>'WS_APPLICATION_PROPERTIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7279\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109734078798313948)
,p_name=>'WS_CANNOT_USE_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7684\986F\793A\985E\578B\4E0D\53EF\4F7F\7528\300C\503C\6E05\55AE\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109736408815313950)
,p_name=>'WS_CHANGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8B8A\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109720881526313938)
,p_name=>'WS_CHANGE_COLUMN_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4\8CC7\6599\6B04\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109736651218313950)
,p_name=>'WS_CHG_WS_RPT_QRY_HLP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\8B8A\66F4\5831\8868\67E5\8A62. \5982\679C\60A8\65B0\589E\8CC7\6599\6B04\5230\67E5\8A62, \5C07\4E0D\6703\5728\57F7\884C\5831\8868\6642\986F\793A\9019\4E9B\8CC7\6599\6B04. \60A8\5C07\9700\8981\4F7F\7528\300C\52D5\4F5C\300D\529F\80FD\8868, \7136\5F8C\9078\53D6\8CC7\6599\6B04\6216\6309<strong>\91CD\8A2D</strong>. \5982\679C\60A8\79FB\9664\67E5\8A62\7684\8CC7\6599\6B04, \5B83\5C07\6703\505C\7528\53C3\7167\9019\4E9B\8CC7\6599\6B04\7684\73FE\6709\7BE9\9078\3001\6A19\793A\898F\5247\4EE5\53CA\5176\4ED6\5831\8868\8A2D\5B9A\503C. \8ACB\78BA\8A8D\60A8\7684\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108914466742313298)
,p_name=>'WS_CHOOSE_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109721341530313938)
,p_name=>'WS_COLUMN_ALIGNMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\5C0D\9F4A\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109684208136313903)
,p_name=>'WS_COLUMN_GROUPS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110095837225314212)
,p_name=>'WS_COLUMN_NAME_NOT_UNIQUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31\5DF2\7D93\5B58\5728. \8ACB\8F38\5165\5176\4ED6\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109684172925313903)
,p_name=>'WS_COLUMN_PROPERTIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\7279\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109722379669313939)
,p_name=>'WS_COL_CONFIRM_DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78BA\8A8D\57F7\884C\6B64\522A\9664\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109733894016313948)
,p_name=>'WS_COL_LABEL_MUST_BE_SPEC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\8CC7\6599\6B04\6A19\7C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109735117882313949)
,p_name=>'WS_COL_MUST_BE_SEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\9078\53D6\8981\8B8A\66F4\503C\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109735353551313949)
,p_name=>'WS_COL_MUST_BE_SEL_REP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\9078\53D6\8981\53D6\4EE3\503C\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109734449522313949)
,p_name=>'WS_COL_NAME_MUST_BE_SPEC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\8CC7\6599\6B04\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109733703125313948)
,p_name=>'WS_COL_SEL_TO_EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\9078\53D6\8981\7DE8\8F2F\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109734580886313949)
,p_name=>'WS_COL_SEL_TO_REMOVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\9078\53D6\8981\79FB\9664\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109720301407313937)
,p_name=>'WS_COMMA_SEP_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9017\865F\5340\9694\7684\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109722000656313939)
,p_name=>'WS_COMMA_SEP_LIST2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\4F7F\7528\9017\865F\5340\9694\7684\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109733482331313948)
,p_name=>'WS_CONF_DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\78BA\8A8D\522A\9664.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110109249775314240)
,p_name=>'WS_CONTROL_PANEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63A7\5236\53F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110032319320314166)
,p_name=>'WS_COPY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109646952298313867)
,p_name=>'WS_COPY_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\9801\9762\70BA\8907\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109670094091313888)
,p_name=>'WS_CREATE_APP_CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\4F7F\7528\4E0B\5217\5C6C\6027\5EFA\7ACB\300CWeb \8A66\7B97\8868\300D.  \8ACB\78BA\8A8D\60A8\7684\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109646373274313867)
,p_name=>'WS_CREATE_CHART_SECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5716\8868\5340\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109425375463313694)
,p_name=>'WS_CREATE_DATA_GRID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\8CC7\6599\65B9\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109646489717313867)
,p_name=>'WS_CREATE_DATA_SECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\8CC7\6599\5340\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109720581881313937)
,p_name=>'WS_CREATE_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109646675099313867)
,p_name=>'WS_CREATE_NAV_SECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5C0E\89BD\5340\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109646834070313867)
,p_name=>'WS_CREATE_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108950581901313327)
,p_name=>'WS_CREATE_PLSQL_SECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB PL/SQL \5340\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109646258635313867)
,p_name=>'WS_CREATE_SECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5340\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109646576855313867)
,p_name=>'WS_CREATE_TEXT_SECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664\6587\5B57\5340\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109720666386313938)
,p_name=>'WS_CURRENT_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108916667751313300)
,p_name=>'WS_DASHBOARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5100\8868\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108893987425313282)
,p_name=>'WS_DATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109406421986313680)
,p_name=>'WS_DATA_GRID_COLUMN_LIMIT_REACHED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9054\8CC7\6599\6B04\985E\578B\7684\8CC7\6599\6B04\6578\76EE\4E0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110096094807314212)
,p_name=>'WS_DATA_GRID_DUP_COL_NAME_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767C\73FE\91CD\8907\7684\8CC7\6599\6B04\540D\7A31.  \8CC7\6599\6B04\540D\7A31\5FC5\9808\662F\552F\4E00\7684.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110061436228314186)
,p_name=>'WS_DATA_GRID_NAME_NOT_UNIQUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\8CC7\6599\65B9\683C\300D\540D\7A31\5DF2\7D93\5B58\5728. \8ACB\8F38\5165\5176\4ED6\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109720748502313938)
,p_name=>'WS_DEFAULT_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109720489780313937)
,p_name=>'WS_DEFAULT_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110122964676314251)
,p_name=>'WS_DEFINE_DATA_GRID_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B9A\7FA9\8CC7\6599\65B9\683C\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109722148522313939)
,p_name=>'WS_DELETE_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109656020265313874)
,p_name=>'WS_DELETE_DATA_GRID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\8CC7\6599\65B9\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109726591014313942)
,p_name=>'WS_DELETE_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109722286212313939)
,p_name=>'WS_DEL_COL_DIALOG_HLP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\96A8\8CC7\6599\6C38\4E45\79FB\9664\7684\8CC7\6599\6B04:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108939519506313318)
,p_name=>'WS_DGQ_FIRST_COL_MUST_BE_PK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C\4E00\500B\8CC7\6599\6B04\5FC5\9808\662F\300C\8CC7\6599\65B9\683C\300D\7684\4E3B\7D22\5F15\9375, \624D\6703\986F\793A\7DE8\8F2F\6216\65B0\589E\8CC7\6599\5217\9023\7D50.  \8ACB\5C07 "APXWS_DATA_GRID_PK" \66FF\4EE3\9805\76EE\65B0\589E\70BA Select \6558\8FF0\53E5\4E2D\7684\7B2C\4E00\500B\8CC7\6599\6B04, \4EE5\5305\62EC\4E3B\7D22\5F15\9375.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108932803295313312)
,p_name=>'WS_DGQ_MORE_THAN_ONE_DATA_GRID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\8A62\5FC5\9808\53EA\53C3\7167\300C\8CC7\6599\65B9\683C\300D\4E00\6B21, \624D\80FD\5920\986F\793A\7DE8\8F2F\6216\65B0\589E\8CC7\6599\5217\9023\7D50.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108939657944313318)
,p_name=>'WS_DGQ_MULTI_SELECT_STMT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\8A62\5305\542B\591A\500B Select \6558\8FF0\53E5.  \8ACB\5C07 "APXWS_DATA_GRID_PK" \66FF\4EE3\9805\76EE\65B0\589E\70BA Select \6558\8FF0\53E5\4E2D\7684\7B2C\4E00\500B\8CC7\6599\6B04, \4EE5\986F\793A\7DE8\8F2F\6216\65B0\589E\8CC7\6599\5217\9023\7D50.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109738146932313951)
,p_name=>'WS_DGQ_SQLVALUE_EXAMPLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQLVALUE \6A19\8A18\8A9E\6CD5:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109485233815313740)
,p_name=>'WS_DGQ_SQL_EXAMPLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \6A19\8A18\8A9E\6CD5:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109719906281313937)
,p_name=>'WS_DISPLAY_AS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109719823768313937)
,p_name=>'WS_DOCUMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109660516572313879)
,p_name=>'WS_DUPLICATE_PK_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\53EF\9078\64C7\76F8\540C\7684\8CC7\6599\6B04\4F5C\70BA\4E3B\7D22\5F15\9375.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109719199591313936)
,p_name=>'WS_EDIT_ATTACHMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110032466473314166)
,p_name=>'WS_EDIT_ATTRIBUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\5C6C\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108915725033313299)
,p_name=>'WS_EDIT_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108915394697313299)
,p_name=>'WS_EDIT_NOTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\9644\8A3B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109646741461313867)
,p_name=>'WS_EDIT_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110032551151314166)
,p_name=>'WS_EDIT_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109653982924313873)
,p_name=>'WS_EDIT_SECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\5340\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109717319198313935)
,p_name=>'WS_EDIT_SECTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\5340\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108915832832313299)
,p_name=>'WS_EDIT_TAG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\6A19\8A18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108979655557313350)
,p_name=>'WS_EDIT_TAGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\6A19\8A18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108955806606313331)
,p_name=>'WS_EMAIL_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109722700093313939)
,p_name=>'WS_EMPTY_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\767D\7684\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109654541911313873)
,p_name=>'WS_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4 %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109732121030313947)
,p_name=>'WS_ERR_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109735819674313950)
,p_name=>'WS_ERR_MSG_MUST_BE_SPEC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\932F\8AA4\8A0A\606F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109686359095313905)
,p_name=>'WS_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109662159890313881)
,p_name=>'WS_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110144635357314267)
,p_name=>'WS_FILE_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\5FC5\9808\542B\6709\4E00\4E9B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109726130930313942)
,p_name=>'WS_FILL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\586B\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109726245000313942)
,p_name=>'WS_FILL_HLP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4EE5\4E0A\5132\5B58\683C\7684\8CC7\6599\6B04\503C\586B\5165\7A7A\503C\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109725956585313942)
,p_name=>'WS_FIND_WHAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0B\627E\76EE\6A19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109641037679313863)
,p_name=>'WS_GETTING_STARTED_CONTENT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4F7F\7528\300CWeb \8A66\7B97\8868\300D\61C9\7528\7A0B\5F0F\6642, \4E00\822C\4F7F\7528\8005\7121\9700\900F\904E\958B\767C\4EBA\54E1\5354\52A9\5373\53EF\7BA1\7406\7D50\69CB\5316\548C\975E\7D50\69CB\5316\8CC7\6599.\300CWeb \8A66\7B97\8868\300D\53EF\8B93\4F7F\7528\8005:'),
'<ul>',
unistr('<li>\53EA\8981\4F7F\7528 Web \700F\89BD\5668, \5373\53EF\5728\7DB2\8DEF\4E0A\5EFA\7ACB\53CA\5171\7528\5167\5BB9.</li>'),
unistr('<li>\4EE5\968E\5C64\65B9\5F0F\7D44\7E54\9801\9762\53CA\4EA4\53C9\9023\7D50\9801\9762.</li>'),
unistr('<li>\4F7F\7528\7A31\70BA\8CC7\6599\65B9\683C\7684\5167\5D4C\529F\80FD, \5EFA\7ACB\53CA\7BA1\7406\5217\8868\5316\8CC7\6599.</li>'),
unistr('<li>\4F7F\7528 SQL \6839\64DA\8CC7\6599\5EAB\5167\7684\73FE\6709\8CC7\6599\7D50\69CB\5EFA\7ACB\4E92\52D5\5F0F\5831\8868.</li>'),
unistr('<li>\4EE5\5716\8868\6216\5831\8868\65B9\5F0F, \986F\793A\9801\9762\5167\7684\8CC7\6599\65B9\683C\548C\5831\8868\8CC7\6599.</li>'),
unistr('<li>\4F7F\7528\6A94\6848\3001\6A19\8A18\548C\9644\8A3B\52A0\8A3B\9801\9762. \53EF\5728\9801\9762\5167\5BB9\4E2D\4EE5\5167\5D4C\65B9\5F0F\986F\793A\95DC\806F\7684\5F71\50CF.</li>'),
unistr('<li>\641C\5C0B\9801\9762\5167\5BB9 (\4F7F\7528\5167\5EFA\7684\641C\5C0B\529F\80FD).</li>'),
unistr('<li>\7BA1\7406\53EF\4EE5\767B\5165\7684\4EBA\54E1, \4EE5\53CA\767B\5165\5F8C\53EF\4EE5\8B80\53D6\3001\5BEB\5165\6216\7BA1\7406\61C9\7528\7A0B\5F0F\7684\4EBA\54E1 (\8A8D\8B49\548C\6388\6B0A).</li>'),
'</ul>',
unistr('<p>\8ACB\6309\4E00\4E0B\300C\8AAA\660E\300D\77AD\89E3\8A73\7D30\8CC7\8A0A.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109720965836313938)
,p_name=>'WS_GROUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109726982573313943)
,p_name=>'WS_GROUP_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109734832665313949)
,p_name=>'WS_GROUP_NAME_MUST_BE_SPEC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\7FA4\7D44\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109721231895313938)
,p_name=>'WS_HEADING_ALIGNMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C\5C0D\9F4A\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109721675235313938)
,p_name=>'WS_HEIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109735012706313949)
,p_name=>'WS_INVALID_COL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109733600137313948)
,p_name=>'WS_INVALID_COL_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\8CC7\6599\6B04\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109691817375313913)
,p_name=>'WS_INVALID_DATA_GRID_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\8CC7\6599\65B9\683C\540D\7A31\6216\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109662377857313881)
,p_name=>'WS_LINKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109727620730313943)
,p_name=>'WS_LINK_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109660870773313879)
,p_name=>'WS_LINK_TO_THIS_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50\81F3\6B64\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109726431890313942)
,p_name=>'WS_LOAD_ORDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109734253297313948)
,p_name=>'WS_LOV_ALREADY_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\503C\6E05\55AE\540D\7A31\5DF2\7D93\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109720287667313937)
,p_name=>'WS_LOV_DEF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109734389793313948)
,p_name=>'WS_LOV_DEF_MUST_BE_SPEC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\503C\6E05\55AE\5B9A\7FA9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109721863196313938)
,p_name=>'WS_LOV_DIALOG_HLP1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\503C\6E05\55AE\300D\4E3B\8981\7528\4F86\9650\5236\4F7F\7528\8005\6240\80FD\8F38\5165\7684\8CC7\6599\6B04\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109721946258313939)
,p_name=>'WS_LOV_DIALOG_HLP2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\53EF\4EE5\5728\7DE8\8F2F\300C\8CC7\6599\6B04\7279\6027\300D\6642, \8A2D\5B9A\5DF2\5B9A\7FA9\300C\503C\6E05\55AE\300D\8207\67D0\500B\8CC7\6599\6B04\7684\95DC\806F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109733995091313948)
,p_name=>'WS_LOV_MUST_BE_DEF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\70BA\9078\53D6\7684\986F\793A\985E\578B\5B9A\7FA9\300C\503C\6E05\55AE\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109734100696313948)
,p_name=>'WS_LOV_MUST_BE_SPEC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\503C\6E05\55AE\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109720178290313937)
,p_name=>'WS_LOV_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109661987541313880)
,p_name=>'WS_MAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5730\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109721563899313938)
,p_name=>'WS_MAX_WIDTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5927\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109493588819313746)
,p_name=>'WS_MAX_WIDTH_LIMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\6700\5927\5BEC\5EA6\300D\4E0D\53EF\5927\65BC 4000.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109719242756313936)
,p_name=>'WS_MINIMIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5C0F\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109684028573313903)
,p_name=>'WS_MOVE_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\52D5\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110046661011314176)
,p_name=>'WS_MUST_BE_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\7B26\5408 %1 \7684\65E5\671F\683C\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109734940572313949)
,p_name=>'WS_NAME_MUST_BE_SPEC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\65B0\8CC7\6599\65B9\683C\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109660401686313879)
,p_name=>'WS_NAME_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109722599206313939)
,p_name=>'WS_NEW_COL_VAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\8CC7\6599\6B04\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108916467951313300)
,p_name=>'WS_NEW_DATA_GRID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA\8CC7\6599\65B9\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109726789689313943)
,p_name=>'WS_NEW_DATA_GRID_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\8CC7\6599\65B9\683C\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109726834900313943)
,p_name=>'WS_NEW_GROUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109720066971313937)
,p_name=>'WS_NEW_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109721776651313938)
,p_name=>'WS_NEW_LOV_BASED_ON_CURR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EE5\76EE\524D\503C\70BA\57FA\790E\7684\65B0\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108916289054313300)
,p_name=>'WS_NEW_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108916535412313300)
,p_name=>'WS_NEW_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108916116496313299)
,p_name=>'WS_NEW_SECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA\5340\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109728789643313944)
,p_name=>'WS_NEW_VALIDATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA\9A57\8B49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109736241327313950)
,p_name=>'WS_NEW_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109621796964313849)
,p_name=>'WS_NOTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9644\8A3B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109662220590313881)
,p_name=>'WS_NOTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9644\8A3B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109621811735313849)
,p_name=>'WS_NOTE_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\9644\8A3B\300D\5FC5\9808\8981\6709\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108916077935313299)
,p_name=>'WS_NO_COLUMNS_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108915602309313299)
,p_name=>'WS_NO_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108914565171313298)
,p_name=>'WS_NO_FILE_CHOSEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9078\64C7\6A94\6848')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108915418313313299)
,p_name=>'WS_NO_NOTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\9644\8A3B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108915929614313299)
,p_name=>'WS_NO_TAGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\6A19\8A18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109719705199313937)
,p_name=>'WS_NUMBER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109736132202313950)
,p_name=>'WS_OLD_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\820A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109726372105313942)
,p_name=>'WS_ORDER_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5217\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109686523392313905)
,p_name=>'WS_PAGE_ALIAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108955626212313331)
,p_name=>'WS_PAGE_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109686679847313905)
,p_name=>'WS_PAGE_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108916395421313300)
,p_name=>'WS_PAGE_DIRECTORY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\76EE\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108916738595313300)
,p_name=>'WS_PAGE_HISTORY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6B77\53F2\8A18\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110084779042314203)
,p_name=>'WS_PAGE_LIST_WITH_CHILD_PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\542B\6709\5B50\9805\9801\9762\7684\968E\5C64\9801\9762\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110032028184314166)
,p_name=>'WS_PROPERTIES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7279\6027')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109733392714313948)
,p_name=>'WS_QRY_MORE_10K'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\67E5\8A62\50B3\56DE\8D85\904E 10,000 \500B\4EE5\4E0A\7684\8CC7\6599\5217, \8ACB\7BE9\9078\8CC7\6599, \78BA\4FDD\53D6\5F97\5B8C\6574\7684\7D50\679C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109700260277313922)
,p_name=>'WS_QUERY_NOT_ALLOWED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5141\8A31\67E5\8A62\5167\90E8\61C9\7528\7A0B\5F0F\7269\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109721145732313938)
,p_name=>'WS_READ_ONLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\552F\8B80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109735903999313950)
,p_name=>'WS_RECENT_CHGS_LISTED_BELOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\8FD1\7684\8B8A\66F4\5217\793A\5982\4E0B:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110032208135314166)
,p_name=>'WS_REPLACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\4EE3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109726084310313942)
,p_name=>'WS_REPLACE_WITH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\4EE3\70BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109736040739313950)
,p_name=>'WS_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109726613718313942)
,p_name=>'WS_ROWS_W_EMPTY_COL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\7A7A\767D\7684\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110044214997314175)
,p_name=>'WS_ROW_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217 %0 \7531 %2 \65BC %1 \5EFA\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110044130031314174)
,p_name=>'WS_ROW_KEY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\7D22\5F15\9375')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110044358138314175)
,p_name=>'WS_ROW_LAST_UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5BB9\4E0A\6B21\7531 %1 \65BC %0 \66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109735261256313949)
,p_name=>'WS_ROW_MUST_BE_SEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\9078\53D6\8981\8A2D\5B9A\8CC7\6599\6B04\503C\7684\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109662039312313880)
,p_name=>'WS_ROW_ORDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109733558975313948)
,p_name=>'WS_ROW_SELECTED_DEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\9078\53D6\4E00\500B\8981\522A\9664\7684\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109670111940313888)
,p_name=>'WS_SAMPLE_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6703\5EFA\7ACB\7BC4\4F8B\9996\9801.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109683877610313903)
,p_name=>'WS_SAVE_ADD_ANOTHER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\4E26\65B0\589E\53E6\4E00\500B\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110085734648314204)
,p_name=>'WS_SEARCH_REPORT_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\5831\8868 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109686417448313905)
,p_name=>'WS_SECTION_CONTENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\6BB5\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108955509206313331)
,p_name=>'WS_SECTION_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5EFA\7ACB\5340\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109670217723313888)
,p_name=>'WS_SECTION_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\6BB5\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109722652787313939)
,p_name=>'WS_SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9078\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109725742189313942)
,p_name=>'WS_SELECTED_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7684\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109721023068313938)
,p_name=>'WS_SELECT_COLUMN_GROUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8CC7\6599\6B04\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109642626488313864)
,p_name=>'WS_SELECT_RPT_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5831\8868\540D\7A31\4EE5\6AA2\8996\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109734718116313949)
,p_name=>'WS_SEQ_MUST_BE_NUM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9806\5E8F\5FC5\9808\662F\6578\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109734601704313949)
,p_name=>'WS_SEQ_MUST_BE_SPEC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\9806\5E8F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109722425392313939)
,p_name=>'WS_SET_COL_VAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\8CC7\6599\6B04\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110092784666314210)
,p_name=>'WS_SIGNUP.PRIVACY_POLICY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<a href="https://www.oracle.com/legal/privacy/index.html" target="_new">Oracle \96B1\79C1\6B0A\653F\7B56</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110085226474314203)
,p_name=>'WS_SIGNUP.TERMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E0B\65B9\7684\300C\4E0B\4E00\6B65\300D\6309\9215\5373\8868\793A\60A8\77AD\89E3\4E26\540C\610F\4F7F\7528 Oracle \7684\7DB2\7AD9\5C07\53D7\5230 <a href="https://www.oracle.com/us/legal/terms/index.html" target="_new">Oracle.com \4F7F\7528\689D\6B3E</a>\9650\5236. Oracle \5C0D\60A8\500B\4EBA\8CC7\8A0A\4E4B\8490\96C6\8207\4F7F\7528\7684\76F8\95DC\8A73\7D30\8AAA\660E, \5305\62EC\5B58\53D6\3001\7559\5B58\3001\4FEE\6B63\3001\522A\9664\3001\5B89\5168\6027\3001\8DE8\570B\8F49\79FB\53CA\5176\4ED6\4E3B\984C\65B9\9762\7684\8CC7\8A0A, \5747\8A18\8F09\65BC <a href="https://www.oracle.com/legal/privacy/inde')
||unistr('x.html" target="_new">Oracle \96B1\79C1\6B0A\653F\7B56</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109719618120313937)
,p_name=>'WS_STRING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B57\4E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109735456741313949)
,p_name=>'WS_STR_MUST_BE_SPEC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\8981\5C0B\627E\7684\5B57\4E32.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109662475052313881)
,p_name=>'WS_TAGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\8A18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110032147133314166)
,p_name=>'WS_TOGGLE_CHECKBOXES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5207\63DB\6838\53D6\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109728856673313944)
,p_name=>'WS_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109727000102313943)
,p_name=>'WS_UNASSIGNED_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6307\5B9A\7684\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109719504902313937)
,p_name=>'WS_UNIQUE_IDENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\552F\4E00 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109727890091313943)
,p_name=>'WS_URL_TARGET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('URL \76EE\6A19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109735566280313949)
,p_name=>'WS_URL_TARGET_SPEC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A URL \76EE\6A19.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109736360726313950)
,p_name=>'WS_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110091018385314208)
,p_name=>'WS_USERNAME_TOO_LONG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31\592A\9577')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110046522477314176)
,p_name=>'WS_VALUE_NUMERIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5FC5\9808\662F\6578\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109621618953313849)
,p_name=>'WS_VALUE_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\5FC5\9808\8F38\5165\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109731985867313947)
,p_name=>'WS_VAL_EXPRESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109735682805313950)
,p_name=>'WS_VAL_NAME_MUST_BE_SPEC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\9A57\8B49\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109729797971313945)
,p_name=>'WS_VAL_NOT_EQ_STR_EXP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\8CC7\6599\6B04\4E0D\7B49\65BC\300C\8868\793A\5F0F\300D\4E2D\7684\5B57\4E32\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109735713797313950)
,p_name=>'WS_VAL_SEQ_MUST_BE_SPEC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\9A57\8B49\9806\5E8F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109729338251313945)
,p_name=>'WS_VAL_TYPE_CHAR_IN_EXP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\8CC7\6599\6B04\81F3\5C11\5305\542B\300C\8868\793A\5F0F\300D\4E2D\7684\5176\4E2D\4E00\500B\5B57\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109731043589313946)
,p_name=>'WS_VAL_TYPE_COL_ALPHA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\8CC7\6599\6B04\70BA\6587\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109730481297313945)
,p_name=>'WS_VAL_TYPE_COL_IN_EXP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\8CC7\6599\6B04\5305\542B\5728\300C\8868\793A\5F0F\300D\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109730522006313945)
,p_name=>'WS_VAL_TYPE_COL_NOT_0'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\8CC7\6599\6B04\4E0D\70BA\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109730283940313945)
,p_name=>'WS_VAL_TYPE_COL_NOT_EXP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\8CC7\6599\6B04\672A\5305\542B\5728\300C\8868\793A\5F0F\300D\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109730982021313946)
,p_name=>'WS_VAL_TYPE_COL_NOT_NULL_OR_0'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\8CC7\6599\6B04\4E0D\662F\7A7A\503C\6216\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109730636151313946)
,p_name=>'WS_VAL_TYPE_COL_NO_SP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\8CC7\6599\6B04\672A\5305\542B\7A7A\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109731133752313946)
,p_name=>'WS_VAL_TYPE_COL_NUM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\8CC7\6599\6B04\70BA\6578\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109731578573313946)
,p_name=>'WS_VAL_TYPE_COL_VAL_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\8CC7\6599\6B04\70BA\6709\6548\7684\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109730037021313945)
,p_name=>'WS_VAL_TYPE_EQ_STR_EXP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\8CC7\6599\6B04\7B49\65BC\300C\8868\793A\5F0F\300D\4E2D\7684\5B57\4E32\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109729914329313945)
,p_name=>'WS_VAL_TYPE_NOT_ANY_CHAR_EXP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\8CC7\6599\6B04\672A\5305\542B\300C\8868\793A\5F0F\300D\4E2D\7684\4EFB\4F55\5B57\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109729275001313944)
,p_name=>'WS_VAL_TYPE_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\8CC7\6599\6B04\4E0D\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109729527108313945)
,p_name=>'WS_VAL_TYPE_ONLY_CHAR_EXP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\8CC7\6599\6B04\53EA\5305\542B\300C\8868\793A\5F0F\300D\4E2D\7684\5B57\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109736576412313950)
,p_name=>'WS_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110084655071314203)
,p_name=>'WS_VIEW_DATA_GRID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\8CC7\6599\65B9\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109718831813313936)
,p_name=>'WS_VIEW_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109719005254313936)
,p_name=>'WS_VIEW_NOTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\9644\8A3B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109718989409313936)
,p_name=>'WS_VIEW_TAGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\6A19\8A18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109660718950313879)
,p_name=>'WS_WEBSHEET_ALIAS_NOT_UNIQUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5225\540D\5DF2\7D93\5B58\5728.  \8ACB\8F38\5165\5176\4ED6\5225\540D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110031948389314166)
,p_name=>'WS_WEBSHEET_PROP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Web \8A66\7B97\8868\7279\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109641160125313863)
,p_name=>'WS_WELCOME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B61\8FCE\4F7F\7528 Web \8A66\7B97\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109721403691313938)
,p_name=>'WS_WIDTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BEC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109661241601313880)
,p_name=>'WS_WITHOUT_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\542B\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109661678700313880)
,p_name=>'WS_WITHOUT_LINKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\542B\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109661885279313880)
,p_name=>'WS_WITHOUT_LOCATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\542B\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109661434595313880)
,p_name=>'WS_WITHOUT_NOTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\542B\9644\8A3B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109661107854313880)
,p_name=>'WS_WITH_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\542B\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109661595415313880)
,p_name=>'WS_WITH_LINKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\542B\9023\7D50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109661782085313880)
,p_name=>'WS_WITH_LOCATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\542B\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109661379768313880)
,p_name=>'WS_WITH_NOTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\542B\9644\8A3B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109412989209313685)
,p_name=>'WWV_CALENDAR_INVALID_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\67E5\8A62\5FC5\9808\81F3\5C11\5305\542B\4E00\500B\65E5\671F\6216\6642\6233\8CC7\6599\6B04, \8ACB\6AA2\67E5\60A8\7684\67E5\8A62. (%0) </p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109148253152313481)
,p_name=>'WWV_CRYPT.KEY_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91D1\9470\5FC5\9808\662F 8, 16 \6216 24 \500B\4F4D\5143\7D44.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108917403208313301)
,p_name=>'WWV_DATA_PKG.APP_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F %0 \4E0D\5B58\5728\65BC\6B64\5DE5\4F5C\5340\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108917668149313301)
,p_name=>'WWV_DATA_PKG.LOAD_TABLE_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165 %0 \8868\683C\5931\6557. \932F\8AA4\90FD\8A18\9304\5728 %1 \8868\683C\4E2D. \82E5\8981\91CD\65B0\57F7\884C, \5FC5\9808\5148\5C07\6B64\8868\683C\522A\9664.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108917349434313300)
,p_name=>'WWV_DATA_PKG.NO_FILE_GENERATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\7522\751F\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108917214810313300)
,p_name=>'WWV_DATA_PKG.ROWS_EXPORTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\51FA\7684\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108917706048313301)
,p_name=>'WWV_DATA_PKG.TABLE_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \932F\8AA4\8868\683C\5DF2\7D93\5B58\5728. \82E5\8981\91CD\65B0\57F7\884C, \5FC5\9808\5148\5C07\6B64\8868\683C\522A\9664.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108917568790313301)
,p_name=>'WWV_DATA_PKG.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\5305\62EC\7684\8CC7\6599\6B04\90FD\662F\4E0D\652F\63F4\7684\8CC7\6599\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108894658193313283)
,p_name=>'WWV_DBMS_CLOUD.DATA_PUMP_DIR_PRIVS_MISSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \7DB1\8981\9700\8981 DATA_PUMP_DIR \76EE\9304\7684 READ \548C WRITE \6B0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108898934107313286)
,p_name=>'WWV_DBMS_CLOUD.FILE_TOO_LARGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\7684\7269\4EF6\5B58\653E\5340\6A94\6848\592A\5927.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108886046387313276)
,p_name=>'WWV_DBMS_CLOUD.INTERNAL_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406 DBMS_CLOUD \8981\6C42\6642\767C\751F\5167\90E8\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108886170952313276)
,p_name=>'WWV_DBMS_CLOUD.INVALID_CREDENTIAL_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7269\4EF6\5B58\653E\5340\53C3\7167\7684\8B49\660E\8CC7\6599\985E\578B\7121\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108894580562313283)
,p_name=>'WWV_DBMS_CLOUD.NO_DATA_PUMP_DIR_ACCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \7DB1\8981\9700\8981 DATA_PUMP_DIR \76EE\9304\7684\5B58\53D6\6B0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108897511724313285)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\7CFB\7D71\4E0A\6C92\6709 DBMS_CLOUD \5957\88DD\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108894466046313283)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD_ACCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \7DB1\8981\9700\8981 DBMS_CLOUD \5957\88DD\7A0B\5F0F\7684 EXECUTE \6B0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109129991737313468)
,p_name=>'WWV_DBMS_SQL.FUNC_BODY_NULL_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5256\6790\932F\8AA4: \51FD\6578\4E3B\9AD4\4E0D\80FD\662F\7A7A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109130011772313468)
,p_name=>'WWV_DBMS_SQL.PARSE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5256\6790\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109122569721313462)
,p_name=>'WWV_FLOW.APP_NOT_FND_FOOTER_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F=%0 \76EE\524D\7684\5DE5\4F5C\5340=%1 \8981\6C42\7684\5DE5\4F5C\5340=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109122098437313462)
,p_name=>'WWV_FLOW.APP_NOT_FND_INV_COMP_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1014 \627E\4E0D\5230\61C9\7528\7A0B\5F0F.  \7121\6548\7684\5DE5\4F5C\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109124127776313463)
,p_name=>'WWV_FLOW.APP_PAGE_REQUEST_FOOTER_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F=%0 \9801\9762=%1 \8981\6C42=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109118199976313459)
,p_name=>'WWV_FLOW.AUTH_SCHEME_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1082 \57F7\884C\6388\6B0A\914D\7F6E\7A0B\5F0F\78BC\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109118967650313460)
,p_name=>'WWV_FLOW.BRANCH_POINT_NULL_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1007 \5206\652F\9EDE\4E0D\80FD\662F\7A7A\503C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109119088843313460)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1008 \57F7\884C\9023\7D50\5230\5206\652F\9801\9762 %0 \6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108879403051313271)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_MODE_PAGE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-7746 \7121\6CD5\8655\7406\300C\5C0D\8A71\65B9\584A\300D\9801\9762\7684\5206\652F\5230\4E0D\540C\9801\9762\6A21\5F0F\7684\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109127353532313466)
,p_name=>'WWV_FLOW.BUTTON_TEMP_FETCH_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64F7\53D6\6309\9215\6A23\677F id=%0 \6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109117730310313459)
,p_name=>'WWV_FLOW.CLICK_TO_LOGIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\6309\4E00\4E0B<a href="%0">\6B64\8655</a>\767B\5165</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109118455032313459)
,p_name=>'WWV_FLOW.COMP_EXP_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1030 \57F7\884C\904B\7B97\8868\793A\5F0F\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109118587932313459)
,p_name=>'WWV_FLOW.COMP_FUNCTION_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1004 \7121\6CD5\904B\7B97\51FD\6578. computation_point=%0 computation_type=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109118314224313459)
,p_name=>'WWV_FLOW.COMP_QUERY_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1003 \57F7\884C\904B\7B97\67E5\8A62\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109118271544313459)
,p_name=>'WWV_FLOW.CREATE_ITEM_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1001 \5EFA\7ACB\9805\76EE\6642\767C\751F\672A\9810\671F\7684\932F\8AA4: FSP_PROCESS_STATE_%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109117960722313459)
,p_name=>'WWV_FLOW.DEEPLINKING_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1001 make_deeplinking_item \968E\6BB5\4F5C\696D=%0 \767C\751F\672A\9810\671F\7684\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109119575771313460)
,p_name=>'WWV_FLOW.DET_COMPANY_FOOTER_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\671F p_company \6216 wwv_flow_company cookie \61C9\5305\542B\61C9\7528\7A0B\5F0F\64C1\6709\8005\7684\5B89\5168\6027\7FA4\7D44 ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109123891864313463)
,p_name=>'WWV_FLOW.DET_COMPANY_ON_ACCEPT_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-7621 \63A5\53D7\61C9\7528\7A0B\5F0F\6642\7121\6CD5\5224\65B7\61C9\7528\7A0B\5F0F (%0) \7684\5DE5\4F5C\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109123994901313463)
,p_name=>'WWV_FLOW.DET_COMP_FOR_FLOW_FOOTER_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\671F p_company \6216 wwv_flow_company cookie \61C9\5305\542B\61C9\7528\7A0B\5F0F\64C1\6709\8005\7684\5B89\5168\6027\7FA4\7D44 ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109119316739313460)
,p_name=>'WWV_FLOW.EVAL_TYPE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1011 \7121\6548\7684\8A55\4F30\985E\578B: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109127270342313466)
,p_name=>'WWV_FLOW.FETCH_VALUE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('fetch_value \767C\751F\61C9\7528\7A0B\5F0F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109118027866313459)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1902 find_item_name \5E38\5F0F\4E2D\7684\300C\9805\76EE ID \300D\662F\7A7A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109118877665313460)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_BOOL_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1021 \7121\6CD5\57F7\884C\300C\51FD\6578\4E3B\9AD4\50B3\56DE\5E03\6797\503C\300D\9A57\8B49.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109118701953313459)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_TEXT_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1024 \7121\6CD5\57F7\884C\300C\50B3\56DE\6587\5B57\7684\51FD\6578\4E3B\9AD4\300D\9A57\8B49.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109119466116313460)
,p_name=>'WWV_FLOW.G_FLOW_ID_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1812 \6307\5B9A G_FLOW_ID (%0) \6642\767C\751F\672A\9810\671F\7684\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109124008029313463)
,p_name=>'WWV_FLOW.INSUFFICENT_INFO_ON_REQ_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-9988 \63D0\4F9B\7D66\6B64\8981\6C42\7684\8CC7\8A0A\4E0D\8DB3:  \53EF\80FD\662F\60A8\672A\7B49\5F85\4E0A\4E00\500B\9801\9762\5B8C\5168\8F09\5165.  \8ACB\6309\700F\89BD\5668\7684\300C\4E0A\4E00\9801\300D\548C\300C\91CD\65B0\8F09\5165\300D\6309\9215, \6216\700F\89BD\60A8\7684\61C9\7528\7A0B\5F0F\9996\9801, \7E7C\7E8C\9032\884C\4F5C\696D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109119904594313460)
,p_name=>'WWV_FLOW.LOGIN_SERVER_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1555 \672A\767B\5165\300COracle \767B\5165\4F3A\670D\5668\300D.  \672A\8B58\5225\516C\7528\4F7F\7528\8005.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109123562443313463)
,p_name=>'WWV_FLOW.LOGOUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109117695081313459)
,p_name=>'WWV_FLOW.NOT_LOGGED_IN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\767B\5165. \8A8D\8B49\9700\8981\7684 cookie \907A\6F0F\6216\7121\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109124593502313464)
,p_name=>'WWV_FLOW.NO_PAGE_TO_BRANCH_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1777: \9801\9762 %0 \672A\63D0\4F9B\53EF\9023\7D50\7684\5206\652F\9801\9762. \8ACB\5411\60A8\7684\61C9\7528\7A0B\5F0F\7BA1\7406\54E1\5831\544A\6B64\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109123644887313463)
,p_name=>'WWV_FLOW.NO_PRIV_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1013 \4F7F\7528\8005 %0 \6C92\6709\60F3\5617\8A66\4E4B\4F5C\696D\7684\6B0A\9650. \9700\8981\89D2\8272 %1, \8ACB\6D3D\8A62\60A8\7684\61C9\7528\7A0B\5F0F\7BA1\7406\54E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108949426969313326)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.CHECKSUM_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\7E3D\548C\6AA2\9A57\5DF2\50B3\9001\81F3\986F\793A\7A0B\5E8F, \5C31\53EF\4EE5\4F7F\7528\5F15\6578\4F86\8981\6C42\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108949614682313326)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.DIRECT_BRANCH_ONLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\80FD\5F9E\5176\4ED6\9801\9762\4F7F\7528\300C\9023\7D50\5230\5206\652F\9801\9762\300D\985E\578B\5206\652F\4F86\5B58\53D6\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108949566288313326)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.NO_ARGS_ALLOWED '
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\6709\4E0D\4F7F\7528\5F15\6578\6642\624D\53EF\4EE5\5B58\53D6\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108949828593313326)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_ARGS_ALLOWED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F15\6578\50B3\9001\81F3\4E0D\63A5\53D7\5F15\6578 (request, clear cache, item values) \7684\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108949351000313326)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.UNPROTECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6C92\6709\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109123479974313463)
,p_name=>'WWV_FLOW.REQUIRED_ROLE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\555F\7528\5FC5\8981\7684\89D2\8272.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109124660184313464)
,p_name=>'WWV_FLOW.RESTART_APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<a href="f?p=%0">\91CD\65B0\555F\52D5\61C9\7528\7A0B\5F0F</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109117862256313459)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1001 \300C\5132\5B58\5E38\5F0F\300D\767C\751F\672A\9810\671F\7684\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109119219650313460)
,p_name=>'WWV_FLOW.SQL_EXP_HEADING_TEXT_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1910 \8A55\4F30\6A19\984C\6587\5B57\4E2D\7684 SQL \8868\793A\5F0F\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109150437153313483)
,p_name=>'WWV_FLOW.UNABLE_HOME_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5C07\60A8\5C0E\5411\9996\9801.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109123744728313463)
,p_name=>'WWV_FLOW.UNABLE_RESOLVE_ALIAS_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1512 \7121\6CD5\89E3\6790\9801\9762\5225\540D (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109127528842313466)
,p_name=>'WWV_FLOW.UNABLE_SET_TIMED_STAT_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A2D\5B9A timed_statistics: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109127486350313466)
,p_name=>'WWV_FLOW.UNABLE_TO_TRACE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8FFD\8E64: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109121314030313461)
,p_name=>'WWV_FLOW.UNSUPP_AUTH_SCHEME_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1444 \4E0D\652F\63F4\7684\8A8D\8B49\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109118616609313459)
,p_name=>'WWV_FLOW.VALIDATION_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1006 \9A57\8B49\5E38\5F0F\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109130189211313468)
,p_name=>'WWV_FLOW_ADMINISTRATION.DEPRECATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\88AB\53D6\4EE3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109158335550313489)
,p_name=>'WWV_FLOW_ADMIN_API.DELETE_DEV_ROLE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\958B\767C\4EBA\54E1\89D2\8272\6642\767C\751F\932F\8AA4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109158274973313489)
,p_name=>'WWV_FLOW_ADMIN_API.FETCH_FND_USER_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\64F7\53D6\5C0B\627E\4F7F\7528\8005\8CC7\8A0A. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109358367091313643)
,p_name=>'WWV_FLOW_ADMIN_API.NO_DEV_PRIV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A:  \4F7F\7528\8005 %0 \6C92\6709\4EFB\4F55\958B\767C\4EBA\54E1\6B0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109025411437313390)
,p_name=>'WWV_FLOW_API.COMPATIBLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\5BB9 (\60A8\53EF\4EE5\9806\5229\57F7\884C\9019\9805\532F\5165.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109903615120314074)
,p_name=>'WWV_FLOW_API.CREDENTIAL_WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8B49\660E\8CC7\6599 "%0" (\975C\614B ID) \8B66\544A:'),
'',
unistr('- Application Express \532F\51FA\6A94\6848\4E26\672A\5305\542B\8B49\660E\8CC7\6599\8CC7\8A0A.'),
unistr('- \61C9\7528\7A0B\5F0F\532F\5165\4E4B\5F8C, \8ACB\4F7F\7528 APEX_CREDENTIAL.SET_PERSISTENT_CREDENTIAL '),
unistr('- \7A0B\5E8F\8A2D\5B9A\8B49\660E\8CC7\6599. \8B49\660E\8CC7\6599\76EE\524D\4F7F\7528'),
unistr('- \5176\975C\614B ID "%0" \53C3\7167')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109020987780313387)
,p_name=>'WWV_FLOW_API.CURRENT_FLOWS_VERSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\7248\672C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109493498704313745)
,p_name=>'WWV_FLOW_API.DELETE_APP_IN_DIFFERENT_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\522A\9664\61C9\7528\7A0B\5F0F %0, \5B83\5DF2\5B89\88DD\5728\4E0D\540C\7684\5DE5\4F5C\5340\4E2D!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109025083143313390)
,p_name=>'WWV_FLOW_API.ERR_AUTH_SCHEME_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\8A8D\8B49\914D\7F6E\540D\7A31=%0 \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109023609570313389)
,p_name=>'WWV_FLOW_API.ERR_BRANCH_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5206\652F ID="%0" \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109024851770313389)
,p_name=>'WWV_FLOW_API.ERR_BUG_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\932F\8AA4 ID="%0" \6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109022179613313387)
,p_name=>'WWV_FLOW_API.ERR_BUILD_OPTION_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\7D44\5EFA\9078\9805\540D\7A31=%0 \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109022253248313388)
,p_name=>'WWV_FLOW_API.ERR_BUILD_OPTION_SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\7D44\5EFA\9078\9805 ID="%0" \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109023507079313389)
,p_name=>'WWV_FLOW_API.ERR_BUTTON_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6309\9215\540D\7A31="%0" ID="%1" \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109378964222313659)
,p_name=>'WWV_FLOW_API.ERR_DA_ACTION_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\52D5\614B\52D5\4F5C\6642\767C\751F\932F\8AA4, \5B50\52D5\4F5C\540D\7A31="%0" ID="%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109378855677313659)
,p_name=>'WWV_FLOW_API.ERR_DA_EVENT_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\52D5\614B\52D5\4F5C\6642\767C\751F\932F\8AA4, \9801\9762="%0" \540D\7A31="%1" ID="%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109063050065313418)
,p_name=>'WWV_FLOW_API.ERR_DUP_PAGE_ITEM_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\8A0A\606F\9801\9762=%0 \9805\76EE="%1" id="%2" \8207\73FE\6709\7684\61C9\7528\7A0B\5F0F\5C64\7D1A\9805\76EE\7684\540D\7A31\76F8\540C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109022771066313388)
,p_name=>'WWV_FLOW_API.ERR_FLOW_COMPUTATION_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F\904B\7B97\9805\76EE="%0" \6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109022632783313388)
,p_name=>'WWV_FLOW_API.ERR_FLOW_ITEM_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F\9805\76EE id="%0" \6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108979915115313350)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_ATTR_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB Plug-in \5C6C\6027 ID="%0" \6642\767C\751F\932F\8AA4	')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109392868065313670)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_ATTR_VALUE_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB Plug-in \5C6C\6027\503C\6642\767C\751F\932F\8AA4, ID="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108979893027313350)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB Plug-in ID="%0" \6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109036245739313398)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_EVENT_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB Plug-in \4E8B\4EF6 ID="%0" \6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109022415405313388)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PROCESS_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F\8655\7406\4F5C\696D id="%0" \6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110067620243314191)
,p_name=>'WWV_FLOW_API.ERR_FLOW_TEMPLATE_OPTION_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F\6A23\677F\9078\9805 id="%0" \6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110067503700314191)
,p_name=>'WWV_FLOW_API.ERR_FLOW_TEMPLATE_OPT_GROUP_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F\6A23\677F\9078\9805\7FA4\7D44 id="%0" \6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109024612079313389)
,p_name=>'WWV_FLOW_API.ERR_FORM_ADDED_TO_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE\5DF2\65B0\589E\81F3\73FE\6709\7684\9801\9762 %0 .')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108999602443313371)
,p_name=>'WWV_FLOW_API.ERR_INSTALL_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\532F\5165\8CC7\6599\5EAB\7269\4EF6\5B89\88DD\5C6C\6027 ID="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108999775644313371)
,p_name=>'WWV_FLOW_API.ERR_INSTALL_SCRIPT_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5B89\88DD\547D\4EE4\6A94 ID="%0" \6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109024310958313389)
,p_name=>'WWV_FLOW_API.ERR_INVALID_REPORT_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\5831\8868\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109024122087313389)
,p_name=>'WWV_FLOW_API.ERR_LANG_MAP_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F\7FFB\8B6F\5C0D\61C9\6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108921939942313304)
,p_name=>'WWV_FLOW_API.ERR_LOV_COL_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\503C\6E05\55AE\8CC7\6599\6B04 ID="%0" \6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109023130707313388)
,p_name=>'WWV_FLOW_API.ERR_LOV_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\503C\6E05\55AE ID="%0" \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109022321325313388)
,p_name=>'WWV_FLOW_API.ERR_NAV_BAR_ITEM_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\5C0E\89BD\5217\9805\76EE ID="%0" \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109023886576313389)
,p_name=>'WWV_FLOW_API.ERR_PAGE_COMPUTATION_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\9801\9762\904B\7B97\9801\9762=%0 \9805\76EE=%1 ID="%2" \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109023239169313388)
,p_name=>'WWV_FLOW_API.ERR_PAGE_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\9801\9762\540D\7A31="%0" ID="%1" \6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109433089496313700)
,p_name=>'WWV_FLOW_API.ERR_PAGE_GROUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\9801\9762\7FA4\7D44\6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109024553005313389)
,p_name=>'WWV_FLOW_API.ERR_PAGE_HAS_BUTTONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 %0 \5DF2\7D93\6709\6309\9215.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109023387506313388)
,p_name=>'WWV_FLOW_API.ERR_PAGE_HELP_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\9801\9762 %0 \8AAA\660E\5167\5BB9\6642\767C\751F\932F\8AA4:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109023764313313389)
,p_name=>'WWV_FLOW_API.ERR_PAGE_ITEM_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762=%0 \9805\76EE="%1" ID="%2" \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109023459756313388)
,p_name=>'WWV_FLOW_API.ERR_PAGE_NAME_UPD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\9801\9762\540D\7A31="%0" ID="%1" \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109024200801313389)
,p_name=>'WWV_FLOW_API.ERR_PAGE_ON_TABLE_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5728\8868\683C "%0" \4E2D\5EFA\7ACB\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109024064115313389)
,p_name=>'WWV_FLOW_API.ERR_PAGE_PROCESS_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\9801\9762\8655\7406\4F5C\696D\9801\9762=%0 \540D\7A31=%1 \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109023908412313389)
,p_name=>'WWV_FLOW_API.ERR_PAGE_VALIDATION_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\9801\9762\9A57\8B49\9801\9762=%0 \540D\7A31=%1 \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109023091782313388)
,p_name=>'WWV_FLOW_API.ERR_PARENT_TAB_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\7236\9805\9801\7C64 ID="%0" \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109022576851313388)
,p_name=>'WWV_FLOW_API.ERR_PROCESS_SQL_SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\8655\7406\4F5C\696D SQL ID="%0" \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109024456107313389)
,p_name=>'WWV_FLOW_API.ERR_REPORT_PAGE_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\9801\9762 %0 \5DF2\7D93\5B58\5728, \5DF2\65B0\589E\5831\8868\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109024736434313389)
,p_name=>'WWV_FLOW_API.ERR_REPORT_PAGE_EXISTS2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5EFA\7ACB\9801\9762 %0, \56E0\70BA\5DF2\7D93\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109024932076313390)
,p_name=>'WWV_FLOW_API.ERR_SHORTCUT_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6377\5F91 ID="%0" \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109022865790313388)
,p_name=>'WWV_FLOW_API.ERR_STD_TAB_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6A19\6E96\9801\7C64 ID="%0" \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109022986123313388)
,p_name=>'WWV_FLOW_API.ERR_TABSET_RENAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C07\9801\7C64\96C6 %1 \547D\540D\6210 %0 \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109022034905313387)
,p_name=>'WWV_FLOW_API.ERR_TEMPL_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6A23\677F\540D\7A31=%0 \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109020812774313386)
,p_name=>'WWV_FLOW_API.FLOWS_API_LAST_EXTENDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\6B21\64F4\5145 API \7684\6642\9593:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109025387358313390)
,p_name=>'WWV_FLOW_API.FLOWS_API_RUNTIME_INCOMPATIBLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\532F\51FA\6A94\6848\8207\60A8\5617\8A66\5C07\6A94\6848\532F\5165\7684 Application Express \7248\672C\4E0D\76F8\5BB9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109021849647313387)
,p_name=>'WWV_FLOW_API.FLOW_ID_MISSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\547C\53EB\7684\7A0B\5E8F %0 \6C92\6709 p_id \503C -- \5FC5\9808\63D0\4F9B\61C9\7528\7A0B\5F0F ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108881148708313273)
,p_name=>'WWV_FLOW_API.FLOW_ID_OUT_OF_RANGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F ID "%0" \4E0D\5728\5141\8A31\7684\7BC4\570D (%1 - %2) \5167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109492939126313745)
,p_name=>'WWV_FLOW_API.FLOW_ID_RANGE_RESERVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\4F7F\7528\61C9\7528\7A0B\5F0F ID "%0", \7BC4\570D (%1 - %2) \662F\4FDD\7559\7BC4\570D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109025243827313390)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F ID %0 \4FDD\7559\7D66 Oracle Corporation ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108881289604313273)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED_FOR_OTHER_WORKSPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F ID "%0" \4FDD\7559\4F9B\5176\4ED6\5DE5\4F5C\5340\4F7F\7528, \7121\6CD5\7528\65BC\6B64\8655')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109021976032313387)
,p_name=>'WWV_FLOW_API.FLOW_NOT_DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\522A\9664\61C9\7528\7A0B\5F0F %0.  \4E0D\6703\5617\8A66\532F\5165.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109021033807313387)
,p_name=>'WWV_FLOW_API.IMPORT_COMPATIBLE_WITH_VERSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\9805\532F\5165\8207\4EE5\4E0B\7248\672C\4E0D\76F8\5BB9:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109451413226313715)
,p_name=>'WWV_FLOW_API.IMPORT_SCRIPT_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\532F\5165\547D\4EE4\6A94. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109021535167313387)
,p_name=>'WWV_FLOW_API.INVALID_CREDENTIALS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\4F7F\7528\8005\540D\7A31\3001\5BC6\78BC\6216\5DE5\4F5C\5340\7D44\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109021152508313387)
,p_name=>'WWV_FLOW_API.MISSING_EXPORT_VERSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\61C9\7528\7A0B\5F0F\532F\5165\672A\63D0\4F9B\532F\51FA\7248\672C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109903507330314074)
,p_name=>'WWV_FLOW_API.MUST_USE_APEX_APP_INSTALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C1A\672A\63D0\4F9B\975C\614B ID \70BA "%0" \4E4B\9060\7AEF\4F3A\670D\5668\7684\503C. \8ACB\5148\4F7F\7528 APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER, \518D\5B89\88DD\61C9\7528\7A0B\5F0F.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109451315483313715)
,p_name=>'WWV_FLOW_API.NEW_SCRIPT_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109025568086313390)
,p_name=>'WWV_FLOW_API.NOT_COMPATIBLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\76F8\5BB9 (\60A8\7684\532F\51FA\9805\76EE\53EF\80FD\5305\542B %0 \7248\672C\4E0D\652F\63F4\7684\547C\53EB.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109903913261314074)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_1'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9060\7AEF\4F3A\670D\5668 "%0" (\975C\614B ID) \8B66\544A.'),
'',
unistr('- \5DF2\66FF\6B64\9060\7AEF\4F3A\670D\5668\7684\5C6C\6027\8A2D\5B9A APEX_APPLICATION_INSTALL.'),
unistr('- \8ACB\6CE8\610F, \5176\4ED6\61C9\7528\7A0B\5F0F\4E5F\4F7F\7528\6B64\9060\7AEF\4F3A\670D\5668\7269\4EF6.'),
'',
unistr('\56E0\6B64, \5DE5\4F5C\5340\9060\7AEF\4F3A\670D\5668\5C6C\6027\5DF2\7D93\66F4\65B0.'),
unistr('- \57FA\790E URL:      %1'),
unistr('- HTTPS \4E3B\6A5F:    %2'),
unistr('- ORDS \6642\5340: %3')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109903872833314074)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_2'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9060\7AEF\4F3A\670D\5668 "%0" (\975C\614B ID) \8B66\544A.'),
'',
unistr('- PROMPT_ON_INSTALL \5C6C\6027\8A2D\70BA YES.'),
unistr('- \5C1A\672A\91DD\5C0D\4EFB\4F55\5C6C\6027\63D0\4F9B APEX_APPLICATION_INSTALL.'),
'',
unistr('\56E0\6B64, \5DE5\4F5C\5340\9060\7AEF\4F3A\670D\5668\8A2D\5B9A\503C\7DAD\6301\4E0D\8B8A.'),
unistr('- \57FA\790E URL:      %1'),
unistr('- HTTPS \4E3B\6A5F:    %2'),
unistr('- ORDS \6642\5340: %3'),
'',
unistr('\8ACB\4F7F\7528 APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER \8B8A\66F4\5C6C\6027.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109903720728314074)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_3'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9060\7AEF\4F3A\670D\5668 "%0" (\975C\614B ID) \8B66\544A.'),
'',
unistr('- PROMPT_ON_INSTALL \5C6C\6027\8A2D\70BA NO.'),
unistr('- \61C9\7528\7A0B\5F0F\532F\5165\6A94\6848\7684\8A2D\5B9A\503C\8207\73FE\6709\7684\5C6C\6027\4E0D\540C.'),
unistr('- \6B64\5DE5\4F5C\5340\4E2D\7684\5176\4ED6\61C9\7528\7A0B\5F0F\4E5F\4F7F\7528\6B64\9060\7AEF\4F3A\670D\5668.'),
'',
unistr('\56E0\6B64, \5DE5\4F5C\5340\9060\7AEF\4F3A\670D\5668\8A2D\5B9A\503C\7DAD\6301\4E0D\8B8A.'),
unistr('- \57FA\790E URL:      %1'),
unistr('- HTTPS \4E3B\6A5F:    %2'),
unistr('- ORDS \6642\5340: %3'),
'',
unistr('\8ACB\4F7F\7528 APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER \8B8A\66F4\5C6C\6027.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109451237929313714)
,p_name=>'WWV_FLOW_API.REPLACE_SCRIPT_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\4EE3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109689438499313909)
,p_name=>'WWV_FLOW_API.SAME_SOURCE_IDENTIFIER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\4E0D\80FD\5C07\610F\898B\56DE\994B\532F\5165\76F8\540C\7684\7CFB\7D71\4E2D!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109451577684313715)
,p_name=>'WWV_FLOW_API.SCRIPT_EXCEEDS_MAX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\547D\4EE4\6A94\5927\5C0F %0 \4F4D\5143\7D44, \8D85\904E\5141\8A31\7684\5927\5C0F\4E0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109025146544313390)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8A2D\5B9A\5957\88DD\7A0B\5F0F\8B8A\6578 e g_security_group_id.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109021706039313387)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET_IMPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8A2D\5B9A\5957\88DD\7A0B\5F0F\8B8A\6578 g_security_group_id, \624D\80FD\532F\5165\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109021305085313387)
,p_name=>'WWV_FLOW_API.UNKOWN_API_VERSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\60A8\5F15\64CE\7684\4E0A\4E00\500B API \7248\672C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109021268940313387)
,p_name=>'WWV_FLOW_API.UNKOWN_ENGINE_VERSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\60A8\7684\5F15\64CE\7248\672C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109021407819313387)
,p_name=>'WWV_FLOW_API.UPGRADE_NEEDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\9700\8981\5347\7D1A\624D\80FD\532F\5165\6B64\61C9\7528\7A0B\5F0F\532F\51FA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109689337400313909)
,p_name=>'WWV_FLOW_API.WRONG_DEPLOYMENT_SYSTEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C1A\672A\532F\51FA\6B64\90E8\7F72\7CFB\7D71\7684\610F\898B\56DE\994B!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108893713929313282)
,p_name=>'WWV_FLOW_AUTOMATION.CANNOT_COPY_WSM_AUTOMATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5F9E\53E6\4E00\500B\61C9\7528\7A0B\5F0F\8907\88FD\53C3\7167 REST \8CC7\6599\4F86\6E90\7684\81EA\52D5\5316.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108892103413313281)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.NEW_ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109070228984313423)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.PLSQL_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165\300C\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578\4E3B\9AD4\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109070139257313423)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.QUERY_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165\300CSQL \67E5\8A62\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109070355805313423)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.REMOTE_SERVER_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165\300C\555F\7528 REST \7684 SQL \670D\52D9\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109070034185313423)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.TABLE_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165\300C\8868\683C\540D\7A31\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109070452785313423)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.WEB_SRC_MODULE_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165\300CREST \8CC7\6599\4F86\6E90\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109070584552313423)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.WHERE_ORDERBY_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165 WHERE \6216 ORDER BY \5B50\53E5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109125623006313465)
,p_name=>'WWV_FLOW_BUILDER.APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109141937687313477)
,p_name=>'WWV_FLOW_BUILDER.NO_FLOW_SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9078\53D6\4EFB\4F55\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109125939009313465)
,p_name=>'WWV_FLOW_BUILDER.NO_PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<span class="tiny">\627E\4E0D\5230\9801\9762.</font>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109125776235313465)
,p_name=>'WWV_FLOW_BUILDER.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109126085653313465)
,p_name=>'WWV_FLOW_BUILDER.PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 <font size=-2>\9801\9762</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109312240907313609)
,p_name=>'WWV_FLOW_BUILDER.PAGE_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\6578:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109312372601313609)
,p_name=>'WWV_FLOW_BUILDER.PAGE_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109125879458313465)
,p_name=>'WWV_FLOW_BUILDER.PLSQL_LINES_SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL %0 %1 \5305\542B %2 \884C\7684\539F\59CB\7A0B\5F0F\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109560906338313800)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.CODE_COMPLETION_NOT_SUPPORTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9060\7AEF SQL \4E0D\652F\63F4\7A0B\5F0F\78BC\5B8C\6210.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109560280235313800)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.QUERY_BUILDER_NOT_SUPPORTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9060\7AEF SQL \4E0D\652F\63F4\67E5\8A62\7522\751F\5668.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109158482803313489)
,p_name=>'WWV_FLOW_BUILDER.UPDATABLE_REPORT_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EF\66F4\65B0\7684\5831\8868\5256\6790\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110093363704314210)
,p_name=>'WWV_FLOW_BUTTON.REDIRECT_TO_PAGE_MODE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5F9E\300C\5C0D\8A71\65B9\584A\300D\9801\9762\91CD\65B0\5C0E\5411\81F3\300C\4E00\822C\300D\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109130394756313468)
,p_name=>'WWV_FLOW_CACHE.OBSOLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\518D\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109130276416313468)
,p_name=>'WWV_FLOW_CACHE.PURGE_DUP_SESSIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5C07 %0 \500B\91CD\8907\7684\968E\6BB5\4F5C\696D\6C38\4E45\6E05\9664.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109098648412313444)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_CHG_ONLY_YOURS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\53EA\80FD\8B8A\66F4\81EA\5DF1\7684\5BC6\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109098895771313444)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\60A8\7684\8B8A\66F4\5BC6\78BC\8981\6C42\6642\767C\751F\672A\9810\671F\7684\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109098327476313444)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NOT_SUPPLIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165\5BC6\78BC\548C\78BA\8A8D\5BC6\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109098410889313444)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NO_MATCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC\4E0D\76F8\7B26, \8ACB\518D\8A66\4E00\6B21.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109099494351313445)
,p_name=>'WWV_FLOW_CHECK.ERR_ORCL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle \932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109099112264313445)
,p_name=>'WWV_FLOW_CHECK.ERR_PROC_PLSQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1025 \8655\7406 PLSQL \8868\793A\5F0F\6642\767C\751F\932F\8AA4.  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108990030190313358)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\6210\54E1\5C6C\6027\7DE8\865F %0 \7121\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109130797838313468)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_EXISTS_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684 exists/not exists \689D\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109130504080313468)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_FUNC_BODY_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\51FD\6578\4E3B\9AD4\689D\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109130465230313468)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_PLSQL_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684 PL/SQL \8868\793A\5F0F\689D\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109130694532313468)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_SQL_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684 SQL \8868\793A\5F0F\689D\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109144877971313479)
,p_name=>'WWV_FLOW_COPY.EXECUTION_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C wwv_flow_copy \6642\767C\751F\932F\8AA4: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108879803924313272)
,p_name=>'WWV_FLOW_COPY.INVALID_TRANSLATED_APPLICATION_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FFB\8B6F\7684\300C\61C9\7528\7A0B\5F0F ID\300D\7121\6548. \6B64\300C\61C9\7528\7A0B\5F0F ID\300D\6B63\7531\73FE\6709\7684\61C9\7528\7A0B\5F0F\6240\4F7F\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109144793734313479)
,p_name=>'WWV_FLOW_COPY.NO_SGID_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\8A2D\5B9A\300C\5B89\5168\6027\7FA4\7D44 ID\300D(\60A8\7684\5DE5\4F5C\5340\8B58\5225).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109432484125313699)
,p_name=>'WWV_FLOW_COPY_METADATA.COMPATIBILITY_MODE_210200'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F "%0" \76F8\5BB9\6A21\5F0F\81F3\5C11\5FC5\9808\662F 21.2, \624D\80FD\91CD\65B0\6574\7406\4E3B\984C. \60A8\53EF\4EE5\5F9E\300C\61C9\7528\7A0B\5F0F\5B9A\7FA9\300D\4E4B\4E0B\7684\300C\7279\6027\300D\8B8A\66F4\76F8\5BB9\6A21\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110129160981314255)
,p_name=>'WWV_FLOW_COPY_METADATA.INCOMPATIBLE_THEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\4E3B\984C\8207\9078\53D6\7684\4E3B\8981\4E3B\984C\4E0D\76F8\5BB9, \4E3B\984C ID \4E0D\76F8\7B26.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109557894826313794)
,p_name=>'WWV_FLOW_COPY_METADATA.PARENT_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\91CD\65B0\6574\7406\6A23\677F, \627E\4E0D\5230\7236\9805\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108998095475313369)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_AUTH_SETUP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\6CD5\516C\5E03\8A8D\8B49\914D\7F6E. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108997442215313369)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_BUTTON_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\6CD5\516C\5E03\6309\9215\6A23\677F. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109151663286313484)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_CAL_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\6CD5\516C\5E03\884C\4E8B\66C6\6A23\677F. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108997213663313369)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_FIELD_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\516C\5E03\6B04\4F4D\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108998163788313369)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_ITEM_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\6CD5\516C\5E03\9805\76EE\8AAA\660E. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108997082103313369)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LIST_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\516C\5E03\6E05\55AE\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108997954292313369)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\6CD5\516C\5E03\6578\503C\6E05\55AE. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108997515468313369)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_MENU_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\6CD5\516C\5E03\300C\5C0E\89BD\8DEF\5F91\300D\6A23\677F. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108997861742313369)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_NAVBAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\516C\5E03\5C0E\89BD\5217. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108996882264313369)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_PAGE_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\516C\5E03\9801\9762\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108997319202313369)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\516C\5E03\5373\73FE\5F0F\300C\6578\503C\6E05\55AE\300D\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108996980381313369)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REGION_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\516C\5E03\5340\57DF\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108997177921313369)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REPORT_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\516C\5E03\5831\8868\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108997678477313369)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SECURITY_SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\516C\5E03\5B89\5168\6027\914D\7F6E. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108997705499313369)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SHORTCUT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\6CD5\516C\5E03\6377\5F91. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108995222869313367)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_AUTH_SETUP_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664\8A8D\8B49\914D\7F6E\53C3\7167 ID. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108994107752313366)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_BUTTON_TEMPLATE_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664\6309\9215\6A23\677F\53C3\7167 ID. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109151556496313484)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_CAL_TEMPLATE_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\6CD5\8A02\95B1\884C\4E8B\66C6\6A23\677F. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108993458753313366)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_FIELD_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664\6B04\4F4D\53C3\7167 ID. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108995302532313367)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_ITEM_HELP_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664\9805\76EE\8AAA\660E\53C3\7167 ID. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108993282230313366)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LIST_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664\6E05\55AE\53C3\7167 ID. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108993832849313366)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LOV_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664\300C\503C\6E05\55AE\300D\53C3\7167 ID. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108994025268313366)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_MENU_TEMPLATE_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664\300C\5C0E\89BD\8DEF\5F91\300D\6A23\677F\53C3\7167 ID. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108993785218313366)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_NAVBAR_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664\5C0E\89BD\5217\53C3\7167 ID. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108993093361313365)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_PAGE_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664\9801\9762\53C3\7167 ID. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108993934231313366)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_POPUP_LOV_TEMPLATE_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664\5373\73FE\5F0F\300C\503C\6E05\55AE\300D\6A23\677F\53C3\7167 ID. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108993163555313365)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REGION_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664\5340\57DF\53C3\7167 ID. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108993311986313366)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REPORT_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664\5831\8868\53C3\7167 ID. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108993565543313366)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SECURITY_SCHEME_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664\5B89\5168\6027\914D\7F6E\53C3\7167 ID. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108993644664313366)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SHORTCUT_REFERENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664\6377\5F91\53C3\7167 ID. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108996621668313368)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_AUTH_SETUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A02\95B1\8A8D\8B49\914D\7F6E. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108996154114313368)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_BUTTON_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A02\95B1\6309\9215\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110088928215314206)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_CAL_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A02\95B1\884C\4E8B\66C6\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108995883605313368)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_FIELD_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A02\95B1\6B04\4F4D\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108996777597313368)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_ITEM_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A02\95B1\9805\76EE\8AAA\660E. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108995678871313368)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LIST_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A02\95B1\6E05\55AE\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108996568564313368)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A02\95B1\300C\503C\6E05\55AE\300D. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108996061447313368)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_MENU_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A02\95B1\5C0E\89BD\8DEF\5F91\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108996412688313368)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_NAVBAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A02\95B1\5C0E\89BD\5217. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108995454659313367)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_PAGE_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A02\95B1\9801\9762\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108995929938313368)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_POPUP_LOV_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A02\95B1\300C\5373\73FE\5F0F\503C\6E05\55AE\6A23\677F\300D. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108995521277313367)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REGION_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A02\95B1\5340\57DF\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108995704581313368)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REPORT_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A02\95B1\5831\8868\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108996282950313368)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SECURITY_SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A02\95B1\5B89\5168\6027\914D\7F6E. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108996324239313368)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SHORTCUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A02\95B1\6377\5F91. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110068042435314191)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_THEME_OPTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A02\95B1\4E3B\984C\9078\9805. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109158933721313490)
,p_name=>'WWV_FLOW_COPY_PAGE.EXECUTION_PAGE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C wwv_flow_copy_page \6642\767C\751F\932F\8AA4: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109145070648313479)
,p_name=>'WWV_FLOW_COPY_PAGE_ITEM.EXECUTION_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C wwv_flow_copy_page_item \6642\767C\751F\932F\8AA4: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109018043518313384)
,p_name=>'WWV_FLOW_COPY_UTIL.OBJ_NOT_FOUND_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\8981\8907\88FD\7684 %0 (%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109345338472313633)
,p_name=>'WWV_FLOW_COPY_UTIL.SHORTCUT_NAME_UNAVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31\70BA %0 \7684\6377\5F91\5DF2\7D93\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109145429503313479)
,p_name=>'WWV_FLOW_COPY_UTIL.UNABLE_TO_FIND_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\8981\8907\88FD\7684\6377\5F91 (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109146484531313480)
,p_name=>'WWV_FLOW_CREATE_FLOW.CREATE_RPT_TEMPLATE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\5EFA\7ACB\5831\8868\6A23\677F) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109147040537313481)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COMPUTE_TAB_TARGET_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\904B\7B97\9801\7C64\76EE\6A19) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109150357562313483)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHENTICATION_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\8907\88FD\8A8D\8B49\914D\7F6E) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109150261749313483)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHORIZATION_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\8907\88FD\6388\6B0A\914D\7F6E) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109147894112313481)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_BUTTON_TEMPLATE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\8907\88FD\6309\9215\6A23\677F) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109147353159313481)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_FIELD_TEMPLATE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\8907\88FD\6B04\4F4D\6A23\677F) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109147623299313481)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LIST_TEMPLATE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\8907\88FD\6E05\55AE\6A23\677F) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109148028401313481)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LOV_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\8907\88FD\300C\503C\6E05\55AE\300D) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109147789013313481)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_MENU_TEMPLATE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\8907\88FD\5C0E\89BD\8DEF\5F91\6A23\677F) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109147981747313481)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_NAVBAR_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\8907\88FD\5C0E\89BD\5217) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109147240914313481)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_PAGE_TEMPLATE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\8907\88FD\9801\9762\6A23\677F) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109147513275313481)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REGION_TEMPLATE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\8907\88FD\5340\57DF\6A23\677F) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109147492416313481)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REPORT_TEMPLATES_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\8907\88FD\5831\8868\6A23\677F) \6642\767C\751F\932F\8AA4: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109148103406313481)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_SECURITY_SCHEME_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\8907\88FD\5B89\5168\6027\914D\7F6E) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109146361617313480)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_FIELD_TEMPLATE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\5EFA\7ACB\6B04\4F4D\6A23\677F) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109146666680313480)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_LIST_TEMPLATE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\5EFA\7ACB\6E05\55AE\6A23\677F) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109146739572313480)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_MENU_TEMPLATE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\5EFA\7ACB\5C0E\89BD\8DEF\5F91\6A23\677F) \6642\767C\751F\932F\8AA4: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109146192458313480)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PAGE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\5EFA\7ACB\9801\9762) \6642\767C\751F\932F\8AA4: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109147107273313481)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PARENT_TABS_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\5EFA\7ACB\7236\9805\9801\7C64) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109146270881313480)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PG_TEMPLATE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\5EFA\7ACB\9801\9762\6A23\677F) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109146873982313480)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_POPUP_TEMPLATE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\5EFA\7ACB\300C\5373\73FE\5F0F\503C\6E05\55AE\6A23\677F\300D) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109146571318313480)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_REGION_TEMPLATE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\5EFA\7ACB\5340\57DF\6A23\677F) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109146945223313480)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_STANDARD_TABS_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\61C9\7528\7A0B\5F0F (\5EFA\7ACB\6A19\6E96\9801\7C64) \6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109146052348313480)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.VERIFY_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49 %0 \932F\8AA4: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109345155616313633)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.ADD_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109345032701313633)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.APPLY_MRD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528 MRD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109344960302313633)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.APPLY_MRU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528 MRU')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109332289043313624)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109409977254313682)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_FORM_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\8868\55AE\9801\9762. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109436487889313703)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_GLOBAL_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\5168\57DF\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109920841338314086)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_IG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\4E92\52D5\5F0F\65B9\683C\9801\9762. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109410163507313683)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\9801\9762\932F\8AA4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109410032936313682)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_TABULAR_FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\5217\8868\5316\8868\55AE\9801\9762. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109410236345313683)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.FETCH_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E %0 \64F7\53D6\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109453603651313716)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.GET_USERNAME_COOKIE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\5F97\4F7F\7528\8005\540D\7A31 Cookie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109549693636313788)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.MENUBAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0E\89BD\529F\80FD\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109409522449313682)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\529F\80FD\8868\9801\9762 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109410309418313683)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.PROCESS_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406 %0 \7684\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109498603675313749)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RELEASE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7248\6B21 %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109337881824313628)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RESET_HIDDEN_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D\96B1\85CF\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109331366927313623)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RESET_RPT_SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D\5831\8868\641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109426189022313695)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RPT_MAX_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\9801\7684\5831\8868\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109422235106313692)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RUNNING_SCRIPT_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\547D\4EE4\6A94:%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109453542108313716)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.SET_USERNAME_COOKIE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\4F7F\7528\8005\540D\7A31 Cookie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109339011258313629)
,p_name=>'WWV_FLOW_CREDENTIAL.INVALID_CONTEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\5F9E\61C9\7528\7A0B\5F0F\968E\6BB5\4F5C\696D\5167\547C\53EB\6B64\7A0B\5E8F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108900799097313288)
,p_name=>'WWV_FLOW_CREDENTIAL.NOT_VALID_FOR_URL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64 URL \7AEF\9EDE\4E0D\5141\8A31\4F7F\7528\8B49\660E\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108894258644313283)
,p_name=>'WWV_FLOW_CREDENTIAL.URL_MUST_START_WITH_HTTP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\4E2D\7684 URL \5FC5\9808\4EE5 http:// \6216 https:// \70BA\958B\982D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109439520843313705)
,p_name=>'WWV_FLOW_CREDENTIAL_DEV.CREDENTIALS_FOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \7684\8B49\660E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109148324600313482)
,p_name=>'WWV_FLOW_CSS_API.UNABLE_TO_REMOVE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664 css: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109454208082313717)
,p_name=>'WWV_FLOW_CSS_CALENDAR.DRAG_DROP_NOT_SUPPORTED_FOR_WEB_SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \8CC7\6599\4F86\6E90\4E0D\652F\63F4\62D6\653E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109129871576313468)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_APPLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528\8B8A\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109011311721313379)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\611F\6E2C\51FD\6578\6703\5C07\5167\5EFA\968E\6BB5\4F5C\696D\9A57\8B49\6AA2\67E5\7684\5E03\6797\503C\7D50\679C\50B3\56DE\7D66\5F15\64CE. \5982\679C\7D50\679C\70BA True, \5F15\64CE\5C07\6703\7E7C\7E8C\986F\793A\6216\63A5\53D7\9801\9762. \5982\679C\7D50\679C\70BA False, \5F15\64CE\5C07\6703\91CD\65B0\5C0E\5411\81F3\6B64\8A8D\8B49\914D\7F6E\4E2D\6307\5B9A\4E4B\7121\6548\7684\968E\6BB5\4F5C\696D\9801\9762\6216 URL (\53C3\898B\4E0B\65B9).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109012632382313380)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION10'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\9801\9762\611F\6E2C\51FD\6578\50B3\56DE TRUE, \5247\6703\7E7C\7E8C\63D0\51FA\6216\8655\7406\9801\9762. \5982\679C\7D50\679C\70BA FALSE, \5247\5F15\64CE\5FC5\9808\7D50\675F, \56E0\70BA\8A8D\8B49\914D\7F6E\4E2D\672A\6307\5B9A\7121\6548\7684\968E\6BB5\4F5C\696D\76EE\6A19. \5728\6B64\60C5\6CC1\4E0B, \4F7F\7528\8005\63D0\4F9B\7684\9801\9762\611F\6E2C\51FD\6578\6703\5047\5B9A\5DF2\91CD\65B0\5C0E\5411\81F3 %0 \74B0\5883\5916\7684\67D0\4E00\500B\767B\5165\9801\9762, \6709\53EF\80FD\662F\4E00\500B\5916\90E8\8A8D\8B49\5165\53E3\7DB2\7AD9. \6B64\51FD\6578\4E5F\6703\8A2D\5B9A\5168\57DF\8B8A\6578 g_unrecoverable_error := true \4F86\6307\793A\5F15\64CE\7D50\675F (\4E0D\986F\793A\932F\8AA4\8A0A\606F\9801\9762).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109012788134313381)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION11'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F15\64CE\5C07\6703\57F7\884C\4E0B\5217\7A0B\5F0F\78BC, \9019\4E9B\7A0B\5F0F\78BC\662F\6307\5B9A\4F5C\70BA\6B64\8A8D\8B49\914D\7F6E\7684\8A8D\8B49\524D\8655\7406\4F5C\696D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109012885655313381)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION12'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\662F\4EE5\6C92\6709\50B3\56DE\503C\7684\533F\540D\5340\584A\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109012904765313381)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION13'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\914D\7F6E\4E2D\672A\6307\5B9A\81EA\8A02\8A8D\8B49\524D\7A0B\5F0F\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109013148165313381)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION14'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EFB\4F55\8F38\5165\767B\5165\8868\55AE\4E2D\7684\4F7F\7528\8005\540D\7A31/\5BC6\78BC\7D44\5408\90FD\6703\88AB\8996\70BA\6709\6548. \8F38\5165\7684\4F7F\7528\8005\540D\7A31\5C07\6703\4F5C\70BA\5DF2\767B\5165\4E4B\4F7F\7528\8005\5728\6574\500B\968E\6BB5\4F5C\696D\671F\9593\7684\540D\7A31. \9019\9805\6280\8853\5C0D\4ECD\5728\958B\767C\61C9\7528\7A0B\5F0F\800C\5C1A\672A\5EFA\7ACB\4EFB\4F55\5BE6\969B\7684\4F7F\7528\8005\5E33\6236\968E\6BB5\975E\5E38\6709\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109013236308313381)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\7167\61C9\7528\7A0B\5F0F\7522\751F\5668(Cookie \4F7F\7528\8005) \5E33\6236, \6AA2\67E5\5728\767B\5165\8868\55AE\4E2D\8F38\5165\7684\4F7F\7528\8005\540D\7A31\548C\5BC6\78BC. \9019\4E9B\5E33\6236\548C\60A8\5DE5\4F5C\5340\4E2D\7528\4F86\767B\5165 %0 \7684\5E33\6236\76F8\540C. \9019\9805\6280\8853\5728\60A8\61C9\7528\7A0B\5F0F\7684\4F7F\7528\8005\662F\958B\767C\4EBA\54E1, \800C\4E14\4ED6\5011\5728\76F8\540C\7684\8CC7\6599\5EAB\548C\5DE5\4F5C\5340\90FD\6709 %0 \5E33\6236\6642\975E\5E38\6709\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108945558848313322)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15A'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\8F38\5165\767B\5165\8868\55AE\4E2D\7684\4F7F\7528\8005\540D\7A31\548C\5BC6\78BC\8207 Oracle Database \5E33\6236\9032\884C\6AA2\67E5. \9019\9805\6280\8853\5728\60A8\61C9\7528\7A0B\5F0F\7684\4F7F\7528\8005\6709\8CC7\6599\5EAB\5E33\6236\6642\975E\5E38\6709\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109013373832313381)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION16'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\6B64\8A8D\8B49\914D\7F6E\4E2D\6307\5B9A\7684 LDAP \76EE\9304\4F86\6AA2\67E5\8F38\5165\767B\5165\8868\55AE\4E2D\7684\4F7F\7528\8005\540D\7A31\548C\5BC6\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109013478108313381)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION17'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('LDAP \53C3\6578\8A2D\5B9A\6210:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109014123220313382)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION18'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\4E0B\5217\7684\81EA\8A02\7A0B\5F0F\78BC\4F86\9A57\8B49\8B49\660E\8CC7\6599:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109014311847313382)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION19'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\67E5\5167\5EFA\968E\6BB5\4F5C\696D\8868\683C\5167\662F\5426\6709\5167\5EFA\767B\5165\9801\9762\6240\4F7F\7528\7684\968E\6BB5\4F5C\696D. \5982\679C\968E\6BB5\4F5C\696D\5B58\5728\800C\4E14\672A\88AB\5176\4ED6\4F7F\7528\8005\64C1\6709, \8ACB\7ACB\5373\5C07\5B83\6A19\8A18\6210\70BA\8A8D\8B49\7684\4F7F\7528\8005 (\4F7F\7528\767B\5165\8868\55AE\7684\4F7F\7528\8005\540D\7A31) \64C1\6709.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109011486786313380)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\611F\6E2C\51FD\6578\6703\5C07\5167\5EFA\968E\6BB5\4F5C\696D\9A57\8B49\6AA2\67E5\7684\5E03\6797\503C\7D50\679C\4EE5\53CA\4F7F\7528\8005\63D0\4F9B\4E4B\968E\6BB5\4F5C\696D\9A57\8B49\6AA2\67E5\7684\7D50\679C\50B3\56DE\7D66\5F15\64CE. \5982\679C\7D50\679C\70BA True, \5F15\64CE\5C07\6703\7E7C\7E8C\986F\793A\6216\63A5\53D7\9801\9762. \5982\679C\7D50\679C\70BA False, \5F15\64CE\5C07\6703\91CD\65B0\5C0E\5411\81F3\6B64\8A8D\914D\7F6E\8981\4E2D\6307\5B9A\4E4B\7121\6548\7684\968E\6BB5\4F5C\696D\76EE\6A19 (\53C3\898B\4E0B\65B9).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109014421048313382)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION20'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\540D\7A31\70BA %0 \7684 cookie \8A2D\6210\627E\5230\5167\90E8\968E\6BB5\4F5C\696D\8868\683C\4E2D\4E4B\8CC7\6599\5217\7684\4E00\500B\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109014507385313382)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION22'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C7A\5B9A\4E0B\4E00\500B\91CD\5C0E\76EE\6A19 URL. \5982\679C\5448\73FE\5F15\64CE\5148\524D\5728\968E\6BB5\4F5C\696D\72C0\614B\8A18\9304\300C\6DF1\5C64\9023\7D50\300D, \8ACB\4F7F\7528\5B83\4F5C\70BA\8981\524D\5F80\7684 URL. \5426\5247, \8ACB\524D\5F80\6307\5B9A\70BA\61C9\7528\7A0B\5F0F\4E4B\9996\9801\9023\7D50\5C6C\6027\7684 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109014729663313382)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION23'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\8B49\660E\8CC7\6599\4E4B\5F8C, \5F15\64CE\5C07\6703\57F7\884C\4E0B\5217\7A0B\5F0F\78BC, \9019\4E9B\7A0B\5F0F\78BC\662F\6307\5B9A\4F5C\70BA\6B64\8A8D\8B49\914D\7F6E\7684\8A8D\8B49\5F8C\8655\7406\4F5C\696D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109014863842313382)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION24'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9019\662F\4EE5\6C92\6709\50B3\56DE\503C\7684\533F\540D\5340\584A\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109014964153313382)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION25'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5728\6B64\914D\7F6E\4E2D\6307\5B9A\81EA\8A02\8A8D\8B49\5F8C\7A0B\5F0F\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109015010437313382)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION26'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\4EE5\4E0A\6240\6C7A\5B9A\7684 URL. \9019\6703\662F\4F7F\7528\5167\5EFA\767B\5165\9801\9762\548C\547C\53EB\4E4B API \767B\5165\7684\8655\7406\7D50\5C3E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109011551614313380)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\81EA\8A02\908F\8F2F\4F86\57F7\884C\9801\9762\611F\6E2C\5DE5\4F5C. \5C0D\65BC\6BCF\500B\9801\9762\8981\6C42, \5F15\64CE\5C07\6703\57F7\884C\4E0B\5217\7A0B\5F0F\78BC:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109011644815313380)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EE5\4E0A\4E4B\5340\584A\7684\5E03\6797\503C\7D50\679C\5C07\6703\50B3\56DE\7D66\5F15\64CE. \5982\679C\7D50\679C\70BA True, \5F15\64CE\5C07\6703\7E7C\7E8C\986F\793A\6216\63A5\53D7\9801\9762. \5982\679C\7D50\679C\70BA False, \5F15\64CE\5C07\6703\91CD\65B0\5C0E\5411\81F3\6B64\8A8D\914D\7F6E\8981\4E2D\6307\5B9A\4E4B\7121\6548\7684\968E\6BB5\4F5C\696D\76EE\6A19 (\53C3\898B\4E0B\65B9).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109011750116313380)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION5'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7528\65BC\968E\6BB5\4F5C\696D\9A57\8B49\7684\5167\5EFA\65B9\6CD5\53EF\4F9B\4F7F\7528 API \547C\53EB\7684 %0 \958B\767C\4EBA\54E1\4F7F\7528:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109011898616313380)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION6'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\5E03\6797\503C\51FD\6578\7D50\679C\53EF\4EE5\8207\4F7F\7528\8005\63D0\4F9B\4E4B\9801\9762\611F\6E2C\51FD\6578 (\5728\8A8D\8B49\914D\7F6E\4E2D\6307\5B9A) \4E2D\7684\5176\4ED6\52FE\9078\9805\76EE\7D50\5408. \5982\679C\547C\53EB\6B64 API, \5B83\6703\6AA2\67E5\540D\7A31\70BA %0 \7684 cookie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109011968840313380)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION7'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C cookie \5B58\5728, \800C\4E14\5B83\7684\89E3\5BC6\503C\5B9A\4F4D\5167\90E8\968E\6BB5\4F5C\696D\8868\683C\4E2D\7684\4E00\500B\8CC7\6599\5217, \5247\968E\6BB5\4F5C\696D\5C31\70BA\6709\6548, \4E26\4E14\6703\5C07 TRUE \503C\50B3\56DE\547C\53EB\5B83\7684\9801\9762\611F\6E2C\51FD\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109012165175313380)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION8'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\9801\9762\611F\6E2C\51FD\6578\50B3\56DE TRUE, \5247\6703\7E7C\7E8C\63D0\51FA\6216\8655\7406\9801\9762. \5982\679C\7D50\679C\70BA FALSE, \5F15\64CE\5C07\6703\986F\793A\9801\9762 %0, \7531\65BC\5B83\5728\6B64\8A8D\8B49\914D\7F6E\4E2D\4EE3\8868\7121\6548\7684\968E\6BB5\4F5C\696D\9801\9762, \56E0\6B64\9019\500B\986F\793A\7684\9801\9762\6703\88AB\8996\70BA\6B64\61C9\7528\7A0B\5F0F\7684\767B\5165\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109012577856313380)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION9'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\611F\6E2C\51FD\6578\6703\50B3\56DE\5E03\6797\503C\7D50\679C\7D66\5F15\64CE. \5982\679C\7D50\679C\70BA TRUE, \6703\7E7C\7E8C\986F\793A\6216\8655\7406\9801\9762. \5982\679C\7D50\679C\70BA FALSE, \5F15\64CE\6703\5C07\91CD\65B0\5C0E\5411\81F3 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109015177489313382)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C\662F\5728\9801\9762\5305\542B\8981\7528\65BC\64F7\53D6\4F7F\7528\8005\4E4B\8B49\660E\8CC7\6599\7684\767B\5165\8868\55AE. \7136\5F8C\9801\9762\7684\9001\51FA\5F8C\7E8C\8655\7406\4F5C\696D\6703\547C\53EB\8A8D\8B49\6A21\7D44\4F86\9A57\8B49\8B49\660E\8CC7\6599. \8A8D\8B49\4E4B\5F8C, \9801\9762\6703\57F7\884C\968E\6BB5\4F5C\696D\8A3B\518A\548C cookie \8A2D\5B9A\5DE5\4F5C. \6700\5F8C, \5B83\6703\91CD\65B0\5C0E\5411\81F3\61C9\7528\7A0B\5F0F\7684\958B\59CB\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109015253032313382)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\5F8C\7E8C\8655\7406\4F5C\696D\53EF\4EE5\547C\53EB %0 API: wwv_flow_custom_auth_std \4F86\57F7\884C\525B\624D\8AAA\660E\7684\9019\4E9B\6B65\9A5F. \6709\5169\500B\53EF\7528\7684\9032\5165\9EDE:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109015301393313382)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\547C\53EB\767B\5165\7A0B\5E8F\8B93\5F15\64CE\70BA\60A8\57F7\884C\6240\6709\7684\6B65\9A5F. \5F15\64CE\5C07\6703\4F7F\7528\5167\5EFA\968E\6BB5\4F5C\696D\8868\683C\4E26\4E14\70BA\60A8\57F7\884C\968E\6BB5\4F5C\696D\8A3B\518A\548C cookie \8A2D\5B9A. \60A8\5728\6B64\8A8D\8B49\914D\7F6E\63D0\4F9B\7684\81EA\8A02\7A0B\5F0F\78BC\5C07\6703\5728\8A8D\8B49\524D\3001\8A8D\8B49\6216\8A8D\8B49\5F8C\7684\5404\500B\9EDE\4F86\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109015471300313382)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5982\679C\60A8\81EA\884C\57F7\884C\8A8D\8B49, \4F46\8981 %0 \66FF\60A8\8655\7406\6240\6709\7684\8A8D\8B49\5F8C\5DE5\4F5C, \8ACB\547C\53EB post_login \7A0B\5E8F. \85C9\7531\9019\5169\500B\9032\5165\9EDE, \60A8\53EF\4EE5\5C07\4EFB\4E00\5167\5EFA\767B\5165\8655\7406\6B65\9A5F\8207\60A8\81EA\5DF1\7684\767B\5165\9801\9762\548C\5728\5176\4E0A\57F7\884C\7684\4EFB\4F55\8655\7406\4F5C\696D\4E00\8D77\4F7F\7528. \8ACB\8A18\4F4F, \5982\679C\60A8\4F7F\7528\5167\5EFA\7684\8A8D\8B49\5F8C\8655\7406, \60A8\4FBF\53EF\4EE5\5229\7528\5167\5EFA\9801\9762\611F\6E2C\4EE5\53CA\968E\6BB5\4F5C\696D\9A57\8B49\8655\7406.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109012270978313380)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.BUILTIN_LOGIN_PG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5EFA\7684\767B\5165\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109015572901313383)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\90E8\767B\5165\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109016319375313383)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN12'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\5165 URL %0 \672A\5C07 %1 \61C9\7528\7A0B\5F0F\9801\9762\6307\5B9A\70BA\7121\6548\7684\968E\6BB5\4F5C\696D\76EE\6A19. \6B64\5916, \8A8D\8B49\914D\7F6E\4E2D\4E5F\6C92\6709\767B\5165\8655\7406\503C. \6B64\9801\9762\4E3B\8981\662F\57F7\884C\4E0B\5217\6B65\9A5F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109016454227313383)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN13'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\6CE8\610F, \9664\975E\5728\6B64 URL \555F\52D5\7684\670D\52D9\4F7F\7528 %0 wwv_custom_auth_std API \4F86\5354\52A9\968E\6BB5\4F5C\696D\8A3B\518A\5DE5\4F5C, \5426\5247\60A8\7684\61C9\7528\7A0B\5F0F\5C07\7121\6CD5\4F7F\7528\5167\5EFA\7684\9801\9762\611F\6E2C\6216\968E\6BB5\4F5C\696D\9A57\8B49\8655\7406. \60A8\5FC5\9808\4F7F\7528\81EA\5DF1\8A2D\8A08\7684\65B9\6CD5\4F86\57F7\884C\9019\9805\5DE5\4F5C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109016708309313383)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN14'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\5165 URL %0 \672A\5C07 %1 \61C9\7528\7A0B\5F0F\9801\9762\6307\5B9A\70BA\7121\6548\7684\968E\6BB5\4F5C\696D\76EE\6A19. \6B64\9801\9762\8CA0\8CAC\57F7\884C\4E0B\5217\6B65\9A5F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109016804978313384)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN15'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\5217\662F\70BA\8A8D\8B49\914D\7F6E\4E2D\4E4B\767B\5165\8655\7406\6240\8A2D\5B9A\7684\503C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109016962881313384)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN16'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\914D\7F6E\4E2D\6307\5B9A\7684\767B\5165\9801\9762\662F\6B64\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762 [%0]. \6B64\9801\9762\8CA0\8CAC\57F7\884C\4E0B\5217\6B65\9A5F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109017020417313384)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN17'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F46\662F, \8A8D\8B49\914D\7F6E\4E2D\6C92\6709\767B\5165\8655\7406\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109017188578313384)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN18'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7531\65BC\6B64\9801\9762\662F\61C9\7528\7A0B\5F0F\7684\6307\5B9A\767B\5165\9801\9762, \56E0\6B64\7576\9801\9762\7B2C\4E00\6B21\986F\793A\6642, \7121\6CD5\5728\9801\9762\57F7\884C\7279\5B9A\7684\52D5\4F5C, \539F\56E0\662F\5C1A\672A\9032\884C\4F7F\7528\8005\8A8D\8B49. \6B64\5916, \4E5F\6C92\6709\53EF\4F9B\7528\65BC\9801\9762\904B\7B97\6216\8655\7406\4F5C\696D\7684\7279\5B9A\968E\6BB5\4F5C\696D\72C0\614B\548C\968E\6BB5\4F5C\696D\8B58\5225\8B8A\6578, \56E0\70BA\9019\4E9B\9805\76EE\53EF\80FD\5728\8A8D\8B49\5F8C\8655\7406\7684\4E00\822C\9801\9762\4E2D. \56E0\70BA\9019\4E9B\539F\56E0, \6309\67D0\500B\8A8D\8B49\914D\7F6E\4E2D\4E4B\9801\78BC\7684\767B\5165\9801\9762\8A2D\5B9A\53EA\9069\5408\9664\4E86\767B\5165\8868\55AE\8655\7406\5916, \6C92\6709\5176\4ED6 (\6216\5F88\5C11) \529F\80FD\7684\9801\9762. \5982\679C\60A8\8981\8B93\60A8\7684\767B\5165\9801\9762\6709\8F03\591A\7684\529F\80FD, \8ACB\4F7F\7528\8A8D\8B49\914D\7F6E\7CBE\9748\4E2D\7684\6307\5B9A\7684\767B\5165 URL \6216\7DE8\8F2F\9801\9762. \53EA\8981\60A8\8A18\5F97\4F7F\7528\300C\7522\751F\5668\300D\4E2D\7684\9801\9762\5C6C\6027\8868\55AE, \5C07')
||unistr('\516C\7528\9801\9762\5C6C\6027\8A2D\6210\300C\662F - \6B64\9801\9762\70BA\516C\7528\300D, \767B\5165\9801\9762\5C31\53EF\4EE5\4F7F\7528\5B8C\6574\7684 %0 \529F\80FD (\9664\4E86\7576\4F5C\60A8\61C9\7528\7A0B\5F0F\4E2D\7684\767B\5165\9801\9762\4E4B\5916).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109015618409313383)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8A8D\8B49\914D\7F6E\4E26\672A\6307\5B9A\8981\7528\65BC\7121\6548\4E4B\968E\6BB5\4F5C\696D\76EE\6A19\7684\767B\5165\9801\9762\6216 URL. \9019\8868\793A\6703\4F7F\7528\9801\9762\611F\6E2C\51FD\6578\4F86\8655\7406\6B64\60C5\6CC1. \6216\8A31\5B83\6703\91CD\65B0\5C0E\5411\81F3\55AE\4E00\767B\5165\5165\53E3\7DB2\7AD9\6216\5176\4ED6\767B\5165\4F3A\670D\5668. \6B64\5916, \8A8D\8B49\914D\7F6E\4E2D\4E5F\6C92\6709\767B\5165\8655\7406\503C. \5982\679C\9019\4E0D\662F\60A8\8981\7684, \8ACB\7DE8\8F2F\6B64\8A8D\8B49\914D\7F6E\4E26\63D0\4F9B\7121\6548\7684\968E\6BB5\4F5C\696D\9801\9762\6216 URL, \7136\5F8C\518D\6B21\6AA2\67E5\6B64\5716\8868\6AA2\8996.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109015749604313383)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8A8D\8B49\914D\7F6E\4E26\672A\6307\5B9A\8981\7528\65BC\7121\6548\4E4B\968E\6BB5\4F5C\696D\76EE\6A19\7684\767B\5165\9801\9762\6216 URL. \9019\8868\793A\6703\4F7F\7528\9801\9762\611F\6E2C\51FD\6578\4F86\8655\7406\6B64\60C5\6CC1. \6216\8A31\5B83\6703\91CD\65B0\5C0E\5411\81F3\55AE\4E00\767B\5165\5165\53E3\7DB2\7AD9\6216\5176\4ED6\767B\5165\4F3A\670D\5668. \7136\800C, \8A8D\8B49\914D\7F6E\4E2D\6709\70BA\767B\5165\8655\7406\8A2D\5B9A\7684\503C, \5982\4E0B\6240\793A:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109015857694313383)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\5165 URL:%0 \5DF2\7D93\5C07 %1 \61C9\7528\7A0B\5F0F\9801\9762\6307\5B9A\70BA\7121\6548\7684\968E\6BB5\4F5C\696D\76EE\6A19. \4E0D\904E, \8A8D\8B49\914D\7F6E\4E2D\6C92\6709\767B\5165\8655\7406\503C. \6B64\9801\9762\8CA0\8CAC\57F7\884C\4E0B\5217\6B65\9A5F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109015962377313383)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN6'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\8981\8B93 %0 \5F15\64CE\80FD\5920\986F\793A\6216\63A5\53D7\60A8\61C9\7528\7A0B\5F0F\7684\767B\5165\9801\9762, \60A8\5FC5\9808\5728\61C9\7528\7A0B\5F0F\7522\751F\5668\7684\300C\9801\9762\5C6C\6027\300D\9801\9762\4E2D\9078\53D6\300C\662F - \6B64\9801\9762\70BA\516C\7528\300D\9801\9762\5C6C\6027. \5982\679C\672A\9078\53D6, \5F15\64CE\5C07\6703\5728\986F\793A\9801\9762\4E4B\524D\5617\8A66\57F7\884C\9801\9762\611F\6E2C\51FD\6578. \5982\679C\60A8\5C1A\672A\767B\5165, \5C07\6703\5617\8A66\91CD\65B0\5C0E\5411\81F3\76F8\540C\7684 URL. \9019\5C07\6703\9020\6210\4E0D\61C9\8A72\767C\751F\7684\8FF4\8DEF. \5982\679C\60A8\7DE8\5BEB\81EA\5DF1\7684\9801\9762\611F\6E2C\51FD\6578\7A0B\5F0F\78BC, \60A8\9700\8981\8FA8\8B58\4EC0\9EBC\6642\5019\76EE\524D\7684\9801\9762\662F\6B64\767B\5165\9801\9762, \7136\5F8C\4EE5\4E0D\540C\65BC\5176\4ED6\9801\9762\7684\65B9\5F0F\4F86\8655\7406. \60A8\53EF\4EE5\4F7F\7528\9801\78BC\4F86\4F5C\8B58\5225. \4F46\4E00\822C\7684\65B9\6CD5\662F\4F7F\7528\5E03\6797\503C\51FD\6578 wwv_flow_custom_auth.c')
||unistr('urrent_page_is_public \4F86\8FA8\8B58\60A8\61C9\7528\7A0B\5F0F\4E2D\4E4B\767B\5165\9801\9762\6216\5176\4ED6\9801\9762\7684\9019\500B\516C\7528\5C6C\6027.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109016008034313383)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN7'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\5165 URL %0 \5DF2\7D93\5C07 %1 \61C9\7528\7A0B\5F0F\9801\9762\6307\5B9A\70BA\7121\6548\7684\968E\6BB5\4F5C\696D\76EE\6A19. \6B64\9801\9762\8CA0\8CAC\57F7\884C\4E0B\5217\6B65\9A5F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109016153105313383)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN8'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\5217\662F\70BA\8A8D\8B49\914D\7F6E\4E2D\4E4B\767B\5165\8655\7406\6240\8A2D\5B9A\7684\503C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109016235742313383)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN9'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300COracle Application Server Single Sign-On \4F3A\670D\5668\300D\5C07\6703\5728\4F7F\7528\8005\8A8D\8B49\5F8C\91CD\65B0\5C0E\5411\56DE\6B64\61C9\7528\7A0B\5F0F. \9032\5165\9EDE\70BA %0 \7DB1\8981\4E2D\7684 wwv_flow_custom_auth_sso.process_success \7A0B\5E8F. %0 \5DF2\8A3B\518A\70BA Oracle Application Server Single Sign-On \5925\4F34\61C9\7528\7A0B\5F0F, \4E26\4E14\53EF\4EE5\66FF\60A8\7BA1\7406\767B\5165\4F3A\670D\5668\7684\6240\6709\4ECB\9762. \7136\800C, \60A8\4E5F\53EF\4EE5\8A3B\518A\81EA\5DF1\7DB1\8981\4E2D\7684\61C9\7528\7A0B\5F0F. \60A8\53EF\4EE5\7DE8\5BEB\81EA\5DF1\7684\9801\9762\611F\6E2C, \6216\8005\6839\64DA\8A8D\8B49\914D\7F6E\5EAB\7684\300C\5165')
||unistr('\53E3\7DB2\7AD9 - SSO\300D\914D\7F6E (\6211\7684\61C9\7528\7A0B\5F0F\70BA\5925\4F34\61C9\7528\7A0B\5F0F) \5EFA\7ACB\8A8D\8B49\914D\7F6E. \7D50\679C\914D\7F6E\5C07\6703\547C\53EB\5167\5EFA SSO \9801\9762\611F\6E2C wwv_flow_custom_auth_std.portal_sso_sentry_v1. \6B64\51FD\6578\8981\6C42\76EE\524D\7684\8A8D\8B49\914D\7F6E\9700\8981\77E5\9053\60A8\5925\4F34\61C9\7528\7A0B\5F0F\7684\540D\7A31 (\5728 Oracle Application Server Single Sign-On \8A3B\518A\7684\540D\7A31). \5EFA\7ACB\8A8D\8B49\914D\7F6E\7CBE\9748\6703\8981\6C42\60A8\8F38\5165\5925\4F34\61C9\7528\7A0B\5F0F\540D\7A31, \6216\8005\53EF\4EE5\5728\5EFA\7ACB\914D\7F6E\5F8C\85C9\7531\7DE8\8F2F\914D\7F6E\4F86\65B0\589E\6216\8B8A\66F4. \8F38\5165\7684\540D\7A31\5FC5\9808\8207\8A3B\518A\7684\5B8C\5168\76F8\540C (\9075\5B88')
||unistr('\5927\5C0F\5BEB). \60A8\540C\6642\9084\9700\8981\7DE8\5BEB\60A8\81EA\5DF1\7684 URLC \63A5\6536\5668\7A0B\5E8F\4E26\547C\53EB\5B83\7684 wwv_flow_custom_auth_sso.process_success API, \4F9D\7167\60A8\5728 Oracle Application Server Single Sign-On \8A3B\518A\7684\61C9\7528\7A0B\5F0F\540D\7A31\50B3\9001. \9019\5C07\6703\5728\8A8D\8B49\5F8C, \5728 %0 \57F7\884C\968E\6BB5\4F5C\696D\8A3B\518A. \5982\679C\60A8\7DE8\5BEB\81EA\5DF1\7684\9801\9762\611F\6E2C, \7576\9801\9762\611F\6E2C\6C7A\5B9A\9700\8981\8A8D\8B49\6642, \5B83\53EF\80FD\6703\547C\53EB wwv_flow_custom_auth_sso.portal_sso_redirect API \4F86\57F7')
||unistr('\884C\91CD\65B0\5C0E\5411\81F3\767B\5165\4F3A\670D\5668. \60A8\5FC5\9808\5C07\60A8\5925\4F34\61C9\7528\7A0B\5F0F\7684\8A3B\518A\540D\7A31\50B3\9001\5230\6B64\7A0B\5E8F. \8ACB\53C3\8003 %0 \6587\4EF6\548C %1 \6587\4EF6\77AD\89E3\8A73\7D30\8CC7\8A0A.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109016615511313383)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_POST_AUTH_PROC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\5F8C\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109016506693313383)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_PRE_AUTH_PROC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\524D\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109011021879313379)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHK_COOKIE1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\5167\5EFA\908F\8F2F\6AA2\67E5\540D\7A31\70BA [%0] \7684 cookie. \5982\679C cookie \5B58\5728, \800C\4E14\5B83\7684\89E3\5BC6\503C\5B9A\4F4D\5167\90E8\968E\6BB5\4F5C\696D\8868\683C\4E2D\7684\4E00\500B\8CC7\6599\5217, \5247\968E\6BB5\4F5C\696D\5C31\70BA\6709\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109011217449313379)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.COMPUTE_RETURN_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97\50B3\56DE\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109013098489313381)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CREDENTIALS_VERIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B49\660E\8CC7\6599\9A57\8B49 (\8A8D\8B49)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109014689709313382)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CUST_POST_AUTH_PROC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\8A8D\8B49\5F8C\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109007788875313377)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_MALFORMED_LOGIN_ARGS2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2 \7684\9032\5165\9EDE\5F15\6578\7121\6548.  ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109007644173313377)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_NULL_LOGIN_ARG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('wwv_flow_custom_auth_std.login--p_flow_page:%0 \7684 p_session_id \5F15\6578\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109007584063313377)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_RUN_CRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\57F7\884C\8A8D\8B49\8B49\660E\8CC7\6599\6AA2\67E5\51FD\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109012097200313380)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.INVALID_SESS_TARGET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\968E\6BB5\4F5C\696D\76EE\6A19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109013742351313381)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_DN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('LDAP \641C\5C0B\57FA\6E96:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109013823047313381)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\5217\5340\584A\6703\7528\65BC\5728\547C\53EB DBMS_LDAP.SIMPLE_BIND_S \4E4B\524D\547C\53EB\51FD\6578. \5F9E\767B\5165\8868\55AE\4E2D\64F7\53D6\7684\4F7F\7528\8005\540D\7A31\6703\50B3\9001\81F3\8A72\51FD\6578, \4EE5\50B3\56DE\7528\65BC\53D6\4EE3\300CLDAP \641C\5C0B\57FA\6E96\300D(\8ACB\53C3\898B\4E0A\65B9) \4E2D\4E4B %LDAP_USER% \7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109013967531313381)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\7A0B\5F0F\78BC\5340\584A\7684\7C3D\7AE0\5FC5\9808\662F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109014064936313381)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\53EF\4EE5\4F7F\7528\9019\9805\529F\80FD\5C07\8F38\5165\65BC\767B\5165\8868\55AE\4E2D\7684\4F7F\7528\8005\540D\7A31\8F49\63DB\6210\7B26\5408\60A8\7684 LDAP \76EE\9304\9805\76EE\7684\683C\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109013505660313381)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_HOST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('LDAP \4E3B\6A5F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109013690874313381)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_PORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('LDAP \9023\63A5\57E0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109010599775313379)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\61C9\7528\7A0B\5F0F (%0) \4F7F\7528\9801\9762 %1 \4F5C\70BA\767B\5165\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109010655320313379)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\7576\9801\9762 %0 \88AB\8981\6C42\6642, \9032\4E00\6B65\7684\8A8D\8B49\6AA2\67E5\5C07\4E0D\6703\57F7\884C, \9801\9762\5C31\6703\63A5\8457\986F\793A\6216\88AB\63A5\53D7. \9019\6703\8B93\767B\5165\9801\9762\5728\958B\59CB\8A8D\8B49\524D\5C31\986F\793A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109010459306313379)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG_HANDLING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\5165\9801\9762\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109010773304313379)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PAGE_SENTRY_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\611F\6E2C\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109010892639313379)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PG_SENTRY1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\5167\5EFA\908F\8F2F\4F86\57F7\884C\9801\9762\611F\6E2C\5DE5\4F5C. \5C0D\65BC\6BCF\500B\9801\9762\8981\6C42, \9801\9762\611F\6E2C\51FD\6578\6703\57F7\884C\968E\6BB5\4F5C\696D\9A57\8B49\4E26\904B\7B97\50B3\56DE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109014229242313382)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.POST_AUTH_PROC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\5F8C\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109011121403313379)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\5176\4ED6\4F7F\7528\8005\63D0\4F9B\7684\7A0B\5F0F\78BC\4F86\6C7A\5B9A\968E\6BB5\4F5C\696D\662F\5426\6709\6548. \5982\679C\5167\5EFA\968E\6BB5\4F5C\696D\9A57\8B49\6AA2\67E5\7684\7D50\679C\70BA TRUE, \8ACB\57F7\884C\4E0B\5217\7A0B\5F0F\78BC\4E26\8A18\4F4F\5B83\7684\5E03\6797\50B3\56DE\503C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109010902655313379)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D\9A57\8B49\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109012365068313380)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SSO_SERVER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Oracle Application Server Single Sign-On \4F3A\670D\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109012471506313380)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.THE_URL'
,p_message_language=>'zh-tw'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109159271891313490)
,p_name=>'WWV_FLOW_DATALOAD_XML.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108897660110313285)
,p_name=>'WWV_FLOW_DATA_LOADER.LOADING_JOB_STARTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\5DE5\4F5C\5DF2\555F\52D5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109068524483313422)
,p_name=>'WWV_FLOW_DATA_PARSER.FILE_TOO_LARGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\6A94\6848\7684\5927\5C0F\8D85\904E %1 MB, \56E0\6B64\4E0D\652F\63F4\8F09\5165\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109454114078313717)
,p_name=>'WWV_FLOW_DATA_PROFILE.INVALID_SQL_EXPR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684 SQL \8868\793A\5F0F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108987940294313356)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.ANALYZE_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\6790 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108988311859313357)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.VIEW_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109148460180313482)
,p_name=>'WWV_FLOW_DEBUGTAB_BIU_FER.INVALID_DATE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\65E5\671F\683C\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109128037671313466)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.DEBUG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9664\932F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109128129165313466)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FEATURE_NOT_SUPPORTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\7248\672C\4E0D\652F\63F4\9019\9805\529F\80FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109125291145313464)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FUNC_RETURN_QUERY_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1101 \7121\6CD5\8655\7406\50B3\56DE\67E5\8A62\7684\51FD\6578\4E3B\9AD4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109128328091313467)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.HELP_REQUEST_ERR2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4 4323- \8AAA\660E\7684\8981\6C42\672A\63D0\4F9B\986F\793A\8AAA\660E\7684\6578\5B57\9801\9762 ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109125003769313464)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1025 \8655\7406 PLSQL \8868\793A\5F0F\6642\767C\751F\932F\8AA4.  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109125159204313464)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_FOOTER_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F=%0 \9801\9762=%1 SQLERRM=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109127842586313466)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PRINT_SHORTCUT_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5217\5370\6377\5F91: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109125340852313464)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PROC_CURR_COND_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1108 \7121\6CD5\8655\7406\9805\76EE\76EE\524D\7684\689D\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109127946217313466)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_CHART_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE\5716\8868\6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109278146517313583)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_COMP_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5448\73FE\5143\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108922246277313304)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_DYN_LIST_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE\300C\52D5\614B\6E05\55AE\300D\5340\57DF\6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109128258723313467)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.REQUEST_FOR_HELP_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4 4322- \672A\4F7F\7528\6B63\78BA\7684\8A9E\6CD5\8981\6C42\8AAA\660E. \9700\8981\6709\6548\7684\9801\78BC, \4F46\8981\6C42\662F\7A7A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109154861826313486)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.UNABLE_TO_BIND_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\9023\7D50 "%0". \8ACB\5728\591A\4F4D\5143\7D44\9805\76EE\4F7F\7528\96D9\5F15\865F, \6216\6AA2\67E5\9805\76EE\9577\5EA6\662F\5426\5728 30 \500B\4F4D\5143\7D44\4EE5\5167. \8ACB\4F7F\7528 v() \8A9E\6CD5\4F86\53C3\7167\8D85\904E 30 \500B\4F4D\5143\7D44\7684\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109692903134313915)
,p_name=>'WWV_FLOW_DML.BLOB_COLUMN_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\8CC7\6599\6B04\683C\5F0F\906E\7F69 DOWNLOAD:TABLE_NAME:BLOB_COLUMN \4E2D\61C9\8A72\8981\6709 BLOB \8CC7\6599\6B04\540D\7A31...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110047538634314177)
,p_name=>'WWV_FLOW_DML.COLUMN_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\8868\683C %1 \4E2D\627E\4E0D\5230\8CC7\6599\6B04 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109150581870313483)
,p_name=>'WWV_FLOW_DML.DML_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('DML \767C\751F\932F\8AA4: p_rowid=%0, p_alt_rowid=%1, p_rowid2=%2, p_alt_rowid2=%3. %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108984525406313354)
,p_name=>'WWV_FLOW_DML.DML_INSERT_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\57F7\884C\63D2\5165\4F5C\696D.  %0  %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109306029492313604)
,p_name=>'WWV_FLOW_DML.DML_INVALID_NUMBER_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04 %1 \7684\6578\503C %0 \7121\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108991251838313359)
,p_name=>'WWV_FLOW_DML.INVALID_ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\7269\4EF6\4E0A\7684\52D5\4F5C %0 \7121\6548. (%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109692009698313914)
,p_name=>'WWV_FLOW_DML.INVALID_TABLE_OWNER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\8868\683C\64C1\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109692198764313914)
,p_name=>'WWV_FLOW_DML.INVALID_URL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109691947551313913)
,p_name=>'WWV_FLOW_DML.LAST_UPDATED_COLUMN_HAS_TO_BE_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\6B21\66F4\65B0\7684\8CC7\6599\8CC7\6599\6B04 "%0" (\8CC7\6599\985E\578B\70BA "%1", \7528\65BC\8FFD\8E64 "%2" \7684\66F4\65B0) \5FC5\9808\662F\65E5\671F\6216\6642\6233\8CC7\6599\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109692274619313914)
,p_name=>'WWV_FLOW_DML.NOT_CALLED_FROM_PAGE_WHICH_CONTAINS_FILE_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4: \5FC5\9808\5F9E\5305\542B FILE \985E\578B\4E4B\9805\76EE\540D\7A31\7684\8868\55AE\9801\9762\547C\53EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109692511693313914)
,p_name=>'WWV_FLOW_DML.NO_FORMAT_MASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\683C\5F0F\906E\7F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109693027788313915)
,p_name=>'WWV_FLOW_DML.PK_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\8CC7\6599\6B04\683C\5F0F\906E\7F69 DOWNLOAD:TABLE_NAME:BLOB_COLUMN:PK1_COL_NAME \4E2D\61C9\8A72\8981\6709\4E3B\7D22\5F15\9375 1 \8CC7\6599\6B04\540D\7A31...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110047608095314177)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\8868\683C\6216\8996\89C0\8868 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109692873428313915)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\8CC7\6599\6B04\683C\5F0F\906E\7F69 DOWNLOAD:TABLE_NAME \4E2D\61C9\8A72\8981\6709\8868\683C\540D\7A31...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109692741367313915)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F\906E\7F69\81F3\5C11\5FC5\9808\5305\62EC 4 \500B\5F15\6578 (\4F7F\7528\5192\865F\5340\9694)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109692699684313915)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK_PREFIX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F\906E\7F69\7684\958B\982D\5FC5\9808\662F DOWNLOAD \6216 IMAGE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109338122221313628)
,p_name=>'WWV_FLOW_EXEC.INVALID_COLUMN_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31 "%0" \5C0D\65BC SQL \67E5\8A62\800C\8A00\7121\6548. \8ACB\78BA\5B9A\60A8\8CC7\6599\6B04\4F7F\7528\7684\662F\552F\4E00\7684\5225\540D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108983457390313353)
,p_name=>'WWV_FLOW_EXEC.NOT_ALLOWED_ON_WEB_SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5141\8A31\5C0D REST \8CC7\6599\4F86\6E90\57F7\884C\9019\9805\4F5C\696D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109338083288313628)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62\4E2D\6240\9078\7684\8CC7\6599\6B04\6578\76EE\4E0D\6B63\78BA. \8ACB\53C3\95B1\5C6C\6027\300C\8AAA\660E\300D\77AD\89E3\8A73\7D30\8CC7\8A0A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108893500446313282)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728 SQL \6558\8FF0\53E5\4E2D\7684\8CC7\6599\985E\578B\4E0D\6B63\78BA. \8CC7\6599\6B04# %1 \70BA %2, \4F46\61C9\70BA %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109439083054313705)
,p_name=>'WWV_FLOW_EXEC_DEV.COLUMN_NOT_UNIQUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31 "%0" \5DF2\7D93\7528\65BC SQL \67E5\8A62\4E2D. \8ACB\78BA\5B9A\60A8\8CC7\6599\6B04\4F7F\7528\7684\662F\552F\4E00\7684\5225\540D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109438965096313704)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_COLUMN_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31 "%0" \5C0D\65BC LOV SQL \67E5\8A62\800C\8A00\7121\6548. \8ACB\78BA\5B9A\60A8\8CC7\6599\6B04\4F7F\7528\7684\662F\6709\6548\7684\5225\540D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109438731955313704)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5728\5256\6790 "%0" \4E2D\50B3\56DE\7684\67E5\8A62\7D50\679C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109438886745313704)
,p_name=>'WWV_FLOW_EXEC_DEV.WRONG_COLUMN_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62\4E2D\6240\9078\7684\8CC7\6599\6B04\6578\76EE\4E0D\6B63\78BA. \8ACB\53C3\95B1\5C6C\6027\300C\8AAA\660E\300D\77AD\89E3\8A73\7D30\8CC7\8A0A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108893047750313282)
,p_name=>'WWV_FLOW_EXEC_WEB_SRC.MODULE_TYPE_NOT_SUPPORTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\652F\63F4 REST \8CC7\6599\4F86\6E90\985E\578B %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108894972913313283)
,p_name=>'WWV_FLOW_EXPORT_INT.DUPLICATE_FILENAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8907\7684\6A94\6848\540D\7A31: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110087352730314205)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.APPLICATION_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110087170370314205)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.CONSTANT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E38\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110086888864314204)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110087968605314205)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.KEYWORD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9375\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110087869723314205)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.MATERIALIZED VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BE6\9AD4\5316\8996\89C0\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110087432745314205)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PACKAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\88DD\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110087256589314205)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PAGE_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110086729992314204)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PROCEDURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110087560435314205)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.SEQUENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110087625859314205)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110088089517314205)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110086918228314205)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110087045559314205)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VARIABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110087722938314205)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109651991291313871)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_LOV_SQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5256\6790 LOV SQL \67E5\8A62! %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109416758889313688)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_QUERY_FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\7684\67E5\8A62\7BE9\9078\7121\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109652834784313872)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31 "%0" \5DF2\7D93\7528\65BC LOV SQL \67E5\8A62\4E2D. \8ACB\78BA\5B9A\60A8\8CC7\6599\6B04\4F7F\7528\7684\662F\552F\4E00\7684\5225\540D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109652729080313872)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_INVALID_COLUMN_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31 "%0" \5C0D\65BC LOV SQL \67E5\8A62\800C\8A00\7121\6548. \8ACB\78BA\5B9A\60A8\8CC7\6599\6B04\4F7F\7528\7684\662F\6709\6548\7684\5225\540D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109651817079313871)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('LOV SQL \67E5\8A62\4E2D\6240\9078\7684\8CC7\6599\6B04\6578\76EE\4E0D\6B63\78BA. \8ACB\53C3\95B1\7BC4\4F8B, \77AD\89E3\6709\6548\7684\6558\8FF0\53E5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108991014686313359)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F3A\670D\5668\5728\5617\8A66\79FB\9664\6A94\6848 "%0" \6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108991149275313359)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\79FB\9664\6A94\6848 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108990875094313359)
,p_name=>'WWV_FLOW_FILE_API.ERROR_WRITING_TO_DIRECTORY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BEB\5165\5BE6\9AD4\6A94\6848\76EE\9304 "%0". (%1: %2) \767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109126342548313465)
,p_name=>'WWV_FLOW_FILE_API.EXCEEDED_WORKSPACE_NON_INTERNAL_FILES_LIMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D85\904E\975E\5167\90E8\5DE5\4F5C\5340\6A94\6848\5927\5C0F\7684\4E0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108990921741313359)
,p_name=>'WWV_FLOW_FILE_API.NO_FILE_TO_WRITE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ID %0 \6C92\6709\53EF\5BEB\5165\7684\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109126246255313465)
,p_name=>'WWV_FLOW_FILE_API.WORKSPACE_MAX_FILE_BYTES.EXCEEDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D85\904E\6240\6709\5DE5\4F5C\5340\6A94\6848\5927\5C0F\7684\4E0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109159589121313490)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.DEV_ROLE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\958B\767C\4EBA\54E1\89D2\8272\6642\767C\751F\932F\8AA4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109035588108313397)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_FND_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56E0\4E0B\5217\539F\56E0\800C\672A\5EFA\7ACB\4F7F\7528\8005: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109700168005313922)
,p_name=>'WWV_FLOW_FND_USER_API.INVALID_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\662F\6709\6548\7684\96FB\5B50\90F5\4EF6\5730\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109153242951313485)
,p_name=>'WWV_FLOW_FORMS.COMBO_JS_NO_QUERY_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\9078\53D6\6E05\55AE (\542B js \91CD\65B0\5C0E\5411) \985E\578B\4E4B\9805\76EE %0 \7684\67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109153103974313485)
,p_name=>'WWV_FLOW_FORMS.COMBO_NO_QUERY_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\9078\53D6\6E05\55AE\985E\578B\4E4B\9805\76EE %0 \7684\67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109153367622313485)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\9078\53D6\6E05\55AE (\542B URL \91CD\65B0\5C0E\5411) \985E\578B\4E4B\9805\76EE %0 \7684\67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109153422517313485)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_PAGE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\9078\53D6\6E05\55AE (\542B URL \91CD\65B0\5C0E\5411\81F3\9801\9762) \985E\578B\4E4B\9805\76EE %0 \7684\67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109127799500313466)
,p_name=>'WWV_FLOW_FORMS.EDIT ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\9805\76EE %0 - %1 , \9806\5E8F: %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109124876829313464)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_FUNC_BODY_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1904 \7121\6CD5\904B\7B97\9805\76EE\9810\8A2D\503C: \985E\578B = \51FD\6578\4E3B\9AD4 computation_type= %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109124747826313464)
,p_name=>'WWV_FLOW_FORMS.PLSQL_ITEM_PROC_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1020 \8655\7406 PLSQL \9805\76EE\6642\767C\751F\932F\8AA4 (\51FD\6578).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109124954434313464)
,p_name=>'WWV_FLOW_FORMS.SPELL_CHK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62FC\5B57\6AA2\67E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109127660837313466)
,p_name=>'WWV_FLOW_FORMS.UNABLE_CAST_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5C07\503C "%0" \50B3\9001\81F3\65E5\671F\683C\5F0F\906E\7F69 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108892719206313281)
,p_name=>'WWV_FLOW_FORM_REGION.BLOB_NOT_SUPPORTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528 REST \7684 SQL \6216 REST \8CC7\6599\4F86\6E90\4E0D\652F\63F4 BLOB \8CC7\6599\985E\578B\7684\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108892909970313282)
,p_name=>'WWV_FLOW_FORM_REGION.CANNOT_FETCH_META_DATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\64F7\53D6\5340\57DF ID %s \7684\63CF\8FF0\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109372928697313654)
,p_name=>'WWV_FLOW_FORM_REGION.FORM_REGION_IS_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\55AE DML \6216\521D\59CB\5316\8655\7406\4F5C\696D\6C92\6709\6307\5B9A\7684\8868\55AE\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109378692406313659)
,p_name=>'WWV_FLOW_FORM_REGION.MIGRATE_FORM_REGION_DESCRIBE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\820A\6709\8868\55AE\9801\9762\79FB\8F49\70BA\8868\55AE\5340\57DF\6642\767C\751F\932F\8AA4: \7121\6CD5\63CF\8FF0 DML \8655\7406\4F5C\696D\4E2D\53C3\7167\7684\8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109109815539313453)
,p_name=>'WWV_FLOW_FORM_REGION.NO_CHECKSUM_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\907A\5931\7684\66F4\65B0\5075\6E2C\7684\7E3D\548C\6AA2\9A57. \53EA\80FD\5C0D\73FE\6709\8CC7\6599\5217\57F7\884C UPDATE \6216 DELETE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109679263757313897)
,p_name=>'WWV_FLOW_FORM_REGION.NO_DML_ON_WSM_SYNC_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5728\5DF2\555F\7528\540C\6B65\5316\7684 REST \4F86\6E90\4E0A\57F7\884C\8868\55AE DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108892616723313281)
,p_name=>'WWV_FLOW_FORM_REGION.NO_PRIMARY_KEY_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C1A\672A\66FF\8868\55AE\5340\57DF %0 \5B9A\7FA9\4E3B\7D22\5F15\9375\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108892803235313281)
,p_name=>'WWV_FLOW_FORM_REGION.WRONG_ITEM_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE %0 \7684\8CC7\6599\985E\578B\4E0D\6B63\78BA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109060892362313416)
,p_name=>'WWV_FLOW_GENERATE_DDL.DOMAIN_INDEX_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7684 %0 \6709\7DB2\57DF\7D22\5F15.\300C\7522\751F DDL\300D\7121\6CD5\7522\751F\7DB2\57DF\7D22\5F15 DDL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108999358848313370)
,p_name=>'WWV_FLOW_GENERATE_DDL.GENERATE_DDL_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Rem \7121\6CD5\7522\751F %0 %1 \7684 DDL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109030091563313393)
,p_name=>'WWV_FLOW_GENERATE_DDL.NO_DDL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\7522\751F DDL \7684 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108999577897313371)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Save_ddl \932F\8AA4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108987164896313356)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5C07 DDL \5132\5B58\70BA\547D\4EE4\6A94\6A94\6848. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108999467325313370)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_PARSE_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5256\6790 DDL \547D\4EE4\6A94\767C\751F\932F\8AA4. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109153538669313485)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.PACKAGE_INVALID_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4, \5957\88DD\7A0B\5F0F\540D\7A31: %0 \7121\6548\6216\5DF2\7D93\88AB\4F7F\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109134617928313471)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_COMMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('-- \61C9\7528\7A0B\5F0F %0 \7684\8868\683C API, \5DF2\7522\751F %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109133339882313470)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\4E0B\5217\7A0B\5E8F\5EFA\7ACB PL/SQL \5957\88DD\7A0B\5F0F %0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109134290473313471)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7528\65BC\5C07\8CC7\6599\63D2\5165 %0, \5FC5\9808\63D0\4F9B\4E3B\7D22\5F15\9375')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109134381031313471)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7528\4F86\66F4\65B0\7531\4E3B\7D22\5F15\9375\8B58\5225\4E4B %0 \4E2D\7684\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109134460430313471)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7528\65BC\522A\9664\4EE5\4E3B\7D22\5F15\9375\70BA\57FA\790E\4E4B %0 \7684\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109134565392313471)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7528\65BC\64F7\53D6\4EE5\4E3B\7D22\5F15\9375\70BA\57FA\790E\4E4B %0 \7684\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109134127412313471)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109133999289313471)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109133885149313471)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_SPEC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09\898F\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109133715095313471)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109133548541313471)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_SPEC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF\898F\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109207300292313526)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_BODY_COMMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('-- \5957\88DD\7A0B\5F0F\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109207464701313526)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_SPEC_COMMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('-- \5957\88DD\7A0B\5F0F\898F\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109133623865313471)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\4E3B\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109133477681313470)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_SPEC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\898F\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109134039185313471)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SUBPROGRAM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B50\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109206842553313525)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_CREATE_COMMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('-- \5EFA\7ACB\8868\683C "%0"  \7684\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109207018752313525)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_DELETE_COMMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('-- \522A\9664\8868\683C "%0" \7684\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109207145253313526)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_GET_COMMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('-- \53D6\5F97\8868\683C "%0" \7684\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109207280647313526)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_MD5_COMMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('-- \5EFA\7ACB\8868\683C "%0" \7684 MD5 \51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109206928932313525)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_UPDATE_COMMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('-- \66F4\65B0\8868\683C "%0" \7684\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109153648273313485)
,p_name=>'WWV_FLOW_GENERIC_ATTR.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109691354586313912)
,p_name=>'WWV_FLOW_GEN_API2.COMPANY_SOURCE_IDENTIFIER_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\5B9A\7FA9\5DE5\4F5C\5340\7684\300C\4F86\6E90 ID\300D!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109691481268313913)
,p_name=>'WWV_FLOW_GEN_API2.DEPLOYMENT_SYSTEM_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\90E8\7F72\7CFB\7D71!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109031669022313395)
,p_name=>'WWV_FLOW_GRID_LAYOUT.FIXED_POSITION_CONFLICT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5143\4EF6 <strong>%0</strong> \7121\6CD5\5728<strong>\8CC7\6599\6B04 %1</strong> \4E2D\4E88\4EE5\5448\73FE, \56E0\70BA\53E6\4E00\500B\5143\4EF6\5DF2\5B58\5728\65BC\6B64\8CC7\6599\6B04\5167.</p>'),
unistr('<p>\5C07\300C\8CC7\6599\6B04\300D\8A2D\70BA<strong>\81EA\52D5</strong>, \901A\5E38\5C31\53EF\4EE5\4FEE\6B63\6B64\554F\984C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110135980145314261)
,p_name=>'WWV_FLOW_GRID_LAYOUT.LABEL_COLUMN_SPAN_TOO_BIG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<p>\9801\9762\9805\76EE <strong>%0</strong> \7684\6A19\7C64\7121\6CD5\4E88\4EE5\5448\73FE, \56E0\70BA\6B64\9801\9762\9805\76EE\7684\6A19\7C64\8CC7\6599\6B04\5BEC\5EA6\7DB2\683C\8A2D\5B9A\503C\7121\6548. \5B83\8A2D\70BA\8207<strong>\6A19\7C64\8CC7\6599\6B04\5BEC\5EA6 %1</strong> \4E00\8D77\986F\793A. \9019\4E0D\53D7\652F\63F4, \56E0\70BA\9801\9762\9805\76EE\672C\8EAB\53EA\6709 <strong>%2 \500B\8CC7\6599\6B04</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109031484401313394)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_CALCULATED_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5143\4EF6 <strong>%0</strong> \7121\6CD5\4E88\4EE5\5448\73FE, \56E0\70BA\6B64\5143\4EF6\7684\7DB2\683C\8A2D\5B9A\503C\7121\6548. \5B83\8A2D\70BA\5728\5177\6709<span>\8CC7\6599\6B04\5BEC\5EA6 %2</strong> \7684<strong>\8CC7\6599\6B04 %1</strong> \4E0A\986F\793A. \9019\4E0D\53D7\652F\63F4, \56E0\70BA\6B64\9801\9762\4E0A\7684\7DB2\683C\6700\591A\53EA\652F\63F4 <strong>%3 \500B\8CC7\6599\6B04</strong>.</p>'),
unistr('<p>\5C07\6240\6709\5143\4EF6\7684\300C\8CC7\6599\6B04\300D\548C\300C\8CC7\6599\6B04\5BEC\5EA6\300D\8A2D\70BA<strong>\81EA\52D5</strong>, \901A\5E38\5C31\53EF\4EE5\4FEE\6B63\6B64\554F\984C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109031528426313394)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_SUPPORTED_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5143\4EF6 <strong>%0</strong> \7121\6CD5\4E88\4EE5\5448\73FE, \56E0\70BA\6B64\5143\4EF6\7684\7DB2\683C\8A2D\5B9A\503C\7121\6548. \5B83\8A2D\70BA\5728\5177\6709<strong>\8CC7\6599\6B04\5BEC\5EA6 %2</strong> \7684<strong>\8CC7\6599\6B04 %1</strong> \4E0A\986F\793A. \9019\4E0D\53D7\652F\63F4, \56E0\70BA\6B64\9801\9762\4E0A\7684\7DB2\683C\53EA\652F\63F4 <strong>%3 \500B\8CC7\6599\6B04</strong>.</p>'),
unistr('<p>\5C07\6240\6709\5143\4EF6\7684\300C\8CC7\6599\6B04\300D\548C\300C\8CC7\6599\6B04\5BEC\5EA6\300D\8A2D\70BA<strong>\81EA\52D5</strong>, \901A\5E38\5C31\53EF\4EE5\4FEE\6B63\6B64\554F\984C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108913680315313297)
,p_name=>'WWV_FLOW_HELP.2_DAY_DBA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('2 \5929\671F DBA \8AB2\7A0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108913525064313297)
,p_name=>'WWV_FLOW_HELP.2_DAY_DEV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('2 \5929\671F\8AB2\7A0B + \958B\767C\4EBA\54E1\624B\518A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108879900256313272)
,p_name=>'WWV_FLOW_HELP.ADMIN_GUIDE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7BA1\7406\624B\518A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108880041290313272)
,p_name=>'WWV_FLOW_HELP.API'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('API \53C3\8003\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109455888698313718)
,p_name=>'WWV_FLOW_HELP.CONTENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109449810910313713)
,p_name=>'WWV_FLOW_HELP.CONTEXT_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\65BC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109455922048313718)
,p_name=>'WWV_FLOW_HELP.FIND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0B\627E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108913423813313297)
,p_name=>'WWV_FLOW_HELP.HTMLDB_USER_GUIDE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7522\751F\5668\4F7F\7528\624B\518A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109561896222313801)
,p_name=>'WWV_FLOW_HELP.INITIAL_INDEX_CREATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C\4E00\6B21\5EFA\7ACB\7D22\5F15\53EF\80FD\9700\8981\5E7E\79D2\9418\7684\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108880173832313272)
,p_name=>'WWV_FLOW_HELP.MIGRATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\79FB\8F49\624B\518A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109455631459313718)
,p_name=>'WWV_FLOW_HELP.NO_INDEX_MAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\6587\4EF6\5C0D\61C9\6A94\6848: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109456018369313718)
,p_name=>'WWV_FLOW_HELP.SCORE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108880263518313272)
,p_name=>'WWV_FLOW_HELP.SQL_WORKSHOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \5DE5\4F5C\5BA4\548C\516C\7528\7A0B\5F0F\624B\518A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109162719961313492)
,p_name=>'WWV_FLOW_HINT.CREATE_NORMALIZE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6B63\5E38\5316\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109338977848313629)
,p_name=>'WWV_FLOW_HINT.NO_PRIVS_ON_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7121\6CD5\5B58\53D6\76EE\524D\6B63\5728\532F\5165\7684\7DB1\8981.  \532F\5165\5931\6557.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109162634534313492)
,p_name=>'WWV_FLOW_HINT.REMOVE_TABLE_HINT_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\547C\53EB remove_table_hint \6642\6C92\6709 p_table_id, \5FC5\9808\63D0\4F9B\8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109068420781313422)
,p_name=>'WWV_FLOW_IMP_PARSER.CREATE_WS_SEC_VIOLATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\88DD\5DE5\4F5C\5340\6642\767C\751F\7B2C\4E8C\6B21 create_company \547C\53EB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109031260246313394)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_BLOCK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('GET_BLOCK \932F\8AA4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109031133904313394)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_STMT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('GET_STMT \932F\8AA4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109031382193313394)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_FILE_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\6A94\6848. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108897450763313285)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_INSTALL_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Zip \5B58\6A94\7121\6548, \627E\4E0D\5230\5B89\88DD\8CC7\8A0A\6E05\55AE\6A94\6848.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109034757265313397)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_PRIV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\6C92\6709 %0 \7DB1\8981\7684\6B0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109031034318313394)
,p_name=>'WWV_FLOW_IMP_PARSER.RUN_STMT_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\57F7\884C\6558\8FF0\53E5\5931\6557. %0'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109071059290313424)
,p_name=>'WWV_FLOW_IMP_PARSER.SEC_VIOLATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\532F\51FA\6A94\7684\5927\578B\5340\584A\5167\5075\6E2C\5230\547C\53EB remove_page \7A0B\5E8F\7684 API.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109332363699313624)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_LABEL_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9805\76EE\6C92\6709\6A19\7C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108949142632313325)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_CONTAINS_WRONG_VERSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Application Express \6A94\6848\4E26\975E\6700\65B0\7248\672C, \56E0\6B64\60A8\7684\74B0\5883\767C\751F\554F\984C! \8F09\5165\7684\6A94\6848\7248\672C\70BA #LOADED_VERSION#, \4F46\9810\671F\7684\7248\672C\70BA %0. \8ACB\78BA\5B9A\60A8\5DF2\6309\7167\5B89\88DD\6307\5357\4E2D\7684\6307\793A, \5C07\5F71\50CF\76EE\9304\8907\88FD\5230\60A8\7684\61C9\7528\7A0B\5F0F\4F3A\670D\5668.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108949048100313325)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_NOT_COPIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C1A\672A\8F09\5165 Application Express \6A94\6848, \56E0\6B64\60A8\7684\74B0\5883\767C\751F\554F\984C. \8ACB\78BA\5B9A\60A8\5DF2\6309\7167\5B89\88DD\6307\5357\7684\6307\793A, \5C07\5F71\50CF\76EE\9304\8907\88FD\5230\61C9\7528\7A0B\5F0F\4F3A\670D\5668. \6B64\5916, \8ACB\78BA\5B9A\60A8\7684\5F71\50CF\524D\7F6E\78BC\8DEF\5F91\662F\5426\6B63\78BA. \76EE\524D\7684\8DEF\5F91\70BA %0 (\5FC5\9808\5305\542B\958B\982D\548C\7D50\5C3E\6B63\659C\7DDA, \4F8B\5982\9810\8A2D\7684 /i/). \5982\8981\8B8A\66F4, \8ACB\4F7F\7528 SQL \547D\4EE4\6A94 reset_image_prefix.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109152600700313485)
,p_name=>'WWV_FLOW_JOB.UNAUTHORIZED_ATTEMPT_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6388\6B0A\5373\5617\8A66\57F7\884C %0 \5DE5\4F5C, \6309\7DB1\8981: %1 \65BC\61C9\7528\7A0B\5F0F: %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109163220215313493)
,p_name=>'WWV_FLOW_LOAD_DATA.COLLECTION_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\96C6\5408: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109162876189313492)
,p_name=>'WWV_FLOW_LOAD_DATA.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109162987293313493)
,p_name=>'WWV_FLOW_LOAD_DATA.FIND_DATA_TYPE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0B\627E\8CC7\6599\985E\578B\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109163123379313493)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_DATATYPE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\5F97\8CC7\6599\985E\578B\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109163051156313493)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_MAX_COL_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\9577\5EA6\4E0A\9650\932F\8AA4 1: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109350943141313638)
,p_name=>'WWV_FLOW_LOAD_DATA.NO_32KB_INSERT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\63D2\5165\8D85\904E 32KB \8CC7\6599\7684\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109163335106313493)
,p_name=>'WWV_FLOW_LOOKUP_TABLES.PRIVS_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005 %0 \6C92\6709 %1 \7DB1\8981\7684\6B0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109154387100313486)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.BRANCH_COND_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\66F4\65B0\9801\9762\5206\652F\8655\7406\689D\4EF6\985E\578B. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109154295298313486)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_BUTTON_COND_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\66F4\65B0\9801\9762\6309\9215\689D\4EF6\985E\578B. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109154037929313486)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_COMP_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\66F4\65B0\300C\61C9\7528\7A0B\5F0F\300D\904B\7B97\985E\578B. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109153999232313486)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_PROC_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\70BA\689D\4EF6\985E\578B\6642\7121\6CD5\66F4\65B0\300C\61C9\7528\7A0B\5F0F\300D\8655\7406\4F5C\696D. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109154765886313486)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_MISSPELL_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\62FC\932F\7684\6587\5B57\6642\767C\751F\932F\8AA4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109153893584313486)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_NAVBAR_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\66F4\65B0\300C\5C0E\89BD\5217\300D\986F\793A\689D\4EF6\985E\578B. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109154415581313486)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_COMP_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\66F4\65B0\9801\9762\904B\7B97\985E\578B. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109154630987313486)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_PROC_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\66F4\65B0\9801\9762\8655\7406\4F5C\696D\985E\578B. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109154102998313486)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_SUBTITLE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\66F4\65B0\9801\9762\5B50\6A19\984C\985E\578B. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109154550890313486)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_VALID_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\66F4\65B0\9801\9762\9A57\8B49\985E\578B. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109701293405313923)
,p_name=>'WWV_FLOW_NATIVE_ITEM.AUTOCOMPLETE_RESTRICTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0:\300C\9072\7DE9\8F09\5165\300D\8A2D\70BA\300C\662F\300D\6642, \624D\80FD\5920\4F7F\7528\300C\968E\5C64\5F0F LOV \7236\9805\9805\76EE\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109692451617313914)
,p_name=>'WWV_FLOW_NATIVE_ITEM.MULTIPLE_DML_PROCESSES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4: \6BCF\4E00\9801\6700\591A\53EA\80FD\5BA3\544A\4E00\500B DML \8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109692307854313914)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_DML_PROCESS_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4: \627E\4E0D\5230\9801\9762 %0 \4E4B\76F8\5C0D\61C9\7684 DML \8655\7406\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109693416013313916)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_VALID_BLOB_SOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5FC5\9808\4F7F\7528\6709\6548\7684 BLOB \8CC7\6599\6B04\4F5C\70BA\4F86\6E90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109654165228313873)
,p_name=>'WWV_FLOW_NATIVE_ITEM.PLSQL_CODE_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\66FF\9805\76EE %0 \6307\5B9A\7522\751F HTML \7684 PL/SQL \7A0B\5F0F\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109164279295313493)
,p_name=>'WWV_FLOW_PARSER.BULK_COLLECT_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5927\91CF\6536\96C6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109163908040313493)
,p_name=>'WWV_FLOW_PARSER.CHECK_CODE_PARSE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\6AA2\67E5\662F\5426\5DF2\7D93\5256\6790\7A0B\5F0F\78BC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109164098579313493)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\57F7\884C\63A7\5236\6A94: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109164781019313494)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_STATS_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\67E5\770B\63A7\5236\6A94\7D71\8A08\8CC7\6599: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109164623576313494)
,p_name=>'WWV_FLOW_PARSER.DELETE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\522A\9664\5256\6790\904E\7684\8CC7\8A0A: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109164504885313494)
,p_name=>'WWV_FLOW_PARSER.EXECUTION_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\6558\8FF0\53E5\5931\6557: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109163412629313493)
,p_name=>'WWV_FLOW_PARSER.FIND_FILE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\6A94\6848. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109163616062313493)
,p_name=>'WWV_FLOW_PARSER.GET_STATEMENT_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\5F97\6558\8FF0\53E5: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109129726955313468)
,p_name=>'WWV_FLOW_PARSER.LINE_TOO_LONG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\9577\5EA6 %0 \8D85\904E\884C %2 \7684 %1 \4E0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109164426957313494)
,p_name=>'WWV_FLOW_PARSER.PACKAGE_COMP_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A: \5EFA\7ACB\7684\5957\88DD\7A0B\5F0F\4E3B\9AD4\6709\7DE8\8B6F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109164136931313493)
,p_name=>'WWV_FLOW_PARSER.RUN_CODE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\57F7\884C\7A0B\5F0F\78BC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109164384742313494)
,p_name=>'WWV_FLOW_PARSER.RUN_STATEMENT_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\57F7\884C\6558\8FF0\53E5: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109163798586313493)
,p_name=>'WWV_FLOW_PARSER.SAVE_PARAMETER_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5C07\53C3\6578\5132\5B58\81F3\8CC7\6599\5EAB: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109163559212313493)
,p_name=>'WWV_FLOW_PARSER.UNABLE_GET_CODE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\5F97\7A0B\5F0F\78BC\5340\584A: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109163893494313493)
,p_name=>'WWV_FLOW_PARSER.VALIDATE_FILE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\9A57\8B49\6A94\6848 "%0". %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109164851850313494)
,p_name=>'WWV_FLOW_PARSER_PUBLIC.PARSE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5256\6790\6A94\6848. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109547226728313786)
,p_name=>'WWV_FLOW_PLUGIN.NO_AUTHENTICATION_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C1A\672A\5B9A\7FA9 Plug-in %0 \7684\8A8D\8B49\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109547381802313786)
,p_name=>'WWV_FLOW_PLUGIN.NO_POST_LOGOUT_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C1A\672A\5B9A\7FA9 Plug-in %0 \7684\767B\51FA\5F8C\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109547169266313786)
,p_name=>'WWV_FLOW_PLUGIN.NO_SESSION_SENTRY_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C1A\672A\5B9A\7FA9 Plug-in %0 \7684\968E\6BB5\4F5C\696D\611F\6E2C\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110100447018314232)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110099647291314215)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_DEFINED_BY_DA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\614B\52D5\4F5C\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110099364875314215)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3\6B64\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110099567037314215)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_URL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\5C0E\5411\81F3 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110099492176314215)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_SUBMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110100088934314216)
,p_name=>'WWV_FLOW_PLUGIN_DEV.CLEAR_CACHE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664\5FEB\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109652027806313871)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_LEGACY_LOV_SQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('LOV \67E5\8A62\7121\6548, \9700\8981\6709\986F\793A\503C\548C\50B3\56DE\503C, \4E14\8CC7\6599\6B04\540D\7A31\5FC5\9808\4E0D\540C. \5982\679C\60A8\7684\67E5\8A62\5305\542B\5167\5D4C\67E5\8A62, SQL \6558\8FF0\53E5\7684\7B2C\4E00\500B FROM \5B50\53E5\4E0D\53EF\5C6C\65BC\5167\5D4C\67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109653736308313872)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_REGION_SOURCE_SQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5256\6790\5340\57DF\4F86\6E90\67E5\8A62! %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109034835794313397)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5256\6790 SQL \67E5\8A62! %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110123357726314251)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL_SIMPLE'
,p_message_language=>'zh-tw'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109652165557313871)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_STATIC_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\975C\614B LOV\300D\7121\6548, \9700\8981\986F\793A\503C\548C\50B3\56DE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109587730300313820)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\683C\3001\8996\89C0\8868\6216\540C\7FA9\5B57\4E0D\5B58\5728!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109034313333313397)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_OPTIONAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \9078\53D6 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109652457414313871)
,p_name=>'WWV_FLOW_PLUGIN_DEV.LOV_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\5C0D\4F7F\7528\6B64\986F\793A\985E\578B\7684\9805\76EE\6307\5B9A\503C\6E05\55AE (LOV) \67E5\8A62\6216\5177\540D\7684\503C\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109652341255313871)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NAMED_LOV_NOT_ALLOWED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\6709\81F3\5C11\9700\8981\5169\500B\300C\503C\6E05\55AE (LOV)\300D\8CC7\6599\6B04\7684\9805\76EE\985E\578B\624D\652F\63F4\4F7F\7528\5177\540D\7684 LOV.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109035048148313397)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_INTEGER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\5FC5\9808\662F\6574\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109034947034313397)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_NUMBER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\5FC5\9808\662F\6578\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110099733921314215)
,p_name=>'WWV_FLOW_PLUGIN_DEV.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108960694610313335)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_HAS_WRONG_DATA_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\7684\8CC7\6599\985E\578B\932F\8AA4. \6B64\5C6C\6027\8981\6C42\8CC7\6599\6B04\5FC5\9808\662F\4E0B\5217\8CC7\6599\985E\578B\4E4B\4E00: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108948938355313325)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\4E0D\5B58\5728\6216\5340\57DF\4F86\6E90\67E5\8A62\7121\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108960703358313335)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_WRONG_DATA_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\7684\8CC7\6599\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109653330837313872)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\66FF\6B64\5340\57DF\985E\578B\7684\5340\57DF\6307\5B9A\5340\57DF\4F86\6E90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109653473921313872)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31 "%0" \5DF2\7D93\7528\65BC\5340\57DF\4F86\6E90\67E5\8A62\4E2D. \8ACB\78BA\5B9A\60A8\8CC7\6599\6B04\4F7F\7528\7684\662F\552F\4E00\7684\5225\540D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109653542979313872)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_INVALID_COLUMN_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31 "%0" \5C0D\65BC\5340\57DF\4F86\6E90\67E5\8A62\800C\8A00\7121\6548. \8ACB\78BA\5B9A\60A8\8CC7\6599\6B04\4F7F\7528\7684\662F\552F\4E00\7684\5225\540D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109653658192313872)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4F86\6E90\67E5\8A62\4E2D\6240\9078\7684\8CC7\6599\6B04\6578\76EE\4E0D\6B63\78BA. \8ACB\53C3\95B1\7BC4\4F8B, \77AD\89E3\6709\6548\7684\6558\8FF0\53E5.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110099922897314215)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REQUEST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110099860142314215)
,p_name=>'WWV_FLOW_PLUGIN_DEV.RESET_PAGINATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D\6B64\9801\9762\7684\5206\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110100100449314231)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SET_THESE_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\9019\4E9B\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109653084464313872)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31 "%0" \5DF2\7D93\7528\65BC SQL \67E5\8A62\4E2D. \8ACB\78BA\5B9A\60A8\8CC7\6599\6B04\4F7F\7528\7684\662F\552F\4E00\7684\5225\540D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109652932096313872)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_INVALID_COLUMN_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\540D\7A31 "%0" \5C0D\65BC SQL \67E5\8A62\800C\8A00\7121\6548. \8ACB\78BA\5B9A\60A8\8CC7\6599\6B04\4F7F\7528\7684\662F\552F\4E00\7684\5225\540D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109035977326313398)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \67E5\8A62\4E2D\6240\9078\7684\8CC7\6599\6B04\6578\76EE\4E0D\6B63\78BA. \8ACB\53C3\95B1\5C6C\6027\300C\8AAA\660E\300D\77AD\89E3\8A73\7D30\8CC7\8A0A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109652248287313871)
,p_name=>'WWV_FLOW_PLUGIN_DEV.STATIC_LOV_NOT_ALLOWED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\6709\81F3\5C11\9700\8981\5169\500B\300C\503C\6E05\55AE (LOV)\300D\8CC7\6599\6B04\7684\9805\76EE\985E\578B\624D\652F\63F4\4F7F\7528\975C\614B LOV.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110100335790314232)
,p_name=>'WWV_FLOW_PLUGIN_DEV.URL_TARGET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('URL \76EE\6A19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110100202964314231)
,p_name=>'WWV_FLOW_PLUGIN_DEV.WITH_THESE_VALUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\542B\9019\4E9B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109154909408313486)
,p_name=>'WWV_FLOW_POPUP_LOV.CONVERT_ID_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1711 \7121\6CD5\8F49\63DB\8981\6C42\4E2D\7684\5373\73FE\5F0F LOV ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109155084283313487)
,p_name=>'WWV_FLOW_POPUP_LOV.FIND_ITEM_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1721 \5728\8981\6C42\4E2D\627E\4E0D\5230\5373\73FE\5F0F LOV ID \7684\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108928808510313309)
,p_name=>'WWV_FLOW_PRINT_UTIL.INVALID_PROXY_URL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684 URL \4E0D\6B63\78BA\6216\5FC5\9808\6307\5B9A\4EE3\7406\4E3B\6A5F URL, \7121\6CD5\9023\7DDA\5217\5370\5F15\64CE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109833401369314023)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.ABOVE_BOX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4E0A\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109833846422314023)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BELOW_BOX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\4E0B\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109833905796314023)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BOTTOM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\5E95\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109833565051314023)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.LEFT_OF_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C\5DE6\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109833109464314023)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_IR_SEARCH_BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\5831\8868\641C\5C0B\5217\53F3\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109833691183314023)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C\53F3\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109833713525314023)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TEMPLATE_DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109833248512314023)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\9802\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109833361071314023)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP_AND_BOTTOM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\9802\7AEF\8207\5E95\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109834034630314024)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.AFTER_HEADER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D\4E4B\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109834164720314024)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.BEFORE_FOOTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\5C3E\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110056655129314183)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\5143\4EF6! \5176\4ED6\4F7F\7528\8005\53EF\80FD\5DF2\522A\9664\8A72\5143\4EF6. \8ACB\91CD\65B0\8F09\5165\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110056583151314183)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5143\4EF6 ''%0'' \53C3\7167\6B64\5143\4EF6, \56E0\6B64\7121\6CD5\5C07\5176\522A\9664!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110056466930314183)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 %1 \4E0A\7684\5143\4EF6 ''%0'' \53C3\7167\6B64\5143\4EF6, \56E0\6B64\7121\6CD5\5C07\5176\522A\9664!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110056770161314183)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_CHANGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6\4F7F\7528\8005\5DF2\8B8A\66F4\5C6C\6027! \8ACB\91CD\65B0\8F09\5165\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110056989016314183)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C6C\6027\4E0D\5728\6B64\76F8\95DC\8CC7\8A0A\74B0\5883\4E2D!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110056828757314183)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6\4F7F\7528\8005\5DF2\8B8A\66F4\5143\4EF6, \4E14\6B64\5C6C\6027\5DF2\4E0D\5B58\5728! \8ACB\91CD\65B0\8F09\5165\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109551194214313789)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5728\5256\6790 "%0" \4E2D\50B3\56DE\7684\67E5\8A62\7D50\679C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110143777245314266)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_REGION_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5256\6790 "%0" \4E2D\50B3\56DE\7684\67E5\8A62\7D50\679C. \5982\679C\60A8\78BA\4FE1\67E5\8A62\8A9E\6CD5\6B63\78BA, \8ACB\52FE\9078\4E0B\65B9\7684\300C\4F7F\7528\4E00\822C\8CC7\6599\6B04\540D\7A31\300D\6838\53D6\65B9\584A, \4EE5\7E7C\7E8C\800C\4E0D\9032\884C\5256\6790.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110095127658314212)
,p_name=>'WWV_FLOW_PROPERTY_DEV.MUST_BE_UNIQUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\662F\552F\4E00\7684!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109834262015314024)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NO_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\6A23\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109551046492313789)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \5340\584A\672A\50B3\56DE\4EFB\4F55\67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110143873066314267)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_REGION_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \5340\584A\672A\50B3\56DE\4EFB\4F55\67E5\8A62. \5982\679C\60A8\78BA\4FE1\7A0B\5F0F\78BC\8A9E\6CD5\6B63\78BA, \8ACB\52FE\9078\4E0B\65B9\7684\300C\4F7F\7528\4E00\822C\8CC7\6599\6B04\540D\7A31\300D\6838\53D6\65B9\584A, \4EE5\7E7C\7E8C\800C\4E0D\9032\884C\5256\6790.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109834424158314024)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\88AB\5176\4ED6\4F7F\7528\8005\9396\5B9A!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109834393004314024)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED_SAVE_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\76EE\524D\7531 %0 \9396\5B9A! \7121\6CD5\5132\4EFB\4F55\8B8A\66F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109441361764313706)
,p_name=>'WWV_FLOW_PROVISION.CANNOT_EXTEND_TS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\64F4\5145\8868\683C\7A7A\9593, \56E0\70BA\6B64 %0  \5DF2\7D93\6C92\6709\7DB1\8981.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109155125312313487)
,p_name=>'WWV_FLOW_PROVISION.DROP_TABLESPACE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('drop_tablespace \767C\751F\932F\8AA4, p_name \662F\7A7A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109155323438313487)
,p_name=>'WWV_FLOW_PROVISION.DROP_USER_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('drop_user no l_username \767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110150734176314272)
,p_name=>'WWV_FLOW_PROVISION.ENCRYPTION_WALLET_NOT_OPEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52A0\5BC6\516C\4E8B\5305\672A\958B\555F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108953974169313330)
,p_name=>'WWV_FLOW_PROVISION.ILLEGAL_PASSWORD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\9001\81F3 wwv_flow_provision.create_user \7684\5BC6\78BC\5B57\4E32\7121\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109155948281313487)
,p_name=>'WWV_FLOW_PROVISION.REMOVE_COMPANY_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('remove_provisioned_company \6709\932F\8AA4.  \5DE5\4F5C\5340\662F\7A7A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109155730539313487)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_TABLESPACE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\8868\683C\7A7A\9593. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109155615442313487)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_USER_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\4F7F\7528\8005. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109155282376313487)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_TABLESPACE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\522A\9664\8868\683C\7A7A\9593. \932F\8AA4: %0 \005Cnsql:\005Cn %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109155480464313487)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_USER_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\522A\9664\4F7F\7528\8005. \932F\8AA4: %0 \005Cnsql:\005Cn %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109155861817313487)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_GRANT_PRIVS_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\6388\4E88\8D77\59CB\6B0A\9650. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108920111499313303)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_TO_CREATE_TABLESPACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7121\6CD5\5EFA\7ACB\8868\683C\7A7A\9593. \8ACB\7A0D\5F8C\518D\8A66.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109155578784313487)
,p_name=>'WWV_FLOW_PROVISION.WITH_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4: %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108998539500313370)
,p_name=>'WWV_FLOW_PROVISIONING.AUTO_PROVISION_FAILURE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('"MAKE_REQUEST" \968E\6BB5\6642\81EA\52D5\4F48\5EFA\5931\6557')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109018155341313384)
,p_name=>'WWV_FLOW_PROVISIONING.CANNOT_FIND_SGID'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\6CD5\5224\65B7\6307\5B9A\4E4B\5DE5\4F5C\5340 ID = "%0" \7684\5B89\5168\6027\7FA4\7D44 ID '),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108998856399313370)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_RESERVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340 %0 \662F\4FDD\7559\7684\540D\7A31, \8981\6C42\88AB\62D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108998630626313370)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_USER_ADD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\4F7F\7528\8005\81F3\5DE5\4F5C\5340 %0 \6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109156255196313487)
,p_name=>'WWV_FLOW_PROVISIONING.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109138063005313474)
,p_name=>'WWV_FLOW_PROVISIONING.NOT_IMPLEMENTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5C0E\5165.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108998356709313370)
,p_name=>'WWV_FLOW_PROVISIONING.NO_COMPANY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\4EE5\4E0B\5DE5\4F5C\5340 ID \7684\5DE5\4F5C\5340: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108998475569313370)
,p_name=>'WWV_FLOW_PROVISIONING.NO_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6307\5B9A\7DB1\8981\7D66\53F3\5217\5DE5\4F5C\5340 ID : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109018252910313385)
,p_name=>'WWV_FLOW_PROVISIONING.REMOVE_LAST_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7121\6CD5\4F7F\7528\6B64\5DE5\5177\4F86\79FB\9664\5DE5\4F5C\5340\7684\6700\5F8C\4E00\500B\7DB1\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108999267926313370)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\8981\6C42 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108999015887313370)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_PROCESSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8655\7406\8981\6C42 %0.  %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108998776814313370)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_PROCESSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8981\6C42\5DF2\7D93\8655\7406\6216\6B63\5728\8655\7406.  \72C0\614B\5FC5\9808\662F "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109018548202313385)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_COMPANY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340 %1 \4E2D\6C92\6709\4F7F\7528\8005\540D\7A31 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109018450012313385)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\80FD\91CD\8A2D\672A\8207\60A8\7684\5DE5\4F5C\5340\95DC\806F\4E4B\7DB1\8981\7684\5BC6\78BC.  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109018329713313385)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_RESERVED_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\91CD\8A2D\7DB1\8981 %0 \7684\5BC6\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108999162542313370)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%2 \8868\683C\4E2D\6709\7DB1\8981 %1, \56E0\6B64\7121\6CD5\8655\7406\8981\6C42 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108998943739313370)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_RESERVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981\540D\7A31 %0 \662F\4FDD\7559\7684\7DB1\8981, \7121\6CD5\4F48\5EFA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108998259337313370)
,p_name=>'WWV_FLOW_PROVISIONING.USER_NO_PRIVILEGES'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4F7F\7528\8005 %0 \6C92\6709 %1 \7DB1\8981\7684\6B0A\9650.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108958209945313333)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYSIS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5206\6790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108961034526313335)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\6790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108943991929313321)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_DBACCOUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8CC7\6599\5EAB\5E33\6236\8B49\660E\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108975008698313346)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_INTERNAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\6B64\61C9\7528\7A0B\5F0F\4E2D\7684\5167\90E8 %0 \5E33\6236\8B49\660E\8CC7\6599\548C\767B\5165\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109654330182313873)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_SSO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528 Oracle Application Server Single Sign-On.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108958321815313333)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108958103705313333)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHOOSE_A_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\4E00\500B\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108960342771313335)
,p_name=>'WWV_FLOW_QUICK_FLOW.CLEAR_CACHE_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\6E05\9664\5FEB\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110037905648314170)
,p_name=>'WWV_FLOW_QUICK_FLOW.COLUMN_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165 #COLUMN_HEADER# \503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108988497555313357)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_ANALYZE_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\5206\6790\9801\9762. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109006631427313376)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_BUTTON_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\6309\9215\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109007460506313377)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_CHART_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\5716\8868\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109006060360313376)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_FLOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109007850885313377)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_HOME_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\9996\9801. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109007239450313376)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_INSERT_FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\63D2\5165\8868\55AE. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109006260236313376)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LABEL_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\6A19\7C64\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109007971349313377)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\6E05\55AE. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109008042906313377)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\6E05\55AE\9805\76EE. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109005906981313375)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\6E05\55AE\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109007003134313376)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\5C0E\89BD\8DEF\5F91. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109006563197313376)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\5C0E\89BD\8DEF\5F91\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109008449380313377)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MODULES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\6A21\7D44.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109006905707313376)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NAVBAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\5C0E\89BD\5217. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108958507986313333)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\65B0 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108961207484313335)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109006187981313376)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_PAGE_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\9801\9762\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109006498052313376)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REGION_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\5340\57DF\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109007174764313376)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\5831\8868\9801\9762. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109006348292313376)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\5831\8868\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109008122056313377)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_SUCCESS_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\6210\529F\9801\9762. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109006811621313376)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\6A19\6E96\9801\7C64. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109007321951313377)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_UPDATE_FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\66F4\65B0\8868\55AE. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108960291153313335)
,p_name=>'WWV_FLOW_QUICK_FLOW.CSV_LINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A66\7B97\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110038188226314170)
,p_name=>'WWV_FLOW_QUICK_FLOW.DATE_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#COLUMN_HEADER# \5FC5\9808\662F\6709\6548\7684\65E5\671F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109008281217313377)
,p_name=>'WWV_FLOW_QUICK_FLOW.DEFINE_DEFAULT_TEMPLATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\5B9A\7FA9\8981\7528\65BC\5EFA\7ACB\61C9\7528\7A0B\5F0F\7684\9810\8A2D\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108962794113313337)
,p_name=>'WWV_FLOW_QUICK_FLOW.DISPLAY_REGION_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\986F\793A\9801\9762\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108959768022313334)
,p_name=>'WWV_FLOW_QUICK_FLOW.HELP_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\986F\793A\9801\9762\8AAA\660E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108960084000313334)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D2\5165 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108958490360313333)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D2\5165\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108959244843313334)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ANOTHER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D2\5165\53E6\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108960561830313335)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5C07\8CC7\6599\5217\63D2\5165 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108959168533313334)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9806\5229\63D2\5165\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109422318012313692)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \5FC5\9808\662F\6709\6548\7684\65E5\671F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108958906362313334)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_NUM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \5FC5\9808\662F\6578\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109358535135313643)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_TIMESTAMP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \5FC5\9808\662F\6709\6548\7684\6642\6233.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108959937168313334)
,p_name=>'WWV_FLOW_QUICK_FLOW.MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5C0E\89BD\8DEF\5F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108958838743313333)
,p_name=>'WWV_FLOW_QUICK_FLOW.NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A %0 \7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110038096814314170)
,p_name=>'WWV_FLOW_QUICK_FLOW.NUMERIC_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#COLUMN_HEADER# \5FC5\9808\662F\6578\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109006742128313376)
,p_name=>'WWV_FLOW_QUICK_FLOW.POPUP_LOV_TEMPLATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\300C\5373\73FE\5F0F\503C\6E05\55AE\6A23\677F\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108961152224313335)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_AND_EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\544A\53CA\7DE8\8F2F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108960142660313334)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\986F\793A\5831\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108960410665313335)
,p_name=>'WWV_FLOW_QUICK_FLOW.RESET_PAGINATION_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\91CD\8A2D\5206\9801.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108959460493313334)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_HOME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8FD4\56DE\9996\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108959836606313334)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_PREV_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8FD4\56DE\4E0A\4E00\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108957946744313333)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110075068421314196)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.ALL_APPS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\6240\6709\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110074292855314195)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.APPS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110074062190314195)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.TEAM.DEV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\5718\968A\958B\767C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110074730954314196)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108958088086313333)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_CHART_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5716\8868\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108962496487313336)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_MENU_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\986F\793A\5C0E\89BD\8DEF\5F91.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108959586327313334)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108959093382313334)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110038299398314170)
,p_name=>'WWV_FLOW_QUICK_FLOW.TIMESTAMP_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#COLUMN_HEADER# \5FC5\9808\662F\6709\6548\7684\6642\6233\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108958772266313333)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108958668713313333)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE_FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109008327740313377)
,p_name=>'WWV_FLOW_QUICK_FLOW.USE_ONE_LEVEL_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\53EA\80FD\4F7F\7528\4E00\500B\5C64\7D1A\9801\7C64\4F86\7D44\5EFA\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108959342134313334)
,p_name=>'WWV_FLOW_QUICK_FLOW.VIEW_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108989470054313358)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ABOUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\65BC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108989521144313358)
,p_name=>'WWV_FLOW_REGION_LAYOUT.BRANCHING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\652F\8655\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109153737972313486)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108979798206313350)
,p_name=>'WWV_FLOW_REGION_NATIVE.JQM_LIST_VIEW.NESTED_LIST_CLIENT_SEARCH_ONLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE2\72C0\6E05\55AE\50C5\652F\63F4\300C\5F9E\5C6C\7AEF\300D\70BA\641C\5C0B\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109141810254313477)
,p_name=>'WWV_FLOW_REGION_TREE.UNEXPECTED_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9810\671F\7684\932F\8AA4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109125471083313464)
,p_name=>'WWV_FLOW_REGION_TREES.ROOT_NOT_FND_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A: \627E\4E0D\5230\6A39\72C0\7D50\69CB\6839\76EE\9304 ID "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109337700954313628)
,p_name=>'WWV_FLOW_REMOTE_EXEC.RUN_PLSQL_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\9060\7AEF SQL \6642, PLSQL \7A0B\5F0F\78BC\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108897799255313285)
,p_name=>'WWV_FLOW_REPORT_DEV.CREATE_CARDS_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\5361\7247\9801\9762. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109479507142313735)
,p_name=>'WWV_FLOW_REST.NOT_ENABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\57F7\884C\8655\7406\672A\555F\7528 RESTful \5B58\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109477820647313734)
,p_name=>'WWV_FLOW_REST.NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\5340\57DF, \6216\5340\57DF\672A\555F\7528 REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109477976853313734)
,p_name=>'WWV_FLOW_REST.NO_OUTPUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6307\5B9A\8F38\51FA\65B9\6CD5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109128477005313467)
,p_name=>'WWV_FLOW_SECURITY.COMPANY_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8981\6709\5DE5\4F5C\5340.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109128590026313467)
,p_name=>'WWV_FLOW_SECURITY.FLOW_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8981\6709\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109128647473313467)
,p_name=>'WWV_FLOW_SECURITY.INVALID_USER_PASS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\4F7F\7528\8005\540D\7A31 "%0" \6216\5BC6\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109357935321313643)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.INSERTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D2\5165 %0 \500B\65B0\5C6C\6027, \800C\4E14\53EF\80FD\9700\8981\7FFB\8B6F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109358026709313643)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.PURGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5C07 %0 \500B\5C6C\6027\6C38\4E45\6E05\9664, \5DF2\7D93\4E0D\9700\8981\7FFB\8B6F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108990354628313358)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_DELETE_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5EFA\522A\9664\932F\8AA4: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108990274486313358)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_INSERT_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5EFA\63D2\5165\932F\8AA4: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109358112897313643)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TOTAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\5171\6709 %0 \500B\5C6C\6027\53EF\80FD\9700\8981\7FFB\8B6F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108990150041313358)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TRANSLATION_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\61C9\7528\7A0B\5F0F %1 \7684 %0 \7FFB\8B6F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109357865151313643)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0 %0 \500B\73FE\6709\7684\5C6C\6027, \800C\4E14\53EF\80FD\9700\8981\7FFB\8B6F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109164942842313494)
,p_name=>'WWV_FLOW_SERIES_ATTR.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109428378022313696)
,p_name=>'WWV_FLOW_SESSION_MON.NO_INDEX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709 %0 \7684\7D22\5F15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109359057461313644)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_INCOMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96C6\5408 <code>%0</code> \4E2D\7684\8CC7\6599\9644\52A0\4E86 <b id="incompl_success_row_count"></b> \4EFD\65B0\6587\4EF6. <b class="u-danger-text" id="incompl_fail_row_count"></b> \4EFD\6587\4EF6\88AB\62D2\7D55.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109358819084313644)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96C6\5408 <code>%0</code> \4E2D\7684\8CC7\6599\5DF2\9644\52A0 <b id="success_row_count"></b> \4EFD\65B0\6587\4EF6!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108896821008313284)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109359224537313644)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT_SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108897079759313285)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108896745539313284)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_KEY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D22\5F15\9375')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108897158696313285)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_LASTMODIFIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\6B21\4FEE\6539\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108896902379313285)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_MEDIA_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5A92\9AD4\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108902186575313289)
,p_name=>'WWV_FLOW_SODA_DEV.DATA_GUIDE_NOT_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5C0E\5F15\7121\6CD5\4F7F\7528. \96C6\5408\672A\5305\542B\4EFB\4F55\8CC7\6599, \6216\8005\5C1A\672A\5EFA\7ACB JSON \641C\5C0B\7D22\5F15.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108896016785313284)
,p_name=>'WWV_FLOW_SODA_DEV.FILE_FORMATS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\50B3 JSON\3001TXT \6216 ZIP \6A94\6848.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108902287394313289)
,p_name=>'WWV_FLOW_SODA_DEV.META_DATA_NOT_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\5F97\96C6\5408\63CF\8FF0\8CC7\6599. \8ACB\6AA2\67E5\96C6\5408\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109359119428313644)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_INCOMPLETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96C6\5408 <code>%0</code> \4E2D\7684\8CC7\6599\5DF2\7531 <b id="incompl_success_row_count"></b> \4EFD\65B0\6587\4EF6\53D6\4EE3. <b class="u-danger-text" id="incompl_fail_row_count"></b> \4EFD\6587\4EF6\88AB\62D2\7D55.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109358929822313644)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96C6\5408 <code>%0</code> \4E2D\7684\8CC7\6599\5DF2\7531 <b id="success_row_count"></b> \4EFD\65B0\6587\4EF6\53D6\4EE3!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109142721947313477)
,p_name=>'WWV_FLOW_SVG.AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\5931\6557: \5EA7\6A19\8EF8\9593\9694\5FC5\9808\5927\65BC 0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109142578739313477)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_MIN_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\5931\6557: \5EA7\6A19\8EF8\4E0A\9650\5FC5\9808\5927\65BC\5EA7\6A19\8EF8\4E0B\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109142950572313477)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\5931\6557: \5EA7\6A19\8EF8\4E0A\9650\5FC5\9808\5927\65BC 0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109142823056313477)
,p_name=>'WWV_FLOW_SVG.AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\5931\6557: \5EA7\6A19\8EF8\4E0B\9650\5FC5\9808\5927\65BC\6216\7B49\65BC 0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109142680848313477)
,p_name=>'WWV_FLOW_SVG.BAR_WIDTH_GT_ZERO_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\5931\6557: \9577\689D\5BEC\5EA6\5FC5\9808\5927\65BC 0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109142270201313477)
,p_name=>'WWV_FLOW_SVG.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109144284148313478)
,p_name=>'WWV_FLOW_SVG.FETCH_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64F7\53D6\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109144077128313478)
,p_name=>'WWV_FLOW_SVG.FUNC_RET_SQL_QRY_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\56DE SQL \67E5\8A62\7684\51FD\6578: \67E5\8A62\7121\6CD5\5728\61C9\7528\7A0B\5F0F\7522\751F\5668\5167\5256\6790. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109143152011313478)
,p_name=>'WWV_FLOW_SVG.GAPS_GT_ZERO_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\5931\6557: \9577\689D\584A\4E4B\9593\7684\9593\8DDD\5FC5\9808\5927\65BC\6216\7B49\65BC 0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109142310134313477)
,p_name=>'WWV_FLOW_SVG.MAX_ROWS_GT_ZERO_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\5931\6557: \8981\986F\793A\7684\8CC7\6599\5217\4E0A\9650\5FC5\9808\5927\65BC 0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109144595821313479)
,p_name=>'WWV_FLOW_SVG.MORE_DATA_FND_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\5230\5F88\591A\8CC7\6599, \4F46\7121\6CD5\986F\793A 30 \500B\4EE5\4E0A\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109144142224313478)
,p_name=>'WWV_FLOW_SVG.PARSE_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5256\6790\932F\8AA4: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109144420285313479)
,p_name=>'WWV_FLOW_SVG.SVG_CHART_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300CSVG \5716\8868\300D\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109144349314313478)
,p_name=>'WWV_FLOW_SVG.UNABLE_CALC_GRAPH_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A08\7B97\5716\5F62\9810\7559\4F4D\7F6E: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109143953690313478)
,p_name=>'WWV_FLOW_SVG.UNABLE_GET_COLOR_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\5F97\8272\5F69: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109143398586313478)
,p_name=>'WWV_FLOW_SVG.X_AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\5931\6557:\300CX \8EF8\300D\9593\9694\5FC5\9808\5927\65BC 0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109143715827313478)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\5931\6557:\300CX \8EF8\300D\4E0A\9650\5FC5\9808\5927\65BC 0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109143501048313478)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\5931\6557:\300CX \8EF8\300D\4E0B\9650\5FC5\9808\5927\65BC\6216\7B49\65BC 0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109143418187313478)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\5931\6557:\300CY \8EF8\300D\9593\9694\5FC5\9808\5927\65BC 0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109143227744313478)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_MIN_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\5931\6557:\300CY \8EF8\300D\4E0A\9650\5FC5\9808\5927\65BC\5EA7\6A19\8EF8\4E0B\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109143893689313478)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\5931\6557:\300CY \8EF8\300D\4E0A\9650\5FC5\9808\5927\65BC 0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109143649015313478)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49\5931\6557: \300CY \8EF8\300D\4E0B\9650\5FC5\9808\5927\65BC\6216\7B49\65BC 0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109140411612313476)
,p_name=>'WWV_FLOW_SW_API.ADD_MEMBER_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\6210\54E1\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108944640354313322)
,p_name=>'WWV_FLOW_SW_API.CANNOT_RUN_CMD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \547D\4EE4\88AB\963B\65B7.  \7121\6CD5\5F9E SQL \5DE5\4F5C\5BA4\57F7\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109137396817313473)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005 %0 \6C92\6709 %1 \7DB1\8981\7684\6B0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108957399608313332)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV_OBJ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DB1\8981 %0 \6C92\6709\8868\683C\6216\8996\89C0\8868 %1 \7684\9078\53D6\6B0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109140629066313476)
,p_name=>'WWV_FLOW_SW_API.CREATE_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\547D\4EE4\6A94\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109137460845313473)
,p_name=>'WWV_FLOW_SW_API.CREATE_PLAN_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\8A08\756B\8868\683C\4F86\5E6B\52A9\8AAA\660E\8A08\756B\9673\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109137952892313474)
,p_name=>'WWV_FLOW_SW_API.CREATE_SCRIPT_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\547D\4EE4\6A94\6A94\6848\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109137591967313473)
,p_name=>'WWV_FLOW_SW_API.ERROR_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C %0 \884C\767C\751F\932F\8AA4: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109137712057313474)
,p_name=>'WWV_FLOW_SW_API.INSERT_SCRIPT_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D2\5165\547D\4EE4\6A94\81F3\6A94\6848\8868\683C\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110085895405314204)
,p_name=>'WWV_FLOW_SW_API.INVALID_ROWID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\8CC7\6599\5217 ID:  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109137888854313474)
,p_name=>'WWV_FLOW_SW_API.PARSE_SCRIPT_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5256\6790\547D\4EE4\6A94\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109137678502313474)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\4E2D\6C92\6709 "%0" \7DB1\8981.  \8ACB\6D3D\8A62\60A8\7684\5DE5\4F5C\5340\7BA1\7406\54E1, \70BA\60A8\8A2D\5B9A\6B63\78BA\7684\9810\8A2D\7DB1\8981.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108938141994313317)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL_ARR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('run_sql_arr \767C\751F\932F\8AA4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109140515849313476)
,p_name=>'WWV_FLOW_SW_API.UPDATE_MEMBER_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\6210\54E1\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108957214025313332)
,p_name=>'WWV_FLOW_SW_PARSER.LINE_EXCEEDS_32K'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\547D\4EE4\6A94\884C\8D85\904E 32767 \500B\4F4D\5143\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108924134680313306)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109172929030313500)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108925123279313306)
,p_name=>'WWV_FLOW_SW_SCRIPT.COMPLETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108925585293313307)
,p_name=>'WWV_FLOW_SW_SCRIPT.ELAPSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \79D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108924223674313306)
,p_name=>'WWV_FLOW_SW_SCRIPT.EXECUTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108983046956313353)
,p_name=>'WWV_FLOW_SW_SCRIPT.INVALID_STMT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\57F7\884C\542B\6709\4E0D\660E\6558\8FF0\53E5\7684\547D\4EE4\6A94. \8ACB\79FB\9664\4E0B\5217\6558\8FF0\53E5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108925265297313306)
,p_name=>'WWV_FLOW_SW_SCRIPT.IN_PROGRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\884C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108982963421313353)
,p_name=>'WWV_FLOW_SW_SCRIPT.LINE_NUMBER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\865F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108944506360313322)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_NEST_LEVEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1004 \547D\4EE4\6A94\7684\5DE2\72C0\5C64\7D1A\4E0D\53EF\4EE5\8D85\904E %0 \500B\5C64\7D1A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108945851792313323)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_OUTPUT_REACHED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1005 \547D\4EE4\6A94\8F38\51FA\5DF2\9054\5927\5C0F\4E0A\9650.  \8ACB\8B8A\66F4\547D\4EE4\6A94\4EE5\6E1B\5C11\7522\751F\7684\8F38\51FA, \6216\6D3D\8A62\7BA1\7406\54E1\589E\52A0\547D\4EE4\6A94\7D50\679C\5927\5C0F\4E0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109274052855313575)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\547D\4EE4\6A94\8D85\904E\5141\8A31\4E4B %0 \500B\4F4D\5143\7D44\7684\5927\5C0F\4E0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108945974261313323)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_WORKSPACE_OUTPUT_REACHED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1005 \547D\4EE4\6A94\8F38\51FA\5DF2\9054\5DE5\4F5C\5340\7D50\679C\5927\5C0F\4E0A\9650. \8ACB\522A\9664\73FE\6709\7684\7D50\679C, \6216\6D3D\8A62\7BA1\7406\54E1\589E\52A0\5DE5\4F5C\5340\7D50\679C\5927\5C0F\4E0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109209066593313527)
,p_name=>'WWV_FLOW_SW_SCRIPT.NO_STMT_BUFFER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE9\885D\5340\4E2D\6C92\6709\8981\57F7\884C\7684\6558\8FF0\53E5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108939831612313318)
,p_name=>'WWV_FLOW_SW_SCRIPT.QUERY_LIMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SELECT \6558\8FF0\53E5\4E0D\80FD\5927\65BC 32KB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108925362819313306)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108925442547313307)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108940789417313319)
,p_name=>'WWV_FLOW_SW_SCRIPT.ROWS_SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9078\53D6 %0 \500B\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109168019525313496)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_EMPTY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\57F7\884C\672A\542B\4EFB\4F55\53EF\57F7\884C\6558\8FF0\53E5\7684\547D\4EE4\6A94.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108937934386313316)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_FILE_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\57F7\884C\547D\4EE4\6A94. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108938088589313316)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_STMT_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('run_statement \767C\751F\932F\8AA4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109167915886313496)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\8981\6C42\57F7\884C\7684\547D\4EE4\6A94\5167\542B SQL \5DE5\4F5C\5BA4\5C07\6703\5FFD\7565\7684\6558\8FF0\53E5. \8ACB\78BA\8A8D\60A8\7684\8981\6C42.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108944477048313322)
,p_name=>'WWV_FLOW_SW_SCRIPT.SCRIPT_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1001 \627E\4E0D\5230\547D\4EE4\6A94.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108924032770313305)
,p_name=>'WWV_FLOW_SW_SCRIPT.SUBMITTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9001\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109172471050313500)
,p_name=>'WWV_FLOW_SW_SCRIPT.UNKNOWN_STATEMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\660E\7684\6558\8FF0\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109172235362313499)
,p_name=>'WWV_FLOW_SW_SCRIPT.USED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\4F7F\7528 %0% ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109157956808313489)
,p_name=>'WWV_FLOW_SW_UTIL.PACKAGE_CREATE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \8A9E\6CD5\7121\6548, \56E0\6B64\7121\6CD5\5EFA\7ACB\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109157619406313489)
,p_name=>'WWV_FLOW_SW_UTIL.TABLE_CREATE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SQL \8A9E\6CD5\7121\6548, \56E0\6B64\7121\6CD5\5EFA\7ACB\8868\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108990597144313359)
,p_name=>'WWV_FLOW_SYNC_TRANSLATIONS.SYNC_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540C\6B65\932F\8AA4: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109314086243313610)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCED_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\7167\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109313948243313610)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53C3\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108988886889313357)
,p_name=>'WWV_FLOW_TABULAR_FORM.MAX_COLUMN_NO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5617\8A66\5B58\53D6\5C0D\61C9\81F3 PL/SQL \9663\5217 apex_application.g_f%0 \7684\5217\8868\5316\8868\55AE\8CC7\6599\6B04, \4F46\53EA\652F\63F4 %1 \500B\5132\5B58\72C0\614B\7684\8CC7\6599\6B04. \8ACB\6E1B\5C11\5132\5B58\72C0\614B\8CC7\6599\6B04\7684\6578\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109551516920313789)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_PARENT_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\7236\9805\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109336905976313627)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_STD_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\6A19\6E96\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109337506402313628)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\9801\7C64\96C6 (\60A8\53EF\4EE5\5728\65B0\9801\7C64\96C6\4E2D\5EFA\7ACB\300C\6A19\6E96\9801\7C64\300D)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109165236783313494)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\7236\9805\7C64 ID = %0 \7684\65B0\9801\7C64\96C6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109165128008313494)
,p_name=>'WWV_FLOW_TAB_MGR.OLD_TABSET_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\9801\7C64 ID = %0 \7684\820A\9801\7C64\96C6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109165320949313494)
,p_name=>'WWV_FLOW_TAB_MGR.PAGE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762 id: %0 \4E0D\662F\6578\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109337092376313627)
,p_name=>'WWV_FLOW_TAB_MGR.PAR_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7236\9805\9801\7C64. \9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109337407402313628)
,p_name=>'WWV_FLOW_TAB_MGR.PSEDUO_DESC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\8207\7236\9805\9801\7C64\95DC\806F. \5B83\76EE\524D\662F\986F\793A\70BA\300C\865B\64EC\7236\9805\9801\7C64\300D, \60A8\53EF\4EE5\7DE8\8F2F\6B64\9801\7C64\96C6\4E2D\7684\300C\6A19\6E96\9801\7C64\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109337672734313628)
,p_name=>'WWV_FLOW_TAB_MGR.SELECT_STD_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6A19\6E96\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109337252552313628)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PAR_TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7684\7236\9805\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109337141603313627)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PSD_PAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7684\865B\64EC\7236\9805\9801\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109165018533313494)
,p_name=>'WWV_FLOW_TAB_MGR.SGID_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8A2D\5B9A\5B89\5168\6027\7FA4\7D44 ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109165402612313494)
,p_name=>'WWV_FLOW_TAB_MGR.SPEC_NEW_TABSET_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\70BA\9801\7C64 id = %0 \6307\5B9A\65B0\9801\7C64\96C6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109336830005313627)
,p_name=>'WWV_FLOW_TAB_MGR.STD_TAB_SEQ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\6E96\9801\7C64. \9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109336742926313627)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_ALSO_CUR_FOR_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540C\6A23\4EE5\6B64\9801\7C64\4F5C\70BA\76EE\524D\9801\7C64\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109336649861313627)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_CUR_FOR_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EE5\6B64\9801\7C64\4F5C\70BA\76EE\524D\9801\7C64\7684\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109337398522313628)
,p_name=>'WWV_FLOW_TAB_MGR.THE_TAB_SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108991722770313360)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\61C9\7528\7A0B\5F0F "%1" \5DE5\4F5C\5340 "%2" \4E2D\627E\4E0D\5230\8981\8907\88FD\7684\6309\9215\6A23\677F (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108992627629313365)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_REPLACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\4EE3\6309\9215\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109158149793313489)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108991473259313359)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\61C9\7528\7A0B\5F0F "%1" \5DE5\4F5C\5340 "%2" \4E2D\627E\4E0D\5230\8981\8907\88FD\7684\6B04\4F4D\6A23\677F (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108992307070313360)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_REPLACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\4EE3\6B04\4F4D\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108992253644313360)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.LIST_TEMPLATE_REPLACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\4EE3\6E05\55AE\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108991694570313360)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\61C9\7528\7A0B\5F0F "%1" \5DE5\4F5C\5340 "%2" \4E2D\627E\4E0D\5230\8981\8907\88FD\7684\5C0E\89BD\8DEF\5F91\6A23\677F (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108992465509313365)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_REPLACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\4EE3\5C0E\89BD\8DEF\5F91\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108991992057313360)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.PAGE_TEMPLATE_REPLACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\4EE3\9801\9762\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108992507862313365)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_LOV_TEMPLATE_REPLACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\4EE3\300C\5373\73FE\5F0F\503C\6E05\55AE\6A23\677F\300D. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109274901523313581)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_TEMPLATE_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\61C9\7528\7A0B\5F0F "%1" \5DE5\4F5C\5340 "%2" \4E2D\627E\4E0D\5230\8981\8907\88FD\7684\5373\73FE\5F0F\6A23\677F (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108992074816313360)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REGION_TEMPLATE_REPLACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\4EE3\5340\57DF\6A23\677F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108992142129313360)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REPORT_TEMPLATE_REPLACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\4EE3\5831\8868\6A23\677F. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108991342204313359)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\8981\8907\88FD\7684\6A23\677F (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108991888473313360)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_REPLACE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\4EE3 %0 \6A23\677F. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110104804669314235)
,p_name=>'WWV_FLOW_THEME.STYLE_NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\4E3B\984C\6A23\5F0F\300D\4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110122320661314250)
,p_name=>'WWV_FLOW_THEME_DEV.IS_READ_ONLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\66F4\65B0\6A23\5F0F, \5176\70BA\552F\8B80!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110122298954314250)
,p_name=>'WWV_FLOW_THEME_DEV.WWV_FLOW_THEME_STYLE_UK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\73FE\6709\7684\6A23\5F0F\5DF2\7D93\4F7F\7528\6B64\540D\7A31!')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108990438378313359)
,p_name=>'WWV_FLOW_TRANSLATIONS.SEED_UPDATE_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5EFA\66F4\65B0\932F\8AA4: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109439440670313705)
,p_name=>'WWV_FLOW_UPGRADE.METADATA_DML_DISABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Application Express \6B63\5728\5347\7D1A\70BA\66F4\65B0\7248\672C. \5C0D\61C9\7528\7A0B\5F0F\7684\8B8A\66F4\5C07\6703\505C\7528, \76F4\5230\5347\7D1A\5B8C\6210\70BA\6B62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109102668586313447)
,p_name=>'WWV_FLOW_UTILITIES.ADD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108907989249313293)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\4EE5\8CC7\6599\5EAB\4F7F\7528\8005 %1 \8EAB\5206\767B\5165\7684\61C9\7528\7A0B\5F0F %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108908078727313293)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_PAGE_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\4EE5\8CC7\6599\5EAB\4F7F\7528\8005 %2 \8EAB\5206\767B\5165\7684\61C9\7528\7A0B\5F0F %0 \9801\9762 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109103668079313448)
,p_name=>'WWV_FLOW_UTILITIES.CAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\884C\4E8B\66C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109131659848313469)
,p_name=>'WWV_FLOW_UTILITIES.CHECKBOX_QUERY_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A55\4F30\6838\53D6\65B9\584A\67E5\8A62\6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109103796406313448)
,p_name=>'WWV_FLOW_UTILITIES.CLOSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109131268976313469)
,p_name=>'WWV_FLOW_UTILITIES.DISP_ONLY_LIST_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4: \50C5\986F\793A\503C\6E05\55AE\5FC5\9808\9078\53D6\5169\500B\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109102457622313447)
,p_name=>'WWV_FLOW_UTILITIES.ERR_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\6C7A\5B9A\300C\503C\6E05\55AE\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109104082509313448)
,p_name=>'WWV_FLOW_UTILITIES.FIND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0B\627E %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109153082135313485)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_POPUP_LOV_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7522\751F\300C\5373\73FE\5F0F\503C\6E05\55AE\300D\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109130976453313469)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_QUERY_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7522\751F\67E5\8A62\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109131004636313469)
,p_name=>'WWV_FLOW_UTILITIES.INIT_LOV_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D77\59CB\300C\503C\6E05\55AE\300D\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109131587004313469)
,p_name=>'WWV_FLOW_UTILITIES.INIT_QUERY_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8D77\59CB\67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109056881023313413)
,p_name=>'WWV_FLOW_UTILITIES.INVALID_LOV_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5373\73FE\5F0F\503C\6E05\55AE\300D\67E5\8A62\7121\6548, \9700\8981\986F\793A\548C\50B3\56DE\503C, \8CC7\6599\6B04\540D\7A31\5FC5\9808\4E0D\540C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109104197462313449)
,p_name=>'WWV_FLOW_UTILITIES.JS_NO_SUPPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\652F\63F4 JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109104323939313449)
,p_name=>'WWV_FLOW_UTILITIES.LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109104709603313449)
,p_name=>'WWV_FLOW_UTILITIES.LOV2_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\300C\503C\6E05\55AE\300D\67E5\8A62\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109103527605313448)
,p_name=>'WWV_FLOW_UTILITIES.NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109103146185313448)
,p_name=>'WWV_FLOW_UTILITIES.NO_MATCHES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\7B26\5408\7684\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109103824872313448)
,p_name=>'WWV_FLOW_UTILITIES.OK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78BA\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109152703557313485)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_BG_SELECT_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5373\73FE\5F0F\503C\6E05\55AE\300D\5FC5\9808\4EE5 "select" \70BA\958B\982D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109130857140313469)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\4F7F\7528\7BE9\9078\7522\751F\300C\5373\73FE\5F0F\503C\6E05\55AE\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109152952351313485)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_INIT_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EE5\4E0B\5217\7BE9\9078\521D\59CB\5316\300C\5373\73FE\5F0F\503C\6E05\55AE\300D\6642\767C\751F\932F\8AA4: %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109152865061313485)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_INIT_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D77\59CB\300C\5373\73FE\5F0F\503C\6E05\55AE\300D\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109131374216313469)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_AUTH_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5373\73FE\5F0F\503C\6E05\55AE\300D\8A8D\8B49\5931\6557.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109131498955313469)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_CHECK_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5373\73FE\5F0F\503C\6E05\55AE\300D\7E3D\548C\6AA2\9A57\9A57\8B49\5931\6557.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109103254148313448)
,p_name=>'WWV_FLOW_UTILITIES.PREV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109102867274313448)
,p_name=>'WWV_FLOW_UTILITIES.REMOVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109103981382313448)
,p_name=>'WWV_FLOW_UTILITIES.SEARCH_DIALOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\5C0D\8A71\65B9\584A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109714900095313933)
,p_name=>'WWV_FLOW_UTILITIES.SHOW_IMAGE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5F71\50CF\6642\767C\751F\932F\8AA4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109132134095313469)
,p_name=>'WWV_FLOW_UTILITIES.T_BOLD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C97\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109132593973313470)
,p_name=>'WWV_FLOW_UTILITIES.T_BULL_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\7B26\865F\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109132994774313470)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_LEFT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5411\5DE6\7E2E\6392')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109133042914313470)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_RIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5411\53F3\7E2E\6392')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109132292792313470)
,p_name=>'WWV_FLOW_UTILITIES.T_ITALICS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\659C\9AD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109132769208313470)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_CEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7F6E\4E2D\5C0D\9F4A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109132639659313470)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_LEFT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9760\5DE6\5C0D\9F4A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109132858338313470)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_RT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9760\53F3\5C0D\9F4A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109132443654313470)
,p_name=>'WWV_FLOW_UTILITIES.T_NO_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\865F\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109132303511313470)
,p_name=>'WWV_FLOW_UTILITIES.T_UNDERLINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E95\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109131151957313469)
,p_name=>'WWV_FLOW_UTILITIES.UNABLE_TO_BIND_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\9023\7D50 "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108907880138313293)
,p_name=>'WWV_FLOW_UTILITIES.WEBSHEET_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\4EE5\8CC7\6599\5EAB\4F7F\7528\8005 %1 \8EAB\5206\767B\5165\7684 Web \8A66\7B97\8868\61C9\7528\7A0B\5F0F %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109331871646313623)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_PROXY_OR_URL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\9023\7DDA Web \670D\52D9, \56E0\70BA\60A8\8F38\5165\7684 URL \7121\6548\3001\60A8\7684\74B0\5883\8981\6C42\70BA HTTP \8981\6C42\8A2D\5B9A\6709\6548\7684\4EE3\7406\4E3B\6A5F\4F3A\670D\5668\4F4D\5740\3001\8981\6C42\903E\6642, \6216\8005\9700\8981\70BA HTTPS \8981\6C42\8A2D\5B9A\516C\4E8B\5305. SQLERRM: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108978513114313349)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNRETRIEVABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\64F7\53D6 WSDL \6587\4EF6, \56E0\70BA\60A8\8F38\5165\7684 URL \7121\6548, \60A8\7684\74B0\5883\8981\6C42\70BA HTTP \8981\6C42\8A2D\5B9A\6709\6548\7684\4EE3\7406\4E3B\6A5F\4F3A\670D\5668\4F4D\5740, \800C\60A8\672A\66FF\6B64\61C9\7528\7A0B\5F0F\5B9A\7FA9\6B64\4F4D\5740, \6216\9700\8981\70BA &PRODUCT_NAME. \7684\9019\500B\57F7\884C\8655\7406\8A2D\5B9A\7528\65BC HTTPS \8981\6C42\7684\516C\4E8B\5305 .')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108979223263313350)
,p_name=>'WWV_FLOW_WIZARD_API.ACTION_PROCESSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\5DF2\8655\7406.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109561288956313800)
,p_name=>'WWV_FLOW_WIZARD_API.ADD_ROW_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\65B0\589E\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108973027601313345)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\6309\9215. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109009527982313378)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CALENDAR_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\884C\4E8B\66C6\9801\9762. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109009245670313378)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CHART_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\5716\8868\9801\9762. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109691626893313913)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_DATA_LOAD_WIZARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5B8C\6210\8CC7\6599\8F09\5165\8655\7406\4F5C\696D. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109009960427313378)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_EXCEL_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB Excel \5716\8868. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109009673794313378)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_EQUIJOIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\7B49\7D50\5408\8868\55AE. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109008867228313378)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_SP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB SP \8868\55AE. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109008963199313378)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_TABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\8868\683C\8868\55AE. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109009002326313378)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_INSERT_FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\63D2\5165\8868\55AE. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109493301810313745)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_JET_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB Oracle JET \5716\8868. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108895966308313284)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_MASTER_DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\4E3B\8981\660E\7D30\9801\9762. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109378741037313659)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_PAGE_DA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\52D5\614B\52D5\4F5C. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109009119934313378)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_QUERY_AND_UPDATE_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\67E5\8A62\4E26\66F4\65B0\9801\9762. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109009490586313378)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_REPORT_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\5831\8868\9801\9762. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109010024393313379)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SUMMARY_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\6458\8981\9801\9762. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109010165870313379)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SVG_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\300CSVG \5716\8868\300D\9801\9762. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109009888616313378)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_TREE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\6A39\72C0\7D50\69CB. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109008724548313378)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_UPDATEABLE_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\53EF\66F4\65B0\7684\5831\8868. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109009766704313378)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_WIZARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\300C\5EFA\7ACB\7CBE\9748\7684\7CBE\9748\300D. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109561104156313800)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8655\7406\522A\9664.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109561573398313801)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664 #MRD_COUNT# \500B\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108914908029313299)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\5F97\4E0B\4E00\500B\6216\4E0A\4E00\500B\4E3B\7D22\5F15\9375\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108914894397313298)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\53D6\5F97\4E0B\4E00\500B\6216\4E0A\4E00\500B\4E3B\7D22\5F15\9375\503C\300D\8655\7406\4F5C\696D\9700\8981\6709\6B64\6309\9215.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108914746328313298)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_ITEM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\53D6\5F97\4E0B\4E00\500B\6216\4E0A\4E00\500B\4E3B\7D22\5F15\9375\503C\300D\8655\7406\4F5C\696D\9700\8981\6709\6B64\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108915596916313299)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\57F7\884C\300C\53D6\5F97\4E0B\4E00\500B\6216\4E0A\4E00\500B\4E3B\7D22\5F15\9375\503C\300D\8655\7406\4F5C\696D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108924675131313306)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_SHORTCUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78BA\5B9A\8981\96E2\958B\6B64\9801\9762\4E14\4E0D\5132\5B58\55CE?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109273961556313575)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK2_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\5F97\6B21\8981\7D22\5F15\9375\9805\76EE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109273830432313575)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\5F97\4E3B\7D22\5F15\9375\9805\76EE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109009309796313378)
,p_name=>'WWV_FLOW_WIZARD_API.INVALID_REPORT_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\5831\8868\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109287959790313590)
,p_name=>'WWV_FLOW_WIZARD_API.IR_REPORT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\5831\8868\5DF2\7D93\5B58\5728. \60A8\53EA\80FD\5728\6BCF\500B\9801\9762\65B0\589E\4E00\500B\4E92\52D5\5F0F\5831\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108999832449313371)
,p_name=>'WWV_FLOW_WIZARD_API.NEXT_PREV_PK_PROCESS_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5EFA\7ACB\53D6\5F97\4E0B\4E00\500B\6216\4E0A\4E00\500B\4E3B\7D22\5F15\9375\503C\8655\7406\4F5C\696D. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109561063378313800)
,p_name=>'WWV_FLOW_WIZARD_API.NO_PAGE_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\6C92\6709\76F8\95DC\8AAA\660E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109008648927313377)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5256\6790\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109008528866313377)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5256\6790 error2 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109561663964313801)
,p_name=>'WWV_FLOW_WIZARD_API.REQUEST_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\9001\8981\6C42\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109561965825313801)
,p_name=>'WWV_FLOW_WIZARD_API.SHOW_TREE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\6A39\72C0\7D50\69CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109561777472313801)
,p_name=>'WWV_FLOW_WIZARD_API.TREE_ROOT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB\6839\76EE\9304')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108979037118313350)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_FETCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\64F7\53D6\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108979127334313350)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_PROCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8655\7406\8868\683C %0 \7684\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109010286872313379)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATEABLE_QUERY_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7D93\6709\53EF\66F4\65B0\7684\300CSQL \67E5\8A62\300D. \60A8\53EA\80FD\5728\6BCF\500B\9801\9762\65B0\589E\4E00\500B\53EF\66F4\65B0\7684 SQL \67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109561304638313800)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_APPLIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5957\7528\66F4\65B0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109561443393313800)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_INSERT_SUCCESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\66F4\65B0 #MRU_COUNT# \500B\8CC7\6599\5217, \5DF2\63D2\5165 #MRI_COUNT# \500B\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109431842591313699)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_AUTH_SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\6388\6B0A\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109431618526313699)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109431449378313699)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109431720563313699)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\73FE\6709\7684\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109431582277313699)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LOV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\73FE\6709\7684\503C\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109133287804313470)
,p_name=>'WWV_FLOW_WORKSHEET.SHOW_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE\5831\8868\6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109589479662313821)
,p_name=>'WWV_FLOW_WORKSPACE_REPORTS.TABLESPACE1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\5171 %0 GB | \5DF2\4F7F\7528 %1 GB | \5DF2\4F7F\7528\767E\5206\4E4B %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108906566312313292)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_PGA_AGG_TARGET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\65B0 PGA \805A\7E3D\76EE\6A19\6642\767C\751F\932F\8AA4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108906369674313292)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_SGA_TARGET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\65B0 SGA \76EE\6A19\6642\767C\751F\932F\8AA4. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110153962880314275)
,p_name=>'WWV_FLOW_XLIFF.ERROR_PROCESSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406 %0 \6642\767C\751F\932F\8AA4: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109128948428313467)
,p_name=>'WWV_RENDER_CHART2.T_AVERAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E73\5747\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109128806515313467)
,p_name=>'WWV_RENDER_CHART2.T_AXIS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EA7\6A19\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109129488845313467)
,p_name=>'WWV_RENDER_CHART2.T_FIRST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109129515379313468)
,p_name=>'WWV_RENDER_CHART2.T_GO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109129352309313467)
,p_name=>'WWV_RENDER_CHART2.T_LAST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109129107242313467)
,p_name=>'WWV_RENDER_CHART2.T_MAXIMUM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5927\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109129235157313467)
,p_name=>'WWV_RENDER_CHART2.T_MINIMUM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5C0F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109128747130313467)
,p_name=>'WWV_RENDER_CHART2.T_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109129020078313467)
,p_name=>'WWV_RENDER_CHART2.T_SUM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\548C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109064431765313419)
,p_name=>'WWV_RENDER_REPORT3.CURSOR_NOT_OPEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5256\6790\67E5\8A62, \6E38\6A19\5C1A\672A\958B\555F\6216\50B3\56DE SQL \67E5\8A62\7684\51FD\6578\672A\50B3\56DE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109424938016313694)
,p_name=>'WWV_RENDER_REPORT3.DUBLICATE_ALIAS_NAMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\67E5\8A62\5305\542B\91CD\8907\7684\5225\540D, \5831\8868\4F7F\7528\7684\67E5\8A62\9700\8981\552F\4E00\7684\5225\540D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109056509785313413)
,p_name=>'WWV_RENDER_REPORT3.ERR_PROC_FUNCTION_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\6CD5\8655\7406\50B3\56DE\67E5\8A62\7684\8655\7406\4F5C\696D\51FD\6578\4E3B\9AD4:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109142490849313477)
,p_name=>'WWV_RENDER_REPORT3.INVALID_COL_NUM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\8A62\4E2D\5B9A\7FA9\7684\8CC7\6599\6B04\6578\76EE\7121\6548, \6B64\5340\57DF\985E\578B\9700\8981 %0 \500B\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109064546793313419)
,p_name=>'WWV_RENDER_REPORT3.QUERY_CANNOT_BE_PARSED'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\50B3\56DE SQL \67E5\8A62\7684\51FD\6578: \7121\6CD5\5728\300C\7522\751F\5668\300D\5167\5256\6790\67E5\8A62. \5982\679C\60A8\76F8\4FE1\60A8\7684\67E5\8A62\8A9E\6CD5\662F\6B63\78BA\7684, \8ACB\52FE\9078\5340\57DF\4F86\6E90\4E0B\65B9\7684<strong>\4E00\822C\8CC7\6599\6B04</strong>\6838\53D6\65B9\584A, \4EE5\4FBF\7E7C\7E8C\4E14\4E0D\5256\6790.'),
'<br/>',
'(%0)'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109064687141313419)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR2'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7121\6CD5\5728\300C\7522\751F\5668\300D\5167\5256\6790\67E5\8A62. \5982\679C\60A8\76F8\4FE1\60A8\7684\67E5\8A62\8A9E\6CD5\662F\6B63\78BA\7684, \8ACB\52FE\9078\5340\57DF\4F86\6E90\4E0B\65B9\7684\300C\4E00\822C\8CC7\6599\6B04\300D\6838\53D6\65B9\584A, \4EE5\4FBF\7E7C\7E8C\4E14\4E0D\5256\6790.'),
'%0</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109140921666313476)
,p_name=>'WWV_SPELING.ADD_WORD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109141519868313476)
,p_name=>'WWV_SPELING.BUTTON_ADD_TO_DICTIONARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\81F3\5B57\5178')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109141439444313476)
,p_name=>'WWV_SPELING.BUTTON_APPLY_CHANGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528\8B8A\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109141335179313476)
,p_name=>'WWV_SPELING.BUTTON_CANCEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109141210082313476)
,p_name=>'WWV_SPELING.BUTTON_DONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109500128881313750)
,p_name=>'WWV_SPELING.BUTTON_SUBMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9001\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109141157244313476)
,p_name=>'WWV_SPELING.DUP_WORD_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5DF2\7D93\5728\60A8\7684\5B57\5178\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109141738031313477)
,p_name=>'WWV_SPELING.ENTER_NEW_WORD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\65B0\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109141633304313477)
,p_name=>'WWV_SPELING.PICK_A_WORD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\4E00\500B\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109359317000313644)
,p_name=>'WWV_SPELING.SPELL_CHECKER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62FC\5B57\6AA2\67E5\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109141081139313476)
,p_name=>'WWV_SPELING.WORD_ADDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\65B0\589E %0 \81F3\60A8\7684\5B57\5178.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108986328423313355)
,p_name=>'XML_LOAD_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('XML \8F09\5165\932F\8AA4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109411209203313683)
,p_name=>'X_ADDITIONAL_TAGS_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6709\53E6\5916 %0 \500B\6A19\8A18\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109412097255313684)
,p_name=>'X_BUGS_HAVE_NO_FIX_DATES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\932F\8AA4\6C92\6709\4FEE\6B63\5B8C\6210\65E5\671F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109586035056313819)
,p_name=>'YEARLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E74\5EA6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109039785812313401)
,p_name=>'YES_BY_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F, \6309\4F7F\7528\8005')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109068856866313422)
,p_name=>'YOUR_EMAIL_IUWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\96FB\5B50\90F5\4EF6\5DF2\5728\4E0B\5217\5DE5\4F5C\5340\7684\4F7F\7528\8005\8A3B\518A:')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(109350210335313637)
,p_name=>'YOU_ARE_NOW_LOGGED_OUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5DF2\7D93\767B\51FA.')
);
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(91645213681389498.4418)
,p_name=>'no auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_15=>'91645213681389498'
,p_invalid_session_type=>'LOGIN'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_comments=>'Based on authentication scheme from gallery:No Authentication (using DAD)'
);
end;
/
prompt --application/shared_components/plugins/region_type/breadcrumb
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3708767719669.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'BREADCRUMB'
,p_display_name=>unistr('\5C0E\89BD\8DEF\5F91')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','BREADCRUMB'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A\76EE\524D\9801\9762\7684\5C0E\89BD\8DEF\5F91\6B77\7A0B\6A94.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3709973247475.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'LIST'
,p_display_name=>unistr('\6E05\55AE')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','LIST'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\6839\64DA\975C\614B\6216\52D5\614B\6E05\55AE\986F\793A\503C. \9019\4E9B\503C\901A\5E38\7528\65BC\700F\89BD\61C9\7528\7A0B\5F0F\4E2D\7684\9801\9762.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_cancel
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3734497742532.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CANCEL'
,p_display_name=>unistr('\53D6\6D88\5C0D\8A71\65B9\584A')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CANCEL'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\53D6\6D88\76EE\524D\7684\5C0D\8A71\65B9\584A\9801\9762.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_close
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3734500756040.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CLOSE'
,p_display_name=>unistr('\95DC\9589\5C0D\8A71\65B9\584A')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CLOSE'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\95DC\9589\76EE\524D\7684\5C0D\8A71\65B9\584A\9801\9762.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3788410042953.4418)
,p_plugin_id=>wwv_flow_api.id(3734500756040.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8981\50B3\56DE\7684\9805\76EE')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\5C0D\8A71\65B9\584A\61C9\8A72\50B3\56DE\4E4B\4E00\6216\591A\500B\9801\9762\9805\76EE\7684\540D\7A31. \82E5\6709\591A\500B\9805\76EE, \8ACB\4F7F\7528\9017\865F\5340\9694\6BCF\500B\9805\76EE\540D\7A31.</p>'),
unistr('<p>\82E5\8981\5B58\53D6\50B3\56DE\7684\9805\76EE\503C, \8ACB\5728\958B\555F\5C0D\8A71\65B9\584A\7684\5143\7D20\4E0A\5B9A\7FA9\8981\5C0D<strong>\5C0D\8A71\65B9\584A\5DF2\95DC\9589</strong>\4E8B\4EF6\89F8\767C\7684\300C\52D5\614B\52D5\4F5C\300D, \800C\52D5\4F5C\70BA<strong>\5C0D\8A71\65B9\584A\50B3\56DE\9805\76EE</strong>\7684<strong>\8A2D\5B9A\503C</strong>\53CA<em>\8A2D\5B9A\985E\578B</em>.</p>')))
);
end;
/
prompt --application/shared_components/plugins/region_type/display_selector
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3782395890396.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DISPLAY_SELECTOR'
,p_display_name=>unistr('\5340\57DF\986F\793A\9078\53D6\5668')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DISPLAY_SELECTOR'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\4EE5\6C34\5E73\65B9\5F0F\7684\6E05\55AE\986F\793A\5340\57DF\540D\7A31, \8B93\4E00\822C\4F7F\7528\8005\80FD\5920\9078\53D6\4E00\500B\5340\57DF\4E26\986F\793A, \540C\6642\5C07\5176\4ED6\5340\57DF\96B1\85CF\8D77\4F86. \6B64\5340\57DF\53EA\6703\986F\793A<em>\5340\57DF\986F\793A\9078\53D6\5668</em>\8A2D\70BA<strong>\662F</strong>\7684\9801\9762\5340\57DF.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1764737380560506621.4418)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5305\62EC\6ED1\687F')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\986F\793A\7684\5340\57DF\540D\7A31\8D85\904E\5340\57DF\7684\5BEC\5EA6\6642, \6703\5728\6B64\5340\57DF\52D5\614B\65B0\589E\6ED1\687F.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763653631955156043.4418)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6A21\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STANDARD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6<em>\5340\57DF\986F\793A\9078\53D6\5668</em>\8A2D\70BA<strong>\662F</strong>\7684\5340\57DF\986F\793A\5728\9801\9762\4E0A\7684\65B9\5F0F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1763654080157157624.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1763653631955156043.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\6AA2\8996\55AE\4E00\5340\57DF')
,p_return_value=>'STANDARD'
,p_help_text=>unistr('\4EE5\9801\7C64\986F\793A\5340\57DF. \9078\53D6\67D0\500B\9801\7C64\5C07\6703\770B\5230\5C0D\61C9\7684\5340\57DF, \4E26\96B1\85CF\5176\4ED6\9078\64C7\9805\76EE.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1763654509981158498.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1763653631955156043.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\6372\52D5\8996\7A97')
,p_return_value=>'JUMP'
,p_help_text=>unistr('\4E00\5F8B\986F\793A\9801\9762\4E0A\7684\6240\6709\5340\57DF. \9078\53D6\67D0\500B\9801\7C64\6703\5C07\8996\7A97\6372\52D5\5230\5C0D\61C9\7684\5340\57DF.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763973139934187732.4418)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5305\62EC\300C\5168\90E8\986F\793A\300D')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1763653631955156043.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STANDARD'
,p_help_text=>unistr('\9644\52A0\300C\5168\90E8\986F\793A\300D\9801\7C64, \9078\53D6\6B64\9801\7C64\6642, \6703\5728\9801\9762\4E0A\986F\793A\6240\6709\5340\57DF.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763975939882192484.4418)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\8A18\4F4F\4E0A\6B21\7684\9078\64C7\9805\76EE')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\8F09\5165\9801\9762\6642, \5C07\6703\986F\793A\60A8\4E0A\6B21\9078\53D6\7684\5340\57DF.')
);
end;
/
prompt --application/shared_components/plugins/region_type/url
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3783484270249.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'URL'
,p_display_name=>'URL'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','URL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A\5F9E URL \53D6\5F97\7684\9060\7AEF\5167\5BB9.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783486275401.4418)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\9060\7AEF\5167\5BB9\7684 URL.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783489372727.4418)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5305\542B\6A21\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IFRAME'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\9801\9762\4E2D\5305\62EC URL \4E4B\9060\7AEF\5167\5BB9\7684\65B9\5F0F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783492373852.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4418)
,p_display_sequence=>10
,p_display_value=>'IFrame'
,p_return_value=>'IFRAME'
,p_help_text=>unistr('\5C07\9060\7AEF\5167\5BB9\5167\5D4C\70BA iframe.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783496377152.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5167\5D4C (\9041\96E2\7279\6B8A\5B57\5143)')
,p_return_value=>'ESC_INLINE'
,p_help_text=>unistr('\5728\9801\9762\5448\73FE\6642\8B80\53D6\9060\7AEF\5167\5BB9\4E26\52A0\4EE5\5167\5D4C, \4F46\9041\96E2\7279\6B8A HTML \5B57\5143\4EE5\9632\6B62\8DE8\7DB2\7AD9\547D\4EE4\6A94\7684\653B\64CA.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783504380866.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\5167\5D4C (\7121\9041\96E2)')
,p_return_value=>'NOESC_INLINE'
,p_help_text=>unistr('\5728\9801\9762\5448\73FE\6642\8B80\53D6\9060\7AEF\5167\5BB9\4E26\52A0\4EE5\5167\5D4C. \53EA\6709\7576\53EF\4EE5\5145\5206\4FE1\4EFB\9060\7AEF\5167\5BB9 (\4EA6\5373\6C92\6709\57F7\884C HTML \9041\96E2) \6642\624D\61C9\9078\53D6\6B64\9078\9805. \5426\5247, \53EF\80FD\6703\4F7F\5340\57DF\906D\53D7\8DE8\7DB2\7AD9\547D\4EE4\6A94\7684\653B\64CA.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783511409602.4418)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('IFrame \5C6C\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IFRAME'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'width="300" height="300"',
'</pre>'))
,p_help_text=>unistr('\8F38\5165 iframe \6A19\8A18\7684\5176\4ED6 HTML \5143\7D20\5C6C\6027.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783517424673.4418)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6368\68C4 HTML, \76F4\5230:')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>unistr('\526A\8F2F\5927\578B\6587\4EF6\7684\67D0\500B HTML \5340\6BB5\6642\8ACB\4F7F\7528\6B64\5C6C\6027. \8ACB\8F38\5165\8B58\5225\76EE\6A19\5340\6BB5\4E4B\958B\982D\7684\5B57\4E32, \6216\8F38\5165\6368\68C4 HTML \7684\7D50\675F\9EDE.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783520428341.4418)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\53F3\8FF0\4E4B\5F8C\6368\68C4 HTML:')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>unistr('\8ACB\4F7F\7528\6B64\5C6C\6027\4F86\526A\8F2F\5927\578B\6587\4EF6\7684\67D0\500B HTML \5340\6BB5. \8ACB\8F38\5165\8B58\5225\76EE\6A19\5340\6BB5\4E4B\7D50\5C3E\7684\5B57\4E32, \6216\8F38\5165\6368\68C4\5176\9918 HTML \7684\958B\59CB\9EDE. \50B3\56DE\7684\6587\5B57\4E2D\4E0D\6703\5305\62EC\8B58\5225\76EE\6A19\5340\6BB5\4E4B\7D50\5C3E\7684\9019\500B\5B57\4E32.')
);
end;
/
prompt --application/shared_components/plugins/region_type/help_text
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3783523603076.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'HELP_TEXT'
,p_display_name=>unistr('\8AAA\660E\5167\5BB9')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','HELP_TEXT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A\5C08\7528\300C\8AAA\660E\300D\9801\9762\4E2D\4F7F\7528\7684\7279\6B8A\300C\8AAA\660E\300D\5340\57DF.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/faceted_search
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1370261776191667.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FACETED_SEARCH'
,p_display_name=>unistr('\591A\9762\5411\641C\5C0B')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FACETED_SEARCH'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('<p>\4EE5\76F8\95DC\806F\300C\591A\9762\5411\641C\5C0B\300D\7684\4F86\6E90\70BA\57FA\790E\7684\5340\57DF, \4E00\822C\4F7F\7528\8005\53EF\4EE5\4F7F\7528\63D0\4F9B\7684\773E\591A\9762\5411, \5728\7A0B\5F0F\5BE6\969B\57F7\884C\6642\7E2E\6E1B\641C\5C0B\7D50\679C. </p>')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1370473361191712.4418)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6279\6B21\9762\5411\8B8A\66F4')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\9078\53D6\5728\300C\591A\9762\5411\641C\5C0B\300D\5831\8868\4E0A, \662F\8981\4EE5\6279\6B21\5957\7528\9078\53D6\7684\9762\5411, \9084\662F\8981\500B\5225\5957\7528.  \5982\679C\9078\53D6\300C\662F\300D, \6703\5728\6309\300C\5957\7528\300D\6309\9215\5F8C\57F7\884C\5831\8868\7BE9\9078.  \5982\679C\9078\53D6\300C\5426\300D, \5247\6703\5728\4EFB\4F55\9762\5411\503C\8B8A\66F4\6642\7ACB\5373\57F7\884C\5831\8868\7BE9\9078.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2517816294852101.4418)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\986F\793A\76EE\524D\7684\9762\5411')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\662F\5426\8981\986F\793A\76EE\524D\7684\9762\5411\5340\57DF. \76EE\524D\7684\9762\5411\5340\57DF\6703\5217\51FA\76EE\524D\9078\53D6\7684\9762\5411, \4E26\63D0\4F9B\4E00\7A2E\7C21\55AE\7684\65B9\5F0F\4F86\500B\5225\79FB\9664\6216\4E00\6B21\79FB\9664\6240\6709\9019\4E9B\9762\5411.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518140718854747.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\662F')
,p_return_value=>'Y'
,p_help_text=>unistr('\76EE\524D\7684\9762\5411\6E05\55AE\6703\986F\793A\5728\300C\591A\9762\5411\641C\5C0B\300D\5340\57DF\7684\9802\7AEF.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518542510858430.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5426')
,p_return_value=>'N'
,p_help_text=>unistr('\4E0D\6703\986F\793A\76EE\524D\7684\9762\5411\6E05\55AE.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518915492864304.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\9078\53D6\5668')
,p_return_value=>'E'
,p_help_text=>unistr('\76EE\524D\7684\9762\5411\5340\57DF\6703\986F\793A\5728\6B64\9078\53D6\5668\6240\6307\5B9A\7684\5143\7D20\5167. \9019\53EF\8B93\60A8\5C07\76EE\524D\7684\9762\5411\5340\57DF\653E\5728\9801\9762\4E0A\7684\4EFB\4F55\4F4D\7F6E.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728482701453610313.4418)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\76EE\524D\7684\9762\5411\9078\53D6\5668')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2517816294852101.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#currentFacetsArea'
,p_help_text=>unistr('\9019\662F\9801\9762\4E0A\5143\7D20\7684\9078\53D6\5668, \591A\9762\5411\641C\5C0B\5340\57DF\5C07\6703\5728\8A72\8655\986F\793A\76EE\524D\7684\9762\5411.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1501356115247921.4418)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\986F\793A\8CC7\6599\5217\7E3D\6578')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\986F\793A\8CC7\6599\5217\7E3D\6578\7684\4F4D\7F6E.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1501661440256814.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5426')
,p_return_value=>'N'
,p_help_text=>unistr('\4E0D\6703\986F\793A\8CC7\6599\5217\7E3D\6578.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1502011338258911.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\662F')
,p_return_value=>'Y'
,p_help_text=>unistr('\8CC7\6599\5217\7E3D\6578\6703\986F\793A\5728\76EE\524D\9762\5411\5340\57DF\7684\9802\7AEF, \6216\8005\5982\679C\300C\986F\793A\76EE\524D\7684\9762\5411\300D\8A2D\70BA\300C\5426\300D, \5247\6703\986F\793A\5728\300C\591A\9762\5411\641C\5C0B\300D\5340\57DF\9802\7AEF.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1502458150261854.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\9078\53D6\5668')
,p_return_value=>'E'
,p_help_text=>unistr('\8CC7\6599\5217\7E3D\6578 (\7121\4EFB\4F55\6A19\7C64) \6703\986F\793A\5728\6B64\9078\53D6\5668\6240\6307\5B9A\7684\5143\7D20\5167. \9019\53EF\8B93\60A8\5C07\8CC7\6599\5217\7E3D\6578\653E\5728\9801\9762\4E0A\7684\4EFB\4F55\4F4D\7F6E.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1503042014268412.4418)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\8CC7\6599\5217\7E3D\6578\6A19\7C64')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1501356115247921.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\7528\65BC\8CC7\6599\5217\7E3D\6578\7684\6A19\7C64. \6B64\8655\82E5\672A\63D0\4F9B\4EFB\4F55\6A19\7C64, APEX \5C07\4F7F\7528 APEX.FS.TOTAL_ROW_COUNT_LABEL \6587\5B57\8A0A\606F.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1503328055272516.4418)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\8CC7\6599\5217\7E3D\6578\9078\53D6\5668')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1501356115247921.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>unistr('\9019\662F\9801\9762\4E0A\5143\7D20\7684\9078\53D6\5668, \591A\9762\5411\641C\5C0B\5340\57DF\5C07\6703\5728\8A72\8655\986F\793A\8CC7\6599\5217\7E3D\6578.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(556135859462274866.4418)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>20
,p_prompt=>unistr('\7E2E\5BEB\6578\5B57\81E8\754C\503C')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('\63D0\4F9B\7E2E\5BEB\6578\5B57\683C\5F0F\986F\793A\9762\5411\6578\76EE\7684\81E8\754C\503C. \4F7F\7528\7E2E\5BEB\6578\5B57\683C\5F0F\6642, <strong>1,234</strong> \503C\5C07\986F\793A\70BA <strong>1K</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2600957382075036.4418)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('\986F\793A\5716\8868')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\986F\793A\9762\5411\503C\5716\8868\7684\4F4D\7F6E.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601268677075657.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5C0D\8A71\65B9\584A')
,p_return_value=>'Y'
,p_help_text=>unistr('\9762\5411\503C\5716\8868\986F\793A\5728\975E\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A\4E2D.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601607534076237.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5426')
,p_return_value=>'N'
,p_help_text=>unistr('\6C92\6709\53EF\8B93\4F7F\7528\8005\986F\793A\9762\5411\503C\5716\8868\7684\6309\9215.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2602011048076805.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\9078\53D6\5668')
,p_return_value=>'E'
,p_help_text=>unistr('\5DF2\5C07\9762\5411\503C\5716\8868\65B0\589E\5230\6B64\9078\53D6\5668\6307\5B9A\7684\5143\7D20. \9019\6A23\60A8\4FBF\80FD\5728\5EFA\7ACB\9762\5411\503C\5716\8868\5100\8868\677F\9801\9762\7684\4EFB\4F55\4F4D\7F6E\653E\7F6E\5716\8868.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2602471299081559.4418)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\5716\8868\9078\53D6\5668')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2600957382075036.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_help_text=>unistr('\9019\662F\9801\9762\4E0A\5143\7D20\7684\9078\53D6\5668, \591A\9762\5411\641C\5C0B\5340\57DF\5C07\6703\5728\8A72\8655\986F\793A\9762\5411\5716\8868.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3900223688176537.4418)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\986F\793A\5716\8868\7684\524D N \500B\503C')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2600957382075036.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'Y,E'
,p_help_text=>unistr('\63D0\4F9B\8981\5728\6BCF\500B\9762\5411\5716\8868\986F\793A\7684\503C\6578\76EE. \503C\8A2D\5B9A\70BA <strong>10</strong> \8868\793A\9762\5411\5716\8868\6703\4F9D\64DA\9762\5411\7684\9806\5E8F\986F\793A<em>\524D 10 \500B</em>\9805\76EE. \5982\679C\958B\555F\300C\4F9D\8A08\6578\905E\6E1B\6392\5E8F\300D\9762\5411\7279\6027, \5247\6703\4F9D\51FA\73FE\6B21\6578\986F\793A<em>\524D 10 \500B</em>\9805\76EE. \6B64\7279\6027\7684\8B8A\66F4\53EF\80FD\4E0D\6703\7ACB\5373\5728\76EE\524D\4F5C\7528\4E2D\7684\700F\89BD\5668\968E\6BB5\4F5C\696D\986F\73FE. \9019\500B\503C\548C\4F7F\7528\8005\9078\64C7\7684\5713\9905\5716\6216\9577\689D\5716\90FD\6703\5132\5B58\5728\700F\89BD\5668\968E\6BB5\4F5C\696D\4E2D. \82E5\8981\67E5\770B\8B8A\66F4\6B64\7279\6027\7684\6548\679C, \8ACB\4F7F\7528\9023\7D50\300C\91CD\8A2D\5340\57DF\300D\5FEB\53D6\63A7\5236\9078\9805 (\4F8B\5982\4F7F\7528\7CBE\9748\7522\751F\7684\300C\91CD\8A2D\300D\6309\9215) \91CD\8A2D\5831\8868.')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(603063046957961274.4418)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4418)
,p_name=>'facetsafterremovechart'
,p_display_name=>unistr('\79FB\9664\5716\8868\4E4B\5F8C')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(603062764743961271.4418)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4418)
,p_name=>'facetsbeforeaddchart'
,p_display_name=>unistr('\65B0\589E\5716\8868\4E4B\524D')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1372274287191736.4418)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4418)
,p_name=>'facetschange'
,p_display_name=>unistr('\9762\5411\8B8A\66F4')
);
end;
/
prompt --application/shared_components/plugins/authentication_type/saml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1381216513007333.4418)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SAML'
,p_display_name=>unistr('SAML \767B\5165')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SAML'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007334.4418)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>70
,p_prompt=>unistr('\4F9B\7C3D\7F72\8981\6C42\7684\8B49\660E\8CC7\6599\5B58\653E\5340')
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\8B49\660E\8CC7\6599\5B58\653E\5340, \6B64\5B58\653E\5340\5305\542B\7528\4F86\7C3D\7F72\7D66\8B58\5225\63D0\4F9B\8005\4E4B\8A0A\606F\7684\516C\7528\6191\8B49\548C\79C1\5BC6\91D1\9470.'),
unistr('\60A8\5FC5\9808\5728\8B58\5225\63D0\4F9B\8005\8A3B\518A\6191\8B49.'),
unistr('&PRODUCT_NAME. \6703\4F7F\7528\79C1\5BC6\91D1\9470\4F86\7C3D\7F72\8981\6C42.'),
unistr('\96D6\7136\9019\662F\9078\64C7\6027\5C6C\6027, \4F46\57FA\65BC\5B89\5168\8003\91CF, \4ECD\5EFA\8B70\7C3D\7F72\8981\6C42.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007335.4418)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\4F7F\7528\4EE5\4E0B\9805\76EE\7684 SAML \5C6C\6027:')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSTANCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'APP'
,p_help_text=>unistr('\6307\5B9A\662F\8981\4F7F\7528\57F7\884C\8655\7406\5C64\7D1A\7D44\614B, \9084\662F\4F7F\7528\61C9\7528\7A0B\5F0F\7279\5B9A\7684 SAML \7D44\614B.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1381216513007332.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1381216513007335.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\57F7\884C\8655\7406')
,p_return_value=>'INSTANCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6574\500B &PRODUCT_NAME. \57F7\884C\8655\7406\90FD\4F7F\7528\5171\7528\7684 SAML \7D44\614B.'),
unistr('\9019\9700\8981\60A8\7684\57F7\884C\8655\7406\7BA1\7406\54E1\5DF2\8A2D\5B9A\57F7\884C\8655\7406\5C64\7D1A\7684 SAML \5C6C\6027.'),
unistr('\5982\679C\4E0D\7B26\5408\6B64\689D\4EF6, \60A8\5C07\6703\6536\5230\7A0B\5F0F\5BE6\969B\57F7\884C\932F\8AA4.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1381216513007331.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1381216513007335.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\61C9\7528\7A0B\5F0F')
,p_return_value=>'APP'
,p_is_deprecated=>true
,p_help_text=>unistr('\4F7F\7528\61C9\7528\7A0B\5F0F\7279\5B9A\7684 SAML \7D44\614B.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007336.4418)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>unistr('\8B58\5225\63D0\4F9B\8005\55AE\4E00\767B\5165 URL')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>unistr('\9078\53D6\8B58\5225\63D0\4F9B\8005\7684\300C\55AE\4E00\767B\5165 POST URL\300D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007337.4418)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('\8B58\5225\63D0\4F9B\8005\55AE\4E00\767B\51FA URL')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\8B58\5225\63D0\4F9B\8005\7684\300C\55AE\4E00\767B\51FA POST URL\300D.'),
unistr('\82E5\662F\7A7A\7684, \5C07\6703\4F7F\7528\300C\55AE\4E00\767B\5165 URL\300D.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007338.4418)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>unistr('\8B58\5225\63D0\4F9B\8005\767C\7167\8005')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\8B58\5225\63D0\4F9B\8005\7684\300C\767C\7167\8005\300D\503C.'),
unistr('&PRODUCT_NAME. \6703\9A57\8B49\4F86\81EA\8B58\5225\63D0\4F9B\8005\4E4B\8A0A\606F\4E2D\7684\9019\500B\503C.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007339.4418)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('\4F7F\7528\8005\540D\7A31\5C6C\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5305\542B\4F7F\7528\8005\540D\7A31\7684 SAML \5C6C\6027.'),
unistr('\9810\8A2D\70BA "Assertion/Subject/NameID" \7BC0\9EDE\7684\503C.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007340.4418)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>60
,p_prompt=>unistr('\8B58\5225\63D0\4F9B\8005\7684\7C3D\7F72\6191\8B49')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\8B58\5225\63D0\4F9B\8005\7528\65BC\7C3D\7F72\8A0A\606F\7684\6191\8B49.'),
unistr('&PRODUCT_NAME. \6703\4F7F\7528\6B64\6191\8B49\4F86\9A57\8B49\4F86\81EA\8B58\5225\63D0\4F9B\8005\7684\56DE\61C9\8A0A\606F.'),
unistr('\96D6\7136\9019\662F\9078\64C7\6027\5C6C\6027, \4F46\57FA\65BC\5B89\5168\8003\91CF, \4ECD\5EFA\8B70\9A57\8B49\56DE\61C9.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(549695930675668342.4418)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\5C07\4F7F\7528\8005\540D\7A31\8F49\63DB\70BA\5927\5BEB')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\8A2D\5B9A\662F\5426\61C9\5C07\4F7F\7528\8005\540D\7A31\7684\5C6C\6027\503C\8F49\63DB\70BA\5927\5BEB.')
);
end;
/
prompt --application/shared_components/plugins/item_type/input
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1401075215817352.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'INPUT'
,p_display_name=>unistr('\8F38\5165\6B04\4F4D')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','INPUT'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:ELEMENT:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1401202979819499.4418)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6BD4\8F03\904B\7B97\5B50')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1401536563820127.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7B49\65BC')
,p_return_value=>'EQUALS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1402360244821204.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\5C0F\65BC')
,p_return_value=>'LT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1402711336822152.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\5C0F\65BC\6216\7B49\65BC')
,p_return_value=>'LTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403187913822669.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4418)
,p_display_sequence=>50
,p_display_value=>unistr('\5927\65BC')
,p_return_value=>'GT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403530010823859.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4418)
,p_display_sequence=>60
,p_display_value=>unistr('\5927\65BC\6216\7B49\65BC')
,p_return_value=>'GTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1574661752077055.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4418)
,p_display_sequence=>70
,p_display_value=>unistr('\958B\982D\70BA')
,p_return_value=>'STARTS_WITH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403924638824893.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4418)
,p_display_sequence=>80
,p_display_value=>unistr('\5305\542B')
,p_return_value=>'CONTAINS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1404353085828349.4418)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6709\5927\5C0F\5BEB\4E4B\5225')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1401202979819499.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STARTS_WITH,CONTAINS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1581137453249138.4418)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\503C\5927\5C0F\5BEB')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MIXED'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1404353085828349.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\5982\679C\6240\6709\7684\8CC7\6599\503C\90FD\5DF2\7D93\662F\5C0F\5BEB\6216\5927\5BEB, \5247\53EF\5728\6B64\9032\884C\5BA3\544A. \4E00\822C\4F7F\7528\8005\6240\63D0\4F9B\7684\7BE9\9078\689D\4EF6\5C07\6703\81EA\52D5\8F49\63DB\6210\5BA3\544A\7684\5927\5C0F\5BEB, \56E0\6B64\4E00\822C\4F7F\7528\8005\6703\9AD4\9A57\5230\4E0D\5340\5206\5927\5C0F\5BEB\7684\641C\5C0B, \800C\8CC7\6599\5EAB\5BE6\969B\57F7\884C\7684\662F\4E00\822C\6709\5340\5206\5927\5C0F\5BEB\7684\641C\5C0B.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1581469548249721.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5927\5C0F\5BEB\6DF7\5408')
,p_return_value=>'MIXED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1581879901250301.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5C0F\5BEB')
,p_return_value=>'LOWER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1582278689250872.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\5927\5BEB')
,p_return_value=>'UPPER'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1573402545049808.4418)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\76EE\524D\6A19\7C64')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>unistr('\7BE9\9078 %0')
,p_help_text=>unistr('\63D0\4F9B\91DD\5C0D\76EE\524D\9762\5411\5340\57DF\4E2D\7684\9019\500B\9762\5411\6240\8981\986F\793A\7684\6587\5B57. \76EE\524D\503C\53EF\4EE5\662F\542B\6709 <strong>%0</strong> \9810\7559\4F4D\7F6E\7684\53C3\7167.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1594998866512975.4418)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\524D\7F6E\78BC\6587\5B57')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\63D0\4F9B\8981\986F\793A\5728\8F38\5165\6B04\4F4D\4E4B\524D\7684\6587\5B57.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1595229523514009.4418)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\5C3E\78BC\6587\5B57')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\63D0\4F9B\8981\986F\793A\5728\8F38\5165\6B04\4F4D\4E4B\5F8C\7684\6587\5B57.')
);
end;
/
prompt --application/shared_components/plugins/region_type/cards
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1602002675849340.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CARDS'
,p_display_name=>unistr('\5361\7247')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CARDS'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\4EE5 SQL \67E5\8A62\70BA\57FA\790E\7684\5831\8868, \4EE5\5361\7247\5F62\5F0F\986F\793A\6BCF\500B\8CC7\6599\5217\7684\8CC7\6599.  \60A8\53EF\4EE5\900F\904E\5361\7247, \5C07\8CC7\6599\4EE5\5167\5BB9\5340\584A\5F62\5F0F\8F15\9B06\5730\8996\89BA\5316.  \4E26\4EE5\5BA3\544A\65B9\5F0F\81EA\8A02\6A19\982D\3001\5A92\9AD4\3001\4E3B\9AD4\6216\52D5\4F5C.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(1602292184849355.4418)
,p_plugin_id=>wwv_flow_api.id(1602002675849340.4418)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(633822552473663477.4418)
,p_plugin_id=>wwv_flow_api.id(1602002675849340.4418)
,p_name=>'tablemodelviewpagechange'
,p_display_name=>unistr('\9801\9762\8B8A\66F4')
);
end;
/
prompt --application/shared_components/plugins/web_source_type/http
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1677862467038200.4418)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'HTTP'
,p_display_name=>'HTTP'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','HTTP'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1901267720643867.4418)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5206\9801\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('\6C92\6709\5206\9801')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1901523910653468.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\9801\9762\5927\5C0F\548C\64F7\53D6\504F\79FB\91CF')
,p_return_value=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5F48\6027\5206\9801\5141\8A31 REST API \4F7F\7528<em>\9801\9762\5927\5C0F</em>\548C<em>\504F\79FB\91CF</em> (\300C\958B\59CB\8CC7\6599\5217\300D) \53C3\6578\8981\6C42\4E00\7D44\7279\5B9A\7684\8CC7\6599\5217. URL \901A\5E38\5C31\50CF\4E0B\5217\7BC4\4F8B, \5176\4E2D\6703\7565\904E <strong>20</strong> \5217, \4E26\64F7\53D6\63A5\4E0B\4F86\7684 <strong>100</strong> \5217:</p>'),
'<pre>',
'http://hostname.domain.com/path/to/rest_api?limit=100&offset=20',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1901988519660109.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\9801\9762\5927\5C0F\548C\9801\78BC')
,p_return_value=>'PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5206\9801\5141\8A31 REST API \4F7F\7528<em>\9801\9762\5927\5C0F</em>\548C<em>\9801\78BC</em>\53C3\6578\8981\6C42\4E00\7D44\8CC7\6599\5217. URL \901A\5E38\5C31\50CF\4E0B\5217\7BC4\4F8B, \5176\4E2D\8981\6C42\9801\78BC <strong>2</strong> \548C\9801\9762\5927\5C0F <strong>100</strong>, \56E0\800C\50B3\56DE 101 \5230 200 \7684\8CC7\6599\5217.'),
'</p>',
'<pre>',
'http://hostname.domain.com/path/to/rest_api?size=100&page=2',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1902974368668773.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\9801\78BC')
,p_return_value=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5206\9801\5141\8A31 REST API \4F7F\7528<em>\9801\9762</em>\53C3\6578\8981\6C42\4E00\7D44\8CC7\6599\5217. \9801\9762\5927\5C0F\56FA\5B9A\4E14\7531 REST API \6C7A\5B9A. URL \901A\5E38\5C31\50CF\4E0B\5217\7BC4\4F8B, \5176\4E2D\8981\6C42\9801\78BC <strong>2</strong>. \5982\679C REST API \4F7F\7528\56FA\5B9A\9801\9762\5927\5C0F <strong>20</strong>, \5247\6703\50B3\56DE 21 \5230 40 \7684\8CC7\6599\5217.'),
'<pre>',
'http://hostname.domain.com/path/to/rest_api?page=2',
'</pre>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1904445073685723.4418)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\9801\9762\5927\5C0F URL \53C3\6578')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'FLEXIBLE,PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D0\4F9B URL \53C3\6578\4EE5\6307\5B9A\8981\5411 REST API \8981\6C42\7684<em>\9801\9762\5927\5C0F</em>. \503C\4E00\822C\70BA <strong>limit</strong>\3001<strong>page_size</strong> \6216 </strong>per_page</strong>.</p>'),
unistr('<p><em>\8ACB\52FF\5728 REST \8CC7\6599\4F86\6E90<strong>\53C3\6578</strong>\5167\65B0\589E\6B64\53C3\6578</em>. &PRODUCT_NAME. \6703\5728\57F7\884C HTTP \8981\6C42\6642\81EA\52D5\65B0\589E\6B64\53C3\6578.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1904796837692405.4418)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\9801\9762\5927\5C0F\4E0A\9650')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>10
,p_unit=>unistr('\8CC7\6599\5217')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D0\4F9B REST API \5141\8A31\64F7\53D6\7684\6BCF\9801\8CC7\6599\5217\6578\76EE\4E0A\9650. &PRODUCT_NAME. \5C07\4E0D\6703\5617\8A66\8981\6C42\8D85\904E\6B64\503C\7684\6BCF\9801\8CC7\6599\5217\6578\76EE.</p>'),
unistr('<p>\8ACB\78BA\4FDD REST API <em>\5BE6\969B\50B3\56DE</em>\8A72\8CC7\6599\5217\6578\76EE, \56E0\70BA\56DE\61C9\6240\542B\7684\8CC7\6599\5217\82E5\5C11\65BC\8981\6C42\7684\6578\76EE, &PRODUCT_NAME. \6703\5047\8A2D\8981\6C42\7684\9801\9762\70BA\6700\5F8C\4E00\9801.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1905045481696652.4418)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\9801\78BC URL \53C3\6578')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D0\4F9B URL \53C3\6578\4EE5\6307\5B9A\8981\5411 REST API \8981\6C42\7684<em>\9801\78BC</em>. \503C\4E00\822C\70BA <strong>page</strong>.</p>'),
unistr('<p><em>\8ACB\52FF\5728 REST \8CC7\6599\4F86\6E90<strong>\53C3\6578</strong>\5167\65B0\589E\6B64\53C3\6578</em>. &PRODUCT_NAME. \6703\5728\57F7\884C HTTP \8981\6C42\6642\81EA\52D5\65B0\589E\6B64\53C3\6578.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1905385707699679.4418)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\7D22\5F15\7684\7B2C\4E00\9801')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\6307\5B9A REST API \662F\61C9\5F9E\7D22\5F15 <strong>"0"</strong> \9084\662F <strong>"1"</strong> \958B\59CB\8A08\7B97\9801\6578.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1905636932702605.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1905385707699679.4418)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
,p_is_quick_pick=>true
,p_help_text=>unistr('REST API \4EE5\9801\9762 <strong>1</strong> \8868\793A\7B2C\4E00\9801.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1906025829704631.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1905385707699679.4418)
,p_display_sequence=>20
,p_display_value=>'0'
,p_return_value=>'0'
,p_is_quick_pick=>true
,p_help_text=>unistr('REST API \4EE5\9801\9762 <strong>0</strong> \8868\793A\7B2C\4E00\9801.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1906661765710861.4418)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\56FA\5B9A\9801\9762\5927\5C0F')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>10
,p_unit=>unistr('\8CC7\6599\5217')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D0\4F9B REST API \6240\6C7A\5B9A\7684<em>\9801\9762\5927\5C0F</em> (\6BCF\9801\7684\8CC7\6599\5217\6578\76EE).</p>'),
unistr('<p>\9019\9805\8CC7\8A0A\901A\5E38\53EF\4EE5\5F9E REST API \6587\4EF6\53D6\5F97. \8ACB\52D9\5FC5\5728\6B64\8655\6307\5B9A\6B63\78BA\7684\503C: \5982\679C\503C\4E0D\6B63\78BA, \7576 &PRODUCT_NAME. \5F9E REST API \64F7\53D6\8CC7\6599\6642, \5C07\6703\907A\6F0F\6216\91CD\8907\8CC7\6599\5217.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1906984049714159.4418)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\8CC7\6599\5217\504F\79FB\91CF URL \53C3\6578')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_unit=>unistr('\8CC7\6599\5217')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D0\4F9B URL \53C3\6578\4EE5\6307\5B9A<em>\504F\79FB\91CF</em>, \9019\4EE3\8868\50B3\56DE\7B2C\4E00\5217\4E4B\524D\61C9\7565\904E\7684\8CC7\6599\5217\6578.</p>'),
unistr('<p><em>\8ACB\52FF\5728 REST \8CC7\6599\4F86\6E90<strong>\53C3\6578</strong>\5167\65B0\589E\6B64\53C3\6578</em>. &PRODUCT_NAME. \6703\5728\57F7\884C HTTP \8981\6C42\6642\81EA\52D5\65B0\589E\6B64\53C3\6578.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1907222147716823.4418)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\8CC7\6599\5217\504F\79FB\91CF\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OFFSET'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9078\64C7<strong>\504F\79FB\91CF</strong>\53C3\6578\6307\5B9A\7684\662F<em>\8981\7565\904E\7684\8CC7\6599\5217\6578</em>, \9084\662F<em>\8981\64F7\53D6\7684\7B2C\4E00\5217</em>.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1907577038717722.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1907222147716823.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\8981\7565\904E\7684\8CC7\6599\5217\6578')
,p_return_value=>'OFFSET'
,p_help_text=>unistr('\504F\79FB\91CF\503C\4EE3\8868\8981\7565\904E\7684\8CC7\6599\5217\6578. \4F8B\5982, \5982\679C\5C07\503C\8A2D\70BA 100, REST API \6703\5F9E\7D22\5F15 101 \958B\59CB\50B3\56DE\8CC7\6599\5217.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1907904681718986.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1907222147716823.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\8981\64F7\53D6\7684\7B2C\4E00\5217')
,p_return_value=>'START'
,p_help_text=>unistr('\504F\79FB\91CF\503C\4EE3\8868\8981\958B\59CB\64F7\53D6\7684\8CC7\6599\5217. \4F8B\5982, \5982\679C\5C07\503C\8A2D\70BA 100, REST API \6703\7565\904E 99 \500B\8CC7\6599\5217, \5F9E\7D22\5F15 100 \958B\59CB\64F7\53D6.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1908579263746808.4418)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\6709\5176\4ED6\8CC7\6599\5217\9078\53D6\5668')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C REST API \50B3\56DE\4E0B\5217 JSON \56DE\61C9:</p>'),
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
unistr('<strong>\6709\5176\4ED6\8CC7\6599\5217\9078\53D6\5668</strong>\70BA <strong>metadata.pagination.moreRows</strong>.'),
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\56DE\61C9 REST API \50B3\56DE\662F\5426\6709\5176\4ED6\9801\9762\7684\8CC7\8A0A, \8ACB\63D0\4F9B<em>\9078\53D6\5668</em>\4EE5\5728\6B64\64F7\53D6\9019\500B\5C6C\6027.</p>'),
unistr('<p>\96D6\7136\4E0D\9700\8981\6307\5B9A<strong>\6709\5176\4ED6\8CC7\6599\5217\9078\53D6\5668</strong>, \4F46\9019\53EF\5354\52A9 &PRODUCT_NAME. \5728\5DF2\64F7\53D6\6240\6709\8CC7\6599\7684\60C5\6CC1\4E0B, \5132\5B58\4E0D\6703\50B3\56DE\8CC7\6599\7684\5176\4ED6 HTTP \8981\6C42.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1908849697751769.4418)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\6709\5176\4ED6\8CC7\6599\5217\6642\9593\503C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1908579263746808.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9078\64C7\5982\4F55\89E3\8B6F<strong>\6709\5176\4ED6\8CC7\6599\5217\9078\53D6\5668</strong>\6240\53C3\7167\7684\56DE\61C9\5C6C\6027\503C.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1909141279756289.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1908849697751769.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7B49\65BC')
,p_return_value=>'EQUALS'
,p_is_quick_pick=>true
,p_help_text=>unistr('\5982\679C<strong>\6709\5176\4ED6\8CC7\6599\5217\9078\53D6\5668</strong>\53C3\7167\7684\56DE\61C9\5C6C\6027\7B49\65BC\67D0\500B\503C, \5247\5047\8A2D\6709\5176\4ED6\8CC7\6599\5217\53EF\7528.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1909569602757607.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1908849697751769.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\975E\7A7A\503C')
,p_return_value=>'NOT_NULL'
,p_is_quick_pick=>true
,p_help_text=>unistr('\5982\679C<strong>\6709\5176\4ED6\8CC7\6599\5217\9078\53D6\5668</strong>\53C3\7167\7684\56DE\61C9\5C6C\6027\5B58\5728\4E14\4E0D\662F\7A7A\7684, \5247\5047\8A2D\6709\5176\4ED6\8CC7\6599\5217\53EF\7528.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1911015518771444.4418)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\6709\5176\4ED6\8CC7\6599\5217\5C6C\6027\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'true'
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1908849697751769.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'EQUALS'
,p_help_text=>unistr('<p>\5982\679C<strong>\6709\5176\4ED6\8CC7\6599\5217\9078\53D6\5668</strong>\53C3\7167\7684\56DE\61C9\5C6C\6027\5305\542B\9019\500B\503C, &PRODUCT_NAME. \6703\5047\8A2D\6709\5176\4ED6\8CC7\6599\5217\53EF\7528.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1911713410779146.4418)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\8CC7\6599\5217\7E3D\6578\9078\53D6\5668')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C REST API \50B3\56DE\4E0B\5217 JSON \56DE\61C9 ...</p>'),
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
unistr('... <strong>\6709\5176\4ED6\8CC7\6599\5217\9078\53D6\5668</strong>\70BA <strong>metadata.pagination.totalRows</strong>.'),
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C REST API \7684\56DE\61C9\50B3\56DE<em>\8CC7\6599\5217\7E3D\6578</em> (\6240\6709\9801\9762), \8ACB\63D0\4F9B<em>\9078\53D6\5668</em>\4EE5\5728\6B64\64F7\53D6\9019\500B\5C6C\6027.</p>'),
unistr('<p>\4E0D\9700\8981\6307\5B9A<strong>\6709\5176\4ED6\8CC7\6599\5217\9078\53D6\5668</strong>; \5B83\80FD\5920\80FD\986F\793A &PRODUCT_NAME. \5143\4EF6\4E2D\7684\8CC7\6599\5217\7E3D\6578, \4F46\524D\63D0\70BA<em>\4E0D\6703\518D\9032\4E00\6B65\7BE9\9078\8CC7\6599</em>.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/geocoded_address
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1700838675352758.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'GEOCODED_ADDRESS'
,p_display_name=>unistr('\5730\7406\7DE8\78BC\5730\5740')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','GEOCODED_ADDRESS'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#model#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.tableModelViewBase#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.grid#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.iconList#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.geoCoder#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\9805\76EE\985E\578B\63D0\4F9B\300C\5730\7406\7DE8\78BC\300D\529F\80FD (\5C07\90F5\5BC4\5730\5740\8F49\63DB\6210\5EA7\6A19).<p>'),
unistr('<p>\5730\7406\7DE8\78BC\662F\7531\5411 <strong>Oracle Elocation</strong> Geocoding Service (elocation.oracle.com) \63D0\51FA REST \8981\6C42\7684<em>\700F\89BD\5668</em>\6240\57F7\884C. \56E0\6B64, \5FC5\9808\5C07\700F\89BD\5668\9023\81F3\7DB2\969B\7DB2\8DEF, \5730\7406\7DE8\78BC\624D\80FD\904B\4F5C.</p>'),
unistr('<p>\5730\7406\7DE8\78BC\8F38\5165\8CC7\6599\53D6\81EA\65BC\8207\5730\5740\90E8\5206 (\4F8B\5982\8857\9053\3001\9580\724C\865F\78BC\3001\90F5\905E\5340\865F\6216\7E23/\5E02) \5C0D\61C9\7684\5176\4ED6\9801\9762\9805\76EE.\300C\5730\7406\7DE8\78BC\5668\300D\6703\986F\793A\4E00\500B\5373\73FE\5F0F\8996\7A97, \5167\542B\53EF\80FD\7684\76F8\7B26\9805\76EE\6E05\55AE. \7576\60A8\9078\64C7\76F8\7B26\7684\9805\76EE\5F8C, \8A72\9805\76EE\7684\968E\6BB5\4F5C\696D\72C0\614B\503C\6703\8B8A\6210 GeoJSON \683C\5F0F\7684\5730\5740\5EA7\6A19. \82E5\555F\7528<strong>\8655\7406\5730\5740</strong>, \5730\5740\90E8\5206\9801\9762\9805\76EE\6703\4EE5\5730\7406\7DE8\78BC\670D\52D9\6240\9001\51FA\4E26\8655\7406\904E\7684\503C\8986\5BEB.</p>'),
unistr('<p>\91DD\5C0D\6BD4\8F03\7C21\55AE\7684\4F7F\7528\72C0\6CC1\6642, <strong>\975E\7D50\69CB\5316\5730\5740</strong>\6A21\5F0F\53EF\4EE5\53EA\5C0D\61C9\4E00\500B\6587\5B57\6B04\4F4D\6216\4E00\500B\6587\5B57\5340, \4E00\822C\4F7F\7528\8005\53EF\5728\6B64\8F38\5165\5730\5740\90E8\5206 (\4F7F\7528\9017\865F\5340\9694). \5728\6B64\60C5\6CC1\4E0B, <strong>\8655\7406\5730\5740</strong>\6A21\5F0F\7121\6CD5\4F7F\7528.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1701330611413991.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5730\7406\7DE8\78BC\5668\6BD4\5C0D\6A21\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'RELAX_HOUSE_NUMBER'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p><strong>\6BD4\5C0D\6A21\5F0F</strong>\6C7A\5B9A\8F38\5165\5730\5740\7684\5C6C\6027\8207\5730\7406\7DE8\78BC\6240\4F7F\7528\8CC7\6599\7684\76F8\7B26\7A0B\5EA6.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702013128418533.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5B8C\5168\76F8\7B26')
,p_return_value=>'EXACT'
,p_help_text=>unistr('<p>\6240\6709\63D0\4F9B\7684\5730\5740\90E8\5206\90FD\5FC5\9808\7B26\5408. \4F46\5982\679C\9580\724C\865F\78BC\3001\8857\9053\540D\7A31\6216\8857\9053\985E\578B\6C92\6709<em>\5168\90E8</em>\7B26\5408, \5C07\6703\50B3\56DE\7B26\5408\4E0B\5217\5730\5740\90E8\5206\7684\7B2C\4E00\500B\9805\76EE: \90F5\905E\5340\865F\3001\7E23/\5E02\6216\9109\93AE, \4EE5\53CA\5DDE. \4F8B\5982, \5982\679C\8857\9053\540D\7A31\4E0D\6B63\78BA, \4F46\6307\5B9A\7684\90F5\905E\5340\865F\662F\6709\6548\7684, \5C31\6703\50B3\56DE\6240\6307\5B9A\90F5\905E\5340\865F\4E2D\7684\67D0\500B\5730\9EDE.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702860244421796.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\653E\5BEC\8857\9053\985E\578B')
,p_return_value=>'RELAX_STREET_TYPE'
,p_help_text=>unistr('<p>\63D0\4F9B\7684<em>\8857\9053\985E\578B</em>\53EF\4EE5\548C\5730\7406\7DE8\78BC\4F7F\7528\7684\8CC7\6599\4E0D\540C. \4F8B\5982, \5982\679C\76F8\95DC\5340\57DF\4E2D\6C92\6709\5176\4ED6\7684 <strong>Main Blvd</strong> \6216 <strong>Main Street</strong>, <strong>Main Street</strong> \6216 <strong>Main Blvd</strong> \5C31\6703\8207 <strong>Main St</strong> \76F8\7B26.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1708669966452560.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\653E\5BEC\9580\724C\865F\78BC')
,p_return_value=>'RELAX_HOUSE_NUMBER'
,p_help_text=>unistr('<p>\9580\724C\865F\78BC\548C\8857\9053\985E\578B\53EF\4EE5\548C\5730\7406\7DE8\78BC\4F7F\7528\7684\8CC7\6599\4E0D\540C. \4F8B\5982, \53EA\8981\6C92\6709\4E0D\660E\78BA\6216\5176\4ED6\76F8\7B26\7684\9805\76EE, <strong>123 Main St</strong> \5C31\6703\8207 <strong>123 Main Lane</strong> \53CA <strong>124 Main St</strong> \76F8\7B26.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702428218420313.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\653E\5BEC\8857\9053\540D\7A31')
,p_return_value=>'RELAX_BASE_NAME'
,p_help_text=>unistr('<p>\8857\9053\7684<em>\57FA\672C\540D\7A31</em>\3001\9580\724C\865F\78BC\4EE5\53CA\8857\9053\985E\578B\53EF\4EE5\548C\5730\7406\7DE8\78BC\4F7F\7528\7684\8CC7\6599\4E0D\540C. \4F8B\5982, \53EA\8981\8CC7\6599\4E2D\6C92\6709\4E0D\660E\78BA\6216\5176\4ED6\76F8\7B26\7684\9805\76EE, <strong>Pleasant Vale</strong> \5C31\6703\8207 <strong>Pleasant Valley</strong> \76F8\7B26.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1703440180425368.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4418)
,p_display_sequence=>50
,p_display_value=>unistr('\653E\5BEC\90F5\905E\5340\865F')
,p_return_value=>'RELAX_POSTAL_CODE'
,p_help_text=>unistr('<p>\90F5\905E\5340\865F (\5982\679C\6709\63D0\4F9B)\3001\8857\9053\540D\7A31\3001\8857\9053\985E\578B\4EE5\53CA\9580\724C\865F\78BC\53EF\4EE5\548C\5730\7406\7DE8\78BC\4F7F\7528\7684\8CC7\6599\4E0D\540C.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1703985342434956.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4418)
,p_display_sequence=>60
,p_display_value=>unistr('\5168\90E8\653E\5BEC')
,p_return_value=>'RELAX_ALL'
,p_help_text=>unistr('<p>\5730\5740\53EA\8981\4F4D\65BC\540C\4E00\500B\7E23\5167, \5C31\53EF\4EE5\4E0D\5728\6307\5B9A\7684\5E02\5167. \53E6\5916\9084\542B\62EC<strong>\653E\5BEC\90F5\905E\5340\865F</strong>\7684\7279\6027.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1709401396458135.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\4EE5\5373\73FE\65B9\5F0F\986F\793A\5EA7\6A19')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3010200212280744.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'GRID'
,p_help_text=>unistr('<p>\6C7A\5B9A\662F\5426\5728\5730\7406\7DE8\78BC\7D50\679C\5373\73FE\5F0F\5C0D\8A71\65B9\584A\4E2D\986F\793A\5730\5740\5EA7\6A19 (\7D93\5EA6, \7DEF\5EA6).</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2105827892587713.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\5730\5716\9810\89BD')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'POPUP:ITEM'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\662F\5426\5141\8A31\9810\89BD\5730\5716\4E0A\7684\5730\7406\7DE8\78BC\5730\5740.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601067718431827.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2105827892587713.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7D50\679C\5373\73FE\5F0F\8996\7A97')
,p_return_value=>'POPUP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\300C\5730\7406\7DE8\78BC\300D\7D50\679C\5373\73FE\5F0F\8996\7A97\4E2D\986F\793A\5730\5716, \8B93\4F7F\7528\8005\5728\9078\53D6\7D50\679C\4E4B\524D\80FD\5920\5148\8907\67E5\4F4D\7F6E.</p>'),
unistr('<p>\555F\7528\300C\986F\793A\65B9\5F0F - \65B9\683C\6AA2\8996\300D\6642, \624D\652F\63F4\6B64\529F\80FD.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601404353432915.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2105827892587713.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\9805\76EE')
,p_return_value=>'ITEM'
,p_help_text=>unistr('\986F\793A\5C07\9805\76EE\4F4D\7F6E\5730\5740\8996\89BA\5316\7684\5730\5716.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1744825789778265.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\80CC\666F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2105827892587713.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9078\64C7\7528\65BC\986F\793A\5730\7406\7DE8\78BC\7D50\679C\7684\80CC\666F\5730\5716.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1746613534792926.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4418)
,p_display_sequence=>5
,p_display_value=>unistr('\9810\8A2D')
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\9810\8A2D\5730\5716\80CC\666F.</p>'),
unistr('<p>\6DF1\8272\4E3B\984C\53EF\4EE5\4F7F\7528 OpenStreetMap (\660E\4EAE\7248) \6216 OpenStreetMap (\6DF1\8272\7248).</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1745320076781973.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4418)
,p_display_sequence=>10
,p_display_value=>unistr('OpenStreetMap (\660E\4EAE\7248)')
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5 OpenStreetMap \8CC7\6599\70BA\57FA\790E\7684\4E00\822C\7528\9014\57FA\790E\5730\5716. \6B64\57FA\790E\5730\5716\6A23\5F0F\91DD\5C0D\8CC7\6599\63D0\4F9B\8A73\7D30\7684\4F4D\7F6E\76F8\95DC\8CC7\8A0A.</p>'),
unistr('<p>\6A23\5F0F\7DB1\8981\548C\5B9A\7FA9\884D\751F\81EA "Mapbox Open Styles", \7531 KlokanTech.com \8207 OpenMapTiles \63D0\4F9B\8005\6240\63D0\4F9B. \7531 BSD/CC-BY \6388\6B0A\63D0\4F9B\6388\6B0A.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">\5728 GitHub \4E0A\6AA2\8996</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1745780305787850.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4418)
,p_display_sequence=>20
,p_display_value=>unistr('OpenStreetMap (\6DF1\8272\7248)')
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5 OpenStreetMap \8CC7\6599\70BA\57FA\790E\7684\4E0D\9192\76EE\6DF1\8272\57FA\790E\5730\5716. \6B64\57FA\790E\5730\5716\6A23\5F0F\8457\91CD\65BC\8CC7\6599\7684\8996\89BA\5316.</p>'),
unistr('<p>\6A23\5F0F\7DB1\8981\548C\5B9A\7FA9\884D\751F\81EA "Mapbox Open Styles", \7531 KlokanTech.com \8207 OpenMapTiles \63D0\4F9B\8005\6240\63D0\4F9B. \7531 BSD/CC-BY \6388\6B0A\63D0\4F9B\6388\6B0A. Stamen Design \88FD\5716\7531 CC0 \63D0\4F9B\6388\6B0A.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">\5728 GitHub \4E0A\6AA2\8996</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1746150917790500.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4418)
,p_display_sequence=>30
,p_display_value=>'OpenStreetMap Positron'
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5 OpenStreetMap \8CC7\6599\70BA\57FA\790E\7684\4E0D\9192\76EE\6DFA\8272\57FA\790E\5730\5716. \6B64\57FA\790E\5730\5716\6A23\5F0F\8457\91CD\65BC\8CC7\6599\7684\8996\89BA\5316.</p>'),
unistr('<p>\6A23\5F0F\7DB1\8981\548C\5B9A\7FA9\884D\751F\81EA "Mapbox Open Styles", \7531 KlokanTech.com \8207 OpenMapTiles \63D0\4F9B\8005\6240\63D0\4F9B. \7531 BSD/CC-BY \6388\6B0A\63D0\4F9B\6388\6B0A. Stamen Design \88FD\5716\7531 CC0 \63D0\4F9B\6388\6B0A.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">\5728 GitHub \4E0A\6AA2\8996</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601367265556756.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4418)
,p_display_sequence=>40
,p_display_value=>unistr('Oracle \4E16\754C\5730\5716')
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5 HERE Map \8CC7\6599\70BA\57FA\790E\7684\4E00\822C\7528\9014\57FA\790E\5730\5716. \6B64\57FA\790E\5730\5716\6A23\5F0F\91DD\5C0D\8CC7\6599\63D0\4F9B\4F4D\7F6E\76F8\95DC\8CC7\8A0A, \540C\6642\8457\91CD\65BC\8CC7\6599\7684\8996\89BA\5316.</p>'),
unistr('<p>\6A23\5F0F\7DB1\8981\548C\5B9A\7FA9\7531 Oracle, USA \6240\63D0\4F9B.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2206585812380955.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\9AD8\5EA6')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>unistr('\50CF\7D20')
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2105827892587713.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\986F\793A\7684\5730\5716\9AD8\5EA6 (\50CF\7D20).</p>'),
unistr('<p>\5730\5716\7684\9810\8A2D\9AD8\5EA6\662F\4EE5\5916\89C0\6BD4\4F8B 3:2 \6839\64DA\5176\5BEC\5EA6\8A08\7B97\6240\5F97.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3010200212280744.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>unistr('\986F\793A\65B9\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'LIST'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9078\53D6\5730\7406\7DE8\78BC\7D50\679C\7684\986F\793A\65B9\5F0F.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3011428457283918.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(3010200212280744.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\6E05\55AE\6AA2\8996')
,p_return_value=>'LIST'
,p_help_text=>unistr('<p>\5C07\6703\4EE5\6E05\55AE\6AA2\8996\986F\793A\7D50\679C.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3011010596282953.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(3010200212280744.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\65B9\683C\6AA2\8996')
,p_return_value=>'GRID'
,p_help_text=>unistr('<p>\5C07\6703\4EE5\65B9\683C\6AA2\8996\986F\793A\7D50\679C.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1709967230470781.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>60
,p_prompt=>unistr('\7D50\69CB\5316\5730\5740')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5<em>\7D50\69CB\5316</em>\9084\662F<em>\975E\7D50\69CB\5316</em>\7684\65B9\5F0F\63D0\4F9B\5730\5740\90E8\5206\7D66\5730\7406\7DE8\78BC\670D\52D9.</p>'),
unistr('<p>\300C\7D50\69CB\5316\300D\8868\793A\5C07\660E\78BA\7684\9801\9762\9805\76EE\5C0D\61C9\81F3\5730\5740\90E8\5206 (\4F8B\5982:\300C\8857\9053\300D\3001\300C\90F5\905E\5340\865F\300D\3001\300C\7E23/\5E02\300D\6216\300C\5730\5340\300D). \9019\6703\8B93\5730\7406\7DE8\78BC\7D50\679C\66F4\70BA\6E96\78BA, \800C\4E14\9084\80FD\5C07\66F4\6B63\904E\7684\5730\5740 '),
unistr('\994B\9001\56DE\9801\9762\9805\76EE.</p>'),
unistr('<p>\300C\975E\7D50\69CB\5316\300D\8868\793A\6574\500B\5730\5740\53EA\4F7F\7528\4E00\500B\9805\76EE; \5730\5740\5404\500B\90E8\5206\6703\4EE5\9017\865F\505A\5340\9694. \6B64\6A21\5F0F\4E0D\5141\8A31\5C07\66F4\6B63\7684\5730\5740\994B\9001\56DE\9801\9762\9805\76EE.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1710428568474713.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>unistr('\570B\5BB6\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9078\64C7\4F7F\7528\975C\614B\570B\5BB6\9032\884C\5730\7406\7DE8\78BC, \9084\662F\5F9E\9805\76EE\884D\751F\570B\5BB6.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1710966154475523.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1710428568474713.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\975C\614B')
,p_return_value=>'STATIC'
,p_help_text=>unistr('<p>\4F7F\7528\9078\53D6\6E05\55AE\4E2D\7684\975C\614B\570B\5BB6.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1711762868476607.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1710428568474713.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\9805\76EE')
,p_return_value=>'ITEM'
,p_help_text=>unistr('<p>\5F9E\61C9\7528\7A0B\5F0F\6216\9801\9762\9805\76EE\53D6\5F97\570B\5BB6. \6B64\9805\76EE\5FC5\9808\5305\542B 2 \4F4D\6578\7684\570B\5BB6 ISO \4EE3\78BC. </p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712263798480014.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('\570B\5BB6')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1710428568474713.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('<li><strong>US</strong>: \7F8E\570B</li>'),
unistr('<li><strong>UK</strong>: \82F1\570B</li>'),
unistr('<li><strong>DE</strong>: \5FB7\570B</li>'),
unistr('<li><strong>AT</strong>: \5967\5730\5229</li>'),
'</ul>'))
,p_help_text=>unistr('<p>\9078\64C7\4E00\500B\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE, \5F9E\4E2D\53D6\5F97\8981\9032\884C\5730\7406\7DE8\78BC\7684\570B\5BB6. \6B64\9805\76EE\5FC5\9808\5305\542B 2 \4F4D\6578\7684\570B\5BB6 ISO \4EE3\78BC.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712712695483947.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>unistr('\570B\5BB6')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'US'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1710428568474713.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9078\64C7\8981\7528\65BC\5730\7406\7DE8\78BC\7684\570B\5BB6.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1713260223484493.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7F8E\570B')
,p_return_value=>'US'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1713640362485278.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\82F1\570B')
,p_return_value=>'UK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1714942400488162.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\5FB7\570B')
,p_return_value=>'DE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1715315187488602.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\6CD5\570B')
,p_return_value=>'FR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1715776600489110.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>50
,p_display_value=>unistr('\7FA9\5927\5229')
,p_return_value=>'IT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1732218107588818.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>60
,p_display_value=>unistr('\52A0\62FF\5927')
,p_return_value=>'CA'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1732613691589456.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>70
,p_display_value=>unistr('\8377\862D')
,p_return_value=>'NL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733039072590094.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>80
,p_display_value=>unistr('\6BD4\5229\6642')
,p_return_value=>'BE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733467346590779.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>90
,p_display_value=>unistr('\5967\5730\5229')
,p_return_value=>'AT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733819745591632.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>100
,p_display_value=>unistr('\745E\58EB')
,p_return_value=>'CH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1734205667592050.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>110
,p_display_value=>unistr('\897F\73ED\7259')
,p_return_value=>'ES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1734685684592583.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>120
,p_display_value=>unistr('\8461\8404\7259')
,p_return_value=>'PT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735060793593960.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>130
,p_display_value=>unistr('\4FC4\7F85\65AF\806F\90A6')
,p_return_value=>'RU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735422526594737.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>140
,p_display_value=>unistr('\611B\6C99\5C3C\4E9E')
,p_return_value=>'EE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735848786595289.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>150
,p_display_value=>unistr('\5370\5EA6')
,p_return_value=>'IN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1736299306596060.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>160
,p_display_value=>unistr('\58A8\897F\54E5')
,p_return_value=>'MX'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1736643807596659.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>170
,p_display_value=>unistr('\6FB3\5927\5229\4E9E')
,p_return_value=>'AU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737040872597462.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>180
,p_display_value=>unistr('\5DF4\897F')
,p_return_value=>'BR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737421643598208.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>190
,p_display_value=>unistr('\667A\5229')
,p_return_value=>'CL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737878315598644.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>200
,p_display_value=>unistr('\6377\514B\5171\548C\570B')
,p_return_value=>'CZ'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1738298290599154.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>210
,p_display_value=>unistr('\632A\5A01')
,p_return_value=>'NO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1738640811599640.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>220
,p_display_value=>unistr('\82AC\862D')
,p_return_value=>'FI'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739045295600254.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>230
,p_display_value=>unistr('\4E39\9EA5')
,p_return_value=>'DK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739492220600840.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>240
,p_display_value=>unistr('\9999\6E2F')
,p_return_value=>'HK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739888238601924.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>250
,p_display_value=>unistr('\611B\723E\862D')
,p_return_value=>'IE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1740248023602467.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>260
,p_display_value=>unistr('\62C9\812B\7DAD\4E9E')
,p_return_value=>'LV'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1740660821603187.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>270
,p_display_value=>unistr('\7F85\99AC\5C3C\4E9E')
,p_return_value=>'RO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741021923603709.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>280
,p_display_value=>unistr('\54E5\502B\6BD4\4E9E')
,p_return_value=>'CO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741493695604368.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>290
,p_display_value=>unistr('\6CE2\862D')
,p_return_value=>'PL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741819445604954.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>300
,p_display_value=>unistr('\963F\62C9\4F2F\806F\5408\5927\516C\570B')
,p_return_value=>'AE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1742273782605774.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>310
,p_display_value=>unistr('\5308\7259\5229')
,p_return_value=>'HU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1742644763606445.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>320
,p_display_value=>unistr('\6C99\70CF\5730\963F\62C9\4F2F')
,p_return_value=>'SA'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1743094899606998.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4418)
,p_display_sequence=>330
,p_display_value=>unistr('\5357\975E')
,p_return_value=>'ZA'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1716542235497108.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>70
,p_prompt=>unistr('\5730\5740\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('<p>\9078\64C7\542B\6709\975E\7D50\69CB\5316\5730\5740\90E8\5206 (\4F7F\7528\9017\865F\5340\9694) \7684\9805\76EE.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1720233540512149.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>80
,p_prompt=>unistr('\8857\9053\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\9078\64C7\542B\6709\5730\5740<em>\8857\9053</em>\90E8\5206\7684\9805\76EE.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1720738899514712.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>90
,p_prompt=>unistr('\9580\724C\865F\78BC\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\9078\64C7\542B\6709\5730\5740<em>\9580\724C\865F\78BC</em>\90E8\5206\7684\9805\76EE.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1721280838517001.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>120
,p_prompt=>unistr('\7E23/\5E02\5B50\5340\57DF\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\9078\64C7\542B\6709\5730\5740<em>\5B50\5340\57DF (\4F4D\65BC\7E23/\5E02\5167)</em> \90E8\5206\7684\9805\76EE.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1721711111518708.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>110
,p_prompt=>unistr('\7E23/\5E02\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\9078\64C7\542B\6709\5730\5740<em>\7E23/\5E02</em>\90E8\5206\7684\9805\76EE.</p>')
);
end;
/
begin
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1722254500520558.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\90F5\905E\5340\865F\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\9078\64C7\542B\6709\5730\5740<em>\90F5\905E\5340\865F</em>\90E8\5206\7684\9805\76EE.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1722749669524835.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>130
,p_prompt=>unistr('\5730\5340\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\9078\64C7\542B\6709\5730\5740<em>\5730\5340 (\5DDE)</em> \90E8\5206\7684\9805\76EE.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1723298553527158.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>unistr('\8655\7406\5730\5740')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\555F\7528\6B64\53C3\6578\4EE5\5C07\5730\5740\8CC7\6599\5F9E\5730\7406\7DE8\78BC\670D\52D9\994B\9001\56DE\5C0D\61C9\7684\9805\76EE.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1727004690548379.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>135
,p_prompt=>unistr('\6BD4\5C0D\5411\91CF\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\64C7\4E00\500B\9801\9762\9805\76EE, \4EE5\4F9B\300C\5730\7406\7DE8\78BC\5668\300D\70BA\5176\50B3\56DE<em>\6BD4\5C0D\5411\91CF</em>. \6BD4\5C0D\5411\91CF\70BA 17 \4F4D\6578\7684\5B57\4E32, \5167\542B\95DC\65BC\5404\500B\5730\5740\5C6C\6027\5982\4F55\8207\5730\7406\7DE8\78BC\6240\4F7F\7528\8CC7\6599\9032\884C\6BD4\5C0D\7684\8A73\7D30\8CC7\8A0A.</p>'),
unistr('<p><strong>\300C\6BD4\5C0D\5411\91CF\300D\53EF\5305\542B\4E0B\5217\6578\5B57:</strong></p>'),
'<ul>',
unistr('<li><p>0: \8F38\5165\5C6C\6027\4E0D\662F\7A7A\503C, \4E14\6709\4E00\500B\76F8\7B26\975E\7A7A\503C\7684\503C.</p></li>'),
unistr('<li><p>1: \8F38\5165\5C6C\6027\70BA\7A7A\503C, \4E14\6709\4E00\500B\76F8\7B26\7A7A\503C\7684\503C.</p></li>'),
unistr('<li><p>2: \8F38\5165\5C6C\6027\4E0D\662F\7A7A\503C, \4E14\53D6\4EE3\70BA\5176\4ED6\975E\7A7A\503C\7684\503C.</p></li>'),
unistr('<li><p>3: \8F38\5165\5C6C\6027\4E0D\662F\7A7A\503C, \4E14\53D6\4EE3\70BA\7A7A\503C\7684\503C.</p></li>'),
unistr('<li><p>4: \8F38\5165\5C6C\6027\70BA\7A7A\503C, \4E14\53D6\4EE3\70BA\975E\7A7A\503C\7684\503C.</p></li>'),
'</ul>',
'<br>',
unistr('<p><strong>\5404\300C\6BD4\5C0D\5411\91CF\300D\6578\5B57\8207\5730\5740\5C6C\6027\7684\5C0D\61C9\5982\4E0B:</strong></p>'),
'<ul>',
unistr('<li><p>3: \5730\5740\9EDE (\8207\5730\7406\7DE8\78BC\4F7F\7528\8CC7\6599\5B8C\5168\76F8\7B26\7684\5730\5740)</p></li>'),
unistr('<li><p>4: \53EF\80FD\7684\9EDE\540D\7A31</p></li>'),
unistr('<li><p>5: \9580\724C\865F\78BC</p></li>'),
unistr('<li><p>6: \8857\9053\9996\78BC</p></li>'),
unistr('<li><p>7: \8857\9053\540D\7A31</p></li>'),
unistr('<li><p>8: \8857\9053\5C3E\78BC</p></li>'),
unistr('<li><p>9: \8857\9053\985E\578B</p></li>'),
unistr('<li><p>10: \6B21\8981\55AE\5143</p></li>'),
unistr('<li><p>11: \7E23/\5E02</p></li>'),
unistr('<li><p>14: \5730\5340</p></li>'),
unistr('<li><p>15: \570B\5BB6</p></li>'),
unistr('<li><p>16: \90F5\905E\5340\865F</p></li>'),
unistr('<li><p>17: \90F5\905E\5340\865F\9644\52A0\78BC</p></li>'),
unistr('<li><p><em>\5176\4ED6\6578\5B57\5C1A\672A\4F7F\7528.</em></p></li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1727549870549765.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\89F8\767C\5730\7406\7DE8\78BC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'AUTOMATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\6C7A\5B9A\5730\7406\7DE8\78BC\7684\89F8\767C\6642\6A5F. \9019\5305\62EC\57F7\884C\5730\7406\7DE8\78BC\670D\52D9 REST \8981\6C42\548C\986F\793A\542B\53EF\80FD\76F8\7B26\9805\76EE\4E4B\5373\73FE\5F0F\8996\7A97\7684\700F\89BD\5668.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728048005551626.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\81EA\52D5')
,p_return_value=>'AUTOMATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5730\7406\7DE8\78BC\6703\5728\9001\51FA\9801\9762\4E4B\524D\81EA\52D5\89F8\767C.</p>'),
unistr('<p>\76F8\4F9D\9805\76EE\503C\82E5\6709\6240\8B8A\66F4 (\4F8B\5982 <em>P1_STREET</em> \503C) \4E14\5230\76EE\524D\70BA\6B62\5C1A\672A\57F7\884C\5730\7406\7DE8\78BC, \6216\5C1A\672A\9078\53D6\6709\6548\7684\5730\5740, \7CFB\7D71\4FBF\6703\78BA\4FDD\81EA\52D5\89F8\767C\5730\7406\7DE8\78BC. \5728\6B64\60C5\6CC1\4E0B, \7CFB\7D71\6703\5148\4E2D\65B7\76EE\524D\9801\9762\9001\51FA\7684\9001\51FA\6D41\7A0B, \4E26\4E14\986F\793A\5167\542B\53EF\80FD\76F8\7B26\9805\76EE\7684\5373\73FE\5F0F\8996\7A97. \4F7F\7528\8005\82E5\9078\64C7\4E86\76F8\7B26\7684\7D50\679C, \7CFB\7D71\4FBF\6703\91CD\65B0\9001\51FA\9801\9762, \4E0D\6703\9032\4E00\6B65\4E2D\65B7.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728439221554365.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\52D5\614B\52D5\4F5C')
,p_return_value=>'DYNAMIC_ACTION'
,p_help_text=>unistr('<p>\5730\7406\7DE8\78BC\5FC5\9808\900F\904E\5728\9801\9762\4E2D\52A0\5165\300C\52D5\614B\52D5\4F5C\300D<em>\89F8\767C\5730\7406\7DE8\78BC</em>\7684\65B9\5F0F, \624D\6703\88AB\89F8\767C.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728803167561342.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4418)
,p_display_sequence=>30
,p_display_value=>unistr('jQuery \9078\53D6\5668')
,p_return_value=>'JQUERY_SELECTOR'
,p_help_text=>unistr('<p>\5730\7406\7DE8\78BC\662F\6839\64DA\9078\53D6\5668\8A2D\5B9A\70BA\76EE\6A19 DOM \5143\7D20\4E2D\7684\67D0\500B\4E8B\4EF6\800C\88AB\89F8\767C. \5982\679C\8F38\5165\6B04\4F4D\6709\88AB\53C3\7167, \5247\8A72\5143\7D20<em>\8B8A\66F4\6642</em>\5C31\6703\89F8\767C\5730\7406\7DE8\78BC, \5982\679C\6309\9215\6709\88AB\53C3\7167, \5247\8A72\6309\9215<em>\9EDE\9078\6642</em>\4FBF\6703\89F8\767C\5730\7406\7DE8\78BC.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1747463542804307.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\9078\53D6\5668')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1727549870549765.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JQUERY_SELECTOR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><em>P1_STREET</em> \548C <em>P1_ZIP_CODE</em> \9805\76EE\8B8A\66F4\6642\57F7\884C\8655\7406\4F5C\696D, jQuery \9078\53D6\5668:</p>'),
'<pre>',
'#P1_STREET,#P1_ZIP_CODE',
'</pre>'))
,p_help_text=>unistr('<p>\63D0\4F9B\53C3\7167\5143\7D20\7684 jQuery \9078\53D6\5668 (\6240\53C3\7167\7684\5143\7D20\6703\89F8\767C\5730\7406\7DE8\78BC). \6309\9215\6703\5728<em>\9EDE\9078\6642</em>\89F8\767C\5730\7406\7DE8\78BC, \5176\4ED6\5143\7D20\5247\662F\5728<em>\8B8A\66F4\6642</em>\9032\884C\89F8\767C.</p>')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(12982963519254231.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_name=>'apexgeocoderresponse'
,p_display_name=>unistr('\5730\7406\7DE8\78BC\56DE\61C9')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(12982639254254214.4418)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4418)
,p_name=>'apexgeocoderselection'
,p_display_name=>unistr('\9078\64C7\7D50\679C')
);
end;
/
prompt --application/shared_components/plugins/region_type/smart_filters
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1800664597261423.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SMART_FILTERS'
,p_display_name=>unistr('\667A\6167\578B\7BE9\9078\689D\4EF6')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SMART_FILTERS'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('<p>\4EE5\76F8\95DC\806F\300C\667A\6167\578B\7BE9\9078\689D\4EF6\300D\7684\4F86\6E90\70BA\57FA\790E\7684\5340\57DF, \4E00\822C\4F7F\7528\8005\53EF\4EE5\4F7F\7528\63D0\4F9B\7684\773E\591A\7BE9\9078\689D\4EF6, \5728\7A0B\5F0F\5BE6\969B\57F7\884C\6642\7E2E\6E1B\641C\5C0B\7D50\679C. </p>')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1816085788971276.4418)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5EFA\8B70\5B57\8A5E\4E0A\9650')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\6240\8981\986F\793A\7684\300C\5EFA\8B70\5B57\8A5E\300D\6578\76EE\4E0A\9650. \82E5\672A\6307\5B9A, \9810\8A2D\503C\5C07\6703\662F 5.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1816321935999387.4418)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\66F4\591A\7BE9\9078\689D\4EF6\5EFA\8B70\5B57\8A5E')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\662F\5426\53EF\900F\904E\300C\66F4\591A\7BE9\9078\689D\4EF6\300D\4E0B\62C9\5F0F\529F\80FD\8868\6309\9215, \9078\53D6\672A\986F\793A\70BA\300C\5EFA\8B70\5B57\8A5E\300D\7684\7BE9\9078\689D\4EF6.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1808803156261456.4418)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\7E2E\5BEB\6578\5B57\81E8\754C\503C')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('\63D0\4F9B\7E2E\5BEB\6578\5B57\683C\5F0F\986F\793A\6578\76EE\7684\81E8\754C\503C. \4F7F\7528\7E2E\5BEB\6578\5B57\683C\5F0F\6642, <strong>1,234</strong> \503C\5C07\986F\793A\70BA <strong>1K</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1801137838146661.4418)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\986F\793A\8CC7\6599\5217\7E3D\6578')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\986F\793A\8CC7\6599\5217\7E3D\6578\7684\4F4D\7F6E.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1801499572149580.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5426')
,p_return_value=>'N'
,p_help_text=>unistr('\4E0D\6703\986F\793A\8CC7\6599\5217\7E3D\6578.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1801880772227865.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\662F')
,p_return_value=>'Y'
,p_help_text=>unistr('\8CC7\6599\5217\7E3D\6578\6703\986F\793A\5728\5EFA\8B70\5B57\8A5E\4E0B\65B9.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1802207279232480.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\9078\53D6\5668')
,p_return_value=>'E'
,p_help_text=>unistr('\8CC7\6599\5217\7E3D\6578 (\7121\4EFB\4F55\6A19\7C64) \6703\986F\793A\5728\6B64\9078\53D6\5668\6240\6307\5B9A\7684\5143\7D20\5167. \9019\53EF\8B93\60A8\5C07\8CC7\6599\5217\7E3D\6578\653E\5728\9801\9762\4E0A\7684\4EFB\4F55\4F4D\7F6E.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802866258261858.4418)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\8CC7\6599\5217\7E3D\6578\6A19\7C64')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801137838146661.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\7528\65BC\8CC7\6599\5217\7E3D\6578\7684\6A19\7C64. \6B64\8655\82E5\672A\63D0\4F9B\4EFB\4F55\6A19\7C64, APEX \5C07\4F7F\7528 APEX.FS.TOTAL_ROW_COUNT_LABEL \6587\5B57\8A0A\606F.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803111571268834.4418)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\8CC7\6599\5217\7E3D\6578\9078\53D6\5668')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801137838146661.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>unistr('\9019\662F\9801\9762\4E0A\5143\7D20\7684\9078\53D6\5668, \667A\6167\578B\7BE9\9078\689D\4EF6\5340\57DF\5C07\6703\5728\8A72\8655\986F\793A\8CC7\6599\5217\7E3D\6578.')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1812244001261470.4418)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4418)
,p_name=>'facetschange'
,p_display_name=>unistr('\7BE9\9078\689D\4EF6\8B8A\66F4')
);
end;
/
prompt --application/shared_components/plugins/web_source_type/oci
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1900426248156512.4418)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'OCI'
,p_display_name=>'OCI'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','OCI'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/adfbc
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2200372246708480.4418)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ADFBC'
,p_display_name=>'ADF BC'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ADFBC'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/ords
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2302882720656544.4418)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ORDS'
,p_display_name=>'ORDS'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ORDS'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700889063556536.4418)
,p_plugin_id=>wwv_flow_api.id(2302882720656544.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\50B3\56DE\820A\6709 ORDS JSON')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6B64 ORDS REST \670D\52D9\82E5\50B3\56DE <em>ORDS \820A\6709 JSON \8868\793A\6CD5</em>\7684\8CC7\6599, \8ACB\555F\7528\6B64\9078\9805.')
);
end;
/
prompt --application/shared_components/plugins/item_type/search
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2606845974894125.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SEARCH'
,p_display_name=>unistr('\641C\5C0B')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SEARCH'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:PLACEHOLDER:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A\6587\5B57\6B04\4F4D, \8B93\4E00\822C\4F7F\7528\8005\80FD\5920\641C\5C0B\300C\591A\9762\5411\641C\5C0B\300D\5340\57DF\4E2D\9762\5411\7684\6E05\55AE\9805\76EE. \300C\591A\9762\5411\641C\5C0B\300D\5340\57DF\652F\63F4\4E00\500B\641C\5C0B\9762\5411, \6B64\9762\5411\4E0D\8AD6\9806\5E8F\70BA\4F55, \4E00\5F8B\6703\5728\9762\5411\6E05\55AE\7684\6700\4E0A\65B9.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2607008165899744.4418)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\641C\5C0B\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ROW'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2607312816901820.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2607008165899744.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\8CC7\6599\5217\641C\5C0B')
,p_return_value=>'ROW'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2607759273903144.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2607008165899744.4418)
,p_display_sequence=>20
,p_display_value=>'Oracle Text'
,p_return_value=>'ORACLE_TEXT'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2608156895911496.4418)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8F38\5165\6B04\4F4D')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FACET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2608417903912546.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2608156895911496.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\591A\9762\5411\641C\5C0B\5340\57DF\9802\7AEF')
,p_return_value=>'FACET'
,p_help_text=>unistr('\641C\5C0B\6B04\4F4D\6703\5448\73FE\5728\591A\9762\5411\641C\5C0B\5340\57DF\9802\7AEF\9762\5411\7684\4E0A\65B9.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2608887428914009.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2608156895911496.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5916\90E8\9801\9762\9805\76EE')
,p_return_value=>'PAGE_ITEM'
,p_help_text=>unistr('\53EF\4EE5\4F7F\7528\76F8\95DC\7684\300C\5916\90E8\9801\9762\9805\76EE\300D\5C6C\6027\4F86\9078\53D6\9801\9762\9805\76EE, \4F5C\70BA\300C\591A\9762\5411\641C\5C0B\300D\5340\57DF\7684\641C\5C0B\6B04\4F4D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2609288187919863.4418)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\5916\90E8\9801\9762\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2608156895911496.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2205297904876322.4418)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\96B1\85CF\7684\641C\5C0B\6B04\4F4D')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_SFILTERS'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\4E00\958B\59CB\662F\5426\8981\96B1\85CF\300C\667A\6167\578B\7BE9\9078\689D\4EF6\300D\7684\641C\5C0B\6B04\4F4D.')
);
end;
/
prompt --application/shared_components/plugins/region_type/map_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2801375174221512.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'MAP_REGION'
,p_display_name=>unistr('\5730\5716')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','MAP_REGION'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/mapbox-gl-js/1.13.0/mapbox-gl.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.spatialMap#MIN#.js'))
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/mapbox-gl-js/1.13.0/mapbox-gl-apex.css',
''))
,p_api_version=>2
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(2801502987221529.4418)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4418)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501189800179937.4418)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4418)
,p_name=>'spatialmapchanged'
,p_display_name=>unistr('\5DF2\8B8A\66F4\5730\5716')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501913148179938.4418)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4418)
,p_name=>'spatialmapclick'
,p_display_name=>unistr('\5DF2\9EDE\9078\5730\5716')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2500840574179919.4418)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4418)
,p_name=>'spatialmapinitialized'
,p_display_name=>unistr('\5DF2\521D\59CB\5316\5730\5716')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501516390179938.4418)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4418)
,p_name=>'spatialmapobjectclick'
,p_display_name=>unistr('\5DF2\9EDE\9078\5730\5716\7269\4EF6')
);
end;
/
prompt --application/shared_components/plugins/region_type/form
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3128550315022076.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FORM'
,p_display_name=>unistr('\8868\55AE')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FORM'),'')
,p_api_version=>2
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:EDITABLE'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\652F\63F4\4E0D\540C\8CC7\6599\4F86\6E90\7684\8868\55AE\5340\57DF. \6B64\8868\55AE\5340\57DF\9664\4FDD\6709\8CC7\6599\4F86\6E90 (\53EF\4EE5\662F\672C\6A5F\3001\9060\7AEF\6216 REST \670D\52D9) \7684\8CC7\8A0A\5916, \4E5F\542B\6709\6307\5B9A\7684\9801\9762\9805\76EE. \6BCF\500B\9805\76EE\90FD\6307\5B9A\7D66\4E00\500B\8868\55AE\5340\57DF\548C\4E00\500B\986F\793A\5340\57DF.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3128740851022088.4418)
,p_plugin_id=>wwv_flow_api.id(3128550315022076.4418)
,p_name=>'SOURCE_LOCATION'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_dml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3129968725049081.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_DML'
,p_display_name=>unistr('\8868\55AE - \81EA\52D5\8CC7\6599\5217\8655\7406 (DML)')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_DML'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\63D2\5165\3001\66F4\65B0\6216\522A\9664\8868\55AE\5340\57DF\8CC7\6599\5217\7684\8655\7406\4F5C\696D.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3130191485054761.4418)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\76EE\6A19\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\8981\57F7\884C\54EA\4E00\7A2E\8CC7\6599\5217\8655\7406\6280\8853, \4EE5\5132\5B58\5C0D\8868\55AE\5340\57DF\6240\505A\7684\8CC7\6599\8B8A\66F4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3130418909057477.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5340\57DF\4F86\6E90')
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D2\5165\3001\66F4\65B0\4EE5\53CA\522A\9664\90FD\4F7F\7528\5340\57DF\4F86\6E90\300CSQL \67E5\8A62\300D.</p>'),
unistr('<p>\6CE8\610F - \8ACB\78BA\5B9A\52D9\5FC5\5C07\4E0D\53EF\63D2\5165\6216\4E0D\53EF\66F4\65B0\8CC7\6599\6B04\7684<strong>\50C5\4F9B\67E5\8A62</strong>\8A2D\70BA<code>\662F</code>, \4EE5\907F\514D\8655\7406\6B64\985E\8CC7\6599\6B04.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3131111455059474.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\8868\683C/\8996\89C0\8868')
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D2\5165\3001\66F4\65B0\4EE5\53CA\522A\9664\90FD\4F7F\7528\4E0D\540C\65BC\5340\57DF\4F86\6E90\300CSQL \67E5\8A62\300D\4E2D\6240\5B9A\7FA9\7684\8868\683C\6216\8996\89C0\8868.'),
unistr('\4F8B\5982, SQL \67E5\8A62\5F9E\8868\683C\7D50\5408\6216\4E0D\53EF\66F4\65B0\7684\6AA2\8996\64F7\53D6\8CC7\6599, \800C\4E14\9700\8981\5C0D\55AE\4E00\57FA\672C\8868\683C\6216\53EF\66F4\65B0\7684\6AA2\8996\57F7\884C DML \8655\7406.</p>'),
unistr('<p>\6CE8\610F - \8ACB\78BA\5B9A\52D9\5FC5\5C07\4E0D\53EF\63D2\5165\6216\4E0D\53EF\66F4\65B0\8CC7\6599\6B04\7684<strong>\50C5\4F9B\67E5\8A62</strong>\8A2D\70BA<code>\662F</code>, \4EE5\907F\514D\8655\7406\6B64\985E\8CC7\6599\6B04.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3131849869061275.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4418)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL \7A0B\5F0F\78BC')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8655\7406\6839\64DA\81EA\8A02 PL/SQL \7A0B\5F0F\78BC\9032\884C. \60A8\53EF\4EE5\5229\7528\6B64\9078\9805\4F86\57F7\884C\4EFB\4F55 PL/SQL \7A0B\5F0F\78BC, \4EE5\64CD\63A7\73FE\6709\8CC7\6599\5EAB\4E2D\7684\6240\6709\8CC7\6599.</p>'),
unistr('<p>\82E5\4F7F\7528\8CC7\6599\5EAB\5957\88DD\7A0B\5F0F (\4F8B\5982\8868\683C API \6216\547C\53EB RESTful Web \670D\52D9), \5C31\5FC5\9808\5229\7528\6B64\9078\9805\4F86\5BE6\884C\5546\696D\908F\8F2F.</p>'),
unistr('<p>\6CE8\610F - \5C07\6703\5C0D\6BCF\500B\5DF2\63D2\5165\3001\66F4\65B0\6216\522A\9664\7684\8CC7\6599\5217\547C\53EB PL/SQL \7A0B\5F0F\78BC.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3132468628068159.4418)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\683C\64C1\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('\9078\53D6\8868\683C\64C1\6709\8005 (\7DB1\8981) \540D\7A31.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3132746852071841.4418)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\8868\683C\540D\7A31')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(3132468628068159.4418)
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('\8F38\5165\6709\5927\5C0F\5BEB\4E4B\5225\7684\8868\683C\6216\8996\89C0\8868\540D\7A31. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3133042217093897.4418)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\8981\63D2\5165/\66F4\65B0/\522A\9664\7684 PL/SQL \7A0B\5F0F\78BC')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\4F9B\7528\65BC\8655\7406\300C\8868\55AE\5340\57DF\300D\4E2D\64CD\63A7\4E4B\6BCF\4E00\5217\8CC7\6599\7684 PL/SQL \7A0B\5F0F\78BC.</p>'),
unistr('<p>\53EF\4F7F\7528\8CC7\6599\6B04\540D\7A31\4F5C\70BA\9023\7D50\8B8A\6578, \4EE5\5B58\53D6\8CC7\6599\6B04\7684\503C. \7CFB\7D71\8B8A\6578 <code>APEX$ROW_STATUS</code> \6703\50B3\56DE\8CC7\6599\5217\7684\72C0\614B, \800C\4E14\53EF\7528\65BC\6AA2\67E5\8CC7\6599\5217\662F\5426\5DF2\5EFA\7ACB\3001\66F4\65B0\6216\522A\9664 (\8ACB\53C3\95B1\4E0B\65B9\7BC4\4F8B, \77AD\89E3\5982\4F55\9032\884C\6AA2\67E5).</p>'),
unistr('<p><em>\6CE8\610F:</em> \4E3B\7D22\5F15\9375\8CC7\6599\6B04\82E5\662F\7531\89F8\767C\7A0B\5F0F\7522\751F\6216\4EE5 PL/SQL \7A0B\5F0F\78BC\7522\751F, \5C31\5FC5\9808\5C07\65B0\503C\6307\5B9A\7D66\4E3B\7D22\5F15\9375\8CC7\6599\6B04\7684\9023\7D50\8B8A\6578, \56E0\70BA\5728\63D2\5165\6216\66F4\65B0\4E4B\5F8C, &PRODUCT_NAME. \6703\4F7F\7528\9019\4E9B\503C\4F86\64F7\53D6\8CC7\6599\5217.</p>'),
unistr('<p>Oracle \5EFA\8B70\60A8\547C\53EB PL/SQL \5957\88DD\7A0B\5F0F\5167\7684\7A0B\5E8F\6216\51FD\6578, \4EE5\5229\65BC\91CD\8907\4F7F\7528\53CA\63D0\9AD8\53EF\7DAD\8B77\6027.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3133532996097347.4418)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\9632\6B62\907A\5931\66F4\65B0')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5728\6709\591A\4F4D\4F7F\7528\8005\66F4\65B0\540C\4E00\7B46\8CC7\6599\5EAB\8A18\9304\6642, \8655\7406\662F\5426\61C9\8A72\78BA\4FDD\66F4\65B0\4E0D\6703\907A\5931.</p> '),
unistr('<p>\7576\5169\4F4D\6216\66F4\591A\4F4D\4F7F\7528\8005\5617\8A66\66F4\65B0\76F8\540C\8CC7\6599\6642\5C31\6703\767C\751F\907A\5931\66F4\65B0, \800C\4E14\6700\5F8C\7684\66F4\65B0\6703\8986\5BEB\7B2C\4E00\4F4D\4F7F\7528\8005\6240\505A\7684\66F4\65B0\4EE5\5132\5B58\8B8A\66F4. \70BA\907F\514D\767C\751F\9019\7A2E\60C5\6CC1, \66F4\65B0\53EF\4EE5\6AA2\67E5\8CC7\6599\5EAB\4E2D\73FE\6709\7684\8CC7\6599\6B04\503C\8207\539F\5148\67E5\8A62\8CC7\6599\5217\6642\6240\64F7\53D6\7684\503C.</p>'),
unistr('<p>\4F8B\5982:'),
'  <ol>',
unistr('    <li>\4F7F\7528\8005 A \67E5\8A62\54E1\5DE5 (EMP) \8A18\9304.</li>'),
unistr('    <li>\4F7F\7528\8005 B \67E5\8A62\76F8\540C\7684\54E1\5DE5\8A18\9304.</li>'),
unistr('    <li>\4F7F\7528\8005 B \66F4\65B0 EMPNO = 7839 \7684\54E1\5DE5\8A73\7D30\8CC7\8A0A, \4E26\5C07\8B8A\66F4\5957\7528 (\78BA\8A8D) \81F3\8CC7\6599\5EAB.</li>'),
unistr('    <li>\4F7F\7528\8005 A \66F4\65B0 EMPNO = 7839 \7684\54E1\5DE5\8A73\7D30\8CC7\8A0A, \4E26\5617\8A66\5C07\8B8A\66F4\5957\7528\81F3\8CC7\6599\5EAB.</li>'),
'  </ol>',
unistr('\5982\679C\4F7F\7528\8005 A \9806\5229\66F4\65B0\76F8\540C\7684\8CC7\6599\5217, \4F7F\7528\8005 B \6240\505A\7684\8B8A\66F4\5C31\6703\907A\5931.'),
unistr('\7576\4F7F\7528\8005 A \5617\8A66\5132\5B58\8A72\54E1\5DE5\8CC7\6599\5217\6642, \8CC7\6599\5EAB\4E2D\7684\8CC7\6599\6703\8207\4F7F\7528\8005 A \539F\5148\67E5\8A62\7684\8CC7\6599\4E0D\540C. \5728\4EE5\4E0A\7684\6B65\9A5F 1 \4E2D, \53EF\4EE5\64F7\53D6\4F7F\7528\8005 A \539F\5148\67E5\8A62\7684\8CC7\6599\6B04\503C. \63A5\8457\5728\4EE5\4E0A\7684\6B65\9A5F 4 \4E2D, \53EF\4EE5\5C07\503C\8207\8CC7\6599\5EAB\4E2D\76EE\524D\7684\503C\505A\6BD4\8F03. \7531\65BC\4F7F\7528\8005 B \5728\6B65\9A5F 3 \66F4\65B0\4E86\8CC7\6599\5EAB\503C, \56E0\6B64\9019\9805\6BD4\8F03\6703\5F15\767C\4F7F\7528\8005 A \7684\932F\8AA4. \9019\6703\8B93\4E00\4F4D\4F7F\7528\8005\7121\6CD5\8986\5BEB\53E6\4E00\4F4D\4F7F\7528\8005\5C0D\76F8\540C\8CC7\6599\5217\6240\505A\7684\8B8A\66F4.</p>'),
unistr('<p>\6CE8\610F - \907A\5931\66F4\65B0\7684\5075\6E2C\65B9\5F0F\53EF\5728\300C\4E92\52D5\5F0F\65B9\683C\300D\5340\57DF\7684\5C6C\6027\4E2D\6307\5B9A, \6839\64DA<strong>\907A\5931\66F4\65B0\985E\578B</strong>\7684\8A2D\5B9A\800C\5B9A.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3134090605099409.4418)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\9396\5B9A\8CC7\6599\5217')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9078\53D6\662F\5426\8981\5728\8655\7406\8CC7\6599\5217\524D\5C07\8981\66F4\65B0\6216\522A\9664\7684\6BCF\500B\8CC7\6599\5217\9396\5B9A\5728\57FA\790E\8868\683C\4E2D.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3134396093101055.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\662F')
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7CFB\7D71\6703\4F7F\7528 SELECT ... FOR UPDATE \5C07\8981\66F4\65B0\6216\522A\9664\7684\8CC7\6599\5217\9396\5B9A, \4EE5\78BA\4FDD\5728\6B64\7570\52D5\78BA\8A8D\524D, \7121\6CD5\5C0D\8CC7\6599\5217\57F7\884C\5176\4ED6\7570\52D5.</p>'),
unistr('<p>\6CE8\610F - \5982\679C\767C\751F\932F\8AA4 (\4F8B\5982\53EF\66F4\65B0\7684\6AA2\8996\4E0D\652F\63F4\9396\5B9A), \5EFA\8B70\60A8\4F7F\7528 PL/SQL \7A0B\5F0F\78BC\4F86\9396\5B9A\9A45\52D5\8868\683C.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3135017839102248.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5426')
,p_return_value=>'N'
,p_help_text=>unistr('\8CC7\6599\5217\4E0D\6703\88AB\9396\5B9A.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3135486454103394.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4418)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL \7A0B\5F0F\78BC')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>unistr('\6B64\7570\52D5\78BA\8A8D\4E4B\5F8C, \624D\6703\4F7F\7528\81EA\8A02 PL/SQL \7A0B\5F0F\78BC\4F86\9396\5B9A\8CC7\6599\5217.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3136083157108563.4418)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\7528\65BC\9396\5B9A\8CC7\6599\5217\7684 PL/SQL \7A0B\5F0F\78BC')
,p_attribute_type=>'PLSQL'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3134090605099409.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>unistr('\8F38\5165\7528\4F86\9396\5B9A\8981\66F4\65B0\53CA\522A\9664\4E4B\8CC7\6599\5EAB\8868\683C\8CC7\6599\5217\7684 PL/SQL \7A0B\5F0F\78BC.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3136593347114047.4418)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\63D2\5165\5F8C\50B3\56DE\4E3B\7D22\5F15\9375')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\662F\5426\61C9\5728\8CC7\6599\5217\63D2\5165\8CC7\6599\5EAB\4E2D\5F8C, \5C07\4E3B\7D22\5F15\9375\8CC7\6599\6B04\50B3\56DE\76F8\5C0D\61C9\7684\5340\57DF\9805\76EE.'),
unistr('\4E00\822C\800C\8A00, \82E5\4E3B\7D22\5F15\9375\8CC7\6599\6B04\5F9E\8CC7\6599\5EAB\89F8\767C\7A0B\5F0F\6216 Oracle Database 12 <em>c</em> \8B58\5225\8CC7\6599\6B04\586B\5165, \5C31\61C9\8A72\4F7F\7528\6B64\9078\9805.</p>'),
unistr('<p>\6CE8\610F - \82E5\767C\751F\6307\793A\4E0D\5141\8A31\4F7F\7528 RETURNING INTO \5B50\53E5\7684\932F\8AA4, \60A8\5FC5\9808\5C07\6B64\9078\9805\8A2D\70BA\300C\5426\300D, \7136\5F8C\9810\5148\586B\5165\4E3B\7D22\5F15\9375\8CC7\6599\6B04.</p>')))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_init
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3136784192133583.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_INIT'
,p_display_name=>unistr('\8868\55AE - \521D\59CB\5316')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_INIT'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\8D77\59CB\8868\55AE\5340\57DF\9805\76EE\7684\8655\7406\4F5C\696D. \521D\59CB\5316\53EF\4EE5\662F\4F7F\7528\4E3B\7D22\5F15\9375\503C\5F9E\5340\57DF\4F86\6E90\64F7\53D6\8CC7\6599, \6216\662F\7C21\55AE\7684\8868\55AE\5340\57DF\9805\76EE\521D\59CB\5316.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1672950586323461.4418)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\4E0B\4E00\500B\4E3B\7D22\5F15\9375\9805\76EE')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1673291445325769.4418)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\4E0A\4E00\500B\4E3B\7D22\5F15\9375\9805\76EE')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1673579797330204.4418)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\76EE\524D\7684\8CC7\6599\5217/\9805\76EE\7E3D\8A08')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/process_type/data_loading
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3205849286768480.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'DATA_LOADING'
,p_display_name=>unistr('\8CC7\6599\8F09\5165')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','DATA_LOADING'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\53EF\6839\64DA\6307\5B9A\7684\8CC7\6599\8F09\5165\5B9A\7FA9, \5C07\8CC7\6599\8F09\5165\76EE\6A19\8868\683C\6216\96C6\5408\7684\8655\7406\4F5C\696D.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3206362206778771.4418)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8CC7\6599\8F09\5165\5B9A\7FA9')
,p_attribute_type=>'DATA LOAD DEFINITION ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\5F9E\300C\5171\7528\7684\5143\4EF6\300D\9078\53D6<strong>\8CC7\6599\8F09\5165\5B9A\7FA9</strong>. \8CC7\6599\8F09\5165\5B9A\7FA9\9664\4E86\5B9A\7FA9\76EE\6A19\8868\683C\6216\96C6\5408\3001\8F09\5165\65B9\6CD5\4EE5\53CA<em>\8CC7\6599\8A2D\5B9A\6A94</em>\4E4B\5916, \9084\5B9A\7FA9\5176\4ED6\5C6C\6027. \6240\6709\8CC7\6599\6B04\540D\7A31\3001\8CC7\6599\6B04\5C0D\61C9\548C\8CC7\6599\985E\578B\8CC7\8A0A\90FD\5132\5B58\5728\8CC7\6599\8A2D\5B9A\6A94\4E2D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3206568816782155.4418)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\4F86\6E90\8CC7\6599\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FILE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\8981\8F09\5165\4E4B\8CC7\6599\7684\4F86\6E90.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3206878557783527.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\6A94\6848\700F\89BD\9805\76EE')
,p_return_value=>'FILE'
,p_help_text=>unistr('\9078\64C7\76EE\524D\9801\9762\4E0A\6A94\6848\700F\89BD\9805\76EE\7684\540D\7A31. APEX \5C07\6703\5F9E\9078\64C7\7684\6A94\6848\8F09\5165\8CC7\6599.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3207319585784462.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\6587\5B57\5340\9805\76EE\540D\7A31')
,p_return_value=>'TEXT'
,p_help_text=>unistr('\9078\64C7\6587\5B57\5340\9805\76EE\7684\540D\7A31, \6B64\9805\76EE\5305\542B\8981\8F09\5165\7684\8CC7\6599.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3207692626786156.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4418)
,p_display_sequence=>30
,p_display_value=>unistr('SQL \67E5\8A62')
,p_return_value=>'SQL_QUERY'
,p_help_text=>unistr('\63D0\4F9B\50B3\56DE\5167\542B\8981\8F09\5165\4E4B\8CC7\6599\7684 CLOB \6216 BLOB \7684 SQL \67E5\8A62.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208086445789769.4418)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6A94\6848\700F\89BD\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FILE'
,p_help_text=>unistr('\9078\64C7\8F09\5165\8CC7\6599\4F86\6E90\7684\6A94\6848\700F\89BD\9805\76EE. \6B64\9805\76EE\5FC5\9808\4F7F\7528 <strong>APEX_APPLICATION_TEMP_FILES</strong> \4F5C\70BA\5176<strong>\5132\5B58\985E\578B</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208411305791534.4418)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6587\5B57\5340\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>unistr('\9078\64C7\6587\5B57\5340\9805\76EE\7684\540D\7A31, \6B64\9805\76EE\5305\542B\8981\8F09\5165\7684\8CC7\6599.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208742752793524.4418)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('SQL \67E5\8A62')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_QUERY'
,p_help_text=>unistr('\63D0\4F9B\53EF\50B3\56DE\4E00\500B\8CC7\6599\5217\548C\4E00\500B\8CC7\6599\6B04 \7684 SQL \67E5\8A62, \5176\4E2D\5305\542B\8F09\5165\8CC7\6599\4F86\6E90\7684 BLOB \6216 CLOB.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3209026300796805.4418)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\5305\542B XLSX \8A66\7B97\8868\540D\7A31\7684\9801\9762\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\4E0A\50B3\7684 XLSX \6A94\6848\4E2D\986F\793A\53EF\7528\5DE5\4F5C\8868\7684\9078\53D6\6E05\55AE\6216\5373\73FE\5F0F LOV \9805\76EE\6703\4F7F\7528\4EE5\4E0B<em>\503C\6E05\55AE SQL \67E5\8A62</em> (<strong>PX_FILE</strong> \662F\7528\4F86\4E0A\50B3 XLSX \6A94\6848\7684\6A94\6848\700F\89BD\9805\76EE).</p><p>\8ACB\6CE8\610F, <strong>SHEET_FILE_NAME</strong> \5C6C\6027\5FC5\9808\4EE5 LOV \50B3\56DE\8CC7\6599\6B04\7684\65B9\5F0F\4F7F\7528.</p>'),
'<pre>',
'select s.sheet_display_name display, ',
'       s.sheet_file_name    return',
'  from apex_application_temp_files f,',
'       table( <strong>apex_data_parser.get_xlsx_worksheets</strong>( p_content => f.blob_content ) ) s',
' where f.name = :PX_FILE',
'</pre>'))
,p_help_text=>unistr('<p>\63D0\4F9B\5167\542B\5DE5\4F5C\8868\540D\7A31\4EE5\8F09\5165 XLSX \6A94\6848\7684\9801\9762\9805\76EE. \8CC7\6599\5C07\5F9E\6307\5B9A\7684\5DE5\4F5C\8868\8F09\5165. \82E5\672A\63D0\4F9B, APEX \5C07\6703\5F9E XLSX \6A94\6848\4E2D\7684\7B2C\4E00\500B\5DE5\4F5C\8868\8F09\5165\8CC7\6599.</p><p><em>\9078\53D6\6E05\55AE</em>\9805\76EE\901A\5E38\6703\7528\65BC\6B64: \5728<em>\503C\6E05\55AE\67E5\8A62</em>\4E2D, \4F7F\7528 <strong>APEX_DATA_PARSER.GET_XLSX_WORKSHEETS</strong> \4EE5\4FBF\64F7\53D6\5DE5\4F5C\8868\7684\986F\793A\540D\7A31\548C\5167\90E8\540D\7A31.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1319771677848714.4418)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\5DF2\8655\7406\7684\8CC7\6599\5217\8A08\6578\9805\76EE')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>unistr('\9078\64C7\7528\4F86\5132\5B58\5DF2\4E0A\50B3 (\548C\5DF2\8655\7406) \8CC7\6599\5217\6578\76EE\7684\9801\9762\9805\76EE.\300C\8CC7\6599\8F09\5165\300D\8655\7406\4F5C\696D\5B8C\6210\5F8C\5373\53EF\4F7F\7528\6B64\503C, \4E26\986F\793A\65BC\8A0A\606F\4E2D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1320047176851343.4418)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\932F\8AA4\8CC7\6599\5217\8A08\6578\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>unistr('\9078\64C7\7528\4F86\5132\5B58\932F\8AA4\8CC7\6599\5217\6578\76EE\7684\9801\9762\9805\76EE.\300C\8CC7\6599\8F09\5165\300D\8655\7406\4F5C\696D\5B8C\6210\5F8C\4FBF\6703\6709\6B64\503C, \800C\4E14\53EF\5C07\5176\986F\793A\65BC\8A0A\606F\4E2D.')
);
end;
/
prompt --application/shared_components/plugins/item_type/range
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(4386180889228297.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RANGE'
,p_display_name=>unistr('\7BC4\570D\5716')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RANGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:ELEMENT:ENCRYPT:LOV:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>\986F\793A\542B\6709\5167\5EFA\503C\6E05\55AE\9078\53D6\5668\7684\9805\76EE.  \9762\5411\652F\63F4\55AE\4E00\6216\591A\91CD\9078\64C7, \4E5F\652F\63F4\624B\52D5\8F38\5165. \5728\55AE\4E00\9078\64C7\652F\63F4\65B9\9762, \6703\5C07\591A\500B\503C\986F\793A\70BA\5713\9215\7FA4\7D44\9078\9805, \8B93\4E00\822C\4F7F\7528\8005\80FD\5920\9078\53D6\55AE\4E00\503C. \5728\591A\91CD\9078\64C7\652F\63F4\65B9\9762, \6703\5C07\591A\500B\503C\986F\793A\70BA\6838\53D6\65B9\584A, \8B93\4E00\822C\4F7F\7528\8005\80FD\5920\9078\53D6\591A\500B\503C. \5728\624B\52D5\8F38\5165\652F\63F4\65B9\9762, \6587\5B57\6B04\4F4D\6703\5448\73FE\5728\9762\5411\4E0B\65B9, \8B93\4E00\822C\4F7F\7528\8005\80FD\5920\624B\52D5\8F38\5165\8981\7528\65BC\7BE9\9078\300C\7BE9\9078\300D\5340\57DF\7684\503C\7BC4\570D.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2513920677752961.4418)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9078\53D6\591A\500B\6A94\6848')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\9762\5411\662F\5426\652F\63F4\9078\53D6\591A\500B\6E05\55AE\9805\76EE.  \82E5\8A2D\70BA<strong>\958B\555F</strong>, \9762\5411\6703\5448\73FE\70BA\6838\53D6\65B9\584A, \4EE5\652F\63F4\591A\91CD\9078\64C7.  \82E5\8A2D\70BA<strong>\95DC\9589</strong>, \9762\5411\6703\5448\73FE\70BA\5713\9215\7FA4\7D44\9078\9805, \4EE5\652F\63F4\55AE\4E00\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2513635447749258.4418)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\624B\52D5\8F38\5165')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\7BC4\570D\9762\5411\662F\5426\652F\63F4\624B\52D5\8F38\5165.  \82E5\8A2D\70BA<strong>\958B\555F</strong>, \6587\5B57\6B04\4F4D\6703\5448\73FE\5728\9762\5411\4E0B\65B9, \8B93\4E00\822C\4F7F\7528\8005\80FD\5920\624B\52D5\8F38\5165\8981\7528\65BC\7BE9\9078\300C\7BE9\9078\300D\5340\57DF\7684\503C\7BC4\570D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(4386359236228299.4418)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\7BC4\570D\6587\5B57')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\8F38\5165\8981\5728\300C\624B\52D5\8F38\5165\300D\6587\5B57\6B04\4F4D\4E4B\9593\986F\793A\7684\6587\5B57.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728476028199560899.4418)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\76EE\524D\6A19\7C64')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>unistr('0% \81F3 %1')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728478221838569501.4418)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\76EE\524D\6A19\7C64 (\958B\9AD8)')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>unistr('\9AD8\65BC %0')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728476302635562853.4418)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\76EE\524D\6A19\7C64 (\958B\4F4E)')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>unistr('\4F4E\65BC %0')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(4390664988228304.4418)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4418)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\4EE5 SQL \67E5\8A62\70BA\57FA\790E\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\5177\6709\76F8\540C\986F\793A\503C\548C\50B3\56DE\503C\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\6CE8\610F: \82E5\662F\70BA\986F\793A\503C\548C\50B3\56DE\503C\9078\53D6\76F8\540C\7684\8CC7\6599\6B04, \8ACB\4F7F\7528\8CC7\6599\6B04\5225\540D.</p>'),
'</dd>',
unistr('<dt>\5177\6709\9023\7D50\8B8A\6578\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\6CE8\610F: \5982\679C <code>P3_DEPTNO</code> \662F\76F8\540C\9801\9762\4E0A\7684\53EF\4FEE\6539\9801\9762\9805\76EE, \8ACB\5C07<em>\968E\5C64\5F0F LOV \7236\9805\9805\76EE</em>\5C6C\6027\8A2D\70BA <code>P3_DEPTNO</code>.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/display_map
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(8870444141116576.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_MAP'
,p_display_name=>unistr('\986F\793A\5730\5716')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_MAP'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.displayMap#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A\4EE5 GeoJSON \9EDE\683C\5F0F\5EA7\6A19\70BA\57FA\790E\7684\5730\5716.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9070464796133078.4418)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\80CC\666F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\8981\4F7F\7528\7684\80CC\666F\5730\5716.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9070760381135077.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\9810\8A2D')
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\9810\8A2D\5730\5716\80CC\666F.</p>'),
unistr('<p>\6DF1\8272\4E3B\984C\53EF\4EE5\4F7F\7528 OpenStreetMap (\660E\4EAE\7248) \6216 OpenStreetMap (\6DF1\8272\7248).</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071162492136081.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4418)
,p_display_sequence=>20
,p_display_value=>unistr('OpenStreetMap (\660E\4EAE\7248)')
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5 OpenStreetMap \8CC7\6599\70BA\57FA\790E\7684\4E00\822C\7528\9014\57FA\790E\5730\5716. \6B64\57FA\790E\5730\5716\6A23\5F0F\91DD\5C0D\8CC7\6599\63D0\4F9B\8A73\7D30\7684\4F4D\7F6E\76F8\95DC\8CC7\8A0A.</p>'),
unistr('<p>\6A23\5F0F\7DB1\8981\548C\5B9A\7FA9\884D\751F\81EA "Mapbox Open Styles", \7531 KlokanTech.com \8207 OpenMapTiles \63D0\4F9B\8005\6240\63D0\4F9B. \7531 BSD/CC-BY \6388\6B0A\63D0\4F9B\6388\6B0A.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">\5728 GitHub \4E0A\6AA2\8996</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071529690137784.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4418)
,p_display_sequence=>30
,p_display_value=>unistr('OpenStreetMap (\6DF1\8272\7248)')
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5 OpenStreetMap \8CC7\6599\70BA\57FA\790E\7684\4E0D\9192\76EE\6DF1\8272\57FA\790E\5730\5716. \6B64\57FA\790E\5730\5716\6A23\5F0F\8457\91CD\65BC\8CC7\6599\7684\8996\89BA\5316.</p>'),
unistr('<p>\6A23\5F0F\7DB1\8981\548C\5B9A\7FA9\884D\751F\81EA "Mapbox Open Styles", \7531 KlokanTech.com \8207 OpenMapTiles \63D0\4F9B\8005\6240\63D0\4F9B. \7531 BSD/CC-BY \6388\6B0A\63D0\4F9B\6388\6B0A. Stamen Design \88FD\5716\7531 CC0 \63D0\4F9B\6388\6B0A.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">\5728 GitHub \4E0A\6AA2\8996</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071983425139542.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4418)
,p_display_sequence=>40
,p_display_value=>'OpenStreetMap Positron'
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5 OpenStreetMap \8CC7\6599\70BA\57FA\790E\7684\4E0D\9192\76EE\6DFA\8272\57FA\790E\5730\5716. \6B64\57FA\790E\5730\5716\6A23\5F0F\8457\91CD\65BC\8CC7\6599\7684\8996\89BA\5316.</p>'),
unistr('<p>\6A23\5F0F\7DB1\8981\548C\5B9A\7FA9\884D\751F\81EA "Mapbox Open Styles", \7531 KlokanTech.com \8207 OpenMapTiles \63D0\4F9B\8005\6240\63D0\4F9B. \7531 BSD/CC-BY \6388\6B0A\63D0\4F9B\6388\6B0A. Stamen Design \88FD\5716\7531 CC0 \63D0\4F9B\6388\6B0A.</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">\5728 GitHub \4E0A\6AA2\8996</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9072395929141067.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4418)
,p_display_sequence=>50
,p_display_value=>unistr('Oracle \4E16\754C\5730\5716')
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5 HERE Map \8CC7\6599\70BA\57FA\790E\7684\4E00\822C\7528\9014\57FA\790E\5730\5716. \6B64\57FA\790E\5730\5716\6A23\5F0F\91DD\5C0D\8CC7\6599\63D0\4F9B\4F4D\7F6E\76F8\95DC\8CC7\8A0A, \540C\6642\8457\91CD\65BC\8CC7\6599\7684\8996\89BA\5316.</p>'),
unistr('<p>\6A23\5F0F\7DB1\8981\548C\5B9A\7FA9\7531 Oracle, USA \6240\63D0\4F9B.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9072916496197068.4418)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\7E2E\653E\7B49\7D1A')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'14'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\8B93\6B64\5716\5C64\8B8A\70BA\53EF\898B\7684\7E2E\653E\7B49\7D1A.</p>'),
'<p>',
unistr('\6700\5C0F\503C: 1<br>'),
unistr('\6700\5927\503C: 18'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073279785199355.4418)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\986F\793A\6A19\8A18')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('<p>\6307\5B9A\662F\5426\61C9\986F\793A\6A19\8A18.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073555327202501.4418)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6A19\8A18\8272\5F69')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9073279785199355.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6A19\8A18\586B\5165\8272\5F69.</p>'),
unistr('<p>\53EF\4F7F\7528\5341\516D\9032\4F4D (hex) \8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\6307\5B9A\8272\5F69. \5341\516D\9032\4F4D\8868\793A\6CD5\5B9A\7FA9\65B9\5F0F\70BA #xxyyzz (# \5F8C\9762\63A5\8457 3 \7D44\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57), \5176\4E2D xx\3001yy \548C zz \70BA\5169\500B\5B57\5143\7684\5341\516D\9032\4F4D\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272. RGB \4EE3\78BC\5B9A\7FA9\65B9\5F0F\70BA RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F 0 \5230 255 \4E4B\9593\7684\6578\5B57, \5404\81EA\70BA\4E00\500B 8 \4F4D\5143\7684\4F4D\5143\7D44\503C, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\548C\85CD\8272.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9075223673219708.4418)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\5DE5\5177\63D0\793A')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9073279785199355.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6240\986F\793A\6A19\8A18\7684\5DE5\5177\63D0\793A\6587\5B57.</p>'),
unistr('<p>\6B64\5DE5\5177\63D0\793A\5C6C\6027\652F\63F4 HTML \8207 APEX \6A23\677F\6307\4EE4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073839532205482.4418)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\986F\793A\5730\5716\63A7\5236\9805')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\61C9\986F\793A\5730\5716\63A7\5236\9805.</p>'),
unistr('<p>\9019\6703\5728\5730\5716\4E2D\52A0\5165\7E2E\653E\548C\65CB\8F49\63A7\5236\9805.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9074137581210550.4418)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\4E92\52D5\5F0F\5730\5716')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5730\5716\662F\5426\5177\4E92\52D5\6027.</p>'),
unistr('<p>\82E5\8A2D\70BA\300C\5426\300D, \5C07\6703\5EFA\7ACB\975C\614B\5730\5716, \4E0D\5177\4EFB\4F55\4E92\52D5\6027.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11976499186792296.4418)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\9AD8\5EA6')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>unistr('\50CF\7D20')
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\986F\793A\7684\5730\5716\9AD8\5EA6 (\50CF\7D20).</p>'),
unistr('<p>\5730\5716\7684\9810\8A2D\9AD8\5EA6\662F\4EE5\5916\89C0\6BD4\4F8B 3:2 \6839\64DA\5176\5BEC\5EA6\8A08\7B97\6240\5F97.</p>')))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/exists
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11251017839289082.4418)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'EXISTS'
,p_display_name=>unistr('Exists SQL \67E5\8A62')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5982\679C\67E5\8A62\81F3\5C11\50B3\56DE\4E00\500B\8CC7\6599\5217, \6388\6B0A\914D\7F6E\5C31\901A\904E; \5982\679C\67E5\8A62\672A\50B3\56DE\4EFB\4F55\8CC7\6599\5217, \6388\6B0A\914D\7F6E\5C31\5931\6557.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11251530568311696.4418)
,p_plugin_id=>wwv_flow_api.id(11251017839289082.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('SQL \67E5\8A62')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''ADMIN''',
'</pre>'))
,p_help_text=>unistr('\5982\679C\67E5\8A62\81F3\5C11\50B3\56DE\4E00\500B\8CC7\6599\5217, \6388\6B0A\914D\7F6E\5C31\901A\904E; \5982\679C\67E5\8A62\672A\50B3\56DE\4EFB\4F55\8CC7\6599\5217, \6388\6B0A\914D\7F6E\5C31\5931\6557.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/not_exists
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11252021695318665.4418)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'NOT_EXISTS'
,p_display_name=>unistr('NOT Exists SQL \67E5\8A62')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','NOT_EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5982\679C\67E5\8A62\672A\50B3\56DE\4EFB\4F55\8CC7\6599\5217, \6388\6B0A\914D\7F6E\5C31\901A\904E; \5982\679C\67E5\8A62\50B3\56DE\4E00\6216\591A\500B\8CC7\6599\5217, \6388\6B0A\914D\7F6E\5C31\5931\6557.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11252200009321795.4418)
,p_plugin_id=>wwv_flow_api.id(11252021695318665.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('SQL \67E5\8A62')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''GUEST''',
'</pre>'))
,p_help_text=>unistr('\5982\679C\67E5\8A62\81F3\5C11\50B3\56DE\4E00\500B\8CC7\6599\5217, \6388\6B0A\914D\7F6E\5C31\5931\6557; \5982\679C\67E5\8A62\672A\50B3\56DE\4EFB\4F55\8CC7\6599\5217, \6388\6B0A\914D\7F6E\5C31\6210\529F.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_null
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11252712476325388.4418)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NULL'
,p_display_name=>unistr('\9805\76EE\662F\7A7A\503C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\9805\76EE\503C\662F\7A7A\503C.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11252900140331368.4418)
,p_plugin_id=>wwv_flow_api.id(11252712476325388.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_display_length=>30
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\6B64\9805\76EE\7684\503C\662F\7A7A\503C, \6388\6B0A\70BA\6210\529F, \5426\5247\70BA\5931\6557.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_not_null
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11253409836334113.4418)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NOT_NULL'
,p_display_name=>unistr('\9805\76EE\4E0D\662F\7A7A\503C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NOT_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\9805\76EE\503C\4E0D\662F\7A7A\503C.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11253615031335591.4418)
,p_plugin_id=>wwv_flow_api.id(11253409836334113.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\6B64\9805\76EE\7684\503C\4E0D\662F\7A7A\503C, \6388\6B0A\70BA\6210\529F, \5426\5247\70BA\5931\6557')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/function_body
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11254106158342546.4418)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'FUNCTION_BODY'
,p_display_name=>unistr('\50B3\56DE\5E03\6797\503C\7684 PL/SQL \51FD\6578')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','FUNCTION_BODY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\50B3\56DE true \6216 false \7684 PL/SQL \51FD\6578\4E3B\9AD4. \82E5\50B3\56DE false \503C, \6388\6B0A\914D\7F6E\5C31\5931\6557. \82E5\50B3\56DE true \503C, \6388\6B0A\914D\7F6E\5C31\901A\904E.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11254314469344909.4418)
,p_plugin_id=>wwv_flow_api.id(11254106158342546.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
,p_attribute_type=>'PLSQL FUNCTION BODY BOOLEAN'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\50B3\56DE true \6216 false \7684 PL/SQL \51FD\6578\4E3B\9AD4. \82E5\50B3\56DE false \503C, \6388\6B0A\914D\7F6E\5C31\5931\6557. \82E5\50B3\56DE true \503C, \6388\6B0A\914D\7F6E\5C31\901A\904E.'),
'<p/>',
unistr('\7BC4\4F8B:'),
'<pre>',
'return to_char(sysdate,''hh24'') between ''08'' and ''17'';',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11255012523353865.4418)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_EQUALS_VALUE'
,p_display_name=>unistr('\504F\597D\8A2D\5B9A\7B49\65BC\503C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\504F\597D\8A2D\5B9A\503C\7B49\65BC\503C.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11255227067358013.4418)
,p_plugin_id=>wwv_flow_api.id(11255012523353865.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\504F\597D\8A2D\5B9A\540D\7A31')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\6B64\504F\597D\8A2D\5B9A\7684\503C\7B49\65BC\4E0B\65B9\6B04\4F4D\4E2D\7684\503C, \6388\6B0A\70BA\6210\529F, \5982\679C\503C\4E0D\540C, \5247\70BA\5931\6557')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11255701918360235.4418)
,p_plugin_id=>wwv_flow_api.id(11255012523353865.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8ACB\53C3\898B\4E0A\65B9')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_not_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11257015209373543.4418)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_NOT_EQUALS_VALUE'
,p_display_name=>unistr('\504F\597D\8A2D\5B9A\4E0D\7B49\65BC\503C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\504F\597D\8A2D\5B9A\503C\4E0D\7B49\65BC\503C.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11257220750375150.4418)
,p_plugin_id=>wwv_flow_api.id(11257015209373543.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\504F\597D\8A2D\5B9A\540D\7A31')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\6B64\504F\597D\8A2D\5B9A\7684\503C\8207\4E0B\65B9\6B04\4F4D\4E2D\7684\503C\4E0D\540C, \6388\6B0A\70BA\6210\529F, \5982\679C\503C\76F8\540C, \5247\70BA\5931\6557')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11257725944376646.4418)
,p_plugin_id=>wwv_flow_api.id(11257015209373543.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8ACB\53C3\898B\4E0A\65B9')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11258208760381085.4418)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_EQUALS_VALUE'
,p_display_name=>unistr('\9805\76EE\7B49\65BC\503C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\9805\76EE\503C\7B49\65BC\503C.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11258417764383723.4418)
,p_plugin_id=>wwv_flow_api.id(11258208760381085.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\6B64\9805\76EE\7684\503C\7B49\65BC\4E0B\65B9\6B04\4F4D\4E2D\7684\503C, \6388\6B0A\70BA\6210\529F, \5982\679C\503C\4E0D\540C, \5247\70BA\5931\6557')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11258925383385933.4418)
,p_plugin_id=>wwv_flow_api.id(11258208760381085.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8ACB\53C3\898B\4E0A\65B9')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_not_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11259414086392075.4418)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_NOT_EQUALS_VALUE'
,p_display_name=>unistr('\9805\76EE\4E0D\7B49\65BC\503C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9805\76EE\503C\4E0D\7B49\65BC\503C.</p>'),
''))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11259621358394213.4418)
,p_plugin_id=>wwv_flow_api.id(11259414086392075.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\6B64\9805\76EE\7684\503C\8207\4E0B\65B9\6B04\4F4D\4E2D\7684\503C\4E0D\540C, \6388\6B0A\70BA\6210\529F, \5982\679C\503C\76F8\540C, \5247\70BA\5931\6557')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11260124128395028.4418)
,p_plugin_id=>wwv_flow_api.id(11259414086392075.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8ACB\53C3\898B\4E0A\65B9')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/geocoding_trigger
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(12476487024106188.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'GEOCODING_TRIGGER'
,p_display_name=>unistr('\89F8\767C\5730\7406\7DE8\78BC')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','GEOCODING_TRIGGER'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>\624B\52D5\89F8\767C<em>\5730\7406\7DE8\78BC\5730\5740</em>\9805\76EE\7684\5730\7406\7DE8\78BC\641C\5C0B.</p>')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/social
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(15242808636946504.4418)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SOCIAL'
,p_display_name=>unistr('\793E\7FA4\767B\5165')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SOCIAL'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\652F\63F4\4F7F\7528 Google\3001Facebook\3001\4E00\822C OpenID Connect \548C\4E00\822C OAuth2 \8B58\5225\63D0\4F9B\8005\9032\884C\8A8D\8B49.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15243730328988135.4418)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8B49\660E\8CC7\6599\5B58\653E\5340')
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\9078\53D6\5305\542B\8A8D\8B49\63D0\4F9B\8005\4E4B\5F9E\5C6C\7AEF ID \548C\52A0\5BC6\5BC6\78BC\7684\8B49\660E\8CC7\6599\5B58\653E\5340.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15249686303031715.4418)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8A8D\8B49\63D0\4F9B\8005')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18383539811983244.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4418)
,p_display_sequence=>10
,p_display_value=>unistr('OpenID Connect \63D0\4F9B\8005')
,p_return_value=>'OPENID_CONNECT'
,p_help_text=>unistr('\4F7F\7528\4EE5 OpenID Connect \70BA\57FA\790E\7684\8A8D\8B49\63D0\4F9B\8005. \60A8\5FC5\9808\5728\4E0B\9762\8F38\5165\63D0\4F9B\8005\7684\300COpenID \5C0B\627E URL\300D.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18384865200013886.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\4E00\822C OAuth2 \63D0\4F9B\8005')
,p_return_value=>'OAUTH2'
,p_help_text=>unistr('\4F7F\7528 OAuth2 \8A8D\8B49\63D0\4F9B\8005. \60A8\5FC5\9808\5728\4E0B\9762\8F38\5165\6388\6B0A\3001\6B0A\6756\53CA\4F7F\7528\8005\8CC7\8A0A\7AEF\9EDE\7684 URL.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18650405105549494.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4418)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
,p_help_text=>unistr('\4F7F\7528\9810\5148\5B9A\7FA9\7684\8A2D\5B9A\503C\9032\884C Google \767B\5165.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18650810905551172.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4418)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
,p_help_text=>unistr('\4F7F\7528\9810\5148\5B9A\7FA9\7684\8A2D\5B9A\503C\9032\884C Facebook \767B\5165.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15249997224035381.4418)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\5C0B\627E URL')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>unistr('\8F38\5165 OpenID Connect \63D0\4F9B\8005\7684\5C0B\627E URL.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18385430957035861.4418)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6388\6B0A\7AEF\9EDE URL')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>unistr('\8F38\5165 OAuth2 \63D0\4F9B\8005\7684\6388\6B0A\7AEF\9EDE URL.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18385701636038222.4418)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\6B0A\6756\7AEF\9EDE URL')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>unistr('\8F38\5165 OAuth2 \63D0\4F9B\8005\7684\6B0A\6756\7AEF\9EDE URL.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386081451040404.4418)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\4F7F\7528\8005\8CC7\8A0A\7AEF\9EDE URL')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>unistr('\8F38\5165 OAuth2 \63D0\4F9B\8005\7684\4F7F\7528\8005\8CC7\8A0A\7AEF\9EDE URL.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386627580109078.4418)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\7BC4\570D')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_examples=>unistr('\96FB\5B50\90F5\4EF6,\8A2D\5B9A\6A94')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\8F38\5165\8981\70BA\767B\5165\4F7F\7528\8005\8981\6C42\7684\6B0A\9650\6E05\55AE (\4F7F\7528\9017\865F\5340\9694).'),
unistr('\53EF\63A5\53D7\7684\503C\8996\8A8D\8B49\63D0\4F9B\8005\800C\5B9A.'),
unistr('\82E5\70BA OpenID Connect \548C Google, Application Express \6703\81EA\52D5\65B0\589E "openid" \7BC4\570D.'),
unistr('\8A8D\8B49\63D0\4F9B\8005\6703\6839\64DA\9019\4E9B\6B0A\9650\50B3\56DE\4F7F\7528\8005\5C6C\6027.'),
unistr('\60A8\53EF\4EE5\5C07\9019\4E9B\5C6C\6027\5C0D\61C9\81F3\61C9\7528\7A0B\5F0F\9805\76EE, \6216\4F7F\7528\5F8C\7E8C\8A8D\8B49\7A0B\5E8F\904B\7528 APEX_JSON.GET_% \51FD\6578\8655\7406\5B83\5011.'),
'</p><p>',
unistr('\4EE5\4E0B\7DB2\5740\5217\51FA OpenID Connect \7BC4\570D\548C\5C6C\6027 (\53C8\7A31\70BA\5BA3\544A): https://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(226010579134296999.4418)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\8A8D\8B49 URI \53C3\6578')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'prompt=consent'
,p_help_text=>unistr('\8F38\5165\8A8D\8B49 URI \7684\9078\64C7\6027\53C3\6578. \8ACB\53C3\95B1\8A8D\8B49\63D0\4F9B\8005\7684\6587\4EF6\4EE5\77AD\89E3\652F\63F4\7684\53C3\6578.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386934074146656.4418)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\4F7F\7528\8005\540D\7A31')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'#sub# (#APEX_AUTH_NAME#)'
,p_is_translatable=>false
,p_examples=>'#sub# (#APEX_AUTH_NAME#)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\8F38\5165\5305\542B\4F7F\7528\8005\540D\7A31\7684\5C6C\6027, \6216\8F38\5165\5305\542B\4E00\6216\591A\500B\4EE5 "#" \62EC\8D77\4F86\4E4B\5C6C\6027\66FF\4EE3\9805\76EE\7684\4EFB\610F\6587\5B57.'),
unistr('\60A8\53EF\4EE5\4F7F\7528 #APEX_AUTH_NAME# \53C3\7167\8A8D\8B49\914D\7F6E\540D\7A31.'),
unistr('\4F8B\5982, "#email# (#APEX_AUTH_NAME#)" \5C07\6703\7522\751F\7531\96FB\5B50\90F5\4EF6\5730\5740, \5F8C\9762\52A0\4E0A " (", \63A5\8457\662F\8A8D\8B49\914D\7F6E\540D\7A31, \5F8C\9762\518D\52A0\4E0A ")" \6240\7D44\6210\7684\4F7F\7528\8005\540D\7A31, \4F8B\5982 "jane.doe@example.com (Google)".'),
'</p><p>',
unistr('\8ACB\53C3\95B1\8A8D\8B49\63D0\4F9B\8005\6587\4EF6\4EE5\77AD\89E3\652F\63F4\7684\5C6C\6027.'),
unistr('\8ACB\6CE8\610F, \60A8\5FC5\9808\8A2D\5B9A\5FC5\8981\7684\7BC4\570D, \5426\5247\8A8D\8B49\63D0\4F9B\8005\4E0D\6703\50B3\9001\6240\6709\5C6C\6027.'),
unistr('\4EE5\4E0B\7DB2\5740\5217\51FA OpenID Connect \7BC4\570D\548C\5C6C\6027 (\53C8\7A31\70BA\5BA3\544A): https://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18652865850779852.4418)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\5176\4ED6\4F7F\7528\8005\5C6C\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>unistr('\9023\7D50,\7167\7247,\96FB\5B50\90F5\4EF6')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\8F38\5165\4EE5\9017\865F\5340\9694\7684\5176\4ED6\4F7F\7528\8005\8CC7\6599\5C6C\6027\6E05\55AE.'),
'</p><p>',
unistr('\8ACB\53C3\95B1\8A8D\8B49\63D0\4F9B\8005\6587\4EF6\4EE5\77AD\89E3\652F\63F4\7684\5C6C\6027.'),
unistr('\8ACB\6CE8\610F, \60A8\5FC5\9808\8A2D\5B9A\5FC5\8981\7684\7BC4\570D, \5426\5247\8A8D\8B49\63D0\4F9B\8005\4E0D\6703\50B3\9001\6240\6709\5C6C\6027.'),
unistr('\4EE5\4E0B\7DB2\5740\5217\51FA OpenID Connect \7BC4\570D\548C\5C6C\6027 (\53C8\7A31\70BA\5BA3\544A): https://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(118623542514218726.4418)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>95
,p_prompt=>unistr('\5C07\4F7F\7528\8005\540D\7A31\8F49\63DB\70BA\5927\5BEB')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\8A2D\5B9A\662F\5426\61C9\5C07\4F7F\7528\8005\540D\7A31\7684\5C6C\6027\503C\8F49\63DB\70BA\5927\5BEB.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(545768003551719989.4418)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>unistr('\6B0A\6756\8A8D\8B49\65B9\6CD5')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\8F38\5165\8B49\660E\8CC7\6599\7684\5F9E\5C6C\7AEF ID \548C\5F9E\5C6C\7AEF\52A0\5BC6\5BC6\78BC\50B3\9001\81F3\4F3A\670D\5668\7684\65B9\5F0F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545768719525723870.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\57FA\672C\8A8D\8B49')
,p_return_value=>'BASIC'
,p_help_text=>unistr('\5728\300C\57FA\672C\8A8D\8B49\300D\6A19\982D\4E2D\50B3\9001\5F9E\5C6C\7AEF ID \548C\5F9E\5C6C\7AEF\52A0\5BC6\5BC6\78BC.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545768336282722977.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4418)
,p_display_sequence=>22
,p_display_value=>unistr('\4E3B\9AD4\7684\57FA\672C\8A8D\8B49\548C\5F9E\5C6C\7AEF ID')
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>unistr('\5728\300C\57FA\672C\8A8D\8B49\300D\6A19\982D\4E2D\50B3\9001\5F9E\5C6C\7AEF ID \548C\5F9E\5C6C\7AEF\52A0\5BC6\5BC6\78BC, \540C\6642\5728\8981\6C42\4E3B\9AD4\4E2D\50B3\9001\5F9E\5C6C\7AEF ID.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545769143256728532.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\4E3B\9AD4\7684\5F9E\5C6C\7AEF ID \548C\5F9E\5C6C\7AEF\52A0\5BC6\5BC6\78BC')
,p_return_value=>'BODY'
,p_help_text=>unistr('\5728\8981\6C42\4E3B\9AD4\4E2D\50B3\9001\5F9E\5C6C\7AEF ID \548C\5F9E\5C6C\7AEF\52A0\5BC6\5BC6\78BC.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(829911196403661792.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\4E3B\9AD4\4E2D\7684\5F9E\5C6C\7AEF ID')
,p_return_value=>'CLID'
,p_help_text=>unistr('\50C5\5728\8981\6C42\4E3B\9AD4\4E2D\50B3\9001\5F9E\5C6C\7AEF ID.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328064759558360148.4418)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>120
,p_prompt=>unistr('\9A57\8B49\5C6C\6027')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\5982\679C\555F\7528, &PRODUCT_NAME. \6703\5C0B\627E "#name#_verified" \5C6C\6027 (\4F8B\5982, \82E5\70BA "email" \5C6C\6027, \5247\70BA "email_verified").'),
unistr('OpenID \5B9A\7FA9\8B58\5225\63D0\4F9B\8005\91DD\5C0D\672A\9A57\8B49\7684 "email" \548C "phone_number" \5C6C\6027\50B3\9001 <code>"#name#_verified":false</code>.'),
unistr('&PRODUCT_NAME. \6703\5FFD\7565\9019\985E\672A\9A57\8B49\7684\5C6C\6027.'),
unistr('\5982\679C "#name#" \70BA Username \5C6C\6027, \9019\6703\5C0E\81F4\8A8D\8B49\5931\6557.'),
'</p><p>',
unistr('\5982\679C\8B58\5225\63D0\4F9B\8005\8B93\653B\64CA\8005\8F38\5165\672A\7D93\9A57\8B49\7684\8CC7\6599\4F9B\61C9\7528\7A0B\5F0F\7528\65BC\8A8D\8B49,'),
unistr('\653B\64CA\8005\5C31\6709\53EF\80FD\6A21\64EC\61C9\7528\7A0B\5F0F\4E2D\7684\5176\4ED6\4F7F\7528\8005.'),
unistr('\300C\9A57\8B49\5C6C\6027\300D\6AA2\67E5\53EF\9632\6B62\6B64\7A2E\60C5\6CC1\767C\751F.'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388762589390412438.4418)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>110
,p_prompt=>unistr('\5C07\5176\4ED6\4F7F\7528\8005\5C6C\6027\5C0D\61C9\81F3')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'G_EMAIL,G_PROFILE,G_PICTURE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\63D0\4F9B<em>\5176\4ED6\4F7F\7528\8005\5C6C\6027</em>\6240\5C0D\61C9\7684\61C9\7528\7A0B\5F0F\9805\76EE\540D\7A31\6E05\55AE (\4EE5\9017\865F\5340\9694). \4F8B\5982, \82E5\8A2D\5B9A'),
'<ul>',
unistr('<li>\5176\4ED6\4F7F\7528\8005\5C6C\6027: email,profile,picture</li>'),
unistr('<li>\5C07\5176\4ED6\4F7F\7528\8005\5C6C\6027\5C0D\61C9\81F3: G_EMAIL,G_PROFILE,G_PICTURE</li>'),
'</ul>',
unistr('APEX \4FBF\6703\5C07\76F8\5C0D\61C9\9805\76EE\7684\5C6C\6027\503C\81EA\52D5\5132\5B58\5728\968E\6BB5\4F5C\696D\72C0\614B\4E2D.')))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_list_view
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(37314610637444633.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_LIST_VIEW'
,p_display_name=>unistr('\6E05\55AE\6AA2\8996')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_LIST_VIEW'),'')
,p_api_version=>1
,p_ajax_function=>'x'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\4EE5\6613\65BC\700F\89BD\7684\6E05\55AE\65B9\5F0F\986F\793A\8CC7\6599. \60A8\4E5F\53EF\4EE5\4F75\5165\8A31\591A\529F\80FD\4F86\589E\5F37\6E05\55AE\6AA2\8996.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37319921504457296.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\529F\80FD')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\91DD\5C0D\6B64\6E05\55AE\6AA2\8996\555F\7528\7684\529F\80FD.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(37507022952387983.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_display_sequence=>5
,p_display_value=>unistr('\9032\968E\683C\5F0F')
,p_return_value=>'ADVANCED_FORMATTING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24342207873614875.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\986F\793A\5F71\50CF')
,p_return_value=>'IMAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24341804410613872.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\986F\793A\6E05\55AE\5206\9694\7DDA')
,p_return_value=>'DIVIDER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24343018955618095.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_display_sequence=>50
,p_display_value=>unistr('\5177\6709\5206\5272\6309\9215')
,p_return_value=>'SPLIT_BUTTON'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24341429213611599.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_display_sequence=>55
,p_display_value=>unistr('\555F\7528\641C\5C0B')
,p_return_value=>'SEARCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24342612721616279.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_display_sequence=>65
,p_display_value=>unistr('\70BA\5DE2\72C0\6E05\55AE\6AA2\8996')
,p_return_value=>'NESTED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(37507428146389462.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_display_sequence=>70
,p_display_value=>unistr('\63D2\5165\6E05\55AE')
,p_return_value=>'INSET'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37321616440465218.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6587\5B57\8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>unistr('\9078\53D6\5305\542B\6E05\55AE\6AA2\8996\9805\76EE\4E4B\4E3B\8981\5167\5BB9\7684\8CC7\6599\5EAB\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18004831401462408.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6E05\55AE\5C6C\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5F9E\5C6C\7AEF\6703\6839\64DA\6E05\55AE\9805\76EE\6587\5B57\5EFA\7ACB\5206\9694\7DDA</dt>'),
'<dd><pre>',
'data-autodividers=true',
'</pre></dd>',
unistr('<dt>\8B8A\66F4\5716\793A</dt>'),
'<dd><pre>',
'data-icon="fa-gear"',
'</pre></dd>',
unistr('<dt>\8B8A\66F4\5206\5272\6309\9215\5716\793A</dt>'),
'<dd><pre>',
'data-split-icon="fa-gear"',
'</pre></dd>',
'</dl>'))
,p_help_text=>unistr('\8F38\5165\8981\5C0D\6B64\6E05\55AE\5143\7D20\8A2D\5B9A\7684\5176\4ED6\5C6C\6027. \8ACB\53C3\95B1\7BC4\4F8B\4EE5\77AD\89E3\5F71\97FF\6E05\55AE\6AA2\8996\7684\4E00\4E9B\5C6C\6027.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18003624513413103.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6E05\55AE\9805\76EE\5C6C\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5C07\6E05\55AE\9805\76EE\9023\7D50\5716\793A\8A2D\5B9A\70BA\522A\9664.</dt>'),
'<dd><pre>',
'data-icon="delete"',
'</pre></dd>',
'</dl>'))
,p_help_text=>unistr('\8F38\5165\8981\5C0D\6E05\55AE\9805\76EE\5143\7D20\8A2D\5B9A\7684\5176\4ED6\5C6C\6027. \8ACB\53C3\95B1\7BC4\4F8B\4EE5\77AD\89E3\5F71\97FF\6E05\55AE\6AA2\8996\7684\4E00\4E9B\5C6C\6027.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37322140682472248.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\6587\5B57\683C\5F0F')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\986F\793A\540D\7A31\8207\4E0B\65B9\54E1\5DE5\8058\50F1\65E5\671F</dt>'),
'<dd><pre>',
'&lt;h3&gt;&amp;ENAME.&lt;/h3&gt;',
'&lt;p&gt;Hire date: &amp;HIREDATE.&lt;/p&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\53EF\5448\73FE\6E05\55AE\6AA2\8996\9805\76EE\4E3B\8981\5167\5BB9\7684 HTML \6A19\8A18.</p>'),
unistr('<p>\82E5\8981\53C3\7167\6E05\55AE\6AA2\8996 SQL \6558\8FF0\53E5\7684\8CC7\6599\6B04\503C, \8ACB\4F7F\7528\66FF\4EE3\8A9E\6CD5.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37323637481490256.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\88DC\5145\8CC7\8A0A\8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>unistr('\9078\53D6\5305\542B\6E05\55AE\6AA2\8996\9805\76EE\4E4B\88DC\5145\8CC7\8A0A\7684\8CC7\6599\5EAB\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37512329447408820.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\88DC\5145\8CC7\8A0A\683C\5F0F')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\4EE5\7C97\9AD4\986F\793A\85AA\8CC7</dt>'),
'<dd><pre>',
'USD &lt;strong&gt;&amp;SAL.&lt;/strong&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\53EF\5448\73FE\6E05\55AE\6AA2\8996\9805\76EE\88DC\5145\8CC7\8A0A\7684 HTML \6A19\8A18.</p>'),
unistr('<p>\82E5\8981\53C3\7167\6E05\55AE\6AA2\8996 SQL \6558\8FF0\53E5\7684\8CC7\6599\6B04\503C, \8ACB\4F7F\7528\66FF\4EE3\8A9E\6CD5.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37323130554488257.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\8A08\6578\5668\8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_is_translatable=>false
,p_help_text=>unistr('\9078\53D6\5305\542B\8A08\6578\6CE1\6CE1\4E2D\986F\793A\4E4B\503C\7684\8CC7\6599\5EAB\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(42537525650337692.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\5F71\50CF\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IMAGE_BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IMAGE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\986F\793A\7684\5F71\50CF\7A2E\985E\8207\5176\8B80\53D6\4F86\6E90. \986F\793A\7684\5F71\50CF\53EF\4EE5\662F 16x16 \5927\5C0F\7684\5716\793A\6216 80x80 \5927\5C0F\7684\7E2E\5716. \5F71\50CF\7684\4F86\6E90\53EF\4EE5\662F\8CC7\6599\5EAB BLOB \8CC7\6599\6B04\6216\975C\614B\6A94\6848\7684 URL.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42538712275343327.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5132\5B58\5728 BLOB \4E2D\7684\5716\793A')
,p_return_value=>'ICON_BLOB'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42539233400349414.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\5F9E URL \8B80\53D6\7684\5716\793A')
,p_return_value=>'ICON_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42539638940351053.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\5132\5B58\5728 BLOB \4E2D\7684\5F71\50CF')
,p_return_value=>'IMAGE_BLOB'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42540042403352086.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4418)
,p_display_sequence=>50
,p_display_value=>unistr('\5F9E URL \8B80\53D6\7684\5F71\50CF')
,p_return_value=>'IMAGE_URL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37324142675491770.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\5F71\50CF BLOB \8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>unistr('\9078\53D6\5305\542B\5F71\50CF\4E14\8CC7\6599\985E\578B\70BA BLOB \7684\8CC7\6599\5EAB\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(42541812668371813.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\5F71\50CF\4E3B\7D22\5F15\9375\8CC7\6599\6B04 1')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S:ROWID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>unistr('\9078\53D6\67E5\5C0B\5F71\50CF\6642\6240\4F7F\7528\7684\4E3B\7D22\5F15\9375\8CC7\6599\6B04\6216\552F\4E00\7684\8CC7\6599\5EAB\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24272827642729595.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\5F71\50CF\4E3B\7D22\5F15\9375\8CC7\6599\6B04 2')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42541812668371813.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\9078\53D6\67E5\5C0B\5F71\50CF\6642\6240\4F7F\7528\7684\6B21\8981\4E3B\7D22\5F15\9375\8CC7\6599\6B04\6216\552F\4E00\7684\8CC7\6599\5EAB\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24218503552483082.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('\5F71\50CF URL \8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_URL,IMAGE_URL'
,p_help_text=>unistr('\9078\53D6\5305\542B\5716\793A/\5F71\50CF\4E4B URL \7684\8CC7\6599\5EAB\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37324722720495516.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\6E05\55AE\5206\9694\7DDA\8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIVIDER'
,p_help_text=>unistr('\9078\53D6\5305\542B\5206\9694\7DDA\7684\8CC7\6599\5EAB\8CC7\6599\6B04. \6BCF\4E00\6B21\5206\9694\7DDA\503C\8B8A\66F4\6642, \4FBF\6703\5728\6E05\55AE\6AA2\8996\9805\76EE\4E4B\9593\986F\793A\65B0\5206\9694\7DDA.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24027626694091285.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\6E05\55AE\5206\9694\7DDA\683C\5F0F')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5728\6A19\8A18\4E2D\986F\793A\90E8\9580\540D\7A31\8207\54E1\5DE5\6578\76EE</dt>'),
'<dd><pre>',
'&amp;DNAME. &lt;span class="t-MediaList-badge"&gt;&amp;EMP_COUNT.&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\53EF\5448\73FE\6E05\55AE\6AA2\8996\5206\9694\7DDA\7684 HTML \6A19\8A18.</p>'),
unistr('<p>\82E5\8981\53C3\7167\6E05\55AE\6AA2\8996 SQL \6558\8FF0\53E5\7684\8CC7\6599\6B04\503C, \8ACB\4F7F\7528\66FF\4EE3\8A9E\6CD5.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37322614971483782.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>160
,p_prompt=>unistr('\9023\7D50\76EE\6A19')
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\8F38\5165\4F7F\7528\8005\6309\67D0\500B\6E05\55AE\9805\76EE\5F8C\6240\8981\547C\53EB\7684\76EE\6A19\9801\9762.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37325839689500405.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>170
,p_prompt=>unistr('\5206\5272\6309\9215\76EE\6A19')
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SPLIT_BUTTON'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\8F38\5165\4F7F\7528\8005\6309\67D0\500B\6E05\55AE\9805\76EE\5F8C\6240\8981\547C\53EB\7684\76EE\6A19\9801\9762.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24021612683850679.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>180
,p_prompt=>unistr('\641C\5C0B\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SERVER_EXACT_IGNORE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\641C\5C0B\7684\57F7\884C\65B9\5F0F.</p>'),
unistr('<p>\5F9E\5C6C\7AEF\641C\5C0B\6703\5728\4F7F\7528\8005\958B\59CB\8F38\5165\5F8C\7ACB\5373\57F7\884C. \5C0D\65BC\6240\6709\4EE5\4F3A\670D\5668\70BA\57FA\790E\7684\641C\5C0B, \4F7F\7528\8005\5FC5\9808\6309 Enter \9375\624D\6703\986F\793A\641C\5C0B\7D50\679C. \4EE5\4F3A\670D\5668\70BA\57FA\790E\7684\641C\5C0B\624D\6703\9867\53CA\91DD\5C0D\61C9\7528\7A0B\5F0F\5B9A\7FA9\7684\300C\5B57\5143\503C\6BD4\8F03\300D\5168\57DF\5C6C\6027.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24022326881854766.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5F9E\5C6C\7AEF')
,p_return_value=>'CLIENT'
,p_help_text=>unistr('\82E5\8981\57F7\884C\700F\89BD\5668\7684\641C\5C0B, \6240\6709\6E05\55AE\6AA2\8996\9805\76EE\90FD\5FC5\9808\8F09\5165\700F\89BD\5668 (\8ACB\6CE8\610F, \6B64\6642\6703\5FFD\7565\300C\64F7\53D6\7684\8CC7\6599\5217\6578\76EE\300D\5C6C\6027). \8ACB\53EA\6709\5728\6E05\55AE\9805\76EE\70BA\6578\4E0D\591A\6642, \624D\4F7F\7528\6B64\641C\5C0B\9078\9805, \4EE5\907F\514D\767C\751F\4E0D\5FC5\8981\7684\9577\6642\9593\9801\9762\8F09\5165.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24022823811882269.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\4F3A\670D\5668: \5B8C\5168\76F8\7B26\4E14\6709\5927\5C0F\5BEB\4E4B\5225')
,p_return_value=>'SERVER_EXACT_CASE'
,p_help_text=>unistr('\4F7F\7528 LIKE [\641C\5C0B\503C]% \641C\5C0B\4EE5\67E5\8A62\7D50\679C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24023232469884808.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\4F3A\670D\5668: \5B8C\5168\76F8\7B26\4E14\5FFD\7565\5927\5C0F\5BEB')
,p_return_value=>'SERVER_EXACT_IGNORE'
,p_help_text=>unistr('\4F7F\7528 LIKE UPPER( [\641C\5C0B\503C] )% \641C\5C0B\4EE5\67E5\8A62\7D50\679C. \5C07\4E0D\6703\4F7F\7528\8CC7\6599\6B04\4E0A\73FE\6709\7684\7D22\5F15, \9664\975E\7D22\5F15\662F\4F7F\7528 UPPER \8868\793A\5F0F\7684\51FD\6578\7D22\5F15.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24023619787890578.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4418)
,p_display_sequence=>50
,p_display_value=>unistr('\4F3A\670D\5668: \76F8\4F3C\4E14\6709\5927\5C0F\5BEB\4E4B\5225')
,p_return_value=>'SERVER_LIKE_CASE'
,p_help_text=>unistr('\4F7F\7528 LIKE %[\641C\5C0B\503C]% \641C\5C0B\4EE5\67E5\8A62\7D50\679C. \5982\6B64\53EF\907F\514D\4F7F\7528\8A72\8CC7\6599\6B04\4E0A\73FE\6709\7684\7D22\5F15.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24024029483893440.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4418)
,p_display_sequence=>60
,p_display_value=>unistr('\4F3A\670D\5668: \76F8\4F3C\4E14\5FFD\7565\5927\5C0F\5BEB')
,p_return_value=>'SERVER_LIKE_IGNORE'
,p_help_text=>unistr('\4F7F\7528 LIKE %UPPER( [\641C\5C0B\503C] )% \641C\5C0B\4EE5\67E5\8A62\7D50\679C. \5982\6B64\53EF\907F\514D\4F7F\7528\8A72\8CC7\6599\6B04\4E0A\73FE\6709\7684\7D22\5F15.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10775027534399383.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>190
,p_prompt=>unistr('\641C\5C0B\8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>unistr('\9078\53D6\7528\65BC\641C\5C0B\7684\66FF\4EE3\8CC7\6599\5EAB\8CC7\6599\6B04. \5982\679C\672A\6307\5B9A\4EFB\4F55\9805\76EE, \5C07\6703\4F7F\7528\300C\6587\5B57\8CC7\6599\6B04\300D.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37327132202507698.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>200
,p_prompt=>unistr('\641C\5C0B\65B9\584A\9810\7559\4F4D\7F6E')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>unistr('\8F38\5165\641C\5C0B\65B9\584A\4E2D\986F\793A\7684\6587\5B57. \82E5\672A\6307\5B9A\503C, \5C07\6703\4F7F\7528\7CFB\7D71\8A0A\606F <strong>APEX.REGION.JQM_LIST_VIEW.SEARCH</strong> \7684\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37325332071498117.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>210
,p_prompt=>unistr('\5DE2\72C0\6E05\55AE\8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'NUMBER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NESTED'
,p_help_text=>unistr('\9078\53D6\5167\542B\5DE2\72C0\67E5\8A62\4E4B\968E\5C64\5C64\7D1A\7684\8CC7\6599\5EAB\8CC7\6599\6B04. \5982\679C\60A8\4F7F\7528 CONNECT BY \67E5\8A62, \8ACB\4F7F\7528\865B\64EC\8CC7\6599\6B04 <code>LEVEL</code>.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(644548607716477014.4418)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4418)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\4F9D\540D\7A31\6392\5217\986F\793A\6240\6709\54E1\5DE5</dt>'),
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
unistr('<dt>\4F9D\540D\7A31\6392\5217\986F\793A\76EE\524D\90E8\9580\7684\6240\6709\54E1\5DE5</dt>'),
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>\5982\679C\4F7F\7528\9023\7D50\8B8A\6578\53C3\7167\9801\9762\9805\76EE, \8ACB\5C07\5B83\5011\6307\5B9A\70BA<strong>\8981\9001\51FA\7684\9801\9762\9805\76EE<strong>.</p>'),
'</dd>',
unistr('<dt>\4F7F\7528 ROWID \4F5C\70BA\4E3B\7D22\5F15\9375\8CC7\6599\6B04</dt>'),
'<dd><pre>',
'SELECT a.rowid as pk_rowid, ',
'       a.* ',
'  FROM emp a ',
'ORDER BY a.ename',
'</pre>',
unistr('<p>\5982\679C\4F7F\7528 ROWID, \5FC5\9808\63D0\4F9B\8CC7\6599\6B04\5225\540D.</p>'),
'</dd>',
unistr('<dt>\50B3\56DE\6240\6709\54E1\5DE5\7684\5DE2\72C0\67E5\8A62</dt>'),
'<dd><pre>',
' select ename,',
'        level',
'   from emp',
'connect by prior empno = mgr',
'  start with mgr is null',
' order siblings by ename',
'</pre></dd>',
'</dl>',
''))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/close_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(72276595215456808.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLOSE_REGION'
,p_display_name=>unistr('\95DC\9589\5340\57DF')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLOSE_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\95DC\9589\652F\63F4\958B\555F\4E14\5DF2\958B\555F\7684\5340\57DF, \4F8B\5982\5167\5D4C\5C0D\8A71\65B9\584A\3001\5167\5D4C\5373\73FE\5F0F\8996\7A97\6216\53EF\96B1\85CF\9805\76EE.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/open_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(72276779733456826.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'OPEN_REGION'
,p_display_name=>unistr('\958B\555F\5340\57DF')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','OPEN_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\958B\555F\652F\63F4\958B\555F\7684\5340\57DF, \4F8B\5982\5167\5D4C\5C0D\8A71\65B9\584A\3001\5167\5D4C\5373\73FE\5F0F\8996\7A97\6216\53EF\96B1\85CF\9805\76EE.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_in_group
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(132376923088056966.4418)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_IN_GROUP'
,p_display_name=>unistr('\4F7F\7528\89D2\8272\6216\7FA4\7D44')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(132377321338088226.4418)
,p_plugin_id=>wwv_flow_api.id(132376923088056966.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\540D\7A31')
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4E00\6216\591A\500B\4F7F\7528\9017\865F\5340\9694\7684\7FA4\7D44\540D\7A31.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91772529032268265.4418)
,p_plugin_id=>wwv_flow_api.id(132376923088056966.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>unistr('\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91772831765269995.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\61C9\7528\7A0B\5F0F\89D2\8272')
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91773214348271589.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5DE5\4F5C\5340\7FA4\7D44')
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91773695579272344.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\81EA\8A02')
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_not_in_group
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(132377111646077506.4418)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_NOT_IN_GROUP'
,p_display_name=>unistr('\4E0D\4F7F\7528\89D2\8272\6216\7FA4\7D44')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_NOT_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(135876608363708702.4418)
,p_plugin_id=>wwv_flow_api.id(132377111646077506.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\540D\7A31')
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4E00\6216\591A\500B\4F7F\7528\9017\865F\5340\9694\7684\7FA4\7D44\540D\7A31.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91774410321279131.4418)
,p_plugin_id=>wwv_flow_api.id(132377111646077506.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>unistr('\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91774719920280165.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\61C9\7528\7A0B\5F0F\89D2\8272')
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91775192472281109.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5DE5\4F5C\5340\7FA4\7D44')
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91775511878281830.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\81EA\8A02')
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker_jet
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(144248864922483430.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER_JET'
,p_display_name=>unistr('\65E5\671F\9078\64C7\5668')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER_JET'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\986F\793A\6587\5B57\6B04\4F4D\4E14\5E36\6709\884C\4E8B\66C6\5716\793A. \4E00\822C\4F7F\7528\8005\53EF\4EE5\76F4\63A5\5728\6587\5B57\9805\76EE\4E2D\8F38\5165\65E5\671F, \6216\8005\6309\4E00\4E0B\884C\4E8B\66C6\5716\793A, \5F9E\5373\73FE\5F0F\884C\4E8B\66C6\9078\53D6\65E5\671F\548C\6642\9593 (\9078\64C7\6027).</p>'),
unistr('<p>\6B64\9805\76EE\7684<em>\683C\5F0F\906E\7F69</em>\82E5\5305\62EC\6642\9593\5143\4EF6, \5373\73FE\5F0F\884C\4E8B\66C6\4E2D\624D\6703\986F\793A\6642\9593.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142750950234528930.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5916\89C0')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63A7\5236\7528\65BC\9078\53D6\65E5\671F\7684\884C\4E8B\66C6\5916\89C0.</p>'),
unistr('<p>\6CE8\610F:\300C\986F\793A\65B9\5F0F\300D\70BA\300C\5373\73FE\5F0F\300D\6216\300C\5167\5D4C\300D\6642, \624D\53EF\4EE5\4F7F\7528\6B64\9078\9805.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142751748618530462.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\986F\793A\9031')
,p_return_value=>'SHOW-WEEK'
,p_help_text=>unistr('\662F\5426\5C07\986F\793A\7576\5E74\9031\6B21.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142752536880532293.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\6708\4EFD\9078\64C7\5668')
,p_return_value=>'MONTH-PICKER'
,p_help_text=>unistr('\662F\5426\61C9\5C07\6708\4EFD\5448\73FE\70BA\5141\8A31\9078\53D6\7684\6309\9215, \800C\4E0D\662F\6587\5B57.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142752956214532903.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\5E74\4EFD\9078\64C7\5668')
,p_return_value=>'YEAR-PICKER'
,p_help_text=>unistr('\662F\5426\61C9\5C07\5E74\4EFD\5448\73FE\70BA\5141\8A31\9078\53D6\7684\6309\9215, \800C\4E0D\662F\6587\5B57.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(143948862668782714.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6708\4EFD\5916\7684\65E5\5B50')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6C7A\5B9A\76EE\524D\6AA2\8996\6708\4EFD\5916\65E5\5B50\7684\884C\70BA.</p>'),
unistr('<p>\6CE8\610F:\300C\986F\793A\65B9\5F0F\300D\70BA\300C\5373\73FE\5F0F\300D\6216\300C\5167\5D4C\300D\6642, \624D\53EF\4EE5\4F7F\7528\6B64\9078\9805.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143949419755783405.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\96B1\85CF')
,p_return_value=>'HIDDEN'
,p_help_text=>unistr('\5C07\96B1\85CF\76EE\524D\6AA2\8996\6708\4EFD\5916\7684\65E5\5B50.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143949752332784630.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\53EF\9078\53D6')
,p_return_value=>'SELECTABLE'
,p_help_text=>unistr('\5C07\53EF\898B\4E14\53EF\9078\53D6\76EE\524D\6AA2\8996\6708\4EFD\5916\7684\65E5\5B50.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143950165800785286.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\53EF\898B')
,p_return_value=>'VISIBLE'
,p_help_text=>unistr('\5C07\53EF\898B\76EE\524D\6AA2\8996\6708\4EFD\5916\7684\65E5\5B50.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142148878705941262.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6642\9593\589E\91CF')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'15'
,p_display_length=>10
,p_max_length=>2
,p_unit=>unistr('\5206\9418')
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7528\65BC\6642\9593\9078\64C7\63A7\5236\9805\7684\6642\9593\589E\91CF (\5206\9418). \6CE8\610F: \9019\53EA\6703\63A7\5236\6B64\63A7\5236\9805\53EF\9078\53D6\7684\6642\9593, \60A8\4ECD\7136\53EF\4EE5\624B\52D5\8F38\5165\4E26\5132\5B58\9019\4E9B\589E\91CF\4EE5\5916\7684\6642\9593.</p>'),
unistr('<p>\6CE8\610F:\300C\986F\793A\65B9\5F0F\300D\70BA\300C\5373\73FE\5F0F\300D\6216\300C\5167\5D4C\300D, \4E14\958B\555F\300C\986F\793A\6642\9593\300D\6642, \624D\53EF\4EE5\4F7F\7528\6B64\9078\9805.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(267715778102442717.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\986F\793A\6642\6A5F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\63A7\5236\4F55\6642\986F\793A\5373\73FE\5F0F\884C\4E8B\66C6. \6CE8\610F:\300C\986F\793A\65B9\5F0F\300D\70BA\300C\5373\73FE\5F0F\300D\6216\300C\5167\5D4C\300D\6642, \624D\53EF\4EE5\4F7F\7528\6B64\9078\9805.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267716390932439526.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(267715778102442717.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\9805\76EE\7126\9EDE')
,p_return_value=>'FOCUS'
,p_help_text=>unistr('\7576\9805\76EE\53D6\5F97\7126\9EDE\6216\6309\4E00\4E0B\884C\4E8B\66C6\5716\793A\5F8C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267716858979438151.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(267715778102442717.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5716\793A\9EDE\9078')
,p_return_value=>'IMAGE'
,p_help_text=>unistr('\53EA\6709\5728\6309\4E00\4E0B\884C\4E8B\66C6\5716\793A\5F8C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141154378544914000.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\986F\793A\6642\9593')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\662F\5426\8981\5305\542B\6642\9593\8CC7\8A0A.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144250268701483448.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\986F\793A\65B9\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\65E5\671F\9078\64C7\5668\7684\986F\793A\6A21\5F0F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144250658827483448.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5373\73FE\5F0F')
,p_return_value=>'POPUP'
,p_help_text=>unistr('\7576\9805\76EE\53D6\5F97\7126\9EDE\6216\6309\4E00\4E0B\884C\4E8B\66C6\5716\793A\6642, \6703\5728\5373\73FE\5F0F\8996\7A97\986F\793A\884C\4E8B\66C6.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144252202058483449.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5167\5D4C')
,p_return_value=>'INLINE'
,p_help_text=>unistr('\884C\4E8B\66C6\4E00\5F8B\6703\4EE5\5167\5D4C\65B9\5F0F\986F\793A\5728\9801\9762\4E0A. \4E0D\6703\986F\793A\6587\5B57\6B04\4F4D, \800C\76EE\524D\7684\65E5\671F\9078\9805\6703\53CD\767D\986F\793A\5728\884C\4E8B\66C6\4E0A.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142151127231126342.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\539F\751F HTML')
,p_return_value=>'NATIVE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\539F\751F HTML \8F38\5165\65E5\671F\985E\578B\5448\73FE (\82E5\700F\89BD\5668\652F\63F4). \82E5\95DC\9589\300C\986F\793A\6642\9593\300D, \9019\6703\5448\73FE ''date'' \985E\578B; \82E5\958B\555F\300C\986F\793A\6642\9593\300D, \5247\6703\5448\73FE ''datetime-local'' \985E\578B. \6CE8\610F: \9019\4E9B\65E5\671F\985E\578B\7684\5BE6\969B\986F\793A\65B9\5F0F\53D6\6C7A\65BC\700F\89BD\5668\7A2E\985E. \82E5\61C9\7528\7A0B\5F0F\7528\65BC\884C\52D5\88DD\7F6E, \5247\5EFA\8B70\4F7F\7528\300C\539F\751F HTML\300D\9078\9805.</p>'),
unistr('<p>\8ACB\6CE8\610F, \4F7F\7528\300C\539F\751F HTML\300D\6642, \56E0\70BA\539F\751F\65E5\671F\985E\578B\5C0D\65BC\6240\9700\8981\7684\65E5\671F\683C\5F0F\975E\5E38\660E\78BA, \56E0\6B64\9805\76EE\7684\300C\683C\5F0F\906E\7F69\300D\5C07\7531 APEX \81EA\52D5\8A2D\5B9A, \800C\4E14\60A8\7121\6CD5\8B8A\66F4. \4E0D\904E, \6B64\683C\5F0F\4E0D\6703\5C0D\4E00\822C\4F7F\7528\8005\986F\793A. \4E00\822C\4F7F\7528\8005\6703\898B\5230\4F7F\7528\9069\5408\5176\76EE\524D\5730\5340\8A2D\5B9A\683C\5F0F\7684\65E5\671F.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141749600267473768.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6700\5C0F\65E5\671F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\6B64\9805\76EE\662F\5426\6709\6700\5C0F\65E5\671F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750147879475182.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7121')
,p_return_value=>'NONE'
,p_help_text=>unistr('\672A\5B9A\7FA9\6700\5C0F\65E5\671F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750575076477005.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\9805\76EE')
,p_return_value=>'ITEM'
,p_help_text=>unistr('\6700\5C0F\65E5\671F\5F9E\5176\4ED6\9805\76EE\503C\52D5\614B\884D\751F\800C\4F86.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750953061477828.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\975C\614B')
,p_return_value=>'STATIC'
,p_help_text=>unistr('\6700\5C0F\65E5\671F\662F\975C\614B\503C, \5176\5B9A\7FA9\7684\503C\662F\7D55\5C0D\503C\6216\4ECA\5929\65E5\671F\7684\76F8\5C0D\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144249127342483446.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\975C\614B\503C\4E0B\9650')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141749600267473768.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\53EF\4EE5\8F38\5165\6216\9078\53D6\7684\6700\5C0F\65E5\671F.</p>'),
unistr('<p>\65E5\671F\503C\53EF\4EE5\662F <code>''YYYY-MM-DDTHH24:MI:SS''</code> \6216 <code>''YYYYMMDDHH24MI''</code> \683C\5F0F\7684\7D55\5C0D\503C, \6216\8005\8207\4ECA\5929\7684\65E5\671F\6709\95DC\7684\76F8\5C0D\503C (\4F8B\5982 <code>+7d</code>), \6216\8005\4F7F\7528\66FF\4EE3\8A9E\6CD5\7684\52D5\614B\503C, \4F46\689D\4EF6\70BA\66FF\4EE3\8A9E\6CD5\50B3\56DE\6B63\78BA\7684\65E5\671F\683C\5F0F\6216\76F8\5C0D\503C.</p>'),
unistr('<p>\76F8\5C0D\65E5\671F\503C\5305\62EC:</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \5E74\6578</dd>'),
'  <dt>m</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \6708\6578</dd>'),
'  <dt>w</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \9031\6578</dd>'),
'  <dt>d</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \5929\6578</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141754177794489952.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\9805\76EE\6578\4E0B\9650')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141749600267473768.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('<p>\6C7A\5B9A\5141\8A31\7684\6700\5C0F\503C\9805\76EE. \6B64\9801\9762\9805\76EE\5FC5\9808\4F4D\65BC\76EE\524D\7684\9801\9762\6216\5168\57DF\9801\9762.<p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141850062850547994.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\6700\5927\65E5\671F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\6B64\9805\76EE\662F\5426\6709\6700\5927\65E5\671F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141850596251549117.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7121')
,p_return_value=>'NONE'
,p_help_text=>unistr('\672A\5B9A\7FA9\6700\5927\65E5\671F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141850928550550352.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\9805\76EE')
,p_return_value=>'ITEM'
,p_help_text=>unistr('\6700\5927\65E5\671F\5F9E\5176\4ED6\9805\76EE\503C\52D5\614B\884D\751F\800C\4F86.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141851351298550860.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\975C\614B')
,p_return_value=>'STATIC'
,p_help_text=>unistr('\6700\5927\65E5\671F\662F\975C\614B\503C, \5176\5B9A\7FA9\7684\503C\662F\7D55\5C0D\503C\6216\4ECA\5929\65E5\671F\7684\76F8\5C0D\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144249516166483447.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\975C\614B\503C\4E0A\9650')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141850062850547994.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\53EF\4EE5\8F38\5165\6216\9078\53D6\7684\6700\5927\65E5\671F.</p>'),
unistr('<p>\65E5\671F\503C\53EF\4EE5\662F <code>''YYYY-MM-DDTHH24:MI:SS''</code> \6216 <code>''YYYYMMDDHH24MI''</code> \683C\5F0F\7684\7D55\5C0D\503C, \6216\8005\8207\4ECA\5929\7684\65E5\671F\6709\95DC\7684\76F8\5C0D\503C (\4F8B\5982 <code>+7d</code>), \6216\8005\4F7F\7528\66FF\4EE3\8A9E\6CD5\7684\52D5\614B\503C, \4F46\689D\4EF6\70BA\66FF\4EE3\8A9E\6CD5\50B3\56DE\6B63\78BA\7684\65E5\671F\683C\5F0F\6216\76F8\5C0D\503C.</p>'),
unistr('<p>\76F8\5C0D\65E5\671F\503C\5305\62EC:</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \5E74\6578</dd>'),
'  <dt>m</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \6708\6578</dd>'),
'  <dt>w</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \9031\6578</dd>'),
'  <dt>d</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \5929\6578</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141853413671557712.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\9805\76EE\6578\4E0A\9650')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141850062850547994.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('<p>\6C7A\5B9A\5141\8A31\7684\6700\5927\503C\9805\76EE. \6B64\9801\9762\9805\76EE\5FC5\9808\4F4D\65BC\76EE\524D\7684\9801\9762\6216\5168\57DF\9801\9762.<p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146749239835527240.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\591A\500B\6708\4EFD')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(144250268701483448.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'POPUP,INLINE'
,p_help_text=>unistr('\884C\4E8B\66C6\662F\5426\986F\793A\591A\500B\6708\4EFD.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144253456913483450.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\6708\6578')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146749239835527240.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\4E00\6B21\8981\986F\793A\7684\6708\6578.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142950502812595734.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\4F7F\7528\9810\8A2D\503C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\4F7F\7528\5728\300C\5171\7528\7684\5143\4EF6\300D>\300C\5143\4EF6\8A2D\5B9A\503C\300D\4E2D\70BA\6B64\5143\4EF6\5B9A\7FA9\7684\9810\8A2D\503C, \6216\81EA\8A02\8A2D\5B9A\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142548837341436051.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\5916\89C0')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63A7\5236\7528\65BC\9078\53D6\65E5\671F\7684\884C\4E8B\66C6\5916\89C0.</p>'),
unistr('<p>\6CE8\610F:\300C\986F\793A\65B9\5F0F\300D\70BA\300C\5373\73FE\5F0F\300D\6216\300C\5167\5D4C\300D\6642, \624D\53EF\4EE5\4F7F\7528\6B64\9078\9805.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549209563439534.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\986F\793A\9031')
,p_return_value=>'SHOW-WEEK'
,p_help_text=>unistr('\662F\5426\5C07\986F\793A\7576\5E74\9031\6B21.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549539424440887.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\6708\4EFD\9078\64C7\5668')
,p_return_value=>'MONTH-PICKER'
,p_help_text=>unistr('\662F\5426\61C9\5C07\6708\4EFD\5448\73FE\70BA\5141\8A31\9078\53D6\7684\6309\9215, \800C\4E0D\662F\6587\5B57.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549996724441519.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\5E74\4EFD\9078\64C7\5668')
,p_return_value=>'YEAR-PICKER'
,p_help_text=>unistr('\662F\5426\61C9\5C07\5E74\4EFD\5448\73FE\70BA\5141\8A31\9078\53D6\7684\6309\9215, \800C\4E0D\662F\6587\5B57.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144048842685822298.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('\6708\4EFD\5916\7684\65E5\5B50')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6C7A\5B9A\76EE\524D\6AA2\8996\6708\4EFD\5916\65E5\5B50\7684\884C\70BA.</p>'),
unistr('<p>\6CE8\610F:\300C\986F\793A\65B9\5F0F\300D\70BA\300C\5373\73FE\5F0F\300D\6216\300C\5167\5D4C\300D\6642, \624D\53EF\4EE5\4F7F\7528\6B64\9078\9805.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144049355435823179.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\96B1\85CF')
,p_return_value=>'HIDDEN'
,p_help_text=>unistr('\5C07\96B1\85CF\76EE\524D\6AA2\8996\6708\4EFD\5916\7684\65E5\5B50.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144049732421823927.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\53EF\9078\53D6')
,p_return_value=>'SELECTABLE'
,p_help_text=>unistr('\5C07\53EF\898B\4E14\53EF\9078\53D6\76EE\524D\6AA2\8996\6708\4EFD\5916\7684\65E5\5B50.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144050133633824443.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\53EF\898B')
,p_return_value=>'VISIBLE'
,p_help_text=>unistr('\5C07\53EF\898B\76EE\524D\6AA2\8996\6708\4EFD\5916\7684\65E5\5B50.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141748859804709713.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\6642\9593\589E\91CF')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>2
,p_unit=>unistr('\5206\9418')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7528\65BC\6642\9593\9078\64C7\63A7\5236\9805\7684\6642\9593\589E\91CF (\5206\9418). \6CE8\610F: \9019\53EA\6703\63A7\5236\6B64\63A7\5236\9805\53EF\9078\53D6\7684\6642\9593, \60A8\4ECD\7136\53EF\4EE5\624B\52D5\8F38\5165\4E26\5132\5B58\9019\4E9B\589E\91CF\4EE5\5916\7684\6642\9593.</p>'),
unistr('<p>\6CE8\610F:\300C\986F\793A\65B9\5F0F\300D\70BA\300C\5373\73FE\5F0F\300D\6216\300C\5167\5D4C\300D, \4E14\958B\555F\300C\986F\793A\6642\9593\300D\6642, \624D\53EF\4EE5\4F7F\7528\6B64\9078\9805.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(267717248823433082.4418)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\986F\793A\6642\6A5F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\63A7\5236\4F55\6642\986F\793A\5373\73FE\5F0F\884C\4E8B\66C6. \6CE8\610F:\300C\986F\793A\65B9\5F0F\300D\70BA\300C\5373\73FE\5F0F\300D\6216\300C\5167\5D4C\300D\6642, \624D\53EF\4EE5\4F7F\7528\6B64\9078\9805.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267717787671430611.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(267717248823433082.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\9805\76EE\7126\9EDE')
,p_return_value=>'FOCUS'
,p_help_text=>unistr('\7576\9805\76EE\53D6\5F97\7126\9EDE\6216\6309\4E00\4E0B\884C\4E8B\66C6\5716\793A\5F8C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267718203365429155.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(267717248823433082.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5716\793A\9EDE\9078')
,p_return_value=>'IMAGE'
,p_help_text=>unistr('\53EA\6709\5728\6309\4E00\4E0B\884C\4E8B\66C6\5716\793A\5F8C.')
);
end;
/
prompt --application/shared_components/plugins/item_type/single_checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(146860542307282603.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SINGLE_CHECKBOX'
,p_display_name=>unistr('\6838\53D6\65B9\584A')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACET_GRP_ITEMS:APEX_APPL_PAGE_SFILTER_GRP_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SINGLE_CHECKBOX'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A\4F7F\7528\8005\53EF\52FE\9078\6216\53D6\6D88\52FE\9078\7684\55AE\4E00\6838\53D6\65B9\584A. \5B9A\7FA9\7684\52FE\9078\6216\672A\52FE\9078\503C\6703\5728\9001\51FA\5F8C\5132\5B58\5728\968E\6BB5\4F5C\696D\72C0\614B\4E2D.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146860884924292553.4418)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6838\53D6\7684\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4E00\822C\4F7F\7528\8005\52FE\9078\6B64\6838\53D6\65B9\584A\6642, \5132\5B58\5728\9801\9762\9805\76EE\4E2D\7684\503C. \6B64\503C\7684\9577\5EA6\6700\591A\53EF\70BA 255 \500B\5B57\5143.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146861562091295771.4418)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\672A\6838\53D6\7684\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4F7F\7528\8005\672A\52FE\9078\6B64\6838\53D6\65B9\584A\6642, \5132\5B58\5728\9801\9762\9805\76EE\4E2D\7684\503C. \82E5\60F3\8981\5728\52FE\9078\6642\5132\5B58 <code>NULL</code>, \4E5F\53EF\4EE5\5C07\6B64\5C6C\6027\7559\767D. \6B64\503C\7684\9577\5EA6\6700\591A\53EF\70BA 255 \500B\5B57\5143.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146862485248305221.4418)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\4F7F\7528\9810\8A2D\503C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\4F7F\7528\5728\300C\5171\7528\7684\5143\4EF6\300D>\300C\5143\4EF6\8A2D\5B9A\503C\300D\4E2D\70BA\6B64\5143\4EF6\5B9A\7FA9\7684\9810\8A2D\503C, \6216\81EA\8A02\8A2D\5B9A\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146864548825351464.4418)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6838\53D6\7684\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146862485248305221.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\8F38\5165\4F7F\7528\8005\52FE\9078\6B64\6838\53D6\65B9\584A\6642, \5132\5B58\5728\9801\9762\9805\76EE\4E2D\7684\503C. \6B64\503C\7684\9577\5EA6\6700\591A\70BA 255 \500B\5B57\5143.</p>'),
'<p>',
unistr('\5728\300C\591A\9762\5411\641C\5C0B\300D\9801\9762\4E2D, \9762\5411\5982\679C<em>\6839\64DA\503C\6E05\55AE</em>\7BE9\9078\67D0\500B\67E5\8A62\8CC7\6599\6B04, \6B64\503C\5247\5FC5\9808\7B26\5408 LOV \986F\793A\503C\8207\50B3\56DE\503C<em>\5169\8005</em>. \5982\679C\986F\793A\503C\8207\50B3\56DE\503C\4E0D\540C, \60A8\5C31\7121\6CD5\5C07\6B64\9762\5411\985E\578B\7528\65BC\9019\500B\8CC7\6599\6B04. \8ACB\6539\7528<strong>\6838\53D6\65B9\584A\7FA4\7D44</strong>\9762\5411.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146865043227355165.4418)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\672A\6838\53D6\7684\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>19
,p_max_length=>255
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146862485248305221.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\4F7F\7528\8005\672A\52FE\9078\6B64\6838\53D6\65B9\584A\6642, \5132\5B58\5728\9801\9762\9805\76EE\4E2D\7684\503C. \82E5\60F3\8981\5728\672A\52FE\9078\6642\5132\5B58 <code>NULL</code>, \4E5F\53EF\4EE5\5C07\6B64\5C6C\6027\7559\767D. \6B64\503C\7684\9577\5EA6\6700\591A\53EF\70BA 255 \500B\5B57\5143.</p>'),
unistr('<p><em>\6CE8\610F: \9801\9762\9805\76EE\4E2D\586B\5165\7684\503C\82E5\4E0D\662F<strong>\52FE\9078\7684\503C</strong>\6216<strong>\672A\52FE\9078\7684\503C</strong>, \5C31\6703\4F7F\7528\9019\500B\503C.</em></p>')))
);
end;
/
prompt --application/shared_components/plugins/region_type/ig
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(230331270232947234.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IG'
,p_display_name=>unistr('\4E92\52D5\5F0F\65B9\683C')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IG'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5 SQL \67E5\8A62\70BA\57FA\790E\7684\5B8C\5099\7DDA\4E0A\591A\91CD\8CC7\6599\5217\5340\57DF\63D0\4F9B\4E86\8A31\591A\81EA\8A02\529F\80FD, \8B93\4E00\822C\4F7F\7528\8005\53EF\5728\7A0B\5F0F\5BE6\969B\57F7\884C\6642\4F7F\7528. '),
unistr('\7576\4E2D\7684\5340\57DF\53EF\5B9A\7FA9\70BA\53EF\7DE8\8F2F\6216\552F\8B80.</p>'),
unistr('<p>\60A8\53EF\4EE5\5B9A\7FA9\55AE\4E00\4E92\52D5\5F0F\65B9\683C, \4E26\8B93\4E00\822C\4F7F\7528\8005\80FD\5920\6839\64DA\5176\7279\5B9A\9700\6C42\64CD\63A7\8CC7\6599\7684\986F\793A, \56E0\6B64\60A8\4E0D\9700\8981\70BA\4E86\6EFF\8DB3\76F8\540C\7684\9700\6C42\800C\958B\767C\8A31\591A\4F7F\7528\4E0D\540C\689D\4EF6\7684\985E\4F3C\5340\57DF.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(465646569260662699.4418)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4418)
,p_name=>'SOURCE_LOCATION'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(936016374443633302.4418)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4418)
,p_name=>'apexbeginrecordedit'
,p_display_name=>unistr('\8CC7\6599\5217\521D\59CB\5316')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322074007251020.4418)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4418)
,p_name=>'gridpagechange'
,p_display_name=>unistr('\9801\9762\8B8A\66F4')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233321734838250996.4418)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4418)
,p_name=>'interactivegridmodechange'
,p_display_name=>unistr('\6A21\5F0F\8B8A\66F4')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322895758251022.4418)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4418)
,p_name=>'interactivegridreportchange'
,p_display_name=>unistr('\5831\8868\8B8A\66F4')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(230312956793621156.4418)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4418)
,p_name=>'interactivegridsave'
,p_display_name=>unistr('\5132\5B58')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(936015222634633296.4418)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4418)
,p_name=>'interactivegridselectionchange'
,p_display_name=>unistr('\9078\64C7\9805\76EE\8B8A\66F4')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322485880251022.4418)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4418)
,p_name=>'interactivegridviewchange'
,p_display_name=>unistr('\6AA2\8996\8B8A\66F4')
);
end;
/
prompt --application/shared_components/plugins/item_type/row_selector
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(253123678064187648.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_SELECTOR'
,p_display_name=>unistr('\8CC7\6599\5217\9078\53D6\5668')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_SELECTOR'),'')
,p_api_version=>2
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5C0D\4E92\52D5\5F0F\65B9\683C\7684\6BCF\500B\8CC7\6599\5217\986F\793A\4E00\500B\6838\53D6\65B9\584A, \4EE5\4FBF\5728\64CD\63A7\8CC7\6599\5217\6642\9078\53D6\7279\5B9A\8CC7\6599\5217.</p>'),
unistr('<p>\4F9D\7167\9810\8A2D, APEX$ROW_SELECTOR \8CC7\6599\6B04\8A2D\70BA\67D0\500B\985E\578B\7684\8CC7\6599\5217\9078\53D6\5668.  \7576\60A8\5C07\4E92\52D5\5F0F\65B9\683C\8A2D\70BA\53EF\7DE8\8F2F\6642, \7CFB\7D71\5C31\6703\81EA\52D5\65B0\589E\6B64\8CC7\6599\6B04.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(253123956742195925.4418)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\555F\7528\591A\91CD\9078\53D6')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\5141\8A31\9078\53D6\591A\500B\8CC7\6599\5217.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(253124243508199498.4418)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\986F\793A\5168\9078')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(253123956742195925.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\5141\8A31\4F7F\7528\8005\4F7F\7528 Ctrl+A \6216\4F7F\7528\8CC7\6599\6B04\6A19\982D\7684\6838\53D6\65B9\584A (<em>\96B1\85CF\63A7\5236\9805</em>\70BA<em>\5426</em>\6642) \4F86\9078\53D6\6240\6709\8CC7\6599\5217.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(276642483200371586.4418)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\96B1\85CF\63A7\5236\9805')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\96B1\85CF\6BCF\500B\8CC7\6599\5217\4E0A\986F\793A\7684\6838\53D6\65B9\584A\6216\5713\9215\63A7\5236\9805.')
);
end;
/
prompt --application/shared_components/plugins/item_type/row_action
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(253124868675308889.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_ACTION'
,p_display_name=>unistr('\52D5\4F5C\529F\80FD\8868')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_ACTION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\4E92\52D5\5F0F\65B9\683C\7684\6BCF\4E00\5217\986F\793A\52D5\4F5C\5716\793A (\6F22\5821). '),
unistr('\4F9D\65B9\683C\5C6C\6027\548C\4E00\822C\4F7F\7528\8005\6388\6B0A\7684\4E0D\540C, \52D5\4F5C\529F\80FD\8868\5305\542B\50CF\55AE\4E00\8CC7\6599\5217\6AA2\8996\3001\65B0\589E\8CC7\6599\5217\3001\522A\9664\8CC7\6599\5217\53CA\91CD\65B0\6574\7406\8CC7\6599\5217\7B49\9078\9805. \9019\4E9B\529F\80FD\8868\9078\9805\53EF\8B93\4E00\822C\4F7F\7528\8005\5C0D\65B9\683C\4E2D\7684\76EE\524D\8CC7\6599\5217\57F7\884C\7279\5B9A\52D5\4F5C.</p>'),
unistr('<p>\53EF\7DE8\8F2F\548C\4E0D\53EF\7DE8\8F2F\7684\4E92\52D5\5F0F\65B9\683C\4E2D\90FD\53EF\4F7F\7528\52D5\4F5C\529F\80FD\8868, \4F46\529F\80FD\8868\9078\9805\5247\6703\6709\6240\4E0D\540C. \82E5\70BA\4E0D\53EF\7DE8\8F2F\7684\4E92\52D5\5F0F\65B9\683C, \529F\80FD\8868\5C07\5305\542B\4E00\90E8\5206\7684\9078\9805, \4F8B\5982\300C\55AE\4E00\8CC7\6599\5217\6AA2\8996\300D\548C\300C\91CD\65B0\6574\7406\8CC7\6599\5217\300D, \4F46\4E0D\6703\5305\542B\50CF\300C\65B0\589E\8CC7\6599\5217\300D\3001\300C\522A\9664\8CC7\6599\5217\300D\7B49\4E4B\985E\7684\53EF\7DE8\8F2F\7279\5B9A\52D5\4F5C.</p>'),
unistr('<p>\4E92\52D5\5F0F\65B9\683C\82E5\8A2D\70BA\53EF\7DE8\8F2F, \5C07\6703\81EA\52D5\65B0\589E APEX$ROW_ACTION \8CC7\6599\6B04, \4E26\5C07\5176\8A2D\70BA\300C\52D5\4F5C\529F\80FD\8868\300D\985E\578B. \5C0D\65BC\4E0D\53EF\7DE8\8F2F\7684\4E92\52D5\5F0F\65B9\683C, \6B64\8CC7\6599\6B04\5FC5\9808\624B\52D5\65B0\589E.</p>')))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jet_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258086019711957603.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JET_CHART'
,p_display_name=>unistr('\5716\8868')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JET_CHART'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\4F7F\7528\5404\7A2E\4E0D\540C\7684\5167\5EFA\5716\8868\985E\578B\986F\793A\8CC7\6599.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(608666764128858384.4418)
,p_plugin_id=>wwv_flow_api.id(258086019711957603.4418)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/hide
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258533608465739815.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'HIDE'
,p_display_name=>unistr('\96B1\85CF')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','HIDE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\96B1\85CF\53D7\5F71\97FF\7684\5143\7D20.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262136912621901373.4418)
,p_plugin_id=>wwv_flow_api.id(258533608465739815.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5728\540C\4E00\884C\96B1\85CF\6240\6709\9801\9762\9805\76EE')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\96B1\85CF\8207\53D7\5F71\97FF\5143\7D20\6240\5728\540C\4E00\884C\4E0A\7684\6240\6709\9801\9762\9805\76EE\548C\6A19\7C64.</p>'),
unistr('<p>\6CE8\610F: \6B64\5C6C\6027\5C0D\672A\4F7F\7528\8868\683C\65B9\683C\986F\793A\8868\55AE\9805\76EE\4E4B\9801\9762\4E2D\7684\9805\76EE\6C92\6709\4F5C\7528. \9019\5305\62EC\4F7F\7528\884C\52D5\88DD\7F6E\9801\9762\6A23\677F\7684\6240\6709\9801\9762.</p>')))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/enable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258537221774904509.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ENABLE'
,p_display_name=>unistr('\555F\7528')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ENABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\555F\7528\53D7\5F71\97FF\7684\5143\7D20')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/disable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258537428700906571.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DISABLE'
,p_display_name=>unistr('\505C\7528')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DISABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\505C\7528\53D7\5F71\97FF\7684\5143\7D20. \505C\7528\6703\8B93\9019\4E9B\5143\7D20\4E0D\80FD\7DE8\8F2F, \56E0\6B64\5728\9801\9762\9001\51FA\5F8C\5B83\5011\4E0D\6703\4FDD\7559\9805\76EE\503C.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258538225714915177.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_VALUE'
,p_display_name=>unistr('\8A2D\5B9A\503C')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_VALUE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD:STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\8A2D\5B9A\53D7\5F71\97FF\5143\7D20\7684\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262584206591281622.4418)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8A2D\5B9A\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC_ASSIGNMENT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\61C9\8A72\5982\4F55\884D\751F\8981\8A2D\5B9A\7684\503C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262584812132283213.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\975C\614B\6307\5B9A')
,p_return_value=>'STATIC_ASSIGNMENT'
,p_help_text=>unistr('\8A2D\5B9A\55AE\4E00\975C\614B\503C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262585623560286495.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4418)
,p_display_sequence=>15
,p_display_value=>unistr('JavaScript \8868\793A\5F0F')
,p_return_value=>'JAVASCRIPT_EXPRESSION'
,p_help_text=>unistr('\8A2D\5B9A\4E00\6216\591A\500B\5F9E JavaScript \884D\751F\6216\8A08\7B97\51FA\7684\503C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262585216634284505.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4418)
,p_display_sequence=>20
,p_display_value=>unistr('SQL \6558\8FF0\53E5')
,p_return_value=>'SQL_STATEMENT'
,p_help_text=>unistr('\6839\64DA SQL \67E5\8A62\7684\7D50\679C, \8A2D\5B9A\4E00\6216\591A\500B\503C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(427666425507065443.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4418)
,p_display_sequence=>40
,p_display_value=>unistr('PL/SQL \8868\793A\5F0F')
,p_return_value=>'PLSQL_EXPRESSION'
,p_help_text=>unistr('\6839\64DA PL/SQL \8868\793A\5F0F\7684\7D50\679C, \8A2D\5B9A\55AE\4E00\503C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(427667018365072832.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4418)
,p_display_sequence=>50
,p_display_value=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
,p_return_value=>'FUNCTION_BODY'
,p_help_text=>unistr('\6839\64DA PL/SQL \51FD\6578\4E3B\9AD4\7684\7D50\679C, \8A2D\5B9A\55AE\4E00\503C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1295383602600152012.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4418)
,p_display_sequence=>60
,p_display_value=>unistr('\5C0D\8A71\65B9\584A\50B3\56DE\9805\76EE')
,p_return_value=>'DIALOG_RETURN_ITEM'
,p_help_text=>unistr('\6839\64DA\5C0D\8A71\65B9\584A\7684\50B3\56DE\9805\76EE, \8A2D\5B9A\55AE\4E00\503C. \6CE8\610F: \53EA\6709\5728\89F8\767C<strong>\5C0D\8A71\65B9\584A\5DF2\95DC\9589</strong>\4E8B\4EF6\7684\52D5\614B\52D5\4F5C\6642, \6B64\985E\578B\624D\9069\7528.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(258539307968928889.4418)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC_ASSIGNMENT'
,p_help_text=>unistr('\8F38\5165\975C\614B\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262586323439352724.4418)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('SQL \6558\8FF0\53E5')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>100
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_STATEMENT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select loc,',
'       dname',
'  from dept ',
' where deptno = :P1_DEPTNO',
'</pre>',
unistr('<p>\5728\6B64\7BC4\4F8B\4E2D, \5728 <strong>\8981\9001\51FA\7684\9801\9762\9805\76EE</strong> \4E2D\8F38\5165 <code>P1_DEPTNO</code>. \91DD\5C0D\7BC4\4F8B P1_LOC \8207 P1_DNAME, \60A8\61C9\8A72\5206\5225\70BA <code>loc</code> \8207 <code>dname</code> \8CC7\6599\6B04\9078\53D6\5169\500B<em>\53D7\5F71\97FF\7684\5143\7D20</em>.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\50B3\56DE 1 \5230 100 \500B\4E4B\9593\8CC7\6599\6B04\7684 SQL \6558\8FF0\53E5. \60A8\4F7F\7528\6B64 SQL \6558\8FF0\53E5\9078\53D6\7684\8CC7\6599\6B04, \5FC5\9808\6309\4F4D\7F6E\5C0D\61C9\81F3\60A8\5728<strong>\53D7\5F71\97FF\7684\5143\7D20</strong>\4E2D\9078\53D6\7684\9801\9762\9805\76EE.</p>'),
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\9023\7D50\8A9E\6CD5\53C3\7167\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE, \4F46\689D\4EF6\70BA\5FC5\9808\5C07\9019\4E9B\9805\76EE\5305\62EC\5728<strong>\8981\9001\51FA\7684\9801\9762\9805\76EE</strong>\4E2D.</p>'),
unistr('<p><em>\6CE8\610F: \5982\679C SQL \6558\8FF0\53E5\53EA\50B3\56DE\55AE\4E00\8CC7\6599\5217, \5247\6B64\6703\4F9D\503C\6240\8A2D\5B9A. \5982\679C\50B3\56DE\591A\500B\8CC7\6599\5217, \5247\503C\96C6\70BA\4F7F\7528\9017\865F\5340\9694\7684\6240\6709\8CC7\6599\5217\5B57\4E32 (\91DD\5C0D\6BCF\500B\503C).</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(427662501518001786.4418)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('PL/SQL \8868\793A\5F0F')
,p_attribute_type=>'PLSQL EXPRESSION'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'nvl(:P1_SAL, 0)',
'</pre>',
unistr('<p>\5728\6B64\7BC4\4F8B\4E2D, \5728<strong>\8981\9001\51FA\7684\9801\9762\9805\76EE</strong>\4E2D\8F38\5165 <code>P1_SAL</code>.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\4F86\8A2D\5B9A\503C\7684 PL/SQL \8868\793A\5F0F.</p>'),
unistr('<p>\60A8\53EF\4EE5\53C3\7167\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE, \4F46\689D\4EF6\70BA\5FC5\9808\5C07\9019\4E9B\9805\76EE\5305\62EC\5728<strong>\8981\9001\51FA\7684\9801\9762\9805\76EE</strong>\4E2D.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(293265419645253258.4418)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('JavaScript \8868\793A\5F0F')
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\7A0B\5F0F\78BC\53EF\5B58\53D6\4E0B\5217\52D5\614B\52D5\4F5C\76F8\95DC\5C6C\6027:</p>'),
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
unistr('    <dd>\89F8\767C\52D5\614B\52D5\4F5C\4E4B\5143\7D20\7684 DOM \7269\4EF6\53C3\7167.</dd>'),
'  <dt><code>this.affectedElements</code></dt>',
unistr('    <dd>\5305\542B\6240\6709\53D7\5F71\97FF\5143\7D20\7684 jQuery \7269\4EF6.</dd>'),
'  <dt><code>this.action</code></dt>',
unistr('    <dd>\5305\542B\8A73\7D30\8CC7\8A0A (\4F8B\5982\52D5\4F5C\540D\7A31\548C\984D\5916\7684\5C6C\6027\503C) \7684\52D5\4F5C\7269\4EF6.</dd>'),
'  <dt><code>this.browserEvent</code></dt>',
unistr('     <dd>\89F8\767C\4E8B\4EF6\4E4B\4E8B\4EF6\7684\4E8B\4EF6\7269\4EF6. \6CE8\610F: \8F09\5165\6642\7B49\540C\65BC ''load''.</dd>'),
'  <dt><code>this.data</code></dt>',
unistr('    <dd>\53EF\5F9E\4E8B\4EF6\8655\7406\7A0B\5F0F\50B3\9001\7684\9078\64C7\6027\984D\5916\8CC7\6599.</dd>'),
'</dl>'))
,p_help_text=>unistr('\8F38\5165\7528\4F86\8A2D\5B9A\503C\7684 JavaScript \8868\793A\5F0F. \6B64\8868\793A\5F0F\53EF\4EE5\7522\751F\55AE\4E00\503C\6216\503C\9663\5217 (\5C07\9805\76EE\8A2D\70BA\652F\63F4\591A\500B\503C\7684\4F4D\7F6E, \4F8B\5982\5F80\8FD4\5207\63DB).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(427662910653013912.4418)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('PL/SQL \51FD\6578\4E3B\9AD4')
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FUNCTION_BODY'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'return getCommission(:P1_SAL, :P1_JOB);',
'</pre>',
unistr('<p>\5728\6B64\7BC4\4F8B\4E2D, \5728<strong>\8981\9001\51FA\7684\9801\9762\9805\76EE</strong>\4E2D\8F38\5165 <code>P1_SAL</code> \8207 <code>P1_JOB</code>.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7528\4F86\8A2D\5B9A\503C\7684 PL/SQL \51FD\6578\4E3B\9AD4.</p>'),
unistr('<p>\60A8\53EF\4EE5\53C3\7167\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE, \4F46\689D\4EF6\70BA\5FC5\9808\5C07\9019\4E9B\9805\76EE\5305\62EC\5728<strong>\8981\9001\51FA\7684\9801\9762\9805\76EE</strong>\4E2D.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262597322287494361.4418)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\8981\9001\51FA\7684\9805\76EE')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>unistr('\8F38\5165\57F7\884C\6B64\52D5\4F5C\6642\8981\9001\51FA\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \82E5\6709\591A\500B\9805\76EE, \8ACB\4F7F\7528\9017\865F\5340\9694\6BCF\500B\9805\76EE\540D\7A31. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7. \5982\679C\5F9E\6E05\55AE\4E2D\9078\64C7, \4E14\540C\6642\9593\5DF2\7D93\6709\8F38\5165\7684\6587\5B57\7684\8A71, \5C07\6703\5728\73FE\6709\6587\5B57\7684\7D50\5C3E\52A0\4E0A\4E00\500B\9017\865F, \5F8C\9762\518D\63A5\8457\5F9E\6E05\55AE\50B3\56DE\7684\9805\76EE\540D\7A31.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(618758229653179194.4418)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\9041\96E2\7279\6B8A\5B57\5143')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>unistr('\6307\5B9A\662F\5426\9041\96E2 HTML \7279\6B8A\5B57\5143. Oracle \5F37\70C8\5EFA\8B70\60A8\5C07\6B64\5C6C\6027\8A2D\70BA<strong>\662F</strong>, \4EE5\907F\514D\767C\751F\8DE8\7DB2\7AD9\547D\4EE4\6A94 (XSS) \653B\64CA.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(399189606786047634.4418)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\6291\5236\8B8A\66F4\4E8B\4EF6')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\662F\5426\6291\5236<strong>\8981\50B3\56DE\7684\9801\9762\9805\76EE</strong>\4E2D\6307\5B9A\4E4B\9805\76EE\7684\8B8A\66F4\4E8B\4EF6. \5982\679C\6291\5236, \5C31\4E0D\6703\518D\5C0D\9019\4E9B\9805\76EE\89F8\767C\4EE5<em>\8B8A\66F4</em>\70BA\57FA\790E\7684\300C\52D5\614B\52D5\4F5C\300D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1295495331704184122.4418)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>75
,p_prompt=>unistr('\50B3\56DE\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIALOG_RETURN_ITEM'
,p_help_text=>unistr('\8F38\5165\7528\4F86\8A2D\5B9A\503C\4E4B\5C0D\8A71\65B9\584A\6240\50B3\56DE\9801\9762\9805\76EE\7684\540D\7A31.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/javascript_code
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258538732294917000.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'JAVASCRIPT_CODE'
,p_display_name=>unistr('\57F7\884C JavaScript \7A0B\5F0F\78BC')
,p_category=>'EXECUTE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','JAVASCRIPT_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\8B93\60A8\80FD\5920\5B9A\7FA9\6216\547C\53EB\53EF\5728\52D5\614B\52D5\4F5C\67B6\69CB\5167\4F7F\7528\7684\81EA\8A02\9805\3001\9801\9762\7279\5B9A JavaScript \7A0B\5F0F\78BC. \82E5\662F\5B9A\7FA9\4E00\500B\9801\9762\7684\7279\5B9A JavaScript \7A0B\5F0F\78BC, \53EF\4EE5\4F7F\7528\9801\9762\5C64\7D1A\5C6C\6027<em>\51FD\6578\548C\5168\57DF\8B8A\6578\5BA3\544A</em>\4F86\9032\884C\5B9A\7FA9. \4E4B\5F8C, \5C31\53EF\4EE5\5F9E\9019\500B\52D5\4F5C\53C3\7167\8A72\8655\5B9A\7FA9\7684\51FD\6578\548C\8B8A\6578.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(258539816972931512.4418)
,p_plugin_id=>wwv_flow_api.id(258538732294917000.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\7A0B\5F0F\78BC')
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\7A0B\5F0F\78BC\53EF\5B58\53D6\4E0B\5217\52D5\614B\52D5\4F5C\76F8\95DC\5C6C\6027:</p>'),
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
unistr('    <dd>\89F8\767C\52D5\614B\52D5\4F5C\4E4B\5143\7D20\7684 DOM \7269\4EF6\53C3\7167.</dd>'),
'  <dt><code>this.affectedElements</code></dt>',
unistr('    <dd>\5305\542B\6240\6709\53D7\5F71\97FF\5143\7D20\7684 jQuery \7269\4EF6.</dd>'),
'  <dt><code>this.action</code></dt>',
unistr('    <dd>\5305\542B\8A73\7D30\8CC7\8A0A (\4F8B\5982\52D5\4F5C\540D\7A31\548C\984D\5916\7684\5C6C\6027\503C) \7684\52D5\4F5C\7269\4EF6.</dd>'),
'  <dt><code>this.browserEvent</code></dt>',
unistr('     <dd>\89F8\767C\4E8B\4EF6\4E4B\4E8B\4EF6\7684\4E8B\4EF6\7269\4EF6. \6CE8\610F: \8F09\5165\6642\7B49\540C\65BC ''load''.</dd>'),
'  <dt><code>this.data</code></dt>',
unistr('    <dd>\53EF\5F9E\4E8B\4EF6\8655\7406\7A0B\5F0F\50B3\9001\7684\9078\64C7\6027\984D\5916\8CC7\6599.</dd>'),
'</dl>'))
,p_help_text=>unistr('\8F38\5165\9801\9762\6216\52D5\614B\52D5\4F5C\7279\5B9A\7684\4EFB\4F55\81EA\8A02 JavaScript.')
);
end;
/
prompt --application/shared_components/plugins/process_type/ig_dml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(260818839554927396.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'IG_DML'
,p_display_name=>unistr('\4E92\52D5\5F0F\65B9\683C - \81EA\52D5\8CC7\6599\5217\8655\7406 (DML)')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','IG_DML'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\63D2\5165\3001\66F4\65B0\6216\522A\9664\4E92\52D5\5F0F\65B9\683C\8CC7\6599\5217\7684\8655\7406\4F5C\696D.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260819106949935652.4418)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\76EE\6A19\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\8981\57F7\884C\54EA\4E00\9805\8CC7\6599\5217\8655\7406\6280\8853, \4EE5\4FBF\5132\5B58\5C0D\4E92\52D5\5F0F\65B9\683C\6240\505A\7684\8CC7\6599\8B8A\66F4.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260819425689937336.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5340\57DF\4F86\6E90')
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D2\5165\3001\66F4\65B0\4EE5\53CA\522A\9664\90FD\4F7F\7528\5340\57DF\4F86\6E90\300CSQL \67E5\8A62\300D.</p>'),
unistr('<p>\6CE8\610F - \8ACB\78BA\5B9A\52D9\5FC5\5C07\4E0D\53EF\63D2\5165\6216\4E0D\53EF\66F4\65B0\8CC7\6599\6B04\7684<strong>\50C5\4F9B\67E5\8A62</strong>\8A2D\70BA<code>\662F</code>, \4EE5\907F\514D\8655\7406\6B64\985E\8CC7\6599\6B04.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260819835191938290.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\8868\683C/\8996\89C0\8868')
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D2\5165\3001\66F4\65B0\4EE5\53CA\522A\9664\90FD\4F7F\7528\4E0D\540C\65BC\5340\57DF\4F86\6E90\300CSQL \67E5\8A62\300D\4E2D\6240\5B9A\7FA9\7684\8868\683C\6216\8996\89C0\8868.'),
unistr('\4F8B\5982, SQL \67E5\8A62\5F9E\8868\683C\7D50\5408\6216\4E0D\53EF\66F4\65B0\7684\6AA2\8996\64F7\53D6\8CC7\6599, \800C\4E14\9700\8981\5C0D\55AE\4E00\57FA\672C\8868\683C\6216\53EF\66F4\65B0\7684\6AA2\8996\57F7\884C DML \8655\7406.</p>'),
unistr('<p>\6CE8\610F - \8ACB\78BA\5B9A\52D9\5FC5\5C07\4E0D\53EF\63D2\5165\6216\4E0D\53EF\66F4\65B0\8CC7\6599\6B04\7684<strong>\50C5\4F9B\67E5\8A62</strong>\8A2D\70BA<code>\662F</code>, \4EE5\907F\514D\8655\7406\6B64\985E\8CC7\6599\6B04.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260820229830940047.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4418)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL \7A0B\5F0F\78BC')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8655\7406\6839\64DA\81EA\8A02 PL/SQL \7A0B\5F0F\78BC\9032\884C. \60A8\53EF\4EE5\5229\7528\6B64\9078\9805\4F86\57F7\884C\4EFB\4F55 PL/SQL \7A0B\5F0F\78BC, \4EE5\64CD\63A7\73FE\6709\8CC7\6599\5EAB\4E2D\7684\6240\6709\8CC7\6599.</p>'),
unistr('<p>\82E5\4F7F\7528\8CC7\6599\5EAB\5957\88DD\7A0B\5F0F (\4F8B\5982\8868\683C API \6216\547C\53EB RESTful Web \670D\52D9), \5C31\5FC5\9808\5229\7528\6B64\9078\9805\4F86\5BE6\884C\5546\696D\908F\8F2F.</p>'),
unistr('<p>\6CE8\610F - \5C07\6703\5C0D\6BCF\500B\5DF2\63D2\5165\3001\66F4\65B0\6216\522A\9664\7684\8CC7\6599\5217\547C\53EB PL/SQL \7A0B\5F0F\78BC.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260820699209949601.4418)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\683C\64C1\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('\9078\53D6\8868\683C\64C1\6709\8005 (\7DB1\8981) \540D\7A31.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260821252819962990.4418)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\8868\683C\540D\7A31')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(260820699209949601.4418)
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('\8F38\5165\6709\5927\5C0F\5BEB\4E4B\5225\7684\8868\683C\6216\8996\89C0\8868\540D\7A31. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261083814084772472.4418)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\8981\63D2\5165/\66F4\65B0/\522A\9664\7684 PL/SQL \7A0B\5F0F\78BC')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\4F9B\7528\65BC\8655\7406\300C\4E92\52D5\5F0F\65B9\683C\300D\4E2D\64CD\63A7\4E4B\6BCF\4E00\5217\8CC7\6599\7684 PL/SQL \7A0B\5F0F\78BC.</p>'),
unistr('<p>\53EF\4F7F\7528\8CC7\6599\6B04\540D\7A31\4F5C\70BA\9023\7D50\8B8A\6578, \4EE5\5B58\53D6\8CC7\6599\6B04\7684\503C. \7CFB\7D71\8B8A\6578 <code>APEX$ROW_STATUS</code> \6703\50B3\56DE\8CC7\6599\5217\7684\72C0\614B, \800C\4E14\53EF\7528\65BC\6AA2\67E5\8CC7\6599\5217\662F\5426\5DF2\5EFA\7ACB\3001\66F4\65B0\6216\522A\9664 (\8ACB\53C3\95B1\4E0B\65B9\7BC4\4F8B, \77AD\89E3\5982\4F55\9032\884C\6AA2\67E5).</p>'),
unistr('<p><em>\6CE8\610F:</em> \4E3B\7D22\5F15\9375\8CC7\6599\6B04\82E5\662F\7531\89F8\767C\7A0B\5F0F\7522\751F\6216\4EE5 PL/SQL \7A0B\5F0F\78BC\7522\751F, \5C31\5FC5\9808\5C07\65B0\503C\6307\5B9A\7D66\4E3B\7D22\5F15\9375\8CC7\6599\6B04\7684\9023\7D50\8B8A\6578, \56E0\70BA\5728\63D2\5165\6216\66F4\65B0\4E4B\5F8C, &PRODUCT_NAME. \6703\4F7F\7528\9019\4E9B\503C\4F86\64F7\53D6\8CC7\6599\5217.</p>'),
unistr('<p>Oracle \5EFA\8B70\60A8\547C\53EB PL/SQL \5957\88DD\7A0B\5F0F\5167\7684\7A0B\5E8F\6216\51FD\6578, \4EE5\5229\65BC\91CD\8907\4F7F\7528\53CA\63D0\9AD8\53EF\7DAD\8B77\6027.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261084825593778341.4418)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\9632\6B62\907A\5931\66F4\65B0')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5728\6709\591A\4F4D\4F7F\7528\8005\66F4\65B0\540C\4E00\7B46\8CC7\6599\5EAB\8A18\9304\6642, \8655\7406\662F\5426\61C9\8A72\78BA\4FDD\66F4\65B0\4E0D\6703\907A\5931.</p> '),
unistr('<p>\7576\5169\4F4D\6216\66F4\591A\4F4D\4F7F\7528\8005\5617\8A66\66F4\65B0\76F8\540C\8CC7\6599\6642\5C31\6703\767C\751F\907A\5931\66F4\65B0, \800C\4E14\6700\5F8C\7684\66F4\65B0\6703\8986\5BEB\7B2C\4E00\4F4D\4F7F\7528\8005\6240\505A\7684\66F4\65B0\4EE5\5132\5B58\8B8A\66F4. \70BA\907F\514D\767C\751F\9019\7A2E\60C5\6CC1, \66F4\65B0\53EF\4EE5\6AA2\67E5\8CC7\6599\5EAB\4E2D\73FE\6709\7684\8CC7\6599\6B04\503C\8207\539F\5148\67E5\8A62\8CC7\6599\5217\6642\6240\64F7\53D6\7684\503C.</p>'),
unistr('<p>\4F8B\5982:'),
'  <ol>',
unistr('    <li>\4F7F\7528\8005 A \67E5\8A62\54E1\5DE5 (EMP) \8A18\9304.</li>'),
unistr('    <li>\4F7F\7528\8005 B \67E5\8A62\76F8\540C\7684\54E1\5DE5\8A18\9304.</li>'),
unistr('    <li>\4F7F\7528\8005 B \66F4\65B0 EMPNO = 7839 \7684\54E1\5DE5\8A73\7D30\8CC7\8A0A, \4E26\5C07\8B8A\66F4\5957\7528 (\78BA\8A8D) \81F3\8CC7\6599\5EAB.</li>'),
unistr('    <li>\4F7F\7528\8005 A \66F4\65B0 EMPNO = 7839 \7684\54E1\5DE5\8A73\7D30\8CC7\8A0A, \4E26\5617\8A66\5C07\8B8A\66F4\5957\7528\81F3\8CC7\6599\5EAB.</li>'),
'  </ol>',
unistr('\5982\679C\4F7F\7528\8005 A \9806\5229\66F4\65B0\76F8\540C\7684\8CC7\6599\5217, \4F7F\7528\8005 B \6240\505A\7684\8B8A\66F4\5C31\6703\907A\5931.'),
unistr('\7576\4F7F\7528\8005 A \5617\8A66\5132\5B58\8A72\54E1\5DE5\8CC7\6599\5217\6642, \8CC7\6599\5EAB\4E2D\7684\8CC7\6599\6703\8207\4F7F\7528\8005 A \539F\5148\67E5\8A62\7684\8CC7\6599\4E0D\540C. \5728\4EE5\4E0A\7684\6B65\9A5F 1 \4E2D, \53EF\4EE5\64F7\53D6\4F7F\7528\8005 A \539F\5148\67E5\8A62\7684\8CC7\6599\6B04\503C. \63A5\8457\5728\4EE5\4E0A\7684\6B65\9A5F 4 \4E2D, \53EF\4EE5\5C07\503C\8207\8CC7\6599\5EAB\4E2D\76EE\524D\7684\503C\505A\6BD4\8F03. \7531\65BC\4F7F\7528\8005 B \5728\6B65\9A5F 3 \66F4\65B0\4E86\8CC7\6599\5EAB\503C, \56E0\6B64\9019\9805\6BD4\8F03\6703\5F15\767C\4F7F\7528\8005 A \7684\932F\8AA4. \9019\6703\8B93\4E00\4F4D\4F7F\7528\8005\7121\6CD5\8986\5BEB\53E6\4E00\4F4D\4F7F\7528\8005\5C0D\76F8\540C\8CC7\6599\5217\6240\505A\7684\8B8A\66F4.</p>'),
unistr('<p>\6CE8\610F - \907A\5931\66F4\65B0\7684\5075\6E2C\65B9\5F0F\53EF\5728\300C\4E92\52D5\5F0F\65B9\683C\300D\5340\57DF\7684\5C6C\6027\4E2D\6307\5B9A, \6839\64DA<strong>\907A\5931\66F4\65B0\985E\578B</strong>\7684\8A2D\5B9A\800C\5B9A.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261085131500782260.4418)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\9396\5B9A\8CC7\6599\5217')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9078\53D6\662F\5426\8981\5728\8655\7406\8CC7\6599\5217\524D\5C07\8981\66F4\65B0\6216\522A\9664\7684\6BCF\500B\8CC7\6599\5217\9396\5B9A\5728\57FA\790E\8868\683C\4E2D.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261085409986783810.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\662F')
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7CFB\7D71\6703\4F7F\7528 SELECT ... FOR UPDATE \5C07\8981\66F4\65B0\6216\522A\9664\7684\8CC7\6599\5217\9396\5B9A, \4EE5\78BA\4FDD\5728\6B64\7570\52D5\78BA\8A8D\524D, \7121\6CD5\5C0D\8CC7\6599\5217\57F7\884C\5176\4ED6\7570\52D5.</p>'),
unistr('<p>\6CE8\610F - \5982\679C\767C\751F\932F\8AA4 (\4F8B\5982\53EF\66F4\65B0\7684\6AA2\8996\4E0D\652F\63F4\9396\5B9A), \5EFA\8B70\60A8\4F7F\7528 PL/SQL \7A0B\5F0F\78BC\4F86\9396\5B9A\9A45\52D5\8868\683C.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261085868401784451.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5426')
,p_return_value=>'N'
,p_help_text=>unistr('\8CC7\6599\5217\4E0D\6703\88AB\9396\5B9A.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261086261920786764.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4418)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL \7A0B\5F0F\78BC')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>unistr('\6B64\7570\52D5\78BA\8A8D\4E4B\5F8C, \624D\6703\4F7F\7528\81EA\8A02 PL/SQL \7A0B\5F0F\78BC\4F86\9396\5B9A\8CC7\6599\5217.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261087562475803605.4418)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\7528\65BC\9396\5B9A\8CC7\6599\5217\7684 PL/SQL \7A0B\5F0F\78BC')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(261085131500782260.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>unistr('\8F38\5165\7528\4F86\9396\5B9A\8981\66F4\65B0\53CA\522A\9664\4E4B\8CC7\6599\5EAB\8868\683C\8CC7\6599\5217\7684 PL/SQL \7A0B\5F0F\78BC.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(352431952250846035.4418)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\63D2\5165\5F8C\50B3\56DE\4E3B\7D22\5F15\9375')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\662F\5426\61C9\5728\8CC7\6599\5217\63D2\5165\8CC7\6599\5EAB\4E2D\5F8C, \5C07\4E3B\7D22\5F15\9375\8CC7\6599\6B04\50B3\56DE\76F8\5C0D\61C9\7684\300C\4E92\52D5\5F0F\65B9\683C\300D\8CC7\6599\5217.'),
unistr('\4E00\822C\800C\8A00, \82E5\4E3B\7D22\5F15\9375\8CC7\6599\6B04\5F9E\8CC7\6599\5EAB\89F8\767C\7A0B\5F0F\6216 Oracle Database 12 <em>c</em> \8B58\5225\8CC7\6599\6B04\586B\5165, \5C31\61C9\8A72\4F7F\7528\6B64\9078\9805.</p>'),
unistr('<p>\6CE8\610F - \82E5\767C\751F\6307\793A\4E0D\5141\8A31\4F7F\7528 RETURNING INTO \5B50\53E5\7684\932F\8AA4, \60A8\5FC5\9808\5C07\6B64\9078\9805\8A2D\70BA\300C\5426\300D, \7136\5F8C\9810\5148\586B\5165\4E3B\7D22\5F15\9375\8CC7\6599\6B04.</p>')))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/add_class
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261340108358474705.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ADD_CLASS'
,p_display_name=>unistr('\65B0\589E\985E\5225')
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ADD_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\65B0\589E\4E00\6216\591A\500B CSS \985E\5225\81F3\53D7\5F71\97FF\7684\5143\7D20.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261340305288502177.4418)
,p_plugin_id=>wwv_flow_api.id(261340108358474705.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\985E\5225')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\65B0\589E CSS \985E\5225 <code>articlenumber</code> \8207 <code>highlight</code> \81F3\53D7\5F71\97FF\5143\7D20\7684 HTML \6A19\8A18:'),
'<pre>articlenumber highlight</pre>'))
,p_help_text=>unistr('\6307\5B9A\8981\5957\7528\81F3\53D7\5F71\97FF\5143\7D20\7684\4E00\6216\591A\500B\985E\5225. \5982\679C\6307\5B9A\591A\500B\985E\5225, \8ACB\4F7F\7528\7A7A\683C\5340\9694\985E\5225\540D\7A31.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/remove_class
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261349722930705968.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REMOVE_CLASS'
,p_display_name=>unistr('\79FB\9664\985E\5225')
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REMOVE_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\79FB\9664\53D7\5F71\97FF\5143\7D20\7684\4E00\6216\591A\500B CSS \985E\5225.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261350305185719779.4418)
,p_plugin_id=>wwv_flow_api.id(261349722930705968.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\985E\5225')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('<p>\6307\5B9A\4E00\6216\591A\500B\8981\81EA\53D7\5F71\97FF\7684\5143\7D20\79FB\9664\7684\985E\5225\540D\7A31. \5982\679C\6307\5B9A\591A\500B\9805\76EE, \8ACB\4F7F\7528\7A7A\683C\5340\9694\985E\5225\540D\7A31. \82E5\8981\79FB\9664\53D7\5F71\97FF\5143\7D20\7684\6240\6709\985E\5225\540D\7A31, \5247\8ACB\7559\767D.</p>')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_css
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261356726281848792.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_CSS'
,p_display_name=>unistr('\8A2D\5B9A\6A23\5F0F')
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_CSS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\66FF\53D7\5F71\97FF\7684\5143\7D20\8A2D\5B9A\4E00\500B\6A23\5F0F (CSS) \7279\6027.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261356901132851044.4418)
,p_plugin_id=>wwv_flow_api.id(261356726281848792.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6A23\5F0F\540D\7A31')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\8981\66FF\53D7\5F71\97FF\5143\7D20\8A2D\5B9A\4E4B\6A23\5F0F (CSS) \7279\6027\7684\540D\7A31.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261357406326852547.4418)
,p_plugin_id=>wwv_flow_api.id(261356726281848792.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\53D7\5F71\97FF\5143\7D20\4E4B\6A23\5F0F\7279\6027\7684\8A2D\5B9A\503C. \82E5\8981\79FB\9664\53D7\5F71\97FF\5143\7D20\7684\6A23\5F0F\7279\6027, \5247\5C07\5176\7559\767D.')
);
end;
/
prompt --application/shared_components/plugins/authentication_type/custom
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(352953211423309033.4418)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'CUSTOM'
,p_display_name=>unistr('\81EA\8A02')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','CUSTOM'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\53EF\8B93\60A8\81EA\884C\5B9A\7FA9\7528\65BC\5224\65B7\4F7F\7528\8005\8A8D\8B49\4E4B\300CPL/SQL \51FD\6578\300D\7684\4E00\7A2E\8A8D\8B49\914D\7F6E.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353179625368369848.4418)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\611F\6E2C\51FD\6578\540D\7A31')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\300CPL/SQL \7A0B\5F0F\78BC\300D\5167, \6307\5B9A\50B3\56DE\5E03\6797\503C\7684 PL/SQL \7A0B\5F0F\78BC -</p>'),
'<pre>',
'function sentry_basic_auth',
'return boolean',
'is',
'    c_auth_header   constant varchar2(4000) := owa_util.get_cgi_env(''AUTHORIZATION'');',
'    l_user_pass     varchar2(4000);',
'    l_separator_pos pls_integer;',
'begin',
'    if apex_application.g_user <> ''nobody'' then',
'        return true;',
'    end if;',
'',
'    if c_auth_header like ''Basic %'' then',
'        l_user_pass := utl_encode.text_decode (',
'                           buf      => substr(c_auth_header, 7),',
'                           encoding => utl_encode.base64 );',
'        l_separator_pos := instr(l_user_pass, '':'');',
'        if l_separator_pos > 0 then',
'            apex_authentication.login (',
'                p_username => substr(l_user_pass, 1, l_separator_pos-1),',
'                p_password => substr(l_user_pass, l_separator_pos+1) );',
'            return true;',
'        end if;',
'    end if;',
'',
'    return false;',
'end sentry_basic_auth;',
'</pre>',
unistr('<p>\6307\5B9A PL/SQL \8CC7\6599\5EAB\51FD\6578 - </p>'),
'<pre>',
'sentry_basic_auth',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165 &PRODUCT_NAME. \5F15\64CE\6536\5230\5C0D\5176\63D0\51FA\4E4B\4EFB\4F55\8981\6C42\7684\958B\982D (\4F8B\5982\5728\986F\793A\6216\8655\7406\6BCF\4E00\9801\4E4B\524D\6216\767C\51FA AJAX \8981\6C42\4E4B\524D) \6240\57F7\884C\4E4B\51FD\6578\7684\540D\7A31. '),
unistr('\6B64\51FD\6578\53EF\4EE5\5B9A\7FA9\5728\8A8D\8B49\7684\300CPL/SQL \7A0B\5F0F\78BC\300D\4E2D\3001\5957\88DD\7A0B\5F0F\5167, \6216\8005\5B9A\7FA9\70BA\9810\5B58\51FD\6578.</p>'),
unistr('<p>\5982\679C\6B64\51FD\6578\50B3\56DE false (\4EE3\8868\4F7F\7528\8005\6216\8A31\672A\767B\5165), \5C31\6703\5C07\968E\6BB5\4F5C\696D\6A19\793A\70BA\7121\6548, \4E26\4E14\5C07\6703\547C\53EB<em>\7121\6548\7684\968E\6BB5\4F5C\696D\7A0B\5E8F</em>.'),
unistr('\4E4B\5F8C, &PRODUCT_NAME. \6703\91CD\65B0\5C0E\5411\81F3\300C\968E\6BB5\4F5C\696D\7121\6548 > \524D\5F80\300D\4E2D\5B9A\7FA9\7684 URL.'),
unistr('\5982\679C\6B64\6B04\4F4D\7684\503C\7A7A\767D,'),
unistr('\5247\6703\547C\53EB\5167\90E8\7684\9810\8A2D\611F\6E2C, \5617\8A66\6BD4\8F03 URL \4E2D\7684\968E\6BB5\4F5C\696D ID \8207\8A8D\8B49\914D\7F6E Cookie (\5982\679C\5931\6557, \5247\4F7F\7528 &PRODUCT_NAME. Builder Cookie) \4E2D\7684\968E\6BB5\4F5C\696D\8CC7\8A0A, \4EE5\5EFA\7ACB\6709\6548\7684\968E\6BB5\4F5C\696D.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551983430308015470.4418)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\7121\6548\7684\968E\6BB5\4F5C\696D\7A0B\5E8F\540D\7A31')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'procedure invalid_session_basic_auth',
'is',
'begin',
'    owa_util.status_line (',
'        nstatus       => 401,',
'        creason       => ''Basic Authentication required'',',
'        bclose_header => false);',
'    htp.p(''WWW-Authenticate: Basic realm="protected realm"'');',
'    apex_application.stop_apex_engine;',
'end invalid_session_basic_auth;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\5075\7167\5230\7121\6548\7684\968E\6BB5\4F5C\696D\6642\6240\547C\53EB\4E4B PL/SQL \7A0B\5E8F\7684\540D\7A31.</p>'),
'',
unistr('<p>\5B83\53EF\4EE5\53C3\7167\8CC7\6599\5EAB\4E2D\4E4B\533F\540D PL/SQL \7A0B\5F0F\78BC\5340\584A\7684\51FD\6578\3001\5957\88DD\7A0B\5F0F\51FD\6578\6216\7368\7ACB\51FD\6578. \4F8B\5982: <code>invalid_session_basic_auth</code></p>'),
'',
unistr('<p>\5982\679C\53C3\7167\8CC7\6599\5EAB PL/SQL \5957\88DD\7A0B\5F0F\6216\7368\7ACB\51FD\6578, \60A8\53EF\4EE5\4F7F\7528 <code>#OWNER#</code> \66FF\4EE3\5B57\4E32\4F86\53C3\7167\76EE\524D\61C9\7528\7A0B\5F0F\7684\5256\6790\7DB1\8981. \4F8B\5982: <code>#OWNER#.invalid_session_basic_auth</code></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353293115026395181.4418)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\8A8D\8B49\51FD\6578\540D\7A31')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\300CPL/SQL \7A0B\5F0F\78BC\300D\6587\5B57\5340\4E2D\8F38\5165\4E0B\5217\7A0B\5F0F\78BC</p>'),
'<pre>',
'function my_authentication (',
'    p_username in varchar2,',
'    p_password in varchar2 )',
'    return boolean',
'is',
'    l_user my_users.user_name%type := upper(p_username);',
'    l_id   my_users.id%type;',
'    l_hash my_users.password_hash%type;',
'begin',
'    begin',
'        select id  , password_hash',
'          into l_id, l_hash',
'          from my_users',
'         where user_name = l_user;',
'    exception when no_data_found then',
'        l_hash := ''-invalid-'';',
'    end;',
'',
'    return l_hash = rawtohex(sys.dbms_crypto.hash (',
'                        sys.utl_raw.cast_to_raw (',
'                            p_password||l_id||l_user ),',
'                        sys.dbms_crypto.hash_sh512 ));',
'end;',
'</pre>',
'',
unistr('<p>\5176\4E2D\7684 <code>my_authentication</code> \662F\300C\8A8D\8B49\51FD\6578\300D.')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5728\767B\5165\9801\9762\4E2D\8F38\5165\4F7F\7528\8005\7684\4F7F\7528\8005\540D\7A31\548C\5BC6\78BC\5F8C, \5C07\7528\4F86\9A57\8B49\5B83\5011\4E4B\51FD\6578\7684\540D\7A31.'),
unistr('\82E5\672A\8F38\5165\4EFB\4F55\9805\76EE, \4EE3\8868\4EFB\4F55\4F7F\7528\8005\540D\7A31/\5BC6\78BC\5747\53EF\6210\529F\767B\5165.'),
unistr('\60A8\53EF\4EE5\5728\8A8D\8B49\7684\300CPL/SQL \7A0B\5F0F\78BC\300D\6587\5B57\5340\4E2D\6216\5957\88DD\7A0B\5F0F\5167\5B9A\7FA9\6B64\51FD\6578, \6216\8005\5C07\5176\5B9A\7FA9\70BA\9810\5B58\51FD\6578.</p>'),
'',
unistr('<p>\6B64\51FD\6578\5FC5\9808\50B3\56DE\5E03\6797\503C\7D66\547C\53EB\5B83\7684\767B\5165\7A0B\5E8F. \5B83\6709 ''p_username'' \548C ''p_password'' \9019\5169\500B\8F38\5165\53C3\6578, \53EF\7528\4F86\5B58\53D6\4E00\822C\4F7F\7528\8005\5728\767B\5165\9801\9762\4E2D\8F38\5165\7684\503C.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353301225415398269.4418)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\767B\51FA\5F8C\7A0B\5E8F\540D\7A31')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\300CPL/SQL \7A0B\5F0F\78BC\300D\6587\5B57\5340\4E2D\8F38\5165\4E0B\5217\7A0B\5F0F\78BC</p>'),
'<pre>',
'procedure my_post_logout',
'is',
'begin',
'    insert into logout_log (',
'        application_id,',
'        session_id,',
'        logout_time,',
'        user_name',
'    ) values (',
'        :APP_ID,',
'        :APP_SESSION,',
'        sysdate,',
'        :APP_USER );',
'end;',
'</pre>',
'',
unistr('<p>\4EE5\53CA <code>my_post_logout</code> \4F5C\70BA\300C\767B\51FA\5F8C\7A0B\5E8F\300D.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E00\822C\4F7F\7528\8005\6309\767B\51FA URL \4E4B\5F8C\6240\547C\53EB\4E4B\7A0B\5E8F\7684\540D\7A31. \6B64\7A0B\5E8F\53EF\7528\65BC\65E5\8A8C\8A18\9304\529F\80FD.'),
unistr('\60A8\53EF\4EE5\5728\8A8D\8B49\7684\300CPL/SQL \7A0B\5F0F\78BC\300D\6587\5B57\5340\4E2D\6216\5957\88DD\7A0B\5F0F\5167\5B9A\7FA9\6B64\7A0B\5E8F, \6216\8005\5C07\5176\5B9A\7FA9\70BA\9810\5B58\51FD\6578.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629094915193552126.4418)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\555F\7528\820A\6709\8A8D\8B49\5C6C\6027')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\82E5\6B64\9078\53D6\6E05\55AE\8A2D\70BA\300C\662F\300D, \5C07\6703\986F\793A\984D\5916\7684\8A8D\8B49\5C6C\6027.'),
unistr('\5B83\5011\4E3B\8981\8207\5F9E &PRODUCT_NAME. 4.0 \6216\66F4\820A\7248\672C\79FB\690D\7684\81EA\8A02\8A8D\8B49\6709\95DC.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629174621211563368.4418)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('SSO \5925\4F34\61C9\7528\7A0B\5F0F\540D\7A31')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\60A8\4F7F\7528 Oracle Application Server Single Sign-On \8A8D\8B49, \4E14\60A8\7684\61C9\7528\7A0B\5F0F\662F\5728 SSO \8A3B\518A\7684\5925\4F34\61C9\7528\7A0B\5F0F, \8ACB\8F38\5165\60A8\5728 SSO \8A3B\518A\5925\4F34\61C9\7528\7A0B\5F0F\6642\6240\4F7F\7528\7684\540D\7A31.'),
'',
unistr('\5982\679C\60A8\4F7F\7528 Application Express \4F5C\70BA\8A3B\518A\7684\5925\4F34\61C9\7528\7A0B\5F0F, \8ACB\5C07\6B64\6B04\4F4D\7559\767D.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629550107668606770.4418)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('LDAP \4E3B\6A5F')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\60A8 LDAP \76EE\9304\4F3A\670D\5668\7684\4E3B\6A5F\540D\7A31.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629554415286608926.4418)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('LDAP \9023\63A5\57E0')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\60A8 LDAP \76EE\9304\4E3B\6A5F\7684\9023\63A5\57E0\865F\78BC.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629644211608617346.4418)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\4F7F\7528 SSL')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\64C7\662F\5426\4F7F\7528 SSL \4F86\9023\7D50\81F3 LDAP \76EE\9304. \5982\679C\9078\64C7\300CSSL \52A0\8A8D\8B49\300D, \5247\5FC5\9808\66FF Application Express \57F7\884C\8655\7406\8A2D\5B9A\4E00\500B\516C\4E8B\5305.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629669815417618470.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4418)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629680822344620420.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4418)
,p_display_sequence=>20
,p_display_value=>unistr('SSL \52A0\8A8D\8B49')
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629685004813624810.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\4E0D\4F7F\7528 SSL')
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629825611870636385.4418)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('LDAP DN \5B57\4E32')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\7CBE\78BA\7684 DN</dt>'),
'  <dd><code>cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com</code></dd>',
unistr('  <dt>\975E\7CBE\78BA\7684 DN (\641C\5C0B\57FA\6E96)</dt>'),
'  <dd><code>dc=yourdomain,dc=com</code></dd>',
'</dl>'))
,p_help_text=>unistr('\8F38\5165\7528\65BC\5EFA\69CB DBMS_LDAP.SIMPLE_BIND_S \4E4B\5B8C\6574\8FA8\5225\540D\7A31 (DN) \5B57\4E32\7684\6A23\5F0F (\82E5\4F7F\7528\7CBE\78BA\7684 DN), \6216\8005\8F38\5165\641C\5C0B\57FA\6E96 (\82E5\4F7F\7528\975E\7CBE\78BA\7684 DN).  \53EF\4F7F\7528 <strong>%LDAP_USER%</strong> \4F5C\70BA\4F7F\7528\8005\540D\7A31\7684\9810\7559\4F4D\7F6E.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629787303213633849.4418)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\4F7F\7528\7CBE\78BA\7684\8FA8\5225\540D\7A31 (DN)')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\9078\64C7\300CLDAP \8FA8\5225\540D\7A31 (DN) \5B57\4E32\300D\662F\5B8C\5168\76F8\7B26\6216\4E0D\5B8C\5168\76F8\7B26. \82E5\70BA\4E0D\5B8C\5168\76F8\7B26,\300CLDAP \8FA8\5225\540D\7A31 (DN)\300D\5C31\662F\641C\5C0B\57FA\6E96, \60A8\5FC5\9808\8981\63D0\4F9B\300C\641C\5C0B\7BE9\9078\300D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(741851526139627010.4418)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\641C\5C0B\7BE9\9078')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629787303213633849.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'cn=%LDAP_USER%',
'</pre>'))
,p_help_text=>unistr('\8F38\5165\672A\4F7F\7528\5B8C\5168\76F8\7B26\8FA8\5225\540D\7A31 (DN) \6642\7684\641C\5C0B\7BE9\9078. \8ACB\4F7F\7528 <code>%LDAP_USER%</code> \4F5C\70BA\4F7F\7528\8005\540D\7A31\7684\9810\7559\4F4D\7F6E.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629863429878641530.4418)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('LDAP \4F7F\7528\8005\540D\7A31\7DE8\8F2F\51FD\6578')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E0B\5217\7A0B\5F0F\78BC\6703\547C\53EB\4E00\500B\5C07 DN \5B57\4E32\4E2D\6240\6709 "." \53D6\4EE3\70BA "_" \7684\51FD\6578:</p>'),
'<pre>',
'return apex_custom_auth.ldap_dnprep;',
'</pre>'))
,p_help_text=>unistr('\60A8\53EF\4EE5\63D0\4F9B\984D\5916\57F7\884C\7684\7A0B\5F0F\78BC, \4EE5\5C07\4F7F\7528\8005\540D\7A31\8F49\63DB\6210\5B8C\5168\7B26\5408 LDAP \76EE\9304\9805\76EE\6216 LDAP \4F7F\7528\8005\540D\7A31\7684\683C\5F0F.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38291032596231774.4418)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\4F7F\7528\8005\540D\7A31\9041\96E2')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\53D6\4EE3 LDAP \8FA8\5225\540D\7A31\548C\641C\5C0B\5B57\4E32\4E2D\7684 <code><strong>%LDAP_USER%</strong></code> \4E4B\524D,'),
unistr('&PRODUCT_NAME. \53EF\4EE5\81EA\52D5\9041\96E2\4F7F\7528\8005\540D\7A31\4E2D\7684\7279\6B8A\5B57\5143.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38291304329233033.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\6A19\6E96')
,p_return_value=>'STD'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6839\64DA RFC 4514 (\91DD\5C0D\8FA8\5225\540D\7A31) \8207 RFC 4515 (\91DD\5C0D\641C\5C0B\5B57\4E32) \9041\96E2\7279\6B8A\5B57\5143.'),
unistr('\6B64\5916, \4E26\9041\96E2 Unicode \5B57\5143.'),
unistr('\9019\662F\6700\5B89\5168\7684\8A2D\5B9A\503C, \4F46\662F\53EF\80FD\6703\5C0E\81F4\90E8\5206 LDAP \4F3A\670D\5668\767C\751F\554F\984C.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38291708139234196.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\50C5\7279\6B8A\5B57\5143')
,p_return_value=>'ONLY'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6839\64DA RFC 4514 (\91DD\5C0D\8FA8\5225\540D\7A31) \8207 RFC 4515 (\91DD\5C0D\641C\5C0B\5B57\4E32) \9041\96E2\7279\6B8A\5B57\5143.'),
unistr('\4F46\4E0D\9041\96E2 Unicode \5B57\5143.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38292111602235122.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\7121\9041\96E2')
,p_return_value=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E0D\9041\96E2\4EFB\4F55\5B57\5143. \9664\975E\4F7F\7528\5DF2\9041\96E2\4F7F\7528\8005\540D\7A31\7684'),
unistr('<strong>\4F7F\7528\8005\540D\7A31\7DE8\8F2F\51FD\6578</strong> (\4F8B\5982, \4F7F\7528 <code>apex_escape.ldap_dn</code> \6216 <code>apex_escape.ldap_search_filter</code>),'),
unistr('\5426\5247\6B64\8A2D\5B9A\503C\53EF\80FD\4E0D\5B89\5168.')))
);
end;
/
prompt --application/shared_components/plugins/process_type/plsql
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(360896225809711408.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PLSQL'
,p_display_name=>unistr('\57F7\884C\7A0B\5F0F\78BC')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\53EF\57F7\884C PL/SQL \7A0B\5F0F\78BC\7684\8655\7406\4F5C\696D.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/process_type/close_window
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361240401142661438.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'CLOSE_WINDOW'
,p_display_name=>unistr('\95DC\9589\5C0D\8A71\65B9\584A')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','CLOSE_WINDOW'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\53EF\95DC\9589\76EE\524D\7684\5F37\5236\56DE\61C9\6216\975E\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A\9801\9762\7684\8655\7406\4F5C\696D.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(369154203766535800.4418)
,p_plugin_id=>wwv_flow_api.id(361240401142661438.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8981\50B3\56DE\7684\9805\76EE ')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\5C0D\8A71\65B9\584A\61C9\8A72\50B3\56DE\4E4B\4E00\6216\591A\500B\9801\9762\9805\76EE\7684\540D\7A31. \82E5\6709\591A\500B\9805\76EE, \8ACB\4F7F\7528\9017\865F\5340\9694\6BCF\500B\9805\76EE\540D\7A31.</p>'),
unistr('<p>\82E5\8981\5B58\53D6\50B3\56DE\7684\9805\76EE\503C, \8ACB\5728\958B\555F\5C0D\8A71\65B9\584A\7684\5143\7D20\4E0A\5B9A\7FA9\8981\5C0D<strong>\5C0D\8A71\65B9\584A\5DF2\95DC\9589</strong>\4E8B\4EF6\89F8\767C\7684\300C\52D5\614B\52D5\4F5C\300D, \800C\52D5\4F5C\70BA<strong>\5C0D\8A71\65B9\584A\50B3\56DE\9805\76EE</strong>\7684<strong>\8A2D\5B9A\503C</strong>\53CA<em>\8A2D\5B9A\985E\578B</em>.</p>')))
);
end;
/
prompt --application/shared_components/plugins/process_type/session_state
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361248208719417603.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SESSION_STATE'
,p_display_name=>unistr('\6E05\9664\968E\6BB5\4F5C\696D\72C0\614B')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SESSION_STATE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\53EF\6E05\9664 &PRODUCT_NAME. \5167\5132\5B58\4E4B\968E\6BB5\4F5C\696D\72C0\614B\7684\8655\7406\4F5C\696D.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361248525085440449.4418)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CLEAR_CACHE_CURRENT_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\8981\6E05\9664\7684\968E\6BB5\4F5C\696D\72C0\614B\985E\578B.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361259116722915252.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4418)
,p_display_sequence=>1
,p_display_value=>unistr('\6E05\9664\76EE\524D\9801\9762\4E2D\7684\6240\6709\9805\76EE')
,p_return_value=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361250412576446197.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4418)
,p_display_sequence=>3
,p_display_value=>unistr('\6E05\9664\9801\9762\4E2D\7684\6240\6709\9805\76EE')
,p_return_value=>'CLEAR_CACHE_FOR_PAGES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361250015380444942.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4418)
,p_display_sequence=>5
,p_display_value=>unistr('\6E05\9664\9805\76EE')
,p_return_value=>'CLEAR_CACHE_FOR_ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361249617968443751.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4418)
,p_display_sequence=>7
,p_display_value=>unistr('\6E05\9664\76EE\524D\7684\968E\6BB5\4F5C\696D')
,p_return_value=>'RESET_SESSION_STATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361249219909442830.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4418)
,p_display_sequence=>9
,p_display_value=>unistr('\6E05\9664\76EE\524D\7684\61C9\7528\7A0B\5F0F')
,p_return_value=>'CLEAR_CACHE_CURRENT_FLOW'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361248822065441760.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\6E05\9664\61C9\7528\7A0B\5F0F')
,p_return_value=>'CLEAR_CACHE_FOR_FLOWS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361253232596482537.4418)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\61C9\7528\7A0B\5F0F')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_FLOWS'
,p_help_text=>unistr('\8F38\5165\61C9\7528\7A0B\5F0F ID \6E05\55AE (\4F7F\7528\9017\865F\5340\9694), \4F8B\5982 <code>100,101,105</code>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361254917715489399.4418)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\9805\76EE')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_ITEMS'
,p_help_text=>unistr('\9078\53D6\8981\81EA\968E\6BB5\4F5C\696D\72C0\614B\6E05\9664\7684\9801\9762\9805\76EE, \4F8B\5982 <code>P1_EMPNO,P1_ENAME</code>. \82E5\6709\591A\500B\9805\76EE, \8ACB\4F7F\7528\9017\865F\5340\9694\6BCF\500B\9805\76EE\540D\7A31. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361255209304493322.4418)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\9801\9762')
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_PAGES'
,p_help_text=>unistr('\8F38\5165\9801\78BC\6E05\55AE (\4F7F\7528\9017\865F\5340\9694), \4F8B\5982 <code>1,2,5</code>.')
);
end;
/
prompt --application/shared_components/plugins/process_type/reset_pagination
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361603521916198029.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'RESET_PAGINATION'
,p_display_name=>unistr('\91CD\8A2D\5206\9801')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','RESET_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\53EF\91CD\8A2D\76EE\524D\9801\9762\4E2D\4E4B\5831\8868\5206\9801\7684\8655\7406\4F5C\696D.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361603814800201390.4418)
,p_plugin_id=>wwv_flow_api.id(361603521916198029.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\76EE\6A19')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THIS_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\662F\61C9\8A72\8981\91CD\8A2D\6240\6709\9801\9762\3001\90E8\5206\9801\9762\6216\76EE\524D\9801\9762\7684\5206\9801.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604111996202714.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\6B64\9801\9762')
,p_return_value=>'THIS_PAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604905742205597.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\9801\9762')
,p_return_value=>'PAGES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604508330204363.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\6240\6709\9801\9762')
,p_return_value=>'ALL_PAGES'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361606225139211720.4418)
,p_plugin_id=>wwv_flow_api.id(361603521916198029.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\9801\9762')
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361603814800201390.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGES'
,p_help_text=>unistr('\8F38\5165\9801\78BC\6E05\55AE (\4F7F\7528\9017\865F\5340\9694).')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_add_rows
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361705302264974293.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_ADD_ROWS'
,p_display_name=>unistr('\5217\8868\5316\8868\55AE - \65B0\589E\8CC7\6599\5217')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_ADD_ROWS'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\53EF\65B0\589E\8CC7\6599\5217\81F3\300C\5217\8868\5316\8868\55AE\300D\5340\57DF\4E2D\7684\8655\7406\4F5C\696D.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361705527915977613.4418)
,p_plugin_id=>wwv_flow_api.id(361705302264974293.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8CC7\6599\5217\6578\76EE')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_help_text=>unistr('\8ACB\8F38\5165\8CC7\6599\5217\6578.')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_update
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361709604296657121.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_UPDATE'
,p_display_name=>unistr('\5217\8868\5316\8868\55AE - \66F4\65B0\591A\91CD\8CC7\6599\5217')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_UPDATE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\53EF\66F4\65B0\300C\5217\8868\5316\8868\55AE\300D\5340\57DF\4E2D\4E4B\591A\500B\8CC7\6599\5217\7684\8655\7406\4F5C\696D. \6B64\8655\7406\4F5C\696D\4E5F\6703\63D2\5165\5340\57DF\4E2D\65B0\589E\7684\8A18\9304.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361709824771662765.4418)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8868\683C\64C1\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\9078\53D6\8868\683C\64C1\6709\8005 (\7DB1\8981) \540D\7A31.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710119164665443.4418)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\683C\540D\7A31')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361709824771662765.4418)
,p_help_text=>unistr('\8F38\5165\6709\5927\5C0F\5BEB\4E4B\5225\7684\8868\683C\6216\8996\89C0\8868\540D\7A31. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710408812670214.4418)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361710119164665443.4418)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\5167\542B\4E3B\7D22\5F15\9375\503C\7684\8CC7\6599\6B04. \5982\679C\8868\683C\6709\591A\500B\5169\90E8\5206\4E3B\7D22\5F15\9375, \8ACB\9078\53D6 <strong>ROWID</strong>.</p>'),
unistr('<p>\4E3B\7D22\5F15\9375\4E3B\8981\7528\4F86\8B58\5225\5217\8868\5316\8868\55AE\4E2D\8981\66F4\65B0\4E14\7D55\5C0D\4E0D\80FD\7DE8\8F2F\7684\8CC7\6599\5217. \65B0\8CC7\6599\5217\7684\4E3B\7D22\5F15\9375\503C\5FC5\9808\662F\7A7A\767D\7684.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710732738674350.4418)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6B21\8981\7D22\5F15\9375\8CC7\6599\6B04')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361710119164665443.4418)
,p_help_text=>unistr('\9078\53D6\5167\542B\6B21\8981\4E3B\7D22\5F15\9375\503C\7684\8CC7\6599\6B04. \5982\679C\60A8\7684\4E3B\7D22\5F15\9375\7531\5169\500B\6B04\4F4D\7D44\6210, \624D\61C9\8A72\586B\5165\6B64\5C6C\6027.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361711421080694858.4418)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\7A0B\5F0F\5BE6\969B\57F7\884C Where \5B50\53E5')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4F7F\7528\4E0B\5217\7A0B\5F0F\78BC\9650\5236\90E8\9580:'),
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('\8F38\5165\8981\9644\52A0\81F3\6240\6709\7522\751F\4E4B INSERT \548C UPDATE \6558\8FF0\53E5\7684 SQL WHERE \5B50\53E5. \60A8\53EF\4EE5\4F7F\7528\6B64\5C6C\6027\4F86\9650\5236\81EA\52D5\7522\751F\4E4B SQL \547C\53EB\5167\4F7F\7528\7684\8A18\9304.')
);
end;
/
prompt --application/shared_components/plugins/process_type/form_fetch
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361799714569626543.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_FETCH'
,p_display_name=>unistr('\81EA\52D5\8CC7\6599\5217\64F7\53D6')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_FETCH'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\53EF\5F9E\55AE\4E00\8CC7\6599\5EAB\8868\683C\6216\8996\89C0\8868\64F7\53D6\8A18\9304\7684\8655\7406\4F5C\696D. \6B64\8655\7406\4F5C\696D\4E3B\8981\7528\4F86\586B\5165<strong>\8CC7\6599\5EAB\8CC7\6599\6B04</strong>\985E\578B\4F86\6E90\7684\8868\55AE\9805\76EE.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800032025633659.4418)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8868\683C\64C1\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\9078\53D6\8868\683C\64C1\6709\8005 (\7DB1\8981) \540D\7A31.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800327927635543.4418)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\683C\540D\7A31')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800032025633659.4418)
,p_help_text=>unistr('\8F38\5165\6709\5927\5C0F\5BEB\4E4B\5225\7684\8868\683C\6216\8996\89C0\8868\540D\7A31. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800622105638213.4418)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\4E3B\7D22\5F15\9375\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559\4E3B\7D22\5F15\9375\8CC7\6599\6B04\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
,p_attribute_comment=>'$$$ DJP - Pop-up LOV allows selection of Custom Page, Global Page, Application Items as well - Shouldn''t it only be Page Items?'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800918654639837.4418)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>25
,p_prompt=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4418)
,p_help_text=>unistr('\9078\53D6\5167\542B\4E3B\7D22\5F15\9375\503C\7684\8CC7\6599\6B04. \5982\679C\8868\683C\6709\591A\500B\5169\90E8\5206\4E3B\7D22\5F15\9375, \8ACB\9078\53D6 <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361801213910642088.4418)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\6B21\8981\7D22\5F15\9375\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361801505499645968.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\8F38\5165\4FDD\7559\6B21\8981\4E3B\7D22\5F15\9375\8CC7\6599\6B04\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361801505499645968.4418)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>40
,p_prompt=>unistr('\6B21\8981\7D22\5F15\9375\8CC7\6599\6B04')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4418)
,p_depending_on_attribute_id=>wwv_flow_api.id(361800918654639837.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('\9078\53D6\5167\542B\6B21\8981\4E3B\7D22\5F15\9375\503C\7684\8CC7\6599\6B04. \5982\679C\60A8\7684\4E3B\7D22\5F15\9375\7531\5169\500B\6B04\4F4D\7D44\6210, \624D\61C9\8A72\586B\5165\6B64\5C6C\6027.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361805328759939092.4418)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\8CC7\6599\5217\7248\672C\8CC7\6599\6B04')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4418)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\8B58\5225\8CC7\6599\5217\7248\672C\7684\8CC7\6599\6B04, \800C\6B64\8CC7\6599\6B04\4E0D\9700\8981\5728\9801\9762\4E2D\986F\793A. \82E5\8981\4F7F\7528\5167\5EFA\7684\7E3D\548C\6AA2\9A57, \8ACB\5C07\6B64\5C6C\6027\7559\767D.</p>'),
unistr('<p>\6295\6A5F\5F0F\9396\5B9A\529F\80FD\4F7F\7528\907A\5931\7684\66F4\65B0\5075\6E2C\4F86\78BA\4FDD\53EF\4E26\884C\5B58\53D6\8CC7\6599\4E4B\61C9\7528\7A0B\5F0F\4E2D\7684\8CC7\6599\5B8C\6574\6027. &PRODUCT_NAME. \53EF\4EE5\4F7F\7528\5167\5EFA\7684\7E3D\548C\6AA2\9A57\4F86\57F7\884C\907A\5931\7684\66F4\65B0\5075\6E2C\8207\5224\65B7\8CC7\6599\5217\7684\7248\672C. \7E3D\548C\6AA2\9A57\662F\4E00\7A2E\7279\5B9A\8868\683C\8CC7\6599\5217\4E4B\6240\6709\8CC7\6599\6B04\503C\7684\96DC\6E4A\51FD\6578. \67E5\8A62\8CC7\6599\5EAB\4E2D\7684\8A18\9304\6642\6703\64F7\53D6\6B64\96DC\6E4A\51FD\6578, \7136\5F8C\8207\8CC7\6599\5EAB\4E2D<em>\81EA\52D5\8CC7\6599\5217\8655\7406</em>\4E4B\4E00\90E8\5206\7684\76EE\524D\8A18\9304\7684\96DC\6E4A\505A\6BD4\8F03. \5982\679C\5169\500B\503C\76F8\540C\5C31\7E7C\7E8C\66F4\65B0, \5426\5247\5C31\7531\300C\81EA\52D5\8CC7\6599\5217\8655\7406\300D\767C\51FA\932F\8AA4.</p>'),
unistr('<p>\60A8\53EF\4EE5\5229\7528\6B64\5C6C\6027\6307\5B9A\4FDD\7559\8CC7\6599\5217\7248\672C\7684\55AE\4E00\8CC7\6599\6B04, \4F5C\70BA\4F7F\7528\5167\5EFA\7E3D\548C\6AA2\9A57\8655\7406\7684\66FF\4EE3\65B9\6CD5. \6BCF\6B21\8CC7\6599\5EAB\4E2D\7684\8A18\9304\66F4\65B0\6642\5C31\5FC5\9808\66F4\65B0\6B64\8CC7\6599\6B04. Oracle \5EFA\8B70\60A8\5C0D\8868\683C\5BE6\884C\300C\66F4\65B0\4E4B\524D\300D\8CC7\6599\5EAB\89F8\767C\7A0B\5F0F\4EE5\905E\589E\6216\66F4\65B0\8CC7\6599\5217\7248\672C\8CC7\6599\6B04. \5DF2\5047\8A2D NUMBER \8CC7\6599\6B04\5305\542B\8CC7\6599\5217\7684\5E8F\865F. \4E0D\904E, \60A8\4E5F\53EF\4EE5\4F7F\7528 DATE \548C TIMESTAMP \8CC7\6599\6B04. \4F7F\7528\55AE\4E00\8CC7\6599\6B04\7684\512A\9EDE\662F &PRODUCT_NAME. \5F15\64CE\4E0D\9700\8981\57F7\884C\5B8C\6574\8CC7\6599\5217\7684\96DC\6E4A\904B\7B97, \5B83\53EA\8981\6BD4\8F03\55AE\4E00\8CC7\6599\6B04\503C\5373\53EF.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361804814168854679.4418)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\7A0B\5F0F\5BE6\969B\57F7\884C Where \5B50\53E5')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4F7F\7528\4E0B\5217\7A0B\5F0F\78BC\9650\5236\90E8\9580:'),
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('\8F38\5165\8981\9644\52A0\81F3\7522\751F\4E4B SELECT \6558\8FF0\53E5\7684 SQL WHERE \5B50\53E5. \60A8\53EF\4EE5\4F7F\7528\6B64\5C6C\6027\4F86\9650\5236\81EA\52D5\7522\751F\4E4B SQL \547C\53EB\5167\4F7F\7528\7684\8A18\9304.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361802100261724338.4418)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\64F7\53D6\6A21\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'D'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\6B64\9078\9805\7D14\7CB9\70BA\4E86\56DE\6EAF\76F8\5BB9\6027\800C\63D0\4F9B.'),
unistr('\65B0\7684\61C9\7528\7A0B\5F0F\8ACB\4E00\5F8B\5C07\6B64\8A2D\5B9A\7559\767D.'),
unistr('\300C\8A2D\5B9A\986F\793A\6642\7684\8A18\61B6\9AD4\5FEB\53D6\300D\9078\9805\5DF2\88AB\53D6\4EE3, \4F7F\7528\6B64\7248\672C\7684 &PRODUCT_NAME. \7522\751F\7684\8655\7406\4F5C\696D\4E2D\5DF2\4E0D\518D\4F7F\7528.'),
'</p>',
'<p>',
unistr('\7576\300C\81EA\52D5\8CC7\6599\5217\64F7\53D6\300D\8655\7406\4F5C\696D\9078\53D6\67D0\500B\8CC7\6599\5217\5F8C, \5C31\6703\5C07\76F8\5C0D\61C9\7684\9801\9762\9805\76EE\8A2D\6210\64F7\53D6\7684\8CC7\6599\6B04\503C.\300CDML \64F7\53D6\6A21\5F0F\300D\8A2D\5B9A\6703\6C7A\5B9A\767C\751F\7684\6642\6A5F. \9810\8A2D\6A21\5F0F\6703\5728\64F7\53D6\8CC7\6599\5217\5F8C, \7ACB\5373\66F4\65B0\5167\5EFA\8A18\61B6\9AD4\968E\6BB5\4F5C\696D\72C0\614B.\300C\8A2D\5B9A\986F\793A\6642\7684\8A18\61B6\9AD4\5FEB\53D6\300D\6A21\5F0F\53EA\6703\5728\9805\76EE\5448\73FE\5F8C\624D\66F4\65B0\6B64\968E\6BB5\4F5C\696D\72C0\614B. \5982\679C\60A8\9700\8981\4F7F\7528\9023\7D50\8B8A\6578\6216 <code>v(''ITEM_NAME'')</code> \8A9E\6CD5, \5728\8CC7\6599\5217\64F7\53D6\548C\9805\76EE\5448\73FE\4E4B\9593\53C3\7167\64F7\53D6\7684\9805\76EE\503C, \60A8\5FC5\9808\4F7F\7528\9810\8A2D\7684\64F7\53D6\6A21\5F0F. \5EFA\7ACB\65B0\7684\300C\81EA\52D5\8CC7\6599\5217\64F7\53D6\300D\8655\7406\4F5C\696D\6642, \5176\64F7\53D6\6A21\5F0F\5373\8A2D\70BA\6B64\9810\8A2D\6A21\5F0F. \9664')
||unistr('\975E\60A8\9801\9762\7684\908F\8F2F\6839\64DA\300C\986F\793A\6642\300D\884C\70BA\800C\5B9A, \5426\5247\6211\5011\5EFA\8B70\60A8\5C07\6B64\8655\7406\4F5C\696D\66F4\65B0\6210\4F7F\7528\9810\8A2D\884C\70BA, \4EE5\4FBF\5728\5448\73FE\9801\9762\6642, \70BA\53C3\7167\64F7\53D6\7684\8CC7\6599\6B04\503C\63D0\4F9B\6700\5927\7684\5F48\6027.'),
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361803025912727611.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(361802100261724338.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\8A2D\5B9A\986F\793A\6642\7684\8A18\61B6\9AD4\5FEB\53D6 [\5DF2\88AB\53D6\4EE3]')
,p_return_value=>'D'
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361898027238424612.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE'
,p_display_name=>unistr('Web \670D\52D9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\53EF\4F7F\7528\6307\5B9A\4E4B Web \670D\52D9\7684\8655\7406\4F5C\696D.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361898312142431520.4418)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Web \670D\52D9\4F5C\696D')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_translatable=>false
,p_lov_type=>'COMPONENT'
,p_lov_component_type_id=>3541
,p_help_text=>unistr('\9078\53D6\4E00\9805 Web \670D\52D9\4F5C\696D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(703289302749886160.4418)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\7D50\679C\5132\5B58\4F4D\7F6E')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(703289611172888366.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(703289302749886160.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\9805\76EE')
,p_return_value=>'ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(703290033944889185.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(703289302749886160.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\96C6\5408')
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(703290641370900883.4418)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\96C6\5408\540D\7A31')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(703289302749886160.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_pagination
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(362034004386015380.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PAGINATION'
,p_display_name=>unistr('\8868\55AE\5206\9801')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\53EF\5F9E\8CC7\6599\5EAB\8868\683C\6216\8996\89C0\8868\64F7\53D6\4E0A\4E00\7B46\6216\4E0B\4E00\7B46\8A18\9304\7684\8655\7406\4F5C\696D. \6B64\8655\7406\4F5C\696D\53EF\7528\65BC\63D0\4F9B\300C\8868\55AE\300D\9801\9762\5206\9801, \5982\6B64\4E00\822C\4F7F\7528\8005\7121\9808\700F\89BD\56DE\5831\8868\5373\53EF\64F7\53D6\4E0A\4E00\7B46\6216\4E0B\4E00\7B46\8A18\9304.</p>'),
unistr('<p><em>\6CE8\610F: \5982\679C\8868\55AE\5141\8A31\66F4\65B0\8CC7\6599, \8ACB\52D9\5FC5\5728\57F7\884C\6B64\5206\9801\8655\7406\524D\5148\57F7\884C\9069\7576\7684\8868\55AE\8655\7406. \5426\5247, \7576\4E00\822C\4F7F\7528\8005\700F\89BD\81F3\53E6\4E00\7B46\8A18\9304\6642, \4ED6\5011\6240\505A\7684\5168\90E8\66F4\65B0\90FD\5C07\907A\5931.</em></p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362034324862021077.4418)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8868\683C\64C1\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\9078\53D6\8868\683C\64C1\6709\8005 (\7DB1\8981) \540D\7A31.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362034618176024149.4418)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\683C\540D\7A31')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034324862021077.4418)
,p_help_text=>unistr('\8F38\5165\6709\5927\5C0F\5BEB\4E4B\5225\7684\8868\683C\6216\8996\89C0\8868\540D\7A31. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035122261037451.4418)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('\4E3B\7D22\5F15\9375\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559\4E3B\7D22\5F15\9375\8CC7\6599\6B04\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035415360040649.4418)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_default_value=>'ROWID'
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4418)
,p_help_text=>unistr('\9078\53D6\5167\542B\4E3B\7D22\5F15\9375\503C\7684\8CC7\6599\6B04. \5982\679C\8868\683C\6709\591A\500B\5169\90E8\5206\4E3B\7D22\5F15\9375, \8ACB\9078\53D6 <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035708675043722.4418)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('\6B21\8981\7D22\5F15\9375\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\8F38\5165\4FDD\7559\6B21\8981\4E3B\7D22\5F15\9375\8CC7\6599\6B04\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362036002636046567.4418)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('\6B21\8981\7D22\5F15\9375\8CC7\6599\6B04')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4418)
,p_depending_on_attribute_id=>wwv_flow_api.id(362035415360040649.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('\9078\53D6\5167\542B\6B21\8981\4E3B\7D22\5F15\9375\503C\7684\8CC7\6599\6B04. \5982\679C\60A8\7684\4E3B\7D22\5F15\9375\7531\5169\500B\6B04\4F4D\7D44\6210, \624D\61C9\8A72\586B\5165\6B64\5C6C\6027.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362067915033505841.4418)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\5C0E\89BD\9806\5E8F\8CC7\6599\6B04')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4418)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\5167\542B\5C0E\89BD\9806\5E8F\503C\7684\8CC7\6599\6B04.</p>'),
unistr('<p>\6B64\8CC7\6599\6B04\4E3B\8981\7528\4F86\6C7A\5B9A\4E0A\4E00\500B\548C\4E0B\4E00\500B\8CC7\6599\5217. \56E0\6B64, \50CF <code>DISPLAY_SEQ</code> \8CC7\6599\6B04\5C31\662F\9069\5408\4F7F\7528\7684\8CC7\6599\6B04. \5F9E\9806\5E8F\6216\6839\64DA Oracle Database 12<em>c</em> \8B58\5225\8CC7\6599\6B04\586B\5165\6642, \82E5\8981\4F9D\7167\8A18\9304\7684\5EFA\7ACB\9806\5E8F\6392\5217\8A18\9304, \60A8\53EF\4EE5\4F7F\7528 <code>CREATED</code> \6216 <code>ID</code> \8CC7\6599\6B04. \4E0D\904E, \60A8\4E5F\53EF\4EE5\6839\64DA\4EFB\5169\500B\8CC7\6599\6B04\6392\5217\8A18\9304, \4F8B\5982 <code>JOB</code> \548C <code>DEPTNO</code></p')
||'>',
unistr('<p><em>\6CE8\610F: \5C0E\89BD\9806\5E8F\8CC7\6599\6B04\5FC5\9808\8207\7528\4F86\6392\5E8F\5831\8868\4F9B\4E00\822C\4F7F\7528\8005\5F9E\5176\79FB\52D5\81F3\6B64\8868\55AE\7684\9810\8A2D\8CC7\6599\6B04\76F8\540C. \6216\8005, \60A8\5FC5\9808\78BA\4FDD\4E00\822C\4F7F\7528\8005\77AD\89E3\6C7A\5B9A\4E0A\4E00\500B\548C\4E0B\4E00\500B\8CC7\6599\5217\7684\65B9\5F0F, \4F8B\5982\900F\904E\4F7F\7528\6309\9215\6A19\7C64\6216\8AAA\660E\5167\5BB9.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362068209426508489.4418)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\6B21\8981\5C0E\89BD\9806\5E8F\8CC7\6599\6B04')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4418)
,p_help_text=>unistr('\9078\53D6\5167\542B\6B21\8981\5C0E\89BD\9806\5E8F\503C\7684\8CC7\6599\6B04. \60A8\7684\5C0E\89BD\7D22\5F15\9375\7531\5169\500B\8CC7\6599\6B04\7D44\6210\6642, \624D\9700\8981\586B\5165\6B64\5C6C\6027.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362068730117514082.4418)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\4E0B\4E00\500B\4E3B\7D22\5F15\9375\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559<em>\4E0B\4E00\7B46</em>\8A18\9304\4E4B\4E3B\7D22\5F15\9375\8CC7\6599\6B04\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069024510516623.4418)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\4E0A\4E00\500B\4E3B\7D22\5F15\9375\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559<em>\4E0A\4E00\7B46</em>\8A18\9304\4E4B\4E3B\7D22\5F15\9375\8CC7\6599\6B04\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069318687519376.4418)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\4E0B\4E00\500B\6B21\8981\7D22\5F15\9375\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\8F38\5165\4FDD\7559<em>\4E0B\4E00\7B46</em>\8A18\9304\4E4B\6B21\8981\4E3B\7D22\5F15\9375\8CC7\6599\6B04\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069614158521442.4418)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\4E0A\4E00\500B\6B21\8981\7D22\5F15\9375\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\8F38\5165\4FDD\7559<em>\4E0A\4E00\7B46</em>\8A18\9304\4E4B\6B21\8981\4E3B\7D22\5F15\9375\8CC7\6599\6B04\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362070100572527702.4418)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('\76EE\524D\8CC7\6599\5217\8A08\6578\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\4FDD\7559\8A18\9304\8A08\6578\7E3D\8A08\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.</p>'),
unistr('<p>\5982\679C\60A8\7684\7D50\679C\5305\542B 10,000 \500B\4EE5\4E0A\7684\8CC7\6599\5217, \5B9A\7FA9\6B64\9805\76EE\5C07\6703\964D\4F4E\6548\80FD.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362070418675534553.4418)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\7A0B\5F0F\5BE6\969B\57F7\884C Where \5B50\53E5')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'deptno = :P1_DEPTNO',
'</pre>'))
,p_help_text=>unistr('\8F38\5165\9650\5236\67E5\8A62\50B3\56DE\4E4B\8A18\9304\7684 SQL \6558\8FF0\53E5.')
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service_legacy
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(362310022409142749.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE_LEGACY'
,p_display_name=>unistr('\820A\6709 Web \670D\52D9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\53EF\4F7F\7528\6307\5B9A\4E4B Web \670D\52D9\7684\8655\7406\4F5C\696D. Oracle \5EFA\8B70\60A8\5C07\6B64\8655\7406\4F5C\696D\66F4\65B0\70BA <strong>Web \670D\52D9</strong>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362310307960149400.4418)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Web \670D\52D9\53C3\7167')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165 Web \670D\52D9\53C3\7167\865F\78BC.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(704862682583352671.4418)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\7D50\679C\5132\5B58\4F4D\7F6E')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(704862979987353733.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(704862682583352671.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\9805\76EE')
,p_return_value=>'ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(704863378280354870.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(704862682583352671.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\96C6\5408')
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(704864081757360262.4418)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\96C6\5408\540D\7A31')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(704862682583352671.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/textarea
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(376364131288521442.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXTAREA'
,p_display_name=>unistr('\6587\5B57\5340')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXTAREA'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A\591A\91CD\8CC7\6599\5217\6587\5B57\5340.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376904739508510313.4418)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\53EF\8ABF\6574\5927\5C0F')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\662F\5426\555F\7528\4F7F\7528\6ED1\9F20\8ABF\6574\6587\5B57\5340\5927\5C0F.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376905227172516182.4418)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\81EA\52D5\8ABF\6574\9AD8\5EA6')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\662F\5426\6839\64DA\986F\793A\7684\5167\5BB9\591A\5BE1\8B8A\66F4\6587\5B57\5340\7684\9AD8\5EA6. \60A8\53EF\4EE5\4F7F\7528\9078\9805\6839\64DA\8CC7\6599\5927\5C0F\8ABF\6574\6587\5B57\5340.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376905734098518181.4418)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\5B57\5143\8A08\6578\5668')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\662F\5426\5728\6587\5B57\5340\4E0B\65B9\986F\793A\8A08\6578\5668. \8A08\6578\5668\6703\986F\793A\5DF2\5728\6B04\4F4D\4E2D\8F38\5165\7684\5B57\5143\6578\76EE\548C\5141\8A31\7684\5B57\5143\6578\7E3D\8A08, \4F8B\5982 <code>123, \5171 4000</code>. \8A2D\70BA\958B\555F\6642, \5FC5\9808\6307\5B9A\300C\9577\5EA6\4E0A\9650\300D\5C6C\6027.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362202612251785897.4418)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\79FB\9664\7A7A\683C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\9001\51FA\9801\9762\4E4B\5F8C\4FEE\526A\9805\76EE\503C\7684\65B9\5F0F. \9019\9805\8A2D\5B9A\6703\79FB\9664\8F38\5165\6587\5B57\7684\7A7A\683C\3001\5B9A\4F4D\4EE5\53CA\65B0\884C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362202910095786913.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\524D\5C0E')
,p_return_value=>'LEADING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362203307938787882.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5C3E\96A8')
,p_return_value=>'TRAILING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362203705781788933.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\524D\5C0E\548C\5C3E\96A8')
,p_return_value=>'BOTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362204104056789676.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\7121')
,p_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/plugins/region_type/sql_report
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380028817628072908.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SQL_REPORT'
,p_display_name=>unistr('\4E00\822C\5831\8868')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SQL_REPORT'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\4EE5\300CSQL \67E5\8A62\300D\70BA\57FA\790E\7684\7C21\5316\5831\8868.\300C\4E00\822C\5831\8868\300D\8207\300C\4E92\52D5\5F0F\5831\8868\300D\985E\4F3C, \4F46\4E0D\5305\62EC\300C\4E92\52D5\5F0F\5831\8868\300D\63D0\4F9B\7684\8A31\591A\4E00\822C\4F7F\7528\8005\81EA\8A02\9078\9805.')
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(234584057047894023.4418)
,p_plugin_id=>wwv_flow_api.id(380028817628072908.4418)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' where deptno = :P1_DEPTNO',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/tabform
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380029119558081299.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TABFORM'
,p_display_name=>unistr('\5217\8868\5316\8868\55AE')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TABFORM'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\4EE5\65B9\683C\7248\9762\914D\7F6E\986F\793A\591A\500B\8CC7\6599\5217\7684\8CC7\6599, \4E00\822C\4F7F\7528\8005\53EF\4EE5\76F4\63A5\66F4\65B0\65B9\683C\5143\7D20\5167\7684\503C.')
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153406632834485.4418)
,p_plugin_id=>wwv_flow_api.id(380029119558081299.4418)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/ir
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380454112071587884.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IR'
,p_display_name=>unistr('\4E92\52D5\5F0F\5831\8868')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IR'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5\300CSQL \67E5\8A62\300D\70BA\57FA\790E\7684\5B8C\5099\7DDA\4E0A\5831\8868, \63D0\4F9B\8A31\591A\4F9B\4E00\822C\4F7F\7528\8005\5728\7A0B\5F0F\5BE6\969B\57F7\884C\6642\81EA\8A02\5831\8868\7248\9762\7684\529F\80FD. \60A8\53EF\4EE5\900F\904E\555F\7528\6216\505C\7528\5404\7A2E\5831\8868\81EA\8A02\9078\9805, \63A7\5236\4E00\822C\4F7F\7528\8005\53EF\7528\7684\529F\80FD.</p>'),
unistr('<p>\60A8\53EF\4EE5\5B9A\7FA9\55AE\4E00\300C\4E92\52D5\5F0F\5831\8868\300D, \4E26\4E14\8B93\4E00\822C\4F7F\7528\8005\80FD\5920\6839\64DA\5176\7279\5B9A\7684\5831\8868\9700\6C42\64CD\63A7\8CC7\6599\7684\986F\793A, \5982\6B64\60A8\5C31\4E0D\9700\8981\70BA\4E86\6EFF\8DB3\76F8\540C\7684\9700\6C42\800C\958B\767C\8A31\591A\4F7F\7528\4E0D\540C\689D\4EF6\7684\985E\4F3C\5831\8868.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1831648887398980457.4418)
,p_plugin_id=>wwv_flow_api.id(380454112071587884.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\52D5\4F5C\529F\80FD\8868\7D50\69CB')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IG'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\300C\52D5\4F5C\300D\529F\80FD\8868\7D50\69CB\662F\5426\8207\300C\4E92\52D5\5F0F\65B9\683C\300D\5143\4EF6\4E00\81F4, \6216\8005\662F\5426\5C07\4F7F\7528\820A\6709\7D50\69CB.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1831649884271983182.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1831648887398980457.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\820A\6709')
,p_return_value=>'LEGACY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1831650362309985149.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1831648887398980457.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\4E92\52D5\5F0F\65B9\683C')
,p_return_value=>'IG'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(234862891586787752.4418)
,p_plugin_id=>wwv_flow_api.id(380454112071587884.4418)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' where deptno = :P1_DEPTNO',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/static
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(384582062506273077.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'STATIC'
,p_display_name=>unistr('\975C\614B\5167\5BB9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','STATIC'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\986F\793A\9801\9762\9805\76EE\7684\6587\5B57\5167\5BB9\6216\5340\57DF\5BB9\5668. \82E5\4E0D\8981\5728\8F38\51FA HTML \6A19\8A18\6642\9041\96E2\5167\5BB9, \8ACB\5C07<em>\8F38\51FA\65B9\5F0F</em>\8A2D\70BA <strong>HTML</strong>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(384582415870309214.4418)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>30
,p_prompt=>unistr('\5C55\958B\6377\5F91')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(481599132721933414.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_help_text=>unistr('\6307\5B9A\662F\5426\8B93 &PRODUCT_NAME. \5728 HTML \4E3B\9AD4\4E2D\5C55\958B\6377\5F91.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(481599132721933414.4418)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\8F38\51FA\65B9\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HTML'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\6587\5B57\5167\5BB9\7684\8F38\51FA\65B9\5F0F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(481599442113934184.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(481599132721933414.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\6587\5B57 (\9041\96E2\7279\6B8A\5B57\5143)')
,p_return_value=>'TEXT'
,p_help_text=>unistr('&PRODUCT_NAME. \7522\751F\5340\57DF\4F86\6E90\6642, \6703\9041\96E2\7279\6B8A HTML \5B57\5143, \4F8B\5982 <code>"<", ">", "&"</code>.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(481600445121939808.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(481599132721933414.4418)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>unistr('&PRODUCT_NAME. \7522\751F\5340\57DF\4F86\6E90\6642, \6703\5305\542B HTML \6A19\8A18. \5982\6B64\53EF\80FD\6703\4F7F\5340\57DF\906D\53D7\8DE8\7DB2\7AD9\547D\4EE4\6A94\7684\653B\64CA.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(481600813887948606.4418)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>unistr('\986F\793A\5206\884C\7B26\865F')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(481599132721933414.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>unistr('\6307\5B9A\662F\5426\5728\5340\57DF\8F38\51FA\4E2D\4FDD\7559\5340\57DF\4F86\6E90\4E2D\7684\5206\884C\7B26\865F.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(105618485369724390.4418)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4418)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/plsql
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385049040242438541.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'PLSQL'
,p_display_name=>unistr('PL/SQL \52D5\614B\5167\5BB9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_PLSQL'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A PL/SQL \7A0B\5F0F\78BC\7684 HTML \8F38\51FA.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153863368834496.4418)
,p_plugin_id=>wwv_flow_api.id(385049040242438541.4418)
,p_name=>'SOURCE_PLSQL'
);
end;
/
prompt --application/shared_components/plugins/region_type/svg_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385104627384108788.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SVG_CHART'
,p_display_name=>unistr('SVG \5716\8868')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SVG_CHART'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\4EE5\300CSVG \5716\8868\300D\986F\793A\8CC7\6599. \6B64\5340\57DF\985E\578B\5DF2\88AB\53D6\4EE3. \8ACB\91DD\5C0D\65B0\7684\5716\8868\5340\57DF\4F7F\7528<em>\5716\8868</em>\5340\57DF\985E\578B. Oracle \5EFA\8B70\60A8\4F7F\7528<em>\5347\7D1A\61C9\7528\7A0B\5F0F</em>, \5C07\9019\4E9B\5340\57DF\66F4\65B0\70BA\540C\7B49\7684\300C\5716\8868\300D\5340\57DF.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153953839834498.4418)
,p_plugin_id=>wwv_flow_api.id(385104627384108788.4418)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/simple_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385106170962146118.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SIMPLE_CHART'
,p_display_name=>unistr('\7C21\55AE\5716\8868')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SIMPLE_CHART'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\4EE5 HTML \5716\8868\986F\793A\8CC7\6599. \6B64\5340\57DF\985E\578B\5DF2\88AB\53D6\4EE3. \8ACB\91DD\5C0D\65B0\7684\5716\8868\5340\57DF\4F7F\7528<em>\5716\8868</em>\5340\57DF\985E\578B. Oracle \5EFA\8B70\60A8\4F7F\7528<em>\5347\7D1A\61C9\7528\7A0B\5F0F</em>, \5C07\9019\4E9B\5340\57DF\66F4\65B0\70BA\540C\7B49\7684\300C\5716\8868\300D\5340\57DF.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jstree
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385504073407123938.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JSTREE'
,p_display_name=>unistr('\6A39\72C0\7D50\69CB')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JSTREE'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\6839\64DA\8A18\9304\4E4B\9593\7684\7236\9805-\5B50\9805\95DC\4FC2, \4EE5\968E\5C64\5F0F\7D50\69CB\986F\793A\8CC7\6599.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388222674242760077.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>450
,p_prompt=>unistr('\555F\7528\4E0B\5217\9805\76EE\7684\7BC0\9EDE\9023\7D50')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'S'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9078\53D6\5728\60A8\7684\6A39\72C0\7D50\69CB\555F\7528\7BC0\9EDE\9023\7D50\7684\5FC5\8981\52D5\4F5C. \6A39\72C0\7D50\69CB\4E3B\8981\7528\65BC\9078\53D6/\986F\793A\6216\5C0E\89BD. \5982\679C\540C\6642\7528\65BC\9078\53D6\548C\5C0E\89BD, \5EFA\8B70\5C07\6B64\52D5\4F5C\8A2D\70BA\300C\6309\5169\4E0B\300D, \8B93\6309\4E00\4E0B\53EA\9069\7528\65BC\9078\53D6\7BC0\9EDE.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388222945238760981.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(388222674242760077.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\6309\4E00\4E0B')
,p_return_value=>'S'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388223328719761701.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(388222674242760077.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\6309\5169\4E0B')
,p_return_value=>'D'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388223746905766372.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>600
,p_prompt=>unistr('\9078\53D6\7684\7BC0\9EDE\9801\9762\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715830565095726781.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\5E0C\671B\7528\4F86\4FDD\7559\6240\9078\7BC0\9EDE\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.</p>'),
unistr('<p>\6B64\9805\76EE\4E3B\8981\7528\4F86\5132\5B58\6A39\72C0\7D50\69CB\72C0\614B, \65B9\6CD5\70BA\4FDD\7559\6700\5F8C\4E00\500B\9078\53D6\4E4B\7BC0\9EDE\7684\503C. \6240\9078\7BC0\9EDE\7684\503C\53EF\4EE5\900F\904E\7BC0\9EDE\9023\7D50\5C6C\6027\6216\900F\904E\9801\9762\8655\7406\4F5C\696D\5132\5B58\81F3\9078\53D6\7684\9805\76EE. \91CD\65B0\8F09\5165\9801\9762\5F8C, \6A39\72C0\7D50\69CB\6703\958B\555F\81F3\9078\53D6\7684\7BC0\9EDE\503C.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388224056018770786.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>400
,p_prompt=>unistr('\5DE5\5177\63D0\793A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\662F\5426\986F\793A\5DE5\5177\63D0\793A\548C\5DE5\5177\63D0\793A\7684\4F86\6E90. \5982\679C\5B9A\7FA9\5DE5\5177\63D0\793A, \7576\4E00\822C\4F7F\7528\8005\805A\7126\6216\505C\99D0\5728\6A39\72C0\7D50\69CB\7BC0\9EDE\6A19\7C64\4E0A\6642, \4FBF\6703\986F\793A\8A72\5DE5\5177\63D0\793A.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388224310716771380.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7121')
,p_return_value=>'N'
,p_help_text=>unistr('\5C07\4E0D\6703\986F\793A\5DE5\5177\63D0\793A.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388224757018772639.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\820A\6709\6A23\677F')
,p_return_value=>'STATIC'
,p_is_deprecated=>true
,p_help_text=>unistr('\5728\4E0B\5217\8CC7\6599\4F86\6E90\8CC7\6599\6B04\66FF\4EE3\9805\76EE\4F7F\7528\975C\614B\5DE5\5177\63D0\793A\503C: #VALUE#\3001#TITLE#\3001#LINK# \548C #TOOLTIP#')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715829871157706251.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4418)
,p_display_sequence=>30
,p_display_value=>unistr('HTML \8868\793A\5F0F')
,p_return_value=>'TEMPLATE'
,p_help_text=>unistr('\63D0\4F9B\4F5C\70BA\5DE5\5177\63D0\793A\7684 HTML \8868\793A\5F0F. \5C07\6703\57F7\884C\66FF\4EE3\9805\76EE.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388225194623774797.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\8CC7\6599\5EAB\8CC7\6599\6B04')
,p_return_value=>'DB'
,p_help_text=>unistr('\4F7F\7528<strong>\5DE5\5177\63D0\793A\8CC7\6599\6B04</strong> \7684\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388225546559783958.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>410
,p_prompt=>unistr('\5DE5\5177\63D0\793A\503C')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(388224056018770786.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STATIC,TEMPLATE'
,p_help_text=>unistr('\8F38\5165\7576\4E00\822C\4F7F\7528\8005\5C07\6ED1\9F20\6307\6A19\505C\7559\5728\6A39\72C0\7D50\69CB\5143\7D20\4E0A\6642\6240\986F\793A\7684\6587\5B57.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388410177919650647.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>900
,p_prompt=>unistr('\975C\614B\6A39\72C0\7D50\69CB ID')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_deprecated_values=>'$NOT_NULL$'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6A39\72C0\7D50\69CB\7684\9078\7528\552F\4E00 ID.</p>'),
unistr('<p>\6700\597D\70BA\5340\57DF\6307\5B9A\975C\614B ID, \7136\5F8C\4F7F\7528 apex.region("<i>static-id</i>").widget() API \5B58\53D6\6A39\72C0\7D50\69CB\5143\7D20.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1397688173262880316.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>520
,p_prompt=>unistr('\5716\793A\985E\578B CSS \985E\5225')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'a-Icon'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_examples=>'fa'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7528\65BC\6307\5B9A\6240\6709\7BC0\9EDE\4F7F\7528\4E4B\5716\793A\985E\578B\7684 CSS \985E\5225. \6B64\985E\5225\5728 CSS \898F\5247\4E2D\4F7F\7528, \4EE5\6307\5B9A\8A72\985E\578B\4E4B\6240\6709\5716\793A\7684\7279\6027. \5716\793A\985E\578B\52A0\4E0A\5340\57DF\4F86\6E90\4E4B\5716\793A\8CC7\6599\6B04\7684\503C\6C7A\5B9A\4E86\7528\65BC\6BCF\500B\7BC0\9EDE\7684\5716\793A CSS \985E\5225.</p>'),
unistr('<p>\5E38\898B\7684\503C\5305\62EC:</p>'),
'<ul>',
unistr('<li><strong><code>a-Icon</code></strong> \53EF\4EE5\4F7F\7528\5C11\6578\7684\5167\5EFA APEX \5716\793A, \4F8B\5982 <code>icon-circle</code> \6216 <code>icon-tree-folder</code>.</li>'),
unistr('<li><strong><code>fa</code></strong> \53EF\4EE5\4F7F\7528 Font APEX \6216 Font Awesome \5716\793A.\300C\901A\7528\4E3B\984C\300D\63D0\4F9B\5176\4E2D\4E00\7A2E\5716\793A\5EAB.</li>'),
'</ul>',
unistr('<p>\82E5\672A\63D0\4F9B\503C, \5C31\4E0D\6703\6709\5716\793A\985E\578B. \5982\6709\9700\8981, \53EF\4EE5\5728\5716\793A\8CC7\6599\6B04\4E2D\5305\542B\5716\793A\985E\578B CSS \985E\5225. \4F8B\5982, \5716\793A\8CC7\6599\6B04\503C\53EF\4EE5\662F "fa fa-user".'),
unistr('\5C0D\65BC\5716\793A\672A\8A2D\5B9A\5716\793A\985E\578B\7684\6A39\72C0\7D50\69CB, \4E14\5176\300C\9810\8A2D\5716\793A\300D\5C6C\6027\7A7A\767D, \90A3\9EBC\5728\300CSQL \67E5\8A62\300D\4F86\6E90\7684\5716\793A\8CC7\6599\6B04\61C9\8A72\662F\7A7A\503C.'),
unistr('\81EA\8A02\6216\7B2C\4E09\65B9\4E3B\984C\53EF\4EE5\8A2D\5B9A\81EA\5DF1\7684\5B57\578B\6216 CSS sprite \5716\793A\5EAB, \4E26\4F7F\7528\60A8\5728\6B64\8655\6307\5B9A\7684\4E0D\540C\5716\793A\985E\578B/\524D\7F6E\78BC\985E\5225.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388198764505202174.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>510
,p_prompt=>unistr('\9810\8A2D\5716\793A CSS \985E\5225')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'icon-tree-folder'
,p_is_translatable=>false
,p_examples=>unistr('<p>\5716\793A\985E\578B\82E5\70BA <code>fa</code> (\4EE3\8868 Font APEX), \5C31\53EF\4EE5\4F7F\7528\4EE5\4E0B\503C: <code>fa-user-circle-o</code>\3001<code>fa-file-o</code> \6216 <code>fa-arrow-circle-right</code>. \8ACB\53C3\95B1\901A\7528\4E3B\984C\61C9\7528\7A0B\5F0F\4EE5\77AD\89E3\6240\6709\7684\5716\793A.</p>')
,p_help_text=>unistr('\300CSQL \67E5\8A62\300D\5716\793A\8CC7\6599\6B04\70BA\7A7A\503C\6642\6240\4F7F\7528\7684\9810\8A2D\5716\793A. \503C\70BA\6307\5B9A\5C07\6703\898B\5230\4E4B\5716\793A\7684 CSS \985E\5225\540D\7A31. \53EF\80FD\7684\503C\53D6\6C7A\65BC\300C\5716\793A\985E\578B\300D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715809220298508190.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>310
,p_prompt=>unistr('\7BC0\9EDE\6A19\7C64\8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\9078\53D6\5167\542B\7BC0\9EDE\6A19\7C64\503C\7684\8CC7\6599\4F86\6E90\8CC7\6599\6B04. \503C\4E0D\80FD\5305\542B\6A19\8A18.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715811910493561671.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>380
,p_prompt=>unistr('\968E\5C64\5C64\7D1A\8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('\9078\53D6\5167\542B\7BC0\9EDE\4E4B\968E\5C64\5C64\7D1A\503C\7684\8CC7\6599\4F86\6E90\8CC7\6599\6B04. <strong>\968E\5C64</strong>\5C6C\6027\82E5\8A2D\70BA<strong>\4E0D\904B\7B97</strong>, \5FC5\9808\9078\53D6\6B64\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715813002119570686.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>500
,p_prompt=>unistr('\5716\793A CSS \985E\5225\8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\9078\53D6\5167\542B\8981\5957\7528\81F3\7BC0\9EDE\4E4B\5716\793A CSS \985E\5225\503C\7684\8CC7\6599\4F86\6E90\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715814135069583776.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>330
,p_prompt=>unistr('\7BC0\9EDE ID \8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('\9078\53D6\5167\542B\7BC0\9EDE ID \7684\8CC7\6599\4F86\6E90\8CC7\6599\6B04. \968E\5C64\82E5\7531 Application Express \904B\7B97, \5FC5\9808\9078\53D6\6B64\8CC7\6599\6B04. \901A\5E38\6703\5728\6B64\8655\9078\64C7\4E3B\7D22\5F15\9375\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715815231948590626.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>340
,p_prompt=>unistr('\7236\9805\7D22\5F15\9375\8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('\9078\53D6\5167\542B\7BC0\9EDE\4E4B\7236\9805\7D22\5F15\9375\503C\7684\8CC7\6599\4F86\6E90\8CC7\6599\6B04. \82E5\7531 Application Express \904B\7B97\968E\5C64, \5FC5\9808\9078\53D6\6B64\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715816326045601781.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>370
,p_prompt=>unistr('\7BC0\9EDE\72C0\614B\8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('\9078\53D6\5167\542B\7BC0\9EDE\72C0\614B\503C\7684\8CC7\6599\4F86\6E90\8CC7\6599\6B04. <strong>\968E\5C64</strong>\5C6C\6027\82E5\8A2D\70BA<strong>\4E0D\904B\7B97</strong>, \5FC5\9808\9078\53D6\6B64\8CC7\6599\6B04. \82E5\70BA\8449\7BC0\9EDE, \6B64\8CC7\6599\6B04\7684\503C\5FC5\9808\662F <strong>0</strong>, \82E5\70BA\542B\6709\5B50\9805\7684\7BC0\9EDE, \6B64\8CC7\6599\6B04\7684\503C\5FC5\9808\662F <strong>1</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715817436034604662.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>350
,p_prompt=>unistr('\6A39\72C0\7D50\69CB\958B\59CB\503C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NULL'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6B64\5C6C\6027\6C7A\5B9A\6A39\72C0\7D50\69CB\6839\76EE\9304\7684\904B\7B97\65B9\5F0F. \7CFB\7D71\6703\5C07<strong>\7236\9805\7D22\5F15\9375</strong>\8CC7\6599\6B04\503C\8207\6B64\8655\5B9A\7FA9\503C\76F8\540C\7684\7BC0\9EDE\8996\70BA\6839\7BC0\9EDE. \53EF\6709\591A\500B\6839\7BC0\9EDE.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715818524967607963.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\6839\64DA\73FE\6709\9805\76EE')
,p_return_value=>'ITEM'
,p_help_text=>unistr('\4F7F\7528\9805\76EE\503C\958B\59CB\6A39\72C0\7D50\69CB.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715818952174610864.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\6839\64DA SQL \67E5\8A62')
,p_return_value=>'SQL'
,p_help_text=>unistr('\4F7F\7528 SQL \67E5\8A62\50B3\56DE\7684\503C\958B\59CB\6A39\72C0\7D50\69CB.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715819396180612829.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\6839\64DA\975C\614B\503C')
,p_return_value=>'STATIC'
,p_help_text=>unistr('\4F7F\7528\975C\614B\503C\958B\59CB\6A39\72C0\7D50\69CB.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715819794480614454.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\503C\662F\7A7A\503C')
,p_return_value=>'NULL'
,p_help_text=>unistr('\4F7F\7528 SQL NULL \958B\59CB\6A39\72C0\7D50\69CB.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715821189465630260.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>351
,p_prompt=>unistr('\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('\9078\64C7\5167\542B\6A39\72C0\7D50\69CB\958B\59CB\503C\7684\9805\76EE.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715822207129637643.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>352
,p_prompt=>unistr('SQL \67E5\8A62')
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>unistr('\6307\5B9A\7528\4EE5\6C7A\5B9A\6A39\72C0\7D50\69CB\958B\59CB\503C\7684 SQL \67E5\8A62. SQL \67E5\8A62\4E00\5F8B\6703\5728<em>\672C\6A5F\8CC7\6599\5EAB</em>\4E2D\57F7\884C, \4E14\5FC5\9808\53EA\50B3\56DE\4E00\500B\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715823388473642206.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>353
,p_prompt=>unistr('\975C\614B\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>unistr('\6A39\72C0\7D50\69CB\975C\614B\958B\59CB\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715830565095726781.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>315
,p_prompt=>unistr('\7BC0\9EDE\503C\8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:ROWID'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\9078\53D6\5167\542B\7BC0\9EDE "value" \503C\7684\8CC7\6599\4F86\6E90\8CC7\6599\6B04. \9019\500B\503C\4E0D\6703\986F\793A, \4F46\6703\65B0\589E\81F3\53EF\4F7F\7528 JavaScript \5B58\53D6\7684\6A39\72C0\7D50\69CB\4ECB\9762\7A0B\5F0F\7BC0\9EDE ID \7279\6027.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715824464978646322.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>460
,p_prompt=>unistr('\9023\7D50')
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\6309\67D0\500B\7BC0\9EDE\5F8C\6240\8981\57F7\884C\7684\9023\7D50.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715825559244651508.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>420
,p_prompt=>unistr('\5DE5\5177\63D0\793A\8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:CLOB'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(388224056018770786.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB'
,p_help_text=>unistr('\9078\53D6\5167\542B\7BC0\9EDE\5DE5\5177\63D0\793A\503C\7684\8CC7\6599\4F86\6E90\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715810380689519088.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>320
,p_prompt=>unistr('\968E\5C64')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'SQL'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\793A Application Express \662F\61C9\7576\5F9E\8CC7\6599\904B\7B97\6A39\72C0\7D50\69CB\968E\5C64, \9084\662F\8CC7\6599\5DF2\7D93\5305\542B\6240\6709\968E\5C64\8CC7\8A0A.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715810629237528987.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(715810380689519088.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\4F7F\7528 SQL \904B\7B97')
,p_return_value=>'SQL'
,p_help_text=>unistr('\968E\5C64\662F\4F7F\7528 SQL START WITH CONNECT BY \5B50\53E5\904B\7B97. \5FC5\9808\63D0\4F9B<strong>\7236\9805\7D22\5F15\9375\8CC7\6599\6B04</strong>. \53EA\6709\5728\60A8\7684 SQL \67E5\8A62<em>\5C1A\672A</em>\5305\542B START WITH CONNECT BY \5B50\53E5\6642, \624D\80FD\4F7F\7528\6B64\9078\9805.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715811097049545246.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(715810380689519088.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\4E0D\904B\7B97')
,p_return_value=>'LEVEL'
,p_help_text=>unistr('\8CC7\6599\4E2D\5DF2\7D93\5305\542B\6240\6709\968E\5C64\8CC7\8A0A. \6B64\9078\9805\9700\8981\5C0D\61C9<strong>\7BC0\9EDE\5C64\7D1A</strong>\548C<strong>\7BC0\9EDE\72C0\614B</strong>\8CC7\6599\6B04. <strong>\7BC0\9EDE\5C64\7D1A</strong>\5FC5\9808\5305\542B\4EE5\6578\503C\8868\793A\7684\968E\5C64\5C64\7D1A; <strong>\7BC0\9EDE\72C0\614B</strong>\5FC5\9808\5305\542B <strong>0</strong> (\8868\793A\8449\7BC0\9EDE) \548C <strong>1</strong> (\8868\793A\975E\8449\7BC0\9EDE).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715827441883672711.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>24
,p_display_sequence=>470
,p_prompt=>unistr('\9023\7D50\8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715824464978646322.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>unistr('\9078\53D6\5167\542B\6309\67D0\500B\7BC0\9EDE\5F8C\6240\8981\57F7\884C\4E4B\9023\7D50\503C\7684\8CC7\6599\4F86\6E90\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715828729502680591.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>25
,p_display_sequence=>360
,p_prompt=>unistr('\540C\7D1A\6392\5217\65B9\5F0F')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>unistr('\9078\53D6\7528\65BC\6392\5217\7236\9805\7BC0\9EDE\5167\5B50\9805\9806\5E8F\7684\8CC7\6599\4F86\6E90\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(381686476818136654.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.multiple = true;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\53EF\53D6\7528\6A39\72C0\7D50\69CB\7684\9078\9805\7269\4EF6\3001\4FEE\6539\8A72\7269\4EF6\4E26\5C07\5176\50B3\56DE\7684 JavaScript \51FD\6578. \53EF\4EE5\7528\4F86\5728\521D\59CB\5316 treeView \5C0F\5DE5\5177\6642, \5C0D\6A39\72C0\7D50\69CB\505A\9032\968E\81EA\8A02. \8ACB\53C3\95B1 treeView \5C0F\5DE5\5177 JavaScript API \6587\4EF6, \77AD\89E3\53EF\4EE5\4F7F\7528\7684\9078\9805.<p>'),
unistr('<p>\6A39\72C0\7D50\69CB\5340\57DF\5B9A\7FA9\7684\5176\4ED6\9078\9805:</p>'),
'<ul>',
unistr('<li><strong>makeNodeAdapter</strong> \7528\65BC\5B9A\7FA9\81EA\8A02 nodeAdapter. \9019\662F\4E00\500B\4F7F\7528\8207 makeDefaultNodeAdapter \76F8\540C\4E4B\5F15\6578\7684\51FD\6578, \4E14\5FC5\9808\50B3\56DE treeNodeAdapter \4ECB\9762.</li>'),
unistr('<li><strong>initialSelectedNodeId</strong> \8981\9078\53D6\7684\7BC0\9EDE\503C. \9019\6839\64DA\300C\9078\53D6\7684\7BC0\9EDE\9801\9762\9805\76EE\300D\5C6C\6027\8A2D\5B9A.</li>'),
unistr('<li><strong>nodeHasTooltip</strong> \9019\6839\64DA\300C\5DE5\5177\63D0\793A\300D\5C6C\6027\8A2D\5B9A. \7BC0\9EDE\82E5\6709\5DE5\5177\63D0\793A, \5247\70BA true, \53CD\4E4B\70BA false.</li>'),
unistr('<li><strong>regionStaticId</strong> \9019\662F\7528\65BC\6B64\5340\57DF\7684\5143\7D20 ID.</li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(715829199415682079.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\968E\5C64\5C6C\6027\8A2D\70BA\300C\4F7F\7528 SQL \904B\7B97\300D\6642</dt>'),
'<dd><pre>',
' select ename, empno, mgr from emp',
'</pre>',
unistr('<p>\6307\5B9A EMPNO \4F5C\70BA\7BC0\9EDE ID \8CC7\6599\6B04, MGR \4F5C\70BA\7236\9805\7D22\5F15\9375\8CC7\6599\6B04\5C6C\6027</p>'),
'</dd>',
unistr('<dt>\968E\5C64\5C6C\6027\8A2D\70BA\300C\4E0D\904B\7B97\300D\6642</dt>'),
'<dd><pre>',
' select case when connect_by_isleaf = 1 then 0 when level = 1 then 1 else -1 end as status,',
'        level,',
'        ename as title,',
'        ''icon-tree-folder'' as icon,',
'        empno as value,',
'        ename as tooltip,',
'        null  as link',
'   from emp',
'  start with mgr is null',
'connect by prior empno = mgr',
'  order siblings by ename',
'</pre>',
unistr('<p>\6307\5B9A STATUS \4F5C\70BA\7BC0\9EDE\72C0\614B\8CC7\6599\6B04, LEVEL \4F5C\70BA\968E\5C64\5C64\7D1A\8CC7\6599\6B04\5C6C\6027.</p>'),
'</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(389020154426295680.4418)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4418)
,p_name=>'treeviewselectionchange'
,p_display_name=>unistr('\9078\64C7\9805\76EE\8B8A\66F4')
);
end;
/
prompt --application/shared_components/plugins/region_type/calendar
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385516061640387971.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CALENDAR'
,p_display_name=>unistr('\884C\4E8B\66C6')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\5404\7A2E\884C\4E8B\66C6\6AA2\8996\4E2D\986F\793A\57FA\65BC\65E5\671F\7684\9805\76EE.</p>'),
unistr('<p>\5EFA\7ACB\65B0\5340\57DF\6642, \8ACB\4F7F\7528<em>\884C\4E8B\66C6</em>\800C\975E\6B64\5340\57DF\985E\578B.\300C\4E00\822C\884C\4E8B\66C6\300D\5340\57DF\901A\5E38\6307\7684\662F\5728 &PRODUCT_NAME. \7248\672C 4.2 \6216\66F4\820A\7248\672C\4E2D\5EFA\7ACB\7684\5340\57DF.</p>')))
,p_version_identifier=>'1.0'
,p_plugin_comment=>'$$$ DJP - Shouldn''t this be ''Is Legacy'' = ''Yes''?'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154143004834501.4418)
,p_plugin_id=>wwv_flow_api.id(385516061640387971.4418)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/tree
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385516341883422042.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TREE'
,p_display_name=>unistr('\4E00\822C\6A39\72C0\7D50\69CB')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TREE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6839\64DA\8A18\9304\4E4B\9593\7684\7236\9805-\5B50\9805\95DC\4FC2, \4EE5\968E\5C64\5F0F\7D50\69CB\986F\793A\8CC7\6599.</p>'),
unistr('<p>\5EFA\7ACB\65B0\5340\57DF\6642, \8ACB\4F7F\7528<em>\6A39\72C0\7D50\69CB</em>\800C\975E\6B64\5340\57DF\985E\578B.</p>')))
,p_version_identifier=>'1.0'
,p_plugin_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$$ DJP - Is the name Classic Tree in preparation for John''s tree being implemented as a standard component in 5.0?',
''))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(385518660732877617.4418)
,p_plugin_id=>wwv_flow_api.id(385516341883422042.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6A39\72C0\7D50\69CB\5143\4EF6 ID')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_expand
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(388431570538859249.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_EXPAND'
,p_display_name=>unistr('\5C55\958B\6A39\72C0\7D50\69CB')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_EXPAND'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5C55\958B\6A39\72C0\7D50\69CB\5340\57DF\4E2D\76EE\524D\7684\7BC0\9EDE.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_collapse
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(388635386274723384.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_COLLAPSE'
,p_display_name=>unistr('\96B1\85CF\6A39\72C0\7D50\69CB')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_COLLAPSE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\96B1\85CF\6A39\72C0\7D50\69CB\5340\57DF\4E2D\76EE\524D\7684\7BC0\9EDE.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/password
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(435122514730662817.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PASSWORD'
,p_display_name=>unistr('\5BC6\78BC')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PASSWORD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A HTML \5BC6\78BC\8868\55AE\5143\7D20. \4E00\822C\4F7F\7528\8005\5728\8F38\5165\6587\5B57\6642, \8A72\5B57\5143\6703\986F\793A\70BA\9ED1\9EDE, \800C\4E0D\662F\5BE6\969B\8F38\5165\7684\5B57\5143.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(435122925859694465.4418)
,p_plugin_id=>wwv_flow_api.id(435122514730662817.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6309 Enter \6642\9001\51FA')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\5728\6B64\6B04\4F4D\4E2D\6642\82E5\6309 <em>Enter</em> \9375, \662F\5426\6703\81EA\52D5\9001\51FA\9801\9762.')
);
end;
/
prompt --application/shared_components/plugins/item_type/stop_and_start_html_table
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(442021108862425785.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STOP_AND_START_HTML_TABLE'
,p_display_name=>unistr('\505C\6B62\53CA\555F\52D5\65B9\683C\7248\9762\914D\7F6E')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STOP_AND_START_HTML_TABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7528\4EE5\505C\6B62\5148\524D\7684 HTML \8868\683C\4E26\958B\59CB\65B0 HTML \8868\683C\7684\820A\6709\9805\76EE. &PRODUCT_NAME. \7248\672C xx \5728\5C0E\5165<em>\7DB2\683C\7248\9762</em>\4E4B\524D, \6B64\9805\76EE\985E\578B\5EE3\6CDB\7684\7528\65BC\4FEE\6539\9801\9762\9805\76EE\7684\986F\793A.</p>'),
unistr('<p>Oracle \5EFA\8B70\60A8\522A\9664\9019\4E9B\820A\6709\7684\9805\76EE\985E\578B, \4E26\4E14\91DD\5C0D\8A72\5340\57DF\4E2D\4E0B\4E00\500B\986F\793A\7684\9801\9762\9805\76EE, \5C07<em>\5F9E\65B0\7DB2\683C\958B\59CB</em>\66F4\65B0\70BA<strong>\662F</strong>. \9019\5728\529F\80FD\4E0A\7B49\540C\65BC\4F7F\7528\300C\505C\6B62\53CA\555F\52D5\7DB2\683C\7248\9762\300D\9805\76EE.</p>')))
,p_plugin_comment=>'$$$ DJP - What APEX Release was Grid Layout introduced?'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/refresh
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(457584914213394021.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REFRESH'
,p_display_name=>unistr('\91CD\65B0\6574\7406')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REFRESH'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\89F8\767C\91CD\65B0\6574\7406\53D7\5F71\97FF\7684\5143\7D20. \4E26\975E\6240\6709\5143\7D20\90FD\652F\63F4\91CD\65B0\6574\7406\52D5\4F5C. \60A8\53EF\4EE5\4F7F\7528\6B64\52D5\4F5C\91CD\65B0\6574\7406\300C\4E92\52D5\5F0F\5831\8868\300D\3001\300C\4E00\822C\5831\8868\300D\4EE5\53CA\652F\63F4\968E\5C64\5F0F LOV \4E4B\6240\6709\9805\76EE\985E\578B\7684\5167\5BB9.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/show
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(517009436728139227.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SHOW'
,p_display_name=>unistr('\986F\793A')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SHOW'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\986F\793A\53D7\5F71\97FF\7684\5143\7D20.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262167718423622079.4418)
,p_plugin_id=>wwv_flow_api.id(517009436728139227.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5168\90E8\986F\793A\5728\540C\4E00\884C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\986F\793A\8207\53D7\5F71\97FF\5143\7D20\6240\5728\540C\4E00\884C\4E0A\7684\6240\6709\9801\9762\9805\76EE\548C\6A19\7C64.</p>'),
unistr('<p>\6CE8\610F: \6B64\5C6C\6027\5C0D\672A\4F7F\7528\8868\683C\65B9\683C\986F\793A\8868\55AE\9805\76EE\4E4B\9801\9762\4E2D\7684\9805\76EE\6C92\6709\4F5C\7528. \9019\5305\62EC\4F7F\7528\884C\52D5\88DD\7F6E\9801\9762\6A23\677F\7684\6240\6709\9801\9762.</p>')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/http_header_variable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(552639319797428791.4418)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'HTTP_HEADER_VARIABLE'
,p_display_name=>unistr('HTTP \6A19\982D\8B8A\6578')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','HTTP_HEADER_VARIABLE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5728\5916\90E8\8A8D\8B49, \4F7F\7528\8005\540D\7A31\6703\5132\5B58\5728 Web \4F3A\670D\5668\6240\8A2D\5B9A\7684\300CHTTP \6A19\982D\300D\8B8A\6578\4E2D.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552647115426436957.4418)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('HTTP \6A19\982D\8B8A\6578\540D\7A31')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5305\542B\4F7F\7528\8005\540D\7A31\4E4B HTTP \6A19\982D\8B8A\6578\7684\540D\7A31. \82E5\672A\6307\5B9A, \5C07\4F7F\7528 REMOTE_USER.</p>'),
'',
unistr('<p>HTTP \6A19\982D\8B8A\6578\662F Web \4F3A\670D\5668\6240\8A2D\5B9A\7684\4E00\500B\8B8A\6578.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552651403090442945.4418)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\4F7F\7528\8005\540D\7A31\7A7A\767D\6642\57F7\884C\52D5\4F5C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\6307\5B9A\82E5 HTTP \6A19\982D\8B8A\6578\4E2D\5132\5B58\7684\4F7F\7528\8005\540D\7A31\7A7A\767D\6642, \61C9\8A72\57F7\884C\7684\52D5\4F5C. \53EF\7528\9078\9805\5305\62EC:'),
'</p>',
'<p>',
'<ul>',
unistr('  <li><strong>\91CD\65B0\5C0E\5411\81F3\5167\5EFA URL</strong>: \7531 Web \4F3A\670D\5668\8D77\59CB\767B\5165. \5FC5\9808\5C07\6B64\300C\5167\5EFA URL\300D\8A2D\5B9A\70BA\53D7 Web \4F3A\670D\5668\4FDD\8B77, \4EE5\5728\547C\53EB\6642\5F37\5236\767B\5165. \767B\5165\4E4B\5F8C, Web \4F3A\670D\5668\5FC5\9808\5C07\7D93\904E\9A57\8B49\7684\4F7F\7528\8005\540D\7A31\5132\5B58\5728 HTTP \6A19\982D\8B8A\6578\4E2D, \4EE5\4F9B\8A8D\8B49\914D\7F6E\4F7F\7528.\300C\5167\5EFA URL\300D\662F'),
'<pre>/apex/apex_authentication.callback</pre>',
unistr('\524D\7F6E\78BC <code>/apex/</code> \6839\64DA\60A8\4F3A\670D\5668\7684\7D44\614B\800C\5B9A.'),
'</li>',
unistr('  <li><strong>\91CD\65B0\5C0E\5411\81F3 URL</strong>: \5728\5916\90E8\4F3A\670D\5668\8D77\59CB\767B\5165, \7136\5F8C\5728 HTTP \6A19\982D\8B8A\6578\4E2D\8A2D\5B9A\7D93\904E\9A57\8B49\7684\4F7F\7528\8005\540D\7A31. \5916\90E8\4F3A\670D\5668\5FC5\9808\4F7F\7528 <code>#CALLBACK#</code> \9810\7559\4F4D\7F6E\7522\751F\7684 URL \91CD\65B0\5C0E\5411\56DE\61C9\7528\7A0B\5F0F, \4EE5\5728\61C9\7528\7A0B\5F0F\4E2D\5B8C\6210\8A8D\8B49.</li>'),
unistr('  <li><strong>\986F\793A\932F\8AA4</strong>: \5C07\986F\793A\6307\5B9A\7684\932F\8AA4\8A0A\606F, \4E14\4E0D\5728\61C9\7528\7A0B\5F0F\4E2D\57F7\884C\767B\5165.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552655716596446845.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\91CD\65B0\5C0E\5411\81F3\5167\5EFA URL')
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552667630233460180.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\91CD\65B0\5C0E\5411\81F3 URL')
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552687932441470278.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\986F\793A\932F\8AA4')
,p_return_value=>'ERROR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552699720929485951.4418)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(552651403090442945.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'<pre>http://sso.example.com/?success=#CALLBACK#</pre>'
,p_help_text=>unistr('\6307\5B9A\5728 HTTP \6A19\982D\8B8A\6578\4E2D\8A2D\5B9A\5DF2\9A57\8B49\4F7F\7528\8005\540D\7A31\4E4B\5916\90E8\767B\5165\4F3A\670D\5668\7684 URL. \6B64\5916\90E8\4F3A\670D\5668\5FC5\9808\4F7F\7528 <code>#CALLBACK#</code> \9810\7559\4F4D\7F6E\6240\7522\751F\7684 URL \91CD\65B0\5C0E\5411\56DE\61C9\7528\7A0B\5F0F, \4EE5\4FBF\5728\61C9\7528\7A0B\5F0F\4E2D\5B8C\6210\8A8D\8B49.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552704028894488210.4418)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\932F\8AA4\8A0A\606F')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(552651403090442945.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>unistr('\6307\5B9A\82E5 HTTP \6A19\982D\8B8A\6578\672A\5305\542B\503C\6216 HTTP \6A19\982D\8B8A\6578\4E0D\5B58\5728\6642, \6240\8981\986F\793A\7684\932F\8AA4\8A0A\606F.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(879327919421164751.4418)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\9A57\8B49\4F7F\7528\8005\540D\7A31')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\6307\5B9A\9A57\8B49\5132\5B58\65BC HTTP \6A19\982D\8B8A\6578\4E2D\4E4B\4F7F\7528\8005\540D\7A31\7684\983B\7387. \53EF\7528\9078\9805\5305\62EC:'),
'</p>',
'<p>',
'<ul>',
unistr('  <li><strong>\6BCF\6B21\8981\6C42</strong>: Web \4F3A\670D\5668\4E00\57F7\884C\767B\5165, \5C31\4E00\5F8B\8A2D\5B9A CGI \8B8A\6578. \5982\679C\4F7F\7528\8005\540D\7A31\8207\76EE\524D &PRODUCT_NAME. \968E\6BB5\4F5C\696D\4E2D\5132\5B58\7684\4E0D\540C, \5C31\6703\5C07\8A72\968E\6BB5\4F5C\696D\8B8A\6210\7121\6548, \7136\5F8C\8D77\59CB\65B0\7684\767B\5165. \9019\662F\6700\5B89\5168\7684\9078\9805, \56E0\70BA\5B83\6703\5075\6E2C\767B\51FA\6216\4F7F\7528\8005\540D\7A31\8B8A\66F4.'),
'  </li>',
unistr('  <li><strong>\767B\5165\5F8C</strong>: Web \4F3A\670D\5668\57F7\884C\767B\5165\4E26\547C\53EB\56DE\547C\4EE5\5728\61C9\7528\7A0B\5F0F\4E2D\5B8C\6210\8A8D\8B49\4E4B\5F8C, \624D\6703\9A57\8B49\4F7F\7528\8005\540D\7A31\4E26\5C07\5176\5132\5B58\65BC &PRODUCT_NAME. \968E\6BB5\4F5C\696D\4E2D. \5982\9700\56DE\547C\76F8\95DC\8CC7\8A0A, \8ACB\53C3\95B1\300C\4F7F\7528\8005\540D\7A31\7A7A\767D\6642\57F7\884C\52D5\4F5C\300D\7D44\614B.'),
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(879343501197168872.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(879327919421164751.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\6BCF\6B21\8981\6C42')
,p_return_value=>'ALWAYS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(879347807777170859.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(879327919421164751.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\767B\5165\5F8C')
,p_return_value=>'CALLBACK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(39504908766917753.4418)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('SSO \4F3A\670D\5668\767B\51FA URL')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5C0D\65BC\4EE5 Oracle Access Manager \70BA\57FA\790E\7684 SSO, \8F38\5165\7BC4\4F8B:</p>'),
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\8A8D\8B49\914D\7F6E\6839\64DA Oracle Access Manager \6216\985E\4F3C\7684\4F3A\670D\5668,,'),
unistr('\60A8\53EF\4EE5\4F7F\7528\6B64\5C6C\6027\6307\5B9A\767B\51FA\4E2D\592E\55AE\4E00\767B\5165\4F3A\670D\5668\7684 URL.</p>'),
'',
unistr('<p>\66FF\4EE3\53C3\6578 <code>%POST_LOGOUT_URL%</code> \5C07\53D6\4EE3\70BA\60A8\61C9\7528\7A0B\5F0F\4E4B\767B\5165\9801\9762\7684\7DE8\78BC URL.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/html_expression
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(562560582820583985.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HTML_EXPRESSION'
,p_display_name=>unistr('HTML \8868\793A\5F0F')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HTML_EXPRESSION'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\6839\64DA HTML \8868\793A\5F0F\986F\793A\4E0D\80FD\8F38\5165\7684\9805\76EE.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(562566479673647057.4418)
,p_plugin_id=>wwv_flow_api.id(562560582820583985.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('HTML \8868\793A\5F0F')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\8B8A\66F4\80CC\666F\548C\6587\5B57\7684\8272\5F69</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&amp;EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\4F7F\7528\6A19\984C 2</dt>'),
'    <dd><pre>&lt;h2>&amp;EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>\4F7F\7528 SQL \67E5\8A62\7684\52D5\614B\985E\5225</dt>'),
'    <dd><pre>&lt;span class="&amp;COLUMN_CLASS!ATTR.">&amp;EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \672C\7BC4\4F8B\4E2D\7684 <code>&amp;COLUMN_CLASS!ATTR.</code> \548C <code>&amp;EMPLOYEE_STATUS.</code> \66FF\4EE3\9805\76EE\70BA\5728 SQL \67E5\8A62\4E2D\9078\53D6\7684\8CC7\6599\6B04.</dd>'),
unistr('  <dt>\986F\793A\5F71\50CF\548C\5DE5\5177\63D0\793A (\7576\6E38\6A19\505C\99D0\6642)</dt>'),
'    <dd><pre>&lt;img src="&amp;IMAGE_NAME!ATTR." title="&amp;EMPLOYEE_NAME!ATTR."&gt;</pre></dd>',
'</dl>'))
,p_help_text=>unistr('\8F38\5165\6B64\8CC7\6599\6B04\4E2D\6240\8981\986F\793A\7684 HTML \8868\793A\5F0F. \82E5\8981\4EE5 HTML \683C\5F0F\986F\793A\8CC7\6599\6B04\503C, \8ACB\4F7F\7528 <code>&amp;COLUMN.</code> \8A9E\6CD5.')
);
end;
/
prompt --application/shared_components/plugins/item_type/link
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(567106626791482337.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LINK'
,p_display_name=>unistr('\9023\7D50')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LINK'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:ESCAPE_OUTPUT:SOURCE:FILTER:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5C07\4E0D\80FD\8F38\5165\7684\9805\76EE\986F\793A\70BA\9023\7D50.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/clear
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626823504054693040.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLEAR'
,p_display_name=>unistr('\6E05\9664')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLEAR'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\6E05\9664\53D7\5F71\97FF\7684\5143\7D20.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/alert
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626823719638697634.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ALERT'
,p_display_name=>unistr('\8B66\793A')
,p_category=>'NOTIFICATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ALERT'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A\8B66\793A\8A0A\606F\4E14\5E36\6709\55AE\4E00\500B<em>\78BA\5B9A</em>\6309\9215. \7528\65BC\986F\793A\5FC5\9808\6309\6309\9215\56DE\61C9\7684\8CC7\8A0A, \4F46\662F\6703\7E7C\7E8C\57F7\884C\4E8B\4EF6.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(626823916999706267.4418)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('\8A0A\606F')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>unistr('<p>&lt;strong&gt;\7121\6CD5&lt;&#x2F;strong&gt;\522A\9664\54E1\5DE5 &amp;P1_ENAME..</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8B66\793A\5C0D\8A71\65B9\584A\4E2D\6240\8981\986F\793A\7684\8A0A\606F.</p>'),
unistr('<p>\6B64\5C0D\8A71\65B9\584A\986F\793A\6642, \5C07\6703\5C0D\5F9E\5C6C\7AEF\57F7\884C\9805\76EE\66FF\4EE3\9805\76EE.</p>')))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3701076455936800.4418)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\6A19\984C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('<p>(\9078\64C7\6027) \63D0\4F9B\5C0D\8A71\65B9\584A\6A19\984C.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3701701323970349.4418)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6A23\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('\9810\8A2D')
,p_help_text=>unistr('\6307\5B9A\5C0D\8A71\65B9\584A\7684\6A23\5F0F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3703043398973992.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\8CC7\8A0A')
,p_return_value=>'information'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3702623945972615.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5371\96AA')
,p_return_value=>'danger'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3702291441971350.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\8B66\544A')
,p_return_value=>'warning'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3703410946975189.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\6210\529F')
,p_return_value=>'success'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3705287585006856.4418)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\5716\793A')
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\9078\64C7\6027\7684\5C0D\8A71\65B9\584A\5716\793A.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3704914260003167.4418)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('CSS \985E\5225')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\8981\5957\7528\81F3\5C0D\8A71\65B9\584A\5BB9\5668\7684\9078\64C7\6027 CSS \985E\5225.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3705505358011056.4418)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\78BA\5B9A\6A19\7C64')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('\8F38\5165\300C\78BA\5B9A\300D\6309\9215\7684\6A19\7C64. \82E5\672A\63D0\4F9B, \5C07\6703\4F7F\7528\6587\5B57\8A0A\606F <code>APEX.DIALOG.OK</code> \7684\503C.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/confirm
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626824429466709866.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CONFIRM'
,p_display_name=>unistr('\78BA\8A8D')
,p_category=>'NOTIFICATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CONFIRM'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A\78BA\8A8D\5C0D\8A71\65B9\584A, \4E14\5176\4E2D\5305\542B\300C\53D6\6D88\300D\548C\300C\78BA\8A8D\300D\6309\9215. \5982\679C\4F7F\7528\8005\9078\64C7<em>\53D6\6D88</em>, \5C31\4E0D\6703\57F7\884C\9032\884C\4E2D\7684\52D5\4F5C, \800C\4E14\6703\53D6\6D88\76EE\524D\7684\4E8B\4EF6.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(626824618169716040.4418)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('\8A0A\606F')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>unistr('<p>&lt;strong&gt;\78BA\5B9A&lt;&#x2F;strong&gt;\8981\522A\9664\54E1\5DE5 &amp;P1_ENAME. \55CE?</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\78BA\8A8D\5C0D\8A71\65B9\584A\4E2D\6240\8981\986F\793A\7684\8A0A\606F.</p>'),
unistr('<p>\6B64\5C0D\8A71\65B9\584A\986F\793A\6642, \5C07\6703\5C0D\5F9E\5C6C\7AEF\57F7\884C\9805\76EE\66FF\4EE3\9805\76EE.</p>')))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2101389282482255.4418)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\6A19\984C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('<p>(\9078\64C7\6027) \63D0\4F9B\5C0D\8A71\65B9\584A\6A19\984C.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2103085785653286.4418)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6A23\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('\9810\8A2D')
,p_help_text=>unistr('\6307\5B9A\5C0D\8A71\65B9\584A\7684\6A23\5F0F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2104149014656515.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\8CC7\8A0A')
,p_return_value=>'information'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2103302674655458.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\8B66\544A')
,p_return_value=>'warning'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2103765346655897.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\5371\96AA')
,p_return_value=>'danger'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2104502204657360.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\6210\529F')
,p_return_value=>'success'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106373192721945.4418)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\5716\793A')
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\9078\64C7\6027\7684\5C0D\8A71\65B9\584A\5716\793A.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106035369711819.4418)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('CSS \985E\5225')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\8981\5957\7528\81F3\5C0D\8A71\65B9\584A\5BB9\5668\7684\9078\64C7\6027 CSS \985E\5225.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106917926775379.4418)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\78BA\8A8D\6A19\7C64')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('\8F38\5165\78BA\8A8D\6309\9215\7684\6A19\7C64. \82E5\672A\63D0\4F9B, \5C07\6703\4F7F\7528\6587\5B57\8A0A\606F <code>APEX.DIALOG.OK</code> \7684\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106670847763561.4418)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\53D6\6D88\6A19\7C64')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('\8F38\5165\300C\53D6\6D88\300D\6309\9215\7684\6A19\7C64. \82E5\672A\63D0\4F9B, \5C07\6703\4F7F\7528\6587\5B57\8A0A\606F <code>APEX.DIALOG.CANCEL</code> \7684\503C.')
);
end;
/
prompt --application/shared_components/plugins/process_type/parse_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(668666822163400066.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PARSE_UPLOADED_DATA'
,p_display_name=>unistr('\5256\6790\4E0A\50B3\7684\8CC7\6599')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PARSE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\53EF\5256\6790\6E96\5099\8981\8F09\5165\73FE\6709\8868\683C\4E2D\4E4B\5DF2\6E96\5099\8A66\7B97\8868\8CC7\6599\7684\8655\7406\4F5C\696D. \9019\662F\7531\300C\5EFA\7ACB\9801\9762\7CBE\9748\300D\91DD\5C0D<em>\8CC7\6599\8F09\5165</em>\6240\7522\751F\7684\8655\7406\4F5C\696D\985E\578B.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668751414675407356.4418)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8CC7\6599\8F09\5165\5B9A\7FA9')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\5F9E\300C\5171\7528\5143\4EF6\300D\9078\53D6\5B9A\7FA9\8981\8F09\5165\4E4B\8868\683C\7684\300C\8CC7\6599\8F09\5165\5B9A\7FA9\300D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668863505241423607.4418)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5F9E\9805\76EE\532F\5165')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559\4E00\822C\4F7F\7528\8005\9078\64C7\4E4B<em>\532F\5165\4F86\6E90</em>\9078\9805\7684\9801\9762\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(714598810997211212.4418)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\5340\9694\7B26\865F\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559\4E00\822C\4F7F\7528\8005\8F38\5165\4E4B<em>\5340\9694\7B26\865F</em>\6587\5B57\7684\9801\9762\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(714603217923213191.4418)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\5206\754C\7B26\865F\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559\4E00\822C\4F7F\7528\8005\8F38\5165\4E4B<em>\5206\754C\7B26\865F (\9078\64C7\6027)</em>\6587\5B57\7684\9801\9762\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668904302255432174.4418)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\7B2C\4E00\500B\8CC7\6599\5217\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559\4E00\822C\4F7F\7528\8005\8F38\5165\4E4B<em>\7B2C\4E00\500B\8CC7\6599\5217\542B\6709\8CC7\6599\6B04\540D\7A31</em>\6838\53D6\65B9\584A\503C\7684\9801\9762\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668954022687438059.4418)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\5E63\5225\7B26\865F\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559\4E00\822C\4F7F\7528\8005\8F38\5165\4E4B<em>\5E63\5225\7B26\865F</em>\6587\5B57\7684\9801\9762\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668962228228439718.4418)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\7FA4\7D44\5340\9694\7B26\865F\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559\4E00\822C\4F7F\7528\8005\8F38\5165\4E4B<em>\7FA4\7D44\5340\9694\7B26\865F</em>\6587\5B57\7684\9801\9762\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668977904810442452.4418)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\5C0F\6578\9EDE\7B26\865F\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559\4E00\822C\4F7F\7528\8005\8F38\5165\4E4B<em>\5C0F\6578\9EDE\7B26\865F</em>\6587\5B57\7684\9801\9762\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668982211736444415.4418)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\6A94\6848\540D\7A31\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559\4E00\822C\4F7F\7528\8005\8F38\5165\4E4B<em>\6A94\6848\540D\7A31</em>\503C\7684\9801\9762\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669001326628448680.4418)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\8907\88FD\4E26\8CBC\4E0A\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559\4E00\822C\4F7F\7528\8005\8F38\5165\4E4B<em>\8907\88FD\4E26\8CBC\4E0A\5206\9694\7684\65E5\671F</em>\6587\5B57\7684\9801\9762\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24234014577732260.4418)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\5B57\5143\96C6\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('\8F38\5165\4FDD\7559\4E00\822C\4F7F\7528\8005\9078\53D6\4E4B<em>\6A94\6848\5B57\5143\96C6</em>\7684\9801\9762\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(48837321936282082.4418)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\65E5\671F\683C\5F0F\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559\4E00\822C\4F7F\7528\8005\8F38\5165\4E4B<em>\65E5\671F\683C\5F0F</em>\6587\5B57\7684\9801\9762\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
end;
/
prompt --application/shared_components/plugins/region_type/data_upload_column_mapping
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669051019271465508.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_display_name=>unistr('\8CC7\6599\4E0A\50B3\8CC7\6599\6B04\5C0D\61C9')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DATA_UPLOAD_COLUMN_MAPPING'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\5C07\5DF2\4E0A\50B3\7684\8A66\7B97\8868\8CC7\6599\6B04\5C0D\61C9\81F3\8868\683C\8CC7\6599\6B04. \9019\662F\7531\300C\5EFA\7ACB\9801\9762\7CBE\9748\300D\91DD\5C0D<em>\8CC7\6599\8F09\5165</em>\6240\7522\751F\7684\5340\57DF\985E\578B.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669071925851467433.4418)
,p_plugin_id=>wwv_flow_api.id(669051019271465508.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8CC7\6599\8F09\5165\5B9A\7FA9')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\9078\53D6<em>\8CC7\6599\8F09\5165</em>\8655\7406\4F5C\696D\4E2D\5B9A\7FA9\7684\300C\8CC7\6599\8F09\5165\5B9A\7FA9\300D.')
);
end;
/
prompt --application/shared_components/plugins/process_type/prepare_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669101621133475493.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PREPARE_UPLOADED_DATA'
,p_display_name=>unistr('\6E96\5099\4E0A\50B3\7684\8CC7\6599')
,p_supported_ui_types=>'DESKTOP:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PREPARE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\53EF\6E96\5099\5C07\4E0A\50B3\81F3\73FE\6709\8868\683C\4E2D\4E4B\8A66\7B97\8868\8CC7\6599\7684\8655\7406\4F5C\696D. \9019\662F\7531\300C\5EFA\7ACB\9801\9762\7CBE\9748\300D\91DD\5C0D<em>\8CC7\6599\8F09\5165</em>\6240\7522\751F\7684\8655\7406\4F5C\696D\985E\578B.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(670229105709707629.4418)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8CC7\6599\8F09\5165\5B9A\7FA9')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\5F9E\300C\5171\7528\5143\4EF6\300D\9078\53D6\5B9A\7FA9\8981\8F09\5165\4E4B\8868\683C\7684\300C\8CC7\6599\8F09\5165\5B9A\7FA9\300D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380468155644060156.4418)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\63D2\5165\8A08\6578\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559\8981\63D2\5165\4E4B\8A18\9304\7B46\6578\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380468974968063264.4418)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\66F4\65B0\8A08\6578\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559\8981\66F4\65B0\4E4B\8A18\9304\7B46\6578\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380469514614067903.4418)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\932F\8AA4\8A08\6578\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559\542B\6709\932F\8AA4\4E4B\8A18\9304\7B46\6578\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380470030664073278.4418)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\8907\67E5\8A08\6578\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559\5DF2\8907\67E5\4E4B\8A18\9304\7B46\6578\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
end;
/
prompt --application/shared_components/plugins/process_type/load_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669285217502512352.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'LOAD_UPLOADED_DATA'
,p_display_name=>unistr('\8F09\5165\4E0A\50B3\7684\8CC7\6599')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','LOAD_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\53EF\5C07\5DF2\5256\6790\7684\8A66\7B97\8868\8CC7\6599\8F09\5165\73FE\6709\8868\683C\6216\8996\89C0\8868\4E2D\7684\8655\7406\4F5C\696D. \9019\662F\7531\300C\5EFA\7ACB\9801\9762\7CBE\9748\300D\91DD\5C0D<em>\8CC7\6599\8F09\5165</em>\6240\7522\751F\7684\8655\7406\4F5C\696D\985E\578B.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669308626852514974.4418)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8CC7\6599\8F09\5165\5B9A\7FA9')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\5F9E\300C\5171\7528\5143\4EF6\300D\9078\53D6\5B9A\7FA9\8981\8F09\5165\4E4B\8868\683C\7684\300C\8CC7\6599\8F09\5165\5B9A\7FA9\300D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669317208629519157.4418)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\63D2\5165\8A08\6578\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\4FDD\7559\5DF2\63D2\5165\4E4B\8A18\9304\7B46\6578\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.'),
unistr('\60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669321513477520652.4418)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\66F4\65B0\8A08\6578\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\4FDD\7559\5DF2\66F4\65B0\4E4B\8A18\9304\7B46\6578\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.'),
unistr('\60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669325819364522297.4418)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\932F\8AA4\8A08\6578\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\4FDD\7559\542B\6709\932F\8AA4\4E4B\8A18\9304\7B46\6578\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.'),
unistr('\60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(208350031209048901.4418)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\8907\67E5\8A08\6578\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\4FDD\7559\5DF2\8907\67E5\4E4B\8A18\9304\7B46\6578\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.'),
unistr('\60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/apex_accounts
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707619648734994478.4418)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'APEX_ACCOUNTS'
,p_display_name=>unistr('Application Express \5E33\6236')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','APEX_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>\8F38\5165\60A8 &PRODUCT_NAME. \5E33\6236\7684\4F7F\7528\8005\540D\7A31\548C\5BC6\78BC. \6BCF\500B\5DE5\4F5C\5340\90FD\6709\81EA\5DF1\7684\4F7F\7528\8005\5E33\6236\5132\5B58\5340\57DF. \60A8\767B\5165\7684\61C9\7528\7A0B\5F0F\5C6C\65BC\5DE5\4F5C\5340 &amp;F4155_WORKSPACE_NAME.. \8ACB\8A18\4F4F, \5BC6\78BC\5340\5206\5927\5C0F\5BEB.</p>')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/open_door
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707675753928996044.4418)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'OPEN_DOOR'
,p_display_name=>unistr('Open Door \8B49\660E\8CC7\6599')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','OPEN_DOOR'),'')
,p_api_version=>1
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\53EF\8B93\6240\6709\4EBA\5B58\53D6\60A8\7684\61C9\7528\7A0B\5F0F. \8ACB\8F38\5165\5728\6B64\968E\6BB5\4F5C\696D\4E2D\8B58\5225\60A8\70BA\61C9\7528\7A0B\5F0F\4F7F\7528\8005\7684 ID. \9019\5C07\6703\8A2D\5B9A APP_USER \8B8A\6578\503C.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/db_accounts
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707686311942002797.4418)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DB_ACCOUNTS'
,p_display_name=>unistr('\8CC7\6599\5EAB\5E33\6236')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DB_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\6B64\8A8D\8B49\914D\7F6E\8981\6C42\8CC7\6599\5EAB\4F7F\7528\8005 (\7DB1\8981) \9700\8981\5B58\5728\65BC\672C\6A5F\8CC7\6599\5EAB\4E2D. \4F7F\7528\6B64\65B9\6CD5\6642, \6703\4F7F\7528\8CC7\6599\5EAB\5E33\6236\7684\4F7F\7528\8005\540D\7A31\548C\5BC6\78BC\4F86\8A8D\8B49\4F7F\7528\8005.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ldap
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707764939992010930.4418)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'LDAP'
,p_display_name=>unistr('LDAP \76EE\9304')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','LDAP'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\4F7F\7528 LDAP \4F3A\670D\5668\7684\8A8D\8B49\8981\6C42\4F86\8A8D\8B49\4F7F\7528\8005/\5BC6\78BC.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708018036276066565.4418)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\4E3B\6A5F')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\60A8 LDAP \76EE\9304\4F3A\670D\5668\7684\4E3B\6A5F\540D\7A31.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708026427403073465.4418)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\9023\63A5\57E0')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('\60A8 LDAP \76EE\9304\4E3B\6A5F\7684\9023\63A5\57E0\865F\78BC. \9810\8A2D\503C\70BA 389.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708041750260080084.4418)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\4F7F\7528 SSL')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\64C7\662F\5426\4F7F\7528 SSL \4F86\9023\7D50\81F3 LDAP \76EE\9304. \5982\679C\9078\64C7\300CSSL \52A0\8A8D\8B49\300D, \5247\5FC5\9808\66FF &PRODUCT_NAME. \57F7\884C\8655\7406\8A2D\5B9A\4E00\500B\516C\4E8B\5305.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708049024764082165.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4418)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708053230651083932.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4418)
,p_display_sequence=>20
,p_display_value=>unistr('SSL \52A0\8A8D\8B49')
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708057433075084636.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\4E0D\4F7F\7528 SSL')
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708170045804107167.4418)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\8FA8\5225\540D\7A31 (DN) \5B57\4E32')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\7528\4EE5\5EFA\69CB DBMS_LDAP.SIMPLE_BIND_S \4E4B\5B8C\6574\8FA8\5225\540D\7A31 (DN) \5B57\4E32\7684\578B\5F0F (\82E5\4F7F\7528\7CBE\78BA\7684 DN), \6216\8005\8F38\5165\641C\5C0B\57FA\6E96 (\82E5\4F7F\7528\975E\7CBE\78BA\7684 DN). \53EF\4F7F\7528 <strong>%LDAP_USER%</strong> \4F5C\70BA\4F7F\7528\8005\540D\7A31\7684\9810\7559\4F4D\7F6E.  \4F8B\5982:'),
'<p>',
unistr('<strong>\7CBE\78BA\7684 DN</strong>'),
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
unistr('<strong>\975E\7CBE\78BA\7684 DN (\641C\5C0B\57FA\6E96)</strong>'),
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708104537708095412.4418)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\4F7F\7528\7CBE\78BA\7684\8FA8\5225\540D\7A31 (DN)')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\9078\64C7\300CLDAP \8FA8\5225\540D\7A31 (DN) \5B57\4E32\300D\662F\5B8C\5168\76F8\7B26\6216\4E0D\5B8C\5168\76F8\7B26. \82E5\70BA\4E0D\5B8C\5168\76F8\7B26,\300CLDAP \8FA8\5225\540D\7A31 (DN)\300D\5C31\662F\641C\5C0B\57FA\6E96, \60A8\5FC5\9808\8981\63D0\4F9B\300C\641C\5C0B\7BE9\9078\300D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708207443165115942.4418)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\641C\5C0B\7BE9\9078')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(708104537708095412.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\4E0D\662F\4F7F\7528\8FA8\5225\540D\7A31 (DN) \5B8C\5168\76F8\7B26\6642\7684\641C\5C0B\7BE9\9078. \8ACB\4F7F\7528 <strong>%LDAP_USER%</strong> \4F5C\70BA\4F7F\7528\8005\540D\7A31\7684\9810\7559\4F4D\7F6E. \4F8B\5982:'),
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708300825765129776.4418)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('LDAP \4F7F\7528\8005\540D\7A31\7DE8\8F2F\51FD\6578')
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\60A8\53EF\4EE5\63D0\4F9B\984D\5916\57F7\884C\7684\7A0B\5F0F\78BC, \5C07\4F7F\7528\8005\540D\7A31\8F49\63DB\6210\5B8C\5168\7B26\5408 LDAP \76EE\9304\9805\76EE\6216 LDAP \4F7F\7528\8005\540D\7A31\7684\683C\5F0F.'),
unistr('\9023\7D50\8B8A\6578 :USERNAME \5305\542B\4E00\822C\4F7F\7528\8005\6307\5B9A\7684\540D\7A31.'),
unistr('\4F8B\5982, \4E0B\5217\7A0B\5F0F\78BC\6703\547C\53EB\4E00\500B\5C07 DN \5B57\4E32\4E2D\6240\6709 "." \53D6\4EE3\70BA "_" \7684\51FD\6578:</p>'),
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
unistr('<p>&PRODUCT_NAME. \5C07\6703\6839\64DA\8A8D\8B49\5C6C\6027<strong>\4F7F\7528\8005\540D\7A31\9041\96E2</strong>, \9041\96E2\50B3\56DE\7684\4F7F\7528\8005\540D\7A31.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38288205752186126.4418)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\4F7F\7528\8005\540D\7A31\9041\96E2')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\53D6\4EE3 LDAP \8FA8\5225\540D\7A31\548C\641C\5C0B\5B57\4E32\4E2D\7684 <strong>%LDAP_USER%</strong> \4E4B\524D,'),
unistr('&PRODUCT_NAME. \53EF\4EE5\81EA\52D5\9041\96E2\4F7F\7528\8005\540D\7A31\4E2D\7684\7279\6B8A\5B57\5143.'),
'<p/>',
unistr('\53EF\80FD\7684\9041\96E2\898F\5247\5305\62EC:'),
'<ul>',
unistr('<li><strong>\6A19\6E96</strong>:'),
unistr('\6839\64DA RFC 4514 (\91DD\5C0D\8FA8\5225\540D\7A31) \548C RFC 4515 (\91DD\5C0D\641C\5C0B\5B57\4E32) \9041\96E2\7279\6B8A\5B57\5143.'),
unistr('\6B64\5916, \9084\6703\9041\96E2 Unicode \5B57\5143.'),
unistr('\9019\662F\6700\5B89\5168\7684\8A2D\5B9A\503C, \4F46\662F\53EF\80FD\6703\5C0E\81F4\90E8\5206 LDAP \4F3A\670D\5668\767C\751F\554F\984C.</li>'),
unistr('<li><strong>\50C5\7279\6B8A\5B57\5143</strong>:'),
unistr('\6839\64DA RFC 4514 (\91DD\5C0D\8FA8\5225\540D\7A31) \548C RFC 4515 (\91DD\5C0D\641C\5C0B\5B57\4E32) \9041\96E2\7279\6B8A\5B57\5143.'),
unistr('\4E0D\9041\96E2 Unicode \5B57\5143.</li>'),
unistr('<li><strong>\4E0D\9041\96E2</strong>:'),
unistr('\4E0D\9041\96E2\4EFB\4F55\5B57\5143.'),
unistr('\9664\975E\4F7F\7528\5DF2\9041\96E2\4F7F\7528\8005\540D\7A31\7684<strong>\4F7F\7528\8005\540D\7A31\7DE8\8F2F\51FD\6578</strong> '),
unistr('(\4F8B\5982, \4F7F\7528 apex_escape.ldap_dn \6216 apex_escape.ldap_search_filter),'),
unistr('\5426\5247\6B64\8A2D\5B9A\503C\53EF\80FD\4E0D\5B89\5168.</li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38288513717188434.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\6A19\6E96')
,p_return_value=>'STD'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38288919604190164.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\50C5\7279\6B8A\5B57\5143')
,p_return_value=>'ONLY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38289324453191614.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\7121\9041\96E2')
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ias_sso
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707826526617016488.4418)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'IAS_SSO'
,p_display_name=>'Oracle Application Server Single Sign-On'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','IAS_SSO'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\9019\6703\5C07\8A8D\8B49\59D4\6D3E\7D66\300COracle AS Single Sign-On (SSO) \4F3A\670D\5668\300D\9032\884C. \82E5\8981\4F7F\7528\6B64\8A8D\8B49\914D\7F6E, \60A8\7684\7DB2\7AD9\5FC5\9808\5DF2\7D93\5728 SSO \4F3A\670D\5668\8A3B\518A\70BA\5925\4F34\61C9\7528\7A0B\5F0F.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(707874032982027788.4418)
,p_plugin_id=>wwv_flow_api.id(707826526617016488.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5925\4F34\61C9\7528\7A0B\5F0F\540D\7A31')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\60A8\4F7F\7528 Oracle Application Server Single Sign-On \8A8D\8B49, \4E14\60A8\7684\61C9\7528\7A0B\5F0F\70BA\5728 SSO \8A3B\518A\7684\5925\4F34\61C9\7528\7A0B\5F0F, \8ACB\8F38\5165\60A8\5728 SSO \8A3B\518A\5925\4F34\61C9\7528\7A0B\5F0F\6642\6240\4F7F\7528\7684\540D\7A31.'),
'</p>',
'<p>',
unistr('\5982\679C\60A8\4F7F\7528 &PRODUCT_NAME. \4F5C\70BA\8A3B\518A\7684\5925\4F34\61C9\7528\7A0B\5F0F, \8ACB\5C07\6B64\6B04\4F4D\7559\767D.'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(477693327944088403.4418)
,p_plugin_id=>wwv_flow_api.id(707826526617016488.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('SSO \4F3A\670D\5668\767B\51FA URL')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>60
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\55AE\4E00\767B\5165\4F3A\670D\5668\7684\767B\51FA\8DEF\5F91, \4F8B\5982'),
'<em>https://login.example.com/sso/logout</em>.',
unistr('\767B\51FA\60A8\7684\61C9\7528\7A0B\5F0F\6642, &PRODUCT_NAME. \6703\4F7F\7528\6B64\503C, \4E32\63A5 ''?p_done_url='' \8207\61C9\7528\7A0B\5F0F\7684\767B\5165 URL, \4E26\4F7F\7528\7522\751F\7684 URL \767B\51FA\55AE\4E00\767B\5165, \7136\5F8C\518D\91CD\65B0\5C0E\5411\56DE\60A8\7684\61C9\7528\7A0B\5F0F.')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/dad
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707880052029033247.4418)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DAD'
,p_display_name=>unistr('\4E0D\8A8D\8B49')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DAD'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\63A5\53D7\76EE\524D\7684\8CC7\6599\5EAB\4F7F\7528\8005. \9019\53EF\4EE5\8207\4F7F\7528\57FA\672C\8A8D\8B49\7684 mod_plsql DAD \7D44\614B\642D\914D\4F7F\7528, \4EE5\8A2D\5B9A\8CC7\6599\5EAB\968E\6BB5\4F5C\696D\4F7F\7528\8005.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38519294499392621.4418)
,p_plugin_id=>wwv_flow_api.id(707880052029033247.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\4F7F\7528\8005\540D\7A31')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'nobody'
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165 &PRODUCT_NAME. \968E\6BB5\4F5C\696D\7684\4F7F\7528\8005\540D\7A31. \82E5\662F\7A7A\7684, \5247 &PRODUCT_NAME. \6703\4F7F\7528\8CC7\6599\5EAB\968E\6BB5\4F5C\696D\4F7F\7528\8005 (\901A\5E38\70BA APEX_PUBLIC_USER).')
);
end;
/
prompt --application/shared_components/plugins/region_type/css_calendar
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(716993259356536483.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CSS_CALENDAR'
,p_display_name=>unistr('\884C\4E8B\66C6')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CSS_CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5728\5404\7A2E\884C\4E8B\66C6\6AA2\8996\4E2D\986F\793A\57FA\65BC\65E5\671F\7684\9805\76EE. \5305\62EC\7D50\675F\65E5\671F\5F8C, \884C\4E8B\66C6\53EF\4EE5\986F\793A\6301\7E8C\6642\9593\5F0F\4E8B\4EF6. \5982\679C\555F\7528\300C\62D6\653E\529F\80FD\300D, \884C\4E8B\66C6\9084\53EF\4EE5\76F4\63A5\66F4\65B0\8A18\9304.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1992827406647874094.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Google \65E5\66C6 API \91D1\9470 [\5DF2\88AB\53D6\4EE3]')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\300CGoogle \65E5\66C6 API \91D1\9470\300D\8B93\6B64\61C9\7528\7A0B\5F0F\4E2D\7684\884C\4E8B\66C6\53EF\4EE5\6574\5408 Google \65E5\66C6\8CC7\6599.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716993576597543647.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>5
,p_prompt=>unistr('\958B\59CB\65E5\671F\8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('\9078\53D6\4FDD\7559\6B64\884C\4E8B\66C6\4E2D\986F\793A\4E4B\4E8B\4EF6\958B\59CB\65E5\671F\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716993872715545529.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\7D50\675F\65E5\671F\8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('\9078\53D6\4FDD\7559\6B64\884C\4E8B\66C6\4E2D\986F\793A\4E4B\4E8B\4EF6\7D50\675F\65E5\671F\7684\8CC7\6599\6B04. \5982\679C\6307\5B9A\6B64\5C6C\6027, \884C\4E8B\66C6\6703\986F\793A\6301\7E8C\6642\9593\5F0F\4E8B\4EF6.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994160638551031.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>2
,p_prompt=>unistr('\986F\793A\8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('\9078\53D6\4FDD\7559\6B64\884C\4E8B\66C6\4E2D\4E4B\4E8B\4EF6\986F\793A\6587\5B57\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994453521554330.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>12
,p_prompt=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2:NUMBER:ROWID'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\4FDD\7559\884C\4E8B\66C6\4E8B\4EF6\4E4B\4E3B\7D22\5F15\9375\503C\7684\8CC7\6599\6B04. \5982\679C\8868\683C\5177\6709\591A\90E8\5206\4E3B\7D22\5F15\9375, \8ACB\9078\53D6 <strong>ROWID</strong>.</p>'),
unistr('<p>\6B64\8CC7\6599\6B04\7684\503C\6703\5728 <code>APEX$PK_VALUE</code> \66FF\4EE3\8B8A\6578\4E2D\50B3\56DE. \60A8\53EF\4EE5\5728<em>\62D6\653E\7A0B\5F0F\78BC</em>\5C6C\6027\4E2D\4F7F\7528\6B64\8B8A\6578, \8B58\5225\5728\884C\4E8B\66C6\9032\884C\62D6\653E\4F5C\696D\5F8C\61C9\8A72\8981\66F4\65B0\7684\8A18\9304.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994772918560561.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>65
,p_prompt=>unistr('\6AA2\8996 / \7DE8\8F2F\9023\7D50')
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\8F38\5165\4F7F\7528\8005\6309\4E00\4E0B\73FE\6709\9805\76EE\6642\8981\547C\53EB\7684\76EE\6A19\9801\9762.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995064292564584.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\5EFA\7ACB\9023\7D50')
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\4F7F\7528\8005\6309\4E00\4E0B\7A7A\767D\5132\5B58\683C\6216\73FE\6709\884C\4E8B\66C6\9805\76EE\5916\90E8\6642\6240\8981\547C\53EB\7684\76EE\6A19\9801\9762.</p>'),
unistr('<p>\60A8\5FC5\9808\4F7F\7528\7279\6B8A\884C\4E8B\66C6\66FF\4EE3\8B8A\6578 <pre>&APEX$NEW_START_DATE.</pre> \548C <pre>&APEX$NEW_END_DATE.</pre>, \5C07\5F9E\884C\4E8B\66C6\9078\53D6\7684\65E5\671F\50B3\9001\5230\76EE\6A19\9801\9762.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995378729573099.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>45
,p_prompt=>unistr('\62D6\653E\529F\80FD')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(716994453521554330.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\5141\8A31\5C0D\6B64\884C\4E8B\66C6\9032\884C\62D6\653E\4F5C\696D.</p>'),
unistr('<p><em>\6CE8\610F: \5982\679C\555F\7528\62D6\653E\529F\80FD, \6709\6B0A\6AA2\8996\6B64\884C\4E8B\66C6\7684\6240\6709\4E00\822C\4F7F\7528\8005, \4E5F\6709\6B0A\66F4\65B0\884C\4E8B\66C6\9805\76EE.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995668377577896.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>55
,p_prompt=>unistr('\62D6\653E PL/SQL \7A0B\5F0F\78BC')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(716995378729573099.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\53EA\6709\958B\59CB\65E5\671F\7684\7BC4\4F8B (\91DD\5C0D\4E0D\662F\4EE5\6301\7E8C\6642\9593\70BA\57FA\790E\7684\4E8B\4EF6)</dt>'),
'<dd><pre>',
'begin',
'    update emp',
'       set hiredate = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS'')',
'     where empno = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
unistr('<dt>\6709\958B\59CB\8207\7D50\675F\65E5\671F\7684\7BC4\4F8B (\91DD\5C0D\4EE5\6301\7E8C\6642\9593\70BA\57FA\790E\7684\4E8B\4EF6)</dt>'),
'<dd><pre>',
'begin',
'    update projects',
'       set start_date = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS''),',
'           end_date = to_date(:APEX$NEW_END_DATE, ''YYYYMMDDHH24MISS'')',
'     where id = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\884C\4E8B\66C6\9805\76EE\82E5\4F7F\7528\62D6\653E\529F\80FD\66F4\65B0\6642, \7528\4F86\66F4\65B0\76F8\95DC\8868\683C\6216\53EF\66F4\65B0\8996\89C0\8868\7684 PL/SQL \7A0B\5F0F\78BC.</p>'),
unistr('<p>\5982\679C\6B64\884C\4E8B\66C6\986F\793A\6301\7E8C\6642\9593\5F0F\4E8B\4EF6 (\900F\904E\9078\53D6\300C\7D50\675F\65E5\671F\300D\8CC7\6599\6B04), \5247 PL/SQL \7A0B\5F0F\78BC\4E5F\9700\8981\66F4\65B0\9019\500B\503C. \5982\679C\62D6\66F3\6574\500B\4E8B\4EF6, \5247\7531\300C\7D50\675F\65E5\671F\300D\7DAD\8B77\76EE\524D\7684\6301\7E8C\6642\9593. \5982\679C\62D6\66F3\4E8B\4EF6\7684\7D50\5C3E, \5247\6703\66F4\65B0\4E8B\4EF6\7684\6301\7E8C\6642\9593. \5728\6B64\985E\60C5\6CC1\4E2D, \958B\59CB\65E5\671F\5C07\7DAD\6301\4E0D\8B8A, \4F46\662F\6703\66F4\65B0\7D50\675F\65E5\671F\4EE5\53CD\6620\4FEE\8A02\5F8C\7684\6301\7E8C\6642\9593.</p>'),
unistr('<p>\884C\4E8B\66C6\66FF\4EE3\8B8A\6578\5305\62EC:</p>'),
'<dl>',
'  <dt>APEX$NEW_START_DATE</dt>',
unistr('    <dd>\50B3\56DE\4FEE\8A02\5F8C\7684\958B\59CB\65E5\671F. \5373\4F7F\6B64\884C\4E8B\66C6\7684<em>\986F\793A\6642\9593</em>\70BA<strong>\5426</strong>, \65E5\671F\683C\5F0F\4ECD\6703\662F <code>''YYYYMMDDHH24MISS''</code>.</dd>'),
'  <dt>APEX$NEW_END_DATE</dt>',
unistr('    <dd>\50B3\56DE\6301\7E8C\6642\9593\5F0F\4E8B\4EF6\7684\4FEE\8A02\5F8C\7D50\675F\65E5\671F. \5373\4F7F\6B64\884C\4E8B\66C6\7684<em>\986F\793A\6642\9593</em>\70BA<strong>\5426</strong>, \65E5\671F\683C\5F0F\4ECD\6703\662F <code>''YYYYMMDDHH24MISS''</code>.</dd>'),
'  <dt>APEX$PK_VALUE</dt>',
unistr('    <dd>\50B3\56DE\300C\4E3B\7D22\5F15\9375\8CC7\6599\6B04\300D\4E2D\6307\5B9A\4E4B\8CC7\6599\6B04\7684\503C.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995977422588893.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>40
,p_prompt=>unistr('\5176\4ED6\884C\4E8B\66C6\6AA2\8996')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'list:navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\8981\986F\793A\7684\5176\4ED6\884C\4E8B\66C6\6AA2\8996. \4E00\5F8B\6703\986F\793A\6708\6AA2\8996.</p>'),
unistr('<p>\6CE8\610F:\300C\986F\793A\6642\9593\300D\82E5\6307\5B9A\70BA<strong>\5426</strong>, \5C31\4E0D\6703\986F\793A\300C\9031\300D\548C\300C\65E5\300D\6AA2\8996.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(484632936569874213.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(716995977422588893.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\6E05\55AE')
,p_return_value=>'list'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(484633358657877168.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(716995977422588893.4418)
,p_display_sequence=>50
,p_display_value=>unistr('\5C0E\89BD')
,p_return_value=>'navigation'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716997678919603353.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\532F\51FA')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\64C7\884C\4E8B\66C6\7684\5E95\7AEF\6240\63D0\4F9B\7684\532F\51FA\9023\7D50.</p>'),
unistr('<p><em>\6CE8\610F: \9019\6703\532F\51FA\76EE\524D\986F\793A\7684\6240\6709\884C\4E8B\66C6\9805\76EE, \800C\4E0D\662F\55AE\4E00\884C\4E8B\66C6\9805\76EE.</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716999168568608195.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4418)
,p_display_sequence=>10
,p_display_value=>'CSV'
,p_return_value=>'CSV'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716997976116604645.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4418)
,p_display_sequence=>30
,p_display_value=>'iCal'
,p_return_value=>'ICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716998373959605713.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4418)
,p_display_sequence=>40
,p_display_value=>'XML'
,p_return_value=>'XML'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716999779985618067.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>40
,p_prompt=>unistr('\884C\4E8B\66C6\6AA2\8996\8207\5C0E\89BD')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'month:week:day:list:navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9078\53D6\8981\986F\793A\7684\884C\4E8B\66C6\6AA2\8996. \81F3\5C11\5FC5\9808\9078\53D6<strong>\5929</strong>\3001<strong>\9031</strong>\6216<strong>\6708</strong>\5176\4E2D\4E00\9805. \82E5\672A\9078\53D6, \884C\4E8B\66C6\5C07\6703\81EA\52D5\986F\793A<strong>\6708</strong>\6AA2\8996.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(772524462334484489.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\6708\4EFD')
,p_return_value=>'month'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717000472653621483.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\9031')
,p_return_value=>'week'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717000871143622145.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\5929')
,p_return_value=>'day'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(696140132483024062.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4418)
,p_display_sequence=>35
,p_display_value=>unistr('\6E05\55AE')
,p_return_value=>'list'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717001267693623757.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\5C0E\89BD')
,p_return_value=>'navigation'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(718537383340695404.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('Google \65E5\66C6 ID')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(5924531429537178.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'3'
,p_examples=>unistr('<p>Google \65E5\66C6 ID : abc123@group.calendar.google.com</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\8981\5728\6B64\884C\4E8B\66C6\4E2D\986F\793A\4E4B\884C\4E8B\66C6\8CC7\6599\994B\9001\7684\300CGoogle \65E5\66C6 ID\300D.</p>'),
unistr('<p>\7531\65BC Google \884C\4E8B\66C6\7684\5B89\5168\9650\5236, \9019\4E9B\884C\4E8B\66C6\5FC5\9808\662F\516C\7528\884C\4E8B\66C6, \6216\8005\53EF\4F9B\6B64\884C\4E8B\66C6\7684\6240\6709\4E00\822C\4F7F\7528\8005\4F7F\7528.</p>'),
unistr('<p><em>\6CE8\610F: \5FC5\9808\8F38\5165\300CGoogle \65E5\66C6 API \91D1\9470\300D, Google \884C\4E8B\66C6\624D\80FD\6B63\5E38\904B\4F5C.  \8ACB\524D\5F80\300C\5171\7528\7684\5143\4EF6\300D>\300C\5143\4EF6\8A2D\5B9A\503C\300D>\300C\884C\4E8B\66C6\300D\4EE5\8A2D\5B9A\61C9\7528\7A0B\5F0F\7684\91D1\9470.</em</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(739025333221911743.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>15
,p_prompt=>unistr('\986F\793A\6642\9593')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\662F\5426\61C9\8A72\986F\793A\65E5\671F\7684\6642\9593\90E8\5206. </p>'),
unistr('<p>\53EA\6709\5728\300C\986F\793A\6642\9593\300D\8A2D\70BA<strong>\662F</strong>\6642, \624D\6703\986F\793A\300C\9031\300D\548C\300C\65E5\300D\6AA2\8996. \5982\679C\958B\59CB\65E5\671F\6216\7D50\675F\65E5\671F\8CC7\6599\6B04\672A\5305\62EC\6642\9593\5143\4EF6, \5247\9019\4E9B\8CC7\6599\6B04\6703\986F\793A\51CC\6668 12:00.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(163693512506908039.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>80
,p_prompt=>unistr('CSS \985E\5225')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6839\64DA\5C08\6848\72C0\614B\8A2D\5B9A\884C\4E8B\66C6\6A23\5F0F</p>'),
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6\7528\4F86\4FDD\5B58\8A2D\5B9A\6B64\884C\4E8B\66C6\4E2D\986F\793A\4E4B\4E8B\4EF6\6A23\5F0F\7684\300CCSS \985E\5225\300D\7684\8CC7\6599\6B04. <br>'),
unistr('\6709\8A31\591A\9810\8A2D\985E\5225\53EF\4F9B\4F7F\7528:'),
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
unistr('\8ACB\53C3\95B1\6709\95DC\65B0\589E\5176\4ED6 CSS \985E\5225\7684\6587\4EF6.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2604378152305541.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('REST Web \670D\52D9 (JSON)')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(5924531429537178.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'3'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\884C\4E8B\66C6\4E2D\8981\986F\793A\4E4B\300CRESTful Web \670D\52D9\300D\994B\9001\7684 URL. \884C\4E8B\66C6\53EF\4EE5\5448\73FE\5F9E\5916\90E8\4F86\6E90 (\4F8B\5982 Oracle REST Data Services) \64F7\53D6\7684 JSON \8CC7\6599. \9019\4E9B Web \670D\52D9\5FC5\9808\662F\516C\7528\7684, \6216\8005\53EF\4F9B\6B64\884C\4E8B\66C6\7684\6240\6709\4E00\822C\4F7F\7528\8005\4F7F\7528.</p>'),
unistr('<p>JSON \994B\9001\5FC5\9808\7D93\904E\683C\5F0F\5316\4E26\5305\62EC:</p>'),
'<ol>',
unistr('<li>\4E8B\4EF6\6E05\55AE\9663\5217, \5176\5167\5BB9\5305\542B - <code>items</code></li>'),
unistr('<li>\6BCF\500B\4E8B\4EF6\7269\4EF6, \5176\5167\5BB9\5305\542B - <code>{ id, title, start, allday, end, description }</code><br>title \548C start \70BA\5FC5\8981\5C6C\6027.</li>'),
'</ol>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2604471144293543.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>30
,p_prompt=>unistr('\88DC\5145\8CC7\8A0A')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_examples=>'&EMPNO.'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\300C\6E05\55AE\6AA2\8996\300D\53CA\300C\5DE5\5177\63D0\793A\300D\4E2D\6240\986F\793A\7684\5176\4ED6 HTML. \4F7F\7528 &COLUMN. \8A9E\6CD5, \4EE5 HTML \683C\5F0F\986F\793A\8CC7\6599\6B04\503C. </p>'),
unistr('<p>\6CE8\610F:\300C\986F\793A\5DE5\5177\63D0\793A\300D\5FC5\9808\8A2D\70BA<strong>\662F</strong>, \6B64\88DC\5145\8CC7\8A0A\624D\6703\986F\793A\5728\300C\6708\300D\3001\300C\9031\300D\53CA\300C\65E5\300D\6AA2\8996\4E2D.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(491266533374023782.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>75
,p_prompt=>unistr('\986F\793A\9031\672B')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\9078\53D6\662F\5426\5728\6B64\884C\4E8B\66C6\986F\793A\300C\661F\671F\516D\300D\548C\300C\661F\671F\65E5\300D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(518889601605918244.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>20
,p_prompt=>unistr('\6642\9593\683C\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'00'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9078\53D6\986F\793A\6B64\884C\4E8B\66C6\4E8B\4EF6\7684\6642\9593\90E8\5206\6642\6240\4F7F\7528\7684\6642\9593\683C\5F0F.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518893959287938933.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\9810\8A2D')
,p_return_value=>'00'
,p_help_text=>unistr('\4F7F\7528\5728\300C\5168\7403\5316\300D\4E4B\4E0B\8F38\5165\7684\61C9\7528\7A0B\5F0F\6642\6233\683C\5F0F. \82E5\672A\586B\5165\6B64\5C6C\6027, \5247\5C07\4F7F\7528\8CC7\6599\5EAB NLS \8A2D\5B9A\503C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518914467554939737.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4418)
,p_display_sequence=>20
,p_display_value=>unistr('12 \5C0F\6642\5236')
,p_return_value=>'12'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528 12 \5C0F\6642\5236\6642\9418\986F\793A\6642\9593, \5305\62EC a.m. (\4F86\81EA\62C9\4E01\6587 <em>ante meridiem</em>, \610F\70BA\4E2D\5348\4E4B\524D) \8207 p.m. (<em>post meridiem</em>, \610F\70BA\4E2D\5348\4E4B\5F8C), \4F8B\5982 8:00 a.m. \8207 4:00 p.m.</p>'),
unistr('<p>a.m./p.m. \7684\5BE6\969B\986F\793A\683C\5F0F (\50CF\662F\5927\5C0F\5BEB\8207\53E5\9EDE) \884D\751F\81EA\300C\6642\6233\683C\5F0F\300D.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518914796377940460.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4418)
,p_display_sequence=>30
,p_display_value=>unistr('24 \5C0F\6642\5236')
,p_return_value=>'24'
,p_help_text=>unistr('\4F7F\7528 24 \5C0F\6642\5236\6642\9418\986F\793A\6642\9593, \4F8B\5982 08:00 \8207 16:00.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(623002076135066927.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>35
,p_prompt=>unistr('\986F\793A\5DE5\5177\63D0\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\662F\5426\5728\4F7F\7528\8005\505C\7559\65BC\6B64\884C\4E8B\66C6\7684\4E8B\4EF6\6642\986F\793A\5DE5\5177\63D0\793A.</p>'),
unistr('<p><em>\4E0B\62C9\5F0F\5C0D\8A71\65B9\584A\5C07\6703\986F\793A\4E8B\4EF6\540D\7A31\3001\88DC\5145\8CC7\8A0A\548C\65E5\671F\8A73\7D30\8CC7\8A0A.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(673441164964154995.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>25
,p_prompt=>unistr('\7B2C 1 \500B\5C0F\6642')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'9'
,p_display_length=>2
,p_max_length=>2
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\8F38\5165 0 \8207 23 \4E4B\9593\7684\6574\6578, \4EE5\6307\5B9A\5728\300C\9031\300D\548C\300C\65E5\300D\884C\4E8B\66C6\4E0A\6240\986F\793A\7684\7B2C\4E00\500B\5C0F\6642.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1218336983535257968.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>70
,p_prompt=>unistr('\4E8B\4EF6\4E0A\9650/\5929')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>2
,p_max_length=>2
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\300C\6708\300D\6AA2\8996\5167\6BCF\5929\986F\793A\7684\4E8B\4EF6\6578\4E0A\9650. </p>'),
unistr('<p>\5982\679C\67D0\4E00\5929\7684\4E8B\4EF6\6578\8D85\904E\6307\5B9A\7684\4E8B\4EF6\6578, \5247\8A72\5929\5C07\5305\62EC<strong>\5176\4ED6...</strong>. \6309\4E00\4E0B\6B64\9805\76EE\5C07\6703\986F\793A\5373\73FE\5F0F\8996\7A97, \5176\4E2D\5305\542B\8A72\5929\7684\6240\6709\4E8B\4EF6.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2080058124058207989.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>32
,p_prompt=>unistr('\591A\884C\4E8B\4EF6')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6<strong>\662F</strong>\8B93\4E8B\4EF6\6839\64DA\300C\986F\793A\8CC7\6599\6B04\300D\6587\5B57\7684\9577\5EA6, \4EE5\591A\884C\986F\793A. </p>'),
unistr('<p>\5982\679C\60A8\8981\4E00\884C\986F\793A\4E00\500B\4E8B\4EF6, \4E26\5C07\4E0D\7B26\5408\986F\793A\9577\5EA6\7684\6587\5B57\622A\65B7, \8ACB\9078\53D6<strong>\5426</strong>. \5B8C\6574\6587\5B57\5C07\6703\986F\793A\5728\5DE5\5177\63D0\793A\4E2D.</p>'),
unistr('<p>\6CE8\610F: \53EA\6709\300C\6708\300D\6AA2\8996\5167\6703\4F7F\7528\591A\884C\4E8B\4EF6\8A2D\5B9A\503C. \82E5\70BA\300C\9031\300D\548C\300C\65E5\300D\6AA2\8996, \5247\7531\4E8B\4EF6\7684\6301\7E8C\6642\9593\6C7A\5B9A\6240\986F\793A\4E8B\4EF6\7684\9AD8\5EA6.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(5924531429537178.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>1
,p_prompt=>unistr('\7248\672C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'FullCalendar 5'
,p_deprecated_values=>'3'
,p_help_text=>unistr('<p>FullCalendar 3 \5DF2\4E0D\518D\4F7F\7528, \5F88\5FEB\5C31\6703\7531 FullCalendar 5 \53D6\4EE3. \70BA\4E86\4E0D\8B93\60A8\7684\61C9\7528\7A0B\5F0F\9762\81E8\672A\4F86\7248\672C\4E2D\65B7\7684\98A8\96AA, \73FE\5728\662F\9032\884C\6B64\8B8A\63DB\7684\6700\4F73\6642\6A5F. \82E5\60A8\5DF2\4F7F\7528\4EFB\4E00\81EA\8A02\300C\521D\59CB\5316 Javascript \7A0B\5F0F\78BC\300D, \5247\8ACB\6CE8\610F FullCalendar \7684 API \5DF2\8B8A\66F4, \56E0\6B64\60A8\7684\7A0B\5F0F\78BC\5F88\53EF\80FD\9700\8981\8ABF\6574.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(5925071337539542.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(5924531429537178.4418)
,p_display_sequence=>10
,p_display_value=>unistr('FullCalendar 3 [\5DF2\88AB\53D6\4EE3]')
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(848019138346305412.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function ( pOptions) {',
'    pOptions.titleFormat      = "[Conference Schedule]";                                // custom title',
'    pOptions.slotMinTime      = "07:00:00";                                             // hide slots before minTime',
'    pOptions.slotMaxTime      = "18:00:00";                                             // hide slots after maxTime',
'    pOptions.dayHeaderFormat  = { weekday: ''short'', month: ''numeric'', day: ''numeric'' }; // week view column headings',
'    pOptions.slotDuration     = "00:15:00";                                             // custom slot duration',
'    pOptions.weekNumbers      = true;                                                   // show week numbers',
'    pOptions.weekText         = "CW";                                    ',
'    return pOptions;',
'}',
'</pre>'))
,p_help_text=>unistr('\8F38\5165\4E00\500B\8986\5BEB\6A19\6E96 FullCalendar \521D\59CB\5316\5C6C\6027\7684 JavaScript \51FD\6578. \6B64\51FD\6578\5FC5\9808\50B3\56DE\4E00\500B\5305\542B\884C\4E8B\66C6\521D\59CB\5316\5C6C\6027\4F5C\70BA\53C3\6578\7684\7269\4EF6.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(236983483525335070.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6839\64DA\5C08\6848\72C0\614B\8A2D\5B9A\884C\4E8B\66C6\6A23\5F0F</p>,'),
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\7528\4F86\4FDD\5B58\8A2D\5B9A\6B64\884C\4E8B\66C6\4E2D\986F\793A\4E4B\4E8B\4EF6\6A23\5F0F\7684\300CCSS \985E\5225\300D\7684\8CC7\6599\6B04. '),
unistr('\6709\8A31\591A\9810\8A2D\985E\5225\53EF\4F9B\4F7F\7528:</p>'),
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
unistr('<p>\8ACB\53C3\95B1\6709\95DC\65B0\589E\5176\4ED6 CSS \985E\5225\7684\6587\4EF6.</p>')))
);
end;
/
begin
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493100634228105571.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_name=>'apexcalendardateselect'
,p_display_name=>unistr('\65E5\671F\5DF2\9078\53D6')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493100238395105571.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_name=>'apexcalendareventselect'
,p_display_name=>unistr('\4E8B\4EF6\5DF2\9078\53D6')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493099818743105570.4418)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4418)
,p_name=>'apexcalendarviewchange'
,p_display_name=>unistr('\6AA2\8996\5DF2\8B8A\66F4')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_delete
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723477031014918732.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_DELETE'
,p_display_name=>unistr('\5217\8868\5316\8868\55AE - \522A\9664\591A\91CD\8CC7\6599\5217')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_DELETE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\53EF\522A\9664\300C\5217\8868\5316\8868\55AE\300D\5340\57DF\4E4B\591A\500B\8CC7\6599\5217\7684\8655\7406\4F5C\696D.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477251489924376.4418)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8868\683C\64C1\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\9078\53D6\8868\683C\64C1\6709\8005 (\7DB1\8981) \540D\7A31.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477545882927054.4418)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\683C\540D\7A31')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477251489924376.4418)
,p_help_text=>unistr('\8F38\5165\6709\5927\5C0F\5BEB\4E4B\5225\7684\8868\683C\6216\53EF\66F4\65B0\8996\89C0\8868\540D\7A31. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477835530931825.4418)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477545882927054.4418)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\5167\542B\4E3B\7D22\5F15\9375\503C\7684\8CC7\6599\6B04. \5982\679C\8868\683C\6709\591A\500B\5169\90E8\5206\4E3B\7D22\5F15\9375, \8ACB\9078\53D6 <strong>ROWID</strong>.</p>'),
unistr('<p>\4E3B\7D22\5F15\9375\4E3B\8981\7528\4F86\8B58\5225\5217\8868\5316\8868\55AE\4E2D\8981\522A\9664\4E14\7D55\5C0D\4E0D\80FD\7DE8\8F2F\7684\8CC7\6599\5217. \65B0\8CC7\6599\5217\7684\4E3B\7D22\5F15\9375\503C\5FC5\9808\662F\7A7A\767D\7684.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723478159456935961.4418)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6B21\8981\7D22\5F15\9375\8CC7\6599\6B04')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477545882927054.4418)
,p_help_text=>unistr('\9078\53D6\5167\542B\6B21\8981\4E3B\7D22\5F15\9375\503C\7684\8CC7\6599\6B04. \5982\679C\60A8\7684\4E3B\7D22\5F15\9375\7531\5169\500B\6B04\4F4D\7D44\6210, \624D\61C9\8A72\586B\5165\6B64\5C6C\6027.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723478847798956469.4418)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\7A0B\5F0F\5BE6\969B\57F7\884C Where \5B50\53E5')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4F7F\7528\4E0B\5217\7A0B\5F0F\78BC\9650\5236\90E8\9580:'),
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('\8F38\5165\8981\9644\52A0\81F3\7522\751F\4E4B DELETE \6558\8FF0\53E5\7684 SQL WHERE \5B50\53E5. \60A8\53EF\4EE5\4F7F\7528\6B64\5C6C\6027\4F86\9650\5236\81EA\52D5\7522\751F\4E4B SQL \547C\53EB\5167\4F7F\7528\7684\8A18\9304.')
);
end;
/
prompt --application/shared_components/plugins/process_type/user_preferences
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723624323202892766.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'USER_PREFERENCES'
,p_display_name=>unistr('\4F7F\7528\8005\504F\597D\8A2D\5B9A')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','USER_PREFERENCES'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\53EF\8A2D\5B9A\4E00\822C\4F7F\7528\8005\4E4B\300C\4F7F\7528\8005\504F\597D\8A2D\5B9A\300D\7684\8655\7406\4F5C\696D.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723624639568915612.4418)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'RESET_USER_PREFERENCES'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\4E00\500B\8655\7406\4F5C\696D\985E\578B\4EE5\91CD\8A2D\6216\8A2D\5B9A\4F7F\7528\8005\504F\597D\8A2D\5B9A.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723626924903922340.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\91CD\8A2D\504F\597D\8A2D\5B9A (\79FB\9664\76EE\524D\4F7F\7528\8005\7684\6240\6709\504F\597D\8A2D\5B9A)')
,p_return_value=>'RESET_USER_PREFERENCES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723627321668923828.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\8A2D\70BA\9805\76EE\503C')
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723627719296924995.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\5982\679C\4E0D\662F\7A7A\503C\5247\8A2D\70BA\9805\76EE\503C')
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723631645557973527.4418)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\504F\597D\8A2D\5B9A\540D\7A31')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723624639568915612.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_text_case=>'UPPER'
,p_help_text=>unistr('\8F38\5165\504F\597D\8A2D\5B9A\540D\7A31.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723631934127978868.4418)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723624639568915612.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_help_text=>unistr('\9078\53D6\4FDD\7559\504F\597D\8A2D\5B9A\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723640922660606468.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS'
,p_display_name=>unistr('\81EA\52D5\8CC7\6599\5217\8655\7406  (DML)')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\53EF\5728\55AE\4E00\8CC7\6599\5EAB\8868\683C\6216\53EF\66F4\65B0\8996\89C0\8868\4E2D\63D2\5165\3001\66F4\65B0\6216\522A\9664\8A18\9304\7684\8655\7406\4F5C\696D. \6B64\8655\7406\4F5C\696D\4E3B\8981\7528\4F86\8655\7406\4F86\6E90\70BA<strong>\8CC7\6599\5EAB\8CC7\6599\6B04</strong>\985E\578B\7684\8868\55AE\9805\76EE. \91DD\5C0D\6B64\8655\7406\4F5C\696D\8F38\5165\7684\5C6C\6027\5FC5\9808\8207<em>\81EA\52D5\8CC7\6599\5217\64F7\53D6</em>\8655\7406\4F5C\696D\4E2D\8F38\5165\7684\5C6C\6027\76F8\95DC\806F.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641240116613584.4418)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8868\683C\64C1\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\9078\53D6\8868\683C\64C1\6709\8005 (\7DB1\8981) \540D\7A31.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641536018615468.4418)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\683C\540D\7A31')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641240116613584.4418)
,p_help_text=>unistr('\8F38\5165\6709\5927\5C0F\5BEB\4E4B\5225\7684\8868\683C\6216\8996\89C0\8868\540D\7A31. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641830196618138.4418)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('\4E3B\7D22\5F15\9375\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559\4E3B\7D22\5F15\9375\8CC7\6599\6B04\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642126745619762.4418)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641536018615468.4418)
,p_help_text=>unistr('\9078\53D6\5167\542B\4E3B\7D22\5F15\9375\503C\7684\8CC7\6599\6B04. \5982\679C\8868\683C\6709\591A\500B\5169\90E8\5206\4E3B\7D22\5F15\9375, \8ACB\9078\53D6 <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642422001622013.4418)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('\6B21\8981\7D22\5F15\9375\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723642713590625893.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\8F38\5165\4FDD\7559\6B21\8981\7D22\5F15\9375\8CC7\6599\6B04\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642713590625893.4418)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('\6B21\8981\7D22\5F15\9375\8CC7\6599\6B04')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641536018615468.4418)
,p_depending_on_attribute_id=>wwv_flow_api.id(723642126745619762.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('\9078\53D6\5167\542B\6B21\8981\4E3B\7D22\5F15\9375\503C\7684\8CC7\6599\6B04. \5982\679C\60A8\7684\4E3B\7D22\5F15\9375\7531\5169\500B\6B04\4F4D\7D44\6210, \624D\61C9\8A72\586B\5165\6B64\5C6C\6027.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723646536850919017.4418)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\8CC7\6599\5217\7248\672C\8CC7\6599\6B04')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\8B58\5225\8CC7\6599\5217\7248\672C\7684\8CC7\6599\6B04, \6B64\8CC7\6599\6B04\4E0D\9700\8981\5728\9801\9762\4E2D\986F\793A. \82E5\8981\4F7F\7528\5167\5EFA\7684\7E3D\548C\6AA2\9A57, \8ACB\5C07\6B64\5C6C\6027\7559\767D.</p>'),
unistr('<p>\6295\6A5F\5F0F\9396\5B9A\529F\80FD\4F7F\7528\907A\5931\7684\66F4\65B0\5075\6E2C\4F86\78BA\4FDD\53EF\4E26\884C\5B58\53D6\8CC7\6599\4E4B\61C9\7528\7A0B\5F0F\4E2D\7684\8CC7\6599\5B8C\6574\6027. &PRODUCT_NAME. \53EF\4EE5\4F7F\7528\5167\5EFA\7684\7E3D\548C\6AA2\9A57\4F86\57F7\884C\907A\5931\7684\66F4\65B0\5075\6E2C\8207\5224\65B7\8CC7\6599\5217\7684\7248\672C. \7E3D\548C\6AA2\9A57\662F\4E00\7A2E\7279\5B9A\8868\683C\8CC7\6599\5217\4E4B\6240\6709\8CC7\6599\6B04\503C\7684\96DC\6E4A\51FD\6578. \67E5\8A62<em>\81EA\52D5\8CC7\6599\5217\64F7\53D6</em>\8CC7\6599\5EAB\4E2D\7684\8A18\9304\6642\6703\64F7\53D6\6B64\96DC\6E4A\51FD\6578, \7136\5F8C\8207\8CC7\6599\5EAB\4E2D\6B64\8655\7406\4F5C\696D\4E4B\4E00\90E8\5206\7684\76EE\524D\8A18\9304\7684\96DC\6E4A\505A\6BD4\8F03. \5982\679C\5169\500B\503C\76F8\540C\5C31\7E7C\7E8C\66F4\65B0, \5426\5247\5C31\7531\6B64\8655\7406\4F5C\696D\767C\51FA\932F\8AA4.</p>'),
unistr('<p>\60A8\53EF\4EE5\5229\7528\6B64\5C6C\6027\6307\5B9A\4FDD\7559\8CC7\6599\5217\7248\672C\7684\55AE\4E00\8CC7\6599\6B04, \4F5C\70BA\4F7F\7528\5167\5EFA\7E3D\548C\6AA2\9A57\8655\7406\7684\66FF\4EE3\65B9\6CD5. \6BCF\6B21\8CC7\6599\5EAB\4E2D\7684\8A18\9304\66F4\65B0\6642\5C31\5FC5\9808\66F4\65B0\6B64\8CC7\6599\6B04. Oracle \5EFA\8B70\60A8\5C0D\8868\683C\5BE6\884C\300C\66F4\65B0\4E4B\524D\300D\8CC7\6599\5EAB\89F8\767C\7A0B\5F0F\4EE5\905E\589E\6216\66F4\65B0\8CC7\6599\5217\7248\672C\8CC7\6599\6B04. \5DF2\5047\8A2D NUMBER \8CC7\6599\6B04\5305\542B\8CC7\6599\5217\7684\5E8F\865F. \4E0D\904E, \60A8\4E5F\53EF\4EE5\4F7F\7528 DATE \548C TIMESTAMP \8CC7\6599\6B04. \4F7F\7528\55AE\4E00\8CC7\6599\6B04\7684\512A\9EDE\662F &PRODUCT_NAME. \5F15\64CE\4E0D\9700\8981\57F7\884C\5B8C\6574\8CC7\6599\5217\7684\96DC\6E4A\904B\7B97, \5B83\53EA\8981\6BD4\8F03\55AE\4E00\8CC7\6599\6B04\503C\5373\53EF.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723646022259834604.4418)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\7A0B\5F0F\5BE6\969B\57F7\884C Where \5B50\53E5')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9650\5236\90E8\9580:</p>'),
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>unistr('\8F38\5165\8981\9644\52A0\81F3\6240\6709\7522\751F\4E4B INSERT\3001UPDATE \4EE5\53CA DELETE \6558\8FF0\53E5\7684 SQL WHERE \5B50\53E5. \60A8\53EF\4EE5\4F7F\7528\6B64\5C6C\6027\4F86\9650\5236\81EA\52D5\7522\751F\4E4B SQL \547C\53EB\5167\4F7F\7528\7684\8A18\9304.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361842218629998562.4418)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\5C07\7D22\5F15\9375\50B3\56DE\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\4FDD\7559 SQL INSERT \6558\8FF0\53E5\50B3\56DE\4E4B\4E3B\7D22\5F15\9375\8CC7\6599\6B04\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.</p>'),
unistr('<p>\6307\5B9A\6B64\8CC7\6599\6B04\53EF\53D6\56DE\9806\5E8F\6216\8CC7\6599\5EAB\89F8\767C\7A0B\5F0F\6240\586B\5165\7684\4E3B\7D22\5F15\9375\6B04\4F4D. \9019\500B\503C\7531\8655\7406\4F5C\696D\8A2D\5B9A\5728\968E\6BB5\4F5C\696D\72C0\614B\4E2D. </p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361842512807001262.4418)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\5C07\6B21\8981\7D22\5F15\9375\50B3\56DE\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723642713590625893.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\8F38\5165\4FDD\7559 SQL INSERT \6558\8FF0\53E5\50B3\56DE\4E4B\6B21\8981\4E3B\7D22\5F15\9375\8CC7\6599\6B04\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361843216017030111.4418)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\652F\63F4\7684\4F5C\696D')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>true
,p_default_value=>'I:U:D'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\52FE\9078\652F\63F4\7684\8CC7\6599\64CD\63A7\8A9E\8A00 (DML) \4F5C\696D. \6B64\8CC7\6599\64CD\63A7\8655\7406\4F5C\696D\6703\5728\8981\6C42\503C\662F\5217\793A\7684\503C\4E4B\4E00\6642, \57F7\884C DML. \4F7F\7528\6309\9215\4F86\9001\51FA\6B64\9801\9762\6642, \8981\6C42\503C\662F\900F\904E\6309\9215\6240\8A2D\5B9A.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362471227178028863.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\63D2\5165')
,p_return_value=>'I'
,p_help_text=>unistr('\4F9D\8981\6C42\503C\89F8\767C: INSERT\3001CREATE\3001CREATE_AGAIN\3001CREATEAGAIN')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362471623727030373.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\66F4\65B0')
,p_return_value=>'U'
,p_help_text=>unistr('\4F9D\8981\6C42\503C\89F8\767C: SAVE\3001APPLY CHANGES\3001UPDATE\3001UPDATE ROW\3001CHANGE\3001APPLY\3001APPLY%CHANGES%\3001GET_NEXT%\3001GET_PREV%')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362472022649030909.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\522A\9664')
,p_return_value=>'D'
,p_help_text=>unistr('\4F9D\8981\6C42\503C\89F8\767C: DELETE\3001REMOVE\3001DELETE ROW\3001DROP')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(216670983590615543.4418)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>105
,p_prompt=>unistr('\9396\5B9A\8CC7\6599\5217')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('<p>\9078\53D6\662F\5426\8981\5728\8655\7406\8CC7\6599\5217\524D\5C07\8981\66F4\65B0\6216\522A\9664\7684\6BCF\500B\8CC7\6599\5217\9396\5B9A\5728\57FA\790E\8868\683C\4E2D.</p>')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_focus
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(854773928315984269.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_FOCUS'
,p_display_name=>unistr('\8A2D\5B9A\7126\9EDE')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_FOCUS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\8A2D\5B9A\53D7\5F71\97FF\5143\7D20\7684\7126\9EDE. \5982\679C\6709\591A\500B\53D7\5F71\97FF\7684\5143\7D20, \5C07\9810\8A2D\70BA\7B2C\4E00\500B\53D7\5F71\97FF\7684\5143\7D20. \9019\5728\642D\914D<em>\986F\793A</em>\548C<em>\555F\7528</em>\52D5\4F5C\4F7F\7528, \4EE5\4FBF\5C07\4F7F\7528\8005\76F4\63A5\5E36\5230\9069\7576\7684\9805\76EE\6642\7279\5225\6709\7528.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/submit_page
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(854776817374066356.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SUBMIT_PAGE'
,p_display_name=>unistr('\9001\51FA\9801\9762')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SUBMIT_PAGE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\9001\51FA\9801\9762.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(854777422315124533.4418)
,p_plugin_id=>wwv_flow_api.id(854776817374066356.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8981\6C42/\6309\9215\540D\7A31')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\7528\65BC\9001\51FA\9801\9762\7684\8981\6C42\503C. \5982\679C\6309\9215\89F8\767C\300C\52D5\614B\52D5\4F5C\300D, \8ACB\5C07\6B64\8A2D\70BA\6309\9215\540D\7A31. \9019\53EF\78BA\4FDD\9032\884C\9801\9762\8655\7406\6642\6703\9075\5B88\6309\9215\7684<em>\57F7\884C\9A57\8B49</em>\5C6C\6027.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(477648707512082509.4418)
,p_plugin_id=>wwv_flow_api.id(854776817374066356.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\986F\793A\8655\7406')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\5728\9001\51FA\9801\9762\671F\9593, \662F\5426\8B93\76EE\524D\7684\9801\9762\8B8A\6210\7070\8272\4E26\986F\793A\300C\8655\7406\4E2D\300D\6A23\5F0F\52D5\756B. \5982\6B64, \4E00\822C\4F7F\7528\8005\5C31\4E0D\80FD\5728\9577\6642\9593\57F7\884C\7684\4F5C\696D\671F\9593\5167\57F7\884C\52D5\4F5C, \4F8B\5982\4E00\822C\4F7F\7528\8005\5617\8A66\5728\5831\8868\91CD\65B0\6574\7406\901F\5EA6\975E\5E38\7DE9\6162\6642\518D\6309\4E00\6B21\300C\641C\5C0B\300D\6309\9215.')
);
end;
/
prompt --application/shared_components/plugins/item_type/number_field
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(858626633540183539.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'NUMBER_FIELD'
,p_display_name=>unistr('\6578\5B57\6B04\4F4D')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','NUMBER_FIELD'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_NUMBER:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\986F\793A\6578\5B57\6B04\4F4D. \6B64\9805\76EE\985E\578B\6703\81EA\52D5\9A57\8B49\503C\662F\5426\70BA\6578\5B57.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858627014886206552.4418)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6700\5C0F\503C')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>0</code></li>',
'<li><code>0.99</code></li>',
'<li><code>&P1_MIN_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('\8F38\5165\5141\8A31\7684\6700\5C0F\503C. \9019\500B\503C\53EF\4EE5\662F\975C\614B\503C\6216\4F7F\7528\66FF\4EE3\8A9E\6CD5\7684\52D5\614B\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858627524583209309.4418)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6700\5927\503C')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>1000</code></li>',
'<li><code>49.99</code></li>',
'<li><code>&P1_MAX_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('\8F38\5165\5141\8A31\7684\6700\5927\503C. \9019\500B\503C\53EF\4EE5\662F\975C\614B\503C\6216\4F7F\7528\66FF\4EE3\8A9E\6CD5\7684\52D5\614B\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858676504215733205.4418)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6578\5B57\5C0D\9F4A\65B9\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'right'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\986F\793A\4E4B\6578\5B57\7684\5C0D\9F4A\65B9\5F0F. \5982\679C\9805\76EE\986F\793A\70BA<em>\552F\8B80</em>\6216\6307\5B9A\4E86 <strong>HTML \8868\55AE\5143\7D20\5C6C\6027</strong>\7684\8A71, \5C31\4E0D\6703\5957\7528\6B64\8A2D\5B9A.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858678212526735663.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\9760\5DE6')
,p_return_value=>'left'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858678618067737263.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\7F6E\4E2D')
,p_return_value=>'center'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858679023954738917.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\9760\53F3')
,p_return_value=>'right'
);
end;
/
prompt --application/shared_components/plugins/item_type/slider
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(880057283386968314.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SLIDER'
,p_display_name=>unistr('\6ED1\687F')
,p_supported_ui_types=>'JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SLIDER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A\6ED1\687F\9805\76EE\985E\578B, \8B93\4F7F\7528\8005\80FD\5920\5411\5DE6\6216\5411\53F3\6ED1\52D5\63A7\5236\9805\4F86\66F4\65B0\9805\76EE\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880057664732991327.4418)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6700\5C0F\503C')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'0'
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>0</code></li>',
'  <li><code>&P1_MIN_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('\8F38\5165\5141\8A31\7684\6700\5C0F\503C. \9019\500B\503C\53EF\4EE5\662F\975C\614B\503C\6216\4F7F\7528\66FF\4EE3\8A9E\6CD5\7684\52D5\614B\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880058174429994084.4418)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6700\5927\503C')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'100'
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>100</code></li>',
'  <li><code>&P1_MAX_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('\8F38\5165\5141\8A31\7684\6700\5927\503C. \9019\500B\503C\53EF\4EE5\662F\975C\614B\503C\6216\4F7F\7528\66FF\4EE3\8A9E\6CD5\7684\52D5\614B\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880107154062517980.4418)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\9593\8DDD\589E\91CF')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>5</code></li>',
'  <li><code>&P1_STEP_SIZE.</code></li>',
'</ul>'))
,p_help_text=>unistr('\8F38\5165\4E00\500B\5F37\5236\8B93\6ED1\687F\8CBC\9F4A\7279\5B9A\589E\91CF\7684\503C. \9019\500B\503C\53EF\4EE5\662F\975C\614B\503C\6216\4F7F\7528\66FF\4EE3\8A9E\6CD5\7684\52D5\614B\503C.')
,p_attribute_comment=>'$$$ DJP - No default value set = 1'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10717732308427631.4418)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6A19\793A\9078\53D6\9805\76EE')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\6ED1\687F\662F\5426\61C9\8A72\6A19\793A\8DEF\5F91, \76F4\81F3\76EE\524D\7684\6ED1\687F\63A7\5236\4F4D\7F6E.')
);
end;
/
prompt --application/shared_components/plugins/process_type/send_email
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(956011735689077213.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SEND_EMAIL'
,p_display_name=>unistr('\50B3\9001\96FB\5B50\90F5\4EF6')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SEND_EMAIL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\53EF\5F9E\61C9\7528\7A0B\5F0F\50B3\9001\96FB\5B50\90F5\4EF6\548C\4E00\6216\591A\500B\9644\4EF6 (\9078\64C7\6027) \7684\8655\7406\4F5C\696D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956092037052376563.4418)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\4F86\6E90')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'&APP_EMAIL.'
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>noreply@test.com</code></li>',
'<li><code>Do not reply &lt;noreply@test.com&gt;</code></li>',
'<li><code>&amp;P6_FROM.</code></li>',
'</ul>'))
,p_help_text=>unistr('\8F38\5165\986F\793A\70BA\96FB\5B50\90F5\4EF6\5BC4\4EF6\8005\7684\96FB\5B50\90F5\4EF6\5730\5740. \6B64\96FB\5B50\90F5\4EF6\5730\5740\5FC5\9808\662F\6709\6548\7684\5730\5740. \5426\5247, \5C07\4E0D\6703\50B3\9001\8A0A\606F. \82E5\8981\4F7F\7528\52D5\614B\503C, \8ACB\4F7F\7528\66FF\4EE3\8A9E\6CD5.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956050619869980888.4418)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6536\4EF6\8005')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_TO.</code></li>',
'</ul>'))
,p_help_text=>unistr('\6307\5B9A\4E00\6216\591A\500B\96FB\5B50\90F5\4EF6\5730\5740\4EE5\8F38\5165\96FB\5B50\90F5\4EF6\6536\4EF6\8005. \82E5\6709\591A\500B\96FB\5B50\90F5\4EF6\5730\5740, \8ACB\4F7F\7528\9017\865F\5340\9694\6E05\55AE. \82E5\8981\4F7F\7528\52D5\614B\503C, \8ACB\4F7F\7528\66FF\4EE3\8A9E\6CD5.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956051928180983251.4418)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\526F\672C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_CC.</code></li>',
'</ul>'))
,p_help_text=>unistr('\6307\5B9A\4E00\6216\591A\500B\96FB\5B50\90F5\4EF6\5730\5740\4EE5\8F38\5165\526F\672C\96FB\5B50\90F5\4EF6\6536\4EF6\8005. \82E5\6709\591A\500B\96FB\5B50\90F5\4EF6\5730\5740, \8ACB\4F7F\7528\9017\865F\5340\9694\6E05\55AE. \82E5\8981\4F7F\7528\52D5\614B\503C, \8ACB\4F7F\7528\66FF\4EE3\8A9E\6CD5.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956052531990984386.4418)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\5BC6\4EF6\526F\672C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_BCC.</code></li>',
'</ul>'))
,p_help_text=>unistr('\6307\5B9A\4E00\6216\591A\500B\96FB\5B50\90F5\4EF6\5730\5740\4EE5\8F38\5165\5BC6\4EF6\526F\672C\96FB\5B50\90F5\4EF6\6536\4EF6\8005. \82E5\6709\591A\500B\96FB\5B50\90F5\4EF6\5730\5740, \8ACB\4F7F\7528\9017\865F\5340\9694\6E05\55AE. \82E5\8981\4F7F\7528\52D5\614B\503C, \8ACB\4F7F\7528\66FF\4EE3\8A9E\6CD5.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956082217032200544.4418)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\56DE\8986')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_REPLY_TO.</code></li>',
'</ul>'))
,p_help_text=>unistr('\8F38\5165\8981\56DE\8986\7684\96FB\5B50\90F5\4EF6\5730\5740. \82E5\672A\6307\5B9A, \5C07\6703\4F7F\7528<strong>\5BC4\4EF6\8005</strong>\4E2D\8F38\5165\7684\96FB\5B50\90F5\4EF6\5730\5740. \82E5\8981\4F7F\7528\52D5\614B\503C, \8ACB\4F7F\7528\66FF\4EE3\8A9E\6CD5.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956053241340987086.4418)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>unistr('\4E3B\65E8')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4418)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>unistr('\8F38\5165\96FB\5B50\90F5\4EF6\7684\4E3B\65E8. \82E5\8981\5305\542B\52D5\614B\503C, \8ACB\4F7F\7528\66FF\4EE3\8A9E\6CD5, \4F8B\5982 <code>&amp;P6_PRODUCT_NAME.</code>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956053823463991423.4418)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>80
,p_prompt=>unistr('\5167\6587 (\7D14\6587\5B57)')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\96FB\5B50\90F5\4EF6\7684\672C\6587. \5982\679C\6536\4EF6\8005\7684\96FB\5B50\90F5\4EF6\5F9E\5C6C\7AEF\4E0D\652F\63F4\986F\793A Rich Text, \5C07\6703\4F7F\7528\7D14\6587\5B57\7248\672C. \82E5\8981\5728\672C\6587\4E2D\5305\542B\52D5\614B\5167\5BB9, \8ACB\4F7F\7528\66FF\4EE3\8A9E\6CD5, \4F8B\5982 <code>&amp;P6_PRODUCT_NAME.</code>.</p>'),
unistr('<p><em>\6CE8\610F: SMTP/MIME \898F\683C\898F\5B9A\55AE\4E00\884C\4E0D\53EF\8D85\904E 1000 \500B\5B57\5143. \70BA\4E86\9075\5FAA\6B64\9650\5236, \60A8\5FC5\9808\52A0\4E0A\6B78\4F4D\5B57\5143\6216\63DB\884C\5B57\5143, \5C07\672C\6587\5206\5272\70BA 1000 \500B\5B57\5143\5167\7684\5340\584A. \82E5\672A\9075\5FAA\6B64\9650\5236, \5C07\6703\7522\751F\932F\8AA4\7684\96FB\5B50\90F5\4EF6\8A0A\606F, \5305\62EC\4E0D\5B8C\6574\7684\8A0A\606F\6216\662F\542B\6709\984D\5916\9A5A\5606\865F\7684\8A0A\606F.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956082724997202851.4418)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>90
,p_prompt=>unistr('\5167\6587 (HTML)')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4418)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\7522\751F\591A\90E8\5206 HTML \8A0A\606F\7684\6587\5B57, \5305\62EC\7D14\6587\5B57\548C HTML \5167\5BB9. \6536\4EF6\8005\4E4B\96FB\5B50\90F5\4EF6\5F9E\5C6C\7AEF\7684\8A2D\5B9A\503C\548C\529F\80FD\5C07\6C7A\5B9A\986F\793A\7684\5167\5BB9. \96D6\7136\5927\591A\6578\73FE\4EE3\7684\96FB\5B50\90F5\4EF6\5F9E\5C6C\7AEF\90FD\80FD\5920\8B80\53D6 HTML \683C\5F0F\7684\96FB\5B50\90F5\4EF6, \4F46\8ACB\8A18\4F4F\6709\4E9B\4F7F\7528\8005\53EF\80FD\6703\70BA\4E86\5B89\5168\4E0A\7684\7406\7531\800C\505C\7528\6B64\529F\80FD. \82E5\8981\5728\6B64\6587\5B57\4E2D\5305\62EC\52D5\614B\5167\5BB9, \8ACB\4F7F\7528\66FF\4EE3\8A9E\6CD5, \4F8B\5982 <code>&amp;P6_PRODUCT_NAME.</code>.</p>'),
unistr('<p>\4F7F\7528 &lt;img /&gt; \6A19\8A18\53C3\7167\5F71\50CF\6642, \8ACB\8A18\4F4F\6536\4EF6\8005\7684\96FB\5B50\90F5\4EF6\5F9E\5C6C\7AEF\5FC5\9808\80FD\5920\5B58\53D6\53C3\7167\7684\5F71\50CF, \6536\4EF6\8005\624D\80FD\898B\5230\5F71\50CF. \4F8B\5982, \5047\8A2D\60A8\5982\4EE5\4E0B\6240\793A\53C3\7167\7DB2\8DEF\4E0A\540D\70BA hello.gif \7684\5F71\50CF:</p>'),
'<pre>',
'&lt;img src=&quot;http://example.com/hello.gif&quot; alt=&quot;Hello&quot; /&gt;',
'</pre>',
unistr('<p>\5728\672C\7BC4\4F8B\4E2D, \5F71\50CF\4E26\672A\9644\52A0\5230\96FB\5B50\90F5\4EF6, \800C\662F\7531\96FB\5B50\90F5\4EF6\53C3\7167. \6536\4EF6\8005\82E5\8981\80FD\5920\898B\5230\8A72\5F71\50CF, \4ED6\5011\5FC5\9808\80FD\5920\4F7F\7528 Web \700F\89BD\5668\5B58\53D6\8A72\5F71\50CF. \5982\679C\5F71\50CF\5728\9632\706B\7246\4E4B\5167\800C\6536\4EF6\8005\5728\9632\706B\7246\4E4B\5916\7684\8A71, \5C07\4E0D\6703\986F\793A\5F71\50CF. \57FA\65BC\6B64\539F\56E0, \8ACB\907F\514D\4F7F\7528\5F71\50CF. \5982\679C\5FC5\9808\5305\62EC\5F71\50CF, \8ACB\52D9\5FC5\542B\62EC ALT \5C6C\6027, \4EE5\4FBF\5728\7121\6CD5\5B58\53D6\5F71\50CF\6642\80FD\5920\63D0\4F9B\6587\5B57\63CF\8FF0.</p>'),
unistr('<p><em>\6CE8\610F: SMTP/MIME \898F\683C\898F\5B9A\55AE\4E00\884C\4E0D\53EF\8D85\904E 1000 \500B\5B57\5143. \70BA\4E86\9075\5FAA\6B64\9650\5236, \60A8\5FC5\9808\52A0\4E0A\6B78\4F4D\5B57\5143\6216\63DB\884C\5B57\5143, \5C07\5167\5BB9\5206\5272\70BA 1000 \500B\5B57\5143\5167\7684\5340\584A. \82E5\672A\9075\5FAA\6B64\9650\5236, \5C07\7522\751F\932F\8AA4\7684\96FB\5B50\90F5\4EF6\8A0A\606F, \5305\62EC\4E0D\5B8C\6574\7684\8A0A\606F\6216\662F\542B\6709\984D\5916\9A5A\5606\865F\7684\8A0A\606F.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956084325437259694.4418)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>unistr('\9644\4EF6 SQL')
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>SQL \6558\8FF0\53E5\5FC5\9808\4F7F\7528\4E0B\5217\683C\5F0F:</p>'),
'<pre>',
'select blob_column,',
'       file_name,',
'       mime_type,',
'       content_id',
'  from table',
'</pre>',
unistr('<p>mime_type \548C content_id \70BA\9078\64C7\6027\8CC7\6599\6B04. \82E5\6307\5B9A content_id, \6A94\6848\5C07\4EE5\5167\5D4C\65B9\5F0F\9644\52A0, content_id \7684\503C\6703\4F5C\70BA\9644\4EF6\7684 CID.</p>'),
unistr('<p>content_id \8CC7\6599\6B04\4E2D\7684\503C\82E5\70BA ''my_inline_content'', \53EF\4F7F\7528\4E0B\5217 HTML \5C07\8A72\5F71\50CF\5167\5D4C\65BC\96FB\5B50\90F5\4EF6\4E2D:</p>'),
'<p>',
'<pre>',
'&lt;div&gt;',
'&nbsp;&nbsp;&lt;h1&gt;Some Embedded Content&lt;/h1&gt;',
'&nbsp;&nbsp;&lt;p&gt;',
'&nbsp;&nbsp;&nbsp;&nbsp;&lt;img src="cid:my_inline_content" alt="Inline Image" &gt;',
'&nbsp;&nbsp;&lt;/p&gt;',
'&lt;/div&gt;',
'</pre>',
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\50B3\56DE\4E00\6216\591A\500B BLOB \7684 SQL \6558\8FF0\53E5, \9019\4E9B BLOB \5C07\4EE5\6A94\6848\5F62\5F0F\9644\52A0\81F3\96FB\5B50\90F5\4EF6.</p>'),
unistr('<p>content_id \8CC7\6599\6B04\82E5\5305\542B\7A7A\503C, \95DC\806F\7684\6A94\6848\5C07\6703\662F\4E00\822C\9644\4EF6. \6587\4EF6\6216 zip \5B58\6A94\4E4B\985E\7684\6A94\6848\901A\5E38\6703\4EE5\9019\7A2E\65B9\5F0F\9644\52A0.</p>'),
unistr('<p>\5982\679C content_id \7684\503C\4E0D\662F\7A7A\503C, \95DC\806F\7684\6A94\6848\6703\6A19\793A\70BA\4EE5\5167\5D4C\65B9\5F0F\9644\52A0. content_id \8CC7\6599\6B04\7684\503C\5C07\4F5C\70BA\9644\4EF6\7684 CID (\5167\5BB9 ID). \6B64 CID \503C\53EF\7528\65BC\96FB\5B50\90F5\4EF6\7684 HTML \7A0B\5F0F\78BC\4E2D, \4EE5\76F4\63A5\5C07\5F71\50CF\5167\5D4C\5728\96FB\5B50\90F5\4EF6\5167\5BB9\4E2D. \8ACB\6CE8\610F, \6709\4E9B\96FB\5B50\90F5\4EF6\5F9E\5C6C\7AEF\53EF\80FD\4E0D\6703\81EA\52D5\986F\793A\5167\5D4C\9644\4EF6. \6B64\5916, \96FB\5B50\90F5\4EF6\6A19\6E96\91DD\5C0D\5167\5BB9 ID \7684\683C\5F0F\6709\8A31\591A\8981\6C42\898F\5B9A. Oracle Application Express \4E26\672A\5F37\5236\8981\6C42\7B26\5408\9019\4E9B\6A19\6E96\898F\7BC4.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(965817719331444057.4418)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>unistr('\7ACB\5373\50B3\9001')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\662F\5426\7ACB\5373\50B3\9001\6B64\96FB\5B50\90F5\4EF6, \9019\4E5F\6703\540C\6642\50B3\9001\76EE\524D\5728 &PRODUCT_NAME. \96FB\5B50\90F5\4EF6\4F47\5217\8868\683C\4E2D\7684\6240\6709\96FB\5B50\90F5\4EF6. \4F9D\7167\9810\8A2D, &PRODUCT_NAME. \6703\5C07\672A\50B3\9001\7684\96FB\5B50\90F5\4EF6\8A0A\606F\5132\5B58\5728\8868\683C\4E2D\4E26\5B9A\671F\50B3\905E\5B83\5011, \8B93\7CFB\7D71\6548\80FD\7DAD\6301\5728\826F\597D\7684\72C0\614B.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1801033763884282.4418)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>60
,p_prompt=>unistr('\96FB\5B50\90F5\4EF6\6A23\677F')
,p_attribute_type=>'EMAIL TEMPLATE ID'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\9078\64C7\8981\4F7F\7528\7684\96FB\5B50\90F5\4EF6\6A23\677F.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802168961897202.4418)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>100
,p_prompt=>unistr('\9810\7559\4F4D\7F6E\503C')
,p_attribute_type=>'PLACEHOLDER JSON'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\8981\66FF\4EE3\7684\6A23\677F\9810\7559\4F4D\7F6E\540D\7A31\548C\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802477287905419.4418)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>110
,p_prompt=>unistr('\8A9E\8A00\8986\5BEB')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\82E5\6307\5B9A\8A9E\8A00\4EE3\78BC, \8655\7406\4F5C\696D\5C07\5F9E\6B64\8A9E\8A00\7684\61C9\7528\7A0B\5F0F\7FFB\8B6F\67E5\5C0B\6A23\677F. \5982\679C\7FFB\8B6F\4E0D\5B58\5728, \8655\7406\4F5C\696D\5C31\6703\4F7F\7528\61C9\7528\7A0B\5F0F\7684\4E3B\8981\8A9E\8A00. \652F\63F4\66FF\4EE3\8A9E\6CD5.</p>'),
unistr('<p>\652F\63F4\8A9E\8A00\4EE3\78BC\968E\5C64. \5982\679C\6307\5B9A\7684\503C\70BA "fr-ca" (\6CD5\6587 - \52A0\62FF\5927), \4F46\53EA\627E\5230 "fr" (\6CD5\6587) \7684\7FFB\8B6F, \5247\7CFB\7D71\5C07\63A1\7528\6B64\7FFB\8B6F.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/file
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(961772418825259055.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'FILE'
,p_display_name=>unistr('\6A94\6848\700F\89BD...')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','FILE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:ICON'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A\6587\5B57\6B04\4F4D\4E14\5E36\6709<em>\700F\89BD...</em> \6309\9215. \4F7F\7528\8005\53EF\4EE5\5229\7528\6B64\300C\700F\89BD\300D\6309\9215\4F86\5C0B\627E\4E26\4E0A\50B3\672C\6A5F\6A94\6848\7CFB\7D71\7684\6A94\6848.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961797912421645170.4418)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>40
,p_prompt=>unistr('\5132\5B58\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\5132\5B58\4E0A\50B3\4E4B\6A94\6848\7684\8CC7\6599\5EAB\8868\683C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961799013591654950.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\9805\76EE\4F86\6E90\5C6C\6027\4E2D\6307\5B9A\7684 BLOB \8CC7\6599\6B04')
,p_return_value=>'DB_COLUMN'
,p_help_text=>unistr('\5C07\4E0A\50B3\7684\6A94\6848\5132\5B58\5728<strong>\81EA\52D5\8CC7\6599\5217\8655\7406 (DML)</strong> \8655\7406\4F5C\696D\4F7F\7528\7684\8868\683C\4E2D\4EE5\53CA\9805\76EE\4F86\6E90\5C6C\6027\5167\6307\5B9A\7684\8CC7\6599\6B04\4E2D. \8CC7\6599\6B04\5FC5\9808\70BA BLOB \8CC7\6599\985E\578B. \6A94\6848\4E0B\8F09\6642, \6703\4F7F\7528<strong>\81EA\52D5\8CC7\6599\5217\64F7\53D6</strong>\8655\7406\4F5C\696D\7684\8868\683C\540D\7A31.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728348831149058771.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\8868\683C APEX_APPLICATION_TEMP_FILES')
,p_return_value=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5C07\4E0A\50B3\7684\6A94\6848\5132\5B58\5728\60A8\53EF\4EE5\4F7F\7528 APEX_APPLICATION_TEMP_FILES \6AA2\8996\5B58\53D6\7684\66AB\6642\4F4D\7F6E. &PRODUCT_NAME. \6703\6839\64DA\60A8\9078\64C7\7684<strong>\6C38\4E45\6E05\9664\6A94\6848\6642\9593</strong>\503C, \5728\968E\6BB5\4F5C\696D\7D50\675F\6216\5728\4E0A\50B3\8981\6C42\7D50\675F\6642\81EA\52D5\5C07\6A94\6848\522A\9664.</p>'),
unistr('<p>\82E5\8981\5728<strong>\5141\8A31\591A\500B\6A94\6848</strong>\8A2D\70BA<strong>\5426</strong>\6642\5B58\53D6\6A94\6848:</p>'),
'<pre>',
'select *',
'  from apex_application_temp_files',
' where name = :<em>page item name</em>;',
'</pre>',
unistr('<p>\82E5\8981\5728<strong>\5141\8A31\591A\500B\6A94\6848</strong>\8A2D\70BA<strong>\662F</strong>\6642\5B58\53D6\6A94\6848:</p>'),
'<pre>',
'declare',
'    l_file_names apex_t_varchar2;',
'    l_file       apex_application_temp_files%rowtype;',
'begin',
'    l_file_names := apex_string.split (',
'                        p_str => :<em>page item name</em>,',
'                        p_sep => '':'' );',
'    for i in 1 .. l_file_names.count loop',
'        select *',
'          into l_file',
'          from apex_application_temp_files',
'         where name = l_file_names(i);',
'        -- add code here to store the uploaded file in your own table',
'    end loop;',
'end;',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961799722296685857.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4418)
,p_display_sequence=>30
,p_display_value=>unistr('WWV_FLOW_FILES \8868\683C')
,p_return_value=>'WWV_FLOW_FILES'
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5C07\4E0A\50B3\7684\6A94\6848\5132\5B58\5728 &PRODUCT_NAME. \8868\683C <code>WWV_FLOW_FILES</code> \4E2D.</p>'),
unistr('<p>\82E5\8981\5B58\53D6\6A94\6848, \8ACB\4F7F\7528:</p>'),
'<pre>',
'select *',
'  from wwv_flow_files',
' where name = :<em>page item name</em>;',
'</pre>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961780714070314496.4418)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>50
,p_prompt=>unistr('MIME \985E\578B\8CC7\6599\6B04')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\4EE5\5927\5BEB\8F38\5165\7528\65BC\5132\5B58\5DF2\4E0A\50B3\6A94\6848\4E4B MIME \985E\578B\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE\540D\7A31. \700F\89BD\5668\6703\4F7F\7528 MIME \985E\578B\4F86\8B58\5225\61C9\8A72\4F7F\7528\54EA\500B\61C9\7528\7A0B\5F0F\986F\793A\4E0B\8F09\4E4B\6A94\6848\7684 BLOB \5167\5BB9.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961781218572315783.4418)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>60
,p_prompt=>unistr('\6A94\6848\540D\7A31\8CC7\6599\6B04')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\8F38\5165\7528\4F86\5132\5B58\4E0A\50B3\6A94\6848\4E4B\6A94\6848\540D\7A31\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961781726537318040.4418)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>70
,p_prompt=>unistr('\5B57\5143\96C6\8CC7\6599\6B04')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\4EE5\5927\5BEB\8F38\5165\7528\65BC\5132\5B58\5DF2\4E0A\50B3\6A94\6848\4E4B\5B57\5143\96C6\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE\540D\7A31. BLOB \7684\5B57\5143\96C6\4E0D\6703\5728\4E0A\50B3\6642\81EA\52D5\8A2D\5B9A. \4E00\822C\4F7F\7528\8005\5FC5\9808\81EA\884C\8A2D\5B9A\4E0A\50B3\4E4B\6587\4EF6\7684\5B57\5143\96C6.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961782232078319703.4418)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>80
,p_prompt=>unistr('BLOB \4E0A\6B21\66F4\65B0\6642\9593\8CC7\6599\6B04')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\4EE5\5927\5BEB\8F38\5165\7528\65BC\5132\5B58\4E0A\50B3\6A94\6848\5F8C\4E4B\7576\6642\6642\6233\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE\540D\7A31. \9019\500B\65E5\671F\503C\5C07\7528\65BC\700F\89BD\5668\5FEB\53D6.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961805334341783950.4418)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>90
,p_prompt=>unistr('\986F\793A\4E0B\8F09\9023\7D50')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\6307\5B9A\6B64\9805\76EE\7684 BLOB \70BA\975E\7A7A\767D\6642, \662F\5426\986F\793A\4E0B\8F09\9023\7D50.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961784310308341810.4418)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>100
,p_prompt=>unistr('\4E0B\8F09\9023\7D50\6587\5B57')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(961805334341783950.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\8F38\5165\8981\986F\793A\70BA\4E0B\8F09\9023\7D50\4E4B\4E00\90E8\5206\7684\6587\5B57. \82E5\672A\6307\5B9A, \5C07\986F\793A\300C\5171\7528\5143\4EF6\300D\5167\5132\5B58\65BC <code>APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT</code> \4E4B\300C\6587\5B57\8A0A\606F\300D\4E2D\7684\6587\5B57.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961782727361327744.4418)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>110
,p_prompt=>unistr('\5167\5BB9\914D\7F6E')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'attachment'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961805334341783950.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\700F\89BD\5668\8655\7406\4E0B\8F09\5167\5BB9\7684\65B9\5F0F.</p>'),
unistr('<p><em>\6CE8\610F: \4E26\975E\6240\6709\5167\5BB9\90FD\80FD\4EE5\5167\5D4C\65B9\5F0F\986F\793A. \662F\5426\652F\63F4\4EE5\5167\5D4C\65B9\5F0F\986F\793A\5167\5BB9, \53D6\6C7A\65BC\700F\89BD\5668\662F\5426\652F\63F4\7279\5B9A\7684 MIME \985E\578B.</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961783330131328554.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(961782727361327744.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5167\5D4C')
,p_return_value=>'inline'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961783735326330101.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(961782727361327744.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\9644\4EF6')
,p_return_value=>'attachment'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728349541683084558.4418)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>unistr('\6C38\4E45\6E05\9664\6A94\6848\6642\9593')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SESSION'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\5B9A\7FA9 &PRODUCT_NAME. \61C9\8A72\79FB\9664\66AB\6642\6A94\7684\6642\6A5F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728349853284087310.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(728349541683084558.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\968E\6BB5\4F5C\696D\7D50\675F')
,p_return_value=>'SESSION'
,p_help_text=>unistr('\5728\76EE\524D &PRODUCT_NAME. \968E\6BB5\4F5C\696D\7D50\675F\6642\522A\9664\6A94\6848.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728350242833089332.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(728349541683084558.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\8981\6C42\7D50\675F')
,p_return_value=>'REQUEST'
,p_help_text=>unistr('\5728\76EE\524D HTTP \8981\6C42\7D50\675F\6642\522A\9664\6A94\6848.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(451543969001781322.4418)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>unistr('\5141\8A31\591A\500B\6A94\6848')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\4E00\6B21\662F\5426\53EF\4EE5\4E0A\50B3\591A\500B\6A94\6848.</p>'),
'',
unistr('<p>\6CE8\610F - \591A\500B\6A94\6848\540D\7A31\5728\9801\9762\9805\76EE\4E2D\5C07\6703\4EE5\5192\865F\5340\9694\7684\6E05\55AE\65B9\5F0F\5132\5B58.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(451544768593842902.4418)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>140
,p_prompt=>unistr('\6A94\6848\985E\578B')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dt>\4EE3\8868\53EA\80FD\63A5\53D7\5F71\50CF\6A94</dt>'),
'<dd><pre>image/*</pre></dd>',
unistr('<dt>\4EE3\8868\53EA\80FD\63A5\53D7\5F71\50CF\548C\8996\8A0A\6A94\6848</dt>'),
'<dd><pre>image/*,video/*</pre></dd>',
unistr('<dt>\4EE3\8868\53EA\80FD\63A5\53D7 PNG \5F71\50CF\6A94</dt>'),
'<dd><pre>image/png</pre></dd>'))
,p_help_text=>unistr('\6307\5B9A\53EF\4F9B\700F\89BD\5668\7528\4F86\9650\5236\80FD\5920\4E0A\50B3\4E4B\6A94\6848\7684\9017\865F\5340\9694\6A94\6848\985E\578B\6E05\55AE.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13629201915222128.4418)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>10
,p_prompt=>unistr('\986F\793A\65B9\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INLINE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\61C9\5982\4F55\5448\73FE\6A94\6848\700F\89BD\9805\76EE\7684\986F\793A\6A23\5F0F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13629582056224659.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5167\5D4C\6A94\6848\700F\89BD')
,p_return_value=>'INLINE'
,p_help_text=>unistr('\5728\9801\9762\4E0A\986F\793A\8207\5176\4ED6\6587\5B57\6B04\4F4D\53CA\9805\76EE\985E\4F3C\7684\6A94\6848\700F\89BD\8F38\5165\6B04\4F4D.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13629902085226258.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5167\5D4C\7F6E\653E\5340\57DF')
,p_return_value=>'DROPZONE_INLINE'
,p_help_text=>unistr('\4EE5\5167\5D4C\7F6E\653E\5340\57DF\7684\5F62\5F0F\986F\793A\6A94\6848\700F\89BD\8F38\5165\6B04\4F4D, \6B64\5340\57DF\53EF\5305\542B\4E00\500B\6A19\984C\548C\63CF\8FF0.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13741737113486642.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\5340\584A\7F6E\653E\5340\57DF')
,p_return_value=>'DROPZONE_BLOCK'
,p_help_text=>unistr('\4EE5\7CBE\9748\6A23\5F0F\7684\7F6E\653E\5340\57DF\5F62\5F0F\986F\793A\6A94\6848\700F\89BD\8F38\5165\6B04\4F4D, \6B64\5340\57DF\53EF\5305\542B\4E00\500B\6A19\984C\548C\63CF\8FF0, \4EE5\53CA\4E00\500B\53EF\4F9B\9078\53D6\6A94\6848\7684\6309\9215.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18970520653850634.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\539F\751F\6A94\6848\700F\89BD')
,p_return_value=>'NATIVE'
,p_help_text=>unistr('\4F7F\7528\700F\89BD\5668\7684\539F\751F\683C\5F0F\986F\793A\6A94\6848\700F\89BD\9805\76EE.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13631853022534008.4418)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>20
,p_prompt=>unistr('\7F6E\653E\5340\57DF\6A19\984C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(13629201915222128.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'INLINE,DROPZONE_INLINE,DROPZONE_BLOCK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\7F6E\653E\5340\57DF\7684\6A19\984C.'),
unistr('\6B64\6B04\4F4D\82E5\7559\767D, \9810\8A2D\6703\4F7F\7528 <code>APEX.ITEM.FILE.DROP_FILE</code> \6216 <code>APEX.ITEM.FILE.DROP_FILES</code> \6587\5B57\8A0A\606F.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13643896497789547.4418)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>30
,p_prompt=>unistr('\7F6E\653E\5340\57DF\63CF\8FF0')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(13629201915222128.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'DROPZONE_INLINE,DROPZONE_BLOCK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\7F6E\653E\5340\57DF\7684\63CF\8FF0\6587\5B57.</p>'),
unistr('<p>\6B64\6B04\4F4D\82E5\7559\767D, \9810\8A2D\6703\6839\64DA\300C\986F\793A\65B9\5F0F\300D\7279\6027\4F7F\7528\4E0B\5217\6587\5B57\8A0A\606F.</p>'),
unistr('<p><strong>\5340\584A\7F6E\653E\5340\57DF</strong><br />'),
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES</code>',
'</p>',
unistr('<p><strong>\5167\5D4C\7F6E\653E\5340\57DF</strong><br />'),
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILES</code>',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13644378210801196.4418)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\6A94\6848\5927\5C0F\4E0A\9650')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'KB'
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\900F\904E\6B64\9805\76EE\4E0A\50B3\6A94\6848\6642\6240\63A5\53D7\7684\6A94\6848\5927\5C0F\4E0A\9650 (KB).')
);
end;
/
prompt --application/shared_components/plugins/item_type/list_manager
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(973073216779459799.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LIST_MANAGER'
,p_display_name=>unistr('\6E05\55AE\7BA1\7406\7A0B\5F0F')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LIST_MANAGER'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ELEMENT_OPTION:PLACEHOLDER:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\986F\793A\5E36\6709\5373\73FE\5F0F\503C\6E05\55AE\5716\793A\3001<em>\65B0\589E</em>\548C<em>\79FB\9664</em>\6309\9215\4EE5\53CA\6240\9078\503C\6E05\55AE\7684\6587\5B57\9805\76EE.</p>'),
unistr('<p>\60A8\53EF\4EE5\8F38\5165\503C\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7. \63A5\8457\60A8\53EF\4EE5\5229\7528\6309\9215\4F86\7BA1\7406\9078\53D6\7684\503C. \9078\53D6\7684\503C\5132\5B58\5728\55AE\4E00\5192\865F\5340\9694\7684\5B57\4E32\4E2D.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(973075623967480816.4418)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\64F7\53D6')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\300C\5373\73FE\5F0F LOV\300D\958B\555F\5F8C\8CC7\6599\7684\986F\793A\65B9\5F0F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973076228816482253.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\4E0D\64F7\53D6')
,p_return_value=>'NO_FETCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973077034010483721.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\64F7\53D6\7B2C\4E00\500B\8CC7\6599\5217\96C6')
,p_return_value=>'FIRST_ROWSET'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973077408168485730.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\64F7\53D6\7B2C\4E00\500B\8CC7\6599\5217\96C6\4E26\7BE9\9078\76EE\524D\7684\503C')
,p_return_value=>'FIRST_ROWSET_FILTER'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(973074833187474061.4418)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\7DAD\6301\539F\4F86\5927\5C0F\5BEB\6A23\5F0F')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\662F\8981\8B93\503C\7DAD\6301\8F38\5165\6642\7684\6A23\5B50, \9084\662F\8F49\63DB\70BA\5927\5BEB.</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154323494834504.4418)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4418)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\4EE5 SQL \67E5\8A62\70BA\57FA\790E\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\5177\6709\76F8\540C\986F\793A\503C\548C\50B3\56DE\503C\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\6CE8\610F: \82E5\662F\70BA\986F\793A\503C\548C\50B3\56DE\503C\9078\53D6\76F8\540C\7684\8CC7\6599\6B04, \8ACB\4F7F\7528\8CC7\6599\6B04\5225\540D.</p>'),
'</dd>',
unistr('<dt>\5177\6709\9023\7D50\8B8A\6578\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\6CE8\610F: \5982\679C <code>P3_DEPTNO</code> \662F\76F8\540C\9801\9762\4E0A\7684\53EF\4FEE\6539\9801\9762\9805\76EE, \8ACB\5C07<em>\968E\5C64\5F0F LOV \7236\9805\9805\76EE</em>\5C6C\6027\8A2D\70BA <code>P3_DEPTNO</code>.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process_legacy
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1086048547681945775.4418)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS_LEGACY'
,p_display_name=>unistr('\820A\6709\81EA\52D5\8CC7\6599\5217\8655\7406')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\53EF\5728\55AE\4E00\8CC7\6599\5EAB\8868\683C\6216\53EF\66F4\65B0\8996\89C0\8868\4E2D\63D2\5165\3001\66F4\65B0\6216\522A\9664\8A18\9304\7684\8655\7406\4F5C\696D. \6B64\8655\7406\4F5C\696D\4E3B\8981\7528\4F86\8655\7406\4F86\6E90\70BA<strong>\8CC7\6599\5EAB\8CC7\6599\6B04</strong>\985E\578B\7684\8868\55AE\9805\76EE. Oracle \5EFA\8B70\60A8\5C07\6B64\8655\7406\4F5C\696D\985E\578B\66F4\65B0\70BA<strong>\81EA\52D5\8CC7\6599\5217\8655\7406 (DML)</strong>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(724250841038369418.4418)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSERT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\652F\63F4\7684\8CC7\6599\64CD\63A7\8A9E\8A00 (DML) \4F5C\696D.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408026159343735.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\63D2\5165')
,p_return_value=>'INSERT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408425080344291.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\66F4\65B0')
,p_return_value=>'UPDATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408824002344800.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\522A\9664')
,p_return_value=>'DELETE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086048865137952891.4418)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\683C\64C1\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\9078\53D6\8868\683C\64C1\6709\8005 (\7DB1\8981) \540D\7A31.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049161039954775.4418)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\8868\683C\540D\7A31')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(1086048865137952891.4418)
,p_help_text=>unistr('\8F38\5165\6709\5927\5C0F\5BEB\4E4B\5225\7684\8868\683C\6216\8996\89C0\8868\540D\7A31. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049455217957445.4418)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>unistr('\4E3B\7D22\5F15\9375\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4FDD\7559\4E3B\7D22\5F15\9375\8CC7\6599\6B04\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. \60A8\53EF\4EE5\8F38\5165\540D\7A31\6216\5F9E\6E05\55AE\4E2D\9078\64C7.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049751766959069.4418)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>unistr('\4E3B\7D22\5F15\9375\8CC7\6599\6B04')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(1086049161039954775.4418)
,p_help_text=>unistr('\9078\53D6\5167\542B\4E3B\7D22\5F15\9375\503C\7684\8CC7\6599\6B04. \5982\679C\8868\683C\5177\6709\591A\90E8\5206\4E3B\7D22\5F15\9375, \8ACB\9078\53D6 <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086053647281173911.4418)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\7A0B\5F0F\5BE6\969B\57F7\884C Where \5B50\53E5')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9650\5236\90E8\9580:</p>'),
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>unistr('\8F38\5165\8981\9644\52A0\81F3\6240\6709\7522\751F\4E4B SELECT\3001UPDATE \4EE5\53CA DELETE \6558\8FF0\53E5\7684 SQL WHERE \5B50\53E5. \60A8\53EF\4EE5\4F7F\7528\6B64\5C6C\6027\4F86\9650\5236\81EA\52D5\7522\751F\4E4B SQL \547C\53EB\5167\4F7F\7528\7684\8A18\9304.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/cancel_event
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1112790930653153311.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CANCEL_EVENT'
,p_display_name=>unistr('\53D6\6D88\4E8B\4EF6')
,p_category=>'MISC'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CANCEL_EVENT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\53D6\6D88\76EE\524D\7684\4E8B\4EF6.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1166598346362318406.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER'
,p_display_name=>unistr('\65E5\671F\9078\64C7\5668 (jQuery)')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\986F\793A\6587\5B57\6B04\4F4D\4E14\5E36\6709\884C\4E8B\66C6\5716\793A. \4E00\822C\4F7F\7528\8005\53EF\4EE5\76F4\63A5\5728\6587\5B57\9805\76EE\4E2D\8F38\5165\65E5\671F, \6216\8005\6309\4E00\4E0B\884C\4E8B\66C6\5716\793A, \5F9E\5373\73FE\5F0F\884C\4E8B\66C6\9078\53D6\65E5\671F\548C\6642\9593 (\9078\64C7\6027).</p>'),
unistr('<p>\6B64\9805\76EE\7684<em>\683C\5F0F\906E\7F69</em>\82E5\5305\62EC\6642\9593\5143\4EF6, \5373\73FE\5F0F\884C\4E8B\66C6\4E2D\624D\6703\986F\793A\6642\9593.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166599468441343733.4418)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6A19\793A\7684\65E5\671F')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>20090624</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_NEXT_AVAILABLE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\547C\53EB\5373\73FE\5F0F\884C\4E8B\66C6\5F8C\61C9\8A72\8981\5F37\8ABF\6A19\793A\7684\9810\8A2D\65E5\671F\503C. \82E5\672A\6307\5B9A, \884C\4E8B\66C6\6703\6A19\793A\76EE\524D\7684\65E5\671F\8207\6642\9593.</p>'),
unistr('<p>\503C\53EF\4EE5\662F <code>''YYYYMMDDHH24MI''</code> \683C\5F0F\7684\7D55\5C0D\503C, \6216\8005\8207\4ECA\5929\7684\65E5\671F\6709\95DC\7684\76F8\5C0D\503C (\4F8B\5982 <code>+7d</code>), \6216\8005\4F7F\7528\66FF\4EE3\8A9E\6CD5\7684\52D5\614B\503C, \4F46\689D\4EF6\70BA\66FF\4EE3\8A9E\6CD5\50B3\56DE\6B63\78BA\7684\65E5\671F\683C\5F0F\6216\76F8\5C0D\503C.</p>'),
unistr('<p>\76F8\5C0D\65E5\671F\503C\5305\62EC:</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \5E74\6578</dd>'),
'  <dt>m</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \6708\6578</dd>'),
'  <dt>w</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \9031\6578</dd>'),
'  <dt>d</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \5929\6578</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166598552726329767.4418)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6700\5C0F\65E5\671F')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\53EF\4EE5\8F38\5165\6216\9078\53D6\7684\6700\5C0F\65E5\671F.</p>'),
unistr('<p>\65E5\671F\503C\53EF\4EE5\662F <code>''YYYY-MM-DDTHH24:MI:SS''</code> \6216 <code>''YYYYMMDDHH24MI''</code> \683C\5F0F\7684\7D55\5C0D\503C, \6216\8005\8207\4ECA\5929\7684\65E5\671F\6709\95DC\7684\76F8\5C0D\503C (\4F8B\5982 <code>+7d</code>), \6216\8005\4F7F\7528\66FF\4EE3\8A9E\6CD5\7684\52D5\614B\503C, \4F46\689D\4EF6\70BA\66FF\4EE3\8A9E\6CD5\50B3\56DE\6B63\78BA\7684\65E5\671F\683C\5F0F\6216\76F8\5C0D\503C.</p>'),
unistr('<p>\76F8\5C0D\65E5\671F\503C\5305\62EC:</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \5E74\6578</dd>'),
'  <dt>m</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \6708\6578</dd>'),
'  <dt>w</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \9031\6578</dd>'),
'  <dt>d</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \5929\6578</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166598957228331042.4418)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6700\5927\65E5\671F')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\53EF\4EE5\8F38\5165\6216\9078\53D6\7684\6700\5927\65E5\671F.</p>'),
unistr('<p>\65E5\671F\503C\53EF\4EE5\662F <code>''YYYY-MM-DDTHH24:MI:SS''</code> \6216 <code>''YYYYMMDDHH24MI''</code> \683C\5F0F\7684\7D55\5C0D\503C, \6216\8005\8207\4ECA\5929\7684\65E5\671F\6709\95DC\7684\76F8\5C0D\503C (\4F8B\5982 <code>+7d</code>), \6216\8005\4F7F\7528\66FF\4EE3\8A9E\6CD5\7684\52D5\614B\503C, \4F46\689D\4EF6\70BA\66FF\4EE3\8A9E\6CD5\50B3\56DE\6B63\78BA\7684\65E5\671F\683C\5F0F\6216\76F8\5C0D\503C.</p>'),
unistr('<p>\76F8\5C0D\65E5\671F\503C\5305\62EC:</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \5E74\6578</dd>'),
'  <dt>m</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \6708\6578</dd>'),
'  <dt>w</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \9031\6578</dd>'),
'  <dt>d</dt>',
unistr('    <dd>\5F9E\4ECA\5929\65E5\671F\8D77\7B97\7684 + / - \5929\6578</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166599961992351304.4418)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\986F\793A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'button'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\986F\793A\65E5\671F\9078\64C7\5668\5373\73FE\5F0F\884C\4E8B\66C6\7684\6642\6A5F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975967945937309446.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\6210\70BA\7126\9EDE\6642')
,p_return_value=>'focus'
,p_help_text=>unistr('\7576\9805\76EE\53D6\5F97\7126\9EDE\6642, \6703\7ACB\5373\986F\793A\884C\4E8B\66C6\5373\73FE\5F0F\8996\7A97.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975968322865312246.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\9EDE\9078\5716\793A\6642')
,p_return_value=>'button'
,p_help_text=>unistr('\6309\4E00\4E0B\5716\793A\6642, \6703\986F\793A\884C\4E8B\66C6\5373\73FE\5F0F\8996\7A97.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975968729792314196.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\4E8C\8005')
,p_return_value=>'both'
,p_help_text=>unistr('\7576\9805\76EE\53D6\5F97\7126\9EDE\7136\5F8C\6309\4E00\4E0B\5716\793A\6642, \6703\7ACB\5373\986F\793A\884C\4E8B\66C6\5373\73FE\5F0F\8996\7A97.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(977131519506267935.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\5167\5D4C')
,p_return_value=>'inline'
,p_help_text=>unistr('\884C\4E8B\66C6\4E00\5F8B\6703\4EE5\5167\5D4C\65B9\5F0F\986F\793A\5728\9801\9762\4E0A. \4E0D\6703\986F\793A\6587\5B57\6B04\4F4D, \800C\76EE\524D\7684\65E5\671F\9078\9805\6703\53CD\767D\986F\793A\5728\884C\4E8B\66C6\4E0A.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166600445500356042.4418)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\986F\793A\5176\4ED6\6708\4EFD')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\662F\5426\986F\793A\4E0A\500B\6708\7684\524D\5C0E\65E5\671F\548C\4E0B\500B\6708\7684\5C3E\96A8\65E5\671F. \524D\5C0E\65E5\671F\548C\5C3E\96A8\65E5\671F\6703\5B8C\5168\586B\5165\884C\4E8B\66C6\7684\7B2C\4E00\884C\548C\6700\5F8C\4E00\884C. \4F8B\5982, \5982\679C\4E00\9031\7684\7B2C\4E00\5929\70BA\661F\671F\65E5, \4F46\662F\986F\793A\4E4B\7576\6708\7684\7B2C\4E00\5929\70BA\661F\671F\4E09\7684\8A71, \90A3\9EBC\6703\986F\793A\661F\671F\65E5\3001\661F\671F\4E00\4EE5\53CA\661F\671F\4E8C\70BA\4E0A\500B\6708\7684\6700\5F8C\4E09\5929.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166601947494375554.4418)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\6708\6578')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1166600445500356042.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>3</dt>',
unistr('    <dd>\6A6B\5411\986F\793A\4E09\500B\6708\4EFD.</dd>'),
'  <dt>[2,3]</dt>',
unistr('    <dd>\4EE5\5169\6A6B\5217\53CA\4E09\76F4\6B04\7684\65B9\5F0F, \986F\793A\516D\500B\6708\4EFD.</dd>'),
'  <dt>[4,3]</dt>',
unistr('    <dd>\4EE5\56DB\6A6B\5217\53CA\4E09\76F4\6B04\7684\65B9\5F0F, \986F\793A\5341\4E8C\500B\6708\4EFD.</dd>'),
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\5373\73FE\5F0F\884C\4E8B\66C6\4E2D\8981\986F\793A\7684\6708\4EFD\6578.</p>'),
unistr('<p>\60A8\53EF\4EE5\8F38\5165\6574\6578\503C, \6216\8005\8F38\5165\4F7F\7528 <code>[<em>row,column</em>]</code> \8868\793A\7684\4E8C\7DAD\9663\5217, \4EE5\5B9A\7FA9\8981\986F\793A\7684\5217\6578\548C\6B04\6578</p>'),
unistr('<p><em>\6CE8\610F: \6703\986F\793A<strong>\6A19\793A\7684\65E5\671F</strong>\4E4B\5F8C\7684\6708\4EFD.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166602447625385046.4418)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\5C0E\89BD\6E05\55AE - ')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\662F\8981\91DD\5C0D\5373\73FE\5F0F\884C\4E8B\66C6\5167\7684\300C\6708\4EFD\300D\548C (\6216)\300C\5E74\5EA6\300D\63D0\4F9B\9078\53D6\6E05\55AE.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785072709337552768.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4418)
,p_display_sequence=>5
,p_display_value=>unistr('\7121')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785071421673546859.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\6708\4EFD')
,p_return_value=>'MONTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785071825829548006.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5E74\5EA6')
,p_return_value=>'YEAR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785072306567551978.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\6708\4EFD\548C\5E74\5EA6')
,p_return_value=>'MONTH_AND_YEAR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166600943554364880.4418)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\5E74\5EA6\7BC4\570D')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1166602447625385046.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'YEAR,MONTH_AND_YEAR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>2000:2010</dt>',
unistr('    <dd>\4F7F\7528\7D55\5C0D\5E74\4EFD, \5C07\5141\8A31\7684\5E74\4EFD\9650\5236\5728 2000 \8207 2010 \4E4B\9593 (\542B).</dd>'),
'  <dt>-05:+05</dt>',
unistr('    <dd>\4F7F\7528\76F8\5C0D\65E5\671F, \5C07\5141\8A31\7684\5E74\4EFD\9650\5236\5728\76EE\524D\5E74\4EFD\7684\524D\5F8C\4E94\5E74.</dd>'),
'  <dt>+01:+03</dt>',
unistr('    <dd>\4F7F\7528\76F8\5C0D\65E5\671F, \5C07\5141\8A31\7684\5E74\4EFD\9650\5236\5728\660E\5E74\4E4B\5F8C\7684\5169\5E74.</dd>'),
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\5373\73FE\5F0F\884C\4E8B\66C6\5167<strong>\5E74\5EA6</strong>\9078\53D6\6E05\55AE\4E2D\986F\793A\7684\5141\8A31\5E74\5EA6\7BC4\570D.</p>'),
unistr('<p>\5E74\5EA6\503C\53EF\4EE5\662F <code>''YYYY:YYYY''</code> \683C\5F0F\7684\7D55\5C0D\503C, \6216\8005\4F7F\7528 <code>''-nn:+nn''</code> \683C\5F0F\7684\76F8\5C0D\503C, \5176\4E2D <code>nn</code> \70BA\6574\6578\503C.')))
);
end;
/
prompt --application/shared_components/plugins/item_type/text_field
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1230861140507488144.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXT_FIELD'
,p_display_name=>unistr('\6587\5B57\6B04\4F4D')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXT_FIELD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\986F\793A\6587\5B57\6B04\4F4D.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230861330595494795.4418)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('\6309 Enter \6642\9001\51FA')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\5728\6B64\6B04\4F4D\4E2D\6642\82E5\6309 <em>Enter</em> \9375, \662F\5426\6703\81EA\52D5\9001\51FA\9801\9762.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230861822761501984.4418)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>unistr('\505C\7528')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\505C\7528\6B64\9805\76EE, \8B93\4E00\822C\4F7F\7528\8005\4E0D\80FD\8B8A\66F4\503C.</p>'),
unistr('<p>\505C\7528\7684\6587\5B57\9805\76EE\4ECD\6703\4EE5\76F8\540C\7684 HTML \683C\5F0F\986F\793A, \9019\4E00\9EDE\8207\6703\79FB\9664 HTML \683C\5F0F\7684<em>\50C5\986F\793A</em>\9805\76EE\985E\578B\4E0D\540C. \505C\7528\7684\6587\5B57\9805\76EE\662F\9801\9762\4F86\6E90\7684\4E00\90E8\5206, \56E0\6B64\9084\662F\6703\8A55\4F30\5176\968E\6BB5\4F5C\696D\72C0\614B. \76F8\53CD\5730, \50C5\4F9B\986F\793A\7684\9805\76EE\4E0D\6703\5132\5B58\5728\968E\6BB5\4F5C\696D\72C0\614B\4E2D.</p>')))
,p_attribute_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$ DJP  - Is this equivalent to specifying Read Only = Always?',
'If so do we need this attribute?'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230862319775510558.4418)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('\9001\51FA\9801\9762\6642\50B3\9001')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1230861822761501984.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\6307\5B9A\9001\51FA\9801\9762\5F8C\662F\5426\61C9\50B3\9001\76EE\524D\7684\9805\76EE\503C.')
,p_attribute_comment=>'$$$ DJP - Why can this only be set when Disabled = Y?'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2642009195904118.4418)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>10
,p_prompt=>unistr('\5B50\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'TEXT'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9078\53D6 HTML5 \6587\5B57\5B50\985E\578B. \5982\6B64\53EF\8B93\5177\6709\87A2\5E55\9375\76E4\7684\88DD\7F6E\986F\793A\8A72\5B50\985E\578B\7279\5B9A\7684\6700\4F73\5316\9375\76E4\7248\9762\914D\7F6E, \4EE5\65B9\4FBF\8F38\5165\8CC7\6599. \9078\53D6\7684\5B50\985E\578B\4E5F\53EF\7528\4F86\4EE5\9801\9762\9805\76EE\503C\5448\73FE\9069\7576\7684\9023\7D50 (\50C5\9650\65BC\552F\8B80\5448\73FE). \4F7F\7528\5BE6\9AD4\9375\76E4\6642, \6B64\5C6C\6027\4E0D\6703\8B8A\66F4\6587\5B57\9805\76EE\6216\8CC7\6599\8F38\5165.  '),
'</p>',
unistr('<p><strong><em>\6CE8\610F:</strong> \6B64 HTML5 \529F\80FD\53EA\80FD\5920\5728\73FE\4EE3\700F\89BD\5668\4E2D\904B\4F5C. \8F03\820A\4E14\975E HTML5 \76F8\5BB9\7684\700F\89BD\5668\6703\5FFD\7565\6B64\5C6C\6027\4E26\5C07\9801\9762\9805\76EE\8996\70BA\4E00\822C\6587\5B57\6B04\4F4D\5448\73FE.</em></p>')))
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be for Mobile UI only?'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4337919498933328.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4418)
,p_display_sequence=>5
,p_display_value=>unistr('\6587\5B57')
,p_return_value=>'TEXT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2643201361911326.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\96FB\5B50\90F5\4EF6')
,p_return_value=>'EMAIL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2643606901912900.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\96FB\8A71\865F\78BC')
,p_return_value=>'TEL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(228427524363055714.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4418)
,p_display_sequence=>25
,p_display_value=>unistr('\641C\5C0B')
,p_return_value=>'SEARCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2644810018913786.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4418)
,p_display_sequence=>30
,p_display_value=>'URL'
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362145212820086745.4418)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>15
,p_prompt=>unistr('\79FB\9664\7A7A\683C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\9001\51FA\9801\9762\4E4B\5F8C\4FEE\526A\9805\76EE\503C\7684\65B9\5F0F. \9019\9805\8A2D\5B9A\6703\79FB\9664\8F38\5165\6587\5B57\7684\7A7A\683C\3001\5B9A\4F4D\4EE5\53CA\65B0\884C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362145508722088644.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\524D\5C0E')
,p_return_value=>'LEADING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362145906566089618.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5C3E\96A8')
,p_return_value=>'TRAILING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362146304625090506.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\524D\5C0E\548C\5C3E\96A8')
,p_return_value=>'BOTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362147027041095284.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\7121')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(580485075516965313.4418)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>16
,p_prompt=>unistr('\6587\5B57\5927\5C0F\5BEB')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('\6C92\6709\8B8A\66F4')
,p_help_text=>unistr('\9078\53D6\9805\76EE\503C\6587\5B57\5927\5C0F\5BEB\7684\8F49\63DB\65B9\5F0F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(580485397894966793.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(580485075516965313.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5C0F\5BEB')
,p_return_value=>'LOWER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(580485762023967520.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(580485075516965313.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5927\5BEB')
,p_return_value=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/hidden
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1230888011377927220.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HIDDEN'
,p_display_name=>unistr('\96B1\85CF')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HIDDEN'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\5305\542B\5728\9801\9762\4F86\6E90\5167\4F46\4E0D\6703\88AB\986F\793A\7684\9805\76EE. \96B1\85CF\7684\9805\76EE\503C\5132\5B58\5728\968E\6BB5\4F5C\696D\72C0\614B\4E2D. \5B83\5011\901A\5E38\7528\4F86\5132\5B58\9801\9762\8655\7406\6216\5176\4ED6\9801\9762\9805\76EE\6240\9700\7684\503C, \800C\4E14\4E0D\80FD\70BA\4E00\822C\4F7F\7528\8005\6240\898B.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230888530209942193.4418)
,p_plugin_id=>wwv_flow_api.id(1230888011377927220.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\503C\53D7\4FDD\8B77')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\9805\76EE\662F\5426\53D7\4FDD\8B77, \8B93\503C\5728\9801\9762\5F35\8CBC\5F8C\4E0D\6703\88AB\7AC4\6539.')
);
end;
/
prompt --application/shared_components/plugins/item_type/display_image
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1411721528366264478.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_IMAGE'
,p_display_name=>unistr('\986F\793A\5F71\50CF')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_IMAGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A\5132\5B58\5728\8CC7\6599\5EAB BLOB \8CC7\6599\6B04\4E2D\6216\5F71\50CF URL \6240\6307\7684\5F71\50CF.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411722225512282537.4418)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6839\64DA')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\64F7\53D6\5F71\50CF\7684\4F86\6E90\4F4D\7F6E.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1411722839364286570.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\9801\9762\9805\76EE\503C\4E2D\5132\5B58\7684\5F71\50CF URL')
,p_return_value=>'URL'
,p_help_text=>unistr('\5F71\50CF URL \8B80\53D6\81EA\5132\5B58\5728\6307\5B9A\9801\9762\9805\76EE\968E\6BB5\4F5C\696D\72C0\614B\7684\503C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1411723213999298173.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\9805\76EE\4F86\6E90\4E2D\6307\5B9A\7684 BLOB \8CC7\6599\6B04')
,p_return_value=>'DB_COLUMN'
,p_help_text=>unistr('\5F9E<strong>\9805\76EE\4F86\6E90</strong>\5C6C\6027\4E2D\6307\5B9A\7684 BLOB \8CC7\6599\6B04\8B80\53D6\5F71\50CF.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(967663732298251689.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4418)
,p_display_sequence=>30
,p_display_value=>unistr('SQL \6558\8FF0\53E5\50B3\56DE\7684 BLOB \8CC7\6599\6B04')
,p_return_value=>'SQL'
,p_help_text=>unistr('\6839\64DA\6307\5B9A\4E4B SQL \6558\8FF0\53E5\50B3\56DE\7684 BLOB \8CC7\6599\6B04\986F\793A\5F71\50CF.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411726413054354627.4418)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\66FF\4EE3\6587\5B57')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_help_text=>unistr('\8F38\5165\7576\4E00\822C\4F7F\7528\8005\700F\89BD\6B64\9805\76EE\6642, \87A2\5E55\52A9\8B80\7A0B\5F0F\6240\8B80\53D6\7684\6587\5B57.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(483911502060080155.4418)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\66FF\4EE3\6587\5B57\8CC7\6599\6B04')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\4EE5\5927\5BEB\8F38\5165\7528\65BC\4FDD\7559\6B64\5F71\50CF\4E4B\66FF\4EE3\6587\5B57\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE\540D\7A31. \87A2\5E55\52A9\8B80\7A0B\5F0F\6703\5728\4E00\822C\4F7F\7528\8005\700F\89BD\81F3\6B64\9805\76EE\6642\8B80\53D6\6B64\6587\5B57.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411725016255336668.4418)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6A94\6848\540D\7A31\8CC7\6599\6B04')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\4EE5\5927\5BEB\8F38\5165\4FDD\7559\8207 BLOB \8CC7\6599\6B04\95DC\806F\4E4B\6A94\6848\540D\7A31\8CC7\6599\6B04\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE\540D\7A31.')
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411725531492341063.4418)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('BLOB \4E0A\6B21\66F4\65B0\6642\9593\8CC7\6599\6B04')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5\5927\5BEB\8F38\5165\4FDD\7559\95DC\806F\4E4B BLOB \4E0A\6B21\66F4\65B0\65E5\671F\8CC7\6599\6B04\503C\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE\540D\7A31.</p>'),
unistr('<p>\9019\500B\503C\7528\65BC\700F\89BD\5668\5FEB\53D6, \7528\4EE5\8B58\5225\81EA\4E0A\6B21\5F9E\700F\89BD\5668\8981\6C42\5F71\50CF\5F8C, \5F71\50CF\662F\5426\8B8A\66F4\904E. \5982\679C\5F71\50CF\4E26\672A\66F4\65B0, \5C31\6703\5F9E\700F\89BD\5668\5FEB\53D6\64F7\53D6\5F71\50CF (\5982\679C\53EF\4EE5\7684\8A71).</p>')))
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(967666433253270876.4418)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>unistr('SQL \6558\8FF0\53E5')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select product_image,',
'       product_name as alt_text,',
'       filename,',
'       mimetype',
'  from demo_product_info',
' where product_id = :P6_PRODUCT_ID',
'</pre>'))
,p_help_text=>unistr('\8F38\5165\50B3\56DE\5167\542B\5F71\50CF\4E4B BLOB \8CC7\6599\6B04\7684 SQL \6558\8FF0\53E5.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91302656605713331.4418)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>50
,p_prompt=>unistr('MIME \985E\578B\8CC7\6599\6B04')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\4EE5\5927\5BEB\8F38\5165\7528\65BC\5132\5B58\5DF2\4E0A\50B3\6A94\6848\4E4B MIME \985E\578B\7684\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE\540D\7A31. \700F\89BD\5668\6703\4F7F\7528 MIME \985E\578B\4F86\8B58\5225\61C9\8A72\4F7F\7528\54EA\500B\61C9\7528\7A0B\5F0F\986F\793A\4E0B\8F09\4E4B\6A94\6848\7684 BLOB \5167\5BB9.')
);
end;
/
prompt --application/shared_components/plugins/item_type/auto_complete
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1446346919506821055.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'AUTO_COMPLETE'
,p_display_name=>unistr('\542B\81EA\52D5\5B8C\6210\529F\80FD\7684\300C\6587\5B57\6B04\4F4D\300D')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','AUTO_COMPLETE'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.inputSearch#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_validation_function=>'dummy'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:CASCADING_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A\6587\5B57\6B04\4F4D, \5176\4E2D\6703\6839\64DA\4E00\822C\4F7F\7528\8005\5DF2\7D93\8F38\5165\7684\6587\5B57\986F\793A\53EF\80FD\7684\503C\6E05\55AE, \4E14\5167\5D4C\5728\6587\5B57\9805\76EE\4E2D. \96A8\8457\4E00\822C\4F7F\7528\8005\8F38\5165\66F4\591A\7684\6587\5B57, \6E05\55AE\4E5F\6703\96A8\8457\9032\4E00\6B65\8ABF\6574.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446356110531045518.4418)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\641C\5C0B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CONTAINS_IGNORE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\5982\4F55\6839\64DA\8F38\5165\7684\503C\9032\884C\641C\5C0B. \5982\679C\4F7F\7528<em>\9072\7DE9\8F09\5165</em>, \9019\9805\8A2D\5B9A\53EF\80FD\6703\5F71\97FF\67E5\8A62\6548\80FD.</p>'),
unistr('<p><em>\6CE8\610F: \5982\679C\9078\53D6<strong>\5305\542B\4E14\6709\5927\5C0F\5BEB\4E4B\5225</strong>\6216<strong>\5305\542B\4E14\5FFD\7565\5927\5C0F\5BEB</strong>, \5C31\4E0D\80FD\4F7F\7528\8CC7\6599\6B04\7D22\5F15.</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406465150066557.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5305\542B\4E14\6709\5927\5C0F\5BEB\4E4B\5225')
,p_return_value=>'CONTAINS_CASE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406557760066557.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5B8C\5168\76F8\7B26\4E14\6709\5927\5C0F\5BEB\4E4B\5225')
,p_return_value=>'EXACT_CASE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406651197066557.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\5305\542B\4E14\5FFD\7565\5927\5C0F\5BEB')
,p_return_value=>'CONTAINS_IGNORE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406756688066558.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\5B8C\5168\76F8\7B26\4E14\5FFD\7565\5927\5C0F\5BEB')
,p_return_value=>'EXACT_IGNORE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446360005383072413.4418)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\9072\7DE9\8F09\5165')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\4F7F\7528<em>\9072\7DE9\8F09\5165</em>\6280\8853\5F9E\8CC7\6599\5EAB\64F7\53D6\76F8\7B26\7684\503C. \6BCF\6B21\4F7F\7528\8005\8F38\5165\67D0\500B\5B57\5143\6642, \9072\7DE9\8F09\5165\529F\80FD\5C31\6703\5F9E\8CC7\6599\5EAB\64F7\53D6\76F8\7B26\7684\8A18\9304. \5426\5247, \6703\5728\9801\9762\8F09\5165\6642\8F09\5165\6240\6709\6E05\55AE\503C.</p>'),
unistr('<p>\5982\679C\60A8\7684\9078\53D6\6E05\55AE\5305\542B\975E\5E38\591A\7684\9805\76EE, Oracle \5EFA\8B70\60A8\4F7F\7528<em>\9072\7DE9\8F09\5165</em>, \56E0\70BA\8F09\5165\5927\91CF\8A18\9304\53EF\80FD\6703\5F71\97FF\521D\6B21\8F09\5165\9801\9762\7684\6642\9593.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446361019928076629.4418)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\6E05\55AE\4E2D\503C\6578\76EE\7684\4E0A\9650')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1446360005383072413.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\9078\53D6\65B9\584A\4E2D\6240\80FD\986F\793A\7684\9805\76EE\6578\4E0A\9650.</p> '),
unistr('<p>\9019\500B\503C\53EF\5E6B\52A9\907F\514D\56E0\50B3\56DE\592A\591A\8CC7\6599\5217\800C\7522\751F\7684\6548\80FD\554F\984C, \540C\6642\4E5F\53EF\907F\514D\53EA\8F38\5165\5E7E\500B\5B57\6BCD\4F46\50B3\56DE\4E00\5927\7D44\8CC7\6599\7684\60C5\5F62.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(224532777127157782.4418)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\6700\5C11\641C\5C0B')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_show_in_wizard=>false
,p_unit=>unistr('\500B\5B57\5143')
,p_is_translatable=>false
,p_help_text=>unistr('<p>\6307\5B9A\5FC5\9808\8F38\5165\591A\5C11\5B57\5143\6578\624D\80FD\57F7\884C\641C\5C0B.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388196560996701804.4418)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>45
,p_prompt=>unistr('\5FEB\53D6')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1446360005383072413.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\6307\5B9A\4F7F\7528\300C\9072\7DE9\8F09\5165\300D\64F7\53D6\76F8\7B26\7684\8A18\9304\6642, \662F\5426\8981\5FEB\53D6\641C\5C0B\7D50\679C.</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845152901732834477.4418)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4418)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5728\9801\9762\9805\76EE\4E2D\986F\793A\4E26\5132\5B58\76F8\540C\7684\503C</dt>'),
'<dd><pre>',
'select ename',
'  from emp',
' order by 1',
'</pre></dd>',
unistr('<dt>\4F7F\7528\9023\7D50\8B8A\6578\986F\793A\7279\5B9A\90E8\9580\7684\54E1\5DE5</dt>'),
'<dd><pre>',
'select ename',
'  from emp',
' where deptno = :P3_DEPTNO',
' order by 1',
'</pre>',
unistr('<p>\6CE8\610F: \5982\679C <code>P3_DEPTNO</code> \662F\76F8\540C\9801\9762\4E0A\7684\53EF\4FEE\6539\9801\9762\9805\76EE, \8ACB\5C07<em>\968E\5C64\5F0F LOV \7236\9805\9805\76EE</em>\5C6C\6027\8A2D\70BA <code>P3_DEPTNO</code>.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(345454551021287898.4418)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4418)
,p_name=>'ojupdate'
,p_display_name=>unistr('\66F4\65B0')
);
end;
/
prompt --application/shared_components/plugins/item_type/rich_text_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1630055805138100682.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RICH_TEXT_EDITOR'
,p_display_name=>unistr('Rich Text \7DE8\8F2F\5668')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RICH_TEXT_EDITOR'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A\542B\5B8C\5099\6587\5B57\683C\5F0F\9078\9805\7684\6587\5B57\5340. \4E00\822C\4F7F\7528\8005\53EF\4EE5\4F7F\7528\50CF Microsoft Word \7B49\7684\6587\5B57\8655\7406\5668, \4EE5\76F8\4F3C\7684\65B9\5F0F\589E\5F37\986F\793A\7684\5167\5BB9. \4E00\822C\4F7F\7528\8005\4E5F\53EF\4EE5\5229\7528<em>\526A\4E0B\4E26\8CBC\4E0A</em>, \5C07 RTF \6A94\6848\683C\5F0F\7684\6587\4EF6\526A\4E0B\4E26\8CBC\5230\6B64\9805\76EE\4E2D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1343844517421090812.4418)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\56DE\61C9\5F0F [\5DF2\88AB\53D6\4EE3]')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A Rich Text \7DE8\8F2F\5668\662F\5426\61C9\7576\81EA\52D5\8ABF\6574\70BA\5BB9\5668\5340\57DF\5927\5C0F. \61C9\7528\7A0B\5F0F\5FC5\9808\4F7F\7528\300C\901A\7528\4E3B\984C\300D\6216\5176\4ED6\56DE\61C9\5F0F\4E3B\984C\624D\80FD\9019\9EBC\505A.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630056002845109474.4418)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5DE5\5177\5217')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'Intermediate'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(635934396859331517.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\7DE8\8F2F\5668\5167\53EF\7528\7684\6587\5B57\683C\5F0F\9078\9805\6578\76EE.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630056586699114299.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\57FA\672C')
,p_return_value=>'Basic'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1263397500002270668.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\4ECB\65BC\4E2D\9593')
,p_return_value=>'Intermediate'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630056989123115033.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\5B8C\6574')
,p_return_value=>'Full'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630057694103125908.4418)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\5DE5\5177\5217\5DF2\5C55\958B')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_help_text=>unistr('\6307\5B9A\6700\521D\662F\5426\5728\6587\5B57\5340\5167\5C55\958B\7DE8\8F2F\5668.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630058192849134992.4418)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\5916\89C0')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\7DE8\8F2F\5668\7684\7DE8\8F2F\5668\5916\89C0.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630058796312136026.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4418)
,p_display_sequence=>1
,p_display_value=>'Moono'
,p_return_value=>'moono'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1637507209047437360.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4418)
,p_display_sequence=>2
,p_display_value=>'Moono Color'
,p_return_value=>'moonocolor'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630059200467137193.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4418)
,p_display_sequence=>3
,p_display_value=>'Kama'
,p_return_value=>'kama'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1270283182212293963.4418)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\5DE5\5177\5217\4F4D\7F6E')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'top'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\6587\5B57\5340\4E2D\7DE8\8F2F\5668\7684\986F\793A\4F4D\7F6E.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1270283477898295997.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1270283182212293963.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\9802\7AEF')
,p_return_value=>'top'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1270283876173296808.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1270283182212293963.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5E95\7AEF')
,p_return_value=>'bottom'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262285287257225297.4418)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>5
,p_prompt=>unistr('\7248\672C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'CK Editor 5'
,p_deprecated_values=>'4'
,p_help_text=>unistr('<p>CKEditor 4 \5DF2\4E0D\518D\4F7F\7528, \5F88\5FEB\5C31\6703\7531 CKEditor 5 \53D6\4EE3. \70BA\4E86\4E0D\8B93\60A8\7684\61C9\7528\7A0B\5F0F\9762\81E8\672A\4F86\7248\672C\4E2D\65B7\7684\98A8\96AA, \73FE\5728\662F\9032\884C\6B64\8B8A\63DB\7684\6700\4F73\6642\6A5F. \82E5\60A8\5DF2\4F7F\7528\4EFB\4E00\81EA\8A02\300C\521D\59CB\5316 Javascript \7A0B\5F0F\78BC\300D, \5247\8ACB\6CE8\610F CKEditor \7684 API \5DF2\8B8A\66F4, \56E0\6B64\60A8\7684\7A0B\5F0F\78BC\5F88\53EF\80FD\9700\8981\8ABF\6574.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1262285918525227088.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1262285287257225297.4418)
,p_display_sequence=>10
,p_display_value=>unistr('CK Editor 4 [\5DF2\88AB\53D6\4EE3]')
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262287152809234036.4418)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\9AD8\5EA6\4E0B\9650')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'180'
,p_display_length=>100
,p_unit=>unistr('\50CF\7D20')
,p_is_translatable=>false
,p_help_text=>unistr('\8A2D\5B9A\53EF\7DE8\8F2F\5340\57DF\7684\9AD8\5EA6\4E0B\9650 (\50CF\7D20).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262288044006238954.4418)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\6700\5927\9AD8\5EA6')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>100
,p_unit=>unistr('\50CF\7D20')
,p_is_translatable=>false
,p_help_text=>unistr('\8A2D\5B9A\53EF\7DE8\8F2F\5340\57DF\7684\9AD8\5EA6\4E0A\9650 (\50CF\7D20). \6B64\5C6C\6027\82E5\7559\767D, \5247\7DE8\8F2F\5668\5C07\96A8\8457\60A8\7684\8F38\5165\7121\9650\5EF6\9577.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(635934396859331517.4418)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>1
,p_prompt=>unistr('\683C\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MARKDOWN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A Rich Text \7DE8\8F2F\5668\4E2D\6240\8F38\5165\5167\5BB9\7684\8F38\51FA\683C\5F0F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(635934864536336814.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(635934396859331517.4418)
,p_display_sequence=>10
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>unistr('\4F7F\7528 HTML \4F5C\70BA\6B64 Rich Text \7DE8\8F2F\5668\7684\4F86\6E90\548C\8F38\51FA.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(635935286305339196.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(635934396859331517.4418)
,p_display_sequence=>20
,p_display_value=>'Markdown'
,p_return_value=>'MARKDOWN'
,p_help_text=>unistr('\4F7F\7528 Markdown \683C\5F0F\4F5C\70BA\6B64 Rich Text \7DE8\8F2F\5668\7684\4F86\6E90\548C\8F38\51FA.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3112575602612766963.4418)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4418)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function(options){',
'    // disable the Autoformat feature',
'    options.editorOptions.removePlugins.push(''Autoformat'');',
'    // apply a custom toolbar',
'    options.editorOptions.toolbar = [',
'        ''heading'', ''bulletedList'', ''numberedList'', ''fontSize'', ''undo'', ''redo''',
'    ];',
'    return options;',
'}',
'</pre>'))
,p_help_text=>unistr('\8F38\5165\7528\4EE5\8986\5BEB\6A19\6E96\7DE8\8F2F\5668\7D44\614B\7684 JavaScript \51FD\6578. CKEditor5 \7279\5B9A\9078\9805\61C9\5957\7528\81F3 <code>options.editorOptions</code>. \8ACB\53C3\95B1 CKEditor5 API \6587\4EF6\4EE5\77AD\89E3\8A73\7D30\8CC7\8A0A.')
);
end;
/
prompt --application/shared_components/plugins/item_type/color_picker
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1779772489424311086.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COLOR_PICKER'
,p_display_name=>unistr('\8272\5F69\9078\64C7\5668')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COLOR_PICKER'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5141\8A31\4F7F\7528\8005\9078\64C7\6216\8F38\5165\8272\5F69. \60A8\53EF\4EE5\5F9E\8272\5F69\983B\8B5C\9078\53D6\8272\5F69.')
,p_version_identifier=>'2.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550403250259918560.4418)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('\6A21\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551367544301244965.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\8981\5728\8272\5F69\9078\64C7\5668\986F\793A\7684\8CC7\8A0A\91CF.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550403921767922285.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(550403250259918560.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7C21\55AE')
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('\50C5\986F\793A\8272\5F69\983B\8B5C\63A7\5236\548C\8272\5F69\9810\5148\8A2D\5B9A (\5982\679C\5DF2\5B9A\7FA9).')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550404269414923460.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(550403250259918560.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5B8C\6574')
,p_return_value=>'FULL'
,p_help_text=>unistr('\986F\793A\5176\4ED6\6B04\4F4D\4EE5\6AA2\8996\8272\5F69, \6216\6839\64DA\300C\50B3\56DE\503C\578B\5F0F\300D\4EE5\5341\516D\9032\4F4D\3001HSL \6216 RGB \503C\548C\9078\64C7\6027 Alpha \503C\8F38\5165\8272\5F69. \4E5F\6703\986F\793A\521D\59CB\548C\76EE\524D\8272\5F69.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551367544301244965.4418)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\986F\793A\65B9\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\8272\5F69\9078\64C7\5668\7684\986F\793A\65B9\5F0F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368003116247557.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5373\73FE\5F0F')
,p_return_value=>'POPUP'
,p_help_text=>unistr('\60A8\53EF\4EE5\5728\6587\5B57\6B04\4F4D\8F38\5165\8272\5F69, \6216\5F9E\5373\73FE\5F0F\8272\5F69\9078\64C7\5668\9078\53D6.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368367822248327.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5167\5D4C')
,p_return_value=>'INLINE'
,p_help_text=>unistr('\4EE5\5167\5D4C\65B9\5F0F\986F\793A\8272\5F69\9078\64C7\5668.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368820390249888.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\8272\5F69\5373\73FE\5F0F')
,p_return_value=>'COLOR_ONLY'
,p_help_text=>unistr('\958B\555F\5373\73FE\5F0F\8272\5F69\9078\64C7\5668\7684\6309\9215.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551469948272853196.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\539F\751F\8272\5F69\9078\64C7\5668')
,p_return_value=>'NATIVE'
,p_help_text=>unistr('\539F\751F\700F\89BD\5668\8272\5F69\8F38\5165. UI \53D6\6C7A\65BC\700F\89BD\5668.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(630450561726642679.4418)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\4F7F\7528\9810\8A2D\503C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\4F7F\7528\5728\300C\5171\7528\7684\5143\4EF6\300D>\300C\5143\4EF6\8A2D\5B9A\503C\300D\4E2D\70BA\6B64\5143\4EF6\5B9A\7FA9\7684\9810\8A2D\503C, \6216\81EA\8A02\8A2D\5B9A\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550407832783006227.4418)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>unistr('\6A21\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(630450561726642679.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\53D6\8272\5F69\9078\64C7\5668\8981\986F\793A\7684\8CC7\8A0A\91CF.</p>'),
unistr('<p>\8ACB\6CE8\610F,\300C\986F\793A\65B9\5F0F\300D\70BA\300C\539F\751F\8272\5F69\9078\64C7\5668\300D\6642, \4E0D\9069\7528\6B64\9078\9805.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550408418705007375.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(550407832783006227.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7C21\55AE')
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('\50C5\986F\793A\8272\5F69\983B\8B5C\63A7\5236\548C\8272\5F69\9810\5148\8A2D\5B9A (\5982\679C\5DF2\5B9A\7FA9).')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550408900996015864.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(550407832783006227.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5B8C\6574')
,p_return_value=>'FULL'
,p_help_text=>unistr('\986F\793A\5176\4ED6\6B04\4F4D\4EE5\6AA2\8996\8272\5F69, \6216\6839\64DA\300C\50B3\56DE\503C\578B\5F0F\300D\4EE5\5341\516D\9032\4F4D\3001HSL \6216 RGB \503C\548C\9078\64C7\6027 Alpha \503C\8F38\5165\8272\5F69. \4E5F\6703\986F\793A\521D\59CB\548C\76EE\524D\8272\5F69.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550764493023397466.4418)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>unistr('\986F\793A\65B9\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(630450561726642679.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\8272\5F69\9078\64C7\5668\7684\986F\793A\65B9\5F0F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550765244915400562.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5373\73FE\5F0F')
,p_return_value=>'POPUP'
,p_help_text=>unistr('\60A8\53EF\4EE5\5728\6587\5B57\6B04\4F4D\8F38\5165\8272\5F69, \6216\5F9E\5373\73FE\5F0F\8272\5F69\9078\64C7\5668\9078\53D6.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550764781445398986.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5167\5D4C')
,p_return_value=>'INLINE'
,p_help_text=>unistr('\4EE5\5167\5D4C\65B9\5F0F\986F\793A\8272\5F69\9078\64C7\5668.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550765575345402504.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\8272\5F69\5373\73FE\5F0F')
,p_return_value=>'COLOR_ONLY'
,p_help_text=>unistr('\958B\555F\5373\73FE\5F0F\8272\5F69\9078\64C7\5668\7684\6309\9215.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551473676631880984.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\539F\751F\8272\5F69\9078\64C7\5668')
,p_return_value=>'NATIVE'
,p_help_text=>unistr('\539F\751F\700F\89BD\5668\8272\5F69\8F38\5165. UI \53D6\6C7A\65BC\700F\89BD\5668.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551688608315986495.4418)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\8272\5F69\9810\5148\8A2D\5B9A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THEME_STYLE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\8272\5F69\9078\64C7\5668\662F\5426\61C9\986F\793A\4E00\7D44\9810\5148\5B9A\7FA9\7684\8272\5F69, \82E5\8981\986F\793A, \61C9\4F7F\7528\4E3B\984C\7684\8272\5F69\6216\81EA\8A02\8272\5F69.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689124385987538.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7121')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689545726989556.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\4E3B\984C\6A23\5F0F\8272\5F69')
,p_return_value=>'THEME_STYLE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689930702991102.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\81EA\8A02\8272\5F69')
,p_return_value=>'CUSTOM'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551690436138997704.4418)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\8272\5F69')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551688608315986495.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CUSTOM'
,p_examples=>'#FF0000;#00FF00;#0000FF;rgb(27,204,119)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8272\5F69\9078\64C7\5668\5C0D\8A71\65B9\584A\4E2D\6240\8981\986F\793A\7684\9810\5148\8A2D\5B9A\8272\5F69\6E05\55AE.'),
unistr('\4F7F\7528\5206\865F\5340\9694\8272\5F69.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551690938640005057.4418)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\5C0D\6BD4\5C0D\8C61')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5141\8A31\5C07\6B64\9805\76EE\7684\8272\5F69\8207\5176\4ED6\9805\76EE\8272\5F69\6216\975C\614B\503C\6BD4\8F03, \4E26\5C07\5169\8005\7684\5C0D\6BD4\5EA6\986F\793A\5728\8272\5F69\9078\64C7\5668 UI \4E2D.  '),
unistr('\9019\6709\52A9\65BC\4F7F\7528\8005\9078\64C7\5C0D\6BD4\5EA6\8DB3\5920\7684\8272\5F69, \8B93\6BCF\500B\4EBA\66F4\5BB9\6613\4F7F\7528.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551691368715005731.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7121')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551691786900007756.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\9801\9762\9805\76EE')
,p_return_value=>'PAGE_ITEM'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551692243251008710.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\975C\614B\8272\5F69')
,p_return_value=>'STATIC'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551692721781014969.4418)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\5C0D\6BD4\9805\76EE')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551690938640005057.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>unistr('\7528\65BC\5C0D\6BD4\6BD4\8F03\7684\9805\76EE.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551693186879019659.4418)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\5C0D\6BD4\8272\5F69')
,p_attribute_type=>'COLOR'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551690938640005057.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>unistr('\7528\65BC\5C0D\6BD4\6BD4\8F03\7684\8272\5F69.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(549148889210907047.4418)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\50B3\56DE\503C\578B\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HEX'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\6B64\9805\76EE\50B3\56DE\7684\8272\5F69\503C\683C\5F0F. \5373\4F7F\8272\5F69\4EE5\4E0D\540C\7684\6709\6548\683C\5F0F\8F38\5165, \4E5F\80FD\4EE5\6B64\683C\5F0F\986F\793A\3001\50B3\56DE\548C\50B3\9001\5230\4F3A\670D\5668.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549149330423908665.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5341\516D\9032\4F4D')
,p_return_value=>'HEX'
,p_help_text=>unistr('\5341\516D\9032\4F4D\8272\5F69\503C. \4E0D\5141\8A31 Alpha \503C. \4F8B\5982 #2244ee')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549149780463910228.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4418)
,p_display_sequence=>20
,p_display_value=>'rgb'
,p_return_value=>'RGB'
,p_help_text=>unistr('RGB \51FD\6578\8868\793A\6CD5\4E2D\7684\7D05\8272\3001\7DA0\8272\3001\85CD\8272. \7BC4\4F8B: rgb(34,68,238)')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549320695805038594.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4418)
,p_display_sequence=>30
,p_display_value=>'rgb/rgba'
,p_return_value=>'RGBA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('RGB/RGBA \51FD\6578\8868\793A\6CD5\4E2D\7684\7D05\8272\3001\7DA0\8272\3001\85CD\8272\548C\9078\64C7\6027 Alpha (\900F\660E\5EA6).'),
unistr('\5982\679C\8272\5F69\6C92\6709 Alpha (Alpha \7B49\65BC 1), \5C07\4F7F\7528 RGB \683C\5F0F.'),
unistr('\5982\679C\8272\5F69\6709 Alpha, \5247\4F7F\7528 RGBA \683C\5F0F.'),
unistr('\7BC4\4F8B: rgba(34,68,238,0.5)')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549150182877911677.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4418)
,p_display_sequence=>40
,p_display_value=>'hsl'
,p_return_value=>'HSL'
,p_help_text=>unistr('HSL \51FD\6578\8868\793A\6CD5\4E2D\7684\8272\8ABF\3001\98FD\548C\3001\4EAE\5EA6. \7BC4\4F8B: hsl(230,86,53)')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549321101724039553.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4418)
,p_display_sequence=>50
,p_display_value=>'hsl/hsla'
,p_return_value=>'HSLA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('HSL/HSLA \51FD\6578\8868\793A\6CD5\4E2D\7684\8272\8ABF\3001\98FD\548C\3001\4EAE\5EA6\548C\9078\64C7\6027 Alpha (\900F\660E\5EA6). '),
unistr('\5982\679C\8272\5F69\6C92\6709 Alpha (Alpha \7B49\65BC 1), \5C07\4F7F\7528 HSL \683C\5F0F.'),
unistr('\5982\679C\8272\5F69\6709 Alpha, \5247\4F7F\7528 HSLA \683C\5F0F.'),
unistr('\7BC4\4F8B: hsla(230,86,53,0.5)')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549321450357041193.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4418)
,p_display_sequence=>60
,p_display_value=>unistr('\4EFB\4E00 CSS \503C')
,p_return_value=>'CSS'
,p_help_text=>unistr('\4EFB\4F55\6709\6548\7684 CSS \8272\5F69\683C\5F0F, \5305\542B\8272\5F69\540D\7A31\6216 CSS \8B8A\6578.')
);
end;
/
prompt --application/shared_components/plugins/item_type/popup_lov
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1800066898109169760.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'POPUP_LOV'
,p_display_name=>unistr('\5373\73FE\5F0F LOV')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','POPUP_LOV'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\986F\793A\6587\5B57\9805\76EE\4E14\5E36\6709\5373\73FE\5F0F\503C\6E05\55AE\5716\793A. \4E00\822C\4F7F\7528\8005\9EDE\9078\6B64\5716\793A\5F8C, \6703\51FA\73FE\4E00\500B\5167\542B\641C\5C0B\6B04\4F4D\548C\652F\63F4\4E4B\503C\6E05\55AE\7684\5373\73FE\5F0F\8996\7A97.</p>'),
unistr('<p>\5373\73FE\5F0F LOV \6700\9069\7528\65BC\5927\578B\6E05\55AE, \56E0\70BA\4E00\822C\4F7F\7528\8005\53EF\4EE5\8F38\5165\641C\5C0B\689D\4EF6\4F86\6E1B\5C11\986F\793A\7684\53EF\7528\503C. \5C0D\65BC\76F8\5C0D\4E0A\8F03\5C0F\7684\6E05\55AE, \901A\5E38\8F03\9069\7528<em>\9078\53D6\6E05\55AE</em>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1800068983311222289.4418)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\986F\793A\65B9\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\5373\73FE\5F0F\503C\6E05\55AE\7684\986F\793A\65B9\5F0F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800069590238224258.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1800068983311222289.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A')
,p_return_value=>'DIALOG'
,p_help_text=>unistr('\503C\6E05\55AE\5C07\6703\5728\5F37\5236\56DE\61C9\5C0D\8A71\65B9\584A\4E2D\986F\793A.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800069993701225262.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1800068983311222289.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5167\5D4C\5373\73FE\5F0F\8996\7A97')
,p_return_value=>'POPUP'
,p_help_text=>unistr('\503C\6E05\55AE\5C07\6703\5728\6B04\4F4D\4E0B\7684\5167\5D4C\5373\73FE\5F0F\8996\7A97\4E2D\986F\793A.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1800067187898204706.4418)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\521D\59CB\64F7\53D6')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\6700\521D\64F7\53D6\503C\6E05\55AE\8CC7\6599\7684\65B9\5F0F. \9019\53EA\9069\7528\65BC\9801\9762\8F09\5165\5F8C\6216\9805\76EE\56E0\70BA\91CD\758A\800C\91CD\65B0\6574\7406, \7B2C\4E00\6B21\958B\555F\5373\73FE\5F0F\8996\7A97\6642. \53E6\8ACB\53C3\95B1\300C\5B57\5143\6578\4E0B\9650\300D\5C6C\6027.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800067791014205587.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\4F7F\7528\8005\8981\6C42\6642')
,p_return_value=>'NO_FETCH'
,p_help_text=>unistr('\4E00\958B\59CB\4E0D\64F7\53D6\503C\6E05\55AE, \7B49\5230\4F7F\7528\8005\4F7F\7528\6216\4E0D\4F7F\7528\641C\5C0B\8A5E\641C\5C0B\6642\624D\64F7\53D6\503C\6E05\55AE.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800068204174209405.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\81EA\52D5')
,p_return_value=>'FIRST_ROWSET'
,p_help_text=>unistr('\4E0D\4F7F\7528\641C\5C0B\8A5E, \4E00\958B\59CB\4FBF\64F7\53D6\503C\6E05\55AE.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800068585605213520.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\4EE5\76EE\524D\7684\503C\81EA\52D5\9032\884C')
,p_return_value=>'FIRST_ROWSET_FILTER'
,p_help_text=>unistr('\4F7F\7528\76EE\524D\7684\503C\4F5C\70BA\641C\5C0B\8A5E, \4E00\958B\59CB\4FBF\64F7\53D6\503C\6E05\55AE.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(828501710103102611.4418)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\591A\500B\503C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\6B64\9805\76EE\53EF\4EE5\6709\591A\500B\503C, \9084\662F\53EA\80FD\6709\55AE\4E00\503C. \591A\500B\503C\6703\4EE5\9017\865F\5340\9694\7684\6E05\55AE\65B9\5F0F\50B3\56DE.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037093113159140.4418)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\624B\52D5\8F38\5165')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\9078\53D6\662F\5426\8981\5141\8A31\624B\52D5\8F38\5165. \82E5\9078\53D6\300C\662F\300D, \4F7F\7528\8005\4FBF\53EF\5F9E\5373\73FE\5F0F\503C\6E05\55AE\4E2D\9078\53D6\73FE\6709\7684\503C, \6216\662F\624B\52D5\8F38\5165\503C. \9019\5C31\50CF\300C\7D44\5408\65B9\584A\300D\4E00\6A23. \82E5\9078\53D6\300C\5426\300D, \4F7F\7528\8005\53EA\80FD\5F9E\5373\73FE\5F0F\503C\6E05\55AE\4E2D\9078\53D6\503C. \9019\5C31\50CF\300C\9078\53D6\6E05\55AE\300D\4E00\6A23. \82E5\5141\8A31\624B\52D5\8F38\5165, \5FC5\9808\8F38\5165\76F8\5C0D\61C9\4E4B\503C\6E05\55AE\7684\50B3\56DE\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037383318177266.4418)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\8F38\5165\6642\5373\641C\5C0B')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\82E5\70BA\300C\662F\300D, \503C\6E05\55AE\6703\96A8\8457\60A8\5728\641C\5C0B\6B04\4F4D\4E2D\8F38\5165\6642\4E00\908A\7BE9\9078. \82E5\70BA\300C\5426\300D, \503C\6E05\55AE\6703\7B49\5230\4F7F\7528\8005\6309 Enter \9375\6216\300C\641C\5C0B\300D\5716\793A\6309\9215\5F8C\624D\9032\884C\7BE9\9078.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037699825192444.4418)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\5B57\5143\6578\4E0B\9650')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'0'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9037383318177266.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\6700\5C11\9808\8F38\5165\591A\5C11\500B\641C\5C0B\8A5E\5B57\5143, \624D\6703\64F7\53D6\503C\6E05\55AE. \9019\5728 LOV \67E5\8A62\8017\6642, \56E0\800C\9700\6E1B\5C11\641C\5C0B\91CF\6642\975E\5E38\5BE6\7528. \6E05\55AE\4E2D\6240\6709\986F\793A\503C\7684\9577\5EA6\90FD\5FC5\9808\8D85\904E\6B64\6700\5C0F\503C, \5426\5247\5C31\6703\627E\4E0D\5230\9019\4E9B\503C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9037973825195793.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7121\6700\5C0F\503C (0)')
,p_return_value=>'0'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9038300277196807.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4418)
,p_display_sequence=>20
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9038738010197706.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4418)
,p_display_sequence=>30
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039143176198691.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4418)
,p_display_sequence=>40
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039528380199625.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4418)
,p_display_sequence=>50
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039968403200723.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4418)
,p_display_sequence=>60
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9040583894241082.4418)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\6A19\984C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\5373\73FE\5F0F\5C0D\8A71\65B9\584A\6A19\984C. \5982\679C\7A7A\767D, \5C07\6703\4F7F\7528\9810\8A2D\6A19\984C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9040894549248059.4418)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\5373\73FE\5F0F\8996\7A97\5BEC\5EA6')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>'px'
,p_is_translatable=>false
,p_help_text=>unistr('\5373\73FE\5F0F\5C0D\8A71\65B9\584A\7684\5BEC\5EA6. \5982\679C\7A7A\767D, \5C07\6703\4F7F\7528\9810\8A2D\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9041180669256760.4418)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\5373\73FE\5F0F\8996\7A97\9AD8\5EA6')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>'px'
,p_is_translatable=>false
,p_help_text=>unistr('\5373\73FE\5F0F\5C0D\8A71\65B9\584A\7684\9AD8\5EA6. \5982\679C\7A7A\767D, \5C07\6703\4F7F\7528\9810\8A2D\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9041484550137059.4418)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\5176\4ED6\8F38\51FA\9805')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(828501710103102611.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>'COL1:P1_ITEM1,COL2:P1_ITEM2'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\50B3\56DE\5176\4ED6\9801\9762\9805\76EE\7684\984D\5916\503C\6E05\55AE (LOV) \8CC7\6599\6B04\4EE5\53CA\300C\4E92\52D5\5F0F\65B9\683C\300D\8CC7\6599\6B04. \8ACB\5B9A\7FA9 LOV \8CC7\6599\6B04\540D\7A31\8207\9801\9762\9805\76EE\540D\7A31\6216\300C\4E92\52D5\5F0F\65B9\683C\300D\8CC7\6599\6B04\975C\614B ID \7684\5C0D\61C9.</p>'),
unistr('<p>\6CE8\610F: \9019\53EA\6709\5728 LOV \5B9A\7FA9\5305\542B\5176\4ED6\8CC7\6599\6B04\6642\624D\9069\7528.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(311784600505681020.4418)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>35
,p_prompt=>unistr('\5340\9694\7B26\865F')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>':'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(828501710103102611.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(9034124600967605.4418)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4418)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function(options) {',
'    options.resizable = false;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\53EF\53D6\7528\5373\73FE\5F0F LOV \9805\76EE\7684\9078\9805\7269\4EF6\3001\4FEE\6539\8A72\7269\4EF6\4E26\5C07\5176\50B3\56DE\7684 JavaScript \51FD\6578. \9019\53EF\5141\8A31\5728\521D\59CB\5316\671F\9593, \9032\4E00\6B65\81EA\8A02\5373\73FE\5F0F LOV \9805\76EE\5C0D\8A71\65B9\584A\53CA\5176\5167\5BB9.</p>'),
'',
unistr('<p>\9019\4E9B\9078\9805\6703\50B3\9001\7D66 <code>popup</code> \5C0F\5DE5\5177\6216 jQuery UI <code>dialog</code> \5C0F\5DE5\5177:<br>'),
unistr('draggable\3001resizable\3001width\3001height\3001minWidth\3001minHeight\3001maxWidth \53CA maxHeight<br>'),
unistr('\5982\9700\8A73\7D30\8CC7\8A0A, \8ACB\53C3\95B1 JQuery UI dialog \5C0F\5DE5\5177\6587\4EF6.</p>'),
'',
unistr('<p>\7576\7D50\679C\986F\793A\5728\7C21\6613\6E05\55AE\6642, <code>defaultIconListOptions</code> \9078\9805\662F\50B3\9001\7D66 <code>tableModelView</code> \5C0F\5DE5\5177\7684\7269\4EF6. \5982\9700\77AD\89E3\53EF\7528\7684\9078\9805, \8ACB\53C3\95B1 APEX tableModelView \5C0F\5DE5\5177\6587\4EF6.</p>'),
'',
unistr('<p>\7576\7D50\679C\986F\793A\5728\65B9\683C\6642, <code>defaultGridOptions</code> \9078\9805\662F\50B3\9001\7D66 <code>grid</code> \5C0F\5DE5\5177\7684\7269\4EF6.'),
unistr('\5982\9700\77AD\89E3\53EF\7528\7684\9078\9805, \8ACB\53C3\95B1 APEX grid \5C0F\5DE5\5177\6587\4EF6.</p>')))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153088232834479.4418)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4418)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\4EE5 SQL \67E5\8A62\70BA\57FA\790E\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\5177\6709\76F8\540C\986F\793A\503C\548C\50B3\56DE\503C\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\6CE8\610F: \82E5\662F\70BA\986F\793A\503C\548C\50B3\56DE\503C\9078\53D6\76F8\540C\7684\8CC7\6599\6B04, \8ACB\4F7F\7528\8CC7\6599\6B04\5225\540D.</p>'),
'</dd>',
unistr('<dt>\5177\6709\9023\7D50\8B8A\6578\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\6CE8\610F: \5982\679C <code>P3_DEPTNO</code> \662F\76F8\540C\9801\9762\4E0A\7684\53EF\4FEE\6539\9801\9762\9805\76EE, \8ACB\5C07<em>\968E\5C64\5F0F LOV \7236\9805\9805\76EE</em>\5C6C\6027\8A2D\70BA <code>P3_DEPTNO</code>.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/execute_plsql_code
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1811565602388283608.4418)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'EXECUTE_PLSQL_CODE'
,p_display_name=>unistr('\57F7\884C\4F3A\670D\5668\7AEF\7A0B\5F0F\78BC')
,p_category=>'EXECUTE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','EXECUTE_PLSQL_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5728\4F3A\670D\5668\4E0A\57F7\884C\7A0B\5F0F\78BC.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1811566513386305684.4418)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('PL/SQL \7A0B\5F0F\78BC')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2700405449462251.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>\70BA\7B26\5408\52A0\85AA\8CC7\683C\7684\54E1\5DE5\63D0\9AD8 3% \7684\85AA\8CC7:</dt>'),
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>',
unistr('<p>\5728\6B64\7BC4\4F8B\4E2D, \60A8\5FC5\9808\5728<strong>\8981\9001\51FA\7684\9805\76EE</strong>\4E2D\8F38\5165 <code>P2_DEPTNO</code>.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5728\4F3A\670D\5668\4E0A\57F7\884C\7684\7D14\57F7\884C PL/SQL \533F\540D\5340\584A.</p>'),
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\9023\7D50\8A9E\6CD5 (\4F8B\5982 <code>:P1_MY_ITEM</code>), \53C3\7167\60A8\61C9\7528\7A0B\5F0F\5167\7684\5176\4ED6\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. <strong>\8981\9001\51FA\7684\9801\9762\9805\76EE</strong>\4E2D\5FC5\9808\5305\62EC\6240\6709\53C3\7167\7684\9805\76EE.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700703882467720.4418)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>11
,p_prompt=>unistr('JavaScript \7A0B\5F0F\78BC')
,p_attribute_type=>'MLE JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2700405449462251.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>\70BA\7B26\5408\52A0\85AA\8CC7\683C\7684\54E1\5DE5\63D0\9AD8 3% \7684\85AA\8CC7:</dt>'),
'<dd><pre>',
'var rows;',
'function needsSalaryRaise( empno ) {',
unistr('  // \7528\65BC\8A08\7B97\54E1\5DE5\662F\5426\9700\8981\52A0\85AA\7684\8907\96DC\908F\8F2F\9810\7559\4F4D\7F6E'),
'  return true;',
'}',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'  if ( needsSalaryRaise( row.EMPNO )) {',
'    apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'  }',
'}',
'</pre></dd>',
'</dl>',
unistr('<p>\5728\6B64\7BC4\4F8B\4E2D, \60A8\5FC5\9808\5728<strong>\8981\9001\51FA\7684\9805\76EE</strong>\4E2D\8F38\5165 <code>P2_DEPTNO</code>.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5728\4F3A\670D\5668\4E0A\57F7\884C\7684\7D14\57F7\884C JavaScript \5340\584A.</p>'),
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\9023\7D50\8A9E\6CD5 (\4F8B\5982 <code>apex.env.P1_MY_ITEM</code>), \53C3\7167\61C9\7528\7A0B\5F0F\5167\7684\5176\4ED6\9801\9762\6216\61C9\7528\7A0B\5F0F\9805\76EE. <strong>\8981\9001\51FA\7684\9801\9762\9805\76EE</strong>\5FC5\9808\5305\62EC\6240\6709\53C3\7167\7684\9805\76EE.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1811567115248315739.4418)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8981\9001\51FA\7684\9805\76EE')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5\5927\5BEB\8F38\5165\9001\51FA\81F3\4F3A\670D\5668\7684\9801\9762\9805\76EE, \4EE5\4FBF\80FD\5920\5728\60A8\7684 <strong>PL/SQL \7A0B\5F0F\78BC</strong>\4E2D\4F7F\7528.</p>'),
unistr('<p>\60A8\53EF\4EE5\8F38\5165\9805\76EE\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.'),
unistr('\5982\679C\5F9E\6E05\55AE\4E2D\9078\64C7, \4E14\540C\6642\9593\5DF2\7D93\6709\8F38\5165\7684\6587\5B57\7684\8A71, \5C07\6703\5728\73FE\6709\6587\5B57\7684\7D50\5C3E\52A0\4E0A\4E00\500B\9017\865F, \5F8C\9762\518D\63A5\8457\5F9E\6E05\55AE\50B3\56DE\7684\9805\76EE\540D\7A31.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(888122401495541038.4418)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\8981\50B3\56DE\7684\9805\76EE')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'    apex_util.set_session_state(''P1_MY_ITEM'', ''New Value'');',
'</pre>',
'</p>',
unistr('<p>\5728\6B64\7BC4\4F8B\4E2D, \5728\6B64\5C6C\6027\4E2D\8F38\5165 <code>P1_MY_ITEM</code>, \4EE5\4FBF\8B93\300C\65B0\503C\300D\986F\793A\5728\9801\9762\7684\8A72\9805\76EE\4E2D.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5\5927\5BEB\8F38\5165\4F3A\670D\5668\547C\53EB\50B3\56DE\7684\9801\9762\9805\76EE\96C6 (\6839\64DA\5176\76EE\524D\5728\968E\6BB5\4F5C\696D\72C0\614B\4E2D\7684\503C). \5982\679C\60A8\7684 <strong>PL/SQL \7A0B\5F0F\78BC</strong> \5728\968E\6BB5\4F5C\696D\72C0\614B\4E2D\8A2D\5B9A\4E00\6216\591A\500B\9801\9762\9805\76EE\503C, \8ACB\5728\6B64\5C6C\6027\4E2D\5B9A\7FA9\9019\4E9B\9805\76EE.</p>'),
unistr('<p>\60A8\53EF\4EE5\8F38\5165\9805\76EE\540D\7A31\6216\5F9E\53EF\7528\9805\76EE\6E05\55AE\4E2D\9078\64C7.'),
unistr('\5982\679C\5F9E\6E05\55AE\4E2D\9078\64C7, \4E14\540C\6642\9593\5DF2\7D93\6709\8F38\5165\7684\6587\5B57\7684\8A71, \5C07\6703\5728\73FE\6709\6587\5B57\7684\7D50\5C3E\52A0\4E0A\4E00\500B\9017\865F, \5F8C\9762\518D\63A5\8457\5F9E\6E05\55AE\50B3\56DE\7684\9805\76EE\540D\7A31.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1002790918416823799.4418)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6291\5236\8B8A\66F4\4E8B\4EF6')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(888122401495541038.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\6307\5B9A\662F\5426\6291\5236<strong>\8981\50B3\56DE\7684\9801\9762\9805\76EE</strong>\4E2D\6307\5B9A\4E4B\9805\76EE\7684\8B8A\66F4\4E8B\4EF6. \5982\679C\6291\5236, \5C31\4E0D\6703\518D\5C0D\9019\4E9B\9805\76EE\89F8\767C\4EE5<em>\8B8A\66F4</em>\70BA\57FA\790E\7684\300C\52D5\614B\52D5\4F5C\300D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700405449462251.4418)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>5
,p_prompt=>unistr('\8A9E\8A00')
,p_attribute_type=>'CODE LANGUAGE'
,p_is_required=>true
,p_default_value=>'PLSQL'
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/item_type/display_only
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2248579157998483215.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_ONLY'
,p_display_name=>unistr('\50C5\986F\793A')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_ONLY'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:ICON:ENCRYPT:LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\986F\793A\4E0D\80FD\8F38\5165\7684\6587\5B57\9805\76EE.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2248592969903496143.4418)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>50
,p_prompt=>unistr('\9001\51FA\9801\9762\6642\50B3\9001')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\9001\51FA\9801\9762\5F8C\662F\5426\61C9\50B3\9001\76EE\524D\7684\9805\76EE\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803821466219365649.4418)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6839\64DA')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VALUE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(4800927632436292.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLAIN'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\6C7A\5B9A\986F\793A\4E4B\503C\7684\65B9\5F0F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822070028366811.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\9805\76EE\503C')
,p_return_value=>'VALUE'
,p_help_text=>unistr('\986F\793A\76EE\524D\7684\9805\76EE\503C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822445572369209.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\986F\793A\503C\6E05\55AE\503C')
,p_return_value=>'LOV'
,p_help_text=>unistr('\4F7F\7528\503C\6E05\55AE, \5C07\9801\9762\9805\76EE\7684\76EE\524D\503C\5C0D\61C9\81F3\4E0D\540C\7684\986F\793A\503C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822855268372026.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4418)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL \7A0B\5F0F\78BC\8F38\51FA')
,p_return_value=>'PLSQL'
,p_is_deprecated=>true
,p_help_text=>unistr('\6307\5B9A\7684 PL/SQL \7A0B\5F0F\78BC\6703\7522\751F\986F\793A\7684\8F38\51FA.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803823354360381170.4418)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('PL/SQL \7A0B\5F0F\78BC')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1803821466219365649.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528 <code>sys.htp.p</code> \6216 <code>sys.htp.prn</code> \8F38\5165 PL/SQL \7A0B\5F0F\78BC, \4EE5\7522\751F HTML \7A0B\5F0F\78BC.</p>'),
unistr('<p>Oracle \5EFA\8B70\4F7F\7528 <code>sys.htf.escape_sc</code> \9041\96E2\5F9E\8CC7\6599\5EAB\64F7\53D6\7684\8CC7\6599, \4EE5\78BA\4FDD\80FD\5920\9041\96E2 HTML \6A19\8A18.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1363556632373484636.4418)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\986F\793A\5206\884C\7B26\865F')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1803821466219365649.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'VALUE,LOV'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\5728\8F38\51FA\4E2D\4FDD\7559\5206\884C\7B26\865F.</p>'),
unistr('<p>\7531\65BC\986F\793A\6703\5448\73FE\6210 HTML, \5982\679C\8A2D\70BA<strong>\662F</strong>, \986F\793A\503C\4E2D\7684\5206\884C\7B26\865F\5C31\6703\88AB\5448\73FE\6210 HTML \5206\884C\7B26\865F, \4EE5\4FBF\53EF\4EE5\6B63\78BA\986F\793A.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(4800927632436292.4418)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>10
,p_prompt=>unistr('\683C\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4801218870437281.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7D14\6587\5B57')
,p_return_value=>'PLAIN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4801656011439608.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4418)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4802071527441522.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4418)
,p_display_sequence=>30
,p_display_value=>'Markdown'
,p_return_value=>'MARKDOWN'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153181852834480.4418)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4418)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('<strong>\7BC4\4F8B 1: \4EE5 SQL \67E5\8A62\70BA\57FA\790E\7684\503C\6E05\55AE.</strong>'),
'<pre>',
'SELECT dname, deptno from dept',
'</pre>',
'</p>',
'<p>',
unistr('<strong>\7BC4\4F8B 2: \975C\614B\6E05\55AE\7BC4\4F8B</strong>'),
'<ul>',
unistr('<li>STATIC:Yes;Y,No;N (\986F\793A\662F/\5426, \800C\975E Y \548C N)</li>'),
'</ul>',
'</p>',
'',
'<p>',
unistr('<strong>\7BC4\4F8B 3: \4F7F\7528\9023\7D50\8B8A\6578\9032\884C\984D\5916\9650\5236\7684\503C\6E05\55AE</strong>'),
'<pre>',
'SELECT dname, deptno from dept where location=:P3_LOCATION',
'</pre>',
'</p>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/star_rating
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2547808060578229016.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STAR_RATING'
,p_display_name=>unistr('\661F\7D1A\8A55\6BD4')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STAR_RATING'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ICON:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>\65B0\5F0F\7684\661F\7D1A\8A55\6BD4\9805\76EE</strong></p>'),
unistr('<p>\6B64\9805\76EE\6703\4EE5\4E00\4E9B\661F\865F\6216\5176\4ED6\5716\793A\986F\793A\6578\503C. \4E00\822C\4F7F\7528\8005\53EF\4EE5\9078\53D6\6240\9700\7684\661F\865F\6578\4F86\8B8A\66F4\503C. \53EF\4EE5\4F7F\7528\6ED1\9F20\9EDE\9078\661F\865F\6578\6216\4F7F\7528\9375\76E4\8ABF\6574\503C.</p>'),
unistr('<p>\8981\986F\793A\7684\5716\793A, \80CC\666F\548C\524D\666F\8272\5F69\53EF\5728\5143\4EF6\8A2D\5B9A\503C\6216\500B\5225\9805\76EE\8A2D\5B9A\503C\4E2D\505A\8ABF\6574. \82E5\8981\4F7F\7528\500B\5225\9805\76EE\548C\8272\5F69, \8ACB\5C07<strong>\4F7F\7528\5143\4EF6\9810\8A2D\503C</strong>\5C6C\6027\8A2D\70BA<strong>\5426</strong>.</p>'),
unistr('<p>\81F3\65BC\5716\793A, \60A8\53EF\4EE5\4F7F\7528\61C9\7528\7A0B\5F0F\4E2D\300C\5716\793A\5B57\578B\300D\6240\63D0\4F9B\7684\4EFB\4F55\5716\793A. \82E5\70BA\300C\901A\7528\4E3B\984C\300D\61C9\7528\7A0B\5F0F, \8ACB\4F7F\7528<em>\5B57\578B APEX</em> \7A0B\5F0F\5EAB\6240\63D0\4F9B\7684\5716\793A.</p>')))
,p_version_identifier=>'1.0'
,p_files_version=>1149
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(475527326399196418.4418)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9810\8A2D\5716\793A')
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumbs-up',
'fa-database',
'</pre>'))
,p_help_text=>unistr('\9078\64C7\8981\4F7F\7528\7684\9810\8A2D\5716\793A.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721912433448449647.4418)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\4F5C\7528\4E2D\8272\5F69')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('\9078\64C7\4F5C\7528\4E2D\661F\865F\7684\9810\8A2D\8272\5F69.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721912884614449648.4418)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\975E\4F5C\7528\4E2D\8272\5F69')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('\9078\64C7\975E\4F5C\7528\4E2D\661F\865F\7684\9810\8A2D\8272\5F69.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(475538451111203492.4418)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\5DE5\5177\63D0\793A')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'#VALUE#'
,p_is_translatable=>false
,p_examples=>unistr('\8A55\6BD4: #VALUE# \9846\661F.')
,p_help_text=>unistr('\6307\5B9A\5DE5\5177\63D0\793A\7684\6A23\677F. #VALUE# \66FF\4EE3\9805\76EE\6703\88AB\76EE\524D\7684\8A55\6BD4\503C\53D6\4EE3.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470180844645338807.4418)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\661F\865F\6578')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'5'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\8981\986F\793A\7684\661F\865F\7E3D\6578.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470251151324440675.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4418)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470263362673575666.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4418)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470263792668576010.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4418)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264197754576285.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4418)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264650749576748.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4418)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264961143577132.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4418)
,p_display_sequence=>60
,p_display_value=>'6'
,p_return_value=>'6'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470265413888577465.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4418)
,p_display_sequence=>70
,p_display_value=>'7'
,p_return_value=>'7'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470265803806577966.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4418)
,p_display_sequence=>80
,p_display_value=>'8'
,p_return_value=>'8'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470266183252578379.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4418)
,p_display_sequence=>90
,p_display_value=>'9'
,p_return_value=>'9'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470266568693578886.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4418)
,p_display_sequence=>100
,p_display_value=>'10'
,p_return_value=>'10'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470195603586349451.4418)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\4F7F\7528\9810\8A2D\503C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\4F7F\7528\5728\300C\5171\7528\7684\5143\4EF6\300D>\300C\5143\4EF6\8A2D\5B9A\503C\300D\4E2D\70BA\6B64\5143\4EF6\5B9A\7FA9\7684\9810\8A2D\503C, \6216\81EA\8A02\8A2D\5B9A\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470360305601388583.4418)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\5716\793A')
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumb-up',
'fa-database',
'</pre>'))
,p_help_text=>unistr('\6307\5B9A\8981\4F7F\7528\7684\5716\793A.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721914847860449650.4418)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\4F5C\7528\4E2D\8272\5F69')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\9078\64C7\4F5C\7528\4E2D\661F\865F\7684\9810\8A2D\8272\5F69.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721915319189449650.4418)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\975E\4F5C\7528\4E2D\8272\5F69')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\9078\64C7\975E\4F5C\7528\4E2D\661F\865F\7684\9810\8A2D\8272\5F69.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721915642741449650.4418)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\5DE5\5177\63D0\793A')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'#VALUE#'
,p_display_length=>30
,p_max_length=>50
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>unistr('\8A55\6BD4: #VALUE# \9846\661F.')
,p_help_text=>unistr('\6307\5B9A\5DE5\5177\63D0\793A\7684\6A23\677F. #VALUE# \66FF\4EE3\9805\76EE\6703\88AB\76EE\524D\7684\8A55\6BD4\503C\53D6\4EE3.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(576030049193688277.4418)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\986F\793A\6E05\9664\6309\9215')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\9078\64C7\662F\5426\8981\986F\793A\6E05\9664\6309\9215.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470218232268377857.4418)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\986F\793A\503C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\9078\64C7\662F\5426\8981\5728\661F\865F\65C1\908A\986F\793A\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470221148895382244.4418)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\552F\8B80\986F\793A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STARS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\64C7\9805\76EE\70BA\552F\8B80\6642\61C9\7576\986F\793A\4EC0\9EBC.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470238266735410069.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\661F\865F')
,p_return_value=>'STARS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470238737727410979.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\503C')
,p_return_value=>'VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470239127391413405.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\661F\865F\8207\503C')
,p_return_value=>'STARS_AND_VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470239521066415362.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4418)
,p_display_sequence=>50
,p_display_value=>unistr('\55AE\4E00\661F\865F\8207\503C')
,p_return_value=>'SINGLE_STAR_AND_VALUE'
);
end;
/
prompt --application/shared_components/plugins/item_type/checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2693981597889753854.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'CHECKBOX'
,p_display_name=>unistr('\6838\53D6\65B9\584A\7FA4\7D44')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','CHECKBOX'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\5C07\591A\500B\503C\986F\793A\70BA\6838\53D6\65B9\584A, \8B93\4E00\822C\4F7F\7528\8005\80FD\5920\9078\53D6\591A\500B\503C. \986F\793A\70BA\6838\53D6\65B9\584A\7684\9805\76EE\9700\8981\6709\503C\6E05\55AE. \5DF2\6838\53D6\65B9\584A\7684\76F8\5C0D\61C9\503C\5132\5B58\5728\55AE\4E00\5192\865F\5340\9694\7684\5B57\4E32\4E2D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(911353315791136342.4418)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8CC7\6599\6B04\6578\76EE')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\7528\4EE5\986F\793A\6838\53D6\65B9\584A\7684\7248\9762\914D\7F6E\8CC7\6599\6B04\6578\76EE. \4F8B\5982, \503C\82E5\70BA 2 \6703\986F\793A\5169\500B\8CC7\6599\6B04\7684\6838\53D6\65B9\584A. \4F9D\7167\9810\8A2D, \6240\6709\503C\6703\986F\793A\5728\4E00\500B\8CC7\6599\6B04\4E2D.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(12186014788201255.4418)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>unistr('\986F\793A\65B9\5411')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VERTICAL'
,p_supported_ui_types=>'JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\6838\53D6\65B9\584A\7684\5448\73FE\65B9\5F0F.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12186517905202120.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(12186014788201255.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5782\76F4')
,p_return_value=>'VERTICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12186921368203093.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(12186014788201255.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\6C34\5E73')
,p_return_value=>'HORIZONTAL'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156526173834547.4418)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4418)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\4EE5 SQL \67E5\8A62\70BA\57FA\790E\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\5177\6709\76F8\540C\986F\793A\503C\548C\50B3\56DE\503C\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\6CE8\610F: \82E5\662F\70BA\986F\793A\503C\548C\50B3\56DE\503C\9078\53D6\76F8\540C\7684\8CC7\6599\6B04, \8ACB\4F7F\7528\8CC7\6599\6B04\5225\540D.</p>'),
'</dd>',
unistr('<dt>\5177\6709\9023\7D50\8B8A\6578\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\6CE8\610F: \5982\679C <code>P3_DEPTNO</code> \662F\76F8\540C\9801\9762\4E0A\7684\53EF\4FEE\6539\9801\9762\9805\76EE, \8ACB\5C07<em>\968E\5C64\5F0F LOV \7236\9805\9805\76EE</em>\5C6C\6027\8A2D\70BA <code>P3_DEPTNO</code>.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/select_list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2698572619073428716.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SELECT_LIST'
,p_display_name=>unistr('\9078\53D6\6E05\55AE')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SELECT_LIST'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\986F\793A\9805\76EE\4E14\5E36\6709\5167\5EFA\7684\503C\6E05\55AE\9078\53D6\5668. \7576\4E00\822C\4F7F\7528\8005\9EDE\9078\9805\76EE\5F8C, \652F\63F4\7684\503C\6E05\55AE\6703\76F4\63A5\986F\793A\4E14\5167\5D4C\5728\76EE\524D\9805\76EE\4E2D.</p>'),
unistr('<p>\300C\9078\53D6\6E05\55AE\300D\6700\9069\7528\65BC\76F8\5C0D\4E0A\8F03\5C0F\7684\96E2\6563\6E05\55AE. \4E00\822C\4F7F\7528\8005\7121\9808\5C07\7126\9EDE\8B8A\66F4\81F3\5373\73FE\5F0F\5C0D\8A71\65B9\584A, \5373\53EF\975E\5E38\5FEB\901F\5730\5F9E\6E05\55AE\4E2D\9078\53D6\503C. \5C0D\65BC\5927\578B\6E05\55AE, \901A\5E38\8F03\9069\7528<em>\5373\73FE\5F0F LOV</em>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2698572905698434305.4418)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9078\64C7\6642\7684\9801\9762\52D5\4F5C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\5728\9078\53D6\6E05\55AE\503C\5F8C\61C9\8A72\63A1\53D6\7684\52D5\4F5C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2264411080592689929.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4418)
,p_display_sequence=>1
,p_display_value=>unistr('\7121')
,p_return_value=>'NONE'
,p_help_text=>unistr('\503C\8B8A\66F4\6642, \4E0D\6703\7ACB\5373\63A1\53D6\52D5\4F5C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698575413579455462.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4418)
,p_display_sequence=>5
,p_display_value=>unistr('\9001\51FA\9801\9762')
,p_return_value=>'SUBMIT'
,p_help_text=>unistr('\9801\9762\5DF2\9001\51FA, \4E14\9801\9762 REQUEST \8A2D\70BA\9801\9762\9805\76EE\540D\7A31.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698574606653453436.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4418)
,p_display_sequence=>7
,p_display_value=>unistr('\91CD\65B0\5C0E\5411\4E26\8A2D\5B9A\503C')
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>unistr('\700F\89BD\5668\91CD\65B0\5C0E\5411\81F3\76EE\524D\9801\9762, \4E14\76EE\524D\9805\76EE\7684\968E\6BB5\4F5C\696D\72C0\614B\8A2D\70BA\9078\53D6\7684\503C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698574220720448121.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4418)
,p_display_sequence=>9
,p_display_value=>unistr('\91CD\65B0\5C0E\5411\81F3\9801\9762')
,p_return_value=>'REDIRECT_PAGE'
,p_help_text=>unistr('\700F\89BD\5668\91CD\65B0\5C0E\5411\81F3\9078\53D6\503C\4E2D\5305\542B\7684\9801\9762. \6E05\55AE\4E2D\7684\50B3\56DE\503C\5FC5\9808\5305\542B\6709\6548\7684\9801\78BC\6216\9801\9762\5225\540D.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698573815526446624.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\91CD\65B0\5C0E\5411\81F3 URL')
,p_return_value=>'REDIRECT_URL'
,p_help_text=>unistr('\700F\89BD\5668\91CD\65B0\5C0E\5411\81F3\9078\53D6\503C\4E2D\5305\542B\7684 URL. \6E05\55AE\4E2D\7684\50B3\56DE\503C\5FC5\9808\5305\542B\6709\6548\7684 URL.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(912506420442525842.4418)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5141\8A31\591A\91CD\9078\53D6')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2698572905698434305.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NONE'
,p_help_text=>unistr('\6307\5B9A\53EF\4EE5\5F9E\503C\6E05\55AE\4E2D\9078\53D6\591A\500B\503C\9084\662F\53EA\80FD\9078\53D6\55AE\4E00\503C. \591A\500B\503C\6703\4EE5\9017\865F\5340\9694\7684\6E05\55AE\65B9\5F0F\50B3\56DE.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(459061412834919653.4418)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\57F7\884C\9A57\8B49\9805\76EE')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2698572905698434305.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>unistr('\6307\5B9A\662F\5426\6839\64DA<strong>\9001\51FA\9801\9762</strong>\7684\9801\9762\52D5\4F5C\8A2D\5B9A, \5728\9001\51FA\9801\9762\6642\57F7\884C\9A57\8B49.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156662497834548.4418)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4418)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\4EE5 SQL \67E5\8A62\70BA\57FA\790E\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\5177\6709\76F8\540C\986F\793A\503C\548C\50B3\56DE\503C\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\6CE8\610F: \82E5\662F\70BA\986F\793A\503C\548C\50B3\56DE\503C\9078\53D6\76F8\540C\7684\8CC7\6599\6B04, \8ACB\4F7F\7528\8CC7\6599\6B04\5225\540D.</p>'),
'</dd>',
unistr('<dt>\5177\6709\9023\7D50\8B8A\6578\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\6CE8\610F: \5982\679C <code>P3_DEPTNO</code> \662F\76F8\540C\9801\9762\4E0A\7684\53EF\4FEE\6539\9801\9762\9805\76EE, \8ACB\5C07<em>\968E\5C64\5F0F LOV \7236\9805\9805\76EE</em>\5C6C\6027\8A2D\70BA <code>P3_DEPTNO</code>.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_column_toggle
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3482208123256545756.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_COLUMN_TOGGLE'
,p_display_name=>unistr('\8CC7\6599\6B04\5207\63DB\5831\8868')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_COLUMN_TOGGLE'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A\5831\8868, \4E00\822C\4F7F\7528\8005\53EF\5F9E\4E2D\9078\53D6\5C07\5728\7A0B\5F0F\5BE6\969B\57F7\884C\6642\986F\793A\7684\8CC7\6599\6B04. \63A5\8457, \4E00\822C\4F7F\7528\8005\53EF\4EE5\6839\64DA\986F\793A\5831\8868\4E4B\756B\9762\7684\5BEC\5EA6\8207\65B9\5411\8B8A\66F4\8CC7\6599\6B04.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823587226519967208.4418)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4418)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\6B64\5831\8868\8CC7\6599\6B04\7684\57FA\790E.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823587544288968547.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7D14\6587\5B57')
,p_return_value=>'PLAIN'
,p_help_text=>unistr('\986F\793A\8CC7\6599\6B04\503C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823587907770969285.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\9023\7D50')
,p_return_value=>'LINK'
,p_help_text=>unistr('\5C07\8CC7\6599\6B04\986F\793A\70BA\9023\7D50.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1305234852618727263.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\767E\5206\6BD4\5716\8868')
,p_return_value=>'PCT_GRAPH'
,p_help_text=>unistr('\5C07\8CC7\6599\6B04\986F\793A\70BA\767E\5206\6BD4\5716\8868. \64F7\53D6\7684\503C\5FC5\9808\4ECB\65BC 0 \5230 100 \4E4B\9593.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823588275617978359.4418)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4418)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\76EE\6A19')
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\8F38\5165\4F7F\7528\8005\6309\4E00\4E0B\73FE\6709\9805\76EE\6642\8981\547C\53EB\7684\76EE\6A19\9801\9762.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238927721819003883.4418)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4418)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\9023\7D50\6587\5B57')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('\8F38\5165\8981\986F\793A\70BA\9023\7D50\7684 HTML \5167\5BB9. \8ACB\4F7F\7528\5F71\50CF\6A19\8A18\4F86\986F\793A\5F71\50CF, \6216\8005\5F9E\9810\8A2D\5F71\50CF\6E05\55AE\4E2D\9078\53D6.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238931409403155860.4418)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4418)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\9023\7D50\5C6C\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('\6307\5B9A\8981\5305\542B\5728 <code>&lt;a href=...&gt;</code> \6A19\8A18\4E2D\7684\5176\4ED6\8CC7\6599\6B04\9023\7D50\5C6C\6027, \5305\62EC\9023\7D50\76EE\6A19\3001\985E\5225\6216\6A23\5F0F.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305278757261772485.4418)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4418)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\80CC\666F\8272\5F69')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC - '),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\5716\8868\8981\4F7F\7528\7684\80CC\666F\8272\5F69.'),
unistr('\6307\5B9A\8272\5F69\6642, \662F\4F7F\7528\5341\516D\9032\4F4D\8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A.</p>'),
unistr('<p>\5341\516D\9032\4F4D\8868\793A\6CD5\662F\4EE5 #xxyyzz (\4E00\500B # \5F8C\9762\8DDF\8457 3 \500B\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57) \4F86\5B9A\7FA9, \5176\4E2D xx\3001yy \53CA zz \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\96D9\5B57\5143\5341\516D\9032\4F4D\503C.'),
unistr('RGB \4EE3\78BC\662F\4EE5 RGB(xxx,xxx,xxx) \4F86\5B9A\7FA9, \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \7684\6578\5B57, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\55AE\4E00 8 \4F4D\5143\4F4D\5143\7D44\503C.</p>'),
unistr('<p>\5728\7DB2\969B\7DB2\8DEF\4E2D\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5373\53EF\627E\51FA\60A8\60F3\8981\4F7F\7528\4E4B\8272\5F69\7684\5C0D\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305279121857779186.4418)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4418)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\524D\666F\8272\5F69')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC - '),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\5716\8868\8981\4F7F\7528\7684\524D\666F\8272\5F69.'),
unistr('\6307\5B9A\8272\5F69\6642, \662F\4F7F\7528\5341\516D\9032\4F4D\8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A.</p>'),
unistr('<p>\5341\516D\9032\4F4D\8868\793A\6CD5\662F\4EE5 #xxyyzz (\4E00\500B # \5F8C\9762\8DDF\8457 3 \500B\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57) \4F86\5B9A\7FA9, \5176\4E2D xx\3001yy \53CA zz \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\96D9\5B57\5143\5341\516D\9032\4F4D\503C.'),
unistr('RGB \4EE3\78BC\662F\4EE5 RGB(xxx,xxx,xxx) \4F86\5B9A\7FA9, \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \7684\6578\5B57, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\55AE\4E00 8 \4F4D\5143\4F4D\5143\7D44\503C.</p>'),
unistr('<p>\5728\7DB2\969B\7DB2\8DEF\4E2D\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5373\53EF\627E\51FA\60A8\60F3\8981\4F7F\7528\4E4B\8272\5F69\7684\5C0D\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305282212210798696.4418)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4418)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\9577\689D\5BEC\5EA6')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>unistr('\50CF\7D20')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>unistr('\8F38\5165\6B64\9577\689D\5716\7684\5BEC\5EA6 (\50CF\7D20).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(149106414354906696.4418)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4418)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\4F5C\70BA\8CC7\6599\5217\6A19\982D')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6B64\9805\76EE\4F9B\8F14\52A9\529F\80FD\4F7F\7528, \7528\65BC\8B58\5225\6700\80FD\4EE3\8868\8CC7\6599\5217\5167\5BB9\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2695400128710862038.4418)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4418)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>25
,p_display_sequence=>250
,p_prompt=>unistr('\512A\5148\9806\5E8F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5831\8868\6703\4F9D\64DA\5169\500B\8F38\5165\9805\4F86\96B1\85CF\548C\986F\793A\8CC7\6599\6B04: \53EF\7528\7684\87A2\5E55\5BEC\5EA6, \6216\4F7F\7528\8005\5728\8CC7\6599\6B04\9078\64C7\5668\529F\80FD\8868\4E2D\52FE\9078\548C\53D6\6D88\52FE\9078\8981\986F\793A\8CC7\6599\6B04. \5206\5225\91DD\5C0D\8981\986F\793A\7684\6BCF\500B\8CC7\6599\6B04\9078\64C7\76F8\5C0D\61C9\7684\512A\5148\9806\5E8F\503C. \4EFB\4F55\5177\6709\512A\5148\9806\5E8F\7684\8CC7\6599\6B04\5747\6703\986F\793A\5728\8CC7\6599\6B04\9078\64C7\5668\529F\80FD\8868\4E2D.<p>'),
'',
unistr('<p>\82E5\8981\6C38\4E45\986F\793A\67D0\8CC7\6599\6B04, \4EA6\5373\6C38\4E0D\96B1\85CF\6B64\8CC7\6599\6B04, \8ACB\9078\53D6<strong>\4E00\5F8B\986F\793A</strong>, \9019\4E5F\6703\5C07\8A72\8CC7\6599\6B04\5F9E\8CC7\6599\6B04\9078\64C7\5668\529F\80FD\8868\4E2D\79FB\9664.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(686758760912714500.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4418)
,p_display_sequence=>5
,p_display_value=>unistr('\4E00\5F8B\986F\793A')
,p_return_value=>'ALWAYS'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245557520909123628.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4418)
,p_display_sequence=>10
,p_display_value=>unistr('1 - \96B1\85CF\6700\5F8C\4E00\500B')
,p_return_value=>'1'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245557959195124246.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4418)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245558584414124867.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4418)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245558946802125444.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4418)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245559350856125993.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4418)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245559812372127827.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4418)
,p_display_sequence=>60
,p_display_value=>unistr('1 - \96B1\85CF\7B2C\4E00\500B')
,p_return_value=>'6'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823549938363826650.4418)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\7248\9762\914D\7F6E\9078\9805')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6AA2\67E5\5176\4ED6\5831\8868\7248\9762\914D\7F6E\9078\9805.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1238928674387055064.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1823549938363826650.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7DDA\689D')
,p_return_value=>'STRIPE'
,p_help_text=>unistr('\5728\6BCF\500B\8CC7\6599\5217\4E0A\65B0\589E\66FF\4EE3\8CC7\6599\5217\7DDA\689D.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1238929097998055827.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1823549938363826650.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\7B46\89F8')
,p_return_value=>'STROKE'
,p_help_text=>unistr('\5728\6BCF\500B\8CC7\6599\5217\4E4B\9593\65B0\589E\6C34\5E73\7DDA.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238929416131062515.4418)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('CSS \985E\5225')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\5143\4EF6\8981\5305\542B\7684\5176\4ED6 CSS \985E\5225 (\4EE5\7A7A\683C\5340\9694).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238929773245063952.4418)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\81EA\8A02\5C6C\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('<p>\8F38\5165\8981\5305\542B\5728\8868\683C HTML \6A19\8A18\4E2D\7684\5176\4ED6\5C6C\6027. \7CFB\7D71\6703\7522\751F\985E\5225 HTML \5C6C\6027, \56E0\6B64\4E0D\9700\8981\63D0\4F9B, \8ACB\6539\7528\5C08\7528\7684 <em>CSS \985E\5225</em>\5C6C\6027.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(106020849730927710.4418)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\8CC7\6599\6B04\6309\9215\6587\5B57')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_help_text=>unistr('\9019\662F\7528\65BC\958B\555F\8CC7\6599\6B04\9078\64C7\5373\73FE\5F0F\8996\7A97\4E4B\6309\9215\7684\6A19\7C64. \82E5\672A\8F38\5165\6587\5B57, \6703\4F7F\7528\9810\8A2D\6A19\7C64.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(107062574864851281.4418)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4418)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\4F9D\540D\7A31\6392\5217\986F\793A\6240\6709\54E1\5DE5</dt>'),
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
unistr('<dt>\4F9D\540D\7A31\6392\5217\986F\793A\76EE\524D\90E8\9580\7684\6240\6709\54E1\5DE5</dt>'),
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>\5982\679C\4F7F\7528\9023\7D50\8B8A\6578\53C3\7167\9801\9762\9805\76EE, \8ACB\5C07\5B83\5011\6307\5B9A\70BA<strong>\8981\9001\51FA\7684\9801\9762\9805\76EE</strong>.</p>'),
'</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/shuttle
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3601651046632666378.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SHUTTLE'
,p_display_name=>unistr('\5F80\8FD4\5207\63DB')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SHUTTLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\986F\793A\70BA\5305\62EC\5169\500B\5167\542B\6E05\55AE\4E4B\65B9\584A\7684\591A\91CD\9078\53D6\6E05\55AE. \5DE6\65B9\6E05\55AE\986F\793A\5C1A\672A\9078\53D6\7684\4F86\6E90\503C\6E05\55AE, \53F3\65B9\6E05\55AE\5247\986F\793A\76EE\524D\9078\53D6\7684\503C. \4E00\822C\4F7F\7528\8005\53EF\4EE5\5728\6E05\55AE\4E2D\9078\53D6\4E00\6216\591A\500B\503C, \7136\5F8C\4F7F\7528\5F80\8FD4\5207\63DB\63A7\5236\9805\4F86\79FB\52D5\9078\53D6\7684\503C\6216\6240\6709\503C.</p>'),
unistr('<p>\76EE\524D\503C\5132\5B58\5728\55AE\4E00\5192\865F\5340\9694\7684\5B57\4E32\4E2D.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1815740271128931626.4418)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\986F\793A\63A7\5236\9805')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\5F80\8FD4\5207\63DB\7576\4E2D\6240\986F\793A\7684\8CC7\6599\79FB\52D5\63A7\5236\9805.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815740874245932549.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5168\90E8')
,p_return_value=>'ALL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815741286365936063.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\50C5\9650\79FB\52D5')
,p_return_value=>'MOVE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815741691214937407.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\50C5\9650\6392\5E8F')
,p_return_value=>'ORDER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815746874076970329.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\7121')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156821574834552.4418)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4418)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\4EE5 SQL \67E5\8A62\70BA\57FA\790E\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\5177\6709\76F8\540C\986F\793A\503C\548C\50B3\56DE\503C\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\6CE8\610F: \82E5\662F\70BA\986F\793A\503C\548C\50B3\56DE\503C\9078\53D6\76F8\540C\7684\8CC7\6599\6B04, \8ACB\4F7F\7528\8CC7\6599\6B04\5225\540D.</p>'),
'</dd>',
unistr('<dt>\5177\6709\9023\7D50\8B8A\6578\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\6CE8\610F: \5982\679C <code>P3_DEPTNO</code> \662F\76F8\540C\9801\9762\4E0A\7684\53EF\4FEE\6539\9801\9762\9805\76EE, \8ACB\5C07<em>\968E\5C64\5F0F LOV \7236\9805\9805\76EE</em>\5C6C\6027\8A2D\70BA <code>P3_DEPTNO</code>.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1815705269182590478.4418)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4418)
,p_name=>'shuttlechangeorder'
,p_display_name=>unistr('\8B8A\66F4\9806\5E8F')
);
end;
/
prompt --application/shared_components/plugins/item_type/radiogroup
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3605341835055239817.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RADIOGROUP'
,p_display_name=>unistr('\5713\9215\7FA4\7D44')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RADIOGROUP'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5C07\591A\500B\503C\986F\793A\70BA\5713\9215\7FA4\7D44\9078\9805, \8B93\4E00\822C\4F7F\7528\8005\80FD\5920\9078\53D6\55AE\4E00\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1822713552956622305.4418)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8CC7\6599\6B04\6578\76EE')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\8981\986F\793A\7684\5713\9215\7FA4\7D44\8CC7\6599\6B04\6578\76EE. \4F8B\5982\503C\82E5\70BA <code>2</code>, \5C07\6703\986F\793A\5169\500B\8CC7\6599\6B04, \56E0\6B64\5982\679C\6709 5 \500B\503C, \5C07\6703\986F\793A\5728 3 \500B\8CC7\6599\5217\4E0A.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823061668632450689.4418)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\9078\64C7\6642\7684\9801\9762\52D5\4F5C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\5728\9078\53D6\5713\9215\7FA4\7D44\503C\5F8C\61C9\8A72\63A1\53D6\7684\52D5\4F5C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823062574865452418.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7121')
,p_return_value=>'NONE'
,p_help_text=>unistr('\503C\8B8A\66F4\6642, \4E0D\6703\7ACB\5373\63A1\53D6\52D5\4F5C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823062977982453399.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\9001\51FA\9801\9762')
,p_return_value=>'SUBMIT'
,p_help_text=>unistr('\9801\9762\5DF2\9001\51FA, \4E14\9801\9762 REQUEST \8A2D\70BA\9801\9762\9805\76EE\540D\7A31.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823063380406454049.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\91CD\65B0\5C0E\5411\4E26\8A2D\5B9A\503C')
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>unistr('\700F\89BD\5668\91CD\65B0\5C0E\5411\81F3\76EE\524D\9801\9762, \4E14\76EE\524D\9805\76EE\7684\968E\6BB5\4F5C\696D\72C0\614B\8A2D\70BA\9078\53D6\7684\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(459060107939889859.4418)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\57F7\884C\9A57\8B49\9805\76EE')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823061668632450689.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>unistr('\6307\5B9A\662F\5426\6839\64DA<strong>\9001\51FA\9801\9762</strong>\7684\9801\9762\52D5\4F5C\8A2D\5B9A, \5728\9001\51FA\9801\9762\6642\57F7\884C\9A57\8B49.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(12184106346189362.4418)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>5
,p_prompt=>unistr('\986F\793A\65B9\5411')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VERTICAL'
,p_supported_ui_types=>'JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\5713\9215\7FA4\7D44\503C\7684\986F\793A\65B9\5411.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12184610155190440.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(12184106346189362.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5782\76F4')
,p_return_value=>'VERTICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12185014311191660.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(12184106346189362.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\6C34\5E73')
,p_return_value=>'HORIZONTAL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728745079326901742.4418)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\96B1\85CF\5713\9215')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156982734834553.4418)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4418)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\4EE5 SQL \67E5\8A62\70BA\57FA\790E\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\5177\6709\76F8\540C\986F\793A\503C\548C\50B3\56DE\503C\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\6CE8\610F: \82E5\662F\70BA\986F\793A\503C\548C\50B3\56DE\503C\9078\53D6\76F8\540C\7684\8CC7\6599\6B04, \8ACB\4F7F\7528\8CC7\6599\6B04\5225\540D.</p>'),
'</dd>',
unistr('<dt>\5177\6709\9023\7D50\8B8A\6578\7684\503C\6E05\55AE</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\6CE8\610F: \5982\679C <code>P3_DEPTNO</code> \662F\76F8\540C\9801\9762\4E0A\7684\53EF\4FEE\6539\9801\9762\9805\76EE, \8ACB\5C07<em>\968E\5C64\5F0F LOV \7236\9805\9805\76EE</em>\5C6C\6027\8A2D\70BA <code>P3_DEPTNO</code>.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_reflow
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(4136056421507264989.4418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_REFLOW'
,p_display_name=>unistr('\56DE\6D41\5831\8868')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_REFLOW'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A\5C07\8CC7\6599\6B04\8F49\63DB\70BA\8CC7\6599\5217\7684\56DE\61C9\5F0F\5831\8868, \4EE5\4FBF\5728\5C3A\5BF8\8F03\5C0F\7684\700F\89BD\5668 (\87A2\5E55) \4E0A\986F\793A\5831\8868.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477435524770686441.4418)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4418)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\985E\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9078\53D6\6B64\5831\8868\8CC7\6599\6B04\7684\57FA\790E.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2477435842539687780.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7D14\6587\5B57')
,p_return_value=>'PLAIN'
,p_help_text=>unistr('\986F\793A\8CC7\6599\6B04\503C.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2477436206021688518.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\9023\7D50')
,p_return_value=>'LINK'
,p_help_text=>unistr('\5C07\8CC7\6599\6B04\986F\793A\70BA\9023\7D50.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1959083150869446496.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4418)
,p_display_sequence=>30
,p_display_value=>unistr('\767E\5206\6BD4\5716\8868')
,p_return_value=>'PCT_GRAPH'
,p_help_text=>unistr('\5C07\8CC7\6599\6B04\986F\793A\70BA\767E\5206\6BD4\5716\8868. \64F7\53D6\7684\503C\5FC5\9808\4ECB\65BC 0 \5230 100 \4E4B\9593.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477436573868697592.4418)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4418)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\76EE\6A19')
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\8F38\5165\4F7F\7528\8005\6309\4E00\4E0B\73FE\6709\9805\76EE\6642\8981\547C\53EB\7684\76EE\6A19\9801\9762.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892776020069723116.4418)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4418)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\9023\7D50\6587\5B57')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('\8F38\5165\8981\986F\793A\70BA\9023\7D50\7684 HTML \5167\5BB9. \8ACB\4F7F\7528\5F71\50CF\6A19\8A18\4F86\986F\793A\5F71\50CF, \6216\8005\5F9E\9810\8A2D\5F71\50CF\6E05\55AE\4E2D\9078\53D6.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892779707653875093.4418)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4418)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\9023\7D50\5C6C\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('\6307\5B9A\8981\5305\542B\5728 <code>&lt;a href=...&gt;</code> \6A19\8A18\4E2D\7684\5176\4ED6\8CC7\6599\6B04\9023\7D50\5C6C\6027, \5305\62EC\9023\7D50\76EE\6A19\3001\985E\5225\6216\6A23\5F0F.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959127055512491718.4418)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4418)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\80CC\666F\8272\5F69')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC - '),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\5716\8868\8981\4F7F\7528\7684\80CC\666F\8272\5F69.'),
unistr('\6307\5B9A\8272\5F69\6642, \662F\4F7F\7528\5341\516D\9032\4F4D\8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A.</p>'),
unistr('<p>\5341\516D\9032\4F4D\8868\793A\6CD5\662F\4EE5 #xxyyzz (\4E00\500B # \5F8C\9762\8DDF\8457 3 \500B\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57) \4F86\5B9A\7FA9, \5176\4E2D xx\3001yy \53CA zz \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\96D9\5B57\5143\5341\516D\9032\4F4D\503C.'),
unistr('RGB \4EE3\78BC\662F\4EE5 RGB(xxx,xxx,xxx) \4F86\5B9A\7FA9, \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \7684\6578\5B57, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\55AE\4E00 8 \4F4D\5143\4F4D\5143\7D44\503C.</p>'),
unistr('<p>\5728\7DB2\969B\7DB2\8DEF\4E2D\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5373\53EF\627E\51FA\60A8\60F3\8981\4F7F\7528\4E4B\8272\5F69\7684\5C0D\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959127420108498419.4418)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4418)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\524D\666F\8272\5F69')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \8272\5F69\4EE3\78BC\7684\7BC4\4F8B\5305\62EC - '),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\5716\8868\8981\4F7F\7528\7684\524D\666F\8272\5F69.'),
unistr('\6307\5B9A\8272\5F69\6642, \662F\4F7F\7528\5341\516D\9032\4F4D\8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A.</p>'),
unistr('<p>\5341\516D\9032\4F4D\8868\793A\6CD5\662F\4EE5 #xxyyzz (\4E00\500B # \5F8C\9762\8DDF\8457 3 \500B\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57) \4F86\5B9A\7FA9, \5176\4E2D xx\3001yy \53CA zz \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\96D9\5B57\5143\5341\516D\9032\4F4D\503C.'),
unistr('RGB \4EE3\78BC\662F\4EE5 RGB(xxx,xxx,xxx) \4F86\5B9A\7FA9, \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \7684\6578\5B57, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\55AE\4E00 8 \4F4D\5143\4F4D\5143\7D44\503C.</p>'),
unistr('<p>\5728\7DB2\969B\7DB2\8DEF\4E2D\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5373\53EF\627E\51FA\60A8\60F3\8981\4F7F\7528\4E4B\8272\5F69\7684\5C0D\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959130510461517929.4418)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4418)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\9577\689D\5BEC\5EA6')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>unistr('\50CF\7D20')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>unistr('\8F38\5165\6B64\9577\689D\5716\7684\5BEC\5EA6 (\50CF\7D20).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(149105606951887044.4418)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4418)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\4F5C\70BA\8CC7\6599\5217\6A19\982D')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6B64\9805\76EE\4F9B\8F14\52A9\529F\80FD\4F7F\7528, \7528\65BC\8B58\5225\6700\80FD\4EE3\8868\8CC7\6599\5217\5167\5BB9\7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477398236614545883.4418)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\7248\9762\914D\7F6E\9078\9805')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6AA2\67E5\5176\4ED6\5831\8868\7248\9762\914D\7F6E\9078\9805.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1892776972637774297.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2477398236614545883.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7DDA\689D')
,p_return_value=>'STRIPE'
,p_help_text=>unistr('\5728\6BCF\500B\8CC7\6599\5217\4E0A\65B0\589E\66FF\4EE3\8CC7\6599\5217\7DDA\689D.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1892777396248775060.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2477398236614545883.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\7B46\89F8')
,p_return_value=>'STROKE'
,p_help_text=>unistr('\5728\6BCF\500B\8CC7\6599\5217\4E4B\9593\65B0\589E\6C34\5E73\7DDA.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892777714381781748.4418)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('CSS \985E\5225')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\5143\4EF6\8981\5305\542B\7684\5176\4ED6 CSS \985E\5225 (\4EE5\7A7A\683C\5340\9694).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892778071495783185.4418)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\81EA\8A02\5C6C\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('<p>\8F38\5165\8981\5305\542B\5728\8868\683C HTML \6A19\8A18\4E2D\7684\5176\4ED6\5C6C\6027. \7CFB\7D71\6703\7522\751F\985E\5225 HTML \5C6C\6027, \56E0\6B64\4E0D\9700\8981\63D0\4F9B, \8ACB\6539\7528\5C08\7528\7684 <em>CSS \985E\5225</em>\5C6C\6027.</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(107061404414844166.4418)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4418)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\4F9D\540D\7A31\6392\5217\986F\793A\6240\6709\54E1\5DE5</dt>'),
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
unistr('<dt>\4F9D\540D\7A31\6392\5217\986F\793A\76EE\524D\90E8\9580\7684\6240\6709\54E1\5DE5</dt>'),
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>\5982\679C\4F7F\7528\9023\7D50\8B8A\6578\53C3\7167\9801\9762\9805\76EE, \8ACB\5C07\5B83\5011\6307\5B9A\70BA<strong>\8981\9001\51FA\7684\9801\9762\9805\76EE</strong>.</p>'),
'</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/pct_graph
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(6012795064666735813.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PCT_GRAPH'
,p_display_name=>unistr('\767E\5206\6BD4\5716\8868')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PCT_GRAPH'),'')
,p_javascript_file_urls=>'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.pctGraph#MIN#.js'
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5C07\503C\986F\793A\70BA\767E\5206\6BD4\5716\8868. \64F7\53D6\7684\503C\5FC5\9808\4ECB\65BC 0 \5230 100 \4E4B\9593.')
,p_version_identifier=>'1.0'
,p_files_version=>16
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1760373882350100186.4418)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\986F\793A\503C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\662F\5426\986F\793A\767E\5206\6BD4\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765925486701799362.4418)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\80CC\666F\8272\5F69')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\5716\8868\8981\4F7F\7528\7684\80CC\666F\8272\5F69.'),
unistr('\6307\5B9A\8272\5F69\6642, \662F\4F7F\7528\5341\516D\9032\4F4D\8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A.</p>'),
unistr('<p>\5341\516D\9032\4F4D\8868\793A\6CD5\662F\4EE5 #xxyyzz (\4E00\500B # \5F8C\9762\8DDF\8457 3 \500B\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57) \4F86\5B9A\7FA9, \5176\4E2D xx\3001yy \53CA zz \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\96D9\5B57\5143\5341\516D\9032\4F4D\503C.'),
unistr('RGB \4EE3\78BC\662F\4EE5 RGB(xxx,xxx,xxx) \4F86\5B9A\7FA9, \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \7684\6578\5B57, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\55AE\4E00 8 \4F4D\5143\4F4D\5143\7D44\503C.</p>'),
unistr('<p>\5728\7DB2\969B\7DB2\8DEF\4E2D\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5373\53EF\627E\51FA\60A8\60F3\8981\4F7F\7528\4E4B\8272\5F69\7684\5C0D\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765925773847803225.4418)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\524D\666F\8272\5F69')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\5716\8868\8981\4F7F\7528\7684\524D\666F\8272\5F69.'),
unistr('\6307\5B9A\8272\5F69\6642, \662F\4F7F\7528\5341\516D\9032\4F4D\8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A.</p>'),
unistr('<p>\5341\516D\9032\4F4D\8868\793A\6CD5\662F\4EE5 #xxyyzz (\4E00\500B # \5F8C\9762\8DDF\8457 3 \500B\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57) \4F86\5B9A\7FA9, \5176\4E2D xx\3001yy \53CA zz \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\96D9\5B57\5143\5341\516D\9032\4F4D\503C.'),
unistr('RGB \4EE3\78BC\662F\4EE5 RGB(xxx,xxx,xxx) \4F86\5B9A\7FA9, \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \7684\6578\5B57, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\55AE\4E00 8 \4F4D\5143\4F4D\5143\7D44\503C.</p>'),
unistr('<p>\5728\7DB2\969B\7DB2\8DEF\4E2D\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5373\53EF\627E\51FA\60A8\60F3\8981\4F7F\7528\4E4B\8272\5F69\7684\5C0D\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1760374133781106494.4418)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6587\5B57\8272\5F69')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1760373882350100186.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\6B64\5716\8868\8981\4F7F\7528\7684\6587\5B57\8272\5F69.'),
unistr('\6307\5B9A\8272\5F69\6642, \662F\4F7F\7528\5341\516D\9032\4F4D\8868\793A\6CD5\3001RGB \8272\5F69\4EE3\78BC\6216 HTML \8272\5F69\540D\7A31\4F86\6307\5B9A.</p>'),
unistr('<p>\5341\516D\9032\4F4D\8868\793A\6CD5\662F\4EE5 #xxyyzz (\4E00\500B # \5F8C\9762\8DDF\8457 3 \500B\96D9\4F4D\6578\7684\5341\516D\9032\4F4D\6578\5B57) \4F86\5B9A\7FA9, \5176\4E2D xx\3001yy \53CA zz \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\96D9\5B57\5143\5341\516D\9032\4F4D\503C.'),
unistr('RGB \4EE3\78BC\662F\4EE5 RGB(xxx,xxx,xxx) \4F86\5B9A\7FA9, \5176\4E2D xxx \662F\4ECB\65BC 0 \5230 255 \7684\6578\5B57, \5206\5225\4EE3\8868\7D05\8272\3001\7DA0\8272\53CA\85CD\8272\7684\55AE\4E00 8 \4F4D\5143\4F4D\5143\7D44\503C.</p>'),
unistr('<p>\5728\7DB2\969B\7DB2\8DEF\4E2D\641C\5C0B\300CHTML \8272\5F69\4EE3\78BC\300D, \5373\53EF\627E\51FA\60A8\60F3\8981\4F7F\7528\4E4B\8272\5F69\7684\5C0D\7B49\5341\516D\9032\4F4D\4EE3\78BC\6216 RGB \4EE3\78BC.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765926334751816120.4418)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\9577\689D\5BEC\5EA6')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>3
,p_unit=>unistr('\50CF\7D20')
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\6B64\9577\689D\5716\7684\5BEC\5EA6 (\50CF\7D20).')
);
end;
/
prompt --application/shared_components/plugins/item_type/markdown_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(8511644498934019458.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'MARKDOWN_EDITOR'
,p_display_name=>unistr('Markdown \7DE8\8F2F\5668')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','MARKDOWN_EDITOR'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:PLACEHOLDER:ENCRYPT:FILTER:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A\6587\5B57\5340, \6B64\6587\5B57\5340\652F\63F4 Markdown \8F38\5165\3001\5177\6709\6587\5B57\683C\5F0F\9078\9805\3001\652F\63F4\5305\542B\5F71\50CF, \800C\4E14\63D0\4F9B\7528\4EE5\6AA2\8996\683C\5F0F\5316\6587\5B57\7684\9810\89BD\9078\9805.\300CMarkdown \7DE8\8F2F\5668\300D\53EF\8B93\60A8\4F7F\7528\6613\8B80\3001\6613\5BEB\7684\7D14\6587\5B57\4F86\64B0\5BEB, \7136\5F8C\4F7F\7528\6240\63D0\4F9B\7684\5404\7A2E\9078\9805\548C\652F\63F4\7684\8A9E\6CD5\5C07\5176\8F49\63DB\6210\6709\6548\7D50\69CB\7684 HTML.')
,p_version_identifier=>'1.0.0'
,p_files_version=>408
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(34405931740234149.4418)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5DE5\5177\5217')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SIMPLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\63D0\4F9B\6578\500B\8A2D\5B9A Markdown \7DE8\8F2F\5668\5DE5\5177\5217\7684\9078\9805')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408106298242570.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\7C21\55AE')
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('\5728\5DE5\5177\5217\4E2D\986F\793A\57FA\672C\683C\5F0F\63A7\5236\9805.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408560093252260.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\5B8C\6574')
,p_return_value=>'FULL'
,p_help_text=>unistr('\5728\5DE5\5177\5217\4E2D\986F\793A\4E00\7D44\5B8C\6574\7684\683C\5F0F\63A7\5236\9805.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408916632257999.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4418)
,p_display_sequence=>40
,p_display_value=>unistr('\7121')
,p_return_value=>'NONE'
,p_help_text=>unistr('\96B1\85CF\5DE5\5177\5217.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(590983936587988716.4418)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8A9E\6CD5\6A19\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\662F\5426\8981\91DD\5C0D\7279\5B9A Markdown \5143\7D20 (\4F8B\5982: \7C97\9AD4\3001\659C\9AD4\3001\7A0B\5F0F\78BC\5340\584A\7B49) \5957\7528\8A9E\6CD5\6A19\793A.</p>'),
unistr('<p>\6A19\793A\50C5\9069\7528\65BC 4000 \500B\5B57\5143\4EE5\5167\7684\5167\5BB9.</p>')))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(55495142284465026.4418)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4418)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function( options ) {',
'    options.toolbar.widgetOptions.actions.push( {',
'        name: ''custom'',',
'        action: function(){',
'            alert( ''custom'' );',
'        }',
'    } );',
'    options.toolbar.widgetOptions.data.push( {',
'        groupTogether: true,',
'        controls: [',
'            {',
'                type: ''BUTTON'',',
'                label: ''Custom Button'',',
'                iconOnly: true,',
'                icon: ''fa fa-file-o'',',
'                action: ''custom''',
'            }',
'        ]',
'    } );',
'',
'    return options;',
'}</pre>'))
,p_help_text=>unistr('<p>\8F38\5165\53EF\53D6\7528 Markdown \7DE8\8F2F\5668\7684\7D44\614B\7269\4EF6\3001\4FEE\6539\8A72\7269\4EF6\4E26\5C07\5176\50B3\56DE\7684 JavaScript \51FD\6578. \9019\53EF\5141\8A31\9032\4E00\6B65\81EA\8A02 Markdown \7DE8\8F2F\5668\5916\89C0\3001\529F\80FD\53CA\884C\70BA (\5305\62EC\5DE5\5177\5217\3001\529F\80FD\8868\548C\52D5\4F5C).<p>')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(9126110225642555867.4418)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4418)
,p_name=>'markdownified'
,p_display_name=>'markdownified'
);
end;
/
prompt --application/shared_components/plugins/item_type/yes_no
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(16382027049111291021.4418)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'YES_NO'
,p_display_name=>unistr('\5207\63DB')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','YES_NO'),'')
,p_api_version=>2
,p_render_function=>'D'
,p_validation_function=>'validate_yes_no'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\986F\793A\70BA\7FFB\8F49\5207\63DB\958B\95DC.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14841509770799749.4418)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\958B\555F\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\8F38\5165\4E00\822C\4F7F\7528\8005\9078\64C7<strong>\958B\555F</strong>\9078\9805\6642, \5132\5B58\5728\9801\9762\9805\76EE\4E2D\7684\503C. \503C\7684\9577\5EA6\6700\591A\70BA 255 \500B\5B57\5143.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14842132411815696.4418)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\958B\555F\6A19\7C64')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165<strong>\958B\555F</strong>\9078\9805\7684\986F\793A\6587\5B57. \82E5\672A\8F38\5165\6587\5B57, \5C07\6703\4F7F\7528\7CFB\7D71\9810\8A2D\6A19\7C64.'),
unistr('<p>\6CE8\610F: \5143\4EF6\8A2D\5B9A\300C\986F\793A\6A23\5F0F\300D\82E5\70BA<strong>\5207\63DB</strong>, \5247\6B64\5C6C\6027\53EA\6703\4F5C\70BA\300C\4E92\52D5\5F0F\65B9\683C\300D\8CC7\6599\6B04\7684\986F\793A\503C, \4E0D\6703\91DD\5C0D\4E00\822C\9801\9762\9805\76EE\986F\793A.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14842724970851430.4418)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\95DC\9589\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165\4F7F\7528\8005\9078\64C7<strong>\95DC\9589</strong>\9078\9805\6642, \5132\5B58\5728\9801\9762\9805\76EE\4E2D\7684\503C. \503C\7684\9577\5EA6\6700\591A\70BA 255 \500B\5B57\5143.</p>'),
unistr('<p><em>\6CE8\610F: \5982\679C\9801\9762\9805\76EE\4E2D\586B\5165\7684\503C\4E0D\662F<strong>\958B\555F\503C</strong>\6216<strong>\95DC\9589\503C</strong>, \5C31\6703\4F7F\7528\9019\500B\503C.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14843532719863116.4418)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\95DC\9589\6A19\7C64')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165<strong>\95DC\9589</strong>\9078\9805\7684\986F\793A\6587\5B57. \82E5\672A\8F38\5165\6587\5B57, \5C07\6703\4F7F\7528\7CFB\7D71\9810\8A2D\6A19\7C64.'),
unistr('<p>\6CE8\610F: \5143\4EF6\8A2D\5B9A\300C\986F\793A\6A23\5F0F\300D\82E5\70BA<strong>\5207\63DB</strong>, \5247\6B64\5C6C\6027\53EA\6703\4F5C\70BA\300C\4E92\52D5\5F0F\65B9\683C\300D\8CC7\6599\6B04\7684\986F\793A\503C, \4E0D\6703\91DD\5C0D\4E00\822C\9801\9762\9805\76EE\986F\793A.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2089613064757884864.4418)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4418)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>1
,p_prompt=>unistr('\986F\793A\6A23\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'SWITCH_CB'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(306600152922320417.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4418)
,p_display_sequence=>5
,p_display_value=>unistr('\5207\63DB')
,p_return_value=>'SWITCH_CB'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2089613549171886868.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4418)
,p_display_sequence=>10
,p_display_value=>unistr('\5713\89D2\6309\9215')
,p_return_value=>'SWITCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2089613999173888214.4418)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4418)
,p_display_sequence=>20
,p_display_value=>unistr('\9078\53D6\6E05\55AE')
,p_return_value=>'SELECT_LIST'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10610711090664543.4418)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\4F7F\7528\9810\8A2D\503C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\4F7F\7528\5728\300C\5171\7528\7684\5143\4EF6\300D>\300C\5143\4EF6\8A2D\5B9A\503C\300D\4E2D\70BA\6B64\5143\4EF6\5B9A\7FA9\7684\9810\8A2D\503C, \6216\81EA\8A02\8A2D\5B9A\503C.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382071946350365830.4418)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\958B\555F\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\8F38\5165\4F7F\7528\8005\9078\64C7<strong>\958B\555F</strong>\9078\9805\6642, \5132\5B58\5728\9801\9762\9805\76EE\4E2D\7684\503C. \503C\7684\9577\5EA6\6700\591A\70BA 255 \500B\5B57\5143.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382622645104567710.4418)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\958B\555F\6A19\7C64')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165<strong>\958B\555F</strong>\9078\9805\7684\986F\793A\6587\5B57.'),
unistr('<p>\6CE8\610F: \5143\4EF6\8A2D\5B9A\300C\986F\793A\6A23\5F0F\300D\82E5\70BA<strong>\5207\63DB</strong>, \5247\6B64\5C6C\6027\4E0D\5177\4EFB\4F55\5F71\97FF\529B.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382623150298569207.4418)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\95DC\9589\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F38\5165\4F7F\7528\8005\9078\64C7<strong>\95DC\9589</strong>\9078\9805\6642, \5132\5B58\5728\9801\9762\9805\76EE\4E2D\7684\503C. \82E5\8981\5728\9078\53D6\300C\95DC\9589\300D\9078\9805\5F8C\5132\5B58 <code>NULL</code>, \4E5F\53EF\4EE5\5C07\6B64\5C6C\6027\7559\767D. \503C\7684\9577\5EA6\6700\591A\70BA 255 \500B\5B57\5143.</p>'),
unistr('<p><em>\6CE8\610F: \5982\679C\9801\9762\9805\76EE\4E2D\586B\5165\7684\503C\4E0D\662F<strong>\958B\555F\503C</strong>\6216<strong>\95DC\9589\503C</strong>, \5C31\6703\4F7F\7528\9019\500B\503C.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(21162632375092489.4418)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\95DC\9589\6A19\7C64')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4418)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F38\5165<strong>\95DC\9589</strong>\9078\9805\7684\986F\793A\6587\5B57.'),
unistr('<p>\6CE8\610F: \5143\4EF6\8A2D\5B9A\300C\986F\793A\6A23\5F0F\300D\82E5\70BA<strong>\5207\63DB</strong>, \5247\6B64\5C6C\6027\4E0D\5177\4EFB\4F55\5F71\97FF\529B.</p>')))
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(4968506573302342.4418)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>unistr('\684C\9762')
,p_display_seq=>10
,p_use_auto_detect=>true
,p_is_default=>true
,p_theme_id=>1
,p_home_url=>'f?p=4411:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4418
,p_user_interface_id=>wwv_flow_api.id(4968506573302342.4418)
,p_name=>unistr('\8A0A\606F')
,p_step_title=>unistr('\8A0A\606F')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(91626406749381989.4418)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
