prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4477
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4477 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4477
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116284268196403999')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'zh-tw'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4477)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113355'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4477)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4477)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4477)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4477)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4477)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4477)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4477)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4477)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4477)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4477)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4477)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4477)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4477)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.zh-tw'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4477
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4477)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4477)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4477)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4477)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4477)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4477)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4477)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.zh-tw'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4477
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4477)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4477)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4477)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4477)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4477)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4477)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4477)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.zh-tw'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4477
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4477)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4477)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4477)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4477)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4477)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4477)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4477)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4477)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4477)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4477)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4477)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4477)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4477)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4477)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4477)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4477)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4477)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.zh-tw'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4477
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4477)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4477)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4477)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4477)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4477)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4477)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4477)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4477)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4477)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4477)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4477)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4477)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4477)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4477)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4477)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.zh-tw'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4477
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4477)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4477)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4477)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4477)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4477)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4477)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4477)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4477)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4477)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4477)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4477)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4477)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4477)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4477)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4477)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.zh-tw'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4477
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4477)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4477)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4477)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4477)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4477)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4477)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4477)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4477)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4477)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4477)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4477)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4477)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4477)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4477)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4477)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.zh-tw'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4477
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4477)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4477)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4477)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4477)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4477)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4477)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4477)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4477)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4477)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4477)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4477)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4477)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4477)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4477)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4477)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4477
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4477)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4477
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4477)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4477
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4477)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4477
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4477)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4477
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4477)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4477
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4477)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4477
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4477)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4477)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4477)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4477)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4477)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4477)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4477)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4477)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4477)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4477)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4477)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4477)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4477)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4477)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4477
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4477)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4477)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4477)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4477)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4477)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4477)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4477)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4477)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4477)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4477
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4477)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4477)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4477)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4477)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4477)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4477)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4477)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4477)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4477)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4477)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4477)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4477)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4477)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4477)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4477)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4477)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4477)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4477)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4477)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4477)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4477)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4477)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4477)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4477)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4477)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4477
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4477)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4477)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4477)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4477)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4477)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4477)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4477)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4477)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4477)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4477)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4477)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4477)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4477)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4477)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4477)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4477)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4477)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4477)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4477)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4477
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4477)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4477)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4477)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4477)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4477)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4477
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4477)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4477)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4477)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4477)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4477)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4477)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4477)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4477)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4477)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4477)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4477)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4477)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4477)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4477
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4477)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4477)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4477)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4477)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4477)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4477
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4477)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4477)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4477)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4477)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4477)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4477
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4477)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4477)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4477)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4477)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4477)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4477)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4477)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4477)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4477)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4477
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4477)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4477)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4477)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4477)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4477)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4477)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4477)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4477)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4477)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4477)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4477)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4477)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4477)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4477)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4477
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4477)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4477)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4477)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4477)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4477)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4477
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4477)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4477
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4477)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4477
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4477)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4477
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4477)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4477
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4477)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4477
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4477)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4477
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4477)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4477
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4477)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4477
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4477)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4477
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4477)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4477
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4477)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4477
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4477)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4477
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4477)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4477
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4477)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4477
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4477)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4477
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4477)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4477
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4477)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4477
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4477)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4477
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4477)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4477
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4477)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4477
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4477)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4477
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4477)
,p_page_name=>'winlov'
,p_page_title=>unistr('\641C\5C0B\5C0D\8A71\65B9\584A')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>unistr('\641C\5C0B')
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>unistr('\95DC\9589')
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('\4E0B\4E00\6B65 &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; \4E0A\4E00\6B65')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>unistr('<div class="a-PopupLOV-pagination">\8CC7\6599\5217 #FIRST_ROW# - #LAST_ROW#</div>')
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4477
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4477)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4477
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4477)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4477)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4477)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4477)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4477)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4477)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4477)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4477)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4477)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4477)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4477)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4477)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4477)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4477)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4477)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4477)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4477)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4477)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4477)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4477)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4477)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4477)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4477)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4477)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4477)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4477)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4477)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4477)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4477)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4477)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4477)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4477)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4477)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4477)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4477)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4477)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4477)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4477)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4477)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4477)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4477)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4477)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4477)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4477)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4477)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4477)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4477)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4477)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4477)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4477)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4477)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4477)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4477)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4477)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4477)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4477)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4477)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4477)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4477)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4477)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4477)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4477)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4477)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4477)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4477)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4477)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4477)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4477)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4477)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4477)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4477)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4477)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4477)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4477)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4477)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4477)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4477)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4477)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4477)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4477)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4477)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4477)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4477)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4477)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4477)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4477)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4477)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4477)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4477)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4477)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4477)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4477)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4477)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4477)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4477)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4477)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4477)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4477)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4477)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4477)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4477)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4477)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4477)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4477)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4477)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4477)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4477)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4477)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4477)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4477)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4477)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4477)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4477)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4477)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4477)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4477)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4477)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4477)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4477)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4477)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4477)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4477)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4477)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4477)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4477)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4477)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4477)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4477)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4477)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4477)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4477)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4477)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4477)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4477)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4477)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4477)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4477)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4477)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4477)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4477)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4477)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4477)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4477)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4477)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4477)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4477)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4477)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4477)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4477)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4477)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4477)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4477)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4477)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4477)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4477)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4477)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4477)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4477)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4477)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4477)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4477)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4477)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4477)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4477)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4477)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4477)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4477)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4477)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4477)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4477)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4477)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4477)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4477)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4477)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4477)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4477)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4477)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4477)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4477)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4477)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4477)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4477)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4477)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4477)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4477)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4477)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4477)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4477)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4477)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4477)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4477)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4477)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4477)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4477)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4477)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4477)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4477)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4477)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4477)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4477)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4477)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4477)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4477)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4477)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4477)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4477)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4477)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4477)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4477)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4477)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4477)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4477)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4477)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4477)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4477)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4477)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4477)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4477)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4477)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4477)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4477)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4477)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115953659220402923)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115940751831402914)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406\54E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115940607784402914)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115997938287402956)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\88AB\62D2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115957625886402926)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684 %0 \5E33\6236\5DF2\7D93\5EFA\7ACB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115943283054402916)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E33\6236\5DF2\88AB\9396\5B9A.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115933124634402909)
,p_name=>'AM_PM'
,p_message_language=>'zh-tw'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116067568651403008)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5207\63DB %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116075637747403014)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\4F5C\7528\4E2D)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116045114926402992)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Ajax \547C\53EB\91DD\5C0D %1 \50B3\56DE\4F3A\670D\5668\932F\8AA4 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115975971652402940)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5C07\61C9\7528\7A0B\5F0F\5225\540D "%0" \8F49\63DB\6210\552F\4E00\7684\61C9\7528\7A0B\5F0F ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115976057053402940)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5B58\5728\5225\540D\70BA "%0" \7684\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115965625323402932)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1816 \8F49\63DB\61C9\7528\7A0B\5F0F\5225\540D p_flow_alias_or_id (%0) \6642\767C\751F\672A\9810\671F\7684\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116058563796403001)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7E3D\548C\6AA2\9A57\63D0\4F9B\4E86\4E00\7A2E\7C21\6613\65B9\5F0F, \53EF\5224\65B7\8DE8\5DE5\4F5C\5340\9593\662F\5426\90E8\7F72\4E86\76F8\540C\7684\61C9\7528\7A0B\5F0F. \60A8\53EF\4EE5\6BD4\8F03\6B64\7E3D\548C\6AA2\9A57\4F86\5224\65B7\662F\5426\6709\76F8\7B26\7684\9805\76EE. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115951456393402922)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\8A8D\8B49\51FD\6578\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115936852039402911)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\8A8D\8B49\51FD\6578\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116100314533403033)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6388\6B0A Oracle Cloud Identity Management \50B3\56DE\7684\79DF\7528\6236\540D\7A31 %0 \4F7F\7528\7DB2\57DF %1!<br/>\8ACB<a href="&LOGOUT_URL.">\91CD\65B0\767B\5165</a>\4E26\6307\5B9A\6388\6B0A\7684\79DF\7528\6236\540D\7A31, \6216\8005\8B8A\66F4\60A8\7684 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115934576346402910)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\5E33\6236 "%0" \6C92\6709\5DE5\4F5C\5340 "%1" \7684\5FC5\8981\958B\767C\6B0A\9650 (DB_DEVELOPER \6216 DB_ADMINISTRATOR)!<br/> \8ACB\5728\7372\5F97\6B0A\9650\4E4B\5F8C<a href="&LOGOUT_URL.">\91CD\65B0\767B\5165</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115933657385402909)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6388\6B0A Oracle Cloud Identity Management \50B3\56DE\7684\79DF\7528\6236\540D\7A31\4F7F\7528\76EE\524D\7684\5DE5\4F5C\5340!<br/>\8ACB<a href="&LOGOUT_URL.">\91CD\65B0\767B\5165</a>\4E26\6307\5B9A\6388\6B0A\7684\79DF\7528\6236\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115934633032402910)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57FA\65BC\5B89\5168\56E0\7D20, \4E0D\5141\8A31\4EE5 URL \4E2D\7684\7DB2\57DF\57F7\884C\6B64\5DE5\4F5C\5340\7684\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115951186511402922)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\8981\6C42\60A8\7684 DBA \57F7\884C $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115951081809402922)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SYS.DBMS_LDAP \5957\88DD\7A0B\5F0F\4E0D\5B58\5728\6216\7121\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115950991474402922)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\7DE8\8F2F LDAP \4F7F\7528\8005\51FD\6578\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115951242953402922)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406 LDAP \8A8D\8B49\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115952082169402922)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('login_page \7A0B\5E8F\7684 p_flow_page \5F15\6578\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115951632527402922)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1 \4E2D\7684 p_session \7121\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115999598649402957)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2 \7684\5F15\6578\683C\5F0F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115951726198402922)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\9001\81F3\767B\5165\7A0B\5E8F\7684\4F7F\7528\8005\540D\7A31\662F\7A7A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115940551154402914)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\7B49\5F85 <span id="apex_login_throttle_sec">%0</span> \79D2\5F8C\518D\91CD\65B0\767B\5165.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115941805185402915)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\5165\5617\8A66\5DF2\88AB\5C01\9396.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115997327304402955)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\8A8D\8B49 "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115942100320402915)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B89\5168\6027\7FA4\7D44 ID \662F\7A7A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115951505956402922)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\8A8D\8B49\5F8C\8655\7406\4F5C\696D\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115951390735402922)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\8A8D\8B49\524D\8655\7406\4F5C\696D\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115952538567402923)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8ACB\5728\8D77\59CB\300C\91CD\8A2D\5BC6\78BC\300D\8981\6C42\7684\76F8\540C\700F\89BD\5668\4E2D\958B\555F\6B64 URL.  \5982\679C\60A8\6309\4E00\4E0B\300C\91CD\8A2D\5BC6\78BC URL\300D, \7136\5F8C\88AB\91CD\65B0\5C0E\5411\81F3'),
unistr('\767B\5165\9801\9762, \8ACB\518D\6B21\8D77\59CB\91CD\8A2D\5BC6\78BC, \4E26\5C07\700F\89BD\5668'),
unistr('\4FDD\6301\958B\555F.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116097864426403031)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D\5BC6\78BC URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115934898980402910)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C1A\672A\5C07\8CC7\6E90\7BA1\7406\7A0B\5F0F\7528\6236\7FA4\7D44 %0 \6388\4E88 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115934935723402910)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\4F7F\7528 DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP \6388\4E88\7F3A\5C11\7684\6B0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115962979402402930)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\968E\6BB5\4F5C\696D\611F\6E2C\51FD\6578\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115963033420402930)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\968E\6BB5\4F5C\696D\9A57\8B49\51FD\6578\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115963251713402930)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\8981\6C42\60A8\7684 %0 \7BA1\7406\54E1\8A2D\5B9A Oracle Application Server Single Sign-On \5F15\64CE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115972722643402938)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('sso \50B3\56DE\4E4B %1 \6B0A\6756\4E2D\7684 %0 \7121\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115951913297402922)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\7DE8\8F2F\8A8D\8B49\914D\7F6E\4E26\65B0\589E\61C9\7528\7A0B\5F0F\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115972429574402937)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \7A0B\5E8F\7684\547C\53EB\7AEF\7121\6548:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115972677903402938)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('urlc \6B0A\6756\4E2D\7684\61C9\7528\7A0B\5F0F\968E\6BB5\4F5C\696D\7121\6548: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115972205256402937)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('portal_sso_redirect \767C\751F\932F\8AA4: \6C92\6709\61C9\7528\7A0B\5F0F\8A3B\518A\8CC7\8A0A: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115963144217402930)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('WWSEC_SSO_ENABLER_PRIVATE \5957\88DD\7A0B\5F0F\4E0D\5B58\5728\6216\7121\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115951854372402922)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\8A8D\8B49\914D\7F6E\4E2D\627E\4E0D\5230\8A3B\518A\7684\5925\4F34\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115972398230402937)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\4F9D\7167\5B89\88DD\6307\5357\7684\8AAA\660E\4F86\8A3B\518A\6B64\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115963370086402930)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406 SSO \8A8D\8B49\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116072742448403012)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6388\6B0A\7684 URL:  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115962733687402930)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\8A8D\8B49\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115934785864402910)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340 "%0" \975E\4F5C\7528\4E2D. \8ACB\6D3D\8A62\60A8\7684\7BA1\7406\54E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115935129254402910)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'zh-tw'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115941505477402915)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\61C9\7528\7A0B\5F0F\300D\5B89\5168\6027\6AA2\67E5\62D2\7D55\5B58\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115941605096402915)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\9801\9762\300D\5B89\5168\6027\6AA2\67E5\62D2\7D55\5B58\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115941703577402915)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\6388\6B0A\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116005120671402961)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528 %1 %0 \5EFA\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116005278312402962)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AA0\5FC3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116063016545403005)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6\63CF\8FF0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116062832411403005)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\65E5\671F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116063115855403005)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6 ID')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116062730077403005)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\65E5\671F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116062902092403005)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6\6A19\984C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115953559551402923)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\548C\6AA2\9A57\5167\5BB9\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115953457868402923)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\548C\6AA2\9A57\683C\5F0F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116017468752402971)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8907\88FD\5230\526A\8CBC\7C3F.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116017101747402971)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\700F\89BD\5668\4E0D\652F\63F4\5F9E\6309\9215\6216\529F\80FD\8868\9032\884C\8907\88FD. \8ACB\5617\8A66 Ctrl+C \6216 Command+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116005650800402962)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589\901A\77E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116061697803403004)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\6BD4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116056105231403000)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116056006788403000)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D77\59CB\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116060237832403003)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \5FC5\9808\662F\6709\6548\7684\8272\5F69. \7BC4\4F8B: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116055983522403000)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\8272\5F69')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116056280273403000)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4\8272\5F69\683C\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116095451850403029)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\6E05\55AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116095506196403029)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\555F\6E05\55AE: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116075787372403014)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\5DF2\5B8C\6210)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115968028297402934)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\6D3D\8A62\60A8\7684\61C9\7528\7A0B\5F0F\7BA1\7406\54E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115982459148402945)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8ACB\6D3D\8A62\60A8\7684\61C9\7528\7A0B\5F0F\7BA1\7406\54E1.'),
unistr('\6709\95DC\6B64\672A\9810\671F\4E8B\4EF6\7684\8A73\7D30\8CC7\8A0A, \8ACB\900F\904E\9664\932F ID "%0" \4F86\53D6\5F97.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116060541413403003)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\5148\66F4\6B63\932F\8AA4\5F8C\518D\5132\5B58.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116006564038402962)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\5230 %0 \500B\76F8\7B26\9805\76EE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116006430653402962)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\76F8\7B26\9805\76EE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116076207572403015)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\9032\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116060902088403003)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('APEX_APPLICATION_TEMP_FILES \4E2D\6C92\6709\9805\76EE %0 \6307\5B9A\7684\6A94\6848.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116049478627402995)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\4E2D\7684\76EE\524D\8CC7\6599\7248\672C\81EA\4F7F\7528\8005\8D77\59CB\66F4\65B0\8655\7406\4F5C\696D\5F8C\5DF2\7D93\8B8A\66F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116018552079402972)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\8F09\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116065591238403007)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116065313524403007)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D2\5165\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116079484803403017)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9806\5E8F : \52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116065491285403007)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116006940808402963)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5373\73FE\5F0F\884C\4E8B\66C6: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115929549967402906)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115929631454402906)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116065725356403007)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165 #LABEL# \503C.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116065631990403007)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \5FC5\9808\662F\6709\6548\7684\65E5\671F, \4F8B\5982 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115933292210402909)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \5FC5\9808\4ECB\65BC %0 \548C %1 \4E4B\9593.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115933373284402909)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \5FC5\9808\5728 %0 \6216\4E4B\5F8C.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115933418457402909)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \5FC5\9808\5728 %0 \6216\4E4B\524D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116010400872402965)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \5927\65BC\6307\5B9A\7684\6700\5927\65E5\671F %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116010869669402966)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \4E0D\7B26\5408\683C\5F0F %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116010323731402965)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \5C0F\65BC\6307\5B9A\7684\6700\5C0F\65E5\671F %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116010567705402966)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \4E0D\5728 %0 \5230 %1 \7684\6709\6548\7BC4\570D\5167.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116010715415402966)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \4E0D\5728 %0 \5230 %1 \7684\6709\6548\5E74\5EA6\7BC4\570D\5167.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116060845524403003)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116088078897403024)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116090082988403025)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116060601382403003)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78BA\5B9A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116060765244403003)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115966966596402933)
,p_name=>'APEX.ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115934384778402910)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\932F\8AA4\8655\7406\56DE\547C\6642\767C\751F\4E0B\5217\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115943014564402916)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E6A\88FD\932F\8AA4\9801\9762\6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115935079507402910)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\90E8\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116074825858403014)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8ACB\6D3D\8A62\60A8\7684\7BA1\7406\54E1.'),
unistr('\6709\95DC\6B64\672A\9810\671F\4E8B\4EF6\7684\8A73\7D30\8CC7\8A0A, \8ACB\900F\904E\9664\932F ID "%0" \4F86\53D6\5F97.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116069136493403010)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\4EE5\552F\8B80\6A21\5F0F\958B\555F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116099728404403033)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ORA-28353: \7121\6CD5\958B\555F\516C\4E8B\5305. \61C9\7528\7A0B\5F0F\8CC7\6599\76EE\524D\7121\6CD5\5B58\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116069279010403010)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62B1\6B49, \6B64\9801\9762\4E0D\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115936737103402911)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6280\8853\8CC7\8A0A (\552F\6709\958B\767C\4EBA\54E1\80FD\5920\898B\5230)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116032846173402982)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4\8A0A\606F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116046766246402993)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\671F\683C\5F0F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116013410489402968)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\5DF2\5728\5B58\53D6\63A7\5236\6E05\55AE\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116013323446402968)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\78BA\8A8D\8981\5C07\4E0B\5217 %0 \4F4D\4F7F\7528\8005\65B0\589E\81F3 <strong>%1</strong> \5B58\53D6\63A7\5236\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116013880068402968)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\5728\91CD\8907\7684\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116013573641402968)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\96FB\5B50\90F5\4EF6\5730\5740\300D\4E2D\907A\6F0F at \7B26\865F (@)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116013689433402968)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\96FB\5B50\90F5\4EF6\5730\5740\300D\4E2D\907A\6F0F\53E5\865F (.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116013704685402968)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31\592A\9577')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116014091103402968)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\6709\61C9\7528\7A0B\5F0F\5B58\53D6\63A7\5236\6E05\55AE\4E2D\5B9A\7FA9\7684\4F7F\7528\8005\53EF\4EE5\5B58\53D6\6B64\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116014183859402968)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9810\671F\7684\5B58\53D6\63A7\5236\8A2D\5B9A\503C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116013997923402968)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\5DF2\8A8D\8B49\7684\4F7F\7528\8005\90FD\53EF\4EE5\5B58\53D6\6B64\61C9\7528\7A0B\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116056766454403000)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116056625279403000)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\555F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116056944860403000)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0: \5DF2\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116056812876403000)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0: \5DF2\555F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116056568120403000)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\8B58\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116049641112402995)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116006180967402962)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528\7684\7BE9\9078 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116047256625402993)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115932132667402908)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\689D\5716')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116059973066403003)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115932222862402908)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\9905\5716')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116058649359403002)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115931951536402908)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A08\6578')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116047792926402993)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116047816649402994)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8\6E05\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116047944733402994)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116065159113403007)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9762\5411 %0 \6240\53C3\7167\7684\8CC7\6599\6B04 %1 \7121\6CD5\4F7F\7528\6216\672A\7D93\6388\6B0A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115922330297402901)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\8981\986F\793A\7684\7BE9\9078\689D\4EF6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116004304131402961)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \7B46\7D50\679C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116004451857402961)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9078\53D6 %0 \7B46')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116007012728402963)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\7BE9\9078')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115923882641402902)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078\689D\4EF6\6E05\55AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116063640013403005)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D85\51FA\9762\5411 %1 \7684\76F8\7570\503C\9650\5236 (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116049277457402995)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('DATE \6216 TIMESTAMP \8CC7\6599\6B04\4E0D\652F\63F4\9762\5411 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116047358609402993)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116047499698402993)
,p_name=>'APEX.FS.GO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116048842557402994)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B49\65BC %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115932970009402909)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\542B %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115932686875402908)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5927\65BC %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115932729324402909)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5927\65BC\6216\7B49\65BC %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115932470461402908)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\65BC %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115932545628402908)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\65BC\6216\7B49\65BC %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115932875561402909)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\982D\70BA %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115935369725402910)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\8F38\5165\6B04\4F4D\300D\9762\5411\4E0D\652F\63F4 %0 \8CC7\6599\985E\578B (%1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115925550158402903)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\591A\91CD\503C\300D\9762\5411\9700\8981 12.2 \6216\66F4\65B0\7248\672C\7684\8CC7\6599\5EAB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116049082188402994)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\91DD\5C0D\9762\5411 %0 \63D0\4F9B\4EFB\4F55\641C\5C0B\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115922473803402901)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\591A\7BE9\9078\689D\4EF6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116004535867402961)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\570D\958B\59CB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116048517740402994)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \81F3 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116048609197402994)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9AD8\65BC %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116048799264402994)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4E\65BC %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116004642493402961)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\570D\7D50\675F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116067428088403008)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\570D\9762\5411 %0 \7684 LOV \9805\76EE #%2 ("%1") \7121\6548 (\907A\6F0F "|" \5340\9694\7B26\865F).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116048981383402994)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\4E0D\652F\63F4\624B\52D5\8F38\5165\7BC4\570D\9762\5411 %0, \56E0\70BA\8CC7\6599\6B04\70BA DATE \6216 TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116048250374402994)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115932048879402908)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664\5716\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116001175361402958)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116047685542402993)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116047543102402993)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116048432474402994)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \9078\53D6 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115931824792402908)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5716\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116048029516402994)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\8F03\5C11\9805\76EE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116048192879402994)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\66F4\591A\9805\76EE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116048330445402994)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \9846\661F\4EE5\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116006026412402962)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078\5EFA\8B70')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116049120454402995)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\50C5 NUMBER \8CC7\6599\6B04\652F\63F4\6587\5B57\6B04\4F4D\9762\5411 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115922229615402901)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\7E3D\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116065280155403007)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\591A\9762\5411\641C\5C0B\4E0D\652F\63F4 %0 \8CC7\6599\985E\578B (%1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116057152369403000)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D\5F80\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116014794414402969)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\805A\7E3D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116022355525402975)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF\63A7\5236\5206\6BB5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116014822571402969)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63A7\5236\5206\6BB5.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116022271645402974)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C55\958B\63A7\5236\5206\6BB5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116100920447403034)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116022053405402974)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664 %0 \500B\8CC7\6599\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116092439088403027)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8907\7684\8B58\5225')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116011762784402966)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C\4E00\500B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116015047167402969)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44\6A19\982D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116014998231402969)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\982D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116011883644402967)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5F8C\4E00\500B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116031814814402982)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\5176\4ED6\8CC7\6599\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116011515778402966)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\500B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116015106897402969)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\8CC7\6599\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116011959091402967)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'zh-tw'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116012038475402967)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 - %1, \5171 %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116068089209403009)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\9801\9762')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116011657297402966)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\500B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116092273663403027)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\65B0\589E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116092337509403027)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8B8A\66F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116100723405403033)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217 %0, \8CC7\6599\6B04 %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116100859508403033)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116092146939403027)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116015385619402969)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\6A19\982D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116010931004402966)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9078\53D6 %0 \500B\5132\5B58\683C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116012109959402967)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9078\53D6 %0 \500B\8CC7\6599\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116052445522402997)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\9078')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116022115545402974)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C %0 \9801')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116015202291402969)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8CC7\6599\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116015446087402969)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\905E\589E\6392\5E8F %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116015584059402969)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\905E\6E1B\6392\5E8F %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116011036813402966)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\905E\589E\6392\5E8F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116011385598402966)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\905E\589E\6392\5E8F %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116011143330402966)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\905E\6E1B\6392\5E8F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116011463819402966)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\905E\6E1B\6392\5E8F %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116011235478402966)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\6392\5E8F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116021913280402974)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\8A08 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115948330504402920)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D "%0" \7684 HTTP \8981\6C42\5931\6557.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116089628817403025)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\683C\9078\53D6\6E05\55AE %0 \8CC7\6599\6B04 %1 \8CC7\6599\5217. \4F7F\7528\65B9\5411\9375')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116021807202402974)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6E05\55AE %0 \8CC7\6599\5217. \4F7F\7528\65B9\5411\9375')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116100530352403033)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\65B9\683C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116008632446402964)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116009613797402965)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116009527252402965)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\8CC7\6599\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116094072080403028)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\805A\7E3D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116079571169403017)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\805A\7E3D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116081217563403018)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116037628294402986)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\6587\5B57\8CC7\6599\6B04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116038815596402987)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66FF\4EE3\9805\76EE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116039987322402988)
,p_name=>'APEX.IG.AND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116059331306403002)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8FD1\4F3C\76F8\7570\8A08\6578')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116095058216403029)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6574\9AD4\8FD1\4F3C\76F8\7570\8A08\6578')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116078148078403016)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\5716')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116080034846403017)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\905E\589E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116038976167402987)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6388\6B0A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116094107802403028)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\52D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116059737226403002)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E73\5747\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116094714834403029)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6574\9AD4\5E73\5747\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116077678608403016)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64\8EF8\6A19\984C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116077828604403016)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\6578\4F4D\6578')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116077729103403016)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6578\503C\8EF8\6A19\984C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116083867435403020)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\80CC\666F\8272\5F69')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116078262673403016)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\689D\5716')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116034296443402983)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4ECB\65BC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116085064328403021)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8C\8005')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116078324387403016)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6CE1\6CE1\5716')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116009869259402965)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116039820138402988)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\5206\5927\5C0F\5BEB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116095679599403029)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\5340\5206\5927\5C0F\5BEB)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116066563652403008)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5132\5B58\8B8A\66F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116010252464402965)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4\6AA2\8996')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116040988309402988)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116037479669402986)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\67E5\8A62\8D85\51FA\6BCF\4E00\5716\8868 %0 \500B\8CC7\6599\9EDE\7684\6578\76EE\4E0A\9650. \8ACB\5957\7528\7BE9\9078\689D\4EF6\4F86\6E1B\5C11\60A8\57FA\790E\67E5\8A62\4E2D\7684\8A18\9304\6578\76EE.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116008559822402964)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868\6AA2\8996')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116015816059402970)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116077165365403015)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6536\76E4\50F9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116084000756403020)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8272\5F69')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116060152330403003)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\89BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116039295992402987)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116008735231402964)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116085810562403022)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\7528\9014')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116039345728402987)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\96DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116008914728402964)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116034806082402984)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\542B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116041116606402989)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63A7\5236\5206\6BB5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116015616263402969)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\5230\526A\8CBC\7C3F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116015745184402969)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116059120573403002)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A08\6578')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116059200805403002)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\7570\8A08\6578')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116094984464403029)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6574\9AD4\76F8\7570\8A08\6578')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116094810425403029)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6574\9AD4\8A08\6578')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116092596911403027)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116037842116402986)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116085677636403022)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\985E\578B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116085266209403021)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116066344782403007)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\65E5\671F\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116035566454402984)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5929')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116038563229402987)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116038319317402986)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\985E\578B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116009729632402965)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116086872903403023)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78BA\5B9A\8981\522A\9664\6B64\5831\8868\55CE?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116042925947402990)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\8CC7\6599\5217')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116041777416402989)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\8CC7\6599\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116080168449403018)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\905E\6E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116040601724402988)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A73\7D30\8CC7\8A0A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116008283428402964)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A73\7D30\6AA2\8996')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116068885350403009)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\5411')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116040376237402988)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\505C\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116034939428402984)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5305\542B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116035182073402984)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\982D\4E0D\70BA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116078420313403016)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\74B0\5708\5716')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116041370905402989)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115940055887402914)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50C5\8CC7\6599')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116087833616403023)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\683C\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115952671606402923)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\555F\7528\4E0B\8F09\683C\5F0F %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116080887070403018)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8907\7684\805A\7E3D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116080994447403018)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8907\7684\63A7\5236\5206\6BB5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116042858138402990)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8907\7684\8CC7\6599\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116041686277402989)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD\8CC7\6599\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116009348326402965)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116079919802403017)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\5716\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116091447692403026)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\7FA4\7D44\4F9D\64DA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116087460161403023)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\4EF6\526F\672C (bcc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116087667355403023)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A0A\606F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116087341012403023)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\526F\672C (cc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116087046054403023)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\5DF2\50B3\9001.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116087524627403023)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\65E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116087235094403023)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6536\4EF6\8005 (to)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116040000980402988)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\555F\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116033211477402983)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B49\65BC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116086472942403022)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116040164692402988)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116086395855403022)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116052334089402997)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\5DF2\5099\59A5. \958B\59CB\4E0B\8F09\4E2D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116015998333402970)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\586B\5165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116017087696402970)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\9805\76EE\586B\5165\65B9\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116016929875402970)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\586B\5165\9078\64C7\9805\76EE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116008859417402964)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116039454566402987)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078\689D\4EF6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116094443444403029)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116080337239403018)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C\4E00\500B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116009043022402964)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5012\6EAF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116037950418402986)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116084982302403021)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F\906E\7F69')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116086739732403022)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'zh-tw'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116086642808403022)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'zh-tw'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115999407868402957)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'zh-tw'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115938759814402913)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'zh-tw'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116042576235402990)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51CD\7D50')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116040233885402988)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578\548C\904B\7B97\5B50')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116078584901403016)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6F0F\6597\5716')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116059092488403002)
,p_name=>'APEX.IG.GO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116033877576402983)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5927\65BC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116033991111402983)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5927\65BC\6216\7B49\65BC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116040575281402988)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\683C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116008083915402964)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\683C\6AA2\8996')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116081107450403018)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116040773866402988)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44\4F9D\64DA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116008365491402964)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44\4F9D\64DA\6AA2\8996')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116085524505403022)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\689D\4EF6\985E\578B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116084486555403021)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116084659555403021)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C\5C0D\9F4A\65B9\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116094372312403028)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116089817355403025)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\76F4\63A5\5728\6B64\4E92\52D5\5F0F\65B9\683C\5167\63D2\5165\3001\66F4\65B0\53CA\522A\9664\8CC7\6599.</p>'),
'',
unistr('<p>\82E5\8981\63D2\5165\65B0\8CC7\6599\5217, \8ACB\6309\4E00\4E0B\300C\65B0\589E\8CC7\6599\5217\300D\6309\9215.</p>'),
'',
unistr('<p>\82E5\8981\7DE8\8F2F\73FE\6709\8CC7\6599, \8ACB\6309\5169\4E0B\7279\5B9A\5132\5B58\683C. \82E5\662F\8981\9032\884C\8F03\5927\91CF\7684\7DE8\8F2F\5DE5\4F5C, \8ACB\6309\4E00\4E0B\300C\7DE8\8F2F\300D\4EE5\9032\5165\7DE8\8F2F\6A21\5F0F. \5728\7DE8\8F2F\6A21\5F0F\4E2D, \60A8\53EF\4EE5\6309\4E00\4E0B\6216\4F7F\7528\9375\76E4\4F86\7DE8\8F2F\7279\5B9A\5132\5B58\683C.</p>'),
'',
unistr('<p>\82E5\8981\8907\88FD\53CA\522A\9664\8CC7\6599\5217, \8ACB\4F7F\7528\300C\8B8A\66F4\300D\529F\80FD\8868. \82E5\8981\555F\7528\300C\8B8A\66F4\300D\529F\80FD\8868, \8ACB\4F7F\7528\6838\53D6\65B9\584A\4F86\9078\53D6\4E00\6216\591A\500B\8CC7\6599\5217.</p>'),
'',
unistr('<p>\82E5\8981\8907\88FD\9078\53D6\7684\8CC7\6599\5217, \8ACB\6309\4E00\4E0B\300C\8B8A\66F4\300D\529F\80FD\8868\4E26\9078\53D6\300C\8907\88FD\8CC7\6599\5217\300D. \82E5\8981\522A\9664\9078\53D6\7684\8CC7\6599\5217, \8ACB\6309\4E00\4E0B\300C\8B8A\66F4\300D\529F\80FD\8868\4E26\9078\53D6\300C\522A\9664\8CC7\6599\5217\300D.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116091952121403027)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116092066861403027)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E92\52D5\5F0F\65B9\683C\6703\4EE5\53EF\641C\5C0B\4E14\53EF\81EA\8A02\7684\5831\8868\5F62\5F0F\5448\73FE\4E00\7D44\8CC7\6599. \60A8\53EF\4EE5\57F7\884C\6578\7A2E\4F5C\696D\4F86\9650\5236\50B3\56DE\7684\8A18\9304, \4EE5\53CA\8B8A\66F4\8CC7\6599\7684\986F\793A\65B9\5F0F.</p>'),
'',
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\300C\641C\5C0B\300D\6B04\4F4D\4F86\7BE9\9078\50B3\56DE\7684\8A18\9304. \6309\4E00\4E0B\300C\52D5\4F5C\300D\5373\53EF\5B58\53D6\8A31\591A\53EF\4F9B\4FEE\6539\5831\8868\7248\9762\914D\7F6E\7684\9078\9805, \6216\8005\4F7F\7528\5DF2\986F\793A\8CC7\6599\6B04\7684\300C\8CC7\6599\6B04\6A19\984C\300D\529F\80FD\8868.</p>'),
'',
unistr('<p>\82E5\8981\5C07\60A8\7684\81EA\8A02\9805\5132\5B58\81F3\5831\8868, \8ACB\4F7F\7528\300C\5831\8868\8A2D\5B9A\503C\300D. \60A8\4E5F\53EF\4EE5\5C07\5831\8868\7684\8CC7\6599\4E0B\8F09\81F3\5916\90E8\6A94\6848, \6216\4F7F\7528\96FB\5B50\90F5\4EF6\5C07\8CC7\6599\50B3\9001\7D66\81EA\5DF1\6216\5176\4ED6\4EBA.</p>'),
'',
unistr('<p>\82E5\8981\77AD\89E3\8A73\7D30\8CC7\8A0A, \8ACB\53C3\95B1 <em>Oracle Application Express End User''s Guide</em> \4E2D\7684 "Using Interactive Grids".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116091737778403026)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\89BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116089723548403025)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\81EA\8A02\4E92\52D5\5F0F\65B9\683C, \8B93\5176\904B\7528\5167\5EFA\7684\529F\80FD, \4EE5\5404\7A2E\4E0D\540C\65B9\5F0F\986F\793A\8CC7\6599.</p>'),
'',
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\300C\8CC7\6599\6B04\6A19\984C\300D\529F\80FD\8868\6216\300C\52D5\4F5C\300D\529F\80FD\8868\4F86\6C7A\5B9A\8981\986F\793A\7684\8CC7\6599\6B04\3001\986F\793A\9806\5E8F\4EE5\53CA\51CD\7D50\8CC7\6599\6B04. \60A8\4E5F\53EF\4EE5\5B9A\7FA9\5404\7A2E\50B3\56DE\8CC7\6599\7684\8CC7\6599\7BE9\9078\548C\6392\5E8F.</p>'),
'',
unistr('<p>\4F7F\7528\300C\6AA2\8996\300D\6309\9215 (\5728\300C\641C\5C0B\300D\6B04\4F4D\65C1\908A) \5373\53EF\5B58\53D6\61C9\7528\7A0B\5F0F\958B\767C\4EBA\54E1\5DF2\7D93\5B9A\7FA9\7684\5176\4ED6\8CC7\6599\6AA2\8996. \60A8\4E5F\53EF\4EE5\5EFA\7ACB\5716\8868\6216\6AA2\8996\73FE\6709\5716\8868.</p>  '),
'',
unistr('<p><em>\6CE8\610F: \6309\4E00\4E0B\4E92\52D5\5F0F\65B9\683C\5C0D\8A71\65B9\584A\4E2D\7684<strong>\8AAA\660E</strong>, \5373\53EF\53D6\5F97\6240\9078\51FD\6578\7684\8A73\7D30\8CC7\8A0A.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116091802958403027)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116041515655402989)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\65B9\683C\8AAA\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116088608064403024)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\6B64\5C0D\8A71\65B9\584A\4F86\805A\7E3D\8CC7\6599\6B04. \805A\7E3D\7684\503C\6703\986F\793A\5728\8CC7\6599\7684\5E95\7AEF, \82E5\5B9A\7FA9\300C\63A7\5236\5206\6BB5\300D\7684\8A71, \5247\986F\793A\5728\6BCF\500B\5206\9694\7684\5E95\7AEF.</p>'),
'',
unistr('<p><strong>\805A\7E3D\6E05\55AE</strong><br>'),
unistr('\300C\805A\7E3D\300D\6E05\55AE\6703\986F\793A\5DF2\5B9A\7FA9\7684\805A\7E3D. \82E5\8981\505C\7528\73FE\6709\7684\805A\7E3D, \53EA\8981\5C07\5B83\53D6\6D88\9078\53D6.<br>'),
unistr('\6309\4E00\4E0B\300C\65B0\589E\300D( &plus; ) \5373\53EF\5EFA\7ACB\65B0\805A\7E3D, \6309\4E00\4E0B\300C\522A\9664\300D( &minus; ) \5373\53EF\79FB\9664\73FE\6709\805A\7E3D.</p>'),
'',
unistr('<p><strong>\805A\7E3D\8A2D\5B9A\503C</strong><br>'),
unistr('\8ACB\4F7F\7528\53F3\5074\7684\8868\55AE\4F86\5B9A\7FA9\805A\7E3D.<br>'),
unistr('\9078\53D6\8CC7\6599\6B04\540D\7A31\548C\805A\7E3D\985E\578B.<br>'),
unistr('(\9078\64C7\6027) \8F38\5165\805A\7E3D\7684\5DE5\5177\63D0\793A.<br>'),
unistr('\82E5\60A8\5DF2\5B9A\7FA9\300C\63A7\5236\5206\6BB5\300D, \9078\53D6<strong>\986F\793A\6574\9AD4\503C</strong>\6642\6703\5728\8CC7\6599\7684\5E95\7AEF\986F\793A\6574\9AD4\5E73\5747\503C\3001\7E3D\8A08\6216\985E\4F3C\7684\503C.</p>'),
'',
unistr('<p><em>\6CE8\610F: \82E5\8981\5B58\53D6\300C\805A\7E3D\300D\5C0D\8A71\65B9\584A, \60A8\53EF\4EE5\4F7F\7528\300C\52D5\4F5C\300D\529F\80FD\8868\6216\6309\4E00\4E0B\8CC7\6599\6B04\6A19\984C\548C\7E3D\548C ( &sum; ).</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116090860271403026)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\805A\7E3D\8AAA\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116089345124403025)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\5728\6B64\5C0D\8A71\65B9\584A\4E2D\5B9A\7FA9\986F\793A\70BA\500B\5225\8CC7\6599\6AA2\8996\7684\5716\8868.<br>'),
unistr('\9700\9078\53D6\5716\8868\985E\578B\548C\5716\8868\5C6C\6027.</p>'),
unistr('<p><strong>\5716\8868\5C6C\6027</strong></br>'),
unistr('\53EF\7528\7684\5716\8868\5C6C\6027\53D6\6C7A\65BC\5716\8868\985E\578B.</p>'),
'<p>',
'<ul>',
unistr('  <li>\9078\53D6\5305\542B\5C6C\6027\503C\7684\8CC7\6599\6B04:'),
'    <ul>',
unistr('      <li>\6A19\7C64 - \6BCF\500B\8CC7\6599\9EDE\7684\6587\5B57.</li>'),
unistr('      <li>\503C - \8981\7E6A\88FD\7684\8CC7\6599.</li>'),
unistr('      <li>\6578\5217 - \7528\65BC\5B9A\7FA9\591A\6578\5217\52D5\614B\67E5\8A62.</li>'),
unistr('      <li>\958B\76E4\50F9 - \6BCF\65E5\80A1\7968\958B\76E4\50F9 (\50C5\9650\80A1\7968\5206\6790\5716).</li>'),
unistr('      <li>\6536\76E4\50F9 - \6BCF\65E5\80A1\7968\6536\76E4\50F9 (\50C5\9650\80A1\7968\5206\6790\5716).</li>'),
unistr('      <li>\9AD8 - \9AD8\503C (\50C5\9650\7BC4\570D\5716\548C\80A1\7968\5206\6790\5716).</li>'),
unistr('      <li>\4F4E - \4F4E\503C (\50C5\9650\7BC4\570D\5716\548C\80A1\7968\5206\6790\5716).</li>'),
unistr('      <li>\6210\4EA4\91CF - \6BCF\65E5\80A1\7968\6210\4EA4\91CF (\50C5\9650\80A1\7968\5206\6790\5716).</li>'),
unistr('      <li>\76EE\6A19 - \76EE\6A19\503C (\50C5\9650\6F0F\6597\5716).</li>'),
unistr('      <li>X - X \8EF8\503C (\50C5\9650\6CE1\6CE1\5716\548C\6563\5E03\5716).</li>'),
unistr('      <li>Y - Y \8EF8\503C (\50C5\9650\6CE1\6CE1\5716\548C\6563\5E03\5716).</li>'),
unistr('      <li>Z - \9577\689D\5BEC\5EA6\6216\6CE1\6CE1\534A\5F91 (\50C5\9650\9577\689D\5716\3001\6CE1\6CE1\5716\4EE5\53CA\7BC4\570D\5716).</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\65B9\5411 - \5782\76F4\6216\6C34\5E73.</li>'),
unistr('  <li>\805A\7E3D - \9078\53D6\5716\8868\503C\7684\805A\7E3D\65B9\5F0F.</li>'),
unistr('  <li>\5806\758A - \6307\5B9A\662F\5426\5806\758A\8CC7\6599\9805\76EE.</li>'),
unistr('  <li>\6392\5E8F\65B9\5F0F - \4F9D\6A19\7C64\6216\503C\6392\5E8F.'),
'    <ul>',
unistr('      <li>\65B9\5411 - \4F9D\905E\589E\6216\905E\6E1B\65B9\5F0F\6392\5E8F\503C.</li>'),
unistr('      <li>\7A7A\503C - \6307\5B9A\76F8\8F03\65BC\975E\7A7A\503C\7684\8A18\9304, \61C9\5982\4F55\6392\5E8F\5305\542B\7A7A\503C\7684\8A18\9304.</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\5C0F\6578\4F4D\6578</li>'),
unistr('  <li>\6A19\7C64\8EF8\6A19\984C</li>'),
unistr('  <li>\503C\8EF8\6A19\984C</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116091296176403026)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868\8AAA\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116088377771403024)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\5728\6B64\5C0D\8A71\65B9\584A\4E2D\9078\64C7\986F\793A\7684\8CC7\6599\6B04\548C\986F\793A\9806\5E8F.</p>'),
'',
unistr('<p>\82E5\8981\96B1\85CF\8CC7\6599\6B04, \53EA\8981\5C07\5B83\53D6\6D88\9078\53D6.<br>'),
unistr('\82E5\8981\91CD\65B0\6392\5217\8CC7\6599\6B04, \8ACB\6309\4E00\4E0B\300C\4E0A\79FB\300D( &uarr; ) \6216\300C\4E0B\79FB\300D( &darr; ).<br>'),
unistr('\4F7F\7528\4E0B\62C9\5F0F\9078\53D6\5668\5373\53EF\5217\51FA\6240\6709\8CC7\6599\6B04\3001\986F\793A\7684\8CC7\6599\6B04\6216\672A\986F\793A\7684\8CC7\6599\6B04.</p>'),
'',
unistr('<p>(\9078\64C7\6027) \53EF\4F7F\7528\8868\55AE\6307\5B9A\8CC7\6599\6B04\7684\6700\5C0F\5BEC\5EA6 (\50CF\7D20).</p>'),
'',
unistr('<p><em>\6CE8\610F: \60A8\4E5F\53EF\4EE5\6309\4E00\4E0B\62D6\66F3\63A7\9EDE (\4F4D\65BC\8CC7\6599\6B04\6A19\984C\7684\958B\982D) \4E26\5C07\8CC7\6599\6B04\5411\5DE6\6216\5411\53F3\62D6\66F3, \4EE5\91CD\65B0\6392\5217\986F\793A\7684\8CC7\6599\6B04. \60A8\4E5F\53EF\4EE5\9078\53D6\8CC7\6599\6B04\5340\9694\7B26\865F (\5728\6A19\984C\4E4B\9593), \7136\5F8C\5C07\5176\5411\5DE6\6216\5411\53F3\79FB\52D5, \4EE5\8B8A\66F4\986F\793A\4E4B\8CC7\6599\6B04\7684\5BEC\5EA6.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116091190278403026)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\8AAA\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116088725076403024)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\6B64\5C0D\8A71\65B9\584A, \4F9D\64DA\5C0D\73FE\6709\8CC7\6599\6B04\57F7\884C\7684\7B97\8853\548C\51FD\6578\904B\7B97, \5B9A\7FA9\5176\4ED6\8CC7\6599\6B04.</p>'),
'',
unistr('<p><strong>\904B\7B97\6E05\55AE</strong><br>'),
unistr('\300C\904B\7B97\300D\6E05\55AE\6703\986F\793A\5DF2\5B9A\7FA9\7684\904B\7B97. \82E5\8981\505C\7528\73FE\6709\7684\904B\7B97, \53EA\8981\5C07\5B83\53D6\6D88\9078\53D6.<br>'),
unistr('\6309\4E00\4E0B\300C\65B0\589E\300D( &plus; ) \5373\53EF\65B0\589E\904B\7B97, \6309\4E00\4E0B\300C\522A\9664\300D( &minus; ) \5373\53EF\79FB\9664\73FE\6709\904B\7B97.</p>'),
'',
unistr('<p><strong>\904B\7B97\8A2D\5B9A\503C</strong><br>'),
unistr('\8ACB\4F7F\7528\6B64\8868\55AE\5B9A\7FA9\904B\7B97.<br>'),
unistr('\8F38\5165\8CC7\6599\6B04\8A73\7D30\8CC7\8A0A, \4F8B\5982\6A19\984C\3001\6A19\7C64, \4E26\9078\53D6\5C0D\9F4A\65B9\5F0F\8A2D\5B9A\503C.<br> '),
unistr('\5728\300C\8868\793A\5F0F\300D\6587\5B57\5340\4E2D\8F38\5165\904B\7B97\7684\8CC7\6599\6B04\548C\95DC\806F\7684\51FD\6578.<br>'),
unistr('\70BA\65B0\8CC7\6599\6B04\9078\53D6\9069\7576\7684\8CC7\6599\985E\578B\548C\683C\5F0F\906E\7F69 (\6B64\70BA\9078\64C7\6027).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116090790786403026)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97\8AAA\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116089000778403024)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\5728\6B64\5C0D\8A71\65B9\584A\4E2D\5B9A\7FA9\4E00\6216\591A\500B\8CC7\6599\6B04\7684\63A7\5236\5206\6BB5.</p>'),
'',
unistr('<p><strong>\63A7\5236\5206\6BB5\6E05\55AE</strong><br>'),
unistr('\300C\63A7\5236\5206\6BB5\300D\6E05\55AE\6703\986F\793A\5DF2\5B9A\7FA9\7684\63A7\5236\5206\6BB5. \82E5\8981\505C\7528\73FE\6709\7684\63A7\5236\5206\6BB5\8CC7\6599\6B04, \53EA\8981\5C07\5B83\53D6\6D88\9078\53D6.<br>'),
unistr('\6309\4E00\4E0B\300C\65B0\589E\300D( &plus; ) \5373\53EF\5728\63A7\5236\5206\6BB5\4E2D\5305\542B\65B0\8CC7\6599\6B04, \6309\4E00\4E0B\300C\522A\9664\300D( &minus; ) \5373\53EF\79FB\9664\63A7\5236\5206\6BB5\4E2D\7684\73FE\6709\8CC7\6599\6B04.<br>'),
unistr('\82E5\8981\91CD\65B0\6392\5217\8CC7\6599\6B04, \8ACB\6309\4E00\4E0B\300C\4E0A\79FB\300D( &uarr; ) \6216\300C\4E0B\79FB\300D( &darr; ), \5C07\9078\53D6\7684\8CC7\6599\6B04\79FB\52D5\81F3\5176\4ED6\8CC7\6599\6B04\7684\4E0A\65B9\6216\4E0B\65B9.</p>'),
'',
unistr('<p><strong>\63A7\5236\5206\6BB5\8A2D\5B9A\503C</strong><br>'),
unistr('\8ACB\4F7F\7528\6B64\8868\55AE\5B9A\7FA9\63A7\5236\5206\6BB5\8CC7\6599\6B04.<br>'),
unistr('\9078\53D6\4E00\500B\63A7\5236\5206\6BB5\8CC7\6599\6B04\3001\6392\5E8F\65B9\5411\4EE5\53CA\7A7A\503C\8CC7\6599\6B04 (\4E0D\542B\503C\7684\8CC7\6599\6B04) \7684\6392\5217\65B9\5F0F.</p>'),
'',
unistr('<p><em>\6CE8\610F: \82E5\662F\6AA2\8996\4E92\52D5\5F0F\65B9\683C, \60A8\53EF\4EE5\6309\4E00\4E0B\300C\8CC7\6599\6B04\6A19\984C\300D\4E26\9078\53D6\63A7\5236\5206\6BB5\5716\793A\4F86\5B9A\7FA9\63A7\5236\5206\6BB5.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116090468567403026)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63A7\5236\5206\6BB5\8AAA\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116089234328403025)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\6B64\5C0D\8A71\65B9\584A\5C07\6240\6709\76EE\524D\7684\8CC7\6599\5217\4E0B\8F09\81F3\5916\90E8\6A94\6848. \6B64\6A94\6848\5C07\53EA\6703\5305\542B\76EE\524D\986F\793A\7684\8CC7\6599\6B04 (\5728\8CC7\6599\5957\7528\4EFB\4F55\7BE9\9078\548C\6392\5E8F\6240\5F97\7684\8CC7\6599\6B04).</p>'),
'',
unistr('<p>\8ACB\9078\53D6\6A94\6848\683C\5F0F, \7136\5F8C\6309\4E00\4E0B\300C\4E0B\8F09\300D.<br>'),
unistr('\6CE8\610F: CSV \5C07\4E0D\6703\5305\62EC\50CF\805A\7E3D\548C\63A7\5236\5206\6BB5\7684\6587\5B57\683C\5F0F.</p>'),
'',
unistr('<p>\82E5\8981\4EE5\96FB\5B50\90F5\4EF6\50B3\9001\6A94\6848, \8ACB\9078\53D6\300C\4EE5\96FB\5B50\90F5\4EF6\50B3\9001\300D, \4E26\8F38\5165\96FB\5B50\90F5\4EF6\8A73\7D30\8CC7\8A0A (\6536\4EF6\8005\3001\4E3B\65E8\548C\8A0A\606F).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116090218230403025)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09\8AAA\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116088459645403024)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\5728\6B64\5C0D\8A71\65B9\584A\4E2D\8A2D\5B9A\9650\5236\50B3\56DE\4E4B\8CC7\6599\5217\7684\8CC7\6599\7BE9\9078\689D\4EF6.</p>'),
'',
unistr('<p><strong>\7BE9\9078\6E05\55AE</strong><br>'),
unistr('\300C\7BE9\9078\300D\6E05\55AE\6703\986F\793A\5B9A\7FA9\7684\7BE9\9078\689D\4EF6. \82E5\8981\505C\7528\73FE\6709\7684\7BE9\9078, \53EA\8981\5C07\5B83\53D6\6D88\9078\53D6.<br>'),
unistr('\6309\4E00\4E0B\300C\65B0\589E\300D( &plus; ) \5373\53EF\5EFA\7ACB\65B0\7BE9\9078, \6309\4E00\4E0B\300C\522A\9664\300D( &minus; ) \5373\53EF\79FB\9664\73FE\6709\7BE9\9078.</p>'),
'',
unistr('<p><strong>\7BE9\9078\8A2D\5B9A\503C</strong><br>'),
unistr('\60A8\53EF\4EE5\4F7F\7528\6B64\8868\55AE\5B9A\7FA9\7BE9\9078\7279\6027.<br>'),
unistr('\9078\53D6\9069\7576\7684\7BE9\9078\985E\578B:<br>'),
unistr('&nbsp;&nbsp;&nbsp;\8CC7\6599\5217 - \53EF\7BE9\9078\4EFB\4F55\53EF\7BE9\9078\8CC7\6599\6B04\4E2D\7684\8A5E\5F59.<br>'),
unistr('&nbsp;&nbsp;&nbsp;\8CC7\6599\6B04 - \53EF\4F7F\7528\6307\5B9A\7684\904B\7B97\5B50\548C\503C\7BE9\9078\7279\5B9A\8CC7\6599\6B04.</p>'),
'',
unistr('<p><em>\6CE8\610F: \82E5\662F\6AA2\8996\4E92\52D5\5F0F\65B9\683C, \60A8\53EF\4EE5\76F4\63A5\5728\300C\641C\5C0B\300D\6B04\4F4D\4E2D\8F38\5165\4EE5\5B9A\7FA9\8CC7\6599\5217\7BE9\9078\689D\4EF6. \6309\4E00\4E0B\300C\9078\53D6\8981\641C\5C0B\7684\8CC7\6599\6B04\300D\5373\53EF\5C07\641C\5C0B\7BC4\570D\9650\65BC\7279\5B9A\8CC7\6599\6B04. \6216\8005, \53EF\958B\555F\300C\8CC7\6599\6B04\6A19\984C\300D\529F\80FD\8868\4E26\9078\53D6\4E00\500B\503C, \4EE5\5EFA\7ACB\8CC7\6599\6B04\7BE9\9078.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116091078896403026)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078\8AAA\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116088885600403024)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\5728\6B64\5C0D\8A71\65B9\584A\4E2D\6AA2\8996\904E\53BB\6642\9593\9EDE\7684\8CC7\6599.</p>'),
unistr('<p>\8ACB\8F38\5165\904E\53BB\7684\5206\9418\6578\4EE5\57F7\884C\5012\6EAF\67E5\8A62.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116090625127403026)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5012\6EAF\8AAA\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116091306537403026)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44\4F9D\64DA\8AAA\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116088963655403024)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\6B64\5C0D\8A71\65B9\584A, \4F9D\64DA\8F38\5165\7684\689D\4EF6, \6A19\793A\8CC7\6599\7684\8CC7\6599\5217\6216\8CC7\6599\6B04.</p>'),
'',
unistr('<p><strong>\6A19\793A\6E05\55AE</strong><br>'),
unistr('\300C\6A19\793A\300D\6E05\55AE\6703\986F\793A\5DF2\5B9A\7FA9\7684\6A19\793A\9805\76EE. \82E5\8981\505C\7528\73FE\6709\7684\6A19\793A, \53EA\8981\5C07\5B83\53D6\6D88\9078\53D6.<br>'),
unistr('\6309\4E00\4E0B\300C\65B0\589E\300D( &plus; ) \5373\53EF\5EFA\7ACB\65B0\6A19\793A, \6309\4E00\4E0B\300C\522A\9664\300D( &minus; ) \5373\53EF\79FB\9664\73FE\6709\6A19\793A.</p>'),
'',
unistr('<p><strong>\6A19\793A\8A2D\5B9A\503C</strong><br>'),
unistr('\8ACB\4F7F\7528\6B64\8868\55AE\5B9A\7FA9\6A19\793A\7279\6027.<br>'),
unistr('\8F38\5165\540D\7A31\3001\9078\53D6\300C\8CC7\6599\5217\300D\6216\300C\8CC7\6599\6B04\300D, \7136\5F8C\9078\53D6\80CC\666F\548C\6587\5B57\7684 HTML \8272\5F69\4EE3\78BC.<br>'),
unistr('\9078\53D6\9069\7576\7684<strong>\689D\4EF6\985E\578B</strong>\4EE5\6A19\793A\7279\5B9A\8CC7\6599:<br>'),
unistr('&nbsp;&nbsp;&nbsp;\8CC7\6599\5217 - \6A19\793A\4EFB\4E00\8CC7\6599\6B04\4E2D\7684\8A5E\5F59.<br>'),
unistr('&nbsp;&nbsp;&nbsp;\8CC7\6599\6B04 - \4F9D\64DA\6307\5B9A\7684\904B\7B97\5B50\548C\503C, \6A19\793A\7279\5B9A\7684\8CC7\6599\6B04.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116090580355403026)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\793A\8AAA\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116089155310403025)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\5728\6B64\5C0D\8A71\65B9\584A\4E2D\5132\5B58\60A8\5C0D\76EE\524D\7684\65B9\683C\7248\9762\914D\7F6E\548C\7D44\614B\6240\505A\7684\8B8A\66F4.<br>'),
unistr('\61C9\7528\7A0B\5F0F\958B\767C\4EBA\54E1\53EF\4EE5\5B9A\7FA9\591A\500B\66FF\4EE3\7684\5831\8868\7248\9762\914D\7F6E. \82E5\60C5\6CC1\5141\8A31, \60A8\548C\5176\4ED6\4E00\822C\4F7F\7528\8005\90FD\53EF\4EE5\5C07\5831\8868\53E6\5B58\70BA\300C\516C\7528\300D, \8B93\5831\8868\53EF\4F9B\65B9\683C\7684\5176\4ED6\6240\6709\4F7F\7528\8005\4F7F\7528. \60A8\4E5F\53EF\4EE5\5C07\5831\8868\53E6\5B58\70BA\53EA\6709\60A8\80FD\5920\6AA2\8996\7684\300C\5C08\7528\300D\5831\8868.</p>'),
unistr('<p>\8ACB\5F9E\53EF\7528\7684\985E\578B\4E2D\9078\53D6, \7136\5F8C\8F38\5165\9810\5B58\5831\8868\7684\540D\7A31.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116090340557403025)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5831\8868\8AAA\660E'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116088528316403024)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\5728\6B64\5C0D\8A71\65B9\584A\4E2D\8A2D\5B9A\986F\793A\9806\5E8F.</p>'),
'',
unistr('<p><strong>\6392\5E8F\6E05\55AE</strong><br>'),
unistr('\300C\6392\5E8F\300D\5C0D\8A71\65B9\584A\6703\986F\793A\5DF2\8A2D\5B9A\7684\6392\5E8F\898F\5247\6E05\55AE.<br>'),
unistr('\6309\4E00\4E0B\300C\65B0\589E\300D( &plus; ) \5373\53EF\5EFA\7ACB\6392\5E8F\8CC7\6599\6B04, \6309\4E00\4E0B\300C\522A\9664\300D( &minus; ) \5373\53EF\79FB\9664\6392\5E8F\8CC7\6599\6B04.<br>'),
unistr('\6309\4E00\4E0B\300C\4E0A\79FB\300D( &uarr; ) \548C\300C\4E0B\79FB\300D( &darr; ) \5373\53EF\5C07\9078\53D6\7684\6392\5E8F\8CC7\6599\6B04\79FB\5230\5176\4ED6\6392\5E8F\8CC7\6599\6B04\7684\4E0A\65B9\6216\4E0B\65B9.</p>'),
'',
unistr('<p><strong>\6392\5E8F\8A2D\5B9A\503C</strong><br>'),
unistr('\8ACB\9078\53D6\4E00\500B\6392\5E8F\8CC7\6599\6B04\3001\6392\5E8F\65B9\5411\4EE5\53CA\7A7A\503C\8CC7\6599\6B04 (\4E0D\542B\503C\7684\8CC7\6599\6B04) \7684\6392\5217\65B9\5F0F.</p>'),
'',
unistr('<p><em>\6CE8\610F: \8CC7\6599\53EF\4EE5\4F9D\7167\672A\986F\793A\7684\8CC7\6599\6B04\6392\5E8F; \4F46\662F\4E26\975E\6240\6709\8CC7\6599\6B04\90FD\53EF\4EE5\6392\5E8F.</em><br>'),
unistr('<em>\6309\8CC7\6599\6B04\6A19\984C\672B\7AEF\7684\5411\4E0A (\905E\589E) \6216\5411\4E0B (\905E\6E1B) \7BAD\865F, \5373\53EF\6392\5E8F\986F\793A\7684\8CC7\6599\6B04. \82E5\8981\5C07\5F8C\7E8C\7684\8CC7\6599\6B04\52A0\5230\73FE\6709\6392\5E8F, \8ACB\6309\4F4F Shift \9375, \7136\5F8C\6309\4E00\4E0B\5411\4E0A\6216\5411\4E0B\7BAD\865F.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116090999647403026)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5E8F\8AAA\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116090171542403025)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1\8AAA\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116042430100402990)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116009244869402965)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116077211231403015)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\9AD8\50F9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116078032183403016)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C34\5E73')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116035428751402984)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\6642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116040415623402988)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116008112486402964)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A\6AA2\8996')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116033680329402983)
,p_name=>'APEX.IG.IN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116042071254402989)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975E\4F5C\7528\4E2D\8A2D\5B9A\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116042120132402989)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975E\4F5C\7528\4E2D\8A2D\5B9A\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116049711966402995)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\300C\4E92\52D5\5F0F\65B9\683C\300D\8981\6C42\6642\767C\751F\5167\90E8\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115945524515402918)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04 "%1" \4E0D\652F\63F4\8CC7\6599\6B04\7BE9\9078\985E\578B "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116089939275403025)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\65E5\671F\683C\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116064116224403006)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\65B9\683C\4E0D\652F\63F4\5B9A\7FA9 %0 \8CC7\6599\6B04\7BE9\9078.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116064078754403006)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\662F\53EF\4F9B\5B9A\7FA9\4E92\52D5\5F0F\65B9\683C\7BE9\9078\7684\6709\6548\7BE9\9078\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115950669480402921)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6578\5B57\683C\5F0F\7121\6548')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116092661011403027)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\8A2D\5B9A\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116092745404403027)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\8A2D\5B9A\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116083753468403020)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\6392\5E8F\65B9\5F0F\300D\8A2D\70BA %0, \4F46\5C1A\672A\9078\53D6\7528\65BC %0 \7684\8CC7\6599\6B04.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116081017374403018)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\7121\6548')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116076144043403015)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\986F\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116034410448402984)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116034687702402984)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5F8C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116033510286402983)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\662F\7A7A\7684')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116033469307402983)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F\7A7A\7684')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116084519531403021)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116076564230403015)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116080401666403018)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5F8C\4E00\500B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116023796420402976)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D 1 \5929')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116023986269402976)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D 1 \5C0F\6642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116024495470402976)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D 1 \5206\9418')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116023402660402975)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D 1 \500B\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116023561899402975)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D 1 \9031')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116023636952402976)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D %0 \5929')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116023813486402976)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D %0 \5C0F\6642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116024541104402976)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D %0 \5206\9418')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116024307289402976)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D %0 \500B\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116024203003402976)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D %0 \9031')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116023288381402975)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D %0 \5E74')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116023372300402975)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D 1 \5E74')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116084733462403021)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\9F4A\5132\5B58\683C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116084817010403021)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\7FA4\7D44 - ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116034098314402983)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\65BC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116034154900402983)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\65BC\6216\7B49\65BC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116078618345403016)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6298\7DDA\5716')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116078710142403016)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6298\7DDA\5340\57DF\5716')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116085136454403021)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'zh-tw'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116077336117403015)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\4F4E\50F9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116087720796403023)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\4F7F\7528\9017\865F\5340\9694\591A\500B\5730\5740')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116035248787402984)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B26\5408\6B63\898F\8868\793A\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116059660579403002)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5927\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116095256512403029)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6574\9AD4\6700\5927\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116059886077403002)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\9593\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116095378508403029)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6574\9AD4\4E2D\9593\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116059579879403002)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5C0F\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116035369739402984)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\9418')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116060306752403003)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\9418\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116095112719403029)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6574\9AD4\6700\5C0F\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116035706896402985)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\500B\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116042341076402989)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5305\542B\7684\8CC7\6599\5217\7B46\6578\8D85\904E %0, \9019\5DF2\8D85\904E\5141\8A31\7684\4E0A\9650. \8ACB\5957\7528\5176\4ED6\7BE9\9078\4EE5\6AA2\8996\7D50\679C.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116069030272403009)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5305\542B\591A\500B\4E92\52D5\5F0F\65B9\683C, \56E0\6B64\5FC5\9808\6307\5B9A\5340\57DF\975C\614B ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116038472368402987)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116038664092402987)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5177\540D\7684\5831\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116022607016402975)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C 1 \5929')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116022437315402975)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C 1 \5C0F\6642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116024653453402976)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C 1 \5206\9418')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116022944975402975)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C 1 \500B\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116022818491402975)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C 1 \9031')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116022705668402975)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C %0 \5929')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116022520305402975)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C %0 \5C0F\6642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116024783968402976)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C %0 \5206\9418')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116024060244402976)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C %0 \500B\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116024168373402976)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C %0 \9031')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116023180230402975)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C %0 \5E74')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116023046278402975)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C 1 \5E74')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116034346585402983)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\4ECB\65BC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116033346539402983)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\7B49\65BC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116099564026403032)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ID \70BA %0 \7684\5340\57DF\4E0D\662F\300C\4E92\52D5\5F0F\65B9\683C\300D\5340\57DF, \6216\8005\4E0D\5B58\5728\65BC\61C9\7528\7A0B\5F0F %1 \4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116033735772402983)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5728')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116034545042402984)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5728\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116034703484402984)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5728\5F8C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116042220952402989)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\8CC7\6599')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116080266060403018)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116085313134403021)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6578\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116080544848403018)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116080629132403018)
,p_name=>'APEX.IG.ON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\555F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116032554967402982)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('1 \5206\9418\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116088231561403024)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\555F\8272\5F69\9078\64C7\5668: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116077084533403015)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\76E4\50F9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116039509835402987)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97\5B50')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116076467106403015)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\5411')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116078850521403017)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\9905\5716')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116040837613402988)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A1E\7D10\5206\6790\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116008492028402964)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A1E\7D10\5206\6790\8868\6AA2\8996')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116088128933403024)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528 "%0" \5340\9694\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116078924185403017)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6975\5EA7\6A19\5716')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116084215141403021)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\9593')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116084366480403021)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\5C3E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116084121332403021)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\982D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116038710472402987)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116039021155402987)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\9810\8A2D\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116055533864402999)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\5831\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115937797916402912)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\62EC\8F14\52A9\529F\80FD\6A19\8A18')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115936411437402911)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A6B\5370')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115936593502402911)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F4\5370')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115936393946402911)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\65B9\5411')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115936201868402911)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'zh-tw'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115936151383402911)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'zh-tw'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115937883747402912)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115935932714402911)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115935802626402911)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115936028976402911)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'zh-tw'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115935793748402911)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5927\5C0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115925967686402904)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664 Rich Text \683C\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116079070829403017)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96F7\9054\5716')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116079190260403017)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\570D\5716')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116089401224403025)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6574\7406')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116043070621402990)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6574\7406\8CC7\6599\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116041899225402989)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6574\7406\8CC7\6599\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116047037905402993)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F %0\3001\9801\9762 %1 \8207\5340\57DF %2 \4E2D\4E0D\5B58\5728\300C\4E92\52D5\5F0F\65B9\683C\300D\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116009996758402965)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116038158275402986)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116098709655403032)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\522A\9664\5831\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116098412788403032)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\70BA\6240\6709\4F7F\7528\8005\5132\5B58\66FF\4EE3\5831\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116098392628403032)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\70BA\6240\6709\4F7F\7528\8005\5132\5B58\9810\8A2D\5831\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116098603647403032)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5132\5B58\5C08\7528\5831\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116098586028403032)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\70BA\6240\6709\4F7F\7528\8005\5132\5B58\516C\7528\5831\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116047122513402993)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31\70BA %0 \7684\300C\9810\5B58\4E92\52D5\5F0F\65B9\683C\300D\4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116032426969402982)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5206\9418\524D\7684\5831\8868\8CC7\6599')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116032312549402982)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('1 \5206\9418\524D\7684\5831\8868\8CC7\6599')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115972038580402937)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\65B9\683C\5831\8868\4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116091684325403026)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868 - \7DE8\8F2F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116046990662402993)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ID \70BA %0 \7684\300C\9810\5B58\4E92\52D5\5F0F\65B9\683C\300D\4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116091538738403026)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868 - \53E6\5B58\65B0\6A94')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116010062773402965)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\8A2D\5B9A\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116099607801403033)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975C\614B ID \70BA %0 \7684\300C\9810\5B58\4E92\52D5\5F0F\65B9\683C\300D\4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116094555299403029)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\6AA2\8996')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116009116834402964)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116043129273402990)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56DE\5FA9\8B8A\66F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116041998342402989)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56DE\5FA9\8CC7\6599\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116039107009402987)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116038016193402986)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\9801\8CC7\6599\5217\6578')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116099294573403032)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\52D5\4F5C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116100400585403033)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217 %0 \7684\52D5\4F5C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116009497120402965)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116052106942402997)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5132\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116007616705402963)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\5B58\5831\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116007720881402963)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115982274394402944)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31\70BA %0 \7684\9810\5B58\5831\8868\5DF2\7D93\5B58\5728. \8ACB\8F38\5165\65B0\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116007826930402963)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C08\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116007902788402964)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116094244283403028)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53E6\5B58\65B0\6A94')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116041255544402989)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\5831\8868\8A2D\5B9A\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116079247412403017)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6563\5E03\5716')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116007563794402963)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116086581862403022)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B: \6240\6709\6587\5B57\8CC7\6599\6B04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116007413628402963)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116085717210403022)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B: \5168\6587')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116032276445402982)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B ''%0''')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116075849979403014)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \9078\53D6 -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116016097481402970)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\9805\76EE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116068759486403009)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\4E3B\8981\5340\57DF\4E2D\7684 1 \500B\8CC7\6599\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116007307507402963)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\641C\5C0B\7684\8CC7\6599\6B04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116098960230403032)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\52D5\4F5C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116016288065402970)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5132\5B58\683C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116016191195402970)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8CC7\6599\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116087110668403023)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EE5\96FB\5B50\90F5\4EF6\50B3\9001')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116079639006403017)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6578\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116005326363402962)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116057934893403001)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\6574\9AD4\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116042779293402990)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\55AE\4E00\8CC7\6599\5217\6AA2\8996')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116041024130402988)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5E8F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116079700777403017)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5E8F\65B9\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116099311587403032)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\500B\8CC7\6599\6B04\53EA\80FD\5B9A\7FA9\4E00\7A2E\6392\5E8F\65B9\5F0F.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116099135029403032)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B8A\66F4\529F\80FD\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116080764747403018)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5806\758A\5716')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116035016513402984)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\982D\70BA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116079394702403017)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\80A1\7968\5206\6790\5716')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116000387039402958)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EF6\4F38\8CC7\6599\6B04\5BEC\5EA6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116041425266402989)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116059488078403002)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\548C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116100698948403033)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\65B9\683C. \5831\8868: %0, \8996\89C0\8868: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116094633394403029)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6574\9AD4\7E3D\548C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116077530400403016)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\6A19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116083968382403020)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\8272\5F69')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116010121091402965)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5207\63DB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116057889960403001)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\5177\63D0\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116038282312402986)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\578B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116042683473402990)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\89E3\9664\51CD\7D50')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116039712928402987)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\55AE\4F4D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116086901247403023)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6709\672A\5132\5B58\7684\8B8A\66F4. \8981\7E7C\7E8C\55CE?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116039672058402987)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116076694066403015)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116081529759403019)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165\503C.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116066444836403007)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C (\4E0D\80FD\8B8A\66F4\6642\5340)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116085496549403021)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116077967376403016)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5782\76F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116037729947402986)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116075955362403014)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116077480676403016)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\4EA4\91CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116035631044402984)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9031')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116076048773403015)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5C0F\8CC7\6599\6B04\5BEC\5EA6 (\50CF\7D20)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116026886076402978)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4ECB\65BC %1 \5230 %2 \4E4B\9593')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116026559921402978)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5305\542B %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116026668496402978)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \672A\5305\542B %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116004790900402961)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\662F\4EE5 %1 \70BA\958B\982D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116025312761402977)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \7B49\65BC %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116025571954402977)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5927\65BC %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116025699417402977)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5927\65BC\6216\7B49\65BC %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116026376378402978)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728 %1 \4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116027591918402978)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\524D %1 \5929\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116027355456402978)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\524D %1 \5C0F\6642\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116027109206402978)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\524D %1 \5206\9418')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116027941986402979)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\524D %1 \500B\6708\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116027766073402979)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\524D %1 \9031\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116028104524402979)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\524D %1 \5E74\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116027488465402978)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\524D 1 \5929\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116027251599402978)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\524D 1 \5C0F\6642\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116027074591402978)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\524D 1 \5206\9418')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116027858913402979)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\524D 1 \500B\6708\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116027656109402979)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\524D 1 \9031\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116028098217402979)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\524D 1 \5E74\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116029941493402980)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\5F8C %1 \5929\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116029751510402980)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\5F8C %1 \5C0F\6642\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116029576985402980)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\5F8C %1 \5206\9418')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116030304593402981)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\5F8C %1 \500B\6708\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116030182289402980)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\5F8C %1 \9031\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116030528650402981)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\5F8C %1 \5E74\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116029889267402980)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\5F8C 1 \5929\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116029636189402980)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\5F8C 1 \5C0F\6642\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116029476744402980)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\5F8C 1 \5206\9418')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116030291464402980)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\5F8C 1 \500B\6708\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116030098915402980)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\5F8C 1 \9031\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116030458575402981)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\5F8C 1 \5E74\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116026049039402977)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\662F\7A7A\7684')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116025968642402977)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \662F\7A7A\7684')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116025768194402977)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5C0F\65BC %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116025875390402977)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5C0F\65BC\6216\7B49\65BC %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116026190500402977)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \540C\65BC %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116026721581402978)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \7B26\5408\6B63\898F\8868\793A\5F0F %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116032684522402982)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5206\9418\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116026983424402978)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\4ECB\65BC %1 \5230 %2 \4E4B\9593')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116025448385402977)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\7B49\65BC %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116026403276402978)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728 %1 \4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116028709173402979)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\524D %1 \5929\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116028599869402979)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\524D %1 \5C0F\6642\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116028394104402979)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\524D %1 \5206\9418')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116029126550402980)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\524D %1 \500B\6708\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116028977408402979)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\524D %1 \9031\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116029302309402980)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\524D %1 \5E74\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116028645075402979)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\524D 1 \5929\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116028409286402979)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\524D 1 \5C0F\6642\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116028230523402979)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\524D 1 \5206\9418')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116029048711402980)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\524D 1 \500B\6708\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116028831138402979)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\524D 1 \9031\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116029287807402980)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\524D 1 \5E74\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116031100566402981)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\5F8C %1 \5929\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116030921590402981)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\5F8C %1 \5C0F\6642\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116030705987402981)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\5F8C %1 \5206\9418')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116031540927402981)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\5F8C %1 \500B\6708\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116031314110402981)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\5F8C %1 \9031\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116031724622402982)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\5F8C %1 \5E74\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116031014593402981)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\5F8C 1 \5929\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116030802896402981)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\5F8C 1 \5C0F\6642\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116030696593402981)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\5F8C 1 \5206\9418')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116031490761402981)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\5F8C 1 \500B\6708\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116031218985402981)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\5F8C 1 \9031\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116031620518402981)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\5F8C 1 \5E74\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116026246925402977)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\540C\65BC %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116033118925402983)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \958B\982D\70BA %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116076776258403015)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116035838015402985)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E74')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116076821288403015)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116076959284403015)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116085987530403022)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'zh-tw'
,p_message_text=>'Monday, 12 January, 2016'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116086036124403022)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'zh-tw'
,p_message_text=>'January'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116086131222403022)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('16 \5C0F\6642\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116086267902403022)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('16 \5C0F\6642\5167')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115941221085402915)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\985E\578B\7121\6548. \652F\63F4\7684\6A94\6848\985E\578B\70BA %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116068119588403009)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\700F\89BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116067827894403009)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\6A94\6848')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116067981888403009)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\6A94\6848')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115941085822402914)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62D6\653E\529F\80FD')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115941430705402915)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\62D6\653E\6A94\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115942684700402916)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\4E00\500B\6A94\6848\6216\5C07\4E00\500B\6A94\6848\653E\5230\6B64\8655.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115942732553402916)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6216\5C07\6A94\6848\653E\5230\6B64\8655.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115942840705402916)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\4E00\500B\6A94\6848\6216\5C07\4E00\500B\6A94\6848\653E\5230\6B64\8655.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115942923486402916)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\6216\5C07\6A94\6848\653E\5230\6B64\8655.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115941322537402915)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\6A94\6848')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115941183337402914)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\904E\5927. \6A94\6848\5927\5C0F\4E0A\9650\70BA %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115928967129402906)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165\5730\5740.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115927865680402905)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E23/\5E02')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115928223181402905)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\570B\78BC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115927961526402905)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F4F\5BB6\9580\724C\865F\78BC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115928840375402906)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DEF\5EA6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115928752869402906)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D93\5EA6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115928610540402906)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5730\5716\4E0A\986F\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115928310234402905)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\6578')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115928076270402905)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\90F5\905E\5340\865F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115928150780402905)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\72C0\614B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115927731820402905)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8DEF/\8857')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115927680295402905)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5730\7406\7DE8\78BC\7D50\679C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115940295781402914)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\9032\884C\5730\7406\7DE8\78BC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115940386029402914)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9032\884C\5730\7406\7DE8\78BC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115928597197402905)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5730\5716')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115928453580402905)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\5730\5740.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115929053438402906)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116098825659403032)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E\6587\5B57: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115992223656402952)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\52FE\9078')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115992321173402952)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\52FE\9078')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115938271040402912)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \4E0D\5728 %0 \5230 %1 \7684\6709\6548\7BC4\570D\5167.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115938332992402913)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \4E0D\662F %0 \7684\500D\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115937958735402912)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \5FC5\9808\7B26\5408\503C %0 \8207 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115938162092402912)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116016460042402970)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116016582341402970)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\555F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115938070384402912)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115921454123402900)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116050668297402996)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116050770724402996)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115921568033402901)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7684\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116054413677402998)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9032\968E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116054786341402999)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116054559326402999)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\822C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116054803284402999)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5373\6642\6A23\677F\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116055408386402999)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\5143\4EF6\4E26\672A\5728\9801\9762\4E2D\5448\73FE, \56E0\6B64\7121\6CD5\4F7F\7528\300C\6A23\677F\9078\9805\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116054374425402998)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\4EFB\4F55\300C\6A23\677F\9078\9805\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116054617647402999)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115929933614402906)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664\5713\5F62')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115931740738402908)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02\6A23\5F0F\4E0D\662F\6709\6548\7684 JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115930270135402907)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8DDD\96E2\5DE5\5177')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115930028126402907)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E6A\88FD\5713\5F62')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115922676473402901)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\591A\9762\5411\641C\5C0B\9700\6709\4E00\500B\5340\57DF\5C64\7D1A\7684\8CC7\6599\4F86\6E90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115925289105402903)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\4F4D\7F6E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115926354110402904)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D77\59CB\4F4D\7F6E\5EA7\6A19\7121\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115923771998402902)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8D77\59CB\4F4D\7F6E\5FC5\9808\662F\9EDE\5E7E\4F55.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115926131730402904)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\91CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115924757595402903)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\5C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116058085607403001)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\5C64: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115929327335402906)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0D\61C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115922596855402901)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A0A\606F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115926229968402904)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82F1\54E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116057050505403000)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5305\542B\7684\8CC7\6599\5217\7B46\6578\8D85\904E %0, \9019\5DF2\8D85\904E\5141\8A31\7684\4E0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115924570550402903)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">\689D\6B3E</a> &nbsp;&nbsp; \5730\5716\8CC7\6599 &copy; 2017 HERE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115923448283402902)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8CC7\6599\5EAB\4E2D\7121\6CD5\4F7F\7528 SDO_GEOMETRY \8CC7\6599\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115924631816402903)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; OpenStreetMap \63D0\4F9B\8005 </a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115924872563402903)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9EDE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116058168873403001)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\9EDE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115930101011402907)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\77E9\5F62\7E2E\653E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115929851628402906)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115925176474402903)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\65B9\4F4D\91CD\8A2D\70BA\5317\65B9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116005499715402962)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5207\63DB\70BA 2D \6A21\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116005510815402962)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5207\63DB\70BA 3D \6A21\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115929751752402906)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5207\63DB\8457\4F5C\6B0A\8072\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115930318084402907)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\8DDD\96E2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115924953356402903)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\653E\5927')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115925053427402903)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E2E\5C0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116052552702402997)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7C97\9AD4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116053437977402998)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F71\50CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116053071024402997)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\5D4C\7A0B\5F0F\78BC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116066633398403008)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D2\5165\5F71\50CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116066736508403008)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D2\5165\9023\7D50')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116052665450402997)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\659C\9AD4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116067317005403008)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9023\7D50')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116053332163402998)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116053299876402998)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\6392\5217\7684\6E05\55AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116052709672402997)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\89BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116052816490402997)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\53EF\9810\89BD\7684\5167\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116052916957402997)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\7DDA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116053162041402998)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6392\5217\7684\6E05\55AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116032096220402982)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116089593916403025)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116031972117402982)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116063743090403006)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\901A\77E5\8A0A\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116037089557402986)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \5FC5\9808\662F\5C0F\65BC\6216\7B49\65BC %0 \7684\6578\5B57.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116037142620402986)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \5FC5\9808\662F\6709\6548\7684\6578\5B57.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116037261507402986)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \4E0D\7B26\5408\6578\5B57\683C\5F0F %0 (\7BC4\4F8B: %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116036913137402985)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \5FC5\9808\662F\5927\65BC\6216\7B49\65BC %0 \7684\6578\5B57.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116036847505402985)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('#LABEL# \5FC5\9808\662F\4ECB\65BC %0 \548C %1 \4E4B\9593\7684\6578\5B57.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116032172480402982)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\65B0\8996\7A97\4E2D\958B\555F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115985351822402947)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7D93\9001\51FA\6B64\9801\9762, \7121\6CD5\91CD\65B0\9001\51FA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115967937643402934)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\61C9\7528\7A0B\5F0F "%0" \9801\9762 "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116001715338402959)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165 #LABEL# \503C.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115945081080402917)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116051051761402996)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116050920174402996)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0B\627E %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116051258078402996)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116051174355402996)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115937171504402912)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\81F3\5C11\6709 %0 \500B\5B57\5143\7684\641C\5C0B\8A5E.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116006669976402963)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5373\73FE\5F0F\503C\6E05\55AE: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115937252994402912)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\641C\5C0B\8A5E.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115937091200402912)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\4EFB\4F55\7D50\679C.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115936938945402911)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116024826502402976)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\8A5E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116050853963402996)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116061561897403004)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115935520145402911)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\81F3\9996\9801\756B\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115931564194402908)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\60A8\7684\88DD\7F6E\6216\700F\89BD\5668\76EE\524D\4F3C\4E4E\4E0D\652F\63F4\5B89\88DD\6F38\9032\5F0F Web App.</p>'),
unistr('    <p class="a-pwaDialog-intro">\5982\679C\60A8\7684\88DD\7F6E\4E0A\5DF2\5B89\88DD\6B64\61C9\7528\7A0B\5F0F, \8ACB\5F9E\60A8\7684\9996\9801\756B\9762\4E2D\958B\555F\61C9\7528\7A0B\5F0F.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115931194579402907)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7DB2\7AD9\5305\542B\61C9\7528\7A0B\5F0F\529F\80FD. \8ACB\5C07\5176\65B0\589E\81F3\60A8\7684\9996\9801\756B\9762, \4EE5\5168\87A2\5E55\4F7F\7528.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \9EDE\9078\5E95\7AEF\5C0E\89BD\7684<strong>\529F\80FD\8868</strong>\5716\793A</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \9EDE\9078<strong>\5B89\88DD</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \9EDE\9078<strong>\65B0\589E</strong>\9032\884C\78BA\8A8D</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115931264326402907)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7DB2\7AD9\5305\542B\53EF\5728 Chrome \6216 Edge \4E2D\7372\5F97\6700\4F73\9AD4\9A57\7684\61C9\7528\7A0B\5F0F\529F\80FD.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \9EDE\9078\7DB2\5740\5217\65C1\7684<strong>\529F\80FD\8868</strong>\5716\793A</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \9EDE\9078<strong>\5B89\88DD</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115930810350402907)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7DB2\7AD9\5305\542B\53EF\5728 Safari \4E2D\7372\5F97\6700\4F73\9AD4\9A57\7684\61C9\7528\7A0B\5F0F\529F\80FD.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \9EDE\9078\5E95\7AEF\5C0E\89BD\7684<strong>\5171\7528</strong>\5716\793A</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \9EDE\9078<strong>\5728 Safari \4E2D\958B\555F</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115930572407402907)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7DB2\7AD9\5305\542B\61C9\7528\7A0B\5F0F\529F\80FD. \8ACB\5C07\5176\65B0\589E\81F3\60A8\7684\9996\9801\756B\9762\4EE5\7372\5F97\6700\4F73\9AD4\9A57.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \9EDE\9078\7DB2\5740\5217\65C1\7684<strong>\5171\7528</strong>\5716\793A</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \9EDE\9078<strong>\65B0\589E\81F3\9996\9801\756B\9762</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \9EDE\9078<strong style="color:#007AE1;">\65B0\589E</strong>\9032\884C\78BA\8A8D</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115930447155402907)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7DB2\7AD9\5305\542B\61C9\7528\7A0B\5F0F\529F\80FD. \8ACB\5C07\5176\65B0\589E\81F3\60A8\7684\9996\9801\756B\9762\4EE5\7372\5F97\6700\4F73\9AD4\9A57.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \9EDE\9078\5E95\7AEF\5C0E\89BD\7684<strong>\5171\7528</strong>\5716\793A</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \5411\4E0B\6372\52D5\4E26\9EDE\9078<strong>\65B0\589E\81F3\9996\9801\756B\9762</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \9EDE\9078<strong style="color:#007AE1;">\65B0\589E</strong>\9032\884C\78BA\8A8D</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115925429682402903)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7DB2\7AD9\5305\542B\61C9\7528\7A0B\5F0F\529F\80FD. \8ACB\5C07\5176\65B0\589E\81F3\60A8\7684\9996\9801\756B\9762\4EE5\7372\5F97\6700\4F73\9AD4\9A57.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \9EDE\9078\7DB2\5740\5217\65C1\7684<strong>\5176\4ED6</strong>\5716\793A</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \9EDE\9078<strong>\65B0\589E\81F3\9996\9801\756B\9762</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \9EDE\9078<strong style="color:#007AE1;">\65B0\589E</strong>\9032\884C\78BA\8A8D</p>'),
'    </div>',
'</div>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115930788423402907)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7DB2\7AD9\5305\542B\61C9\7528\7A0B\5F0F\529F\80FD. \8ACB\5C07\5176\65B0\589E\81F3\60A8\7684\9996\9801\756B\9762\4EE5\7372\5F97\6700\4F73\9AD4\9A57.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\9EDE\9078\7DB2\5740\5217\65C1\7684<strong>\5171\7528</strong>\5716\793A</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\9EDE\9078<strong>\5728 Safari \4E2D\958B\555F</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115930699431402907)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7DB2\7AD9\5305\542B\61C9\7528\7A0B\5F0F\529F\80FD. \8ACB\5C07\5176\65B0\589E\81F3\60A8\7684\9996\9801\756B\9762\4EE5\7372\5F97\6700\4F73\9AD4\9A57.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\9EDE\9078\5E95\7AEF\5C0E\89BD\7684<strong>\5171\7528</strong>\5716\793A</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\9EDE\9078<strong>\5728 Safari \4E2D\958B\555F</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115931492101402908)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7DB2\7AD9\5305\542B\53EF\5728 Chrome \4E2D\7372\5F97\6700\4F73\9AD4\9A57\7684\61C9\7528\7A0B\5F0F\529F\80FD.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox \76EE\524D\4E0D\652F\63F4\5B89\88DD Web \61C9\7528\7A0B\5F0F.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115930969331402907)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7DB2\7AD9\5305\542B\53EF\5728 Chrome \6216 Edge \4E2D\7372\5F97\6700\4F73\9AD4\9A57\7684\61C9\7528\7A0B\5F0F\529F\80FD.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox \76EE\524D\4E0D\652F\63F4\5728 macOS \4E0A\5B89\88DD Web \61C9\7528\7A0B\5F0F.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115931070081402907)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7DB2\7AD9\5305\542B\53EF\5728 Chrome \6216 Edge \4E2D\7372\5F97\6700\4F73\9AD4\9A57\7684\61C9\7528\7A0B\5F0F\529F\80FD.</p>'),
unistr('    <p class="a-pwaDialog-intro">Safari \76EE\524D\4E0D\652F\63F4\5728 macOS \4E0A\5B89\88DD Web \61C9\7528\7A0B\5F0F.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115931394181402907)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7DB2\7AD9\5305\542B\53EF\5728 Chrome \6216 Edge \4E2D\7372\5F97\6700\4F73\9AD4\9A57\7684\61C9\7528\7A0B\5F0F\529F\80FD.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox \76EE\524D\4E0D\652F\63F4\5728 Windows \4E0A\5B89\88DD Web \61C9\7528\7A0B\5F0F.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115933876432402909)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>\7121\6CD5\9023\7DDA</h1>'),
unistr('    <p>\60A8\9700\6709\7DB2\969B\7DB2\8DEF\9023\7DDA\624D\80FD\4F7F\7528\6B64\61C9\7528\7A0B\5F0F.</p>'),
unistr('    <button type="button">\91CD\8A66</button>'),
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115933716988402909)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\9023\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116073511725403013)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116017984355402971)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116096803123403030)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\9001\9080\8ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116096675932403030)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116019707420402973)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\6AA2\8996 (\5168\65E5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116019563529402972)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\6AA2\8996 (\8CC7\6599\8207\6642\9593)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116064434610403006)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116058813987403002)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115949401789402920)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'zh-tw'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115949252490402920)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'zh-tw'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115949119773402920)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'zh-tw'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115949371086402920)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'zh-tw'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115948881423402920)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115949070329402920)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E8B\4EF6\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116096771776403030)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9080\8ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116064509140403006)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116064213791403006)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116067085997403008)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116081334650403018)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116097053119403031)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\73FE\6709\4E8B\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116096933801403030)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\900F\904E\96FB\5B50\90F5\4EF6\50B3\9001\9080\8ACB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116067139358403008)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116075168012403014)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\9001\96FB\5B50\90F5\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116074968600403014)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\9001\96FB\5B50\90F5\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116097764034403031)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\6B04\4F4D\90FD\662F\5FC5\8981\7684.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116097671147403031)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\9001\9080\8ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116096509036403030)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\65E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116075016444403014)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6536\4EF6\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115948944145402920)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116072898892403012)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \76F8\95DC\8868\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116019333285402972)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116067203145403008)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4ECA\5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116065056625403006)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116064358718403006)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116019642161402972)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9031\6AA2\8996 (\5168\65E5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116019490696402972)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9031\6AA2\8996 (\8CC7\6599\8207\6642\9593)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116064949749403006)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116064667338403006)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116064708823403006)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\5176\4ED6\9805\76EE...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115996870320402955)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8FD4\56DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115943137377402916)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\5176\4ED6\9805\76EE...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115945281664402917)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116064805888403006)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\5176\4ED6\9805\76EE...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116066940807403008)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\5340\57DF ID %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115945199360402917)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115969246103402935)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\91CD\8A2D\5340\57DF\5206\9801.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115937473832402912)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\5340\57DF\5206\9801\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116058253776403001)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116066825189403008)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\652F\63F4\5340\57DF\985E\578B %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115937334938402912)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE\5340\57DF "#COMPONENT_NAME#" \6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116001853696402959)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165 #COLUMN_HEADER# \503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116096137763403030)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0, Rich Text \7DE8\8F2F\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116003943249402960)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('Rich Text HTML \6A19\8A18\8D85\904E\9805\76EE\7684\6700\5927\9577\5EA6 (\4E0A\9650\70BA %1 \500B\5B57\5143, \4F46\5BE6\969B\6709 %0 \500B\5B57\5143)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116063852594403006)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116055613704402999)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8907\88FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116053960408402998)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\7684\8CC7\6599\6B04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116053850381402998)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\9664\7A7A\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116063914342403006)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116017561853402971)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\79FB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116017614896402971)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\79FB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116053653665402998)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\500B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116054282589402998)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6\8CC7\6599\6B04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116053708356402998)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\500B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116054052090402998)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116054182954402998)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C %0 \500B\8CC7\6599\5217, \5171 %1 \500B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116055745093402999)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\6574\7406')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116055894848403000)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56DE\5FA9\8B8A\66F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116053564798402998)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\503C\529F\80FD\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116014565795402969)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F8B\5982, %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115922056832402901)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\767B\5165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115921918066402901)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\968E\6BB5\4F5C\696D\5DF2\7D50\675F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115922117273402901)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EF6\9577')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115921701711402901)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\968E\6BB5\4F5C\696D\5C07\5728 %0 \7D50\675F. \8981\5EF6\9577\55CE?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115921843641402901)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\968E\6BB5\4F5C\696D\5C07\5728 %0 \7D50\675F\4E14\7121\6CD5\5EF6\9577. \8ACB\7ACB\5373\5132\5B58\6240\6709\4F5C\696D, \4EE5\907F\514D\4EFB\4F55\8CC7\6599\907A\5931.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116074784428403014)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\8CC7\6599\5EAB\968E\6BB5\4F5C\696D\6E05\9664\7A0B\5F0F\78BC\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115967846098402934)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\8CC7\6599\5EAB\968E\6BB5\4F5C\696D\8A2D\5B9A\7A0B\5F0F\78BC\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115941987151402915)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\968E\6BB5\4F5C\696D\5DF2\7D50\675F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116073698817403013)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\95DC\9589\6B64\5C0D\8A71\65B9\584A, \7136\5F8C\6309\700F\89BD\5668\7684\300C\91CD\65B0\8F09\5165\300D\6309\9215\4EE5\53D6\5F97\65B0\7684\968E\6BB5\4F5C\696D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116092960811403027)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\4E00\4E0B<a href="%0">\6B64\8655</a>\4EE5\5EFA\7ACB\65B0\7684\968E\6BB5\4F5C\696D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115979593047402943)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D\7121\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116019048151402972)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5728\4F7F\7528\8005 "%0" \7684 Real Application Security \968E\6BB5\4F5C\696D\4E2D\555F\7528\4EFB\4F55\300C\52D5\614B\89D2\8272\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115965790774402932)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-99900 \7121\6CD5\5EFA\7ACB\552F\4E00\7684\968E\6BB5\4F5C\696D ID: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115982092189402944)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D\72C0\614B\4FDD\8B77\9055\898F: \53EF\80FD\7684\539F\56E0\662F\624B\52D5\66F4\6539\53D7\4FDD\8B77\7684\9801\9762\9805\76EE %0. \5982\679C\60A8\4E0D\78BA\5B9A\9020\6210\6B64\932F\8AA4\7684\539F\56E0, \8ACB\6D3D\8A62\61C9\7528\7A0B\5F0F\7BA1\7406\54E1\53D6\5F97\5354\52A9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116101149311403034)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\4FDD\8B77\9055\898F: \53EF\80FD\7684\539F\56E0\662F\9001\51FA\5C1A\672A\5B8C\6210\8F09\5165\7684\9801\9762, \6216\624B\52D5\66F4\6539\53D7\4FDD\8B77\9801\9762\9805\76EE. \5982\9700\9032\4E00\6B65\7684\5354\52A9, \8ACB\6D3D\8A62\61C9\7528\7A0B\5F0F\7BA1\7406\54E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116100111425403033)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5305\542B\4E0B\5217\5176\4E2D\4E00\500B\7121\6548\5B57\5143 &<>"/;,*|=% \6216 --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116100286096403033)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5305\542B\4E0B\5217\5176\4E2D\4E00\500B\7121\6548\5B57\5143 &<>"/;,*|=% \6216 -- \6216\65B0\884C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116099958561403033)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5305\542B\7279\6B8A\5B57\5143. \50C5\5141\8A31\5B57\5143 a-Z\30010-9 \8207\7A7A\683C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116100092955403033)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5305\542B <, > \6216 " \7B49\7121\6548\7684\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115944112959402917)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\4E00\6216\591A\500B request, clear cache \6216\5F15\6578\503C\4F5C\70BA\53C3\6578\50B3\9001\6642, \672A\63D0\4F9B\7E3D\548C\6AA2\9A57\4F86\986F\793A\9700\8981\7E3D\548C\6AA2\9A57\7684\9801\9762\8655\7406.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115976934936402941)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\968E\6BB5\4F5C\696D\72C0\614B\4FDD\8B77\9055\898F: \53EF\80FD\7684\539F\56E0\662F\624B\52D5\66F4\6539\5167\542B\7E3D\548C\6AA2\9A57\7684 URL, \6216\4F7F\7528\7684\9023\7D50\5305\542B\932F\8AA4\6216\907A\6F0F\7684\7E3D\548C\6AA2\9A57. \5982\679C\60A8\4E0D\78BA\5B9A\9020\6210\6B64\932F\8AA4\7684\539F\56E0, \8ACB\6D3D\8A62\61C9\7528\7A0B\5F0F\7BA1\7406\54E1\53D6\5F97\5354\52A9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116054963065402999)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\9AD8\5C0D\6BD4\6A21\5F0F\8A2D\70BA\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116055021058402999)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\9AD8\5C0D\6BD4\6A21\5F0F\8A2D\70BA\958B\555F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115973698099402938)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E95\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115973814246402938)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\79FB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115973959323402939)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115974026600402939)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115974176123402939)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115974217925402939)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8\79FB\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115974369405402939)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115973561001402938)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9802\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115973746617402938)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\79FB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116082663399403019)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116083306767403020)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5929\5167')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116082593543403019)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116083457710403020)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5C0F\6642\5167')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116082328123403019)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116083560272403020)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5206\9418\5167')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116082989074403020)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116083191037403020)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\6708\5167')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116082422633403019)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116083245669403020)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \79D2\5167')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116082707891403019)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116083677476403020)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \9031\5167')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116082899548403020)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116083095257403020)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5E74\5167')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115922983205402902)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('[\7DDA\689D]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115923395541402902)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('[\591A\500B\7DDA\689D]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115923154652402902)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('[\591A\9EDE]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115923545530402902)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('[\591A\500B\591A\908A\5F62]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115923644913402902)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('[\5E7E\4F55\7269\4EF6]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115922809980402901)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('[\9EDE (%0,%1)]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115923066831402902)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('[\591A\908A\5F62]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116000286889402958)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116000171807402958)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56DE\5FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116046628279402993)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664\8A55\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116036584288402985)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728 1 - %1 \7684\6709\6548\8A55\6BD4\7BC4\570D\5167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116036619569402985)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\662F\6578\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116032737863402982)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6210\529F\8A0A\606F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116095816066403030)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\500B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116095742329403030)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\500B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116081419569403019)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\5177\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116096226529403030)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C55\958B/\96B1\85CF\5C0E\89BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116096374328403030)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C55\958B/\96B1\85CF\5074\908A\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116005962688402962)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\5C0E\89BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116012905235402967)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('1 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116012756897402967)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('1 \5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116013034570402967)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116012839489402967)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116012636953402967)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5206\9418')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116013207425402968)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116013199031402967)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('1 \9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116099496755403032)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\958B\982D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115961405383402929)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\555F\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115935226566402910)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406\8981\6C42\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116014642712402969)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116097547842403031)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\7B49\5230\9801\9762\5B8C\5168\8F09\5165\5F8C\518D\8A66\4E00\6B21.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116057725088403001)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\6709\672A\5132\5B58\7684\8B8A\66F4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115938697674402913)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\5DE5\4F5C\7C3F\6C92\6709\4F5C\7528\4E2D\5DE5\4F5C\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115938563593402913)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\5DE5\4F5C\7C3F\672A\8D77\4F7F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115938494437402913)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB XLSX \6A94\6848\6642\767C\751F\5167\90E8\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115940958927402914)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116072652908403012)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115990153742402950)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52D5\4F5C\529F\80FD\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115985883099402947)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115985762934402947)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F9D\8CC7\6599\6B04\65B0\589E\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116019935300402973)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\6A1E\7D10\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116020032489402973)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\8CC7\6599\5217\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115960250306402928)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\805A\7E3D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115996371587402955)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\805A\7E3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115977466055402941)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E73\5747\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115981788351402944)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A08\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115977522069402941)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5927\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115977757847402941)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\9593\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115977657008402941)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5C0F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115977368115402941)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\548C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115978469543402942)
,p_name=>'APEXIR_ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115959558117402928)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115942086284402915)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6240\6709\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116069605051403010)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66FF\4EE3\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116071288501403011)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66FF\4EE3\9810\8A2D\503C:  %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115972114820402937)
,p_name=>'APEXIR_AND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115961693329402929)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5957\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115955318274402925)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\905E\589E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115974907384402939)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65BC %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116071821754403011)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E73\5747\503C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116063238606403005)
,p_name=>'APEXIR_BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\689D\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115961092586402929)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4ECB\65BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115954138609402924)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\80CC\666F\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115956059865402925)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\85CD\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115987731958402949)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E95\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115956604634402926)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\6D88')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115962550623402930)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115954042511402924)
,p_name=>'APEXIR_CELL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115978366622402942)
,p_name=>'APEXIR_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115988621543402949)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B63\5728\8D77\59CB...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116024951668402977)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\5716\8868\6A19\7C64.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116037341777402986)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684\67E5\8A62\8D85\51FA\6BCF\4E00\5716\8868 %0 \500B\8CC7\6599\9EDE\7684\6578\76EE\4E0A\9650. \8ACB\5957\7528\7BE9\9078\689D\4EF6\4F86\6E1B\5C11\60A8\57FA\790E\67E5\8A62\4E2D\7684\8A18\9304\6578\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116036274640402985)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\5716\8868\300D\67E5\8A62\7684\8CC7\6599\5217\8A08\6578\4E0A\9650\9650\5236\7684\662F\57FA\790E\67E5\8A62\4E2D\7684\8CC7\6599\5217\6578\76EE, \800C\4E0D\662F\9650\5236\986F\793A\7684\8CC7\6599\5217\6578\76EE.  \60A8\7684\57FA\790E\67E5\8A62\8D85\51FA\8CC7\6599\5217\8A08\6578\4E0A\9650 (%0 \500B\8CC7\6599\5217).  \8ACB\5957\7528\7BE9\9078\4EE5\6E1B\5C11\60A8\57FA\790E\67E5\8A62\4E2D\7684\8A18\9304\6578\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115959678505402928)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116032996934402982)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8\52FE\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115975399569402940)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\5831\8868\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115982777523402945)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115956583076402925)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115993961344402953)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116066229654403007)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115984743008402946)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\6A19\984C\529F\80FD\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115988437361402949)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116068575782403009)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115986155730402947)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115970265358402936)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\542B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115971134532402936)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5305\542B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115955071923402924)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115971393988402937)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5728\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115979807824402943)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5728\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115971281726402937)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115979732028402943)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115954972938402924)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115954805390402924)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115954653434402924)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540C\65BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115955101025402925)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115954712885402924)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\540C\65BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115970532239402936)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B26\5408\6B63\898F\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115975236787402939)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116035966747402985)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115994201514402953)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8CC7\6599\6B04\5225\540D\5EFA\7ACB\904B\7B97.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115994336076402953)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'zh-tw'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115994497966402953)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'zh-tw'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115994582737402953)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'zh-tw'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115940428090402914)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'zh-tw'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115979173083402942)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115986767832402948)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63A7\5236\5206\6BB5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115989713819402950)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63A7\5236\5206\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116074145527403013)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63A7\5236\5206\6BB5\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115937527115402912)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\7570\8A08\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116072386203403012)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\7570\8A08\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116072203577403012)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A08\6578 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116044328908402991)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116099024662403032)
,p_name=>'APEXIR_DATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115988593088402949)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5206\9418\524D\7684\5831\8868\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116062057911403004)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\65B9\683C\8AAA\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115960363805402928)
,p_name=>'APEXIR_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115992485753402952)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116069486151403010)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D\5831\8868\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115956759897402926)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115960690468402928)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\522A\9664\9019\4E9B\5831\8868\8A2D\5B9A\503C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116055343445402999)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\9810\8A2D\5831\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115986445208402948)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\5831\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115955441302402925)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\905E\6E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115962621098402930)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115984633932402946)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\55AE\4E00\8CC7\6599\5217\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115992993785402952)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\5411 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115993886057402953)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115956206200402925)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115959437117402928)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\7684\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115992810061402952)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A\5728\5831\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115987674502402948)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\79FB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115979294477402942)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115992782573402952)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116058771609403002)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\793A\5DF2\7D93\5B58\5728\7684\76F8\540C\689D\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116074383939403013)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8907\7684\6A1E\7D10\5206\6790\8868\8CC7\6599\6B04.  \6A1E\7D10\5206\6790\8868\8CC7\6599\6B04\6E05\55AE\5FC5\9808\662F\552F\4E00\7684.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116074576203403013)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115988745207402949)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\5716\8868\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115995362941402954)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115995745362402954)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\7BE9\9078\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116050130555402995)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\7FA4\7D44\4F9D\64DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115995631185402954)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\6A19\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116020226126402973)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F\6A1E\7D10\5206\6790\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116069708149403010)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115948436379402920)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6\5730\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116070064092403010)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\4EF6\526F\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116070292937403010)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672C\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116069952608403010)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\526F\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116070716737403011)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\983B\7387')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115952150301402922)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C1A\672A\8A2D\5B9A\6B64\61C9\7528\7A0B\5F0F\7684\96FB\5B50\90F5\4EF6.  \8ACB\6D3D\8A62\60A8\7684\7BA1\7406\54E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116043681075402990)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\96FB\5B50\90F5\4EF6\5730\5740.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116070338428403010)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\770B\9644\52A0\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116070126166403010)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\65E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116044616509402991)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\96FB\5B50\90F5\4EF6\4E3B\65E8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116069827764403010)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6536\4EF6\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115953887838402924)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\555F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115995519382402954)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\555F\7528/\505C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115995017984402954)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115994630810402953)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115995400413402954)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BC4\4F8B:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115959339686402927)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\9664\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115996026313402954)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C55\958B/\96B1\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115993679067402953)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8868\793A\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115978701782402942)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115989623512402950)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115999977869402957)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078\8868\793A\5F0F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116096444024403030)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078\8868\793A\5F0F\592A\9577.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115999815282402957)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BE9\9078\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115996241987402955)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8981\641C\5C0B\7684\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115979044350402942)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5012\6EAF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115993478228402953)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\60F3\6AA2\8996\5148\524D\6642\9EDE\7684\8CC7\6599, \53EF\4EE5\4F7F\7528\5012\6EAF\67E5\8A62.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116044078164402991)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5012\6EAF\6301\7E8C\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116045424836402992)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115975189979402939)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\683C\5F0F\906E\7F69 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115986310837402948)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115994134571402953)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116069324919403010)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578/\904B\7B97\5B50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115986003678402947)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\51FD\6578 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115978571385402942)
,p_name=>'APEXIR_GO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115954332067402924)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DA0\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115937660938402912)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7FA4\7D44\4F9D\64DA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116070492867403010)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F9D\8CC7\6599\6B04 %0 \7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116025013276402977)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\7FA4\7D44\4F9D\64DA\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116036177627402985)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\7FA4\7D44\4F9D\64DA\300D\67E5\8A62\7684\8CC7\6599\5217\8A08\6578\4E0A\9650\9650\5236\7684\662F\57FA\790E\67E5\8A62\4E2D\7684\8CC7\6599\5217\6578\76EE, \800C\4E0D\662F\9650\5236\986F\793A\7684\8CC7\6599\5217\6578\76EE.  \60A8\7684\57FA\790E\67E5\8A62\8D85\51FA\8CC7\6599\5217\8A08\6578\4E0A\9650 (%0 \500B\8CC7\6599\5217).  \8ACB\5957\7528\7BE9\9078\4EE5\6E1B\5C11\60A8\57FA\790E\67E5\8A62\4E2D\7684\8A18\9304\6578\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116016748199402970)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\6392\5E8F\7FA4\7D44')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116074269291403013)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\6392\5E8F\9806\5E8F\7FA4\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115959754856402928)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C34\5E73\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115991354654402951)
,p_name=>'APEXIR_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115983181379402945)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E00\822C\4F7F\7528\8005\53EF\5728\4E92\52D5\5F0F\5831\8868\81EA\8A02\5831\8868. \4F7F\7528\8005\53EF\4EE5\9078\53D6\60F3\8981\7684\8CC7\6599\6B04, \4E26\7BE9\9078\3001\6A19\793A\53CA\6392\5E8F, \4EE5\66F4\6539\5831\8868\8CC7\6599\7684\7248\9762\914D\7F6E. \4E5F\53EF\4EE5\5B9A\7FA9\5206\6BB5\3001\805A\7E3D\3001\5716\8868\3001\7FA4\7D44\65B9\5F0F\4EE5\53CA\65B0\589E\81EA\5DF1\7684\904B\7B97. \4E5F\53EF\4EE5\5EFA\7ACB\8A02\95B1, \4F9D\6307\5B9A\7684\9593\9694\900F\904E\96FB\5B50\90F5\4EF6\6536\5230 HTML \7248\672C\7684\5831\8868. \4F7F\7528\8005\53EF\4EE5\5EFA\7ACB\591A\7A2E\4E0D\540C\7684\5831\8868, \4E26\5132\5B58\70BA\5177\540D\5831\8868, \4F9B\516C\7528\6216\79C1\4EBA\6AA2\8996\4E4B\7528. '),
'<p/>',
unistr('\5F8C\9762\7684\6BB5\843D\6703\6458\8981\8AAA\660E\60A8\53EF\4EE5\81EA\8A02\4E92\52D5\5F0F\5831\8868\7684\65B9\5F0F. \5982\9700\77AD\89E3\8A73\7D30\8CC7\8A0A, \8ACB\53C3\95B1 <i>Oracle Application Express End User''s Guide</i> \7684 "Using Interactive Reports"</a>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115990247121402950)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\52D5\4F5C\300D\529F\80FD\8868\6703\986F\793A\5728\300C\641C\5C0B\300D\5217\4E2D\300C\57F7\884C\300D\6309\9215\7684\53F3\908A. \60A8\53EF\4EE5\4F7F\7528\6B64\529F\80FD\8868\4F86\81EA\8A02\4E92\52D5\5F0F\5831\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115983912726402946)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\805A\7E3D\662F\6307\5C0D\8CC7\6599\6B04\57F7\884C\7B97\8853\904B\7B97. \5728\6BCF\500B\63A7\5236\5206\6BB5\4E4B\5F8C\8207\5831\8868\7D50\5C3E\8655, \65BC\5B9A\7FA9\8981\8A08\7B97\805A\7E3D\7684\8CC7\6599\6B04\5167\986F\793A\805A\7E3D\503C. \9078\9805\5305\62EC:'),
'<p>',
'</p><ul>',
unistr('<li><strong>\805A\7E3D</strong>: \9078\53D6\5148\524D\5B9A\7FA9\7684\805A\7E3D\9032\884C\7DE8\8F2F.</li>'),
unistr('<li><strong>\51FD\6578</strong>: \8981\57F7\884C\7684\51FD\6578 (\4F8B\5982 SUM\3001MIN).</li>'),
unistr('<li><strong>\8CC7\6599\6B04</strong>: \9078\53D6\8981\5957\7528\7B97\8853\51FD\6578\7684\8CC7\6599\6B04. \53EA\6703\986F\793A\6578\503C\8CC7\6599\6B04.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115984037721402946)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\60A8\53EF\4EE5\66FF\6BCF\4E00\4EFD\5132\5B58\7684\5831\8868\5B9A\7FA9\4E00\500B\5716\8868. \5B9A\7FA9\4E4B\5F8C, \5C31\53EF\4EE5'),
unistr('\4F7F\7528\300C\641C\5C0B\300D\5217\7684\6AA2\8996\5716\793A, \5728\5716\8868\8207\5831\8868\6AA2\8996\4E4B\9593\5207\63DB.'),
unistr('\9078\9805\5305\62EC:  '),
'<p>',
'</p><ul>',
unistr('<li><strong>\5716\8868\985E\578B</strong>: \6307\5B9A\8981\5305\542B\7684\5716\8868\985E\578B.'),
unistr('\53EF\9078\53D6\7684\985E\578B\5305\62EC\6C34\5E73\9577\689D\5716\3001\5782\76F4\9577\689D\5716\3001\5713\9905\5716\6216\6298\7DDA\5716.</li>'),
unistr('<li><strong>\6A19\7C64</strong>: \9078\53D6\8981\7576\4F5C\6A19\7C64\7684\8CC7\6599\6B04.</li>'),
unistr('<li><strong>\6A19\7C64\7684\5EA7\6A19\8EF8\6A19\984C</strong>: \5728\9078\53D6\70BA\300C\6A19\7C64\300D\4E4B\8CC7\6599\6B04\7684\5EA7\6A19\8EF8\4E0A\986F\793A\7684'),
unistr('\6A19\984C. \9019\4E0D\9069\7528\65BC\5713\9905\5716.</li>'),
unistr('<li><strong>\503C</strong>: \9078\53D6\8981\7576\4F5C\503C\7684\8CC7\6599\6B04.  \82E5\4F7F\7528 COUNT \51FD\6578,'),
unistr('\5C31\4E0D\9700\8981\9078\53D6\300C\503C\300D.</li>'),
unistr('<li><strong>\503C\7684\5EA7\6A19\8EF8\6A19\984C</strong>: \5728\9078\53D6\70BA\300C\503C\300D\4E4B\8CC7\6599\6B04\7684\5EA7\6A19\8EF8\4E0A\986F\793A\7684'),
unistr('\6A19\984C. \9019\4E0D\9069\7528\65BC\5713\9905\5716.</li>'),
unistr('<li><strong>\51FD\6578</strong>: \8981\5C0D\9078\53D6\70BA\300C\503C\300D\4E4B\8CC7\6599\6B04\57F7\884C\7684\9078\64C7\6027\51FD\6578.</li>'),
unistr('<li><strong>\6392\5E8F</strong>: \53EF\6392\5E8F\7D50\679C\96C6.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115983373003402945)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6309\4E00\4E0B\4EFB\4E00\8CC7\6599\6B04\6A19\984C\5373\53EF\986F\793A\8CC7\6599\6B04\6A19\984C\529F\80FD\8868. \9078\9805\5305\62EC:'),
'<p></p>',
'<ul>',
unistr('<li><strong>\905E\589E\6392\5E8F</strong>\5716\793A: \6309\8CC7\6599\6B04, \4EE5\905E\589E\9806\5E8F\6392\5E8F\5831\8868.</li>'),
unistr('<li><strong>\905E\6E1B\6392\5E8F</strong>\5716\793A: \6309\8CC7\6599\6B04, \4EE5\905E\6E1B\9806\5E8F\6392\5E8F\5831\8868.</li>'),
unistr('<li><strong>\96B1\85CF\8CC7\6599\6B04</strong>: \96B1\85CF\8CC7\6599\6B04.  \60A8\7121\6CD5\96B1\85CF\6240\6709\8CC7\6599\6B04.  \8CC7\6599\6B04\82E5\7121\6CD5\96B1\85CF, \5C31\4E0D\6703\6709\300C\96B1\85CF\8CC7\6599\6B04\300D\5716\793A.</li>'),
unistr('<li><strong>\5206\6BB5\8CC7\6599\6B04</strong>: \6839\64DA\8CC7\6599\6B04\5EFA\7ACB\5206\6BB5\7FA4\7D44.  \5831\8868\5C07\6703\4EE5\8A72\8CC7\6599\6B04\4F5C\70BA\4E3B\8981\8A18\9304.</li>'),
unistr('<li><strong>\8CC7\6599\6B04\8CC7\8A0A</strong>: \986F\793A\8CC7\6599\6B04\7684\8AAA\660E\5167\5BB9 (\5982\679C\6709\7684\8A71).</li>'),
unistr('<li><strong>\6587\5B57\5340</strong>: \53EF\65BC\5176\4E2D\8F38\5165\6C92\6709\5927\5C0F\5BEB\4E4B\5206\7684\641C\5C0B\689D\4EF6'),
unistr('(\4E0D\9700\4F7F\7528\842C\7528\5B57\5143). \82E5\8F38\5165\503C, \5C07\53EF\6E1B\5C11\529F\80FD\8868'),
unistr('\5E95\7AEF\7684\503C\6E05\55AE. \60A8\53EF\4EE5\5F9E\5E95\7AEF\9078\53D6\4E00\500B\503C,'),
unistr('\9078\53D6\7684\503C\5C07\6703\4F7F\7528 ''='' \5EFA\7ACB\70BA\7BE9\9078\689D\4EF6'),
unistr('(\4F8B\5982, <code>column = ''ABC''</code>). \6216\8005, \60A8\53EF\4EE5\6309\4E00\4E0B\300C\624B\96FB\7B52\300D \5716\793A\4E26\8F38\5165\503C, \4F7F\7528 ''LIKE'' \4FEE\98FE\689D\4EF6'),
unistr('\5C07\503C\5EFA\7ACB\70BA\7BE9\9078\689D\4EF6 (\4F8B\5982, <code>column LIKE ''%ABC%''</code>).</li>'),
unistr('<li><b>\552F\4E00\503C\6E05\55AE</b>: \5305\542B\7B26\5408\7BE9\9078\689D\4EF6'),
unistr('\7684\524D 500 \500B\552F\4E00\503C. \8CC7\6599\6B04\82E5\662F\65E5\671F, \5247\6703\986F\793A'),
unistr('\65E5\671F\7BC4\570D\6E05\55AE. \5982\679C\9078\53D6\67D0\500B\503C, \5C07\6703\4F7F\7528'),
unistr('''='' \5EFA\7ACB\4E00\500B\7BE9\9078\689D\4EF6 (\4F8B\5982, <code>column = ''ABC''</code>).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115983877966402946)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\53EF\8B93\60A8\65B0\589E\7D93\904E\904B\7B97\7684\8CC7\6599\6B04\5230\60A8\7684\5831\8868. \53EF\4EE5\662F\5957\7528\81F3\73FE\6709\8CC7\6599\6B04\7684\7B97\8853\904B\7B97 (\4F8B\5982, <code>NBR_HOURS/24</code>) \6216\6A19\6E96\7684 Oracle'),
unistr('\51FD\6578. \90E8\5206\986F\793A\70BA\7BC4\4F8B\548C\5176\4ED6\9805\76EE (\4F8B\5982\4E5F\53EF\4EE5\4F7F\7528 <code>TO_DATE)</code>). \9078\9805\5305\62EC:'),
'<p></p>',
'<ul>',
unistr('<li><strong>\904B\7B97</strong>: \9078\53D6\5148\524D\5B9A\7FA9\7684\904B\7B97\4F86\52A0\4EE5\7DE8\8F2F.</li>'),
unistr('<li><strong>\8CC7\6599\6B04\6A19\984C</strong>: \65B0\8CC7\6599\6B04\7684\6A19\984C.</li>'),
unistr('<li><strong>\683C\5F0F\906E\7F69</strong>: \8CC7\6599\6B04\5957\7528\7684 Oracle \683C\5F0F\906E\7F69 (\4F8B\5982 S9999).</li>'),
unistr('<li><strong>\904B\7B97</strong>: \8981\57F7\884C\7684\904B\7B97. \5728\904B\7B97\5167, \4E3B\8981\4F7F\7528\986F\793A\7684\5225\540D\53C3\7167\8CC7\6599\6B04.</li>'),
'</ul>',
unistr('<p>\5728\904B\7B97\4E0B\65B9, \60A8\67E5\8A62\4E2D\7684\8CC7\6599\6B04\6703\4EE5\5176\76F8\95DC\5225\540D'),
unistr('\986F\793A. \6309\4E00\4E0B\8CC7\6599\6B04\540D\7A31\6216\5225\540D\5373\53EF\5C07\5176\5305\62EC\5728'),
unistr('\300C\904B\7B97\300D\4E2D. \300C\8CC7\6599\6B04\300D\7684\65C1\908A\662F\4E00\500B\9375\53F0. \6B64\9375\53F0\7684\529F\80FD\70BA'),
unistr('\5E38\7528\6309\9375\7684\6377\5F91. \6700\53F3\908A\5247\662F\300C\51FD\6578\300D.</p>'),
unistr('<p>\4E0B\5217\7BC4\4F8B\904B\7B97\793A\7BC4\5982\4F55\986F\793A\5831\916C\7E3D\8A08:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(\5176\4E2D\7684 A \662F ORGANIZATION, B \662F SALARY, \800C C \662F COMMISSION)</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115990341405402950)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\4E00\6216\6578\500B\8CC7\6599\6B04\5EFA\7ACB\5206\7D44. \9019\53EF\5C07\4E92\52D5\5F0F\5831\8868\7684\8CC7\6599\6B04\986F\793A\70BA\4E3B\8981\8A18\9304.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115984575691402946)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\8981\4E00\6B21\6AA2\8996\67D0\500B\55AE\4E00\8CC7\6599\5217\7684\8A73\7D30\8CC7\8A0A, \8ACB\6309\4E00\4E0B\60F3\8981\6AA2\8996\4E4B\8CC7\6599\5217\7684\55AE\4E00\8CC7\6599\5217\6AA2\8996\5716\793A. \5982\679C\6709\7684\8A71, \55AE\4E00\8CC7\6599\5217\6AA2\8996\4E00\5F8B\662F\7B2C\4E00\500B\8CC7\6599\6B04. \6839\64DA\81EA\8A02\4E92\52D5\5F0F\5831\8868\65B9\5F0F\7684\4E0D\540C, \55AE\4E00\8CC7\6599\5217\6AA2\8996\6709\53EF\80FD\662F\6A19\6E96\6AA2\8996\6216\5141\8A31\66F4\65B0\7684\81EA\8A02\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115984426689402946)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\53EF\4EE5\4E0B\8F09\76EE\524D\7684\7D50\679C\96C6. \4E0B\8F09\683C\5F0F\5C07\6839\64DA\5B89\88DD\548C'),
unistr('\5831\8868\5B9A\7FA9\7684\4E0D\540C\800C\6709\6240\4E0D\540C, \53EF\80FD\5305\62EC CSV\3001'),
unistr('HTML\3001\96FB\5B50\90F5\4EF6\3001XLS\3001PDF \6216 RTF.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115983587672402945)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5728\67E5\8A62\65B0\589E\6216\4FEE\6539 <code>WHERE</code> \5B50\53E5, \4EE5\5F37\8ABF\5831\8868\91CD\9EDE. \60A8\53EF\4EE5\6839\64DA\8CC7\6599\6B04\6216\8CC7\6599\5217\7BE9\9078.  '),
unistr('<p>\82E5\6309\8CC7\6599\6B04\7BE9\9078, \8ACB\9078\53D6\4E00\500B\8CC7\6599\6B04 (\4E0D\4E00\5B9A\8981\662F'),
unistr('\986F\793A\7684\8CC7\6599\6B04), \63A5\8457\9078\53D6\4E00\500B\6A19\6E96 Oracle \904B\7B97\5B50 (=\3001!=\3001not in\3001between), \7136\5F8C\8F38\5165\64DA\4EE5\6BD4\8F03\7684\8868\793A\5F0F. \8868\793A\5F0F\6709\5927\5C0F\5BEB\4E4B\5206. \8ACB\4F7F\7528 % \4F5C\70BA\842C\7528\5B57\5143 (\4F8B\5982, <code>STATE_NAME'),
'like A%)</code>.</p>',
unistr('<p>\82E5\6309\8CC7\6599\5217\7BE9\9078, \53EF\4EE5\5EFA\7ACB\8907\96DC\7684 <code>WHERE</code> \5B50\53E5, \65B9\6CD5\70BA\4F7F\7528'),
unistr('\8CC7\6599\6B04\5225\540D\548C\4EFB\4F55\7684 Oracle \51FD\6578\6216\904B\7B97\5B50 (\4F8B\5982, <code>G = ''VA'' \6216 G = ''CT''</code>, \5176\4E2D\7684'),
unistr('<code>G</code> \662F <code>CUSTOMER_STATE</code> \7684\5225\540D).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115984109958402946)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\60A8\53EF\4EE5\5229\7528\5012\6EAF\67E5\8A62\6AA2\8996\5148\524D\6642\9EDE\7684\8CC7\6599.'),
unistr('\4F9D\7167\9810\8A2D, \53EF\4EE5\5012\6EAF\7684\6642\9593\70BA 3 \5C0F\6642 (\6216 180 \5206\9418),'),
unistr('\4F46\5BE6\969B\6642\9593\5C07\6839\64DA\6BCF\500B\8CC7\6599\5EAB\800C\6709\6240\4E0D\540C.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116045345664402992)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\5229\7528\683C\5F0F\81EA\8A02\5831\8868\7684\986F\793A.'),
unistr('\683C\5F0F\5305\542B\4E0B\5217\5B50\529F\80FD\8868:</p>'),
unistr('<ul><li>\6392\5E8F</li>'),
unistr('<li>\63A7\5236\5206\6BB5</li>'),
unistr('<li>\6A19\793A</li>'),
unistr('<li>\904B\7B97</li>'),
unistr('<li>\805A\7E3D</li>'),
unistr('<li>\5716\8868</li>'),
unistr('<li>\7FA4\7D44\4F9D\64DA</li>'),
unistr('<li>\6A1E\7D10\5206\6790\8868</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116043532888402990)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\60A8\53EF\4EE5\66FF\6BCF\4E00\4EFD\5132\5B58\7684\5831\8868\5B9A\7FA9\4E00\500B\300C\7FA4\7D44\4F9D\64DA\300D\6AA2\8996.'),
unistr('\5B9A\7FA9\4E4B\5F8C, \5C31\53EF\4EE5\4F7F\7528\300C\641C\5C0B\300D\5217\4E0A\7684\6AA2\8996\5716\793A, \5728\7FA4\7D44\4F9D\64DA'),
unistr('\8207\5831\8868\6AA2\8996\4E4B\9593\5207\63DB. \82E5\8981\5EFA\7ACB\300C\7FA4\7D44\4F9D\64DA\300D\6AA2\8996,'),
unistr('\8ACB\9078\53D6:'),
'<p></p><ul>',
unistr('<li>\8981\7FA4\7D44\7684\8CC7\6599\6B04</li>'),
unistr('<li>\8981\805A\7E3D\7684\8CC7\6599\6B04\8207\8981\57F7\884C\7684\51FD\6578 (average\3001sum\3001count... \7B49\7B49)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115983741736402946)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\53EF\8B93\60A8\5B9A\7FA9\7BE9\9078. \7CFB\7D71\5C07\4F7F\7528\7BE9\9078\76F8\95DC\7279\6027, \5C07\7B26\5408\7BE9\9078\689D\4EF6\7684\8CC7\6599\5217\53CD\767D\986F\793A. \9078\9805\5305\62EC:</p>'),
'<ul>',
unistr('<li><strong>\540D\7A31</strong>: \53EA\7528\65BC\986F\793A.</li>'),
unistr('<li><strong>\9806\5E8F</strong>: \6307\5B9A\898F\5247\7684\8A55\4F30\9806\5E8F.</li>'),
unistr('<li><strong>\555F\7528</strong>: \6307\5B9A\555F\7528\6216\505C\7528\898F\5247.</li>'),
unistr('<li><strong>\6A19\793A\985E\578B</strong>: \6307\5B9A\61C9\8A72\6A19\793A\8CC7\6599\5217\6216\5132\5B58\683C.'),
unistr('\5982\679C\9078\53D6\300C\5132\5B58\683C\300D, \5247\6703\6A19\793A\300C\6A19\793A\689D\4EF6\300D\4E2D\53C3\7167\7684'),
unistr('\8CC7\6599\6B04.</li>'),
unistr('<li><strong>\80CC\666F\8272\5F69</strong>: \65B0\7684\6A19\793A\5340\57DF\80CC\666F\8272\5F69.</li>'),
unistr('<li><strong>\6587\5B57\8272\5F69</strong>: \65B0\7684\6A19\793A\5340\57DF\4E2D\6587\5B57\8272\5F69.</li>'),
unistr('<li><strong>\6A19\793A\689D\4EF6</strong>: \5B9A\7FA9\7BE9\9078\689D\4EF6.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115921315714402900)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\60A8\53EF\4EE5\66FF\6BCF\4E00\4EFD\5132\5B58\7684\5831\8868\5B9A\7FA9\4E00\500B\300C\6A1E\7D10\5206\6790\8868\300D\6AA2\8996. \5B9A\7FA9\4E4B\5F8C, \5C31\53EF\4EE5\4F7F\7528\300C\641C\5C0B\300D\5217\4E0A\7684\6AA2\8996\5716\793A, \5728\6A1E\7D10\5206\6790\8868\8207\5831\8868\6AA2\8996\4E4B\9593\9032\884C\5207\63DB. \82E5\8981\5EFA\7ACB\300C\6A1E\7D10\5206\6790\8868\300D\6AA2\8996, \8ACB\9078\53D6: '),
'<p></p>',
'<ul>',
unistr('<li>\6A1E\7D10\5206\6790\8868\4F5C\7528\7684\8CC7\6599\6B04</li>'),
unistr('<li>\8981\986F\793A\70BA\8CC7\6599\5217\7684\8CC7\6599\6B04</li>'),
unistr('<li>\8207\8981\57F7\884C\51FD\6578 (average\3001sum\3001count \7B49\7B49) \805A\7E3D\7684\8CC7\6599\6B04</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115994851097402954)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\60A8\81EA\8A02\4E92\52D5\5F0F\5831\8868, \5831\8868\8A2D\5B9A\503C\6703\986F\793A\5728\300C\641C\5C0B\300D\5217\4E0B\65B9\548C\5831\8868\7684\4E0A\65B9.'),
unistr('\60A8\53EF\4EE5\4F7F\7528\5DE6\908A\7684\5716\793A\96B1\85CF\53CA\5C55\958B\6B64\5340\57DF.'),
'<p>',
unistr('\60A8\53EF\4EE5\5C0D\6BCF\4E00\500B\5831\8868\8A2D\5B9A\57F7\884C\4E0B\5217\4F5C\696D:'),
'</p><ul>',
unistr('<li>\6309\4E00\4E0B\540D\7A31\4F86\7DE8\8F2F\67D0\9805\8A2D\5B9A\503C.</li>'),
unistr('<li>\53D6\6D88\52FE\9078\6216\52FE\9078\300C\555F\7528/\505C\7528\300D\6838\53D6\65B9\584A, \4EE5\505C\7528/\555F\7528\67D0\9805\8A2D\5B9A\503C. \60A8\53EF\4EE5\4F7F\7528\6B64\63A7\5236\9805\66AB\6642\95DC\9589\548C\958B\555F\67D0\9805\8A2D\5B9A\503C.</li>'),
unistr('<li>\6309\4E00\4E0B\300C\79FB\9664\300D\5716\793A, \4EE5\79FB\9664\67D0\9805\8A2D\5B9A\503C.</li>'),
'</ul>',
unistr('<p>\5982\679C\60A8\5DF2\7D93\5EFA\7ACB\5716\8868\3001\7FA4\7D44\4F9D\64DA\6216\6A1E\7D10\5206\6790\8868, \53EF\4EE5\4F7F\7528\53F3\65B9\986F\793A\7684\300C\5831\8868\6AA2\8996\300D\3001'),
unistr('\300C\5716\8868\6AA2\8996\300D\3001\300C\7FA4\7D44\4F9D\64DA\6AA2\8996\300D\548C\300C\6A1E\7D10\5206\6790\8868\6AA2\8996\300D\9023\7D50, \5728\5B83\5011\8207\57FA\672C\5831\8868\4E4B\9593'),
unistr('\5207\63DB. \5982\679C\60A8\6AA2\8996\5716\8868\3001\7FA4\7D44\4F9D\64DA\6216\6A1E\7D10\5206\6790\8868, \4E5F\53EF\4EE5\4F7F\7528\300C\7DE8\8F2F\300D\9023\7D50\4F86\7DE8\8F2F'),
unistr('\8A2D\5B9A\503C.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115984390737402946)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5831\8868\91CD\8A2D\70BA\9810\8A2D\503C, \79FB\9664\4E4B\524D\8A2D\5B9A\7684\81EA\8A02\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116045678893402992)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A2D\5B9A\6BCF\9801\6240\8981\986F\793A\7684\8A18\9304\6578\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115984243164402946)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5132\5B58\81EA\8A02\5831\8868\4F9B\672A\4F86\4F7F\7528. \59B3\9700\8981\63D0\4F9B\540D\7A31\548C\9078\64C7\6027\7684\63CF\8FF0, \4E5F\53EF\4EE5\8B93\5831\8868\53EF\4F9B\516C\958B\5B58\53D6 (\4EA6\5373, \80FD\5920\5B58\53D6\4E3B\8981\9810\8A2D\5831\8868\7684\6240\6709\4F7F\7528\8005). \60A8\53EF\4EE5\5132\5B58\56DB\7A2E\985E\578B\7684\4E92\52D5\5F0F\5831\8868:</p>'),
'<ul>',
unistr('<li><strong>\4E3B\8981\9810\8A2D</strong> (\50C5\9650\958B\767C\4EBA\54E1).\300C\4E3B\8981\9810\8A2D\300D\662F\4E00\958B\59CB\986F\793A\7684\5831\8868.\300C\4E3B\8981\9810\8A2D\300D\5831\8868\4E0D\53EF\91CD\65B0\547D\540D\6216\52A0\4EE5\522A\9664.</li>'),
unistr('<li><strong>\66FF\4EE3\5831\8868</strong> (\50C5\9650\958B\767C\4EBA\54E1). \53EF\8B93\958B\767C\4EBA\54E1\5EFA\7ACB\591A\500B\5831\8868\7248\9762\914D\7F6E. \53EA\6709\958B\767C\4EBA\54E1\80FD\5920\5132\5B58\3001\91CD\65B0\547D\540D\6216\522A\9664\300C\66FF\4EE3\5831\8868\300D.</li>'),
unistr('<li><strong>\516C\7528\5831\8868</strong> (\4E00\822C\4F7F\7528\8005). \53EF\7531\5EFA\7ACB\5831\8868\7684\4E00\822C\4F7F\7528\8005\5132\5B58\3001\91CD\65B0\547D\540D\6216\522A\9664. \5176\4ED6\4F7F\7528\8005\53EF\4EE5\6AA2\8996\4EE5\53CA\5C07\7248\9762\914D\7F6E\53E6\5B58\70BA\53E6\4E00\4EFD\5831\8868.</li>'),
unistr('<li><strong>\5C08\7528\5831\8868</strong> (\4E00\822C\4F7F\7528\8005). \53EA\6709\5EFA\7ACB\5831\8868\7684\4E00\822C\4F7F\7528\8005\53EF\4EE5\6AA2\8996\3001\5132\5B58\3001\91CD\65B0\547D\540D\6216\522A\9664\5831\8868.</li>'),
'</ul>',
unistr('<p>\82E5\60A8\5132\5B58\81EA\8A02\5831\8868, \6703\5728\300C\641C\5C0B\300D\5217\4E2D\300C\8CC7\6599\5217\300D\9078\53D6\5668 (\82E5\555F\7528\6B64\529F\80FD) \7684\5DE6\908A\986F\793A\300C\5831\8868\300D\9078\53D6\5668.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115983264534402945)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\500B\5831\8868\9801\9762\7684\9802\7AEF\90FD\6709\4E00\500B\641C\5C0B\5340\57DF. \6B64\5340\57DF (\6216\300C\641C\5C0B\300D\5217) \63D0\4F9B\4E0B\5217\529F\80FD:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116046296197402992)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<li><strong>\52D5\4F5C\529F\80FD\8868</strong>: \53EF\4F9B\81EA\8A02\5831\8868. \8ACB\53C3\95B1\5F8C\9762\7684\6BB5\843D.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116045777054402992)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<li><strong>\9078\53D6\8CC7\6599\6B04\5716\793A</strong>: \53EF\6307\5B9A\8981\641C\5C0B\7684\8CC7\6599\6B04 (\6216\5168\90E8\8CC7\6599\6B04).</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116046067824402992)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<li><strong>\5831\8868</strong>: \986F\793A\66FF\4EE3\9810\8A2D\503C\4EE5\53CA\9810\5B58\7684\5C08\7528\6216\516C\7528\5831\8868.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116045947986402992)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<li><strong>\8CC7\6599\5217</strong>: \8A2D\5B9A\6BCF\9801\6240\8981\986F\793A\7684\8A18\9304\6578\76EE.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116045808299402992)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>\6587\5B57\5340</strong>: \53EF\4F9B\60A8\8F38\5165\4E0D\5340\5206\5927\5C0F\5BEB\7684\641C\5C0B\689D\4EF6 (\6703\81EA\52D5\4F7F\7528\842C\7528\5B57\5143).</li>'),
unistr('<li><strong>\57F7\884C\6309\9215</strong>: \57F7\884C\641C\5C0B. \5982\679C\6E38\6A19\5728\641C\5C0B\6587\5B57\5340\4E2D, \5247\6309 Enter \9375\4E5F\6703\57F7\884C\641C\5C0B.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116046110322402992)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<li><strong>\6AA2\8996\5716\793A</strong>: \53EF\5728\5831\8868\7684\5DF2\5B9A\7FA9\5716\793A\3001\5831\8868\3001\8A73\7D30\8CC7\8A0A\3001\5716\8868\3001\7FA4\7D44\4F9D\64DA\8207\6A1E\7D10\5206\6790\8868\6AA2\8996\4E4B\9593\5207\63DB.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116062146275403004)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('<li><strong>\7BA1\7406</strong>: \53EF\7BA1\7406\7279\6027\3001\8CC7\6599\6B04\3001\8CC7\6599\5217\4EE5\53CA\6AA2\8996\5831\8868\6216\8CC7\6599\65B9\683C\7684\6B77\53F2\8A18\9304.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115983475764402945)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7528\4EE5\4FEE\6539\986F\793A\7684\8CC7\6599\6B04. \6703\986F\793A\5728\53F3\65B9\7684\8CC7\6599\6B04. \5728\5DE6\65B9\7684\8CC7\6599\6B04\5247\6703\96B1\85CF\8D77\4F86. \60A8\53EF\4EE5\4F7F\7528\6700\53F3\65B9\7684\7BAD\982D\91CD\65B0\6392\5217\986F\793A\7684\8CC7\6599\6B04. \7D93\904E\904B\7B97\7684\8CC7\6599\6B04\524D\9762\6703\52A0\4E0A <strong>**</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115983612356402945)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7528\4EE5\8B8A\66F4\6392\5E8F\7684\8CC7\6599\6B04\53CA\6C7A\5B9A\662F\6309\905E\589E\6216\905E\6E1B\9806\5E8F'),
unistr('\6392\5E8F. \60A8\4E5F\53EF\4EE5\6307\5B9A\8655\7406 <code>NULL</code> \7684\65B9\5F0F.'),
unistr('\9810\8A2D\70BA\4E00\5F8B\5728\6700\5F8C\9762\6216\4E00\5F8B\5728\6700\524D\9762\986F\793A <code>NULL</code>.'),
unistr('\6392\5E8F\7D50\679C\6703\986F\793A\5728\5831\8868\4E2D\8CC7\6599\6B04\6A19\984C\7684\53F3\65B9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116043382970402990)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E\8A02\95B1\6642, \60A8\9700\8981\63D0\4F9B\96FB\5B50\90F5\4EF6\5730\5740 (\82E5\6709\591A\500B\96FB\5B50\90F5\4EF6\5730\5740, \4F7F\7528\9017\865F\5340\9694)\3001\96FB\5B50\90F5\4EF6\4E3B\65E8\3001\983B\7387\4EE5\53CA\958B\59CB\548C\7D50\675F\65E5\671F. \7522\751F\7684\96FB\5B50\90F5\4EF6\6703\5305\62EC\4E00\500B\5176\4E2D\5305\542B\76EE\524D\8CC7\6599\4E4B HTML \7248\672C\7684\4E92\52D5\5F0F\5831\8868 (\4F7F\7528\65B0\589E\8A02\95B1\6642\7684\5831\8868\8A2D\5B9A).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116061939537403004)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8CC7\6599\65B9\683C\57FA\672C\4E0A\662F\53EF\9AD8\5EA6\81EA\8A02\7684\53EF\7DE8\8F2F\5831\8868. \4F7F\7528\8005\53EF\4EE5\9078\53D6\60F3\8981\7684\8CC7\6599\6B04, \4E26\7BE9\9078\3001\6A19\793A\4EE5\53CA\6392\5E8F, \4EE5\66F4\6539\5831\8868\8CC7\6599\7684\7248\9762\914D\7F6E. \4E5F\53EF\4EE5\5B9A\7FA9\5206\6BB5\3001\805A\7E3D\3001\5716\8868\3001\7FA4\7D44\65B9\5F0F\4EE5\53CA\65B0\589E\81EA\5DF1\7684\904B\7B97. \4F7F\7528\8005\53EF\4EE5\5EFA\7ACB\591A\7A2E\4E0D\540C\7684\5831\8868, \4E26\5132\5B58\70BA\5177\540D\5831\8868, \4F9B\79C1\4EBA\6AA2\8996\4E4B\7528. '),
'<p/>',
unistr('\60A8\53EF\4EE5\4F7F\7528\641C\5C0B\5217\3001\52D5\4F5C\529F\80FD\8868\3001\7BA1\7406\529F\80FD\8868\6216\8CC7\6599\6B04\6A19\984C\529F\80FD\8868\4F86\81EA\8A02\8CC7\6599\65B9\683C.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116073793544403013)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\52D5\4F5C\300D\529F\80FD\8868\6703\986F\793A\5728\300C\641C\5C0B\300D\5217\4E2D\300C\57F7\884C\300D\6309\9215\7684\53F3\908A. \60A8\53EF\4EE5\4F7F\7528\6B64\529F\80FD\8868\4F86\81EA\8A02\8CC7\6599\65B9\683C\5831\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116062441398403005)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\589E / \7DE8\8F2F\8CC7\6599\5217\9801\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116062501497403005)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\82E5\8981\65B0\589E\8CC7\6599\5217\81F3\8CC7\6599\65B9\683C, \8ACB\6309\4E00\4E0B\300C\65B0\589E\8CC7\6599\5217\300D. \82E5\8981\7DE8\8F2F\67D0\500B\8CC7\6599\5217\7684\8A73\7D30\8CC7\8A0A, \8ACB\6309\4E00\4E0B\60A8\8981\7DE8\8F2F\4E4B\8CC7\6599\5217\7684\7DE8\8F2F\8CC7\6599\5217\5716\793A (\7B2C\4E00\500B\8CC7\6599\6B04). \5C07\6703\986F\793A\300C\65B0\589E/\7DE8\8F2F\8CC7\6599\5217\300D\9801\9762, \5176\4E2D\986F\793A\8CC7\6599\65B9\683C\7684\8CC7\6599\6B04. </p>'),
'',
unistr('<p>\7DE8\8F2F\8CC7\6599\5217\6642, \60A8\53EF\4EE5\57F7\884C\4E0B\5217\52D5\4F5C:</p>'),
'',
'<p><ul>',
unistr('<li><strong>\522A\9664</strong>\8CC7\6599\5217.</li>'),
unistr('<li><strong>\5957\7528\8B8A\66F4</strong>, \5132\5B58\5C0D\8CC7\6599\5217\6240\505A\7684\8B8A\66F4.</li>'),
unistr('<li>\5728<strong>\52D5\4F5C</strong>\5167, \65B0\589E\8CC7\6599\5217, \65B0\589E\6A94\6848\3001\9644\8A3B\3001\9023\7D50\6216\6A19\8A18, \4EE5\53CA\8907\67E5\6B77\53F2\8A18\9304.</li>'),
unistr('<li>\5C0E\89BD<strong>\4E0B\4E00\500B\548C\4E0A\4E00\500B</strong>\8CC7\6599\5217.</li>'),
unistr('<li>\5728<strong>\7BA1\7406</strong>\5167, \8A2D\5B9A\8CC7\6599\6B04\7279\6027\3001\8CC7\6599\6B04\7FA4\7D44\3001\9A57\8B49\4EE5\53CA\503C\6E05\55AE.</li>'),
'</ul></p>',
'',
unistr('<p>\9801\9762\5E95\7AEF\7684\300C\8A3B\89E3\300D\5340\57DF\5C07\6703\986F\793A\8207\76EE\524D\8CC7\6599\5217\95DC\806F\7684\6240\6709\6A94\6848\3001\9644\8A3B\3001\9023\7D50\6216\6A19\8A18.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116073862787403013)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91DD\5C0D\4E00\6216\6578\500B\8CC7\6599\6B04\5EFA\7ACB\5206\7D44. \9019\53EF\5C07\8CC7\6599\65B9\683C\7684\8CC7\6599\6B04\986F\793A\70BA\4E3B\8981\8A18\9304.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116062333696403004)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8B93\76EE\524D\7684\7D50\679C\96C6\53EF\4F9B\4E0B\8F09, \4E0B\8F09\683C\5F0F'),
unistr('\5305\62EC CSV\3001HTML \6216\96FB\5B50\90F5\4EF6.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116073969477403013)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\60A8\81EA\8A02\8CC7\6599\65B9\683C\5831\8868, \5831\8868\8A2D\5B9A\503C\6703\986F\793A\5728\300C\641C\5C0B\300D\5217\4E0B\65B9,'),
unistr('\5831\8868\7684\4E0A\65B9. \60A8\53EF\4EE5\4F7F\7528\5DE6\908A\7684\5716\793A\96B1\85CF\53CA\986F\793A\6B64\5340\57DF.'),
'<p>',
unistr('\60A8\53EF\4EE5\5C0D\6BCF\4E00\9805\5831\8868\8A2D\5B9A\57F7\884C\4E0B\5217\4F5C\696D:'),
'</p><ul>',
unistr('<li>\6309\4E00\4E0B\540D\7A31\4F86\7DE8\8F2F\67D0\9805\8A2D\5B9A.</li>'),
unistr('<li>\53D6\6D88\52FE\9078\6216\52FE\9078\300C\555F\7528/\505C\7528\300D\6838\53D6\65B9\584A, \505C\7528/\555F\7528\67D0\9805\8A2D\5B9A. \60A8\53EF\4EE5\4F7F\7528\6B64\63A7\5236\9805\66AB\6642\95DC\9589\53CA\958B\555F\67D0\9805\8A2D\5B9A.</li>'),
unistr('<li>\6309\4E00\4E0B\300C\79FB\9664\300D\5716\793A, \79FB\9664\67D0\9805\8A2D\5B9A.</li>'),
'</ul>',
unistr('<p>\5982\679C\60A8\5DF2\7D93\5EFA\7ACB\5716\8868\6216\7FA4\7D44\4F9D\64DA, \53EF\4EE5\4F7F\7528\53F3\65B9\7684\300C\5831\8868\6AA2\8996\300D\3001'),
unistr('\300C\5716\8868\6AA2\8996\300D\4EE5\53CA\300C\7FA4\7D44\4F9D\64DA\6AA2\8996\300D\9023\7D50, \5728\5B83\5011\8207\57FA\672C\5831\8868\4E4B\9593'),
unistr('\505A\5207\63DB. \5728\6AA2\8996\5716\8868\6216\7FA4\7D44\4F9D\64DA\6642, \4E5F\53EF\4EE5\4F7F\7528\300C\7DE8\8F2F\300D\9023\7D50'),
unistr('\4F86\7DE8\8F2F\8A2D\5B9A\503C.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116062261167403004)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5132\5B58\81EA\8A02\7684\8CC7\6599\65B9\683C\5831\8868\7248\9762\914D\7F6E, \4F9B\672A\4F86\4F7F\7528. \60A8\9700\8981\63D0\4F9B\540D\7A31\548C\9078\64C7\6027\7684\63CF\8FF0. \60A8\53EF\4EE5\5132\5B58\4E09\7A2E\985E\578B\7684\8CC7\6599\65B9\683C\5831\8868\7248\9762\914D\7F6E:</p>'),
'<ul>',
unistr('<li><strong>\4E3B\8981\9810\8A2D</strong> (\50C5\9650\7BA1\7406\54E1).\300C\4E3B\8981\9810\8A2D\300D\662F\4E00\958B\59CB\986F\793A\7684\7248\9762\914D\7F6E. \300C\4E3B\8981\9810\8A2D\300D\5831\8868\4E0D\53EF\91CD\65B0\547D\540D\6216\52A0\4EE5\522A\9664.</li>'),
unistr('<li><strong>\66FF\4EE3\5831\8868</strong> (\50C5\9650\7BA1\7406\54E1). \53EF\8B93\7BA1\7406\54E1\5EFA\7ACB\591A\500B\5831\8868\7248\9762\914D\7F6E. \53EA\6709\7BA1\7406\54E1\80FD\5920\5132\5B58\3001\91CD\65B0\547D\540D\6216\522A\9664\300C\66FF\4EE3\5831\8868\300D.</li>'),
unistr('<li><strong>\5C08\7528\5831\8868</strong> (\6240\6709\4F7F\7528\8005). \5EFA\7ACB\5831\8868\7248\9762\914D\7F6E\7684\4F7F\7528\8005\53EF\4EE5\6AA2\8996\3001\5132\5B58\3001\91CD\65B0\547D\540D\6216\522A\9664\5831\8868.</li>'),
'</ul>',
unistr('<p>\82E5\60A8\5132\5B58\81EA\8A02\5831\8868, \6703\5728\300C\641C\5C0B\300D\5217\4E2D\300C\8CC7\6599\5217\300D\9078\53D6\5668 (\82E5\555F\7528\6B64\529F\80FD) \7684\5DE6\908A\986F\793A\300C\5831\8868\300D\9078\53D6\5668.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115988376617402949)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115978934637402942)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115989802747402950)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115994976707402954)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\793A\689D\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116043975456402991)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\793A\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115953930398402924)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\793A\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116063402604403005)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C34\5E73')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116093074198403027)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('1 \500B\975E\4F5C\7528\4E2D\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116093158389403028)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\975E\4F5C\7528\4E2D\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115984929565402946)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E92\52D5\5F0F\5831\8868\8AAA\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115995994327402954)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115989370429402950)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\904B\7B97\8868\793A\5F0F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115948734243402920)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\65E5\671F\5FC5\9808\665A\65BC\958B\59CB\65E5\671F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116003637145402960)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\7BE9\9078\8868\793A\5F0F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116071466172403011)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\7BE9\9078\67E5\8A62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116093276737403028)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('1 \500B\7121\6548\7684\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116093303498403028)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\7121\6548\7684\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116044183363402991)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\5206\9418)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116061144108403003)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\524D %1 \4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116061306667403004)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728\5F8C %1 \4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116061204193403004)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\524D %1 \4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116061493447403004)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E0D\5728\5F8C %1 \4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115994071554402953)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9375\53F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115960128133402928)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115987957837402949)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64\7684\5EA7\6A19\8EF8\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115980441078402943)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D 1 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115980680645402943)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D 1 \5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115980137200402943)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D 1 \500B\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115980243417402943)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D 1 \9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115980323085402943)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D %0 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115980529498402943)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D %0 \5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115979957982402943)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D %0 \5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115980041269402943)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\524D 1 \5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115960022895402928)
,p_name=>'APEXIR_LINE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6298\7DDA\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115956829375402926)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6298\7DDA\5340\57DF\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116071349253403011)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E6A\88FD\5730\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115988800169402949)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\8A62\9810\4F30\6703\8D85\904E\5141\8A31\7684\8CC7\6E90\4E0A\9650.  \8ACB\4FEE\6539\60A8\7684\5831\8868\8A2D\5B9A\503C, \7136\5F8C\518D\8A66\4E00\6B21.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115971056483402936)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\5831\8868\7684\8CC7\6599\5217\6578\76EE\4E0A\9650\70BA %0 \500B\8CC7\6599\5217.  \8ACB\5957\7528\7BE9\9078\4F86\6E1B\5C11\60A8\67E5\8A62\4E2D\7684\8A18\9304\6578\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116071979260403012)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5927\503C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116072130968403012)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E2D\9593\503C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115975048250402939)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5206\9418\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116072064240403012)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5C0F\503C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116071061020403011)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116044541752402991)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115987151323402948)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115987088115402948)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116098201521403031)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5305\542B\591A\500B\4E92\52D5\5F0F\5831\8868, \56E0\6B64\5FC5\9808\6307\5B9A\5340\57DF\975C\614B ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115955510025402925)
,p_name=>'APEXIR_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115982905250402945)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA\805A\7E3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116093942298403028)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\985E\5225')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115983013144402945)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA\904B\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115977810686402941)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115980965080402944)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C 1 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115980772514402943)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C 1 \5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115981274838402944)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C 1 \500B\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115981199002402944)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C 1 \9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115981009629402944)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C %0 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115980877836402943)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C %0 \5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115981473135402944)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C %0 \5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115981352371402944)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F8C 1 \5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115955836264402925)
,p_name=>'APEXIR_NO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115996175738402955)
,p_name=>'APEXIR_NONE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \7121 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116043793258402991)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\662F\6709\6548\7684\96FB\5B50\90F5\4EF6\5730\5740.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115992604546402952)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\503C\4E00\5F8B\986F\793A\5728\6700\524D\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115992510911402952)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\503C\4E00\5F8B\986F\793A\5728\6700\5F8C\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115993004150402952)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\503C\6392\5E8F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115989449067402950)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5012\6EAF\6642\9593\5FC5\9808\662F\6578\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115989051730402949)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9806\5E8F\5FC5\9808\662F\6578\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115993576380402953)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97\5B50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115954471350402924)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A58\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116063376677403005)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115956358240402925)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5176\4ED6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115939159786402913)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115939814167402914)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A6B\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115939969944402914)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F4\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115939093220402913)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115939679163402913)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'zh-tw'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115939562582402913)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'zh-tw'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115939797822402914)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115939394583402913)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'zh-tw'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115939287528402913)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'zh-tw'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115939466841402913)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'zh-tw'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116072410483403012)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\8A08\6578\767E\5206\6BD4 %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116071626969403011)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\548C\767E\5206\6BD4 %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116070685149403011)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\8A08\6578\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116070561908403011)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\548C\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115959926342402928)
,p_name=>'APEXIR_PIE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5713\9905\5716')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116019825395402973)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A1E\7D10\5206\6790\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116021307394402974)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\805A\7E3D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116021597697402974)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\4E0D\80FD\5C0D\88AB\9078\53D6\4F5C\70BA\8CC7\6599\5217\8CC7\6599\6B04\7684\8CC7\6599\6B04\57F7\884C\805A\7E3D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116020710996402973)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A1E\7D10\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116020588037402973)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A1E\7D10\8CC7\6599\6B04 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116021123778402974)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\6A1E\7D10\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115921275935402900)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\6A1E\7D10\5206\6790\8868\300D\67E5\8A62\7684\8CC7\6599\5217\8A08\6578\4E0A\9650\9650\5236\7684\662F\57FA\790E\67E5\8A62\4E2D\7684\8CC7\6599\5217\6578\76EE, \800C\4E0D\662F\9650\5236\986F\793A\7684\8CC7\6599\5217\6578\76EE. \60A8\7684\57FA\790E\67E5\8A62\8D85\51FA\8CC7\6599\5217\8A08\6578\4E0A\9650 (%0 \500B\8CC7\6599\5217). \8ACB\5957\7528\7BE9\9078\4EE5\6E1B\5C11\60A8\57FA\790E\67E5\8A62\4E2D\7684\8A18\9304\6578\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116021026126402974)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A1E\7D10\5206\6790\8868\6392\5E8F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115990469022402950)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A1E\7D10\5206\6790\8868\8CC7\6599\6B04\5305\542B\592A\591A\4E0D\540C\7684\503C - \7121\6CD5\7522\751F\6A1E\7D10\5206\6790\8868 SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116043813349402991)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\89BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115977983541402941)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116069536378403010)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116044880216402991)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115938935757402913)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5305\62EC\8F14\52A9\529F\80FD\6A19\8A18')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115925887974402904)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664 Rich Text \683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116002677172402959)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C08\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115960504749402928)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\516C\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115956108102402925)
,p_name=>'APEXIR_RED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D05\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116098169992403031)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\975C\614B ID %0 \4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115987234383402948)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115987306298402948)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8\79FB\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116093461997403028)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115986845556402948)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664\63A7\5236\5206\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115986594321402948)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115986623656402948)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664\5012\6EAF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116093543209403028)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664\7FA4\7D44\4F9D\64DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115986954640402948)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664\6A19\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116093692840403028)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664\6A1E\7D10\5206\6790\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116074659976403013)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\9664\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116055294001402999)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\547D\540D\9810\8A2D\5831\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115996481445402955)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\65B0\547D\540D\5831\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115978293620402942)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116072585942403012)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115952779695402923)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5225\540D\70BA %0 \7684\300C\9810\5B58\4E92\52D5\5F0F\300D\5831\8868\4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116002971873402960)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115952828048402923)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\9810\5B58\4E92\52D5\5F0F\5831\8868\300DID %0 \4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115994770917402954)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115975540106402940)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115979479997402942)
,p_name=>'APEXIR_RESET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115960722915402928)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\5831\8868\56DE\5FA9\6210\9810\8A2D\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115955984020402925)
,p_name=>'APEXIR_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116068607261403009)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\4E0D\80FD\4F7F\7528 ROWID \4F5C\70BA REST \8CC7\6599\4F86\6E90\7684\4E3B\7D22\5F15\9375\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115985900309402947)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116045522317402992)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\9801\8CC7\6599\5217\6578')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116020821299402973)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116020633280402973)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\8CC7\6599\6B04 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116021231307402974)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\8CC7\6599\5217\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116021418064402974)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\8CC7\6599\6B04\5FC5\9700\8207\6A1E\7D10\8CC7\6599\6B04\4E0D\540C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116000021139402957)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\7BE9\9078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115975631518402940)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7B2C %0 \500B\8CC7\6599\5217, \5171 %1 \500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115979632027402943)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\6587\5B57\5305\542B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115955260605402925)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115990062046402950)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\5B58\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115989971084402950)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\5B58\5831\8868 = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115992117467402952)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\5831\8868\8A2D\5B9A\503C\5C07\6210\70BA\6240\6709\4F7F\7528\8005\7684\9810\8A2D\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116055175869402999)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\9810\8A2D\5831\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115979390841402942)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\5831\8868')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116093874179403028)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58\5831\8868 *')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116046510695402993)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115984893686402946)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116093712315403028)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116052076174402997)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116036091258402985)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\7684\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115956901324402926)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \9078\53D6\8CC7\6599\6B04 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115978697765402942)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8CC7\6599\6B04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115960436403402928)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \9078\53D6\51FD\6578 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115985604785402947)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \4F9D\8CC7\6599\6B04\9078\53D6\7FA4\7D44 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116020354939402973)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \9078\53D6\6A1E\7D10\8CC7\6599\6B04 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116071513570403011)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116020463437402973)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('- \9078\53D6\8CC7\6599\5217\8CC7\6599\6B04 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115929159270402906)
,p_name=>'APEXIR_SEND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\50B3\9001')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115935468125402910)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EE5\96FB\5B50\90F5\4EF6\50B3\9001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115955698370402925)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115978812165402942)
,p_name=>'APEXIR_SORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5E8F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115988195849402949)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\905E\589E\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115988262572402949)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\905E\6E1B\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116074055373403013)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6392\5E8F\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115982656305402945)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7A7A\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115993740053402953)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\72C0\614B %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116044296665402991)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116070998355403011)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\675F\65BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115925336406402903)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\8CC7\6599\6642\7565\904E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116070835565403011)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\65BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116071748175403011)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\548C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116061793262403004)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF = %0, \5831\8868 = %1, \6AA2\8996 = %2, \986F\793A\7684\8CC7\6599\5217\958B\982D = %3, \986F\793A\7684\8CC7\6599\5217\7D50\5C3E = %4, \8CC7\6599\5217\7E3D\6578 = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115982314121402945)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF = %0, \5831\8868 = %1, \6AA2\8996 = %2, \986F\793A\7684\8CC7\6599\5217\958B\982D = %3, \986F\793A\7684\8CC7\6599\5217\7D50\5C3E = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115954598698402924)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6587\5B57\8272\5F69')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115971671016402937)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115971581631402937)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115971455621402937)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\9418')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115971803408402937)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\500B\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115971768058402937)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115971909291402937)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116074426031403013)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5207\63DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115987478591402948)
,p_name=>'APEXIR_TOP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9802\7AEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116067652474403008)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5206\7D44\7684\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115988959682402949)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\6A19\793A\540D\7A31\300D\5FC5\9808\662F\552F\4E00\7684.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115959271218402927)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\652F\63F4\7684\8CC7\6599\985E\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115987506301402948)
,p_name=>'APEXIR_UP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\79FB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115989146799402950)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\8F38\5165\6709\6548\7684\8272\5F69.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115989243950402950)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\8F38\5165\6709\6548\7684\683C\5F0F\906E\7F69.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115956410120402925)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115988001933402949)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\503C\7684\5EA7\6A19\8EF8\6A19\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115995846278402954)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\8F38\5165\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115959858299402928)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5782\76F4\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116063535535403005)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5782\76F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115995160509402954)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\5716\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116050324944402995)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\8A73\7D30\8CC7\8A0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116095922543403030)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\672A\5B9A\7FA9 %0 \6AA2\8996.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116050417562402996)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\7FA4\7D44\4F9D\64DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116050254052402995)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\5716\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116020112726402973)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\6A1E\7D10\5206\6790\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115995250713402954)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116044489830402991)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115978195718402942)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116073144737403012)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116073026955403012)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116072998605403012)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5206\9418')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116073393211403013)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116073240323403012)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116073431184403013)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116071152867403011)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115954221280402924)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9EC3\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115955793621402925)
,p_name=>'APEXIR_YES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115987887479402949)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5305\542B < \6216 > \7121\6548\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116010648662402966)
,p_name=>'APEX_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115938873707402913)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9055\53CD API \5148\6C7A\689D\4EF6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115958370539402927)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\53D6\5F97\61C9\7528\7A0B\5F0F\8A2D\5B9A\503C %0 \7684\503C, \56E0\70BA\95DC\806F\7684\7D44\5EFA\9078\9805\5DF2\505C\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115958200428402927)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A2D\5B9A\61C9\7528\7A0B\5F0F\8A2D\5B9A\503C %0 \7684\503C, \56E0\70BA\95DC\806F\7684\7D44\5EFA\9078\9805\5DF2\505C\7528.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116065986626403007)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8A2D\5B9A %0 \503C\7121\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116065854666403007)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5B9A\7FA9\8981\6C42\7684\61C9\7528\7A0B\5F0F\8A2D\5B9A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116066032803403007)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\8A2D\5B9A %0 \4E0D\53EF\8A2D\70BA\7A7A\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115946946867402919)
,p_name=>'BACK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8FD4\56DE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115933996648402909)
,p_name=>'BUILDER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7522\751F\5668')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115998072051402956)
,p_name=>'BUTTON LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215\6A19\7C64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115933096901402909)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\9215 CSS \985E\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115962275235402930)
,p_name=>'BUTTON_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7522\751F\7684\6309\9215 ID \5C07\662F\6309\9215\7684\300C\975C\614B ID\300D(\5982\679C\5B9A\7FA9), \6216\8005\82E5\672A\5B9A\7FA9\7684\8A71, \5C07\662F\683C\5F0F\70BA ''B'' || [\5167\90E8\6309\9215 ID] \7684\5167\90E8\7522\751F ID')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115925787901402904)
,p_name=>'CANDLESTICK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('K \7DDA\5716')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116007291958402963)
,p_name=>'CENTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7F6E\4E2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115957257315402926)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \8981\6C42')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115948606708402920)
,p_name=>'CHECK$'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\9078\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116067792966403008)
,p_name=>'CHECKED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\52FE\9078')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116043241135402990)
,p_name=>'COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116003794746402960)
,p_name=>'COMMENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A3B\89E3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115985222323402947)
,p_name=>'CONTINUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E7C\7E8C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115947251784402919)
,p_name=>'COPYRIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8457\4F5C\6B0A\6240\6709 &copy; %0, \4FDD\7559\4E00\5207\6B0A\5229.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115990955663402951)
,p_name=>'COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A08\6578')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115997663052402956)
,p_name=>'CREATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116049905915402995)
,p_name=>'CREATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116050029815402995)
,p_name=>'CREATED_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115974844248402939)
,p_name=>'CREATED_ON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\65E5\671F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115985402643402947)
,p_name=>'CUSTOM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115996605086402955)
,p_name=>'CUSTOMIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\81EA\8A02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115998238759402956)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\91CD\8A2D\4F7F\7528\8005 %0 \7684\9801\9762\504F\597D\8A2D\5B9A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115998310085402956)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\8B8A\66F4\4F7F\7528\8005 %0 \7684\504F\597D\8A2D\5B9A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115998186075402956)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\91CD\8A2D\4F7F\7528\8005 %0 \7684\9801\9762\504F\597D\8A2D\5B9A.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115961904663402929)
,p_name=>'DAILY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\65E5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115933550887402909)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\50B3\7684\6A94\6848\7121\6548, \6216\526F\6A94\540D\4E0D\6B63\78BA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115957440413402926)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\7684 XML \6216 JSON \9078\53D6\5668\7121\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115926732489402904)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8A2D\5B9A\6A94\548C\4E0A\50B3\7684\6A94\6848\672A\5305\542B\4EFB\4F55\76EE\6A19\8868\683C\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116012418706402967)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\4E0A\50B3\7684\6A94\6848\4E2D\627E\4E0D\5230\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116012502515402967)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\5DE5\4F5C\8868 "%0" \4E2D\627E\4E0D\5230\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115932349694402908)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\6A94\6848\4E0D\662F XLSX \6A94\6848.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115922758010402901)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\5B8C\6210: \5DF2\8655\7406 %0 \500B\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115923938924402902)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\5B8C\6210: \5DF2\8655\7406 %0 \500B\8CC7\6599\5217, \4F46\767C\751F 1 \500B\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115924217942402902)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\5B8C\6210: \5DF2\8655\7406 %0 \500B\8CC7\6599\5217, \4F46\767C\751F %1 \500B\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115924022889402902)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\5B8C\6210: \5DF2\8655\7406 1 \500B\8CC7\6599\5217.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115927063917402904)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\5B8C\6210: \5DF2\8655\7406 1 \500B\8CC7\6599\5217, \4F46\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115924127496402902)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\8F09\5165\5B8C\6210: \5DF2\8655\7406 1 \500B\8CC7\6599\5217, \4E14\7121\4EFB\4F55\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116017729527402971)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\6A19\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116017843786402971)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F86\6E90\8CC7\6599\6B04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116018682671402972)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F / \6578\5B57\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116082081408403019)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\64F7\53D6\67E5\5C0B\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116050589123402996)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599/\8868\683C\5C0D\61C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116018704581402972)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116014258523402968)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F49\63DB\898F\5247\5931\6557')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115990503680402951)
,p_name=>'DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65E5\671F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115964637303402931)
,p_name=>'DAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115964733905402931)
,p_name=>'DAYS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5929')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116003463272402960)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\61C9\7528\7A0B\5F0F\672A\555F\7528\9664\932F\529F\80FD.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116052242875402997)
,p_name=>'DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115965451447402932)
,p_name=>'DELETE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115925635261402903)
,p_name=>'DIAL_PCT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A08\91CF (\767E\5206\6BD4)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115940124295402914)
,p_name=>'DOWNLOAD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\8F09')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116051366172402996)
,p_name=>'DUP_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE\5167\6709\91CD\8907\7684\300C\4F7F\7528\8005\540D\7A31\300D.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115947703238402919)
,p_name=>'EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115957159951402926)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\96FB\5B50\90F5\4EF6\5730\5740 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115942299319402915)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\96FB\5B50\90F5\4EF6\662F\7531 %0 \6240\50B3\9001.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116051570315402996)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\96FB\5B50\90F5\4EF6\5730\5740\300D\592A\9577.  \9650\5236\70BA 240 \500B\5B57\5143.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115985193150402947)
,p_name=>'ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116014321385402968)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8A2D\5B9A\91CD\65B0\6574\7406\90E8\5206\9801\9762\5340\57DF\7684\9801\9762\9805\76EE\4F86\6E90\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115976620970402940)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5EFA\7ACB\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115942565222402916)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC\904E\671F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115936625039402911)
,p_name=>'FILE_EMPTY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A94\6848\662F\7A7A\7684.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116016813466402970)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\50B3\7684\6A94\6848\5927\5C0F\8D85\904E %0 MB. \8ACB\4E0A\50B3\8F03\5C0F\7684\6A94\6848.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115944617489402917)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\8A8D\8B49\5931\6557, \672A\4E0A\50B3\4E00\6216\591A\500B\6A94\6848.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115944783871402917)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\57F7\884C\8655\7406\4E0D\5141\8A31\672A\8A8D\8B49\7684\4F7F\7528\8005\4E0A\50B3\6A94\6848.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115997705461402956)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767C\751F 1 \500B\932F\8AA4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115996944012402955)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7D93\767C\751F %0 \500B\932F\8AA4')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115947147556402919)
,p_name=>'FORM_OF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0, \5171 %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115981877821402944)
,p_name=>'GO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116081631169403019)
,p_name=>'HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8AAA\660E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115934024775402909)
,p_name=>'HOME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9996\9801')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115964409344402931)
,p_name=>'HOUR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115964525205402931)
,p_name=>'HOURS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C0F\6642')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115948571910402920)
,p_name=>'ICON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\793A %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115998528411402956)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\767B\5165\8B49\660E\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116098009155403031)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\53C3\6578\503C: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115993299113402952)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53E6\5B58\70BA\9810\8A2D\5831\8868\8A2D\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115993334423402953)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\547D\540D\5F8C\5B58\70BA\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115975702725402940)
,p_name=>'IR_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \932F\8AA4. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115975427180402940)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5F9E\5C0E\89BD\904B\7B97. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115953051334402923)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\4E92\52D5\5F0F\5831\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115952464574402923)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F %0\3001\9801\9762 %1 \8207\5340\57DF %2 \4E2D\4E0D\5B58\5728\4E92\52D5\5F0F\5831\8868\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115993175486402952)
,p_name=>'IR_STAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\6709\958B\767C\4EBA\54E1\770B\5F97\5230')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115981559799402944)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\67E5\8A62\9700\8981\4F7F\7528\552F\4E00\7684\7D22\5F15\9375\4F86\8B58\5225\6BCF\500B\8CC7\6599\5217.  \6B64\7D22\5F15\7121\6CD5\4F7F\7528\63D0\4F9B\7684\7D22\5F15\9375.  \8ACB\5B9A\7FA9\552F\4E00\7684\7D22\5F15\9375\8CC7\6599\6B04. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115981691116402944)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\67E5\8A62\9700\8981\4F7F\7528\552F\4E00\7684\7D22\5F15\9375\4F86\8B58\5225\6BCF\500B\8CC7\6599\5217.  \6B64\7D22\5F15\7121\6CD5\4F7F\7528\63D0\4F9B\7684\7D22\5F15\9375.  \8ACB\7DE8\8F2F\5831\8868\5C6C\6027, \5B9A\7FA9\552F\4E00\7684\7D22\5F15\9375\8CC7\6599\6B04. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116018919542402972)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\6A94\6848')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116018831814402972)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\6A94\6848\62D6\653E\5230\6B64\8655, \6216')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115947403194402919)
,p_name=>'ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115976888681402941)
,p_name=>'ITEM_VALUE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115991224084402951)
,p_name=>'LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\7C64')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116003339108402960)
,p_name=>'LANGUAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A9E\8A00')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115965168920402932)
,p_name=>'LAST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904E\53BB')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115944520737402917)
,p_name=>'LENGTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9577\5EA6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115997808997402956)
,p_name=>'LOGIN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\5165')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116036478888402985)
,p_name=>'MANAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7BA1\7406')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116101086215403034)
,p_name=>'MAXIMIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\5927\5316')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115964234913402931)
,p_name=>'MINUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\9418')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115964384257402931)
,p_name=>'MINUTES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5206\9418')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116051729700402996)
,p_name=>'MISSING_AT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\96FB\5B50\90F5\4EF6\5730\5740\300D\4E2D\907A\6F0F "@".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116051919568402997)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A: \5C1A\672A\5728\61C9\7528\7A0B\5F0F %1 \4E2D\70BA\300C\5C0D\8A71\65B9\584A\300D\9801\9762 %0 \5B9A\7FA9\300C\5C0D\8A71\65B9\584A\9801\9762\300D\6A23\677F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116051605729402996)
,p_name=>'MISSING_DOT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\96FB\5B50\90F5\4EF6\5730\5740\300D\7DB2\57DF\4E2D\907A\6F0F ".".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116000844858402958)
,p_name=>'MODULE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A21\7D44')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115957957886402927)
,p_name=>'MONTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115961779872402929)
,p_name=>'MONTHLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115958064873402927)
,p_name=>'MONTHS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\500B\6708')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115990830921402951)
,p_name=>'MOVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116058399259403001)
,p_name=>'MOVE_FROM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\52D5\81EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116058487767403001)
,p_name=>'MOVE_TO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79FB\52D5\81F3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115978032349402941)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\522A\9664\591A\91CD\8CC7\6599\5217\4F5C\696D\767C\932F\8AA4: \8CC7\6599\5217= %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115977063625402941)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\80FD\662F\516C\7528\4F7F\7528\8005')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115934235443402910)
,p_name=>'NAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\540D\7A31')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115991016755402951)
,p_name=>'NEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115957759734402926)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\53EF\4EE5\524D\5F80\4E0B\5217\4F4D\5740\767B\5165 %0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115957872922402926)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0 %0 \5E33\6236\901A\77E5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116081827698403019)
,p_name=>'NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\500B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116000742406402958)
,p_name=>'NO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116096020837403030)
,p_name=>'NOBODY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6307\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115965598934402932)
,p_name=>'NOT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116006329787402962)
,p_name=>'NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\975E\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115977158365402941)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\662F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115996737623402955)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\8CC7\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116005865722402962)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\53EF\66F4\65B0\7684\5831\8868. \60A8\53EA\80FD\5728\985E\578B\70BA\300C\53EF\66F4\65B0\7684\5831\8868\300D\7684\5217\8868\5316\8868\55AE\57F7\884C\591A\91CD\8CC7\6599\5217\66F4\65B0\548C\522A\9664\4F5C\696D.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116006747112402963)
,p_name=>'OK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\78BA\5B9A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116002477402402959)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'zh-tw'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116099831751403033)
,p_name=>'ORA_06550'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ORA-06550: \884C %0, \8CC7\6599\6B04 %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116049327735402995)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\4E0D\652F\63F4\60A8\76EE\524D\4F7F\7528\7684 Web \700F\89BD\5668. \5982\9700\652F\63F4\7684\700F\89BD\5668\6E05\55AE, \8ACB\53C3\95B1 Oracle Application Express Installation Guide.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115950713826402921)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42\7684\4E00\7D44\8CC7\6599\5217\7121\6548, \5831\8868\7684\4F86\6E90\8CC7\6599\5DF2\7D93\904E\4FEE\6539.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115970858945402936)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\6709\6548\7684\9801\78BC, \4F8B\5982 p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115974467008402939)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115974531476402939)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0B\4E00\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115974607281402939)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115974799603402939)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\7D44')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116081780062403019)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\5206\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116012330278402967)
,p_name=>'PASSWORD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115957025448402926)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\7684 %0 \5BC6\78BC\5DF2\7D93\8B8A\66F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115946895501402919)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC\4E0D\7B26\5408\6B64\7DB2\7AD9\7684\5BC6\78BC\8907\96DC\6027\898F\5247.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115945912968402918)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\65B0\5BC6\78BC\8207\820A\5BC6\78BC\81F3\5C11\5FC5\9808\6709 %0 \500B\5B57\5143\4E0D\540C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115946594973402918)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC\4E0D\5F97\5305\542B\4F7F\7528\8005\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115946764072402918)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC\5305\542B\7981\6B62\4F7F\7528\7684\7C21\55AE\6587\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115946671158402918)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC\4E0D\5F97\5305\542B\5DE5\4F5C\5340\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115945855367402918)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC\81F3\5C11\5FC5\9808\8981\6709 %0 \500B\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115946097462402918)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC\81F3\5C11\5FC5\9808\5305\542B\4E00\500B\5B57\6BCD\5B57\5143 (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115946418958402918)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC\81F3\5C11\5FC5\9808\5305\542B\4E00\500B\5C0F\5BEB\5B57\6BCD\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115946196566402918)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC\81F3\5C11\5FC5\9808\5305\542B\4E00\500B\6578\5B57\5B57\5143 (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115946276622402918)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC\81F3\5C11\5FC5\9808\5305\542B\4E00\500B\6A19\9EDE\7B26\865F\5B57\5143 (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115946378190402918)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC\81F3\5C11\5FC5\9808\5305\542B\4E00\500B\5927\5BEB\5B57\6BCD\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115957522729402926)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC\91CD\8A2D\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115944844991402917)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC\7121\6CD5\4F7F\7528, \904E\53BB %0 \5167\5DF2\7528\904E\6B64\5BC6\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116025186084402977)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116025237602402977)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116002285763402959)
,p_name=>'PERCENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115972596683402937)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8ACB\6D3D\8A62\7BA1\7406\54E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116081918186403019)
,p_name=>'PREVIOUS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0A\4E00\500B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116017329634402971)
,p_name=>'PRINT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5217\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116001088148402958)
,p_name=>'PRIVILEGES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B0A\9650')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115970909165402936)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\53C3\7167')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115991177013402951)
,p_name=>'REPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116000928458402958)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\671F\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116082193245403019)
,p_name=>'REPORT_LABEL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116001641946402959)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5831\8868\7E3D\8A08')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115950868556402921)
,p_name=>'RESET'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D\5206\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115976709862402941)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D\5206\9801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116005793887402962)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D\5BC6\78BC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115982539768402945)
,p_name=>'RESTORE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\56DE\5FA9')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116014412559402968)
,p_name=>'RESULTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7D50\679C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116006866996402963)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8FD4\56DE\61C9\7528\7A0B\5F0F.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116007185756402963)
,p_name=>'RIGHT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9760\53F3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116036775893402985)
,p_name=>'ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115990743348402951)
,p_name=>'ROW_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217\8A08\6578')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116006258030402962)
,p_name=>'SAVE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5132\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116002879716402960)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66FF\4EE3\9810\8A2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116003279181402960)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63CF\8FF0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116002703732402960)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E3B\8981\9810\8A2D\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116003544400402960)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6709 %0 \500B\4EE5\4E0A\53EF\7528\7684\8CC7\6599\5217. \8ACB\589E\52A0\8CC7\6599\5217\9078\53D6\5668\4EE5\6AA2\8996\66F4\591A\8CC7\6599\5217.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116068978738403009)
,p_name=>'SEARCH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\641C\5C0B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115964138013402931)
,p_name=>'SECONDS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\79D2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116002341128402959)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\770B\9644\52A0\9805\76EE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116060058823403003)
,p_name=>'SELECT_ROW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\53D6\8CC7\6599\5217')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116002006755402959)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\87A2\5E55\52A9\8B80\7A0B\5F0F\6A21\5F0F\8A2D\70BA\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116002145001402959)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C07\87A2\5E55\52A9\8B80\7A0B\5F0F\6A21\5F0F\8A2D\70BA\958B\555F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115998404769402956)
,p_name=>'SHOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116061815054403004)
,p_name=>'SHOW_ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8\986F\793A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116087948930403023)
,p_name=>'SIGN_IN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116037581893402986)
,p_name=>'SIGN_OUT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767B\51FA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115991747287402951)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5929\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115998903678402957)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\73FE\5728\8D77 %0 \5929')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115991616645402951)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5C0F\6642\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115998869798402957)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\73FE\5728\8D77 %0 \5C0F\6642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115991538007402951)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5206\9418\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115998756964402957)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\73FE\5728\8D77 %0 \5206\9418')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115991934495402951)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \500B\6708\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115999143417402957)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\73FE\5728\8D77 %0 \500B\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115999382259402957)
,p_name=>'SINCE_NOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\525B\525B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115991453950402951)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \79D2\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115998636025402956)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\73FE\5728\8D77 %0 \79D2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115991828966402951)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \9031\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115999064481402957)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\73FE\5728\8D77 %0 \9031')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115992090750402952)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5E74\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115999261972402957)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5F9E\73FE\5728\8D77 %0 \5E74')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115985560174402947)
,p_name=>'STANDARD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\6E96')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116001992050402959)
,p_name=>'START_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\958B\59CB\65E5\671F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115942486675402915)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\6536\5230\7684\9019\5C01\96FB\5B50\90F5\4EF6, \662F\4F86\81EA %0 \5EFA\7ACB\7684\300C\4E92\52D5\5F0F\300D\5831\8868\8A02\95B1\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116097113299403031)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A02\95B1')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116045292836402992)
,p_name=>'TAB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\7C64')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115964086451402931)
,p_name=>'TITLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\984C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115947022112402919)
,p_name=>'TODAY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4ECA\5929')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116001504067402959)
,p_name=>'TOTAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7E3D\8A08')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115948032004402919)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6700\591A\53EF\4EE5\9078\53D6 %0 \500B\8CC7\6599\6B04.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115926584171402904)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8\96B1\85CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115926873037402904)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF\4E0B\65B9\6240\6709\9805\76EE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115926467114402904)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8\5C55\958B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115926655628402904)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C55\958B\4E0B\65B9\6240\6709\9805\76EE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115926931181402904)
,p_name=>'TREE.REPARENT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\91CD\8A2D\7236\9805')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116019147339402972)
,p_name=>'TREES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A39\72C0\7D50\69CB')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116062669350403005)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\8981')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115986251692402947)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6388\6B0A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116033050714402982)
,p_name=>'UNAVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\4F7F\7528')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115999744012402957)
,p_name=>'UNKNOWN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115943307980402916)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767C\751F\7121\6CD5\8FA8\8A8D\7684\8A8D\8B49\932F\8AA4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115945318514402917)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\4E0D\60F3\518D\6536\5230\96FB\5B50\90F5\4EF6, \8ACB\6309\4E00\4E0B<a href="%0">\53D6\6D88\8A02\95B1</a>\4EE5\7BA1\7406\60A8\7684\8A02\95B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115942383469402915)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\82E5\4E0D\60F3\518D\6536\5230\96FB\5B50\90F5\4EF6, \8ACB\81F3\4E0B\5217 URL \7BA1\7406\60A8\7684\8A02\95B1:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115977232320402941)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\652F\63F4\7684\8CC7\6599\985E\578B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115965304055402932)
,p_name=>'UPDATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115963989387402931)
,p_name=>'UPDATED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\6642\9593')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115970686457402936)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42\7684 URL \7981\6B62\4F7F\7528. \8ACB\6D3D\8A62\60A8\7684\7BA1\7406\54E1.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115990622929402951)
,p_name=>'USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116012237136402967)
,p_name=>'USERNAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116051874535402997)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\4F7F\7528\8005\540D\7A31\300D\592A\9577, \4E0D\53EF\8D85\904E %0 \500B\5B57\5143.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115997441073402956)
,p_name=>'USERS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116051400411402996)
,p_name=>'USER_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\4F7F\7528\8005\540D\7A31\300D\5DF2\7D93\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116066185842403007)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005 %0 \7684\8A2D\5B9A\6A94\5F71\50CF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115953754969402924)
,p_name=>'VALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6709\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115947322795402919)
,p_name=>'VALIDATIONS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9A57\8B49')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116003055106402960)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116046416104402993)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A %0 \7684\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115972962491402938)
,p_name=>'VERTICAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5782\76F4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115965209562402932)
,p_name=>'VIEW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115997509402402956)
,p_name=>'VIEWS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6AA2\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116003850488402960)
,p_name=>'VIEW_ALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5168\90E8\6AA2\8996')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115985020298402947)
,p_name=>'WARNING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8B66\544A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115964836934402931)
,p_name=>'WEEK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115961866546402929)
,p_name=>'WEEKLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6BCF\9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115964971693402931)
,p_name=>'WEEKS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9031')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116003116371402960)
,p_name=>'WELCOME_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B61\8FCE\4F7F\7528: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116001341400402958)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767C\73FE\7121\6548\7684\503C, \8ACB\6AA2\67E5\8F38\5165\7684\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116001455125402959)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767C\73FE\7121\6548\7684\503C, \8ACB\6AA2\67E5\8F38\5165\7684\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115944433533402917)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\5230\7121\6548\7684\65E5\671F\503C, \8ACB\6AA2\67E5\65E5\671F\683C\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116001230732402958)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767C\73FE\7121\6548\7684\6578\503C, \8ACB\6AA2\67E5\6578\5B57\683C\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115953357636402923)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\767C\73FE\7121\6548\7684\6642\6233\503C, \8ACB\6AA2\67E5\6642\6233\683C\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115975895981402940)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\9023\7D50 "%0". \8ACB\5728\591A\4F4D\5143\7D44\9805\76EE\4F7F\7528\96D9\5F15\865F, \6216\6AA2\67E5\9805\76EE\9577\5EA6\662F\5426\5728 30 \500B\4F4D\5143\7D44\4EE5\5167. \8ACB\4F7F\7528 v() \8A9E\6CD5\4F86\53C3\7167\8D85\904E 30 \500B\4F4D\5143\7D44\7684\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115966387989402933)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\88AB %0 \5B89\5168\6027\6AA2\67E5\62D2\7D55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115968812269402934)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\7121\6CD5\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115967263671402933)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1014 \627E\4E0D\5230\61C9\7528\7A0B\5F0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115967325344402933)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F=%0  \5DE5\4F5C\5340=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115967767826402933)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5B58\53D6\6B64\61C9\7528\7A0B\5F0F\6709\9650\5236, \8ACB\7A0D\5F8C\518D\8A66.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115967654384402933)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53EA\6709\61C9\7528\7A0B\5F0F\958B\767C\4EBA\54E1\624D\80FD\5B58\53D6\6B64\61C9\7528\7A0B\5F0F, \8ACB\7A0D\5F8C\518D\8A66.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115966881122402933)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-7744 \7121\6CD5\8655\7406\5206\652F\5230\50B3\56DE URL \7684\51FD\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115966798485402933)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-7744 \7121\6CD5\8655\7406\5206\652F\5230\50B3\56DE\9801\9762\7684\51FD\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115967064439402933)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1430 \4E0D\652F\63F4\5F9E\9801\9762\8655\7406\4F5C\696D\986F\793A\547C\53EB: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115968176790402934)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1018 \6E05\9664\6B65\9A5F\5FEB\53D6\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115966540811402933)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1005 \4E0D\660E\7684\904B\7B97\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115967493937402933)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1201 \672A\5728\81EA\8A02\8A8D\8B49\8A2D\5B9A\968E\6BB5\4F5C\696D ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115967516617402933)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115967167794402933)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-7620 \7121\6CD5\5224\65B7\61C9\7528\7A0B\5F0F\7684\5DE5\4F5C\5340 (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115949514810402920)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7DE8\8F2F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115966239265402932)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1802 \627E\4E0D\5230\9805\76EE id "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115965912592402932)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1002 \5728\61C9\7528\7A0B\5F0F "%1" \4E2D\627E\4E0D\5230\9805\76EE "%0" \7684 ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115966074299402932)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9810\671F\7684\932F\8AA4, \5728\61C9\7528\7A0B\5F0F\6216\9801\9762\5C64\7D1A\627E\4E0D\5230\9805\76EE\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115966400500402933)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5DF2\7D93\5728\7B2C\4E00\500B\8CC7\6599\9801\9762.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115981992604402944)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE ID (%0) \4E0D\662F\76EE\524D\9801\9762\4E2D\5B9A\7FA9\7684\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115944074405402917)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\900F\904E\5C07\5F15\6578\50B3\9001\81F3\61C9\7528\7A0B\5F0F\4F86\8A2D\5B9A\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115944340896402917)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('(\672A\63D0\4F9B\7E3D\548C\6AA2\9A57)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115943823260402916)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\82E5\642D\914D\300C\4F7F\7528\8005\5C64\7D1A\66F8\7C64\300D\7E3D\548C\6AA2\9A57, \5373\53EF\8A2D\5B9A\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115943727442402916)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\82E5\642D\914D\300C\61C9\7528\7A0B\5F0F\5C64\7D1A\66F8\7C64\300D\7E3D\548C\6AA2\9A57, \5373\53EF\8A2D\5B9A\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115943955103402916)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\82E5\642D\914D\300C\968E\6BB5\4F5C\696D\300D\7E3D\548C\6AA2\9A57, \5373\53EF\8A2D\5B9A\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115943692624402916)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9805\76EE\6C92\6709\4FDD\8B77.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115968200589402934)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6C92\6709\9801\9762\8AAA\660E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115957300551402926)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340 %0 \6C92\6709\5256\6790\65B9\5F0F\7DB1\8981 %1 \7684\6B0A\9650.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115966680516402933)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1010 \5DF2\7D93\8D85\904E\9023\7D50\5230\5206\652F\9801\9762\63A5\53D7\8655\7406\5FAA\74B0\9650\5236. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115944207375402917)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\4F7F\7528 URL \4F86\547C\53EB\6B64\9801\9762, \6216\4F7F\7528 GET \6216 POST \4F86\986F\793A\7A0B\5E8F, \5FC5\9808\4F7F\7528\300C\9023\7D50\5230\5206\652F\9801\9762\300D\5206\652F\985E\578B\4F86\547C\53EB\5B83.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116020978554402973)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5617\8A66\5728\9805\76EE %0 \4E2D\5132\5B58\975E\6578\503C\6642\767C\751F\932F\8AA4. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115959097400402927)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\4E2D\6C92\6709\61C9\7528\7A0B\5F0F\7684\5256\6790\7DB1\8981 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115959156322402927)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('INTERNAL \5DE5\4F5C\5340\4E2D\7684\5E33\6236\53EA\80FD\7528\65BC\5B58\53D6 &PRODUCT_NAME. <a href="%0">\7BA1\7406\670D\52D9</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115965890899402932)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-1029 \7121\6CD5\5132\5B58\968E\6BB5\4F5C\696D\8CC7\8A0A  \968E\6BB5\4F5C\696D=%0 \9805\76EE=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115968971915402934)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\505C\6B62\8FFD\8E64: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115966144354402932)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\9810\671F\7684\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115976158656402940)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('update_substitution_cache \767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115969054883402934)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\63D0\4F9B\61C9\7528\7A0B\5F0F\548C\9801\9762\624D\80FD\6AA2\8996\8AAA\660E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115989505136402950)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\81EA\52D5\5316.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115970170655402936)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\5C07 %0 \500B\968E\6BB5\4F5C\696D\6C38\4E45\6E05\9664.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115929494587402906)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\57F7\884C %0 \7A0B\5F0F\78BC! \8CC7\6599\5EAB\4E0D\652F\63F4\6216\57F7\884C\8655\7406\53C3\6578 MLE_LANGUAGES \672A\555F\7528\6B64\7A0B\5F0F\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115929209013402906)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8CC7\6599\5EAB\7248\672C\6C92\6709\591A\8A9E\8A00\5F15\64CE!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115950097182402921)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\96C6\5408\9663\5217\4E0D\80FD\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115949827239402921)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\6210\54E1\5C6C\6027\7DE8\865F %0 \7121\6548.  \5C6C\6027\7DE8\865F\5FC5\9808\4ECB\65BC 1 \5230 %1 \4E4B\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115950304815402921)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\96C6\5408\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115950189345402921)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96C6\5408\540D\7A31\4E0D\80FD\662F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115950293185402921)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96C6\5408\540D\7A31\4E0D\80FD\8D85\904E 255 \500B\5B57\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115949654581402921)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\96C6\5408 %0 \4E0D\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115950419910402921)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E38\6A19\5C1A\672A\958B\555F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115949771431402921)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\61C9\7528\7A0B\5F0F\300D\96C6\5408 %1 \4E2D\6C92\6709\6210\54E1\9806\5E8F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115949986188402921)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\7528\7A0B\5F0F\96C6\5408 "%1" \4E2D\6C92\6709\6210\54E1\9806\5E8F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116021771292402974)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\7CFB\7D71\4E0D\652F\63F4\52A0\5BC6\7684\51FD\6578 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116075284907403014)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F14\52A9\529F\80FD\5DF2\6E2C\8A66')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115969637208402935)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\95DC\9589')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115969743096402935)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\81EA\8A02\9078\9805')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115969898984402936)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9810\8A2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115969920976402936)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115970081312402936)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96B1\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115969464912402935)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\52FE\9078\60A8\60F3\5305\62EC\5728\6B64\9801\9762\4E2D\7684\5340\57DF.  \5982\679C\60A8\4E0D\5728\6B63\78BA\7684\61C9\7528\7A0B\5F0F\76F8\95DC\8CC7\8A0A\74B0\5883\4E2D, \6216\8005\6C92\6709\6B63\78BA\7684\6B0A\9650, \5C07\4E0D\6703\986F\793A\52FE\9078\7684\5340\57DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115969594214402935)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9801\9762\4E0D\80FD\81EA\8A02.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116075575675403014)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\53EF\4EE5\8B8A\66F4\300C\4E3B\984C\6A23\5F0F\300D, \4EE5\500B\4EBA\5316\6B64\61C9\7528\7A0B\5F0F\7684\5916\89C0. \8ACB\7531\4E0B\65B9\6E05\55AE\4E2D\9078\53D6\4E00\500B\300C\4E3B\984C\6A23\5F0F\300D, \7136\5F8C\6309\4E00\4E0B\300C\5957\7528\8B8A\66F4\300D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116076372244403015)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5340\57DF\986F\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116075477710403014)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\61C9\7528\7A0B\5F0F\9810\8A2D\6A23\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116075305836403014)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5916\89C0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116018305788402971)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\805A\7E3D %0 \4E2D\6240\53C3\7167\7684\8CC7\6599\6B04\7D22\5F15\4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115921663873402901)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \683C\5F0F\4E0D\652F\63F4 CLOB \8F38\51FA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116018079718402971)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\5206\6BB5\9700\8981\5728\8CC7\6599\6B04\9663\5217\7684\958B\982D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116018172855402971)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E2D\6240\53C3\7167\7684\8CC7\6599\6B04\7FA4\7D44\7D22\5F15\4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115935628770402911)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\532F\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115940840568402914)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528 ORDS \4F5C\70BA\5217\5370\4F3A\670D\5668\6642, \532F\51FA\683C\5F0F\5FC5\9808\662F XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116018483934402972)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6A19\793A %0 \4E2D\6240\53C3\7167\7684\8CC7\6599\6B04\7D22\5F15\4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115934102555402910)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\532F\51FA\683C\5F0F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116018249991402971)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E2D\6240\53C3\7167\7684\7236\9805\7FA4\7D44\7D22\5F15\4E0D\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116043488717402990)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \8868\683C\7684 %1 \8CC7\6599\6B04\662F "GENERATED ALWAYS" \8B58\5225\8CC7\6599\6B04. \8ACB\78BA\5B9A\300C\8A2D\5B9A\300D\5C0D\8A71\65B9\584A\4E2D\6C92\6709\4EFB\4F55\4F86\6E90\8CC7\6599\6B04\5C0D\61C9\81F3 %1 \8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115960846479402929)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\78BA\8A8D\9593\9694\592A\5C0F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115960908639402929)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C1A\70BA\91DD\5C0D\8CC7\6599\8F09\5165\63D0\4F9B\4EFB\4F55\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115962113256402929)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\4EFB\4F55\8CC7\6599\5217\9078\53D6\5668 "%0" \7684\8CC7\6599\6B04. \8ACB\5617\8A66\81EA\52D5\5075\6E2C\6216\8907\67E5 JSON \7D50\69CB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115970460244402936)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728 XLSX \6A94\6848\4E2D\627E\4E0D\5230\4EFB\4F55\5DE5\4F5C\8868.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115970312052402936)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\5DE5\4F5C\8868\4E0D\5728 XLSX \6A94\6848\4E2D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115950588020402921)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5EAB\4E2D\7684\76EE\524D\8CC7\6599\7248\672C\81EA\4F7F\7528\8005\8D77\59CB\66F4\65B0\8655\7406\4F5C\696D\5F8C\5DF2\7D93\8B8A\66F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115952941683402923)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66F4\65B0\5831\8868\8CC7\6599\6B04\6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116057676705403001)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5C07 %0 \8F49\63DB\6210 SDO_GEOMETRY.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115997190342402955)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5C07\8CC7\6599\985E\578B %1 \7684\8CC7\6599\6B04 %0 \8F49\63DB\70BA VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116004152017402961)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\8CC7\6599\4F86\6E90\4E2D\627E\4E0D\5230\66FF\5C6C\6027 "%1" \6307\5B9A\7684\8CC7\6599\6B04 "%0"!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115945495663402918)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\591A\91CD\503C\8CC7\6599\6B04\4E0D\652F\63F4\7BE9\9078\985E\578B %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116061036486403003)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\4ECB\65BC\300D\7BE9\9078\689D\4EF6\7121\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115927522777402905)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6307\5B9A\7684\503C\6E05\55AE\985E\578B\7121\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115927448255402905)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\8A62\985E\578B\7121\6548. \67E5\8A62\985E\578B\5FC5\9808\662F\8868\683C\3001SQL \67E5\8A62, \6216\50B3\56DE SQL \67E5\8A62\7684 PL/SQL \51FD\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115997245118402955)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\6CD5\5256\6790 SQL \67E5\8A62!'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116004213363402961)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728 SQL \6558\8FF0\53E5\4E2D\627E\4E0D\5230\66FF\5C6C\6027 "%1" \6307\5B9A\7684\8CC7\6599\6B04\4F4D\7F6E %0!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115926070905402904)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\591A\91CD\503C\7BE9\9078\689D\4EF6\4E2D\4F7F\7528\4E86\592A\591A\9805\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116004003232402961)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6307\5B9A\5C6C\6027 "%0" \7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115927391005402905)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('PL/SQL \51FD\6578\4E3B\9AD4\672A\50B3\56DE\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116017298885402971)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \8CC7\6599\4F86\6E90\672A\5305\542B\8655\7406\6240\8981\6C42 DML \52D5\4F5C\7684\4F5C\696D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115923272250402902)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8CC7\6599\5EAB\4E2D\7121\6CD5\9032\884C GeoJSON \8207 SDO_GEOMETRY \8F49\63DB (\8CC7\6599\6B04 %0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115924350065402903)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('XML \8CC7\6599\4F86\6E90\4E0D\652F\63F4 SDO_GEOMETRY \8F49\63DB (\8CC7\6599\6B04 %0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115931607861402908)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\652F\63F4\4EE5 %0 \5B57\5143\4F5C\70BA\591A\91CD\503C\5340\9694\7B26\865F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116058968441403002)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5728\67E5\8A62\76F8\95DC\8CC7\8A0A\74B0\5883\4F7F\7528\6B64\51FD\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115924482276402903)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\6B04\8CC7\6599\985E\578B\4E0D\7B26.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115927220813402905)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5167\90E8 ORDS OUT \9023\7D50\9650\5236\5DF2\8D85\904E. \8ACB\6E1B\5C11 DML \8CC7\6599\5217\6578\76EE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116005047650402961)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\6CD5\5256\6790\4F86\81EA\9060\7AEF\4F3A\670D\5668\7684 JSON \56DE\61C9: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115927163257402905)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76F8\95DC\8CC7\8A0A\74B0\5883\985E\578B\4E0D\660E\6216\4E0D\6B63\78BA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116021614584402974)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5256\6790\5668\4E0D\652F\63F4\6B64\6A94\6848\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115976266738402940)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6388\6B0A\7684\5B58\53D6 (\672A\8A2D\5B9A wwv_flow_api.set_credentials).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115953279724402923)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DE5\4F5C\5340\5DF2\7D93\5B58\5728, \56E0\6B64\672A\5EFA\7ACB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115953161403402923)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\5EFA\7ACB\4F7F\7528\8005\7FA4\7D44, \56E0\70BA\5DF2\7D93\5B58\5728.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115963443576402930)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\5230 %0 \7684\91CD\8907\4F7F\7528\8005\540D\7A31.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115963569669402930)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F09\5165\4F7F\7528\8005\6642\767C\751F\932F\8AA4. \5728\4F7F\7528\8005 %0 \5931\6557.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115973467722402938)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\61C9\8A72\5DF2\7D93\8F09\5165 %0 \500B\4F7F\7528\8005.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115973217871402938)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5BC6\78BC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115973385328402938)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B0A\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115973033115402938)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F7F\7528\8005\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116049572886402995)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE\9801\9762\9805\76EE #COMPONENT_NAME# \6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115969179235402934)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\986F\793A\9801\9762\9805\76EE, \56E0\70BA\5C1A\672A\958B\555F HTML \8868\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115934459917402910)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97\9801\9762\9805\76EE #COMPONENT_NAME# \7684\9805\76EE\9810\8A2D\503C\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115968429242402934)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9801\9762\9805\76EE #COMPONENT_NAME# \7684\9805\76EE\5F8C\7E8C\904B\7B97\6709\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115968317525402934)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\904B\7B97\9801\9762\9805\76EE #COMPONENT_NAME# \7684\9805\76EE\4F86\6E90\503C\6642\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115948138313402919)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6388\6B0A\7684\5B58\53D6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115968623070402934)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\652F\63F4 JavaScript.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115968743701402934)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6E05\55AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115969309202402935)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8D77\59CB\67E5\8A62.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115976585692402940)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E0D\652F\63F4\66F4\65B0 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115970705020402936)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684\9805\76EE ID: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115997034862402955)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\9805\76EE\6C92\6709\76F8\95DC\8AAA\660E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115961580992402929)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5716\8868\67E5\8A62\7522\751F\5931\6557. \8ACB\6AA2\67E5\300C\4F86\6E90\300D\548C\300C\8CC7\6599\6B04\5C0D\61C9\300D\8A2D\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116056398703403000)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9644\4EF6\5927\5C0F %0 MB \7684\8D85\904E\9644\4EF6\7684\5927\5C0F\4E0A\9650 %1 MB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115962492805402930)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684 p_mail_id \53C3\6578\503C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116079817955403017)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5DF2\7D93\8D85\51FA\6BCF\4E00\5DE5\4F5C\5340\7684\96FB\5B50\90F5\4EF6\8A0A\606F\6578\76EE\4E0A\9650.  \8ACB\6D3D\8A62\7BA1\7406\54E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115943456464402916)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\5F9E\61C9\7528\7A0B\5F0F\968E\6BB5\4F5C\696D\5167\547C\53EB\6B64\7A0B\5E8F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115962345529402930)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\63D0\4F9B\7D66 %0 \53C3\6578\7684\503C\662F\7A7A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116016359334402970)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728\61C9\7528\7A0B\5F0F %1 \4E2D\627E\4E0D\5230\96FB\5B50\90F5\4EF6\6A23\677F "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116092809787403027)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('SMTP_HOST_ADDRESS \57F7\884C\8655\7406\53C3\6578\5FC5\9808\8A2D\70BA\50B3\9001\90F5\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115962006325402929)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\60A8\5FC5\9808\8F38\5165\8A0A\606F\6536\4EF6\8005\624D\80FD\50B3\9001\90F5\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116082239086403019)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8207\8A2D\5B9A\7684\96FB\5B50\90F5\4EF6\4F3A\670D\5668\5EFA\7ACB SMTP \9023\7DDA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116056433060403000)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6548\7684 Ajax \547C\53EB!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115947803738402919)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C1A\672A\66FF Plug-in %0 \5B9A\7FA9 Ajax \51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116046813292402993)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C1A\672A\66FF Plug-in %0 \5B9A\7FA9\57F7\884C\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115947948027402919)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5C1A\672A\66FF Plug-in %0 \5B9A\7FA9\5448\73FE\51FD\6578')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116057349510403001)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \8CC7\6599\4F86\6E90 Plug-In "%0" \4E0D\5305\542B\300C\529F\80FD\300D\51FD\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116057225899403001)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \8CC7\6599\4F86\6E90 Plug-In "%0" \4E0D\5305\542B DML \51FD\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116057445337403001)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \8CC7\6599\4F86\6E90 Plug-In "%0" \4E0D\5305\542B\57F7\884C\51FD\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116057548408403001)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('REST \8CC7\6599\4F86\6E90 Plug-In "%0" \4E0D\5305\542B\64F7\53D6\51FD\6578.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115945656189402918)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8655\7406 Plug-in \6642, PLSQL \7A0B\5F0F\78BC\767C\751F\932F\8AA4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115952264195402922)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\6307\5B9A\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115982888831402945)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5C07\8CC7\6599\985E\578B %0 \8F49\63DB\70BA VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116068475630403009)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5728 SQL \6558\8FF0\53E5\4E2D\627E\4E0D\5230\66FF\5C6C\6027 "%1" \6307\5B9A\7684\8CC7\6599\6B04 "%0"!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116044730499402991)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5FC5\9808\5C0D %0 \6307\5B9A\503C\6E05\55AE (LOV) \67E5\8A62\6216\5177\540D\7684\503C\6E05\55AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116046349201402992)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \4E4B LOV SQL \67E5\8A62\4E2D\6240\9078\7684\8CC7\6599\6B04\6578\76EE\4E0D\6B63\78BA. \8ACB\53C3\95B1\7BC4\4F8B, \77AD\89E3\6709\6548\7684\6558\8FF0\53E5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116068224713403009)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\672A\6307\5B9A\5C6C\6027 "%0" \7684\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116097951013403031)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\70BA\5C6C\6027 "%1" \8F38\5165\7684\503C %0 \4E0D\662F\6578\5B57.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116049841259402995)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 \5728 SQL \6558\8FF0\53E5\4E2D\7684\8CC7\6599\985E\578B\4E0D\6B63\78BA. \8CC7\6599\6B04# %1 \70BA %2, \4F46\61C9\70BA %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116068340954403009)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\66FF\5C6C\6027 "%1" \6307\5B9A\4E4B\8CC7\6599\6B04 "%0" \7684\8CC7\6599\985E\578B\70BA %2, \4F46\61C9\70BA %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115944966375402917)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\627E\4E0D\5230\5831\8868\7248\9762\914D\7F6E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116004924360402961)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4EE5 REST \8CC7\6599\4F86\6E90\70BA\4F9D\64DA\7684\5831\8868\4E0D\80FD\4F7F\7528\904B\7B97\7E3D\548C\529F\80FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115968519226402934)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('ERR-2904 \7121\6CD5\8A2D\5B9A\6377\5F91\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115972871478402938)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\932F\8AA4: \4E0D\660E\7684\6377\5F91\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115962815413402930)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\5F9E\61C9\7528\7A0B\5F0F %0 \64F7\53D6 authentication_scheme.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116036337759402985)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\968E\6BB5\4F5C\696D\5DF2\7D93\6709\8A72\79DF\7528\6236 ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115973166883402938)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\96FB\5B50\90F5\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116097390315403031)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8A8D\8B49\5931\6557.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115999602535402957)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4E00\6216\591A\500B apex_util.g_request_cookies \4E2D\8A2D\5B9A\7684 Cookie \5305\542B\7121\6548\7684\503C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115982126698402944)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('UDDI \767B\9304\7684\56DE\61C9\7121\6548.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115945741191402918)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8F38\5165\7684 URL \672A\50B3\56DE\6709\6548\7684 WSDL \6587\4EF6.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115948207895402920)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('WSDL \6587\4EF6\5305\542B\591A\500B SOAP \9023\7D50. &PRODUCT_NAME. \50C5\652F\63F4\5167\542B\4E00\500B SOAP \9023\7D50\7684 WSDL. \6309\4E00\4E0B\300C\624B\52D5\5EFA\7ACB Web \670D\52D9\53C3\7167\300D, \5373\53EF\7E7C\7E8C\5EFA\7ACB\6B64\670D\52D9\7684\53C3\7167.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116016631192402970)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\670D\52D9\7684\56DE\61C9\4E0D\662F XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116097287250403031)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('OAuth \5B58\53D6\6B0A\6756\7121\6CD5\4F7F\7528\6216\5DF2\904E\671F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116060403208403003)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5DF2\7D93\8D85\51FA\6BCF\4E00\5DE5\4F5C\5340\7684 Web \670D\52D9\8981\6C42\6578\76EE\4E0A\9650. \8ACB\6D3D\8A62\7BA1\7406\54E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116097446762403031)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\4F3A\670D\5668\56DE\61C9\4E0D\652F\63F4\7684 OAuth \6B0A\6756\985E\578B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115947647098402919)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('WSDL \6587\4EF6\672A\5305\542B SOAP \7684\9023\7D50, \6240\4EE5\7121\6CD5\65B0\589E\53C3\7167.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115943508805402916)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64 WSDL \9700\8981\8A8D\8B49\8B49\660E\8CC7\6599. \8ACB\5728\4E0B\65B9\8F38\5165\4F7F\7528\8005\540D\7A31\548C\5BC6\78BC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115952363170402923)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5448\73FE\5F15\64CE\7121\6CD5\77AD\89E3 WSDL \6587\4EF6. \6309\4E00\4E0B\300C\624B\52D5\5EFA\7ACB Web \670D\52D9\53C3\7167\300D, \5373\53EF\7E7C\7E8C\5EFA\7ACB\6B64\670D\52D9\7684\53C3\7167.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116019287869402972)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\7121\6CD5\8655\7406\66F4\65B0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116045020397402992)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\503C\6E05\55AE\300D\7684\50B3\56DE\8CC7\6599\6B04\548C\986F\793A\8CC7\6599\6B04\76F8\540C!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116044956530402991)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\300C\503C\6E05\55AE\300D\6C92\6709\50B3\56DE\8CC7\6599\6B04.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115976446544402940)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\64F7\53D6\8CC7\6599\6B04\503C\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116000430965402958)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\76EE\524D\7684\5217\8868\5316\8868\55AE\8CC7\6599\592A\820A; \4F86\6E90\8CC7\6599\5DF2\4FEE\6539\904E.<br/> \8ACB\6309\4E00\4E0B<strong><a href="%0">\6B64\8655</a></strong>\4F86\6368\68C4\60A8\7684\8B8A\66F4, \7136\5F8C\5F9E\8CC7\6599\5EAB\91CD\65B0\8F09\5165\8CC7\6599.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115958517239402927)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5224\65B7\5206\9801\5B57\4E32\6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115958477267402927)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\6CD5\5224\65B7\67E5\8A62\6A19\984C:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115958659309402927)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\57F7\884C\5831\8868\8868\5C3E\53D6\4EE3\6642\767C\751F\932F\8AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115958788168402927)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\6CD5\5256\6790 SQL \67E5\8A62:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115963768310402931)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8981\6C42\7684\8CC7\6599\5217\6578\76EE\4E0B\9650: %0, \627E\5230\4F46\672A\986F\793A\7684\8CC7\6599\5217\6578\76EE: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115961272795402929)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\8A62\8CC7\6599\6B04 #%0 (%1) \7121\6548, \4F7F\7528 HTML \7684\8CC7\6599\6B04\9700\8981\5225\540D\540D\7A31')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115976356722402940)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\53D6\5F97\67E5\8A62\6A19\984C\6642\767C\751F\932F\8AA4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115958807182402927)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5831\8868\932F\8AA4:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115996556974402955)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6309\6B64\8CC7\6599\6B04\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115961363480402929)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'zh-tw'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7121\6CD5\5256\6790\67E5\8A62, \8ACB\6AA2\67E5\60A8\7684\67E5\8A62\8A9E\6CD5.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116000527385402958)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\6B64\8868\55AE\5305\542B\672A\5132\5B58\7684\8B8A\66F4. \82E5\4E0D\8981\5132\5B58\8B8A\66F4, \8ACB\6309\300C\78BA\5B9A\300D\7E7C\7E8C\9032\884C\4F5C\696D. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116004809343402961)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\9078\64C7\7684\8CC7\6599\4F86\6E90\4E0D\652F\63F4\5831\8868\5206\9801\914D\7F6E (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115961153294402929)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\67E5\8A62\8CC7\6599\6B04 #%0 (%1) \7121\6548, \8ACB\4F7F\7528\8CC7\6599\6B04\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115963852173402931)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217 %0 - %1 , \5171\8D85\904E %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116002575939402959)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 - %1, \8D85\904E %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115963614603402931)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\8CC7\6599\5217 %0 - %1, \5171 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115947574459402919)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('%0 - %1, \5171 %2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115958954121402927)
,p_name=>'Y'
,p_message_language=>'zh-tw'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115965061381402932)
,p_name=>'YEAR'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115958185300402927)
,p_name=>'YEARS'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116000688272402958)
,p_name=>'YES'
,p_message_language=>'zh-tw'
,p_message_text=>unistr('\662F')
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4477)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4477)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>unistr('\684C\9762')
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4477
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4477)
,p_name=>unistr('\8A0A\606F')
,p_alias=>'MESSAGES'
,p_step_title=>unistr('\8A0A\606F')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
