--------------------------------------------------------------------------------
-- Name: Universal Theme Development
-- Copyright (c) 2012, 2021 Oracle and/or its affiliates.
-- Licensed under the Universal Permissive License v 1.0
-- as shown at https://oss.oracle.com/licenses/upl/
--------------------------------------------------------------------------------
prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>20
,p_default_application_id=>8940
,p_default_id_offset=>0
,p_default_owner=>'ORACLE'
);
end;
/
 
prompt APPLICATION 8940 - Universal Theme Development
--
-- Application Export:
--   Application:     8940
--   Name:            Universal Theme Development
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                    136
--       Items:                  156
--       Processes:                5
--       Regions:              1,058
--       Buttons:                282
--       Dynamic Actions:         35
--     Shared Components:
--       Logic:
--       Navigation:
--         Parent Tabs:            2
--         Lists:                 38
--         Breadcrumbs:            2
--           Entries:            116
--         NavBar Entries:         1
--       Security:
--         Authentication:         1
--       User Interface:
--         Themes:                 1
--         Templates:
--           Page:                10
--           Region:              18
--           Label:                7
--           List:                13
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               3
--           Report:              12
--         LOVs:                   4
--         Shortcuts:              2
--         Plug-ins:               3
--       Globalization:
--       Reports:
--       E-Mail:
--     Supporting Objects:  Included
--       Install scripts:          2
--   Version:         21.2.0-19
--   Instance ID:     696285138374724
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'ORACLE')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Universal Theme Development')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'UTDEV')
,p_application_group=>wwv_flow_api.id(1268170835711543)
,p_application_group_name=>'21.1 Sample Apps'
,p_page_view_logging=>'YES'
,p_page_protection_enabled_y_n=>'N'
,p_checksum_salt_last_reset=>'20211022114518'
,p_bookmark_checksum_function=>'MD5'
,p_max_session_length_sec=>28800
,p_compatibility_mode=>'21.2'
,p_flow_language=>'en-us'
,p_flow_language_derived_from=>'FLOW_PRIMARY_LANGUAGE'
,p_allow_feedback_yn=>'Y'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_documentation_banner=>'Created 08/12/2004 11:25:08 AM'
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(6617513688278274885)
,p_application_tab_set=>1
,p_logo_type=>'T'
,p_logo_text=>'Universal Theme'
,p_favicons=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/app-sample-universal-theme.ico" />',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/app-sample-universal-theme-16x16.png" />',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/app-sample-universal-theme-32x32.png"><link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/app-sample-universal-theme.png" />'))
,p_public_user=>'HTMLDB_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'21.2'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'S'
,p_deep_linking=>'Y'
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'P'
,p_csv_encoding=>'N'
,p_auto_time_zone=>'N'
,p_substitution_string_01=>'APP_DATE_FMT'
,p_substitution_value_01=>'Day Month DD, YYYY'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20211022114518'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_files_version=>204
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
,p_copyright_banner=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Name: #APP_NAME#',
'Copyright (c) 2012, #YEAR# Oracle and/or its affiliates.',
'Licensed under the Universal Permissive License v 1.0',
'as shown at https://oss.oracle.com/licenses/upl/'))
);
end;
/
prompt --application/shared_components/navigation/lists/ut_application_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(404960847609814309)
,p_name=>'UT - Application Navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404961057623814311)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Getting Started'
,p_list_item_link_target=>'f?p=&APP_ID.:500:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-mouse-pointer'
,p_list_text_01=>'getting_started'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790181588986588997)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Design'
,p_list_item_link_target=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-design'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790211978341702368)
,p_list_item_display_sequence=>750
,p_list_item_link_text=>'Colors'
,p_list_item_link_target=>'f?p=&APP_ID.:402:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-eyedropper'
,p_parent_list_item_id=>wwv_flow_api.id(790181588986588997)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790212244932703684)
,p_list_item_display_sequence=>760
,p_list_item_link_text=>'Customization'
,p_list_item_link_target=>'f?p=&APP_ID.:403:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_parent_list_item_id=>wwv_flow_api.id(790181588986588997)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790212527342704563)
,p_list_item_display_sequence=>770
,p_list_item_link_text=>'Data Entry'
,p_list_item_link_target=>'f?p=&APP_ID.:404:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_parent_list_item_id=>wwv_flow_api.id(790181588986588997)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790212848859705878)
,p_list_item_display_sequence=>780
,p_list_item_link_text=>'Layout'
,p_list_item_link_target=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-3row'
,p_parent_list_item_id=>wwv_flow_api.id(790181588986588997)
,p_list_text_10=>'700'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713375871653885764)
,p_list_item_display_sequence=>830
,p_list_item_link_text=>'Grid Layout'
,p_list_item_link_target=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(790212848859705878)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'300'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404962634570814314)
,p_list_item_display_sequence=>840
,p_list_item_link_text=>'Page Templates'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(790212848859705878)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790216425887716634)
,p_list_item_display_sequence=>850
,p_list_item_link_text=>'Responsive Design'
,p_list_item_link_target=>'f?p=&APP_ID.:701:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_parent_list_item_id=>wwv_flow_api.id(790212848859705878)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790213137543706961)
,p_list_item_display_sequence=>790
,p_list_item_link_text=>'Notifications and Messaging'
,p_list_item_link_target=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_parent_list_item_id=>wwv_flow_api.id(790181588986588997)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790213493149707798)
,p_list_item_display_sequence=>800
,p_list_item_link_text=>'Navigation'
,p_list_item_link_target=>'f?p=&APP_ID.:407:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-tabs'
,p_parent_list_item_id=>wwv_flow_api.id(790181588986588997)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713416031033967219)
,p_list_item_display_sequence=>810
,p_list_item_link_text=>'UI Patterns'
,p_list_item_link_target=>'f?p=&APP_ID.:5000:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_parent_list_item_id=>wwv_flow_api.id(790181588986588997)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'5000'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790206689515692874)
,p_list_item_display_sequence=>690
,p_list_item_link_text=>'Login Page'
,p_list_item_link_target=>'f?p=&APP_ID.:5001:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(713416031033967219)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790208910412694520)
,p_list_item_display_sequence=>700
,p_list_item_link_text=>'Home and Dashboard'
,p_list_item_link_target=>'f?p=&APP_ID.:5002:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(713416031033967219)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790209281981695461)
,p_list_item_display_sequence=>710
,p_list_item_link_text=>'Filter Page'
,p_list_item_link_target=>'f?p=&APP_ID.:5003:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(713416031033967219)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790209512553696422)
,p_list_item_display_sequence=>720
,p_list_item_link_text=>'Marquee page'
,p_list_item_link_target=>'f?p=&APP_ID.:5004:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(713416031033967219)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790209819506697499)
,p_list_item_display_sequence=>730
,p_list_item_link_text=>'Modal Dialogs'
,p_list_item_link_target=>'f?p=&APP_ID.:5005:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(713416031033967219)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(662087081340490957)
,p_list_item_display_sequence=>820
,p_list_item_link_text=>'Mobile Patterns'
,p_list_item_link_target=>'f?p=&APP_ID.:420:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-mobile'
,p_parent_list_item_id=>wwv_flow_api.id(790181588986588997)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(747800042111773242)
,p_list_item_display_sequence=>570
,p_list_item_link_text=>'Navigation'
,p_list_item_link_target=>'f?p=&APP_ID.:421:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(662087081340490957)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(747800481356773242)
,p_list_item_display_sequence=>580
,p_list_item_link_text=>'Headers and Footers'
,p_list_item_link_target=>'f?p=&APP_ID.:422:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(662087081340490957)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(747800881252773242)
,p_list_item_display_sequence=>590
,p_list_item_link_text=>'Data Entry'
,p_list_item_link_target=>'f?p=&APP_ID.:423:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(662087081340490957)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(747801294056773242)
,p_list_item_display_sequence=>600
,p_list_item_link_text=>'Touch Gestures'
,p_list_item_link_target=>'f?p=&APP_ID.:424:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(662087081340490957)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(747801668191773243)
,p_list_item_display_sequence=>610
,p_list_item_link_text=>'jQuery Mobile Components'
,p_list_item_link_target=>'f?p=&APP_ID.:425:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(662087081340490957)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Components'
,p_list_item_link_target=>'f?p=&APP_ID.:3000:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-shapes'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404979442701814329)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Activity Timeline'
,p_list_item_link_target=>'f?p=&APP_ID.:1406:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-history'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404972651333814323)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Alert'
,p_list_item_link_target=>'f?p=&APP_ID.:1202:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-alert'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404971453126814322)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Badges List'
,p_list_item_link_target=>'f?p=&APP_ID.:1304:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-badge-list'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790254803403841579)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Breadcrumb'
,p_list_item_link_target=>'f?p=&APP_ID.:3810:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-breadcrumb'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404964288241814317)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Buttons'
,p_list_item_link_target=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-button'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404976257639814325)
,p_list_item_display_sequence=>430
,p_list_item_link_text=>'Text Only'
,p_list_item_link_target=>'f?p=&APP_ID.:1501:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(404964288241814317)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404976611148814326)
,p_list_item_display_sequence=>440
,p_list_item_link_text=>'Icon Only'
,p_list_item_link_target=>'f?p=&APP_ID.:1502:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(404964288241814317)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404977006637814326)
,p_list_item_display_sequence=>450
,p_list_item_link_text=>'Text with Icon'
,p_list_item_link_target=>'f?p=&APP_ID.:1503:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(404964288241814317)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404973453969814323)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Button Group'
,p_list_item_link_target=>'f?p=&APP_ID.:1204:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-button-group'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790255856031844227)
,p_list_item_display_sequence=>160
,p_list_item_link_text=>'Button Container'
,p_list_item_link_target=>'f?p=&APP_ID.:1250:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-button-container'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404965070284814317)
,p_list_item_display_sequence=>170
,p_list_item_link_text=>'Calendars'
,p_list_item_link_target=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-calendar'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404965851915814318)
,p_list_item_display_sequence=>180
,p_list_item_link_text=>'Card Templates'
,p_list_item_link_target=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-cards'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(760796011618227152)
,p_list_item_display_sequence=>185
,p_list_item_link_text=>'Card Regions'
,p_list_item_link_target=>'f?p=&APP_ID.:3110:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-address-card-o'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404973885709814324)
,p_list_item_display_sequence=>190
,p_list_item_link_text=>'Carousel'
,p_list_item_link_target=>'f?p=&APP_ID.:1205:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-carousel'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790265128676888907)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'Charts'
,p_list_item_link_target=>'f?p=&APP_ID.:1902:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-bar-chart'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404974282533814324)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>'Collapsible'
,p_list_item_link_target=>'f?p=&APP_ID.:1206:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-collapsible'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404979026242814329)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>'Comments'
,p_list_item_link_target=>'f?p=&APP_ID.:1405:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-comments-o'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(350269099343744384)
,p_list_item_display_sequence=>225
,p_list_item_link_text=>'Content Row'
,p_list_item_link_target=>'f?p=&APP_ID.:1407:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-list-left'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1407'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(775201947420869417)
,p_list_item_display_sequence=>227
,p_list_item_link_text=>'Contextual Info'
,p_list_item_link_target=>'f?p=&APP_ID.:1307:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-list-right'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1307'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404967011884814319)
,p_list_item_display_sequence=>230
,p_list_item_link_text=>'Data Tables and Reports'
,p_list_item_link_target=>'f?p=&APP_ID.:3400:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-table'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404977409522814326)
,p_list_item_display_sequence=>520
,p_list_item_link_text=>'Classic Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(404967011884814319)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404977886452814327)
,p_list_item_display_sequence=>530
,p_list_item_link_text=>'Interactive Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(404967011884814319)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790268545349916852)
,p_list_item_display_sequence=>540
,p_list_item_link_text=>'Interactive Grid'
,p_list_item_link_target=>'f?p=&APP_ID.:1410:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(404967011884814319)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(315960897745901520)
,p_list_item_display_sequence=>550
,p_list_item_link_text=>'Reflow Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1710:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(404967011884814319)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(315969693867057913)
,p_list_item_display_sequence=>560
,p_list_item_link_text=>'Column Toggle Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1720:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(404967011884814319)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1720'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404964628365814317)
,p_list_item_display_sequence=>240
,p_list_item_link_text=>'Forms'
,p_list_item_link_target=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-forms'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404975439087814325)
,p_list_item_display_sequence=>460
,p_list_item_link_text=>'Form Modifiers'
,p_list_item_link_target=>'f?p=&APP_ID.:1601:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(404964628365814317)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404975876769814325)
,p_list_item_display_sequence=>470
,p_list_item_link_text=>'Multi Column Layout'
,p_list_item_link_target=>'f?p=&APP_ID.:1602:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(404964628365814317)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(459023291133671112)
,p_list_item_display_sequence=>480
,p_list_item_link_text=>'Floating Labels'
,p_list_item_link_target=>'f?p=&APP_ID.:1603:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(404964628365814317)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790269502035934295)
,p_list_item_display_sequence=>250
,p_list_item_link_text=>'Help Text'
,p_list_item_link_target=>'f?p=&APP_ID.:1903:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-question-circle-o'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404973086247814323)
,p_list_item_display_sequence=>260
,p_list_item_link_text=>'Hero'
,p_list_item_link_target=>'f?p=&APP_ID.:1203:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-hero'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404963476164814315)
,p_list_item_display_sequence=>270
,p_list_item_link_text=>'Lists'
,p_list_item_link_target=>'f?p=&APP_ID.:1300:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-list'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404971091531814322)
,p_list_item_display_sequence=>410
,p_list_item_link_text=>'Links List'
,p_list_item_link_target=>'f?p=&APP_ID.:1303:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(404963476164814315)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404969862307814321)
,p_list_item_display_sequence=>420
,p_list_item_link_text=>'Media List'
,p_list_item_link_target=>'f?p=&APP_ID.:1301:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(404963476164814315)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(315960556742899480)
,p_list_item_display_sequence=>280
,p_list_item_link_text=>'List View'
,p_list_item_link_target=>'f?p=&APP_ID.:1700:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-list'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404971867315814322)
,p_list_item_display_sequence=>300
,p_list_item_link_text=>'Menu Bar'
,p_list_item_link_target=>'f?p=&APP_ID.:1305:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-tabs'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2055949222457173047)
,p_list_item_display_sequence=>310
,p_list_item_link_text=>'Menu Popup'
,p_list_item_link_target=>'f?p=&APP_ID.:1306:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-list-alt'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790276453845986993)
,p_list_item_display_sequence=>320
,p_list_item_link_text=>'Modal Dialogs and Popups'
,p_list_item_link_target=>'f?p=&APP_ID.:1906:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-modal-header'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790276737645989387)
,p_list_item_display_sequence=>910
,p_list_item_link_text=>'Page Dialog'
,p_list_item_link_target=>'f?p=&APP_ID.:1910:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(790276453845986993)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(214816472130393004)
,p_list_item_display_sequence=>915
,p_list_item_link_text=>'Page Drawer'
,p_list_item_link_target=>'f?p=&APP_ID.:1917:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(790276453845986993)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1917'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790277208146991379)
,p_list_item_display_sequence=>920
,p_list_item_link_text=>'Inline Dialog'
,p_list_item_link_target=>'f?p=&APP_ID.:1911:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(790276453845986993)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(211956527018166062)
,p_list_item_display_sequence=>925
,p_list_item_link_text=>'Inline Drawer'
,p_list_item_link_target=>'f?p=&APP_ID.:1916:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(790276453845986993)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1916'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(210177885358595795)
,p_list_item_display_sequence=>930
,p_list_item_link_text=>'Inline Popup'
,p_list_item_link_target=>'f?p=&APP_ID.:1915:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(790276453845986993)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790277525593993484)
,p_list_item_display_sequence=>330
,p_list_item_link_text=>'PL/SQL Dynamic Content'
,p_list_item_link_target=>'f?p=&APP_ID.:1908:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-dynamic-content'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790277868047999295)
,p_list_item_display_sequence=>340
,p_list_item_link_text=>'Tabs and Region Display Selector'
,p_list_item_link_target=>'f?p=&APP_ID.:1907:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-tabs'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404972205392814323)
,p_list_item_display_sequence=>350
,p_list_item_link_text=>'Standard Region'
,p_list_item_link_target=>'f?p=&APP_ID.:1201:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-window'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790279267001011450)
,p_list_item_display_sequence=>360
,p_list_item_link_text=>'Static Content'
,p_list_item_link_target=>'f?p=&APP_ID.:1905:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-code'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404974609886814324)
,p_list_item_display_sequence=>370
,p_list_item_link_text=>'Title Bar Region'
,p_list_item_link_target=>'f?p=&APP_ID.:1207:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-breadcrumb'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790285419368017835)
,p_list_item_display_sequence=>380
,p_list_item_link_text=>'Tree'
,p_list_item_link_target=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-tree-org'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404978249669814328)
,p_list_item_display_sequence=>390
,p_list_item_link_text=>'Value Attribute Pairs Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1403:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-th-list'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404975096292814325)
,p_list_item_display_sequence=>400
,p_list_item_link_text=>'Wizards'
,p_list_item_link_target=>'f?p=&APP_ID.:1208:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-wizard'
,p_parent_list_item_id=>wwv_flow_api.id(404962211197814314)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404965403854814318)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Migration Guides'
,p_list_item_link_target=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-tasks'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790240668963732669)
,p_list_item_display_sequence=>490
,p_list_item_link_text=>'Updating Universal Theme'
,p_list_item_link_target=>'f?p=&APP_ID.:1909:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-arrow-up'
,p_parent_list_item_id=>wwv_flow_api.id(404965403854814318)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790240986197737670)
,p_list_item_display_sequence=>500
,p_list_item_link_text=>'From Other Themes'
,p_list_item_icon=>'fa-window-arrow-up'
,p_parent_list_item_id=>wwv_flow_api.id(404965403854814318)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(431029421608761404)
,p_list_item_display_sequence=>860
,p_list_item_link_text=>'Why Migrate'
,p_list_item_link_target=>'f?p=&APP_ID.:2010:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(790240986197737670)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(431029745944763173)
,p_list_item_display_sequence=>870
,p_list_item_link_text=>'Migration Steps'
,p_list_item_link_target=>'f?p=&APP_ID.:2020:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(790240986197737670)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(431030318199767164)
,p_list_item_display_sequence=>880
,p_list_item_link_text=>'Post Migration'
,p_list_item_link_target=>'f?p=&APP_ID.:2030:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(790240986197737670)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(431030688725769883)
,p_list_item_display_sequence=>890
,p_list_item_link_text=>'Bookmarklet'
,p_list_item_link_target=>'f?p=&APP_ID.:2040:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(790240986197737670)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(431030913878770752)
,p_list_item_display_sequence=>900
,p_list_item_link_text=>'FAQ'
,p_list_item_link_target=>'f?p=&APP_ID.:2050:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(790240986197737670)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(599863267040037658)
,p_list_item_display_sequence=>510
,p_list_item_link_text=>'From jQuery Mobile'
,p_list_item_link_target=>'f?p=&APP_ID.:2060:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-mobile'
,p_parent_list_item_id=>wwv_flow_api.id(404965403854814318)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(558383049237173693)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Icons'
,p_list_item_link_target=>'f?p=&APP_ID.:4000:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-apex'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713402133307911730)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Reference'
,p_list_item_link_target=>'f?p=&APP_ID.:6000:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-cogs'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'6000,6306'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2089704419056989065)
,p_list_item_display_sequence=>620
,p_list_item_link_text=>'Button Builder'
,p_list_item_link_target=>'f?p=&APP_ID.:6100:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-button'
,p_parent_list_item_id=>wwv_flow_api.id(713402133307911730)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2089707066709007706)
,p_list_item_display_sequence=>630
,p_list_item_link_text=>'Responsive Classes'
,p_list_item_link_target=>'f?p=&APP_ID.:6301:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-expand'
,p_parent_list_item_id=>wwv_flow_api.id(713402133307911730)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2089707755638016479)
,p_list_item_display_sequence=>640
,p_list_item_link_text=>'Color and Status Modifiers'
,p_list_item_link_target=>'f?p=&APP_ID.:6302:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-eyedropper'
,p_parent_list_item_id=>wwv_flow_api.id(713402133307911730)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(7639293462804912)
,p_list_item_display_sequence=>641
,p_list_item_link_text=>'Layout Modifiers'
,p_list_item_link_target=>'f?p=&APP_ID.:6303:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-fit-to-size'
,p_parent_list_item_id=>wwv_flow_api.id(713402133307911730)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(7639749289812861)
,p_list_item_display_sequence=>642
,p_list_item_link_text=>'Content Modifiers'
,p_list_item_link_target=>'f?p=&APP_ID.:6304:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-text-height'
,p_parent_list_item_id=>wwv_flow_api.id(713402133307911730)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2089708048733018188)
,p_list_item_display_sequence=>650
,p_list_item_link_text=>'JavaScript Events'
,p_list_item_link_target=>'f?p=&APP_ID.:6200:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-mouse-pointer'
,p_parent_list_item_id=>wwv_flow_api.id(713402133307911730)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(458968332337637149)
,p_list_item_display_sequence=>660
,p_list_item_link_text=>'JavaScript APIs'
,p_list_item_link_target=>'f?p=&APP_ID.:6201:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-code-fork'
,p_parent_list_item_id=>wwv_flow_api.id(713402133307911730)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
begin
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2089709547365020270)
,p_list_item_display_sequence=>670
,p_list_item_link_text=>'Component Templates'
,p_list_item_link_target=>'f?p=&APP_ID.:6307:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-list'
,p_parent_list_item_id=>wwv_flow_api.id(713402133307911730)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2089709850880021459)
,p_list_item_display_sequence=>680
,p_list_item_link_text=>'Region Types'
,p_list_item_link_target=>'f?p=&APP_ID.:6308:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-list'
,p_parent_list_item_id=>wwv_flow_api.id(713402133307911730)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(364288651901511169)
,p_list_item_display_sequence=>690
,p_list_item_link_text=>'Change Log'
,p_list_item_link_target=>'f?p=&APP_ID.:6305:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-history'
,p_list_item_disp_cond_type=>'NEVER'
,p_parent_list_item_id=>wwv_flow_api.id(713402133307911730)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/template_regions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(476431339368267518)
,p_name=>'Template - Regions'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476431982778267525)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Alert'
,p_list_item_link_target=>'f?p=&APP_ID.:1202:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-exclamation-triangle'
,p_list_text_01=>'Alert Notify your users with alerts, confirmations, and other action-oriented messages.'
,p_list_text_03=>'LS'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476432769034267526)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Buttons Container'
,p_list_item_link_target=>'f?p=&APP_ID.:1250:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-square-o'
,p_list_text_01=>'Organize your button bars, toolbars, and simple horizontal forms.'
,p_list_text_03=>'BC'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476433117077267527)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Carousel'
,p_list_item_link_target=>'f?p=&APP_ID.:1205:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-arrows-h'
,p_list_text_01=>'Show off one sub region at a time. For example, displaying a report and a chart, a slideshow, or different views of the same data.'
,p_list_text_03=>'CS'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476433516807267527)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Collapsible'
,p_list_item_link_target=>'f?p=&APP_ID.:1206:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-folder-open-o'
,p_list_text_01=>'Allow your users to toggle the visibility of a region''s content on the page.'
,p_list_text_03=>'DL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285532804560449971)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Content Block'
,p_list_item_icon=>'fa-file'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476432369863267526)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Hero'
,p_list_item_link_target=>'f?p=&APP_ID.:1203:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-bullhorn'
,p_list_text_01=>'Capture your users'' attention on homepage, dashboard, and other introductory-style pages. This region template displays an icon, heading and sub headings, and buttons.'
,p_list_text_03=>'HR'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285533100472449972)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Inline Dialog'
,p_list_item_link_target=>'f?p=&APP_ID.:1911:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-modal-header'
,p_list_text_01=>'An inline dialog displays a region on the current page within a modal dialog.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285533511986449972)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Interactive Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-sort-amount-desc'
,p_list_text_01=>'Interactive Reports provide powerful features for customizing your report such as searching, filtering, sorting, highlighting, group-by, pivot, aggregations, calculations, charting, and more.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285533945570449972)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Login'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.:other:&DEBUG.::::'
,p_list_item_icon=>'fa-file-o'
,p_list_text_01=>'A generic login screen.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476431536940267523)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Standard'
,p_list_item_link_target=>'f?p=&APP_ID.:1201:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-align-justify'
,p_list_text_01=>'The generic region template. It works well with all widgets and can be heavily customized.'
,p_list_text_03=>'SD'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285534382993449973)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Tab Container'
,p_list_item_link_target=>'f?p=&APP_ID.:1907:&SESSION.:tab_container:&DEBUG.::::'
,p_list_item_icon=>'fa-tabs'
,p_list_text_01=>'The Tabs Container Region Template can be used to create a set tabs within your page.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476433944551267527)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Title Bar'
,p_list_item_link_target=>'f?p=&APP_ID.:1207:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-adn'
,p_list_text_01=>'Group breadcrumbs, page title, and primary page actions at the top of the page.'
,p_list_text_03=>'TB'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476440377156621616)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Wizard Container'
,p_list_item_link_target=>'f?p=&APP_ID.:1208:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-magic'
,p_list_text_01=>'Use this region template for the Wizard Progress list, and as the container for your forms.'
,p_list_text_03=>'WZ'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/template_lists
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(476573383197691871)
,p_name=>'Template - Lists'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285509281144327151)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Badge List'
,p_list_item_link_target=>'f?p=&APP_ID.:1304:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-badge-list'
,p_list_text_01=>'This list template is useful for displaying badges or counters.'
,p_list_text_03=>'BL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285509725445331674)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Cards'
,p_list_item_link_target=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-cards'
,p_list_text_01=>'Presents a variety of information in small blocks and can be heavily customized'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476574301796691880)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Links List'
,p_list_item_link_target=>'f?p=&APP_ID.:1303:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-list'
,p_list_text_01=>'This list template provides a list of links which can be used for navigation and other action-oriented tasks. You can optionally show badges, icons, sub list items, and more.'
,p_list_text_03=>'LS'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476573563215691877)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Media List'
,p_list_item_link_target=>'f?p=&APP_ID.:1301:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-media-list'
,p_list_text_01=>'This list template is a very common design pattern involving an icon, heading, description, and a badge.'
,p_list_text_03=>'ML'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285510075083331674)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Menu Bar'
,p_list_item_link_target=>'f?p=&APP_ID.:1305:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-tabs'
,p_list_text_01=>'This list template is used to display a menu bar control and is useful for building pages with advanced interaction.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285510481150331675)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Menu Popup'
,p_list_item_link_target=>'f?p=&APP_ID.:1306:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-list-alt'
,p_list_text_01=>'You can easily create a popup menu in your application by using Lists and associating a button with the menu.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285510865297331675)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Navigation Bar'
,p_list_item_link_target=>'f?p=&APP_ID.:407:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-breadcrumb'
,p_list_text_01=>'Navigation is an important part of your application and can determine the how your users navigate within your application.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285511255005331675)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Tabs'
,p_list_item_link_target=>'f?p=&APP_ID.:1907:&SESSION.:tab_list:&DEBUG.::::'
,p_list_item_icon=>'fa-tabs'
,p_list_text_01=>'You can use Tabs within your application pages to improve navigation,'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285511637712331676)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Wizard Progress'
,p_list_item_link_target=>'f?p=&APP_ID.:1208:&SESSION.:wizard_list:&DEBUG.::::'
,p_list_item_icon=>'fa-wizard'
,p_list_text_01=>'The Wizard Progress List Template is used to display the total steps of a wizard along with a marker of the current step the user is on.'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/template_reports
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(476579719264733455)
,p_name=>'Template - Reports'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285561707719536226)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Alerts'
,p_list_item_link_target=>'f?p=&APP_ID.:1202:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-exclamation-triangle'
,p_list_text_01=>'Display alerts, confirmations, and other action-oriented messages.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285562001417536227)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Badge List'
,p_list_item_link_target=>'f?p=&APP_ID.:1304:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-badge-list'
,p_list_text_01=>'Displaying badges or counters.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2182543778758267099)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Cards'
,p_list_item_link_target=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-cards'
,p_list_text_01=>'This report template provides the Cards UI and is useful for presenting a variety of information. Cards can be displayed in three styles, with icons or initials, and you can control the layout.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476581538439733458)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Comments'
,p_list_item_link_target=>'f?p=&APP_ID.:1405:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-comments-o'
,p_list_text_01=>'This report template is used to display user comments and status updates.'
,p_list_text_03=>'CM'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(775220668939941719)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>'Contextual Info'
,p_list_item_link_target=>'f?p=&APP_ID.:1307:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-list-right'
,p_list_text_01=>'This report template is best used to display key value pairs.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476579975751733455)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Standard'
,p_list_item_link_target=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-table'
,p_list_text_01=>'This is the default report template used for displaying tabular data.'
,p_list_text_03=>'RP'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476583558130758825)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Timeline'
,p_list_item_link_target=>'f?p=&APP_ID.:1406:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-clock-o'
,p_list_text_01=>'This timeline report template is useful for displaying recent updates and interactions within an application.'
,p_list_text_03=>'TL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476580797814733457)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Value Attribute Pairs'
,p_list_item_link_target=>'f?p=&APP_ID.:1403:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-pause'
,p_list_text_01=>'This report template is useful for displaying attribute value / key value pairs and works well with both Row or Column based queries.'
,p_list_text_03=>'VA'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2302998102575626036)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Search Results'
,p_list_item_icon=>'fa-table'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/template_buttons
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(476584406006772879)
,p_name=>'Template - Buttons'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476584644680772879)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Text Only'
,p_list_item_link_target=>'f?p=&APP_ID.:1501:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-file-text-o'
,p_list_text_01=>'This is your standard button in Universal Theme'
,p_list_text_03=>'TO'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476585035303772880)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Icon Only'
,p_list_item_link_target=>'f?p=&APP_ID.:1502:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-photo'
,p_list_text_01=>'This list template provides the Cards UI and is useful for presenting a variety of information. Cards can be displayed in three styles, with icons or initials, and you can control the layout.'
,p_list_text_03=>'IO'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476585408801772881)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Text With Icon'
,p_list_item_link_target=>'f?p=&APP_ID.:1503:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-file-picture-o'
,p_list_text_01=>'This template enables you to display an icon next to your button label. You can easily position the icon to the right or left of the label using Template Options.'
,p_list_text_03=>'TI'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/template_forms
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(476588768580793809)
,p_name=>'Template - Forms'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476588928305793810)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Form Modifiers'
,p_list_item_link_target=>'f?p=&APP_ID.:1601:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-forms'
,p_list_text_01=>'This is a basic form which can be customized using Template Options of the Region they are in.'
,p_list_text_03=>'FM'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(476589362742793811)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Multi Column Layout'
,p_list_item_link_target=>'f?p=&APP_ID.:1602:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-columns'
,p_list_text_01=>'These examples show how complex form layout can achieved in Universal Theme.'
,p_list_text_03=>'MC'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(458994195620648265)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Floating Labels'
,p_list_item_link_target=>'f?p=&APP_ID.:1603:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-cloud-cursor'
,p_list_text_01=>'This form style features labels that automatically shrink as data is entered.'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_migration_guide
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(558263404439591029)
,p_name=>'UT - Migration Guide'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(558263675345591030)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Why Migrate'
,p_list_item_link_target=>'f?p=&APP_ID.:2010:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-question'
,p_list_text_06=>'u-color-11'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(558264058382591032)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Migration Steps'
,p_list_item_link_target=>'f?p=&APP_ID.:2020:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-list-ol'
,p_list_text_06=>'u-color-11'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(558264495416591033)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Post Migration'
,p_list_item_link_target=>'f?p=&APP_ID.:2030:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-check'
,p_list_text_06=>'u-color-11'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(558264826389591033)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Bookmarklet'
,p_list_item_link_target=>'f?p=&APP_ID.:2040:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-bookmark-o'
,p_list_text_06=>'u-color-11'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(558265275145591033)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'FAQ'
,p_list_item_link_target=>'f?p=&APP_ID.:2050:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-list'
,p_list_text_06=>'u-color-11'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_wizard_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(561122940005233277)
,p_name=>'UT - Wizard Progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(561123101558233277)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Step 1'
,p_list_item_icon=>'fa-check-circle'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(561124892979236826)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Step 2'
,p_list_item_link_target=>'f?p=&APP_ID.:100:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-cloud'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(561123463797233277)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Step 3'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-comment'
,p_list_item_current_type=>'ALWAYS'
,p_list_item_current_for_pages=>'1112'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(561125155004236826)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Step 4'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-dashboard'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_mobile_patterns
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(608043492397034627)
,p_name=>'UT - Mobile Patterns'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(608043606699034632)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Navigation'
,p_list_item_link_target=>'f?p=&APP_ID.:421:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-breadcrumb'
,p_list_text_06=>'u-color-3'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(608044068623034633)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Headers and Footers'
,p_list_item_link_target=>'f?p=&APP_ID.:422:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-header-footer'
,p_list_text_06=>'u-color-3'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(608049594314081832)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Data Entry'
,p_list_item_link_target=>'f?p=&APP_ID.:423:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-forms'
,p_list_text_06=>'u-color-3'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(608044438288034634)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Touch Gestures'
,p_list_item_link_target=>'f?p=&APP_ID.:424:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-hand-o-right'
,p_list_text_06=>'u-color-3'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(608044828577034634)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Mobile Components'
,p_list_item_link_target=>'f?p=&APP_ID.:425:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-cubes'
,p_list_text_06=>'u-color-3'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_sample_media_list
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(620486248054927814)
,p_name=>'UT - Sample Media List'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(620486432502927815)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Amet Incorporated'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-cloud'
,p_list_text_01=>'Mauris nulla. Integer urna. Vivamus molestie dapibus ligula. Aliquam erat volutpat. Nulla dignissim. Maecenas ornare egestas ligula. Nullam feugiat placerat'
,p_list_text_02=>'4'
,p_list_text_03=>'ML'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(620486740028927816)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Ridiculus LLP'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-comments-o'
,p_list_text_01=>'Phasellus nulla. Integer vulputate, risus a ultricies adipiscing, enim mi tempor lorem, eget mollis lectus pede et risus. Quisque libero.'
,p_list_text_02=>'12'
,p_list_text_03=>'AR'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(620487004353927816)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Tristique LLC'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-calendar'
,p_list_text_01=>'Aliquam nisl. Nulla eu neque pellentesque massa lobortis ultrices. Vivamus rhoncus. Donec est. Nunc ullamcorper, velit in aliquet lobortis, nisi.'
,p_list_text_02=>'4'
,p_list_text_03=>'SR'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(620487305645927816)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Cras Interdum Consulting'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-envelope-o'
,p_list_text_01=>'Integer tincidunt aliquam arcu. Aliquam ultrices iaculis odio. Nam interdum enim non nisi. Aenean eget metus. In nec orci.'
,p_list_text_02=>'431'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(620487683994927816)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Felis Associates'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-dashboard'
,p_list_text_01=>'Aenean gravida nunc sed pede. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Proin vel arcu.'
,p_list_text_02=>'Pending'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(620490918520958475)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Eros Nec Corporation'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-credit-card-terminal'
,p_list_text_01=>'Purus gravida sagittis. Duis gravida. Praesent eu nulla at sem molestie sodales. Mauris blandit enim consequat purus. Maecenas libero est.'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/badge_list_sample
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(637608094510847311)
,p_name=>'Badge List Sample'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(637608253885847312)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Active Bugs'
,p_list_item_link_target=>'#'
,p_list_text_01=>'12'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(637608579786847312)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Closed Bugs'
,p_list_item_link_target=>'#'
,p_list_text_01=>'31'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(637609104207847317)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Users'
,p_list_item_link_target=>'#'
,p_list_text_01=>'188'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(637609462006847317)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Projects'
,p_list_item_link_target=>'#'
,p_list_text_01=>'34'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(637611479729856126)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Milestones'
,p_list_item_link_target=>'#'
,p_list_text_01=>'3'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905914759695861881)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Action Items'
,p_list_item_link_target=>'#'
,p_list_text_01=>'15'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_migration_guide_from_jquery_mobile
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(654287896600461596)
,p_name=>'UT - Migration Guide from jQuery Mobile'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(654288022871461596)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Migrating from jQuery Mobile to Universal Theme'
,p_list_item_link_target=>'f?p=&APP_ID.:2060:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-check'
,p_list_text_06=>'u-color-11'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_utility_classes
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(713403702397911733)
,p_name=>'UT - Utility Classes'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713404031145911737)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Responsive Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:6301:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-mobile'
,p_list_text_01=>'CSS utility classes that enable fine grain control on how your application responds to different screen sizes.'
,p_list_text_06=>'u-color-13'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713404428801911737)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Color and Status Modifiers'
,p_list_item_link_target=>'f?p=&APP_ID.:6302:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-eyedropper'
,p_list_text_01=>'These color and status modifier classes enable you to add color to custom components.'
,p_list_text_06=>'u-color-13'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713404881513911737)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Layout Modifiers'
,p_list_item_link_target=>'f?p=&APP_ID.:6303:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-th'
,p_list_text_01=>'These CSS classes enable you to modify layout blocks by setting margins, paddings, and more.'
,p_list_text_06=>'u-color-13'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713405204403911738)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Content Modifiers'
,p_list_item_link_target=>'f?p=&APP_ID.:6304:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-keyboard-o'
,p_list_text_01=>'These content modifiers enable you to control the appearance of text, headings, and paragraphs.'
,p_list_text_06=>'u-color-13'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_tools
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(713405900484911743)
,p_name=>'UT - Tools'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713406261353911743)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Button Builder'
,p_list_item_link_target=>'f?p=&APP_ID.:6100:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-tools'
,p_list_text_01=>'Get the HTML markup or link attributes you need to add buttons to report columns, static content regions, and more.'
,p_list_text_06=>'u-color-13'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713406618862911743)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Icon Builder'
,p_list_item_link_target=>'f?p=&APP_ID.:4000:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-tools'
,p_list_text_01=>'Get the HTML markup or icon classes you need to add icons within your UI components.'
,p_list_text_06=>'u-color-13'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_javascript_utilities
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(713407327666911744)
,p_name=>'UT - JavaScript Utilities'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713460604663425801)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'JavaScript Events'
,p_list_item_link_target=>'f?p=&APP_ID.:6200:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-code'
,p_list_text_01=>'Listen and respond to these documented events in Universal Theme'
,p_list_text_06=>'u-color-13'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713407680446911744)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Javascript APIs'
,p_list_item_link_target=>'f?p=&APP_ID.:6201:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-code'
,p_list_text_01=>'Extend Universal Theme with the following widget APIs'
,p_list_text_06=>'u-color-13'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_design_patterns
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(713419631491967228)
,p_name=>'UT - Design Patterns'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713419977147967228)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Login Page'
,p_list_item_link_target=>'f?p=&APP_ID.:5001:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-key'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713420325392967229)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Home and Dashboard'
,p_list_item_link_target=>'f?p=&APP_ID.:5002:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-home'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713420748995967229)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Filter Page'
,p_list_item_link_target=>'f?p=&APP_ID.:5003:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-header-sidebar-left'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713421166924967229)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Marquee Page'
,p_list_item_link_target=>'f?p=&APP_ID.:5004:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-check-circle-o'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713421594146967229)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Modal Dialogs'
,p_list_item_link_target=>'f?p=&APP_ID.:5005:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-modal-blank'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_miscellaneous
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(790289546548048869)
,p_name=>'UT - Miscellaneous'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1808782715624849532)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Component Templates'
,p_list_item_link_target=>'f?p=&APP_ID.:6307:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-list'
,p_list_text_01=>'See a list of all available templates grouped by component type'
,p_list_text_06=>'u-color-13'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2055910706772108747)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Region Types'
,p_list_item_link_target=>'f?p=&APP_ID.:6308:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-list'
,p_list_text_01=>'See a list of the region types available in Application Express and Universal Theme'
,p_list_text_06=>'u-color-13'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790289728055048870)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Change Log'
,p_list_item_link_target=>'f?p=&APP_ID.:6305:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-list-ol'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_text_01=>'See the changes in the new version of Universal Theme'
,p_list_text_06=>'u-color-13'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(790290111386048870)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'FAQ'
,p_list_item_link_target=>'f?p=&APP_ID.:6306:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-question-circle'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_text_01=>'Answers to commonly asked questions.'
,p_list_text_06=>'u-color-13'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_sample_navigation_mega_menu
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(842010198961843152)
,p_name=>'UT - Sample Navigation Mega Menu'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(842010383986843153)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Menu Item 1'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-home'
,p_list_item_current_for_pages=>'#'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(842016350939843156)
,p_list_item_display_sequence=>160
,p_list_item_link_text=>'Sub Menu Item 1.1'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(842010383986843153)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(842016710053843157)
,p_list_item_display_sequence=>170
,p_list_item_link_text=>'Sub Menu Item 1.2'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(842010383986843153)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(842010761115843154)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Menu Item 2'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-user'
,p_list_item_current_type=>'ALWAYS'
,p_list_item_current_for_pages=>'#'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(842012365116843154)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Sub Menu Item 2.1'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(842010761115843154)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(842012778542843155)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Sub Menu Item 2.2'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(842010761115843154)
,p_list_item_current_type=>'ALWAYS'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(842013181422843155)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Sub Menu Item 2.3'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(842010761115843154)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(842011163444843154)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Menu Item 3'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-play-circle-o'
,p_list_item_current_for_pages=>'#'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(842013525051843155)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Sub Menu Item 3.1'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(842011163444843154)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(842013944315843155)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Sub Menu Item 3.2'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(842011163444843154)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(842014390308843155)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Sub Menu Item 3.2.1'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(842013944315843155)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(842014721946843156)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Sub Menu Item 3.2.2'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(842013944315843155)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(842015147679843156)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Sub Menu Item 3.2.3'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(842013944315843155)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(842011515485843154)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Menu Item 4'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-gear'
,p_list_item_current_for_pages=>'#'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(842015596615843156)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Sub Menu Item 4.1'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(842011515485843154)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(842015902796843156)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Sub Menu Item 4.2'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(842011515485843154)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_components_dynamic_list
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(879773454971203054)
,p_name=>'UT - Components Dynamic List'
,p_list_type=>'SQL_QUERY'
,p_list_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null,',
'       entry_text as label,',
'       entry_target as target,',
'       null is_current',
'from APEX_APPLICATION_LIST_entries',
'where application_id = :APP_ID',
'and list_name = ''UT - Application Navigation''',
'and parent_entry_text = ''Components'''))
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/navigation_bar
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1398847823861474656)
,p_name=>'Navigation Bar'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_migration_guide_from_ut_1_0
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1566181754433295518)
,p_name=>'UT - Migration Guide from UT 1.0'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1566181961278295519)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Updating to the Latest Universal Theme'
,p_list_item_link_target=>'f?p=&APP_ID.:1909:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-check'
,p_list_text_06=>'u-color-11'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_components
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1725945334801719893)
,p_name=>'UT - Components'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3451869176279065064)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Activity Timeline'
,p_list_item_link_target=>'f?p=&APP_ID.:1406:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-history'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3451869508721065064)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Alert'
,p_list_item_link_target=>'f?p=&APP_ID.:1202:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-alert'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3451869956760065064)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Badges List'
,p_list_item_link_target=>'f?p=&APP_ID.:1304:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-badge-list'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3451871675858075137)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Breadcrumb'
,p_list_item_link_target=>'f?p=&APP_ID.:3810:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-breadcrumb'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3451871945196075138)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Buttons'
,p_list_item_link_target=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-button'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880115227856078764)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Button Group'
,p_list_item_link_target=>'f?p=&APP_ID.:1204:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-button-group'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3451872775172075138)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Button Container'
,p_list_item_link_target=>'f?p=&APP_ID.:1250:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-button-container'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880126123242134609)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Calendars'
,p_list_item_link_target=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-calendar'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880126504818134610)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Card Templates'
,p_list_item_link_target=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-cards'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(760794687049215662)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Card Regions'
,p_list_item_link_target=>'f?p=&APP_ID.:3110:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-address-card-o'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880126931084134610)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Carousel'
,p_list_item_link_target=>'f?p=&APP_ID.:1205:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-carousel'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880127350993134610)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Charts'
,p_list_item_link_target=>'f?p=&APP_ID.:1902:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-bar-chart'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880129106086146408)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Collapsible'
,p_list_item_link_target=>'f?p=&APP_ID.:1206:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-collapsible'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880129543851146408)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Comments'
,p_list_item_link_target=>'f?p=&APP_ID.:1405:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-comments-o'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(775220194579928762)
,p_list_item_display_sequence=>145
,p_list_item_link_text=>'Contextual Info'
,p_list_item_link_target=>'f?p=&APP_ID.:1307:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-list-right'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(350310925826944427)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Content Row'
,p_list_item_link_target=>'f?p=&APP_ID.:1407:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-list-left'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880129910819146408)
,p_list_item_display_sequence=>160
,p_list_item_link_text=>'Data Tables and Reports'
,p_list_item_link_target=>'f?p=&APP_ID.:3400:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-table'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880130304764146409)
,p_list_item_display_sequence=>170
,p_list_item_link_text=>'Forms'
,p_list_item_link_target=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-forms'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880130709946146409)
,p_list_item_display_sequence=>180
,p_list_item_link_text=>'Help Text'
,p_list_item_link_target=>'f?p=&APP_ID.:1903:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>' fa-question-circle-o'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880131194073146409)
,p_list_item_display_sequence=>190
,p_list_item_link_text=>'Hero'
,p_list_item_link_target=>'f?p=&APP_ID.:1203:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-hero'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880131566736146409)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'Lists'
,p_list_item_link_target=>'f?p=&APP_ID.:1300:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-list'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(315903431361516015)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>'List View'
,p_list_item_link_target=>'f?p=&APP_ID.:1700:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-list'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2043131267392766073)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>'Menu Bar'
,p_list_item_link_target=>'f?p=&APP_ID.:1305:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-tabs'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2055915043795158217)
,p_list_item_display_sequence=>230
,p_list_item_link_text=>'Menu Popup'
,p_list_item_link_target=>'f?p=&APP_ID.:1306:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-list-alt'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880133052623157537)
,p_list_item_display_sequence=>240
,p_list_item_link_text=>'Modal Dialogs'
,p_list_item_link_target=>'f?p=&APP_ID.:1906:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-modal-header'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880133421998157538)
,p_list_item_display_sequence=>250
,p_list_item_link_text=>'PL/SQL Dynamic Content'
,p_list_item_link_target=>'f?p=&APP_ID.:1908:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-dynamic-content'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880133824287157539)
,p_list_item_display_sequence=>260
,p_list_item_link_text=>'Region Display Selector'
,p_list_item_link_target=>'f?p=&APP_ID.:1907:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-tabs'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(315903718951517698)
,p_list_item_display_sequence=>270
,p_list_item_link_text=>'Responsive Tables'
,p_list_item_link_target=>'f?p=&APP_ID.:1710:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-table'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880134271673157540)
,p_list_item_display_sequence=>280
,p_list_item_link_text=>'Standard Region'
,p_list_item_link_target=>'f?p=&APP_ID.:1201:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-header'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880134615922157540)
,p_list_item_display_sequence=>290
,p_list_item_link_text=>'Static Content'
,p_list_item_link_target=>'f?p=&APP_ID.:1905:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-code'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285564102824543354)
,p_list_item_display_sequence=>300
,p_list_item_link_text=>'Tabs'
,p_list_item_link_target=>'f?p=&APP_ID.:1907:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-tabs'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880135085745157541)
,p_list_item_display_sequence=>310
,p_list_item_link_text=>'Title Bar Region'
,p_list_item_link_target=>'f?p=&APP_ID.:1207:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-breadcrumb'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880136098908163523)
,p_list_item_display_sequence=>320
,p_list_item_link_text=>'Tree'
,p_list_item_link_target=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-tree-org'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880136496854163523)
,p_list_item_display_sequence=>330
,p_list_item_link_text=>'URL'
,p_list_item_icon=>'fa-link'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880136848200163523)
,p_list_item_display_sequence=>340
,p_list_item_link_text=>'Value Attribute Pairs Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1403:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-th-list'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880137211946163525)
,p_list_item_display_sequence=>350
,p_list_item_link_text=>'Wizards'
,p_list_item_link_target=>'f?p=&APP_ID.:1208:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-wizard'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_sample_navigation_menu
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1885182092683398328)
,p_name=>'UT - Sample Navigation Menu'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1885182283423398329)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Menu Item 1'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-home'
,p_list_item_current_for_pages=>'#'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1885182672140398330)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Menu Item 2'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-user'
,p_list_item_current_type=>'ALWAYS'
,p_list_item_current_for_pages=>'#'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1885184691788408418)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Sub Menu Item 2.1'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(1885182672140398330)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1885184984396409366)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Sub Menu Item 2.2'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(1885182672140398330)
,p_list_item_current_type=>'ALWAYS'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1885185272292410226)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Sub Menu Item 2.3'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(1885182672140398330)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1885183052997398330)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Menu Item 3'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-play-circle-o'
,p_list_item_current_for_pages=>'#'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1885185559326412330)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Sub Menu Item 3.1'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(1885183052997398330)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1885185839680413231)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Sub Menu Item 3.2'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(1885183052997398330)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1885186193096414318)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Sub Menu Item 3.2.1'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(1885185839680413231)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1885186480799415361)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Sub Menu Item 3.2.2'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(1885185839680413231)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1885186992360416271)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Sub Menu Item 3.2.3'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(1885185839680413231)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1885183403248398330)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Menu Item 4'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-gear'
,p_list_item_current_for_pages=>'#'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1885187277976417908)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Sub Menu Item 4.1'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(1885183403248398330)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1885187536343418647)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Sub Menu Item 4.2'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(1885183403248398330)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1885183834267398330)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Menu Item 5'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-alert'
,p_list_item_current_for_pages=>'#'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1885187804094419799)
,p_list_item_display_sequence=>160
,p_list_item_link_text=>'Sub Menu Item 5.1'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(1885183834267398330)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1885188154676420435)
,p_list_item_display_sequence=>170
,p_list_item_link_text=>'Sub Menu Item 5.2'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(1885183834267398330)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_sample_cards_list
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1905294320111585320)
,p_name=>'UT - Sample Cards List'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905294505697585323)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Amet Incorporated Amet Incorporated'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-cloud'
,p_list_text_01=>'Mauris nulla. Integer urna. Vivamus molestie dapibus ligula. Aliquam erat volutpat. Nulla dignissim. Maecenas ornare egestas ligula. Nullam feugiat placerat'
,p_list_text_02=>'4 Widgets'
,p_list_text_03=>'AM'
,p_list_text_07=>'New York'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905294935989585324)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Ridiculus LLP Ridiculus LLP'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-comments-o'
,p_list_text_01=>'Phasellus nulla. Integer vulputate, risus a ultricies adipiscing, enim mi tempor lorem, eget mollis lectus pede et risus. Quisque libero.'
,p_list_text_02=>'12 Widgets'
,p_list_text_03=>'RD'
,p_list_text_07=>'Reston'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905295369724585324)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Tristique LLC Tristique LLC'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-calendar'
,p_list_text_01=>'Aliquam nisl. Nulla eu neque pellentesque massa lobortis ultrices. Vivamus rhoncus. Donec est. Nunc ullamcorper, velit in aliquet lobortis, nisi.'
,p_list_text_02=>'4 Widgets'
,p_list_text_03=>'TR'
,p_list_text_07=>'Columbus'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905295764296585326)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Cras Interdum Consulting Cras Interdum Consulting'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-envelope-o'
,p_list_text_01=>'Integer tincidunt aliquam arcu. Aliquam ultrices iaculis odio. Nam interdum enim non nisi. Aenean eget metus. In nec orci.'
,p_list_text_02=>'431 Widgets'
,p_list_text_03=>'CI'
,p_list_text_07=>'Vienna'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_sample_links_list
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1905596320814687297)
,p_name=>'UT - Sample Links List'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905596536207687297)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Amet Incorporated'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-cloud'
,p_list_text_01=>'4'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905596969485687298)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Ridiculus LLP'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-comments'
,p_list_text_01=>'12'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905597364739687298)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Tristique LLC'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-calendar'
,p_list_text_01=>'4'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905597791472687298)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Cras Interdum Consulting'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-envelope'
,p_list_text_01=>'431'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905598144786687299)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Felis Associates'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-dashboard'
,p_list_text_01=>'Pending'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905598584337687301)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Eros Nec Corporation'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-user'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_sample_links_list_nested
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1905725173247765454)
,p_name=>'UT - Sample Links List (Nested)'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905725317963765454)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Amet Incorporated'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-cloud'
,p_list_text_01=>'4'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905725746257765455)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Ridiculus LLP'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-comments'
,p_list_text_01=>'12'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905726107658765455)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Tristique LLC'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-calendar'
,p_list_text_01=>'4'
,p_list_item_current_type=>'ALWAYS'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905726569807765455)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Cras Interdum Consulting'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-envelope'
,p_parent_list_item_id=>wwv_flow_api.id(1905726107658765455)
,p_list_text_01=>'431'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905726936888765456)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Felis Associates'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-dashboard'
,p_parent_list_item_id=>wwv_flow_api.id(1905726107658765455)
,p_list_text_01=>'Pending'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905727314446765456)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Eros Nec Corporation'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-user'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_sample_menu_bar_list
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1905952052314948882)
,p_name=>'UT - Sample Menu Bar List'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905952607959948883)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Menu Item 1'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-cloud'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905954215593948883)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Sub Menu Item 1.1'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-area-chart'
,p_parent_list_item_id=>wwv_flow_api.id(1905952607959948883)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905954674933948884)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Sub Menu Item 1.2'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-bar-chart'
,p_parent_list_item_id=>wwv_flow_api.id(1905952607959948883)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905955080502948884)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Sub Menu Item 1.3'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-bar-chart-o'
,p_parent_list_item_id=>wwv_flow_api.id(1905952607959948883)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905953072764948883)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Menu Item 2'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-anchor'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905955483020948884)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Sub Menu Item 2.1'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-bars'
,p_parent_list_item_id=>wwv_flow_api.id(1905953072764948883)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905955894256948884)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Sub Menu Item 2.2'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-beer'
,p_parent_list_item_id=>wwv_flow_api.id(1905953072764948883)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905956281189948884)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Sub Menu Item 2.2.1'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-binoculars'
,p_parent_list_item_id=>wwv_flow_api.id(1905955894256948884)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905956672130948884)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Sub Menu Item 2.2.2'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-bomb'
,p_parent_list_item_id=>wwv_flow_api.id(1905955894256948884)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905957019149948885)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Sub Menu Item 2.2.3'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-bug'
,p_parent_list_item_id=>wwv_flow_api.id(1905955894256948884)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905953487146948883)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Menu Item 3'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-archive'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905957411424948886)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Sub Menu Item 3.1'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-briefcase'
,p_parent_list_item_id=>wwv_flow_api.id(1905953487146948883)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1905957883540948886)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Sub Menu Item 3.2'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-camera'
,p_parent_list_item_id=>wwv_flow_api.id(1905953487146948883)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2449454871874145996)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Menu Item 4'
,p_list_item_link_target=>'#'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_sample_navigation_bar
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1909492128497202180)
,p_name=>'UT - Sample Navigation Bar'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1909492392340202182)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Help'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-question-circle'
,p_list_text_02=>'icon-only'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1909492704734202182)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Notifications'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-inbox'
,p_list_text_01=>'3'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1909493151686202183)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'&APP_USER.'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-user'
,p_list_text_02=>'has-username'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1909493570863202183)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Sign Out'
,p_list_item_link_target=>'&LOGOUT_URL.'
,p_parent_list_item_id=>wwv_flow_api.id(1909493151686202183)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/template_pages
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1917756475003302943)
,p_name=>'Template - Pages'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1917854764902086401)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Both Side Columns'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.:both_sides:&DEBUG.::::'
,p_list_item_icon=>'fa fa-columns'
,p_list_text_01=>'This page template features both the left side column and the collapsible right-side column and is well suited for very complex pages.'
,p_list_text_03=>'BS'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1917758219558302948)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Dialog Page'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.:dialog:&DEBUG.::::'
,p_list_item_icon=>'fa-comment'
,p_list_text_01=>'These page templates can be loaded as either modal or non-modal (pop-up) dialogs and are very useful for displaying commonly used forms, reports, and other components.'
,p_list_text_03=>'DP'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1917757070091302947)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Left Side Column'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.:left_side:&DEBUG.::::'
,p_list_item_icon=>'fa-layout-2col'
,p_list_text_01=>'Features a left-side display position for search filters, charts, and other interactive widgets.'
,p_list_text_03=>'LC'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1917759284120309798)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Login Page'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.:other:&DEBUG.::::'
,p_list_item_icon=>'fa-file-o'
,p_list_text_01=>'The Login page template'
,p_list_text_03=>'LP'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1917757817164302947)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Master Detail'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.:master_detail:&DEBUG.::::'
,p_list_item_icon=>'fa-layout-3col-1col'
,p_list_text_01=>'This page template features a collapsible right side column and a title-bar area which contains primary information.'
,p_list_text_03=>'MD'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285497438316229565)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Minimal (No Navigation)'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.:other:&DEBUG.::::'
,p_list_item_icon=>'fa-file-o'
,p_list_text_01=>'It is useful for single page applications or pages where where navigation is not necessary.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285501589504274877)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Modal Dialog'
,p_list_item_link_target=>'f?p=&APP_ID.:1910:&SESSION.:other:&DEBUG.::::'
,p_list_item_icon=>'fa-layout-modal-header'
,p_list_text_01=>'Modal dialogs are a great way to get user input, display information, and speed up user interactions without changing context or leaving the current page.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1917757429622302947)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Right Side Column'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.:right_side:&DEBUG.::::'
,p_list_item_icon=>'fa-layout-2col'
,p_list_text_01=>'This page template features a collapsible right-side display position and is especially useful for displaying action-oriented controls such as buttons or lists.'
,p_list_text_03=>'RS'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1917756637934302944)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Standard'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.:standard:&DEBUG.::::'
,p_list_item_icon=>'fa-file-o'
,p_list_text_01=>'The default page template.'
,p_list_text_03=>'ST'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285503483961293818)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Wizard Modal Dialog'
,p_list_item_link_target=>'f?p=&APP_ID.:1208:&SESSION.:other:&DEBUG.::::'
,p_list_item_icon=>'fa-wizard'
,p_list_text_01=>'Wizards can be very useful in simplifying complex flows into smaller, more manageable steps.'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/top_data_tables_and_reports
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(2010946567680071816)
,p_name=>'Top - Data Tables and Reports'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2010946713391071818)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Classic Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-table'
,p_list_text_01=>'This is the default report template used for displaying tabular data.'
,p_list_text_03=>'CR'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2010947167731071820)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Interactive Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-table-pointer'
,p_list_text_01=>'Customizing your report such as searching, filtering, sorting, highlighting, group-by, pivot, aggregations, calculations, charting, and more.'
,p_list_text_03=>'IR'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2010969252333081300)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Interactive Grid'
,p_list_item_link_target=>'f?p=&APP_ID.:1410:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-table-cursor'
,p_list_text_01=>'Extensible and Customizable, makeing it effortless to create master-detail relationships.'
,p_list_text_03=>'IG'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(315967780734034756)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Reflow Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1710:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-tablet'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(315968035924038409)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Column Toggle Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1710:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-toggle-on'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/top_modal_dialogs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(2011053202038416818)
,p_name=>'Top - Modal Dialogs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2011053433081416822)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Page Dialog'
,p_list_item_link_target=>'f?p=&APP_ID.:1910:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-modal-header'
,p_list_text_01=>'Include a full page inside another page. You will be able to utilize Page Process and Page Validation from that page.'
,p_list_text_03=>'PM'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(214825760574325040)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Page Drawer'
,p_list_item_link_target=>'f?p=&APP_ID.:1917:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-modal-header'
,p_list_text_01=>'Include a full page inside another page. You will be able to utilize Page Process and Page Validation from that page.'
,p_list_text_03=>'PD'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2011053895828416824)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Inline Dialog'
,p_list_item_link_target=>'f?p=&APP_ID.:1911:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-modal-header'
,p_list_text_01=>'Essentially a hidden Region on the same page displayed as a dialog.'
,p_list_text_03=>'ID'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(212155131654209482)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Inline Drawer'
,p_list_item_link_target=>'f?p=&APP_ID.:1916:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-modal-nav-right'
,p_list_text_01=>'Essentially a hidden Region on the same page displayed as a drawer.'
,p_list_text_03=>'DR'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(210177198989587652)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Inline Popup'
,p_list_item_link_target=>'f?p=&APP_ID.:1915:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-modal-blank'
,p_list_text_01=>'Essentially a hidden Region on the same page displayed as an inline popup.'
,p_list_text_03=>'IP'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/templates_region_types
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(2055911789926116545)
,p_name=>'Templates - Region Types'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2055911953028116548)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Breadcrumb'
,p_list_item_link_target=>'f?p=&APP_ID.:3810:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-breadcrumb'
,p_list_text_01=>'A hierarchical list of links that indicates where the user is within the application from a hierarchical perspective.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2055912389249116549)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Calendar'
,p_list_item_link_target=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-calendar'
,p_list_text_01=>'calendar is based on the Full Calendar library and supports drag and drop, multiple views, and more'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2055960954361299471)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Chart'
,p_list_item_link_target=>'f?p=&APP_ID.:1902:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-area-chart'
,p_list_text_01=>'Charts are based on Oracle JavaScript Extension Toolkit (JET) Data Visualizations'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2055962902260318939)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Help Text'
,p_list_item_link_target=>'f?p=&APP_ID.:1903:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-info-circle'
,p_list_text_01=>'Page-level help'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2056017212222817190)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Classic Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-align-justify'
,p_list_text_01=>'The default report template used for displaying tabular data'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(342347434760422392)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Column Toggle Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1720:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-toggle-on'
,p_list_text_01=>'Quickly choose columns to display when screen size is limited.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2056017656799817190)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Interactive Grid'
,p_list_item_link_target=>'f?p=&APP_ID.:1410:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-modal-grid-2x'
,p_list_text_01=>'A native APEX component and provides powerful features for customizing your report'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2056018038357817190)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Interactive Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-sort-amount-asc'
,p_list_text_01=>'All the features you expect for powerful reporting, including fixed headers, frozen columns, scroll pagination, multiple filters, sorting, aggregates, computations, and more'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(334869847605736365)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'List View'
,p_list_item_link_target=>'f?p=&APP_ID.:1700:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-list'
,p_list_text_01=>'This is a port of the jQuery Mobile List View component and provides a simple list with a number of settings.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2055963503129328008)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Map Chart'
,p_list_item_link_target=>'f?p=&APP_ID.:1904:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-globe'
,p_list_text_01=>'Visualize geo related data'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2055964176626333376)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'PL/SQL Dynamic Content'
,p_list_item_link_target=>'f?p=&APP_ID.:1908:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-terminal'
,p_list_text_01=>'Render HTML or text using the PL/SQL Web Toolkit'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2055964651808337740)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Region Display Selector'
,p_list_item_link_target=>'f?p=&APP_ID.:1907:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-tabs'
,p_list_text_01=>'Show and hide controls for regions'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(342149812969419468)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Reflow Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1710:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-tablet'
,p_list_text_01=>'Display data vertically to save space when screen size becomes small'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2055965040665342525)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Static Content'
,p_list_item_link_target=>'f?p=&APP_ID.:1905:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-layout-blank'
,p_list_text_01=>'Use HTML markup directly'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2055965552556347381)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Tree'
,p_list_item_link_target=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-tree-org'
,p_list_text_01=>'Hierarchical navigational control based on a SQL query'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_sample_menu_popup
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(2151851130486915930)
,p_name=>'UT - Sample Menu Popup'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2151851347742915931)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Action A'
,p_list_item_link_target=>'#'
,p_list_item_current_for_pages=>'#'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2151851768475915933)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Action B'
,p_list_item_link_target=>'#'
,p_list_item_current_for_pages=>'#'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2151852970586915934)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Sub Item A'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(2151851768475915933)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2151967813182919356)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Sub Item B'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(2151851768475915933)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2151852114030915934)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Action C'
,p_list_item_link_target=>'#'
,p_list_item_current_for_pages=>'#'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2151852574926915934)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Action D'
,p_list_item_link_target=>'#'
,p_list_item_current_for_pages=>'#'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_sample_menu_popup_actions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(2152333587573851637)
,p_name=>'UT - Sample Menu Popup (Actions)'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2152333734855851640)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'New'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-file-o'
,p_list_text_01=>'action_a'
,p_list_text_05=>'Ctrl+Alt+D'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2152334191341851641)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Open'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-folder-open-o'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2152335373302851642)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Spreadsheet'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-file-excel-o'
,p_parent_list_item_id=>wwv_flow_api.id(2152334191341851641)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2152335728933851643)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Image'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-file-image-o'
,p_parent_list_item_id=>wwv_flow_api.id(2152334191341851641)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2152334571721851641)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'---'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2152334936858851642)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Exit'
,p_list_item_link_target=>'#'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_get_started_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(2199914850856725555)
,p_name=>'UT - Get Started Navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199915038780725558)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Getting Started'
,p_list_item_link_target=>'f?p=&APP_ID.:500:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-mouse-pointer'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_text_01=>'getting_started'
,p_list_text_05=>'u-color-1'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199915813984725560)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Design'
,p_list_item_link_target=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-design'
,p_list_text_06=>'u-color-3'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199925451619725568)
,p_list_item_display_sequence=>680
,p_list_item_link_text=>'Overview'
,p_list_item_link_target=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199915813984725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199925889085725568)
,p_list_item_display_sequence=>690
,p_list_item_link_text=>'Colors'
,p_list_item_link_target=>'f?p=&APP_ID.:402:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199915813984725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199926220386725568)
,p_list_item_display_sequence=>700
,p_list_item_link_text=>'Customization'
,p_list_item_link_target=>'f?p=&APP_ID.:403:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_parent_list_item_id=>wwv_flow_api.id(2199915813984725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199926683759725569)
,p_list_item_display_sequence=>710
,p_list_item_link_text=>'Data Entry'
,p_list_item_link_target=>'f?p=&APP_ID.:404:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_parent_list_item_id=>wwv_flow_api.id(2199915813984725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199927045499725569)
,p_list_item_display_sequence=>720
,p_list_item_link_text=>'Layout'
,p_list_item_link_target=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199915813984725560)
,p_list_text_10=>'700'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199915471527725560)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Grid Layout'
,p_list_item_link_target=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199927045499725569)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'300'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199917052595725561)
,p_list_item_display_sequence=>34
,p_list_item_link_text=>'Page Templates'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199927045499725569)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199928692650725570)
,p_list_item_display_sequence=>760
,p_list_item_link_text=>'Responsive Design'
,p_list_item_link_target=>'f?p=&APP_ID.:701:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_parent_list_item_id=>wwv_flow_api.id(2199927045499725569)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199927456431725569)
,p_list_item_display_sequence=>730
,p_list_item_link_text=>'Notifications and Messaging'
,p_list_item_link_target=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_parent_list_item_id=>wwv_flow_api.id(2199915813984725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199927829440725570)
,p_list_item_display_sequence=>740
,p_list_item_link_text=>'Navigation'
,p_list_item_link_target=>'f?p=&APP_ID.:407:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199915813984725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199928259636725570)
,p_list_item_display_sequence=>750
,p_list_item_link_text=>'UI Patterns'
,p_list_item_link_target=>'f?p=&APP_ID.:5000:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_parent_list_item_id=>wwv_flow_api.id(2199915813984725560)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'5000'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199923492905725566)
,p_list_item_display_sequence=>630
,p_list_item_link_text=>'Login Page'
,p_list_item_link_target=>'f?p=&APP_ID.:5001:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199928259636725570)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199923821118725566)
,p_list_item_display_sequence=>640
,p_list_item_link_text=>'Home and Dashboard'
,p_list_item_link_target=>'f?p=&APP_ID.:5002:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199928259636725570)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199924258051725567)
,p_list_item_display_sequence=>650
,p_list_item_link_text=>'Filter Page'
,p_list_item_link_target=>'f?p=&APP_ID.:5003:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199928259636725570)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199924654552725567)
,p_list_item_display_sequence=>660
,p_list_item_link_text=>'Marquee page'
,p_list_item_link_target=>'f?p=&APP_ID.:5004:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199928259636725570)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199925080599725568)
,p_list_item_display_sequence=>670
,p_list_item_link_text=>'Modal Dialogs'
,p_list_item_link_target=>'f?p=&APP_ID.:5005:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199928259636725570)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Components'
,p_list_item_link_target=>'f?p=&APP_ID.:3000:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-shapes'
,p_list_text_06=>'u-color-15'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199929865854725571)
,p_list_item_display_sequence=>1000
,p_list_item_link_text=>'Activity Timeline'
,p_list_item_link_target=>'f?p=&APP_ID.:1406:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199930236532725571)
,p_list_item_display_sequence=>1010
,p_list_item_link_text=>'Alert'
,p_list_item_link_target=>'f?p=&APP_ID.:1202:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199930620624725572)
,p_list_item_display_sequence=>1020
,p_list_item_link_text=>'Badges List'
,p_list_item_link_target=>'f?p=&APP_ID.:1304:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199931063021725572)
,p_list_item_display_sequence=>1040
,p_list_item_link_text=>'Breadcrumb'
,p_list_item_link_target=>'f?p=&APP_ID.:3810:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199931421447725572)
,p_list_item_display_sequence=>1050
,p_list_item_link_text=>'Buttons'
,p_list_item_link_target=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199920230321725564)
,p_list_item_display_sequence=>380
,p_list_item_link_text=>'Text Only'
,p_list_item_link_target=>'f?p=&APP_ID.:1501:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199931421447725572)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199920697586725564)
,p_list_item_display_sequence=>385
,p_list_item_link_text=>'Icon Only'
,p_list_item_link_target=>'f?p=&APP_ID.:1502:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199931421447725572)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199921017032725564)
,p_list_item_display_sequence=>390
,p_list_item_link_text=>'Text with Icon'
,p_list_item_link_target=>'f?p=&APP_ID.:1503:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199931421447725572)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199931813796725573)
,p_list_item_display_sequence=>1060
,p_list_item_link_text=>'Button Group'
,p_list_item_link_target=>'f?p=&APP_ID.:1204:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199932247847725573)
,p_list_item_display_sequence=>1070
,p_list_item_link_text=>'Button Container Region'
,p_list_item_link_target=>'f?p=&APP_ID.:1250:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199932671914725573)
,p_list_item_display_sequence=>1080
,p_list_item_link_text=>'Calendars'
,p_list_item_link_target=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199933013206725573)
,p_list_item_display_sequence=>1090
,p_list_item_link_text=>'Cards'
,p_list_item_link_target=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199933487059725574)
,p_list_item_display_sequence=>1090
,p_list_item_link_text=>'Carousel'
,p_list_item_link_target=>'f?p=&APP_ID.:1205:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199933890141725574)
,p_list_item_display_sequence=>1100
,p_list_item_link_text=>'Charts'
,p_list_item_link_target=>'f?p=&APP_ID.:1902:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199934236802725574)
,p_list_item_display_sequence=>1110
,p_list_item_link_text=>'Collapsible'
,p_list_item_link_target=>'f?p=&APP_ID.:1206:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199934636509725575)
,p_list_item_display_sequence=>1120
,p_list_item_link_text=>'Comments'
,p_list_item_link_target=>'f?p=&APP_ID.:1405:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199935042466725575)
,p_list_item_display_sequence=>1130
,p_list_item_link_text=>'Data Tables and Reports'
,p_list_item_link_target=>'f?p=&APP_ID.:3400:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199935812483725576)
,p_list_item_display_sequence=>1140
,p_list_item_link_text=>'Classic Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199935042466725575)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199936247089725576)
,p_list_item_display_sequence=>1150
,p_list_item_link_text=>'Interactive Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199935042466725575)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199937458556725577)
,p_list_item_display_sequence=>1160
,p_list_item_link_text=>'Interactive Grid'
,p_list_item_link_target=>'f?p=&APP_ID.:1410:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199935042466725575)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199935466844725576)
,p_list_item_display_sequence=>1140
,p_list_item_link_text=>'Forms'
,p_list_item_link_target=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199919456634725563)
,p_list_item_display_sequence=>360
,p_list_item_link_text=>'Form Modifiers'
,p_list_item_link_target=>'f?p=&APP_ID.:1601:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199935466844725576)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199919801571725563)
,p_list_item_display_sequence=>370
,p_list_item_link_text=>'Multi Column Layout'
,p_list_item_link_target=>'f?p=&APP_ID.:1602:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199935466844725576)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199936645857725576)
,p_list_item_display_sequence=>1150
,p_list_item_link_text=>'Help Text'
,p_list_item_link_target=>'f?p=&APP_ID.:1903:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199937014553725577)
,p_list_item_display_sequence=>1160
,p_list_item_link_text=>'Hero'
,p_list_item_link_target=>'f?p=&APP_ID.:1203:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199937816517725578)
,p_list_item_display_sequence=>1180
,p_list_item_link_text=>'Lists'
,p_list_item_link_target=>'f?p=&APP_ID.:1300:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199938264055725578)
,p_list_item_display_sequence=>1180
,p_list_item_link_text=>'Links List'
,p_list_item_link_target=>'f?p=&APP_ID.:1303:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199937816517725578)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199938673155725578)
,p_list_item_display_sequence=>1190
,p_list_item_link_text=>'Media List'
,p_list_item_link_target=>'f?p=&APP_ID.:1301:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199937816517725578)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199939015849725579)
,p_list_item_display_sequence=>1208
,p_list_item_link_text=>'Map Chart'
,p_list_item_link_target=>'f?p=&APP_ID.:1904:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199939488521725579)
,p_list_item_display_sequence=>1209
,p_list_item_link_text=>'Menu Bar'
,p_list_item_link_target=>'f?p=&APP_ID.:1305:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199940248049725579)
,p_list_item_display_sequence=>1210
,p_list_item_link_text=>'Menu Popup'
,p_list_item_link_target=>'f?p=&APP_ID.:1306:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199939871074725579)
,p_list_item_display_sequence=>1210
,p_list_item_link_text=>'Modal Dialogs'
,p_list_item_link_target=>'f?p=&APP_ID.:1906:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199940604541725580)
,p_list_item_display_sequence=>1220
,p_list_item_link_text=>'Page Modal'
,p_list_item_link_target=>'f?p=&APP_ID.:1910:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199939871074725579)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199941064558725580)
,p_list_item_display_sequence=>1230
,p_list_item_link_text=>'Inline Modal'
,p_list_item_link_target=>'f?p=&APP_ID.:1911:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199939871074725579)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199941457938725580)
,p_list_item_display_sequence=>1240
,p_list_item_link_text=>'PL/SQL Dynamic Content'
,p_list_item_link_target=>'f?p=&APP_ID.:1908:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199941824973725580)
,p_list_item_display_sequence=>1250
,p_list_item_link_text=>'Region Display Selector'
,p_list_item_link_target=>'f?p=&APP_ID.:1907:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199942279010725581)
,p_list_item_display_sequence=>1260
,p_list_item_link_text=>'Standard Region'
,p_list_item_link_target=>'f?p=&APP_ID.:1201:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199942630089725581)
,p_list_item_display_sequence=>1270
,p_list_item_link_text=>'Static Content'
,p_list_item_link_target=>'f?p=&APP_ID.:1905:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199943091597725581)
,p_list_item_display_sequence=>1280
,p_list_item_link_text=>'Title Bar Region'
,p_list_item_link_target=>'f?p=&APP_ID.:1207:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199943487824725581)
,p_list_item_display_sequence=>1290
,p_list_item_link_text=>'Tree'
,p_list_item_link_target=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199943813522725582)
,p_list_item_display_sequence=>1310
,p_list_item_link_text=>'Value Attribute Pairs Report'
,p_list_item_link_target=>'f?p=&APP_ID.:1403:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199944253783725582)
,p_list_item_display_sequence=>1320
,p_list_item_link_text=>'Wizards'
,p_list_item_link_target=>'f?p=&APP_ID.:1208:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199916206798725560)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199917882611725561)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Migration Guide'
,p_list_item_link_target=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-tasks'
,p_list_text_06=>'u-color-11'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199929086519725570)
,p_list_item_display_sequence=>770
,p_list_item_link_text=>'From Universal Theme v1.0'
,p_list_item_link_target=>'f?p=&APP_ID.:1909:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199917882611725561)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199929423586725571)
,p_list_item_display_sequence=>780
,p_list_item_link_text=>'From Other Themes'
,p_parent_list_item_id=>wwv_flow_api.id(2199917882611725561)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199921480975725564)
,p_list_item_display_sequence=>530
,p_list_item_link_text=>'Why Migrate'
,p_list_item_link_target=>'f?p=&APP_ID.:2010:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199929423586725571)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199921899733725565)
,p_list_item_display_sequence=>540
,p_list_item_link_text=>'Migration Steps'
,p_list_item_link_target=>'f?p=&APP_ID.:2020:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199929423586725571)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199922235425725565)
,p_list_item_display_sequence=>550
,p_list_item_link_text=>'Post Migration'
,p_list_item_link_target=>'f?p=&APP_ID.:2030:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199929423586725571)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199922629181725565)
,p_list_item_display_sequence=>560
,p_list_item_link_text=>'Bookmarklet'
,p_list_item_link_target=>'f?p=&APP_ID.:2040:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199929423586725571)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199923016509725566)
,p_list_item_display_sequence=>570
,p_list_item_link_text=>'FAQ'
,p_list_item_link_target=>'f?p=&APP_ID.:2050:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199929423586725571)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199918228951725562)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Icons'
,p_list_item_link_target=>'f?p=&APP_ID.:4000:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-apex'
,p_list_text_06=>'u-color-9'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199918651863725562)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Reference'
,p_list_item_link_target=>'f?p=&APP_ID.:6000:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-cogs'
,p_list_text_06=>'u-color-13'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'6000,6303,6304,6305,6306,2,6201'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199944661376725582)
,p_list_item_display_sequence=>1330
,p_list_item_link_text=>'Button Builder'
,p_list_item_link_target=>'f?p=&APP_ID.:6100:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199918651863725562)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199945031619725582)
,p_list_item_display_sequence=>1340
,p_list_item_link_text=>'Responsive Classes'
,p_list_item_link_target=>'f?p=&APP_ID.:6301:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199918651863725562)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199945441839725584)
,p_list_item_display_sequence=>1350
,p_list_item_link_text=>'Color and Status Modifiers'
,p_list_item_link_target=>'f?p=&APP_ID.:6302:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199918651863725562)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199945827934725585)
,p_list_item_display_sequence=>1360
,p_list_item_link_text=>'JavaScript Events'
,p_list_item_link_target=>'f?p=&APP_ID.:6200:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199918651863725562)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199946285768725585)
,p_list_item_display_sequence=>1370
,p_list_item_link_text=>'Component Templates'
,p_list_item_link_target=>'f?p=&APP_ID.:6307:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199918651863725562)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2199946614195725585)
,p_list_item_display_sequence=>1380
,p_list_item_link_text=>'Region Types'
,p_list_item_link_target=>'f?p=&APP_ID.:6308:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(2199918651863725562)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_progress_list
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(2285450736180797899)
,p_name=>'Wizard Progress List'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285451805253797903)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Step 1'
,p_list_item_link_target=>'f?p=&APP_ID.:1920:&SESSION.::&DEBUG.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285456678636797921)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Step 2'
,p_list_item_link_target=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285462162578797926)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Step 3'
,p_list_item_link_target=>'f?p=&APP_ID.:1922:&SESSION.::&DEBUG.'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_sample_tabs_list
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(2285543718406476760)
,p_name=>'UT - Sample Tabs List'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285543917158476761)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Tab 1'
,p_list_item_link_target=>'javascript:void(0);'
,p_list_item_icon=>'fa-user'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1907'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285544391396476761)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Tab 2'
,p_list_item_link_target=>'javascript:void(0);'
,p_list_item_icon=>'fa-heart-o'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2285544741435476761)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Tab 3'
,p_list_item_link_target=>'javascript:void(0);'
,p_list_item_icon=>'fa-cloud'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ut_sample_menu_bar_variation_1_list
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(2505356324704497838)
,p_name=>'UT - Sample Menu Bar Variation 1 List'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2505356552464497840)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Menu Item 1'
,p_list_item_icon=>'fa-cloud'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2505357768390497842)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Sub Menu Item 1.1'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(2505356552464497840)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2505358168401497842)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Sub Menu Item 1.2'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(2505356552464497840)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2505358574874497843)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Sub Menu Item 1.3'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(2505356552464497840)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2505356955981497842)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Menu Item 2'
,p_list_item_icon=>'fa-anchor'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2505358996211497844)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Sub Menu Item 2.1'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(2505356955981497842)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2505359340862497844)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Sub Menu Item 2.2'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(2505356955981497842)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2505360557572497844)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Sub Menu Item 2.2.1'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(2505359340862497844)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2505360991574497844)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Sub Menu Item 2.2.2'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(2505359340862497844)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2505361327831497845)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Sub Menu Item 2.2.3'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(2505359340862497844)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2505357383685497842)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Menu Item 3'
,p_list_item_icon=>'fa-archive'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2505359775199497844)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Sub Menu Item 3.1'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(2505357383685497842)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2505360190070497844)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Sub Menu Item 3.2'
,p_list_item_link_target=>'#'
,p_parent_list_item_id=>wwv_flow_api.id(2505357383685497842)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2505361729012497845)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Menu Item 4'
,p_list_item_link_target=>'#'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/files/bookmarklet_html
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '3C7374796C653E0A20202020626F6479207B0A2020202020202020746578742D616C69676E3A63656E7465723B0A202020207D0A2020202061207B0A2020202020202020666F6E742D66616D696C793A202748656C766574696361204E657565272C2027';
wwv_flow_api.g_varchar2_table(2) := '5365676F65205549272C2048656C7665746963612C20417269616C2C2073616E732D73657269663B0A2020202020202020666F6E742D73697A653A20312E35656D3B0A2020202020202020636F6C6F723A20233233373063323B0A202020202020202074';
wwv_flow_api.g_varchar2_table(3) := '6578742D6465636F726174696F6E3A206E6F6E653B0A202020207D0A202020207461626C65207B0A2020202020202020666F6E742D66616D696C793A202748656C766574696361204E657565272C20275365676F65205549272C2048656C766574696361';
wwv_flow_api.g_varchar2_table(4) := '2C20417269616C2C2073616E732D73657269663B0A2020202020202020666F6E742D73697A653A202E3735656D3B0A202020202020202077696474683A2033303070783B0A20202020202020206D617267696E3A206175746F3B0A20202020202020206D';
wwv_flow_api.g_varchar2_table(5) := '617267696E2D746F703A20323070783B0A202020207D0A202020207464207B0A2020202020202020766572746963616C2D616C69676E3A20746F703B0A2020202020202020626F726465723A20317078206772617920736F6C69643B0A202020207D0A20';
wwv_flow_api.g_varchar2_table(6) := '20202074643A66697273742D6368696C64207B0A2020202020202020666F6E742D7765696768743A20626F6C643B0A202020207D0A3C2F7374796C653E0A3C612069643D22636F64654F75742220687265663D276A6176617363726970743A2866756E63';
wwv_flow_api.g_varchar2_table(7) := '74696F6E28297B2866756E6374696F6E28297B69662877696E646F772E243D3D3D756E646566696E6564297B616C6572742822546F20757365207468697320626F6F6B6D61726B6C65742C20796F75206E65656420746F2C2066697273742C2064726167';
wwv_flow_api.g_varchar2_table(8) := '20697420696E746F20796F757220626F6F6B6D61726B206261727320616E64207468656E20636C69636B206F6E206974206F6E207061676520333836206F6620746865207468656D65207377697463682077697A6172642122293B72657475726E3B7D24';
wwv_flow_api.g_varchar2_table(9) := '2E676574536372697074282268747470733A2F2F617065782E6F7261636C652E636F6D2F706C732F617065782F617065785F706D2F722F34322F66696C65732F7374617469632F7639332F626F6F6B6D61726B6C65742E6A7322292E646F6E652866756E';
wwv_flow_api.g_varchar2_table(10) := '6374696F6E287363726970742C74657874537461747573297B636F6E736F6C652E6C6F672874657874537461747573293B7D292E6661696C2866756E6374696F6E286A717868722C73657474696E67732C657863657074696F6E297B7D293B7D2928293B';
wwv_flow_api.g_varchar2_table(11) := '7D2928293B273E556E6976657273616C205468656D65204D6967726174696F6E2048656C7065722056312E313C2F613E0A3C7461626C653E0A202020203C74686561643E0A20202020202020203C74723E0A2020202020202020202020203C74683E0A20';
wwv_flow_api.g_varchar2_table(12) := '20202020202020202020202020202056657273696F6E0A2020202020202020202020203C2F74683E0A2020202020202020202020203C74683E0A20202020202020202020202020202020446174650A2020202020202020202020203C2F74683E0A202020';
wwv_flow_api.g_varchar2_table(13) := '2020202020202020203C74683E0A202020202020202020202020202020204368616E6765730A2020202020202020202020203C2F74683E0A20202020202020203C2F74723E0A202020203C2F74686561643E0A202020203C74626F64793E0A2020202020';
wwv_flow_api.g_varchar2_table(14) := '2020203C74723E0A2020202020202020202020203C74643E0A20202020202020202020202020202020312E310A2020202020202020202020203C2F74643E0A2020202020202020202020203C74643E0A20202020202020202020202020202020362F3139';
wwv_flow_api.g_varchar2_table(15) := '2F31350A2020202020202020202020203C2F74643E0A2020202020202020202020203C74643E0A202020202020202020202020202020205468656D652032312C2032322C20323320737570706F72743C62722F3E496E7465726E6574204578706C6F7265';
wwv_flow_api.g_varchar2_table(16) := '7220537570706F72742E203C62722F3E204175746F205570646174696E670A2020202020202020202020203C2F74643E0A20202020202020203C2F74723E0A20202020202020203C74723E0A2020202020202020202020203C74643E0A20202020202020';
wwv_flow_api.g_varchar2_table(17) := '202020202020202020312E30310A2020202020202020202020203C2F74643E0A2020202020202020202020203C74643E0A20202020202020202020202020202020352F31332F31350A2020202020202020202020203C2F74643E0A202020202020202020';
wwv_flow_api.g_varchar2_table(18) := '2020203C74643E0A2020202020202020202020202020202046697265666F7820537570706F72740A2020202020202020202020203C2F74643E0A20202020202020203C2F74723E0A20202020202020203C74723E0A2020202020202020202020203C7464';
wwv_flow_api.g_varchar2_table(19) := '3E0A20202020202020202020202020202020312E300A2020202020202020202020203C2F74643E0A2020202020202020202020203C74643E0A0A2020202020202020202020203C2F74643E0A2020202020202020202020203C74643E0A20202020202020';
wwv_flow_api.g_varchar2_table(20) := '202020202020202020496E697469616C2052656C656173650A2020202020202020202020203C2F74643E0A20202020202020203C2F74723E0A202020203C2F74626F64793E0A3C2F7461626C653E0A';
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784237817002151244)
,p_file_name=>'bookmarklet.html'
,p_mime_type=>'text/html'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/bookmarklet_js
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '0A2F2A210A20202020436F707972696768742028632920323031342C204F7261636C6520616E642F6F722069747320616666696C69617465732E20416C6C207269676874732072657365727665642E0A202A2F0A2866756E6374696F6E2829207B0A2020';
wwv_flow_api.g_varchar2_table(2) := '20206966202877696E646F772E24203D3D3D20756E646566696E656429207B0A2020202020202020616C6572742822546F20757365207468697320626F6F6B6D61726B6C65742C20796F75206E65656420746F2C2066697273742C206472616720697420';
wwv_flow_api.g_varchar2_table(3) := '696E746F20796F757220626F6F6B6D61726B206261727320616E64207468656E20636C69636B206F6E206974206F6E207061676520333836206F6620746865207468656D65207377697463682077697A6172642122293B0A202020202020202072657475';
wwv_flow_api.g_varchar2_table(4) := '726E3B0A202020207D0A0A0A0A202020207661722057524954455F4D4F4445203D20747275653B0A0A0A20202020766172207468656D653231416E645468656D6532324D617070696E67203D207B0A20202020202020202242726561646372756D62223A';
wwv_flow_api.g_varchar2_table(5) := '207B0A2020202020202020202020202242726561646372756D62204D656E75223A202242726561646372756D62220A20202020202020207D2C0A202020202020202022427574746F6E223A207B0A20202020202020202020202022486F7420427574746F';
wwv_flow_api.g_varchar2_table(6) := '6E202852656429223A202254657874222C0A20202020202020202020202022486F7420427574746F6E2028426C61636B29223A202254657874222C0A20202020202020202020202022486F7420427574746F6E2028526564204F75746C696E6529223A20';
wwv_flow_api.g_varchar2_table(7) := '2254657874222C0A20202020202020202020202022536D616C6C20427574746F6E223A202254657874222C0A20202020202020202020202022427574746F6E223A202254657874222C0A2020202020202020202020202248544D4C20627574746F6E2028';
wwv_flow_api.g_varchar2_table(8) := '6C6567616379202D20415045582035206D6967726174696F6E29223A202254657874222C0A2020202020202020202020202248544D4C20696D61676520286C6567616379202D20415045582035206D6967726174696F6E29223A202254657874222C0A20';
wwv_flow_api.g_varchar2_table(9) := '202020202020202020202022536D616C6C20486F7420427574746F6E202852656429223A202254657874220A20202020202020207D2C0A2020202020202020224C6162656C223A207B0A202020202020202020202020225265717569726564223A202252';
wwv_flow_api.g_varchar2_table(10) := '65717569726564222C0A20202020202020202020202022526571756972656420776974682068656C70223A20225265717569726564222C0A202020202020202020202020224F7074696F6E616C223A20224F7074696F6E616C222C0A2020202020202020';
wwv_flow_api.g_varchar2_table(11) := '20202020224E6F204C6162656C223A202248696464656E222C0A202020202020202020202020224F7074696F6E616C20776974682068656C70223A20224F7074696F6E616C220A20202020202020207D2C0A2020202020202020224C6567616379204361';
wwv_flow_api.g_varchar2_table(12) := '6C656E646172223A207B0A2020202020202020202020202243616C656E646172223A202243616C656E646172222C0A2020202020202020202020202243616C656E6461722C20416C7465726E61746976652031223A202243616C656E646172222C0A2020';
wwv_flow_api.g_varchar2_table(13) := '2020202020202020202022536D616C6C2043616C656E646172223A202243616C656E646172220A20202020202020207D2C0A2020202020202020224C697374223A207B0A20202020202020202020202022486F72697A6F6E74616C205461627320526F75';
wwv_flow_api.g_varchar2_table(14) := '6E646564204C697374202846756C6C20576964746829223A202254616273222C0A2020202020202020202020202248696572617263686963616C20457870616E64696E67223A20224C696E6B73204C697374222C0A20202020202020202020202022486F';
wwv_flow_api.g_varchar2_table(15) := '72697A6F6E74616C20496D616765732077697468204C6162656C204C697374223A20224D65646961204C697374222C0A20202020202020202020202022566572746963616C20496D61676573204C697374223A20224D65646961204C697374222C0A2020';
wwv_flow_api.g_varchar2_table(16) := '2020202020202020202022546162626564204E617669676174696F6E204C697374223A202254616273222C0A202020202020202020202020224448544D4C2054726565223A20224C696E6B73204C697374222C0A2020202020202020202020202257697A';
wwv_flow_api.g_varchar2_table(17) := '6172642050726F6772657373204C6973742C20486F72697A6F6E74616C20547261696E223A202257697A6172642050726F6772657373222C0A2020202020202020202020202257697A6172642050726F6772657373204C697374223A202257697A617264';
wwv_flow_api.g_varchar2_table(18) := '2050726F6772657373222C0A20202020202020202020202022566572746963616C20556E6F726465726564204C69737420776974682042756C6C6574732C20416C7465726E6174697665223A20224C696E6B73204C697374222C0A202020202020202020';
wwv_flow_api.g_varchar2_table(19) := '2020202250756C6C20446F776E204D656E75207769746820496D616765223A20224C696E6B73204C697374222C0A20202020202020202020202022427574746F6E204C697374223A20224C696E6B73204C697374222C0A20202020202020202020202022';
wwv_flow_api.g_varchar2_table(20) := '486F72697A6F6E74616C205461627320526F756E646564204C697374223A202254616273222C0A20202020202020202020202022566572746963616C204F726465726564204C697374223A20224C696E6B73204C697374222C0A20202020202020202020';
wwv_flow_api.g_varchar2_table(21) := '202022566572746963616C20556E6F726465726564204C69737420776974686F75742042756C6C657473223A20224C696E6B73204C697374222C0A20202020202020202020202022566572746963616C20556E6F726465726564204C6973742077697468';
wwv_flow_api.g_varchar2_table(22) := '2042756C6C657473223A20224C696E6B73204C697374222C0A2020202020202020202020202250756C6C20446F776E204D656E75223A20224C696E6B73204C697374222C0A20202020202020202020202022486F72697A6F6E74616C204C696E6B73204C';
wwv_flow_api.g_varchar2_table(23) := '697374223A20224D65646961204C697374222C0A2020202020202020202020202250616765204C6576656C2054616273204C697374223A2022546F70204E617669676174696F6E204D656E75222C0A20202020202020202020202022566572746963616C';
wwv_flow_api.g_varchar2_table(24) := '2053696465626172204C697374223A20224C696E6B73204C697374222C0A2020202020202020202020202243656E74657265642054616220536574223A202254616273220A20202020202020207D2C0A20202020202020202250616765223A207B0A2020';
wwv_flow_api.g_varchar2_table(25) := '20202020202020202020224F6E65204C6576656C2054616273202D204C65667420616E642052696768742053696465626172202866697865642D7769647468202F20444956206C65667420616E64206F7074696F6E616C207461626C652D626173656420';
wwv_flow_api.g_varchar2_table(26) := '726967687429223A20224C65667420616E64205269676874205369646520436F6C756D6E73222C0A202020202020202020202020224E6F2054616273202D205269676874205369646562617220286F7074696F6E616C202F207461626C652D6261736564';
wwv_flow_api.g_varchar2_table(27) := '29223A20225374616E64617264222C0A202020202020202020202020225072696E74657220467269656E646C79223A20224D696E696D616C20284E6F204E617669676174696F6E29222C0A202020202020202020202020224C6F67696E223A20224C6F67';
wwv_flow_api.g_varchar2_table(28) := '696E222C0A2020202020202020202020202254776F204C6576656C2054616273202D204C6566742053696465626172202866697865642D7769647468202F2044495620626173656429223A20224C656674205369646520436F6C756D6E222C0A20202020';
wwv_flow_api.g_varchar2_table(29) := '2020202020202020224E6F2054616273202D2052696768742053696465626172202866697865642D7769647468202F2044495620626173656429223A20225269676874205369646520436F6C756D6E222C0A2020202020202020202020202254776F204C';
wwv_flow_api.g_varchar2_table(30) := '6576656C2054616273202D2052696768742053696465626172202866697865642D7769647468202F2044495620626173656429223A20225269676874205369646520436F6C756D6E222C0A202020202020202020202020224E6F2054616273202D204C65';
wwv_flow_api.g_varchar2_table(31) := '66742053696465626172202866697865642D7769647468202F2044495620626173656429223A20224C656674205369646520436F6C756D6E222C0A202020202020202020202020224F6E65204C6576656C2054616273202D204C65667420536964656261';
wwv_flow_api.g_varchar2_table(32) := '72202866697865642D7769647468202F2044495620626173656429223A20224C656674205369646520436F6C756D6E222C0A20202020202020202020202022506F707570223A20224D696E696D616C20284E6F204E617669676174696F6E29220A202020';
wwv_flow_api.g_varchar2_table(33) := '20202020207D2C0A202020202020202022526567696F6E223A207B0A2020202020202020202020202249525220526567696F6E2054656D706C617465223A2022496E746572616374697665205265706F7274222C0A202020202020202020202020224272';
wwv_flow_api.g_varchar2_table(34) := '6561646372756D6220526567696F6E223A20225469746C6520426172222C0A202020202020202020202020225265706F72747320526567696F6E223A20225374616E64617264222C0A2020202020202020202020202257697A61726420526567696F6E22';
wwv_flow_api.g_varchar2_table(35) := '3A20225374616E64617264222C0A202020202020202020202020225369646562617220526567696F6E2C20426F726465726564223A20225374616E64617264222C0A20202020202020202020202022427261636B6574656420526567696F6E223A202253';
wwv_flow_api.g_varchar2_table(36) := '74616E64617264222C0A2020202020202020202020202243656E7465726564205461622053657420526567696F6E223A20225374616E64617264222C0A202020202020202020202020225369646562617220526567696F6E223A20225374616E64617264';
wwv_flow_api.g_varchar2_table(37) := '222C0A202020202020202020202020225265706F72747320526567696F6E204E6F205469746C652C20416C7465726E61746976652031223A20225374616E64617264222C0A202020202020202020202020224E617669676174696F6E20526567696F6E22';
wwv_flow_api.g_varchar2_table(38) := '3A20225374616E64617264222C0A20202020202020202020202022466F726D20526567696F6E223A20225374616E64617264222C0A202020202020202020202020225369646562617220526567696F6E2C20426F72646572656420416C7465726E617469';
wwv_flow_api.g_varchar2_table(39) := '7665223A20225374616E64617264222C0A20202020202020202020202022427574746F6E20526567696F6E2077697468205469746C65223A2022427574746F6E7320436F6E7461696E6572222C0A20202020202020202020202022536964656261722052';
wwv_flow_api.g_varchar2_table(40) := '6567696F6E2C20416C7465726E61746976652031223A20225374616E64617264222C0A202020202020202020202020224E657374656420526567696F6E223A20225374616E64617264222C0A202020202020202020202020225265706F72747320526567';
wwv_flow_api.g_varchar2_table(41) := '696F6E204E6F205469746C65223A20225374616E64617264222C0A20202020202020202020202022427574746F6E20526567696F6E20776974686F7574205469746C65223A2022427574746F6E7320436F6E7461696E6572222C0A202020202020202020';
wwv_flow_api.g_varchar2_table(42) := '202020225265706F72747320526567696F6E2C20416C7465726E61746976652031223A20225374616E64617264222C0A202020202020202020202020224869646520616E642053686F7720526567696F6E223A2022436F6C6C61707369626C65222C0A20';
wwv_flow_api.g_varchar2_table(43) := '2020202020202020202020224368617274204C697374223A20225374616E64617264222C0A20202020202020202020202022526567696F6E20776974686F7574205469746C65223A20225374616E64617264222C0A202020202020202020202020225265';
wwv_flow_api.g_varchar2_table(44) := '67696F6E20776974686F757420427574746F6E7320616E64205469746C6573223A20225374616E64617264222C0A20202020202020202020202022426F726465726C65737320526567696F6E202D204E6F205469746C65223A2022426C616E6B20776974';
wwv_flow_api.g_varchar2_table(45) := '682041747472696275746573222C0A202020202020202020202020225265706F72747320526567696F6E2031303025205769647468223A20225374616E64617264222C0A20202020202020202020202022436861727420526567696F6E223A2022537461';
wwv_flow_api.g_varchar2_table(46) := '6E64617264222C0A20202020202020202020202022426F726465726C65737320526567696F6E223A20225374616E64617264222C0A202020202020202020202020224E617669676174696F6E20526567696F6E2C20416C7465726E61746976652031223A';
wwv_flow_api.g_varchar2_table(47) := '20225374616E64617264222C0A2020202020202020202020202257697A61726420526567696F6E20776974682049636F6E223A20225374616E64617264220A20202020202020207D2C0A2020202020202020225265706F7274223A207B0A202020202020';
wwv_flow_api.g_varchar2_table(48) := '202020202020225374616E64617264223A20225374616E64617264222C0A2020202020202020202020202256616C756520417474726962757465205061697273202D20446976223A202256616C756520417474726962757465205061697273202D20436F';
wwv_flow_api.g_varchar2_table(49) := '6C756D6E222C0A202020202020202020202020225374616E646172642C20416C7465726E6174696E6720526F7720436F6C6F7273223A20225374616E64617264222C0A2020202020202020202020202246697865642048656164657273223A2022537461';
wwv_flow_api.g_varchar2_table(50) := '6E64617264222C0A20202020202020202020202022426F726465726C657373205265706F7274223A202253656172636820526573756C7473222C0A2020202020202020202020202254776F20436F6C756D6E20506F72746C6574223A202256616C756520';
wwv_flow_api.g_varchar2_table(51) := '417474726962757465205061697273202D20526F77222C0A20202020202020202020202022486F72697A6F6E74616C20426F72646572223A20225374616E64617264222C0A2020202020202020202020202253656172636820526573756C747320526570';
wwv_flow_api.g_varchar2_table(52) := '6F7274202853454C454354206C696E6B5F746578742C206C696E6B5F7461726765742C2064657461696C312C2064657461696C322C206C6173745F6D6F64696669656429223A202253656172636820526573756C7473220A20202020202020207D0A2020';
wwv_flow_api.g_varchar2_table(53) := '20207D3B0A0A202020202F2A2A0A20202020202A204D616B6520616E79204A534F4E206368616E67657320746F20746865206F626A6563742062656C6F772E0A20202020202A2F0A2020202076617220737570706F727465645468656D6573203D207B0A';
wwv_flow_api.g_varchar2_table(54) := '202020202020202032363A207B0A202020202020202020202020696D6167653A202268747470733A2F2F617065782E6F7261636C652E636F6D2F706C732F617065782F617065785F706D2F722F34322F66696C65732F7374617469632F7638342F2F692F';
wwv_flow_api.g_varchar2_table(55) := '7468656D6532362E706E67222C0A202020202020202020202020746578743A20225468656D65203236202D2050726F647563746976697479204170706C69636174696F6E73222C0A2020202020202020202020206D617070696E67733A207B0A20202020';
wwv_flow_api.g_varchar2_table(56) := '2020202020202020202020202242726561646372756D62223A207B0A20202020202020202020202020202020202020202242726561646372756D62204D656E75223A202242726561646372756D62222C0A20202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(57) := '202248696572617263686963616C204D656E75223A202242726561646372756D62220A202020202020202020202020202020207D2C0A2020202020202020202020202020202022427574746F6E223A207B0A202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(58) := '2020225B202B205D2041646420427574746F6E223A202249636F6E222C0A2020202020202020202020202020202020202020225B203E205D20476F20546F20427574746F6E223A202249636F6E222C0A2020202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(59) := '225B2054657874205D20427574746F6E223A202254657874222C0A202020202020202020202020202020202020202022427574746F6E223A202254657874222C0A20202020202020202020202020202020202020202248544D4C20627574746F6E20286C';
wwv_flow_api.g_varchar2_table(60) := '6567616379202D20415045582035206D6967726174696F6E29223A202254657874222C0A202020202020202020202020202020202020202022496E746572616374697665205265706F727420427574746F6E20284E65787429223A202254657874207769';
wwv_flow_api.g_varchar2_table(61) := '74682049636F6E222C0A202020202020202020202020202020202020202022496E746572616374697665205265706F727420427574746F6E223A202254657874222C0A2020202020202020202020202020202020202020224C6172676520427574746F6E';
wwv_flow_api.g_varchar2_table(62) := '20284E65787429223A20225465787420776974682049636F6E222C0A2020202020202020202020202020202020202020224C6172676520427574746F6E202850726576696F757329223A20225465787420776974682049636F6E222C0A20202020202020';
wwv_flow_api.g_varchar2_table(63) := '20202020202020202020202020224C6172676520427574746F6E223A202254657874222C0A202020202020202020202020202020202020202022536D616C6C20427574746F6E223A202254657874220A202020202020202020202020202020207D2C0A20';
wwv_flow_api.g_varchar2_table(64) := '202020202020202020202020202020224C6162656C223A207B0A20202020202020202020202020202020202020202248696464656E206C6162656C2C20726561642062792073637265656E20726561646572223A202248696464656E222C0A2020202020';
wwv_flow_api.g_varchar2_table(65) := '202020202020202020202020202020224E6F204C6162656C223A202248696464656E222C0A2020202020202020202020202020202020202020224F7074696F6E616C20776974682068656C70223A20224F7074696F6E616C222C0A202020202020202020';
wwv_flow_api.g_varchar2_table(66) := '2020202020202020202020224F7074696F6E616C223A20224F7074696F6E616C222C0A202020202020202020202020202020202020202022526571756972656420776974682068656C70223A20225265717569726564222C0A2020202020202020202020';
wwv_flow_api.g_varchar2_table(67) := '202020202020202020225265717569726564223A20225265717569726564220A202020202020202020202020202020207D2C0A20202020202020202020202020202020224C65676163792043616C656E646172223A207B0A202020202020202020202020';
wwv_flow_api.g_varchar2_table(68) := '20202020202020202243616C656E646172202D20416C7465726E6174697665223A202243616C656E646172222C0A20202020202020202020202020202020202020202243616C656E646172223A202243616C656E646172222C0A20202020202020202020';
wwv_flow_api.g_varchar2_table(69) := '2020202020202020202022536D616C6C2043616C656E646172223A202243616C656E646172220A202020202020202020202020202020207D2C0A20202020202020202020202020202020224C697374223A207B0A20202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(70) := '2020202022427574746F6E204C697374223A20224C696E6B73204C697374222C0A2020202020202020202020202020202020202020224448544D4C2054726565223A20224C696E6B73204C697374222C0A20202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(71) := '20224665617475726564204C69737420776974682053756274657874223A20224D65646961206C697374222C0A20202020202020202020202020202020202020202248696572617263686963616C20457870616E64696E67223A20224C696E6B73204C69';
wwv_flow_api.g_varchar2_table(72) := '7374222C0A202020202020202020202020202020202020202022486F72697A6F6E74616C20496D616765732077697468204C6162656C204C697374223A20224D65646961204C697374222C0A202020202020202020202020202020202020202022486F72';
wwv_flow_api.g_varchar2_table(73) := '697A6F6E74616C204C696E6B73204C697374223A20224D65646961204C697374222C0A202020202020202020202020202020202020202022486F72697A6F6E74616C2057697A6172642050726F6772657373204C697374223A202257697A617264205072';
wwv_flow_api.g_varchar2_table(74) := '6F6772657373222C0A20202020202020202020202020202020202020202250616765204C6576656C2054616273204C697374223A2022546F70204E617669676174696F6E204D656E75222C0A20202020202020202020202020202020202020202250756C';
wwv_flow_api.g_varchar2_table(75) := '6C20446F776E204D656E75207769746820496D616765223A20224C696E6B73204C697374222C0A20202020202020202020202020202020202020202250756C6C20446F776E204D656E75223A20224C696E6B73204C697374222C0A202020202020202020';
wwv_flow_api.g_varchar2_table(76) := '2020202020202020202020225365617263682046696C7465722054616273223A202254616273222C0A202020202020202020202020202020202020202022546162626564204E617669676174696F6E204C697374223A202254616273222C0A2020202020';
wwv_flow_api.g_varchar2_table(77) := '20202020202020202020202020202022566572746963616C20496D61676573204C697374223A20224D65646961204C697374222C0A202020202020202020202020202020202020202022566572746963616C204C69737420776974682053756274657874';
wwv_flow_api.g_varchar2_table(78) := '20616E642049636F6E223A20224D65646961204C697374222C0A202020202020202020202020202020202020202022566572746963616C204F726465726564204C697374223A20224C696E6B73204C697374222C0A202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(79) := '202020202022566572746963616C2053696465626172204C697374223A20224C696E6B73204C697374222C0A202020202020202020202020202020202020202022566572746963616C20556E6F726465726564204C69737420776974682042756C6C6574';
wwv_flow_api.g_varchar2_table(80) := '73223A20224C696E6B73204C697374222C0A202020202020202020202020202020202020202022566572746963616C20556E6F726465726564204C69737420776974686F75742042756C6C657473223A20224C696E6B73204C697374222C0A2020202020';
wwv_flow_api.g_varchar2_table(81) := '2020202020202020202020202020202257697A6172642050726F6772657373204C697374202D20566572746963616C223A202257697A6172642050726F6772657373220A202020202020202020202020202020207D2C0A20202020202020202020202020';
wwv_flow_api.g_varchar2_table(82) := '2020202250616765223A207B0A2020202020202020202020202020202020202020224469616C6F67223A20224D6F64616C204469616C6F67222C0A2020202020202020202020202020202020202020224C6F67696E223A20224C6F67696E222C0A202020';
wwv_flow_api.g_varchar2_table(83) := '2020202020202020202020202020202020224D696E696D616C2050616765223A20224D696E696D616C20284E6F204E617669676174696F6E29222C0A2020202020202020202020202020202020202020224E6F2054616273202D204C65667420616E6420';
wwv_flow_api.g_varchar2_table(84) := '52696768742053696465626172223A20224C65667420616E64205269676874205369646520436F6C756D6E73222C0A2020202020202020202020202020202020202020224E6F2054616273202D204C6566742053696465626172223A20224C6566742053';
wwv_flow_api.g_varchar2_table(85) := '69646520436F6C756D6E222C0A2020202020202020202020202020202020202020224E6F2054616273202D204E6F2053696465626172223A20225374616E64617264222C0A2020202020202020202020202020202020202020224E6F2054616273202D20';
wwv_flow_api.g_varchar2_table(86) := '52696768742053696465626172223A20225269676874205369646520436F6C756D6E222C0A2020202020202020202020202020202020202020224F6E65204C6576656C2054616273202D20436F6E74656E74204672616D65223A20224D61737465722044';
wwv_flow_api.g_varchar2_table(87) := '657461696C222C0A2020202020202020202020202020202020202020224F6E65204C6576656C2054616273202D204C65667420616E642052696768742053696465626172223A20224C65667420616E64205269676874205369646520436F6C756D6E222C';
wwv_flow_api.g_varchar2_table(88) := '0A2020202020202020202020202020202020202020224F6E65204C6576656C2054616273202D204C6566742053696465626172223A20224C656674205369646520436F6C756D6E222C0A2020202020202020202020202020202020202020224F6E65204C';
wwv_flow_api.g_varchar2_table(89) := '6576656C2054616273202D204E6F2053696465626172223A20225374616E64617264222C0A2020202020202020202020202020202020202020224F6E65204C6576656C2054616273202D2052696768742053696465626172223A20225269676874205369';
wwv_flow_api.g_varchar2_table(90) := '646520436F6C756D6E222C0A2020202020202020202020202020202020202020224F6E65204C6576656C2054616273202D205365617263682046696C74657220426172223A20224C656674205369646520436F6C756D6E222C0A20202020202020202020';
wwv_flow_api.g_varchar2_table(91) := '20202020202020202020224F6E65204C6576656C2054616273202D2057697A6172642050616765223A20225374616E64617264222C0A202020202020202020202020202020202020202022506F707570223A20224D696E696D616C20284E6F204E617669';
wwv_flow_api.g_varchar2_table(92) := '676174696F6E29222C0A2020202020202020202020202020202020202020225072696E74657220467269656E646C79223A20224D696E696D616C20284E6F204E617669676174696F6E29222C0A2020202020202020202020202020202020202020225477';
wwv_flow_api.g_varchar2_table(93) := '6F204C6576656C2054616273202D204C65667420616E642052696768742053696465626172223A20224C65667420616E64205269676874205369646520436F6C756D6E73222C0A20202020202020202020202020202020202020202254776F204C657665';
wwv_flow_api.g_varchar2_table(94) := '6C2054616273202D204C6566742053696465626172223A20224C656674205369646520436F6C756D6E222C0A20202020202020202020202020202020202020202254776F204C6576656C2054616273202D204E6F2053696465626172223A20225374616E';
wwv_flow_api.g_varchar2_table(95) := '64617264222C0A20202020202020202020202020202020202020202254776F204C6576656C2054616273202D2052696768742053696465626172223A20225269676874205369646520436F6C756D6E220A202020202020202020202020202020207D2C0A';
wwv_flow_api.g_varchar2_table(96) := '2020202020202020202020202020202022526567696F6E223A207B0A20202020202020202020202020202020202020202249525220526567696F6E2054656D706C617465223A2022496E746572616374697665205265706F7274222C0A20202020202020';
wwv_flow_api.g_varchar2_table(97) := '202020202020202020202020202241636365737369626C6520526567696F6E20776974682048656164696E67223A20225374616E64617264222C0A202020202020202020202020202020202020202022416C65727420526567696F6E223A2022416C6572';
wwv_flow_api.g_varchar2_table(98) := '74222C0A202020202020202020202020202020202020202022426F726465726C65737320526567696F6E20286E6F2068656164696E6729223A20225374616E64617264222C0A202020202020202020202020202020202020202022426F726465726C6573';
wwv_flow_api.g_varchar2_table(99) := '7320526567696F6E223A20225374616E64617264222C0A202020202020202020202020202020202020202022427261636B6574656420526567696F6E223A20225374616E64617264222C0A20202020202020202020202020202020202020202242726561';
wwv_flow_api.g_varchar2_table(100) := '646372756D6220526567696F6E223A20225469746C6520426172222C0A202020202020202020202020202020202020202022427574746F6E20526567696F6E2077697468205469746C65223A2022427574746F6E7320436F6E7461696E6572222C0A2020';
wwv_flow_api.g_varchar2_table(101) := '20202020202020202020202020202020202022427574746F6E20526567696F6E20776974686F7574205469746C65223A2022427574746F6E7320436F6E7461696E6572222C0A2020202020202020202020202020202020202020224368617274204C6973';
wwv_flow_api.g_varchar2_table(102) := '74223A20225374616E64617264222C0A202020202020202020202020202020202020202022436861727420526567696F6E223A20225374616E64617264222C0A202020202020202020202020202020202020202022436F6E74656E74204672616D652042';
wwv_flow_api.g_varchar2_table(103) := '6F647920436F6E7461696E6572223A2022426C616E6B20776974682041747472696275746573222C0A20202020202020202020202020202020202020202244495620526567696F6E2077697468204944223A2022426C616E6B2077697468204174747269';
wwv_flow_api.g_varchar2_table(104) := '6275746573222C0A202020202020202020202020202020202020202022466F726D20526567696F6E223A20225374616E64617264222C0A2020202020202020202020202020202020202020224869646520616E642053686F7720526567696F6E20284869';
wwv_flow_api.g_varchar2_table(105) := '6464656E20466972737429202D20426F726465726C657373223A2022436F6C6C61707369626C65222C0A2020202020202020202020202020202020202020224869646520616E642053686F7720526567696F6E202D20426F726465726C657373223A2022';
wwv_flow_api.g_varchar2_table(106) := '436F6C6C61707369626C65222C0A2020202020202020202020202020202020202020224869646520616E642053686F7720526567696F6E223A2022436F6C6C61707369626C65222C0A202020202020202020202020202020202020202022496E74657261';
wwv_flow_api.g_varchar2_table(107) := '6374697665205265706F727420526567696F6E223A2022496E746572616374697665205265706F7274222C0A2020202020202020202020202020202020202020226A5175657279204D6F64616C20526567696F6E2054656D706C617465223A2022496E6C';
wwv_flow_api.g_varchar2_table(108) := '696E65204469616C6F67222C0A2020202020202020202020202020202020202020224C6F67696E20526567696F6E223A20224C6F67696E222C0A2020202020202020202020202020202020202020224D6F64616C20526567696F6E223A2022496E6C696E';
wwv_flow_api.g_varchar2_table(109) := '65204469616C6F67222C0A2020202020202020202020202020202020202020224E617669676174696F6E20526567696F6E202D2048656164696E6720496E73696465223A20225374616E64617264222C0A20202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(110) := '20224E617669676174696F6E20526567696F6E223A20225374616E64617264222C0A202020202020202020202020202020202020202022526567696F6E20776974686F757420427574746F6E7320616E64205469746C6573223A20225374616E64617264';
wwv_flow_api.g_varchar2_table(111) := '222C0A202020202020202020202020202020202020202022526567696F6E20776974686F7574205469746C65223A20225374616E64617264222C0A2020202020202020202020202020202020202020225265706F72742046696C746572202D2053696E67';
wwv_flow_api.g_varchar2_table(112) := '6C6520526F77223A20225374616E64617264222C0A2020202020202020202020202020202020202020225265706F7274204C697374223A20225374616E64617264222C0A2020202020202020202020202020202020202020225265706F72747320526567';
wwv_flow_api.g_varchar2_table(113) := '696F6E202D2031303025205769647468223A20225374616E64617264222C0A2020202020202020202020202020202020202020225265706F72747320526567696F6E202D2048656164696E6720496E73696465223A20225374616E64617264222C0A2020';
wwv_flow_api.g_varchar2_table(114) := '202020202020202020202020202020202020225265706F72747320526567696F6E223A20225374616E64617264222C0A2020202020202020202020202020202020202020225363726F6C6C61626C6520436F6E74656E7420526567696F6E223A20225374';
wwv_flow_api.g_varchar2_table(115) := '616E64617264222C0A2020202020202020202020202020202020202020225365617263682046696C74657220526567696F6E223A20225374616E64617264222C0A2020202020202020202020202020202020202020225369646562617220526567696F6E';
wwv_flow_api.g_varchar2_table(116) := '202D2048656164696E6720496E73696465223A20225374616E64617264222C0A2020202020202020202020202020202020202020225369646562617220526567696F6E223A20225374616E64617264222C0A202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(117) := '20202257697A61726420427574746F6E73223A2022427574746F6E7320436F6E7461696E6572222C0A20202020202020202020202020202020202020202257697A61726420526567696F6E20776974682049636F6E223A20225374616E64617264222C0A';
wwv_flow_api.g_varchar2_table(118) := '20202020202020202020202020202020202020202257697A61726420526567696F6E223A20225374616E64617264220A202020202020202020202020202020207D2C0A20202020202020202020202020202020225265706F7274223A207B0A2020202020';
wwv_flow_api.g_varchar2_table(119) := '20202020202020202020202020202022426F726465726C657373205265706F7274223A20225374616E64617264222C0A202020202020202020202020202020202020202022436F6D6D656E7420427562626C6573223A2022436F6D6D656E7473222C0A20';
wwv_flow_api.g_varchar2_table(120) := '202020202020202020202020202020202020202246697865642048656164657273223A20225374616E64617264222C0A202020202020202020202020202020202020202022486F72697A6F6E74616C20426F72646572223A20225374616E64617264222C';
wwv_flow_api.g_varchar2_table(121) := '0A2020202020202020202020202020202020202020224F6E6520436F6C756D6E20556E6F726465726564204C697374223A20224C696E6B73204C697374222C0A20202020202020202020202020202020202020202253656172636820526573756C747320';
wwv_flow_api.g_varchar2_table(122) := '5265706F7274202853454C454354206C696E6B5F746578742C206C696E6B5F7461726765742C2064657461696C312C2064657461696C322C206C6173745F6D6F64696669656429223A202253656172636820526573756C7473222C0A2020202020202020';
wwv_flow_api.g_varchar2_table(123) := '202020202020202020202020225374616E64617264202D20416C7465726E6174697665223A20225374616E64617264222C0A2020202020202020202020202020202020202020225374616E64617264223A20225374616E64617264222C0A202020202020';
wwv_flow_api.g_varchar2_table(124) := '20202020202020202020202020202254776F20436F6C756D6E20506F72746C6574223A202256616C756520417474726962757465205061697273202D20526F77222C0A20202020202020202020202020202020202020202256616C756520417474726962';
wwv_flow_api.g_varchar2_table(125) := '757465205061697273202D204C65667420416C69676E6564223A202256616C756520417474726962757465205061697273202D20436F6C756D6E222C0A20202020202020202020202020202020202020202256616C756520417474726962757465205061';
wwv_flow_api.g_varchar2_table(126) := '697273223A202256616C756520417474726962757465205061697273202D20436F6C756D6E220A202020202020202020202020202020207D0A2020202020202020202020207D0A20202020202020207D2C0A202020202020202032353A207B0A20202020';
wwv_flow_api.g_varchar2_table(127) := '2020202020202020746578743A20225468656D65203235202D20426C756520526573706F6E73697665222C0A202020202020202020202020696D6167653A202268747470733A2F2F617065782E6F7261636C652E636F6D2F706C732F617065782F617065';
wwv_flow_api.g_varchar2_table(128) := '785F706D2F722F34322F66696C65732F7374617469632F7638342F2F692F7468656D6532352E706E67222C0A2020202020202020202020206D617070696E67733A207B0A202020202020202020202020202020202242726561646372756D62223A207B0A';
wwv_flow_api.g_varchar2_table(129) := '20202020202020202020202020202020202020202242726561646372756D62204D656E75223A202242726561646372756D62220A202020202020202020202020202020207D2C0A2020202020202020202020202020202022427574746F6E223A207B0A20';
wwv_flow_api.g_varchar2_table(130) := '2020202020202020202020202020202020202022427574746F6E202D2049636F6E204F6E6C79223A2249636F6E222C0A202020202020202020202020202020202020202022427574746F6E202D2049636F6E223A225465787420776974682049636F6E22';
wwv_flow_api.g_varchar2_table(131) := '2C0A202020202020202020202020202020202020202022427574746F6E223A202254657874222C0A20202020202020202020202020202020202020202248544D4C20627574746F6E20286C6567616379202D20415045582035206D6967726174696F6E29';
wwv_flow_api.g_varchar2_table(132) := '223A202254657874222C0A2020202020202020202020202020202020202020224C6172676520427574746F6E202D2049636F6E204F6E6C79223A202254657874222C0A2020202020202020202020202020202020202020224C6172676520427574746F6E';
wwv_flow_api.g_varchar2_table(133) := '202D2049636F6E223A202249636F6E222C0A2020202020202020202020202020202020202020224C6172676520427574746F6E223A202249636F6E220A202020202020202020202020202020207D2C0A20202020202020202020202020202020224C6162';
wwv_flow_api.g_varchar2_table(134) := '656C223A207B0A20202020202020202020202020202020202020202248696464656E204C6162656C2028526561642062792053637265656E205265616465727329223A202248696464656E222C0A2020202020202020202020202020202020202020224F';
wwv_flow_api.g_varchar2_table(135) := '7074696F6E616C2028486F72697A6F6E74616C202D204C65667420416C69676E656429223A20224F7074696F6E616C222C0A2020202020202020202020202020202020202020224F7074696F6E616C2028486F72697A6F6E74616C202D20526967687420';
wwv_flow_api.g_varchar2_table(136) := '416C69676E656429223A20224F7074696F6E616C222C0A2020202020202020202020202020202020202020224F7074696F6E616C20284C6162656C2041626F766529223A20224F7074696F6E616C222C0A20202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(137) := '202252657175697265642028486F72697A6F6E74616C202D204C65667420416C69676E656429223A20224F7074696F6E616C222C0A20202020202020202020202020202020202020202252657175697265642028486F72697A6F6E74616C202D20526967';
wwv_flow_api.g_varchar2_table(138) := '687420416C69676E656429223A20224F7074696F6E616C222C0A202020202020202020202020202020202020202022526571756972656420284C6162656C2041626F766529223A20224F7074696F6E616C220A202020202020202020202020202020207D';
wwv_flow_api.g_varchar2_table(139) := '2C0A20202020202020202020202020202020224C65676163792043616C656E646172223A207B0A20202020202020202020202020202020202020202243616C656E646172223A202243616C656E646172220A202020202020202020202020202020207D2C';
wwv_flow_api.g_varchar2_table(140) := '0A20202020202020202020202020202020224C697374223A207B0A202020202020202020202020202020202020202022427574746F6E204C697374223A20224C696E6B73204C697374222C0A202020202020202020202020202020202020202022466561';
wwv_flow_api.g_varchar2_table(141) := '7475726564204C69737420776974682053756274657874223A224D65646961204C697374222C0A202020202020202020202020202020202020202022486F72697A6F6E74616C20496D616765732077697468204C6162656C204C697374223A20224D6564';
wwv_flow_api.g_varchar2_table(142) := '6961204C697374222C0A202020202020202020202020202020202020202022486F72697A6F6E74616C204C696E6B73204C697374223A20224D65646961204C697374222C0A202020202020202020202020202020202020202022486F72697A6F6E74616C';
wwv_flow_api.g_varchar2_table(143) := '2057697A6172642050726F6772657373204C697374223A202257697A6172642050726F6772657373222C0A20202020202020202020202020202020202020202250616765204C6576656C2054616273204C697374223A2022546F70204E61766967617469';
wwv_flow_api.g_varchar2_table(144) := '6F6E204D656E75222C0A202020202020202020202020202020202020202022546162626564204E617669676174696F6E204C697374223A2254616273222C0A202020202020202020202020202020202020202022566572746963616C20496D6167657320';
wwv_flow_api.g_varchar2_table(145) := '4C697374223A20224D65646961204C697374222C0A202020202020202020202020202020202020202022566572746963616C204C6973742077697468205375627465787420616E642049636F6E223A224D65646961204C697374222C0A20202020202020';
wwv_flow_api.g_varchar2_table(146) := '2020202020202020202020202022566572746963616C204F726465726564204C697374223A20224C696E6B73204C697374222C0A202020202020202020202020202020202020202022566572746963616C2053696465626172204C697374223A20224C69';
wwv_flow_api.g_varchar2_table(147) := '6E6B73204C697374222C0A202020202020202020202020202020202020202022566572746963616C20556E6F726465726564204C69737420776974682042756C6C657473223A20224C696E6B73204C697374222C0A202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(148) := '202020202022566572746963616C20556E6F726465726564204C69737420776974686F75742042756C6C657473223A20224C696E6B73204C697374222C0A20202020202020202020202020202020202020202257697A6172642050726F6772657373204C';
wwv_flow_api.g_varchar2_table(149) := '697374202D20566572746963616C223A202257697A6172642050726F6772657373220A202020202020202020202020202020207D2C0A202020202020202020202020202020202250616765223A207B0A2020202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(150) := '224469616C6F67223A224D6F64616C204469616C6F67222C0A2020202020202020202020202020202020202020224C6F67696E223A20224C6F67696E222C0A2020202020202020202020202020202020202020224E6F2054616273202D204C6566742061';
wwv_flow_api.g_varchar2_table(151) := '6E642052696768742053696465626172223A224C65667420616E64205269676874205369646520436F6C756D6E222C0A2020202020202020202020202020202020202020224E6F2054616273202D204C6566742053696465626172223A20224C65667420';
wwv_flow_api.g_varchar2_table(152) := '5369646520436F6C756D6E222C0A2020202020202020202020202020202020202020224E6F2054616273202D204E6F2053696465626172223A20225374616E64617264222C0A2020202020202020202020202020202020202020224E6F2054616273202D';
wwv_flow_api.g_varchar2_table(153) := '2052696768742053696465626172223A225269676874205369646520436F6C756D6E222C0A2020202020202020202020202020202020202020224F6E65204C6576656C2054616273202D20436F6E74656E74204672616D65223A20224D61737465722044';
wwv_flow_api.g_varchar2_table(154) := '657461696C222C0A2020202020202020202020202020202020202020224F6E65204C6576656C2054616273202D204C65667420616E642052696768742053696465626172223A20224C65667420616E64205269676874205369646520436F6C756D6E222C';
wwv_flow_api.g_varchar2_table(155) := '0A2020202020202020202020202020202020202020224F6E65204C6576656C2054616273202D204C6566742053696465626172223A20224C656674205369646520436F6C756D6E222C0A2020202020202020202020202020202020202020224F6E65204C';
wwv_flow_api.g_varchar2_table(156) := '6576656C2054616273202D204E6F2053696465626172223A20225374616E64617264222C0A2020202020202020202020202020202020202020224F6E65204C6576656C2054616273202D2052696768742053696465626172223A20225269676874205369';
wwv_flow_api.g_varchar2_table(157) := '646520436F6C756D6E222C0A2020202020202020202020202020202020202020224F6E65204C6576656C2054616273202D2057697A6172642050616765223A20225374616E64617264222C0A202020202020202020202020202020202020202022506F70';
wwv_flow_api.g_varchar2_table(158) := '7570223A20224D696E696D616C20284E6F204E617669676174696F6E29222C0A2020202020202020202020202020202020202020225072696E74657220467269656E646C79223A20224D696E696D616C20284E6F204E617669676174696F6E29222C0A20';
wwv_flow_api.g_varchar2_table(159) := '202020202020202020202020202020202020202254776F204C6576656C2054616273202D204C65667420616E642052696768742053696465626172223A20224C65667420616E64205269676874205369646520436F6C756D6E222C0A2020202020202020';
wwv_flow_api.g_varchar2_table(160) := '2020202020202020202020202254776F204C6576656C2054616273202D204C6566742053696465626172223A20224C656674205369646520436F6C756D6E222C0A20202020202020202020202020202020202020202254776F204C6576656C2054616273';
wwv_flow_api.g_varchar2_table(161) := '202D204E6F2053696465626172223A20225374616E64617264222C0A20202020202020202020202020202020202020202254776F204C6576656C2054616273202D2052696768742053696465626172223A20225269676874205369646520436F6C756D6E';
wwv_flow_api.g_varchar2_table(162) := '220A202020202020202020202020202020207D2C0A2020202020202020202020202020202022526567696F6E223A207B0A20202020202020202020202020202020202020202249525220526567696F6E2054656D706C617465223A2022496E7465726163';
wwv_flow_api.g_varchar2_table(163) := '74697665205265706F7274222C0A20202020202020202020202020202020202020202241636365737369626C6520526567696F6E20776974682048656164696E67223A20225374616E64617264222C0A2020202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(164) := '22416C65727420526567696F6E223A22416C657274222C0A202020202020202020202020202020202020202022426F726465726C65737320526567696F6E223A20225374616E64617264222C0A2020202020202020202020202020202020202020224272';
wwv_flow_api.g_varchar2_table(165) := '6561646372756D6220526567696F6E223A20225469746C6520426172222C0A202020202020202020202020202020202020202022427574746F6E20526567696F6E2077697468205469746C65223A2022427574746F6E7320436F6E7461696E6572222C0A';
wwv_flow_api.g_varchar2_table(166) := '202020202020202020202020202020202020202022427574746F6E20526567696F6E20776974686F7574205469746C65223A2022427574746F6E7320436F6E7461696E6572222C0A202020202020202020202020202020202020202022436F6E74656E74';
wwv_flow_api.g_varchar2_table(167) := '204672616D6520426F647920436F6E7461696E6572223A2022426C616E6B20776974682041747472696275746573222C0A20202020202020202020202020202020202020202244495620526567696F6E2077697468204944223A2022426C616E6B207769';
wwv_flow_api.g_varchar2_table(168) := '74682041747472696275746573222C0A202020202020202020202020202020202020202022466F726D20526567696F6E223A20225374616E64617264222C0A2020202020202020202020202020202020202020224869646520616E642053686F77205265';
wwv_flow_api.g_varchar2_table(169) := '67696F6E2028457870616E64656429223A2022436F6C6C61707369626C65222C0A2020202020202020202020202020202020202020224869646520616E642053686F7720526567696F6E202848696464656E29223A2022436F6C6C61707369626C65222C';
wwv_flow_api.g_varchar2_table(170) := '0A202020202020202020202020202020202020202022496E746572616374697665205265706F727420526567696F6E223A2022496E746572616374697665205265706F7274222C0A2020202020202020202020202020202020202020224D6F64616C2052';
wwv_flow_api.g_varchar2_table(171) := '6567696F6E223A22496E6C696E65204469616C6F67222C0A202020202020202020202020202020202020202022526567696F6E20776974686F757420427574746F6E7320616E64205469746C6573223A20225374616E64617264222C0A20202020202020';
wwv_flow_api.g_varchar2_table(172) := '20202020202020202020202020225369646562617220526567696F6E223A20225374616E64617264222C0A2020202020202020202020202020202020202020225374616E6461726420526567696F6E202D204E6F2050616464696E67223A20225374616E';
wwv_flow_api.g_varchar2_table(173) := '64617264222C0A2020202020202020202020202020202020202020225374616E6461726420526567696F6E223A20225374616E64617264222C0A20202020202020202020202020202020202020202257697A61726420427574746F6E73223A2022427574';
wwv_flow_api.g_varchar2_table(174) := '746F6E7320436F6E7461696E6572220A202020202020202020202020202020207D2C0A20202020202020202020202020202020225265706F7274223A207B0A202020202020202020202020202020202020202022426F726465726C657373205265706F72';
wwv_flow_api.g_varchar2_table(175) := '74223A20225374616E64617264222C0A202020202020202020202020202020202020202022436F6D6D656E7420427562626C6573223A2022436F6D6D656E7473222C0A202020202020202020202020202020202020202022466978656420486561646572';
wwv_flow_api.g_varchar2_table(176) := '73223A20225374616E64617264222C0A202020202020202020202020202020202020202022486F72697A6F6E74616C20426F72646572223A20225374616E64617264222C0A2020202020202020202020202020202020202020224F6E6520436F6C756D6E';
wwv_flow_api.g_varchar2_table(177) := '20556E6F726465726564204C697374223A224C696E6B73204C697374222C0A20202020202020202020202020202020202020202253656172636820526573756C7473205265706F7274202853454C454354206C696E6B5F746578742C206C696E6B5F7461';
wwv_flow_api.g_varchar2_table(178) := '726765742C2064657461696C312C2064657461696C322C206C6173745F6D6F64696669656429223A202253656172636820526573756C7473222C0A2020202020202020202020202020202020202020225374616E64617264202D20416C7465726E617469';
wwv_flow_api.g_varchar2_table(179) := '7665223A20225374616E64617264222C0A2020202020202020202020202020202020202020225374616E64617264223A20225374616E64617264222C0A20202020202020202020202020202020202020202254776F20436F6C756D6E20506F72746C6574';
wwv_flow_api.g_varchar2_table(180) := '223A202256616C756520417474726962757465205061697273202D20526F77222C0A20202020202020202020202020202020202020202256616C756520417474726962757465205061697273202D204C65667420416C69676E6564223A202256616C7565';
wwv_flow_api.g_varchar2_table(181) := '20417474726962757465205061697273202D20436F6C756D6E222C0A20202020202020202020202020202020202020202256616C756520417474726962757465205061697273223A202256616C756520417474726962757465205061697273202D20436F';
wwv_flow_api.g_varchar2_table(182) := '6C756D6E220A202020202020202020202020202020207D0A2020202020202020202020207D0A20202020202020207D2C0A202020202020202032343A207B0A202020202020202020202020746578743A20225468656D652032342D20436C6F756479222C';
wwv_flow_api.g_varchar2_table(183) := '0A202020202020202020202020696D6167653A202268747470733A2F2F617065782E6F7261636C652E636F6D2F706C732F617065782F617065785F706D2F722F34322F66696C65732F7374617469632F7638342F2F692F7468656D6532342E706E67222C';
wwv_flow_api.g_varchar2_table(184) := '0A2020202020202020202020206D617070696E67733A207B0A202020202020202020202020202020202242726561646372756D62223A207B0A20202020202020202020202020202020202020202242726561646372756D62204D656E75223A2022427265';
wwv_flow_api.g_varchar2_table(185) := '61646372756D62222C0A20202020202020202020202020202020202020202248696572617263686963616C204D656E75223A2242726561646372756D62220A202020202020202020202020202020207D2C0A202020202020202020202020202020202242';
wwv_flow_api.g_varchar2_table(186) := '7574746F6E223A207B0A2020202020202020202020202020202020202020225B202B205D2041646420427574746F6E223A2249636F6E222C0A2020202020202020202020202020202020202020225B2054657874205D20427574746F6E223A2254657874';
wwv_flow_api.g_varchar2_table(187) := '222C0A202020202020202020202020202020202020202022427574746F6E223A202254657874222C0A20202020202020202020202020202020202020202248544D4C20627574746F6E20286C6567616379202D20415045582035206D6967726174696F6E';
wwv_flow_api.g_varchar2_table(188) := '29223A202254657874222C0A202020202020202020202020202020202020202022496E746572616374697665205265706F727420427574746F6E223A202254657874222C0A2020202020202020202020202020202020202020224C617267652042757474';
wwv_flow_api.g_varchar2_table(189) := '6F6E223A202254657874222C0A202020202020202020202020202020202020202022536D616C6C20427574746F6E223A202254657874220A202020202020202020202020202020207D2C0A20202020202020202020202020202020224C6162656C223A20';
wwv_flow_api.g_varchar2_table(190) := '7B0A2020202020202020202020202020202020202020224C6162656C2048696464656E206C6162656C2C20726561642062792073637265656E20726561646572223A2248696464656E222C0A2020202020202020202020202020202020202020224E6F20';
wwv_flow_api.g_varchar2_table(191) := '4C6162656C223A202248696464656E222C0A2020202020202020202020202020202020202020224F7074696F6E616C20776974682068656C70223A20224F7074696F6E616C222C0A2020202020202020202020202020202020202020224F7074696F6E61';
wwv_flow_api.g_varchar2_table(192) := '6C223A20224F7074696F6E616C222C0A202020202020202020202020202020202020202022526571756972656420776974682068656C70223A20225265717569726564222C0A202020202020202020202020202020202020202022526571756972656422';
wwv_flow_api.g_varchar2_table(193) := '3A20225265717569726564220A202020202020202020202020202020207D2C0A20202020202020202020202020202020224C65676163792043616C656E646172223A207B0A20202020202020202020202020202020202020202243616C656E646172202D';
wwv_flow_api.g_varchar2_table(194) := '20416C7465726E6174697665223A202243616C656E646172222C0A20202020202020202020202020202020202020202243616C656E646172223A202243616C656E646172222C0A202020202020202020202020202020202020202022536D616C6C204361';
wwv_flow_api.g_varchar2_table(195) := '6C656E646172223A202243616C656E646172220A202020202020202020202020202020207D2C0A20202020202020202020202020202020224C697374223A207B0A202020202020202020202020202020202020202022427574746F6E204C697374223A20';
wwv_flow_api.g_varchar2_table(196) := '224C696E6B73204C697374222C0A2020202020202020202020202020202020202020224448544D4C2054726565223A20224C696E6B73204C697374222C0A20202020202020202020202020202020202020202248696572617263686963616C2045787061';
wwv_flow_api.g_varchar2_table(197) := '6E64696E67223A20224C696E6B73204C697374222C0A202020202020202020202020202020202020202022486F72697A6F6E74616C20496D616765732077697468204C6162656C204C697374223A20224D65646961204C697374222C0A20202020202020';
wwv_flow_api.g_varchar2_table(198) := '2020202020202020202020202022486F72697A6F6E74616C204C696E6B73204C697374223A20224C696E6B73204C697374222C0A202020202020202020202020202020202020202022486F72697A6F6E74616C2057697A6172642050726F677265737320';
wwv_flow_api.g_varchar2_table(199) := '4C697374223A202257697A6172642050726F6772657373222C0A20202020202020202020202020202020202020202250616765204C6576656C2054616273204C697374223A22546F70204E617669676174696F6E204D656E75222C0A2020202020202020';
wwv_flow_api.g_varchar2_table(200) := '2020202020202020202020202250756C6C20446F776E204D656E75207769746820496D616765223A20224C696E6B73204C697374222C0A20202020202020202020202020202020202020202250756C6C20446F776E204D656E75223A20224C696E6B7320';
wwv_flow_api.g_varchar2_table(201) := '4C697374222C0A202020202020202020202020202020202020202022546162626564204E617669676174696F6E204C697374223A202254616273222C0A202020202020202020202020202020202020202022566572746963616C20496D61676573204C69';
wwv_flow_api.g_varchar2_table(202) := '7374223A20224C696E6B73204C697374222C0A202020202020202020202020202020202020202022566572746963616C204C6973742077697468205375627465787420616E642049636F6E223A224D65646961204C697374222C0A202020202020202020';
wwv_flow_api.g_varchar2_table(203) := '202020202020202020202022566572746963616C204F726465726564204C697374223A20224C696E6B73204C697374222C0A202020202020202020202020202020202020202022566572746963616C2053696465626172204C697374223A20224C696E6B';
wwv_flow_api.g_varchar2_table(204) := '73204C697374222C0A202020202020202020202020202020202020202022566572746963616C20556E6F726465726564204C69737420776974682042756C6C657473223A20224C696E6B73204C697374222C0A2020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(205) := '20202022566572746963616C20556E6F726465726564204C69737420776974686F75742042756C6C657473223A20224C696E6B73204C697374222C0A20202020202020202020202020202020202020202257697A6172642050726F6772657373204C6973';
wwv_flow_api.g_varchar2_table(206) := '74202D20566572746963616C223A202257697A6172642050726F6772657373220A202020202020202020202020202020207D2C0A202020202020202020202020202020202250616765223A207B0A20202020202020202020202020202020202020202244';
wwv_flow_api.g_varchar2_table(207) := '69616C6F67223A224D6F64616C204469616C6F67222C0A2020202020202020202020202020202020202020224C6F67696E223A20224C6F67696E222C0A2020202020202020202020202020202020202020224E6F2054616273202D204C65667420616E64';
wwv_flow_api.g_varchar2_table(208) := '2052696768742053696465626172223A224C65667420616E64205269676874205369646520436F6C756D6E73222C0A2020202020202020202020202020202020202020224E6F2054616273202D204C6566742053696465626172223A20224C6566742053';
wwv_flow_api.g_varchar2_table(209) := '69646520436F6C756D6E222C0A2020202020202020202020202020202020202020224E6F2054616273202D204E6F2053696465626172223A20225374616E64617264222C0A2020202020202020202020202020202020202020224E6F2054616273202D20';
wwv_flow_api.g_varchar2_table(210) := '52696768742053696465626172223A20225269676874205369646520436F6C756D6E222C0A2020202020202020202020202020202020202020224F6E65204C6576656C2054616273202D20436F6E74656E74204672616D65223A224D6173746572204465';
wwv_flow_api.g_varchar2_table(211) := '7461696C222C0A2020202020202020202020202020202020202020224F6E65204C6576656C2054616273202D204C65667420616E642052696768742053696465626172223A20224C65667420616E64205269676874205369646520436F6C756D6E73222C';
wwv_flow_api.g_varchar2_table(212) := '0A2020202020202020202020202020202020202020224F6E65204C6576656C2054616273202D204C6566742053696465626172223A20224C656674205369646520436F6C756D6E222C0A2020202020202020202020202020202020202020224F6E65204C';
wwv_flow_api.g_varchar2_table(213) := '6576656C2054616273202D2052696768742053696465626172223A20225269676874205369646520436F6C756D6E222C0A2020202020202020202020202020202020202020224F6E65204C6576656C2054616273202D2057697A6172642050616765223A';
wwv_flow_api.g_varchar2_table(214) := '225374616E64617264222C0A202020202020202020202020202020202020202022506F707570223A20224D696E696D616C20284E6F204E617669676174696F6E29222C0A2020202020202020202020202020202020202020225072696E74657220467269';
wwv_flow_api.g_varchar2_table(215) := '656E646C79223A20224D696E696D616C20284E6F204E617669676174696F6E29222C0A20202020202020202020202020202020202020202254776F204C6576656C2054616273202D204C65667420616E642052696768742053696465626172223A224C65';
wwv_flow_api.g_varchar2_table(216) := '667420616E64205269676874205369646520436F6C756D6E73222C0A20202020202020202020202020202020202020202254776F204C6576656C2054616273202D204C6566742053696465626172223A20224C656674205369646520436F6C756D6E222C';
wwv_flow_api.g_varchar2_table(217) := '0A20202020202020202020202020202020202020202254776F204C6576656C2054616273202D204E6F2053696465626172223A20225374616E64617264222C0A20202020202020202020202020202020202020202254776F204C6576656C205461627320';
wwv_flow_api.g_varchar2_table(218) := '2D2052696768742053696465626172223A20225269676874205369646520436F6C756D6E220A202020202020202020202020202020207D2C0A2020202020202020202020202020202022526567696F6E223A207B0A202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(219) := '20202020202249525220526567696F6E2054656D706C617465223A2022496E746572616374697665205265706F7274222C0A202020202020202020202020202020202020202022416C65727420526567696F6E223A22416C657274222C0A202020202020';
wwv_flow_api.g_varchar2_table(220) := '202020202020202020202020202022426F726465726C65737320526567696F6E223A20225374616E64617264222C0A202020202020202020202020202020202020202022427261636B6574656420526567696F6E223A20225374616E64617264222C0A20';
wwv_flow_api.g_varchar2_table(221) := '202020202020202020202020202020202020202242726561646372756D6220526567696F6E223A20225469746C6520426172222C0A202020202020202020202020202020202020202022427574746F6E20526567696F6E2077697468205469746C65223A';
wwv_flow_api.g_varchar2_table(222) := '2022427574746F6E7320436F6E7461696E6572222C0A202020202020202020202020202020202020202022427574746F6E20526567696F6E20776974686F7574205469746C65223A2022427574746F6E7320436F6E7461696E6572222C0A202020202020';
wwv_flow_api.g_varchar2_table(223) := '2020202020202020202020202020224368617274204C697374223A20225374616E64617264222C0A202020202020202020202020202020202020202022436861727420526567696F6E223A20225374616E64617264222C0A202020202020202020202020';
wwv_flow_api.g_varchar2_table(224) := '202020202020202022436F6E74656E74204672616D6520426F647920436F6E7461696E6572223A22426C616E6B20776974682041747472696275746573222C0A20202020202020202020202020202020202020202244495620526567696F6E2077697468';
wwv_flow_api.g_varchar2_table(225) := '204944223A22426C616E6B20776974682041747472696275746573222C0A202020202020202020202020202020202020202022466F726D20526567696F6E223A20225374616E64617264222C0A2020202020202020202020202020202020202020224869';
wwv_flow_api.g_varchar2_table(226) := '646520616E642053686F7720526567696F6E202848696464656E20466972737429202D20426F726465726C657373223A22436F6C6C61707369626C65222C0A2020202020202020202020202020202020202020224869646520616E642053686F77205265';
wwv_flow_api.g_varchar2_table(227) := '67696F6E202D20426F726465726C657373223A2022436F6C6C61707369626C65222C0A2020202020202020202020202020202020202020224869646520616E642053686F7720526567696F6E223A2022436F6C6C61707369626C65222C0A202020202020';
wwv_flow_api.g_varchar2_table(228) := '2020202020202020202020202020226A5175657279204D6F64616C20526567696F6E2054656D706C617465223A22496E6C696E65204469616C6F67222C0A2020202020202020202020202020202020202020224C6F67696E20526567696F6E223A224C6F';
wwv_flow_api.g_varchar2_table(229) := '67696E222C0A2020202020202020202020202020202020202020224D6F64616C20526567696F6E223A22496E6C696E65204469616C6F67222C0A2020202020202020202020202020202020202020224E617669676174696F6E20526567696F6E202D2048';
wwv_flow_api.g_varchar2_table(230) := '656164696E6720496E73696465223A20225374616E64617264222C0A2020202020202020202020202020202020202020224E617669676174696F6E20526567696F6E223A20225374616E64617264222C0A20202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(231) := '2022526567696F6E20776974686F757420427574746F6E7320616E64205469746C6573223A20225374616E64617264222C0A202020202020202020202020202020202020202022526567696F6E20776974686F7574205469746C65223A20225374616E64';
wwv_flow_api.g_varchar2_table(232) := '617264222C0A2020202020202020202020202020202020202020225265706F72742046696C746572202D2053696E676C6520526F77223A20225374616E64617264222C0A2020202020202020202020202020202020202020225265706F7274204C697374';
wwv_flow_api.g_varchar2_table(233) := '223A225374616E64617264222C0A2020202020202020202020202020202020202020225265706F72747320526567696F6E202D2031303025205769647468223A20225374616E64617264222C0A2020202020202020202020202020202020202020225265';
wwv_flow_api.g_varchar2_table(234) := '706F72747320526567696F6E202D2048656164696E6720496E73696465223A20225374616E64617264222C0A2020202020202020202020202020202020202020225265706F72747320526567696F6E223A20225374616E64617264222C0A202020202020';
wwv_flow_api.g_varchar2_table(235) := '2020202020202020202020202020225363726F6C6C61626C6520436F6E74656E7420526567696F6E223A225374616E64617264222C0A2020202020202020202020202020202020202020225365617263682046696C74657220526567696F6E223A225374';
wwv_flow_api.g_varchar2_table(236) := '616E64617264222C0A2020202020202020202020202020202020202020225369646562617220526567696F6E202D2048656164696E6720496E73696465223A20225374616E64617264222C0A202020202020202020202020202020202020202022536964';
wwv_flow_api.g_varchar2_table(237) := '6562617220526567696F6E223A20225374616E64617264222C0A20202020202020202020202020202020202020202257697A61726420427574746F6E73223A22427574746F6E7320436F6E7461696E6572222C0A20202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(238) := '202020202257697A61726420526567696F6E20776974682049636F6E223A20225374616E64617264222C0A20202020202020202020202020202020202020202257697A61726420526567696F6E223A20225374616E64617264220A202020202020202020';
wwv_flow_api.g_varchar2_table(239) := '202020202020207D2C0A20202020202020202020202020202020225265706F7274223A207B0A202020202020202020202020202020202020202022426F726465726C657373205265706F7274223A20225374616E64617264222C0A202020202020202020';
wwv_flow_api.g_varchar2_table(240) := '202020202020202020202022436F6D6D656E7420427562626C6573223A22436F6D6D656E7473222C0A20202020202020202020202020202020202020202246697865642048656164657273223A20225374616E64617264222C0A20202020202020202020';
wwv_flow_api.g_varchar2_table(241) := '2020202020202020202022486F72697A6F6E74616C20426F72646572223A20225374616E64617264222C0A2020202020202020202020202020202020202020224F6E6520436F6C756D6E20556E6F726465726564204C697374223A224C696E6B73204C69';
wwv_flow_api.g_varchar2_table(242) := '7374222C0A20202020202020202020202020202020202020202253656172636820526573756C7473205265706F7274202853454C454354206C696E6B5F746578742C206C696E6B5F7461726765742C2064657461696C312C2064657461696C322C206C61';
wwv_flow_api.g_varchar2_table(243) := '73745F6D6F64696669656429223A202253656172636820526573756C7473222C0A2020202020202020202020202020202020202020225374616E64617264202D20416C7465726E6174697665223A20225374616E64617264222C0A202020202020202020';
wwv_flow_api.g_varchar2_table(244) := '2020202020202020202020225374616E64617264223A20225374616E64617264222C0A20202020202020202020202020202020202020202254776F20436F6C756D6E20506F72746C6574223A202256616C75652041747472696275746520506169727320';
wwv_flow_api.g_varchar2_table(245) := '2D20526F77222C0A20202020202020202020202020202020202020202256616C756520417474726962757465205061697273202D204C65667420416C69676E6564223A2256616C756520417474726962757465205061697273202D20436F6C756D6E222C';
wwv_flow_api.g_varchar2_table(246) := '0A20202020202020202020202020202020202020202256616C756520417474726962757465205061697273223A202256616C756520417474726962757465205061697273202D20436F6C756D6E220A202020202020202020202020202020207D0A202020';
wwv_flow_api.g_varchar2_table(247) := '2020202020202020207D0A20202020202020207D2C0A202020202020202032333A207B0A202020202020202020202020746578743A20225468656D65203233202D204372696D736F6E222C0A202020202020202020202020696D6167653A202268747470';
wwv_flow_api.g_varchar2_table(248) := '733A2F2F617065782E6F7261636C652E636F6D2F706C732F617065782F617065785F706D2F722F34322F66696C65732F7374617469632F7638342F2F692F7468656D6532332E706E67222C0A2020202020202020202020206D617070696E67733A207B0A';
wwv_flow_api.g_varchar2_table(249) := '202020202020202020202020202020202242726561646372756D62223A207B0A20202020202020202020202020202020202020202242726561646372756D62204D656E75223A202242726561646372756D62220A20202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(250) := '7D2C0A2020202020202020202020202020202022427574746F6E223A207B0A2020202020202020202020202020202020202020224C6172676520427574746F6E223A202254657874222C0A202020202020202020202020202020202020202022536D616C';
wwv_flow_api.g_varchar2_table(251) := '6C20427574746F6E223A202254657874222C0A202020202020202020202020202020202020202022427574746F6E223A202254657874222C0A202020202020202020202020202020202020202022496E746572616374697665205265706F727420427574';
wwv_flow_api.g_varchar2_table(252) := '746F6E223A202254657874222C0A20202020202020202020202020202020202020202248544D4C20627574746F6E20286C6567616379202D20415045582035206D6967726174696F6E29223A202254657874220A20202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(253) := '7D2C0A20202020202020202020202020202020224C6162656C223A207B0A2020202020202020202020202020202020202020224F7074696F6E616C20776974682068656C70223A20224F7074696F6E616C222C0A20202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(254) := '20202020224F7074696F6E616C223A20224F7074696F6E616C222C0A2020202020202020202020202020202020202020225265717569726564223A20225265717569726564222C0A2020202020202020202020202020202020202020224E6F204C616265';
wwv_flow_api.g_varchar2_table(255) := '6C223A202248696464656E222C0A202020202020202020202020202020202020202022526571756972656420776974682068656C70223A20225265717569726564220A202020202020202020202020202020207D2C0A2020202020202020202020202020';
wwv_flow_api.g_varchar2_table(256) := '2020224C65676163792043616C656E646172223A207B0A20202020202020202020202020202020202020202243616C656E646172223A202243616C656E646172222C0A202020202020202020202020202020202020202022536D616C6C2043616C656E64';
wwv_flow_api.g_varchar2_table(257) := '6172223A202243616C656E646172222C0A20202020202020202020202020202020202020202243616C656E646172202D20416C7465726E6174697665223A202243616C656E646172220A202020202020202020202020202020207D2C0A20202020202020';
wwv_flow_api.g_varchar2_table(258) := '202020202020202020224C697374223A207B0A202020202020202020202020202020202020202022486F72697A6F6E74616C2057697A6172642050726F6772657373204C697374223A202257697A6172642050726F6772657373222C0A20202020202020';
wwv_flow_api.g_varchar2_table(259) := '2020202020202020202020202022566572746963616C204F726465726564204C697374223A20224C696E6B73204C697374222C0A202020202020202020202020202020202020202022566572746963616C2053696465626172204C697374223A20224C69';
wwv_flow_api.g_varchar2_table(260) := '6E6B73204C697374222C0A20202020202020202020202020202020202020202257697A6172642050726F6772657373204C697374202D20566572746963616C223A202257697A6172642050726F6772657373222C0A202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(261) := '202020202022566572746963616C20556E6F726465726564204C69737420776974682042756C6C657473223A20224C696E6B73204C697374222C0A2020202020202020202020202020202020202020224448544D4C2054726565223A20224C696E6B7320';
wwv_flow_api.g_varchar2_table(262) := '4C697374222C0A20202020202020202020202020202020202020202248696572617263686963616C20457870616E64696E67223A20224C696E6B73204C697374222C0A20202020202020202020202020202020202020202250756C6C20446F776E204D65';
wwv_flow_api.g_varchar2_table(263) := '6E75207769746820496D616765223A20224C696E6B73204C697374222C0A202020202020202020202020202020202020202022427574746F6E204C697374223A20224C696E6B73204C697374222C0A202020202020202020202020202020202020202022';
wwv_flow_api.g_varchar2_table(264) := '50616765204C6576656C2054616273204C697374223A2022546F70204E617669676174696F6E204D656E75222C0A202020202020202020202020202020202020202022546162626564204E617669676174696F6E204C697374223A202254616273222C0A';
wwv_flow_api.g_varchar2_table(265) := '202020202020202020202020202020202020202022566572746963616C20556E6F726465726564204C69737420776974686F75742042756C6C657473223A20224C696E6B73204C697374222C0A202020202020202020202020202020202020202022486F';
wwv_flow_api.g_varchar2_table(266) := '72697A6F6E74616C204C696E6B73204C697374223A20224C696E6B73204C697374222C0A20202020202020202020202020202020202020202250756C6C20446F776E204D656E75223A20224C696E6B73204C697374222C0A202020202020202020202020';
wwv_flow_api.g_varchar2_table(267) := '202020202020202022566572746963616C20496D61676573204C697374223A20224C696E6B73204C697374222C0A202020202020202020202020202020202020202022486F72697A6F6E74616C20496D616765732077697468204C6162656C204C697374';
wwv_flow_api.g_varchar2_table(268) := '223A20224D65646961204C697374220A202020202020202020202020202020207D2C0A202020202020202020202020202020202250616765223A207B0A20202020202020202020202020202020202020202254776F204C6576656C2054616273202D204C';
wwv_flow_api.g_varchar2_table(269) := '6566742053696465626172223A20224C656674205369646520436F6C756D6E222C0A2020202020202020202020202020202020202020224E6F2054616273202D204E6F2053696465626172223A20225374616E64617264222C0A20202020202020202020';
wwv_flow_api.g_varchar2_table(270) := '20202020202020202020225072696E74657220467269656E646C79223A20224D696E696D616C20284E6F204E617669676174696F6E29222C0A2020202020202020202020202020202020202020224C6F67696E223A20224C6F67696E222C0A2020202020';
wwv_flow_api.g_varchar2_table(271) := '20202020202020202020202020202022506F707570223A20224D696E696D616C20284E6F204E617669676174696F6E29222C0A20202020202020202020202020202020202020202254776F204C6576656C2054616273202D205269676874205369646562';
wwv_flow_api.g_varchar2_table(272) := '6172223A20225269676874205369646520436F6C756D6E222C0A2020202020202020202020202020202020202020224E6F2054616273202D2052696768742053696465626172223A20225269676874205369646520436F6C756D6E222C0A202020202020';
wwv_flow_api.g_varchar2_table(273) := '2020202020202020202020202020224E6F2054616273202D204C6566742053696465626172223A20224C656674205369646520436F6C756D6E222C0A2020202020202020202020202020202020202020224F6E65204C6576656C2054616273202D204C65';
wwv_flow_api.g_varchar2_table(274) := '66742053696465626172223A20224C656674205369646520436F6C756D6E222C0A2020202020202020202020202020202020202020224F6E65204C6576656C2054616273202D204C65667420616E642052696768742053696465626172223A20224C6566';
wwv_flow_api.g_varchar2_table(275) := '7420616E64205269676874205369646520436F6C756D6E73220A202020202020202020202020202020207D2C0A2020202020202020202020202020202022526567696F6E223A207B0A202020202020202020202020202020202020202022495252205265';
wwv_flow_api.g_varchar2_table(276) := '67696F6E2054656D706C617465223A2022496E746572616374697665205265706F7274222C0A202020202020202020202020202020202020202022427574746F6E20526567696F6E2077697468205469746C65223A2022427574746F6E7320436F6E7461';
wwv_flow_api.g_varchar2_table(277) := '696E6572222C0A2020202020202020202020202020202020202020225265706F72747320526567696F6E202D2048656164696E6720496E73696465223A20225374616E64617264222C0A2020202020202020202020202020202020202020224E61766967';
wwv_flow_api.g_varchar2_table(278) := '6174696F6E20526567696F6E223A20225374616E64617264222C0A2020202020202020202020202020202020202020225265706F72742046696C746572202D2053696E676C6520526F77223A20225374616E64617264222C0A2020202020202020202020';
wwv_flow_api.g_varchar2_table(279) := '20202020202020202022427261636B6574656420526567696F6E223A20225374616E64617264222C0A202020202020202020202020202020202020202022436861727420526567696F6E223A20225374616E64617264222C0A2020202020202020202020';
wwv_flow_api.g_varchar2_table(280) := '202020202020202020224E617669676174696F6E20526567696F6E202D2048656164696E6720496E73696465223A20225374616E64617264222C0A202020202020202020202020202020202020202022466F726D20526567696F6E223A20225374616E64';
wwv_flow_api.g_varchar2_table(281) := '617264222C0A202020202020202020202020202020202020202022526567696F6E20776974686F7574205469746C65223A20225374616E64617264222C0A202020202020202020202020202020202020202022526567696F6E20776974686F7574204275';
wwv_flow_api.g_varchar2_table(282) := '74746F6E7320616E64205469746C6573223A20225374616E64617264222C0A20202020202020202020202020202020202020202257697A61726420526567696F6E20776974682049636F6E223A20225374616E64617264222C0A20202020202020202020';
wwv_flow_api.g_varchar2_table(283) := '20202020202020202020225369646562617220526567696F6E202D2048656164696E6720496E73696465223A20225374616E64617264222C0A2020202020202020202020202020202020202020225265706F72747320526567696F6E223A20225374616E';
wwv_flow_api.g_varchar2_table(284) := '64617264222C0A2020202020202020202020202020202020202020224869646520616E642053686F7720526567696F6E202848696464656E20466972737429223A2022436F6C6C61707369626C65222C0A20202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(285) := '2022426F726465726C65737320526567696F6E223A20225374616E64617264222C0A2020202020202020202020202020202020202020224368617274204C697374223A20225374616E64617264222C0A2020202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(286) := '224869646520616E642053686F7720526567696F6E202D20426F726465726C657373223A2022436F6C6C61707369626C65222C0A20202020202020202020202020202020202020202242726561646372756D6220526567696F6E223A20225469746C6520';
wwv_flow_api.g_varchar2_table(287) := '426172222C0A20202020202020202020202020202020202020202257697A61726420526567696F6E223A202257697A61726420436F6E7461696E6572222C0A2020202020202020202020202020202020202020225369646562617220526567696F6E223A';
wwv_flow_api.g_varchar2_table(288) := '20225374616E64617264222C0A2020202020202020202020202020202020202020224869646520616E642053686F7720526567696F6E223A2022436F6C6C61707369626C65222C0A202020202020202020202020202020202020202022427574746F6E20';
wwv_flow_api.g_varchar2_table(289) := '526567696F6E20776974686F7574205469746C65223A2022427574746F6E7320436F6E7461696E6572222C0A2020202020202020202020202020202020202020225265706F72747320526567696F6E202D2031303025205769647468223A20225374616E';
wwv_flow_api.g_varchar2_table(290) := '64617264220A202020202020202020202020202020207D2C0A20202020202020202020202020202020225265706F7274223A207B0A20202020202020202020202020202020202020202254776F20436F6C756D6E20506F72746C6574223A202256616C75';
wwv_flow_api.g_varchar2_table(291) := '6520417474726962757465205061697273202D20526F77222C0A20202020202020202020202020202020202020202246697865642048656164657273223A20225374616E64617264222C0A202020202020202020202020202020202020202022486F7269';
wwv_flow_api.g_varchar2_table(292) := '7A6F6E74616C20426F72646572223A20225374616E64617264222C0A20202020202020202020202020202020202020202253656172636820526573756C7473205265706F7274202853454C454354206C696E6B5F746578742C206C696E6B5F7461726765';
wwv_flow_api.g_varchar2_table(293) := '742C2064657461696C312C2064657461696C322C206C6173745F6D6F64696669656429223A202253656172636820526573756C7473222C0A20202020202020202020202020202020202020202256616C756520417474726962757465205061697273223A';
wwv_flow_api.g_varchar2_table(294) := '202256616C756520417474726962757465205061697273202D20436F6C756D6E222C0A2020202020202020202020202020202020202020225374616E64617264223A20225374616E64617264222C0A202020202020202020202020202020202020202022';
wwv_flow_api.g_varchar2_table(295) := '5374616E64617264202D20416C7465726E6174697665223A20225374616E64617264222C0A202020202020202020202020202020202020202022426F726465726C657373205265706F7274223A20225374616E64617264220A2020202020202020202020';
wwv_flow_api.g_varchar2_table(296) := '20202020207D0A2020202020202020202020207D0A20202020202020207D2C0A202020202020202032323A207B0A202020202020202020202020696D6167653A202268747470733A2F2F617065782E6F7261636C652E636F6D2F706C732F617065782F61';
wwv_flow_api.g_varchar2_table(297) := '7065785F706D2F722F34322F66696C65732F7374617469632F7638342F2F692F7468656D6532322E706E67222C0A202020202020202020202020746578743A20225468656D652032322D20426C7565204A6179222C0A2020202020202020202020206D61';
wwv_flow_api.g_varchar2_table(298) := '7070696E67733A207468656D653231416E645468656D6532324D617070696E670A20202020202020207D2C0A202020202020202032313A207B0A202020202020202020202020746578743A20225468656D65203231202D20536361726C6574222C0A2020';
wwv_flow_api.g_varchar2_table(299) := '20202020202020202020696D6167653A202268747470733A2F2F617065782E6F7261636C652E636F6D2F706C732F617065782F617065785F706D2F722F34322F66696C65732F7374617469632F7638342F2F692F7468656D6532312E706E67222C0A2020';
wwv_flow_api.g_varchar2_table(300) := '202020202020202020206D617070696E67733A207468656D653231416E645468656D6532324D617070696E670A20202020202020207D0A202020207D3B0A0A0A202020202F2A2A0A20202020202A20426F6F6B6D61726B6C657420636F64652073746172';
wwv_flow_api.g_varchar2_table(301) := '747320686572652E0A20202020202A2F0A20202020766172206469616C6F67446976243B0A20202020766172206469616C6F67203D2066756E6374696F6E28207469746C652C206D6573736167652C206578747261436F6E74656E74242C20627574746F';
wwv_flow_api.g_varchar2_table(302) := '6E732029207B0A20202020202020206966202821627574746F6E7329207B0A202020202020202020202020627574746F6E73203D20207B0A202020202020202020202020202020202243616E63656C223A2066756E6374696F6E2829207B0A2020202020';
wwv_flow_api.g_varchar2_table(303) := '2020202020202020202020202020202428207468697320292E6469616C6F67282022636C6F73652220293B0A202020202020202020202020202020207D0A2020202020202020202020207D0A20202020202020207D0A0A2020202020202020766172206F';
wwv_flow_api.g_varchar2_table(304) := '6B427574746F6E24203D202428273C627574746F6E20636C6173733D22612D427574746F6E20612D427574746F6E20612D427574746F6E2D2D7061644C656674223E4F6B61793C2F627574746F6E3E27293B0A20202020202020206469616C6F67446976';
wwv_flow_api.g_varchar2_table(305) := '242E6469616C6F6728226F7074696F6E222C20227469746C65222C207469746C65292E6469616C6F6728226F7074696F6E222C2022627574746F6E73222C20627574746F6E73293B0A20202020202020206469616C6F67446976242E68746D6C28223C64';
wwv_flow_api.g_varchar2_table(306) := '6976207374796C653D2770616464696E673A323070783B273E22202B206D657373616765202B2020223C2F6469763E22293B0A20202020202020206469616C6F67446976242E6368696C6472656E28292E666972737428292E617070656E642820657874';
wwv_flow_api.g_varchar2_table(307) := '7261436F6E74656E742420293B0A20202020202020206469616C6F67446976242E6469616C6F6728226F70656E22293B0A202020207D3B0A0A202020207661722063686F6F73655468656D65546F5772697465203D2066756E6374696F6E28207468656D';
wwv_flow_api.g_varchar2_table(308) := '654E756D6265722029207B0A2020202020202020766172206C69737424203D202428273C756C20636C6173733D22612D49636F6E4C6973742D2D77697A61726420612D49636F6E4C6973742220726F6C653D226C697374626F78223E3C2F756C3E27293B';
wwv_flow_api.g_varchar2_table(309) := '0A2020202020202020666F722028766172206B657920696E20737570706F727465645468656D657329207B0A2020202020202020202020202866756E6374696F6E2829207B0A20202020202020202020202020202020766172207468656D65546F577269';
wwv_flow_api.g_varchar2_table(310) := '74654B6579203D206B65793B0A20202020202020202020202020202020766172206974656D24203D20202428273C6C6920636C6173733D2277697A6172642D73656C656374696F6E20612D49636F6E4C6973742D6974656D2075742D6D6967726174696F';
wwv_flow_api.g_varchar2_table(311) := '6E2D68656C7065722220726F6C653D226F7074696F6E2220746162696E6465783D2230223E3C2F6C693E27293B0A20202020202020202020202020202020766172207468656D65546F5772697465203D206765745468656D65546F577269746528207468';
wwv_flow_api.g_varchar2_table(312) := '656D65546F57726974654B657920293B0A202020202020202020202020202020206974656D242E617070656E6428273C6469763E3C696D67207372633D2227202B207468656D65546F57726974652E696D616765202B202722202F3E3C2F6469763E2729';
wwv_flow_api.g_varchar2_table(313) := '3B0A202020202020202020202020202020206974656D242E617070656E6428273C7370616E20636C6173733D22612D49636F6E4C6973742D69636F6E4E616D65223E27202B207468656D65546F57726974652E74657874202B273C2F7370616E3E27293B';
wwv_flow_api.g_varchar2_table(314) := '0A202020202020202020202020202020206974656D242E636C69636B2866756E6374696F6E2829207B0A20202020202020202020202020202020202020206469616C6F67446976242E6469616C6F672822636C6F736522293B0A20202020202020202020';
wwv_flow_api.g_varchar2_table(315) := '202020202020202020206170657854656D706C61746548656C7065722E777269746528207468656D65546F577269746520293B0A202020202020202020202020202020207D293B0A202020202020202020202020202020206C697374242E617070656E64';
wwv_flow_api.g_varchar2_table(316) := '286974656D24293B0A2020202020202020202020207D2928293B0A20202020202020207D0A20202020202020206469616C6F67280A2020202020202020202020202253656C656374207468652062617365207468656D65206E756D626572222C0A202020';
wwv_flow_api.g_varchar2_table(317) := '2020202020202020202254686520626F6F6B6D61726B6C657420697320636F6D70617469626C65207769746820612066657720276261736527207468656D65732E2022202B0A2020202020202020202020202253656C65637420746865206F6E65207468';
wwv_flow_api.g_varchar2_table(318) := '61742062657374206D61746368657320796F7572732062656C6F7720746F206170706C792074686520636F7272656374207468656D65206D617070696E6720222C0A2020202020202020202020206C697374242C0A202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(319) := '207B7D293B0A202020207D3B0A0A20202020696620282177696E646F772E75744D6967726174696F6E53637269707441637469766529207B0A20202020202020202428226865616422292E617070656E6428223C7374796C653E22202B0A202020202020';
wwv_flow_api.g_varchar2_table(320) := '202020202020222E7468656D652D6D6967726174696F6E2D2D69732D75706461746564207B206261636B67726F756E642D636F6C6F723A20234341463743373B207D2022202B0A202020202020202020202020222E7468656D652D6D6967726174696F6E';
wwv_flow_api.g_varchar2_table(321) := '2D2D69732D6572726F72207B206261636B67726F756E642D636F6C6F723A20234644453541343B207D22202B0A202020202020202020202020222E75742D6D6967726174696F6E2D68656C70657220646976207B2077696474683A20393070783B206865';
wwv_flow_api.g_varchar2_table(322) := '696768743A20363070783B206F766572666C6F773A68696464656E3B206D617267696E3A206175746F3B207D22202B0A202020202020202020202020222E75742D6D6967726174696F6E2D68656C70657220696D67207B2077696474683A203238307078';
wwv_flow_api.g_varchar2_table(323) := '3B206865696768743A2031323070783B206D617267696E2D746F703A202D313070783B207D22202B0A202020202020202020202020222E75742D6D6967726174696F6E2D68656C706572207B20746578742D616C69676E3A63656E7465723B20626F7264';
wwv_flow_api.g_varchar2_table(324) := '65723A20317078207768697465736D6F6B6520736F6C69643B20626F726465722D7261646975733A203270783B207D2022202B0A202020202020202020202020222E75742D6D6967726174696F6E2D68656C706572202E612D49636F6E4C6973742D6963';
wwv_flow_api.g_varchar2_table(325) := '6F6E4E616D65207B206865696768743A20353070783B20646973706C61793A696E6C696E652D626C6F636B3B206D617267696E2D746F703A3570783B207D22202B0A2020202020202020223C2F7374796C653E22293B0A202020202020202077696E646F';
wwv_flow_api.g_varchar2_table(326) := '772E75744D6967726174696F6E44697624203D206469616C6F6744697624203D202428223C6469763E22293B0A2020202020202020242822626F647922292E617070656E64286469616C6F6744697624293B0A2020202020202020617065782E7468656D';
wwv_flow_api.g_varchar2_table(327) := '652E696E6974526573706F6E736976654469616C6F677328293B0A20202020202020206469616C6F67446976242E6469616C6F67280A2020202020202020202020207B0A202020202020202020202020202020206175746F4F70656E3A2066616C73652C';
wwv_flow_api.g_varchar2_table(328) := '0A202020202020202020202020202020206D696E57696474683A203530302C0A202020202020202020202020202020202F2F6D696E4865696768743A203330302C0A20202020202020202020202020202020636C6F7365546578743A20224F6B220A2020';
wwv_flow_api.g_varchar2_table(329) := '202020202020202020207D293B0A202020207D20656C7365207B0A20202020202020206469616C6F6744697624203D2077696E646F772E75744D6967726174696F6E446976243B0A202020207D0A2020202077696E646F772E75744D6967726174696F6E';
wwv_flow_api.g_varchar2_table(330) := '536372697074416374697665203D20747275653B0A0A20202020766172206170657854656D706C61746548656C706572203D202866756E6374696F6E2829207B0A2020202020202020766172206275696C6450616765526570726573656E746174696F6E';
wwv_flow_api.g_varchar2_table(331) := '203D2066756E6374696F6E2829207B0A2020202020202020202020207661722070616765526570726573656E746174696F6E203D207B7D3B0A2020202020202020202020207661722063757272656E7454656D706C617465547970653B0A202020202020';
wwv_flow_api.g_varchar2_table(332) := '2020202020202428222E612D5265706F72742D7265706F727422292E66696E64282274626F647922292E66696E642822747222292E656163682866756E6374696F6E2829207B0A20202020202020202020202020202020766172207461626C65526F7724';
wwv_flow_api.g_varchar2_table(333) := '203D20242874686973293B0A202020202020202020202020202020207661722074656D706C6174655479706524203D207461626C65526F77242E66696E64282274645B686561646572733D2754454D505F54595045275D22293B0A202020202020202020';
wwv_flow_api.g_varchar2_table(334) := '202020202020207661722066726F6D54656D706C61746524203D207461626C65526F77242E66696E64282274645B686561646572733D2746524F4D5F54454D504C415445275D22293B0A202020202020202020202020202020207661722073656C656374';
wwv_flow_api.g_varchar2_table(335) := '4D617070696E6724203D207461626C65526F77242E66696E64282274645B686561646572733D274C4F56275D22292E66696E64282273656C65637422293B0A202020202020202020202020202020207661722074656D706C61746554797065203D207465';
wwv_flow_api.g_varchar2_table(336) := '6D706C61746554797065242E7465787428292E7472696D28293B0A202020202020202020202020202020207661722066726F6D54656D706C617465203D2066726F6D54656D706C617465242E7465787428292E7472696D28293B0A202020202020202020';
wwv_flow_api.g_varchar2_table(337) := '202020202020206966202874656D706C617465547970652026262074656D706C617465547970652E7472696D282920213D3D20222229207B0A202020202020202020202020202020202020202063757272656E7454656D706C61746554797065203D2074';
wwv_flow_api.g_varchar2_table(338) := '656D706C617465547970653B0A202020202020202020202020202020207D0A20202020202020202020202020202020696620282170616765526570726573656E746174696F6E5B63757272656E7454656D706C617465547970655D29207B0A2020202020';
wwv_flow_api.g_varchar2_table(339) := '20202020202020202020202020202070616765526570726573656E746174696F6E5B63757272656E7454656D706C617465547970655D203D207B0A20202020202020202020202020202020202020207D3B0A202020202020202020202020202020207D0A';
wwv_flow_api.g_varchar2_table(340) := '2020202020202020202020202020202070616765526570726573656E746174696F6E5B63757272656E7454656D706C617465547970655D5B66726F6D54656D706C6174655D203D207B0A20202020202020202020202020202020202020202273656C6563';
wwv_flow_api.g_varchar2_table(341) := '7424223A2073656C6563744D617070696E67242C0A202020202020202020202020202020202020202022726F7724223A207461626C65526F77242C0A20202020202020202020202020202020202020202273656C6563746564223A2073656C6563744D61';
wwv_flow_api.g_varchar2_table(342) := '7070696E67242E66696E6428223A73656C656374656422292E7465787428290A202020202020202020202020202020207D3B0A2020202020202020202020207D293B0A20202020202020202020202072657475726E2070616765526570726573656E7461';
wwv_flow_api.g_varchar2_table(343) := '74696F6E3B0A20202020202020207D3B0A0A202020202020202076617220697465726174655468726F756768526570726573656E746174696F6E203D2066756E6374696F6E20282070616765526570726573656E746174696F6E2C2063616C6C6261636B';
wwv_flow_api.g_varchar2_table(344) := '2029207B0A202020202020202020202020666F7220287661722074656D706C6174655479706520696E2070616765526570726573656E746174696F6E29207B0A202020202020202020202020202020207661722074656D706C6174655479706573203D20';
wwv_flow_api.g_varchar2_table(345) := '70616765526570726573656E746174696F6E5B74656D706C617465547970655D3B0A20202020202020202020202020202020666F7220287661722066726F6D54656D706C61746520696E2074656D706C617465547970657329207B0A2020202020202020';
wwv_flow_api.g_varchar2_table(346) := '20202020202020202020202063616C6C6261636B282074656D706C61746554797065735B66726F6D54656D706C6174655D2C2074656D706C617465547970652C2066726F6D54656D706C617465293B0A202020202020202020202020202020207D0A2020';
wwv_flow_api.g_varchar2_table(347) := '202020202020202020207D0A20202020202020207D3B0A0A20202020202020207661722067657454656D706C6174654A736F6E203D2066756E6374696F6E2829207B0A2020202020202020202020207661722070616765526570726573656E746174696F';
wwv_flow_api.g_varchar2_table(348) := '6E203D206275696C6450616765526570726573656E746174696F6E28293B0A202020202020202020202020697465726174655468726F756768526570726573656E746174696F6E2870616765526570726573656E746174696F6E2C2066756E6374696F6E';
wwv_flow_api.g_varchar2_table(349) := '28206F7074696F6E2C2074656D706C617465547970652C2066726F6D54656D706C6174652029207B0A2020202020202020202020202020202070616765526570726573656E746174696F6E5B74656D706C617465547970655D5B66726F6D54656D706C61';
wwv_flow_api.g_varchar2_table(350) := '74655D203D20206F7074696F6E2E73656C65637465643B0A2020202020202020202020207D293B0A20202020202020202020202072657475726E204A534F4E2E737472696E676966792870616765526570726573656E746174696F6E293B0A2020202020';
wwv_flow_api.g_varchar2_table(351) := '2020207D3B0A0A20202020202020207661722073656C6563745265736574436F6C6F72203D2066756E6374696F6E2829207B0A202020202020202020202020242874686973292E72656D6F7665436C61737328227468656D652D6D6967726174696F6E2D';
wwv_flow_api.g_varchar2_table(352) := '2D69732D6572726F7222292E72656D6F7665436C61737328227468656D652D6D6967726174696F6E2D2D69732D7570646174656422293B0A20202020202020207D3B0A0A20202020202020207661722073656C6563744F7074696F6E427954657874203D';
wwv_flow_api.g_varchar2_table(353) := '2066756E6374696F6E282073656C656374242C20726F77242C2020746578742029207B0A20202020202020202020202073656C656374242E6F666628276368616E6765272C2073656C6563745265736574436F6C6F72293B0A2020202020202020202020';
wwv_flow_api.g_varchar2_table(354) := '20766172206F7074696F6E24203D2073656C656374242E66696E6428226F7074696F6E3A636F6E7461696E73282722202B2074657874202B202022272922290A202020202020202020202020202020202E66696C7465722866756E6374696F6E2869297B';
wwv_flow_api.g_varchar2_table(355) := '0A202020202020202020202020202020202020202072657475726E20242874686973292E746578742829203D3D3D20746578743B0A202020202020202020202020202020207D293B0A20202020202020202020202073656C656374242E6F6E2822636861';
wwv_flow_api.g_varchar2_table(356) := '6E6765222C2073656C6563745265736574436F6C6F72293B0A20202020202020202020202073656C656374242E72656D6F7665436C61737328227468656D652D6D6967726174696F6E2D2D69732D6572726F7222292E72656D6F7665436C617373282274';
wwv_flow_api.g_varchar2_table(357) := '68656D652D6D6967726174696F6E2D2D69732D7570646174656422293B0A202020202020202020202020696620286F7074696F6E242E6C656E677468203C3D203029207B0A2020202020202020202020202020202073656C656374242E616464436C6173';
wwv_flow_api.g_varchar2_table(358) := '7328227468656D652D6D6967726174696F6E2D2D69732D6572726F7222293B0A2020202020202020202020202020202072657475726E202D313B0A2020202020202020202020207D0A2020202020202020202020206966202873656C656374242E76616C';
wwv_flow_api.g_varchar2_table(359) := '2829203D3D3D206F7074696F6E242E76616C282929207B0A2020202020202020202020202020202072657475726E20303B0A2020202020202020202020207D0A20202020202020202020202073656C656374242E76616C286F7074696F6E242E76616C28';
wwv_flow_api.g_varchar2_table(360) := '29293B0A20202020202020202020202073656C656374242E616464436C61737328227468656D652D6D6967726174696F6E2D2D69732D7570646174656422293B0A20202020202020202020202072657475726E20313B0A20202020202020207D3B0A0A0A';
wwv_flow_api.g_varchar2_table(361) := '2020202020202020766172207772697465203D2066756E6374696F6E2028207468656D652029207B0A202020202020202020202020766172206E657750616765526570726573656E746174696F6E203D207468656D652E6D617070696E67733B0A202020';
wwv_flow_api.g_varchar2_table(362) := '2020202020202020206966202820747970656F66206E657750616765526570726573656E746174696F6E203D3D3D2022737472696E67222029207B0A202020202020202020202020202020206E657750616765526570726573656E746174696F6E203D20';
wwv_flow_api.g_varchar2_table(363) := '4A534F4E2E7061727365286E657750616765526570726573656E746174696F6E293B0A2020202020202020202020207D0A2020202020202020202020207661722070616765526570726573656E746174696F6E203D206275696C64506167655265707265';
wwv_flow_api.g_varchar2_table(364) := '73656E746174696F6E28293B0A20202020202020202020202076617220746F7563686564203D20303B0A20202020202020202020202076617220706172736564203D20303B0A202020202020202020202020766172206368616E676564203D20303B0A20';
wwv_flow_api.g_varchar2_table(365) := '2020202020202020202020766172206572726F7273203D207B7D3B0A202020202020202020202020697465726174655468726F756768526570726573656E746174696F6E2870616765526570726573656E746174696F6E2C2066756E6374696F6E202820';
wwv_flow_api.g_varchar2_table(366) := '6F7074696F6E2C2074656D706C617465547970652C2066726F6D54656D706C6174652029207B0A2020202020202020202020202020202069662028216E657750616765526570726573656E746174696F6E5B74656D706C617465547970655D29207B0A20';
wwv_flow_api.g_varchar2_table(367) := '2020202020202020202020202020202020202069662028216572726F72735B74656D706C617465547970655D29207B0A2020202020202020202020202020202020202020202020206572726F72735B74656D706C617465547970655D203D20747275653B';
wwv_flow_api.g_varchar2_table(368) := '0A20202020202020202020202020202020202020207D0A202020202020202020202020202020207D20656C73652069662028216E657750616765526570726573656E746174696F6E5B74656D706C617465547970655D5B66726F6D54656D706C6174655D';
wwv_flow_api.g_varchar2_table(369) := '29207B0A202020202020202020202020202020202020202069662028216572726F72735B74656D706C617465547970655D29207B0A2020202020202020202020202020202020202020202020206572726F72735B74656D706C617465547970655D203D20';
wwv_flow_api.g_varchar2_table(370) := '7B7D0A20202020202020202020202020202020202020207D0A20202020202020202020202020202020202020206572726F72735B74656D706C617465547970655D5B66726F6D54656D706C6174655D203D20303B0A202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(371) := '207D20656C7365207B0A2020202020202020202020202020202020202020766172206F7074696F6E4368616E676564203D0A20202020202020202020202020202020202020202020202073656C6563744F7074696F6E42795465787428206F7074696F6E';
wwv_flow_api.g_varchar2_table(372) := '2E73656C656374242C206F7074696F6E2E726F77242C20206E657750616765526570726573656E746174696F6E5B74656D706C617465547970655D5B66726F6D54656D706C6174655D20293B0A2020202020202020202020202020202020202020696620';
wwv_flow_api.g_varchar2_table(373) := '286F7074696F6E4368616E676564203D3D3D203129207B0A2020202020202020202020202020202020202020202020206368616E6765642B2B3B0A20202020202020202020202020202020202020207D20656C73652069662028206F7074696F6E436861';
wwv_flow_api.g_varchar2_table(374) := '6E676564203D3D3D202D3129207B0A20202020202020202020202020202020202020202020202069662028216572726F72735B74656D706C617465547970655D29207B0A202020202020202020202020202020202020202020202020202020206572726F';
wwv_flow_api.g_varchar2_table(375) := '72735B74656D706C617465547970655D203D207B7D0A2020202020202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020202020206572726F72735B74656D706C617465547970655D5B66726F6D54656D';
wwv_flow_api.g_varchar2_table(376) := '706C6174655D203D20313B0A20202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020746F75636865642B2B3B0A202020202020202020202020202020207D0A2020202020202020202020202020202070';
wwv_flow_api.g_varchar2_table(377) := '61727365642B2B3B0A2020202020202020202020207D293B0A202020202020202020202020766172206572726F724D657373616765203D20223C756C3E223B0A2020202020202020202020207661722066726F6D54656D706C6174654E6F74496E4D6170';
wwv_flow_api.g_varchar2_table(378) := '70696E67203D205B5D3B0A2020202020202020202020207661722066726F6D54656D706C617465496E4D617070696E674275744E6F74496E53656C6563744C697374203D20303B0A202020202020202020202020666F722028766172206B657920696E20';
wwv_flow_api.g_varchar2_table(379) := '6572726F727329207B0A20202020202020202020202020202020696620286572726F72735B6B65795D29207B0A2020202020202020202020202020202020202020696620286572726F72735B6B65795D20213D3D207472756529207B0A20202020202020';
wwv_flow_api.g_varchar2_table(380) := '2020202020202020202020202020202020666F7220287661722066726F6D54656D706C61746520696E206572726F72735B6B65795D29207B0A20202020202020202020202020202020202020202020202020202020696620286572726F72735B6B65795D';
wwv_flow_api.g_varchar2_table(381) := '5B66726F6D54656D706C6174655D203D3D3D20302026262066726F6D54656D706C61746520213D3D202249525220526567696F6E2054656D706C6174652229207B0A20202020202020202020202020202020202020202020202020202020202020206672';
wwv_flow_api.g_varchar2_table(382) := '6F6D54656D706C6174654E6F74496E4D617070696E672E707573682866726F6D54656D706C617465293B0A202020202020202020202020202020202020202020202020202020207D20656C7365207B0A2020202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(383) := '20202020202020202020202066726F6D54656D706C617465496E4D617070696E674275744E6F74496E53656C6563744C6973742B2B3B0A202020202020202020202020202020202020202020202020202020207D0A202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(384) := '2020202020202020207D0A20202020202020202020202020202020202020207D20656C7365207B0A2020202020202020202020202020202020202020202020206572726F724D657373616765202B3D20223C6C693E3C623E22202B206B6579202B20223C';
wwv_flow_api.g_varchar2_table(385) := '2F623E2074656D706C6174652074797065206973206E6F7420696E20746865206D617070696E673C2F6C693E223B0A20202020202020202020202020202020202020207D0A202020202020202020202020202020207D0A2020202020202020202020207D';
wwv_flow_api.g_varchar2_table(386) := '0A2020202020202020202020206572726F724D657373616765202B3D20223C2F756C3E223B0A2020202020202020202020207661722066726F6D54656D706C6174654572726F72203D2066726F6D54656D706C6174654E6F74496E4D617070696E672E6C';
wwv_flow_api.g_varchar2_table(387) := '656E677468203E2030203F0A202020202020202020202020202020202020202028273C623E27202B2066726F6D54656D706C6174654E6F74496E4D617070696E672E6C656E677468202B20273C2F623E202266726F6D2074656D706C617465732220636F';
wwv_flow_api.g_varchar2_table(388) := '756C64206E6F7420626520666F756E6420696E20746865206D617070696E672E203C62722F3E2827202B2066726F6D54656D706C6174654E6F74496E4D617070696E672E6A6F696E28222C20222920202B20272927290A20202020202020202020202020';
wwv_flow_api.g_varchar2_table(389) := '202020202020203A2022223B0A202020202020202020202020766172206E6F74496E53656C6563744C6973744572726F72203D2066726F6D54656D706C617465496E4D617070696E674275744E6F74496E53656C6563744C697374203E2030203F0A2020';
wwv_flow_api.g_varchar2_table(390) := '20202020202020202020202020202020202028273C623E27202B2066726F6D54656D706C617465496E4D617070696E674275744E6F74496E53656C6563744C697374202B2020273C2F623E2074656D706C617465206D617070696E677320636F756C6420';
wwv_flow_api.g_varchar2_table(391) := '6E6F742062652073657427202B0A20202020202020202020202020202020272062656361757365207468652073656C656374206C69737420646964206E6F74206861766520746865207370656369666965642076616C7565732E3C7374726F6E673E4469';
wwv_flow_api.g_varchar2_table(392) := '6420796F752073657420224D617463682054656D706C61746520436C61737365732220746F20224E6F2220696E207468652070726576696F757320737465703F3C2F7374726F6E673E270A202020202020202020202020202020202020202029203A2022';
wwv_flow_api.g_varchar2_table(393) := '223B0A2020202020202020202020206572726F724D657373616765203D2066726F6D54656D706C6174654572726F72202B206E6F74496E53656C6563744C6973744572726F72202B206572726F724D6573736167653B0A20202020202020202020202076';
wwv_flow_api.g_varchar2_table(394) := '61722073756D6D6172794D657373616765203D20223C623E22202B20746F7563686564202B20223C2F623E206F7574206F66203C623E22202B20706172736564202B20223C2F623E2074656D706C617465206D617070696E672873292077657265207265';
wwv_flow_api.g_varchar2_table(395) := '636F676E697A6564206279207468697320626F6F6B6D61726B6C65742E3C62722F3E204F662074686573652C203C623E22202B206368616E676564202B20223C2F623E2074656D706C617465206D617070696E67287329207765726520616C7465726564';
wwv_flow_api.g_varchar2_table(396) := '2E3C62722F3E223B0A20202020202020202020202076617220686561646572203D202253756363657373223B0A202020202020202020202020766172206469616C6F674D657373616765203D2022223B0A20202020202020202020202076617220627574';
wwv_flow_api.g_varchar2_table(397) := '746F6E73203D20205B0A202020202020202020202020202020207B20746578743A2022436C6F7365222C20636C69636B3A2066756E6374696F6E202829207B20202428207468697320292E6469616C6F67282022636C6F73652220293B20207D2C20636C';
wwv_flow_api.g_varchar2_table(398) := '6173733A22612D427574746F6E2D2D686F74227D0A2020202020202020202020205D3B0A20202020202020202020202069662028206572726F724D65737361676520213D3D20223C756C3E3C2F756C3E222029207B0A2020202020202020202020202020';
wwv_flow_api.g_varchar2_table(399) := '2020686561646572203D20225761726E696E67223B0A202020202020202020202020202020206469616C6F674D657373616765203D206572726F724D6573736167653B0A20202020202020202020202020202020627574746F6E73203D205B0A20202020';
wwv_flow_api.g_varchar2_table(400) := '202020202020202020202020202020207B20746578743A20224D617020746F206120446966666572656E74205468656D65222C20636C69636B3A2066756E6374696F6E202829207B202428207468697320292E6469616C6F67282022636C6F7365222029';
wwv_flow_api.g_varchar2_table(401) := '3B2063686F6F73655468656D65546F577269746528293B207D2C20636C6173733A22227D2C0A20202020202020202020202020202020202020207B20746578743A2022436C6F7365222C20636C69636B3A2066756E6374696F6E202829207B2020242820';
wwv_flow_api.g_varchar2_table(402) := '7468697320292E6469616C6F67282022636C6F73652220293B20207D2C20636C6173733A22612D427574746F6E2D2D686F74227D0A202020202020202020202020202020205D0A2020202020202020202020207D0A20202020202020202020202073756D';
wwv_flow_api.g_varchar2_table(403) := '6D6172794D657373616765203D0A20202020202020202020202020202020273C64697620636C6173733D22612D416C65727420612D416C6572742D2D64656661756C7449636F6E7320612D416C6572742D2D636F6C6F72424720612D416C6572742D2D27';
wwv_flow_api.g_varchar2_table(404) := '202B206865616465722E746F4C6F776572436173652829202B20202720612D416C6572742D2D686F72697A6F6E74616C223E27202B0A2020202020202020202020202020202020202020273C64697620636C6173733D22612D416C6572742D7772617022';
wwv_flow_api.g_varchar2_table(405) := '3E27202B0A202020202020202020202020202020202020202020202020273C64697620636C6173733D22612D416C6572742D69636F6E223E3C7370616E20636C6173733D22612D49636F6E20223E3C2F7370616E3E3C2F6469763E27202B0A2020202020';
wwv_flow_api.g_varchar2_table(406) := '20202020202020202020202020202020202020273C64697620636C6173733D22612D416C6572742D636F6E74656E74223E27202B0A20202020202020202020202020202020202020202020202020202020273C64697620636C6173733D22612D416C6572';
wwv_flow_api.g_varchar2_table(407) := '742D686561646572223E3C683220636C6173733D22612D416C6572742D7469746C65223E272B2020686561646572202B273C2F68323E3C2F6469763E27202B0A20202020202020202020202020202020202020202020202020202020273C64697620636C';
wwv_flow_api.g_varchar2_table(408) := '6173733D22612D416C6572742D626F6479223E27202B20206469616C6F674D657373616765202B20273C2F6469763E27202B0A202020202020202020202020202020202020202020202020273C2F6469763E27202B0A2020202020202020202020202020';
wwv_flow_api.g_varchar2_table(409) := '202020202020273C2F6469763E27202B0A20202020202020202020202020202020273C2F6469763E27202B0A2020202020202020202020202020202073756D6D6172794D6573736167653B0A2020202020202020202020206469616C6F67282022417070';
wwv_flow_api.g_varchar2_table(410) := '6C696564205C2222202B207468656D652E74657874202B20225C22206D617070696E6773222C2073756D6D6172794D6573736167652C2022222C20627574746F6E73293B0A20202020202020207D3B0A0A202020202020202076617220746F5461626C65';
wwv_flow_api.g_varchar2_table(411) := '203D2066756E6374696F6E2829207B0A202020202020202020202020766172207461626C65203D20223C7461626C653E3C74723E3C74683E5468656D653C2F747274683E3C74683E54656D706C61746520547970653C2F74683E3C74683E46726F6D2054';
wwv_flow_api.g_varchar2_table(412) := '656D706C6174653C2F74683E3C74683E56616C75653C2F74683E3C2F74723E223B0A202020202020202020202020666F722028766172206B657920696E20737570706F727465645468656D657329207B0A20202020202020202020202020202020766172';
wwv_flow_api.g_varchar2_table(413) := '207072696E745468656D65203D20747275653B0A202020202020202020202020202020207661722070726576696F757354656D706C61746554797065203D206E756C6C3B0A20202020202020202020202020202020697465726174655468726F75676852';
wwv_flow_api.g_varchar2_table(414) := '6570726573656E746174696F6E28737570706F727465645468656D65735B6B65795D2E6D617070696E67732C2066756E6374696F6E286F7074696F6E2C2074656D706C617465547970652C2066726F6D54656D706C61746529207B0A2020202020202020';
wwv_flow_api.g_varchar2_table(415) := '202020202020202020202020766172207072696E7454656D706C61746554797065203D2066616C73653B0A20202020202020202020202020202020202020206966202874656D706C6174655479706520213D3D2070726576696F757354656D706C617465';
wwv_flow_api.g_varchar2_table(416) := '5479706529207B0A2020202020202020202020202020202020202020202020207072696E7454656D706C61746554797065203D20747275653B0A20202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(417) := '70726576696F757354656D706C61746554797065203D2074656D706C617465547970653B0A2020202020202020202020202020202020202020766172207472203D0A202020202020202020202020202020202020202020202020223C74723E22202B0A20';
wwv_flow_api.g_varchar2_table(418) := '2020202020202020202020202020202020202020202020223C74643E22202B0A202020202020202020202020202020202020202020202020287072696E745468656D65203F206B6579203A202222202920202B0A20202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(419) := '2020202020202020223C2F74643E22202B0A202020202020202020202020202020202020202020202020223C74643E22202B0A202020202020202020202020202020202020202020202020287072696E7454656D706C61746554797065203F2074656D70';
wwv_flow_api.g_varchar2_table(420) := '6C61746554797065203A20222229202B0A202020202020202020202020202020202020202020202020223C2F74643E22202B0A202020202020202020202020202020202020202020202020223C74643E22202B0A20202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(421) := '202020202020202066726F6D54656D706C617465202B0A202020202020202020202020202020202020202020202020223C2F74643E22202B0A202020202020202020202020202020202020202020202020223C74643E22202B0A20202020202020202020';
wwv_flow_api.g_varchar2_table(422) := '2020202020202020202020202020737570706F727465645468656D65735B6B65795D2E6D617070696E67735B74656D706C617465547970655D5B66726F6D54656D706C6174655D202B0A2020202020202020202020202020202020202020202020202022';
wwv_flow_api.g_varchar2_table(423) := '3C2F74643E22202B0A20202020202020202020202020202020202020202020202020223C2F74723E223B0A2020202020202020202020202020202020202020207461626C65202B3D2074723B0A2020202020202020202020202020202020202020202F2F';
wwv_flow_api.g_varchar2_table(424) := '7072696E745468656D65203D2066616C73653B0A20202020202020202020202020202020207D293B0A202020202020202020202020207D0A202020202020202020202020207461626C65202B3D20223C2F7461626C653E223B0A20202020202020202020';
wwv_flow_api.g_varchar2_table(425) := '202020242822626F647922292E68746D6C287461626C65293B0A2020202020202020207D3B0A0A20202020202020202072657475726E207B0A20202020202020202020202020746F4A534F4E3A2067657454656D706C6174654A736F6E2C0A2020202020';
wwv_flow_api.g_varchar2_table(426) := '202020202020202077726974653A2077726974652C0A20202020202020202020202020746F5461626C653A20746F5461626C650A2020202020202020207D3B0A20202020207D2829293B0A0A0A2020202020766172206765745468656D65546F57726974';
wwv_flow_api.g_varchar2_table(427) := '65203D2066756E6374696F6E287468656D654E756D62657229207B0A20202020202020202069662028217468656D654E756D62657229207B0A2020202020202020202020202072657475726E20756E646566696E65643B0A2020202020202020207D0A20';
wwv_flow_api.g_varchar2_table(428) := '202020202020202072657475726E20737570706F727465645468656D65735B7468656D654E756D6265725D3B0A20202020207D3B0A0A20202020206966202857524954455F4D4F444529207B0A2020202020202020202866756E6374696F6E2829207B0A';
wwv_flow_api.g_varchar2_table(429) := '20202020202020202020202020766172207468656D654E756D626572537472696E67203D2024282223503338365F4143544956455F5448454D4522292E7465787428293B0A20202020202020202020202020766172207468656D654E756D626572417272';
wwv_flow_api.g_varchar2_table(430) := '6179203D202F285C642B295C2E2F2E65786563287468656D654E756D626572537472696E67293B0A20202020202020202020202020766172207468656D65546F57726974653B0A2020202020202020202020202069662028217468656D654E756D626572';
wwv_flow_api.g_varchar2_table(431) := '4172726179207C7C207468656D654E756D62657241727261792E6C656E677468203C3D2031207C7C20217468656D654E756D62657241727261795B315D29207B0A20202020202020202020202020202020206469616C6F6728224572726F72222C202254';
wwv_flow_api.g_varchar2_table(432) := '686973206973206E6F7420746865205468656D652053776974636820506167652028333836292E20506C6561736520747279207573696E6720746865206D617070696E6720626F6F6B6D61726B6C6574206F6E2074686520636F72726563742070616765';
wwv_flow_api.g_varchar2_table(433) := '2E22293B0A202020202020202020202020202020202072657475726E3B0A202020202020202020202020207D0A20202020202020202020202020747279207B0A2020202020202020202020202020202020766172207468656D654E756D626572203D2070';
wwv_flow_api.g_varchar2_table(434) := '61727365496E74287468656D654E756D62657241727261795B315D293B0A20202020202020202020202020202020207468656D65546F5772697465203D206765745468656D65546F577269746528207468656D654E756D62657220293B0A202020202020';
wwv_flow_api.g_varchar2_table(435) := '202020202020202020202069662028217468656D65546F577269746529207B0A202020202020202020202020202020202020202063686F6F73655468656D65546F577269746528207468656D654E756D62657220293B0A20202020202020202020202020';
wwv_flow_api.g_varchar2_table(436) := '2020202020202072657475726E3B0A20202020202020202020202020202020207D0A202020202020202020202020207D20636174636820286529207B0A20202020202020202020202020202020206469616C6F6728224572726F722070617273696E6720';
wwv_flow_api.g_varchar2_table(437) := '7468656D65206E756D626572222C202065202B20222E20506C6561736520676F20746F20687474703A2F2F617065782E6F7261636C652E636F6D20666F72206D6F726520696E666F726D6174696F6E2E22293B0A20202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(438) := '2072657475726E3B0A202020202020202020202020207D0A202020202020202020202020206170657854656D706C61746548656C7065722E777269746528207468656D65546F577269746520293B0A2020202020202020207D2829293B0A20202020207D';
wwv_flow_api.g_varchar2_table(439) := '20656C7365207B0A202020202020202020636F6E736F6C652E6C6F67286170657854656D706C61746548656C7065722E746F4A534F4E2829293B0A2020202020202020206170657854656D706C61746548656C7065722E746F5461626C6528293B0A0A20';
wwv_flow_api.g_varchar2_table(440) := '202020207D0A207D2829293B0A';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784238077763151245)
,p_file_name=>'bookmarklet.js'
,p_mime_type=>'application/javascript'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/img_persona_female01_apex_png
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000001000000010008030000006BAC5854000002FD504C544547704C5F4146693A476B3C48693B466A3B466A3B47693B465C434760494D5C4349693A466A3B476B3C486B3C476A3B476B3B476B3C476A3B47554F';
wwv_flow_api.g_varchar2_table(2) := '4E837A6A6A3A466A3B476E3E4A6B3C486C3D496D3D495C3E456140476D3F4A6D3E4A6F3F4B6A3B476B3D486B3B476C3E496E404B6F414C6A3B486B3B476A3A466A3B47735D4D6A3B476B3B4870424D6939467346505E41476A3A4671444E6B3B4772444E';
wwv_flow_api.g_varchar2_table(3) := '76485173535C765E66889C9D858E91704C568CA9A98BA6A68695977A7473796A7090A9AA8BA3A3837E7C828588673745807A79683A467C4D547D7776A77A7287585BC59B87DEB099CCA18BCC9686BC8D7FA2746E9B6C69D1A18DDEAF98DCAC95DDAD95DF';
wwv_flow_api.g_varchar2_table(4) := 'AE95D8A992D09D8BB38479DBAB93DCAC94DBAB94C89E89815357C59484DAAA92936463DDAC948D5F5FDDAD96DDAE97D6A790D4A58FAB7F75E0B29B6A3C47E3B198E0B099E1B097AA8A79A58677B08D7CBA9582CFA38DC59D88BE9784C9A08B5D41465750';
wwv_flow_api.g_varchar2_table(5) := '4B544E4A5A524D5F554F655A54706058806D649E8275C19985937A6E73645D7B6A62695D578D766B4B47444845424543414E49475C5754514B48504D4C84706788756B6E615C43413E997F725A5553937F74786860605956524E4DD3AD9AEABFA9E8BDA7';
wwv_flow_api.g_varchar2_table(6) := 'E2B8A3B89888A0887AA98E80BC9C8BD9B19EE6BBA6DDB4A0C5A391E1B7A2E3B9A4E4BAA54E4B4AB39586CDA7965752503D39353A3733403C39B6907F58535154504EC78D81C2867D956563DAAB92D8A991DAAA91DBAB93D8AA91DBAB92DBAC93DBAB93DB';
wwv_flow_api.g_varchar2_table(7) := 'AC93DDAD94EBB9A0DAAA92AF8678DBAC94C69D87DBAB92D9AA92D9A992DAAB93524E4D524E4D534E4DA28475514D4D504D4C524E4D524F4E555150524F4D534F4E524E4D54504E524E4D54504F534F4E585452524E4D55504F55514F524E4D544F4E514C';
wwv_flow_api.g_varchar2_table(8) := '4C524E4D524E4D5D58565652505753515A565354504E544F4E524E4D524E4D5652506A6563726D6C75706E6762616D6866645F5E97918F938D8B958F8D6F6A69908A8878727196908E9993909B9593605B5A8883818D8785E6B49BDBAB93DCAB92DAAA92';
wwv_flow_api.g_varchar2_table(9) := 'DBAB92DAAA910C80596B000000FF74524E5300143E687D7661360A051B5797CAE5EDF4F9B4280144AAFBFFFFFF0E30FFFFFF88FFFCFFFFFF4DDB71A102D1FFFF2BFF22FFFFC0F3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF';
wwv_flow_api.g_varchar2_table(10) := 'FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6EFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBC72E129C2';
wwv_flow_api.g_varchar2_table(11) := '1DD50CA9F546FF7D83B5C1643A31ED54A5E0BB9A367FF4FFFBECC9936BFFFFFF60FFFFBD744587F7FFFFFFFFD3FF8CB3F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9914F28C528615CD3100002B18494441547801ECC105018000000020BB3BFF3F';
wwv_flow_api.g_varchar2_table(12) := '75850D04000000009709A33849D32C2F82FF29ABBA69BB7E18C771E8A77909FEA488D67A1BF6831CFBC08A1C46C238FEC8394EFA7F6654464822DAD36B9369989CF3FD4FB33CBAB5A43DC0187ED0F92595A4AA92400048C5E2D8DA235AF72FC7979D890C';
wwv_flow_api.g_varchar2_table(13) := '81CAF59947B2F247E69E2F960519028F6063EE310C7FEDD9FCC2725920321F0062428B9B8F60ED4F6C6D94C67D12515B9B0F7DF16FAF2F21CF5D1E7C0894E5D2CED4C8DAF4F4CCEE831CFFCB9DBD15C045001300720EAA3A019222B0BCB5B03A3FB1F96A';
wwv_flow_api.g_varchar2_table(14) := 'F6C11585B93D09C023C8EA9E0764A020648024B392ADE763A3FF7948E39F5A344000226BEADA0308A86AE75A0302005696CBFBE3CF1ECA3A181DDF1248425C0B6DE05A0C0431904440561F2C8C3F8865B0B6BA528073DC56B7DE1C9991251BBEB7D8BED8';
wwv_flow_api.g_varchar2_table(15) := '5A1FE9FEF25FDD102009A4E873269450CD7D528E86A2DCC6D664B737C2CCAB4541085CF192C842002403400CB9E4C9E440ECBFEC720066770CA94EE0C4409D801051F090A20990F006020908CAF102CAC5B1CE9E97A727569720AA6A901808BD04C82181';
wwv_flow_api.g_varchar2_table(16) := 'AFDBC8807720200628C4154905143CEF6A321C5F2E058248860F9E2B4E403CACB92D880C0F024ADB7FD5CDFCB7643793BC22144616440129709BC8849C0770D8C25417DBDF7D43DC62312586DA088400E2FF526C62CE88AA17BAB70B46B650191890F700';
wwv_flow_api.g_varchar2_table(17) := '980420400C250178CF7DC169F083CAE7235D4B80E3867AB541D35464D1DDDAE8E206CF906818086494F31DBB349ADF00E443A5A3E35EC390090005AE481618F2015C92628C6D5B5400C2E52D42E9D63B35FEC96523D4818AE39393D3A3A6E2A61000104A';
wwv_flow_api.g_varchar2_table(18) := '461003327758FBD4B3FAB0B518551B12A800909636BBD400ED19A18D81E6ECB47FDEBF787D5655DC27E76EEC05C9F51C0421796B711E402E798AD4B6B637DB99F13F9DDC108A4AB53BBAE89F9FF7CF4FDEB4552100EFD0E0CDDDFD1F7C6A2B0FE22E45E1';
wwv_flow_api.g_varchar2_table(19) := '617EB7330B60BF047CD5F6527CF3F63202E7EFCE4F8FA800941C201485C0094000C103E62C729B7C4800B6D8956E60664200846434EECD49FFFC52FFDD9BD400C8295904E530200499475C93811303E57A474E05CF96051E5200AAE6ECFDBBCB00BC7DDB';
wwv_flow_api.g_varchar2_table(20) := 'FF70F611084DDD8A019918527EBEC51B14E41F979E75A305583581900050938E2F13C1DBCB205CBC7115C23900849119009241E09AEF25900A1300E5F3B54E5C816E708392AAEAECD3BBFED536F8D056DCAF875EC367E38E206E5A19ED420FFC5C5820F3';
wwv_flow_api.g_varchar2_table(21) := '26A8383EBD0AC1BB0F67DCA0C8670031A4FA6648C00482CC763AD00F6EAF144D8A64C5E06D135E5FF42FCBE1C9C55191CA7AF87B150EBF340DD7D4BA80C02C0004C43589E57FFF50B4BB2A219199018364F8E16A117C6DEABA6E1D009F0FBF7DFB527EFC';
wwv_flow_api.g_varchar2_table(22) := '0C4088E28E74E3F2D801B0FDEFDF822F4ADC6062A8D1F1E9E526386E141A04549FBFFFF8F9EBF79FBFDFF519F0F703E0BD0B92470ADEE13DECEDFEF33B60F97F35EE6E1A6BE81D7DF81AA9DAF6BFCC5A87929C381075CEE1F2A9B992A630D2C5E130B8E6';
wwv_flow_api.g_varchar2_table(23) := '0FAE661D706D4062BC2D6D06E71CFEFF560231CCD81FA037416C5E351D5EBF96A3F96C7BA792AAAE174FB6663959F302EE7F03859446F6D2750EDF5D0E3D027E61E3CACE27648C69EE78207553B1D9EE42A18556666F9B921C6CF2F3692FB52C2976C154';
wwv_flow_api.g_varchar2_table(24) := '64E99444DD6FBC137A5378E5A663C143F2667643EBA010937CFFC06E5EDAA7417DB87934B35521EAE4134858C70E989FA726B12D2624BA19761DB87AF91FB6C6ED60D9F7C0A8FC1F3D51061DBA451F1F9C24003E73A68278807D4E8B4E5B8F6E853D27F8';
wwv_flow_api.g_varchar2_table(25) := 'F187DB900C35FE5B0037F59A9F2CAAA66DEDEE8D44075D3DDE9EFCD76DD737882C1EFD1015B32286EFCE076D80DF27EB7C1EE02B0340214E76143665792835F6FB371295DA3C72FBE7D67691BD8C7B36C9A776A636CB80B0BFC2A6C193C1D5D9F82850C2';
wwv_flow_api.g_varchar2_table(26) := 'C6CC10ECFE11A54129B17701DD9E2EEAE911A11480C544647C694ACE87D099DCBB12720ABC610DC06CD6268CC310FB2959CA9CBCA0DB3B1A0D76907D0898CAAEF5EEC96CEA3AA9A4EF146D295821567F044C067FBA7B1B0058218ABE12F899882F868C92';
wwv_flow_api.g_varchar2_table(27) := '38CFB7161A7DFE3365D9C8D3A5F59F519B1B62EA950196F49B87412988BE3B17B0016C0470CE9938C572C21B130F5E009DEF3F53D8C398A66D9A561A391800F1E0C47263009AA77D4F3105661341D419F17AC045F046E4C59BD98C78248C8CC820D9D8AC';
wwv_flow_api.g_varchar2_table(28) := '7109D34AA96D18B495B27ED1542D1E3C98E52401B0310F918BA038E659C6BA5F7DF1A77053C03F5EC5268293783C06F5C8C5731FFEC6AD65D9B6D2605BBE680D1ADDBEA84C85BB334896E351C82659C2D28C413722B912AE01BEEB8AD6F848D49467C9A8';
wwv_flow_api.g_varchar2_table(29) := '339AEF3F5538C04863B4AC4E1FD25A014D638E5B89EAD98918AB6400DC3E8993C7D80FE1CAE3773B2D88FA1E28FA5AE7139B0AC7681A9495294B6B0DE712BA6C10D5EEC3C86B2294119B0E32D1571116F0A0F4DC9D6F383D44E3083842A31107F663B980';
wwv_flow_api.g_varchar2_table(30) := '3652565D4CD8A7AE249AC3CD87B4809844FD2F4B040327330289FEF837743570950473BABC9E3F7C328E7FD35826DC361275FFE9A6BB6EA4DA2C6CD017C4B641AC2BA6454C5901703BDC8EF8E5520E05FFB45960E8868B830A57A18D344DD5988E0818A9';
wwv_flow_api.g_varchar2_table(31) := 'A55D5B8D870F44CA088B294D786F809403111C26E18AE3175628BF73593A3A239890936795BFFB3D4C570A4DEF035A6A5B0A0CA27A7634CFB9100071D1FF34406CE97016EE94F4E2B7A67A902C23E079297B11C02FA6716E30D8A32ACBA6FBBADE7938A7';
wwv_flow_api.g_varchar2_table(32) := '99E80F930C4A1115D9A5700F05ACEE3D5EEB06E71B7BB5BFED7E194136F6BD2A7D852CB77342056150CC38001DE60CE9C56075C11F56C7BDEB981FD5DA553BB51603685C0D344E1BEAA3C1A03AD898135114A9C8A6224DC175160C88B810AC28748FAE88';
wwv_flow_api.g_varchar2_table(33) := '00B076F62BDB7D55D775D36AF4F021201D27B2AEAFAA5ABD7E53AB6329F1CD034AD28C4022B828522009A794B038E019E9CD62A500A67CD501F6DFBE7DF7FEC3E3C59B37F5B177FBB26ABA1BDE221ED7AFD4C74F8F3E7F78FF79EFCBE2C5AB37D57EEE08';
wwv_flow_api.g_varchar2_table(34) := '204DB358008941080254046B80DF6ED164D4F8FF4FBD7570259204E1CB3947E01EB01836CA06F6F90F7CB839B3BE05D91C2F880961C8C1EE9EC3009B7050A061669453BCFB8D57D533A6757FC0EC47CE544D5575F5D75F63B8EE866726168FC7A4443295';
wwv_flow_api.g_varchar2_table(35) := 'CE6483463B74E3D1E8A30B37440718BA11CDE50BC50440824BB2989A1D7BE03267C2AE3EB142E270DB417370E073CB3A60B7C52874DD93027E42118C312AC75363174321B41C3BE1D1D0FDE06424F5B72C5EA6B24C1882C44B2579C66FB4937D78D5EB00';
wwv_flow_api.g_varchar2_table(36) := 'E1B1FBB0658BE02143D7B59F0C74E2919CD9B29F51446A7C72E451E8FEFDE0C8DD1B8FC39184F12A21141D006094CC11194E64C63FE044FB7D3EA4C91C5EEB3AE098C3B61B0EFBEE04E82FCCCFCF2F14F28B45A9C4CA142C4CE5226391482557C9CCC618';
wwv_flow_api.g_varchar2_table(37) := '5A4FE3CF170BF30BB9172F720BE9978BAF5E332ACFA1475CC00D3921FBFBB0A9707FF29EA51D60DF270533B50ED5A5A5256549A9559757161663652A4CA66506D7C27C7971A1DE68F2254581F7015AEDCC22A54486F3091FF04C424F0E575EEB76824780';
wwv_flow_api.g_varchar2_table(38) := 'C5DBAF7CEE15F70686D59A80A6734569B6174A60DC2A9D83430CA0942EAE3575856B085DC3F769BAD2CC314A28215E4357E1F2F582C6EC57EB9282076CBD385EEF6987ECDB136134AA6642E7AD7A89ACAE5259184F89BC50E5BAE1A09A0630EEF28E280D';
wwv_flow_api.g_varchar2_table(39) := 'B26D5B61DA6BE9E9F05710EFBDB6B7C37F76DB785D18A7AD607ECB04CD2724DD349FC58BF1167CD85A6024967B3AE8B799B03623F4B14106BEDD01D322FC758EF12D62412D627DCB1764BA2AFFD3368EBFF9067C20D07AC1562B53E15B27B63C60074ED0';
wwv_flow_api.g_varchar2_table(40) := 'BA4AA94F7A5CD8FE795C7B854E628D6FA803B1AD56AB4DBE95076A865236FBF0428E50BAA8EABA511F5AD5AA0A95603B02CAE548782A7AC5BFD55B002B7CD4BA9418921E78DE033B4A1C6CCE8EA6B532F97C7AADB6853A65C9F0CD9BD124A36955C43FE7';
wwv_flow_api.g_varchar2_table(41) := 'CBF3F997952A3783446B16181B03078C9F38E544F33DD65E1778FF9821E4786324C4BFEE3FD7D4787D7D7D7D8365B8590C5708CB041EDD0864CAF4A591FFBC9AD82897BBF9AA110E35AD9A64F1F1F054F8FC39EF20AE3781FD5665C4109FFFE2405923E8';
wwv_flow_api.g_varchar2_table(42) := '1FF6B1A2A71E4095CB6D74BBDD8D946AD8AF164869F3AFD1E0CDE9387DD511231F6FCBDD6EB9CB1A8A391E74084B6E86A7A6A20FEC7D3E37FAD26D65D1F8E7471C76FBAEC10F23D61479F86FA99A56110EC86386C3B91AA3C9C90028231EA7CAF20AD784';
wwv_flow_api.g_varchar2_table(43) := '034AEBE001B2ACE07BA01AD6197B998D46A72E3E006AC0261CF0C34F1616087DE4C244DDC9FD9DAD004367D59AB2DC5D87534EA921788590D9BF8280BF7284BE6C6108E8CDD406BCA5084540D735C8810261B9C92846C029D153FABCDF7F64757D84D819';
wwv_flow_api.g_varchar2_table(44) := 'B517E8802B2D1804664B5D9AAE8A0C58EA2458221C8025A160E07C82C5EBA2FB511AC57259AA731C0FE189A644486452A4C08007256476AFB535F3B83C6E6CF6B1BFE980A72AB640EDB5464BAF89639D6764FE8FD0F567D72104D294FD5B177EE1CDE5B5';
wwv_flow_api.g_varchar2_table(45) := '0EC78A886F5A9159721AEC9FCADEF638FBFBD1B59801161E064EBBF6CAA150E820242243B754619FA2E8467D9BA5349E0D0025843CD87489D2576D2E8C86A9101C7CA30B48129A860408473787078C1D16DF5B5B22F4F901EFDE26C8650C8A761BA4005A';
wwv_flow_api.g_varchar2_table(46) := '6E4253EB84D2C27D4185211B348FB3A1F656FB83E50FA0540895C6A358029EE2264AF4EA3716DF3F78F057D7EEF877E1EABEE80587AE1A554EC344E0CD8C4C65E97C701B17139492E21ABC478C10C698B82C419644A7A00DC8DEB3795D4229FAD57BD6C6';
wwv_flow_api.g_varchar2_table(47) := '8F5FEFD060AE6DB1307406FE7B2AD78DEE4E51DB6946A1C119DD61C643E32546E97F2F3A3A87F227E643BC5DA434390D09103E7FC56B12ACDF597D1BF56FA892EA75BCD90AFA9CA76E37F425CE39F21C15098C25958721532505B7A160063D20E7D7AABA';
wwv_flow_api.g_varchar2_table(48) := 'A2C0BB9466FD1521F10856C076F681CFEB7947F60B7CE806EEE78473AF2E1072C03D132B64EA8D352083E2480291CC5D931A37D441A1D0A6440965ABC974A5DE68D417F2843149D83F95BDD7DB277C6AFFE6F8BBB061CA3338E835E643BBB4620E0F6572';
wwv_flow_api.g_varchar2_table(49) := '5C7A5E62603E65B1483020ECDE59260E4CE72980E1DBA41263B49CDC8CA2FD9B0FDCA6D6C2FDD151EBEF983AEDC686659750D254FB79659310263289E52E8E864C890C5CDFBD7B171F049E8CA50821E26D8492F8C2C5917076F3E9D561DB805158DC5F5B';
wwv_flow_api.g_varchar2_table(50) := '3E009014F97E2F356CB2FA83832929063C7F4C4AA6C7AEDD35D683EF3E0987C3D9E989E9EC1378043E19399F4B17139224255F662E826AF2F630A8CDFABCE6A6835F3FF9E99DD8367CC2EC853DBB6BA1B7EFF24874620C56C64281FBFF737796DB892451';
wwv_flow_api.g_varchar2_table(51) := '1CEF7177EB62A6E124842884852C6FC0817802144D52B7E25DCD181BFF3C0FB432EEEEAFB594B5E4E405BA7F09FAADEE29BD75FF7F88C4693DDADAFA6B6B6B6BAFADBF61CDA66DBB2E3C74D609ED6C54F85042EA863D79211A1E0257337E9DBC473A5B99';
wwv_flow_api.g_varchar2_table(52) := '2760DBCD2678A501CE34EB46A0CB2E3994667DB96206B87CD28804C77BBDF55F83D256D12AB5C0BF12C7720284D59DEDED1D1912460E602FFAC6035C4B16150381D111D5FA9EE0B550D1B2568004917A09705DD5271C4C42D04EADA24547C84AA3B1A878';
wwv_flow_api.g_varchar2_table(53) := '4A0D0FE9634058229AD201A0A2225294880500F511EBFA19D69E2C07F4A75C291211EEC83371C805249140E95A037BEDE7FF8C111F0718061108F535B5578A15EF82A5EFCF08F9479C1E416698A4D05057EBF71A54B41B18F13A83FF8E7AF32387ADDF2D';
wwv_flow_api.g_varchar2_table(54) := 'FBA2EA5BC7868DC8706628850EDC8CF2619CCD2D3618887DBF83E516E85080525D24E6EF23B86C3C3AFC219563485C67224F015CD8F0D44104DC3A9BD63D800F7F20ED5522604A4536E7AF8128622E42D76F0C24B46D62A9689AB2CE1955AA2BB63AFF11';
wwv_flow_api.g_varchar2_table(55) := 'E63E9EADB75731A38436186EB5171ECFAA0060F104EE9AAF2BBF1A3517A5B3374D49BE1B0094CD979252403E718F622CFA3E85D9274F9E3C5E59E0CC3E7EDC7DDF8660193DAC2454D931EA8D5CFB8DE1A317A56D5ABE54CC0A7F24E11F5CDE586D12AC8B';
wwv_flow_api.g_varchar2_table(56) := '03179E04F1DB4F89439903B582940925AEF0CBD0C83194E25EC1C97CA94F4BA291992E94A63A9470F89A0F0B8FFDE6CFB6288F8A9E239CC6521E49BDE42D5E14173DFA4752662287FA727A21E775DF196B11FB7231825BBCF37366EBBCD98C120DD83569';
wwv_flow_api.g_varchar2_table(57) := '429218E065A151E4C6C50C4A224F3CDEC395907973A30D8402762875F81200D06AB9DD3F009D1B50D873B98299CD155337478D88323C86D256E84498CCE4ADFC2255C39C0115190002007C57A8468004DA939690D846D956B7FF120AD74B6578C96FA90E';
wwv_flow_api.g_varchar2_table(58) := '549585FB0931CC9C7B582F901C7B3E9D4689DE9173A78DE8327CEC0A3283F4A57325AB304128E112298A0327234AD5F8C73A1150CE5D19381F7157E5DB37797D7730023D492B9B6F49610065C05B8E49102AB7864E37002331F0D53E7B2165E5433A7A94';
wwv_flow_api.g_varchar2_table(59) := '3673773BD421EA2CAC073EC817AA02B0DE7A7AEE8811038E5D4EA403DA19A19ACA579718C5078F42EA13A843E18367462C387DFC92CCE848CB680BF1AD61CF461DC82150AA9F71E7F90B231E9C397729E12704646ECC4CCEDB41C110F59E745C005EBE32';
wwv_flow_api.g_varchar2_table(60) := 'E2423F37574616177E674C49A5B4D2F4163C088F052642D1791D9F005C3F7931892CD42714A41652DAA9FA3A9D76C4D4C7584844D820245601E0DC18F096C15C522589D666C0E1990F4AB01CFA611EBC7C63C488639793BE99742E833296559C678E1CF5';
wwv_flow_api.g_varchar2_table(61) := '0ECF12EA246903C73200A747C77AFD2CB1D597B7102A6DCDECEFB8BCBD8C3540767E68F0A0C46E0870CE9CBCA87F5007C94C79A1B4C86B9F76DA6D1753B7BDD322382024EDBCBD6EC48C5363A11FD942E942756F6657B3EFF2D55F98C9A82170C6881BA3';
wwv_flow_api.g_varchar2_table(62) := '572F26CC0005B3C6EBFF4401C88CC88636E481502F83B1E3CC9DAB29646AB81342F5EED22E67474A69D9B4A30E8430FDEEBD1143CE0E0E64B5AD08B7CBB2AAF33C023BAB72F2A38E7722BCF7E1E3B01143CE7C9A2825CC4241FA255B1994AB3DDA6F8936';
wwv_flow_api.g_varchar2_table(63) := '87A10F3EBF3262C88B2FFB8FEE6E548BD94AC1EA490B6BC9C9295E30E130DE6AA03A3F4461FDAB113F5E7D1133FE543706A98CD953E1173FE5C9B9F5263F0262C2EE813A0F5120F6CB6F46DCF8FE655F2D7A4BDBF36B93D56AAE5CAE94CBB9893656E541';
wwv_flow_api.g_varchar2_table(64) := 'C1F440E779CCE6C13B1F9FEFFBEBFECEFED4F63F738B77276AB5DAC6FCA1F901FBC757E3EC9198B4FEF6CF5FBFB766767DF6BBFF6DB0A1E5BA6E7DE97F6ACE67474D288AC3E9AEE3D6D94D9F6056BE877537D0043A89212D2E9AD1D68C2BA39D7F1B4343';
wwv_flow_api.g_varchar2_table(65) := '2495473071A13C45231D04B19E835E1DDBAB3E49414E06D33A7BF936D7EBCAEF770E70724354A543083F7E3E3AD9B3F4DB9F6646B6EB998D6B92A71ED859CB118A7410E55A1FFBFEE49793EEB1F8243BF5012140ED61CFBFF0FE6D624A27C4FF3C0C85AF';
wwv_flow_api.g_varchar2_table(66) := '751343C09FE532AF535B7D67E40630470444D6CEEF26BFFC65AD2425C6D12A7F90933331F22FDC9A1803F6627A92CED16F39F48D39330388451A5F6A61F14B2A1D8727247B5A64A54FFE1620C2D81E4E9F527743CCAE26BFFF743822AED71861A25E51D5';
wwv_flow_api.g_varchar2_table(67) := '6254E70BE9309481A2DE74348C89C2E39EE7DA93E99B34E93B437BCCD9608321CCE071029AD12E292FABD35B72B2A43691FCD91AE2100002D75E9DA7E5B1975BFA003B6B6BA7818469E99FD58F8AFC52ED439462F5A1C31192062078ABE5AE9CCCF1DF0D';
wwv_flow_api.g_varchar2_table(68) := 'CE73B3C53830002DFAF96091010043EC7DEF1714F13902F922760F8976A2506BD64D40C6F03FBCD606B6ABA757471E4176B9E51E672C72B7D680099C41B4354DBD927FB77B6D3C21FA876D45BC122ECBF75D139F49628842F438727B319C668FF74A3809';
wwv_flow_api.g_varchar2_table(69) := '473EEEEDB72E7D0086095AB7735729548B5742340A498A2C88A2F849A895DBDFEA9A86040560C17E08D6DCF3DCED63E6489B7FB6F0437D20F360DF64D323051E4760E8FAED4DBF28841361ADDA6F962B8D3BBDC5BA893EC100C1A2F4E86A028E93917374';
wwv_flow_api.g_varchar2_table(70) := 'B3D1E9D96CE27A8038E0542ED8AFE460102E3CF080BE35354D331A0DFD5ED73BF556CF1884FBBFCCDB4F72DCB612C7F1F2CEF136DB9C20AB5C7396ACF2DC811BF62D1255624352FCFB52EC44311B34EC778EF75E486AC0F9A3248B91F3D98805D1160134';
wwv_flow_api.g_varchar2_table(71) := 'BB5B187BBF078AB03F172B0E1B2F0EBC00E9E3CDCFFFAE17E19B1FDEDDDCCE93B3FFCFA2C44E3982AD3CEDA96960FFA7FF7D59BA9E02A0C30208D894042D5FFCEED70FBFFC6BF2E12F9FEF2416C2E6E9E641D48A820D751C188062B920FA0210422871C2';
wwv_flow_api.g_varchar2_table(72) := '5D71F3E1D5BF62F7DF3CDC652CC4CCD502D035FD3615B6EB3A1820B151842887D46FBB3EC1F18D855ABCFFF9EB77C83FBCFBED53113658BD3906A0A90FF1C497EB928C538A797E326616097051131B8A8FF7BF3E7ED5CFFDFEF8741B71F468D16A0AC0DB';
wwv_flow_api.g_varchar2_table(73) := 'DC98B19019CF312219C7843907E28842375F1EBFDAF41FEE6F4F1EDAC0907586BC0F220C100A9ED1364D46559C54643CCB75F7754AC2378FF7B7F5BC4FA8E9F27157D788732CF77E7C6BA52466DAFEBC611DBD7BF7EAE5B7FFDD473133234FA181270523';
wwv_flow_api.g_varchar2_table(74) := 'C6217A00746805C328B2ED64CCD9320651B1814513CCC200A475B9D2FDE3F72F3DFF6A06D0378D64900040C949E334145BEEE826B11A1C805498294AA936B8844A9FB681252F20F67D54B55654E2EEF1652BFF17553302F6FBBAF56F5A20B2C07DBE4500';
wwv_flow_api.g_varchar2_table(75) := '66876B42A073493E51069E98AD0B90A8A96CFF7CBA7978C118F8F65EE2B2323C3DEF3070810126CE68C581C459AE6D55B0B8FBF06207C8DF7DDAF57B6A110230DC798E784E00604D57CF5F4ED885541B094AD272EBFB0F2F14036FEE75B2B14DE689E9AF';
wwv_flow_api.g_varchar2_table(76) := '662E9E17CE22F5262AE654DA96617C3B0120E2FD879739F1FA22B4D9EAA3688CEC27755CD48C13FEF76ABF055BCD38EE046A5DD1DE7CFB12F5FF838488C46ABE948E7A5E13C8B02A9BADC43F675A7F484ACB08C94BDF450262727CF49F5EBF4001B81340';
wwv_flow_api.g_varchar2_table(77) := '39DA3CF328C8D7F6C4BA7E6AE781C302989DDB7E5DDE7B555702E81B2044D71840DA35B667A52EEFFEB8FA0ABCFE39CF13B6E3E72E8E8F010052378EBB469C970125382D142E9C330A8D03D3D8ECAD3A639B264F20A58485B0F49FAB17C3875BA011FD94';
wwv_flow_api.g_varchar2_table(78) := 'A924007C6C59E5DE7529E0E3D9118933A205FAB1DDF72D8985FB14FB34E92912D3B5D3C0EB4F02FA7E9F76AD001027512B419248027C1D79D61205C9B8C8E7658DA6EDC64416C5A11F9D3C4E6BCBE9B9FF7CD510F8FE770C1782E5DD2B4F412F4880C273';
wwv_flow_api.g_varchar2_table(79) := '702482BF43935F281542809BA61DC3F476943B798DB97E0C1872E744CE7757FDCF463F7E74AB37CD8C9A99200616214E4A80EA010970C900D3F6169F9C9A81C2889CFAE6ED4E29C800DD38895D47F2B68BD443F9F59A0BF09342CCBC037CE022E1CC3CB3';
wwv_flow_api.g_varchar2_table(80) := '2848E176B60A381B16E28C4192766DEA05A8C06E67D15AD7CC4D81D0CDAB2BF6809F92B1C809A0F5E73A9AB2E6432AD1882306787096B121077A581B82249541A9CFF3376397DFFF78BD057877ABA7373F445DCC108631AB73A3603B8E08FE929E2B0985';
wwv_flow_api.g_varchar2_table(81) := 'DC56BF7CAF9968D839CDCE7FBA5E0AFCD29E3C61CC4342A78FAB335191B60B92F8E7E4D035BD59164004A91BCC42D674D0ED3E5DED1D78751FCC042106013D808571622854EF8BCEC5B412054CAC92F137A3A3156D062149CD509EBE1377577B077E5853';
wwv_flow_api.g_varchar2_table(82) := '4068C8210C24170B598B590250BD00A19454352FE24C71B0CD0274A25238E669BB96FBAAE6C474B53AF0F8717007902C256C9E436161A501C431992E67B5F383CE792D73D80D899A370132D23400DD976BF542BFE7760C6D1E3892282519A9031C0C1078';
wwv_flow_api.g_varchar2_table(83) := 'D4B352E2C0A231800064548C8B22ADFD54F2E32549AE699C4F68228B21DF5F2909BCFEDC93506985747CFEA181958213F577BC07405250B6DB6EBD33D399D7DE8D998EEE69A36DCDD6F72BDD7C77A51470DF2EA13EEF881744781C56E188D77541583515';
wwv_flow_api.g_varchar2_table(84) := '44BFEBA01DA8ED9B0624CE30C809E4AC0ECB9E02A5C39B73FB78A59380F73C2902E449BB653BDBCD5E9DA630F3225822B80460D98FEE6E73378E99CCAC1C7716804954FAC6AAB7473D73843D5CE7DF403C74545CF453E3A9D536910B94C5BADFA2706049';
wwv_flow_api.g_varchar2_table(85) := '2CE3C19E2D8D797A3B05C3513735EBC6E0C494374785D2DC787E7E7D9D1410AC3C1034BB4E285D88FDB3896D1A58E4BECD6C68B21813153BFC3D697CBBB3D33ED196FBDD8C27E9CB9BAB1C86FE9678E20692002C0AC7E9BECF401EDDFA0012B3EA523EEC';
wwv_flow_api.g_varchar2_table(86) := '5C9251119EDD501762A11898C5381E467BCE10E0A245D739157973A32A947BF18C290469F2187B0072CB310D8E488513A90AF676A7A7ABC4CA5A4E0C165A0FE7FD97AB7C1C9258E50E89858E7EA32DF30A4980A666AECFA7071D49F3FDE5C299A83A6197';
wwv_flow_api.g_varchar2_table(87) := 'FB41C152138C95B20088DDC3353E247A48D506A37327F58773C2D4CFE9EEBFB45D87AEA33A1A56D7EC33EC1BEC432009098947DABE3B7D90A7A1337E84482982A7D8BEEB4CB111EC2DD8B9D10C9060033101D4AF4D483999DC9EE3F41E7FFEFC97EFFFA3';
wwv_flow_api.g_varchar2_table(88) := 'C0EF93C0308540B7C6F56744378A798C44079AD31F2EA544F892D3447762057FF31E0F853F7DE6A9D3988DF199404E4F948F6149C16EC04B1A205C185602716A6618B2D56A15F776FF874614EA04F87B02AE25FAFF1DC482BFFA78A8C66B922118C4F16E';
wwv_flow_api.g_varchar2_table(89) := 'B3EE24711478CBCF73E1C85967FDC82F4BBD1917AB5521569094455519E0F64EF02F25506EE07F7FC6A0C6FFEEC00DDCFBE750FADE79E53189E2376FE8AD2255E01F5CB2566CA9DA2930300BA146914584BA21A1F856AF1B8936B2AA44020949EB5A5A80';
wwv_flow_api.g_varchar2_table(90) := 'FCF040EC874982FE730736F093DB5BB558B31F0F8EE9D46BB338C0DA3F464BD207F9FD84212A8D8D1AC60A53A35E2D6357DB7E08A14E86961E22C8AAAAB2DF0D7651D80A000887051F7A282F6901F8BC9EB43C67D61DC4827FFFC448C45C87121278811F';
wwv_flow_api.g_varchar2_table(91) := 'F9E7954AEC62BD2FFB33B5B4C317852300D5D90812BAD9AE42A789A917BA8E0B411F3F6380F286F43630A914030041288294F91050C75108C6087EB6AFE86249C04192D2D187D6C73C7C7CC6E2FDF533E22FE63E1EF72C874E4C093DDB80109CE01F1C15';
wwv_flow_api.g_varchar2_table(92) := 'E14592669B6C9D6382B23A894ADB4E9BD232ADB4817AD641926E3665AEDF4001608E9ACCD8640909094B0CD3B43659BB8247F5040F21F382E027CF98CE0C7C12510FEBFCD47130F10FAAD0FFAFDF46FB1EF525915E83623E66A7691C66CBC74FCF73D49E';
wwv_flow_api.g_varchar2_table(93) := '96705DF7A3322829EB8416752D3AD9DFB356F36FCCA2DE6EEB6AA31920B835B2D5AD6DE70264C9BAA8B8BA91E1FDFB450A173C24FDF8D56C08FFF79AB36EC84374FF05DEFEFAFA2501D2D7E06804750C1F321C4527EC8F66AFFCB3B47F57442E796B5B1D';
wwv_flow_api.g_varchar2_table(94) := 'E7450E9BAC614625A5AC6CA393BC6A6060D6D25C6F04172BA8B6800220955BD9A508AE04EFF2B831447D04203C41173F9D3C8B027A8AB94FE9B1B9687E752B78EF5DB4A03B2252DC7B2AD73F69E37A3C9DC1FD171D63766C9988634469D372992AA2D290';
wwv_flow_api.g_varchar2_table(95) := 'A65C566A3F34DD565AA355213B1713ABE616D036C076DA9A672C22B014BC8D31A6B99DC37DE4484F45C057D3573818138C8F552AEC076CEF34E757B7827FFFDFE24D10863A53197EC2132B0644434A0067D319C0E785C0A89738F27263755266746004D7';
wwv_flow_api.g_varchar2_table(96) := '6B0A365C7634AD655B966B53CA56012064DB726EE8FE2FC5004514D34E73477DA2DF2B1FFEA9ED07B3E92BA03DCF7879006531484D91CE1AAE2E8C7E351FC7EE62E0F6587D5AE3EC92D59E888F27D3C9333C4C9A8D4F9C54DEF2BA2E8A4266FB2D51AFA1';
wwv_flow_api.g_varchar2_table(97) := '9A402964171BBCE05BB5EBD5B687A0AC6BC9A5B43DBD8ED81635D7A35BD1859A170BC7E121E6440483D964F6940598FAC7D879BC3C1161FF7F6D003EE26570F82CEA63E5CC02DA672381A30830994C9FEC731C7F79A02A8C2B2EAD75627299F9780020D5';
wwv_flow_api.g_varchar2_table(98) := '2B9849D9314333A01F8966BD9455A5106054E7107966B595824434CBB84FAEE9411474033C52884F468E868A7D5E414257AF102A13103B0E54130B3C7AF81957A87987BC0501FD9F895E487C60B22DAA66E41B0A002D67215CD6BC6D00085A5E5830AD8B';
wwv_flow_api.g_varchar2_table(99) := '16020046A380C0B550CBAD50102950C099190AE2A6AC649D102FD0ED350BD78DC7BB9C9F2A00D49841A681D173F76FB78E52F7CA9DA3AA26E28E77922E5EDED2B923E462FC583160F204AA5B1700100D6C5A29B31E37C580A2E8D2D22C0A91835C4DD770';
wwv_flow_api.g_varchar2_table(100) := '08CA2D030486282C403221AB2C0609171B0C8067CA7A05998FD5A7864C75C4ED7DEDB3C95451E0551F7A3382CFA50137FEFAC3957B43BF0996FDCCFBB415B82E801040822120549B4005C0B30BE90E68842CAAAE129267440F0D8090EAA8161AFBA12DD5';
wwv_flow_api.g_varchar2_table(101) := 'F5AA12B505522EB736C01697925B6E22A46C8DCCD2CE00EE091E28020CBEFE77F7FFF0FB87CFFFF8FCE5FD3F3DD77F54FFD0F33CAA680230428831C4D03FAE5C14FAE7A7F91C93F91CBAF7EFBFBCFFE0C1FD0737EAF2BEBE7173F3C73FFEE94F37BFBF20';
wwv_flow_api.g_varchar2_table(102) := '06C3B0144551995655A57B00B86D7655D7AE31C630D874A290BC2E36A4144218C035351EF62251B8149C4BD1E617B201E87ECBDB19F4460D5C71FC4BE45370E847E0C009A9EE69BD73184FA568B54E156D0C04712515492ED6862816EB638F91F6807D08';
wwv_flow_api.g_varchar2_table(103) := '100A0D42050E95224BADC6D31D5595C7DBAD9436412DCD216581A0FAEDD88CED4CB68954F727B4CE3846BBFE67E6CDF3EC9BF7EEF6702703FD7CE9BE717FF5C1EAAFB27A456B5B9B9B4FFEF2FB9CFFED3470E3277FFCD3E1E11FFE7A78F8E7DF1D4C7B8E';
wwv_flow_api.g_varchar2_table(104) := '62EA003DA7B7F4C4D77CBFEDF3A3D3D3A3E1D9C9D1592140D6A7CF8E3FA67EDE453E9DDE3CFDDB711C7927D935BE9F1C65B87172FAE9F8EF376FDFFCE4F64BFBE740D4480AD02E765C5BA66174D08A838C6507A183A692AF2C2C1452BCE9E159EE376275';
wwv_flow_api.g_varchar2_table(105) := 'F3A23079BD9C47BB6A718496464146CC67E3059E184E320176E1014942FD3E50AC08C115D012311C76850FA70AA2486EC398C47CE397162E20C422D86861C09C369E81E8D75F7A90159758321D66AB5BD4C9585CD73DCC0F83F262A07F7CEB7336B66FDD';
wwv_flow_api.g_varchar2_table(106) := '76FDFC7E469A00634AB58BBF743C2A02CEFCED5FB42B8959C9B241A4007B0BCD0B6061D3B44D43E64636B1C4EAACEFB2B84E545D32E8DFCE86F53F33C7E8A40FE63B92A1F1150168B1A3A24E1447BCB8B8BF8D7F609BD8C2C4B0656BBAD774A0E4D717CE';
wwv_flow_api.g_varchar2_table(107) := 'AC4282AA1244649A64B4BE1B5F84799549E1E473C6BFFEF1EF333FD613245E3C3F56480AB0A4EA76E5AF925EE379D8F6BFD9B84AB78B01F4B01080D6E3E7D469BF0FFFE27EAC271A728FE9D679D480A01C04D8F859A75C9144E524E99D379C8FF4C6FE6B';
wwv_flow_api.g_varchar2_table(108) := '5CC2323121A42A00E5F3E2C1E7448DD2C9D8AB5E18559A292D74E96F1795DB407CF8044D0BA078FEDAD2258021D8C90550506DB02808A48546D29B1D5375E642E420650108F0085945B51282AD96EC94B66D61E755D302FCF6B21420BDAD8A00612998B0';
wwv_flow_api.g_varchar2_table(109) := '5847BE1A6C1457E1E51DF9692A8D6051B90D52511A720AE8B6C8FF4180EF0EBE48AB6562E7B1666453CD8FD7663C9647584496F49F205C60768D1699794436C1CD0B7063CF29ACAE898961CA866118D8D919F9DAA0D1F9D0FFAE4D9A161304CF1393F8EB';
wwv_flow_api.g_varchar2_table(110) := '96F5A32811365B669E9B9998CEDBAF0D6F98F9629573819BB396692CDBD8591BEAE636B5BF4A4BE4B24A33BE1C9EC0BA3B0715FC87A8A8486258B884B9D2B400FBAFECD2A483657270D3B4712640E0C71727403E1C6927731EE60278AA01ABA9974E11F9';
wwv_flow_api.g_varchar2_table(111) := '867AC996235D204CF24938F7C9CCE5170D0BF0FC9961102580A57E44773C8D007AD465828765013433A68A49E2B42A402D0319A468232B2FF71B76035E22DB24B8ADCAA7924280A7033FBE36119FCC9B10427DBCA5D8724AD2975CD256A302005F9FC951';
wwv_flow_api.g_varchar2_table(112) := 'FF437A624B6380D15DCF871E3FE786E60645F260A4E9F7CA98B2F2F975257C9996DD7ED6B4002FDAA41080B4708EB56C1374C7851EE05E65BAA79AB40B91B82009E54A005E0A918A468F9DDC0FAD413ADF1A16E01DD81E4B3A80D9B1A06B5B3207A4CFC6';
wwv_flow_api.g_varchar2_table(113) := 'E20A1D5F7B623E1E133C0EF36FA5371D4CB01A86E53265CF1B1660513E07124BAE03A83AB2D6D2761F16CC997B8DFDD343110A1E5F053F4EC7C3781679E40E4080E2FD8985CBF4DE37EC092F62A8995A796B593BAC737F2313800965ACB54C44B925989B';
wwv_flow_api.g_varchar2_table(114) := 'A4F1A5A8ED67DE988EE221A510A4EF0E063B48E5E0ACD27BD7EC2CF01B1040BADEA49A141593751F6E50DBA9D56247CD045211D1CBADA3A04AA921A38CE5F1631C6C80061363E77BB33D0004B06DD3C417711E4F94CD1A27FA611DAA1C11D7258C474540';
wwv_flow_api.g_varchar2_table(115) := '38DF4185F6A45EB0BBE125A1EF8B30DB402D00522F9BED6C86F2DB49368BA29DEBE30B3EDF3A6897C528A8C6610609EE22F9FC8BEBB496DF342C8045B099AF40625271C5D00EF7122FE49C52190329D2502B81DA7B588F0A0E4B1BE535BEF0044618F480';
wwv_flow_api.g_varchar2_table(116) := '600D0450D3105102AC342CC0FB976D39E60193547CE1B5802503C6BD229625A2796A0D9ADF2097F1EE54A4B51D1761598089EBE95C4AF97F26E043F8DEBDB6BA6F4B7E12D96E7E087CB070195B95516DDF3B0B3CC1E35120F23C01903448FEC9002A182C';
wwv_flow_api.g_varchar2_table(117) := '93E7DD4351C49CD1DC42B244687309A8007CDF5B6DD57ABE897350C33DE04DCDE82A6B48BA4F3F0A0F3EE59086A1662E08E046D95899F9B09C2A10868EFC5A3DE5F17CA2C87D80082E63E70A1082CE9B15E01C4B6645B3BB38C73666E9D037A8DC3F39C9';
wwv_flow_api.g_varchar2_table(118) := 'A73C180A2A9C58C06F99DCDB53B70222754532BEE283240DBD7B085750D6107D6934CDE2C279D9E4549E8A097AEACAB8BDC8837DECB9150052AAA2A9D2340549EA21B04132488238BC9A07E9BB0F3AB806290478D56C9EC9BD454CA407D6EE589D0E4256';
wwv_flow_api.g_varchar2_table(119) := '76B4501BA176FBA703918A8889F158A400F3CE12C6D2AC210463AE9B9DF252968E590A0441905D929D4F189C4B9271D64C6730799457C1EB50C0EF04900283556421784B04F47ABDE9F4602A3978DB6C0FD8CBDE6B8AE0E5C37FB896030D86C2100AC04F';
wwv_flow_api.g_varchar2_table(120) := '388061E0B7570C9700241228C44D80F616C3FAEF80FB0939C7C18508B0009F2FA083F0FDB02AF99C273397776B6C2926C2A2E93991D6A6AA99E19E9B5FAF47E8DDD57A5657DB9C898DFF187011C197E018BFF6E6808361188802F005B8570001F20FEEE7';
wwv_flow_api.g_varchar2_table(121) := '57B18AA0CDBF5A347659A166186C83F749BC3B87B7AEEBB1957B294799E7399B7CD3D2B7DE7BEE39D7DDD5BAD7672C231448D334851020AA724A9A5248D127C00CCE43DEB1177202A03A7E528771B03A3AEBE875AD3588DCCC20FF11FDC5CBF613315E22';
wwv_flow_api.g_varchar2_table(122) := '7EDC4C4444444444444444F400A59D1659F6414BE80000000049454E44AE426082';
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784238350215151246)
,p_file_name=>'img/persona-female01-apex.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/img_chatbots_jpg
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := 'FFD8FFE000104A46494600010100000100010000FFDB008400060606060706070808070A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA70106060606070607080807';
wwv_flow_api.g_varchar2_table(2) := '0A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA7FFC200110801A401A403012200021101031101FFC4001D0000020203010101000000000000000000000102030405';
wwv_flow_api.g_varchar2_table(3) := '06070809FFDA0008010100000000F7418C134800403060304D0C12684D000030060021034C629080103684C43880001248018021821836086081A0108000009C4000681826860C04D00810000000048040034C0130400806DA88000000004C00409A0400';
wwv_flow_api.g_varchar2_table(4) := '00005964EB94AB8021C0400004C01044608018310EC93B04AB2719C6DA66574A00024C100C148134D302F9E4555392AB2B1ABBD5709DCA242B8200B120180D204020B264AC4460C6A4560D80C8C08233EC8531AA2E2000000000C0001000000005F160D5';
wwv_flow_api.g_varchar2_table(5) := '6934030100D0000000000000064370BD8E9A48A44902681A60008060200000001B4020068000000000002BE6B494751BEB400001880000001A0000349E31A0C3DCDD2DAEE2DC4A37D9D87D16E45A1EC00008390C0004C1034D1E7BE1FA7B80B7216DB77B';
wwv_flow_api.g_varchar2_table(6) := '8ED3079FC9862387B8811E7F8BE3F54F6FD9FA167020000000F20F26C481938F2C8B0AA6FBFDED395A9DB735463ED258DA9A4064733ADE833E8C8EB2F00000F3AF00C9C0B0BB033AEB6155F3C5C97B7D9F42A9E518D0A51736AB0665FAFF006000015FC1';
wwv_flow_api.g_varchar2_table(7) := '9ACCFCBCCDAEC6A79338D53BEB82AE6B276EE435750E730235882CF7BDE0001E49F1E8346E7B936A471F22F7A6CFA3269A1F5719458A5729C055200E8FDE1800BE44F1C001ECBBBDCB853916BC5C0C9C8A2A5D6C652AA165E2613AE9007ED1DA0901F9F1';
wwv_flow_api.g_varchar2_table(8) := 'A91001B5EEB735D591255632CBA20BAB53A6AD76F9B0149504949E7FD0570C396F828BE51B6BAA0667A1E79912852A34DF1875F54E8C1AF7C8430AA24B539D990F52F470179A7CB5728471D6463E269E7D676337050BEBD76547ADAE55EB4DE2728815C0';
wwv_flow_api.g_varchar2_table(9) := '4C94B61F44083C73C1A5144C4B3B9EE771FA2EDEE80E71AF553ED86B1B0F7321803C7002CAFDE7A2E5B26DF17F271C1D702CCDD7636835B9BD7EE72AD8A85547604A04316E964DC949E248116D5EA3E95C179F6BFCFF000292C6D4E2A1662E9B170E8CDD';
wwv_flow_api.g_varchar2_table(10) := '86F36799287564A33846AC2C2D8EDC2CC2966D9AE76D3D97B5F2BE0181CCEB2D3D730377D3737C3EABBDF55F91255E4C30B5754A79767B4CA25B08C6BA30F2F68CC6EB3D3F85E5757286EFE8316A3E3AD6DBF4D7A680C0E53E4A92C78465A3D446E3DF40';
wwv_flow_api.g_varchar2_table(11) := '01C5D181E81D2F31B3F6328F3DE2F4F8D97ED3B6D89F0D62F6BF5D00C0388F9169BE14E558F53A38AFA0988946719C27F4C4C40A5E71C6E2E1FA49B5EAFE1A87BD7B88000703F2AD6378D910A969B0FE8280E3156A12F6EEC400391F10CBCFEB3A1ECF4B';
wwv_flow_api.g_varchar2_table(12) := 'F17D1F61F5E34D20F39F99C21547A4E56EB25AFF00598B8CAAA32983E97DE04C6AAF9BB1CF76EA4F2EF96767F7083004BCC7E6F71AE7BDFB1F88F12E01D9DF32D8ED3AEE674017D1F40EF8403F1FE00F57F483E59F35F69FA150E2048F24F9F631AB27A3';
wwv_flow_api.g_varchar2_table(13) := 'FAED9A1F2BE2FB0BB6BBBEA76C693C06A1AEFF00D80043D6FCF13DBF7BE3BE7B6FD85BE49A6C678A786D05576FFEC306A24C003CDBCA185FF48DE021F90F1355DE58BD87E856289200F07F15856EFDBFD94E224324C0C7F9DB040F63EF5001E4FE2B7EEF';
wwv_flow_api.g_varchar2_table(14) := '9BC2FA4FBC9A4449291F3B7985E1759F62080E222129CF0FCE352E138FB576C200E5BE5DBB7F7D9ED1D83928A1C83E60E4DA1AFAB7A0488F9A29464B41C7C4944DD77F97979799959762F26E37D43A1A77E4924D807C8BAF799B1D0BFA13D1822798A017';
wwv_flow_api.g_varchar2_table(15) := '9D638E7566FA1369366664E6E65F7E46436C83900BE4FD29EC581E587AF7ADD98705E7F5DF5644743CDD68C2E97BA421B5638C4532DBEC9DB199640F9EB5D1F6E878B47B0F508CA77E8236E3E4431F97C4C8C396D7B38E53A29BE58F94865F4E3624E594';
wwv_flow_api.g_varchar2_table(16) := 'EB1E3D3E4F8D8BEEBB2F16D4EC3D376B2BECE1A76D97DD93663F154C33BD0E624264E00E4806E45B0AB9AE7F5F8BE87AEE0F69B8D3FA7D55D5C180D0946E21B88CE7276CD975AAC9DA6453950B6529E0F9F5DA83368C7DBD58B91289BE210A31B1D38CF2';
wwv_flow_api.g_varchar2_table(17) := '2A799B5CD7394AC70C3C4C3C6C7AE9006D138D0DD8860DAF4C437154D58F18DF9F73AEAA26F248B40DE2538928C35BA7ADA40349A9645BDFA7384630828CAEB24249B90A23920487254E8F5181413C8CACBCBCDCDCAB238919C1C86EC9001141310D1383';
wwv_flow_api.g_varchar2_table(18) := '1464378F1998D7C1C06D4AEBA035252514C06802DBE2B1E92A9E4C5C6E8C273A5003892719C5304394271139134EC9CE506289175A44AB8DB18928C5B939B6E15343646708C3151664359154F200812AAB1CE314C02237152AAA8197210C42090E77CC8C';
wwv_flow_api.g_varchar2_table(19) := '843915C14630764A128C20C24A2A4810004A4E49BB240C52232611146BA724AEBB6B203042945878B0A7200404D000000028A539A81006800019FFC4001A010003010101010000000000000000000000010203040506FFDA0008010210000000F01DA79A';
wwv_flow_api.g_varchar2_table(20) := '42D1B092E5429186D08A13155D4A4132A5823A5128120426DCA68189753810E4A6A9CB94E473285DB12A49421BA498903149A1A90B36D21A620648269BB490D313055D62E3E797D20CADF4CF01204D6BE8F5E4F1CBC9E6ABDBDD54C2313939843F6F6513';
wwv_flow_api.g_varchar2_table(21) := '9DE5597367EC00002F2B10E8F641613586EEEA00000CBCA47A3E8028C5E7AAD2F31A001AF3798F7BB80C239A6A75BCC000039783B7D8D9128C7289BA801A0CB471E7F67AD8F911AD757A2A7146000711CD7E857072FD5781C2C5EEFA20B08C400F3F21F6';
wwv_flow_api.g_varchar2_table(22) := '747165F43F33229F7FB8E2BEA5E5CE51DAF1E395B76F376DF872AABDDEA3CAE0D35E0D2CEAE85C128DFABBFC4CF38BAF7BA0F27CB98F107ECFBAF1F134D74EAD72E2BCD5BFA5B5C5E44E5F3E2FB5D4F99F241E9AE9A6CEAA7EC3816FF1F1228EDF53D2F9';
wwv_flow_api.g_varchar2_table(23) := 'DF14001D24757DEF8B3EDFC77967AEEABAFA31F2705055D085EAFAD8619E78BF9F1D5BCE1D4A68BA7BF66C4E59673C80810C437234DB4D048005A4120300002890001000310DA01AF7413130004C00000FFFC4001A010101010101010100000000000000';
wwv_flow_api.g_varchar2_table(24) := '000000010203040506FFDA0008010310000000F7C965B4CA152B4A18B60124AA5AA0E6AA2858284572554A845285A5E1AB4B424A149559655A8A0028121400BAE8F47AF9F0F2E3A714CE6ECA0BF53C9ECCFBB9CE979F4FC990BABD3A099F46FD7D7D5C3D';
wwv_flow_api.g_varchar2_table(25) := '5E7CB5F9610A7A3673F19EBFBFE8E1F43E73CDCFE390535E83879D67B7EFDEFE470E3F20828EFBBC324C6BF43E8E7D3C1CFE48851D3BE3942E2E3DBEAF56787C9046F2BDB38BD6E59E69CEEC0E8E938BAF4F3F7D0E3CD673CF5076A73C74DF2EE5BC70A9';
wwv_flow_api.g_varchar2_table(26) := '2B57935D2B38D475B64E51BABACE59C3AD3ECFC9F3F56AE5CCDEEDFBE9F33E54EBF47971E7DB5E4E93493255DFE8CFCB737DEFA267972E7CF9664BE2ED71F4F57AB7E4F0787ED7D4A4B9844F97DB1CFE975CF8189E7E1D7E8F5BAB9CC94C72CF3EB98FB2';
wwv_flow_api.g_varchar2_table(27) := '9339DE92AA4CCE5E5E6D6FA6EFA45A1226A99014092452D28331D2049905B65505F9322A05454D52587FFFC4004E100001020303050C060705070403010000010002030411122131051041519106131416202253617181A1D11530324252B12343626392';
wwv_flow_api.g_varchar2_table(28) := 'C1F033507282E124354073A2B2F1254454607493A3C2FFDA0008010100013F01FF00D4A9FF00B557955FDCD5F5742A842208FDE165DA8AB206876C5762DD8BB157BBC42A1D5B11C70F0A2A758565592ACD4AA75841A71543FE3A8A8A8A99E99AC6B34567';
wwv_flow_api.g_varchar2_table(29) := '675AA0D6D5470FE8563D7E051D7FEA0803AD6CF92D2ACBBFE02FD6B2A87B021FAFD1578D48E26F5752BB17CF49440C02A7EE0A2B17DE70C50A570BCE010A77EB44B35FEBB5547E8AEC28D3BF5AAE351DA3F340D0FC95B2451548C0FE4B66D5879226FF00';
wwv_flow_api.g_varchar2_table(30) := 'D7C954D7F555FAC50EC1B55493E016A03BBCD5D80C3E6AEFD60A95F32ACFABA7A8AF22BCA046A41C3C5546BEB28118944E8B90A68C55FF00178E7FC95DA3B42EFD372245746C40B7F415A0AA35AA855EE55179551F922F17D3B3B95A14FD60AD05682B42';
wwv_flow_api.g_varchar2_table(31) := '9895514EE46CDEB9BAF906809C2E6D15D875D3662AED4151B41ACAB3D6AFFDE1F9E6D0BFAA1DA8EB45A3E6A9FBBBAD517EB62228D41B8F6D30D4A834FEBB951AAB5A9170D6A976176B2A9A8AA53935FDD75FDC8E7B5A2AE7003AD4CE548709D658C2E34A';
wwv_flow_api.g_varchar2_table(32) := 'EA08E549A34F60570BB01ACA94CAF391206F91A0084462D768034E850F28C37BDADA5C47B430D683D8EC1C3F744EE5195936D62BEFD0D189537BA69E8A4883484DDA7C57A5F299FF00BB89B544CA5949C3FBC22B3AED2665BCA8DC269DDE01F9AE30E551';
wwv_flow_api.g_varchar2_table(33) := '5FA707F91AB8C1954FD70FC21332F4C3D911B15CE048B9CDBA884D418D5A460498C2809BF1EB53206FACA8AD1A4F5769EA50F9D149380D2EDB69DF9050AD377E1166044AC4B560801D0D8FD745290A908B5C281EEB4DA68EA4E25C0B49A4465F5FCD3728';
wwv_flow_api.g_varchar2_table(34) := 'CD34545F64F3D86FD9F9297CAB0A232197308B55175F8264DCB380222B6FD777CD09C932F2CE130AD0A55B6C54553E765598C56E34BAFBFB93F2EE4F61A55E7B1BEA4B9A31202041C0FF0087CAD96DB2B583028E8DA4E86FF551E2BDEE73DEE2E71D2552';
wwv_flow_api.g_varchar2_table(35) := 'B9ACB5CC70736A0E8504DA60366CF527218219A1CEC7652AEB40601D7A96CA0D734EFB504E91ACE9F251C49428F023320126659BD97815F6BE24D6733793A002D3D9E49F6A256974461A7EBA8AB558CD8AD07136C750F24EE63E1D9BD8E7D47513E68DC0';
wwv_flow_api.g_varchar2_table(36) := 'FD98C3FD47FAA8F05C1B3B1604287BF963482463B3B107343DCC8CF66F858D88E60381189EC5CE7DF645345AE49200A9340A365590838C60E3A9B7A98DD044351021D9FB4EBCA8B39351EBBE4779EAADD982859467617B130FEC378F152DBA075CD8F0BF';
wwv_flow_api.g_varchar2_table(37) := '99BE4A04C418EDB509E1C3FC1E5ACBCE6B9D2D28EBF07C4FC82C4D53D0CDA131C6D3DAE2DEA031A2D2B4AD199C79A9B8045D1ECBDB0A2BA1DAD214B6580610645357B07ED06BEB0B864BB9A22B220B40739BA69FD13398F3185EDB3CEF34582A61D2B0DD';
wwv_flow_api.g_varchar2_table(38) := '8752ABECC70E378B37EB214470C5BCD3645A2747576A9996B8C5635AD8F62CC22454F7A6428B619C226A91297D920050E6A661FB11E20EC71432B6501FF707605E98CA3D3FFA5A9D94A79C2F997F75DF24E8911F7BDE5DDA6BEA21C6890DD586E2D3AC15';
wwv_flow_api.g_varchar2_table(39) := '072F4DB2E881B106C3E099BA1807DB80F1D97F92F4F48EA89B11DD04A56E8710EC50B2EC8BFDAB6CED1E4A1C48711B698F0E1AC1AFACDD0655E07077986EFA68A3BDADD6998A37055BEAB404DBDC8E2028C6142FA62DBF0A84DC50474229DA15531010D9';
wwv_flow_api.g_varchar2_table(40) := '1486C3357DE5DA13B02A0C68B0AA58F2DAEA50F29CC31962E23C542CA3079B5696F8D9EBED4C8D05F66C3838FBACAE1D67AD3F9AEA9E73CFEB62C3DB654F50E450D2AB42A1CC31CD7AA2A2A7274281311A03ED42796959372AB26FE8DE0362F83BB3D53D';
wwv_flow_api.g_varchar2_table(41) := 'ED86C73DC68D68249EA0B2AE51893F94234D12454F306A68C0264DCC330887BEF4328CC137D94D9E3A58BD210B4B5CA0CD4B3ABF48076DCB5A7569763A132D58BE9538E639BDEEC5A3F5A1370515AF2CA31D65DAD39CDA5C41A62B4229B822A1CDCC4337';
wwv_flow_api.g_varchar2_table(42) := '3F6DE9B951ED17C3B475D7918D022288D4819C0E49E535CE639AE69A106A0AC9F38D9B970FF785CF1D7EA77673FC1B24EF2D3CF98758FE5D3C8AE7969C8906EC59A9438AC8ADB6C37260850A259B57C424D10CFAD69A6A19DC1CD8FCC86DB0EF68E9AE63';
wwv_flow_api.g_varchar2_table(43) := '79A2C02382D398E8CDAF362AB9CE398E0331CC79592E7382CC827D875CFF003F53BB69CDFB2B6F3A204303BDD7FA89698301F5D1A42B6E8D0AD407007AD0C331F653454B42179AA19A95508321520B6D5CDADFDA9B7B91471CC568CFA0D11A034410E59A';
wwv_flow_api.g_varchar2_table(44) := '270229CBC8939BFCB6F6E3CF877777A89E993353B331CFD64573B69F532D32F80EBAF0710A5A2CB1277B71ABF9C4229E9BA4FEAFCE73450E30DC03AC9D6A139B5DEEDD5E1B52B5AD1C9ADF7A3727114BD5AB64004E3EA0A71B80CE34E6A736A9A2A54A4C';
wwv_flow_api.g_varchar2_table(45) := 'BE5661B15BA311AC6A50E236231AF69A870A8E565C8FC1F244F45FB9701DAEB86710A21C1A5183107B856F713E12B788BF0ADEA27C05169188233C18F120BAD30A949B64C56EA38684F3529B8724E80A2B1CE866CBEC1D68C5687B61579C455391C337BA';
wwv_flow_api.g_varchar2_table(46) := '330D3D89DA93890C22EA152E3E93BBD49CE54CF0A0E1BD614FD62A06FBBCFD27B554C28E256409AAB1F2EE3ECF39BD9CADD63C0C8EF61C2244637FFEBF241B0F442F057FC0ACBAB82C1173555A15BADC81BBD94E64338B3604651E439CCC06B54A269702';
wwv_flow_api.g_varchar2_table(47) := '0B6B5EA52D3CE77362E270721F2CE739D01104DAA1A5D7141F65EC86E24B88C69A91C7368A672014F8240506E89DDC81A792EE50C427FB45494C7079A85174037F61C795BB18B48126CF89EE3B3FE79040D48533E957690A8C1087371BD476089759A1D6';
wwv_flow_api.g_varchar2_table(48) := '9EC890CD0AA9D6A5B28BE1D1AFE737C531EC78B4D3519B4E66AADE4EA5833B50D6A91596436AFABB9C49C027CC4163ACB9E2BC978562F1D49AFB4DF514A83CB7639B2547DFA4609D2D164FF2E6F4D64CAD384807AC108656C987FEF607E30BD2593BFF00';
wwv_flow_api.g_varchar2_table(49) := '3607FF00605BAA9B9798892820C663EC07D6C9AE2AC8540155555517752B6507DF456AFA6B0A2BEFA0D01383B5A7303C16B93E59EDC2F19A1478B04D58EA28394E111F49CD3E0A1C586FF65E0A285C168035A7E34470A6674284E352C693D6339C73908B';
wwv_flow_api.g_varchar2_table(50) := '48F6495BE9188D8B7F8674A6B9AE17142E35471CD8A1517E7C4F21C0D736E762F363C2EB0E1F9E6CA3B9E939D71881CE8510E9181ED0A2EE426AD7D1CCC277F155BE68EE53298F7A09FE63E4A72562CA4CBE0453CF6D2B670BC55137226BA103F655CAEC';
wwv_flow_api.g_varchar2_table(51) := 'D44D6D7BEE4EA5A06DF7205A6B555611A6AA1418B18B843864D96173BA80C4A2544870ED7B26F379D49D2E7DD35461C41EE9CCD988EDC22BB6AF48CD53DB1B142CAACFAC61AF5264E4B4435DF00EDB95B6BEA5AE07B39271CC06724014D69ED3AB4E2B9C';
wwv_flow_api.g_varchar2_table(52) := '28A1C7D0EDBC82EAE08DCF568124A830AD9BF00A3412DBC6198A7E8CD9062599F0DF8D8E1F9FE59B2CCA4E4C49D25233A1C56BAD0A38B6D755CA3657DD1487363458ACFE3657C484775596FF00F33FFCD9E4A627234D457468CFB6F762694EAD0A849CD0';
wwv_flow_api.g_varchar2_table(53) := 'C38B9AD6B1CE24D001892A4F7293D19B6A3BDB001D1ED3B62CABB9E9A933037811262DD6B621E1F3521B918F11A1F391B7BFBB6DEEDA9DB8E90A1A4CCCD7ACB7C946DC74CB00DE2698FF00E205BE6A6721E57838C9BC8FB1CFFF006A664ECA6EB848CC6A';
wwv_flow_api.g_varchar2_table(54) := 'FD9B9486E4E76290E9B220B350E73D4DC94AC86459F640606FF677D4E9376942DEB403B5263686849BCDCB7A76B460D7DA684655B7E213E139988BB5A14D4AA3526C4B26A170A8C3088EDAB87CCFC7E0330CFAC85A33DF537A70756E45B86AA285169CD7';
wwv_flow_api.g_varchar2_table(55) := '7772225D452391A3CC509AC387ACE27B0266499364130DADBFE3F794CCAC49775978BB41D0545814BD9B331D19B26BEC4FCB1FB607E2BB3DC9F212110D5F2701DDAC054F6F42726ACD0377E7D00ED40B5D5B285EB73B915B2701B1E337E9DE2B7FB80E8F';
wwv_flow_api.g_varchar2_table(56) := '53970D324CE7F97F3546A042BA8ADD90039C09569CAA552EA28D2E45ECD99E835AA375FA82331013DA2CD3A91692EBEE592B2246981BE447B990B40D2546DCF3BEA6357A9CA264B9D87ED4071FE1BFE4B23407F0EE743F65A4DE33C486C88D2D78A85379';
wwv_flow_api.g_varchar2_table(57) := '35F0AAE87CE6788512035F78B8A7B0B40A8CD01FBDC782FF0085ED3B0A6656973ED0737C5326E59F8456FCB3C6A3E24476B712B7BBB15902404D65380C2398DE7BFB1BEAB7466991670F537FDC16FA8470ADA2ADD868B4EAAA0210C28AA546836B9CDC51';
wwv_flow_api.g_varchar2_table(58) := '14F50331BF35D9A106438D09EE682CB42D8D63526905A0B70A5D4F5196DAD83BD456B05E48726BE1C41F9274AB741A232F1075AF47437FEC6698EEA5E8898F8E1F8A97C9D1A11078411D4D45C1A0B8E02F5557ADC64B7326A648C4860EEBCFAADD3FF72C';
wwv_flow_api.g_varchar2_table(59) := 'D0D763FDC1582752DE06A0B7AA2DEFAD59A69445905C5D5083139A80A694F82C7F9A892EF6758565DA952EAA18E6BAECE0AD03939126445930CAF3A1F37BB47A8CB70B7C9079F80877E4AF4D8F11BA6BDA84D374B4A872135121B1ED6735C01178D2A048';
wwv_flow_api.g_varchar2_table(60) := 'CFB29F4F646AAD7C1535ACA6FB193675DAA044A6C545459065782E4A9565284B6DBBF9EFF55BA934C92EEB88DCD7AA2D3827172E77527E46CAE25593625DCE639B80D03590B7DA06975C4ABCE854BD165A1428C9C3FB4B466198AA076289B2EEFE4D1648';
wwv_flow_api.g_varchar2_table(61) := '99E0F3ACAFB2FE69EFF51118D890DEC760E6907BD4463A1BDF0DC2F6BA87BB3E46896F27C1BF0A8F1CFBAD9B10324B99A633DAD1DDCEFC95BAAC9D2F1273284B4BE87BC57B34ABB91555E4EEB3FBB19FE7B7E45772EE553D48015468B234387132A4A322';
wwv_flow_api.g_varchar2_table(62) := '00E69882AD39B28EE7F274FD5CE876227C6CB8F7A9EDCCE5294B4F86DE10CD1671D8AB4B9CDB2751D68A1C834B213AEA28121371E9BDC175359B878A83B9AB4FB7331BF959E6B2949F04992D00D837B391A0F666C9B33C264E1BEBCEC1DDA3D465F95B11';
wwv_flow_api.g_varchar2_table(63) := 'DB1C61131ED19F73916B0A3C2D4EB5B7FE33EEA679B399437B6DEC97AB47F1695646A5B8D90063C79C23D81619DA71F57BAF3FD8A5DBF7D5D8153AD5022335CB239FFAAC97F9CDE44DE4C919CFDBCBB1C7E2F7B6A99DC6339E65668827444BFC42E2CE58';
wwv_flow_api.g_varchar2_table(64) := '65C6035FD61CDA78AF43651E83FD4DF34CC87941D8B1ADED779287B9D8F5FA48CC1D953E4A16E7E55BFB488F7F8050A424E17B101A3AF13B4E79F926CE4B967BC2F61D453D8584B5C28E068467AE6C81356261D009E6C4C3B47A89B966CCCBBE13B4E1D4';
wwv_flow_api.g_varchar2_table(65) := '54463A1BDCC70A39A6842DE62F46EC2B868592E6B834E31E4F34F35DD8565D9D8D0443850DC5B6AF2462A36529997AEF71DE1E7AD513585EE6B5A2A49A01D6B26493646460C0D2073BF88E3EA2ECFBB23CC911D713F2CC7156BAF30AD164A77FD5643FF9';
wwv_flow_api.g_varchar2_table(66) := '10FE7EBF2EC85A1C2A18BC7ED0756BE4C288E8511911B8B5C08EE50A2362C36446E0E15F51BA6830DA60456DCF79A1EB034A85949D0DA44505FF0068388722E86F687B2B4D3535BD4F4FBDF250816931215C1DF67AFB139CF24B8955EB5B96C9662C6E19';
wwv_flow_api.g_varchar2_table(67) := '147321FECFADDFD3D66EC5FF004D28CD4D71DBFF000AFD6AE551AB30593A8DCA324ED5310FFDDEBE2BE1B18E310B43697D705342008F137835875E6F2720472F957433F56EF03EA3752D36651DA8BC6DA289A94BFB7DB9A364FB46B0AEEA50A4E2DAA385';
wwv_flow_api.g_varchar2_table(68) := '0695B9E3FD84B7432210367ACDD673F28C3034401F32B79D650850EF565BA9596FC210BAB7263AC3C3B51AF2F864C749E0170C99E93C02E1933D27805C3667A4F00B86CCFC7E084F4C6B1B17A423EA6A8D968C117B5A5DA94DCF4C4DBEB11D76868C066A';
wwv_flow_api.g_varchar2_table(69) := '5D98639B214ABA0CA97B85F14D7BB47A8CB12866A45ED68ABDBCF6F6844D494D25A414D88C7607BB3374AC8901D0A4AAEF7DD6BF2F599722EFB956688D0EB3F86EE5E4A8DBFE4E9589A77BA1ED6DDCAA66BB566050A6A5353621D5ACBDDF244924926FE5';
wwv_flow_api.g_varchar2_table(70) := '4A4B188EB6EF6478A11E2B7088EDA84ECC0F7EBDC86518BA5AD29B949BEF433DC84FCB9C491DC9B352EEC220EFB90734E0E073E56DCEEFEF74795A071BDCC381EC50F739955EEA3A1B5835970FCAAB27E409495E73FE9626B22E1DC9F93A45F8CBC3EE14';
wwv_flow_api.g_varchar2_table(71) := 'F92664B9063AD09715EBA9F9FAD9C25D3730E3898AEF9E62A5E5E24CC7870618E73CD02CA72624A722400490DA509D351982DCBC42FC9CE04FB115C07663C8240F501B7BB90700AA02930C8F1ECDF402AB014E5D536663814DF0A6CE471EF57B5367E369';
wwv_flow_api.g_varchar2_table(72) := '603E084F8D30FC509E81D6109B807EB0211619C1EDDBEB72980328CE0FBF7FCF3EE5A55A37E9B70FB0CD3DAB754C1C265E2806F616E14F64FF005CFB958AE026DB69BEE1E71A6B5BEBFEE8FF003A3148F7477387E744E741898B0ED03F35F44D03E8A16D';
wwv_flow_api.g_varchar2_table(73) := 'AFE4ADC1E8A1ECFE89AF79B24D28EC3E69D19C056CE96EC72DF296AEC1E06D463D2BCDF8BFD2B7C1469F88D108AD367ADB6BB946840BCB9A71BD1BAECC480ADDA8576B41A4DEEC564E148E7F84FA916752B4AA55791CE5BEC61EFBB6A1311FA572E1B303';
wwv_flow_api.g_varchar2_table(74) := 'EB3C02F48461EF374F82194625686CEC5E9389F0B50CA514922CB71A2394E20F75B81F05E908DF0B315E918BA9982E1F18D7D853AFB73932ED715E7C552EAE6C9AE8D0646035AE2059AFE2BD65082F9C8165CE25C2F6D75A208241CD914FF698835C3FCD';
wwv_flow_api.g_varchar2_table(75) := '0EC5555EA4DA60AE418F0208F85BE34A2DE9F640A696EC09D0DE6D75BDA7651180F3BE617DBA77E0B7B7FD10BB9AE3F9A8709CD0DAF476518116EFE068D89F2F18175A6DE98C73DC1AD15254D426C373198D1B7F6A6B4060AA0A589132CA695CFD4817F4';
wwv_flow_api.g_varchar2_table(76) := '74EF080AD6F088A695CEAE08BA20C2113B136A47B242A156CFC0E5434543AB3DF50B9D4F63427989EE81878A76F86D7F10A7627438DCEFE22478230DF6AA3AFE616F6E1D9CEF135560D6BDA8B6B80D5FD56F4ED1F646C29D09D7D3E17F8A7B5D5BB584C8';
wwv_flow_api.g_varchar2_table(77) := '6EAB6BF0513E1FD1B8C4D55BBA8232B1A95A27418C3169582932D3292FFE537E48D14FD87CD44742BC69ED5BDBCFBAA1419A86E6BD8083A0A939B319A6D3691062155C4FB0EF05576A2876A24AF4846F859E2BD2117E16AF48BBA31B50CA3F75E2BD230B';
wwv_flow_api.g_varchar2_table(78) := 'E172E1F03ED26CDCBBBEB36D517C08941BE376A84C8105EF75B15775A8CE1163BDFAD7BA3342258F0ED49AE0E6870C0AAE6A9E55A2ABC80E21579210A2D372A50E28D3AB36508C0337A6E27146E0DEA0A28B37752182907DA966F51216549ADED82130DE';
wwv_flow_api.g_varchar2_table(79) := 'EF6BB1600282C2F75028CF0D63E9A68D1DCA0C530E335FA8A74484DF7DBB56FF0007A46ED5C2E581BDE119D95F8FC0FAA068836A9AD756A1A51B42E354D7CC4087744A752E1B31F1F805C366358D8B87C6D4D5E908DF0B17A422FC2D4328BBE00BD23F77';
wwv_flow_api.g_varchar2_table(80) := 'E2BD23F75E2BD23F75E2865087F015E9083F0BD7A420EA7AE1D03AD09D97F8BC109A973F5884D40AD37C08C586317B477A13305C69BE045C06268B7C87F1B76A111BAC20F15AD5551235A8D137B86E70D09A4BA2D4DFA53CDD5D67E49EEABB34BCCC6876';
wwv_flow_api.g_varchar2_table(81) := 'C31D40A3EF91A25B73AAB7A35C4282EDEED2886D91A00170421D0D793E8F8BF1357A3E2FC4D5C0236B6A32130340DA8CA4C0FAB28C18A3EADDB17553900D108AF0280A738B8D49BD73DE7492992B19FEED3B6E4CC9FF0013F62121075B970396188F15C0';
wwv_flow_api.g_varchar2_table(82) := 'A5FE0F12B814BFC1E2570397E8FE6B8340E8C2E0F03A36A74ACBBBEAC775CB8040D6EDA9F93FE17ED464236B694652607B8B798C3EADDB1587DFCC37757AA6DC9D7D3A82B015908340C07F80EE4E870DDED3015BC40229BDB762E072FF000789464A5E9E';
wwv_flow_api.g_varchar2_table(83) := 'CD3BD70081F6B6A1272E0FB3B535AC6FB200CF7274386EF6980F685C1601F700F0465E16AF146103A5DF88ABFD4BA0C275E618D88CB403F561701816AB7F62E030351DAB8040FB48E4E874B9EEF9A7C8456FB24145AE69A38107D6D2A8428A7063B62E0F';
wwv_flow_api.g_varchar2_table(84) := '1FA37726A1540D2ADB3E26ED46242F8DBF896FD07A566D0B7F83D2B3685BFC0E95BB5708823EB026BDAF1507D40CD5A7AF731AF1473410A264F61F61D4EA4E93986FBB5EC461446E2C70EECE1A4E0095BC46E89DB1364E60FB94ED2864F89F1B53327B7D';
wwv_flow_api.g_varchar2_table(85) := 'E793D88494B8F76BDE841843EADBB10B95066DE5B5F7BF114E810CE353DE53614368A06DCB83C0E8DBB16F306BFB267E10B7983D0B362DEA1746DD8B7B87F03762B2DD43934FF0039602DF60D69BE376ADFE0E878284461D7B0A0F695C220D696BC0A315';
wwv_flow_api.g_varchar2_table(86) := 'A2BCEC16FCC17D7C0ADF994ADFF84ADFD9A9FF0084ADFD9A9FF84ADF99A9FF0085CB7E6EA7FE072DF99A9FF80ADFD9A9DF81C83C381A57BC11F355E4DDF2CC557955EBE4D33069540A999ED7D2E345BDC4A7ED4D7B0230E274BE0B7A8DD31D8131B1062E';
wwv_flow_api.g_varchar2_table(87) := 'B5DCA9C8ADD8226B98542B5F6BD6DD9E9EB8AC40564AA5EA8D5568E4D1515066AE8550AAD57570566BA1508D2BBD139BBD10A8A955454CD4CC0B555A859551AD7375AA8CC40D683553AD52F544505454ECCD446EBE8762DFBEEDFF00856FDF751362DFBE';
wwv_flow_api.g_varchar2_table(88) := 'EA26C4D8F4FAA8BB16F848FD93FC3CD5A3D0BFC3CD1894A7D0BFC3CD5A3F0108C6A7BAF3FCA508D5206F6F1DCAF57E6BD5FF0012A75E62EEA569555A76B579567ACAA66BD5EA8550A39C0442BF3594E6C4F75C07757F3548DD233F09F3444C7C50F61566';
wwv_flow_api.g_varchar2_table(89) := '67EC6C2BF582A2EFCD55DBC9DBC80A9D4A9CABB9340AC8442B2ACE617A0D442A8D6AD056BA95ACDA31CF5EB55CE177AA957AEEE5DEAC9560AB1D6AC8D6ACB55CA99FBD53914F52513D59AE2ACA70C15EACF5AB82BB368E4D330A57355555EB8C73DD1C1D';
wwv_flow_api.g_varchar2_table(90) := '87CD718E7BA383B0F9AE31CEF450761F35C659EE8A06C3E6B8CD3FD1C0D87CD719A7FA281B0F9AE32CF7470761F35C659EE8E0EC3E6B8CB3DD1C1D87CD719A7FA383B0F9AE32CF7450361F35C659EE8A06C3E6B8CB3DD140D87CD719A7FA281B0F9AE33C';
wwv_flow_api.g_varchar2_table(91) := 'FF00450361F35C669FE8A06C3E6B8CD3FD1C0D87CD719A7FA281B0F9AE334FF450361F35C669FE8E06C3E6B8CD3FD1C1D87CD719A7FA381B0F9AE334FF00470361F35C669FE8A06C3E6B8CD3FD140D87CD719E7FA281B0F9AE334FF450361F35C669FE8A';
wwv_flow_api.g_varchar2_table(92) := '06C3E6B8CD3FD140D87CD71967BA281B0F9AE324F7470761F35C649EE8E0EC3E6B8C73DD1C1D87CD71967BA281B0F9AE33CFF450361F35C669FE8A06C3E6B8CB3FF041D87CD71967BA383B0F9AE31CEF450761F35C639EE8E0EC3E6B8C73BD1C1D87CD71';
wwv_flow_api.g_varchar2_table(93) := '8E77A383B0F9AE31CF7470761F35C639EE8E0EC3E6B8C73BD1C1D87CD718E7BA383B0F9AE31CF7470761F35C639EE8E0EC3E6B8C73DD1C1D87CD718E77A383B0F9AE31CEF450761F35C649DE8A06C3E6B8C73DD1C1D87CD7FFC4002A1001000201030303';
wwv_flow_api.g_varchar2_table(94) := '040301010100000000010011213141511061718191A120B1C1D130E1F040F150FFDA0008010100013F10FE16665CB973797FC17D1AB804AAE987A54A99E219958E9E2532BF9ABBCAE970657799E988F57E8AFA09EB324AB9444EA9D552996CDA57984A65';
wwv_flow_api.g_varchar2_table(95) := '4AE85DC74FF8AFA24A8F5A7E9A952A2756512B88928263A66233352BAE2622FF00C75D08CACCC74B25F7E950E998DF10263AA4C4B7A5A5CB964B972DFF003D4A94CA94F5CF4C4C4B263A5CB4B96CB65B2DFA417416080862EA2EA4466A027FCD5D6BAFAC';
wwv_flow_api.g_varchar2_table(96) := 'BFA2FF009CFEAA6A28F36222C977A8C27725B9579AFC9302AF2D9CB0A2C677CC7D20B65B4D2909DC3D6FED1A17746D7859EFF1BC12023DF69DE1EB7F688361CB305C44D44FE5BEABD17A5329952BA53D2BA5A5A5A5A54ACF453055603BEAF826AB03B9D4';
wwv_flow_api.g_varchar2_table(97) := 'EC3DAD95AC31CDD0ABBB32D14F7EF31A59BD353D48ABAB7218F72273E9D5F8817403B5B75E2A53B277A3E6083A96F10C4D9F97CB3030D9C5620768FA23F8896CF76902D5A580E6A2DADBEE2BB12F519DF383CC566B21B9A7F0BACCF4C32E59312FB43AE5';
wwv_flow_api.g_varchar2_table(98) := 'EB8FA6EDE9528E20B29B6B0654285D76EDE61A68BB8581CB086F5D5BBDB821AF55EE16FBA1CC872A817791EFFB26EB61D371E7F72E3574C5B9C22E2CD66DB9B93025A4C6FE9983910F152AADAF93681A75B2F615DD8885CBA166DDA28C147B662AAF07A8';
wwv_flow_api.g_varchar2_table(99) := '84B4B1DAF0880997E5DD9A1A9D3F28D14ADABBBFD4D1B35AAE8F0475AA85E0BF0456691A2E257D7E9D094952A5742C65CB2525CBEAB65BD2DE811B575CC0BDB2F6D09700ACDF75E2662192D39E080ADBBB85FD1326EA6B8BF7748B6BA9EB95A5D0EC9F84';
wwv_flow_api.g_varchar2_table(100) := 'C315D2FD78EF2DAB2AF20E39234BB689EA6D2C04063D8664AB207B26B317A16094604CBABF7658B4837776220175C1ABE594EC380B6559ADAA2F5CC33E6A807E58CBE0B876830ADB71E3F66034A7835A25D9545E35F56568F71BD3333B9C0BE5D59929A0';
wwv_flow_api.g_varchar2_table(101) := '01DFBCAF74DA2068DF5A0858F0E5C30332E11E9C94162B9ADDBFDA1330B82E879D09D83B5E2FC5C69764B65FFC59FF00B11BB16D59E6F11D1A5DD3D711C22DBFF130EED5D3D0896C5055B505DD97F70174E8FC22C94F4AFA6A07FF001794F8EEE98EC418';
wwv_flow_api.g_varchar2_table(102) := '856C35DB6F788097B65F81EECA03B57E5959E8283880328385DBC082636A2FB176AF762309BDBF9A237B00E465886AC5F1515A93DC8D4B3ADBA63EBBE95D6A67EB3A3FF22D96FF00CD9FE4CD820B545B1162B95F75D83762241CDD961D6F703B13970CAB';
wwv_flow_api.g_varchar2_table(103) := 'AC7DDB134E5549764A0FA47298F1BFFD772E5BF55B2D97D7512979D2A89FA503F9612DBE8D25F4AE8B7D442BFD8F433EED3F010BCD5E26FCCC62955684BEBEB50C06D944DEAA25A3932F094CE295C1A16EC415B3EF631675506AC1257B44BBBF66A4BFD4';
wwv_flow_api.g_varchar2_table(104) := '01E763D987DAF56A8BB2D7BC5AD98382EDE3894E1242D9A76A411AFA61165D9712ABD4D4AA2C1CA5ED897689FC3F3F8D436C93B37D6BA54A98E98FA5FA2FE9736C353F6C2AF3CB5AB051541100099E51577635ED0383BC3EB5B83E09530137A0154F25D5';
wwv_flow_api.g_varchar2_table(105) := '4194BE4C4B6D76EA056C25A728AA88A57B8B080A9C875F928EED2C06CDEA78252A259BBA3A730D680751280DFA5AC97FF11FA2590330F03A5E5A63068B008AA7A80A8AC935B0DA7E257D0D841BB825E1FE63C621A38DBEC10260DDE87B4A2515779B97B2';
wwv_flow_api.g_varchar2_table(106) := '9479957806E7C56978A76FDAA72F22B53C9A9F563F9686A5A9A8EF1152CDF2C790830B1CD1CC5073343D59EE11C88181C7E20E6F2CBC4A14147BEBF822DC982AED8C9BEF29FDC6A592B1697BC5CBD96692D4A6AD81B04E3C3B7F3DA02C42A8DFAD761D49';
wwv_flow_api.g_varchar2_table(107) := '719C63CB1EA95074D82D95C94F3D21B7F8AB4ADDF27ED28D4843054E13C0087D5BE57EE457FD3ED37B7D97EA8C58AB56FBBE95B85282E3A32DADA8CAB0CDD3E4830B2EF3EF83743C9FDC3D3BF50FCC429777FBD05BAE821FC82271B54F05FC488B3C1F2C';
wwv_flow_api.g_varchar2_table(108) := '59E2950A511890DC092F71A96C37E199A16600E083011E98515E3F1882ADE0A84A6758D673C317D88B5DCDD424B39D8BA038125D690D60007517AA8F34969E49F57B98EE4D807D8E04B4173DAB70674CCB80B111A60CA988AE1C310D4E8C2CED318C4047';
wwv_flow_api.g_varchar2_table(109) := '68180AD2218890BBC46EF32B5B6925987783B7A6B47B268C72922C0D0357B8E3F882FB2FA016AC3F1576671A5AB02EF47DD15672AA92A53A35ECA1F30004D8D0A60196E17E52CB7E8478C98396971D291B4D2E05D128AC758A5DE2CAAD79580F931F696A';
wwv_flow_api.g_varchar2_table(110) := 'A8D4652D0947736605038252886D779B92005D2AAB021A11A168DABA458AADAC2E84454C691D1D09452C5B55E99A66CC1641465592D6D7AB97181B2646617988EC7F0FF0AB51F6067AC629DE5BD29DAFC5F105D85EE3C315141556E433535DF074D2D860';
wwv_flow_api.g_varchar2_table(111) := '4F3F6CCAA0B60F572C0EFA12ED58642D8E9C16E6272894D7131A4FB254005205A12AB2724308F0C552B06144D9817515A7A31E509682400E1E9AA57D28EF6EEDB7A26D72994CA952995D10CBE93D6BFC1455AEBBD2AEEDC274E461AD65CDA0354B83CBF7';
wwv_flow_api.g_varchar2_table(112) := '63516EAFBCDD2E8944DEF1206417229D17058FA465854CE3796BC46A996E6E5C02D198A7B18AC974B8861BF1D2D2FE84A520B01C411405BAE86508D6DD0D6525CA7B9DACB65B1BFA1405500D566B0D53C1707F0BB7E4B9705BD97877F138455889A276A2';
wwv_flow_api.g_varchar2_table(113) := '34312D089CCB4B6FB4566860E5210A0061ABBC5C52D6C46EDDD8185763A5343D0B2EC89176F808B79682E25AD034E31DEA0501D330C2357F42B6E5FBE264E87570444866EE8D0B346F5CCEB147F54ECC254AEA37548D705F79EB53F0A6A5E8173FF2D89E';
wwv_flow_api.g_varchar2_table(114) := 'BF320B75ECC6E9CE12BAE1E791C8CA56E8DEECE497241856EAFB608E4E8E359B1CB999B01465AC4B687488B4ED58420CD1B152803A39A39E9DA80E56E51166102BBD6E407C13069BA8B75D8FA2D40EBACEA856B49A49B95577093A870F1DEA50D72C345D';
wwv_flow_api.g_varchar2_table(115) := 'E3DD8DFCA7274B97D4D855A1D98E9B4B76B0D854B8A2161577744685A59E6795C97332875CEAC0B3539BA9A01B78AA981A5E284F6874DD5660C5244448AC00E1D444770AA287B30A3E153825CD35CB376197A44F2C228BA7665A5B9D218D4EDD2C35AEFA';
wwv_flow_api.g_varchar2_table(116) := '184C5C28B737A40CDDB53186ED44A6AEBAA2B0DBE831023D1D7A53D1FBD05432750FE345FD29738F679027765EA452EAAF48BABD70ED2ABB6F2EF4B99C42AD0CCB358E642EAC4D19D0012B4784C93105A357F97643675309378E7C23821B7D6A3D8854D0';
wwv_flow_api.g_varchar2_table(117) := 'E729BF84B641742B6E224006A3D6F68E89788A9BF820841C8BF1283E805C1D0AB2F4894A4C9BA99E8618B6B8EA6A44B971D2C54F4BB817E94F432BC77DE49A07AC73FDAFE60F4548C8D78F1322D4C8688E58166C7BCA3294D90DAFB44AA2C72F8204212F';
wwv_flow_api.g_varchar2_table(118) := '438B9722C01631946B8D4292F93F7BDBA5E5DB5367C90185DD42E17CF39A12FDBA75DC1F2C4794A3AF8262797443CB80BD3721AE8AB829A454A6E9CC02E747306628EC8C589ADC485313255BBD2A9B5CA0D3A177E22B646CC3D0D484175D1552500F9C7D';
wwv_flow_api.g_varchar2_table(119) := '87443436D6B7290F72B90FF04E9DE37E482446195E8394EF1CB5230755D818FCA2D15C4C9195994DA059B0B07D60B2A1AD08CE455B53DE2829A5B33146CC69ED1740944066F736D46BC870A0C51BF6AFA28383A0A4F66184A66F4CC34E0A314F94943202';
wwv_flow_api.g_varchar2_table(120) := 'D3F74291262D5939667A1948C5574BADE239885683310069CE63872BA7AB4889651347C4529EC8BBCF41A46583E12888A29DEA051A5A69095898D7FB60D26F3538A96BF1E80E175BE952A2559FB0E81B6C25731A112F855CBD41A8D64ACBF2500C50D08E';
wwv_flow_api.g_varchar2_table(121) := '415AF499A80C4E0DA30006560B24E19EF0A202054B4CCAABA611C975A7D4D24791B928F60C48A2BBB9F89B57470D3E16630DCB590FBA92DF3B2C27E0845D475DD65A8858B77B9FD21289F594DE688AADD8528768AD13C2B2EE5E014F98DDA36A22C52F2B';
wwv_flow_api.g_varchar2_table(122) := '214429388307D4D8F9B9FE3FA23AC40FA7430C50EE2A1AEFD3A210350628D0DE5E600351A5CAA5A63278830ADFA2421CAA12BBF07A064B86DB9BB44B615D3A11D2566AF0F116D562B325C57452F7FF0057CCB25C6C22591E28E5EF923109A85405E80238';
wwv_flow_api.g_varchar2_table(123) := 'A9DF69A16097CE25BB2B29E3FBF3FC2297747B8203B40E6E08598DB02A1B5CBDC00798AB1B5808EA4B436B71B7894EFD0A7358ECBF68B129FA29E942740023948E01D97BE09AEC0361D0831EF357B77A101680E1A7DC9674FB3FDE8A37829B6E86BBCB97';
wwv_flow_api.g_varchar2_table(124) := '03ABEA3324F592571E476616D4F4C4B78DE686549E8D494B9CECB6F6608F41CA22FBB70C058FCCBA92A5A9C0F65A3A575B972E5CB987BFBE4836478462DABAF2540B7A315EC09A3C411331ABA8D32AF86A3AC0E87680E33EAC36856E366224444D4FA155';
wwv_flow_api.g_varchar2_table(125) := 'FA167A2B18DA8E884E5A94EB08825D5A5C83BC69058568ADABE8A94CA65430B5E4C5B564A1E1BDDAC465FB1C913103C1FDC5792747AD7A5CFF00D4FD2396AB6E8BEF198A157820A8B18AF6959AB57DBF89AF36241816951D8F2854036D7DE086872C1C2A';
wwv_flow_api.g_varchar2_table(126) := '267A2C029080A97530B96FC4AD96F994B763C267EBBA6DE6778C4DC5EB51008D5B506D63CCC5B517DE02C530C777BCBC574ACC54DD7CB7C3D7D65DCA9EB294BB3CF97C3040F138E38CA3349E330972B5B42E3B527B157D588202D6D66643A54BBDEA384B';
wwv_flow_api.g_varchar2_table(127) := 'F6F786B9F572389528E947D221E2CDB4DA1936C70C0E59A602FD2E0AA82092F56F15A051EDD8D6E638D04157BCB4147682D90D34EB48B54478496DCEFD29793A0A7D2358024A604A69AFD259A5A9695FF967D1FAEC8697B6429952477915756B566FF6A5';
wwv_flow_api.g_varchar2_table(128) := '47B75C5DEF502B3F64B0B202569BB4E5FB10A140006025CC4BEA30635D1D09BCBAE61B140D5449D75693316FBC74B3335548C07A571AB7508F23461440E69A3E65C48B69C49C19902730145FD00735C183B5C7DA966AF9E0DAD71FB91C7D9C5BB372FB7D';
wwv_flow_api.g_varchar2_table(129) := '1568D568E961D813EA1D313D3AA1FC55DBFBCEA1B818EF5A7DBAAC352EED6B8E940E3AF96FA2BAA74CF40812BE57C8CAF2973ADC70BAF10570C0A189548CF52F13D2943C0A6057B542A1E20E754DBD7B86622A261BBB07ED1F83F6FDD8A452E0A6952A46';
wwv_flow_api.g_varchar2_table(130) := '88ABC58CC4F48D3A331FF34E8C4BC9AB64C275102458D8AC5EDFDC7F057A6397068C5FE8A3648882D2D797ABC41AAAFECEE7A315DA5C350D0183D3F746E1DD25378C54E06AAC01083596CDF2298972BA90AE8BE94F21BD89D636D487AC4E3F08B6C63288';
wwv_flow_api.g_varchar2_table(131) := '506A1EE7A5C1EB898FA2BE8B7BA601B8D3E9A195E725714CB39F097D31D732E662257A66C6E2F9122E0EC028E4213E13598DD9B5631F676D73E749951ADABBC1BA0F78D5B75074E7F1D212A51C4605C0EB674444FE7A4237557689B35EF1FE8904748576';
wwv_flow_api.g_varchar2_table(132) := '8F9EA7D04C24C4C45EB994CA667E902AF2D70EF702D6CD9131EB29AE8B6F4679BC7EF9D2BAE0EAB2E9EA305921D6AD15ED98970D906EAF4F48A29272C47E397C0861F4274167ACDB58746AFD2BE5680DF610B0DD6254327F490028338885EA63C8DCABD1';
wwv_flow_api.g_varchar2_table(133) := '81F4BCE97790EF61FE1FA21C4F6416ADE88723E8FEE579D686C6690E769E22354788BA3D0082386A507884E0FD4AE97FA20F3B3EA4654316A4AD06EBCBA6A15B4ABB4B93B203DEAFA1D162F5A21D47491FAC8FE4999B4A81D18EE5D823AB92FAA4A9531C';
wwv_flow_api.g_varchar2_table(134) := '4A3A7607BCA34597A412F6C4A4AA25867D50059A2BB7EEC768A6D5EA34EB8BE9AA541439BDE4AA0B4555AA6D6EC4427C65913A2F2BFBD4F983FD2E7DC1BF29F1E092C971D4BFA32F2F6619E7EF3E6A067F9B447DA32FEC837CA83EC93A9D1B9528944AFA';
wwv_flow_api.g_varchar2_table(135) := '356517CAFA0A5389742ED4395EC19601B6784D17A64CB4A523841F7BD09735042789B7D2962724A05325F553146D037C685CB2722EB174C000001A54ACD5C44BC7AC0CF4BE8222615F76DF98C80FB00C335EFD1BA8F1688D7D626961E6CFBCD5D7810472';
wwv_flow_api.g_varchar2_table(136) := '3D2BF8331B80AD0FBB97D2C2D4710F738E0CBCB766CDFA8174D81D9195B94383F620E2B1CB20023BCFDA4351F197DD397DE4D7E27896B754B60401198B57FD0F9F98599636BE5F305A4E82174BD37ED0E5592BE61B614963E7A09948AB0F65EF0F726CBF';
wwv_flow_api.g_varchar2_table(137) := 'C710B5CAE6F521DFA3D5B8D5C35D221AC606232BC5B653C4068D4857748684BC286AF9B3F797AAAF98275500B59EA8A4163BBF70CEB82F66ECCD6B3233361E2F996D6749A3A6BDE375176154EB57CC1F356AD1D3DE0E1611C94DC46DB6F3CA970EC54F6E';
wwv_flow_api.g_varchar2_table(138) := '8B1668F74A96CDAB4804111A4764E8E59C2FB82256B296B0A3046D8A69B456299DE243985C4826C47618F536559A0702F8C9F69973619DE210114649AC15408334B0ACE8911800845A736B8DDA8B6A9BBDC88834043A96B1F299B68B682307B435AEA1F1';
wwv_flow_api.g_varchar2_table(139) := '0C2D379D139C47B95CA0F9029DD9C2BE3B470199C8CCC05CDC649470EDED380F49928E1D0A8216BD22186019579B9428BBE676979559AD420ED957AE534EE55670B2295AEE38C283E21EB5E199D6D03E20B291B6FE2CBED1A252DD55CD6BEDACD452BCF1';
wwv_flow_api.g_varchar2_table(140) := '87F085C09B3B98D7F523500C966B5454C8935DFB3F12BA001B6F7B25D6CE2DA58D4EA6913406DAD77F580D521AE731BC11B96A8987D8467156D691962A8D0C6C6A1A652A2BAC121B517CDDC852BE45FDA66ABEB4D3F73345072241B8A67FE27ED0DD7F47';
wwv_flow_api.g_varchar2_table(141) := 'F703D53C52037743B7F586E1F8A60A641E91AD23C012E9576A373961C20A86712F4780A22E2EF05B980768425222163E6781ED2D3257B450AB6A6B17BBD08DC69D6292960D4D25D4002296D966C420592C69945AB85B34AA6198D2EB5655A4215126A678';
wwv_flow_api.g_varchar2_table(142) := '11E837FD768C80DEAF561B82AEE59F7B2BD1894A1DAE387AC2C1BAC00128EE2CF935B0B0F21C9B931D5736081EAF5C18FE7135ED2C63E57E3F82E3A44424AA2F78FB307044A8078609A42E2A3AF99D9402D5BC894FE961FD6BFB9FD38FEE075676A525EB';
wwv_flow_api.g_varchar2_table(143) := '330DECFF00782576FF003E92D644ED4B0FE90FDCFF00C63F70E73E93913CAFC4A4A01DCA89AAEEF75EF2BFD58112977BFE21626395ABF786DFB487D1C7848140FBC0A889EF52872F37072A46082AFC957CEB06CB397D3FB31AE755B9A1185511AA181204';
wwv_flow_api.g_varchar2_table(144) := '85AF6C432D819B16BA3C6D31529880D8571D0F3D194B91EF6FEA70FCDFA8E99EFBFA806BF832C2FD247ED356F7D111B2BE257402E26883E881C106DF1A3A4C30296816CD2D8E64B84FC05F960F55F5FEA2C05BEE8B872A1FE5FB207A7CA0131F7E2E95ED';
wwv_flow_api.g_varchar2_table(145) := '4D5038CBEC991FB6AFB4DDC7C1815AF50FE49ACB7C231653EFE7CE5963E9FEE336D7AABA950243A5188DF6DF4AFE83E9BEA662D306276F79FEE0E98DEFA23AEAE77828705611B97A5462FF00A41141F70A2A561E21B3778B2843E8DEC54235C4BE119F52';
wwv_flow_api.g_varchar2_table(146) := '060A6FC0806802B510CAEC5E03F300113A0CA279F9E8546A8ABED15B779A5B02A4FC155ED16A2A77E22C3533C835DE3020F21FA4B07B2E8C7011B254F59898E83D6FE916816156B3B29D9BD257508E85998EB81E663B90464FC88865FF00177E8D7FE4A2';
wwv_flow_api.g_varchar2_table(147) := '26F5766FED3304735D2E8976547AE6E2AD26798598A7C45B6E3F7F9843B540256C5F79A4C76F789E3DE5574B2B2732E83C47B4BE05C918577CB24BCA04DD1334777475F8342E0BA7BB82DE0EC137BE85C1E7B60AFBCB9B7E4B12BC3DA41A00085933C692';
wwv_flow_api.g_varchar2_table(148) := 'CB5DB9FEF9414F337E6212E149CCA0FC68F95BEA43FA5CAF41F440727B49469E910A0D0867796DBD2DAD311373A63E83BE26F1AE95771E85343E21B5F1F99E1F3515E5F78F9E94EB2AC97888ECB1BD4DEE18A610ED6DC493EC0F749A139F68350F8FF040';
wwv_flow_api.g_varchar2_table(149) := 'AE39444254D564809B576FFC637FF8FD48DB9FF5F24FF65F89D9ABFC693FD4FE21A8FF0093B4AA58E20025F994C798344C4D46378D6BC3F69AB4D67601DE26FF00E2595A4B20EB06A5B4B7BC3385895B74AAD6597E65375572C386553094E910CBB7AD5F';
wwv_flow_api.g_varchar2_table(150) := 'C4BDEB3760B1D2F638F7B85857BDFE21ADF6D302AB3B415E8CDE23529202CD3CC6A6094F0C760314B9872F3EF3B53EDD36B81FA9CFFB525BD4260E836CC6B3431BC5704F07DA224BE9BAF625554A5D3372E60F3DE38C9A4BB200C4AB356D0F3CC1AA8AEE';
wwv_flow_api.g_varchar2_table(151) := '07E54B02825404EF30AC090CFE657798B95050AAC68D08F8262A8E63711D0A8AA91C1426F44B0CDA2A6ACDCD74BF482AB5CBF3305DC3083C08A23BA62C4E1FDC13041CC16289C0443C78653B0F48397744D08A630CD467ED038F6892ABDC54A50EFF00E4';
wwv_flow_api.g_varchar2_table(152) := '94D6AE65903D1836864D12C1563D3301CFEE2BBFB4545257097D89B5F4F6749D36D49C3F72937EC7F70BCE3E31757DF939B3F81D7B2812153D1FB30A8FA4FC92ECB5BB841B367C4CB896F042F7C78B95BA93035468CFBC4853B105B11C87C25625F9972E';
wwv_flow_api.g_varchar2_table(153) := 'FD88D0BA6B8618AB057F31A5FAFE63C2F5748D56B04606AD619952C4253B8B281A7C4C7FAA09171F119547DDFD8206615E20B1777CDF304D05FE398AA566298CD35C7EA689FB4DFD7DE29B28965E1EBBFAC2A637B9656163DFF728E3D9043FB258D691C5';
wwv_flow_api.g_varchar2_table(154) := '695E482CD185FF00380289BCC512C19B712CE49717DBE255FF00E4A398F98C28607144AB58598E758A5365CAAC97E2259A57150D1B40F130F955C7CF301A9B7B7A417316C5C3ACB62B151DCC5EC40B1FD5C0F2D78268E3EE26C0BEF106B35D8F7598E268';
wwv_flow_api.g_varchar2_table(155) := '7A4CCB7585EB29653C830D3AF79E38D2AC4C768806CF980469BED981C4A636EE4A7E5355DBAFE662A60DA618C0409593AFA4CD690BDC3F52964CAC55B766B292C74E4B9777B8C1A2A51A299DEBC4736236ED14F6269EE8B823BF466859425B5D23EB3071';
wwv_flow_api.g_varchar2_table(156) := '2F2D75BD79EBBC3977EB0FFF00FF00F3E9F3E3FF008EF1C3C72F1E3D7BF5EBC78E1E3C78F9EFDC54F853E75CE9E3A8DB2C539FABFB8B367F7B230D5FD1EBD7EF04FD3FFDBD3D7FFFC4003311000103010507030207000300000000000100021103041221';
wwv_flow_api.g_varchar2_table(157) := '3151101341525361910514203071152232426281A1063372FFDA0008010201013F00C7445C1072251464644A932A4E21631B004D9C4221C0705801C149D2503FC50223885C329C1126325770C8A80539B77E44285748C8A82A2428C23BABA38ABA382BA6';
wwv_flow_api.g_varchar2_table(158) := '500AE89C8A184944485F9422580ABCDD512C8CD5F642DE464AF9D022E3F42E95755D0A1A063AA3103152D57BB045E4ABCE57DFAABCED4A976A760695715D1DD4282A0A85E76C23B64A2E1A808FDD0A6352AE346A8D31AA34C6A8D31A9571982DDB744697';
wwv_flow_api.g_varchar2_table(159) := '64288469303782680A1B189C506B08FD4543752A1B08101045B2AE220850A365C9E28B3106423704141CD57C2354A351CAF38F145CE318A24EAA7BA0E2AF141D2A4290A4291A85794ABC55F7205CAF1ECA563B60A149C405B9EE11A78E04AB821404D0DE';
wwv_flow_api.g_varchar2_table(160) := '32B0C21105108231A95755D57428402BAA3BEDC76E3B325255E3181526664A9FBA95FDA952A7BA90B0D982C3BAC10124000A163A84024808D8DDCC11B2548CC2AA2AD3C0D3285425A1CAAD42C9703F61C3FD54AB97E0E0BF2F30577B8C95D2882A0A14DE';
wwv_flow_api.g_varchar2_table(161) := '720532C6F39985EC473A7591E3118A22302D82B0D029139044FD97853D86C054E2A9537547405468B5A4044C9478A718006CA966A4F619681255AEC35831975C5F1E55363980CB48C2137F369842A66F60E31A1E2AE3799BFEA2C61CDA16EE98C9A3C281';
wwv_flow_api.g_varchar2_table(162) := 'F075363FF50051B2D2D0A364A4471556CCF662311B676005C551A229D28E27354D84274807028704F38A08E4029FCC834164103129F64A0413762745F871CD8FF2BD8DA395BF4EBD1B8FC322AEBB42AEB95D3A2B232FD61DB1F8427A09FB06413B804DCB';
wwv_flow_api.g_varchar2_table(163) := 'EA5665F640CD173A631507BABAAC2C80F7282A0E8A0E87639929AD37A13F340219ACCCA1F4E765A5975F3AA9D9E9EC02CE0C664A8D90880AE4CC280139A41402E04A087D5B5B6694E8552148BA2A1206A10B358DD95A150A6DA749AD69911F09329A2110';
wwv_flow_api.g_varchar2_table(164) := 'D7234CA2C4586210690710860147D1756634C2041120ECA8258E1D935CD61040129B6BA185EA2D4D8BA234568B4368324E7C021EA368BF262344EB6DA5CE9BF0996FAE33829FEA1588300357A712E63DC4C9BCA1608D3051042927451F6F94E68D77924A';
wwv_flow_api.g_varchar2_table(165) := '75775D820225DA2A756A34E0304C7DF6828E453A9D9CFEF213806B806B8390C82F51A97ABC70685215E8578EAAF15E993B877FED63B4804414E610A0E87E759843CF7D9A280ACE61B1B1F509244054A9CD5608CCA73835A49E01547073DC4F13285CE308';
wwv_flow_api.g_varchar2_table(166) := '6ED1689CD463985E9C22CFFD9DB69B43A939A1A152B5D27E04C1EFB2E8D021529F3046BD31C51B4728F2A9D67DF971C36D660737ECA028D94DC5AE05173444B82A8C9A9038AB2D9EEBAF9FE95B6A06D3BBCC9C021DD5D92AE0D55C6E0AC400B3B7EE76FA';
wwv_flow_api.g_varchar2_table(167) := '87FD8C3D9481826D7AB4FF004BCAFC46D1CAC4D711FB5074F03B683C910670DAE10E70D844C21F742936B06B5F884C6065D071838215197730AD354D4ACE9E0A0689C3B04D2011822542B23628314285EA521D4CF628B8E06EA2E273D9BEABD47795BEAB';
wwv_flow_api.g_varchar2_table(168) := 'D47795BFADD4779561B2DA6A454AB51C19A7128000081B2B56651A65EF3805F8A537389730A6DBECE7F71085A28BB2A8D4D73489042B3D6634C12AA5663467257BA6F294F25EE25090334EBC5063906C2E3C552005360D1A1120024E509AE0E68232215B';
wwv_flow_api.g_varchar2_table(169) := 'DB34C1D0AC110D3A2BA355BB74C214DE720835C0E4551A82A52638716EDF577B8DA6EC98032F80738644A6DA2BB72A850B6DA38B81FE90B7D5E2026FA8652CFF0050F51A5C58E46DD488C9DE10B7510323E17BEA1FCBC2F7F47F9AA441A74FEC17AB5A85';
wwv_flow_api.g_varchar2_table(170) := '9ACE3F9185E956D65A6840FD4CCC2F51716D8EAB80C84AFC45FC817BF7F205EFDFCA16E2BE810A5696E4D08D3B4721564B756B39BB5186E7DB2542D2EB4DA7F28229B0792767ACB08AAC7DDC08844F6D93865F1BDD82DE1D022F2AF957CAB232A57B4318';
wwv_flow_api.g_varchar2_table(171) := 'D1991274099509202FF9034BACF4DDCAF5E83617B186D0E245F10D6AAB527F24033985EAB61166AE0D312D7891D95CA872615BAABD37785EE28F385BFA3CE10A8C393C2C0AB3D76D369042F794F42ABDA28D4A65A593F74F3656E61AB7B64E43E16F2C9D';
wwv_flow_api.g_varchar2_table(172) := '3722FB274CABF65E9B90163273210A365393D7B4A3D442C4C8FD6BD88E75EC473FF8BD8FF3FF0017A79A56463C104B9C7354EDD676E2655AAD767AD45F4EE933112A9DBEBD36358D88020085EEEBDEBD7B1FB2AB5AA5620BDD3197C7142FF0941D58645C';
wwv_flow_api.g_varchar2_table(173) := 'B7968D5C9CF79C1CE3B06192BEFE6289273F84A151E3F715BFABCE50B456E72996D78FD6014CB4527FEE03EE810722A46A8D4A6337046D3447EE46DB4F834A36E3C1817BD7F28579DCCAF3B5579DA9579DA95275FA00770AE8E6088EFF00011C4152DD0A';
wwv_flow_api.g_varchar2_table(174) := '05BDD48EEA59A1F2BF2687CA96687CA377803F03F0B8ED15C72BA7B795748D15D7465F4C6D8139ABA3982B9FC87C06D9F91FAFBAA5C8DF0B754BA6DF0B754BA6DF0B754BA6DF0B754BA6DF0B754BA6DF0B754BA6DF0B754BA6DF0B754BA6DF0B754BA6DF';
wwv_flow_api.g_varchar2_table(175) := '0B754BA6DF0B754BA6DF0B754BA6DF0B754BA6DF0B754BA6DF0B754BA6DF0B754BA6DF0B754BA6DF0B754BA6DF0B754BA6DF0B754B91BE16EA974DBE16EA974DBE16EA974DBE16EA974DBE16EA974DBE16EA974DBE17FFC4003011000103020306040701';
wwv_flow_api.g_varchar2_table(176) := '010100000000000100021103121021510413203152911422416105303242537181621533FFDA0008010301013F0050546030810A0701840895DD7F51FDA8338CA940CF1052A564A7095254852A51C334015054150655AAD5188E1952A4A9384150A0280A';
wwv_flow_api.g_varchar2_table(177) := '0281A2FE61214A952A7E58185C5495720E3A2B95C55C55CAF2839C4A24A92A5DA2CF40A4ACFDB0952A78254A12A0AB55AAD0A02818C2851C30A14280A0280A382422E12AF41CAE3819F4E2952A54E12A7E540D147B6118C7C86B5CE300125369B892324D';
wwv_flow_api.g_varchar2_table(178) := 'D9DEED39A141F75B926EC2EE6E704CD9A8B5BF4C9D4AF0F49CCCDA8EC4EFB084EA3598736141AF3C9856E6B7E338C846A85BDF642A0527559AEEA38610049002B5BB3D0240F31F54C10D9F529A035CCFD2A6D97B8FF14081FA524D40340831D710065321';
wwv_flow_api.g_varchar2_table(179) := '01185A41B9A3F8AF3D0549D4AB9DA9E10E215EE5BC726BC1C631A5B4B595012D300AAFB653AA44486854AA31F55A2F0AA66D71CA7D0AA23CAD4EF54C3E779569DD821B98CC6AAA19ABFA19A63DC5F6FB27576B0890BC4D1EAF96C748523D94853EE15530';
wwv_flow_api.g_varchar2_table(180) := 'C3C1436973618E32D5B291F68F2F307D13B91FD2A399081C97D0E3A38AA3C9EFD4C02AA9972CB4F96D3042811E8BB2955CCC0C60E1B2ED6EA2E68305B3FD1FA4FAEC7D02F6190E2A864C4E74353F361F7409A6C0D3C80C8EA9E333EC3E6D332317FD5C25';
wwv_flow_api.g_varchar2_table(181) := 'B2724CA8FA67226345B36D34AAB0069CFD427BB2FD9512E68F74F824E9CD3E5AD13264AB9BA8F994CC39198CA15CEE94E249E08CB020142E6996920A67C42A8B6F01D0A9FC4A9024B984185E2683D9E5A82491D93C871CB92F2F4FC9B4E2398599D55A7D';
wwv_flow_api.g_varchar2_table(182) := 'F06B492AC6AB1A8B420C09FCC625A166107B872256F6AFE43DF8ED08304A002735A88838073F40849198C298CB0850A154FABF9C044A2D23E434C8C64A7E002272C04C059A37204A94FE78812A0E1015AED0A0D25589CD118B4C292A7022420D71E4D250';
wwv_flow_api.g_varchar2_table(183) := '39225346681384AB8E8AE29DCF16E112AC1EE889F5447BE2E188C022B662DA7B15C009256D3FFACC0123068F2A9281464E26655A506A68407BA030DCD1FC6DECB7347F137B2DC51FC6DECB6BABB332594E9B4BB5D31A549F55E1AD1251F86D41C9C11D87';
wwv_flow_api.g_varchar2_table(184) := '681F6828ECF59BCE9B91690730532AB83030E426556149D1E6CC05BB3EC84008A10AE0899E312A4ABC44A2F6A907D555616547B4FA1C7E1AD68A174664F039AD3CDA0A76CF45DCE984761A1A108EC14BD1C51F87E9507647E1F57D1ED4361AC3D5BDD782';
wwv_flow_api.g_varchar2_table(185) := 'ADEDDD781AFEDDD781ADFE510412B67A0EAEE2011905B46CEEA2E13C8854581F55AD3EA57FCF6F521B1003EB2BC237A8ADF5146A513CDC507D1EA0B69D969D612C700ED7555680A1405D17B8F6187C31E0B1EC9CC159F1104AB558352AD10AD080129ED6';
wwv_flow_api.g_varchar2_table(186) := 'DA653B65A704C95B1510C7133CC2DB2A35E775A7AA66CCC1064CAA3525B9F308BD9A857D3EA0B7357A0A34AA74956387DA567A2AD45CF2082BC354D42A346AB1E1C1DD9346D0795CACDA3AD59B47E4083768EB0ADDA3AC23E24688D5DA07D8BC455E85E2';
wwv_flow_api.g_varchar2_table(187) := '9DD2178A3D2178AFF0BC57F84EAE1DCC27BC3840D539CE96DA6211634BA7399571E2C91B7D916D23E8D4594746A6B5839018402AC6E8A234E1B1A7ED0B754FA51A34FA427ECAD3F4984EA151BE8A0FA850831E7934A142A9FB50D95FEA42F0BAB97866EA';
wwv_flow_api.g_varchar2_table(188) := '55A3456B740AD1A281A05969C52AE53ECAEF62A780DDE908076A141D4283A85E6D42F36A179B50B39C254E3385CDD51785785703AA91C31808E28457F0A9F63C32355214A9C0700C33470C965F2378FEB77746A3FADDDD6F1FD67BABDFD47BABDFD47BAB';
wwv_flow_api.g_varchar2_table(189) := 'DFD47BABDFD47BABDF1F51EEAF7F51EEAF7F5157BFA8F757BFA8F757BFA8ABDFD47BABDFD67BADE3FACF746A3FACF757BE3EA3DD5EF8FA8F757BFACF75BC7F5BBBABDFD67BADE3FADDDD6F1FD67BADE3FADDDD6F1FD6EEEAF7F51EEBFFD9';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784238631008151250)
,p_file_name=>'img/chatbots.jpg'
,p_mime_type=>'image/jpeg'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/img_persona_male01_apex_png
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000001000000010008030000006BAC5854000002EB504C544547704CB76541A34D23A54D25A44C24A54C23A54D25A44E25A54D25A54E26A64E26A64F26A64E26A54E26A64E2589593DBB654BA54E26A64E26A64F';
wwv_flow_api.g_varchar2_table(2) := '26A74F27A64E26A95128202D34A64F27A64F27A75027A85027A75028A74F27A44E26A54E26AD5229A65028A75128A54D24A54E26A7532AA75229A65027A85229A54D25A8552CAA572EA64E26A8532BA9552CA64E24AB5A31A54E25A64E26AB5128A54E25';
wwv_flow_api.g_varchar2_table(3) := 'A44C24AF5C33B8673FB4633BAD5830C77952CA7D57DD946FEFAC88F2AE8AEEA985EBA581D78D67CF835DC2724BBB6A42BE6E46CD815AF3B08DF2AF8CE7A17CDA916BB25F37F6B28EF5B18DF3AF8BF2AE8BF6B490D38963F3B18EE39C77F5B08CF1AD89F3';
wwv_flow_api.g_varchar2_table(4) := 'B391D0855FE09873F7B693F1AF8CFEB791B37E60895C4A7E5140845745AB755DBA8B6F774C3C7F524159332849261E44221BC68B6E4F2C23996752F5AF8BD09577EAA987FBB38E8A5B47E5A684DCA080E0A383D79879D69E80D39B7DCA9577C9977CC090';
wwv_flow_api.g_varchar2_table(5) := '73B5886CB0856AB68D76F2AD88ECA984AE6D4BF2AE89B68A6EF2AD8AEEAB87F1AD89B6886BB07453F2AE8AB7896CF2AE89B1866BF2AE89F2AE89F3AE89F2AD88163742B48B74F1AD891B3B468E7362C3947A1837441C3C471B3B461B3B463F4E529D7E6D';
wwv_flow_api.g_varchar2_table(6) := 'AA877328424D1B3B461C3B46183844153742183742193A451C3B461C3C481C3C471A3B4691796B374A4F1B3B461A3B451C3C471A3A461D3D481C3A452A434E857368203E491E3D481D3E491C3C461939451C3B4626424D203F4A1D3C47203D485056577B';
wwv_flow_api.g_varchar2_table(7) := '6D63243F4A1F3D48223F4A1B3B461A394518394532474D70675F1B3C47223E49CD9A7F2B45501B3B475E5E5B1B3A461F3E4923404B1B3A46213E491537431B3B461B3B461D3F4A4652541C3A4526414C1B3B4624414C1C3B471B3B462D4752193944364F';
wwv_flow_api.g_varchar2_table(8) := '595E6D76475B653B525C5969723F55604F626C778089757E876E79827C848C54656F79818A717B84324C5667747D4C5F6943586263707A80889021363E2930333036393A3D3E57514BCA987DD29D80F2AD89ECAA8624404A388158C1000000F974524E53';
wwv_flow_api.g_varchar2_table(9) := '000C1E3926134E5884C3CBD4DDBA7A08059FE6EFF6FBFF03A9FFFFFFFFFF438EFFFFFF3395FFFFFFFF62FFFF74FFFF2EFF6CB3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF';
wwv_flow_api.g_varchar2_table(10) := 'FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7418E8F3FC7F36A288FFC9CBDA628E50475C10B2B462C9FF2E5CD4F4FFFFFFFFE17F1D0B164CCAFFFFFFFFFFAF2674C0FFFFFFFFFFFFFFB937A4FFFFFFFFFFFFFFFFFFEC41FFFFFFFFFFFFFFFA';
wwv_flow_api.g_varchar2_table(11) := 'FF97FFFF78FFFF857CFFFF6EFF8AFF9169FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEDD9E72B8955D9D8ED00002DB3494441547801ECCF050180400000B177C5AD7F5334037E6B3071290000000000209536F6A777E37C882917';
wwv_flow_api.g_varchar2_table(12) := '399555FDB37B637D9BBB7E18A7C390DC428E7DECA791F451009DA4E8ACC0E888C2E6964D35A65DEDF4FECFF685410126ED91CF0E7695EEFDFFFAF71FE9D61FDF5C5EBB9D97C5C2D6627175F2A32CFFE8EDBB8BE53CA8D5A3C5F3DF7E88E5BF7AFFE17A39';
wwv_flow_api.g_varchar2_table(13) := 'F72058056D7EF60364E1D1E9D9C5EC96BA4A80A0057531BB79EA3BF0FBC9F9F5723640B10E300C6CCDAFCF3EFEF294977F7C76352F3050875237A08C1B2059CCAF2E9E9FBDF974FCCBCF4FF1F67FBA9ADFD68E3642CD3A601C03EBA08DE384EBB3E3CF4F';
wwv_flow_api.g_varchar2_table(14) := '6D3A7A7FB358685F1A86156AA4DA4736E308EBE5F2E2EBD1531A8E4ECE97C858DC5BF732AE3D484051A0AA572FDEBC3B792ACDF8CB9BEB19999A7B519B5A6CAD4828AB1694A14859CC96CBEBE7372F9F422C1E7D2B736CBEA4740F8A2DBD05C86AD507E2';
wwv_flow_api.g_varchar2_table(15) := 'DEED6C7E75F3EBE1AFFF439F8221B2A9FE22550AA83535CDAEC5E2E2E5D1A1DFFFA52D8D8840DC9B8A079B885D99A6F9F9E7838EFFB379DF202D1A569B14145414A5202D826A2BA0D0BFF42CCF4F0EB710DE3E9F65BCDF8082699C62ABA2501B89ADA4DA';
wwv_flow_api.g_varchar2_table(16) := 'EA65359101B3C5CDA15E82CF6733AAAD1AACC7D1BEC4A3083AA6B40E6BDCCECF0F340B3FCC4ACB7EDAAD635FEC68154219C2BA47B67DF0ECED418EFF975336BDDAEA136A21FE5EADA6D8EA0D75930A2C66373F1F60003E9F195601C583ACAA7F32740425';
wwv_flow_api.g_varchar2_table(17) := 'C4A32CDF1C1DDE00F41D1348F357F9D7BF86FD9FE5F2E3E1050034906A2BBA7BA1F4AAF7368E1D246918A0A7F4350C03985F9C1C58035EDA5141586DA40618D2BE4CFAD8DB97B1B695A9114A8250BB1DDF0FECB3E18BB9BF527B100350C61549529269BD';
wwv_flow_api.g_varchar2_table(18) := '0EE89DDAA77125760C4E0F69FD1F2FE712181A15624790B43189F88BBDF6DC6AD7EF0E28075FBFF86EAFD242DF59D00009F474FB92BA06B1E7E2D3EB9F0EC5AF97B36C6A406959B54A08B510C583882D03432875F017E1FBE5FB83F9FE7FBAD4C70A12AB';
wwv_flow_api.g_varchar2_table(19) := 'B1217BC3BE80D8319010E25109842C0FA60A7F79F1DD6622F6C680C483028656548FB2D92069795C7EDCFB7E762845F0EBC5DC009BC19E52F76B31B1AF147B5A6F0D84F5EDE57FA9B90EEEB491B57D9293DEFB8DB23861F485B270D1FA8B6768461258E0';
wwv_flow_api.g_varchar2_table(20) := '198A66CC20E4B2BDB86CEFF5D7DFA9B4B33FC09AC512D6B049DE67DE5E7873251B2AF041DE06F42B2E20440841A3F49774570A86FB8105003A089421FC37235ABE958DD4C0B527B9A59C2BA35EABA05CBDD168365BDB10A25577D7AB38AE2E14E8FF01C2';
wwv_flow_api.g_varchar2_table(21) := '6AB9D1DE6DD43D6018A50480E51AF75E363203AFF39A382BC9D54AA1D2DCEDF841D8EDED45FD3A42501BC88DB0084250A80FF6F7BB980C47BBD1D898D1DA5265EEBC7D940509B8B5A301705DD7B0371C7427316594C60707FE70D41E23084DF8BFA41E79';
wwv_flow_api.g_varchar2_table(22) := 'F5FA7418FA989280F2C09F8D910240158F8A45994ED87A722D0B00E838C8B200709D7214260109E4C28426B13FECF59B2D078A55D0C443A7DED89BCD3A34A694101E0484D078D4040B83E17A4096D39E67C1125EB9FDDEBA0B03EB5D1EAC2ECA8534ECF7';
wwv_flow_api.g_varchar2_table(23) := 'A37ED4EE0F068D46BB379B75C3399684330152CAC5950478AFBC341AAEC6320BBED0D5E7CEC6DAE5821CB348C098FA2D9C4B5AF5732297DA543705030B68770C17E6508BD3F32C00707333BF911B61A6E8644C5D0D1498132C295504636E20B21F209C05';
wwv_flow_api.g_varchar2_table(24) := 'B857361C503385C527591081379B69DF713725010938E6CC70803DECCD65C0B14C91CE5A5A9DDAD2C1AB4C00F0760300B4CF53491849532297257049AF7EB6F200ABF7241D5625002EB0F62257CE424CFC5638BCA0BCF4DFE08891059D58126624C01C3A';
wwv_flow_api.g_varchar2_table(25) := '218C497870B0580625E62B25502B2D120AEEE30CD8C1FB5B4E6DA51CE256867495BBADDC73BEC6F68411B32F2FE6FDBC0D75E1D8750BAA74BC753F03D1C09DAD45DA4F85755E97AE98009E72860362ED82BD2D4F7E5551CEF79519284B375847938F33A0';
wwv_flow_api.g_varchar2_table(26) := '03EEE696ECEF0904EA2B00302C1691006CD2CFA4754C89150BAD08E6872670B0B1F3D6CB87190060BDFE059A0A00B3A4BD6392DD31E7580220AE8458DB20DEA81BD12A33084668BD76E464A14072A7BC1EE23442BA72DA38159413714B250044D0298966';
wwv_flow_api.g_varchar2_table(27) := '84AC828453C2C44F408FD04621F56D0644E0A5B7561080AB1C80992037C51C33AECE9A13C2D57963B6EA0B30858D78D3D300146D5E612B0B0DA5EFB6D65C41385E150122484B49AA1D0345344FD9BA0B8495286823A175005854D57377AF66C10A6C943C';
wwv_flow_api.g_varchar2_table(28) := '873460C6D6E917D13A9031F9925A40C181ED2E531A9004CC5881652755AE9685A4D8ED0D005A432A695EB8429262ABFDB9367C8A769E0A609836966693ED172AEBB5C5FF6640073C5E38AEAA0E607480A298C693838389A49460A313B0110C45B0DA8F63';
wwv_flow_api.g_varchar2_table(29) := '6C01F007A0B2A55B65CCBA958560082CDDA08A57820B3F80C6DD5EBBBDBB3FF239B12C80256F60CD1FC97C263261EDBD8E9F18D7601E4100CAAEEC957080EAAB7E930100DE2D1C2150AC78321D821563FB9D41DD732BE57275DC0BE7263C90E6503B8074';
wwv_flow_api.g_varchar2_table(30) := 'B83B6ED53D08BCED462FA4587B82A8582B7AA28A5AABCAE27136CCE0FD751D6044800E076507AA8590D3DAED12C3F7A9BA517F5AAF40E4142104CEF67634230A805DE87845004AA54275BB024A920332A404CD58D0B8CB59900CC74810EE7A2DB5AAC5C1';
wwv_flow_api.g_varchar2_table(31) := '4C3B7E4C7B7FC30894CBE2F9785CAF7BDB086D8F4C3024C30050706BDBAAD4B695051D70D7005052E94C885A820368D8A88D1BD1EEFEB433EA88D59BEE8D7C623C7EC283F928DADF3B1C8D469DA3D174BAD71E349A3DCA02D686B2805EB46A351B1C7067';
wwv_flow_api.g_varchar2_table(32) := '010010673E8EDAA120B3B77B34F42793C9F1314FE3980B6D6FD301824CCC027C7C7C209EC5F23FF1A9B43B3B129B277D844A25B0522F7B9B25117050BF7D340CC33923ACEBC709D50A3F35F94F69E795BDC378E1FF30F932CA51DE8F7ABDC381AEAD1B57';
wwv_flow_api.g_varchar2_table(33) := '384322E0C0A8EB27982A2328AF26E2E336419472FD04F3457218DB7858478401A1F8243C6A648A03FEF3644BAB3FD40EE97ABE9370B29904215CE222F7E4A963E52433E319F134D525926E0441761CA1EB0200B98AD5A3C94ADE53528D79AA388190252C';
wwv_flow_api.g_varchar2_table(34) := '04CBE71A0B8C03ACACA2320D84D8B479326C145C55202B3FCE408BF4530500008D25032C32C1C713FAE131B5B1AFE57ACE8D6CE049927C38516101273A2A540C114F41C955F591FB971F801B1A00583E3C50A67C2670B0927DF0D1C79F7CFA999F58006C';
wwv_flow_api.g_varchar2_table(35) := '9E106B0581E79F7FF2C5979F292C6CAC44243BC4C33A02C0C98157F72EFF9CF9FF3FD31AB03EC38AED7B431C58FA3FFFEAF4ECECF4339F32B60A00B105A2F3AFCECECE2EBEFE662938EA2ADD08A40AAD5BF732100C1A1330F69504C451875B528F3F3E3B';
wwv_flow_api.g_varchar2_table(36) := 'BD383DBBF836594A80FAE11A23FFEBB353F181AFCE27C1FA2293010272E668EBE907975E07DED5C571D4D4744F066DDF9C259D7C2109BC383B4F0933062F252B3582EF3E55FB179F2D016006BA08542B55370B76F0F59317B29825005054103C58A6C5BF';
wwv_flow_api.g_varchar2_table(37) := 'FF419DF0E9B789D6FC5ACF2B265872C0E9D957E7F1E2E8B54D1000948AC52200CE8B3B97BD47E4C1B35C11D48A00354D016C8066D448F344C8B820F0CB1F35228AF519E7C4BA41F4DBAF24005F7C47A527248F7FDEF5E5061322E0C87E4BF0E2D2B709BD';
wwv_flow_api.g_varchar2_table(38) := 'CB3B00A8AE886122FFED0280DDC092189F7F7171F1C94F89957D42240029363E110DBEFDE2F4E2D39F1242304F3966B47B4875B0DC40D20B00CEAB67973C297655CC899475267714CB338C07221CB4395112FFFCCB2FF2FC0DC981AE092C743E4DE47EA2';
wwv_flow_api.g_varchar2_table(39) := '1D248C6512612237E3E118944045769CEE5CF268E0E68EC95D793022CA0A0C60B563581EB3204962F30B317261D581462589931863898BFA9936943371D029439366CFDFB9D495812B6FF3B686835A33A9CBB890DE0195BCA08F7B69FFCCCD3483602C35';
wwv_flow_api.g_varchar2_table(40) := 'A20449D5C4F4EE7C3098280968A3C530E9934BDD2573EDCE0B600070D09E24E820425026C6B12255E9FD651890C432483E0982F9FC044B832096098CA57AC05DAF2F390077AA30A772C3E2B573A99B44DECFBF78CF0200EB9D3860C711726AD338205C49';
wwv_flow_api.g_varchar2_table(41) := '395E9E6FE0FFFADB6FDFFEFEFBEF7FFCFEE7EF3F9FB095D6106D21319E222902C9511DD93AD3AB9DFCA5AE8D5C7B70FBDE8B17A6091A8DA74120017022CAACC0A7DCD23F3FF9FDAFBFFEFAFBEFBFFEF9FCF79FBEB3F57373E5921378430210AB8EC9921A';
wwv_flow_api.g_varchar2_table(42) := '9DDA79FAF2FD6BFFB9DC5F9375F5F563D52727BB24BCA902008D8549B48D624BE577E2FFFAF95F62FDF9B3CF4DED44154C992919D1614B0010EE8DA1290B3DBBFFFEB52B596815FDBF5B6664086EB7C3087AA0D53332B0B9BEFBEDCFCF7FFBCE4062ADA1';
wwv_flow_api.g_varchar2_table(43) := '7CC3380926530F354763004D8AF5FED5CCCC915F150141CD2BC80EA96AB3268068C7014BAD05606B107C87B1E99BC2EA4A547958C215F705E950122F3BEFDD9D77D9F9CAB50F9E941D502B00D3E0531232801796CFDCCDA232556A5F4C594ACE79CA4990';
wwv_flow_api.g_varchar2_table(44) := 'CC8CEE73657B40B1F8220BA5716B0C763C33FC53023A36143260D6927E73F22C9031015F3A87445A44164C76C16A81C1293F7B9D99A1A937793B2B573309F228A49BDC4F09A654D04A292556FF6B0ED06EF1BC8F56BF74AC54ADFF37332AE05DBE58ABE8';
wwv_flow_api.g_varchar2_table(45) := '710F55D975606B9628F28CB69BFB61B7D31545A2BDC3EE6C360BC3AE1F126A9C2475916930B8F8DA154F8401B5D6CBEB99999CAF6D6F574DA7A41E1A4053431AC6D49F8D06D576C3F35ACDEA566E1C0D9ACD4634E81F754392488DC85578341999717B71';
wwv_flow_api.g_varchar2_table(46) := '296C1773C56A557AC1995837F34EC1735D37A778D7CA8096FEA4DB6BB7107420B4F3D150AE1C44DE78D01BD2D806087E1BB952F2ABE25AF4E41F95CBCAE0E095C779EDB6AAAB5A45A7D9959520CA671114E4FFEB82088D0F8789D110C33102468A2C8EF9';
wwv_flow_api.g_varchar2_table(47) := 'C7D9189B7BFDCC05DE624E5E8FCDE4DC43D90B14EED5A181C47BF52F1808087A58678746488DDA829599CBEAD36B99181B1483B32A8109564973F7C32439EA97919D0AAF796BFBB6040C5BB2A28649D897C19F6B86E624F5D57225FF3A131270F7BDF529';
wwv_flow_api.g_varchar2_table(48) := '5957F5F9569B51A30A97DC6F87AB2BC07084DD2847B3D01FFE8FBBBBFA721B4BE238AE7072C289DB33DFF66DF8D5AEEE55A4BD5A75D23CCCCCCCD32FCBFB1E1E66CE5FBC96DC91E5A577EBD3DC7EBA2528E9A8AAFC18C21585E7AEB22CE370E5DC3C5C06';
wwv_flow_api.g_varchar2_table(49) := '8E862313CEA2099081844873A6BC2F4AD924C319B56EC87636ABCA09959597C00024975D3979601E0270EFC9C1EAD039D2AA32144B59E9316AC63E097302F0DD7A1A8989D2133015316446637465F5E2C939390B1E5E3B7D6AB83A5CB232CA0711A3239A';
wwv_flow_api.g_varchar2_table(50) := '6849B4BC49FC77A9F3A9328FD970757570F2DEB5F9B9193877F8E8F113AC0E47029301595518CE0720783195A6FC1F26EAE98A17CE5F3A346FD315CF1DFCDDA5DF9F1C8C96CC1BDE54551E0A07799ED361EA1E1B81592E8E2E9E3EB33CAF5356CF1E3978';
wwv_flow_api.g_varchar2_table(51) := 'F4F2C2D274845421249BAC4C4C19D6F6D8748D2EAE1C3A72E05C32CFD60623101326EEA6FB577677D8D8A8DB8603362EA1DB6022B47130313C793899F7C9F3671616312F0404C75D1BAFBCFAF6EED6E64E516C6E3FB1FBF6C375000498EFE4C42600F3EE';
wwv_flow_api.g_varchar2_table(52) := 'F838004B66721860C1EED60FBCF6E6AB0FBDFDC82B8FDCFFDA03AF3EF516926CE63420D095C973A0393F04AC74CE0326302B99D878EED9776B4F8DBFFEB16BEB60453A1301D0EA8964EE1DBD30347C1E6C3F0402238BD2FACEEEDB0FD4DEB87F0BEF8158';
wwv_flow_api.g_varchar2_table(53) := '44A0C8DBF19A16CF2773EFF0C918B3D9EB9FD2AA02D3BA2B1EDF7DF2C9DDADB88E1798F212C88B76F6FCE2E05232FF2EEF540EA202203220531E01E11C751A005C04900982E104F8A8EC541F664BAF2D4461D183CCD32596D4EE18E6A8794BC184F914C2';
wwv_flow_api.g_varchar2_table(54) := 'E5A4078E9C0872B9D11922E6A905637A07240019792CE53279CB53B17034E983630BD11B5D4E0021C33CF2DD9B447CEA50686E96E54E1EE8C77CF98BC6ACE91E6FC23C2DF33195F7517965C4B896F4C23D7F182C2166A64B4D4340D0F438F0A929C395B9';
wwv_flow_api.g_varchar2_table(55) := '2F537FA5276F3DD314CE98514BCD77136234C4AC4C00B9C9ECE272D2177FBCB093E33CC43242100400E5AEF9699D986002091B65CD04C99E38361862B9F0298E8910DAF1AA59E941EDD1E124618BE70F24FD71F6F860241956180214027999B3CFA774F8';
wwv_flow_api.g_varchar2_table(56) := 'C280E64160AF22B0181DA4659103AEF454B9D18A9DFCA8325FCF9EBC91F4CBCD5BC5A23328AA6C49C88368749E0E4419133BCFDEEE5B000E7FF2FE263587B220B23C5A70880965E03C9AF45A6EBDF6FA1B9F26FDF2D9277BEF6F7B903CB5B2CA21C87B5A';
wwv_flow_api.g_varchar2_table(57) := '56625EAC6F3CFECC78AADEE749BF7CF1C9D5AB57BF8CA0D2B70140445C59441A0608F7E878FAE083CF7F7520E993035FEF5DBF7AF5932F0B883940CC0235A162B312ADE291379EAAEBCABFF92CE9936F3F696A223F79BF826080DACC2F39C7BE756DBF3D';
wwv_flow_api.g_varchar2_table(58) := '69147BF0C1EF7A9503BEDEDBBB3AF1656E65103289407B4834273F36DF7AA8EE16A93B4C5FBFFD7D8FAE02BED8BBDABAB65DF9A5F55865C8012C59BDF6B1726BF7994929755335FEFC373FF467FD9F5CEDB8FEFE97CF55555EAF597E7D635D795E3CB7BD';
wwv_flow_api.g_varchar2_table(59) := 'FDC42B0F3DFFD4534D37755350368EC08F67931EF8E9DB9FF7F6577EB5F5FEFB5FD69A1FEFBFFFFE9F9F79F8E1579F7FB159F7B4D3F6F9377EF971EE73C13DBFFE3639FFCDFAE493F697F1AB77FE51D7C7FDBBA75F7AFD9FB7FF45CD59A4370E4441F808';
wwv_flow_api.g_varchar2_table(60) := '73226B393CF28075006FE70B7372863099492539A071D432B54172DAECA1F07D065A1D4EF6D6BF7AB57C556510AE6E793BFDED9DDD5078E159B80DC1699F24E06F1613239791682C9E487A35FC543AA3025A480FCEDF5B3B2856176A4612DC2CCE5F3727';
wwv_flow_api.g_varchar2_table(61) := 'BDFA1CD8CC6AC0EE5E3AE5C5FDF70F0E5503FFF8963BBAFF29B82B82F393B224B8FFB205FF7B79E9FFFE26B1AC7CC1732D481763A5323854AB54F587D517CC4E28B2FFC1DB54B9F68D8C4ED4EA1A05CA76C5B11AE994A72E931F176396E5100B1CD560CD';
wwv_flow_api.g_varchar2_table(62) := 'D6E2135F85F31323B2F408FF6B591A195196AA1A0305DA2004D8392C6EAF7865FDC47ACC3278F6E0500AAD936D2DDEDF3EF86F7D497EF5FAEEEAAE52BA934AB7D573084021285B681C16BCB07DF278AFD18700949429B101B435D26C8517EF6EEFBBF7CD';
wwv_flow_api.g_varchar2_table(63) := '275094F1B9EEC4D22057EAF54C704C520660C3501BDFD7F787FCBFD14A3A4FC1213F0C931A8EE9B89A7B901BD4C28B8BF3B3B3D32381C09DBD6F065996263737F510B436C9E588DBA29F04EE00A8C8FC1A660752E9A26AC1C5FE0DDB000C832B62730B18';
wwv_flow_api.g_varchar2_table(64) := '6B56074791EEA4CFEF1B15046449912529207D1D1D1DE92EE983CE89460110C70001400805088560E7343DAC3F0989B30C3DA7A000B50103B8FB3540E0A23176C29A1783C1A0A687F55AAD16EE8E28E39313DDCDA588DEAA6671C23470A80A610000C7FC';
wwv_flow_api.g_varchar2_table(65) := '3FB44D1B6AE9C76EFE7208FF1FBE38C8F4CF55B8947E52D709134FD0662727278C55AE1CA6B1EC45B55ABDB80885B2B9CE096BB7FF3267072A6E1CD91AC71F6101003FF58540980134EBEB587F41BC392BEA536CF527982A27D046C6D56EEE0E743A993C';
wwv_flow_api.g_varchar2_table(66) := 'CD0D68A4293463C33276921F029A1680AACEA9A373BA9133328030600005A4D26F17F4D75DDC5C5E7CF7773BFB1F2F2E374B0EEC616BC8D705079FD2AF56ABBE0FAF563FFF61F5C767850DD9E6C4D9DC914D9AC0406CAEBEF91B75C8CF9E7FBC7A5FBA41';
wwv_flow_api.g_varchar2_table(67) := 'B4FA32897B06050DBB62001B1837A74BEB7EC50EA8808D65EEF9FD0F1FBF7DF637297D1FAF82BE14658E0CB88EE6C4E04E1CD9002481013409A0D65E443207E648C9694AB4FCE32FFFFAF66F9005FFF8E9FB9B65856EDA660E1C60920040082280E02402';
wwv_flow_api.g_varchar2_table(68) := '6100578098D70900DA5D13AD2527021437EF7FFCE7EBBFBCE7FDF1ED601988EB6D1A7BEED8290020A3F37842A40043366103EE1290332DF188889D0A00C4CDFBAB5FFECA49F1DB37579B9B3AB09DA14F6337170C06A08A4734254D23419CEEF5000E9239';
wwv_flow_api.g_varchar2_table(69) := '091E61641F2F97F1FEE52FAF9EFD35A5EFD5AF6F099B206B141E4AA1560186F2B9658CD7DB8233B011672A0F994F3010EF2FFEF33FCFFE829EF7FB4B2F69C4B0281900031980EBCCA3BA29F5DC099D677B88039B7607F2921303386C002EFEF3CD8B3F79';
wwv_flow_api.g_varchar2_table(70) := 'E279A38E93E8A1EE072D0C409C0AF9684204ED62C8E68C82C7D6CF3000805300548105E038CB8CE0CD9F580E5FBCFE7039EFF27D9BE2D1F27A9F748C4859648E5264802C0E96451800678054991207B601540501DDC0410436B4ECE6AA87E58FDF3CFF93';
wwv_flow_api.g_varchar2_table(71) := '92FFB7976F0F4D9F9103F034C32A0D953E2500D4C429050039013BD3B000729003000CD6DD064432F49CC810E2C4061FAFE6A95F6E7CF1E1A73F21F97F7B791901B46A101503CEC13D03A889580530B4FA9C1FCD7F43AB00D51C397012775201969BB87A';
wwv_flow_api.g_varchar2_table(72) := 'F395B7E0C56F179711A0220341A4F3DF6B5AE233721C4FBAB9A34C473DED9339313016DA651B4325CB35ED001CBC7DF3351BE49F5E9A83329F65E783B0B7C4E3DC84F720666DDC7C6799937E9C1D8BDBBD00500D800D3692308C15B8FCF5D5577BCBF176';
wwv_flow_api.g_varchar2_table(73) := '030FDB5A0D0220DA3FF2A06173C6368DCCA7A87262568CB7FB7D866549EE94C31C04A019146873F5751E9F3EFF4000302400250E947BA0EF15609D166B7112C2FC97028304B81800BB8E2AD75D0AF75A14BC983912A0B5B55E542C3EBCFA0AB5FF62033A';
wwv_flow_api.g_varchar2_table(74) := '95F5D0609C0324C0C3B0182AAE1C59A0C71AC1081A41C3E24ED806C675402E8CD7198CD6EBB4EAC140F42EF33B73C780AC619A327073F1E24B57BF37971BEE790351D1BA001872B7DFAFD73AEFD43848028FF070480811E2A4594F197A186E17C210D900';
wwv_flow_api.g_varchar2_table(75) := '0CFB5C837052ED0713A695F398229700E20B3F42FFC79B793F8A03832BC07103009CA6BAF1298CA6A57C764B637343E21169EEA1EE67A7D9BBC006D0386C575ECB46E1FA208DCA0006202E5E7FC9FCFF95BA9E1040DB931964A1008DC6E9B81C6700F349';
wwv_flow_api.g_varchar2_table(76) := '3ACB86733EB689DB719E77FB19179441FB6155F6DB3100A0DBCD0E7B0300CE692B6309D85C7CC13AF071037D7F3FC80311C63B20AED3D071661CF904D3F0F653436326328498D756B9BD4DCEDA1962BDA5EFF6538FCBD0F55D9D53A91C58659A5276CA00';
wwv_flow_api.g_varchar2_table(77) := '74DF7FB1D6F8A7F7000A40B4ACC01AFB388B676F7360B96D15B2DDE78C201060C001C0722AB41C44CD7D1A3D0DB7FBDC29270369BFAEFDBCF877CDC3D0A5E21E21739017C96001B0DD7EF8422DD1B31F8230134007AD3027416400C885239941197C1FE5';
wwv_flow_api.g_varchar2_table(78) := '0802208169A4FC58AE48644DDB5804900DC3BE46519A0DFDB04F003BB3240C640507C1B47EFBDD9759FF1B032CAF01D248C380FC20BFD314DC1B86CA3903C53C46D05A56C3582C604CB0099113F3D01BA26A3DF7B84844D0892C540062B3DF77175FE410';
wwv_flow_api.g_varchar2_table(79) := '7C73B984AA64009239905170D2E42198139BEA1A3C645A0E0E128F19CA784C30D99033B6165D3FEC0BDA268CD20460DBA4489E8A973F7C8196F0F9CB000061A00E015896013DD2D09A5004776A6D5B61FBB1DEC87C56ADF4C3760DA502FD90D0D085EBE8';
wwv_flow_api.g_varchar2_table(80) := '329B719B01526E5F43C83668F9FEFF9E7E003E440036852CA0740191EC073F3FBB497B6CFCA04ED4D48E4A066500824FB209E8FB62CA801D4E8E6D89A03739C06302CABBBAC53E9B3C3657DF3EF9C1EFDB0DE4515D096C3C2ADF47B70B220404403618C8';
wwv_flow_api.g_varchar2_table(81) := '49B922E3BB450380B18976EC37E40CC0503F9F111A8D21302058FD1B520507A84C72EE93AE17E59D41750A2004B0F9F0D404F87803283B251920638ED220C2064C231480694378CEA6A5E051BBD4E70C28D38A69800862D1011E3429C8E95D9249633798';
wwv_flow_api.g_varchar2_table(82) := '8D31C0CDC5F3A756808D01C218A0E6D4872554026457B0214683DA809D1C26194802843991F9945A003CBB2F8276D385DE69DECF06D8CD42D51A003BE79CD8558FC600E0DC3DF1AFF0BB1BBB249471D3BAB727DED44FE76F07E04118427A279B13551812';
wwv_flow_api.g_varchar2_table(83) := 'D880A025013260C0027098835CD2B83398C8403FCF763679BBD0D96099BB0FFFFBA421E8C30610D40C16847649188B476C9AE7766A875F1975EBD9E444C3ABB416128F10A4119397343A30688031401CF5DD10A0D223830C0100F1F24967E0C555101084';
wwv_flow_api.g_varchar2_table(84) := '01497958033852706043CF031EC3A712E81C40E9E4A09186B2BEDD923218C02C0D18805E010439008C01D2BA692989A253079EA7A11680085745101CC4EB279D8080C3871D7DD96E8B8ADA36D8D87818C1061C0A1A4E61009C73ED57D08AED34DDAE4B93';
wwv_flow_api.g_varchar2_table(85) := '01DEDD6FC0B81E7ACE950900C7D89CC6B102692A4A00E0D483130737FF7ACA44F04F0E549129EB29A31C4D100C4016D8606CC0983BD7C7558417BBD9B4624ADACFB40C8101B4BE5D6F1EB4899204C6D91B736FACFB45891E89E364650EE2FBA7148137DC';
wwv_flow_api.g_varchar2_table(86) := 'C9C6960CD08923650018AE03D2E29AA103254EB4E160D46296A934020DC9A8CB1D77F2EE14C6C56DE28E86E09CB16023D704D2BA0446020C0C69DEEE04B0BC7A423BFCEC82037BAE9F6B5BE75986A9E4F542006536679493826A5AABD5AAA72E0A2B30D0';
wwv_flow_api.g_varchar2_table(87) := '977DE520AD078E94CE7B0723D75C060008796748DC4955DAEF6B0F40FFEA0935F02D00741359DC09F0B279B3210052CE101EA6381B1ADDE44235B85DFF76BBD50ACFDBB9EF07FFFEF3EF2BB9E91BDBB1182484964B4EBA0480E64C977AC0409652400FA1';
wwv_flow_api.g_varchar2_table(88) := '0078C2CBA2D79700669849C19D4D70349C02ADA1CB067A5A3FFFFEFFA45B098FA33A12FE19FBA7F73EDE7D97F774222AAB856AA96184E4164F0F44EF9587869084C486989064667EC2629CA6C9A4F7CAFBA62F2CE7E09B725D5FC582119E23C3A51585C5';
wwv_flow_api.g_varchar2_table(89) := '72B99A84EB725930966FD6EBC263579D063ECE0CC99EBA4B50C0FBE6BCD513297DDA417E6202C3EB1FD00AFAC04619819E290392649C950910DCDED12855241ADFFFB6B4D8300426DE9302CDAF7825D52AAFEA9D078B9DD6BAD9875785A288F1CEBEEA1D';
wwv_flow_api.g_varchar2_table(90) := '879730CAD1287339F1E7CEBB6FEAE4EF6F27E0D71FCCCE663575441C45514667996326E22CF141E07BA6CEE7F8ECB417556DB15B00BA99E8FBD9A6B2EFE1054413BE954DAB972E83B0D44A9E0918D99BA984E99B6B99EC6598F680B97B1A140A1EA47FF9';
wwv_flow_api.g_varchar2_table(91) := '2104105AEF97A5409FE47936B6BBE89361CA8BFA9F6E76D93466875D59EE3A6C4276AC4E5EAF7CF2A7C48902B3C52B953A450C804587670268B823D375A561E9BFC399C6CE585BE4885FDF4EC0EB6F29C91302B489E02779326E8846D37E180E1178D2EB';
wwv_flow_api.g_varchar2_table(92) := '40E71E2F8D7CFC279FF80CCD9F4755C52CA090019BCC62E87EE343BF272E0A77421C48649521808506C23E1E3DA7DBEA980411FF93CE00C973C8B4C395A30CE2D58F6E8E82BF4FE726BEA6F773FF0EAD131BA1EF867BBE29FE62404412FCF26D79D1FEB8';
wwv_flow_api.g_varchar2_table(93) := '3A76371842B8562DE3FBA228B26C73D81EF73133F6C9D8D4ACE5E658580216AE59D8C70013C8D787ED61B35F6F378EBD179B0211A40884D948458EA34CD82B231C5DB245AFFE707314FC4D349F098079349F24E9F8A88BE187C1DD7C18F2B8F081C756D6';
wwv_flow_api.g_varchar2_table(94) := '6FDEC87697335634A770DAD6B5DA965A9B5FD30990936D96B2AE65BB72D99980C76DB750AB02046DDADA40A937ED4400F831193182A709059EE0F71182B9EE2B6C4C02F1D45820DFA45D420CB9D50737C7C15F7D3AEB79F7D26032BF1B6B7E013E5F711B';
wwv_flow_api.g_varchar2_table(95) := 'B3AE25F07057BFA96B2DA56E739637E5635E692595EE08E87EB611054929F59BA6D152EF4088AC31049452295D6F60B1575AB687C349CA7AF9380C19112589FD4F7F403B90D32F0B318E988E19D9F3C1E2DBE9CF6F8E82AF38381EA06B0E28A6880303F7';
wwv_flow_api.g_varchar2_table(96) := '9918B97F91E01301768F6D7E2C76EDAE283A3350F2B0887397F99B9392B259E5C5A9567A173B6B29E5368ACA6EB1089F2CA0E368B7F6801D6B59E531BAC74A9721A448741FD8AE808D328489E5E44272341041E2455102F040800E4DBFBFBD216EDC0939';
wwv_flow_api.g_varchar2_table(97) := '711F62EFADE7A1ABAC34C6CCE669EF090677899770F4D68DD4E5822764C282926AC518E427A91A372BB53C455E5854526D17600828564DC7103201B8AAA53ABADE2C8E8E39EB33C32C008EF4345FE6130F121A8F178F6713E2C0B1FDF3393A37C7C1D71F';
wwv_flow_api.g_varchar2_table(98) := 'A400891572676E94083398716DEA7E0A766DF67E9FCF5D1FCA53A55447007C6309D026E6E164A3955AE79594ED767BD875142D17BD05B41D43253377B8586BD95DB4CBED7ACAD9B9B074A239D0B35690E085464DF77CA42F99B295B0EF89DC4C4094593E';
wwv_flow_api.g_varchar2_table(99) := '1D14591E79A2BF78F0C614100A2F007C294ED3BA35FE4E5A02CC02190202733A0AADF4A1301EA1EEFC64ADEBD384651D55B243BB67E007342DA536975A5747938F058E93389ECFF940009EA30E9ED7F8F49E05F64F2272123A3BA9DFDC5A107F67240081';
wwv_flow_api.g_varchar2_table(100) := '641CB097A50FE6C963E1B978D9A4A2BE037E05B66EB4ACB69B557F04FA4A213404B882205C6B55AF73A5E4696BB161C210A0CD773B6500CE0316BBCE7CB454757D0C7BBFE7CE6168AADD9118199BB0DDA378948F933BB75BF96DE280114567804E963E3D';
wwv_flow_api.g_varchar2_table(101) := 'A56FCE5A96A4737A71C665AC9EDB20A0955A51E7FB655D2EEECE04C866B330F99F963ACA2B2D97B10172BF0F83FAB4DF29A90F31039697C77CBFDF1F4F4A9B5CBA838813823475B8959870740AE7FEB50D3A1EDACED96D22A949038CE5F9346ADC23A067';
wwv_flow_api.g_varchar2_table(102) := '922E9EBED4DDBF6CE02FCA5A35EB05DBF704105802946C0B9CEE94942566A5EE76B00EC9E1100AB7914DF1982DA5566B07269B5AAFA618B2A8923D018431475B43C497EED6A720F2E00CBC926AF907AF6F4F03CEC8A6D8C7B820263F31BE00FFBBBAF7B8';
wwv_flow_api.g_varchar2_table(103) := 'D54A9D36AB569E7D00614F80544D23B5AC727858ABEE627958ED2AB57D3C56B2AF058EC6F755053B6A2DB7FBCCED2387F521564CE2BEC7692CD0040E39361E5DB4AB6DB921127EAB42F8D507D6821240D7455B8EA57CE854F8F89F0960FB56F72E4CEABA';
wwv_flow_api.g_varchar2_table(104) := '23C00CF0F547A0D2BA737B6D41980487467790DDF7F6B1ACFB72D8EF97F4363CD6E677C798964B77E20C6D11D70D003FF1709EC5F600DA69C15E23231C0DDBF227097E76631CFCF5D900ECA0964D7D45E23F55BB69F252518E3490C3D6A7A6A9CAF5B26D';
wwv_flow_api.g_varchar2_table(105) := '0F0C63B24E705994A7D3691B51E003E39B655BA9A66ACB22DC9CDAF69433BE6B3B9C0AB651EDA96A946ADADD9491C7C14238F329F9D38065534FF4F20CE2D09BE5BD302B865AD0E57D63F8CF3746C1BFDBA8EA93C385C321E8B50A3AA7FD3E8E8765DF9B';
wwv_flow_api.g_varchar2_table(106) := '1931822DE761B6DFE70099EB26806009E8D2DA30F660C1C07A058AF6DDA69C3160899B47E639DD0E1E63499167F9BE58AF5DE6276CFCF941707836ED5FDE4938F0792AC636381ED74E093C0EB3AF6F8B839D2E6A9E4C6414C7E281079F1829CB1588E7F3';
wwv_flow_api.g_varchar2_table(107) := '85D7A140C4091F4FB6868B5000EBD0E7A9ECF160329E30646C88DDACDB3361CCFED957FE821900897B9F41B8601306E8806F45266B88314E73A7272038CFD6E0C08EB5411C6C322698DDA690FEE4BBBF039D7BAC69E24D33ECC3DCC8E683F82A084C730F';
wwv_flow_api.g_varchar2_table(108) := 'AE70DEE66C4E9596CDE9B4C2E7D22686173F2768848D18E29784F21469C63F710705CE3ED145678EC0C9CCA2CD94E9C644E0F33FFD3D898DE6CA0D0749E60CE2444AFFD6F5052E5EAD39B693C6DCA5CDEC64933C93184DE16510A7175F84EC2D5E39E0B7';
wwv_flow_api.g_varchar2_table(109) := '74D927F58D9263AB187E4B416CA220EF9BED195E4896C233C2C8E4EDB0447ECFFC58C31CC9B3B3D993D5B064DB543D961E586086D927389256C7C073D97B355ACC5FF848324EDE4EBE19C57E1AC933F80DFFEAB69670FF6A2460847B42A3457EF3F6DD04';
wwv_flow_api.g_varchar2_table(110) := '2CAC05235C413C1BB305CB0A0BD7AE0325AE2FC4B0112F4D9EFA369710342A346C5C7B6A4C89D1F99ABC7B3BB208AB9D0F8EC17B7D5314FCBBEDE5E305D3841DD1DF4CDEBD33845F825FE8C4BEC7DF23005868C106BDC7372C04C3831CBA603040E04160';
wwv_flow_api.g_varchar2_table(111) := '9D2EF7C186173461A25FF232E75FB45DE16EDB3610C69E60FDD7A7899F20F62FE757DF20B09106C93220288A6140516CEDB0C1C3E044457FCC728C629CC2735BEB92991CEAD21102116AA1CE1090A770936EDDDF49B42CCAA9C4A0027650204434A9E327';
wwv_flow_api.g_varchar2_table(112) := '8ABC3B7EA432009446784D1B926603F76D95B0E05FE18219807A26284378FEFEFD7C1500500981D49599D96629B127541357C9AA47A3635CD410D33CDC91334FFDC2B7A622A568F05EA291355C5153DF237CF943056EC4DB10872328B478C79797698B2B';
wwv_flow_api.g_varchar2_table(113) := '7CF1F5AD8D34B8B264E9A423844B0B5299749C1345D2916499E68F62002E2FC7A5B305CF9F5618055F0ED3D01666B4C894318ED6D5D5E51C4B489E6621E486DFE1B2ED50C7A1CADC50B74CA9F83EE7C21F05A014B2311D8FD05500CCCB0877F2D767157C';
wwv_flow_api.g_varchar2_table(114) := 'C1E7431B385BB1F867E3C5BA98B8FEF12B57B2C60789E1E9A265612EC5072C45112C0F148940F3A31215A4D0A50AC951C1628B1880F797F31E915084FA9F2FAA00E0225A3EB5FCBE32CE16DB5C905E4FD82C7E0334006CD5E891400AA305340DDA38443B';
wwv_flow_api.g_varchar2_table(115) := 'CD42D2EBFAA2264905BC970FBEF7A2A4B3D033E2769CEC8E4E1677C179AC52D233835255FD099D955430049E3E0112F0808DBA03076693C169B76B0D4E07933E7BF326B9D7FCF7CF68F8194E2753109923A9E2FC79212CC391E4C704CCB12B9734109278';
wwv_flow_api.g_varchar2_table(116) := '3D28D392709EE87475650583C9BBD3AE33E9BE9B0441BC61CDC20C0F7FAA600684F6ABA3CE5EA7B3B3DB39E89CEDDEDDD9DBEFEC1C1C1C1DBFFEE3C3D587ABB97EC49F213035A5BA5CE43BD4BCFF33049D909100E9D28CEA77F7BEFEAAD3D9DD3DDC3F3B';
wwv_flow_api.g_varchar2_table(117) := 'DBB9BBB3DFE9EC1D1CC5BBF4BCEEBE1BF40909DF7EF9F9D18027BFFCF677BBDE8C6573A39948A3D668ACC5D25ADBDADE6A9D2F46734D0531CB271347B488458F593B404EF3ABA14450741F394BCBE89FD6EAF544D78D8652B5B6A9546DB55A5B5B5BFFBC';
wwv_flow_api.g_varchar2_table(118) := 'F8F95995BDE86EDFBEF5A0592B9446A3D13E5283B098CD6EA67D17901AD066EEA74E1342D6D261E4EAC92DC57B50BEF82AC51420C5961DB78B158D556D3EACBE1BF0C37AAD4CD60F9DFE82CDE6F66E04203F94A8AE89F8F64D222D1750150D9E77925876';
wwv_flow_api.g_varchar2_table(119) := '44077AF2800207313D28D7B4F1B1FA86E81FCB8BDD3C1B240048E016375A3AA01311416240574DB542FF21E1830796043F816E7CE105DA13270C6DB142960022C687CD524D9B1F6F5507A0592B976E12AB8F3800980040862B83A4756189D245D62752E8';
wwv_flow_api.g_varchar2_table(120) := 'E74F306098AC0A1F5D2CA8633D2025446B31EB6C96B780FBF7AA02F0F87EA3562AEDF37EEA9D9712DE875990560F689442B9FD8853DD454A4ED38DB38007256F1840921D404C5A350300FF5605E09B351300C72CD777732F12A586BE5FD00BDE684023E2';
wwv_flow_api.g_varchar2_table(121) := '72AA595FB2A5BF8A04AA8245B76602A0F23EF5DFD50C00D40FA60292908B705D61074E20CAB70910940A73CD4950904F051A00B5E12BD36890A610458E3A9DFF3F007CBB6E28B7B93FEE73CFA2C4C574B1048EB46A79212E23851E2041ED4AC335A30A01';
wwv_flow_api.g_varchar2_table(122) := '91A9F21439273908F517D93474828FD4E9B511804755170BFC6802A0B66DF522EFC283B18B0BDD91D994B274D56FC619A1044E38252B4C7948AAB30480443AC0A905A72C864DD37FD5A1B716A42205D057001C360C8A56DEA7FF8B076D13001B83D14872';
wwv_flow_api.g_varchar2_table(123) := '9EF82724699604050021D9CA69E272B459C4218D96E4580C4C05B30953D7A8C78BDC2A8288EA225B9D7355484432DF1530D13102F0B8E2E4F0BD87EB35939C5B33AE1E879BB1D208CD1379496227E9113B814187AF190386A8FCA3E285D524EB433911D7';
wwv_flow_api.g_varchar2_table(124) := 'BC5CEEB8EAACE27553986C9B00D8785CD50CB85F3702706C49444C6BE6EB512F65EB320668CB1921D9D2395DCD2177A4E521B18D823AA84856D109689EB2D53F6D99F4ACFCC9A2476B4D2300876A80F20999F9369D89749968A21ECFAC3A399651F6E433';
wwv_flow_api.g_varchar2_table(125) := 'BA380AEA5D289E65B94BC98CF625022C03301C5E9D1B01D8A8FAB592EF1BF58672AE6247ABDD6EDFB9131F5ADA77B6C3E170184A574661380CDDF8F0BCA1EB86A10CC330BEEAC6A7C84D8E4C5C194ACF55A9A3F8FA3225C9745DA2EBD764AE9428F446A1';
wwv_flow_api.g_varchar2_table(126) := '1245DD39DED86CD495A2EB9F281AFF5FF59345FF7131071A10C33018C71F7C440DA69C5D314061607680EA4B849212913C490D70D90EB81F3EF8F8BF06008C01635996F73C8729861826177C638CEBBEEFA58A901EE553EA51892FEDB6B9A4A8582BE666';
wwv_flow_api.g_varchar2_table(127) := '7C096512473937EE96ECBCB1754ECC96D299FFB5E7E746428244AA88A8AADEF1427BFE5FC26CBBAD00DFF6EADB80A11006C2F03181E86E1A2FE6EC011801D1B221A573CE76E3F0EE2B897FA7DE2174B00B9D6E42A7EF4E81E16CABB5361C0E8110237662';
wwv_flow_api.g_varchar2_table(128) := 'B0526BCDC98C5E72CEA524C21C1BEE9E5272023023695CC3553C77B4614EFAD6768BBC56DA6E848610F115081111111111111111916FB0000B0EB70E1EBCAF760000000049454E44AE426082';
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784238916138151251)
,p_file_name=>'img/persona-male01-apex.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/img_analyze_jpg
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := 'FFD8FFE000104A46494600010100000100010000FFDB008400060606060706070808070A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA70106060606070607080807';
wwv_flow_api.g_varchar2_table(2) := '0A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA7FFC200110801A401A403012200021101031101FFC4001C0000020203010100000000000000000000000102030405';
wwv_flow_api.g_varchar2_table(3) := '060708FFDA0008010100000000F1160080403498D4803D3BD3F3B1EBCFB717650759284727AF73E6302120ABE4C600804D0809340CCAF5AEEE775274D8139D0562863641AFD2E0553E9B53CB791480040204C6D21B373E9FDF6CF4266DFBA8CB5D56B751';
wwv_flow_api.g_varchar2_table(4) := 'ABD79950A725857E51C3742D802004863685253E8BBBF48CD8D78DD0E3E9F0F4583662545F7C1A20AAF09E7BB160045B1243183119FB8EEFD0A5B3D3EAF5FACC89274AAA558928D7779279DAEF240009890048011B9CCEC3D3F96D6D25D758350ADC31DD';
wwv_flow_api.g_varchar2_table(5) := '841C3C8784B4EC869802013448104BA3373D2EBF22D32326170AA860D33BB252CAF9FE56EFB65CBB4C0040000303337259D65AECB6EAB2E5285746395D9BDDC6F75BE2DB5D94A1E48086027101A2401BBCB0EAA7919592EAC92EBEFCB8663A7075381378';
wwv_flow_api.g_varchar2_table(6) := '90C9D3F9A0D30040900C616F42296EB7B4E56464E7F41BCCAC121CD73DAABEDAA1931D0F2BCEE267260301111A063363B5892CCEA73ECDD6DB733CDA795D36B6AC66F61C5E9F59A9AFA0E8F6DE5E0C0004868063DFDF1528F6D95DA64ECABC5D269A86B2';
wwv_flow_api.g_varchar2_table(7) := '767B9DA7CEBE71D2F4FD0EC5D53F210000042680253E8580B65DDF6D8DA7D5C271C9DCEEF6D81471FE71D4659550606938C0000008834C365B32424FB4BF255D666F65B6D769F5FCFE1C2573C7E7798D2F316F48C010C010818F7991198C8EDFAAB2C2CE';
wwv_flow_api.g_varchar2_table(8) := 'C7339AE763074DD91C2F29A8C7C4AE0BAB60000009032DDFCA334CADF679593748C7AA6E98EF3A6DC63F2FADDAEFDEAB07E741821A6011069EC76526C8A1DBDC3CD9C2A9C2CDFF005553B736DCCAAE8515FC6AA4989A60240C37F39498418B6BDA96C2BC';
wwv_flow_api.g_varchar2_table(9) := 'CE976D3CDD6DA6C71AFDBAADC7E291A180261106B2B783022268DC7676E774D9D935129D31CDA2366C330C7F8B41821893690E3B7D8B04E24407D5FABEC72B033AB846FAA1904239D1BF1BE3D430004206074170D0E0C88A72DB607211DA6FFDBF6F9B8A';
wwv_flow_api.g_varchar2_table(10) := '4CAA77CA8C5F9384C0040080CBDE881389249928D7A5C3C07EFDE99954D7910AA6B6DA5CAF9040040E2DC588DCE781106A5152431EAF9CE9BE9BB2F21934D43DCF39BAF8DDA1824C1A41D2FBC70FC1A141CD0A2C630876FEA1953C8AB331A985BB5D2F45';
wwv_flow_api.g_varchar2_table(11) := 'F14830040083ACF53DE753C0792D5242911528A909B25D2763D5EC72618E8CA30FE4B18260090BA3F6FC4A3D1323CFFC7EB044A29048149319B2E833B2B231F17039EE206000080F79CFC6A67EAF8FE6BE4B16C208521A6D9446AA69A6840C6008620475';
wwv_flow_api.g_varchar2_table(12) := '5ED5AA91819DEA783E3FC0B138A68AEBA2BAEAA22C60A24852000220C3D87A6A25078799DCD1E0780471ABA2AAA8403130188138CC04D388C79BF416BC911A3172E7E41AAAA1168681A01B4A424D0482564691833D77B2C08595E3D463F946B80421821A';
wwv_flow_api.g_varchar2_table(13) := '060340D26C597EC36F86B00EFBD5302AAA983359E5D84D34D210D8000C400032377B57A07CA2933D07D0947022DE8396E5E23182100D3130043008CC89EB5479606CBBAED255E242AE2F92C64D0300109B430100A402187D19DCE64EDD068F4443063A6F';
wwv_flow_api.g_varchar2_table(14) := '34C51A001A048600C13438B0003B0FB44161F92E992C35A1F2E8898009B222638C9034034A4008F56FAA3032323C002BC37CF79940600A493624086D0C10A4948403EE3EA3D76CF8BE554F5F91C979AC062602018868001A01A0009247B0FAEE547590D9';
wwv_flow_api.g_varchar2_table(15) := 'D3E75E1290C4D4900021881300001A071991CFF77EBF2455F19E1180DA00681A0489218801881A01C5BBBD6F7B2AEAAB8FF3B6340C68000486021B1494463426D657AC6F0A315F29E7898E2C1B4098268103060446310066FACEE2345269B96E49368018';
wwv_flow_api.g_varchar2_table(16) := '34818210C0189A052040BDB36661577F298B679E345536D800980210352126C4D34262F71CEAB15F1FC4765B1F37AC7CC656EE4002069A010C18008621491D57A9463CCF1FCEF71B5F3ED1E751CA6EF72D34C4C014E32AC06C68621086E37EF7B9D7E2E9';
wwv_flow_api.g_varchar2_table(17) := '79CEB373C4E8F134B87BEDDB59EB1A54800C1240D80021A18965DF97B7D9E8F0F6BB5E3795873A751D048CA843678DA7AD2275D9151063012068241BD6F7D93CED1CE740B9FD1193B4DFDD5455F316991009C2086C40260E200FA055F15DC4A3E7F8DD76';
wwv_flow_api.g_varchar2_table(18) := 'D352A176DED2959B8B664636A027083ADC5A071698D2069EF1E3682BE9324C2C2B42B86766BC7D66E307675E5E36A0B630559101A13131003EA398CAC8BAC161EB8791917DCC34EB64B5FD12C6D439A8B8520D31200001F79C3D62272465E6B603585AED';
wwv_flow_api.g_varchar2_table(19) := 'B6159BB1EBF5D3694B10184418801A3FFFC4001B01000203010101000000000000000000000001020304050607FFDA0008010210000000DEC40218D707342C4A2A35D30E868F44C40860E1C0CCAFCD972D3013EC7A6D8C0486C55F0B164CB401366BF517';
wwv_flow_api.g_varchar2_table(20) := '6E00403155E7B813AA013766AEB63A3DAB01206E15F27CC46775D6534D5559D3DBE90609032B8D7E1B6EDA31E5B6FE9DB4F3B37D0C00426521E6F9F9AAE85F1CF4D3B77EAF42C004108053E26B77E634747A928BECB0010549A395E56A9ECDCEE8422BD8';
wwv_flow_api.g_varchar2_table(21) := '0026855001C4E3EF9A4DA857EC004010800041438EA319157AE01011A9800051C46E29CFD2B010B2517DC00011CD9AA858FBC008CF49976DC806D8E426310062425B243060D342967E6F61BCF408D768800069A1D7C1F431AA98CEEB24342600001CBE4C';
wwv_flow_api.g_varchar2_table(22) := 'B66E56EA1A1A4300130385CDEAEB869D0C0004304D3033F9CADF4BB80002608180066A61A34B4DA01340C4343CB52868D621B434818000B2D6A71DB4CED000130004D5B973EAC5AF2EFBAC2A826446D09A67479F6CB2CEBDBB33D955114A2021A4DEA859';
wwv_flow_api.g_varchar2_table(23) := 'A30C276DF993956284410006ACA48D370579676A80520804D7FFC4001B01010100030101010000000000000000000001020304050607FFDA000801031000000058445A7A9BB2D5965723D0D9E4F179F448B65CBD5DCD5D5E8777A18B1781F1F9824B4BEA';
wwv_flow_api.g_varchar2_table(24) := '7A5E875F43635619F07C673D04A197D47D571DCF1CF6E3C1C5E2FA3D9F100C4C96FBBF5FA79F979B5F5F56EE8D3E4F97E196312B39B7F43F13CAEDF4BB31E5F1B4757B1DBF9C020B6BE9FB3B77791C9B7BBA777179BC3E2010ACDB3EFD868EEBC7E3783A';
wwv_flow_api.g_varchar2_table(25) := 'B29AC2C84CF2C5EB7D7EDD5C1E56AC35E9B7CD09619D611EF7ABE5EBB2CC753CC0432C931B8E739B67B99546CF0A09632CA63931651ED2530F1C1232C8971994CB3DFB73CB09E682316FC2D982ACA98D511711964C62529132DBD7E753152901445BE9F9';
wwv_flow_api.g_varchar2_table(26) := '6914524A0586EE9C71E3AB2C562509475F579FA68541149652E7EA67397CF51129144A4992596892C3262A9719974DE645B16428091BF6E7C5948022D2258DBD5A3A3873D78D64485B12CB2EC9AB66175E395CB665AF1522C944C330B959B263884254CA';
wwv_flow_api.g_varchar2_table(27) := '442AECD79E78B020967FFFC4004B1000010302030405060B060404070000000100020304111221310510415113226171812032404291B10614233033505272A1C1D115628292B2F0344353E1247393A216545563A3D2F1FFDA0008010100013F01F4AD8B';
wwv_flow_api.g_varchar2_table(28) := '4CC7CC715FAACE06DEE4CA5898E0E05F71CDEE3EF29FF149591BC744E700438E44E48BFE4CF441AE23417C942E9DD7E9626B7B9D750C306303A26679681543D91863A3A7790ED430640A8A773DD9C12347375BF5F23B571455D15049D1BEFED40822E37D';
wwv_flow_api.g_varchar2_table(29) := '4FD33B76268E23D3A117785B05BD79DDD8029249DA7A90E21CF1594513668A512D1C6DC3637C9DD8991C718B318D68EC1652F4D97465A3EF0BA69A8E2C67F31FD1300C6F8B8136FD15883628026FD89ECC2EB772E3BB823BDD344DD641ED506D4A78C3AF';
wwv_flow_api.g_varchar2_table(30) := '8CF72936EB079B01F129DB6AA4DECC637F14FACA990DDD222E73B52770241B8505603948403CD4DB6A998E2180BFBB44EDB95788E16B00F6FA5402CCBF35B075A8FE1465881B191B7EF50F5FA46036C719008E69B048D7026A647761C36FC02C557FE947';
wwv_flow_api.g_varchar2_table(31) := 'FF0050FF00F5588B5B723BED9A9AAE2C61D694620DFF002DFF00A297AED6CBCF2777A833930FDA042A8FA67EE73DAD00B9C02756423424F8276D03A0600A4ADA83962F62C4F7DCB893E29A0E482215BAC5699EEE2373B82DB733E9E6688AC31B6F742BAA';
wwv_flow_api.g_varchar2_table(32) := 'FF00D5FC07A48049B202C005B0CBFA694039585D18E33EA37D8A0B472C76161893DB67B872255936787A431E318C705266C84FEEFB930458FAEEB7548177587B11AE8A278C3D6B1E0A6DA4E7BCB9B1817E79A96A277FAE7B8648171D773B5051B84DEF5A';
wwv_flow_api.g_varchar2_table(33) := '9BEEBE68D95F20AE8903341C9C78F05B52B0555512DF31A30B50732D9FA4C03AE7BB76C473874E1A1A4E5A9B27C4C95A04AC07B35CD4514517D1B005571B1F29BB4106CECFB53E7A5A6EAB8B597E007E8BF69C4726349EFC94F52E98343EC4341B0B7351';
wwv_flow_api.g_varchar2_table(34) := 'B81D1840EE59DFC824AC8EAB8D8A70B02B11E4BC77146E45B92E087BD1B0CFB16D7DABD213042EEA0F39DCFD2E06D997E7BB621FF8C776C65491472370C8D0E1C94C76541FE5465DD811A92E6E18F0B19F65884EDCEF7F6289C1E49FCAC8B1F7F3EDE0B8';
wwv_flow_api.g_varchar2_table(35) := 'DB0E5CFC825008B878AB82113C91239A1983BCDD5814F7C71B313DC005B56B6A67760631CD8C7FDCB0BB915D149F6536191C2E07A401720202C00DD412F43551BBBD4F39738BAEF00FAB89C509584DB8F76E683928F15EF80D93F2E250216877957CD380';
wwv_flow_api.g_varchar2_table(36) := 'B668F057D50283C65920725D8B092471553495B0533E5E8C5C37106F30A6ABA992A313DF7CCDB90425EDE29AD9253D48CBAC780BEAA3A0AA233661EF213766496F3DBF8FA4402EFBF2DED36703DA83C1E07D9BB82026D6EC4DE9F15BA96F14F6E2B0B905';
wwv_flow_api.g_varchar2_table(37) := '358E1EB937EE564079041CF92CEC9CDD15B54184E99A6D0549635F82C1DA28B65755EE7CBA7250BE8E9DC6E5AD1620F3536D383032C1CE2DB85FB1E9DF34B23C9EB3C9C2DC867C14547431F9B036FDA2FEF445B42AF70B31A5FD2226E16F7F911C98DA35';
wwv_flow_api.g_varchar2_table(38) := 'BF72735E4E4FB7822F68D5C028E38CB6F85A6FD89B6599BF04D6381CE427B2C3788E43A31C7C17C52A0FF97F884282727D509BB2DEE63DC6502D6E1CD7ECD67AD2397C42003D628D35243D6735A3EF67EF4EAC8180860BF858276D3A8203035A00CC78A7';
wwv_flow_api.g_varchar2_table(39) := 'D54CF06EF3DDA2055AF6BAE653B92CD0D334EADA363883203DD9FBBD1D82EE03C9A673F0902D9734DB9EF4DE90F9CD6F8141CF040E8F21DA13B17AA6C98D91D9005C7B028E9247BC5F135368A11ADCA8628C32501801B03EC5267144EE576FB37FC66064';
wwv_flow_api.g_varchar2_table(40) := '5207483864A5DA234633C4A96AEA1DEB587627127539A69D73413B24ECACBB517300BB9C00536D0A18F59813C9B9FB94BB65CEFA38ADF7B32A6A9A897CE7DC7E081B01D507D1E9DB99779303F049DF92F94CB20077A6E574DEB1F34FB13608D8419B1DED';
wwv_flow_api.g_varchar2_table(41) := 'A358E3EE51D55332C1AD900FF94FFD17F7CB7419BCB79B484658D903C3DE066084FAF00D98CBF6A92A66935758721B8DB358BDAAE6FDA9A1D6C85CA6D2D4BFCD89D967C9546D6A58E42CB9767EA66A7DB771F2517F37FB276D5AB3EBD8760FD5492175B1';
wwv_flow_api.g_varchar2_table(42) := '3CB8F35D14D364C8C9516C8A839B8B5A3DA7F0516CAA765F1173F2B72F728E8E99ADB0819E22FEFF00478C5983CA8E4E92107FBBA0E735BF44EFC151C44478DF139AE3A5EDF921F1C1ABE1FE53FAA7E2C396BC17FC4895FD20880B9BE1713EF0A4AC8584';
wwv_flow_api.g_varchar2_table(43) := '8BE23D89F5B293D5EAF76A8DCDEE7C5678B7B696A243611E5DB9266CBCFAF278051D0D333D4BF7A218C6939342DB9B7E6AB2E820263838E79BFBFB3B106B9CFC2D692E2543B32AE4F5300FDEC943B12DF4B370F55328A899A442FEDF7AC8772C95ECB101';
wwv_flow_api.g_varchar2_table(44) := 'ADFD19A31103CBA695CD7601EB2A6EBBDA1D6D734FAB8D8C734B4E4EEC5F1E830DF32A4AB748CB61C3DC4DFF00045D238DDF23DC7B492AC08DC4A8E9A77FAB6EF4DD9CDF59E4F728A38A220B1A011C54E07484F07663C5649D34718BBDD65B42B04D4D2C';
wwv_flow_api.g_varchar2_table(45) := '111B17B70E22381D543B228DBE782E3DA54704310B471B5BDC376A5103176A7047F24F9E18FCF95A3BCA76D4A2BFD293DC3D1A9DBA9F2DA6C41E46E8189F77F0EF57843475D83C507C672B83E28C4CCBA8BD6DD0C0F94E5A712BE2504582CDB9C20DCA97';
wwv_flow_api.g_varchar2_table(46) := '311BB9B7DCAE2C4A92B69D808C57EC0A6DAAE73181B1DB0F129F573BDD9BEC39058BBD7041B643528A74B13337BDADEF2A6DAD48DB58979EC09FB6A5762C2C681ED214DB46A5C3E94F865EE4E2EE39928007FF00DF468C5983E62966C0706563CD58D961';
wwv_flow_api.g_varchar2_table(47) := '09CD2747909AD70D5D897150D45386000DADCD4F5F4C238C87DC86DAC13F694CF16659A01EF5248F71B17937E6558DF547F0DC4E7DC9BC959D80BF0BAC333604FB94FB6E26DC44C2E3CCE4149B56B242E18C307EEAC66425CE717769BAB8B772F1D51CBF';
wwv_flow_api.g_varchar2_table(48) := '442D6F0430FA2C6313C0F9AA49FA56383B51AAE823B13847726580C2196474405B71B5D58DFB2CAC0EAAE8F7201C4643ACA3D9D2BFCFB33F150D1C11F0C47B7755ECEA0A99CF494D13B111D6B679F6852FC12D9121EAF4B1F0B31FE1C6E87C0AD9B775EA';
wwv_flow_api.g_varchar2_table(49) := '2A3DADFD133E0A6C66646291F97179FF0060A1D87B1A2C9B451788C7FD49BB3F66F0A0A617FF00DA6A77C1BD8AEEB7C4DBFCC47B97FE12D887FC897C1E7F3F4581BABBCA3E431E58E045FDB651C91F46D22F9F8AE9A2BF9DF826B9AE171A793926452BC7';
wwv_flow_api.g_varchar2_table(50) := '51A4A8B67F194F8042289B030B181B6EA9B7E0872DC0DD692467EEA73B0CAF6F0C67F4409C8F36FE9C900315EDE3A9FF00B961761765C110065CFF00BF70409E5ADBF1CD3F5CA0C7E3E8AD6E1681F374B3F46FB3BCD45BD5EAA6E3F588DC57351C12C96C';
wwv_flow_api.g_varchar2_table(51) := '0DCB9A6ECD633017BB15C5FB164D161BA1189B2339B6E3C3782A4376C27F713CDDEE77692A29034D9C2ED58C7A800BF2CBDE81713AFF007F82372EEEFF007432B9B7F7AA0D9B81034BF7DBD1226E278DD6F9BA6A9730E12FB37DC86833BF6EE6D34D27A9';
wwv_flow_api.g_varchar2_table(52) := '6EF54DB3E1BBF1F588613D9756B760572631C81F7AE3B98FC0F6BFB54AC0C7BC76A3A8478271EA47DC7DE9E33DC1C5A7250B8C8FE17433D3428DB0FE5F97795D5E32E1FCFD129C644FCF6CC9E16CA22A8796C67D6E45450C01AD73003C9DAAC4A07B7A50';
wwv_flow_api.g_varchar2_table(53) := '0902E0FB90735D9820F7269EAB9BCFF2DDC5689E4B8466DC2DECDC4222D1B0F3714FB5FC06FA63F2ECF14F2E8A57819669927487011FA23391A01DBE88C6D9A07CFC15F570330472D8775FDEAAAB2ADCCBFC624FE6211188E7993C754C2599309B91AF72';
wwv_flow_api.g_varchar2_table(54) := '66D4DA0DFA2AB9477B9537C25DA51BFAEE130E45B6FE95B3ABE2AFA61330119E170E4423AD937385F966D20FB72DEE3789BF78A92C1DFC2DF76F88DA561FDE0A6BF497F0F664A2386661ED4E6E1738723E87136EF1F3237DBC97B1AF162A485CDEEE68F5';
wwv_flow_api.g_varchar2_table(55) := 'B21DD905738723E28687ECAF828D737669241B3E67382EF5179C7B5A46E287D0B7EF9F7296F887DD6FBB7DECE0AA1B6C7D927F566B2B85536E99D6E39FB7D0E9C752FCFCBBEE1F34FA7199600094E648D7D8B56C7D97FB46A70BEFD137392DEEF151C6C6';
wwv_flow_api.g_varchar2_table(56) := '46D631A1AD68B003805C531D6734F2213F291DCAEB508B47440FEFA770FBAAE4040A2149D6120E71B5DEC453A132B6270FB007B3D0A8367BEA0873B28F9F3EE51414D2533233134B40B5ADA2AED8CE8C1929EEE6F16711E86E6B5C2C402B656D28A8E230';
wwv_flow_api.g_varchar2_table(57) := 'BA2EA1762BB75B950D4C33B6F13C387F7C15D5ACA4CDD7EC1B8FF871FF0030FB91C832FCBF3455D5D3BCF80F38F0FE4B0DD52CCC6C6438F1CBD0766ECD7553B1B87C98FC5060600D02C068150CB1B24C32798EE3CBB54D03E239E9C0ADA3B2DB3DE4885A';
wwv_flow_api.g_varchar2_table(58) := '5FC1C9CD735C5AE162351E48F207CD349041191506D6AC87D7C7F7F354DB76177D3B701E63309DB4286510E0A865F0DAD7B7BF762F9003F7894FCDB1FDDFCFC879F9380F7FBD4A30C8F0799F41D9D446AA6CFCC6F9DFA28D823686B4000290DCEED995AD';
wwv_flow_api.g_varchar2_table(59) := '959F169B3FB37F72A8A6311B8CDAB696CD6D4B71B32947E3DE9CD735C5AE162351E40F26FF003B1D655476C13BC01C2F921B76B83403D19EF087C21A8C203E161B72B8FD537E108F5E9C8EE721F08293D68DE3D89FF0928F846F527C2984C6C6B699D76D';
wwv_flow_api.g_varchar2_table(60) := 'FD6E6A5F8573BCDDB4AC197175FF00447E10ED3FB6C1FC23E7F3BAA0A514D0319C78F7A91D9D86E7970CC263B88E0B67D7B6A59D14BE7FF52A9A6313AE3CD2B6AECEE99A6689BF28351F687A197346A574B1FDA46A19DABE307ECAE9DE8C8F3EB2249F44';
wwv_flow_api.g_varchar2_table(61) := 'D8F4FD356309F359D629C6CDF20E28CDC689AE3D5734E60AA2AF8EA5BD0CD6C7FD4AA2030BEDC0E856DAA1C0EF8C463AA7CFEFE7F32771206A574AC1EB2E9DBC8A3507ECAE9DFD88CB21F595EFAFA5EC4A7E8E9B1919C86FE0A43981BF8A3A2B6039689A';
wwv_flow_api.g_varchar2_table(62) := 'EE20A8368B656743527EEC9FAA9630EC6C78B83915530182A248BEC9FC37920715D3339A350CE457C6393519DFD88CAF3EB2CFEA1A681D3CCC8C71298D11B0346802EDF20A2E5A1B84D7DFBD4B5C2923C6E765CB9F72AADA1354CCE95C1A2FC39232C87D';
wwv_flow_api.g_varchar2_table(63) := '645CE3A93E9CD04AC164FC8DBE6363509859D2C8DEBBB4EC0A43E417045D7DC1544D0C11E390F70E2554D549532627F80E5F50B7CD5F0620A67C533CC6D32B5FA9E02CB6E6CC7543259D91DA48FF00F91BFEDE5ECDD9B7C334C32F55BF9958C0089DCE78';
wwv_flow_api.g_varchar2_table(64) := 'E08B89F22AAB21A51D7CDFC18154544951217BCF70E5F5130D8AF8333427A48BA16891ADBE31A96DF42AB7A5E865E8B27961C2791F2B66ECCD26987DD67EBBC9B045D75C5714EB34627100732A6DA7491E40979FDDD14FB5EA1F94768C766BED449399D7';
wwv_flow_api.g_varchar2_table(65) := 'EA4F82B27CBD4B2C2E580DFB97C21AFAF6563E0E98B63C22C1B96BE44347553FD140F7F68192A0D93D19E9270310D1BA81BCBAC892573524B0C2DC52BC347BD4FB66437103708E6732A496594DE47B9C7B4FD4D47F02A97A26BAAA794BC8176B6CD03B38';
wwv_flow_api.g_varchar2_table(66) := 'AA4F83DB3E88B9F4ED70796DB139D74763D0CE4BAA6998F7E809E4BF616C7FFC841FCABF62EC8FFD3E9FFE984CA4A589EFE8E9E26758F9AD01555562EA4672E2779C822493BAAEB594ADFB521D072EF52CB24CF2F7BAE7EA7D834C2AB6BD1C674C788FF0';
wwv_flow_api.g_varchar2_table(67) := '75BC991E5A4E792A9AA2F7BDAD3D52E3E3BEF609C6FBAB6B9B4CDC2DCE43C3977A739CE71738DC939FD51F035A0ED8BFD981E47E0139CD68249C82654364D3240D8A240049392AE860976ACF563AD888C3D966DB7B8D91249415757B69C6161BCBFD29CE';
wwv_flow_api.g_varchar2_table(68) := '738924DC9D4FD53F072AD94BB5E99EF3663AEC3FC4AB1F778670199EFDCCA8E0EF6ADA15D24A4C6DBB59FD5BF0BDC70B45CA735D8CB7537B234F335989CC205F8AAFAFF8BDE366725B5FB28924DC9CFEABD91B76F829EA8E7A324FC8A0F2814E6B5C2C45';
wwv_flow_api.g_varchar2_table(69) := 'C234701E0478A143003C4F8A0C6B5A43459470C7179A33E2752BE116D130323859E7BBAD7FB23444926E4DCFD594AD2F9E368D6EA8647C11863CE21EEEE4C7B5F9B1D758CAC6562714E7E1F38D9566DDA3A6C4D6BBA4907AADFCCAA9A996A667CD29BB9C';
wwv_flow_api.g_varchar2_table(70) := '7EAC646F91ED6305DC7454142CA56E79C8753FA6F33C8347BBDABA79BFD57FB56391DABDC7C56D1DA182F0C2EEB7ACFE5D83EAD8E292578631B77154344CA567379D4FE9BDCEE017056BADA358E89A238BD6D5FF0090FAB618649A40C636E55251B29996';
wwv_flow_api.g_varchar2_table(71) := '19B8F9CEE7BCBB76153548F3233DE555C67A0BF237FAB692923A68835BAF1773DDC138EE02EA7AF8E573A188E5C5DCFB94200B852B7144F1FBA7C92F68761273B2B83A1FA9E96713D3B1FCC67DFB9F7D1141AB6A567C988E37754EBDAA17619587B537CE';
wwv_flow_api.g_varchar2_table(72) := '1B9C30B9C391B791559CDE09A0CA475C921A33BE8069F53ECDADE824C2FF00A377E05020E60E49DA2C20024A9AA0CB76B3CCE7CD57E5D10EFDCD370D77300EEA8169A4FBC54AE7B0878F378840820109F261D354F3771CD51F9AFEFF009F3AEE3C3D18F2';
wwv_flow_api.g_varchar2_table(73) := 'E2A96BE5A5B37CE67D93F928B69D23ED771693C0855155D38B32E19EF51F9AAB5989EDEE458E1A8511F9267721A2ACFF0010FF000F729ADD13EFC944EB53B4A91E4923DBBA8BD7F0F2190E36DC393A02D1E704D6B8E88C6FFB27CB033473405CA399F460';
wwv_flow_api.g_varchar2_table(74) := '32C85EE9B1F13AA0D013075421A053FD21DCC1D56D82CF92ACFF0010EF0556EB476E6549D48D839377D047763CF6AE8C2E882E8DAA3B353ECE298DEB0453D8D902736C6C5595B78D770E27B10CCFA365BC46EB3567CD3CDDEE3DBBA4DAB53148E637059A';
wwv_flow_api.g_varchar2_table(75) := '6D985057CB237D5C4355212F7623AAAD88BA2B8F54A9A7123473C36549074CF37F346AA929D920971B731A2D9FF427EF21B88DF18CD49A28F44F8C3876A22C6DBEC86A8642E8E4D02DDA8684FA43DD858E77204A66D0ACC42F3B94552646DC38F6EF9219';
wwv_flow_api.g_varchar2_table(76) := '249A7B0D092A299D1B828EB22764E201DCFA2A771BDADDC99471B1D76B9E3C54030544ED20F58DC28637472CBD5EAB8DC143C960B35487ACA3D373D98BBD116CB78D1DDC88EB5B8279CD683FBE2B82B65E88F381E5AEF040F253466489CC0EB5D7ECEF93';
wwv_flow_api.g_varchar2_table(77) := '2315DF7C8A8A0AC8CDEDF8A8DD291D78EC7B0E5BE46C7A9637D8BE4BEC37F942C6D0326D9749D8BA52B1BB9AB9E6A1D09DF20B85750C85C2C7822E372A31D4CD74A3181BA48F10CB556B6E1A78A1A15605DD89CB92D4FA255C78981C351EE40D9099DC73';
wwv_flow_api.g_varchar2_table(78) := '4266A0F673F226D06FB12844E4211C4AE8D9C90CBC891B67263B0B8142205D8AF9299FEA8437CACC42E35DC167F9A6AD4E68E79712B9DBD108C4083C53859C479389DCCAC6FE68B9C7529DF928D8D22E7E667F57753936239276A5463AE3C899A323BB83';
wwv_flow_api.g_varchar2_table(79) := 'BBEC8E5FCA13743DE10E2573FBBE89FFC4002910010002010304020301010003010000000100112110314120516171819130A1B1C1D140E1F0F1FFDA0008010100013F10E7FF0028B56F8B9DAD6E89E26D13E4420AE3395058B8D792D615BB597506F0DD';
wwv_flow_api.g_varchar2_table(80) := 'DFE897B561CB79312F6C1474FE4AB952A76D03D559951BDA70DB01B3776975776768B0D5C208BBF17106963810D2089895B68ABE0FE4E0C477DBDCB2C5956C50623783ADE8AD09738FC7B6AC2D9BBF6ADEDB9411EF0C98190BB9B70DA20406D087EA065B';
wwv_flow_api.g_varchar2_table(81) := 'AF365BD5240066D71FED057ADE0BC26E8A7758D24B88605B195BC7EC5C06CC7199593F51D163CC68222B02B2A3B52E1AA1B281FF00526F23CD313A57A512FB2DE403F84B85CF75B94DC24888D8F329F8C9B43156E7341A7963D38F88FED6421D2E978D2F';
wwv_flow_api.g_varchar2_table(82) := '574E3A184B7A2F392FD11FD7FEE29246E22C868CAA2CD52C4BB31508BE3B457D2CBB15F9606C7E0285FA816C2E545B59AF3000AAFE839F995B0E15F927F37F226560137CB5117D21FF0052E5B16AD6E559AFA55CAD731BB163654A172C6F8EDDE59046E8';
wwv_flow_api.g_varchar2_table(83) := '8D27BAA598CE18A812C3E37946ED25C3A87D1535410250FE53FC9C75BD27E404376109C152A246C6AEEAC29E228AA2BC897030180A29C328BE17D31551456DC97E7EBF6A85B35D0417BB6A632D913D92DF0397F8A969642DCCEAB54C659B46082ECDAE5D';
wwv_flow_api.g_varchar2_table(84) := '3B7D448E5527198508C67EF4A6E448C6687F728A2F232A965618E09B2E8F131DB4ACA6D35B956828E6511224EF5BB0000AF884AEB357A0FC37256DFD68F2F474EE8BDA8650D64780F0DA5E09B575BB512864003B2F981AB95EF1F88B2DE0C5583F5D0CA8';
wwv_flow_api.g_varchar2_table(85) := '64D2E60754A52C046BE1A08CADE6F076768EC0DA1F3C961F544C894BAABEF15DB81B115028898401D9FB95555C84B85B6B91DAE24BB40AFD11337545FA9E353FF23C9A18A071FD4333326EDB5C7AAEB6013EE520F402FBAF7604BAD7DD00978EEA105061';
wwv_flow_api.g_varchar2_table(86) := '54597E56258BB0E454B06A038D28E273B0483FFA4C0B050B62AEE5B5DC7EA2587C5C4A1F112512E2B2895976C65F70BDA0E5E2F5DE0E08E6C23A3A3D4F473A3F8148DD6011B054C5CBDEE8421C88953996E056FC5A426545C28FEE8A69BB729B87B9AFF1';
wwv_flow_api.g_varchar2_table(87) := '9762676D38AED36C26D700155CDEFB6208DE8077263462965C532E195B0C05EEC12BB5E65016A25A525834BB95C2D2E0397D12C156C39DCB03B10522A076E128238214A7438A23077305F92AE1EA4214128AD932C31B179DC7E27F328F011953C141FA88';
wwv_flow_api.g_varchar2_table(88) := 'D03ED1A570DEB9DA31DDD55E4885A55DB2A9E495603FD18CDD6E094F7808B51B7100BF2DE8CC5DC63D8E1898317B97C416B83170051773131C1575416CBB452250D9DE986A2BA3477B6B76003C6B7167DC51DE67022D9BC5D5009062B206018D9B23B6F7';
wwv_flow_api.g_varchar2_table(89) := '82E98866263962D0047E474B97165F5D6DEF93D0694B0CE557EE5A1CF6A24A13D921E399625C5DA1B805FB6599CE1430224F707F0D43B31D9124A767D82660FB188087404DFD88DE28F457F6E19D6D4DDFF9506A2940AFD04C486BC6445608E0B62EC758';
wwv_flow_api.g_varchar2_table(90) := '460FC152A29F7F30428E46157B0DD4288295E65615C90E6D42A2CEEDBCC1E2E187E37A6E5F42D76EE99A838D137FB62C9BFA1802A8B1F0418155F47C843A338085F5434CD97294577BDBF82E3213DB235ED9B697CB5FC815E1102E953996AECD8FD89919';
wwv_flow_api.g_varchar2_table(91) := '5713A2AD436E1EC4CF42F0B8FA272F6E0D1FF6265CF2778160BE2AE22B7BA8E8FA990841405750D778D4096F52B4C9FB8CB11DAED43B3537AC82ADC1DF018968B082A8B98E9C7E1BD6BF0228301469788EC43688094EE71BC1A658E512FF00084B916FE6';
wwv_flow_api.g_varchar2_table(92) := '31685E2D177DAE070F25443CA5840B1C544225975C58AF91C8C1DE6F4FF9D29939EB978688E682B735FA9696A3D8232A15C425668EF373774C0413B1360211558594A51CB719E928B418F360CA0CC6D6F9EC90DD0725835F10FD40DD952EEEB3C469A3B0';
wwv_flow_api.g_varchar2_table(93) := 'B0DAFBA6C4232F052F83C20EDDC56D0A62CC19E17F76FCB5F8ABFCD5BF3A13886C4B461D9DB549CF711B363E1FFB8A18159D8AE2CC15541ECF8FAC565478168B8EF5817D0510E1E26CFB8917B6AFFD25EC8BDD6EC409BDCFE4B85A84409299717EE31835';
wwv_flow_api.g_varchar2_table(94) := '5B1FEC6044EEEDDFEB682EAA5BB0010039B18ABBEDDBB20652015963D6DD5CE2CF8DE5DBE0146BF6CBF6ABBDD7D1064CA2E369404305587780601661F99960B5F0CBFCAC23A54AD57BA309C69B1A33102973DE344829838A25E786D88E1BA1458A0278AB';
wwv_flow_api.g_varchar2_table(95) := 'B4AC11B1B17DA91E541C67D2C6E2A055510014657A3083781EC94058EC68FB62B5AB373679650A603D5944B18BA23319AC0EFF005185ADB418E85EF52BEDEDAD07C0474052B10CE32ADB386B6815B2B150403B1B44E37E1B429131D8CAF866F9E42A7E66';
wwv_flow_api.g_varchar2_table(96) := '5F4EFA7F2CD0E8639FB80F8832B99BA8A970DC7021A9C6C807132C01BCD622A00E621550386AD93621BB9372E587B189F38C6C08073104D8ECDC007455F6A5D982261ADB3045AB62572B9816CA57899159B0B945AED315137FCF72B38C9503EAE134EF70';
wwv_flow_api.g_varchar2_table(97) := 'FDB516C74E57C063F36EACE4EDB23BB865F795835A5BF0FE687E47A0AE8A7772DF986D39D2F5B8ABB8EF68E01F24501285DEE55FC483FD9737FB015F52B75FC4C3F6DA0C0DEB7B0C30492B9648BF7DA92A0766D1D14B165805DBBC030D96C732C2EFA890';
wwv_flow_api.g_varchar2_table(98) := '98ECA5084AAD57FF00030168DD52A93CE58F11D5ABD7CC5525ADAAB3E1FECBAEE77396BFEC6A51DB1C283BB2D4DB8C3DB9B98722C3FF0005D09D92BCFA25950C11D884ACCC1A666D3B1A8F21E6656C17408C483E8026551ABA81F096866042E544A4C078';
wwv_flow_api.g_varchar2_table(99) := '8DCA16902DFBAF70ADDA69CC362B6C016DC22C05DF731017177CFF005B40A00E0A967E6D52E372863D49E5580E5B62AF4CAE3FEC8D8D6E2DFC9222DECA1B5F0DD66CAF983087C99096686E9C5BB2C2915DD9BB3E0C7EFA5F45DBF95D317C508372B552F2';
wwv_flow_api.g_varchar2_table(100) := '45CCE2384384158F640354366F0935460BB4434B7DD366647E6253F33E1CEF3709BC563A7C7EDA808596B2D8FB96148D6A5E53055D8DE0B0C401AF396855EDF1769FA8AB2DA3653716F677B81C1BEE10F9CBE88AE5168B6C5BF797F44246E307BA2BBFD1';
wwv_flow_api.g_varchar2_table(101) := '101BD493B35FF4128BC0EEEC383E4CE875D7E26713F7C6841CBAE2512CD3BC32B5778ECF7963105D25E480AA9171427F599AF3156F2ADA39997396560972F46A15BAAA62081D8DA3C3F737FEF05BDE732AF1C40AC796070371B90AFE948798CD0F6CAD36';
wwv_flow_api.g_varchar2_table(102) := '3641AF5703303C803E5C3E01993AAAE46BF60957695C92B81FAB942DB1C355547F0011F65700506C7E7AD0D2E203832C0DE1A398C4B20686F3986821CBCD5DA0DF22A2C8E0082D29A08764900E0095A060E08F2D597F7AFD40CA205B51BB670E4E60136C';
wwv_flow_api.g_varchar2_table(103) := '8F4E49F026F50DF197D28A78E1810F29F3C7F25100516C0B7D28B1A5C0D8437CF6A2FE0A9D925610DB96FF00D12F715AD317936BEAF6E83A1E9BE83553BD6BE087473A5DB1D1B9537952F87D473FFA980004BB3EC3295708082B6D61834395CAFF009281';
wwv_flow_api.g_varchar2_table(104) := '0A81B38B7FC5D06914CA297181B2D7BB2D92D6F88886D47F5362379FF430B8CABDA3F51DD4398722D90CE8B4D0615175E228D9BCA4E7F780D38FC9C68747878D2B4DA6FA3BCDD3444D43172A2253B748A7AA352F43EF45AF8972A51BB75F75DE3450328D';
wwv_flow_api.g_varchar2_table(105) := '6160523EDA70AD53E152A51AEA1497C3190FA4E79C5F31AC056C043F64CD1E62854406E0FF00612AAB0BFCB153042EB4AACF5D9F937F8215B71B5ECE25EBCA7D75BABAD75178F9FAD497A1B4F8899D1799777A28868DC425BF26E4BABAC766F325BB027B';
wwv_flow_api.g_varchar2_table(106) := '9DABBC510A2A94E0E598B5D5931BDC1BEB5FB5058C4C8D2328CFDCA98FDCC621A6EB1062C6E7C5201DBB8FA40A3332188348ECDCA8AF71F804146DF984B8B281F4BFC944E3535A5232BF4748EF0AD19AD0E97537972F24C40D3168B0361B57193E25B8DF';
wwv_flow_api.g_varchar2_table(107) := '1B532D5CD0DDBC5FBB83A487501802A6D035F76ABD42D42ACAF5380602BE6C5F8A18ED46F43EB13209CCDCF72CA6E268ED3BE92F74CEE353DA4868F4D474AE837D4DB4DCF2F18A105EC7D3B339801B9EAEFD15894C0BCE85C768151CB3302E14CAC4C541';
wwv_flow_api.g_varchar2_table(108) := 'B21199CEC9645FC27E50B185B9F01C9ED648D9841DC2F3F7553036CCCE238A76FDA6F8655C101529E0DF6B8B25BA86DEC7F0FCD468C08A3E27C48104940501D89CA7692D5F881D5B6E1D9879845A6DEDF3110A110A448537A6F30139751F106981CB185D';
wwv_flow_api.g_varchar2_table(109) := 'E8EE4C44CD0C88D24C150F6B57E7787A2F685E5A0D58ACDDDCA44A1A08916E4F88842796FF00A8DE6AE055C0B1A8D9D9377A53B0CABD392586C7E6BD2B46AA56D77B087402802820609676855ED54F91FE897E1570F6F0C446030EC1388552A44DC4D2B3';
wwv_flow_api.g_varchar2_table(110) := '18B5425C21DE7138957332F4A2106F50C6C65B4F871086A5BB5B6FD245298D0BDD5798FDD4BBFA10A215C6FF00F486DEF7D88D469B8031720D4CDB4ABC108542763FDAE10FCA0800AAD0463175B7E5BCCA4C732F328431CC651D15B9B89311F1E7632A4A';
wwv_flow_api.g_varchar2_table(111) := 'ED3DBC3031878383FD26799712FA1DF4A86F1824B950E7566CE9F3336C81702F88F10F962BC87C45AD5F18885AAC197F9584B86882BFA9C12ED3D10DE56225A8C1C90E497952C08D224AD8115E3FE18955B9BBC4B1AAB89C2FF5D0E95CC4BDA5686E6CC1';
wwv_flow_api.g_varchar2_table(112) := 'ED995622768916140F9B8BF67A209568A5695EB7FF0012EEBD47AE086F610342D822AC97BB37C4372046FC93130FD0F12308243846329BD97BA2CD6DAC111727E202E922EF07CB15B03E20795F188AB75D3986BCE84E7A9D2FAEF474673D1B8FE67B1BAC';
wwv_flow_api.g_varchar2_table(113) := '3982907608E554BC4369514004DFC41762BE2180610D3E3BEDDA18C15A1740289CA26E8BDBA91DF434A8E970753AAA67522746CB114B6E06E089B895AD43A1DD43C1DE3495CB2EDA8F8C4E277151F64B96331B3078377B12E960C1EC3A6A3A1F81D07A9B';
wwv_flow_api.g_varchar2_table(114) := 'E8E7A6EBA81D9F456BE1531247688A065F7A0E9754FB9F77B4117F4475577629BC001932D0BF897A191806D8AD99F6F625999DB80763F03D17A3F98EAA4BD98E9A8122D65E86564DA5B5B18732EF32F4BD3ECB4FEE85A998896BDA6083F896C05BA012DB';
wwv_flow_api.g_varchar2_table(115) := 'B342ADED81D5F25F7445454DABBABA6743A5D6A1D2CE3A5D2BF0308352ABADC1527EE065B7DD414DBA1A6DFDB5B47B76956B36F9E43562C596C0B5C7A6D1DA105EFE84405F7EFF00843255B2CD47ADD0D4D4D6A1A1ADF41ADF45CA540155C04B993AC8BB';
wwv_flow_api.g_varchar2_table(116) := 'E445F0A9458BBAA84DF564B1C901FF0062C0F69A9F50234A7C12BA8DE1F3E0F106C98CC669C05A954285E1F28704FCBC1D8EB3A1DBAB8D38D4E97A9E9B9B31FE3069F35D284D416DEC4BA424A797F20D5902264B6574AA01ACE1E70EE1453CAFE1AD2F56';
wwv_flow_api.g_varchar2_table(117) := '26951DA1B68697AB2E331F831AAE5BFD8206D8DC61281F0774D206A00B576022ECA0DCAA934F750C9A08DFD4B433BA233371B83BBE7B110B2151B55E5EA368F48EB8D0BD1D0DBA0D1E93425E63094EB63389F5A3E2E53EE1F95B41AA466D7D28571F7129';
wwv_flow_api.g_varchar2_table(118) := 'A72F89BE439834DC005BF042270AC3393B436E54E0DFA82162E436BFFB15214DAB95630D6FA79D4DBF1B08C19BEB8D6A5E9538D6B472AD29BD828FFAC26F92025928CFB09736EF57FEAE5E13C4E1FA8798BD883E316E964E4EBEE060D444846D5CAAF3A3';
wwv_flow_api.g_varchar2_table(119) := 'AEF1E83F01AD695AE34347474BE823D0C1955601177FBB3E36E21947B8373D903DC23C6138DFA238B13E7117631B807B4733106B60E00EC7E3A9B74574F1D0FE63A598B6813618BFFAE07350DAF98957DA4C6D77B7C59561DD329D8EC27FFD1A710E9B86';
wwv_flow_api.g_varchar2_table(120) := '97A66710D0D1D73A3F85D495A731D71A39ECCAEC44DC7FFD7E1172C378F564605B063919281C06FA8435E353A6BF071D35F858CE3A2E32C546C3B1E5F11B7D985FF2711432B2DD983DC8A5C440DEBB0FF84B5B6DFC368FE27A874AD0E8E7A6E5E8CA95D1';
wwv_flow_api.g_varchar2_table(121) := 'C750C02CDACA88012E2F40D882DC5476378CD683576F11476F0ABF7A3463A0C09929ED0B88278D58745F5BF81D4E9AE9E3538FF8061816C470FB809736B44657088CE04F0CD1F4E2584F312E79D4FA6868CA2F604B8822BEC000F06AF4F3D15F9CE8357A';
wwv_flow_api.g_varchar2_table(122) := '6E9297E8E7D77810051627332A41A78AB5EC4570CB4F38221385A2ADBFD8173894F7B9F6DC6D2C63FDE2A16259F308565FC4B1E56EFDE12CE69D55A5695ABA0C8ED8FAC6840354D5FDF49F81FC215A996FE0ED0607FF00A2D7105A8DBEFE9706DAC7A670';
wwv_flow_api.g_varchar2_table(123) := 'F94C35A49BDD8EE6D2E4EC4FAC4787A9FF00DDE128F231D8CA0D7DC303EDDDD160F9D5B410F74AD9960C1E62A945F7502D3F11713A910776A2B2F76551DD22B10A176E9C755CBD6F5AD1D2B591FB7FE88F6AFF00C4DAC95FAE1AF546BE3086D2AAEAAA85';
wwv_flow_api.g_varchar2_table(124) := '40AD57797F257F1104327EC47DD6B6CAD543E08492F50E696D0D99EACDA0954A05AC108975862B053A15DA5697AD719FACC2625DB7DAF10D045B56A85C1D15A1A73D4F45C740014634A84A12A8B2BC4A3C3EA668DD6803DA8B1665E9D8045F5FA6085733';
wwv_flow_api.g_varchar2_table(125) := '63EB98AAE2B479183C037E57B10991A4C9298F1F67FC26E34A3449627B11503BCDDF73B4B83119149A5118B1F07F90646EED3CD4DA63F08F999AE97ACD1EA2B5FF00F2EC2E6CA132FED85E4754E7782DE9AA2320A262FC76654D17CB87E658836545763E';
wwv_flow_api.g_varchar2_table(126) := '454418F8EC22D5017A6B977839C284C78A9BD84A18D0D59389BC1BCC8F12AB6F9D0C9581B31128A475AD3DC07D8CB40D8D5F83765831C5D7BCC4A6CD8FDFFEB2F679985DDDDB4A874B9FC9B70E5708C14B432E9135751A98A068A2BB40605ED60DBC8C39';
wwv_flow_api.g_varchar2_table(127) := '577818BD0B4E2BBD1655EF340A22F40252BBFBC78422F0BEE985ECAC34E667F920CD98C1B3FB11F9F99517739970722D5E817095244A743BBC1FA21C94ED47CC56AC27F50B8C1DDAF31365F16C71F07F0E925F5DE7AD4D7761958A421810932231060FDD';
wwv_flow_api.g_varchar2_table(128) := '411DA9357F7EA6C058BDE89CB18071FEC00A0AE8B30D9C914DE37F51150B6C2395F3448951BD30861FB948D244DFC30A18E0B7F094E533BFA32C37F936C0528596F8B89589A6EAFB69531A3378FE51D9429F98646C308E8403FED3CD989B2A004A387F25';
wwv_flow_api.g_varchar2_table(129) := '44B6E001803F06CF968E76C8AF9895DDEE126FB96E8B895395699DFD31FD0F8661C83FFD29833783E32C57DEA7F788070D87EFA587E33675FFC4003511000103020404030704010500000000000100020304111221314105103051203271131415224261';
wwv_flow_api.g_varchar2_table(130) := '9140525381432325336292FFDA0008010201013F00EA1558E79A8734393EC2DE88138B10B0FB2246B60AD9733A2F6B1B757846AE01F55D3ABDBB34AF7FFF00A2807B7178C12BDC67EC3F28751CAB2DEF0FBF6089F92C16A7CBF844B13AAA06820B85EE9D';
wwv_flow_api.g_varchar2_table(131) := '5CDFA5A53AAA676E02748F76AE27C3C1DB209C917C387E65FDF549CD56FCB5275B594B3B18CBDDC493D93EAA42CB88DC3EE9CF739B9BF11B77D3C2072D15251C952EC810DDDCA08190B031815BEDD43A72E33ED1B24645F096E764E2D2461047A9BAF664';
wwv_flow_api.g_varchar2_table(132) := '0377374EEAC08B978F4F00E4CA795DA30A641047674AF073F2A3C56962686C6D245B6160A4E3531BE08DA3D735F16ACFDC3F1D0BF81E79717843E9C3ED9B4FA6A87CF91B59BE80A7875C07385AFDEEA38E570706B411DEC994321F31017B8301CDC4A14B';
wwv_flow_api.g_varchar2_table(133) := '4EDF376DCA73A919E56DD3AA6DE4606A74D2BB57945470CAFF00246E3E8143C2277D8BC860FC95F0683F91DD43AF29636C91BD8E1910A48DC1EE6900169B6B65052B01C520DB217585B84E116013EAA28CEB7F452D6C8FF2D9A8B9CE3992536191DA34A6';
wwv_flow_api.g_varchar2_table(134) := 'D13CEAE0A1E13106E295C57FB553ECC27FF4549C658DCA287F392978955C9F5E11D82F6F3FF2BBF3D326C3C1C5E06B6664A186CED481B84FAA96D94761DEC9F3BDC0012B88DC68135AE738003351D01D5EEFE820D822EC13EAE204DB346B64CB0D8292A2';
wwv_flow_api.g_varchar2_table(135) := '793CF212835CE360095170EAB93FC647DCE4A2E0C7FC920F40BE0F4FDDC8749E7C13C2D9E2731C3552426295F1CA5C083B0BA712061CADB1B0BA866744E2400A4AB95FBDB2D91713A941474D23F6B7DCA828E9DB9C80B9472D2462CD606FF48D745B0285';
wwv_flow_api.g_varchar2_table(136) := '7C7BB4AF7E87EFD3273F0F13A2F6F1E368389BA8EE1384763604107426FC9AD7388001254746ED5F928E18D9935A344DD534E49C2E5580E563D1D91391F1F12E1A65FF00521003B71DD4745FBDC9B1318C185B656451DD0BDCADD5839D644106CAFD2774';
wwv_flow_api.g_varchar2_table(137) := '3D94772700BFA2B0EC8C71BB56852801EE034BF2EE11BDCABDAC9E2C75463173D1240172B1827A254C1E18700B94E0413706EB6437F445020EAA404A059617E812004E79715239EC38866370A395AE6820E5D2746C7E4E6829F4511BD8909D4520F29053';
wwv_flow_api.g_varchar2_table(138) := 'A927BF97642967FE32851D41FA3B6EBE1D3FEE674267676E6E6BA2763679770A3903803B78AC5612B09585610B0856E912113724F818C00FCBBEC834D85D605842B056EA54C8E8E3BB7550D593500484F8257DF21CAFC80248B28E30DCF7FD0BDA1ED2D2';
wwv_flow_api.g_varchar2_table(139) := '3221369DE6AB06408CF3E45CD1992027C9B05745358E721081AA0D68D3C63A75F50F8DCD6B0DB746490BF1979C5DD09663F5BBF2A9E9CF9E4D761CE38EF99D10FD2712044C09D2CB102A9212C188EA422401725636DC0C43351C77CCFE92DCAA6164B190';
wwv_flow_api.g_varchar2_table(140) := 'E1B6454B4CF8F6F429AF959E57108BE67917712A8A96474A2490100697DD0F11E63A9B2924BE434E581BFB428626DAF97E9E490BB21A72D5484B72548EBB08FBF2B857F19EAC8CC27EDCA37032B5A15537CA551F99C81CECA678B59442CD07BF42DD4F67';
wwv_flow_api.g_varchar2_table(141) := '8F2B2AA80451837372570F663A83F66AAE8F031A477549FF0029F44F759C4F61CA18DC636A30BC6A84430A14E484F89CD563CB6E47A62CB89E622687775C3E90C25CF2E0EC432B2E22DC4C6002F9AA6308CB080E5340E71BB48CD320C25989A352A9C1C2';
wwv_flow_api.g_varchar2_table(142) := 'D69D8A7B4382D090B46275881E888B2B045AB73D03E07C858EB1192708253776B650B047E590DBB6CB19531F9CE416376C83657264443AE4F29868E4D7970B5CA2ECC7222DC880422DE9D4FD3CC13DD3943A730A5F2151F997D43D793B4416E10E9FFFC4';
wwv_flow_api.g_varchar2_table(143) := '00361100010302050204040405050000000000010002031121041012314105202230517113146181063252911633404353152392A1B1FFDA0008010301013F00F2867876B0441C5BCD8D2A99535DB7FBA205286A50041DECAB950202E9F849A41A9B1B8F';
wwv_flow_api.g_varchar2_table(144) := 'D937A5635C2A6303DCA8FA4C8000F900B71747A4DAD2FF00D2C4B7E5491290DF4FAAF9FC3FA9438F302C313F042D20BB9D96DBBBF75479FADD330389790430D29B9B28FA538805F20FA80A1E9F8606ED2EF74C862633C11B47D938A0FE151114155D7DD0';
wwv_flow_api.g_varchar2_table(145) := '9C2B43A9AB5785507E908674F278585BC206EB0B829E77D28C6803937FD945D3626BE8E95AEFA26C51B1FE18F4807D05F31BD917109D53954AC7751870AD3A8D5DC3562712FC44A6491DEC3D15479DD019877B250E0D32070D25D74CF88D69D65AEF6144';
wwv_flow_api.g_varchar2_table(146) := 'EC4EA3663ED63655A51A2376F77708E4C37DE88B85689DA395262B0CCAD6406FB0BA93158A9AAD8222052CEA21D071D3B8BE57806B724D4A8BF0D61C006495EEF6B2FF0040E9BFA1DFBAE7BEBD832E838931628B2B678DA95B85239B1925BAF53BDDC135';
wwv_flow_api.g_varchar2_table(147) := 'CC3A8B586A45C529553CD030B5CF796BADE1D4A4EA9137F2B4B91EAB29FCAC68BFBAF9EC63FF0026F5E028E3EA12D35485A8602A0192573CA8F0D034F86300D5114164EC4C10DE491A3DCAC57E22C2B052205E7F60BF89315FE167914EC194133A196391';
wwv_flow_api.g_varchar2_table(148) := 'B62D354266981AF0F73B58A834AFFE2C5750948D1113BDDD444BCBBC46A4FD14580C44A3F2E91EA543D32165DE4B8FEC106B1828D68011C4E1E31E278AA7F558C598C27DECA7EBF882ED30B1BBEFBAAF5CC5F2F6B7FE2143F87657F8A79EFC817AAC3F45';
wwv_flow_api.g_varchar2_table(149) := 'C045FDAD67D5D75F290710474F61DE7B46457449DD261A584BEED1E1A9A50151F4E82D59753ABB02A1C2C4D35F82C0783B94F91AC612E34014DD546D137EE51931588B788FB287A6E21DBD1A99D32103FDCABABF651E130B0FF2A268A0F4BA25AD697388';
wwv_flow_api.g_varchar2_table(150) := '028A5EB1818379838D366DD4DF895BFD983EEE5FC478CFF1C7FB797C22AF6CB0D8892099B234904151E27E3C2C9620D208E4D13181CED7535E454D16270CC9DA039C6C543D3F0ECDC6A3C12A803406856001254F8FC3B0100EA3E81627A8E29E29096B2D';
wwv_flow_api.g_varchar2_table(151) := 'EE54DF39293F12573BDCA1867F2423867FA85F2CFF0051E60C8EF974AC7FCBC9F0DE7C2E3634D8A064A8A90E046E0532739AC1573800A5EA4C6DA31A94D89965BB9C695D86D9385084E6595FCA390400EEE97D53E09D13125B4B1F452F53E2267DCA7CEF';
wwv_flow_api.g_varchar2_table(152) := '91E75BEAAB99A5970139A28518CEE365A1DE9E45F20330B9540A8504F2F76CF364750374D9646ECF2A124C6C2EDC85C95E8570170536ED4D758779CC1CEF91DD02AF9101CA28DBF106A3E14D20814228B9FB23C208A8EC151DE4F0994362AED3428640D9';
wwv_flow_api.g_varchar2_table(153) := '1408CB85B64D7B9BB3884DC4C8295BA18969A541DD0C4C5FAB95F1E2FD417CC436F17AAF9C8BD1DE5821E28775706850C9CA990250A2A844AA9C8F967308BAA2E81B2AAA9553DA3208E74CA1607BE876A29610223A1A3B494151143B6BD832DBB98F2D78';
wwv_flow_api.g_varchar2_table(154) := '213A6688B55FD2D9004EC1155FE84674CA26035256CDD36A2D2DF40A7C40A6866DC94153FA3A65EAB0CDD564F888D94CFA9D20200941AEBD8DBFA5A7D728A4731E0851CF1C9B1BA732376ED053638D9B3405889581858DA54A1E48CAD98EDE33250283DF';
wwv_flow_api.g_varchar2_table(155) := 'EA578B9AE43C83DE7B8E41411027515896D1C3EA3B78C8F915CE9DA72111111715873B858B1E169C827795543C8AE50005EB106912C39F11589FE58F75C209CE155A82A828B8217543E4D555572E3381E185C482B11309000011750B8B49354F74877712';
wwv_flow_api.g_varchar2_table(156) := '135DEA8BAB5A276EAE82DCA16281A854088EF191EDA908DF75A420A815B305020200640845101114EC3DED5C79032E3ED90DC23E5F197FFFD9';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784239228981151252)
,p_file_name=>'img/analyze.jpg'
,p_mime_type=>'image/jpeg'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/img_best_in_class_jpg
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := 'FFD8FFE000104A46494600010100000100010000FFDB008400060606060706070808070A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA70106060606070607080807';
wwv_flow_api.g_varchar2_table(2) := '0A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA7FFC200110801A401A403012200021101031101FFC4001C0000020203010100000000000000000000000102030405';
wwv_flow_api.g_varchar2_table(3) := '060708FFDA0008010100000000F5E018D085124009A006980260000E49B007040369A518C98349A600801A06000D8D80CAD34E49371490C9A40C01348006000DB600CAE2C2426E28006801A0728A42060C18DB001C200E426E22716034C1049A8C401B06';
wwv_flow_api.g_varchar2_table(4) := 'A4318012A901243710232137118E610208934D884E40C009571018124009A1C54AC8C0BA75545965712421363001BAE226C1B22E488F84E9BD87B18B8016164A6C9635621C490C00274A13636C84C479678187AE7B94C43B2EBA928B2C80A11841B60004';
wwv_flow_api.g_varchar2_table(5) := 'AB12D2EBB2B5FB8CBCBB6623E64E16E862FACFBF8EE9DA4A0929390C28A50C6809408E07114E64F172B5F6773B40F8F799DBCB171FDD3D9DCC958542495CD2926E306C412810D4F354697376587B4E4F4BD2FAA9F13E14F6AAAA3E84F569126EA00526D2';
wwv_flow_api.g_varchar2_table(6) := '1B60D03956E35F9B96EB77B0A5F1FCC66EEBC2DC27B6863E47D41DAC64CAC0630412E77A19000DD524BCD13B7132E7560729A48F3FCDD059B38C36BF536F2C1D2C4E498948E4BA7C81898EA944D1F9BE764E2E4E6D191C4F2A9D1C9E9C96CA73E8FEA2CF';
wwv_flow_api.g_varchar2_table(7) := '8CE960356401B183131D5288FC7A397B9D1ED0B79DE2A88B5A0E5A31D9E54BBAFA4E53A580E364406360C0754E21A8F32C8CC8E3ED33B9BF2AA36AA26BF8EC636F7E3FB6FB64EB00236C41486C18042501AF13B3A1D64765660793F1BDA51B18470F8BC7';
wwv_flow_api.g_varchar2_table(8) := '7B393FA4BD22A6038CE2DC244860C1D538A92D5FCBBDEF45A8C8DF6379C733A8C7CDE8B36383C7613C9D9647D55BE1835288D36D800CAE6A2A6FCD7E77ED7A0C9DCD9C2F9FEAF7D8766766E653C56363E7E7F4DF51E4300AEE8B4DB1803754944723E56F';
wwv_flow_api.g_varchar2_table(9) := '3FE9F63BEE9355E3FD2C74B6ECF9FE93654729AB9DFB2F4AFA258238CC9EAE4890300657270093D07C73B1C1BD1B5D661D37AEA39DCDDCE770588F2F3FE81F5400A3214D263600CAE6086795790F38B57D8F35BAD2472219991858F4F73AEE4714CCD8FD';
wwv_flow_api.g_varchar2_table(10) := '5DD280C5340C600C83626E3F3C6069794AB7D8356DEAD6C6FD26DD60E5F4F8FC7E2BCFEAFEAEBC01588946400374C9B00F33F2E79F85C7E2ED70AFE577FA4DCE91753890DDE2F2945BB1F5AFA0500A6A42630074CA4C0391F1C775B2C5C0E53435ED757D';
wwv_flow_api.g_varchar2_table(11) := '1F2A5BBFE6FADCEC1E46BD8E47D23E8C0290DC5F9FF679E0154A4D308786F3BB3D6C773ABC4869F498187B0E93BAE4F82AFAED96AF8EB763B2FABB720A4C02360015B934C4F88F9C6BC9EC29365C675189BDE73455FD1DD0EBBC6BC7F67BED6F2DB59F77';
wwv_flow_api.g_varchar2_table(12) := 'F4D812043900056C8F07E80317CDDE56BA1C6EAB62EDC695EF0775EBD0CDD4F82F9D6D712AD953F44FA801249B9000A0D3C3CE241A2F95B13531EAF98E8B771DA6B77587A8ECBD4B2E9D9F19E0FC69B2C8BFEB6DB034A4E4002C7B54984D35CBFCE3CAAB';
wwv_flow_api.g_varchar2_table(13) := '29EAB94DF75B64B1F3B9EEBBD6A16E559E7DE2FCFD87A3FD215E1E6C8992001D4C2489A034BE57A0D2EB21CB35B5ECB8EDDEDF8AF6DEFA73C7C8CDE23C2F4F0FA9F67CBEFBA6264810DD60984C01E2F9AF3CB59AEE439ACDDBE8F6FDC72DB4F79C8B6B85';
wwv_flow_api.g_varchar2_table(14) := 'D97C67CE0BB6FA77CCBA3CDADDBD0DA983AC22D163014D6838BE694B41CFF25931BB6DB1F42EF55B7EA2DABC7BCE976DC6AFB0A9C2E9B284D12AC22D1634C5348C3E5743CF570D5E8759A3C1EC3E96A39FD595DF81E0F4CF331BE9AF469834D3200844E5';
wwv_flow_api.g_varchar2_table(15) := '1629A088EBD06A753ADD362EBB90FA4341AE75C67C8795DD1F62EAFB4E85B924D39560843980A510528A9288E8C2D55DA6C7C2C323C0F11ADE9FD4FBCEC06DA4C72AC1035465829210409450490035A5F0CEA9D1B5DCE476326C431B80002E13AED88A69';
wwv_flow_api.g_varchar2_table(16) := '0A2268448426CC5F9A35F0D97D0D7E26F26C681B70000260D4820444E231884D8BC8F8BB4F58DFE75C0C6936E20004A4030AD069B43D2EC02424120D6789E24BD07D186818863400039A60108B31B8AEF009020682BF31E07D17D2C68011252400013521';
wwv_flow_api.g_varchar2_table(17) := '0EB4C49A60C40D0000000219240980A69B2D9E34442698310340000000864902602912BAE1AC6A00001881A000000040C189CE6A7394E2320471E2800620684D0C0010034D89E6C55A2B2A994CDD62AEA403100D045B000004D36E5721909B44624AB9DA';
wwv_flow_api.g_varchar2_table(18) := '44C64322C0121B00004036E24A2D04D27100000068010218C4C00006D0D20249003130103049A0134C8C98003191644024D081802001A4980214813600048488836C000004304D240021C9209000C0157318C0001A10D304A2D01243043060E50FFFC400';
wwv_flow_api.g_varchar2_table(19) := '1A010003010101010000000000000000000000010203040506FFDA0008010210000000F961828A72C130006D946431CA1830250D8E86DE232A4434C6663A06DA778A6526BA35E1735734908A15565354D33E97BFC2F11E9AC4D3512DA2A63755975F37D1';
wwv_flow_api.g_varchar2_table(20) := '76D781E43D324B40630ACE6EACE9FA6E5CFADFCF799790D8AD833351A5DAFBBAE1E2E9D7E579B26DA298D90828AFA0F57A39BCEE99F97E706058D908EB5E7F47A7E8EFDCBCDDB0F96060E86384AFD930E9DDAECE9F376F33C31B06C6F3B4FD6DB4B990EC';
wwv_flow_api.g_varchar2_table(21) := 'EAF3B6F9EE16AC1AA795B3D2D35BB079FA57C1B7CAE43A572EB1D037F51A4DD72EFEB3C793E68A15A6F3769FABD9312B358DF76DD9F39E5D2A6C59BB6DF6F46FB65929E75AF6767C7F9DE8DB1BCD15619E7D9E875C2E49C67AE7973AC875921DB05191D1';
wwv_flow_api.g_varchar2_table(22) := 'D9B7CBF9CBEAFDCE6F250159A0D004948CE2CB9FA7DF9E3A075981A0C9848A4394B781A75005D066AB3290CCF542153403A6F2126034C0487493A756E32901A69369C83668E9A493880025B1A41408A49A608049830634A5D0008640034DAA0534300131';
wwv_flow_api.g_varchar2_table(23) := '426D898E97FFC4001B01010100030101010000000000000000000001020305060407FFDA0008010310000000EE02C0001119096C00A82126625012D21031CC41F3EBFB492C55824CDF4DD5AB179FE3FA0ED498DB0B50996EEE6786FF002B31F31F2F7FAF';
wwv_flow_api.g_varchar2_table(24) := '264B8845C72CBD2B5DE7FE5DEBBEAF37F27A1E9CC8120995EF7DFAF56DFC2F0F4BE8FCF73FD67D54104995CFD56196BF2BE2791D9F5DC4F8FD56D0222646EF43D6F839DC9E4F92CBD9727E7F4E0424C966CFB3EBF9FE5C6F99E2FAEE7BB62049913A1AF1';
wwv_flow_api.g_varchar2_table(25) := '949E7F81EB795D3FB48099635D2DFA75E9C586CF21F17A8E0FA7D84B099437FD8CA6386BFA3E6F1BA7EEC3D222C1513767B366CCB3C33C393F1F99F43D21065245EBDF9746FDB961BEEAE5797F55F7F3D2C991232EF76FE4E47C19EDDCDB9FC7C9D98CCA';
wwv_flow_api.g_varchar2_table(26) := 'C99088CFA3D3FB357C9F1777EDBE47819FD39126431A16B66DFB3E8CF9BCD9B04990C6C5A0366CC745094628CCB01B66B002232000164A48C572A000062851682C02C09400A4B0058005162016000C88212FFFC400341000020201030204050303030500';
wwv_flow_api.g_varchar2_table(27) := '000000010203040005111213211014223106203040412332501524513360704243536171FFDA0008010100010801FF00639FF868FF00B00027365FCFA73623E51FC66DB7B93E20919D9B3623DF3638170A7F003E4F6CBFF1359790AD483E27D4E223A9A6';
wwv_flow_api.g_varchar2_table(28) := '6B55750F48DBFCFA7391F907882DB67A336183DBC38EE30AFF0005F155874AB142A3FF00448DBBAB323AB2689F119DD6BDD0173D19BAE6E33D19E9C09BE74F081B67BE761B8F05CFC78019C57386F9C0E6C7EC6C5F86B4D1A4B35A9F65E296E5989558AF';
wwv_flow_api.g_varchar2_table(29) := '4B0BA75FCE74E644996D465DD1A3963906E9F2FC5B659F5411E21E433B1CDB6C23FC7C3FAF188C54EC78F1FF003C47C9FE466D9B67E73F39BF6CEFB78039BF876C3B7D6B2F2A5795E38668E68CAE716A40363F417A6D86491A59399E9C51A8C4DD8475E4';
wwv_flow_api.g_varchar2_table(30) := '951DBA93C506AD3A37EAD7B95EC764F1D6998EAD779AB153B8E41866D83DFB376F7F87B5DE5C2A59F0DCE7239C8E72CE67391CE47391CDCE6E7373818E72CDF37CE59CB39672C3F52E49D283A996E0EBAC76AB4130B11CA57735BD51954E9C4B88CCC66E';
wwv_flow_api.g_varchar2_table(31) := '6F1A42EB04AED372E796624470F1CA1B8EE9475E91364B68E8EA192491228DE47B1334F3CD3362B3210429E4BBE0F738FE1F0F6B9E65456B3E03E90FB4201041522B96912CC1B84B70878E4ACF3A0514E6E12859775545104CBD1C8A49576392471B3986';
wwv_flow_api.g_varchar2_table(32) := '3393A1493B53BD66A3728B5BD784FA69863F50F0388CCBECA437704123372310B07564D23555BD1717C1F44E0CFCFCC6E112CA146FB0DFEA5D0F52EB380C95244E323357985C8DE08DB8C0B59DDE3E9E111CA9B890BB411DC1D30CAD125E557E9D94B00F';
wwv_flow_api.g_varchar2_table(33) := '0DC161F90CBB64D441DDA360CA766F0562BDF01E6371DF08DF2BD89A09639934FD461D42B7563FA27E73DC64DA35676568A18CC714687EA6A35C4D59B2AC8AFCAB495E50AAD059A7192F369F2CECDBC56D5D5399CEA022399E1EAC692C4664575B71A32E';
wwv_flow_api.g_varchar2_table(34) := 'EA461DBC361DB6923E6BC4CF55A31B8CFF003818A9DC23F219B6FED9A76A52509C4A95E78AC42934583EFB52ADD0B2D92BB3C296811D4AE93C6BC656C8794B5AC57316D62295024CAA695BC6E30F418D98BA56654127A5D81DD718A67BEDB713BE58A9B8';
wwv_flow_api.g_varchar2_table(35) := 'F491DCEFB1C0763BE2386C53FE5F6CD0758F2533452AB2BA8651F48FDA5EAE2C5765CD3DD7ABD26A2784CD14908755B75F269960BD05B5E06ACCE993471837E1446F31536CB243F4241A848F0DCF4456237F728C3361F9E5B7B73193D78E6EF8F194620E';
wwv_flow_api.g_varchar2_table(36) := '0391BAB638F4E0DF3E1BD636E14A71F7FAF2350B293ACD67CC4A65124852CD4BAD246054B1064CE5D29CAD04A9D5D39CD490C2CC99621E9452266B280344F9BA76C925E2F664C8ADA487BF6DBB9007B7B7BCA91CCBB192278DB63E0B2923639EA0067C3D';
wwv_flow_api.g_varchar2_table(37) := 'AC79D8BA32FD01F6D7AA4772A4B5DE24BF4ACCF0B798E71F48F5E39E538A795375C505AB4C7271CADBB1B522BC93B0D541F2DBE3AC3C654C6B33345D2CEA77DF22B7247B6D0D98A4ED9EC7B364912BAF16961788EC47846FF83DF89CAD626AB324D0E99A';
wwv_flow_api.g_varchar2_table(38) := '8C5A85512A7DD7E3E4F8874CF350B4CB24E0CFD44371622DD68675E12F18481D4055FF004E8307DC0880D4577AB2635994C7C33BED8B5E331A8357632966B04915DC576B6630D91CA6450C06491C6E3669A1689B6C2771E1149B763F919A56A2DA7DBEAA';
wwv_flow_api.g_varchar2_table(39) := 'C52C73449247F375137030FDBFC45A5F91B659502B3AAE4B2F0599A34D5D042A4C5AA42D546E6D556DF2631C914CA3B64B0C02395023C5D38A5C82448A405A768DFA6A90C9004824650FC792D59CC8E233CFD887532060D34062EDE1FF00C590AF6C07D5';
wwv_flow_api.g_varchar2_table(40) := '9A06B1E525F2D37CD782563D614575566596DFDA0F0D4E955BB51E3B0C1D1986756D5A7556951E27E260B32C5BF104EC092497E467AF146B27179A66856239DB6CE4B848E272BCA162AF8FFA52B01E764E44BC52211B83C5E321A685A26DBC637D8804FB';
wwv_flow_api.g_varchar2_table(41) := '919F0DEADD78BCA4BF2B431BB233FDBEBD78F2F2AB7696CB63856F6B196BDAA8C032655E9CD10E4FDB27B4245938EEE3376C8101EAB49622E9CA42CF59E15272AECF1F4DA5267B2FC2746898068A63191B214650CB247D4055A589A26D8F8237E0A49246';
wwv_flow_api.g_varchar2_table(42) := 'EB22695A947A856120F9061FB01F3EADD51A9DA385A42A79B5601FA91D959BA8CD2B42D19DA479A03148C218A22B33BD9892291D56C45088A74582085921435F86D611AC48A2CA95B32C3C2411F2394DBFBA8F7B2AF1D7AA924904D12AB3D59FA4D84F2C';
wwv_flow_api.g_varchar2_table(43) := '912375E2D2C4D19D8F82BF6CD2B529285A594452C73449247F683E7D4D1A3B8844AEA3900083ED12832C3BCF4C3C4BBCB4EC479148AA2449024764F51E4B6AD1B6559210B03B6568602B0F50A904E7958FA3E04F7CB21BFBFDEC430A893A75E4663D3CF5';
wwv_flow_api.g_varchar2_table(44) := '019246920E39246D1B716C43B1CDBBE7C35ABAC0C6ACFF00683E7D6525357A91F92AEEA0B4E644DC34D1B201913EC25732F0EA3ED3D3575DE45D3FD15FA53519B9B956055B663905A11840714AF4D66F169246555362488A4EEB95AC735DB096C9628E55';
wwv_flow_api.g_varchar2_table(45) := '2319591B6391376033DF3E1DD53CDD6E8C9F4EF5B782C74D2BBCEF10337CC3E760181536A2F2B322989409518C9BF4E518155A3923791DA46631315DA623F50292164DE3DA468E17FDED4A1701B1E9301C9248668FBB654556B75D5A081F516AD1CB2FC1';
wwv_flow_api.g_varchar2_table(46) := 'DFF8AC7C31AAC3DD648A4898A48AC548221B4920D8FEECB15838C3B83B143B366F956DCD5268E68E8DD86F5649A2FA41141623E71F435BA5D6AFD55965BD00E4DFD56DB11CD2E5773BC90B09C7E92B93BE6EADDC590592CA6528793CCECDB332E4C87F12';
wwv_flow_api.g_varchar2_table(47) := '6FFDCE792AD348C5ECD08E27468A5F3C248655A7A8C76608A5F0B552B5A8CA4FA8FC28CBBBD2922961919248ADFE245951876B55F9FAD77DB1482BBE153EF9A06A9E46D7093E41F60DC8A9E3FD6112D74DBE5D7B4D7A4D725C01B639C5C6F951D42C5C8D';
wwv_flow_api.g_varchar2_table(48) := 'DB5B9C5705376EA991389EE08DA31C9DDB27990322E7564700647BBB32E488DCA18F240C8789D32FF939A4E67F5D55A3532F51372E8A4037B4EA97A3E13EA5F0D5CABBBC218A9DD52E4ABEF334721E6236FC610461CF86753F315FCB49F6905682BA718B';
wwv_flow_api.g_varchar2_table(49) := 'E5D428417EB3C129A2F52F4904F32C6442F9F9C23BE329FD77C1C815DA2B76F899196DD775DF1424858805761B3F2421C40499D4E4C0F978C82AEE194E997C4518AD71001048C8FC8EC18CE5646DF2FE81A75C258EA3A1DEA1EA7CD8FE11F961EEB956CC';
wwv_flow_api.g_varchar2_table(50) := 'B56C473474AE4576AC73C7F5DB3F1F4B52D2E1BC9DF51D3E7AE5533F4F7CDA3C673D3099B2F7C8B8EF4D336CA361C4B0234F3F28A1EAAEDEF8AFD370F934D18E282675096107185BD79A3EAC22984537181E03C79BF08B8725880E685C970CACACBDAFFC';
wwv_flow_api.g_varchar2_table(51) := '3542D7AA3BFA1EA147D4C8A1F76C3D8E1F7CF86F51156D745F392F20B86751604585946DBFD81C1F35CA4965324AC609195E6D3AB4DFBA4D193FE810D9A70CAEAF3C10D89010076CDC6D9E9395ED4C855049340DCB8DAE1D6F4CB3878500BE9FDACB1280';
wwv_flow_api.g_varchar2_table(52) := 'DCC71D0752791841609EACAC87A92B093620AAAAC4C424ACEBD7ECE46E3B65EF87E8DA25D2DD39E9CED0CCCBDB7C1EDDB45D485FA6A4D992447DB19D8C9CF239A4924551F7134114C3692E69F2C1BB0DFC25AD5DCEEE2808E27E86A15A659A47C1913049';
wwv_flow_api.g_varchar2_table(53) := '11B2D274E290609A551C72135CAB286B04A703E5CCD307627A1287C82C2CE95AC2813AB305EDCDA4C85B7DD30CC2491530F78D5D964E4DB66B7A49BC824881237DF6EFDB42D47C96A09CE48D645E2D7EC54A9370934EB74254678E5B6FBED91C124DEA53';
wwv_flow_api.g_varchar2_table(54) := '46E8FF004D17568FF72162BEAFB5B3A7C139DF2C699621F506423DC0CDB24D3EACAFBB4DA3B0DFA32412C5FBEAF633BE5BDBA88F9596D4BD921BE8A1524711BFEAE687242525AB22B470B0E6E789412CC921915B2491155C916D38F530BC091E1D5221B1';
wwv_flow_api.g_varchar2_table(55) := 'CD769AB4AD720E638EF9BF2040ABF136AB0327292432C8F234161E2995E3A6D567AD14D14DA65390F211CBA8D5F4D88A58E55E49F663E59A08661FA9268D1FFDB934AB680ECF04D16C5F6C7D88D88AB595C916B4CEAB73414ACAC0132E022D4FBABBA7B6';
wwv_flow_api.g_varchar2_table(56) := '95A94B15D84B12EA809B16BA4E80496A578BD7217978B07E52EDCFF7481872276DAC71E849D6EC77D87BE3EDBEE2BD69A7EB74F3E1693969083C07DEF639269751CEF926891EDE87D12C0278C9A5DD5C31C8BBF274575D9E4A555C118DA4CE06EB5E42F1';
wwv_flow_api.g_varchar2_table(57) := 'A6D327EA92F16C599B3DC98DCBB1D9B2B8DB910A1950EFA9CB19AF2C607638406DCA861B107E0E48FCCDA6CBFF000AD5B129920D2E82E9F5160183F8378A27003B52A8C363268F4DC1D852992B45124BA64EEDDDA84C37186BD84E38C364DA51DF810F12';
wwv_flow_api.g_varchar2_table(58) := 'C81D5ED694E84B43245F90371DF2A697A8DE47920A1A769BA95289AB6996AEB4D66ADCF01F62668870F93F3F29FB0EC7DED45025799F21D590EC278AC41280524AF149FBABE93A73D841258A83469A2B35350D3A749FCF5059A379AAEA31820F7183EC67';
wwv_flow_api.g_varchar2_table(59) := '4BFD69453AB1CD142AB37DC4D1F561923C7D1AC2120352B6BEEB25C4C8F50D415D7268D350D3DD334F9CD8A95E56D2D385081702A8F6FBB3F65AF4B3D3996455D67BF7FEB31EDDFF00AD45F8D0EEF9BA8D902F4A5993234E08147DD9F92D5A10EEA2DEB9';
wwv_flow_api.g_varchar2_table(60) := '5AB42A5AB3CEF0219FEA5BA915BAEF04B63405AE7D7FD2EB7B1F23A7C7FBF419AB133C50FF00032451C9FBC542DAB7D7744752AF73E1881F76AADF0F6AE87D3A069976934C6C7FB34780C0A4E70C236FE38780CE3836F039EF8C9B7F12149CE39C7020CE';
wwv_flow_api.g_varchar2_table(61) := '03BE7019B67E7C796FE0319461047F0E7F6F81F03BED8B9B66DBE6D87C570FBF871DF0A1CD88FE0B618BB0C27C3719C8672CE43398DB398CE79CF39672CE79BE061BE7219DBC3D1FF3B03FC8FF00FFC40046100001030104040B05050508030100000001';
wwv_flow_api.g_varchar2_table(62) := '0002110312213141225161710410132332528191A1C1D120404262B130335072E143538292F0051434606373C2F12480B2A2FFDA0008010100093F01FF00D223DC8FE2787B177E15A14FAD12E3B539B55BF308F10B42AFEECE7B9143EC30417723C67F02';
wwv_flow_api.g_varchar2_table(63) := '77DE93686C6F1B8B5C2F04620A7E3366B38F83938765EA537C537C5029DE09C138229C7BBDEC3E1C26D4603CD3D8CB479AA98D3A9B2722A916D560E768FC5F9993F44EB741F70AA05E3F30D9A9590C7896556996B95A63DA24B5C2F8D9AD3DA6751F68DD';
wwv_flow_api.g_varchar2_table(64) := '46988DEEBD62BBF8CE813A151C7A1B377E06DB4E0D903154EDB317707CDBF351F451C238156EE3E8E551E691FB8E11F1523D472A6DE58B79EA5F0D76F599F322EABC0EA1961F898EF5FAA7C546E9704AF91F953393A94FEF9A2E83D60B4DBE29D7EA38FB';
wwv_flow_api.g_varchar2_table(65) := '18F2A7D8CB89DB293FFE27DC82087DB03A2E69B8C11B42815B1965D6F6819386613039E44D7A180A83AECD4E0B9DE0F56EBF03B1DA9C154E689E62B674DDD472A3A43FC552C2D01F1B76AA93C1AA69D1ABD5DBEABFC57071CE8CAAD3D6BEEAA096798EC4';
wwv_flow_api.g_varchar2_table(66) := 'E870E89CD3491D718F684E05A7021186B5A5C77058BDE5DDFEDBF9E1D0775C7AFE020191814C77F772F8A94E74A9B87F5714FD3BDD6808B61A7A4353866130583770AA43C2A35455E0F55B323E21D61B42335E8B41A2FF00DE525751AE49A27F755736EE';
wwv_flow_api.g_varchar2_table(67) := '4DE7F82E5D660C5A7721CD571CAD0D8FCDBE5C581BD1BB369E8954CB5D52EA97E0366FF60AEEE3743819076AD1AEC1A6DD7B47B9C3C068B201CC98420FDADEDAA349B9381C5AAABBFBB54D263B363C6CD633D6131B65C6CD5A7F0C9C47E5764AFA55B4F8';
wwv_flow_api.g_varchar2_table(68) := '2B8E4ECD85122B5136E8EBBBA4D44727C25D781FB3AC30EF5757A0E0CAC35EA27E85130E1CB706D87E26A102B092353C74B8987EABD163AB242FF6877276934C828464F6F54FB954AB40874F36613CB8B5A0171CF6FDAF499A4D440654221DD57E47D508';
wwv_flow_api.g_varchar2_table(69) := 'B20B1FBA7EAC38274126693B5541AB7AB9E5D0FD95067DAAEA3C2E9CB7E578F42BA358723C206A78CFCD7DEF05A9CA33FE43B5091038452DC715A97F5DE8A1DC84ABC7B77B707B7584E9638483F803618EBDA8E9B0D8ABFF001277AB9F44869D767E1776';
wwv_flow_api.g_varchar2_table(70) := '60A1ACE18DCBE0AAD43499CE306777490FBCA76C7FBB4C5E3B54FEEEB6DB3FA274B2856B048CE9BB4823735C6376481C535C388947C9000AB8F1983C7F70F37FC875A208224119FBFE38B7785F775C587791EC2B07034DDAAF5F794B9C61D4EA78F8212C';
wwv_flow_api.g_varchar2_table(71) := '780F8DE21C15A069BC3DBF97FE95ECD1AD4B77FD142F7502C23E6A378F02BE2A2D9DEDB93A039A0907044349C90F153E08951E21133AF1F6201E229DFED13FFCFE00DFFC7AA74A3E07FEA8417013BC0C501157A5185DA2EF04DD3E0F5E675B5DA28E2C34';
wwv_flow_api.g_varchar2_table(72) := 'DC7F21F42AF96F24F1E1F42A39BAE0DFA8F367EABF65C20B7B08FD137105A9B95EA62CB1EDD5A709D64EF511C5F4477671ED6457DFD36DE7AE35FBFE0F18EA3AD31BA1D3B57377CA7744CD9D44840CD5E0D61DF9C607C17C0F0F1FC571444B5EC77F32B8';
wwv_flow_api.g_varchar2_table(73) := '709A05ED1B5CDF50B0A8C63C6FB90C1C15168736831F6F698F5474060DC90184288500EAF45E8A561F45865B78FBD6B4F2D737FABD5C707B751F7FC5B4E1F025D0D3693CB400D8D702E45A1A5FCD969996EB44383D9667B657C54CFAA37B0B9A7F9A7CD5';
wwv_flow_api.g_varchar2_table(74) := 'C6C3E99DE0AD87C558BE1A5FF110DC25144F2AF63DEDD42C6477C2008631EF8C890253402FA7780204C91E480736FB2D261C631B3B967B54F68F440C232D381F602D26B843D9AC274B1C241F6DC249F786F33564B366B0B37009BC99A75EC36CDDA37DC7';
wwv_flow_api.g_varchar2_table(75) := '5E0AD17C411E72816F3BE242AADD1A9A57E13FF49ED32C39F1538E4E931F6EF936A3D5546F3745EC2DCC93311DEA4B482D76E70853658C004E26F927C5548345AF1620C926623BD5A86E275202D65B734F1B348A263BFE8B0381F63C51E65EECFE03E9ED';
wwv_flow_api.g_varchar2_table(76) := 'BEF73A4371BF5AA94A2C91C9B5BDC7DDE03710F98B275A00C68C8C13868C926206D2633405D7C8C0839A6B4CB81BC4DE30299399DAA9C992A4BA93C36A4E0675273AC0C04DC9BC410CF5A1A2EAEE6B86B04017A905AE806702112E075A859EB586478CDD';
wwv_flow_api.g_varchar2_table(77) := 'C4EE729B740F59BFA7B4C04B0CB6723EF0444694E6752A5679373608F8B5A7FEC1DF508DFC837EA8A0DE6994CB4E0729EF94E4D21D55C2DC91176413B6226EB829B34D97819C9885304348FE2129CC743ECBE3E176A458CB351AE976AC0F6AA77D471B23';
wwv_flow_api.g_varchar2_table(78) := '794C6DEDB88320ED0421BF6AC109F25D87D8716BDA65A76EF573C5D51BA8FBED37BC5B9185DB95924C4B8082E8D6AE75F33787039142F3B2EDC135CD9C2445DAD3CF28FA6CA65B18598BFC11716D302E17132613A4000B675384A6B41A2299B599B58CF7';
wwv_flow_api.g_varchar2_table(79) := 'A82EAD6E1D7DD18479AA8D6DB60009C241946D06060075D8109E5DCA56B78440BEEDF7A29D8CB6FDA2136CBC5BB8E3129840382C0A33C5D87D8BD86E7B7584EB4C70969F7C375578276E021384E528AEB852D772AF777E38A01C06A4C365E0746E3214B4';
wwv_flow_api.g_varchar2_table(80) := 'D5AB62981836C8BA7E8A9738F0D6BCE5A3EB0AA069A0E71B3D606F11C4D71356AD81062CE17F8F138F2BC972B1959D5BF8F07708616F6CF92B5CD55B0E9CF6F8200DD729EE90A3E887B0E8A6F3A0726BBF5F7CC598EE28693A5C06E43439568A42323386';
wwv_flow_api.g_varchar2_table(81) := 'C45A44C18C9192008B57E3BD445C774894C1E6113A1C226FBF18F442D0B455C471530E2C75BA66620F9F13DB0DE0CEA644DF6AF02EE37B886F441382A809AEF6BACE6DCCCF138DAFAA6CF6210EC90BF8B2E2773D48678B9BAFED29D4E10FB42A0A6DC42A';
wwv_flow_api.g_varchar2_table(82) := '5C9BEFD199FB6C08829DA34AD0BCDE7ABDF2AFD20BF7D778A7C0201CF16EE4001310EC622E5526DD986EA8C55CE13104A6B85DF10894D0E385EA59AEE8FAA70737B953709C2EE2120D56CF7AAD0F7577B2DBB544C7A2E19FCCDF44C6D51F21F54C731C32';
wwv_flow_api.g_varchar2_table(83) := '70828DEA03941421C30F60E930DDAB7238E23AA757D9B449C4EBF701A74FFF009CD45927618D9B138386E854C83AF1441F0EC566CE4653AEF05F0D92D9C151B765A5C03B5A6726392B6645C35A2088041D61602C00137004BA2E3727BC02039B9C26B741';
wwv_flow_api.g_varchar2_table(84) := 'F6DB64469632426D90EB8EC7E6D3C545B506D4F9FF0049DE4531CC7B7106E2109DA8A1A5F5E2BB6A1DA13B98AB73B61C8FBA9BE2E5CA54AB62393A6DB578F69D34EBBD8E67E693723879AC82AB64D2AD6CFCC0C6119DC9C6F25552D70635EE6C5D0EC2F4';
wwv_flow_api.g_varchar2_table(85) := 'E696DC2EF329DDF7DC9FD2610DEA8D48B4C3407107038A76883010043D8E1DA9B7D81776A1FAA1CD3E2D465B5548CE9BDA643A7C93BA6DBC62CBBAA7C9189C1539D4E1D21B8AE7A96CE90EC4615E841CF88AC51E7290BA7367E9EEACB233D677FB59E0EC';
wwv_flow_api.g_varchar2_table(86) := 'DA7626DF4D8E71070759123B100DE529C90309061145744F04A71DB6479230A95AA7304E109C06C372754B8C1BEE9D4B056889BC0DBBD1D77F6202D8B4026D8CED03F5447273A0F07A07C9547D3BAFB4303AE131AF61898C8EBDC84B062462D3B46ADBC4';
wwv_flow_api.g_varchar2_table(87) := 'CE4EA1F8D9777A6DBA7D765E3B757B27498647A1583B2D4757BDE8D40C7B5AEFCC2153716D26599ED99529C555716837372DE8EE4FD1753AADDF6894E09CDB1CA5E9CE65536B448C77841A23C3883834604E64A60229D98005FF00D154F480997084E259';
wwv_flow_api.g_varchar2_table(88) := '10C7DA18640AB41A3AB20B48D4AB30B8DED245CF536499B4E3307526441B8E44220843907FC9D1EE4CB6CFDE32F1FA237C5EBBF8BEEEB5DB9D91E237EA5ABC51F78B9E303E4A9807726C1D6DB954236140DB2E6C16DFA226531D34AABF938C34B23B94A9';
wwv_flow_api.g_varchar2_table(89) := '52A5C0DD64ED551CD2DABC999C09D88F693215775C4690CA2EBE17EC9ECB318EA5D28B80CEEC555D3B3CDB758F5084B0638113A88C8AA6D25AE88B588F5564103A075792A47FD489EFF99537BA002207481EAF13791ABD66607785176046635AC114472A';
wwv_flow_api.g_varchar2_table(90) := 'CD1A83CFB55ED7645632AE93A5B7DE5B3E4B499AC6436F1D2693AD1B1508B9D386E548D937C8C36F160D703DC9CD3CA57B6C838B40C7C53B47AB927439D75F82C6E9385A2AE6DAC35809C1B608734C598ED4D6C546D9249870D8ACBBE63888C9DEA9C6E6';
wwv_flow_api.g_varchar2_table(91) := 'E933A507666ABDBB30E0474A0EBD69C431E341C333B0E47614E61B0E9B51387D0A6E8D905AFC41462AD306075B62BAF85721CDD5D07ECD478B85530EEADE4F82E12C7B863174761BD54A1406BAAED3FE55FDAD55E3FD3E4E3E857F6AD7FE36B1DE4154E0';
wwv_flow_api.g_varchar2_table(92) := 'F5C6E349DE6136C9D533EEDA0ED6335A6DD98A078E9C1D9727CEC2A9B9BBD74994A5B39190101A749AE3175E45E9F708E93A049C06F4D2D22E37261718F85D281B2F36980EBF229D36EE15AEBF50319A79E5263946B72385A41A6C19166E7D9CD1B40C68';
wwv_flow_api.g_varchar2_table(93) := 'C609B154E21B783B76A6F48DA3C9BAE0FF00254DF6674F5B7B13340DEF839EBEDE3AA2A31B02C380C06D58B9C49ED448730C854981AF64F44772A7C9D4FDE53D0778267F78A5956A634C7E667A2748F79A61CAA91F9AF4D0EDC553736758E212352A2DBC';
wwv_flow_api.g_varchar2_table(94) := '41DC5548B800D8B84265FCB8376A84089A8E23BD14EC746718B5B1536DA2ED26F58ECFD541B58EB1B5596BDB83C649D330641BF784DB9A703F5042195CF181D850C73D49A393B3A607D42273C7885C532D726CB6E0318E2F86A3C79FE00C2DFCAAB386F1';
wwv_flow_api.g_varchar2_table(95) := '2AA30F82A56BF2994C70EC4C046D549A368B93DA4A7D569AAC0448901D9AA561C0E1F093D66EF4D876063028020DE22E54DD00DE3E21EAA1CD75E1E33DFB53AC696778ECD8AA873A2E20DF1A9DC41094E6DAB00019EB2AA7224E2D896A7DA824976B27F0';
wwv_flow_api.g_varchar2_table(96) := '5A6D206B0A833BA1073771F55C220B624C5C46A4F639A5B05A7C95290718CD527BB6E610B5AEEF141C2FFEA5090EB88D8AF6EACD0DFC5434403A58491AB6AB7C1B855010E23A41DF36F4D6F2B46C9E51B83DAECFDD1DD27408D7EF54D82CD371C3504DFE';
wwv_flow_api.g_varchar2_table(97) := '20AA34A603D8A8C82709B939CDA152BB5B5E8FC3A5748400E103EF199561AB7A9E4AAD2E4EA4FC37CB49DC6E467DCE801065AEA9D1B433557947E6E88C7DE7E2616F7850E8BB57D55272E546E956891916AB856A576C270EE2869168B43E61715F378B8A';
wwv_flow_api.g_varchar2_table(98) := '007E1CC05953C1C151F1545DDEA91EF4D8B0FB3E6B073F946FF174BC5603F00E9C489C14F2AF90C67CDE8A972753E26C83F4FB5E8BBC36AAA40C9D92AAE4FF00FF005E89B700D76FFC09A0AA5149803848696F667F6ED0E69C414FE4DDD575EDFD15069D';
wwv_flow_api.g_varchar2_table(99) := 'CF09B4C5B6B408749BBFCA47FCC27EC47F978FB61043EC8FFE947FFFC4002A1001000202010401030501010101000000010011213141105161712030819140A1B1C1D1E1F050F1FFDA0008010100013F10FA967C9F9D7CAFF50E8E87C98CA8753E07E816';
wwv_flow_api.g_varchar2_table(100) := 'EFF427D07E07D23A1D1F83F1AB947EA587D471D4E8F4E7E570FA67C8FA2FC0FA3A47ADF423BF9939EB7F23A5753E9BD0E87D27AA75770EA8504036BE929B867B3FC893355DC6C8FC454A95389538F810DFE8F8EA46575A847A132B8195DB5E0DCBCA0AEC';
wwv_flow_api.g_varchar2_table(101) := '21A84D4313552EDC451411E97688EDDB28E6226C47E17F1273F48FA2745D6A5815400B57895C3A863C55E89E2730AFB53026F3AB52FCBBC8D741E36C11A6FB8A15747631D186A0E892A069EC600CDBECC68696C2FCA15050BB7B4C68DDC4008DCA745EFD';
wwv_flow_api.g_varchar2_table(102) := 'A6497F125FCAFE0FC58743A1A8EE71F0A5FE11B6A9425E9198A986D281C95098FAFD8A9100E24B3C91A77FE09FFE951FF9D41469FB8C0EF1EE02D5FBC4005B14E66CED10B5D039A85301CED7FE4CD6D220BEF7BDFDC8D109578CCB9AFE2285EAE0C34C72';
wwv_flow_api.g_varchar2_table(103) := 'D521CCC174C61F4CE8EFA10D5A0B89A4D45590BC28FDEBF1B1EC04A6BDFD937780C6CC397B703CA126F0A66EFE200C8A808734BA7A81428B2867309C75B2BA93DB261F35375B9565C0ED60952E1559C8F12E8D468695877BEAA5A086AAE2E17E4FDE1DA2';
wwv_flow_api.g_varchar2_table(104) := 'B57EFF006CC4ABA8E11FBF399DD7296D5DC101E332EC5F1FCC459ABB836B7C60E22E02050132D577AED179C5C529691531BFA647A20358070E539080EEED6FDB6EBBCF99B3FB0E3944B15B68F9F2843960ADAA1A63505723513BEF47934203E520341C5B';
wwv_flow_api.g_varchar2_table(105) := 'B3C5E996C8B47DAEAA3B3C9C4AED393013616C969575111C857415288052E9D3071CD8EC75F721A25256386155CB683100930FEF0DE7B44EB5170A1C105D8FC4ECA7D8237393F13CF30D5F58654346EE2D3441F68E3551BEC47C50AE8CBD64887407D127';
wwv_flow_api.g_varchar2_table(106) := '6E8489C61DCAACEE42A4478AAE5DA8BA5A813E1E22BABE730D099A8F4122AC962D46FBD9FF00C91FDD1C6F848AA3CD4C614D0BCB47F8318AA60A68FEFC6E29AAA776174BE5E25721F60A0F494CE3B115D3F05C078B68B1820163D82D97B8AABF3B986216';
wwv_flow_api.g_varchar2_table(107) := '77AF5080AD36661AB296BEF332EAFCF301322DFEE46B96EB37D8F58FC07463F049A42FF407461B41042C6F863D905CAFB148EF99BA0E4353983FFC2662CE3442E8F103988B3470F65E06A2DB8ED15CD104DC65DF7BE50C405EDF955DE3FC633A09E9ABF9';
wwv_flow_api.g_varchar2_table(108) := '110FD9ED18B6381E6575DB373EE85C67F376415348DC560AE065AEF99546B19D456D3B57A866D2BD88ED1202C98BDEE33E3C4D20D24AF61916803D64E1F87309C26DF03D126237D26F902652C014ECF6FA24788F4BEB714F214BDF38B2F997BAC0818A20';
wwv_flow_api.g_varchar2_table(109) := '59A77E833072F29EFF00B071EEA530C4B5E4FED094BDA5AF9CCBE0C5D2C14CA31ED4102B762F069F38FC91821516A883EEE65415A76AD44B6179AA8422DA4D35FE216D4FCAF4975143CEC62952AC3571CA53E1D510D4BC23B861BFC97010D2E1FDD3E57A';
wwv_flow_api.g_varchar2_table(110) := '7B8F68418C6EEFB30E87C799C9D06E73D18F4020823BB82F4D7CEA103C6E6C688030CAF2FD03A31E981F03EC0C9F72257275C457ADD784C3623E5E6FCCF0879BB6CD557631F63639E4DBB7381B0CC9C2FF00E3E988969FAFFD9EA1DAA5CCF61E81920DDC';
wwv_flow_api.g_varchar2_table(111) := '1785AD3E68662772AA3E77F9FF0012F1915DF5FC590556DE72FE217A9B375E4BA48FAF1EE2246916DCCA71ED39012C2AB79196CADE9E209E7FB88F595E77A4E13860889499B743A139E8E984FB4771E87D4E62475D5D25DF8B3B25C3809579AADABAE196';
wwv_flow_api.g_varchar2_table(112) := '61A6BC99FB9DA5959555D1777F9CFA66DE12C60DC27DA65A57EEA0F753307C517BC62337DDC5665C3EF5FE92E05CC576ADB5F8886B6555DA08BF7552D982EB754FF50038278B13F19802A3EB3FDA15F7FC96E6500106926041B2E2D4C370AC22E22A531C';
wwv_flow_api.g_varchar2_table(113) := '7A6785BA2B88CC2CEAE7441DF72160748CDA63E0EFA3A84571369F6E970D741FA3CF47A1359C66DD41596D10EFB2F3077E9CDC0C73F7A6E3B0A6EED155F7005D78C3AAE90974A8173C2A254550A35C9A8E1A698516E39EE06B9523F15FF8215A7260B64B';
wwv_flow_api.g_varchar2_table(114) := '8017D34B07E49417F82881833D29800276FF008C2CAA19DBFD12811571A7EFCC08E9CFDFC929194226C8452D8D3A6625F7F64A0BA21D9BFF00A41E4B8C6A7FF71F1731E3E03823B7A71D0FA075E6711EACAEE52FBAA9E3685AF2F76411EEAE5730A9E47F';
wwv_flow_api.g_varchar2_table(115) := 'BD09AD0ABDDBF084A1EBE5DA0BF34401357A98A1656CD5BCCC6E57C50672CA3F9B03F784BD9B4D64C8CCF95D72DBE229C5AF39B2D3F2C0E0526140BE364C0512D5947E4B2525D0FF00DF6657316F763F9229CD371C9E9A6503EF4F73BC579259BD4C365B';
wwv_flow_api.g_varchar2_table(116) := '11C67D8CDB6E1392386B320F03FD4A7BF35734B5F7F79C3F07A514BD2D1DB0F81F4F88F5661D6A9C8320F4C1B56B9820C07B1BC4D1756EE2EE8AEE42B782EEAB28F758F738317C0FF298B3352F612CFC4A8C5A85D580C6E16416E7865FDC7101BCDF6710';
wwv_flow_api.g_varchar2_table(117) := 'C0A112DB612B4158C1A9E2EC3C92D54ED41529E5D29194EED6DB59F6C3285C9EE02BF680CD7BE255C15A74AEE5CAFB69A7D9366C8D53EA6717D72208CC2011351A835D859E87661BC0B99938FCC5A8EE1CC7A0C3E93D7517D56CA629A5550A5D4ADEA4E7';
wwv_flow_api.g_varchar2_table(118) := '0C235CD11CE99F301C45C6A5DB1186EB00FED38E80F48D183ABC0EB141F8804CA60EDB3FE91BC63D543333B940052561768E53DAAE5C2AD0955A836E4CC36678E94607C5EC881908545A8182C8C447D0CEFB8C585D6C6E57860B4687B3F984263BC8097E';
wwv_flow_api.g_varchar2_table(119) := 'CA49F8D50BF646B28E94F355E1ED7C3E2358D7F3F8606B33AA9FEC48430B3723D78E8F4033E005ED364D886E574099FA9C54E3A5D433D31756F39DDC5CC25F3E16A202D9C46A3D91C9808D18CAB79F027150DF0D2DCD68D12A14BEEC3253E604C81283C4';
wwv_flow_api.g_varchar2_table(120) := '6E6DB0BD4BE4022D9CB76D53ACBA897D6B51B91E72B20A0DDC49E4B8B2AD50A452016AD837394028AC31E52DC30401AB6ADD1715456E15816BAACCA86685D086FD911B19C869D9D18DAA9CDBAE621765B3081020E3C7A63A04DE2A1AF1A6ADDCFB7338F9';
wwv_flow_api.g_varchar2_table(121) := '5FD6A9B5328ACD1CC2FE56B156DDB7BF0C37FA14E8F4731461DB053D598E7B556654EC7CC04D51C2145D36686F72CDAD0E612C0F64653F18358D40E92E26A4CF98B56C456164472CAA35C0AC92EBA04A888036AA94EEA25880FDE5AD721B8539DAB9D546';
wwv_flow_api.g_varchar2_table(122) := 'D555C5ECED29DA5CF693BCB0B29C1EC8A6AE5F51CB18FF00241074748173640C1FF0F7FBC62AD4B61575D2D8E825B1A63A5DB4DE33504C2F98971EFE4BB42617E43CC6EF30DF4A3A1F4986BAF3F06E2B0DC52E9C0ADABC550D962DE4B23DFB27A601772B';
wwv_flow_api.g_varchar2_table(123) := '0ED6927836B55FDCAEC86C1639D7699E596197759965DDB50C9C39A56ED9DE34DFC7694B4356CED71AB9B4A0501B2359650B57A85D011AE4B89E43166B1B587E4C44D780E030DBE1492AB71614B98604852846719018A628582D3297916308D90A817080';
wwv_flow_api.g_varchar2_table(124) := 'FB1554CAEED3942ACEAAB70D18B86C141720ED145F475F1FF0F1F26D39E978FA8CD0F83D186B5C5968A82A06921A0251EE788A14500149A43B30E8C029298945180087A8610F65C2E3C45A0D596BF643446EE0634D42DBA9840CE5280DD720C3DE50DEB1';
wwv_flow_api.g_varchar2_table(125) := 'E7CD8ED0A3AA2A178D46366D2E39582A14DD70D40AD96C0A96CF7A965EDDB748A2BDC0112D4B69DE5AFC115A5CFEEC5281695046AC7D336DB729DAE9AD34DD31BBE59A6B5CC3AA672CBCB93C5311015ED13C9640E25368362462E6C8EF9732FC41FF009F';
wwv_flow_api.g_varchar2_table(126) := 'B36408A19748F46107316FA67A3D0FA2CD25EE1F14F478614AA3A3AD40630CA3413B907B5CE71BE6642725F802AEE6696C14E4D7A88566B80AD897389AEC68417CA648C861B68D6BA2B745C414195DFDC16F0CA4A22B3A9F0851F36E453B297EA0BCF2C0';
wwv_flow_api.g_varchar2_table(127) := '627EEC3310B96596FBDE752F1D8174B789ED4ABE1CDEF3BA3DB2B1082089B192BCC055845D3123495D34A18FE83B1EE773A53EAB9B9B28CF695E915F6363D8E87A1D48F4E3AD86DF9B34E87C3370C302AF7555642EE4521AAE2B776E6A366D8070822BF0';
wwv_flow_api.g_varchar2_table(128) := '8ECD95D39064D6E28362E636ABA842C8B853A0523744C5D25EE4BAC9709C8CE81E571251698C69A5F31F1A9A4E60F11D9850AD8190D30352D2EEED8B4027C67046CD88DCBCC44E1836CB209EA3A852B31BC17F66B47796888A3DE2DF01B2EFDB336167FF';
wwv_flow_api.g_varchar2_table(129) := '003CCA8021B26BF11C561D2CC0BEED46ACD1FDFE654B908AEF85F6E98EA13923B8C353B46A5E3AD532FC6FABC423C8D812178C9F27A18477D0979609B6A0EE25305FCCB052DFDD0B2C435BEF5EA04ED944FAB44446D59596A3679C425C53DD00B269097A';
wwv_flow_api.g_varchar2_table(130) := '55D8BB7959ED8C454CA14084ECD4AEB0E4FE2A5C0B0CA978E2F772E90F0B0B75E1169F1ED8F72907AA6AA5F0F336B7088080E91109C6E09C1FBF7498AFEDFF007B867E56FF00159BA9933F0313B01C242BDD387F661587F6317D50646BD23020111A4861';
wwv_flow_api.g_varchar2_table(131) := '6619ABDBBFFA4ACD5856AC768ECC33942AFB476E1398EDE86A177AF8103A5C48068516F3F37A1847E24D746DF3BC24D665E4EC54DAAE18AB39C52CF2B5CBDE69B9E1861B8F9146BC9DD06ADAED12682ED3B4A4A5A2D9B4B95612642A8287B8C44A171DBB';
wwv_flow_api.g_varchar2_table(132) := '86070CA55D0DBD070ABEDA842D47066C9B994AD7658A715F69CA16B329AB8B1A4AB16F6569225B1E4BA45DC3598954511D135D837ABDF4E0014393D3B218F1DDB99B340C3814D056285CC87AFC9FDD402E90BA6C9121377013CBB3FB9451603D10DB2413';
wwv_flow_api.g_varchar2_table(133) := '8D713A3B7A2E8CBE843E6C230020356ECF111895940BF289883749A4BE8F46668153455E7ED20F02D6AFD23B03439E18338EEA5741E652245A945D594DA5CC561B55C6019E4594E97635BA301B1A94B100234028A46E03C4ECBC6528E31B950E5E8962B4';
wwv_flow_api.g_varchar2_table(134) := '68B86748830982B67E0B848E41DE458579AA880201770A90AEF4CB5B355A41DCA8152529C9A606456B968A187273DC4335E2577772AF0F7508DA756C0BDAFBC424F4CBDE193C45A9AF749142391CCB4C6FCE9FC91CA9DC5D3E654AD69D5478AA59EAE550';
wwv_flow_api.g_varchar2_table(135) := 'B2A9CE3F78CEF4F7DBFDBA173D0DC62D9D4FA0CE273362460746D654EE9B57A1F01668C882A736862D161CCA1DD4C9BC9B41970ECD400D1697F7ED2EA5325EE5474075C5803F2A35AC5D8DEA5EB150945EE1105ADD7B3880B0DC6341A07699BAF82C14EC';
wwv_flow_api.g_varchar2_table(136) := 'CD588B670CF68D34ADB2CED16FE2D4BC08D7EF0DFD9B092FC1A87DA2F48F023B8B23BA3436D75ACF3587730B5C557E83BFDE413B4019B4736D7025E77117A2DA5BE9A60D57C907F3E811296C70894866A04B49C4A360D3BF70ECC69F1E791ED47A1B97A8';
wwv_flow_api.g_varchar2_table(137) := 'EDFA69B83704276E843E17FB847C0C87B9136B6AA5AA9A0BA332DEC3F0E2A285E4A38E798D0DAEEB4BD83433055B4F0D9DE1474BC2B60B701664D77CDC06366885762DED2CF572B08B0345977501AA4341AA425CB06D3B9CE7C8C5EE531798B898ACA30D';
wwv_flow_api.g_varchar2_table(138) := 'A97CC294103817DD8F6C040783767678881B2AD781A322768EA97A61766B4A768813A802CDD9E038670C2136AD3DC7B92CCEACB32630916718D82CF995DAEE7287BE6112A0B53F978A88CA9E06994F08CDE9CB71AFA09208CB39245073BFE551D195682A';
wwv_flow_api.g_varchar2_table(139) := 'DCF83E9913A91D1F3097028EF9FCA7AA8767CDF31A15E5A9BEEB11BF8C6EFEE41400D76C8FB142E04CBA6BFD40F24A001358F715C0A53DA0A177EF7DAA5E1A5345AC542A94969C8BA77A42E364B055682BDEE54C86A5C851A3EC5C3728E3174B5EB77B6E';
wwv_flow_api.g_varchar2_table(140) := '201AD294A1C971388EE8D8194BDC80178355DDB21B18588C5013B59314E1C46C6E5DEEDC67C1D44E768B90A3A26A9A6B24AA4EADCF7CAC17C6E09B652EB9A970838BFA361349C818E21E201470C9DA528C714620EE6BD601606D18B8F53CD7EA283BE8DF';
wwv_flow_api.g_varchar2_table(141) := '2FC751C7D03E06E73161B87C0A87329F4834F36ECC48ADAD666063932FB96FB7B298A0F5B7972BA4525EAE54F1CAF764386B31E70C5597E4ED86A5FF0061A06D2BD58CECC1B5957E1882C20BA2BC3618F514014509632BD5F826EEA834A5B0A880D426CE';
wwv_flow_api.g_varchar2_table(142) := '2268B2FD6F601BC34D2388A89A01BEC8AF656B62015A35002605B053D18622AA0BCCAEAAD507B9B8D0FC92B29D1F723407BC33982D19088A128220DEC918CF6547778BE142A6B5C231195D6ECAFDE32C0A5AEB26E98C43FD18AAB816871EE16A10BCA364';
wwv_flow_api.g_varchar2_table(143) := '24B1C6B41FDD2BEEC0DD60A41FC408103D85FC41B0F24FCE1204F74A29F73E93861AE86E1F13A3051325A67E4439A4BB5A1DD2314042F23319B9ABBCF98DAC5B5C3486BE37ECC4D3CC0A3F312182C71765CCF61850012C018880EE97114238DCF70DAE21';
wwv_flow_api.g_varchar2_table(144) := '221C58158960291747D866BCD41202EB2DBAE6D8D2B818032A5E14E1770484405059A354E9E2E10919438450BC25ECD27996BED6A5CCDA614BCBCC13B800CBEFDB86FBD4AA0C33400A6870DBF0CAC1C2155795D93D47A75D7A1BA9DA0A0CA1621053D9E6';
wwv_flow_api.g_varchar2_table(145) := '1A836E6C3402E3DCAF4B79572D6A40C6B659C3A611AF10C17B5E988BB69EB7DD6FD31B544F0378B7EE079DF92CAF08D23F4D21D421098F82E5F43C550D2ECF4C519BBBA148C2102FFC9945E5AAC2EA045CACB617222C802B7002085220C6505582A0D00C';
wwv_flow_api.g_varchar2_table(146) := 'B5A6E6C385063C097C12C54B4BC39387D929C23D74D56F22003D034AD169C5BC420F317960ECEE4B80B84378720F7E498A6A4A4BB269F4C6640A2F64C910043042911FFC542E1A8348DBC8D3106A162B3472471B09A1C8E22037064458970A4CB6052829';
wwv_flow_api.g_varchar2_table(147) := 'EAE6371992AB7F3D3A4CAE7E77F1E3A9D39EA7527315972E2022089489771204A98547E22B24F07F0A9407F176A54F21761487E0F86D998390F206C6BB5CCF7869B12B240BD88CE81D41964BD7A70F12C09494703F065922514F3AB6393C9F9225795916';
wwv_flow_api.g_varchar2_table(148) := '0BE43F649BDD46613B8183EA02B238A3D07677372C11388825749A6D2B45E5B20DA461F0C74DD9DE314215709E2CCE99AACBF698B60455ADB2CFEE165453CE9EAB3DBE63A1F1671D4A8477D4DA747AB023D388EFA8B5534A0401A98F8E74117EA05BA8D6';
wwv_flow_api.g_varchar2_table(149) := '40C56AD283846672866C3B4FBB2631A5439EB0B51FF572BCD6B16593CDD67CC63DB532A55EC715CD44D20B0D53677EE1EE43240D8A6D8C779FBC8D31DB589E577EA2A45E25EC56D4F0BBA16818FBE56970A923A9B5AA75DBE27C0EAC3A914157BDBE45DF';
wwv_flow_api.g_varchar2_table(150) := '1D2F3D171E8477D4FA098009E7305EC2DC0147443EB34D18B39496A37B399926BBB97D997CAC1BC4BAB9BB6B329613B5E37879ABB48181CE291E8258980800E91B3A6DD39F99F429935FB0C570964CF575E772AF43D3867274CD4A7A3F030C77D4FA2564';
wwv_flow_api.g_varchar2_table(151) := '1BACF14C024B1B598AA800D2382FF886E0BDEC6653D6167679ED2B03922524B5EE144A13B4B5FE48EE76FC512C739BA03A1F54847A1F078F8387E0611EA6FE7CF5E415E9E412C5518D922A7D9A66599694D2CBB54DE976D25209D877BF41E85FDE06ACD1';
wwv_flow_api.g_varchar2_table(152) := 'EBA9D0B8E2AE11DF43A1F40E9CF4E3E25D751B82006C5C131D6A6F85AEACEE205D099A7378E7EA978A264DA320F5145ADA60B4C6DD2782C65BB14387F6D456E9E214594883B0F911E9CF43A1F56E5C63F00C29757C45D6866E28A17A371D43A1F23E22F0';
wwv_flow_api.g_varchar2_table(153) := '285631275ADCCD7C1CC24031A1190B6B84F2BE6477F5C8B0E9503376F45F8B1EA43E4FE94F81F13A69D4941AD60FA8FB57C5FA0F57F527CC18697F898D28A8D1F66A3B6F329BB8B36778964FFE48166BBCD5C2A6B6BA229DBB88E177751A6EA003011529';
wwv_flow_api.g_varchar2_table(154) := '6C0B509563382915AA55CD579A9CA9687FD658343FAC4BFA64C418B8458AF39941546883456BF88AB098608B04F52FE59878527DA04D32D5DFEF02896518AD4C54A5ACA81D171D83ABD5F8BF07F44572B04D980944B80DE4A83DBFC955167BE08F6D98EA';
wwv_flow_api.g_varchar2_table(155) := '09B57DE6A7E1083F6C4767A73BB22FB4AF24A0B9856CDE096AFF00D20DF1AD53111B08D5E1671398EA3D0EAFC087C4FD1F6E8F4B8FD3E3A711E8757AB0F91F42BE47C8FD69D1970FAFCC5E97D5FD03F07E8D47A1F49F9D7EA5EA74CF43E044FAAC9F03EA';
wwv_flow_api.g_varchar2_table(156) := '338EA6FE64611F8730FA9C3D3FFFC40032110001030206010303040007010000000001000211033104101221415120051322303271426181911415233472A1D1E1FFDA0008010201013F00F1284CE66E8E654EDF54E411F10B9F123E98C8AE10C878819C';
wwv_flow_api.g_varchar2_table(157) := '4A011BA28050805190F0191F016450DC0442C3E16AE2090C03655B0188A2092D0476111056C8CCA62B9B2F6FF7418D84E610829450F019422830907F64584016826EB49179473F4E01B41ADDA4EF2889B858FC05EA526FE5AA5092784D1D808474321B14';
wwv_flow_api.g_varchar2_table(158) := '482A042D0D4E60EFC0F80891288DE09F944B5DDA0F264447615B7E0ECAB348F9095430AFAF44BE9EE5BF73795066237E95305AC6F10153A9AB637446CBD4303135A98DBF5040A04F6A4A2E3D9527B46507180892B51409EF208E60EC8DD35C1C08369FE8';
wwv_flow_api.g_varchar2_table(159) := 'F61113D6A0838116E2C8DA17A5D5F631A1A4FC5FB7FE2AF81C3D67879003C58A7D27D33BA060CA6540F106E88044158FC10A24BD80E83FF49B6F0E0A16CDB128F88B1C9E4B48704D76E398123F76F48883DCDBF3FF00D0A64833C274B5EC78890E54DC1E';
wwv_flow_api.g_varchar2_table(160) := 'C63846E01440220C2AD86E59FD2DC2A7543B6374F635EC2D700410B1386761EA386FA4FDA50B20B842C9ABBCF8F1191121169A6D6127607E27B09DB3607E9323F8DC2616C96F04C89E8A792EA60FED07F8580C4BC61E9C4910A8E269D41D1CAB500F9222';
wwv_flow_api.g_varchar2_table(161) := '51041854EA8221CB1141B5E916387E0F4554A4FA4F2C70DC7836E5725143C8728A1B8541EDDE9BC02D72AF83AB4F767C8116E50305B378820A2ED40FEFBAF4F24D08E9C8E90A9E25F4C86DC2A788A7536077E956A02A091745A5A482A9D4E0AC761056A7';
wwv_flow_api.g_varchar2_table(162) := '2DFBC2208241FE466DBAFD590F0190E538642C161AB7B8C837013F0F4AA6CF60257F97D324C12161A80C382DD44EA2B498895009947E3B854714E101D6ED3E9B6AB641DE139A4182A9542362BD4F077ACC1FF21982E13060A738970B2843C0642FE14C68';
wwv_flow_api.g_varchar2_table(163) := 'A6DD3D26904CABC23A49FC22F6F454FC96E42B10161ABE8307ED55A936A0917441698298E0416B963B0BEC54903E0EB1C8237C8790BA17CE8381A609FC20A9BC8D917B6F650D23629CD31B27ED11941690B0F541F893BAAD443C48BADC1556932BD22D3C';
wwv_flow_api.g_varchar2_table(164) := 'AAD49D4AA398EB839F033D3F199190C87DCB95CE541FA5F1C15EDB8C6E1411B9404269904AF71C10AB23708BB56E3A5EFD569830A9E25A489D8AA38A0400FF00ED57A41E3532EA89E17A8E13DEA65E07CDA3FB0AC8A16F3081DD13206DBA19616B073209';
wwv_flow_api.g_varchar2_table(165) := 'F900B4870174E03608D385A77DC151C05BCC27B2448BA2132ABD9CECA8E2BA71056B3AB56C810E1217A8E17DA7FB8D1F171FE8E42C89F200824A08A6E4D7169041DD33D41EC6C3D92998FA0E8D5217BADA9F6904222441E91A701060253446CAB5381A86';
wwv_flow_api.g_varchar2_table(166) := '6CACF67EE151C4C1DBF909EDA788A4E6F042C4CE18B83C1D8C2A18E0E73C381FBBE3E3C784EC9A731B8459D2D4F6EED24154B1D599787772A97A85078874B7F2816E9904145A08994679B2708272757A0C8D550094717876B87FA8D9546B8A8054A0F9DE';
wwv_flow_api.g_varchar2_table(167) := '0C70562B0CFC4FC8C6A8DC76A9FA2E1A99D4D9D4A5A096DBF894E2E03823B8F08C8E4DBA3936CA51885A590853E8A9AECFB5C47E0A663F12CD9C01FC84CF546400FA653EAD1A9BD3703DAC6E3AB8AD55AC7C35A7840BCEC0FEE0CF69ED1AA246D002F43A';
wwv_flow_api.g_varchar2_table(168) := '069D0A8E3325D6536213F14C6552D7480AB16BAA3CB6D2B8198BF8F2A32014236462026A37CA074AC08EC27E0693B97047D384C87F3D2A9E9D8C0DD7484C1DF4DD617D77138786626938C7362B0FEA94716C269021DD14F76B69E41B4DDA7216450F304E';
wwv_flow_api.g_varchar2_table(169) := '983DE4142390BE5CF8B9F8E69030DA667769E53AAFA991157D3D8FFC154BDF0E93821405E411B94E3703933E23C8781CB5B1BA65B3BF708993E4090642D38A7BBFDF3DA38100AFF07A66A54C63EA38584EDE1C7D06A0775CA0D3C04664CE451F13F54028';
wwv_flow_api.g_varchar2_table(170) := 'B4A0C374186505288051691F5A7219C21F16A945C1070E5073517841ED5A81288695A3A399F09FADC29FAD28193F40952729FA47C4D9723E80B0FA8505FAB308F3E232FFC4003A1100020103020306020706070000000000010203000411122105314110';
wwv_flow_api.g_varchar2_table(171) := '20223051611391143240427181A150627282B1C1062333D1D2E1F1FFDA0008010301013F00FB79FB11F24F986B3F62B9BB8ADC02E79F21505FDBCC400C41F43DC3D9AA8939A07CC4B595B41C61586C4F2A16729D436D4A33A7A9A6B79460E8D88C8C510C';
wwv_flow_api.g_varchar2_table(172) := 'A486041EDE2D049AFE2E72981B7A529C7226AC2FF388E53F81ED35BF772681F2201AA541807C4363D695868D4A0FC32D89233CD4FF006F634D028D272581E4DD7FF7D457D6CA93E31E2F5FCC63AFF5156E219C7C29914EDE13E9ED9FD4571578B87DE08A';
wwv_flow_api.g_varchar2_table(173) := '4C88DF78DFA7B834082010720D380E0AB0041157D646DDB52E7413B7B52B78AAC2F7562290EFF74F61ADAB03B71D981581DEEB4A7041CD00D88A54392CBF93803753EF4AC1320E7E1B8391D463DFD57FA53C65188270411823E79A5FADAF91CE0FB11BFF';
wwv_flow_api.g_varchar2_table(174) := '00D8F6AFF145A0BFE08D2AAF8E1F1FCB98AB2E29736A40FAC9D54D5A5FDBDD2E637C1EAA798A745752ACA08357764D6EFA9774CFCA8120E41C1AE1F7BF1D42498D63F5A3DDEBDBD3AF70F73844A2447B66241FAC87D0D4918D0DBE0B360FEEC9D0D292C9';
wwv_flow_api.g_varchar2_table(175) := '8231A0807D94FF00C4D15C064D3939E5F86E3FB8A8009229606C95743FEC6A789A19E58C8394720D23BA306562083B570FE35AB11DC11ECF4555D48D9811579626125D374FE948ED1C8ACB9041AB5B95B88C1C8D5F7851EE1F24F645234722BAF3073504';
wwv_flow_api.g_varchar2_table(176) := 'E978242831AD3C7ECC3AD26F206619120D2E07A9F09F911520934A48724804103916439FED56EAB1DC11C81395F70D5C6B83DADC5D4D9508E4E750ABEE0B776A4900489D196B6EA2B877147B72124CB45EBE94AC92206520A91F88ABDE1E50FC4886573B';
wwv_flow_api.g_varchar2_table(177) := '8F4A82768250EBEBB8F51514A92A0743B1EE1F32095E370CAE41A82F6DE6DA5F030270C396F45728C57182C0823A8A8E328C99CEC0A81FC279FE95C542ADCE7D5050D4DD6AF782DADD02F8D0FEA2AF3855DDA1CB8CA74615C3F88C96AE01C942771514B1';
wwv_flow_api.g_varchar2_table(178) := 'CD18746041157B639FF3221BE775AB1BB3049A5F3A0F3F6A04100839F43E61EE2EF51DDCF0E4C72102978ACB819504D5DDC9BA2ADA40D22B58CEC072A076C5604834B6318AE23C0A360D25BECD9C94E86AD2F65B1974B29D19C32D432A48A1D0820D5F59';
wwv_flow_api.g_varchar2_table(179) := '060648C6F8C915C32EF94321FE1EDDBA8F24F2EE448A63C63A53A32AE08A5D8107143505FC6B4367191440D1F9D6429DA8EEA5AB8BF0BFA4219231891472F515617D25AB856074751E948E922065208357B6E51BE2A72CFCAAC6EBE3C786FAEBCFCBE9DC';
wwv_flow_api.g_varchar2_table(180) := '85CBC6A0731D9246ADBD7C261B73F4A25C1DC52E33BD281BF66A0C0D719B064633C606827C40743EB5C3AFCC0C11C9319FD0D10B2C646C55873A5792D6E3DD4FCC5432ACB1ABA9D88EDEBE5DBC811F07AD7C741B608A0C1B6045139C530C10B8CD1850F4';
wwv_flow_api.g_varchar2_table(181) := 'A6B6DFC2D5A1972197AD7D1E161B6454D66DA4EC1948DC55FF00047425EDF24755EA3F0AE1B7CF038827C85CED9E86B8946352C806C76CD70EBA1149A18F818FC8F9EA4B60564A9A476DCD2CF9E79AD7B0D245648C135D335ABA74A5240A78A3973D0D5D';
wwv_flow_api.g_varchar2_table(182) := 'F0D8A407E2C4187AF5A92CD3E01886718DB3BE29D1E272AE3041AE1F75F153431F128DBDC7939ED3D80E08356F6D0DDE0A49A5B1E253BFCAA4E1774BF5406FC0D189E23E352A7DE95B0734B364EF4D2E90318E74CDAB246361513E4907B35629E089F246';
wwv_flow_api.g_varchar2_table(183) := 'C6AF785A4EBB801FA3518EE2C6752CA4107F222ADF13852846E2A6B3D2A847A78BCA3DAACC8C1958822AD78CEC1671FCC2A37B6B85182AE2A7E196F20F0E50F4C54BC2AEA2C90038F6E74C183E082B492E93A71F2A5D2465719A07967B16295B38526841';
wwv_flow_api.g_varchar2_table(184) := '2B29CA1A9E05DE2B8418C677F4A1F47B73A61274E76F6A7BF99C692462B9D0F20F69EC47746CAB106A2E2D789805837E350F1C46DA542BEE37A5BEE19363515FE65A3C3F86CFE28A400FEEB549C124C931CCA7D334B0DCC24895187A1AB6B688C68597C4';
wwv_flow_api.g_varchar2_table(185) := 'D4740E948C74838C6739AE3B721E644523006E7B0464A82297200EE1F3B26966957948C3F3AFA6DC9C66527076CEF49C62E57EEA1A5E38DF7A107F3A938B433284C15CF3CF2A96C23972D1B8152DABC04063F2A0318F2CE33D86B3E52080E7E2E7DB1412';
wwv_flow_api.g_varchar2_table(186) := 'DB9A5CB0A97411B4E64343CB3DE0A493BD74EF87840FF401F7CD34E1869584283E61AE9D99FB4122B3DCCFD9B06B06B0680358358ADEB3FB171FB0FAFD84F91FFFD9';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784239569134151253)
,p_file_name=>'img/best-in-class.jpg'
,p_mime_type=>'image/jpeg'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/img_persona_male03_png
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000001000000010008030000006BAC5854000002F7504C544547704C5C3029592D235B2C226F4E435C2D235D2E245D2E245A2D235B2E245C2D235A2D235C2D245E2D24602F266130266232275F2F256030266839';
wwv_flow_api.g_varchar2_table(2) := '2E5D2F255A2B2163332960302661312765352B5E2E25647633613227582B225E2E245F2E255A2C246D3D3191887F5C2C237B4D3D9B6E589E725B966955825543754537B98C70BB8E72BB8F75BE9074B88B6FB6896DAB80666F4638895A48A37760B88C70';
wwv_flow_api.g_varchar2_table(3) := 'BA8D71B3876CA87D64B78A6EB88B70B98D72B1856AB98C71BA8E74AE83699E755E9F765F9366518F614EB88C71B98C6FB88C6FBC9178B88A6EBD957C512B234D29214B271F5430284D281F502A2146231C4C2820A07760A57B6389604D835B49966F5A9B';
wwv_flow_api.g_varchar2_table(4) := '715B9D745DA17963A47D67AA8A799F7760A0765F9E765E9F7760A177619F765FA47B6292847A9F755E9E765F8F806F977C6A9E755E837A749483799F775F9F765E9F765EB78A6EB98B6FB78A6EB98B70B6896EB88A6EB88A6EA7836E9A7660AD92828E6B';
wwv_flow_api.g_varchar2_table(5) := '55898077857C75DDDDDBDEDEDBE1E1DFE2E2E1D0D0CE847F78C5C0BCDDDDDBEAEAE9DCDBDAC6C6C4B19585BFA28FCBCAC7D1D0CEE3E3E3E2E2E1C6C5C3AE8E7BC8B1A1D7D6D5DEDEDEE0E0DFC0BDBBDFDFDEE2E2E2E1E1E0E1E1E0E4E5E4D7CDC7C7AB9A';
wwv_flow_api.g_varchar2_table(6) := 'DCD7D3D0C0B6C09B84CCB9ACDFDEDD87827C837E78BBBAB7847F78837E78BAB8B57A7670837E78827D77837E78847F79837E7887817C938E8997928D837E7888837D837D78847F79837F78847F798A857F85807A807B75B5B2AF827D77847F797F7B7584';
wwv_flow_api.g_varchar2_table(7) := '7F79847F788A847FD3C7BE857F7A837D7876726D78746F7C77727D79737B7671A5A19D88827D86807B837E78817B76837E7977736E74706B75716C847F7A6E6863736F6A7A7570726E697F7A75847F7986817B85807B8C87828B868089837EACA9A5827D';
wwv_flow_api.g_varchar2_table(8) := '78858079716D689E9A967E79747B77719B9792837E78827C76847F7986817C827E78A19D99837E77837E78817C76837F797D7873857F79706C676F6B6679746F847F798F8A8584807976726D8481797A756F87817B6B645F6B635E6B645F6F69646B635F';
wwv_flow_api.g_varchar2_table(9) := '1DCA486A000000FD74524E530008101A04439AB783726A8EA97AF0FFFFFCF7FFC723FFFFFFFFD901E54D5AFF32FF02FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE2F0FFCAFFFFFFFFFF36D0';
wwv_flow_api.g_varchar2_table(10) := 'FFFF15FFF37C56FBE646078CBE10206B240BA260F7E3F0D587C2A75AFFFF76FF282D385E7EF1434D57D9FFFFF5FEFFFFFFFFFFFFFFFFFF92FFFFBF2BE5FFFFFFFFFFFFFFFFFF3B1A9C94EDFFF0DE9C3387E4FFFFFFFFFFA45DAEF0FFFFFFFFFFFF7D66FF';
wwv_flow_api.g_varchar2_table(11) := 'FFFFFFF3FFFFFFFFFFFFFFFFD58CFFFFFFFFFFFFFFFFFFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFCB41E9FF80FF6CBCFF74FFFFFFFFFFF8FFFF837FC0FCFFF3EB91365EF0850500002F8A494441547801ECC1830103400000B1B78DFD57ED14F52502000000';
wwv_flow_api.g_varchar2_table(12) := '00000000F06A526925FE9332D6F910532E39A45495F82B525B5F5A1F73B535E75C6B9F12AC32E22F187DC37C70631E5AABC3300CFE077BC534459259859FF77FC6BB929252CE7D80F663A93E53AEADF4002329C9F9174527F7C7E5E1F4317EBEB7F57C17';
wwv_flow_api.g_varchar2_table(13) := '045226CA4852FC4BB0F365FCC37F9DCB2C908164E340B467036838AF26E39EFED51C60014653AB45317036EAE4DF541E65C696A23C5743751DAFFFC38641A29CEF48B424CE63EDC0E7E51892535221BB65C6BCC8FA738CF64F8775651452031C526E8691';
wwv_flow_api.g_varchar2_table(14) := '4A2AC78176D3316EFFFA688114925D8F60265508B50D2056E3F37FDBECAD843D89BBF315135BB01ECF0EFC7CDD6EDFD7C5F588D0716AA41B5F5151B6F91A49EADD16F5AEAA76D5EE0C776622489A15CB3D04AB0FE338F4D695021326E5DB5C7C7B2A89EF';
wwv_flow_api.g_varchar2_table(15) := '2C46300293696D7C02BC2CBAD84145344904CC06DF81CF7565EF11A75C93A46E030C1280182D550236DF03F7BFD98BEF281BA4DC283DABB83B3D9ADFDD00B9511878106EF710FF4F003AE32F218241A2248B84C860B3219F85D3B3DF5DA475E65FA092E8';
wwv_flow_api.g_varchar2_table(16) := 'EFBFC9FD2D1902573FC35D807974931B4DC5961C69FA218A4C1352BE0C061686FD447C3D5BB9C3F2D6270421D528A41F667A1794D1EAA106E157FD0C7B921EDB8BC6BDE49E9851F9EEC525E693613EFE4EAB90ED8B64B4E7A4C398843193956459B64427';
wwv_flow_api.g_varchar2_table(17) := 'B55F0E33011648495FEEADB9F882B5C6F3B7B18789A48EDFC3FCDFCBBA53DE346C1AEF39147A27823C49A93440DCAF87B804D36436857AF3887FF0C7E3D134703898BAE211ECA208514DD364FFF968380FF024386DAD4CF903BFA9318BF38A011000D77B';
wwv_flow_api.g_varchar2_table(18) := '6C3C50E323EEEEFBEFF5E2B242FE2B17DC2CDB766CD7B37CD608F1B47B990270893E916902332399A4A3200BFAB20EDD6F1978F9BCAC3FBE138413519CA499EDB16E125C527E77800693F15F795138599695768104A0090030A5807A3F077CC3EE00E232';
wwv_flow_api.g_varchar2_table(19) := '0C9289AA0A823A68DAD2F52721AD7BE10111716197599386755D476157FA6B8EA02608F77B11BF8AB0DDBF64B94D72D207C11039856D59BEEC336A2008026A3ECBD648BD59B737AE2B71F832DFDB3E4F96394D51D6FE021D2799C928A4D67B02BBC5C3CC';
wwv_flow_api.g_varchar2_table(20) := 'DFFF1B5C59B6D31CFCDF6F98A3F7198DD047A7A3B649D51806E0D8A4E3E6CB3C3A1A617054BB81F1DEFD9D32053C6A4DF0334441C0683A188D8E7ABDD97C3E3B1A0C3A02A342001860E301A407BBBB0F8A6F7952BB3AF0BCAAD90F9B638302AE6E89C00C';
wwv_flow_api.g_varchar2_table(21) := '3140DA1F2669C09833AB228C888A7308B44F5E167DE69D9D57B51B0894839A97AD23832D08F06201A3622D40E1B694E215E7C55D54F0AC555A7CF0A26E2BE6FFDA29535B7390FE4C00598780CBB237A2A8CAAF55D119A2000C01DA79F0B21841EEFEB766';
wwv_flow_api.g_varchar2_table(22) := '7DA1BD57A580D6FED810C8A34209C4C53D03F1605604C8969E44983CC365029851A8033197D66F62E4F983A29BDBEAB50D39941840ACD98E73F582428020C2C589C813CEFBC72F8BAE52FD04FC73B7E8C5B6E667E014055E0130A38299B3CC79E28D2243';
wwv_flow_api.g_varchar2_table(23) := 'B883FC70DE8A1A6B28E0C54ED1BB6BCD526C104B1E5B903A27E284C49E4533CC6F5040A4B04E8E5AC588AA8655A0CA01B344B1052BF356AE3756C4885138EB342A1256C30C6286F1C961AB984C7A50C30878F46827D09A2706DB303322C400C366CE0AB1';
wwv_flow_api.g_varchar2_table(24) := 'CB32EB416ADFB3EC01082127397DB9B3B3DB78D0A8DD4AE9DEABD622B23C7ACFA042090063030991AAF556C50A03E47C6A05804AF1C6E470B5C8592FDED6AD2FFCE777ABD572B55A5D1CBDC6EFE0046A25CB001013009339041420E4022E96CBFC8B1697';
wwv_flow_api.g_varchar2_table(25) := '7513F0A767ABC82F04B002D0F23E8C4255D422C01ECCD04C601810670A01ABC07211AB40BDE684570507BF1601440C8084C1E2C4411839EC9C8702A280BACC733659AEC2299C6B27E08F7F5B5611A0286140EEEE4794E55CAC231504588A5BA700C87A24';
wwv_flow_api.g_varchar2_table(26) := '578BBCFCE1F29FBA09F8CB7F8BD8DD126044C50144B88300F656884DF91601A92346247D7D15BE631D2EF58B80BD578B42C0EC352A889C202088280072009450626C9649F93A03FEBDE9451090A7C17FD66E62F8FE93A20ACC12FC1C8F08E12788206033';
wwv_flow_api.g_varchar2_table(27) := '53D8F1CE01C93424C1C53A5482FACD0BFFF9DEF267AD809734498124758C0D8CB20F4C20C9A74E1969628AF0C805ACF25EC06AF1F67EAD05300294F0E070369F1F0EDA89410909005530848CC5E0F0683E3FBA0E6F60012B27D33CFC17CBC565FD1687FE';
wwv_flow_api.g_varchar2_table(28) := 'F28F75EC08CDD333E4183AD86F3E6AB55ABBCD9379274144332BCC0CA843DA9FED371E86373C6A9CCC475946EC38F403622F60FD8F1AAE0DBD58C408B84911191D3FCE97C702ADD6E366AF9F027AAECEBB4C1900A5A7FB8F5BF9CB61DFD8CB0727070983';
wwv_flow_api.g_varchar2_table(29) := '11050496CFEBB83FEE6D8C805951054627F932D9E3EEF1BCD7EB1D9F348FC72913011007066026CD66A3D13CD93F0E2FEF371E3DEE0D21949502DEBEAAE33131979BB18057D30B817FD8690F812186C3617E07E27833466A0F4E07A3F6506508F6C3E160';
wwv_flow_api.g_varchar2_table(30) := '767C98659A1D1601104702B5E3EF8B4A00CCE8606C63EA2344483D60334700CA495063E25D019C8349035692C932B7B8ACE7F1237FBB1380F3C4E10E05032027CE419D174685A863768E8BF87021072C42F9DFD573E3F83F363900BC3502A4CD5D75E759';
wwv_flow_api.g_varchar2_table(31) := '629509779CABF156082003F5368E069797F5DC35FCFC6DE8C4AD0F1214108A927A2A6B82580B218F804705130B8907C0EC3999C424F89F9A6E93BE777BFBFEFB63832D8C31CEA1C0670A270088519272FB8D08ACA0C08C6F6EBBEB77CFEB29E0830FA7D3';
wwv_flow_api.g_varchar2_table(32) := 'E9E427024CFFA3F70F06C3335035EDE32DD85A561100679D9BE3F969DB64090ACCE8EAE38FDE7FF6AA96E5FFE4C3AB492E8001AD7AFDEDE3C5C5C57AFE061BC442098073603368841ABFB8198AD908987C7AF5D1679FEFD5F1F0A82FBEBCCA2360301472';
wwv_flow_api.g_varchar2_table(33) := '8A8899AE63B37EC88C0A8F0AC14D786DBD2CD3863290F483C3E9E9575FD750C037DF5E4F631580028C4872B358E51C9B6A71102E0A288644FD462E60BDD84FCA661012055C0DBEFBBE7E027EF8F0AA10C0B4C973E9BC9827BB2D0408413CAA691146FF71';
wwv_flow_api.g_varchar2_table(34) := '9CFE5B755F238700378A02AEBEAC61087C7D3D8D55A0A3024013044C677D914FF11D1A0F401D18D0BB65C3F6716CF4D63709AB8F7ECE82808F3FFA68DAF9A2866DC0F5473104C6DB6BC1E6282481C56D1B2080E3F9AEFC643ADDC5EA62D9ED9F19162701';
wwv_flow_api.g_varchar2_table(35) := 'D3BEBAFAF8E34FA7831F9FFEA166EC85089856CD2053B1070426BD3EDE9FB5CFCA895F031157692041DABFE9766FFA06F0E24455B4FD7FEEED63BB59258903380BBF85775E16ADBF74CE5720AAD48D3807C477B7708391E52F4727394FCEE1BD07112C66';
wwv_flow_api.g_varchar2_table(36) := 'E6BE80F83928ADBA28AAA38A655507B27C73E41D9A3E00B3A80B003805249F4CFC7EE59B894C6E067920E44F2613A3005BD45217EE4A40D264C0E1DD02496D53CC00105E5841A37910E13C45C73AC18EE64A8C962E92DA61D680EFEF8BE6E2C57D6B0308';
wwv_flow_api.g_varchar2_table(37) := '06183B345816E73E0D44ED7E2054549B4D521E5E2F707C71592645D1DC02DDD506C430A0AA10C058FC0A6188C2F6F531AB0350249B57EF7FF10ECFCB4810A965B0730AA17DFAABD9B7F9BFB8A04D09310AD401D8D5C0CF670739172877012843A4CE0A48';
wwv_flow_api.g_varchar2_table(38) := '152DC1CEAABFE5AD4A96A1C3B04C5086024E81B82E23EB72FDC63B4457E7AF765530243094202BC012865619228DA6D3703105562AE0363E4691A3314B92AA9A9F7EF50ED1C5A7EBBAFDCB45060B1248DBF9755810CDAAB251957104ECB704BB01A27401';
wwv_flow_api.g_varchar2_table(39) := '589F5F7987E9E2CD7551146106B03AED5AA70E7D63A7B3AABE4796C52C8C0090F483054019560117CD974571FEEDC83B546F4FCF5F2D20A99FFFD0DEF2366501A4EF18E2725DCC4334ACC0A668F50726A259797DFAE1C43B5C17579F6F2200CE710016EC';
wwv_flow_api.g_varchar2_table(40) := '892801D96291ED6BA37383D354228CF0FDE76F5FBC03F7614B68B39BD053A03D0D8C2C03E3570940B71F3E7A07EFCB4DC0D658B0EDDB2550A0AB8B3D6BF02BEEBC1138BA2771260508438E310C003B150C5900FCC11B83078087D7DA02A2C28E316095BB';
wwv_flow_api.g_varchar2_table(41) := '47346C00D0ED9937068FAFC12CB06AFB4A2000C339EC056CDA8FAD712F33A3E0E1C41B83B36D3702C80D139C81ED174198D111EA6B84F6734760F278EC8DC1C97DD05ED1D490052C54C11A009041C127B46C4A6805DBAFDE281C3F4E30C056009A3D392B';
wwv_flow_api.g_varchar2_table(42) := '64512325421C131A4ED0F11FBE78E3F0754B18B0224ED7CFCFE522700C36265ACC7FFEB91F10693F12CC268F27DE381CFDC6C78E756C55198060FAFCDBDFFEF6E775399F57CF3FD74F4BC21EAB00FEEDEFBC9138FE7ADB44C05A413F27CAC2BAD97BD56B';
wwv_flow_api.g_varchar2_table(43) := 'DA9F1E26E7D86272F7D11B8BB3870983449DB578C9F0459D03BD321B54447DED9CB3C1F683371E8FBE0FEB5CDF48598141D1BC4EFEDACFCB3803AB49D1231026F75FBCF1B878F05D9E072A005955260598290B178B300E3302C0CA18A0EDA337268F5B5F';
wwv_flow_api.g_varchar2_table(44) := 'F3C038DB4E739DB30C0865440191C03118438E1E2EBC31B9B89F88068E6119D60964703440D5CFB57947192DD6EDEFBD51397EDC92CB2D00923C073815E9573E98C9090081A2E7DF786373EFAFD2B4BBE200B77B8316430266006C01BAF9E88DCB97CB70';
wwv_flow_api.g_varchar2_table(45) := '254DF1B32ACD1FC090E1178699C12F6FDD5C8C2D00A7F329607211B2CA418A0191F621856D178E648C19F0BE9A47C87F50F48BC2FF8DA94B02580B80EE8FBD71F9FABE58CE337682160F1F79B871CE63BC059A0024451CA1A3345C0813B41C1818690D38';
wwv_flow_api.g_varchar2_table(46) := '7B5F559B6416A141466119A286B0C7068DA61738F2C6E5F87477D667399F9202202770CCD015A327E83947E32B82DE69B169767A53555743CD420DB7FD21588CB16889F20803B03B31931455F51483541548FDE66237CD965CAC711285111A417073E68D';
wwv_flow_api.g_varchar2_table(47) := 'C4D149DF0D26C96653C72029C308AC823425506E8401284008678BAC5B13F6C75304FFF0C7A3260E4D06B48AF9626A1C096A2B2065C9B2340A67459CA1636E46B31AF0A73FFFF12FB5BF7601682C97E5229D22F08928A08CA6E1227EAA9625241534B2ED';
wwv_flow_api.g_varchar2_table(48) := 'DF1A7F39F84438FBFB3FFEF9AFDABFAB646F536DD6EB723E8BE3781687F1BC7C9554EBAA9C4244858C2120FB0FF566ADD74A1085F17B8157C1E16071F7A49D54B3BFEDE852E30EF1DD894C5C707851C6A26F30FF64B5FB8EAF952BD54AB5FA72FB4F73EE';
wwv_flow_api.g_varchar2_table(49) := '2CDB2E5408A9C900506BCCFE4698EDA08869E030DBC3F8C40F0C073852993D0008D609210DFB5EF3EE9F6BE629A50D52C688CF010A13F17E20DA2212A59181FC3B2071EC3800E020D3220D9A6F6B5E0B3A5D8B19A05739DF10229509B87E149980313301';
wwv_flow_api.g_varchar2_table(50) := '3A048933E80041BA5CA5BDFEC3A3DE11F098A70C7B701E9EF3BEF804C09C9D402646FE940F200E30794FDA0B07C3518FF6F24DAD27A25CB34F39D6D808CFF4463016C560AE2C1C06F7608AC30BB073F03A62C1D3B3BA1DAD4B608F4AAC373C8D019C555B';
wwv_flow_api.g_varchar2_table(51) := '631A056E0F7861018F6F2C6D97BF5FD33803DA1695F46839ACAA1DCBFF69322858035CC6517F97C6B3BB1FBA5A60EDF3B240A734781950B00630CFE1BC7EC550E8EFF57AD4FABAB9D1B1159C5E7FFFFC2AF1365F0DCE3726BA0D634E7E381B0FCCDE19FF';
wwv_flow_api.g_varchar2_table(52) := 'A3E6BCFADAC6D2307E936F3157DB77A7F7DE9BB94DAE762FB7EF7E83C9D514FF165B62F08F29A29B5E06E163DA2BEB491318074C1F17E44611A447B484FD02235B474636B94B23FF842E97F739EFFB9CF7A8D9A5601940838354D7D73FF0E59326C1A9C1';
wwv_flow_api.g_varchar2_table(53) := '9F86E4E180D4E0A2D5B101EB72D8E26727FF5FE7CB82A78F0CA0A6C9F5B8608885C323679FA8DA1F1D1B9F202522497CF88B48A26384EE02F8C0CAFFF22D06F997176A5BEC0771EA5420DC3F726EF0493183CEF34313322E5CF4957C5C92CA85F0EDEF6D';
wwv_flow_api.g_varchar2_table(54) := '0B388AFFF48BD695D46E3EB3E27FEF5245FC6220C4A0C9139363834F44F88323FD7D53D1E9D8E519AF6007C015E0FD903B034EBF7F14FAD3FC2412CB00CB9AF1AFBD0A2666595C9D9BEFF8CF49B7BE8EB171B6A02C2E2D2F2F7D27345421B45B4B820F4E';
wwv_flow_api.g_varchar2_table(55) := '9705F8F3EBAE3D824FF3AF9FD67AA5AA87F9567E4E4493D1547A757CAEBBF3BF27B8F11BEC5ED591C9E6F204753820361CA3D66A02381FBCF2C6EB6FBF66DBDF5B9F7CE29C36E8A96991AA0490BC85A4B2960F3300EB34343078529DBFA37B32CC402BB2';
wwv_flow_api.g_varchar2_table(56) := 'AE13160A42451C765481FFD93660F5C367ACE52FC7BA8FECBBAFDAE710BDF0742B7F988BC6BA30832C4383453CDFDF71224F1F1B1DEB5B4C6D2496A30C20B0095E0195482D5C8133EF57B81F7781575FA869BFD7A3829B0A3494A06462B96F60F4C49D43';
wwv_flow_api.g_varchar2_table(57) := 'D931D06324A35BD3B1749AC1E2C236EF022B7D50129BBEFDBD95FD2FF2EAAFE055AB01680D36DC03A1B798FF54D220361535D6AE8C7E71925AA35F5F1DBB065D650085658285763D2254E7BF64B70597FE72E6FDD79FE7C35F85B50416B9F557B9C0B08A';
wwv_flow_api.g_varchar2_table(58) := '22046001A0D5A1B91B573B4F8AF5758C4D82E046BE78F31E5188F697FAF20971D5B75CF6B43571E3AC56418C10C816C0169868B5BFFBCB13D11959CE2FE34800FECD7792745C015ED0B51E7E8D843BFAE2F87FDEEAC4CF1F5DFE2CF97370138F5B22CB93';
wwv_flow_api.g_varchar2_table(59) := 'B73A1FBB1DFE7374280F6045D66043240318F64AD50A947F149A3EB746FB9801BEE5F9BC3D58DEA8FAD1E24D5443AAA1DCBE75F6A9C7EAFC0357A0C34227AC5311201327CD2C0479CDDF0BB1FD6D4FB5FFBDFBBCE7F37A77E2573FD687A3345B2F8B3D4B';
wwv_flow_api.g_varchar2_table(60) := 'FDDD8FAF39BC3A329ECF138A18A98D8DC46234BAA542BFAE85737552C52856CF6AEDC76700CF7BB52DEEEDABF186983D13AEA9A6613070485E9DDB792C8BE5535F0CF4900ECE9A6258C47677D91E56A0CE78A56383E8FE45536DC53E90F79E7DF6BD176A';
wwv_flow_api.g_varchar2_table(61) := 'DBF90C183CFE40BE20B08825F6F7F70F0EEE108E24B8DB73FBEADF1E75E90F0E8C1BC61E1C34B850599DC8A7BDCA4920E0F3F276A8F9557711146F995273896FF65D28E20F8AC7C50B1C3202C054535117B8DF3255554D9311AE8C3ED224F8EFD5B1BB32';
wwv_flow_api.g_varchar2_table(62) := '1C56A8E8C844007781A9C36202881525200A5E7F6F0811EEEB52FDF31E27FA77ED5D40A2BD9D3F7B41392CF802922055D54D44B91887CDF592E09985C5442AB1914A32C87707BE7C746DC1E0FC64985086B017B6BC8034A48DDD6903CC2834F2EE8F2336';
wwv_flow_api.g_varchar2_table(63) := '3606BE2B1C2A2AF2757C89DCD2ECE10A944E1979B6952BE3BD4944B2A9DFECF537348A956B425976042068D000968CDEB91C53CC0500F985B1D14722C1A92F47AED9CEC71BF3A9A5546A1A2562D1C5A924CC5040ACDC11E28FDC0CA90A03C0867D5C8160';
wwv_flow_api.g_varchar2_table(64) := 'BB7D8341BE0FC8C98C82DDEB3053C96E46FC8220552E086CB804209D2C6043617DAEFBA14BF0D4D5816BBA1C2770D2463A6D4CEF9A28B1C08AE805A1A209AEDB3E5C51CC0B286226B7BDCE58B7799C6EC0D3CC3B20E1BB0915D7C9761205879BBD81A344';
wwv_flow_api.g_varchar2_table(65) := '1222B2A928C6AE91664086F7850E9A06E8FF37AFEC3C542F387576647C550728170687F6F608D075B2AD309301CBFA8EFAB9A03FB29D672A838DB6BB9F2ACBD354E3E1F1BFDD14E43BBF86953573F6BABDF9DED2FE7E3477B3CE1B9424DB1EC23F1F1C1C';
wwv_flow_api.g_varchar2_table(66) := 'ECA73662B0917500710D366C697F239598BBF5CF87D61A75FED443442B005B602A2AC8CB706037456E7BC140DD4CDEC9580725ECE8136CB5FB21CF7BF5CE0458884D6DEC6F24A64CD82C68B388172D3128580F6A2C242FA74D1C21CBD072D98BFC15E24A';
wwv_flow_api.g_varchar2_table(67) := '3A1DB396A373A3FF7D487DCF953034A8E9AD64742A31C5DCD9E78E50B67C4E1205C1B2BD105341DAFA5EA9589D4DCCED80C88BBAFE859201B4F3895FFC4E63AA692ABB49052E98C942115F401044FF219351493E9BBD4800C919D23328A1D3C3B1822FFB';
wwv_flow_api.g_varchar2_table(68) := 'C3B0502E2F2E2E26EFECC28648B3BDB96C46D61C284A015F6F687FDFA4156850A6935BBBD35BD1AD0B3C070ACEAE82961A4B01CFAB97B82FFA0F55F0A7AA424D4FCCF4FA82DFCCAC971642B44244719D647D6F76F67A3C0EC839799D268857436EE4C12B';
wwv_flow_api.g_varchar2_table(69) := 'F0B71B3DB3B0D066C90645C858B266E25D02345D26D2F5754241107D33C3599301A0A2368A118B59FFB7A6A1D946C16E06F9905F6AF378DA5AED16580A8454D01E5CB8DA3DA62AB9EDC8775900BFB0EE656B8E2257FEFF65DEA2DF671E62EEBCDB6F605F';
wwv_flow_api.g_varchar2_table(70) := 'CDBEEFDB95F7AD97F017F4A28389E964684072509348A4101D9230D2202FF8736194455579ECBC9C381110424BB9BF52D5AFBECE569224449C38EBEF9C2430F327FECC6FDB92E3E9B3C97CB1984F1BCF125CCB0FC4A33F7CDDFBFFF653D1F91DEDEF9244';
wwv_flow_api.g_varchar2_table(71) := 'EBF36E324933061EDDF9AD1F9493B4FDE13FFFF733EA9095A246150E22EB003F3C38C2DFEF29807FFF91A30E3F62E7706A1B6E1D5BFC6095A314C74DB99BECA42A166E2418CBC254D2D0B6A725964971D8D63BEFBDDECCF74D74FE127A751C98E51E5963';
wwv_flow_api.g_varchar2_table(72) := '44C76D18369E1D2ED796F290C48AC09CE3290C63FCEFFFF9357DFC9AF5BA6401F574211DE362166E1825EB8AE682893EEA264BB90C816A4029EB5C4051369382899F7FF81AA9822F3EB6D40BB3304CD34913366148D6022E6D4F65C4CFA5440098409557';
wwv_flow_api.g_varchar2_table(73) := '620049E485656667996D2BDBF851E7F7BEFE75E90F8C030001EC228CEC894572C2D78211602807BE0646641C48BA7B88BCAE954D7CF0B3D7A7FFEF8E3401315DCCE7D3B9EFCF8212FAAD0BA3E6FA339088087602912EE4AF2E24E68B59BD6714FEF938D5';
wwv_flow_api.g_varchar2_table(74) := 'FF9B3FFD714D29B512F90535BEBE3DAEAF740C593218B90CDCD51ABC8811DCF14A7EE52B81EFE54B2608E1D02506F9E3D7E509DF789BA8ED8188D0CFF5F69C3535BD6147F03C605D228720E653B20409ACDD685D2BA35E7DB773845D44FCB1AC6A141652';
wwv_flow_api.g_varchar2_table(75) := 'C0D3EDBD03EE920DA116C098A804CF576B4F546015B57C98EB021D71162D0917E8043D6343E4DDD75423BFF7BDD80F9C4EBDCDA620F3E338C8D865D80E001000C5DD2CC9D044C812F5B55EFD15BA01330370DBA64110A4BB306C4A8990B26373307107C0';
wwv_flow_api.g_varchar2_table(76) := '83751559893FDF4AE770DF2E418884AB84CB5D01A87BB449B4BF7E2DE7FFCD47599A8EE969E1CF13A9A83544974C15C6DB7B19A9A6D3D9047F8FE447E6A08383F3937F38084046C065A5F7771A32545CA44D10C7D9BE0FAC1CE362D8CA40D0A04BF12261';
wwv_flow_api.g_varchar2_table(77) := '49199741DBA699141D549176921F7DF83A24F08BA7C0CE203A4DF72293AE95655D3865D8344D29BFCBE4313669BC7300EF3AD6E4CE6F6036D0E14767DE148C556901A4F1AC19DCC1ABE75AD689BE159F58A659E0973563550E28378B8BEF7FF935140032';
wwv_flow_api.g_varchar2_table(78) := '01368BA18E53D3235510A4CB8816D27AA7412B31F39D93F81725F8994ADC08303F109A1DC11AD0BA9122B3EBDA9632AC1DF6BB814AC0732B01025D4524388057C1DECD314EECB5FFA92C60F0E6A75F3D037C2A0CF1C3ECC0F7331D0048A49C22E35A113C';
wwv_flow_api.g_varchar2_table(79) := '38E03CFE7392C9239CF97E3C36A911739E6937F0D77FF503CA8A762A7DCAAC6DD2597BFB491260FB0D70019CE06790C8E1607F91505622B05212EFBC722C7CEB238B81118063673645F102A9652EB6DB956C69F41B3CD1876B180A40A0A49A5446CFE974';
wwv_flow_api.g_varchar2_table(80) := 'DAA08BAAFD591C529D0D20D1A15260CA68210561A3061038C8E9026839F1633F0E8DA4689770A8B22CE758A2479EE50A61BDFBAACDA30F4780BEBC0354CAF461E345E114E3BAEF240777B5CF8D690C01181C95051445A1687D99DC4DE382515538FEFB3F';
wwv_flow_api.g_varchar2_table(81) := '27941DB0D9AB808F28D336DE513640D52556753D0EC3D2EE0500396128C3C855AB138400AE950390EF7FF1553D403A9BCD82B0B34BDEE77F1EA30E4681C4F3B40B125C9FBEA7650062280B10C76120299CA288B032FEAB7FFF9BBFC41AF05252E9484264';
wwv_flow_api.g_varchar2_table(82) := '1E50BD733A1ECB0D2775ED81493859F7EA25B82BAE4D6049295E149DEA11C8DF7BB518F8872C4E2793301326C88147E0285D372BEAC3161076199D20C0EAF55BD09FFCC33F480330060C1C06C2A012FA90697C2FB9A02D7E89D5D68F055645A4F212BC49';
wwv_flow_api.g_varchar2_table(83) := 'F60CA45EC6B54A1DC52867F9B7BFF44AFCF7BB84095802039E9B98E7EDB126577A0A28E581E3731C5A18FE0B0B149A80C60612CFAC1AE5C8AC35C1A2E0874EF79B2AF9CD7323CB23D0BAB66D568C9B2C390E0880109C81D8D3668C695418863B87912A51';
wwv_flow_api.g_varchar2_table(84) := '0D3BF1E8F3AF64013F976B028271C765156E757842B08C60CDEB324C7763A176E1CB22DDDF318D3A8E03EC966176B76B27E5522B296A090776C3A284B24D1746EB204ED3A6AC47AB8AF141BB65B05DF4447B0031640CB857AB8C23EB5CC15EDE048AB3E5';
wwv_flow_api.g_varchar2_table(85) := '9C2B43D8906FBC120B84B1D4EB8A11184B371E0CCA3E3ECA4108E98F269386E27D855C8B5D664A9113E6944D386ED23690BE4C0AA2C19D0BA506E5743A9FCA34766103A35A014A49992459B1CA2366642C4414199973A530AC9C64B504D5577928157E3B';
wwv_flow_api.g_varchar2_table(86) := '9FC6436B5421C4E29536B8FC7F5E250EBC9DEE00FA5A8C66ADEF87DA5C051E48BEE6D071F343EAC38C326C00812766AAA691BAD196596C66374D4387B9BE5803594587E34F17B3D9742EEB4F3C5FB1D2E4E75846535F6A96AFB22D281C2CB06BC74B86A6';
wwv_flow_api.g_varchar2_table(87) := '01C0576EE46917F9F8559CC0E3CCC6A558287CD4BDDB7EC54B663799ED38F85371EAE558925B4CD7EA5675A898A90498252ED778BA4741D343F57D5EC4619AE27B9C065F31DE698AB45AAF746B5082564E5DF786B1DF0FAC320246D49AD6A4A36AE19DCF';
wwv_flow_api.g_varchar2_table(88) := 'BD4210F83EA86CFCACE44984153F994F6721651750D49CA19ABA205656CF5F33677EFF64BBD8F5CB154280D88B4BBF5E65A6FD4D5CE83F8DAA83A42EC419F02A8F13256596502AB4E0EB2C0C5F2113F8E607D025DFC72919E70CF6FDB53E2C99FC854EE6';
wwv_flow_api.g_varchar2_table(89) := '2A495A6409B8D60DEBB2343A4ED3B6CDFA03ABC7CD38CB9C935D24873CD202E699475F2A96840E18C9412E1C9C401AC8AE69DB4225224E2C2DE80F5FA113F011639EE624692FFF8D07E012238F6E1D3A5D7479B7B771561475E9A81CD50010C6A5C7F738';
wwv_flow_api.g_varchar2_table(90) := '5151B22370C2BCDE231C7A2D2F4E8A014E82264D7DDF0F266D5A83CA8424C887D74FBFFDE153E5A1774D3A0B39EBDCB50C3B997D6B3356F18EFCA1611A86F26A9D1C72F824DA834E8315CEEB1956D02E2780C3DCCBA67BE0AE0D82764C07C97FD318738B';
wwv_flow_api.g_varchar2_table(91) := '22A15D6D7451241A9D782C8B2DFFEB7A0DF8E5D36EE0C1A969976B66FE6C8E19EAFDD85AAD564473853349CDCCD5F5F9F8786442E4E97CEEE3E4CC4588E711EF7BDED6D2A87392CAD2DA9F38DE410069DCF5CBF63949E3380DE4B711FB44F0B510EF5F2F';
wwv_flow_api.g_varchar2_table(92) := '806F7F6C5AA0BDD227A4709CDA81C2814E00BD6BAEDC24CB6CC78B8C8D22730EE1246C7669764A13226E9BC94446D638B4E5331D961CA4449D029DD900876F05B77741BC53FA71196651943292F39FBE421484EE18D711B39443F7462B6EF2D9350AC080';
wwv_flow_api.g_varchar2_table(93) := 'AFB02A8F3CD874C508C9E1747C46AC5CC1A0F71DD96CBEB85FCC3123BABFDF4AAF89F1CE58C56540F74430BA91D50EAD11038940CE8AF8FE7E3A4B3D6FF3F3AB33A1DFFBA9E8B43307ECBE3120399E2AB72C0F994D2043EB060EEA120B776561688163F0';
wwv_flow_api.g_varchar2_table(94) := 'D56A0D79647E4393CC14AB0660403B810121F03BB6CFA2FCF0D9DE3E99C7ADAC58E3897DB8CA57C0A444B2B44D807D70751CFCF423C17A81DF008984250F10808D5682554BE5FC2693FA4CF564F95C9EDBA7A2942D3777A3283AAA663C063D6FC8F5F8CF';
wwv_flow_api.g_varchar2_table(95) := '6515F0F046F0F620A410253A4D2CEBC2BE75B29AE7C0BC5E044B0BBAC40C187C74352BF4CDEF2B0178168350F6A6FCD90C3B23F34C704F1D370DDB14D3B4A30218140172067BD2D8749DBB9DCE782A4FDE1F05B108B0C45CC370EC761F81C9F4960CE2A9';
wwv_flow_api.g_varchar2_table(96) := '6CAD480FD8B6B1F4915AAE9A11F704F198A82EA9DDD3ABE3E0E7B500C49A317B17EE2619D2D0659A10A5BD8383048B1C1D76959CD062518419C96C12F8FE749E818A747E9C86761F2C22751320DB796098CAB409E3A0090F1C6B3609620CF4A98CCC2DE3';
wwv_flow_api.g_varchar2_table(97) := '6A7949E7173C424E37AF57F5F1DBD70AE0CB5A0015510FD2AD1A808D66C5122B61266E3553E9CF02DA7B7AAEABA16C8E4CB1AC676625D0E2D6736EA9E374696E922145D83A3DB56C87A932266E014B8CD6C82811A7DACA04AA996768924EEC00C6377800';
wwv_flow_api.g_varchar2_table(98) := '5CC7EA22C677A66963DB19869F77AFE60331133670571600F350EC4A2D56521E4BDE1121CD6074251287A67E5DD77211352E589CFBB36E5EC08B94AC6A4F13ABCFE1D8F679A23C08265647EB01067C454C9029A262593B2A68D965D64CD218075952F9FD';
wwv_flow_api.g_varchar2_table(99) := 'D571F05DA0037E86AC5D576D42155CF9B375A2C7A23839690CF18A5D4C5B2F11FCC67F8014709F11F1E3BB5C0BB58A3C37899E564802C96D6667752700D8C5B2780E0A758FAEC5C58A802285BE746526FC9B7691024442B9A51BC613605AEB2B06C4025E';
wwv_flow_api.g_varchar2_table(100) := '695AC41DB648859A60DCBF3886752706DEE94F73C140819CEA8A4A37949CB370D2EC5A87E8965999C6F3C5B4E884596759666B3DEC73B1A5E64DBFFF952B09C19FD22613D652ADB51A8DE4463DC6D54280DD00AB04605DA4DCD6651CC7870440208FA6C8';
wwv_flow_api.g_varchar2_table(101) := 'E3D3FD2720ECB2699ADD2EAC4FC9756EC9D3F7F2DCAA1AE4D8DAC9B29F49BEAD33C7036D49C3828958C335FCFC0FAF8C828F2CD8400E9EE7BA09E115D1B16A8FB4CC743B6BE338F6A7333FF20E66BFBCCC031B245D0E780EA803E947B732CA6D433087A8';
wwv_flow_api.g_varchar2_table(102) := 'C101E505328BCA6F0B4C923B65C3400A10F1D3A4033C6B35FCF6A35F5E2780AFBCD38DC578162F6F9B34F653A74BE2DDBCA6D4718A5AD6857C69D4BB08FC349C4CE219323AFB9D3F5D64676C47D964E81A5171A32331D15B4E251295152AC8A767613A69';
wwv_flow_api.g_varchar2_table(103) := 'B2D25157720186F3D7F0B431114F78005E6F79829665D894B6AD1B99706D1CFCE2F77BFD8D6A5FBAD43655116C593158BB542F7C90C82C81D16CBC6BE37612AA1BA9CC1BD46D1B30EA49D385E24AB669D159A8E6FB84601071933FAB1F39BB603643B5D8';
wwv_flow_api.g_varchar2_table(104) := 'DEC770E44A36B0043025575E49D9390578B626F0806E9FDCCB5FBA9F2DA619DE635D1907DF7A879B0A1C009602BA6A0CD80116631DF1A9966FB811369854B0B33A2BC725ED7E1E012219CC3D901CAA881C6F52094E80791E1AB9567CE6D865568605D3A8';
wwv_flow_api.g_varchar2_table(105) := '5CD7DE35B345D02EB633BC073C6C604AF750A802298FF2C76F5CC789FF363AB2DF655FCD82D09C0DBE5DB01B7B1766276E1D8EAC3E9CB669904ED819F6759886C8AD5EF61C9E2B0624872091A203F8266B027FE6D7A6545F529B2F4B8C0140306C46FBE1';
wwv_flow_api.g_varchar2_table(106) := '0A04B37E7A551C7CE39723750C1BE8809155177C1140E46189C8B0380C654D5B32EF6205A7DC31AD9D82DE5EF28F75D8B669DAFA0E1BD40FB0EC3F741AB8531356F30C22AD55F4B6509E108CD38BA41101807610D5A05AF600D39647DFBC2A0A7E1B7968';
wwv_flow_api.g_varchar2_table(107) := '47B9FAD97C8EBDEDD934504E515456B426D0E53254D7E2CF819FEF7FB53A2B0B8DAE2C051E0FA585833361A0A6ED5974A13566378DF46963E7222DC891608095D5AB9E77967C50F1CE5589C037DF570F55B9AC8D669CD94599E9E593CAE2AAA94395FC8F';
wwv_flow_api.g_varchar2_table(108) := '5F8AF3CE6556D78E04B7D819545390527682408E893D99562E3E41A2504F1F62CF2E61796673C78058722D3FBB2A0A3E322DE15EAC2A0C614E5A8EC320C0B820D3921A2F0CE004D3C5BDC442AA8C6F9F911958C237E35056974D76B4413BDC8DED92E438';
wwv_flow_api.g_varchar2_table(109) := '3E3097FF7CCCE6077700BF3046FABC63ED2F31A3BD28EAACBC2A13FAC661384A906381532CB710537F3E6BE0D4B61D89DA564DCB1B760651C7D2EE77BB36489D9365BBEE86E9F899B658F2FBFE91003A97D8B386984E0845B1C309DF2C5F8C4714B20EEB';
wwv_flow_api.g_varchar2_table(110) := '0FAF0A02AEC9ECE034B705C47EBF07015D60C03A9916FBA3A56C36BD5ADE3A75418F5BDA88B3D208AFE4D01FE15164A47B216CC7E3FADADEF66519308B153DEE723D28D455E1D86A0EE2380E1AD661F48B6BE686DF5B9FFD493480FAEF12B278AEC73C9D';
wwv_flow_api.g_varchar2_table(111) := '61C9C3854E10A53574CBF96470B81414EB85C4FD8CF5B527B54B5DFBE4AE355A27A91FFB996B3A540932C296DBFBA6FCCDCF5DC188FE6A74D07A2058E4DD123EF44BE6E34D9E0B07FD9EC489561BB7E838FDEDB7B7EC0578C10F5C574D0A864D6DDBA776';
wwv_flow_api.g_varchar2_table(112) := 'CE18E16BB7B46D3B0C6DE38B738ECCA9CB8DDB7DFCCD6B26E43BEE55B75B6D6992B359EBFB763FA735593464A925B45EAD5F50FFEECF731F7FEAA332D468A8619A86A82D8534FA34F0CBCB2AC13B3E028D235164A4438B1AE1382462D17AD1E80E255483';
wwv_flow_api.g_varchar2_table(113) := '91F5C13CBF7874451CFCE663777886AD2FAD0AE7E40B9DD2CBA984BB6D43D57BF97AC58FECDA71F0CC6B09BB382DFC69EA4F43C6205DA0C9F861A67E61262346109482BD184B2580652E859EB5980AE2E061A0D4FE2E344D93E70C20EA06677AAE9E89EF';
wwv_flow_api.g_varchar2_table(114) := '7CE38A52E89DBED2818E7D05B0DC8A8F2AD679A97B5F8DED376993862D8E398FB1835700AB5B1C6C90CB937CE098C069F52661BEF255AE6263872AE91B85D0C3FC665219F1D436E65E39A1371BE42BEDBBB4CBABA21CEA309DECD27012C6B1A3FD47B487';
wwv_flow_api.g_varchar2_table(115) := 'DF5E91087CE5E370D250C58A1BBD42AB5AAFBB45D577F7103D67741C86D8E0C23D4B76A075B028C4BF122A3309BB6097D14D74904817DCA7D1A6F4E374BC4BA52BAFE1203A76143BF6FDF9C40FAD9ACA008C51F6AE4D2582783EAD192A038EDFDCBE7745';
wwv_flow_api.g_varchar2_table(116) := '1474A6D3989ADC838F74950A24278A14DC840F776A4A0CC16E6F28EABD53A8C00F07B0DF0DF1821B6A29D23696CC021EA3C972ED20964979C38E8211D44F94001840A526536478F6D04547892A361D7F3E8F7FFDD2EDB1373E24988D1A105E99E6A6A7A6';
wwv_flow_api.g_varchar2_table(117) := '62660F7775979F811B1D53609F8C334AAC6BE6185009FCD213271CF522C0A1C59A91230194770F7E573D5A03A7BB57260CCA238937BFF4D28CE82FACFDFE7082B66D421CE8E123983F6CD3EEC7B0267D6EEFBE4802B4C0F450227318246769C4A42C7761';
wwv_flow_api.g_varchar2_table(118) := '690FC3284027D648C93839561BC3BFC3E4E1617A89790630392C79FC072FDD177C53604D53165A9AED7C26359221D004F0DFFDDDDD4C740A5B677EAA2470C3DD734FEE4C24D22088659120A73D27E7A420C60485454A4DE5736CF1965575A55EB55A0FF7';
wwv_flow_api.g_varchar2_table(119) := '9A48555C0C5ED64861D281348822863FFFD2C5F0FB99F4E2E8481460CF96B5E6B738D709FF93878727EA92E7C9989E86542DEE391F4567061DA469AACEB7B6337BD0C6F648C5742E01A094BECEBA9F3AB5FCC62EC765DD275B8CB8F2662140B8AB354E97';
wwv_flow_api.g_varchar2_table(120) := '101DA500660FE88DA017C02EF55B5699210558471E83A75F7E690D78AC3BEFDE713A82D09DB24C0AE06EEE53F5FDC68C3346E8294F3120B636C76D144C2186EABBE92C4E0601A933ED741BECBB6C1020214E8C679286010E1360D0A9D1C4170F0F0F5250';
wwv_flow_api.g_varchar2_table(121) := '307899299C44BE5E27CCF3F2978E839F7B24007A963552EEDE0860AD3E2EA400C2BA9BE73A4374393384131708E2621CA09A4D489CDE27085EE55E4EB2AC91111E198AAC949F26D807B2EFA400E404DE7C1B47FAD07BD62E8AF00BC979C4AC0FDF785946';
wwv_flow_api.g_varchar2_table(122) := 'F46315FE61E8DC0528C75C71F43E14DF1BC23909616793C06FB271988DD3F1B034D8498E20E8842342C92FCDB064C3295A79DC21659F085391197AC4E300995CC85D26ED256DF0163FDED976ED60FF2AE74C37526F1979FB65E3E07B09397DB763A7BE5C';
wwv_flow_api.g_varchar2_table(123) := 'B31F646899E28914C0448056016D024BEC6386A91C039EC59296DE6EE703B2804EA66DBBEBA724EDCC96261E4ED236C066F76E7CECC261796A42DDCE759FCA0CAE0083E6410AA017F4289F4CEF9F487568D5952C40F713A7BBECDDFFFB9202F8D5711A93';
wwv_flow_api.g_varchar2_table(124) := '0BDCC0622AEBDD384C12ECEBA306CCB02475C0419DACB181EC269190A038B6934447EEDEF0E79A4218A4BC9B7D375D3C4808A3E1EBB3669C2963C0F38C8C25D1F138A3AC7D90B0FBCAB1DA80B49024D29EBA540208C3C9EE372F9B08BC3DDE056943FB7A';
wwv_flow_api.g_varchar2_table(125) := '982F81E0397B4B01C212388479F720FF05E9443E7DBA7D727797DE46F96A6545967760F045A476665A38AA8B0F841CB10A89AEE48C00DC5CB5411B64F735CA346DC769B96B655297813186B11FB40E9DA10634C73E86AC56BA12EA10F19FBFAC00DE94BA';
wwv_flow_api.g_varchar2_table(126) := 'D974725D5B9C27208F1786B1ED0E5F5C44D471ECB22C9B9D13AD795E450C7874707470305AC0532104BF8B2E8C0AA0B8BA0127812EF689ECEED88794A6A01843CB71E380F14937379432672ED7B10D0FDE610FA6815699786BFDF6651981F707737A916A';
wwv_flow_api.g_varchar2_table(127) := '0100C77AD44069C0832D4CE4F1604D2CF487044CEF571CF59000CDF62421561C87DC5A9D00B0BD67EAA3ACCC6C9B9E87533D84F75C78E620D0173DC984FC1407A16DDB0EF73A2E0F12236A606FBD6429F05887C0CAA3B6F45059136645D9D841E7C4F651';
wwv_flow_api.g_varchar2_table(128) := '4E9500346B698D74C17E4B9DBA49ED4DA78E9D29304FF1C602500062EF6D36665E12CAB90C0DDBFBE92C984E2265239F0C916C36DE8926CE916CDEDE2B6C17B15693A82B2AD494FF1FBEEC801868635A66535CA15CE62C28D379AAF6E66465133C20EE4A';
wwv_flow_api.g_varchar2_table(129) := 'A7F3D911B0A895E3B2DB27410E5DB224E0783CD4F655AFB76CEA4343D5C3BF27653877CB2FD710B5A6DAE8C0FAE4237669536AFFA0D76112C125BB85EA201F20E95486DA36FD8F972C869FA2FF12A21242284D4ED6CF9EAD728B130911CA68B0950A2011';
wwv_flow_api.g_varchar2_table(130) := 'D7B965712B1FE5EE689D8BFD738BAC9EADD7F9485E709FAD46ABF54863B51A8DA87498936637D915EBD15A61B55E3D5BA9FFADF0CE0E6BF545834CA4AB8B83B4B4720577346A66F2D26E12AA5BECBBBBBBEDDD1C9F22B17AF68367EA911AF8D80CFFC033';
wwv_flow_api.g_varchar2_table(131) := 'DDBDF97FFE97723AD0601806C200FCBA7D84E5654A4A9A04B405344FD080C160006D9DAB032337DA0EBBB43060FAE1FFF34380BB24F8B97A3C5FBECA666FCC308E1266901E8D9769EEEBB66EDB3BBA6E5996AEE96AC01801DB8CB4D675DD68260CEC1C80';
wwv_flow_api.g_varchar2_table(132) := '3B30331185809461206A83940433FCC8AB27814810538A7B4ABB3E4580D4F748C75F623F85F68FE9E209586BCBA9B427A5D4AD2824A58F8794FA7CDB95030C06A21808C359728B07E458050C59E654B96ABBAD075A1480FD3F06CCFF762A1F33E7F47485';
wwv_flow_api.g_varchar2_table(133) := '94F161BBBB5D1151525E9354B5E2B7FAB2CBD28B33BDD5CAEBDCC5E1C376C69DAD00000000000000FEF604539088288D63B6C60000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784239897667151254)
,p_file_name=>'img/persona-male03.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/img_app_user_jpg
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000080000000800800000000E6553E170000047A494441547801EDDB0187EC3A1BC0F1F3FD3FCDBF51514A0902B142A92D553186C218465194EAF35E7B2EEF39D76EA7ED4DE670ED1F30E02743469EC7FCB8FE';
wwv_flow_api.g_varchar2_table(2) := 'E17E5CFE703FAE973FDAF53CE01BF00DF8067C03BE01DF80D07A5B6A85D2A5F56D783120D426E3D7325387D7017AA7006D9BEBED313E6ED7C66A40B9FE3580E032D0CD6D95FFB7DE1A0D990B2F00343954D745FED972AD206F52038285E2B2CA67AD9702';
wwv_flow_api.g_varchar2_table(3) := '6C480AE80BF08B7CD5E2A1E81302BA9C7C90AD869CBC4B06E814C528DB8D05AA4B04E814D52CCF9A2B5497041034E52CCF9B4B74480008157A923D4D9A2AC40738B2BBECEB9EE1A2033A08B2B7005D644028B1B23F4B19E2023C6A92FD4D0A1F1510149D';
wwv_flow_api.g_varchar2_table(4) := '1CA9438598008F5EE4488BC64704044590630554880768D08B1C6BD134F100258D1CADA18C06E86192A34DD0C702788C1CCFE063014A3A395E471909106094E38D10E2005AB49C49D3C60178AC9CC9E1E3000C9D9CA9C3C401140C72A681220E004639D3';
wwv_flow_api.g_varchar2_table(5) := '085100016639D30C2106A0073917F431001D5ACEA5E96200DAD38082360EA0380FF84F7C051DC8B9880308B0C89916089100A72FA228808B3E7D15EBFFC88F91C3C9991C2E0EA0A1903315347100012639DE04210EE052D0CBF102C52512C061E5781617';
wwv_flow_api.g_varchar2_table(6) := '0BD091CD72B439A38B05B814B472B496E2120D50532C72ACB5C0477D9E5FE558D7A8CFF38BA33C38A02871914734E1C47C22EA904ACFB2BF59E3238FE9344EF6E7D0212EE0D2C2207B1BA08D3EAAB5A851F6352A6C8261754939CB9EE69232C4075CFA1C';
wwv_flow_api.g_varchar2_table(7) := 'B3C8F31643DEA75A58D8E782C52659587CD42AAA49B69B2A547B4903F8101477D9EA5EA0DA946B3B4DD6AEF2556B9BA1FBB48B4B03D54D3EEF568109A957B7B502FB19E16641D52F585E7700553FC9AF4DA102E82E2F00B460012A1F6EE33CCFE32DF80A';
wwv_flow_api.g_varchar2_table(8) := 'C042FB0A408D7E0CBEE0F70A3F3C72EA5700DEA8C6C7E331BCBB4A01A02AF73EFCF5C958F1F60A80C5ADF3F4F8E87EBBDDEE8F8FA67975D857000C8D88FC6518C7C7CFC6719A57116930AF009404F9BBE567F2773DE52B0039837CDE409E1AB03D301921';
wwv_flow_api.g_varchar2_table(9) := 'A407B45F8F8C66E8D2036AB47C95A6490F7018F9AA8AB7F4800A2F5FE531C9017DC6B0F9204C0D305B0FE545631303DCF6FBA4873A25A037E065A3D592B99008106AA3C0AFB2D56C40BB2E3EA0F79502F4559EB4340AD0B6091101AD2B0194BB2EF2BCA9';
wwv_flow_api.g_varchar2_table(10) := '290194F17D0C40A8AD0628FCB0C8DEC6DE6600A56BF703360E9EAA7DC8C1E6C16B006DEBF01CB079F0364C72AAF5DE5400AA7AEB8E0242637FFA9F1FFC7653B00AA0B04DD80FE86D0E5035F755FE7DCBAD2E00B40D3B01B53A71F0DB8D9DC920AF77013C';
wwv_flow_api.g_varchar2_table(11) := '146196D8CDBD06BF03D0809D2545B3256B9E0282C62C92A6C5A0C33380474D92AA49E19F012ABCA4CB533D03E40C92AE81FC09A08749D23541BF0D686191742DD06E036AB4A44C536F03DE309232C3DB36C0E224650EBB0D30D492B21AB30D28E925653D';
wwv_flow_api.g_varchar2_table(12) := 'E536403348CA06F43620E32E29BB936D027A98246513F45B8077B25552B666BC6F016A0A495B41BD057018499BC16D012C4ED2E6B05B004323696B30BF03BE1842262B50FEE3CFEFBFA519246D03FAFA6BFF032C7232269F7297340000000049454E44AE';
wwv_flow_api.g_varchar2_table(13) := '426082';
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784240100067151261)
,p_file_name=>'img/app_user.jpg'
,p_mime_type=>'image/jpeg'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/img_adaptable_jpg
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := 'FFD8FFE000104A46494600010100000100010000FFDB008400060606060706070808070A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA70106060606070607080807';
wwv_flow_api.g_varchar2_table(2) := '0A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA7FFC200110801A401A403012200021101031101FFC4001C0000020203010100000000000000000000000201030405';
wwv_flow_api.g_varchar2_table(3) := '060708FFDA0008010100000000D8116C96D04D8849241045D5AAB49335C22CDB5B428CD4AB64C628172DC335712EA49210A1756AA30D35C560EB2B331657597350A05B6C9329137543040B31755092C4B2AD70D28CA3ABD503D94104C64CCC45880D0011';
wwv_flow_api.g_varchar2_table(4) := '131335ACB0E8C5758D0C2B8456F6235500A65CC40F116D72111130CF423384AB2D71654E449135BAB1005619704D95C35B580810D663C3B420CD14935BBA4A8E962CC2458E958649316D4E400A0488AF22B4914C4343ACA0F1654F35C4BB450597C0EB25';
wwv_flow_api.g_varchar2_table(5) := '9582903ABD23C2C5D095410ED024CD908ED50D12F558304BA9175510412B328EB12E5758A0F6914DAD5C3BD70EF0634DEEA03C03A2C104E566DF93917D6F6E161EAF524CB8830F12CAD31138E5F62CA9757312F44C6E36366C1EBBE78DD4F35856ED3B2E';
wwv_flow_api.g_varchar2_table(6) := 'BB4BC8C30B2C32BBA4A8353165AB15DD60A11109D1F47814E664EA7CA7CE39FB4D6C363FAA7BDE46A3434BCCB44D88D5C1652AF64456998D5930423F6F978F4E6739F3CDCBCCDB4E8B236D6AEFBEA55AACA30B074EF2A84122B3408865C43216E3586DFA';
wwv_flow_api.g_varchar2_table(7) := '6B70E8F2AE16AC3D42E255B3B3D1B9FE6BD5FD67E71D0FA475FE855F2B8682AD892CE85606524A0AE01D76DB5BCBF33E718B93A8D7E3A63D9B9C5AF67EE1F287BF769E579FEE39DC72C572EAC4880D2E2285CB04B7757F9CF1DCBEB1759424615D564C6A';
wwv_flow_api.g_varchar2_table(8) := 'BEAFF8F7EA5E37D6BC2F7FEFDCB6A906242546592DA8861D07532FB7F3DE739CE36AC6C7549C9C166D37D5BF367D2193479E761E814F243044B1360A920AC43C0293D4727C56171538B8A7AFFA96CBC53C9ABD17B477DC17A170DE93CB751D570CD12ACC';
wwv_flow_api.g_varchar2_table(9) := 'F6D4A5713628116A044AEFB65E3585C3396FBAEABCFAEF78F9431F98EF3E96F23E77A7F5DE733FA3E3A01665C985AE52D1A165D0052DEBF97F1EE73A6ED3BEF03E4684F5EE2FCF3B1E9371ED7C4F5FADD0F4DB3E5E6B42C6005555B6C84686AE5AB5B6AD';
wwv_flow_api.g_varchar2_table(10) := '9F6D42DDE59E10FEA7EB7E175731ACE86FC8BBB2EFF51B8E834BCDD60EE40056B36CC016D654029DEE69E07C21EEDA2F57F96BD2BC6F7B936A57BBF4BEBD3CDB718C0CE4912AAA190A0B2356A45B53755BCF35F19DB7B678A7BE79E786FD21E0DB8C9B32';
wwv_flow_api.g_varchar2_table(11) := 'F5DEA11D07CF9C97D1B903493300AB305D1303457040EB1D6EF7E6CE77E83F16B33FCB7E8CF21B2F84DCFADDB3C3795E07BF44B44C924D20163C03D30A12E8DD5745F2253F59F94F0591EB1E53C7F7FA4C66C3F50F4DE1BCE351AEF726D726CAC248AC02';
wwv_flow_api.g_varchar2_table(12) := '6E8081140746B375D67CA983EBDE89A6E0FC27B2FA5BE7FD9737B2DBF61D6F9673BA65F6CE7F5AF774D7C228034DA408D4805A96BAF79E77E24BACAB67ECDDEF8C727EF1E0197EB58F87C1EF78BDAFA8EA373AED56774515813219108A8C80163911BBEB';
wwv_flow_api.g_varchar2_table(13) := '79BE2F136791E67E49E89E9BD07836FF00D5F92E06EEB390DA7A373D76EB5FA8EA64024232552B1D601AC201BBACAF1AF1BD7E827B2F76F51E2F9BB341CB69F5DE9D8DB5E86039DC4EA1C000326BA8B6A01A6C4098EBF0FE5FD97AE6EB63D722F9AF27CB';
wwv_flow_api.g_varchar2_table(14) := 'A6FB94E6FA5EFE8CACD7D526E364124030D584913336D64C43F5BCC7807D1FE6BF3FC7B57D23A9F05B39FCDEAB85E627D8F678743E56765849012CF4930D11332C4CC2CF4D47CD5F587C43F4CFCE777DABE15A7D8713B3EA345C2FA8F6F24A404C9104CD';
wwv_flow_api.g_varchar2_table(15) := '8F8C12C84B19153440DB0EC3E68F63F9A3EC2F1EF18FAB7C4B3B71E6367739B4F5AD644AAAC93100CF6A5123D612583C12C3773A3F9A3E8CE83C3F43E85C4EC6FE05BB95CBC7D94CE5673D896D3124CD8A8A0E848EF20D2346CFB0E43E5BC9E4BEC2F35D';
wwv_flow_api.g_varchar2_table(16) := '4ED2EBFA64D5EB68899B1F6DB29868596649BB1868097B950B255C836BD06079FF0071BBF14CBD8F3ADD1E584558B8F85ADBB7F9E16D6E297C63CD884B59111644B1056B3B0D9DDAFD2AAE0F3F9BD034C213185CCE5F4ED13688642AD36230EEF5B10D24';
wwv_flow_api.g_varchar2_table(17) := '15420AF12286068F75B45D5F3D97B6D91CA53D0EC09CAA232162B46879709885770AEA985795222B69D56BFA68E697A70AB92B373B59BA19D62A8BA861AC468119E4AA0889688530F453B2DB729BFCBE6E8EACA39FC3B7A9BDE2CC8A1112625C67958506';
wwv_flow_api.g_varchar2_table(18) := '1164897552239DCCDC61E572BB8D96975190F85376F362E3DB34D6A033172C2BD658A8AC2CDD524C1668F0B70BA73A468D3E15995939D2F2F6A94290D2D7D62AD8AAE22BCAAD889203273789197BEBC0002C2D747C65022D7914162C111822FAAB025EB2';
wwv_flow_api.g_varchar2_table(19) := 'BD63EC9E5EB8966A6D8B99122B020C88202A6975AD81C58490BAA500710009B4B1AB5494080BE2626A97945826C2B0818888092542601ACB6516A1908226F892B9185492FAD4589990406745098066CA54442DA20242D95898995818408091D50198AC02';
wwv_flow_api.g_varchar2_table(20) := '618CA6AAB498648092E2226014B26B82221896AC82662098018B72685A8192025E665A04078A880688259192479A8248266CBD228621AA097612D95882EA2148978597486920B6889000B7371EB4057A825C945C9521EB5255661E0221E25ADAD124020B';
wwv_flow_api.g_varchar2_table(21) := '32EA5495505258948336AAA1D26E4A82266EA2620B32B160880809D8E3A2B45717523AC90A47FFC4001A010101000301010000000000000000000000010204050306FFDA0008010210000000EA2002C28129002CA8A00258162CB2800400A4A000815106';
wwv_flow_api.g_varchar2_table(22) := '401162C2E380919E59094082E18F933B2D794D8CA80944C3476665570F19ADD6CC0018E87B7AC279E197CEF73A625009AEF5C4F2D1D9C7E5FE8FAE000638B1B8E878343D7E8FD0000C7162C39B867F19F53F43E80004C130F2D3739B9DBE7F9F5A80079B';
wwv_flow_api.g_varchar2_table(23) := '1F3F0CF5B8BD1CBB3CEB974C0031C31F2CF9FC6E97439BBBB5A1B9BC0013CFCFC3DB9D7CFA1B5ADE5B3B200098795C397EFE9A3BFEFB1E800109E3E5EBADCEFA0D4D7F2D7E97400045496E878F574B2D8F9FFA0CC9408A1A78EB75787DDD6E1FD0FAC500';
wwv_flow_api.g_varchar2_table(24) := '038DD0D0EA686AE5BFB8944A006B737A3B4094000004A0000012800000250000009404A094025250FFC4001A010101000301010000000000000000000000010204050306FFDA0008010310000000E1DB160A8B20596156580040582ACB058116005A4096';
wwv_flow_api.g_varchar2_table(25) := '540050582966252512965994CF6367D6F9E8EB4152CB143D2757B5ADE330BC7F5DFE3E120152AE7F6BE3E7A931BA3EBD2EAFC1798014CBEE7C347CF532DAD3DB9F4FF1FC62842C5EEF5799A9EFE3B1DEE67B76BE4B890B01619FA6FF00B73F73B7F40D2E';
wwv_flow_api.g_varchar2_table(26) := '37CCF80002DDFDFD6F3CFEDB739DB9F23CBE700017ABEBABEB7EC32CB83F31EFA2A0B017DFA6D7EA63D9F7F94E5E7AA50B2C0CBA3B1ACE8757E477B978C8A00B1976B4FDBC7CB1C7A5A9A05000B76FDBC3A3CECF2E6A800594CB63DF7FC389492D0B0A08';
wwv_flow_api.g_varchar2_table(27) := 'CA48A31C8585254025958E4A829004B2C16A0A8B004B60A40058002A000000A80B00002A0160000B71019620B0032C4B03FFC4003F10000103020304090203070401050000000100020304111221310510415113202230324061718142A15291B1142333';
wwv_flow_api.g_varchar2_table(28) := '506272C1153482D1534363A2E1F0FFDA0008010100013F02EB3B5EA70F35C3BB0169DD0EA01DE1F33644F9AD3BDD57B798E5FC98057F2239F77E9D6D7C88EFC71EFBD7CC6BDF9FE496B7941DD70F2B9735EDDDE5D6E7D4E1E6B25C75DF7E5DC5B7623E57';
wwv_flow_api.g_varchar2_table(29) := 'A37FE12BA27FA2FD9CFE25D037995D147C906347046F9856C82C0DE4118D99E4BA01CD3A2737C8E5DE7AF54F51B0B8EB92E8983D56168BF651457AA08A7D6D2B4D8CA3F54FDA94CD196271F6476B7FEC7DD7FAC49FF85BF9AFF58771847C14DDAF11F146';
wwv_flow_api.g_varchar2_table(30) := 'E1F750D5C12F81F9F2391DD2B01F756B77B977C7B88A3CAFB8FB2BE69A6FBA59A388768FC297684BA30611CF52A4739DE2713EFBEC9DD4A5DA534566BFB6DFBA6491CCCBB1D70B00B669D07E14411DD5FCBC7E06EFC3EBBAAA7E859702E539EF73B138E6';
wwv_flow_api.g_varchar2_table(31) := '83DC3D512C3C2CB4DC4A3B847CD746C58152549A79717D27C410702D041D45C2288E4836CBA261E0BA01CD185C3D7CC8EA44FC3922170DD8835A5CA592470762CD764A2C563D4C3742CD45CA53D11A5644076F5CAF7552C6473B9ADF456B95B266BF4911';
wwv_flow_api.g_varchar2_table(32) := '3EAD4E732369738E405C9536D7A879380068FBA656D63DC3F7EE4DAEA8FC77F851ED01F5B7E426B9AF176BAE13D8D77FDA2DC3AF91F4EB0E3D58DF885B761F5552EC385AB24F6E17B87AA04858827EA55B715C95D0A899B6687E5C3D3D95C9CCA2551C9D';
wwv_flow_api.g_varchar2_table(33) := '1D542EFEAB7E6B6B7FB277F70BEED9DB3DAE884B25FB5A0526CE611FBB384FD910E638B5C2C428E57C67134D8A8276CACBF1E213DB885BE7CBDFAA324D7070CB7565CBC5BF0A0A7F1FC6F76455F7156417D48A289D156DA5A090F36077F9DD5A4B2969D8';
wwv_flow_api.g_varchar2_table(34) := 'D3C07D8282AA5848D70F255703668B18D40B83E8ACA9CB9B202DF9F642C45D4A2CEF7F391BB09BEEAABB646FB2C4D2AA5B934FAA3B9DD5002233451D0A72D9AF1351B2FC3B055553982A1F1FAE5EC9B10AAA4845F36D81F85B42269A7BDBC16B7B2D9D36';
wwv_flow_api.g_varchar2_table(35) := '28FA33AB74F65531F43339BC351ECA063437D78A83C16E4A71D907BBB15973596EBFA75F875E2776155DCE12B8A981E8CEF76F8766F66F29FF008851D3C2CB618DA3E11630E45A3F25B42859134CD1E42FDA0B33C11D0A76AB624B67CB193A8B8F85B460';
wwv_flow_api.g_varchar2_table(36) := '0E0D92D9B3F45054181DFD3C4296AE99F4F259F7BB74544F2CA8665A9C2AAA3BCCC7F261FCD16BB0FD3A7DECA99CFE908CAD6F952F81DDC6592BF7BC075E1B67ECA68F1C76FC95FD13ED85DEDBCE8A18259DD6637E782828994E311CDD6CDCA5DA70B326';
wwv_flow_api.g_varchar2_table(37) := '371FAE8149B46A9FA3F0FB283695433C6718F5D530C75109B1BB5C2C9C30388E20D93DFD9DD034C443C78C2824133011F2155D274325C784E9FF005BA91B8EA19E99A9CE43FB4A771F95078C7B1521FDDBBDBA96F25CBAF7B1B841D8DB75554B8EEF678B';
wwv_flow_api.g_varchar2_table(38) := '973531201075DCCA59DFA467F450ECF693FBD77C04F960A5885EC393471553592D46B937F08DC4A6AD932673B7D8AAFB0AA9FF00B913750C587B475DD0CCE89F71F298E8A761FA9A7509DB3B3ECC9F9AA7A76C371ADF52A775FB233CBF540EB7515C768F';
wwv_flow_api.g_varchar2_table(39) := '152F816AB457BF933D61AEE89F85DE9B9CD6BB5683EE800DD004554D7B1994362EE27804F739CE2E7124A6B5CE361992A0D9A4FF0014FF00C428A1863166C607C2DA51451D40C02D76DCAD957FDA9DCB01BADA6EBD6CCA28B895659EE6BDCD3769CD32BE';
wwv_flow_api.g_varchar2_table(40) := '76EB677BA2F95CDD2D9705840D7F24C8AF9B958153F01E58EBDCB0DD8DDF5B566438187B1FAAB2829A49DF85BF27926B696862CF53C7894DDA4DC76653BCFCE69871806C47A1D5564DD2D4C8469A0F60B63C794CFE6404E1D2D54CFE18CF5A0612FBF2E6';
wwv_flow_api.g_varchar2_table(41) := 'A38B16B97F94D8D8CD14B2C71371BDD60BFD5E0BFF000DF6E68CA25B3DBA5B2F39C06F80F66DBB68CF847443EA19FB2B59410BA79308F93C948E868A0B86FB0E6A28E4AD9DD89DEA4FA72098C8E36DA3680ABEBF0B4C319ED713C93185CF6B5A33272533';
wwv_flow_api.g_varchar2_table(42) := '9B4343607B56B0FEE3C54430B07530BB0E2C26DCD6B6B02A3A791B160C7C33C397DD160CEEDF5F4B84252DD74FF0AAE696694977FC472DCD1858D1C879C3BE0F09F75AAA87E39A477AFE88AA18C3201CDD995B42674B3B9BC186C02D9F531C0E93A4D1C3';
wwv_flow_api.g_varchar2_table(43) := '87A2AADA25DD98416FF57156CF254145D00C6FF19FFE2B69550A89C35BE06E43D7D506F2DF7E4A0A8921399B8E210869E6C32B39FF00FAE9D76E47FF00A58DBAFDFF00E954B80ECB72BEAA71902A0179A21FD43CB5FBA8388DC753B996C0DB6960AAB671';
wwv_flow_api.g_varchar2_table(44) := '7C8648DC33FA4AFF004FABBFF0BEE13765D5137706B7E541494F4831B9D9FE377F855FB4FA406287C3C5DCD50D3BE6972190D4AA86359296B7801F9EEB5F55671B019EEA1BB1A5DCCE8A468919F709DD905C49F54E76224A9BF84E549FEE23F9DE651EE8';
wwv_flow_api.g_varchar2_table(45) := '4A392041F2E3A911B1414ADC323DBC9C775156B030472656F095D3D3FF00E567E69F5D4ADFFD507DB3536D6CBF74CF9729E692675DEF2E549B3259ACE7F659F73ECAD0D34390C2D0A4931BDCF395CDD40C2E133AD93633F75754EFC33C67FA82AB8F0D43';
wwv_flow_api.g_varchar2_table(46) := 'C73FF28462C1B964A2712D23968AA4FEF08FB6EA8C9A0732A885EA07A027748FE1BC1B661020F90E1F3D6E07A974D70215752193F78CD788E7BCA09B4F3CF60C67CF0549B2A2848749DB77D829EA2183395F6BFE6AA6A8D4104783805A9B669910A7A37E';
wwv_flow_api.g_varchar2_table(47) := '21F492EDD1F8DBFDC15536F56D70FC09CFB0196B904FA8742C2F1E270B7CA8EE5A3F5582C2EAAFE8F95B3C7EF1DFDA9C6C0A8C5CA21BC404E8B96E69B1F2D97561758DB74D4B0CB9B867CC6A9FB31BC253F926ECA1F5CDF90420D9D17D51DC7375D49B4E';
wwv_flow_api.g_varchar2_table(48) := '8E3C83F17F6A9B6D4CECA26067DCA73DF23F139D7278AC80541486E267FC7FDADA2EB53FB90374503DEE6E595C2AAC2DCCE96CD120769FAF2BA9DE48BFAA84DDBEC8072AA61203B92D9EDFE23BE11170ACE6945EE7649BA0520D0AE08683BF3DE30DDBBA';
wwv_flow_api.g_varchar2_table(49) := 'AABDCCBB63D7F129669A5F1BC95A377004E8A1A1AB90B4885D6E67251ECF02CE93323870DD5584E1040418D6F01CCE483D8C76279B6772A6AAC6F0E65C00B326E54DE16A8DD85DE883EC111CD5386B1987AAF7DD7C2190EF86BD73D687362AB97A2A7791';
wwv_flow_api.g_varchar2_table(50) := 'AE83E53B454F492541761B00352537655381DAC4EFB2105133E98C5B9DBFCAFDB29186DD3C7D498F69C4FDD3E6E0D4F299984C6657BAA8C8B46E826C36051ED6E0F705D2FA2E97D117172D2D74C65B33E5475E0F0FCADA5FEDC7F784E0A85A1B4D18B6A2';
wwv_flow_api.g_varchar2_table(51) := 'E7E56D2DA0E6130446D6F13BFC6FD9358E6BC40ED1DE1F43BA67E085EEFC939C5CB0952F050E87DD34E10AABC60F31BE9E0C0CED1CFF0045D1E6B01B1BAB64B09B0B5D6075F926B037CEC1F52AC8CBE070F91F09FE15E18F2E02FF009218A593D5CEFD50';
wwv_flow_api.g_varchar2_table(52) := 'D9B49D1F47D1E7F8F8AA981D04CE8CFC1F4547FEEA1CEDDA0AEAA27E9A4FE91A20162CACA4377280EA3755C7D90EE5BA9A97076DFE2E1E9E74F5E336785C55643D0C85BC351ECA8261353807568C2E5534F252CF6F5BB4A639B2303868E175B6A21D1472';
wwv_flow_api.g_varchar2_table(53) := '7106DF9AA217AB807F58558FC303BD7243758614752986CE07717656B28638D8490CF9DFAEEB7B2B7911C7ADC3B963B10BAAAA66D4478743C0AE927A39EF6B386442827A7AC8B83B9B4F04D6358D0D60000E0B6CD53486C0D3C6EE5B1A1C55064FC03EE5';
wwv_flow_api.g_varchar2_table(54) := '573EF286F2080DC1B7520EDBBDD318F7F85A5063DAD18B7075B75EC32720F7AE94F24246EFBEEB79C89D677BEEAAA48AA9B6764EE0E52C353472F169E0E1C51DA55A5B6E98A6B5CF706B45C95474DFB34219C7EA3EAA7FE349FDC77040D931ACC59B73DE';
wwv_flow_api.g_varchar2_table(55) := 'E87922C70E1BEEAF9A71BA1702E1364BEBD41E7192E1C8AD73054985E0B5ED0423B2695F62039BEC553D2C34FF00C36FB9E2B8953826A24CBEA4D807D48B0108EB65726C98710EAD8725D1B792E89A8C647AEECADEAA375C77DE9D5011D7BC048D174CEE';
wwv_flow_api.g_varchar2_table(56) := '284EDE4519DB746627408EA4EF7B717BA170812DCFB97B2FEFBAF6B11AF93D3CB3D97F7599C9467872DEF7DB2E3B9A1FF4A064E237C9E22B251F83A83F911206AB13783B748DFA90C883BE4F194CCDFD426C112B2CD45E1F9EEF4F34E75966E28B1C3551';
wwv_flow_api.g_varchar2_table(57) := '1E1BADAA61BB46E7F8D34D9D7DE5C0273F16EE39202C2DD53FC824F1A8B8EE6B6D7DC732E2A2F0EE9471DC1CE0BA4773DE013A04C65BAC75EE89EFF4F7EBCA34283AC5091A8C8D4E792834DFF5EA3A2E4B03F92C0FE4BA337D508DBDC1D7B8F7F32E690A';
wwv_flow_api.g_varchar2_table(58) := 'CB92009C86883401DF8D7CC69DD1175D10E6BA26F52FD5B72F3C05D1EBE9EFD7B2BF7197CF9C1E66D7F3797F20E07F91F0EEC799CBF9901E4B5F277EFF002E1DDE9E4F4F7EBFAF7B92BF93B779CBC901AFB2B9EF8E448EBB45C8EF08B5BB8FA7BBFFC400';
wwv_flow_api.g_varchar2_table(59) := '2910010002010205030403010000000000000100112131411020516171308191A1B1C1F040D1E1F1FFDA0008010100013F21E35C763A6392F47CFA8B803DF9E9ABDA3E26BC2F8A0753F69AE5E778A31CB67D2A5EBC963D8F50079DF9F1996BC34E3E20A0';
wwv_flow_api.g_varchar2_table(60) := 'F7E6AE0BC4557E815C868E792E8AF4CECCEDCE55E58B7E3942D34D5B7A0BC511A62BBFA8D572157D35597CA16F3DE2BD2474850C6BD7FA84789E8ADBA571B1E908B4386BC6B882A8D65E2BE7935E0A551EFC025F0BE1AF116D725F0AF46997EDF23741EF';
wwv_flow_api.g_varchar2_table(61) := 'E91668E7CF318CD7008F26BC6AA94C45B729C1F405578CFAD6F305DF6996AF8EBC57012B9F5C47DCE0639DE35C865A25DEBC5537E9184FB1CB9E1A18782F2E5A9A4AE5ADD1BECE15CED85D42B36C31CDC34AAE51A3BB93EF7D10B42356D72D3035EDC179';
wwv_flow_api.g_varchar2_table(62) := 'B48395737D62A3054A30079E18BED3B41C43902F48D373C43B9710C18F1C081CCB7C8941CE5BA1704851A6AEF0DD100D53E928DDF31610918DC217B2687FD221D1E999668C7E61D756753D3AE15C69AB8F7B73A705E21CC59B3950D78E3AB44D5909302B';
wwv_flow_api.g_varchar2_table(63) := 'BB0261D6268D8DE24B7A54E9FAA8ACB960BDA67ED5A17F640F7E88A7D597DE15FBE91D81F2A16DBBCBFD4AEF3C242CD6D3C079E03DE0EAFEE2B51EA52E84D056BBF238E21C56B885B2978E5D78DA5EFF006E1B14E759FED2964CCA19D8FE0E5F8948B76F';
wwv_flow_api.g_varchar2_table(64) := 'C90F549775CD2AB81847753626D363ADCC85EEE9F0C0264FA79862559932F988525736BC016628CE7A453E3A72BC2A69C179314F5E52AF3A478BBF04BCFB40B5B34FCCB6D87D621D23D6B44BD0EEC6695E5609F9665D8B6F4C92A02608E19496997C4F27';
wwv_flow_api.g_varchar2_table(65) := 'CC69A6605C9C1D43FC96362C3A92F87A43D1530B5531B4BF8C5F467D669F87694F00BDE5F4E6B95E8B5B72A4B4E9C9695A3F782A433E4401BA6B144C658089C0BFB54BD269EF10DFE620D5662529166CCC21085067AC197EBB8B465A9A4EE41D2F69A8D3';
wwv_flow_api.g_varchar2_table(66) := '115E3CC5F7A94BFF001493A637C5D3DE0D3FE30FB3C8331CAFDD3E257E27482670C6C79D88B7EBD4BA3957347772D62727D486368A5FD66086DF5F680DB313B431654C1B15FBEF295454DA6897A9CD41350DA61D02DBA9D26623DF8399B095E31973C1F0';
wwv_flow_api.g_varchar2_table(67) := '0C2B6D8A3AB2D69D15B51F023232F2F73A3E66DF1F6BFC9856BA195C87A3BF0BE37C9604EBCA9426A4BD7BBB70BC868D5E65B5FB45ABAEA824C7FD96C9F5E1B2538318EE8A529F11011A8953B5B3EDC0BD81B2B7228EA9EAB44ED1A65EF574429E26DDDE';
wwv_flow_api.g_varchar2_table(68) := 'CEA9561C3996A9A652FF00835C9B69EFCDD9DBC1BF11AC68EDDAA6F75EBFF22542C364C3826C986213ACB317511AD4CCF335E953E8A6825311AD3D8FF2545C7CAB48D2CF47C1F921020B78162A5EFF006AC4D557CA9DDFAF733A832C78678C3F7E4AE17C';
wwv_flow_api.g_varchar2_table(69) := '998819255ABEC983AB5073A5CA1B1E7BD1DF9D31328D4C6FB931AAC6621A6197D663A41BF0AB402DE9311F93C1D9615F0066BCCCA99AD22A183F01BDC950393F841FBE9D1D27E5EEFEA3C6F33F6EF2E755655BCE936CCCBC3BC4A63478BC346270527768';
wwv_flow_api.g_varchar2_table(70) := 'FB25C6EDF39379587E2E1A725357589493B1E65F603DBD5CF639F40EF682FBFEF95BA72367305ABC5B804316C6F5D8F2C6C8059743C769437A7E9EB1EF826AA21F8A3C30742F1EFD7B9197DD3C9883AC35C759ACCB4D29D0B8B31775D0ED301F5BD3BA64';
wwv_flow_api.g_varchar2_table(71) := '331835857F6992BA622F2AFF00A084BEF5C3DA5993FEB91A6A9E25E1C4B5F4CE55B074E7158A4A9A64D49F217F4D65B48B19853536BBD5C3EB3542FB7F30B68875DECFCCC176DF9BAF0AB818B7A9F867CDB5E4B8CD595BA0D3A70D7D1B3AC11B281B879E';
wwv_flow_api.g_varchar2_table(72) := '933B01D0FF005031CA8D3570939453CBB096DA816F8D7EB2920E38BD7CB1174DE880E82616CC5F8713D2D79853EC731B116E6B0E5AF013C4D07EF0CC6F0458D626FEC90EB15D972BAB0D1B8406ACCA559C27DD9F7D1CFBC252C70D2EE175FEA542ADB21F';
wwv_flow_api.g_varchar2_table(73) := '04C47B67E608D25EEFACB25878371A6155F72FA430376A28E7DE7595AA3A8FEA5E296B43623ECE30F132DAAF51F450A79AF8D83B7DB8BBC7E17AFF00A856994B7179F4810B2ACACF8E3BEB897B4D579B143CC17583F4D95F4AAF8CB2F0CDBF398540952A';
wwv_flow_api.g_varchar2_table(74) := 'A513A49AE09D3C74234C67ABAC422EBF5ED29619DD1F687DCBEA14FF00149ABCCFCCBC6DF233CC61D7B3F140F730AE335E826228100D5BFB98D582BB280AD528C197FB819A251FD277976CA00EB3462793179565F7812F827F19626B0AB6B11BEE61D07A';
wwv_flow_api.g_varchar2_table(75) := 'DAE25C3D1AAF435D6117902DF0FC91C46AFC2ED19DB34F83D3796F94D74B8D732BAEC71D7D456899F2F20F1813447FAD37F3A47134DF1357DE305AAE45D461F17ABF552CD05AEC7798CF169D1FDC476F29D4EB14764CF073C37A7B4016FEE21B3317B16B';
wwv_flow_api.g_varchar2_table(76) := '317E112614D4BC13F33A8F7EAF84AA232356EFCCBB77A4273D334F4CA5F879D55578BC77A693EB19B3E26575AAF89955B7975ECC4755F102603BDBE84A7E4F60233D07E6F1ED365DF649A5191CF4662D6AFCC45C1469E60C0AB60CB2EF595FE75B460DDB';
wwv_flow_api.g_varchar2_table(77) := '9865585AE72CB572DD4C44357328A74AFBCAFBFF006712E909D5132037CABCF5C2B88B9EFCD4B2F4E212E4FDC457A9BC5E963EB2BE22A78EB66BA31AADAFC67DB66130AD7F6A9868B4B63607AF00F803D0D57F2B35B8484786B34465F87489675FDD529F';
wwv_flow_api.g_varchar2_table(78) := 'DC24036C565AD3C451EA2E97A7BCB82E9AD2A981908F2DD4F697DFD4AE08D8BAE06B1DF732426C71C6FF00871C009704226A6909A44B6A57444A77217728DB2A971C591F01EF14FE99BDF983D0DA355E0258400CDF763604B2EDBF68039123BA554CDCCB';
wwv_flow_api.g_varchar2_table(79) := '3FFD258CD2D9EA2D4C0D64795D9E9E625D7D790EB074A9A972EAB7CCBAC0347482BFF79972848BB1894EE0FF000CA4738A95EECFF012ABC73186B9B81C99DEFC1FC1F1A3C1AEA195ED2BC5F7971481B4A0E22BB0FEE6211D593253F2A619B004A095B9EA';
wwv_flow_api.g_varchar2_table(80) := 'C5D9FD66B2A1D94B16F4B962EC6CFDF0465D9642A69B2A5D9BC6F3987100C630627628FCA1B8C72787698103E204275A9A47865E5445F17A8BC6D79E6D397BC615DE25CBCE570ACD7627C23DE3E25DCEF1885057B4CE40361F5966F6C747F70D25F7159C';
wwv_flow_api.g_varchar2_table(81) := 'F7876000D8782000D3235BD8F685DE81BBD522D82F5CCC03BC335BD8CA1A2FA4BAC184D3B4A15DD73DF8D1140B704B38D36954753A4141D0F4EF8E94D7995B8D39ADE17FD8F8122CEF061D978157B4136F769F04F9DE80C0474C3FD4BBEF195925CF78A6';
wwv_flow_api.g_varchar2_table(82) := '9FE4BAAD0336EECC796D5F79698BF1A137506FE785B5E2F0F48B0C46EDF399881B3BC3AE53D7718CE65641772D6E6C74F4AA2F2629E63AAEC73BCC82E0EE7C3300ED7055BCFAC740B96B7D1C5CF5FD879973385355E4C532E92B2E3D1DB3C3318E66CBD4';
wwv_flow_api.g_varchar2_table(83) := 'E19BEF186CB66BEC8E66EE660274275315B4528776219007D73B93D7F814519E6CD79E35C8CA1BE213B53077CA77A580E41D3B0B8425F5DDD405D6EE6B8E8DD67A8B79F505D22073897097A07F3EF3063597553435973DB1F107CF9816D7589BAD0FBCA5';
wwv_flow_api.g_varchar2_table(84) := '402D5C4B383A1FAD7F8DAB145C15CBACD55D31CEDDDB5F31BB748FBA5B7BA670A91D4D9F723342077B071281920F7CC5758EF6804378777E3F7D603E605ED1AE9AE26B3BB3CDD34D3ACB9A8CC91F2AED044B1E00AA25617A4BF5F94DDA6202E9E91C2F91';
wwv_flow_api.g_varchar2_table(85) := '51D5A7356AEFE881FCBCCB91A33D261D692B4498081B7B578FCCD2FEC3420125F67D097598C3F04C81FDCC05CDCA7DE259369458546AD3BEDF31798BA633C1C6988DADD6B358B8DA21A332869CE2F7A82258DF011E3A4C5779A6C6FD0595C9780AE6AA73';
wwv_flow_api.g_varchar2_table(86) := 'C95CBAF38E0D3B9A5A9FE4056EE3E3C18D9D49B00FC91F82E83AACA4537F71363FB30699A06269632E6BD1782094CC16B0F59B866E59997730C8C3535835C7586E5ED0B1C1E4A6ED44469E559533C4EB5CC18BBD25F139EB5167DA095B05C09C5B3A7BCC';
wwv_flow_api.g_varchar2_table(87) := 'D00F63EB05AAEF532A5FB040C2CA9C4EE1DA57002A14B3AC7BE1295DE68E9155B78AFB7E2313B4A4D1A3CE21962D875390CE174D396A54BE2D861BE796C621C095E9BB6AA6A507BCC2B0FACEA4934E08AF70EAF111D9A44AFD7B46C461D66BE8018EB2BB';
wwv_flow_api.g_varchar2_table(88) := '2358365F2015DEF92B851C02C5D8E352B83861D481EB154F0BE405819900E5A252FC3C71D2B57D26B973DD8ACD826265E234BAC306DAE91D8ED8E4A647A70A8151E4BDB97357EB86EDD45B79720AA69D17E785587BC65D79E36800ACC77E4B8622ABAEB0';
wwv_flow_api.g_varchar2_table(89) := '6A133789ADCAD5785F06662D28D5D793481795C731C6E5F038E568899A1E532756577F339A3B456E104465282E49ED2E1AFAED0C171D6D8CBB13A441C3D2A567202007D897C1794E01BA63D1BE6CB8954C796D85F4A835F0F9BC78E0B096660AB7578697';
wwv_flow_api.g_varchar2_table(90) := 'B166BA6BE269AFB315E8F04D7AB700473503AF720E6EBC0E01C2F62F4E0BCE4B3C6DC2F935F432CBCCAF2E602ADD25BD9C31AF34768AD71E67577307A1D23283AEC81457041D658DBF666B16A7B934B02A19883C41ED7000A0E40E2AD31E6D20067E1EBE';
wwv_flow_api.g_varchar2_table(91) := 'B12AB9DD62088EF11A726CCD4649517A35D52A47A81C166945BE7C51D790385FA3ACBA25679BC47A569C4053A47AE8055DB003480BA4AA73997DA8F12DBBBE16D55E228D62A772FEFC75E2BC36BBE7C50572AF25C7869C514A6837CF9BE39DA2F696AAF4';
wwv_flow_api.g_varchar2_table(92) := '34794D7991A1EBFC506EC5BD0A39F14FD3D05573E8895722F16ADAD3D2BE4BE0F21433F135CF3FB6383C84DAEA2DABE8840C2F3184EB8F4F3C9517885A5E2E5D7A056F16DEDCD4D98B75D3D20AD11701CCD628DB9B58574F42F853573031996E3D02AF2E';
wwv_flow_api.g_varchar2_table(93) := '22DF63F8211283AF315BE9E8572BC51D260BF48ABCC5BE605512EAC1C7A4108B6F33806DCCCEECBE60B634D516DE6D792B05D7A73B2CAA3FEFA413FE5D38EBC9B6CE9E82F25357B4D1DE5F6A3C705F4AF095CE5B2B44C5E9E904C052EFD0571DBD206182';
wwv_flow_api.g_varchar2_table(94) := 'AF1C8F1798D42625A690E52009DE6FE910B0EE7161B72683BB9F6E623AF27FFFC40028100100020201040202020301010000000001001121314110516171208191A1B1C130D1F0F1E1FFDA0008010100013F10BCC610074A58810753F03A05C7B40156D6';
wwv_flow_api.g_varchar2_table(95) := 'D7AD131F3BEB706A90DF93D1E81D6E5A5AB3CBE2216C07823C234603EA58F6CAFCC25916D301AF696A515F3D2EA796240B89F8F82840B7B76953E1D9C7C8CB02B3173D30AD0770B8BCB39976D426B50157D74AAF93D7994A70FDBB745970CF52D928863C';
wwv_flow_api.g_varchar2_table(96) := 'B1A16DD1446DD450D1B810B265BA2D1987238DA3D2E7337369A3AA11CAA01CBFC13214062B1CC73F1DC29D022C02942B4779537502296A8A8B7DB89A815FE1B3B514DF8BE7A2CB6F103ADC711CC35800140711ED16B12F730E88E815AB5E03CCB1225345';
wwv_flow_api.g_varchar2_table(97) := 'EFD6EA55B7310BB9C44D12A54A519AD4750AE8A3C4CCF1D37D31DA051D6FA2A46E95F6BD022C72D55A0CFCB33C4C139E8A16AD15D1770EAF9D036BD8EF1AB6AEB8BDF57040B8BC12DE3BB7CC5A81AB8B5881094408BC131713A1742FD10317DDC46D6EE0';
wwv_flow_api.g_varchar2_table(98) := 'BE8E20B8D1F159998998A781AE97728D2B0D67BB2BFC170680CC5A0EE3CE3A91477C4B84015471110BBEE5874508B6C45A28823CD97DDEDE88B52ACB1A423497899853516EE29043DB44B6557527E6186668CC7E0CAE82886031E56097537EBA52EAA6C7';
wwv_flow_api.g_varchar2_table(99) := 'DFC6EFE155153E407CC5E81D1E985393B43A3157D4BC51034A906B3CF4E462E20468F7D0B5351CFA866ABAD79A8C180EC1A250118B096AE9B47AE65625CCB009E72FB4DEFA52A073F0B9B87EA2CA7AB505B537D08B597A1D8A80B62E42E8A2F83A28658A';
wwv_flow_api.g_varchar2_table(100) := 'A972E235A82FEEE1945ED022D4EF7D3D4CA0131853B8388DB441D0A3EA532A1D1D18DF4DC1D6BA5C0B810D914EF256DEA66AF169EF8EAB3718B02FA2C621B7FF00A32A1D2F9E822005B60A76604A7516FA5F4B7B2B451E099B088F23B842E28E81CDF436';
wwv_flow_api.g_varchar2_table(101) := '007632B16AC115557997782142388B027135B86610D94B43C4B4B9758C6FDC39037B602764DDDF3D6BA1D0322BEB9F800279A7E8E8CF73DC5812E2E2311B5A956C178E8116A6D883488F98E88AA16C27012B32CA8B181070ADC5A1393BA14B32EF647320';
wwv_flow_api.g_varchar2_table(102) := '74B04ACE59471B4BEB11A582F7AB7F2CAA25F694462C022200AF68C7365E8DB2A69C310850F40456AAD8268BE9570E9B8B4D6AB1E21D3D4B0AECBAE8D4FE7A12E0D87A171A3F7147EE18A9A684E12E597BD0B09BCC562A31458E5551294437AB7716A305';
wwv_flow_api.g_varchar2_table(103) := 'F18BE229D61D8D5D788AD5F5510655341445B29BDEF65234A0F793F245BEA40E58AB1604DF42998BC4295D1663571AB98309E9445B05051C73EE05C2230332A8B441BB659DFA5633F898E1C1AA77AEDD77D1CDA8057A976C5A85858AB5832FA865878B96';
wwv_flow_api.g_varchar2_table(104) := '29A0393FA08C860B0B978C66E116F26102AAC5ED1103C867D52909F6E4FC31399432AE313399B11A57BD52508A2977F162E3B82673FC917478ACFB85183E847ED46477D1641D5DA4ABE1D1E1147061AA619AE332AB2C7CCB604331CD40398B703A65D881';
wwv_flow_api.g_varchar2_table(105) := '97B44179DB2D78A973CC336C548B2AE66975D4639847306AE26E9468FF006FC2E91AE7516CE03316B501EF99612B3F74949C9E224442AB999DDC76D562B92E3884808B7E7889112C7632DC96E06F3C0E2518B1693FA04B5632D6DEEE20AACCA0C7297176';
wwv_flow_api.g_varchar2_table(106) := '3963203896E058AB14E35DA78CC1122A2961FD9E998DEBD9851B03913B331D5ADB7C7A6316C2974F9ED71DAD766300399E59CCC1330144B4A168B8B784D9BA710B0C034301D4CB307404CB10C3A51EE5D4557A59B87B7B57370E59EFA2CC442DB277250D';
wwv_flow_api.g_varchar2_table(107) := '4CB0C4159A2AFB3104F8E50C255995AA811B5C3079778F2DCBF358815E5E45B0633B6DB58885072105C1C8272E85F0CB7216B66A194DAF999BEAC235C28416E8A2305E78FF0068001F94385683877884AA63F6F3CF085B8D06462C65411B67BD38C4C0A1';
wwv_flow_api.g_varchar2_table(108) := '1B754E33E61C8746508AD03E3F6C4515AF245954FCCFC31B1111B8F6258AA1872CB9764B26A5F4A862FF0071B7454D15798116B06E3447A039A2EB2CC8D1AF3BFB9E5E9702E5B504FD1C406E6BA79DB9E3FF00A83CA866CE1EF151B1FC1144BC2721FB97';
wwv_flow_api.g_varchar2_table(109) := '9514EDC9C1E55826EC842D5C99324521E030AFB25E52B7D3F0E98BAC7F68369A65068DDF7636E1E18D5105E59664A2EC710D82B2E0546008C93050A578CCA8437DE1B444A5E85939EDA974EB6D64BC18B8CC2B8D508DBD8FF3CDCB94650672604C2B0425';
wwv_flow_api.g_varchar2_table(110) := 'CD68B9A0E6D0672BB4F4F663B70CC0F1DFB9190588BE04EF72C2A19ED83A2C5870B3516DC409C4C1398B4574F2CAA2DFA9662D0D6DBAE6BAACAE562DC1101F343F0DB02BA810F0B54F7D030000A12D2ABDDD981FEA1114EA4C26B9F2C10EAAC370850B4C';
wwv_flow_api.g_varchar2_table(111) := '97A73284F579EDF66A1186BC63EEA0512ADDF38B359CCB8B0BDAF31B70E0B3DC331590DAAB1B5CEAD8FF00ECBE83016DE22E46ADA5CBE58C8AF06066967E47B3CE1F5D6B3718AF6B4D171565B8F0CB223C16F24AAE1319FF00C8254B4323D86922AA9572';
wwv_flow_api.g_varchar2_table(112) := 'DFB17B8BF61BAA6B7C7DCB8A3B1A48E5A8B516098C1D2B9825DD7A27388B53302E6E03BE59439E862301CB1B601005AAE8B95D16AA4B25B2C814EE789CDD3896B835014C962BA382D57FAB1940260BB2EB12A670706A22B6C578152C41C6A1A5468B4AC5';
wwv_flow_api.g_varchar2_table(113) := 'C0AFF92340038A830A86ACE2A6BC620FB689DA2CBC998417F2CA4F30577E152262656D17BCBB7F24A19A29DABF6B3245056628A7152B4B8996F5883CE387D42AC653F7B889CCAB8E307DC09510BA84B0E94DF9952A6AF3F73ECFB8A11661CF40AE850FCB';
wwv_flow_api.g_varchar2_table(114) := '1D9E25FE3E17146968A3E195C4AB1BEE3C8CA41AFC86DAD9055D0D3FF54622CF85D16D39A8B41CC2EC80ADA2A162A7D91182221832BA218E7108C90F9A8A00EED9C331036128FD48C0E1A22C9E4707DA97C14B7DDC80F3BAF0D7EF2113238431A1446628';
wwv_flow_api.g_varchar2_table(115) := '67CF07D432985DDE13EB504A2D2D72058578E3CC74CB0B868C842A77A9F5D00C5AD43A86A1DD9BCB01A05ACBD564CD563848AA1A1BAA6E105681C9A2174F6122DCD458625F46E499B2FE2A15D19733D1629480EEB651CCBBAD75FEE28A0077827782B7BA';
wwv_flow_api.g_varchar2_table(116) := '3B241AC5D314FBFF0071F0359149CFD412122002D5740412F9B150F1CAA61DF89B9F65984373A590B85A4884E91C37E3B65F12FD960FD623786EAE580E054A4A042EA79F20686F9DF6831B0B3EC391E0430BB0CAF9451DB6698D7F9CB7000B2A25A1D8B8';
wwv_flow_api.g_varchar2_table(117) := 'F4C55C1280AA36658211D38F60C1B333FF00C6672CCFB302B2C58B6CBB229CD623514AB2CCF12E992CBA3A655F9A328755B9B94F04C12E7332C59958E62E1612EE5CB95E3A3999369BD29A20EF069F03A3EF4CCB68C89E0984EE400DD306CF572EA5E658';
wwv_flow_api.g_varchar2_table(118) := '777C608FAB3B9AF69287A81AEE97D0E58D27DDEC7C6D8B180E0DF91B566D6B566357663C55A725720E218635AA725A5D8A445B956F1DA655F2B0FAC2778BCB4D9B8209624B1EF6E188962C396F995D3B4215ADBD83701594FEB8A98545D3EE4063952F79';
wwv_flow_api.g_varchar2_table(119) := '34E78940A581F62E260C12B32F88A16C795B01451B36F130AD50205E66F533178A8B3C74E3A2F45013532CAADCC21547F6CB267A6BDC5E98191C2EFEE19766AE2B33500E28A4B5FEB23DA057170DB0702FB195954BBB3A7CDD65E9B81ABCAE5F2678A378';
wwv_flow_api.g_varchar2_table(120) := 'F2E5461A79461AD2F946A62E43DE3897C39B4B97E5426748B2ADF4D3E453DD0B07011906DE14BABFDCB0AE3C42677D1AEA43F1840C89C36A2AA77E2CD0F98775B4190683B0704B8C4286D1A398868D4CEB76CF7F8D4E2D81E3BFCEF1C102F1447BB9E7F1';
wwv_flow_api.g_varchar2_table(121) := '3F783C12FF00B0B52A8C1C00A27821012E71896471D1FD745E80C056A29CCA58511565302ECFC972A554D45E8457576FA25859465187B4ECF4A6516452BF94A57910173E208952BACF78893B0B9F17052E9CF4DA79F110F2EDD3C12FEE349FD32F7A4A5A';
wwv_flow_api.g_varchar2_table(122) := '3EC56B0E4E27D16CB0E2C20A5F57E2C8000063FB88CC7D951F1F7100C83DE265A8015C404D5C523EC80332954AF5BAC6B6FA46DC65A8EAAC0797B05EBC747304D81B73F0DFF32D074800C7E2A0A4614ABA07433986B75C459A3A074D11B8E2A1E7A5C5C7';
wwv_flow_api.g_varchar2_table(123) := '5065C5AF70E8C256996711688AF5B1A5E8CBF5CEFF00A31A629917856FB423B843B0F32760CD6B83CB1B8B0F0A797FA204BA82563613821E48F622F4266324738B8A05D32F7C5475C83DB6C2504BDB926C155B3B2CE896639B25BC619A00E3B4767F117E';
wwv_flow_api.g_varchar2_table(124) := 'C7E981AC2C230BBC0590F2D3B1AA0E5484397966C2159142B36EC3958ADC381CDF3661E846E91DD33F0096E218CBD1C4376CBE8BDBE1BE98ED32ED97DA2444E1B18AA2ED6D961157A5D7401DE47D18E9A80B66CE0B0BCC501C296BDC436AF7ED47DA640A';
wwv_flow_api.g_varchar2_table(125) := 'FE089FA05F34F3EDE08AECBB0DD6579EE8DBC1ECEA3FA23DC45955B8B5DA978FBDD8E0D5B71F3F7CA51B11427372E1E8ECFF00526AB252A0D988269B6B3B8B4E616EABE2E4F1CDE88F336E52B6E69685152CF829B1E325583C5AD3F217AEC3B82DE5E5C3';
wwv_flow_api.g_varchar2_table(126) := 'E81DD36CC470DC200A28FD0750BE9A9BCBD37965F45C5FC74E8155B639D300FA86CE81B4EE115942B38255FC7C0504D74A1B838F6A218961C6B86E16566EF14D4115ECF9219EE141F4FA08C1BCD560BE62880796295D24B4415641F50D651B11405AAB45';
wwv_flow_api.g_varchar2_table(127) := '6E391EFD276ECF7E667DE43A56282019428F46261624DAD22D4B288B99AC0BB8C49B1DFE1D28666720331C06920362141EC4F752A4A15C60F5701E5C4AE4172BAB6B61D2506DE4757049B1B8F4DCDE5E811782620778B3CB2E0453533F26E073165632CD';
wwv_flow_api.g_varchar2_table(128) := 'CEF792FCF57A8A23D995B56B6F400DCCD12E8D7D4C21EDCC76069FBA9E625E12B662A002C8ED5A83A6B30C9EEA868A3DD07E6E2CB48297F36556D52C78A388AEACC528BB764E508968DBAFBEC41F5C87952CAE086AAAC9854A19CB45B4BC88E22554D094';
wwv_flow_api.g_varchar2_table(129) := 'F412F95BD31B42029419017420F6EA8D4030D724186C1667EC66A31E5AA7B5F1022A329F7A4591E0F77AE812EEA80D98250648F7B84531DC9703BEBA128D7CB1309B650DCABCB1608A354A62FC76D4E55D033038FCCCE8160AC251A3B3C5C6619EC1A52B';
wwv_flow_api.g_varchar2_table(130) := '95E5005641DB8F693865015C19AD9F05195EA7E4E0BF065A0982B83D1A226FD9115E10FF002CC059DB47B89AAE90700F172BFF00D9B5143F45CA7035A0B58F24BF6A65F0D90C5582DF1BE3B3092ADE4362F1CAEAEB9DC626ED01DE8E76894E97C602BA49';
wwv_flow_api.g_varchar2_table(131) := '7010ACBE31B847648831ADFF0070F61F9AAA7F30232B05A539488DB54C0B741AE57F3505DB8A2F27620913D4FC81008E7D4AA2572C5B3A359E2DFD03E4456B380FB6620EDFA8F18DD525FD23EE64B4ECCDF8C559D04F24A544B1AA784E120056AEF6C498';
wwv_flow_api.g_varchar2_table(132) := 'B2DDFBE66640DB947834C6ED25B297970256CAB13C318259743F92181A5E37B27E7615CC14E76BAF7BED0683AB57597F1A8AA8D71FF31A66A516793A9974AAA315C20661AC8E3215E40967086D0805D6A946876544029BB614C5402F06837FCC13501650';
wwv_flow_api.g_varchar2_table(133) := '669496B992A7D98C228D50F9710E2B068F7BDCB9A4EE9505057DB9F4C5D2C971BED98B943697745D745A3E40458BD30462D4B85CB695FBE95F016DAEC7882658B7352E54A50ECF75309717A5EADEEF7C332ABA363BF5537FE2CA6BEDBCEF5B04D88E1363';
wwv_flow_api.g_varchar2_table(134) := 'D0FBA04BAF03F3CF3A96D56340B04E2FC170C44175E972AE7076820B9AFEE1BFF132AC357F6CBE04CC396C731BCE3322D064111B74BC55231AE59769BBBD6D80C5AD4C16E7572DADA1C5F15FCCBB5DFDDA74CBE834135B768C16F5ECD3102B458D300CD8';
wwv_flow_api.g_varchar2_table(135) := 'C9695FB4031AF616C882831A6F351D7769BFF063AAF51893453AAED58F867A5638CA5CB970E8288308D9E2A12D4D9FCCA0845DC286D2BB195D5D7B62AF0C448740C1EDC15283B9E1450B60835E4717BAC3CF65E1598CF336A5EE8BA806C06E6C1C0AD918';
wwv_flow_api.g_varchar2_table(136) := 'D004CA07B5F328776567C019633945402D8AF4388F98AD3DBCB10A1B4F6D45382BA7B31C541DBDF3293AD0562D14C3ADB0DC916273E6209482792E01A00F1888100DAC42020BCB97BC41365295FD513C661FE263D54CF5436FD662A95DADFC025C25E000';
wwv_flow_api.g_varchar2_table(137) := 'F463A54081756C58C36EF0ED445A18DD963B885B65F1E0E657CAEFB54E006D6630BCE6D798EC4F85453DA9875DC16EFF009B12AAECB02377639DC36D5D7330C9778CF9866216811A183031431C9E0A39A8C356D6DD9EECCC1C39E0658D446A94E7CDCC69';
wwv_flow_api.g_varchar2_table(138) := 'D6BCE0C78828DB9DC78BE22B3468B0129BF330061364A4CB359546D3FD35117480D2952EACA560C0415A471379E2021679FF00865EA7C9E8C98F80642DE28EA17D2F101A9856BCE8997A333CC3CB02DB961B87FC1295CBF1A0E56A17253EAB662D9DC4E6';
wwv_flow_api.g_varchar2_table(139) := '856217B5E3CB155572F2BD108F573E6AF5146BCC62815C7358481352B00A1AE5A9AF7D7BD10C6F2DB78768732181BEC9C79829783505828FEB3516F8D475036D0799665AF2D1E2F3DE1596775A6E1584A68CFE6A176AB61B66E3A28576450C6396D3385D';
wwv_flow_api.g_varchar2_table(140) := '1B6FE15F2087C50702B7676F8F965E3AC2FE204AA70666D2B2CD30F2C3726AFA86AA884DEC7EA7B071F8626AECB382FBA992618AFBCFDB08291052385656A2F85C48AB6BCAAEF2DC4660A5B7456FF11AE6B15DBC3BC5084E17733445070CDEF517B7C7EA';
wwv_flow_api.g_varchar2_table(141) := '0362DD0FD618D9416AB871345A34408108032ABAA3BC7115EE9E6F7E8DF4558BF0D4A87C420712C317F00400B7B460D278DFC728032B44A943780FEDE988EA51038E605461F20F184A700A2AB8BE2E11CB4239E0FAD45DC33934D7AA1DA9A6578865C385';
wwv_flow_api.g_varchar2_table(142) := '1CD6D07A59F995290A5B075F70FBAC0E7FF295AAB6A87EE691EDDEA1830583DD62576F8BBDCCED4155F0E194DE993678AE65312D67B3F512C5D467E603A87848F23D0C1665D32522F39CC101FD182477F66FD4B405D17F474BEB7F0D4128A6E7AFC019C8';
wwv_flow_api.g_varchar2_table(143) := 'A7DEDF91982629E6037764A85D626A128810B1B1C8D8F99C86AAF1E44A0EB75EFDFE1E656C16EFDF1E476316982D521DD7EA1D98D680B6C10AC519C4A9AAD5FBFD68C0141A0E33B0E9F838F33276A1F9388180CB19A887C04D787316A1754C0F6A882C21';
wwv_flow_api.g_varchar2_table(144) := '6520ED7155431BFCDCAFB71A4F3123464D618A1B5359DEE0F530761454BB32374D4ADB4BC90B083C9083561EE164AEEE5F551C8106FB9EC8BD4E81B60F2C56098756D5855E796FBFC0AE61962D00D9C6A04BB814FC835D454F61E163089216B7D7E7C257';
wwv_flow_api.g_varchar2_table(145) := 'C45B00A18FFE2D1FD4302C7479600513B26B064F1C476E96F6EE2959440898FD77973696E60D1559ADC7BE888044A462660B28E5E9895A9C14D91A06AD2A206F076E60E8A1A7D440B016277634CA50AF764E2DC70F1DC8F952EBB2F4D6E2DC0EC4EC78FB';
wwv_flow_api.g_varchar2_table(146) := '8C832427328E7A5905CC3B43EFAEF6B0229D2BA5303D541B5628C73F51BAADABFB8A9C65E25BA3F30545657C599DC29B8706619BF3A9C7441B4770C7023297FE0594D4EF7FF2A2680BAAFEDB94DC00C30E485CB176E0FB60DE3242A220A44366DEE45B5A';
wwv_flow_api.g_varchar2_table(147) := '366FDCA2CCB09E666B458E9EFE49661561105C830A457BD889E4781423A958D6925720A1C63F50539257FE6605B4B82EC8A8EF9BB9F0552981D2FEBA18B97161910A6E67AE94AD11D95297B3D2A54CC4A8F6BD839620B8347FB608E73DE57042897927DF';
wwv_flow_api.g_varchar2_table(148) := '562D4632DFD778264A95B0E231C37B34B803410D98CC79A9EEE588C52F7DE7CCF3D0C2791C3E18F015BA27DA6329986EF860E08DDE6E1D17B450DA1EF1F04C814D3DFC3286D48A267BC03544A2F3DE000D259E9F826F6D34AE3BDF4580C0116DF11E573D';
wwv_flow_api.g_varchar2_table(149) := '0D2683F2BA3A55F40AA54B802D4A1FC32898B9412FE04631E5B8C7A05932551DE114CAA33D50A05586A004A1EFE18D27874BC9B26B5AABCBA17612B8B4177D9DE36AE6C6734202F17170E8ADCA50F53AE87FB171364C1A77CCACDDD9EA0949A0A0F0EC8C';
wwv_flow_api.g_varchar2_table(150) := '12C085C4ED2D5C3015A05C5CB516C5EA197102A131529662AEA074B08CBB617CF558B2DC5CF7143A680CB4A4C9501C076ED19A9B8B00A23CC02EEEF295E33D02DBC2B87DCCFEEDCF43BB8B7AE96E468035E25E06CD761E3E00FF0007E5E09464A14F9619';
wwv_flow_api.g_varchar2_table(151) := '8280A5EFAA155D0254BA4405896282DBC6A05115C4F511A97C205B773D8EDD0B3A15ED0EF40BF6BD89566BA5A72C7116E5087EFA20C466F3883B4682A53DA000ED5C4132077E2E63ADCE44D441C369BCB83860800876B07B863682CF199A404A620A45A0';
wwv_flow_api.g_varchar2_table(152) := 'E1EF05A7144F274264C32B1D6254851869BC388220DF4135BDB6C25B1EC0CBF73361ADD352B6F9079308EE0FDF2CA8145CB52A054A01FF00A11CA899BF3380E94F425A286A2BB812E395A2ADD7680545E08B5A8CC1986AE1A8D25B899603C45A8778AC01';
wwv_flow_api.g_varchar2_table(153) := 'F011BE29661A622BABD1A490AD1E2A1EB06C25154665F69BAFA22C1C16515C5E99A5737F5D309862FB0ED33552A69A05FA830610D570E384B48379AD8BBE48A74C2EFBF8085AF51AE33E594A975AC68F5D09CC5B893500459C17A5961D44E811C010165C';
wwv_flow_api.g_varchar2_table(154) := '4A01434ED08DAC3ED97C1A81514816B65458F40BF5142CA95CB0B00E60A952D4F67A983A71D6F1286AB6BE22ADB4B3B06A3A0BC1971BDF720592FB080144F803FB61F6B674EDE586F1C0B5A2000280A3A0082C4A460D10863AC4B585D4A5C842FDC4DAB5';
wwv_flow_api.g_varchar2_table(155) := '54789B55ECE3F0400003835D2A2AE894F4BCD71799C716AC56635D4CCB080B3102839D9CFEFB11DACA8B2971A211458661DE2DFA8D3181CB0CBC12AAE67694B21B2F12EBDF4D7C28A428BC1B86D6053282D974040227702FF9ED019277B3B170CB91CACD';
wwv_flow_api.g_varchar2_table(156) := '54A93EDE57BBF06C51253435F1028997A9928844F81B7D198A9F39661EAF4B25E18E7B9E6F2BF9E8B7A8152C3336399B60745EFF00896C0ADCDB98C0B04709674BBC762071CC7A574CB45956A540AC536F7E9B894ED455D00ECA2670A3468800000D0442';
wwv_flow_api.g_varchar2_table(157) := '82BD8882C3B8195EBE967F2CE417777E62AAAAABB62E52A38382086B4294DB1B8A279343D9D00252AB8815352CC116B13361406AAF2DCFD1D3738AEAA844432F2CBCD1D4EECA25B0264600F71742A1DC65303DF8F7285A4E5EEC22F07C454A8E0F61F98A';
wwv_flow_api.g_varchar2_table(158) := 'ED0E17CBE268E839AE7DFCC5111A6F0C32EFF454080AE8B16B12EE1A960292A6FE2E31D6AE3826560660EAA6A2798BD097C12D3481F6FD109A62353133A8D75D107346DFA47CB1F854E65EBB28EC1D8FF010C8CAE881412EA5CE03A58A5EA0CE39617737';
wwv_flow_api.g_varchar2_table(159) := 'F1AE87A9859425ADAF5440E5FC45D2BBC0599EC9BFF8B156A0078311EDC4F0658F5D4CE1536AF75C4695A28B813E0080984821E2E5D805F018F85FC30111CCDB3487DBD2E2DEA2DCD465CE453FB65FC965971C1160C639995978872624AAD99ED1F31408';
wwv_flow_api.g_varchar2_table(160) := '1C9D54136972563B4F2FE23165F63309B9A990B35E371C9AA0501A09772EFAD54BB06869F6C7E201407F81C40B9482D8AE051FDF3162DFA8B7D2A37AB595F2F7F8D4CA801594AA8DC08C0F3178205658C057966401A36FB8B5029E5C1F445A8AB451E3A6';
wwv_flow_api.g_varchar2_table(161) := '09BF8942C393B874A01BA26F11EA4CD282F7F1FE4B2C72CD763CC58A458459668E1C3CFC4957E0980996E137167962EDCC28CCB596B4C1B5D11A86DE2B52DA45FAE970D40E7A3DA54B8A8A29D88AEDC1540683C45CC4A254AE9F602DE3CB141FB6FCD7C1';
wwv_flow_api.g_varchar2_table(162) := 'F8F32ECC548D1888CABE5EF16899581180B45424E50CFB5E5F804094E4CC0A20E70B97514305C5C4FACCC5281795940B146EDC11D1E56E557B7E0799A45976C6A2F09958BB798B6AF78B02A6DB66FA0AC44ABD1B7BAF316FA1F232CBBD403273C387B79F';
wwv_flow_api.g_varchar2_table(163) := '116EE2845D095C139965C047672AF6E7E00B304D65DC3BB2CE8B35EE2028DB4F7AED0A0696D9ED50CA11F0CFE5CCF111C4094EEE7F3F0189985E50710A506533C92A3000B65DCB81E79951A8E2FF00A22D9543B399947A6BAB5F0BD96C5436FF00152E3C';
wwv_flow_api.g_varchar2_table(164) := 'B1565518FB62F54017028F878A86BCB0AAB62AF5CC4D24F64A89A72AC5CB56ADA16A3B09C1EE26EA0170059BC7A70B184CFBC425DCA5AC773CF43097D04B54A4DD45C8F7FA96AB1E3CC09DBA33BF5C98224ED7A3B898303BEE3398B1D0E6FA6840DFAE84';
wwv_flow_api.g_varchar2_table(165) := '7980513BBCCD87C3FFC40032110002020103010605030305000000000001020003110412213105101340415120223032714261811491A123606270B1FFDA0008010201013F00FAA7FD943CEE44DC26E9BA647942D327BB2338E219CCC99930181BEB1F80';
wwv_flow_api.g_varchar2_table(166) := 'F75B615C018CE61653C388AA07427B80E61C0EECC37283EB06A5338248FCC0D91D7EB91DD680CE4868B92A33CF10280782664FC04E4309581C93E91D43A93B7044AEF14F24FC9EB11810083C1E87EBB4B2B1BC9F594E7663BF10833315BFD430909660FD';
wwv_flow_api.g_varchar2_table(167) := 'A44360168C1182276ABAB5A6856DB8E4CECB766D1D5B88257827EB911EBDDCCAC10271DE0C7207E635A41E22B8B9304E1A252DB86E5C007ACED321F5D63A1040207F89D915BD7A45DDD5893E41BE2B5CEE389BF3D40991D4666B2ED4DD6AE9E9BBA8E668';
wwv_flow_api.g_varchar2_table(168) := '7B14A3AD9A8B03107214748B8F20DD3E176DA8613930ACF049AD8D672E07DBEF2CB7575DD60B13E6DDCE389D8F75DE128B189527E5CF5113C81E9F0330513697C97E90A6E738E998A0E40F4CCED1BDA8DAAAC55B775FC4D5D69AC5D2DEBC6E077F1ED285';
wwv_flow_api.g_varchar2_table(169) := '02CAD444E9351AD60DB6BFE4CAB5EE180B304452180208C79126B0724CB6D27895A6D4663ED0BA291B980E67680F135AF90481C002535357A2009FD7FDA69D878EB98431A982F5C194DC95D6D5B564BE7A63ACD4E95455E2A8DA71CACECEB090C84FEE3E';
wwv_flow_api.g_varchar2_table(170) := 'B3433DE785EEC20A53A9E676B5DB34E1149DCE70268F496BDD5BD8C7EE0707AF12D551739C0CE65081A8C11D732DA9AA6C1CFEC651AFC00B603F9106AF4DD77FF89A9D59B7E44042FF00ECD150D5A966EA7EB374EEB188C0119194032962411ED356435D';
wwv_flow_api.g_varchar2_table(171) := 'D3ED9A41BADCFB09AA045ED34ADBA95FDA786AC3E600C7D052C4919107672FAB9956969ACE40C9F73E4580638F5966361CCAF85CFB99A9E2E69A13F3B8FDA6B69620381D0732AB9EA6CA98BDA2BFA90FF1175D41F523F8896D6FF6B03E4488E9BB9E8678';
wwv_flow_api.g_varchar2_table(172) := '4E4FCC630E0012FD2B58BB87DC07F7953B55683EC7911595D411D089668697E46561ECE3E960874178E983192DA9B90419A4D517211FAFA1F2381368981DDABD2EFCBA75F51EF343710C6B6FE3BAFD62D4DB40C9956A8BE33538F638C89656B629561083';
wwv_flow_api.g_varchar2_table(173) := '5D8403C832B7DF5AB7B8FA87E3BF542B6088373CAB54E6C15D89B499ACAFC2B56C5F5311B722B0F51188FEA8EEE9BE09A8D4A56A402377B4E49FCCA536548BEC3C99229D69670719273F986DD392AE5D7E59A9BC6A1951019526CAD17D84D5E91D9CBA73';
wwv_flow_api.g_varchar2_table(174) := '9EA201ABC6007C45D15EDC918FDCCA3469590C796F29A9D3ADCBFF0021D20D0DF9C607E7334FA54A467AB7BFFD123E01F17FFFC40032110002010302030704010305000000000001020300041105211231411013202240516114303271426081B1235052';
wwv_flow_api.g_varchar2_table(175) := '91A1FFDA0008010301013F00ED3FD638AE1344505AC1F067C79FB2056D4371515ACEFB843C3EF42C47F2634B6908E609AFA687FE34F6719FC722A681E3E75C27D103914715A658FD49676D917FF4D089D07FA4D951ED52963F92807B00A92511E06324D6';
wwv_flow_api.g_varchar2_table(176) := '1648C7B30A96329214A4B49188E54FA1DE04E340920C6FC277A789918820823A1FBE0E2B19AD2A2096317C8CD4802C8C01C106A67629E6039F3A201E5441145437300F65C8C4B1B7CD1E3678D11882C79D5BCF359CF1C6F317473857E441AD474F17911C';
wwv_flow_api.g_varchar2_table(177) := 'A05980F2B0EB4E8549041041C1FBEA6B4B60F6309F8C55EA8137EC53038E7D8D7A8A7032D515DA3B052B8A2055C8E25CFB1AB6B733D9996361DEA36C2A2B6964B0943A10C8C4AE6B4B9A596CE37762D91FE2B5A88477D3607E478BC3B7DA15A56A2203DD';
wwv_flow_api.g_varchar2_table(178) := '3E7809D8FB1ABD951DD70790A9278A31BB0CD132DC6C3CA9496F120FC41F935730A2AF78BB114A7CAA7A91563A5A94EF271CC6C2A6B5934BBA322A16B773BFC55DEAB09B76114A5CB0C00472CD68F1BC7A7401C10D824FF735AECE92DFBF09C8450A4F66';
wwv_flow_api.g_varchar2_table(179) := 'DF68F814D64FBD5BDA0386907E8549304F2A8CB7B54A67CE6438F614E786DB7EA2B4BB10E8B24836C61452DBB28F231A2B260AB007E0D496DA7C00DC3C0AA54FB66AFB5E3223456CA46762FD6A447519653BF53E8179D59C5C72648185157137751E4733';
wwv_flow_api.g_varchar2_table(180) := 'CA92374899C6EEC2A0B66CF1CB4C7BF95517F106A1430C68304600FD525C708DF06AE3566826E19E1C447938DFFEEA3EEE48D5970CA791AD4E6B61A9F771C601C61987BD5FB6E8BE806C6AC4EEFF00A15791B3A295E86926B85DB873FDA8ACF20F390A3D';
wwv_flow_api.g_varchar2_table(181) := 'A925EE9D56200BE76FDD25C182D90B925805077CE4D4924611D87E58CD428973002F86474E47E6A3BC974B4BD81CE7808EE87EEA12D25CAB13B96CD5F11DE8FD7A18A56421873A5BD888F364535D27F105BF54CF3CA761C22B4BB4505E43CD455DDC19AE';
wwv_flow_api.g_varchar2_table(182) := '62811B6E305A9D5991B00ECB5A7489169713BB85D89626B55B88EF034D1A6071601EB81564713A64D5E1CCEDE8579D5ADB8705D8640A79E28B6EBEC2BEA4B7E319AFAD9C23223708277C73AD06157BB695F1C3129249ABCD76DC936D6E38F8FCA5F9000D';
wwv_flow_api.g_varchar2_table(183) := '5DDCCC4F74D2131A1C2AF4156C81AD4291CC1A9627864FF068B16393CCF66687DE5E62AC994C0C3A8350A8791DDBA1A8E647240AB98C2F0B0FE448A9A5962436E1B00E0BE3A9F6AB042D364F4157A989DF3566E1ADD77E5B1ABBB857F22E081CCD63B31F';
wwv_flow_api.g_varchar2_table(184) := '7C74AB797BB7F83CE9F313960328D508CCA38475A862371751C63927989AD46268AEE456F7C8AD3480F20CEF8AD40292AC0827A8A0CCAA4293BD66B22B6F420D47394183B8AFA88C2F956B459144F333B01E5C935AC5CDACEEBDD92CCBCDBA62812A763E';
wwv_flow_api.g_varchar2_table(185) := '0C563036A07D1711AC9DF7EC228784FA63D9D7C5D3D19EC23B71FD203FDD0513EB8F4F17FFD9';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784240490024151262)
,p_file_name=>'img/adaptable.jpg'
,p_mime_type=>'image/jpeg'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/img_diversity_jpg
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := 'FFD8FFE000104A46494600010100000100010000FFDB008400060606060706070808070A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA70106060606070607080807';
wwv_flow_api.g_varchar2_table(2) := '0A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA7FFC200110801A401A403012200021101031101FFC4001C0000000701010000000000000000000000000102030506';
wwv_flow_api.g_varchar2_table(3) := '070408FFDA0008010100000000D38049A41292A5022306682060819852834906400040C0016A230951B2A225290028883841246002306C33DA80A2200C802ACD9C074949369E53016A4C7E51A64C0041C20C386B490021B20DD1F40AD56F417C1902A2C4';
wwv_flow_api.g_varchar2_table(4) := '6A414E2424138694A818CA58D70915FB028161351BE6D2A4C6F475671357026E029D7C95200018EDE6D651730120D266A428242B89893CA8F5107C3E6CA66D1B62E3616A572B09B9C5C72C0CD2002E71D2BCA7BF465B6A0612FB0C74A16E1F1D5F25DB26';
wwv_flow_api.g_varchar2_table(5) := 'C2A17CA7D1EB579DAED29C87BDD91315380D46920396BCED9E270BDB671D6CC3868779B25D7DB53C13171F63389AF53722BA6D1DB5F9F8BB7E0137AB572DA005049A919C72E91D51793DD2ECFB466E2C955BCA77220FA9B6617A6673B8E82A8775A3AA07';
wwv_flow_api.g_varchar2_table(6) := '5F9F6AA98D6C3332400582310923D0237AB93AFA9C6543A8B8FB2A71B76237968E7147BD2ABF4B77984E5E96EB4587D8B4A480A304B85AE774F44D83A1B06B401D6791DC253A8D44E3C9609142D0B9E9B59B1DF82CCC911B5CB9B6938E9402BDDF99D965';
wwv_flow_api.g_varchar2_table(7) := 'EC0A5248D6822EE10F92E91366B337D3CE0ABB9CC8DFEC2402C049233A78AC729E53DEEEB06FCAE3FA24E918347174BE83ED039A1A4CCD6B753CC00CBF58349835808054CC7791CD2DB98EF119CB79EB002D356C9B7E7D91DA60A2B3BD0FB0DF36D830E4';
wwv_flow_api.g_varchar2_table(8) := '240DF9B0A599A48C56AB9943B63D5226992B7B956CC038499C16DBA7AD91DC016610DAE7436F1B4CA89D6B33D3B35B7588D46D9ACAA767CF1768A6DC24C19A4C01906B953B6B8A64FB41151ED1D2FB0E82E65A5E6EB11B07C17F9A95362976A90A85B78E';
wwv_flow_api.g_varchar2_table(9) := '95C5A429B48524C82725D165566E303B853BAFAA62AB6B65C03996975BE8C3EE74D988DB2E8C2B39A69F1D61CCEFB346B6520051246734EB6E92E1B65DE55FC9A7B48C8771E7512F994611D358CDF756ABD5D94B994354AB764D01C6DC0C36082CB92BF6';
wwv_flow_api.g_varchar2_table(10) := 'D435D09520BBC871D6386075EE75757332A0927DAAEE53B1DDCABADC88142BEB6A4AD2CB4091C15792B598483322ED230595D92DACA96F710301C61E6F3483DC8D8E8159E89D480696D8211393D4761BF1950AF4A591760234C04A39C4FF005B91CA5A92';
wwv_flow_api.g_varchar2_table(11) := 'E36B6D5984CE8201E65A6848068473906701ADD5F69DBF9F06D9E367FA4BB0110152B347F2CD76429F51A5DAA474B5995846FA02736D3088036D3CC0F3C94C07923FD4131C7130D337647692160A360ECD0F31335E88ECACF67753AB960BF4E79EB7D8B9';
wwv_flow_api.g_varchar2_table(12) := 'FA4CB58482541A4F38A44E4EE2558295D5ED04A7D2D768412D2DD6E4DC29587A3F6DE09C6DD7197F1E8AD2EDB946B0010010D30D669A8529DB99D25FB6A56F36D482124A365BA6DB3B3AE0236C064B6DC585E670DB3C253F4D04001CE18CC2F350BEF528';
wwv_flow_api.g_varchar2_table(13) := 'D26920FA59EF6C926686BA33ABFD32CEE3EA484B8E0ACD7F3BF48623B2F4A881019CDC6228F27A1281AD21043A50D771111B6965E8DC91765BF9A8811B9115EB4E6D0D67BECA980553E8A2DAF27BDE90C2C05B66901D26FB924936890A6E33339DBC7704';
wwv_flow_api.g_varchar2_table(14) := 'A9B71666393CE5B95175F742C43E2DD50BD3BF861621232DC5C25DAB09ED6CE0FA7B54836C6795ED3665BE6ED42DF2237607CFDA1EBD4C99990548CDE03D24EB2D3F58C559D96E34190B63A81D6DB91D965BADC383B0A9D03C9AE670347487D2975D159C';
wwv_flow_api.g_varchar2_table(15) := '1B79AA5AAD0622309DFBAF82460F3ACE48EEFB2E772515DF796FB88247073F5D56A7AB33CCBA11D5F720559B4879D319DE2BA3DDAADC3A363BBA7670743542CCB89A7A5FD035F4B166EBE59048204C47C464DA6DC4F83BF3980D8C40E53BA29F70C16459';
wwv_flow_api.g_varchar2_table(16) := 'E6A92D3F85EED2C941435638A91CBB2CB70CCBA80F72C82140832D70671D7A52A0A91A954A2343C997AB38F2CC01E5BD7AFD826D33894A02687195BE0D2E7A516023A39BB9B5849B1139BD76C368171C5B589387A142EB922E3EB348565D4191D16524A4';
wwv_flow_api.g_varchar2_table(17) := 'AAD2BDA8CEE40E9DD5ACA5C0A6BA59EA4A1685B0859B01AA843A3A6EBC14BD502FA785FE8070BE61F42DD2AD9BE9F98EA94BEFB7777350329F4BA566A6BA99E8201A779C949400E937C549AD77DB6D6C56DF7A77B4FCFF0077D30B9B117CEFB3FD29759A';
wwv_flow_api.g_varchar2_table(18) := '8E0FE8B9A53A4D75B0F841B6E739389418592019671937A6DDEB84CD78F5FCAFBF5B20DE6A5A426364D0B64E3B9661CE969AEA012D9A1D652B0904E06C191532134EEB89A1D650C7A181D3AA9A776B6DC54A05B02AB559DBBF4B6D7582086D2E301C0129';
wwv_flow_api.g_varchar2_table(19) := '70DB0A09193EB1D28A5D7E0359B142E5B7CB799213073216D9D39F9AEEE84B1D6D381B652EB44E1A492FA5B0A00B3F9EB48AAD0173296755762FB9E22AECD1B88ABCCF6C3CC74A79FA99E84B24DA901C36C25E241905A23E89A84279E371AC476A73A42A';
wwv_flow_api.g_varchar2_table(20) := 'B944FE86FF001523563A55B1C1896DFD29E7EAE7E96521B36CDC2241ADA59825D66A50FAEF9B27CEED297F34A98CB2B3CFA4C3D07D214C9D944C7629BDF4930EF3F6F28324A03865174E727AC469CEA0E52E7963599695B577D72D212B25C6562673CACE';
wwv_flow_api.g_varchar2_table(21) := 'F151BCB0AE3CF255BEFB27627B3981A0926A5716571DCFA959202817BB28E5F35D5F7CD208D6FA49C0A4D16EB87C6DEF4676B2D757453D8666AEA5D3CE1494A544C65B151EEEC74A94BC12C503CEFB7EAA402BA1014A3898D99C3DA95BB74CAC880F3A9E';
wwv_flow_api.g_varchar2_table(22) := '730F32C9BA807CB9747ABABB246F1D54D9E955615C3E8122499BA74BB9B879BE84D608FE8D770D3BCE1E74F9896754CBA3EC5A64CF3E7B7397AD44DBBB8866341DA26BCC9E8E98484988CC9A67575AF37B3E7750E8F43BA10B65A75E5F393845CF05C72E';
wwv_flow_api.g_varchar2_table(23) := 'FF00284B13AEAC925179173744E6AEA6CC11E11C7AE5AC9DCAA1B6AF363FE92368CDB697D0AE50A336C292644A090A09484625C5BE38680419F3DDF746E9273CD7B7DA7CF5DBBB290871A4ADD5B2904B09524D26A0DAC8248B28C87778E0935F6753D9B4';
wwv_flow_api.g_varchar2_table(24) := 'EDCEDA4AC5B71187CB6A6492002DE3648128050249801269284F3E562EF77B4C8F6F63C953959A3C059F505665A98C9AC96F49A40353E1A008289C4A526A01A8DA76675DBF6AB3C018320A5120C8C53652C10D22F24C88C1B86024C0353202C1B59DE471';
wwv_flow_api.g_varchar2_table(25) := '1ACEA7D26612666126B3402071B41D4824D264460027021F04A4A0C95C58053B8B43DEDE0000003206F06CC216F619B8364464000609C4A3FFC4001A010003010101010000000000000000000000010203040506FFDA0008010210000000F406026869A4';
wwv_flow_api.g_varchar2_table(26) := '500D2680039B4D9113A8F8FA8E7EA0C2B4004C53CFBE9CD3D784F414019D71F6849CFD49072E3AEBACC6F422078EEC8C75D14DC2E6D761E3D02279FA580F2CB7A53673EAD0F9F92793E812D0596C6673F58A8CF0D6C27CDE5F675A6625D99C954513E4FC';
wwv_flow_api.g_varchar2_table(27) := 'EFB1EF736D4EA81F3AE81E580754D863E0797F45E965B52B6A5B07912CE4EBD4271B716CB78E1D396CDE6C3831E8EE3936562A1D91CCFA61EB952A8F3CF4D93963AE80EF3A615359B2A70ADC23057A0B1D1EE864D663A315B8498E3D0CE1E8E9AE19ED74';
wwv_flow_api.g_varchar2_table(28) := 'F332DF1D729AE8CEA32C74A5BF9DC186DF4196BAE615C9D1509C6F073B37AC3E6EFE936156637CDB3C3A30E95C7D51CFB43DA66B64381D0D0B371F03F57E86AF8BAF56B1DE41514868795FC979DF69AABA1BE7D582A6D000A72F0FBBD130DE379BC6DB9A';
wwv_flow_api.g_varchar2_table(29) := '6D1E6776B9A9C3A70E9396BC1FA4D0E5BDAA5B73C79F696B8BBAE0923E57E9B7A8C7A2A39B7D79D3DA21DEA4F275C4FCC7D46838B42540C3877DD9C675E35E4FB0CA8A01301E7C9D0E9E38762AE3EF022804C59E3AECC04385540204A85C79FA2C00962C';
wwv_flow_api.g_varchar2_table(30) := 'B61809FF00FFC4001B01000203010101000000000000000000000102000304050607FFDA0008010310000000E1C58648409092901124730156004375D9164602404C612110BD62756EE28D34459043034164A99981F59AB9FC1A34DBCD432323A912F5A8';
wwv_flow_api.g_varchar2_table(31) := 'B3D575BDDE6734AF479618588CA089A16A0D65536D0A4AE9D87679D2884183404473535F6D4B23F4B4F1AAA961108D0B02B54CFD8EFF002382B6C5AEB92309174AC50D5137F77771B976A566905E242BA64167479B9887D748B2A9295D5B3053185E24EF';
wwv_flow_api.g_varchar2_table(32) := 'DF878650ECA4B2094CB77AF391D6F5296F7DBCC88F7A5B4C829BEB5215EBD0B2B7DA9884B26EAE9811ECC6481625EAAA3559884B26A94489B3255DDB7CE86174401F46745736E85CE7564ED7A3EA63F9A86AF4C15950ED4CB2C9B7268CC9BBE974FCCF21';
wwv_flow_api.g_varchar2_table(33) := '89A04A88B01345BB72D9B7022BDBA07318ADC0565183DE8DEF7CB63A148A63ECE7580B20461241A69F5FD2F1959A9162C960635A86530167BBB99399546D782CA45CB0AAAB9F5DE672DCEFAB0DF962BFD47E6342CB152C55167B5E9780AEA6EA7252C8E6';
wwv_flow_api.g_varchar2_table(34) := 'DFACFCBB020748C90EEDD572AB6D74D1096B5FEA5F2DCE05B5129188016CD591648752FB0F18916DAE4844805FD1C4AAAA87427638401B5242509BF4D190421D25CD5A090B2D9164EB3F1148865891EFCA089193FFC4002F100001040103040202010402';
wwv_flow_api.g_varchar2_table(35) := '030100000004010203050010113106122041131421301522232432253433404216FFDA0008010100010501F05FDCBC7EA4D1DFFA3F9C5F25E3C1337FD099EFD7EA7CD14490931108BFB5964D98CF25CDF46E2F1A7ADBF185A13F0B2DCDEE04A4263F14C5';
wwv_flow_api.g_varchar2_table(36) := 'D3BD88FF00D071882C28B31A5451B228F52ED461952DCE9E48925ECF2BA2BB59D3E9BCDE7B6898BC269EB5B5AD7B25AB27B0AD1716C615975DF66DC12E8329EC94096BFA94A24FD4B9FE01A29593479643926CB5B5882E8B8E54442642648A0A59DD8305';
wwv_flow_api.g_varchar2_table(37) := '08ADF3B7EF71F54128B068392D9A7D37F24F24E5C188E736458DF96A7BA45A08D565D49F97E0BB911494CE95AED5E50AC71EF8C8068A773267CCD9989B6C9F9D269D9131B0BE45D53CA491B1B6362A269676CE73A85AE6F8A62E2A7E131317259A3899A7';
wwv_flow_api.g_varchar2_table(38) := 'A4C5C9A264B13CA9468D8C74EFAF0FEA0FB6266D960D7BE03257CC50223CC262863860D09AD189C9699D06575577BFAA9F2F75211F62B63FCB259638A319AF95754F296548DB21A30EE12C1E53FD584AB104C6FF0050037D71B3DF82EFA2E8617F64CC5C';
wwv_flow_api.g_varchar2_table(39) := '5C4C5C5C286889802776AA26849083B7F919F2DAD89EF589B9507C55AA25B805E4E787067F3E3ABCA3C715581CE539133A8192A1DD2B3FF541F9817FCE3573D689E45CE4CEE1696576431321661EB0FD51A78457C578C739AA8E4F79EB7C54D36D2CA5F8';
wwv_flow_api.g_varchar2_table(40) := '42AF83E59F171713171743467CAD04C617161711644DF8C2A16CED4AC29712AA5D80A482471D4A10ECAC00D21C1578E2AAE96C0FDB169A5F82D492A41AB0319A28FE09E2549DCE8FE3EDD1C4FF005C5176E3C10D5D1410C499EFC3D404444332DD37AFA8';
wwv_flow_api.g_varchar2_table(41) := '0DD12272BAAE2F0BCE1ED786535ED7B1B8457A3D5E112C72452F74BF14590D8D91708745044FC4E744E2F415188AC738D2BF49257C4E2DEA00D4DFF4A72211D9D85958C8D91B3179D3DF8991CA1995E7FCE92FE574F78D5C5C770BCE6C8B8148A01CDC9C';
wwv_flow_api.g_varchar2_table(42) := '91C7423A92BA3630CBCB251BA7876BDAD6B5BEF1345D091D84C1D3E8D401DE109824EA9A965BFE414560EDBA7F79F112C086142735FA22E2F3A7BF13836170B9B38D20B3FD94D3DAE267A770B89A5983F70765D5B1AF8FA7099DE2D5002A6BEF13C13FDA';
wwv_flow_api.g_varchar2_table(43) := '27BC70BF9D8118DBF09720384231788422DF94A74A4438696F8B0311068FF09866E7D9040442B754C76844EC82189CAF8D7CA48A395808EC81755C44DB13178C4D3D4FDD556C8BBE7AF34D1390876934F231EC7226EA8F7432FDD87652B76C709AD90DB2';
wwv_flow_api.g_varchar2_table(44) := '68AC0C368AA4DF8513FE99F6690C3141178263B9B1B2606D74A415231BD8CF5E5139ADC26DE7926898B1C5B63B577189A6D870BF6C4A237E58344F15D532A7FEADC828AAE4563DB1AC8F8609657880B0769965DAB1555FACB074D43DD00828CDF28CBF90';
wwv_flow_api.g_varchar2_table(45) := 'E5E4E91D317500AB9DFA2C89545A985D2D86263F9F58EE174F6DC4C3BFE3EEDCE6B192DC4924801AD25BE0EF0A84ED6398D7349AA54921A65EFD850E1528FB450C21C462F87BD77D92BA5729EF723519563BE644DB44F396B5851500F140C5C4C772DE13';
wwv_flow_api.g_varchar2_table(46) := '1DC6A99EEF04FB35F4052175A68CD82789EE8DCDB68B233469359115CC8ED9F1C901504E9953DDF264ADEE52EEE38960A92099538F6EFD0A9BB6A235FB7F925FFA25B2FAB3456A149912EC77B98FFF003D31DCB784E5DC68BCA62F3F8C258B4B6F688D92';
wwv_flow_api.g_varchar2_table(47) := '26A2F7481131B77FC846BA154FCA2E5880842324923901B06919508BF3165C0244B35A5C48156880B573D63B9F3DD11A823CB74CC320901BA9376AF737C8F0BECC72C2E63AAA65434B9D0780372FDCC7729C272EE345E5344E2D0069E2D79AD0901A9A97';
wwv_flow_api.g_varchar2_table(48) := '3661A485641E19B26AF7B5B585FE342C080AC5AA2E178D692C2E829249A54446A2EBEDDCF94D3450C4D8A63F47222E358C6F82F3E130F0CC93D544C8EE096CA0D5C3DE663BFDB19DAAC771899EF46F1EECEB213E285F7744FA9EAC84CC5700ECEE09AA75';
wwv_flow_api.g_varchar2_table(49) := '70F3E0D32CACD15764E9F8A2FABE4EF0739ADC20C1878A2BF164C1C59E67FAF5AA738BCF958B3E26D50AE89898FE531BCB91344C5D1796EDB67AC3FA6A199D57764C1369F1A7C9A5C1283D755C290D7F93FC25AF0667DC81009326EDC02FC121BEBD2E5A';
wwv_flow_api.g_varchar2_table(50) := 'D935988BBE268BCF95842E7C50CD1CF16EA88F99319235D8DC5FCA4B16F1B7F1E0DC5CF5899D4A0A3E2A0B1FB23F8583FEF5AF92E3F8D659590C5672165C52BD3EBE74E5CBF7C917B581C2F28998C16054B8AFEF86686645F2F79F800A4E498F2366F906';
wwv_flow_api.g_varchar2_table(51) := 'EB8A9B614F548A17F7C7AB709B61617A5E37682D0599C99D8D54A5DC5BAD555AD4A18FE69BC971DC6B32FF002C5DD09F3558FB2E3C55CDA48940B3FB62FF0096EC82BC68327A515F89473EF053764AA99BF9963C64415C44BDF2A6E9F96E06B8E7B5ACB0';
wwv_flow_api.g_varchar2_table(52) := '723A00DD849630ACFBE796A95E43F22AAAF6B6C699FF002A007643485BD451E51F4BD5920B864A9F00E7309272FC8F86BAAA0582BFCDDFEBA5DD828D0D70681079634E9092D80873158E46876930380DB8A62EAEC5F0F69ABF83067CB8392C2A0737B904';
wwv_flow_api.g_varchar2_table(53) := 'EEEF6B7B23B172ED34A6C6C129628DDEF1B8BCB785E174EAA893652679E0A81BE2870E543EF3F42F1924D1C11554529C764D68E9D45A7898FCF46D18A42D754441F83B8D5571794D5D8987B1C0911BDAF6C7DA8E6B5ACC3E2544136EFD5BCAF2DD3DE754';
wwv_flow_api.g_varchar2_table(54) := '42AE0FA7DB112FCB135808BD3902AC7E723DAC6AF19673AD8184902D78EC61D6D9143141167ACF789AAF1AAA62F3ABB131DB2B5ABFC490983F50452594F2F6B9AC63575F78DC5D08B7163596C3EF4623E6ABB3CBB956C0F862643179DF4EB904A9341627';
wwv_flow_api.g_varchar2_table(55) := '301182F86A430AB5E4499EB133D7BF0F5E3B62E2AE3B44FF0059E08C884A32C2AC606BBEA222AA626DAFB4E5796F2B86092109FC147B8C20E337A9E1DB07BF923AEE9A07B2130941A1FC2F89F39422896714EB72E5FBD53F804931861D560C84CAEE33D7';
wwv_flow_api.g_varchar2_table(56) := 'A4F34F245C5C5C5D138C30484B822267611BA6C3BBBA1D13139C6F3AA61234450F655F202453D830D14F9DF39B122B627391AD6B91CDD0E83E7158EDB0A95D338CB356874758C365E1178CF5E8B3C60DA0DB30B9F422648201A66CF0E278ED851B10D242';
wwv_flow_api.g_varchar2_table(57) := '48F3E2E3B8F0B315843C72A56CA13B78B247B2360D33678939C6F3F8C54D3DE585740744D71758653363388CBA995B057C88F1353AA9647189282DAAAD20F262823863FC64B2471318F63DBFFC9D6A38992912CEF8DEE8A4A7B194C665EC8A91D37FD3C6';
wwv_flow_api.g_varchar2_table(58) := 'F9123C6446488504EAFB0F9DCE5C4C9C86C18BCE16DFEF10344546258BABE46AA392F267FCBD3E57733DE8B8EF1B3AC84F8A394DAC2EAECA33E0B872A9B509B0BA9A6C01C238A55C9F1431C11AE24B1C9343582E5BA895C14DD40E78BFD588B8D5446D21';
wwv_flow_api.g_varchar2_table(59) := 'EC824CBF67F40AF88001F7ADC12D899E45DFCE4821573DF23322919236E9AAA3876D20EF454547C31BF1048324147921EC2E95E74A39B155395B65AD99FF00023B133DEBD415AA4C231328D3105C26390A8C00E5B43A5567DD2258626830234CBC3C51A2';
wwv_flow_api.g_varchar2_table(60) := '160F6440936318C8DBFC84F1E596E7E4C2BE14FF00E51774EE4DC30A6264C25AC358455C13E369846E411C7135DE6BC2E3C76B9497BBE2259B3E92557878984111408D545C3E99C8FA56C6E3F4B02FEAC11F7CE4AF29E575488880108393FC61523A2A64';
wwv_flow_api.g_varchar2_table(61) := 'C5FA804051265B94089186368BA14CFCAB51726899F14A1B760E0888261AA0A2C9A78604F8E6231A88D6E8DE5DC68ABE2BC64E60B03CDFE31EB4E70D14589966CEF06A4EF824CB4A984F6036728F265BCFF215470FC846379F15445430578A4F4E18D905';
wwv_flow_api.g_varchar2_table(62) := '9A68A08ECCF7DA155E0420C1AAE6FF0097235ED2F71F247B931CBDD92351F82146970C01C503B134F49CBBF42F04B4A7B4AAB3D8F91937701532C8F70458B915D8E8E4EC91A70AA3CE1CAB3089868301D001652833FD7989284163160C6F2BE5D4E3B160';
wwv_flow_api.g_varchar2_table(63) := 'A49E382C6D2CA4B29EA2998161C44C228C5C44B70FB260D83FCBF5F15ED6B49B41249FE23C841E9E36675108C6674CCE9AB79D3DBB1354C5C4D1DCE7A55FC68F8E395AFE9E0BBC8A8B6558E7BA019175384B839A210DB2AE84F829895127D1395C710C4C';
wwv_flow_api.g_varchar2_table(64) := '64AD7F859358E0111572A2A58147972DDC11677C2F2CE6461C31CB34C498286D7585A199052C6AAC8E38F13FD73A919B815C528C62F3899EB3DAE7E3C538C773E7EF261E09D0AE9A065CF9AFAADE44E1DD0B5164870D924A91354F2E6991BB3B754C8664';
wwv_flow_api.g_varchar2_table(65) := '934E32EAD7EE4B4B4D1471E9344D96296170F2BE5EF8C394E9D44A71A0749F86A62F2DD2F617495D18F2CCDAD7C9257E262A68BA6DE0BC262EBEBD6BED39D134B4A188851882EB4F63DAF6E84A7F596EDA68DF2B2418869115E5CA49955468E4D5CE6B10';
wwv_flow_api.g_varchar2_table(66) := 'FB288B70BD3EAAAD63236E14BB418B8DE1717B55201061B073593948BF94E5745CF5B68BC262E273C782F8FBF1BAAB4387E9931CF8342FF18741DD8D54C91D2FC54558E249D4EBB044C5AFB2B57C03403B7174317FC7C5C6F0BCE5C4EF882A8564389710';
wwv_flow_api.g_varchar2_table(67) := '22C6AAEC5C6E89C6ADC77298ED53F57BD0DFF8EBDCF4F447B5E8B13C90FF00A9C88FCAC93B84C2EC04112536C6E64069030FC174297BA6D131DCA71649192C1AAA08E18C782256F2BC262E8BE0BA3B8D13179D76F15D7A906496BAAA674F5DEB2D4B1851';
wwv_flow_api.g_varchar2_table(68) := 'AB2DD4990C89D14F585240F32F649DD5FD3ABDCC6358DC24A8C6C8E4648DD60FEE99BA67A6F0B8B3CA5BE1822823F4416C8656F3E9BC2F38BCEABA2F1A373DF9FBD3D971FCA2F4B91F202B871F003014495685D5D5435D05A5A013384AF94F7015C282CD';
wwv_flow_api.g_varchar2_table(69) := '6DDBDC2EF247905B18CC0EC6129A712A30CAF8AB8300F7CD749A1A54A54C3C31C10FAF4494E20C4FF6D1DCE2F3E2ED5BA2EAABB27C8C5778956D5E33A4EA9076E935FEA9C884786C2C1C7155920203A79ECEF24AEE9C806704AB158A783D8D7A160CA3AB';
wwv_flow_api.g_varchar2_table(70) := 'A36AE23A589C3CDFC8957F26F3B1551CDCB432647881C418CDD0A7760A3C7F297EF4762AE2EA9AAEA98B8B8490C1E34B799ABFCDC9804AA4B34554443BA90481CD1EFECE31FA5C3662D7811C7D27FF0097A96C6299D1B555C1F4C9322C51470C7F8D8B8D';
wwv_flow_api.g_varchar2_table(71) := 'C92278268F1057E588A10E2578CA30979B389123F9A79E78C7869627CA9EB3D9112CB056A0C2E3AF23DD2F5C891DEC0A91123908BAAF29E49A113B2164F3BE791EA9DBEAA1360B0FB41016B62B5BA687520889A11224500163F486CA1A8FACCD5BCFA5D5';
wwv_flow_api.g_varchar2_table(72) := '3593B4EB655CB07AAA56EF97C4ABE1631B1B5789EC421D7E73E6C411CE470A32C6EA591AF5AA3131B5053F20A58A27AA7E3173DEA9E13CF1C1113348439CE6A22B9557F3D8335A3073DA985CC1D10F149AA675211F0D6EF9454891B7C139F4BE2616C105';
wwv_flow_api.g_varchar2_table(73) := 'AA1BEB8442EC39CBFD9ACDF62278FF0091FE567233E8173A0E20E335754E71745C5C5D1658931B231FE334D1C11CE63C9C68A5C8895E62AA5498E91AE08446D69A73A286285996C6BC6C10C84B8F4EAB9FB89E9EAC4248F2DF1DB2621A8459268B966F52';
wwv_flow_api.g_varchar2_table(74) := 'AC79C9D3BA0B25FECD6FFE30EA8273133D262F1A3755E5745E4FAD527260E41DE8DD947B1347514E1C94C9668E18FEA9D64F8001A145D91B25A8A923C5B33944120121C5D2F1ABF346F9209AB4F42D93CF1C10EC4DAD8001B021BC8B32212334F9C9CA36';
wwv_flow_api.g_varchar2_table(75) := '6E4A6262E5627CF6E7D88E043136CEED4B5DC681EAD058CED8F1784CF5A267BC762F3ABE3648D7D502EC5A51B22045853E0C78D339CAC3F1073573F8A15CB1C6C8DBA2EA58AC2622839A05AF99C39BD4B63F2CBD3003A38FC97F08710A54FB6550AB0409';
wwv_flow_api.g_varchar2_table(76) := 'B67BF7492450A8AC7DE9CD4446D922C765568B29FA3B55D1BCFBC5C5E7CD3C178D57C1CD6B92ED42164A2A8431C88889E5222AC6C6EF81891355AE73BC0E570845407F56BFD750B3B2DBA699DE7E6FA269EB1BCEABCFE95C4E178C5C4F1B6EA16B107892';
wwv_flow_api.g_varchar2_table(77) := '79E2B9A91D9FFEA84C6F558DDABD582239BD5422E2752F7362B4B59D1AFEA1915E3DD2B176470F6EF1F05B8167C4FCEB65039DD44BA754B3627A5A3FECEF9BAF9267A5E37FD6B89A6DA26A79F0030D85B1673B03A03C9C8FA52047368AA9AF8EAEBA3468';
wwv_flow_api.g_varchar2_table(78) := '61B71B1C6C4E3C0BAC80859AA0B8F3EA4EB804B6423B7DF4EA2FED4FBA3933AA99FD8A18963AAFD098ECDB4DBF71260C2B5FD4D5AD423A82CA6CFF0030D944E9825EE06B850A2FDCBA750C48FABA89D27ACC34284D82363638FF00422E2AEF89E69E6E54';
wwv_flow_api.g_varchar2_table(79) := '6E59750402A9F6841F900A490F03A61A990C30C0CFFD2B01D4803A56755835F7FBD33DE262E93C8B1C33753DA771049043F282B863648E38E36FEDDBC9BCE74CBDDF7D7F6A62E9FFC4004910000200030405080705050606030000000102000311041221';
wwv_flow_api.g_varchar2_table(80) := '311022415161132030325271819123426272A1C1D105143340B143538292E12463A2B2C2F015344473D2F16093E2FFDA0008010100063F01FC90FF00E01598EAA389826512546DA5074CB2248A8C4BBF76EFC89367617C6C22B58FC5C7B2408AD28C3AC3';
wwv_flow_api.g_varchar2_table(81) := 'A1B9796F6EAE3D0DECD8E0A2112F12CED998544C9461CC2BD77ECAFCE02489082B957185E54A97DB745073D64039E2DDD1696F647EBF927B44A5AA1356A7AA612A7ADAA7C7418AC09526B35CEECBC4F309C701130ABACA9F30E2898B807F78FBF8089871';
wwv_flow_api.g_varchar2_table(82) := '2ACBD5C695AF089325E425C98D7756B51CC9B37B2B877C2CC435561A15A42DE96052B5A0AED8E51E866914C321A6A4D06D822C8B9FAE70FE5AC7A421079983706273639F40CB424D16820961477C48DDC34DA65AD292EE8AF1DBD11E75E3212F6FA50C2C';
wwv_flow_api.g_varchar2_table(83) := 'A9C6B53A933B5C0FB5FAC183290D114D0FB462D134EC503CF98FC935D6385EECEF6F01092912ECB44AA0F58DFC6ADC4E86B6B8DEB2BE674D1E7CB0775E89DC94C57A50E06B944D924EA152DDD486776E4ECA3D638729FF00E7F5814CA3C745E6DA68A066';
wwv_flow_api.g_varchar2_table(84) := 'C7708BF68A1ECCBF557EA7A2A9EE03693B8455A97CE7F4D2D2241A2E4CC36F744E3B28BE7A0F437E63506039CD2E62D54C4D9339B5F93632A67EF29FEA1025A8249CA9012B56CD8F1E60968A4F293111A9D9275BE113E63E6D31ABF489721336389DC37C';
wwv_flow_api.g_varchar2_table(85) := '4B952D68A828069A95BAFDA03F58337EF12D42E37CEAD23969B5E488C108A5FE2C37708B34BAFA3BA4F8C4824E2BA87F862BDFFAC3CC98C1514549302D33928C7F0D0E68A7E676F455209D800CC9DC22F4F981A753AA98DDE023D1D99820CDD8E89EE33B';
wwv_flow_api.g_varchar2_table(86) := 'BFAE118794282358E2DA0F38E94C7D1CB7017CF3E7B499991381DA0EF10D679888B3906374503AF6C69CAA4E423D5892AA1569AC0F1A15D0EC6CF7CBE17AB8810024CA3F61F031E927A83BB33F080124CC604D2BFD202B12D31BA9297176849D6EA0A1AA';
wwv_flow_api.g_varchar2_table(87) := '59C62ABC5B79D130BE440BBDD168915DCE3F43128EF51053FE9ECCFADEDCDDDDCBD196912E65DC511C0D9B48EFFD22F4D3706EF5A0220A28D1304D3AACB4E301B91335864721175ECEE3DDD68077F433DF6DDA79E112538D4F70C748E6A3CA6BB3E51ACB';
wwv_flow_api.g_varchar2_table(88) := '6FF49E062F5DBAEA6ECC439A36E3A2D25E4524A6AA1AE2C369A68A1374AD68630BB4DF58D698A3BB18D6BCCA3382E2D7C97B2D8D604E92ED2D2B41372F282CB569846B4D6C59B49A0F4898AF1DE22457D6370FF1459F93159D302CB943DA3F48972571A0';
wwv_flow_api.g_varchar2_table(89) := 'D63DA6DA7A24B34B3AF306B1ECA6D3F211752945D5A0D94D9A4CA942FCC19F657DE30599AF39142DF21C22BF774F283C9CB55EE1D05E96D5DFBC77E89FE1FAC34E98285851470E857ED194357AB6941B57B5E10AE86AAC2A0E866966E9DDB228C9E23180';
wwv_flow_api.g_varchar2_table(90) := '04A72493414FAC0FBD5A791C3AB76AD5DD0A9F67D92E2E466B65E10B3AD2C67CFDACF88AF77396D1286ABB57B9844B9C4D65D9A42AAFFDC6189E89254B4BF39C6AA7FA9B70876E52F5A6766F979701B207BED17E6BD06CDE4EE036980665644AFDD8FC46';
wwv_flow_api.g_varchar2_table(91) := 'F78ECF080A8A154640746E65B150D8A91C60CB99F883E2225AEF6FD31E88822A08C443FD9EFF0084FAD6627FCBA2B3A722779A4132D9A636C0053E260725279155C43D29F168136D531A7CCDB7BAB5F9C2AA8000C80E7BCA7C9BE077C5C19ACC6AF1AE3C';
wwv_flow_api.g_varchar2_table(92) := 'D2254F473B81C799F76B300D68231DD2D7B4DF486A3333B1ABCC6EB31E31776220F8E312242272B69982F09433C769DC23EF1697E52D1BF620DC9A474570E04754EE3175C1475C8FD225CCDBC963DE4D3E5A4730F328A69350DE94DB9842C8B34AB9329A';
wwv_flow_api.g_varchar2_table(93) := 'FDFB73C845FB6DA71DC0DE3E660727216BDA6D63F1E8EC73A5B505D2ADB8D09A41AE38C62B307847A39CA786460E3B338132583864D97941953FF1E575BDA1B1B424A92A1ED137A8BB07B4DC041C6F4C737A6CCDAED06B0CB63D7EA8699EAA5218D4BCD6';
wwv_flow_api.g_varchar2_table(94) := 'EBCD6EB373DA639C879F0896C732809F1E795988186E31684426E8614AECC2B4F8F49F7A03FB3DA309BC0F4820493BDC03DCE690E8450826BA03038A98235B2CA28A87E7093C59E5DEC4105EE9BA610726CF3DFA92467E3C21E7DA2606B44DFC476C3F84';
wwv_flow_api.g_varchar2_table(95) := '7011C9C90F3E66C09979C4B6B63191276C85CCF7C2CB94815572039E0017A630C07CCC5E98E58EC1F4845DCA0465CFB5331A0134D4F7010255996EDE34076C22962C40C49DA7A29D230AB2EAD77EC86B2B8BB3646A91C3A498375A277F9A397519E0DDF0';
wwv_flow_api.g_varchar2_table(96) := '4118C2D728BA8B5315EB3EFF00A4191634E5AD39507553DE8993CDA65CB9B33AC7334F2C22F5AED13279DD908A499289DC39F3E40C91479EDD13EF76C81DC308139D7557A9C4C0E826C953FB562DC60395C116F78E43A03A0E8B3DB3F67385D99DF0598D';
wwv_flow_api.g_varchar2_table(97) := '001527841E44D1766198820E0E33E86D89B56D736BE38C1522A0C2DD60431A0AEC8F493053D98249596833631C9D92F48B37AD3C8D66F762E4940379DADC4F424C238AEBCC35F182CC6800A930D6898A6AED7AE6C103A1B4319A451F114E101258C3E279';
wwv_flow_api.g_varchar2_table(98) := 'A79A744C006B4BD75F0812E610ED2F5181DDB20A4B5A252A06E80CA7107081596E230998EE3869601A8761DD0D2AD32B59732B1E8DB1DA36E8FB4AA7FEB1B420DF5FD204A908675A08EAAE201E30B69FB4A65F6F5640EAAC01B3A261BC4495A754B57C20';
wwv_flow_api.g_varchar2_table(99) := '37EC572F6C8DBEE8E85A54F42456AAC371DF0072974FB42913D7B72D1FCAABA2559A5F687287E5D09830216D083FB3CDADE5FD47D224CF46054ED1B8C506D30756BEEE80AED5967E1A6FA7E228F38DA8EBE1171B099FAC7DA95CFEF663959CD45F89EE8F';
wwv_flow_api.g_varchar2_table(100) := '415B3D947AFB4C11253139B9C58F48498B5CCB3BDC9530E0FF00BCE03D9E31ACCEADDE7E1025DA10B7B6A31F28071C77E1CFC3AEB971E10548208CC44A52756EB20F1C61E69D830EF84986A499A0D7BFA3106556EB56A8788899F677DA12C85BD81DD5F9';
wwv_flow_api.g_varchar2_table(101) := '472B2AAC69996AD3BA35861BF6455D7F8A2B2CDE1BB6C090FF00C3F4D3AC28DDA19C2BCA757A1A8D862D52ACF24CCB44EB4B30DC2397FB466F2ADFBBF5442851400500E91A64C60AAB998BF6852967F5649EB3F199C3868A1158D5451DC29D0FA44061E6';
wwv_flow_api.g_varchar2_table(102) := '49BFCAA0BC98ED18C59997AB35837C2B12F72EB796930DDA070E239839B43AB300D47FF7B20912CB4AAFBC9F0CA1254E4BB308CB7F7463298461209EF8E5ACAC25CD18DCC81FEB06F0A3A9A383BF4D6264E174BCC9AD5603E1D1EB103BCD22FCC9829B29';
wwv_flow_api.g_varchar2_table(103) := '893DD0FA8EA40D519DEE038C2DA2DB4BC319727D597F5683D37DDF609B7E57BAF98F030CEE359B2EED3E1A78681CF79D676B8F9DCF56BF285B3DB1895ADD25BAC874F29EB528788D33DB695B8BDED16641FBB04F79C7A32F36CD2DD8ED61589664CB0893';
wwv_flow_api.g_varchar2_table(104) := '0643788A83484479A126E46F6009E0799F77978BD4163BA98D201DFD12CD96A1A6496BEA37D331E3093659AAB8A88CA328F0D1485546B94A5283E1020730F316D52D3597F129D9DE639173E9650F35E6D9AC0BD4966FCDF0D9D23CC98D455152612DD305';
wwv_flow_api.g_varchar2_table(105) := 'D94D32EC94E1BFC619963C6058AD0F5AFE131FF2E87619804C01892C6A4FC4C013272AF0DB14E5B6F64C132A62B0E1D0F5A922D13301D8987E4DA2B19C1031A4630083EB080606930CA2AE476607F673E71424A1F6BEB1482A7107031C830A1D74E612C6';
wwv_flow_api.g_varchar2_table(106) := '806716DB711F8930843C33E93EECA7FB2C86F4CDDB6EC8898A8B8CBA3A81ECC3A9C8C1287C0C0342A46DE3129D253BB91AF41450C3898C79341C2AE7E50D7036B678FD22B2FD1B7988FC597F18131E6FF261F1E85E54C1AAD9FD61EC9683E9E50EB7EF13';
wwv_flow_api.g_varchar2_table(107) := '637D6290C21FC2198E43763FA44B236B0E1B2197C603CF9AA836576F741FB9D96ECBFDF4EC3C962B68B7CE6F665FA25F84106406E2E4B1F8C1996600A9CD37774102CF33CA2B3184B1FCC62E99F7D2985E188D0D35754D1194F8424D7216A818EE1510EB';
wwv_flow_api.g_varchar2_table(108) := '2F1454CF79AE8701A8D30851F38B3A1146BB53DED8F46B265633E76AA53671895246606B1DEC73D1366D9DD04B02AE18DD084EC060389332E9DB74C6B23794112D54CB2D52B170552653AA79A3BBA149B2709F28D659DFBD4F030262E18D194E6AC33074';
wwv_flow_api.g_varchar2_table(109) := '4FA0A9BB95612589452F67C964B08B55A03BF1AC52C7283CC7377DDE30275A9CDA276757C429E1A3C60C1E6D9266DD65F9C59D1DB044029F3305C8EBE5DDA2CF65F524E2DFA9E8DE64C34551527844CFB4E72D17AB2574348FB3979599919BFB34F1859D';
wwv_flow_api.g_varchar2_table(110) := '686E5A756B8F501E0349797E8A66F191EF117DA8D371D6DDDDD08E77DFE5D4CA6A0B4A0FF3F842BAB02A45411B60E198A13088A5E807783DE4C5F0A9D6C4818F8C1A6ED0741E74999D8998FF00144C1313F0D411B8E879CD89C946F6313AD9306BCD7346';
wwv_flow_api.g_varchar2_table(111) := 'E1B7E3D0558D06993F66493AB7EB39BBBE900B9088AB455DA78082D3EFD9ECBB250EB3FBC7742CB952C228D83A11D19DD014FF00C94D6D53FBA73B3DD3A0D8D7F0C8A09A3637D224C8572E7D624E3E348C1403A0E83A72D0556AE46ECA1ECC6CD5E50535';
wwv_flow_api.g_varchar2_table(112) := '4E238C2ABE175AE4CF74E89164906F5CC0D32BC73F2897293AA8A00F0E82CF241DB7CFCA25CC1EB2C34D6EB648BBDA3EFB6805A7DA31036D0E3FFB84B7DBAA669C5259C906CC39A3BFF2261E54C155614306C4D56AE1267FB1F51159A3D230C7701BA061';
wwv_flow_api.g_varchar2_table(113) := '5A1AE93CEA0B4320DA00C0C0BF6873DC29044A4A5733B4C499A1168D833531A8CB1899677AF2A16ECA7FAF7435ADB399AA83D98BE73A8006F8C39A26AB06964D0A919180AC2E31CB718A6C0822A4E179B1899689E6F59A47E1CBED5721E3B63FE216D156';
wwv_flow_api.g_varchar2_table(114) := '6C6521C94777E9F943CD6953060723B54EF10D64B59F4C327ED88A1312CD29873FC798F2660D56FF00758E4D9AF022AADBC40C02BA6ABA8F97087AF556A13C2258398510589A002A6030C88AE99A833A547788A184763560B74F8650B6295B4D669DF5F5';
wwv_flow_api.g_varchar2_table(115) := '62FCD43C84BFF1B461E1CDACD7C4E4A333065724530AA9AE7A664D3EAAC24C1B47C7A04136F00D936CAEE8F47355B873DC35703AAC33531F77B41F49EA3E41FF00AC50E60E86776A28CCC24C5C9B9B4E65C99811D471B2180376621A7023E8626CE345B8';
wwv_flow_api.g_varchar2_table(116) := 'D529C4FCB424A1FB46C7B844AE02E9F0E634C9140C7353F283CB4BA16EA0AFFBC20B56EA637E652B9EC1C612522D11450081179DD546F2691791830DE0D468BBD799D91B3BE264C72496DDB225BCB375D7227311339451542358615AE8B3CBAF59EA7F86';
wwv_flow_api.g_varchar2_table(117) := '0FFDC3D034B98B5060B637075662C7253082C06077E9935C9E65D2775749828FE0777747236C35967059C3FD50AC0820E4442CA1905AF8C3D9CE6BACBDDB7A2A1C260EA3FD7843DD37262E0C3618AE0262F5D7E638428AE02588277B9E619B34F70DAC78';
wwv_flow_api.g_varchar2_table(118) := '43CC7242D75DB628EC884952D68AA28068E425CC5E52878D3BE905A6CAE55FB73358F86E879D2A4A24C2404A0A54F1A41E4A5149BB4E7E518AE39C531A53D6CA06233D821E54D14131851F2C7459DF7391E708673D0B6B5DDB8C6A59D9BBCD20AAD8ABDC';
wwv_flow_api.g_varchar2_table(119) := 'DD006E4C5E1930C0C6B2975DEA311DE3E91791830DE213DFC63929E4B4BDFB560107031ACB5A41C0F9C194F29590E60C032C34FB113D4F5A5C25AECF32F5355F78AE55892076C8F31CC4972CEB92B5E023C79C27CA5ACC96311DA5849B29A8C3FDE312AD';
wwv_flow_api.g_varchar2_table(120) := '09812975D7B24449571598456E0E31AAC258DC202ACD9849F68C3CC9F686341AC49C077431C906FC917EB092658D55F8F1D00316BBB541A57BE004014708BACA1A9B6072DB3AB4C2906AD5AE58D3C20250E1B4460C3CAB0BAFE508B2D4DDBD569872D0F2';
wwv_flow_api.g_varchar2_table(121) := '571151599B148FD4C5E677BDBF38D6BEDE34FD22EA2051B87445D09499DB5DBDE36C3CAB5A5148FC65EA0EFECC63F08BBD87207767A50CC3452D4AEEEF81B4521AD160A2CC228F2BD57104CC3726A7EC9B06BDA6A3ACC68B124135633057CE0F3E6DAECF';
wwv_flow_api.g_varchar2_table(122) := 'EF3A7CC42B9A537915A71A47281D1EFE37EF671E966F82C3B9A220CCED31751588AEA4BD8A37989725760C4EF3BF9AADC2918C5DA0232A520994F7BD96897266BB4BAE1E3BA07A3BC77BE302F1CFAAA0627DD11E9B513F740E27DE23F411402800C00E9A';
wwv_flow_api.g_varchar2_table(123) := '8F3057B3998ACA5796C73A2EA9F08E4667A36BC4DE63AADE3A6770C612CF30EA31D43B8E806B7272F55FEB02C7F68EA4DF5269C9C77E82BB25E1E3B61E71CA5E5DE7A0A1CA26C96C2E9C388D91F76275E565EE9869931C2AAE66254A92A6E5692D7793B6';
wwv_flow_api.g_varchar2_table(124) := '04B4CFD76DE749D343940A8ADE6A083EEC06A654C205F6084621B744BB811529469D5BC491D95FAC17AB3CC3D698F8B1FE9A3C3A411764BAA5737389F08BC3D20DEB9C2828FE4603DA1292FB27D6FE900D8260B807FCBCCEAFF09D91C9DA95ACD30661F2';
wwv_flow_api.g_varchar2_table(125) := 'F031810CA477E117366686244C3994C7BF4195347BADB54F08160B7E1434973786CAC3CA5EB5F378EE15CE16526CCCEF3BFA19568A6B2B5C3DC625BCC70AB758127BA12459D5AE06D51B5CEF8E5666B4E3FE1EE849A35A59C194ECE222A871198DA345C4';
wwv_flow_api.g_varchar2_table(126) := 'D69BF01DF12CCC35722A7C745E6200DE7089A92AFCF61742ACB5BDB6F18D4B248B3AFB66FB792E103959F3261FE45FF0C59DD16831046C89F67AEDBE3F43CC1D30D252620653B08A885790D36CEDFDDB4516DCB396B809B9C146B009B297B07182274A9B';
wwv_flow_api.g_varchar2_table(127) := '28F756034A9E8D5E38F945C7C1C751FB261EC16A97726D755BB7A468C318C33DDCCB507BB4E4CE6682BB20002A62FBE33D8627B3C0686E0CA615D731F11027266E353BFF00A42AE6CC713159F35506CDFE514B0D9B92967F6D3BE4203DB273DA5FDAEA0F';
wwv_flow_api.g_varchar2_table(128) := '08BB2D1546E02903429AF5668F8C489BB2F51FB8E079A74E5CD3A073C69A4D948FEF0AC564D64B70C4452629B4491B7AC3CF310BC937276B4C65A93AD5DC37C54FE2A61307CFC745EB8EDC156F18597F709C92CE6EC3E90C6A71D9BA2A229EB69E4E59F4';
wwv_flow_api.g_varchar2_table(129) := '0870F68EF895699CB59A75941C97FAE9796D930A4147EB08928729778FF343A5865D2B835A0E4A384728F59D3B6CC7C62BB883F183CC9943D4A3F944C6452C1316A674269166671AD7057C30D260F483A333ACFE8E6E7418063F5813262307FDA2B6D061';
wwv_flow_api.g_varchar2_table(130) := '5D4D558541E0748E22268A9AF7C2B25EBC22F8CF2238C3596CEDA9FB471B7808913ED32D568B8263ADC5BE9CC2CCC001B4C7DDAC76716899DBA6AAC07B6CDBFF00DDAF57C602AA8551901B344E3EC1E6D08AC37212825E38D22D12D4D556ED0FEB0C3768';
wwv_flow_api.g_varchar2_table(131) := '30740D27A41CFAA01CB2754EFF00661ECAE0D64E5DC76786946F08E5571DE2052B8D7CE2624A9AEA5C5185738131D3D0CB38D7691B39845FE51FB09F3859B6B6E4657AB2F6D3BBEB17654B55073A0CF99346FA0F33483A4E86B87176BB589D39CEAAA7C4';
wwv_flow_api.g_varchar2_table(132) := 'EC80AA8F31D8FABBCEE804AD0EEDDCC1F97916A0292A7E133BCE074DD230222E365BE2FA0C0F587CC40DFB0C2034AA6069A3D34D00F6736F28E46CCA65C9F58FFE47E501AEDF99DB6F90E7596576A6DE3DD2F1D19F30D9535A760D41EA716DD17668130F';
wwv_flow_api.g_varchar2_table(133) := '1C87747A3948BDC3A41F9067DB29AF786462CB31BAD7287C30D2CF385E3EA2ED2612434A3CA1C8AE51305DEBE223D290A8E9D66CAAB06CFF006723339F5E9FE58E56DC6F1CEE56BFCC602A28503200506896667559A95DD1791C30DE399689BEACBF429E';
wwv_flow_api.g_varchar2_table(134) := '18B1F38A571E63C9B335D44AACD9FB8F6538F18B92D283F53BCEFD167967398D4EEE61E807403A0B44BED4B61F087947F66FF06C7472B37B9576B185D5ABB10A8A321C0412483308D77F90E112E5CA6BF3013AC3AA3C60A8B4DC96A358679C1594B89CD8';
wwv_flow_api.g_varchar2_table(135) := 'E67983838317A5B11C41A463343F068C355F6A1F943CC5157EAA0DEED808961C934C38B31CE274C72165CC96125AEEA69362B2350FEDE6F606E1ED42CA96B755700341EE89730EC71747007A03D25684D0643180B5D62B5BA73A7773AECCB42DEECAEB1F';
wwv_flow_api.g_varchar2_table(136) := '8438126765C045B17821FD61A6CD7BAAB998698C354612D7708FBD5A2656653D1CA5C4807698B9250AC9072C947BC604C9EE26BEC1EA88694D990C3BF6D79A558541C0C1C2A9B1BEBA0303461911122653D1D9D6F1E335BE91293B295F38BC361810962B';
wwv_flow_api.g_varchar2_table(137) := '2FE3CEF5BB0BDA859495CEA49CD89DB0744F6DD2CC59A5EF71F0C607E44BB780DF04BA2B2EEC8C53915E18C19D3556F0737780A69249A01998B92472CDC0D17CE2B36709325BD5CABE02019D31E61DC35561EE59248C09EA08B5FF00DB5FD612CD29AB71';
wwv_flow_api.g_varchar2_table(138) := 'AAE7657742802A4E4042B5A5B935DAA3163F485972D02A2E4068913D3D4717C70DFCFD69287C2274DE4F1035457363908952DBAF9BFBC601E1489695A066CE264D7EAA0A989D6F9C072B3CE1C1041D33658CD94886B45A262AB62A8BB69B708A4A96C78E';
wwv_flow_api.g_varchar2_table(139) := '51FF002DFE281CA4B65EEC62B2A606DFD2DE6F01BCC5F7CF76EEE83A138B368F4AFAF76AA83331E99848B2D6B40316FAC0E4E502DDB6C5B4CE7392CB63E422D772BCACD0AABEC8DF1C605A27A7A66C87607D7A454AD655905E6DC661CBCB417DEC4C547A';
wwv_flow_api.g_varchar2_table(140) := 'A22C9665FF00A965AF742A2E4A283B8418BAF385FEC2EB37908F456612876A71C7F9563D3CF993387517C960CBE496E9DC2907929808DCD818EA29FE283795505467FD215F967BC36AEAC0E8CCC78BEDE5B846148C744B13182DD5D624D338691F65A060';
wwv_flow_api.g_varchar2_table(141) := '3AD38E423969EE6D13B6B3E55EEE69419CD609E19983096AB4AEBE689D9E278F49327B7AA30E276425F5A4D99AF338B18987D931FC42267847D9827B8497252F927BCFD22960B23CCFEF266A2437DF6D8CC0FECA56A27D62EC994A8380F9F30777418CC4';
wwv_flow_api.g_varchar2_table(142) := '1E2235594F71AF34CC7340219991813F8636011A819CF0C23F01FCA1010A97AB99FA42AD1AD36AD92947AD17FED29B4518AC897801DF025CA40AA360D122E75AF5E3DC3645F967BD768D3224D7A8978FF1472F357D14BCB7337F4E82A6244B94D545BC49';
wwv_flow_api.g_varchar2_table(143) := 'DE69CCB0D850E01B969BDCB968983D830BEF439E309689B2B9477A36BE34EE1CF1CF0C27B834EA93AB1498B43B0EC8A8620C62FCA2765A05C6A3760E074198E68A204D9C79297EAAFF0048C16A77B6315D91C949BD3E6F6250BDE67211E9E67DDA57EEE5';
wwv_flow_api.g_varchar2_table(144) := '9BCE6BBDA165495A28AF79EFE64A6D8529E501D1CA9D86183002627587CC44C9D30D15054C35D1AF35ABC147F4897210D6999DE4EDE7DE7DB90DF18B516B820CA2BD9427E5CCFB52D24F50894BFEFC204C9B5C4D1546662B318C9B25725DBF5855DA930A';
wwv_flow_api.g_varchar2_table(145) := '9EF58214EB4C7BA3F8B08541928007874639975D430DC63F0AEF718EBCCF8451650EF3898D499313B8E1F1AC4B3CB2B14CAFA54577E0447E3C9FFEB3FF00946B5BE9EE4B51FAD62F4E332737F7AE48F2CA02A2AAAEE02839C51BC0EE317662F736C894DE';
wwv_flow_api.g_varchar2_table(146) := 'D50F10708FBA4B3AB2CEB9DEDBBC21ED6E3F10513DDDFD019B5C3D51C22BC22F375DF13DDA447DB330F5127D49E18C35A2761224D292FE5F58000A0116D974C3962F16093B1265E3E18F403F30430041D8602C863CB5715192435A27D79256CBB662839E';
wwv_flow_api.g_varchar2_table(147) := 'E06774FE9A1265A9D47625E64F788EA103DACFCB99F69D9B1F4B314F856F7CE24A1CCEBB77B6873DB96A7E5131E984B95FAE1F981D0349B1B55B6CDD83DD85479AA809D676397185B3482CF728A81475BC4C3FF679BC32C631B2CDF311859E6D37D4437F';
wwv_flow_api.g_varchar2_table(148) := '669DC32358057ECF9E788CA3D17D947F8DAEFEB07D0D9650F6896FD22BF7E977BB292A95F1304B4BBCD535BCE73EE5A453EEB242FB02EC50D659F6B2F3E659EF2EACC6954F0D3647DE8CBF18B54DDF302FF2FE7B949A7DD5DAC7841BED765EC96B978EFD';
wwv_flow_api.g_varchar2_table(149) := '08C579396C2B79BE90A665A5D86D016958BDF761952849221EED9256B67857F580059A50A0A750400A8A00CA829CD2FD57DE36F7C6A80E38670472132BEE985579135E56EA623BA2BBF47D9B6AAF52650F81BD0181A8388D1667DD308F31167F6AADE67F';
wwv_flow_api.g_varchar2_table(150) := '361A7CD54072AED8D5E55B85DA7EB184DE4C7B187C609F4B39FC58C03697089B97168B92973C4B1C49FC8CC3D8656F94599A94A2DD23DDC3419336B4AD6A33061117055000EE1F99A934117240135FBF5444BE56E80B5A051BE2E4A94CE780857B63D7FB';
wwv_flow_api.g_varchar2_table(151) := 'B5F998092A5AA2EE1F93B4491D66434EFCE2D127B2E1BF9BFF005F963CC771985AC100CA5C762C5E9D359CF13A2719E09B8305AD018088815770FCB4F5AE0651AF81FC8FFFC4002810010002020104020301010101010100000100112131411051617181';
wwv_flow_api.g_varchar2_table(152) := '9120A1B1C1D1F0E130F1FFDA0008010100013F102E9F539D47572EE61F817D086E1A8F1D34CE49AB8EE1C074E257E158FC26122B7F0777F81BFF00F0270949453142029A978864F3729D3C970E826045CF4B98A98E970091728E4783F1BEBC747886FBD0';
wwv_flow_api.g_varchar2_table(153) := '0473815748F8BDFE0A95F857E0A02A800AACAB5E21AA1F8686A26A71368D78EAAC046185364A238DC2C20F1CE997F760E5622B7AFF006F27866A78FC16494B85B8BDC4C448B2AB1E0852588F4269FC5A505DAE5EEF82348B075573F0417AAA7FD3E58EBA';
wwv_flow_api.g_varchar2_table(154) := '12F0A6D3C5EDC44BB6AB384C48CD3E01BEB7F859989FF39F32D538FEFA83A731E22F456E2AA622B04EF0816BA6CF98E568ADF95A38601A9317878318DD2BE66059021EC9EB121B538256084788E36AC682D6B34108A5D9CCE1FE29245A9DB20B0D40C582';
wwv_flow_api.g_varchar2_table(155) := '86D77E8F1D2AA05443CAC10AC9089083628F5A5B22F67989A9E143D89BC7370D245640152D01DD65DE515718F71B7B8F0F2ECDF0A19C790A1F9904D015AA54716B2D5D0D406254521380E50C5C7528CACF4AC30A8BC05C2D5CE7A168E8C2D23EC1B5F902';
wwv_flow_api.g_varchar2_table(156) := '731F0AA9B07F308B562D78D4390FF271203E1571E957CC44C0E0758AFF0041958EE46762EEF7B0166662E7FF008A7C474475756C2E06A454254ADD404E01B70B77D240EFB2D8BFCFDE0000002AB551E5E11F5355092AA055B745CAC20896219A7BFF0077';
wwv_flow_api.g_varchar2_table(157) := '07139E9B26D3986E1CFA95D281AAB4F6B41DE66532B38F07B13885D6089AC1E49F278453B497D99B66D10A8BAF5141D01C3050CDD80C1687755A00E58DF56FF12D641F1869A71911349B1962B08F141A7B731CEE353EC3261AA1145CA8E496416BDA6955';
wwv_flow_api.g_varchar2_table(158) := '3C7329339F465A45C0E4CE20774F013CBF09526FED8271F3389745BF585FF50C22F6B2BF64CB4B66278E076F2E665C0A9F096A2D986FBF023A3B95F6A3211698099F04A8796FBFB35F80C302730993A59E0A6D9EBC8C678E1C5BFF008577119A0A4F8039';
wwv_flow_api.g_varchar2_table(159) := '9C0F32ED6953C5E05355CE395B1A867F5AF1F0437D25CB39186789C4C18868CC02A3CFB88B124038797CA2E5F7D0B504189A7CC351C81D3D37720983D62D6013879386276885CBC9A7916EABDAA045C508B691BE2998C023DA2DCA8854FC10DB7BFF0087';
wwv_flow_api.g_varchar2_table(160) := 'C33025B8BFA21336A313EA35CF3373C040C40DBB4697FF009911179A8022B2F8A9C7A650FDABFA83B72AD54559A0F30B5FD3E60A663A2FF01B62592B447D4565555A7F77CF10299537BA817F44E847A2B02D3E0F1067B7086F706D584ECDCFF8E1863B00';
wwv_flow_api.g_varchar2_table(161) := '2588FC8CE51DC348460D40C11E71D4A59AB4BE64FC1A53B6441B7A466359AB2894476E60E641DAB77DDD6C44521A29B83CCA3D63E2F09801323A9764D37E19800ECC15863580A983E816B47A025191C09E20AA60E2ED19A729DB0143C370BBB05FD41A37';
wwv_flow_api.g_varchar2_table(162) := '50F36B2BD8FF0058FAB17D7891B3D233E1F50BE5BCCA657CAFE223AE9DE0E23B28E43678F1AFD92815EBE053FC427309378A46ADFABD198216BC4563B1C7844495F8420B9738AE1B2729B671F3016FA5A26AE8D4A2C1C1C27611D7C4AEF87F463F9B41B3';
wwv_flow_api.g_varchar2_table(163) := 'B9F7D4AB6350F1DB12D5377C4D9357173B43E23F681C240F48E99B3E61E657682894C9523395B3998E210DA8B734311DE022696CF6F18CF9805894507E6D3645ECCAECA1C010B09131A98F95CA4AE4CD674AB93FE3F6A27B3A9D0F12B1F3D38979CE25A0';
wwv_flow_api.g_varchar2_table(164) := '3978602ADC1CE1D9C71A0AE6732F2CA48BA86F842CA762192EF250763D7C414F8C3A087078E81C7B86C8194ED3BFBE8F45487795BE4F8895401A4C55FEC432086A3D8C70CB8820EF1B49802644DACDD3BC40520264476317B73F1C39677B94D0D5957D0D';
wwv_flow_api.g_varchar2_table(165) := 'B3935A72BE608E6D48B24AA96D63C2BFB3221B3601501D80890106599BE8A865E2C3CF00880A835F019A189C7421278D237E9B9B4B9C907965A72EFF00D9CA0558A5BEEBFC0608B6B4E7BCD18220FD72DAEB3961E0314573B8B83CED8C266A4D90D4ED09';
wwv_flow_api.g_varchar2_table(166) := '775398EFAA45DA88CF24B89AD2B998EA8249C5D75E186066A6F0CF42D8F5397A989A2BC7DEA7C300F05580B5C25C2441CDB2A73F541A706C0CBEE3DB1BB84ACA5745666E30D83C92E8BE87932E2F1A8C808ED792AB085642D583D8CADED0B5F6637110D6';
wwv_flow_api.g_varchar2_table(167) := '5BD58768CCB8F2813CFF00FF00063B6657C07701BED48A1CF06C72F8EC4504800557001DE064301C5A9957966F41739FCF63B13351D74DE6D3BC1F80C872B810EF0343562E6C4372AFF06E96F05C54004AB6D6DBAB6934BADB117DCD3A7C3D0EBE653465';
wwv_flow_api.g_varchar2_table(168) := '63873B7DFF00F48404447254D45C1B2153966E119B31DC3F64D50F853712957012B0955AB367276C70C320A3469B3B330EEAD58D7662A3AA02C47E04B852C46A2DEF4BA82D216A00716EA4E3559ED3DA2F10AAA43E2F318C6E8BB478950143D002D68EE0';
wwv_flow_api.g_varchar2_table(169) := '206D19AE0B781C44E499F82A30E61F80EE53E5ACD01A5F902E2DAFE8861C02ADE46094961259708F08D41BF53BC3160E1996D0398BC318ADA707C9A9C4E73357DC4CF421143718727B82B822FA71808BD950DC00E9C44A7C2D20F77D147765E5972B35E2';
wwv_flow_api.g_varchar2_table(170) := '16D49E52777282B85BE908A9E08B374ECBFB55868E77C9F2B99C134F4E08E88699DA863DCB02D111864F18B425673307EEF44D31C4E7A9D388D442ABB90A23D6B49E2C41D10EA68F50D1F1D0D19B43706D1583B336254829DE2D15FD30DCAE9700CAC291';
wwv_flow_api.g_varchar2_table(171) := '2A7729A558649AEE13B92F2437D6D5F3D4E3DCB911FB208274344EE424EF5CCD0241C0B7ED944C79157472F2C2FC36A03B5A0FC5CC658156434C63A21A8C3A9C11884382FEA3FCB75C85585A144701CCB94D06D59DFCF2900000380289C1EE691DBF8308';
wwv_flow_api.g_varchar2_table(172) := '19B00CF25B18AA41955B4EEB36498135458C6DF566DBED34B1D22582A897462BBF33E4977C0CFDF7C60B971C60E108D3C32BCDFF00234B478A48F019ECFF007D08F59841E5C31C30C9DC1E18891416B81EC8406997FC48AC06791FB51FAB8AF83AA45B60';
wwv_flow_api.g_varchar2_table(173) := 'DE85D98689A5506003894FD66DF118E4E8B6DCAC46711896943EF10CC76CF1424C337DF6BBFF0083BB389C1D382730EAFAF31EDD548B5C6D10514E06F3649986C3AFA8B359A4FE1D1DD37E399C4E7E26C99527EC429ED14D0F4341FE7B819C94361CE31D';
wwv_flow_api.g_varchar2_table(174) := '61701989AD7B5CBF5B9518EF514C7C8F723011112C4E60C7CC365589C57B3FE4A90B48F21944211A344E481576A6FF002EA28B4EC20B2D88F0DC3EDF52BE654CF90CC120552733F8CE271D1D4B311E961000B57001CB13432B14F7765BBE50D05DB1435A';
wwv_flow_api.g_varchar2_table(175) := 'B769647E8B5F21B8638016015F233B936477D79840D42DF439530A965E2279290F7A7F44FF005022C043AA8E5CDB6C3A6E97B97B42CBA94E3D438468CB956540E03743BDE185CB2770578F9092A62F1DAF9A6194C54E431BE2DD830FD91BB0CDA42D38CD';
wwv_flow_api.g_varchar2_table(176) := 'FBE8CDC1ED8CA31FA3DE3204C3B7EF0C1BAD896101F6E860394401401A083112D8118FE7389C75E3A02F2B48301F4E1763B1D928060A040097801D92C97B62F63F88689DE7FCFC0EFD0714FA793D2440C20DB1AC4D12A3D182062B917F333898C1A8C990';
wwv_flow_api.g_varchar2_table(177) := '03C2CD9F1D1E2708E215DB6C4A63235F282A9F2497C3DD4EDCC25F60E528009DB42DDB83332A78C7E8606BE432FEAC6DCA02CD39382029EBBA90F5B0EC17EB300AA8307677E0E8C75399C466E7E0008AF21FD4AF52682B1D812B8BA38D3E2AD299AE5473';
wwv_flow_api.g_varchar2_table(178) := 'E77FAC257090AA673D26DB82A11E99BEA2DC2641FBFF005C9DB1481D87BFB8AC9A3D4E51AA282E25646D1862D4525F5832CA54D9184B58E6F1E63E22AF432F247A2A42996FAAFD71D516B6A8F441D2BC161B74671032CE23B2687566C57857FB8B9FD7AA';
wwv_flow_api.g_varchar2_table(179) := '57052322612BB4A1590456C39F591B7C1A2BEC601ED07EF3363DC1B9B237F8A8421A7797FF0025293FADCD3DFC90B12EF682A5712C34F0710E6015163847918D4BD8D600AA189616568A5EF1D4953B4AA2730830386764D34F1345E25971E9725AF44A7B';
wwv_flow_api.g_varchar2_table(180) := 'C12DDEA1F669FC5E814DBBA2FA9FF7A1D384D11EA111F77011672ADE097F344620F07A1623952CDB18629DE8DCF77F91D7CC701630F20B044DAD6C16C62E6B86DFD095D7E36C13BB952D7B364DA37D71533D040A89F0B0D5F5FDA257341C0EE16E8030FB';
wwv_flow_api.g_varchar2_table(181) := '805A9416F98C5A867BC6463BA5B7BC8FB25C62738EF3012579630CB52683ED97D68B7CE6499D068BD81102C21D0283C8E197B781CF264FC0CA0953A032B373E8BE76EBC740E9C21EB32CBCDA81AE36EC420FA4B71B87C4674901A8676CC90DA2A52A8362';
wwv_flow_api.g_varchar2_table(182) := '27694EB9F2A063256FF6C3EC3497BB1C8CBB6EAA9881A2F7377B18229B7B42EB3E2CDF71451E0EAB6D99C90D0F5B3A1D5363B079194968138681FE45BF712EFCCA07EF7321AA328D5B4DB45E3C5965A7538B155674C6C9AB0475205B334ECDB0105C569F';
wwv_flow_api.g_varchar2_table(183) := '2EC63397EE80F5B4EE09D0BDAD895623A5FF008C49CAEA1CD9662ED870D2C2227B1D4D152EA693F805C40216AD64230F966B56F0F01D2B3491CA6E4FF60FD93A9D3F8332EAB79C3760E18A666E1790A191950CE6F41477D845BE2B0A0D47B481C8BE7DC2';
wwv_flow_api.g_varchar2_table(184) := '5A634C5D6C4D332A624E7AECF526BD2078EAE1312547894A7B269873C79DABFD260DEAB7624F289721BE18C9889A7416F4B99676E0297ED6DAC79A8812646F8B926FB08786FC63003595B46BD1CB1C5D378CDCA5A0715D3CD47F45459F78BB5F635128E6';
wwv_flow_api.g_varchar2_table(185) := 'B4F1E7E7A2DCBBBCA857F83F83B8F23A19D715C088A73AB80C5FC4E264A8DA13CAF262710CB8777CAF973336E58DAAF328155B4641585600403C0873EA7106223287A7A81D266BEE2C1C0CCC66F138B3D99A09DF94B3929AC0E9196D76C186A306D09B27';
wwv_flow_api.g_varchar2_table(186) := 'BD16163A13B2ADC10BDA6384C2B1C374784B89B982971C415EAAF512DC4FD51CC350CEA2BE1825BAC87DBC87BFFF00051B8216F75A26CE8EEE951F3481A870F0601E582295DA9F7E08BE4551D11FF603959B9C3EE27ED3BCD1E84C9BC4E0F5D79A0C1834';
wwv_flow_api.g_varchar2_table(187) := 'C0FB6645ED2C09E66F00E828444B1222EAA48D9CC768AC903C577186E6B94388B76108A1E7084BC7CC77E10B165B644A8CBA8B7FF998DF72033E327D997285416F6B4AC4784621B1E5FF004E8ACAC5B90CBD182C57A0C7FF00811A2BFA388E1205F0F316';
wwv_flow_api.g_varchar2_table(188) := '01F64DAF836C41EC1EDDC3FD53B5DF217A1583E6355F3115D07061CFCFE0223D434C7F0A2901531457CF308A174FF099A40F217C491C49BB9408979EF10564185D6E2549A8F69858E5361DC9B26999986702BC47D92F518E02D092FB8F72C437F71B2979';
wwv_flow_api.g_varchar2_table(189) := '9A27B38F9099E1528E03BF996C0B30EE73FA8202AC723E3ABD3691F0BC49586706445BF431ADAC3419C0F6D012ED61AEB2C3E9DC1D4F393744E01C20C5E6FA7FB9CF1CC4555711707B96D9D0D93BCED160F98676C7A2C52F73254584828B4285CE089C3B';
wwv_flow_api.g_varchar2_table(190) := 'BD1536C3D1D79896697AE3E373CCC9067566E35470143DB11307B9CCC99A673D04542E1B737859B0C4D98E393A6B62641E494B9C2EB1AD7723786CC107023BA225AD178557F335846FB081A9047404496C01F0E4EA87ADFECA4B7C1FC8C6EC6EFB266398';
wwv_flow_api.g_varchar2_table(191) := '4E6D960FF629038742F76560A05803407697E7D3FDC76876877B4AF60BB0B8EC8F1EE3CB3542C877783E59A47CC76184E9FEA19A3CC637338C31DAA0796F49747296971C8735E98DD4B7E903981FD8EEBA0E21F0C1B206388ED3FF00218505629E730CD1';
wwv_flow_api.g_varchar2_table(192) := 'E61E02DA6886921283BA1A94A4E664650579BDFB9419545CEEE1042D65F761BFD3B919D5FBFA8E600180DDBE53A109CC1238E7E73F0DE5DDE20BDD4A801652DA3B4186D3153117B598B40F557BB118A1E5310FDC069BA327C92BF68439D38FECF11A732B';
wwv_flow_api.g_varchar2_table(193) := 'DA0A022C765B2C4E6A03E00150F84EF0E5417CDC21CB3656D95866E3DA17851ECCC6C982C2F6272799401ADEE1EFB476B071E277F312AA728C6108CEC34CDF0E633EB1075920C19B11BB7DE0E21B4FC9C08708C51623A4621673E7751B651F2A83023B83';
wwv_flow_api.g_varchar2_table(194) := '48CC0B65082AC3708C4341FCA78EE5005333961B04764ED8B76DE3C8963DFD4B62A97967C01D29ECCA49838E8FE042BE6113C189DE385D89C0E580ADFDC35E7F80B9814F5734B1C51C1F01071F9195DD28344344C5260799B62BAAC2B75DD5829656C4D5';
wwv_flow_api.g_varchar2_table(195) := 'BC4402E6997BFDB14E287294C1704F989D9B3E2964BC354F27604B16977221E09532F2E9F6A414B4A5E375D5C13B4BD4A07129DED6007E48BA80FF009277EE026A9B2FE220F07EE1A8140A836FFA10D12022691D328D3430F24CA6FAE7C4D38C45C72951';
wwv_flow_api.g_varchar2_table(196) := '5967B302D075EBB2789A167E324ED1329D16ADBE7793F6CC14ECA6EC20E84B30355BDB5EC9667B8EC8F03919B1B76DBFE3470C5495BDD9DE7B1087D85F959CCEB05077578218DED4DAB80F304775F3B77079529841F2B95E58C8F5EEC8BF2329E21B7460';
wwv_flow_api.g_varchar2_table(197) := '3550B6CF4587E6A241A95CE2FB971C37147DB985DA4A3780CE771D8E6552403DD968D905F2F94D12AE680546734F7E81DD4C5B9D1FC88A01902E963B03AF89BE2F9A20618F043AEA84028E8DF79AA0897557FD160FB8A315C0AA1A4EFF00626D479508F6';
wwv_flow_api.g_varchar2_table(198) := '44D9172D7C4841CCE515B6ABB1259E04010896B322309271A4E860CAD64514D0EC2769B63D18E65A1DABEA5BCB7B6DEE62B4EEACDDF5086BAF331D157FD7169468D4DF5DEA8D11C1BD5799B28F82BF6C15D05BE5383CBD89C37E4FFE0ED8248E6E77DAE9';
wwv_flow_api.g_varchar2_table(199) := 'DE306A0677C46388D9EC97F4E73E6BBC6DEC196D5EBD4B5A0297FF0021161B8EA9AE3B83E12FFC4D4A5E2D57CFD872C0562FEE8A62BBC001401D821CC7534FE15158E7A7119846A5294410B8E86ED7278235DF4685DE6D8F64546E29155E387A6088A252';
wwv_flow_api.g_varchar2_table(200) := '6272F50CA9A87E18A8AD64E6E3D31600F85FF9E130CE15F627421EE2AFECA26911D366669847A11005A293B8C276C8F9AE5F51F65CA1E5B8F4C03CD6BA2574A2CDF3E402C5E797FE7D8E8CE608FC4A0A20DC25D285A96B072C63B1D4F331AC159642F21B';
wwv_flow_api.g_varchar2_table(201) := 'C8CA880A2C3CB3FE46CBF1A3075F6418B07556ED7C7814743BF302DD54485420C407A22D7BE8E98221351B0C2FEC443D08E8F1DB93D91CC4DE1DAA8FE0EEF1BE35C4029682ABEFB544A7EA1E6F8E25ECD52057A8F0AFEA66684D7F0C334677CEA07B116A';
wwv_flow_api.g_varchar2_table(202) := '7497A75B3B76602DB4ABAD85340B926D36BA699B10EA6E7304942A7735062B878D82E1F4AAFC35102B02EF82F1E5DD8F58DD55B848D586CE0C41218D7ED809996F83BA8870C2437B501F2C1643733AAAE8D04ADB51B70FA84B172331F44559BD719418D9';
wwv_flow_api.g_varchar2_table(203) := '52FE751E7E67FD9FC981B45E8D25ABA70C6F24B53572E09D05691AE86DEC61CCC643137EC8926794AFA6518B0950FC8319A1A8DA2DB6AAD4F88C719473C2656800F45662F22EBCDFF079218C72EFF02FF9D0E9A988BA07D7042F2AE4B7D481427AEA1DCE';
wwv_flow_api.g_varchar2_table(204) := 'B31F411A036B0D19EA23D246F7C8A6E7D7D83158D62F71CC655DE2670ED629AA305CBD0CB17B08A0ABE6771E7A6FC122BDA343E896C10896714077A2466344E499B3DCEF3148A7DA259E11817570695D05D41731D311A39E8B2788CE0F245C5798EBE677';
wwv_flow_api.g_varchar2_table(205) := '84BCC0DEB1DCA63FC3FB30F5F8BFE365F9B3BA8F0482D0E0D8A737F0616C3579BC7AF418593BC9F0433B747AF076D06222F865AA76820444D2439494D873D140AA002AAD01191E780AB9F8ED1BF14D32E9AE7AB63CD78B8553CFD9384EE31D16A6F5A403';
wwv_flow_api.g_varchar2_table(206) := 'ADF02389CBD3DF6FC0EA3AADFE1520A42667F297ADF332474A9545809B4A9E201B1A83B778E28456DDEC9DE6E7B9869364E2F4B379999786096E63CA3A8BB45D477D074671084D0827199C74698EF026152F3E20496784EFDC2F609B90B1834918438776';
wwv_flow_api.g_varchar2_table(207) := '208363898AE0618C56C6C878683E188ADCE8CFBDDA06509152F65FAF4FC0E935AC01ED619EE517B47131996B1FC9CC23C343A07809B506109C27D10E54E66E3E081B666CC2328E44B2A1FBB0F660B92D2D2989B3C67EF30E3348327A741FC23E5060E286';
wwv_flow_api.g_varchar2_table(208) := '6B97304382FDC5BFA8B383D44524324E5970DC1CBC44CC2047A503F3731E60773337BDFB28C6102EAEFF00398A8B28620C869992C845DEAD75381FAC50CD464598F4D6FC22523C5828F96883CF79E47FA79862F4BA45BBB5D28B986D69F11AA711F65FEA';
wwv_flow_api.g_varchar2_table(209) := '702FBD4D7E60CBDC3520C43640992904B63B5271F2B81E712F7A64E5C1C909614C5AD17C1A9A332FDC60FA262559BA650987730022A8B5CB5476F4D23B6188EDE9C93FE3D0E7A234950D908900BB8B2CFE31C3363D4596B2262FF6771BB896C330F10A85';
wwv_flow_api.g_varchar2_table(210) := 'A12E8CD1DE39E0D894771E96EE26727A11477A8E3B8FE84AAD1E834FD44BC9D39832242C43C440B63E8AFF00BA80154ECC44C31641F305280935924A9AEC5D04F960443CB5CDAC3FDDCCFB5E4C66980B4382728388B31D5C002A5E61CCD3EA5A3DBA1C4C';
wwv_flow_api.g_varchar2_table(211) := '14ED397A510949F50DF559953492A4E31F793F368AF75CB8F8139182D51A26A307EEED54737A8FD600B0EFDA6C3B2CA80B37A5787287FACC5DB28559EFCD03A550C1E822C62F1724BBD58A7683D5796FAE3B4B3FA0F2ABF781F10C9C0BAE6A19DE5FED2E';
wwv_flow_api.g_varchar2_table(212) := 'A47BCE0363BE17BF420E16F7BA6D1CA7BB3D3899FCF8777FB9A63B743190144672E9B1E968EDA9A9D3BCD3A3FEC77D2F32939959E875D46C167DB28BB43C68AF8258055696CF04104274C2FF00FD16661BCF006F2684A72D82C0F1DCC4B0534A9BF0456D';
wwv_flow_api.g_varchar2_table(213) := 'E5FD762A016EBD649969F7617EA3C00064EFE9255B07E872B9211DB0EEC531FDA74CE59FCAAC64C3C6D4C41F7352514D0EEE21C2D26395FBA1431D3E0E8B065A04BE88CB607AAAE04C0FB7A004C638975741A64D74A94C575D26ABA8AC97C447EC816D5D';
wwv_flow_api.g_varchar2_table(214) := '073012AD0E0F34768EE7371868987A37607B87332A0B957FFA6442642B4FE072BC111F0571FF00DAF31DA96A1FAC62C534699FB5CCC21CCB129FE76C51735C71C6DE7A19DE3A80C04878653CEFC592BB7632CD30D6C8CBDB7C24E623CE97647457ACEC27';
wwv_flow_api.g_varchar2_table(215) := 'CD5C048D8271158BB9345B5BC39E14140BCF128E10166564E0FAA8E39CAF5920DA42AD9C3373D42026D18BBF334E84DBE21D1CFF005D16F2F01B52BD7AEAD529361325B1B28261AA989C91DC3DC0B468039567B33E85FEA6E6F4A62FB3EE2A4A45A24182';
wwv_flow_api.g_varchar2_table(216) := '152CC84CDBFF0036943DB9BD20F51B8A6B215ED508BEF552ECF107F92B488B4CB5A701E5B5878B9CA3063AEA56D4EF87F20E5950DD61FCCC54451785773EB5184E0BF2998357147C6636DB46FC0470A7DFD40236DCF106BA11EC37DBA873AEC1B230A96D';
wwv_flow_api.g_varchar2_table(217) := 'AC7A166D168931F95181F505C25C041CD0727B1C92F1BB8C594588C1874624A8DA66237F01BEC110122C1D8E0802E45B03CB8A8FEB5FA97EEEBA5DEE4B25FF0033CB0B2CA877D0FECCEF7EEB6F975F13BBD365E9F9195716CF80B5930386D839DC2AD4B3';
wwv_flow_api.g_varchar2_table(218) := '6FFC5C7A71290352E0E1E9A425CAB5846674E8A29E0CB196B701546A6A3D94C4BE9F3A5CFF005805A10FC14741797E19FBED7B008B5F43DCFF00648ABBA25F8F02FCAC561F107C84E628AF31604B24F5044C6C831FA216B7F6511CC5A61631619CA1D2E8';
wwv_flow_api.g_varchar2_table(219) := 'BEAE27118440C01B5EC4334DA602D27128013C066879597B05701158A05B828634603936B2B52273AED719BAE72BCC29CF5D23A49C160D32665BB5D3B438FC62A8DA9B9DA0E197D071330BA1DDD2351416F39398E00E3F94C5BA2A56315BFE25BE374FB8';
wwv_flow_api.g_varchar2_table(220) := 'FE22FEF4A31BC97960C301BACECBB42A78799F7B3057D41DFA989BDDE398710732C9F306673F572DB53B4F42192CCBA3D69FC4E2699509FB69A5E00E599AF12DF6DBE58A1E5884128C0379BA1FB87285A0D517A855DEE7E80F3C103DE56963BB268F3E74';
wwv_flow_api.g_varchar2_table(221) := '4E22F78844E9C56F700E49BB6F660DA4ADC01F070F2E324AA213C13D43AF995D487783573115851B5D54AF372B57BF44DA1493025C14C3C6E0C5605170FC346E50BC27F8CAF1C4FE8839076603C105A2A80C1C0473877E92413B4C9F5673160A1E59B152';
wwv_flow_api.g_varchar2_table(222) := 'A2685F0913C1A5C7EA6A5F2F8851DC798ADDF030C316F335BF0B9269C4CE17FEC3640761CBDFB07965C48ABCC1E3FD33596FFF0090D133640195C0479D8DB022584CB4208A7B510A9366D1DAB958AF410CE32FE4A0B3E6094042AB48EA17EB57F5C1E597';
wwv_flow_api.g_varchar2_table(223) := '315B45C1EFE044A02EAE155B01B8FE1C428EAAA3DB95776C8AFF00EE3AEEB4FB84EE2DCD5864AD2CEC43109E6160777EDAA7072FCEA3A8B776F69314EBDFBA40E2005E054A83221C461C3D1A57A60BB1C46989BE80677F71C912B4E50B20384BCE4B6211';
wwv_flow_api.g_varchar2_table(224) := '5AB8BEBF7CB7CB13AF0D7FD088E9D423E87222747DDBE2DEE0F1FBD9A454DBFA16A02BAC06FA08E88259296C613074ECF7DC98531D195E99E293CE6042FDD2D0EBD229C6D3F346DF9437387A540B7A02C5A39607AE1AEC1D4A948F0F9CDC56154876E043';
wwv_flow_api.g_varchar2_table(225) := '47BC1A517EC8C0D23C5DA10AB06E1E4F9EE47100002803809AC4D43C97FBB94B959CDDEF82A1B6188BBF6834452B7189D132B861CCD1068C41CB398C08C77053D1DB05A9A20C7884D8F538EBB1BB058CAF9D645FCDDFC40C5543E6B7E080400000300438';
wwv_flow_api.g_varchar2_table(226) := '87465F4DDF04F6D089429130F78CE12946DF71B6654EE582FF001F30E82EF9B8D3280D38AA3F6431E43D34ECAF88614A638BF7526266C1F2E051234798A658B1B9621693DBA60662C63A6394265D039B97186EE2B1DC5EAC913F4276E845372F27550154';
wwv_flow_api.g_varchar2_table(227) := '032AE885D75967C3DCCB94BEB81CE5B6707B0BA7B547B5862274737689B05E41615115CA1462A1F459089DACE40FB086911CAA3E284F08B5A7EEC74486420F0CB1ACEF907CAE1293DA917DE62DEB68FD1070EDD07041AB505C260CCA15491457FCC8A7B2';
wwv_flow_api.g_varchar2_table(228) := 'AF42E3609B18D8BD38EBB90DA6FB260CE6FBF42A11BA84AA956273344E3E62B7DCB5C431EA691E877D12E6B80F89030B76427FD9D002AAFDAF5CDB090B719F75B0B17FE98D2EE1613B99878DA8869550AD3DB50472501A1E2A6450D04E660620042C2BEF';
wwv_flow_api.g_varchar2_table(229) := '31E8832F937F862B1E0350E5605BF6C8482E8596539F0C2600F41E020328561C8E465D2B2CE7CFAC529BF23B74C7E24564051013732E86E713961922E617519DA3CB2F31E8BE513991C010CA16D29FDA31657B837F98711A796804A46EB5BE2EC4557554';
wwv_flow_api.g_varchar2_table(230) := 'A2F8B7F0E184ED3BF4DD4CDC4C0F4CD4364D98468EC67E6FFD803BFC719AC2B0301681C90DBA37D82A5D5C61F88D42370A81074656352B3737188A8CE26AA5144799DE1940395A3ED8339BD3F6CDB1FA5155F5ECAAC01CBA5D5EDD13239AB750F688963A';
wwv_flow_api.g_varchar2_table(231) := '3A3A8E63D3884C591E8745C69AE89D4217860BE384470E2BE149F70C49DE2DAE97D42547A8A45B59712704DCCFA58CD7D4799CC29C5407588A3C7FE39B889FF9BBE8E2701C17443AB921F2150594D1D1F93D78EBC7446E318CE63BE8309B4D1DD3A8670C';
wwv_flow_api.g_varchar2_table(232) := '613BC7F2E7A3D757FFC4002F110002010205030303040301010000000001020003111012213141042051132261053281233042711452622491FFDA0008010201013F0083F74E906BAF7AB86BDBB35860C6B87D1949946A174D77C0306D8E0EF922D6536C';
wwv_flow_api.g_varchar2_table(233) := '2E0024CBDC031D6A54A96D428834B084D81307AEEDAFB4418F50C453D39328A95A6018580B0F3DA61D05EF81805B613A873A28E6515C8801C2B99452E6F85435751941168859297BA03700E005BB73A66B5F58C6CA4FC4A25AA56CC7887B2F3A8737441C';
wwv_flow_api.g_varchar2_table(234) := 'C10EC20846B703597956A3E6E442C4EE653A8C080358CF57301612C4EF2AAE64328B7B75E2283B9ED619F4CD694E9226D1B50444A55576616ED4AB76CA7430D306A06F02730C181195878263AA9DE1A69C313129DBE20006D8E4CB53E0E37070B93A08AD';
wwv_flow_api.g_varchar2_table(235) := '7AE7C2882E77C38EDA9483EBB194EF945F7C389C8C08B8B409727312483001C0EDEA50D4A65431536DC6F283D5A607EAB38F99D4FD51BA72B7A59830D0833A0EBBAAADD45BD2FD3E48E2137D04CC36517894C292792712C156E653ABEA31D341DAD518B8';
wwv_flow_api.g_varchar2_table(236) := '45BEFA99B010EC20DF031F460D3A9EAA974CA19EFA9D2D29564AC81D0DC18713F709D453AF4AA16A499D1B75E4183A1EA3AAA81AB0C8838E651A694D325250AA398292FC996031AAF95907932BA3540A04A74C228020C4544DAE22A282481ADE6606F63B';
wwv_flow_api.g_varchar2_table(237) := '18769CE0768C2E2D3EA74F3F46DA7B90832875F5BA5B84700370674BF59CEEAB5940BFF21046A8F4DACC2E2060C5488580D398149B66EEACB764238312B8BD981180C6A510C6E378B9A9D36BCE9EF949F267020376B62655A7986C36DBCCEB7E914AB819';
wwv_flow_api.g_varchar2_table(238) := '3DAC227D17EA08DF72E59D054AA9FA15AF703DA7C884022C44F4C2B0CBA4500623024799981DA012C3C773AE65314044D36022D6A6DB3095DCFA9A1DA5172E97381DA18CA186B14956CA7F061506D7034380D589FC6222ED8552A06DAC154A1D223865B8';
wwv_flow_api.g_varchar2_table(239) := '95DD80551B999D06858404707B4693A8A654E603432E674CE43DB830B01096B6D1EA570D6B4A4F508F72CABC3783330D0426C098A2CA3111631005E65B837DCCC9C194EE87E200ADAE86350A64DED11154698F185AEB000EA55A54A6699B4A42F5160006';
wwv_flow_api.g_varchar2_table(240) := 'D0C3B412AFD8651424E7631B5217B44B866F812E5BE04000DA100EF00005861C6025F01B4CBE37954E7B2DBFB9414016C7886E0682F00ACC752008AC1095317405CF38B3051732AB834EEA799EA5A98F24445BDAFB7ECDC01AC163B4104AC3406523EE9B';
wwv_flow_api.g_varchar2_table(241) := '4B822E2718D44CC3E631670A9CDE31C8A4FC406E01845C434DD491ADA5342D62769A0B4FCCEA7AC5A432A905A749D5FA9EC7FBA546CA84CA6C59149F188968B48A3DD4E9E303582D4CA768EB9960A6C083712B126991CCE998B53B78382B0248076870A8';
wwv_flow_api.g_varchar2_table(242) := '9C8DE3BE6A647305454400EF689573FF001369AD43FF003875C594213B45EAEA282A8C409BCE9D9D6AA94173795573532211585956C0011038FB9AE7B7712B85363985E5120D35D788E48524452B5562014BDBC5F432BBE44D3733A5539493C9871AA801';
wwv_flow_api.g_varchar2_table(243) := 'B88B4A9901A7DFA0D14402D04EA68FAD48AC6A6F4DACC08329B59D6E2E2F292A0519100046277C79C08B88DD3293A131292AAD85E1CC3C194D4D3A8C6C729133236978F4C965563EDBC0001611B789D6F4AF54D35ACA5BC60E2EA4440CC32F178C32A1CB';
wwv_flow_api.g_varchar2_table(244) := 'C094EB06537E25272C598EDC4CC4EC235257B6700FE23D1A694CE5402506BADBC4381E3B0EFDCCAA770232301A1B8F1293E6163B89D452F569B266203022F2B74ED47AA7A61F543A19F4BEB4D64F4EA302E0687C88E4B1CABF9314050008799E89CC429D';
wwv_flow_api.g_varchar2_table(245) := '253A6140C388CB75B444F4C8B9DF13C4BE1CC3B8EC3D8E32B061F9867D6BA47A55FF00C941756FBA50AD9595D09B89D3956A28E0DF30BC2E07F73296FBBFF9D9C4BE9191DAB061B011438BE622710EC311391D87B1C5D48F88A6EAB2B15CA50A86B8DA75';
wwv_flow_api.g_varchar2_table(246) := '1F48A34D1EAA12AD6B95E27D395FFC6517F6DE2A858C48524788BD40E4181815B83710D7A48E11986630CBDFFA9B094EA672FE01C0EC25A0C39C39970012656AB59DBDB70251CFE9AE6DED81A83600933F54F8115F2D10626767B81730521BB6A4CE9D0D';
wwv_flow_api.g_varchar2_table(247) := '335299E1AE3FA38B74D737532953756B122D3A925FAB7B1FE560612745806968D7CA6DE2512B4D09623582B533FCA0B1B58E03B09035952A17361B60085500F89959BEEDBC4000B5847365262867207022A85161819C61B4272A331F04CB92ACDCE6BCA0';
wwv_flow_api.g_varchar2_table(248) := 'E19039E4080B196952923EE20E9E9DF98A8ABB0C1890345BCFF248362929D647FEF070F536D167A0A00BB4148700FE62A812B92B4C9129570F6077958E8179329A645C58802E4CF5F3BAAAED7863703C9950820A5AF71321CB939CF694D0222A81B0C043';
wwv_flow_api.g_varchar2_table(249) := '80C4A2B6EA22D3406E144B0840800C48041044A940D32194F329A966CEDD9D5936513A7A56F71C2A1CB94C4165B9DCCF4AFD5DBFEA5A5A087F638C38C2A5554FEE12F51869783D63E04CB57FDC4CB53FDE653CB19569B358A982A5743620CA6F9F822551';
wwv_flow_api.g_varchar2_table(250) := 'EDC153FF00631F8EDE7B4763D655D06F3356A9B45E9C6EC6F0000683F62A0BA91299BA89617BD85EDDB6EEE6712A936DE27DCB06DFB4651FB7F3DFCE1FFFC400331100020102050303040103030500000000010200031104101221310541511322322061';
wwv_flow_api.g_varchar2_table(251) := '7181911452A1303342152362B1C1FFDA0008010301013F0087913BE465F3ED0F3F48E65F6FF4F68BCC3B983222F2DB4397694689AA400654C0D54D56DC01CF1F45B7DF2B4DFE9EF00CEC25A2EFBE4601BCDA32996804E9E9B93B6D3A856D29E98E48DE08';
wwv_flow_api.g_varchar2_table(252) := '661E87AB5552F6279FB47428EEA7906D07173C42498276CB9860C8719DA010DC4ED1798629BFB4F134DA749C0606A614332AD473F2FB46C0A526229D2001F131BD329947ACE4A587312950D05B51FDED2E003A7F99D3EBAD2C40D43661627C4EA3448C41';
wwv_flow_api.g_varchar2_table(253) := '207CAC63B0BD870321CE67DA3F3901E7C41CC13CCBE5AA19DA29DE1E0CEF01D69FF928984C4D7C3B6AA4C41EE3CC5EB78AD1BD2407FB8CC5E3EA573EF6D5F6E008599CEE60E25B78F5FD6C18BFCD0DBF461195883B8CAC06E7F427B9DA12178DCF99DE77';
wwv_flow_api.g_varchar2_table(254) := '83E86178C2D6820E61E3F53BC5241047686A6955F4C0008E616279390CBB4C238A4E18A822FB83C4AF4A8D43FED053F6987E9295C12B54A9077045E751C16169E1F7A9EF1C5FBC55B6E47E0799E9B13A9F610B0B5978C80879821FA1F73145CC1C98DC4E';
wwv_flow_api.g_varchar2_table(255) := 'F04A3EE429FB130D84AB8A62A96D86E4CAB45E8B9A6E2C46478822FC1BF2261AAD0A8812ABE8751B37622363F0F86A65681F51C9E6567677D7558B31ED0E22A7D87E25C93B9CEF908DDB3BC2045E4C5F9187E2608BCCA6DA581F0674E714F1AA41F65407';
wwv_flow_api.g_varchar2_table(256) := 'F9988C150C4D8D4537039989E8DA50B51626C3E26112E444DD1A2A13B9D8798CE105936F27BE4793F405B8BF68482726CCAC20E8DE24FF009185484BF9104EF139328D6D3B13B5F63DC1987EA1529EEEDA97CCFF00ABE16DC998FA74AA7FDFA36B1F90F0';
wwv_flow_api.g_varchar2_table(257) := '72A7A555C917E23BB37308C9B93900C7B4D046EDB42D7FC43CE465B3E45BCC553AC20E6F1F0788A6496A66DFCCC2521E87B85C31E262E92D2AD65E0E4BF2839329D4643711D55D054503EF0330BD8F2326F6A28F3B9CCC7E72C3872DF2DA1C3AD40755F9';
wwv_flow_api.g_varchar2_table(258) := '95293536B1FD1860FA8FBB7EE399D3B122A27A6E7DCBFF00A8EA03100098FA01B0FAEDEE530231DFB40101F94DF51B18010661F7D69E443B1B451A980950DDCE663F3FA88A5D8010D4D2EBA7853B41546C44AD6A8BC0B88E181B1169C9840179BE5DF2B9';
wwv_flow_api.g_varchar2_table(259) := '0E089A9A9545A88650C52E21750163DC4C495185A9B03B7119D98EE60E441F2865036AAB1D48A86FE6531A559CF8B0FA0C6E60564A60007538FF0012CA9CEED19998EE606652083198B1B9821E7222110EC237CA07DF7E089860691D7707C7DE632A3B3D';
wwv_flow_api.g_varchar2_table(260) := 'EE40237198E44BC05835EF1D0D54471CF795980B20E1732639F6CA34CD4209E00955EDAADC9E4FFF00209DFF0050C395F22612442611BC330ADB953C5A6257D97FBE420E7F72D951ABA0D8F12BD223DCBF1338107196866360398CC28D3089CF78016B80';
wwv_flow_api.g_varchar2_table(261) := '2F2C412089D2FA3D4C530A95415A5FE5A758E9030E0D6A207A561717DC1CFB0C8886159BDE1949F43DCC6C45365D241B4A8842DD775CC9E62E546A5BD8DBA9988A3A370368080203AB810DA92F973FE2724DE749A2D5BD54A36D62C77362444E8D47D8F5';
wwv_flow_api.g_varchar2_table(262) := 'E986706F0002C06DB713A8D3A15309552B3809A7996860174FA7831B4D8F6379622768AE578E3B89A038BA7ED619C002271FBCE8B7A8851A352D2E577E76800A2A091EE3FE2124924C3C4E9B8CFE8F1695791C37E0CA588A15E987A6E1948E44AF4C9A4E';
wwv_flow_api.g_varchar2_table(263) := '11F4B11B1F131552BB55715EA976536E6F2E49C97E27232FB410F32C378AE478B41E9B7959E96F60C0CD1529906C44655A8BA947B87C86482E23E0B1494C546A4C172A4D67532A9443ACF36D84766637301F305D890019A02FC980FB72652C555A44FA4C';
wwv_flow_api.g_varchar2_table(264) := 'C9F833098CC4D4C5D3F52B3B027826754A3A3105C0D9C41C8C97832DF7CAFB41C7D021E225475E18C4AA8CC3500ADD984C452D0C08F89985AA293ABE804A906C651AEB5F0C950A6CC3713AA604516F52983A09DC78329AAD35D6FF00A11DD9D89397A36D';
wwv_flow_api.g_varchar2_table(265) := 'D8DA33802CA2C2083E528D4F4AAABFF6998DC68C4D868B00763DE0E443139334E47E307065F2ED04304B4A6C5E99A67F2B13933A362D2A51FE9DCD997E32AD2D4A518020CC56A159D08F89B5A2D32DB9D877335AA7C3F984930F32D6B41F296DCCB79839';
wwv_flow_api.g_varchar2_table(266) := '1F99FF00289C997C8CEC72ED92C3389C9329B69753E0C71A6A38987472C1C31500F330FD5EAD5AAB499432F67EF3A83521896623DF6E3B477673B98C6C26A83789D3F175A8BD74A2C69A8F94025829B9E489C98BC89DE2F265E31B4ED3B65DA2537A9515';
wwv_flow_api.g_varchar2_table(267) := '1012C4CC2748A54698F5103B91BDE63A9A53C55444E01C968B72C428FBC1FD3A9EED1E97A989237B77953D34A7A49B0B710E2091A52CAA2622A2D514AA0E4AD88FB8978614F105D45FF4274C55A5D228EA5B0F47511F9DE003DCFD81DA3312D73928D84B';
wwv_flow_api.g_varchar2_table(268) := '897B5F279DB3A68EEC114124CE99D353089ADC03548FE3ED0B0373E26201AD89ACC2DA4B9DFB5A6B441EC173FDD0B331B926F29AEA751E4C764A40B7732A3B3B16392F12FBE4372008ABEA57A74C1DB5013485AA94C5AC29DA63681A55AA521C2BB0FF00';
wwv_flow_api.g_varchar2_table(269) := '31C203B927F1356FB00201730A0B4ED934D425EF00B9987AC30A6E1AEF6EDDA275AC501A45353B726F2B754C4D404338DC6EAB1DD9BF1E213C65855F7173C012B55F51C9ED98309DE2989CB378130E195D2ADEC03037FC4F5D4D4F56FEDF4B54C4567AD5';
wwv_flow_api.g_varchar2_table(270) := 'EA543CB31308DE30EF14EF3B43DF2E722202440C63331E49821CA9A33300B2B3AA20A49FB307D163C9979406BD6BE40955AEF61F11C087136E91AEFBFA569797DE13073018721999DE113BE5470EF577E040B4A8A7207DE138504FC9A17C3DF643FCC2F4';
wwv_flow_api.g_varchar2_table(271) := '7B523FCCD6BDA9AC2CDDADFC42C4F33B4C31F7DBC8879952BDBA3535F2F63FA32F98E44ED37CAD913B0CBB65470AEE416D9614C350DCEE63E318EC80010B1637277FA07D144D9D4CAE34D4610BBE809A8E906E043F46A3C657CCCED951551D84ABB5268D';
wwv_flow_api.g_varchar2_table(272) := 'F2FF0043CC3C45E2627FDCFD43F499DB2FFFD9';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784240764989151263)
,p_file_name=>'img/diversity.jpg'
,p_mime_type=>'image/jpeg'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/img_construction_and_engineering_jpg
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := 'FFD8FFE000104A46494600010100000100010000FFDB008400060606060706070808070A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA70106060606070607080807';
wwv_flow_api.g_varchar2_table(2) := '0A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA7FFC200110801A401A403012200021101031101FFC4001C0000010501010100000000000000000000010002030405';
wwv_flow_api.g_varchar2_table(3) := '060708FFDA0008010100000000EEC94935AE6C4E2907221ED2926872692E28109C810D734825A4A4904026291AD72731CE6948B0A63CB902924506B4A4882C2F493020438A6A0E7001E122D6C6A412945249209AE6B8265529D24C9A926A4E4035EE6A73';
wwv_flow_api.g_varchar2_table(4) := '1EE8D3EB973948905129980B5E9452BF3DD24AE4C7A0D6B629A42D2C92288CE4C1328DC5A5D2010C6F992443931EA8A7A2527B589ACB6D735D04CF2D7A6A739A0264AE6900A620D12389551E426A2E7B98D6B899637090808C4E292899610635813CCAC7';
wwv_flow_api.g_varchar2_table(5) := '17353AAA40B926CE5B1190B924E40B530129C2363E4747186B93641296B9C69A28B0DBEF6CF2F9DA106502935CA595A2BB1AF8A38CBA695B5D273DAA70E0C91A6A14D0E00ED74FB58BCA64BA70A17DC6B119C3A1AC227CE5C995CCCE41F5EA2644CADB45';
wwv_flow_api.g_varchar2_table(6) := '06A4115EB1833ED0E539AB2D920209610CB0FA71BA6798A3639EF4DC8E10344A3D3000120E7B3B8C9C0B57F22574AF6A41F0BDCD4A935CF0E49A1CE8A7C4E4F4B26FE76B75A9D34644C00967CE99ED782935B2020353237BE17CC610E2753330392D2CAD';
wwv_flow_api.g_varchar2_table(7) := '2CCD6EB92481289914B1BE4682D73908DAC6B34067BA44D3222F72D3CBC0E56F665DA3A3D824924E0887C913E47B940482CCFCBE8BACEEEC739C1D488BA76C4F749A79391C66864CD06AF5C9248A09229169453A4070FCC2AFB6FA46869CB4F9BE4F3A40';
wwv_flow_api.g_varchar2_table(8) := '4A5A57F07178CD2CABF9FAFD8249248244A4F6B985349CAF2A801F42EB8BA3411092EAB723AFE6BC1D91A78FA9DAA224E67A6736348908B9AE612DE439F4D43D2ACC9192C091D3E838EDE665F93CB16B51D4EC91919C077A948935AE0522513C94142EBF';
wwv_flow_api.g_varchar2_table(9) := '3FB0D34180912EE75B5B32D9D8F37E13276B274FAB638E657BF65D52DA6D835EC39A1E42E43AEE6B7E4E2B775C005C5D3FA263D809D4FA0F0DE6743335BB3E63328BA58237CF993DDAD1667AB5B29169E66CE2EBBB1BA1D76A4A663E4F41F33D8A724DCD';
wwv_flow_api.g_varchar2_table(10) := 'FA5F93F13A995A9E83E69C669F725DBED620E0B9FE96EB9EE90AE6AAD2D3A7477F6E30D49277A570BAB5EB5FA9D579779FE9E6E977BCC60E933646F22D2A46F35D14A100973DB993D051C0B3B6924923E8BC9E9C69DCD7A079879BB9DB9DBB53B98B753A';
wwv_flow_api.g_varchar2_table(11) := '449A12381BE12452C1868DF666EFEC1492457A3F9374346E59CCF44F1DE376F1EFF7808E65F36E94920307665201A15726C67EBD7CBB97F7DC82457A9F276284B373DEA1E47E71A991B3DC358396D15B88A4D6AE5AFECA4971F8C7D1B1F7EAF2B8C7D1C8';
wwv_flow_api.g_varchar2_table(12) := '45E1FE8DC2EE52C9DDC7ECFCC385D5C6D7F4CC86AE76EC3B68A052F3EDBA91EB6E9E3F196BD3B833E177A4859DA613BD078B90964BA7C5703A19DA9DAE473B6AAE8E96B2523DCF3C9F2D7A593475F98A3D74195B95B3B538BF4831607412A7FA579E99A0';
wwv_flow_api.g_varchar2_table(13) := '91BBFC479DBE1D8D3E7C2CAB7D1756FB9D924CA106B925BE55C96BF715F1F72BE6E9F9C6B74CDC6E8E5527A1E35DCBB566AF49E2FC35DCFD2AC91CC99BA7B5BD6843CD63374F56B61B48B16D4323A393350E8A0EB4A77A579EDDC7D4B7C9FA778CF29A79';
wwv_flow_api.g_varchar2_table(14) := '9A9035A71D5FB8D57DF9E12F61B9078D3536CF4D261EAC995A1C9BC6AD7D0D9D16FA0711A7972E8E3F71E41C85DA1A8189628B9A4224504BD4B3AE67458BB973A0C8E5FA09726E79DB9C20994BA1EE7CC5FA16467F71E45C36BE369C6D6BB2A0BF758838';
wwv_flow_api.g_varchar2_table(15) := '80EF5FD28B5D99357A8E7327CC36AB35D8F0BE70885F44F0F6703A36725EB1E4FC3E9E7EBE7BD2C396C68312735A17ADF667957751439FDA5E51D654BB85C69606354B27D15C9CF4AD5AC6EE7C778ED6CBD4A0E6ACD4349C41DFB5CE45EA5AC39E1D1338';
wwv_flow_api.g_varchar2_table(16) := 'BED3561E57ABB54B87ECF8AE119087CFF497277F1F4E0CBED7C878BBF9BA75935D94ACDB48AF58EAFC1AA7A8779857686C73DD3F29D6F2DD472DD672BD4F298DE5EF98397D11C2DEC8D3B7CFFA6F8C70ED3BB9C8B33645A08FA86AE46E790D2F5DCAD5DB';
wwv_flow_api.g_varchar2_table(17) := '770FB7A10F17D9585C7F7F76BF97F108CB23BE89F1D87B5B3367F69E0B89AF9B7AB3623C3326EE12F4ED5CDD6F21ADEB58FD66855CCAFD76767DFD7AFCDD5DF9BCAF984E8E2B3EEBE6FB387DA1E2BD5FC330DAE1798DABE7EACFA2A3EB5A389ADE4B4FD4';
wwv_flow_api.g_varchar2_table(18) := '7B9F2FEE68751532EAF53836F23A8CB8F2E87980ACD9E7DFF60E5F99ED3A70EF03C149B79B147283295ED9B585B5E0957D635B81A7E8D2C5C7ED6C3391DBD71C6EE6579ED7B88E5FB2753C85FE63D0B525F0AC3720A26BDCD9113B772BDAE5D9E99D7797';
wwv_flow_api.g_varchar2_table(19) := 'D7EBFBBCC14F56BD6A1D5633B2E9794C732A597EADABCE5B665770EF3FA70CF1B212F784896A832756C7B363F2117A4C2FE9C7256FA6A5CC741B03CBF87557384AB6332C0655B3A52B6A54B49149AF0E62A5CA749A625D859B54249148A6D08618EF3D8D';
wwv_flow_api.g_varchar2_table(20) := 'D3CA9DCD4ABB1CFBF3A1BF0D67B550022CCB1A05465E1029241292E4B44851B24CB0885231D2C9303D5F614EB5D8FCC83551BE9248A0410825A1EEB85A3579CC2E9F567A1C7757A14F9C6F41D03396E3F08BBA2CFB220D3E5421585ACC104F01B113A090';
wwv_flow_api.g_varchar2_table(21) := 'C32BBD0BB0A961F97CC75D72CD7E7BADD7A9C656DFD6662E2F1CF1D4F2801EA394401656B6728C166AE9652BB0588C6F6C5365E963D3C957ABCF03648A6CE8ECD6A09491849EC09A8A0189E4A998F3235EC2CAA9F0A86C343A57D298341369CD48A09061';
wwv_flow_api.g_varchar2_table(22) := '0104E053558607CAC4E28C618E13A6C52B584B629592B9A1A1CD493084012824926BA49278264C63909180BE32224F1119116A41109A8A0924824120517CAC72739EC627B2233354B13404922904824924904924884A4959227BD22D21A5A9D032C1A6E4';
wwv_flow_api.g_varchar2_table(23) := '1A9249221245049248971692E73A363E52E4639192210277FFC4001A010101000301010000000000000000000000010203040506FFDA0008010210000000DA280080A8A0002C85952AA148009409908B08A0520990C0C8452A54446618A64952AC5468C0';
wwv_flow_api.g_varchar2_table(24) := 'EB204A054134E075804A6FE7D5967659356B3AD832A07227564269308EAC6D90CC9E169C7DFDE8D52303A70B44CC781A31FA0E9268123A64CA914F1756BF6BA4738C537ECC6D22BC4E7CF5E3F4B4D10C4766BB714DAC3E632935FD573755E78B8A7A2D77';
wwv_flow_api.g_varchar2_table(25) := '0E4B9EABBFE7B6E0D5F57E3FA79738C4EF619650F23A3ABE77A7465A3EAB97A27342477B5E7478D8AB8B3D1F584E2189DF75E75E7F7F8F25913ABD338A189DED3B33F2E7A7E56BB2CB377AA708C4F41CFB33F1EFADE4E9CECB2EDF5538C6EADC461AF7F9';
wwv_flow_api.g_varchar2_table(26) := '1A36036FAD8E38C36994C2DCB93A5C3DB98638965865968E09DDD31006961B2658E19DD9916584217082C5659290944B00295144004502CA0010007FFFC4001B01010002030101000000000000000000000001020304050607FFDA0008010310000000E7';
wwv_flow_api.g_varchar2_table(27) := '8404C4C1208255900044C9130109222498904C0081284A480204A684E7B460242B13304D966113966D840552896F67392124C044C04DB733A392024460DCDCC7AD498B5B6B60E42F110074E679B582DBF35CC72AD6A24AC4BD7ED5BC76A25BF90B9CDD8C';
wwv_flow_api.g_varchar2_table(28) := '71598BE084FAFDCC9E37449E8CA2D2E5DE6944DAA47A9DAC9E5B449E94932E653363A978ABD56ED32CF87AA7A52591CFD2DCAD6D33A14DCF7F5B4E6F9ED267A56858F2B5DA9D8DFC5AF9EBA9EFA9919FE65B779E94C2D2F291BBAD8EF47AAD1E6FBDD7DB';
wwv_flow_api.g_varchar2_table(29) := 'A6C7CC72CE7EDCA2D2F28DCD5A0F5594BF6F1EC7CC10F5124CBC9B6F06376791EA320BC5B9BC03D3D8997939EA69EB77EDC1F4F900D5F389F4F258F297E9E96AFA78F37EA34FA00D6F3733E988E55679C8336C69FA4E6F5AE4B5BCDE4D8BE587397C36CB';
wwv_flow_api.g_varchar2_table(30) := '15C7D7E653630544E4CD68A5AB366A46EF7E789CDBD724CC4C4BA93930CE1D8BE28E76B5E8B556AE756F08D8B258F36330EB0009241130400004A500400009098943FFC40045100001030104050807050704020300000001000203110412213110132041';
wwv_flow_api.g_varchar2_table(31) := '511422323352617181233042537291A134406282D105437392B1C1F04450A2E154632460F1FFDA0008010100013F02F55454D8C76A9EA71FF66AFAFC7D7F97A9AFA8AA3B75F5982AE83F79A69A68A6CD3D57969F3F5B555D9C563A7CB66A1576F05555D1';
wwv_flow_api.g_varchar2_table(32) := '5D23457628B1D34D15D8A2A7DF28A9B35D80B1D274D3D40F555555558FDD285534943D463EBB158E8A7DD2A8E8F2FBAE3B75D8A77E8A7AC8CB43C5E150A8C7D2EBBE49EC691D0AA759C7B2EF22B512F05A8E25131B72153EA6955CD1DEAA3B2A9C0FDCAA';
wwv_flow_api.g_varchar2_table(33) := '163F71C936D12377D7C532D11BB0228AEF02A41514356F82740F18E63BB4D1D4AD0AAEC53B5F244D7C3609073F9AA378FD151BDAFA2A702A8A9EAABB24868A95AE8FB4B5B1F682D747DB5AF8F8AE52CEF5CA470F591BAF31A5493B992114A84C9E226B91';
wwv_flow_api.g_varchar2_table(34) := '45B1C8320508A366200534D7B9ADC95108CAB9C4AA81D1F559E6AEF82A7AE9DDE8CE9AFADA68B29CDAAD1D6BB402E6E453A57B8509D353C554F12AF155EE0AF7E10AADE0AA381F9AAB7B3F5551C173782AFE10ABF842BC7B215F76C62ABB543A30E1A27E';
wwv_flow_api.g_varchar2_table(35) := 'AFCD31A0E6B56D4073A8B56DEF4EC0AB8DDAF354D90483509EEBEE2EFB957D4D745179E89A81FE41555A3A1E69AD0E5AAEF433A2D577A76055C6F7FABAAAFDC6BA1B13DF9353A37B7369D35D9AECCF4D668B40E679A6B6AB55DEA98D15C3C53850AB878F';
wwv_flow_api.g_varchar2_table(36) := 'AEA1D34F54F91B18AB94568126191D10D9EF62EC06992CCC765814F8CB0D0AA0D186D8CC29F19344FD594DAEE2AEBFB4AB8ABEEE289AAA3BB7F76A955D334CD8C77F04F7979A9D161B5C245241CFE3C57298B8942688FB61073776837694722DB271FAA7';
wwv_flow_api.g_varchar2_table(37) := 'EAEBCC2745555574D531AF2460A60FBF92AA9CFA32995392F49C57B545AB28E05524E3F79965118EFE09CE2E353B104F7B9AECF4D4F1F551C54C4E7A5CC63EBB94F846F40D325AC77726D6F23ADE28DEAE2AF4BC06D12395B3B987453BD53EE16868BC3C';
wwv_flow_api.g_varchar2_table(38) := '15C1C15C6F0571AAE355C099D06F87AB8D84B861829AF318EC68992485ED178E6AD4F958F680E2305677175EBC4956D69B84D3720D2725AB7F042B555911CFBD7A4E1B5EC89B8CBF4CB62AB05454F5742A706F0F04C82478A8575D7AEEFAA9227474AA64';
wwv_flow_api.g_varchar2_table(39) := '2F9054238121427D18F551C37B9C7254C06213A3079A57278C1C2A9F109285C9B0B5996F423A8CD5A6C972AE8C7885CFECA1D2553D829D9E4AF3BB3A2ADED0579BB885E6A57523750E390F35246350E60DCDC3C95F6DCBC48A5102D70A8228B04648C100';
wwv_flow_api.g_varchar2_table(40) := 'B854AC38AAB78A0F6900B5C28AAD5561DE9CE6B4B7BCD06D5555555A3A43C159BA96AFF57F995ABAAF3566EA878953F5CFF150F436A8A8A8A898CC2816BA31BD39ED1187EE299331C6EB77A7CC2325A53648CB4BAA7042D3176912C214B79923DA0615C1';
wwv_flow_api.g_varchar2_table(41) := '5715AC3D94E754AD67E13A26D4D7265EEFDC9D0D92ED03995E2AB64BBD5B2F569DDE28C364BA29232A37F14C36239B180851B2CC4973AE01B9B5FEAA48ECCD37D8633C595FE89C6C57016B1A49C8264165BBCE73093DE982CCCAB640D3C1C37A645677BA';
wwv_flow_api.g_varchar2_table(42) := 'F1BAD6EE6D73524765142037BC556AECCF346B5A076ABFD148CB346F61E696E4467E6A373039F280D143CD6A6BD8EC9C0FA8B40C5AA39C3181B756B3D2DFA6FAA96712329439A8A70C65DBA53DD79E4D3350F43CF631D355540E2154B53A392A79A734E6';
wwv_flow_api.g_varchar2_table(43) := 'BCC0D6869AA81B2B6469BAA764AE90BAE951B1FAA930355AB93B2745AC96CE79BB82079D55ACEE29C6A55FFC2747ED06B45C200A93894CA6AA6C370FEAAC4019B10322A66304B67E68E914C6C72BEF5D1741C30566630C22AD69C4EEEF5AA87DDB7E4B53';
wwv_flow_api.g_varchar2_table(44) := '0FBB6FC96AA1F76DF92D543EEDBF25A987DDB7E4B530FBB6FC96A61F76DF92D445EE9BF25698E36C550C68E70DC8318DE8B40D145454D8B47B2A287595C688B0892E77A960D5B6B7AAA28B595C6944F6DC716A80F30F8AAAAED8CD5E24A36A757A213E52';
wwv_flow_api.g_varchar2_table(45) := 'C635C37A8A6323E8699296795AE2DAE0A291C63713B972A1D8401392B6BE93E3C0219D56B3B91C4A0FC323A2D50BA50D029814DB13831E0BC73A8A0B2EA9F7AFD7056D0E222A677959DED2D0D0285B9B559BAAFCCEFEBB75D16BEA1DE23455555555574D';
wwv_flow_api.g_varchar2_table(46) := 'A326AB2F55E6A4FB537C95A3A972B27567C55ABADF250743CFD51353823676F693A2BED68AE4A2B316BAA0A96CF575E2EA26C77637B5AECD727910AAB63C097CB451515E1B368E959FF88A48AF1BCD375FC5594D611E27D4DA7A97797F5F5368C878A8AD';
wwv_flow_api.g_varchar2_table(47) := '1AB6D2EA74B596FD13ED25EC2DBAA2B46ADB4BAA59358FAD141D0F3F557B24733E29FF00668FC5404EB5AAD58C83C159BF798EE5AF947B48772B7F5FF94219857DA9C71C15E6ECDA3383F889CE3282198377BB8F82B37D9E3F0F53692D11E27DA6A6B9AE';
wwv_flow_api.g_varchar2_table(48) := '008C8ED3A46B4E2B5ECEF52C81E1410892A4E48C7E96E77A9ACE18DBC0A8211256B905236E3CB5472DC14A2E503B27D4B1DB93AD1057AAFA27B9A23692CC0A88C6E7F3598A7CF1579D1568AFC6197DADA04DD43881CE419C1CADAD1AFC4FB210A5E57589';
wwv_flow_api.g_varchar2_table(49) := 'D81C15D6ABA781D8B50A88BF8815E375ED3D20D3E6ACFD445F0FA9B6343A1C5D4A62ACEDBB0B0776D4FD3F2D365EABCD7FACF3569EA4F92B27567C55A3AE77AA19AC11B3BFB948C73A3635BB9431C8C92A78274325E269BD6AA43670C037A6D9E66B812D';
wwv_flow_api.g_varchar2_table(50) := 'DFA2D7183354F0080ABA8B54D4680D16ADA9D2F0D8B4E51FF11AA665E61E201A156635823F0F5369BA2D11193A145CA59521B8D1199EB5B2714D9C6FD33F4FCB4B267B050515F75FBDBD3A691C284A64CF60A04E25C493B4D389D81984EC8DDAE4B5969E';
wwv_flow_api.g_varchar2_table(51) := '07E48496A1BBE88CD693BBE8B5D69A747E8B5B69ECFD16BAD7C3E8A132B89BFF00D15B23ACE79DB820DC6955AAEF45B42B523B5A1F286F8AD63FB484CFDF8A9E6696B3E309C1D231CE75436868DFD541D4C5F08D8A1E055D7702AEBF81571FC0AB8EECA9';
wwv_flow_api.g_varchar2_table(52) := '2A5FD0ADDEEDE50639A6974D3C16AE4EC3BE4B552FBB77C96A26F76E4C8ED0DFDD957B1A1143C0A9FA7E4982F3DA38953C2C6C7568C959E2639A4B86F4631AFB9BAAA78636B2AD0ACF131E09704631AFB9BAAAD10B1ACAB46FD8268340CB48CC27D03496';
wwv_flow_api.g_varchar2_table(53) := 'E6B5D2F0FA2D74DC3E8B944DFE05AF97FC0B94CBFE05CA66EEF92B3CA5E5D7D5B2BAF3476E0AA55E7F146A55D77694936E6EC4B937E20848E01CDDF4504C356C0782041CB433A6D551C55471551C55E6F109F346D6B8DE1805096B631578A9C4E3BCABC3';
wwv_flow_api.g_varchar2_table(54) := 'B415471551C74547156DA6B7F2E8B3F5CC568EA5CACBD579AFF58AD3D4B9597AAF35FEB3FCE0AD5D579E86CAE1DE9B235C9E50CDC865A4663419D81C4126AB5E0B1CEBC6810B447519A9276B5C993DFAD09C10B4C60E755AC1D956B0ED71A3B82A73A8B5';
wwv_flow_api.g_varchar2_table(55) := '5DE9C2855D7F1D993D8F8948016951F56D4091926CE77A6BDAEC8E92E6B734F989CB4B617B88006245477AE473F647CD3ECD2B1A5CE186CB4969A828CAF70A17609B2BDA28D72BEEBD7AB8A74AF70A129B2BDA28D2B58EBD7B7A74AF70A13B3ED9F0D9A9';
wwv_flow_api.g_varchar2_table(56) := '18554B148E91C404D6BC40F6D33DC9B0C951CD5346F73EAD6EE50C5286BF9BB96AE4EC142F103C15B1CE13BBC90AD55D93B49D5AE2BD22A2A6997D8F8916B9E0D701C146398DF0D8123C6F46590ECB226C9668C1E181DE0A89EEA98E4E98FF0090E2BAD9';
wwv_flow_api.g_varchar2_table(57) := 'FF000C7F57FF00D239EC31B79ED1DEAD10B1A039A141031CCAB96AFD35CFC4AD3135A016A8206B99572117A7B9B95A216B002DD86E59ABC2F3BC909E9E0848C3BF4F0524AF12380761557DDA8BD5C54523CC8D05C695569244B838D28ACEF7DC931382E5';
wwv_flow_api.g_varchar2_table(58) := '327726B8D01EE56C6B8DA1DE4856BDEAB2A35AE2BD26CCD8DC1F891BCD06B88519171BE1A2BB15D88659F54C02CF514CEF056892D3E8CEA5A1F7B99CEA9566369D536E88B0CEB5AD77D51B14BC5AB904BDA6A9607444026B854D370E2572093B6D4CB13D';
wwv_flow_api.g_varchar2_table(59) := 'AF06F8C14D017B2E82A0C016E774D2F6EAAFF57F995ABAAF3566EA87894DFB63BCD5AFAB1E3B237E90E70C8A133D6E4F367A9BCD3540C661FC354392DE6915536A2F73815198CDE6B2A2B9AE4CDDD226101A05D56B2ED7BA8DE087495E77613B3C95E7F6';
wwv_flow_api.g_varchar2_table(60) := '7664CE3F89175EAD321BD474B8DF0F54D9032CF16152451A3895145779EF3579CCFF0060A4696BB5B18C7DA6F687EA98F6BDA1CDC414F91AC6173B20A161A39CF1CF7E7FA28FD13F5272FDDFE9E5A25739CED530D0FB4EEC8FD55A18F0D8DB0E000DCAAE';
wwv_flow_api.g_varchar2_table(61) := 'BDBEB552B670DE79C147AE38309404A64C2B794BAD183C9D15F1579AB0586CE0A68DC64751A68831DA870A635418EBC39A735696389690D56763838D4530D0C346B69C15ADD219DF87058DE579FD94E38E4AF3BB1B336377C5070BA5B9103251F41BE1B3';
wwv_flow_api.g_varchar2_table(62) := '5D9B2C7CD123B3A51BDC34BBD038BC7567A6381ED7EABAE9BF0467E6EFFAD12462465D38703C0F15CA4DCBA47A6ADDBBDFC7C145188DB4AD49C5C7894FDC8FDAFF003AB4F525593A0EF143ED0FF842B666CD34575AAE8E2A87B4B9C81D000DEA49DCD7B8';
wwv_flow_api.g_varchar2_table(63) := '0A2129D517619A1693D952CC58EA0014335E0FAB4608DA7F004C22992B539DAF7F3503CEAABE7B2538D4ABE7B3B3252B1FC4A5BB74D5455B82BB3828ECEF91B56D1723986E088A1A688B956A9977554A6FAA0CB59FDE47E4D5ABB47FE47FC0273257C9AA';
wwv_flow_api.g_varchar2_table(64) := '6DA243DBCA807EAA0B3017A2BF20B8773A981C97248B7DF3F98AE4B001BF0FC450B361CA05FF0086B8DC4D858E682D964A1DF79363A6F73BC5186006F9681BEA9CD9241ADBBCCDD1F6871F151B21B80B060715AA656B4C54B14374BA468A342100652591';
wwv_flow_api.g_varchar2_table(65) := '9CC774876387FDAE4B07BB0AD913181975B4C7464ABDCB9C7B95DD178914BA9D67BEFADECD7270222CBF8A6D95F7BA414F677B8D6A1470DC0EA9CC2E48EA74C26B5D8515A9CEE50FE6ADF55ACEE44D4A0E34E8E9CB44BEC7C4A80824F051F41BE1B562EA';
wwv_flow_api.g_varchar2_table(66) := '7F31551C549D37FC47440F746D8EF9E63B23C0F03A26908A319D3765DDDEA38C46DA0F33C54C082256E6DCC716A6B838020E054BE95E21DD9C9E1C3CF47D9DF5FDD38FF2BBF43A0FFF0021F4FDDB4E3F88FE8347D9DDFF00A9C7F949FEDA319E4FFD6C3F';
wwv_flow_api.g_varchar2_table(67) := 'CCE1FD868A3ACFD1A98BB3BDBE1DCADA43A3888350557154A6C550F1A29657B6470BF82648E303DD7B1DC9B3497873CE6A791E1F838A85EF7324ABB25CA25E28388A62AD327A77EC6B06CC9EC7C49EDCC8511AB1BE1B10D9E1744C25B890B92C1D850C11';
wwv_flow_api.g_varchar2_table(68) := '383AACF6C85C9A0F7613E81EF1DFA23740606B1EE6F47104A6DADB1B0B5CF0E734D1B8F4B87FDA85D0B2A5D330BDDD235FF305AF83DEB3E6B5F0FBD67CD3ED0CB39371CD2D7F4457A2EFD147259E26D35EC27371AE6572AB3FBE67CD3AD365228646E2B9';
wwv_flow_api.g_varchar2_table(69) := '4B5BE804E2EFBCDE070F14CB4591AD01B20A00B9559BDE84EB4598820C83242D007A064CD35E8C95C9BFAA8F541A1AC2DA0EF579BC42D645DB6FCD5A8455F46F14271683BF8AA7058F05782041D35AD15B75724BAA069BDE7FB2B23B55134495D5C805D3';
wwv_flow_api.g_varchar2_table(70) := 'C0A68B3970A56AA430DF37EF57B9441843EED7BD6AA0EDFD5736EE0AD7F6893C5034216B1A9C412AFB7869C5134692B5B27696B64ED14C7BAF8C77EC43CA754DBA594A60A96BED46A11373E8F68E79DCAEDA7DE33E49F5BEEAE75D0C6C0CB3B5EE637A35';
wwv_flow_api.g_varchar2_table(71) := '268B931A6BB562FF00BBFC3D9F14D6D9DED0F0C6538D16AE3EC37E4A410B5A5EF6B70EE51420DE91EC179FBB80E0980405B1902E13CC3FD8AA0E0A57DC6D695393471250B30D49693CE3897FE2E2A190BC10EC1EDC1C343E40C639C720136CED74244AD1';
wwv_flow_api.g_varchar2_table(72) := '79F8BBBBFF00C4C6465E592C6CD60183A9D21C50820F74CF92D5C231B8DF929F9C04A051A4D183BB8EC502073AE892610C4E79DC11825F492118B855431364FD97136EE398F9AB1BC996EB87398EC55A1A5D255ADC28A20E6B24A8D0C02E0C772B57DA24';
wwv_flow_api.g_varchar2_table(73) := 'F155DB93A0EF0D2CE9B7C76219A11130178C972883B61433C2D0FABBDB2572A83B6A4A5F7538E8818E91B197F45BD11C4F13A252DBEFB99138F0AF151481D1D49CB34C0677090F4074071FC47FB687B1B230B5D9150BDD531BFA6DDFDA1C547E96432FB2';
wwv_flow_api.g_varchar2_table(74) := 'DC19FDCE896375448CE98FA8E0A39048DA8F0238147D3494FDDB1D8FE270FD344B16B1B9D1C316BB8151497EA1C28F6F4827FA7718C7401E79E3F87F556EEAD9F169BCB9C7B9014D16D3AF12DC7F321A79952C7E824C7D83FD17ECF005921AF04D61BD3C';
wwv_flow_api.g_varchar2_table(75) := 'B18AB9933F0ED772B3DAE29EB46114A5414295E0B7F15DF77056AFB44BF12A1542B158E8A20304EF0C15C67642BACEC8575BC362CFD4C7E1A20EAFF33BFAE87F4DDE274412BF52CBB1134C330B5937B8FF00904F23736EF9D50237E237ABD6AC7D1B3BB9';
wwv_flow_api.g_varchar2_table(76) := 'CAB69ECC7F32AB6AF771FF00329F944CEB823687346243B71DDE6A39E52D21B66E8E14BC305AE7EFB3BFE856BDDFF8F2FC829659B5A7530BC3CB79D5A65C7C54323C42CD5D9CDDDDCE0B5B3FFE3FFC82BF69F70DFE7531B53A4686C6D125D38877B2A09D';
wwv_flow_api.g_varchar2_table(77) := 'DAB65CB29BBDC42B5CD7D806A9EDC77844D02BBC7624752806655A2211D86515F673E2A42046FDFCD2BF66D39233CD593A569FE3B9482516C99D0D2F06B0DDED0566B509995679839855EE4471182B4F5F27C5B6D05531DB6DA6668003B05CB27E23E49B';
wwv_flow_api.g_varchar2_table(78) := '6A9582828B96CDF87E489A927443E8446EF61E05EEE771F352B5CE6D01A295859781E09983478515966CA27FE43C7BBC744B26ADB80AB8E0D1C4A863D5B33AB89AB8F12A561075AC1CE198ED0E098E6BDA1CDC8A9246C6DA915DC0712A1616D5CFE9BBA5';
wwv_flow_api.g_varchar2_table(79) := 'FA2EA241EEDE7F95DFF7A2596E5001579E8B54515C19D5C7173B894FF42F327B0EE9F77E2FD55BBAA6FC5A00A6FD2E78069BD5DA3D849C4956AB707C0E6DD3B93EDACBAFA075685582D0C8ECC1AE0732ACF696375F81C652536D439548FBA716342B44C3';
wwv_flow_api.g_varchar2_table(80) := '5B1491C747DEC7BD37F6844E1D51AF8AE5ACEC1521BF239DC4ABBA28A9DFA3C50C7D539D4692B5C6ED6E26BAF341A6888C66CEC6B8B7A3885AF31B5D1D6F11D17772764EF04DE837C13238B5575C4639E284C623764755BECBFF00550F3DDAE7FE41C07E';
wwv_flow_api.g_varchar2_table(81) := 'A555BC42A8E2139C2CEF2FFDDBBA5DC78F9A89B7DDAD7F4BD96F647EBA248DB231CD3914D9E5EAA80CA33ECD3B4A28432A49BCE39B8AC38AA056A8DD13032B58EBCDE23B961C560AF331C55F24D183CD345D93F2A79E747E2A4C87C41139A83AB0A3F6FE';
wwv_flow_api.g_varchar2_table(82) := '243AD77C21499C7F1297D8A6755AC2D1CE6A041D2F7B5A10D6115E68F5B2741DE085DD4BB9F8D7250F56DD2023D13E099D06F827815F595EF4656F8ABEF393134C8E19809918ABAB8E28758EF842AFA5FCAA4E947F1297D9F8822702A03E8D467A7F1204';
wwv_flow_api.g_varchar2_table(83) := 'EB5DF084F38C7F1279E747E2A63E8CA91A2E38D13AAD6121C5497AE1E79C93DA044EF04321B16784CB281425B5E7230BF58580635C93E3923E98A27432B1B79CC202114A5B7830DDE2AE73039A6B873BBB60E20A63E4642F8356DE76F5134B5801D83914';
wwv_flow_api.g_varchar2_table(84) := '32F5A012842FECAD4C9C14704A180109B04A0BB0DEB512DF269B96A25D656EEE4F865AB39BBD490C86EF37DA4E8DF74F34E4A26B9AC151451FB7F121D6BBE10A4CE3F893FA51F8A97AB2A5EADDE0A5EA8F8292BAB7782901D5BB0DC9BD11E1B105A3531C';
wwv_flow_api.g_varchar2_table(85) := '94E91A5140C16688CF2F48E4159E2D6B8DA26E8A37ADB68A7B015A643239B66872181568B9678352DC5CEE91D93D637C0FDCA38DD23A8141666443BD5C0F9DC3BCA6D9DA5CF153828A06BEF549C0D13F9A5C3820F355132FBC35180095ACAE69D6701EC1';
wwv_flow_api.g_varchar2_table(86) := '7B35345ABA639A9BA23C5471192B8AE46EFC29F667B454D13B01926125451191D45C8CF6D723776C2A50E6991B71F1D8B2343AD11D42926925E9BAB44FB44AF60613CDE09968963616B4D028A67C552DA7C95A4E319A0ABA304ECD39C113423868F4DF85';
wwv_flow_api.g_varchar2_table(87) := '7A6FC2BD2DEA542A4BDA1F24DD611D3FA276B4637BE8A92F6C7C91D681D21F25E97B6DF921AC3EDFD1112D3A7F440388A894A21E29E93045B2D307A6DE343ACFA2B33EED686856BA5ED940BC1AD71425901347669AF91B5A14FAF38E86B9CD350B58F2E0';
wwv_flow_api.g_varchar2_table(88) := 'EAE216B9F81AE49D239F4AA9B21E2A294C64D172B776427DA1EF696D0297726669AF734D42E533715CA66E3F455A951B6B7BE2D8B17DA59E7B36AFDC7F086D1154DAE4776973A33ED042565312AFB03AA1DE2B5B1F14D91830BDE0AF8A5507DD245D753C';
wwv_flow_api.g_varchar2_table(89) := '139F8D435D55AC3D87217C1244668AA48EACA6978C0B0AA9BD50C777A0682B9216C65315CBD97A9770E3543F68328799F542DAC232A79AE57165FDD6B63E2B940E050B734D798705CB9976B70A6DA9845689F30753C53AD71B78AE5D1D01A3972D8AF017';
wwv_flow_api.g_varchar2_table(90) := '4A74D11A54A12C6D2B95C7FE15CBD98F30AE5ECA56E7D572D626DADA2B88CF60120D41A6CD4FAAA0E0A8382A6C536B0D14440E0A8DEC85723EC85723EC85AB67642D53382D446B551D3A216A99D95AA8FB2B551F656A99D95AB8FB216AE3EC85AB67642D';
wwv_flow_api.g_varchar2_table(91) := '5B3B216AD9D90AEB7B215D67642B8CECFDE6AB0D145E7A31D1E7A305454442A1D38A3B050FF63A6D65A3155D8F2D387FB554ED0AADFB382A2A6C63FEC216F5E7FF00D1C2FFC4002910000300010303030403010100000000000001112110314151617120';
wwv_flow_api.g_varchar2_table(92) := '8191A1B1F0F130C1D1E140FFDA0008010100013F21F53D595A988BD05EA7BE99EDAA69349DCCAE04647E0570F6F45FE1CF6D2777A6FD49A4FE4C97478376CFE0E761C197B33E744BB6B8D63EBA760AFF002B2BEA27920BC19D73D0A46956B832582D05B6';
wwv_flow_api.g_varchar2_table(93) := 'AFB098DC3C0F728C5073A94DB920A7532354C0817646C16C6FFC5EFA3F710E5DF44BB8CABAE98D2317610836EA4EA4741EC2504BB8D56443DC6884496ECB8E4E3725DCB1C838415F4D5CEE647BF236AEC39C91185EA6169DCDBA8DBE0A17542BE9AD37D2';
wwv_flow_api.g_varchar2_table(94) := '6A9A3B024652C2AEFAA1F768F01BAF2469919B31BC10A869133C95C0A1702B781917628D0DD98592191E079F43A4154332250CE917429933D8467AFA724215992BA9446B8231192BA19323D86BA3DCABA9BB77A45A12EDAC1F813C1703647A45A5454233';
wwv_flow_api.g_varchar2_table(95) := '771FB982D2DB8D09F723BB90F633FC33B91B16C3548BB897EC5D430E691F6D10833CFF000B273A6C5F45D6138939B3050919297BE8AF2454DBD6B4E4B813441429C8AA12F5D7742F4D28DA3267A1EFA52A30516ABA3D568DBE8C4994825A253D9FAA6B46';
wwv_flow_api.g_varchar2_table(96) := 'C10AC49740ECDA37D46DBC4ECEE6F8664E0BAD161F6CC1A7BCF03CB6FA99D38F4A6AEDBB3CDF423F49B25F376787A52A78CE9CEE39DF58C57A934C9E7489F0448E833CC579867AE88C6722D89DCC94A5D77D536D538CDFA219A699E3AEE39E2D97688F9E';
wwv_flow_api.g_varchar2_table(97) := '0C96FB08A17786519EA34521D478171A26255B9AECDFFE0F65144D908CDD361E7E5EE632EE84B710FB6CCF2238138F442D5A1EE26B823A89F631D85747073884FF00F432A2B60FAC7EC767E03EB8F6D298FE07F38D67C93AA0B0243594EC5C3EE054D177';
wwv_flow_api.g_varchar2_table(98) := '247E4BEA798DAB31DDC174C97C9C17BF224BA7A303BA36FA173B18CF07D7FD36EEDE1914710BD0E1C610FC0999EA52AEC60479A146F461EB73A5F467D1C995BCE50BF12FB1199C727D988D5A1E189B123B04BD83F288FC088BFE851FF56C6DE2D10DBD3E';
wwv_flow_api.g_varchar2_table(99) := 'E5FDACEDFAFA4FD09C185E30464152F515D4CB322F346D959DC21BFF00C1843FD019B1DE621DB6A67E5EE2A7213D2DCA97052957532410626C45B94DB814991AC8C698A2A2D3EBA3F27BEBEE2B74C68E0A1745431563C68A76D7B119E50FB888645DE040';
wwv_flow_api.g_varchar2_table(100) := 'F89711BD24AA21F212CAEC2624EFAD4ACC9594789B98E473A89E8C624CACCEB4B828DB6568AAB99B3C5D74A4772A2899571487BA121B9DF48E8D4985115182FB075E668ABCC34EC5D9B3FC367A7DF4326742A8A547247823231E978785D47CD974575135';
wwv_flow_api.g_varchar2_table(101) := 'C8C9F13CB22512D91BA2EB8FA445BFE68634290506E7061F5D2A178394251BE88896C8FAE42B37831A1A5573A26357B98D7FE057E9ACEE69A53A81B60CAFAC4E109126D37F632FF41B47D81C595F0C6D3E0B3427714E9F0250D2EE8C11A9518D3277DC62';
wwv_flow_api.g_varchar2_table(102) := 'AF64789C7728A9EC1214AE0C9E136C60587F2E4CEB0F8D27A6BDBBC032BAB7AFB98CDEC7D484EE771F3FC5042FD854D65E7830671E0C581ACA1E0A7B869495B21C07A72F5224B9C0D239F9CDFF00860E5815FC38D2EB083974B529DA3B476C5ACBC393DC';
wwv_flow_api.g_varchar2_table(103) := '8BAEB8F53F790794CD8D875B3223B204F91F6D05089348BF26C2BA145C56518367F06F363C7E8C25DFEC5AC4DAEEDF7FA35DB6865DB2792DA8D971FC31F423D491CA13BB17B413B8CF0B4F943C2145D446E16514F70BE0AFD69524EA30BA94FE23A09EAA';
wwv_flow_api.g_varchar2_table(104) := '3DE0AB23478747546141D67DC32BC8C05BECF9453BCE66EC620CEF03B9D215347965385E518E8F93142B939C0A656C04D15323BE45964DB3A5EA5F221AB6153C0342AD076075266D59C8A88B8110DD788CD663D1EDE86F45F71F717E7E0CEBA2EB82DBF2';
wwv_flow_api.g_varchar2_table(105) := 'FD108CAD0904191C0379AE3D98D0DB618A4CCF0686D0D33BEE183AAAF662435C999147AEC2DFE6EDA4431BC165322BC363F33EE64B45C59A77C9F0197EA743C96C75792113E6456AF67C9F43A53AF712244B26EFF47801B3E7A0B4EF93C6781F4EB2C58F';
wwv_flow_api.g_varchar2_table(106) := '6E4F9290773C8DDED278380FA82ED0FD8C4B533BAA4205815A6FC9806DCC660C14BA420DF618F63397923E344E558086CCCBCDEA4EE130EFE62E8EBE0832553730245FBC8A2C68BFE60C30479454C51EEC54189A5982A8CCD97B0FFE38D4893B84266B70';
wwv_flow_api.g_varchar2_table(107) := '9E0E74D7DC112892AB772212C86D4588F69731B30B5351742798F4EE7D47B3CE740BFE58DDFB23F5E3F563F4E3F471FF00CB9FA916545B29D47D5B765345E959EA7F60F56C08B9B5615F22A3DC8F074A3B0738E0E3078E8AFAFAB63C93367D8B069995EA';
wwv_flow_api.g_varchar2_table(108) := 'F03A2132624D8A707C73306CD65E1E926321B64D3CC79FE474E704A445467A94793B5302E8E9DFE14904A6F4AF743E8C899BAD710C6BE34D63BFC8DC4CB2CF13C0A2BD3EA19BCFBCFAD3F6BF71321FB5172EFF00C4C88ADE6BE056CB8CAF10A1AE2E90EC';
wwv_flow_api.g_varchar2_table(109) := 'C8B81B6893B6BE4484BB0A69DDA3CB705A2A5BB31A4D1FE28A5388585FB31EDB59CBF3FC39ABAB4FE121B95B2F349DC7317A0E12ABCD391B377380B0943EEBF82696F823EBC46179E02795EE354FA49EE40BFE421DE3942B783A4EEE3FC51677B0535FE7';
wwv_flow_api.g_varchar2_table(110) := 'A5D27BE9FB0C81A7FE2FF6623A52E98F424624F37BD1BDDD8663D148A674FC484D493DCB95C630371BE9A53A71E6962EFB1D4E568C454EF3A02CA5FC09C325B0DB60FD82F83761436331469D662703CBD3116E2E2BAE0A501F6CCC11A78ACFCA99AB60A2';
wwv_flow_api.g_varchar2_table(111) := 'B1F53F4C34D6EA6A955ED2F93FC8413742FC5F4427A1B2368BCE361F5AEFF9CFABECB5FBD3F1F63EA741FD8FDBF831A3603DB3256E33D3116F8E0C694A90EAD836E46982AB6A98CCA4AEA12DF30B1192C0FB9456C26A4E33817DC6DB75EBBB2537B34E86';
wwv_flow_api.g_varchar2_table(112) := '0C0D715F1FC2E826D1FBAA27A4688B2B6F037B4425757B0E61677E0B74FB2D767EB7621977DBDC7B5A781DDAA5B9434ACBDF59AE2AEEF4F7D23DC43AC36753C996BF7065539DD8D2A36196CC8D14A29848B12C6884D7A4F182868C62C86F7685B80DEB51';
wwv_flow_api.g_varchar2_table(113) := 'EFD8CE82A9978DFF00C7A75FA83F447EAB4A69E42BCA9124C97FC91BBD9E32C33F743F703F446C71E86158CFB2D313148D91749B11BADECFB6E623E345AE66231FDC9F1B88D26CF4660B97D8A8BBEBF508AD1E0F08EE8F705B9431E44535A228C4A25381';
wwv_flow_api.g_varchar2_table(114) := '5B148B3EF917138CCADD14B794E875F42DEB6019672B570D0AAF91551056AB4FAC3B0F93B03B03F64372FB397382C673719C8CFDE1DAFC9D87C95754761F2515A69E036DEEC4F93FA27E1FB91F38B779FE8FA85F737BCF43ED74DFF0EE6D7BF415211EE2';
wwv_flow_api.g_varchar2_table(115) := 'FB0F51EBF50899AA93417617B388308EAE84334D39C1242E54A6FA4CAACEE1A7C140AF27251A4A9857A7F6A708349B4C7B86606159A10C2DEE8FB11AA8CA181C57D75454DCCE4763F5C15C5277BD8C908410236B92D3B181C5EC7DEF291B5D0C2C239BF3';
wwv_flow_api.g_varchar2_table(116) := '33E4BD0B8C8A7B1FB88C68B7454D36940A9B2B55608BDF35CA2F835192E6EAE07EB484CB8822AB58FB0AAC797A04A26AC4BB745108634F84183B47393F2727C0886882CC579C9C84F03AF2FD145534AD78EA918411B56DD07F689E6FE4FF0006E79D7029';
wwv_flow_api.g_varchar2_table(117) := 'AECD1126198D1075ADCF6172F187B09DA66344B56B705B776E1BF81154CC68F733A4ACC2BF9E0511ABF51B6FB1E0BA258663F14603666F7FB973664352C4392DADFF0002FD233E46D06CEF8E5D88E3B0EC3F8333917A568D94A27941966CDE795E473C42';
wwv_flow_api.g_varchar2_table(118) := '8C5294A3253222C48591531CE08B3AA936EA4C2CA959BFB41B6DBCFE4FC06288EE3D5C0A7FD47ADB566467413AB7305C301BB925E0A8E3E21C87FC1D065A9BA6EF3D771508CCA7EC24B9096F8F046EDC5C8F881A6BA8FCAA0AA4103EA9EC654A2862EA5F';
wwv_flow_api.g_varchar2_table(119) := 'E07695CCDD87FB43B6F61E8F1D0C6911D1974F1467ABB217197018CC4D2951C182A33B9223BFE1B95383CE04BEC0FF0044E2E2FE9C0DFE2A99B4B159D5585E8B8F68FBC5D6CFA2DFFABB182EF315572F4EEE04BD794686EEFD553259D75A4CE2AEF10FAB';
wwv_flow_api.g_varchar2_table(120) := 'B974BD3CE566AD27A7C05D41510386345BA1A478781F4E33C333F7A02B4D8703703537592C356150E563EE70184927F813C93374AC6CDC33BED69508D156ECB33501F4BD2FA14BABAE57FC9F2F92E0BD8C5597FA2760DA52DEE7D38FD87B0E146DD1BA36';
wwv_flow_api.g_varchar2_table(121) := '42105A60F3F95962A5DC9C9BC22E023DD5F723F0F02AB17D33D5A3DD23B48EF3E4E9313A9310DC78643C4410C4A78A87DF54B6703CD269968B5852D6546231047070ADB68490B92FB189DDB69171C829EE3060C183803964D9607693C7831D0C742AE855';
wwv_flow_api.g_varchar2_table(122) := 'D0BD041516658F95F86506594E321B49363239EC50ABF2BFBB2DEDE02D00A560D7185962FD771311E763A8F27FB8D859495BE9FB8C6ADDF847BF3EBC8E1F4548F9A2D5A799BBD839392C9DEDDC9552E639FC4889C5389CD121F7D86CC92036DF0856A3E0';
wwv_flow_api.g_varchar2_table(123) := '6F768D9E74D6106D6E6570CCED059575B231F630B983C05BAC3B6132607449C490722878307FC031150D909559BABEC273CC5FEC587D449156ADADCC592F62AE0A7ABAC743E8FE8A51BAC3B03F11D744FD16BBF7D2E8F4C377ED1797F066BBCD66ECF76F';
wwv_flow_api.g_varchar2_table(124) := 'B89DDB5C57BCBCADD08ACD153EA998A3C67DA7E5B68F2F72E8EE7F0CE894FE99F1F864C8EBDF75F9B2FA191D0BBDFA4FC3238F75832E39499FED760B8EC369AD9E0A6C939D5891AA1F9D2BEA57533F00A942318068DC3ABE013E9610FAA4E29F8D212A65';
wwv_flow_api.g_varchar2_table(125) := '842F3A7BFF0043959EE41439D609A6B07DB8C982E67BA11D97A1CE1C659F99B1F6A712CBD9680A98B09D2F9D32BDAA48B7367E7262F750933BD3FC2ECE0C5FD314F1F045DB336319D7BF72F4F5D2B939D10D8FD249BD4C6E643B57E1F6105B8C927842EB';
wwv_flow_api.g_varchar2_table(126) := '634353C934F6662C9C0F89F67034F222491987FB86AFF38823AE340D2FB14AADB6E55DEFC1DA9EC6C460A87D10FD7BE73C258F70BAABEEA3C0A86CD8DF71D871213ACF516DBE91650EC19B7BFC4289F0C5DCF818DAD8484957C68ECC6E5C71E51DA24CB6';
wwv_flow_api.g_varchar2_table(127) := '829DB8F2F45E279968B93E0636B926B3C9D00EF2B5AFBE988B520B6FFE8909D7B053F27C8FB56CA8999BDCEC21A495B81E2BA262BFEEEA3EBA09AC3FCA3123645EC2B7F5FD023726A4DF94781747C87D5767C09CB0DE4D363D419B5BB8483EBA887FEEEA';
wwv_flow_api.g_varchar2_table(128) := '27FE11DB1F7942CE66052EEBF3AD1F463EA39B4E0F73145FF57D4E1102D6F3B530A6DEC302ED92F60714617B2C52B9E02B12C7F5A6610E06D1B3A35A4C8AF2879AE6F81E84B934B51F94C42EFAD87B3153FC3199ED5379F3A2E28B5DB3F25A4852B1392F';
wwv_flow_api.g_varchar2_table(129) := '022629F6CE441B1F5FCF40B9AA3254F51FD1FF006377CBBFF8C451C9BB79DBADFE89C9A69D1BA38657E6413C7DDA2912AC1BFE1B8F4B927F6AECF82AE7DF55C02FE0E841E371A709B276DF52082471E2AE8F7FD0EBADBB62A4DDDE3C9B6A3A36341DB4AF';
wwv_flow_api.g_varchar2_table(130) := '9029D01B4B82F746CD3064F4B03B07609D04E8381DE7B424B466B7A63F407EA049D97E3D08746F11247E7BAE8E6056535830EFD8996FCA5808D38C2D38693B92D53BD5FAE0DBFCEF6159D62ECFFE1BBF26CB87A06F8063461C34CC3F43FEC66DFF00C3A8';
wwv_flow_api.g_varchar2_table(131) := 'A3B02DB898C2ECE0B408CDE6BCBEE7BB2C6FDABFF0253BDC7E0EAF8EE2388F1952754E646629745C71A425E4DB1638392A321F487A59BC9C6EA876C48B7F6D8B4FAF2EE2C47E5817650387223A0CEE8E8C51BA320D7C06463DB55D6EFD0416E721449F2E';
wwv_flow_api.g_varchar2_table(132) := 'FA19891161357485A915BCAEBA250376EE9D9B9F0978721BEE3DEF42C25570F03BD834EC9ECD35B32391D1BC3ABB349AE83B93F32611F9013762ED4B9F86BD06DD55532EE3370EECD921348DF596CBA276470B873ABFD7DDA4FB15EB79ECB965BB57F11B';
wwv_flow_api.g_varchar2_table(133) := '7430DDEC7A83F2BB0D26A33A86A85BDF645DE19BF04B358FAA1A96C278E85946D84674F9DE188E2512F464D6433AEDE61B254C3E863E1F9D1C56A9A213D4F00D8E24DB6064871EA7AE28D909AD78B9A6D0AE8CC04E58D09F381E6AFB5EE876EDD43FC02B';
wwv_flow_api.g_varchar2_table(134) := 'BDC5F73B7810D777E9EFEFC8CAC25546BF7C3F707EF0B533D459FF003721E89D2DCDEFEDC9EEBE4617826F9F2862AEF23F91E7A15DFBBCFB2E8BB1E01BB0E34F7114EA2FDB5D0813A8C78F0E0DFA85CD5BDA7F238EEBF3371132E191EE33EE74452752B5';
wwv_flow_api.g_varchar2_table(135) := 'B60D34B975DD6C2FC35A4289BF6192F60F3AA517A6E974A65E70FB82F6AFD0ACE6C2E2EE3E80218F3FC57B95F51C2C8E037E1917F70623383AC1C7E65262A5804CBF3E47A2D868F898C8F2C7FCBA207019F8F81BF192ACA512F1A577111DB3B0862F23E9';
wwv_flow_api.g_varchar2_table(136) := '9699D24284C3847362A56A8F126BB56315183B37DCABBEC6303B60DEC7AE6484D162EA995E19BCF2200CE7D1F40629E3F95AC4A8928A0EC3E44A1BE4B8AE6D650B1746AB73B031DFB8D3D6CB6608EE2325791C0B27E4F742FD520882FD5BEC2BD87C7DC4';
wwv_flow_api.g_varchar2_table(137) := '7B211ECBD826C986733DA7D0BD0C979E9D3B8BB3AE6F9FED8F7F51957673FA460957D35FEB145FF41FD227F31FECFF000BE84CBE918B0922FA295FA94562C38994EF71700FAE6A9EE602849DD0FE844BB1407372C2C4DC485B7E674138EF23E823D9453A';
wwv_flow_api.g_varchar2_table(138) := '9D27F018D4E9741DA98AE98C17314EDBE0E9FC0C762E0C615F0E85A64515156FE151D2A7009AB130496C2E3B37895F91FC26D46DD1CC4CFAB7E96CDBC24FEA3DCE587DB4F2FAC9D5F5972578AB1B984D969EFC9321C32E7A1684CF51733809324C19EA53';
wwv_flow_api.g_varchar2_table(139) := '5BA0B3355D82740F03BA6AE62C3126AB7D22164335CA8F819FA27458AB26E47436EE36E75D659332DDA47D0507C637C740E0DADD9D4DB9336D9B620BF1C6022754C99FFD47812995CCB5BF8337533F32476FF01E437BBC8846EED5B3F3BB0F9F46CF5742';
wwv_flow_api.g_varchar2_table(140) := '34D618F96F72EAB55B24D6CFA31EC14F9439973B3FBD3ADDC5D8F6E838D6B4FA23BE012E060CE76DD74D0DA80B75DC6F2CCB4CE6DE087847A9BA70CDE86F85E762D49F6031938E232593A7482D695F03163EA429EF6047C75DD13EB925425245E2A15A6D';
wwv_flow_api.g_varchar2_table(141) := '2B7420AD3789469DECDF0B81F20674E47F81EE8EACF7488F9F031563EE8685A67B0AA5B2ED45319D9EFA5D2F93754E7A5B256DCF5DD7B6F812F64F823A222E9A21375317930BDCC35BB313765EE6461E0823DBF028E59EC87FF28A29F4D18E1789E1B1F4';
wwv_flow_api.g_varchar2_table(142) := '3EAC60974E2E845D111E1A54DB0BAFE838D7C0483F582E6F84EDBE08432421084D30634C18F42DFD6B01D32513751A686FC8BB08DB23EA1B9CE9779A7119A4D3324EA2BA89B1B65CE4613B8B71E72267B1B697F8B72E97F839F4D21909989C969BEE8490';
wwv_flow_api.g_varchar2_table(143) := 'F21273732E0C1C87B9695DC41D15F42A3C870C14DE131B8C9A52FF001C213FF0660B81B570B433EE2BD0CDEC4EE3A96E20883435CE897620C850CFB0DA148C5FC6BFF9510B930285E48B4C157A668D5268FB698EA7B7FED84D6BEA57D4BA56565626362C';
wwv_flow_api.g_varchar2_table(144) := 'E93C8B93817A1A958F75E0D87FFFC400281001000202020104010501010100000000010011213141516110718191A120B1C1D1F0E1F130FFDA0008010100013F104CED81FA45C2F8838CCBD3514EC9406B7DC3054F196AD3066ABF731743E628D01BF861';
wwv_flow_api.g_varchar2_table(145) := '75DBED139417CCA5DDA7CC29CAC69B29F7811BB7EE34377326C9C855BBE25B92BE6E79541C5FA40058ABD11512830BAC9EB4BABF4A2A563F431BE2A7B62FB997F740A36B2FA0FC400DDBF7148793F7097FA598A8D061265238A996EC82B892815581A07B';
wwv_flow_api.g_varchar2_table(146) := '9A4A78ABB80A5D0CC877F12E4EAF387CC0AE5942E27B46F8482F32D355F89F132DB69EE4F27E88B59BC454E4400CB735B98F4BFD167E9D74BED091967E970209BF7868713DA67D4B79608B55F897D1133839975573C84B2619CEA2634928330569814A25';
wwv_flow_api.g_varchar2_table(147) := '0C33DC3771430A788AC706681298C87F985F0A8BAAA17D6E340DBEC44573F115105C7713DAF8594752B65C6C537F129685F2B17A5FCC10D9F998960AE8FA626EAACC600798E8E560D2E5D4B3D3E7D13D7311E22F214CAE9FA5C4262E01654D9B65179300';
wwv_flow_api.g_varchar2_table(148) := 'ED61D98D5FBCA5CCCCB83046E603D401A88D29994AFE203C211588396A0DDE599CA31C080A6245AB2DA9AA235EF1A8A7D9957F72A00650AB50AE370C03ABDF11533CC40D97F37047723AF41C32F8948DD4143298619AC742890D505004967A5CDA32A9BB';
wwv_flow_api.g_varchar2_table(149) := '89C4E04CFA21B1F4C3FCB730A8FC9111711A31F84E9514D32A913F22E336FD0C35D8C3B31280BA2A3C939AE0C86731F73E60F318809CAC18ED047F0CCC050C12F6D2735168B67D4E5317D45CF92098A0836293DC8ED243557BAB114D1F9C4043F28965F5';
wwv_flow_api.g_varchar2_table(150) := 'B996D2BA8D06AB285DE2021B4A88D844D886E76374CA6C104B0A5FA1339D544A5A58D5C179C6B492B6FD894307BCB1B3F997669855A42ED53178453575F7589ACD7C4F6BEA542BB215DFE22564204596D650CDC36DDC2F1462ED24CA2113A88543885854';
wwv_flow_api.g_varchar2_table(151) := 'BEA1664C5494D17AA188F1485EC61E429BDC0C0B133A80392FCCC8647BC3591A317B544B4B99B547B44590370D5DACC3B8023A2014D54C3ACB72589BC57A556E6587A1C764EDB257F06A5D763D994C928EA26B4942AD0F33C158B5AF1C82B1E6556A069A';
wwv_flow_api.g_varchar2_table(152) := '9D622BC11704A5D9352DD9515BC405B6E0EF625CCBF5CC09854B4716F71BC162C129F1D250A2A7B1040C5799572215586225B55302101368A1EBD6C25D90088F70CF711B33F8956BB96C39AC11411B6861BBA6A61A6D85055C6AEE37DFA299AAD29AA2BC';
wwv_flow_api.g_varchar2_table(153) := '5C11FF00609D453ABF69656D3EA1DD89E07D4D90F4789636A5985329E9B8DFA5D62F10A626EA24976D542F4ABEB731B7338290B2A675065E1CBAB94135F0DCAD541E2E201A585D0D91AC86202AC99E494437CFA5AF5E9D365D8C9ECE265B12D1A57C104B';
wwv_flow_api.g_varchar2_table(154) := 'DB1A4B2E5962382201412D5CB38C0454B624E16349B4F994D46CD1178938EBDE56B5FD410DAC019B664BA7E60D62455DDB3E25E3514E9B9896EBD17D34656ECFE61E30A5D418EC29187EB180297B242F63E85A588354AF7453EC92F025F218FA15CD8222';
wwv_flow_api.g_varchar2_table(155) := '901E06BE218118264469208188304EA62955B0D046CE5FF5E60CE405EED7E6E3960B8FC470C71B0BBE711A8590E513463130FF000C5C6DF3311F661A618E8DB1C72117832BCA60E196B2C9C6185ED134B05FB4C7FB136C1DF53CCA23B209725F994D183E';
wwv_flow_api.g_varchar2_table(156) := 'DF2C7A10E1994B94E259E658408EEA030E2FB06994547464FDCC28097870C240DAC6A72132076C4A447CCDD05030D4B3363DB736191E60936828B4D0C4260D5DC0AA67B61EA9CB19BE53C9EDD4584693A3FB6654DB1C5AA8ECD5CAC7CC3B7B1DC7F83B43';
wwv_flow_api.g_varchar2_table(157) := '993C1FD9967D369F819765A72B7CB341F710515950DC55C4B66F64D35106DF72D647D5C1ACA2D712DE5F511AF280B58A8DD73395DCE617A8F8244947E79A46F61608C7B470032AC11D1F5E8B352C8EA0F28B2E5B299F1094EC97B743DAC32B52E5612CCE';
wwv_flow_api.g_varchar2_table(158) := '481E02BBC83AB20C07D5FE48D010B5E68F7667D29CBBAF47532DA816A2976013C5C033DB8B7F88DA14C55F2FDBA9B04501D44AD132C45B230946E25383F302E03F339AD2F19978DDFB3F996D2B8B42B4735B97A204A26FBB877490989DB1AE4C3C8BE08D';
wwv_flow_api.g_varchar2_table(159) := 'CA9EE41B6B529E21985F833C57E160441B434F728F0CA4B098669712D6F235E852129179BC4C0352D7894F5333299817557E60930C0E8C31F32FEF21FB58602751C39A9A2244DB5807DEB72E35A9C8F89CB4E00A476C4FBB155146F77FD5066FEB405361';
wwv_flow_api.g_varchar2_table(160) := 'D7FEA512FC45FBDC40AFB8FE25AD0FECFF0013282479C11B4B2A0985E6DFCCC336F8A5FE615D06793730B604A70C3AC11B16F0B391730FA2CCDC1C1A946EEAAB73428C74EE2A68FB8753EA5029BF32CD5561CC28E808423B1B84B6102B33ED7B861B2463';
wwv_flow_api.g_varchar2_table(161) := '729C3E84135801B8C46E770A48AFDE57A9BEC0F69708466DA9F2C0BB106B6DA8839081DFCAA363A3CC1B553E25BE801330FF00103068A2B1109F0961C442AD2301D40D8E90F026375925B52B22A999777E58DF7061A32D41CE6CA1A8B34152C6C273C57A';
wwv_flow_api.g_varchar2_table(162) := '8002A2A731598BF94375552C0F1159FC904A43B404EACBDE268A38F328C979ABC4682A3E6386BD988E8517700553FA968296D5C6B54CB3FE1656E6C840CAF4C54BF5B4A34B06168741031761222A28C43ACD1A560B05E2D8319B80E6375041E47A2F994E';
wwv_flow_api.g_varchar2_table(163) := '5236A5C187EC4B68009E8E0477A3ED870F842CFB2625A7922DEF110C13DBDA64B5EC22AA5B9596296C4416F8627C10E4D4C8CE0CB98B0DCD50A20890A0B9E6FEA528A3697ED360D7CC4A2BA1985436D1AFFE05B9952E081A98DC3355001B3DE586AC81CE';
wwv_flow_api.g_varchar2_table(164) := 'E665AAC2198791E82AC8F6CFDCBE56D2C34151BEA39EC53B5D102FDD776078F30AE1180A19E1FF00181420145140752AA9EF6C852F7228CEE1E5ECCC10A6CB21CEFE2738225A83B28DF743CC10E5F922D66FC532CA89FD92E88AC8141F133BD1664C3052';
wwv_flow_api.g_varchar2_table(165) := 'AF98565EEDC2E11CBEAB494D1428A2BF5DB2D97FA29266648767A0BC305EE16698069F4063ACC6EC6E0936AAD777E5E8890D5F80E8E88884691B136413CF79FF00181BF22F3F1697F940489EC12018571DE97B29FCCDE1A7164FAC0CAF9E65C2C18600D0';
wwv_flow_api.g_varchar2_table(166) := 'C7B648718116D77730D045A7156F5823CBC05667531C287984D7A2FE62B5DC32C260B45ADB12E245AC0B1B75BAD660F451455CC7A93E6579F4C7E8CF7037254576CA6A2CCB335B8A67BA35452C6E12FDA39027CCFF00517DAED7D4C366904826AF83C5F3';
wwv_flow_api.g_varchar2_table(167) := 'E829A8A7FBD37B6E7C9E84B3F490F24AAB96FD2A5002AA180D3BCF5502C88355B7E62D4D40FD92D7014A560687D044B71475960D5259A13430000D3E251FA2C1745D3DFD4C3F69318CCCF98C82CA69C9CB02A0E3ACEEE260D596966752BD7131DCB8E67B';
wwv_flow_api.g_varchar2_table(168) := '8C74C54BCDC42626654B54B4B713CB9DCD7847FF00543FF6B3D8C7B7F6C4CB0DCD9C63328BAA4A0C198A853958A029CFB4DFE8A961080AF117AB392CD2C7421E16F0B501B19E743965217D73666D602F858AC590F3A11EE7D90D992D6F50B5744E7815F1';
wwv_flow_api.g_varchar2_table(169) := 'C41205F8DA7FDF50540CABA88A12F3112B0629155572B104B767E727D4AA6BD051B1A66EB1761C4CD9BB70C812C85279352CAD1497F3E80773139D43DA6B825FA720A6380CF8D7F7601E435755A70451067F6950ED5CD68B38971A156AAFC11638D48D58';
wwv_flow_api.g_varchar2_table(170) := '916D8588D799EC1F10C859F51B7965131039978F4C2423AA94A2395FD46E551839C3259CB2D41EA09B1B20109AE8A62EE3E738D95AACF3052143225FDCBE669658443C2FB84869B318E0B16258E8B1828546A2C4F0BA0185C2CA9DCE3CCEFF0085094F30';
wwv_flow_api.g_varchar2_table(171) := '817A908DDCA1B167CD92D3D8A754B823D6C0524FFC2461714C2D976347B9190619552823A7CE015630B81619234B7DC486683639E6FA964F33D67B44E151AAA486F51ABA9609435984B38DD9157FE6661E665CE768B850CD3E712EBFF8B98FFA688D4EF5';
wwv_flow_api.g_varchar2_table(172) := '2494F711EE6506D13C506CF2996359B5A03CCC60A2196389AA4F69A9A54403371A6F1D1D17B60AF80A05EC80E20DE5EAE08B3C785FF5ED95C79B94A653B362526B85E16C5BE2E190A78CC0009B9257FF00D71076F5C1CCA7FC5A623ADD2310651DBCB190';
wwv_flow_api.g_varchar2_table(173) := '917E1ADE09D41F2CCD63C9317F170E6FE5ED1058E5C00E6BA8D6522B71F3BD22FCB0101BC67183457A7A11604A843528F8AD55125B005B5CD5C277B15A839C8FCB04BFE15BC0A6FDE07EF3356A9DEF06E200D9749F9A219E5825FF00928D02FD4B0CAC5D';
wwv_flow_api.g_varchar2_table(174) := '31B3AF88378D4BAC1E479901B6E383555CB9AEA357AA5A95446D289406D70936C2945278CA81DE362A1730A392AA58E081D1103CAFD1D4DFFB4A5B2796202C582722CB34804C9B9497A70561EE60738F0C11BE40E0CBE81071401F350C497633C928AC72';
wwv_flow_api.g_varchar2_table(175) := '68F4440A2C30C5A3A234E08154101901571CABD219168D4B874D404B2A53260221F389EF7900155F992AD24B43844C069C4DB3975278A71C41ED2CD38D37C1569230D6F9340917A4E446D56559AAEB10B4AAF997F30179B95B750A34FA5767D4F2DB34CA';
wwv_flow_api.g_varchar2_table(176) := 'BAB4BB62AB28383C18018000D37C91AF2C82F26DE08CEDAB0F08E462A1DBFB12DC08A679D2D7F4AA5E8334FC98A77198EA528534C407A2CB566DC540ABE497B3DEE1C23004384B96ECB75AE405CBC1406C330CB05D0EFB819330991A2F5E8969C5F13488';
wwv_flow_api.g_varchar2_table(177) := '037184F7A174D95C0C2FB4554424F6427CDCEE2BE8FCF5988317C216341FE338799EF257932A6310B32A3C2A5DAA88C6616FAC63D140CC38085BA22BA45F4F42EE596C4DAB01EE3F18129328E2D5FF00095DEDBFC04D51417B7F057EA2E53E85DFB33015';
wwv_flow_api.g_varchar2_table(178) := '6AAB72F8DC737C9971C6000D842809429E496990283A15189635B4192B351CD5F5E18194175E264DD7E0F2CC85AADDCB81B6676DCA4382257CCA2690A07303DCFDB94863732B5DA4AF8E53855AA466627994FE9027C57BA26A5FE825FA25FD2FDA20D754';
wwv_flow_api.g_varchar2_table(179) := 'D3B898E59DED35806609AA6E798FB63B97171A96BD45262623FA09B4CD3113C8068A6542BC9FB92A57B51D3571BC2A7B5AD316A39FC0B0F505547BC3B47DDBF725776115ADC645339AFE6380C02E2FE22CA36AAE25591B0077CCBE896C5B7D19800555A0';
wwv_flow_api.g_varchar2_table(180) := '2D06CB3414D37E0EE094792FDAB387A96C482A352A50A105741533B688732E9A82752FC1E9685310BC171A30C06752F9810950185AC02DDA5F4E6E544C01A738B2A2C2682B0B50C26989F096443606D893FF00788AC555839F3E8D47D710E2141F5B4535';
wwv_flow_api.g_varchar2_table(181) := '96DAD8B019BB17165E2E0D14D06B55ED01834D469A802CD308DAB2C5A15D6B10583AE1AC11C8902C6A115533575CC8324A159B9AB2E8BB9142BEE47E9D6E92A5FA5F9595EC122068298C02ABF9CE1951546B58253D132B2D59F4A4A6172988F308A8C47E';
wwv_flow_api.g_varchar2_table(182) := 'A5EABC5F172BF4EA9532A004F76CB18EA7F9B3306EDFEC4663EFF625C365FA35E853CCACC0E8C6A582F64AB2696E34CB1A8572A92C694D0B16518B8425236C1576859E58BC18C072B281CE135033070B8CDB28C8B541ACA2EAE51E6BDA108689B7103B9B';
wwv_flow_api.g_varchar2_table(183) := '7E423A455DBEA9296BF7D99A42D6D5ACF64C2416A01512BA7FF1C1A48AB26AC6A626BC3DA32D87A0BFDE3993EE1132DFA660004444C27A6AF59AA86B2B36C2B77E1B1F088C8D1A09A821AACC92D84F6AAB30A8032F44449532C009BEE01796510F3966EA';
wwv_flow_api.g_varchar2_table(184) := 'FF00ED0082130B69A8B249E6963D5E3D8498776699585540ABF6852C939CC2ABAACECC360AAB108B92329F538538EED5C5DC40791D4B964675707BCC7878304A5287929FB223369E7A56D546E44069954A7E207FAF8953C4DB04FEE41B5F725DFDC82DFE';
wwv_flow_api.g_varchar2_table(185) := 'D453F8611D6B36A06D2B7FB9025B5572366B5A608D0901F5305D7DD8F67F266220EB21E4A7AEE3C257CA800A4519B0CAD8B538FF0045B451E2591B82DC9486F72672B63EF1CAD6B5A1AB5C4AD57E60458973C81656C7DFD0D1E96D4CE88142F2A9F7731B';
wwv_flow_api.g_varchar2_table(186) := '5354CCC4657FD5B8748E16EF1713C36F98390E31994747FA85605E243AE70D985549F48C2D01D532B63EB795DD4AD223B417F2A2452ED95D545798B77AD1E6FB4BF5C61AA0B9165687A4728D915C81864C10F07B0F460CF59FF909FF00B04FFDC27FE725';
wwv_flow_api.g_varchar2_table(187) := 'BF412555BA202DA1DA1D2DD7D198FF00872C763EC9FF00B91369FA5103874A258BD47051A2AD6F109F027E9443FC74985B89BF0B655790607C93D9F7FDA1633B3A94A2F0EDF0CA41D77EE51F3BB8D15D237D88EF6D3D4A8539FDC97B182DAA16BE61632D';
wwv_flow_api.g_varchar2_table(188) := '2898F9D126CB0C97B053159F82560AC4168D51573F724A00D9404D6989E3147C47BB9D8B9E07D4B56D5CC3086AB1FA6B5E73425EC848CC56129F12F44EC656537B0C10A97B619475289783E872FB10B4BBFB4C1C4A3A21BD8C4BB2B775C9B3D04A124DA1';
wwv_flow_api.g_varchar2_table(189) := '4AB400CAAB4128594CBBC43DA4DB2CE02986CB8DD2AACA3897C17AD56CFB903615B668E2A2F7B4555C468DBD6A8DB0FD8F9D56A23CBC690327B4A170413AF4562B361976C20EF76FC28043AA941DC3DE2A6BD244E6A166BDEA3C0BA1B3A8F22BA619D45E';
wwv_flow_api.g_varchar2_table(190) := '9433D031615822A7B2F573862037F6227566056B10DE431D46ACB6E783F7015830B0214D68AD4ABA6212DD4BCC7ACAFA23148A5354187FA4DA7FE3840314328577030A3A80955F602346C5795B6152EE0F1126459A0D3F0C7D731F55DA0F8EB819A3626B';
wwv_flow_api.g_varchar2_table(191) := 'E81FCDF6C142F08961306EE39732E585110D9DD29930C1AD440294610D09D6D79E515A972D66AC731BB9800A507B4480B67941719F16F15D977996C2A8DF98EF1E785D435C4202782E32D1B03AA4ABA47DC42845B94B053D6C84B54302525D8C078C5D61';
wwv_flow_api.g_varchar2_table(192) := '17EA593C70154A60196550CA0CC8FE5290691AF25CBA3967F660A97B38EC9FF808DEAF3E2149FC52F78C4160EF3533764B09A01E3643B1AA3BC7D895DA340D70864811A0F429D4F64B9185F265E0A65ADC468FB06D860CBA07255316C8B5F0A1DBDD206F';
wwv_flow_api.g_varchar2_table(193) := '2D324AD636FA382FD852953DB5B0A49EF415FAD02130C610D6182FC3CB955DBDF15EE1B9DCFC545678997FB370769B8FBCCFECCB25FC4A1A20976C7FEBD7A584FC61388E045759FE92EAC08506730AD872434B1ED11434C511F782610379BF24115ACD6D';
wwv_flow_api.g_varchar2_table(194) := 'A0F68EDEE61D6AF318A56AAB47F72A16BD83744D369416B8C185EF8572FA4664A8B2E141B63B83484E440135123C4AA54C8FDA16DB4F32A02A42D9AED8CB2314AC440319F12ECE0200CD4F0CC20976D403B8F062F928D1D06D704618C61ADAAF83F6ED88';
wwv_flow_api.g_varchar2_table(195) := '1C81F587E773A8303C803F87B232D4FE47D8F2E8810B69BE575ED9DF6DC715A7EEE95EF6ED17E7705943BCE07D1E866360E028C5198A369CDF1FDC0AA916528F17516DAB4005C7F81BBA89DAB05C5289F12C895989AD804278FB5D32858DFB3C4055EDB7';
wwv_flow_api.g_varchar2_table(196) := 'CCB1C4404B38265EE112DAF1601E4346F10893772B94B3500F965BEE5B5FC43B479100C2B6E5638DA43254BE9317510CB47D6280B9BD0733CDFA65ACC0C542A2A56F1883430DB11F2473B4CF748B0AEDF8ECEE61FE8C451A711B7115F6A9651294CACB5C';
wwv_flow_api.g_varchar2_table(197) := 'BF438B24B81E0FB5411489C43E7CE5CDF91A1F30200039C1B1E45BF796E29CAD5887F3FE40C1FE0C615583A46FD4B6865BBDEFE870461EC3114D11FDC59A3988960DFF0014EF83E75651EDFE7267C40F6F780523DE3B2AF0351A0A1F6840FE0328C7CFC4';
wwv_flow_api.g_varchar2_table(198) := 'C82A34D67DA244CE2E592CF0546DFA9796BE18A755A826C4C0F230BCB1DD0000DB73366BEC4E18A2FE44D39040F26A59EAA8C3D239515B34E6E29D506D8A829959D7327103912F2C42BB162F6173E2061852F74DD6A532851F545E025F54F0E78F0A3265';
wwv_flow_api.g_varchar2_table(199) := '7E6F581B26B3C11FE6A5240A0E9220065F8ABBAEAACA1702AEF165F31A5543C1B7F2B33860A48B7F6090475CAD12A92FBB64A557ED0F57E53281B5822F72A59E395F8C2FAE7307BAE591CB8363A10312CDE2A0C32A97F681142EDF22DC995FE5B501BCC1';
wwv_flow_api.g_varchar2_table(200) := 'B104B0E43442A8214E0CB36DFB4BEC4D818816914F989F57572A25EE6A022DFB351F995C01F6C60200DBC42C30C24383CD46C9A8C30E207441AC5116F54958E8607C81CEFB598A6334A725B044E5D04199540B0EB10C4A15FC231502AF4C7A3174E1E11C';
wwv_flow_api.g_varchar2_table(201) := '5840F530482F728047097710BD0542D5B51C4C6AB4EB413FCCEBF408E65B50456330C85ECEC9C2FF000A5B284D3AEB89E44ADAA89D22722C38F0781CB07366337BE7CA8FB51B26C8F7043FBCFAC8189B981271BFBCB707D405B55AEE3F4E4EA0F7943B75';
wwv_flow_api.g_varchar2_table(202) := 'DF1F974DF7E8148EEF466FDFFB4EA4487EDEC7E46FB8A284A2912EEF770BCDEC09FBE7DFB933BD2D811A623382BB3E21C017BE62B8B6CCFB4652C80B288ECB11460B5415E62B9686BC75300842BBB63525AAE60C5174B30B88A18E3C483D5DDAE526FF00';
wwv_flow_api.g_varchar2_table(203) := '2BAF640905A552FA975822CA12A84B1875332A3825400AB25EE1B514B0714364A8AF00CA95E9635B2A4586335D05E36182184FDF871C1CE821F69493BB350D22C3D8E43BCB7A3A51A8404AD4D67C69112AB2D16486DFFBCB19F06F3CE0E363A63C51EE9D';
wwv_flow_api.g_varchar2_table(204) := 'EFE01C13A535A2C4A0A4EC6C09502F7B469E75CF07D414B92927F111ACAE156FE099151FA3DD8D30A37AAF368EF5CD1BDEB207B3B94851F731DC837FEF31D754F2F6017CB1C71E439273DF72E71ADF98E10C5B4B6B7ED1C5B40C055E220B70D19849DC55';
wwv_flow_api.g_varchar2_table(205) := '93306B79BE6A30BA2DD18665E44D0D2A9CC6E1569F12A02A7BEE384A020F7894D835E3A04A4180B8B4FEE97896AAC46A5E00D07D1DD874B8A0CDB66C95425A8FA8ED3FA23098EADD2F0DFADB3C0E0553CCDCF673A7E40C0E794B751FE74C8091604D366D';
wwv_flow_api.g_varchar2_table(206) := '2532B8E524555D5AB441E64E0AA8A6BA699B80C8F6876F3661BD91543BB3BFDF10C86F167D8C655D12FAC13AB85F6B6E5AC9C6E7D3F7F76A1F44740253A4DE5E003F97A8ABE578A37A755B47504328E11C3B37C23585B9F331D7DB541A3CBA25D3448057';
wwv_flow_api.g_varchar2_table(207) := '678E04C08313E0A7438C55ACDB6D8A0D32DC501B5A84C4C038D62397AF12D96CBC4643C0310CA1C148D055D40CE7B4976B1F2318D912165CDDC422A451A6DD20FBAF372917A953E364C8FF0089DD28D57C44E18ACABE22AEEFFA12DE25AC5B2EB56C4BD7';
wwv_flow_api.g_varchar2_table(208) := 'DCB2988439C6AA66511BAB1D91175CE59CB2CEC8453FE99F3EA3B0A4BB19FF0095FD25221CC0B4C3A89011D8F12BB1B133B9DC3CDFF855F4B9408EF00870BCF72ECCA52D146CF5181D6453C21D74F98847B1454693911E11C8CA0419E16603F61C30B7BE';
wwv_flow_api.g_varchar2_table(209) := '2EF5F3D40A4A118D054F6D5E9DAE18DD191EB787D93010A0BF701F365EFD0029C0A2E7C8E87242E236F02EBBF7A8C6B0DC7F633B7C4AEB2A90136982D07BE27ECA4C4A5C402025B59235A5C0693C548435A0C5D2EE10AD694EDCB5446B90A5D25CEB46AA';
wwv_flow_api.g_varchar2_table(210) := '6F81E6925A29D0D5D43AB48C43435B41A97ACD2A3E229145C32BDCFA8F48495B560F11C2D5DEFCC5284D4900F0F8C793E8C4046F81E9D4A616A2EB3631CCCDEB7FBA804A033301FF0056F4162B02C2E9DB646CA59C11CCA69A5806EEC4944ADBAEB03B17';
wwv_flow_api.g_varchar2_table(211) := '03D185DED3A9B4748B39E47B31555F1772C175D54229B51A5EB75EB255051D40423D6FEE6A53A1E651FBCD84362660AAC34F786148B6D392F776770A71BBC716A01E8D7CD28EC186F05BED1E7004304DFE7110B3DC47A4D5AEDA290B6C4B0EE8F98B47CC';
wwv_flow_api.g_varchar2_table(212) := 'B5053003C4B6CDB38158B66BEABC1796525AD0476CD42562962B3DCA9D1DF49CCDC464C2FB467C7DD4DB276451C4C1B503B677BB203284EACA89D3D95E97E25A5B7A253D4CF51022BDF5296BABC0F0752A2BEC0AF6944B2C842AD5EE5B33E889A92A1004';
wwv_flow_api.g_varchar2_table(213) := 'E9FAF3CE341CAB679E0D58B4ABB5B9511A1E944F83A20892015B3C88AB84B7A660BC008974C43A62B6586CAE82C6E8D764A98C1B3EF58F636B826C3556AFD99C07518ED2BC53B5E1B7055FFDA5D2724AC00E57EF1B1FA21C405787C4A771CB826C4E9FEA';
wwv_flow_api.g_varchar2_table(214) := '2FC4ADDBE0E673D3740AFD6C37FC43438214CB4ABF6C3E38FB4460EB5F68C82C622C395A596F7E822AF053E58E5FB3E3A04B18B9E5734125C352A54110440284A588B5C315A0AB9C0A8958B4761A100D34A1605186BA62829B59B6880164072973DD37A5';
wwv_flow_api.g_varchar2_table(215) := 'A9E744DC281B6710AD3A81DC5D44E0E6144A098F4A4483B95D339887DB35770B2DBA9A85AC1AEB3508418D9984A466242D677C675D31D1AADAF2A9B84E1AFEB8F00EA820C8A1B1E0C2176E52F05D66ABA1885CCDCC0AF238D8F451317F1667FE24AA717B';
wwv_flow_api.g_varchar2_table(216) := '47A21EC0EE5169230FF88DFE2562FF0002052CB250727904B22B8C3C2E86EBA737161682860D06878101344855C040D223B11846C8295E172FCA8559844C07DD99A46E576027198EB9556B8EDA95405695B583AFB6BDC86F30B1F6A89AC4BD9D9236F9C5';
wwv_flow_api.g_varchar2_table(217) := '358FF4DB1AEB7FC329FB49078B2E340C3CEAE5A5C1D32A880D7F11EE5180659850A62C5531D46AAAA000004C60AF457D2D506B51EE418C5C52015E1AAE08AFE43F3E9474443096805AD17E27FADD441430B679A251D128E894747ADBDCB756FA5BB4F225';
wwv_flow_api.g_varchar2_table(218) := 'B3406D5A2692F614584DD7757543F23766CD8E8226AB5969C5AD4263C290C1B660F057BFED478BB8B6BD09ABE237185EAE61779FF966D9BB71FD98F0F380E9D7EE8428672770E2C146C66A12D4B2C99B794952E37CB2E7CCFF001BA85CAF467D41617F6C';
wwv_flow_api.g_varchar2_table(219) := 'C8790CD8B82AE54D4042D2523F69D0F08E6A054E8D9B874515874DA05E65FD4A1D617D9054929C0C1F35C4A280526F6FA131CCE26EFF00B4C1F84F8FD34CA7F50A7BE881847AB08F71F082A06ECABB6E208074E2A219954B1D8C6855CFA6F28A8D37860A';
wwv_flow_api.g_varchar2_table(220) := '831BE2AAC04A8AE402CF1128DA10FBB88662769391FF00D18B03A7ECCCA79E26EE2F49521DF84FC0618C019A601608975B9457FE4C4BF40876D48C608370AF52467B47E460F3225843A22FFEFACC189551A7ADFDB0D65499BA1BFE825B88DF5EBF12FF00';
wwv_flow_api.g_varchar2_table(221) := '67F47CC0225EC49EC403EA5AA5CCCB65A79267F4AEC55CC76734EC2314757D928351A2AF0BCCBD80E2AB3532D286BEED1789675505C4A250BD171B99FE25DE6573B950C56E67AF70AAA94CB33CAA9745BB892AB7DC328682BB396BA84836B462300C858E';
wwv_flow_api.g_varchar2_table(222) := 'A0D0B1D92EE98FFDFC7F9C8474C5A0D786A5983018E088979D7A02B151756E236E7C5E80BF01B871A341B5A8D4BA36DAD5798A7FB04757742CB128A32D5A297A998FA9DF95FA46956E394E9F6F44B59EC5459C5F0A19EE6CDEA9BA8DEABEB440AE16D038';
wwv_flow_api.g_varchar2_table(223) := '8D8CA278C2B8777F7E9B69A239653B5438209626D09327AA967FC60D1417402FB459A45EB503AFF4FB62FC318C564A5705BC39435B5D32B0962D9B5150B4A829BF165CE6144A0B69B4C66E79D0806D831484BCB07D289C0C69ABDCC37DAA1884DEFC2614';
wwv_flow_api.g_varchar2_table(224) := 'A663132E8DBDA6AD0D95331545996D4C646C04297786E058778D376CE58FA157BC3316B2AB7EDB0BECE4685656188B89995E26CC43635C7EFCA5FBA59E8A56204F3FEAECBC1490C5C56ADF032FD2826577C0225ECB2F275D904D0E39B35A1E6282253929';
wwv_flow_api.g_varchar2_table(225) := '6E27B05ED1D8C01DACB97EA18974CA5B761E2222781BA9CCA088173E09B5C15A13B1EF0718CA4C370C1274F17E0B2B421E02A9A77B82C155E68AC1A9DDBCCACB10C70A00350CAB750B2AE4B490D4A2A020B563648038547007DD1101D3DE3DE58E02ED69';
wwv_flow_api.g_varchar2_table(226) := '2FA943D944F9C853617E6342B20167E53386E0753ED2D03A8407A2B470C0A3AE04026C1FBF9AC4CBAD2558E25EBCD63885893335AB8ACB45838374A59F24BF4B9773524016AD1D132FADCCD91984B75077751FF869A47E2901C05F040740F6271883AD44';
wwv_flow_api.g_varchar2_table(227) := '65A11F308BD082592FDA8A2201CE9EE656A99622B3E23C82CC967BC2862F904000F9CB11A16893445EF44B4A1FE620B2B4BE60105C7619983F90D4F088C0C50BD4F70300AFDA5CB13E2E2C1715A44C5635259E37A9D5F4A5BD0E7182EFE112CC584ACAC8';
wwv_flow_api.g_varchar2_table(228) := '43E0CF6C3B4A76401DCAF430476C352FA46B920CE92A60B6CBF045CD4B950BF4028AC7C8FF00B0C4D900E83F99B07551A0E7084A86FAEBC753DEAE3136CCB5AA20244DAD09504FBF50A3AF0C1F6F8DCC6A08B7AF15292EF8F6A9738E9C405E4C78890A84';
wwv_flow_api.g_varchar2_table(229) := '70E258B55EF2D2F1F665448BF38B960AA1BA9D1DD4BBB28C4B54EAE74A99EA5B2E733E67CFE84A230B188F2CE132C4184A723E8A5FC4CFB4C1B65351AF4D46E9A828D92DDFCC058AFA625D7BCB189F697C8131BC45A560BA98057CC6D0531386C7B4ABB3';
wwv_flow_api.g_varchar2_table(230) := '3E65A85BBCCE0D2F2D112EA96B9A2264E4C9DC4CAD2FEE0A8A4ECB882D265772D0D8B89B948701C5DFBC11825666C43A9CC881354BF897437EA54B7D2A54A98F4A89117996995C556252101F44E8945CAA99A99A95D4E1521B971D4F372DD8C7AACEE55B';
wwv_flow_api.g_varchar2_table(231) := '600C33486214DF7C4AC5DF6C475B705D111E030586910563E4E7110AB15095433CEBD45FA6A20F102F3296509518981ABEA0A2D8784531666FDA2A635ED1F46BB9F33E65621165CB8C5FA5B2FD6A5799F27FF2C4A9D568BB991F8C5CD560C6C601016954';
wwv_flow_api.g_varchar2_table(232) := '616955304BA30A309E98CD04616F7030471029A98BB217812FCCE36BA3302DA5A870C9AC9B94717840C4E671FF00C2FD2DFD047FF8D40CACE89F2C3B12BE504C1624C521932C6884B02E55ADCAF7F689BCA70955704A3AF4EE1D25B25DC8F286D7BCFFC4';
wwv_flow_api.g_varchar2_table(233) := '00341100010303020405030205050000000000010002110312210431102051711322324161144081053023425272911524435060FFDA0008010201013F00FF00C58FFA52D2A4843E4FD89215C3A8570EA15CDEA399DB20042B4F5510B3FBD53D5F678E7F';
wwv_flow_api.g_varchar2_table(234) := '64FDFEC00250A423E53C381223802503DF946CAA7ABF1CC5DD04AB80DC14083B11FB0EFD4E8517B98E63A415FEB5A6FE97FF00808FEAFA470CB5E9AE0E6823DC48E627281CA79C8EDC708959744981C2422D69DC05046CE52E1ED3D95EDF7C77E57506D5';
wwv_flow_api.g_varchar2_table(235) := 'D7556BA6374DD330D1AEECCB098FC2ABA76334F49E265CB4C66852FEC1CA5DC70791DB2998C2851215AAD56945BCB5CD61AEA8290F3109A7536568189F32A8ED43A832EF44E168CFFB6A5DB94C2C2C49411E27215A166494361C8763DB96ABD94F5EF738';
wwv_flow_api.g_varchar2_table(236) := 'C0B537514ADD489F5130AAD6A6748CA60F981185A48FA6A5FDBCA78625084773C5B569B8C07827A03C3DCA1B721D90DB8D7FD42BB2B3D8DB6015449D4EA66A41C2650A4696A0C65A4C7E155A4C6E929380F312A9EB750C6B58D7081F086C33C867865047';
wwv_flow_api.g_varchar2_table(237) := '72870D2E8A869845264752772AC28FB8436E1737A857B7A85734ECE09A5A064844D3FEA0A5A4E1C0AD502755500F7726E9EBB2B0635C03A37F84DA55ECAA438C026E13BA34AB9A34C97794986855693A954B5C9BB05A8A96BD91B8DD03201E054F753DD0';
wwv_flow_api.g_varchar2_table(238) := '4773C32800381DCAB7023A27349042FA51FD6868E7F98AFA311179474D4C7FCC13748D76D56551D3786FBAF95A97066B5EE2367A3ACA7F51E2418B213754C14EB360CBC94754CF0A8B60F91C095A8ACDAD5839A0A0D168551F7BDC537D23B702A4ACCA07';
wwv_flow_api.g_varchar2_table(239) := '98EE7A21B0E1038B9A4BDC246E569DED617071010AD48FF3055E939FAB73A25A5E850A67524D82CB7F129B4A99A1A8C090E307B23469F85A5368CB84AD4B18DD500D000C21B0474AD2F249392830000655851E1EE84A3CA77210D87242A987B80EAB75B0';
wwv_flow_api.g_varchar2_table(240) := '512ACBFC9240EA153A334F504BCF949FCC2A7A6BA951717BB2764F65BAB0C927CC325058E2616162504773CA7729BB0EDC6A6A2AB6A380020143202A937BB6DD02465124E655C40DD127A9400682319DD6C00071ECA1A087102E9DD507BCD56CB891C251';
wwv_flow_api.g_varchar2_table(241) := '456161084773CBE2373BA63AE1C1E6A5EEFE28DF694F2EBCFF001537D23B275B73E67746273285A11842D011842D84627DD69E3C56F1211E1EE87291321783F298CB4707965EEC1DFAA79A779F29DFAA6FA4765501BDDB6EB3765104A0D9C61105069382';
wwv_flow_api.g_varchar2_table(242) := '883F0809C2A208ACCE1289804F28A2D23DD780DEA5780DEA798D2A64CD813DB41A7CCD19286C215404B9C63DD7B7E5413ED94410221004E21191851217B405433559DD4A2E011C893D516364A0C1E5563615AD9823812AEEFC09192BC4A71378FF002BC4';
wwv_flow_api.g_varchar2_table(243) := '64C5E263AA6B9AE12D208E1AA0F36DACBB22537D23B22241011D1C922F4C6DAC026606FC71C2023F85EFEA3B216803BAC4153BF643662F63DD1D9E8819EC8819EDC750D7BE939AC201217D0BF0316B04B4757752BE86B91970979F39F8E8169A9B98C20C';
wwv_flow_api.g_varchar2_table(244) := '44F963A702A54FC153F055DF0A7E0ABBE0AB8F42AE3D1498959EAB29E48216509466021722E37808DC84FBF122428E0040E5874EE143BE1091EE14188950719507A94022D25587A84580EE022D720D7220C2B5DF0ACCCC045A55AEF8507E3ED87D8C28E3';
wwv_flow_api.g_varchar2_table(245) := '1FB1F9FBFF00FFC4003B110001040003050506030705010000000001000203110412211013203151052232418114335261717215309123243440425362061650B1C1F0FFDA0008010301013F00FE6ED5F1EBF997F916AD5AF4FCCD382B6DFF00343F201A';
wwv_flow_api.g_varchar2_table(246) := '284ADF308471BB509E037C2D57B2D056AD52AFC80831C45805647FC256E9FF00095BA93E13C509A7575464735E5095BCCB754E7662495DDD9A750BD42F50BD569B6F870DEEFD76DECBE00573E3B56A9D57478DFE372C3FBBF5FCDBD9A2240168CA6FE4A2';
wwv_flow_api.g_varchar2_table(247) := '1190097040B4F2A4F89A539997CC6CBD8D164278A79587F01FAECD381ACBBB3E4B293CA9511F911761E2B130B256C8C01C3406D7FB6B1DFDC8BF5287FA771EC3A3E2FD4A7B5CC739A79834785A0934026B0345045A0836142DCA1C3E7C0012B9795A6D8F';
wwv_flow_api.g_varchar2_table(248) := '55450CDE56BEAD59413D1647790BE0D14789741D95877B2AF927631E31186650CB23413EAB0F8A924C5CD11032B792C70AC66207F9BB80051B0340E3885BAB545B4092E3A2B196C928BC071D4ADE0AA04ADE8F9A120EA53641A0D6D1ABD3652A5836E1DD';
wwv_flow_api.g_varchar2_table(249) := 'D950EFCF7413FF0069C307BCC3D9EF50DDFD144DC237152643FB5AEF7AAED2158E9FEFE004D84095AAD691436B4969B08CAF37AF356323014FF1BB819E26F0E162926EC88D918B39CA761272FC190DF006E6D5438799B8F925737B8415DA249C74FF0079';
wwv_flow_api.g_varchar2_table(250) := 'E16AD5792286D2C78165A6B60F0B13FC4781959C27001C40EBB709D8F84970D148ECF6E6D9D5621830582CB0D8D5498A984F8368768F6B730EB6A09E47E3E66127281A053765E0A47BE4730971D6ECA7788ED1CD0A5E4B4450E5B7118B924D647E9D10C4';
wwv_flow_api.g_varchar2_table(251) := 'B094C707358411569FE23B32BBA1591FF0942D96E2D354A674AE77743B2F9269C483E171F44D71AEF34B7EA1601C1B8085C790627E2F0D2618CAE692C0EAA23CD3E6C2892005833380CA6B926CF8613CC0369ED16E75286764F117B6EB5E69DE2722760E';
wwv_flow_api.g_varchar2_table(252) := '68700DAF7B9E6CEC63A99103E64EBD11C439AF703AEA5473309041F3E4BDACFC013FB4033FA45AFC51DFDA086367201185727F68C8CACF87216271C678F26EEB5E76BB3D8E93B26168AB31521D9D28C2187337367BB4FC0C866C3BF336A36B41F443052E';
wwv_flow_api.g_varchar2_table(253) := 'FB12FB6D48C207AAC261DF87C396388F336109DED79F316AEEB60E682D361438595BB8AAB3595278DDF53B378FF88ABD90FBA8FED0BB42192511E469356BD8F13FDB2B05898A2ECD8985E03DB1D57CD1C649EC4D6EF0EF33FAD27CF28C4E0C6634E60BF9';
wwv_flow_api.g_varchar2_table(254) := 'DA6E226DF6346734D6BB28E94B092BDF81739E492014799FAA133834000689B88783AD14DC4B4F3053769A43970B00DD46E02CF4E9AA93591DF5E0B50FBA8FED1C11C9BA787D035E454B89A9B08D11B7BE06B5CAFA29719926C4B444CEEB79D73FAA64B9';
wwv_flow_api.g_varchar2_table(255) := 'BB39F21681FB371202356568A97984DE416AB5A47899A362759D0F9294DC8F3439ED8703877C2C7126C84E14E23A150FBA8FED1C25EF24124E9CBE48B9C49249B3CCADE4997267396B95E8B1914430D210C6835D150563A207509AB55AD2287001640EA5';
wwv_flow_api.g_varchar2_table(256) := '3707300CEF37458B84C526B5DED7644D8774CFDDC9EE8B394289B1EEC7EEF7A7409FE377D543EEA3FB4706BC18DFE1A456B45C884DE43694396D09840783D0AFC49BF0158AC409DCD20114364425DD329CDF08F25109B76DA7B6ABA27F8DDF550FB967DA';
wwv_flow_api.g_varchar2_table(257) := '13667366366F8F19FC349F454158E898D2F78010E41799DAFED199AF73435BA15F894DF0B57E252FC0D411E01889DA284AE50FB74AD3BA2F2073D53810E20F3BD535F1881B6EFE9089EFDB6C28DDDC1988BA599BD42CCDEA158563AAD3AAC5FF000D27D1';
wwv_flow_api.g_varchar2_table(258) := '6A99048EBD280176536A3706B7CD8493D744319386B351AB88E49F8A9419751DD3A218B9B78D163C3A8F44711396B5CC78D7FA7CD381B248D6F54D6171A02CADD1EADFD7635A5EE0D1CC95ECB89BADCBEEBE12BD9B1157B97D5D72F352452C4ECAF6169A';
wwv_flow_api.g_varchar2_table(259) := 'E47676648C687874B914C419A420E998D140EAB7FF00E29CEB24AB2ACAB3D559EAACF54C1635638A1618E22100D8AF34FDE38BEEEB220D7676687C0B29A8851E654BE2C47DCB5DE33ECFFC4CBCF87FFEF34C7BC88C1248DE26BDF51EA7DE278EF3BEBB3B';
wwv_flow_api.g_varchar2_table(260) := '3A48A2C644F91A5CD1E48F6E618871A787BCD39D5E16F40BF1BC107691BE982A26D79F52BB4F111CF331CDCD797BC4F99D8C344FD0A2D2003D56EBFCD9FAA30D55C8C5B8EF65DE36FD5088134246ADCF33BC6E8B74DABDEB6BD56E5BA7ED5BAFD53626EF';
wwv_flow_api.g_varchar2_table(261) := '435CE055B29A037405668EC774A858D707D840B2B506ED38C746815186EF5D7CA822D86B442366E6EB54CDD57786A9FBBAEE8597E43631D95ED77428EC7BB3389DA1DDD236668B2D10EFD517C46ADAEB1E769CF8C9B0D3FAADEB2EF77AD6BAF342460BA8';
wwv_flow_api.g_varchar2_table(262) := 'C6BF35BC6556EC7EA53A40E2DEE81499896806DA4E9D51C54641A6909B8ACBC9EE1E81331110073171D7A276262234CC0DF44D9981D64B8FA2F6987E172F6B394B439D5F40998963798714EC4C6468D70D5678BABFFE5BD7F9CFFFD9';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784241063088151265)
,p_file_name=>'img/construction-and-engineering.jpg'
,p_mime_type=>'image/jpeg'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/img_discovery_jpg
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := 'FFD8FFE000104A46494600010100000100010000FFDB008400060606060706070808070A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA70106060606070607080807';
wwv_flow_api.g_varchar2_table(2) := '0A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA7FFC200110801A401A403012200021101031101FFC4001C0000020203010100000000000000000000000102030405';
wwv_flow_api.g_varchar2_table(3) := '060708FFDA0008010100000000F5006DC1200000000764A3E7BA1B35FA63EB7E9155E57D455C97CD7AEDA767BAC3C1D2E7E77B2AB0AD898029A883100ED91CAEAEF8E377BEACC8E2CF57F3C791FA542ED8E06B5EE74DED2AEB31468608BD520C01174F17';
wwv_flow_api.g_varchar2_table(4) := '91D7C31A9F4BF60D1F9FF334E56AFCB75BD7F27CEED7D4B94E9BA0AFBE5913C5528B4C465471C698209CF53C7E7BC0E67BDF57F0CC48843C5B521B5EB36DDBE4DAFBBAB2258E380C14B2ABA0716080BB95D6E971B035FEA74686A8BAF85F3B1F4DD991CC';
wwv_flow_api.g_varchar2_table(5) := 'EF16ABD4B1F21E3A94103566442956D20863C6F2DD74AAE4B8CFB0FCFA35BE43CFB11F4BBECB4156FBAAA7D228C931D5B52682DC8AEB52AE2004F92E0F59CCF318BDDFBD71F086B7C5B67BEDD4E0AF940CAC9DD7ABD373A644120322D84224220D13F1CE';
wwv_flow_api.g_varchar2_table(6) := '6FCDAB3ABFBB7E77C289E4795BEC7C8B62E192ABCAD2F13F67D3375B708A077DB08C0845A02BF9E63E78A7F5E759E2D655CAF3FBBA6EA88DD6BB70B375B67D175CC84942222591255C02B9440E4BC8B5DC6EF3ECCEFF00C0B9596379974509EA39ED342C';
wwv_flow_api.g_varchar2_table(7) := 'DD6D73B3A8CCD7FD2F19A8B5180877D8AB80572881E4DC6F3795F5DFA1F3BE0F8A79AD1BB870FA9250DB6FF22BC4DCF79C6FD100C9C55286ADBE30805735121F3F62FB07BEE51E2BC551ACF1DC6D8EAEA63CAEAA5D2621E91BEF01FA7A4E329C6348494F';
wwv_flow_api.g_varchar2_table(8) := '222A91D72703079FF47F411627CDF1C6F25E7B11A333A8E63AACC30ACECBDCF93F1BFA21A8DAE25712719DEA35A75CA75AE93B64C5E6BE5D1F3EF38A5337DE83C5655F85A88F7BD8FAE729E0DF4D846D128C47195E2A9384A75C3C6FEB4CB660FCFD87A1';
wwv_flow_api.g_varchar2_table(9) := 'F16C78D87A166735D56073FA3C5CBEEBD5FD0757E37EDE384C654864AE8BA91176D5CDF8BFA1FD3B63F1CE2B03C4F545FD274181D1D383A5E73065D7FA0F6BDA43C67D8455CDB752192BA0EB889DB5795F047D1BEB9C67864BC468EA7AEDCD95E079DF35';
wwv_flow_api.g_varchar2_table(10) := 'D7EB39B3AEF423D1FA58F9DFA0284664884583B62E1113BA8F00C0F4EFA475BF3F68790E87A753C6C7E5BCF71B3B6BACEF3BFDD7158FDF7611A9C63198DC22C1CCB29889DBA0F39FA7777ACF00D451B32354FCEF8DDF7275F57EADD8CF75C1F3F7F6BD6A';
wwv_flow_api.g_varchar2_table(11) := 'A5C62A4320A487294E9494A7B7EE6CD2783EA94F2953C879C6ABA6D92F48EFB2736E9F9463D5E85D3AAE246321A8A91194DCE9889DBE85B1E0FC7F0D16646A3CB57ACEC35FB8C6CEEB31F373B53E7BB4CEE9B66512231720AD822F6E9889E7F4DE57C6D9';
wwv_flow_api.g_varchar2_table(12) := '18981C0EA3D1BA7AEAB676D3D66F6C942C9D6AC950DA80D95B69174CA6227A8E1853AF41C6637ABF6FCAC333272B6F97952934A4058EA6E35390EB620B6C2989A7D9725A1951C570BB2F49EAB6B95B2CCBA2949493B145B529533235B6C800165AA95A0F';
wwv_flow_api.g_varchar2_table(13) := '9C7D3F7187AFD0EFBA8EBB2DCE53A4888720B08314CA6E215B638A009DEA95E6DE0BBFF53F4BB53437394AA8C5A6A6A532A9295B5557A8D6C25140396447170FC2397D4EDFE9AD89288DD8E75569A9225744809DB542E51809CE080765F8F86B5FE37DE6';
wwv_flow_api.g_varchar2_table(14) := '676A0013996D552945B8DA4A24494EA8DD12B139D6004DEB6E22F2DC404D5922DA6B0242196422AD235DE8AC44A000634722A78D9B691006AD92B21511949A439C224D15E4C08244A018B954519CA85C3C7BFBE00D3570590AA25AE249A22A3644864553';
wwv_flow_api.g_varchar2_table(15) := '8A4A50AFC8F94F55DE6C321D7772BC9EC7D1A200CB4522A4A644B8642B72146EA81C49431FE71D56CFD57A5DC5F355701A4EE7A306276A6108938C4BE4E35D729118E4504D4471393F9FEADDFA9F59D056A1A6E0A7EA68025646C82506C8BB2C235C264A';
wwv_flow_api.g_varchar2_table(16) := '30C8AE2D26464BCCFC7A5BDFA27361182F39D57A46CC62B24A6AA884C892B655D4AC6E10BE0A558D262F17E0FD57D52C8420F96E3FB0EA1A648948A50E6A12939D702D6570C8AD38038B157C2F7D3BEB841E8F80EABB0682D8CA4E802C5093255A2E1421';
wwv_flow_api.g_varchar2_table(17) := '74633AC72ADB8B14EFAE10343C0F61D600E4A4E74225742B984AA09D91AE3A30121C66E0E0A7934251E7743D5ED9C5B12B651ADC8ADCDB8C18E73AABA8051649914895F411C4E669ECEC68626DA892928CD38C4264EB8D881290A5634C9DD8B4E0E830F6';
wwv_flow_api.g_varchar2_table(18) := 'FD144062649449CEA8CD9002C52AC9C471C1E9ECE32DEAE6227762F23A6C4CDEAA44444A2E4101CE09B8804DD9529572151B5D86261ED6490EC879E606CBA0B48910193230729C60C4012B1C2BB602653B749B22606BE7ACD8E69689D434E368563B6B88';
wwv_flow_api.g_varchar2_table(19) := '0032528A9C5447521005389B2D6CF683BAB72A5A01C8812B552000032C2314490801EBB037BCED1D5864544E9001B223B6304310D0C2623515D708C62D471F08566D4321BAB37640C1906EC5040034C14E4A7C560A828A220C731C4B674EEBA7430690EC';
wwv_flow_api.g_varchar2_table(20) := '8C001A09C53913746871A33D964431EA70C57999163B32D464C001C4948AC0681C8565729958E0806206980E20C001C4732000098DDD44E7088E080609CA1242681800A511B94004C52712FA6D7041010304E509201030014A23728268681CA53AAD708C';
wwv_flow_api.g_varchar2_table(21) := '8AC88301CEA9C4275830023243275803431DCBFFC4001A010101010101010100000000000000000000010203040506FFDA0008010210000000F4CA0067C9F25F4BD1CB3C279FB3A7D6CE833A09F1FC3C7ECFD4E9F3DAE1C7ABE8E7618D84FCBF1F7FDCF4';
wwv_flow_api.g_varchar2_table(22) := 'CF9BAF9FE0BF47AFD39A9533A5397CEF4F6F56FC3F23C88DFDAF62AA674A7A38F9B5EAE1F9A7B37CFC937FA31A316D5F67CDE7E9E9E0F9FF004B7397CAEDC3F428D18D2A6395F5F2E6D4C70F9DECF07E8AC53369DFC7CFBEB8DDB9CE1F9DFBDF94FDE54A';
wwv_flow_api.g_varchar2_table(23) := '66D4F6F9B876E7BE9CB8E79FE739FE97E77DEA948A989EA8E7C31C7CDD7F27EDFD2DF658A66D73D77BCFE67E77E5E3ED7DAF57CEFA1E9DAA532D37AE5F2BE5F2EFF47D9E90966819AE3E8995968CD4D6740CCCE7A6C92D24A5CE818CDDD125A9654B9B4C';
wwv_flow_api.g_varchar2_table(24) := '5C4DB624B65CAD251C66B5BE7AD10A65A8B289C77AD4C7424D0935162833A73E833A4B162FA004BC71E9B128951A2704874E1EADD9602A04F14177E9B699B73A12596E471B7B65A22E74089C6249354EFB4B2684A90A252844D25882D11409629082D42C';
wwv_flow_api.g_varchar2_table(25) := 'A10A197FFFC4001B01000203010101000000000000000000000001020304050607FFDA0008010310000000E2B4903403B7B5EDA5E6395ADF469596EE5F1AEA1A0BE800B7DB7A2D9E328B67563EBF07CF65E8594911E8A088ECFADEDE6796BD3BBABD4A7E';
wwv_flow_api.g_varchar2_table(26) := '5D8DCEA204EEAD561BFD9C39D7CADEC6F2664F9DF39C4A8B6DAE30467F41D8CDD19FA530575D9CCCFE4D8A9277D4A02C3EC2AEADD774F910C3CAEDD56F942652DDD08C24F7E9B3B504D65E474EECDB3C9122A1DAA11965EDE8EA6A80A8E574F6EDF39ECB';
wwv_flow_api.g_varchar2_table(27) := 'E5D093AC76282960E977FA6C8D4737B1D35E57A5E4A0DC19320ACDBD2E94DE7C56F4F572FD2E1F2B0E3C1B8356AACE8F636909F7FAF3E470FCDF4B959289407015EAA7EB34D1A773C5C7E6626327095438A2E4FABA39B9A11B2B884A712755908CA29DD7';
wwv_flow_api.g_varchar2_table(28) := '69962C8D5965510B1C49556C62E01BF44315516AD9D70904A2DD76A891D52D4677862D5CE109A9B82709A12EB594E5CFBF3661D8E30946E74B217410ACEAE3A2ABB473C94E54A9C6C7558556A8B8938DB54B7F354C9D45B5C88D8AA80862270DB6F34068';
wwv_flow_api.g_varchar2_table(29) := '6086E0C7B6498EADDCAA418869A24207D8007573A09049294406D389219B611C9222004E000366E93939B84118A900944001C93498D210004A203249A48062000068064871480924D000340138FF00FFC400301000020102040601030402030100000000';
wwv_flow_api.g_varchar2_table(30) := '0102030004051011121320213031411406225123324042153324344352FFDA0008010100010801D794D1FE2695AD1AC6ECE1BB6815D3E9FB3A3815978A93E9FB6AB8C153A0AC3FE9FE2DFC11BDAE1586DA49C48327DC51B6F5DCFBB0E401CD6236C54F19';
wwv_flow_api.g_varchar2_table(31) := '2531B46DC4BC97893CC41703EDA8ECE69B42228D615FD28D752CD5319429DBF76A80194A0715A6DE23D6AFEF2147B63B8B5F9AD2A792E35EBB4FA0937DBB4F1746DC656D34AFA761D5E798F249043275748638FF0065D5F456E34AFA8B137F88C8D696AF';
wwv_flow_api.g_varchar2_table(32) := '3A71654B38608435712774EBA8E9AA001410CA1BCC8789AAA470C4F248C2DE0FD30AD77F2D65D22C97B8BE3B8B948DA21A3A46412D7119FDC5EDCE947823768D249A0D3E969975BA8CD5D6216B69A712E3EA29753C17C67117A5C5B1214D8DE22D13A50B';
wwv_flow_api.g_varchar2_table(33) := '804A03F524771C78E56B7BF11416D117C72C36E82E71DB993A43F3EF89D6A3C62F635D0C17105D43BA2BAB02929916D95E0E0C2A9D5B5AD5BD64BE3B83C5376C51ABA595D55536D9C7E55A4FFC4CB73A7596E648F50C5893A9FA6C37F92AC53105B38BED';
wwv_flow_api.g_varchar2_table(34) := '9247791DDF92E65F8D66F2D4B34DF72499DBDA4931E89696F1006A29595B548A55954350821E26EA43D32D32191EC8C8F70F8AB9103CFA3BCAC9A805E0D7EF76B6D84255C5CC502EADF432BCC97D78F895C71EFA67A6F7C9C1BC69536FD417A934A90AE4';
wwv_flow_api.g_varchar2_table(35) := '013D05BD831FBE48E3545A3D3C6E5FED0DC6C7D42B061B874035ADF2EADB72191ECAE46876854D270A277A7B895C119B32A02CD3E283C4459DC92D835D4307D2B6CF0351CF12BA0A0C0A2F2E5555502828CC638A494E891E184759638628BF6EE23A9E23';
wwv_flow_api.g_varchar2_table(36) := 'D6C26B46A20D5ACED11D095DE052F8EB90F191ECAE4687BC8D1E7158B4DB6348EBD54B75045FBE6C589E91492C8EFACA0135836017D8AB81162290D945698740E7AD1395DDCADBC0D21791E462CF0DB485D0AAD942A7561AE9A0D280AD10F95E18F1BC7F';
wwv_flow_api.g_varchar2_table(37) := '521CD04D4E85C683A4370621B58DD5B74D725CFF00191E6191F14323479C562D72CF7AEA0173AD30FD460BD2B4F7583E1E712C4A0B40160B4B6D12E2569EE24949CF12B937173B16DEC826A64F5F693D74A527FA804D1D3D861D768209A0C4D3374D02A1';
wwv_flow_api.g_varchar2_table(38) := 'AD3A55E473F035892EAE221B5051A1CA798646876A590450BC85DCB1663FB7EEA275EB5A74D680691C05FA43E9F930E85EE6E71EB9DB6EB083E6A4F5962577C1411A5A5AAC6A0C9A5100F4AFDA34AEA4511407E376BD2B45AD5726688685DE19361215EE';
wwv_flow_api.g_varchar2_table(39) := '81FB4DC5EEB91A1C8798739C872E3B284B2D95E54D5DB6D8196BA2ED2B86E1B758A5E0B78308FA730EC2D1365625702E2EE5714DEA9D9638D9DA276BAB979DF43910D52DE4108D03E2172D4589F34198788CC9B012642D16D10B42D0C695FE39B66E8E28';
wwv_flow_api.g_varchar2_table(40) := 'A788EB134F7E4FEA7F91B11E7DD7BEE6BCA28E43971A9B7DD6CA04FBBD9C89405B0C0B16C4006B6FA77024C22D0A9AC56EBE359BB0F547CD1F158CDDEA45B2E1DA889C50D9524E9126E3717724BD065D34CAD230CFBDBC86151209A4244BC56D4B810C44';
wwv_flow_api.g_varchar2_table(41) := '388EE67948AB2C38C91B5C5DBDFC4CC4BFF00D7AA14721E6BDE6CC154B1924333BB9552CEAAB65F43DB4B0192FA185208638932C76EB8B74221AF9A3E6AEEE45BDB33D3BF5DF42570FBC7CFB9A77776D5B92188C8E050564074541D018EE7871ED85E4B6';
wwv_flow_api.g_varchar2_table(42) := '63FACAB6E586CB1C1141E25E630FB30E9E8717FAF7465EB2F54331E792E6D6E6EA07860B7FA3EEDB5E3597D37875AB894E73CAB0C3248CC59E4666D28E957D7E25943237925F92385DDB6D4786243134F771C3249A6889126D0813AAA55DBA2C2192381A';
wwv_flow_api.g_varchar2_table(43) := '5B759042251AF07035D710026AC6269E1B4DD0FC8BBCBF1CE79BD57ACBD50A390F3C9854D03497110E5C7EE7A25B8CB19BED8BF1D3A2EA396CF0F9AE7AD7FC3B05DCD3C92DCCCAF3268AA426FD9AF105CC411F4B990B4A75B493649A1E24CE2B05E97BB7';
wwv_flow_api.g_varchar2_table(44) := '2C663E2583AD1B79865F8A3CCDE79BD50F197AA1473F79120024DBE272DB6222F9609A29E14963CEE674821791A599E67691EAFEF56D21DD4EEDAC9406A74C82F4D4A23BB055B3C2113492EAEF1540765AF0DA4FD4920B69CF0F8979C15578D7A33B6A5D';
wwv_flow_api.g_varchar2_table(45) := '4075A03520574899835AC324C8AD3E0A1448E055E2EEB694549092DAC791C857E333E79457AA1E331CD8ACDC2B1968755D2BE9DC71EC9D6295583286196397FC5944095713A410B48F737925C4AEE74F649DDA5244CDE22C22EE56D64924830D02384418';
wwv_flow_api.g_varchar2_table(46) := '8DFF00FBA1C3E3897699AF6CED4EC8F8F3CA0EE7277EAB70E048563552EDA5161B76D619641FF5E4D2B084D04C723E29D191D9733DB15EA857BEC7D4336AF0C43FAA9A1FDABE92177F11CB5631890B58B8683DD4D32431348F797B2DDC9B9A2B69A42BB2';
wwv_flow_api.g_varchar2_table(47) := '2C0E63A7162C22C62D0D68078F55EEA6BC82D46B25CE2B7170C522FF00E52A2D6A591C42EA40275A3A536077E91C0F208D63511AA9D5AB0C0040D9DFDB49F20B21C8E5EB90F31F1428F9E6195DCFF227925A40E480B877D317B72E24B88A28E18D638EF6';
wwv_flow_api.g_varchar2_table(48) := 'F62B380BBDC4F25C4CD2C9717515BAEAE6D310C4240F35AE0D6917561A2AE8B91A9668A14DD23E244BE88C5A79756673B42559C2CF30A79771D2A28AEEE9024767F4C99978B3D861185F155E1C59FED8D29B7114BD3A5610FAC520CF6D1EC1E75AF74723';
wwv_flow_api.g_varchar2_table(49) := 'C9884DC1B399AB06C1AE310956ACB0EB3B24DB055DDDC36B11924BCBC96F26E23D08A3572E078A1EE851F3523C71A177BCC697C5B8E2DCB9794FE9C3BE9E42FA6A3F270DB1B8BCFF005D9E0A588F931456B21E12CACC4159A1E2F0C193147D6E08AEBB69';
wwv_flow_api.g_varchar2_table(50) := '943206384A69031C8FF057CE479AD2C60B904CEA8A8A156AF6FE0B34D5EF6F26BB9B7C998F02879AD6AF3188222563B9BDB9B9FF006F4AB6750231535B5D4AAFB2DF04BE7996230FD33040ABABCC91690412492EEE1C7B8285DF434F72932C921A75DA2B';
wwv_flow_api.g_varchar2_table(51) := '76A2B0AFFAB91AD35A3DB3C8B468F35AC7C381172C471B8A00521925927767933F547C0AB9BDB7B5525EEF15B8B8D5461F84DE5FB1114585D95822EC48A05470C0AC2AA1FE6CFB9779904FBEAD2E785F74C8DBE12D14171BCEC0902099A5A357926CB67A';
wwv_flow_api.g_varchar2_table(52) := '58AE0EA116C2F1968612C47DD6B6E2DE3D828E47B679051A3E79614DF322D5DE2B656C3EEBEC6AE6E8145A028E73DDDBDB0D65BAC6E7935586DF0EBFBA75E1C182DAC210B27112452A66FD758EBFD5A97612B30D247545D5934118A4612B6A9089E58B6D';
wwv_flow_api.g_varchar2_table(53) := 'C228002A8A6A1472F54323FC0F5428D1F3C9F8ABE99936AA9F39FAAD7DD4F89DA4248ABAC62697A4569855E5DB0356B84E1D692014F78BA32A2C7A3331DB121690F09BFAA61F328269B0BE215DEB6708F3F1E0D9A64297CD7BA34B4794F21EE7AA5A3473';
wwv_flow_api.g_varchar2_table(54) := 'BBBEB6B34569A391254474BA937CEF969D29D9514B35C6368355827BAB89FF00D96985DD5CF5AB6C1E1880DA2C2721547C0998AD261ABBF73AD95AA33385441E0F8AF59FAC865F8A3E2968D7BA3E686468E67B9EA97C51CF14BC6B3B2967596E65B890C9';
wwv_flow_api.g_varchar2_table(55) := '2FD373BA8BA53AEBB8D134D25C3822DA4C0B1CBB606687E908BFF6B6FA770CB73AD2DBC2A770AF747CF2FAE55A3428F8A5F147CD7BE4391C8F73D50A39E338941C19AD97AA9D0DA5DBDBBEE4B4C66C1A508FB1069CE3CD7BED0C80A3EE851F343DE4398F';
wwv_flow_api.g_varchar2_table(56) := '73D64689A750E8CA6FAC65B59F432C61D7555620E8625795D512D23963B58525C8720EC9CFCD6946878A3E686428FF0007D64CD5F9CAEADA2B985A291B0DBA175C1A3F4E59BDB6D7C27054B0DEEFCE3CD7BCBD727ACC643C57B34DE2BD51A192D1CCF7D9';
wwv_flow_api.g_varchar2_table(57) := 'C015F7495E335F3DA5E5F7C8687AAF7472D7A67EB25A3EB3397AEE3C816823375933791231AB2684020F64729F35EB335A75AF747CF29C850CCF6D268646754ADDAF80BD75A19B1D01A9E5694EA6DAE9EDDB42AEAEA197B033F591F398CB5EB5AEB90A39';
wwv_flow_api.g_varchar2_table(58) := '1A390E43D9765452CD88634D3968E082E5E0951E38B12F92BD23935C97200935A6957B068788AC2ACEEB80FB5BB0B5F9E43E7B028F39EDCB1A4B13C6F756F2DA4EF136E5D3AC17124328AB6BA5997558E4F34875AD35A1D28D100820DC45C290AD11586C';
wwv_flow_api.g_varchar2_table(59) := 'E5E3319E71CA731C828768F6B16C385E43AABA32B1A0576E956B712C5255BDD2CC9B96D37B6672BD8B7C5A86156D2F0A657AE9A0E715EF2F791E4F7DE398E619639866F06EA1D34259401A2D432C9138616C75850E673B98B872BAE5672712D90F38A1EF';
wwv_flow_api.g_varchar2_table(60) := '23E798F31CC65F9CCF731AC33E3B71E25D3AD60B869FB6E655A391CF114FD8F5EEB0B6FD3957B1F9EC1F3CC7315A64723DC74491591E1FA7EDA39F7B52F3621FF5E879AC2FF74DD91CE721E79C6672343BCB5EABDD1CF116D20D2B5EB5848FF69E63EF21';
wwv_flow_api.g_varchar2_table(61) := '43CF28F391C9721CBEB2FEB999A435C6928CB257164A32C95C692B8D2571A4AE3495C692B8D257164AE34946592B8B252CB2571A4D2B8D2571A4AE3495C592AEE667600D591748CE9C692B8B257164AE2C95C592B8D2571A4AE2486B8D2509A4A33495C6';
wwv_flow_api.g_varchar2_table(62) := '92B8D2571E4AE34A6B8B257164A13C8284D2571A4AE3495C592B8D2571A4AE34B5C692B8B26DAE3495C5928D7AEF0A3E39259360A63D68522ED451DB39FBAD34D28E428730CBFAD7AEC6D35B5A9BEDF2BA900D6D7AE1BD709EB84F5C27A113EB4627D28A';
wwv_flow_api.g_varchar2_table(63) := '30F352CA17A0763AE56916E6DE7B673F7DBF591F199E5B82444DA2B6E556CAEA4D2ED91D6E84114A1D49DA35E41E68D3FED34F3FA5635E6A180C87AA803A0A1CA794F29ED0147C6679655D51C55B36EB788E534314C9B2586C6CE06DD1730A35210AEC28';
wwv_flow_api.g_varchar2_table(64) := 'B5436C5BAB8000D02D1F342B4EC9E53DA15F9AFC73915672224255B8F0D71E1AE3C35C786B8F0D7C886B8F0D71E1A96EBD209A52696E655A789A599D84702275CD68F9A1E4D1F1D81FC1F473FCF36C4AD895B12B8695C34AE1A570D2B62548AA16906E6D';
wwv_flow_api.g_varchar2_table(65) := '284694EBB4D46747E45A3E697CD376051E53E3BE3BB72DB505473A0615BD475335D293D239F5950720F028F9AF429BBA7C77FD67A53DD2A9D14DD9AF98D5F31ABE63D7CC7AF98F5F324AF99257CC92A599A55D1B6AD6D5ADAB4A029047CA96BE54B5F2E4';
wwv_flow_api.g_varchar2_table(66) := 'A5BC6E95F2DEBE5B74A37AF505C097A738FE30A3EEA6B578D41AD8D5B5AB63570CD70DAB86D5C37AE1B570DEB63D6D7ADAF5B1EB6C95B5EB6BD6C6AD8D455CD70D80FBB8649A8ACA44647EE8FE00A34CA19482F68DFD7E3CD5F1E6A16B29A5B48C79E043';
wwv_flow_api.g_varchar2_table(67) := '46DA1A3669EBE1D7C3A3667D1B69850B694D2D9FE7E2475F1A1AF8D0D082215B5478A000F1DB197AEE7AAD33147F807F867C57E2BDF67DE5F9A1E33F547BC723FC43EBB228F9CD7C721F3DD14723FC43DD1E390F9C8F6C79A6C8F21EF0F397AEE1F14BE2';
wwv_flow_api.g_varchar2_table(68) := 'BFFFC40043100001020304050906040405050000000001000203112112314151102261718104203240425291A1B11350C1D1E1F0236272923033A2F1245382B2C270748393E2FFDA0008010100093F01EBB11A2C4CCA75AEE4C79FFC6FF8C9418BFF00AF';
wwv_flow_api.g_varchar2_table(69) := 'FF00A4C8BFB1E3E6A3D47DE3246DC373C5A9658DCB924363E52B40574CA72A2E9075E4E39AAEADEA604F5A586D5A94A9C367D3C93C164F54E630921209BAB9957CA9BD6206E57DADD44D934099DE80B449ACE55BA88C8619288C6ECEBC1F0D93A7B48821';
wwv_flow_api.g_varchar2_table(70) := '0F0155EC9DB5B09F17CDC99127FF006CD09EE6EFE4F2F45CA611FD56DAAC4C49B36C8EDC39B0DA782600B59FDD09CC05FA8D681734D51758346C85494D68735B571132A0CAF227961340AC6F44D27C77A91909E1F0520696AF17E3241319665DEA9EBB96';
wwv_flow_api.g_varchar2_table(71) := 'D3E89B2CE76617ACDCB943787B47FF00B8A8A4EE83F5519E37C397A15CA2D6CAFC55E64ED0FAF7454A8400CDD52A3CB70017297792882A3A4048844FD7694DFC2B3266FC66A5AAF9DABCAB6ED965010C7895CA62CFF527070DA2A8CF312AA2F16E1BAD4B';
wwv_flow_api.g_varchar2_table(72) := '78C935AE12D7331BE9A078D3AEBA20BED581596FA008C39E558CEF290507944B73217C14374A58F2956ED117FB7B6344E909D352F6AFE88F89466E379E6893DDAB0F399F927B9E4E2493CCA373285B399587157E592842D77A59A9F1EBC5F15DD982DA8F';
wwv_flow_api.g_varchar2_table(73) := '2460C1194E6EF0628B19FB9A1BEA99127997097A683C1769E21B3606D54E5390E1CD16598CC5F55D89976FD22685325F24389FAA3340C965A08903DD27AE6016AB67D16D07D74900669B43DA44B8A6F62CFF00AE72279AFB2489B8EC519ED0327109D54D';
wwv_flow_api.g_varchar2_table(74) := '253B80FAA0C1C66ABE4B5467FDD5787CD11F7BA4ACF0466C3E5E0AEBD4FAE768CFC34441BAF50F8B91B45649A61C3ED467747866BF9705933B49E64F21BD3A65546782168EDBBC90A6CFA269FBF05F7EA8847C135BEABC4D3D51F9A9715D023727034BC0';
wwv_flow_api.g_varchar2_table(75) := '247975C3AAC1678A33C42EF192BD66A761CEB4F39305E9A190E13280601AAF7BA7CC76A34C9B2F545A41B8494F8052F5281DEBCD11A1A853EF721A1D25062C40EBDE1A48928CE609DD3EB7D9692BBD5E2B008551C6E4D9B8990007A26CA3C5120DEE311A';
wwv_flow_api.g_varchar2_table(76) := 'C435DC398F9447E39052B7862513E9E8A6767D02A6CBBD113EBF3478297DEF55F45E0A676212DB24FA137B8A6441DD88D608ACFE99A10621FC8E7427F9287CAC7EC89E6475BBE2103863A01D6E8946A86B1AB9C6E68CCA861F1B18CE1ADC32D07546AB78';
wwv_flow_api.g_varchar2_table(77) := '69326B6F52B20EA82A83721F7BB41B6EC85C886EEFAA24E8714F757EFEA9E4132C7EF35CB2039D2D664512AEFA7AA82F19BA046B43C0FCD72A853FCED742778B54031C0C458E52DF9A05A720F8ACF2AF5B346364779AABD1B87AAE48F733BE755BE68874';
wwv_flow_api.g_varchar2_table(78) := '77FF0035E3D068E93B55BBCF330ABBE49D64875735AD99C1197C519332D37E8E8B7EFC95099B7717DFFB5A9C00A99641FBFF002850E1BDA78799984C8F04F79A69E226B95C28DB223413E2359400C0D1301AE26D4BF5542E511D84F65D0CFCCF5AB80994';
wwv_flow_api.g_varchar2_table(79) := '6AF74D0A9A0516288D12B6586561364C634340D834DD0BD4E9E97646653C9884CC946A9C3C13893CDBB1AC949A5B9DCD1DE3B32CCAB562566EA904CE5FA9FE8BD91797CEC1B26B8DF29AE43EC9FDE82F300F83A4172B8B0E7FE7C2041FF5B54382F703A9';
wwv_flow_api.g_varchar2_table(80) := '2131BF5944B1301B6A5394D72BE4E4787A75A6CDCE94E6654C5728632B80B544D3162033B4FCF60E65CD04A3324CC9D2755B400E59A13B429CDBF009D2005182F272D178A1224D71E353E084AB30C68ACF3FAB93848020119E32CC9CD7B7B32EE7B46514';
wwv_flow_api.g_varchar2_table(81) := '486ED8C88619F0345C94B48617075902A36B640F868700EB60767FE4B91407ED3C927FED98EB4EFC56D9246C3CE3F99DF0D27588D7D9B148CC78737559DE4ED795E7A47726B9B0BB2DFBC545686CE80B9BFF0030A359197B4BF8430139C43451A0586569';
wwv_flow_api.g_varchar2_table(82) := 'BCA136D9D4183428A580E20035479372A184EFFEA9AE4AF85F84EEF48F991A1C454545EA3FEE835EB37042F76B8CDB9274DAE1307997342BCE8ABCF40275AB4664A3A2EF8A6924E0111FA6741BD00E952DF6422E8B132DC6E400959BCD69340BDD60899C';
wwv_flow_api.g_varchar2_table(83) := '3530F04D1FDAC9F44C95C3C3409D1426EF3D23F142E601A3BBE8A3168385A78F423ACDEFD41C56213BFC3B8FEC2714E041C46933633A5FAB461E6A9684A596E5FDD04D2E390F8A9436CEBFD94073A2385F9F15A8CBC34D1389D880313BADCF695470AD2E';
wwv_flow_api.g_varchar2_table(84) := '9DE3ECABAD82D38106A3E213B544A5C15E5344E77A131D91F1D1B069C091D64F405B3C7463EABF9168D8CE78CB66877E33C5360CF419068464DECB7250CBE79288D60C86B14CB6462E54D2EDC312BF0DA7C7C5375AD54A76A3A87E7F7242968D77E0761B';
wwv_flow_api.g_varchar2_table(85) := 'C6809964447012C44F34241B723BD62FD2C987007AC9E91238609A5CEC85EBF0611BFBE770DA9A1AD68900304667B23BC51D628D4DCD1795F850F0070E0BF10FE6BBC100064398F0D1B531D66D0AE7546B644C9D885CA7202771F8278748661D2FDD64A8';
wwv_flow_api.g_varchar2_table(86) := '6E786E2301B762E54C6C3FC95BB695C8ED31B7467BAF23BA16266740583BAD9ACAC8DE68816C0066E89F2505ADCCE2779D0770C49D8B80C86868B47B58F35C0345E50AF79C29E09CE77C4E4111AB5DEEC3E685C84D30BAC9BEA0378D1598ACFCD3AEEC57';
wwv_flow_api.g_varchar2_table(87) := '262D8509D4A59639DBB192801E0F4210168996267441A1D88150176401A0D64B1775B841ED6B8481BA69A0345C0683371E8B45E51DC301CF1ED1FF00D2A24C4E72C068B803399FBF995022B89B9A1A4D906F2EFCC53031F7999E88DA9A3944426F79B2C6';
wwv_flow_api.g_varchar2_table(88) := 'F017A841CF028C146B466EC8266B4AAF3D01F34EA990DE74F69CAED1DF3D6B257CA678E893E27F4B53CB9C6F3CE76B60D1795A8C380F894D01A2F7BA81416F288F3917C4E8B7828109EE35B5600AFC0291713AAD637D3E69C43889086DAC8664A884C8C9';
wwv_flow_api.g_varchar2_table(89) := 'D23E49FECE1E0D9D06F4CB24CC80F166B9908FB4B3D38804993C82ABCD2670190D18D3C5437F8212DE54503704E26B399EB6FB4EEEB6A57E1C3C85E779E73E5B3143D9B73ED284E3684E672CF722E7C406A6E1C13835ADE8808B7A3395E7E8A239CE75DF';
wwv_flow_api.g_varchar2_table(90) := '2013835B2AE2E3B16E90139A6D812BB24CB52AB4EDD8986FECEA83B37268000A014F70B8826F965CE7DA2306D5030C673AA165AE3D3726FB57E316209B47E96A07614E2E273C06415E6F71F44C3379BECDE76A00B8DEE71A951B545EC02877A99509A778';
wwv_flow_api.g_varchar2_table(91) := '9F30F5E74A668054A336B84C158534B800314D9FE6372884ECC136C33BC54DD13BF29F820E6B71CCF1514344EA062A2B8CAE68A0FAA87AC6F26B72681EE665A2D94B8A79738E253B51AD0E96DD3C9624639CA4DF12BD9B4656EEE0172B71FD0D97AA8662';
wwv_flow_api.g_varchar2_table(92) := '1CDE66A1B6774FDD9275A127BB01F54163473730B937B3B54B44DA013452EA7BC27512BD6B03D07612F9A375EE38ABD02E73A8004E9BDAC01C7DE228532D3BB32BA59A27DB7F983EEE4E0F8983B21EEE34546F99F79FF75C1BCC3208CE78FBB2235C5BD2';
wwv_flow_api.g_varchar2_table(93) := '00DDA6FE6DD92AB3108CC1F749000A92512D8789C5DF44E93B0DBB15336EDE78A63A3A06FD9B7DD3D173483C55EDF30BA07FA4A35EC9EF2A1C473AE5C345EDBB77BA7F9ACE8EDD885451CD47F0CDC7161475DBFD4150E2325767CDBDBA30BF77BA9BAC3F';
wwv_flow_api.g_varchar2_table(94) := '98DCF6A17F49B9A3ABD977755E3C0A6D99B419653E770D1853C3DD43F09C758774AB8A14EC34FAF3F768C1DEBEEA6CDAE12213DCF676587E3FC0EF0D190F79E2ED190EBCE4E4E4E4E4E4E4E4E4E4E4E4E4E29C538A72727272723396832994E4E4E29C9C';
wwv_flow_api.g_varchar2_table(95) := '9C9C9C5393914E4514E4E29C9C9C9C9C9C9C9C9C9C9C9C9DD56FD397B90140AA20646E324D4D439810D17E9B85DEE5C44F4194C030F689565C51327B641B9BB092BE55FE078E9E8FB9725DDF4D10DAF6E444D40635D9E3E7FC1CF45065EE77012714F09E';
wwv_flow_api.g_varchar2_table(96) := '13C2784F09E13C2785E29E519EF5404AA9CFDD0104104104104340F79E68A70968CFDCE26989813420D56559565595252E66066A4A4ACA0D4D08041AAFEBEF9D5393939391451E79453914E4741512BD7EE466989A8494CA6043CD38A7F927F927A13424';
wwv_flow_api.g_varchar2_table(97) := '9EA6826A60400D03FEB87FFFC40029100100020201030402030101010100000001001121314110517120618191A1C130B1D1E1F0F140FFDA0008010100013F10631D1C4B16584FFF002086D00573D2DB9CA3163C05E23413BB463EDC02D376A705D1FF00';
wwv_flow_api.g_varchar2_table(98) := 'E9AA4A434C20E1FA32F57489A42DA14CB73C7523B0CAC4C9CC0420D592C18BDD08D27BFC8EFF00AA8C74F071DC4779B3D9F188E3197885A8C25661B49749EC71C9200C941880E32044B303C99B98A339AA838C77B8FA9628B9B673037C7616AE78FCFC4C';
wwv_flow_api.g_varchar2_table(99) := 'F04840C4D5766A18ED835FA2DFBDC11B5D2A40D69C10051E10D62F279525402B5940BE55EFD689074B496DFF0001BB819FE220C2C022A99E65E0C57DD252E08ABEFBCFA25AA0C12B30F2C605A5A17067BEB1CF7974AFBF38847D10A5D796A4E651779D4A';
wwv_flow_api.g_varchar2_table(100) := 'F33E62D61EE85975913358D4BE3D84FEFB4CE81D08CC5129BE8B127A285991D0144994C7EA522D741B1AAEC730A08FBD2E3FF951C8472576DFFCD110ACB58E17B35896B37561166B1B3021A17D25F07BBBC02A28A18A30DD83DF716AB79688ED63D06189';
wwv_flow_api.g_varchar2_table(101) := '8FE31944A5F1FC6B641C4BF582D0B3278BAFC466CBD3B11F7B701A3BB00AD78088EC9D073B4B84A35BDED40CCC069DFE6A50D17181F0CC42867EAC58B0E0C9F2512FADFB4822B67CE2FEC8C1258ABE1240601C2B79EEF836CB5B116EDB0F74C5C50900BC';
wwv_flow_api.g_varchar2_table(102) := 'E9ECB2D8317FE2E29EE4B9FEF11BB7BCB4F7C7C6E4DEE5CC0A2C017911C4C3AD3C457058C1E0D1042E32D9D6030E579947B8D1450D79177E65F92AF72A267A8E98FEBA7FBFC06A34FE3DE604023D2552EC5A0F2C5D4B7B1619C4E2F2537D916B546583E6';
wwv_flow_api.g_varchar2_table(103) := '8630CD60A5E4062E4B56D6252608A7C6E53AC2F07E823B9BAA6D63DFAE0DA168671B8CE8565B29D0A3E4B05DE5399F3E8BB539B57C06E5E4F6603E2EC2170AE5436F652E6A268BDA856442D0CFBB3EF2E29A097C830388788ABEBCD4FD204E5F3EB16C3A';
wwv_flow_api.g_varchar2_table(104) := '4DCA95BF1FC2F1950A12D7B568F0F949ECFAB43C8D7DC6DD83FF005258801C6941F008ED82B39403B66997B101784050567B1A95BCB64BEA231A2D1B60D99D59A60EBBA3B38AB6C70E1B8AD85D8CCAC19B09A3E609283C61F4CC6D17E0AF9B2FC4AEB2FB';
wwv_flow_api.g_varchar2_table(105) := '67FA5881C692904F82075B18CBD2E2C4040769EF674E66B2F71EA730E6E3EADBA6B39787A21129F48E3A85330ED7761BD1D3CF3DF9F940AD743BE8CA6A1ADA925F0FC137658AAACA7EAA7E6A214CCD66670C7A238763E0F335F4591B36F5CB0EBD95DF83';
wwv_flow_api.g_varchar2_table(106) := 'FE60A0F276C1172B850A7DDB2C1404F05F952D64576D0F9A0B28BFA054F9C112360EC06FEDB232E712C55DFF00684ADE8E4C3861AC775BDDC1CF471DE709C9148EFD43FBE9A4FE89CC536F59BB801ADDAF12D40361EC327E08A523B7F9117A4ACA5C0FB5';
wwv_flow_api.g_varchar2_table(107) := '4550AC272D6A1E16359B1DBBD05A72A77CB67C196578E818A7485E5AB97344CAF30422BB5691BDCDBAC07C43AAA03581F517A10BDDBFD4655AD7B0FEE2B709CE79F772C141C99453F6DB156839DB9FE2E624E0C87E193F89A92F62EDE56DA80F83DEF5F9';
wwv_flow_api.g_varchar2_table(108) := '6D9AA2CCD35F06D945DE84A49EC8601129E8E189A810C14CEDD4DC21C1D4E539E8DBD630DF68A0CA1AECCB100B4215EFB90D01443DD98E154D16E1864561BCC61437939326AA97405A210348AF61D1F10D278E831E81CE962BB808A02CFED750040681FF';
wwv_flow_api.g_varchar2_table(109) := '008509C98E5483B0FEEADFC13480D797E0B83FA67FCCC60160DA2BFB98DB4EEA7EEE0C8ADB9C7E235055783F5005B9FEA5CB610D807E62EA650063792362C4A694CD9E819869F13B4D466CCEDE8373F5E9A4C2E768EDCC7A1BF4E957CCD12F295BF7FBBF';
wwv_flow_api.g_varchar2_table(110) := '246B23578D7B0B67C6A5F064557BAB7730C4B29DD16A856E55C0036C1DC6F27653EEC122FA39BA15F100E3DA05C7E0E9D93B998695E05FB1315037B6DF59C4056F72BF93FB62A15F614FC0313393D8C3F306196A878FDFF90EE814F0BF2FF8801962E5D0';
wwv_flow_api.g_varchar2_table(111) := '6382ED4CF679E229CA2E05C0436EFA18E8850081F1A23FB24647717011E5FF00721106AD4F15FDD986D8733843A3AE8EFE9DA1D1D33BCE09CB061E9B7A44DF453B1B84D9A74BEFA65E888A038DB7E25D9B8DB8D30A537E20BB9390BC84FF00866A3BA68F';
wwv_flow_api.g_varchar2_table(112) := '04A5DF88B028C4AC2055D820316C32AAF5ACB44A76FB4514F1BAF2C410295C5F3E04108D806AEABC84A01F69A7961B413DBFBB313573DDBE98007852149D58B5A04B1F14B19478014ABAA38B687CDAC74114C093A33A7BC5D4FEC4AFBE78F75BFEC58FF3';
wwv_flow_api.g_varchar2_table(113) := '0019ACA47E29F714A72E327F5C18581CC21D18197D2413F718EA3A63A26CCD3A6D397D0645A6ED193F882B2D4A2BC45BFCFDB94768575FDB19707E835AF689A65A4FC186FE2156886C4471F312F3485EEB920512C213474DC79B9A36B8B47958B420FC2C';
wwv_flow_api.g_varchar2_table(114) := '08BACED717E6BAECDE5F8E94977652CB0BF9A662346623DB00F8F32C2641568059428B581954B16F17D8FA59C30DB8F2C28F42EA8FC3AC2CAE3D40B5A2FC28C4FAD6DB9E3821B9CCE210E7AB397D041CF4753473D192CD3D5376ABC016C0B962EF7725FB';
wwv_flow_api.g_varchar2_table(115) := '66272B02E72D079E26A6CC224A1125C0504AC6925929C23A79A9582B856A3A8BD2600333B7B9989D277C52AD134A31E0D455DF25EA53CC4C4A9D8A5E803CB049D22686716640E8E734AB85E456741DDB8E205C855EC252C27D986584DB1607C2B3B780BF';
wwv_flow_api.g_varchar2_table(116) := 'A3983B86C1A5B5FB4343C91E6760634639CABF8BA974BE676974306179EAC77D6A73368E9E8EF18D98EBA62272F507401400DCAE08FB1DAFF84AD551A0EE180769F102AE862B8724EDC798E71646D596E59565680B5F1B8AC9B358F2F265F3C58C6BD342';
wwv_flow_api.g_varchar2_table(117) := '094D0DB7DA6464CBF609984005DF62EAEB989AAB60C793F5A30D6ED79ABB1BCFFC896A241282C5AE57BE04396DA3649C10AB420A0AACBBFDDF84BFCE45CEE3FC88772C25B95362367165993C8CFB70773897A1A8CE48C14BE90ACC608EF1639750C23B63';
wwv_flow_api.g_varchar2_table(118) := 'B7A18EF099D89E9C4C2ACBF4E91BBB202F3F10285B4EC7FB31A5870446157D16A6FB930F8EF128F554C94F0271F805B5F5B4933980D0C7C5B1549D38A6BE413BB0FC654B05D9CCAA20A0E38341043B0EA0D2DD35E181A6AF4A7EA3F32EA9B65E056777F4';
wwv_flow_api.g_varchar2_table(119) := '14B4F5A116A15562BFEC1172C75D4351D1393A6CE875CC65742472F1D46C9FA476C4400157B065973418EFAE64571E2ECCF72A6E3711FA4BE5E0F963503BFB01803C119874C15D2F77D895A4AC0F2AE657505BB7074C8BC560D6C7111735016B1B4F59C4';
wwv_flow_api.g_varchar2_table(120) := '79BCCB8D809147AC7895AB9A6D943200F0C3D8ED2F21668EEB00C76540D55EEB21AD41BA4E161829589F2738846D6A215D941357295401007DD714F86522C30F9F78CB08C09FED11E6E3B4F068CAC135E8B1D1C909B3D06E728EC4FEE8ED8EBA1EB593C4';
wwv_flow_api.g_varchar2_table(121) := '770B2288F2CE9719CF262217C07F0133E2610447B24032D4CD651655BA2D9CF6FC4BC47D3030777625C551B320388BA295792EFE91B40A0003B4681ED81DA2764AB29B5917E04C525687EFFA10D5A0E3AAA7E6A281BAA143B33EE986305A6982AD5DA031';
wwv_flow_api.g_varchar2_table(122) := '43B8343558544922BB9235AF6CFCB16AB59696B45FB8350A94B36B2A29058C14D96EE536A0AABF3DE003DEEE82D0D5253E221EAF39ECC670134E86A1B2727476F549CF43B4D58ED1847A70438F11DC4FEF60C080D032289E70FF0071378A3B9D8B986541';
wwv_flow_api.g_varchar2_table(123) := 'D74F652E96A2F916DCA6EDE72CCBFD1EEFB1DD63D50385C1FDB18470E38F9744BF88A90423E50BF83134003D8A941F38A290988F5D39F11032B78A73F30D2E10C1B57EA3C15B7E0C1D8560A730829140319DA9F232C3660B6D8955128CE76F782F4F53DE';
wwv_flow_api.g_varchar2_table(124) := '58848C540ED0E9004288D899F01163A8C7089E74C18F9E8BA1B41CCE7A6DD58422CBA764611E8E89A1E231144813C57FC464C0D6A92ECA3BE65C72C4BC1CF0409D2E981389A3CB0BE6AE6B40683D88518A731FD898DD7DF0F6EEF76235A7CE8F842420C0';
wwv_flow_api.g_varchar2_table(125) := '144BA62E12A1A4F110F7FD55F8EF0C1C0DA8B616078480D352CC54D2E660897DF3132ACEE26B17ABF2464CE6EC53DC5B1AFA57C953D05CE63706E43636719008082926B2FB3DE1DF709E230443A0BD5F3510F008C235B2DBF2746E98DB64B6A5D11E8698';
wwv_flow_api.g_varchar2_table(126) := '6CE8CDBABD5D3369CA72F41D1383C4A868AEC4241CD4E3B77B34C4809757732C1B0C27B41E66FF0002118BD1547AED10AC4E71AD67C2DD12E4EDE44E63ED2B482E932602531EF2A83C4320E356B94D5DA5FC10237B9F95B7E16BE151B40028A951002F57';
wwv_flow_api.g_varchar2_table(127) := '5716BD04DF8822532DBB029D8ABF252560E9D79DB0F3254772A525EEDC244D1BB52F605BBA9DBCFDE32F0DF8611006DDFCC2FF00BBD4DCD19A8BA9DA3D3886CE8C7ABD0D91D3D077368477D1D1367C44F981EE8E6A1E6CA0507C133319C18841AE5169EC';
wwv_flow_api.g_varchar2_table(128) := '75453C4A1E299408586C8368E1E5E6525A286224BEE2612361B82F80ECF68042F25B32D0630EB896F245336F20FC11C8A39063CECA3AE29E290C7E46535BA12A5BF95EC7CC470942B8F112A205E92DB6515F66262E44500380D4C0EB10AC9D02CACEA7A9';
wwv_flow_api.g_varchar2_table(129) := 'C74630DFA0466ECDA6CF47A3A2117514FE4651BE22EFAEBBF23CB16F1964557A9B415EC92F15436BE29717E74901009767C277609BF431EFB389D990C3AA02825E2F5107BD1EC7742E922A7F603DDC12BF97A319AB427EA20A445207DC7DFD88F60949B2';
wwv_flow_api.g_varchar2_table(130) := '74339FB806B760623F63EC5D7312220A25FF005277EF31A965E48630E2F677F2CCB084E2AFA2E5C303919FAB814CDB02D59BAE82BA9DCE7D5CC3D03210F336E831E8E89EFCA5F832CA19F07E63B4C929B7C5DA15011C4B6FA5E48CC097072EBB04348528';
wwv_flow_api.g_varchar2_table(131) := 'DFEDA21AAC45E8F7D7F2864C2DFC3A3102130F2E29BBE3D8951D95317F28607BBB80251E87E9CC27234362F270112588B9049D004D3C1D803DB1884196E0E1EE7BF9265E1452E0EFB6D1F994FE60001D8098A916BA342DED14486D15C0E8F11DB1E27786';
wwv_flow_api.g_varchar2_table(132) := 'E2CE0E8C61CC23BEA546B394D9E631EA06C17222F64D92DE945DAE6888A52072F1197DBAFEDA84064DA32C07D62ED2FC72C2280ACC8EC5B63080A01FF22BBFA0D02CD0626081B05B5C05D1D8269055009C1BA434A02A7F0683B1114D99C83C59EDDA0BB7';
wwv_flow_api.g_varchar2_table(133) := 'EED7F53390AF250FCC31AC78949661021BCDA3FD4B6C890B9CCE13E2731E9E7A2E89DA3EB2349B3E26CC7518E04544B3C108E902D232E65D10FC4799403CF1E20D26B53412F65F87E04A70F35A7D09403D8743E0DB064A1AB15E0B6104396C5D3FBB6FCC';
wwv_flow_api.g_varchar2_table(134) := '6E615816FB2FB47D7EB89FBB56A8265A44B8E816E080FD1044C709C74FDBA66CB4BA96B461E4C052CD88661C27EA0B6C5822CC76CE269D59DBA3E920E5D0D9F11E7CC7440E4E01D0BAB66CDEFC0763B12DB875BA6D63CC524DA5B032A9041DE0CFCD7186';
wwv_flow_api.g_varchar2_table(135) := 'B053145ED64237EC21F9DA1D7C3D21E0009456A982DA38B7A1A74023CC35162E04E1F46D379BCCE9D04326DD070C066A47AB20EBDBABBF51B4D66CF88FEE59AE63AEC4DCF0F78CFAC9BBED12A082C689BA63EBC08AAF9D10450DEC31C622AEFA11EBA226';
wwv_flow_api.g_varchar2_table(136) := '1398F338F99AE9C7477D378DACCD1E234261D11CF4A5452BA319A7439EAC77EB1A9CA1175B8E8D19251A7B24AB4D86BA3E129350A8FA9109206B3B8A048D92B095981DCEB6F46D34D436F99C4AC47A70F4E0F73A5D329D20026B3FB202F1D2C76D4EC09C';
wwv_flow_api.g_varchar2_table(137) := '23D1DCE23AF53B7D4412810962D19C4B01FDE3DC97BF3AAF6E7BCA1DA7C73093AEC2107EC3CBFC1AA3B4C11837F11E86DD1E099B18C143C12C0F30D264DC5B7DA5B539C7A8E8F41D4E671D39E8FA8D464A00658A179C746BFC4802A003ADA951D474FF00';
wwv_flow_api.g_varchar2_table(138) := '008EE72C350DFC44CA712F1502EA6E4DA02EBEF0532D6FDD8A729C44C4D45B394564263A9E239129B8EA7339FE03032DB40655EC474AB190C879EEC76CE58CDC7812B480B064668747D7FB93967786BA6C9CBCF42056583E20274C080C4A43BC7046BF13';
wwv_flow_api.g_varchar2_table(139) := '420904577710AE9B45BA8E895963A9CF4EFE87047560A9C468EC862797CF63B13595961CCB052D17465C46BA183B0866C57C3EE43FE2B1873E23EB1736A436F9971DE6E9C745822E182431825CC8A9C18992595EAE102AE3AE9B12E71F13863A2724E677';
wwv_flow_api.g_varchar2_table(140) := '9DA0CF750A00E56681AF4FF9455D8F80E54024840372793C4A1AE5B60883348EE302516273C2D1387BF866658F60DE7922EED1C57ACDCE50DC7FB32C36CDD2B0F434C76F427210C0590DCE58E5841A4F10E669D1DC596CCD4789CCE7A8AD627EC26509FC';
wwv_flow_api.g_varchar2_table(141) := '0DA4F24B93677F0C0AF8FD91D9F784F4017E9EC4C18230EC4128049D069DA2922A769B5DC9531D753CDE7FE3D7C9D2399DFCCBCCB8732F7D3F7880F5DBA1E96DB1874C45E9B4AE847A731EB434095FE6E278C6558BAC227794292C4009D02EF8EEFF00B2';
wwv_flow_api.g_varchar2_table(142) := 'C65345D0ADD5771546272F4106AB98F1CC03E621DA5F66E5A71B12EFCFAB920E8A95D93B47AEA2FE63A75BC90703D196F4353833D13075567A68C3A73E83B665B0AC389C7DC8AB9295C07FD8621EAF3278F12B08C49C108F7787B42E98C0DF8F4438D1BF';
wwv_flow_api.g_varchar2_table(143) := '075291F231DB7217E7D4ADC5FD7A1173E825AFAF62683A3CCBE81C4AD79E86E8E9B74AC2C3550E9CF5277E97F5F09E7FD3285DF70F7EF34246A67CFADFE4DBA8E23BBFEC959467B053E1D0DF5E48B06985D8B865E8EDF41A9A3A1B8EF11549C4575D125A';
wwv_flow_api.g_varchar2_table(144) := 'BC41544B9C3ACD41C30FD757A93BF4230CAF48CA670D880F0B9E9B475398F1D18334DE09EEEC97A3DDF4F31D3086DF136E8EFA54329126E798ED99C72CC371C11D1063963C2C2DB8699A1D1F470F470CED1D4BC79E8434F4EFD7623B746C75A1EC886D99';
wwv_flow_api.g_varchar2_table(145) := 'B8A987A08A0622E28116223D7547738F9976B369B60C314AAE873D2CA9EF19CA3AE9656E14B9CA267332DE2EF3808168E1CE69FD48DBB4D3FA12956FF447BE9EEBE888AB964B9015926BFB1155CE36EF17FF008205CE5495FDDE8A482F9EEE3DF4537F16';
wwv_flow_api.g_varchar2_table(146) := '263AB42FABC46CB4F75312E45217D4B75FD097CFD48AF298FF00C9329FA12E36E3CF2AF9C6AE12972A8D22BB51011CF317ACE7BAFA22AED0C19C73651312D3FE09EFFA0DA31DF563A25170A8F57A6E4194E63BE8785CB5ED2F56CD8C4EFF009D0B33AE86';
wwv_flow_api.g_varchar2_table(147) := 'E3D324BB49758F437191435D094BD1DFD2303EF1DC5C63A7461AF99DA3CB3FC847FE34C1FAA2A8DC7BCA1EFF002207C316E50CB94B67D83EE7B47DCACD7DCBEFDA0EB41196B93F02292AAC558A3B1F931E3D247A71D39F41708E5FB8BD060E897E9AC213';
wwv_flow_api.g_varchar2_table(148) := '4CC62574DC3F52FF00B8C68C5B2FC5CAB343F6E8FB71CD620F71B13DE58D2CD1DE2548334F7E7A3D754654377F68CAE9EE95AED22DA5D2C727BFB1090280A0E845CF68CE3A1B9FA74AC43D2E6041D08EE5FA45C12C486D799840E8857A1BEBDEC54323B0';
wwv_flow_api.g_varchar2_table(149) := 'FE9388BB625217186A80963C364E9CC7A9B9B4E133044457B8C65C4AA2E5EE6000003010658281065F11A03EA1CC36B367A49B9A3E7A11F50EA709C43A512514CAEA57E6596470C1C1ED3149F47575349D6AEA5C2F77FA8B2F5F78A175F6874CB4CB92E6';
wwv_flow_api.g_varchar2_table(150) := '35E575DD9AE1806ABD79F42F6EC451E3AF6898F351D3D39F53B84B0A60C1D11A86A0FDBE8B858E399ED63DACF633D8C61F633DAC4E86E52266976B9894BF72B3792BD0717D61E2BDFD6746875351D7F08F5317383A1A669E8AFE114AEE5A9A6C652A0A6E';
wwv_flow_api.g_varchar2_table(151) := 'F12BEF069EEC630C24F4623DF3D20FB21C8FAC84E3D0B08939FE3E25C2347C422B318588D5DD132A87DC11FD8C63BFFD29ED47B5F467B11EE7D250EFEB053506F188F23F9896D7EE5DCBF7379C03CCFF00D49ED7D6157F6A8B4BF9A21BFBD857470F31BB';
wwv_flow_api.g_varchar2_table(152) := '92CD68975DFD46FA38EA47204673EB7A26BA1D3445C7C4F19A453187B1C472FB616CE24A4F653D8CF691EC27BE7DCF0749662EF1F73DD3EE1D8FDC5B8428444F6B0BC708C9F8C16127C33085DD621400294A7E47D63E8271E268FA9F4210E98EF1D31D43';
wwv_flow_api.g_varchar2_table(153) := 'D051DA750BA8569C300E5F64F7FF006468B03BAC2335FA3A42B99E14468F9A67B65EF90CC0F92A690F8316C9F249A3EA080ED7F33DEFDB01FF00B7A14A7195C151CC5B01E0FE51A87E47A48EFA9B25DA4ADCE50B118EA6938461AF881AFE236478E9B7A1';
wwv_flow_api.g_varchar2_table(154) := 'AA3BFF003134475069E63B7D09CCE3A1B26A0770710C474A61D0ED3410E3F88D90D5437373C7A381FE6373B4D62F231F42DF5D8E913534CEF032435318735121C7478FE0C921C9D3366E3D2B0FF19D486BC30E0958FE022CE2E26B11C3392059D3AD4D08';
wwv_flow_api.g_varchar2_table(155) := '6CF1D1D1FC1AA70E9B10EBA7F1F1D7474DAE9CFACE87106107E53FFFC400351100010301070302040406030000000000010002110304101221314151132061053022324052237181B106142442549163A2F0FFDA0008010201013F00F7AD950B29402412';
wwv_flow_api.g_varchar2_table(156) := '56379DDDFA3975AAB74A847E665599F51D4839E666EA94CBE20A7063297C64054982A02FDA722AA0734480553264CA998585EEDB2E5747C8B8EBDDBF71D55B9E4D4811F085F9FEC53C81202B012FA0D109B480D5616F015BA9D021A0CE33F280A953C34D';
wwv_flow_api.g_varchar2_table(157) := 'AD3B0418D0AB5A28B32224AA5680E24010A66E1DC56FDCE21A093A00AAD7C4F710352B113900ACF6073A1D5240E375418D6E8205CE700095D273AB751EE048D154AF4A9FCCE12AB5B5CE043042CE4925372320E6A9D50F6E512A4A0B7B85E6F1D9568D4A';
wwv_flow_api.g_varchar2_table(158) := 'D4DEC6100908FA474E31D499E02A567A54BE560B98D802EB45A18CD4AA96AA95098384233710B65449EA3407019AE9B7EE085E2F3DF44644AB4BA5C07014A60975D69AC29537393EA3AA3CB894D63DE40682532C350FCCE011B07FC88FA7BBEF0B0318E2';
wwv_flow_api.g_varchar2_table(159) := '1EE2338E3F7401D01611E7250EFF001BFEBDE7BDA21A0784F74BC9BA9B61A8980AD34CD66113099607170C6442631AC10D000BEAB8B184E4BAA63E2691CF9FF5299429E1C6E68D321A7ECBA4CFB8FF00EFD3D91D84968909D5AA3B7B9A248175474E5786';
wwv_flow_api.g_varchar2_table(160) := '139EC891B5D68638B25A7307854DE4D500B4665568145F20111BA1D2E59FEAE178DAFD90ECA4D05AE9DD55A658EF1731B02539D02E0094001E4A21C737180891B5D68B43285273DDFA0E559ABBABDB59B092435546E3A6F6F2D85D5AECF87A84465EC8BC';
wwv_flow_api.g_varchar2_table(161) := '2680D68568AAD230883E55366232744E3C6A8309CCA0C01689D50681124EAB4D4AEAB660495EAD6873EB8A7A35BFB95E9A3FAB073F94DCFF004EA4F7B9DC99F63642F043733CAA955CF3E13185C7C200008DCEA80273E7528D460D5C13AD03FB33F29CF7';
wwv_flow_api.g_varchar2_table(162) := 'BB554800CC4557AC2A5779E5CBD25B168CF83177E9EC7285EE93904CA5BB90B9CF6B55B7D468D99B2F3AE8D1A955BD6ABD404526006093BC04FB4D6A84752A621CAA95EAD4188974CE50725E9F5AA16F4DD4DD91CA02142A93F2909D6773A939A1C04884';
wwv_flow_api.g_varchar2_table(163) := 'CF43B3082F7B8AA160B35032C667CCCAC238178EE3BA174A68CAE75568F2AD5EAD4A99C0D38DFF006B44AFE6BD56B388A767201E41109DE93EA5683356A31B9267F0EE86A5A49E400A97A2D8987110E71F2553B0D929C60A0C041E1401B5DB5FC7B25044';
wwv_flow_api.g_varchar2_table(164) := 'E49AECD078D9113AA2C61C88109B4E9B3E56347E43B8E976CB6F6CA94420D2530476943B0ADAED90BC7738A170EDDD1F60DE3B4BC4A2514146481EF1ADF1DE3B5C20A06E02E70CD34F76FD87B823D844844414D04042E70C9375F6C6B78F6202285C744D';
wwv_flow_api.g_varchar2_table(165) := 'D47B274B876C0E02C2380A070A070140E0281C050380A0701068E0281C0555C3410A8892A070140E0281C050380B08E02C2380B0B780A1BC050DE02C2DE0281C050380B0B78083470140E05E4C02575CF0BAC780BACEE02EB3BC2EB3B809B59D2253EAEC';
wwv_flow_api.g_varchar2_table(166) := '1005C531A1A3DE1D877442850A14284DA6E72630342DD6FDA3BCDFCDF8470B0B780B0B780B0B7809F18C055032151395DBADC7D0935654D5F2A6AF95357CA9ABE510E3A82B0BB828078D257E2F95F89E57E2F94C2E8CFE861405014280A140503EA77FA0';
wwv_flow_api.g_varchar2_table(167) := 'DFDBE3E84DDFFFC4003711000103010702040404050500000000000100020311041012213141510513202261813242527106143091152433A1C12343536272FFDA0008010301013F00A954CAAB12AF82872F0EE80C82E8567EE5BB1900B582B99E510D1F';
wwv_flow_api.g_varchar2_table(168) := '401C1653FC210C4EF8A26BB92D690BAB18DB6A31C6281A0039D73BACB68109755B50509DEEB4636026BB236A6411D5E48F41CAB3F5586790318E6B5B8B571A2EA41B81AEDC9A54F0ACCD68046415A3A8D8ECECA8792F0402D5FC45AEF376DB9E79908A6F';
wwv_flow_api.g_varchar2_table(169) := 'C3ECB747C14A37C4D3E55F87E06B2CA5EEA92F3A015C82A914C23F7737FC85034B802F196D9835FD975B869D4DE19F300532CB1B479B32BB71FD03F64C6B5B5A3405344C9DB478CAAA2E97648CD7097718B35174BEFB338DA19CAEA5D32D1D31C2563CC9';
wwv_flow_api.g_varchar2_table(170) := '0BB2269982AD0438E215D333EA554709CD40641655474BDBA8474544E14F044C73DED63454B8803EE5596C1DA822638E4D680BB6C6D09769ECAD7D558CAB61A39DF56C130BE49A599E4924D11BAB928ACB34BF0B0D39D959FA731843A535556D00634E41';
wwv_flow_api.g_varchar2_table(171) := '4F1B6689F148C058E14705D53A4BEC169C2FAF65DF0B96285B9769A69BE49C81C82A669D7B0668E8B84EF0582D7058ED50CF330B9AC350072ACDF8AFF38E904567C3840CDC54D6B9E73E779A703453CC59E56EA546D2D8C0BA182499D468F7D945638621';
wwv_flow_api.g_varchar2_table(172) := '52311E4E89B4A2C935DB0CBD965886A575386CF3599ED9980B6997DFD13BA3B711A499553B443640275EC08A28E885F683E60380BA1425B0C921F98D07B29666C7F750032CF89DB2D8A86232C8D60DCA8A3644C0D6B744F7B2204B886A93A8C43E069721';
wwv_flow_api.g_varchar2_table(173) := 'D529FED7DF347AFC2D753B2E527572E03B5103EEA7B4C931C52170E00CC2C43FE6FEF7844237311456C86A8DCEF33CFDD412B60B3451B06602738B89255959823AEE6EB34DD9943C8245149D4DA1BFE9B4D7D54923E47627389375AE7C2DC0352333C269';
wwv_flow_api.g_varchar2_table(174) := '7191AC682493AF154230294704E95F5C00EFAAC6EE05C4E6B6B8EA826EB7390D10D42705131B23C349D547648232086E7C9BA2617C8D6FAA029923E09ED21808653122C99F53424AB2D97B50F9B3714F6D18684E4142D2656004D49471F0EB8EAAB95C75';
wwv_flow_api.g_varchar2_table(175) := '3F7B82DFD9397CA82768A47B9AE610742ACD686CCCAEE35175922C2DC475289BC9A04E6CB26A435B5F744C426786333DDC4AB3C785B52A18CCCFC2D56B823B3D8A5C23334CD46FC1231FF4B81420B3BFCDDA06B9ADD38E686D71D6E0BE609CB6413B409E';
wwv_flow_api.g_varchar2_table(176) := '4B9D972AC36691AFEE3AA06C395678719C47E1081542800AA026CC1CF21BB0CCA95E1AC738EC141039EEC5415A8AF29CC2C617BA805174B67F2FDC3AB8E5F60BAAD4D8CFFE822A3EA93B18D68D8008EA515C5C753705F304E5B20BB6E9086B78567B2C70';
wwv_flow_api.g_varchar2_table(177) := '8E5DB950C05F99C9A80005026DD25A18CA81995377DCCC479D158627961760755C57E4F18A48E2D1E9AA86CD0C230B000372775D4652E94440E43556688C7046DE1ABAC1FE572E45D51C8B8DFBADAE03309F705648CBAA403C28ACBA17FECA94000173A6';
wwv_flow_api.g_varchar2_table(178) := '6306673567B2DB2DCEA46DC2C1A92ACDD0ACD010647171C85532CD0B1BE48E878D53218E338461A53356FEC46EC7DE60046757019A93AAD8636D0CA1EE1A5335FC41A2D0242D2EF3578AA93F125A8D4323637FBAB4755B6DA061925CABA00022F7919B8A';
wwv_flow_api.g_varchar2_table(179) := 'CEE76B76DE06EA13D141A4006868AC9176ECD18DC8AAFB94FB43064332A0B15B2D2DC6EA451EEE764843D0ECAD0E96D6D73870E0E47F12F4A83FA51C8FCD4BF8C4E7D9B1803624A9FF0013F5490616B991B7FEA14BD53A84D8BB96A948234C592AB8BB32';
wwv_flow_api.g_varchar2_table(180) := '4A0468A9E70B7F75955572BDDADFBDECFF0009CA36173DA30D73458D20348CAA14DD51B1D0088A97A94F26C005F999F50F20D76C93E69A4357C8F77DCA1A21A237B75087C4BE65BA1AA390554774ED6E0B73704C4D86A6A534E14F998CA54AB4CA1E406E';
wwv_flow_api.g_varchar2_table(181) := '82EDAE6E9EE8272177050A2F996E86A9C6E3AA722878208B728A2A57623A23E01A209DA5C3454D16E50AE68A6EA8E79DC4A28A1736C8E2CA9342A3870E6ED5313A8136605F45345881737547C1B0413F4BAB90588A1AAA668A6AD97BA7A08DC2B50A1944';
wwv_flow_api.g_varchar2_table(182) := '8CF54E6D55709A952C85C7D11D542FC6C1CAB43035D51BDE16C11474BB65BA6DC50474B9DAA033BC6A99218DE1C131E1EDC414F235CF0D1B228EAACEEA3E9CAB48AC75E0DED4365B2376C820689C72B804EB89F32178D514D7BDA0804E69BAA28EEA2CE4';
wwv_flow_api.g_varchar2_table(183) := '6A9FFA66F1A207440A3A9435446486B73AE09DA5D535D4AA9553EAAA792B3E554F2AA7D5026BBA713C9553CAB246EAE33ECAD6EA46072554FAAA9553C9552838FAA24D554A25DC9409AEAB11588F2554F2AA40D4A24E4AA79475B9A31380E4AFCA37EA28';
wwv_flow_api.g_varchar2_table(184) := '591BC95F9467D457E523E4A1658EA35525959424135A286CD5CDFF00B2739B1B6A720A594C8E27F40F888CEE3734D083EB754A08ADEE9278E3CB52A595F21A92BE554CBC26E3E108F871BFEA2BB8FF00A8AEE3FEA2BB8FFA8A871981C413556674A5DB90';
wwv_flow_api.g_varchar2_table(185) := 'AD6DA3C1E45C745F2F84DC7C7ED701926B6CA00CEA561B2AA597D161B2F0161B370D4D744D140E0BB91FD6138C0E3E620AA59BD152CBE8A9655308C3AB19CBF5F640905622B11552B11588AC65622B11E554FE98F050208E9E3D96DFAFB2A5C11D1728F8';
wwv_flow_api.g_varchar2_table(186) := '762B6B878C6DE31A1BBFFFD9';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784241336296151266)
,p_file_name=>'img/discovery.jpg'
,p_mime_type=>'image/jpeg'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/img_hr_jpg
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := 'FFD8FFE000104A46494600010100000100010000FFDB008400060606060706070808070A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA70106060606070607080807';
wwv_flow_api.g_varchar2_table(2) := '0A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA7FFC200110801A401A403012200021101031101FFC4001C0001000202030100000000000000000000000102030704';
wwv_flow_api.g_varchar2_table(3) := '050608FFDA0008010100000000DD40000000463B5A5000900000001120891312426509840000000104890131242A1210908260425201248226111200089100249000128422512084820089121202624820026000226004CC0B44A2626244104240040265';
wwv_flow_api.g_varchar2_table(4) := '122408130009A8009022528240043ADD51E9762809A4992AA4A420989844C801E43C46C7EF9E27E75F2FF6E73022136E4722D6E3471EA2026212984C1283CB6B3E97E80E6F8AF0FE2FEA092125FB08CF4A63C94E25408049000F37E775B7AADC1C4F11C1';
wwv_flow_api.g_varchar2_table(5) := 'DA821273B345AFC79CB86BC440226A244C4916ABCE69AC5F44BC7F41DEFA9E6084F3F265ADB87968B5789130089261330075FAF7A3EBB6D66F3949EE3D5883B38226914CD671B15102094809ACF8CF218A7B6F55D2530771ECC0EC2B6C6BDB1B35B0659E';
wwv_flow_api.g_varchar2_table(6) := '3E2E3A104C824886BCE878DEB7CF7792E066D8B9C19EF52D9AB5E4570E7531D38A88924908381AAF271799E9F99D3B89D46D3EC819A705204B1788C1EF394D67A5B74ECA0984979538FABBD5759D676BEF7CCF4AE17A8F419D24541C5E9B3779E0F54F9A';
wwv_flow_api.g_varchar2_table(7) := 'FA4BD3C7C9B4DCFB39132988CB144F5787B5EBB5F5B0EDAF05AB73743F4A75BEAB188810F05C6E7FB8D75F3D6CDDC3DE35EF90EDB6E2125AD4B823A8D759B9BB23557CFD387EC2F25B43844A01E0B0765EA7ACD31B77D318BCBFAAB8B2D316B52D15383A';
wwv_flow_api.g_varchar2_table(8) := '979DEABD6E9FD0D967ED0B763D7265508E8BA2F51D96BDD7DE87712393DC757C4826CB44D2D169471750F3FD3FB2D4DF3F66F4FF0054BB0E0A254983CB7CC3EAB727AED1311B4BD8F9AEEBD5F13AB985AEADB1755D5C2F9B9BDAEA0E57A7F5DAFF00E65B';
wwv_flow_api.g_varchar2_table(9) := '7B2FA9997271A2D152787F27F437E77D19AF38D7DCDDC69FF77B33A1ACCC642DC4E870668B5A94B78EE276BB3FCA7C95DFF4BF54FAFB763D741598695D5BCCF2B9BE83F27D672377F59D16D3EDB5FF0097F599FB1CB762F2BD4F7DC9CD2AD38DE77C9F6B';
wwv_flow_api.g_varchar2_table(10) := 'EFBB6F8B7E88F9E7716F5761C022261AF3E7DCFD073BDE7A8F35C9DC14E83A0F47CBEFB8BE7FB1D37B5B63F49F2ADFEA7B91359E8FA6CFDEFA8F8EFE9DF9EBD37D08E7F0A924A1D77CA793687BDD6DE7B9FB5BB5D6DA9B93DFFD2BC5E5F97F8E36AFD39A';
wwv_flow_api.g_varchar2_table(11) := '6748F7BF519116AC53ABB737BDF9B378788F35F402FCBE0901D66B0CBCFF0061A87A4ECF69F65E6F42F29BEFE4EFB17ACF93395F6A7CC9E5FD77D1D6C3065534BED8D47F416ACF5FDA6A5DD871B930891C0D5DCCCDEF741F25B42FE7F46762C7ADB6D7D3';
wwv_flow_api.g_varchar2_table(12) := '3F1360FA2F4AD7626F79C6E1F414EB3C4F4BDB75FB2FC9761C6E0FBE9E1F9AEDB062DE421AE3879765FCFC6D7F5BA8F477699F1EB69FB1B42F83EE17DBBB898A7A7D53C7A226505812FA3D098D75C0CDB3B45F4B837D779A9B467D37A4B2EB8F3FB233F8';
wwv_flow_api.g_varchar2_table(13) := '5ED273FD29E8ADE03AED99E674EF372CAB266C13298B53E9009D6FC1E66C9F9E35777FF5CD7E6DF0779F4D9350E7E6F61C9A6C9DC9C7D11E3F3FD49DC6B4D6DD872262442F09B3E8D44C575970FD17B3F92BCD6C7FA67587CEF499F618F55F2F99DBC67F';
wwv_flow_api.g_varchar2_table(14) := 'A4BAAD13D6C6EDDAD4E1687E0E4CD6ABB064C68B0FA450790F2FC5F77E3B42E1DD5B97E55F3B8E7B4F53E43C4F3FB4E5372FA1F9F704EC9DE77707896B703C5741D172B9D7A26F498FA48357F6DE5F6A689CBE4F78EAFD693193E9AD57A47373FB273B6C';
wwv_flow_api.g_varchar2_table(15) := '69CC75F7DBBE16E5F75971AF3E4F49F070E5EC2E1F48A0D4FB3359ED8F99BE86D01E9F4B42FF0042FA8F9A3C5F2FB2465C52F69BF72E4E4F2B978E17B5697E2EB9D6DC0E4E5CCBFD1C93C1FB5F05EE34DEE5F9ABC556677D7A6F92BDB62E275C18BBCFAB';
wwv_flow_api.g_varchar2_table(16) := 'BB04489B4D6969A3AEF99D5E673DF4807CF5E83C3F65E3383C6AD6DC6CBD7E2E5E5CF13645FE9FF771094C44D626D8C684F2113DB5BE9298F39A1BC4D6248A5AB59B11131736CEFE994AB25169A0751F3AE2C57E5FD3AD3BA3F04C4A6615C9499B42B53D';
wwv_flow_api.g_varchar2_table(17) := '3EDADAF94A42CAA6F5AA60782D2527D51AAFE7BB45A30DED16B2AADB256279BB6F6AF712174128A0099D1DE2697FA77E47EA6B2A325B119283256BB1FE87E509100000E17CD7C46C6D20A5AB3368C77416ACB9FF005B76200000246AAD5AF3FD6DE62A4C';
wwv_flow_api.g_varchar2_table(18) := '4CD24B52CFA2F65930004A48091D6FCDB5F1765A2B6ACC4C44C5E2FEC370EC298008B4244A135B0878DD17E3EA5905A25DCFBAF63EABBFCE1304C0424900149D2BA513499944FA3D97B0BD28130251280984A71D70D1832713164B713E4F2B0B4733E85D';
wwv_flow_api.g_varchar2_table(19) := '8C2B4C187062C586B9306162C6BCE063AD2F7A522D69E4B1E7E4668CDF285324456D7FA07D94F1F89C6C16A22626D6C716A4DA7152B5A5AF1870D2910A42B15A69489B63B5770EC0BDA508A5E96A4C56298A98D49C78B1E0C38A89412034BD16AC7B3DE5';
wwv_flow_api.g_varchar2_table(20) := '4B5D36AE34DAA8E3634538FC7C3870E12420024696AC5A795BF79A8BC62B5217C38698F1E2C34C60000120D1554CF69DF4AA85229100204A2C2240007FFFC4001B01010002030101000000000000000000000001020304050607FFDA0008010210000000';
wwv_flow_api.g_varchar2_table(21) := 'F340002B604888900813129908800404C9312150020926402109894909031DDB9A882D966B4A84481AD8F6299A225B36888A5441216D69E2E7EC21B282D4A5612074ADCDF3597BC2F54CD6EBE1AC8965BD34787B9D792A8F2DDDDDB5726B65994A1C2E6F';
wwv_flow_api.g_varchar2_table(22) := 'B0DBC5AB6211E5BD3D59BADCBA2D2ACCF0F4FD675F9FAD428E97A4F39C1C97F43CED55A9E53931B7D08F5BD8D2D1BD147A8DEE7F90B47A4E260DA9E7F9DF3B58DFEC7A7EBDF95971217F45C3E7C65CF5CFB7876FC1F92C57BFA9F4FB2D7BE39ACCF5B4B9';
wwv_flow_api.g_varchar2_table(23) := '57D8CD3D8D0DACBF32F337F7FD1DD618CD333A27574F1C46EE0EAD6FA5F28F5BCCBFB692498E72FD5D0E9F337F634776CF33BBBBF25D5FA0766F6913CF6D66C3932EEE1E775E18DF38D6EAF7AD37C99A65CE51BFB5B71A7B317972F5129AA33E7B4F3B77';
wwv_flow_api.g_varchar2_table(24) := 'A179402BA5A08084EDDD8FAA4C4C14E76A4244064DB9DCCB12894395A720484ED5FA5122B830EB6B044A6413B1D5930686B2F7BDED3649098463AF512464BC8012248D632D809252006BC4E5892D090001FFC4001B010101000301010100000000000000';
wwv_flow_api.g_varchar2_table(25) := '00000001020305040607FFDA0008010310000000E98000B00940000401400524B0B255001608012A880103DBE69B7404C2659596500EBFB387D1E429A62DCA80433EFF0017ADE7E52B504B95A40BE49EDEEE3C38B8D27AB4EBCD2E3618DCB7F5F5F235AD';
wwv_flow_api.g_varchar2_table(26) := '3BFCCEBF27C5EFC7C5096BB7D1F94C2FA3CE53E8B89DEE6F33CDE8A919476FD5F31E6DD9E45BE3E4773F50E3FCC72F66D933EDFBA69C77FCAE8CF6E3932717CDD0FD37C9C1E3F4AF9B57B3A5BE5DB97CDF89BB0CD49EFF00ADD1F2FD1F0F371B3ADD0CF1';
wwv_flow_api.g_varchar2_table(27) := '6AE2EB4517B9E3FBAE47CA74B5F07393B9EE7234E0DF7C9963076FC1F45C8E75F5F1AB77D371F7B99040B9F6B97E9F0F9F5FBBC2BD1D5A3E877727C16023DBBFC8F1EBBEBF1D2FD267E2E6632D03DBB7C1E6C5B316359E6455061AD005CF302830D49417';
wwv_flow_api.g_varchar2_table(28) := '66680A459A6006DCC0804BA00CAE7900404BA05D994D78618E12214B6E79E469E635E082A8820FA24E3E80088003BD30E7D4820000FFC4004A10000103020205070905050704020300000100020304110521101231415106132252617191141520303242';
wwv_flow_api.g_varchar2_table(29) := '81A1D12362B1C1F033344053721624738292A2E1435063F13560648083FFDA0008010100013F01FF00B066B3FF00F542DFFD82AAB29A8E132CF206338A9F9694AD36869647F6B8EAFD560DCA2831291D118F9B940B817B823D6D8AD475AF65AA78220F0F';
wwv_flow_api.g_varchar2_table(30) := 'E3B12C45F4FF0067136EFB5C9E0A3C66B9AEBB9E1C385953E254B386DA40D71F74E5A71DA7A69E958D999ADD3E8E76B2C4B0E640E8B99B9D736D5ED579E967046B32461BF682A9E432D3C321DAE8DAE3F11EAF540172B66DDDFF00B59D80B2232F82BBB3';
wwv_flow_api.g_varchar2_table(31) := 'B648B05B6FE411047F1931FB6785594CF8A473F2D573B25654D7F2786FB751BF868C635888C16F43F34E8D8E2D739A096ECEC52615256633036C79B93371E01BB50000000C87A9009D816A359BF356E36BEE1C1342D7E95EC9C4FEBF5B95AFE3FAF8A011';
wwv_flow_api.g_varchar2_table(32) := '037A233FE2E48DFCE1002AB839F8C8F79BB158AA4C5EA200D63807B065DB64C707B1AE1B08BAA9A715116A136CF6AAFA01044D918F27A40381ED5452886A1AE3B361F5518CBFE0AB676B5BE67C1760089198F140B87C16F400DAB5B259EEF922DBADFF00';
wwv_flow_api.g_varchar2_table(33) := 'C467A6A00E74F680A40448F078A68D6786F1364C6EAB5AD1B8593DC1AD2E3B1554E676EA1166A10341DA4A8EA248F61CB828666CADB8F88F50D69B705ACD6841E16AF0F92B6D2B77C7F05ADB3F5FAD9A73B847A564411E95BF83A998430B9FE03B536A48';
wwv_flow_api.g_varchar2_table(34) := '0EBE6E26EA58B9C25DEF2F27901CACB0D9EA2688F3BAB96571B7E2AB89D56B789D0724330A8CDA5B711EA375D3C6E1C48FCD5F3F98432CC7E8845E7612ADC7E2ADFAF821B3E2B2CCA037A1BAFF0014FD9E28B08D8882368FE1F167FEC59DE7438D935DAC';
wwv_flow_api.g_varchar2_table(35) := '2EA96A0C3283BB7855A6E63B6CB6876C519DA1531B4ECF511EC46FBBB3C42C88FC3F5D8BBB6AD6FD66AE787C1676FD7EB347243E3FFA57F14D44E77FD649B95AFF00AB66AFB0F8A7B2DFAE08B382CFF84C51D7AB60E0CD126C545140281C66360E765F0E';
wwv_flow_api.g_varchar2_table(36) := '1A18F2E8A3BEEB8D07626DF9C01794C71BC1BEC2A390491B5E36385C7A6C7808BDA5739E3FACD6BB56B0FD5D07B56BB78AE8F5D5D89A5A766C45D977A199D97FCD659E79A1C05D1E2B6777E09D6DEB2FE0AA2A23A78F59DF01C54933A698C8EDA56AB88C';
wwv_flow_api.g_varchar2_table(37) := '822C7389C8D86D4039DAAD1736D8153E1AE39CB90EAAAC6B5AE6068B0D5D3973ADFEA09F4D236691807B2EDAB0F8A465047AE41B38DBB8FA7FFF002FC5599BF2F8A701B8DFD43DED634B9CEB01B4A931D603F67192389364DE53513656C55079ABECDE14';
wwv_flow_api.g_varchar2_table(38) := '53C73461F1C81ED3B08370AE78ACD72831D386B591C3A8E99DC7DD08F2A31C73B2A803B031AB93F88E295A24F2B89A1AD0355F6B127BBD5E6AD6DA574782CBAA896A7CB1358E7037B03923E535F39D56927F04280414CFDEE3B4A1CDC62F95D3E591DD81';
wwv_flow_api.g_varchar2_table(39) := '61D2864DA87DED9DFA2BBF68DEED322A81AF14728DE335873B5E9A5670F5B2CD1C43A451AFE0C5156873ACE16D18ECAE0C8A31B1C493F0534ED8232F7787154748CC439EA899CEF6BD96AC22920A3A16470925B7D63737CCE9E54C32478CCEE76C9035CD';
wwv_flow_api.g_varchar2_table(40) := 'EEB5951D03E1AAA591C35DAE17B8DC6CB0E9B9BAA17F65C2DEAADC513C32F4249241B145012759FE09AC6B3D900772AF7114739FBBA47ED633F7868C7E67D3D336666D06DE299CA077BF00F814EE500B654FFEE53E3554F16635ACF994C6896923DDAD1B';
wwv_flow_api.g_varchar2_table(41) := '7F0583D4345516F14F6EABDC3B7D64B2191E5C74011B4B6FC747295DCCD009ED72C781FEA5472CF5789D3122FD3F6470586D0BA9E37744F38FE93C5B6762C3D9AB4E32CC9BE9E516142BE8EEDB0962CC1ECDE131BA8C6B7800153335E789A77BBD400B21';
wwv_flow_api.g_varchar2_table(42) := 'B3C7406959715D1E0B2E0BA3C17478AB703755EC268AA07DC519BB1BDDA28E1E72A5BC1B9944705CAC93568216F5A71F20AE6C6C76E837B2A70F143086DB5B996DAFC6CA3C32B1AE075DAD20ED054C3D877168F1F593466391CD29A2E74422D1B7B96234';
wwv_flow_api.g_varchar2_table(43) := '31D7D1CB4F21B076FE042A1A2A6C3A77964BCE3B66B1161F0586CAD904AECB5B5BE5E8398246961D8EDAA4C05D7698E516B83672B0E1E98175756E2AFC15ADB4AB8E0B58F62B8EAAE8F6AE8F6AE8F6AA96834D367EE39407A24702895855B525E3ACAF65';
wwv_flow_api.g_varchar2_table(44) := 'CB1FDDA8EDFCD77E0805641A647B18066E701E280D50070D1ED53FF49FC7D65732ED0EB816E2A3195D52B008465B7462D5F6BD3C67FACFE5A30DA914F52358F41D91F4216DCDF44CDB1BF1F480BABAD9DEB37157E1A2DC48081675C236EB0562B5558A94';
wwv_flow_api.g_varchar2_table(45) := '5E378FBA533295DDBA309B8E7BBC2B03B3C172B7F7280D87ED6DF2D16236AC161E7714A51C1FAC7FCB9E9833D76759BEAF16C522C3E9F5F6C8EF61AAA6AA7A995D24CF2E27F592C2F1734B68A5CE2F9B561989433D44D0B250E1AA1ECFCC29E5E6A1924E';
wwv_flow_api.g_varchar2_table(46) := 'AB4945C5C493993B74E0F52F963746ECF52D9E8ABC40412B59ABAD974952E2546FB3758871DC46898747D102E8DB621967E0B6A27C11200CD3EA1D9EA643E689BE9BB86F425947BC995446D1E08398F0A71CDCA0F075915848169B3E0885CA866BE1323B';
wwv_flow_api.g_varchar2_table(47) := '7B2463BF2572813BD60552DA6C4A173F63BA37E17D31BB55ED3DAA66EACAE1EA679E38217CB21B35A2E56215D2D754BA693FCA380E08903453CF2534CC9A236734E49F54EAEC19B301A9AFED0EE29F1B98093B1037436AC3616C54ACE2F1AC4A9246C6C7';
wwv_flow_api.g_varchar2_table(48) := '3DDB00524AE91EE79DE5611487584CF1FD1A2AE67B66A78C6C7EB5FE03D1D9DE86D44DCA39649CF0D523CB8E80DE26C15DA36355CDBD81E0BFC9F3571D45D13BEDDE839EC20AAD1774996F50BB5983B322A92A3C9E6CFD976450CC7E0B1A66BE1558DFFC';
wwv_flow_api.g_varchar2_table(49) := '77F0CD648D13FCDADAC1ECF3C587C16B0581D69ACC3E3738DDECE83BE1A66E93237F65BD4F2B6ACFD8528DE35DDF92A0A19ABAA1B0C7BF69E038AE50503286B9AC8FD831348FC0A69C93753586B921BBEDB6CA3C470A7E1EDA7A597600030E4E55C09832';
wwv_flow_api.g_varchar2_table(50) := 'DCE1751FB23461EED6A380FDDB782C5DC440C1C5D9AC3A9193B8BDFB1BB94033D18E48F8DD4CE61B1E928B16A86FB603BE4A0C429E6B0BEA9E053AAE3D7E6D8759FC173B10786970BF0D1B82196689B02554D4C71DCC8F0D6F695157524CED58E7613C2E';
wwv_flow_api.g_varchar2_table(51) := '98DDE477211DF325741BB02D6EE5ADF742B8E08B18510E8F75FB0AAA02E08DE14248A873373BF24F192C3A6E729C03B5B92A9673D4F337ACC20AD992C3A87CA793421CBED1AE23BEF92376EDDBC172426FB6AA8B71635DE1A59D281E3867EA71DC14D786';
wwv_flow_api.g_varchar2_table(52) := 'CB1102668B67EF0524553493D9ED7C723766E3F058857D457B21E7AC5F18235B883C53464A388CD232306C5EE0D1F151E075D87CBCECA18583DE695358C527F495191ABA30775E85BD8E2162C3FBBB4FDF54F53E4987D64FD5D9DFB952F2AEA983ED2063';
wwv_flow_api.g_varchar2_table(53) := 'FBAED5FDB065BF7277FAFF00E150E2C3159A48E5A7600D6DDA36A761D487FE9DBB8AF3552FDFF152E153B4F40870F054F4B52C001E883B7F57588729AB4D4BDB4B2EA42C366D86DB6F5C9EC5E5C4A0979EFDAC445CF1051D802AEA8653533E67FB2DCFE8';
wwv_flow_api.g_varchar2_table(54) := 'AAAAA7AA94C92BBE1C150FEFB4DFE2B7F1400BABDEC1643BD6B76057EC0AEDDE3C15B2BABDF22AA20DD7EE51D26ACE24D6DDB13A9EE4D9CB0F8847CE0B937B206C5627073188D5C7C2675BE39AC0C01845101B0C40AE505379362B365D179D71F15C90B7';
wwv_flow_api.g_varchar2_table(55) := '974FFE07E7A698FDA58FBC2C9C2C48F5353494D54CD49A26BC76EE5894421AC98450C8210EB34BBEAB0C652CB54D150FD565BBAE54B84C3CF42F63CB5AD78218162A4BA81FDE13DFFDD5E7EE9507B3A303FDCDDFE21FC9622CD6A493B3355E0B70179EB4';
wwv_flow_api.g_varchar2_table(56) := 'E133668C2EA7C9ABA07EEBD9DDC7419E112884CACE708B865F323BB463B3BA9F0BAB70C8F37AA3FCD968E485508B13E689CA66DBE23344DCAE5654D9B0530DFD33A30C6EB621483FF284726819F156200ED5B3BD6B3B8AD672C8F6140EA9D88D93B36D93';
wwv_flow_api.g_varchar2_table(57) := '6D7CD386E54BEDBBBB472AA1D4C535FF0099183E192C13FF008BA0FF0005AB95D47CE52C75036C4EB1FE92B91C3FBD559FFC43F1D23220AA86FDA5F88BFA9AD90C74B2B870FC7251A314476C6DF050745F1B46435864B126DE866EE41D108A4121B377A8';
wwv_flow_api.g_varchar2_table(58) := '4748968FB3DD7DA559609FBABFFC4FC96252BA3A7E8FBD92C518C8F007B5FD56DBFA8951E98B156B305F2C7ED8D963DAE197CD3EBAA9F566ACC879ED6D6D6ED584E20CC428629C6D22CF1C1C172A01384D55BEE9F9E88267C13472B32731C1C3E0A9E765';
wwv_flow_api.g_varchar2_table(59) := '44114CCD8F68778AC6E7E7F13A976E0ED51FE5CB46031EBE2B4C3BCFC96D7207DA77A3B476A6F0288DA1455952DC579A74C4B79D2DB2CCB0FDD4243162A35642409F8F6E8E54D173F4F04ADF698FB7C1CB032DF36D2B6F9C6CD53DE155C31CF4B3C6FF00';
wwv_flow_api.g_varchar2_table(60) := '65CC375C986B69A7998E774A402DF0F41F885297C506BFDA8CAD6D17F4EA63E769E56716A88688FF006B17F585562F4D30FB853A3639C1C45EDA70724514846DD73F826D3C953387CA6EC6F87C172AA4D5A2859D697F00A37595F456D538614FA7DCE9DA';
wwv_flow_api.g_varchar2_table(61) := '7E474724B13F26ADF2679FB39FE4F55D4C2A69E781DEFB0B54913A291EC764E6B883DE34725311D6A196079CE0E90FE929E759EE75F6925582E4CB01C41CEEA44E4DCBC165AA3BF4CF3C50335DE6C11C629783FC10C6A9C5FA0FD8AAB187EA33C9836E76';
wwv_flow_api.g_varchar2_table(62) := 'EBEE53D6E273DC3A7B03B9B928E2918E0F046B03705493D6CA2CF9AE846F076A9B1D9B642C00713B54F575351FB594BBB151E233D1C723230D3ADC7729ABEB26B87CC6DC0641412BA19A3906D69BAFED07FF008FFEE5E7E7EA5C451EDD9737471FA9DD14';
wwv_flow_api.g_varchar2_table(63) := '7F352D6CB25473F66875C1CBB11C6EBCFBCCFF004A38BE207FEAFC82F3A57FF3DDF2F4EAA311D4C806CDBE3A21FDE611F7827B759AE6F1042B5B4E0ED068731EF9D1CADFD852FF0059D0C0FE6C3CB4EAEB6ADF75F43E0E7E3919BF5096F7B73D00904106';
wwv_flow_api.g_varchar2_table(64) := 'C42C0315F39D087BFF006ACE8C9DFC5729611162F3D87B767F8E8A59658B9C2C75B5D858EED07405C968BA5532EED5D51F8A6EFEE5B5BDDA6B697CA62D4D6B106E14D0C9049A920B1FC7B96B7440B0F44056FE0AB0DEB25F87E1A2973AB8BFAB4563352A';
wwv_flow_api.g_varchar2_table(65) := 'A76FDF29D2C6DDAF03E29957049332163AEF7B834779587C32414CD63C74AE7472B3F76A6FF10FE080248036AA4C3608F0B652CC066DBBFF00A8AC42864A19B549D68CFB0FE2B0D36AEA63FF00907CD62B47E478854C1B9AFE8FF49D9A392D5DE4B8AC6C';
wwv_flow_api.g_varchar2_table(66) := '27A13740FE4B94B52CA8C5A52CD8C019FE94D05C577688D8E7BDAC6ED71007C55040DA5862886E19F7A0513A9D2D8155F28A82176AC7AD21ECD9E2A0E53D33DF692274638ED4DE90BB731C56314BCED2177BF1E610908DA8383B62ED5719E48DB72D99E8';
wwv_flow_api.g_varchar2_table(67) := '16BE7B1119ED4E75DAD16196FF004C38B761DDEA2B2FE5937C3F04561CDBD533B013A3952753106869B5E304A26C2EB0067398C51F63F5BC33D04868249B01B56398BF96CA18CFD8B0F47B7B5365735C1CD36233053E69A4377C8E71ED374D9640DD5D73';
wwv_flow_api.g_varchar2_table(68) := '6E1B9501BD4D311FCC6FE2B966C6B7148CEF7422FA23243DA41B106F746E4A632CD56D1C9EA32E94D4B864CC9BDE9E33BF1CD54D7414D099667DBB379589631535B765F522EA0DFDE8A631CF76AB45C975805410CB4F45042F75CB18015AA5639431B40A';
wwv_flow_api.g_varchar2_table(69) := '88B8D9FF00540DB626480EDC964B2F46C45F49BF059AB156442F8FA44868249C82965E7667BEDB7627EC584B7ED2477DDB78A91EC8D8E7BCD9AD172562358EADAC96739027A2380521DCB92316BE285DD488FCF2D1CA8AC30D232169CE539FF4847D0C2C';
wwv_flow_api.g_varchar2_table(70) := '7F7AA6FF0015BF8AE583EF8C11D5899F5D0C4C1770D3144F9A5646C1773DD60A9E945242C807B82C7BD62189C345167D290FB0DFAF62AAAA9AAA53248EBFE5DDA36AE4FE15CD015728E99F60701C56B3B8E8A8A7F288248BAC36A9E9E581CE6C8C23B776';
wwv_flow_api.g_varchar2_table(71) := '86BC84253C173DD88CA531FD2CCE9B36C3337F42F92F8FA8C56521AC887BD99EE4027665616CB40E7759CB9555862A68E99BB653777704C63DEF6B1A2EE26C076AADA77D3554D0BCDCB1D65C8C82D155CFC5CD60F866A596386374923835AD172562B88C';
wwv_flow_api.g_varchar2_table(72) := '98855190E4D1931BC068B68A3A496B2764310CCFC87158632D5F4ADE1205CA2979DC6AB0F07EAFFA72D0D160A26E57D3C95A0CDF58F1B3A31AC73168697A11D9D3F0EAF7A9247CAF73DEE25C769D381E17AEE6D4CECE803D061DE83E32AED45CD03627C8';
wwv_flow_api.g_varchar2_table(73) := 'E77722C0FE896EB5F72183509F6E06DFB2E11C0B0CFE49FF00514FE4FD0107575DBF1BFE2A5E4ED6B5C750B1E3BECA5C2EBE1F6E9DDF8FE1A1B2DB6A043B67A2ED5BF46FEA6AA4E76AE43C0D87C151D3F3AF24FB23F1472255347CDC11B7B172B1F7AF89';
wwv_flow_api.g_varchar2_table(74) := 'BC21FCD725F0F32CE6A9C3A117B3FD47E8B94ECD5C627ED0D3F25C9C8399C229FEFDDFE2B9418C79549E4F09FB161CCF58E8CECBE098D73DC1AD6DDC4D805826142829EEFF00DB3FDBECEC53CACA0C5A695FECC72B9DF985248E9647BDDED39C49EF29AC';
wwv_flow_api.g_varchar2_table(75) := '21323BE6762CF45353C95151142CF69EEB7FC95886371D1C2DA2A075F51BAA64FA2717124B8DC9E2746E5846126A089E61F65B875BFE106B2D91D5EC5AA7B16A91BC78AD5CF37051C3AD6BDEC991868CAC3F357E1A471DCBB4AC570F6D640751AD128CDA';
wwv_flow_api.g_varchar2_table(76) := '6DF24FC3EB986C69A4F052432C47ED23737BC596B386F425726905B7F5601E71FF00D4543188A20DF151B39CA86B78BB462DAF5F8E4914599D7118F82A3A48E8E9A3823D8D1B789E2B1FA77D563E2267BFCDB6EB1DC5D90C5E4148763755EEEC1B95D65A';
wwv_flow_api.g_varchar2_table(77) := '034B8800664AC0B03F24689EA00E7CEC1D4FF958A62B4B86C06494E67D866F71555513E2114D3B80D790DEC3B1066AED6E698CBF72BD967A23964613A8E2DD61636E055F4E0D84BEBE42F70FB266DEDEC5CDD85B9AB77648404F11F04295C7DE085236D9';
wwv_flow_api.g_varchar2_table(78) := 'BD36185BDA55F865E85B8ADBDC8E803C14F1453B4B2560734EE2A7E4D446E619CB7B1C2EAAA8EA295FAB2B6DC0EE3DC9AF2D5CF0E083D874BB5775FD285D079D248CBB306EDED2A4706C6F71DCD2B06D495D249EF34E43B0A9E411412487DD692B007D33';
wwv_flow_api.g_varchar2_table(79) := '6B6474994AF1D127B76A9A68A08CC92BC31A37958A629CF574B2D33881B03B61E08A17E2AE78A173B1727E828620D95D34725470EA2C671AA7C321B9E94AE1D08FEBD8AB2BAA6BAA1D34EFBB8FC8700A26F371B5BC027544236BC7E2BCB2227A2C27E164';
wwv_flow_api.g_varchar2_table(80) := '5E492762BE8BA2512550514B5D52C8231B769E038AA5A586920643136CD6FA8B5D643B56DDBB113A4E9AB81B514D2C447B4DCBBF72EF595B446FDC7D44D238D548F073E7091E29F8E543A07C6F0CE936DADB13310103EF1CA41E214D8F4D2C2F89D2DC38';
wwv_flow_api.g_varchar2_table(81) := '67D146A38354B3CF35B5E573ADB2E6F6D1C741B6F4CAA7309D5603DEBCB2A0EE1E0A5324AED67ED421284648CC94226E8DA81CBD01C02C070C6D0D2DDFFB69337767DD46FBF35D156ED0B54AD577056ED0AC38AB8E0B32B21DA89D1B512360F471AA234D';
wwv_flow_api.g_varchar2_table(82) := '545E07424CC77F0D3F14C7640FA38862B4940DFB57F48EC60DA5623CA0AEAB25AC77351F55BB7E256BB8FBC7C56DD39E9DCB8222FB559BC158705970560ACB8E8DFE8F2730792695B57330F34CF62FEF1FF8D0091B15FB174782B76AD52AC78200956089';
wwv_flow_api.g_varchar2_table(83) := 'D207822787A55D471D5D3BA277C0F02A781F04AF8DE2CE69CD6B5DA1A46C5F04091B10946F1A717E52866B414762ED865DC3B93E47CAF73DEE2E738E64E82AFA335757D19A2AFE99D0068A6C1F12A9F6299F6EB386A8F9AC3B92F0C443EA9DCE3BA9EE8F';
wwv_flow_api.g_varchar2_table(84) := 'AA003400320AE378596E28B5C377A17237ABF6FA190DAAFEA31CC3F9F879F8DBF68C19F6B566AC5588DCACEE1A394F88F3300A68DDD393DAEC6FFCE83E882AFDBA02C97821EA29A96A2AA4D486273CF67E6A8B927B1D572FF919F554D41474A3EC606B7B';
wwv_flow_api.g_varchar2_table(85) := '77FA7AC55C7542E8F6ACB8AE8F12BA1DAAEDE0B58FABC670FF00269B9C68FB279F03C15C7157E055FB54D2B2189F2BCD9AC17255755BEB2AA599DEF1C8701C3D1DDE8159A1A0F72C8AB7A38060E2B9EE9661F62CFF007150C3140C0C8A36B1A3701FC5D4';
wwv_flow_api.g_varchar2_table(86) := '411D442F89E2E1C14D13A195F1BB6B5D63A795388D8368D876F4A4FA69B2B69B7A392F82C967A32D34B4D2555447033DA795494B152D3C70C63A2D1E3DBFC6F28A8BD9A968FBAFFC96A85AAAA6A5F513493487A4F75CABE8BA3EA7C7484746DC82E4E612';
wwv_flow_api.g_varchar2_table(87) := '6920E7E667DB483E2D6FF1D590F3F4B345D669B2734B490E16236A0E6F52FE3A6FA7B51E1A772FD782B68B69B2631CF366B493D8A9701C4AA6D68751BD67E4B0CE4ED2D1384AF3CECBC4EC1DDFF60C4B098EAEF233A32FC8F7A7B1D1BDCC70B106C47AE8';
wwv_flow_api.g_varchar2_table(88) := '30DAEA8FD95348EF865F354FC93AC78BCD2B23ECF68A8792940DFDA4923FFDAA1C1B0B87D9A48FFCDD2FC53228D9EC46D6F70B7FD86E38AB8E2B1D82F5FAC3DE634E8CB45FD22A9709C42AEDCD40EB758E4152F2440B1A9A8CFAACFA954B8461D4BFB3A7';
wwv_flow_api.g_varchar2_table(89) := '6DFACEE91F9FF1A5C00CCA0F61B74B6A33347BAEDFBB82E7F8B77D909EE48D5CC1FD5909DDD137CBBBE2B9C71D847B47FF004892F16D71B76F1BE7F8221B704DADABB4DF7FE2A2B5AE037B77AB16D8EA8C8F1EFCD3A86294DE465C8C8777A05676F42082';
wwv_flow_api.g_varchar2_table(90) := '5A895B1C4D2E7BB70585F27A9A943649C0926FF68F46E06D2B9C8FAE11A8847BEBCAE0E27C11AE8B838A35CDDCC3E2BCBCFF002FE68D748760010AC97B1795C877AF2A97ACBCA27EB946A263FF0050AE7A5FE63BC573B275CF8AD77F58A0EEF45CB35AC7';
wwv_flow_api.g_varchar2_table(91) := '4191193B762123973A78AE75FB9DF35CE387BFF1BAD7765D222DDAB9C7F13E2B9D96F7D637CEEB9E96D6B9B6EB7E48544B7BDCEB67F1BA13BC657CB81EE4DA8946FF00F95E56ED4D523E2BCB19AF723867C10AB888171981C36AE761EB766CD82C8F367D';
wwv_flow_api.g_varchar2_table(92) := '9D43F1F445F4B1AE7B831A2E4EEDEB0AA1187C7706F2B8749DF9042A9FC0235526E6808D44FD61E08CD527DF29CE9B7B9DE2B35ADD88959FA3ACB5BB3D3D608BAFB1171DE16B1E089DBB578F6A17E281B67DA8B8662FB573ADEB232B38FC973EDEAAE759';
wwv_flow_api.g_varchar2_table(93) := 'D52B9FCBD946727DD0B9F37F642E79D7DCB9E7F15CF49C573927597392758AD77F58AB9E27D460987734C1512B7A6E1D0FBA165C50EFD365B7668202B2D56AB3782D46F0458D41A02D40B53B56A76A736DBF41232573959124ED2ACD446FB846C37A3233';
wwv_flow_api.g_varchar2_table(94) := '8E6B9E675724673C1738FCF345CE3B4FF096D183D0794CDAEF1F66C39F69E1A05B45F4DD5D65A2FA2E3ACB5DBC519064B9C758AD624F78CB344F6EFCF341CDCFE08BDA01E0B9E675973ED1BCAF283B82E7DF9F6A323CED77F17044F9A5646C1D272A6819';
wwv_flow_api.g_varchar2_table(95) := '4D03226DEC3B3E655FB7C55EFBF7A0E71B5AC56B3BB2FBD6B7DE19EC5CE3B3CC6C57E077715AC32DBE3BD5C0E28B86CCD6BF7AE799C7C4AE7D837DD1A9197D10A9EC5E52EBE4173EFE01738FE2B59DD63FC66B95AE56B141E5738552D74B4AF73A36B6E4';
wwv_flow_api.g_varchar2_table(96) := '5B35FDA0AEEAC7E07EABFB415A7DD8BC0FD57F682B7A91781FAAF3FD67F2E1F03F55E7FACFE5C5E07EABCFF59D48BC0FD579FEB7AB1781FAAF3ED67563F02BCFB59C23F9FD579EEB3833E7F55E79AAEA47E07EABCF355D48FC0FD579E6ABA91F81FAAF3C';
wwv_flow_api.g_varchar2_table(97) := 'D57523F03F55E79AAEA47E07EABCF355D48FC0FD579EAABA91F81FAAF3D557523F03F55E7AAAEA47E07EABCF555D48FC0FD579EAABA91F81FAAF3D557523F03F55E7AAAEA47E07EABCF555D48FC0FD579EAABA91F81FAAF3D557523F03F55E79AAEA47E0';
wwv_flow_api.g_varchar2_table(98) := '7EABCF555D48FC0FD579E6ABA91F81FAAF3CD57523F03F55E7AAAEA47E07EABCF355D48FC0FD579E6ABA91F81FAAF3CD57523F03F55E79AAEA47E07EABCF355D48FC0FD579E6ABA91F81FAAF3CD57523F03F55E7AAAEA47E07EABCF355D48FC0FD579EAA';
wwv_flow_api.g_varchar2_table(99) := 'BA91F81FAAF3CD57523F03F55E79AAEA47E07EABCF355D48FC0FD579E6ABA91F81FAAF3D557523F03F55E7AAAEA47E07EABFFFC4002A100100020103030401050101010000000001001121314151106171208191A1B130C1D1F0F1E14050FFDA00080101';
wwv_flow_api.g_varchar2_table(100) := '00013F10E97D6DF52F4CFA2FADBE8B972E6667ABA4A80E5332DE9999972E5CB6665F4B97D332D7D07E86F9FD635C7EB83B5CA812A512BAE23FA41FA4AE3B7A6BF496DF454AF464F4DC72AFA2B32BFF00469FA352A574C4A952A574A952A54A95E9CEC3EB';
wwv_flow_api.g_varchar2_table(101) := 'AFD1AF4E2575C7A6A04AE972FA67ADF4BEB9F4D626253FFC2B97D2FF0045F4BE8BE97EB3F5CF27AF30254AF4D61C9D0F4D3D6BBCA95D2A68BB257FE7AFD66A63ADFEA59FAD52A625131D2BA131FAB898F49878D5B36F006562D01C4922FB9BE14C7A62A6';
wwv_flow_api.g_varchar2_table(102) := '3D07519504D060FB09DD4134C54AEA85E3ABD3131D6CC625CBED2FA5DD5BFA15D31C440B759161609B0B2C87D54DCA032AFA7960B1A155ADACB88DD59CACF654B88342342C8C396840D9265F4C4B972FA660D435251787F98061A769CEA3F68A6C2E9561';
wwv_flow_api.g_varchar2_table(103) := '19639715A4539055E8D7765161E7F05E59AA0D5E1E63D2FF0041EB88543AEDEABEB708766F676840A22A6BA5C56EC00D5E531532B9672E8A8D646DBAA7725C1E8198141340000D8343F45104586A6D4CD613F898A3A0EC0E5EC4177BCFFDB7BB10502F4D';
wwv_flow_api.g_varchar2_table(104) := '41FB2E1546AC726D61F812995E796DFCA8B7608DEAB6AF9FD882BC05ED6FDB08C324AEB88D5189A4CE7A67A1A96BD4A25C7D0A5E0E96FA08656EF8CE18E2A88BE66CC416E52C8C0E0763346363C25916585129755345554526E8E953BF1B30E470E495D6';
wwv_flow_api.g_varchar2_table(105) := 'A542B3D45685BA508FD5130A070B3E1116B52AEAE74DD80A533A9DE6615A1DF3C6EC5556D87DE7F773339E9B7896C1436A3F0416216AF62FD951037A9E7EEF2444432FA666637D712EAFA5CB972E5CBE972FAE7A5D3B4CCCC2535687CC143371218558FE';
wwv_flow_api.g_varchar2_table(106) := '5034C10F015151A06620C846B7B21C5EC187822345A45C149EC7A335E8A2D8F7FF00A4B1AAD1BAD5A8968B17166A068402982EA39E3C612242A6C1722685EE12DB56B87C3FEC70FB7DC0AF7A33FBFCAC51AB7C4141F1BC00AE2DC76ED10A4A66653ACF79';
wwv_flow_api.g_varchar2_table(107) := '5288454AF4575AE94FA2A574B8AACA6391691AEEFA5D3305C51397999CC838465036B0265E1046E47DA3315D44026F0F84A74A254A9529950296B42FE1B74F136CD7E75085CD1BA1E73FB4A829D0FE07C91569AAAA6ECDB4E6150C06D7B374F820E9B0C1';
wwv_flow_api.g_varchar2_table(108) := '7F1FF50BEE5F5FE4A6A201A5F9A26BA71B77E583472BF9661D299A4F6BA25E2AC17CE1A8F221D6D9706E3FF868793E8C4A218B973471AC0CDDF1CC4152B571E47A0B8F619E70D7CF55F45C4609915AAAB1D650D2B440FC2FB92C0856156E566BCC162E85';
wwv_flow_api.g_varchar2_table(109) := '9A3367EE4C78B8528F2F0EFC1344706AF2977F2A1D9AFF00197F12C1816431D9E18D75D5F350BAD09B7106D6C14F93F9309D952FC97DB30DDA70C6D9DBB2C0D15A27BFF2216AB0E4BE18D2C4E9A4BF4D66BD39E8DD74CF5CD3A5F6AC30457840789AB7BC';
wwv_flow_api.g_varchar2_table(110) := '086ADAD2DA815B21E2FA0CA02232A1F314EBA4D19D1976FAC3D68E560556965347C3ED00179CB35BF670CB28FC98F8D9F10AF35E2E0CD6036C60FE583A6ED4B737CAF306ED85DEB43C5C71025145B004386AA01FB109A0E3772705EDCB0366033A616C78';
wwv_flow_api.g_varchar2_table(111) := '8A289B7871AE99AB6532176914C09EC43652CE7B568FB68CB2D765B6CDDFC8CC944D309A57648E4D7A0598E843A389B7425FA1C3F60D54ABCB3434085A23CD6D2D6DC55A40C75A8ADAF04747EC3560340C0307528EE993C5CC6518B695B4A2806C6EB253';
wwv_flow_api.g_varchar2_table(112) := 'D5E96CA252FF000A47682ED7FD98174DCE9EAB970FF1ED3408E415880D851B59F7EB49A0BE993DC9DF4BA6AC3B7374ECE54259231627F22D5B3D47E852D25520E38CCB06A7BAD4BAE7673065A27BCBC09D4456B620636506863E2072FD8BD0ED13283B35';
wwv_flow_api.g_varchar2_table(113) := '632836E2B998560695742FEBE7AE08C23C587CE73ABB0F12FD172E5AEEF4D7D160F086AC3FE761E3DDC238E963DE4287971546E5C108BD952BB00B8F3F2425BD2FA176AD3CD303C15A2A66171878FCAB92E2F6EA6B2E5CD52BAE25E3C7336704A95D184B';
wwv_flow_api.g_varchar2_table(114) := '8F88207DDBF98521AB742B3038E96F8622C4234055E0F370207655CCB181E14F2C4C0BAF784789B93F230BC00A381432C1D52B3BE6A76C51D68E7A5FA98D66F41C1D15AF5532F2F43A5841CE88ECAA13403960036E156BD29DAE3BDA2975CFA0BFBCC63B';
wwv_flow_api.g_varchar2_table(115) := '8F8C2A0E9C0E4C43D01DFAA2D12D77274236AF3895BFDA106864B7CCBAEABF31CDA5DA22BA67925EE822BD6F96FE447333633FC6E2525AB279907876502814B2F8D2E0DD944767886F525B186AEA19EF818A772337B6DE79187F50A8DECEE329897106DD';
wwv_flow_api.g_varchar2_table(116) := 'E59EF1A09843AA2C657D7765372972C75C2EB81474E3A14EA14069A631E4B0B63B92A4C31A63496CCB1E81D2E65A398E14144372A21B4D35EEC427338C19FB80551BEF98B095F038A8A5D8F6C4D5A45F0F940578B5625421349F11AEBAE7B6B12B586CD6';
wwv_flow_api.g_varchar2_table(117) := '80BDA095C37CCB09B8D083A5B31B421941F2AA183A003C18E8E3E7EBEAA7A63D38E837EB902CED729D06F4476983169579CF46551C1198E148DFB1C3D5622AE80208C7A517632C6D82EAF04AD6976D2642BE56342AE1BBBB0158D2903BB13CB005A42DDE';
wwv_flow_api.g_varchar2_table(118) := '0DA27C92D69AB7CF7A896538FB8171A87C90A1470C7B44C3A4744AAD0F667606E2C11C6D52D2ED885F33028965FB331DD81E283D33F215E49BE6FBCC74C73EB66AAE1CEF2F622E5EDDC1D86C4CB0BB0EBE0E484D75671A4890FDC08972854EEBAB101AA8';
wwv_flow_api.g_varchar2_table(119) := 'CB09469DADE3A173799525E929670036EDF17D2CBF0F4439EA8A88814D0BCF31B5DD700AFB603834691F28023917E78556B7E6199981308F0CDF49DF3102E3BC39AAF27EE4611C3AF1A44C65B46E91069333FD3210F98F12DE1788D785CD69A372BA271F';
wwv_flow_api.g_varchar2_table(120) := '94F3159EF998EB8F4730B7BE8CD271C5F83D04A8BA803533D9E50472A1DCA108A580DEE08B1964034F7C477324577348EE529631396598D7E0FE7A60719F7E625CB25F45AD68B58472D0CB2E198ABEFDE3A0FF0084596A97836E84D3DEB57DA15285EF99';
wwv_flow_api.g_varchar2_table(121) := '680C025EEB2A56474EE10836A0F3DE0119AE0634ED0B381F86A5D8A5DABCCB76FF00208F6675767B918409A65CCC75BBE52164F7CA0EB4288C58E3135CDA79743EE4C4BC4A72D67B74B97EA1DB6BF631283C727D0F58BF7159E480226F2C2E2C6E418799';
wwv_flow_api.g_varchar2_table(122) := 'AAAD03965B1348F199242A070C7F0400B8C6E688D65B9E6BCF6876C69F5D285AB47CD44403F97D4581AF6E62F2B54D0F2F682135A5F2FB45555BB8D015972E91A123C10D8D02E66F76522D3F35B41BB56727C40AB8DE4ECD6EF6826DB5465D3821621F94';
wwv_flow_api.g_varchar2_table(123) := 'CCB5E9F03CCA7C10CD65C40718788BB606E11E75604EE4AF0A17E1170984D78DFC1A4B672FBB8A8D8CC11CDC2A2B762DEC14AC2CDF0AC663657D81575EE361E989EF2FD3853AFA356A1A63DAC977531094697321F50F7821900E82E8B8730C324B7B3508';
wwv_flow_api.g_varchar2_table(124) := '6FF6238F4FE96B5977087E187ABA0ABBB2BECCA9F7E6BFBCEE8E2919777FDF5A72CCBFCC117BA478112B7AC6E8712ECCAD0E68436D88C538596195508CA0B86680F77DE2EB43B92D3409BAC652AAD6C3C12883F2D6C88E07EC453000D0235159A377A12D';
wwv_flow_api.g_varchar2_table(125) := '77EC574C2E14C99D9ED160D43BCC0E512BC466B06EB925F25A414E4A9A601EDA4742A137A622024608A187B2A4BA3D49CE5821C45F9B2CA84ACB379AF5136C8A2F18D75CFAB80A34CF70ED3577A52FB9C1833B20B69B02C00E35CABB1BBD58869A6DD6F1';
wwv_flow_api.g_varchar2_table(126) := '1B590BDEAA2C29E9F07F1460866BF161C0C25F046F43DAD3EDB4DE83E0E51A9B9ABA3969F80C3DE23AFEFF00852C1E58FB03ED982064C30693557D9B81A00ADBF69420C8BEF4CC6203CB8F11BD6F2E29713C7F444C9D88C0291B1945659F85DC94E3C68C';
wwv_flow_api.g_varchar2_table(127) := 'A16C3A68DC2D54FF00B85C1B183DCE0033C443DDDF98DFC51F99A951A66C8CA99D084AE95E8C74D41711E2D0719267DBE44A01D91832C205681C764808EBC96A32A8DDC7BDE268876B7FE11094B77F09985A708E0A4CC78890226CB45F0DF2973309E038';
wwv_flow_api.g_varchar2_table(128) := 'EC4A5F2A1F2094E3453E32F5B22FF687BAB8C4639DA933F5F8B86352270EB7B397AC817E225F069B65F13333D75DCD3EC9456CA7F32853530C2F9CD52A9B08184C657C0CA276522447A3132FF984A48D0ECCF3063F663583B91D9A6B5964B964BD2B1765';
wwv_flow_api.g_varchar2_table(129) := '696172EFA2FD4FB82579324C19D7A69F9FCB1CEFF125F8828BD0F68742E2C5677A4BBA8D0C278ECE58C0380BF12B54C0D152DE20E5A5E763A4CD57117B1A4C77171554A61954613E1298E211FE7B7CDF4CBA4AFCE30A759CE75F284625B30B7E711A7794';
wwv_flow_api.g_varchar2_table(130) := 'B25914D25AE5560F46F64CA3323423699762708705A8C5FA20A90F809925C18DC307D420D444C91F78928EDCA0001B3407B10E44C6CAD8E292128D6BF802676C74E7B45EC7DFFE62B9C6179368FE52C4D2D1AB8D90F11B24F12B7F8BD6A0BB2138D55D2C';
wwv_flow_api.g_varchar2_table(131) := '8B9BEE589FC8151D07098654A250091C70027F47C741D9143781752D629E5FB58FDA5747EC8B11A44DC8A905CEFD31EF84F41F4BD0368803CA226E33C238F691EF3646DEEBACD7780AE1CADF0F513B084D4BD298D2AB9381CA8DB422B759CF2CB80296D7';
wwv_flow_api.g_varchar2_table(132) := '7E9880B56FE66814C5CC74A82764FD4AE8FD9A7E9D2D5BFA3A7636BF0B703BF3D04249A0EA505C32C0441BD596C39B8FBA01054D01BAC5FF00331E551E494D7668D01B3DC82B16229C9844AFA7F964E86A046BEEE5C596ECFDF54301A1ACBC116BC7E181';
wwv_flow_api.g_varchar2_table(133) := '82906355531E254EEAD6AB1046A152E5376E951D9655E35ED685AFCA6E1220DAC2C1929CDC700B4ACCB5B931C6E116A14522CB8D9833A7699357BC1501A4709170730A16AB650B8020B03874B9641A7414A779EF2BA1316CBDA2CAC2A1AE1967AC0D2ABF';
wwv_flow_api.g_varchar2_table(134) := 'C1150B11D5A87C574443A6C755525C28E673F877A0EF0153A01AB2B852FB9E90DF960351D98BDB1B575F711056DADBF2A99D99FC6861D4FDAA746EC101844C891215B56DF799A7572C757BC47EC99955E57ABEC4A40702997E21F0A60DCF635562F772D3';
wwv_flow_api.g_varchar2_table(135) := '6CD1E6C2E73BFED0EBCF06AAB2E1AACD25E5D633AC3A29D01437A4231B0EF28C47969103577DC954E819332F5EF0CD114046C699ED055C102ADFBCACB110D485AB48BBA40C68F51D602D5E269787F0304554E65BC31F25FED05EB2AD832C101A24D9C04C';
wwv_flow_api.g_varchar2_table(136) := '208B4785DF7474517578C5AE7FB4C1596DC35F648DE5FB23B12BF3D06858A6ABCE638D5EECD58FFC013970408ABDC3731F84D13AF9E10A6D6806838100CE7B4532BC7F3197C1B7DEFC98B156AC1F188ABAB09968AFB1D98BD81406556E3BCC56F7343BAE';
wwv_flow_api.g_varchar2_table(137) := '26ECCFEB7386115CECF4CC6D84DC563E6E54F767BB2D62B5DF7958231DE5F6F5396DAF6528222C9FDE008F2D223AA3087AAB0105A2ED346A5E47E31B477E4568106747C6B6CF765352C3196547BBD83551F40469E1865B611F69352946529EAC4B204B71';
wwv_flow_api.g_varchar2_table(138) := '5B5DF69339B8A760E6BBC6A4B68DACAD898AC40376E03E6F6959671BD429C0AF9893ECB2F0BAE06082D11858B185DB9ECE8ED8A95336706386D7DD1314716F5CFEE32E919C987CDA69718066731C042BB11C4B65C4A62AB428D75BACC5853AACB3BFA943';
wwv_flow_api.g_varchar2_table(139) := '71EC5842A9F77752E2DC5272786FCB96084E4BED4C8F8AEF90A2EF7F859BBB3FD07B12A21545F69AFE51FF001422D5740989088A327030ACD1A77B08955AD7296CA05D63560A5471292127802F439EC1AC01CAA660FE72CD82D6C55E65773D88E29B4A85';
wwv_flow_api.g_varchar2_table(140) := '86DF570DA60184635D0AED305DE8E4E2E3E01788A52B9CDDE8D6D0D21C8E9F1ACC3D419E6C4C5C53877EA371840BB46BFB825EAE9445D6A9E18A6F3B34F92041F741ADF30D033DE075A66A25A60E9ED332A67D4E20CA55DEE1BF50B5CBBC6AABD7F176F4';
wwv_flow_api.g_varchar2_table(141) := '3992F61D33349595AEE2857B630B05C195023BA60AC7BDFA87619F6898A1D18C512006AAEDE6126839C116B32699053DB468A55447798EEDA6B5B20D0A4A97DD349ABA0D82EA17DE1D957075A26629CB77E571822751A06818C01884DEF86762EBED3563';
wwv_flow_api.g_varchar2_table(142) := '202D64CA821A35FCCC5B3D9C9E8301C098A680885C1471D2CB530D66AB8C08CF01D47C915A72A12FBCA680890DC71DD51EFD2C8AE6951A9BEFA7A8070583BC5D7B4B98A635C046FB14ACBADD8EA51C26846FC40D32ABF7335FF1BD12CD3853B31912DBAD';
wwv_flow_api.g_varchar2_table(143) := '5CD0CC3B4B2FF08582D6E91FA82CB9EC07565BD1CA9D7BF0860B8E6C6C06C41396B525F8F782301DE102544CB620DACB04B2832C3B4FE92CD2B24B188DA15DE6A3D5403E7AADD775EEFE80B41EFB13DE7D4CE4A87F3909651B1A1D02D02330018C637EFD';
wwv_flow_api.g_varchar2_table(144) := '4D1B61D95C8894A584698FB97A4C4A519ADA05B8198E1F530E2E46A258666071E48B9459E2D0E920359976B840255851E0302BC198F2D8AF7602BAF6D59416F1CF11218E6D71D30F880E434ABD3044035030E0316E90DAC00C51FEE18BFB3E6613C6BED2';
wwv_flow_api.g_varchar2_table(145) := 'A333A42A962AE0A6182A21F8ED0B58A73F511DD29C5E617F273302E3E6242B40E635BFC928693ED994885BBB2DEB2EAD1B437A96C6DEF116D97CC074401B18BBDDF4E637AFC6E8BEC417A2C239AF4D96E2BCF92C86B05A440D767D4B455672FE66A5DFBC';
wwv_flow_api.g_varchar2_table(146) := '2CD988B661DBE768A9587B7762A5B7FDE1A046AEA063C3F241ADB6607A70650BEEB8200742621296EF7FC9032F3FBC1AA60E25929BC661A5258D8E8F8E8B0B24A6E1FA96B718E6E55706BBE20BA16F6CC402D16626884A5CB79D08A941474CC572B5B99B';
wwv_flow_api.g_varchar2_table(147) := '010952BA574C2AAE78FD1983B8089396D8779445EB14B2DF6EA8B46EEB926EA4055AACCB00054D17F3705B6AFF007FFB0771F4929C9F6C69588E97F7CC32C94F1AB301ED9DA72EDF896E436824BCB0D34E98940CEBFD59A798E3E31033466DC474A0BF9C';
wwv_flow_api.g_varchar2_table(148) := 'B06BF68DC041800018038966B5DEA6223743CCB4BF40D22259C2ABA82B416F10390F0453AF5B23578E96CB8D90610D7FE52B84C1A4182A62CAFD7A3D7A76CD7F9E02D00C4189ECE668371AC731BF68B5ABF73FA66642C3DD85DD5799435964618C623584';
wwv_flow_api.g_varchar2_table(149) := '9755F50A77F695A4688E296106BFF0C072B4222D59FDC64F157B0BF939F5F253E65CB7EC59068D96A379A5CBE226CF827BBF04A2ABE6C500D898E97D312E7BF4B966E0C06DB2FBA35231C6094E12DD7BC60845A37F1BA41FDA99B5BA980B89A791868F1A';
wwv_flow_api.g_varchar2_table(150) := 'F7789A3FD594F2B33B8FE610D3EA16C081C10675F8CC7B91266F042C31BC603894A693C36F33BC7A37555D76E68D42AC7FEB01749E1D93B90C3A7169A6F28E859FE8871B4D7B13F1CCB6CB0A534AF2C1BEE5D1DEA657F78502BE77F627BFCE63FDD485DD';
wwv_flow_api.g_varchar2_table(151) := 'CAEFE6F4800CDFBFF04C6CBE087B1EF898F3FBCB686ACED3244CFC31402DA96262D99C5A3E0DD7B12A7832F75BAEEFFE5CFA2BA32A58F1941F26167FD94CC0B6A3528BD8EC4B2D3F10E7EFA34188B47D1E3FECCD761F994BAC1ED1CAB0F39FEDB142ABDB';
wwv_flow_api.g_varchar2_table(152) := 'B42DBCE398572A7DC34EDC4441B92CA33154645ED71150150E781E8DFF004EA54A8747D17EA408C8BCB5227D520751204A4F75C28E662316B2FB6DF999CF763F1169C232B98096941E2EBDA14DACA5BB83E600CA2A53F6F981549D02B1EB3CDD7E35950B';
wwv_flow_api.g_varchar2_table(153) := '340A7E47E8DE3D17D3DFA5F795D2A30089DFAE793D4754AF5FA61A1BC8D4486940C380B9B42DED2C1ABB8563C7E25986998FA956B3030AA235998C6304A94D77C3E5421C0EEA2E75AB7E41F529AF3C8BFE703A0B83FC3FF25CBEB7D6BAB2A5844F53F335';
wwv_flow_api.g_varchar2_table(154) := 'F1C35151CAFDB23DFECFDC96B09EFB7CCAC73DA2ACEF2911A87E3FC7A8CA4BEDAFFBEC02CB748A65E763ED80028FD4DC0FD7DE5DA0230252A2E0A616AF64005B1561AD642FC66520A888E144B185605B2B728AFB56D0CBD3258DB59B1D8844AA60B4D41D';
wwv_flow_api.g_varchar2_table(155) := 'A3257464A175DF3D908C080342A4A5BE2CA3B42C59228B6693DD9663209BD40C11A3254BCDD433A745C2D7697A17E19755647AE144354C2CE57B1E8A8E8027FA24BBB31C94DE140E9ED094BED4761057E799BF576A94B67B473D76E85DC4AAE4269BD985';
wwv_flow_api.g_varchar2_table(156) := 'C64F7455FDF4FF006D8FBBF366DDB1C947DE60ABC4BABCB0002DC352B1056348072DE6AEDAE638696A156E58A0DA3B52F760A5B2D064D9B9458D44AD1A95F728BD2A2F569812176AB2CBCD3A9E2002B51A23179B869278053478F117425D35614A6970B1';
wwv_flow_api.g_varchar2_table(157) := '786CDE81CDEAD660E4E85A52DB726B060BB2861A2EEBE71C4496A85E422F8D8972B5C95CA934579FA896D166DB6B7DEAE3065DC413330CD3B91BAD048AEDE06F2CAA80F169BF8A046D2382EBBDB17B3E2342F6908ABB1EE66FC30409A7797D623A0A9E62';
wwv_flow_api.g_varchar2_table(158) := '98E82C15DC7271B85E5266154E7ADA1553102157882EC5ED88334624D396B5DA35D31BB979D4095695036C630634888177D98F150360375F24A04A83C1A54B193E76469695DC0BFA5D697294DFE601551778B96D9D4B984861A4FB77325D2F9A9A548AE3';
wwv_flow_api.g_varchar2_table(159) := '13FDB96379BCC5DCFCCC42BB134B605357886A9DEFE6634A8B464A82ED750ED0C23BA6BE5882E91383190C0C1B951BBAA27258864786521A7C46F6D9EE4B8C0477C131459A2EE2896DCCDABE6574BC1AE99AB4D4C168D83983D1AEFC62E0CBD0ED510A14';
wwv_flow_api.g_varchar2_table(160) := '0BC735A4B1ABCAE2B66E150B061F8D49491146DA58E20A94233889AD350E34D66C4F65CB895E14BD7E2A585AFBFF00E0430C4A19653EF06DF6FC4ED5F04004A0D43F995FACD862AC459587040C52E550372CDD934DEA1DE1186CC5B03772816D6A5898D5';
wwv_flow_api.g_varchar2_table(161) := '09B68C34C4571B0FDEA05066D3EE58E835A5735A4708D018656C5B6E89F62B12D9A41680EB8ABC7116156992F7D2E2549CBBFD4B0D6A598ADEF3105535B2D8D391CB11BB497FA37FA98C0CB801BCA96D54B4A2517B77EC11913AA9A972F922ECA666A863';
wwv_flow_api.g_varchar2_table(162) := '26EC2CA4E34385DF32BBC9C3F210C80D05E58F116D85F66EC18A0A075C0FFD99D822E0B6DB7EF03576B6E886B377B16DDF46A5845CAB05CDF7951B4BF2D112C6203603AF112D156B55DECF72521C5B8852C71B31E2261229C5E7138C7238BDA2C8EB3F9B';
wwv_flow_api.g_varchar2_table(163) := '8BEBF27FECC6944BF344788DE70C9DB3EE2C4E40383B524CC5AF989D766DA259CF4D16CEB157DCE370D583492F2B0FE6F78E1311DA175FE3937E7AA24483D522408102041D0C183FF018302041890224483122C48912241EB9022408912241241D0408FF';
wwv_flow_api.g_varchar2_table(164) := 'C4003911000104000305050605040203000000000100020311041221051031415113203061811415223271A106425263912343536224344072C1FFDA0008010201013F00DD7E3651BE8AA2A8AA54A9578C4F7295776B7DABEFFA6EF4EED85A789A21BEFC';
wwv_flow_api.g_varchar2_table(165) := '0A54A952A0ABC1D15054A8AA77454552A54AB7E9E03A56834810782B68D5D7498C86465B398DF615856135A4FD100890A910478D236FAA8DE1A75B4F6E669014523E193D2B7D1DEDD02FA272BA5A222BBDAAD7BC2273DB6149839D8746D8F252BCC7139D';
wwv_flow_api.g_varchar2_table(166) := '441013A599C49CE5616691B235A5D6D2552A2A9515CB75DF12A90011E0B2028B48F0E1151B539D9696D5681872EF30AD3330918403C574EE02EAE21663E483CAED4F4424F209D3007559CD0394D7228BD089EF17A044106B4EFD79851461C6C91414B8C8';
wwv_flow_api.g_varchar2_table(167) := 'A3D2C0E96BDE387028C8C2E3C0036B6848E7C26F744E2217968B2131C1D0C4FEADFB8EF134B13B5F10F94B6121ADBA06B52B05ED7D99F68209E549B0176691C698D4E97338869F8392B53E28B6263471A2085017169DC2F752FA2CA88BE683696D71F1C7';
wwv_flow_api.g_varchar2_table(168) := 'F45030BE66347329B13647B18E008BD42F75E06EFB2FB9589C3C11461AC60176B0EDAC396653F01B1EBBEFB8FD98F1B403723BB22ECD7CA934557D149292C747F94F151650C0D03401005C4008602074603C59EAA58CC72399D0AB40EEBFE55AED1A0D67';
wwv_flow_api.g_varchar2_table(169) := '016604F10B5E8B6B6A59F45B37FED37D561F495BBB1A7E268F2517CC5BFA852AEEECEC19C4496EF91BC7CD4B868258BB373052DA381F6601ECD5955BA3E29F318882D3F15AC1C93490874A06BC1634B4CE6B9016B44179A964644C2E79A0B1BB5E595C59';
wwv_flow_api.g_varchar2_table(170) := '112C67DCAA75DB9EB3B41D26A50E3F13111D9E20BBC89D3EEA5DA0DC5B630F6E57B4D1FA158291B1629A5DD5446A4611D5170156B18CE0FF00429A48702A414F3D0EBDDD9D246EC276713C0928AC3B656C6D126AE5B5DB13E139E420804B4754787AA8B8';
wwv_flow_api.g_varchar2_table(171) := 'FA2AB9C04CC5401A066AA0B1999F887BE376869174A07005411C9372013DAE63883C94BB3E5DA32E4ED0B2267CC799256DBC047B3258846F2F320D2F923238F023CDC7FF008B3FFB9F50ADC1B60870F2E2161247C8F6B5BAD9E7C53D921C4B22C94FC80A';
wwv_flow_api.g_varchar2_table(172) := 'C297B626078D42C43BFA6C23AA95D9F0E4F92B4F371B1DE8566F257BE32ECEDCA4836BDB1C612C37755981D562CCA5AD0F7E6A069652584A8FE6F44D1730F209DC56524803AA9F0C626B4DDF558303238FFB2C6B29C1DD561A211C4075D4FAAFC5EEFF00';
wwv_flow_api.g_varchar2_table(173) := '990B7F6A87A94E70680403FEA8C927EA726BB36A000E1F7513DF1491CACD3E21616D2ED23C561E46F12C0F0B2D3186F88B4F95AE8A36E61981D4213B04058E70BBD168839B91ED24722168B4DE0D104754D39803E4B17C47D112547F37A289A0393DAA12';
wwv_flow_api.g_varchar2_table(174) := '04AC27AA9181EC2D3CC2C312C9648CA9631232BCD0D02FC4D3076D6001072B3EEA579F84F501618C2EC444D9DC5B1DD388E34A1D81B29CC6BD999CD23439961B65E070ED0190349BBB22CA7451BDCD7398D2E1C0D704F8C3C0B430B183766FEABD8E3BBB';
wwv_flow_api.g_varchar2_table(175) := '3FCAEC99D11863356D0846DE81646F41DC8FE46FD02C51F8C7D14580CE038BF8A9A0642E01A4A8C12ED02F657B80B2029A13151BB0A17668D84F44631DAE7F2ADD8FC5B309859267721A79953B27C4CC7282F94BEC01ADDAD9DF84E3C81F8C2493AF6638';
wwv_flow_api.g_varchar2_table(176) := '34AFC49B1F67605B0BE1B6B9C4DC7C57E1EDA9D965C248C2D6B9DF01BE6792BF0E3617BC04D00000744F064C450EA9B429A3A2C51CD31002C3C3D9B05FCDBB18E194379DA84544C1E5BF6F6167C73591426CB5C2C725B2F63C38160269D2D6AF58DC6C38';
wwv_flow_api.g_varchar2_table(177) := '381D2CAEE1C073256D0C6E231B887CD24B56746EB4D0A019646C81E6DA6C5755B3B6BBF154D740E047170E0BB56F9A0F0781081F030B56E3E4A39733A43C82C31B95CE2A19734EE772A50436E32BB99D06E9A66C4DBE698C7CAECEEE04AB1B8F034A38DA';
wwv_flow_api.g_varchar2_table(178) := 'CE014D2B6189F238580380D4AC7CF8DDA1892E3192DFCACA2293364E31FF00D823CCB961761B5AE0E9CB7FF51AA63191B4358D0D01007736421095A503DE7CCF8C0CBCD36499C7FA6D7115AD28227B98E05AE6FD541856C66C9B3B8AF662F9333DDA27B0';
wwv_flow_api.g_varchar2_table(179) := '10D00D008460733DCC4CDDA3A81D02A545515A2B0B89DF0BB88DC37C3842EA2FB0136363450684287825CD1C480A7C50A2D67A955D0AD42B1D169E6AD00B4E5BC1AD531D9802A8AD56121CEFCC46815782F78634B8F052631EED1BA045C5C6C93BC12ACA';
wwv_flow_api.g_varchar2_table(180) := 'BF20AD5957BAF73242D2AED6650C623606F858A9B3BB283A0EFD154A952A54A82D1446C574F00B9A35242762A16F3B4EC737930A931523C5701DFBDD7DF05C0D8B59FBB2CEC886BC53F1923B8688B9CE36492831E780284131E11BBF84309883C1850C0E';
wwv_flow_api.g_varchar2_table(181) := '20FE503D57B04FE486CE97F5357BB9FF00AC2F76BBFC83F85EED3FE45EEDFDCFB2F76FEE7D97BB7F73ECBDDC7FC83F85EEF3FAC2F603FA82F617F9238393C91C34C3F2A30CB66D85647F43DC02CA74113BE6682861A01FDB0846C1C1837DF834A952A54A';
wwv_flow_api.g_varchar2_table(182) := 'B7D771A287834A950F1C711FF93FFFC4003811000104000403040707040300000000000100020311041221510510312030417113141522526181233233404272A106536391344362FFDA0008010301013F00FC85F3B56AD5AB57F9CA55DDFD7F397CED5F';
wwv_flow_api.g_varchar2_table(183) := '77AF3B0AC77F160679599C527C6F61A7020A634BDE1A3C4A7C2584823B14A9120227983DF6126C8E6EA28F558FC3BE66372568A1788E505C3A1D54992681C59DA3D79055C81EF6395AC78B50F12C3491EAF0D7578A6C79E6CB98104F5098D6B1B402C4C2';
wwv_flow_api.g_varchar2_table(184) := 'C2C2E029C39DAB5E3D82BC5662AC776F36E2836D70F3F6E07278CCD70F92208247634F9ACA1650B222C587C0E27117E8985D4A5C3C90BCB1E29C0ACA9AC28820D1EE1E4B47436A2C2BE5D68A3819FA88DF940D4914B04C0D9857273F2BDBB152D896507E';
wwv_flow_api.g_varchar2_table(185) := '2EDC1C3616C60C809755958C6C01E0C4080B07C462C3E0191B07DA926FEBE2B12DB66677DE275E5848DAFB27C0858E0D12348EB5DAB4D347A5A73CB8EAB851FB27FEE533C3227B9DE01090B2DCDEABD7713F1FF09934AF75B9C742B1593D30735C0E61AF';
wwv_flow_api.g_varchar2_table(186) := 'D3B71635AEC28398670288533F312362B86709CF17A6949163DD0B8A611D87C4F525AE160A2681253319331C4B1D40F826BB3B43B9573A590F5A2A8F2E127DC907CD711FF8AFF309DD0A2A2E89FD2F62AFB38BC47A2650FBC5473CB149E91AE36B87621B';
wwv_flow_api.g_varchar2_table(187) := '899DAD9285BC5F9151BE37B4163810365C79D18C200E16E2EF74ECB0D866CD9B38B6D2C5B218E62C889A0A16B84609F1E8B5E6C639EEA68586C0318039E039DB1E8ADBD03558F1627E1A078F7A2AF98584C2981EFCA6D8E58C8DD2619E1BD69386842A51';
wwv_flow_api.g_varchar2_table(188) := '9F047504269B1D9C5B1E27CEF692CB529639C4B3A2E101E71713432C39E015C31D7139BB397F5036F0AC76CF519230672F5253B018AB3EE5FCED40638A16C5347EF04D6615CE34F236054CD6467475F2867661999B2DB9DD02C3631D8863B3340A3A908D';
wwv_flow_api.g_varchar2_table(189) := '9EB7F20ABFF3FE8A068F52D298F68B2FD0D2134790BB37BB6B1419E99E59D1306A535B4FE40539C152AE6181E436BA94EE0604A1ED9055DE52161E08F0F8D808005BDB6B0C5914F34401B2EB5C72BD44FEF0A3716C2C1BBD0E816359D1FF0044D75A71E9';
wwv_flow_api.g_varchar2_table(190) := 'E498539D98AE1DF84E3B3ACA009BBFAACADD8222BC8A346DA5618B1D13C1E81D44294DBDCBD1BC02FCA72EE84523ADCD69200D56AB23CB8168274D7B2D241047814D7666876E1621D96784ED49AD6D5802C8D4AE3840C10FDE131E5F2B3609AE1D0AC4B3';
wwv_flow_api.g_varchar2_table(191) := '340F081A29DAB4140D1E58261186D47529A3AF9A7870612DFBD49D8BC4025A686E293E795E757141EE682038D14D7069BA07CD1C5BCB3296B72ED4863240D2D01A011A8AE4D7B9B641F057D98BF099FB42C61FB56FC828F8BD41186C7A868B24AE21C466';
wwv_flow_api.g_varchar2_table(192) := 'C4B446E6B40BBD1423DFCDE014F890E20309D0A827F4D1BDA7EF009C28940E95CB0F099A56B0789D53B2318D3A0686D1F929B881BA8EB6CCB05899A5CC1D46BC562E0CD720366B5EE74E71B33BC35001A001E014DEFE208F9A2434068D94A6DE53A42465';
wwv_flow_api.g_varchar2_table(193) := 'E839609BF88ED9A9DD4F9F3E1F3C703DCE78D0858AC63E7711A865F450C2F99E18C0A285B1303430E9D4ACAE78ACB4162B08D875F483C95F758202DE760A2973BA53FA40D143ACA5C7E66D09334A4DE949EFB27CF9004950CAD8C3C6EDEC124A634B9C1A';
wwv_flow_api.g_varchar2_table(194) := '2B52B0EDC3E1E21EFD1F170A369D8EC3B7ACA0F9053F12241115F994E739E6DC493DDE0E3CFE9466AB6A6C0238A46BE46B4BBA1B520119ACE0D8F028BC9E79A86881A59BB0D14AD69DD7D7939DB2CCEDD593DC84D69E5A72D79EBDAB1B84E750EE80B283';
wwv_flow_api.g_varchar2_table(195) := '00ECD054ABCD57669505946E89B3DD3050EE6F9DF3B3DC520D2B21DD0681F91BEC8168302D11730752119E11D646FF00B4717871FAC238EC381F789FA2F5F82BC57B462F85C8F118FE02BDA4DFED9FF6BDA43FB6BDA5FE3FE57B4BFC5FCAF68FF8BF95ED';
wwv_flow_api.g_varchar2_table(196) := '01FDBFE57B41BF015EBE3E12BD799B143191EE50C4C27F521345A53C2CEDDC76269446CB5EB335D879471339FF00B0A32487ABCF6E8AA54A82B0AD5AB565595655F2B3CCE82D4F2991E4F8782A54A952AE5A2B0AD5AB567BC0ACA9BF0CAA1B2A1B2A1B2A';
wwv_flow_api.g_varchar2_table(197) := '1B2A1B2A1B054360A86CA86C150D82A1B054360A86C150D82A1B054360A86C150D82A1B054360A86C150D82A1B054360BFFFD9';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784241605725151268)
,p_file_name=>'img/hr.jpg'
,p_mime_type=>'image/jpeg'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/img_emerging_tech_jpg
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := 'FFD8FFE000104A46494600010100000100010000FFDB008400060606060706070808070A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA70106060606070607080807';
wwv_flow_api.g_varchar2_table(2) := '0A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA7FFC200110801A401A403012200021101031101FFC4001C0000020301010101000000000000000000000102030405';
wwv_flow_api.g_varchar2_table(3) := '060708FFDA0008010100000000FA2F3E450059188AEB1C9D6A7D12445C22E78F9E9965616302D8E7B5D2CFAEF9CF299AA8832CA8B2731B807466150590965E7013819374C8DD0A2F2AB28FB0534F99F3148345902E98371AE5D26E000A59B9E86E258E50';
wwv_flow_api.g_varchar2_table(4) := 'B6A534287D59463F39C916D0DBB26C522A8DDA6F88D0051CE44E04E6E32AEDAD85DF4E83E4783D36F38403D0484C745AA5B51210D55CC1CA1CAAEDDF7DD0AF4D1B7ADED688F93F3DD4F77E2384D039689208C637D50859AF43062CBCF251E6E3B7574345';
wwv_flow_api.g_varchar2_table(5) := '6ACD3DA87B3CBCFF001B9BADEBF5799F2506495B6CC8C615DD3AE3437AEFBE338BE7659AAACBB9FB6C89BBAE57ECF919FC61D6F45358F918308AEB14DA856DC042896EDBC51E5C6522744EFAB675A643D572B2F9687A4EE56EB88EBA4E765C7580055183';
wwv_flow_api.g_varchar2_table(6) := '9A70BB75D1CD82CAB977EF9E8D3D29B84FBD5F17CCBF45E94CA524CD7D6E1414389C8A90E96DA4A69EDD50E64F62D3773F7E8B27567E7FD0ABF19C57E93AF22DAA835F6EBE4D4A64B99C3C0500121C1CAFDDA7A3635175429E7E28BFA8F1FCDF12BF4DDA';
wwv_flow_api.g_varchar2_table(7) := '6ECCEA5DD54E2A48E8A3773B565E2F3F3C73013216FA5D546183D9B17039F39532FA6F1795E76AF63D21C11D2DD99E4CC1BB9DD6E55DD08F0BB93F2DE591127D6EDD1C6C996FD9D3E8F079D7EFE8775E4C5E4AEF55B2114AFEE535BAB087479BB72C3A58';
wwv_flow_api.g_varchar2_table(8) := '7C56EE8F9CAAB9CD1DFDBC6E5F243675FBD774F565C9AF9F4C974315C881D7E7733CE67B6DEB757B7949E4D38BCCDAE34623A971B6CE070E907E83B7D0ED3E753E6F955D65FAF4EE979EE579EAC6319D7F53D6EE407E6E5567A69A87675FABC1E46145BD';
wwv_flow_api.g_varchar2_table(9) := 'DEFDFDAB3CD66F19AE49578B263CCC053431C035FA8EB5FC6A516454266AF53CDE6716B7D7E976793E761C3C4BB51CF9AA51144829D8D92758364EE9C9D14C027BBD9F679D92AB347672FCFF009284118C4A95D120E71A66AFB1921893008C66C097AEF4';
wwv_flow_api.g_varchar2_table(10) := 'AED9F91F274C4AA51BE2494A1388D9285739C46ACBA118A751275CDCA40ACF5EBCBE5AC728A8ED14927380000C4A48B2310000000E7EBB5A072250409A06201A93274B71B1409C0004C05551A2D6D849C2034D04D4460DC9D64A2980E003400371A3369D';
wwv_flow_api.g_varchar2_table(11) := '6109CE31834D276C08B90D58AB945C49449D608060371BB3E6A2FD6E726A1000624C730B235CEB92528A00680098426919E99DBAC8C1004DD6D128B9D91CFC5C677754DC0000C5B425241140E9A0BDDA2024E221A0D18FE43C96EDFABF6E50000E45FD00';
wwv_flow_api.g_varchar2_table(12) := '0182B2B094B363E92000006295BF3AF1087D6F67EB000155E3F67A909CA364146700739AAD029440010E7F2DF3293EE7A7F669B4079CE2DBEDA416D52220016165026A512490984BE7DE292EDEFF0041EB19646065F22FD56D1960910061353AA75BC3C0';
wwv_flow_api.g_varchar2_table(13) := 'CBC5F49DBE882929737E34A3DAEC6FF6E3991C9E46AF69784C915B9C22C6494EB9E7F9CF1362ABA3D7F5FA1A09CBE4BE7E1D7EDF57D90C9E6F1F9BA5EB100C11380D30A6AD4F97F2DB3AB9B5F1FE87DD9000FC678DB7A177A8F4482DF33C33D674400006';
wwv_flow_api.g_varchar2_table(14) := '86A59E8A4E9D9CAF93F5699DBAFE8568081F8FE546EEEFA1B1060F290EA7A90040DA629519A111764E57C93AF228EDFB9B4000F05996DF7419F351C6C7ABD75AD00004A35E3AA4E1AAE8FCF7C9CB75BA65DEF6931A4D65F1D94EAFA1298853CBF5B680D0';
wwv_flow_api.g_varchar2_table(15) := '039AC59668BF45D0F8BF3747D37C95B93573FEA5B0059B2C239EE98010A3BB680C40325933C559BA716FE0B17B3A135D2A31FD03B853C6B980001553DCBC06200039AEB95BBE5067C16366FED6608CFB9EE8E146F001A0CDC8F4BD3013000039CE0DF45A';
wwv_flow_api.g_varchar2_table(16) := '0E2FCDF8D76ABF5747062E67BBF75E6B748009445F3F9E9BE95B7B5E9242600F1D309AD7A1353AFC2780923B5A7CFC5FA7F5BAD802198FC0F46C4A41EB3D080005388925D260E783E1ED9E827E745E9FD9DCC1C581CFF0FD092A340FDBF58000163AEB0D';
wwv_flow_api.g_varchar2_table(17) := '1B41C8F835725D67C917BCF4309D800072BC76F9531BCFA0FA8E200016D78B34C4EED64E52F85E292F4593947ABF41D4CCB5A6981E5F8DAD669E8B3F46793E400017D75F3612639F41397C678EDF71714FA8D1D4CE6A4D30865F19AF253BA7F61F7DE43C';
wwv_flow_api.g_varchar2_table(18) := 'E0008BEB8E3CEC8A1DF655F2BE437DEA78D2FA979D7A3B3B180274F83D5CDD1ADFD17EB5F37F3763BA1AE775B5C63862293B2115F30E2C9BB2AD9F40E297F6B63000B7E71E8E3C89FBAFABC7E3D9E6A31529ABF48A9B663901F2FE3484CEDFAAE6157A4D';
wwv_flow_api.g_varchar2_table(19) := 'EC0944CFE57A9ABD7FACF47C5F9E70985B0528B11520B2E9EE8D9F27E58C91E9FB381F23DAEF6002CB969D7F4BF5E791F975B28C296E7274DAA514C2EEDD67C870128CCF6BBB9C5FD6E83000CD551CBF77EBE1E5BC9D8A7719A364E12028B08CECEE5757';
wwv_flow_api.g_varchar2_table(20) := 'C660D8DFBCEAF00E968E9B000E678FAEFB584B46ADB3B1165469BB2A9406E3DD391F261B7A3D97AF8F8B5D1DBD060047E7AB50C005777765759056DB65229451E86DF2DF301B159F52EA78A5D5D1D09001CBF11BA60000767AA9B8573D1929B336FBB267';
wwv_flow_api.g_varchar2_table(21) := 'FFC4001B01000203010101000000000000000000000001020304050607FFDA0008010210000000E07A1B40510E57CFEBB25A7DF6F17C9396BDDFB567CAECF69DC0510397E12A65DEF3A8787F0F6FD8AF783E75443DDFA408A074F9AF3F98BBE85BBCD7CD';
wwv_flow_api.g_varchar2_table(22) := '3D5FD0CF29E23462B69F4DEBBA8E2306B8DE6F93D0FA1F2BE4BF4FF41E5BC1B85EF3D05BE8B276FD2F48901C5F19E9FA1F26FA970BC7E8EC73A8318B5F4BCD47576FD67674DACC9F30C50377B8EFCFE3A3C6A5DCCDC9CDBD9B1DFDEEE62F05B6CCD7FA8F';
wwv_flow_api.g_varchar2_table(23) := '2F0EF5F9B8F97D0F52EA39997838BA2FADD35CDE47425460DF83AFF4A84298B2046CAF91D5E8B890F974ECCBD9F670B52060116898808F0BCFF77D00DD4DC5824C4C900101A839B4E234A12248B04C8A889C25632137055D9223369A20125184E6C8B688';
wwv_flow_api.g_varchar2_table(24) := 'EC79E120AA5382649525AC69B0D31C938B79ED944262842CB2D9555B50DB5E4B62572B520911232D122843518B994C348D21A822DD2186E4E541B2ED1CA8324462E048E8D712351B3503173AA4A42845C9C764E0A5096F04EAE6D4E4D8422E4C86BBA24A';
wwv_flow_api.g_varchar2_table(25) := 'DB841879AD4AF105639BAEED716697213E6619C21ADA2B68932CD488D7B2F41CCCCA9AF5C870B209C344F48518BA9AD27CBC50A9834AC949C764EF919B275EF69F02114A24A20C21D0BEE70E79BF7B455AE655838A82AB023BF558CE4CF7744159680799';
wwv_flow_api.g_varchar2_table(26) := 'CA9C24D1FFC4001B01000105010100000000000000000000000001020304050607FFDA0008010310000000666B45405347BA954ADC2D053D5B49BC4F1E2758CCACB05414D1EDEC845C2E69DA7670F92D75B3D1CFA1C7E58288A4BD2741608780A7D37A67';
wwv_flow_api.g_varchar2_table(27) := '1FE7A6FF005789A12D0CCC8A88A08A3B5BA3D6A1E7DA9EA7E71CF6EF58EC9B6B4DEACCE752CDAE006C763CD667A8F996A7411D0874D2AA3A2AD755B47269C4D0B3DDC8E6D4E6B25BDA5D4AEA94A49DF1A248D9F3722C75FA32D5C0E7F4A4A714971F9346';
wwv_flow_api.g_varchar2_table(28) := 'BBEEDCD399EEA55E3B9BDA8FAD8D91629F2AD6B50001DA0CAE8892FA06C4D4B99E458C7A002B55451AA02AEFEF73F82885F11400001000D1A718A2000028802002ADB7D7841105114557310407B414B33C75E200024D10CA40D08AA28013DACE00409EFB';
wwv_flow_api.g_varchar2_table(29) := 'EC73E0BD1E3D301145125D1B75F3211DA362C7382EF54CA5000759A9A3AAACE71A2EED9CCCC34F539B8C141F7AF2E15ED374BCA089D2B7998E3E929551055BBA2DA35AD9A524182C8207B115D69CA20B77522C442F58BAF664E754042E6F46942002EEA2';
wwv_flow_api.g_varchar2_table(30) := '61B11D6E6B0B5B2A9806E7448B4B9C024DD2A648B66CD84AD8AC688BD2ECC7254E6805D4B851A34ECE8D8336CE5D3117A1D859E1E7A348D24DA5178FB7ACA41B9CE6588741A1A3353840207A8BC6DED308B6F97A022F4F66DAD6014101DC5695F25BCFE7';
wwv_flow_api.g_varchar2_table(31) := 'F1D51752AB125BDB2A2B9A0BC669DC17663C1C6075B8003A5B20E68ABFFFC4003310000201030303040202010206030000000102030004110512211031410613202214323051151623243335426171344053FFDA0008010100010800BCD36FACF2D222F3';
wwv_flow_api.g_varchar2_table(32) := '9A2719C0E7347140E0D1A5EE2B795C8ADBC6478C56460F4FFCD678ACD2BED228AFD4102BCD0382088A6571BABEEC4B52B139CE42F35F52A2831C602905B2C14B658901194D2B649227B767CC8BF0399327E1BD32281E41E9E2850FD7347BF07B9A14C022';
wwv_flow_api.g_varchar2_table(33) := 'E40EF4806EE4924925D77230ABBD0E19D8BC37765736848997143B35678E87C51A5665208015C003A28E9E3A038E6986304740ECA7222944AB5B5558646C2D45796345B24E796638CB061B9C9C15AC94183873CD4D6EAC0B2F5048E4361BEC3A5D46CC01';
wwv_flow_api.g_varchar2_table(34) := '519C0C9EE6BC741FA1A63800D1A45180C646670C4AD365108E8AC1870CC771152012A34725E7A7C619ED6582685DD24F1D0D1ED5E7A6F0C00720A9C153E2876343AC6E518D15E3228F7A8DCA30221903838652A796C9EC0AE083918C50DD9DF4093F5523';
wwv_flow_api.g_varchar2_table(35) := '20051BBB363270648565070559490DD14E0F2CB83C74C51F147F515E452F634DD8D226EC56EDD8A2702A34DFC06C9626B69A438614E7EC7A310AA58DE4E6E6E26949523AE3EBD781CD07E02B3A80015523140E7E0AD839A6518054F7A56A14B3EF203210';
wwv_flow_api.g_varchar2_table(36) := '4101932C76B14AFB3649FD0915CB727EFC9A539502B2CC72B345BFBB29562ADD01DCA41E9BB77359E051C6074CF06BB902B18050F029C57E9F52A7342D2E1C060839068F7358CD6B53FB16456B383414138ABDD2E7B448E4A3DF347B7C4315CE10065660';
wwv_flow_api.g_varchar2_table(37) := '32383F0C91D982BF20AE1CAB5102A395E33C24EAF8C326DC57F4CD8CFDDFEC0E1381C0E5010DCB6339FB1DD2C4B2AF1D0120821C76615740ACC4D09E61D96F675AB7B912E4513CE2B1B5779CF14C734000BB989C1AB5B76601D84EA001406D8EB145D548';
wwv_flow_api.g_varchar2_table(38) := '075DB857BA48ABB9AB1432CF0A53AB3AB236ABA3BDA932C58A38F183819E9838A8CF268386FD994AE33D4D1AF7390088F39D94DDE9BB52CF22F74BA8D88CAE0E0D630CC1B763852BBB92A5B715ADA377DBEA589AB98778322F4182A474BD1F74346A3825';
wwv_flow_api.g_varchar2_table(39) := '97F5488C0D9A0092053608C0CE05041824E49EF6D69EE1F71C90462867FED7C045152CA235E1492E3379319AEE69286735A664DD29115C9ECC4E548AD474257DD2DABC6F1B157EAA7B8A5FDABCD062B9C7D5BB3232921A9A89CE4538C1143B507CF0C550';
wwv_flow_api.g_varchar2_table(40) := 'E4874280E7A2B32F64BD906722E11F6E1431190CA81720281C53EDC80A5986D15730FB6D9148DB4834CBB588A6863908DC90420A803F63480FBA7319DBB9A93B0A2A7392CD96AB4B57970D5B54735DF2095DD52FED533EF7244CFED41349580319723823';
wwv_flow_api.g_varchar2_table(41) := '4707DE92852CB22F6696461CCF6B6F381EE4BA27FF00949A65E47934CACB8DC064D2FEC2BCF5576140A3100B283FAEC70DCCBE281ED43B9A3DEB7B2E31B86DC10A8C70BB1F686EA933AD473C521FB12AAC7009C71867E148474D94EA518A9A7E429A0A31';
wwv_flow_api.g_varchar2_table(42) := '9A19041A1C714400734E0AAA2D44B9C54C46F216DED7DC219D44630170C38A3B4A025A46CF174FB15CD715AB131D828AF14578AF4F46ADF9597B661FAFB32628C2D8E48C1C578AC9E281CF66B6B670FEE1D234D66C97F4C26731BE8D201F4934CBB4A962';
wwv_flow_api.g_varchar2_table(43) := '9631F714691D8721A462B828E9C6418E99549E197FA28FD77927ED942A2B61E76D24EE8305258DC0C658F03F4C83731EE40E287DA3C55D645BB858EEE74AFF0022F8A8C97009605D9B180AA1445698D923EDC122B1B851F18DC70A4E64EC97BCB85A860D';
wwv_flow_api.g_varchar2_table(44) := 'C72DAF4EACD1200D4726B4291912660B382705E75F0ACCC4E5D770ACD71E063C81C8A82DDDF96A6186229AB19A5B0B49DB6BCFA3B807DA92DE7848F70F66241E84F9A3CD0254E577B60020C64F381B410CACA4835BDB80D85209A22489F350DD6EC230D9';
wwv_flow_api.g_varchar2_table(45) := '40E495A953DB722A0477DE02E9B34C0A3A7A721C1DFF00E06C718A6D320EE82CE5866A8AD5625DCCCAB9AC7762402990DFF86BA8232B4753997857452FCCB204426B5604328751CF0FB460D69008B62E065451E03528FB93D1D477A24E6B7919AB284BB6';
wwv_flow_api.g_varchar2_table(46) := '4D348070243FEE35350351361D4D4C36BB0A815241246F73A25B2E76CDA65D21FA94747C39C63E4AEEBDB2A719D848245062282ABE36C5395C2C832C7EAB60B210D3222A280BF0F14CBF6CD670053DC4510FB49A93918491E47E0EDEC6B1082D99300F37';
wwv_flow_api.g_varchar2_table(47) := '326E9805D55B261AF270E726B4BDE96E01048340F00143F734CE14502C4D1A446660A228D624540EFE054E3127422877ABB5E54D40DB655A9D73193447151C10DC478966D02C1FF597D3770BFF0028E8DA98EEFA7DF236D3F87794411DFA715BC1397D84';
wwv_flow_api.g_varchar2_table(48) := '8056A306460956D6E218D07496E122EED7D26EFA9B9998D2DD4AB8A4BB8DCE28530C8ABABC9773222866CE0AA0243348C3F4C73D2F25D833441238D4D37421EBFF004016200B78D90C228607144E4F2990C4513B8E6B079159AB28703DCA66DABD6E472A';
wwv_flow_api.g_varchar2_table(49) := '6B15CD62A74CC39AEC6BE8D1D11E2A03B5C0E8CC115988D7E0DF86565750CB835EA299418610C3B515C0CD7014E6B38390086C03A65B104CAD53CA228C9A672C49325CC71E457E74951DF6E601B35673B3651AB50882485DB7923150D9DD4D9F6E3D1EE8';
wwv_flow_api.g_varchar2_table(50) := 'F125BE8F6CB20F705959800095564272DECA702E23F7EDE440CACA1B3A7DB19A5DE50E080C4D0EF59DA1E848067008350446693140600A90E4E3ACE32947AAFDA31971838AB6398F15329591A877A460C8AD5AAB0163280473C585FDC5A7092EB93327D2';
wwv_flow_api.g_varchar2_table(51) := '579DDCC923718C63B9ADD9E6BDADE69AD6403205A5C11562196DD4355D316988ABB94A2601249C9ACD5B5C952159491CD46E1D15825ADBDCB6C9A1B0B3871EDD5C2F66AED4B7B6C454D74794895FE82895C7FB82D6D9DC6F8D228D36A343ED95C26D2148';
wwv_flow_api.g_varchar2_table(52) := '380715838E76FF006B1BB150A1ED6CD02CB2FA9F42897264F57688A8ECAFEB9BBDCC565F5B6A8F1E117D6F78620B245EB25DDFEEDBFA9B4A9F830DF59CE71142018D6AE536C9916CDB64C55E29FAB50AB7701B69D6FF00F8F1004528C0AE09A2B9EF2401';
wwv_flow_api.g_varchar2_table(53) := '89C35B3EEE1216CF2B0F03AC1FA53921090C49624DCB1699B35DBA2FECB5E2AD73ECAE6DB3EF2E005ADA3C6A1702110AD62B50888BA721EEEE5C60BCD2BFEC4D679A8A7990FD1757D4140149AD38DDBA1D62D98E1A4D634B8232CF73EAF88362DA4F566A';
wwv_flow_api.g_varchar2_table(54) := 'E4B18A59A59E46925A1DE9850AF35FD51A3C0AB1D7F55B065310F5BC12227BB67AF69975B423CA5D46681C106B524125A835240A45055551969EDC776BF887EAD7F29CED6BBB839CFBD3519652284D30AFCAB8AD36E9A50E8F52AED95C55EC7F60FF0008';
wwv_flow_api.g_varchar2_table(55) := '9774883A44BB1145473C50387923963954347CD6B849B9896AEF5CB1B3843493FAA35095CB0A6423028A36335CD3DC43167DC6D4EDC76935590FE925D5C4A496F977142BCD7F5D3C51EB6F7D796ACA60B7F585C2A01345EACB070374DEA2335B98A27BA9';
wwv_flow_api.g_varchar2_table(56) := 'DFBB3331FB74313820305538CB34207267B6E6965B724E014C0AB360971195ABE8F9570E81D4A992278C906954B30020B7F6865AD61F71F3D3549084501AF459B6E0FEAFD636148E6D4B5199CB49D0EB52950A0EB374790DA95F1A6B9B96CEE1DE89C506';
wwv_flow_api.g_varchar2_table(57) := '52714241814D22826BDCA0E696624D1998771283D84808384911B20075238EA7A9A19A34934919CA7E75D50D42E850D4AE68EA9798203DE5D39E5A591BF6EA92CA9FA47AA5C263363EA1B09D144A1E0B842125B578F91806BD887141157B4504929E2340';
wwv_flow_api.g_varchar2_table(58) := '8B817BA85AD947BA6D4359BABC95882599B26B3F0DEB5EEA90483235090E787190B94641BB2324B679CD0EFC1FB1501B38C860096AC7F658B70C1F049219B6EE21C8AF74648AF790D2B2B0E3FBE87B50347E7B85096338C020FC52478D83A697EA46C88A';
wwv_flow_api.g_varchar2_table(59) := 'F625B1B8CB45F8299A16908ED34D05BC7BE5D43D50C729672CB24CECF2EE515EEA0C57BA0F3465931C6F6E71BE5ECAF6CEC8C08B538C51B539DC05AB52DA9CF26DB2396B4CF6303F38FC77C000DB1236D1B6268DBE450B6C6057E38CF3F88BCD1B493268';
wwv_flow_api.g_varchar2_table(60) := '5B7342D7815F8C79A369CE696D5D1314229C62846DE4420AD7B7835ED9A2AC2886C8C7B6FCE2449C1FAAC539CE45B1F26DB3835F88772D7E3BD186434227CD08ABDB34636AF6CD4133C1324B12FAA8FD4337A9A62AC12EAE2EEEA50F37B2ED80C6D9C86A';
wwv_flow_api.g_varchar2_table(61) := '36CC735F8A5D8D35B9C9245B3F35F8E739A68242727C7CBC501FC24560E33583D33918EABD8530C1FF00E84B292ED5132B2022B95C74F23A609A000CD30EC680FAD038EF806B9C628639CD0EC7A0E8BC1147BF53DCD628576A5A2334B9C5363146850A3C';
wwv_flow_api.g_varchar2_table(62) := '1A14FDC562B147F5AC107F9248B71C8C346F4278B3C920F6C71414E6B191478ACD771429C5628D01C13D076A039EA9DCD3039EA688A14CB8A4A239A1DA80E0D638A60314A0579340F069BB0A0781591934C723E3E0FCC2D11835807BCD073F5532267097';
wwv_flow_api.g_varchar2_table(63) := '1C00C8CAC32338A383835E7143A3563A6715FDD78F8276A6347B74C9ACFD690F34E693BD63A29C1AEF9AEE3149DA9A879AC7D6BC0A3DE8F6FE414791D0E29915C619ED971F4FBC44525D3719575603041CD2D13D4AD63E2079AECBF134B80335B81A4EE7';
wwv_flow_api.g_varchar2_table(64) := 'A1AC720D638A00E681E69BB0A15E08AC7D7A67E1E3E614505CD15E2BC50C11CF19C5628807029E0539C1876F7133AF78EE63635E28F6A1C8E7278ACE3E249E051184E40AC75C605678C50A4EE7A1A9A548A36791FD55A2A2BE3FD69A4D7FAC34962055AE';
wwv_flow_api.g_varchar2_table(65) := 'A5657A99B7A534394FE18AF166B878E3E83BD6E34A45134A400726881D01228503C628C287243C730231EE3A9E12E188C1F7631DCF61D71C51E9B8F14CC08A2738ACF8A3CF424F9AC7143BF4BBBB8ADADE59A4D4F56BCD425767EB034E92A3C3A0EA13DF';
wwv_flow_api.g_varchar2_table(66) := '58EF9C1C529FAFCF8AD5AEFDA8C44BA6C021B543F3607028B5628D7147A78C50F14E88DDE4B724607B680904F65A3D31D735E0D63E07147A01D8D64115EB1BC6F760B3146BC74D280CCD5A24E52E4C3FC33CF1C111792E2779E6791ACF52960215C10CA0';
wwv_flow_api.g_varchar2_table(67) := '8E80E2980E30C2BC0A60076071C51344F6AC8C9A3E7A034E781D0806BFEDCD63B51EE6B1DA8D29347A8F3D0513F053806BD5B9FF002E49A3428569B0958DA43A4233DF464750A4D1EFF0D6650658A3150C2F348A891C61234503CF55248AC1C564E298D7';
wwv_flow_api.g_varchar2_table(68) := 'FEFE3E29F9514A781D073C50CF1D33D168F45E41A039F9A704D7ACED889EDAE40A3D2D6D217B419863F6A244AD0A455B9743400C668F6A4ED4FDC51E9757715B26E69E679E5791E0B79677D91D9D9A5AC7807C746F15801852F9AC0C1ACE4511C8A23934';
wwv_flow_api.g_varchar2_table(69) := '7A0158C668D015DD680E28722971914E300743573A9595B1C4B7BEA6F673ECC9AA5EDC20CDBDFDDDA5D301FEA49A0D8B269FA9DBDFABB45F0C71D1456B561F9FA74F0AD1E9A6DC0C085B15A59C5FC1D73F5349DA9E98D5DDCA5B425DA79E49E42F277E2A';
wwv_flow_api.g_varchar2_table(70) := 'DEDD6DE2545EBDF14782294F2687EA68122B71E29739A381F0F14318A539CD29F140F143F6A627152CA90C524AF7BEA3D42EA665489E62FC4F03456A33EDC970916D96DE6870EDEF46B0FBE7D33752192F0324AECD8E8067A1ACD64F140E457A9ACD6D75';
wwv_flow_api.g_varchar2_table(71) := '593674D3A22B994D68916FBF434D8E8052F048A3D8D4B22468CEF757325CCA5DAB4A87DCBB5639C9EA3BD6689C9A5CE681E7AA9AEFD0763D003835C6D340D3C9B7B19A5E85B22B58CFF8CBBC7B71824B80BEFC7EDCD242EDEC1120B6984425785C189BDB';
wwv_flow_api.g_varchar2_table(72) := '98B08AB45D3D21B5CD2A05E074E3AE681AF54DB25C4B6CB474CB81DA2D2F90659B01140470CB9AD021389A6A3D01C5735FDD6B175965817A69B6A60832DF2EC4579EA33CE3A038C8E838CD34C9D9656738DDB01C1AF6C560D3280B5AB0274CBCC6E333A8';
wwv_flow_api.g_varchar2_table(73) := '0B0FFC4C652DD81BC2CF7C8C658EA2B108EAC6DA549AF52DD5005C01F315AD3EEBF61D6D208AE2FADE1922F4E429264C3147146A8871CFC2E75382004091DA47776AD32D4CD3091BF8479AF1438E688A1408C1A69401C3CD231E598E4E770F19FAE6B19A';
wwv_flow_api.g_varchar2_table(74) := 'E38A6E54D6A57B63696CC6EF6F1EE451DE068405FC581635DF2CA9EC9151D94920DCFA358AA6A5038F23A9F88ABE93DCBC9DBAE97FF55B4E9E2890064B5C46BD9EE1DBB3658303756C2220AD5B5A4B72D84821486258D2BC7CCD0A3DE8F1D24902534ACF';
wwv_flow_api.g_varchar2_table(75) := '9049140AD33D16246292DE464195822518371730DB42F2CDA97ABEEA6CC76734D2CF23492DBC8EAFB56DA1DEF97102B49B516C548DD52DCCBC489A3C8925E40E14648EA7C7C090054973E12EED5E1727A2AB31C2E9F673C5770DC335CC84D0B99706998B';
wwv_flow_api.g_varchar2_table(76) := '1CB759D43C6CB5696725CBE0430470C6113AE2BB8F90EE2980A24724C93863842083F640BE4F3FA804A9A8A0C9259238D7B0618A279AD4755BCD4650F39AB74B7799167D02CF41886FB2D736C5AA5DC5159C48B1645E47EDB064607F0F02D2736F750CC2';
wwv_flow_api.g_varchar2_table(77) := 'DAF2DE70A17A1F1D0900124DDC58CABCAEFDE880460FE1DB6734888830A7A78F83385ACC92B6C486311C31AFC8FC33934287714FE2A67C9C5396F18E092A47240DEEC052284C511919A1581BA8AF4CE4D79AB5881940A82D5CCF9924492D25DE93CCB34D';
wwv_flow_api.g_varchar2_table(78) := '16F9AE12214D2FDE257927CDCEF6D0B5337F0481BA4F32C31976F7A59D89703E5E3E2F2002A35927608B0409026D4F8F9FE0CF22BB1CD139EE4A0ADCE4540312724E693B74079C963CD78E887914CA23F6D825F40546EBB93DD8A375B8DBF8B066CD0ACC';
wwv_flow_api.g_varchar2_table(79) := '564B97D978AC7DC895B3368DA8DBC57D144BD351937CEB1D4406DC8F978E828D5C5D416E9BA5FF002D6D2B002CAF34E28A90FF003B85573967E283499E379F2B261B343C5762450EBAA7A7EC75205DF56D0EF34C7FBD473BA02B50CD064FBB25D5B18123';
wwv_flow_api.g_varchar2_table(80) := '8C6A912808219D6542F4A9F9733B1D42E999CC2884A9C8D1BD57DA1D403A940E118CB333950075F1D0753D1885049BBB96B9B9790C69D8F437572C8109663DC120F116A37D1636DAEBF9216E5595D5597F800E454EAA24DD4039CD6D2D907620030509A8';
wwv_flow_api.g_varchar2_table(81) := '09DB823BD0ACF3D375491AC8A524D7FD2D6F0C135DD98E83CD78A87DE454091DE451A30A249C923A683AB5E2136550020F1FC57EE52D2E08519614BDBA1E050607E1E9E91DA0990FF00CD4C3E84D6E4A0DE013C2D64738594A10695C32E4751C9A6EE2B5';
wwv_flow_api.g_varchar2_table(82) := '288CBA7DDC63A0AF156B3C2628035EC96AF048475F4F40089A5308C2FC7C7C456A87161706A3FD8528C7463806A262C07C344B568B4D8E63FC0288CE6882B9A60E68035B73CD170B514BB4FDB3D38AE76D3F8A64054832C7ED4B2C67FAE9E2BDE93D8892';
wwv_flow_api.g_varchar2_table(83) := 'AE208FF0FDC5EBA2C5B2CE0CA6319131DAA0D2B7D413F11D7596034E941871BB90723A4E711B5438D83AE87E857BDB6B7BBBBD6A382092DADA1FE0DA36D118C55CA28C391B0F602B1906B68A20798A700853D07E869288AD506352BE142B35E285CC1F8D';
wwv_flow_api.g_varchar2_table(84) := '1C66F6078633B723A7FA745D6976F7B6768A23548C270062EBF45AB7CF3F21D75FB905A3B75841C50A2C0305AB96C955A85481D0432989A51A642D0699630B6B80FF0092973FC0688C82688CAB0A385241C8ADE00ADF9140E299CD473EDC0A8DD0AE683A';
wwv_flow_api.g_varchar2_table(85) := '804509117B89632335EA0006B37D815E2B1C55B40925A3B53CC1AC258DB1D3D3CFB346B78DE3BAB7F708A4756C15BA2368156F9DBFC126FD87659595B5A09AE258BB7466CDC0ACFB929254600E9E8D8ACEFBD34F68F5EA4502E206FE1FFB6B3F53D2E231';
wwv_flow_api.g_varchar2_table(86) := '90E063C115C51D9E7EBE335FEDD18C1E69DF0800762D8AD7C6357BBAF1D0D69D74BB12337501F76444348A5DD5448AB6B61EDA74B6FF00986A0CE31F1C51EB70ACD6B73883CD678CD72C49A893FB0303A7A0EC2F04D36A06BD55A8CBFE444310BDBB5392';
wwv_flow_api.g_varchar2_table(87) := '6F6EC90C06A320FD935180FEC7538CBE105D406BDF871921948045638E8C032E09DCB9049A39C648240ACBD6E71DF7B544C3277124B7D8F249AF517FD62EA8563A248EA30126950B95AD3A1F7AFED63AD51F11C6BD6DCFFB956FFC31E0AB0262314F2467';
wwv_flow_api.g_varchar2_table(88) := '49854EE99AF34A42ED2DB84D848E9E9DF465D5EBA4F7F34714166228A1BA8D2DDDA4BE952E6EE79DD23848229A38CFD46C51DBDA07B18E6158001DC1A30780CEC0A8F6C2906A29A65C91F9F3E028FCDB90796BA56E49B9880E1244901236D051E72B4222';
wwv_flow_api.g_varchar2_table(89) := 'C32000AE417186C0AF509CEB177D3346875F4FC264D52123546CCEABD6DE52DA908EA1C8C7CCF49DC8C0AD5EDCA4CB38B08C9B5888DEA321F45F4CE91ACE9C26934CF4AE8DA6BAC9156BB78B6764253A96B525DA7B71921719325BF9DF6E718F74062286';
wwv_flow_api.g_varchar2_table(90) := '48A2AC3B0DE3B96EC0E53CAC8A0FD00734D8041ADD1A91933479FA1B807B7B99EE1E4CF1EE05E5E3B9228CEFE3811A9A34A84F35AE1CEAD7B5E2851AFEBAFA56326F677AD479BA7EBA749EE6AC58DBE327E59347A5C21665AB9B68E58591AD5235B74DFB';
wwv_flow_api.g_varchar2_table(91) := 'CE38F46211A54AC7A7AD029D21370857C08C81C01364533CFBB14C0739DA9E027F5B594E46E4F236F7A3B2B11034899228E15F14D22790D0E46498CF6F6D4D7B47C7B4735B16A251ED9CB2A850C15CAE2B557F7353BD6E828E3A8AF472826FCD6A69B670';
wwv_flow_api.g_varchar2_table(92) := 'DD31563A5A4666BD6889E287F04E25FA9454941FBCAD046A5DE7D62D554887D2DEB6B0B6B08ED2F47AD7D324669BD6FE9A1DB5FF0058E977F6CB6F6FEFBB9040693934659877499DBB09252B8ADE4A1DC5A23DF30F85300E6BF221DB8AF7EDC0C02F95E1';
wwv_flow_api.g_varchar2_table(93) := '638B3921555BE8ED3E0E16498D6FB8347DE1FB076C9DA05CD08E7039560014603DC20548E90ACB233B977673428F6A02B3D3D1C8DED5DB56B56E42C528E96EC7D855A8B19A19AC7CF53BA8EDA35669AF279CB0A08C5B9118C83407C15D97B25E4E9D86A0';
wwv_flow_api.g_varchar2_table(94) := '8D8DC166700840C18024E322B73E3EA5A4ECDF6009AF708AFC9C52C8F22E176485305923E2BDB1E099699B1FB9192298782616232A2DC63908CB2648DEAF93AC4C23D32F5DBA0EF46BC559DA4D773A410DAFA4E087125FD947651C0AB69A84225B3957AD';
wwv_flow_api.g_varchar2_table(95) := 'BEDF679B7FDA87C4F477544776BBBA7BAB8795A1420E680FE18A66898110A1963575C4CA0637B82436E62701B38E7294594F148F1A76077762DC1147DCF0D9EE43C6BC937284614957C644684657310E0C9C3C54C03020FAA06DD22403A9AF143BD3BB31';
wwv_flow_api.g_varchar2_table(96) := 'CB7A6176E930D5E1FF00682D1F3D2DA24306FA81416143E27A6B2CCBA7CD88C7349FC7A7C22488E45BC4B915ECC74218FBD7B30F6A36D167878FDB3C10E0211EC0DACC67010F1F42B92AB1EC634935421DD7342DD704994AC6DC1BD981C0FFC400421000';
wwv_flow_api.g_varchar2_table(97) := '01030105050603070302040700000001000211210310314151126171819104202230A1B142C1D1133240527292E16282B223501433A2F04353637383A3F1FFDA0008010100093F00602CFCE2A3C8C0E235464409DC4A1DE060E230908C8CF71D3B9439EA';
wwv_flow_api.g_varchar2_table(98) := '8231E9718423862B7954081D60AA0CDC714D0338D787764BB3CC9EE113187775EE1F11E34B8505489844924D4A188885FE9BB300784AB389C08A85A21DD30540708E7BE4F7C2C0E184DF421100E726A8A97220456315AC9BAA854E48035E2AAE23A04EF1';
wwv_flow_api.g_varchar2_table(99) := '0E87BA00D409A5F883EEB18EEEA6EC37E68C99B8997E2328EE00E63A85A704E335F01F914C2D70C41EFE5F167414171EEE0687785CF76EBF14D976735370A098462AA437D4A6D108D5603334928980A9190CB8AA4668106F1233184A3232384F93CCE835';
wwv_flow_api.g_varchar2_table(100) := '5007A529374802A4E81015D30BF5B8D0092A6A69E455B58DC4E68CB64C1CE9DE00A277838F70804053250A206408846B19E0141040DCB01400222B53543799C16431C11AE450822F3F76A24F774BB5589404835DD7B6B359C46EB9A20E124040203AA03A';
wwv_flow_api.g_varchar2_table(101) := 'AC6D0EC0AF5B850AAB1E05742723DFCC577A2056ADD348EF1500D64600204117E1A232E34034441955D02300F5289AAA94D35AAC32033408850D2D14DF7E20A0435D84913713512AD1DD519E2841B9B9102452F04C8F0E87237086CD37A20680826F224A';
wwv_flow_api.g_varchar2_table(102) := 'FF00C315E2EAA08482F1D0204B488237141CEB2CF56F913318EA6734381D7BCD9A928ED61862677770ED0DE9B0622B82874E1A046A731540B7527154194E2565A670AAE3905B340B1CCEB7C48A8A54DDA45CCE68CBBD04A249580C37DD374EC654993F45';
wwv_flow_api.g_varchar2_table(103) := '1047169FA22399208DC62E6D4AC768555769D4E180B8996B49479A320A80EC4D9E4782696B8620883DF388854C4C1C10823BC240006F013E0C9A1434F5ADE610127E218A719033C51139B8E4892653A9BAA4A0990621606EA8CC61239220C695084C2B36';
wwv_flow_api.g_varchar2_table(104) := 'F45BEE890298832748BB09EAA607DD06B010F00C5088E50A038F43C50618A78F10B20B01447EEB0C713417E1B1714E2ACC1DF8156DC9C1596D0FE932811C477B0998C90D9CA4579A70353BA8334D3DD39CA60E29D127E2FAA1489F95E646853B66300865';
wwv_flow_api.g_varchar2_table(105) := '0BC235409409256571CB48C3BA089135C2B9A923130325864A433DCE814081004B65133759ED40D0984EA9BB17DA04501543F2AAA69502E06EFAAB0B323F4C1EB42AC9CC89FBAE31EAADDC388055A871D0884C0E0330531CDE22F2419F655824D77AB318';
wwv_flow_api.g_varchar2_table(106) := '0C27240E7FC27C61884E6935A618714D380F5BFC5526BA94082BC42B868338BAA1498C963E817A14002061BAE8A1999D77299109D237D53026C388C141CA823040CE7483C17EDE138F446629EDEE4AC16EAE934A212691CD110DA12732B8AA05831C668B';
wwv_flow_api.g_varchar2_table(107) := '9DD9913398084198B8D7E9458DC47CBF82A8B59CB2520531CF3BB237D88E2287D15A499C0AB32DEF120AA8AE3BD34814FBBFCA7098920D1020837788022877648C103039D72542330A01CB45E23A9C11A7C9606A250268329ACA1B2D342655A3934AA183';
wwv_flow_api.g_varchar2_table(108) := '1528023E19132AAFF622A81353EB5F62B3A94052BCC5111AD70A7C938BA34AE02135B1BE4A028A888CF059A2B37131BDB0BE19E8D345FD43E6B7FAC1BA3EAB14790A26F8463231BF5BF5B84B5C20829CE00E19C268781982985A74223BE7965A21140247';
wwv_flow_api.g_varchar2_table(109) := 'B955024DDEB5C550931078632A610AEE4493C500077A323CF042847CA6A9C38664609A057138A24A22A271C56D1AD08812105837FC8FC8E0802D825BAD72E574502A51C638C11EC89C49EA67E68A37C44F2FE5135E4B2BF4F22C98FD9A5404E7D9FE933E';
wwv_flow_api.g_varchar2_table(110) := 'EADD8FE20B7EABB31E4E695D9AD6468D242ECD6BFB0A1DC93BF3C1419310319E1702E27AD02036A2B74928084E4548BE5A038D7335438A26412081F55E1C30EE0A9247091B5E8E580B491C1ED9B854946765AD00EEF87E6D42974AC17347E54F9059E14F';
wwv_flow_api.g_varchar2_table(111) := '222906E9322ECEE300092AC5E1931B5434D602208224108200BAAE3B936E15B8A81809D10111E1376392C4A32744D09A38DC785C0BB68D34A6AB0131CD583DC358A2D966E353E88B9FBB01E8BB358FED084A6ED3A660638CAB303C34125D046182A1143C';
wwv_flow_api.g_varchar2_table(112) := '9076C5989711928906BA78B3FD27D0AD71CC5E0FFDD02AAC3126ECAFCBB99B6ECAF29D05D007544C68A4B73695601AE39974C22E712649408470C6AA2B964A881299EA10208D6B765446AE46FA8271BB309A48C8490BB3B0119C49EA7B96CD04182098AF';
wwv_flow_api.g_varchar2_table(113) := '340E85C333981F3392897610099E033E253E0E85D31C9B0131A6468CA8E554C6B5BA01081D907C2E152CDC756A3C20E3C0A8F6F744E3995875F64249C3A6ABB459B0C4F8DC1B2BB7D99FD32EF6956EF7B860C0C74BBAC05D8AC8372049956560C3A804FB';
wwv_flow_api.g_varchar2_table(114) := '95D92C9CE8AB8121762207F4BE4F4202B47591D2D047A890BB4D93CE8D70251E81030567AA8D2E38A9ADA89E8550A89CEE09A699AB3744207146FD5639299EE9CEE2142254F442AF7C19C85CD30402AD08111028234A27B8D22A495A5D6AF6C0C9C42B69';
wwv_flow_api.g_varchar2_table(115) := '8D5A176765726D04EF0657DA3176C6E38536FA357667387E679D93CA13D9633F95A09F59568E7BCE2E71249F27B53CB73B3792E61E45762787E7B2E042ED018F3F03FC2575BF00E0548440DE9E3955309E29AD03AAB42AD1DD4AB4775568EEA9FE811A83';
wwv_flow_api.g_varchar2_table(116) := '4BB559F7231BDFB2D189568D7375066E9A59CF52AD039E5A0FD9B6AEAFB2B3B168C84137040C118DCF028839DC02601C6AAD4D790FC0768B4641C01A745D99B68756BB63E4532D18FD0C475562C8342E2653C8E144E26F1B358AD215A018E4724E3319C0';
wwv_flow_api.g_varchar2_table(117) := 'AA78C47C639AA8DAA78861A20660CD7A278C2B20E7881170DC6E06E15254171580BB556A58ECB64D4AB50064F700E72ED76CE3A979BECE80463BE5403332492655B102B4119AB7B43C5C6F226BE8A4C9A6F426B1C4E88602BC7408019BB726D250044658';
wwv_flow_api.g_varchar2_table(118) := 'D0C2EA6811A6B9220A35F29E5AAD4F409E0F20B63A27800800C3464AD9DCA89EE3C4F71E420D241C702AD3ECAD3021D41D55A31E0E6D20AA8B981340429A9B9F04FDD68AB8A3B0CC80C611249EF15262AA1189C371D0AC67D9676867D4D5183F11D37054';
wwv_flow_api.g_varchar2_table(119) := '81FB47D5088149CB79DEA8DCB8EA868473CBA8587C9D45CF9D0A12670CA42A8C78C67F45949E6003F2466A7D0A0721D4C228CC798538570EF3CB5C3020C1444656BF5568C7E7E174FB27184D4F6B1833344C8FFD470F60AD0BDE7124CA2A6A61031AE9C5';
wwv_flow_api.g_varchar2_table(120) := '06D7039722B2A467251040A49CCF24F15307484E18475327AA700EC678A70D44645111984FAEB09FE9B8A231A6E9C4A22061C7528D33D494F02B38279CFD6A9D4008E48F14E35C77A2D29C9DC698D213F1109FE89C0E8516C6614228DC130A8401128819';
wwv_flow_api.g_varchar2_table(121) := '8FA14F4EAF04E103F8440CA9904F84444714E445F6843D86410BB1FEA3B71D042ECCD048F092E98E2215A979DF403804F839C27CC823AA78C67D213842709C88A14E15CC67C4280065F4D1387523FDA6A018A123CC3FED2482AD00E309ED08D3FDD00E8A';
wwv_flow_api.g_varchar2_table(122) := '45708098EE20233FEE6D0501C3040B74F194D9E128D67034FF00731737A008388DF0A41EBF86B46B18DC5CE3002ED05E5B9063BC5C158F69FDADFAA67686CE65A3E4576863E0540C47107CC6CB583C4FCA741E73402730A48DD09FC7C4100EDE0A747E09';
wwv_flow_api.g_varchar2_table(123) := 'D0D6364AB570B327C3641DE103B85E2D1B505B884C2DB4638B1C6203B78F28F8DE2BB9ABEF3C071E7F800ABC4A0019C27F006EC00FB476F2683BB8D161683D457C974098E256668341A225D67EA3823422477079A3F059D9323BBF150700B068713D23C9';
wwv_flow_api.g_varchar2_table(124) := 'F8449E77092560D000E5E41FC58A398584EF064771B57CD74466062B17B69CABE462706EAB1714D93E8155C7EF3BF0F6ED0E8FBB89E8176571D1EF30278056C580B7E0F0E2BB4DA104D6A4AB16DA1764DA3907B4B080F6B84113E47DF8DA67EA187731C5';
wwv_flow_api.g_varchar2_table(125) := 'B76A47A77F1C86A519370CAA753F86FBAC6971E013FEC6C84D1B8C6F29C09263AA71276C13BA8A3C2D83BA16B8839A68DA2239E8AB2187844A023C8686B2D1A1ED02834378D1ADBB0602E3EDDE34024AC3E11A0BB0678B9E5F8305C77261EA2F31FE994E';
wwv_flow_api.g_varchar2_table(126) := '324E4B025B0382925DA65154D10625C7129E25D4840D1C46E9542F83BE079261CD6133C4A2C3CD3F9054BB321A3954F7B015771BC43DF53F21F81209D2506C69B4834706CAD9FD97E562E3D04AA212D6B26551D5EAB31013E60CE087DF7412840020793F';
wwv_flow_api.g_varchar2_table(127) := '031A3E77825AE0F063F4AED0F2CFCB001EA9B0D68803BA76DFF947CCAC5C64F3B878186789F30F7012891C8044C716A91FB53BFEAFA2B3EB37DA00C7B48D9CDD342004E3134D61097C401BD3C07E3B52ADC39FF0918A76CCF54E9D96B899E11E5605E638';
wwv_flow_api.g_varchar2_table(128) := '0A5FFD7FE26F8552A8113071AA9D9370A0C5C7008500EBE70253E068213BAECA741DC5A13C7EEFE13BA57D804E81BE7EA9809D615A0631A2A4A6FD8B27EF982E23E4AD1CF79C5CE324A05DB540DDEA40569349262000ADC46A0210C0E8E28E3B5D630F27';
wwv_flow_api.g_varchar2_table(129) := 'AA04B09A1B8127408001934389910A02238C224F7064A8D1F79DA210079C7982250078D11B30AD40E154E2776C929A00E85345EFA0FBAC146B6EB53656671786ED47256CDB6B68ABDC7C606E1927784BA4C6A44909C1C4E31EC8C6D82085666764785027';
wwv_flow_api.g_varchar2_table(130) := '61E0C2B4697113B381E9DD301495D2E1456413001BBC81B46134086D40F389E486D0D0B55901FDC9ADE85C8BBA00864B5EFD5D926189947C27FEE0A0E6363DD55C700159B76DC67F48530D3400E881DBB22019CC1C0DFD354EF0E4D180F341A9F11C82E6';
wwv_flow_api.g_varchar2_table(131) := '733E7B4E3A909B69D559F553CA83E68E5BFC9C67144839D1121A4910812E810530ED86C89424085D9C0DAA880A8DB51B3840072BCD1BEE7CC781A0CCADA1071215B36B91A1279FE01B9E4D94C77ED567E908B7F72239381EF34D9DAD7FD466278EABC764';
wwv_flow_api.g_varchar2_table(132) := '4F86D5A29C0E86EAB74283C0CB6539D4249909B20080536231461A11218CA1DE4224106853BF4DB47F92702D226461081AB8931E59A00B09F08D1A2FB7B42D02009289457687F0276BDD300FEB6FCC220822411E56CD79144F54679CA0678204F1859779';
wwv_flow_api.g_varchar2_table(133) := 'A0870A83509C5818DDA7591A8E47BA490EB30E8D6455596C9032D51937F8EC5ED38E2CE0B9F97FF96EF24CB58E1B3CFCA028B613870FE02070FCA531DD00F75EED59F7B17585A01C63BB2D73063922D2F8A7700924307B9F33F2C75A21DCE7DCA1B67BDC';
wwv_flow_api.g_varchar2_table(134) := '3F4B61BEE0F96493C97A809A0F20811FDA0A7C7F6A7D0EA23B9ADD98828D58F2DE863B821BB239A792644F73305DD4A1447359F9399681D67C8ED3B1676803C59B04B8B4E15C9303596560035A321E56886E352101FB894D53E85077B7B2681C44A22388';
wwv_flow_api.g_varchar2_table(135) := 'EF65DA2D7FC8F704C35A0A74D9B88ADE7C46CBFD4B339B9B43B2A08000E977E6531E49FBBE2771CBB9C6FB379B36901CF00EC827004A10EB3ECF64D237B5A02CC363847979841DCC047FC53FD42AF33F20984FF6952DE615471947AA28A70E7459DA4F51';
wwv_flow_api.g_varchar2_table(136) := '3DCFBC11F1088DE26F142D79C72712512049027309C08DC8FC5E4805D149C277A8B4B682EDB70CF131A5E704626F008FB578B519C9320DD89610791F30638E08C731F247DCA2EE8E51CC7D4A2396CA73BF7043D4A194C2066105AB7D5A3B8D0291233432';
wwv_flow_api.g_varchar2_table(137) := '91762E200E68D196618DF6BFF2A34F267FE53FD9152693DDB47B3B335A5BB20C0B577CC0B9922C98038C8C4D55948D090ACECC3742492BB37474A96F140386BB507A271E8AD1BCCA33BFBA4227AA61E653009C21A81E8BD97F8145159AFE8FF01DC29E41';
wwv_flow_api.g_varchar2_table(138) := '7083BEE300DA09E02AB374F4BF4F2B038AC58F2D3CA888A7840549C59972420CD45CC758F67150C347DA7D026358C6C35AD140004E8164D927FA42B3731D68F2E3127138484D79E33F356498E1C0FD0AB578E68B5E3FA855766E90AD4B0FE577F2AD2CC8';
wwv_flow_api.g_varchar2_table(139) := 'CC01FCA75934EE6D79555ADA1CA0D0742ACC13AAB3B3EA506B4C6B445A78556CFF0070211B35B27810A87710A554138AC8DDFD1E8C1DFF008039C7A423836FC1B644F3308C4F92F7B41FCA256DC3F1247C4BED262641002FB60353FC275A8B46DB39A5EC';
wwv_flow_api.g_varchar2_table(140) := '741220183B40AB02FB56E16968769C2E6170FB4022631053BEC999C384B97691E8AD8BB77FF89B26326995684681E14109BD1CB6FA03ECAA3482ACC0E216C4EEF11F4439B8FC822C1456965D13C7EC2AD4CE8188DB726C2FB7E815BDB8E509F68FE47E4A';
wwv_flow_api.g_varchar2_table(141) := 'C6D3A7F28626E8894662D7BF958C7521682FCF6A390F283881A10159DAD450E3075566F0E688347629B6A388953E2ED0E2246CE405F87FC43729C8A2DFEE6109ECFDA13DBFB4A7470612AD2D79B68AD2CF9CB5341FD0F4DB66F0328DB4F35F6DC6A9D6A3';
wwv_flow_api.g_varchar2_table(142) := '8072713FADB3EE8D3731AB687F6056CF9DDB2139C7FBFF0094C71FEFFE5590FDE55981C1E426DAC7EB0559DAFEE28089A2389C11104AC0DBBE3803DFD2CC75943EF37DAF74B9FF00700F86B52509C7C9634EB30ACAC805FF000E0715601CEC9D80F914C7';
wwv_flow_api.g_varchar2_table(143) := 'B0B0B8FDAB06D03266ABB7FF00F55A7D176D2EE164FF00A26DB487876DB983668ADF843255B3E7FF006D3E2356156D65CE8981C771FAAB177A15D99DFB5585A0E02159BDBC8A2EE8539F3C4FCD17FAFC930CEBB0E5696BD09469AB801EE53DBC9BB4ACC1';
wwv_flow_api.g_varchar2_table(144) := 'E2D856566D1A94DB33FA5A4AB26730158D928A05480812DB36B9C78344AC5C493CFBF817347409D49208DE6B7B9D126914EBE53A4C9864993D11869F842943BA4A7956641D769C516B9BB9D3EEACDC383014E23FF8D5A823A1FF00AA50B41C003EC9F6BD';
wwv_flow_api.g_varchar2_table(145) := '02B4B4FD8AD5BCD856D1DE1B1FE484F1747B2683C0972B26F44DE807D517F3303A85F64379F115DA6384056A2D0685C7E4AC4F270F9A70AD39AC6256764E6F37787BC017BB004C615CD76A6C0F85A765BCC942CFECBFA20891BC2C437687115BDEE0670C';
wwv_flow_api.g_varchar2_table(146) := '8A03C8346B64F00B3C0683CBA8CC649C21C3012103C9F3FE483FF6CFB2B277296216A3FBC2B7B46F132BB4CF16AB5B2E3B1F44FB3E3B04AB4793B98BED4F268566FE6F8F9AFB36F392AD3FE9253ED4F223D82B27F1DA8F74DB3E76A65666E38DAB41EFB8';
wwv_flow_api.g_varchar2_table(147) := '9E289A971583A86F076AB595AF9062481CA7CD7110FC902699929BEA53559B7A20470253DDCE0AB477A2B4B471DEEFA22EE6E72609E2559B159D98FED56AE1C2139E4CE6EFA2B369A67541806802FFC40039110001030205020502040405050000000001';
wwv_flow_api.g_varchar2_table(148) := '0002030411051021314112510613202271326114338191233052721516344262535482A1B1FFDA0008010201013F00A5C79A086548B7FCC0D131EC91BD4C7023B8FE4E298632BA2E048D1ED729E27C32BA391A439B901952D54B4B33648CD8F23BAA0C42';
wwv_flow_api.g_varchar2_table(149) := '1AD8BA9BA387D4DCC8041045C158CD0FE0ABE58C7D27567C1CFC254366C958EE7DADF43E42E8C1E6EA9710ABA57754721B763B1585E350D6D98F0192F6E0FF002713C2E1AD67F4C807B5CAA68E7A590B25610473C15DB382796090491B8B48586E251D6C';
wwv_flow_api.g_varchar2_table(150) := '7C0900F7373F1841FE966F969CA9E17CF3C71306AF7582A5A765353C50B05831B6CDD895035C5A6A98083622E9FED6B45BEE8BDA5A401AA0E735CD7349041D0AC23191306C3506D270ED81F41F415353C33B0B2560702AABC3845DD4CFFF00C5CA7A4A8A';
wwv_flow_api.g_varchar2_table(151) := '736962737382792095B2466C42A0AE8EB200F6E87FDCDEC72F15461D86757F4480E5E13A312D5C93B86910D3E4E4563B8E7937A6A7377ECF77647537D5564C580DAD7D95303D2E2792A5D2324286B1CDB07127B10B0FF15BA0B473B1CF670EE42A7C730B';
wwv_flow_api.g_varchar2_table(152) := 'A8B7455301ECEF6941ED7004381F4F0337318F1673410AA702A29AE580C6EEE15660D574D7701D6CEEDCB0DAD751D435F73D07470FB263DAF635CD37042C763F330AAA1D997FDB557D978629BC9C318E23591C5D96378F3616BA0A670321D1CEE1A8B8B8';
wwv_flow_api.g_varchar2_table(153) := 'DC9B92775AAA80E96A0B426B40000D822401AEC8C301D7A88458CE01560A2A8A88DDEC95EDB6D6242A2C47130C25D50FB717D545E2BC562759E59258F215278C58F73593D3104F2D2A9316A0ABD219DA5DFD2743EBAFC1A9EA417300649DC6C554D2CF4B';
wwv_flow_api.g_varchar2_table(154) := '2164AC20F0782BC3F5A5EC7533CEAD176FC2C56A699B4552C7CCC05D138017D750801758662D87C90470B25E92C6016769B2C5FC425FD5052921BB39FDFE1175D414D3CE436289CF3F608787B13FFA23F70A7023EAB5AE4A8FE852E8C44A16B65470798F';
wwv_flow_api.g_varchar2_table(155) := 'EA3F4852CD6166A947F15FF2986CE07EE9BECA8FD7FF00AA2F10625452D84824670D7EAA93C4D4F2B18658DCCB8D4EE1478A50482EDA967EA6C854D39DA567EE8107639D65353D442E1301602F7ECA4AA7433BBF0F21001203868539B2484B8924DF7257';
wwv_flow_api.g_varchar2_table(156) := '92E4E045961D87CF5F2F9715B41EE2780A8FC3543058CB795DF7D9471C71B4358C6B40E00B2B8EEA790BE4278513B4531BD822B8098D2F7068DCA6B4410868455537A66F9086EAA5A0163C7202A9F7B237AA37DEECBFDC27B882004251C92A1ADA985D78';
wwv_flow_api.g_varchar2_table(157) := 'A6737EC0AA6F1354B2C268C483B8D0A83C4386CA07548633D9C163B8A40EC3DCDA79D8E2F201B1D6C98DEA728E30423130F0A58F4B2C1ABBF035CD79BF41043829FC5036860FD5C556F88B15925737CEE86DF668B2FC64E75F3DFF00BA6784AA1D6EBA86';
wwv_flow_api.g_varchar2_table(158) := '0F8175FE501FF786FF00DAA5F09D58FCB9E377CDC2A9C0314877A72E1DDBAA8B0AAF99C5AD81FA1E74541E1F919EE99C03BEC9D83539B5DEF4DC3688007C90A6C170E97EA807EE4297C2F4A7F2E57B7FF6AAF03AA1086C6D12586E34D948C96189F0CD13';
wwv_flow_api.g_varchar2_table(159) := '9A6FEDB85138B250EFBA9082FDB8D14704F29FE1C4F77C025418062B21FC9E81DDC6C99E18AC23DF3C63E2E53BC2751C54B3F655BE1EADA481D339CC735BBF493750DB54C3ED194A6F64C6974C035A492574F49B3996F90AA29A69E70D8A3738ED609980';
wwv_flow_api.g_varchar2_table(160) := '627D2DF6B76EE8CF18E57E21BC028D43AF6002748F3C9433B10330A48E39347B1AE07BA7E03863DF7F26DAF04854F4386C21B6A56DC0E7529B242D166B6C11A86F62BF11FF0015F883FD2A67B268648DC3EA690A6A69E9A521F1B80077B689927646516D';
wwv_flow_api.g_varchar2_table(161) := '949269F758051C8EAB6543987CB66B73C953B619CFBA261F90991C6CFA58D1F01595C2B8570890AE15C2EA0BA82242F6A047053881642D7CAE15C2B8570AE11E920822FF0062AB7038252E7C2EF2DD6DB85FE1189136F2FF005B85458141159F390F776E';
wwv_flow_api.g_varchar2_table(162) := '134340B0D07002BB6E839ABA82B94723B21B65C22745D5A206EB64FD4207444FAEF640DD121752B9BA1BE476476193CE8813608AB9B15725AAE8DC15A80B8436478F51BA1B268BA20E476CBA8A17033BABE5B8445814159C6D65D2E3BB4AB1B58AD95B23';
wwv_flow_api.g_varchar2_table(163) := '95C647A9026DFAA1FAA20A2D441015D7B7B8417032B056190CA36073AC55801948FF00774D9103D0F364C208C8BAC5176C6CB8D11BE993911A666F608EC86CAFBFA23B093273C340251775484E449B206E3226EE4D690B94EB2BA046571746D65C647EA0';
wwv_flow_api.g_varchar2_table(164) := '834B8A11808346DA2735A012810465AAB904140DC02A4B741BAE5708D8829BB273AEA31CE4511A201386886D91561AAD1122E3E547B14755A6EA776AC6F7DD5AC332059091C3445EE73B55D250564E36B8405CD95AC07A4AE10202BEAB5C9B1171D1359D';
wwv_flow_api.g_varchar2_table(165) := '23756FBAF853DFCD6E40E4D8DCFD004E6B9A483BDD318F73859A57E1A5B70994A07D4508D8058342AA84324F6EC53596F4F0AFB2BABEA5728856FB2B000291B71B95C0174784E6071079B2B59017B0B28E986EE41A00B0011634EED05580D82E32738017';
wwv_flow_api.g_varchar2_table(166) := '534BD6469A0C8A19D91040436406A8E82E8AF7264AD77CA3AD974D8846E38405EC9F19DC2A76DDD7EDE828ECA597A1BF752543DC6C6D65E67D9799F64083E9721E9D8A85C4B753CE4E4DCA3681EAAA3A8C80D3267D43D3657C81CCF754E75393B84D4480';
wwv_flow_api.g_varchar2_table(167) := '9BB05CE672AA702E395ACCCA225D26A87A1A4DD3B3057522D0A16D89C9C9AA4B5932B1C058805452798DEAB5B3E46552D01C6C98DDD3CF09FF004A8480F04AF399DD798CEE117B3B85D4382136C8FA3ABECADAA8F7F44E6CDCA945A31995C2A87833B988';
wwv_flow_api.g_varchar2_table(168) := 'C8E03A45B74640117171402D7EEB50AE82F70E4A123C72BADE848795E68EC579A1756AA2BDCFC7A27E728482C16F4D5DC54BEC794C8A490FB584A9292A1AE3FC271F8174CA5A8BDFCA7FEC8870DF42AC55CE5F00AD95D0D96BF6FDD7EA17EA168A2D8A1C';
wwv_flow_api.g_varchar2_table(169) := '64F958CDCEAA498B9FD85F2A23763BFBB3E726C0C3297DAE494D63466F8627FD4C054F87308262363D93C59C41DEF9009C0590B8396BDB2D576517D287190537E6BFE72A1D9FFDDE8E147EAACFCF93E7204A3B04DDCAB9B276C82B0ECBFFC40039110002';
wwv_flow_api.g_varchar2_table(170) := '01030106040307030305000000000102030004112105101231415113203271225261061415304281913353A123347240436282A2FFDA0008010301013F0097679C1688FED4CACA704107F27676D07B393A98C9F885452C73461D08208D376375D5AC5731';
wwv_flow_api.g_varchar2_table(171) := '18DC0C1E47B55F584B67261B553E96DE090411CC56C8BB1796114A4FC5E971F51B9ABED4DEE4C768A797C4DE40B86A96DA298619455EECC9AD8718F893BF6FC9D9FB4A5B37EF193AAD5B5DC3731878DC1EE3B569BE68239E331C880835B4B66C96727531';
wwv_flow_api.g_varchar2_table(172) := '9F4B6FFB2536B7317B30AEDEF57332C304923F255C9AB99DEE279267392E73BD6C6ED802216C1FA50D49A8509917B538054E46462AF2C8A12F1FA7A8EDF930CF2C0E1E372A6AD3ED08D16E13FF0065A82EEDE75E28A4077CF0473C4D1C8B90455F594969';
wwv_flow_api.g_varchar2_table(173) := '3146D47E93DC6EFB272706D4E1F9E322884EB8AFB5975E15AC70A1FEA9D7D86FD95B2FC42B34C3E0E6ABDEB853E5A8938AA21A934FE93ED4D103C80AB9D921F2D190ADDBA54961751F388FB8D68A91CC63F2159D0E54906ADB6E5E424062245EC79D5A6D';
wwv_flow_api.g_varchar2_table(174) := '8B4B8201628DF29A1DEB68D92DDDB95C0E31AA9A656476561820D6C493C3DA96AD9E6D8FE74A635F69AEBC7DA4CA0E91A85DDB3764B4A44B30213A0EF40000015AD47858C135083C19EE6A6C98CE0D077E58A04F5DCD1C6DEA453535B5A93A46B4DB2AD5';
wwv_flow_api.g_varchar2_table(175) := '8680AFB1A9B6390094907B1A96D2E21F5C671DFCF61B62E2D885725E3FF22ADAEA1B98C3C4C08EA3A8ADBF65C0E2E1068C70D5B352517B6D208D885914938E80D3DF5A7D49F6ABFB2BB13C92B2643B93A6BCEB66EC80BC32DC0C9E6A9DAB3A0A9278615E';
wwv_flow_api.g_varchar2_table(176) := '291C28FAD7E3363F367F6A8F2D8A8FD02A5F46E3CC50A99F8570399A54CEA697D23DA8EA0D7AA3A7B0B69C64AF09EE34A9B66488C423034D6B70BCE33463907E8358237DA5CCF6F286849C9E63BD3113C2A258C6A012BCF5A484E0708005782DDC53291C';
wwv_flow_api.g_varchar2_table(177) := 'C55D5E456B186933F402AE76CDCCB911E117E9CE9DDDC966624FD6BF6A88055C75A88E98A95BA6EC5120024D125DF277467E1DD11E62A3D19854A391A86257525A9ADDF3800115F7481902BC6ADFB54FB0E16C989CAFD398A97645E467450C3B835B2ECA';
wwv_flow_api.g_varchar2_table(178) := '41760CB1B0E1191A699A8D789AA3881193CA8C49DAA58BA1ADA56DE3DBB2F507229365FCF27F150ECFB555CF064E399D6BC05FED8FE29B6C423D3131F7D2BF1A3FD9FF00EA936C45FA918547B42D5F94807D0E9525F5AC432D2AFEDAD5CED98CE91A922B';
wwv_flow_api.g_varchar2_table(179) := 'F159FA2A51BFBA3FF74D26D2BC5E52FF008151EDB987AE35356FB52DD9B2CC53E8691E39183C6EAC3AE2986411501C27EF4F3449EA751EE69F6B59A7EBCFB536DE8472898D7E39193AC46AD76A5BCD288C0604F2CD418C9A420A8DD374A9C80921246315';
wwv_flow_api.g_varchar2_table(180) := '9CEA1AB8E38A10EEC00AFC66CFE66FE2B8D6B8C7D68B9A2C7BD64566B22B3E45764395620D26D5BD418E3074EA29F685C3F39186BA81A5197249249AE35EC6BC4FA5789F4A867E0911FB30356B7904A1592453A6A33AD472E069A8A338E82A597F9ADB17';
wwv_flow_api.g_varchar2_table(181) := 'B147034218176E6074142E255F4B91ED4D23BFA998EEF0E4F96BC397E5AF0A43D2BC29074AF09FE535E0C9DABC193B518641D2843276AF0A5F96BC393E5342273D2BC27ED5C2DD8D1471FA4D0473FA4D18E4F96BC37F94D089FB504954E464558ED7BD88';
wwv_flow_api.g_varchar2_table(182) := '04742EB9E7D714DB5AD80D653ED8ABDDB17529290A945EFD68A4AC49209279935E149DABC393B1AF0E4F94FE60FC90167842A1008E95244F19C303FF0054090410692ED80C3A861462826D636C1ED52412273191F9AAAC79035E149F29A2083A8F332329';
wwv_flow_api.g_varchar2_table(183) := '018634F2838D4545752273F88566D663D54D3D948354208AF066FEDB7F147F2235E26028000600DD35BF141C63981E5B1B73249C647C22AEE2912525F50C743E7151CF2C6746AFBF9F93FCFE4DB9C3EE442E702A6052D5801FA7C8AACEC154649A854430';
wwv_flow_api.g_varchar2_table(184) := '286C0C0D6AF2E44CC02FA47E5C50B4874EF5159478C9C9A31A6062318F6AB8B24703C35F8CF4A9E0785B85F19C6F538208A53C401A873C631531021933F29DE0124015696A215C9038CD6D197E258C1E4327F2511DC80A09AFB9CDF4DD6447037BD2E574';
wwv_flow_api.g_varchar2_table(185) := 'C0D4D0E2C95C694E192095E33F1014CCCEC598924F920857C18F23A5612342D8E42AEAEE378F853273BEC6D98B891974034A96411A163D0548E647663CC9F3A46EE70A09A8AC87373FB52AA8D1400372233F2150288F99E74AE481900F6AFAB0A628B6F2';
wwv_flow_api.g_varchar2_table(186) := '9E983E42EABCEA178DE2428C08C55CCD1240E19D4641D2BC64A331E82B8DB39C9CD585E71DBB191B54E66AEAE9A6381A283E786D09C33F2ED4A8A8B850053C891AE588A92F4F2415F789BE73400000028C464C0048A854A005B2703143197ED53C65E229';
wwv_flow_api.g_varchar2_table(187) := 'C6464D48851CA9E868D3CA790A249A49244F4B91ED4492724EF5524D22F08C67CF648ACE58F4A352B158D88ED458B1C924EF4955BDEA37039D78C194E58529466C861A53B85058F7D055DE656E302A438147CB676BF78720921473A1B2A1E1D090686CA6';
wwv_flow_api.g_varchar2_table(188) := 'EB28FE29B65301F0C80FED8A9ADE584E1D7CB64D8908EF4688C822A4428E54F43E48589539DD6FAB1D6AE4EAA32375DB0F10E3CDB247FA6C7FF2A1D289D71BB68006D5BDC79636E0756EC686A01DD750F1AF10F50F241CCEEB71AB6B8A9FD7CBA53305E7';
wwv_flow_api.g_varchar2_table(189) := '531CB93F5AC7C39F2ECB88AC233D4E7767326EDA9F0DA6839B0F359CBC49C0798DF716BC44B273EA2BC293E434663D855A4A5A4234E5BADB1C641ED5719E219AB92498907366A9364C6DE990AD5D5BF80DC1C59D3C83420D6C9919FC42C73A8A91B1802A';
wwv_flow_api.g_varchar2_table(190) := '30799A4E75B450BDB32A8C92451B29FB0A36B3FC95F779FF00B668A38E6A46E864F0E453AD0208077E3EBBAC7FAA7FE3B812395124F334838EFA21F28CEEDA47339F6F2ECB89923F133A374AF0C7DE0CC59B38C01D2910B006B0114D4D206C01C8790806';
wwv_flow_api.g_varchar2_table(191) := '8AA30C15068DAC1F20A08AA3039560570D70D1AB01F137B792D987E2041F931BAF5834CF8E871E5D9F8FBA474F2A27A980A82F6D4C6BFEB28F738A96F2D3808F19351DE810751BB1E4C7935DD603E173BE385E4F4F2A8AC218C9939BE39EEDA6A1650401';
wwv_flow_api.g_varchar2_table(192) := 'CBCAB2BA40899E429A463BD26953D2E4543B4181024D477A52080472C6E2681D6B9F9315DEACFF00A3FBEFC9C547FED93FE3BB6A7F517DBC89EB5F7A97CD69FD08FDB78E668D75A5E74777FFD9';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784241924925151269)
,p_file_name=>'img/emerging-tech.jpg'
,p_mime_type=>'image/jpeg'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/img_persona_female03_png
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000001000000010008030000006BAC5854000002FA504C544547704C563A313F3A37493A353F3B37403B384136323F3936673F3A6A4838483934403B38403B383F3B38403C3849454144403D403C39403C393F3B';
wwv_flow_api.g_varchar2_table(2) := '383F3B373F3B3847423E413D3A3F3B38403834744636503933423E3B433E3B403B39403B383F3B38443F3B443A36593F36413C393F3B39403C3A4038343E3B383C3A3857484173574A6D52469F6D56A9745A8962504D423D7A5B4CAA755DAA755CA9735A';
wwv_flow_api.g_varchar2_table(3) := 'AA745AA16F58685145966853AE785FAA745BA9745BAB745BA8725A805E4E5D4B42A46F579A6C56AC7961A671599168558D6552AB775FAB765DA9735B52443FAC786048403CAF775DA97259AB765EAD7A62AF7D65AE7B63634E44AD755BB2795F9D6951A5';
wwv_flow_api.g_varchar2_table(4) := '71585A473E653F33855846855945845845855845855946885C49855846855946865A47805544A56F57875A488559459A6751A9735A895F4B8A614EA9735A7A50409D6A538E5E4A84584583574594634E633F35A66D568953437D473B774036805241804A';
wwv_flow_api.g_varchar2_table(5) := '506B454A8F525C844C5378454B91535F884E569358627C484C89535590525E8C505A9255608F515E955B6590535FA0675B9C615CA46D5B4A3B36573D3657372F5231286C3F3C5D3A32623B314B2A22482921965B5D663C384B2B23603A30633D335F3A30';
wwv_flow_api.g_varchar2_table(6) := '613B31522F2645271F693F3758342B653F35623C33603D345C382E57342B44261E5D382E603B30543128613B325F392F5F3A305B362C603A3059342B4728204F2E255E392FA7705A5B362D4D2D245F392F502F26633C32623B31603A305E382F623C3154';
wwv_flow_api.g_varchar2_table(7) := '322943251D4A2A225230277142404D2C23623C32603B3060392F5F39305E392E613B304D2D2559352C6640365632295E382E653D335B372D5C382E58342B5E382F613B31613A305C372D623B32633D34643E3469433956332A674137603A317544444627';
wwv_flow_api.g_varchar2_table(8) := '1F42241C5A352C4F30284F2D245D382E4C2C2258342A4C2B23663E345E392E6D473D623C329D676DA6747DAF828ACFB4B7FDFCFBB99298F4EDEDD8C3C5E8DBDC794D3F92614EA97259A87259A9735AA87158A87259A9735AA9735AA97259A872594E2E24';
wwv_flow_api.g_varchar2_table(9) := '7C5040C69CA9CC000000FE74524E530017415382A4752C060A37CBEAEFF4FFFFFFF9D294D9FFFFFC690223FFFFE2C2B3FF4A10FFE7FF5EFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF';
wwv_flow_api.g_varchar2_table(10) := '2662D92FBDE4859CFFFF68F1FFFF3AFFD0FFEEFFF1F6FFFFFFFFD5FF8815FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCFFFFFFFFFFFFC17F9ADCF9FFFFFFFFFFFFFFFFFFFAD592';
wwv_flow_api.g_varchar2_table(11) := 'F0FFFFFFFFFFFFFFEA435EA4F5FFFFFFFF74FFFFFFF26DB2E2FFFFFFFFFFFFFF8AFFFFFFFFFFFFECDFB3EAFF68FFFEFFFFFFFFFFFFFFFFFFD2CDADC5D82F509B7682E680C706F2EBFF0000395B494441547801ECC131010000040030A07F652D5CDBE203';
wwv_flow_api.g_varchar2_table(12) := '000000000064F5EC1E797681DC48924601389A51567E867C863F2DCB53DDF6F2DEFF720B5361C1C0014AFEC40A7CC9F0F1D36BCCFEF9CBD7F7DFBEAFCED6CDF9EAE2DDE75716FFCBD7CBAB73B0EEC1F5CD6B4A7F7B7773795619F672F5F6F6D5E4FFF4FE';
wwv_flow_api.g_varchar2_table(13) := '5BD568E9C34EE5FEFDDBBB375F5E43FCCBFB91A8A162D64832CEAEBE6D1E3E7CFCFAF9A45BFFC72B0131B31D0554EB7DD4D9FDE6E1FDA7532D84BB0FE7F11B2909A84A659BB85E6D3E7D39C599EFF15B128178D163A74580F30F8F6F4E2DFF2F1FAFA3F5';
wwv_flow_api.g_varchar2_table(14) := '04FB57828C98506621D3E6F1B45AC1DDC3405FB7C9AC103248CC92326BE9FDE1EE9446FFCD288CF5DAB1C45E0403AD46CBE6EDE9E4BF484A6294637160048A4C61DB7F7CBC3D95FA8FD65121FE58951EB33650BDCE6F4EA204DE3C949D6CCB9F99B63F09';
wwv_flow_api.g_varchar2_table(15) := '1202ABA75358135C6678F1D38BD879FEFD5FE167C8EA69F9F91F5729B3D87A51A4456BA3AF1B483230414BDAC0B8F865E9F9DF5E4581B06D5231CB5877ADB7B15E57357D10922054FB49CE2F175E0277DFCA4EB5202620EB46667D6C03DAA0B6BD37819C';
wwv_flow_api.g_varchar2_table(16) := '7FFCBCECFD4FA3200E4C48464F22BBBF76469825CEBE2E7A06FCD107C21654EDC226D0D21C9B920102E461D10D6064A48D22840A113B51CCC21492C991F30537814FDF13DBF540901CA6451C0829F253EC25D9DC2EB601BC2F640009C7F98D287BE90DC9';
wwv_flow_api.g_varchar2_table(17) := 'C8417C568F8BDD03DF3B92020A44E258E248B531C887A536819B734732468278D1B760129010BF55179F16BA09F806D57AEB01B21EC38B89E7DE15AA062471A0604A72B6D08B838FE7A0B7D687D9F09300ADFCC6187DFCB637B486F7CB1C01365B988C67';
wwv_flow_api.g_varchar2_table(18) := '0152030146F1FC17076244324D8644A0F5C8E6CD227741F70389B11E14D81E4F7FCF7FFDDB16A842901AFD257B314D21AB452E059E5641481F0493599BBF64FAFB3FFEF9AF7F07AA3122A1AD7B2862566A8913E1ED7FA9B90EEEB68D279F5E6D1348C1BA';
wwv_flow_api.g_varchar2_table(19) := '00B9206618A8502477072A3B80D8A4C5128A4149FC57DBA42D1FA34B9114DDB97CFEC3EE42A498BB2FB03F3FB393EFCD4FB3D330331F2DD33E972C852137BEBFD1EE5006F1F686DBA8CC9F5F85CAFE5F3D6460A315FCECFB6059EE22A4AE855AAAFF9AB7';
wwv_flow_api.g_varchar2_table(20) := 'B3BBC711204937DA91E39095DAA83AFA91BF081B421BAB83EF7FED1B1340946D27C471B466D7350D51637D9F26A0C1935637AA445D06C54E10D46A376181FFF1631B13415211E0D5D49957F290C038FCA8DDEA250008A06EE85E6F238CD4A76FBB3E3FAC';
wwv_flow_api.g_varchar2_table(21) := '08202408BE7C646129E82BB27A9E83C0AD3B2AFD6B90CD3EDB1B800652862C1E1E6C38D1F2C83BB72367A7EE93EF2C24E087404BEFD78215CFE704FEFAE190C34080012200C4996C8D48A4DE37D6F0164818068E7D7EF0E187A14B82556902429CDAA883';
wwv_flow_api.g_varchar2_table(22) := '9CE5928106831BC4BDCEFA51B47AF5741131F95F58180684AEEFE9E4478118027C6FE7E0672169CE9F00480908151011F6C446B416DDE8BEE3DFA2E1BE8D0418D5AFC430C1DD5AF7A0D863143328062203003616C838307310B2E6FE6618D5435520AFD5';
wwv_flow_api.g_varchar2_table(23) := '8286BB806321010F82D54BBEC48F828DFEDE713E108C17C7C7830280D2E313C910B6388512324EB6F7D723CFA9F9C4A985EE12F54FAD3C02CB78D6F8BE43CAB6288E455EE0982200E48C0E280760022BA718A7FD9DB0E1A8EBA8F565DA14DCB7918060A5';
wwv_flow_api.g_varchar2_table(24) := 'B81991D37ECC990018D3F18912565300F978E10A0C4473BF1B5617D2AB9CC1F3023B8DA042DDC4836B479D145042B28594D29C19BB8714F85880A64370040EC0194F0F36462A80AA57059230208185BD02A51B5C8044A3D6044069BBC8440E508082CC05';
wwv_flow_api.g_varchar2_table(25) := '5542170C80E52705178A0AC6D3EDCD2872BD80F88E639C828D04FC1090850F583BED4F4083529E9D64946BFD97050AFDA2BECD2920328A9CB2A4B911468E5377434D40DD4E02FC80385E5D59C2A8DB4CC08003425E30C9CD33C1194AC13848FD3417C821';
wwv_flow_api.g_varchar2_table(26) := '1300C9B0B571649C880A831C1BDDE01777FDC0F1742860E4D77F73C1013842055E8C8F074F0A6EA8011C8B2700C50000B349BFABC348C7F754B3C8A79666830A51773B36699F420C06C6F5813811860A2A06089C0267ECB8788254554AFC48E50EAA9670';
wwv_flow_api.g_varchar2_table(27) := 'D742021E7DED9810707D9B83413C9924693C493848CE000B6088D4280472FD81F1DFC4801D672CCF01E2E1E911D176C4096D4C87DFFF52BB81C6E8200683C9B0DFDADFE81C6CEF25C0A8042A010585425451413181FE41A7D339DCDE1BE708C8B0D36EA8';
wwv_flow_api.g_varchar2_table(28) := 'A26AE07CF3B98D557173B1A3958146CC0FBB6DAF16F947EB1B0713C116C9B054C20E8E694CF7BBED46B4B616AC6FF4271900E6DBDDB550E553E1479F59591324A503DC1CC6988152E88D761439815F6B44517B673B815C00820428044560196B9E1EA964';
wwv_flow_api.g_varchar2_table(29) := '308AA2357FB44F0180D17DA7E6A88AE947166AC0C38F4B0D88C28309681F37DC74FD301C75373A1B1B9BDDD14E938D734094006250508064773D3C6AAF77BB9B1B9BA7A3C0DB1C0295C9B0A303812F3FB5AF28FAF77FFCB35112705A99FDB8D52E357F3B';
wwv_flow_api.g_varchar2_table(30) := '4D5380222D011A340760140178D23FE86F230A4C314D717B7FB375321E8BC96E5BF9C22FEDBB32F4AF7F3FDD0CDDE8A8350105CE0F77E3BD93134430916F0546058218481D141502B27101809CF12CCB0A2178323C8DCA72C8E8996D47E0F1F3E96CF3C8';
wwv_flow_api.g_varchar2_table(31) := '8DD67B4A0128484812A47C902117289604502A38E403D4CAC00B0A2810D860CCCB27001CF8CF9DB0E146A3D90BCBCEC0B397D3B357ED886C4C000198048558F0412E724484250A890361DC01654CEAA820CB1114069C4F5A47A42460FAF23FED22E0DFF3';
wwv_flow_api.g_varchar2_table(32) := 'E9F46CD4085B894EFBA5620045CE33CAF96AFACF0159A19E22509D0B81548F35A8C4787B546A4077367F6ED709F8A524607E5A3FDA45280A30E03995C37EBF9772B6CC052470FA24AF3E926E977650D2150D49D623B7D19D9F3DB52A12F8FCDFD3B3E9D9';
wwv_flow_api.g_varchar2_table(33) := '66D03EFF2F4AB5855337981CAC878ED7A1638E42CBFC64ACB9C87323FF7EDB25DDC31496C078B8538FC2CD5F67BFFDDDAA30F869A901D35747A3F3DF7FE7B04437F23D3FEAA40042804AFC0543AA4C21006C415F27C04787C9527E1E6FFF119626603E7F';
wwv_flow_api.g_varchar2_table(34) := 'F92FAB34E097F95969044E7776590A0ADA0CC6FD76A48AC3A39E3EF219E602311F306A3EC20F759780BB33918040B700814B7E313F5DDF9C4FE72FED0A869F4F356697920348B68550222B09201E89DA3DCA41A7BE2A0918AB841801F8A06508389D505A';
wwv_flow_api.g_varchar2_table(35) := '0C8E7381EAABE7F3E9D559C9E69F767981175383592F5E1A7DC6BAAABE17ED0C0580120E3043E30314B2E691AAA0059D8994488B5CF1C2935DA54AE50F3DB32C177E79660868C6344704D4A15E7230AA37A2D16E6CEAA308A073815C71A32282FDD075C9';
wwv_flow_api.g_varchar2_table(36) := '2915903100A6DEC6E4FA4A1330B7C904283C9F4F15E6E71C34943A73E4FDCDEEE92E688115280504150D67546485280E4F4F37F084814186D938BDBCD2BFF3E763CB52C1BFBF9C9F29E5BD9E8086767B94677B7FFB39361550440E1CB52D00A5F2A24091';
wwv_flow_api.g_varchar2_table(37) := 'ED4D269940F52A7F8214410C0D019685C28A81172F9523B8BAA6CBB40F388AE313651541630B1454482065552667DAF7216445210445E4BD993A0097CF1FDB570F79A6ACC0D5658F8386BAC32D1CE7122A08F30E3BC93907038EFA15E403A6AD0424CDE9';
wwv_flow_api.g_varchar2_table(38) := 'F4D7E9ECE9BF6C6C14FDF74C19AFE6C2082820CD0032D0B825B5D0729B0FE5EA664039689C5F4D67F3B3670FADDC95F2E2E9AFB3AB8B4C3044002A60151240C63103CED3942E29824C7B874106505048AFA7B3B3A72F2CAC081A4BF8FCCF57D72968E018';
wwv_flow_api.g_varchar2_table(39) := 'C100E106BD66F3E2A2D9DCBDE050C2A4444C161228CDABB699CBA7BF3C535980ADF8A92CFE25F2C6E529304A170C5C4CAFCA7FF3EB9401E35014081CE5563E189CE41C14927EF7BFFFE73D8BF1E0FB46B4C86D0C68061532E0CDD2C95D37E35CE8A288C9';
wwv_flow_api.g_varchar2_table(40) := '1A7951884546BCBFF69DCD43F41FDEB9E7AE7552E3F517B7062618EAEDEE0E39A07907C164071C80193A7A3B91FFF5FBF6AE0DF99210B7A1AF0C1AA34E59060BE892789C62AC33414D47C66F77CE719937CB04997CF3D056F91FDC25A411B82D13DB18C7';
wwv_flow_api.g_varchar2_table(41) := '9731A8400170F1C43C909015920D18BF5197D61A09EBF73EB4756CFC47D317DD3567E0C60A022EEE32011512CD8E4990189386140EA7919A9EB0F4103CBE591B14F663DD0936CE9704A4298715F084C35F81FD233D4C7AFF1B3B2D6070D3F5BA33E11CC0';
wwv_flow_api.g_varchar2_table(42) := '24C506C9C5EB0BCE61019E35AF7BB79E538EB805931DD367EDFFF883950A10B815DA7D6E0C1C2EFB82DFBC797D9EF22DFD44F6CE5FBF799DDE8A930422A7108F48DD3060E3E4E417F716E3A24167C23872014B24976FDEBE7DF3FAFAFCA2797EF94E3D6E';
wwv_flow_api.g_varchar2_table(43) := 'C64BF9110A0632391C79864462E108FDC38F42C7275A7E6D065116B98405A8540C28BC79A36FAF192C20259C9C308C77BC5A40F4FC54605F83C4A31FEB4EADE6BB44ADCFF2F6276CB5391E59EFF55B03237FC66E074A5C50480EDB8D9A53F77D2B55E0E1';
wwv_flow_api.g_varchar2_table(44) := '033D2E1712BF4E5CA7719A664CC202120170687440E1DD7902FF07934D87048E1F046A94CCB72D1A7AF8AD5B22323B13FC881CEE9D8C1920D585A02A1B62BDF3CBD7EF5EBFBE3C1FF2FF477E7511C17801552CBFF7C8B22C68B93AD00F7CB7D16127C714';
wwv_flow_api.g_varchar2_table(45) := '4085F9A21060C079DAEBF5866912038355A88E9AB56AF780A6813CB04B01BE37B34F816F96C344EDDDA4E00003067211FF4A25671C2B5F9849D0402AC120393C7217F03DE2DAB546E2F3AF95D84E48AA6661B2B6D333D53E58808301A38C8F91C2021224';
wwv_flow_api.g_varchar2_table(46) := 'E5CDF5C85F4CDB28D8D52AF9E977BE5B279EDA9B644E4123DA4F9642AF168618E7039E572AC18D37483A917B03CF5386E4AB4FEC9A9B0E4ABDF51A442F4D6AB83E69B477279A81457FE080AE90812516BC24BB6D455D352EA0A6C98955DB74DEFFE94EDD';
wwv_flow_api.g_varchar2_table(47) := 'AFD51C47E5320EF1D466A068A43AE639CFC1006901AB60630A064979006E2D51308F6DDA2AF6C5975FA92978BFE639665E2CF0EA24EAF633347F6C95F6CB55E195EC856620CFE3E14EA467ADFCE5D40D21772CAA8D7D702F707D2754412009CC5E383D35';
wwv_flow_api.g_varchar2_table(48) := '318C41216727F913264D51CC802A5E649EAB774FD24D2DF72DE1D508E6571F5934345A460124545DAECA7C796A063A24F5A87D9DC64CFB0291E9D38EB706074C808C0032DB6D2BA50F427F75A5CAF7D638C2C7DF044A00BFEE54A3D0442D0472A3F6ABDD';
wwv_flow_api.g_varchar2_table(49) := '5EBCE20738DE24005B9C9B289117BA3B9404C162DCD2CCCFF95F5A63041EFD874E03EB2A8DD36B1309F1D4C294D1D5F4B2A904A5A0C1816F55C55163FC25875CE493FEA811948C29A1D5F78847CC0EFA47D6D8C0EF6EF6C73AB590105F6D53238680ABD9';
wwv_flow_api.g_varchar2_table(50) := '795AF58C81CC80539D1FB0650C44294E0EC286A737ED55A3E7BEAB722A8B36A97CF0D5CD3A10AFE64537EE4C1D8169894B7D0C98B94ACE2470060B705A14F8F3EE51F9455F2F91215AFE7A18B8C4BBFF834D9B03DCC5D204035F1370A6BB5DAE7B18C7C0';
wwv_flow_api.g_varchar2_table(51) := '56AE151A6B402997D9E4C0F302CF59ACDE0994269537C14FD610E0A95D11AB265C1170F46AA6BA461405CD5ECA392F18A0CA87745A081A0C21E9B71D9F9006F9CB9235E7813504A80C30308BD396F13CF1DBAF66BFCEA6AAE7A9B486D717CD1EA62586C3';
wwv_flow_api.g_varchar2_table(52) := '5EF3E2FAF2026F18485A6143CDCD86C1CA163A527B60D7F610A26A8251B520547BC29200D5F0A2717575359F5D1AFCFAEB747AC1010D013069AD91526627F4FD95357CDE27D610707FB10EC66B3861E0798EE7972FB55FCD5BDA0AE8FFBF96DD1306D3F9';
wwv_flow_api.g_varchar2_table(53) := 'EC0296D83B68442E29E1FB1E09487D31446FD111582E10548E8CF8A143F411389BFD6A0EC1AFF3ABD6AFF36985D94576AB476872E054F4D53C1D405470EC3182BE51DB6A53FC628B9A7283BFB6D429389B192D309837B92E9967A6583469999D42EDC50E';
wwv_flow_api.g_varchar2_table(54) := '0D4342680D011FB87F41D88E1CCF8F46FF4BDD5520C7B103D1FFC31C3333333333850F6090CBCC8503D2420F25316E180F1BB5B4A00D1C40AF5CED02C34A0DD37A1A3DAD8BE8271BDC6CACAC9065990F87AD729F18BB221101B318309919C678427F43DA';
wwv_flow_api.g_varchar2_table(55) := 'D27A9D1A21150D8B26F6740D4DE877B2226AE0CEACF84EC8F2C9746F6233A0479CAAC7B5406965E6A2653F11AAC38953F825D7B5B94BEA7E659A7670A56999887D99FE68792AECC8F43F195D5AEA525E25443A849A1C060B3D496B251E5ED3E742818C4C';
wwv_flow_api.g_varchar2_table(56) := '553AEE49286CD088115997EF7DEF8881AFC8F43F99EE7EF1F2D5703A5518A5116A00388BF1525A2302A0ECB63EFB82BC13CC2F4DDEA7F1C4721D835203DD4F44D8732327E36094F3E4CA46F990E0CA072294DA0CD8B8BC99235FF652E5FA7062550535AA';
wwv_flow_api.g_varchar2_table(57) := '3ADEA2CB588846920FBD1D3E0584838F1FB54394C5D03C9E201C6EEB8A52EA01805182846A4295FBA6469CE08312B58D37C3BE0BC63A21F10920CB1B6467962C1F0A6185DE2EC905486A7048CCC368D40E0002E709920999482FE9A5AD5B8DDA09293D71';
wwv_flow_api.g_varchar2_table(58) := 'C37501A232F61396AF0A52E57F18F30057874246860BABF4BEB61800B84DF9197181B97C7D4A0022A740D9D37912C6C1581BA20048C8A7BF82853833D68D73C1F9C1371004AEEB2CE6D725FF4C8556276672F3533560D105447459193FD942F7FF0B6D6F';
wwv_flow_api.g_varchar2_table(59) := 'F15758E03455A644F6F5BA6EA522190135A726301C8FB791EA7D4FFA92C1AF62B86BA94BD0E53C00C200811B3DAB4954925CBD8E4C543D12E3AFA9393DBFA010F631099CF842980CB4CAD352DCE2573ABA3100C29EEB7BFCB79CCBF3D3D39A9ACCBA8C12';
wwv_flow_api.g_varchar2_table(60) := 'DD84752B381750737A76157BF7DE66E1300004D6C6D13267010E0FE6BB8745DA0FF5FC1DDD1F3C603E0B33703E7EFAFCE5EC94CF8076D7EDDC2E7B7276F635F6EDFB8F9F164804D16572B2D53A3A34CCA1063E964089A12134A20248447E51F35DED6D5B';
wwv_flow_api.g_varchar2_table(61) := '6BBACFF4F213B2EF26B7A7F75EAF4EBDF6CF385D8F15CA1E4B713BB3692F21C15A784D03740890C88E07580109A44080F1A511D40EB80B44108C614ABB249E3EF3170E40485134E7D64A79D59E1497EFE5BBDEAFAC0F7CA01BFD477FF007FFF73BB72EFB';
wwv_flow_api.g_varchar2_table(62) := 'BD37EE0F744037BBAF5CBDD169A379F59FFCCD7FDF84781677FBFD023699E0765304B5D8B6BAC070A4DB6FFEE0CA776A49F0ADC77FE8B816A4B22FB73AB76E9C1270E75F5E38EC4DC0A7CBD32DDAF79678BB3E01B56DECD5D55367C71B4FA0B97E10BCF3';
wwv_flow_api.g_varchar2_table(63) := 'EE774604BF73E5BDF7111E44128815EBE1CE5E23801677BFDAF5FCF3F397FDC2D6CCDD1B353A376FD604DCB8FA24B1040D54028F3FF8C1872FBFF41DE8853FFAF81386D181AA91089DFBE2C96E1B7F2B81FF7A7A05F6CFCF1E106CA3FEEAAAC0DB776E9C';
wwv_flow_api.g_varchar2_table(64) := '32D0A9BF6F4FD3994823C926CA21BDF9C3DFFB956FF9F353577EF8C6A70160996666B079CFB7B5EB6D382D0B7B774FA5FE5FEA9BA1FA4AB865E0A226EEBC76E3D6C633AFDDBA71AB7375D0B5699ECC498BFCC0FDD1E38F7FFC6DBE21FCF0273FD55D1D64';
wwv_flow_api.g_varchar2_table(65) := 'A33B20E44EA421BBDE5AFAA90C5EFBAA0B3493F08B04D49F6F7F29985B1BDE8EC643E041BAC03829C250F0EEBBFFFD57BEA51DD047EF3DFE54647EA40E86CB1921F0958C347FEB34A0169DDBFFF082E55F44734F78BBB6BE53BA9A23B0FBBA9383429FB3';
wwv_flow_api.g_varchar2_table(66) := '5235D2EE4AF38C77DEFCEC777FE75B77F47FE587EFFE28D101E2D62852B51501B26F7037DE698239C76BFFE562C8ED73F2EDB78D03EE5D246CF7E9B40479AA45B92373A50F220ADEF9E97BDF7BE9A56F97EF7FF0CEA7B65B45E50484C961E47A1A8C1579';
wwv_flow_api.g_varchar2_table(67) := 'CFD65F89E7562DEABDB7CF77C2BF9A01FFDEE93F3429B0731A7C4BC0610CB2A29C2C653D74426CC0EC0F3EFEEF57BE2D14BCFCE15B3F92CC30A89FD5141C4E88112FD571691781745FDF3B2760AFF3D75DE0746BB879FF8C761272BBD3695AA77374B626';
wwv_flow_api.g_varchar2_table(68) := '0AC750CD68789C0937C4192878FC6BDF0A33F81FBFF7312689126BABA500E52755A26B8208A1DFED7A444F9B88362F7EFDEDDC051ABF3B7D7EB81909376F25F2F75B01B4D19FDBE0CE3D2745A07621D53298689C330004A07FF4B3F73EFCC629B8F2D91B';
wwv_flow_api.g_varchar2_table(69) := 'EFAC88B452AD926C5614ECC81AED2B2739517F91F9D1787EBD25E01CAFBEF6F63F6CD7A14E87A0FFFCFC0CD40E70C1303A0D094FA60F88A6AA36F463808FF7E724FA051AB0E00FDF78EBC36FB4E07FEB7196A803B95C31A9C7D1B4D418885987AA339E0B';
wwv_flow_api.g_varchar2_table(70) := '2278AEBE7BE3FFC3ED3603D46FB3D8CAE01CFFE5CEAB372E28A021E1693702858AA472CC310C9DAA6B938D0D1864F7E7BFF8C62878F9073F45C0EB57DCF1654134ECA76E35CD00021FA8AA6F010C4F3B6D181725F0F7FEE3BFABDF35E2DCFCCF70B773EA';
wwv_flow_api.g_varchar2_table(71) := '80174CC0AA72928E47BA921320634729873883964E7FF9D6F7BE113BFC958F47871310C04BB59AA69A982D8BF949A584131078A63A7ECE97DBE7F17476B64F19B8FD0FFEEBD965D097EF27DB1681A76DE0CEEE577F59A11E529074691D65841AD2ADC639';
wwv_flow_api.g_varchar2_table(72) := '1AD80480EBD12F7FF02BDF80F5BF29A775B4390808BCA9933C5A881558EE56D1408A82ECB5AAF8F64EA7D36995DCD94ABB6D5C9DD7DA54D8E0C264EC5FBE769AFB3FBDD772B519A4BCFAD0F70B7132667230094004501A5523490C2D98F44FDEF8F06B16';
wwv_flow_api.g_varchar2_table(73) := 'C1AFBC65156099AF38710E661794B9C783CC16446C9D54EA7CB5600CBAEAD711EFDD6A847DF515B72AB73A6D8D7FFBECF988D335E1560F7FEBF68D16AFCCC5E7D7AFEED5BFB421A073FD300A849FD8364D326C4093B852F509A10591B5FED9EF7EBDFDFE';
wwv_flow_api.g_varchar2_table(74) := '1B56C66133A1E9919978AB1518E4405546760162791C457E468CE8F58680369929AA1CDEBBDA69CBC18BFB61CD673B0ADE4865E7705DD878B2736687DB52C9035FB54123672A090D28F72B65A4B5FF6063B5A2773FFA1A3570E5DD6088162443A5725390';
wwv_flow_api.g_varchar2_table(75) := '3842DE559452030879AC38490E7AE5D4CAB71E264ACE80AD8B1D418BD321D13FBC73DA365E574B02A477D6456CD9AA1EC42A00393D50426C10C03B51A2122D1606C4FB5FBCF435C66F100120D8FD3449465115E91C8C41968A329A000C93815A25691BC3';
wwv_flow_api.g_varchar2_table(76) := 'CEEB16720B809FEE9E7604FFF0BCFD6DDE59AFED029AF8EB16F8A15F02D092F0E9CE8D06BBF6D80FD62E80A2984FAB69394103C6F3692F2A09822084007DF27531F0BBEF128C1523E232F595CA896DA4E34A2925D82625A8A5853E803471B69BD3BF6527';
wwv_flow_api.g_varchar2_table(77) := '4EA8013CAEC25309EC5D90C06620F20FEB2EA03188CE16629703DC1DF3C52B8D13BC7ACF8D866850AC40C6F78F95D8024082E08D2B551F12A84FB0F1C9175F8FFFBD21C0882CAFF4A34A39D179DFE8C3CEDC5E145A044058DD93D20A506352DBFEF65302';
wwv_flow_api.g_varchar2_table(78) := '1B44034C5C3365F7CE6A817F79B1276C04D0E6C0ABF7A85425806ECC11DEDBAD19B8DE55270C0D388AE7CF577E55858BC236A8C65A35930CAD1E578FBF8E61C96FFF706540A6B1AA3AAAAB4F88A88F0681A71EA8996000C8F2E3520A1A3EB9DAB91EBB73';
wwv_flow_api.g_varchar2_table(79) := 'A2A6881F572521D8BED1E282049A9EE07414DCD90E6810590C64594059BDBE53A7456D8E1AD4170B2A6645D15F27BD720E5ACE001A9651E56782005AFED1C75FC3C0ECC3F7AD388A5477A049084168D90F8CFB8370AD9AEEFAD41A07B1ABF3EDDDA7089B';
wwv_flow_api.g_varchar2_table(80) := '8A881826F577C0BDDF6987C44D4770FEF0DC5917D0A9F53EA4B4F2024000D08ECB626BEFEAC3C5AA0FB2DC6CB92C380042BA6F46E96C561040DAA162262900A24F3F7BF9D20FC02F122709338D1309F497061A70AB1C1F77EF2FB56EAF37B5D0C0B64695';
wwv_flow_api.g_varchar2_table(81) := 'FECABD2330791845B1057B41407CA06F86C44D3978E6834D25782E80AD009439EB00C50C80B19AA178BAF364286C507A600E960DE7820A610F8EAB24276C20CB26194388E293CB4E862FBDA78F2C0E26D08096C611347DEC38D13435FA8250BBB4D358D4';
wwv_flow_api.g_varchar2_table(82) := '1100EF81A21C723068999B58EC0893B1D9E54F37738EBDF33B824D326805D08CC135009A15CF172B00E2F90A8BD9C3272DCD71D51B6B2B4E4BB241341CA83DBF659BA0958E39CE61AC7EFABD4B1E7AFF3400CE7A310A8672DE8DCC7199830A1BF646B5A1';
wwv_flow_api.g_varchar2_table(83) := 'E3C4DAA255815B45D99080A106C09A9A25F8C3ED4E5B1CDCFD6A2F74E74C009F0EA1718A0F1222007CB12A56B3FE72466480848C95E3AE573C5F2E0835B4508D328D0802C024547AA1BD2C3EBB5C097CCC043610C296F3CC577ACA40CE0C7CC90A68C84B';
wwv_flow_api.g_varchar2_table(84) := 'D5CF38310094268A3F6FABF63CEAAD19ECE1D3CE7922A89BC20DEE9E358D4F384BA761E04D7B52344165B3A54DC6F3E7C58437E227EDFE71CFD5962BC0366606D9E17132EF076840DC8F8EEDFE07972A812B1FB0F6B5E76B5F752AC7EDA69A2840A7A434';
wwv_flow_api.g_varchar2_table(85) := '4E15EFEB820DA2C89F130026BCB1E35B44A455D59AFAA089DCE96CC2BD75FBCB82F86FBDD65C845CAB2BE680774D674D64556E009A9B49B1C06A5613D08D4A12805D2CEF4707E12388FECC30844179AC28291136980F9C68FEDE6512F09E0180218BA3AA';
wwv_flow_api.g_varchar2_table(86) := '4A4669CE8970068210C3527916E5DA7DCA63C70939D0275A943DA50BD2620F2070BFF7B4CD037BAFFDCBB35BE1B7F7DA89E1D557A47F70F0C0921A539D9CA039552ED0A7D5AA5F87ADA60101ABA516AB4AD710008CE78290AACA5827900D34BE903EFE95';
wwv_flow_api.g_varchar2_table(87) := '4B7480778B02BCDCAFCDA8B4B43601F6710659BA8AD914848392087972B09FC2066646FCACF1E821032013F3E461DB155FFBB223F85B773AA7ADFF2239300F2AC77114E7994FC0DA9C2E6C60312BA3B2541457C78288FADA893A8D3580042D574C3B7495';
wwv_flow_api.g_varchar2_table(88) := 'A94784822038FFE4122F51BFF884CF7DC78C4AC941409F70062D0B93CA3C483C0EC142153546CF4CD3954410C3B95F55F946A35155F2617B5BD6D402E735C0C6029E2666ECC5A5B4E6993556240346A64700A8EB84A8E56526191704D618AA32E22B831B';
wwv_flow_api.g_varchar2_table(89) := '4B03FD551A55716D98D8E0E34B3C0171A41CFBDE102010808DEEC060856AE5F86EEF99927222940911A874D2915395841AB6D795005247491971BE7BB11C7CED6C10E456030E801A94CF74029391CA170B50383DCE9861878E39D5FA14CC8A23CF559C74';
wwv_flow_api.g_varchar2_table(90) := '018895408D34F2EF4FD02078F7572EED08FCC28F33C3208016F697B99059A34851431EF4E3C83C9886A9EC2A8501F27A9EB05C33912D5500D3CDC8B219E2837309D479F01FDEEDBCDA4E8A9E28A53FF5E3381C0C06A1FACCD536BFA66404361FA82A0A83';
wwv_flow_api.g_varchar2_table(91) := '642D4037E54B83E8281DF7A25263FD6201D8C6D03F56273680E0671F5DDA10F8B1A0A27F2EFC451120EF26919B6A63E524ED0B2D3B1C3B076199500091572981D63D551236E83627824DDC83F8F3AB9D4E7B5D5E1741FFB2AE01AE35FFB8EBC989EFC7BE';
wwv_flow_api.g_varchar2_table(92) := 'EF2749A29895B96600929ED5104E69AF4B848064A89A513C21880273BF170D68B6229B5088C5FD45414050BC77697DF027843E6C9CA19895AAA2F8DE906C7D5A55FB8708489BAF659C0020AB6A344CEB7DA76B0318C666C259E382E1F0E87A1370DB11FC';
wwv_flow_api.g_varchar2_table(93) := 'C3CD28B8F9BA6E1341D32CBD0CE3916F9ACF622EFA982B3E4004B8CE84F8380E82D43C508F07C3868EE57CBFF6D719AD88400B4310B1A278F893CBAA857EED8FDAC903FA042AC8F3A32A49AD58D535505FA6AE1A85128C102705814947271E0E68329826';
wwv_flow_api.g_varchar2_table(94) := '6BE253C7D7182651AF0BD4B3B176ECFFEAEDCD5DC006BBDE895BF3E93855FDA54ECD83834AAE6CCCFC5E8E069E59D2C454258669141DAB8985C600781929216668D017948ED2B27CE3924CE0577E2250830847E0D2534D27B438ECB5EA385D6B4804BEF6';
wwv_flow_api.g_varchar2_table(95) := 'A36937D5BA11474B403F3A09603F525DD1AD625B149EA2E8040CAD4602B73A4D39D80860D31D3C55ABDEB348CF3DC939873DE4032704706455632200433FB258B7E712308FDC4154753506EA430BABAEADA16F37BD59746056FBBFBC724965E04F039010';
wwv_flow_api.g_varchar2_table(96) := '45C0ADC189E244A69B8350434F9CC82F734E027C9438E1C0910C81A5A4241DBF0F10604569B15CADAB2907C0C367F65E5B0FEFDDBDF36AA7D30E4286F01EA8AA7F984F865CE696E4C7AA0608F27B1E6A90D58B518CAA39C14E4DDD1E9B8965A3817CE0EC';
wwv_flow_api.g_varchar2_table(97) := '67060032D67169D13B1F5E12019FD4D1AF96EB91ABF4A2EE1C7E55F96B1E100852F7A3685A4E8868984BDDB1986DCC558FA4121618E6BC98AF01433A4D446C121FA8473B9D66EA7DEDE61FDFBCB1B7B719841424029265F4AC72BB7E5499513CE88D08FD';
wwv_flow_api.g_varchar2_table(98) := '3A709F5083FC4A5BCAC807C0A78AC440894A4E80E89397F8AB9530360D1AD1E79794063E5AAE16A93F565437CE34C6846D95AA13C51902A32042D68D14D71322081A024059E491E68604A9ACC9167D31324F3480F2E820E6C357EA2370B3C15EEB80BBF7';
wwv_flow_api.g_varchar2_table(99) := '627F9CF8AE3BF5435D1F94657A3FE3BE332700B50408805DD3B922DD4C19FAC3CA07C9B08A069C0A0134F2A7021BF41F7E76290B24BFF35E164E23359C0F0F2337271088265E1C55FBA51D00761F96EEABAABBA6B2390294D7714F8EE70C93261D80EE2B';
wwv_flow_api.g_varchar2_table(100) := 'E11040E93803008BBA25BAB9D774401B74AEABEE282CB3B9E41C54432C9F2FC5BCE7320079E533D4A0D8C9FA50540DB68895391852C754CB0C58F4672B8300226274F4E94F2EC5055FFE49374EA50632B4D8A9D4438B03628149EA56CA6001C058CEF8A3';
wwv_flow_api.g_varchar2_table(101) := '8113D1C09100653501524D09DCD10945F7380483ED1F283903CDABA7CD00AC736DAFF1BFCEDED52796063012C5022DC46AC9B95FAD094037DA2801D251389566086012C520E675FD485573EACBE3790062D24FC6899AFCFCB72E8580374B652439A1C630';
wwv_flow_api.g_varchar2_table(102) := 'F51527EAE66DD72FC3EEF1F450F29521964B7084CEA31568AD642415BD2580FB4EDC2792AE3995002CB55A9CD5C34D23DCD99E4C34ADFE144B4C2613990F623F540E74AB9A12C0E4D4E5A8418AA913DC2A0728F58966DD831C03330669BE6AB18274B372';
wwv_flow_api.g_varchar2_table(103) := '54D71FFCEEA564C177ADC4515C5D8288C028F795284E2509006C1EAAAA5B4ACC560476E8D8054857E6D41C7F7027A53C09FB8054AA110066EDF7BCE1D6D9FAE0ADBA1E785D89BAFE7EA2AA6AB4BF1F39664F51A763D742B7CA03E06870A03310917FE007';
wwv_flow_api.g_varchar2_table(104) := '24958403E8EA3006950BE85526C88EDC2130CCADA65479782993C10F3F219261A28C63DD023180F8BC1B255D0F04D0AA48DD288953104E3D60904892FB160377D64C10812CA5D2013099F47436BCB7DB5EFF36D8E99E9C0CC271928CC727EEF8C41FA513';
wwv_flow_api.g_varchar2_table(105) := 'DAD09C57F111C086AA32410D3B52B8B007E62101693441902929218E3C88F22096B42000861097E1822FFD706E1B82984C4F22477DE0A1862864A93AFB3A08441468A91F25879AD02B8B817457AB4395D81C0102D85A893C000B196D5CBD7FBDD32AA059';
wwv_flow_api.g_varchar2_table(106) := '83A120A0E62B080211D420B4A0AE992FA84F5ECF0704213DE81210F7D68461E21F816DB6267CC502425391B45A1100F1E6CB9740C05BDF0FBF9F491041A67152F98F66021034F1FC4A2DDB992071EBFB89E2FA91444BC0C497E8732565007433D248D0AC';
wwv_flow_api.g_varchar2_table(107) := '3F35F5E69F875E3B186972A0811684160B620D900FFC67E9CA26905FE5440057A361E3802A80B4C9B678B03F619B43315CC713CC960509D0FB9790067EFBF16A75FFD87133CE880DB5F538F9FE236D081C099EF94A14EA1A962B902D47FBE63E0768E072';
wwv_flow_api.g_varchar2_table(108) := '68031B7DAEE620E855A2091498AB4E8A8D1EA64F4F09D8AB1D4055D5B11F8FBABEEBD63E1E294ED5A0679A07CAC21E0E219D04C3FAA76E7A04965629414B7C02A4EA02EBCA27805B792E1FA5E9281E5D820B5E79A74ECD46B9EF24A9040198377494433B';
wwv_flow_api.g_varchar2_table(109) := '20A0487D27EA3E5A10037014461CA0D207868F560528C940A95272CC0A7891931D0154F622F970F7741276BFDB544151142549A24EA7BE1FC7F1A84618EA5EBA6F7D6E1845E14DF9E70F3F87549AEAB0EF2713626964B186498F90293AA1AC1B0147A93F';
wwv_flow_api.g_varchar2_table(110) := '95FD2F2EA10EFC430B05313B739DFD70330D5D2DCAC499C6BA14868040A9D67C588C407A825302EC47CBE76276EC31E46B0006A551B42610C25E6221B8BEB7C9044F85615083875B1B6C6F9DFEDCDED9DDDDB9BEB5B3FBFBDBDBDB5B3BDBBB3B052B158B';
wwv_flow_api.g_varchar2_table(111) := '2D84E50C56403CB201F8F1502C074EC6E66E9CCEE799E454BCF7E2D3C067D3C84FB580E8C8F315E5A40E95A19906A98E3A5810054448A74A34CA6DD25D0268309E14B378B9147C3A0140CDE7A84AA400ECF840C903A2278DFEAFEDDE1B42A0C6F0C95EE7';
wwv_flow_api.g_varchar2_table(112) := '1C4D7D54DB648DBA5E6EFEB1F9F68434B5B48D82E2E325D15CCD01E145F3BEB150228B11F5094C00C59B2F9E8037E5E1B4525C9D13D1A4590B4906926A409649B45F6AA22942A5AE568955FA84460772B5526780A5108800662555683320579F3D3395FD';
wwv_flow_api.g_varchar2_table(113) := 'E43879A573EBE6B5EB5E66493EE4104FDB85AA53746EEDB5FBC29B79519B319E42646ABA69877C1B859B7010A2D110C89D7D4E6821F0FECB2FBC13786CB0611EEE574A2CC1562B39183B4ECD014034B14B371A8FD61C1468A1322AE3428074D55ACD1201';
wwv_flow_api.g_varchar2_table(114) := '5A47D4B60A89A36301F2945E9A9D24917AACBEBEBB7773E7BEA236837045895EDFFB6B7BA217F78CEBBAF9096C6C5200F394C1AAB09C12A0512401969AA3A0C00686F1CE95173E0EFB60251803CF63A51AA71CC4B8552655153DC8FAB422CDD24F6A42BA';
wwv_flow_api.g_varchar2_table(115) := 'F9109C975D02289D4AD19F02D02302682595280760973D653E23BE01B6F76E6E5B9AB4B2B41CF9F1D3CE57C3EFDCFC933FFDE3766D62838680EBD4F8674A0494913456A162017D7504801E54D20620F5437FACBEF0E72CBFF8D162C1E9C858D87CA056EA';
wwv_flow_api.g_varchar2_table(116) := '83B5040113BD1D8BD9C480497AA254896EF132DC10A05A348935405709406946F300E023539DDB9AC64185203CB975F509045A045B9D36CE7659E8E69FFDF99FFFF99F9D8AA2AD1A3BBFBF020D938803D08EBB358F49025ACE1D8F01137510604189693A';
wwv_flow_api.g_varchar2_table(117) := 'AAFFD60BBF12B8DF4DDCB546440B833532D81F35AD10A37E1AAACE682D59F30FDA40359D74506E3C209224A7122813023C33B148D0C437DD3C4EC663BF9BCD1E59926F6FB3D94AB426410D018DE76D3AC4AB7FF19735017FF927BB373AA7BCEC5DDBDBEA';
wwv_flow_api.g_varchar2_table(118) := '13C3BA173200D2D1192C67408262C562407A6C9341EBF850237AF34513F0938776DAAD94582363458C9087CD30C4223228E0FA5871C6A1450C04AF9C0F06ED3AA745D6BE04429F01D9030E90A71EC4DC9A2AE6B367CF14C7AC1275ED25C7F149D274B16A';
wwv_flow_api.g_varchar2_table(119) := '7CBD73D61DD687FEEA5FFD79833FDDA99F216CADB1A6668BF70530AD72D627EE479C217432EADBD348DB4C63398111D9A09FBEFCA237A30256F4D727CE349CAF04002299BA9573D2F601DC0B93CA713DF41701A1DC10305025D927398A515C006202B054';
wwv_flow_api.g_varchar2_table(120) := '3908396192AF5D531D84A5EE3907C9288C7DF5D981331D8F4E3703F7DA67AD1B021A05B433B3069D6BDBC3622128737C22F4332725F0441D42144917363CA764D8807DF0E10B6E059BC5082258035F1D3FC8ED0500D63C1E5439E3520318B4F948A9D4B4';
wwv_flow_api.g_varchar2_table(121) := '0FF00D016C94684C533D16C4A1C0067A659668C0482A4E0EA2E0D04C6C60A88D7A2EF8EBED6AF5ADBD5BB7EA7CB8BB39027F75EE82F57651675BA3C28048138B80A19F6860999251F17CEE6404C48A1560834F7EFC82EBC09F7EF0FE071FBCFFFEFBEF7C';
wwv_flow_api.g_varchar2_table(122) := 'BE92039D7F2E3E6D2082C9A0D4E7647CFAB900B89E548E9FC9AE4E00F77D207372C6FC113638749C14EB39005A90A754DEFFA3ED7A62DBB8D2FB75F77EF371EFD9835805E8500BA45A403284408A61B4D84B0BD4316CC0DA1A6E0E0E12370D90F628D6E3';
wwv_flow_api.g_varchar2_table(123) := '87CE9BF944910A3843123DBC199033BC0C879E871C38124C5E6851E3DD11A58B6014285AB4759CBF97CEEF913457EBE6B67C41864F3201F2FDF4BDEFEFEF7BEFE890F420035A1D1EE4EF3C78D361362DA0FFE77FFFD77FFCFBA28100E35188EA709527BB';
wwv_flow_api.g_varchar2_table(124) := 'EA62E35D9C4DF5F0D6EDBFFE9BFBBBBBB76E3DDC7DB9FB3FBFFBFB7FCBC7EF7EF127AE8A7DF59BDFFCECE75FFDE2ABFFBDF3DE7BEFDCB9F3E0EF1EE48F07F9CB830777DEBD933FEE3B52EA84DA9D600A807E88D64187649C3655B5B8CB5A92BB22D1E9F4';
wwv_flow_api.g_varchar2_table(125) := 'E5D189178B2F8FC087842AA3B11747CEB3475F5C31FEFFFCC93F7C32F7079465F8E2E38AA89FBEA852F3E53B9B5B5B85554DD3565737D7F0D456B5ED75AD70F3D5522932D77E7E771327E06A6B6BDAE6965658CB5FF34FCF7FD6EEF7C316A8634ED866E9';
wwv_flow_api.g_varchar2_table(126) := '5892E5D62439CC23C91485AD66779126F08C7245375F8CC7E661CC20C7562C1C02B5A41C7BE3A71FBFD561A24865A05CE72CEAA74805E69979D9DC7D77756B67657AEE9036EFBFD7F2D9DAD7CBA50A7E740F1FF8D6E9179AF6EBDDC01051D0CA931956DC';
wwv_flow_api.g_varchar2_table(127) := 'AB9AC4030500D72D312464898E938839D2E44139240E483C430001EE464E15162233C6D5E74F3F9B0BC154F7C104E4F142BE293E7D3A8653213C4927FECB5FE3003E75616D11647B0501C6EAEBE5F6547E736F4E71BEBE5DBC7247FA43CF6BF522234C47';
wwv_flow_api.g_varchar2_table(128) := '0E8BE1A7B8A9A416E372283C9229ABC9EAA0ECC28CC7488C4968D4D87090EF0A6A87844A78B926F9F3838F3F9BA58950325021001AE9FEE9F37D280BF28D127CFD97D30B2C0BDBF363B9DFFC25EE2E17806F5716F456DC113B1F00409754AFEEB12CEB06';
wwv_flow_api.g_varchar2_table(129) := 'F8A6712AA9C4EA321187FA80A5A8A65704966AB5C5844C0990A0C6491E26170EE5232DBB44BCF3F873F5F7C77F8BBE99DF77DA0C1D73E6B0EF3C37F9CB77D7FE9FFE6300716FB95CD1EFC06B84F45D1D00604812D44EC7CD62673421ABD1921445BAAC44';
wwv_flow_api.g_varchar2_table(130) := 'A7D52054D68F46718FEBC403519384A1277BAAC996450A81E36E8F13B52E268F3EB9120B7DF1FB84EB2311AAFA501C34899FFE766DC133BE327EF5CD520178957777AE686F1F7BA1BDF7D2085A1002BDC327C15966A98A6E1C9BE3B0DC240E37D0B788AC';
wwv_flow_api.g_varchar2_table(131) := 'A8ED2B7B9D2882D591D90C873ACABD91A39BC48FBBA085D4CEDC47398542658C412AFDF404B52559323C42BA4558CF01C0D5EFB000E0C3A55A8157ABC5C21FAD5FC3C5286BEFEDBA91881B2DEE4F4AC266A0C871CE9D21B63F36BAF42B71A3433429C7A4';
wwv_flow_api.g_varchar2_table(132) := '13D5E2969217C9F70552E50E8BBC319972FF0C2590E08C3DFDF413044590FE4797C7E591A44143D464B549D275C95A005050CF8552BEFEED3201F8CBD71A7420CEBB7A6B0B58D40A991DB1CC680C5035B3E2C84014600DEB043E63D940C8461316401C46';
wwv_flow_api.g_varchar2_table(133) := 'ED5AC75471E09E01B9F7E2AC22C792C26ECCE133965B4F3FFB47D4CE1E35863C609EC96D168BD1F8A4A9FBE77B4D00B002F50F00AE365F7EBF5400EEFEC4D93F5AAE0465C709841D203054DD1DEDB333684324CE7A422080261D4152D623BC442161C871';
wwv_flow_api.g_varchar2_table(134) := 'CB0E38493FCAF08B7AA35B3A227D22D8F0E0F32FF266AB52D7E1B141D2EA46436670593D7DF1B8E40180C23A0078630CF29FB5A503F0E114808D9DEDB795606DDF102899EA33027D90B194633E0CD04A489278657F80626FE05A4A142EAC29046176C109';
wwv_flow_api.g_varchar2_table(135) := '5CF200E5E35EF4D8241A31C3ABFECBE7FFDAB6234B9501ACCCE84CB294CCF1E9A91B9DBEB356DC58DC53B39E4BE5D6FA96D2013F2C1380EFEF2900F2433057FE18805DF12484E89324DF398E55FA100153CB15466AE1B7B5A86CA0BAA19BA5D8D791D167';
wwv_flow_api.g_varchar2_table(136) := '039D301AF6B44BC876899A3CECA73A629CBD1726E9A3A8243DD196A695B53BB2171D56C93CB5CA93DF16D0793C977FD825AC1FBBF3BB651E94F08302A078E3839DE25B00248461360721A863139506AEB702615470E0819746593C69364F4FA5EF5B3102';
wwv_flow_api.g_varchar2_table(137) := '77728C68161DEEDBAE0FF388426FFE92A54456CFD883076558D2B1F73BE49743937C866C3832E1776ECE2EF59F2BC26201DAB9B8A1BD5AA60AF87A13CA56DBFEC36330B519001748905A49298A828A2A9EEA1225A31A491455A3A8DF229D72EA7F18C7B2';
wwv_flow_api.g_varchar2_table(138) := '19EC5B92083C28080D96DEE692AC1C014E92C77622D10060587E6CF872D205CFC4DECBD75E8B2C955F1EDCD9FCB3DC155D597F736B39BCB2EB9A56D0BE5E2600AF8A6F391F73001E96BC8E5362ACD4E2AAB429652EFC7142F90FC90533420BE5D3FAB027';
wwv_flow_api.g_varchar2_table(139) := '4490364D198B1698B6A9DDF609E3B81CFB244D9009497A31ABE93476CF9221D8100D14C206760AEFD165F030AC837C0BA0DF70A1078A9869DA4AE1F53243A15C0236DEF68200C0AF6EF94E2044007F10C30B0D162796AC2741342D217895E0098BC39AA3';
wwv_flow_api.g_varchar2_table(140) := 'DE311042397FADC87074EC8263FB828FAB3C0502BA67880481A575DC9D481E3387CC4AA682ECC619A8E8FC007E40B1B0F5075B51DBC2293CC5C28FD79609C09AA6A47FFD0D0C5BD76700DC7745147A7555E1B1D2583C290D2DBFD26665160C787D141A59';
wwv_flow_api.g_varchar2_table(141) := 'C64A83FC0DB30E40EFBCEF28A4DC4821403D3BE087442DD146FDD7089044B00CE6EB96DD3FA47198C18D08448CB70300A880C556041CC595DC1DD27EFC6889A1D0EB99FFB5B333F7847037921AB79E1C73522E5FE232A40751341671E890CE07FD2C9F8D';
wwv_flow_api.g_varchar2_table(142) := 'E6F46AF25BBD8BFAF8229A28B81A3373D963715D070230097EE83A448EED4A72CAA833F4856F9A24D820EB919C01B0B89D4C8D15A8A7C2DD6F9608C0DD19E22BEBC5F987EEACA8E9EA6D4FC7DA1C540D42EAF809DABB3D297527098C389CB5FB4BC94749';
wwv_flow_api.g_varchar2_table(143) := '2FCA58E049DE7B32D1A75630F03129D9AA47201181A5D2FECD4E68D72425E75F8E89586C1259B66B069973D43C5A5CD259DCD4E633F84185BBCBF385AF7D7F6F8AFB02F50D6D7BD6F8741BDB3CE9A134A2771C24CD919E47FABC0B321F6148F3B012F659';
wwv_flow_api.g_varchar2_table(144) := '1437A0013BE6C80821E8CD306B7BD3E289E1EB20DA430686E7352B36EA3AED8547551A64611584B9B4E3643DCE8FEE2C84FF97C5FC7BCC115829DCFBAB2506C3EFCFD330F3B1B582E00856E0FEE83846B5D09112ADD4BD018C41ED8908983D9A5A05E934';
wwv_flow_api.g_varchar2_table(145) := 'FAFDF0F1970E5774BE56D00E1A2C50C00C18C30E1F5BE5C8C18F51E94555262CB24B63E2E77BA7A62C951D7451640E4E11F0AE00B070087099DD8DF525FAC23F14B5E9AA17599137935B2C8BD321975431B228559E6F6288604071C6495A93B0178BB897';
wwv_flow_api.g_varchar2_table(146) := 'D4D1FD062BD0CEEC28F06B65A5EC68F8444C88CC6A5A8E7C64CBDCA05A1D27869D4A1A8A5295645B00A85E068F318A1D6C81B92C4E0F2456AED0753CBE5BA20468AB3F710ADAF68DBF454769DD2B610F70226BD2635D36A83FA72836D1521305A963D509';
wwv_flow_api.g_varchar2_table(147) := 'C3525D67EEC0E2688F06EF1D86CF069154D6B2D857F9A4D892A691F908A77B92883D418539383755EC1C2800165F456151D8509AE9E6D74B04E0E64CF0E737E8ABA4D8E676FEFFCE6D0FD62F43A734F72AAE284746B78732B648290D92D1CC0058CE2460';
wwv_flow_api.g_varchar2_table(148) := 'E8BAF767FD6649C6C07BACFAED6EC0A75C3247C20E1A74280CBD63822CAE4FB21EF1A323A34D1861662A001096CD963FBFAF0A005C5B3A0073C1DFFE20B7012BABF99DB1ABC5FBB5DE796684964949C06C9C2BE0765B2AD4F3C6E6ACD1C09B9462964541';
wwv_flow_api.g_varchar2_table(149) := '5257DB60FA18B168484D457E0BB8DA0D862549775810968F2578614487BDEE84E489251AD3DEF1B3920200E6680AC00DB52D573405C0CF966805AEA89EE2D68DFC6E848D154C57EF67FDC4AB8E87A5A82CBAA925A51721EA95415C37ABA60413BE2F32A3';
wwv_flow_api.g_varchar2_table(150) := '571991349B4DAC1EAA90574AE72A23A88C40306D9246EAA46AB133DB93B256C6A22381D681637BA80A74B1DD7EB089C399E7F990E20737B076F555DE5F9E045C7BF57E61E3978B6B52D7D737B6B7F3FC786E15AE6BB72B56C70F632182492A7C89B47FED';
wwv_flow_api.g_varchar2_table(151) := '3999D5B85487F5AFB5992D4A13B06A4809FF8929C70465502E85C2F015CFBDA16A873AC56C40B253B20D22E9660EE9BEE1D6099A9083905817FDE1838530221B5658C1A4A074C0EB8F96E609BF7E1FDED6FCF0C7E2CE160E05453EA60047A8E50A9BA50E';
wwv_flow_api.g_varchar2_table(152) := 'A7FDB6446008A678B59AA9C02ECAA2A0E591D4177DB656A51789282AD70EF94428CD27A9D43D26A840E5FD37BA21C9517621C79D565423248F2FEAEA9FEDD24B78823399DFC469DCAA3892870200E09BE5650415EC503D4AEC7736A67F81224A540FD1EA';
wwv_flow_api.g_varchar2_table(153) := 'D475E1CBB281899C57DB927434CC1C58C69AC395168475B43C27A9EDF5CF4BFD7468714B19C52902C4E36E3A454024D4EE3A24C3B3449AB2668F74CA9F35C26865C9D5AC306C21E0C0E3FACD1F3F5C3200001D2E171232103BC4479B1B0F8D905BE5A043';
wwv_flow_api.g_varchar2_table(154) := '14F44FB0960B6CE86A189C1CCE630049CDE1240D0C26B278EF71F5052D8E829A740D8590EF962B78F5E22864B1AF5B3176473D100ED4893D228C46E65CDED99C8740DB1A56BE30C8851FBF5D360058B65628686B37F3226941DBF8F3B59B7971D47F363E';
wwv_flow_api.g_varchar2_table(155) := 'E9570E2E3B51ED99693E6BBAD6655E348F1A07079728A4EBDC69A58D5E1CD4D28A232F4F4F4F2FE7A3C39D94B1E367983F3B66134C9E7969797279C9A3FC71A91B3DF3F2C08C2F3AA8C95FBAEEE5E55FEC68F9A7FE1F2D6480C13010445160EF9013E400';
wwv_flow_api.g_varchar2_table(156) := 'AD92486F10954AF40ACB52EC910A647A810E0059B0B0296000CA1E2160A774A63D431F7F3ECCCCE7775D339C4FE3D0F4D334A994FDE56F05144D197B99CEB5CED9ED586CDBD95236E7AECFC77C9B0311E16B9DD7B0620284542F0222DE4340361593074F';
wwv_flow_api.g_varchar2_table(157) := 'E4C520C698738A4AC5A636292F190098E1C7D759B79261B94166F9832AFF3EEC24BE58BB7DDA9D6B038661200AA0A7EEDF0ADFA55632F5DE40A3070CAAC29C329CFFC478B7318EF35C4F635E9BA6A9AEEC49D2500F3BDD4ED5F5FD7AE8B77D5BAC45801E';
wwv_flow_api.g_varchar2_table(158) := '42114270A3D3B6DC3DC688F58C00B141D2EEE115DB210007DDA3AF01D53E6CBF56552925982512B427E36DBEC793D394262222222222222222F2A9560BCFEB42FB0087BB0000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784242292261151270)
,p_file_name=>'img/persona-female03.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/img_persona_female04_oracle_png
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000001000000010008030000006BAC5854000002F7504C544547704C4A3A3B3E39363E3937443A393E3A364C383B5F39426745467D52453F3B38403C39413D3A403C39403C393E3A373F3B38403C383E3A373F3B';
wwv_flow_api.g_varchar2_table(2) := '37403C39433F3C403C39423E3A403C39403B383F3B383F3B383F3B383D3B38403A3845403D413C3947423E3E3A37403D3948433F433E3B3F3B38403C394A45413E3A385A393F63554A4B433E4F4741534A439479638E745FBC9776836C5A776253C09677';
wwv_flow_api.g_varchar2_table(3) := 'CA9E7C3B3937715F51AC8A6ED9AA84D2A58189705D6A594E584D45DBAD86DAAB85B28E71393736C59C7AD7A984D5A782D6A883C29A79D6A9845C50477D6857D6AA859B7D66D0A380A8866CD8AD8AD7AB87B99474A2836AB79273B89373CDA17FDDAD87D6';
wwv_flow_api.g_varchar2_table(4) := 'A884DFAF88C69779B78568BB8B70A26A54A8725BB07F68A56E58BF9074B574616C3F49B99475D5A782683C46D4A881B89373D6A782CFA37FD6A883D6A882B79272D6A882B79273D6A883CFA280D6A882D7A983D6AC85D5A782D3A681B69272B89372D6A8';
wwv_flow_api.g_varchar2_table(5) := '83B89272B79372D6A882693A466B3C4873454D6A3B466A3A476A3B466B3C486B3C486D3F4A70424D9F716577484F693B476B3C486A3B47683A456A3B476B3C486C3D4971434E95675F8759576A3B476B3D486A3C486C3D486E3E4A6C3C486D3D496A3B48';
wwv_flow_api.g_varchar2_table(6) := '8F625C7C4D526A3B476C3E49693A46805153B486706D3E4A6839456A3A46703F4B73464F683A46A67968673A457447517549528B5D5A72414C6E404B7A4F586F414C693A46683945673945693B4683545566384471434E774B5480575F7D535B6438435B';
wwv_flow_api.g_varchar2_table(7) := '323C6337426839465A313B58303A784C565E343F6136415D343D5E333E613540552E38582F3A60353F633C455C323D613742673B456B414A693946683E477F3D42864649BC4030C5402EC64330B84031C14331C0402FC0412FC04130C1402FC44C3AC247';
wwv_flow_api.g_varchar2_table(8) := '35BB4A39B93F30BF3C2AC75746B73E30CA5F4FD98D81E4AEA6EAC1BAF5E2DEFFFFFFF7E8E6DF9D92DC95894A31354F3539CF6E5FFDFAF9EECAC5433032F1D6D0463234D580739E6F64E3B28AD6A882D6A781D6A8839A3B35A24039D5A782663C49CA9C7C';
wwv_flow_api.g_varchar2_table(9) := 'C617C735000000FD74524E5300102F463F371A15060297DEFFFCF4B1A6895163EEFFFFFFE7C770D47B2256FFFFFF28FFFFFFBCF9FFFF0BFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF';
wwv_flow_api.g_varchar2_table(10) := 'FFFFFFFFFFFFFFFFFF9EF5ED7E2BE23740F563EADE2FBD1CD5C50EAB507FCF7FC1B2E049A9DE602A59D4F3FFFFFFFFFFFAEB358BFFFFFFFFFFFFFFFFC6FFFFFFFFFFFFDEFFFFFFFFFF65B8FFFFFFFF21FFFFFFFFFFFFFF956CFF74FFFFECFFFFFFFFFFFF';
wwv_flow_api.g_varchar2_table(11) := 'FDFFFFFFFFFFC9FFFFFFE8FFFFFFFFFFFF83FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFB9FF9474FDFFFFE3FFF3BD7389A000002E20494441547801ECC131010000040030A07F652D5CDB0200000000F8';
wwv_flow_api.g_varchar2_table(12) := '93D5B35B477E5D60B78E2D61145E371C6707AF6B57F81CC552E8BDEE9EFFE81A224BB61A0620E70B98E1AF55878E8E4FBE65FCD383C5199C5F9C5D5E5DDFECFDF87E05F8B90C04C80C6FEF1687DF2CFFFD6DB8417276B7D83FF93EFDFFF3029C00970F8F';
wwv_flow_api.g_varchar2_table(13) := '4FDFA30627CF4B4AA8845F28686DC28BC5E1C9AE873F7E7A795CE24A1CB50D6A87E6C5E3CB0E877F3978BCBEBA7BC8540507A538A0DC1DECE6AAFFF3FEF1F5EC222333B7B2A3468303CC6E79F9BC6BE98F6E160F17176F4956293851DFDB8F480740DEDE';
wwv_flow_api.g_varchar2_table(14) := '7FEE52E31F5E2D2F04D740D30C35429595A5B8EDFCF2F07367E21F5CBFE128D9BA52ED9122E006AF7BA73B917FEFFAA2B387926DE8909436D500526D0274FCCBBB5D18062F8BDB744B971F8AF8A5BC776A07ABAAB46DDACB54C4D79BB9E77FBA23EDF557';
wwv_flow_api.g_varchar2_table(15) := '6ACD74047EA91D6AF31E4EC5DDF1BCF31FDC814E55542335D341629A65E514E7774F338EFFB97F6B0FFF89C812F668438DF199D50177F3DD161E5F5D147B819BD5BFCAF6A010157B19AAE288D71FB3CD5F9B95A25952E53DAA135DD75F8C85D9826BD5C5';
wwv_flow_api.g_varchar2_table(16) := '3C2BF0E392B447D327C529986C0C12D2416A0434D9B4CDD5D11C0BF0FC066A1694C4E8C27F97E8D829297E81E63D6AD344FB1E5733EC8183875495CE2FD1666AE07FAB11AAE38028EF0AACE0FC7E767BC2A3079C2A96D2BC172A7EC9FE3F429F7783FE5F';
wwv_flow_api.g_varchar2_table(17) := '5B0454BDD89FDB02783526C141FB1E49E9D8BE9706AD9A6155926915322255736E83E0DE518E570A8EA2886A4D32BA2A889268826B6C5AE0715683E0E01615352343AD4AB107CA7BF14B4AD3600F5071F8278E2EF66694FFF492617C9728A52A9A4326D4';
wwv_flow_api.g_varchar2_table(18) := '6C50D4D5B82126594DDADF4A58AB6B8B931935C012B5EB43E2B62CAE6114A7BA75F0BAFE9FB871319F95E07311AEA5A8910E6AB71A1E31A3BF3EEE95B280A3A1862A689ECDE658B47786834CA18483ADABD257A444131FE57FFFFFD0A609DC421B806420';
wwv_flow_api.g_varchar2_table(19) := '6F37736980C7CEE94C46BA468683F5B5AE8DD2E8872AB9B5412E553F7050DF9E6732065E96D56DB841388A44B5AEF825C68751585FAF4E9CDFCD6421B849D58A138CF3DCA853F5E3D7DFFEA7A46AF6A1C7E4147BA4FA0735D7A19EB8CEB4FFB3BD687B24';
wwv_flow_api.g_varchar2_table(20) := '25A709FFD8BB6803A462620218108A8842509203DE5EEEFF2A3E241961935C80FDA63895E799D7D36764F0EA712962E0DF18DD01F343B2F92B8A1AFB0787352BB42309BA2C19E3F4A7448F4B5EDC2B4917F056D5EB4A3C58C159F169FDE8B8B55FAFAED2';
wwv_flow_api.g_varchar2_table(21) := '450A2AC80E8D6C16486C62846D1F11C0776520E06F94C366EDBF26A01A06ED93A873DAB0A102014ABA0DA706C0734111606C1B0AE0AF32A8C0FB4DC99D15E741C3DE7EA71F0F9AD4F3AA150089E79FB6F69B1590A68510DC72A178BB042AF068FB6E02D0';
wwv_flow_api.g_varchar2_table(22) := '060FC3E6DEA8CFA2410F05B6190EBB03168D4F01B5F942A6282030D5A0655FA0042E606B5372909B875510D64DD1C6E9318F38EF74ABE91F84EDB3988978B43FC1360724693F0556B40BF16BE6AF9E17BF45FCEE25DA00B1B3306F6DFC18EC1E8F19E72C';
wwv_flow_api.g_varchar2_table(23) := '3EAF10F3731A1CB522BE84141713AC59AAE14CED88F012B6242A7E21B8690184989B69DDBFFE14D6BA7B53C63967D165831A096973BFC338975CCE94B83A1F7A10E10DCF014C16552DFCA4E891AB03524082030F7A30FD0E51DABB8E62AE11DFF4AC9C74';
wwv_flow_api.g_varchar2_table(24) := 'F25F9F2F21845252C58306F628456993C4CD0B80EF01F0FC41D17BC1A612DE4095343D97F99CB7626E101D4C86A6FD13B64711B7904A2AD13FDB0D7DCF2C4D111F57A1D6030C4C1609FF7A54F42CE0433E00606CED00A7AEAEB137EF738B5697EA8C9992';
wwv_flow_api.g_varchar2_table(25) := '5363FEC2E8C06C2695585C1DD56A042000BD060158FF7FD5268BF879D1338137B7721F08337CEC9F8959C23558AB6B1D5CEF8247DC42482E84585210CD0F6D1B15101268E35F4D0DC1F6FDA705F7813853F1B9C1808D82D43B9D3296EA7FAB8D00A2A87E';
wwv_flow_api.g_varchar2_table(26) := '381F33EEA004174ACC149B9F1B81574902482B27B0FDEE63B17B013B18E5E13C39A5CD4BCEB8105C63DCA68886F5A31B26ACFA6B245C88E547A22467A3F306461853CF07C653FA102350411F9E7D2CF83C046337EAAB64275F94B6AF62CE5302E293C670';
wwv_flow_api.g_varchar2_table(27) := '08774F62ABFDC2522039172A51824BC1237688811704A90741C4AF5549808B3E2BBEF79CE05A6D55C3A13568636F1ADBDB2C3401836E7B7F30ED0B9E42A41721B8524248C1E3835DDD53A7AB3E5AE0018082A287817BDB10D47C4B4016B471398ECC2D4E';
wwv_flow_api.g_varchar2_table(28) := '44624C60D4128B48094B8843629201C1F51F2D4E3C4CCCDEC86A3A02FD20287626F4F4E196E9626E82364F22E654DD20622CD1A23A5823906B6DE0E353E2D76A3875AADA0C6A0014BC1A78B84DD06D84CD9B484827E6DDD8FC8D146C7A047C3FBDF9C027';
wwv_flow_api.g_varchar2_table(29) := '0891006CDF2BF84804BB969E03ED5DC6FC36568C88BB48114233D09A5431C0A6C3685FB4460A9E09BD3587602AB9BD38D41B2C8C7DB3B8DFEF47196BB7C94F56FE597F8948F044183F30DEA3007B30AD05B05EAADF7EF8B4D004A00C02DF58AF77D33746';
wwv_flow_api.g_varchar2_table(30) := 'FF697C79B1777DCCFBCC1260915100D65767D7CB3F692D586A30D1B22A40D04308D67C842140107F7857E819E1FD0F60BD138B03AC0DE09A19598E0F771B3EA937BB17F36833F6596947FBBBBD7AA3519B1C1E30A63342C1A36B44FD20B0C9B0B603F0E1';
wwv_flow_api.g_varchar2_table(31) := '5DA135E0C14B47002669A747D7FE6CBEDF0088521A86216C1C1E8FF926D8FCB4198421859852543F3FE3722678121F37690D126C736A4CF0B21828761470D530F64D39471B3791BEB95D1A62526FF426BD5EB3D99C5C329EE4E51FEDE25A6389E6A4D96B';
wwv_flow_api.g_varchar2_table(32) := 'F8B07E6D3852B24D21A82250C1C4F321C4FEF6BDF2CC45F56837DC638CB369DB9B744FF72ECFC651BFCFE607834187A96CEC63E3CBF3FDEBC1CDC1D9349ACF0F2EF7BB5D4D1C178B3D0FD9650A483C88BCDAF6C362CF053501990D97B0711C6BFB3FBD38';
wwv_flow_api.g_varchar2_table(33) := '8BFBFD58DF77C159144559DF6F72C378B1E8AB998AA4622A8AFB8BD131D3DEA17F5D47B62024242018918213706F1B646BC0AAB71F9B9C2EEE47996C37E1990CD8E6BD69445452A5D96264FF6171E1D93305583788010285D7009CD90E46607213F3DB70';
wwv_flow_api.g_varchar2_table(34) := 'B5AFBE4897062B296422F249E1621FA6ED100002043129782AFC47BE1F40270711CF8231B64143E2EA0125055711CBCA2FC5E210226C54C08214BC1A7CF23E4F40E324CE8ACFE72DDB007250423A6728186FB5E63C5292A76592509F8E86081B2F68E1ED';
wwv_flow_api.g_varchar2_table(35) := '147C61F055E08681BA81A309485CC01B5FB777DB7BF348642A20C1D7E85C77BB4717D3C8A8031789142A6A0FCDDA845BAC7A5FF03591671E70EB6000D07AB60C8A4FEA433AA4A71DE5E497CE21689C9090527A3A4E7542CC7834ED5631761B350407AF0A';
wwv_flow_api.g_varchar2_table(36) := '3F19F3535D6DE8E845F6FACC89BB6887486320D7658030174B40E7284404D2FA492C6C70143C3E9B783EACACCED612FCE1EF8213F0F0B96775159BC94678FE498B275202865A358697EC5640E096008A31A2FEF542D8F4204916031FE0F5CA1D2CFEAEDC';
wwv_flow_api.g_varchar2_table(37) := '931DB0DA0F24445702FDB5848B436A6CE32AE2523AE1A54A7F2FC7FB2102C826CFD23AC6C525053ED092DB7D21F0FEFF8A8E372FD653418086BB1DE6248D8E77C3301C1E4ED99DFD20119DF596BFA7E7664C6A20E3BD212010E9F1228104006B0185C6BF';
wwv_flow_api.g_varchar2_table(38) := 'B9F178D81BC5EBB227BE6AF77AED5124560D60911A471AF6D455B737399F5B7E74F7544ECF87D0EE4D112F2090BC7C58FC0D912D008CCBB620277DD3DEB188F868B4FC245C1B402A6E61BBA1B19AB7622BBF6B8840CF8D18A1F7AA041BD33B1867EAA1E1';
wwv_flow_api.g_varchar2_table(39) := '1ECF2A3C8B63966D028ADC6020E16A166743647C55A77E0D025763FF5B9E2D31583353DDF0B4C37286BE11021D84933AC34F7439D4450086AB45FB8765D895CF1000BDB03B8AF3756F26F449C5B4F28FC726EDE7B7D1390D91E631B0E2A30F8FCA705E70';
wwv_flow_api.g_varchar2_table(40) := '6B7DFC0323444FA25CDB3FB155A0504AF0E97CDE5A62341FF34C60149936D92EC51EB61E4097447F7D2C03017FB95547629DC0E6CC43AAC4F8FD716B6070D631CA9FD85FAE2D2061675E05EA8EA82E858117E0529C1AF9F83E770E383CEAA80D028431F5';
wwv_flow_api.g_varchar2_table(41) := '6479695D0D0607F33C3B6BFF98F0EB100173EFED2E19B61DE182E3C9338CD60074329F89ACE55B06EC64447646A34E664C90E46743E3239A1EA3B217FCA014DBE27F6608C084E281ABF8DD55ACEA7D36B6614166D5DF616ED6886D7B0D5610D9FAFF5210';
wwv_flow_api.g_varchar2_table(42) := 'F02E4740859E8F374B1F296733CBCA2A471219DB700AC04E82DCB611FEEB9F729C9A26D9E928F49AD35BE35FA16462DB7F0ECE0B6632E7F32073BC1A23BCF3A81C87E65E6C3C27E224BA73142EF2DFAB99C813C5E64D9ADBB9032521E09F6D80B21521EA';
wwv_flow_api.g_varchar2_table(43) := 'B27C24146623566C1020723E5029DEBF20288B521240FC0A42F54D1510EAF397294B36F601F2DF4AC9BB34237C8908B8F7B2927D620C40F468B1990C7DFDF6FDEB743C36D5011F77A6F3AF3F3A32E729657CD2A0EB354B730AF5F93FE58802B0E20A5803';
wwv_flow_api.g_varchar2_table(44) := 'DA3B8837CCBBF5F3DBCFEF3FBE7EFEDC6AFDFAFAE3F78F6FDFBECE64567CA1FAE7D4CE58DD992BF0B214043C7953CB1F07C7081DC69B2DC02FDF960CFCD49F961FCBEB8F0ECBFA4591C467BD303D79EACE1BE287E53839ECD7A0933FA82C2F61F32CCE97';
wwv_flow_api.g_varchar2_table(45) := '836CFAC30AAE61E4973C8FE8224C23E05A9582B74FCB40C00EC620E30474393BDC632CBF05C73ABF96F73EC5CF5F633553A927B4E1213AEE51F7A8D115F09B2765A806B741353027056D09432002B4771C719EA8D9CC4DBD186FFDFA6254E0FB979662D2';
wwv_flow_api.g_varchar2_table(46) := '10603EA4B49D80CC33585246C1AB3294C38FB7F47D07C67E3DB03A127534655CCC942660364BCD4026D369ABD59A8E59BA302AD44A01D87FFE5D278EB7FE2843268CCD52973B226400F035E7C256006AE509A458E2EE65C9717BF5BF1893F5A97A508672';
wwv_flow_api.g_varchar2_table(47) := 'F01902D4D3C10B6736452AA871D997B399584F04855069F597489EE409E85F0708AC6F3FF13C60BF7D530202768016DD9E007604C08036AF622532899FC87CE7D644EC253EE8D91CD2A262FA824625768A1F06EE6DD925399443D5C761779A6D0DA999F5';
wwv_flow_api.g_varchar2_table(48) := '764208C9A5DB1A5742CBBF4BED965D0E9E578A072A3D7BA1173B410565B0FC26001572C859B61E507226AD09986D00BE1A08469D36D8201040D319F3007A5DFCE78704CE63E52B1910F68ED95AE9959052595B9059176808F81F7957D5E4360C84C3C71C';
wwv_flow_api.g_varchar2_table(49) := '87139799546E98C1E3B13592CF793D6666FCEFF546C6C27BAA7E61CE7EA2455964EA8FE8A9BA99149E3C9D4C0CF734381A4EC7C53878839F0AEE6D84E3F1C9687A6679A59E779C9FBAA232BD4751E1A163149657D7C6D3D198F119C1A64F000AA0C870C8';
wwv_flow_api.g_varchar2_table(50) := '4B661EA585172F9E3C31FEEA8B2790E0CA0E9EF0F4F9C4B3F19CDFB7BE81DA9A63EF5826308C0309C8D0CD7AA2D54D9F7F7EEE593A3A0945429322DB6C06948BB82846877A2B157F682135373B312D3E792B3E114541484C2467E716828FE04F8F6DAD20';
wwv_flow_api.g_varchar2_table(51) := '82EB79BB44CC547D1B5027E6F285FDD8DE627E85502E333E934E3C8F0B82687C19D098C985226343BF797E201CCA2DA4520B0BF3C17020EB1C40656B055342DA79DBFF01BDBF03F0B8071BFD1D87D1C8A34038180CCECF0783A140D6EFFB37F09736DADA';
wwv_flow_api.g_varchar2_table(52) := '4594528CB4A615065514BDF51B2A7BEBDE2FE306FB1B880230AACBCD5683B1C00CA36633AFE5CD85A07170E8E3123601C8B8697FD1E47CBE69209FCFCB5ABD8D352B44BC78C42D01BB08538A3166D7E8737B80CF881284BF483A0B19F34BC01823800164';
wwv_flow_api.g_varchar2_table(53) := '269418C084508AB4963450898080E313CE87800D8CF0E08C90CCC6BF2AB5FE2B0228080F3CC886E02C4F0C02223CCF012ED99D5B98FFA0F3030B8A41C0E918BF7300FD033ECBE01C00A7081B07FD83511F9F38C398FE06D206B54857557311ECF0BB0ABC';
wwv_flow_api.g_varchar2_table(54) := '3A6FB3716F9E0720F56603AC2045328B8825156C012E7178817E2500E3BA992207C15006B5D3BFE4731238FF4C01B6EC08A63FB33842970645038C85329FBAF03EEB000064DD82FA6B11E04A0D68ECF03800AEA8770D24F433C8CF5206254F70A07CBCC5';
wwv_flow_api.g_varchar2_table(55) := '5FFB5F237BE2A3600D100CD31F10D06949A64BDCBE5EBCE18C81C37350021172AF7EB2DDE525EF2D738BED8C46785107466FEFEEABC86C7813F84BDE69F28E9D45ECE0C7EAE9DD4FEECD6ABB712B0AC3ABE8CEABF8AADC2A850143699831FC14E15860FA';
wwv_flow_api.g_varchar2_table(56) := 'B7E27362412D352629A8303E5E751C692DC3CABD3D9FF0F63B4C7B6169F923B0FF646535272BEAB57AF47E7CEFFE4DE78362A4FB1FB47CA1389BFC6AA4BBC464A95C044857F4B5A771DFFFF4715CFAE31C7FD97D3AE67A8F38F5BAC23880F56A792531B2';
wwv_flow_api.g_varchar2_table(57) := 'FA8952396798C4C10DCBFEF78EF00FF5BFFF4158F61A77454C8B80D197D2F7B5BC49C401329C85E54F46B2147C325B0DF501723960E2BF8D07D9EC37F77EB81F0FF9C4E83FE6656F82BCA8D718425C00BC5170AA0B4B5F8E5CEE375B8576A32103B2A728';
wwv_flow_api.g_varchar2_table(58) := '0C1CBEB6F9F7583A958A13A0B3FC23883F3152E643CD07080202C8308C62ABBC354AFAA529276758D77948DB3B1E132ACC539FA7A24DA09B49A55EEFEE31805C84C8013A58C45B5B2352116E7D32BF905B376474683420EF782E28006CAA7DB89F927AFC';
wwv_flow_api.g_varchar2_table(59) := 'C53CA8CB5E4A3F7FBBC16C104C0B020E1089C430C9999D1F85C6E093F92A99C0FEBE09131D0E763C1D24440054EA3F485234FEFF23D47FD4AB7F4FD500B82493F840BC89D0901142B9C3D9F9611F1D2D1F4D3916C0D8F60E3A0A82C00D3A2601077CBF52';
wwv_flow_api.g_varchar2_table(60) := 'BFFFFBEFB7A528EBE3662095BA7D7BEC7B553BB64592B95C161F22744386E52C9C0C715B905C5A70DA068135B675C6D0817384102208F071BAA67E789D9624299592426F49BA7DFBF7CCF3B76AC53B63DDBEBC811E48B487583D490C69D96F56CF2F2C84';
wwv_flow_api.g_varchar2_table(61) := '30FD721B117126063262EC635BD7D489D713DF8F3D7FFDBC5E9F98F8B0B95639D5709C47379C13FA0808B497AB964B4357116E258E5673C6C536C1854CE4C5BA66D088D2A14B86480F024FD36A354DD3F6F63CEF2060BE9FB73108111A0100D78D0B109D';
wwv_flow_api.g_varchar2_table(62) := 'F98D82534E2486290D925B27C5C2C595CE11E2EE7B0CBD50A0901E8A746133A6042CC4B6C50381DCE76E463FC0FFCC9A8972DB489286F7EEE997D807F053EDF514738F8108F6F1FD8828D0043AC26044B54DC490BB25F470822B11C0022206E2B0217BEE';
wwv_flow_api.g_varchar2_table(63) := '51FB9CE351564D209A9257DE9BEEF97CA0123EA4FC3391995504C33F4E80BC28CAE9BF7DF8E0E33F99B678EFAF3EBB1FA393B30040899F1D9E7AA16115C4B1B849E4C42D6E2A2400628F8120EBFF49481CB955515575953FFAD69FFF498C7CDFFAEC83C7';
wwv_flow_api.g_varchar2_table(64) := '9253360F11CCCF87F6DFA3C44BC0A220F06F79A7C1DD507DAF0771E060C631809BFBBD3D5EA668AF65A4871F7FEBEBAF879F3EE07104F3F5CC18E48C09E640ACECDCD1E32592E0136F96DD8CB9F50E02F40B6E90F47F1A8928529F1E023C469BA26A9653';
wwv_flow_api.g_varchar2_table(65) := '24C9FE4BF393CFBEF5F546FFDB1F3E1610AED7411F286700C4F9DAA3C7B7DECC019997F912038AF9CF08854D04E21642C9AA698BAAAEEBA294F28A87DFFEDA24B8F7E387F7A32C02449601986C1D18F604A7FD224460AD85D8CF3CB2D08286F80F883750';
wwv_flow_api.g_varchar2_table(66) := '16CC2C7DE0C52D2E9A04CC345D2E576555A5DAAE26AB9FFEFDD7520EDFFFE8018A00CCBC0F3F36220901DCB9CF9BC80681056ECE475EC69DD82CB861DC1429AFB66D934E0D02B3A947C585CA4A1FFED37BEF3EFC9FFEEB84B08FF1792F40D65F904EFFF9';
wwv_flow_api.g_varchar2_table(67) := 'C493C70D428299FA34E9530286EE9EE88D3C50C29BC4F4449296BBA2AEDA5D6E2292CF774D3DDD15B2BB07EFFA39F8E1C7E1B917268066D665F471EF0588989F2D7C25075FACA7D0CD8344A8B70F1D014D2440968124231C56C3BFF5027ACA72491C47D3';
wwv_flow_api.g_varchar2_table(68) := '55D3D56D2A85C5B2AEAB52793DF9F0A377BBDFFF814F8800E667A7C680F17C30005944280344C37E8EA1083AC190035600BDE793FE96273864CD410025879CC8DBA2689B251317A79755195197D36B537549FEF0BBEFBF43FF1F9E9F33305B2F8C4BBEBC';
wwv_flow_api.g_varchar2_table(69) := '3A0016D736B791051B0ECBB7E5770860F98F841903C82C574D57D4DD8A48E536D7453D55A4BC1E994BF3E1A7EF2EFF7F202F03120790087FEE6133F585E0ECDCE0EC701C14C7BC41C80DC47FC2501D34F30EFFC82A0EA7E38BBA98C2E53657D581AA1DCB';
wwv_flow_api.g_varchar2_table(70) := '2E8DEFFFE8FD77E4FFA33E50D2FE5916E00DEE6392F3130B7190F015126F82EE36EEA6573A5D9908E78762DF004AC3AE36D48D96F552AB4A70FFDDE4C0BD47B3130B7233CFADCF323F8B108BB3C0007E8631E236CEB147FF2D397A2C37510CCAEBB65C22';
wwv_flow_api.g_varchar2_table(71) := 'F64479BD31A66BA327DB74554DA35D2BA2273F7D1767C7DFF8D1FDE0D409EBCF63B73EF7671E0682F3CC40B63EB11040089ED813C6D1E1594F0ECE26FF93148830F9925DD16D721301A0B4E8C6697D19B6D5B8DA95751A49C5EADBF78E2FC0B73E748150';
wwv_flow_api.g_varchar2_table(72) := '82098D321BFA98D979620C4070762E98A04CF25C1FB950FDC8E3CF3C31096F3A2DDDE1FD6D3B1C2C935E74556ED37253B44B8188E9AAE869918FAACDB2CB9F08DB5459F0D9D13788EF3D38CB6421243B5F609224B39CAEBDDE1965963D5E08B1C866FA6A';
wwv_flow_api.g_varchar2_table(73) := '0C5C2C663E77636DFF5B8FE306B1B000C690E65D7D8159367537258A7D4D8B76F1B4182DABD28409CAB7F9E873FFD8CDF0FD9FCD4E3307F238393B0925804920CD82EC743E78301BD2FF200028CBD4BB18456F8639B2BC81D34D038C192FCB7CBA6CEBCD';
wwv_flow_api.g_varchar2_table(74) := '945153EDA60409CBFAE97C53044FAA29A8ACCBF1AEF1BFF3C3239FFADE3F9DCDE609604FFA8DCFCCC7061EFEECE46C2D103A399B991B67FA10035E126105A1D5A1C3BD15E9D6D430BD34BB6D5755B9316D5D4EA3D1A69ADABDD3992B7E9EE54F12C6D585';
wwv_flow_api.g_varchar2_table(75) := '5B5666B6F8F8B829F04FD96C3E0F041ED9DE7FADCF05C298D39345BF219A9F5A84863AE8B2C417B78932F1DFC1F519A4B28BBB2E5553B52BA5555546BAB88881495D2E9ED45EF0B9CF6E67BDAEC49F7F78D414F8F387C2F940B09E133B99E1B897789609';
wwv_flow_api.g_varchar2_table(76) := '83942D32C3408885D009314CFD0CE88D50630FFB208734A44E08204C9733CD2FDB695476C5CEE445674C954724AEACB2D1E6E7F39F3F49BBB16B5AD0D3CF3F3BA6003FFA00D07E0770AE282138F10D804ED6A716507C7AB6B8BBA287E157964B6EF8AF2C';
wwv_flow_api.g_varchar2_table(77) := '1468B00FFD511EA2A7EC006B767519A5655737795568B333842CEB70DC6EFCA79BA4A9AA62649916D977DE3B62097C3401B0BEBC59D69F0464002467EB590CB82C58380688DE32F7048E03F2DD9D8391CD1858D529404459554B5176F5B626EFA6A0BC0A';
wwv_flow_api.g_varchar2_table(78) := 'E34D65C35ACB4D3972A26D75FFFBC713E0AF1E4EFAF2D7EF779CD7CFA5C1B9973907B8F549C28045090712D11309BD71C89524BC9D515A97ABB6AEAB7C8AC9EB6ECA783432512F40DB19D3B67159052EC12ABAAC96B27F7FBC21F0D163009DAFE78610B7';
wwv_flow_api.g_varchar2_table(79) := '3E35EC05397380C03B59641E8086D6167303E9A00DDCD5F50993903768B79BE5763722EFEA268DA2B2DE4D2350B331A0FA82517769376D30CB4C9CADEA5C043F38DA33F0C38713700B270784D6CE7D0306CD8304AC75F3D0189B21707765FE21CE0A1274';
wwv_flow_api.g_varchar2_table(80) := '579DF014DE7E6CACD291D2AA892294164563648A2A05B53B03669B6B543593EBFB49829E14BB48C41FFEEDD18E01EE0B9DF755CECC4F1203303B991B279B39737E9611DB4378E512C2445F0DB41604C87AB29265E08EDE70A884CE0A489B6225D072535D';
wwv_flow_api.g_varchar2_table(81) := '1035758AEA5268592DA3D536653B4E409B6AA948D01CAD0F7CD717E1E97ECC11C1220439ADCFE6C643CE122C2C920EF1CC1C24774E392107C4DBF78765D5E62642E35D5DAC84C8BB3A57B789F66D50F96ECCAED5B20E859A7AA9557D61A6BB47479A85EE';
wwv_flow_api.g_varchar2_table(82) := '7DBCF09D1237F42A818299377C64E34EE684C85A21D97E3C9088D46BE059087563F83F203F03482C2085B744182DF34DB549816553D717291A95D5765BC4DA2C21BABC64594CB5690D5AD5394D515669DA3E38521178EFDB93607D6E00FAF617269CCE49';
wwv_flow_api.g_varchar2_table(83) := '9CF0F04EE6F44C0627EFAC73E35B24C997BF3F7583F934D95F18B022F6C34FA6ABAACB0D982F7702CB3166BA344ADB14C66DAEB65554E790D6CD78D719B35DAEAA87477AC1F46F1E3D9EAD4F8D55A2607DEA40B159CC4022980BAC2459EBF196F68FC42F';
wwv_flow_api.g_varchar2_table(84) := 'DECE2F7F392C1830440A02C9695574974BC468536FD20850DE1A342ED2693DD6AA5AC2A655D3997855A5BBCD07DF3A521378B0F6FD04E77CEDF336738133068139590B48C2C4CE3D00BC84BB18FFEAD703BFF9CD70ED8DFD6FFDBD5F0D29306DF227A3A7';
wwv_flow_api.g_varchar2_table(85) := '4F57796822BB6CBB6625C5A6AB8C40654BA2A656DEC5BA684DB4AAA79F54D328D8ED282E1F7FF7484721D70D20019D9F0B42E1EC22030478BE3C34F303EB1C3DA16020CE0402087F7BF5C5B32F0E5C3D7FB6B79F3FBFBA7ADEDF7AF1DB4180D13879F2F4';
wwv_flow_api.g_varchar2_table(86) := 'E9CF9BDDAE2B768AA7E5A64D6D34DE5529A8DCF933BA362E3B4C576ADC6DE2B6413F6F46E3EDF2F1C7DF38CA1CFCE3207002E68B0885A18221CF4DE67906A17990E9B0B93FBC1C240BC4BD00D76E3EDBFFEC0578F97C583D7B75F5EAEA9600911FC85F38';
wwv_flow_api.g_varchar2_table(87) := '485765572CA569D9ED3E81A233E8325F2CB22A57D39176AB78B91D6F0A435E8DEC6A3B9E3C3A4A15BCF7D9C4D0FBE37B40B0F6D963167E941C5E839147CFE1494802B76F19895EBFF832EC872CB81AAED719F0F2FAFEF3E78300A6692E9A66F7C40B0DCE';
wwv_flow_api.g_varchar2_table(88) := '4DC2A6EAA690EE36633BDDAED065932DFCADD1AE8BF27A9AB517D362A5555D463415F171AAE07B0F63F06689446241A163CFEC14E17CDECEF0D1900BE4BF7EB577B70FF64D9E3DBF7A7E751060DAEC2E9BA669ABBAD83C799AC0A8AD56113CCDA7AA76A8';
wwv_flow_api.g_varchar2_table(89) := 'D905B3CB4ADA6C9457665C536E18D58D88BA96888F8E721824FA1721508839BC00E12F1458623120088755D29B804D6C0878AFAF7A01FACCDFAF87CBB5EFCFAEAEAFBD0003564A5765D535A3483FAFA7C2EC76F1AE1DABD969DCEEA4A2515E7DD26EA6DD';
wwv_flow_api.g_varchar2_table(90) := '4A6D81A4BA84C7473919FCFE641F4BABD04D140627BD006EAE4F6C902861E0C6D62E99790C78994D80F1EF5EBC11F8C1FDBD0C57577D0D3046520410584222AD8A2EB5B3B2184159A8AC8C2E1A8DBB52AA4AAD2AEA7653C5CD3695C7A89EC2E38FEF1DA1';
wwv_flow_api.g_varchar2_table(91) := '067E1C254E18085DE04EE66E88FF6906C6C56033DF03420E38ABDB9F748C7F7B5B80DEFB418021195E8F9755B12BF327299AD86134DCD569487519917623B3356C4A8DBB462A72E5C5A4ACDA74B9CD3D50531BA2D14FDE3BC65ED89EAE9D0190922073C3';
wwv_flow_api.g_varchar2_table(92) := 'D18604F801CC168BB91D76FC5664BE0B411CD80BF06A70F410FEE7FD62780E5EBD7A1D9A55B96B77979BA2A88ACD128889362DFB53A0B44DD99AB05B69DCEE0588934B484DDC759140450BBA3CC64744F73E249827008850932481C44F5C061006902D16';
wwv_flow_api.g_varchar2_table(93) := '0B8FAFB0B3DEF2049008DCCC1BFFF6D0016E77817E2A787EFDF3B763228C310AD3345D5D56AD01486B74B131D1729F0169BB1A6A40CE384F81B45A0988B639A8DA7C74841A18F8F478EBF92CE44BFF44329FC7281440B6987BF4F4A60B0927490C9EA3EF';
wwv_flow_api.g_varchar2_table(94) := '02371F81DF7FF1EAE51FFEF08797D7BCBA36AEAEAE6BE3B367CF5FFCB11D41BF7F8A1499745B868930356A37E36855C0D64CDB95D8B55297639A654CD4F43A4DEB258CEAD5A747D80BCF02031091CC023F21982524D92CB0280B3239C1C47203EB0B6207';
wwv_flow_api.g_varchar2_table(95) := '782E092D0984FFCEAAB5B0B66D456106FB37E3D90205D63FB37F3222819CF51CD32BD7F766541A628DA06B853A2FE221892B24547323279857BD1507DC394E94B64EE2B8BF603A72EC591BE5E90F59D897877D3FDFF3D0F93E2260BDFDE9F9ECE21EB3F3';
wwv_flow_api.g_varchar2_table(96) := '69B55011501D82D1DF512E567698835E488E30DBD1FC2ACC018BB7C003297A44C0A063BE8D50A80C7866B4D1908A9E37795C74A022C978B3FB32F0C4BCCFFA000C3CA07F1F7C1A8DD22940CB37E0ABD07586D84C8293B3F3CB720B97E76793F7AB96F85D';
wwv_flow_api.g_varchar2_table(97) := '96768152BFCA5424D5B043D25198C480510690152296CCCD93500BA503B1020C4E75EEF6438F238A22B57C4F0DC4B3DD13F02B0782D6065FE30201114DB28501A0E6A3731C896D3DDFDCB4C3789F0AB141C068569657B38F9F56985D95E56C54AF572120';
wwv_flow_api.g_varchar2_table(98) := '0D0E18C82238610CF443B4D85B59C4C0DD28E04C6518471D437D9E9BBD42C3B00034072E067D43033AFC211E769218F7BED97911788E5083B15532E0E093395A376BFDDF98CFB702C06A3B4DDF5F83004A79D737E5ED743CAE029F7036BD2D6FAE27EFDF';
wwv_flow_api.g_varchar2_table(99) := '1301EF02002B97B1EDD3DC44F7599614B1CD81E50AC0962E0E22C6D4E7C5712F12D8EBDBC093107BD2466C8B20B2410489CB5B3BCF823FED23691B042A811BDD0A35A44FE962AE6D1960B0A1FD6AC498B67D02CE66E5E5B44E7C2B4CA697E5EC6CFD34E8';
wwv_flow_api.g_varchar2_table(100) := '0E8ACC58B16D744299F61854C812833402C43CAFC8F8BC989F241C20493926190FFB0CA18D99AABD13B6D3DA7916FC718F4303FCE56F9A6602B64DA003B0989F3AD40C99F03FF87CDD19AF09987CB82B3F9E6D17C4D1C7F2EEC3841646EF94CC586D1776';
wwv_flow_api.g_varchar2_table(101) := '6315291BD0E2802C4E7A1C8228E3FE4099AC582E96E411E2AA5F7B84D23EB916CCF0D4433EE803983B1F8CFED1E2D01C75E82FABF8ACA9E88AC172391F8AD52E7D0BB6801CDA1C116A6C08985E955F269B868856BE9457D33F47350151C0EBD1F9695EC4';
wwv_flow_api.g_varchar2_table(102) := '8C031C0A61C779120A57252937FD61082C5D2E17739922B8FDB05BA44C469E87BE569C08845C22C0B35D13F0060410A8A6D5C367A6F95C03ACCB81355F2C9729695C88D86E3A1CC4B62F7A73022ECB4FA3463BFCA9BCFC409454216002E124542EAE98E8';
wwv_flow_api.g_varchar2_table(103) := '15511E33205B00D228F4D463B2FAC26552380052768F3343E6481684C806CF8C22047CBEEB66F8074420F8BE63D2F6BD432A81883ACD407ACBC562115914036DAB4980D988099A0811C617E5DD98A600F4A201C1F8AEBC186F4F847AC5D012AB27885CAA';
wwv_flow_api.g_varchar2_table(104) := '001D372A7AF56FE072A8DBC98218483D0EAA8F83C22E72A2E624E2D836D39CD4916F77DC083FEBC2BA0CA2386C83E7F9B8EE7431AD09A8E502CDD371237608F80F3A44C0EAC4DF273DC2889222C5C4BF0484D16AB7D4F9E42EA0504966C7756E64F2C4E9';
wwv_flow_api.g_varchar2_table(105) := '240B6260EE23C47D5B253501E864B2BA6BA97280EFFDBEE31CB82F3856E01C5CE340F70F3C305CB7BAAA1B63F3658581D0D007A736F6E257DC91EB2A3019DF96E5DDF9F53DCEEFCAF2764C01501380A87297BCB5B4FF28EE00F2220F32A9823CA9BB5DB4';
wwv_flow_api.g_varchar2_table(106) := '8E1F3EFEEEF1F78F7EFEE5E8D5D35747C3D7A7D96B5F40561C60B7AB42BFFBE2C58E25D227BCD56AEDEFEFB55AAF8F8E8E9E56D7ABEA46A0778F1E3E78F0503F40B4BADBB21E34D0EC04A71737E5166E2EA693D15F2B02C01A0E3D04F474C148EE817F88';
wwv_flow_api.g_varchar2_table(107) := '390F1FB5992C80ABEBCBDF7395485A24F171BDA8ADF6D3F5DE7BEF0D125F798F8D4D3024C209D2329B02B23E2BBE321E8DCFFE6CE40C9BEBBDF7DEEFD2AEDF3C7B618B98A81DDA5FD0986CE7C79B19F3DEC3E0E491504AEBE631008B83C17477A3D9D0D4';
wwv_flow_api.g_varchar2_table(108) := '1E39FD84E6139EF7E2E73D6FF7F2E533DBDB17CE7DF0FCF9C71E3BAFF9FF6E03A73EF2A957BCE2D1F77FE4D157BCE26FB73756B175FA46B078E313020D477703C0C353E01BDFFEE1777FF3C75FFC6A9F5FFCF137FBCF3F0960D99E3F2ADF6D1A66320412';
wwv_flow_api.g_varchar2_table(109) := '90C6B2E085CA220110C860B0B3DB689634E85F4D53D737FD67DC7EC71AAF457AEA140DEFDE6AAEA2F1AC735659CC5CE43EFACE8AC2F84200A5C47EF88D1FFD649F1F7DE3878B84C0B7BEF3E378DE05C2CA22DA065DD22AB2284B2DDFC13202AC8B8F6FAE';
wwv_flow_api.g_varchar2_table(110) := 'E6F6DAAF40F4B63B9BAB053C7C61485B566B11FAADC39B81BB104039C1253F5C5245C537CBA4E88F45E58CC98C214097872364AAE036B6CB326477167A979E555B2D60EBEE8909685C2F73378BC2BF0B389D3A708CF6F7BFBB2225F6EDEA4069F16F2C92';
wwv_flow_api.g_varchar2_table(111) := 'A2BD500A1B5CEC65AA281C2143CF0A8B481516F463EE5D7A6AD32460DD8D926F7BD3467325B5EB2194D08B0313434A8B1F416788BEF7DDC361B12F208DB90B30F43F932476A15812C752CD192B66615F7276E974E32404106F7EB9E157D74B0108D0C1D1';
wwv_flow_api.g_varchar2_table(112) := '8AA647F778525417C588EF55B17F5C401A07E5EBECEED891BC9BA9C0C6D128E0228BC37E925A179F609A02771E5A7304BCF9B50F1230F211472BDA5E11C19415A69784C705B8220EC081E1F88B5931E031B71399E5F33C532A1D506194DD3045C0E69D75';
wwv_flow_api.g_varchar2_table(113) := '5F90F59526011B174200D4989A3EE863838500AA851905B8451454BD3371280A3F508AD9E13C4DC41EB35C3A130A6FD49B06016F5FB780D7359A0601DB01100E987AE01D70DA5F5F56448E4CFCA3024414EC7F8FE22852CF4B6554A8282B8A444501F8B2';
wwv_flow_api.g_varchar2_table(114) := 'B8F1F0EA3FE3DEFA05BC63D328801D64C43B6858040FAD01DF3409A086877D42C9DC50A6160B45C03CDBB6BC34EA5D9BC7E7364E2A024EDDDD300938E38EF6EB06D36BD73A7094A3091133DFD2DB6092E2326EE6D2032F9179A0612C087894BB9DF9EC7A';
wwv_flow_api.g_varchar2_table(115) := 'E3A4043C74C73805767B389EA2036589A405860E91B20BC4CCD7BEFBB51FC45091277C884271067621234937A968739CCF2E189F8637AD59C09BDF7EAFB99AFAEED4B69D1652BBA3EF232C20254BF0FEDF8F735FDFAA8FD248078195BE591C71AB176645';
wwv_flow_api.g_varchar2_table(116) := '2E02CF03D77647A33E9299D9B651C05BDFBCE64DE01F0D93801776EC55BD514704C03F8F7333FEE7CDD99CEECD633DDCBAF5CFD9C01981069364904A81C8789A8B344F8B244D394340A58C02EA6F79F39A4F03DE6212F0DCE79DB5801A8756753C9A090B';
wwv_flow_api.g_varchar2_table(117) := 'E4CA02002CB22E75D273B59C2F59013CCA2C17C1B23CC602E688446600B3B951408D04AC9337BFC11C016D70296556A68D86CBFA183C987C8E45E102202A011A374D800812C1AC2CB12D4A05D91A168641D7625C056C165C6F360C02FEB16E016FAA9966';
wwv_flow_api.g_varchar2_table(118) := 'DF0BCF4EC1C5FD6DA0355AEC88E51D3385804C50BA0DA352004A5E9E3208C9E382E58A6B0591522A524991281945919D45608C80C66BD72CE0D5F79A06F43510BB8B8877A89DAC043B1D93010644127A2AA4450F635E7E34F6AA26F198D9994CC324E11E';
wwv_flow_api.g_varchar2_table(119) := 'F6FBD482AB0F687B4E30E3AE5140B3FECA9312D0387DC982452AD4752A158E3FEA74F4015690D8341621531CABA71E61DA6245B75A3A45648D4299053C4B52A248F29414A192169A056CAD59C0EBCC11F0848B0328F1A7CBD56FD8411CAE16D095A58079';
wwv_flow_api.g_varchar2_table(120) := 'E89180FD2930EDDCA29630E449CAE8D1BB5C4522E05C88B9E0623EE75D379C71E89FA9370D6CBE66CD67C24601CDC6391B88E51248A0F1BA1858BEF56F1816A0E6344B30CBF5D84B0568E2288B659EAB384B7922551ADAA881A2009BB601767DD328E01D';
wwv_flow_api.g_varchar2_table(121) := 'EB15F01AB3808D6DD75D75891C979ED2F1188F0BC8AA392FFB695EF61BA4CA0670398D1073DB0B954C039E4499E079164922DB8362E60170F314D8586F46E4D403226073DB75A0A4D5860A6A202ACBA7EE580F88B024E0AE484163C7C0256B2F973F3B66';
wwv_flow_api.g_varchar2_table(122) := '24438603C4309245688714020E42899809043BDBAD1B05ACF9D2FCEF305F0FB47EC6C7A36510B87AB58D53A4067A9A017EFB604670E505AA3ADBE1FD684EDFE1C6611918058D459C7018F5BD44263973822413168003C12C217BF1991313F06A3A1334BD';
wwv_flow_api.g_varchar2_table(123) := '18181F3B159EEAB78CB7A73EBA9592D170D842AC3AC65814DA11688656D4B32286082824683CC95163894C6549D087507C3155B990B10D0E48E50235445DAE9DC41420DEF172A380DAE5C9C0F55BCBC5CFF6AFB6DBD31E0CDBBDC587D001ACA2C1911C79';
wwv_flow_api.g_varchar2_table(124) := 'E8DAED694BA5239960B92F701700C2AA1834853D11CDE68857C7812832A56CC4601694FB057F71EDA422E0DD4D23CF785E6700A3E14165AC7DD59F0202F8888B8FB61CA84095FB2CB2E0EA14B984601692A030B64023B408745AD872611E2BC71FBAAECD';
wwv_flow_api.g_varchar2_table(125) := '984D13A3DC3A31FEA25940FDCE7A05DC312F82B5178F0750D21FB7111C9BFA9BAA5C18E9006759341AEE31E4728822A3E6F36E96BB3CB6419328A44318257EC7BF46DD269E8A3C58802AEBD27136BC5C3F4101E608989000628814C250260786652B7D79';
wwv_flow_api.g_varchar2_table(126) := '6A805500E034132EC4B96B257B9D69C7B7A400A9C880A572BB54C06FDEEA942DF6604771B01410E7A59F59E7F1E60878FB7AF3E2771F2E2B929A5A4353AF37E858D7B5C946FD91B33B9A1EA18F931D1A343B57E92EFDA7F3F989FEB0BEA5F964322D70E2';
wwv_flow_api.g_varchar2_table(127) := '0ADC998C277666F79498E84F8D8AD4A7AFE84C5A7BDCDB2949B3BEFE5049CC68E4EAECF3EA8DAA1E4A6C6E6D6EDDBEBDA5D187DBEB16F03FA6E6C082A12006E3F8680FED222781F026A8F316F800BAC0DD0289ECF1CD739C873614FD1109C1BF324785C4';
wwv_flow_api.g_varchar2_table(128) := '96D97EAD6DC7F39453EC7137806DCEF7ECDD339D7115B8B7D6A13112A082AC95A9634496A833635CA1FFF89DFA46240138E93F8ADB96C869B23FEDDD01A603311804E03F90CC5C25F78AC4C23E9B658FF44ED800E89F0D50056829F31961187280207FAE';
wwv_flow_api.g_varchar2_table(129) := 'F77E6DE371B93146A37D5239B7F3D66AF594524B6DCDCF59038010E37F4C299B65DA0D398790301B406222DF3E62F3952D04903D0B8875B967DA8FDD87078935FEE677A274262222222222222222F24B9E9E201B4922F6F49A0000000049454E44AE4260';
wwv_flow_api.g_varchar2_table(130) := '82';
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784242514283151271)
,p_file_name=>'img/persona-female04-oracle.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/img_blockchain_jpg
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := 'FFD8FFE000104A46494600010100000100010000FFDB008400060606060706070808070A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA70106060606070607080807';
wwv_flow_api.g_varchar2_table(2) := '0A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA7FFC200110801A401A403012200021101031101FFC4001C0000030101010101010000000000000000000102030405';
wwv_flow_api.g_varchar2_table(3) := '060708FFDA0008010100000000D6AE6554D397337B4625243427AE98C84B4C066B12DD0207512AF3AB49E75B4E34E6400AD9E52AA00003548006A8D252BC5E80E2A96454C310DF4AC9159C9495C8D8396C1AD09579369DE577389AC4A622BA0C8579E6D8';
wwv_flow_api.g_varchar2_table(4) := '03A04C54333D1A64179D38AB31A2526A969A19B428100DD24AC6D4D4D354F32E6895A291CCCB4DE96408994D03A64AAA2945A02D4AD246864B79CAA966D732D250391969CAAD33D163BCBA404D8C5344513320CDA9CCC8F22E446AA034BCAC8B91B49AD1';
wwv_flow_api.g_varchar2_table(5) := '38A54A5930868D742090C9DCCB2DC05DCD1968931C8EE5C8C0619C34D5EC4C93591A42195217AE6D46932EA42E94A60A98B381B2B544C8677AE7985A96EEE451B28288AA652821D8D648291D12299B0ABE79180EED131ACC944EB628CF53176227E27E9B';
wwv_flow_api.g_varchar2_table(6) := 'B9C74A0991E37A2055393BAD1065BE52AC5D0DA332F056499FDC7CAC4F3FA53C6D28BCDEBBF336F68CF1D2C6879CAB0AB8A50B7E73B793A561F45F16BAB6CBD0297E6FF69D125BC8A624B4D400CE15B2A954C1D5C4FD0E25E27E5BD5E774FF004BF379DC';
wwv_flow_api.g_varchar2_table(7) := '5C1D5CFF002BF5BDFCF9576714D2723362A274CD2B4E829F4734E4F38F5FD2FC1BE674FD83B7A7BB878BF4BE7F8DF5FC2D2B1E8C465432B464AB898D931946DCEB7CF8F1FA4AF96FC4DFED1AF555F0FE87F64BA7F13E0F7787ABCC6CA863D1A33D625585';
wwv_flow_api.g_varchar2_table(8) := '31BBC387A3A33E3FACF07CCFC5B4F6FF0050E934C7A3F4DFA25F8E78F7D674E38E54915A88CF5CD4E92E9D973D3C1D19E37E9F97E6FE25D3C9EDFEBBB691AFDBFDB7E71F2DC5DFB799BE76EA19562236CD4E8277E8715F347369ABEAF77E8FF30FC2FF00';
wwv_flow_api.g_varchar2_table(9) := '53F6BF13FD83D7D157CB6DB7AE3DF7F9EEDD401D5A337A44962B059F2FA5966DEFF5FF004DF8FF00E29FB570FE43FB6D73FE51F77C3BF37DAC5D19E5AF673674CD62F39D73168E6C7D5E3F4FB7E6F339BFB5F57F9E397F45F1BE1FF4F3C7FCD7D3FA58E6';
wwv_flow_api.g_varchar2_table(10) := 'FB88A6F2E9E2EA8427A0F3AA84B4734CAE3EAEBE5C467D97A5F96727B1C9F96FEABBE9F9B767A1EEFCCFD8DAB79F3BE8409DBACEC84AAD31DF263DFEAF880FE87D6F96D7CCE0E6E8CFE7BE0BEEBB7EAFE4FBBDBAB32E0FA2F384055699A72C6CB877CBBC';
wwv_flow_api.g_varchar2_table(11) := '7A7E7663F4BDBF90E2F5B8FCFE4AFCC7CCFDCBE7BEB7CEF23E9AB4DB97CEF63070CB7624A29531A7EB781F4FE77167257E71D9EAFD1B6957E51F29FB47C87E837F25F615A2CF93AD882AADCC90D9686570FA1D7CBCA99F99F4EFE8FD4B08FCEBCFFB5FA0';
wwv_flow_api.g_varchar2_table(12) := 'CBCCF9CFB8EC7E6F57A3C9934156EA4896B4062D7939FBFBEFC7A3CDF0FE9BE33ECBDDE39F95F93E1FACFD178F1E8E5F573F0BEA7C7DB8C43BA6D284D6A930D0F2BD5E571EB707E71F767CB7DFF772707C0F079BFAC774FD3793E46DCBCD7D4201EA3694';
wwv_flow_api.g_varchar2_table(13) := '21D83168BC8F5D796EBE575FD0FE7BCBFA1ECF3F4F07BBE5BBBD1F5BABBFC3F43835F33D3612DE94A8328A354A81BCFAFDDF95E6E48EFCBC68FA0EAE49F8BF57D7E5F0F8FEA3B35EFEFCBE73D46083645AAC1336906AC99B8E5F37C3FB2F13DEE1EFCFA5';
wwv_flow_api.g_varchar2_table(14) := '7C87B1DFD7E878BF987E8FD5F4DE2F1E1B0D09EA9B57801A8865A896B8179BEA6074EFEE789CDF0FF4DF59F45F215E0F677012C10DEB2D86253D2185539CA5F1DF417E2FAEB5C787E27DEFA1D7653E3FAC1A409A4EB58B9166335439D19108B845787ECD';
wwv_flow_api.g_varchar2_table(15) := '24BC6F66B752B8FA02E1A7255699EB296636E86DB164268161B69991E6FAC6E94488B9409BAB4DE7054BB561553332C929494A6816E4C483A80116C6DCE4D8E86D944C0921BCDD29A03573122ABCDA41740EB3CC6AC2E93A4B263CDB14D9234B7144A1D1';
wwv_flow_api.g_varchar2_table(16) := '2D13A051A4644B2AA9B69E734AB301162083673290A84E695485B79C81556545295521148742252DC85221B54A5DC0EA9E209BD18E472AA491A75524096CE66531B96916952B3306DBD09469120F30A0A8A813D88528344A6A4B9632F2405D5C8E6A12A5';
wwv_flow_api.g_varchar2_table(17) := '030292106AE1481A4B9A8564D3A22536EC6C9664D824098082AE0905BE6120D52D050815D2A010939A42103134EE0919BE4DE68A09D4710C2A8A0CF448854024009B2A520ADB1BBE70A09B2E20195772674E1C88612C258DB424CDF134C84D03BACD2075';
wwv_flow_api.g_varchar2_table(18) := '569E6C4E53A87034C13542687AE1A5E2021553336875654A072D32490010DA01CBB2A731A00D033A4156C0242E269249C80C0684C651086E474CCD941772372A365950250C436D21CB342014D144B75FFFC4001A01010101010101010000000000000000';
wwv_flow_api.g_varchar2_table(19) := '0000010203040506FFDA0008010210000000F89280094002509412800000250004A8504A00022C288A0004525115504A942A0451448A1161DBB70E0BDB98114225CBA7D7F9131D661A08A1126B1DBF4DE3F892EF89692824975E4F6FD6CFCCBE99E373DD';
wwv_flow_api.g_varchar2_table(20) := '004CDD3C3E8F7F5F175EFAF0C99D80465ABE4F99F53D77DFCB93839F4004C5DBDFF47E370BF67E672E9C717445067375EB9DFE6FB3EBFC4F3D63A004A9967E878F58F663AF9FCF67408A962B1DF874CDD73E9CED0250959D73E89BCB3A0010A067528001';
wwv_flow_api.g_varchar2_table(21) := '14025000428000008500000094000001280000025000000940000004B280001FFFC4001A010100030101010000000000000000000000030405010206FFDA0008010310000000C800000000000000000000000000000000000EF000EB800E871DDBC30743';
wwv_flow_api.g_varchar2_table(22) := '8001EE7D5AD156ED8CE0001DECF25FF1461D0F5672A0F1C000F56EA69E74BE21F5636726BFA8BC8012CAABAACF47359D2F9EE5E820002DC11B627C2922D59E1C9E4966900163DD468EEE243EAF54AAAFDBD4000B75788EB5AF7DDDCCAD66A5B8A10024BD';
wwv_flow_api.g_varchar2_table(23) := '4FC45C8E7BBB7815F9EEF670005A8F472EE21B56395B95EDE60001A952E66F9DEC8AF7A3ABEFC000166B6AE536327CF6E5200003DF85BA8000000000000000000000000000000000000000000000000000000001FFC40040100001030106030604040503';
wwv_flow_api.g_varchar2_table(24) := '0207000000010002031104101221314120305105132232617140528191144262A1233372B1C115344324445053637392D1F0FFDA0008010100013F01BCA37EE82370BC5C798DB8F3765BF00282AACD67C27805E2F1F0079A38C5D5E21C8285FBDE78C6B7';
wwv_flow_api.g_varchar2_table(25) := '95B5E7982EDF84734A6DC7962F3C0791BDD446F1ADC11BF7E6142E3CB179E03C8DD1B8F01435479E78CF18BCADB9611E23A208F237E328734728E9C2384701E01C1BF19E2371E11C83C81A70854450478CF20F20F28DC39238CA08DC6F1ADC79079078C7';
wwv_flow_api.g_varchar2_table(26) := '01BBADFB708E11C07877B8FC01E78155872DB84708B8DC79B849D02731DD39278B7BCA28DFE15975FD97869BAC4DA66094695C85E384734349D9603E9F70B0F53F655A697D7AAC27DF8CE89FDAAE0EA88C603E52775679DB3C789BF5085EE63994AEE2A8';
wwv_flow_api.g_varchar2_table(27) := '2DD146E1C0345AAA01EEB1FE96FD957D1015392A700E1A70EF787B80A55546ED0AACF93F75567CBFBAAB7E4FDD178F902C5FA1A83FA35A139CE76A78A401ED2D269514FBA86C7136C90C348DCC6C6036ADAE7D7353D9218277B6114C641C23407D14B1F7';
wwv_flow_api.g_varchar2_table(28) := '6E0DAE7BA95AD6BC806B441492B657455C80C8A95CD73BC228D1905BA371E1661FCD55566C69F45467CFFB2C2DF9FF0065847CC106FEA6ACFE70B17EBFD938B4E833B87336E4398E6F985E2194B3106922E7C781C1A4F4523301D41077520C11778E7343';
wwv_flow_api.g_varchar2_table(29) := '46E4AEC9B48B442709C4C6BE80D15BBB49966B7CAC971636BAA0D32A6C9B6EB3CE6A266927E85324A11E02EA1FA2F1BCB9DFD82F29CFEE99239A0D342A10C74947296331BCB54C636B5A199E599F552F6ADA2194B6481B9743B28646CB13256F95C32BC7';
wwv_flow_api.g_varchar2_table(30) := '10B8FC3BA5718C34EC75BA8695A64A29258DB89A0D13DC4B8BB24F7CAF352057DD5AAD82CECC4E61CCF87D54F6896D0FC523ABD06C159ADF6CB2B4B609DCC07501492492BDCF91E5CE3A939AB2C4E92D5676961C2E91B991952A9F67B1C99B5C1BFD34A2';
wwv_flow_api.g_varchar2_table(31) := 'FC23986B1CE3EB927599C319EF232E1F96B9A6320C04F8B17A64155CD78AEFA14E7B9E6A7309F9B7D15BECD8E291CC66290868FB2B206C16216739D00CFD531ED0C70A78CE5F44F6398687542E87BBC44C9A01A754E3571376DF05B714B0960076298D2E';
wwv_flow_api.g_varchar2_table(32) := '7068DD107153D53D81AEF03D033612C1435F44277C7AE40EFA840D5D4E8A47C584358CFAEEA6ECE826B0BA29B5778B17CA7653F654D04323DD2034D29E89BA5DD9FF00ECA0FE951E589BF29B99316E658C77F50AAC3D354F24E4541D96E1183DE00E2DE9';
wwv_flow_api.g_varchar2_table(33) := '5A2FF43AFF00CFF608D96536A9218FC6E69A540A68AD1D9F6881B888AB7723655C05B4EB92CDC7A9298F88364AE6ED00A269739C006954A6BAF00E21CBDB89F3B8C780E954C7E1A39A9CEC6F713D552131EB478FDD4738631E00CCEE8F8853650640FF00';
wwv_flow_api.g_varchar2_table(34) := '515638B1CB88F9599AB55A3BC7501F08FDD5A0620C69DDC8B4B1EF61FCAE23ED75929F8583FA0267F3253EDC1379A2FEB5076AE4048DFA850CAD9630F69A851C11C6E95CD19BDD571440228464AD91F7524CDF91C5407F88D7BF5D40F4F456A746E7B5CD';
wwv_flow_api.g_varchar2_table(35) := '3AB73581E007528364E6B9D11949DC0E505BFC035E58EAB54CD717627021C7E8BC4C3571A8A66566E385A9D1BA334229759F367B92A4C56781B1D337E6E3FE2EB4E51E3F92AEFB20F7485CF71AB9C6A6EB1DB64B33BAB0EADFFE9453473303D86A380B43';
wwv_flow_api.g_varchar2_table(36) := 'A95D8DDD966B636FA38DFDAB9DA2D4999B1BEC15299E6BBE74873755191D80336AAEE2B0F78D3A7982818D7BFC47202A53F0E234D38C5C799434ADCD6179A0D535E58E0E0117BA6EED875AEBEEA7606F7836A15607B226173BCD87252485EEAA2ACA3BA7';
wwv_flow_api.g_varchar2_table(37) := 'C5BD1CAD52F78FA74375AFFDACFF00FB6EFECA2F2858652096C6E701AD0568BBCEA1592D6F8240E69F09F30EA98F6C8C6BDA7222A387B1E41FC58EBFA822AD1DAD6882D1231B85CD0452AA67BA4748E3ABAA544088DA0F451BDCC350BBA92D2E2EA54FD8';
wwv_flow_api.g_varchar2_table(38) := 'A91B24633CE9AD7542520785DE643D7946EAF2A095ACA870AB4EAB2D935E6370704577981CDCE854CE7189E69F74CF237D85F17F359EEA2B289AD6E07CBE62AD762B1B61243309D8852B7C2F6FA1099E50BB2A2C165C5BBCD54B04128FE2C6D70F50BC18';
wwv_flow_api.g_varchar2_table(39) := 'DFDDF9311C3ECAC2DC164841F96BF7E0AD14B317BEA0D29A26DBEDADC9B6997FF9274D495988D49399E08DE58EA852CA64C2699A872A9CF5345504B48379E33CDCF658ABF4D5632F391A37AF550B8435A019F552D25AE54AF44050017C7E767BA824EEAD';
wwv_flow_api.g_varchar2_table(40) := '4C71F2C830FB156DA7755246457684F1402490E83A6E5431991EC60FCC6898D0C635A3402815B09164B411FF0094EFECA08B1BE38C6E4040002836BA694C70BDC00AED5EA9F6EED08A6F14E716BE885B5B68819875FCE3D55405050BFE89E6B2D7F52378';
wwv_flow_api.g_varchar2_table(41) := '47CAAC309963C8E79A7B0D6A32704CF1D28333B27C4E8CF8A9F7E23CF8E36BBFE4015A2AD069EC55069E8A29191C35C22B5CD48E6B9D56B69E88DFA514117E2308DB22BB558F7C1E1D9D52BB75DFC3B3B7ABC9FB2EC886B23E423268A0F7377683B0D8AD';
wwv_flow_api.g_varchar2_table(42) := '07F453EEBB2A3C56A07E46D6FB5E22D6002A2ABB45A3C0EDEB4AAECE63831CF3A3B4FA2EE98D687C875D1A1617B003A6208EDEE8DED5AB5598BE0A295E2491CE029550485923CB767145C5C6A4FC34EDAC6E5061786E27D3252F75908FEE8349072E1B0C';
wwv_flow_api.g_varchar2_table(43) := 'EF647927CF23F577D976DF6549690C960D595AB3AD7A2B043DCD95808CCE67DCDD23FC0EA36B91C97675ABF0D33C4C0B718D7A28DE1ED041046C6ED149258A595CD95FE02E3F44C63226E063CB9BB12ACAC6C9278B402B4EAAD0CC71FA8B83839B51A5C1';
wwv_flow_api.g_varchar2_table(44) := '0474BA4760CFD144DC2CF5D4F19F8097CAE1E8541FCA6A6D0B80268A69DA5B819E5E1B21F0BBDD156AED3FC24AD6490BCB30D5D23479507592DADC704CD3EA3FCA92CF2B36A8EA2E9AC914E009580D3450C10C0CC2C6E10A4B546CD3C454D6874B93BCBD';
wwv_flow_api.g_varchar2_table(45) := '15A7063761D158ECC4D862949FCBA7A281D86667AE574CCC0F21589DFCC6FD6E082DAE778E7036684EB3964789EEA1E9C41142E3C011E43880E762F95450BE4384787D020CC2A287BC6F9C07744E696BA8782CD344C796BE468274A94EB440D1532B3EEA';
wwv_flow_api.g_varchar2_table(46) := '53DEBCBEB9151D9E28DD898C6B49DDA28BBD907E62AD1DFCAC204AD03E52DFF2BB893001DFB91B157FE5FD90B0B3F33DC54C656C8F639DA1A293CAAC4DC362B30FFD26A9006CDDD870C55F0AF756A8EACAF4566349FDDB70B98CC65ADEA9FE0342ACCE3D';
wwv_flow_api.g_varchar2_table(47) := 'E3DFFA9492BE43E2371E01C078022871473370E078F0AC9D30F46AB152A7AD55A29DF494EBC523CBED32B8F5A0414168C1E17797FB21E9C5DA8CC36C7FEA00A9744F9E3B3411E377E5007D908AD36C97BF1468C429F4588AC408CD348FC50635C31075C2';
wwv_flow_api.g_varchar2_table(48) := 'EEF4C6F6168A9AAD5C5C753A9504328EF0E134AEBC6380F10E33E1981D9C29F54247479B4D143244CA9736AED948E2E792754782505B3CA3F5951B9CEC80A95882827319FD28104547039C18D2E3A0533BBE90B9C13E38E87C21767C8668CB5F996D3558';
wwv_flow_api.g_varchar2_table(49) := '0AA1E8AD124B1B6AC84BCFF650D8AD0F944F23B09C55A6E99197380D1398E61A382C2EA62A65D5101D29AECD4D8EA406B73F44CEF5E4425F974F64F6163A87882DEF3C02E038E5663611BEC984C82A546E1504F5CD5A4B5CF696FCA9B2C4E6E091A3DE97';
wwv_flow_api.g_varchar2_table(50) := '50A031103AAEDA6430471C6C02AE79738EE6828BB363F1BDFD051491C6FF0033415E1A9C3A6CA36D2360F453D9F0B7BC6E9BFA286174AEA0FA952B431E5A0D68BB425A35B1F5CCDCF7557657F364FE95031AF796BBA292331BDCD3B2D724F864636AE14F';
wwv_flow_api.g_varchar2_table(51) := '440D082A6999246C14CC151CD858F6B8644279C32B4ECE1450491C50177E62563224C635AD54F2F7AFC54A65C416F7047887219E19E46FD536CF249E2665EBD54B8E1231B69ED9855073051CB30A0B4966E68AD96A89A7BC1953FBA9ED12DA64C4ED7401';
wwv_flow_api.g_varchar2_table(52) := '59A131C4C6019FF956AAB627EC68ACF1E2918D4F81CC655C73E89B696F70F6BB52D50DA0471BC53528B89249DD5B1D8AD0FF004C94713E69031BF53D11616CAE69FCA48560ECC9608DD24AE6B4B80F0F440969A84F90C8F24EAAC8C6B220F3E62AD32191';
wwv_flow_api.g_varchar2_table(53) := 'D419DC637600E2322887660394AC7B9B4A8F4C944EC4DAEFBF202DEF3C43845FFF0077F44D739BA1A2AD4E69F154D59E13D507B984364FA39125AE2D1BE8BB45DE28E2AFEA2AC3155C2470D34F750CCD8DAFCBC47FB2B61AC6ECF32ACA0B49706929A659';
wwv_flow_api.g_varchar2_table(54) := '1CD0F341F752D94C79E2C6DFFF006CB7A1FA5D6F6F66B5B260748E9BF6AAB23226C2DC1B8AD7AAB633BAB4F7A06A6BE950BFD62D247F100767ECA0ED08A5C88C27F65E6F2FDD095C5B4C46832A265A0322C2D19EE53E5603E2766A4B507C71C6C613468D';
wwv_flow_api.g_varchar2_table(55) := '725FC43D07B6680A28BC334ADE40BC7305F415AD33513585DE3346855B3BC3C06B681BD2E99B589DECA13518DDEC159AD765EF5F4B3F79239DE675080029281A48686806B41A27BDC294F338E4ADDFC1B3B9C33792003EEAC0F7F74E0F25AF0730E14CBA';
wwv_flow_api.g_varchar2_table(56) := 'A120D37466930E1F15139CDA78AA131D889F456E149E456291D1D9F0D33A9A7D5772F7C785C194E9AA3608E9469C27D4554B61B581910E1E85476C9ECBE7AE11B3BFC28ED9669DFF00C29467E61A145CE9490D3468D4A64623D064B092DAE12428248036';
wwv_flow_api.g_varchar2_table(57) := '8F8C13D54CE8891819443FDD3B93D79039609A1F5BA63489DECB1886CCE90E643495D8D8659E62F95AD711957FC2B43434E1EF1AE046C89787C78B3F550C8C89D88B2A469E8ADB5B5B985CF7B437400A86381B012E24BB468AE7EF744D6B9D42EA2B4597';
wwv_flow_api.g_varchar2_table(58) := 'B9FE2B4B4D3CDB64AD980485E7668564CECEC3F30A94D18721A223AA16DC2DA5029A116989FDE425CC3AE4AC10363B4DB06BDDE40FD54429136EFC508D9161E8A7746E7E260A575F7BB03438BB7E40E56DC937DA7F97F50BBA6BE20D3A16A93B36CCF756';
wwv_flow_api.g_varchar2_table(59) := '85A7F4E499086343439C7DF352C24B4FA28BC6CAAC0506D148C6FE1623BD2E7BF1308F456D76187BC353E201589FFF0049161351456120CF9FD109E279730E79D2854ECEEE57B360A29A668F0B97E18471C987F312E77525406B10E68BB7BB6E2DB9051B';
wwv_flow_api.g_varchar2_table(60) := 'ED2D263C9455EEDB514CB82CF93A46DE5EE200AE43444542787069A0AAB459AD369C2C61688F535EABB3E0920B388DFAE2298F735C1C3558553EB715653E76F06DC8087C5D9B37BCF09FF0ACBF9FE8A83A5E6E299135AE7386FC1B7FE07B14D6359E51C2';
wwv_flow_api.g_varchar2_table(61) := 'FAE177B2B283E2CB88F0EDC62E086A85C79C6FDD1F813C3B718BC6B79E71F8ADB8C5FBDE79C7926EDB95BF175E20AA8701E71E49E61E2EBF062E1C43836B8AD96DC908F3873C7052E170E21C908F387C11B8F19E58478C69C63E10F2CF18478F6B86BC23';
wwv_flow_api.g_varchar2_table(62) := '9B5E33C81F0434B87C30F86DB8C2DD05B7C6D5579BB71ECB7411D3E047C56C79075411E59E7EFF0003B710D6FE88F2B7F81A7C3EA8FC40E0DEE2B7F851703F067845E2E2B7BF7BC710E13C0DD51D780F11BCAFFFC4002710010002020202020203010003';
wwv_flow_api.g_varchar2_table(63) := '0000000001001121311041516120718191A1B1C1D1E1F0F1FFDA0008010100013F10EC862F8067810FF25C32E5EF8C962663B9B4674944A5869959E3BE1E095071830EF837CA7C0E0DC2061DC1F3D4BE259B62A5A83065397A821299DF06638264899E6C';
wwv_flow_api.g_varchar2_table(64) := 'EF8D33CF15CDF0652060E378186040CF3BF8572F10EDA8E600CC41CB13DF53B4D33081922F0988EA0C3C7984EA590A8CD9E0C6769D90DB73B4F1F120C25F1BF0224DBE3DCD870665CBC312922CCC436FAE0C5C67E383B0A971D4584EBE0B06789B316657';
wwv_flow_api.g_varchar2_table(65) := '5C1DC25115E4D33B95C5B3F53152D95B99A211DBCA997896F173A8170F70B04304C4DC1516CDB9145CBB8F31D04ECE1C92A751D46031BB25ADE2BC3B959276463BE3A8CDC2033CEEC353B22E5A9970F2B9E4D2B898AE06E19A8B91F70DCA5A6D641A8437';
wwv_flow_api.g_varchar2_table(66) := '3CCD93B9BE1DCEB877C02C1961DB3A8B31062129462561E0E0951C781C08C67508F15F064CD41B277089FDC51A13FC41204021C5C25B0EC8E9E2A13B8A6B33863D4254753FE47BF81B841A89C3B8B809E25EEE3BE020BE5B8CD5585C4844E4B07045C862';
wwv_flow_api.g_varchar2_table(67) := '2CCA8998B0D989A63AE7B8998087D7098184786D832CD4BE76E6862658E097921B60AB870E89B9535C1B44441F33CCEE9E0DC6D3066B5C9D9C1886E38AE06D8CAC4277162E6601C751BAE5CC77C75F020FF509796330023BE0EB975C6DE3B9931BCDB3B8';
wwv_flow_api.g_varchar2_table(68) := '3084DCD9838E6056109B23B9D613C44E3BE319E5DF056EA5715C7BE6A109A71E63D4E90EE75062570AC70709B8AD7144D10F1DE65EA385F51819E061DFC0C226632F2C6A546AE5E1E6B8E92BE3DC0C4BCCEE2608C36F2831AED9677FDA255899EE772B8D';
wwv_flow_api.g_varchar2_table(69) := 'A375C6E260E24199506267D4677C0E6771EE19BF85E6E0A080C5FE28CCD32E33CC2A32E33AF2704C9033B9B7E26934842ACB1977C09F798E96DFA8320B160A4AEEAE3DD07B6E66753619755E2099834CBC54D09DC62C61F72A698BC5DB2F3020F67E5D47';
wwv_flow_api.g_varchar2_table(70) := 'C9250D3FC99E257BEE2AB10B85CABA7AD90A2C11E4E038A9E22B2A5DC102DB0E4151AB194493289D33689C380D223E988A96F0691D4D92271514170A51CFA382143FB2D10E53F462050D5F0C698478A9644D1CD4AB8C623B787A219E06A04B68EBA976C7';
wwv_flow_api.g_varchar2_table(71) := 'BAAFEA7FEC53D99F1FECA59FFAFF00D81A7FA18803F40315BB9842AA31EB8A4E193BAA55CC55AA27CABE5337109520AFDA2A41AFD06F5117685F73620F61C4FB732C660C0638AB5FA8EA68436D788D72AED11E9A661443F65FDDC6DDA7D3FDA78BF3D906';
wwv_flow_api.g_varchar2_table(72) := 'EFF999646ABFBBFF0018F95FD1FF00750C2D3CB05FEA638DCDF1DF1A63BE0846105F06163C2434E22E082967B3D4ED840544ECCCEC8D5D589EEAE08514B0404DC60951EF2964642D0B8181051291706FAE4BFC0C15D5C9482AF731C13369A6088E8F6EBE';
wwv_flow_api.g_varchar2_table(73) := 'E0BA126C723055E09587231D48D163E4650422DE452A69C912D5D8CB5944A7FA78EB8186752B8EB908704AE5E7CC61065438F33BE331860A95AE971DB52DB9DEB2ABF712207BAC12BF8B550C472F7E0FF207BCA00ED1CB3F41F0116EDDD0ABD5E6394FB5';
wwv_flow_api.g_varchar2_table(74) := 'D987196081665BD554ADFB5923EA0D1ED7E084A6728CDDCEC11C0FF23E607AA8807193A600440ABEF1FE441D536DCC3281E4175FB83AB861E1B61FDAB47C298DE5320DD7037729C8583C9E2162816C09BE0753F1E63B84AB834309B633A25CEA5626D382';
wwv_flow_api.g_varchar2_table(75) := 'A3690F8B72FD5EB7FC652A5AA834E84A67CEA57110DA18FC0CBDE6C694367D308AB1290DB7E62B2304BF6CA96EAD9930BFAA50D96C7D443FB6BAA766FC9D45638142F7FED9BB3A0FA7270DA86A84501EE625BA82474446FBC46F97E1DD34662B607B5843';
wwv_flow_api.g_varchar2_table(76) := 'ADAA07CBC040A1A0DACFC915E605BC3B98BB457B560CA7484D7965E0EEACA832E7967AE353C70EFF003C187CCD3CBB99BAA9EB875364ECE0C4A872D433C052101BEF04B881A8E1816C87B991C27D93D0B1B747881C1A5B5F1E020A77745FAC42A8BC8F6F';
wwv_flow_api.g_varchar2_table(77) := '4465BC9FB400D831FA82F368FE55C10622198CE6A6795563F4426884450E98A930D56F3F240C4AA0EB52A42EEE2C4005148F6300BBAA1F436430EB09D0202096FAF9B835B472717F52F86FFC1CBC3A35A86F9581A97D266E35529994F81172C350E121C1';
wwv_flow_api.g_varchar2_table(78) := '4DDAD5C5BD90853EB602933B498A0AF75973D10A5A55D4D042820ABBF6C27A97768F49712C6AAE5F60B970204F2B9E284172FF00DBDA19F5FD8F84E9870623CF6B886BEE183C3E561F94FD128F432D04D0AF57771B2C4EB55F880639D9FB9856A99767B2';
wwv_flow_api.g_varchar2_table(79) := '52E9627A234E6ACD70E984A975313420E652E58CA97C5665C226587043418BABF72A557BA5D4360A5D5F4F98BAED3B5ED0976C7E8A8BC5A1E4DB1BBFA20B12FA843C927EF31D68836F8B2277FDE824B2C19A0B79A811A41F12E4887844BCD193D30CCA9D';
wwv_flow_api.g_varchar2_table(80) := 'C3A86B45A83E7A63A1855910391A2CB26C5E4FB6179494A6587A6A5840CABBFD112160B01469FE65CD2868EC4976FB1D72BC19E0AA83552B241304B13670EE3089960EE108AEA88DC5B2AC5B2B8EC717EE3BFB8965760FD4BD4B4CBB37005102770FF2A2';
wwv_flow_api.g_varchar2_table(81) := '3E8029DB7D4273A94EFDF9232EDBFC6A82BE8957A2FF001304A1E5992C7E66E84541DE588FB63FC8BE07112205AD016C0AE0B569FB81519AABB2A6F9FB76F6C65C30CBED0B42029576474628161605C4906ECC7ACF061E04EF83519DF0A8EE1AE158F0B9';
wwv_flow_api.g_varchar2_table(82) := '84088C088334BECE988653E5E95D33069D5DBEAF44613BB6CFED950A4E35842BAD159952B31D37A42D0437C1AB84540CD7E1C43E8C40773004DAF80F57DC1AE85F4054DAC1443006F19EE022C003E8E1BF094550AC17107554B163E08ECA987A3C3EA242';
wwv_flow_api.g_varchar2_table(83) := 'D88B65EC460BF4A7F3065E022DC549F4B1200511EDB9685ED77D532E4B380ED7E21E1DDE8B44BEE54A8370753483183B9573A9DB3BE0DC61A868E080AABE86E65532E3FE188013052A564A6A10B4624A97A6AFD4C984EE5E4364119C0AA755987D17517A';
wwv_flow_api.g_varchar2_table(84) := '87FF00CA8AFF00677E8C60F5094EDFECA97EE93F3704C705C16140BC9A814CC92F409D2614F3E532448B76CF2B3139AC18A3C40AD774A9DAF82A68C4107B2A0944519944029EEA1485D2BEACAC44E85A8CC5460C32CB9862D93B87D470F06E1A86E6D950';
wwv_flow_api.g_varchar2_table(85) := 'C40C4371966EC2FF00503806AAD5E7C12B00B5B4DDC48121B6A3B610EA301E296D8C4AD03C6043986FF60ED289862DD9050DB2ACA7122C5AD53080A0062587BF516182C1B185CB2CAD01958630694BFA224A9A2D9CBA7EA6E469216A8769354F846167B4';
wwv_flow_api.g_varchar2_table(86) := '618C530189A4A8355B5D1E6A200ED7F630B8C4C4230D9C0DB2B112986A7709598C37084AE3BE17DC67E899BDF4FF007154A2E5F04278C5144EE10DCEE5C5E20590ED0DB8195164F6BA2DFE9B25EAFE5D01750172AECA27D24046B6EBDBF72C85E935FB96';
wwv_flow_api.g_varchar2_table(87) := '95FA75F9F33430F4D5CBD4344AF46AE5DBA6BFCCCD13C2CB67D3302BA41F9E4311E0068BB4FDB2A710B096E7CF885971F75CB3626DC11A20999D71B4300B998687938E9A57F36EA0AC2AC757DB1B017E9CC166A3B91F1D27E7960A04B005D7DC6E307AB2';
wwv_flow_api.g_varchar2_table(88) := '820AD9F5D44DB6404FE486B7E6CC4ECA641FC01812701D11325317CFC050469D6E830622050910C587D970C908D1696F242E8C2EB330732EFF00131DE63F59E3067510FC2AA515F378F2FD10220BAB4E752C902607C2AA4764D6B8E8470CEAE1BE1B9306';
wwv_flow_api.g_varchar2_table(89) := '5359978A9D704BBBF4DD648F42E73ED6A59E9257D19A76C79764741DFD00D13206256C7A4210558F64AF89B8D7EC4A9D3101A818CAA45431159D19E3CD43BE98D60C38607A6F2F465FE215D33687703A3281D51B58DE78970B319D8192570EB109708B32';
wwv_flow_api.g_varchar2_table(90) := 'AD1EA5E40F12A6F1DF06C8771DCADC59D71DC38A3D857D36969E2AFEE18E5DB183DE604B4BAF1EA6DBE3A8EEE2AB67F64407D1746753C987C3008DB6C9E3D901258963EA3CB5B40ACA4E55C0E68E89D9BAC625272E8E4D31E8A8D5B42AACD635F685716F';
wwv_flow_api.g_varchar2_table(91) := 'ADC17D2CD5B06B07FBF6328CDEBE170F8D8747DB06F55A36976A010A77D31181D241CC5B31F0DC8F4825C113850E6750E0BC0999E2678372A541819FB12F702603C35B6208D61F66E2F4366EBC8D43A1628391ECA838DCB4D3FA8C2ED07EE0CF7751C865';
wwv_flow_api.g_varchar2_table(92) := 'DD1A9F6CA4D66DDFEE2A729772DD466761B94F971076BCFD44EE005A6822DB14CBDE2508E5FE02585ACB15E604F0D7FB9AF45D3D8DEC992A5C050055701986CD6684E6201B1B823431CF8AC90EEC79F9967F62FBEA30AAD9EE885E546A8003A89EF8578D';
wwv_flow_api.g_varchar2_table(93) := 'F1BFC0C18A951D30870AE33CC610DC1D32A62381C265016AC814E91948BDE5083EC8168279207B19C9E60A5A32C4632350B68ABB62BDB0196542CC640EED6D515E883338ABC46ACBCDB091448774FB8FC3243C2CBA3536FA40999A55B17C040FC43CFDF4';
wwv_flow_api.g_varchar2_table(94) := '0F2CD92A9F86A3DB5056A0CE61D5A6A0DE1435D81507A1B5BEC3C1035F56F05CC8A2666D524194B009D972E87760C9495EBD3EDC8717C9A8F0353E9D4345B1D4D434C350638D4ACBC86B85CBF0FE25A2F02652AC1A4A36707E8DCAE8A7469FB8215AACF4';
wwv_flow_api.g_varchar2_table(95) := '5EEFD12B05A8B5ED710F142AF713731008AFB6AF1DEE35C0C0980EF7008B357772FF004428771ABAAA7C3029FB4F30068B0B76C0CB02D8FEC12AA23D689765EE5489ACD97DAB8D52F66FFE0880EAF179FDA0A0464D2C10FD4B15B5E486F2CAF93C4508D9';
wwv_flow_api.g_varchar2_table(96) := 'FB66735270DFE770CD6FEF21AED7B5CB17855B393367352E7FA8D5BC69C0093AE3A830E2EFE471C7DAB30BD20B7DFA80EAB58A7ADC4A008477AB1F88EDB10F7D78949B7CA305157744667800A19E88491A03C10168DA0B6A25319CA96A9862321F43BFA8';
wwv_flow_api.g_varchar2_table(97) := 'B5911AC45207BD1C3E6E571AB3B34DF64FB1D3FB2014EED6D042311E62D7E6FCC4557AD8734AEAAFE1A89D79E270416B97A5BF434C5E9881B7EA21772738C91AE798A525084762EE2655EEB4FD0CA60F19FD7C1AE1843CD772F301983198F11E0D703509';
wwv_flow_api.g_varchar2_table(98) := '5878EA1771998C5DC308B401F7DC67E8AFDE20B0AB08C370745DB6D63B1B33FA319950C115D6EB6F6F25F713B856AF2F6B101BB55857685D67705B8BA7DC5A84A14CACF630658703DCA2E169F918EBB1A3C3E228609F64414C844841C8C4FA7AA8F3353C';
wwv_flow_api.g_varchar2_table(99) := 'C92547B2FF0073A8F4A2B07412D628B1AA856881A99EF3F0EA30E2D28B677F88688F708F15027871E633A86F8AA8F01A971E6401C89C4F2435EC101221DBB7EE390E45D4B158B30FDCB31642D21EA981BF36C5ACB1B268D3315692E7DA399628A5C6BCBA';
wwv_flow_api.g_varchar2_table(100) := 'FB210DDAC2366017D06080DA63E9C928CD4381C84C762A0EC6559F59B21CA60E37C03C84261316CDFE11D7018F070691BE6F33C71F729C32709C0AD98250288A53EA771D93EE3F49FE353A9988FB0D0848459B5582EA3E786DC3D227255CA6CA58C8D070';
wwv_flow_api.g_varchar2_table(101) := 'C13FF995DAAAA167EE0B13C916FC193E18A2C40F83C1B9B4ED71AB99BE0E88C619E33789A2A564E0330A9A9BEB863135F070936C5ACC1ED4BFDBC54EB8D1FB4DC25E20F1A14380E41FDF0441B0DDF0C25FF28E5F875C0E61D33A605ACDB1311D10FC4AE0';
wwv_flow_api.g_varchar2_table(102) := 'ACF179979F857045DCC463B08F3DC4107494C3D28B979965728542A3AAFA821A8304D42A5C5263F9F8121C182718E466380E1B222295160E439EFF0033BE7BE2BE04CC711661C3C3B254A8EB827DF06F87966F9EA116DCA86E3F0B0596BF0935E7A38F10';
wwv_flow_api.g_varchar2_table(103) := 'EA1BA8771330632FBF87B9DC75F98319EE5476718A9D70399D7244BA9D31D9C5D725C3BE6B8B9B4701F70D0C38B7F0DD71E21D30CB08C36C25F0E827995986D89C789D4260F15C2A76CC512E7643518764631CDE086BF3315C2DAA9DBC823870371EB8D0';
wwv_flow_api.g_varchar2_table(104) := '98E3F1C5C20427FD87D7C15B09D90BCC1E7A86A6502F875332A3AE48F52F3368F0F04BCC1CBC652E5E08350BCB2BD772F372B1C698F1F70E013B308B53A20E262F80E21DC1A988393701DC08F2C78A53C08EF8EA11846B318D51312F118CA8EE10A8CDD4';
wwv_flow_api.g_varchar2_table(105) := '7E152A108107F73CC67B852336E346788C23031349E278E3FEF17C572751DDFC41A62659958FC34E02514CCB3AC78846F92353AC4CC3A6155C33A425219B667CCEA33A8702154C18B58B9DCE9E1E094AE26276C7E14DFCC52FEFE0D57038EA5813293A9A';
wwv_flow_api.g_varchar2_table(106) := 'B2319BE71502AAD9D30CF1DC5BBF1CFAE1D45CBC77372E1A6789B4B877C2F3AC7755349C3DC23082C77325102F3C75C6FC85F0E3E570669171030461B6307CC5716751CD7DCE986C94119A71798BC1C3C8E20E22E63BE062700972C45B3AB9DF2706A5C1';
wwv_flow_api.g_varchar2_table(107) := '2C962CEE273DCCC66E3AE1D7072D4ACC4CCA9D12E6C81A8992E230F85D71583E26D1DC5CF3F7C6A437872C736F72F9359E3A9DB02821BE3F1C75F03C478753A82B4F3DBF52B447828F015E1E3A86C9DCBC724764218EF8B9D7009EC4B9ACDDCDC386770C';
wwv_flow_api.g_varchar2_table(108) := '9F51DCEF8AE74726A8988C21084EDFA8EC8B1AB956B026A5662D706A77CD12E118419DBF01B423599822605FB8DAA86E6382A5F0C224180BF82CA84744303C12E77C0798C56B809D4F1F70997E1D7C09DC368B97875C75C43B63B595896570B8E3AF81C3';
wwv_flow_api.g_varchar2_table(109) := '1F99DF38EF823D704D5C610D4EAFDC37348950D93CC7FD9DCC71D73D108C2013AF855C25D37050CA7F32AC195AE585C78C4787AFA97CD4AE5E59A32A5432420EF83A4F27159E2B33D43938CF05F071731C611DB2A3317E29D4AE0233A953CF04783875C3';
wwv_flow_api.g_varchar2_table(110) := 'A86A6D51DC353378D563A4675FA86DC3DC53B8F1E23C289D73871D9C6794C1478EF977C19391D426D3FFC4002E1100020201020405030403010000000000010200110321310410124113202230510540711432608123425061FFDA0008010201013F00FF';
wwv_flow_api.g_varchar2_table(111) := '00823EDCFF00191F71A793AD1AC015C89F357B67C8219730E16C9AF68BC200EC49F4D4CE8B8C8009D44B1F32F931438D481ADCBFB0EDC8C07D3731E57C6BA1EF04CB7E27F66508C3481560484D1A82FE60F7F6343E27683FD5748AA19941D8994AA3B09C';
wwv_flow_api.g_varchar2_table(112) := '5708B94174D1A104120CD22EF0902A1FDF0E92FDEB276801EABE4CDD3C6E307628408BD472A8027D43256354EE67D3C909918B1A11DBA9D9BE4CC788E4BA2260C5D3AB6F195726422BF68E66BA87E0C07DC707A4CD081CF8C08AD8723DD2B6B5382FAA70';
wwv_flow_api.g_varchar2_table(113) := 'CDC6206B55BD18CE2B2F8999883A6C260C8470F9500D4F2C2486B00E93265B1E8B9858143F30F2A04DCDD80F8F71B68BB010572E3919F8660A093A4E0784F11C9CB8DBA2BF1AC5C39B09AC793A93E1A2B115D8CDCD9330E2E8D6FB44607C5535B9981FA5';
wwv_flow_api.g_varchar2_table(114) := 'EBE6671593F239588966CFC9F68F261B4EF7072E06BADA3A63C8A54899F03626FF00CEDC802481131108A09D6A3FF8DD948D6E01A8995BA88DB6E43524C5D057B661162A29F4C0419667098D9B207BA51326439388F49EF4271EF5D097DA0268CE0D3AB2';
wwv_flow_api.g_varchar2_table(115) := '8BEC2E752F5117A8138A757CCC54C2684175AF21B912B6F21F39E4AB40CD1B71350C16E3E538F08C614835BC4661901502C1EF3296672589B9B09C100F90FA88A13F5031F10FBB0BD60FD3E5D9425F72666C0D8B5BB12C9BA1FDCA23B98DBA7E7DB1E515';
wwv_flow_api.g_varchar2_table(116) := 'E2EBD847218DD98BA3153DE76A8359881F1952E839D4CC8A03356C0C147713AC8C5916F7112BA47E2015281F687982FAAF93FEF4E7D6532E322BBC66EA249EFCF182AB5E63EF50BE656D837C7D89FE79F3FC67FFC4003211000201030302040503030500';
wwv_flow_api.g_varchar2_table(117) := '0000000001020300041112213110410513306122517181912332401470A120334262C1FFDA0008010301013F00FED2ED5B57DFA6DD40CB0157D611436CB2291DBA6FFEAC7AF838E823638231F9C52DAB923247E735318E4B58A23AB29DF351D8864764D2';
wwv_flow_api.g_varchar2_table(118) := 'C411804E2BFA3BBD457C9C8C6E0115E483AC29F880FDA7635041AE68D18F277ABFB64819428E7F8386C6683321A42198092318F9F14D017BA10A7CF14D342D711C1128D080827E78159148731DD0276C061F5CE2A39A58CE51CA9AB2BA6695564557E486';
wwv_flow_api.g_varchar2_table(119) := '3C8C6F518B767D49B1E48CD5D2ACE106002A3635E4EA8DA4638D2483F326B547D90FDCD649F595CA9C8A621E013151A81D3C6C681C91934D245A6EE7573A99B4A7D0D452346E1979AC9F9D32E7A2B329054906AD1B130F714A85B38C6C3269981B6720EF';
wwv_flow_api.g_varchar2_table(120) := 'E6E40EFB8A0C8D8D7F634F09088CA430248C8A65D27D458F56E38EF4D0AC3FEEE7511FB47FE9A7950DAAA0183E613F6C74B68D5EC9B233A6504FD3157904420475C06D58229CEC293835DEA3B77742C38AB7874E59B9A20A5BBFFDC607D3AC274D94E48D';
wwv_flow_api.g_varchar2_table(121) := '8BA0A9154C6AE99C0D88EE0FA962C16EA2CF0580A983091D5B390C73D7C259899E1001D69C1ABBF0C9B6954E481BAD3726910B2363A59CB981E32A3E11907E74C9A535B92171C77349319509FF00144609C8E825711347FF0012413F51410476AEE787C0';
wwv_flow_api.g_varchar2_table(122) := '5FB727D4B51FAA1B19D3BE2AE0C6F34AFA865989C75F0B9025E2124004115E217EB02AF96CA589A9AE6CE7C978591FBB2D186150ACB7037F6DC52A59839798BFB6314CF1E802340052CCD2F98AE7B55BBE8931D8D5CAE253EE3A282C7001AF10CA491C3D';
wwv_flow_api.g_varchar2_table(123) := 'A3451F73B9F52D06F2E09D5E59D35A4E3576CF5973A6816539A470C3A004900525BB045048CE9A2C6DD9D748D5DCFB5282CC00C55D152CB8607037E8EB1C6918C90C5416DB9CEF53CCD34ACED8C9038F6F52291A2911D4EEA7357AA826D3B2A32874F6C8';
wwv_flow_api.g_varchar2_table(124) := 'A7B79115588CA9EE37A2B8008E2A5C8519EE28001371DAA11C9AC1C558461E7048FDA335AD7515CEE06F578EAF3B1539144118CF44546C02C054F107B58A50C095F81B1FE0FAD7570B37938523444AA7ED50CEF09254FDBB52AC525B3DC680083A590705';
wwv_flow_api.g_varchar2_table(125) := 'BB1151832CC436FA8E292D22C2199C8573850BC9A9515091144A40FA92295647382323DBB55AC0C97050B3020676A4B77824692570A18E06A3C8A68FC39F235E0D35B64F97B639561BD7F4B0C43F59CEBC644639FB9A696303E0840F73B9AB22648EF036';
wwv_flow_api.g_varchar2_table(126) := '71E493F83FC053A3C314F669F7FA0152BC45C3A647B718ABAC4F690CCA7F6128C06DCEE0D6B6C019E2B39AF0D20A35C3B6F10D3F9E2A795DA5972C4E58F4B0934DC460B63E35ABD0C2EE7D5CEB3D15DD43696232307DC7F00DC936AB069180FA81E96433';
wwv_flow_api.g_varchar2_table(127) := '637F9E02AFE73D6CC91E1D7A476294CDA893D01C107E557F3453DCB491F0C067EBFC40EE14A06214F23B1EB1DD18ED668028FD4232DF4FEED0F53FFFD9';
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784242863138151272)
,p_file_name=>'img/blockchain.jpg'
,p_mime_type=>'image/jpeg'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/img_collaboration_jpg
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := 'FFD8FFE000104A46494600010100000100010000FFDB008400060606060706070808070A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA70106060606070607080807';
wwv_flow_api.g_varchar2_table(2) := '0A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA7FFC200110801A401A403012200021101031101FFC4001C0000020203010100000000000000000000000102030405';
wwv_flow_api.g_varchar2_table(3) := '060708FFDA0008010100000000F52731A516310114DB4A24869304D12528A91260222A60310E24A09D8463162698C10260C9406991001B638B1A626869C52400036C4D45881A0018363402001036C050180D0D89201A1A1124393490200006326D6A745D';
wwv_flow_api.g_varchar2_table(4) := '888064188060201C893A5C88881C924C1A1BC6F93713EC263680040D91001A02400089308827103CEFE6DF5AF7C0001800312000018D08000686803E79F34FA87B261280090048698849A560104C001C80882F0ECFF639B1B8B5188021B138B013400031';
wwv_flow_api.g_varchar2_table(5) := '0003035BE69EBAC634C101168921916D8106D27208A002201E3DEAD9A388DB22DC5C91318D2486C82620930441880C1F29F63060C148130536E119349037ACCF60C0042041E11DEF7821CD3126204034862631F27D54A51716804C114F9159B9F47008B0';
wwv_flow_api.g_varchar2_table(6) := '600080063904CA59175CC249B20C1F9577FB4F9CA5EE7BA01A1032200C252139249223C776034C9272655E41ECA607CE5A7F7EEC5A0431A420009C98495603102188912F30D9E1FA1BD6FCDD67D3CD2006206036464D34481311190D2610F9D3979BFA33';
wwv_flow_api.g_varchar2_table(7) := 'A9F96F2BE9948888351E79B8F4342934D0C0538A40306D0DBF37D8FCED5CF67EABE29D47D30800178179E9F4EF488001390AC889B80D00C11E27ED7F26E023BCE07BEFA18014A27CFBC04FD67D9E20340E4049204C1038B5C0EC7ADE63CE3CC71B77AAF4';
wwv_flow_api.g_varchar2_table(8) := '9F76104A4A3E4DE311EDBE8B1880098293124C8B1CA21E23EDA83E65E6ADEEFA8F59693132BF32F2AD6FD0BD9302279CF96FD276A2F0444411B26D7150EE16379B7946AB1FA5F7FDD924D001F3E728BD6FD3EF25C1F8373BBEFACEC23611949009037E29';
wwv_flow_api.g_varchar2_table(9) := 'ED655F38725D373D5749F406E410A42C2F9EE1EAD256775CAF9FF35E79E8DEE5B919709003289CCE5757DF2F34F0B977785C7749F406E460C1786F984BDEAE97174F6BDFC357BB4291600D0C38DE3775B0F3CF6FCB8FCBFACCEF65E77CA3A6F7ADCC4090';
wwv_flow_api.g_varchar2_table(10) := '637CA78FB9F680E2AFF690249039881025C5F132D5EABA5CAC4F29C8FA0E30F0EDBFD05B50408F35F0897B17408E2F8AFA9E4D8213930004B87E2ACE0F32191A5C2E8BA8ED962BEBF62001CD781683B6F4E88FCEF85FAAB6898004C05104F9CF17D8F0B7';
wwv_flow_api.g_varchar2_table(11) := '5189566EEB2FD606703B9DDED77195E7BCFD9E55B4FA0759365B9BD4A189265C24C4330FC5385CEC7B73F373F1759EA3942F1152C8AF5BD36FF9BE43E89DCE888CBB0CD01887286400000790F996CB771D36CF7EEBE8B2962F8E6BAAC8D8470F0A5B7DF7';
wwv_flow_api.g_varchar2_table(12) := '55D14E075B9E0860376000803C421A4C3CBD966DB237F9BAAE1B4BBEB21814604367D1E5EDF6EA31E3A3D0F4B9F95B06252B400077697CCF3355ACD733232A5AED7646F313031AABAAAB2BB79AD967A4BCFB9BE8B349DD9F9997D46F26811B3BA7AEE5BB';
wwv_flow_api.g_varchar2_table(13) := '15E49A2A753CED98C6C76522F90EDB2C529449C93AE4308B859DF7560EDDBED71F0E5F3BF2FF0047ED972DE6BE378B99DCCA744A71AA7916CE58365B38CED5718994519527753DEF565991B3A2996562F8CF49EA18F5657CF5C9F5739E0E2D78CA7919D2';
wwv_flow_api.g_varchar2_table(14) := 'CABEED5A2B860DF9B8519C613BAC864D7E87D56FA7660D19D938185E13EC5DAAAF5DAFDED94AD6E9ACD3ECEEC3C6D56C6D8ECF4B3D2D16720A36C2BB2128C252F47EA76B4E3E4555DF3B204A8279B053A9C29CCC7E575FCFEBB3BA9AF47812CBC3BE7A6C';
wwv_flow_api.g_varchar2_table(15) := '39938BAD5564BD377BB2924F6387194A14DA2A6FBE9C7B1A9D9ACAEFCF96AB94356A8DE656AABAB4FAC134D3AFD6B37AAAD6BAEAA64656576AB2EBF1A1AFB73EFC485DB39E2C70AD91A9C0D76BAAC4C6D86069B549D95F470F4CCDB6FBEFAA56E1D36E3B';
wwv_flow_api.g_varchar2_table(16) := '95F292C1A7232AEC79DF3D6C0AE363CB9DF8D91561D1AEC5AEAB30365ACE3BB9EBB2B1B1CCBBAAC79DADD989767D58418B690B68C695F44F2251C7CE59BAF9D816531CCCBE77447451BF3E0574C32F069B276E44F14702589916E32D83AEDC786641D2F1';
wwv_flow_api.g_varchar2_table(17) := 'B26382ACB679355738D76535D33C39E56CE1870BEF72D76149E366C3611864D34D9032AED54E9C5C9D8E4E3E15D936DB450B324D6159A9951694DB955E2C20A49005D9F75D56D2A955873CA31B1E6EA9DD546328BCFA6247647269A004201302DBE98EC6';
wwv_flow_api.g_varchar2_table(18) := 'DAF2A2A7759452A72B2783954D16DF8102175F74344C4021893959B58B91766E1E2D73AA596D5B1C5C49DE46BB32CA0739C608D2031590BB679E54ABC98D90A29BD9B235CA10849D59EA3763D46D6BAA355962B29A2BD367C60675555E57667C68C59C27';
wwv_flow_api.g_varchar2_table(19) := '913AA18D15B054B85B94F0E374B155F52CEB6AC6AA70CA959AB9D79545D4A6D64537D0139E395C82C8543A6DBEBBE8C59D4139AA565597114F3EA429CA32B94A11B2CC78537E46366C28BEAB6AB1431ADA61814916002000E8325E163DD74ACA50B14C8A';
wwv_flow_api.g_varchar2_table(20) := '2CC9818797552A34D8DDF99657ADB561508B952C400E6C367BAC4BB9BEBB57B6CCE672F69CE62E6F45C86F306CE82A4F968676E26B1D185B1D1ADCE1EFF0341A96007FFFC4001A010101000301010000000000000000000000010203040506FFDA000801';
wwv_flow_api.g_varchar2_table(21) := '0210000000EE8142A291605800508A16096C04D6DA161512CA02F0F4EC9400152C0D3B51688B02C29756C2020A02873EEC902824AA21AF2E7D9B8A090501399D1C7DCA98E68000D7AB4E73B86AE4EDCC245035ECE6E5C7D5A938F774131CD88A9859E5EF';
wwv_flow_api.g_varchar2_table(22) := 'F3BE8C38F837FA5AB9FAB65C153872DDBF8FC5DF87D18D1CBE76CF6374A417C0D18F475FCD68F67EA47171736DF57A0215E26BCF3E0F2BCBF4BDBEDE9CF1E2E7EBF5ECA601C9E1E18F272F27BBDD72CB59BBBB7EDC88638EAF2F8B2CAB5436ECC66382EC';
wwv_flow_api.g_varchar2_table(23) := 'EDF618E0D576F165E6730CAE2942F67BBAD94C551AB561CFA36638E3AF058EFF006F552C2652598EAD1861AB5E1AD7D4F4B082B1CAC29218EBC35E8F4B358B266916264958AC5D81562638CB2D8518B7098989145964A959C58C69565635508636C94132';
wwv_flow_api.g_varchar2_table(24) := '22E590588C25D71B70CDAAEDD533B66BCB78FFC4001B01000203010101000000000000000000000001020304050607FFDA0008010310000000E3B10269086086D3010DA010C5106322009B1890D0C9DCB3B10869126204C012EB60A9A0449080928B0248';
wwv_flow_api.g_varchar2_table(25) := '3566901140C4C0149C508BE9060353048100080D9962C004031B4A23249DF5ECA3388040E63220801F5EFE2EFE5A4A5A728C18A510065D7F62AC5CA035FA1F3B906A4D893405F46DE855C74DBEA67C0129D4589A14AD84BAF4E9F3A03D8A9868D9CFA4B5';
wwv_flow_api.g_varchar2_table(26) := '01E829C18FA5D4AA3E79334EDE658F3B41340BE85B67CCE176EAE4F9A03A7464BAEC6C44C48F733CF477E5934C787CACB3E70E2843B403ADEF3466E74196575E6ABCF64D7BB065AD390593BFD8772AA6996E49F1F9915BFBE2CFC3F16E76BBD51DACDEB3';
wwv_flow_api.g_varchar2_table(27) := 'AB2231858C0125C6F017A8CE4219B355DD2DD9EDB2CD568A4B81E1B4C440C941B4ECD9BB45DB2ED3A543CB797B64D209C232124DCC2CBEFD1D1F31438C88C9D4390A40A16454C0152869202739C949418901379504E69CC24441A13921C556DA6E510126';
wwv_flow_api.g_varchar2_table(28) := '89A516C18E6A3269099280371AE0024C93B88DD64699C23A0CDA1D641DB1C6C5FFC400341000010302040406010402020301000000010002030411051213211022314106142030324223152433404351255052617116FFDA0008010100010801F4EDECDB';
wwv_flow_api.g_varchar2_table(29) := 'FE82FC6FC6EAFC6EAFEC13EBB2B7B1B2D96DEEEFEDDFD8B2B2B2B04786DC2EAEAEAFFF0057BFF46CACADE9BFBFBF1B70B95BADD6FF00D1B2B2ABADA4A36679E9F1EC2EA24D36EDEABA3ECDBD8BABAB8571ED59595BD56E375752CCC8A27C8FC42BE4ADA9';
wwv_flow_api.g_varchar2_table(30) := '7CCFA480D4D543080034003FB965656F4DD5D5F85D5D5FD8F135568E1C581784E933D4CB527FEB2C7D5E29A8D5AF6C2B2AC0697CB61908365656565656FF00ADC7832B717A5A4899E120D9DA4FF4EFFDBB957E35752CA5A69677F86A9DF23EA310995FFA';
wwv_flow_api.g_varchar2_table(31) := '3B71B1FE8596DEEF88AA1F53554D86C34F0474F0470B15BDABABF10B7560ADFD3B70B2B70BF0BABADB8D954CECA782499FE1CA77D4545462537B67FA5BF1A9AA8A9999E4073341F5596FC765B7AFC453D4C95FE51B80D6534948C819E9BFAEDEC6FEE56E';
wwv_flow_api.g_varchar2_table(32) := '1CC96A619F8D87BF2CAC8627C8FC02175657D4E252E3F412412B6BE9B0BC7A2A80D8EA2CACACACACACADEDDBD8B2B2B7B1985C8F6EE56EAEBC4B5AFC9150C5414ADA4A48A00E6B5ED2D762F86BA867DA831DAAA3B3150E234D5B167895D5FF00BF3E159E';
wwv_flow_api.g_varchar2_table(33) := '632B0000587AB6E1B717BD91B1CF7E0CCFD4313A8AF93854D343530BA29710A096866C8E8AA1F4F28962C23178ABD85A76F6365B71DFD8BFB36E36E16F6FC4D58E653B2923A5968709A08E2929FC474B34ED8CDC0E155494F57118A6C4A8E3A3AC920184';
wwv_flow_api.g_varchar2_table(34) := 'B8C789526556F76FC36E36FE85BD9360092F8A7C52A2BAB9B6B2B2249EB82CA65C3602E55B399EB2799617776274B7F46CB6E1B70ACAEA6A366799DE2A8EFCB43E2082AA6113F85BDCB7B5656F55C2F1257E85208194D41E5B067C0AE575EB654D5B534A';
wwv_flow_api.g_varchar2_table(35) := '6F0C58BCCFC16AA69730581F362B4BED789737EA1CDBA19810B09ABF374313CFB7BF0BFBDBF0DF852038B63AFA8245F65514B514D97578E28F81B8761B043B2F0DB43B1369F6BC487FE496CB359785EA06AD441EF5BD8BFA2FC2FC7C475FE5684B1B8251';
wwv_flow_api.g_varchar2_table(36) := 'BA928236B962B402BA91CC54FE169DCDBCF2B248A47C6F50D2C9531723985BB3BC2CDFDECCEF60F0C7F0B7C9AD58091D9787DAC389C47DBD96DC36F46DEC5BD2CFF97C7F37A09B024E2F550D4574B24598A64F246F0E6C73C189B34E5F0CC0F89F5B9D6D';
wwv_flow_api.g_varchar2_table(37) := 'C6FE9735AE05A62F0BD3B5E73E214C692AE68944E7B5ED7B70AC5E3AD6063BD57FF75DE25A2A7BB617788311358CA851BC491B1EDF45D5FD3656E3757E38F56795A0786E014029285A4F09658E18DD249598F514A0C42AA998C707C65A6EB2AC1C7EFE35';
wwv_flow_api.g_varchar2_table(38) := '44D68D423D57F4E393B6BAAFF00A3A9429EA9841586E235AEE4962935181DE8C5F1B8B0EB3157E2D595CEFCB6541412D6D43226318D631AC6FA6FE8B2B2B70D96DC6EA6BE2B8F363E174E78682E38B62B356CFB672B0EFCD23E9CCAC92395D1BAFFEF08C';
wwv_flow_api.g_varchar2_table(39) := 'DE7A3547D1FC2DEAB70A89E3A785F2C9598D57D4C8ECB4589CF14B6945CAB397328AB0C3550C6EDD55E33414A6CE7E338B622EC9418AE0F5F041E6A7CAE240145E19AD9ECE9A8A829E8A1D387D765BFA9F246CB66041008E18CD70A3A17B878768BCBD16';
wwv_flow_api.g_varchar2_table(40) := 'A3ACACBC4B59A74ADA768282C0E03A924CB198F2555D396117F3D1AA2E8FF6BC495BA938A66ED75651B486342B1E18DB9C208488E3C73196E6347E1BC3E9EC5ED6868003D8C918E63E970EA2A43F83D16563EDE2E79614D7BDBF18B12A88C58B31677DAB';
wwv_flow_api.g_varchar2_table(41) := 'AA598AE2B0C2A39A178E44E73402E388D60ABAA7CC4BAE1A0D3523EAA5C8C8208E089B1B318833D30916C56156F3B10547D1FC2DEB9A66431492BE591F348F91F65410EBD4B1AAFC3658DDB4235E18AD2259699DE9DBD57575757575757572AE56317FC0';
wwv_flow_api.g_varchar2_table(42) := 'B75CCAAA5D185CE586D31645A86C9B3CECF8E238A550A47466C53217BDED6B68A8A1A4A02C627343DA5AEACA77D34C58EC19AE358D70A4DA3BABF0BF0D96DC7C4B5BA54ADA76DD5D61D4DE5E0E6E1758DBFF000C4A86A4D3D5C128BF0BFAEFE9B70B7A31';
wwv_flow_api.g_varchar2_table(43) := 'DFE089E1B2B5CC046655F3196A0443CCCDD0798A82579A982A8A87C8F17BAA37451F33A39E22F611C248A3945A46471C6DCACA62DD268F62AF17A0A4B89313AEF3D56E982C268751FAEFB2B70DD639BBE06AC8A843CD15366E16F4D95BDBC522CF48534B';
wwv_flow_api.g_varchar2_table(44) := 'E1796A9E5D185CF50C4FCBAA4BDA1199179575135CE3742198A1492EC78DB83AA63D57A66253B6C037179EDBB3178CFC9B5D4AE4E9E16C7A86AFC4F4B1DDB4E59E22C53AD4E0987E1B4324D2FF00AB5152CB5750C859342CA7869E265D5D6CB6430AA2AB';
wwv_flow_api.g_varchar2_table(45) := '0249A2C170C8DC1CDF72CACADC2CACACACAA23CF048D53B09199492BDEF319C9592B005E4EA50C3E53D461CC1F311D044B56FF00074B55D9D3D483BC0E2E8222AFC49BDD5F64247346C6BA460DFF0053A87ECC3CEE06782BA9E93781BE28A816BE298BCB';
wwv_flow_api.g_varchar2_table(46) := '88698E181E1F1D2D3E755DFE3E16E1BAA6FE067B56F7712B53C93B8D3C0E21D398DCE8DD74C95AF52C19BA79795A552B0499A47ADD104F5841D26AB1562A7B88652BB2754346C06ABF72292579B81415564682A93A92A02D3704232553B32481EE15920E';
wwv_flow_api.g_varchar2_table(47) := '9435324F9C3C056561C297F81BC765B2D96CB6F46DEE78964D6AC829A311E58C30490BDBD2C531CF6A6CAC3D5BFEC5D5C2CC153DB4F8545752D3FF00254E332CE1D153B30E964DE58A8A9A2DD67A5614EAC8B6B3AADDD9D52E731173CF55153197751D1C';
wwv_flow_api.g_varchar2_table(48) := '2D0B4630153358DCD6D95B85956D6D453545991E3D543AC5E212E2016E2D01F93710A472F374AB6F5DC2B8571E90B2594F590454F34CB01A67554B535F3D5533A092DC2480F56F4D8B40EA376A133C2D75AF029313862F819711ABF8C58646DB19326516';
wwv_flow_api.g_varchar2_table(49) := '63A39CA753CB75E5DF65A4F51B5AD730BB2ACA1451091ED6AC8D00016DB8403E4B2AB2CAACB168C7986A6C249B28E38A2E9759C2BB4A692D3CADABAA6F4188D58B2FD4EA950CF24F1B9CFB7A2CADC236C246F92041B0AAD81B2C3A48E1D875334AA0741A';
wwv_flow_api.g_varchar2_table(50) := '195B55471D434B55661F3D2EEF4E607F591863E64FAECB7C9154B1CC2E7BAAC9368BCB554B6D46431469AF23701F2AD67A12B96A1EFAA109A359D881FF005672E6577ABBD5DEB33D677ACEE45C53B980561E9BAE5472F6B8E184FF00149E96373287CBC6';
wwv_flow_api.g_varchar2_table(51) := '6EE12432BBF1CB2BDBF2D65A8EB6F8BCF435750E7A6536019B9A8A968A8E999043662303641635383B74ED0D651E21031F9257CAF75DFD0AA78B5676350874FE3FFDE6B2BC6506B510E591EB2FFACB221A8835E559ADF93A61D8B8216E1CC8E66A129720';
wwv_flow_api.g_varchar2_table(52) := '252AF282B3B9173ACB59CB304F91A1AD5AD12076E1641ACB383B22C247E3915B8647A6E8A10BC8B831BFA2746D67F236568F88CCE5521E29A528D0D49F8E17492B2A1A5C5EE76E7333BFE2726D3DD6270D536795EE8D9E6646B19FFE4E47B04899854F06';
wwv_flow_api.g_varchar2_table(53) := 'CD7D354C7F33FF00B3034EE0C1223039089E102426E69366B70FAB3B86D24B7B17D2C8DB28E8AA4EEA5A57B073329E476E1CD0DD9CDA4988CE3333A2746D29F1D931EEB0045EC9C24EAB636CDA71227601979D5BFF002691DAEE43FF007B2CCB09FE07F0';
wwv_flow_api.g_varchar2_table(54) := '8853C7BA2ECE79795BFC863A326EB4A99451EDF8B256045D537E69A1D78E48DF2435F4333E2185C1969A290092BC2749507759EBDC9E1FB671055798D56679FBEAC8058DDC84965554F155DB3FE89872FD16883495E59B9B2B24C3E78AD9C612E962CEA0';
wwv_flow_api.g_varchar2_table(55) := 'A20C78C95994BAD2B63A667E460AABEE7CDC05B674552739CB357D3B99953619A43984BFA5BD99257526136D9B438792029B049DA0BA03196B887656A19415B27363775C8074B2BAB5D6FC45D612DFDBB95939AD67C8C9076CCC427006C650EEB7855E2B';
wwv_flow_api.g_varchar2_table(56) := '21243DB5188B8F6172516B7ED969D5A95034B7DBF27D73C8DEBAAF42A2DD3CE54DD79A9DDD4B5A7E46288756D444C6D9BAF33C9C953864D393A9FA5F259E70F6B4D8BDB4B13AC637C2F368A0A0C466DD3E89E0F33A5A16121EFA8A727959530B37071227';
wwv_flow_api.g_varchar2_table(57) := 'A99A9DFD5A68EE2CEF217B4930A6CDF86CB28560BB0445D380D95BFD1CCAC7B804944B76B61C2D491AD93596F898A7EADD29C7571A96A6C9567E3FBD0DBBDD2488CB51D83EB0FC7F7A8BAA08B38656ACED2BFF00848EF929D3347E8E152B4EA4AD0A85A5';
wwv_flow_api.g_varchar2_table(58) := '20F96AC6DD96BB16BC47A99A9C845D0F6BC683893C996AEDBE69AD65361AF9C7E47E0CCBFE3761D88645E4315DD362C4997C9E6F136B9407C4123864967AF88E59855550B96F9DC4C95353E2953674925154C40993D766D82B054CDC94F134ACD50B74F0';
wwv_flow_api.g_varchar2_table(59) := '3EFF00841E5CCD3D4C70776C74D6DAC0742E42E8E51D449FEB55A7AE76042471F882F5F93BE847D8C25A8BA30799B2403A3671D15E1EAE2F8BE99DFD84BD9343BEE75169B7ABF51AD1C99DE4A0E9BEB798FC866ED34146FF00E4F2F05ACD970E63D0C169';
wwv_flow_api.g_varchar2_table(60) := 'D4941046464707C77BE7CDD2317F954181C0B16841951D8ABEF61BACAF3D05C9CA23C2ABE46DD9FA6D636563246E5FB7ED56B40F3CC20A797E1E4DF1EEC60D4160609C7402ADA8CCFB7397B3B6695170FB730F8EB3BB895BF6D583B195C7A35B3391A6DE';
wwv_flow_api.g_varchar2_table(61) := 'EA62C6A64B082B5D9742690FC7F70E473FD8326B72033B7E7E621B58B9D40AF41DB2C277465A41D04D4E8D5C6534D23BAB686370B80D7C44071A77B85C69550F8B5F52DEAE9013CCFE6165A71DB98D1D15C96F97A967C74EA6D603423BEAB6B220D3A5AB';
wwv_flow_api.g_varchar2_table(62) := '58F3CA68AAA56F39A38E004BDF3D36621F874D016666B671DB52A517496DCB93445F20F753385DEC958459AF89FDC3A95BD448E3F1CF220C96D775A5EAC2F73473F988FB36773B60C91E13A479444E7E1A753F63907CFF006E7A08D68BD08646AD17B969';
wwv_flow_api.g_varchar2_table(63) := '9EDAB94AD77AF355007299EA5096A5CB2CFDC3A51D0B8F7BC6EF930C4CE541F4CD7721CCF1CA58D69FC9AB0FF8C3E55795E6C2C41B11AE3ABA760D9DE69BD848F3BA74AFB593E95AF712E9B0FC4AFF00822C3EB43C19CF9568B20C8DDF1D25A56E83CE9D';
wwv_flow_api.g_varchar2_table(64) := '9A5928F98C8B23D35E62E9E61DD8B2AA45E5E66F5DDAB38EE678410BCE87A7545459799AC42677F93CE47D01A888A12C0BCC45D1034A508DA7A7347D35DBD15DEEE8C15046E6290F5D0785CCD4F987D8163FA68A2D95BF0C95CEDDC76F91DC72B9A46E5B';
wwv_flow_api.g_varchar2_table(65) := '50EEEF96777C4D3D51DC88E46F50F42660BDD959147B345549D58EA9AB5E66A8FCBCCC6DF979B8CF5D78495AF0B53A6A778E6FDB7D43C7DF55CEE56105A7983E2EEC8A193E3A15CDF89F39F675BEED653766C57E8219C74C957D899ADCEE7AD6950A99C2';
wwv_flow_api.g_varchar2_table(66) := '7D44AFF95CA15738161AF238F3303EDB3A2613B88C34EC49039EEE3D0C48E947F2CED77C3F32699423512F6749293BEAB1BD1DAB20CC839A81A73D594AF3CD0E4AF09DAFF62203F2C917D745FF005D3A84D65604ECDF6CAB9BB34BDBB1190AB4A3E0FCFF';
wwv_flow_api.g_varchar2_table(67) := '006319ED91E7AEBCA8544A06DA8FEA84F285E626B596671EAC7B5A8D5C9F5355395A921598FB4C91EC376F9DA94CAAA92519AA2E9A630497677346DE62C85FEC618F2DD69942093AA1A8D59987E4F731FB2CAF1D079A3D0B1C7E6594A0F36B301B439ABB';
wwv_flow_api.g_varchar2_table(68) := 'B9CDF7C8C3D0C74FDF4E9D18A9426C501E97CBB35CF7F7B465642DE8252760DF35F5FF0091FEA358F774D09916B87501C7A369AA7E40BE66ECE0EA5CDCDE60746B750EE32BEFCC045DC0A65AB1B3E26A5C56A5FE57A73D74E98AD0A6421806E3B2BC23A7';
wwv_flow_api.g_varchar2_table(69) := 'E5EC5CD1F2D76F6D58DCB5B20D9F29775036D8B2440483A8D11B9F30CEDF3EBA6CF7EC4A6B77DC3214E6D2142316E4B48B4A03F210D3B7AB66637E24BE428DDAB9DC888C75CF1A123BB095E42FDE76B55AD0AB7231D433E5A88D8F505DDB4E77F5F2AE0B';
wwv_flow_api.g_varchar2_table(70) := 'CBCBDB4ADF26867D4C553DC3081CE4D105AB49D8C9021E58A22996661F8E57F6CB7F9E8D37AF2B80BF06B587AB2081CB4221D0B5E11CE1195A3AEAB5C40595F65BA6EBF62ECBBBFCD4256AD32FC5D580CBD1A617FDA16393E3EEB3C21192346A211D3529';
wwv_flow_api.g_varchar2_table(71) := '9C39B2B3FC4D6D514401FC81D083CBA89D51523A79BAB41D883D18D9FE622890D0FA8170B25B76D9E8388EBAEC05339B7696BAFBF3DF94896DCC668D88CD03BAE6A6E0DA72E09D4D3345D3742DCDF83B09996B025DF5BCE5073FB9745DEF4C9829C9DB4D';
wwv_flow_api.g_varchar2_table(72) := 'FF005C950117CFDCEFD79565694D25ABCC39091C7A17BBBE83DFF13039BF3C8D595C08C9AB543E65F527A67AB29C6A5D6CD9CB7A89E0FB0C9FE2B557D6436DA50F89BF16D45939F9D133761AC166FF00CB340AF4A98C611C9A73763E61A9CE90F50D0AC1';
wwv_flow_api.g_varchar2_table(73) := '651D84AE0B58959E4EC1BBEE614393E1E62746471DCDDF9771172DC645B0576AD966BACB05F9B4212B2D20EB6A359290F4CB4C169C0511034EF7A55929CF4D18CAC94EDEB7A659690ACB137A7E10B56CBF0B95AC76B1422B8458D1D5B2CC3E2F99EFD8A7';
wwv_flow_api.g_varchar2_table(74) := '3DEEF971CE42134A3A19243D78030F71E5D7ED167A457A5ED9A995E911A7847568A6BEC763CD762BC36434BB18A15A718EA04283CB7A6B91D4D637B79B5E61A50977DB5A34E9585678BBEA47F56CF51D13D8D70BB9B1465329617A752C0108A9EFBE830F';
wwv_flow_api.g_varchar2_table(75) := 'C432DF12CAAECD6D65F62651B4BA51CA8D1B0757454CDEB9596FC634C752223F278683CB7FE83658C7C75F645D1FDDF2423E21E1DD6C10CB6DC3227211EC4B4D87CAEDB6D708D401D0CE56A38AD596CB39FB6A42EEAD7D337A17B0F4D2711B965383B882';
wwv_flow_api.g_varchar2_table(76) := '2B23142DEBC876668484A7534C169C88170D96B346CB520EF9E9BB09FF00D6AE6BA2FA646617B0E529CCB846278EB623888E4458F1D7DD82164877F2108055342C79727D3871E6737F259474AC6B4112564B13B2B620F95A1CE75D8DBA7D74A0D852CB34';
wwv_flow_api.g_varchar2_table(77) := 'EE7074CF3136E0E233DD1AA95C6EA99EE9DF95FE4E9D4B918FB0A58F51975579E33614B007EEB46DD0C050A6EEA4639ADB87D44ED7583AA6470E78C46FB5C50D3F5468299790A64FA082DB0C3E1B2FD3E153D345165B79701832CF0358CCCA96064A4E67';
wwv_flow_api.g_varchar2_table(78) := 'C6DA7176455734AECA9B159544CE8BA3AB6775FD8FFFC40049100001030103060A08040307030500000001000203110471811221316191A110224151728292B1C1D105132030325262E1404250A214B2F0062343537393F183A3D224336070C2FFDA0008';
wwv_flow_api.g_varchar2_table(79) := '010100093F01FF00EA21ED1E13FF00C025C91C9CA4A9E8E3A32864D7F53346B5A49B82273FC2DF94732FCEF01681FA96999D938693C1A236E48BDDFA9E8899BDD9F80719FC7775BF5303D6687BEFCFB82B4E5455CE3273DC87EA5A18DADFA90E348E21A7';
wwv_flow_api.g_varchar2_table(80) := 'BFF451EFCE72E05F8E8438AC6D3F4D1ED7C2C6D57C4E710DC74FE827F301B5728FC139E5946D231CA50C892214730F7FE3C704595C60246F2539FF000468D6824A1CB46DE7C82AB4D78F4E43CE8864BF37E577E89A47BE04BE5232A9CD5CC36AFCA339E7';
wwv_flow_api.g_varchar2_table(81) := '3CA9B56914216789DF01F02BFBC8FE577823D269D23F429DE2BA5B539F557DE9A35A2A4EA086669E25FC9B070B6AD2B3B4FC0FE709F92E0864CADF89BCFAC7E9DF1CC777DD4ECCA68E30073971D4A373038D038F0B6ADDE0EA4F2E0299EFCE89AFAD0DDB';
wwv_flow_api.g_varchar2_table(82) := '9BF4D34013B25B08AB6E1A3D87651150703C07E27E6BB917F9A0FBA9295D0394AB1B88D6FA7828CC65DF0E7A827F41F8E6CD9BE5438EE89C5FD270E028953B99CFCDB11E3B4E403A2B95C1CE7F97DD1A8F56DC91CC82AA755E38AFBC7E81FF00B307C387';
wwv_flow_api.g_varchar2_table(83) := 'C3E6B9546E6655726B9B423C27316FAC75FA3807C2C71F0F75FE5B50E03F10CA187E3CFF007937145DCA871DDC67DE783E319D875A9C37E96E7DEB33984838703C39CCFC95CF4D49B43AD0D1178FBA7FC2C1C4A7370C9914069F566D1F8FCF041BC37CCF';
wwv_flow_api.g_varchar2_table(84) := 'B2DE2E6CFCF4E5411A11CA864CF4CCE1CA9B4702C6A1EE738233A9DEE6F201990CCD7716EE44482D3507997167033B79F58F6CAFEF9FABE1DAA4E2B7FC2199B45A1CD0463EE8FB93C79388DF12871E5E33BC385E1AD1A4A63DCC399C69A51CA89DF09F02';
wwv_flow_api.g_varchar2_table(85) := '9B41C1CCEEE4DCE48AFBC89C72064E581F12824EC950CA0D7E52A378207C44663ECB32E570A81A00BD4946F231BF0A2BAC7E51CE85034002E1F83CF041B0E4E9DA784800692B344D3C46F8F01E248DD8472AD2D34451E47772E71EE8D1AD0A5746CE4634';
wwv_flow_api.g_varchar2_table(86) := 'D336B4F739874D7391EC7C1355BD6E4E09729DF2B33AB39637E7D3BF40537AD25D47F2E4E2534D4AA42DD7F16C4CA739E537FBF7015D08D473F09E3BB8ACBCF2E0871E6E37579384F1A5D3D108A2B464D05EB43C5766641733BB96AF7478B1FC5ADDC3CC';
wwv_flow_api.g_varchar2_table(87) := '380A27348AD2D6415A10330D8137D73BEBD1B10000D00268735C28415035A79F49DA7F03CE5388C551D7A886053F2618FE2AEF4F691AB80E61A50D399A3982398685D63CC1680B4B0EE3C0791DDCB57B9F858D24E0B3B9CE24A080A0CEEB87B03FC4F05A';
wwv_flow_api.g_varchar2_table(88) := '1C329B78D3F821C3F5701473FE5BD7C4FEE4548E18A77C7C5AD33D3800A9344F6B9E73BDC394F068228568FCA79C26F15A0D4AE53EE4F1A539FA2387E37677797B14F8D1A00F15BB97F0BF95FC017C2DD2A807251393BB93B423BD1E31523748E5E1635C';
wwv_flow_api.g_varchar2_table(89) := '3584D0D1CC11CFEE261943F237394D21B401A0F30E0F81A78BADDF6F67989545F17AA65767E13F2B81F05A2AB9B35EBF3F2A3EC04C45BECB8839455A2BB0A8DA546E1BD4CDC73295819F3573263A676C6AFF00D3C27A9F745D349A1B5CC328EA45693A4F';
wwv_flow_api.g_varchar2_table(90) := '30E75F0B1B41ECB097681C62332B30A8D1524F7FE1795A572695CFA1378A34014516F0B242982C973B5E7A289C70A283C51A60B9583BBDA3452260BD4AEB8674C21DCF9AAA26BBBD3031ACE4AD739E0C932BFE2E5A6A5AFD9D7F8719B48C5729E03429E4';
wwv_flow_api.g_varchar2_table(91) := '62B467CFA51CA765693A78420820BE428042A9A1448346280DAA3386743805689A1127269A4D74A28A28AD7F87F8A9C75A00A2CE380ACC8F09479782500FCBCAACE4822953A53E9AB4A667E72564A6B8EE4CD3AEA890ED5A112555661CEB3DE98DD89A06';
wwv_flow_api.g_varchar2_table(92) := '8E028A29D41920E6251F151F7FDD35C37A9297853B36F09F7AE6ED5235CD8DB5343543E32E6B71D2BE1FCA78367970159B5E8EE4768F24C382752F4F2E3AB32CA636F4E2F3B951B829BC167C530A6B935DA78D56F2269A5C8706603DC3BF22205E9E09E7';
wwv_flow_api.g_varchar2_table(93) := '45656C55D88952BB6A7D70419B152A1D4CDEE192E0A39D59A43895E8A9A66BF3380932335E485E82899C9492D2DCFBCAB1D9636B4D0064A1E372F56074D161693988704781E29CF5A2CFAF9310B25A473663826656B23C9499B9B4A6F681053E41CD4705';
wwv_flow_api.g_varchar2_table(94) := '23F1629198821530298E595B0A7D148DDA88DBEC55555538A71455101C2104383470FCDECB9A2F2A569D5924A92879B2478A9646F542B5BB16AB60017A7E42D3FE1B6379006D56FB5BFA308077950C8E03E739F3F3E4AB2BB695647907909FB2B0BB2B9F';
wwv_flow_api.g_varchar2_table(95) := 'D615134BC696E5B7287574A754EBE1691D129C3AC288BA9A8E50463C4513460E46418652C8378A20CAEA7269EDA0FDA0A3B405FCA8B71242A7FB88FEF4E3DA0B2F7290EE4698852EE553870B06FF0024D4C1B78023C1A79399357CC8F034EC4C7B8EC50B';
wwv_flow_api.g_varchar2_table(96) := '183EA4D89D711F651BDB76853BC5E3327C2FBE89963AE49A659A371537F67E2EC9EF055A7D0CFC8F88C2C697EAD0332B66C6956B90DD55EBCE214531BC80BFB3438C73B9C65937B1CBD042BCCC74A3F98951BE23FE51765EFA056495BD42A191B7821043';
wwv_flow_api.g_varchar2_table(97) := '26E526D09B19DA135E3A2E4E78BC20D7E05589C6E0428B27FEA8F12A984ACF34D7F7F72781B4F826B9F7467C930B4EB694C7168E50C5DC535BB16E626BB6229F5C130A09C383BCACAD856F54E1F9F82D1B199FC55B4E20856C71E8A9DD88569FD855B05D';
wwv_flow_api.g_varchar2_table(98) := 'A108CEC5003D4562AB5EDA1CCE1DCBFB350482BC577A9925CD892BD12C8247B6AF606902B728851594579E954327605691B49EE5E9270664D0C7959BF76856B66D56B62B6F7AB69D84AB5BB06B5BDEA57D75BDA06EAA01DA84B5F00A066367950F47307D';
wwv_flow_api.g_varchar2_table(99) := '4DA2365A7D3191DD42A2665739825EF71563B34F4FCC24A6EAAF475962FAA5932F605E986C7AA387EC17A6AD15FA63A2F4F3EE7C5E6BD332E57CC23CDB82FED151B7F815E95B53DC397391B28BD28F07FD22BD2DFF0068853B6768F91D9F62CA047254AA';
wwv_flow_api.g_varchar2_table(100) := 'ED3C202A708F67E7E0B311AF2959F6B8A886D2A18F11550B30CCA3776BECACEEED29266EA0AD330FEAF56C38E52B4B8DD945492E2DFBA91FD94F93626C8EDDDCAC800D62AACF18BDA843B026C15B93DBB9163AFA281CDD6D5238755195D7BA8372600EE7';
wwv_flow_api.g_varchar2_table(101) := '02AEDEAD6F1A9EFA8D8ADCF77D2D069BCA64F806BBC53273A8D19E6AC0D71D65CEEE560B3307D6DA2B0C1291A4432386EAAF469CA1A5A65229B95858DEBBCF8AB1464FD45C7C5592C94FF4D5908E83E9DF94AC72BCEB93C9AAC52C439DAFAFF304F796FD';
wwv_flow_api.g_varchar2_table(102) := '429EC0E0A66CDC038020479AE5A9E0B4346D0A8EE8D135B8E4ACA1822FD8A50C1AE8AD7DEA769FEB5A78C0B553F6A9D8DEB0F056AD95538774C27C02E1F656A3802BD69B82B3B9E75A82302E0A166C6A8B70566AEDF05660312A2A5CE298E1B0F785EB8E';
wwv_flow_api.g_varchar2_table(103) := '29AEDA9AEDAA26E02BDE9A00D61A15A182E3E4AD76823985485682D3F5B69DCAD3149CCD2EAECCA56738E4D131BD4C827F6A74B5B97ADBDC2837AF4B441C34802B4D817A55A7A595E215AA23AEB18EF4D0FD7567826B453EB6F81F71A505F28E0B4C4710';
wwv_flow_api.g_varchar2_table(104) := '8594AB1E2DFB27C8CBD5B1DB0AB57ED29D23FA21414E99FF0084D854509EB7DD470B71AF727403AA7C93A03D42BF87EC94F60E830F9296775CDA77A3201F53C3535AE3FEA2B27EEAAB3D31213646745CAD383DBE29D67C026C26FAF8A6D9C6C52B2BF4B2';
wwv_flow_api.g_varchar2_table(105) := 'A9EED8D6A849FF00A8A08D9D27554D0B6E0AD83B95AD9895240EBD4103FA2AC85B879AB54D18D45DE6BD292F5812ADB5BA3563B5CB7D00DCAC9638C7D6EA9EFAA86C27AD4EF2158AC64738940FFF0049D62653E5CB276AB6C3FBFF00F14E07802638E0B4';
wwv_flow_api.g_varchar2_table(106) := 'A8811D36F9AB3BC54E9A54269C0A6CBB959FB2539CCBC290BB9C0342A56BB53DB9D4109FEB5A819B940CC5E141057A4136CE3626D9F6F92F503678A9A3C1B5F053837C6A9D58FCD473BBF6F72824C642A068EBA645702494D78B9C9F337AD556A6F58517';
wwv_flow_api.g_varchar2_table(107) := 'A991591A7A3F6566636FD3BD4EC66C56A380A22F3AD090A8260A026F34566FDCACCC50BDA756752EE52B9BCCED2D29B0BF0A2822D81599BB68A08BB614167A6BC92A1B1D3580A0B2876EDEAD5676B79BD5B7C15BD8DE8C217AA90F3FF09E4536D3745135';
wwv_flow_api.g_varchar2_table(108) := '817A3ED98CCF0BD1CE3D3B492AC76469FAE625595869CB138B7BEABF8A14CD9E5CCAD3237A42AAD516E56B60BBECAD4E3B55A0B4F453CB9DCED19254E6E90554229CE1F9B7A8EA6FAA80E007923236F60213A2A7454313BAB4EF563035809B4EAB53A6C0';
wwv_flow_api.g_varchar2_table(109) := '0408D6F3E0BD73BA23242B306EB39CEF5331BFD6A569ADCC42571C1599E6F34EE564FDCA19302A294DEE0A007AD5EE50305E0F8A633B213436E6A7B902EEAD54718BC3429A16DD456CD9556879C15A6ADE62C29D2B6ED09CC97F6B9474BDEA1FEB7A8E41';
wwv_flow_api.g_varchar2_table(110) := '701E49F83DB45EA49E87905638CDC159F24DC1650B83509CEC013A9A9A32CED50CF2FF00A8E34D817A888736435BE6ADF1E4F335B95E09EE3D1680A1948C3C9590F68AB10ED289AC56B685342E3F5354313FA253258F78DEA78F16D138BB145ADEB2B56C';
wwv_flow_api.g_varchar2_table(111) := '24AB5BF0053E67535D159B2B7AB36E2A3C324A8E4EF1FB91945C1A1493ED0A79F6A7CE45E132526F565931345667B7A2E2A49DA6FAA9A37F4BEEA2CDF43E89B3F6C2865EDAB349DB2AC8EC5C558958BF7AB1B06F523630AD8C3D5051B33B0A2B29BD87FE';
wwv_flow_api.g_varchar2_table(112) := '5485BA9EDAA999D5CC86D2A7637ADE4AD87F72B4CA6E4C7BBA4E564C5414EAA8DD8021364AF3D1B54E9B7296D1B54D3A331C543210A77E1F75EB0DEE27B9474BEAA3D853DC0EB15EE526FF00353B05E42B5ECA95EB5F70564762E5658F1FF95044300AD4';
wwv_flow_api.g_varchar2_table(113) := 'C6DCAD4F3B54AFDAA4723B82EE4FDC13B702AD51B41E6CCAD35EA92A593B053A43D28EA159E278E768566905CA39B134533DBA9DA372B48EDAB6336D55A99B15A3794F95D8E4A8DC473E72A31BD35CDB8D54BDED526F0AD6C171F2568738EA1E6A099D7E';
wwv_flow_api.g_varchar2_table(114) := '656418B959A2D8108D9B15B73EA56DEF56DEF56C61DEA4B39BDA9D671AC2B6B2EA05688772B6B7B49DB8234B8009EEDA9DB948538A8DA6F418DB8290F727BB6A71F74689FB8291B8AB4C7FD60A5693CCD62691AE4753705232BCCC65544CCFCB2507728C';
wwv_flow_api.g_varchar2_table(115) := '3DDCCCD0AC676956668BCFDD7F0CD5347832AAD6EECD15A586F3E6A468A6B0AD830355339F7056718E728860E7340ADBB2A54B33AE6AF5FB1367D8A493B29B33B050C4CD6F352A787657C17F0FB485666387383556361EAAB346D54DDF846B8DC144ED89';
wwv_flow_api.g_varchar2_table(116) := 'A534951EDA78A9727534792F58E3AD3DADB810B8DD17F9A07ACCF108EC2EF24D06FCA3E080C23F34E976053D75398BD5E19417F37984E3DA6A15BDDFF8A90B473346477A6349E771AA9A160FA68AD6F3A8554B3A7DA0A865C5C5324A748F8A85BD677FC2';
wwv_flow_api.g_varchar2_table(117) := '89A1441D87928E469D453A7ED28263D629968F7E10760A198AF58C3AC555A9B4D7995ADBDB2A673CEA09B2E3996F901F152BFAA41EE56878C0AB48C4953D6E6D53BFEDB53E9B47729BF77984E79BB3A336C4F9313F7523B66529CF654CE2A53BD3DC7072';
wwv_flow_api.g_varchar2_table(118) := '8DE772B395048ACEF71D7F642366C0AD8303542472B39DAACBBCAB33F02559E56EB56B78D4EAAB5B7B4AD629A8928CA7ABED83C0EA61552BEEC82ACF23AFCCA081B7A7599AAD15E8B14939BA8BF89DAA2B43AF2A093B7E6ACCED8DF24D7B7A3409F3ED56';
wwv_flow_api.g_varchar2_table(119) := '591DACD558DB8B559995FA5D45EB9B79144647765CA400FF00A4AD4FC1B446637BA8BD61BE8550DC6877A12ED467524ADD6BD4CB7E63BD59C01D14CFDAB36E56ACFAB3A924534830524CFB8515971794DB3053C4DE88AA9A4C1A13AD250B4ED504B8B885';
wwv_flow_api.g_varchar2_table(120) := '03F68777AB391801E08CC2E29F3EDE0919DA4CCDAB3A0F0755117EC09D2E140A1A1F99D9CEF527EF0AD54C4953C8EFEB5A32EE51CAED5FF0AC6DC4D559A21B14EC6EA1F65691FB95AB715691BD5A80BAAAD47B0AD6316D15B36554ED7E39D39ADBCF929D';
wwv_flow_api.g_varchar2_table(121) := '9BFC948DC0D3BD45977B6AA16B7AB4EF44E345927B2540CD8ACE3AB995A8B753948C7E20A829AC66524A14D2EE4D95E359CDB9519A8665353ADE4AD6EC2A9F29D8BD6EE5667BB5B8D159234D8A3D7995A86F569EF56AFE65681BD5AF713DEAD5B58AD6C4';
wwv_flow_api.g_varchar2_table(122) := 'CAF44A6C83AAA5A6D09CD3AF326C7B0291AC6EAD3B937171C90847DAFBAF55BCA7C7D8FB29982E6D3C15ADDB0A74AEC17AEECA749B289D26E4F936264C77286751CB8E64C936852385ED53B77A7B9DD114EF51BFB49D236FCEAD07B25073B728D9B15587';
wwv_flow_api.g_varchar2_table(123) := '684F1DCB20E2131F86745C2F6D14BB7EEA98538093EC53604F22ECC9EE38F0B5FB7ECBD66E4E93604C936A12EE4C7ED4D9372F5C3AAAD0E182B446473D328AB591D523B94A1D7B14C19734D548643D203BD3198C8A38FF00DD4DB38C54B160DAA929733E';
wwv_flow_api.g_varchar2_table(124) := 'EA77F6029A7C289D3E2D054C1A7FD3CEAD4FC1B456A98A9E6AEB4F8DE359F3A28A1173E89ACFF7106F55F5595DA09A3FDC0ACC7B6A08B175559E2D8142C1AE815A23BA954D613CF19F0284BB029246DED56AC1DA14ED1D162B513D529D51F819E56DF9D5';
wwv_flow_api.g_varchar2_table(125) := 'A186F62F51802A388ED4C8B7851447AFF756765F963C5103AA0FF2A64446B0477AB26C0ACCEECA81DD81E4B29BD56A9E5D9F7534DB3EE9F2E2CAAA6318423EC1F028C7D825185D7B68AC83AAE4D9C1C1433EE514FB95949C4950387F5AD44E513B615156';
wwv_flow_api.g_varchar2_table(126) := 'FAA823DEA1D8E4666E2AD46E736AA481DD26D108AB8851454B9321DA4285A2E7AA6D1EC31DB1308C3DF5517214A1FEB4A91E71E07BF473AA6352A576199389BD35830521CDCD459EF41AB276054A5C146A31BD3DEDB8A95E6F29EF17152C9B54F2ED534B';
wwv_flow_api.g_varchar2_table(127) := 'DA533F7295CB25D7851377A076A69DA9A76ACADA9CF45E81353CA9EF6DD9917575A2557125102EFBA95E71401BD500E6A7B8FFC4002810010002010206020301010101000000000100112131511041617181A191B1C1D1F020E1F130FFDA000801010001';
wwv_flow_api.g_varchar2_table(128) := '3F10B604B785470971A61DB8513131BCC6F29BCA221B331D7859C165CB98964B20931BF0C11A98EB3CCAEBC39EB3CCD25CB6F0CA580CA7661DA357C17BC50808A6D1D62884592E066506590ED2F8350A399020CB65C5E933B446A7713B895D4944A27894';
wwv_flow_api.g_varchar2_table(129) := '4A2510382C3E65B1609B4CEA0705E084B8C2F912B63C3132F0BEB1E164C4B1E0A6557396417865953BE57794DE10A5E2639B2E0439C4F0DE5A5FF9BE38EB2999E14E952BA44E9125B5A70B97C2E5B33FE6FA4BE92E0CAE84A97D18A42CB25F525BB92E5B';
wwv_flow_api.g_varchar2_table(130) := 'CA18A77E0C46A62620CC6D31C2E33C7038774170799E785CB4B62BFE5E1897B7F9B8CB2996DA5A9C0B959B8CCA7FF9DBBCF30A944A6D2B0D899A19EC032C356A506F02C1D9312F85AF296ED0B72251E04AFF0000B119694CA7FC89B4AED03B719A94CB65';
wwv_flow_api.g_varchar2_table(131) := 'F596CF3C6996979795D230A946F2A7770B25268962B27B05B01E6D56583A097ED6CD7239BE0857A001D8972D971B99DE6611E1995C2A0465C7FD1C2B8D4EE979695D489D663797FE059292929B4B972F1FE59D953C79254409FE036257F8A654A4972FA4';
wwv_flow_api.g_varchar2_table(132) := 'BE93350CED1BD89E273D278FF352B85CCCB66637BF0F3FFC03AC4653C0A9E7FC209A33DC968F575BDED1EA1C59359794CA7697C2DFF22F0C04A9999E35C3947809311A8F1CF038DCF134E52F86794B7991E172E1E700AD93F166875402B5640060A12D9E';
wwv_flow_api.g_varchar2_table(133) := '65BC12570A89C2B854495C025707899B9CE665704654A9533FEC65CAFF0074738A65B2E53A58A5D5B97932FD0C2EADB964A4B967398DE79972C2590465F0C3109CA0592A79950CCCCD1B85CA667ACF999DE67796EF29DA032A274E144A374A6D3B232960';
wwv_flow_api.g_varchar2_table(134) := '70A654AFF49E690D4BE77632C21400F5AE6F5661E73A19E25F0A81119E38595015A4B728EB030C544B836220E539419731C713100944A25F5E16CB979CCB9770B4A6754A4288C5F0A9B4F29472657525A33B487D6B91D560FABDC7D53E8FF172A574944A';
wwv_flow_api.g_varchar2_table(135) := '653C31071CB304B830B8F05B31330BDE53332F8532A2DDE59CA1DA2347BA566200FCCAC69298B06741969E53CCA39B2B74ADDFED7A46FDB3A101E682CBBF9B0ED324B65CB2F494A972E6379999857F832A54A6524D04CCCCB65CB7796CB616CCF0660BB9';
wwv_flow_api.g_varchar2_table(136) := 'BC05BFDA5062B100E063698A71C2F86BC2898C46A5CB769E1810A7AEF602E68F863C838294017C5E44E805C685FC32D509EE25B7E0B4B6CCA7694ED332D9E21733195C3098EB2F6B9E6532985EC432E84F097E909A94F48905E7312D96C1CA880A730749';
wwv_flow_api.g_varchar2_table(137) := '72D97B92E5A306545E175C01D8CB4B8B50765E482747462ADCA8779A41623C98F1BADB656F58F39B3BF94D44CE42FEA4525E5A0918ACCCCC1E152994CCCB9AF298964C41EBC00952B85F12AA7995D6231B97DDEA50CEF52C182000000363FC51C396B2B7';
wwv_flow_api.g_varchar2_table(138) := '40378118817CE1BD45DC82D629AB5C6C8A831BCB3720682F91DCD922356D3460BF246D2AC27D3B90190EF90384C70BE3731B701D112532A33FEAE103D084A80F0CCF332F3382A54A4A3831C3300DE728C201BCC6E4CCCA818432D5FB532D7F39CC3843B9';
wwv_flow_api.g_varchar2_table(139) := '5704B74B23AA988465B23A6E17265BAA42338D0629112BA8ED2894952B8AF0D23C6D96CEC263831BB058A7694F1F32E2BBCB61C6B4659C2994CB438292FACC4B804A1655B0155E41AB3A56534D11D68B85407B602515968A2D8F56D65B72D0F88D06A10E';
wwv_flow_api.g_varchar2_table(140) := '98AAFA3119DADB0A6B4DCF894EC4A221C4C70620711C0F2DD021D9CA893F81473AD4D3B46870A96952B857495C332EC80EF2A57024A8CCBCA24AE92994CA6774EE98A9500E17C07B3AF8EA06BF3A46FEA787A6916D68C72CCCAC9DE56482CD90369DD423';
wwv_flow_api.g_varchar2_table(141) := '0D52839941ECB94E972C6D9FE132E5BBCB9898821C2EF8026956DAB6444B4A0CD8A6CA7487421FE3DCCCC71B666533333BF00E091A4070CCB65C5972C9E65B2D8B05999719E04A154032DC462EA7AC7F6604AB414F98D1CB14E42A8D3CB604CAEAC6CC67';
wwv_flow_api.g_varchar2_table(142) := 'E65AF9A9BBD4F9B86E67FCC868C759F30AE18D9E08B3233333CDA4B4D13252B89786224EF832E5F438E263FC0F0CCAE0C46A54CCCF0B2525B2D972D2FA9052D96C5A5ECE973E50FBBF1C9F0456A1870F7B91FC32C07A682FE6018A55B2AA6B1F26557A0D';
wwv_flow_api.g_varchar2_table(143) := '776C6AC6D60B49854BB4453E4CB8F0C7003794EF2C662B171D2F86A9A9BB885A51D6AE21AA116C134EB7C38C89C73FE0EE97161C18DA51288473C1332A51BC712E042298C5CC4857E8BB2310CF0BE906A000ABC808FC874B15714CD4946C25D1F5830909';
wwv_flow_api.g_varchar2_table(144) := '14DD6C5207FE73196738E82046894AD259323ACD25105CB403A23848B37D691F37314BAC2BCAF2A1F368354646549F40A53A9C7114E0D45C016ED50A687BA8F797D51398BCC246C97B642E53C6CE0A4B368F6884A229BF03C0300F0C41292FA1A41D0EC4';
wwv_flow_api.g_varchar2_table(145) := 'AFFD5F892A54CD88D20CCB68007946643AF7079F5899C2E158712C5CA6D3FF004C308125BE2B8100E3E7839C49A4BA83515DA5C1FA2575CF23D87610113C434D44863DEF4600053CCD988BCA067494732346F3368682A26D46ED025C060F9C28F279AA50';
wwv_flow_api.g_varchar2_table(146) := '2156C144CF28CA253BCB67642B6E14C62B284A2245469A5CB65A2C335D6582FD48204D706912A3401AACA517F185FAB33E724D75257CF0C0D0BAA129B74A3EC4CE653D3E783A4A95C2B1CA7712984D6C9DDD83AB1A91589D16E3560DC766BB8194044479';
wwv_flow_api.g_varchar2_table(147) := 'CA656C623F541D0D3F2D2384A2FE4E6F65D0F2CBC7CD28B1DD901863322C3A5C2CF18802D5E90762F65A82C81ABE5F752E66B597BCB254F3C2DCB833C2C964C44CDED2D8BA2E1E642C191224194AEEFDCCF04A56882BD4E0AD7ACBA2BAEBCA099104A538';
wwv_flow_api.g_varchar2_table(148) := '844DC6B6B75103587975C9034541279A7EE41F3C37C4989470A36988AF867EA4FC12A8A6041556526705EA015AC6C0AF7966702272698B599B1DE355F32D9079D3E327D9A80007408F9883588F262E5175F67233CC6B7943CE54CB48EE4BE17FE307F8A8';
wwv_flow_api.g_varchar2_table(149) := '3F9C4A4C36948893A0B75196DBA72B0FBB89F5A77C9E3E215A8140B4AE92C79C1F402AD839CC6ED740E90702B457416E886340CF277980351F95DDEAC30832D7C0C46CA9B54D4C53DAE5F5F9C25F37834D61445C9167C4272982B6172F3535D59872C16E';
wwv_flow_api.g_varchar2_table(150) := 'EBA7FF004993CAA5B12918AFF85118AA5F8A2DB99DA032A684628D895D257058C0594B9581DA76BFE2454CB57F09DF081D3B0AB6E8C1F9832B1C5A62CED8706EA9560B35D21B446C830DB3BC3D183E39BE8998530B81D9997FD54E216EFE8758908B4D4F';
wwv_flow_api.g_varchar2_table(151) := '529049DD2C970C62090500B9D11A732E0340CCAC4187A1B45CBCCB460EE96EFA4BA0DBCF5E937619799DD06738A4C4C4B49694CA2512B828FF000B26043761F1092D651C83E617A3E1DEACC4298A000025067EA0031F2403134A343EA6A68103DA3E009E';
wwv_flow_api.g_varchar2_table(152) := '1A092DDE2AC3BAD000D435B3A01291282D2F396F85CA653FE2ECFADECC34F31B9C1AE200738E45A4B9A51DC4B4A6508CBF04F9C845E970D251666F59492B82A2473299665A7CCB2B9CC6F311E892DDC972F8665B5D10ECFF00D46D03ADDB7869F2C1BAD2';
wwv_flow_api.g_varchar2_table(153) := '0336D28B9D32D472E919D2EB94439CF78A5B8032EC06B3477E4086689119A97C04B2A5F68B353ADF2A879612CB57DDB0BDD6964A2EF6209455E47E516186A883CC6C90D0C976EF2B909EDC4504CFA79A089400FA9D6E50B0F552C6C45DAB5596B9B07778';
wwv_flow_api.g_varchar2_table(154) := '8EF083B48BC84CA7F500A3B115E5ED7AD492D8AAF0198B8CEDC3CCF312532DB4B7051C1595E152CB681D7525665A2BB25BB34D394778BB144100F50AB24EF0D7CBDFF50E12D7200BF2C27258468AA553B4C456F8212B0771871AFE5423CDB56F3D62D737';
wwv_flow_api.g_varchar2_table(155) := 'B65D169A454ADB559659B4756ADC6A247C1ACACF7E198172D3AB6F78269DF659ED6E1E0635551471AEC86C798B3CDC1690ED894F2292C587F9502E38447681B586B11A7D98C059A3A12F3A4165BC4B9AA51FFD156A0A5BF210787303F72AE54795E23D48';
wwv_flow_api.g_varchar2_table(156) := 'B745D6266B6D648A428516A182EB1BCA24B15736D55B815A6637C905A04D9A957000206393C50478C8A7822A2B0A88BF0388AD0B6E5F70AA5BF884385B3FA47737F9BC5F3FD9B4754CF112953636263AF898F1DA37CFC3CA2F53282F822F2A477299A025';
wwv_flow_api.g_varchar2_table(157) := '2DAFF19440A657570D702B770B7665FF00F05B2D9999999A8B055DF4F83304B62522CB6FA7BC7AF316DCD9B4AFB215A9F5C9F24A2234D712DA5474AD9404D9D244121BA72E96BF04B6F0D7347A11A158E86DFA940123988F2B26C5C35F75AF4B662A402C';
wwv_flow_api.g_varchar2_table(158) := 'BB3CD54A2D62054119B5E77C880DF7E6E53B521C05DD73ED0728B1BB814F689CB2B6402E18329BA3CA9CB64A4C9020A1F51F0B8EA1001D5E4518FC6B08C066EA13407E1C15A22711AEB2D99961CE75A75A75259BCB25D4BE905F33CB51A2DF8F132814F9';
wwv_flow_api.g_varchar2_table(159) := '1CB1CD84F57EE19F444CED4F74955CE58FBD5F28D581C6A564F064F129A92F9BFBFDCAA9CE5815ED8335F49E0F98AD0BE7092EB5BB9D12A5C9B59D3E6632C79B4F6E5F117E6B4BA829B16DA3D547ACEE37F88F4ABFD6F2BBB65E02AABE62265FC2C5321A';
wwv_flow_api.g_varchar2_table(160) := '044162CA72CCC41C2D2ABF31CA5895DE85B7B100550A0250A441C4B1F0984B7308439196254029B3CB0F7545504C725D6D98D13044C5667257E583031EAB25A44EE3502AE8EEDF772F89E84FE080D5F957EE68382D0550C14CCA653C16DF805B8F36A92B';
wwv_flow_api.g_varchar2_table(161) := 'D1BB81394FEA722503691541BC5BA98821BDA578BBEFD8E450CAAEED834EE5C4CA28797E20D8AFA3995943A3A243DA3B96F6D994001A7252FB26DFF616F0B899BB327E20B5BF5D511D8B82E42EF194A9045623B97357D6D4F72B694EE317C9BD188FD02E';
wwv_flow_api.g_varchar2_table(162) := '6E83BCB414EE13EC83605F09734FED1D5F72BA3E61D4F9944366600D113FF06230585FDE5809200D03B92F1587CCB767E656EBBDCBAE699198B094247753D17AC39012BF89A7E8FA94EF2CDE5CB96AA8EF44276BD13C310BB2BC9DA9307B7351F2413A07';
wwv_flow_api.g_varchar2_table(163) := '73F171669CE749F825F2F005B77032AC2767DE5606BB5511AAD61B9FDFD239D6C60FB853EBBD87C890E97C05C12C68DA2C45B9D90AD02E7346DC9930673514E2F9E3F4C5BE7F6BFF0024C12751EB19CD3BBA29CBA4C4D04EB47A97E6FCBA64963A825393';
wwv_flow_api.g_varchar2_table(164) := 'C70E9A112DACEFBE986601D917DE634AA419B06582D3D45130A9F6B7BD0B616BBDCA31F12DFDCC6516F645B1F22CC5AF66A7DC01A496880FBFA85B5E93161A236A1BA0CF5CB06401BADCF54B09D4079B7CA00AD299B767C463095CAB93924B1C929EDBEA';
wwv_flow_api.g_varchar2_table(165) := '0B770D25037600A37804F40675F9895F6C03F0A3E95281B6D143ED1CA1DE577A2C59BE3CFB06138AB6AD705C7495FE246940239F7C2AC8C920ED3D044EDE9E03ED96F85FB9068F6C2426A154F7C4202C5B956F74645A15CB65D832B3ED4CBE67CC07DE13';
wwv_flow_api.g_varchar2_table(166) := '683D18617CBABA712AEBF03320F1082BEBAFA9ABF6DB03AC36CD07EEC1BEA6162D90F412905AF413F72CD6BEA53E4316F8313E053083E627E6A1C76300FC211BEA9129F24C95BBDA56DA9BB68B5406B40982437767A23D4B83740F20FE588E15D71FB987';
wwv_flow_api.g_varchar2_table(167) := '2494D89B0933527D431B19E890427528D4F32EAC26F857E651703D882552929872A32A28FF00025F5991176429E521F00BE5EC4967D946BEF33DCDAB1BDAF94100740EFD18DDAEA433FA854277CCBF51CC983A889D44CC9B5CEF7C4E2AEDB5D6A73B7651';
wwv_flow_api.g_varchar2_table(168) := '47C33E75D045411FC6B13AAF2317DA593C5895A7300BE11B82DF4B7D11F2A416FD4B397E61379FD3305254D3D846E3EFF44437440693EA48247E6818F95599C00C28DF98AEED14067B2E07D758B6084A493A2CBA96690EEAB51F9653EE6B50594B724998';
wwv_flow_api.g_varchar2_table(169) := '46E520193AE437F032D33ACC6681CCE4B3D90C3D617CA79F23F2C12BD94690E131940CE7ACD7483F2BF72EDCA54D84DCB856A8EC54C35733B3E61A0450E6905B97B84E4030860C2FE88C67CCD8A9ECE65040EE8FAA85F9ECFF00D65289DC5F2B3F2D6FD3';
wwv_flow_api.g_varchar2_table(170) := '35953C60C8B8DEDFA800371410F641BD873F50AAF54FAB8A878D81CD1BCD7F31D5BF9D659AB78FEE510FECA5BDA62575E6BE58FCC6A3ED97EA66D6FD2C4D1B70CFB88683B6334446D6CA7427793E19933390D5FB96B06D45DAD2A4C0FDEAD11925B440F4';
wwv_flow_api.g_varchar2_table(171) := '9B8CF6F5F328D68F7FA812F3DEAFF526F933F46894808E6BEB6B1BBA9841DC7E105AD2BC94C198977547D22072B29FE217AC2E853DDCD4A6F2B9F830F0D9101E53DA5ABE021ED42E521F0B01B1047494726255439F3CCC0318D31154AA0A2157D6635483';
wwv_flow_api.g_varchar2_table(172) := 'AD1BF09502D85F8CB188A429CDDC13B77B25EC27211D58A9A0F7B27241F27B83E40E987A94763B41DDD1255617D03F44135F067B04C6AFA40A72BE728886C0485558ED7FEA00AADB3FA732C3ED57DA8BC32F97FC90DDEA89F6CA71C9BAFD13D0AC7ED897';
wwv_flow_api.g_varchar2_table(173) := '1DD20DD005D06E0233BC84826C5D439647AD0C0AC286C80F518B4FB97F12975BA243EA0EA4EDFB6979A16D07CCB7E1C1F5887F97EB0212C4B92FB365B0243507C2040509065A7B1C4CA6BCFF007C60B153C539FC24BD26DD104BCE751BD0CD0DEB0AF81C';
wwv_flow_api.g_varchar2_table(174) := '99D365FA245518304D4EEA11446753E2C95FE37A9929BD22479D3CC26234142F9C501497774B65F694E84EBFA25DF29EE5B0050872585C88E60BFA4942837FCEB1B947CD2D2D36A7EE04C5D55FA510469BFCFDDC082BB4108ED6EAFD6F296FB2494333BA';
wwv_flow_api.g_varchar2_table(175) := '9F4135449F37AA60297DD705677B7D112D5BF77BF44339FCBE8CA80F45AF716BEADFB62E804EBFE4448B6F97D31AFA63D5200D7503FEE3A83A55FC20F557A1FF00A227A1228BEA2895083BFB262A52FF008E644D47F58FD046C703C991757F703F48B76D';
wwv_flow_api.g_varchar2_table(176) := '131D844E6B7F7EA41B9676717E58255E5AA5F92B09A67951F70705D29401E98A9ED07B65AD376223321CBC8A8228A1B90BEA1961A57C30D342669B28C326A9C7DCEDBF92295311B80EE59095BA740FB18639F9A348C39A87A22D96DAE1ECC53420D1BEDA';
wwv_flow_api.g_varchar2_table(177) := 'C524E5E3262BF98FB46B2E7407D31281748341DE1E67C7F0F58C335E8881C9DD967ECC4748EE2A13A2ED741D35B701F6662BAF2A3D6039F003DC6C9DE394C2E7FD609728F1FE53F6CE41BA4CF9195CFF00898463AF0FFA99A1F7040DB2F604CBD2BBFF00';
wwv_flow_api.g_varchar2_table(178) := 'C518E56EB97E604653910BC89B998C56F97A87CD17AA4F702D320B4D372220EBCBAA7796A2F99E70E9085EB9DBE8C740CE9F918062F50997CB7D562100AD450190AE73F063F708B51D8C2160DA973D256816D59F44C86E0B2F9021DA7FB8A5946F7CB3F4';
wwv_flow_api.g_varchar2_table(179) := '11097DCA3A68C6130F0CCECCA0B305079D467C662DC763062CF3A3F11342367FA102C13743F34876AD79ABF4B3FF0050152E04ED703E666BCF2E1EC9A57D25F3BA2345526BA6AFF8004C8CAE685F8083003E74D7C525E02E604FA95B6BD9FA25EA9D3EF8';
wwv_flow_api.g_varchar2_table(180) := '40AE89CFABD8C75FEDFCCB5FE06CCD05F42B2FE0405F03F2D454AE52A0FD0C41B3FB4D04546977B462D3EDFE09AF7B69F64A14E8B9FD88E1DA3921F68B2576E45609DB8A6D1F9262FCAFCA4AC1EBBF713EA0DFA2315CFDD3D46804AF36875CB04697D581';
wwv_flow_api.g_varchar2_table(181) := '89DB4E688B277833E849771E945F8058950EBCDA17C5C55BA9BAFD525009E87F06358EDECFB81568770237D85FBC863F8EBF11E05FD06D79080D6B75F2B12C5D380E7E222EEB98AA3B34A5408D497E99100B1BC85F64CA6F2FFD2187D967AA962E575292';
wwv_flow_api.g_varchar2_table(182) := '856F700A98B5B669FB9A875C13D916747BD4FA62CD23AFEA12D1B8EE8E2F8ED2A7BA972BBE02175247FAAA56DABA7E4315ACE85AA694B0FE728BA98F216204E187444CB423A9F80311281B401AA9860A7C28E1F08220D72A112AEE7747D44250B9FE945E';
wwv_flow_api.g_varchar2_table(183) := 'D752A8FA672027220BF19404391FA1692EED74C504DDDE3F8807AFE6FA8AFE67B91C0BFCBFA81DBF08D17BBA8E3636E2C94F85B083C4946C08B4E4DAF5158163FF0044A6121DA597D41F30DC7F2CB27E42FC5A3187C029F16F57DB0C6D5AC18B49D83F82';
wwv_flow_api.g_varchar2_table(184) := '0152FDECB2882CDD3F52E0837BDC48A70F6A4FD4D50BC21942F747EE14F20652CEECB9A843B5D7E691C02DE561E292A60B6A3F32ABF329F77120E5C3ED41CC879FA8A2C82826AFF0E6551BA410753EF1F827D915FDC04BDC08A6819C997EA5575DA9F931';
wwv_flow_api.g_varchar2_table(185) := 'B71F26362799BF4CD0C7FADA079C7C262F080456F56451EA02FF001445963E90E05DE81F996907730F9860F480F9DA2DE7B9A9EC65010BD8475CFB8BF280D689BDE1F7F23FBC11497C7F1328AAF351A394E947E62C0D689F75C06ABE7F68BF970F44210A';
wwv_flow_api.g_varchar2_table(186) := 'BAD89119603AC16AE90B7F10F0EC65FB831775FD041A91779FC913303E4FB664826F43EAE1B613626BD4699BF854AD17F74C3A8DB3521F2EE88FDC1786D8A65A603B28986F7CD1FA9AA13B0AA025513653EC8B03BEBF8C099751BDA098F2A5FCD5C56CAF';
wwv_flow_api.g_varchar2_table(187) := 'A351D7AEECD59BBA7E89C8E6C30AA47B7E91D67CC8AEA9E78DF0C6D0E3980DEB812BD576812D87C793D42411A8D5F2928D27A4C2A5167CC2F95888A5E4667C0876D470AFE50D03CB37642DDC85B091B0ADF0A342E8161EA162A366FA11AB41CC19EA2165';
wwv_flow_api.g_varchar2_table(188) := 'EEFA952C9D0A9F6C331AE889181D809CB1C1E7F443E48A7E596353C22A68F72CD4ACDB0633E3801297D86182CCE36A080B9531A15DDC8FDB1F3A008C37DC007EE0747A43C2A570B38575871BE0DCB60F15EB3DA48C4CFCA8BA023B5D80B86AA1FD690159';
wwv_flow_api.g_varchar2_table(189) := 'EE0FCD0F70363BEA02F86E0252F6B4F25C0CAA5E79FE2CC6E6377BF2C338BA53FB5006B375EAA4D585EB5FCA9A59F69BA603AAFDCB1A9FCF930D3B5DBF523605BDA7F1A24FAB45AA3B0E1F2C8B2AEDABFA62172A83A21F5325FC6B2C41A01D51FCCA05A7';
wwv_flow_api.g_varchar2_table(190) := 'A24D2B7A9FEA0788BADF4617B6C9F71531D619FB59615DD3479AC757493FCCE476121EC6A7D91E71FC4C70663FF892E19026034ED8661C2FC7FD40B2F64262BA02653C3542C7623BED8996FAD0FBA82D06FF0082D1182F67D0B26617B64E16657B3FB262';
wwv_flow_api.g_varchar2_table(191) := '457F6B6A01A37BA7E65A7FB5B5894433E8C8552C2DD1F460B8ABF9D600FC04720BBDE1C71E3246CD8751FDCFCFDFA5C4B41F553D92CE8FA07EF1C981D557D2450C0DD1C7B27BB2283D811408FDBF7330846CF09E53BB4406AE3D5C46B53A14FDDC4152F4';
wwv_flow_api.g_varchar2_table(192) := '4BFCC51D9C3EC4A6D0F64317AFEC47E20A59D71C1E3FCA4221E69508C671D17E93434E84607A6777580560EA31660D764109CE9E458F2C0615C823D13082E7610A197754FA96688EAFEA40A8BBAC7C90E027DBF00258E7E1456095FE5571383FE3565C2C';
wwv_flow_api.g_varchar2_table(193) := '6CB3F171F659F5C3E65C617700F84829029CD8B8ACBDA9C0A67758A9B274FB0A636DA4EAFC50A647CE7DF931ED97867B1FAA825B6CE4826C0F7919CB08F74B932774235F6F309AC0605EC1F9254FF3BB4A4B3758BE58DC86B6BF4ACC8DB22CD174DFD475';
wwv_flow_api.g_varchar2_table(194) := '439586680EDC4A9A90F0FC4BD47D63515D3FBE0B16A53BAE8F5CC8439FF021ACB657B08B96C277207A83075A17D8440DF97FBA10DEEC7EB87CA732DFA84B56FA1F9860BFA0FA530BC71FB46ACBC841BEA236F1FDB2C72FBE4FC999675734F8B05ED9DD5F';
wwv_flow_api.g_varchar2_table(195) := '8804C322EB1BB93A193BBEAA7218B297FF0096918A7B93D128AA5B2CF68B763A5BF169BD084CC77B67A428760FAC93388EE151633EA3DC012134BA226B69BDABD35198EF530583D4A4A87A90FB115515DDFE461CF8BAFC24B1953B7E4B072E8D57C04D01';
wwv_flow_api.g_varchar2_table(196) := '2DC3DDCC4D93D6DFD265798E85FDD4DCF0BF696391CFC19023C9075A7F3168F44AFEE7D1F6BE8816D0761FE08E8173A915B77F7C5FA82EAEC48358C874976AFC4B7D037F9819511BDFF244A54F91EA220A9AC21B03B277C9EA1AF37220BC4DD90174D00A';
wwv_flow_api.g_varchar2_table(197) := 'D7D38AC283ADFE461CF0F97DC59C9DF0BD40055BD059CCC6E03ED61490AF9C5A8EE815EE2A605EA2860D8EC63CE9EA0251B03B024F7883F09BA1D4828693B9F4C34DE704E6936A1F31BDDCA7EA53C23700F50FAD43F32D1556EA0F56C0618766DEDCC4FD';
wwv_flow_api.g_varchar2_table(198) := 'C9BF242E37B717EC10AAABC07D240B8EFE395A3FCBFEC663452B4589387A1C803D4146C95385DDBAE163C0D11FDBA4C001B2FC2637BC265C195CF20309B941D940195BA0128E61BD229AAE97073BE1FEA749F307BE6B63D4B61F346C10977217B5C32D2C';
wwv_flow_api.g_varchar2_table(199) := 'E8007821A83BAB87E4CC4CAFEB4B558C6DEB7F9A6162B767F104E1D8C7F790B07D98D9BF0250D56E7F98AD67C42CA794EC1172641B1C8DBD7F28B5507F4C546BF0059126CBBB23D30C09BE447E4807AC7F0C8F3F3BFA934BA0D54FB931A1637398853B09';
wwv_flow_api.g_varchar2_table(200) := 'FA89AD46E90FB63AF59FBB14587B64F71594F471CB1779F9D10B474823E6A99759D13EA53DE6C830AE8D76FE0C5810DFF2D13C71E4AF96230794D27DF078FF00172C964B3FC3C733D5C412D6B6F520DABFBA7D4CCFCC7D204D3DBD4FA1872BB4FDA1580F';
wwv_flow_api.g_varchar2_table(201) := 'A307B429431BAFDA28576F6CA04ADDF07D45852EC3F230C2D6777EE312FB324374761F8819637681843F67ECC49B82A542EB4439DB79BF698EEA5A0BEF161A9BFF00D1948D9150AB0DD5A4CF93B94979C1BAAF5534AE88BA836DF0D3F570AA8EF405B7F4';
wwv_flow_api.g_varchar2_table(202) := 'EC92A0BE0B7DC15B73B9F985F6F74136B118B30819B21836FD017A217E483EDCC2AB13A5CF691AA3AA0FCAC247C233E98A3224CC22811BB29EFC91C2FA4267857F81E15C2B4C768ACB6B749A92D0267F28E418BD6D007752F5E739846AC4F52A0337B1ED';
wwv_flow_api.g_varchar2_table(203) := '8483D103D10A452E5944B9C2599401700941F885F2BA96130F8DFDC68D0F7BEC96DD52EBFE71534785216779BBFDCE4ADC9C3DDC0005126ECEC418A1783F63145BE027D10C7510B7E47F489FC853060047157D950FA0B3923F330BC3B5443A5E5301F620';
wwv_flow_api.g_varchar2_table(204) := '1284342FC87EA36FE63F509D1036FD546B08EA33E84A25939B5C340D6C911D9F0BE048D117739FB4717E50833DCCDFD54145B0A4047E6FFDD4FFC40031110001030106040504020301000000000001000211030412213151611020418105303291A11322';
wwv_flow_api.g_varchar2_table(205) := '4271B1F014233463FFDA0008010201013F00F2BBAC3CC851C3B7930B0F347260A072C8E582AA3EE0549E5E0CA8E23C980A177E4850A160B0E354CBCAA62EB02952A79E796147342858AC0029AC0E971199F2679654F0C792562B1E2F330D1D54447971C7';
wwv_flow_api.g_varchar2_table(206) := 'BF01E4CC205C25FBFC26B8112148582EFE54852A7C99D93CE4D1D5400213DA5865B92A7543B039F951E71A90E250AE7A89408737B21EBC3552A54F0303342AB0989E1879EFCA0665556C06C69C18E201C7A260FBC7EF96B7A385332C1CA7840F25BF738B';
wwv_flow_api.g_varchar2_table(207) := '9100885558D6810AA0796FD84077C2B257352ADC7B6EBDB9B76D472B9A1CD21398E6892A8BC65C254A2F0DCD35E1F30A38C719E2F384752808109EFBA1572E639D5EF9DDBD2026B838023222414D711E35446B48F0EFC66156AA483742FF0020E8ACD5DD';
wwv_flow_api.g_varchar2_table(208) := 'F56E9260A24018909D50C7DA0A01CE3D4AA6CBA37F22ADB7E955730B6404DB7D020492135EC73E6F0CB01C1EEBCE95E2D6A14E89A43D4F1F0BC32B7D4B23356E05013E3540FF00E6796B3A04226012B554BD6D54DA089389E0206439FB70B77FD2FECA93';
wwv_flow_api.g_varchar2_table(209) := '6F3B1C86253DE5CE25599D54BC00E310AAD514DB2BC5EAFD5AD4DF763EC8560B73ACAF320961CC2F0CB40B5F89BAA5D80DA501428DF812066AA3AF3A5577FE3C28FAC2A0731CB8724852BC499FED6BB50853BB4EE97005D99D935966666E051B4D26FA55';
wwv_flow_api.g_varchar2_table(210) := '5ADF51D2485E2025B4CEE787870C6A11B265A2BB7D350AA56BB5756823538236B760030EE42BEC2D9337B74C01CE8255AB0AEE8DB8589A0D533A20D03203970E6B5D20F6024E45557173C9529E0B9A4028D278E8AD00DC19E6994DEF2035A49D958AC8FA';
wwv_flow_api.g_varchar2_table(211) := '2C26A90D9EE50AAC67A1B2752BFCAA9B216BA83442D6F26034270AAF749742C4667851AE28B8B8827084DF10A073909B69A0ECAA041EC764E079EF0DD17C2BF78890AD3662C379B25A7E1426537BCC0695F46AC910AED168FB8DED864BEAC08600D1B299';
wwv_flow_api.g_varchar2_table(212) := 'E03831E18325F586851A8345F5139F2238CE850AD586551DEEAC75EABAB00E792238608908807A95109EA98EA8890AA59A8DE0E03B745761B8055DEE7BBD2E00285DB8004E40ABAED0ABAE8C941D141E59E00AB0FF00D03F47844EBF0AE9441511D02736';
wwv_flow_api.g_varchar2_table(213) := 'F2BA0003057469F08857760834E89D66A4E74B9A253AC6C3177F84FB29030683B4A753AAD68FF49083C831EFFD0A6A671FCA3527323F5251730E2437E5430CCB47EC4A2C8EA38428E3E1E26BFE9BC2F1D9033D02EC3D961A2EC14F09214EA813D119D14E';
wwv_flow_api.g_varchar2_table(214) := 'C50C11A9B7CAC0FE213ECF49D9B7BA7589872711DD1B13FF00179468D7180638EE4A2CA80E323589571AED51610731C43499804AF0F61697B883A2BDB15FA9467FA163D6146CBD94EC110BB04372161A1501770AE02AE9FE95775FE5437FA541D4AC50C7';
wwv_flow_api.g_varchar2_table(215) := '3851B0469D339B02367A67A1F746CE464611B3BB59F609D46A5E0D6B48DE01549818C01405055DDD619143B29D56083468AE6C1060570AC1608A82A141401D916A31B26F6F6523AAFB50034443740B04214A81A058281A280801B73434A21BB22142EE89';
wwv_flow_api.g_varchar2_table(216) := '27540153B7C29DCAEDC3142F6EAEA8446CA361EDCA5C02BE3457F645EA773EEA5CB1DD05794ACFF15ECB1DBD9025127641C517292BDD4FEFDD4AC5772895251587261BFB2EE560755037F65DCFB2EC540D146C110142857428575169574A88D57BA81A15';
wwv_flow_api.g_varchar2_table(217) := '1B7C2C7740EC51EFC335034577650A176282EBEA2A0EAA370A0A876EB1DD093AA9D908E123C8766BA94FC87019A76698068AA607047D2BF14175503452752AF3B52A4C66813826A7A3926F2FFFC4003E1100010302030603060403070500000000010002';
wwv_flow_api.g_varchar2_table(218) := '1103210412510510314161917181A11320223242520662B1C1141643232435B2D1F0F13353548292FFDA0008010301013F0081AA90ADEE489420A8570A4ABAEC8792ECBB7B8377252B315994AF352774A95214F4448D029F05255F551D51082BA83BEDBA';
wwv_flow_api.g_varchar2_table(219) := '55D5F785752742A4AF33BE0A87285055D4A90A8D2150F455E9B6991054EE9475F7204FB92507159CAEEADA15214ACC5665254957DF866E5A43ADCAAE73D52B29594ACA546E953BA1428DD1BA4A2EF7A5665640124009F54D38634F00A54A90A42B285088';
wwv_flow_api.g_varchar2_table(220) := '406E83D57750B2A80AC8C2B20A165EA880ACA3C142A232873CF216F1524C92ADA283EE8DD6844A9DD281E8A7A23316DD1EEC2841A4C270690297303D53A9B9A6082A1CBE20A4A9F78F9A83D77653AA0D2B2F52A1414495752549DC015075549B12F3C022';
wwv_flow_api.g_varchar2_table(221) := '49332A93DB5065744AAD44B2E088527553BC23BE54A047B90A0280BCB740DC15D61B06CAAC01CF88371CD54D914C9191E5B6F14FA6EA751CD9BB4A2DFECAFA2CA16551B9AD738C34494EC0E29ADCC6998857574370B6EBABEE80A028565695652A94925C';
wwv_flow_api.g_varchar2_table(222) := '78342C3D432EBDE550C508CAF37D5639B4CB59F00927E6550C31DE1EEE06A1A75F340E0A9D7A750C5E62EB194852C43DA384C8F746E93BA375F741441DCFF829B59CCDCA0482082A8547BC994DAA080C7DDBEAB174832897B5D99878151D5421B98E731C';
wwv_flow_api.g_varchar2_table(223) := '08542BB43C16F258ECF55FED3942850A004CA6E7986829F49D4E262EA4A95254CA214284242954C02E922C2E9CECCE24F32A933DA1E8A88616B69068E879CA2209066C55600ECAABD1E141DF7401244054E8B98337130BF893F62243898690835CE36692';
wwv_flow_api.g_varchar2_table(224) := '9945B98678F044B298E402AD5B39E8A54787BD83D8631783A759B572B8CF2D0AABB031EC272B4386A0A7D0AD4E941A6EE3F11E5650A8D3CAC02CB0140BAA673C1A7D5636964AEEFCD70AAFF85551F9C282A50DD86602E2ED1180092A0495487F68D559EE';
wwv_flow_api.g_varchar2_table(225) := '6BB28B0E8BBA9278CEEF25E455D5D5D5F55E6B6099D9947A13FAAC65634E890DF9DE72B7C4AC3D2651A2C6682EB6B3708DC3B89A4C2F261A604AC1E0DD89AB9470FA8E8A8E03F826B99ED0BF33A562B0C2BB45E1C3815B468BA8600305E5F78598A92A50';
wwv_flow_api.g_varchar2_table(226) := '0E7700A934B18073588A87E50A4AA198D40B14D3F095254953BA4EF82A1CB295F866A8384A94CFD2E98F14FC51AB8935451A8F65390D007D4AAD7DAB58C3293D83C213764E36A106A1CB3A99584C3D1C2D30C0F04F33A9589821BBB0E07C4AAECFC05413';
wwv_flow_api.g_varchar2_table(227) := '530ECF18858BD95B21A7E1A8F6BBED6994DD974A5C4D6681C838DFD11A6F6D4CA1CDCB3C5AAA39CD6170692A5C4F35274599C2E2C8BDC4DC9DD3BA0FBFB2316EA159E1A09CEC8F3583A4DA341ACE7127A928B556A4E73601829D87AADFA7B201C0C194E7';
wwv_flow_api.g_varchar2_table(228) := '35A25CE002A38A710451A4E79278F009D82C46207F78AB0DFB5886C8C28B66A9DD3B63619D30E7855764E16830BEAD72D6854F6B6030CCF674A93DC3531758EAD4F118A7D56332B4C404634581C19C656F641C1A7292154FC3D8E67CB91FE07FD554D998';
wwv_flow_api.g_varchar2_table(229) := 'FA733867F694FA359919A939BE2085E4A54ABA92AEB21D4265224C484299A6090E83AAD97B51B8860A7548155B693F520E55B1787A026A5403F54768613235E1F33C00E28BF195ED4E90A6DFB9F73D9336753CD9AA9351DABB876419020085951648510B';
wwv_flow_api.g_varchar2_table(230) := '696CCAD8C7B62A86B1A3842FE5DA9FF7C7647F0D543FD71D97F2CBFF00F20765B3B627F095C5535B3588888406E2D06C44A760B06FBBB0F4CF8B42DB5B3F094702F7D3A2D6BA45C28573C935A4A0F2D119442CF3C1521C49559DC820482083041B442C3E';
wwv_flow_api.g_varchar2_table(231) := 'D6C68A4E6174CFD46E567CEF199E249E24AD9D87A387A777B1CF26642CC14853D539ED6FCCE011AAC1F5357B5A531984A0F69E0E5981988F74001704E123895B7FFC39FE2DDD316B0EEB303C40F5281683303D422E07813DD32A649E7E61672493D7508B';
wwv_flow_api.g_varchar2_table(232) := 'CEBEA9AE32483DAEB3F52B3B752A9ED2C55360653AAE002A7B66B89F69274F8951DAA1E407562CFCD96552C4612A5424E34388F108D163867971116363FE695970B246793D3214CC2408635E3A96B0A6D1AD4ED4DD500E26ED44E25AE043DF1CC10DFDA1';
wwv_flow_api.g_varchar2_table(233) := '32B66305A418DD2A4CEE9112BF10BC0C001F73C6EC8DEA8B6381424733DD10ED7B151D5CA06AA3A85941597427F445807194037914411F50441773F4428C7D51E48661FD474684AA3B4B154A032A5B480553DB98868875361F284CDB944FFD4A2D4DC6EC';
wwv_flow_api.g_varchar2_table(234) := 'F79CCEAB49A340CBF73299570CE1F006BA78660D5FC43E9C08601A081FBA6625A4025AE066C20A90A46A13EA5364173C347530BF11D763DB87A6C78372E593F3053A80502DD23CD5A244ACC6D250E92A0EA42042B7327B23D1A7C614B845C2CC7AFAA07A';
wwv_flow_api.g_varchar2_table(235) := '146A96C7EF2BDA0E9D9671CBFCAA5DAFA05239B41F440B79C784A36B8256633F399E89B88C437E5AAF1E69BB4312DB9733CD813768877CEC27C2C13769301F903234CC4FEAA963B0FECCD4A95413A66702B155CD6AEE78B0E426602976A7B959C2CE34F5';
wwv_flow_api.g_varchar2_table(236) := '284F100F95D3A4F194068BE3D3D0A2F70E27F40BDAEAE28D574F12BDA0FF0061098E1FA2977820614B7CD66F2F20B33475F208B875F041FE1DCA1985E0F9275F8CF78401E5FBA19C7FC7FAA25FF77E8817EA7D17C7AA39F4594E9E814BBEE2A5DAA93A95';
wwv_flow_api.g_varchar2_table(237) := '9DC058A2E71E654953BE0952F6F32135CF23EA283A3A20EF3562784201A39A242CBA3BD5653A0446AEED65010CBD11C834EC8BCA0E9E40269FCC549FCDDFDD6B095EC4F32BD975429F52A07081D9430738EE865D1A8924745ECE44A85FFB85FF00D7756D';
wwv_flow_api.g_varchar2_table(238) := '0F74437994034FDC7C91637FD94D62CA02EDD8200F4ECA3C3B221BA850346A0DE88060E47F5438D9412A4F443C971FF90BE2D477507F2F75F10E63D51718B47744741DD7811DD4BB53DD4F52839CB374F545C3AAF68616659D07846A0EAB34E8ADA8EEB3';
wwv_flow_api.g_varchar2_table(239) := '1FB8772B3F51DCAF83A2200E6D40F87AA8D00571A0599DAA2F3AA0F3D5662570FA878029DC6602B47C814E8C05668B642B3859987880A19D13A0736A2DD0A20EE876FBFBAD02382FA552E2549CDC53B82A64906E9E4EA551B83374DF9D7F511E07C10F95';
wwv_flow_api.g_varchar2_table(240) := '0719892B2B6DF0859193F2845AD9E0116883609FFB2A40404099E2AA131C778DDFFFD9';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784243123416151273)
,p_file_name=>'img/collaboration.jpg'
,p_mime_type=>'image/jpeg'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/img_ai_jpg
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := 'FFD8FFE000104A46494600010100000100010000FFDB008400060606060706070808070A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA70106060606070607080807';
wwv_flow_api.g_varchar2_table(2) := '0A0B0A0B0A0F0E0C0C0E0F1610111011101622151915151915221E241E1C1E241E362A26262A363E3432343E4C44444C5F5A5F7C7CA7FFC200110801A401A403012200021101031101FFC4001C0000030002030100000000000000000000000102030405';
wwv_flow_api.g_varchar2_table(3) := '060708FFDA0008010100000000864838B6124822D0050A5B723206503CD78D6246C4E2A122A2A8484E04D831A229B9549014C2DD28959A715895399B694848D500D84B2A13258DD31A005462B12A713624021A1B4E800529882A9580813B8C7434349A09';
wwv_flow_api.g_varchar2_table(4) := '2A1B498CA09A0534916E1D0D394E72E229354C96252A915286C638AA4A691C9F6FE95A4553094E2F1BB10E94527309B7509B01B8B6731C76B762EDDABE75A3BD3907490F112F2A10C91A5227640037B3820CBDCA3A0F6CE73CB706DEFD306C1296B20082';
wwv_flow_api.g_varchar2_table(5) := 'B0E414923A210E9E6EF3D2F5397EFF00D37CFB96F53F289DED8E496969CA7624998F6110B8CD6E3B5B5572BD9ECA121ABCFDF353CFB99F42E99D037F98F45F1CE5FB0F6FAA7ADC2F59D46222A3C5FB06EE4E2F86C4E2322C5B9EADC8325CD2DEEE1CE797';
wwv_flow_api.g_varchar2_table(6) := '71BDD3B5F8BEEECF63E0343B3EE754E233EC6D65AD7A412478A65958B2D65C58762B1ECE2F59DD100BBBF65EA9E65CE776C9E79B7B3B3A79F8ED4D7C6B2EC6F0DB4E49F11CCD45D5E048E4F8FD6E57D5F388327A7711E5FC8DFA4F9B565EEB9763070BC6';
wwv_flow_api.g_varchar2_table(7) := '71A96650F242548C7E23B3061C8F6752F1DF27C20762F5100CDEA1E49ADB97CBF01CD2E3F45776EE13ABC269E05C4E0DAC503873E219A1E2ABC9318F99C7C3DC577AEEC01EA9E25CAE4DEC3C96BEA61471F51ABC8E7B2DE7C32AD4AF0FCB2A72A6AF076A';
wwv_flow_api.g_varchar2_table(8) := 'EAAE669775EF4DAF4DF15E7B63B068E7EC3BBD7F84E312C59329253B82414F8866C4CB558A8AEC5A77C2113DDBBE0BD07CAFB24E9BC3A7CBF7DDFC1A9C3BE378840CC822652F11CD8E1959306507D9BACF7FF3CDDE3F6FD99AEC5A5BFAFAFA1338B8D7A5';
wwv_flow_api.g_varchar2_table(9) := 'B1D93558C11749492BC436270814AE9466E77B9ED78F43F65DDDDE53AE71BDA7BA6B715C268CB9060D36E924925E1F9AA2A14DCE6C32F7FD2F96F37EAA7A1F73E5B853578CE7BD2F527572F1BC6E86169D4AA2D24A43C514E458ADCED4E08A5C87A761F2';
wwv_flow_api.g_varchar2_table(10) := '55D93DA38696E7855D931EA46FDEBDA0A9545092908E1B81E2F435A2EF044CB46C7A8F9BE0EE5DD1A1D2D6C793690C029C2A6C494B55925A00C1E79ADA3C6C064ED5B7D1FD7F9207684D020B4A946406A490AB4009F55E89C9F6CC5E7BAC3CBCD715EC39';
wwv_flow_api.g_varchar2_table(11) := '80C884C409B6826C2A4991D5C920C1CA357CEFADA3B57A40019521081BA5225989A94450644E400242F375FF0037E2BB57A40D2BC8434082C4A43293532262B19250102DFAE39F13B7B2C456593B377ED2EBDD3B016A1A556E5CA94DAA6310AD4BDB34E5';
wwv_flow_api.g_varchar2_table(12) := 'B53424F2C9E9FDF4E85F39FB5779C3C6753EB747278F4D124854D053450A37A3594304390C81CD7B36E7CF5E35EF3EE31E25E69EA3DFF3EBECBD0E07AA71682D5228430E475758AC631210EE4ACFD8BAEF9AFD19E83E7BF3A69FD0FDCEF9E04E3CEBCE65';
wwv_flow_api.g_varchar2_table(13) := 'D80AD12B2F25A38C931942A9965A60C7CAF75C9F3B60F7FEC1DB1A60B1F94F4AA6511435B99F8E6EA0C72C2BD176BCD705201DA5397B2F67E7F99C809F01C7E55D47A556DE2C2AAB76F4B0D050F12542F42F41E1FE6EE5F9CD68066BF61F68DA04C00407';
wwv_flow_api.g_varchar2_table(14) := '947CEBEA5BD74E756114D6598BC537EC7CF705D37B2F90F97FD51DABE6CF36F68F77E1BE69F44F780000100703F19FADE4131BBC741931A207DD3D4B32F03F1EEDDEFBA1A3E03DF7D72FA5F8876EF61EEBC8800090F07CAFD833CA1BBB9806A9E24CE63D';
wwv_flow_api.g_varchar2_table(15) := '4BB079AF46D8F7BE17E71E9DDCFE9FE23CF347CE7AFC7AAFABF6D00042E2BE7BDBCF25C5678AC48C903202F1F70F4EDCC3E3FE13F51F35E3FD2B83F6FF0061E2BE69E3B8EE1FE87F5F00D7E12676BCBFAF640A666462932E2C84437587B2FA4F3C62F953';
wwv_flow_api.g_varchar2_table(16) := 'DFB7799F9A743DDF5FA57B76CF57F9BB86FA96127BFCDE731FCF2AD15930ED29C216ACC42292C5CA76C9D2F42E4FA8F8D7D38BCBFE6FFABBB99A1E21EF590011E7BE57C1F67A1D3C7B38102CF4B08869AC749F3BDFBB0EDF91FB0078D77FC5C6F0BE89C8';
wwv_flow_api.g_varchar2_table(17) := 'BAC1C7707D67AAEB733EA9E25554D61CAB1D8F3AC59561055325263EC5A3CCE2E2F8B4297B38B2E3992689A0A2B16589C8190CD3184078D5548D301A92E152AB9505116AC9A9BC3768CE95E280C911364B1CB60A5E5C2A8BA94904BBB78DAC9202C93170';
wwv_flow_api.g_varchar2_table(18) := 'C56A25B96C572C758C9545DC270322AED5418F3C20A558D85E204E6950A90A5B98C864CB806A5D62C887922676A12142C8002429A4EC24AC7494D555CC5382A69E39B6E7660C76F04E44364892B9740990DC0B25E689250E326292DA7B3046588C768608';
wwv_flow_api.g_varchar2_table(19) := '21D4B18D90322AB2E489C72642544991D64CA2C794C786A41A412C592E64121836F64888753872EB89D67BB5729E2494BC938C2531E525029CA4D55E69231A26EF044B797625B1981E324CB09A84CBBB8924979633176B1A58A92CF8712CB3B4A84ADE0C';
wwv_flow_api.g_varchar2_table(20) := '98F1D3AC720A5959A491C27719A1E670F145BC74B0990D9328B064AC59235E9DE349C08796A25A1E49929E54EB043CBFFFC4001A010101000301010000000000000000000000010203040506FFDA0008010210000000DA020A960A0008144140020288D1';
wwv_flow_api.g_varchar2_table(21) := 'C1EB80042C30CF4797A7CDF6FD8A229315A1E778BD9E27D2781F4DF3AF6BD3DA393298977EC8F27E3BEB3E73EB79663CADFEDEF4720329D193E634FD57CB7BFE4F9AF627A3DC272065265D17E7BAF1F2B77A5DFE5F4F7E548E40B931BD3F3FB7A7BFCFF0';
wwv_flow_api.g_varchar2_table(22) := '76F6FAFD0A47202ED69E9F173F1FCAF7FD1DFDE2A1A70845DDA347A4E6F3377A1BA81144D175B4F56E59628114135E8CFA0A254A2283573F605985B4A42869D5D72C2B0C294B92871ECE84AC6D13190ACEF3493AB20C715B2CC40BAFA0018E0AC7292819';
wwv_flow_api.g_varchar2_table(23) := 'E45404D65C7263330B995160898A2DC56A6C0520000005400250000004A00A40002C08B4408A054096881140A805B082280A8FFFC4001A010101000301010000000000000000000000010203040506FFDA0008010310000000F1C0000152A000002C5400';
wwv_flow_api.g_varchar2_table(24) := '0067BF940160059B3A72EDE2E052299ECCB4EB0E8EAD3E97076799D6E7E6C47BFAB66663E5729D1EAF1F4F0B3BD6E7F3F01F420C32F174BD0E8F27D5F37B3A35F3B9F5C1F421AF3BAFC7D5DD968EDD5CB876EBE3960FA10689BF5F87DD34EAEBEFC38F97';
wwv_flow_api.g_varchar2_table(25) := '003E8413CFC7D3F0F6EEEEC39356BD001E9F46CAA9E67A7C1E737F761C7AA0006CF530EC6AE4F3800000E8F4DE2000001967AB2C46DF439B5B44B002DCB5817B766CC70B9B571600D8C20DDA436EEDDBAB0D7C18E74C04756E9AF1CA3B96175E7E39413A';
wwv_flow_api.g_varchar2_table(26) := '7BB4B1CD8E772CA98F99AD560973F4E6B58CC8AE0D52AC581B3A3A31D9A73D5D170D3AB6F0829086594C0A41401000A82801058150A8B622C0032810C8420A42D41168841485A822DB088160AB0FFFC40047100001020305040508080503030500000001';
wwv_flow_api.g_varchar2_table(27) := '02030004110512213141102051611322303271143342528191A1B1061523405362C1D1244372829216A2E12550633473B2C2F0FFDA0008010100013F01EC06E834FB88ED44260C6914C22906040CA29CFB11F761F70D234D860469FF007E3FF6BAC0EC4C';
wwv_flow_api.g_varchar2_table(28) := '0FBF00684D308BAAA034C0F69A7DFC6FE27286E4DE5D30A41936E5D94B2AEB2C9BEBFD044C4C075C294F751BA37C9FB9D3B72C5C974129AB8EF747040D7DB0EB61BA26BD6D796C62414B22F024FAA21322867CE2D0DF2CD5F0876D293961F647ADEB1C55';
wwv_flow_api.g_varchar2_table(29) := 'EC1A44D5A4B7414A4501CCEA6191D5AF18A6E0CE0FDC2BF7265A2EAE8386E252A51A015896B3026EBB34688D11AAA272710D952D54BC7248F978436A52EFAD471262499AF5E9C931695A1E403C9D9A5FA75D50A79F7412B7091E3010A56423A1C6AA31A6';
wwv_flow_api.g_varchar2_table(30) := 'E8EC74FBCB682E2D2819A8D20B4869D7AEEAE2BE70F5DE997778EC6254AC5E56021B699944A6A8AB84542744F8F389EB4E8A3455F70FB842D6A5A8A946A4C2137520448228B6AF6484DE3FDB168385D9B7944FA50D374153B1B65C73BA9F6C790ABD7106';
wwv_flow_api.g_varchar2_table(31) := '49CD140C2D87939A7DDDA216858AA1414391AEEA94948AA880389854FCA27F9C3D98FCA1569CA01DE27D90AB5DAAE0D2CC1B67833F18FAE1EFC3447D72F7E1A61AB5D8577D251F184388713790A04763AEC6DB5B868911674B250F23975947FA718997AE';
wwv_flow_api.g_varchar2_table(32) := '21C74F8FB4C346A9F6C4BB5D2398E4338954A6F95A8755B17BC62D39C554A6F75D7893CB636CEA6194DE75039C2DC4CB4A38EAB358A0F0840BEBA9F13B1894C94B19E4984CA4C11E6E839E1F38F2557E2343FBC409378F76EABC1423C8A67D41FE421720';
wwv_flow_api.g_varchar2_table(33) := '15E74B49F1563F085484B2079D52CF0180F7C2D8741F379F0C629D82491429241844FCD251E775C8E31F5C3C3BCDA0F8611F5CAF4647BE1CB526D595D4F80852D4B3551A9802A445208830445D8A43130EB0AAA154E2348959944CB4143056A3B161A2E2';
wwv_flow_api.g_varchar2_table(34) := 'B96B00048A010AFE1D829FE62C75BF2A62D398BCA0D2724E2AF18645111269A355E261243726F28FA4A09F7630EACBCF2958E2610DA53E3B2CF4245E7549AE89E11694E99872E03500FBCC368BA9E712AD348ABAFAAEA4643530E5B8847558047861F1CE';
wwv_flow_api.g_varchar2_table(35) := '1EB4E69673BBF13F18F297FF00197EF302726BF14FB63EB09B1E98F70816A4C7AA8F740B4A64E4847C63CA26140DE5FB00DD3B8207185630338D638408A611AC1CE303B0E62261A0CCC38807BA70865F725DC0B49FF9861E43CD85A0FF00C760CA2E3691';
wwv_flow_api.g_varchar2_table(36) := 'EF86D2961097578A8F9B4FEA62726D2D82A59BCB56438C252A7166BC713030112FE651E116C3FD04B34C8CEEE3FDD898613D5AEC6DB2E2C2444CBEA3FC3CB8269DE22112C86BCEAB1E0338E9AEF9B404F3CCC2C059AAB130584E860B2BE51D0B9C23A273';
wwv_flow_api.g_varchar2_table(37) := '840617CA030353000197640C0381D823581981B2B841EF650B4914E62018BD1289BF32D57206F1F018C3AB2E38B59F48D764A4CAA59CBD983DE108710E242D06A0EF245540738954256E8BDDD482A3E022726EEDE7578A8E422FBAF3D7CA8D78F0800245';
wwv_flow_api.g_varchar2_table(38) := '06C94427A34AD7DC42413CF944FCC19C9C52B4819436DAD66894C3726DA5AA29E4A789E3EE84B1214BA99B6C0E02BFA40B3A50F75D6BDB51F3872CC0815E8AA9F5926A20C8B7A28885CA3A9C857C228467B7A373D457BA0A5433046D39EF98A6300E060E';
wwv_flow_api.g_varchar2_table(39) := '4613073DA94DEAF2107330B55427908148BB18B32EA3E93BD51FD3AEE484E793AEEA8F5159F2E7BCD9A388FEA10C60C4D119DD48F798B49DBF3053A2052181D4AF1D894DE501C4C5A73BD512AD77477A18655A26A4C5C6DBEF9A9F547EB1E52EFA3448E0';
wwv_flow_api.g_varchar2_table(40) := '042CDFEF63E305941E5087A665FBAAC38691276A8A8EBF46BF818E925DDF38DDC3EB23F68F2527CDBADA878D0FC61C907A955317BC05EF947921AF5649F3FD840FF7521D7C4BE6D201F542D24FFB6B08B401CDA50854E923040F6C2D6166B7427C36AB65';
wwv_flow_api.g_varchar2_table(41) := '2BBA98106065B6B8424AB4826AAAF3850F76C9163CA1E09390C4F844EBDD2BEA23BA304F80D9517694D73DB674FD68CBA7920FE9BCC9FE1A67C11F389855E7DD3F9CC2451206C6BECD2B78FA397330D4A1AF4AF1A138D358FB722EB4D1427E263C99E03B';
wwv_flow_api.g_varchar2_table(42) := '9052A19823716C8F46133132C8002C8F8C393932E66E9F661F28438E20F514A079183E52E8A38EAC8E64984A128186E0CE09EC040CA151A6C10613818A57210BA0BB86CB25603AE23552308D206DAEC93B528021FF0062FF007806A2BB92C7F8778FFE24';
wwv_flow_api.g_varchar2_table(43) := 'FCC40C56399D8DB4B70D07BE0B92CCB691DEA70C718FADCB75E8E5FDAAC6136FAFD2653EE4FED0CDA321338293D1AB961F08765D494D70520E4A1943928D2B2EA9E50E4AB88FCC396E1420FA220048C86CD3706707B1D06E980AA0CB61C4010450C24A92';
wwv_flow_api.g_varchar2_table(44) := '4292AA110D34C4D1C15717E92743FD31D3B0937532C29ADEADEFD23A265FF33D55FE19D7C0C11983818AE148C76595326F740ACB34FEDB8855C917D5FF00807EF0CA6BD6AE508645DBEE1A27E2616F150BA91753C3694A4E6214CFAB12569CCCA1A77D07';
wwv_flow_api.g_varchar2_table(45) := 'BC85434EC94D62C3C949FC370DD3ECE31E4933F84A872455FCC4363FA949063EAC04E0D24F8281F91873C91A5DD71170F05248F9C1F23A57A9EC858933DD511EFF00B87082372B094D53EDD891B524A48A6063A313C82B48A3E3BC3D78054DAC1182927E';
wwv_flow_api.g_varchar2_table(46) := '513B26265B0F35DFBB5F18BAABD775AC3F2EE30101645558DDAE23C764BB81B7DA5E8142BB34D93EB29950D2735903DD0CCB746055056BD10057DF06427DD3796D2878831E40E8D530A9478695F08295273046D53615E30B69634C23A57C2697D6070AC6';
wwv_flow_api.g_varchar2_table(47) := '75E30965479421F7D09BBD2A949F555D61EE3D80AC6BD86BB08CA34DC070236F1DAD3CB656168342226929986FCA9A1FFBA9E078C482EFCA35C853DD843AD8BAB5A1B4F4B4374D31AC28A8A895135D6BB655CE925DA5714EC9645F793CB1898750DBB78A';
wwv_flow_api.g_varchar2_table(48) := '6FAE9D5034872726B1BA9B80E74C4FBE3CA6653889873FC8C4A5B0BA844DD5C47AFE9A7F78522894AD2A0B6D5DD58C8C1008C4561726DABBBD587259D46951C46C269DA0ECB58D469148A08A6E69BB2EFA985D4620E0A4E84449743D00E88F56A7D9CB65';
wwv_flow_api.g_varchar2_table(49) := 'AB2FD1BC1C192FE7B6C776ADADBF54D47B6287404C5F12C9294E2E1CF94624EC5B415E3052539C59F68AE5144117D9577D1FA8E70DA5A994DF9573A41AA725A7C4428841BAA201E07080B49C8D7C31F940690F1C187147936A83672B49374FC3E748765F';
wwv_flow_api.g_varchar2_table(50) := 'A2EF484CF8DD3482ED9EBD4A0F8185B74C410A4F11F7271A71B55D5A483B7483B0183B2BF668D876611844B4CAE59754E20E638C4BCCB5309AA0F88D444F31D34B2C6A311ECDB659509C68271BD5040824309BA9EFEA786EA921428616D14F84254506F2';
wwv_flow_api.g_varchar2_table(51) := '4904644186ED9B5109A09B5FB7ADF3872D6B4DCEF4DB83FA4DDF94796CFB98199795FDE62E2D7DF5930DA96DF716A4F8185B8E386AB5951E2713F735A10B1452411C0E30BB32588376A9AF0FF985D8CBF41D07C7085D9B389FE5D7C0C1959A19B2BFF18E';
wwv_flow_api.g_varchar2_table(52) := '85DAF9B5FBA2E2EBDC54742F7E1AFDC63A07BF097EE30BA8001AC0AD229BAD3AE32B0B41A18949C6E653C16334C4DB65A98713CF0F086D95BAB421BEB2D5E88871E6ECC6D4C4BA82A60F9D747A3F95300DE483C77CB483CA3A0FCD0194F8C0C378FDC387';
wwv_flow_api.g_varchar2_table(53) := '62E3886D054B551222667585ABA92C8A6A54313EE809917725A9A573EB261C947902F8A2D1EB2711196E216A42829268442C2AD04B5D1A6AF8C149E238C3AEB566B6A625D57A61428EBC3D1FCA9D928499563FA076C7EE877ED461E790DF478DD26A9812';
wwv_flow_api.g_varchar2_table(54) := 'D304D032BFF130DD9736BCC04F898949032CBBDD31386229844DD98874DF6E8957C0C3AD2DA5942D343B8DB8B6D695A1452A19111E4A5F6BA6607F52381E50DB2B71610906F57DD0DA0210840F45207BB747DF4F68F4BB4F26EB89AC4DD9AEB35523AE8F';
wwv_flow_api.g_varchar2_table(55) := '88DCB21C29985274527E5F7438ED0713D98EDD0D29C3865A9E113F67CA3E7EC93755EBFADE30FC9CC31DF4757D6196CB21359951E08FBB8ECC76CDB65C352689199875DA8BA8C11F3DAE48CAB9DE6857961F286586994DD6D341D959921E54E28AC9B89C';
wwv_flow_api.g_varchar2_table(56) := 'F9F28FAA2CFF00C2FF007185D87287BAA5A4F8D61FB0DF48AB6E05F2C8C38CBAD2AEB88293CF70EE8ECC76AD357BACAC1021C76F0BA91440C876A765824742F0D6FE3E1B6D7B63C8C2928EF245547843D6E4D3AF748AA1C75CE916233236830B5949343C';
wwv_flow_api.g_varchar2_table(57) := '699C7D4F67FE11FF002306C6923A2C781FDE1CB05B27ECDE23C45626ECD7E59379574A6B983FBEE265268E52EE7F8985CB4CB62AB65607120FDD9B6852FAF047CE1C74ACF048C86CD7B6919C32AF85D2A93828728626197D379B582367D2A53EC4CD5B34';
wwv_flow_api.g_varchar2_table(58) := 'BE538FB23A769428E322BEB27AA7F68FA1C1B097FA2528A4E75E3B14A4A52544D00CCC5B1F4ABA22B665463EB40B71E7160CC0BDF9AB166C8A67AF90ED1229A56B5866C6936FBC0ACF387A6A5A4E8DB6D82B3936818FC2129B4A6715AFC9D1EAA71547D5';
wwv_flow_api.g_varchar2_table(59) := '72EAF3AA75CFEA598365487E0FC4C2EC4935657D3ED876C27879A752AF1C22624E625CFDA228343A6F0ECD2D2502FBBEC4F1871C52CE3EC1F726DC5B6ABC85149E22136C4F270BE0F888B41C5DA340F1186541942EC77EF9BAB411C4C7D1BB3FC8A479B8';
wwv_flow_api.g_varchar2_table(60) := '6B5D9F4926972F26283035AFB20CFCBBEAABD29ED071FD216BB3BD16DEF0C3FE63E8A06FC91C5377AEE0057945A132E328421A1575C344C4948A25D3795D6755DE59DE5252A0428541CC44FD8F81725FDA8FDB746D1BB584254A5500C63ECD9CFACBE1A0';
wwv_flow_api.g_varchar2_table(61) := '85294A35271DD3BB4ECC67B2567A6657CDAB0F54E50D5BCD1C1D6549E63189D7ACBB425CB4E3F4E7430F58CB438434EA549AEB840B21F27ACB401CB18B0DD9695965A54E211D6C0784345B99B4BA64381496D9A7B49EC2FA3D6116C4A069EE9503A8BCF9';
wwv_flow_api.g_varchar2_table(62) := '2B7C6EA582A178F553C4C74886D252D571CD5B8041CFB093B150A692B7D46AA15BA21FB09923EC5652781C443CCB8CB850E268A1D8273DC4A54A340093CA18B226DDEF26E0FCDFB43561323CE3AA578610DD9922818300F8E3094A500252000341BCEB93';
wwv_flow_api.g_varchar2_table(63) := '8E28A18404019B8BFD041B21B70D5F7DD715E302C690FC33FE460D8D214C1047828C4CD88FB78B2AE9070C8C6BB3A34ABCDABD8703052A4E608DC0951380AC0975E6BEA8E717D96FB89BC78985AD6BC546BBA0C1C778EC91B6528425A7C1C050287EB0D3';
wwv_flow_api.g_varchar2_table(64) := 'AD3A9BEDAC28711168C9F953141DF4E28FDA1CB44B0E143F2EB463A63FB43130D3E9AA155E5A886E5A61C15432B50E204292B41A29241E07706C5BADA0A429542A341CE2CF95F2A9808268902AA869969A4DD6D0123976F6FC9DDABE9182C10AA71A45CB';
wwv_flow_api.g_varchar2_table(65) := '3978F4EE279115D8979D4E4B31D31D5B6CFB203C9FC14474C3469BF742A61E3E9D3C22A4E676EBB8983B30E114DB23212A861A5DC0A5148378E39C2D865CEFB485788061EB2649DFE5DC3F970876CF9D9025D61CAA466467ED11276CB0EA68F10DAFE062';
wwv_flow_api.g_varchar2_table(66) := 'DDBF32F3A654E057EFC22B3128E216A6AE107319111609579339EADFC22625999945C713E075116D353F2AF740DA7FB8474934D2AF74A6B5D175F7C7D1F9E6261CE8DF6504934C6132EC23B8D207B2266CA95787553715C5316CC9BCC4D294EB811740BB';
wwv_flow_api.g_varchar2_table(67) := 'CC8E11F472D1696F02481793754381FB85A6DF4922F0A642BEE8989575B7DC486D54AE141A6E0DCD213C4C1A8DC0372A76D9D6A740034EE2DE87D5842D0E24290A041D46DFA4566250B0B42D4DA4D4D78718F2879A156E76FF00235FFED166CD89E7532E';
wwv_flow_api.g_varchar2_table(68) := 'E2002AA0AE63134CA11664CB6D84373EA481A04C373D372B34199C20A4FA7FAC7D249344DC97488292A109B19DBB8BA9BDC22C0B39A969AE9E61F48BB0E5B4D568D32B73E109B698AD1D69C6CF847D21FAB271A6DD2E83733CC611E5ECB44F93CB247051';
wwv_flow_api.g_varchar2_table(69) := 'CE243E964DCB8BAE20293F2892FA4729308AA81079630CCDCBBFE6DD49E5AF6472DAE26FB6B4FAC923DF1333E99772E16C9C2BB065BC323070D61470DDA408C20F2DC95997659779B5788391892B45A9AEAF757EAFEDB2D85A67879232853841EB11A690';
wwv_flow_api.g_varchar2_table(70) := 'AFA28BE8FF00F4E3D8BC62C7B2E5A4672AF9B84622FC0208C22D0951332EA4D3AC31478C4E19D144B08F13A8F7C2D369B442D65CC39D62C9B4C2DE1D2B495148AD3430D290A6D0A40EA94823DB13B3524D26E3E02ABE852B0F58867314B171BAD425C313';
wwv_flow_api.g_varchar2_table(71) := '5F459C5A475810918212690BB19B975AFA50E1A7A1AC17DC6C071A612D0391CCFC605AB3493894ABD9FB459D6FBEB1D5749206285E31276B32FD12BEA2FE07B37E76565FCE382BEAE66268305E5DE1A9A546ED368184019C2A9076D22B15819EEA60E712';
wwv_flow_api.g_varchar2_table(72) := '3E5B3854854CAC3491D735F8432C34C2021B4D06C71B6DD4DD5A411C0C5BF664C225D0655E5A500F76B80AC37684CCBBDE7CB835CFF58B15B43924A52D21416E1388AC3B65C9383CD04F34E113B63A2CF982F8EE949C47ED1F59CEA8FF00088504FAD8C7';
wwv_flow_api.g_varchar2_table(73) := 'D693E876AA563AD4522C19875C7DBA56EAD1550D93726D4D3775631D15A889CB1665E9B5F939E938D318FF004F4EA317D2509E343FAC3DE58D751094B0DF107F5E3089F9A6D5E74ABC7111605BA1F01A74F215D3FE3796EB4DE2B5A53E2690E5AB268C02';
wwv_flow_api.g_varchar2_table(74) := 'EF9E0815813934EF9A9350E6E1BB0A969D77CECDDC1AA5B14F8C31674A306A96EAAF595898B59094CF3B419D0EF11098196F08D6308A6CA61B0EC3167DA06514A176F2559886AD392772780E4AC36561C4A1482958AA48C627EC62E5A2B4B245DE92878E';
wwv_flow_api.g_varchar2_table(75) := '70CCED9F272ED321CADD4FA38C22D69159A7494FEA1043530D94D52B49CF58B5EC89C6A756843BF679A2A699C49FD1F9A7485A92569074CBDF126A6241AEBB2F249EF2CA30F845A1F48E524C0A0BF511FEA0368FD92161B0734EB0CB2865B4B68140364F';
wwv_flow_api.g_varchar2_table(76) := '58F2738850536013A88B46C17A5966E8FED3FA18B2EF2668A7F29BD1F5CC9A40054AAD31EAC1B61B3E6A5DE5FB20DA13CA1D4B3D639AAB1FF5B5FE1A3FFDED81674E2FCECFAF984C37654937FCBBE7F363086DB6C51084A47214DAB5A1092B5901233316';
wwv_flow_api.g_varchar2_table(77) := '95A72EB9C7145CBBC072D9C76E5060408D60E5B9A1800C5291A6EE9B92F3732C79B7081C3486EDE7479C652AF03487EDB71C45D43413CC9AC59F6699AAB8B5108AD39986A4249AA04B29279E27E305A6D428A6D27C444E58CD2C15B1D45F0D0C4BCE4C33';
wwv_flow_api.g_varchar2_table(78) := '6A36CCCA12B4DFC8F0DB6CFD1E62693D2348A287A23F489943ACCE51090935EA048CF84586B7972A6F9C02A89DB32D30EB4A0F01778F0E71272287E745D467DF3F9630EC277E914B4B92969975F57E51D5F7C4ECFDB1681C6EB28E10DD8CD9155748B35C';
wwv_flow_api.g_varchar2_table(79) := '4EE8E70760CA0D7774D84F67AEC929F76515862839A6116DC99CC2D3EC8666A5DFF34E0572D614AA44E492662DE414530A57971DCB664A58CF21C494DFFF00E24C3535674B3496D2FA689F6D7DD06DA911AA8F8085DBCC8EE32A3E387EF0277CB9CB930F';
wwv_flow_api.g_varchar2_table(80) := '069AF546BED8956E5508A31769C538FC635DAB71B477D694F89A419F9202BE508F7D61EB6E5515B8952CFB843D6DCCAF06D296FE261C7DE74D5C714AF13B25152693598694BF0CA199EB3FA3171D6D03D5EEC5370520C5601856704EED318300453B54A9';
wwv_flow_api.g_varchar2_table(81) := '695541A11A8816B4F045DE97DB4158959B7A5D4B5A2978E64E31F5D4EFE4F742AD89D23BE073A0872766DC042DF5D386437C3CF0C9C5FBCC5E57AC601C73839F618EE083B0659456B14CB7131857618AC1DA229F71A6EEB077CECAEE1DBC601DC1941100';
wwv_flow_api.g_varchar2_table(82) := 'C691CB7065DB9CB608A8839EE9DB4DC3B0E903383B8208C6060370651A6CA8A6F675EC86EAA9BE20F61A18D2130A81046DD77818AC57B7E3B75DA6041DD02091D813072806904C57768691C629BC360DF3BA0EED46CF66FD3B0A1A41CA29841A6CAEE614';
wwv_flow_api.g_varchar2_table(83) := '8F0827626B14EC46D3BC35DE1AC1DE158C6B14DCA4523183DD8D368D835810061148A53627B53B34DA6065B4182760DE4ED3B996DD372BB01C3669B08D94D846F9DC3B34D8235ED467B94DB8520C5634DE104631A4260C5308104EC3A6EE9D98D7B4A6CA';
wwv_flow_api.g_varchar2_table(84) := 'EF811A452836D362738E104C0831581B4EE8CA0ECC378452053B2315C22BB6B15C60ECD360CA06504D76D6B033D958A4650760D94A46348A6DD206907B01B13AEF08C8C69B2BB758AEE8DA2077B68D238EC199DC300EC314839761A6F0CE139EE6BB047A';
wwv_flow_api.g_varchar2_table(85) := '3BA3669032D9A0D82008FFC40028100100020202010403000301010100000001001121311041516171819120A1B1C1D1F030E1F1FFDA0008010100013F10DF0CBCD4770DC631625F9E18F22A57042308BC54AE4FCCEA3CF7062F2144ACC9E88ECB8F8405';
wwv_flow_api.g_varchar2_table(86) := 'CACA0AE3021CB0E1DC1CB09470CC4782573DCD4B971FFC4C25729C1882771957B7C4CF6F8E0620B785F04793860E677C2F0DBC3AE330DF172FF30FC1FC187150E2BF1BE18620F25D5CBE4E3485E3F0A8B3D3F0269E711FC54F3C570FE0F24D12FF001EB9';
wwv_flow_api.g_varchar2_table(87) := 'BC30B1348A4AC5CBC04BA79232D534E5E186F8A0E5FC1AE6E32A6397823CA829096F45C41A84C3E6A2C197C6F9BC4B6A2D909742A2DB3AA9D11DF2725891870C61C9C3C9F9334E5E0D460200557444BB5ABDFD12A33D051AAF8859473A84EDEDF6E02571';
wwv_flow_api.g_varchar2_table(88) := '78EDE4256E1B84D01A970DCDCA95F854ECE0E584A81296359E1BE026B8EB962F070AA09BA763EB6D3E220C5AD93CB4407012E006B2BF30AC19B1FCA128668B1ED862135EF0DC9C7E6FD1341B84BE1D07882B51259514EA6D8CA3CCED958397F061E1E2A7';
wwv_flow_api.g_varchar2_table(89) := '7C5C5B6E5C78B979FC344B257C4446932477C1B5AF484E5EB1FAFD0861D1EA60C00E844506FAC66A6B703035AEDDF8BF108864B1A19F4895AC1B9B600000E1D71788933CAE21161B9DC6E76F0C35C78FC717F8BAFC428FC3B83C0FEA115EAC330647C5A8';
wwv_flow_api.g_varchar2_table(90) := '8D5AC5FEFB8E184D55D06D947A437E07BB1839B0ADC171EF2CF327731457B26972CA8B45F530C103B7A3C4526592BCB043B47D85823FAC416D53CE52F820CB8F0998465B1779B00724BDD93D5450044A95F97F9A5ACF4E31FDD41BC67B12D52BF0B7896B';
wwv_flow_api.g_varchar2_table(91) := 'F7434BF1DC52B1DBD60143D23718421B9984604342E1B96D2F97A224A96F1FA80ED9907A9823DEB6AADF5732A018AFD5E91D9D14754D1F70E0D816C502F5F5104F8C9DFA257D8CB303AD1F4B97E52888F9ED7D465C26C97FE0CB08FD8FF8A0BBA1E6367F';
wwv_flow_api.g_varchar2_table(92) := '6BFF0099FF0043FE60CFC20FF565B4ABC167F545D7C47EDC1345C1FD66037BE189186E3A9886D8FD989662D5400E9E5B614CC2EED0A602F95A47690FFD6EE347BBB5B95012ECF49676EA5EBFA9835128EDE0D6EFCEA6EBDB32BDC956418BF232A1F82AC0';
wwv_flow_api.g_varchar2_table(93) := 'A8B0D8B476FF000438600C04223813F66BDD962B427F11B6DDAB2F3D5FC189E63BBC19D967D5E87A757EC4F595B6798CD8F43F6581F6F9E83145744AA1DB70819B9104F4196413D397BB8668577FE46D32DE4F323A07CE1FEC1A8A27990A857D55FEE529';
wwv_flow_api.g_varchar2_table(94) := 'F57FDA240E9E80717A8F2EE3C32A654313A0660AE7F94DB977376E6C42768B660842113ADBF72F3C2E5E1C973512D9D0F0CB7E0993B5E196CEA5438BBE0FBDABF730D3057FC7D2F10DD58532AF2FA4404DA9F598000D05401F3A5CBCEBEEFE4312868CBC';
wwv_flow_api.g_varchar2_table(95) := '7741B7C1DB01C715D2F4B3F70FBF87BFE844E1EA0FE8CCA9F22E66C213ACA947FF0064FF008A4655A21D1461F400E1DC35315C3C5449540C6442EFDA6798F9C2242D5A2BCC0DDC2881DEFE22C98B129B255897BD4C31579E8CAB9B4E5FB45864F4BCA423';
wwv_flow_api.g_varchar2_table(96) := '26B121CF7098A96C15EF1A8D81F91BA8C1825BDAB7C12F0ABDD1AA7A431C05C2FAF2AC1F5596D6EC97FD60AA12C62EFE08CAFBDCDFA2C34421F16E7F81660D4FFDEC4BCFD61FB0633FDD46D40FDBEA28A14F8791349ECA037EF82706CF782D15B8FB47F0';
wwv_flow_api.g_varchar2_table(97) := '6F64DB50452260ECA7D620C0DF5359D92B4C04DEA38634590774235744BB1DCCAAD828F01F0F6F9704396DA2F93C2089CBC587C27EE2712CAFA56C613401EBB594F917081EC0FB9BA4A7D4B3104DA0EA57BF5FFF00A8D54BA00A8895ADF74328215B56FB';
wwv_flow_api.g_varchar2_table(98) := '657C751F47A0586359F0AFBAFF0011CC47AC7E6291C9E0360BE328D1B5FF00F79A217E0E20FC63F980AF8DC8C5052F0AE540EECD20164DEA0CC7732352B119697EA460EFD60B266F0BDC16B5016F370CE68566BC4CCB4E4B2AC86D01D91708F8B0C2AC98';
wwv_flow_api.g_varchar2_table(99) := '634622B8E837964DD78E2B35085625793D0B9B84B4977AEDF5201E953EE60AD15C201D868F97012C969692DAE704457D0BEA2B1715FC233F7B85466A20889159C1F0EA1E6AAA9A1F17730157C61F9C21C7CE987F5113C19FDC8C7CB108703094459B7812';
wwv_flow_api.g_varchar2_table(100) := '31E150CC04CA1156C1744A15718B85F66A3664DD4191D327B40FE31A487D8902E95053AB94F8E1B2AEDF0540584D96B10000447223767E196768C8AD72DAF14075B5803D63A516606EF94B286DD989F8465AAA7DD37F846CB477FE659F531AA7D85EFE1F';
wwv_flow_api.g_varchar2_table(101) := '466447A9A7D41943D4DBEA31711A48A661A44F6265676613355022AC26FA94E6EBD2771DF171E0D471EB45BB830AB992EA580F683A4B2D22A2B68FEB15465CE1D89B118372F6D37DABFE933A65A4D2AF64100B9D7BEE9EB7F18E2441A44A63ADEDADF704';
wwv_flow_api.g_varchar2_table(102) := '64B38BE4B42BE137C2B8BDFA0F9B3FC25CB2D80850EEA3F490910747FCF98F06D0B31AAF863BB98DA69005CF6417C270226D5DEA167D914E61FF00F40DC18B10BA73E92517FC97D08594D5D2BFD4DF3FA08FDC70B4DFA93AE1BE0DCBB9E38ABC9D475C3C';
wwv_flow_api.g_varchar2_table(103) := '1A814E977D9710BB84752E658676C1E4FB7175BE0B7E2003ED309F71512348F626653B070E00767ACB2A253A46366800E8A7F60818982934FB4143251B51A8AC0C4428B7B3B872BF2A704EAE0B715F90441E2585EC5115224F637FEA3E513E57FBA8F539';
wwv_flow_api.g_varchar2_table(104) := 'EB898E366579451ABD9AACE207120A02088B5957CDB1714A79771CBEC97EBB41E02DE1E2A32C4A86D15E158EA78E4301856A5882D66BD571CD4CC7314C4A676D4BC155291404A38BACAF84F0FA4C10BAEC80123DB9097C5C8D18CC5406E5B5F0CBADC8DF';
wwv_flow_api.g_varchar2_table(105) := 'B98623103D2B7C4B3C0A50A3E5BED9529EC323DD5C1D4AE321CB6EBD6DEA0F4F4619585EABFE1F24A100F0972F94AFB2036FCC212A7151E0FC4E29CB18EB9CF897A9883A9DB7E2184B84E08C4ADCB2999346AE0F618ECF33A9495EB3655773098563E130';
wwv_flow_api.g_varchar2_table(106) := '0BB5A03BBB6AF6E0C1F9FD0EF9BFF7F012220A34005ADCB006C7AF4C542AABB599966D579116A8B3F1CEEFF808F4E59A7D876FB91EF96CB7D305BF6B9FEAD11011B50FDA129FEBDFEB039183A27D86189D0F83E0B227A7C7B3E7C33AE2A57E043F063AFC';
wwv_flow_api.g_varchar2_table(107) := '117869266B17506180C55ED05944CAB7552BD48E1262D9B082886E2E52BDB2DBF63D08E730DB0AA4BFBB8C99E0A15E6AB8E10598FF00422DDB02A5C30328A46EF7E5062FAE8121274F6AFB2CAFC575FE8E20077854FEC5C3E917715160D2A4F5C6AFEC79';
wwv_flow_api.g_varchar2_table(108) := '6F1C1C32A10E3C4771FC43785807EE1A8F5CB3EAD3F94AFF001710A29F21075FB665547E27FEA37716E8A661A25205218EE40985792A5168EDC57A716D54AC9BF49E1826901ED7A9E48A5BA36FD61AF768B2C7D6E88180EB4BFE596086D82C7D1FC4312A';
wwv_flow_api.g_varchar2_table(109) := 'EE6B72F481F2FA830B5800A00231E184E93BE5843F0633AFC2F85CD92F1C6E15310B7132B2B8BF01FD4484B816B31F4771686C5F3CE8ECFC131BAC48E878370F40BE88237A40F27FEBC5C7BFF1FE2164081C92ADFC1BC511604DFC318F05C612B1C3BA8C';
wwv_flow_api.g_varchar2_table(110) := '675C1AE5D718FC1E82505B6F4C5B670D27FF00D6AE5677A834513AAF65668B883F67939EA2661BC2463546EE8F7FE0B1B59512B1EA66963DC695C3CAC4B97C57AC08846771CD95C5609D4CC18CA9DF04EB878BE2A350E14C6E133C1CBCD1C8E9ECF662B6';
wwv_flow_api.g_varchar2_table(111) := '7C9FD08FBF3D857F799C5C230E0D4717C57046297C0062A74F04C12E297010B2C8F3D46771D7151B76F2611A18512A68816113867470EA56680D9A13402D8EDE442B6071938352B4B9F0A91E2B3B97C744351E2894423C54B811E089C5EDFF00C0AFC17C';
wwv_flow_api.g_varchar2_table(112) := '0C63B8FB44B275CBB8AD541448C3603F44C1D568EFD4F0EE3F62F2BBF98AD1DCF6BEEBC0196A1C1B83C318050330DA7503052F7FFEF09FAF07EE3A161B1F56E7765285591E40CB466126A304BFC302FAF345F1504EF8EE51552A2CB6982C4D4786105FBA';
wwv_flow_api.g_varchar2_table(113) := 'F9F423159987FAF961B6356737C179A80FE4CCF15C3EE188EB82277826E89601DB1508ED92A1B827DF0E8843FE2FFB35DFF57CA5E07F05FB95073BE9FE852387805402D94EA475275DDC11C3C7708EBF036CA0AAE021A123C1CBC31AA1F6BC103006A7A2';
wwv_flow_api.g_varchar2_table(114) := '05DCC90EF823C79E5E0772F3352E6814B6AF1EA4F23CAB67A275C7A7262FC63B7F67F885C528B5D749C4D18D530004D08F6E230E8D8A1F370814AECC2BCA047BB78FA20C9151C59F3D26312EBFA3D4685AF967F2A51CEA75FEF9B0BFA5FF00B71D103B0A';
wwv_flow_api.g_varchar2_table(115) := 'FF00570BDECD0E57C9C3A78EF8ED31C5BD108C25D4B83C15D0FBDEEF0426D00C0E83C1086D9BEE27FE24F3CB0294E929875BD59DFEAA056400E8B0DDC11DA7160FD53107485F911146946B72D89BD5DB8A10A82B4DDFE613685AEC0FB584141BDEED2F9E';
wwv_flow_api.g_varchar2_table(116) := '7E9F962EECD98DB9A3F041468C70054548589EA4107D663F3C1C769B8CED2E2C23D45400A568256761EBB315B9512F8EF9678781BCD5B2F10E311DC381622DDCB02D6DB96597C2142FF2A26C3D504B2A14BC81B5A1B3BC365FC21572A320D094D4CC3438';
wwv_flow_api.g_varchar2_table(117) := 'FE46C0A3BAF18E339FC1436C7B3EF26F11F66C7EF83836C0FC4465D10BE6F68A22DB785F4382594406F3C8EF823C6B4CAE2C05001F2C6ED3F0B644D8CC8F7EA4A97185CEE1C6896B71885DC22F7A05AC6C43CF83F109AD57807FCCA17A95FF00B9AC8B05';
wwv_flow_api.g_varchar2_table(118) := '07C1F825D5BA6F87F655FB5E683BCF4803D8CD4094B7AB07A17F363F770C7B834A7FDCAAA32E0D5057FF0091D32FC71F24606078343AF0172BA85FBFF12771F8FBF425EAD75E92EA88F38522C198A6D8DCA78ECE555210D783C20945ECB86F497A7F7E51';
wwv_flow_api.g_varchar2_table(119) := '27820551AF170F0F4DE9EE101BA5D252547AD8A27C31E332840A209DA05DA82EC831BA21735E86FDFCBCEE0FE19FCCAFD40AA4D49EF1C8ADD8DFD91DB090A9E1C9F4C7721EBFEB3B7F15CAB49F94A42C3C0AA8A1517CADC750CD9530C3C8A8412A351590';
wwv_flow_api.g_varchar2_table(120) := 'D0E1D92FC7D8990BC5EA55141AC67DC3B1EA3FC5A8970978343DEB20030DAFDC30174B3E02517E5CC70BC890778431182DA3F6998E6D1B0C279180108DF993A7D268D6250CFC5161E339A2E97487867A6B9824668E742A2DF244F356B6B91A75DDC6F6DC';
wwv_flow_api.g_varchar2_table(121) := '3DF3E1AFFCFBFC4F246BFA5EE34396B54B648B9E1D3F8331A93421B71053CB34B6C7084638B258658463DD6CF2B6FE9359C64B18F07CDA9DD535828603E757B0881813600516DC2A09B6FA66A52740A3A081647A05A1B291D45585D00A7DC00080D7946C';
wwv_flow_api.g_varchar2_table(122) := '0ED9634EDBA7F1954C3E6C102D27582CFA11EFA883BF99BD0619C117A8F736408BD4ED5F573C3F9AE2C96B56EA190E0D7D23EC2A185E909559E297BFA9D430705719CA80FA4B8B370E00BDBE9142F994B252584122A5718671F3BDC25BD132D4DDFAAE12';
wwv_flow_api.g_varchar2_table(123) := 'B49D508A221614854BDA6AAF8075579801422589A482F1529E8EBE61C1B637A09E023055AECAC3D6961BDEAAD3A6FD654E046AA817A202EA201FBD3A8FE4E5CD8FC5B3C1BD94F62A310C6C657EB570C0D5576FCEC43F41DDD1FBA41AF8C1B1FA6ED02DFB';
wwv_flow_api.g_varchar2_table(124) := '4FFE572F039E9FC08C49EE1AB6AF8AAC91D308E04B2F04056554676C8101367307834465A3D8C4162E50B44277182D9613DDC1E60F053E50DB9FDAF97CBC397BD8591A0DED257C3B0851A97B647A50461A6C2958A3CC4E2EEB2C99F6110A3CB63B8B09C6';
wwv_flow_api.g_varchar2_table(125) := 'A85AFE304BF4E762E67DA98D8EF5EA862C618A234A04C66586659B7B9F710711A37CE47D76085901F107DF762EA10E9A9F73C1E515ADD0F95F9114CF25FD4485BE98D8D51DE9A7C65656BE55FF006B70254DB365FC256CD7DC4CC35ACAC7A2B47043652C';
wwv_flow_api.g_varchar2_table(126) := '32A64B9CD4FE11C1B7DA3556C6AF9161FA9844F02A619A65A363985287146181A62A15D05B1558EA9A44EC85166FA9FDC2B677297579ABA81B5203AA8322D13B222C86FEB08537B73A99D2FA5023D85D51A7EA3123066A1E144D744055574AA88F197EB2';
wwv_flow_api.g_varchar2_table(127) := '29A230D5BC46BE2A271121A69EABB25549D7AAF97D6613A4668BBC559F290ED7C897679EE8F370AC38AA65E52AC119F9A83FD010FD5C4835D607F0962517F9AC4502F1ED84BE549DBFE753D33810FD724E56D1A087E6D422DD0A17C5CBBAC54EF906CB2B';
wwv_flow_api.g_varchar2_table(128) := '5EE6200B6DB9ACAA6AC40ABB66F9A656096576470B92542A9E601D910AC463A0C1B775F0C2A90F2DFEF1CBD7773F18206686AB7FCC644A5DFDF85A0AA901BA8449B3FED888FDD007100000006288977E13516D02DE191072540A5FD9969CE519A28B079A';
wwv_flow_api.g_varchar2_table(129) := '5222AF1EB0F5321CAA1C594B5962C7EB839785015400CDC0FF00FCE1F9C0C1B78BDA44EA948F6C288EAF9FA0CCCE9976CA186634CBBFC056CC12E5516EA5638D406969811232A15349F4E14D46DBB5F2786645AEEEC7E9612AB05A303DC733C156CC1EAD';
wwv_flow_api.g_varchar2_table(130) := '43B92709B25AFAE06CB384B5B2A5E309595D2DD66BB5F26318F5FF00EDA9FBC79FCC79FEF298BA54A5AFBA16F78AC9F89B381EC4F4BFA8E156782BE89482DA42FF00961690F27F6658C1EA3C29057A400F5317194A7492BF0C2116881735860773CEDF6E';
wwv_flow_api.g_varchar2_table(131) := '1457EE2CA89D601CF70D0D4CED037028605163C5A108A56B87F0F12DCD434EA94D4DC6391AA1D0F996931A0DAAEE34D5FBA6B879E2E62E02336B3E0A25E12884781974DC10045752BDB6CF36C54E6BDE59BF863831B611E133325EE393508C551DD4EE20';
wwv_flow_api.g_varchar2_table(132) := '6C25608ACB8AE8E2C8C0B0BCCAB8E8656C9416B85596C45033A780E32CB830B8A55109DC23C5D41EBDE2C2DAE0D32985DB886215F5C262307954CD4451EB02EA24AC916A25B0B3501216CDEBF1B232A1BEA34DAE58D4370D9C0DA3A466C7838BEB838AC9';
wwv_flow_api.g_varchar2_table(133) := 'E84337F859046E60C6CF4942840E081E92CBC114E8814D71D419816B9EA103084A345918388C4E19FB8CC86878ACF09B545C31E4834254B01E26F8D6666A2A010A1684A855FE37BE285CDB72E196A69A651455B1605DFB4A97C539A8B27A40DC786E8C37';
wwv_flow_api.g_varchar2_table(134) := '53B9828E1264AF7A2E2B52A6D7054AAC01D9299746B4C56F054B498AFC082141AB950DDB52FF0005777C12B879CF14541C3817101DF1B6E2A7CC572EA772D976CECEC8A28DC605CAD959956BE934433C25A562E22BEF301FB8CD59ED04372C77B9E69858';
wwv_flow_api.g_varchar2_table(135) := '52E1976AC210B3D11419E3295121A60CA66E7B6E2BA6BEE28DC7822D4BCFE4A98DAA950B62DC221A8D4B28ED51F13C5309A9D416AA184A59D30ABCEE3B53835C163DE56B9D33276E2E35E65E278318376BA25170623445B181758B8DAD8F702E134F26B9';
wwv_flow_api.g_varchar2_table(136) := '79FC16D3C52E89549728C12A1134CA8468C08F15C12882D98829E62AF5DC114A08B9581B8275C050A4BD1BB7CC5C03CC5D97094C31EE06BD91799645A22D70C333B8AA32F09D4211E3A9D45C438EA65C51D8F6E0661573141A8462101AE30462DCC524EE';
wwv_flow_api.g_varchar2_table(137) := '0575C64E7E26085A988B751AAC460D7CC147AC4F2928A42534B1CC745C65E25F031EA10E289579B9E9805B9849134D7C40744C78DB0E56A03C6333A8955306B8675C3A8BFBCD32B96A2DA25A281C58F0F3502E66C3834CC475C35894DB1FE351F6D31002';
wwv_flow_api.g_varchar2_table(138) := '981154E196DD46C24A8F16ACB2C677BAA9B04FACA5B348186E9350425DC35F196F6F09433A88A59777655117319A8F19018EF8CD955691358718BE2F1CE1081B65AC2E1443238A45DCC4C51666EE2C051A970AAE3452382EE75311A3A8E5980949B77128';
wwv_flow_api.g_varchar2_table(139) := 'EB8EE44EAB8229069D4BDEB9560DDC1866A517100ED8E12B911A1E29658C3427A51DC4CC7F018696364B25311B1033CCAAB63FD4337895AA8C36943DCC33C5CC63E873640130F6CA12F72E608D881B472E83CC51A4B8858B97634EA282E77C55094B8ADF';
wwv_flow_api.g_varchar2_table(140) := '39589C061E1532F4FA7F259316E629F7E4AA4AE28CC86216F01D6E3A875EF2E97B444DF4EEE226A6C9A947709E636B715A38F13610C5BC4B5A265C06220B1E53C466515508540E61087708B0351DFC73D98FE1DCCD1E9335C3081E5D471322BC0CFF0028';
wwv_flow_api.g_varchar2_table(141) := 'AD7B57E277F1001FA933F970C1EB8024FFC4003B1100020102040306030506070100000000010203001104051221104151132030313261227191144042528115336062B1D1234344507292A1C1FFDA0008010201013F00FF00613DE1E38FB94B89821FDE';
wwv_flow_api.g_varchar2_table(142) := '4A1693345971AB8789091F89CFDD5658CC8D1861A940247097150437D720161584CC65C6628685D308BEFCDAB1F984AF2BC103155436661E649E42970CEEF75BEAE67D4DF5ACBB01D81D6542F87A97A8AD6BD6BB45A0C0F7B199943872B1821A462005E9';
wwv_flow_api.g_varchar2_table(143) := 'F3AC8DE4971D8999D89D42B36CCA48E55C340D673EB6E82A38DB1075313A2FB2F36F7358587ECF0C9338B594D87B0AC0A3CAE0736624FCDAA69F0D97C00B7E839935367199C8D78A2D0BCB6BD459C66C87E38758E7F0D419CC0EBFE3AF627DCD4534528B';
wwv_flow_api.g_varchar2_table(144) := 'C6E187506FDD048AD6FD68927B82F48FA87BF7338C71C261C68F5B9B2D2ABA9DEE667FA8079D65185EC9755B603EA6A42D363B16FF00CC547EBB56030891C68C46F6DBD85671896D230D111ADFD47A2D65F0764A0A2176EBE42B1597626694C8CF7E814D';
wwv_flow_api.g_varchar2_table(145) := 'AC28605D36EC0FD2F4300CDFE47FE5459246C419100150411409A6340A3DBC3E56A06D4ADA871CF37C4E16E365566FA6F59561048E19F72DB9F951D2887C8002B2FC30790C8DB26A2C49A69E69148C3203B6CEDB2D36518924C8D22B39DF9DEA7FB5C048';
wwv_flow_api.g_varchar2_table(146) := '66957DD58FF435066798C66E9289D7A73A8F3976003E0E60D6E428E678E6368B007F535859B18FB4D86ECFDF503E1A8048A3E6782B10683023867A3E2C39FE5907D56B2A4B231F600566B8B2B1763129777F505E429269D146A80DC7929DD47E97AFDB78';
wwv_flow_api.g_varchar2_table(147) := 'A8F77811D479E9B822B0B9CE0B1161AF437E56DAA48A2996CC01F7A7CA63D5A90ADFDC5459785F5B93ED4A8AA005000F146FD2F56BD58D29B1E19D9BBE113992D51CAAB084590220F5C9CC9E8B506372D4B224C80FB9B50ECE45B8D2C2B1397A3FC51801';
wwv_flow_api.g_varchar2_table(148) := 'BA54D96445AED1BA1E76A8706D60B1C9891F27B5264D2DC16C64C3DB56F587C39816DDB48FFF00237F1D0DCD4836BF00C346A245AD4F8338FC4F6CE4AC2ABA500F36EA6A4CA9145E33BFBD62708935C30D2E3C9BFBD2B661827F80BAFF0043584CF31040';
wwv_flow_api.g_varchar2_table(149) := '13615DBF99057ED643BFD9711FF5AC2E610CE74E9646E8C2D7F08C47951461CAAC6AC7BAAC1858D310A093CAA20D8A376DA10765FCDF3F6A02DC31185498746E468E071487E13F4351E066637924B7B0A8F0F147E4BBF5E756143C526C2BE227CA8C66DC';
wwv_flow_api.g_varchar2_table(150) := '6488CCE351F800F48E67DEA21E7E31F0A631A21672001CE9353206D2403D7CE93D43EE43BD2CA9129663F2151C4F2B89661E5E84E9EE7DF858774F91AB9AD56B5EB50AD43C69A74880BDC93E951E64D450BB38966B6AFC2BC97C12B4CADC0D87314AC77D';
wwv_flow_api.g_varchar2_table(151) := 'C70BD5CD6A357BF78D3E26EC5211ADFAFE11F3350E1C212EEC5E43F88FFF003BD71DE201A2AB5651E5DD0471D3894F4B2B8E8DB1FA8A336207FA727E4C28C98B6F4C0ABEECDFDABECD249FBF9491F957E1148888A155400390EF6AAD8D7C40506DAB56D4';
wwv_flow_api.g_varchar2_table(152) := '1C1AD42B55C91E00ADFF002F86578106B70382E9BF9106BF4A23A115B8F55020F977EC7C43C406DC703AAF46B6B5585A85C1B1AB1AB56DC6E3C5B55851BF037E005AF5635E5C6C6B49AD3561F97EE361561C4FF008FE1C1E00EE7FFFC400301100020102';
wwv_flow_api.g_varchar2_table(153) := '04030607010003000000000001020003110412213130415110132022326114404252718191235054A1FFDA0008010301013F00F991F363E5151DBD2A4C6C314A45D8FCA952003CBB1293B9D04AB875A748B13ACC3E1C101985EFB09E541A9004C4E21193';
wwv_flow_api.g_varchar2_table(154) := '22F5E058DF6B760060A554EC87F90616BFD93E12B7411E9544F5291E2A341AA1BECB31680515B0D8CC3500E3336D00004C4D51519514F3D65C2213C8096A95EA45C25203CD731B0948EC488F8471B6B0AB29B107C2C88DBA833E1A8FD822D344F4A81E06';
wwv_flow_api.g_varchar2_table(155) := 'CA7CA798989A1DDB5C0F29F061E90A8FAEC201D04C65419420DEF292DA9A0F698AAECCC506C26169DDB39D84C4D50DE5BD9650AF41142EA20AD44FD621AD446EE254C620164D4C77673763C35D5CB7E84650CA41DA57A26935B972EDC16CF2BD4EEE9923';
wwv_flow_api.g_varchar2_table(156) := '79AB37BCA8FDDD31F75AC040AA0DDCFE86F131346C16C40812930B80A47E2361A9372B43826BE8C21C2A20BBD411D698F4BDFF005C3AC48A6C46F1405503A0ECAB496A258CA949E9B5987660B7798E6F42CC353BB866D846A59CDF3FF2360D79319530D5';
wwv_flow_api.g_varchar2_table(157) := '5395C44A8F4CDD4C5C68FA93F92A6318FA45A33163724F158653A925797B46A82932826EA763D2665D05C6B2B207A647B7660B7732A067A85B293D047A55CEA54CBB29DC8328E2C8D1F51D62BA36CE0C71486AD963E2296CB4C477CDF481F8E31008B198';
wwv_flow_api.g_varchar2_table(158) := 'A52B4C2EB6074330550662A798D0F65642B5597DE2D5EE532800B7394B18366503DC4B820106353471E65063E0C6E8DFA33E0EA7DCB2A5074DF51C24C6A9F50222E22936CE2074FB84CCBD440CA798ED650C2C76956835170E9B5E2B02AA7A898CF290C0';
wwv_flow_api.g_varchar2_table(159) := '6A46FDB46BBD23D4418BA246B711F1883D0B78F5EABEEC65CF1A900CEA0B585E7F922E952DFB8B8B40D949D3934041008875D0C19698B1F4DE63594AA8F98A15AAA10175F6895E9BE9717988B772F7F98552C6C2160A32AFECF617722C58DBC341435400';
wwv_flow_api.g_varchar2_table(160) := 'C34A9FDA2361C393DD83A4186A8472870D504652BA11D995ADB1E1AA163198019576EBD780AC54DC1898A1F50328D5A166B9B1BC5D89B9D4CBB1620292A37B47A54CBA1C846BB19600E54503A9829AF3D7F30D2A7F688D8643B5C47464363E309CDB4119';
wwv_flow_api.g_varchar2_table(161) := 'EFA0161E2187A856F6845BC2959D76316BD627CA20F886605ADA455B76966FA56F2AA3BAD8A8FEC6465362258CBA1DC1132A7DFF00F92D4F9B1FE4CE17D2BFB3AC249373E25C2B100E6101AB4C5986611FB962AC79EFADA1C3AE7501BCA446C310C05C58';
wwv_flow_api.g_varchar2_table(162) := 'F38F856500E60443856034220A00646D48BF9BDA00390F1D550C87DA0EEC81FE878746B95B06DA2B2B0B831594330CA596FD2E22A522CC402072109646097041D893B4735B2DF3AB2F3B439C0BF78221BFAD4912EAFA52B8FCED19AA531775D3A88ACAC2';
wwv_flow_api.g_varchar2_table(163) := 'E0F858A806E44F2F43E01C0A64061726D14A11E5223283AF385A912AD70081AC6547072900FB45EE4290403A6DB9948855B5F5BE82024D525415206B1BBC26E4861D239A650BA5832EE277A9F74EF07204FEA0673B2DBF32CE776FE4C8A3531918B12174';
wwv_flow_api.g_varchar2_table(164) := 'BF8070412350677F56D6CD28B51035B5F9930AA38E529DB5B01A42B799EEE2E40CA353D61AD4C7D4269558106C39F53349710D441BB08D8A41B0267C433696025DFF00EC0F900CC36262D47034261A8E7763E0B9EB2F0F109E39E00E20E38F921C43C71F';
wwv_flow_api.g_varchar2_table(165) := 'F11CBE40F6FF00FFD9';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784243475261151275)
,p_file_name=>'img/ai.jpg'
,p_mime_type=>'image/jpeg'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/img_persona_male04_apex_png
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000001000000010008030000006BAC5854000002EE504C544547704C9671757F6C62625554685A597B61607A61607A60607B615F7B61607C62617B61607B61607C62617B605F7D61605C51507D605E7C62617C62';
wwv_flow_api.g_varchar2_table(2) := '617A61607C62617D63627C62617C62617B61607C61607F65647E64637E63627C62617E63617A605F7D626181666582696779605F625453866B6791746C9E7F73A68476CFA38DDEAD95CCA18BAB8878785F5EDCAC93DBAB93DBAC94DFAE96D8A992BD9682';
wwv_flow_api.g_varchar2_table(3) := '9A7A70D6A890B08D7AB38F7DB18E7BB7917DDCAC95DDAC94BB947FC59C87D1A58FDBAB94C49A85CA9F8ADDAE97DCAD96C19883DAAA92AF8C798B706AD4A68FE0AF97DBAD96DDAF99C79F8ADFB19BE0B29CC59D88E1B097B48D79AE8A76CBA491A27F6C97';
wwv_flow_api.g_varchar2_table(4) := '76657E6353745A4C6D55476952447057498366578F70607A5F50664F42614B3E604B3D5C473A5A46395E493C604B3F5F4A3D634D40876A59A98773604A3D6D5F5AD4A994E5B6A0E3B59FE2B39DBC9B8A98867EA68F84797472575F627D77758B6D5CB195';
wwv_flow_api.g_varchar2_table(5) := '8744535A354B555F63652F47519E7E73706C6A29434F87807DD0A08CB9947FB69482D5A68FC59D88C49C87D0A38DBE9884736E6DC79E89D1A28DBF9884C89F89B7917F807A78BC9483C69D88C19A84C69D88D8A891E2B198D1A38DDAAA92DBAB93D9A991';
wwv_flow_api.g_varchar2_table(6) := 'DBAB92DBAB93D9A991DBAB93DBAB92DBAB93DBAB92DAAA92DBAB93DAAA92DAA992DBAB92E6B49BDAAA92DAAB93B38E7CAF8C7AB4927FB28E7B514E4D544E4D524E4D54504F534F4E685D58635A56514D4C534F4E555150524E4D5A555392796D58535153';
wwv_flow_api.g_varchar2_table(7) := '4E4C514D4B524E4D524E4D57535155504F74655E534F4E524E4D534E4D5F5A585D58565652505F5855524E4D514D4C534F4E5954525B565455514F565150504D4C544F4E534F4D534F4E534F4E54504E504C4B524E4D53504E7A6961524E4D514E4D524D';
wwv_flow_api.g_varchar2_table(8) := '4D514D4D5652514E4A49534F4E524F4D5C5755524E4D514E4D635E5D837D7B6964636661606D686697918F948E8C8E88869B9593989290918B8996908E76716F8983814B4643413D3A3E39363B373345413D5F524A4C4A4AD0A38D0B5653EE000000FA74';
wwv_flow_api.g_varchar2_table(9) := '524E53000104090F4B7137698EC6BBA3B15127162EDBEEE5FCFFFFF9FFC0FFFFFFF57F5FD0FFFF441DFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF';
wwv_flow_api.g_varchar2_table(10) := 'FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD7FFFFFF0A91FF2DF1BE1A7FFFA213B0E52BFF524261D322FF49CCFBB682E950F2D9E1785AF86E3691FFA4EFEFE9FFCB5B75CCFFFFFFFF3DD4FFFFFFFFFF6824B8F2FFFFFFE19EC6FF';
wwv_flow_api.g_varchar2_table(11) := 'FFFFFFDB37F8FFFFFFFFFFFFE7A5FCFF2C87FFFFAD44337DFFFFED92FFBE50FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4D782DB4CFD00002845494441547801ECC1470103210000B0636FF0EFB62AFA4BF2010000000000FF1562CAB9D456FA98';
wwv_flow_api.g_varchar2_table(12) := '6B9FB3CF9AA3DEF772F891631EBBADC3501404D285B8973372EE712363FFFF1FBE2E9A4E5D4B6F762C9B116E13FF07FBD9FC69B458AED68B670108D600ACDBCDCBFD7C7E7B3BE8AF703B7D78212C87B4C5E282D066B16B9BFDFCEE66A0F637D343734CA6';
wwv_flow_api.g_varchar2_table(13) := 'A25B0890D84AA91D8FF6F783F49F3C2FA2D3EFA25FFF56A2A04879F7341D9CFE7CB48CE03D82C435CEB16A5E67830AFE53B3D216C02EE20503220C240148B48BD16940A5EF69A54ED65CA16E6D4CC182EDF875308DAF69B77C8040CEA2A83B09082101E7';
wwv_flow_api.g_varchar2_table(14) := 'C56136889678389A4F50B0A94A60CE022C0438E7DD783E00FF8765E21A5D3AA0B02948FC2500A573E8A9FFFEFB9DF91E0B42D55242092DF7373D2FFFFBDDB6ABED61BEC08E72C1B92B8F6A9B9B9EFB0B6D5200E4B3AA5077E83A25E4CBAAEA19EDA1CFFE';
wwv_flow_api.g_varchar2_table(15) := '93A5293800759DD039B826CAC7A9D1AAC7DD7076AC2555025C1F991250EF0B0BC08BC7BEFA9FC66B0A75140822F80495BBE9EF424D5F07A091444DA96C10D9AEB3FE3D652C26163DFD33BADF89CFB09523670BD5F960106F516A6EFBE83F5DE4C0E682A8';
wwv_flow_api.g_varchar2_table(16) := 'FC74CE16196DABDD487F175BD7AF055ACCFBD801465637DC56B8AA060545200002DB0275EDC220D2A887C3C09F0E285310105176A29A099453774797EEA81231D27D0F03200C4EAACB9F5299F65CBF0539D32DCB81F4935AEBDE6F9C0582D77B2FF011F0';
wwv_flow_api.g_varchar2_table(17) := '15F84525D806E47245C4D159A4B7EFFD9FE602470CE2EABF4C9ABB34CBECEC6A49782B1C3DCDCF01DE10AF73CB032188194C11F200F881C800718D78FD3CBB0C20FEEC112CCAAA2C08426E7D23F1C32445705212310E77FEBB97DD4500F5AE8EEB1DCEF9';
wwv_flow_api.g_varchar2_table(18) := '7852B229820003005954E0004C4031DD3CC828B9160A7D945925BCFDD0D20018A05A0829956866F34581A608C264F4E501FC4D8A0986D3A97B21003F5E8DDEBC7AB595590EDC7982DDC9A3C5524807D188F1BC2E1CB3C03ABA696FA3E9A8AC269F3E7FA9';
wwv_flow_api.g_varchar2_table(19) := '4B14AE9E461FB69F6FDFC9AB0BDEF663B0E957252D5A1B02CD97E3DD12A290EA64E079882DBEAEF6BA4E6A35DBFB5C20EC9F6619EE93BCF49741D36F5C46105A2ED793128F0042683302425700842E76F796528BDEB8178AFD02790360CF32EC83DF8110';
wwv_flow_api.g_varchar2_table(20) := '8004EA607DB8382A280110595720B428CA7AF7584A972D462A69A13F03F263409A6500DE903400032134B3D5D749BDA8168BAA9E7C5D1D73AE37F1B1FCBBABAFD9914F159A610ABC784AA1054A03D049875668DE3427CDC9C949D3702D227DD81450A7FD';
wwv_flow_api.g_varchar2_table(21) := '999287BE4C900C6742779EB80447F45CA70188A1E44F3067CA3E7176D18A31728570F4EE7E860A706510A262AD7FC135216EBA58FEC2DDEA5A298E0B640B25799D6100EE3CA54E0147632D87E8CF2C51D306FA5EFF8E7ADF079D886505B00BC0CBFCA661';
wwv_flow_api.g_varchar2_table(22) := 'B79F500ABC02021CF3B36E980E46C5EEA7C24BBB8343C63006198EC45C2BFCAB2AA08C11A6ED3D6721624FE87A338C9530734028C0F4E3768E3B223478406A83679726A2397083813BF06F04631B8017194E841F30F80B0F681D3F61D4F5CA77C9AACB36';
wwv_flow_api.g_varchar2_table(23) := 'B249FE3F638C02FAE84E8E7BE20C42300840D779CB8B757F76162D7F52254DB3C29052526CDDCE71264E9C02CA1D1EFC7EE8744AFE0DFC9C204AF1D1D31CF7475FBA5E785A2D858C91F24E9F6D9DFD5F07600501C0A4787A33CF00001B80639E106F554A';
wwv_flow_api.g_varchar2_table(24) := '388552BE3C5E7900C614B3273732C4FDD7230801AE8E2F7AB7D2A9E23789D0A6CC03F89AD98979F130CF7D213710AE8E2F7BF96BEAAE0FE88CDAF4C3C6DE3E95017A5D2080D9E87D8E1BA3B7B728840457C746FE16AD5291308CEAD5B031D0E3230421CE';
wwv_flow_api.g_varchar2_table(25) := '6E22EC70E7118510B3C59EF8B5C1ABE08109BA8102201CBDFE90A3025C00002977B4FC2728E393C398D803AC02DE3CCBF29F431EB9916EBD14CA8D437963471F0DE7E2371D80929AEBAB17F1867FA7DE2CF41C4582307EEE6EEBEE84DF307EBBC496CC65';
wwv_flow_api.g_varchar2_table(26) := 'F676E202699A2490A2A387AC8E65DD5DDEF80A9AD537A0E209F6FFFA6BA08B4A2A25BD73C05F877F8B658DCC677C3C7C6E15C96BCB623E5D97CF346439AD9C472112C8BB72F603DFA7E613A292CBCBF9B49C178585F91AEA506E1EC13A999896C87C1AE6';
wwv_flow_api.g_varchar2_table(27) := 'C4769D5464556B11A2EB3A0D4237485B53D30B890F0641526221AF7688410C8A131A84906E5B3DA72C8B478EE0759243F12C10410166886E52D3EA01D8C0FA36E02B060C2C9368B9857F529224E1E3ECEC725A6D99160B7EE6770C189A9412B26B070A10';
wwv_flow_api.g_varchar2_table(28) := 'CFB2F11F0EEFA08C31C03BD2506260D31A6883610F09D9C01C2999C5745E516479DC9E0C068146434A7122BCA15D4CE8F701E79FFC17CBC12076816FF7EC18B22060423AAA9C139CACE388D5C5F1D2A8ABA3043D8BFB01F0C106CCC4AE315EAC8AD90567';
wwv_flow_api.g_varchar2_table(29) := 'C1111CE5EF4E97F606F8837164F7A7F1AC91DE19094055C1F57CBF1286EF7B9EEB2C6A06300C04EC851A0DDB63B18253E164D1749E5BEA0C7B6CD8338E7C1FCF1AB96FF6FFA533C4ECC9AE5F2E57CAF8F03C3F78C537AED0417A3600D6C317D04F177022';
wwv_flow_api.g_varchar2_table(30) := 'FCC1750309CA61B88596391C9A33877F8CE9BF047EFF6BD70C05362C84CC78BF70F1E22527A2F39D2E2039D5032758B21F6854F19B97AF5CBD58A8442A953BFD0999D9B1E387783AE0EBDF4E2C9D5AB79955E5CCFEC6E6D6D6D6950B881AF2D581C12827';
wwv_flow_api.g_varchar2_table(31) := '76F0A55DE45334B7A7D3ADE976339CC4AB14DBC3E1BE23FBFE8C69A1E8AFD794BCA8DAAC778637A873FD06E2DDD82E703D2A390092492472C4068D6BE25D9A6EE1EDC64DDE61CA45030C397FEADF03B1E4BF755BA956C5860503D5E7CD7B651AB4EF6629';
wwv_flow_api.g_varchar2_table(32) := 'B2800CB63A27492915589B7F53BC79638A7123B240D9B1A0BB582ADD89A70077EF89D56AEE8E01D00AF9D1DF01DE8DCD88AED2B1A9323F3BBB963106341736F94702541A03BB55C285DC7F1047033C6CE2B6379B2306E622F2789E7B3114E011DFC5F98A';
wwv_flow_api.g_varchar2_table(33) := '698F12C120606D1DD8BA1776818D80FF6D17705B6069A862557C1CC31381274F834D6F3AA74C801102557CCFB98E74574A7E8057715A6036D68241E05A9D8239E616B8BC85FC57B801FC1205A38E2A568567CFE3770CB87B0FB7BC542A65080095BD00CF';
wwv_flow_api.g_varchar2_table(34) := '2F6CE061303A08A233D6A3EB04D20806FA386CF542E9E68B8B4DEE11AFC3D80855C4105EC6CF01AF04E4C76D5FD506CC6E39E1611EEF215BC573D61923A214E57D323AC0E454C10B7FE3F4C87F9AA272B95080ECEB180A2056C3583EDF05666B85D0D51C';
wwv_flow_api.g_varchar2_table(35) := 'D0F7ABEB36588DD49BF457626C01B3B46AC58BE811DF1308306D45E4023C8CDF4EE0A5C00510A43C85015BCF795C02DFF3329A6E0353E7DE2543A4F11018504DF15C7ECEE07BE708C0FA42D189AD00AF2201CECF261A26D291A512B27BBED81819003054';
wwv_flow_api.g_varchar2_table(36) := '17A4371702A43969AEA1DB0C98A1D5B338915B90D7A96D8FC454211BDB2E7037137501C4ABEB007DAA9351A74D743318FD7617A37C709267402549694D18003371AAF59661024C3421313BD7CC04BB926CFC76829F3EB92F720720A8945BA734001F0EF0';
wwv_flow_api.g_varchar2_table(37) := 'C9320D359B92CE7E901B9D9396EB2D9D32B0FBC06CE899EDFA2ACEB92A701D5FC5F14448E002F0949FA2B64990E821A4A5D597112DF9869CF783C2CA4A32996B68A36E10EB6AFE7FEECD333B712588C27258C2DBC413F8D42DC4B1D448980615E8086426';
wwv_flow_api.g_varchar2_table(38) := '6E62C2229C3D39397B721E336F910F21108809FFE9CF41E9D7BD94BABAE8EA24C410679405CAAF8E16722ADC1A47404A50A9D81BF57ABBBCDEED56504404802F0C2A756F1C134AC7372A01C9D400FBE14296C3DBE9346063BA3044E9A24040D21714D09C';
wwv_flow_api.g_varchar2_table(39) := 'B789B02E2E16D1FA665A0B3C79612D224F5F9547066814906BC9DC2229E9EC0896E283D480743EF970D95A50078606D89D827ACEFEC0C5463909697C15EACC9221CC12A763E00216837941B4B7592E18C0028D09711C376CBB6197CBBD6B492F7B1B78A6';
wwv_flow_api.g_varchar2_table(40) := '9B8881C66679EFE181B5B06CBDDC7F121361060927F1DE697AB7A214AFED24BE4F0C5DF0CA0728DEDB7FB9642D322B27A7251475E5B1AFED9A1B45AA3A1E27A9D82812268CB3F3975BD6A2737146C58C971B00BD6EB7DB0D042C09403C4D0B9CF9115CEE';
wwv_flow_api.g_varchar2_table(41) := '5A0BCFD2EB37849C242CF44B51E0380140E96DC67CB7802EBDDDB2169FA377C16F9A3FE88FCDF3923592717A3C3740FFD2D66990EA96A20B45040CF1796624600A19786F19C0D287339966FD3FA141495FA0FD446B99744C7F3CB04CE0E05D1F19CC7A32';
wwv_flow_api.g_varchar2_table(42) := '09229A1BF801842133081C7236132A9D2F5B46F0A90BCC77C7DBB14E25FB80A6911F0EC6908F21FDBEE0C68965069FCF6F8019209149B778D0769BEB14F6FB0C49089D56BD1C4CC77F1124FD90706499C1EE6509297ADA1745767427AADEEEF53ACEFAFD';
wwv_flow_api.g_varchar2_table(43) := 'EB75F74EAD83543709E73E74CF1F5966B0F5A5DB179AA4B80CDA58BBB3A6D4AD5BB7D66EADDDB9E3C5042D7AB6919ACE4E2C53F8FCB1EFCFF785D346B4A6A23B296B776A71C01011D2D396E9CADB23CB148E4E6FF0EC6C47A71A43BBAEEE8C88AA319196';
wwv_flow_api.g_varchar2_table(44) := '50EBC9D3F4F9D72F5B96292C7F3AD628C02111E9FBAD76B5DA6EC544A0B02F42007C121FC2A85C7EB6CCE1E86D174518020AA8E3381D220CE1449244000DAD29E1A0F26DD93287A50BD0DFA6C25A93504F04C480F8002AEF3E5B2671705A2AEA9E87A497';
wwv_flow_api.g_varchar2_table(45) := '245964F40510FE6699C5C9F750086358F7F4FCEE2166487622042D1FDF5B66F1E8493852CB63039032BF55169A0121B09867C0D31F65824FC8112DD0735F9451226066DFEFD11BC30C583ABAAAC5C452D82947E9E5ECCE713FDF5F45E645C0D5A0DA6141';
wwv_flow_api.g_varchar2_table(46) := '11CEFEEB692568AA014B4FAF945BEDD06FF46B9D0850F4864B06468052513377408F5F010698242B951939D2372F0B0C0D70A3BA53980BF9342BBA371D200CCC025B57CA75DDA8EA10A6F81A0524215F20E1F06860040C941A7A506B391813621E264E42';
wwv_flow_api.g_varchar2_table(47) := '304B689E0107579E3BD849A3A01ED31F3652931377D8DC34A8D4CEC880A8D68A11904601A2C069545BC1D80CFFECC2328B173F763C37450D2DA86F36204434951F38B1DDF4DAB92B645C3174A80683CC80D481C8AB37CB76838280A85462C7DEA80FDCA8';
wwv_flow_api.g_varchar2_table(48) := 'DAC9E587C7A75B6625819F9ECA22C0CB0ED1F0A4566D37AF6F36DBD554BD8A6A31618466ADBB667D1FB0FCF287720BA8C951A5BFE9493D9E2D0BFDB32F4B26E5809FB54CEE90547C81ECAD50769E1B3434A4F4FDB5650C2BDB8354B437187853F1C578A8';
wwv_flow_api.g_varchar2_table(49) := 'B5284F87120A03DD7727C6E83FCC3E746F67E066113F0987FCA41E0779F83344430337DE7E3063207CFE58A98950CF9DA20693ABA81E137242C98A05E99E9D9B60C1F68FDA8CE66CFCCB8C50AAA89F31827BE3234AC7DF177E42B8FADF3FFF663A3D35CE';
wwv_flow_api.g_varchar2_table(50) := '82CA1D783BEA7F6AAEC2C86D208A860A480D87C691798EF90CE13AC235A89A8C0EFE1AB4F6999999D92E25C23535603D31EBBDE5DD3F7FA1C031691E6C7813A2FE3DBD537437C8FEE33320B78A247612F7992399BFE3E842EE1B9579CBD6C494D6E241CF';
wwv_flow_api.g_varchar2_table(51) := '8FFB8A0D7CEF938F0584B03FE0385A4AFA24FBE357C7160D09701977A28BD1338AF160042FCFC190229DC804C39128201E3816B72E09407668E6C8A2BBBA95470B57468FED36D3CDE10BE61F67A389A45771F49F52E94C1649C03877E038E670742CD606';
wwv_flow_api.g_varchar2_table(52) := 'C44C81FEABB35184F81D25D78328CA6033DB9938C6D2F32C9B4F1614C53FE82B96D2654050AA4812543D077A31E61FD33423F03FBF341B28D1247615F60B8DDD7250AE6144C0D61B4DA548F0E69DB7D9F2FBDB7CF80388BFCF4B50F738D50EBE2C6068E6';
wwv_flow_api.g_varchar2_table(53) := '988BFB36BB81DAF42FF8D1E0BABED031BB2524D0AF231180A01A4916DE29807EA7EB6B41AF0AC0A275607FDFA9D23B2CDF3EEB5CD4D99A5B4923DF31AE35DD6A2C16959BC4FDAA48BF1D6B739B4A6B307CBFE5F447E3C404C47F46D16A1BADA3968BEFAA';
wwv_flow_api.g_varchar2_table(54) := '8EAEB9C8CFB98A12A1A50C763E2518B52693EB8256F5B3538CB2CB0F41B41D036E9365AB3078DC620946C1E68CA72F81AD1001809CC5B836ADE57EF4FBBB872AB52A1008A82F5C76DBE5CDC5FD915EE5EC7BF05448FA803601FCD909A4BA9DEDA41F9AFB';
wwv_flow_api.g_varchar2_table(55) := '226BF19EA04DA410A8D56A536E5579C9D630F6FC88C7FBFD1F3FDC9E5C9623FF9F393BEE8DE276FE382E8007C093E0D9533E6F097CAB6D89ADA6398BC63B8B698644A49CC2F17B22BFEA7B396BF73624540985D79F9123EDF8C633E3DD1577D9F0FAF3CF';
wwv_flow_api.g_varchar2_table(56) := 'B7058F9E7DFA9D3E7220839852010017ACFE17ADBF7BF76E15DFFD235E04EE22315AE0F7E3DF1EFD54F7DDDFCEDF6F23B9AB953B54405ECA98A398DB8A1925261CC70104285C1DFFFDE4A7A97CAF3E1FC51281528AB8E64C559F9C6380B157602E3B8D03';
wwv_flow_api.g_varchar2_table(57) := '3170208B1DF55967C77F3FFD394ADFF969BCE84EB68062740004626A3476649670C85D89D3B24036004808100B9A96D338448DA7C7973F7A0B1E3FBBFCEBFD3A7543E93B8378F8BC3D3B729AB10A803CE491C6CD01C0104B59AD74EC840CEACFFEF8E547';
wwv_flow_api.g_varchar2_table(58) := '5E949EBF38FEF2FBC9D09387C12A2048CE445C9E078FEA0707E5B1F434E256A266079C196D4E7F5C4B78F4F4D315DBF5E8804B0090324B8B5A969461DC948B140C50C58CBDCA21EBBB4E24C003071479FFF9B7C73FA0F0FFF9E9ED9999526B6FB7A92C28';
wwv_flow_api.g_varchar2_table(59) := '0C31C2BC0E146E6465BA52CC291D1D7F78F21F87FFF7F9FB80CA2076726C518839E1DE1533B1E740DD762A1B000426006490A4F9993071484CA58A4E3FFF875BF0E4F98BF3D74160A65A5182D4D7D6A20B0E30DD107543962038000489615BB8C001C85D';
wwv_flow_api.g_varchar2_table(60) := '7F58EF6AE0DA26CC5AA905363D73E6DABC3DBF7CFC1F5DF73EBD3C2B5100CA7D4682AADA2A943197005600080788834031837205509AE44E06C03360BE9C2524249AC0F5BA588EDEBCF8FE59F0ECF2C5972B45B943EE52B7CE3066E6348ADB28B5C41E99';
wwv_flow_api.g_varchar2_table(61) := 'F0697E3B602C612313238DC2D597EF9C058F3FFCF2F975143B3E0C4AE0727636233B659B98F2ACFD126E256E2101D077A209759426E5E2E8E39FDF2F0B9E5EFE93FC687400AF78B7EE9C86AA114040C099CA45347216C4BF11D92B23C644A8677F7DAF2D';
wwv_flow_api.g_varchar2_table(62) := '787E1C0240180CAC4F803A03607450E91CC85DA4CD806AC15DD02806687FC2EEDE8065DDFF6A831D8D7074FE5DBE24FCF991E401D07A48A974B4DA966409ACEB04AB6110B8D3B367793E145A8B0277D03244772AFF9600520562FFE6F23BC4FF7A037D07';
wwv_flow_api.g_varchar2_table(63) := 'A2DFC67E3D5C00D6ADC76A6110410E0031CF3B209800579F60045CD7C35DB10B37674F9000C49CFCAB9920B12739605B03A297ABCF4F1E3AFFDF9CA1308EE054558500E0DB93F5769081100021A771F9A45540155D570140B65DAF87F895793184C9FCA3';
wwv_flow_api.g_varchar2_table(64) := 'C04446E226390261BD361C7C73F6F1D9838E3E1FFE3A03150375E3A46795DEA2C5004A2D52180BB68EE3242E7700BA8E3D2B39380038385312074C346E2CA128D0B6130312E8CD035E131F5DBE3C15076FAA016AADDB936EDD31173A6318526DF135B81C';
wwv_flow_api.g_varchar2_table(65) := '0964090F6D92C9DCAE5600647C951C50897D97874EC4F0E5E172E0E997531D76A0B2017579D5ADB7EB7E1EA8810E7F4D2190C073DE440E15BE4929F5E6F22F4980D1AF8336EB9348507FFC6075E0D359459024E80060957B08DB085E7A00B01A0F5EFF2E';
wwv_flow_api.g_varchar2_table(66) := 'B8C033D794976BA569A313608680DA3A86EF3783439651AFBEDF9E6C6CB4101F6A077EB912082A40521480AB825CB37B1BA45C0170725EA63695466093E3BBE38E25B5850224FCA6F4B791430E18C9CB4089A0D35F1FA400FCDF5560AA8F14C80142091C';
wwv_flow_api.g_varchar2_table(67) := '7276541CD078C101E3903AA341B170C8814DE25B8C0EE34810D8E6FD878798FF3FDA4129729C7E9B97577567CF9C3C2FE8829B170B9C468E4BC637CBDC442525E4FEE6F1037480B76112830033C899255B06A86800722D572076928B6B66CC18FF5A3561';
wwv_flow_api.g_varchar2_table(68) := '4389AB1874F40087E0D7AB04EE15847702701062A7A6E5808E53333260CC082416AAD8B37E92065AF47F77984D4595DB54C18ABCB2A2F0F2DEBDF0F22D00D445C24911A0267700525BA64C1C47004673C48E8F0961009A6C804659A2A57DDDB0E7E8A039';
wwv_flow_api.g_varchar2_table(69) := '28B40D5B585EBF2FF0D3F3FBBE00F96303802E163F8FC83D68F66799004F64D96292F798719C4372A684B8831B4B0ECA689CBD26D9DC33051EFF1A0060132D70206CB7619EFEDA7636AB70351B240F500415E4E080699AC963A2C1FAD8A604E3DB7804F0';
wwv_flow_api.g_varchar2_table(70) := 'DE50646A3C7D75BF19F04D98B4970335B7603B073024D5BCA11A9579F606AE39597C4532801801903646A541107A6E16586E9700E2A77B3582E747DC4602B20CA512F1A0D62D3278C245C8062096B0C9C6484E5B681569E8842273DB11195F5180E04C98';
wwv_flow_api.g_varchar2_table(71) := 'F4F25E6F475EB5A45D42D8082A8A425D5404601A0739AC7DFE5D17B1D4AA076C0484048C51423428C6EE64CB6664CF9D26D56541A9DB8CEE7506CEDD6D3E988846D6158100E4529E1D7F5BE5A11465ABF3FF14E40802A0A60BA692D891F26AC55CDFF5EB';
wwv_flow_api.g_varchar2_table(72) := '754C12B3AC69E58705DF5636E78FEF5302942B380DA2C17370105A54F22C44DC0EB99D0B10AD4D26103775F4D8B3232FB14FCCC4B81AB61C72002ECAC9C966D9574CA6374FEF31045C49DC2D17C12C5F5581AAD987FFC9B7CDD0655037AC6204525A0E47';
wwv_flow_api.g_varchar2_table(73) := '41FD20614C397D0ED05B662FB7096138E9D9EB030D47CFEE51028EB89B6014074AE6169B410EB1A31B1C80C282CC1D024B5D6740054843644743A1C962E2D5036C404D2DB5043A68F60E48342A366D7B6DA5447BF294E0FF39B7B22DD56DA5FD0F2F9097';
wwv_flow_api.g_varchar2_table(74) := '384FC8E292C56D5FF12219AA32485ECE2067B0954196E5CEF6499FC9246483271A1B7ABA3E9211D81077067F7B1006F532FAACAAFA54550D74B50E81223ABE83489506C5A4DB2C72209F70CEA7BB1C930BD38BAFE5D4695BBE379E805FDEFC56B3113DA4';
wwv_flow_api.g_varchar2_table(75) := 'E8B1C4DE15D0E3A4BFD1138C1C5BAD511AC7FF5AF0103A7B368E40AD179B1955D96293511AE6599633DA1356FC3AFA40189F696702065D5372755694F0FEF893E0271E0EC28BDC20EDA8775D0463D55DDE8EC588924593CDA245A11029ED2A64B6B4A471';
wwv_flow_api.g_varchar2_table(76) := '5356337F7B3F4D514DCA7257AFD5F5C1CA933DB742F04F80C3E5F8E3F820F089D74575825DC5874540C084EB4EF073DEEFE1093525AB6055DDEF5A4C15123F18609386D3AADEEE360E45B5D8558D21A0479224C805BF6EC1E8F889FBA45B1087249747E9';
wwv_flow_api.g_varchar2_table(77) := '6FC6F77E7EC5649F4B1BA798ECEED04544CB95E0A7560FD70FA6169952C5B6F6BDCE1198FFDA5A1A5B54D53CA08834D8574D95ABAEA402512C6D16C68048FC13184855DCFEEFE82878CBD1758879DA49CFC2AEA313B09583B06AFB1CD3204C4E0ACD091C';
wwv_flow_api.g_varchar2_table(78) := 'A5A8FE6BBCC1ACAA7C69BC0145EA09CFBC2998F980E4B95047EEEAA629224A8D376C1D4DC2202548A93D5943C736BE8621C1F9F33BA383C06DC863374CFF283FC3CD8E771C002E4C300221646CA60A7F9D67F9DA4F15AAA2DAF23B5F5FBAA2D84F66EBD6';
wwv_flow_api.g_varchar2_table(79) := 'DB01D57120CF733FA62D016553AC7CED0AF33541A4E81737937DB1CE26B9EA29DF04091B62A0B340C1CED52804B8FBE2DF630978FB73E0527BE62329B187D8216D141D0561B8E254CFF2C3C413A8177DA8B503A80E135FD1BC9E2F57077DB55FECEEF530';
wwv_flow_api.g_varchar2_table(80) := '59996DCF8A79B5DB3587196B09B8AF32392DCDC7B9BE2EF4F4FBFBFBAABADF2C31695D0FA2C7ECFDAE119FB38E2CE0B4ED574BDA6028BE783B3A1FFE0347035718C7CFD293C84CAE56CF911BF6E3230F48384F2217514D771A65D3ECB66BE5D78BA55F97';
wwv_flow_api.g_varchar2_table(81) := '555595A55E72B53B0448C9B429CB5A3FF8721A233AF57D932F178D9E725FA05A57A5E66E7F689A52138008DCF02F1CDA99C2C54E2709B6C9A9D8E55DD52101CFF9E1FDF105116C219C63B265D817C50EB30A4D20CA348E05988725414D0F37F9BA385495';
wwv_flow_api.g_varchar2_table(82) := '0E03E0871432FDBAAC67EB6CDEE8F788CA4A1D058360D1ECEA5CB53B60BD9C685738CD1962B12BEB804B6756971B6A38E79AFD58307C054473D82FE025DC56ACDEFC329680AFA157DFB7855DE6D8164D38976F1883E3FA1373E5C5FC942F73530048B3BA';
wwv_flow_api.g_varchar2_table(83) := 'DA2D94D101A88CA3DF238160DE3475281665B34951E5DBA69A28EED49A879BBAA96731C594CD76553573182141B14ED022715E210080CBCBBD99709140AB5DBF19AB837E6D0FE74E08AD6EE932434E38549108020980916B774DA02785D96471D8562D01';
wwv_flow_api.g_varchar2_table(84) := '1A8680F2607A4B69A15797F9DBA639ECF7FB69AD77B94A845EFBA1325CB473B3461B43B5DD4CB240D273D15CCA588F7DA4ECE898E4A5EFE70EE2B144EB7D30F240FCCE071147CF0D2E6AF2E6C259FD36918110AE6CF55B428491EFBB343B94DA8DED2E08';
wwv_flow_api.g_varchar2_table(85) := 'D86D388358E5DA1B14BE5E6DA9FDDC4ECF9A531475559945CF1D339BEAFDD13A9072B72D08A21758DA99D3EF9E33A76E8909F38CFFE9CB22997A824B63B8F0DD672375902989481EF5CBC2495B7D8F3BB2414FB833AFA94BE0FC1E78228D0BEDDDEA4931';
wwv_flow_api.g_varchar2_table(86) := 'B92460EEB48F57D3926B028C9BDB9BBF856A0928F57ED166A1005079F964BEAD768D9E55A8565B0DE5C4ED16252239258B6508D63603D4D4DCC1EDC88E997FDF422F1B23129BC4E717272F97416B2162F5AD618A0886F67335D58BDC3B2AAF2F4CA02E96';
wwv_flow_api.g_varchar2_table(87) := '48D942EF8030D836BB0D3190E688E7684B98AFA75553CE10121A4C3216F8EB627E74A2D2C56450E7A0D79628DD50B44C185B811335FA8291686C7DE8ED0F5DF745B072F8F909747D8EC72A355B452018EB2541647224A0CEA86B08D81C09A07BFD7CB739';
wwv_flow_api.g_varchar2_table(88) := 'AC267A5C80DEE46595510D7673A330ACB5145E8AB98E0919A02AF4607464501B02EC9A07B381D2D83F70C70FFA9B03480C6674E1CD4F23097803277F4ADD509E6FCB257A0EEFA75E03EE39143BF08020AA8936DF43B1DF36FD1DA0575ED5B5B6F5AD4F55';
wwv_flow_api.g_varchar2_table(89) := '6E2E363737D36D355916DBA63D0CCD5ADF976B02B401AD8533ABCA46D38398F2930C93C32552475A53ED03C04BC79D07FFFFFD373094692046EC47D8C39DE321F14E41C83DFA2554EBAD563C3A986B5D6308204702EA6DA989A90E3922857D5D6A3FA7D5';
wwv_flow_api.g_varchar2_table(90) := '5039592EEEF5DB6B05FA2D73AD66F76634C2E9FEE00324C0F839C112E1EB80DE040F518482FDFABFA382C03F49B7EDAE4AD90071CF12258F7B8FC54D6DFFA0CA0E75552FB2CDE1B05778278E3E60932FE6F34DAB849142B1D9D61A87857EE2F3C361E32B';
wwv_flow_api.g_varchar2_table(91) := '981E0C32737A386C6BCDD861BA8E2005F74AF35B32AE64A1177595226BB12BE79BFF1F1504BEF96D31ECEAC5053FD2CA4F48A4C444020725D6B96F8E4946BD44D486C1A5224C2A6B310A82B5464095896F8E400D474350647920FC5C1F8C4245AF561B91';
wwv_flow_api.g_varchar2_table(92) := '73A8EF10333383859E7920D0F716EC93BF8DDB016997CAED9ADD3BAB18E8F16C0BE212089284AC38521414816A20F208E9F24880A2D8F5912883F60DAA711AA9A650293D9E3E04AF9798BB3BF70676A0C2458286795393827E723CBD1D751EFCBB91017D';
wwv_flow_api.g_varchar2_table(93) := 'EA3D4460DEF57390B23D87009C6602072978E8D870D095BA59A1C37A55CFE733EF7C8CF0055EA2FB198FF4FBA86C1E568F094F067F3957733E74426080E917FF1A2D03AE0BD8273906F47CE7F45C114C533D18262449EDA1C55A84010D37BBA645CD3ABD';
wwv_flow_api.g_varchar2_table(94) := '4AF01AB00A015F411C06110E422DE9ABBFB51CC3DBD13BC0026CDD9D07F6912C1F2881F33D92F8DCBE202F8A12860C66052265937AAB516F3729BE0690184777AF7D98721646C37D78EA51717B28BE0603779412FAD717801D4464AA64CCB1C5FC874785';
wwv_flow_api.g_varchar2_table(95) := '6700873EE13D709E48E8AC3437C832E7EACB0F5AC040098CAF24D27E925EF608787A6809A097AD3A697B7E633F8D8983EFA55D9F4E2C781CB1B88D6F496CF87E5A76AD3F7A883BBAAF3A63CD4F5B5EA83A820E757E33F83D02BA5F16E20C073AAA60F9F4';
wwv_flow_api.g_varchar2_table(96) := 'AC485B2DF07A3E035C3022D9195520FD57DA390079B2557E1C97CFCF0F9D46EA98888DB7FEB38851B2AEBF5600FE2990F49A180E47025ECC28E082DDC494A8BF5DFDF8CE1825DC370126FBEE903E6A02FAAA84710478355B410281C3B838D78E040F2243';
wwv_flow_api.g_varchar2_table(97) := 'C0F3D3D3D0D60112062CFDE6B31155915FBA28D08131386E80E797D3E2656AB5821D622B192515ABA364737D7F9019F9E74AAFC9EF7263BBF81F9E5F5E96FA2A25B2AFD48061221CF9F3F72384E02D1DB055EE99AB174DC053FB0A2EE20D93B2DFD6C3C2';
wwv_flow_api.g_varchar2_table(98) := 'E37777826FE1759797E0EF40AC003BD802C5D01E32043C3EB472A85F53634E5B4D25EF8DB080B435F83BA448D14A32AA28313778D4EB7F5A5E387E90123DD795A1E87D458AFC584E720777BDB9723DE85F5EA96E700C01404EF447088304249A80A7C767';
wwv_flow_api.g_varchar2_table(99) := 'FD9DA8B2DF5449718718B1B1AD52FFFBA9BBF241314EBFFDC8F5C4471F7DF9E187E2A32FBFFD28F6D4F259E3459D0421B34AAFD5E1AECF255C1F1EE2C135FE2EA0F3E26702E07A0E74C6F4A21FC9F38312F85FD2AE46356E2308D33C41DFA114FBA28074';
wwv_flow_api.g_varchar2_table(100) := 'AA62DC9EE238B16C27A99DE49EC38FD11728C5342571835B921A426064C34A565B2453ACBD82BC1B15166C5A041C7D830269CB6F76D72B69EF747262F9E32CEBB0CF9E9D19CDFECDEC371A6D1DED8F46FB5B234AA52EC4C7E86F974F13F9398EFC9BCE63';
wwv_flow_api.g_varchar2_table(101) := 'C759DA747A0E2740DFBCB3E86CF67AF337E7E60EFEF9F7ED5B1FB4AC0E188B513FCA4F930CC7F5D23924B87B7DA072FA76D44973C1BEB3E8DCFA62F5CEFAE74B4B776FDC7DE5ACAEF6E6E7E70EEFF1E36944C2DDAF1F5FDA035EFFFEC77FB7EC1583C35D';
wwv_flow_api.g_varchar2_table(102) := '73F9C570C5F1D79C19696181D325DFFFE4CD6424C250EE463046A1DA008F70BD96DE3C17A41D6CCA5B088EDAA228637E70E43EB00D0ECB14921A966B989CC269818B7AFBF637BFFCFDFACFCB4F88AF7DF4E95FFF1BD64C98A6399CA7C1EC0E0D985A300B';
wwv_flow_api.g_varchar2_table(103) := '7169F02CC5EAE778EC77032B9A0EC0A0544072F860A5666DF2B4EFDC68DF73735E9120AB6F35602F8E82C9ECB1BCCCFF51B50189961B18D2F2F6E403063C843467081783F6EC0D6F5052FB3EF27499CDA7DD59F29EDB8A2054F1C059821FE9CBBE38F3D5';
wwv_flow_api.g_varchar2_table(104) := '583A08A4D34FE7FBE293F3528A1CCD288920542533B50226EE2320D8FF0044EBC6606343C9F7502AC0324B6F7D7AADBB028C9208C5EC2B3A20C98467F297B5FF462F0F4E2ACBE6AA46A29A44877A421D7B8F35513E991B998EA15D59D5483A7CBCB22C8E';
wwv_flow_api.g_varchar2_table(105) := 'A3EB0B053C7A38D0CF6635F73A73D7EEEEB996064F5DE4B53F3CAB96E290B0786DA9300B266CD9382AA4B9C75E17134FD7DED0A4DD45EA159083CFBC15CFDAE84FD17B2B057C7565D6F065AF1905868749BD5282A9DABCE360591CC3443B58638982A4E1';
wwv_flow_api.g_varchar2_table(106) := '85E72BD0FCC2EEA1812D2D54D5CD5F96BA30773A9F53FFA2E2C8530AD06F873DDA92F81D09B7656446D64E44C5BB4254391781E8265B80F07BC2C32999FCEC59D9F2FE72CDDF35D810B75751C04F43AB096F70FE6CB9AF227D194BD50B080389853EA863';
wwv_flow_api.g_varchar2_table(107) := '772D3949C5896B70AA2638594B34A0F862DB27E27E3287FD9ED6570DA668ABCC9DAFBB92227C675BB3E0F52539C6F550932DF4694694943402D966444486A986221D1D93383A552AA17E4213150F40D5C1E4407C1A0B4DE67AE590DE9544E3C6AE40B06E';
wwv_flow_api.g_varchar2_table(108) := '72ABA898D718B3EC3CEBAA806FB7ADD99004DA6BFB55E66F1C267E2CCC3B0D08F3DA09B293501CB656C4B275C2843968B35DC8807F61A2DAAC41695325D8A561E391081CB3266F9A2630327FD8ED4E142A824813EABF9C9582E010C9EB18376ADE0B2DF7';
wwv_flow_api.g_varchar2_table(109) := '992B80807CC0D18CAA784441EC6CA3D3598F3D30A04C290037424730BAAEDB5D92B6EA0AF8B1EB3060CFB05AB0222E87814FA1ECBC598CF5314E14D7AB483E1A6722E48527B5DF327D9F294ED47CDAC759026AE14D07E07116A6B1DF82E0E87EC33A1A3A';
wwv_flow_api.g_varchar2_table(110) := '53163D7BE2361DBF5680B91E4849D979C0A7F8E418575D7C0E53BE0048BC64DF9D611F45B2CD683AE6E32CCE889EEBE457D500E918B5F584C1D9C24584A64F5E74558069BBAEC161DBF6F6F6F6CB496CBFBCC180922A57383D3ECE846C0C10924FB65404';
wwv_flow_api.g_varchar2_table(111) := '9C8390029004201C262CE137046529887D00227E37C928E22050C40502805C7E942649460150CC3583A1A020C0088112E22F4270B8E67AB6E10A418742505D56FEBE2B65D1EEF3773C92816604311445BFBF5FD066DA692462AA9004290D7DC313EA79A3';
wwv_flow_api.g_varchar2_table(112) := '2502A0AEEE97ECCCB07B00B81CC77D716E9ADEA6799E9F96C5FA608CF1D65B63AC35E1E1F3FF87F3566B5DD75AB7FDA4DB09C586DF3C0894D70F55214001228EB1B4F29748D3E02660A8EE158E50446980E3976402F812A5F791B54375A4AABA4F31B44B';
wwv_flow_api.g_varchar2_table(113) := '6C0C74FDCE1D27CC5262619177E71E5FEFA2FE10B537D110CCF3B5DD39C0981888A1009C19FF05FE43F49EC350F41A0BB0400039410E1098007A917DADB1405905CBBE0FF126CF10B9677D4CBDF775DB445AAD45A060D6F6379EBBEBFE362637CBA1EAE9';
wwv_flow_api.g_varchar2_table(114) := '3AD43D1C2913C1208E956A5878A4EBE448E89740CA582C3255CF4F67890A23C32CC1872640045601FFC7911787B656E5BE72F946FA1E05E4B7152122222222222222A20FBD0053C64F3405FF08560000000049454E44AE426082';
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784243727161151278)
,p_file_name=>'img/persona-male04-apex.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/utdevmode_js
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2F2F204E616D657370616365206372656174696F6E0A7661722075744465764D6F6465203D2075744465764D6F6465207C7C207B7D3B0A0A2866756E6374696F6E28242C207574696C2C207574646D29207B0A20207661722067496E697469616C566572';
wwv_flow_api.g_varchar2_table(2) := '73696F6E2C0A2020202067496E697469616C5374796C653B0A0A20207661722067437573746F6D5374796C65203D207B0A202020206973437573746F6D3A2066616C73650A20207D3B0A0A20207661722066696C655265676578203D207B0A202020202F';
wwv_flow_api.g_varchar2_table(3) := '2F24332069732076657273696F6E206E756D6265720A202020202F2F2435206973207374796C650A2020202064656661756C745374796C653A202F282E2A29285C2F7468656D65735C2F7468656D655F34325C2F29282E2A29285C2F6373735C2F29282E';
wwv_flow_api.g_varchar2_table(4) := '2A3F29283F3A5C2E6D696E293F285C2E6373732E2A292F692C0A0A202020202F2F2433206973207374796C650A20202020637573746F6D5374796C653A202F282E2A29285C2F66696C65735C2F7468656D655C2F34325C2F765B302D395D2B5C2F29282E';
wwv_flow_api.g_varchar2_table(5) := '2A3F29283F3A5C2E6D696E293F285C2E6373732E2A292F692C0A0A202020202F2F24332069732076657273696F6E206E756D6265720A20202020636F72655374796C653A202F282E2A29285C2F7468656D65735C2F7468656D655F34325C2F29282E2A29';
wwv_flow_api.g_varchar2_table(6) := '285C2F6373735C2F436F7265283F3A5C2E6D696E293F5C2E6373732E2A292F692C0A0A2020202064656D6F5374796C653A202F282E2A29285C2F7468656D65735C2F7468656D655F34325C2F29282E2A29285C2F6373735C2F44656D6F283F3A5C2E6D69';
wwv_flow_api.g_varchar2_table(7) := '6E293F5C2E6373732E2A292F690A20207D3B0A0A2020766172206756657273696F6E4D656E754964203D20277468656D6556657273696F6E732D6C697374272C0A20202020675374796C654D656E754964203D20277468656D655374796C65732D6C6973';
wwv_flow_api.g_varchar2_table(8) := '74273B0A0A20207661722064656661756C7456657273696F6E203D207B0A2020202069643A202744656661756C74272C0A202020206E616D653A202744656661756C74270A20207D3B0A0A20207661722064656661756C745374796C65203D207B0A2020';
wwv_flow_api.g_varchar2_table(9) := '202069643A202744656661756C74272C0A202020206E616D653A202744656661756C74272C0A2020202073696E636556657273696F6E3A202730270A20207D3B0A2020766172206E6F5374796C65203D207B0A2020202069643A20274E6F2D5468656D65';
wwv_flow_api.g_varchar2_table(10) := '2D5374796C65272C0A202020206E616D653A20274E6F205468656D65205374796C65272C0A2020202073696E636556657273696F6E3A202730270A20207D3B0A202076617220637573746F6D5374796C65203D207B0A2020202069643A2027437573746F';
wwv_flow_api.g_varchar2_table(11) := '6D272C0A202020206E616D653A2027437573746F6D272C0A2020202064697361626C65643A20747275652C0A2020202073696E636556657273696F6E3A202730270A20207D3B0A0A2020766172206756657273696F6E73203D205B0A2020202064656661';
wwv_flow_api.g_varchar2_table(12) := '756C7456657273696F6E2C0A202020202F2F207B0A202020202F2F202020202069643A2027312E30272C0A202020202F2F20202020206E616D653A2027312E30270A202020202F2F207D2C0A202020202F2F207B0A202020202F2F202020202069643A20';
wwv_flow_api.g_varchar2_table(13) := '27312E31272C0A202020202F2F20202020206E616D653A2027312E31270A202020202F2F207D2C0A202020202F2F207B0A202020202F2F202020202069643A2027312E32272C0A202020202F2F20202020206E616D653A2027312E32270A202020202F2F';
wwv_flow_api.g_varchar2_table(14) := '207D2C0A202020207B0A202020202020202069643A2027312E33272C0A20202020202020206E616D653A2027415045582031392E31202D20555420312E33270A202020207D2C0A202020207B0A202020202020202069643A2027312E34272C0A20202020';
wwv_flow_api.g_varchar2_table(15) := '202020206E616D653A2027415045582031392E32202D20555420312E34270A202020207D2C0A202020207B0A202020202020202069643A2027312E35272C0A20202020202020206E616D653A2027415045582032302E31202D20555420312E35270A2020';
wwv_flow_api.g_varchar2_table(16) := '20207D2C0A202020207B0A20202020202069643A2027312E36272C0A2020202020206E616D653A2027415045582032302E32202D20555420312E36270A202020207D2C0A202020207B0A20202020202069643A202732312E31272C0A2020202020206E61';
wwv_flow_api.g_varchar2_table(17) := '6D653A2027415045582032312E31270A202020207D0A20205D3B0A0A202076617220675468656D655374796C6573203D205B0A2020202064656661756C745374796C652C0A202020206E6F5374796C652C0A20202020637573746F6D5374796C652C0A20';
wwv_flow_api.g_varchar2_table(18) := '2020202F2F207B0A202020202F2F202020202069643A20275669737461272C0A202020202F2F20202020206E616D653A20275669737461272C0A202020202F2F202020202073696E636556657273696F6E3A2027312E30270A202020202F2F207D2C0A20';
wwv_flow_api.g_varchar2_table(19) := '2020207B0A20202020202069643A202756697461272C0A2020202020206E616D653A202756697461272C0A20202020202073696E636556657273696F6E3A2027312E30270A202020207D2C0A202020207B0A20202020202069643A2027566974612D4461';
wwv_flow_api.g_varchar2_table(20) := '726B272C0A2020202020206E616D653A202756697461204461726B272C0A20202020202073696E636556657273696F6E3A2027312E34270A202020207D2C0A202020202F2F207B0A202020202F2F202020202069643A2027566974612D526564272C0A20';
wwv_flow_api.g_varchar2_table(21) := '2020202F2F20202020206E616D653A20275669746120526564272C0A202020202F2F202020202073696E636556657273696F6E3A2027312E31270A202020202F2F207D2C0A202020202F2F207B0A202020202F2F202020202069643A2027566974612D53';
wwv_flow_api.g_varchar2_table(22) := '6C617465272C0A202020202F2F20202020206E616D653A20275669746120536C617465272C0A202020202F2F202020202073696E636556657273696F6E3A2027312E30270A202020202F2F207D2C0A202020207B0A20202020202069643A202752656477';
wwv_flow_api.g_varchar2_table(23) := '6F6F64272C0A2020202020206E616D653A2027526564776F6F64204C69676874272C0A20202020202073696E636556657273696F6E3A202732312E31270A202020207D0A20205D3B0A0A20207661722073746F726167654B6579203D207B0A2020202076';
wwv_flow_api.g_varchar2_table(24) := '657273696F6E3A202776657273696F6E272C0A202020207374796C653A20277374796C65272C0A20202020646972656374696F6E3A2027646972272C0A2020202064656661756C7456657273696F6E3A202764656661756C7456657273696F6E272C0A20';
wwv_flow_api.g_varchar2_table(25) := '20202064656661756C745374796C653A202764656661756C745374796C65270A20207D3B0A0A20207661722073657373696F6E53746F72616765203D20617065782E73746F726167652E67657453636F70656453657373696F6E53746F72616765287B0A';
wwv_flow_api.g_varchar2_table(26) := '202020207072656669783A202775747248656C7065722E7468656D655374796C65272C0A2020202075736541707049643A20747275652C0A202020207573655061676549643A2066616C73652C0A20202020726567696F6E49643A2027270A20207D293B';
wwv_flow_api.g_varchar2_table(27) := '0A0A20202F2F6164642074686520656C656D656E7420746F20746865206E617662617220616C6F6E6720776974682074686520636F72726573706F6E64696E67206D656E750A2020766172206164644E61764D656E754974656D203D2066756E6374696F';
wwv_flow_api.g_varchar2_table(28) := '6E28704E61764D656E75456C656D2C20704D656E7549642C20704D656E75436F6E6669672C20704E61764D656E75456C656D4C696E6B29207B0A202020207661722069636F6E4F6E6C79436C617373203D2028704E61764D656E75456C656D2E69636F6E';
wwv_flow_api.g_varchar2_table(29) := '4F6E6C7929203F20272069636F6E2D6F6E6C7927203A2027272C0A20202020202069636F6E507265666978436C617373203D2028704E61764D656E75456C656D2E69636F6E20262620704E61764D656E75456C656D2E69636F6E2E696E6465784F662827';
wwv_flow_api.g_varchar2_table(30) := '66612D2729203D3D3D203029203F202766612027203A2027272C0A2020202020206E61764261724974656D203D20273C6C6920636C6173733D22742D4E617669676174696F6E4261722D6974656D27202B2069636F6E4F6E6C79436C617373202B202720';
wwv_flow_api.g_varchar2_table(31) := '27202B207574696C2E65736361706543535328704E61764D656E75456C656D2E636C61737329202B2027223E273B0A0A20202020766172206974656D4861735375624D656E75203D2028747970656F6620704D656E75496420213D3D2027756E64656669';
wwv_flow_api.g_varchar2_table(32) := '6E65642729203F2074727565203A2066616C73653B0A0A202020202F2F69662074686572652069732061206D656E7520746F2062652061646465640A20202020696620286974656D4861735375624D656E7529207B0A2020202020206E61764261724974';
wwv_flow_api.g_varchar2_table(33) := '656D202B3D20273C627574746F6E20747970653D22627574746F6E2220636C6173733D22742D427574746F6E20742D427574746F6E2D2D69636F6E20742D427574746F6E2D2D68656164657220742D427574746F6E2D2D6E6176426172206A732D6D656E';
wwv_flow_api.g_varchar2_table(34) := '75427574746F6E2220646174612D6D656E753D2227202B207574696C2E65736361706543535328704D656E75496429202B2027222069643D2227202B207574696C2E65736361706543535328704D656E75496429202B20272D627574746F6E2220617269';
wwv_flow_api.g_varchar2_table(35) := '612D686173706F7075703D22747275652220617269612D657870616E6465643D2266616C7365223E273B0A202020207D20656C7365207B0A2020202020206E61764261724974656D202B3D20273C6120636C6173733D22742D427574746F6E20742D4275';
wwv_flow_api.g_varchar2_table(36) := '74746F6E2D2D69636F6E20742D427574746F6E2D2D68656164657220742D427574746F6E2D2D6E61764261722220687265663D2227202B20704E61764D656E75456C656D4C696E6B202B2027223E273B0A202020207D0A0A202020206E61764261724974';
wwv_flow_api.g_varchar2_table(37) := '656D202B3D20273C7370616E20636C6173733D22742D49636F6E2027202B2069636F6E507265666978436C617373202B207574696C2E65736361706543535328704E61764D656E75456C656D2E69636F6E29202B2027223E3C2F7370616E3E27202B0A20';
wwv_flow_api.g_varchar2_table(38) := '2020202020273C7370616E20636C6173733D22742D427574746F6E2D6C6162656C223E27202B207574696C2E65736361706548544D4C28704E61764D656E75456C656D2E6C6162656C29202B20273C2F7370616E3E27202B0A202020202020273C737061';
wwv_flow_api.g_varchar2_table(39) := '6E20636C6173733D22742D427574746F6E2D6261646765223E3C2F7370616E3E273B0A0A20202020696620286974656D4861735375624D656E7529207B0A2020202020206E61764261724974656D202B3D20273C7370616E20636C6173733D22612D4963';
wwv_flow_api.g_varchar2_table(40) := '6F6E2069636F6E2D646F776E2D6172726F77223E3C2F7370616E3E27202B0A2020202020202020273C2F627574746F6E3E273B0A202020207D20656C7365207B0A2020202020206E61764261724974656D202B3D20273C2F613E273B0A202020207D0A0A';
wwv_flow_api.g_varchar2_table(41) := '202020206E61764261724974656D202B3D20273C2F6C693E273B0A0A202020202F2F61646420746865206E617669676174696F6E20656C656D656E742061742074686520626567696E6E696E67206F6620746865206E61766261720A202020202428272E';
wwv_flow_api.g_varchar2_table(42) := '742D4E617669676174696F6E42617227292E70726570656E64286E61764261724974656D293B0A0A202020202F2F43726561746520616E6420696E6974696C69617A6520746865206D656E7520656C656D656E740A20202020696620286974656D486173';
wwv_flow_api.g_varchar2_table(43) := '5375624D656E7529207B0A202020202020242827626F647927292E617070656E6428273C6469762069643D2227202B207574696C2E65736361706543535328704D656E75496429202B2027223E3C2F6469763E27293B0A0A202020202020242827232720';
wwv_flow_api.g_varchar2_table(44) := '2B207574696C2E65736361706543535328704D656E75496429292E6D656E7528704D656E75436F6E666967293B0A202020207D0A20207D3B0A0A2020766172207365744D656E7553656C656374696F6E203D2066756E6374696F6E28704D656E7549642C';
wwv_flow_api.g_varchar2_table(45) := '20704974656D496429207B0A20202020766172206D656E754974656D73203D202428272327202B207574696C2E65736361706543535328704D656E75496429292E6D656E7528276F7074696F6E27292E6974656D733B0A0A20202020242E65616368286D';
wwv_flow_api.g_varchar2_table(46) := '656E754974656D732C2066756E6374696F6E28692C206974656D29207B0A2020202020206974656D2E69636F6E203D206E756C6C3B0A0A202020202020696620286974656D2E6964203D3D3D20704974656D496429207B0A20202020202020206974656D';
wwv_flow_api.g_varchar2_table(47) := '2E69636F6E203D202766612066612D636865636B273B0A2020202020207D0A202020207D293B0A20207D3B0A0A20207661722067657456657273696F6E4974656D73203D2066756E6374696F6E28704974656D7329207B0A20202020766172206974656D';
wwv_flow_api.g_varchar2_table(48) := '73203D205B5D2C0A20202020202063757256657273696F6E203D206765744170706C69656456657273696F6E28293B0A0A2020202076617220636F6E76657274203D2066756E6374696F6E28704974656D29207B0A202020202020766172206974656D20';
wwv_flow_api.g_varchar2_table(49) := '3D207B0A2020202020202020747970653A2022616374696F6E220A2020202020207D3B0A0A2020202020206974656D2E6964203D20704974656D2E69643B0A2020202020206974656D2E6C6162656C203D20704974656D2E6E616D653B0A202020202020';
wwv_flow_api.g_varchar2_table(50) := '6974656D2E64697361626C6564203D20704974656D2E64697361626C6564207C7C2066616C73653B0A0A20202020202069662028704974656D2E6E616D65203D3D3D2063757256657273696F6E29207B0A20202020202020206974656D2E69636F6E203D';
wwv_flow_api.g_varchar2_table(51) := '202766612066612D636865636B273B0A2020202020207D0A0A2020202020206974656D2E616374696F6E203D2066756E6374696F6E2829207B0A2020202020202020766172206D656E754974656D4964203D20746869732E69643B0A0A20202020202020';
wwv_flow_api.g_varchar2_table(52) := '2075744465764D6F64652E73657456657273696F6E28704974656D2E69642C2066756E6374696F6E2829207B0A202020202020202020207365744D656E7553656C656374696F6E286756657273696F6E4D656E7549642C206D656E754974656D4964293B';
wwv_flow_api.g_varchar2_table(53) := '0A20202020202020207D293B0A2020202020207D3B0A0A20202020202072657475726E206974656D3B0A202020207D3B0A0A202020206974656D73203D20704974656D732E6D617028636F6E76657274293B0A0A2020202072657475726E206974656D73';
wwv_flow_api.g_varchar2_table(54) := '3B0A20207D3B0A0A2020766172206765745374796C654974656D73203D2066756E6374696F6E28704974656D7329207B0A20202020766172206974656D73203D205B5D2C0A2020202020206375725374796C65203D206765744170706C6965645374796C';
wwv_flow_api.g_varchar2_table(55) := '6528293B0A0A2020202076617220636F6E76657274203D2066756E6374696F6E28704974656D29207B0A202020202020766172206974656D203D207B0A2020202020202020747970653A2022616374696F6E220A2020202020207D3B0A0A202020202020';
wwv_flow_api.g_varchar2_table(56) := '6974656D2E6964203D20704974656D2E69643B0A2020202020206974656D2E6C6162656C203D20704974656D2E6E616D653B0A2020202020206974656D2E64697361626C6564203D20704974656D2E64697361626C6564207C7C2066616C73653B0A0A20';
wwv_flow_api.g_varchar2_table(57) := '202020202069662028704974656D2E6964203D3D3D206375725374796C6529207B0A20202020202020206974656D2E69636F6E203D202766612066612D636865636B273B0A2020202020207D0A0A2020202020206974656D2E616374696F6E203D206675';
wwv_flow_api.g_varchar2_table(58) := '6E6374696F6E2829207B0A2020202020202020766172206D656E754974656D4964203D20746869732E69643B0A0A202020202020202075744465764D6F64652E7365745374796C6528704974656D2E69642C2066756E6374696F6E2829207B0A20202020';
wwv_flow_api.g_varchar2_table(59) := '2020202020207365744D656E7553656C656374696F6E28675374796C654D656E7549642C206D656E754974656D4964293B0A20202020202020207D293B0A2020202020207D3B0A0A20202020202072657475726E206974656D3B0A202020207D3B0A0A20';
wwv_flow_api.g_varchar2_table(60) := '2020206974656D73203D20704974656D732E6D617028636F6E76657274293B0A0A2020202072657475726E206974656D733B0A20207D3B0A0A2020766172206275696C645468656D6556657273696F6E53656C6563746F72203D2066756E6374696F6E28';
wwv_flow_api.g_varchar2_table(61) := '29207B0A20202020766172206E6176456C656D203D207B0A202020202020636C6173733A202776657273696F6E732D6C697374272C0A2020202020206C6162656C3A202756657273696F6E272C0A20202020202069636F6E3A202766612D707261676D61';
wwv_flow_api.g_varchar2_table(62) := '272C0A20202020202069636F6E4F6E6C793A2066616C73650A202020207D3B0A0A20202020766172206D656E75436F6E666967203D207B0A2020202020206974656D733A2067657456657273696F6E4974656D73286756657273696F6E73292C0A202020';
wwv_flow_api.g_varchar2_table(63) := '20202063616C6C6F75743A20747275650A202020207D3B0A0A202020206164644E61764D656E754974656D286E6176456C656D2C206756657273696F6E4D656E7549642C206D656E75436F6E666967293B0A20207D3B0A0A2020766172206275696C6454';
wwv_flow_api.g_varchar2_table(64) := '68656D655374796C6553656C6563746F72203D2066756E6374696F6E2829207B0A20202020766172206E6176456C656D203D207B0A202020202020636C6173733A20277468656D652D7374796C65732D6C697374272C0A2020202020206C6162656C3A20';
wwv_flow_api.g_varchar2_table(65) := '275468656D65205374796C65272C0A20202020202069636F6E3A202766612D7061696E742D6272757368272C0A20202020202069636F6E4F6E6C793A2066616C73650A202020207D3B0A0A20202020766172206D656E75436F6E666967203D207B0A2020';
wwv_flow_api.g_varchar2_table(66) := '202020206974656D733A206765745374796C654974656D7328675468656D655374796C6573292C0A20202020202063616C6C6F75743A20747275650A202020207D3B0A0A202020206164644E61764D656E754974656D286E6176456C656D2C2067537479';
wwv_flow_api.g_varchar2_table(67) := '6C654D656E7549642C206D656E75436F6E666967293B0A20207D3B0A0A2020766172206275696C6452746C53656C6563746F72203D2066756E6374696F6E2829207B0A20202020766172206E6176456C656D203D207B0A202020202020636C6173733A20';
wwv_flow_api.g_varchar2_table(68) := '2772746C2D73656C6563746F72272C0A2020202020206C6162656C3A202752544C272C0A20202020202069636F6E3A202766612D6172726F772D7269676874272C0A20202020202069636F6E4F6E6C793A2066616C73650A202020207D3B0A0A20202020';
wwv_flow_api.g_varchar2_table(69) := '6164644E61764D656E754974656D286E6176456C656D2C20756E646566696E65642C20756E646566696E65642C20276A6176617363726970743A2075744465764D6F64652E746F67676C6552746C28293B27293B0A20207D3B0A0A202076617220676574';
wwv_flow_api.g_varchar2_table(70) := '44656661756C745468656D655374796C6543737346696C65203D2066756E6374696F6E2829207B0A2020202072657475726E202428276C696E6B5B747970653D22746578742F637373225D272C202768746D6C27292E66696C7465722866756E6374696F';
wwv_flow_api.g_varchar2_table(71) := '6E287229207B0A2020202020207661722068726566203D20242874686973292E6174747228276872656627293B0A20202020202072657475726E2066696C6552656765782E64656661756C745374796C652E74657374286872656629202626202166696C';
wwv_flow_api.g_varchar2_table(72) := '6552656765782E636F72655374796C652E74657374286872656629202626202166696C6552656765782E64656D6F5374796C652E746573742868726566293B0A202020207D293B0A20207D3B0A0A202076617220676574437573746F6D5468656D655374';
wwv_flow_api.g_varchar2_table(73) := '796C6543737346696C65203D2066756E6374696F6E2829207B0A2020202072657475726E202428276C696E6B5B747970653D22746578742F637373225D272C202768746D6C27292E66696C7465722866756E6374696F6E287229207B0A20202020202076';
wwv_flow_api.g_varchar2_table(74) := '61722068726566203D20242874686973292E6174747228276872656627293B0A20202020202072657475726E2066696C6552656765782E637573746F6D5374796C652E746573742868726566293B0A202020207D293B0A20207D3B0A0A20207661722067';
wwv_flow_api.g_varchar2_table(75) := '6574436F726543737346696C65203D2066756E6374696F6E2829207B0A2020202072657475726E202428276C696E6B5B747970653D22746578742F637373225D272C202768746D6C27292E66696C7465722866756E6374696F6E287229207B0A20202020';
wwv_flow_api.g_varchar2_table(76) := '20207661722068726566203D20242874686973292E6174747228276872656627293B0A20202020202072657475726E2066696C6552656765782E636F72655374796C652E746573742868726566293B0A202020207D293B0A20207D3B0A0A202076617220';
wwv_flow_api.g_varchar2_table(77) := '67657456657273696F6E203D2066756E6374696F6E2829207B0A202020202F2F7573696E672074686520636F72652066696C6520617320746865207468656D6520636F756C6420626520637573746F6D0A2020202072657475726E20676574436F726543';
wwv_flow_api.g_varchar2_table(78) := '737346696C6528290A2020202020202E6174747228276872656627290A2020202020202E7265706C6163652866696C6552656765782E636F72655374796C652C2027243327293B0A20207D3B0A0A2020766172206765745374796C65203D2066756E6374';
wwv_flow_api.g_varchar2_table(79) := '696F6E2829207B0A202020206966202867437573746F6D5374796C652E6973437573746F6D29207B0A20202020202072657475726E20637573746F6D5374796C652E69643B0A202020207D20656C7365207B0A20202020202072657475726E2067657444';
wwv_flow_api.g_varchar2_table(80) := '656661756C745468656D655374796C6543737346696C6528290A20202020202020202E6174747228276872656627290A20202020202020202E7265706C6163652866696C6552656765782E64656661756C745374796C652C2027243527293B0A20202020';
wwv_flow_api.g_varchar2_table(81) := '7D0A20207D3B0A0A2020766172206765744170706C69656456657273696F6E203D2066756E6374696F6E2829207B0A2020202072657475726E2073657373696F6E53746F726167652E6765744974656D2873746F726167654B65792E76657273696F6E29';
wwv_flow_api.g_varchar2_table(82) := '207C7C2067657456657273696F6E28293B0A20207D3B0A0A2020766172206765744170706C6965645374796C65203D2066756E6374696F6E2829207B0A2020202072657475726E2073657373696F6E53746F726167652E6765744974656D2873746F7261';
wwv_flow_api.g_varchar2_table(83) := '67654B65792E7374796C6529207C7C206765745374796C6528293B0A20207D3B0A0A2020766172207365745468656D655374796C65203D2066756E6374696F6E287056657273696F6E2C20705374796C652C207043616C6C6261636B29207B0A20202020';
wwv_flow_api.g_varchar2_table(84) := '7661722076657273696F6E2C0A2020202020207374796C652C0A2020202020207374796C654F626A2C0A2020202020207374796C6553696E63653B0A0A2020202069662028747970656F66207056657273696F6E203D3D3D2027756E646566696E656427';
wwv_flow_api.g_varchar2_table(85) := '29207B0A20202020202076657273696F6E203D206765744170706C69656456657273696F6E28293B0A202020207D20656C736520696620287056657273696F6E203D3D3D2064656661756C7456657273696F6E2E696429207B0A20202020202076657273';
wwv_flow_api.g_varchar2_table(86) := '696F6E203D2073657373696F6E53746F726167652E6765744974656D2873746F726167654B65792E64656661756C7456657273696F6E293B0A202020207D20656C7365207B0A20202020202076657273696F6E203D207056657273696F6E3B0A20202020';
wwv_flow_api.g_varchar2_table(87) := '7D0A0A2020202069662028747970656F6620705374796C65203D3D3D2027756E646566696E65642729207B0A2020202020207374796C65203D206765744170706C6965645374796C6528293B0A202020207D20656C73652069662028705374796C65203D';
wwv_flow_api.g_varchar2_table(88) := '3D3D2064656661756C745374796C652E696429207B0A2020202020207374796C65203D2073657373696F6E53746F726167652E6765744974656D2873746F726167654B65792E64656661756C745374796C65293B0A202020207D20656C7365207B0A2020';
wwv_flow_api.g_varchar2_table(89) := '202020207374796C65203D20705374796C653B0A202020207D0A0A202020202F2F20617065782E64656275672E6C6F6728274E65772056657273696F6E3D272C2076657273696F6E293B0A202020202F2F20617065782E64656275672E6C6F6728274E65';
wwv_flow_api.g_varchar2_table(90) := '77205374796C653D272C207374796C65293B0A0A202020202F2F6D616B6520737572652074686174207468652073656C6563746564207374796C6520697320617661696C61626C6520666F72207468652073656C65637465642076657273696F6E0A2020';
wwv_flow_api.g_varchar2_table(91) := '20207374796C654F626A203D20675468656D655374796C65732E66696E64287265636F7264203D3E207265636F72642E6964203D3D3D207374796C65293B0A20202020696628217374796C654F626A297B0A202020202020636F6E736F6C652E6C6F6728';
wwv_flow_api.g_varchar2_table(92) := '605374796C6520247B7374796C657D20646F6573206E6F742065786973742E2049676E6F72696E6760293B0A20202020202072657475726E3B0A202020207D20656C7365207B0A2020202020207374796C6553696E6365203D20675468656D655374796C';
wwv_flow_api.g_varchar2_table(93) := '65732E66696E64287265636F7264203D3E207265636F72642E6964203D3D3D207374796C65292E73696E636556657273696F6E3B0A202020207D0A0A202020202F2F7374796C65206E6F7420666F756E640A2020202069662028217374796C6553696E63';
wwv_flow_api.g_varchar2_table(94) := '6529207B0A202020202020617065782E6D6573736167652E636C6561724572726F727328293B0A0A202020202020617065782E6D6573736167652E73686F774572726F7273285B7B0A2020202020202020747970653A20276572726F72272C0A20202020';
wwv_flow_api.g_varchar2_table(95) := '202020206C6F636174696F6E3A202770616765272C0A20202020202020206D6573736167653A20275374796C65206E6F7420666F756E64272C0A2020202020202020756E736166653A2066616C73650A2020202020207D5D293B0A202020207D0A202020';
wwv_flow_api.g_varchar2_table(96) := '202F2F207374796C65206E6F7420617661696C61626C6520666F207370656369666965642076657273696F6E0A20202020656C736520696620287374796C6553696E6365203E2076657273696F6E29207B0A202020202020617065782E6D657373616765';
wwv_flow_api.g_varchar2_table(97) := '2E636C6561724572726F727328293B0A0A202020202020617065782E6D6573736167652E73686F774572726F7273285B7B0A2020202020202020747970653A20276572726F72272C0A20202020202020206C6F636174696F6E3A202770616765272C0A20';
wwv_flow_api.g_varchar2_table(98) := '202020202020206D6573736167653A20275374796C6520646F65736E5C277420657869737420666F72207468652073656C65637465642076657273696F6E272C0A2020202020202020756E736166653A2066616C73650A2020202020207D5D293B0A2020';
wwv_flow_api.g_varchar2_table(99) := '20207D0A202020202F2F637573746F6D207374796C65206E6F7420617661696C61626C6520666F722070726576696F75732076657273696F6E0A20202020656C736520696620287374796C65203D3D3D20637573746F6D5374796C652E69642026262067';
wwv_flow_api.g_varchar2_table(100) := '496E697469616C56657273696F6E203E2076657273696F6E29207B0A202020202020617065782E6D6573736167652E636C6561724572726F727328293B0A0A202020202020617065782E6D6573736167652E73686F774572726F7273285B7B0A20202020';
wwv_flow_api.g_varchar2_table(101) := '20202020747970653A20276572726F72272C0A20202020202020206C6F636174696F6E3A202770616765272C0A20202020202020206D6573736167653A2027437573746F6D207374796C6520646F65736E5C277420657869737420666F72207468652073';
wwv_flow_api.g_varchar2_table(102) := '656C65637465642076657273696F6E272C0A2020202020202020756E736166653A2066616C73650A2020202020207D5D293B0A202020207D20656C7365207B0A2020202020202F2F20434F5245204353532046696C650A20202020202076617220636F72';
wwv_flow_api.g_varchar2_table(103) := '655374796C6546696C654E616D65203D20676574436F726543737346696C6528292E6174747228276872656627292C0A20202020202020206E6577436F72655374796C6546696C654E616D65203D20636F72655374796C6546696C654E616D652E726570';
wwv_flow_api.g_varchar2_table(104) := '6C6163652866696C6552656765782E636F72655374796C652C20272431243227202B2076657273696F6E202B2027243427293B0A0A2020202020202F2F6F6E6C79206368616E6765206966206E65772066696C656E616D6520697320646966666572656E';
wwv_flow_api.g_varchar2_table(105) := '7420746F2070726576656E74206120666C617368696E67206566666563740A20202020202069662028636F72655374796C6546696C654E616D6520213D3D206E6577436F72655374796C6546696C654E616D6529207B0A2020202020202020676574436F';
wwv_flow_api.g_varchar2_table(106) := '726543737346696C6528292E61747472282768726566272C206E6577436F72655374796C6546696C654E616D65293B0A2020202020207D0A0A2020202020202F2F44454641554C54206F7220435553544F4D204353532046696C650A2020202020207661';
wwv_flow_api.g_varchar2_table(107) := '72207468656D655374796C6546696C65243B0A0A2020202020202F2F69662063757272656E742066696C6520697320637573746F6D0A2020202020206966202867437573746F6D5374796C652E6973437573746F6D29207B0A2020202020202020746865';
wwv_flow_api.g_varchar2_table(108) := '6D655374796C6546696C6524203D20676574437573746F6D5468656D655374796C6543737346696C6528293B0A2020202020207D20656C7365207B0A20202020202020207468656D655374796C6546696C6524203D2067657444656661756C745468656D';
wwv_flow_api.g_varchar2_table(109) := '655374796C6543737346696C6528293B0A2020202020207D0A0A202020202020766172207468656D655374796C6546696C654E616D65203D207468656D655374796C6546696C65242E6174747228276872656627292C0A20202020202020206E65775468';
wwv_flow_api.g_varchar2_table(110) := '656D655374796C6546696C654E616D653B0A0A2020202020202F2F206E6577207374796C6520697320637573746F6D0A20202020202069662028637573746F6D5374796C652E6964203D3D3D207374796C6529207B0A202020202020202067437573746F';
wwv_flow_api.g_varchar2_table(111) := '6D5374796C652E6973437573746F6D203D20747275653B0A20202020202020206E65775468656D655374796C6546696C654E616D65203D2067437573746F6D5374796C652E637573746F6D46696C653B0A2020202020207D0A2020202020202F2F206E65';
wwv_flow_api.g_varchar2_table(112) := '77206973206E6F7420637573746F6D20616E796D6F72650A202020202020656C7365207B0A202020202020202067437573746F6D5374796C652E6973437573746F6D203D2066616C73653B0A20202020202020202F2F626173696E67207468652066696C';
wwv_flow_api.g_varchar2_table(113) := '65206E616D65206F6E20636F72652061732069742068617320616C6C207468652070617274730A20202020202020206E65775468656D655374796C6546696C654E616D65203D20636F72655374796C6546696C654E616D652E7265706C6163652866696C';
wwv_flow_api.g_varchar2_table(114) := '6552656765782E64656661756C745374796C652C20272431243227202B2076657273696F6E202B2027243427202B207374796C65202B2027243627293B0A2020202020207D0A0A2020202020202F2F6F6E6C79206368616E6765206966206E6577206669';
wwv_flow_api.g_varchar2_table(115) := '6C656E616D6520697320646966666572656E7420746F2070726576656E74206120666C617368696E67206566666563740A202020202020696620287468656D655374796C6546696C654E616D6520213D3D206E65775468656D655374796C6546696C654E';
wwv_flow_api.g_varchar2_table(116) := '616D6529207B0A20202020202020206966202867437573746F6D5374796C652E6973437573746F6D29207B0A202020202020202020207468656D655374796C6546696C65242E61747472282768726566272C206E65775468656D655374796C6546696C65';
wwv_flow_api.g_varchar2_table(117) := '4E616D65293B0A20202020202020207D20656C7365207B0A202020202020202020207468656D655374796C6546696C65242E61747472282768726566272C206E65775468656D655374796C6546696C654E616D65293B0A20202020202020207D0A202020';
wwv_flow_api.g_varchar2_table(118) := '2020207D0A0A2020202020202F2F73617665207468652076657273696F6E20616E64207374796C6520696E206F7264657220746F2062652061626C6520746F206170706C7920697420616761696E20616674657220612070616765206C6F61640A202020';
wwv_flow_api.g_varchar2_table(119) := '20202073657373696F6E53746F726167652E7365744974656D2873746F726167654B65792E76657273696F6E2C2076657273696F6E293B0A20202020202073657373696F6E53746F726167652E7365744974656D2873746F726167654B65792E7374796C';
wwv_flow_api.g_varchar2_table(120) := '652C207374796C65293B0A0A202020202020696620287043616C6C6261636B29207B0A20202020202020207043616C6C6261636B28293B0A2020202020207D0A202020207D0A20207D3B0A0A20207574646D2E7365745374796C65203D2066756E637469';
wwv_flow_api.g_varchar2_table(121) := '6F6E28705374796C652C207043616C6C6261636B29207B0A202020207365745468656D655374796C6528756E646566696E65642C20705374796C652C207043616C6C6261636B293B0A20207D3B0A0A20207574646D2E73657456657273696F6E203D2066';
wwv_flow_api.g_varchar2_table(122) := '756E6374696F6E287056657273696F6E2C207043616C6C6261636B29207B0A202020207365745468656D655374796C65287056657273696F6E2C20756E646566696E65642C207043616C6C6261636B293B0A20207D3B0A0A20207574646D2E746F67676C';
wwv_flow_api.g_varchar2_table(123) := '6552746C203D2066756E6374696F6E2829207B0A20202020696620282124282768746D6C27292E686173436C6173732827752D52544C272929207B0A0A20202020202073657373696F6E53746F726167652E7365744974656D2873746F726167654B6579';
wwv_flow_api.g_varchar2_table(124) := '2E646972656374696F6E2C202772746C27293B0A0A20202020202024282768746D6C27290A20202020202020202E616464436C6173732827752D52544C27290A20202020202020202E617474722827646972272C202772746C27293B0A202020207D2065';
wwv_flow_api.g_varchar2_table(125) := '6C7365207B0A20202020202073657373696F6E53746F726167652E72656D6F76654974656D2873746F726167654B65792E646972656374696F6E293B0A0A20202020202024282768746D6C27290A20202020202020202E72656D6F7665436C6173732827';
wwv_flow_api.g_varchar2_table(126) := '752D52544C27290A20202020202020202E617474722827646972272C20276C747227293B0A202020207D0A20207D3B0A0A20207574646D2E696E6974203D2066756E6374696F6E2829207B0A2020202069662028676574437573746F6D5468656D655374';
wwv_flow_api.g_varchar2_table(127) := '796C6543737346696C6528292E6C656E677468203E203029207B0A20202020202067437573746F6D5374796C652E6973437573746F6D203D20747275653B0A20202020202067437573746F6D5374796C652E637573746F6D46696C65203D206765744375';
wwv_flow_api.g_varchar2_table(128) := '73746F6D5468656D655374796C6543737346696C6528290A20202020202020202E6174747228276872656627290A20202020202020202E7265706C6163652866696C6552656765782E64656661756C745374796C652C2027243527293B0A0A2020202020';
wwv_flow_api.g_varchar2_table(129) := '202F2F656E61626C652074686520637573746F6D207374796C652066726F6D207468652064726F70646F776E0A202020202020675468656D655374796C65732E66696E64287265636F7264203D3E207265636F72642E6964203D3D3D20637573746F6D53';
wwv_flow_api.g_varchar2_table(130) := '74796C652E6964292E64697361626C6564203D2066616C73653B0A202020207D0A0A202020202F2F7361766520696E697469616C2076657273696F6E20616E64207374796C6520666F72206C61746572207573652C2073696E636520697420636F756C64';
wwv_flow_api.g_varchar2_table(131) := '206368616E67650A2020202067496E697469616C56657273696F6E203D2067657456657273696F6E28293B0A2020202067496E697469616C5374796C65203D206765745374796C6528293B0A0A202020202F2F73617665207468652064656661756C7420';
wwv_flow_api.g_varchar2_table(132) := '76657273696F6E20616E64207374796C6520696E206F7264657220746F2062652061626C6520746F20726576657274206261636B0A2020202073657373696F6E53746F726167652E7365744974656D2873746F726167654B65792E64656661756C745665';
wwv_flow_api.g_varchar2_table(133) := '7273696F6E2C2067496E697469616C56657273696F6E293B0A2020202073657373696F6E53746F726167652E7365744974656D2873746F726167654B65792E64656661756C745374796C652C2067496E697469616C5374796C65293B0A0A202020202F2F';
wwv_flow_api.g_varchar2_table(134) := '20617065782E64656275672E6C6F67282767657456657273696F6E3D27202B2067496E697469616C56657273696F6E293B0A202020202F2F20617065782E64656275672E6C6F6728276765744170706C69656456657273696F6E3D27202B206765744170';
wwv_flow_api.g_varchar2_table(135) := '706C69656456657273696F6E2829293B0A202020202F2F20617065782E64656275672E6C6F6728276765745374796C653D27202B206765745374796C652829293B0A202020202F2F20617065782E64656275672E6C6F6728276765744170706C69656453';
wwv_flow_api.g_varchar2_table(136) := '74796C653D27202B206765744170706C6965645374796C652829293B0A0A202020202F2F73657420696E697469616C207374796C6520616E642076657273696F6E0A202020207365745468656D655374796C65286765744170706C69656456657273696F';
wwv_flow_api.g_varchar2_table(137) := '6E28292C206765744170706C6965645374796C652829293B0A0A202020206966202873657373696F6E53746F726167652E6765744974656D2873746F726167654B65792E646972656374696F6E2929207B0A2020202020207574646D2E746F67676C6552';
wwv_flow_api.g_varchar2_table(138) := '746C28293B0A202020207D0A0A202020202F2F206275696C6420616E6420616464206D656E75730A202020206275696C645468656D655374796C6553656C6563746F7228293B0A202020202F2F206275696C645468656D6556657273696F6E53656C6563';
wwv_flow_api.g_varchar2_table(139) := '746F7228293B0A202020206275696C6452746C53656C6563746F7228293B0A20207D3B0A7D2928617065782E6A51756572792C20617065782E7574696C2C2075744465764D6F6465293B0A0A0A242866756E6374696F6E2829207B0A202075744465764D';
wwv_flow_api.g_varchar2_table(140) := '6F64652E696E697428293B0A7D293B0A';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784244067982151279)
,p_file_name=>'utDevMode.js'
,p_mime_type=>'application/javascript'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/utdevmode_js_map
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '7B2276657273696F6E223A332C22736F7572636573223A5B2275744465764D6F64652E6A73225D2C226E616D6573223A5B2275744465764D6F6465222C2224222C227574696C222C227574646D222C2267496E697469616C56657273696F6E222C226749';
wwv_flow_api.g_varchar2_table(2) := '6E697469616C5374796C65222C2267437573746F6D5374796C65222C226973437573746F6D222C2266696C655265676578222C2264656661756C745374796C65222C22637573746F6D5374796C65222C22636F72655374796C65222C2264656D6F537479';
wwv_flow_api.g_varchar2_table(3) := '6C65222C22675374796C654D656E754964222C2264656661756C7456657273696F6E222C226964222C226E616D65222C2273696E636556657273696F6E222C2264697361626C6564222C22675468656D655374796C6573222C2273746F726167654B6579';
wwv_flow_api.g_varchar2_table(4) := '222C2273657373696F6E53746F72616765222C2261706578222C2273746F72616765222C2267657453636F70656453657373696F6E53746F72616765222C22707265666978222C227573654170704964222C22757365506167654964222C22726567696F';
wwv_flow_api.g_varchar2_table(5) := '6E4964222C226164644E61764D656E754974656D222C22704E61764D656E75456C656D222C22704D656E754964222C22704D656E75436F6E666967222C22704E61764D656E75456C656D4C696E6B222C2269636F6E4F6E6C79436C617373222C2269636F';
wwv_flow_api.g_varchar2_table(6) := '6E507265666978436C617373222C2269636F6E222C22696E6465784F66222C226E61764261724974656D222C22657363617065435353222C22636C617373222C226974656D4861735375624D656E75222C2265736361706548544D4C222C226C6162656C';
wwv_flow_api.g_varchar2_table(7) := '222C2270726570656E64222C22617070656E64222C226D656E75222C227365744D656E7553656C656374696F6E222C22704974656D4964222C226D656E754974656D73222C226974656D73222C2265616368222C2269222C226974656D222C2267657444';
wwv_flow_api.g_varchar2_table(8) := '656661756C745468656D655374796C6543737346696C65222C2266696C746572222C2272222C2268726566222C2274686973222C2261747472222C2274657374222C22676574437573746F6D5468656D655374796C6543737346696C65222C2267657443';
wwv_flow_api.g_varchar2_table(9) := '6F726543737346696C65222C2267657456657273696F6E222C227265706C616365222C226765745374796C65222C226765744170706C69656456657273696F6E222C226765744974656D222C226765744170706C6965645374796C65222C227365745468';
wwv_flow_api.g_varchar2_table(10) := '656D655374796C65222C227056657273696F6E222C22705374796C65222C227043616C6C6261636B222C2276657273696F6E222C227374796C65222C227374796C6553696E6365222C2266696E64222C227265636F7264222C226D657373616765222C22';
wwv_flow_api.g_varchar2_table(11) := '636C6561724572726F7273222C2273686F774572726F7273222C2274797065222C226C6F636174696F6E222C22756E73616665222C227468656D655374796C6546696C6524222C22636F72655374796C6546696C654E616D65222C226E6577436F726553';
wwv_flow_api.g_varchar2_table(12) := '74796C6546696C654E616D65222C226E65775468656D655374796C6546696C654E616D65222C227468656D655374796C6546696C654E616D65222C22637573746F6D46696C65222C227365744974656D222C22636F6E736F6C65222C226C6F67222C2273';
wwv_flow_api.g_varchar2_table(13) := '65745374796C65222C22756E646566696E6564222C2273657456657273696F6E222C22746F67676C6552746C222C22686173436C617373222C2272656D6F76654974656D222C2272656D6F7665436C617373222C22616464436C617373222C22696E6974';
wwv_flow_api.g_varchar2_table(14) := '222C22704974656D73222C226375725374796C65222C226D656E75436F6E666967222C226C656E677468222C226D6170222C22704974656D222C22616374696F6E222C226D656E754974656D4964222C2263616C6C6F7574222C2269636F6E4F6E6C7922';
wwv_flow_api.g_varchar2_table(15) := '2C226A5175657279225D2C226D617070696E6773223A22414143412C49414149412C55414159412C574141612C49414537422C53414155432C45414147432C4541414D432C4741436A422C49414149432C45414346432C45414545432C454141652C4341';
wwv_flow_api.g_varchar2_table(16) := '436A42432C554141552C47414752432C454141592C43414764432C614141632C6D45414764432C594141612C2B44414762432C554141572C6745414558432C554141572C6945414958432C454141652C6D42414562432C45414169422C4341436E42432C';
wwv_flow_api.g_varchar2_table(17) := '474141492C5541434A432C4B41414D2C5741474A502C454141652C4341436A424D2C474141492C5541434A432C4B41414D2C5541434E432C614141632C4B414F5A502C454141632C43414368424B2C474141492C5341434A432C4B41414D2C5341434E45';
wwv_flow_api.g_varchar2_table(18) := '2C554141552C45414356442C614141632C4B4175435A452C454141652C4341436A42562C45416A44592C4341435A4D2C474141492C694241434A432C4B41414D2C694241434E432C614141632C4B41674464502C45414D412C434143454B2C474141492C';
wwv_flow_api.g_varchar2_table(19) := '4F41434A432C4B41414D2C4F41434E432C614141632C4F414568422C43414345462C474141492C5941434A432C4B41414D2C5941434E432C614141632C4F415968422C43414345462C474141492C5541434A432C4B41414D2C674241434E432C61414163';
wwv_flow_api.g_varchar2_table(20) := '2C53414964472C4541434F2C55414450412C4541454B2C5141464C412C454147532C4D414854412C454149632C6942414A64412C45414B592C6541475A432C4541416942432C4B41414B432C51414151432C7742414177422C4341437844432C4F414151';
wwv_flow_api.g_varchar2_table(21) := '2C7542414352432C554141552C45414356432C574141572C45414358432C534141552C4B414952432C45414169422C53414153432C45414163432C45414153432C45414161432C47414368452C49414149432C45414169424A2C45414171422C53414149';
wwv_flow_api.g_varchar2_table(22) := '2C614141652C47414333444B2C4541416D424C2C454141614D2C4D414136432C49414172434E2C454141614D2C4B41414B432C514141512C4F414167422C4D4141512C4741433146432C454141612C6B4341416F434A2C45414167422C4941414D68432C';
wwv_flow_api.g_varchar2_table(23) := '4541414B71432C55414155542C45414161552C4F4141532C4B41453147432C4F414171432C4941415A562C45414933424F2C47414445472C454143592C6F484141734876432C4541414B71432C55414155522C474141572C5341415737422C4541414B71';
wwv_flow_api.g_varchar2_table(24) := '432C55414155522C474141572C75444145724C2C384541416746452C4541416D422C4B41476E484B2C474141632C754241417942482C4541416B426A432C4541414B71432C55414155542C454141614D2C4D414176452C7943414373426C432C4541414B';
wwv_flow_api.g_varchar2_table(25) := '77432C574141575A2C45414161612C4F41446E442C3843414B5A4C2C47414445472C454143592C77444147412C4F41476842482C474141632C5141476472432C454141452C6F4241416F4232432C514141514E2C4741473142472C4941434678432C4541';
wwv_flow_api.g_varchar2_table(26) := '41452C5141415134432C4F41414F2C5941416333432C4541414B71432C55414155522C474141572C5941457A4439422C454141452C4941414D432C4541414B71432C55414155522C49414155652C4B41414B642C4B41497443652C4541416D422C534141';
wwv_flow_api.g_varchar2_table(27) := '5368422C4541415369422C47414376432C49414149432C4541415968442C454141452C4941414D432C4541414B71432C55414155522C49414155652C4B41414B2C55414155492C4D414568456A442C454141456B442C4B41414B462C474141572C534141';
wwv_flow_api.g_varchar2_table(28) := '53472C45414147432C4741433542412C4541414B6A422C4B41414F2C4B41455269422C4541414B74432C4B41414F69432C494143644B2C4541414B6A422C4B41414F2C6D42416B48646B422C45414138422C57414368432C4F41414F72442C454141452C';
wwv_flow_api.g_varchar2_table(29) := '7742414179422C5141415173442C5141414F2C53414153432C47414378442C49414149432C4541414F78442C4541414579442C4D41414D432C4B41414B2C51414378422C4F41414F6E442C45414155432C614141616D442C4B41414B482C4B4141556A44';
wwv_flow_api.g_varchar2_table(30) := '2C45414155472C5541415569442C4B41414B482C4B4141556A442C45414155492C5541415567442C4B41414B482C4F41497A47492C45414136422C5741432F422C4F41414F35442C454141452C7742414179422C5141415173442C5141414F2C53414153';
wwv_flow_api.g_varchar2_table(31) := '432C47414378442C49414149432C4541414F78442C4541414579442C4D41414D432C4B41414B2C51414378422C4F41414F6E442C45414155452C594141596B442C4B41414B482C4F41496C434B2C45414169422C5741436E422C4F41414F37442C454141';
wwv_flow_api.g_varchar2_table(32) := '452C7742414179422C5141415173442C5141414F2C53414153432C47414378442C49414149432C4541414F78442C4541414579442C4D41414D432C4B41414B2C51414378422C4F41414F6E442C45414155472C5541415569442C4B41414B482C4F414968';
wwv_flow_api.g_varchar2_table(33) := '434D2C454141612C574145662C4F41414F442C4941434A482C4B41414B2C5141434C4B2C5141415178442C45414155472C554141572C4F4147394273442C454141572C574143622C4F41414933442C45414161432C53414352472C454141594B2C474145';
wwv_flow_api.g_varchar2_table(34) := '5A75432C4941434A4B2C4B41414B2C5141434C4B2C5141415178442C45414155432C614141632C4F41496E4379442C4541416F422C57414374422C4F41414F37432C4541416538432C514141512F432C494141754232432C4B41476E444B2C4541416B42';
wwv_flow_api.g_varchar2_table(35) := '2C57414370422C4F41414F2F432C4541416538432C514141512F432C494141714236432C4B41476A44492C45414167422C53414153432C45414155432C45414151432C47414337432C49414149432C45414346432C45414541432C45417542462C474170';
wwv_flow_api.g_varchar2_table(36) := '4245462C4F414473422C49414162482C454143434A2C49414344492C4941416178442C45414165432C47414333424D2C4541416538432C514141512F432C47414576426B442C45414956492C4F41446F422C49414158482C45414344482C49414343472C';
wwv_flow_api.g_varchar2_table(37) := '4941415739442C454141614D2C4741437A424D2C4541416538432C514141512F432C47414576426D442C45414F4370442C4541416179442C4D41414B432C47414155412C4541414F39442C4B41414F32442C49415372442C47414A45432C454141617844';
wwv_flow_api.g_varchar2_table(38) := '2C4541416179442C4D41414B432C47414155412C4541414F39442C4B41414F32442C4941414F7A442C61416533442C4741414930442C45414161462C45414370426E442C4B41414B77442C51414151432C634145627A442C4B41414B77442C5141415145';
wwv_flow_api.g_varchar2_table(39) := '2C574141572C434141432C4341437642432C4B41414D2C5141434E432C534141552C4F4143564A2C514141532C2B434143544B2C514141512C554149502C47414149542C4941415568452C454141594B2C4941414D582C4541416B4271452C4541437244';
wwv_flow_api.g_varchar2_table(40) := '6E442C4B41414B77442C51414151432C634145627A442C4B41414B77442C51414151452C574141572C434141432C4341437642432C4B41414D2C5141434E432C534141552C4F4143564A2C514141532C73444143544B2C514141512C5341454C2C434145';
wwv_flow_api.g_varchar2_table(41) := '4C2C49415349432C45415441432C4541416F4276422C4941416942482C4B41414B2C514143354332422C4541417542442C4541416B4272422C5141415178442C45414155472C554141572C4F41415338442C454141552C4D41477646592C494141734243';
wwv_flow_api.g_varchar2_table(42) := '2C474143784278422C4941416942482C4B41414B2C4F41415132422C47416168432C49414345432C45414445432C47414C464A2C4541444539452C45414161432C5341434773442C49414541502C4B414771424B2C4B41414B2C51414931436A442C4541';
wwv_flow_api.g_varchar2_table(43) := '41594B2C4B41414F32442C474143724270452C45414161432C554141572C454143784267462C45414177426A462C454141616D462C61414972436E462C45414161432C554141572C454145784267462C4541417742462C4541416B4272422C5141415178';
wwv_flow_api.g_varchar2_table(44) := '442C45414155432C614141632C4F41415367452C454141552C4B41414F432C454141512C4F41493147632C4941417542442C49414372426A462C45414161432C5341436636452C45414167427A422C4B41414B2C4F41415134422C49414F6A436C452C45';
wwv_flow_api.g_varchar2_table(45) := '41416571452C5141415174452C4541416F4271442C474143334370442C4541416571452C5141415174452C4541416B4273442C4741457243462C47414346412C53412F45466C442C4B41414B77442C51414151432C634145627A442C4B41414B77442C51';
wwv_flow_api.g_varchar2_table(46) := '414151452C574141572C434141432C4341437642432C4B41414D2C5141434E432C534141552C4F4143564A2C514141532C6B424143544B2C514141512C55416456512C51414151432C494141492C534141536C422C2B424134467A4276452C4541414B30';
wwv_flow_api.g_varchar2_table(47) := '462C534141572C5341415374422C45414151432C4741432F42482C4F41416379422C4541415776422C45414151432C4941476E4372452C4541414B34462C574141612C534141537A422C45414155452C4741436E43482C45414163432C4F41415577422C';
wwv_flow_api.g_varchar2_table(48) := '4541415774422C494147724372452C4541414B36462C554141592C574143562F462C454141452C5141415167472C534141532C554151744235452C4541416536452C5741415739452C47414531426E422C454141452C514143436B472C594141592C5341';
wwv_flow_api.g_varchar2_table(49) := '435A78432C4B41414B2C4D41414F2C5341566674432C4541416571452C5141415174452C45414173422C4F414537436E422C454141452C514143436D472C534141532C534143547A432C4B41414B2C4D41414F2C5341556E4278442C4541414B6B472C4B';
wwv_flow_api.g_varchar2_table(50) := '41414F2C5741314E6B422C49416A4444432C4541457A42432C4541754445432C45416D4E4133432C494141364234432C4F4141532C49414378436E472C45414161432C554141572C4541437842442C454141616D462C5741416135422C4941437642462C';
wwv_flow_api.g_varchar2_table(51) := '4B41414B2C5141434C4B2C5141415178442C45414155432C614141632C4D41476E43552C4541416179442C4D41414B432C47414155412C4541414F39442C4B41414F4C2C454141594B2C4B414149472C554141572C4741497645642C4541416B4232442C';
wwv_flow_api.g_varchar2_table(52) := '4941436C4231442C454141674234442C494147684235432C4541416571452C5141415174452C454141324268422C4741436C4469422C4541416571452C5141415174452C4541417942662C474151684467452C45414163482C4941417142452C4B41452F';
wwv_flow_api.g_varchar2_table(53) := '422F432C4541416538432C514141512F432C4941437A426A422C4541414B36462C5941394F48512C454141612C4341436674442C4F41314479426F442C454130444A6E462C4541784472426F462C454141576E432C494130424C6B432C4541414F492C4B';
wwv_flow_api.g_varchar2_table(54) := '417842442C53414153432C47414372422C4941414974442C4541414F2C4341435434422C4B41414D2C55416D42522C4F4168424135422C4541414B74432C4741414B34462C4541414D35462C474143684273432C4541414B562C4D41415167452C454141';
wwv_flow_api.g_varchar2_table(55) := '4D33462C4B41436E4271432C4541414B6E432C5341415779462C4541414D7A462C574141592C454145394279462C4541414D35462C4B41414F77462C494143666C442C4541414B6A422C4B41414F2C6541476469422C4541414B75442C4F4141532C5741';
wwv_flow_api.g_varchar2_table(56) := '435A2C49414149432C454141616E442C4B41414B33432C4741457442662C5541415536462C53414153632C4541414D35462C494141492C574143334267432C45414169426C432C4541416367472C4F4149354278442C4D416B435079442C534141532C47';
wwv_flow_api.g_varchar2_table(57) := '4147586A462C45415A632C4341435A572C4D41414F2C6F42414350472C4D41414F2C63414350502C4B41414D2C694241434E32452C554141552C474151596C472C4541416332462C474157744333452C454150632C4341435A572C4D41414F2C65414350';
wwv_flow_api.g_varchar2_table(58) := '472C4D41414F2C4D414350502C4B41414D2C694241434E32452C554141552C514147596A422C4F414157412C454141572C7543416E536C442C43417967424778452C4B41414B30462C4F41415131462C4B41414B70422C4B41414D462C5741473342432C';
wwv_flow_api.g_varchar2_table(59) := '474141452C57414341442C554141557147222C2266696C65223A2275744465764D6F64652E6A73227D';
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784244371814151280)
,p_file_name=>'utDevMode.js.map'
,p_mime_type=>'application/json'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/utdevmode_min_js
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '7661722075744465764D6F64653D75744465764D6F64657C7C7B7D3B2166756E6374696F6E28652C742C73297B766172206E2C612C693D7B6973437573746F6D3A21317D2C6F3D7B64656661756C745374796C653A2F282E2A29285C2F7468656D65735C';
wwv_flow_api.g_varchar2_table(2) := '2F7468656D655F34325C2F29282E2A29285C2F6373735C2F29282E2A3F29283F3A5C2E6D696E293F285C2E6373732E2A292F692C637573746F6D5374796C653A2F282E2A29285C2F66696C65735C2F7468656D655C2F34325C2F765B302D395D2B5C2F29';
wwv_flow_api.g_varchar2_table(3) := '282E2A3F29283F3A5C2E6D696E293F285C2E6373732E2A292F692C636F72655374796C653A2F282E2A29285C2F7468656D65735C2F7468656D655F34325C2F29282E2A29285C2F6373735C2F436F7265283F3A5C2E6D696E293F5C2E6373732E2A292F69';
wwv_flow_api.g_varchar2_table(4) := '2C64656D6F5374796C653A2F282E2A29285C2F7468656D65735C2F7468656D655F34325C2F29282E2A29285C2F6373735C2F44656D6F283F3A5C2E6D696E293F5C2E6373732E2A292F697D2C723D227468656D655374796C65732D6C697374222C6C3D7B';
wwv_flow_api.g_varchar2_table(5) := '69643A2244656661756C74222C6E616D653A2244656661756C74227D2C633D7B69643A2244656661756C74222C6E616D653A2244656661756C74222C73696E636556657273696F6E3A2230227D2C753D7B69643A22437573746F6D222C6E616D653A2243';
wwv_flow_api.g_varchar2_table(6) := '7573746F6D222C64697361626C65643A21302C73696E636556657273696F6E3A2230227D2C643D5B632C7B69643A224E6F2D5468656D652D5374796C65222C6E616D653A224E6F205468656D65205374796C65222C73696E636556657273696F6E3A2230';
wwv_flow_api.g_varchar2_table(7) := '227D2C752C7B69643A2256697461222C6E616D653A2256697461222C73696E636556657273696F6E3A22312E30227D2C7B69643A22566974612D4461726B222C6E616D653A2256697461204461726B222C73696E636556657273696F6E3A22312E34227D';
wwv_flow_api.g_varchar2_table(8) := '2C7B69643A22526564776F6F64222C6E616D653A22526564776F6F64204C69676874222C73696E636556657273696F6E3A2232312E31227D5D2C6D3D2276657273696F6E222C663D227374796C65222C703D22646972222C683D2264656661756C745665';
wwv_flow_api.g_varchar2_table(9) := '7273696F6E222C793D2264656661756C745374796C65222C533D617065782E73746F726167652E67657453636F70656453657373696F6E53746F72616765287B7072656669783A2275747248656C7065722E7468656D655374796C65222C757365417070';
wwv_flow_api.g_varchar2_table(10) := '49643A21302C7573655061676549643A21312C726567696F6E49643A22227D292C763D66756E6374696F6E28732C6E2C612C69297B766172206F3D732E69636F6E4F6E6C793F222069636F6E2D6F6E6C79223A22222C723D732E69636F6E2626303D3D3D';
wwv_flow_api.g_varchar2_table(11) := '732E69636F6E2E696E6465784F66282266612D22293F22666120223A22222C6C3D273C6C6920636C6173733D22742D4E617669676174696F6E4261722D6974656D272B6F2B2220222B742E65736361706543535328732E636C617373292B27223E272C63';
wwv_flow_api.g_varchar2_table(12) := '3D766F69642030213D3D6E3B6C2B3D633F273C627574746F6E20747970653D22627574746F6E2220636C6173733D22742D427574746F6E20742D427574746F6E2D2D69636F6E20742D427574746F6E2D2D68656164657220742D427574746F6E2D2D6E61';
wwv_flow_api.g_varchar2_table(13) := '76426172206A732D6D656E75427574746F6E2220646174612D6D656E753D22272B742E657363617065435353286E292B27222069643D22272B742E657363617065435353286E292B272D627574746F6E2220617269612D686173706F7075703D22747275';
wwv_flow_api.g_varchar2_table(14) := '652220617269612D657870616E6465643D2266616C7365223E273A273C6120636C6173733D22742D427574746F6E20742D427574746F6E2D2D69636F6E20742D427574746F6E2D2D68656164657220742D427574746F6E2D2D6E61764261722220687265';
wwv_flow_api.g_varchar2_table(15) := '663D22272B692B27223E272C6C2B3D273C7370616E20636C6173733D22742D49636F6E20272B722B742E65736361706543535328732E69636F6E292B27223E3C2F7370616E3E3C7370616E20636C6173733D22742D427574746F6E2D6C6162656C223E27';
wwv_flow_api.g_varchar2_table(16) := '2B742E65736361706548544D4C28732E6C6162656C292B273C2F7370616E3E3C7370616E20636C6173733D22742D427574746F6E2D6261646765223E3C2F7370616E3E272C6C2B3D633F273C7370616E20636C6173733D22612D49636F6E2069636F6E2D';
wwv_flow_api.g_varchar2_table(17) := '646F776E2D6172726F77223E3C2F7370616E3E3C2F627574746F6E3E273A223C2F613E222C6C2B3D223C2F6C693E222C6528222E742D4E617669676174696F6E42617222292E70726570656E64286C292C63262628652822626F647922292E617070656E';
wwv_flow_api.g_varchar2_table(18) := '6428273C6469762069643D22272B742E657363617065435353286E292B27223E3C2F6469763E27292C65282223222B742E657363617065435353286E29292E6D656E75286129297D2C673D66756E6374696F6E28732C6E297B76617220613D6528222322';
wwv_flow_api.g_varchar2_table(19) := '2B742E657363617065435353287329292E6D656E7528226F7074696F6E22292E6974656D733B652E6561636828612C2866756E6374696F6E28652C74297B742E69636F6E3D6E756C6C2C742E69643D3D3D6E262628742E69636F6E3D2266612066612D63';
wwv_flow_api.g_varchar2_table(20) := '6865636B22297D29297D2C433D66756E6374696F6E28297B72657475726E206528276C696E6B5B747970653D22746578742F637373225D272C2268746D6C22292E66696C746572282866756E6374696F6E2874297B76617220733D652874686973292E61';
wwv_flow_api.g_varchar2_table(21) := '74747228226872656622293B72657475726E206F2E64656661756C745374796C652E746573742873292626216F2E636F72655374796C652E746573742873292626216F2E64656D6F5374796C652E746573742873297D29297D2C783D66756E6374696F6E';
wwv_flow_api.g_varchar2_table(22) := '28297B72657475726E206528276C696E6B5B747970653D22746578742F637373225D272C2268746D6C22292E66696C746572282866756E6374696F6E2874297B76617220733D652874686973292E6174747228226872656622293B72657475726E206F2E';
wwv_flow_api.g_varchar2_table(23) := '637573746F6D5374796C652E746573742873297D29297D2C493D66756E6374696F6E28297B72657475726E206528276C696E6B5B747970653D22746578742F637373225D272C2268746D6C22292E66696C746572282866756E6374696F6E2874297B7661';
wwv_flow_api.g_varchar2_table(24) := '7220733D652874686973292E6174747228226872656622293B72657475726E206F2E636F72655374796C652E746573742873297D29297D2C623D66756E6374696F6E28297B72657475726E204928292E6174747228226872656622292E7265706C616365';
wwv_flow_api.g_varchar2_table(25) := '286F2E636F72655374796C652C22243322297D2C423D66756E6374696F6E28297B72657475726E20692E6973437573746F6D3F752E69643A4328292E6174747228226872656622292E7265706C616365286F2E64656661756C745374796C652C22243522';
wwv_flow_api.g_varchar2_table(26) := '297D2C443D66756E6374696F6E28297B72657475726E20532E6765744974656D286D297C7C6228297D2C563D66756E6374696F6E28297B72657475726E20532E6765744974656D2866297C7C4228297D2C243D66756E6374696F6E28652C742C73297B76';
wwv_flow_api.g_varchar2_table(27) := '617220612C722C703B696628613D766F696420303D3D3D653F4428293A653D3D3D6C2E69643F532E6765744974656D2868293A652C723D766F696420303D3D3D743F5628293A743D3D3D632E69643F532E6765744974656D2879293A742C642E66696E64';
wwv_flow_api.g_varchar2_table(28) := '2828653D3E652E69643D3D3D72292929696628703D642E66696E642828653D3E652E69643D3D3D7229292E73696E636556657273696F6E29696628703E6129617065782E6D6573736167652E636C6561724572726F727328292C617065782E6D65737361';
wwv_flow_api.g_varchar2_table(29) := '67652E73686F774572726F7273285B7B747970653A226572726F72222C6C6F636174696F6E3A2270616765222C6D6573736167653A225374796C6520646F65736E277420657869737420666F72207468652073656C65637465642076657273696F6E222C';
wwv_flow_api.g_varchar2_table(30) := '756E736166653A21317D5D293B656C736520696628723D3D3D752E696426266E3E6129617065782E6D6573736167652E636C6561724572726F727328292C617065782E6D6573736167652E73686F774572726F7273285B7B747970653A226572726F7222';
wwv_flow_api.g_varchar2_table(31) := '2C6C6F636174696F6E3A2270616765222C6D6573736167653A22437573746F6D207374796C6520646F65736E277420657869737420666F72207468652073656C65637465642076657273696F6E222C756E736166653A21317D5D293B656C73657B766172';
wwv_flow_api.g_varchar2_table(32) := '20762C673D4928292E6174747228226872656622292C623D672E7265706C616365286F2E636F72655374796C652C2224312432222B612B22243422293B67213D3D6226264928292E61747472282268726566222C62293B76617220422C243D28763D692E';
wwv_flow_api.g_varchar2_table(33) := '6973437573746F6D3F7828293A432829292E6174747228226872656622293B752E69643D3D3D723F28692E6973437573746F6D3D21302C423D692E637573746F6D46696C65293A28692E6973437573746F6D3D21312C423D672E7265706C616365286F2E';
wwv_flow_api.g_varchar2_table(34) := '64656661756C745374796C652C2224312432222B612B222434222B722B2224362229292C24213D3D42262628692E6973437573746F6D2C762E61747472282268726566222C4229292C532E7365744974656D286D2C61292C532E7365744974656D28662C';
wwv_flow_api.g_varchar2_table(35) := '72292C7326267328297D656C736520617065782E6D6573736167652E636C6561724572726F727328292C617065782E6D6573736167652E73686F774572726F7273285B7B747970653A226572726F72222C6C6F636174696F6E3A2270616765222C6D6573';
wwv_flow_api.g_varchar2_table(36) := '736167653A225374796C65206E6F7420666F756E64222C756E736166653A21317D5D293B656C736520636F6E736F6C652E6C6F6728605374796C6520247B727D20646F6573206E6F742065786973742E2049676E6F72696E6760297D3B732E7365745374';
wwv_flow_api.g_varchar2_table(37) := '796C653D66756E6374696F6E28652C74297B2428766F696420302C652C74297D2C732E73657456657273696F6E3D66756E6374696F6E28652C74297B2428652C766F696420302C74297D2C732E746F67676C6552746C3D66756E6374696F6E28297B6528';
wwv_flow_api.g_varchar2_table(38) := '2268746D6C22292E686173436C6173732822752D52544C22293F28532E72656D6F76654974656D2870292C65282268746D6C22292E72656D6F7665436C6173732822752D52544C22292E617474722822646972222C226C74722229293A28532E73657449';
wwv_flow_api.g_varchar2_table(39) := '74656D28702C2272746C22292C65282268746D6C22292E616464436C6173732822752D52544C22292E617474722822646972222C2272746C2229297D2C732E696E69743D66756E6374696F6E28297B76617220652C742C6C3B7828292E6C656E6774683E';
wwv_flow_api.g_varchar2_table(40) := '30262628692E6973437573746F6D3D21302C692E637573746F6D46696C653D7828292E6174747228226872656622292E7265706C616365286F2E64656661756C745374796C652C22243522292C642E66696E642828653D3E652E69643D3D3D752E696429';
wwv_flow_api.g_varchar2_table(41) := '292E64697361626C65643D2131292C6E3D6228292C613D4228292C532E7365744974656D28682C6E292C532E7365744974656D28792C61292C24284428292C562829292C532E6765744974656D2870292626732E746F67676C6552746C28292C6C3D7B69';
wwv_flow_api.g_varchar2_table(42) := '74656D733A28653D642C743D5628292C652E6D6170282866756E6374696F6E2865297B76617220733D7B747970653A22616374696F6E227D3B72657475726E20732E69643D652E69642C732E6C6162656C3D652E6E616D652C732E64697361626C65643D';
wwv_flow_api.g_varchar2_table(43) := '652E64697361626C65647C7C21312C652E69643D3D3D74262628732E69636F6E3D2266612066612D636865636B22292C732E616374696F6E3D66756E6374696F6E28297B76617220743D746869732E69643B75744465764D6F64652E7365745374796C65';
wwv_flow_api.g_varchar2_table(44) := '28652E69642C2866756E6374696F6E28297B6728722C74297D29297D2C737D2929292C63616C6C6F75743A21307D2C76287B636C6173733A227468656D652D7374796C65732D6C697374222C6C6162656C3A225468656D65205374796C65222C69636F6E';
wwv_flow_api.g_varchar2_table(45) := '3A2266612D7061696E742D6272757368222C69636F6E4F6E6C793A21317D2C722C6C292C76287B636C6173733A2272746C2D73656C6563746F72222C6C6162656C3A2252544C222C69636F6E3A2266612D6172726F772D7269676874222C69636F6E4F6E';
wwv_flow_api.g_varchar2_table(46) := '6C793A21317D2C766F696420302C766F696420302C226A6176617363726970743A2075744465764D6F64652E746F67676C6552746C28293B22297D7D28617065782E6A51756572792C617065782E7574696C2C75744465764D6F6465292C24282866756E';
wwv_flow_api.g_varchar2_table(47) := '6374696F6E28297B75744465764D6F64652E696E697428297D29293B0A2F2F2320736F757263654D617070696E6755524C3D75744465764D6F64652E6A732E6D6170';
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(784244673974151281)
,p_file_name=>'utDevMode.min.js'
,p_mime_type=>'application/javascript'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/bookmarklet_min_js
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2F2A210A20202020436F707972696768742028632920323031342C204F7261636C6520616E642F6F722069747320616666696C69617465732E20416C6C207269676874732072657365727665642E0A202A2F0A2166756E6374696F6E28297B696628766F';
wwv_flow_api.g_varchar2_table(2) := '69642030213D3D77696E646F772E24297B76617220652C743D7B42726561646372756D623A7B2242726561646372756D62204D656E75223A2242726561646372756D62227D2C427574746F6E3A7B22486F7420427574746F6E202852656429223A225465';
wwv_flow_api.g_varchar2_table(3) := '7874222C22486F7420427574746F6E2028426C61636B29223A2254657874222C22486F7420427574746F6E2028526564204F75746C696E6529223A2254657874222C22536D616C6C20427574746F6E223A2254657874222C427574746F6E3A2254657874';
wwv_flow_api.g_varchar2_table(4) := '222C2248544D4C20627574746F6E20286C6567616379202D20415045582035206D6967726174696F6E29223A2254657874222C2248544D4C20696D61676520286C6567616379202D20415045582035206D6967726174696F6E29223A2254657874222C22';
wwv_flow_api.g_varchar2_table(5) := '536D616C6C20486F7420427574746F6E202852656429223A2254657874227D2C4C6162656C3A7B52657175697265643A225265717569726564222C22526571756972656420776974682068656C70223A225265717569726564222C4F7074696F6E616C3A';
wwv_flow_api.g_varchar2_table(6) := '224F7074696F6E616C222C224E6F204C6162656C223A2248696464656E222C224F7074696F6E616C20776974682068656C70223A224F7074696F6E616C227D2C224C65676163792043616C656E646172223A7B43616C656E6461723A2243616C656E6461';
wwv_flow_api.g_varchar2_table(7) := '72222C2243616C656E6461722C20416C7465726E61746976652031223A2243616C656E646172222C22536D616C6C2043616C656E646172223A2243616C656E646172227D2C4C6973743A7B22486F72697A6F6E74616C205461627320526F756E64656420';
wwv_flow_api.g_varchar2_table(8) := '4C697374202846756C6C20576964746829223A2254616273222C2248696572617263686963616C20457870616E64696E67223A224C696E6B73204C697374222C22486F72697A6F6E74616C20496D616765732077697468204C6162656C204C697374223A';
wwv_flow_api.g_varchar2_table(9) := '224D65646961204C697374222C22566572746963616C20496D61676573204C697374223A224D65646961204C697374222C22546162626564204E617669676174696F6E204C697374223A2254616273222C224448544D4C2054726565223A224C696E6B73';
wwv_flow_api.g_varchar2_table(10) := '204C697374222C2257697A6172642050726F6772657373204C6973742C20486F72697A6F6E74616C20547261696E223A2257697A6172642050726F6772657373222C2257697A6172642050726F6772657373204C697374223A2257697A6172642050726F';
wwv_flow_api.g_varchar2_table(11) := '6772657373222C22566572746963616C20556E6F726465726564204C69737420776974682042756C6C6574732C20416C7465726E6174697665223A224C696E6B73204C697374222C2250756C6C20446F776E204D656E75207769746820496D616765223A';
wwv_flow_api.g_varchar2_table(12) := '224C696E6B73204C697374222C22427574746F6E204C697374223A224C696E6B73204C697374222C22486F72697A6F6E74616C205461627320526F756E646564204C697374223A2254616273222C22566572746963616C204F726465726564204C697374';
wwv_flow_api.g_varchar2_table(13) := '223A224C696E6B73204C697374222C22566572746963616C20556E6F726465726564204C69737420776974686F75742042756C6C657473223A224C696E6B73204C697374222C22566572746963616C20556E6F726465726564204C697374207769746820';
wwv_flow_api.g_varchar2_table(14) := '42756C6C657473223A224C696E6B73204C697374222C2250756C6C20446F776E204D656E75223A224C696E6B73204C697374222C22486F72697A6F6E74616C204C696E6B73204C697374223A224D65646961204C697374222C2250616765204C6576656C';
wwv_flow_api.g_varchar2_table(15) := '2054616273204C697374223A22546F70204E617669676174696F6E204D656E75222C22566572746963616C2053696465626172204C697374223A224C696E6B73204C697374222C2243656E74657265642054616220536574223A2254616273227D2C5061';
wwv_flow_api.g_varchar2_table(16) := '67653A7B224F6E65204C6576656C2054616273202D204C65667420616E642052696768742053696465626172202866697865642D7769647468202F20444956206C65667420616E64206F7074696F6E616C207461626C652D626173656420726967687429';
wwv_flow_api.g_varchar2_table(17) := '223A224C65667420616E64205269676874205369646520436F6C756D6E73222C224E6F2054616273202D205269676874205369646562617220286F7074696F6E616C202F207461626C652D626173656429223A225374616E64617264222C225072696E74';
wwv_flow_api.g_varchar2_table(18) := '657220467269656E646C79223A224D696E696D616C20284E6F204E617669676174696F6E29222C4C6F67696E3A224C6F67696E222C2254776F204C6576656C2054616273202D204C6566742053696465626172202866697865642D7769647468202F2044';
wwv_flow_api.g_varchar2_table(19) := '495620626173656429223A224C656674205369646520436F6C756D6E222C224E6F2054616273202D2052696768742053696465626172202866697865642D7769647468202F2044495620626173656429223A225269676874205369646520436F6C756D6E';
wwv_flow_api.g_varchar2_table(20) := '222C2254776F204C6576656C2054616273202D2052696768742053696465626172202866697865642D7769647468202F2044495620626173656429223A225269676874205369646520436F6C756D6E222C224E6F2054616273202D204C65667420536964';
wwv_flow_api.g_varchar2_table(21) := '65626172202866697865642D7769647468202F2044495620626173656429223A224C656674205369646520436F6C756D6E222C224F6E65204C6576656C2054616273202D204C6566742053696465626172202866697865642D7769647468202F20444956';
wwv_flow_api.g_varchar2_table(22) := '20626173656429223A224C656674205369646520436F6C756D6E222C506F7075703A224D696E696D616C20284E6F204E617669676174696F6E29227D2C526567696F6E3A7B2249525220526567696F6E2054656D706C617465223A22496E746572616374';
wwv_flow_api.g_varchar2_table(23) := '697665205265706F7274222C2242726561646372756D6220526567696F6E223A225469746C6520426172222C225265706F72747320526567696F6E223A225374616E64617264222C2257697A61726420526567696F6E223A225374616E64617264222C22';
wwv_flow_api.g_varchar2_table(24) := '5369646562617220526567696F6E2C20426F726465726564223A225374616E64617264222C22427261636B6574656420526567696F6E223A225374616E64617264222C2243656E7465726564205461622053657420526567696F6E223A225374616E6461';
wwv_flow_api.g_varchar2_table(25) := '7264222C225369646562617220526567696F6E223A225374616E64617264222C225265706F72747320526567696F6E204E6F205469746C652C20416C7465726E61746976652031223A225374616E64617264222C224E617669676174696F6E2052656769';
wwv_flow_api.g_varchar2_table(26) := '6F6E223A225374616E64617264222C22466F726D20526567696F6E223A225374616E64617264222C225369646562617220526567696F6E2C20426F72646572656420416C7465726E6174697665223A225374616E64617264222C22427574746F6E205265';
wwv_flow_api.g_varchar2_table(27) := '67696F6E2077697468205469746C65223A22427574746F6E7320436F6E7461696E6572222C225369646562617220526567696F6E2C20416C7465726E61746976652031223A225374616E64617264222C224E657374656420526567696F6E223A22537461';
wwv_flow_api.g_varchar2_table(28) := '6E64617264222C225265706F72747320526567696F6E204E6F205469746C65223A225374616E64617264222C22427574746F6E20526567696F6E20776974686F7574205469746C65223A22427574746F6E7320436F6E7461696E6572222C225265706F72';
wwv_flow_api.g_varchar2_table(29) := '747320526567696F6E2C20416C7465726E61746976652031223A225374616E64617264222C224869646520616E642053686F7720526567696F6E223A22436F6C6C61707369626C65222C224368617274204C697374223A225374616E64617264222C2252';
wwv_flow_api.g_varchar2_table(30) := '6567696F6E20776974686F7574205469746C65223A225374616E64617264222C22526567696F6E20776974686F757420427574746F6E7320616E64205469746C6573223A225374616E64617264222C22426F726465726C65737320526567696F6E202D20';
wwv_flow_api.g_varchar2_table(31) := '4E6F205469746C65223A22426C616E6B20776974682041747472696275746573222C225265706F72747320526567696F6E2031303025205769647468223A225374616E64617264222C22436861727420526567696F6E223A225374616E64617264222C22';
wwv_flow_api.g_varchar2_table(32) := '426F726465726C65737320526567696F6E223A225374616E64617264222C224E617669676174696F6E20526567696F6E2C20416C7465726E61746976652031223A225374616E64617264222C2257697A61726420526567696F6E20776974682049636F6E';
wwv_flow_api.g_varchar2_table(33) := '223A225374616E64617264227D2C5265706F72743A7B5374616E646172643A225374616E64617264222C2256616C756520417474726962757465205061697273202D20446976223A2256616C756520417474726962757465205061697273202D20436F6C';
wwv_flow_api.g_varchar2_table(34) := '756D6E222C225374616E646172642C20416C7465726E6174696E6720526F7720436F6C6F7273223A225374616E64617264222C2246697865642048656164657273223A225374616E64617264222C22426F726465726C657373205265706F7274223A2253';
wwv_flow_api.g_varchar2_table(35) := '656172636820526573756C7473222C2254776F20436F6C756D6E20506F72746C6574223A2256616C756520417474726962757465205061697273202D20526F77222C22486F72697A6F6E74616C20426F72646572223A225374616E64617264222C225365';
wwv_flow_api.g_varchar2_table(36) := '6172636820526573756C7473205265706F7274202853454C454354206C696E6B5F746578742C206C696E6B5F7461726765742C2064657461696C312C2064657461696C322C206C6173745F6D6F64696669656429223A2253656172636820526573756C74';
wwv_flow_api.g_varchar2_table(37) := '73227D7D2C693D7B32363A7B696D6167653A2268747470733A2F2F617065782E6F7261636C652E636F6D2F706C732F617065782F617065785F706D2F722F34322F66696C65732F7374617469632F7638342F2F692F7468656D6532362E706E67222C7465';
wwv_flow_api.g_varchar2_table(38) := '78743A225468656D65203236202D2050726F647563746976697479204170706C69636174696F6E73222C6D617070696E67733A7B42726561646372756D623A7B2242726561646372756D62204D656E75223A2242726561646372756D62222C2248696572';
wwv_flow_api.g_varchar2_table(39) := '617263686963616C204D656E75223A2242726561646372756D62227D2C427574746F6E3A7B225B202B205D2041646420427574746F6E223A2249636F6E222C225B203E205D20476F20546F20427574746F6E223A2249636F6E222C225B2054657874205D';
wwv_flow_api.g_varchar2_table(40) := '20427574746F6E223A2254657874222C427574746F6E3A2254657874222C2248544D4C20627574746F6E20286C6567616379202D20415045582035206D6967726174696F6E29223A2254657874222C22496E746572616374697665205265706F72742042';
wwv_flow_api.g_varchar2_table(41) := '7574746F6E20284E65787429223A225465787420776974682049636F6E222C22496E746572616374697665205265706F727420427574746F6E223A2254657874222C224C6172676520427574746F6E20284E65787429223A225465787420776974682049';
wwv_flow_api.g_varchar2_table(42) := '636F6E222C224C6172676520427574746F6E202850726576696F757329223A225465787420776974682049636F6E222C224C6172676520427574746F6E223A2254657874222C22536D616C6C20427574746F6E223A2254657874227D2C4C6162656C3A7B';
wwv_flow_api.g_varchar2_table(43) := '2248696464656E206C6162656C2C20726561642062792073637265656E20726561646572223A2248696464656E222C224E6F204C6162656C223A2248696464656E222C224F7074696F6E616C20776974682068656C70223A224F7074696F6E616C222C4F';
wwv_flow_api.g_varchar2_table(44) := '7074696F6E616C3A224F7074696F6E616C222C22526571756972656420776974682068656C70223A225265717569726564222C52657175697265643A225265717569726564227D2C224C65676163792043616C656E646172223A7B2243616C656E646172';
wwv_flow_api.g_varchar2_table(45) := '202D20416C7465726E6174697665223A2243616C656E646172222C43616C656E6461723A2243616C656E646172222C22536D616C6C2043616C656E646172223A2243616C656E646172227D2C4C6973743A7B22427574746F6E204C697374223A224C696E';
wwv_flow_api.g_varchar2_table(46) := '6B73204C697374222C224448544D4C2054726565223A224C696E6B73204C697374222C224665617475726564204C69737420776974682053756274657874223A224D65646961206C697374222C2248696572617263686963616C20457870616E64696E67';
wwv_flow_api.g_varchar2_table(47) := '223A224C696E6B73204C697374222C22486F72697A6F6E74616C20496D616765732077697468204C6162656C204C697374223A224D65646961204C697374222C22486F72697A6F6E74616C204C696E6B73204C697374223A224D65646961204C69737422';
wwv_flow_api.g_varchar2_table(48) := '2C22486F72697A6F6E74616C2057697A6172642050726F6772657373204C697374223A2257697A6172642050726F6772657373222C2250616765204C6576656C2054616273204C697374223A22546F70204E617669676174696F6E204D656E75222C2250';
wwv_flow_api.g_varchar2_table(49) := '756C6C20446F776E204D656E75207769746820496D616765223A224C696E6B73204C697374222C2250756C6C20446F776E204D656E75223A224C696E6B73204C697374222C225365617263682046696C7465722054616273223A2254616273222C225461';
wwv_flow_api.g_varchar2_table(50) := '62626564204E617669676174696F6E204C697374223A2254616273222C22566572746963616C20496D61676573204C697374223A224D65646961204C697374222C22566572746963616C204C6973742077697468205375627465787420616E642049636F';
wwv_flow_api.g_varchar2_table(51) := '6E223A224D65646961204C697374222C22566572746963616C204F726465726564204C697374223A224C696E6B73204C697374222C22566572746963616C2053696465626172204C697374223A224C696E6B73204C697374222C22566572746963616C20';
wwv_flow_api.g_varchar2_table(52) := '556E6F726465726564204C69737420776974682042756C6C657473223A224C696E6B73204C697374222C22566572746963616C20556E6F726465726564204C69737420776974686F75742042756C6C657473223A224C696E6B73204C697374222C225769';
wwv_flow_api.g_varchar2_table(53) := '7A6172642050726F6772657373204C697374202D20566572746963616C223A2257697A6172642050726F6772657373227D2C506167653A7B4469616C6F673A224D6F64616C204469616C6F67222C4C6F67696E3A224C6F67696E222C224D696E696D616C';
wwv_flow_api.g_varchar2_table(54) := '2050616765223A224D696E696D616C20284E6F204E617669676174696F6E29222C224E6F2054616273202D204C65667420616E642052696768742053696465626172223A224C65667420616E64205269676874205369646520436F6C756D6E73222C224E';
wwv_flow_api.g_varchar2_table(55) := '6F2054616273202D204C6566742053696465626172223A224C656674205369646520436F6C756D6E222C224E6F2054616273202D204E6F2053696465626172223A225374616E64617264222C224E6F2054616273202D2052696768742053696465626172';
wwv_flow_api.g_varchar2_table(56) := '223A225269676874205369646520436F6C756D6E222C224F6E65204C6576656C2054616273202D20436F6E74656E74204672616D65223A224D61737465722044657461696C222C224F6E65204C6576656C2054616273202D204C65667420616E64205269';
wwv_flow_api.g_varchar2_table(57) := '6768742053696465626172223A224C65667420616E64205269676874205369646520436F6C756D6E222C224F6E65204C6576656C2054616273202D204C6566742053696465626172223A224C656674205369646520436F6C756D6E222C224F6E65204C65';
wwv_flow_api.g_varchar2_table(58) := '76656C2054616273202D204E6F2053696465626172223A225374616E64617264222C224F6E65204C6576656C2054616273202D2052696768742053696465626172223A225269676874205369646520436F6C756D6E222C224F6E65204C6576656C205461';
wwv_flow_api.g_varchar2_table(59) := '6273202D205365617263682046696C74657220426172223A224C656674205369646520436F6C756D6E222C224F6E65204C6576656C2054616273202D2057697A6172642050616765223A225374616E64617264222C506F7075703A224D696E696D616C20';
wwv_flow_api.g_varchar2_table(60) := '284E6F204E617669676174696F6E29222C225072696E74657220467269656E646C79223A224D696E696D616C20284E6F204E617669676174696F6E29222C2254776F204C6576656C2054616273202D204C65667420616E64205269676874205369646562';
wwv_flow_api.g_varchar2_table(61) := '6172223A224C65667420616E64205269676874205369646520436F6C756D6E73222C2254776F204C6576656C2054616273202D204C6566742053696465626172223A224C656674205369646520436F6C756D6E222C2254776F204C6576656C2054616273';
wwv_flow_api.g_varchar2_table(62) := '202D204E6F2053696465626172223A225374616E64617264222C2254776F204C6576656C2054616273202D2052696768742053696465626172223A225269676874205369646520436F6C756D6E227D2C526567696F6E3A7B2249525220526567696F6E20';
wwv_flow_api.g_varchar2_table(63) := '54656D706C617465223A22496E746572616374697665205265706F7274222C2241636365737369626C6520526567696F6E20776974682048656164696E67223A225374616E64617264222C22416C65727420526567696F6E223A22416C657274222C2242';
wwv_flow_api.g_varchar2_table(64) := '6F726465726C65737320526567696F6E20286E6F2068656164696E6729223A225374616E64617264222C22426F726465726C65737320526567696F6E223A225374616E64617264222C22427261636B6574656420526567696F6E223A225374616E646172';
wwv_flow_api.g_varchar2_table(65) := '64222C2242726561646372756D6220526567696F6E223A225469746C6520426172222C22427574746F6E20526567696F6E2077697468205469746C65223A22427574746F6E7320436F6E7461696E6572222C22427574746F6E20526567696F6E20776974';
wwv_flow_api.g_varchar2_table(66) := '686F7574205469746C65223A22427574746F6E7320436F6E7461696E6572222C224368617274204C697374223A225374616E64617264222C22436861727420526567696F6E223A225374616E64617264222C22436F6E74656E74204672616D6520426F64';
wwv_flow_api.g_varchar2_table(67) := '7920436F6E7461696E6572223A22426C616E6B20776974682041747472696275746573222C2244495620526567696F6E2077697468204944223A22426C616E6B20776974682041747472696275746573222C22466F726D20526567696F6E223A22537461';
wwv_flow_api.g_varchar2_table(68) := '6E64617264222C224869646520616E642053686F7720526567696F6E202848696464656E20466972737429202D20426F726465726C657373223A22436F6C6C61707369626C65222C224869646520616E642053686F7720526567696F6E202D20426F7264';
wwv_flow_api.g_varchar2_table(69) := '65726C657373223A22436F6C6C61707369626C65222C224869646520616E642053686F7720526567696F6E223A22436F6C6C61707369626C65222C22496E746572616374697665205265706F727420526567696F6E223A22496E74657261637469766520';
wwv_flow_api.g_varchar2_table(70) := '5265706F7274222C226A5175657279204D6F64616C20526567696F6E2054656D706C617465223A22496E6C696E65204469616C6F67222C224C6F67696E20526567696F6E223A224C6F67696E222C224D6F64616C20526567696F6E223A22496E6C696E65';
wwv_flow_api.g_varchar2_table(71) := '204469616C6F67222C224E617669676174696F6E20526567696F6E202D2048656164696E6720496E73696465223A225374616E64617264222C224E617669676174696F6E20526567696F6E223A225374616E64617264222C22526567696F6E2077697468';
wwv_flow_api.g_varchar2_table(72) := '6F757420427574746F6E7320616E64205469746C6573223A225374616E64617264222C22526567696F6E20776974686F7574205469746C65223A225374616E64617264222C225265706F72742046696C746572202D2053696E676C6520526F77223A2253';
wwv_flow_api.g_varchar2_table(73) := '74616E64617264222C225265706F7274204C697374223A225374616E64617264222C225265706F72747320526567696F6E202D2031303025205769647468223A225374616E64617264222C225265706F72747320526567696F6E202D2048656164696E67';
wwv_flow_api.g_varchar2_table(74) := '20496E73696465223A225374616E64617264222C225265706F72747320526567696F6E223A225374616E64617264222C225363726F6C6C61626C6520436F6E74656E7420526567696F6E223A225374616E64617264222C225365617263682046696C7465';
wwv_flow_api.g_varchar2_table(75) := '7220526567696F6E223A225374616E64617264222C225369646562617220526567696F6E202D2048656164696E6720496E73696465223A225374616E64617264222C225369646562617220526567696F6E223A225374616E64617264222C2257697A6172';
wwv_flow_api.g_varchar2_table(76) := '6420427574746F6E73223A22427574746F6E7320436F6E7461696E6572222C2257697A61726420526567696F6E20776974682049636F6E223A225374616E64617264222C2257697A61726420526567696F6E223A225374616E64617264227D2C5265706F';
wwv_flow_api.g_varchar2_table(77) := '72743A7B22426F726465726C657373205265706F7274223A225374616E64617264222C22436F6D6D656E7420427562626C6573223A22436F6D6D656E7473222C2246697865642048656164657273223A225374616E64617264222C22486F72697A6F6E74';
wwv_flow_api.g_varchar2_table(78) := '616C20426F72646572223A225374616E64617264222C224F6E6520436F6C756D6E20556E6F726465726564204C697374223A224C696E6B73204C697374222C2253656172636820526573756C7473205265706F7274202853454C454354206C696E6B5F74';
wwv_flow_api.g_varchar2_table(79) := '6578742C206C696E6B5F7461726765742C2064657461696C312C2064657461696C322C206C6173745F6D6F64696669656429223A2253656172636820526573756C7473222C225374616E64617264202D20416C7465726E6174697665223A225374616E64';
wwv_flow_api.g_varchar2_table(80) := '617264222C5374616E646172643A225374616E64617264222C2254776F20436F6C756D6E20506F72746C6574223A2256616C756520417474726962757465205061697273202D20526F77222C2256616C756520417474726962757465205061697273202D';
wwv_flow_api.g_varchar2_table(81) := '204C65667420416C69676E6564223A2256616C756520417474726962757465205061697273202D20436F6C756D6E222C2256616C756520417474726962757465205061697273223A2256616C756520417474726962757465205061697273202D20436F6C';
wwv_flow_api.g_varchar2_table(82) := '756D6E227D7D7D2C32353A7B746578743A225468656D65203235202D20426C756520526573706F6E73697665222C696D6167653A2268747470733A2F2F617065782E6F7261636C652E636F6D2F706C732F617065782F617065785F706D2F722F34322F66';
wwv_flow_api.g_varchar2_table(83) := '696C65732F7374617469632F7638342F2F692F7468656D6532352E706E67222C6D617070696E67733A7B42726561646372756D623A7B2242726561646372756D62204D656E75223A2242726561646372756D62227D2C427574746F6E3A7B22427574746F';
wwv_flow_api.g_varchar2_table(84) := '6E202D2049636F6E204F6E6C79223A2249636F6E222C22427574746F6E202D2049636F6E223A225465787420776974682049636F6E222C427574746F6E3A2254657874222C2248544D4C20627574746F6E20286C6567616379202D20415045582035206D';
wwv_flow_api.g_varchar2_table(85) := '6967726174696F6E29223A2254657874222C224C6172676520427574746F6E202D2049636F6E204F6E6C79223A2254657874222C224C6172676520427574746F6E202D2049636F6E223A2249636F6E222C224C6172676520427574746F6E223A2249636F';
wwv_flow_api.g_varchar2_table(86) := '6E227D2C4C6162656C3A7B2248696464656E204C6162656C2028526561642062792053637265656E205265616465727329223A2248696464656E222C224F7074696F6E616C2028486F72697A6F6E74616C202D204C65667420416C69676E656429223A22';
wwv_flow_api.g_varchar2_table(87) := '4F7074696F6E616C222C224F7074696F6E616C2028486F72697A6F6E74616C202D20526967687420416C69676E656429223A224F7074696F6E616C222C224F7074696F6E616C20284C6162656C2041626F766529223A224F7074696F6E616C222C225265';
wwv_flow_api.g_varchar2_table(88) := '7175697265642028486F72697A6F6E74616C202D204C65667420416C69676E656429223A224F7074696F6E616C222C2252657175697265642028486F72697A6F6E74616C202D20526967687420416C69676E656429223A224F7074696F6E616C222C2252';
wwv_flow_api.g_varchar2_table(89) := '6571756972656420284C6162656C2041626F766529223A224F7074696F6E616C227D2C224C65676163792043616C656E646172223A7B43616C656E6461723A2243616C656E646172227D2C4C6973743A7B22427574746F6E204C697374223A224C696E6B';
wwv_flow_api.g_varchar2_table(90) := '73204C697374222C224665617475726564204C69737420776974682053756274657874223A224D65646961204C697374222C22486F72697A6F6E74616C20496D616765732077697468204C6162656C204C697374223A224D65646961204C697374222C22';
wwv_flow_api.g_varchar2_table(91) := '486F72697A6F6E74616C204C696E6B73204C697374223A224D65646961204C697374222C22486F72697A6F6E74616C2057697A6172642050726F6772657373204C697374223A2257697A6172642050726F6772657373222C2250616765204C6576656C20';
wwv_flow_api.g_varchar2_table(92) := '54616273204C697374223A22546F70204E617669676174696F6E204D656E75222C22546162626564204E617669676174696F6E204C697374223A2254616273222C22566572746963616C20496D61676573204C697374223A224D65646961204C69737422';
wwv_flow_api.g_varchar2_table(93) := '2C22566572746963616C204C6973742077697468205375627465787420616E642049636F6E223A224D65646961204C697374222C22566572746963616C204F726465726564204C697374223A224C696E6B73204C697374222C22566572746963616C2053';
wwv_flow_api.g_varchar2_table(94) := '696465626172204C697374223A224C696E6B73204C697374222C22566572746963616C20556E6F726465726564204C69737420776974682042756C6C657473223A224C696E6B73204C697374222C22566572746963616C20556E6F726465726564204C69';
wwv_flow_api.g_varchar2_table(95) := '737420776974686F75742042756C6C657473223A224C696E6B73204C697374222C2257697A6172642050726F6772657373204C697374202D20566572746963616C223A2257697A6172642050726F6772657373227D2C506167653A7B4469616C6F673A22';
wwv_flow_api.g_varchar2_table(96) := '4D6F64616C204469616C6F67222C4C6F67696E3A224C6F67696E222C224E6F2054616273202D204C65667420616E642052696768742053696465626172223A224C65667420616E64205269676874205369646520436F6C756D6E222C224E6F2054616273';
wwv_flow_api.g_varchar2_table(97) := '202D204C6566742053696465626172223A224C656674205369646520436F6C756D6E222C224E6F2054616273202D204E6F2053696465626172223A225374616E64617264222C224E6F2054616273202D2052696768742053696465626172223A22526967';
wwv_flow_api.g_varchar2_table(98) := '6874205369646520436F6C756D6E222C224F6E65204C6576656C2054616273202D20436F6E74656E74204672616D65223A224D61737465722044657461696C222C224F6E65204C6576656C2054616273202D204C65667420616E64205269676874205369';
wwv_flow_api.g_varchar2_table(99) := '6465626172223A224C65667420616E64205269676874205369646520436F6C756D6E222C224F6E65204C6576656C2054616273202D204C6566742053696465626172223A224C656674205369646520436F6C756D6E222C224F6E65204C6576656C205461';
wwv_flow_api.g_varchar2_table(100) := '6273202D204E6F2053696465626172223A225374616E64617264222C224F6E65204C6576656C2054616273202D2052696768742053696465626172223A225269676874205369646520436F6C756D6E222C224F6E65204C6576656C2054616273202D2057';
wwv_flow_api.g_varchar2_table(101) := '697A6172642050616765223A225374616E64617264222C506F7075703A224D696E696D616C20284E6F204E617669676174696F6E29222C225072696E74657220467269656E646C79223A224D696E696D616C20284E6F204E617669676174696F6E29222C';
wwv_flow_api.g_varchar2_table(102) := '2254776F204C6576656C2054616273202D204C65667420616E642052696768742053696465626172223A224C65667420616E64205269676874205369646520436F6C756D6E222C2254776F204C6576656C2054616273202D204C65667420536964656261';
wwv_flow_api.g_varchar2_table(103) := '72223A224C656674205369646520436F6C756D6E222C2254776F204C6576656C2054616273202D204E6F2053696465626172223A225374616E64617264222C2254776F204C6576656C2054616273202D2052696768742053696465626172223A22526967';
wwv_flow_api.g_varchar2_table(104) := '6874205369646520436F6C756D6E227D2C526567696F6E3A7B2249525220526567696F6E2054656D706C617465223A22496E746572616374697665205265706F7274222C2241636365737369626C6520526567696F6E20776974682048656164696E6722';
wwv_flow_api.g_varchar2_table(105) := '3A225374616E64617264222C22416C65727420526567696F6E223A22416C657274222C22426F726465726C65737320526567696F6E223A225374616E64617264222C2242726561646372756D6220526567696F6E223A225469746C6520426172222C2242';
wwv_flow_api.g_varchar2_table(106) := '7574746F6E20526567696F6E2077697468205469746C65223A22427574746F6E7320436F6E7461696E6572222C22427574746F6E20526567696F6E20776974686F7574205469746C65223A22427574746F6E7320436F6E7461696E6572222C22436F6E74';
wwv_flow_api.g_varchar2_table(107) := '656E74204672616D6520426F647920436F6E7461696E6572223A22426C616E6B20776974682041747472696275746573222C2244495620526567696F6E2077697468204944223A22426C616E6B20776974682041747472696275746573222C22466F726D';
wwv_flow_api.g_varchar2_table(108) := '20526567696F6E223A225374616E64617264222C224869646520616E642053686F7720526567696F6E2028457870616E64656429223A22436F6C6C61707369626C65222C224869646520616E642053686F7720526567696F6E202848696464656E29223A';
wwv_flow_api.g_varchar2_table(109) := '22436F6C6C61707369626C65222C22496E746572616374697665205265706F727420526567696F6E223A22496E746572616374697665205265706F7274222C224D6F64616C20526567696F6E223A22496E6C696E65204469616C6F67222C22526567696F';
wwv_flow_api.g_varchar2_table(110) := '6E20776974686F757420427574746F6E7320616E64205469746C6573223A225374616E64617264222C225369646562617220526567696F6E223A225374616E64617264222C225374616E6461726420526567696F6E202D204E6F2050616464696E67223A';
wwv_flow_api.g_varchar2_table(111) := '225374616E64617264222C225374616E6461726420526567696F6E223A225374616E64617264222C2257697A61726420427574746F6E73223A22427574746F6E7320436F6E7461696E6572227D2C5265706F72743A7B22426F726465726C657373205265';
wwv_flow_api.g_varchar2_table(112) := '706F7274223A225374616E64617264222C22436F6D6D656E7420427562626C6573223A22436F6D6D656E7473222C2246697865642048656164657273223A225374616E64617264222C22486F72697A6F6E74616C20426F72646572223A225374616E6461';
wwv_flow_api.g_varchar2_table(113) := '7264222C224F6E6520436F6C756D6E20556E6F726465726564204C697374223A224C696E6B73204C697374222C2253656172636820526573756C7473205265706F7274202853454C454354206C696E6B5F746578742C206C696E6B5F7461726765742C20';
wwv_flow_api.g_varchar2_table(114) := '64657461696C312C2064657461696C322C206C6173745F6D6F64696669656429223A2253656172636820526573756C7473222C225374616E64617264202D20416C7465726E6174697665223A225374616E64617264222C5374616E646172643A22537461';
wwv_flow_api.g_varchar2_table(115) := '6E64617264222C2254776F20436F6C756D6E20506F72746C6574223A2256616C756520417474726962757465205061697273202D20526F77222C2256616C756520417474726962757465205061697273202D204C65667420416C69676E6564223A225661';
wwv_flow_api.g_varchar2_table(116) := '6C756520417474726962757465205061697273202D20436F6C756D6E222C2256616C756520417474726962757465205061697273223A2256616C756520417474726962757465205061697273202D20436F6C756D6E227D7D7D2C32343A7B746578743A22';
wwv_flow_api.g_varchar2_table(117) := '5468656D652032342D20436C6F756479222C696D6167653A2268747470733A2F2F617065782E6F7261636C652E636F6D2F706C732F617065782F617065785F706D2F722F34322F66696C65732F7374617469632F7638342F2F692F7468656D6532342E70';
wwv_flow_api.g_varchar2_table(118) := '6E67222C6D617070696E67733A7B42726561646372756D623A7B2242726561646372756D62204D656E75223A2242726561646372756D62222C2248696572617263686963616C204D656E75223A2242726561646372756D62227D2C427574746F6E3A7B22';
wwv_flow_api.g_varchar2_table(119) := '5B202B205D2041646420427574746F6E223A2249636F6E222C225B2054657874205D20427574746F6E223A2254657874222C427574746F6E3A2254657874222C2248544D4C20627574746F6E20286C6567616379202D20415045582035206D6967726174';
wwv_flow_api.g_varchar2_table(120) := '696F6E29223A2254657874222C22496E746572616374697665205265706F727420427574746F6E223A2254657874222C224C6172676520427574746F6E223A2254657874222C22536D616C6C20427574746F6E223A2254657874227D2C4C6162656C3A7B';
wwv_flow_api.g_varchar2_table(121) := '224C6162656C2048696464656E206C6162656C2C20726561642062792073637265656E20726561646572223A2248696464656E222C224E6F204C6162656C223A2248696464656E222C224F7074696F6E616C20776974682068656C70223A224F7074696F';
wwv_flow_api.g_varchar2_table(122) := '6E616C222C4F7074696F6E616C3A224F7074696F6E616C222C22526571756972656420776974682068656C70223A225265717569726564222C52657175697265643A225265717569726564227D2C224C65676163792043616C656E646172223A7B224361';
wwv_flow_api.g_varchar2_table(123) := '6C656E646172202D20416C7465726E6174697665223A2243616C656E646172222C43616C656E6461723A2243616C656E646172222C22536D616C6C2043616C656E646172223A2243616C656E646172227D2C4C6973743A7B22427574746F6E204C697374';
wwv_flow_api.g_varchar2_table(124) := '223A224C696E6B73204C697374222C224448544D4C2054726565223A224C696E6B73204C697374222C2248696572617263686963616C20457870616E64696E67223A224C696E6B73204C697374222C22486F72697A6F6E74616C20496D61676573207769';
wwv_flow_api.g_varchar2_table(125) := '7468204C6162656C204C697374223A224D65646961204C697374222C22486F72697A6F6E74616C204C696E6B73204C697374223A224C696E6B73204C697374222C22486F72697A6F6E74616C2057697A6172642050726F6772657373204C697374223A22';
wwv_flow_api.g_varchar2_table(126) := '57697A6172642050726F6772657373222C2250616765204C6576656C2054616273204C697374223A22546F70204E617669676174696F6E204D656E75222C2250756C6C20446F776E204D656E75207769746820496D616765223A224C696E6B73204C6973';
wwv_flow_api.g_varchar2_table(127) := '74222C2250756C6C20446F776E204D656E75223A224C696E6B73204C697374222C22546162626564204E617669676174696F6E204C697374223A2254616273222C22566572746963616C20496D61676573204C697374223A224C696E6B73204C69737422';
wwv_flow_api.g_varchar2_table(128) := '2C22566572746963616C204C6973742077697468205375627465787420616E642049636F6E223A224D65646961204C697374222C22566572746963616C204F726465726564204C697374223A224C696E6B73204C697374222C22566572746963616C2053';
wwv_flow_api.g_varchar2_table(129) := '696465626172204C697374223A224C696E6B73204C697374222C22566572746963616C20556E6F726465726564204C69737420776974682042756C6C657473223A224C696E6B73204C697374222C22566572746963616C20556E6F726465726564204C69';
wwv_flow_api.g_varchar2_table(130) := '737420776974686F75742042756C6C657473223A224C696E6B73204C697374222C2257697A6172642050726F6772657373204C697374202D20566572746963616C223A2257697A6172642050726F6772657373227D2C506167653A7B4469616C6F673A22';
wwv_flow_api.g_varchar2_table(131) := '4D6F64616C204469616C6F67222C4C6F67696E3A224C6F67696E222C224E6F2054616273202D204C65667420616E642052696768742053696465626172223A224C65667420616E64205269676874205369646520436F6C756D6E73222C224E6F20546162';
wwv_flow_api.g_varchar2_table(132) := '73202D204C6566742053696465626172223A224C656674205369646520436F6C756D6E222C224E6F2054616273202D204E6F2053696465626172223A225374616E64617264222C224E6F2054616273202D2052696768742053696465626172223A225269';
wwv_flow_api.g_varchar2_table(133) := '676874205369646520436F6C756D6E222C224F6E65204C6576656C2054616273202D20436F6E74656E74204672616D65223A224D61737465722044657461696C222C224F6E65204C6576656C2054616273202D204C65667420616E642052696768742053';
wwv_flow_api.g_varchar2_table(134) := '696465626172223A224C65667420616E64205269676874205369646520436F6C756D6E73222C224F6E65204C6576656C2054616273202D204C6566742053696465626172223A224C656674205369646520436F6C756D6E222C224F6E65204C6576656C20';
wwv_flow_api.g_varchar2_table(135) := '54616273202D2052696768742053696465626172223A225269676874205369646520436F6C756D6E222C224F6E65204C6576656C2054616273202D2057697A6172642050616765223A225374616E64617264222C506F7075703A224D696E696D616C2028';
wwv_flow_api.g_varchar2_table(136) := '4E6F204E617669676174696F6E29222C225072696E74657220467269656E646C79223A224D696E696D616C20284E6F204E617669676174696F6E29222C2254776F204C6576656C2054616273202D204C65667420616E6420526967687420536964656261';
wwv_flow_api.g_varchar2_table(137) := '72223A224C65667420616E64205269676874205369646520436F6C756D6E73222C2254776F204C6576656C2054616273202D204C6566742053696465626172223A224C656674205369646520436F6C756D6E222C2254776F204C6576656C205461627320';
wwv_flow_api.g_varchar2_table(138) := '2D204E6F2053696465626172223A225374616E64617264222C2254776F204C6576656C2054616273202D2052696768742053696465626172223A225269676874205369646520436F6C756D6E227D2C526567696F6E3A7B2249525220526567696F6E2054';
wwv_flow_api.g_varchar2_table(139) := '656D706C617465223A22496E746572616374697665205265706F7274222C22416C65727420526567696F6E223A22416C657274222C22426F726465726C65737320526567696F6E223A225374616E64617264222C22427261636B6574656420526567696F';
wwv_flow_api.g_varchar2_table(140) := '6E223A225374616E64617264222C2242726561646372756D6220526567696F6E223A225469746C6520426172222C22427574746F6E20526567696F6E2077697468205469746C65223A22427574746F6E7320436F6E7461696E6572222C22427574746F6E';
wwv_flow_api.g_varchar2_table(141) := '20526567696F6E20776974686F7574205469746C65223A22427574746F6E7320436F6E7461696E6572222C224368617274204C697374223A225374616E64617264222C22436861727420526567696F6E223A225374616E64617264222C22436F6E74656E';
wwv_flow_api.g_varchar2_table(142) := '74204672616D6520426F647920436F6E7461696E6572223A22426C616E6B20776974682041747472696275746573222C2244495620526567696F6E2077697468204944223A22426C616E6B20776974682041747472696275746573222C22466F726D2052';
wwv_flow_api.g_varchar2_table(143) := '6567696F6E223A225374616E64617264222C224869646520616E642053686F7720526567696F6E202848696464656E20466972737429202D20426F726465726C657373223A22436F6C6C61707369626C65222C224869646520616E642053686F77205265';
wwv_flow_api.g_varchar2_table(144) := '67696F6E202D20426F726465726C657373223A22436F6C6C61707369626C65222C224869646520616E642053686F7720526567696F6E223A22436F6C6C61707369626C65222C226A5175657279204D6F64616C20526567696F6E2054656D706C61746522';
wwv_flow_api.g_varchar2_table(145) := '3A22496E6C696E65204469616C6F67222C224C6F67696E20526567696F6E223A224C6F67696E222C224D6F64616C20526567696F6E223A22496E6C696E65204469616C6F67222C224E617669676174696F6E20526567696F6E202D2048656164696E6720';
wwv_flow_api.g_varchar2_table(146) := '496E73696465223A225374616E64617264222C224E617669676174696F6E20526567696F6E223A225374616E64617264222C22526567696F6E20776974686F757420427574746F6E7320616E64205469746C6573223A225374616E64617264222C225265';
wwv_flow_api.g_varchar2_table(147) := '67696F6E20776974686F7574205469746C65223A225374616E64617264222C225265706F72742046696C746572202D2053696E676C6520526F77223A225374616E64617264222C225265706F7274204C697374223A225374616E64617264222C22526570';
wwv_flow_api.g_varchar2_table(148) := '6F72747320526567696F6E202D2031303025205769647468223A225374616E64617264222C225265706F72747320526567696F6E202D2048656164696E6720496E73696465223A225374616E64617264222C225265706F72747320526567696F6E223A22';
wwv_flow_api.g_varchar2_table(149) := '5374616E64617264222C225363726F6C6C61626C6520436F6E74656E7420526567696F6E223A225374616E64617264222C225365617263682046696C74657220526567696F6E223A225374616E64617264222C225369646562617220526567696F6E202D';
wwv_flow_api.g_varchar2_table(150) := '2048656164696E6720496E73696465223A225374616E64617264222C225369646562617220526567696F6E223A225374616E64617264222C2257697A61726420427574746F6E73223A22427574746F6E7320436F6E7461696E6572222C2257697A617264';
wwv_flow_api.g_varchar2_table(151) := '20526567696F6E20776974682049636F6E223A225374616E64617264222C2257697A61726420526567696F6E223A225374616E64617264227D2C5265706F72743A7B22426F726465726C657373205265706F7274223A225374616E64617264222C22436F';
wwv_flow_api.g_varchar2_table(152) := '6D6D656E7420427562626C6573223A22436F6D6D656E7473222C2246697865642048656164657273223A225374616E64617264222C22486F72697A6F6E74616C20426F72646572223A225374616E64617264222C224F6E6520436F6C756D6E20556E6F72';
wwv_flow_api.g_varchar2_table(153) := '6465726564204C697374223A224C696E6B73204C697374222C2253656172636820526573756C7473205265706F7274202853454C454354206C696E6B5F746578742C206C696E6B5F7461726765742C2064657461696C312C2064657461696C322C206C61';
wwv_flow_api.g_varchar2_table(154) := '73745F6D6F64696669656429223A2253656172636820526573756C7473222C225374616E64617264202D20416C7465726E6174697665223A225374616E64617264222C5374616E646172643A225374616E64617264222C2254776F20436F6C756D6E2050';
wwv_flow_api.g_varchar2_table(155) := '6F72746C6574223A2256616C756520417474726962757465205061697273202D20526F77222C2256616C756520417474726962757465205061697273202D204C65667420416C69676E6564223A2256616C75652041747472696275746520506169727320';
wwv_flow_api.g_varchar2_table(156) := '2D20436F6C756D6E222C2256616C756520417474726962757465205061697273223A2256616C756520417474726962757465205061697273202D20436F6C756D6E227D7D7D2C32333A7B746578743A225468656D65203233202D204372696D736F6E222C';
wwv_flow_api.g_varchar2_table(157) := '696D6167653A2268747470733A2F2F617065782E6F7261636C652E636F6D2F706C732F617065782F617065785F706D2F722F34322F66696C65732F7374617469632F7638342F2F692F7468656D6532332E706E67222C6D617070696E67733A7B42726561';
wwv_flow_api.g_varchar2_table(158) := '646372756D623A7B2242726561646372756D62204D656E75223A2242726561646372756D62227D2C427574746F6E3A7B224C6172676520427574746F6E223A2254657874222C22536D616C6C20427574746F6E223A2254657874222C427574746F6E3A22';
wwv_flow_api.g_varchar2_table(159) := '54657874222C22496E746572616374697665205265706F727420427574746F6E223A2254657874222C2248544D4C20627574746F6E20286C6567616379202D20415045582035206D6967726174696F6E29223A2254657874227D2C4C6162656C3A7B224F';
wwv_flow_api.g_varchar2_table(160) := '7074696F6E616C20776974682068656C70223A224F7074696F6E616C222C4F7074696F6E616C3A224F7074696F6E616C222C52657175697265643A225265717569726564222C224E6F204C6162656C223A2248696464656E222C22526571756972656420';
wwv_flow_api.g_varchar2_table(161) := '776974682068656C70223A225265717569726564227D2C224C65676163792043616C656E646172223A7B43616C656E6461723A2243616C656E646172222C22536D616C6C2043616C656E646172223A2243616C656E646172222C2243616C656E64617220';
wwv_flow_api.g_varchar2_table(162) := '2D20416C7465726E6174697665223A2243616C656E646172227D2C4C6973743A7B22486F72697A6F6E74616C2057697A6172642050726F6772657373204C697374223A2257697A6172642050726F6772657373222C22566572746963616C204F72646572';
wwv_flow_api.g_varchar2_table(163) := '6564204C697374223A224C696E6B73204C697374222C22566572746963616C2053696465626172204C697374223A224C696E6B73204C697374222C2257697A6172642050726F6772657373204C697374202D20566572746963616C223A2257697A617264';
wwv_flow_api.g_varchar2_table(164) := '2050726F6772657373222C22566572746963616C20556E6F726465726564204C69737420776974682042756C6C657473223A224C696E6B73204C697374222C224448544D4C2054726565223A224C696E6B73204C697374222C2248696572617263686963';
wwv_flow_api.g_varchar2_table(165) := '616C20457870616E64696E67223A224C696E6B73204C697374222C2250756C6C20446F776E204D656E75207769746820496D616765223A224C696E6B73204C697374222C22427574746F6E204C697374223A224C696E6B73204C697374222C2250616765';
wwv_flow_api.g_varchar2_table(166) := '204C6576656C2054616273204C697374223A22546F70204E617669676174696F6E204D656E75222C22546162626564204E617669676174696F6E204C697374223A2254616273222C22566572746963616C20556E6F726465726564204C69737420776974';
wwv_flow_api.g_varchar2_table(167) := '686F75742042756C6C657473223A224C696E6B73204C697374222C22486F72697A6F6E74616C204C696E6B73204C697374223A224C696E6B73204C697374222C2250756C6C20446F776E204D656E75223A224C696E6B73204C697374222C225665727469';
wwv_flow_api.g_varchar2_table(168) := '63616C20496D61676573204C697374223A224C696E6B73204C697374222C22486F72697A6F6E74616C20496D616765732077697468204C6162656C204C697374223A224D65646961204C697374227D2C506167653A7B2254776F204C6576656C20546162';
wwv_flow_api.g_varchar2_table(169) := '73202D204C6566742053696465626172223A224C656674205369646520436F6C756D6E222C224E6F2054616273202D204E6F2053696465626172223A225374616E64617264222C225072696E74657220467269656E646C79223A224D696E696D616C2028';
wwv_flow_api.g_varchar2_table(170) := '4E6F204E617669676174696F6E29222C4C6F67696E3A224C6F67696E222C506F7075703A224D696E696D616C20284E6F204E617669676174696F6E29222C2254776F204C6576656C2054616273202D2052696768742053696465626172223A2252696768';
wwv_flow_api.g_varchar2_table(171) := '74205369646520436F6C756D6E222C224E6F2054616273202D2052696768742053696465626172223A225269676874205369646520436F6C756D6E222C224E6F2054616273202D204C6566742053696465626172223A224C656674205369646520436F6C';
wwv_flow_api.g_varchar2_table(172) := '756D6E222C224F6E65204C6576656C2054616273202D204C6566742053696465626172223A224C656674205369646520436F6C756D6E222C224F6E65204C6576656C2054616273202D204C65667420616E642052696768742053696465626172223A224C';
wwv_flow_api.g_varchar2_table(173) := '65667420616E64205269676874205369646520436F6C756D6E73227D2C526567696F6E3A7B2249525220526567696F6E2054656D706C617465223A22496E746572616374697665205265706F7274222C22427574746F6E20526567696F6E207769746820';
wwv_flow_api.g_varchar2_table(174) := '5469746C65223A22427574746F6E7320436F6E7461696E6572222C225265706F72747320526567696F6E202D2048656164696E6720496E73696465223A225374616E64617264222C224E617669676174696F6E20526567696F6E223A225374616E646172';
wwv_flow_api.g_varchar2_table(175) := '64222C225265706F72742046696C746572202D2053696E676C6520526F77223A225374616E64617264222C22427261636B6574656420526567696F6E223A225374616E64617264222C22436861727420526567696F6E223A225374616E64617264222C22';
wwv_flow_api.g_varchar2_table(176) := '4E617669676174696F6E20526567696F6E202D2048656164696E6720496E73696465223A225374616E64617264222C22466F726D20526567696F6E223A225374616E64617264222C22526567696F6E20776974686F7574205469746C65223A225374616E';
wwv_flow_api.g_varchar2_table(177) := '64617264222C22526567696F6E20776974686F757420427574746F6E7320616E64205469746C6573223A225374616E64617264222C2257697A61726420526567696F6E20776974682049636F6E223A225374616E64617264222C22536964656261722052';
wwv_flow_api.g_varchar2_table(178) := '6567696F6E202D2048656164696E6720496E73696465223A225374616E64617264222C225265706F72747320526567696F6E223A225374616E64617264222C224869646520616E642053686F7720526567696F6E202848696464656E2046697273742922';
wwv_flow_api.g_varchar2_table(179) := '3A22436F6C6C61707369626C65222C22426F726465726C65737320526567696F6E223A225374616E64617264222C224368617274204C697374223A225374616E64617264222C224869646520616E642053686F7720526567696F6E202D20426F72646572';
wwv_flow_api.g_varchar2_table(180) := '6C657373223A22436F6C6C61707369626C65222C2242726561646372756D6220526567696F6E223A225469746C6520426172222C2257697A61726420526567696F6E223A2257697A61726420436F6E7461696E6572222C22536964656261722052656769';
wwv_flow_api.g_varchar2_table(181) := '6F6E223A225374616E64617264222C224869646520616E642053686F7720526567696F6E223A22436F6C6C61707369626C65222C22427574746F6E20526567696F6E20776974686F7574205469746C65223A22427574746F6E7320436F6E7461696E6572';
wwv_flow_api.g_varchar2_table(182) := '222C225265706F72747320526567696F6E202D2031303025205769647468223A225374616E64617264227D2C5265706F72743A7B2254776F20436F6C756D6E20506F72746C6574223A2256616C756520417474726962757465205061697273202D20526F';
wwv_flow_api.g_varchar2_table(183) := '77222C2246697865642048656164657273223A225374616E64617264222C22486F72697A6F6E74616C20426F72646572223A225374616E64617264222C2253656172636820526573756C7473205265706F7274202853454C454354206C696E6B5F746578';
wwv_flow_api.g_varchar2_table(184) := '742C206C696E6B5F7461726765742C2064657461696C312C2064657461696C322C206C6173745F6D6F64696669656429223A2253656172636820526573756C7473222C2256616C756520417474726962757465205061697273223A2256616C7565204174';
wwv_flow_api.g_varchar2_table(185) := '74726962757465205061697273202D20436F6C756D6E222C5374616E646172643A225374616E64617264222C225374616E64617264202D20416C7465726E6174697665223A225374616E64617264222C22426F726465726C657373205265706F7274223A';
wwv_flow_api.g_varchar2_table(186) := '225374616E64617264227D7D7D2C32323A7B696D6167653A2268747470733A2F2F617065782E6F7261636C652E636F6D2F706C732F617065782F617065785F706D2F722F34322F66696C65732F7374617469632F7638342F2F692F7468656D6532322E70';
wwv_flow_api.g_varchar2_table(187) := '6E67222C746578743A225468656D652032322D20426C7565204A6179222C6D617070696E67733A747D2C32313A7B746578743A225468656D65203231202D20536361726C6574222C696D6167653A2268747470733A2F2F617065782E6F7261636C652E63';
wwv_flow_api.g_varchar2_table(188) := '6F6D2F706C732F617065782F617065785F706D2F722F34322F66696C65732F7374617469632F7638342F2F692F7468656D6532312E706E67222C6D617070696E67733A747D7D2C613D66756E6374696F6E28742C692C612C6E297B6E7C7C286E3D7B4361';
wwv_flow_api.g_varchar2_table(189) := '6E63656C3A66756E6374696F6E28297B242874686973292E6469616C6F672822636C6F736522297D7D293B2428273C627574746F6E20636C6173733D22612D427574746F6E20612D427574746F6E20612D427574746F6E2D2D7061644C656674223E4F6B';
wwv_flow_api.g_varchar2_table(190) := '61793C2F627574746F6E3E27293B652E6469616C6F6728226F7074696F6E222C227469746C65222C74292E6469616C6F6728226F7074696F6E222C22627574746F6E73222C6E292C652E68746D6C28223C646976207374796C653D2770616464696E673A';
wwv_flow_api.g_varchar2_table(191) := '323070783B273E222B692B223C2F6469763E22292C652E6368696C6472656E28292E666972737428292E617070656E642861292C652E6469616C6F6728226F70656E22297D2C6E3D66756E6374696F6E2874297B766172206E3D2428273C756C20636C61';
wwv_flow_api.g_varchar2_table(192) := '73733D22612D49636F6E4C6973742D2D77697A61726420612D49636F6E4C6973742220726F6C653D226C697374626F78223E3C2F756C3E27293B666F7228766172207220696E2069292166756E6374696F6E28297B76617220743D722C693D2428273C6C';
wwv_flow_api.g_varchar2_table(193) := '6920636C6173733D2277697A6172642D73656C656374696F6E20612D49636F6E4C6973742D6974656D2075742D6D6967726174696F6E2D68656C7065722220726F6C653D226F7074696F6E2220746162696E6465783D2230223E3C2F6C693E27292C613D';
wwv_flow_api.g_varchar2_table(194) := '732874293B692E617070656E6428273C6469763E3C696D67207372633D22272B612E696D6167652B2722202F3E3C2F6469763E27292C692E617070656E6428273C7370616E20636C6173733D22612D49636F6E4C6973742D69636F6E4E616D65223E272B';
wwv_flow_api.g_varchar2_table(195) := '612E746578742B223C2F7370616E3E22292C692E636C69636B282866756E6374696F6E28297B652E6469616C6F672822636C6F736522292C6C2E77726974652861297D29292C6E2E617070656E642869297D28293B61282253656C656374207468652062';
wwv_flow_api.g_varchar2_table(196) := '617365207468656D65206E756D626572222C2254686520626F6F6B6D61726B6C657420697320636F6D70617469626C65207769746820612066657720276261736527207468656D65732E2053656C65637420746865206F6E652074686174206265737420';
wwv_flow_api.g_varchar2_table(197) := '6D61746368657320796F7572732062656C6F7720746F206170706C792074686520636F7272656374207468656D65206D617070696E6720222C6E2C7B7D297D3B77696E646F772E75744D6967726174696F6E5363726970744163746976653F653D77696E';
wwv_flow_api.g_varchar2_table(198) := '646F772E75744D6967726174696F6E446976243A282428226865616422292E617070656E6428223C7374796C653E2E7468656D652D6D6967726174696F6E2D2D69732D75706461746564207B206261636B67726F756E642D636F6C6F723A202343414637';
wwv_flow_api.g_varchar2_table(199) := '43373B207D202E7468656D652D6D6967726174696F6E2D2D69732D6572726F72207B206261636B67726F756E642D636F6C6F723A20234644453541343B207D2E75742D6D6967726174696F6E2D68656C70657220646976207B2077696474683A20393070';
wwv_flow_api.g_varchar2_table(200) := '783B206865696768743A20363070783B206F766572666C6F773A68696464656E3B206D617267696E3A206175746F3B207D2E75742D6D6967726174696F6E2D68656C70657220696D67207B2077696474683A2032383070783B206865696768743A203132';
wwv_flow_api.g_varchar2_table(201) := '3070783B206D617267696E2D746F703A202D313070783B207D2E75742D6D6967726174696F6E2D68656C706572207B20746578742D616C69676E3A63656E7465723B20626F726465723A20317078207768697465736D6F6B6520736F6C69643B20626F72';
wwv_flow_api.g_varchar2_table(202) := '6465722D7261646975733A203270783B207D202E75742D6D6967726174696F6E2D68656C706572202E612D49636F6E4C6973742D69636F6E4E616D65207B206865696768743A20353070783B20646973706C61793A696E6C696E652D626C6F636B3B206D';
wwv_flow_api.g_varchar2_table(203) := '617267696E2D746F703A3570783B207D3C2F7374796C653E22292C77696E646F772E75744D6967726174696F6E446976243D653D2428223C6469763E22292C242822626F647922292E617070656E642865292C617065782E7468656D652E696E69745265';
wwv_flow_api.g_varchar2_table(204) := '73706F6E736976654469616C6F677328292C652E6469616C6F67287B6175746F4F70656E3A21312C6D696E57696474683A3530302C636C6F7365546578743A224F6B227D29292C77696E646F772E75744D6967726174696F6E5363726970744163746976';
wwv_flow_api.g_varchar2_table(205) := '653D21303B76617220722C6F2C642C6C3D28723D66756E6374696F6E28297B76617220652C743D7B7D3B72657475726E202428222E612D5265706F72742D7265706F727422292E66696E64282274626F647922292E66696E642822747222292E65616368';
wwv_flow_api.g_varchar2_table(206) := '282866756E6374696F6E28297B76617220693D242874686973292C613D692E66696E64282274645B686561646572733D2754454D505F54595045275D22292C6E3D692E66696E64282274645B686561646572733D2746524F4D5F54454D504C415445275D';
wwv_flow_api.g_varchar2_table(207) := '22292C723D692E66696E64282274645B686561646572733D274C4F56275D22292E66696E64282273656C65637422292C6F3D612E7465787428292E7472696D28292C643D6E2E7465787428292E7472696D28293B6F26262222213D3D6F2E7472696D2829';
wwv_flow_api.g_varchar2_table(208) := '262628653D6F292C745B655D7C7C28745B655D3D7B7D292C745B655D5B645D3D7B73656C656374243A722C726F77243A692C73656C65637465643A722E66696E6428223A73656C656374656422292E7465787428297D7D29292C747D2C6F3D66756E6374';
wwv_flow_api.g_varchar2_table(209) := '696F6E28652C74297B666F7228766172206920696E2065297B76617220613D655B695D3B666F7228766172206E20696E2061297428615B6E5D2C692C6E297D7D2C643D66756E6374696F6E28297B242874686973292E72656D6F7665436C617373282274';
wwv_flow_api.g_varchar2_table(210) := '68656D652D6D6967726174696F6E2D2D69732D6572726F7222292E72656D6F7665436C61737328227468656D652D6D6967726174696F6E2D2D69732D7570646174656422297D2C7B746F4A534F4E3A66756E6374696F6E28297B76617220653D7228293B';
wwv_flow_api.g_varchar2_table(211) := '72657475726E206F28652C2866756E6374696F6E28742C692C61297B655B695D5B615D3D742E73656C65637465647D29292C4A534F4E2E737472696E676966792865297D2C77726974653A66756E6374696F6E2865297B76617220743D652E6D61707069';
wwv_flow_api.g_varchar2_table(212) := '6E67733B22737472696E67223D3D747970656F662074262628743D4A534F4E2E7061727365287429293B76617220693D7228292C6C3D302C733D302C673D302C753D7B7D3B6F28692C2866756E6374696F6E28652C692C61297B696628745B695D296966';
wwv_flow_api.g_varchar2_table(213) := '28745B695D5B615D297B766172206E3D66756E6374696F6E28652C742C69297B652E6F666628226368616E6765222C64293B76617220613D652E66696E6428226F7074696F6E3A636F6E7461696E732827222B692B22272922292E66696C746572282866';
wwv_flow_api.g_varchar2_table(214) := '756E6374696F6E2865297B72657475726E20242874686973292E7465787428293D3D3D697D29293B72657475726E20652E6F6E28226368616E6765222C64292C652E72656D6F7665436C61737328227468656D652D6D6967726174696F6E2D2D69732D65';
wwv_flow_api.g_varchar2_table(215) := '72726F7222292E72656D6F7665436C61737328227468656D652D6D6967726174696F6E2D2D69732D7570646174656422292C612E6C656E6774683C3D303F28652E616464436C61737328227468656D652D6D6967726174696F6E2D2D69732D6572726F72';
wwv_flow_api.g_varchar2_table(216) := '22292C2D31293A652E76616C28293D3D3D612E76616C28293F303A28652E76616C28612E76616C2829292C652E616464436C61737328227468656D652D6D6967726174696F6E2D2D69732D7570646174656422292C31297D28652E73656C656374242C65';
wwv_flow_api.g_varchar2_table(217) := '2E726F77242C745B695D5B615D293B313D3D3D6E3F672B2B3A2D313D3D3D6E262628755B695D7C7C28755B695D3D7B7D292C755B695D5B615D3D31292C6C2B2B7D656C736520755B695D7C7C28755B695D3D7B7D292C755B695D5B615D3D303B656C7365';
wwv_flow_api.g_varchar2_table(218) := '20755B695D7C7C28755B695D3D2130293B732B2B7D29293B766172204C3D223C756C3E222C623D5B5D2C533D303B666F7228766172206820696E207529696628755B685D296966282130213D3D755B685D29666F7228766172205220696E20755B685D29';
wwv_flow_api.g_varchar2_table(219) := '303D3D3D755B685D5B525D26262249525220526567696F6E2054656D706C61746522213D3D523F622E707573682852293A532B2B3B656C7365204C2B3D223C6C693E3C623E222B682B223C2F623E2074656D706C6174652074797065206973206E6F7420';
wwv_flow_api.g_varchar2_table(220) := '696E20746865206D617070696E673C2F6C693E223B4C2B3D223C2F756C3E223B76617220703D622E6C656E6774683E303F223C623E222B622E6C656E6774682B273C2F623E202266726F6D2074656D706C617465732220636F756C64206E6F7420626520';
wwv_flow_api.g_varchar2_table(221) := '666F756E6420696E20746865206D617070696E672E203C62722F3E28272B622E6A6F696E28222C2022292B2229223A22222C633D223C623E222B6C2B223C2F623E206F7574206F66203C623E222B732B223C2F623E2074656D706C617465206D61707069';
wwv_flow_api.g_varchar2_table(222) := '6E672873292077657265207265636F676E697A6564206279207468697320626F6F6B6D61726B6C65742E3C62722F3E204F662074686573652C203C623E222B672B223C2F623E2074656D706C617465206D617070696E67287329207765726520616C7465';
wwv_flow_api.g_varchar2_table(223) := '7265642E3C62722F3E222C6D3D2253756363657373222C543D22222C763D5B7B746578743A22436C6F7365222C636C69636B3A66756E6374696F6E28297B242874686973292E6469616C6F672822636C6F736522297D2C636C6173733A22612D42757474';
wwv_flow_api.g_varchar2_table(224) := '6F6E2D2D686F74227D5D3B223C756C3E3C2F756C3E22213D284C3D702B28533E303F223C623E222B532B273C2F623E2074656D706C617465206D617070696E677320636F756C64206E6F74206265207365742062656361757365207468652073656C6563';
wwv_flow_api.g_varchar2_table(225) := '74206C69737420646964206E6F74206861766520746865207370656369666965642076616C7565732E3C7374726F6E673E44696420796F752073657420224D617463682054656D706C61746520436C61737365732220746F20224E6F2220696E20746865';
wwv_flow_api.g_varchar2_table(226) := '2070726576696F757320737465703F3C2F7374726F6E673E273A2222292B4C292626286D3D225761726E696E67222C543D4C2C763D5B7B746578743A224D617020746F206120446966666572656E74205468656D65222C636C69636B3A66756E6374696F';
wwv_flow_api.g_varchar2_table(227) := '6E28297B242874686973292E6469616C6F672822636C6F736522292C6E28297D2C636C6173733A22227D2C7B746578743A22436C6F7365222C636C69636B3A66756E6374696F6E28297B242874686973292E6469616C6F672822636C6F736522297D2C63';
wwv_flow_api.g_varchar2_table(228) := '6C6173733A22612D427574746F6E2D2D686F74227D5D292C633D273C64697620636C6173733D22612D416C65727420612D416C6572742D2D64656661756C7449636F6E7320612D416C6572742D2D636F6C6F72424720612D416C6572742D2D272B6D2E74';
wwv_flow_api.g_varchar2_table(229) := '6F4C6F7765724361736528292B2720612D416C6572742D2D686F72697A6F6E74616C223E3C64697620636C6173733D22612D416C6572742D77726170223E3C64697620636C6173733D22612D416C6572742D69636F6E223E3C7370616E20636C6173733D';
wwv_flow_api.g_varchar2_table(230) := '22612D49636F6E20223E3C2F7370616E3E3C2F6469763E3C64697620636C6173733D22612D416C6572742D636F6E74656E74223E3C64697620636C6173733D22612D416C6572742D686561646572223E3C683220636C6173733D22612D416C6572742D74';
wwv_flow_api.g_varchar2_table(231) := '69746C65223E272B6D2B273C2F68323E3C2F6469763E3C64697620636C6173733D22612D416C6572742D626F6479223E272B542B223C2F6469763E3C2F6469763E3C2F6469763E3C2F6469763E222B632C6128274170706C6965642022272B652E746578';
wwv_flow_api.g_varchar2_table(232) := '742B2722206D617070696E6773272C632C22222C76297D2C746F5461626C653A66756E6374696F6E28297B76617220653D223C7461626C653E3C74723E3C74683E5468656D653C2F747274683E3C74683E54656D706C61746520547970653C2F74683E3C';
wwv_flow_api.g_varchar2_table(233) := '74683E46726F6D2054656D706C6174653C2F74683E3C74683E56616C75653C2F74683E3C2F74723E223B666F7228766172207420696E2069297B76617220613D6E756C6C3B6F28695B745D2E6D617070696E67732C2866756E6374696F6E286E2C722C6F';
wwv_flow_api.g_varchar2_table(234) := '297B76617220643D21313B72213D3D61262628643D2130292C613D723B766172206C3D223C74723E3C74643E222B742B223C2F74643E3C74643E222B28643F723A2222292B223C2F74643E3C74643E222B6F2B223C2F74643E3C74643E222B695B745D2E';
wwv_flow_api.g_varchar2_table(235) := '6D617070696E67735B725D5B6F5D2B223C2F74643E3C2F74723E223B652B3D6C7D29297D652B3D223C2F7461626C653E222C242822626F647922292E68746D6C2865297D7D292C733D66756E6374696F6E2865297B696628652972657475726E20695B65';
wwv_flow_api.g_varchar2_table(236) := '5D7D3B2866756E6374696F6E28297B76617220652C743D24282223503338365F4143544956455F5448454D4522292E7465787428292C693D2F285C642B295C2E2F2E657865632874293B69662821697C7C692E6C656E6774683C3D317C7C21695B315D29';
wwv_flow_api.g_varchar2_table(237) := '6128224572726F72222C2254686973206973206E6F7420746865205468656D652053776974636820506167652028333836292E20506C6561736520747279207573696E6720746865206D617070696E6720626F6F6B6D61726B6C6574206F6E2074686520';
wwv_flow_api.g_varchar2_table(238) := '636F727265637420706167652E22293B656C73657B7472797B76617220723D7061727365496E7428695B315D293B6966282128653D73287229292972657475726E20766F6964206E28297D63617463682865297B72657475726E20766F69642061282245';
wwv_flow_api.g_varchar2_table(239) := '72726F722070617273696E67207468656D65206E756D626572222C652B222E20506C6561736520676F20746F20687474703A2F2F617065782E6F7261636C652E636F6D20666F72206D6F726520696E666F726D6174696F6E2E22297D6C2E777269746528';
wwv_flow_api.g_varchar2_table(240) := '65297D7D2928297D656C736520616C6572742822546F20757365207468697320626F6F6B6D61726B6C65742C20796F75206E65656420746F2C2066697273742C206472616720697420696E746F20796F757220626F6F6B6D61726B206261727320616E64';
wwv_flow_api.g_varchar2_table(241) := '207468656E20636C69636B206F6E206974206F6E207061676520333836206F6620746865207468656D65207377697463682077697A6172642122297D28293B0A2F2F2320736F757263654D617070696E6755524C3D626F6F6B6D61726B6C65742E6A732E';
wwv_flow_api.g_varchar2_table(242) := '6D6170';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(786795983309707117)
,p_file_name=>'bookmarklet.min.js'
,p_mime_type=>'application/javascript'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/bookmarklet_js_map
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '7B2276657273696F6E223A332C22736F7572636573223A5B22626F6F6B6D61726B6C65742E6A73225D2C226E616D6573223A5B22756E646566696E6564222C2277696E646F77222C2224222C226469616C6F6744697624222C227468656D653231416E64';
wwv_flow_api.g_varchar2_table(2) := '5468656D6532324D617070696E67222C2242726561646372756D62222C2242726561646372756D62204D656E75222C22427574746F6E222C22486F7420427574746F6E202852656429222C22486F7420427574746F6E2028426C61636B29222C22486F74';
wwv_flow_api.g_varchar2_table(3) := '20427574746F6E2028526564204F75746C696E6529222C22536D616C6C20427574746F6E222C2248544D4C20627574746F6E20286C6567616379202D20415045582035206D6967726174696F6E29222C2248544D4C20696D61676520286C656761637920';
wwv_flow_api.g_varchar2_table(4) := '2D20415045582035206D6967726174696F6E29222C22536D616C6C20486F7420427574746F6E202852656429222C224C6162656C222C225265717569726564222C22526571756972656420776974682068656C70222C224F7074696F6E616C222C224E6F';
wwv_flow_api.g_varchar2_table(5) := '204C6162656C222C224F7074696F6E616C20776974682068656C70222C224C65676163792043616C656E646172222C2243616C656E646172222C2243616C656E6461722C20416C7465726E61746976652031222C22536D616C6C2043616C656E64617222';
wwv_flow_api.g_varchar2_table(6) := '2C224C697374222C22486F72697A6F6E74616C205461627320526F756E646564204C697374202846756C6C20576964746829222C2248696572617263686963616C20457870616E64696E67222C22486F72697A6F6E74616C20496D616765732077697468';
wwv_flow_api.g_varchar2_table(7) := '204C6162656C204C697374222C22566572746963616C20496D61676573204C697374222C22546162626564204E617669676174696F6E204C697374222C224448544D4C2054726565222C2257697A6172642050726F6772657373204C6973742C20486F72';
wwv_flow_api.g_varchar2_table(8) := '697A6F6E74616C20547261696E222C2257697A6172642050726F6772657373204C697374222C22566572746963616C20556E6F726465726564204C69737420776974682042756C6C6574732C20416C7465726E6174697665222C2250756C6C20446F776E';
wwv_flow_api.g_varchar2_table(9) := '204D656E75207769746820496D616765222C22427574746F6E204C697374222C22486F72697A6F6E74616C205461627320526F756E646564204C697374222C22566572746963616C204F726465726564204C697374222C22566572746963616C20556E6F';
wwv_flow_api.g_varchar2_table(10) := '726465726564204C69737420776974686F75742042756C6C657473222C22566572746963616C20556E6F726465726564204C69737420776974682042756C6C657473222C2250756C6C20446F776E204D656E75222C22486F72697A6F6E74616C204C696E';
wwv_flow_api.g_varchar2_table(11) := '6B73204C697374222C2250616765204C6576656C2054616273204C697374222C22566572746963616C2053696465626172204C697374222C2243656E74657265642054616220536574222C2250616765222C224F6E65204C6576656C2054616273202D20';
wwv_flow_api.g_varchar2_table(12) := '4C65667420616E642052696768742053696465626172202866697865642D7769647468202F20444956206C65667420616E64206F7074696F6E616C207461626C652D626173656420726967687429222C224E6F2054616273202D20526967687420536964';
wwv_flow_api.g_varchar2_table(13) := '6562617220286F7074696F6E616C202F207461626C652D626173656429222C225072696E74657220467269656E646C79222C224C6F67696E222C2254776F204C6576656C2054616273202D204C6566742053696465626172202866697865642D77696474';
wwv_flow_api.g_varchar2_table(14) := '68202F2044495620626173656429222C224E6F2054616273202D2052696768742053696465626172202866697865642D7769647468202F2044495620626173656429222C2254776F204C6576656C2054616273202D205269676874205369646562617220';
wwv_flow_api.g_varchar2_table(15) := '2866697865642D7769647468202F2044495620626173656429222C224E6F2054616273202D204C6566742053696465626172202866697865642D7769647468202F2044495620626173656429222C224F6E65204C6576656C2054616273202D204C656674';
wwv_flow_api.g_varchar2_table(16) := '2053696465626172202866697865642D7769647468202F2044495620626173656429222C22506F707570222C22526567696F6E222C2249525220526567696F6E2054656D706C617465222C2242726561646372756D6220526567696F6E222C225265706F';
wwv_flow_api.g_varchar2_table(17) := '72747320526567696F6E222C2257697A61726420526567696F6E222C225369646562617220526567696F6E2C20426F726465726564222C22427261636B6574656420526567696F6E222C2243656E7465726564205461622053657420526567696F6E222C';
wwv_flow_api.g_varchar2_table(18) := '225369646562617220526567696F6E222C225265706F72747320526567696F6E204E6F205469746C652C20416C7465726E61746976652031222C224E617669676174696F6E20526567696F6E222C22466F726D20526567696F6E222C2253696465626172';
wwv_flow_api.g_varchar2_table(19) := '20526567696F6E2C20426F72646572656420416C7465726E6174697665222C22427574746F6E20526567696F6E2077697468205469746C65222C225369646562617220526567696F6E2C20416C7465726E61746976652031222C224E6573746564205265';
wwv_flow_api.g_varchar2_table(20) := '67696F6E222C225265706F72747320526567696F6E204E6F205469746C65222C22427574746F6E20526567696F6E20776974686F7574205469746C65222C225265706F72747320526567696F6E2C20416C7465726E61746976652031222C224869646520';
wwv_flow_api.g_varchar2_table(21) := '616E642053686F7720526567696F6E222C224368617274204C697374222C22526567696F6E20776974686F7574205469746C65222C22526567696F6E20776974686F757420427574746F6E7320616E64205469746C6573222C22426F726465726C657373';
wwv_flow_api.g_varchar2_table(22) := '20526567696F6E202D204E6F205469746C65222C225265706F72747320526567696F6E2031303025205769647468222C22436861727420526567696F6E222C22426F726465726C65737320526567696F6E222C224E617669676174696F6E20526567696F';
wwv_flow_api.g_varchar2_table(23) := '6E2C20416C7465726E61746976652031222C2257697A61726420526567696F6E20776974682049636F6E222C225265706F7274222C225374616E64617264222C2256616C756520417474726962757465205061697273202D20446976222C225374616E64';
wwv_flow_api.g_varchar2_table(24) := '6172642C20416C7465726E6174696E6720526F7720436F6C6F7273222C2246697865642048656164657273222C22426F726465726C657373205265706F7274222C2254776F20436F6C756D6E20506F72746C6574222C22486F72697A6F6E74616C20426F';
wwv_flow_api.g_varchar2_table(25) := '72646572222C2253656172636820526573756C7473205265706F7274202853454C454354206C696E6B5F746578742C206C696E6B5F7461726765742C2064657461696C312C2064657461696C322C206C6173745F6D6F64696669656429222C2273757070';
wwv_flow_api.g_varchar2_table(26) := '6F727465645468656D6573222C223236222C22696D616765222C2274657874222C226D617070696E6773222C2248696572617263686963616C204D656E75222C225B202B205D2041646420427574746F6E222C225B203E205D20476F20546F2042757474';
wwv_flow_api.g_varchar2_table(27) := '6F6E222C225B2054657874205D20427574746F6E222C22496E746572616374697665205265706F727420427574746F6E20284E65787429222C22496E746572616374697665205265706F727420427574746F6E222C224C6172676520427574746F6E2028';
wwv_flow_api.g_varchar2_table(28) := '4E65787429222C224C6172676520427574746F6E202850726576696F757329222C224C6172676520427574746F6E222C2248696464656E206C6162656C2C20726561642062792073637265656E20726561646572222C2243616C656E646172202D20416C';
wwv_flow_api.g_varchar2_table(29) := '7465726E6174697665222C224665617475726564204C69737420776974682053756274657874222C22486F72697A6F6E74616C2057697A6172642050726F6772657373204C697374222C225365617263682046696C7465722054616273222C2256657274';
wwv_flow_api.g_varchar2_table(30) := '6963616C204C6973742077697468205375627465787420616E642049636F6E222C2257697A6172642050726F6772657373204C697374202D20566572746963616C222C224469616C6F67222C224D696E696D616C2050616765222C224E6F205461627320';
wwv_flow_api.g_varchar2_table(31) := '2D204C65667420616E642052696768742053696465626172222C224E6F2054616273202D204C6566742053696465626172222C224E6F2054616273202D204E6F2053696465626172222C224E6F2054616273202D2052696768742053696465626172222C';
wwv_flow_api.g_varchar2_table(32) := '224F6E65204C6576656C2054616273202D20436F6E74656E74204672616D65222C224F6E65204C6576656C2054616273202D204C65667420616E642052696768742053696465626172222C224F6E65204C6576656C2054616273202D204C656674205369';
wwv_flow_api.g_varchar2_table(33) := '6465626172222C224F6E65204C6576656C2054616273202D204E6F2053696465626172222C224F6E65204C6576656C2054616273202D2052696768742053696465626172222C224F6E65204C6576656C2054616273202D205365617263682046696C7465';
wwv_flow_api.g_varchar2_table(34) := '7220426172222C224F6E65204C6576656C2054616273202D2057697A6172642050616765222C2254776F204C6576656C2054616273202D204C65667420616E642052696768742053696465626172222C2254776F204C6576656C2054616273202D204C65';
wwv_flow_api.g_varchar2_table(35) := '66742053696465626172222C2254776F204C6576656C2054616273202D204E6F2053696465626172222C2254776F204C6576656C2054616273202D2052696768742053696465626172222C2241636365737369626C6520526567696F6E20776974682048';
wwv_flow_api.g_varchar2_table(36) := '656164696E67222C22416C65727420526567696F6E222C22426F726465726C65737320526567696F6E20286E6F2068656164696E6729222C22436F6E74656E74204672616D6520426F647920436F6E7461696E6572222C2244495620526567696F6E2077';
wwv_flow_api.g_varchar2_table(37) := '697468204944222C224869646520616E642053686F7720526567696F6E202848696464656E20466972737429202D20426F726465726C657373222C224869646520616E642053686F7720526567696F6E202D20426F726465726C657373222C22496E7465';
wwv_flow_api.g_varchar2_table(38) := '72616374697665205265706F727420526567696F6E222C226A5175657279204D6F64616C20526567696F6E2054656D706C617465222C224C6F67696E20526567696F6E222C224D6F64616C20526567696F6E222C224E617669676174696F6E2052656769';
wwv_flow_api.g_varchar2_table(39) := '6F6E202D2048656164696E6720496E73696465222C225265706F72742046696C746572202D2053696E676C6520526F77222C225265706F7274204C697374222C225265706F72747320526567696F6E202D2031303025205769647468222C225265706F72';
wwv_flow_api.g_varchar2_table(40) := '747320526567696F6E202D2048656164696E6720496E73696465222C225363726F6C6C61626C6520436F6E74656E7420526567696F6E222C225365617263682046696C74657220526567696F6E222C225369646562617220526567696F6E202D20486561';
wwv_flow_api.g_varchar2_table(41) := '64696E6720496E73696465222C2257697A61726420427574746F6E73222C22436F6D6D656E7420427562626C6573222C224F6E6520436F6C756D6E20556E6F726465726564204C697374222C225374616E64617264202D20416C7465726E617469766522';
wwv_flow_api.g_varchar2_table(42) := '2C2256616C756520417474726962757465205061697273202D204C65667420416C69676E6564222C2256616C756520417474726962757465205061697273222C223235222C22427574746F6E202D2049636F6E204F6E6C79222C22427574746F6E202D20';
wwv_flow_api.g_varchar2_table(43) := '49636F6E222C224C6172676520427574746F6E202D2049636F6E204F6E6C79222C224C6172676520427574746F6E202D2049636F6E222C2248696464656E204C6162656C2028526561642062792053637265656E205265616465727329222C224F707469';
wwv_flow_api.g_varchar2_table(44) := '6F6E616C2028486F72697A6F6E74616C202D204C65667420416C69676E656429222C224F7074696F6E616C2028486F72697A6F6E74616C202D20526967687420416C69676E656429222C224F7074696F6E616C20284C6162656C2041626F766529222C22';
wwv_flow_api.g_varchar2_table(45) := '52657175697265642028486F72697A6F6E74616C202D204C65667420416C69676E656429222C2252657175697265642028486F72697A6F6E74616C202D20526967687420416C69676E656429222C22526571756972656420284C6162656C2041626F7665';
wwv_flow_api.g_varchar2_table(46) := '29222C224869646520616E642053686F7720526567696F6E2028457870616E64656429222C224869646520616E642053686F7720526567696F6E202848696464656E29222C225374616E6461726420526567696F6E202D204E6F2050616464696E67222C';
wwv_flow_api.g_varchar2_table(47) := '225374616E6461726420526567696F6E222C223234222C224C6162656C2048696464656E206C6162656C2C20726561642062792073637265656E20726561646572222C223233222C224869646520616E642053686F7720526567696F6E20284869646465';
wwv_flow_api.g_varchar2_table(48) := '6E20466972737429222C223232222C223231222C226469616C6F67222C227469746C65222C226D657373616765222C226578747261436F6E74656E7424222C22627574746F6E73222C2243616E63656C222C2274686973222C2268746D6C222C22636869';
wwv_flow_api.g_varchar2_table(49) := '6C6472656E222C226669727374222C22617070656E64222C2263686F6F73655468656D65546F5772697465222C227468656D654E756D626572222C226C69737424222C226B6579222C227468656D65546F57726974654B6579222C226974656D24222C22';
wwv_flow_api.g_varchar2_table(50) := '7468656D65546F5772697465222C226765745468656D65546F5772697465222C22636C69636B222C226170657854656D706C61746548656C706572222C227772697465222C2275744D6967726174696F6E536372697074416374697665222C2275744D69';
wwv_flow_api.g_varchar2_table(51) := '67726174696F6E44697624222C2261706578222C227468656D65222C22696E6974526573706F6E736976654469616C6F6773222C226175746F4F70656E222C226D696E5769647468222C22636C6F736554657874222C226275696C645061676552657072';
wwv_flow_api.g_varchar2_table(52) := '6573656E746174696F6E222C22697465726174655468726F756768526570726573656E746174696F6E222C2273656C6563745265736574436F6C6F72222C2263757272656E7454656D706C61746554797065222C2270616765526570726573656E746174';
wwv_flow_api.g_varchar2_table(53) := '696F6E222C2266696E64222C2265616368222C227461626C65526F7724222C2274656D706C6174655479706524222C2266726F6D54656D706C61746524222C2273656C6563744D617070696E6724222C2274656D706C61746554797065222C227472696D';
wwv_flow_api.g_varchar2_table(54) := '222C2266726F6D54656D706C617465222C2273656C65637424222C22726F7724222C2273656C6563746564222C2263616C6C6261636B222C2274656D706C6174655479706573222C2272656D6F7665436C617373222C22746F4A534F4E222C226F707469';
wwv_flow_api.g_varchar2_table(55) := '6F6E222C224A534F4E222C22737472696E67696679222C226E657750616765526570726573656E746174696F6E222C227061727365222C22746F7563686564222C22706172736564222C226368616E676564222C226572726F7273222C226F7074696F6E';
wwv_flow_api.g_varchar2_table(56) := '4368616E676564222C226F6666222C226F7074696F6E24222C2266696C746572222C2269222C226F6E222C226C656E677468222C22616464436C617373222C2276616C222C2273656C6563744F7074696F6E427954657874222C226572726F724D657373';
wwv_flow_api.g_varchar2_table(57) := '616765222C2266726F6D54656D706C6174654E6F74496E4D617070696E67222C2266726F6D54656D706C617465496E4D617070696E674275744E6F74496E53656C6563744C697374222C2270757368222C2266726F6D54656D706C6174654572726F7222';
wwv_flow_api.g_varchar2_table(58) := '2C226A6F696E222C2273756D6D6172794D657373616765222C22686561646572222C226469616C6F674D657373616765222C22636C617373222C22746F4C6F77657243617365222C22746F5461626C65222C227461626C65222C2270726576696F757354';
wwv_flow_api.g_varchar2_table(59) := '656D706C61746554797065222C227072696E7454656D706C61746554797065222C227472222C227468656D654E756D626572537472696E67222C227468656D654E756D6265724172726179222C2265786563222C227061727365496E74222C2265222C22';
wwv_flow_api.g_varchar2_table(60) := '616C657274225D2C226D617070696E6773223A223B3B3B434149432C574143472C5141416942412C49414162432C4F41414F432C454141582C43414F412C4941796A4249432C4541746A4241432C45414132422C4341433342432C574141632C43414356';
wwv_flow_api.g_varchar2_table(61) := '432C6B4241416D422C6341457642432C4F4141552C4341434E432C6D4241416F422C4F41437042432C7142414173422C4F41437442432C3242414134422C4F41433542432C65414167422C4F414368424A2C4F4141552C4F4143564B2C3043414132432C';
wwv_flow_api.g_varchar2_table(62) := '4F41433343432C7943414130432C4F41433143432C7942414130422C5141453942432C4D4141532C4341434C432C534141592C5741435A432C7142414173422C5741437442432C534141592C5741435A432C574141592C5341435A432C7142414173422C';
wwv_flow_api.g_varchar2_table(63) := '5941453142432C6B4241416D422C43414366432C534141592C5741435A432C3042414132422C5741433342432C694241416B422C5941457442432C4B4141512C4341434A432C3443414136432C4F41433743432C7942414130422C6141433142432C6F43';
wwv_flow_api.g_varchar2_table(64) := '414171432C6141437243432C7542414177422C6141437842432C7942414130422C4F41433142432C614141632C61414364432C7943414130432C6B4241433143432C7542414177422C6B4241437842432C6F44414171442C6141437244432C3442414136';
wwv_flow_api.g_varchar2_table(65) := '422C6141433742432C634141652C61414366432C2B42414167432C4F41436843432C7742414179422C6141437A42432C3043414132432C6141433343432C7543414177432C6141437843432C694241416B422C6141436C42432C7742414179422C614143';
wwv_flow_api.g_varchar2_table(66) := '7A42432C7542414177422C734241437842432C7742414179422C6141437A42432C6D4241416F422C5141457842432C4B4141512C4341434A432C6B4741416D472C384241436E47432C6D4441416F442C5741437044432C6D4241416F422C304241437042';
wwv_flow_api.g_varchar2_table(67) := '432C4D4141532C51414354432C3044414132442C6D4241433344432C6F44414171442C6F4241437244432C3244414134442C6F4241433544432C6D4441416F442C6D4241437044432C3044414132442C6D4241433344432C4D4141532C3242414562432C';
wwv_flow_api.g_varchar2_table(68) := '4F4141552C4341434E432C7342414175422C714241437642432C6F42414171422C5941437242432C694241416B422C5741436C42432C6742414169422C5741436A42432C3242414134422C5741433542432C6D4241416F422C5741437042432C30424141';
wwv_flow_api.g_varchar2_table(69) := '32422C5741433342432C694241416B422C5741436C42432C7943414130432C5741433143432C6F42414171422C5741437242432C634141652C57414366432C7543414177432C5741437843432C3242414134422C6F4241433542432C6743414169432C57';
wwv_flow_api.g_varchar2_table(70) := '41436A43432C6742414169422C5741436A42432C3042414132422C5741433342432C384241412B422C6F4241432F42432C6743414169432C5741436A43432C7542414177422C6341437842432C614141632C57414364432C7542414177422C5741437842';
wwv_flow_api.g_varchar2_table(71) := '432C6F43414171432C5741437243432C2B42414167432C774241436843432C3442414136422C5741433742432C65414167422C5741436842432C6F42414171422C5741437242432C6D4341416F432C5741437043432C3042414132422C5941452F42432C';
wwv_flow_api.g_varchar2_table(72) := '4F4141552C4341434E432C534141592C5741435A432C384241412B422C694341432F42432C6D4341416F432C5741437043432C6742414169422C5741436A42432C6F42414171422C694241437242432C7142414173422C384241437442432C6F42414171';
wwv_flow_api.g_varchar2_table(73) := '422C5741437242432C7946414130462C6D42414F3946432C4541416B422C4341436C42432C474141492C43414341432C4D41414F2C6746414350432C4B41414D2C754341434E432C534141552C4341434E39462C574141632C43414356432C6B4241416D';
wwv_flow_api.g_varchar2_table(74) := '422C6141436E4238462C6F42414171422C6341457A4237462C4F4141552C4341434E38462C6D4241416F422C4F41437042432C7142414173422C4F41437442432C6B4241416D422C4F41436E4268472C4F4141552C4F4143564B2C3043414132432C4F41';
wwv_flow_api.g_varchar2_table(75) := '43334334462C6D4341416F432C694241437043432C3442414136422C4F41433742432C7342414175422C694241437642432C3042414132422C694241433342432C65414167422C4F414368426A472C65414167422C5141457042492C4D4141532C434143';
wwv_flow_api.g_varchar2_table(76) := '4C38462C7343414175432C534143764331462C574141592C5341435A432C7142414173422C5741437442462C534141592C5741435A442C7142414173422C5741437442442C534141592C59414568424B2C6B4241416D422C4341436679462C7942414130';
wwv_flow_api.g_varchar2_table(77) := '422C574143314278462C534141592C5741435A452C694241416B422C5941457442432C4B4141512C4341434A572C634141652C614143664C2C614141632C6141436467462C3642414138422C614143394270462C7942414130422C6141433142432C6F43';
wwv_flow_api.g_varchar2_table(78) := '414171432C6141437243632C7742414179422C6141437A4273452C6B4341416D432C6B4241436E4372452C7542414177422C734241437842522C3442414136422C61414337424D2C694241416B422C6141436C4277452C7142414173422C4F414374426E';
wwv_flow_api.g_varchar2_table(79) := '462C7942414130422C4F41433142442C7542414177422C614143784271462C7343414175432C614143764335452C7742414179422C6141437A424D2C7742414179422C6141437A424A2C7543414177432C6141437843442C3043414132432C6141433343';
wwv_flow_api.g_varchar2_table(80) := '34452C6B4341416D432C6D424145764372452C4B4141512C4341434A73452C4F4141552C654143566C452C4D4141532C514143546D452C65414167422C304241436842432C6D4341416F432C384241437043432C7942414130422C6D4241433142432C75';
wwv_flow_api.g_varchar2_table(81) := '42414177422C5741437842432C3042414132422C6F4241433342432C694341416B432C674241436C43432C3043414132432C364241433343432C6743414169432C6D4241436A43432C384241412B422C5741432F42432C694341416B432C6F4241436C43';
wwv_flow_api.g_varchar2_table(82) := '432C7143414173432C6D4241437443432C2B42414167432C574143684378452C4D4141532C3042414354502C6D4241416F422C30424143704267462C3043414132432C384241433343432C6743414169432C6D4241436A43432C384241412B422C574143';
wwv_flow_api.g_varchar2_table(83) := '2F42432C694341416B432C71424145744333452C4F4141552C4341434E432C7342414175422C71424143764232452C694341416B432C5741436C43432C65414167422C5141436842432C694341416B432C5741436C4370442C6F42414171422C57414372';
wwv_flow_api.g_varchar2_table(84) := '4270422C6D4241416F422C57414370424A2C6F42414171422C5941437242572C3242414134422C6F4241433542492C384241412B422C6F4241432F42472C614141632C574143644B2C65414167422C574143684273442C2B42414167432C774241436843';
wwv_flow_api.g_varchar2_table(85) := '432C7142414173422C77424143744272452C634141652C5741436673452C6D4441416F442C6341437044432C6F43414171432C63414372432F442C7542414177422C634143784267452C3442414136422C714241433742432C2B42414167432C67424143';
wwv_flow_api.g_varchar2_table(86) := '6843432C65414167422C5141436842432C65414167422C674241436842432C7143414173432C574143744337452C6F42414171422C5741437242592C6F43414171432C5741437243442C7542414177422C57414378426D452C3642414138422C57414339';
wwv_flow_api.g_varchar2_table(87) := '42432C634141652C57414366432C384241412B422C5741432F42432C6B4341416D432C5741436E4378462C694241416B422C5741436C4279462C3442414136422C5741433742432C7542414177422C5741437842432C6B4341416D432C5741436E437446';
wwv_flow_api.g_varchar2_table(88) := '2C694241416B422C5741436C4275462C694241416B422C6F4241436C426E452C3042414132422C574143334278422C6742414169422C594145724279422C4F4141552C4341434E4B2C6F42414171422C574143724238442C6B4241416D422C5741436E42';
wwv_flow_api.g_varchar2_table(89) := '2F442C6742414169422C5741436A42472C6F42414171422C574143724236442C3442414136422C614143374235442C7946414130462C69424143314636442C7942414130422C574143314270452C534141592C5741435A4B2C7142414173422C38424143';
wwv_flow_api.g_varchar2_table(90) := '744267452C7543414177432C694341437843432C7742414179422C6F4341497243432C474141492C4341434135442C4B41414D2C364241434E442C4D41414F2C6746414350452C534141552C4341434E39462C574141632C43414356432C6B4241416D42';
wwv_flow_api.g_varchar2_table(91) := '2C6341457642432C4F4141552C4341434E774A2C7142414171422C4F41437242432C6742414167422C6942414368427A4A2C4F4141552C4F4143564B2C3043414132432C4F41433343714A2C3242414134422C4F41433542432C7342414175422C4F4143';
wwv_flow_api.g_varchar2_table(92) := '764274442C65414167422C514145704237462C4D4141532C4341434C6F4A2C7743414179432C5341437A43432C7543414177432C5741437843432C7743414179432C5741437A43432C7942414130422C5741433142432C7543414177432C574143784343';
wwv_flow_api.g_varchar2_table(93) := '2C7743414179432C5741437A43432C7942414130422C5941453942704A2C6B4241416D422C43414366432C534141592C5941456842472C4B4141512C4341434A572C634141652C6141436632452C3642414136422C61414337426E462C6F43414171432C';
wwv_flow_api.g_varchar2_table(94) := '6141437243632C7742414179422C6141437A4273452C6B4341416D432C6B4241436E4372452C7542414177422C734241437842622C7942414179422C4F41437A42442C7542414177422C614143784271462C7343414173432C614143744335452C774241';
wwv_flow_api.g_varchar2_table(95) := '4179422C6141437A424D2C7742414179422C6141437A424A2C7543414177432C6141437843442C3043414132432C614143334334452C6B4341416D432C6D424145764372452C4B4141512C4341434A73452C4F4141532C654143546C452C4D4141532C51';
wwv_flow_api.g_varchar2_table(96) := '4143546F452C6D4341416D432C364241436E43432C7942414130422C6D4241433142432C7542414177422C5741437842432C3042414130422C6F4241433142432C694341416B432C674241436C43432C3043414132432C364241433343432C6743414169';
wwv_flow_api.g_varchar2_table(97) := '432C6D4241436A43432C384241412B422C5741432F42432C694341416B432C6F4241436C43452C2B42414167432C574143684378452C4D4141532C3042414354502C6D4241416F422C30424143704267462C3043414132432C364241433343432C674341';
wwv_flow_api.g_varchar2_table(98) := '4169432C6D4241436A43432C384241412B422C5741432F42432C694341416B432C71424145744333452C4F4141552C4341434E432C7342414175422C71424143764232452C694341416B432C5741436C43432C654141652C514143666E442C6F42414171';
wwv_flow_api.g_varchar2_table(99) := '422C574143724278422C6F42414171422C5941437242572C3242414134422C6F4241433542492C384241412B422C6F4241432F4238442C2B42414167432C774241436843432C7142414173422C77424143744272452C634141652C5741436673472C6B43';
wwv_flow_api.g_varchar2_table(100) := '41416D432C6341436E43432C6743414169432C6341436A432F422C3442414136422C714241433742472C654141652C674241436668452C6F43414171432C5741437243642C694241416B422C5741436C4232472C2B42414167432C5741436843432C6B42';
wwv_flow_api.g_varchar2_table(101) := '41416D422C5741436E4272422C694241416B422C7142414574426C452C4F4141552C4341434E4B2C6F42414171422C574143724238442C6B4241416D422C5741436E422F442C6742414169422C5741436A42472C6F42414171422C574143724236442C34';
wwv_flow_api.g_varchar2_table(102) := '42414134422C614143354235442C7946414130462C69424143314636442C7942414130422C574143314270452C534141592C5741435A4B2C7142414173422C38424143744267452C7543414177432C694341437843432C7742414179422C6F4341497243';
wwv_flow_api.g_varchar2_table(103) := '69422C474141492C4341434135452C4B41414D2C6D4241434E442C4D41414F2C6746414350452C534141552C4341434E39462C574141632C43414356432C6B4241416D422C6141436E4238462C6F4241416F422C634145784237462C4F4141552C434143';
wwv_flow_api.g_varchar2_table(104) := '4E38462C6D4241416D422C4F41436E42452C6B4241416B422C4F41436C4268472C4F4141552C4F4143564B2C3043414132432C4F4143334336462C3442414136422C4F41433742472C65414167422C4F414368426A472C65414167422C5141457042492C';
wwv_flow_api.g_varchar2_table(105) := '4D4141532C4341434C674B2C3443414134432C5341433543354A2C574141592C5341435A432C7142414173422C5741437442462C534141592C5741435A442C7142414173422C5741437442442C534141592C59414568424B2C6B4241416D422C43414366';
wwv_flow_api.g_varchar2_table(106) := '79462C7942414130422C574143314278462C534141592C5741435A452C694241416B422C5941457442432C4B4141512C4341434A572C634141652C614143664C2C614141632C614143644A2C7942414130422C6141433142432C6F43414171432C614143';
wwv_flow_api.g_varchar2_table(107) := '7243632C7742414179422C6141437A4273452C6B4341416D432C6B4241436E4372452C7542414175422C734241437642522C3442414136422C61414337424D2C694241416B422C6141436C42582C7942414130422C4F41433142442C7542414177422C61';
wwv_flow_api.g_varchar2_table(108) := '4143784271462C7343414173432C614143744335452C7742414179422C6141437A424D2C7742414179422C6141437A424A2C7543414177432C6141437843442C3043414132432C614143334334452C6B4341416D432C6D424145764372452C4B4141512C';
wwv_flow_api.g_varchar2_table(109) := '4341434A73452C4F4141532C654143546C452C4D4141532C514143546F452C6D4341416D432C384241436E43432C7942414130422C6D4241433142432C7542414177422C5741437842432C3042414132422C6F4241433342432C6943414169432C674241';
wwv_flow_api.g_varchar2_table(110) := '436A43432C3043414132432C384241433343432C6743414169432C6D4241436A43452C694341416B432C6F4241436C43452C2B4241412B422C5741432F4278452C4D4141532C3042414354502C6D4241416F422C30424143704267462C3043414130432C';
wwv_flow_api.g_varchar2_table(111) := '384241433143432C6743414169432C6D4241436A43432C384241412B422C5741432F42432C694341416B432C71424145744333452C4F4141552C4341434E432C7342414175422C71424143764234452C654141652C514143666E442C6F42414171422C57';
wwv_flow_api.g_varchar2_table(112) := '4143724270422C6D4241416F422C57414370424A2C6F42414171422C5941437242572C3242414134422C6F4241433542492C384241412B422C6F4241432F42472C614141632C574143644B2C65414167422C574143684273442C2B4241412B422C774241';
wwv_flow_api.g_varchar2_table(113) := '432F42432C7142414171422C77424143724272452C634141652C5741436673452C6D4441416D442C6341436E44432C6F43414171432C63414372432F442C7542414177422C634143784269452C2B4241412B422C674241432F42432C654141652C514143';
wwv_flow_api.g_varchar2_table(114) := '66432C654141652C6742414366432C7143414173432C574143744337452C6F42414171422C5741437242592C6F43414171432C5741437243442C7542414177422C57414378426D452C3642414138422C5741433942432C634141632C57414364432C3842';
wwv_flow_api.g_varchar2_table(115) := '41412B422C5741432F42432C6B4341416D432C5741436E4378462C694241416B422C5741436C4279462C3442414134422C5741433542432C7542414175422C5741437642432C6B4341416D432C5741436E4374462C694241416B422C5741436C4275462C';
wwv_flow_api.g_varchar2_table(116) := '6942414169422C6F4241436A426E452C3042414132422C574143334278422C6742414169422C594145724279422C4F4141552C4341434E4B2C6F42414171422C574143724238442C6B4241416B422C5741436C422F442C6742414169422C5741436A4247';
wwv_flow_api.g_varchar2_table(117) := '2C6F42414171422C574143724236442C3442414134422C614143354235442C7946414130462C69424143314636442C7942414130422C574143314270452C534141592C5741435A4B2C7142414173422C38424143744267452C7543414175432C69434143';
wwv_flow_api.g_varchar2_table(118) := '7643432C7742414179422C6F43414972436D422C474141492C4341434139452C4B41414D2C714241434E442C4D41414F2C6746414350452C534141552C4341434E39462C574141632C43414356432C6B4241416D422C6341457642432C4F4141552C4341';
wwv_flow_api.g_varchar2_table(119) := '434E71472C65414167422C4F414368426A472C65414167422C4F414368424A2C4F4141552C4F4143566B472C3442414136422C4F4143374237462C3043414132432C5141452F43472C4D4141532C4341434C4B2C7142414173422C5741437442462C5341';
wwv_flow_api.g_varchar2_table(120) := '41592C5741435A462C534141592C5741435A472C574141592C5341435A462C7142414173422C5941453142492C6B4241416D422C43414366432C534141592C5741435A452C694241416B422C5741436C4273462C7942414130422C594145394272462C4B';
wwv_flow_api.g_varchar2_table(121) := '4141512C4341434A75462C6B4341416D432C6B4241436E4331452C7742414179422C6141437A424D2C7742414179422C6141437A4275452C6B4341416D432C6B4241436E4333452C7543414177432C6141437843542C614141632C614143644A2C794241';
wwv_flow_api.g_varchar2_table(122) := '4130422C6141433142512C3442414136422C6141433742432C634141652C614143664F2C7542414177422C734241437842622C7942414130422C4F41433142532C3043414132432C6141433343472C7742414179422C6141437A42442C694241416B422C';
wwv_flow_api.g_varchar2_table(123) := '6141436C425A2C7542414177422C6141437842442C6F43414171432C6341457A436B422C4B4141512C4341434A6F462C6743414169432C6D4241436A43562C7542414177422C574143784276452C6D4241416F422C304241437042432C4D4141532C5141';
wwv_flow_api.g_varchar2_table(124) := '43544D2C4D4141532C304241435434452C694341416B432C6F4241436C43582C3042414132422C6F4241433342462C7942414130422C6D42414331424B2C6743414169432C6D4241436A43442C3043414132432C2B4241452F436C452C4F4141552C4341';
wwv_flow_api.g_varchar2_table(125) := '434E432C7342414175422C714241437642592C3242414134422C6F424143354238452C6B4341416D432C5741436E436A462C6F42414171422C574143724238452C3642414138422C57414339426C462C6D4241416F422C57414370426D422C6541416742';
wwv_flow_api.g_varchar2_table(126) := '2C574143684238442C7143414173432C574143744335452C634141652C57414366552C7542414177422C5741437842432C6F43414171432C57414372434D2C3042414132422C57414333426B452C6B4341416D432C5741436E4333462C694241416B422C';
wwv_flow_api.g_varchar2_table(127) := '5741436C4271482C7343414175432C634143764339462C6F42414171422C57414372424E2C614141632C5741436438442C6F43414171432C634143724368462C6F42414171422C5941437242452C6742414169422C6D4241436A42492C694241416B422C';
wwv_flow_api.g_varchar2_table(128) := '5741436C42572C7542414177422C6341437842462C384241412B422C6F4241432F4279452C384241412B422C5941456E4337442C4F4141552C4341434E4D2C7142414173422C384241437442462C6742414169422C5741436A42472C6F42414171422C57';
wwv_flow_api.g_varchar2_table(129) := '41437242432C7946414130462C6942414331462B442C7742414179422C694341437A4274452C534141592C5741435A6F452C7942414130422C574143314268452C6F42414171422C6341496A4375462C474141492C434143416A462C4D41414F2C674641';
wwv_flow_api.g_varchar2_table(130) := '4350432C4B41414D2C714241434E432C534141552F462C474145642B4B2C474141492C434143416A462C4B41414D2C714241434E442C4D41414F2C6746414350452C534141552F462C49415364674C2C454141532C53414155432C4541414F432C454141';
wwv_flow_api.g_varchar2_table(131) := '53432C45414165432C4741433743412C49414344412C454141572C43414350432C4F4141552C5741434E764C2C45414147774C2C4D41414F4E2C4F4141512C59414B646C4C2C454141452C714541436C42432C45414157694C2C4F41414F2C534141552C';
wwv_flow_api.g_varchar2_table(132) := '51414153432C4741414F442C4F41414F2C534141552C55414157492C4741437845724C2C45414157774C2C4B41414B2C3842414167434C2C454141572C55414333446E4C2C45414157794C2C57414157432C51414151432C4F414151502C474143744370';
wwv_flow_api.g_varchar2_table(133) := '4C2C45414157694C2C4F41414F2C5341476C42572C45414171422C53414155432C4741432F422C49414149432C454141512F4C2C454141452C6B454143642C4941414B2C49414149674D2C4B41414F6E472C4741435A2C574143492C494141496F472C45';
wwv_flow_api.g_varchar2_table(134) := '41416B42442C4541436C42452C454141536C4D2C454141452C71474143586D4D2C45414165432C4541416942482C4741437043432C4541414D4E2C4F41414F2C6B4241416F424F2C4541416170472C4D4141512C63414374446D472C4541414D4E2C4F41';
wwv_flow_api.g_varchar2_table(135) := '414F2C7143414175434F2C454141616E472C4B41414D2C57414376456B472C4541414D472C4F41414D2C57414352704D2C45414157694C2C4F41414F2C5341436C426F422C4541416D42432C4D41414F4A2C4D414539424A2C4541414D482C4F41414F4D';
wwv_flow_api.g_varchar2_table(136) := '2C4741566A422C4741614A68422C454143492C2B424143412C3249414541612C454143492C4B414750684D2C4F41414F794D2C7742416F4252764D2C45414161462C4F41414F304D2C6942416E4270427A4D2C454141452C51414151344C2C4F41414F2C';
wwv_flow_api.g_varchar2_table(137) := '796541516A42374C2C4F41414F304D2C674241416B42784D2C45414161442C454141452C5341437843412C454141452C51414151344C2C4F41414F334C2C4741436A42794D2C4B41414B432C4D41414D432C7742414358334D2C45414157694C2C4F4143';
wwv_flow_api.g_varchar2_table(138) := '502C4341434932422C554141552C45414356432C534141552C49414556432C554141572C51414B7642684E2C4F41414F794D2C7942414130422C4541456A432C49414351512C4541304241432C4541694241432C454135434A5A2C47414349552C454141';
wwv_flow_api.g_varchar2_table(139) := '30422C57414331422C49414349472C45414441432C45414171422C474173427A422C4F41704241704E2C454141452C6F4241416F42714E2C4B41414B2C53414153412C4B41414B2C4D41414D432C4D41414B2C57414368442C49414149432C4541415976';
wwv_flow_api.g_varchar2_table(140) := '4E2C45414145774C2C4D41436467432C4541416742442C45414155462C4B41414B2C324241432F42492C4541416742462C45414155462C4B41414B2C2B4241432F424B2C4541416942482C45414155462C4B41414B2C714241417142412C4B41414B2C55';
wwv_flow_api.g_varchar2_table(141) := '414331444D2C45414165482C4541416378482C4F41414F34482C4F41437043432C454141654A2C454141637A482C4F41414F34482C4F41437043442C47414177432C4B41417842412C45414161432C5341433742542C4541417342512C4741457242502C';
wwv_flow_api.g_varchar2_table(142) := '4541416D42442C4B41437042432C4541416D42442C47414175422C4941473943432C4541416D42442C4741417142552C47414167422C4341437044432C514141574A2C454143584B2C4B414151522C45414352532C534141594E2C454141654C2C4B4141';
wwv_flow_api.g_varchar2_table(143) := '4B2C6141416172482C57414739436F482C47414750482C4541412B422C53414157472C4541416F42612C47414339442C4941414B2C494141494E2C4B41416742502C4541416F422C4341437A432C49414149632C4541416742642C4541416D424F2C4741';
wwv_flow_api.g_varchar2_table(144) := '4376432C4941414B2C49414149452C4B414167424B2C4541437242442C45414155432C454141634C2C47414165462C45414163452C4B41613744582C4541416D422C5741436E426C4E2C45414145774C2C4D41414D32432C594141592C36424141364241';
wwv_flow_api.g_varchar2_table(145) := '2C594141592C6743416F4A7A442C43414348432C4F41394A69422C5741436C422C4941414968422C45414171424A2C4941497A422C4F414841432C4541413642472C4741416F422C5341415569422C45414151562C45414163452C4741433745542C4541';
wwv_flow_api.g_varchar2_table(146) := '416D424F2C47414163452C4741416942512C4541414F4C2C59414574444D2C4B41414B432C554141556E422C4941304A7242622C4D4139484F2C53414157492C4741436E422C4941414936422C454141774237422C4541414D31472C534143492C694241';
wwv_flow_api.g_varchar2_table(147) := '41314275492C49414352412C4541417742462C4B41414B472C4D41414D442C49414576432C4941414970422C45414171424A2C494143724230422C454141552C45414356432C454141532C45414354432C454141552C45414356432C454141532C474143';
wwv_flow_api.g_varchar2_table(148) := '6235422C4541413642472C4741416F422C5341415769422C45414151562C45414163452C47414339452C4741414B572C4541417342622C47414970422C4741414B612C4541417342622C47414163452C47414B7A432C434143482C4941414969422C4541';
wwv_flow_api.g_varchar2_table(149) := '3143532C5341415568422C45414153432C4541414F2F482C4741432F4338482C4541415169422C494141492C5341415537422C47414374422C4941414938422C454141556C422C45414151542C4B41414B2C6F424141734272482C454141512C4D414370';
wwv_flow_api.g_varchar2_table(150) := '44694A2C5141414F2C53414153432C474143622C4F41414F6C502C45414145774C2C4D41414D78462C53414157412C4B41496C432C4F41464138482C4541415171422C474141472C534141556A432C4741437242592C454141514B2C594141592C364241';
wwv_flow_api.g_varchar2_table(151) := '413642412C594141592C2B4241437A44612C45414151492C514141552C4741436C4274422C4541415175422C534141532C38424143542C4741455276422C4541415177422C514141554E2C454141514D2C4D41436E422C4741455878422C454141517742';
wwv_flow_api.g_varchar2_table(152) := '2C494141494E2C454141514D2C4F4143704278422C4541415175422C534141532C2B424143562C474130424B452C4341416F426C422C4541414F502C514141534F2C4541414F4E2C4B41414F532C4541417342622C47414163452C49414370452C494141';
wwv_flow_api.g_varchar2_table(153) := '6C4269422C45414341462C4B414332422C4941416E42452C49414348442C4541414F6C422C4B4143526B422C4541414F6C422C47414167422C49414533426B422C4541414F6C422C47414163452C47414167422C4741457A43612C5341664B472C454141';
wwv_flow_api.g_varchar2_table(154) := '4F6C422C4B4143526B422C4541414F6C422C47414167422C49414533426B422C4541414F6C422C47414163452C47414167422C4F4150684367422C4541414F6C422C4B4143526B422C4541414F6C422C49414167422C47416F422F4267422C4F41454A2C';
wwv_flow_api.g_varchar2_table(155) := '49414149612C454141652C4F414366432C45414132422C4741433342432C45414130432C45414339432C4941414B2C4941414931442C4B41414F36432C4541435A2C47414149412C4541414F37432C474143502C4941416F422C494141684236432C4541';
wwv_flow_api.g_varchar2_table(156) := '414F37432C474143502C4941414B2C4941414936422C4B4141674267422C4541414F37432C4741434D2C494141394236432C4541414F37432C4741414B36422C49414177432C774241416A42412C4541436E4334422C4541417942452C4B41414B39422C';
wwv_flow_api.g_varchar2_table(157) := '474145394236422C53414952462C47414167422C5541415978442C4541414D2C67444149394377442C47414167422C51414368422C49414149492C4541416F42482C45414179424C2C4F4141532C4541436A442C4D4141514B2C45414179424C2C4F4141';
wwv_flow_api.g_varchar2_table(158) := '532C6B4541416F454B2C4541417942492C4B41414B2C4D4141532C494143704A2C47414D4E432C45414169422C4D41415170422C454141552C6B4241416F42432C454141532C6D4641417146432C454141552C384341432F4A6D422C454141532C554143';
wwv_flow_api.g_varchar2_table(159) := '54432C45414167422C474143684231452C454141572C434143582C4341414574462C4B41414D2C5141415371472C4D41414F2C57414165724D2C45414147774C2C4D41414F4E2C4F4141512C554141652B452C4D41414D2C6B42414535442C6341507442';
wwv_flow_api.g_varchar2_table(160) := '542C45414165492C47414A59462C45414130432C45414335442C4D414151412C454141542C774C4145492C4941433843462C4B415174444F2C454141532C55414354432C4541416742522C45414368426C452C454141552C4341434E2C4341414574462C';
wwv_flow_api.g_varchar2_table(161) := '4B41414D2C32424141344271472C4D41414F2C57414163724D2C45414147774C2C4D41414F4E2C4F4141512C53414157572C4B414179426F452C4D41414D2C49414372482C434141456A4B2C4B41414D2C5141415371472C4D41414F2C57414165724D2C';
wwv_flow_api.g_varchar2_table(162) := '45414147774C2C4D41414F4E2C4F4141512C554141652B452C4D41414D2C6D4241477446482C454143492C754541417945432C4541414F472C63414168462C6D4D41497545482C45414A76452C7743414B3443432C45414C35432C3242415341462C4541';
wwv_flow_api.g_varchar2_table(163) := '434A35452C454141512C5941416579422C4541414D33472C4B41414F2C61414165384A2C45414167422C4741414978452C49417743744536452C51417243532C574143562C49414149432C454141512C364641435A2C4941414B2C4941414970452C4B41';
wwv_flow_api.g_varchar2_table(164) := '414F6E472C45414169422C43414337422C49414349774B2C45414175422C4B4143334270442C454141364270482C45414167426D472C4741414B2F462C554141552C534141536F492C45414151562C45414163452C47414376462C4941414979432C4741';
wwv_flow_api.g_varchar2_table(165) := '416F422C454143704233432C494141694230432C4941436A42432C4741416F422C4741457842442C454141754231432C45414376422C4941414934432C454143412C5741456376452C454146642C61414B4373452C4541416F4233432C454141652C4941';
wwv_flow_api.g_varchar2_table(166) := '4C70432C59415141452C454152412C5941574168492C45414167426D472C4741414B2F462C5341415330482C47414163452C47415835432C6141634875432C47414153472C4B41496A42482C474141532C5741435470512C454141452C51414151794C2C';
wwv_flow_api.g_varchar2_table(167) := '4B41414B32452C4D41576E4268452C4541416B422C534141534E2C47414333422C4741414B412C4541474C2C4F41414F6A472C454141674269472C4B414974422C574143472C494145494B2C4541464171452C4541416F4278512C454141452C73424141';
wwv_flow_api.g_varchar2_table(168) := '734267472C4F41433543794B2C4541416D422C55414155432C4B41414B462C47414574432C4941414B432C4741416F42412C454141694272422C514141552C4941414D71422C45414169422C474143764576462C4541414F2C514141532C384741447042';
wwv_flow_api.g_varchar2_table(169) := '2C434149412C494143492C49414149592C4541416336452C53414153462C45414169422C49414535432C4B41444174452C45414165432C45414169424E2C49414737422C59414441442C4941474C2C4D41414F2B452C4741454C2C5941444131462C4541';
wwv_flow_api.g_varchar2_table(170) := '414F2C364241412B4230462C454141492C2B444147394374452C4541416D42432C4D41414F4A2C4B416E4239422C51416A31424430452C4D41414D2C3649414664222C2266696C65223A22626F6F6B6D61726B6C65742E6A73227D';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(786796201652707123)
,p_file_name=>'bookmarklet.js.map'
,p_mime_type=>'application/json'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1603909248535898)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(91982914389572371)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(99847510628888904)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176132299464506821)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(592239080401709448)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(821272426124330293)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1765084935075712071)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831787808583994192)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1917660199250940025)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1937475917086479910)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.APEX.D3.BUBBLE45203'
,p_attribute_01=>'1.333'
,p_attribute_02=>'3'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1999311583087033598)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(10645977349305910813)
,p_icon_sequence=>10
,p_icon_subtext=>'Logout'
,p_icon_target=>'&LOGOUT_URL.'
,p_icon_image_alt=>'Logout'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
wwv_flow_api.create_toplevel_tab(
 p_id=>wwv_flow_api.id(10345291198234495493)
,p_tab_set=>'Page Templates2'
,p_tab_sequence=>10
,p_tab_name=>'T_PARENTTABTEST2'
,p_tab_text=>'Parent&nbsp;Tab&nbsp;Test&nbsp;2'
,p_tab_target=>'f?p=&APP_ID.:200:&SESSION.::&DEBUG.:::'
,p_current_on_tabset=>'TS1'
);
wwv_flow_api.create_toplevel_tab(
 p_id=>wwv_flow_api.id(10345288219718477677)
,p_tab_set=>'Page Templates2'
,p_tab_sequence=>20
,p_tab_name=>'T_PAGE TEMPLATES2'
,p_tab_text=>'Parent&nbsp;Tab&nbsp;Test&nbsp;1'
,p_tab_target=>'f?p=&APP_ID.:200:&SESSION.::&DEBUG.:::'
,p_current_on_tabset=>'PageTemplates'
);
end;
/
prompt --application/shared_components/user_interface/lovs/availability
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(160414337382963894)
,p_lov_name=>'AVAILABILITY'
,p_lov_query=>'.'||wwv_flow_api.id(160414337382963894)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(160414723240963895)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Immediate'
,p_lov_return_value=>'IMMEDIATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(160415176616963895)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Next Month'
,p_lov_return_value=>'NEXTMONTH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(160415520833963895)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Not Available'
,p_lov_return_value=>'NOTAVAILABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/font_animations
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(562737530366047618)
,p_lov_name=>'FONT_ANIMATIONS'
,p_lov_query=>'.'||wwv_flow_api.id(562737530366047618)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(562738521271047624)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spin'
,p_lov_return_value=>'fa-anim-spin'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(562737797145047621)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Spin in Steps'
,p_lov_return_value=>'fa-anim-spin-step'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(562738178804047623)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Flash'
,p_lov_return_value=>'fa-anim-flash'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(562751360586120648)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Horizontal Shake'
,p_lov_return_value=>'fa-anim-horizontal-shake'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(562751771179120648)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Vertical Shake'
,p_lov_return_value=>'fa-anim-vertical-shake'
);
end;
/
prompt --application/shared_components/user_interface/lovs/role
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(160417043060963896)
,p_lov_name=>'ROLE'
,p_lov_query=>'.'||wwv_flow_api.id(160417043060963896)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(160417472388963897)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Developer'
,p_lov_return_value=>'DEVELOP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(160417816503963897)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Designer'
,p_lov_return_value=>'DESIGN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(160418263172963897)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Manager'
,p_lov_return_value=>'MANAGER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/skills
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(160409448640963882)
,p_lov_name=>'SKILLS'
,p_lov_query=>'.'||wwv_flow_api.id(160409448640963882)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(160409850103963886)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'APEX'
,p_lov_return_value=>'APEX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(160410273789963888)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'HTML'
,p_lov_return_value=>'HTML'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(160410626679963888)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'JavaScript'
,p_lov_return_value=>'JS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(160411086984963888)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'CSS'
,p_lov_return_value=>'CSS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(160411457066963888)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Java'
,p_lov_return_value=>'Java'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(160411823871963889)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Scala'
,p_lov_return_value=>'Scala'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(160412272089963889)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Ruby on Rails'
,p_lov_return_value=>'Ruby on Rails'
);
end;
/
prompt --application/pages/page_groups
begin
wwv_flow_api.create_page_group(
 p_id=>wwv_flow_api.id(405064482015020227)
,p_group_name=>'Components'
);
wwv_flow_api.create_page_group(
 p_id=>wwv_flow_api.id(558266987012620477)
,p_group_name=>'Design'
);
wwv_flow_api.create_page_group(
 p_id=>wwv_flow_api.id(431032219555845082)
,p_group_name=>'Migration Guide'
);
wwv_flow_api.create_page_group(
 p_id=>wwv_flow_api.id(713639924515207048)
,p_group_name=>'Tools and Utilities'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbs/universal_theme_breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(1725934084712570512)
,p_name=>'Universal Theme Breadcrumb'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7673360602846008)
,p_parent_id=>wwv_flow_api.id(713441110976327619)
,p_short_name=>'Layout Modifiers'
,p_link=>'f?p=&APP_ID.:6303:&SESSION.'
,p_page_id=>6303
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7685388498866322)
,p_parent_id=>wwv_flow_api.id(713441110976327619)
,p_short_name=>'Content Modifiers'
,p_link=>'f?p=&APP_ID.:6304:&SESSION.'
,p_page_id=>6304
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(210168877180558147)
,p_parent_id=>wwv_flow_api.id(881157505434754791)
,p_short_name=>'Inline Popup'
,p_link=>'f?p=&APP_ID.:1915:&SESSION.'
,p_page_id=>1915
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(211961789541166023)
,p_parent_id=>wwv_flow_api.id(881157505434754791)
,p_short_name=>'Inline Drawer'
,p_link=>'f?p=&APP_ID.:1916:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>1916
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(214819845821392940)
,p_parent_id=>wwv_flow_api.id(881157505434754791)
,p_short_name=>'Page Drawer'
,p_link=>'f?p=&APP_ID.:1917:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>1917
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(315966332257005007)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'List View'
,p_link=>'f?p=&APP_ID.:1700:&SESSION.::&DEBUG.:::'
,p_page_id=>1700
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(316475931504323548)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Reflow Report'
,p_link=>'f?p=&APP_ID.:1710:&SESSION.::&DEBUG.:::'
,p_page_id=>1710
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(316476488861330022)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Column Toggle Report'
,p_link=>'f?p=&APP_ID.:1720:&SESSION.::&DEBUG.:::'
,p_page_id=>1720
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(350283341012744451)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Content Row'
,p_link=>'f?p=&APP_ID.:1407:&SESSION.'
,p_page_id=>1407
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(405016342125846517)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Standard Region'
,p_link=>'f?p=&APP_ID.:1201:&SESSION.::&DEBUG.:::'
,p_page_id=>1201
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(405040484449865679)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Alert'
,p_link=>'f?p=&APP_ID.:1202:&SESSION.::&DEBUG.:::'
,p_page_id=>1202
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(405062644608003720)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Hero'
,p_link=>'f?p=&APP_ID.:1203:&SESSION.::&DEBUG.:::'
,p_page_id=>1203
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(405108427828686806)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Button Group'
,p_link=>'f?p=&APP_ID.:1204:&SESSION.::&DEBUG.:::'
,p_page_id=>1204
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(405191402701156577)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Carousel'
,p_link=>'f?p=&APP_ID.:1205:&SESSION.::&DEBUG.:::'
,p_page_id=>1205
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(405231916079328330)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Collapsible'
,p_link=>'f?p=&APP_ID.:1206:&SESSION.::&DEBUG.:::'
,p_page_id=>1206
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(405259632803407094)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Title Bar Region'
,p_link=>'f?p=&APP_ID.:1207:&SESSION.::&DEBUG.:::'
,p_page_id=>1207
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(405315415623757810)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Wizards'
,p_link=>'f?p=&APP_ID.:1208:&SESSION.::&DEBUG.:::'
,p_page_id=>1208
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(405358438291967114)
,p_parent_id=>wwv_flow_api.id(1911030665098394574)
,p_short_name=>'Text Only'
,p_link=>'f?p=&APP_ID.:1501:&SESSION.'
,p_page_id=>1501
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(405404246911043708)
,p_parent_id=>wwv_flow_api.id(1911030665098394574)
,p_short_name=>'Icon Only'
,p_link=>'f?p=&APP_ID.:1502:&SESSION.'
,p_page_id=>1502
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(405722108370782715)
,p_parent_id=>wwv_flow_api.id(1911030665098394574)
,p_short_name=>'Text With Icon'
,p_link=>'f?p=&APP_ID.:1503:&SESSION.'
,p_page_id=>1503
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(405776641189895027)
,p_parent_id=>wwv_flow_api.id(405777134403900984)
,p_short_name=>'Media List '
,p_link=>'f?p=&APP_ID.:1301:&SESSION.::&DEBUG.:::'
,p_page_id=>1301
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(405777134403900984)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Lists'
,p_link=>'f?p=&APP_ID.:1300:&SESSION.::&DEBUG.:::'
,p_page_id=>1300
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(415729531119475692)
,p_parent_id=>wwv_flow_api.id(405777134403900984)
,p_short_name=>'Links List'
,p_link=>'f?p=&APP_ID.:1303:&SESSION.::&DEBUG.:::'
,p_page_id=>1303
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(415752454589532129)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Badge List'
,p_link=>'f?p=&APP_ID.:1304:&SESSION.::&DEBUG.:::'
,p_page_id=>1304
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(415772729409701356)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Menu Bar'
,p_link=>'f?p=&APP_ID.:1305:&SESSION.::&DEBUG.:::'
,p_page_id=>1305
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(415798956596821823)
,p_parent_id=>wwv_flow_api.id(881194233909445309)
,p_short_name=>'Classic Report'
,p_link=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.:::'
,p_page_id=>1401
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(415955727913117791)
,p_parent_id=>wwv_flow_api.id(881194233909445309)
,p_short_name=>'Interactive Report'
,p_link=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.:::'
,p_page_id=>1402
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(416129372898571323)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>' Value Attribute Pairs'
,p_link=>'f?p=&APP_ID.:1403:&SESSION.::&DEBUG.:::'
,p_page_id=>1403
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(416218025971740499)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Comments'
,p_link=>'f?p=&APP_ID.:1405:&SESSION.::&DEBUG.:::'
,p_page_id=>1405
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(416303482217820050)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Timeline'
,p_link=>'f?p=&APP_ID.:1406:&SESSION.::&DEBUG.:::'
,p_page_id=>1406
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(416369132735887980)
,p_parent_id=>wwv_flow_api.id(416370450953899013)
,p_short_name=>'Form Modifiers'
,p_link=>'f?p=&APP_ID.:1601:&SESSION.::&DEBUG.:::'
,p_page_id=>1601
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(416370450953899013)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Forms'
,p_link=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.:::'
,p_page_id=>1600
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(416507407538131265)
,p_parent_id=>wwv_flow_api.id(416370450953899013)
,p_short_name=>'Multi Column Layout'
,p_link=>'f?p=&APP_ID.:1602:&SESSION.'
,p_page_id=>1602
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(430904312030166974)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Calendar'
,p_link=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.:::'
,p_page_id=>1800
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(431026239113724261)
,p_parent_id=>wwv_flow_api.id(431031703087824044)
,p_short_name=>'Why Migrate'
,p_link=>'f?p=&APP_ID.:2010:&SESSION.::&DEBUG.:::'
,p_page_id=>2010
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(431031703087824044)
,p_parent_id=>0
,p_short_name=>'Migration Guides'
,p_link=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:::'
,p_page_id=>2000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(431044436003209545)
,p_parent_id=>wwv_flow_api.id(431031703087824044)
,p_short_name=>'Bookmarklet'
,p_link=>'f?p=&APP_ID.:2040:&SESSION.::&DEBUG.:::'
,p_page_id=>2040
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(431272858361902943)
,p_parent_id=>wwv_flow_api.id(431031703087824044)
,p_short_name=>'FAQ'
,p_link=>'f?p=&APP_ID.:2050:&SESSION.'
,p_page_id=>2050
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(435211113342906473)
,p_parent_id=>wwv_flow_api.id(431031703087824044)
,p_short_name=>'Migration Steps'
,p_link=>'f?p=&APP_ID.:2020:&SESSION.::&DEBUG.:::'
,p_page_id=>2020
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(435224098597129018)
,p_parent_id=>wwv_flow_api.id(431031703087824044)
,p_short_name=>'Post Migration'
,p_link=>'f?p=&APP_ID.:2030:&SESSION.'
,p_page_id=>2030
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(459020312700661741)
,p_parent_id=>wwv_flow_api.id(416370450953899013)
,p_short_name=>'Floating Labels'
,p_link=>'f?p=&APP_ID.:1603:&SESSION.'
,p_page_id=>1603
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(480671848759352791)
,p_short_name=>'About'
,p_link=>'f?p=&APP_ID.:600:&SESSION.'
,p_page_id=>600
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Components'
,p_link=>'f?p=&APP_ID.:3000:&SESSION.'
,p_page_id=>3000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(599865283849044119)
,p_parent_id=>wwv_flow_api.id(431031703087824044)
,p_short_name=>'Migrating from jQuery Mobile'
,p_link=>'f?p=&APP_ID.:2060:&SESSION.'
,p_page_id=>2060
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(662088705999490988)
,p_parent_id=>wwv_flow_api.id(878800086315994991)
,p_short_name=>'Mobile Patterns'
,p_link=>'f?p=&APP_ID.:420:&SESSION.'
,p_page_id=>420
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(673646648036520165)
,p_parent_id=>wwv_flow_api.id(662088705999490988)
,p_short_name=>'Navigation'
,p_link=>'f?p=&APP_ID.:421:&SESSION.'
,p_page_id=>421
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(713440476208313042)
,p_parent_id=>wwv_flow_api.id(713441110976327619)
,p_short_name=>'JavaScript Events'
,p_link=>'f?p=&APP_ID.:6200:&SESSION.::&DEBUG.:::'
,p_page_id=>6200
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(713441110976327619)
,p_parent_id=>0
,p_short_name=>'Reference'
,p_link=>'f?p=&APP_ID.:6000:&SESSION.::&DEBUG.:::'
,p_page_id=>6000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(713639758730194276)
,p_parent_id=>wwv_flow_api.id(713441110976327619)
,p_short_name=>'Button Builder'
,p_link=>'f?p=&APP_ID.:6100:&SESSION.'
,p_page_id=>6100
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(732954489982714238)
,p_parent_id=>wwv_flow_api.id(1758435596542435858)
,p_short_name=>'Standard Page Template'
,p_link=>'f?p=&APP_ID.:1115:&SESSION.'
,p_page_id=>1115
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(736913114356128770)
,p_parent_id=>wwv_flow_api.id(713441110976327619)
,p_short_name=>'Responsive Utilities'
,p_link=>'f?p=&APP_ID.:6301:&SESSION.::&DEBUG.:::'
,p_page_id=>6301
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(747876825088794510)
,p_parent_id=>wwv_flow_api.id(662088705999490988)
,p_short_name=>'Headers and Footers'
,p_link=>'f?p=&APP_ID.:422:&SESSION.'
,p_page_id=>422
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(752552499874333310)
,p_parent_id=>wwv_flow_api.id(713441110976327619)
,p_short_name=>'Color and Status Modifiers'
,p_link=>'f?p=&APP_ID.:6302:&SESSION.'
,p_page_id=>6302
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(756678249191197562)
,p_parent_id=>wwv_flow_api.id(878820395161346399)
,p_short_name=>'Page Footer'
,p_link=>'f?p=&APP_ID.:1117:&SESSION.'
,p_page_id=>1117
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(756755896005683553)
,p_parent_id=>wwv_flow_api.id(662088705999490988)
,p_short_name=>'Data Entry'
,p_link=>'f?p=&APP_ID.:423:&SESSION.'
,p_page_id=>423
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(756768285839753736)
,p_parent_id=>wwv_flow_api.id(756755896005683553)
,p_short_name=>'Mobile Forms Example'
,p_link=>'f?p=&APP_ID.:1604:&SESSION.'
,p_page_id=>1604
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(756831656565273988)
,p_parent_id=>wwv_flow_api.id(662088705999490988)
,p_short_name=>'Touch Gestures'
,p_link=>'f?p=&APP_ID.:424:&SESSION.'
,p_page_id=>424
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(761088222290584702)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Card Regions'
,p_link=>'f?p=&APP_ID.:3110:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>3110
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(775206954383869455)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Contextual Info'
,p_link=>'f?p=&APP_ID.:1307:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>1307
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(790468275074051539)
,p_parent_id=>wwv_flow_api.id(662088705999490988)
,p_short_name=>'jQuery Mobile Components'
,p_link=>'f?p=&APP_ID.:425:&SESSION.::&DEBUG.:::'
,p_page_id=>425
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(840826676176747170)
,p_parent_id=>wwv_flow_api.id(878810707644066974)
,p_short_name=>'Menu Bar'
,p_link=>'f?p=&APP_ID.:1120:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>1120
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(841294298262783356)
,p_parent_id=>wwv_flow_api.id(878810707644066974)
,p_short_name=>'Tabs'
,p_link=>'f?p=&APP_ID.:1121:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>1121
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(842000530060801868)
,p_parent_id=>wwv_flow_api.id(878810707644066974)
,p_short_name=>'Mega Menu'
,p_link=>'f?p=&APP_ID.:1122:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>1122
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(842002795877810836)
,p_parent_id=>wwv_flow_api.id(878810707644066974)
,p_short_name=>'Side Tree Navigation'
,p_link=>'f?p=&APP_ID.:1123:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>1123
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(842007588900829852)
,p_parent_id=>wwv_flow_api.id(878810707644066974)
,p_short_name=>'Mega Menu Variation 2'
,p_link=>'f?p=&APP_ID.:1124:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>1124
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(878800086315994991)
,p_parent_id=>0
,p_short_name=>'Design'
,p_link=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.:::'
,p_page_id=>401
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(878803110284040666)
,p_parent_id=>wwv_flow_api.id(878800086315994991)
,p_short_name=>'Colors'
,p_link=>'f?p=&APP_ID.:402:&SESSION.'
,p_page_id=>402
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(878805148812052134)
,p_parent_id=>wwv_flow_api.id(878800086315994991)
,p_short_name=>'Customization'
,p_link=>'f?p=&APP_ID.:403:&SESSION.'
,p_page_id=>403
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(878806872645056196)
,p_parent_id=>wwv_flow_api.id(878800086315994991)
,p_short_name=>'Data Entry'
,p_link=>'f?p=&APP_ID.:404:&SESSION.'
,p_page_id=>404
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(878808536733061977)
,p_parent_id=>wwv_flow_api.id(878800086315994991)
,p_short_name=>'Notifications and Messaging'
,p_link=>'f?p=&APP_ID.:406:&SESSION.'
,p_page_id=>406
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(878810707644066974)
,p_parent_id=>wwv_flow_api.id(878800086315994991)
,p_short_name=>'Navigation'
,p_link=>'f?p=&APP_ID.:407:&SESSION.'
,p_page_id=>407
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(878820013807343793)
,p_parent_id=>wwv_flow_api.id(878820395161346399)
,p_short_name=>'Login Page'
,p_link=>'f?p=&APP_ID.:5001:&SESSION.::&DEBUG.:::'
,p_page_id=>5001
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(878820395161346399)
,p_parent_id=>wwv_flow_api.id(878800086315994991)
,p_short_name=>'UI Patterns'
,p_link=>'f?p=&APP_ID.:5000:&SESSION.::&DEBUG.:::'
,p_page_id=>5000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(878822705619358077)
,p_parent_id=>wwv_flow_api.id(878820395161346399)
,p_short_name=>'Home and Dashboard'
,p_link=>'f?p=&APP_ID.:5002:&SESSION.'
,p_page_id=>5002
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(878823819415362574)
,p_parent_id=>wwv_flow_api.id(878820395161346399)
,p_short_name=>'Filter Page'
,p_link=>'f?p=&APP_ID.:5003:&SESSION.::&DEBUG.:::'
,p_page_id=>5003
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(878824976710375281)
,p_parent_id=>wwv_flow_api.id(878820395161346399)
,p_short_name=>'Marquee Page'
,p_link=>'f?p=&APP_ID.:5004:&SESSION.'
,p_page_id=>5004
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(878826051998379262)
,p_parent_id=>wwv_flow_api.id(878820395161346399)
,p_short_name=>'Modal Dialogs'
,p_link=>'f?p=&APP_ID.:5005:&SESSION.'
,p_page_id=>5005
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(878827168982388181)
,p_parent_id=>wwv_flow_api.id(878800086315994991)
,p_short_name=>'Layout'
,p_link=>'f?p=&APP_ID.:700:&SESSION.::&DEBUG.:::'
,p_page_id=>700
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(878830369710409691)
,p_parent_id=>wwv_flow_api.id(878827168982388181)
,p_short_name=>'Responsive Design'
,p_link=>'f?p=&APP_ID.:701:&SESSION.'
,p_page_id=>701
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(878835075205587954)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Breadcrumb'
,p_link=>'f?p=&APP_ID.:3810:&SESSION.'
,p_page_id=>3810
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(879740912488795988)
,p_parent_id=>wwv_flow_api.id(878827168982388181)
,p_short_name=>'Grid Layout'
,p_link=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:::'
,p_page_id=>300
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(881066848076282529)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Tree'
,p_link=>'f?p=&APP_ID.:1901:&SESSION.'
,p_page_id=>1901
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(881111039740601975)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Charts'
,p_link=>'f?p=&APP_ID.:1902:&SESSION.'
,p_page_id=>1902
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(881116326102723830)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Help Text'
,p_link=>'f?p=&APP_ID.:1903:&SESSION.'
,p_page_id=>1903
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(881118152890734670)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Map Chart'
,p_link=>'f?p=&APP_ID.:1904:&SESSION.'
,p_page_id=>1904
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(881121800279740598)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Static Content'
,p_link=>'f?p=&APP_ID.:1905:&SESSION.::&DEBUG.:::'
,p_page_id=>1905
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(881157505434754791)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Modal Dialogs and Popups'
,p_link=>'f?p=&APP_ID.:1906:&SESSION.::&DEBUG.:::'
,p_page_id=>1906
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(881163895342772753)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Tabs and Region Display Selector'
,p_link=>'f?p=&APP_ID.:1907:&SESSION.::&DEBUG.:::'
,p_page_id=>1907
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(881167366244202617)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'PL/SQL Dynamic Content'
,p_link=>'f?p=&APP_ID.:1908:&SESSION.'
,p_page_id=>1908
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(881168623211214610)
,p_parent_id=>wwv_flow_api.id(431031703087824044)
,p_short_name=>'Updating Universal Theme'
,p_link=>'f?p=&APP_ID.:1909:&SESSION.::&DEBUG.:::'
,p_page_id=>1909
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(881170097767222220)
,p_parent_id=>wwv_flow_api.id(881157505434754791)
,p_short_name=>'Page Dialog'
,p_link=>'f?p=&APP_ID.:1910:&SESSION.::&DEBUG.:::'
,p_page_id=>1910
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(881172314139238857)
,p_parent_id=>wwv_flow_api.id(881157505434754791)
,p_short_name=>'Inline Dialog'
,p_link=>'f?p=&APP_ID.:1911:&SESSION.::&DEBUG.:::'
,p_page_id=>1911
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(881194233909445309)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Data Tables and Reports'
,p_link=>'f?p=&APP_ID.:3400:&SESSION.'
,p_page_id=>3400
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(881228626406484346)
,p_parent_id=>wwv_flow_api.id(881194233909445309)
,p_short_name=>'Interactive Grid'
,p_link=>'f?p=&APP_ID.:1410:&SESSION.::&DEBUG.:::'
,p_page_id=>1410
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(881374476202981669)
,p_parent_id=>wwv_flow_api.id(713441110976327619)
,p_short_name=>'Change Log'
,p_link=>'f?p=&APP_ID.:6305:&SESSION.'
,p_page_id=>6305
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(881376276477993941)
,p_parent_id=>wwv_flow_api.id(713441110976327619)
,p_short_name=>'FAQ'
,p_link=>'f?p=&APP_ID.:6306:&SESSION.'
,p_page_id=>6306
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1758435596542435858)
,p_parent_id=>wwv_flow_api.id(878827168982388181)
,p_short_name=>'Page Templates'
,p_link=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:::'
,p_page_id=>1100
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1773976871138980525)
,p_parent_id=>wwv_flow_api.id(1758435596542435858)
,p_short_name=>'Standard Page Template'
,p_link=>'f?p=&APP_ID.:1101:&SESSION.'
,p_page_id=>1101
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1808784107265857503)
,p_parent_id=>wwv_flow_api.id(713441110976327619)
,p_short_name=>'Component Templates'
,p_link=>'f?p=&APP_ID.:6307:&SESSION.'
,p_page_id=>6307
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1885245761685551804)
,p_parent_id=>wwv_flow_api.id(1758435596542435858)
,p_short_name=>'Standard Page Template'
,p_link=>'f?p=&APP_ID.:1102:&SESSION.'
,p_page_id=>1102
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1885259462750625674)
,p_parent_id=>wwv_flow_api.id(1758435596542435858)
,p_short_name=>'Left Column Page with Side Navigation'
,p_link=>'f?p=&APP_ID.:1103:&SESSION.'
,p_page_id=>1103
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1885267674882727203)
,p_parent_id=>wwv_flow_api.id(1758435596542435858)
,p_short_name=>'Left Column Page with Top Navigation'
,p_link=>'f?p=&APP_ID.:1104:&SESSION.'
,p_page_id=>1104
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1890860434385160978)
,p_parent_id=>wwv_flow_api.id(1758435596542435858)
,p_short_name=>'Right Column Page with Top Navigation'
,p_link=>'f?p=&APP_ID.:1105:&SESSION.'
,p_page_id=>1105
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1890864473059172587)
,p_parent_id=>wwv_flow_api.id(1758435596542435858)
,p_short_name=>'Right Column Page with Top Navigation'
,p_link=>'f?p=&APP_ID.:1106:&SESSION.'
,p_page_id=>1106
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1890868915075211375)
,p_parent_id=>wwv_flow_api.id(1758435596542435858)
,p_short_name=>'Marquee Detail Page with Side Navigation'
,p_link=>'f?p=&APP_ID.:1107:&SESSION.::&DEBUG.:::'
,p_page_id=>1107
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1891239718441396761)
,p_parent_id=>wwv_flow_api.id(1758435596542435858)
,p_short_name=>'Marquee Detail Page with Top Navigation'
,p_link=>'f?p=&APP_ID.:1108:&SESSION.::&DEBUG.:::'
,p_page_id=>1108
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1897720798714999483)
,p_parent_id=>wwv_flow_api.id(1758435596542435858)
,p_short_name=>'Side Columns Page with Side Navigation'
,p_link=>'f?p=&APP_ID.:1109:&SESSION.'
,p_page_id=>1109
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1897734087043021074)
,p_parent_id=>wwv_flow_api.id(1758435596542435858)
,p_short_name=>'Side Columns Page with Top Navigation'
,p_link=>'f?p=&APP_ID.:1110:&SESSION.'
,p_page_id=>1110
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1898478875532595926)
,p_parent_id=>wwv_flow_api.id(1758435596542435858)
,p_short_name=>'Standard Dialog Page'
,p_link=>'f?p=&APP_ID.:1111:&SESSION.'
,p_page_id=>1111
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1899238584269120733)
,p_parent_id=>wwv_flow_api.id(1758435596542435858)
,p_short_name=>'Minimal Page Template'
,p_link=>'f?p=&APP_ID.:1113:&SESSION.'
,p_page_id=>1113
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1911030665098394574)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Buttons'
,p_link=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:::'
,p_page_id=>1500
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2055956183257222899)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Menu Popup'
,p_link=>'f?p=&APP_ID.:1306:&SESSION.'
,p_page_id=>1306
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2089777306376286802)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Card Templates'
,p_link=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.:::'
,p_page_id=>3100
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2176455778526356925)
,p_parent_id=>wwv_flow_api.id(713441110976327619)
,p_short_name=>'JavaScript APIs'
,p_link=>'f?p=&APP_ID.:6201:&SESSION.'
,p_page_id=>6201
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2182465237568964508)
,p_parent_id=>wwv_flow_api.id(558267818619623839)
,p_short_name=>'Button Container'
,p_link=>'f?p=&APP_ID.:1250:&SESSION.::&DEBUG.:::'
,p_page_id=>1250
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2190812909868353587)
,p_parent_id=>wwv_flow_api.id(713441110976327619)
,p_short_name=>'Region Types'
,p_link=>'f?p=&APP_ID.:6308:&SESSION.::&DEBUG.:::'
,p_page_id=>6308
);
end;
/
prompt --application/shared_components/navigation/breadcrumbs/legacy_breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(10646235150665492431)
,p_name=>'Legacy Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/drawer
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(212157975711187152)
,p_theme_id=>42
,p_name=>'Drawer'
,p_internal_name=>'DRAWER'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.theme42.initializePage.modalDialog();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-Drawer-page t-PageTemplate--drawer #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD#>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Drawer" role="dialog" aria-label="#TITLE#">',
'  <div class="t-Drawer-header">#REGION_POSITION_01#</div>',
'  <div class="t-Drawer-bodyWrapperOut">',
'    <div class="t-Drawer-bodyWrapperIn">',
'      <div class="t-Drawer-body" role="main">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION##BODY#</div>',
'    </div>',
'  </div>',
'  <div class="t-Drawer-footer">#REGION_POSITION_03#</div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>11
,p_preset_template_options=>'js-dialog-class-t-Drawer--pullOutEnd'
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_js_init_code=>'apex.theme42.dialog(#PAGE_URL#,{title:#TITLE#,w:#DIALOG_WIDTH#,mxw:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,dlgCls:''t-Drawer-page--standard ''+#DIALOG_CSS_CLASSES#,#DIALOG_ATTRIBUTES#},#PAGE_CSS_CLASSES#,#TRIGGERING_ELEMENT#)'
,p_dialog_js_close_code=>'apex.theme42.dialog.close(#IS_MODAL#,#TARGET#)'
,p_dialog_js_cancel_code=>'apex.theme42.dialog.cancel(#IS_MODAL#)'
,p_dialog_height=>'auto'
,p_dialog_width=>'720'
,p_dialog_max_width=>'960'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(212158314539187140)
,p_page_template_id=>wwv_flow_api.id(212157975711187152)
,p_name=>'Content Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(212158843466187131)
,p_page_template_id=>wwv_flow_api.id(212157975711187152)
,p_name=>'Dialog Footer'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(212159355878187131)
,p_page_template_id=>wwv_flow_api.id(212157975711187152)
,p_name=>'Dialog Header'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/master_detail
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(549332834543365415)
,p_theme_id=>42
,p_name=>'Marquee'
,p_internal_name=>'MASTER_DETAIL'
,p_is_popup=>false
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.stickyTableHeader#MIN#.js?v=#APEX_VERSION#',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.apexTabs#MIN#.js?v=#APEX_VERSION#'))
,p_javascript_code_onload=>'apex.theme42.initializePage.masterDetail();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-PageBody t-PageBody--masterDetail t-PageBody--hideLeft no-anim t-PageTemplate--marquee #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD# id="t_PageBody">',
'<script>(sessionStorage.getItem("right.&APP_ID..&APP_PAGE_ID..preferenceForExpanded") === "true") ? document.getElementById(''t_PageBody'').classList.add(''js-rightExpanded'') : document.getElementById(''t_PageBody'').classList.add(''js-rightCollapsed'')</sc'
||'ript>',
'<a href="#main" id="t_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header" role="banner">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." title="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." id="t_Button_navControl" type="button"><span class="t-Header-'
||'controlsIcon" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'      #AFTER_LOGO#',
'    </div>',
'    <div class="t-Header-navBar">',
'      <div class="t-Header-navBar--start">#BEFORE_NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--center">#NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--end">#AFTER_NAVIGATION_BAR#</div>',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">#TOP_GLOBAL_NAVIGATION_LIST##REGION_POSITION_06#</div>',
'</header>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  #SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">#REGION_POSITION_01#</div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      <main id="main" class="t-Body-mainContent">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-fullContent">#REGION_POSITION_08#</div>',
'        <div class="t-Body-info" id="t_Body_info">#REGION_POSITION_02#</div>',
'        <div class="t-Body-contentInner" role="main">#BODY#</div>',
'      </main>',
'      <footer class="t-Footer" id="t_Footer" role="contentinfo">',
'        <div class="t-Footer-body">',
'          <div class="t-Footer-content">#REGION_POSITION_05#</div>',
'          <div class="t-Footer-apex">',
'            <div class="t-Footer-version">#APP_VERSION#</div>',
'            <div class="t-Footer-customize">#CUSTOMIZE#</div>',
'            #BUILT_WITH_LOVE_USING_APEX#',
'          </div>',
'        </div>',
'        <div class="t-Footer-top">',
'          <a href="#top" class="t-Footer-topButton" id="t_Footer_topButton"><span class="a-Icon icon-up-chevron"></span></a>',
'        </div>',
'      </footer>',
'    </div>',
'  </div>',
'  <div class="t-Body-actions" id="t_Body_actions">',
'    <button class="t-Body-actionsToggle" title="#EXPAND_COLLAPSE_SIDE_COL_LABEL#" id="t_Button_rightControlButton" type="button"><span class="t-Body-actionsControlsIcon" aria-hidden="true"></span></button>',
'    <div class="t-Body-actionsContent" role="complementary">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs" id="t_Body_inlineDialogs">#REGION_POSITION_04#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'      <span class="t-Icon a-Icon icon-user"></span>',
'      <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#">',
'    <span class="t-Icon #IMAGE#"></span>',
'    <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>17
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(232272496455976906)
,p_page_template_id=>wwv_flow_api.id(549332834543365415)
,p_name=>'After Logo'
,p_placeholder=>'AFTER_LOGO'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(232272953461976906)
,p_page_template_id=>wwv_flow_api.id(549332834543365415)
,p_name=>'After Navigation Bar'
,p_placeholder=>'AFTER_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(232273447716976905)
,p_page_template_id=>wwv_flow_api.id(549332834543365415)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'BEFORE_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898026135033193806)
,p_page_template_id=>wwv_flow_api.id(549332834543365415)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898026259383193856)
,p_page_template_id=>wwv_flow_api.id(549332834543365415)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898026302468193858)
,p_page_template_id=>wwv_flow_api.id(549332834543365415)
,p_name=>'Master Detail'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898026459439193860)
,p_page_template_id=>wwv_flow_api.id(549332834543365415)
,p_name=>'Right Side Column'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898026514723193861)
,p_page_template_id=>wwv_flow_api.id(549332834543365415)
,p_name=>'Dialogs, Drawers and Popups'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898026613257193863)
,p_page_template_id=>wwv_flow_api.id(549332834543365415)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898026707805193864)
,p_page_template_id=>wwv_flow_api.id(549332834543365415)
,p_name=>'Top Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898026843032193866)
,p_page_template_id=>wwv_flow_api.id(549332834543365415)
,p_name=>'Banner'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898026951804193868)
,p_page_template_id=>wwv_flow_api.id(549332834543365415)
,p_name=>'Full Width Content'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
end;
/
prompt --application/shared_components/user_interface/templates/page/modal_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(651378991620880020)
,p_theme_id=>42
,p_name=>'Modal Dialog'
,p_internal_name=>'MODAL_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.theme42.initializePage.modalDialog();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-Dialog-page t-Dialog-page--standard t-PageTemplate--dialog #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD#>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="t-Dialog-header">#REGION_POSITION_01#</div>',
'  <div class="t-Dialog-bodyWrapperOut">',
'    <div class="t-Dialog-bodyWrapperIn">',
'      <div class="t-Dialog-body" role="main">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION##BODY#</div>',
'    </div>',
'  </div>',
'  <div class="t-Dialog-footer">#REGION_POSITION_03#</div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>3
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_js_init_code=>'apex.theme42.dialog(#PAGE_URL#,{title:#TITLE#,h:#DIALOG_HEIGHT#,w:#DIALOG_WIDTH#,mxw:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,dlgCls:''t-Dialog-page--standard ''+#DIALOG_CSS_CLASSES#,#DIALOG_ATTRIBUTES#},#PAGE_CSS_CLASSES#,#TRIGGERING_ELEMEN'
||'T#)'
,p_dialog_js_close_code=>'apex.theme42.dialog.close(#IS_MODAL#,#TARGET#)'
,p_dialog_js_cancel_code=>'apex.theme42.dialog.cancel(#IS_MODAL#)'
,p_dialog_height=>'auto'
,p_dialog_width=>'720'
,p_dialog_max_width=>'960'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898027761432193879)
,p_page_template_id=>wwv_flow_api.id(651378991620880020)
,p_name=>'Content Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898027843455193881)
,p_page_template_id=>wwv_flow_api.id(651378991620880020)
,p_name=>'Dialog Header'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898027960279193882)
,p_page_template_id=>wwv_flow_api.id(651378991620880020)
,p_name=>'Dialog Footer'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/login
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(652129338145143712)
,p_theme_id=>42
,p_name=>'Login'
,p_internal_name=>'LOGIN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.appLogin();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-PageBody--login t-PageTemplate--login no-anim #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD#>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Login-container">',
'  <header class="t-Login-containerHeader">#REGION_POSITION_01#</header>',
'  <main class="t-Login-containerBody" id="main">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION##BODY#</main>',
'  <footer class="t-Login-containerFooter">#REGION_POSITION_02#</footer>',
'</div>',
''))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>6
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(238833681160466736)
,p_page_template_id=>wwv_flow_api.id(652129338145143712)
,p_name=>'Body Footer'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898025989579193803)
,p_page_template_id=>wwv_flow_api.id(652129338145143712)
,p_name=>'Content Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898026037066193804)
,p_page_template_id=>wwv_flow_api.id(652129338145143712)
,p_name=>'Body Header'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/wizard_modal_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(672766417768219611)
,p_theme_id=>42
,p_name=>'Wizard Modal Dialog'
,p_internal_name=>'WIZARD_MODAL_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.theme42.initializePage.wizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-Dialog-page t-Dialog-page--wizard t-PageTemplate--wizard #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD#>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="t-Dialog-header">#REGION_POSITION_01#</div>',
'  <div class="t-Dialog-bodyWrapperOut">',
'    <div class="t-Dialog-bodyWrapperIn">',
'      <div class="t-Dialog-body" role="main">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION##BODY#</div>',
'    </div>',
'  </div>',
'  <div class="t-Dialog-footer">#REGION_POSITION_03#</div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_theme_class_id=>3
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},''t-Dialog-page--wizard ''+#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'auto'
,p_dialog_width=>'720'
,p_dialog_max_width=>'960'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898029543229193907)
,p_page_template_id=>wwv_flow_api.id(672766417768219611)
,p_name=>'Wizard Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898029677647193908)
,p_page_template_id=>wwv_flow_api.id(672766417768219611)
,p_name=>'Wizard Progress Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898029796003193910)
,p_page_template_id=>wwv_flow_api.id(672766417768219611)
,p_name=>'Wizard Buttons'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/left_side_column
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(1077614758642401794)
,p_theme_id=>42
,p_name=>'Left Side Column'
,p_internal_name=>'LEFT_SIDE_COLUMN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.leftSideCol();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-PageBody t-PageBody--showLeft t-PageBody--hideActions no-anim t-PageTemplate--leftCol #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD# id="t_PageBody">',
'<a href="#main" id="t_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header" role="banner">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." title="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." id="t_Button_navControl" type="button"><span class="t-Header-'
||'controlsIcon" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'      #AFTER_LOGO#',
'    </div>',
'    <div class="t-Header-navBar">',
'      <div class="t-Header-navBar--start">#BEFORE_NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--center">#NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--end">#AFTER_NAVIGATION_BAR#</div>',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">#TOP_GLOBAL_NAVIGATION_LIST##REGION_POSITION_06#</div>',
'</header>',
''))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  #SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">#REGION_POSITION_01#</div>',
'    <div class="t-Body-side" id="t_Body_side">#REGION_POSITION_02#</div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      <main class="t-Body-mainContent" id="main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-fullContent">#REGION_POSITION_08#</div>',
'        <div class="t-Body-contentInner">#BODY#</div>',
'      </main>',
'      <footer class="t-Footer" id="t_Footer" role="contentinfo">',
'        <div class="t-Footer-body">',
'          <div class="t-Footer-content">#REGION_POSITION_05#</div>',
'          <div class="t-Footer-apex">',
'            <div class="t-Footer-version">#APP_VERSION#</div>',
'            <div class="t-Footer-customize">#CUSTOMIZE#</div>',
'            #BUILT_WITH_LOVE_USING_APEX#',
'          </div>',
'        </div>',
'        <div class="t-Footer-top">',
'          <a href="#top" class="t-Footer-topButton" id="t_Footer_topButton"><span class="a-Icon icon-up-chevron"></span></a>',
'        </div>',
'      </footer>',
'    </div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs" id="t_Body_inlineDialogs">#REGION_POSITION_04#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'      <span class="t-Icon a-Icon icon-user"></span>',
'      <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#">',
'    <span class="t-Icon #IMAGE#"></span>',
'    <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>17
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(232298438362928231)
,p_page_template_id=>wwv_flow_api.id(1077614758642401794)
,p_name=>'After Logo'
,p_placeholder=>'AFTER_LOGO'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(232298896303925762)
,p_page_template_id=>wwv_flow_api.id(1077614758642401794)
,p_name=>'After Navigation Bar'
,p_placeholder=>'AFTER_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(232299205137925762)
,p_page_template_id=>wwv_flow_api.id(1077614758642401794)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'BEFORE_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898024222202193732)
,p_page_template_id=>wwv_flow_api.id(1077614758642401794)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898024367682193743)
,p_page_template_id=>wwv_flow_api.id(1077614758642401794)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898024448183193745)
,p_page_template_id=>wwv_flow_api.id(1077614758642401794)
,p_name=>'Left Column'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898024532396193746)
,p_page_template_id=>wwv_flow_api.id(1077614758642401794)
,p_name=>'Dialogs, Drawers and Popups'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898024677698193748)
,p_page_template_id=>wwv_flow_api.id(1077614758642401794)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898024722418193749)
,p_page_template_id=>wwv_flow_api.id(1077614758642401794)
,p_name=>'Top Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898024819634193750)
,p_page_template_id=>wwv_flow_api.id(1077614758642401794)
,p_name=>'Banner'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898024932142193752)
,p_page_template_id=>wwv_flow_api.id(1077614758642401794)
,p_name=>'Full Width Content'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>8
);
end;
/
prompt --application/shared_components/user_interface/templates/page/right_side_column
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(1077618304322444671)
,p_theme_id=>42
,p_name=>'Right Side Column'
,p_internal_name=>'RIGHT_SIDE_COLUMN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.rightSideCol();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8"> ',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-PageBody t-PageBody--hideLeft no-anim t-PageTemplate--rightSideCol #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD# id="t_PageBody">',
'<script>(sessionStorage.getItem("right.&APP_ID..&APP_PAGE_ID..preferenceForExpanded") === "true") ? document.getElementById(''t_PageBody'').classList.add(''js-rightExpanded'') : document.getElementById(''t_PageBody'').classList.add(''js-rightCollapsed'')</sc'
||'ript>',
'<a href="#main" id="t_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header" role="banner">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." title="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." id="t_Button_navControl" type="button"><span class="t-Header-'
||'controlsIcon" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'      #AFTER_LOGO#',
'    </div>',
'    <div class="t-Header-navBar">',
'      <div class="t-Header-navBar--start">#BEFORE_NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--center">#NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--end">#AFTER_NAVIGATION_BAR#</div>',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">#TOP_GLOBAL_NAVIGATION_LIST##REGION_POSITION_06#</div>',
'</header>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  #SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">#REGION_POSITION_01#</div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      <main id="main" class="t-Body-mainContent">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-fullContent">#REGION_POSITION_08#</div>',
'        <div class="t-Body-contentInner">#BODY#</div>',
'      </main>',
'      <footer class="t-Footer" id="t_Footer" role="contentinfo">',
'        <div class="t-Footer-body">',
'          <div class="t-Footer-content">#REGION_POSITION_05#</div>',
'          <div class="t-Footer-apex">',
'            <div class="t-Footer-version">#APP_VERSION#</div>',
'            <div class="t-Footer-customize">#CUSTOMIZE#</div>',
'            #BUILT_WITH_LOVE_USING_APEX#',
'          </div>',
'        </div>',
'        <div class="t-Footer-top">',
'          <a href="#top" class="t-Footer-topButton" id="t_Footer_topButton"><span class="a-Icon icon-up-chevron"></span></a>',
'        </div>',
'      </footer>',
'    </div>',
'  </div>',
'  <div class="t-Body-actions" id="t_Body_actions">',
'    <button class="t-Body-actionsToggle" aria-label="#EXPAND_COLLAPSE_SIDE_COL_LABEL#" title="#EXPAND_COLLAPSE_SIDE_COL_LABEL#" id="t_Button_rightControlButton" type="button"><span class="t-Body-actionsControlsIcon" aria-hidden="true"></span></button'
||'>',
'    <div class="t-Body-actionsContent" role="complementary">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs" id="t_Body_inlineDialogs">#REGION_POSITION_04#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'      <span class="t-Icon a-Icon icon-user"></span>',
'      <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#">',
'    <span class="t-Icon #IMAGE#"></span>',
'    <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>17
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(232262242908017048)
,p_page_template_id=>wwv_flow_api.id(1077618304322444671)
,p_name=>'After Logo'
,p_placeholder=>'AFTER_LOGO'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(232262709687017045)
,p_page_template_id=>wwv_flow_api.id(1077618304322444671)
,p_name=>'After Navigation Bar'
,p_placeholder=>'AFTER_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(232263264707017044)
,p_page_template_id=>wwv_flow_api.id(1077618304322444671)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'BEFORE_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898028034231193884)
,p_page_template_id=>wwv_flow_api.id(1077618304322444671)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898028155004193885)
,p_page_template_id=>wwv_flow_api.id(1077618304322444671)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898028292859193887)
,p_page_template_id=>wwv_flow_api.id(1077618304322444671)
,p_name=>'Right Column'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898028375002193889)
,p_page_template_id=>wwv_flow_api.id(1077618304322444671)
,p_name=>'Dialogs, Drawers and Popups'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898028459934193890)
,p_page_template_id=>wwv_flow_api.id(1077618304322444671)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898028510530193892)
,p_page_template_id=>wwv_flow_api.id(1077618304322444671)
,p_name=>'Top Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898028667980193893)
,p_page_template_id=>wwv_flow_api.id(1077618304322444671)
,p_name=>'Banner'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898028715321193895)
,p_page_template_id=>wwv_flow_api.id(1077618304322444671)
,p_name=>'Full Width Content'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
end;
/
prompt --application/shared_components/user_interface/templates/page/left_and_right_side_columns
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(1077621880644450151)
,p_theme_id=>42
,p_name=>'Left and Right Side Columns'
,p_internal_name=>'LEFT_AND_RIGHT_SIDE_COLUMNS'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.bothSideCols();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">  ',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0"/>',
'</head>',
'<body class="t-PageBody t-PageBody--showLeft no-anim t-PageTemplate--leftRightCol #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD# id="t_PageBody">',
'<script>(sessionStorage.getItem("right.&APP_ID..&APP_PAGE_ID..preferenceForExpanded") === "true") ? document.getElementById(''t_PageBody'').classList.add(''js-rightExpanded'') : document.getElementById(''t_PageBody'').classList.add(''js-rightCollapsed'')</sc'
||'ript>',
'<a href="#main" id="t_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header" role="banner">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." title="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." id="t_Button_navControl" type="button"><span class="t-Header-'
||'controlsIcon" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'      #AFTER_LOGO#',
'    </div>',
'    <div class="t-Header-navBar">',
'      <div class="t-Header-navBar--start">#BEFORE_NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--center">#NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--end">#AFTER_NAVIGATION_BAR#</div>',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">#TOP_GLOBAL_NAVIGATION_LIST##REGION_POSITION_06#</div>',
'</header>',
''))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  #SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">#REGION_POSITION_01#</div>',
'    <div class="t-Body-side" id="t_Body_side">#REGION_POSITION_02#</div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      <main id="main" class="t-Body-mainContent">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-fullContent">#REGION_POSITION_08#</div>',
'        <div class="t-Body-contentInner">#BODY#</div>',
'      </main>',
'      <footer class="t-Footer" id="t_Footer" role="contentinfo">',
'        <div class="t-Footer-body">',
'          <div class="t-Footer-content">#REGION_POSITION_05#</div>',
'          <div class="t-Footer-apex">',
'            <div class="t-Footer-version">#APP_VERSION#</div>',
'            <div class="t-Footer-customize">#CUSTOMIZE#</div>',
'            #BUILT_WITH_LOVE_USING_APEX#',
'          </div>',
'        </div>',
'        <div class="t-Footer-top">',
'          <a href="#top" class="t-Footer-topButton" id="t_Footer_topButton"><span class="a-Icon icon-up-chevron"></span></a>',
'        </div>',
'      </footer>',
'    </div>',
'  </div>',
'  <div class="t-Body-actions" id="t_Body_actions">',
'    <button class="t-Body-actionsToggle" title="#EXPAND_COLLAPSE_SIDE_COL_LABEL#" id="t_Button_rightControlButton" type="button"><span class="t-Body-actionsControlsIcon" aria-hidden="true"></span></button>',
'    <div class="t-Body-actionsContent" role="complementary">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs" id="t_Body_inlineDialogs">#REGION_POSITION_04#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'      <span class="t-Icon a-Icon icon-user"></span>',
'      <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#">',
'    <span class="t-Icon #IMAGE#"></span>',
'    <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>17
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(232276788936967382)
,p_page_template_id=>wwv_flow_api.id(1077621880644450151)
,p_name=>'After Logo'
,p_placeholder=>'AFTER_LOGO'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(232277268564967382)
,p_page_template_id=>wwv_flow_api.id(1077621880644450151)
,p_name=>'After Navigation Bar'
,p_placeholder=>'AFTER_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(232277791090967382)
,p_page_template_id=>wwv_flow_api.id(1077621880644450151)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'BEFORE_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898025094277193753)
,p_page_template_id=>wwv_flow_api.id(1077621880644450151)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>6
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898025169785193755)
,p_page_template_id=>wwv_flow_api.id(1077621880644450151)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898025218727193756)
,p_page_template_id=>wwv_flow_api.id(1077621880644450151)
,p_name=>'Left Column'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>3
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898025307072193757)
,p_page_template_id=>wwv_flow_api.id(1077621880644450151)
,p_name=>'Right Column'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>3
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898025400630193759)
,p_page_template_id=>wwv_flow_api.id(1077621880644450151)
,p_name=>'Dialogs, Drawers and Popups'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898025522864193760)
,p_page_template_id=>wwv_flow_api.id(1077621880644450151)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>6
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898025653552193798)
,p_page_template_id=>wwv_flow_api.id(1077621880644450151)
,p_name=>'Top Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898025767532193800)
,p_page_template_id=>wwv_flow_api.id(1077621880644450151)
,p_name=>'Banner'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898025829378193801)
,p_page_template_id=>wwv_flow_api.id(1077621880644450151)
,p_name=>'Full Width Content'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>6
);
end;
/
prompt --application/shared_components/user_interface/templates/page/minimal_no_navigation
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(1530046751615002521)
,p_theme_id=>42
,p_name=>'Minimal (No Navigation)'
,p_internal_name=>'MINIMAL_NO_NAVIGATION'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.noSideCol();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#  ',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-PageBody t-PageBody--hideLeft t-PageBody--hideActions no-anim #PAGE_CSS_CLASSES# t-PageBody--noNav t-PageTemplate--minimal" #TEXT_DIRECTION# #ONLOAD# id="t_PageBody">',
'<a href="#main" id="t_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header" role="banner">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" aria-label="#EXPAND_COLLAPSE_NAV_LABEL#" title="#EXPAND_COLLAPSE_NAV_LABEL#" id="t_Button_navControl" type="button"><span class="t-Icon fa fa-bars" aria-hidden="true"'
||'></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'      #AFTER_LOGO#',
'    </div>',
'    <div class="t-Header-navBar">',
'      <div class="t-Header-navBar--start">#BEFORE_NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--center">#NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--end">#AFTER_NAVIGATION_BAR#</div>',
'    </div>',
'  </div>',
'</header>',
'    '))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">#REGION_POSITION_01#</div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      <main id="main" class="t-Body-mainContent">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-fullContent">#REGION_POSITION_08#</div>',
'        <div class="t-Body-contentInner">#BODY#</div>',
'      </main>',
'      <footer class="t-Footer" id="t_Footer" role="contentinfo">',
'        <div class="t-Footer-body">',
'          <div class="t-Footer-content">#REGION_POSITION_05#</div>',
'          <div class="t-Footer-apex">',
'            <div class="t-Footer-version">#APP_VERSION#</div>',
'            <div class="t-Footer-customize">#CUSTOMIZE#</div>',
'            #BUILT_WITH_LOVE_USING_APEX#',
'          </div>',
'        </div>',
'        <div class="t-Footer-top">',
'          <a href="#top" class="t-Footer-topButton" id="t_Footer_topButton"><span class="a-Icon icon-up-chevron"></span></a>',
'        </div>',
'      </footer>',
'    </div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs" id="t_Body_inlineDialogs">#REGION_POSITION_04#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>',
''))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar t-NavigationBar--classic" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'      <span class="t-Icon a-Icon icon-user"></span>',
'      <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header" href="#LINK#">',
'    <span class="t-Icon #IMAGE#"></span>',
'    <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(232268622379999614)
,p_page_template_id=>wwv_flow_api.id(1530046751615002521)
,p_name=>'After Logo'
,p_placeholder=>'AFTER_LOGO'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(232269166611999611)
,p_page_template_id=>wwv_flow_api.id(1530046751615002521)
,p_name=>'After Navigation Bar'
,p_placeholder=>'AFTER_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(232269610943999610)
,p_page_template_id=>wwv_flow_api.id(1530046751615002521)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'BEFORE_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898027097506193870)
,p_page_template_id=>wwv_flow_api.id(1530046751615002521)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898027153015193872)
,p_page_template_id=>wwv_flow_api.id(1530046751615002521)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898027208668193873)
,p_page_template_id=>wwv_flow_api.id(1530046751615002521)
,p_name=>'Dialogs, Drawers and Popups'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898027379730193874)
,p_page_template_id=>wwv_flow_api.id(1530046751615002521)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898027406825193876)
,p_page_template_id=>wwv_flow_api.id(1530046751615002521)
,p_name=>'Top Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898027540226193877)
,p_page_template_id=>wwv_flow_api.id(1530046751615002521)
,p_name=>'Banner'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898027682364193878)
,p_page_template_id=>wwv_flow_api.id(1530046751615002521)
,p_name=>'Full Width Content'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/page/standard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(2623327345562852400)
,p_theme_id=>42
,p_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.noSideCol();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-PageBody t-PageBody--hideLeft t-PageBody--hideActions no-anim t-PageTemplate--standard #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD# id="t_PageBody">',
'<a href="#main" id="t_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header" role="banner">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." title="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." id="t_Button_navControl" type="button"><span class="t-Header-'
||'controlsIcon" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'      #AFTER_LOGO#',
'    </div>',
'    <div class="t-Header-navBar">',
'      <div class="t-Header-navBar--start">#BEFORE_NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--center">#NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--end">#AFTER_NAVIGATION_BAR#</div>',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">#TOP_GLOBAL_NAVIGATION_LIST##REGION_POSITION_06#</div>',
'</header>',
''))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  #SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">#REGION_POSITION_01#</div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      <main id="main" class="t-Body-mainContent">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-fullContent">#REGION_POSITION_08#</div>',
'        <div class="t-Body-contentInner">#BODY#</div>',
'      </main>',
'      <footer class="t-Footer" id="t_Footer" role="contentinfo">',
'        <div class="t-Footer-body">',
'          <div class="t-Footer-content">#REGION_POSITION_05#</div>',
'          <div class="t-Footer-apex">',
'            <div class="t-Footer-version">#APP_VERSION#</div>',
'            <div class="t-Footer-customize">#CUSTOMIZE#</div>',
'            #BUILT_WITH_LOVE_USING_APEX#',
'          </div>',
'        </div>',
'        <div class="t-Footer-top">',
'          <a href="#top" class="t-Footer-topButton" id="t_Footer_topButton"><span class="a-Icon icon-up-chevron"></span></a>',
'        </div>',
'      </footer>',
'    </div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs" id="t_Body_inlineDialogs">#REGION_POSITION_04#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>',
''))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar t-NavigationBar--classic" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'      <span class="t-Icon a-Icon icon-user"></span>',
'      <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header" href="#LINK#">',
'    <span class="t-Icon #IMAGE#"></span>',
'    <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(232259715027041275)
,p_page_template_id=>wwv_flow_api.id(2623327345562852400)
,p_name=>'After Logo'
,p_placeholder=>'AFTER_LOGO'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(232260189129041273)
,p_page_template_id=>wwv_flow_api.id(2623327345562852400)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'BEFORE_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(232260674821041273)
,p_page_template_id=>wwv_flow_api.id(2623327345562852400)
,p_name=>'After Navigation Bar'
,p_placeholder=>'AFTER_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898028805728193896)
,p_page_template_id=>wwv_flow_api.id(2623327345562852400)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898028986053193898)
,p_page_template_id=>wwv_flow_api.id(2623327345562852400)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898029024317193899)
,p_page_template_id=>wwv_flow_api.id(2623327345562852400)
,p_name=>'Dialogs, Drawers and Popups'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898029147558193901)
,p_page_template_id=>wwv_flow_api.id(2623327345562852400)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898029298175193902)
,p_page_template_id=>wwv_flow_api.id(2623327345562852400)
,p_name=>'Top Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898029317528193904)
,p_page_template_id=>wwv_flow_api.id(2623327345562852400)
,p_name=>'Banner'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898029472887193905)
,p_page_template_id=>wwv_flow_api.id(2623327345562852400)
,p_name=>'Full Width Content'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/button/text_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(633800930240492718)
,p_template_name=>'Text with Icon'
,p_internal_name=>'TEXT_WITH_ICON'
,p_template=>'<button class="t-Button t-Button--icon #BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES# onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#"><span class="t-Icon t-Icon--left #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="t-Button-label">#LABEL#'
||'</span><span class="t-Icon t-Icon--right #ICON_CSS_CLASSES#" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="t-Button t-Button--icon #BUTTON_CSS_CLASSES# t-Button--hot" #BUTTON_ATTRIBUTES# onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#"><span class="t-Icon t-Icon--left #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="t-Button-'
||'label">#LABEL#</span><span class="t-Icon t-Icon--right #ICON_CSS_CLASSES#" aria-hidden="true"></span></button>'
,p_theme_class_id=>4
,p_preset_template_options=>'t-Button--iconLeft'
,p_theme_id=>42
);
end;
/
prompt --application/shared_components/user_interface/templates/button/icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(900079107762114354)
,p_template_name=>'Icon'
,p_internal_name=>'ICON'
,p_template=>'<button class="t-Button t-Button--noLabel t-Button--icon #BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES# onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#"><span class="t-Icon #ICON_CSS_CLASSES#" aria-hidde'
||'n="true"></span></button>'
,p_hot_template=>'<button class="t-Button t-Button--noLabel t-Button--icon #BUTTON_CSS_CLASSES# t-Button--hot" #BUTTON_ATTRIBUTES# onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#"><span class="t-Icon #ICON_CSS_CLASSE'
||'S#" aria-hidden="true"></span></button>'
,p_translate_this_template=>'N'
,p_theme_class_id=>5
,p_theme_id=>42
);
end;
/
prompt --application/shared_components/user_interface/templates/button/text
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(2623334346116852418)
,p_template_name=>'Text'
,p_internal_name=>'TEXT'
,p_template=>'<button onclick="#JAVASCRIPT#" class="t-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#"><span class="t-Button-label">#LABEL#</span></button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="t-Button t-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#"><span class="t-Button-label">#LABEL#</span></button>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>42
);
end;
/
prompt --application/shared_components/user_interface/templates/region/inline_popup
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(36340727081178326)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#_parent">',
'<div id="#REGION_STATIC_ID#" class="t-DialogRegion #REGION_CSS_CLASSES# js-regionPopup" #REGION_ATTRIBUTES# style="display:none" title="#TITLE!ATTR#">',
'  <div class="t-DialogRegion-wrap">',
'    <div class="t-DialogRegion-bodyWrapperOut"><div class="t-DialogRegion-bodyWrapperIn"><div class="t-DialogRegion-body">#BODY##SUB_REGIONS#</div></div></div>',
'    <div class="t-DialogRegion-buttons">',
'       <div class="t-ButtonRegion t-ButtonRegion--dialogRegion">',
'         <div class="t-ButtonRegion-wrap">',
'           <div class="t-ButtonRegion-col t-ButtonRegion-col--left"><div class="t-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'           <div class="t-ButtonRegion-col t-ButtonRegion-col--right"><div class="t-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'         </div>',
'       </div>',
'    </div>',
'  </div>',
'</div>',
'</div>'))
,p_page_plug_template_name=>'Inline Popup'
,p_internal_name=>'INLINE_POPUP'
,p_theme_id=>42
,p_theme_class_id=>24
,p_preset_template_options=>'js-dialog-size600x400'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(36341067236178344)
,p_plug_template_id=>wwv_flow_api.id(36340727081178326)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142716714925341565)
,p_plug_template_id=>wwv_flow_api.id(36340727081178326)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142716859747341565)
,p_plug_template_id=>wwv_flow_api.id(36340727081178326)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142716924697341564)
,p_plug_template_id=>wwv_flow_api.id(36340727081178326)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142717030133341564)
,p_plug_template_id=>wwv_flow_api.id(36340727081178326)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142717185458341564)
,p_plug_template_id=>wwv_flow_api.id(36340727081178326)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142717219272341564)
,p_plug_template_id=>wwv_flow_api.id(36340727081178326)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142717358148341564)
,p_plug_template_id=>wwv_flow_api.id(36340727081178326)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/inline_drawer
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(211944521729302482)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#_parent">',
'  <div id="#REGION_STATIC_ID#" class="t-DrawerRegion js-dialog-class-ui-dialog--drawer #REGION_CSS_CLASSES# js-regionDialog" #REGION_ATTRIBUTES# style="display:none" title="#TITLE!ATTR#">',
'    <div class="t-DrawerRegion-wrap">',
'      <div class="t-DrawerRegion-bodyWrapperOut">',
'        <div class="t-DrawerRegion-bodyWrapperIn">',
'          <div class="t-DrawerRegion-body">#BODY##SUB_REGIONS#</div>',
'        </div>',
'      </div>',
'      <div class="t-DrawerRegion-buttons">',
'        <div class="t-ButtonRegion t-ButtonRegion--dialogRegion">',
'          <div class="t-ButtonRegion-wrap">',
'            <div class="t-ButtonRegion-col t-ButtonRegion-col--left">',
'              <div class="t-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div>',
'            </div>',
'            <div class="t-ButtonRegion-col t-ButtonRegion-col--right">',
'              <div class="t-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div>',
'            </div>',
'          </div>',
'        </div>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'Inline Drawer'
,p_internal_name=>'INLINE_DRAWER'
,p_theme_id=>42
,p_theme_class_id=>24
,p_default_template_options=>'js-modal'
,p_preset_template_options=>'js-dialog-class-t-Drawer--pullOutEnd'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(211944943574302471)
,p_plug_template_id=>wwv_flow_api.id(211944521729302482)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(211945479087302464)
,p_plug_template_id=>wwv_flow_api.id(211944521729302482)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(211945928585302463)
,p_plug_template_id=>wwv_flow_api.id(211944521729302482)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(211946474067302463)
,p_plug_template_id=>wwv_flow_api.id(211944521729302482)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(211946977078302463)
,p_plug_template_id=>wwv_flow_api.id(211944521729302482)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(211947433164302462)
,p_plug_template_id=>wwv_flow_api.id(211944521729302482)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(211947923912302462)
,p_plug_template_id=>wwv_flow_api.id(211944521729302482)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(211948491393302461)
,p_plug_template_id=>wwv_flow_api.id(211944521729302482)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(591654834181983844)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-header">',
'        <h2 class="t-Alert-title" id="#REGION_STATIC_ID#_heading" data-apex-heading>#TITLE#</h2>',
'      </div>',
'      <div class="t-Alert-body">#BODY##SUB_REGIONS#</div>',
'    </div>',
'    <div class="t-Alert-buttons">#PREVIOUS##CLOSE##CREATE##NEXT#</div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'Alert'
,p_internal_name=>'ALERT'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>21
,p_preset_template_options=>'t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--warning'
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142717415901341564)
,p_plug_template_id=>wwv_flow_api.id(591654834181983844)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142717588324341564)
,p_plug_template_id=>wwv_flow_api.id(591654834181983844)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142717678399341564)
,p_plug_template_id=>wwv_flow_api.id(591654834181983844)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142717754305341563)
,p_plug_template_id=>wwv_flow_api.id(591654834181983844)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142717848897341563)
,p_plug_template_id=>wwv_flow_api.id(591654834181983844)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(591655247569983854)
,p_plug_template_id=>wwv_flow_api.id(591654834181983844)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/region/cards_container
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(623695900776932839)
,p_layout=>'TABLE'
,p_template=>'<div role="region" aria-label="#TITLE!ATTR#" class="t-CardsRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY##SUB_REGIONS#</div>'
,p_page_plug_template_name=>'Cards Container'
,p_internal_name=>'CARDS_CONTAINER'
,p_theme_id=>42
,p_theme_class_id=>21
,p_default_template_options=>'u-colors'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142717914170341563)
,p_plug_template_id=>wwv_flow_api.id(623695900776932839)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142718018465341563)
,p_plug_template_id=>wwv_flow_api.id(623695900776932839)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/interactive_report
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(651498026300583706)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="t-IRR-region #REGION_CSS_CLASSES#">#PREVIOUS##BODY##SUB_REGIONS##NEXT#</div>',
''))
,p_page_plug_template_name=>'Interactive Report'
,p_internal_name=>'INTERACTIVE_REPORT'
,p_theme_id=>42
,p_theme_class_id=>9
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142718182234341563)
,p_plug_template_id=>wwv_flow_api.id(651498026300583706)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142718236038341563)
,p_plug_template_id=>wwv_flow_api.id(651498026300583706)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142718371265341563)
,p_plug_template_id=>wwv_flow_api.id(651498026300583706)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142718483424341563)
,p_plug_template_id=>wwv_flow_api.id(651498026300583706)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/wizard_container
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(670020401234384587)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-Wizard #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-Wizard-header">',
'    <h1 class="t-Wizard-title" id="#REGION_STATIC_ID#_heading" data-apex-heading>#TITLE#</h1>',
'    <div class="u-Table t-Wizard-controls">',
'      <div class="u-Table-fit t-Wizard-buttons">#PREVIOUS##CLOSE#</div>',
'      <div class="u-Table-fill t-Wizard-steps">#BODY#</div>',
'      <div class="u-Table-fit t-Wizard-buttons">#NEXT#</div>',
'    </div>',
'  </div>',
'  <div class="t-Wizard-body">#SUB_REGIONS#</div>',
'</div>'))
,p_page_plug_template_name=>'Wizard Container'
,p_internal_name=>'WIZARD_CONTAINER'
,p_theme_id=>42
,p_theme_class_id=>8
,p_preset_template_options=>'t-Wizard--hideStepsXSmall'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142718524794341563)
,p_plug_template_id=>wwv_flow_api.id(670020401234384587)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142718674817341562)
,p_plug_template_id=>wwv_flow_api.id(670020401234384587)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142718701854341562)
,p_plug_template_id=>wwv_flow_api.id(670020401234384587)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142718833678341562)
,p_plug_template_id=>wwv_flow_api.id(670020401234384587)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(2078063386176426255)
,p_plug_template_id=>wwv_flow_api.id(670020401234384587)
,p_name=>'Wizard Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
);
end;
/
prompt --application/shared_components/user_interface/templates/region/buttons_container
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(677400524731372757)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-ButtonRegion t-Form--floatLeft #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-ButtonRegion-wrap">',
'    <div class="t-ButtonRegion-col t-ButtonRegion-col--left"><div class="t-ButtonRegion-buttons">#PREVIOUS##CLOSE##DELETE#</div></div>',
'    <div class="t-ButtonRegion-col t-ButtonRegion-col--content">',
'      #BODY#',
'      <div class="t-ButtonRegion-buttons">#CHANGE#</div>',
'      #SUB_REGIONS#',
'    </div>',
'    <div class="t-ButtonRegion-col t-ButtonRegion-col--right"><div class="t-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'Buttons Container'
,p_internal_name=>'BUTTONS_CONTAINER'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>17
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142718908285341562)
,p_plug_template_id=>wwv_flow_api.id(677400524731372757)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142719041350341562)
,p_plug_template_id=>wwv_flow_api.id(677400524731372757)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142719188276341562)
,p_plug_template_id=>wwv_flow_api.id(677400524731372757)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142719238751341562)
,p_plug_template_id=>wwv_flow_api.id(677400524731372757)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142719355082341561)
,p_plug_template_id=>wwv_flow_api.id(677400524731372757)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142719465049341561)
,p_plug_template_id=>wwv_flow_api.id(677400524731372757)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142719589559341561)
,p_plug_template_id=>wwv_flow_api.id(677400524731372757)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(677400902423372768)
,p_plug_template_id=>wwv_flow_api.id(677400524731372757)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(677401435884372770)
,p_plug_template_id=>wwv_flow_api.id(677400524731372757)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/region/content_block
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(873087052820635270)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-ContentBlock #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-ContentBlock-header">',
'    <div class="t-ContentBlock-headerItems t-ContentBlock-headerItems--title">',
'      <span class="t-ContentBlock-headerIcon"><span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span></span>',
'      <h1 class="t-ContentBlock-title" id="#REGION_STATIC_ID#_heading" data-apex-heading>#TITLE#</h1>',
'      #EDIT#',
'    </div>',
'    <div class="t-ContentBlock-headerItems t-ContentBlock-headerItems--buttons">#CHANGE#</div>',
'  </div>',
'  <div class="t-ContentBlock-body">#BODY##SUB_REGIONS#</div>',
'  <div class="t-ContentBlock-buttons">#PREVIOUS##NEXT#</div>',
'</div>',
''))
,p_page_plug_template_name=>'Content Block'
,p_internal_name=>'CONTENT_BLOCK'
,p_theme_id=>42
,p_theme_class_id=>21
,p_preset_template_options=>'t-ContentBlock--h1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142727858270341551)
,p_plug_template_id=>wwv_flow_api.id(873087052820635270)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142727903740341551)
,p_plug_template_id=>wwv_flow_api.id(873087052820635270)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142728055525341551)
,p_plug_template_id=>wwv_flow_api.id(873087052820635270)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142728126834341551)
,p_plug_template_id=>wwv_flow_api.id(873087052820635270)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142728241596341551)
,p_plug_template_id=>wwv_flow_api.id(873087052820635270)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142728312700341551)
,p_plug_template_id=>wwv_flow_api.id(873087052820635270)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/title_bar
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1082434711915925186)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<nav aria-label="#TITLE!ATTR#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="t-BreadcrumbRegion #REGION_CSS_CLASSES#">',
'  <div class="t-BreadcrumbRegion-top">',
'    <div class="t-BreadcrumbRegion-body">',
'      <div class="t-BreadcrumbRegion-breadcrumb">#BODY#</div>',
'        <div class="t-BreadcrumbRegion-title">',
'        <h1 id="#REGION_STATIC_ID#_heading" class="t-BreadcrumbRegion-titleText" data-apex-heading>#TITLE#</h1>',
'      </div>',
'    </div>',
'    <div class="t-BreadcrumbRegion-buttons">#PREVIOUS##CLOSE##DELETE##HELP##CHANGE##EDIT##COPY##CREATE##NEXT#</div>',
'  </div>',
'  <div class="t-BreadcrumbRegion-bottom">#SMART_FILTERS#</div>',
'</nav>',
''))
,p_page_plug_template_name=>'Title Bar'
,p_internal_name=>'TITLE_BAR'
,p_theme_id=>42
,p_theme_class_id=>6
,p_default_template_options=>'t-BreadcrumbRegion--showBreadcrumb'
,p_preset_template_options=>'t-BreadcrumbRegion--useBreadcrumbTitle'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142728459360341550)
,p_plug_template_id=>wwv_flow_api.id(1082434711915925186)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142728567287341550)
,p_plug_template_id=>wwv_flow_api.id(1082434711915925186)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142728667628341550)
,p_plug_template_id=>wwv_flow_api.id(1082434711915925186)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142728743574341550)
,p_plug_template_id=>wwv_flow_api.id(1082434711915925186)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142728881900341550)
,p_plug_template_id=>wwv_flow_api.id(1082434711915925186)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142728925967341550)
,p_plug_template_id=>wwv_flow_api.id(1082434711915925186)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142729084754341550)
,p_plug_template_id=>wwv_flow_api.id(1082434711915925186)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142729103332341550)
,p_plug_template_id=>wwv_flow_api.id(1082434711915925186)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142729228375341550)
,p_plug_template_id=>wwv_flow_api.id(1082434711915925186)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142729330997341549)
,p_plug_template_id=>wwv_flow_api.id(1082434711915925186)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142729446148341549)
,p_plug_template_id=>wwv_flow_api.id(1082434711915925186)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(230730829922491062)
,p_plug_template_id=>wwv_flow_api.id(1082434711915925186)
,p_name=>'Smart Filters'
,p_placeholder=>'SMART_FILTERS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/collapsible
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1215306280710140812)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!HTML#" class="t-Region t-Region--hideShow #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
' <div class="t-Region-header">',
'  <div class="t-Region-headerItems t-Region-headerItems--controls"><span class="t-Button t-Button--icon t-Button--hideShow"><span class="a-Icon _a-Collapsible-icon" aria-hidden="true"></span></span></div>',
'  <div class="t-Region-headerItems t-Region-headerItems--title">',
'    <h2 class="t-Region-title" data-apex-heading><button class="t-Region-titleButton" type="button">#TITLE#</button></h2>',
'  </div>',
'  <div class="t-Region-headerItems t-Region-headerItems--buttons">#EDIT#</div>',
' </div>',
' <div class="t-Region-bodyWrap">',
'   <div class="t-Region-buttons t-Region-buttons--top">',
'    <div class="t-Region-buttons-left">#CLOSE#</div>',
'    <div class="t-Region-buttons-right">#CREATE#</div>',
'   </div>',
'   <div class="t-Region-body">',
'     #COPY#',
'     #BODY#',
'     #SUB_REGIONS#',
'     #CHANGE#',
'   </div>',
'   <div class="t-Region-buttons t-Region-buttons--bottom">',
'    <div class="t-Region-buttons-left">#PREVIOUS#</div>',
'    <div class="t-Region-buttons-right">#NEXT#</div>',
'   </div>',
' </div>',
'</div>'))
,p_page_plug_template_name=>'Collapsible'
,p_internal_name=>'COLLAPSIBLE'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>1
,p_preset_template_options=>'is-expanded:t-Region--scrollBody'
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142729515808341549)
,p_plug_template_id=>wwv_flow_api.id(1215306280710140812)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142729633846341549)
,p_plug_template_id=>wwv_flow_api.id(1215306280710140812)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142729758639341549)
,p_plug_template_id=>wwv_flow_api.id(1215306280710140812)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142729847045341549)
,p_plug_template_id=>wwv_flow_api.id(1215306280710140812)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142729946937341549)
,p_plug_template_id=>wwv_flow_api.id(1215306280710140812)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142730007401341549)
,p_plug_template_id=>wwv_flow_api.id(1215306280710140812)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142730119893341548)
,p_plug_template_id=>wwv_flow_api.id(1215306280710140812)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(1215306610603140813)
,p_plug_template_id=>wwv_flow_api.id(1215306280710140812)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(1215307164553140813)
,p_plug_template_id=>wwv_flow_api.id(1215306280710140812)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/region/inline_dialog
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1223645131968329858)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#_parent">',
'<div id="#REGION_STATIC_ID#" class="t-DialogRegion #REGION_CSS_CLASSES# js-regionDialog" #REGION_ATTRIBUTES# style="display:none" title="#TITLE!ATTR#">',
'  <div class="t-DialogRegion-wrap">',
'    <div class="t-DialogRegion-bodyWrapperOut"><div class="t-DialogRegion-bodyWrapperIn"><div class="t-DialogRegion-body">#BODY##SUB_REGIONS#</div></div></div>',
'    <div class="t-DialogRegion-buttons">',
'       <div class="t-ButtonRegion t-ButtonRegion--dialogRegion">',
'         <div class="t-ButtonRegion-wrap">',
'           <div class="t-ButtonRegion-col t-ButtonRegion-col--left"><div class="t-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'           <div class="t-ButtonRegion-col t-ButtonRegion-col--right"><div class="t-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'         </div>',
'       </div>',
'    </div>',
'  </div>',
'</div>',
'</div>'))
,p_page_plug_template_name=>'Inline Dialog'
,p_internal_name=>'INLINE_DIALOG'
,p_theme_id=>42
,p_theme_class_id=>24
,p_default_template_options=>'js-modal:js-draggable:js-resizable'
,p_preset_template_options=>'js-dialog-size600x400'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142730210459341548)
,p_plug_template_id=>wwv_flow_api.id(1223645131968329858)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142730333299341548)
,p_plug_template_id=>wwv_flow_api.id(1223645131968329858)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142730414711341548)
,p_plug_template_id=>wwv_flow_api.id(1223645131968329858)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142730536767341548)
,p_plug_template_id=>wwv_flow_api.id(1223645131968329858)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142730609274341548)
,p_plug_template_id=>wwv_flow_api.id(1223645131968329858)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142730724110341548)
,p_plug_template_id=>wwv_flow_api.id(1223645131968329858)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142730804850341548)
,p_plug_template_id=>wwv_flow_api.id(1223645131968329858)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(2078379876172179331)
,p_plug_template_id=>wwv_flow_api.id(1223645131968329858)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/hero
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1224989219520090364)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-HeroRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-HeroRegion-top">',
'    <div class="t-HeroRegion-wrap">',
'      <div class="t-HeroRegion-col t-HeroRegion-col--left"><span class="t-HeroRegion-icon t-Icon #ICON_CSS_CLASSES#"></span></div>',
'      <div class="t-HeroRegion-col t-HeroRegion-col--content">',
'        <h1 class="t-HeroRegion-title" data-apex-heading>#TITLE#</h1>',
'        #BODY#',
'      </div>',
'      <div class="t-HeroRegion-col t-HeroRegion-col--right"><div class="t-HeroRegion-form">#SUB_REGIONS#</div><div class="t-HeroRegion-buttons">#NEXT#</div></div>',
'    </div>',
'  </div>',
'  <div class="t-HeroRegion-bottom">#SMART_FILTERS#</div>',
'</div>',
''))
,p_page_plug_template_name=>'Hero'
,p_internal_name=>'HERO'
,p_theme_id=>42
,p_theme_class_id=>22
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142737294104341539)
,p_plug_template_id=>wwv_flow_api.id(1224989219520090364)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142737392368341539)
,p_plug_template_id=>wwv_flow_api.id(1224989219520090364)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(230731400331481768)
,p_plug_template_id=>wwv_flow_api.id(1224989219520090364)
,p_name=>'Smart Filters'
,p_placeholder=>'SMART_FILTERS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(1412035210013638440)
,p_plug_template_id=>wwv_flow_api.id(1224989219520090364)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
);
end;
/
prompt --application/shared_components/user_interface/templates/region/login
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1225129382632869472)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-Login-region t-Form--stretchInputs t-Form--labelsAbove #REGION_CSS_CLASSES#" id="#REGION_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-Login-header">',
'    <span class="t-Login-logo #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    <h1 class="t-Login-title" id="#REGION_STATIC_ID#_heading" data-apex-heading>#TITLE#</h1>',
'  </div>',
'  <div class="t-Login-body">#BODY#</div>',
'  <div class="t-Login-buttons">#NEXT#</div>',
'  <div class="t-Login-links">#EDIT##CREATE#</div>',
'  <div class="t-Login-subRegions">#SUB_REGIONS#</div>',
'</div>'))
,p_page_plug_template_name=>'Login'
,p_internal_name=>'LOGIN'
,p_theme_id=>42
,p_theme_class_id=>23
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142737406956341539)
,p_plug_template_id=>wwv_flow_api.id(1225129382632869472)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142737553560341539)
,p_plug_template_id=>wwv_flow_api.id(1225129382632869472)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142737697427341539)
,p_plug_template_id=>wwv_flow_api.id(1225129382632869472)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142737754999341539)
,p_plug_template_id=>wwv_flow_api.id(1225129382632869472)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(1895482490835588056)
,p_plug_template_id=>wwv_flow_api.id(1225129382632869472)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/carousel_container
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1418258663404351882)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-Region t-Region--carousel #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-Region-header">',
'    <div class="t-Region-headerItems t-Region-headerItems--title">',
'      <span class="t-Region-headerIcon"><span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span></span>',
'      <h2 class="t-Region-title" id="#REGION_STATIC_ID#_heading" data-apex-heading>#TITLE#</h2>',
'    </div>',
'    <div class="t-Region-headerItems t-Region-headerItems--buttons">#COPY##EDIT#<span class="js-maximizeButtonContainer"></span></div>',
'  </div>',
'  <div role="region" aria-label="#TITLE#" class="t-Region-bodyWrap">',
'    <div class="t-Region-buttons t-Region-buttons--top">',
'      <div class="t-Region-buttons-left">#PREVIOUS#</div>',
'      <div class="t-Region-buttons-right">#NEXT#</div>',
'    </div>',
'    <div class="t-Region-body">',
'      #BODY#',
'      <div class="t-Region-carouselRegions">#SUB_REGIONS#</div>',
'    </div>',
'    <div class="t-Region-buttons t-Region-buttons--bottom">',
'      <div class="t-Region-buttons-left">#CLOSE##HELP#</div>',
'      <div class="t-Region-buttons-right">#DELETE##CHANGE##CREATE#</div>',
'    </div>',
'  </div>',
'</div>'))
,p_sub_plug_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div data-label="#SUB_REGION_TITLE#" id="SR_#SUB_REGION_ID#">',
'  #SUB_REGION#',
'</div>'))
,p_page_plug_template_name=>'Carousel Container'
,p_internal_name=>'CAROUSEL_CONTAINER'
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.apexTabs#MIN#.js?v=#APEX_VERSION#',
'#IMAGE_PREFIX#plugins/com.oracle.apex.carousel/1.1/com.oracle.apex.carousel#MIN#.js?v=#APEX_VERSION#'))
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>5
,p_default_template_options=>'t-Region--showCarouselControls'
,p_preset_template_options=>'t-Region--hiddenOverflow'
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142737844775341538)
,p_plug_template_id=>wwv_flow_api.id(1418258663404351882)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142737982139341538)
,p_plug_template_id=>wwv_flow_api.id(1418258663404351882)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142738049236341538)
,p_plug_template_id=>wwv_flow_api.id(1418258663404351882)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142738190286341538)
,p_plug_template_id=>wwv_flow_api.id(1418258663404351882)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142738238220341538)
,p_plug_template_id=>wwv_flow_api.id(1418258663404351882)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142738361071341538)
,p_plug_template_id=>wwv_flow_api.id(1418258663404351882)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142738451957341538)
,p_plug_template_id=>wwv_flow_api.id(1418258663404351882)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142738558952341538)
,p_plug_template_id=>wwv_flow_api.id(1418258663404351882)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142738644624341537)
,p_plug_template_id=>wwv_flow_api.id(1418258663404351882)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(1418259019553351884)
,p_plug_template_id=>wwv_flow_api.id(1418258663404351882)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(1418259515441351885)
,p_plug_template_id=>wwv_flow_api.id(1418258663404351882)
,p_name=>'Slides'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/region/tabs_container
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1774143203700285855)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-TabsRegion #REGION_CSS_CLASSES# apex-tabs-region" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'  <div class="t-TabsRegion-items">#SUB_REGIONS#</div>',
'</div>'))
,p_sub_plug_template=>'<div data-label="#SUB_REGION_TITLE#" id="SR_#SUB_REGION_ID#">#SUB_REGION#</div>'
,p_page_plug_template_name=>'Tabs Container'
,p_internal_name=>'TABS_CONTAINER'
,p_javascript_file_urls=>'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.apexTabs#MIN#.js?v=#APEX_VERSION#'
,p_theme_id=>42
,p_theme_class_id=>5
,p_preset_template_options=>'t-TabsRegion-mod--simple'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(1774183925743302430)
,p_plug_template_id=>wwv_flow_api.id(1774143203700285855)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(1777381553192669666)
,p_plug_template_id=>wwv_flow_api.id(1774143203700285855)
,p_name=>'Tabs'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/blank_with_attributes_no_grid
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1922209187092703219)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="#REGION_CSS_CLASSES#">#PREVIOUS##BODY##SUB_REGIONS##NEXT#</div>'
,p_page_plug_template_name=>'Blank with Attributes (No Grid)'
,p_internal_name=>'BLANK_WITH_ATTRIBUTES_NO_GRID'
,p_theme_id=>42
,p_theme_class_id=>7
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142738733645341537)
,p_plug_template_id=>wwv_flow_api.id(1922209187092703219)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142738817157341537)
,p_plug_template_id=>wwv_flow_api.id(1922209187092703219)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(1922210004201708852)
,p_plug_template_id=>wwv_flow_api.id(1922209187092703219)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(1922210541525708854)
,p_plug_template_id=>wwv_flow_api.id(1922209187092703219)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/standard
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2623330321607852408)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-Region #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
' <div class="t-Region-header">',
'  <div class="t-Region-headerItems t-Region-headerItems--title">',
'    <span class="t-Region-headerIcon"><span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span></span>',
'    <h2 class="t-Region-title" id="#REGION_STATIC_ID#_heading" data-apex-heading>#TITLE#</h2>',
'  </div>',
'  <div class="t-Region-headerItems t-Region-headerItems--buttons">#COPY##EDIT#<span class="js-maximizeButtonContainer"></span></div>',
' </div>',
' <div class="t-Region-bodyWrap">',
'   <div class="t-Region-buttons t-Region-buttons--top">',
'    <div class="t-Region-buttons-left">#PREVIOUS#</div>',
'    <div class="t-Region-buttons-right">#NEXT#</div>',
'   </div>',
'   <div class="t-Region-body">',
'     #BODY#',
'     #SUB_REGIONS#',
'   </div>',
'   <div class="t-Region-buttons t-Region-buttons--bottom">',
'    <div class="t-Region-buttons-left">#CLOSE##HELP#</div>',
'    <div class="t-Region-buttons-right">#DELETE##CHANGE##CREATE#</div>',
'   </div>',
' </div>',
'</div>',
''))
,p_page_plug_template_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>8
,p_preset_template_options=>'t-Region--scrollBody'
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142768508310341501)
,p_plug_template_id=>wwv_flow_api.id(2623330321607852408)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142768637212341500)
,p_plug_template_id=>wwv_flow_api.id(2623330321607852408)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142768711187341500)
,p_plug_template_id=>wwv_flow_api.id(2623330321607852408)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142768849704341500)
,p_plug_template_id=>wwv_flow_api.id(2623330321607852408)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142768954626341500)
,p_plug_template_id=>wwv_flow_api.id(2623330321607852408)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142769034030341500)
,p_plug_template_id=>wwv_flow_api.id(2623330321607852408)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142769121231341500)
,p_plug_template_id=>wwv_flow_api.id(2623330321607852408)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142769263245341500)
,p_plug_template_id=>wwv_flow_api.id(2623330321607852408)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142769393872341500)
,p_plug_template_id=>wwv_flow_api.id(2623330321607852408)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(864307425592021306)
,p_plug_template_id=>wwv_flow_api.id(2623330321607852408)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(864307829600021306)
,p_plug_template_id=>wwv_flow_api.id(2623330321607852408)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/region/blank_with_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3052412050530173647)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="#REGION_CSS_CLASSES#">#PREVIOUS##BODY##SUB_REGIONS##NEXT#</div>'
,p_page_plug_template_name=>'Blank with Attributes'
,p_internal_name=>'BLANK_WITH_ATTRIBUTES'
,p_theme_id=>42
,p_theme_class_id=>7
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142738966042341537)
,p_plug_template_id=>wwv_flow_api.id(3052412050530173647)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142739018910341537)
,p_plug_template_id=>wwv_flow_api.id(3052412050530173647)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142739180787341537)
,p_plug_template_id=>wwv_flow_api.id(3052412050530173647)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(142739218263341537)
,p_plug_template_id=>wwv_flow_api.id(3052412050530173647)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/top_navigation_tabs
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(5429749254678674)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavTabs-item #A03# is-active" aria-current="page" id="#A01#">',
'  <a href="#LINK#" class="t-NavTabs-link #A04# " title="#TEXT_ESC_SC#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    <span class="t-NavTabs-label">#TEXT_ESC_SC#</span>',
'    <span class="t-NavTabs-badge #A05#">#A02#</span>',
'  </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavTabs-item #A03#" id="#A01#">',
'  <a href="#LINK#" class="t-NavTabs-link #A04# " title="#TEXT_ESC_SC#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    <span class="t-NavTabs-label">#TEXT_ESC_SC#</span>',
'    <span class="t-NavTabs-badge #A05#">#A02#</span>',
'  </a>',
'</li>'))
,p_list_template_name=>'Top Navigation Tabs'
,p_internal_name=>'TOP_NAVIGATION_TABS'
,p_theme_id=>42
,p_theme_class_id=>7
,p_preset_template_options=>'t-NavTabs--inlineLabels-lg:t-NavTabs--displayLabels-sm'
,p_list_template_before_rows=>'<ul class="t-NavTabs #COMPONENT_CSS_CLASSES#" id="#PARENT_STATIC_ID#_navtabs">'
,p_list_template_after_rows=>'</ul>'
,p_a01_label=>'List Item ID'
,p_a02_label=>'Badge Value'
,p_a03_label=>'List Item Class'
,p_a04_label=>'Link Class'
,p_a05_label=>'Badge Class'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/top_navigation_mega_menu
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(217865321596155171)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item t-MegaMenu-item--top t-MegaMenu-item--noSub is-active #A04#" data-current="true" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item t-MegaMenu-item--top t-MegaMenu-item--noSub #A04#" data-current="false" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>',
'</li>'))
,p_list_template_name=>'Top Navigation Mega Menu'
,p_internal_name=>'TOP_NAVIGATION_MEGA_MENU'
,p_theme_id=>42
,p_theme_class_id=>20
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-MegaMenu #COMPONENT_CSS_CLASSES#" id="t_MenuNav" style="display:none;">',
'  <div class="a-Menu-content t-MegaMenu-container">',
'    <div class="t-MegaMenu-body">',
'    <ul class="t-MegaMenu-list t-MegaMenu-list--top">'))
,p_list_template_after_rows=>' </ul></div></div></div>'
,p_before_sub_list=>'<ul class="t-MegaMenu-list t-MegaMenu-list--sub">'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item is-active #A04#" data-current="true" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item #A04#" data-current="false" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item t-MegaMenu-item--top t-MegaMenu-item--hasSub is-active #A04#" data-current="true" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item t-MegaMenu-item--top t-MegaMenu-item--hasSub #A04#" data-current="false" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>',
'</li>'))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item is-active #A04#" data-current="true" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>'))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item #A04#" data-current="false" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>'))
,p_a01_label=>'ID Attribute'
,p_a02_label=>'Badge Value'
,p_a03_label=>'Description'
,p_a04_label=>'List Item Class'
,p_a05_label=>'Shortcut Key'
,p_a06_label=>'Link Target'
,p_a07_label=>'Badge Class'
,p_a08_label=>'Menu Item Class'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(561120526789187584)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-WizardSteps-step is-active" aria-current="step" id="#LIST_ITEM_ID#">',
'  <div class="t-WizardSteps-wrap" data-link="#LINK#">',
'    <span class="t-WizardSteps-marker" aria-hidden="true"></span>',
'    <span class="t-WizardSteps-label">#TEXT# <span aria-hidden="true" class="t-WizardSteps-labelState"></span></span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-WizardSteps-step" id="#LIST_ITEM_ID#">',
'  <div class="t-WizardSteps-wrap" data-link="#LINK#">',
'    <span class="t-WizardSteps-marker" aria-hidden="true"></span>',
'    <span class="t-WizardSteps-label">#TEXT# <span aria-hidden="true" class="t-WizardSteps-labelState"></span></span>',
'  </div>',
'</li>'))
,p_list_template_name=>'Wizard Progress'
,p_internal_name=>'WIZARD_PROGRESS'
,p_javascript_code_onload=>'apex.theme.initWizardProgressBar();'
,p_theme_id=>42
,p_theme_class_id=>17
,p_preset_template_options=>'t-WizardSteps--displayLabels'
,p_list_template_before_rows=>'<ul aria-label="#CURRENT_PROGRESS#" class="t-WizardSteps #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/menu_bar
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(561127424267431983)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_list_template_name=>'Menu Bar'
,p_internal_name=>'MENU_BAR'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menubar", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup( e );',
'}',
'e.menu({',
'  behaveLikeTabs: e.hasClass("js-tabLike"),',
'  menubarShowSubMenuIcon: e.hasClass("js-showSubMenuIcons") || null,',
'  iconType: ''fa'',',
'  menubar: true,',
'  menubarOverflow: true,',
'  callout: e.hasClass("js-menu-callout")',
'});'))
,p_theme_id=>42
,p_theme_class_id=>20
,p_default_template_options=>'js-showSubMenuIcons'
,p_list_template_before_rows=>'<div class="t-MenuBar #COMPONENT_CSS_CLASSES#" id="#PARENT_STATIC_ID#_menubar"><ul style="display:none">'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_a01_label=>'Menu Item ID / Action Name'
,p_a02_label=>'Disabled (True/False)'
,p_a03_label=>'Hidden (True/False)'
,p_a04_label=>'Title Attribute (Used By Actions Only)'
,p_a05_label=>'Shortcut'
,p_a06_label=>'Link Target'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/badge_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(614901035349879760)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item #A02# is-current" aria-current="page">',
'  <a class="t-BadgeList-wrap u-color #A04#" href="#LINK#" #A03#>',
'    <span class="t-BadgeList-label">#TEXT#</span>',
'    <span class="t-BadgeList-value">#A01#</span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item #A02#">',
'  <a class="t-BadgeList-wrap u-color #A04#" href="#LINK#" #A03#>',
'    <span class="t-BadgeList-label">#TEXT#</span>',
'    <span class="t-BadgeList-value">#A01#</span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'Badge List'
,p_internal_name=>'BADGE_LIST'
,p_theme_id=>42
,p_theme_class_id=>3
,p_preset_template_options=>'t-BadgeList--large:t-BadgeList--cols t-BadgeList--3cols:t-BadgeList--circular'
,p_list_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_a01_label=>'Value'
,p_a02_label=>'List item CSS Classes'
,p_a03_label=>'Link Attributes'
,p_a04_label=>'Link Classes'
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'A01: Large Number',
'A02: List Item Classes',
'A03: Link Attributes'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(618966256865274517)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MediaList-item is-active #A04#" aria-current="page">',
'  <a href="#LINK#" class="t-MediaList-itemWrap #A05#" #A03#>',
'    <div class="t-MediaList-iconWrap" aria-hidden="true">',
'      <span class="t-MediaList-icon u-color #A06#"><span class="t-Icon #ICON_CSS_CLASSES#" #IMAGE_ATTR#></span></span>',
'    </div>',
'    <div class="t-MediaList-body">',
'      <h3 class="t-MediaList-title">#TEXT#</h3>',
'      <p class="t-MediaList-desc">#A01#</p>',
'    </div>',
'    <div class="t-MediaList-badgeWrap">',
'      <span class="t-MediaList-badge">#A02#</span>',
'    </div>',
'  </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MediaList-item  #A04#">',
'  <a href="#LINK#" class="t-MediaList-itemWrap #A05#" #A03#>',
'    <div class="t-MediaList-iconWrap" aria-hidden="true">',
'      <span class="t-MediaList-icon u-color #A06#"><span class="t-Icon #ICON_CSS_CLASSES#" #IMAGE_ATTR#></span></span>',
'    </div>',
'    <div class="t-MediaList-body">',
'      <h3 class="t-MediaList-title">#TEXT#</h3>',
'      <p class="t-MediaList-desc">#A01#</p>',
'    </div>',
'    <div class="t-MediaList-badgeWrap">',
'      <span class="t-MediaList-badge">#A02#</span>',
'    </div>',
'  </a>',
'</li>'))
,p_list_template_name=>'Media List'
,p_internal_name=>'MEDIA_LIST'
,p_theme_id=>42
,p_theme_class_id=>5
,p_default_template_options=>'t-MediaList--showIcons:t-MediaList--showDesc'
,p_list_template_before_rows=>'<ul class="t-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_a01_label=>'Description'
,p_a02_label=>'Badge Value'
,p_a03_label=>'Link Attributes'
,p_a04_label=>'List Item CSS Classes'
,p_a05_label=>'Link Class'
,p_a06_label=>'Icon Color Class'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/side_navigation_menu
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(1018710602436487872)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_list_template_name=>'Side Navigation Menu'
,p_internal_name=>'SIDE_NAVIGATION_MENU'
,p_javascript_file_urls=>'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.treeView#MIN#.js?v=#APEX_VERSION#'
,p_javascript_code_onload=>'apex.jQuery(''body'').addClass(''t-PageBody--leftNav'');'
,p_theme_id=>42
,p_theme_class_id=>19
,p_default_template_options=>'js-defaultCollapsed'
,p_preset_template_options=>'js-navCollapsed--hidden:t-TreeNav--styleA'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-nav" id="t_Body_nav" role="navigation" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL".">',
'  <div class="t-TreeNav #COMPONENT_CSS_CLASSES#" id="t_TreeNav" data-id="#PARENT_STATIC_ID#_tree" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL".">',
'    <ul style="display:none">',
''))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    </ul>',
'  </div>',
'</div>',
'<script>(sessionStorage.getItem("nav.&APP_ID..preferenceForExpanded") === "true" && window.matchMedia("(min-width: " + getComputedStyle(document.documentElement).getPropertyValue("--js-mq-lg") + ")").matches) && document.getElementById(''t_PageBody'').'
||'classList.add(''js-navExpanded'');</script>'))
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_a01_label=>'ID Attribute'
,p_a02_label=>'Disabled (True/False)'
,p_a04_label=>'Title Attribute (Used By Actions Only)'
,p_a05_label=>'Shortcut Key'
,p_a06_label=>'Link Target'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/top_navigation_menu
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(1077726089382032168)
,p_list_template_current=>'<li class="a-MenuBar-item a-Menu--current" data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a class="a-MenuBar-label" href="#LINK#" title="#A04#" target="#A06#">#TEXT_ES'
||'C_SC#</a></li>'
,p_list_template_noncurrent=>'<li class="a-MenuBar-item" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a class="a-MenuBar-label" href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_list_template_name=>'Top Navigation Menu'
,p_internal_name=>'TOP_NAVIGATION_MENU'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("#t_MenuNav", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup( e );',
'}',
'e.menu({',
'  behaveLikeTabs: e.hasClass("js-tabLike"),',
'  menubarShowSubMenuIcon: e.hasClass("js-showSubMenuIcons") || null,',
'  menubar: true,',
'  menubarOverflow: true,',
'  callout: e.hasClass("js-menu-callout")',
'});',
''))
,p_theme_id=>42
,p_theme_class_id=>20
,p_default_template_options=>'js-tabLike'
,p_list_template_before_rows=>'<div class="t-Header-nav-list #COMPONENT_CSS_CLASSES#" id="t_MenuNav"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul style="display: none">'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li class="a-MenuBar-item a-Menu--current" data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a class="a-MenuBar-label" href="#LINK#" title="#A04#" target="#A06#">#TEXT_ES'
||'C_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li class="a-MenuBar-item" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a class="a-MenuBar-label" href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_a01_label=>'Menu Item ID / Action Name'
,p_a02_label=>'Disabled (True/False)'
,p_a03_label=>'Hidden (True/False)'
,p_a04_label=>'Title Attribute (Used By Actions Only)'
,p_a05_label=>'Shortcut Key'
,p_a06_label=>'Link Target'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/navigation_bar
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(1398514441042912293)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item is-active #A02#" aria-current="page">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#" title="#A04#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true" #IMAGE_ATTR#></span><span class="t-Button-label">#TEXT_ESC_SC#</span><span class="t-Button-badge">#A01#</span>',
'  </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item #A02#">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#" title="#A04#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true" #IMAGE_ATTR#></span><span class="t-Button-label">#TEXT_ESC_SC#</span><span class="t-Button-badge">#A01#</span>',
'  </a>',
'</li>'))
,p_list_template_name=>'Navigation Bar'
,p_internal_name=>'NAVIGATION_BAR'
,p_theme_id=>42
,p_theme_class_id=>20
,p_list_template_before_rows=>'<ul class="t-NavigationBar #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<div class="t-NavigationBar-menu" style="display: none" id="menu_#PARENT_LIST_ITEM_ID#"><ul>'
,p_after_sub_list=>'</ul></div></li>'
,p_sub_list_item_current=>'<li data-current="true" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-current="false" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item is-active #A02#" aria-current="page">',
'  <button class="t-Button t-Button--icon t-Button t-Button--header t-Button--navBar js-menuButton" type="button" id="#LIST_ITEM_ID#" data-menu="menu_#LIST_ITEM_ID#" title="#A04#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true" #IMAGE_ATTR#></span><span class="t-Button-label">#TEXT_ESC_SC#</span><span class="t-Button-badge">#A01#</span><span class="a-Icon icon-down-arrow" aria-hidden="true"></span>',
'  </button>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item #A02#">',
'  <button class="t-Button t-Button--icon t-Button t-Button--header t-Button--navBar js-menuButton" type="button" id="#LIST_ITEM_ID#" data-menu="menu_#LIST_ITEM_ID#" title="#A04#">',
'      <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true" #IMAGE_ATTR#></span><span class="t-Button-label">#TEXT_ESC_SC#</span><span class="t-Button-badge">#A01#</span><span class="a-Icon icon-down-arrow" aria-hidden="true"></span>',
'  </button>'))
,p_sub_templ_curr_w_child=>'<li data-current="true" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_templ_noncurr_w_child=>'<li data-current="false" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_a01_label=>'Badge Value'
,p_a02_label=>'List  Item CSS Classes'
,p_a04_label=>'Title Attribute'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/cards
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(1437740873962425604)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Cards-item is-active #A04#" aria-current="page">',
'  <div class="t-Card">',
'    <a href="#LINK#" class="t-Card-wrap" #A05#>',
'      <div class="t-Card-icon u-color #A06#"><span class="t-Icon #ICON_CSS_CLASSES#"><span class="t-Card-initials" role="presentation">#A03#</span></span></div>',
'      <div class="t-Card-titleWrap">',
'        <h3 class="t-Card-title">#TEXT#</h3>',
'        <h4 class="t-Card-subtitle">#A07#</h4>',
'      </div>',
'      <div class="t-Card-body">',
'        <div class="t-Card-desc">#A01#</div>',
'        <div class="t-Card-info">#A02#</div>',
'      </div>',
'      <span class="t-Card-colorFill u-color #A06#" aria-hidden="true"></span>',
'    </a>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Cards-item #A04#">',
'  <div class="t-Card">',
'    <a href="#LINK#" class="t-Card-wrap" #A05#>',
'      <div class="t-Card-icon u-color #A06#"><span class="t-Icon #ICON_CSS_CLASSES#"><span class="t-Card-initials" role="presentation">#A03#</span></span></div>',
'      <div class="t-Card-titleWrap">',
'        <h3 class="t-Card-title">#TEXT#</h3>',
'        <h4 class="t-Card-subtitle">#A07#</h4>',
'      </div>',
'      <div class="t-Card-body">',
'        <div class="t-Card-desc">#A01#</div>',
'        <div class="t-Card-info">#A02#</div>',
'      </div>',
'      <span class="t-Card-colorFill u-color #A06#" aria-hidden="true"></span>',
'    </a>',
'  </div>',
'</li>'))
,p_list_template_name=>'Cards'
,p_internal_name=>'CARDS'
,p_theme_id=>42
,p_theme_class_id=>4
,p_preset_template_options=>'t-Cards--animColorFill:t-Cards--3cols:t-Cards--basic'
,p_list_template_before_rows=>'<ul class="t-Cards #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_a01_label=>'Description'
,p_a02_label=>'Secondary Information'
,p_a03_label=>'Initials'
,p_a04_label=>'List Item CSS Classes'
,p_a05_label=>'Link Attributes'
,p_a06_label=>'Card Color Class'
,p_a07_label=>'Subtitle'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/tabs
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(1840624874773603093)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Tabs-item is-active #A03#" aria-current="page" id="#A01#">',
'  <a href="#LINK#" class="t-Tabs-link #A04#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    <span class="t-Tabs-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Tabs-item #A03#" id="#A01#">',
'  <a href="#LINK#" class="t-Tabs-link #A04#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    <span class="t-Tabs-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_list_template_name=>'Tabs'
,p_internal_name=>'TABS'
,p_javascript_file_urls=>'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.apexTabs#MIN#.js?v=#APEX_VERSION#'
,p_theme_id=>42
,p_theme_class_id=>7
,p_preset_template_options=>'t-Tabs--simple'
,p_list_template_before_rows=>'<ul class="t-Tabs #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_a01_label=>'List Item ID'
,p_a03_label=>'List Item Class'
,p_a04_label=>'Link Class'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(2044682192514224742)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'Menu Popup'
,p_internal_name=>'MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup( e );',
'}',
'e.menu({ iconType: ''fa'', callout: e.hasClass("js-menu-callout")});'))
,p_theme_id=>42
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_a01_label=>'Menu Item ID / Action Name'
,p_a02_label=>'Disabled (True/False)'
,p_a03_label=>'Hidden (True/False)'
,p_a04_label=>'Title Attribute (Used By Actions Only)'
,p_a05_label=>'Shortcut'
,p_a06_label=>'Link Target'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(2623332529225852414)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="t-LinksList-link" #A02#>',
'    <span class="t-LinksList-icon" aria-hidden="true"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span>',
'    <span class="t-LinksList-label">#TEXT#</span>',
'    <span class="t-LinksList-badge">#A01#</span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-LinksList-item #A03#">',
'  <a href="#LINK#" class="t-LinksList-link" #A02#>',
'    <span class="t-LinksList-icon" aria-hidden="true"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span>',
'    <span class="t-LinksList-label">#TEXT#</span>',
'    <span class="t-LinksList-badge">#A01#</span>',
'  </a>',
'</li>'))
,p_list_template_name=>'Links List'
,p_internal_name=>'LINKS_LIST'
,p_theme_id=>42
,p_theme_class_id=>18
,p_list_template_before_rows=>'<ul class="t-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul class="t-LinksList-list">'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="t-LinksList-link" #A02#>',
'    <span class="t-LinksList-icon" aria-hidden="true"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span>',
'    <span class="t-LinksList-label">#TEXT#</span>',
'    <span class="t-LinksList-badge">#A01#</span>',
'  </a>',
'</li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-LinksList-item #A03#">',
'  <a href="#LINK#" class="t-LinksList-link" #A02#>',
'    <span class="t-LinksList-icon" aria-hidden="true"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span>',
'    <span class="t-LinksList-label">#TEXT#</span>',
'    <span class="t-LinksList-badge">#A01#</span>',
'  </a>',
'</li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="t-LinksList-link" #A02#>',
'    <span class="t-LinksList-icon" aria-hidden="true"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span>',
'    <span class="t-LinksList-label">#TEXT#</span>',
'    <span class="t-LinksList-badge">#A01#</span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-LinksList-item #A03#">',
'  <a href="#LINK#" class="t-LinksList-link" #A02#>',
'    <span class="t-LinksList-icon" aria-hidden="true"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span>',
'    <span class="t-LinksList-label">#TEXT#</span>',
'    <span class="t-LinksList-badge">#A01#</span>',
'  </a>',
'</li>'))
,p_a01_label=>'Badge Value'
,p_a02_label=>'Link Attributes'
,p_a03_label=>'List Item CSS Classes'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/timeline
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(65791776421862960)
,p_row_template_name=>'Timeline'
,p_internal_name=>'TIMELINE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Timeline-item #EVENT_MODIFIERS#" #EVENT_ATTRIBUTES#>',
'  <div class="t-Timeline-wrap">',
'    <div class="t-Timeline-user">',
'      <div class="t-Timeline-avatar #USER_COLOR#" role="presentation">',
'        #USER_AVATAR#',
'      </div>',
'      <div class="t-Timeline-userinfo">',
'        <span class="t-Timeline-username">#USER_NAME#</span>',
'        <span class="t-Timeline-date">#EVENT_DATE#</span>',
'      </div>',
'    </div>',
'    <div class="t-Timeline-content">',
'      <div class="t-Timeline-typeWrap">',
'        <div class="t-Timeline-type #EVENT_STATUS#">',
'          <span class="t-Icon #EVENT_ICON#"></span>',
'          <span class="t-Timeline-typename">#EVENT_TYPE#</span>',
'        </div>',
'      </div>',
'      <div class="t-Timeline-body">',
'        <h3 class="t-Timeline-title">#EVENT_TITLE#</h3>',
'        <p class="t-Timeline-desc">#EVENT_DESC#</p>',
'      </div>',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':EVENT_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Timeline-item #EVENT_MODIFIERS#" #EVENT_ATTRIBUTES#>',
'  <a href="#EVENT_LINK#" class="t-Timeline-wrap">',
'    <div class="t-Timeline-user">',
'      <div class="t-Timeline-avatar #USER_COLOR#" role="presentation">',
'        #USER_AVATAR#',
'      </div>',
'      <div class="t-Timeline-userinfo">',
'        <span class="t-Timeline-username">#USER_NAME#</span>',
'        <span class="t-Timeline-date">#EVENT_DATE#</span>',
'      </div>',
'    </div>',
'    <div class="t-Timeline-content">',
'      <div class="t-Timeline-typeWrap">',
'        <div class="t-Timeline-type #EVENT_STATUS#">',
'          <span class="t-Icon #EVENT_ICON#"></span>',
'          <span class="t-Timeline-typename">#EVENT_TYPE#</span>',
'        </div>',
'      </div>',
'      <div class="t-Timeline-body">',
'        <h3 class="t-Timeline-title">#EVENT_TITLE#</h3>',
'        <p class="t-Timeline-desc">#EVENT_DESC#</p>',
'      </div>',
'    </div>',
'  </a>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-Timeline #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_timeline" data-region-id="#REGION_STATIC_ID#">',
''))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>7
);
end;
/
prompt --application/shared_components/user_interface/templates/report/content_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(350261643030073247)
,p_row_template_name=>'Content Row'
,p_internal_name=>'CONTENT_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-ContentRow-item #ITEM_CLASSES#">',
'  <div class="t-ContentRow-wrap">',
'    <div class="t-ContentRow-selection">#SELECTION#</div>',
'    <div class="t-ContentRow-iconWrap">',
'      <span class="t-ContentRow-icon #ICON_CLASS#">#ICON_HTML#</span>',
'    </div>',
'    <div class="t-ContentRow-body">',
'      <div class="t-ContentRow-content">',
'        <h3 class="t-ContentRow-title">#TITLE#</h3>',
'        <div class="t-ContentRow-description">#DESCRIPTION#</div>',
'      </div>',
'      <div class="t-ContentRow-misc">#MISC#</div>',
'      <div class="t-ContentRow-actions">#ACTIONS#</div>',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-ContentRow #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_report" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>4
);
end;
/
prompt --application/shared_components/user_interface/templates/report/media_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(644575648490092151)
,p_row_template_name=>'Media List'
,p_internal_name=>'MEDIA_LIST'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MediaList-item #LIST_CLASS#">',
'  <a href="#LINK#" class="t-MediaList-itemWrap #LINK_CLASS#" #LINK_ATTR#>',
'    <div class="t-MediaList-iconWrap" aria-hidden"true">',
'      <span class="t-MediaList-icon u-color #ICON_COLOR_CLASS#"><span class="t-Icon #ICON_CLASS#"></span></span>',
'    </div>',
'    <div class="t-MediaList-body">',
'      <h3 class="t-MediaList-title">#LIST_TITLE#</h3>',
'      <p class="t-MediaList-desc">#LIST_TEXT#</p>',
'    </div>',
'    <div class="t-MediaList-badgeWrap">',
'      <span class="t-MediaList-badge">#LIST_BADGE#</span>',
'    </div>',
'  </a>',
'</li>',
''))
,p_row_template_condition1=>':LINK is not null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MediaList-item #LIST_CLASS#">',
'  <div class="t-MediaList-itemWrap #LINK_CLASS#" #LINK_ATTR#>',
'    <div class="t-MediaList-iconWrap" aria-hidden"true">',
'      <span class="t-MediaList-icon u-color #ICON_COLOR_CLASS#"><span class="t-Icon #ICON_CLASS#"></span></span>',
'    </div>',
'    <div class="t-MediaList-body">',
'      <h3 class="t-MediaList-title">#LIST_TITLE#</h3>',
'      <p class="t-MediaList-desc">#LIST_TEXT#</p>',
'    </div>',
'    <div class="t-MediaList-badgeWrap">',
'      <span class="t-MediaList-badge">#LIST_BADGE#</span>',
'    </div>',
'  </div>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="t-MediaList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_report" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>1
,p_default_template_options=>'t-MediaList--showDesc:t-MediaList--showIcons'
,p_preset_template_options=>'t-MediaList--stack'
,p_row_template_comment=>' (SELECT link_text, link_target, detail1, detail2, last_modified)'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/value_attribute_pairs_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(651486509760474849)
,p_row_template_name=>'Value Attribute Pairs - Row'
,p_internal_name=>'VALUE_ATTRIBUTE_PAIRS_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dt class="t-AVPList-label">',
'  #1#',
'</dt>',
'<dd class="t-AVPList-value">',
'  #2#',
'</dd>'))
,p_row_template_before_rows=>'<dl class="t-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="report_#REGION_STATIC_ID#" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</dl>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>7
,p_preset_template_options=>'t-AVPList--leftAligned'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/value_attribute_pairs_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(651486824354474850)
,p_row_template_name=>'Value Attribute Pairs - Column'
,p_internal_name=>'VALUE_ATTRIBUTE_PAIRS_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dt class="t-AVPList-label">',
'  #COLUMN_HEADER#',
'</dt>',
'<dd class="t-AVPList-value">',
'  #COLUMN_VALUE#',
'</dd>'))
,p_row_template_before_rows=>'<dl class="t-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</dl>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>6
,p_preset_template_options=>'t-AVPList--leftAligned'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/badge_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(655615347857707855)
,p_row_template_name=>'Badge List'
,p_internal_name=>'BADGE_LIST'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-wrap u-color">',
'    <span class="t-BadgeList-label">#COLUMN_HEADER#</span>',
'    <span class="t-BadgeList-value">#COLUMN_VALUE#</span>',
'  </span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>6
,p_preset_template_options=>'t-BadgeList--large:t-BadgeList--fixed:t-BadgeList--circular'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/contextual_info
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(666744069198116681)
,p_row_template_name=>'Contextual Info'
,p_internal_name=>'CONTEXTUAL_INFO'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ContextualInfo-item">',
'  <span class="t-ContextualInfo-label">#COLUMN_HEADER#</span>',
'  <span class="t-ContextualInfo-value">#COLUMN_VALUE#</span>',
'</div>'))
,p_row_template_before_rows=>' <div class="t-ContextualInfo #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES# data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</div>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>6
);
end;
/
prompt --application/shared_components/user_interface/templates/report/standard
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1089625725920080767)
,p_row_template_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_row_template1=>'<td class="t-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES# data-region-id="#REGION_STATIC_ID#">',
'  <div class="t-Report-wrap">',
'    <table class="t-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="t-Report-tableWrap">',
'    <table class="t-Report-report" id="report_table_#REGION_STATIC_ID#" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="t-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="t-Report-pagination t-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="t-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</thead>',
'<tbody>'))
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>4
,p_preset_template_options=>'t-Report--altRowsDefault:t-Report--rowHighlight'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/comments
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1164140200812557328)
,p_row_template_name=>'Comments'
,p_internal_name=>'COMMENTS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Comments-item #COMMENT_MODIFIERS#">',
'  <div class="t-Comments-icon">',
'    <div class="t-Comments-userIcon #ICON_MODIFIER#" aria-hidden="true">#USER_ICON#</div>',
'  </div>',
'  <div class="t-Comments-body">',
'    <div class="t-Comments-info">',
'      #USER_NAME# <span class="t-Comments-date">#COMMENT_DATE#</span> <span class="t-Comments-actions">#ACTIONS#</span>',
'    </div>',
'    <div class="t-Comments-comment">',
'      #COMMENT_TEXT##ATTRIBUTE_1##ATTRIBUTE_2##ATTRIBUTE_3##ATTRIBUTE_4#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-Comments #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_report" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>',
''))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>7
,p_preset_template_options=>'t-Comments--chat'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/alerts
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1433874327034140123)
,p_row_template_name=>'Alerts'
,p_internal_name=>'ALERTS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--horizontal t-Alert--colorBG t-Alert--defaultIcons t-Alert--#ALERT_TYPE#" role="alert">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon" aria-hidden="true"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-header">',
'        <h2 class="t-Alert-title">#ALERT_TITLE#</h2>',
'      </div>',
'      <div class="t-Alert-body">',
'        #ALERT_DESC#',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      #ALERT_ACTION#',
'    </div>',
'  </div>',
'</div>'))
,p_row_template_before_rows=>'<div class="t-Alerts #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_alerts" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</div>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>14
);
end;
/
prompt --application/shared_components/user_interface/templates/report/cards
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1525953837592492828)
,p_row_template_name=>'Cards'
,p_internal_name=>'CARDS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Cards-item #CARD_MODIFIERS#">',
'  <div class="t-Card">',
'    <a href="#CARD_LINK#" class="t-Card-wrap">',
'      <div class="t-Card-icon u-color #CARD_COLOR#"><span class="t-Icon fa #CARD_ICON#"><span class="t-Card-initials" role="presentation">#CARD_INITIALS#</span></span></div>',
'      <div class="t-Card-titleWrap"><h3 class="t-Card-title">#CARD_TITLE#</h3><h4 class="t-Card-subtitle">#CARD_SUBTITLE#</h4></div>',
'      <div class="t-Card-body">',
'        <div class="t-Card-desc">#CARD_TEXT#</div>',
'        <div class="t-Card-info">#CARD_SUBTEXT#</div>',
'      </div>',
'      <span class="t-Card-colorFill u-color #CARD_COLOR#"></span>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is not null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Cards-item #CARD_MODIFIERS#">',
'  <div class="t-Card">',
'    <div class="t-Card-wrap">',
'      <div class="t-Card-icon u-color #CARD_COLOR#"><span class="t-Icon fa #CARD_ICON#"><span class="t-Card-initials" role="presentation">#CARD_INITIALS#</span></span></div>',
'      <div class="t-Card-titleWrap"><h3 class="t-Card-title">#CARD_TITLE#</h3><h4 class="t-Card-subtitle">#CARD_SUBTITLE#</h4></div>',
'      <div class="t-Card-body">',
'        <div class="t-Card-desc">#CARD_TEXT#</div>',
'        <div class="t-Card-info">#CARD_SUBTEXT#</div>',
'      </div>',
'      <span class="t-Card-colorFill u-color #CARD_COLOR#"></span>',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-Cards #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_cards" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>7
,p_preset_template_options=>'t-Cards--animColorFill:t-Cards--3cols:t-Cards--basic'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/search_results
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(2623331619605852412)
,p_row_template_name=>'Search Results'
,p_internal_name=>'SEARCH_RESULTS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-SearchResults-item">',
'    <h3 class="t-SearchResults-title"><a href="#SEARCH_LINK#">#SEARCH_TITLE#</a></h3>',
'    <div class="t-SearchResults-info">',
'      <p class="t-SearchResults-desc">#SEARCH_DESC#</p>',
'      <span class="t-SearchResults-misc">#LABEL_01#: #VALUE_01#</span>',
'    </div>',
'  </li>'))
,p_row_template_condition1=>':LABEL_02 is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-SearchResults-item">',
'    <h3 class="t-SearchResults-title"><a href="#SEARCH_LINK#">#SEARCH_TITLE#</a></h3>',
'    <div class="t-SearchResults-info">',
'      <p class="t-SearchResults-desc">#SEARCH_DESC#</p>',
'      <span class="t-SearchResults-misc">#LABEL_01#: #VALUE_01#</span>',
'      <span class="t-SearchResults-misc">#LABEL_02#: #VALUE_02#</span>',
'    </div>',
'  </li>'))
,p_row_template_condition2=>':LABEL_03 is null'
,p_row_template3=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-SearchResults-item">',
'    <h3 class="t-SearchResults-title"><a href="#SEARCH_LINK#">#SEARCH_TITLE#</a></h3>',
'    <div class="t-SearchResults-info">',
'      <p class="t-SearchResults-desc">#SEARCH_DESC#</p>',
'      <span class="t-SearchResults-misc">#LABEL_01#: #VALUE_01#</span>',
'      <span class="t-SearchResults-misc">#LABEL_02#: #VALUE_02#</span>',
'      <span class="t-SearchResults-misc">#LABEL_03#: #VALUE_03#</span>',
'    </div>',
'  </li>'))
,p_row_template_condition3=>':LABEL_04 is null'
,p_row_template4=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-SearchResults-item">',
'    <h3 class="t-SearchResults-title"><a href="#SEARCH_LINK#">#SEARCH_TITLE#</a></h3>',
'    <div class="t-SearchResults-info">',
'      <p class="t-SearchResults-desc">#SEARCH_DESC#</p>',
'      <span class="t-SearchResults-misc">#LABEL_01#: #VALUE_01#</span>',
'      <span class="t-SearchResults-misc">#LABEL_02#: #VALUE_02#</span>',
'      <span class="t-SearchResults-misc">#LABEL_03#: #VALUE_03#</span>',
'      <span class="t-SearchResults-misc">#LABEL_04#: #VALUE_04#</span>',
'    </div>',
'  </li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-SearchResults #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_report" data-region-id="#REGION_STATIC_ID#">',
'<ul class="t-SearchResults-list">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>',
'</div>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>1
,p_row_template_comment=>' (SELECT link_text, link_target, detail1, detail2, last_modified)'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional_floating
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(160093352808944961)
,p_template_name=>'Optional - Floating'
,p_internal_name=>'OPTIONAL_FLOATING'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer t-Form-fieldContainer--floatingLabel #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>'<div class="t-Form-inputContainer"><div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'
,p_after_element=>'#ITEM_POST_TEXT##HELP_TEMPLATE#</div>#INLINE_HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<span class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</span>'
,p_error_template=>'<span class="t-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>42
,p_theme_class_id=>3
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/required_floating
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(160093532401945979)
,p_template_name=>'Required - Floating'
,p_internal_name=>'REQUIRED_FLOATING'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer">',
'  <label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer t-Form-fieldContainer--floatingLabel is-required #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-inputContainer">',
'  <div class="t-Form-itemRequired-marker" aria-hidden="true"></div>',
'  <div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'))
,p_after_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#ITEM_POST_TEXT##HELP_TEMPLATE#',
'  </div>',
'  <div class="t-Form-itemAssistance">',
'    #ERROR_TEMPLATE#',
'    <div class="t-Form-itemRequired" aria-hidden="true">#REQUIRED#</div>',
'  </div>',
'  #INLINE_HELP_TEMPLATE#',
'</div>'))
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<div class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</div>'
,p_error_template=>'<div class="t-Form-error">#ERROR_MESSAGE#</div>'
,p_theme_id=>42
,p_theme_class_id=>4
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(591757292230152601)
,p_template_name=>'Hidden'
,p_internal_name=>'HIDDEN'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer t-Form-labelContainer--hiddenLabel col col-#LABEL_COLUMN_SPAN_NUMBER#">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label u-VisuallyHidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer t-Form-fieldContainer--hiddenLabel rel-col #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>'<div class="t-Form-inputContainer col col-#ITEM_COLUMN_SPAN_NUMBER#"><div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'
,p_after_element=>'#ITEM_POST_TEXT##HELP_TEMPLATE#</div>#INLINE_HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<span class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</span>'
,p_error_template=>'<span class="t-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>42
,p_theme_class_id=>13
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(869572400154599626)
,p_template_name=>'Optional'
,p_internal_name=>'OPTIONAL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer col col-#LABEL_COLUMN_SPAN_NUMBER#">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>',
''))
,p_before_item=>'<div class="t-Form-fieldContainer rel-col #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>'<div class="t-Form-inputContainer col col-#ITEM_COLUMN_SPAN_NUMBER#"><div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'
,p_after_element=>'#ITEM_POST_TEXT##HELP_TEMPLATE#</div>#INLINE_HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<span class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</span>'
,p_error_template=>'<span class="t-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>42
,p_theme_class_id=>3
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/required
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1077732000333505897)
,p_template_name=>'Required'
,p_internal_name=>'REQUIRED'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer col col-#LABEL_COLUMN_SPAN_NUMBER#">',
'  <label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer is-required rel-col #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-inputContainer col col-#ITEM_COLUMN_SPAN_NUMBER#">',
'  <div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'))
,p_after_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#ITEM_POST_TEXT##HELP_TEMPLATE#',
'  </div>',
'  <div class="t-Form-itemAssistance">',
'    #ERROR_TEMPLATE#',
'    <div class="t-Form-itemRequired" aria-hidden="true">#REQUIRED#</div>',
'  </div>',
'  #INLINE_HELP_TEMPLATE#',
'</div>'))
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<div class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</div>'
,p_error_template=>'<div class="t-Form-error">#ERROR_MESSAGE#</div>'
,p_theme_id=>42
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1582533052086761500)
,p_template_name=>'Optional - Above'
,p_internal_name=>'OPTIONAL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer t-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>'<div class="t-Form-inputContainer"><div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'
,p_after_element=>'#ITEM_POST_TEXT#</div>#INLINE_HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<span class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</span>'
,p_error_template=>'<span class="t-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>42
,p_theme_class_id=>3
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/required_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1582533317526763209)
,p_template_name=>'Required - Above'
,p_internal_name=>'REQUIRED_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer">',
'  <label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label> #HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer t-Form-fieldContainer--stacked is-required #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-inputContainer">',
'  <div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'))
,p_after_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#ITEM_POST_TEXT##HELP_TEMPLATE#',
'  </div>',
'  <div class="t-Form-itemAssistance">',
'    #ERROR_TEMPLATE#',
'    <div class="t-Form-itemRequired" aria-hidden="true">#REQUIRED#</div>',
'  </div>',
'  #INLINE_HELP_TEMPLATE#',
'</div>'))
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<div class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</div>'
,p_error_template=>'<div class="t-Form-error">#ERROR_MESSAGE#</div>'
,p_theme_id=>42
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumb
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(2623334730651852421)
,p_name=>'Breadcrumb'
,p_internal_name=>'BREADCRUMB'
,p_before_first=>'<ul class="t-Breadcrumb #COMPONENT_CSS_CLASSES#">'
,p_current_page_option=>'<li class="t-Breadcrumb-item is-active" aria-current="page"><h1 class="t-Breadcrumb-label">#NAME#</h1></li>'
,p_non_current_page_option=>'<li class="t-Breadcrumb-item"><a href="#LINK#" class="t-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>42
,p_theme_class_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(1437816705917664972)
,p_page_name=>'winlov'
,p_page_title=>'Search Dialog'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#THEME_STYLE_CSS#',
'#FAVICONS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="t-Page t-Page--popupLOV"'
,p_before_field_text=>'<div class="t-PopupLOV-actions t-Form--large">'
,p_filter_width=>'20'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="apex-item-text"'
,p_find_button_text=>'Search'
,p_find_button_attr=>'class="t-Button t-Button--hot t-Button--padLeft"'
,p_close_button_text=>'Close'
,p_close_button_attr=>'class="t-Button u-pullRight"'
,p_next_button_text=>'Next &gt;'
,p_next_button_attr=>'class="t-Button t-PopupLOV-button"'
,p_prev_button_text=>'&lt; Previous'
,p_prev_button_attr=>'class="t-Button t-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_result_row_x_of_y=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>100
,p_before_result_set=>'<div class="t-PopupLOV-links">'
,p_theme_id=>42
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(2623334936060852422)
,p_cal_template_name=>'Calendar'
,p_internal_name=>'CALENDAR'
,p_day_of_week_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<th id="#DY#" scope="col" class="t-ClassicCalendar-dayColumn">',
'  <span class="visible-md visible-lg">#IDAY#</span>',
'  <span class="hidden-md hidden-lg">#IDY#</span>',
'</th>'))
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar">',
'<h1 class="t-ClassicCalendar-title">#IMONTH# #YYYY#</h1>'))
,p_month_open_format=>'<table class="t-ClassicCalendar-calendar" cellpadding="0" cellspacing="0" border="0" aria-label="#IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'</div>',
''))
,p_day_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_day_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#">#TITLE_FORMAT#<div class="t-ClassicCalendar-dayEvents">#DATA#</div>'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="t-ClassicCalendar-day is-today" headers="#DY#">#TITLE_FORMAT#<div class="t-ClassicCalendar-dayEvents">#DATA#</div>'
,p_weekend_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_weekend_open_format=>'<td class="t-ClassicCalendar-day is-weekend" headers="#DY#">#TITLE_FORMAT#<div class="t-ClassicCalendar-dayEvents">#DATA#</div>'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_nonday_open_format=>'<td class="t-ClassicCalendar-day is-inactive" headers="#DY#">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar t-ClassicCalendar--weekly">',
'<h1 class="t-ClassicCalendar-title">#WTITLE#</h1>'))
,p_weekly_day_of_week_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<th scope="col" class="t-ClassicCalendar-dayColumn" id="#DY#">',
'  <span class="visible-md visible-lg">#DD# #IDAY#</span>',
'  <span class="hidden-md hidden-lg">#DD# #IDY#</span>',
'</th>'))
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" aria-label="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t-ClassicCalendar-calendar">'
,p_weekly_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'</div>'))
,p_weekly_day_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_weekly_day_close_format=>'</div></td>'
,p_weekly_today_open_format=>'<td class="t-ClassicCalendar-day is-today" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_weekly_weekend_open_format=>'<td class="t-ClassicCalendar-day is-weekend" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_weekly_weekend_close_format=>'</div></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t-ClassicCalendar-day t-ClassicCalendar-timeCol">'
,p_weekly_time_close_format=>'</th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" id="#DY#" class="t-ClassicCalendar-dayColumn">#IDAY#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar t-ClassicCalendar--daily">',
'<h1 class="t-ClassicCalendar-title">#IMONTH# #DD#, #YYYY#</h1>'))
,p_daily_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" aria-label="#CALENDAR_TITLE# #START_DL#" class="t-ClassicCalendar-calendar">'
,p_daily_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'</div>'))
,p_daily_day_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_daily_day_close_format=>'</div></td>'
,p_daily_today_open_format=>'<td class="t-ClassicCalendar-day is-today" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_daily_time_open_format=>'<th scope="row" class="t-ClassicCalendar-day t-ClassicCalendar-timeCol" id="#TIME#">'
,p_daily_time_close_format=>'</th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_cust_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar">',
'<h1 class="t-ClassicCalendar-title">#IMONTH# #YYYY#</h1>'))
,p_cust_day_of_week_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<th id="#DY#" scope="col" class="t-ClassicCalendar-dayColumn">',
'  <span class="visible-md visible-lg">#IDAY#</span>',
'  <span class="hidden-md hidden-lg">#IDY#</span>',
'</th>'))
,p_cust_month_open_format=>'<table class="t-ClassicCalendar-calendar" cellpadding="0" cellspacing="0" border="0" aria-label="#IMONTH# #YYYY#">'
,p_cust_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'</div>'))
,p_cust_week_open_format=>'<tr>'
,p_cust_week_close_format=>'</tr> '
,p_cust_day_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_cust_day_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#">'
,p_cust_day_close_format=>'</td>'
,p_cust_today_open_format=>'<td class="t-ClassicCalendar-day is-today" headers="#DY#">'
,p_cust_nonday_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_cust_nonday_open_format=>'<td class="t-ClassicCalendar-day is-inactive" headers="#DY#">'
,p_cust_nonday_close_format=>'</td>'
,p_cust_weekend_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_cust_weekend_open_format=>'<td class="t-ClassicCalendar-day is-weekend" headers="#DY#">'
,p_cust_weekend_close_format=>'</td>'
,p_cust_hour_open_format=>'<tr>'
,p_cust_hour_close_format=>'</tr>'
,p_cust_time_title_format=>'#TIME#'
,p_cust_time_open_format=>'<th scope="row" class="t-ClassicCalendar-day t-ClassicCalendar-timeCol">'
,p_cust_time_close_format=>'</th>'
,p_cust_wk_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar">',
'<h1 class="t-ClassicCalendar-title">#WTITLE#</h1>'))
,p_cust_wk_day_of_week_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<th scope="col" class="t-ClassicCalendar-dayColumn" id="#DY#">',
'  <span class="visible-md visible-lg">#DD# #IDAY#</span>',
'  <span class="hidden-md hidden-lg">#DD# #IDY#</span>',
'</th>'))
,p_cust_wk_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t-ClassicCalendar-calendar">'
,p_cust_wk_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'</div>'))
,p_cust_wk_week_open_format=>'<tr>'
,p_cust_wk_week_close_format=>'</tr> '
,p_cust_wk_day_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_cust_wk_day_close_format=>'</div></td>'
,p_cust_wk_today_open_format=>'<td class="t-ClassicCalendar-day is-today" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_cust_wk_weekend_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#">'
,p_cust_wk_weekend_close_format=>'</td>'
,p_agenda_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar t-ClassicCalendar--list">',
'  <div class="t-ClassicCalendar-title">#IMONTH# #YYYY#</div>',
'  <ul class="t-ClassicCalendar-list">',
'    #DAYS#',
'  </ul>',
'</div>'))
,p_agenda_past_day_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-ClassicCalendar-listTitle is-past">',
'    <span class="t-ClassicCalendar-listDayTitle">#IDAY#</span><span class="t-ClassicCalendar-listDayDate">#IMONTH# #DD#</span>',
'  </li>'))
,p_agenda_today_day_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-ClassicCalendar-listTitle is-today">',
'    <span class="t-ClassicCalendar-listDayTitle">#IDAY#</span><span class="t-ClassicCalendar-listDayDate">#IMONTH# #DD#</span>',
'  </li>'))
,p_agenda_future_day_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-ClassicCalendar-listTitle is-future">',
'    <span class="t-ClassicCalendar-listDayTitle">#IDAY#</span><span class="t-ClassicCalendar-listDayDate">#IMONTH# #DD#</span>',
'  </li>'))
,p_agenda_past_entry_format=>'  <li class="t-ClassicCalendar-listEvent is-past">#DATA#</li>'
,p_agenda_today_entry_format=>'  <li class="t-ClassicCalendar-listEvent is-today">#DATA#</li>'
,p_agenda_future_entry_format=>'  <li class="t-ClassicCalendar-listEvent is-future">#DATA#</li>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'<span class="t-ClassicCalendar-event">#DATA#</span>'
,p_theme_id=>42
,p_theme_class_id=>1
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
wwv_flow_api.create_theme(
 p_id=>wwv_flow_api.id(2623335322494852446)
,p_theme_id=>42
,p_theme_name=>'Universal Theme'
,p_theme_internal_name=>'UNIVERSAL_THEME'
,p_ui_type_name=>'DESKTOP'
,p_navigation_type=>'L'
,p_nav_bar_type=>'LIST'
,p_is_locked=>false
,p_default_page_template=>wwv_flow_api.id(2623327345562852400)
,p_default_dialog_template=>wwv_flow_api.id(651378991620880020)
,p_error_template=>wwv_flow_api.id(652129338145143712)
,p_printer_friendly_template=>wwv_flow_api.id(2623327345562852400)
,p_breadcrumb_display_point=>'REGION_POSITION_01'
,p_sidebar_display_point=>'REGION_POSITION_02'
,p_login_template=>wwv_flow_api.id(652129338145143712)
,p_default_button_template=>wwv_flow_api.id(2623334346116852418)
,p_default_region_template=>wwv_flow_api.id(2623330321607852408)
,p_default_chart_template=>wwv_flow_api.id(2623330321607852408)
,p_default_form_template=>wwv_flow_api.id(2623330321607852408)
,p_default_reportr_template=>wwv_flow_api.id(2623330321607852408)
,p_default_tabform_template=>wwv_flow_api.id(2623330321607852408)
,p_default_wizard_template=>wwv_flow_api.id(2623330321607852408)
,p_default_menur_template=>wwv_flow_api.id(1082434711915925186)
,p_default_listr_template=>wwv_flow_api.id(2623330321607852408)
,p_default_irr_template=>wwv_flow_api.id(651498026300583706)
,p_default_report_template=>wwv_flow_api.id(1089625725920080767)
,p_default_label_template=>wwv_flow_api.id(160093352808944961)
,p_default_menu_template=>wwv_flow_api.id(2623334730651852421)
,p_default_calendar_template=>wwv_flow_api.id(2623334936060852422)
,p_default_list_template=>wwv_flow_api.id(2623332529225852414)
,p_default_nav_list_template=>wwv_flow_api.id(1077726089382032168)
,p_default_top_nav_list_temp=>wwv_flow_api.id(1077726089382032168)
,p_default_side_nav_list_temp=>wwv_flow_api.id(1018710602436487872)
,p_default_nav_list_position=>'SIDE'
,p_default_dialogbtnr_template=>wwv_flow_api.id(677400524731372757)
,p_default_dialogr_template=>wwv_flow_api.id(3052412050530173647)
,p_default_option_label=>wwv_flow_api.id(160093352808944961)
,p_default_required_label=>wwv_flow_api.id(160093532401945979)
,p_default_page_transition=>'NONE'
,p_default_popup_transition=>'NONE'
,p_default_navbar_list_template=>wwv_flow_api.id(1398514441042912293)
,p_file_prefix => nvl(wwv_flow_application_install.get_static_theme_file_prefix(42),'#IMAGE_PREFIX#themes/theme_42/21.2/')
,p_files_version=>64
,p_icon_library=>'FONTAPEX'
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.stickyWidget#MIN#.js?v=#APEX_VERSION#',
'#THEME_IMAGES#js/theme42#MIN#.js?v=#APEX_VERSION#'))
,p_css_file_urls=>'#THEME_IMAGES#css/Core#MIN#.css?v=#APEX_VERSION#'
);
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(490875900505711269)
,p_theme_id=>42
,p_name=>'Vita - Red'
,p_is_current=>false
,p_is_public=>true
,p_is_accessible=>false
,p_theme_roller_input_file_urls=>'#THEME_IMAGES#less/theme/Vita-Red.less'
,p_theme_roller_output_file_url=>'#THEME_IMAGES#css/Vita-Red#MIN#.css?v=#APEX_VERSION#'
,p_theme_roller_read_only=>true
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(1148844624906858585)
,p_theme_id=>42
,p_name=>'Redwood Light'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/oracle-fonts/oraclesans-apex#MIN#.css?v=#APEX_VERSION#',
'#THEME_IMAGES#css/Redwood#MIN#.css?v=#APEX_VERSION#'))
,p_is_current=>false
,p_is_public=>true
,p_is_accessible=>false
,p_theme_roller_input_file_urls=>'#THEME_IMAGES#less/theme/Redwood-Theme.less'
,p_theme_roller_output_file_url=>'#THEME_IMAGES#css/Redwood-Theme#MIN#.css?v=#APEX_VERSION#'
,p_theme_roller_read_only=>true
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(1272293502653387589)
,p_theme_id=>42
,p_name=>'Vita'
,p_is_current=>true
,p_is_public=>true
,p_is_accessible=>true
,p_theme_roller_input_file_urls=>'#THEME_IMAGES#less/theme/Vita.less'
,p_theme_roller_output_file_url=>'#THEME_IMAGES#css/Vita#MIN#.css?v=#APEX_VERSION#'
,p_theme_roller_read_only=>true
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(1844401536064988062)
,p_theme_id=>42
,p_name=>'Vita - Slate'
,p_is_current=>false
,p_is_public=>true
,p_is_accessible=>false
,p_theme_roller_input_file_urls=>'#THEME_IMAGES#less/theme/Vita-Slate.less'
,p_theme_roller_output_file_url=>'#THEME_IMAGES#css/Vita-Slate#MIN#.css?v=#APEX_VERSION#'
,p_theme_roller_read_only=>true
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(2095766600097112746)
,p_theme_id=>42
,p_name=>'Vita - Dark'
,p_is_current=>false
,p_is_public=>true
,p_is_accessible=>false
,p_theme_roller_input_file_urls=>'#THEME_IMAGES#less/theme/Vita-Dark.less'
,p_theme_roller_output_file_url=>'#THEME_IMAGES#css/Vita-Dark#MIN#.css?v=#APEX_VERSION#'
,p_theme_roller_read_only=>true
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(211969301851984670)
,p_theme_id=>42
,p_name=>'REGION_POSITION'
,p_display_name=>'Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the position of the region.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(215039477563845876)
,p_theme_id=>42
,p_name=>'PAGE_POSITION'
,p_display_name=>'Position'
,p_display_sequence=>1
,p_template_types=>'PAGE'
,p_help_text=>'Sets the position of the page.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(215042146962825010)
,p_theme_id=>42
,p_name=>'DIALOG_SIZE'
,p_display_name=>'Size'
,p_display_sequence=>1
,p_template_types=>'PAGE'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(215635458665067919)
,p_theme_id=>42
,p_name=>'ICON_HOVER_ANIMATION'
,p_display_name=>'Icon Hover Animation'
,p_display_sequence=>55
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(238836143358553477)
,p_theme_id=>42
,p_name=>'PAGE_LAYOUT'
,p_display_name=>'Page Layout'
,p_display_sequence=>10
,p_template_types=>'PAGE'
,p_null_text=>'Floating (Default)'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(238836456250556001)
,p_theme_id=>42
,p_name=>'PAGE_BACKGROUND'
,p_display_name=>'Page Background'
,p_display_sequence=>20
,p_template_types=>'PAGE'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(240331572408240607)
,p_theme_id=>42
,p_name=>'ICON_SHAPE'
,p_display_name=>'Icon Shape'
,p_display_sequence=>60
,p_template_types=>'LIST'
,p_help_text=>'Determines the shape of the icon.'
,p_null_text=>'Circle'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(240331900166242117)
,p_theme_id=>42
,p_name=>'ICON_SHAPE'
,p_display_name=>'Icon Shape'
,p_display_sequence=>60
,p_template_types=>'REPORT'
,p_help_text=>'Determines the shape of the icon.'
,p_null_text=>'Circle'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(240334389763319806)
,p_theme_id=>42
,p_name=>'COLLAPSIBLE_ICON_POSITION'
,p_display_name=>'Collapsible Icon Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Determines the position of the expand and collapse toggle for the region.'
,p_null_text=>'Start'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(240335211940344543)
,p_theme_id=>42
,p_name=>'COLLAPSIBLE_BUTTON_ICONS'
,p_display_name=>'Collapsible Button Icons'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Determines which arrows to use to represent the icons for the collapse and expand button.'
,p_null_text=>'Arrows'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(253590311653377102)
,p_theme_id=>42
,p_name=>'ICON_SHAPE'
,p_display_name=>'Icon Shape'
,p_display_sequence=>60
,p_template_types=>'REGION'
,p_help_text=>'Determines the shape of the icon.'
,p_null_text=>'Rounded Corners'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(254246764314801329)
,p_theme_id=>42
,p_name=>'CALLOUT_POSITION'
,p_display_name=>'Callout Position'
,p_display_sequence=>10
,p_template_types=>'REGION'
,p_help_text=>'Determines where the callout for the popup will be positioned relative to its parent.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(323023042025382157)
,p_theme_id=>42
,p_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_sequence=>90
,p_template_types=>'LIST'
,p_help_text=>'Determines the display for a desktop-sized screen'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(323023383838383536)
,p_theme_id=>42
,p_name=>'MOBILE'
,p_display_name=>'Mobile'
,p_display_sequence=>100
,p_template_types=>'LIST'
,p_help_text=>'Determines the display for a mobile-sized screen'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(330622871777976980)
,p_theme_id=>42
,p_name=>'LOGIN_HEADER'
,p_display_name=>'Login Header'
,p_display_sequence=>10
,p_template_types=>'REGION'
,p_help_text=>'Controls the display of the Login region header.'
,p_null_text=>'Icon and Title (Default)'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(341348731255729287)
,p_theme_id=>42
,p_name=>'COLLAPSE_STYLE'
,p_display_name=>'Collapse Mode'
,p_display_sequence=>30
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(350784197398221961)
,p_theme_id=>42
,p_name=>'COL_SELECTION'
,p_display_name=>'Selection'
,p_display_sequence=>100
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(350784424517223601)
,p_theme_id=>42
,p_name=>'COL_ICON'
,p_display_name=>'Icon'
,p_display_sequence=>110
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(350784797183225680)
,p_theme_id=>42
,p_name=>'COL_CONTENT_TITLE'
,p_display_name=>'Title'
,p_display_sequence=>120
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(350785031716227530)
,p_theme_id=>42
,p_name=>'COL_CONTENT_DESCRIPTION'
,p_display_name=>'Description'
,p_display_sequence=>130
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(350785337301229407)
,p_theme_id=>42
,p_name=>'COL_MISC'
,p_display_name=>'Misc'
,p_display_sequence=>140
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(350785675912230663)
,p_theme_id=>42
,p_name=>'COL_ACTIONS'
,p_display_name=>'Actions'
,p_display_sequence=>150
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(355501396300309305)
,p_theme_id=>42
,p_name=>'CONTENT_ALIGNMENT'
,p_display_name=>'Content Alignment'
,p_display_sequence=>90
,p_template_types=>'REPORT'
,p_null_text=>'Center (Default)'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(385801771488104515)
,p_theme_id=>42
,p_name=>'PAGINATION_DISPLAY'
,p_display_name=>'Pagination Display'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_help_text=>'Controls the display of pagination for this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(404184026341118922)
,p_theme_id=>42
,p_name=>'HEADING_LEVEL'
,p_display_name=>'Heading Level'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(446733723296185373)
,p_theme_id=>42
,p_name=>'SIZE'
,p_display_name=>'Size'
,p_display_sequence=>35
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(576117721821431474)
,p_theme_id=>42
,p_name=>'CONTENT_PADDING'
,p_display_name=>'Content Padding'
,p_display_sequence=>1
,p_template_types=>'PAGE'
,p_help_text=>'Sets the Content Body padding for the page.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(582142591229178435)
,p_theme_id=>42
,p_name=>'SPACING_TOP'
,p_display_name=>'Spacing Top'
,p_display_sequence=>90
,p_template_types=>'BUTTON'
,p_help_text=>'Controls the spacing to the top of the button.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(582143096365182722)
,p_theme_id=>42
,p_name=>'SPACING_BOTTOM'
,p_display_name=>'Spacing Bottom'
,p_display_sequence=>100
,p_template_types=>'BUTTON'
,p_help_text=>'Controls the spacing to the bottom of the button.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(596249650773764068)
,p_theme_id=>42
,p_name=>'REQUIRED_INDICATOR'
,p_display_name=>'Required Indicator'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(610768348500863614)
,p_theme_id=>42
,p_name=>'DISPLAY_MODE'
,p_display_name=>'Display Mode'
,p_display_sequence=>30
,p_template_types=>'PAGE'
,p_help_text=>'Determines the default display appearance and positioning of the dialog. The default opens a floating dialog position at the center of the screen.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(610768969500869508)
,p_theme_id=>42
,p_name=>'DISPLAY_MODE'
,p_display_name=>'Display Mode'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Determines the default display appearance and positioning of the dialog. The default opens a floating dialog position at the center of the screen.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(624295607366539525)
,p_theme_id=>42
,p_name=>'HEADING_FONT'
,p_display_name=>'Heading Font'
,p_display_sequence=>100
,p_template_types=>'REGION'
,p_help_text=>'Sets the font-family of the heading for this region.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(666745372691130214)
,p_theme_id=>42
,p_name=>'DISPLAY_ITEMS'
,p_display_name=>'Display Items'
,p_display_sequence=>20
,p_template_types=>'REPORT'
,p_null_text=>'Inline (Default)'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(666745984744136740)
,p_theme_id=>42
,p_name=>'DISPLAY_LABELS'
,p_display_name=>'Display Labels'
,p_display_sequence=>30
,p_template_types=>'REPORT'
,p_null_text=>'Inline (Default)'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686928892790028100)
,p_theme_id=>42
,p_name=>'ICON_STYLE'
,p_display_name=>'Icon Style'
,p_display_sequence=>35
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686929122234028100)
,p_theme_id=>42
,p_name=>'SIZE'
,p_display_name=>'Size'
,p_display_sequence=>10
,p_template_types=>'BUTTON'
,p_help_text=>'Sets the size of the button.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686929314140028100)
,p_theme_id=>42
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686930381900028100)
,p_theme_id=>42
,p_name=>'ALERT_DISPLAY'
,p_display_name=>'Alert Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the layout of the Alert Region.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686930518563028100)
,p_theme_id=>42
,p_name=>'HEADER'
,p_display_name=>'Header'
,p_display_sequence=>20
,p_template_types=>'REGION'
,p_help_text=>'Determines the display of the Region Header which also contains the Region Title.'
,p_null_text=>'Visible - Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686930602304028100)
,p_theme_id=>42
,p_name=>'LABEL_DISPLAY'
,p_display_name=>'Label Display'
,p_display_sequence=>50
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686930751269028100)
,p_theme_id=>42
,p_name=>'ALTERNATING_ROWS'
,p_display_name=>'Alternating Rows'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_help_text=>'Shades alternate rows in the report with slightly different background colors.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686930833556028100)
,p_theme_id=>42
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>50
,p_template_types=>'BUTTON'
,p_help_text=>'Sets the position of the icon relative to the label.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686931442667028100)
,p_theme_id=>42
,p_name=>'BODY_OVERFLOW'
,p_display_name=>'Body Overflow'
,p_display_sequence=>2
,p_template_types=>'REGION'
,p_help_text=>'Determines the scroll behavior when the region contents are larger than their container.'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686931906521028101)
,p_theme_id=>42
,p_name=>'ITEM_SIZE'
,p_display_name=>'Item Size'
,p_display_sequence=>110
,p_template_types=>'REGION'
,p_help_text=>'Sets the size of the form items within this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686932039417028101)
,p_theme_id=>42
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>80
,p_template_types=>'BUTTON'
,p_help_text=>'Controls the spacing to the right of the button.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686932190740028101)
,p_theme_id=>42
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>40
,p_template_types=>'BUTTON'
,p_help_text=>'Enables you to group many buttons together into a pill. You can use this option to specify where the button is within this set. Set the option to Default if this button is not part of a button set.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686932580235028101)
,p_theme_id=>42
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>30
,p_template_types=>'LIST'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686932753785028101)
,p_theme_id=>42
,p_name=>'STYLE'
,p_display_name=>'Style'
,p_display_sequence=>40
,p_template_types=>'REGION'
,p_help_text=>'Determines how the region is styled. Use the "Remove Borders" template option to remove the region''s borders and shadows.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686932883424028101)
,p_theme_id=>42
,p_name=>'ACCENT'
,p_display_name=>'Accent'
,p_display_sequence=>30
,p_template_types=>'REGION'
,p_help_text=>'Set the Region''s accent. This accent corresponds to a Theme-Rollable color and sets the background of the Region''s Header.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686932933875028101)
,p_theme_id=>42
,p_name=>'HIDE_STEPS_FOR'
,p_display_name=>'Hide Steps For'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686934198962028101)
,p_theme_id=>42
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>70
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686934361014028101)
,p_theme_id=>42
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>30
,p_template_types=>'REPORT'
,p_help_text=>'Controls the display of the Report''s borders.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686934797631028101)
,p_theme_id=>42
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>30
,p_template_types=>'REPORT'
,p_help_text=>'Determines the layout of Cards in the report.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686934921941028101)
,p_theme_id=>42
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing Left'
,p_display_sequence=>70
,p_template_types=>'BUTTON'
,p_help_text=>'Controls the spacing to the left of the button.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686935492736028101)
,p_theme_id=>42
,p_name=>'ITEM_PADDING'
,p_display_name=>'Item Spacing'
,p_display_sequence=>100
,p_template_types=>'REGION'
,p_help_text=>'Sets the padding around items within this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686935554787028101)
,p_theme_id=>42
,p_name=>'BODY_HEIGHT'
,p_display_name=>'Body Height'
,p_display_sequence=>10
,p_template_types=>'REGION'
,p_help_text=>'Sets the Region Body height. You can also specify a custom height by modifying the Region''s CSS Classes and using the height helper classes "i-hXXX" where XXX is any increment of 10 from 100 to 800.'
,p_null_text=>'Auto - Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686935600596028101)
,p_theme_id=>42
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>3
,p_template_types=>'REGION'
,p_help_text=>'Sets the type of alert which can be used to determine the icon, icon color, and the background color.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686935738222028101)
,p_theme_id=>42
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>30
,p_template_types=>'LIST'
,p_null_text=>'No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686935812869028101)
,p_theme_id=>42
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>20
,p_template_types=>'REPORT'
,p_help_text=>'Determines whether you want the row to be highlighted on hover.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686936339267028101)
,p_theme_id=>42
,p_name=>'TYPE'
,p_display_name=>'Type'
,p_display_sequence=>20
,p_template_types=>'BUTTON'
,p_null_text=>'Normal'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686936498799028101)
,p_theme_id=>42
,p_name=>'STYLE'
,p_display_name=>'Style'
,p_display_sequence=>30
,p_template_types=>'BUTTON'
,p_help_text=>'Sets the style of the button. Use the "Simple" option for secondary actions or sets of buttons. Use the "Remove UI Decoration" option to make the button appear as text.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686937130886028102)
,p_theme_id=>42
,p_name=>'WIDTH'
,p_display_name=>'Width'
,p_display_sequence=>60
,p_template_types=>'BUTTON'
,p_help_text=>'Sets the width of the button.'
,p_null_text=>'Auto - Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(686938015244028102)
,p_theme_id=>42
,p_name=>'BODY_PADDING'
,p_display_name=>'Body Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the Region Body padding for the region.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(720406663650878470)
,p_theme_id=>42
,p_name=>'DISPLAY_ICON'
,p_display_name=>'Display Icon'
,p_display_sequence=>50
,p_template_types=>'REGION'
,p_help_text=>'Display the Hero Region icon.'
,p_null_text=>'Yes (Default)'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(872906013962098469)
,p_theme_id=>42
,p_name=>'ITEM_PRE_TEXT'
,p_display_name=>'Item Pre Text'
,p_display_sequence=>20
,p_template_types=>'FIELD'
,p_help_text=>'Adjust the display of the Item Pre Text'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(872906399664100106)
,p_theme_id=>42
,p_name=>'ITEM_POST_TEXT'
,p_display_name=>'Item Post Text'
,p_display_sequence=>30
,p_template_types=>'FIELD'
,p_help_text=>'Adjust the display of the Item Post Text'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(880962127232017732)
,p_theme_id=>42
,p_name=>'ANIMATION'
,p_display_name=>'Animation'
,p_display_sequence=>80
,p_template_types=>'LIST'
,p_help_text=>'Sets the hover and focus animation.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(880963719987020955)
,p_theme_id=>42
,p_name=>'ANIMATION'
,p_display_name=>'Animation'
,p_display_sequence=>70
,p_template_types=>'REPORT'
,p_help_text=>'Sets the hover and focus animation.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(940959055224631412)
,p_theme_id=>42
,p_name=>'LABEL_ALIGNMENT'
,p_display_name=>'Label Alignment'
,p_display_sequence=>130
,p_template_types=>'REGION'
,p_help_text=>'Set the label text alignment for items within this region.'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(940979718001664041)
,p_theme_id=>42
,p_name=>'LABEL_POSITION'
,p_display_name=>'Label Position'
,p_display_sequence=>140
,p_template_types=>'REGION'
,p_help_text=>'Sets the position of the label relative to the form item.'
,p_null_text=>'Inline - Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1038527687487780252)
,p_theme_id=>42
,p_name=>'ALERT_TITLE'
,p_display_name=>'Alert Title'
,p_display_sequence=>40
,p_template_types=>'REGION'
,p_help_text=>'Determines how the title of the alert is displayed.'
,p_null_text=>'Visible - Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1048200623912835168)
,p_theme_id=>42
,p_name=>'REGION_TOP_MARGIN'
,p_display_name=>'Top Margin'
,p_display_sequence=>200
,p_template_types=>'REGION'
,p_help_text=>'Set the top margin for this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1048201178198836942)
,p_theme_id=>42
,p_name=>'REGION_BOTTOM_MARGIN'
,p_display_name=>'Bottom Margin'
,p_display_sequence=>210
,p_template_types=>'REGION'
,p_help_text=>'Set the bottom margin for this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1048203232599844933)
,p_theme_id=>42
,p_name=>'REGION_LEFT_MARGIN'
,p_display_name=>'Left Margin'
,p_display_sequence=>220
,p_template_types=>'REGION'
,p_help_text=>'Set the left margin for this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1048203592334847309)
,p_theme_id=>42
,p_name=>'REGION_RIGHT_MARGIN'
,p_display_name=>'Right Margin'
,p_display_sequence=>230
,p_template_types=>'REGION'
,p_help_text=>'Set the right margin for this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1093528122542993730)
,p_theme_id=>42
,p_name=>'STYLE'
,p_display_name=>'Style'
,p_display_sequence=>10
,p_template_types=>'LIST'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1215309761905148163)
,p_theme_id=>42
,p_name=>'DEFAULT_STATE'
,p_display_name=>'Default State'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the default state of the region.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1217903970492295002)
,p_theme_id=>42
,p_name=>'ITEM_WIDTH'
,p_display_name=>'Item Width'
,p_display_sequence=>120
,p_template_types=>'REGION'
,p_help_text=>'Sets the width of the form items within this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1223646971237343931)
,p_theme_id=>42
,p_name=>'DIALOG_SIZE'
,p_display_name=>'Size'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1332170055887643649)
,p_theme_id=>42
,p_name=>'ANIMATION'
,p_display_name=>'Animation'
,p_display_sequence=>10
,p_template_types=>'REGION'
,p_help_text=>'Sets the animation when navigating within the Carousel Region.'
,p_null_text=>'Fade'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1332170259565645642)
,p_theme_id=>42
,p_name=>'TIMER'
,p_display_name=>'Timer'
,p_display_sequence=>2
,p_template_types=>'REGION'
,p_help_text=>'Sets the timer for when to automatically navigate to the next region within the Carousel Region.'
,p_null_text=>'No Timer'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1337807492374178719)
,p_theme_id=>42
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1341358060911539894)
,p_theme_id=>42
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the source of the Title Bar region''s title.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1373692906398577433)
,p_theme_id=>42
,p_name=>'TOP_MARGIN'
,p_display_name=>'Top Margin'
,p_display_sequence=>200
,p_template_types=>'FIELD'
,p_help_text=>'Set the top margin for this field.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1373693355147580605)
,p_theme_id=>42
,p_name=>'BOTTOM_MARGIN'
,p_display_name=>'Bottom Margin'
,p_display_sequence=>220
,p_template_types=>'FIELD'
,p_help_text=>'Set the bottom margin for this field.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1373693635931582685)
,p_theme_id=>42
,p_name=>'LEFT_MARGIN'
,p_display_name=>'Left Margin'
,p_display_sequence=>220
,p_template_types=>'FIELD'
,p_help_text=>'Set the left margin for this field.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1373694106751588886)
,p_theme_id=>42
,p_name=>'RIGHT_MARGIN'
,p_display_name=>'Right Margin'
,p_display_sequence=>230
,p_template_types=>'FIELD'
,p_help_text=>'Set the right margin for this field.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1437744671284475130)
,p_theme_id=>42
,p_name=>'COLOR_ACCENTS'
,p_display_name=>'Color Accents'
,p_display_sequence=>50
,p_template_types=>'LIST'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1437745695703477673)
,p_theme_id=>42
,p_name=>'ICONS'
,p_display_name=>'Icons'
,p_display_sequence=>20
,p_template_types=>'LIST'
,p_null_text=>'No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1437746379683480702)
,p_theme_id=>42
,p_name=>'BODY_TEXT'
,p_display_name=>'Body Text'
,p_display_sequence=>40
,p_template_types=>'LIST'
,p_help_text=>'Determines the height of the card body.'
,p_null_text=>'Auto'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1443062277679626593)
,p_theme_id=>42
,p_name=>'RADIO_GROUP_DISPLAY'
,p_display_name=>'Item Group Display'
,p_display_sequence=>300
,p_template_types=>'FIELD'
,p_help_text=>'Determines the display style for radio and check box items.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1512514270407882520)
,p_theme_id=>42
,p_name=>'SIZE'
,p_display_name=>'Size'
,p_display_sequence=>10
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1517530105045469419)
,p_theme_id=>42
,p_name=>'COMMENTS_STYLE'
,p_display_name=>'Comments Style'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_help_text=>'Determines the style in which comments are displayed.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1525956956755555832)
,p_theme_id=>42
,p_name=>'BODY_TEXT'
,p_display_name=>'Body Text'
,p_display_sequence=>40
,p_template_types=>'REPORT'
,p_help_text=>'Determines the height of the card body.'
,p_null_text=>'Auto'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1525957196240557785)
,p_theme_id=>42
,p_name=>'COLOR_ACCENTS'
,p_display_name=>'Color Accents'
,p_display_sequence=>50
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1525957399615559004)
,p_theme_id=>42
,p_name=>'ICONS'
,p_display_name=>'Icons'
,p_display_sequence=>20
,p_template_types=>'REPORT'
,p_help_text=>'Controls how to handle icons in the report.'
,p_null_text=>'No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1525957602312561277)
,p_theme_id=>42
,p_name=>'STYLE'
,p_display_name=>'Style'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_help_text=>'Determines the overall style for the component.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1583514852507574967)
,p_theme_id=>42
,p_name=>'PRESERVE_LABEL_SPACING'
,p_display_name=>'Preserve Label Spacing'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_help_text=>'Preserves the label space and enables use of the Label Column Span property.'
,p_null_text=>'Yes'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1819504545813380867)
,p_theme_id=>42
,p_name=>'ALERT_ICONS'
,p_display_name=>'Alert Icons'
,p_display_sequence=>2
,p_template_types=>'REGION'
,p_help_text=>'Sets how icons are handled for the Alert Region.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1840639733836662642)
,p_theme_id=>42
,p_name=>'SIZE'
,p_display_name=>'Size'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1857478787516903577)
,p_theme_id=>42
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1857479096126905096)
,p_theme_id=>42
,p_name=>'TAB_STYLE'
,p_display_name=>'Tab Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1857480037379911594)
,p_theme_id=>42
,p_name=>'TABS_SIZE'
,p_display_name=>'Tabs Size'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(2152178420884088035)
,p_theme_id=>42
,p_name=>'BODY_STYLE'
,p_display_name=>'Body Style'
,p_display_sequence=>20
,p_template_types=>'REGION'
,p_help_text=>'Controls the display of the region''s body container.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(36341567142178351)
,p_theme_id=>42
,p_name=>'AUTO_HEIGHT_INLINE_DIALOG'
,p_display_name=>'Auto Height'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(36340727081178326)
,p_css_classes=>'js-dialog-autoheight'
,p_template_types=>'REGION'
,p_help_text=>'This option will set the height of the dialog to fit its contents.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(36342386197178363)
,p_theme_id=>42
,p_name=>'LARGE_720X480'
,p_display_name=>'Large (720x480)'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(36340727081178326)
,p_css_classes=>'js-dialog-size720x480'
,p_group_id=>wwv_flow_api.id(1223646971237343931)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(36342743089178365)
,p_theme_id=>42
,p_name=>'MEDIUM_600X400'
,p_display_name=>'Medium (600x400)'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(36340727081178326)
,p_css_classes=>'js-dialog-size600x400'
,p_group_id=>wwv_flow_api.id(1223646971237343931)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(36344019112178367)
,p_theme_id=>42
,p_name=>'SMALL_480X320'
,p_display_name=>'Small (480x320)'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(36340727081178326)
,p_css_classes=>'js-dialog-size480x320'
,p_group_id=>wwv_flow_api.id(1223646971237343931)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(36345016860199829)
,p_theme_id=>42
,p_name=>'NONE'
,p_display_name=>'None'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(36340727081178326)
,p_css_classes=>'js-dialog-nosize'
,p_group_id=>wwv_flow_api.id(1223646971237343931)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(55849741180886501)
,p_theme_id=>42
,p_name=>'NONE'
,p_display_name=>'None'
,p_display_sequence=>5
,p_region_template_id=>wwv_flow_api.id(1223645131968329858)
,p_css_classes=>'js-dialog-nosize'
,p_group_id=>wwv_flow_api.id(1223646971237343931)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(136984374131672603)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(36340727081178326)
,p_css_classes=>'t-DialogRegion--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes the padding around the region body.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(136984645774677058)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>5
,p_region_template_id=>wwv_flow_api.id(1223645131968329858)
,p_css_classes=>'t-DialogRegion--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes the padding around the region body.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(137821929232283849)
,p_theme_id=>42
,p_name=>'HIDE_ICON_ON_DESKTOP'
,p_display_name=>'Hide Icon on Desktop'
,p_display_sequence=>20
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_css_classes=>'t-Button--desktopHideIcon'
,p_template_types=>'BUTTON'
,p_help_text=>'This template options hides the button icon on large screens.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(138686562864078208)
,p_theme_id=>42
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(2044682192514224742)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
,p_help_text=>'Enables you to define a keyboard shortcut to activate the menu item.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(139249009997129834)
,p_theme_id=>42
,p_name=>'SHOW_REGION_ICON'
,p_display_name=>'Show Region Icon'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(873087052820635270)
,p_css_classes=>'t-ContentBlock--showIcon'
,p_template_types=>'REGION'
,p_help_text=>'Displays the region icon in the region header beside the region title'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(139425226067120175)
,p_theme_id=>42
,p_name=>'STYLE_A'
,p_display_name=>'Style A'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(1018710602436487872)
,p_css_classes=>'t-TreeNav--styleA'
,p_group_id=>wwv_flow_api.id(1093528122542993730)
,p_template_types=>'LIST'
,p_help_text=>'Style Variation A'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(139425499017121455)
,p_theme_id=>42
,p_name=>'STYLE_B'
,p_display_name=>'Style B'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(1018710602436487872)
,p_css_classes=>'t-TreeNav--styleB'
,p_group_id=>wwv_flow_api.id(1093528122542993730)
,p_template_types=>'LIST'
,p_help_text=>'Style Variation B'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(171426272527047412)
,p_theme_id=>42
,p_name=>'WIZARD_PROGRESS_LINKS'
,p_display_name=>'Make Wizard Steps Clickable'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_api.id(561120526789187584)
,p_css_classes=>'js-wizardProgressLinks'
,p_template_types=>'LIST'
,p_help_text=>'This option will make the wizard steps clickable links.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(174928601863682667)
,p_theme_id=>42
,p_name=>'STYLE_C'
,p_display_name=>'Classic'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(1018710602436487872)
,p_css_classes=>'t-TreeNav--classic'
,p_group_id=>wwv_flow_api.id(1093528122542993730)
,p_template_types=>'LIST'
,p_help_text=>'Classic Style'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(182676470096796084)
,p_theme_id=>42
,p_name=>'COMPACT'
,p_display_name=>'Compact'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(65791776421862960)
,p_css_classes=>'t-Timeline--compact'
,p_group_id=>wwv_flow_api.id(1525957602312561277)
,p_template_types=>'REPORT'
,p_help_text=>'Displays a compact version of timeline with smaller text and fewer columns.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(211950557910302422)
,p_theme_id=>42
,p_name=>'MODAL'
,p_display_name=>'Modal'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(211944521729302482)
,p_css_classes=>'js-modal'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(211951782071302419)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>5
,p_region_template_id=>wwv_flow_api.id(211944521729302482)
,p_css_classes=>'t-DialogRegion--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes the padding around the region body.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(211952148534302417)
,p_theme_id=>42
,p_name=>'NONE'
,p_display_name=>'None (Auto)'
,p_display_sequence=>5
,p_region_template_id=>wwv_flow_api.id(211944521729302482)
,p_css_classes=>'js-dialog-nosize'
,p_group_id=>wwv_flow_api.id(1223646971237343931)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(211965908675000489)
,p_theme_id=>42
,p_name=>'POSITION_START'
,p_display_name=>'Start'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(211944521729302482)
,p_css_classes=>'js-dialog-class-t-Drawer--pullOutStart'
,p_group_id=>wwv_flow_api.id(211969301851984670)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(211966282923997887)
,p_theme_id=>42
,p_name=>'POSITION_END'
,p_display_name=>'End'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(211944521729302482)
,p_css_classes=>'js-dialog-class-t-Drawer--pullOutEnd'
,p_group_id=>wwv_flow_api.id(211969301851984670)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(212142541969272240)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(211944521729302482)
,p_css_classes=>'js-dialog-class-t-Drawer--sm'
,p_group_id=>wwv_flow_api.id(1223646971237343931)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(212142834847270069)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(211944521729302482)
,p_css_classes=>'js-dialog-class-t-Drawer--md'
,p_group_id=>wwv_flow_api.id(1223646971237343931)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(212143109586268176)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(211944521729302482)
,p_css_classes=>'js-dialog-class-t-Drawer--lg'
,p_group_id=>wwv_flow_api.id(1223646971237343931)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(212145804141255628)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_EXTRA_LARGE'
,p_display_name=>'Extra Large'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(211944521729302482)
,p_css_classes=>'js-dialog-class-t-Drawer--xl'
,p_group_id=>wwv_flow_api.id(1223646971237343931)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(212159812871187130)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>20
,p_page_template_id=>wwv_flow_api.id(212157975711187152)
,p_css_classes=>'t-Dialog--noPadding'
,p_template_types=>'PAGE'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(214827682901306630)
,p_theme_id=>42
,p_name=>'POSITION_END'
,p_display_name=>'End'
,p_display_sequence=>20
,p_page_template_id=>wwv_flow_api.id(212157975711187152)
,p_css_classes=>'js-dialog-class-t-Drawer--pullOutEnd'
,p_group_id=>wwv_flow_api.id(215039477563845876)
,p_template_types=>'PAGE'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(214827938466304745)
,p_theme_id=>42
,p_name=>'POSITION_START'
,p_display_name=>'Start'
,p_display_sequence=>10
,p_page_template_id=>wwv_flow_api.id(212157975711187152)
,p_css_classes=>'js-dialog-class-t-Drawer--pullOutStart'
,p_group_id=>wwv_flow_api.id(215039477563845876)
,p_template_types=>'PAGE'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(215040432606833800)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_page_template_id=>wwv_flow_api.id(212157975711187152)
,p_css_classes=>'js-dialog-class-t-Drawer--sm'
,p_group_id=>wwv_flow_api.id(215042146962825010)
,p_template_types=>'PAGE'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(215040748121832747)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>20
,p_page_template_id=>wwv_flow_api.id(212157975711187152)
,p_css_classes=>'js-dialog-class-t-Drawer--md'
,p_group_id=>wwv_flow_api.id(215042146962825010)
,p_template_types=>'PAGE'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(215041034039831676)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>30
,p_page_template_id=>wwv_flow_api.id(212157975711187152)
,p_css_classes=>'js-dialog-class-t-Drawer--lg'
,p_group_id=>wwv_flow_api.id(215042146962825010)
,p_template_types=>'PAGE'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(215041351975830356)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_EXTRA_LARGE'
,p_display_name=>'Extra Large'
,p_display_sequence=>40
,p_page_template_id=>wwv_flow_api.id(212157975711187152)
,p_css_classes=>'js-dialog-class-t-Drawer--xl'
,p_group_id=>wwv_flow_api.id(215042146962825010)
,p_template_types=>'PAGE'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(215603298226026242)
,p_theme_id=>42
,p_name=>'HIDE_LABEL_ON_MOBILE'
,p_display_name=>'Hide Label on Mobile'
,p_display_sequence=>10
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_css_classes=>'t-Button--mobileHideLabel'
,p_template_types=>'BUTTON'
,p_help_text=>'This template options hides the button label on small screens.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(215636050096082468)
,p_theme_id=>42
,p_name=>'SPIN'
,p_display_name=>'Spin'
,p_display_sequence=>10
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_css_classes=>'t-Button--hoverIconSpin'
,p_group_id=>wwv_flow_api.id(215635458665067919)
,p_template_types=>'BUTTON'
,p_help_text=>'The icon will spin on button hover or focus.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(215636422248085038)
,p_theme_id=>42
,p_name=>'PUSH'
,p_display_name=>'Push'
,p_display_sequence=>20
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_css_classes=>'t-Button--hoverIconPush'
,p_group_id=>wwv_flow_api.id(215635458665067919)
,p_template_types=>'BUTTON'
,p_help_text=>'The icon will animate to the right or left on button hover or focus.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(215642794957092725)
,p_theme_id=>42
,p_name=>'SPIN'
,p_display_name=>'Spin'
,p_display_sequence=>10
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_css_classes=>'t-Button--hoverIconSpin'
,p_group_id=>wwv_flow_api.id(215635458665067919)
,p_template_types=>'BUTTON'
,p_help_text=>'The icon will spin on button hover or focus.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(215643345060093995)
,p_theme_id=>42
,p_name=>'PUSH'
,p_display_name=>'Push'
,p_display_sequence=>20
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_css_classes=>'t-Button--hoverIconPush'
,p_group_id=>wwv_flow_api.id(215635458665067919)
,p_template_types=>'BUTTON'
,p_help_text=>'The icon will animate to the right or left on button hover or focus.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(239920721902752792)
,p_theme_id=>42
,p_name=>'REMOVE_PAGE_OVERLAY'
,p_display_name=>'Remove Page Overlay'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(36340727081178326)
,p_css_classes=>'js-popup-noOverlay'
,p_template_types=>'REGION'
,p_help_text=>'This option will display the inline dialog without an overlay on the background.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(240332596533273672)
,p_theme_id=>42
,p_name=>'ICONS_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--iconsSquare'
,p_group_id=>wwv_flow_api.id(240331572408240607)
,p_template_types=>'LIST'
,p_help_text=>'The icons are displayed within a square shape.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(240332914288277171)
,p_theme_id=>42
,p_name=>'ICONS_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_css_classes=>'t-MediaList--iconsSquare'
,p_group_id=>wwv_flow_api.id(240331572408240607)
,p_template_types=>'LIST'
,p_help_text=>'The icons are displayed within a square shape.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(240333389335280467)
,p_theme_id=>42
,p_name=>'ICONS_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--iconsSquare'
,p_group_id=>wwv_flow_api.id(240331900166242117)
,p_template_types=>'REPORT'
,p_help_text=>'The icons are displayed within a square shape.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(240333685105283106)
,p_theme_id=>42
,p_name=>'ICONS_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(1164140200812557328)
,p_css_classes=>'t-Comments--iconsSquare'
,p_group_id=>wwv_flow_api.id(240331900166242117)
,p_template_types=>'REPORT'
,p_help_text=>'The icons are displayed within a square shape.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(240333953355286064)
,p_theme_id=>42
,p_name=>'ICONS_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(644575648490092151)
,p_css_classes=>'t-MediaList--iconsSquare'
,p_group_id=>wwv_flow_api.id(240331900166242117)
,p_template_types=>'REPORT'
,p_help_text=>'The icons are displayed within a square shape.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(240336838431350961)
,p_theme_id=>42
,p_name=>'ICONS_PLUS_OR_MINUS'
,p_display_name=>'Plus or Minus'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--hideShowIconsMath'
,p_group_id=>wwv_flow_api.id(240335211940344543)
,p_template_types=>'REGION'
,p_help_text=>'Use the plus and minus icons for the expand and collapse button.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(240337400241354943)
,p_theme_id=>42
,p_name=>'CONRTOLS_POSITION_END'
,p_display_name=>'End'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--controlsPosEnd'
,p_group_id=>wwv_flow_api.id(240334389763319806)
,p_template_types=>'REGION'
,p_help_text=>'Position the expand / collapse button to the end of the region header.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(241863902970571755)
,p_theme_id=>42
,p_name=>'ICONS_ROUNDED'
,p_display_name=>'Rounded Corners'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--iconsRounded'
,p_group_id=>wwv_flow_api.id(240331572408240607)
,p_template_types=>'LIST'
,p_help_text=>'The icons are displayed within a square with rounded corners.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(241864573774577986)
,p_theme_id=>42
,p_name=>'ICONS_ROUNDED'
,p_display_name=>'Rounded Corners'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--iconsRounded'
,p_group_id=>wwv_flow_api.id(240331900166242117)
,p_template_types=>'REPORT'
,p_help_text=>'The icons are displayed within a square with rounded corners.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(241872609228581726)
,p_theme_id=>42
,p_name=>'ICONS_ROUNDED'
,p_display_name=>'Rounded Corners'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_css_classes=>'t-MediaList--iconsRounded'
,p_group_id=>wwv_flow_api.id(240331572408240607)
,p_template_types=>'LIST'
,p_help_text=>'The icons are displayed within a square with rounded corners.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(241873954103585234)
,p_theme_id=>42
,p_name=>'ICONS_ROUNDED'
,p_display_name=>'Rounded Corners'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(644575648490092151)
,p_css_classes=>'t-MediaList--iconsRounded'
,p_group_id=>wwv_flow_api.id(240331900166242117)
,p_template_types=>'REPORT'
,p_help_text=>'The icons are displayed within a square with rounded corners.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(241874505626588903)
,p_theme_id=>42
,p_name=>'ICONS_ROUNDED'
,p_display_name=>'Rounded Corners'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(1164140200812557328)
,p_css_classes=>'t-Comments--iconsRounded'
,p_group_id=>wwv_flow_api.id(240331900166242117)
,p_template_types=>'REPORT'
,p_help_text=>'The icons are displayed within a square with rounded corners.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(248035289187741665)
,p_theme_id=>42
,p_name=>'PAGE_LAYOUT_SPLIT'
,p_display_name=>'Split'
,p_display_sequence=>1
,p_page_template_id=>wwv_flow_api.id(652129338145143712)
,p_css_classes=>'t-LoginPage--split'
,p_group_id=>wwv_flow_api.id(238836143358553477)
,p_template_types=>'PAGE'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(248035509228744610)
,p_theme_id=>42
,p_name=>'PAGE_BACKGROUND_1'
,p_display_name=>'Background 1'
,p_display_sequence=>10
,p_page_template_id=>wwv_flow_api.id(652129338145143712)
,p_css_classes=>'t-LoginPage--bg1'
,p_group_id=>wwv_flow_api.id(238836456250556001)
,p_template_types=>'PAGE'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(248035809643746378)
,p_theme_id=>42
,p_name=>'PAGE_BACKGROUND_2'
,p_display_name=>'Background 2'
,p_display_sequence=>20
,p_page_template_id=>wwv_flow_api.id(652129338145143712)
,p_css_classes=>'t-LoginPage--bg2'
,p_group_id=>wwv_flow_api.id(238836456250556001)
,p_template_types=>'PAGE'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(253590809515383098)
,p_theme_id=>42
,p_name=>'ICONS_CIRCULAR'
,p_display_name=>'Circle'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1224989219520090364)
,p_css_classes=>'t-HeroRegion--iconsCircle'
,p_group_id=>wwv_flow_api.id(253590311653377102)
,p_template_types=>'REGION'
,p_help_text=>'The icons are displayed within a circle.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(253591054883386658)
,p_theme_id=>42
,p_name=>'ICONS_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1224989219520090364)
,p_css_classes=>'t-HeroRegion--iconsSquare'
,p_group_id=>wwv_flow_api.id(253590311653377102)
,p_template_types=>'REGION'
,p_help_text=>'The icons are displayed within a square.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(253963831800734687)
,p_theme_id=>42
,p_name=>'FULL_WIDTH'
,p_display_name=>'Full Width'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(217865321596155171)
,p_css_classes=>'t-MegaMenu--fullWidth'
,p_template_types=>'LIST'
,p_help_text=>'Stretches the menu to fill the width of the screen.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(253964192595737507)
,p_theme_id=>42
,p_name=>'DISPLAY_MENU_CALLOUT'
,p_display_name=>'Display Menu Callout'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(217865321596155171)
,p_css_classes=>'js-menu-callout'
,p_template_types=>'LIST'
,p_help_text=>'Displays a callout arrow that points to where the menu was activated from.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(253964461625742999)
,p_theme_id=>42
,p_name=>'2_COLUMNS'
,p_display_name=>'2 Columns'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(217865321596155171)
,p_css_classes=>'t-MegaMenu--layout2Cols'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(253964708556744254)
,p_theme_id=>42
,p_name=>'3_COLUMNS'
,p_display_name=>'3 Columns'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(217865321596155171)
,p_css_classes=>'t-MegaMenu--layout3Cols'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(253965005259745198)
,p_theme_id=>42
,p_name=>'4_COLUMNS'
,p_display_name=>'4 Columns'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(217865321596155171)
,p_css_classes=>'t-MegaMenu--layout4Cols'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(253965317541746166)
,p_theme_id=>42
,p_name=>'5_COLUMNS'
,p_display_name=>'5 Columns'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_api.id(217865321596155171)
,p_css_classes=>'t-MegaMenu--layout5Cols'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(253965625846747278)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>60
,p_list_template_id=>wwv_flow_api.id(217865321596155171)
,p_css_classes=>'t-MegaMenu--layoutStacked'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(253965941571748457)
,p_theme_id=>42
,p_name=>'CUSTOM'
,p_display_name=>'Custom'
,p_display_sequence=>60
,p_list_template_id=>wwv_flow_api.id(217865321596155171)
,p_css_classes=>'t-MegaMenu--layoutCustom'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(253997974882550974)
,p_theme_id=>42
,p_name=>'PAGE_BACKGROUND_3'
,p_display_name=>'Background 3'
,p_display_sequence=>30
,p_page_template_id=>wwv_flow_api.id(652129338145143712)
,p_css_classes=>'t-LoginPage--bg3'
,p_group_id=>wwv_flow_api.id(238836456250556001)
,p_template_types=>'PAGE'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(254244493501769393)
,p_theme_id=>42
,p_name=>'DISPLAY_MENU_CALLOUT'
,p_display_name=>'Display Menu Callout'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_api.id(561127424267431983)
,p_css_classes=>'js-menu-callout'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add display a callout for the menu.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(254244711403772753)
,p_theme_id=>42
,p_name=>'DISPLAY_MENU_CALLOUT'
,p_display_name=>'Display Menu Callout'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(2044682192514224742)
,p_css_classes=>'js-menu-callout'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add display a callout for the menu. Note that callout will only be displayed if the data-parent-element custom attribute is defined.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(254245025797780615)
,p_theme_id=>42
,p_name=>'DISPLAY_MENU_CALLOUT'
,p_display_name=>'Display Menu Callout'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_api.id(1077726089382032168)
,p_css_classes=>'js-menu-callout'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add display a callout for the menu.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(254245588692791119)
,p_theme_id=>42
,p_name=>'DISPLAY_POPUP_CALLOUT'
,p_display_name=>'Display Popup Callout'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(36340727081178326)
,p_css_classes=>'js-popup-callout'
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add display a callout for the popup. Note that callout will only be displayed if the data-parent-element custom attribute is defined.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(254247399124810318)
,p_theme_id=>42
,p_name=>'BEFORE'
,p_display_name=>'Before'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(36340727081178326)
,p_css_classes=>'js-popup-pos-before'
,p_group_id=>wwv_flow_api.id(254246764314801329)
,p_template_types=>'REGION'
,p_help_text=>'Positions the callout before or typically to the left of the parent.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(254247601687811782)
,p_theme_id=>42
,p_name=>'AFTER'
,p_display_name=>'After'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(36340727081178326)
,p_css_classes=>'js-popup-pos-after'
,p_group_id=>wwv_flow_api.id(254246764314801329)
,p_template_types=>'REGION'
,p_help_text=>'Positions the callout after or typically to the right of the parent.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(254247931980813673)
,p_theme_id=>42
,p_name=>'ABOVE'
,p_display_name=>'Above'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(36340727081178326)
,p_css_classes=>'js-popup-pos-above'
,p_group_id=>wwv_flow_api.id(254246764314801329)
,p_template_types=>'REGION'
,p_help_text=>'Positions the callout above or typically on top of the parent.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(254248268785815794)
,p_theme_id=>42
,p_name=>'BELOW'
,p_display_name=>'Below'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(36340727081178326)
,p_css_classes=>'js-popup-pos-below'
,p_group_id=>wwv_flow_api.id(254246764314801329)
,p_template_types=>'REGION'
,p_help_text=>'Positions the callout below or typically to the bottom of the parent.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(254248572094818502)
,p_theme_id=>42
,p_name=>'INSIDE'
,p_display_name=>'Inside'
,p_display_sequence=>50
,p_region_template_id=>wwv_flow_api.id(36340727081178326)
,p_css_classes=>'js-popup-pos-inside'
,p_group_id=>wwv_flow_api.id(254246764314801329)
,p_template_types=>'REGION'
,p_help_text=>'Positions the callout inside of the parent. This is useful when the parent is sufficiently large, such as a report or large region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(323024443186403293)
,p_theme_id=>42
,p_name=>'LABEL_INLINE_LG'
,p_display_name=>'Display labels inline'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(5429749254678674)
,p_css_classes=>'t-NavTabs--inlineLabels-lg'
,p_group_id=>wwv_flow_api.id(323023042025382157)
,p_template_types=>'LIST'
,p_help_text=>'Display the label inline with the icon and badge'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(323024784490409002)
,p_theme_id=>42
,p_name=>'LABEL_ABOVE_LG'
,p_display_name=>'Display labels above'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(5429749254678674)
,p_css_classes=>'t-NavTabs--stacked'
,p_group_id=>wwv_flow_api.id(323023042025382157)
,p_template_types=>'LIST'
,p_help_text=>'Display the label stacked above the icon and badge'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(323025261908423830)
,p_theme_id=>42
,p_name=>'NO_LABEL_LG'
,p_display_name=>'Do not display labels'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(5429749254678674)
,p_css_classes=>'t-NavTabs--hiddenLabels-lg'
,p_group_id=>wwv_flow_api.id(323023042025382157)
,p_template_types=>'LIST'
,p_help_text=>'Hides the label for the list item'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(323044096831435346)
,p_theme_id=>42
,p_name=>'DISPLAY_LABELS_SM'
,p_display_name=>'Display labels'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_api.id(5429749254678674)
,p_css_classes=>'t-NavTabs--displayLabels-sm'
,p_group_id=>wwv_flow_api.id(323023383838383536)
,p_template_types=>'LIST'
,p_help_text=>'Displays the label for the list items below the icon'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(323044326011438615)
,p_theme_id=>42
,p_name=>'HIDE_LABELS_SM'
,p_display_name=>'Do not display labels'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_api.id(5429749254678674)
,p_css_classes=>'t-NavTabs--hiddenLabels-sm'
,p_group_id=>wwv_flow_api.id(323023383838383536)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(330619183951965588)
,p_theme_id=>42
,p_name=>'LOGIN_HEADER_ICON'
,p_display_name=>'Icon'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1225129382632869472)
,p_css_classes=>'t-Login-region--headerIcon'
,p_group_id=>wwv_flow_api.id(330622871777976980)
,p_template_types=>'REGION'
,p_help_text=>'Displays only the Region Icon in the Login region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(330619403821967325)
,p_theme_id=>42
,p_name=>'LOGIN_HEADER_TITLE'
,p_display_name=>'Title'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1225129382632869472)
,p_css_classes=>'t-Login-region--headerTitle js-removeLandmark'
,p_group_id=>wwv_flow_api.id(330622871777976980)
,p_template_types=>'REGION'
,p_help_text=>'Displays only the Region Title in the Login region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(330619758143968581)
,p_theme_id=>42
,p_name=>'LOGO_HEADER_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(1225129382632869472)
,p_css_classes=>'t-Login-region--headerHidden js-removeLandmark'
,p_group_id=>wwv_flow_api.id(330622871777976980)
,p_template_types=>'REGION'
,p_help_text=>'Hides both the Region Icon and Title from the Login region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(330624992191999827)
,p_theme_id=>42
,p_name=>'DISPLAY_MENU_CALLOUT'
,p_display_name=>'Display Menu Callout'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(1398514441042912293)
,p_css_classes=>'js-menu-callout'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add display a callout for the menu.'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(334241145487690857)
,p_theme_id=>42
,p_name=>'DISPLAY_SUBTITLE'
,p_display_name=>'Display Subtitle'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--displaySubtitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(334721208695984399)
,p_theme_id=>42
,p_name=>'BLOCK'
,p_display_name=>'Block'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--featured t-Cards--block force-fa-lg'
,p_group_id=>wwv_flow_api.id(1093528122542993730)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(334851471331443195)
,p_theme_id=>42
,p_name=>'BLOCK'
,p_display_name=>'Block'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--featured t-Cards--block force-fa-lg'
,p_group_id=>wwv_flow_api.id(1525957602312561277)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(334851708965445205)
,p_theme_id=>42
,p_name=>'DISPLAY_SUBTITLE'
,p_display_name=>'Display Subtitle'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--displaySubtitle'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(335457279389178312)
,p_theme_id=>42
,p_name=>'SHOW_REGION_ICON'
,p_display_name=>'Show Region Icon'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--showIcon'
,p_template_types=>'REGION'
,p_help_text=>'Displays the region icon in the region header beside the region title'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(341352557131809035)
,p_theme_id=>42
,p_name=>'COLLAPSE_STYLE_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(1018710602436487872)
,p_css_classes=>'js-navCollapsed--hidden'
,p_group_id=>wwv_flow_api.id(341348731255729287)
,p_template_types=>'LIST'
,p_help_text=>'Completely hide the navigation menu when it is collapsed.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(345588708808550765)
,p_theme_id=>42
,p_name=>'SHOW_REGION_ICON'
,p_display_name=>'Show Region Icon'
,p_display_sequence=>50
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'t-Region--showIcon'
,p_template_types=>'REGION'
,p_help_text=>'Displays the region icon in the region header beside the region title'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(350798785322250277)
,p_theme_id=>42
,p_name=>'TITLE_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(350261643030073247)
,p_css_classes=>'t-ContentRow--hideTitle'
,p_group_id=>wwv_flow_api.id(350784797183225680)
,p_template_types=>'REPORT'
,p_help_text=>'Hides the Title from being rendered on the screen.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(350801269373255760)
,p_theme_id=>42
,p_name=>'SELECTION_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(350261643030073247)
,p_css_classes=>'t-ContentRow--hideSelection'
,p_group_id=>wwv_flow_api.id(350784197398221961)
,p_template_types=>'REPORT'
,p_help_text=>'Hides the Selection column from being rendered on the screen.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(350801554087257419)
,p_theme_id=>42
,p_name=>'ICON_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(350261643030073247)
,p_css_classes=>'t-ContentRow--hideIcon'
,p_group_id=>wwv_flow_api.id(350784424517223601)
,p_template_types=>'REPORT'
,p_help_text=>'Hides the Icon from being rendered on the screen.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(350801875813261741)
,p_theme_id=>42
,p_name=>'DESCRIPTION_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_api.id(350261643030073247)
,p_css_classes=>'t-ContentRow--hideDescription'
,p_group_id=>wwv_flow_api.id(350785031716227530)
,p_template_types=>'REPORT'
,p_help_text=>'Hides the Description from being rendered on the screen.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(350802111464263493)
,p_theme_id=>42
,p_name=>'MISC_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_api.id(350261643030073247)
,p_css_classes=>'t-ContentRow--hideMisc'
,p_group_id=>wwv_flow_api.id(350785337301229407)
,p_template_types=>'REPORT'
,p_help_text=>'Hides the Misc column from being rendered on the screen.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(350802409866265726)
,p_theme_id=>42
,p_name=>'ACTIONS_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_api.id(350261643030073247)
,p_css_classes=>'t-ContentRow--hideActions'
,p_group_id=>wwv_flow_api.id(350785675912230663)
,p_template_types=>'REPORT'
,p_help_text=>'Hides the Actions column from being rendered on the screen.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(355501726269314508)
,p_theme_id=>42
,p_name=>'ALIGNMENT_TOP'
,p_display_name=>'Top'
,p_display_sequence=>100
,p_report_template_id=>wwv_flow_api.id(350261643030073247)
,p_css_classes=>'t-ContentRow--alignTop'
,p_group_id=>wwv_flow_api.id(355501396300309305)
,p_template_types=>'REPORT'
,p_help_text=>'Aligns the content to the top of the row. This is useful when you expect that yours rows will vary in height (e.g. some rows will have longer descriptions than others).'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(360797139177944340)
,p_theme_id=>42
,p_name=>'STYLE_COMPACT'
,p_display_name=>'Compact'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(350261643030073247)
,p_css_classes=>'t-ContentRow--styleCompact'
,p_group_id=>wwv_flow_api.id(1525957602312561277)
,p_template_types=>'REPORT'
,p_help_text=>'This option reduces the padding and font sizes to present a compact display of the same information.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(385802123000140486)
,p_theme_id=>42
,p_name=>'HIDE_WHEN_ALL_ROWS_DISPLAYED'
,p_display_name=>'Hide when all rows displayed'
,p_display_sequence=>10
,p_css_classes=>'t-Report--hideNoPagination'
,p_group_id=>wwv_flow_api.id(385801771488104515)
,p_template_types=>'REPORT'
,p_help_text=>'This option will hide the pagination when all rows are displayed.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(389540278597397799)
,p_theme_id=>42
,p_name=>'APPLY_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(614901035349879760)
,p_css_classes=>'u-colors'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(389540525192400322)
,p_theme_id=>42
,p_name=>'CIRCULAR'
,p_display_name=>'Circular'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(614901035349879760)
,p_css_classes=>'t-BadgeList--circular'
,p_group_id=>wwv_flow_api.id(1093528122542993730)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(389540821020401488)
,p_theme_id=>42
,p_name=>'GRID'
,p_display_name=>'Grid'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(614901035349879760)
,p_css_classes=>'t-BadgeList--dash'
,p_group_id=>wwv_flow_api.id(1093528122542993730)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(389542129155407029)
,p_theme_id=>42
,p_name=>'APPLY_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(655615347857707855)
,p_css_classes=>'u-colors'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(389542429691408764)
,p_theme_id=>42
,p_name=>'CIRCULAR'
,p_display_name=>'Circular'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(655615347857707855)
,p_css_classes=>'t-BadgeList--circular'
,p_group_id=>wwv_flow_api.id(1525957602312561277)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(389542753799409875)
,p_theme_id=>42
,p_name=>'GRID'
,p_display_name=>'Grid'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(655615347857707855)
,p_css_classes=>'t-BadgeList--dash'
,p_group_id=>wwv_flow_api.id(1525957602312561277)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(404184383398129367)
,p_theme_id=>42
,p_name=>'HEADING_LEVEL_H1'
,p_display_name=>'H1'
,p_display_sequence=>10
,p_css_classes=>'js-headingLevel-1'
,p_group_id=>wwv_flow_api.id(404184026341118922)
,p_template_types=>'REGION'
,p_help_text=>'H1'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(404184662537133163)
,p_theme_id=>42
,p_name=>'HEADING_LEVEL_H2'
,p_display_name=>'H2'
,p_display_sequence=>20
,p_css_classes=>'js-headingLevel-2'
,p_group_id=>wwv_flow_api.id(404184026341118922)
,p_template_types=>'REGION'
,p_help_text=>'H2'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(404184999231135282)
,p_theme_id=>42
,p_name=>'HEADING_LEVEL_H3'
,p_display_name=>'H3'
,p_display_sequence=>30
,p_css_classes=>'js-headingLevel-3'
,p_group_id=>wwv_flow_api.id(404184026341118922)
,p_template_types=>'REGION'
,p_help_text=>'H3'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(404185218783138294)
,p_theme_id=>42
,p_name=>'H4'
,p_display_name=>'H4'
,p_display_sequence=>40
,p_css_classes=>'js-headingLevel-4'
,p_group_id=>wwv_flow_api.id(404184026341118922)
,p_template_types=>'REGION'
,p_help_text=>'H4'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(404185598946140607)
,p_theme_id=>42
,p_name=>'HEADING_LEVEL_H5'
,p_display_name=>'H5'
,p_display_sequence=>50
,p_css_classes=>'js-headingLevel-5'
,p_group_id=>wwv_flow_api.id(404184026341118922)
,p_template_types=>'REGION'
,p_help_text=>'H5'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(404185849835141952)
,p_theme_id=>42
,p_name=>'HEADING_LEVEL_H6'
,p_display_name=>'H6'
,p_display_sequence=>60
,p_css_classes=>'js-headingLevel-6'
,p_group_id=>wwv_flow_api.id(404184026341118922)
,p_template_types=>'REGION'
,p_help_text=>'H6'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(420237935560308130)
,p_theme_id=>42
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(1018710602436487872)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add shortcuts for menu items. Note that actions.js must be included on your page to support this functionality.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(420238559793325881)
,p_theme_id=>42
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(217865321596155171)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add shortcuts for menu items. Note that actions.js must be included on your page to support this functionality.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(446734458710189573)
,p_theme_id=>42
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(644575648490092151)
,p_css_classes=>'t-MediaList--large force-fa-lg'
,p_group_id=>wwv_flow_api.id(446733723296185373)
,p_template_types=>'REPORT'
,p_help_text=>'Increases the size of the text and icons in the list.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(455321834594513591)
,p_theme_id=>42
,p_name=>'USE_COMPACT_STYLE'
,p_display_name=>'Use Compact Style'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1082434711915925186)
,p_css_classes=>'t-BreadcrumbRegion--compactTitle'
,p_template_types=>'REGION'
,p_help_text=>'Uses a compact style for the breadcrumbs.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(481104777436103223)
,p_theme_id=>42
,p_name=>'TEXT_CONTENT'
,p_display_name=>'Text Content'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--textContent'
,p_group_id=>wwv_flow_api.id(686932753785028101)
,p_template_types=>'REGION'
,p_help_text=>'Useful for displaying primarily text-based content, such as FAQs and more.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(525375534202309688)
,p_theme_id=>42
,p_name=>'ICON_DEFAULT'
,p_display_name=>'Icon (Default)'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(1018710602436487872)
,p_css_classes=>'js-navCollapsed--default'
,p_group_id=>wwv_flow_api.id(341348731255729287)
,p_template_types=>'LIST'
,p_help_text=>'Display icons when the navigation menu is collapsed for large screens.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(533164987261211784)
,p_theme_id=>42
,p_name=>'COLLAPSED_DEFAULT'
,p_display_name=>'Collapsed by Default'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(1018710602436487872)
,p_css_classes=>'js-defaultCollapsed'
,p_template_types=>'LIST'
,p_help_text=>'This option will load the side navigation menu in a collapsed state by default.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(536323872783725783)
,p_theme_id=>42
,p_name=>'STRETCH_TO_FIT_WINDOW'
,p_display_name=>'Stretch to Fit Window'
,p_display_sequence=>1
,p_page_template_id=>wwv_flow_api.id(651378991620880020)
,p_css_classes=>'ui-dialog--stretch'
,p_template_types=>'PAGE'
,p_help_text=>'Stretch the dialog to fit the browser window.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(536325439502731177)
,p_theme_id=>42
,p_name=>'STRETCH_TO_FIT_WINDOW'
,p_display_name=>'Stretch to Fit Window'
,p_display_sequence=>10
,p_page_template_id=>wwv_flow_api.id(672766417768219611)
,p_css_classes=>'ui-dialog--stretch'
,p_template_types=>'PAGE'
,p_help_text=>'Stretch the dialog to fit the browser window.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(562970700525845496)
,p_theme_id=>42
,p_name=>'AUTO_HEIGHT_INLINE_DIALOG'
,p_display_name=>'Auto Height'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1223645131968329858)
,p_css_classes=>'js-dialog-autoheight'
,p_template_types=>'REGION'
,p_help_text=>'This option will set the height of the dialog to fit its contents.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(576282688780451553)
,p_theme_id=>42
,p_name=>'REMOVE_PADDING'
,p_display_name=>'Remove Padding'
,p_display_sequence=>1
,p_css_classes=>'t-PageBody--noContentPadding'
,p_group_id=>wwv_flow_api.id(576117721821431474)
,p_template_types=>'PAGE'
,p_help_text=>'Removes padding from the content region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(582142144315170056)
,p_theme_id=>42
,p_name=>'DISPLAY_AS_LINK'
,p_display_name=>'Display as Link'
,p_display_sequence=>30
,p_css_classes=>'t-Button--link'
,p_group_id=>wwv_flow_api.id(686936498799028101)
,p_template_types=>'BUTTON'
,p_help_text=>'This option makes the button appear as a text link.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(582143375393191970)
,p_theme_id=>42
,p_name=>'SMALLTOPMARGIN'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_css_classes=>'t-Button--padTop'
,p_group_id=>wwv_flow_api.id(582142591229178435)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(582143651912193762)
,p_theme_id=>42
,p_name=>'LARGETOPMARGIN'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_css_classes=>'t-Button--gapTop'
,p_group_id=>wwv_flow_api.id(582142591229178435)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(582143967848196059)
,p_theme_id=>42
,p_name=>'SMALLBOTTOMMARGIN'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_css_classes=>'t-Button--padBottom'
,p_group_id=>wwv_flow_api.id(582143096365182722)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(582144229162198170)
,p_theme_id=>42
,p_name=>'LARGEBOTTOMMARGIN'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_css_classes=>'t-Button--gapBottom'
,p_group_id=>wwv_flow_api.id(582143096365182722)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(582152958347346516)
,p_theme_id=>42
,p_name=>'TINY'
,p_display_name=>'Tiny'
,p_display_sequence=>10
,p_css_classes=>'t-Button--tiny'
,p_group_id=>wwv_flow_api.id(686929122234028100)
,p_template_types=>'BUTTON'
,p_help_text=>'A very small button.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(596231510749560661)
,p_theme_id=>42
,p_name=>'FORMSTANDARDPADDING'
,p_display_name=>'Standard'
,p_display_sequence=>5
,p_css_classes=>'t-Form--standardPadding'
,p_group_id=>wwv_flow_api.id(686935492736028101)
,p_template_types=>'REGION'
,p_help_text=>'Uses the standard spacing between items.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(596474915819054647)
,p_theme_id=>42
,p_name=>'INDICATOR_ASTERISK'
,p_display_name=>'Asterisk'
,p_display_sequence=>10
,p_field_template_id=>wwv_flow_api.id(160093532401945979)
,p_css_classes=>'t-Form-fieldContainer--indicatorAsterisk'
,p_group_id=>wwv_flow_api.id(596249650773764068)
,p_template_types=>'FIELD'
,p_help_text=>'Displays an asterisk * on required items.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(596476182717182451)
,p_theme_id=>42
,p_name=>'INDICATOR_ASTERISK'
,p_display_name=>'Asterisk'
,p_display_sequence=>10
,p_field_template_id=>wwv_flow_api.id(1077732000333505897)
,p_css_classes=>'t-Form-fieldContainer--indicatorAsterisk'
,p_group_id=>wwv_flow_api.id(596249650773764068)
,p_template_types=>'FIELD'
,p_help_text=>'Displays an asterisk * on required items.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(596476519207191651)
,p_theme_id=>42
,p_name=>'INDICATOR_LABEL'
,p_display_name=>'Inline Label'
,p_display_sequence=>20
,p_field_template_id=>wwv_flow_api.id(1077732000333505897)
,p_css_classes=>'t-Form-fieldContainer--indicatorLabel'
,p_group_id=>wwv_flow_api.id(596249650773764068)
,p_template_types=>'FIELD'
,p_help_text=>'Displays "Required" inline.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(596476841686195361)
,p_theme_id=>42
,p_name=>'INDICATOR_ASTERISK'
,p_display_name=>'Asterisk'
,p_display_sequence=>10
,p_field_template_id=>wwv_flow_api.id(1582533317526763209)
,p_css_classes=>'t-Form-fieldContainer--indicatorAsterisk'
,p_group_id=>wwv_flow_api.id(596249650773764068)
,p_template_types=>'FIELD'
,p_help_text=>'Displays an asterisk * on required items.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(596477197814200874)
,p_theme_id=>42
,p_name=>'INDICATOR_LABEL'
,p_display_name=>'Inline Label'
,p_display_sequence=>20
,p_field_template_id=>wwv_flow_api.id(1582533317526763209)
,p_css_classes=>'t-Form-fieldContainer--indicatorLabel'
,p_group_id=>wwv_flow_api.id(596249650773764068)
,p_template_types=>'FIELD'
,p_help_text=>'Displays "Required" inline.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(596477462768203924)
,p_theme_id=>42
,p_name=>'INDICATOR_LABEL'
,p_display_name=>'Inline Label'
,p_display_sequence=>20
,p_field_template_id=>wwv_flow_api.id(160093532401945979)
,p_css_classes=>'t-Form-fieldContainer--indicatorLabel'
,p_group_id=>wwv_flow_api.id(596249650773764068)
,p_template_types=>'FIELD'
,p_help_text=>'Displays "Required" inline.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(600035619556705078)
,p_theme_id=>42
,p_name=>'NOBORDER'
,p_display_name=>'Remove Borders'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--noBorder'
,p_group_id=>wwv_flow_api.id(686932753785028101)
,p_template_types=>'REGION'
,p_help_text=>'Removes borders from the region.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(602853461239198628)
,p_theme_id=>42
,p_name=>'NOBODYPADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes padding from region body.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(602853620109202595)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stack Region'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--stacked'
,p_group_id=>wwv_flow_api.id(686932753785028101)
,p_template_types=>'REGION'
,p_help_text=>'Removes side borders and shadows, and can be useful for accordions and regions that need to be grouped together vertically.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(602893817874299585)
,p_theme_id=>42
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'i-h240'
,p_group_id=>wwv_flow_api.id(686935554787028101)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 240px.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(602894866897301163)
,p_theme_id=>42
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'i-h320'
,p_group_id=>wwv_flow_api.id(686935554787028101)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 320px.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(602900228684367254)
,p_theme_id=>42
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(591654834181983844)
,p_css_classes=>'t-Alert--wizard'
,p_group_id=>wwv_flow_api.id(686930381900028100)
,p_template_types=>'REGION'
,p_help_text=>'Show the alert in a wizard style region.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(602900497107369926)
,p_theme_id=>42
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(591654834181983844)
,p_css_classes=>'t-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(686930381900028100)
,p_template_types=>'REGION'
,p_help_text=>'Show horizontal alert with buttons to the right.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(602900803681376271)
,p_theme_id=>42
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(591654834181983844)
,p_css_classes=>'t-Alert--warning'
,p_group_id=>wwv_flow_api.id(686935600596028101)
,p_template_types=>'REGION'
,p_help_text=>'Show a warning alert.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(602901061803377891)
,p_theme_id=>42
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(591654834181983844)
,p_css_classes=>'t-Alert--success'
,p_group_id=>wwv_flow_api.id(686935600596028101)
,p_template_types=>'REGION'
,p_help_text=>'Show success alert.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(602901212250385190)
,p_theme_id=>42
,p_name=>'DANGER'
,p_display_name=>'Danger'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(591654834181983844)
,p_css_classes=>'t-Alert--danger'
,p_group_id=>wwv_flow_api.id(686935600596028101)
,p_template_types=>'REGION'
,p_help_text=>'Show an error or danger alert.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(602902611617394912)
,p_theme_id=>42
,p_name=>'COLOREDBACKGROUND'
,p_display_name=>'Highlight Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(591654834181983844)
,p_css_classes=>'t-Alert--colorBG'
,p_template_types=>'REGION'
,p_help_text=>'Set alert background color to that of the alert type (warning, success, etc.)'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(602902878720396440)
,p_theme_id=>42
,p_name=>'INFORMATION'
,p_display_name=>'Information'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(591654834181983844)
,p_css_classes=>'t-Alert--info'
,p_group_id=>wwv_flow_api.id(686935600596028101)
,p_template_types=>'REGION'
,p_help_text=>'Show informational alert.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(602908977429443127)
,p_theme_id=>42
,p_name=>'USEDEFAULTICONS'
,p_display_name=>'Show Default Icons'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(591654834181983844)
,p_css_classes=>'t-Alert--defaultIcons'
,p_group_id=>wwv_flow_api.id(1819504545813380867)
,p_template_types=>'REGION'
,p_help_text=>'Uses default icons for alert types.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(620482902253879261)
,p_theme_id=>42
,p_name=>'SPANHORIZONTAL'
,p_display_name=>'Span Horizontal'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_css_classes=>'t-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
,p_help_text=>'Show all list items in one horizontal row.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(620483121048882086)
,p_theme_id=>42
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_css_classes=>'t-MediaList--cols t-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(620483509964884914)
,p_theme_id=>42
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_css_classes=>'t-MediaList--cols t-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(620483726066885981)
,p_theme_id=>42
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_css_classes=>'t-MediaList--cols t-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(620483948191887217)
,p_theme_id=>42
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_css_classes=>'t-MediaList--cols t-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(620539348195152034)
,p_theme_id=>42
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>70
,p_list_template_id=>wwv_flow_api.id(614901035349879760)
,p_css_classes=>'t-BadgeList--float'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
,p_help_text=>'Float badges to left'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(620539512442154321)
,p_theme_id=>42
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>80
,p_list_template_id=>wwv_flow_api.id(614901035349879760)
,p_css_classes=>'t-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
,p_help_text=>'Use flexbox to arrange items'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(620541965646162313)
,p_theme_id=>42
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>60
,p_list_template_id=>wwv_flow_api.id(614901035349879760)
,p_css_classes=>'t-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
,p_help_text=>'Span badges horizontally'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(620542157011164636)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(614901035349879760)
,p_css_classes=>'t-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
,p_help_text=>'Stack badges on top of each other'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(620542572920168235)
,p_theme_id=>42
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(614901035349879760)
,p_css_classes=>'t-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
,p_help_text=>'Arrange badges in a two column grid'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(620553729890174648)
,p_theme_id=>42
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(614901035349879760)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
,p_help_text=>'Arrange badges in a 3 column grid'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(620553913715176130)
,p_theme_id=>42
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_api.id(614901035349879760)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
,p_help_text=>'Arrange badges in 4 column grid'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(620554128698178151)
,p_theme_id=>42
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_api.id(614901035349879760)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
,p_help_text=>'Arrange badges in a 5 column grid'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(620556013388184603)
,p_theme_id=>42
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(614901035349879760)
,p_css_classes=>'t-BadgeList--small'
,p_group_id=>wwv_flow_api.id(686934198962028101)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(620556208977186747)
,p_theme_id=>42
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(614901035349879760)
,p_css_classes=>'t-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(686934198962028101)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(620556460887189232)
,p_theme_id=>42
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(614901035349879760)
,p_css_classes=>'t-BadgeList--large'
,p_group_id=>wwv_flow_api.id(686934198962028101)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(620556848772193409)
,p_theme_id=>42
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_api.id(614901035349879760)
,p_css_classes=>'t-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(686934198962028101)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(623698787642029943)
,p_theme_id=>42
,p_name=>'STYLE_A'
,p_display_name=>'Style A'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(623695900776932839)
,p_css_classes=>'t-CardsRegion--styleA'
,p_group_id=>wwv_flow_api.id(686932753785028101)
,p_template_types=>'REGION'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(623699037968030780)
,p_theme_id=>42
,p_name=>'STYLE_B'
,p_display_name=>'Style B'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(623695900776932839)
,p_css_classes=>'t-CardsRegion--styleB'
,p_group_id=>wwv_flow_api.id(686932753785028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(623699337248031799)
,p_theme_id=>42
,p_name=>'STYLE_C'
,p_display_name=>'Style C'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(623695900776932839)
,p_css_classes=>'t-CardsRegion--styleC'
,p_group_id=>wwv_flow_api.id(686932753785028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(624543341761604055)
,p_theme_id=>42
,p_name=>'HEADING_FONT_ALTERNATIVE'
,p_display_name=>'Alternative'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1082434711915925186)
,p_css_classes=>'t-BreadcrumbRegion--headingFontAlt'
,p_group_id=>wwv_flow_api.id(624295607366539525)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(624578505782678221)
,p_theme_id=>42
,p_name=>'HEADING_FONT_ALTERNATIVE'
,p_display_name=>'Alternative'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1224989219520090364)
,p_css_classes=>'t-HeroRegion--headingFontAlt'
,p_group_id=>wwv_flow_api.id(624295607366539525)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(624579297437681868)
,p_theme_id=>42
,p_name=>'HEADING_FONT_ALTERNATIVE'
,p_display_name=>'Alternative'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(873087052820635270)
,p_css_classes=>'t-ContentBlock--headingFontAlt'
,p_group_id=>wwv_flow_api.id(624295607366539525)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(629612070677575318)
,p_theme_id=>42
,p_name=>'APPLY_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(623695900776932839)
,p_css_classes=>'u-colors'
,p_template_types=>'REGION'
,p_help_text=>'Applies the colors from the theme''s color palette to the icons or initials within cards.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(631232387342532111)
,p_theme_id=>42
,p_name=>'ALLSTEPS'
,p_display_name=>'All Steps'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(561120526789187584)
,p_css_classes=>'t-WizardSteps--displayLabels'
,p_group_id=>wwv_flow_api.id(686930602304028100)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(631232765266535093)
,p_theme_id=>42
,p_name=>'CURRENTSTEPONLY'
,p_display_name=>'Current Step Only'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(561120526789187584)
,p_css_classes=>'t-WizardSteps--displayCurrentLabelOnly'
,p_group_id=>wwv_flow_api.id(686930602304028100)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(631233887528541325)
,p_theme_id=>42
,p_name=>'HIDELABELS'
,p_display_name=>'Hide Labels'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(561120526789187584)
,p_css_classes=>'t-WizardSteps--hideLabels'
,p_group_id=>wwv_flow_api.id(686930602304028100)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(631238384520579676)
,p_theme_id=>42
,p_name=>'SCROLLBODY'
,p_display_name=>'Scroll - Default'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--scrollBody'
,p_group_id=>wwv_flow_api.id(686931442667028100)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(632850642362803892)
,p_theme_id=>42
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_api.id(614901035349879760)
,p_css_classes=>'t-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(686934198962028101)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(632852164656819345)
,p_theme_id=>42
,p_name=>'SHOWICONS'
,p_display_name=>'For All Items'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(2623332529225852414)
,p_css_classes=>'t-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(686935738222028101)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(632855381042841052)
,p_theme_id=>42
,p_name=>'HIDEREGIONHEADER'
,p_display_name=>'Hidden but accessible'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(686930518563028100)
,p_template_types=>'REGION'
,p_help_text=>'This option will hide the region header.  Note that the region title will still be audible for Screen Readers. Buttons placed in the region header will be hidden and inaccessible.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(632929080064468607)
,p_theme_id=>42
,p_name=>'REMOVEALLBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(1089625725920080767)
,p_css_classes=>'t-Report--noBorders'
,p_group_id=>wwv_flow_api.id(686934361014028101)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(632929223441470267)
,p_theme_id=>42
,p_name=>'STRETCHREPORT'
,p_display_name=>'Stretch Report'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(1089625725920080767)
,p_css_classes=>'t-Report--stretch'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(632929446541476696)
,p_theme_id=>42
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'No Outer Borders'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_api.id(1089625725920080767)
,p_css_classes=>'t-Report--inline'
,p_group_id=>wwv_flow_api.id(686934361014028101)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(632929602414480112)
,p_theme_id=>42
,p_name=>'ALTROWCOLORSDISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(1089625725920080767)
,p_css_classes=>'t-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(686930751269028100)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(632929846310482325)
,p_theme_id=>42
,p_name=>'ALTROWCOLORSENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(1089625725920080767)
,p_css_classes=>'t-Report--altRowsDefault'
,p_group_id=>wwv_flow_api.id(686930751269028100)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(632930608553506317)
,p_theme_id=>42
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Only'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(1089625725920080767)
,p_css_classes=>'t-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(686934361014028101)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(632930811468507680)
,p_theme_id=>42
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Only'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(1089625725920080767)
,p_css_classes=>'t-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(686934361014028101)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(632932511116537063)
,p_theme_id=>42
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(1089625725920080767)
,p_css_classes=>'t-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(686935812869028101)
,p_template_types=>'REPORT'
,p_help_text=>'Enable row highlighting on mouse over'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(632932708101540953)
,p_theme_id=>42
,p_name=>'ROWHIGHLIGHTDISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(1089625725920080767)
,p_css_classes=>'t-Report--rowHighlightOff'
,p_group_id=>wwv_flow_api.id(686935812869028101)
,p_template_types=>'REPORT'
,p_help_text=>'Disable row highlighting on mouse over'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(637548659512161172)
,p_theme_id=>42
,p_name=>'SHOWGOTOARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(2623332529225852414)
,p_css_classes=>'t-LinksList--showArrow'
,p_template_types=>'LIST'
,p_help_text=>'Show arrow to the right of link'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(637548802658166014)
,p_theme_id=>42
,p_name=>'DISABLETEXTWRAPPING'
,p_display_name=>'Disable Text Wrapping'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(2623332529225852414)
,p_css_classes=>'t-LinksList--nowrap'
,p_template_types=>'LIST'
,p_help_text=>'Do not allow link text to wrap to new lines. Truncate with ellipsis.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(637549022650170015)
,p_theme_id=>42
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(2623332529225852414)
,p_css_classes=>'t-LinksList--showBadge'
,p_template_types=>'LIST'
,p_help_text=>'Show badge to right of link (requires Attribute 1 to be populated)'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(637596471768731223)
,p_theme_id=>42
,p_name=>'SHOWTOPICONS'
,p_display_name=>'For Top Level Items Only'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(2623332529225852414)
,p_css_classes=>'t-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(686935738222028101)
,p_template_types=>'LIST'
,p_help_text=>'This will show icons for top level items of the list only. It will not show icons for sub lists.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(642559281767120949)
,p_theme_id=>42
,p_name=>'HIDEOVERFLOW'
,p_display_name=>'Hide'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--hiddenOverflow'
,p_group_id=>wwv_flow_api.id(686931442667028100)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(644576242429100106)
,p_theme_id=>42
,p_name=>'2_COLUMN_GRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(644575648490092151)
,p_css_classes=>'t-MediaList--cols t-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(644576556343101535)
,p_theme_id=>42
,p_name=>'3_COLUMN_GRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(644575648490092151)
,p_css_classes=>'t-MediaList--cols t-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(644576881273102676)
,p_theme_id=>42
,p_name=>'4_COLUMN_GRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(644575648490092151)
,p_css_classes=>'t-MediaList--cols t-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(644577152378104341)
,p_theme_id=>42
,p_name=>'5_COLUMN_GRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_api.id(644575648490092151)
,p_css_classes=>'t-MediaList--cols t-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(644581268880124694)
,p_theme_id=>42
,p_name=>'STACK'
,p_display_name=>'Stack'
,p_display_sequence=>5
,p_report_template_id=>wwv_flow_api.id(644575648490092151)
,p_css_classes=>'t-MediaList--stack'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(644581505592126644)
,p_theme_id=>42
,p_name=>'SPAN_HORIZONTAL'
,p_display_name=>'Span Horizontal'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_api.id(644575648490092151)
,p_css_classes=>'t-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(644582003102129455)
,p_theme_id=>42
,p_name=>'SHOW_ICONS'
,p_display_name=>'Show Icons'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(644575648490092151)
,p_css_classes=>'t-MediaList--showIcons'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(644582770755132175)
,p_theme_id=>42
,p_name=>'SHOW_DESCRIPTION'
,p_display_name=>'Show Description'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(644575648490092151)
,p_css_classes=>'t-MediaList--showDesc'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(644583027884133496)
,p_theme_id=>42
,p_name=>'SHOW_BADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(644575648490092151)
,p_css_classes=>'t-MediaList--showBadges'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(644583396537134489)
,p_theme_id=>42
,p_name=>'APPLY_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_api.id(644575648490092151)
,p_css_classes=>'u-colors'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(655580565028370985)
,p_theme_id=>42
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(651498026300583706)
,p_css_classes=>'t-IRR-region--noBorders'
,p_template_types=>'REGION'
,p_help_text=>'Removes borders around the Interactive Report'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(655618661385728558)
,p_theme_id=>42
,p_name=>'128PX'
,p_display_name=>'128px'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_api.id(655615347857707855)
,p_css_classes=>'t-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(686929314140028100)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(655618845630730307)
,p_theme_id=>42
,p_name=>'32PX'
,p_display_name=>'32px'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(655615347857707855)
,p_css_classes=>'t-BadgeList--small'
,p_group_id=>wwv_flow_api.id(686929314140028100)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(655619007069730954)
,p_theme_id=>42
,p_name=>'48PX'
,p_display_name=>'48px'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(655615347857707855)
,p_css_classes=>'t-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(686929314140028100)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(655619408394731732)
,p_theme_id=>42
,p_name=>'64PX'
,p_display_name=>'64px'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(655615347857707855)
,p_css_classes=>'t-BadgeList--large'
,p_group_id=>wwv_flow_api.id(686929314140028100)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(655619658172732738)
,p_theme_id=>42
,p_name=>'96PX'
,p_display_name=>'96px'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_api.id(655615347857707855)
,p_css_classes=>'t-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(686929314140028100)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(655620810758737160)
,p_theme_id=>42
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(655615347857707855)
,p_css_classes=>'t-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
,p_help_text=>'Arrange badges in a two column grid'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(655621033870739147)
,p_theme_id=>42
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(655615347857707855)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
,p_help_text=>'Arrange badges in a 3 column grid'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(655621265054740302)
,p_theme_id=>42
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_api.id(655615347857707855)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(655621457712741266)
,p_theme_id=>42
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_api.id(655615347857707855)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(655621625387742361)
,p_theme_id=>42
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>80
,p_report_template_id=>wwv_flow_api.id(655615347857707855)
,p_css_classes=>'t-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(655621875247743157)
,p_theme_id=>42
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>70
,p_report_template_id=>wwv_flow_api.id(655615347857707855)
,p_css_classes=>'t-BadgeList--float'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(655622017439744047)
,p_theme_id=>42
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_api.id(655615347857707855)
,p_css_classes=>'t-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(655622279322744947)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(655615347857707855)
,p_css_classes=>'t-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(666746910751158846)
,p_theme_id=>42
,p_name=>'DISPLAY_ITEMS_STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(666744069198116681)
,p_css_classes=>'t-ContextualInfo-item--stacked'
,p_group_id=>wwv_flow_api.id(666745372691130214)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(666747212066160929)
,p_theme_id=>42
,p_name=>'DISPLAY_LABELS_STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(666744069198116681)
,p_css_classes=>'t-ContextualInfo-label--stacked'
,p_group_id=>wwv_flow_api.id(666745984744136740)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(668308099618062345)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>20
,p_page_template_id=>wwv_flow_api.id(651378991620880020)
,p_css_classes=>'t-Dialog--noPadding'
,p_template_types=>'PAGE'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(668310294328068024)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>20
,p_page_template_id=>wwv_flow_api.id(672766417768219611)
,p_css_classes=>'t-Dialog--noPadding'
,p_template_types=>'PAGE'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(670141940193619051)
,p_theme_id=>42
,p_name=>'HIDESMALLSCREENS'
,p_display_name=>'Small Screens (Tablet)'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(670020401234384587)
,p_css_classes=>'t-Wizard--hideStepsSmall'
,p_group_id=>wwv_flow_api.id(686932933875028101)
,p_template_types=>'REGION'
,p_help_text=>'Hides the wizard progress steps for screens that are smaller than 768px wide.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(670142159644622493)
,p_theme_id=>42
,p_name=>'HIDEXSMALLSCREENS'
,p_display_name=>'X Small Screens (Mobile)'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(670020401234384587)
,p_css_classes=>'t-Wizard--hideStepsXSmall'
,p_group_id=>wwv_flow_api.id(686932933875028101)
,p_template_types=>'REGION'
,p_help_text=>'Hides the wizard progress steps for screens that are smaller than 768px wide.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(672662339530258211)
,p_theme_id=>42
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>10
,p_css_classes=>'t-Button--primary'
,p_group_id=>wwv_flow_api.id(686936339267028101)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(672662696819258212)
,p_theme_id=>42
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>10
,p_css_classes=>'t-Button--stretch'
,p_group_id=>wwv_flow_api.id(686937130886028102)
,p_template_types=>'BUTTON'
,p_help_text=>'Stretches button to fill container'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(672662911341258213)
,p_theme_id=>42
,p_name=>'DANGER'
,p_display_name=>'Danger'
,p_display_sequence=>30
,p_css_classes=>'t-Button--danger'
,p_group_id=>wwv_flow_api.id(686936339267028101)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(672663283794258213)
,p_theme_id=>42
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>40
,p_css_classes=>'t-Button--success'
,p_group_id=>wwv_flow_api.id(686936339267028101)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(672663844828258213)
,p_theme_id=>42
,p_name=>'NOUI'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>20
,p_css_classes=>'t-Button--noUI'
,p_group_id=>wwv_flow_api.id(686936498799028101)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(672664184112258213)
,p_theme_id=>42
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>30
,p_css_classes=>'t-Button--large'
,p_group_id=>wwv_flow_api.id(686929122234028100)
,p_template_types=>'BUTTON'
,p_help_text=>'A large button.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(672664470249258213)
,p_theme_id=>42
,p_name=>'SMALLLEFTMARGIN'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_css_classes=>'t-Button--padLeft'
,p_group_id=>wwv_flow_api.id(686934921941028101)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(672664788706258214)
,p_theme_id=>42
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'t-Button--small'
,p_group_id=>wwv_flow_api.id(686929122234028100)
,p_template_types=>'BUTTON'
,p_help_text=>'A small button.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(672665035925258214)
,p_theme_id=>42
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>20
,p_css_classes=>'t-Button--warning'
,p_group_id=>wwv_flow_api.id(686936339267028101)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(672665682932258214)
,p_theme_id=>42
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>10
,p_css_classes=>'t-Button--simple'
,p_group_id=>wwv_flow_api.id(686936498799028101)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(672665998112258215)
,p_theme_id=>42
,p_name=>'LARGELEFTMARGIN'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_css_classes=>'t-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(686934921941028101)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(672666225547258215)
,p_theme_id=>42
,p_name=>'SMALLRIGHTMARGIN'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_css_classes=>'t-Button--padRight'
,p_group_id=>wwv_flow_api.id(686932039417028101)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(672666554971258215)
,p_theme_id=>42
,p_name=>'LARGERIGHTMARGIN'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_css_classes=>'t-Button--gapRight'
,p_group_id=>wwv_flow_api.id(686932039417028101)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(672666808305258216)
,p_theme_id=>42
,p_name=>'PILLSTART'
,p_display_name=>'First Button'
,p_display_sequence=>10
,p_css_classes=>'t-Button--pillStart'
,p_group_id=>wwv_flow_api.id(686932190740028101)
,p_template_types=>'BUTTON'
,p_help_text=>'Use this for the start of a pill button.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(672667103292258216)
,p_theme_id=>42
,p_name=>'PILL'
,p_display_name=>'Inner Button'
,p_display_sequence=>20
,p_css_classes=>'t-Button--pill'
,p_group_id=>wwv_flow_api.id(686932190740028101)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(672667464496258217)
,p_theme_id=>42
,p_name=>'PILLEND'
,p_display_name=>'Last Button'
,p_display_sequence=>30
,p_css_classes=>'t-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(686932190740028101)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(673224766759925807)
,p_theme_id=>42
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>10
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_css_classes=>'t-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(686930833556028100)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(673224976885926841)
,p_theme_id=>42
,p_name=>'RIGHTICON'
,p_display_name=>'Right'
,p_display_sequence=>20
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_css_classes=>'t-Button--iconRight'
,p_group_id=>wwv_flow_api.id(686930833556028100)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(677454643993813297)
,p_theme_id=>42
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>4
,p_region_template_id=>wwv_flow_api.id(677400524731372757)
,p_css_classes=>'t-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(686932753785028101)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(677454804770815157)
,p_theme_id=>42
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(677400524731372757)
,p_css_classes=>'t-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(686932753785028101)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(677469563819099303)
,p_theme_id=>42
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>5
,p_region_template_id=>wwv_flow_api.id(677400524731372757)
,p_css_classes=>'t-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(686938015244028102)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(677469976402100363)
,p_theme_id=>42
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>3
,p_region_template_id=>wwv_flow_api.id(677400524731372757)
,p_css_classes=>'t-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(686938015244028102)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(677533426928384394)
,p_theme_id=>42
,p_name=>'HIDDENHEADERNOAT'
,p_display_name=>'Hidden'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--removeHeader js-removeLandmark'
,p_group_id=>wwv_flow_api.id(686930518563028100)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(678341816064160644)
,p_theme_id=>42
,p_name=>'FORMLEFTLABELS'
,p_display_name=>'Left'
,p_display_sequence=>20
,p_css_classes=>'t-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(940959055224631412)
,p_template_types=>'REGION'
,p_help_text=>'Align form labels to left.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(678345091102220861)
,p_theme_id=>42
,p_name=>'FORMSIZELARGE'
,p_display_name=>'Large'
,p_display_sequence=>10
,p_css_classes=>'t-Form--large'
,p_group_id=>wwv_flow_api.id(686931906521028101)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(678345257809222117)
,p_theme_id=>42
,p_name=>'FORMSIZEXLARGE'
,p_display_name=>'X Large'
,p_display_sequence=>20
,p_css_classes=>'t-Form--xlarge'
,p_group_id=>wwv_flow_api.id(686931906521028101)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(678346090849233251)
,p_theme_id=>42
,p_name=>'FORMSLIMPADDING'
,p_display_name=>'Slim'
,p_display_sequence=>10
,p_css_classes=>'t-Form--slimPadding'
,p_group_id=>wwv_flow_api.id(686935492736028101)
,p_template_types=>'REGION'
,p_help_text=>'Reduces form item spacing.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(678346529637235955)
,p_theme_id=>42
,p_name=>'FORMREMOVEPADDING'
,p_display_name=>'None'
,p_display_sequence=>20
,p_css_classes=>'t-Form--noPadding'
,p_group_id=>wwv_flow_api.id(686935492736028101)
,p_template_types=>'REGION'
,p_help_text=>'Removes spacing between items.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(678350070302310559)
,p_theme_id=>42
,p_name=>'SHOWFORMLABELSABOVE'
,p_display_name=>'Show Form Labels Above'
,p_display_sequence=>10
,p_css_classes=>'t-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(940979718001664041)
,p_template_types=>'REGION'
,p_help_text=>'Show form labels above input fields.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(691404462935188947)
,p_theme_id=>42
,p_name=>'ACCENT_6'
,p_display_name=>'Accent 6'
,p_display_sequence=>60
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--accent6'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(691404717750190229)
,p_theme_id=>42
,p_name=>'ACCENT_7'
,p_display_name=>'Accent 7'
,p_display_sequence=>70
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--accent7'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(691405043740190972)
,p_theme_id=>42
,p_name=>'ACCENT_8'
,p_display_name=>'Accent 8'
,p_display_sequence=>80
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--accent8'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(691405349043191891)
,p_theme_id=>42
,p_name=>'ACCENT_9'
,p_display_name=>'Accent 9'
,p_display_sequence=>90
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--accent9'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(691405656235192804)
,p_theme_id=>42
,p_name=>'ACCENT_10'
,p_display_name=>'Accent 10'
,p_display_sequence=>100
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--accent10'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(691405902036193648)
,p_theme_id=>42
,p_name=>'ACCENT_11'
,p_display_name=>'Accent 11'
,p_display_sequence=>110
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--accent11'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(691406231942194568)
,p_theme_id=>42
,p_name=>'ACCENT_12'
,p_display_name=>'Accent 12'
,p_display_sequence=>120
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--accent12'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(691406509795195574)
,p_theme_id=>42
,p_name=>'ACCENT_13'
,p_display_name=>'Accent 13'
,p_display_sequence=>130
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--accent13'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(691406822029196664)
,p_theme_id=>42
,p_name=>'ACCENT_14'
,p_display_name=>'Accent 14'
,p_display_sequence=>140
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--accent14'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(691407143550197660)
,p_theme_id=>42
,p_name=>'ACCENT_15'
,p_display_name=>'Accent 15'
,p_display_sequence=>150
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--accent15'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(720403722871842452)
,p_theme_id=>42
,p_name=>'FEATURED'
,p_display_name=>'Featured'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1224989219520090364)
,p_css_classes=>'t-HeroRegion--featured'
,p_group_id=>wwv_flow_api.id(686932753785028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(720404048327844150)
,p_theme_id=>42
,p_name=>'STACKED_FEATURED'
,p_display_name=>'Stacked Featured'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1224989219520090364)
,p_css_classes=>'t-HeroRegion--featured t-HeroRegion--centered'
,p_group_id=>wwv_flow_api.id(686932753785028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(720408287624887878)
,p_theme_id=>42
,p_name=>'DISPLAY_ICON_NO'
,p_display_name=>'No'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1224989219520090364)
,p_css_classes=>'t-HeroRegion--hideIcon'
,p_group_id=>wwv_flow_api.id(720406663650878470)
,p_template_types=>'REGION'
,p_help_text=>'Hide the Hero Region icon.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(752336251168448492)
,p_theme_id=>42
,p_name=>'STICK_TO_BOTTOM'
,p_display_name=>'Stick to Bottom for Mobile'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(677400524731372757)
,p_css_classes=>'t-ButtonRegion--stickToBottom'
,p_template_types=>'REGION'
,p_help_text=>'This will position the button container region to the bottom of the screen for small screens.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(767873229249082891)
,p_theme_id=>42
,p_name=>'STICKY_HEADER_ON_MOBILE'
,p_display_name=>'Sticky Header on Mobile'
,p_display_sequence=>100
,p_page_template_id=>wwv_flow_api.id(1077614758642401794)
,p_css_classes=>'js-pageStickyMobileHeader'
,p_template_types=>'PAGE'
,p_help_text=>'This will position the contents of the Breadcrumb Bar region position so it sticks to the top of the screen for small screens.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(767876055517107778)
,p_theme_id=>42
,p_name=>'STICKY_HEADER_ON_MOBILE'
,p_display_name=>'Sticky Header on Mobile'
,p_display_sequence=>100
,p_page_template_id=>wwv_flow_api.id(1077621880644450151)
,p_css_classes=>'js-pageStickyMobileHeader'
,p_template_types=>'PAGE'
,p_help_text=>'This will position the contents of the Breadcrumb Bar region position so it sticks to the top of the screen for small screens.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(767877353755110428)
,p_theme_id=>42
,p_name=>'STICKY_HEADER_ON_MOBILE'
,p_display_name=>'Sticky Header on Mobile'
,p_display_sequence=>100
,p_page_template_id=>wwv_flow_api.id(549332834543365415)
,p_css_classes=>'js-pageStickyMobileHeader'
,p_template_types=>'PAGE'
,p_help_text=>'This will position the contents of the Breadcrumb Bar region position so it sticks to the top of the screen for small screens.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(767878173152112950)
,p_theme_id=>42
,p_name=>'STICKY_HEADER_ON_MOBILE'
,p_display_name=>'Sticky Header on Mobile'
,p_display_sequence=>100
,p_page_template_id=>wwv_flow_api.id(1530046751615002521)
,p_css_classes=>'js-pageStickyMobileHeader'
,p_template_types=>'PAGE'
,p_help_text=>'This will position the contents of the Breadcrumb Bar region position so it sticks to the top of the screen for small screens.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(767879415863114863)
,p_theme_id=>42
,p_name=>'STICKY_HEADER_ON_MOBILE'
,p_display_name=>'Sticky Header on Mobile'
,p_display_sequence=>100
,p_page_template_id=>wwv_flow_api.id(1077618304322444671)
,p_css_classes=>'js-pageStickyMobileHeader'
,p_template_types=>'PAGE'
,p_help_text=>'This will position the contents of the Breadcrumb Bar region position so it sticks to the top of the screen for small screens.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(767880286329116551)
,p_theme_id=>42
,p_name=>'STICKY_HEADER_ON_MOBILE'
,p_display_name=>'Sticky Header on Mobile'
,p_display_sequence=>100
,p_page_template_id=>wwv_flow_api.id(2623327345562852400)
,p_css_classes=>'js-pageStickyMobileHeader'
,p_template_types=>'PAGE'
,p_help_text=>'This will position the contents of the Breadcrumb Bar region position so it sticks to the top of the screen for small screens.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(821849890024783638)
,p_theme_id=>42
,p_name=>'STRETCH_FORM_FIELDS'
,p_display_name=>'Stretch Form Fields'
,p_display_sequence=>10
,p_css_classes=>'t-Form--stretchInputs'
,p_group_id=>wwv_flow_api.id(1217903970492295002)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(872907273778156106)
,p_theme_id=>42
,p_name=>'PRE_TEXT_BLOCK'
,p_display_name=>'Display as Block'
,p_display_sequence=>10
,p_css_classes=>'t-Form-fieldContainer--preTextBlock'
,p_group_id=>wwv_flow_api.id(872906013962098469)
,p_template_types=>'FIELD'
,p_help_text=>'Displays the Item Pre Text in a block style immediately before the item.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(872951050567163172)
,p_theme_id=>42
,p_name=>'POST_TEXT_BLOCK'
,p_display_name=>'Display as Block'
,p_display_sequence=>10
,p_css_classes=>'t-Form-fieldContainer--postTextBlock'
,p_group_id=>wwv_flow_api.id(872906399664100106)
,p_template_types=>'FIELD'
,p_help_text=>'Displays the Item Post Text in a block style immediately after the item.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(878937325735229972)
,p_theme_id=>42
,p_name=>'CONTENT_TITLE_H1'
,p_display_name=>'Large'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(873087052820635270)
,p_css_classes=>'t-ContentBlock--h1'
,p_group_id=>wwv_flow_api.id(1341358060911539894)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(878937610197231714)
,p_theme_id=>42
,p_name=>'CONTENT_TITLE_H2'
,p_display_name=>'Medium'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(873087052820635270)
,p_css_classes=>'t-ContentBlock--h2'
,p_group_id=>wwv_flow_api.id(1341358060911539894)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(878937951862233641)
,p_theme_id=>42
,p_name=>'CONTENT_TITLE_H3'
,p_display_name=>'Small'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(873087052820635270)
,p_css_classes=>'t-ContentBlock--h3'
,p_group_id=>wwv_flow_api.id(1341358060911539894)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(880961536593004135)
,p_theme_id=>42
,p_name=>'CARDS_STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>5
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--stacked'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
,p_help_text=>'Stacks the cards on top of each other.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(880994985213035290)
,p_theme_id=>42
,p_name=>'COLOR_FILL'
,p_display_name=>'Color Fill'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--animColorFill'
,p_group_id=>wwv_flow_api.id(880962127232017732)
,p_template_types=>'LIST'
,p_help_text=>'Fills the card background with the color of the icon or default link style.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(880995210301040201)
,p_theme_id=>42
,p_name=>'RAISE_CARD'
,p_display_name=>'Raise Card'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--animRaiseCard'
,p_group_id=>wwv_flow_api.id(880962127232017732)
,p_template_types=>'LIST'
,p_help_text=>'Raises the card so it pops up.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(926197662242631445)
,p_theme_id=>42
,p_name=>'CARDS_COLOR_FILL'
,p_display_name=>'Color Fill'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--animColorFill'
,p_group_id=>wwv_flow_api.id(880963719987020955)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(926197931815632977)
,p_theme_id=>42
,p_name=>'CARD_RAISE_CARD'
,p_display_name=>'Raise Card'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--animRaiseCard'
,p_group_id=>wwv_flow_api.id(880963719987020955)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(929108783400916047)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1224989219520090364)
,p_css_classes=>'t-HeroRegion--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes the padding around the hero region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1018709610060466208)
,p_theme_id=>42
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(1077726089382032168)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add shortcuts for menu items. Note that actions.js must be included on your page to support this functionality.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1018709716596467415)
,p_theme_id=>42
,p_name=>'BEHAVE_LIKE_TABS'
,p_display_name=>'Behave Like Tabs'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(1077726089382032168)
,p_css_classes=>'js-tabLike'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1018709987192470221)
,p_theme_id=>42
,p_name=>'SHOW_SUB_MENU_ICONS'
,p_display_name=>'Show Sub Menu Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(1077726089382032168)
,p_css_classes=>'js-showSubMenuIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1038541038338811097)
,p_theme_id=>42
,p_name=>'HIDDENHEADERNOAT'
,p_display_name=>'Hidden'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(591654834181983844)
,p_css_classes=>'t-Alert--removeHeading js-removeLandmark'
,p_group_id=>wwv_flow_api.id(1038527687487780252)
,p_template_types=>'REGION'
,p_help_text=>'Hides the Alert Title from being displayed.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1038541830986818587)
,p_theme_id=>42
,p_name=>'HIDDENHEADER'
,p_display_name=>'Hidden but Accessible'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(591654834181983844)
,p_css_classes=>'t-Alert--accessibleHeading'
,p_group_id=>wwv_flow_api.id(1038527687487780252)
,p_template_types=>'REGION'
,p_help_text=>'Visually hides the alert title, but assistive technologies can still read it.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1048248796692887121)
,p_theme_id=>42
,p_name=>'RTM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-top-none'
,p_group_id=>wwv_flow_api.id(1048200623912835168)
,p_template_types=>'REGION'
,p_help_text=>'Removes the top margin for this region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1048635493780005125)
,p_theme_id=>42
,p_name=>'RTM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-top-sm'
,p_group_id=>wwv_flow_api.id(1048200623912835168)
,p_template_types=>'REGION'
,p_help_text=>'Adds a small top margin to the region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1048846342126014919)
,p_theme_id=>42
,p_name=>'RTM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-top-md'
,p_group_id=>wwv_flow_api.id(1048200623912835168)
,p_template_types=>'REGION'
,p_help_text=>'Adds a medium top margin to the region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1048848116422021751)
,p_theme_id=>42
,p_name=>'RTM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-top-lg'
,p_group_id=>wwv_flow_api.id(1048200623912835168)
,p_template_types=>'REGION'
,p_help_text=>'Adds a large top margin to the region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1048848939283025656)
,p_theme_id=>42
,p_name=>'RBM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-bottom-none'
,p_group_id=>wwv_flow_api.id(1048201178198836942)
,p_template_types=>'REGION'
,p_help_text=>'Removes the bottom margin for this region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1048849411342027598)
,p_theme_id=>42
,p_name=>'RBM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-bottom-sm'
,p_group_id=>wwv_flow_api.id(1048201178198836942)
,p_template_types=>'REGION'
,p_help_text=>'Adds a small bottom margin to the region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1048849892231043339)
,p_theme_id=>42
,p_name=>'RBM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-bottom-md'
,p_group_id=>wwv_flow_api.id(1048201178198836942)
,p_template_types=>'REGION'
,p_help_text=>'Adds a medium bottom margin to the region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1048850193128045302)
,p_theme_id=>42
,p_name=>'RBM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-bottom-lg'
,p_group_id=>wwv_flow_api.id(1048201178198836942)
,p_template_types=>'REGION'
,p_help_text=>'Adds a large bottom margin to the region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1049118140679276825)
,p_theme_id=>42
,p_name=>'RRM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-right-none'
,p_group_id=>wwv_flow_api.id(1048203592334847309)
,p_template_types=>'REGION'
,p_help_text=>'Removes the right margin from the region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1049118439434279314)
,p_theme_id=>42
,p_name=>'RRM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-right-sm'
,p_group_id=>wwv_flow_api.id(1048203592334847309)
,p_template_types=>'REGION'
,p_help_text=>'Adds a small right margin to the region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1049118706290281287)
,p_theme_id=>42
,p_name=>'RRM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-right-md'
,p_group_id=>wwv_flow_api.id(1048203592334847309)
,p_template_types=>'REGION'
,p_help_text=>'Adds a medium right margin to the region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1049325821430297888)
,p_theme_id=>42
,p_name=>'RRM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-right-lg'
,p_group_id=>wwv_flow_api.id(1048203592334847309)
,p_template_types=>'REGION'
,p_help_text=>'Adds a large right margin to the region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1049326160547300240)
,p_theme_id=>42
,p_name=>'RLM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-left-none'
,p_group_id=>wwv_flow_api.id(1048203232599844933)
,p_template_types=>'REGION'
,p_help_text=>'Removes the left margin from the region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1049326448074301934)
,p_theme_id=>42
,p_name=>'RLM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-left-sm'
,p_group_id=>wwv_flow_api.id(1048203232599844933)
,p_template_types=>'REGION'
,p_help_text=>'Adds a small left margin to the region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1049326799354304380)
,p_theme_id=>42
,p_name=>'RLM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-left-md'
,p_group_id=>wwv_flow_api.id(1048203232599844933)
,p_template_types=>'REGION'
,p_help_text=>'Adds a medium right margin to the region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1049327057112305913)
,p_theme_id=>42
,p_name=>'RLM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-left-lg'
,p_group_id=>wwv_flow_api.id(1048203232599844933)
,p_template_types=>'REGION'
,p_help_text=>'Adds a large right margin to the region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1086837203572201036)
,p_theme_id=>42
,p_name=>'HIDE_BREADCRUMB'
,p_display_name=>'Show Breadcrumbs'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1082434711915925186)
,p_css_classes=>'t-BreadcrumbRegion--showBreadcrumb'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1086840862081264691)
,p_theme_id=>42
,p_name=>'GET_TITLE_FROM_BREADCRUMB'
,p_display_name=>'Use Current Breadcrumb Entry'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1082434711915925186)
,p_css_classes=>'t-BreadcrumbRegion--useBreadcrumbTitle'
,p_group_id=>wwv_flow_api.id(1341358060911539894)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1093532280453002873)
,p_theme_id=>42
,p_name=>'ACTIONS'
,p_display_name=>'Actions'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(2623332529225852414)
,p_css_classes=>'t-LinksList--actions'
,p_group_id=>wwv_flow_api.id(1093528122542993730)
,p_template_types=>'LIST'
,p_help_text=>'Render as actions to be placed on the right side column.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1163585239016086733)
,p_theme_id=>42
,p_name=>'ACCENT_1'
,p_display_name=>'Accent 1'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--accent1'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1163600524316087929)
,p_theme_id=>42
,p_name=>'ACCENT_2'
,p_display_name=>'Accent 2'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--accent2'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1163615853975088682)
,p_theme_id=>42
,p_name=>'ACCENT_3'
,p_display_name=>'Accent 3'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--accent3'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1163631142738089505)
,p_theme_id=>42
,p_name=>'ACCENT_4'
,p_display_name=>'Accent 4'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--accent4'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1163646438942118978)
,p_theme_id=>42
,p_name=>'ACCENT_5'
,p_display_name=>'Accent 5'
,p_display_sequence=>50
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--accent5'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1215307599608140815)
,p_theme_id=>42
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'i-h240'
,p_group_id=>wwv_flow_api.id(686935554787028101)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 240px.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1215307684575140816)
,p_theme_id=>42
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'i-h320'
,p_group_id=>wwv_flow_api.id(686935554787028101)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 320px.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1215307773157140816)
,p_theme_id=>42
,p_name=>'ACCENT_1'
,p_display_name=>'Accent 1'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--accent1'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1215307890924140817)
,p_theme_id=>42
,p_name=>'ACCENT_2'
,p_display_name=>'Accent 2'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--accent2'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1215307912337140817)
,p_theme_id=>42
,p_name=>'ACCENT_3'
,p_display_name=>'Accent 3'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--accent3'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1215308029393140817)
,p_theme_id=>42
,p_name=>'ACCENT_4'
,p_display_name=>'Accent 4'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--accent4'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1215308126025140817)
,p_theme_id=>42
,p_name=>'ACCENT_5'
,p_display_name=>'Accent 5'
,p_display_sequence=>50
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--accent5'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1215308347474140817)
,p_theme_id=>42
,p_name=>'HIDEOVERFLOW'
,p_display_name=>'Hide'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--hiddenOverflow'
,p_group_id=>wwv_flow_api.id(686931442667028100)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1215308508887140817)
,p_theme_id=>42
,p_name=>'NOBODYPADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes padding from region body.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1215308643803140817)
,p_theme_id=>42
,p_name=>'NOBORDER'
,p_display_name=>'Remove Borders'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--noBorder'
,p_group_id=>wwv_flow_api.id(686932753785028101)
,p_template_types=>'REGION'
,p_help_text=>'Removes borders from the region.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1215308765948140817)
,p_theme_id=>42
,p_name=>'SCROLLBODY'
,p_display_name=>'Scroll - Default'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--scrollBody'
,p_group_id=>wwv_flow_api.id(686931442667028100)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1215308998812140817)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stack Region'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--stacked'
,p_group_id=>wwv_flow_api.id(686932753785028101)
,p_template_types=>'REGION'
,p_help_text=>'Removes side borders and shadows, and can be useful for accordions and regions that need to be grouped together vertically.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1215310211128151927)
,p_theme_id=>42
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(1215309761905148163)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1215310333891152708)
,p_theme_id=>42
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(1215309761905148163)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1218415969638455617)
,p_theme_id=>42
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'i-h480'
,p_group_id=>wwv_flow_api.id(686935554787028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1218431551037457207)
,p_theme_id=>42
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'i-h640'
,p_group_id=>wwv_flow_api.id(686935554787028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1222904331453859153)
,p_theme_id=>42
,p_name=>'LEFT_ALIGNED_DETAILS'
,p_display_name=>'Left Aligned Details'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(651486824354474850)
,p_css_classes=>'t-AVPList--leftAligned'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1222904556477862903)
,p_theme_id=>42
,p_name=>'RIGHT_ALIGNED_DETAILS'
,p_display_name=>'Right Aligned Details'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(651486824354474850)
,p_css_classes=>'t-AVPList--rightAligned'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1223645823728337255)
,p_theme_id=>42
,p_name=>'DRAGGABLE'
,p_display_name=>'Draggable'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1223645131968329858)
,p_css_classes=>'js-draggable'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1223645984531338199)
,p_theme_id=>42
,p_name=>'MODAL'
,p_display_name=>'Modal'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1223645131968329858)
,p_css_classes=>'js-modal'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1223646175209340625)
,p_theme_id=>42
,p_name=>'RESIZABLE'
,p_display_name=>'Resizable'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(1223645131968329858)
,p_css_classes=>'js-resizable'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1223647395661348388)
,p_theme_id=>42
,p_name=>'SMALL_480X320'
,p_display_name=>'Small (480x320)'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1223645131968329858)
,p_css_classes=>'js-dialog-size480x320'
,p_group_id=>wwv_flow_api.id(1223646971237343931)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1223647449707349925)
,p_theme_id=>42
,p_name=>'LARGE_720X480'
,p_display_name=>'Large (720x480)'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(1223645131968329858)
,p_css_classes=>'js-dialog-size720x480'
,p_group_id=>wwv_flow_api.id(1223646971237343931)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1223647571774352414)
,p_theme_id=>42
,p_name=>'MEDIUM_600X400'
,p_display_name=>'Medium (600x400)'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1223645131968329858)
,p_css_classes=>'js-dialog-size600x400'
,p_group_id=>wwv_flow_api.id(1223646971237343931)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1337808790879184277)
,p_theme_id=>42
,p_name=>'FIXED_SMALL'
,p_display_name=>'Fixed - Small'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(651486824354474850)
,p_css_classes=>'t-AVPList--fixedLabelSmall'
,p_group_id=>wwv_flow_api.id(1337807492374178719)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1337808809121185907)
,p_theme_id=>42
,p_name=>'FIXED_MEDIUM'
,p_display_name=>'Fixed - Medium'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(651486824354474850)
,p_css_classes=>'t-AVPList--fixedLabelMedium'
,p_group_id=>wwv_flow_api.id(1337807492374178719)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1337808929715187155)
,p_theme_id=>42
,p_name=>'FIXED_LARGE'
,p_display_name=>'Fixed - Large'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(651486824354474850)
,p_css_classes=>'t-AVPList--fixedLabelLarge'
,p_group_id=>wwv_flow_api.id(1337807492374178719)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1337814316699252841)
,p_theme_id=>42
,p_name=>'VARIABLE_SMALL'
,p_display_name=>'Variable - Small'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_api.id(651486824354474850)
,p_css_classes=>'t-AVPList--variableLabelSmall'
,p_group_id=>wwv_flow_api.id(1337807492374178719)
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1337814565215254423)
,p_theme_id=>42
,p_name=>'VARIABLE_MEDIUM'
,p_display_name=>'Variable - Medium'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_api.id(651486824354474850)
,p_css_classes=>'t-AVPList--variableLabelMedium'
,p_group_id=>wwv_flow_api.id(1337807492374178719)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1337814741366256496)
,p_theme_id=>42
,p_name=>'VARIABLE_LARGE'
,p_display_name=>'Variable - Large'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_api.id(651486824354474850)
,p_css_classes=>'t-AVPList--variableLabelLarge'
,p_group_id=>wwv_flow_api.id(1337807492374178719)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1339941266115695177)
,p_theme_id=>42
,p_name=>'REMEMBER_COLLAPSIBLE_STATE'
,p_display_name=>'Remember Collapsible State'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'js-useLocalStorage'
,p_template_types=>'REGION'
,p_help_text=>'This option saves the current state of the collapsible region for the duration of the session.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1341251441834337073)
,p_theme_id=>42
,p_name=>'REGION_HEADER_VISIBLE'
,p_display_name=>'Use Region Title'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1082434711915925186)
,p_css_classes=>'t-BreadcrumbRegion--useRegionTitle'
,p_group_id=>wwv_flow_api.id(1341358060911539894)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1375597646117638183)
,p_theme_id=>42
,p_name=>'FBM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-bottom-none'
,p_group_id=>wwv_flow_api.id(1373693355147580605)
,p_template_types=>'FIELD'
,p_help_text=>'Removes the bottom margin for this field.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1378328832968677986)
,p_theme_id=>42
,p_name=>'FBM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-bottom-sm'
,p_group_id=>wwv_flow_api.id(1373693355147580605)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a small bottom margin for this field.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1378713756151680136)
,p_theme_id=>42
,p_name=>'FBM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-bottom-md'
,p_group_id=>wwv_flow_api.id(1373693355147580605)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a medium bottom margin for this field.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1378769704340685428)
,p_theme_id=>42
,p_name=>'FBM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-bottom-lg'
,p_group_id=>wwv_flow_api.id(1373693355147580605)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a large bottom margin for this field.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1378770022187689290)
,p_theme_id=>42
,p_name=>'FLM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-left-none'
,p_group_id=>wwv_flow_api.id(1373693635931582685)
,p_template_types=>'FIELD'
,p_help_text=>'Removes the left margin for this field.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1378770379746691757)
,p_theme_id=>42
,p_name=>'FLM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-left-sm'
,p_group_id=>wwv_flow_api.id(1373693635931582685)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a small left margin for this field.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1378770694691694065)
,p_theme_id=>42
,p_name=>'FLM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-left-md'
,p_group_id=>wwv_flow_api.id(1373693635931582685)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a medium left margin for this field.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1378770937661695459)
,p_theme_id=>42
,p_name=>'FLM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-left-lg'
,p_group_id=>wwv_flow_api.id(1373693635931582685)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a large left margin for this field.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1378771565626697748)
,p_theme_id=>42
,p_name=>'FRM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-right-none'
,p_group_id=>wwv_flow_api.id(1373694106751588886)
,p_template_types=>'FIELD'
,p_help_text=>'Removes the right margin for this field.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1378772152957700625)
,p_theme_id=>42
,p_name=>'FRM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-right-sm'
,p_group_id=>wwv_flow_api.id(1373694106751588886)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a small right margin for this field.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1378772410120702706)
,p_theme_id=>42
,p_name=>'FRM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-right-md'
,p_group_id=>wwv_flow_api.id(1373694106751588886)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a medium right margin for this field.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1378772881362704577)
,p_theme_id=>42
,p_name=>'FRM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-right-lg'
,p_group_id=>wwv_flow_api.id(1373694106751588886)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a large right margin for this field.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1378773116389706743)
,p_theme_id=>42
,p_name=>'FTM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-top-none'
,p_group_id=>wwv_flow_api.id(1373692906398577433)
,p_template_types=>'FIELD'
,p_help_text=>'Removes the top margin for this field.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1378830040159708376)
,p_theme_id=>42
,p_name=>'FTM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-top-sm'
,p_group_id=>wwv_flow_api.id(1373692906398577433)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a small top margin for this field.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1378860278347710857)
,p_theme_id=>42
,p_name=>'FTM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-top-md'
,p_group_id=>wwv_flow_api.id(1373692906398577433)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a medium top margin for this field.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1378861132203713659)
,p_theme_id=>42
,p_name=>'FTM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-top-lg'
,p_group_id=>wwv_flow_api.id(1373692906398577433)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a large top margin for this field.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418259913240351888)
,p_theme_id=>42
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'i-h240'
,p_group_id=>wwv_flow_api.id(686935554787028101)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 240px.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418260000857351889)
,p_theme_id=>42
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'i-h320'
,p_group_id=>wwv_flow_api.id(686935554787028101)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 320px.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418260129668351889)
,p_theme_id=>42
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'i-h480'
,p_group_id=>wwv_flow_api.id(686935554787028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418260247851351889)
,p_theme_id=>42
,p_name=>'5_SECONDS'
,p_display_name=>'5 Seconds'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'js-cycle5s'
,p_group_id=>wwv_flow_api.id(1332170259565645642)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418260323918351889)
,p_theme_id=>42
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'i-h640'
,p_group_id=>wwv_flow_api.id(686935554787028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418260444632351889)
,p_theme_id=>42
,p_name=>'ACCENT_1'
,p_display_name=>'Accent 1'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'t-Region--accent1'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418260504366351890)
,p_theme_id=>42
,p_name=>'ACCENT_2'
,p_display_name=>'Accent 2'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'t-Region--accent2'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418260609155351890)
,p_theme_id=>42
,p_name=>'ACCENT_3'
,p_display_name=>'Accent 3'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'t-Region--accent3'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418260712321351890)
,p_theme_id=>42
,p_name=>'ACCENT_4'
,p_display_name=>'Accent 4'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'t-Region--accent4'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418260800620351890)
,p_theme_id=>42
,p_name=>'ACCENT_5'
,p_display_name=>'Accent 5'
,p_display_sequence=>50
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'t-Region--accent5'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418260985010351890)
,p_theme_id=>42
,p_name=>'HIDDENHEADERNOAT'
,p_display_name=>'Hidden'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'t-Region--removeHeader'
,p_group_id=>wwv_flow_api.id(686930518563028100)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418261092473351890)
,p_theme_id=>42
,p_name=>'HIDEOVERFLOW'
,p_display_name=>'Hide'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'t-Region--hiddenOverflow'
,p_group_id=>wwv_flow_api.id(686931442667028100)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418261173740351890)
,p_theme_id=>42
,p_name=>'HIDEREGIONHEADER'
,p_display_name=>'Hidden but accessible'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'t-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(686930518563028100)
,p_template_types=>'REGION'
,p_help_text=>'This option will hide the region header.  Note that the region title will still be audible for Screen Readers. Buttons placed in the region header will be hidden and inaccessible.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418261232399351892)
,p_theme_id=>42
,p_name=>'NOBODYPADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'t-Region--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes padding from region body.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418261385403351892)
,p_theme_id=>42
,p_name=>'NOBORDER'
,p_display_name=>'Remove Borders'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'t-Region--noBorder'
,p_group_id=>wwv_flow_api.id(686932753785028101)
,p_template_types=>'REGION'
,p_help_text=>'Removes borders from the region.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418261416549351892)
,p_theme_id=>42
,p_name=>'REMEMBER_CAROUSEL_SLIDE'
,p_display_name=>'Remember Carousel Slide'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'js-useLocalStorage'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418261504053351892)
,p_theme_id=>42
,p_name=>'SCROLLBODY'
,p_display_name=>'Scroll'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'t-Region--scrollBody'
,p_group_id=>wwv_flow_api.id(686931442667028100)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418261725191351892)
,p_theme_id=>42
,p_name=>'SLIDE'
,p_display_name=>'Slide'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'t-Region--carouselSlide'
,p_group_id=>wwv_flow_api.id(1332170055887643649)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418261802204351892)
,p_theme_id=>42
,p_name=>'SPIN'
,p_display_name=>'Spin'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'t-Region--carouselSpin'
,p_group_id=>wwv_flow_api.id(1332170055887643649)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1418261981748351892)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stack Region'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'t-Region--stacked'
,p_group_id=>wwv_flow_api.id(686932753785028101)
,p_template_types=>'REGION'
,p_help_text=>'Removes side borders and shadows, and can be useful for accordions and regions that need to be grouped together vertically.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1437741778445448541)
,p_theme_id=>42
,p_name=>'SPAN_HORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>70
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--spanHorizontally'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1437742958039452375)
,p_theme_id=>42
,p_name=>'FLOAT'
,p_display_name=>'Float'
,p_display_sequence=>60
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--float'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1437743045630454254)
,p_theme_id=>42
,p_name=>'2_COLUMNS'
,p_display_name=>'2 Columns'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--cols'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1437743149992455426)
,p_theme_id=>42
,p_name=>'3_COLUMNS'
,p_display_name=>'3 Columns'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--3cols'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1437743219909456740)
,p_theme_id=>42
,p_name=>'4_COLUMNS'
,p_display_name=>'4 Columns'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--4cols'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1437743363957458086)
,p_theme_id=>42
,p_name=>'5_COLUMNS'
,p_display_name=>'5 Columns'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--5cols'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1437747093491485543)
,p_theme_id=>42
,p_name=>'FEATURED'
,p_display_name=>'Featured'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--featured force-fa-lg'
,p_group_id=>wwv_flow_api.id(1093528122542993730)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1437747326008486736)
,p_theme_id=>42
,p_name=>'BASIC'
,p_display_name=>'Basic'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--basic'
,p_group_id=>wwv_flow_api.id(1093528122542993730)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1437747933658490046)
,p_theme_id=>42
,p_name=>'USE_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'u-colors'
,p_template_types=>'LIST'
,p_help_text=>'Applies the colors from the theme''s color palette to the icons or initials within cards.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1437749744766501856)
,p_theme_id=>42
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--displayIcons'
,p_group_id=>wwv_flow_api.id(1437745695703477673)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1437750157836506330)
,p_theme_id=>42
,p_name=>'DISPLAY_INITIALS'
,p_display_name=>'Display Initials'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--displayInitials'
,p_group_id=>wwv_flow_api.id(1437745695703477673)
,p_template_types=>'LIST'
,p_help_text=>'Initials come from List Attribute 3'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1437755216777546994)
,p_theme_id=>42
,p_name=>'2_LINES'
,p_display_name=>'2 Lines'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--desc-2ln'
,p_group_id=>wwv_flow_api.id(1437746379683480702)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1437765346354548059)
,p_theme_id=>42
,p_name=>'3_LINES'
,p_display_name=>'3 Lines'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--desc-3ln'
,p_group_id=>wwv_flow_api.id(1437746379683480702)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1437765447649549085)
,p_theme_id=>42
,p_name=>'4_LINES'
,p_display_name=>'4 Lines'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--desc-4ln'
,p_group_id=>wwv_flow_api.id(1437746379683480702)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1443062563414634703)
,p_theme_id=>42
,p_name=>'DISPLAY_AS_PILL_BUTTON'
,p_display_name=>'Display as Pill Button'
,p_display_sequence=>10
,p_css_classes=>'t-Form-fieldContainer--radioButtonGroup'
,p_group_id=>wwv_flow_api.id(1443062277679626593)
,p_template_types=>'FIELD'
,p_help_text=>'Displays the radio buttons to look like a button set / pill button.  Note that the the radio buttons must all be in the same row for this option to work.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1475818147587546912)
,p_theme_id=>42
,p_name=>'APPLY_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_css_classes=>'u-colors'
,p_template_types=>'LIST'
,p_help_text=>'Applies colors from the Theme''s color palette to icons in the list.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1480493812321779714)
,p_theme_id=>42
,p_name=>'LIST_SIZE_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_css_classes=>'t-MediaList--large force-fa-lg'
,p_group_id=>wwv_flow_api.id(1840639733836662642)
,p_template_types=>'LIST'
,p_help_text=>'Increases the size of the text and icons in the list.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1485035212186308480)
,p_theme_id=>42
,p_name=>'ACCENT_6'
,p_display_name=>'Accent 6'
,p_display_sequence=>60
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--accent6'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1485035823673309547)
,p_theme_id=>42
,p_name=>'ACCENT_7'
,p_display_name=>'Accent 7'
,p_display_sequence=>70
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--accent7'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1485036183062310522)
,p_theme_id=>42
,p_name=>'ACCENT_8'
,p_display_name=>'Accent 8'
,p_display_sequence=>80
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--accent8'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1485036432555311364)
,p_theme_id=>42
,p_name=>'ACCENT_9'
,p_display_name=>'Accent 9'
,p_display_sequence=>90
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--accent9'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1485036830356312411)
,p_theme_id=>42
,p_name=>'ACCENT_10'
,p_display_name=>'Accent 10'
,p_display_sequence=>100
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--accent10'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1485037124929313435)
,p_theme_id=>42
,p_name=>'ACCENT_11'
,p_display_name=>'Accent 11'
,p_display_sequence=>110
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--accent11'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1485037698030314203)
,p_theme_id=>42
,p_name=>'ACCENT_12'
,p_display_name=>'Accent 12'
,p_display_sequence=>120
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--accent12'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1485037997456315237)
,p_theme_id=>42
,p_name=>'ACCENT_13'
,p_display_name=>'Accent 13'
,p_display_sequence=>130
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--accent13'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1485038362270316173)
,p_theme_id=>42
,p_name=>'ACCENT_14'
,p_display_name=>'Accent 14'
,p_display_sequence=>140
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--accent14'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1485038691002317127)
,p_theme_id=>42
,p_name=>'ACCENT_15'
,p_display_name=>'Accent 15'
,p_display_sequence=>150
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--accent15'
,p_group_id=>wwv_flow_api.id(686932883424028101)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1512514737713894421)
,p_theme_id=>42
,p_name=>'LARGE_FIELD'
,p_display_name=>'Large'
,p_display_sequence=>10
,p_css_classes=>'t-Form-fieldContainer--large'
,p_group_id=>wwv_flow_api.id(1512514270407882520)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1512525751558899364)
,p_theme_id=>42
,p_name=>'X_LARGE_SIZE'
,p_display_name=>'X Large'
,p_display_sequence=>20
,p_css_classes=>'t-Form-fieldContainer--xlarge'
,p_group_id=>wwv_flow_api.id(1512514270407882520)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1517589895250620683)
,p_theme_id=>42
,p_name=>'BASIC'
,p_display_name=>'Basic'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(1164140200812557328)
,p_css_classes=>'t-Comments--basic'
,p_group_id=>wwv_flow_api.id(1517530105045469419)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1517606339615707631)
,p_theme_id=>42
,p_name=>'SPEECH_BUBBLES'
,p_display_name=>'Speech Bubbles'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(1164140200812557328)
,p_css_classes=>'t-Comments--chat'
,p_group_id=>wwv_flow_api.id(1517530105045469419)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525955285853519017)
,p_theme_id=>42
,p_name=>'2_COLUMNS'
,p_display_name=>'2 Columns'
,p_display_sequence=>15
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--cols'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525955315642520219)
,p_theme_id=>42
,p_name=>'3_COLUMNS'
,p_display_name=>'3 Columns'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--3cols'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525955418102521363)
,p_theme_id=>42
,p_name=>'4_COLUMNS'
,p_display_name=>'4 Columns'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--4cols'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525955521199522870)
,p_theme_id=>42
,p_name=>'5_COLUMNS'
,p_display_name=>'5 Columns'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--5cols'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525955691292525016)
,p_theme_id=>42
,p_name=>'FLOAT'
,p_display_name=>'Float'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--float'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525955790333526146)
,p_theme_id=>42
,p_name=>'SPAN_HORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>70
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--spanHorizontally'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1526010171047577420)
,p_theme_id=>42
,p_name=>'2_LINES'
,p_display_name=>'2 Lines'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--desc-2ln'
,p_group_id=>wwv_flow_api.id(1525956956755555832)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1526010276258578315)
,p_theme_id=>42
,p_name=>'3_LINES'
,p_display_name=>'3 Lines'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--desc-3ln'
,p_group_id=>wwv_flow_api.id(1525956956755555832)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1526010377091579347)
,p_theme_id=>42
,p_name=>'4_LINES'
,p_display_name=>'4 Lines'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--desc-4ln'
,p_group_id=>wwv_flow_api.id(1525956956755555832)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1526010408723581538)
,p_theme_id=>42
,p_name=>'USE_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'u-colors'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1526010588016583255)
,p_theme_id=>42
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--displayIcons'
,p_group_id=>wwv_flow_api.id(1525957399615559004)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1526010628778584429)
,p_theme_id=>42
,p_name=>'DISPLAY_INITIALS'
,p_display_name=>'Display Initials'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--displayInitials'
,p_group_id=>wwv_flow_api.id(1525957399615559004)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1526010706303585631)
,p_theme_id=>42
,p_name=>'FEATURED'
,p_display_name=>'Featured'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--featured force-fa-lg'
,p_group_id=>wwv_flow_api.id(1525957602312561277)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1526011053786591079)
,p_theme_id=>42
,p_name=>'BASIC'
,p_display_name=>'Basic'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--basic'
,p_group_id=>wwv_flow_api.id(1525957602312561277)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1582559994988798658)
,p_theme_id=>42
,p_name=>'STRETCH_FORM_ITEM'
,p_display_name=>'Stretch Form Item'
,p_display_sequence=>10
,p_css_classes=>'t-Form-fieldContainer--stretchInputs'
,p_template_types=>'FIELD'
,p_help_text=>'Stretches the form item to fill its container.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1758443150640520811)
,p_theme_id=>42
,p_name=>'SHOW_NEXT_AND_PREVIOUS_BUTTONS'
,p_display_name=>'Show Next and Previous Buttons'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'t-Region--showCarouselControls'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1773833130039489732)
,p_theme_id=>42
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_api.id(561127424267431983)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add shortcuts for menu items. Note that actions.js must be included on your page to support this functionality.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1773833327247490563)
,p_theme_id=>42
,p_name=>'BEHAVE_LIKE_TABS'
,p_display_name=>'Behave Like Tabs'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(561127424267431983)
,p_css_classes=>'js-tabLike'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1773833721985493171)
,p_theme_id=>42
,p_name=>'SHOW_SUB_MENU_ICONS'
,p_display_name=>'Show Sub Menu Icons'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(561127424267431983)
,p_css_classes=>'js-showSubMenuIcons'
,p_template_types=>'LIST'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1779026382934967345)
,p_theme_id=>42
,p_name=>'REMEMBER_ACTIVE_TAB'
,p_display_name=>'Remember Active Tab'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1774143203700285855)
,p_css_classes=>'js-useLocalStorage'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1805577058603291412)
,p_theme_id=>42
,p_name=>'FIXED_SMALL'
,p_display_name=>'Fixed - Small'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(651486509760474849)
,p_css_classes=>'t-AVPList--fixedLabelSmall'
,p_group_id=>wwv_flow_api.id(1337807492374178719)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1805577215396293454)
,p_theme_id=>42
,p_name=>'FIXED_MEDIUM'
,p_display_name=>'Fixed - Medium'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(651486509760474849)
,p_css_classes=>'t-AVPList--fixedLabelMedium'
,p_group_id=>wwv_flow_api.id(1337807492374178719)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1805577485230295260)
,p_theme_id=>42
,p_name=>'FIXED_LARGE'
,p_display_name=>'Fixed - Large'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(651486509760474849)
,p_css_classes=>'t-AVPList--fixedLabelLarge'
,p_group_id=>wwv_flow_api.id(1337807492374178719)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1805577734956298543)
,p_theme_id=>42
,p_name=>'VARIABLE_LARGE'
,p_display_name=>'Variable - Large'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_api.id(651486509760474849)
,p_css_classes=>'t-AVPList--variableLabelLarge'
,p_group_id=>wwv_flow_api.id(1337807492374178719)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1805578291414302969)
,p_theme_id=>42
,p_name=>'VARIABLE_MEDIUM'
,p_display_name=>'Variable - Medium'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_api.id(651486509760474849)
,p_css_classes=>'t-AVPList--variableLabelMedium'
,p_group_id=>wwv_flow_api.id(1337807492374178719)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1805578496665305272)
,p_theme_id=>42
,p_name=>'VARIABLE_SMALL'
,p_display_name=>'Variable - Small'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_api.id(651486509760474849)
,p_css_classes=>'t-AVPList--variableLabelSmall'
,p_group_id=>wwv_flow_api.id(1337807492374178719)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1805578790687308244)
,p_theme_id=>42
,p_name=>'LEFT_ALIGNED_DETAILS'
,p_display_name=>'Left Aligned Details'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(651486509760474849)
,p_css_classes=>'t-AVPList--leftAligned'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1805578907543309384)
,p_theme_id=>42
,p_name=>'RIGHT_ALIGNED_DETAILS'
,p_display_name=>'Right Aligned Details'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(651486509760474849)
,p_css_classes=>'t-AVPList--rightAligned'
,p_group_id=>wwv_flow_api.id(686934797631028101)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1819505187528387194)
,p_theme_id=>42
,p_name=>'HIDE_ICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(591654834181983844)
,p_css_classes=>'t-Alert--noIcon'
,p_group_id=>wwv_flow_api.id(1819504545813380867)
,p_template_types=>'REGION'
,p_help_text=>'Hides alert icons'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1819505330686391846)
,p_theme_id=>42
,p_name=>'SHOW_CUSTOM_ICONS'
,p_display_name=>'Show Custom Icons'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(591654834181983844)
,p_css_classes=>'t-Alert--customIcons'
,p_group_id=>wwv_flow_api.id(1819504545813380867)
,p_template_types=>'REGION'
,p_help_text=>'Set custom icons by modifying the Alert Region''s Icon CSS Classes property.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1823214089216124154)
,p_theme_id=>42
,p_name=>'COMPACT'
,p_display_name=>'Compact'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--compact'
,p_group_id=>wwv_flow_api.id(1093528122542993730)
,p_template_types=>'LIST'
,p_help_text=>'Use this option when you want to show smaller cards.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1823218623268133955)
,p_theme_id=>42
,p_name=>'HIDDEN_BODY_TEXT'
,p_display_name=>'Hidden'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_css_classes=>'t-Cards--hideBody'
,p_group_id=>wwv_flow_api.id(1437746379683480702)
,p_template_types=>'LIST'
,p_help_text=>'This option hides the card body which contains description and subtext.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1823341639365252326)
,p_theme_id=>42
,p_name=>'COMPACT'
,p_display_name=>'Compact'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--compact'
,p_group_id=>wwv_flow_api.id(1525957602312561277)
,p_template_types=>'REPORT'
,p_help_text=>'Use this option when you want to show smaller cards.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1823341832326254505)
,p_theme_id=>42
,p_name=>'HIDDEN_BODY_TEXT'
,p_display_name=>'Hidden'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_api.id(1525953837592492828)
,p_css_classes=>'t-Cards--hideBody'
,p_group_id=>wwv_flow_api.id(1525956956755555832)
,p_template_types=>'REPORT'
,p_help_text=>'This option hides the card body which contains description and subtext.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1840640333182666537)
,p_theme_id=>42
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(1840624874773603093)
,p_css_classes=>'t-Tabs--large'
,p_group_id=>wwv_flow_api.id(1840639733836662642)
,p_template_types=>'LIST'
,p_help_text=>'Increases font size and white space around tab items.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1840640584632670330)
,p_theme_id=>42
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(1840624874773603093)
,p_css_classes=>'t-Tabs--simple'
,p_group_id=>wwv_flow_api.id(1093528122542993730)
,p_template_types=>'LIST'
,p_help_text=>'A very simplistic tab UI.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1840640714366677118)
,p_theme_id=>42
,p_name=>'PILL'
,p_display_name=>'Pill'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(1840624874773603093)
,p_css_classes=>'t-Tabs--pill'
,p_group_id=>wwv_flow_api.id(1093528122542993730)
,p_template_types=>'LIST'
,p_help_text=>'Displays tabs in a pill container.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1840640959032680779)
,p_theme_id=>42
,p_name=>'INLINE_WITH_LABEL'
,p_display_name=>'Inline with Label'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(1840624874773603093)
,p_css_classes=>'t-Tabs--inlineIcons'
,p_group_id=>wwv_flow_api.id(1437745695703477673)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1840641188331684977)
,p_theme_id=>42
,p_name=>'ABOVE_LABEL'
,p_display_name=>'Above Label'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(1840624874773603093)
,p_css_classes=>'t-Tabs--iconsAbove'
,p_group_id=>wwv_flow_api.id(1437745695703477673)
,p_template_types=>'LIST'
,p_help_text=>'Places icons above tab label.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1840771248368857341)
,p_theme_id=>42
,p_name=>'FILL_LABELS'
,p_display_name=>'Fill Labels'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(1840624874773603093)
,p_css_classes=>'t-Tabs--fillLabels'
,p_group_id=>wwv_flow_api.id(686932580235028101)
,p_template_types=>'LIST'
,p_help_text=>'Stretch tabs to fill to the width of the tabs container.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1840772056805868916)
,p_theme_id=>42
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>5
,p_list_template_id=>wwv_flow_api.id(1840624874773603093)
,p_css_classes=>'t-Tabs--small'
,p_group_id=>wwv_flow_api.id(1840639733836662642)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1857525073392915857)
,p_theme_id=>42
,p_name=>'FILL_TAB_LABELS'
,p_display_name=>'Fill Tab Labels'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1774143203700285855)
,p_css_classes=>'t-TabsRegion-mod--fillLabels'
,p_group_id=>wwv_flow_api.id(1857478787516903577)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1857525298156917410)
,p_theme_id=>42
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1774143203700285855)
,p_css_classes=>'t-TabsRegion-mod--simple'
,p_group_id=>wwv_flow_api.id(1857479096126905096)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1857528892294919146)
,p_theme_id=>42
,p_name=>'PILL'
,p_display_name=>'Pill'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1774143203700285855)
,p_css_classes=>'t-TabsRegion-mod--pill'
,p_group_id=>wwv_flow_api.id(1857479096126905096)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1857529220071921213)
,p_theme_id=>42
,p_name=>'TABS_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1774143203700285855)
,p_css_classes=>'t-TabsRegion-mod--small'
,p_group_id=>wwv_flow_api.id(1857480037379911594)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1857540160986922312)
,p_theme_id=>42
,p_name=>'TABSLARGE'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1774143203700285855)
,p_css_classes=>'t-TabsRegion-mod--large'
,p_group_id=>wwv_flow_api.id(1857480037379911594)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1945816593056340775)
,p_theme_id=>42
,p_name=>'SHOW_ICONS'
,p_display_name=>'Show Icons'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_css_classes=>'t-MediaList--showIcons'
,p_template_types=>'LIST'
,p_help_text=>'Display an icon next to the list item.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1945817529318346106)
,p_theme_id=>42
,p_name=>'SHOW_DESCRIPTION'
,p_display_name=>'Show Description'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_css_classes=>'t-MediaList--showDesc'
,p_template_types=>'LIST'
,p_help_text=>'Shows the description (Attribute 1) for each list item.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1945817867103351016)
,p_theme_id=>42
,p_name=>'SHOW_BADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_css_classes=>'t-MediaList--showBadges'
,p_template_types=>'LIST'
,p_help_text=>'Show a badge (Attribute 2) to the right of the list item.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(2152176995371063683)
,p_theme_id=>42
,p_name=>'ADD_BODY_PADDING'
,p_display_name=>'Add Body Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(873087052820635270)
,p_css_classes=>'t-ContentBlock--padded'
,p_template_types=>'REGION'
,p_help_text=>'Adds padding to the region''s body container.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(2152188547704242450)
,p_theme_id=>42
,p_name=>'SHADOW_BACKGROUND'
,p_display_name=>'Shadow Background'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(873087052820635270)
,p_css_classes=>'t-ContentBlock--shadowBG'
,p_group_id=>wwv_flow_api.id(2152178420884088035)
,p_template_types=>'REGION'
,p_help_text=>'Gives the region body a slightly darker background.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(2152188840015248645)
,p_theme_id=>42
,p_name=>'LIGHT_BACKGROUND'
,p_display_name=>'Light Background'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(873087052820635270)
,p_css_classes=>'t-ContentBlock--lightBG'
,p_group_id=>wwv_flow_api.id(2152178420884088035)
,p_template_types=>'REGION'
,p_help_text=>'Gives the region body a slightly lighter background.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(2250019549067012060)
,p_theme_id=>42
,p_name=>'SHOW_MAXIMIZE_BUTTON'
,p_display_name=>'Show Maximize Button'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'js-showMaximizeButton'
,p_template_types=>'REGION'
,p_help_text=>'Displays a button in the Region Header to maximize the region. Clicking this button will toggle the maximize state and stretch the region to fill the screen.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(2250073074620085614)
,p_theme_id=>42
,p_name=>'SHOW_MAXIMIZE_BUTTON'
,p_display_name=>'Show Maximize Button'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(651498026300583706)
,p_css_classes=>'js-showMaximizeButton'
,p_template_types=>'REGION'
,p_help_text=>'Displays a button in the Interactive Reports toolbar to maximize the report. Clicking this button will toggle the maximize state and stretch the report to fill the screen.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(2250125868908110127)
,p_theme_id=>42
,p_name=>'SHOW_MAXIMIZE_BUTTON'
,p_display_name=>'Show Maximize Button'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'js-showMaximizeButton'
,p_template_types=>'REGION'
,p_help_text=>'Displays a button in the Region Header to maximize the region. Clicking this button will toggle the maximize state and stretch the region to fill the screen.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(2264893908431592276)
,p_theme_id=>42
,p_name=>'VERTICAL_LIST'
,p_display_name=>'Vertical Orientation'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(561120526789187584)
,p_css_classes=>'t-WizardSteps--vertical'
,p_template_types=>'LIST'
,p_help_text=>'Displays the wizard progress list in a vertical orientation and is suitable for displaying within a side column of a page.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(2380813654357274785)
,p_theme_id=>42
,p_name=>'10_SECONDS'
,p_display_name=>'10 Seconds'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'js-cycle10s'
,p_group_id=>wwv_flow_api.id(1332170259565645642)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(2380813825009276231)
,p_theme_id=>42
,p_name=>'15_SECONDS'
,p_display_name=>'15 Seconds'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'js-cycle15s'
,p_group_id=>wwv_flow_api.id(1332170259565645642)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(2380814252918279535)
,p_theme_id=>42
,p_name=>'20_SECONDS'
,p_display_name=>'20 Seconds'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(1418258663404351882)
,p_css_classes=>'js-cycle20s'
,p_group_id=>wwv_flow_api.id(1332170259565645642)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(2380826718554404144)
,p_theme_id=>42
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'i-h480'
,p_group_id=>wwv_flow_api.id(686935554787028101)
,p_template_types=>'REGION'
,p_help_text=>'Sets body height to 480px.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(2380826978315406723)
,p_theme_id=>42
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'i-h640'
,p_group_id=>wwv_flow_api.id(686935554787028101)
,p_template_types=>'REGION'
,p_help_text=>'Sets body height to 640px.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(2380838853145460918)
,p_theme_id=>42
,p_name=>'SHOW_TITLE'
,p_display_name=>'Show Title'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(670020401234384587)
,p_css_classes=>'t-Wizard--showTitle'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(2470780003349555916)
,p_theme_id=>42
,p_name=>'REMOVE_UI_DECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(1215306280710140812)
,p_css_classes=>'t-Region--noUI'
,p_group_id=>wwv_flow_api.id(686932753785028101)
,p_template_types=>'REGION'
,p_help_text=>'Removes UI decoration (borders, backgrounds, shadows, etc) from the region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(2471213186329560663)
,p_theme_id=>42
,p_name=>'REMOVE_UI_DECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(2623330321607852408)
,p_css_classes=>'t-Region--noUI'
,p_group_id=>wwv_flow_api.id(686932753785028101)
,p_template_types=>'REGION'
,p_help_text=>'Removes UI decoration (borders, backgrounds, shadows, etc) from the region.'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/user_interface/shortcuts/delete_confirm_msg
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(10646301435715879852)
,p_shortcut_name=>'DELETE_CONFIRM_MSG'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>'Would you like to perform this delete action?'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/ok_to_get_next_prev_pk_value
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(10647329157070899202)
,p_shortcut_name=>'OK_TO_GET_NEXT_PREV_PK_VALUE'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>'Are you sure you want to leave this page without saving?'
);
end;
/
prompt --application/shared_components/security/authentications/application_express
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(6617513688278274885)
,p_name=>'Application Express'
,p_scheme_type=>'NATIVE_APEX_ACCOUNTS'
,p_invalid_session_type=>'LOGIN'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_comments=>'Based on authentication scheme from gallery:Existing Login Page: Use Application Express Account Credentials'
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_preview_template_options
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(776877005555146556)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.PREVIEW_TEMPLATE_OPTIONS'
,p_display_name=>'Preview Template Options'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.PREVIEW_TEMPLATE_OPTIONS'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/js/widget.propertyEditor.js',
'#IMAGE_PREFIX#apex_ui/js/templateOptionsHelper.js',
'#PLUGIN_FILES#js/script#MIN#.js'))
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#PLUGIN_FILES#css/base#MIN#.css',
'#PLUGIN_FILES#css/style#MIN#.css'))
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'c_workspace constant varchar2(100) := apex_util.find_workspace(:workspace_id);',
'',
'subtype t_region_type is varchar2(40);',
'c_region_type_list_region       constant t_region_type := ''NATIVE_LIST'';',
'c_region_type_breadcrumb_region constant t_region_type := ''NATIVE_BREADCRUMB'';',
'c_region_type_sql_report        constant t_region_type := ''NATIVE_SQL_REPORT'';',
'c_region_type_tabform           constant t_region_type := ''NATIVE_TABFORM'';',
'',
'procedure emit_template_templ_options',
'    ( p_component_id   number',
'    , p_application_id number',
'    , p_theme_id       number',
'    , p_template_id    number',
'    , p_template_type  varchar2',
'    , p_current_values varchar2',
'    )',
'as',
'    type t_groups is table of apex_appl_template_opt_groups%rowtype index by varchar2( 255 );',
'    ',
'    l_groups                 t_groups;',
'    l_group_id               varchar2(255);',
'    l_default                apex_application_temp_page.default_template_options%type;',
'    l_preset                 apex_application_temp_page.preset_template_options%type;',
'    l_emit_template_defaults boolean := true;',
'    ',
'    procedure emit_template_options (',
'        p_d           in varchar2,',
'        p_r           in varchar2,',
'        p_seq         in number,',
'        p_is_advanced in boolean,',
'        p_help_text   in varchar2 default null,',
'        p_group_id    in varchar2 default null )',
'    is',
'    begin',
'        apex_json.open_object;',
'        apex_json.write(''d'',          p_d);',
'        apex_json.write(''r'',          p_r);',
'        apex_json.write(''seq'',        p_seq);',
'        apex_json.write(''isAdvanced'', p_is_advanced);',
'        apex_json.write(''helpText'',   apex_escape.html_whitelist(p_help_text));',
'        apex_json.write(''groupId'',    p_group_id);',
'        ',
'        apex_json.close_object;',
'    end emit_template_options;',
'begin',
'    apex_json.open_object;',
'',
'    apex_json.write(''componentId'', '''' || p_component_id);',
'    apex_json.write(''title'', initcap(p_template_type));',
'',
'    apex_json.open_array( ''values'' );',
'',
'    for l_option in ( select o.display_name,',
'                             o.display_sequence,',
'                             o.is_advanced,',
'                             o.help_text,',
'                             o.css_classes,',
'                             ',
'                             to_char(g.template_opt_group_id)    as group_id,',
'                             g.display_name     as group_display_name,',
'                             g.display_sequence as group_display_sequence,',
'                             g.is_advanced      as group_is_advanced,',
'                             g.help_text        as group_help_text,',
'                             g.null_text        as group_null_text',
'                        from apex_appl_template_options o,',
'                             apex_appl_template_opt_groups g',
'                       where o.application_id    = p_application_id',
'                         and o.theme_number      = p_theme_id',
'                         and o.workspace         = c_workspace',
'                         and (  (   o.virtual_template_id is null',
'                                and instr( o.virtual_template_type, p_template_type ) > 0',
'                                )',
'                             or (   o.virtual_template_id   = p_template_id',
'                                and o.virtual_template_type = p_template_type',
'                                )',
'                             )',
'                         and g.template_opt_group_id (+) = o.group_id',
'                       order by o.display_sequence, o.template_option_id )',
'    loop',
'        if l_emit_template_defaults then',
'            emit_template_options (',
'                p_d           => wwv_flow_lang.system_message(''TEMPLATE_OPTIONS.USE_TEMPLATE_DEFAULTS''),',
'                p_r           => ''#DEFAULT#'',',
'                p_seq         => 0,',
'                p_is_advanced => false );',
'            l_emit_template_defaults := false;',
'        end if;',
'        ',
'        emit_template_options (',
'            p_d           => l_option.display_name,',
'            p_r           => l_option.css_classes,',
'            p_seq         => l_option.display_sequence,',
'            p_is_advanced => ( l_option.is_advanced = ''Y'' ),',
'            p_help_text   => l_option.help_text,',
'            p_group_id    => l_option.group_id );',
'        ',
'        if l_option.group_id is not null and not l_groups.exists( l_option.group_id ) then',
'            l_groups( l_option.group_id ).display_name     := l_option.group_display_name;',
'            l_groups( l_option.group_id ).display_sequence := l_option.group_display_sequence;',
'            l_groups( l_option.group_id ).is_advanced      := l_option.group_is_advanced;',
'            l_groups( l_option.group_id ).help_text        := l_option.group_help_text;',
'            l_groups( l_option.group_id ).null_text        := l_option.group_null_text;',
'        end if;',
'    end loop;',
'    apex_json.close_array;',
'',
'    ',
'    apex_json.open_object( ''groups'' );',
'    l_group_id := l_groups.first;',
'    loop',
'        exit when l_group_id is null;',
'',
'        apex_json.open_object( l_group_id );',
'        apex_json.write(''title'',      l_groups(l_group_id).display_name);',
'        apex_json.write(''seq'',        l_groups(l_group_id).display_sequence);',
'        apex_json.write(''isAdvanced'', (l_groups(l_group_id).is_advanced = ''Y''));',
'        apex_json.write(''helpText'',   wwv_flow_escape.html_whitelist(l_groups(l_group_id).help_text));',
'        apex_json.write(''nullText'',   l_groups(l_group_id).null_text);',
'        apex_json.close_object;',
'        ',
'        l_group_id := l_groups.next( l_group_id );',
'    end loop;',
'    apex_json.close_object;',
'',
'    execute immediate ''select default_template_options, preset_template_options from '' ||',
'                        case p_template_type',
'                        when ''REGION''     then ''apex_application_temp_region''',
'                        when ''BUTTON''     then ''apex_application_temp_button''',
'                        when ''FIELD''      then ''apex_application_temp_label''',
'                        when ''REPORT''     then ''apex_application_temp_report''',
'                        when ''LIST''       then ''apex_application_temp_list''',
'                        when ''BREADCRUMB'' then ''apex_application_temp_bc''',
'                        end ||',
'                    '' where '' ||',
'                        case p_template_type',
'                        when ''REGION''     then ''region_template_id''',
'                        when ''BUTTON''     then ''button_template_id''',
'                        when ''FIELD''      then ''label_template_id''',
'                        when ''REPORT''     then ''template_id''',
'                        when ''LIST''       then ''list_template_id''',
'                        when ''BREADCRUMB'' then ''breadcrumb_template_id''',
'                        end ||',
'                    '' = :p_template_id and workspace = :p_security_group_id''',
'                 into l_default,',
'                      l_preset',
'                using p_template_id,',
'                      c_workspace;',
'',
'    apex_json.write(',
'        p_name       => ''currentValues'',',
'        p_value      => p_current_values,',
'        p_write_null => true );',
'',
'    apex_json.write(',
'        p_name       => ''defaultValues'',',
'        p_values     => apex_string.split(',
'                            p_str => l_default,',
'                            p_sep => '':'' ),',
'        p_write_null => true );',
'',
'    apex_json.write(',
'        p_name       => ''presetValues'',',
'        p_values     => apex_string.split(',
'                            p_str => l_preset,',
'                            p_sep => '':'' ),',
'        p_write_null => true );',
'',
'    apex_json.close_object;',
'',
'end;',
'',
'procedure emit_component_templ_options',
'    ( p_application_id      number',
'    , p_page_id             number',
'    , p_component_type      varchar2',
'    , p_component_static_id varchar2',
'    )',
'as',
'    l_component_id               number;',
'    l_primary_template_id        number;',
'    l_primary_template_type      varchar2(10);',
'    l_primary_template_options   apex_application_page_regions.region_template_options%type;',
'    l_secondary_template_id      number;',
'    l_secondary_template_type    varchar2(10);',
'    l_secondary_template_options apex_application_page_regions.component_template_options%type;',
'    l_theme_id                   number := 42;',
'begin',
'    ',
'    if p_component_type = ''REGION'' then',
'',
'        l_primary_template_type := ''REGION'';',
'        select region_id,',
'               template_id,',
'               region_template_options,',
'               case',
'                 when source_type_plugin_name = c_region_type_list_region                          then list_template_override_id',
'                 when source_type_plugin_name = c_region_type_breadcrumb_region                    then breadcrumb_template_id',
'                 when source_type_plugin_name in (c_region_type_sql_report, c_region_type_tabform) then report_template_id',
'               end,',
'               case',
'                 when source_type_plugin_name = c_region_type_list_region                          then ''LIST''',
'                 when source_type_plugin_name = c_region_type_breadcrumb_region                    then ''BREADCRUMB''',
'                 when source_type_plugin_name in (c_region_type_sql_report, c_region_type_tabform) then ''REPORT''',
'               end,',
'               component_template_options',
'          into l_component_id,',
'               l_primary_template_id,',
'               l_primary_template_options,',
'               l_secondary_template_id,',
'               l_secondary_template_type,',
'               l_secondary_template_options',
'          from apex_application_page_regions',
'         where static_id         = p_component_static_id',
'           and application_id    = p_application_id',
'           and workspace         = c_workspace;',
'        ',
'    elsif p_component_type = ''ITEM'' then',
'',
'        l_primary_template_type := ''FIELD'';',
'        select item_id,',
'               item_label_template_id,',
'               item_template_options',
'          into l_component_id,',
'               l_primary_template_id,',
'               l_primary_template_options',
'          from apex_application_page_items',
'         where item_name        = p_component_static_id',
'           and application_id   = p_application_id',
'           and workspace        = c_workspace;',
'',
'    elsif p_component_type = ''BUTTON'' then',
'',
'        l_primary_template_type := ''BUTTON'';',
'        select button_id,',
'               button_template_id,',
'               button_template_options',
'          into l_component_id,',
'               l_primary_template_id,',
'               l_primary_template_options',
'          from apex_application_page_buttons',
'         where button_static_id = p_component_static_id',
'           and application_id   = p_application_id',
'           and workspace        = c_workspace;',
'               ',
'    end if;',
'    ',
'    -- if there is a secondary template, get that one',
'    if l_secondary_template_id is not null then',
'        emit_template_templ_options (',
'            p_component_id   => l_component_id,',
'            p_application_id => p_application_id,',
'            p_theme_id       => l_theme_id,',
'            p_template_id    => l_secondary_template_id,',
'            p_template_type  => l_secondary_template_type,',
'            p_current_values => l_secondary_template_options );',
'    else',
'    -- if not, get the main template',
'        emit_template_templ_options (',
'            p_component_id   => l_component_id,',
'            p_application_id => p_application_id,',
'            p_theme_id       => l_theme_id,',
'            p_template_id    => l_primary_template_id,',
'            p_template_type  => l_primary_template_type,',
'            p_current_values => l_primary_template_options );',
'    end if;',
'end;',
'',
'function render',
'    ( p_region              apex_plugin.t_region',
'    , p_plugin              apex_plugin.t_plugin',
'    , p_is_printer_friendly boolean',
'    )',
'return apex_plugin.t_region_render_result',
'as',
'',
'    c_component_type                constant varchar2(1000) := p_region.attribute_01;',
'    c_component_static_id           constant varchar2(1000) := p_region.attribute_02;',
'',
'    c_region_id                     constant varchar2(1000) := p_region.static_id;',
'    c_preview_id                    constant varchar2(1000) := c_region_id || ''_preview'';',
'    c_preview_selector              constant varchar2(1000) := apex_escape.html(''#'' || c_preview_id);',
'begin',
'',
'    if apex_application.g_debug then',
'        apex_plugin_util.debug_region',
'            ( p_plugin => p_plugin',
'            , p_region => p_region',
'            );',
'    end if;',
'',
'    htp.p(''<div id="'' || apex_escape.html(c_preview_id) || ''" class="ut-PropertyEditor"></div>'');',
'',
'    apex_json.initialize_clob_output;',
'',
'    emit_component_templ_options',
'        ( p_application_id      => :app_id',
'        , p_page_id             => :app_page_id',
'        , p_component_type      => c_component_type',
'        , p_component_static_id => c_component_static_id',
'        );',
'',
'    apex_javascript.add_onload_code(',
'        p_code => ''apex.theme42demo.initPreviewTemplateOptions("'' || c_preview_selector || ''", ''',
'            || apex_json.get_clob_output(p_free => true) || '');''',
'    );',
'',
'    return null;',
'end;'))
,p_api_version=>1
,p_render_function=>'render'
,p_substitute_attributes=>true
,p_reference_id=>2941579137966323558
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
,p_files_version=>142
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(776877232102146559)
,p_plugin_id=>wwv_flow_api.id(776877005555146556)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Component Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(776877615486146561)
,p_plugin_attribute_id=>wwv_flow_api.id(776877232102146559)
,p_display_sequence=>10
,p_display_value=>'Region'
,p_return_value=>'REGION'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(776878127670146565)
,p_plugin_attribute_id=>wwv_flow_api.id(776877232102146559)
,p_display_sequence=>20
,p_display_value=>'Item'
,p_return_value=>'ITEM'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(776878621074146565)
,p_plugin_attribute_id=>wwv_flow_api.id(776877232102146559)
,p_display_sequence=>30
,p_display_value=>'Button'
,p_return_value=>'BUTTON'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(776879198784146566)
,p_plugin_id=>wwv_flow_api.id(776877005555146556)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Static ID'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>For regions and buttons, provide their Static ID.</p>',
'<p>For items, provide their regular names.</p>'))
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '3C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222077696474683D223422206865696768743D2234223E3C706174682066696C6C3D22236666662220643D224D322E37383720312E3238374C312E363235';
wwv_flow_api.g_varchar2_table(2) := '20322E3434386C2D2E3431322D2E343131612E3132352E3132352030203120302D2E3137372E3137376C2E352E352E3038392E3033362E3038382D2E30333720312E32352D312E3235632E3034392D2E3034392E3034392D2E31323820302D2E31373773';
wwv_flow_api.g_varchar2_table(3) := '2D2E3132372D2E3034382D2E3137362E3030317A222F3E3C2F7376673E';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(776879554611146570)
,p_plugin_id=>wwv_flow_api.id(776877005555146556)
,p_file_name=>'assets/checkbox-checked.svg'
,p_mime_type=>'image/svg+xml'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '3C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222077696474683D2234303022206865696768743D22323030222076696577426F783D222D39392E3520302E352034303020323030223E3C706174682066';
wwv_flow_api.g_varchar2_table(2) := '696C6C3D22233434342220643D224D3135362E32352037332E37633020312E362D2E36313220332E322D312E38323520342E3432354C313030203133322E35352034352E3537352037382E313235632D322E3433382D322E3433382D322E3433382D362E';
wwv_flow_api.g_varchar2_table(3) := '3420302D382E38333773362E342D322E34333820382E38333720304C313030203131342E3836326C34352E3537352D34352E35373561362E32353320362E32353320302030203120382E383337203020362E323320362E323320302030203120312E3833';
wwv_flow_api.g_varchar2_table(4) := '3820342E3431337A222F3E3C2F7376673E';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(776879964009146571)
,p_plugin_id=>wwv_flow_api.id(776877005555146556)
,p_file_name=>'assets/select-arrow.svg'
,p_mime_type=>'image/svg+xml'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2E75742D50726F7065727479456469746F72207B0A20202F2A203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(2) := '0A2020202050726F7065727479202850726F706572747920456469746F722050726F70657274696573290A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(3) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A20202F2A2A0A202020202A2050726F706572747920436F6D706F6E656E740A202020202A0A202020202A205468697320697320612070726F70657274792074686174206973207573656420';
wwv_flow_api.g_varchar2_table(4) := '77697468696E2074686520636F6E74657874206F6620612070726F706572747920656469746F7220746F0A202020202A2070726F766964652061206C6162656C20616E6420696E707574206669656C642E0A202020202A0A202020202A204578616D706C';
wwv_flow_api.g_varchar2_table(5) := '652048544D4C3A0A202020202A0A202020202A203C64697620636C6173733D22612D50726F7065727479223E0A202020202A2020203C64697620636C6173733D22612D50726F70657274792D6C6162656C436F6E7461696E6572223E0A202020202A2020';
wwv_flow_api.g_varchar2_table(6) := '2020203C6C6162656C20636C6173733D22612D50726F70657274792D6C6162656C223E4C6162656C3C2F6C6162656C3E0A202020202A2020203C2F6469763E0A202020202A2020203C64697620636C6173733D22612D50726F70657274792D6669656C64';
wwv_flow_api.g_varchar2_table(7) := '436F6E7461696E6572223E0A202020202A20202020203C696E70757420747970653D22746578742220636C6173733D22612D50726F70657274792D6669656C64223E0A202020202A2020203C2F6469763E0A202020202A203C2F6469763E0A202020202A';
wwv_flow_api.g_varchar2_table(8) := '2F0A20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A2020202050726F706572747920457272';
wwv_flow_api.g_varchar2_table(9) := '6F720A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A20202F2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(10) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A2020202050726F7065727479205761726E696E670A202020202A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(11) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(12) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A202020204C6162656C20616E6420507265202F20506F737420546578740A202020202A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(13) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(14) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A2020202050726F7065727479204669656C64202D205573656420666F722070726F706572747920656469746F720A2020';
wwv_flow_api.g_varchar2_table(15) := '20202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A20202F2A2050726F70657274792045646974';
wwv_flow_api.g_varchar2_table(16) := '6F722053656C656374204C6973740A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A20202F';
wwv_flow_api.g_varchar2_table(17) := '2A205465787420417265610A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A20202F2A2A2A';
wwv_flow_api.g_varchar2_table(18) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020436F6D626F20426F78205374796C65730A202020';
wwv_flow_api.g_varchar2_table(19) := '202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(20) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020436865636B626F78202B20526164696F20427574746F6E730A202020202A2A2A2A';
wwv_flow_api.g_varchar2_table(21) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(22) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020436865636B626F782053706563696669630A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(23) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(24) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020526164696F2053706563696669630A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(25) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(26) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020596573202F204E6F20427574746F6E730A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(27) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(28) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020526164696F0A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(29) := '2A2A2A2A2A2A2A2A2A2A2F0A20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A202020205965';
wwv_flow_api.g_varchar2_table(30) := '73202F204E6F20526164696F730A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2020';
wwv_flow_api.g_varchar2_table(31) := '2F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020537461636B65642050726F7065727469';
wwv_flow_api.g_varchar2_table(32) := '65730A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A20202F2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(33) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020486964652F53686F7720436C61737365730A202020202A2A2A2A2A';
wwv_flow_api.g_varchar2_table(34) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(35) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A202020205661726961626C65204669656C640A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(36) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(37) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020436865636B626F780A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(38) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(39) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020536574204974656D73205461626C650A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(40) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(41) := '2A2A2A2A2A2A0A2020202050726F706572747920456469746F7220696E204469616C6F67730A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(42) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(43) := '2A2A2A0A2020202050726F706572747920456469746F7220427574746F6E730A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(44) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A2020';
wwv_flow_api.g_varchar2_table(45) := '2020537461636B6564205374796C65730A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F';
wwv_flow_api.g_varchar2_table(46) := '0A20202F2A203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D0A202020204869676820436F6E7472617374204D';
wwv_flow_api.g_varchar2_table(47) := '6F64650A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A20202F2A0A202020202464697370';
wwv_flow_api.g_varchar2_table(48) := '6C61792D787878733A2036343070783B0A2020202024646973706C61792D7878733A2038303070783B0A2020202024646973706C61792D78733A203130323470783B0A2020202024646973706C61792D736D616C6C3A203132383070783B0A2020202024';
wwv_flow_api.g_varchar2_table(49) := '646973706C61792D6D656469756D3A203136383070783B0A2020202024646973706C61792D6C617267653A203139323070783B0A202020202A2F0A20202F2A203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(50) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D0A2020202050726F706572747920456469746F720A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(51) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A20202F2A2050726F706572747920456469746F722047726F7570730A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(52) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A20202F2A2A0A202020202A204D6F6469666965723A2069732D656D7074790A202020202A0A202020202A20557365642077';
wwv_flow_api.g_varchar2_table(53) := '68656E20616E206572726F72206D65737361676520697320646973706C617965640A202020202A2F0A20202F2A2046696C746572696E670A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(54) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A20202F2A2050726F70657274792046696C746572204E6F7420466F756E640A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(55) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A20202F2A0A2020202024646973706C61792D787878733A2036343070783B0A2020202024646973706C61792D7878733A20';
wwv_flow_api.g_varchar2_table(56) := '38303070783B0A2020202024646973706C61792D78733A203130323470783B0A2020202024646973706C61792D736D616C6C3A203132383070783B0A2020202024646973706C61792D6D656469756D3A203136383070783B0A2020202024646973706C61';
wwv_flow_api.g_varchar2_table(57) := '792D6C617267653A203139323070783B0A202020202A2F0A20202F2A203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(58) := '3D3D3D0A2020202050726F70657274792047726F7570202850726F706572747920456469746F722047726F757073290A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(59) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A20202F2A2A0A202020202A2050726F70657274792047726F757020436F6D706F6E656E740A202020202A0A202020202A205468697320697320612067726F7570696E67206F66';
wwv_flow_api.g_varchar2_table(60) := '206F6E65206F72206D6F72652070726F7065727469657320696E2074686520636F6E74657874206F6620612070726F70657274790A202020202A20656469746F722E205468697320616C6C6F777320757320746F20636F6E76656E69656E746C79206772';
wwv_flow_api.g_varchar2_table(61) := '6F7570206F75722070726F7065727469657320616E64207573650A202020202A2070737565646F2073656C6563746F727320746F206170706C79207374796C657320746F206669727374202F206C61737420656C656D656E74732077697468696E207468';
wwv_flow_api.g_varchar2_table(62) := '652067726F75702E0A202020202A0A202020202A204578616D706C652048544D4C3A0A202020202A0A202020202A203C64697620636C6173733D22612D50726F706572747947726F7570223E0A202020202A2020203C64697620636C6173733D22612D50';
wwv_flow_api.g_varchar2_table(63) := '726F706572747947726F75702D6974656D223E0A202020202A20202020205B50726F70657274792020486572655D0A202020202A2020203C2F6469763E0A202020202A2020203C64697620636C6173733D22612D50726F706572747947726F75702D6974';
wwv_flow_api.g_varchar2_table(64) := '656D223E0A202020202A20202020205B50726F70657274792020486572655D0A202020202A2020203C2F6469763E0A202020202A2020203C64697620636C6173733D22612D50726F706572747947726F75702D6974656D223E0A202020202A2020202020';
wwv_flow_api.g_varchar2_table(65) := '5B50726F70657274792020486572655D0A202020202A2020203C2F6469763E0A202020202A203C2F6469763E0A202020202A2F0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479207B0A2020706F736974696F6E3A2072';
wwv_flow_api.g_varchar2_table(66) := '656C61746976653B0A2020646973706C61793A207461626C653B0A20206D617267696E3A20303B0A202070616464696E673A20303B0A202077696474683A20313030253B0A20207461626C652D6C61796F75743A206175746F3B0A7D0A2E75742D50726F';
wwv_flow_api.g_varchar2_table(67) := '7065727479456469746F72202E612D50726F7065727479202E612D49636F6E2E69636F6E2D7265717569726564207B0A2020646973706C61793A206E6F6E653B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6275';
wwv_flow_api.g_varchar2_table(68) := '74746F6E436F6E7461696E65722C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C436F6E7461696E65722C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D756E6974436F6E';
wwv_flow_api.g_varchar2_table(69) := '7461696E6572207B0A2020646973706C61793A207461626C652D63656C6C3B0A2020766572746963616C2D616C69676E3A206D6964646C653B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E';
wwv_flow_api.g_varchar2_table(70) := '7461696E65722C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C436F6E7461696E65722C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64436F6E7461696E6572';
wwv_flow_api.g_varchar2_table(71) := '2C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D756E6974436F6E7461696E6572207B0A202070616464696E673A20347078203870783B0A7D0A406D65646961206F6E6C792073637265656E20616E6420286D61782D77';
wwv_flow_api.g_varchar2_table(72) := '696474683A2031303234707829207B0A20202E75742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461696E65722C0A20202E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C';
wwv_flow_api.g_varchar2_table(73) := '6162656C436F6E7461696E65722C0A20202E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64436F6E7461696E65722C0A20202E75742D50726F7065727479456469746F72202E612D50726F70657274792D756E69';
wwv_flow_api.g_varchar2_table(74) := '74436F6E7461696E6572207B0A2020202070616464696E673A20327078203870783B0A20207D0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C436F6E7461696E6572207B0A202070616464696E672D72';
wwv_flow_api.g_varchar2_table(75) := '696768743A20303B0A20206D696E2D77696474683A2031313270783B0A7D0A2E75742D50726F7065727479456469746F72202374656D706C6174654F7074696F6E73446C675045202E612D50726F70657274792D6C6162656C436F6E7461696E6572207B';
wwv_flow_api.g_varchar2_table(76) := '0A20206D696E2D77696474683A2031343470783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274793A6E6F74282E612D50726F70657274792D2D7374';
wwv_flow_api.g_varchar2_table(77) := '61636B656429202E612D50726F70657274792D6C6162656C436F6E7461696E6572207B0A2020646973706C61793A207461626C652D726F773B0A202077696474683A20313030253B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F';
wwv_flow_api.g_varchar2_table(78) := '70657274792D6669656C64436F6E7461696E6572207B0A2020646973706C61793A207461626C652D63656C6C3B0A202077696474683A20313030253B0A2020766572746963616C2D616C69676E3A206D6964646C653B0A7D0A2E75742D50726F70657274';
wwv_flow_api.g_varchar2_table(79) := '79456469746F72202E612D50726F70657274792D6669656C64436F6E7461696E65722D2D636F6D626F426F78207B0A202070616464696E672D72696768743A20302021696D706F7274616E743B0A7D0A2E75742D50726F7065727479456469746F72202E';
wwv_flow_api.g_varchar2_table(80) := '612D50726F70657274792D627574746F6E436F6E7461696E65722D2D636F6D626F426F78202E612D427574746F6E207B0A20206D617267696E2D6C6566743A202D3170783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F706572';
wwv_flow_api.g_varchar2_table(81) := '74792D636F6C6F7250726576696577207B0A2020646973706C61793A20626C6F636B3B0A202077696474683A20313270783B0A20206865696768743A20313270783B0A2020626F726465722D7261646975733A20313030253B0A7D0A2E75742D50726F70';
wwv_flow_api.g_varchar2_table(82) := '65727479456469746F72202E612D50726F70657274792D6669656C64436F6E7461696E65722D2D636F6C6F725069636B6572207B0A202070616464696E672D72696768743A20302021696D706F7274616E743B0A7D0A2E75742D50726F70657274794564';
wwv_flow_api.g_varchar2_table(83) := '69746F72202E612D50726F70657274792D6669656C64436F6E7461696E65722D2D636F6C6F725069636B6572202E612D50726F70657274792D6669656C64207B0A202070616464696E672D6C6566743A20323470783B0A2020626F726465722D746F702D';
wwv_flow_api.g_varchar2_table(84) := '72696768742D7261646975733A20302021696D706F7274616E743B0A2020626F726465722D626F74746F6D2D72696768742D7261646975733A20302021696D706F7274616E743B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70';
wwv_flow_api.g_varchar2_table(85) := '657274792D6669656C64436F6E7461696E65722D2D636F6C6F725069636B6572202E612D50726F70657274792D636F6C6F7250726576696577207B0A2020706F736974696F6E3A206162736F6C7574653B0A20206D617267696E3A203670783B0A202070';
wwv_flow_api.g_varchar2_table(86) := '6F696E7465722D6576656E74733A206E6F6E653B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461696E65722D2D636F6C6F725069636B6572202E612D427574746F6E207B0A20206D6172';
wwv_flow_api.g_varchar2_table(87) := '67696E2D6C6566743A202D3170783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D756E6974436F6E7461696E6572207B0A202070616464696E672D6C6566743A20302021696D706F7274616E743B0A2020776869';
wwv_flow_api.g_varchar2_table(88) := '74652D73706163653A206E6F777261703B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D6572726F72202E69636F6E2D6572726F72207B0A20206D617267696E2D72696768743A203470783B0A7D0A2E7574';
wwv_flow_api.g_varchar2_table(89) := '2D50726F7065727479456469746F72202E612D50726F70657274792E69732D7761726E696E67202E69636F6E2D7761726E696E67207B0A20206D617267696E2D72696768743A203470783B0A7D0A2E75742D50726F7065727479456469746F72202E612D';
wwv_flow_api.g_varchar2_table(90) := '50726F70657274792D6C6162656C2C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D7365744974656D734865616465722D6865616465722C0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479';
wwv_flow_api.g_varchar2_table(91) := '2D756E6974207B0A202070616464696E673A2034707820303B0A2020666F6E742D73697A653A20313270783B0A20206C696E652D6865696768743A20313670783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D63';
wwv_flow_api.g_varchar2_table(92) := '6865636B626F782D6C6162656C2C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F207B0A2020666F6E742D73697A653A20313270783B0A20206C696E652D6865696768743A20313670783B0A7D0A2E75742D';
wwv_flow_api.g_varchar2_table(93) := '50726F7065727479456469746F72202E612D50726F70657274792D756E6974207B0A2020666F6E742D73697A653A20313170783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C2D2D7769746849636F';
wwv_flow_api.g_varchar2_table(94) := '6E207B0A202070616464696E673A2034707820303B0A20206C696E652D6865696768743A20313670783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64207B0A202070616464696E673A203470783B0A';
wwv_flow_api.g_varchar2_table(95) := '20206D696E2D6865696768743A20323470783B0A2020666F6E742D73697A653A20313270783B0A20206C696E652D6865696768743A20313670783B0A2020626F726465722D7261646975733A203270783B0A7D0A2E75742D50726F706572747945646974';
wwv_flow_api.g_varchar2_table(96) := '6F72202E612D50726F70657274792D6669656C643A666F637573207B0A20206F75746C696E653A206E6F6E653B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D7661726961626C65202E612D49636F6E2E69';
wwv_flow_api.g_varchar2_table(97) := '636F6E2D7661726961626C65207B0A20206D617267696E2D72696768743A203470783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D7661726961626C65202E612D50726F70657274792D6669656C64207B';
wwv_flow_api.g_varchar2_table(98) := '0A2020626F726465722D7261646975733A203270783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C642D2D73656C656374207B0A20206F766572666C6F773A2068696464656E3B0A202070616464696E';
wwv_flow_api.g_varchar2_table(99) := '672D72696768743A20333070783B0A2020746578742D696E64656E743A20302E303170783B0A2020746578742D6F766572666C6F773A202720273B0A20206261636B67726F756E642D706F736974696F6E3A203130302520303B0A20206261636B67726F';
wwv_flow_api.g_varchar2_table(100) := '756E642D73697A653A203332707820323470783B0A20206261636B67726F756E642D7265706561743A206E6F2D7265706561743B0A20202D7765626B69742D617070656172616E63653A206E6F6E653B0A20202D6D6F7A2D617070656172616E63653A20';
wwv_flow_api.g_varchar2_table(101) := '6E6F6E653B0A2020617070656172616E63653A206E6F6E653B0A7D0A2E75742D50726F7065727479456469746F7220626F64793A6E6F74283A2D6D6F7A2D68616E646C65722D626C6F636B656429202E612D50726F70657274792D6669656C642D2D7365';
wwv_flow_api.g_varchar2_table(102) := '6C656374207B0A202070616464696E673A20327078203234707820327078203270783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C642D2D74657874617265612C0A2E75742D50726F70657274794564';
wwv_flow_api.g_varchar2_table(103) := '69746F7220626F6479202E75692D776964676574202E612D50726F70657274792D6669656C642D2D7465787461726561207B0A202070616464696E673A203470783B0A20206D61782D6865696768743A2033323070783B0A20206865696768743A206175';
wwv_flow_api.g_varchar2_table(104) := '746F3B0A2020666F6E742D73697A653A20313170783B0A2020666F6E742D66616D696C793A2053464D6F6E6F2D526567756C61722C204D656E6C6F2C204D6F6E61636F2C20436F6E736F6C61732C20224C696265726174696F6E204D6F6E6F222C202243';
wwv_flow_api.g_varchar2_table(105) := '6F7572696572204E6577222C206D6F6E6F73706163653B0A20206C696E652D6865696768743A20313470783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726561644F6E6C79207B0A2020666F6E742D77656967';
wwv_flow_api.g_varchar2_table(106) := '68743A20626F6C643B0A2020666F6E742D73697A653A20313270783B0A20206C696E652D6865696768743A20323B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D7365744974656D735461626C652D686561646572';
wwv_flow_api.g_varchar2_table(107) := '207B0A2020666F6E742D7765696768743A206E6F726D616C3B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D7365744974656D735461626C65202E612D50726F70657274792D6669656C64207B0A2020626F726465';
wwv_flow_api.g_varchar2_table(108) := '722D746F702D72696768742D7261646975733A20303B0A2020626F726465722D626F74746F6D2D72696768742D7261646975733A20303B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461';
wwv_flow_api.g_varchar2_table(109) := '696E65722D2D636F6D626F426F78202E612D427574746F6E207B0A20206D617267696E2D6C6566743A203870783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D';
wwv_flow_api.g_varchar2_table(110) := '22636865636B626F78225D2C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D207B0A2020706F736974696F6E3A206162736F6C7574653B0A20206F766572';
wwv_flow_api.g_varchar2_table(111) := '666C6F773A2068696464656E3B0A2020636C69703A20726563742830203020302030293B0A20206D617267696E3A202D3170783B0A202070616464696E673A20303B0A202077696474683A203170783B0A20206865696768743A203170783B0A2020626F';
wwv_flow_api.g_varchar2_table(112) := '726465723A20303B0A20202F2A2044697361626C65642053746174650A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(113) := '3D3D3D3D3D3D3D202A2F0A20202F2A20466F6375730A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(114) := '202A2F0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C2C0A2E75742D50726F7065727479456469746F72202E612D';
wwv_flow_api.g_varchar2_table(115) := '50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D202B206C6162656C207B0A2020706F736974696F6E3A2072656C61746976653B0A202070616464696E672D72696768743A203870783B0A202070616464696E672D6C';
wwv_flow_api.g_varchar2_table(116) := '6566743A20323070783B0A2020637572736F723A20706F696E7465723B0A7D0A2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F7822';
wwv_flow_api.g_varchar2_table(117) := '5D202B206C6162656C2C0A2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D202B206C6162656C207B0A202070616464696E672D6C6566743A';
wwv_flow_api.g_varchar2_table(118) := '203870783B0A202070616464696E672D72696768743A20323070783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C616265';
wwv_flow_api.g_varchar2_table(119) := '6C3A6265666F72652C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C3A61667465722C0A2E75742D50726F7065727479';
wwv_flow_api.g_varchar2_table(120) := '456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D202B206C6162656C3A6265666F72652C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E';
wwv_flow_api.g_varchar2_table(121) := '7075745B747970653D22726164696F225D202B206C6162656C3A6166746572207B0A2020706F736974696F6E3A206162736F6C7574653B0A2020746F703A203370783B0A20206C6566743A20303B0A2020646973706C61793A20626C6F636B3B0A202077';
wwv_flow_api.g_varchar2_table(122) := '696474683A20313470783B0A20206865696768743A20313470783B0A2020636F6E74656E743A2027273B0A20202D7765626B69742D7472616E736974696F6E3A20302E31323573206F70616369747920656173653B0A20207472616E736974696F6E3A20';
wwv_flow_api.g_varchar2_table(123) := '302E31323573206F70616369747920656173653B0A7D0A2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C';
wwv_flow_api.g_varchar2_table(124) := '3A6265666F72652C0A2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C3A61667465722C0A2E75742D5072';
wwv_flow_api.g_varchar2_table(125) := '6F7065727479456469746F72202E752D52544C202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D202B206C6162656C3A6265666F72652C0A2E75742D50726F7065727479456469746F72202E752D52544C20';
wwv_flow_api.g_varchar2_table(126) := '2E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D202B206C6162656C3A6166746572207B0A20206C6566743A206175746F3B0A202072696768743A20303B0A7D0A2E75742D50726F7065727479456469746F72';
wwv_flow_api.g_varchar2_table(127) := '202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C3A6265666F72652C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E';
wwv_flow_api.g_varchar2_table(128) := '7075745B747970653D22726164696F225D202B206C6162656C3A6265666F7265207B0A20207A2D696E6465783A2039303B0A2020626F726465723A2031707820736F6C69643B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065';
wwv_flow_api.g_varchar2_table(129) := '7274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C3A61667465722C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D22';
wwv_flow_api.g_varchar2_table(130) := '726164696F225D202B206C6162656C3A6166746572207B0A20207A2D696E6465783A203130303B0A20206F7061636974793A20303B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075';
wwv_flow_api.g_varchar2_table(131) := '745B747970653D22636865636B626F78225D3A64697361626C6564202B206C6162656C2C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D3A64697361626C';
wwv_flow_api.g_varchar2_table(132) := '6564202B206C6162656C207B0A20206F7061636974793A20302E353B0A2020637572736F723A2064656661756C743B0A2020706F696E7465722D6576656E74733A206E6F6E653B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70';
wwv_flow_api.g_varchar2_table(133) := '657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A64697361626C6564202B206C6162656C3A6265666F72652C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D69';
wwv_flow_api.g_varchar2_table(134) := '6E7075745B747970653D22726164696F225D3A64697361626C6564202B206C6162656C3A6265666F7265207B0A20206F7061636974793A20302E353B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B62';
wwv_flow_api.g_varchar2_table(135) := '6F782D696E7075745B747970653D22636865636B626F78225D3A686F7665723A636865636B6564202B206C6162656C3A61667465722C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E707574';
wwv_flow_api.g_varchar2_table(136) := '5B747970653D22636865636B626F78225D3A666F6375733A636865636B6564202B206C6162656C3A61667465722C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D2272616469';
wwv_flow_api.g_varchar2_table(137) := '6F225D3A686F7665723A636865636B6564202B206C6162656C3A61667465722C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D3A666F6375733A63686563';
wwv_flow_api.g_varchar2_table(138) := '6B6564202B206C6162656C3A6166746572207B0A20206F7061636974793A20313B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D207B';
wwv_flow_api.g_varchar2_table(139) := '0A20202F2A20556E636865636B65640A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A2020';
wwv_flow_api.g_varchar2_table(140) := '2F2A20436865636B65640A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A7D0A2E75742D50';
wwv_flow_api.g_varchar2_table(141) := '726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C3A6265666F7265207B0A2020626F726465722D7261646975733A203270783B0A7D0A2E';
wwv_flow_api.g_varchar2_table(142) := '75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C3A6166746572207B0A20206261636B67726F756E642D706F736974696F6E3A';
wwv_flow_api.g_varchar2_table(143) := '203530253B0A20206261636B67726F756E642D73697A653A20313670783B0A20206261636B67726F756E642D7265706561743A206E6F2D7265706561743B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D63686563';
wwv_flow_api.g_varchar2_table(144) := '6B626F782D696E7075745B747970653D22636865636B626F78225D3A696E64657465726D696E617465202B206C6162656C3A6166746572207B0A20206F7061636974793A20313B0A20206261636B67726F756E642D696D6167653A206E6F6E653B0A2020';
wwv_flow_api.g_varchar2_table(145) := '77696474683A203870783B0A20206865696768743A203270783B0A2020626F726465722D7261646975733A203270783B0A20206D617267696E3A20367078203370783B0A20202D7765626B69742D7472616E73666F726D3A207363616C6528302E373529';
wwv_flow_api.g_varchar2_table(146) := '3B0A20207472616E73666F726D3A207363616C6528302E3735293B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A636865636B6564';
wwv_flow_api.g_varchar2_table(147) := '202B206C6162656C3A61667465722C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A636865636B6564202B206C6162656C3A6265666F72';
wwv_flow_api.g_varchar2_table(148) := '65207B0A20206F7061636974793A20313B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D207B0A20202F2A20556E636865636B65640A202020203D3D';
wwv_flow_api.g_varchar2_table(149) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A20202F2A20436865636B65640A202020203D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(150) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065';
wwv_flow_api.g_varchar2_table(151) := '7274792D726164696F2D696E7075745B747970653D22726164696F225D202B206C6162656C3A6265666F7265207B0A2020626F726465722D7261646975733A20313670783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F706572';
wwv_flow_api.g_varchar2_table(152) := '74792D726164696F2D696E7075745B747970653D22726164696F225D202B206C6162656C3A6166746572207B0A20206D617267696E3A203570783B0A202077696474683A203470783B0A20206865696768743A203470783B0A2020626F726465722D7261';
wwv_flow_api.g_varchar2_table(153) := '646975733A20313030253B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D3A636865636B6564202B206C6162656C3A6166746572207B0A20206F7061';
wwv_flow_api.g_varchar2_table(154) := '636974793A20313B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574207B0A20207061646469';
wwv_flow_api.g_varchar2_table(155) := '6E673A2030203470783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F207B0A20206D617267696E2D7269676874';
wwv_flow_api.g_varchar2_table(156) := '3A202D3170783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E707574207B0A20202F2A20556E63686563';
wwv_flow_api.g_varchar2_table(157) := '6B6564202A2F0A20202F2A20436865636B6564202A2F0A20202F2A20466F6375736564202A2F0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F';
wwv_flow_api.g_varchar2_table(158) := '70657274792D726164696F2D696E707574202B206C6162656C207B0A202070616464696E673A20327078203870783B0A20202D7765626B69742D7472616E736974696F6E3A206261636B67726F756E642D636F6C6F7220302E31357320656173653B0A20';
wwv_flow_api.g_varchar2_table(159) := '207472616E736974696F6E3A206261636B67726F756E642D636F6C6F7220302E31357320656173653B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D';
wwv_flow_api.g_varchar2_table(160) := '50726F70657274792D726164696F2D696E707574202B206C6162656C3A6265666F72652C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274';
wwv_flow_api.g_varchar2_table(161) := '792D726164696F2D696E707574202B206C6162656C3A6166746572207B0A2020636F6E74656E743A20696E697469616C3B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F';
wwv_flow_api.g_varchar2_table(162) := '6E536574202E612D50726F70657274792D726164696F2D696E7075743A636865636B6564202B206C6162656C207B0A2020666F6E742D7765696768743A20626F6C643B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479';
wwv_flow_api.g_varchar2_table(163) := '2D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A666F637573202B206C6162656C207B0A20207A2D696E6465783A20313B0A20206F75746C696E653A206E6F6E653B0A2020626F7264';
wwv_flow_api.g_varchar2_table(164) := '65722D7261646975733A203270783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75703A666F637573207B0A20206F75746C696E653A206E6F6E653B0A7D0A2E75742D50726F706572747945';
wwv_flow_api.g_varchar2_table(165) := '6469746F72202E612D50726F70657274792D726164696F207B0A2020646973706C61793A20696E6C696E652D626C6F636B3B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E707574207B0A2020';
wwv_flow_api.g_varchar2_table(166) := '646973706C61793A20696E6C696E652D626C6F636B3B0A20206D617267696E3A203270783B0A202077696474683A20313670783B0A20206865696768743A20313670783B0A2020766572746963616C2D616C69676E3A20746F703B0A7D0A2E75742D5072';
wwv_flow_api.g_varchar2_table(167) := '6F7065727479456469746F72202E612D50726F70657274792D726164696F2D6C6162656C207B0A2020646973706C61793A20696E6C696E652D626C6F636B3B0A202070616464696E673A203270783B0A2020766572746963616C2D616C69676E3A20746F';
wwv_flow_api.g_varchar2_table(168) := '703B0A2020666F6E742D73697A653A20313270783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64436F6E7461696E65722D2D726164696F47726F7570207B0A202070616464696E672D746F703A2036';
wwv_flow_api.g_varchar2_table(169) := '70783B0A202070616464696E672D626F74746F6D3A203670783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E5365743A6265666F72652C0A2E75742D50726F706572';
wwv_flow_api.g_varchar2_table(170) := '7479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E5365743A6166746572207B0A2020646973706C61793A207461626C653B0A2020636F6E74656E743A2027273B0A7D0A2E75742D50726F70657274794564';
wwv_flow_api.g_varchar2_table(171) := '69746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E5365743A6166746572207B0A2020636C6561723A20626F74683B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F';
wwv_flow_api.g_varchar2_table(172) := '47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F207B0A2020666C6F61743A206C6566743B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574';
wwv_flow_api.g_varchar2_table(173) := '746F6E536574202E612D50726F70657274792D726164696F2D696E707574207B0A2020706F736974696F6E3A206162736F6C7574653B0A20206F766572666C6F773A2068696464656E3B0A2020636C69703A20726563742830203020302030293B0A2020';
wwv_flow_api.g_varchar2_table(174) := '6D617267696E3A202D3170783B0A202070616464696E673A20303B0A202077696474683A203170783B0A20206865696768743A203170783B0A2020626F726465723A20303B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F706572';
wwv_flow_api.g_varchar2_table(175) := '74792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A64697361626C6564202B206C6162656C207B0A20206F7061636974793A20302E353B0A7D0A2E75742D50726F70657274794564';
wwv_flow_api.g_varchar2_table(176) := '69746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E707574202B206C6162656C207B0A20206D696E2D77696474683A20343870783B0A2020746578742D61';
wwv_flow_api.g_varchar2_table(177) := '6C69676E3A2063656E7465723B0A20206C696E652D6865696768743A20323070783B0A2020626F726465722D7261646975733A203270783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F7570';
wwv_flow_api.g_varchar2_table(178) := '2D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E707574202B206C6162656C202E612D49636F6E207B0A20206D617267696E3A203270783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274';
wwv_flow_api.g_varchar2_table(179) := '792D2D737461636B6564207B0A2020706F736974696F6E3A2072656C61746976653B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D6C6162656C436F6E746169';
wwv_flow_api.g_varchar2_table(180) := '6E65722C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D6669656C64436F6E7461696E6572207B0A2020646973706C61793A20626C6F636B3B0A7D0A2E75742D5072';
wwv_flow_api.g_varchar2_table(181) := '6F7065727479456469746F72202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D6C6162656C436F6E7461696E6572207B0A20206D617267696E2D72696768743A20363470783B0A202070616464696E672D626F74746F';
wwv_flow_api.g_varchar2_table(182) := '6D3A20303B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D6669656C64436F6E7461696E6572207B0A202070616464696E672D746F703A20303B0A7D0A2E7574';
wwv_flow_api.g_varchar2_table(183) := '2D50726F7065727479456469746F72202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D627574746F6E436F6E7461696E6572207B0A2020706F736974696F6E3A206162736F6C7574653B0A2020746F703A20303B0A20';
wwv_flow_api.g_varchar2_table(184) := '2072696768743A20303B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D627574746F6E436F6E7461696E6572202B202E612D50726F70657274792D6669656C64';
wwv_flow_api.g_varchar2_table(185) := '436F6E7461696E6572207B0A202070616464696E672D746F703A203470783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D627574746F6E436F6E7461696E65';
wwv_flow_api.g_varchar2_table(186) := '72202E612D427574746F6E2D2D717569636B5069636B207B0A20206D617267696E2D6C6566743A203870783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D2D7363726F6C6C61626C65207B0A2020646973706C61';
wwv_flow_api.g_varchar2_table(187) := '793A20626C6F636B3B0A20206F766572666C6F773A206175746F3B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C436F6E7461696E65722D2D77697468427574746F6E73207B0A2020646973706C6179';
wwv_flow_api.g_varchar2_table(188) := '3A207461626C652D63656C6C3B0A20207461626C652D6C61796F75743A206175746F3B0A202070616464696E672D626F74746F6D3A203870783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C436F6E';
wwv_flow_api.g_varchar2_table(189) := '7461696E65722D2D68696464656E4C6162656C207B0A202070616464696E673A20303B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461696E6572207B0A202070616464696E672D6C6566';
wwv_flow_api.g_varchar2_table(190) := '743A20302021696D706F7274616E743B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461696E65722D2D70756C6C5269676874207B0A2020666C6F61743A2072696768743B0A7D0A2E7574';
wwv_flow_api.g_varchar2_table(191) := '2D50726F7065727479456469746F72202E612D50726F70657274792E69732D6368616E676564202E612D50726F70657274792D6C6162656C436F6E7461696E65723A6265666F7265207B0A2020706F736974696F6E3A206162736F6C7574653B0A202074';
wwv_flow_api.g_varchar2_table(192) := '6F703A203170783B0A2020626F74746F6D3A20303B0A20206C6566743A203170783B0A2020646973706C61793A20696E6C696E652D626C6F636B3B0A202077696474683A203370783B0A2020636F6E74656E743A2027273B0A20206F7061636974793A20';
wwv_flow_api.g_varchar2_table(193) := '302E353B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D6368616E6765643A686F766572202E612D50726F70657274792D6C6162656C436F6E7461696E65723A6265666F72652C0A2E75742D50726F706572';
wwv_flow_api.g_varchar2_table(194) := '7479456469746F72202E612D50726F70657274792E69732D6368616E6765642E69732D666F6375736564202E612D50726F70657274792D6C6162656C436F6E7461696E65723A6265666F7265207B0A20206F7061636974793A20313B0A7D0A2E75742D50';
wwv_flow_api.g_varchar2_table(195) := '726F7065727479456469746F72202E612D50726F70657274792D6C6162656C2C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D756E6974207B0A2020646973706C61793A20626C6F636B3B0A20202D6D732D746578742D';
wwv_flow_api.g_varchar2_table(196) := '6F766572666C6F773A20656C6C69707369733B0A2020746578742D6F766572666C6F773A20656C6C69707369733B0A20206F766572666C6F773A2068696464656E3B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D';
wwv_flow_api.g_varchar2_table(197) := '6669656C64207B0A2020646973706C61793A20626C6F636B3B0A202077696474683A20313030253B0A20206261636B67726F756E642D636C69703A20626F726465722D626F783B0A2020626F726465723A203020736F6C69643B0A7D0A2E75742D50726F';
wwv_flow_api.g_varchar2_table(198) := '7065727479456469746F72202E612D50726F70657274792D6669656C642D2D7465787461726561207B0A20206D696E2D6865696768743A20343870783B0A2020666F6E742D66616D696C793A2053464D6F6E6F2D526567756C61722C204D656E6C6F2C20';
wwv_flow_api.g_varchar2_table(199) := '4D6F6E61636F2C20436F6E736F6C61732C20224C696265726174696F6E204D6F6E6F222C2022436F7572696572204E6577222C206D6F6E6F73706163653B0A2020726573697A653A20766572746963616C3B0A7D0A2E75742D50726F7065727479456469';
wwv_flow_api.g_varchar2_table(200) := '746F72202E612D50726F70657274792E6A732D73686F77416C6C2C0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702E6A732D73686F77416C6C207B0A2020646973706C61';
wwv_flow_api.g_varchar2_table(201) := '793A206E6F6E653B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722E6A732D73686F77416C6C202E612D50726F70657274792E6A732D73686F77416C6C2C0A2E75742D50726F7065727479456469746F';
wwv_flow_api.g_varchar2_table(202) := '72202E612D50726F7065727479456469746F722E6A732D73686F77416C6C202E612D50726F7065727479456469746F722D70726F706572747947726F75702E6A732D73686F77416C6C207B0A2020646973706C61793A20626C6F636B3B0A7D0A2E75742D';
wwv_flow_api.g_varchar2_table(203) := '50726F7065727479456469746F72202E612D50726F7065727479456469746F722D2D737461636B65642E6A732D73686F77416C6C202E612D50726F70657274792E6A732D73686F77416C6C207B0A2020646973706C61793A207461626C653B0A7D0A2E75';
wwv_flow_api.g_varchar2_table(204) := '742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F7847726F75703A666F637573207B0A20206F75746C696E653A206E6F6E653B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479';
wwv_flow_api.g_varchar2_table(205) := '2D636865636B626F782D696E707574207B0A2020646973706C61793A20696E6C696E652D626C6F636B3B0A20206D617267696E3A203270783B0A202077696474683A20313670783B0A20206865696768743A20313670783B0A2020766572746963616C2D';
wwv_flow_api.g_varchar2_table(206) := '616C69676E3A20746F703B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D6C6162656C207B0A2020646973706C61793A20696E6C696E652D626C6F636B3B0A202070616464696E673A203270';
wwv_flow_api.g_varchar2_table(207) := '783B0A2020766572746963616C2D616C69676E3A20746F703B0A2020666F6E742D73697A653A20313270783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D7365744974656D735461626C65207B0A202077696474';
wwv_flow_api.g_varchar2_table(208) := '683A20313030253B0A2020626F726465722D73706163696E673A20303B0A2020626F726465722D636F6C6C617073653A20636F6C6C617073653B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D7365744974656D73';
wwv_flow_api.g_varchar2_table(209) := '5461626C65207464207B0A202070616464696E672D626F74746F6D3A203470783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D7365744974656D735461626C652074723A6C6173742D6368696C64207464207B0A';
wwv_flow_api.g_varchar2_table(210) := '202070616464696E672D626F74746F6D3A20303B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D7365744974656D734865616465722D686561646572207B0A2020746578742D616C69676E3A206C6566743B0A7D0A';
wwv_flow_api.g_varchar2_table(211) := '2E75742D50726F7065727479456469746F72202E612D50726F70657274792D7365744974656D735461626C652D72656D6F7665436F6C207B0A202077696474683A20343070783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70';
wwv_flow_api.g_varchar2_table(212) := '657274792D627574746F6E207B0A20202D2D612D627574746F6E2D70616464696E672D793A203670783B0A202077696474683A20313030253B0A202077686974652D73706163653A206E6F726D616C3B0A7D0A2E75742D50726F7065727479456469746F';
wwv_flow_api.g_varchar2_table(213) := '72202E612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274792D6C6162656C436F6E7461696E6572202E612D50726F70657274792D6C6162656C207B0A202070616464696E672D72696768743A20313270783B0A20';
wwv_flow_api.g_varchar2_table(214) := '2070616464696E672D626F74746F6D3A203270783B0A202070616464696E672D6C6566743A20313270783B0A2020666F6E742D73697A653A20313170783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F';
wwv_flow_api.g_varchar2_table(215) := '722D2D737461636B6564202E612D50726F70657274792D6669656C64436F6E7461696E65722C0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274792D627574';
wwv_flow_api.g_varchar2_table(216) := '746F6E436F6E7461696E6572207B0A202070616464696E672D746F703A20303B0A202070616464696E672D626F74746F6D3A203870783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D2D73746163';
wwv_flow_api.g_varchar2_table(217) := '6B6564202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D627574746F6E436F6E7461696E6572207B0A202070616464696E672D746F703A203470783B0A202070616464696E672D626F74746F6D3A203470783B0A7D0A';
wwv_flow_api.g_varchar2_table(218) := '2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D6C6162656C436F6E7461696E6572202E612D50726F';
wwv_flow_api.g_varchar2_table(219) := '70657274792D6C6162656C207B0A202070616464696E673A2034707820303B0A7D0A2E75742D50726F7065727479456469746F72202E752D48434D202E612D50726F70657274792D6669656C64207B0A2020626F726465723A2031707820736F6C696420';
wwv_flow_api.g_varchar2_table(220) := '21696D706F7274616E743B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D77726170706572202E612D50726F7065727479456469746F722D70726F706572747947726F75703A66697273742D636869';
wwv_flow_api.g_varchar2_table(221) := '6C64207B0A20206D617267696E2D746F703A203870783B0A7D0A2E75742D50726F7065727479456469746F72202E75692D6469616C6F67202E612D50726F7065727479456469746F72207B0A20206F766572666C6F773A206175746F3B0A20206D61782D';
wwv_flow_api.g_varchar2_table(222) := '6865696768743A2034303070783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F7570207B0A2020646973706C61793A20626C6F636B3B0A20206261636B67726F756E64';
wwv_flow_api.g_varchar2_table(223) := '2D636C69703A2070616464696E672D626F783B0A20202D7765626B69742D7472616E736974696F6E3A206261636B67726F756E642D636F6C6F7220302E317320656173652C202D7765626B69742D626F782D736861646F7720302E317320656173653B0A';
wwv_flow_api.g_varchar2_table(224) := '20207472616E736974696F6E3A206261636B67726F756E642D636F6C6F7220302E317320656173652C202D7765626B69742D626F782D736861646F7720302E317320656173653B0A20207472616E736974696F6E3A206261636B67726F756E642D636F6C';
wwv_flow_api.g_varchar2_table(225) := '6F7220302E317320656173652C20626F782D736861646F7720302E317320656173653B0A20207472616E736974696F6E3A206261636B67726F756E642D636F6C6F7220302E317320656173652C20626F782D736861646F7720302E317320656173652C20';
wwv_flow_api.g_varchar2_table(226) := '2D7765626B69742D626F782D736861646F7720302E317320656173653B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702E69732D636F6C6C6170736564202E612D50';
wwv_flow_api.g_varchar2_table(227) := '726F7065727479456469746F722D70726F706572747947726F75702D686561646572207B0A2020626F726465722D626F74746F6D3A206E6F6E653B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70';
wwv_flow_api.g_varchar2_table(228) := '726F706572747947726F75702E69732D636F6C6C6170736564202E612D50726F7065727479456469746F722D70726F706572747947726F75702D626F6479207B0A2020646973706C61793A206E6F6E653B0A7D0A2E75742D50726F706572747945646974';
wwv_flow_api.g_varchar2_table(229) := '6F72202E612D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75703A66697273742D6368696C64207B0A20206D617267696E2D746F703A203470783B0A7D0A2E75742D50726F7065727479';
wwv_flow_api.g_varchar2_table(230) := '456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572207B0A20206D617267696E2D746F703A203470783B0A202070616464696E673A2031327078203870783B0A2020626F726465722D776964';
wwv_flow_api.g_varchar2_table(231) := '74683A20303B0A20202D7765626B69742D7472616E736974696F6E3A206D617267696E20302E317320656173653B0A20207472616E736974696F6E3A206D617267696E20302E317320656173653B0A7D0A406D65646961206F6E6C792073637265656E20';
wwv_flow_api.g_varchar2_table(232) := '616E6420286D61782D77696474683A2031303234707829207B0A20202E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572207B0A2020202070616464696E672D';
wwv_flow_api.g_varchar2_table(233) := '746F703A203470783B0A2020202070616464696E672D626F74746F6D3A203470783B0A20207D0A7D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A203130323570782920616E6420286D61782D77696474683A20';
wwv_flow_api.g_varchar2_table(234) := '31323739707829207B0A20202E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572207B0A2020202070616464696E672D746F703A203670783B0A202020207061';
wwv_flow_api.g_varchar2_table(235) := '6464696E672D626F74746F6D3A203670783B0A20207D0A7D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A203132383170782920616E6420286D61782D77696474683A2031363739707829207B0A20202E75742D';
wwv_flow_api.g_varchar2_table(236) := '50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572207B0A2020202070616464696E672D746F703A203870783B0A2020202070616464696E672D626F74746F6D3A203870';
wwv_flow_api.g_varchar2_table(237) := '783B0A20207D0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465723A686F766572202E612D49636F6E207B0A20206F7061636974793A20313B0A7D0A2E';
wwv_flow_api.g_varchar2_table(238) := '75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572202E612D49636F6E207B0A20206D617267696E3A20327078203670782032707820303B0A2020626F72646572';
wwv_flow_api.g_varchar2_table(239) := '2D7261646975733A203270783B0A20206F7061636974793A20302E353B0A20202D7765626B69742D7472616E736974696F6E3A20302E327320656173653B0A20207472616E736974696F6E3A20302E327320656173653B0A7D0A2E75742D50726F706572';
wwv_flow_api.g_varchar2_table(240) := '7479456469746F72202E752D52544C202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572202E612D49636F6E207B0A20206D617267696E3A20327078203020327078203670783B0A7D0A2E75742D50726F70';
wwv_flow_api.g_varchar2_table(241) := '65727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572202E612D49636F6E2E69636F6E2D72696768742D6172726F773A6265666F7265207B0A2020636F6E74656E743A20225C453044';
wwv_flow_api.g_varchar2_table(242) := '38223B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572202E612D49636F6E2E69636F6E2D646F776E2D6172726F773A6265666F7265207B0A202063';
wwv_flow_api.g_varchar2_table(243) := '6F6E74656E743A20225C65306332223B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465722E69732D666F6375736564207B0A2020706F736974696F6E';
wwv_flow_api.g_varchar2_table(244) := '3A2072656C61746976653B0A20207A2D696E6465783A203130303B0A20206F75746C696E653A206E6F6E653B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865';
wwv_flow_api.g_varchar2_table(245) := '616465722E69732D666F6375736564202E612D49636F6E207B0A20206F7061636974793A20313B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D7469746C65207B';
wwv_flow_api.g_varchar2_table(246) := '0A2020646973706C61793A20696E6C696E652D626C6F636B3B0A20206D617267696E3A20303B0A202070616464696E673A20303B0A2020766572746963616C2D616C69676E3A20746F703B0A2020666F6E742D7765696768743A203630303B0A2020666F';
wwv_flow_api.g_varchar2_table(247) := '6E742D73697A653A20313470783B0A20206C696E652D6865696768743A20323070783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722E69732D656D707479207B0A2020646973706C61793A202D7765';
wwv_flow_api.g_varchar2_table(248) := '626B69742D626F783B0A2020646973706C61793A202D6D732D666C6578626F783B0A2020646973706C61793A20666C65783B0A20206F766572666C6F773A2068696464656E3B0A20206865696768743A20313030253B0A20202D7765626B69742D626F78';
wwv_flow_api.g_varchar2_table(249) := '2D616C69676E3A2063656E7465723B0A20202D6D732D666C65782D616C69676E3A2063656E7465723B0A2020616C69676E2D6974656D733A2063656E7465723B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469';
wwv_flow_api.g_varchar2_table(250) := '746F722D6D657373616765207B0A202070616464696E673A20313270783B0A202077696474683A20313030253B0A2020746578742D616C69676E3A2063656E7465723B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479';
wwv_flow_api.g_varchar2_table(251) := '456469746F722D6D65737361676554657874207B0A20206D617267696E3A20303B0A7D0A2E75742D50726F7065727479456469746F72202E612D49636F6E202B202E612D50726F7065727479456469746F722D6D65737361676554657874207B0A20206D';
wwv_flow_api.g_varchar2_table(252) := '617267696E2D746F703A203870783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D65646974506172656E74207B0A202070616464696E673A20367078203870783B0A2020746578742D616C69676E';
wwv_flow_api.g_varchar2_table(253) := '3A2063656E7465723B0A7D0A406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A2031303234707829207B0A20202E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D65646974';
wwv_flow_api.g_varchar2_table(254) := '506172656E74207B0A2020202070616464696E673A20327078203870783B0A20207D0A7D0A406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A203130323570782920616E6420286D61782D77696474683A2031323739';
wwv_flow_api.g_varchar2_table(255) := '707829207B0A20202E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D65646974506172656E74207B0A2020202070616464696E673A20347078203870783B0A20207D0A7D0A2E75742D50726F70657274794564';
wwv_flow_api.g_varchar2_table(256) := '69746F72202E612D50726F7065727479456469746F722D66696C746572207B0A2020706F736974696F6E3A2072656C61746976653B0A2020646973706C61793A202D7765626B69742D626F783B0A2020646973706C61793A202D6D732D666C6578626F78';
wwv_flow_api.g_varchar2_table(257) := '3B0A2020646973706C61793A20666C65783B0A202070616464696E673A20303B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C746572202E612D50726F7065727479456469746F722D66696C';
wwv_flow_api.g_varchar2_table(258) := '7465722D69636F6E207B0A2020706F736974696F6E3A206162736F6C7574653B0A2020746F703A20303B0A20206C6566743A20303B0A20206D617267696E3A203870783B0A20206F7061636974793A20302E353B0A20202D7765626B69742D7472616E73';
wwv_flow_api.g_varchar2_table(259) := '6974696F6E3A20302E317320656173653B0A20207472616E736974696F6E3A20302E317320656173653B0A2020706F696E7465722D6576656E74733A206E6F6E653B0A7D0A2E75742D50726F7065727479456469746F72202E752D52544C202E612D5072';
wwv_flow_api.g_varchar2_table(260) := '6F7065727479456469746F722D66696C746572202E612D50726F7065727479456469746F722D66696C7465722D69636F6E207B0A20206C6566743A206175746F3B0A202072696768743A20303B0A7D0A2E75742D50726F7065727479456469746F72202E';
wwv_flow_api.g_varchar2_table(261) := '612D50726F7065727479456469746F722D66696C746572202E612D50726F70657274792D6669656C643A6E6F74282E612D50726F70657274792D6669656C642D2D7465787429207B0A20202D7765626B69742D626F782D73697A696E673A20626F726465';
wwv_flow_api.g_varchar2_table(262) := '722D626F783B0A2020626F782D73697A696E673A20626F726465722D626F783B0A202070616464696E673A20387078203870782038707820333270783B0A20206865696768743A20333270783B0A20206C696E652D6865696768743A20333270783B0A20';
wwv_flow_api.g_varchar2_table(263) := '20626F726465722D7261646975733A203270783B0A7D0A2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F7065727479456469746F722D66696C746572202E612D50726F70657274792D6669656C643A6E6F74282E612D50';
wwv_flow_api.g_varchar2_table(264) := '726F70657274792D6669656C642D2D7465787429207B0A202070616464696E673A20387078203332707820387078203870783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C746572202E61';
wwv_flow_api.g_varchar2_table(265) := '2D50726F70657274792D6669656C643A6E6F74282E612D50726F70657274792D6669656C642D2D74657874293A666F637573202B202E612D49636F6E207B0A20206F7061636974793A20313B0A7D0A2E75742D50726F7065727479456469746F72202E61';
wwv_flow_api.g_varchar2_table(266) := '2D50726F7065727479456469746F722D66696C746572202E612D427574746F6E2D2D737469636B7946696C746572207B0A2020706F736974696F6E3A206162736F6C7574653B0A2020746F703A20303B0A202072696768743A20303B0A2020626F74746F';
wwv_flow_api.g_varchar2_table(267) := '6D3A20303B0A20207A2D696E6465783A2031303B0A20206D617267696E3A203470783B0A202070616464696E673A203470783B0A20206F7061636974793A20303B0A20202D7765626B69742D7472616E736974696F6E3A206F70616369747920302E3173';
wwv_flow_api.g_varchar2_table(268) := '20656173653B0A20207472616E736974696F6E3A206F70616369747920302E317320656173653B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C7465723A666F6375732D77697468696E202E';
wwv_flow_api.g_varchar2_table(269) := '612D50726F70657274792D6669656C64202B202E612D49636F6E207B0A20206F7061636974793A20313B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C746572202E612D50726F7065727479';
wwv_flow_api.g_varchar2_table(270) := '2D6669656C643A666F637573207E202E612D427574746F6E2D2D737469636B7946696C7465722C0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C746572202E612D427574746F6E2D2D737469636B';
wwv_flow_api.g_varchar2_table(271) := '7946696C7465722E69732D6163746976652C0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C746572202E612D427574746F6E2D2D737469636B7946696C7465723A666F637573207B0A20206F7061';
wwv_flow_api.g_varchar2_table(272) := '636974793A20313B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D686967686C69676874207B0A202070616464696E673A2032707820303B0A2020626F726465722D7261646975733A203270783B0A20202D776562';
wwv_flow_api.g_varchar2_table(273) := '6B69742D7472616E736974696F6E3A20302E317320656173653B0A20207472616E736974696F6E3A20302E317320656173653B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6E6F74466F756E64207B0A20207061';
wwv_flow_api.g_varchar2_table(274) := '6464696E673A20312E3672656D3B0A2020746578742D616C69676E3A2063656E7465723B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6E6F74466F756E64202E612D49636F6E207B0A20206D617267696E2D626F';
wwv_flow_api.g_varchar2_table(275) := '74746F6D3A203870783B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F706572747947726F75702D6974656D207B0A2020626F726465722D746F703A2031707820736F6C69643B0A2020626F726465722D626F74746F6D2D776964';
wwv_flow_api.g_varchar2_table(276) := '74683A20303B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D626F6479207B0A202070616464696E673A2034707820303B0A7D0A';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(776880361529146571)
,p_plugin_id=>wwv_flow_api.id(776877005555146556)
,p_file_name=>'css/base.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '7B2276657273696F6E223A332C22736F7572636573223A5B22626173652E637373225D2C226E616D6573223A5B5D2C226D617070696E6773223A2241413449412C38422C434143452C69422C434143412C612C434143412C512C434143412C532C434143';
wwv_flow_api.g_varchar2_table(2) := '412C552C434143412C69422C434145462C6F442C434143452C592C434145462C38432C434143412C36432C434143412C34432C434143452C6B422C434143412C71422C434145462C38432C434145412C36432C434144412C36432C434145412C34432C43';
wwv_flow_api.g_varchar2_table(3) := '4143452C652C434145462C30434143452C38432C434145412C36432C434144412C36432C434145412C34432C434143452C694241474A2C36432C434143452C652C434143412C652C434145462C6D452C434143452C652C434145462C3844414138442C67';
wwv_flow_api.g_varchar2_table(4) := '442C43414335442C69422C434143412C552C434145462C36432C434143452C6B422C434143412C552C434143412C71422C434145462C75442C434143452C79422C43414B462C32432C434143452C612C434143412C552C434143412C572C434143412C6B';
wwv_flow_api.g_varchar2_table(5) := '422C434145462C30442C434143452C79422C434145462C34452C434143452C69422C434143412C6D432C434143412C73432C434145462C6D462C434143452C69422C434143412C552C434143412C6D422C434145462C71452C434143452C67422C434145';
wwv_flow_api.g_varchar2_table(6) := '462C34432C434143452C77422C434143412C6B422C434145462C6D442C43416D43412C67452C43416843412C75442C434146452C67422C43414B462C6F432C434143412C6F442C434145452C612C434143412C632C434143412C67422C434148462C6D43';
wwv_flow_api.g_varchar2_table(7) := '2C434143452C612C434145412C67422C434145462C36432C434147452C67422C434146462C6F432C434143452C632C434143412C67422C434145462C6D432C434143452C632C434145462C38432C434143452C612C434143412C67422C434145462C6F43';
wwv_flow_api.g_varchar2_table(8) := '2C434143452C572C434143412C652C434143412C632C434143412C67422C434143412C69422C434145462C30432C434143452C532C43414B462C34442C434143452C69422C434145462C34432C434143452C652C434143412C6B422C434143412C69422C';
wwv_flow_api.g_varchar2_table(9) := '434143412C69422C434143412C30422C434143412C79422C434143412C32422C434143412C75422C434143412C6F422C434143412C652C434145462C3442414134422C67442C43414331422C77422C434145462C38432C434143412C38442C434143452C';
wwv_flow_api.g_varchar2_table(10) := '572C434143412C67422C434143412C572C434143412C632C434145412C67422C43414E462C38442C43414B452C30462C434147462C75432C434143452C652C434143412C632C434143412C612C434145462C6D442C434143452C652C434145462C38442C';
wwv_flow_api.g_varchar2_table(11) := '434143452C79422C434143412C34422C434145462C6B452C434143452C652C434145462C34442C434143412C73442C434143452C69422C434143412C652C434143412C6B422C434143412C572C434143412C532C434143412C532C434143412C552C4341';
wwv_flow_api.g_varchar2_table(12) := '43412C512C43414D462C6B452C434143412C34442C434143452C69422C434143412C69422C434143412C69422C434143412C632C434145462C79452C434143412C6D452C434143452C67422C434143412C6B422C434147462C77452C434144412C79452C';
wwv_flow_api.g_varchar2_table(13) := '434145412C6D452C434145452C69422C434143412C4F2C434143412C4D2C434143412C612C434143412C552C434143412C572C434143412C552C434143412C71432C434143412C36422C434154462C6B452C434143452C69422C434143412C4F2C434143';
wwv_flow_api.g_varchar2_table(14) := '412C4D2C434143412C612C434147412C552C434143412C71432C434143412C36422C434147462C2B452C434144412C67462C434147412C79452C434144412C30452C434145452C532C434143412C4F2C434145462C79452C434143412C6D452C43414345';
wwv_flow_api.g_varchar2_table(15) := '2C552C434143412C67422C434145462C77452C434143412C6B452C434143452C572C434143412C532C434145462C32452C434143412C71452C434143452C552C434143412C632C434143412C6D422C434145462C6B462C434143412C34452C434143452C';
wwv_flow_api.g_varchar2_table(16) := '552C434147462C73462C434144412C73462C434147412C67462C434144412C67462C434145452C532C434151462C79452C434143452C69422C434145462C77452C434143452C75422C434143412C6F422C434143412C32422C434145462C73462C434143';
wwv_flow_api.g_varchar2_table(17) := '452C532C434143412C71422C434143412C532C434143412C552C434143412C69422C434143412C632C434143412C34422C434143412C6F422C434145462C67462C434143412C69462C43416B42412C30452C43416A42452C532C434151462C6D452C4341';
wwv_flow_api.g_varchar2_table(18) := '43452C6B422C434145462C6B452C434143452C552C434143412C532C434143412C552C434143412C6B422C43414B462C2B452C434143452C612C434145462C73452C434143452C69422C43414F462C6B462C434143452C652C434143412C36432C434143';
wwv_flow_api.g_varchar2_table(19) := '412C71432C43413844412C632C434143412C69422C434143412C67422C434143412C69422C43413944462C77462C434144412C79462C434145452C652C434145462C30462C434143452C652C434145462C77462C434143452C532C434143412C532C4341';
wwv_flow_api.g_varchar2_table(20) := '43412C69422C434145462C2B432C434143452C532C434145462C6F432C434143452C6F422C434145462C30432C434143452C6F422C434143412C552C434143412C552C434143412C572C434143412C6B422C434145462C30432C434143452C6F422C4341';
wwv_flow_api.g_varchar2_table(21) := '43412C572C434143412C6B422C434143412C632C434145462C79442C434143452C652C434143412C6B422C434147462C30442C434144412C32442C434145452C612C434143412C552C434145462C30442C434143452C552C434145462C73452C43414345';
wwv_flow_api.g_varchar2_table(22) := '2C552C434145462C34452C434143452C69422C434143412C652C434143412C6B422C434143412C572C434143412C532C434143412C532C434143412C552C434143412C512C434145462C32462C434143452C552C434151462C30462C434143452C552C43';
wwv_flow_api.g_varchar2_table(23) := '4145462C75432C434143452C69422C434147462C6B452C434144412C6B452C43413445412C73452C434143412C30462C43413345452C612C434145462C6B452C434143452C69422C434143412C67422C434145462C6B452C434143452C612C434145462C';
wwv_flow_api.g_varchar2_table(24) := '6D452C434143452C69422C434143412C4B2C434143412C4F2C434145462C38462C434143452C652C434145462C77462C434143452C652C434145462C30432C434143452C612C434143412C612C434145462C30442C434143452C6B422C434143412C6942';
wwv_flow_api.g_varchar2_table(25) := '2C434143412C6B422C434145462C30442C434143452C532C434145462C38432C434143452C77422C434145462C79442C434143452C572C434145462C32452C434143452C69422C434143412C4F2C434143412C512C434143412C512C434143412C6F422C';
wwv_flow_api.g_varchar2_table(26) := '434143412C532C434143412C552C434143412C552C434147462C73462C434144412C69462C434145452C532C434145462C6F432C434143412C6D432C434143452C612C434143412C30422C434143412C73422C434143412C652C434145462C6F432C4341';
wwv_flow_api.g_varchar2_table(27) := '43452C612C434143412C552C434143412C30422C434143412C632C434145462C38432C434143452C652C434143412C30462C434143412C652C434145462C79432C434143412C36442C434143452C592C43414D462C2B452C434143452C612C434145462C';
wwv_flow_api.g_varchar2_table(28) := '6B442C434143452C532C434145462C36432C434143452C6F422C434143412C552C434143412C552C434143412C572C434143412C6B422C434145462C36432C434143452C6F422C434143412C572C434143412C6B422C434143412C632C434145462C3443';
wwv_flow_api.g_varchar2_table(29) := '2C434143452C552C434143412C67422C434143412C77422C434145462C2B432C434143452C6B422C434145462C36442C434143452C67422C434145462C6F442C434143452C652C434145462C73442C434143452C552C434145462C71432C434143452C79';
wwv_flow_api.g_varchar2_table(30) := '422C434143412C552C434143412C6B422C434145462C30462C434143452C6B422C434143412C6B422C434143412C69422C434143412C632C434147462C79452C434144412C77452C434145452C612C434143412C6B422C434145462C38462C434143452C';
wwv_flow_api.g_varchar2_table(31) := '652C434143412C6B422C434145462C2B472C434143452C612C434145462C32432C434143452C30422C434145462C77462C434143452C632C434145462C2B432C434143452C612C434143412C67422C434145462C6B442C434143452C612C434143412C32';
wwv_flow_api.g_varchar2_table(32) := '422C434143412C77452C434145412C77442C434143412C6F462C434145462C73472C434143452C6B422C434145462C6F472C434143452C592C434145462C67462C434143452C632C434145462C79442C434143452C632C434143412C67422C434143412C';
wwv_flow_api.g_varchar2_table(33) := '632C434143412C6B432C434143412C30422C434145462C30434143452C79442C434143452C652C434143412C6F4241474A2C412C69454143452C79442C434143452C652C434143412C6F4241474A2C412C69454143452C79442C434143452C652C434143';
wwv_flow_api.g_varchar2_table(34) := '412C6F4241474A2C75452C434143452C532C434145462C69452C434143452C6F422C434143412C69422C434143412C552C434143412C32422C434143412C6D422C434145462C77452C434143452C6F422C434145462C79462C434143452C652C43414546';
wwv_flow_api.g_varchar2_table(35) := '2C77462C434143452C652C434145462C6F452C434143452C69422C434143412C572C434143412C532C434145462C34452C434143452C532C434145462C77442C434143452C6F422C434143412C512C434143412C532C434143412C6B422C434143412C65';
wwv_flow_api.g_varchar2_table(36) := '2C434143412C632C434143412C67422C434145462C36432C434143452C6D422C434143412C6D422C434143412C592C434143412C652C434143412C572C434143412C77422C434143412C71422C434143412C6B422C434145462C34432C434143452C592C';
wwv_flow_api.g_varchar2_table(37) := '434143412C552C434143412C69422C434145462C67442C434143452C512C434145462C77442C434143452C632C434145462C2B432C434143452C652C434143412C69422C434145462C30434143452C2B432C434143452C694241474A2C412C6945414345';
wwv_flow_api.g_varchar2_table(38) := '2C2B432C434143452C694241474A2C32432C434143452C69422C434143412C6D422C434143412C6D422C434143412C592C434143412C532C434145462C79452C434143452C69422C434143412C4B2C434143412C4D2C434143412C552C434143412C552C';
wwv_flow_api.g_varchar2_table(39) := '434143412C32422C434143412C6D422C434143412C6D422C434145462C67462C434143452C532C434143412C4F2C434145462C6B4541416B452C77422C43414368452C36422C434143412C71422C434143412C77422C434143412C572C434143412C6742';
wwv_flow_api.g_varchar2_table(40) := '2C434143412C69422C434145462C7945414179452C77422C43414376452C77422C434145462C6B4541416B452C73432C43414368452C532C434145462C6D452C434143452C69422C434143412C4B2C434143412C4F2C434143412C512C434143412C552C';
wwv_flow_api.g_varchar2_table(41) := '434143412C552C434143412C572C434143412C532C434143412C6D432C434143412C32422C434145462C6B462C434143452C532C434147462C36452C434143412C79452C434146412C32462C434147452C532C434145462C77432C434143452C612C4341';
wwv_flow_api.g_varchar2_table(42) := '43412C69422C434143412C32422C434143412C6D422C434145462C75432C434143452C632C434143412C69422C434145462C2B432C434143452C69422C434145462C77432C434143452C6F422C434143412C71422C434145462C75442C434143452C6122';
wwv_flow_api.g_varchar2_table(43) := '2C2266696C65223A22626173652E637373222C22736F7572636573436F6E74656E74223A5B222E75742D50726F7065727479456469746F72207B5C6E20202F2A203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(44) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D5C6E2020202050726F7065727479202850726F706572747920456469746F722050726F70657274696573295C6E202020203D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(45) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F5C6E20202F2A2A5C6E202020202A2050726F706572747920436F6D706F6E656E745C6E';
wwv_flow_api.g_varchar2_table(46) := '202020202A5C6E202020202A205468697320697320612070726F7065727479207468617420697320757365642077697468696E2074686520636F6E74657874206F6620612070726F706572747920656469746F7220746F5C6E202020202A2070726F7669';
wwv_flow_api.g_varchar2_table(47) := '64652061206C6162656C20616E6420696E707574206669656C642E5C6E202020202A5C6E202020202A204578616D706C652048544D4C3A5C6E202020202A5C6E202020202A203C64697620636C6173733D5C22612D50726F70657274795C223E5C6E2020';
wwv_flow_api.g_varchar2_table(48) := '20202A2020203C64697620636C6173733D5C22612D50726F70657274792D6C6162656C436F6E7461696E65725C223E5C6E202020202A20202020203C6C6162656C20636C6173733D5C22612D50726F70657274792D6C6162656C5C223E4C6162656C3C2F';
wwv_flow_api.g_varchar2_table(49) := '6C6162656C3E5C6E202020202A2020203C2F6469763E5C6E202020202A2020203C64697620636C6173733D5C22612D50726F70657274792D6669656C64436F6E7461696E65725C223E5C6E202020202A20202020203C696E70757420747970653D5C2274';
wwv_flow_api.g_varchar2_table(50) := '6578745C2220636C6173733D5C22612D50726F70657274792D6669656C645C223E5C6E202020202A2020203C2F6469763E5C6E202020202A203C2F6469763E5C6E202020202A2F5C6E20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(51) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E2020202050726F7065727479204572726F725C6E202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(52) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F5C6E20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(53) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E2020202050726F7065727479205761726E696E675C6E202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(54) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F5C6E20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(55) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E202020204C6162656C20616E6420507265202F20506F737420546578745C6E202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(56) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F5C6E20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(57) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E2020202050726F7065727479204669656C64202D205573656420666F722070726F706572747920656469746F725C6E202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(58) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F5C6E20202F2A2050726F706572747920456469746F722053656C656374204C6973745C6E20';
wwv_flow_api.g_varchar2_table(59) := '2020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F5C6E20202F2A205465787420417265615C6E2020';
wwv_flow_api.g_varchar2_table(60) := '20203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F5C6E20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(61) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E20202020436F6D626F20426F78205374796C65735C6E202020202A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(62) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F5C6E20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(63) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E20202020436865636B626F78202B20526164696F20427574746F6E735C6E202020202A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(64) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F5C6E20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(65) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E20202020436865636B626F782053706563696669635C6E202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(66) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F5C6E20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(67) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E20202020526164696F2053706563696669635C6E202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(68) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F5C6E20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(69) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E20202020596573202F204E6F20427574746F6E735C6E202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(70) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F5C6E20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(71) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E20202020526164696F5C6E202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(72) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F5C6E20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E';
wwv_flow_api.g_varchar2_table(73) := '20202020596573202F204E6F20526164696F735C6E202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(74) := '2A2A2A2F5C6E20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E20202020537461636B6564';
wwv_flow_api.g_varchar2_table(75) := '2050726F706572746965735C6E202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F5C6E2020';
wwv_flow_api.g_varchar2_table(76) := '2F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E20202020486964652F53686F7720436C617373';
wwv_flow_api.g_varchar2_table(77) := '65735C6E202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F5C6E20202F2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(78) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E202020205661726961626C65204669656C645C6E202020202A2A2A2A';
wwv_flow_api.g_varchar2_table(79) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F5C6E20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(80) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E20202020436865636B626F785C6E202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(81) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F5C6E20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(82) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E20202020536574204974656D73205461626C655C6E202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(83) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F5C6E20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(84) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E2020202050726F706572747920456469746F7220696E204469616C6F67735C6E202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(85) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F5C6E20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(86) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E2020202050726F706572747920456469746F7220427574746F6E735C6E202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(87) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F5C6E20202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(88) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A5C6E20202020537461636B6564205374796C65735C6E202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(89) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F5C6E20202F2A203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(90) := '3D3D3D3D3D3D3D3D3D3D3D3D5C6E202020204869676820436F6E7472617374204D6F64655C6E202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(91) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F5C6E20202F2A5C6E2020202024646973706C61792D787878733A2036343070783B5C6E2020202024646973706C61792D7878733A2038303070783B5C6E2020202024646973706C61792D78733A20313032';
wwv_flow_api.g_varchar2_table(92) := '3470783B5C6E2020202024646973706C61792D736D616C6C3A203132383070783B5C6E2020202024646973706C61792D6D656469756D3A203136383070783B5C6E2020202024646973706C61792D6C617267653A203139323070783B5C6E202020202A2F';
wwv_flow_api.g_varchar2_table(93) := '5C6E20202F2A203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D5C6E2020202050726F70657274792045646974';
wwv_flow_api.g_varchar2_table(94) := '6F725C6E202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F5C6E20202F2A2050726F7065727479';
wwv_flow_api.g_varchar2_table(95) := '20456469746F722047726F7570735C6E202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F5C6E20';
wwv_flow_api.g_varchar2_table(96) := '202F2A2A5C6E202020202A204D6F6469666965723A2069732D656D7074795C6E202020202A5C6E202020202A2055736564207768656E20616E206572726F72206D65737361676520697320646973706C617965645C6E202020202A2F5C6E20202F2A2046';
wwv_flow_api.g_varchar2_table(97) := '696C746572696E675C6E202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F5C6E20202F2A205072';
wwv_flow_api.g_varchar2_table(98) := '6F70657274792046696C746572204E6F7420466F756E645C6E202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(99) := '3D3D3D202A2F5C6E20202F2A5C6E2020202024646973706C61792D787878733A2036343070783B5C6E2020202024646973706C61792D7878733A2038303070783B5C6E2020202024646973706C61792D78733A203130323470783B5C6E20202020246469';
wwv_flow_api.g_varchar2_table(100) := '73706C61792D736D616C6C3A203132383070783B5C6E2020202024646973706C61792D6D656469756D3A203136383070783B5C6E2020202024646973706C61792D6C617267653A203139323070783B5C6E202020202A2F5C6E20202F2A203D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(101) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D5C6E2020202050726F70657274792047726F7570202850726F70657274792045';
wwv_flow_api.g_varchar2_table(102) := '6469746F722047726F757073295C6E202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F5C6E2020';
wwv_flow_api.g_varchar2_table(103) := '2F2A2A5C6E202020202A2050726F70657274792047726F757020436F6D706F6E656E745C6E202020202A5C6E202020202A205468697320697320612067726F7570696E67206F66206F6E65206F72206D6F72652070726F7065727469657320696E207468';
wwv_flow_api.g_varchar2_table(104) := '6520636F6E74657874206F6620612070726F70657274795C6E202020202A20656469746F722E205468697320616C6C6F777320757320746F20636F6E76656E69656E746C792067726F7570206F75722070726F7065727469657320616E64207573655C6E';
wwv_flow_api.g_varchar2_table(105) := '202020202A2070737565646F2073656C6563746F727320746F206170706C79207374796C657320746F206669727374202F206C61737420656C656D656E74732077697468696E207468652067726F75702E5C6E202020202A5C6E202020202A204578616D';
wwv_flow_api.g_varchar2_table(106) := '706C652048544D4C3A5C6E202020202A5C6E202020202A203C64697620636C6173733D5C22612D50726F706572747947726F75705C223E5C6E202020202A2020203C64697620636C6173733D5C22612D50726F706572747947726F75702D6974656D5C22';
wwv_flow_api.g_varchar2_table(107) := '3E5C6E202020202A20202020205B50726F70657274792020486572655D5C6E202020202A2020203C2F6469763E5C6E202020202A2020203C64697620636C6173733D5C22612D50726F706572747947726F75702D6974656D5C223E5C6E202020202A2020';
wwv_flow_api.g_varchar2_table(108) := '2020205B50726F70657274792020486572655D5C6E202020202A2020203C2F6469763E5C6E202020202A2020203C64697620636C6173733D5C22612D50726F706572747947726F75702D6974656D5C223E5C6E202020202A20202020205B50726F706572';
wwv_flow_api.g_varchar2_table(109) := '74792020486572655D5C6E202020202A2020203C2F6469763E5C6E202020202A203C2F6469763E5C6E202020202A2F5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479207B5C6E2020706F736974696F6E3A207265';
wwv_flow_api.g_varchar2_table(110) := '6C61746976653B5C6E2020646973706C61793A207461626C653B5C6E20206D617267696E3A20303B5C6E202070616464696E673A20303B5C6E202077696474683A20313030253B5C6E20207461626C652D6C61796F75743A206175746F3B5C6E7D5C6E2E';
wwv_flow_api.g_varchar2_table(111) := '75742D50726F7065727479456469746F72202E612D50726F7065727479202E612D49636F6E2E69636F6E2D7265717569726564207B5C6E2020646973706C61793A206E6F6E653B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D5072';
wwv_flow_api.g_varchar2_table(112) := '6F70657274792D627574746F6E436F6E7461696E65722C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C436F6E7461696E65722C5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065';
wwv_flow_api.g_varchar2_table(113) := '7274792D756E6974436F6E7461696E6572207B5C6E2020646973706C61793A207461626C652D63656C6C3B5C6E2020766572746963616C2D616C69676E3A206D6964646C653B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F';
wwv_flow_api.g_varchar2_table(114) := '70657274792D627574746F6E436F6E7461696E65722C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C436F6E7461696E65722C5C6E2E75742D50726F7065727479456469746F72202E612D50726F706572';
wwv_flow_api.g_varchar2_table(115) := '74792D6669656C64436F6E7461696E65722C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D756E6974436F6E7461696E6572207B5C6E202070616464696E673A20347078203870783B5C6E7D5C6E406D65646961206F';
wwv_flow_api.g_varchar2_table(116) := '6E6C792073637265656E20616E6420286D61782D77696474683A2031303234707829207B5C6E20202E75742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461696E65722C5C6E20202E75742D50726F7065';
wwv_flow_api.g_varchar2_table(117) := '727479456469746F72202E612D50726F70657274792D6C6162656C436F6E7461696E65722C5C6E20202E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64436F6E7461696E65722C5C6E20202E75742D50726F7065';
wwv_flow_api.g_varchar2_table(118) := '727479456469746F72202E612D50726F70657274792D756E6974436F6E7461696E6572207B5C6E2020202070616464696E673A20327078203870783B5C6E20207D5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479';
wwv_flow_api.g_varchar2_table(119) := '2D6C6162656C436F6E7461696E6572207B5C6E202070616464696E672D72696768743A20303B5C6E20206D696E2D77696474683A2031313270783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202374656D706C6174654F7074696F6E7344';
wwv_flow_api.g_varchar2_table(120) := '6C675045202E612D50726F70657274792D6C6162656C436F6E7461696E6572207B5C6E20206D696E2D77696474683A2031343470783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D2D737461';
wwv_flow_api.g_varchar2_table(121) := '636B6564202E612D50726F70657274793A6E6F74282E612D50726F70657274792D2D737461636B656429202E612D50726F70657274792D6C6162656C436F6E7461696E6572207B5C6E2020646973706C61793A207461626C652D726F773B5C6E20207769';
wwv_flow_api.g_varchar2_table(122) := '6474683A20313030253B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64436F6E7461696E6572207B5C6E2020646973706C61793A207461626C652D63656C6C3B5C6E202077696474683A20313030';
wwv_flow_api.g_varchar2_table(123) := '253B5C6E2020766572746963616C2D616C69676E3A206D6964646C653B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64436F6E7461696E65722D2D636F6D626F426F78207B5C6E20207061646469';
wwv_flow_api.g_varchar2_table(124) := '6E672D72696768743A20302021696D706F7274616E743B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461696E65722D2D636F6D626F426F78202E612D427574746F6E207B5C6E2020';
wwv_flow_api.g_varchar2_table(125) := '6D617267696E2D6C6566743A202D3170783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636F6C6F7250726576696577207B5C6E2020646973706C61793A20626C6F636B3B5C6E202077696474683A203132';
wwv_flow_api.g_varchar2_table(126) := '70783B5C6E20206865696768743A20313270783B5C6E2020626F726465722D7261646975733A20313030253B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64436F6E7461696E65722D2D636F6C6F';
wwv_flow_api.g_varchar2_table(127) := '725069636B6572207B5C6E202070616464696E672D72696768743A20302021696D706F7274616E743B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64436F6E7461696E65722D2D636F6C6F725069';
wwv_flow_api.g_varchar2_table(128) := '636B6572202E612D50726F70657274792D6669656C64207B5C6E202070616464696E672D6C6566743A20323470783B5C6E2020626F726465722D746F702D72696768742D7261646975733A20302021696D706F7274616E743B5C6E2020626F726465722D';
wwv_flow_api.g_varchar2_table(129) := '626F74746F6D2D72696768742D7261646975733A20302021696D706F7274616E743B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64436F6E7461696E65722D2D636F6C6F725069636B6572202E61';
wwv_flow_api.g_varchar2_table(130) := '2D50726F70657274792D636F6C6F7250726576696577207B5C6E2020706F736974696F6E3A206162736F6C7574653B5C6E20206D617267696E3A203670783B5C6E2020706F696E7465722D6576656E74733A206E6F6E653B5C6E7D5C6E2E75742D50726F';
wwv_flow_api.g_varchar2_table(131) := '7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461696E65722D2D636F6C6F725069636B6572202E612D427574746F6E207B5C6E20206D617267696E2D6C6566743A202D3170783B5C6E7D5C6E2E75742D50726F7065';
wwv_flow_api.g_varchar2_table(132) := '727479456469746F72202E612D50726F70657274792D756E6974436F6E7461696E6572207B5C6E202070616464696E672D6C6566743A20302021696D706F7274616E743B5C6E202077686974652D73706163653A206E6F777261703B5C6E7D5C6E2E7574';
wwv_flow_api.g_varchar2_table(133) := '2D50726F7065727479456469746F72202E612D50726F70657274792E69732D6572726F72202E69636F6E2D6572726F72207B5C6E20206D617267696E2D72696768743A203470783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50';
wwv_flow_api.g_varchar2_table(134) := '726F70657274792E69732D7761726E696E67202E69636F6E2D7761726E696E67207B5C6E20206D617267696E2D72696768743A203470783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C2C5C6E';
wwv_flow_api.g_varchar2_table(135) := '2E75742D50726F7065727479456469746F72202E612D50726F70657274792D7365744974656D734865616465722D6865616465722C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D756E6974207B5C6E202070616464';
wwv_flow_api.g_varchar2_table(136) := '696E673A2034707820303B5C6E2020666F6E742D73697A653A20313270783B5C6E20206C696E652D6865696768743A20313670783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D6C61';
wwv_flow_api.g_varchar2_table(137) := '62656C2C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F207B5C6E2020666F6E742D73697A653A20313270783B5C6E20206C696E652D6865696768743A20313670783B5C6E7D5C6E2E75742D50726F7065';
wwv_flow_api.g_varchar2_table(138) := '727479456469746F72202E612D50726F70657274792D756E6974207B5C6E2020666F6E742D73697A653A20313170783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C2D2D7769746849636F6E20';
wwv_flow_api.g_varchar2_table(139) := '7B5C6E202070616464696E673A2034707820303B5C6E20206C696E652D6865696768743A20313670783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64207B5C6E202070616464696E673A203470';
wwv_flow_api.g_varchar2_table(140) := '783B5C6E20206D696E2D6865696768743A20323470783B5C6E2020666F6E742D73697A653A20313270783B5C6E20206C696E652D6865696768743A20313670783B5C6E2020626F726465722D7261646975733A203270783B5C6E7D5C6E2E75742D50726F';
wwv_flow_api.g_varchar2_table(141) := '7065727479456469746F72202E612D50726F70657274792D6669656C643A666F637573207B5C6E20206F75746C696E653A206E6F6E653B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D766172696162';
wwv_flow_api.g_varchar2_table(142) := '6C65202E612D49636F6E2E69636F6E2D7661726961626C65207B5C6E20206D617267696E2D72696768743A203470783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D7661726961626C65202E612D50';
wwv_flow_api.g_varchar2_table(143) := '726F70657274792D6669656C64207B5C6E2020626F726465722D7261646975733A203270783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C642D2D73656C656374207B5C6E20206F766572666C6F';
wwv_flow_api.g_varchar2_table(144) := '773A2068696464656E3B5C6E202070616464696E672D72696768743A20333070783B5C6E2020746578742D696E64656E743A20302E303170783B5C6E2020746578742D6F766572666C6F773A202720273B5C6E20206261636B67726F756E642D706F7369';
wwv_flow_api.g_varchar2_table(145) := '74696F6E3A203130302520303B5C6E20206261636B67726F756E642D73697A653A203332707820323470783B5C6E20206261636B67726F756E642D7265706561743A206E6F2D7265706561743B5C6E20202D7765626B69742D617070656172616E63653A';
wwv_flow_api.g_varchar2_table(146) := '206E6F6E653B5C6E20202D6D6F7A2D617070656172616E63653A206E6F6E653B5C6E2020617070656172616E63653A206E6F6E653B5C6E7D5C6E2E75742D50726F7065727479456469746F7220626F64793A6E6F74283A2D6D6F7A2D68616E646C65722D';
wwv_flow_api.g_varchar2_table(147) := '626C6F636B656429202E612D50726F70657274792D6669656C642D2D73656C656374207B5C6E202070616464696E673A20327078203234707820327078203270783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274';
wwv_flow_api.g_varchar2_table(148) := '792D6669656C642D2D74657874617265612C5C6E2E75742D50726F7065727479456469746F7220626F6479202E75692D776964676574202E612D50726F70657274792D6669656C642D2D7465787461726561207B5C6E202070616464696E673A20347078';
wwv_flow_api.g_varchar2_table(149) := '3B5C6E20206D61782D6865696768743A2033323070783B5C6E20206865696768743A206175746F3B5C6E2020666F6E742D73697A653A20313170783B5C6E2020666F6E742D66616D696C793A2053464D6F6E6F2D526567756C61722C204D656E6C6F2C20';
wwv_flow_api.g_varchar2_table(150) := '4D6F6E61636F2C20436F6E736F6C61732C205C224C696265726174696F6E204D6F6E6F5C222C205C22436F7572696572204E65775C222C206D6F6E6F73706163653B5C6E20206C696E652D6865696768743A20313470783B5C6E7D5C6E2E75742D50726F';
wwv_flow_api.g_varchar2_table(151) := '7065727479456469746F72202E612D50726F70657274792D726561644F6E6C79207B5C6E2020666F6E742D7765696768743A20626F6C643B5C6E2020666F6E742D73697A653A20313270783B5C6E20206C696E652D6865696768743A20323B5C6E7D5C6E';
wwv_flow_api.g_varchar2_table(152) := '2E75742D50726F7065727479456469746F72202E612D50726F70657274792D7365744974656D735461626C652D686561646572207B5C6E2020666F6E742D7765696768743A206E6F726D616C3B5C6E7D5C6E2E75742D50726F7065727479456469746F72';
wwv_flow_api.g_varchar2_table(153) := '202E612D50726F70657274792D7365744974656D735461626C65202E612D50726F70657274792D6669656C64207B5C6E2020626F726465722D746F702D72696768742D7261646975733A20303B5C6E2020626F726465722D626F74746F6D2D7269676874';
wwv_flow_api.g_varchar2_table(154) := '2D7261646975733A20303B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461696E65722D2D636F6D626F426F78202E612D427574746F6E207B5C6E20206D617267696E2D6C6566743A';
wwv_flow_api.g_varchar2_table(155) := '203870783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D2C5C6E2E75742D50726F7065727479456469746F72202E612D50';
wwv_flow_api.g_varchar2_table(156) := '726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D207B5C6E2020706F736974696F6E3A206162736F6C7574653B5C6E20206F766572666C6F773A2068696464656E3B5C6E2020636C69703A20726563742830203020';
wwv_flow_api.g_varchar2_table(157) := '302030293B5C6E20206D617267696E3A202D3170783B5C6E202070616464696E673A20303B5C6E202077696474683A203170783B5C6E20206865696768743A203170783B5C6E2020626F726465723A20303B5C6E20202F2A2044697361626C6564205374';
wwv_flow_api.g_varchar2_table(158) := '6174655C6E202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F5C6E20202F2A20466F6375735C6E';
wwv_flow_api.g_varchar2_table(159) := '202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F5C6E7D5C6E2E75742D50726F70657274794564';
wwv_flow_api.g_varchar2_table(160) := '69746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D202B206C6162656C2C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E';
wwv_flow_api.g_varchar2_table(161) := '7075745B747970653D5C22726164696F5C225D202B206C6162656C207B5C6E2020706F736974696F6E3A2072656C61746976653B5C6E202070616464696E672D72696768743A203870783B5C6E202070616464696E672D6C6566743A20323070783B5C6E';
wwv_flow_api.g_varchar2_table(162) := '2020637572736F723A20706F696E7465723B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D202B206C6162';
wwv_flow_api.g_varchar2_table(163) := '656C2C5C6E2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D202B206C6162656C207B5C6E202070616464696E672D6C6566743A203870';
wwv_flow_api.g_varchar2_table(164) := '783B5C6E202070616464696E672D72696768743A20323070783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D202B206C61';
wwv_flow_api.g_varchar2_table(165) := '62656C3A6265666F72652C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D202B206C6162656C3A61667465722C5C6E2E75742D5072';
wwv_flow_api.g_varchar2_table(166) := '6F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D202B206C6162656C3A6265666F72652C5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479';
wwv_flow_api.g_varchar2_table(167) := '2D726164696F2D696E7075745B747970653D5C22726164696F5C225D202B206C6162656C3A6166746572207B5C6E2020706F736974696F6E3A206162736F6C7574653B5C6E2020746F703A203370783B5C6E20206C6566743A20303B5C6E202064697370';
wwv_flow_api.g_varchar2_table(168) := '6C61793A20626C6F636B3B5C6E202077696474683A20313470783B5C6E20206865696768743A20313470783B5C6E2020636F6E74656E743A2027273B5C6E20202D7765626B69742D7472616E736974696F6E3A20302E31323573206F7061636974792065';
wwv_flow_api.g_varchar2_table(169) := '6173653B5C6E20207472616E736974696F6E3A20302E31323573206F70616369747920656173653B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F70657274792D636865636B626F782D696E7075745B7479';
wwv_flow_api.g_varchar2_table(170) := '70653D5C22636865636B626F785C225D202B206C6162656C3A6265666F72652C5C6E2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B62';
wwv_flow_api.g_varchar2_table(171) := '6F785C225D202B206C6162656C3A61667465722C5C6E2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D202B206C6162656C3A6265666F';
wwv_flow_api.g_varchar2_table(172) := '72652C5C6E2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D202B206C6162656C3A6166746572207B5C6E20206C6566743A206175746F';
wwv_flow_api.g_varchar2_table(173) := '3B5C6E202072696768743A20303B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D202B206C6162656C3A6265666F72652C5C';
wwv_flow_api.g_varchar2_table(174) := '6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D202B206C6162656C3A6265666F7265207B5C6E20207A2D696E6465783A2039303B5C6E2020626F7264';
wwv_flow_api.g_varchar2_table(175) := '65723A2031707820736F6C69643B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D202B206C6162656C3A61667465722C5C6E';
wwv_flow_api.g_varchar2_table(176) := '2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D202B206C6162656C3A6166746572207B5C6E20207A2D696E6465783A203130303B5C6E20206F70616369';
wwv_flow_api.g_varchar2_table(177) := '74793A20303B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D3A64697361626C6564202B206C6162656C2C5C6E2E75742D50';
wwv_flow_api.g_varchar2_table(178) := '726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D3A64697361626C6564202B206C6162656C207B5C6E20206F7061636974793A20302E353B5C6E2020637572736F723A';
wwv_flow_api.g_varchar2_table(179) := '2064656661756C743B5C6E2020706F696E7465722D6576656E74733A206E6F6E653B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F78';
wwv_flow_api.g_varchar2_table(180) := '5C225D3A64697361626C6564202B206C6162656C3A6265666F72652C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D3A64697361626C6564202B20';
wwv_flow_api.g_varchar2_table(181) := '6C6162656C3A6265666F7265207B5C6E20206F7061636974793A20302E353B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D';
wwv_flow_api.g_varchar2_table(182) := '3A686F7665723A636865636B6564202B206C6162656C3A61667465722C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D3A666F6375';
wwv_flow_api.g_varchar2_table(183) := '733A636865636B6564202B206C6162656C3A61667465722C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D3A686F7665723A636865636B6564202B';
wwv_flow_api.g_varchar2_table(184) := '206C6162656C3A61667465722C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D3A666F6375733A636865636B6564202B206C6162656C3A61667465';
wwv_flow_api.g_varchar2_table(185) := '72207B5C6E20206F7061636974793A20313B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D207B5C6E20202F2A20556E6368';
wwv_flow_api.g_varchar2_table(186) := '65636B65645C6E202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F5C6E20202F2A20436865636B';
wwv_flow_api.g_varchar2_table(187) := '65645C6E202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F5C6E7D5C6E2E75742D50726F706572';
wwv_flow_api.g_varchar2_table(188) := '7479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D202B206C6162656C3A6265666F7265207B5C6E2020626F726465722D7261646975733A203270783B5C6E7D5C6E2E';
wwv_flow_api.g_varchar2_table(189) := '75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D202B206C6162656C3A6166746572207B5C6E20206261636B67726F756E642D706F73697469';
wwv_flow_api.g_varchar2_table(190) := '6F6E3A203530253B5C6E20206261636B67726F756E642D73697A653A20313670783B5C6E20206261636B67726F756E642D7265706561743A206E6F2D7265706561743B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F706572';
wwv_flow_api.g_varchar2_table(191) := '74792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D3A696E64657465726D696E617465202B206C6162656C3A6166746572207B5C6E20206F7061636974793A20313B5C6E20206261636B67726F756E642D696D6167';
wwv_flow_api.g_varchar2_table(192) := '653A206E6F6E653B5C6E202077696474683A203870783B5C6E20206865696768743A203270783B5C6E2020626F726465722D7261646975733A203270783B5C6E20206D617267696E3A20367078203370783B5C6E20202D7765626B69742D7472616E7366';
wwv_flow_api.g_varchar2_table(193) := '6F726D3A207363616C6528302E3735293B5C6E20207472616E73666F726D3A207363616C6528302E3735293B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D';
wwv_flow_api.g_varchar2_table(194) := '5C22636865636B626F785C225D3A636865636B6564202B206C6162656C3A61667465722C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C';
wwv_flow_api.g_varchar2_table(195) := '225D3A636865636B6564202B206C6162656C3A6265666F7265207B5C6E20206F7061636974793A20313B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164';
wwv_flow_api.g_varchar2_table(196) := '696F5C225D207B5C6E20202F2A20556E636865636B65645C6E202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(197) := '3D3D3D202A2F5C6E20202F2A20436865636B65645C6E202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(198) := '202A2F5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D202B206C6162656C3A6265666F7265207B5C6E2020626F726465722D726164697573';
wwv_flow_api.g_varchar2_table(199) := '3A20313670783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D202B206C6162656C3A6166746572207B5C6E20206D617267696E3A203570';
wwv_flow_api.g_varchar2_table(200) := '783B5C6E202077696474683A203470783B5C6E20206865696768743A203470783B5C6E2020626F726465722D7261646975733A20313030253B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D69';
wwv_flow_api.g_varchar2_table(201) := '6E7075745B747970653D5C22726164696F5C225D3A636865636B6564202B206C6162656C3A6166746572207B5C6E20206F7061636974793A20313B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F72';
wwv_flow_api.g_varchar2_table(202) := '2D2D737461636B6564202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574207B5C6E202070616464696E673A2030203470783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D';
wwv_flow_api.g_varchar2_table(203) := '726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F207B5C6E20206D617267696E2D72696768743A202D3170783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D';
wwv_flow_api.g_varchar2_table(204) := '726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E707574207B5C6E20202F2A20556E636865636B6564202A2F5C6E20202F2A20436865636B6564202A2F5C6E20202F2A20466F6375736564202A2F';
wwv_flow_api.g_varchar2_table(205) := '5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E707574202B206C6162656C207B5C6E20207061646469';
wwv_flow_api.g_varchar2_table(206) := '6E673A20327078203870783B5C6E20202D7765626B69742D7472616E736974696F6E3A206261636B67726F756E642D636F6C6F7220302E31357320656173653B5C6E20207472616E736974696F6E3A206261636B67726F756E642D636F6C6F7220302E31';
wwv_flow_api.g_varchar2_table(207) := '357320656173653B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E707574202B206C6162656C3A6265';
wwv_flow_api.g_varchar2_table(208) := '666F72652C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E707574202B206C6162656C3A6166746572207B5C';
wwv_flow_api.g_varchar2_table(209) := '6E2020636F6E74656E743A20696E697469616C3B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075';
wwv_flow_api.g_varchar2_table(210) := '743A636865636B6564202B206C6162656C207B5C6E2020666F6E742D7765696768743A20626F6C643B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E';
wwv_flow_api.g_varchar2_table(211) := '612D50726F70657274792D726164696F2D696E7075743A666F637573202B206C6162656C207B5C6E20207A2D696E6465783A20313B5C6E20206F75746C696E653A206E6F6E653B5C6E2020626F726465722D7261646975733A203270783B5C6E7D5C6E2E';
wwv_flow_api.g_varchar2_table(212) := '75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75703A666F637573207B5C6E20206F75746C696E653A206E6F6E653B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274';
wwv_flow_api.g_varchar2_table(213) := '792D726164696F207B5C6E2020646973706C61793A20696E6C696E652D626C6F636B3B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E707574207B5C6E2020646973706C61793A20696E6C';
wwv_flow_api.g_varchar2_table(214) := '696E652D626C6F636B3B5C6E20206D617267696E3A203270783B5C6E202077696474683A20313670783B5C6E20206865696768743A20313670783B5C6E2020766572746963616C2D616C69676E3A20746F703B5C6E7D5C6E2E75742D50726F7065727479';
wwv_flow_api.g_varchar2_table(215) := '456469746F72202E612D50726F70657274792D726164696F2D6C6162656C207B5C6E2020646973706C61793A20696E6C696E652D626C6F636B3B5C6E202070616464696E673A203270783B5C6E2020766572746963616C2D616C69676E3A20746F703B5C';
wwv_flow_api.g_varchar2_table(216) := '6E2020666F6E742D73697A653A20313270783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64436F6E7461696E65722D2D726164696F47726F7570207B5C6E202070616464696E672D746F703A20';
wwv_flow_api.g_varchar2_table(217) := '3670783B5C6E202070616464696E672D626F74746F6D3A203670783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E5365743A6265666F72652C5C6E2E75742D50';
wwv_flow_api.g_varchar2_table(218) := '726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E5365743A6166746572207B5C6E2020646973706C61793A207461626C653B5C6E2020636F6E74656E743A2027273B5C6E7D5C6E2E75742D50';
wwv_flow_api.g_varchar2_table(219) := '726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E5365743A6166746572207B5C6E2020636C6561723A20626F74683B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D5072';
wwv_flow_api.g_varchar2_table(220) := '6F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F207B5C6E2020666C6F61743A206C6566743B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D';
wwv_flow_api.g_varchar2_table(221) := '726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E707574207B5C6E2020706F736974696F6E3A206162736F6C7574653B5C6E20206F766572666C6F773A2068696464656E3B5C6E2020636C69703A';
wwv_flow_api.g_varchar2_table(222) := '20726563742830203020302030293B5C6E20206D617267696E3A202D3170783B5C6E202070616464696E673A20303B5C6E202077696474683A203170783B5C6E20206865696768743A203170783B5C6E2020626F726465723A20303B5C6E7D5C6E2E7574';
wwv_flow_api.g_varchar2_table(223) := '2D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A64697361626C6564202B206C6162656C207B5C6E20206F706163';
wwv_flow_api.g_varchar2_table(224) := '6974793A20302E353B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E707574202B206C6162656C207B';
wwv_flow_api.g_varchar2_table(225) := '5C6E20206D696E2D77696474683A20343870783B5C6E2020746578742D616C69676E3A2063656E7465723B5C6E20206C696E652D6865696768743A20323070783B5C6E2020626F726465722D7261646975733A203270783B5C6E7D5C6E2E75742D50726F';
wwv_flow_api.g_varchar2_table(226) := '7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E707574202B206C6162656C202E612D49636F6E207B5C6E20206D617267696E3A2032';
wwv_flow_api.g_varchar2_table(227) := '70783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D2D737461636B6564207B5C6E2020706F736974696F6E3A2072656C61746976653B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50';
wwv_flow_api.g_varchar2_table(228) := '726F70657274792D2D737461636B6564202E612D50726F70657274792D6C6162656C436F6E7461696E65722C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D6669';
wwv_flow_api.g_varchar2_table(229) := '656C64436F6E7461696E6572207B5C6E2020646973706C61793A20626C6F636B3B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D6C6162656C436F6E7461';
wwv_flow_api.g_varchar2_table(230) := '696E6572207B5C6E20206D617267696E2D72696768743A20363470783B5C6E202070616464696E672D626F74746F6D3A20303B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D2D737461636B6564202E612D50';
wwv_flow_api.g_varchar2_table(231) := '726F70657274792D6669656C64436F6E7461696E6572207B5C6E202070616464696E672D746F703A20303B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D';
wwv_flow_api.g_varchar2_table(232) := '627574746F6E436F6E7461696E6572207B5C6E2020706F736974696F6E3A206162736F6C7574653B5C6E2020746F703A20303B5C6E202072696768743A20303B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D';
wwv_flow_api.g_varchar2_table(233) := '2D737461636B6564202E612D50726F70657274792D627574746F6E436F6E7461696E6572202B202E612D50726F70657274792D6669656C64436F6E7461696E6572207B5C6E202070616464696E672D746F703A203470783B5C6E7D5C6E2E75742D50726F';
wwv_flow_api.g_varchar2_table(234) := '7065727479456469746F72202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D627574746F6E436F6E7461696E6572202E612D427574746F6E2D2D717569636B5069636B207B5C6E20206D617267696E2D6C6566743A20';
wwv_flow_api.g_varchar2_table(235) := '3870783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D2D7363726F6C6C61626C65207B5C6E2020646973706C61793A20626C6F636B3B5C6E20206F766572666C6F773A206175746F3B5C6E7D5C6E2E75742D';
wwv_flow_api.g_varchar2_table(236) := '50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C436F6E7461696E65722D2D77697468427574746F6E73207B5C6E2020646973706C61793A207461626C652D63656C6C3B5C6E20207461626C652D6C61796F75743A206175';
wwv_flow_api.g_varchar2_table(237) := '746F3B5C6E202070616464696E672D626F74746F6D3A203870783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C436F6E7461696E65722D2D68696464656E4C6162656C207B5C6E202070616464';
wwv_flow_api.g_varchar2_table(238) := '696E673A20303B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461696E6572207B5C6E202070616464696E672D6C6566743A20302021696D706F7274616E743B5C6E7D5C6E2E75742D';
wwv_flow_api.g_varchar2_table(239) := '50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461696E65722D2D70756C6C5269676874207B5C6E2020666C6F61743A2072696768743B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50';
wwv_flow_api.g_varchar2_table(240) := '726F70657274792E69732D6368616E676564202E612D50726F70657274792D6C6162656C436F6E7461696E65723A6265666F7265207B5C6E2020706F736974696F6E3A206162736F6C7574653B5C6E2020746F703A203170783B5C6E2020626F74746F6D';
wwv_flow_api.g_varchar2_table(241) := '3A20303B5C6E20206C6566743A203170783B5C6E2020646973706C61793A20696E6C696E652D626C6F636B3B5C6E202077696474683A203370783B5C6E2020636F6E74656E743A2027273B5C6E20206F7061636974793A20302E353B5C6E7D5C6E2E7574';
wwv_flow_api.g_varchar2_table(242) := '2D50726F7065727479456469746F72202E612D50726F70657274792E69732D6368616E6765643A686F766572202E612D50726F70657274792D6C6162656C436F6E7461696E65723A6265666F72652C5C6E2E75742D50726F7065727479456469746F7220';
wwv_flow_api.g_varchar2_table(243) := '2E612D50726F70657274792E69732D6368616E6765642E69732D666F6375736564202E612D50726F70657274792D6C6162656C436F6E7461696E65723A6265666F7265207B5C6E20206F7061636974793A20313B5C6E7D5C6E2E75742D50726F70657274';
wwv_flow_api.g_varchar2_table(244) := '79456469746F72202E612D50726F70657274792D6C6162656C2C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D756E6974207B5C6E2020646973706C61793A20626C6F636B3B5C6E20202D6D732D746578742D6F7665';
wwv_flow_api.g_varchar2_table(245) := '72666C6F773A20656C6C69707369733B5C6E2020746578742D6F766572666C6F773A20656C6C69707369733B5C6E20206F766572666C6F773A2068696464656E3B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479';
wwv_flow_api.g_varchar2_table(246) := '2D6669656C64207B5C6E2020646973706C61793A20626C6F636B3B5C6E202077696474683A20313030253B5C6E20206261636B67726F756E642D636C69703A20626F726465722D626F783B5C6E2020626F726465723A203020736F6C69643B5C6E7D5C6E';
wwv_flow_api.g_varchar2_table(247) := '2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C642D2D7465787461726561207B5C6E20206D696E2D6865696768743A20343870783B5C6E2020666F6E742D66616D696C793A2053464D6F6E6F2D526567756C6172';
wwv_flow_api.g_varchar2_table(248) := '2C204D656E6C6F2C204D6F6E61636F2C20436F6E736F6C61732C205C224C696265726174696F6E204D6F6E6F5C222C205C22436F7572696572204E65775C222C206D6F6E6F73706163653B5C6E2020726573697A653A20766572746963616C3B5C6E7D5C';
wwv_flow_api.g_varchar2_table(249) := '6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792E6A732D73686F77416C6C2C5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702E6A732D73';
wwv_flow_api.g_varchar2_table(250) := '686F77416C6C207B5C6E2020646973706C61793A206E6F6E653B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722E6A732D73686F77416C6C202E612D50726F70657274792E6A732D73686F77416C';
wwv_flow_api.g_varchar2_table(251) := '6C2C5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722E6A732D73686F77416C6C202E612D50726F7065727479456469746F722D70726F706572747947726F75702E6A732D73686F77416C6C207B5C6E2020';
wwv_flow_api.g_varchar2_table(252) := '646973706C61793A20626C6F636B3B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D2D737461636B65642E6A732D73686F77416C6C202E612D50726F70657274792E6A732D73686F77416C6C20';
wwv_flow_api.g_varchar2_table(253) := '7B5C6E2020646973706C61793A207461626C653B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F7847726F75703A666F637573207B5C6E20206F75746C696E653A206E6F6E653B5C6E7D5C6E';
wwv_flow_api.g_varchar2_table(254) := '2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E707574207B5C6E2020646973706C61793A20696E6C696E652D626C6F636B3B5C6E20206D617267696E3A203270783B5C6E202077696474683A20';
wwv_flow_api.g_varchar2_table(255) := '313670783B5C6E20206865696768743A20313670783B5C6E2020766572746963616C2D616C69676E3A20746F703B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D6C6162656C207B5C6E';
wwv_flow_api.g_varchar2_table(256) := '2020646973706C61793A20696E6C696E652D626C6F636B3B5C6E202070616464696E673A203270783B5C6E2020766572746963616C2D616C69676E3A20746F703B5C6E2020666F6E742D73697A653A20313270783B5C6E7D5C6E2E75742D50726F706572';
wwv_flow_api.g_varchar2_table(257) := '7479456469746F72202E612D50726F70657274792D7365744974656D735461626C65207B5C6E202077696474683A20313030253B5C6E2020626F726465722D73706163696E673A20303B5C6E2020626F726465722D636F6C6C617073653A20636F6C6C61';
wwv_flow_api.g_varchar2_table(258) := '7073653B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D7365744974656D735461626C65207464207B5C6E202070616464696E672D626F74746F6D3A203470783B5C6E7D5C6E2E75742D50726F706572747945';
wwv_flow_api.g_varchar2_table(259) := '6469746F72202E612D50726F70657274792D7365744974656D735461626C652074723A6C6173742D6368696C64207464207B5C6E202070616464696E672D626F74746F6D3A20303B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50';
wwv_flow_api.g_varchar2_table(260) := '726F70657274792D7365744974656D734865616465722D686561646572207B5C6E2020746578742D616C69676E3A206C6566743B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D7365744974656D735461626C';
wwv_flow_api.g_varchar2_table(261) := '652D72656D6F7665436F6C207B5C6E202077696474683A20343070783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E207B5C6E20202D2D612D627574746F6E2D70616464696E672D793A2036';
wwv_flow_api.g_varchar2_table(262) := '70783B5C6E202077696474683A20313030253B5C6E202077686974652D73706163653A206E6F726D616C3B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F';
wwv_flow_api.g_varchar2_table(263) := '70657274792D6C6162656C436F6E7461696E6572202E612D50726F70657274792D6C6162656C207B5C6E202070616464696E672D72696768743A20313270783B5C6E202070616464696E672D626F74746F6D3A203270783B5C6E202070616464696E672D';
wwv_flow_api.g_varchar2_table(264) := '6C6566743A20313270783B5C6E2020666F6E742D73697A653A20313170783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274792D6669656C6443';
wwv_flow_api.g_varchar2_table(265) := '6F6E7461696E65722C5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274792D627574746F6E436F6E7461696E6572207B5C6E202070616464696E672D746F';
wwv_flow_api.g_varchar2_table(266) := '703A20303B5C6E202070616464696E672D626F74746F6D3A203870783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274792D2D737461636B6564';
wwv_flow_api.g_varchar2_table(267) := '202E612D50726F70657274792D627574746F6E436F6E7461696E6572207B5C6E202070616464696E672D746F703A203470783B5C6E202070616464696E672D626F74746F6D3A203470783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E';
wwv_flow_api.g_varchar2_table(268) := '612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D6C6162656C436F6E7461696E6572202E612D50726F70657274792D6C6162656C207B5C6E2020706164';
wwv_flow_api.g_varchar2_table(269) := '64696E673A2034707820303B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E752D48434D202E612D50726F70657274792D6669656C64207B5C6E2020626F726465723A2031707820736F6C69642021696D706F7274616E743B5C6E7D5C6E';
wwv_flow_api.g_varchar2_table(270) := '2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D77726170706572202E612D50726F7065727479456469746F722D70726F706572747947726F75703A66697273742D6368696C64207B5C6E20206D617267696E';
wwv_flow_api.g_varchar2_table(271) := '2D746F703A203870783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E75692D6469616C6F67202E612D50726F7065727479456469746F72207B5C6E20206F766572666C6F773A206175746F3B5C6E20206D61782D6865696768743A2034';
wwv_flow_api.g_varchar2_table(272) := '303070783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F7570207B5C6E2020646973706C61793A20626C6F636B3B5C6E20206261636B67726F756E642D636C6970';
wwv_flow_api.g_varchar2_table(273) := '3A2070616464696E672D626F783B5C6E20202D7765626B69742D7472616E736974696F6E3A206261636B67726F756E642D636F6C6F7220302E317320656173652C202D7765626B69742D626F782D736861646F7720302E317320656173653B5C6E202074';
wwv_flow_api.g_varchar2_table(274) := '72616E736974696F6E3A206261636B67726F756E642D636F6C6F7220302E317320656173652C202D7765626B69742D626F782D736861646F7720302E317320656173653B5C6E20207472616E736974696F6E3A206261636B67726F756E642D636F6C6F72';
wwv_flow_api.g_varchar2_table(275) := '20302E317320656173652C20626F782D736861646F7720302E317320656173653B5C6E20207472616E736974696F6E3A206261636B67726F756E642D636F6C6F7220302E317320656173652C20626F782D736861646F7720302E317320656173652C202D';
wwv_flow_api.g_varchar2_table(276) := '7765626B69742D626F782D736861646F7720302E317320656173653B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702E69732D636F6C6C6170736564202E612D';
wwv_flow_api.g_varchar2_table(277) := '50726F7065727479456469746F722D70726F706572747947726F75702D686561646572207B5C6E2020626F726465722D626F74746F6D3A206E6F6E653B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F706572747945646974';
wwv_flow_api.g_varchar2_table(278) := '6F722D70726F706572747947726F75702E69732D636F6C6C6170736564202E612D50726F7065727479456469746F722D70726F706572747947726F75702D626F6479207B5C6E2020646973706C61793A206E6F6E653B5C6E7D5C6E2E75742D50726F7065';
wwv_flow_api.g_varchar2_table(279) := '727479456469746F72202E612D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75703A66697273742D6368696C64207B5C6E20206D617267696E2D746F703A203470783B5C6E7D5C6E2E75';
wwv_flow_api.g_varchar2_table(280) := '742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572207B5C6E20206D617267696E2D746F703A203470783B5C6E202070616464696E673A2031327078203870783B5C';
wwv_flow_api.g_varchar2_table(281) := '6E2020626F726465722D77696474683A20303B5C6E20202D7765626B69742D7472616E736974696F6E3A206D617267696E20302E317320656173653B5C6E20207472616E736974696F6E3A206D617267696E20302E317320656173653B5C6E7D5C6E406D';
wwv_flow_api.g_varchar2_table(282) := '65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A2031303234707829207B5C6E20202E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561';
wwv_flow_api.g_varchar2_table(283) := '646572207B5C6E2020202070616464696E672D746F703A203470783B5C6E2020202070616464696E672D626F74746F6D3A203470783B5C6E20207D5C6E7D5C6E406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A2031';
wwv_flow_api.g_varchar2_table(284) := '30323570782920616E6420286D61782D77696474683A2031323739707829207B5C6E20202E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572207B5C6E202020';
wwv_flow_api.g_varchar2_table(285) := '2070616464696E672D746F703A203670783B5C6E2020202070616464696E672D626F74746F6D3A203670783B5C6E20207D5C6E7D5C6E406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A203132383170782920616E64';
wwv_flow_api.g_varchar2_table(286) := '20286D61782D77696474683A2031363739707829207B5C6E20202E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572207B5C6E2020202070616464696E672D74';
wwv_flow_api.g_varchar2_table(287) := '6F703A203870783B5C6E2020202070616464696E672D626F74746F6D3A203870783B5C6E20207D5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465';
wwv_flow_api.g_varchar2_table(288) := '723A686F766572202E612D49636F6E207B5C6E20206F7061636974793A20313B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572202E612D4963';
wwv_flow_api.g_varchar2_table(289) := '6F6E207B5C6E20206D617267696E3A20327078203670782032707820303B5C6E2020626F726465722D7261646975733A203270783B5C6E20206F7061636974793A20302E353B5C6E20202D7765626B69742D7472616E736974696F6E3A20302E32732065';
wwv_flow_api.g_varchar2_table(290) := '6173653B5C6E20207472616E736974696F6E3A20302E327320656173653B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F7065727479456469746F722D70726F706572747947726F75702D68656164657220';
wwv_flow_api.g_varchar2_table(291) := '2E612D49636F6E207B5C6E20206D617267696E3A20327078203020327078203670783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572202E61';
wwv_flow_api.g_varchar2_table(292) := '2D49636F6E2E69636F6E2D72696768742D6172726F773A6265666F7265207B5C6E2020636F6E74656E743A205C225C5C453044385C223B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F';
wwv_flow_api.g_varchar2_table(293) := '706572747947726F75702D686561646572202E612D49636F6E2E69636F6E2D646F776E2D6172726F773A6265666F7265207B5C6E2020636F6E74656E743A205C225C5C653063325C223B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E61';
wwv_flow_api.g_varchar2_table(294) := '2D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465722E69732D666F6375736564207B5C6E2020706F736974696F6E3A2072656C61746976653B5C6E20207A2D696E6465783A203130303B5C6E20206F75746C696E65';
wwv_flow_api.g_varchar2_table(295) := '3A206E6F6E653B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465722E69732D666F6375736564202E612D49636F6E207B5C6E20206F7061636974';
wwv_flow_api.g_varchar2_table(296) := '793A20313B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D7469746C65207B5C6E2020646973706C61793A20696E6C696E652D626C6F636B3B5C6E20206D61';
wwv_flow_api.g_varchar2_table(297) := '7267696E3A20303B5C6E202070616464696E673A20303B5C6E2020766572746963616C2D616C69676E3A20746F703B5C6E2020666F6E742D7765696768743A203630303B5C6E2020666F6E742D73697A653A20313470783B5C6E20206C696E652D686569';
wwv_flow_api.g_varchar2_table(298) := '6768743A20323070783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722E69732D656D707479207B5C6E2020646973706C61793A202D7765626B69742D626F783B5C6E2020646973706C61793A20';
wwv_flow_api.g_varchar2_table(299) := '2D6D732D666C6578626F783B5C6E2020646973706C61793A20666C65783B5C6E20206F766572666C6F773A2068696464656E3B5C6E20206865696768743A20313030253B5C6E20202D7765626B69742D626F782D616C69676E3A2063656E7465723B5C6E';
wwv_flow_api.g_varchar2_table(300) := '20202D6D732D666C65782D616C69676E3A2063656E7465723B5C6E2020616C69676E2D6974656D733A2063656E7465723B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D6D657373616765207B';
wwv_flow_api.g_varchar2_table(301) := '5C6E202070616464696E673A20313270783B5C6E202077696474683A20313030253B5C6E2020746578742D616C69676E3A2063656E7465723B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D6D';
wwv_flow_api.g_varchar2_table(302) := '65737361676554657874207B5C6E20206D617267696E3A20303B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D49636F6E202B202E612D50726F7065727479456469746F722D6D65737361676554657874207B5C6E20206D61726769';
wwv_flow_api.g_varchar2_table(303) := '6E2D746F703A203870783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D65646974506172656E74207B5C6E202070616464696E673A20367078203870783B5C6E2020746578742D616C69676E';
wwv_flow_api.g_varchar2_table(304) := '3A2063656E7465723B5C6E7D5C6E406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A2031303234707829207B5C6E20202E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D65';
wwv_flow_api.g_varchar2_table(305) := '646974506172656E74207B5C6E2020202070616464696E673A20327078203870783B5C6E20207D5C6E7D5C6E406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A203130323570782920616E6420286D61782D77696474';
wwv_flow_api.g_varchar2_table(306) := '683A2031323739707829207B5C6E20202E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D65646974506172656E74207B5C6E2020202070616464696E673A20347078203870783B5C6E20207D5C6E7D5C6E2E75';
wwv_flow_api.g_varchar2_table(307) := '742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C746572207B5C6E2020706F736974696F6E3A2072656C61746976653B5C6E2020646973706C61793A202D7765626B69742D626F783B5C6E2020646973706C';
wwv_flow_api.g_varchar2_table(308) := '61793A202D6D732D666C6578626F783B5C6E2020646973706C61793A20666C65783B5C6E202070616464696E673A20303B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C746572202E61';
wwv_flow_api.g_varchar2_table(309) := '2D50726F7065727479456469746F722D66696C7465722D69636F6E207B5C6E2020706F736974696F6E3A206162736F6C7574653B5C6E2020746F703A20303B5C6E20206C6566743A20303B5C6E20206D617267696E3A203870783B5C6E20206F70616369';
wwv_flow_api.g_varchar2_table(310) := '74793A20302E353B5C6E20202D7765626B69742D7472616E736974696F6E3A20302E317320656173653B5C6E20207472616E736974696F6E3A20302E317320656173653B5C6E2020706F696E7465722D6576656E74733A206E6F6E653B5C6E7D5C6E2E75';
wwv_flow_api.g_varchar2_table(311) := '742D50726F7065727479456469746F72202E752D52544C202E612D50726F7065727479456469746F722D66696C746572202E612D50726F7065727479456469746F722D66696C7465722D69636F6E207B5C6E20206C6566743A206175746F3B5C6E202072';
wwv_flow_api.g_varchar2_table(312) := '696768743A20303B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C746572202E612D50726F70657274792D6669656C643A6E6F74282E612D50726F70657274792D6669656C642D2D7465';
wwv_flow_api.g_varchar2_table(313) := '787429207B5C6E20202D7765626B69742D626F782D73697A696E673A20626F726465722D626F783B5C6E2020626F782D73697A696E673A20626F726465722D626F783B5C6E202070616464696E673A20387078203870782038707820333270783B5C6E20';
wwv_flow_api.g_varchar2_table(314) := '206865696768743A20333270783B5C6E20206C696E652D6865696768743A20333270783B5C6E2020626F726465722D7261646975733A203270783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F70657274';
wwv_flow_api.g_varchar2_table(315) := '79456469746F722D66696C746572202E612D50726F70657274792D6669656C643A6E6F74282E612D50726F70657274792D6669656C642D2D7465787429207B5C6E202070616464696E673A20387078203332707820387078203870783B5C6E7D5C6E2E75';
wwv_flow_api.g_varchar2_table(316) := '742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C746572202E612D50726F70657274792D6669656C643A6E6F74282E612D50726F70657274792D6669656C642D2D74657874293A666F637573202B202E612D';
wwv_flow_api.g_varchar2_table(317) := '49636F6E207B5C6E20206F7061636974793A20313B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C746572202E612D427574746F6E2D2D737469636B7946696C746572207B5C6E202070';
wwv_flow_api.g_varchar2_table(318) := '6F736974696F6E3A206162736F6C7574653B5C6E2020746F703A20303B5C6E202072696768743A20303B5C6E2020626F74746F6D3A20303B5C6E20207A2D696E6465783A2031303B5C6E20206D617267696E3A203470783B5C6E202070616464696E673A';
wwv_flow_api.g_varchar2_table(319) := '203470783B5C6E20206F7061636974793A20303B5C6E20202D7765626B69742D7472616E736974696F6E3A206F70616369747920302E317320656173653B5C6E20207472616E736974696F6E3A206F70616369747920302E317320656173653B5C6E7D5C';
wwv_flow_api.g_varchar2_table(320) := '6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C7465723A666F6375732D77697468696E202E612D50726F70657274792D6669656C64202B202E612D49636F6E207B5C6E20206F7061636974793A20';
wwv_flow_api.g_varchar2_table(321) := '313B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C746572202E612D50726F70657274792D6669656C643A666F637573207E202E612D427574746F6E2D2D737469636B7946696C746572';
wwv_flow_api.g_varchar2_table(322) := '2C5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C746572202E612D427574746F6E2D2D737469636B7946696C7465722E69732D6163746976652C5C6E2E75742D50726F7065727479456469746F';
wwv_flow_api.g_varchar2_table(323) := '72202E612D50726F7065727479456469746F722D66696C746572202E612D427574746F6E2D2D737469636B7946696C7465723A666F637573207B5C6E20206F7061636974793A20313B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D';
wwv_flow_api.g_varchar2_table(324) := '50726F70657274792D686967686C69676874207B5C6E202070616464696E673A2032707820303B5C6E2020626F726465722D7261646975733A203270783B5C6E20202D7765626B69742D7472616E736974696F6E3A20302E317320656173653B5C6E2020';
wwv_flow_api.g_varchar2_table(325) := '7472616E736974696F6E3A20302E317320656173653B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6E6F74466F756E64207B5C6E202070616464696E673A20312E3672656D3B5C6E2020746578742D616C69';
wwv_flow_api.g_varchar2_table(326) := '676E3A2063656E7465723B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6E6F74466F756E64202E612D49636F6E207B5C6E20206D617267696E2D626F74746F6D3A203870783B5C6E7D5C6E2E75742D50726F';
wwv_flow_api.g_varchar2_table(327) := '7065727479456469746F72202E612D50726F706572747947726F75702D6974656D207B5C6E2020626F726465722D746F703A2031707820736F6C69643B5C6E2020626F726465722D626F74746F6D2D77696474683A20303B5C6E7D5C6E2E75742D50726F';
wwv_flow_api.g_varchar2_table(328) := '7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D626F6479207B5C6E202070616464696E673A2034707820303B5C6E7D5C6E225D7D';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(776880780679146571)
,p_plugin_id=>wwv_flow_api.id(776877005555146556)
,p_file_name=>'css/base.css.map'
,p_mime_type=>'application/json'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2E75742D50726F7065727479456469746F72207B0A202020202F2A203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(2) := '3D3D0A2020202050726F7065727479202850726F706572747920456469746F722050726F70657274696573290A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(3) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A202020202F2A2A0A202020202A2050726F706572747920436F6D706F6E656E740A202020202A0A202020202A205468697320697320612070726F706572747920746861742069732075';
wwv_flow_api.g_varchar2_table(4) := '7365642077697468696E2074686520636F6E74657874206F6620612070726F706572747920656469746F7220746F0A202020202A2070726F766964652061206C6162656C20616E6420696E707574206669656C642E0A202020202A0A202020202A204578';
wwv_flow_api.g_varchar2_table(5) := '616D706C652048544D4C3A0A202020202A0A202020202A203C64697620636C6173733D22612D50726F7065727479223E0A202020202A2020203C64697620636C6173733D22612D50726F70657274792D6C6162656C436F6E7461696E6572223E0A202020';
wwv_flow_api.g_varchar2_table(6) := '202A20202020203C6C6162656C20636C6173733D22612D50726F70657274792D6C6162656C223E4C6162656C3C2F6C6162656C3E0A202020202A2020203C2F6469763E0A202020202A2020203C64697620636C6173733D22612D50726F70657274792D66';
wwv_flow_api.g_varchar2_table(7) := '69656C64436F6E7461696E6572223E0A202020202A20202020203C696E70757420747970653D22746578742220636C6173733D22612D50726F70657274792D6669656C64223E0A202020202A2020203C2F6469763E0A202020202A203C2F6469763E0A20';
wwv_flow_api.g_varchar2_table(8) := '2020202A2F0A202020202E612D50726F7065727479207B0A20202020706F736974696F6E3A2072656C61746976653B0A20202020646973706C61793A207461626C653B0A202020206D617267696E3A20303B0A2020202070616464696E673A20303B0A20';
wwv_flow_api.g_varchar2_table(9) := '20202077696474683A20313030253B0A202020207461626C652D6C61796F75743A206175746F3B0A202020207D0A0A202020202E612D50726F7065727479202E612D49636F6E2E69636F6E2D7265717569726564207B0A20202020646973706C61793A20';
wwv_flow_api.g_varchar2_table(10) := '6E6F6E653B0A202020207D0A0A202020202E612D50726F70657274792D627574746F6E436F6E7461696E65722C0A202020202E612D50726F70657274792D6C6162656C436F6E7461696E65722C0A202020202E612D50726F70657274792D756E6974436F';
wwv_flow_api.g_varchar2_table(11) := '6E7461696E6572207B0A20202020646973706C61793A207461626C652D63656C6C3B0A20202020766572746963616C2D616C69676E3A206D6964646C653B0A202020207D0A0A202020202E612D50726F70657274792D627574746F6E436F6E7461696E65';
wwv_flow_api.g_varchar2_table(12) := '722C0A202020202E612D50726F70657274792D6C6162656C436F6E7461696E65722C0A202020202E612D50726F70657274792D6669656C64436F6E7461696E65722C0A202020202E612D50726F70657274792D756E6974436F6E7461696E6572207B0A20';
wwv_flow_api.g_varchar2_table(13) := '20202070616464696E673A20347078203870783B0A202020207D0A0A20202020406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A2031303234707829207B0A202020202E612D50726F70657274792D627574746F6E43';
wwv_flow_api.g_varchar2_table(14) := '6F6E7461696E65722C0A202020202E612D50726F70657274792D6C6162656C436F6E7461696E65722C0A202020202E612D50726F70657274792D6669656C64436F6E7461696E65722C0A202020202E612D50726F70657274792D756E6974436F6E746169';
wwv_flow_api.g_varchar2_table(15) := '6E6572207B0A202020202020202070616464696E673A20327078203870783B0A202020207D0A202020207D0A0A202020202E612D50726F70657274792D6C6162656C436F6E7461696E6572207B0A2020202070616464696E672D72696768743A20303B0A';
wwv_flow_api.g_varchar2_table(16) := '202020206D696E2D77696474683A2031313270783B0A202020207D0A0A202020202374656D706C6174654F7074696F6E73446C675045202E612D50726F70657274792D6C6162656C436F6E7461696E6572207B0A202020206D696E2D77696474683A2031';
wwv_flow_api.g_varchar2_table(17) := '343470783B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274793A6E6F74282E612D50726F70657274792D2D737461636B656429202E612D50726F70657274792D6C6162656C43';
wwv_flow_api.g_varchar2_table(18) := '6F6E7461696E6572207B0A20202020646973706C61793A207461626C652D726F773B0A2020202077696474683A20313030253B0A202020207D0A0A202020202E612D50726F70657274792D6669656C64436F6E7461696E6572207B0A2020202064697370';
wwv_flow_api.g_varchar2_table(19) := '6C61793A207461626C652D63656C6C3B0A2020202077696474683A20313030253B0A20202020766572746963616C2D616C69676E3A206D6964646C653B0A202020207D0A0A202020202E612D50726F70657274792D6669656C64436F6E7461696E65722D';
wwv_flow_api.g_varchar2_table(20) := '2D636F6D626F426F78207B0A2020202070616464696E672D72696768743A20302021696D706F7274616E743B0A202020207D0A0A202020202E612D50726F70657274792D627574746F6E436F6E7461696E65722D2D636F6D626F426F78202E612D427574';
wwv_flow_api.g_varchar2_table(21) := '746F6E207B0A202020206D617267696E2D6C6566743A202D3170783B0A202020207D0A0A202020202E612D50726F70657274792D636F6C6F7250726576696577207B0A20202020646973706C61793A20626C6F636B3B0A2020202077696474683A203132';
wwv_flow_api.g_varchar2_table(22) := '70783B0A202020206865696768743A20313270783B0A20202020626F726465722D7261646975733A20313030253B0A202020207D0A0A202020202E612D50726F70657274792D6669656C64436F6E7461696E65722D2D636F6C6F725069636B6572207B0A';
wwv_flow_api.g_varchar2_table(23) := '2020202070616464696E672D72696768743A20302021696D706F7274616E743B0A202020207D0A0A202020202E612D50726F70657274792D6669656C64436F6E7461696E65722D2D636F6C6F725069636B6572202E612D50726F70657274792D6669656C';
wwv_flow_api.g_varchar2_table(24) := '64207B0A2020202070616464696E672D6C6566743A20323470783B0A20202020626F726465722D746F702D72696768742D7261646975733A20302021696D706F7274616E743B0A20202020626F726465722D626F74746F6D2D72696768742D7261646975';
wwv_flow_api.g_varchar2_table(25) := '733A20302021696D706F7274616E743B0A202020207D0A0A202020202E612D50726F70657274792D6669656C64436F6E7461696E65722D2D636F6C6F725069636B6572202E612D50726F70657274792D636F6C6F7250726576696577207B0A2020202070';
wwv_flow_api.g_varchar2_table(26) := '6F736974696F6E3A206162736F6C7574653B0A202020206D617267696E3A203670783B0A20202020706F696E7465722D6576656E74733A206E6F6E653B0A202020207D0A0A202020202E612D50726F70657274792D627574746F6E436F6E7461696E6572';
wwv_flow_api.g_varchar2_table(27) := '2D2D636F6C6F725069636B6572202E612D427574746F6E207B0A202020206D617267696E2D6C6566743A202D3170783B0A202020207D0A0A202020202E612D50726F70657274792D756E6974436F6E7461696E6572207B0A2020202070616464696E672D';
wwv_flow_api.g_varchar2_table(28) := '6C6566743A20302021696D706F7274616E743B0A2020202077686974652D73706163653A206E6F777261703B0A202020207D0A0A202020202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(29) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A2020202050726F7065727479204572726F720A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(30) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A202020202E612D50726F70657274792E69732D6572726F72202E69636F6E2D6572726F72207B0A202020206D617267696E2D72696768743A203470783B';
wwv_flow_api.g_varchar2_table(31) := '0A202020207D0A0A202020202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A2020202050726F70';
wwv_flow_api.g_varchar2_table(32) := '65727479205761726E696E670A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A202020';
wwv_flow_api.g_varchar2_table(33) := '202E612D50726F70657274792E69732D7761726E696E67202E69636F6E2D7761726E696E67207B0A202020206D617267696E2D72696768743A203470783B0A202020207D0A0A202020202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(34) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A202020204C6162656C20616E6420507265202F20506F737420546578740A202020202A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(35) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A202020202E612D50726F70657274792D6C6162656C2C0A202020202E612D5072';
wwv_flow_api.g_varchar2_table(36) := '6F70657274792D7365744974656D734865616465722D6865616465722C0A202020202E612D50726F70657274792D756E6974207B0A2020202070616464696E673A2034707820303B0A20202020666F6E742D73697A653A20313270783B0A202020206C69';
wwv_flow_api.g_varchar2_table(37) := '6E652D6865696768743A20313670783B0A202020207D0A0A202020202E612D50726F70657274792D636865636B626F782D6C6162656C2C0A202020202E612D50726F70657274792D726164696F207B0A20202020666F6E742D73697A653A20313270783B';
wwv_flow_api.g_varchar2_table(38) := '0A202020206C696E652D6865696768743A20313670783B0A202020207D0A0A202020202E612D50726F70657274792D756E6974207B0A20202020666F6E742D73697A653A20313170783B0A202020207D0A0A202020202E612D50726F70657274792D6C61';
wwv_flow_api.g_varchar2_table(39) := '62656C2D2D7769746849636F6E207B0A2020202070616464696E673A2034707820303B0A202020206C696E652D6865696768743A20313670783B0A202020207D0A0A202020202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(40) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A2020202050726F7065727479204669656C64202D205573656420666F722070726F706572747920656469746F720A20202020';
wwv_flow_api.g_varchar2_table(41) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A202020202E612D50726F70657274792D6669656C';
wwv_flow_api.g_varchar2_table(42) := '64207B0A2020202070616464696E673A203470783B0A202020206D696E2D6865696768743A20323470783B0A20202020666F6E742D73697A653A20313270783B0A202020206C696E652D6865696768743A20313670783B0A20202020626F726465722D72';
wwv_flow_api.g_varchar2_table(43) := '61646975733A203270783B0A202020207D0A0A202020202E612D50726F70657274792D6669656C643A666F637573207B0A202020206F75746C696E653A206E6F6E653B0A202020207D0A0A202020202E612D50726F70657274792E69732D766172696162';
wwv_flow_api.g_varchar2_table(44) := '6C65202E612D49636F6E2E69636F6E2D7661726961626C65207B0A202020206D617267696E2D72696768743A203470783B0A202020207D0A0A202020202E612D50726F70657274792E69732D7661726961626C65202E612D50726F70657274792D666965';
wwv_flow_api.g_varchar2_table(45) := '6C64207B0A20202020626F726465722D7261646975733A203270783B0A202020207D0A0A202020202F2A2050726F706572747920456469746F722053656C656374204C6973740A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(46) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A202020202E612D50726F70657274792D6669656C642D2D73656C656374207B0A202020206F766572666C6F773A2068';
wwv_flow_api.g_varchar2_table(47) := '696464656E3B0A2020202070616464696E672D72696768743A20333070783B0A20202020746578742D696E64656E743A20302E303170783B0A20202020746578742D6F766572666C6F773A202720273B0A202020206261636B67726F756E642D706F7369';
wwv_flow_api.g_varchar2_table(48) := '74696F6E3A203130302520303B0A202020206261636B67726F756E642D73697A653A203332707820323470783B0A202020206261636B67726F756E642D7265706561743A206E6F2D7265706561743B0A202020202D7765626B69742D617070656172616E';
wwv_flow_api.g_varchar2_table(49) := '63653A206E6F6E653B0A20202020202020202D6D6F7A2D617070656172616E63653A206E6F6E653B0A202020202020202020202020617070656172616E63653A206E6F6E653B0A202020207D0A0A20202020626F64793A6E6F74283A2D6D6F7A2D68616E';
wwv_flow_api.g_varchar2_table(50) := '646C65722D626C6F636B656429202E612D50726F70657274792D6669656C642D2D73656C656374207B0A2020202070616464696E673A20327078203234707820327078203270783B0A202020207D0A0A202020202F2A205465787420417265610A202020';
wwv_flow_api.g_varchar2_table(51) := '203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A202020202E612D50726F70657274792D6669656C64';
wwv_flow_api.g_varchar2_table(52) := '2D2D74657874617265612C0A20202020626F6479202E75692D776964676574202E612D50726F70657274792D6669656C642D2D7465787461726561207B0A2020202070616464696E673A203470783B0A202020206D61782D6865696768743A2033323070';
wwv_flow_api.g_varchar2_table(53) := '783B0A202020206865696768743A206175746F3B0A20202020666F6E742D73697A653A20313170783B0A20202020666F6E742D66616D696C793A2053464D6F6E6F2D526567756C61722C204D656E6C6F2C204D6F6E61636F2C20436F6E736F6C61732C20';
wwv_flow_api.g_varchar2_table(54) := '224C696265726174696F6E204D6F6E6F222C2022436F7572696572204E6577222C206D6F6E6F73706163653B0A202020206C696E652D6865696768743A20313470783B0A202020207D0A0A202020202E612D50726F70657274792D726561644F6E6C7920';
wwv_flow_api.g_varchar2_table(55) := '7B0A20202020666F6E742D7765696768743A20626F6C643B0A20202020666F6E742D73697A653A20313270783B0A202020206C696E652D6865696768743A20323B0A202020207D0A0A202020202E612D50726F70657274792D7365744974656D73546162';
wwv_flow_api.g_varchar2_table(56) := '6C652D686561646572207B0A20202020666F6E742D7765696768743A206E6F726D616C3B0A202020207D0A0A202020202E612D50726F70657274792D7365744974656D735461626C65202E612D50726F70657274792D6669656C64207B0A20202020626F';
wwv_flow_api.g_varchar2_table(57) := '726465722D746F702D72696768742D7261646975733A20303B0A20202020626F726465722D626F74746F6D2D72696768742D7261646975733A20303B0A202020207D0A0A202020202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(58) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020436F6D626F20426F78205374796C65730A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(59) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A202020202E612D50726F70657274792D627574746F6E436F6E7461696E65722D2D636F6D626F426F78202E';
wwv_flow_api.g_varchar2_table(60) := '612D427574746F6E207B0A202020206D617267696E2D6C6566743A203870783B0A202020207D0A0A202020202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(61) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020436865636B626F78202B20526164696F20427574746F6E730A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(62) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A202020202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D2C0A202020202E612D50726F70657274';
wwv_flow_api.g_varchar2_table(63) := '792D726164696F2D696E7075745B747970653D22726164696F225D207B0A20202020706F736974696F6E3A206162736F6C7574653B0A202020206F766572666C6F773A2068696464656E3B0A20202020636C69703A20726563742830203020302030293B';
wwv_flow_api.g_varchar2_table(64) := '0A202020206D617267696E3A202D3170783B0A2020202070616464696E673A20303B0A2020202077696474683A203170783B0A202020206865696768743A203170783B0A20202020626F726465723A20303B0A202020202F2A2044697361626C65642053';
wwv_flow_api.g_varchar2_table(65) := '746174650A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A202020202F2A20466F6375730A';
wwv_flow_api.g_varchar2_table(66) := '202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A202020207D0A0A202020202E612D50726F70';
wwv_flow_api.g_varchar2_table(67) := '657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C2C0A202020202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D202B206C6162656C207B0A2020';
wwv_flow_api.g_varchar2_table(68) := '2020706F736974696F6E3A2072656C61746976653B0A2020202070616464696E672D72696768743A203870783B0A2020202070616464696E672D6C6566743A20323070783B0A20202020637572736F723A20706F696E7465723B0A202020207D0A0A2020';
wwv_flow_api.g_varchar2_table(69) := '20202E752D52544C202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C2C202E752D52544C0A202020202E612D50726F70657274792D726164696F2D696E7075745B747970';
wwv_flow_api.g_varchar2_table(70) := '653D22726164696F225D202B206C6162656C207B0A2020202070616464696E672D6C6566743A203870783B0A2020202070616464696E672D72696768743A20323070783B0A202020207D0A0A202020202E612D50726F70657274792D636865636B626F78';
wwv_flow_api.g_varchar2_table(71) := '2D696E7075745B747970653D22636865636B626F78225D202B206C6162656C3A6265666F72652C202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C3A61667465722C0A20';
wwv_flow_api.g_varchar2_table(72) := '2020202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D202B206C6162656C3A6265666F72652C0A202020202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D202B';
wwv_flow_api.g_varchar2_table(73) := '206C6162656C3A6166746572207B0A20202020706F736974696F6E3A206162736F6C7574653B0A20202020746F703A203370783B0A202020206C6566743A20303B0A20202020646973706C61793A20626C6F636B3B0A2020202077696474683A20313470';
wwv_flow_api.g_varchar2_table(74) := '783B0A202020206865696768743A20313470783B0A20202020636F6E74656E743A2027273B0A202020202D7765626B69742D7472616E736974696F6E3A202E31323573206F70616369747920656173653B0A202020207472616E736974696F6E3A202E31';
wwv_flow_api.g_varchar2_table(75) := '323573206F70616369747920656173653B0A202020207D0A0A202020202E752D52544C202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C3A6265666F72652C202E752D52';
wwv_flow_api.g_varchar2_table(76) := '544C202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C3A61667465722C202E752D52544C0A202020202E612D50726F70657274792D726164696F2D696E7075745B747970';
wwv_flow_api.g_varchar2_table(77) := '653D22726164696F225D202B206C6162656C3A6265666F72652C202E752D52544C0A202020202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D202B206C6162656C3A6166746572207B0A202020206C656674';
wwv_flow_api.g_varchar2_table(78) := '3A206175746F3B0A2020202072696768743A20303B0A202020207D0A0A202020202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C3A6265666F72652C0A202020202E612D';
wwv_flow_api.g_varchar2_table(79) := '50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D202B206C6162656C3A6265666F7265207B0A202020207A2D696E6465783A2039303B0A20202020626F726465723A2031707820736F6C69643B0A202020207D0A0A20';
wwv_flow_api.g_varchar2_table(80) := '2020202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C3A61667465722C0A202020202E612D50726F70657274792D726164696F2D696E7075745B747970653D2272616469';
wwv_flow_api.g_varchar2_table(81) := '6F225D202B206C6162656C3A6166746572207B0A202020207A2D696E6465783A203130303B0A202020206F7061636974793A20303B0A202020207D0A0A202020202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D226368';
wwv_flow_api.g_varchar2_table(82) := '65636B626F78225D3A64697361626C6564202B206C6162656C2C0A202020202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D3A64697361626C6564202B206C6162656C207B0A202020206F7061636974793A';
wwv_flow_api.g_varchar2_table(83) := '202E353B0A20202020637572736F723A2064656661756C743B0A20202020706F696E7465722D6576656E74733A206E6F6E653B0A202020207D0A0A202020202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D2263686563';
wwv_flow_api.g_varchar2_table(84) := '6B626F78225D3A64697361626C6564202B206C6162656C3A6265666F72652C0A202020202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D3A64697361626C6564202B206C6162656C3A6265666F7265207B0A';
wwv_flow_api.g_varchar2_table(85) := '202020206F7061636974793A202E353B0A202020207D0A0A202020202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A686F7665723A636865636B6564202B206C6162656C3A61667465722C';
wwv_flow_api.g_varchar2_table(86) := '0A202020202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A666F6375733A636865636B6564202B206C6162656C3A61667465722C0A202020202E612D50726F70657274792D726164696F2D';
wwv_flow_api.g_varchar2_table(87) := '696E7075745B747970653D22726164696F225D3A686F7665723A636865636B6564202B206C6162656C3A61667465722C0A202020202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D3A666F6375733A636865';
wwv_flow_api.g_varchar2_table(88) := '636B6564202B206C6162656C3A6166746572207B0A202020206F7061636974793A20313B0A202020207D0A0A202020202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(89) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020436865636B626F782053706563696669630A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(90) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A202020202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D207B0A202020202F2A20556E636865636B6564';
wwv_flow_api.g_varchar2_table(91) := '0A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A202020202F2A20436865636B65640A2020';
wwv_flow_api.g_varchar2_table(92) := '20203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A202020207D0A0A202020202E612D50726F706572';
wwv_flow_api.g_varchar2_table(93) := '74792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C3A6265666F7265207B0A20202020626F726465722D7261646975733A203270783B0A202020207D0A0A202020202E612D50726F70657274792D63';
wwv_flow_api.g_varchar2_table(94) := '6865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C3A6166746572207B0A202020206261636B67726F756E642D706F736974696F6E3A203530253B0A202020206261636B67726F756E642D73697A653A203136';
wwv_flow_api.g_varchar2_table(95) := '70783B0A202020206261636B67726F756E642D7265706561743A206E6F2D7265706561743B0A202020207D0A0A202020202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A696E6465746572';
wwv_flow_api.g_varchar2_table(96) := '6D696E617465202B206C6162656C3A6166746572207B0A202020206F7061636974793A20313B0A202020206261636B67726F756E642D696D6167653A206E6F6E653B0A2020202077696474683A203870783B0A202020206865696768743A203270783B0A';
wwv_flow_api.g_varchar2_table(97) := '20202020626F726465722D7261646975733A203270783B0A202020206D617267696E3A20367078203370783B0A202020202D7765626B69742D7472616E73666F726D3A207363616C6528302E3735293B0A2020202020202020202020207472616E73666F';
wwv_flow_api.g_varchar2_table(98) := '726D3A207363616C6528302E3735293B0A202020207D0A0A202020202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A636865636B6564202B206C6162656C3A61667465722C0A202020202E';
wwv_flow_api.g_varchar2_table(99) := '612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A636865636B6564202B206C6162656C3A6265666F7265207B0A202020206F7061636974793A20313B0A202020207D0A0A202020202F2A2A2A2A';
wwv_flow_api.g_varchar2_table(100) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020526164696F2053706563696669630A202020202A2A';
wwv_flow_api.g_varchar2_table(101) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A202020202E612D50726F70657274792D726164696F2D';
wwv_flow_api.g_varchar2_table(102) := '696E7075745B747970653D22726164696F225D207B0A202020202F2A20556E636865636B65640A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(103) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A202020202F2A20436865636B65640A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(104) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A202020207D0A0A202020202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D202B206C6162656C3A6265666F7265207B0A20202020626F726465722D7261646975';
wwv_flow_api.g_varchar2_table(105) := '733A20313670783B0A202020207D0A0A202020202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D202B206C6162656C3A6166746572207B0A202020206D617267696E3A203570783B0A202020207769647468';
wwv_flow_api.g_varchar2_table(106) := '3A203470783B0A202020206865696768743A203470783B0A20202020626F726465722D7261646975733A20313030253B0A202020207D0A0A202020202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D3A6368';
wwv_flow_api.g_varchar2_table(107) := '65636B6564202B206C6162656C3A6166746572207B0A202020206F7061636974793A20313B0A202020207D0A0A202020202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(108) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020596573202F204E6F20427574746F6E730A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(109) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A202020202E612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574207B';
wwv_flow_api.g_varchar2_table(110) := '0A2020202070616464696E673A2030203470783B0A202020207D0A0A202020202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F207B0A202020206D617267696E2D726967';
wwv_flow_api.g_varchar2_table(111) := '68743A202D3170783B0A202020207D0A0A202020202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E707574207B0A202020202F2A20556E636865636B6564202A2F';
wwv_flow_api.g_varchar2_table(112) := '0A202020202F2A20436865636B6564202A2F0A202020202F2A20466F6375736564202A2F0A202020207D0A0A202020202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D';
wwv_flow_api.g_varchar2_table(113) := '696E707574202B206C6162656C207B0A2020202070616464696E673A20327078203870783B0A202020202D7765626B69742D7472616E736974696F6E3A206261636B67726F756E642D636F6C6F72202E31357320656173653B0A202020207472616E7369';
wwv_flow_api.g_varchar2_table(114) := '74696F6E3A206261636B67726F756E642D636F6C6F72202E31357320656173653B0A202020207D0A0A202020202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E70';
wwv_flow_api.g_varchar2_table(115) := '7574202B206C6162656C3A6265666F72652C202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E707574202B206C6162656C3A6166746572207B0A20202020636F6E';
wwv_flow_api.g_varchar2_table(116) := '74656E743A20696E697469616C3B0A202020207D0A0A202020202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A636865636B6564202B206C6162656C20';
wwv_flow_api.g_varchar2_table(117) := '7B0A20202020666F6E742D7765696768743A20626F6C643B0A202020207D0A0A202020202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A666F63757320';
wwv_flow_api.g_varchar2_table(118) := '2B206C6162656C207B0A202020207A2D696E6465783A20313B0A202020206F75746C696E653A206E6F6E653B0A20202020626F726465722D7261646975733A203270783B0A202020207D0A0A202020202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(119) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020526164696F0A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(120) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A202020202E612D50726F70657274792D726164696F47726F75703A666F637573207B0A202020206F75746C696E65';
wwv_flow_api.g_varchar2_table(121) := '3A206E6F6E653B0A202020207D0A0A202020202E612D50726F70657274792D726164696F207B0A20202020646973706C61793A20696E6C696E652D626C6F636B3B0A202020207D0A0A202020202E612D50726F70657274792D726164696F2D696E707574';
wwv_flow_api.g_varchar2_table(122) := '207B0A20202020646973706C61793A20696E6C696E652D626C6F636B3B0A202020206D617267696E3A203270783B0A2020202077696474683A20313670783B0A202020206865696768743A20313670783B0A20202020766572746963616C2D616C69676E';
wwv_flow_api.g_varchar2_table(123) := '3A20746F703B0A202020207D0A0A202020202E612D50726F70657274792D726164696F2D6C6162656C207B0A20202020646973706C61793A20696E6C696E652D626C6F636B3B0A2020202070616464696E673A203270783B0A2020202076657274696361';
wwv_flow_api.g_varchar2_table(124) := '6C2D616C69676E3A20746F703B0A20202020666F6E742D73697A653A20313270783B0A202020207D0A0A202020202E612D50726F70657274792D6669656C64436F6E7461696E65722D2D726164696F47726F7570207B0A2020202070616464696E672D74';
wwv_flow_api.g_varchar2_table(125) := '6F703A203670783B0A2020202070616464696E672D626F74746F6D3A203670783B0A202020207D0A0A202020202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(126) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020596573202F204E6F20526164696F730A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(127) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A202020202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E5365743A6265666F72652C202E612D50726F70657274792D726164696F47726F75702D2D62';
wwv_flow_api.g_varchar2_table(128) := '7574746F6E5365743A6166746572207B0A20202020646973706C61793A207461626C653B0A20202020636F6E74656E743A2027273B0A202020207D0A0A202020202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E5365743A61';
wwv_flow_api.g_varchar2_table(129) := '66746572207B0A20202020636C6561723A20626F74683B0A202020207D0A0A202020202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F207B0A20202020666C6F61743A20';
wwv_flow_api.g_varchar2_table(130) := '6C6566743B0A202020207D0A0A202020202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E707574207B0A20202020706F736974696F6E3A206162736F6C7574653B';
wwv_flow_api.g_varchar2_table(131) := '0A202020206F766572666C6F773A2068696464656E3B0A20202020636C69703A20726563742830203020302030293B0A202020206D617267696E3A202D3170783B0A2020202070616464696E673A20303B0A2020202077696474683A203170783B0A2020';
wwv_flow_api.g_varchar2_table(132) := '20206865696768743A203170783B0A20202020626F726465723A20303B0A202020207D0A0A202020202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A64';
wwv_flow_api.g_varchar2_table(133) := '697361626C6564202B206C6162656C207B0A202020206F7061636974793A202E353B0A202020207D0A0A202020202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E';
wwv_flow_api.g_varchar2_table(134) := '707574202B206C6162656C207B0A202020206D696E2D77696474683A20343870783B0A20202020746578742D616C69676E3A2063656E7465723B0A202020206C696E652D6865696768743A20323070783B0A20202020626F726465722D7261646975733A';
wwv_flow_api.g_varchar2_table(135) := '203270783B0A202020207D0A0A202020202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E707574202B206C6162656C202E612D49636F6E207B0A202020206D6172';
wwv_flow_api.g_varchar2_table(136) := '67696E3A203270783B0A202020207D0A0A202020202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(137) := '0A20202020537461636B65642050726F706572746965730A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(138) := '2A2A2A2A2A2A2F0A202020202E612D50726F70657274792D2D737461636B6564207B0A20202020706F736974696F6E3A2072656C61746976653B0A202020207D0A0A202020202E612D50726F70657274792D2D737461636B6564202E612D50726F706572';
wwv_flow_api.g_varchar2_table(139) := '74792D6C6162656C436F6E7461696E65722C0A202020202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D6669656C64436F6E7461696E6572207B0A20202020646973706C61793A20626C6F636B3B0A202020207D0A0A';
wwv_flow_api.g_varchar2_table(140) := '202020202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D6C6162656C436F6E7461696E6572207B0A202020206D617267696E2D72696768743A20363470783B0A2020202070616464696E672D626F74746F6D3A20303B';
wwv_flow_api.g_varchar2_table(141) := '0A202020207D0A0A202020202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D6669656C64436F6E7461696E6572207B0A2020202070616464696E672D746F703A20303B0A202020207D0A0A202020202E612D50726F70';
wwv_flow_api.g_varchar2_table(142) := '657274792D2D737461636B6564202E612D50726F70657274792D627574746F6E436F6E7461696E6572207B0A20202020706F736974696F6E3A206162736F6C7574653B0A20202020746F703A20303B0A2020202072696768743A20303B0A202020207D0A';
wwv_flow_api.g_varchar2_table(143) := '0A202020202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D627574746F6E436F6E7461696E6572202B202E612D50726F70657274792D6669656C64436F6E7461696E6572207B0A2020202070616464696E672D746F70';
wwv_flow_api.g_varchar2_table(144) := '3A203470783B0A202020207D0A0A202020202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D627574746F6E436F6E7461696E6572202E612D427574746F6E2D2D717569636B5069636B207B0A202020206D617267696E';
wwv_flow_api.g_varchar2_table(145) := '2D6C6566743A203870783B0A202020207D0A0A202020202E612D50726F70657274792D2D7363726F6C6C61626C65207B0A20202020646973706C61793A20626C6F636B3B0A202020206F766572666C6F773A206175746F3B0A202020207D0A0A20202020';
wwv_flow_api.g_varchar2_table(146) := '2E612D50726F70657274792D6C6162656C436F6E7461696E65722D2D77697468427574746F6E73207B0A20202020646973706C61793A207461626C652D63656C6C3B0A202020207461626C652D6C61796F75743A206175746F3B0A202020207061646469';
wwv_flow_api.g_varchar2_table(147) := '6E672D626F74746F6D3A203870783B0A202020207D0A0A202020202E612D50726F70657274792D6C6162656C436F6E7461696E65722D2D68696464656E4C6162656C207B0A2020202070616464696E673A20303B0A202020207D0A0A202020202E612D50';
wwv_flow_api.g_varchar2_table(148) := '726F70657274792D627574746F6E436F6E7461696E6572207B0A2020202070616464696E672D6C6566743A20302021696D706F7274616E743B0A202020207D0A0A202020202E612D50726F70657274792D627574746F6E436F6E7461696E65722D2D7075';
wwv_flow_api.g_varchar2_table(149) := '6C6C5269676874207B0A20202020666C6F61743A2072696768743B0A202020207D0A0A202020202E612D50726F70657274792E69732D6368616E676564202E612D50726F70657274792D6C6162656C436F6E7461696E65723A6265666F7265207B0A2020';
wwv_flow_api.g_varchar2_table(150) := '2020706F736974696F6E3A206162736F6C7574653B0A20202020746F703A203170783B0A20202020626F74746F6D3A20303B0A202020206C6566743A203170783B0A20202020646973706C61793A20696E6C696E652D626C6F636B3B0A20202020776964';
wwv_flow_api.g_varchar2_table(151) := '74683A203370783B0A20202020636F6E74656E743A2027273B0A202020206F7061636974793A202E353B0A202020207D0A0A202020202E612D50726F70657274792E69732D6368616E6765643A686F766572202E612D50726F70657274792D6C6162656C';
wwv_flow_api.g_varchar2_table(152) := '436F6E7461696E65723A6265666F72652C202E612D50726F70657274792E69732D6368616E6765642E69732D666F6375736564202E612D50726F70657274792D6C6162656C436F6E7461696E65723A6265666F7265207B0A202020206F7061636974793A';
wwv_flow_api.g_varchar2_table(153) := '20313B0A202020207D0A0A202020202E612D50726F70657274792D6C6162656C2C0A202020202E612D50726F70657274792D756E6974207B0A20202020646973706C61793A20626C6F636B3B0A202020202D6D732D746578742D6F766572666C6F773A20';
wwv_flow_api.g_varchar2_table(154) := '656C6C69707369733B0A20202020746578742D6F766572666C6F773A20656C6C69707369733B0A202020206F766572666C6F773A2068696464656E3B0A202020207D0A0A202020202E612D50726F70657274792D6669656C64207B0A2020202064697370';
wwv_flow_api.g_varchar2_table(155) := '6C61793A20626C6F636B3B0A2020202077696474683A20313030253B0A202020206261636B67726F756E642D636C69703A20626F726465722D626F783B0A20202020626F726465723A203020736F6C69643B0A202020207D0A0A202020202E612D50726F';
wwv_flow_api.g_varchar2_table(156) := '70657274792D6669656C642D2D7465787461726561207B0A202020206D696E2D6865696768743A20343870783B0A20202020666F6E742D66616D696C793A2053464D6F6E6F2D526567756C61722C204D656E6C6F2C204D6F6E61636F2C20436F6E736F6C';
wwv_flow_api.g_varchar2_table(157) := '61732C20224C696265726174696F6E204D6F6E6F222C2022436F7572696572204E6577222C206D6F6E6F73706163653B0A20202020726573697A653A20766572746963616C3B0A202020207D0A0A202020202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(158) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020486964652F53686F7720436C61737365730A202020202A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(159) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A202020202E612D50726F70657274792E6A732D73686F77416C6C2C0A20202020';
wwv_flow_api.g_varchar2_table(160) := '2E612D50726F7065727479456469746F722D70726F706572747947726F75702E6A732D73686F77416C6C207B0A20202020646973706C61793A206E6F6E653B0A202020207D0A0A202020202E612D50726F7065727479456469746F722E6A732D73686F77';
wwv_flow_api.g_varchar2_table(161) := '416C6C202E612D50726F70657274792E6A732D73686F77416C6C2C0A202020202E612D50726F7065727479456469746F722E6A732D73686F77416C6C202E612D50726F7065727479456469746F722D70726F706572747947726F75702E6A732D73686F77';
wwv_flow_api.g_varchar2_table(162) := '416C6C207B0A20202020646973706C61793A20626C6F636B3B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D2D737461636B65642E6A732D73686F77416C6C202E612D50726F70657274792E6A732D73686F77416C6C207B0A';
wwv_flow_api.g_varchar2_table(163) := '20202020646973706C61793A207461626C653B0A202020207D0A0A202020202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(164) := '2A2A2A2A2A2A2A2A2A2A0A202020205661726961626C65204669656C640A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(165) := '2A2A2A2A2A2A2A2A2A2A2A2A2F0A202020202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A2020';
wwv_flow_api.g_varchar2_table(166) := '2020436865636B626F780A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A202020202E';
wwv_flow_api.g_varchar2_table(167) := '612D50726F70657274792D636865636B626F7847726F75703A666F637573207B0A202020206F75746C696E653A206E6F6E653B0A202020207D0A0A202020202E612D50726F70657274792D636865636B626F782D696E707574207B0A2020202064697370';
wwv_flow_api.g_varchar2_table(168) := '6C61793A20696E6C696E652D626C6F636B3B0A202020206D617267696E3A203270783B0A2020202077696474683A20313670783B0A202020206865696768743A20313670783B0A20202020766572746963616C2D616C69676E3A20746F703B0A20202020';
wwv_flow_api.g_varchar2_table(169) := '7D0A0A202020202E612D50726F70657274792D636865636B626F782D6C6162656C207B0A20202020646973706C61793A20696E6C696E652D626C6F636B3B0A2020202070616464696E673A203270783B0A20202020766572746963616C2D616C69676E3A';
wwv_flow_api.g_varchar2_table(170) := '20746F703B0A20202020666F6E742D73697A653A20313270783B0A202020207D0A0A202020202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(171) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020536574204974656D73205461626C650A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(172) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A202020202E612D50726F70657274792D7365744974656D735461626C65207B0A2020202077696474683A20313030253B0A20202020626F726465722D73706163696E673A20303B0A20202020626F';
wwv_flow_api.g_varchar2_table(173) := '726465722D636F6C6C617073653A20636F6C6C617073653B0A202020207D0A0A202020202E612D50726F70657274792D7365744974656D735461626C65207464207B0A2020202070616464696E672D626F74746F6D3A203470783B0A202020207D0A0A20';
wwv_flow_api.g_varchar2_table(174) := '2020202E612D50726F70657274792D7365744974656D735461626C652074723A6C6173742D6368696C64207464207B0A2020202070616464696E672D626F74746F6D3A20303B0A202020207D0A0A202020202E612D50726F70657274792D736574497465';
wwv_flow_api.g_varchar2_table(175) := '6D734865616465722D686561646572207B0A20202020746578742D616C69676E3A206C6566743B0A202020207D0A0A202020202E612D50726F70657274792D7365744974656D735461626C652D72656D6F7665436F6C207B0A2020202077696474683A20';
wwv_flow_api.g_varchar2_table(176) := '343070783B0A202020207D0A0A202020202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A202020';
wwv_flow_api.g_varchar2_table(177) := '2050726F706572747920456469746F7220696E204469616C6F67730A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(178) := '2A2A2A2A2A2A2A2A2A2A2F0A202020202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A20202020';
wwv_flow_api.g_varchar2_table(179) := '50726F706572747920456469746F7220427574746F6E730A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_api.g_varchar2_table(180) := '2A2A2A2A2A2A2F0A202020202E612D50726F70657274792D627574746F6E207B0A202020202D2D612D627574746F6E2D70616464696E672D793A203670783B0A2020202077696474683A20313030253B0A2020202077686974652D73706163653A206E6F';
wwv_flow_api.g_varchar2_table(181) := '726D616C3B0A202020207D0A0A202020202F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A0A202020';
wwv_flow_api.g_varchar2_table(182) := '20537461636B6564205374796C65730A202020202A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A';
wwv_flow_api.g_varchar2_table(183) := '202020202E612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274792D6C6162656C436F6E7461696E6572202E612D50726F70657274792D6C6162656C207B0A2020202070616464696E672D72696768743A20313270';
wwv_flow_api.g_varchar2_table(184) := '783B0A2020202070616464696E672D626F74746F6D3A203270783B0A2020202070616464696E672D6C6566743A20313270783B0A20202020666F6E742D73697A653A20313170783B0A202020207D0A0A202020202E612D50726F7065727479456469746F';
wwv_flow_api.g_varchar2_table(185) := '722D2D737461636B6564202E612D50726F70657274792D6669656C64436F6E7461696E65722C0A202020202E612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274792D627574746F6E436F6E7461696E6572207B0A';
wwv_flow_api.g_varchar2_table(186) := '2020202070616464696E672D746F703A20303B0A2020202070616464696E672D626F74746F6D3A203870783B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274792D2D73746163';
wwv_flow_api.g_varchar2_table(187) := '6B6564202E612D50726F70657274792D627574746F6E436F6E7461696E6572207B0A2020202070616464696E672D746F703A203470783B0A2020202070616464696E672D626F74746F6D3A203470783B0A202020207D0A0A202020202E612D50726F7065';
wwv_flow_api.g_varchar2_table(188) := '727479456469746F722D2D737461636B6564202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D6C6162656C436F6E7461696E6572202E612D50726F70657274792D6C6162656C207B0A2020202070616464696E673A20';
wwv_flow_api.g_varchar2_table(189) := '34707820303B0A202020207D0A0A202020202F2A203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D0A20202020';
wwv_flow_api.g_varchar2_table(190) := '4869676820436F6E7472617374204D6F64650A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F';
wwv_flow_api.g_varchar2_table(191) := '0A202020202E752D48434D202E612D50726F70657274792D6669656C64207B0A20202020626F726465723A2031707820736F6C69642021696D706F7274616E743B0A202020207D0A0A202020202F2A0A2020202024646973706C61792D787878733A2036';
wwv_flow_api.g_varchar2_table(192) := '343070783B0A2020202024646973706C61792D7878733A2038303070783B0A2020202024646973706C61792D78733A203130323470783B0A2020202024646973706C61792D736D616C6C3A203132383070783B0A2020202024646973706C61792D6D6564';
wwv_flow_api.g_varchar2_table(193) := '69756D3A203136383070783B0A2020202024646973706C61792D6C617267653A203139323070783B0A202020202A2F0A202020202F2A203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(194) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D0A2020202050726F706572747920456469746F720A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(195) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A202020202E612D50726F7065727479456469746F722D77726170706572202E612D50726F7065727479456469746F722D70726F706572747947726F75703A66697273742D';
wwv_flow_api.g_varchar2_table(196) := '6368696C64207B0A202020206D617267696E2D746F703A203870783B0A202020207D0A0A202020202E75692D6469616C6F67202E612D50726F7065727479456469746F72207B0A202020206F766572666C6F773A206175746F3B0A202020206D61782D68';
wwv_flow_api.g_varchar2_table(197) := '65696768743A2034303070783B0A202020207D0A0A202020202F2A2050726F706572747920456469746F722047726F7570730A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(198) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A202020202E612D50726F7065727479456469746F722D70726F706572747947726F7570207B0A20202020646973706C61793A20626C6F636B3B0A202020206261636B67';
wwv_flow_api.g_varchar2_table(199) := '726F756E642D636C69703A2070616464696E672D626F783B0A202020202D7765626B69742D7472616E736974696F6E3A206261636B67726F756E642D636F6C6F7220302E317320656173652C202D7765626B69742D626F782D736861646F7720302E3173';
wwv_flow_api.g_varchar2_table(200) := '20656173653B0A202020207472616E736974696F6E3A206261636B67726F756E642D636F6C6F7220302E317320656173652C202D7765626B69742D626F782D736861646F7720302E317320656173653B0A202020207472616E736974696F6E3A20626163';
wwv_flow_api.g_varchar2_table(201) := '6B67726F756E642D636F6C6F7220302E317320656173652C20626F782D736861646F7720302E317320656173653B0A202020207472616E736974696F6E3A206261636B67726F756E642D636F6C6F7220302E317320656173652C20626F782D736861646F';
wwv_flow_api.g_varchar2_table(202) := '7720302E317320656173652C202D7765626B69742D626F782D736861646F7720302E317320656173653B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D70726F706572747947726F75702E69732D636F6C6C6170736564202E';
wwv_flow_api.g_varchar2_table(203) := '612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572207B0A20202020626F726465722D626F74746F6D3A206E6F6E653B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D70726F706572';
wwv_flow_api.g_varchar2_table(204) := '747947726F75702E69732D636F6C6C6170736564202E612D50726F7065727479456469746F722D70726F706572747947726F75702D626F6479207B0A20202020646973706C61793A206E6F6E653B0A202020207D0A0A202020202E612D50726F70657274';
wwv_flow_api.g_varchar2_table(205) := '79456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75703A66697273742D6368696C64207B0A202020206D617267696E2D746F703A203470783B0A202020207D0A0A202020202E612D50726F7065727479456469';
wwv_flow_api.g_varchar2_table(206) := '746F722D70726F706572747947726F75702D686561646572207B0A202020206D617267696E2D746F703A203470783B0A2020202070616464696E673A2031327078203870783B0A20202020626F726465722D77696474683A20303B0A202020202D776562';
wwv_flow_api.g_varchar2_table(207) := '6B69742D7472616E736974696F6E3A206D617267696E202E317320656173653B0A202020207472616E736974696F6E3A206D617267696E202E317320656173653B0A202020207D0A0A20202020406D65646961206F6E6C792073637265656E20616E6420';
wwv_flow_api.g_varchar2_table(208) := '286D61782D77696474683A2031303234707829207B0A202020202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572207B0A202020202020202070616464696E672D746F703A203470783B0A20202020202020';
wwv_flow_api.g_varchar2_table(209) := '2070616464696E672D626F74746F6D3A203470783B0A202020207D0A202020207D0A0A20202020406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A203130323570782920616E6420286D61782D77696474683A203132';
wwv_flow_api.g_varchar2_table(210) := '3739707829207B0A202020202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572207B0A202020202020202070616464696E672D746F703A203670783B0A202020202020202070616464696E672D626F74746F';
wwv_flow_api.g_varchar2_table(211) := '6D3A203670783B0A202020207D0A202020207D0A0A20202020406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A203132383170782920616E6420286D61782D77696474683A2031363739707829207B0A202020202E61';
wwv_flow_api.g_varchar2_table(212) := '2D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572207B0A202020202020202070616464696E672D746F703A203870783B0A202020202020202070616464696E672D626F74746F6D3A203870783B0A202020207D0A';
wwv_flow_api.g_varchar2_table(213) := '202020207D0A0A202020202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465723A686F766572202E612D49636F6E207B0A202020206F7061636974793A20313B0A202020207D0A0A202020202E612D50726F70';
wwv_flow_api.g_varchar2_table(214) := '65727479456469746F722D70726F706572747947726F75702D686561646572202E612D49636F6E207B0A202020206D617267696E3A20327078203670782032707820303B0A20202020626F726465722D7261646975733A203270783B0A202020206F7061';
wwv_flow_api.g_varchar2_table(215) := '636974793A20302E353B0A202020202D7765626B69742D7472616E736974696F6E3A202E327320656173653B0A202020207472616E736974696F6E3A202E327320656173653B0A202020207D0A0A202020202E752D52544C202E612D50726F7065727479';
wwv_flow_api.g_varchar2_table(216) := '456469746F722D70726F706572747947726F75702D686561646572202E612D49636F6E207B0A202020206D617267696E3A20327078203020327078203670783B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D70726F706572';
wwv_flow_api.g_varchar2_table(217) := '747947726F75702D686561646572202E612D49636F6E2E69636F6E2D72696768742D6172726F773A6265666F7265207B0A20202020636F6E74656E743A20225C45304438223B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D';
wwv_flow_api.g_varchar2_table(218) := '70726F706572747947726F75702D686561646572202E612D49636F6E2E69636F6E2D646F776E2D6172726F773A6265666F7265207B0A20202020636F6E74656E743A20225C65306332223B0A202020207D0A0A202020202E612D50726F70657274794564';
wwv_flow_api.g_varchar2_table(219) := '69746F722D70726F706572747947726F75702D6865616465722E69732D666F6375736564207B0A20202020706F736974696F6E3A2072656C61746976653B0A202020207A2D696E6465783A203130303B0A202020206F75746C696E653A206E6F6E653B0A';
wwv_flow_api.g_varchar2_table(220) := '202020207D0A0A202020202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465722E69732D666F6375736564202E612D49636F6E207B0A202020206F7061636974793A20313B0A202020207D0A0A202020202E61';
wwv_flow_api.g_varchar2_table(221) := '2D50726F7065727479456469746F722D70726F706572747947726F75702D7469746C65207B0A20202020646973706C61793A20696E6C696E652D626C6F636B3B0A202020206D617267696E3A20303B0A2020202070616464696E673A20303B0A20202020';
wwv_flow_api.g_varchar2_table(222) := '766572746963616C2D616C69676E3A20746F703B0A20202020666F6E742D7765696768743A203630303B0A20202020666F6E742D73697A653A20313470783B0A202020206C696E652D6865696768743A20323070783B0A202020207D0A0A202020202F2A';
wwv_flow_api.g_varchar2_table(223) := '2A0A202020202A204D6F6469666965723A2069732D656D7074790A202020202A0A202020202A2055736564207768656E20616E206572726F72206D65737361676520697320646973706C617965640A202020202A2F0A202020202E612D50726F70657274';
wwv_flow_api.g_varchar2_table(224) := '79456469746F722E69732D656D707479207B0A20202020646973706C61793A202D7765626B69742D626F783B0A20202020646973706C61793A202D6D732D666C6578626F783B0A20202020646973706C61793A20666C65783B0A202020206F766572666C';
wwv_flow_api.g_varchar2_table(225) := '6F773A2068696464656E3B0A202020206865696768743A20313030253B0A202020202D7765626B69742D626F782D616C69676E3A2063656E7465723B0A20202020202020202D6D732D666C65782D616C69676E3A2063656E7465723B0A20202020202020';
wwv_flow_api.g_varchar2_table(226) := '2020202020616C69676E2D6974656D733A2063656E7465723B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D6D657373616765207B0A2020202070616464696E673A20313270783B0A2020202077696474683A20313030253B';
wwv_flow_api.g_varchar2_table(227) := '0A20202020746578742D616C69676E3A2063656E7465723B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D6D65737361676554657874207B0A202020206D617267696E3A20303B0A202020207D0A0A202020202E612D49636F';
wwv_flow_api.g_varchar2_table(228) := '6E202B202E612D50726F7065727479456469746F722D6D65737361676554657874207B0A202020206D617267696E2D746F703A203870783B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D65646974506172656E74207B0A20';
wwv_flow_api.g_varchar2_table(229) := '20202070616464696E673A20367078203870783B0A20202020746578742D616C69676E3A2063656E7465723B0A202020207D0A0A20202020406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A2031303234707829207B';
wwv_flow_api.g_varchar2_table(230) := '0A202020202E612D50726F7065727479456469746F722D65646974506172656E74207B0A202020202020202070616464696E673A20327078203870783B0A202020207D0A202020207D0A0A20202020406D65646961206F6E6C792073637265656E20616E';
wwv_flow_api.g_varchar2_table(231) := '6420286D696E2D77696474683A203130323570782920616E6420286D61782D77696474683A2031323739707829207B0A202020202E612D50726F7065727479456469746F722D65646974506172656E74207B0A202020202020202070616464696E673A20';
wwv_flow_api.g_varchar2_table(232) := '347078203870783B0A202020207D0A202020207D0A0A202020202F2A2046696C746572696E670A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(233) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A202020202E612D50726F7065727479456469746F722D66696C746572207B0A20202020706F736974696F6E3A2072656C61746976653B0A20202020646973706C61793A202D7765626B69742D626F78';
wwv_flow_api.g_varchar2_table(234) := '3B0A20202020646973706C61793A202D6D732D666C6578626F783B0A20202020646973706C61793A20666C65783B0A2020202070616464696E673A20303B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D66696C746572202E';
wwv_flow_api.g_varchar2_table(235) := '612D50726F7065727479456469746F722D66696C7465722D69636F6E207B0A20202020706F736974696F6E3A206162736F6C7574653B0A20202020746F703A20303B0A202020206C6566743A20303B0A202020206D617267696E3A203870783B0A202020';
wwv_flow_api.g_varchar2_table(236) := '206F7061636974793A202E353B0A202020202D7765626B69742D7472616E736974696F6E3A202E317320656173653B0A202020207472616E736974696F6E3A202E317320656173653B0A20202020706F696E7465722D6576656E74733A206E6F6E653B0A';
wwv_flow_api.g_varchar2_table(237) := '202020207D0A0A202020202E752D52544C202E612D50726F7065727479456469746F722D66696C746572202E612D50726F7065727479456469746F722D66696C7465722D69636F6E207B0A202020206C6566743A206175746F3B0A202020207269676874';
wwv_flow_api.g_varchar2_table(238) := '3A20303B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D66696C746572202E612D50726F70657274792D6669656C643A6E6F74282E612D50726F70657274792D6669656C642D2D7465787429207B0A202020202D7765626B69';
wwv_flow_api.g_varchar2_table(239) := '742D626F782D73697A696E673A20626F726465722D626F783B0A202020202020202020202020626F782D73697A696E673A20626F726465722D626F783B0A2020202070616464696E673A20387078203870782038707820333270783B0A20202020686569';
wwv_flow_api.g_varchar2_table(240) := '6768743A20333270783B0A202020206C696E652D6865696768743A20333270783B0A20202020626F726465722D7261646975733A203270783B0A202020207D0A0A202020202E752D52544C202E612D50726F7065727479456469746F722D66696C746572';
wwv_flow_api.g_varchar2_table(241) := '202E612D50726F70657274792D6669656C643A6E6F74282E612D50726F70657274792D6669656C642D2D7465787429207B0A2020202070616464696E673A20387078203332707820387078203870783B0A202020207D0A0A202020202E612D50726F7065';
wwv_flow_api.g_varchar2_table(242) := '727479456469746F722D66696C746572202E612D50726F70657274792D6669656C643A6E6F74282E612D50726F70657274792D6669656C642D2D74657874293A666F637573202B202E612D49636F6E207B0A202020206F7061636974793A20313B0A2020';
wwv_flow_api.g_varchar2_table(243) := '20207D0A0A202020202E612D50726F7065727479456469746F722D66696C746572202E612D427574746F6E2D2D737469636B7946696C746572207B0A20202020706F736974696F6E3A206162736F6C7574653B0A20202020746F703A20303B0A20202020';
wwv_flow_api.g_varchar2_table(244) := '72696768743A20303B0A20202020626F74746F6D3A20303B0A202020207A2D696E6465783A2031303B0A202020206D617267696E3A203470783B0A2020202070616464696E673A203470783B0A202020206F7061636974793A20303B0A202020202D7765';
wwv_flow_api.g_varchar2_table(245) := '626B69742D7472616E736974696F6E3A206F706163697479202E317320656173653B0A202020207472616E736974696F6E3A206F706163697479202E317320656173653B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D6669';
wwv_flow_api.g_varchar2_table(246) := '6C7465723A666F6375732D77697468696E202E612D50726F70657274792D6669656C64202B202E612D49636F6E207B0A202020206F7061636974793A20313B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D66696C74657220';
wwv_flow_api.g_varchar2_table(247) := '2E612D50726F70657274792D6669656C643A666F637573207E202E612D427574746F6E2D2D737469636B7946696C7465722C0A202020202E612D50726F7065727479456469746F722D66696C746572202E612D427574746F6E2D2D737469636B7946696C';
wwv_flow_api.g_varchar2_table(248) := '7465722E69732D6163746976652C0A202020202E612D50726F7065727479456469746F722D66696C746572202E612D427574746F6E2D2D737469636B7946696C7465723A666F637573207B0A202020206F7061636974793A20313B0A202020207D0A0A20';
wwv_flow_api.g_varchar2_table(249) := '2020202E612D50726F70657274792D686967686C69676874207B0A2020202070616464696E673A2032707820303B0A20202020626F726465722D7261646975733A203270783B0A202020202D7765626B69742D7472616E736974696F6E3A202E31732065';
wwv_flow_api.g_varchar2_table(250) := '6173653B0A202020207472616E736974696F6E3A202E317320656173653B0A202020207D0A0A202020202F2A2050726F70657274792046696C746572204E6F7420466F756E640A202020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(251) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A202020202E612D50726F70657274792D6E6F74466F756E64207B0A2020202070616464696E673A20312E3672656D3B';
wwv_flow_api.g_varchar2_table(252) := '0A20202020746578742D616C69676E3A2063656E7465723B0A202020207D0A0A202020202E612D50726F70657274792D6E6F74466F756E64202E612D49636F6E207B0A202020206D617267696E2D626F74746F6D3A203870783B0A202020207D0A0A2020';
wwv_flow_api.g_varchar2_table(253) := '20202F2A0A2020202024646973706C61792D787878733A2036343070783B0A2020202024646973706C61792D7878733A2038303070783B0A2020202024646973706C61792D78733A203130323470783B0A2020202024646973706C61792D736D616C6C3A';
wwv_flow_api.g_varchar2_table(254) := '203132383070783B0A2020202024646973706C61792D6D656469756D3A203136383070783B0A2020202024646973706C61792D6C617267653A203139323070783B0A202020202A2F0A202020202F2A203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D';
wwv_flow_api.g_varchar2_table(255) := '3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D0A2020202050726F70657274792047726F7570202850726F706572747920456469746F722047726F757073290A20';
wwv_flow_api.g_varchar2_table(256) := '2020203D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D202A2F0A202020202F2A2A0A202020202A2050726F7065';
wwv_flow_api.g_varchar2_table(257) := '7274792047726F757020436F6D706F6E656E740A202020202A0A202020202A205468697320697320612067726F7570696E67206F66206F6E65206F72206D6F72652070726F7065727469657320696E2074686520636F6E74657874206F6620612070726F';
wwv_flow_api.g_varchar2_table(258) := '70657274790A202020202A20656469746F722E205468697320616C6C6F777320757320746F20636F6E76656E69656E746C792067726F7570206F75722070726F7065727469657320616E64207573650A202020202A2070737565646F2073656C6563746F';
wwv_flow_api.g_varchar2_table(259) := '727320746F206170706C79207374796C657320746F206669727374202F206C61737420656C656D656E74732077697468696E207468652067726F75702E0A202020202A0A202020202A204578616D706C652048544D4C3A0A202020202A0A202020202A20';
wwv_flow_api.g_varchar2_table(260) := '3C64697620636C6173733D22612D50726F706572747947726F7570223E0A202020202A2020203C64697620636C6173733D22612D50726F706572747947726F75702D6974656D223E0A202020202A20202020205B50726F70657274792020486572655D0A';
wwv_flow_api.g_varchar2_table(261) := '202020202A2020203C2F6469763E0A202020202A2020203C64697620636C6173733D22612D50726F706572747947726F75702D6974656D223E0A202020202A20202020205B50726F70657274792020486572655D0A202020202A2020203C2F6469763E0A';
wwv_flow_api.g_varchar2_table(262) := '202020202A2020203C64697620636C6173733D22612D50726F706572747947726F75702D6974656D223E0A202020202A20202020205B50726F70657274792020486572655D0A202020202A2020203C2F6469763E0A202020202A203C2F6469763E0A2020';
wwv_flow_api.g_varchar2_table(263) := '20202A2F0A202020202E612D50726F706572747947726F75702D6974656D207B0A20202020626F726465722D746F703A2031707820736F6C69643B0A20202020626F726465722D626F74746F6D2D77696474683A20303B0A202020207D0A0A202020202E';
wwv_flow_api.g_varchar2_table(264) := '612D50726F7065727479456469746F722D70726F706572747947726F75702D626F6479207B0A2020202070616464696E673A2034707820303B0A202020207D0A7D';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(776881197476146572)
,p_plugin_id=>wwv_flow_api.id(776877005555146556)
,p_file_name=>'css/base.less'
,p_mime_type=>'text/plain'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2E75742D50726F7065727479456469746F72202E612D50726F70657274797B706F736974696F6E3A72656C61746976653B646973706C61793A7461626C653B6D617267696E3A303B70616464696E673A303B77696474683A313030253B7461626C652D6C';
wwv_flow_api.g_varchar2_table(2) := '61796F75743A6175746F7D2E75742D50726F7065727479456469746F72202E612D50726F7065727479202E612D49636F6E2E69636F6E2D72657175697265647B646973706C61793A6E6F6E657D2E75742D50726F7065727479456469746F72202E612D50';
wwv_flow_api.g_varchar2_table(3) := '726F70657274792D627574746F6E436F6E7461696E65722C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C436F6E7461696E65722C2E75742D50726F7065727479456469746F72202E612D50726F7065727479';
wwv_flow_api.g_varchar2_table(4) := '2D756E6974436F6E7461696E65727B646973706C61793A7461626C652D63656C6C3B766572746963616C2D616C69676E3A6D6964646C657D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461696E';
wwv_flow_api.g_varchar2_table(5) := '65722C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64436F6E7461696E65722C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C436F6E7461696E65722C2E75742D50';
wwv_flow_api.g_varchar2_table(6) := '726F7065727479456469746F72202E612D50726F70657274792D756E6974436F6E7461696E65727B70616464696E673A347078203870787D406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A313032347078297B2E75';
wwv_flow_api.g_varchar2_table(7) := '742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461696E65722C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64436F6E7461696E65722C2E75742D50726F7065';
wwv_flow_api.g_varchar2_table(8) := '727479456469746F72202E612D50726F70657274792D6C6162656C436F6E7461696E65722C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D756E6974436F6E7461696E65727B70616464696E673A327078203870787D7D2E';
wwv_flow_api.g_varchar2_table(9) := '75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C436F6E7461696E65727B70616464696E672D72696768743A303B6D696E2D77696474683A31313270787D2E75742D50726F7065727479456469746F72202374656D';
wwv_flow_api.g_varchar2_table(10) := '706C6174654F7074696F6E73446C675045202E612D50726F70657274792D6C6162656C436F6E7461696E65727B6D696E2D77696474683A31343470787D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D2D73';
wwv_flow_api.g_varchar2_table(11) := '7461636B6564202E612D50726F70657274793A6E6F74282E612D50726F70657274792D2D737461636B656429202E612D50726F70657274792D6C6162656C436F6E7461696E65727B646973706C61793A7461626C652D726F773B77696474683A31303025';
wwv_flow_api.g_varchar2_table(12) := '7D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64436F6E7461696E65727B646973706C61793A7461626C652D63656C6C3B77696474683A313030253B766572746963616C2D616C69676E3A6D6964646C657D2E';
wwv_flow_api.g_varchar2_table(13) := '75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64436F6E7461696E65722D2D636F6D626F426F787B70616464696E672D72696768743A3021696D706F7274616E747D2E75742D50726F7065727479456469746F7220';
wwv_flow_api.g_varchar2_table(14) := '2E612D50726F70657274792D636F6C6F72507265766965777B646973706C61793A626C6F636B3B77696474683A313270783B6865696768743A313270783B626F726465722D7261646975733A313030257D2E75742D50726F7065727479456469746F7220';
wwv_flow_api.g_varchar2_table(15) := '2E612D50726F70657274792D6669656C64436F6E7461696E65722D2D636F6C6F725069636B65727B70616464696E672D72696768743A3021696D706F7274616E747D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D666965';
wwv_flow_api.g_varchar2_table(16) := '6C64436F6E7461696E65722D2D636F6C6F725069636B6572202E612D50726F70657274792D6669656C647B70616464696E672D6C6566743A323470783B626F726465722D746F702D72696768742D7261646975733A3021696D706F7274616E743B626F72';
wwv_flow_api.g_varchar2_table(17) := '6465722D626F74746F6D2D72696768742D7261646975733A3021696D706F7274616E747D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64436F6E7461696E65722D2D636F6C6F725069636B6572202E612D5072';
wwv_flow_api.g_varchar2_table(18) := '6F70657274792D636F6C6F72507265766965777B706F736974696F6E3A6162736F6C7574653B6D617267696E3A3670783B706F696E7465722D6576656E74733A6E6F6E657D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D';
wwv_flow_api.g_varchar2_table(19) := '627574746F6E436F6E7461696E65722D2D636F6C6F725069636B6572202E612D427574746F6E7B6D617267696E2D6C6566743A2D3170787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D756E6974436F6E7461696E6572';
wwv_flow_api.g_varchar2_table(20) := '7B70616464696E672D6C6566743A3021696D706F7274616E743B77686974652D73706163653A6E6F777261707D2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D6572726F72202E69636F6E2D6572726F722C2E7574';
wwv_flow_api.g_varchar2_table(21) := '2D50726F7065727479456469746F72202E612D50726F70657274792E69732D7661726961626C65202E612D49636F6E2E69636F6E2D7661726961626C652C2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D7761726E';
wwv_flow_api.g_varchar2_table(22) := '696E67202E69636F6E2D7761726E696E677B6D617267696E2D72696768743A3470787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C2C2E75742D50726F7065727479456469746F72202E612D50726F706572';
wwv_flow_api.g_varchar2_table(23) := '74792D7365744974656D734865616465722D6865616465727B70616464696E673A34707820303B666F6E742D73697A653A313270783B6C696E652D6865696768743A313670787D2E75742D50726F7065727479456469746F72202E612D50726F70657274';
wwv_flow_api.g_varchar2_table(24) := '792D756E69747B70616464696E673A34707820303B6C696E652D6865696768743A313670787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D6C6162656C7B6C696E652D6865696768743A31367078';
wwv_flow_api.g_varchar2_table(25) := '7D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F7B666F6E742D73697A653A313270783B6C696E652D6865696768743A313670787D2E75742D50726F7065727479456469746F72202E612D50726F7065727479';
wwv_flow_api.g_varchar2_table(26) := '2D756E69747B666F6E742D73697A653A313170787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C2D2D7769746849636F6E7B70616464696E673A34707820303B6C696E652D6865696768743A313670787D2E';
wwv_flow_api.g_varchar2_table(27) := '75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C647B70616464696E673A3470783B6D696E2D6865696768743A323470783B666F6E742D73697A653A313270783B6C696E652D6865696768743A313670783B626F7264';
wwv_flow_api.g_varchar2_table(28) := '65722D7261646975733A3270787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C643A666F6375737B6F75746C696E653A307D2E75742D50726F7065727479456469746F72202E612D50726F70657274792E6973';
wwv_flow_api.g_varchar2_table(29) := '2D7661726961626C65202E612D50726F70657274792D6669656C647B626F726465722D7261646975733A3270787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C642D2D73656C6563747B6F766572666C6F773A';
wwv_flow_api.g_varchar2_table(30) := '68696464656E3B70616464696E672D72696768743A333070783B746578742D696E64656E743A2E303170783B746578742D6F766572666C6F773A2720273B6261636B67726F756E642D706F736974696F6E3A3130302520303B6261636B67726F756E642D';
wwv_flow_api.g_varchar2_table(31) := '73697A653A3332707820323470783B6261636B67726F756E642D7265706561743A6E6F2D7265706561743B2D7765626B69742D617070656172616E63653A6E6F6E653B2D6D6F7A2D617070656172616E63653A6E6F6E653B617070656172616E63653A6E';
wwv_flow_api.g_varchar2_table(32) := '6F6E657D2E75742D50726F7065727479456469746F7220626F64793A6E6F74283A2D6D6F7A2D68616E646C65722D626C6F636B656429202E612D50726F70657274792D6669656C642D2D73656C6563747B70616464696E673A3270782032347078203270';
wwv_flow_api.g_varchar2_table(33) := '78203270787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C642D2D74657874617265612C2E75742D50726F7065727479456469746F7220626F6479202E75692D776964676574202E612D50726F70657274792D';
wwv_flow_api.g_varchar2_table(34) := '6669656C642D2D74657874617265617B70616464696E673A3470783B6D61782D6865696768743A33323070783B6865696768743A6175746F3B666F6E742D73697A653A313170783B6C696E652D6865696768743A313470787D2E75742D50726F70657274';
wwv_flow_api.g_varchar2_table(35) := '79456469746F7220626F6479202E75692D776964676574202E612D50726F70657274792D6669656C642D2D74657874617265617B666F6E742D66616D696C793A53464D6F6E6F2D526567756C61722C4D656E6C6F2C4D6F6E61636F2C436F6E736F6C6173';
wwv_flow_api.g_varchar2_table(36) := '2C224C696265726174696F6E204D6F6E6F222C22436F7572696572204E6577222C6D6F6E6F73706163657D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726561644F6E6C797B666F6E742D7765696768743A3730303B66';
wwv_flow_api.g_varchar2_table(37) := '6F6E742D73697A653A313270783B6C696E652D6865696768743A327D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D7365744974656D735461626C652D6865616465727B666F6E742D7765696768743A3430307D2E75742D';
wwv_flow_api.g_varchar2_table(38) := '50726F7065727479456469746F72202E612D50726F70657274792D7365744974656D735461626C65202E612D50726F70657274792D6669656C647B626F726465722D746F702D72696768742D7261646975733A303B626F726465722D626F74746F6D2D72';
wwv_flow_api.g_varchar2_table(39) := '696768742D7261646975733A307D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461696E65722D2D636F6D626F426F78202E612D427574746F6E7B6D617267696E2D6C6566743A3870787D2E7574';
wwv_flow_api.g_varchar2_table(40) := '2D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D636865636B626F785D2C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E707574';
wwv_flow_api.g_varchar2_table(41) := '5B747970653D726164696F5D7B706F736974696F6E3A6162736F6C7574653B6F766572666C6F773A68696464656E3B636C69703A726563742830203020302030293B6D617267696E3A2D3170783B70616464696E673A303B77696474683A3170783B6865';
wwv_flow_api.g_varchar2_table(42) := '696768743A3170783B626F726465723A307D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D636865636B626F785D2B6C6162656C2C2E75742D50726F7065727479456469';
wwv_flow_api.g_varchar2_table(43) := '746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D726164696F5D2B6C6162656C7B706F736974696F6E3A72656C61746976653B70616464696E672D72696768743A3870783B70616464696E672D6C6566743A323070783B';
wwv_flow_api.g_varchar2_table(44) := '637572736F723A706F696E7465727D2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D636865636B626F785D2B6C6162656C2C2E75742D50726F70657274';
wwv_flow_api.g_varchar2_table(45) := '79456469746F72202E752D52544C202E612D50726F70657274792D726164696F2D696E7075745B747970653D726164696F5D2B6C6162656C7B70616464696E672D6C6566743A3870783B70616464696E672D72696768743A323070787D2E75742D50726F';
wwv_flow_api.g_varchar2_table(46) := '7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D636865636B626F785D2B6C6162656C3A61667465722C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865';
wwv_flow_api.g_varchar2_table(47) := '636B626F782D696E7075745B747970653D636865636B626F785D2B6C6162656C3A6265666F72652C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D726164696F5D2B6C6162656C';
wwv_flow_api.g_varchar2_table(48) := '3A6265666F72657B706F736974696F6E3A6162736F6C7574653B746F703A3370783B6C6566743A303B646973706C61793A626C6F636B3B77696474683A313470783B6865696768743A313470783B636F6E74656E743A27273B2D7765626B69742D747261';
wwv_flow_api.g_varchar2_table(49) := '6E736974696F6E3A2E31323573206F70616369747920656173653B7472616E736974696F6E3A2E31323573206F70616369747920656173657D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B';
wwv_flow_api.g_varchar2_table(50) := '747970653D726164696F5D2B6C6162656C3A61667465727B706F736974696F6E3A6162736F6C7574653B746F703A3370783B6C6566743A303B646973706C61793A626C6F636B3B636F6E74656E743A27273B2D7765626B69742D7472616E736974696F6E';
wwv_flow_api.g_varchar2_table(51) := '3A2E31323573206F70616369747920656173653B7472616E736974696F6E3A2E31323573206F70616369747920656173657D2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F70657274792D636865636B626F782D696E70';
wwv_flow_api.g_varchar2_table(52) := '75745B747970653D636865636B626F785D2B6C6162656C3A61667465722C2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D636865636B626F785D2B6C61';
wwv_flow_api.g_varchar2_table(53) := '62656C3A6265666F72652C2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F70657274792D726164696F2D696E7075745B747970653D726164696F5D2B6C6162656C3A61667465722C2E75742D50726F7065727479456469';
wwv_flow_api.g_varchar2_table(54) := '746F72202E752D52544C202E612D50726F70657274792D726164696F2D696E7075745B747970653D726164696F5D2B6C6162656C3A6265666F72657B6C6566743A6175746F3B72696768743A307D2E75742D50726F7065727479456469746F72202E612D';
wwv_flow_api.g_varchar2_table(55) := '50726F70657274792D636865636B626F782D696E7075745B747970653D636865636B626F785D2B6C6162656C3A6265666F72652C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D';
wwv_flow_api.g_varchar2_table(56) := '726164696F5D2B6C6162656C3A6265666F72657B7A2D696E6465783A39303B626F726465723A31707820736F6C69647D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D63';
wwv_flow_api.g_varchar2_table(57) := '6865636B626F785D2B6C6162656C3A61667465722C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D726164696F5D2B6C6162656C3A61667465727B7A2D696E6465783A3130303B';
wwv_flow_api.g_varchar2_table(58) := '6F7061636974793A307D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D636865636B626F785D3A64697361626C65642B6C6162656C2C2E75742D50726F70657274794564';
wwv_flow_api.g_varchar2_table(59) := '69746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D726164696F5D3A64697361626C65642B6C6162656C7B6F7061636974793A2E353B637572736F723A64656661756C743B706F696E7465722D6576656E74733A6E6F6E';
wwv_flow_api.g_varchar2_table(60) := '657D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D636865636B626F785D3A64697361626C65642B6C6162656C3A6265666F72652C2E75742D50726F7065727479456469';
wwv_flow_api.g_varchar2_table(61) := '746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D726164696F5D3A64697361626C65642B6C6162656C3A6265666F72657B6F7061636974793A2E357D2E75742D50726F7065727479456469746F72202E612D50726F7065';
wwv_flow_api.g_varchar2_table(62) := '7274792D636865636B626F782D696E7075745B747970653D636865636B626F785D3A666F6375733A636865636B65642B6C6162656C3A61667465722C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D';
wwv_flow_api.g_varchar2_table(63) := '696E7075745B747970653D636865636B626F785D3A686F7665723A636865636B65642B6C6162656C3A61667465722C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D726164696F';
wwv_flow_api.g_varchar2_table(64) := '5D3A666F6375733A636865636B65642B6C6162656C3A61667465722C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D726164696F5D3A686F7665723A636865636B65642B6C6162';
wwv_flow_api.g_varchar2_table(65) := '656C3A61667465727B6F7061636974793A317D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D636865636B626F785D2B6C6162656C3A6265666F72657B626F726465722D';
wwv_flow_api.g_varchar2_table(66) := '7261646975733A3270787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D636865636B626F785D2B6C6162656C3A61667465727B6261636B67726F756E642D706F736974';
wwv_flow_api.g_varchar2_table(67) := '696F6E3A3530253B6261636B67726F756E642D73697A653A313670783B6261636B67726F756E642D7265706561743A6E6F2D7265706561747D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E70';
wwv_flow_api.g_varchar2_table(68) := '75745B747970653D636865636B626F785D3A696E64657465726D696E6174652B6C6162656C3A61667465727B6F7061636974793A313B6261636B67726F756E642D696D6167653A6E6F6E653B77696474683A3870783B6865696768743A3270783B626F72';
wwv_flow_api.g_varchar2_table(69) := '6465722D7261646975733A3270783B6D617267696E3A367078203370783B2D7765626B69742D7472616E73666F726D3A7363616C65282E3735293B7472616E73666F726D3A7363616C65282E3735297D2E75742D50726F7065727479456469746F72202E';
wwv_flow_api.g_varchar2_table(70) := '612D50726F70657274792D636865636B626F782D696E7075745B747970653D636865636B626F785D3A636865636B65642B6C6162656C3A61667465722C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F78';
wwv_flow_api.g_varchar2_table(71) := '2D696E7075745B747970653D636865636B626F785D3A636865636B65642B6C6162656C3A6265666F72652C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D726164696F5D3A6368';
wwv_flow_api.g_varchar2_table(72) := '65636B65642B6C6162656C3A61667465727B6F7061636974793A317D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D726164696F5D2B6C6162656C3A6265666F72657B626F7264';
wwv_flow_api.g_varchar2_table(73) := '65722D7261646975733A313670787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D726164696F5D2B6C6162656C3A61667465727B6D617267696E3A3570783B77696474683A34';
wwv_flow_api.g_varchar2_table(74) := '70783B6865696768743A3470783B626F726465722D7261646975733A313030257D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274792D726164696F47726F75';
wwv_flow_api.g_varchar2_table(75) := '702D2D627574746F6E5365747B70616464696E673A30203470787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F7B6D61';
wwv_flow_api.g_varchar2_table(76) := '7267696E2D72696768743A2D3170787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075742B6C6162656C7B70';
wwv_flow_api.g_varchar2_table(77) := '616464696E673A327078203870783B2D7765626B69742D7472616E736974696F6E3A6261636B67726F756E642D636F6C6F72202E31357320656173653B7472616E736974696F6E3A6261636B67726F756E642D636F6C6F72202E31357320656173653B6D';
wwv_flow_api.g_varchar2_table(78) := '696E2D77696474683A343870783B746578742D616C69676E3A63656E7465723B6C696E652D6865696768743A323070783B626F726465722D7261646975733A3270787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D7261';
wwv_flow_api.g_varchar2_table(79) := '64696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075742B6C6162656C3A61667465722C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D62';
wwv_flow_api.g_varchar2_table(80) := '7574746F6E536574202E612D50726F70657274792D726164696F2D696E7075742B6C6162656C3A6265666F72657B636F6E74656E743A696E697469616C7D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F4772';
wwv_flow_api.g_varchar2_table(81) := '6F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A636865636B65642B6C6162656C7B666F6E742D7765696768743A3730307D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D';
wwv_flow_api.g_varchar2_table(82) := '726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A666F6375732B6C6162656C7B7A2D696E6465783A313B6F75746C696E653A303B626F726465722D7261646975733A3270787D2E75742D';
wwv_flow_api.g_varchar2_table(83) := '50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75703A666F6375737B6F75746C696E653A307D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F7B646973706C61793A69';
wwv_flow_api.g_varchar2_table(84) := '6E6C696E652D626C6F636B7D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075747B646973706C61793A696E6C696E652D626C6F636B3B6D617267696E3A3270783B77696474683A313670783B6865';
wwv_flow_api.g_varchar2_table(85) := '696768743A313670783B766572746963616C2D616C69676E3A746F707D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D6C6162656C7B646973706C61793A696E6C696E652D626C6F636B3B70616464696E67';
wwv_flow_api.g_varchar2_table(86) := '3A3270783B766572746963616C2D616C69676E3A746F703B666F6E742D73697A653A313270787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64436F6E7461696E65722D2D726164696F47726F75707B706164';
wwv_flow_api.g_varchar2_table(87) := '64696E672D746F703A3670783B70616464696E672D626F74746F6D3A3670787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E5365743A61667465722C2E75742D50726F7065';
wwv_flow_api.g_varchar2_table(88) := '727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E5365743A6265666F72657B646973706C61793A7461626C653B636F6E74656E743A27277D2E75742D50726F7065727479456469746F72202E612D5072';
wwv_flow_api.g_varchar2_table(89) := '6F70657274792D726164696F47726F75702D2D627574746F6E5365743A61667465727B636C6561723A626F74687D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E';
wwv_flow_api.g_varchar2_table(90) := '612D50726F70657274792D726164696F7B666C6F61743A6C6566747D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D69';
wwv_flow_api.g_varchar2_table(91) := '6E7075747B706F736974696F6E3A6162736F6C7574653B6F766572666C6F773A68696464656E3B636C69703A726563742830203020302030293B6D617267696E3A2D3170783B70616464696E673A303B77696474683A3170783B6865696768743A317078';
wwv_flow_api.g_varchar2_table(92) := '3B626F726465723A307D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A64697361626C65642B6C616265';
wwv_flow_api.g_varchar2_table(93) := '6C7B6F7061636974793A2E357D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075742B6C6162656C202E612D49';
wwv_flow_api.g_varchar2_table(94) := '636F6E7B6D617267696E3A3270787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D2D737461636B65647B706F736974696F6E3A72656C61746976657D2E75742D50726F7065727479456469746F72202E612D50726F7065';
wwv_flow_api.g_varchar2_table(95) := '7274792D2D737461636B6564202E612D50726F70657274792D6669656C64436F6E7461696E65722C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D6C6162656C436F6E';
wwv_flow_api.g_varchar2_table(96) := '7461696E65722C2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722E6A732D73686F77416C6C202E612D50726F70657274792E6A732D73686F77416C6C2C2E75742D50726F7065727479456469746F72202E612D';
wwv_flow_api.g_varchar2_table(97) := '50726F7065727479456469746F722E6A732D73686F77416C6C202E612D50726F7065727479456469746F722D70726F706572747947726F75702E6A732D73686F77416C6C7B646973706C61793A626C6F636B7D2E75742D50726F7065727479456469746F';
wwv_flow_api.g_varchar2_table(98) := '72202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D6C6162656C436F6E7461696E65727B6D617267696E2D72696768743A363470783B70616464696E672D626F74746F6D3A307D2E75742D50726F7065727479456469';
wwv_flow_api.g_varchar2_table(99) := '746F72202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D6669656C64436F6E7461696E65727B70616464696E672D746F703A307D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D2D7374';
wwv_flow_api.g_varchar2_table(100) := '61636B6564202E612D50726F70657274792D627574746F6E436F6E7461696E65727B706F736974696F6E3A6162736F6C7574653B746F703A303B72696768743A307D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D2D7374';
wwv_flow_api.g_varchar2_table(101) := '61636B6564202E612D50726F70657274792D627574746F6E436F6E7461696E65722B2E612D50726F70657274792D6669656C64436F6E7461696E65727B70616464696E672D746F703A3470787D2E75742D50726F7065727479456469746F72202E612D50';
wwv_flow_api.g_varchar2_table(102) := '726F70657274792D2D737461636B6564202E612D50726F70657274792D627574746F6E436F6E7461696E6572202E612D427574746F6E2D2D717569636B5069636B7B6D617267696E2D6C6566743A3870787D2E75742D50726F7065727479456469746F72';
wwv_flow_api.g_varchar2_table(103) := '202E612D50726F70657274792D2D7363726F6C6C61626C657B646973706C61793A626C6F636B3B6F766572666C6F773A6175746F7D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C436F6E7461696E65722D2D';
wwv_flow_api.g_varchar2_table(104) := '77697468427574746F6E737B646973706C61793A7461626C652D63656C6C3B7461626C652D6C61796F75743A6175746F3B70616464696E672D626F74746F6D3A3870787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C';
wwv_flow_api.g_varchar2_table(105) := '6162656C436F6E7461696E65722D2D68696464656E4C6162656C7B70616464696E673A307D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461696E65727B70616464696E672D6C6566743A302169';
wwv_flow_api.g_varchar2_table(106) := '6D706F7274616E747D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461696E65722D2D70756C6C52696768747B666C6F61743A72696768747D2E75742D50726F7065727479456469746F72202E61';
wwv_flow_api.g_varchar2_table(107) := '2D50726F70657274792E69732D6368616E676564202E612D50726F70657274792D6C6162656C436F6E7461696E65723A6265666F72657B706F736974696F6E3A6162736F6C7574653B746F703A3170783B626F74746F6D3A303B6C6566743A3170783B64';
wwv_flow_api.g_varchar2_table(108) := '6973706C61793A696E6C696E652D626C6F636B3B77696474683A3370783B636F6E74656E743A27273B6F7061636974793A2E357D2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D6368616E6765642E69732D666F63';
wwv_flow_api.g_varchar2_table(109) := '75736564202E612D50726F70657274792D6C6162656C436F6E7461696E65723A6265666F72652C2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D6368616E6765643A686F766572202E612D50726F70657274792D6C';
wwv_flow_api.g_varchar2_table(110) := '6162656C436F6E7461696E65723A6265666F72657B6F7061636974793A317D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C2C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D75';
wwv_flow_api.g_varchar2_table(111) := '6E69747B646973706C61793A626C6F636B3B2D6D732D746578742D6F766572666C6F773A656C6C69707369733B746578742D6F766572666C6F773A656C6C69707369733B6F766572666C6F773A68696464656E7D2E75742D50726F706572747945646974';
wwv_flow_api.g_varchar2_table(112) := '6F72202E612D50726F70657274792D6669656C647B646973706C61793A626C6F636B3B77696474683A313030253B6261636B67726F756E642D636C69703A626F726465722D626F783B626F726465723A3020736F6C69647D2E75742D50726F7065727479';
wwv_flow_api.g_varchar2_table(113) := '456469746F72202E612D50726F70657274792D6669656C642D2D74657874617265617B6D696E2D6865696768743A343870783B666F6E742D66616D696C793A53464D6F6E6F2D526567756C61722C4D656E6C6F2C4D6F6E61636F2C436F6E736F6C61732C';
wwv_flow_api.g_varchar2_table(114) := '224C696265726174696F6E204D6F6E6F222C22436F7572696572204E6577222C6D6F6E6F73706163653B726573697A653A766572746963616C7D2E75742D50726F7065727479456469746F72202E612D50726F70657274792E6A732D73686F77416C6C2C';
wwv_flow_api.g_varchar2_table(115) := '2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702E6A732D73686F77416C6C7B646973706C61793A6E6F6E657D2E75742D50726F7065727479456469746F72202E612D50726F';
wwv_flow_api.g_varchar2_table(116) := '7065727479456469746F722D2D737461636B65642E6A732D73686F77416C6C202E612D50726F70657274792E6A732D73686F77416C6C7B646973706C61793A7461626C657D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D';
wwv_flow_api.g_varchar2_table(117) := '636865636B626F7847726F75703A666F6375737B6F75746C696E653A307D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075747B646973706C61793A696E6C696E652D626C6F636B3B6D6172';
wwv_flow_api.g_varchar2_table(118) := '67696E3A3270783B77696474683A313670783B6865696768743A313670783B766572746963616C2D616C69676E3A746F707D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D6C6162656C7B64697370';
wwv_flow_api.g_varchar2_table(119) := '6C61793A696E6C696E652D626C6F636B3B70616464696E673A3270783B766572746963616C2D616C69676E3A746F703B666F6E742D73697A653A313270787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D736574497465';
wwv_flow_api.g_varchar2_table(120) := '6D735461626C657B77696474683A313030253B626F726465722D73706163696E673A303B626F726465722D636F6C6C617073653A636F6C6C617073657D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D7365744974656D73';
wwv_flow_api.g_varchar2_table(121) := '5461626C652074647B70616464696E672D626F74746F6D3A3470787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D7365744974656D735461626C652074723A6C6173742D6368696C642074647B70616464696E672D626F';
wwv_flow_api.g_varchar2_table(122) := '74746F6D3A307D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D7365744974656D734865616465722D6865616465727B746578742D616C69676E3A6C6566747D2E75742D50726F7065727479456469746F72202E612D5072';
wwv_flow_api.g_varchar2_table(123) := '6F70657274792D7365744974656D735461626C652D72656D6F7665436F6C7B77696474683A343070787D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E7B2D2D612D627574746F6E2D70616464696E672D79';
wwv_flow_api.g_varchar2_table(124) := '3A203670783B77696474683A313030253B77686974652D73706163653A6E6F726D616C7D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274792D6C6162656C43';
wwv_flow_api.g_varchar2_table(125) := '6F6E7461696E6572202E612D50726F70657274792D6C6162656C7B70616464696E672D72696768743A313270783B70616464696E672D626F74746F6D3A3270783B70616464696E672D6C6566743A313270783B666F6E742D73697A653A313170787D2E75';
wwv_flow_api.g_varchar2_table(126) := '742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274792D627574746F6E436F6E7461696E65722C2E75742D50726F7065727479456469746F72202E612D50726F706572';
wwv_flow_api.g_varchar2_table(127) := '7479456469746F722D2D737461636B6564202E612D50726F70657274792D6669656C64436F6E7461696E65727B70616464696E672D746F703A303B70616464696E672D626F74746F6D3A3870787D2E75742D50726F7065727479456469746F72202E612D';
wwv_flow_api.g_varchar2_table(128) := '50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D627574746F6E436F6E7461696E65727B70616464696E672D746F703A3470783B70616464696E672D626F74';
wwv_flow_api.g_varchar2_table(129) := '746F6D3A3470787D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D2D737461636B6564202E612D50726F70657274792D2D737461636B6564202E612D50726F70657274792D6C6162656C436F6E7461696E65';
wwv_flow_api.g_varchar2_table(130) := '72202E612D50726F70657274792D6C6162656C7B70616464696E673A34707820307D2E75742D50726F7065727479456469746F72202E752D48434D202E612D50726F70657274792D6669656C647B626F726465723A31707820736F6C696421696D706F72';
wwv_flow_api.g_varchar2_table(131) := '74616E747D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D77726170706572202E612D50726F7065727479456469746F722D70726F706572747947726F75703A66697273742D6368696C647B6D617267696E';
wwv_flow_api.g_varchar2_table(132) := '2D746F703A3870787D2E75742D50726F7065727479456469746F72202E75692D6469616C6F67202E612D50726F7065727479456469746F727B6F766572666C6F773A6175746F3B6D61782D6865696768743A34303070787D2E75742D50726F7065727479';
wwv_flow_api.g_varchar2_table(133) := '456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75707B646973706C61793A626C6F636B3B6261636B67726F756E642D636C69703A70616464696E672D626F783B2D7765626B69742D7472616E736974696F6E3A';
wwv_flow_api.g_varchar2_table(134) := '6261636B67726F756E642D636F6C6F72202E317320656173652C2D7765626B69742D626F782D736861646F77202E317320656173653B7472616E736974696F6E3A6261636B67726F756E642D636F6C6F72202E317320656173652C626F782D736861646F';
wwv_flow_api.g_varchar2_table(135) := '77202E317320656173653B7472616E736974696F6E3A6261636B67726F756E642D636F6C6F72202E317320656173652C626F782D736861646F77202E317320656173652C2D7765626B69742D626F782D736861646F77202E317320656173657D2E75742D';
wwv_flow_api.g_varchar2_table(136) := '50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702E69732D636F6C6C6170736564202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465727B62';
wwv_flow_api.g_varchar2_table(137) := '6F726465722D626F74746F6D3A6E6F6E657D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702E69732D636F6C6C6170736564202E612D50726F7065727479456469746F722D';
wwv_flow_api.g_varchar2_table(138) := '70726F706572747947726F75702D626F64797B646973706C61793A6E6F6E657D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F7570';
wwv_flow_api.g_varchar2_table(139) := '3A66697273742D6368696C647B6D617267696E2D746F703A3470787D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465727B6D617267696E2D746F703A347078';
wwv_flow_api.g_varchar2_table(140) := '3B70616464696E673A31327078203870783B626F726465722D77696474683A303B2D7765626B69742D7472616E736974696F6E3A6D617267696E202E317320656173653B7472616E736974696F6E3A6D617267696E202E317320656173657D406D656469';
wwv_flow_api.g_varchar2_table(141) := '61206F6E6C792073637265656E20616E6420286D61782D77696474683A313032347078297B2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465727B7061646469';
wwv_flow_api.g_varchar2_table(142) := '6E672D746F703A3470783B70616464696E672D626F74746F6D3A3470787D7D406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A3130323570782920616E6420286D61782D77696474683A313237397078297B2E75742D';
wwv_flow_api.g_varchar2_table(143) := '50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465727B70616464696E672D746F703A3670783B70616464696E672D626F74746F6D3A3670787D7D406D65646961206F6E6C';
wwv_flow_api.g_varchar2_table(144) := '792073637265656E20616E6420286D696E2D77696474683A3132383170782920616E6420286D61782D77696474683A313637397078297B2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F7065727479';
wwv_flow_api.g_varchar2_table(145) := '47726F75702D6865616465727B70616464696E672D746F703A3870783B70616464696E672D626F74746F6D3A3870787D7D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D';
wwv_flow_api.g_varchar2_table(146) := '6865616465723A686F766572202E612D49636F6E7B6F7061636974793A317D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572202E612D49636F6E7B6D6172';
wwv_flow_api.g_varchar2_table(147) := '67696E3A327078203670782032707820303B626F726465722D7261646975733A3270783B6F7061636974793A2E353B2D7765626B69742D7472616E736974696F6E3A2E327320656173653B7472616E736974696F6E3A2E327320656173657D2E75742D50';
wwv_flow_api.g_varchar2_table(148) := '726F7065727479456469746F72202E752D52544C202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572202E612D49636F6E7B6D617267696E3A327078203020327078203670787D2E75742D50726F70657274';
wwv_flow_api.g_varchar2_table(149) := '79456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572202E612D49636F6E2E69636F6E2D72696768742D6172726F773A6265666F72657B636F6E74656E743A225C45304438227D2E75742D50';
wwv_flow_api.g_varchar2_table(150) := '726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572202E612D49636F6E2E69636F6E2D646F776E2D6172726F773A6265666F72657B636F6E74656E743A225C65306332227D';
wwv_flow_api.g_varchar2_table(151) := '2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465722E69732D666F63757365647B706F736974696F6E3A72656C61746976653B7A2D696E6465783A3130303B6F';
wwv_flow_api.g_varchar2_table(152) := '75746C696E653A307D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465722E69732D666F6375736564202E612D49636F6E7B6F7061636974793A317D2E75742D';
wwv_flow_api.g_varchar2_table(153) := '50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D7469746C657B646973706C61793A696E6C696E652D626C6F636B3B6D617267696E3A303B70616464696E673A303B76657274696361';
wwv_flow_api.g_varchar2_table(154) := '6C2D616C69676E3A746F703B666F6E742D7765696768743A3630303B666F6E742D73697A653A313470783B6C696E652D6865696768743A323070787D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722E69732D';
wwv_flow_api.g_varchar2_table(155) := '656D7074797B646973706C61793A2D7765626B69742D626F783B646973706C61793A2D6D732D666C6578626F783B646973706C61793A666C65783B6F766572666C6F773A68696464656E3B6865696768743A313030253B2D7765626B69742D626F782D61';
wwv_flow_api.g_varchar2_table(156) := '6C69676E3A63656E7465723B2D6D732D666C65782D616C69676E3A63656E7465723B616C69676E2D6974656D733A63656E7465727D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D6D6573736167657B7061';
wwv_flow_api.g_varchar2_table(157) := '6464696E673A313270783B77696474683A313030253B746578742D616C69676E3A63656E7465727D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D6D657373616765546578747B6D617267696E3A307D2E75';
wwv_flow_api.g_varchar2_table(158) := '742D50726F7065727479456469746F72202E612D49636F6E2B2E612D50726F7065727479456469746F722D6D657373616765546578747B6D617267696E2D746F703A3870787D2E75742D50726F7065727479456469746F72202E612D50726F7065727479';
wwv_flow_api.g_varchar2_table(159) := '456469746F722D65646974506172656E747B70616464696E673A367078203870783B746578742D616C69676E3A63656E7465727D406D65646961206F6E6C792073637265656E20616E6420286D61782D77696474683A313032347078297B2E75742D5072';
wwv_flow_api.g_varchar2_table(160) := '6F7065727479456469746F72202E612D50726F7065727479456469746F722D65646974506172656E747B70616464696E673A327078203870787D7D406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A31303235707829';
wwv_flow_api.g_varchar2_table(161) := '20616E6420286D61782D77696474683A313237397078297B2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D65646974506172656E747B70616464696E673A347078203870787D7D2E75742D50726F70657274';
wwv_flow_api.g_varchar2_table(162) := '79456469746F72202E612D50726F7065727479456469746F722D66696C7465727B706F736974696F6E3A72656C61746976653B646973706C61793A2D7765626B69742D626F783B646973706C61793A2D6D732D666C6578626F783B646973706C61793A66';
wwv_flow_api.g_varchar2_table(163) := '6C65783B70616464696E673A307D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C746572202E612D50726F7065727479456469746F722D66696C7465722D69636F6E7B706F736974696F6E3A616273';
wwv_flow_api.g_varchar2_table(164) := '6F6C7574653B746F703A303B6C6566743A303B6D617267696E3A3870783B6F7061636974793A2E353B2D7765626B69742D7472616E736974696F6E3A2E317320656173653B7472616E736974696F6E3A2E317320656173653B706F696E7465722D657665';
wwv_flow_api.g_varchar2_table(165) := '6E74733A6E6F6E657D2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F7065727479456469746F722D66696C746572202E612D50726F7065727479456469746F722D66696C7465722D69636F6E7B6C6566743A6175746F3B';
wwv_flow_api.g_varchar2_table(166) := '72696768743A307D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C746572202E612D50726F70657274792D6669656C643A6E6F74282E612D50726F70657274792D6669656C642D2D74657874297B2D';
wwv_flow_api.g_varchar2_table(167) := '7765626B69742D626F782D73697A696E673A626F726465722D626F783B626F782D73697A696E673A626F726465722D626F783B70616464696E673A387078203870782038707820333270783B6865696768743A333270783B6C696E652D6865696768743A';
wwv_flow_api.g_varchar2_table(168) := '333270783B626F726465722D7261646975733A3270787D2E75742D50726F7065727479456469746F72202E752D52544C202E612D50726F7065727479456469746F722D66696C746572202E612D50726F70657274792D6669656C643A6E6F74282E612D50';
wwv_flow_api.g_varchar2_table(169) := '726F70657274792D6669656C642D2D74657874297B70616464696E673A387078203332707820387078203870787D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C746572202E612D50726F70657274';
wwv_flow_api.g_varchar2_table(170) := '792D6669656C643A6E6F74282E612D50726F70657274792D6669656C642D2D74657874293A666F6375732B2E612D49636F6E7B6F7061636974793A317D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D6669';
wwv_flow_api.g_varchar2_table(171) := '6C746572202E612D427574746F6E2D2D737469636B7946696C7465727B706F736974696F6E3A6162736F6C7574653B746F703A303B72696768743A303B626F74746F6D3A303B7A2D696E6465783A31303B6D617267696E3A3470783B70616464696E673A';
wwv_flow_api.g_varchar2_table(172) := '3470783B6F7061636974793A303B2D7765626B69742D7472616E736974696F6E3A6F706163697479202E317320656173653B7472616E736974696F6E3A6F706163697479202E317320656173657D2E75742D50726F7065727479456469746F72202E612D';
wwv_flow_api.g_varchar2_table(173) := '50726F7065727479456469746F722D66696C7465723A666F6375732D77697468696E202E612D50726F70657274792D6669656C642B2E612D49636F6E7B6F7061636974793A317D2E75742D50726F7065727479456469746F72202E612D50726F70657274';
wwv_flow_api.g_varchar2_table(174) := '79456469746F722D66696C746572202E612D427574746F6E2D2D737469636B7946696C7465722E69732D6163746976652C2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C746572202E612D42757474';
wwv_flow_api.g_varchar2_table(175) := '6F6E2D2D737469636B7946696C7465723A666F6375732C2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D66696C746572202E612D50726F70657274792D6669656C643A666F6375737E2E612D427574746F6E';
wwv_flow_api.g_varchar2_table(176) := '2D2D737469636B7946696C7465727B6F7061636974793A317D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D686967686C696768747B70616464696E673A32707820303B626F726465722D7261646975733A3270783B2D77';
wwv_flow_api.g_varchar2_table(177) := '65626B69742D7472616E736974696F6E3A2E317320656173653B7472616E736974696F6E3A2E317320656173657D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6E6F74466F756E647B70616464696E673A312E3672656D';
wwv_flow_api.g_varchar2_table(178) := '3B746578742D616C69676E3A63656E7465727D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6E6F74466F756E64202E612D49636F6E7B6D617267696E2D626F74746F6D3A3870787D2E75742D50726F7065727479456469';
wwv_flow_api.g_varchar2_table(179) := '746F72202E612D50726F706572747947726F75702D6974656D7B626F726465722D746F703A31707820736F6C69643B626F726465722D626F74746F6D2D77696474683A307D2E75742D50726F7065727479456469746F72202E612D50726F706572747945';
wwv_flow_api.g_varchar2_table(180) := '6469746F722D70726F706572747947726F75702D626F64797B70616464696E673A34707820307D0A2F2A2320736F757263654D617070696E6755524C3D626173652E6373732E6D61702A2F';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(776881501923146572)
,p_plugin_id=>wwv_flow_api.id(776877005555146556)
,p_file_name=>'css/base.min.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C642D2D73656C656374207B0A20206261636B67726F756E642D696D6167653A2075726C28222E2E2F6173736574732F73656C6563742D6172726F772E7376672229';
wwv_flow_api.g_varchar2_table(2) := '3B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D6572726F72202E612D50726F70657274792D6C6162656C207B0A2020636F6C6F723A20233130304630453B0A7D0A2E75742D50726F706572747945646974';
wwv_flow_api.g_varchar2_table(3) := '6F72202E612D50726F70657274792E69732D6572726F72202E612D50726F70657274792D6669656C643A6E6F74283A666F63757329207B0A2020636F6C6F723A20234337343633343B0A7D0A2E75742D50726F7065727479456469746F72202E612D5072';
wwv_flow_api.g_varchar2_table(4) := '6F70657274792E69732D6572726F72202E69636F6E2D6572726F72207B0A2020636F6C6F723A20234337343633342021696D706F7274616E743B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D7761726E69';
wwv_flow_api.g_varchar2_table(5) := '6E67202E612D50726F70657274792D6C6162656C207B0A2020636F6C6F723A20233130304630453B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D7761726E696E67202E69636F6E2D7761726E696E67207B';
wwv_flow_api.g_varchar2_table(6) := '0A2020636F6C6F723A20234438393734442021696D706F7274616E743B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C2C0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479';
wwv_flow_api.g_varchar2_table(7) := '2D7365744974656D734865616465722D6865616465722C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D756E6974207B0A2020636F6C6F723A20233130304630453B0A7D0A2E75742D50726F7065727479456469746F72';
wwv_flow_api.g_varchar2_table(8) := '202E612D50726F70657274792D636865636B626F782D6C6162656C2C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F207B0A2020636F6C6F723A20726762612831362C2031352C2031342C20302E38293B0A';
wwv_flow_api.g_varchar2_table(9) := '7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64207B0A2020782D6261636B67726F756E642D636F6C6F723A20234643464246413B0A2020636F6C6F723A20233130304630453B0A2020626F726465722D63';
wwv_flow_api.g_varchar2_table(10) := '6F6C6F723A20234536453345303B0A20202D7765626B69742D626F782D736861646F773A20302031707820327078207267626128302C20302C20302C20302E31293B0A2020626F782D736861646F773A20302031707820327078207267626128302C2030';
wwv_flow_api.g_varchar2_table(11) := '2C20302C20302E31293B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C643A686F766572207B0A2020782D6261636B67726F756E642D636F6C6F723A20234646464646463B0A20202D7765626B69742D62';
wwv_flow_api.g_varchar2_table(12) := '6F782D736861646F773A20302031707820327078207267626128302C20302C20302C20302E31293B0A2020626F782D736861646F773A20302031707820327078207267626128302C20302C20302C20302E31293B0A7D0A2E75742D50726F706572747945';
wwv_flow_api.g_varchar2_table(13) := '6469746F72202E612D50726F70657274792D6669656C643A666F637573207B0A20206F75746C696E652D636F6C6F723A20233337374535353B0A2020782D6261636B67726F756E642D636F6C6F723A20234646464646463B0A20202D7765626B69742D62';
wwv_flow_api.g_varchar2_table(14) := '6F782D736861646F773A20302031707820327078207267626128302C20302C20302C20302E31293B0A2020626F782D736861646F773A20302031707820327078207267626128302C20302C20302C20302E31293B0A20206F75746C696E652D6F66667365';
wwv_flow_api.g_varchar2_table(15) := '743A203270783B0A20206F75746C696E652D77696474683A203270783B0A20206F75746C696E652D7374796C653A20646F747465643B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D6572726F722E69732D';
wwv_flow_api.g_varchar2_table(16) := '616374697665202E612D50726F70657274792D6669656C643A6E6F74282E612D50726F70657274792D6669656C642D2D7465787461726561293A666F637573207B0A20202D7765626B69742D626F782D736861646F773A20302030203020317078202345';
wwv_flow_api.g_varchar2_table(17) := '333531334320696E7365742C2030203170782032707820726762612835312C2035312C2035312C20302E31293B0A2020626F782D736861646F773A20302030203020317078202345333531334320696E7365742C20302031707820327078207267626128';
wwv_flow_api.g_varchar2_table(18) := '35312C2035312C2035312C20302E31293B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D736861646F772E69732D616374697665202E612D50726F70657274792D6669656C643A6E6F74282E612D50726F70';
wwv_flow_api.g_varchar2_table(19) := '657274792D6669656C642D2D7465787461726561293A666F637573207B0A20202D7765626B69742D626F782D736861646F773A20302030203020317078202345333531334320696E7365742C2030203170782032707820726762612835312C2035312C20';
wwv_flow_api.g_varchar2_table(20) := '35312C20302E31293B0A2020626F782D736861646F773A20302030203020317078202345333531334320696E7365742C2030203170782032707820726762612835312C2035312C2035312C20302E31293B0A7D0A2E75742D50726F706572747945646974';
wwv_flow_api.g_varchar2_table(21) := '6F72202E612D50726F70657274792E69732D7661726961626C65202E612D49636F6E2E69636F6E2D7661726961626C65207B0A2020636F6C6F723A20233746424546323B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274';
wwv_flow_api.g_varchar2_table(22) := '792E69732D7661726961626C65202E612D50726F70657274792D6669656C64207B0A20202D7765626B69742D626F782D736861646F773A203020302030203170782072676261283132372C203139302C203234322C20302E352920696E7365743B0A2020';
wwv_flow_api.g_varchar2_table(23) := '626F782D736861646F773A203020302030203170782072676261283132372C203139302C203234322C20302E352920696E7365743B0A2020782D6261636B67726F756E642D636F6C6F723A20236633663966653B0A7D0A2E75742D50726F706572747945';
wwv_flow_api.g_varchar2_table(24) := '6469746F72202E612D50726F70657274792E69732D7761726E696E67202E612D50726F70657274792D6669656C642D2D74657874617265613A666F637573207B0A2020626F726465722D636F6C6F723A20234641434436322021696D706F7274616E743B';
wwv_flow_api.g_varchar2_table(25) := '0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D6572726F72202E612D50726F70657274792D6669656C642D2D74657874617265613A666F637573207B0A2020626F726465722D636F6C6F723A202345333531';
wwv_flow_api.g_varchar2_table(26) := '33432021696D706F7274616E743B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461696E6572202E612D427574746F6E207B0A20206261636B67726F756E642D636F6C6F723A2023464646';
wwv_flow_api.g_varchar2_table(27) := '4646463B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C3A6265666F72652C0A2E75742D50726F70657274794564';
wwv_flow_api.g_varchar2_table(28) := '69746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D202B206C6162656C3A6265666F7265207B0A20206261636B67726F756E642D636F6C6F723A20234646464646463B0A2020626F726465722D636F';
wwv_flow_api.g_varchar2_table(29) := '6C6F723A20234446444344383B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A666F637573202B206C6162656C3A6265666F72652C';
wwv_flow_api.g_varchar2_table(30) := '0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A696E64657465726D696E617465202B206C6162656C3A6265666F72652C0A2E75742D5072';
wwv_flow_api.g_varchar2_table(31) := '6F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D3A666F637573202B206C6162656C3A6265666F72652C0A2E75742D50726F7065727479456469746F72202E612D50726F7065';
wwv_flow_api.g_varchar2_table(32) := '7274792D726164696F2D696E7075745B747970653D22726164696F225D3A696E64657465726D696E617465202B206C6162656C3A6265666F7265207B0A2020626F726465722D636F6C6F723A20233337374535353B0A20202D7765626B69742D626F782D';
wwv_flow_api.g_varchar2_table(33) := '736861646F773A207267626128302C20302C20302C20302E3129203020317078203170783B0A2020626F782D736861646F773A207267626128302C20302C20302C20302E3129203020317078203170783B0A7D0A2E75742D50726F706572747945646974';
wwv_flow_api.g_varchar2_table(34) := '6F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A666F6375733A636865636B6564202B206C6162656C3A6265666F72652C0A2E75742D50726F7065727479456469746F72202E612D50';
wwv_flow_api.g_varchar2_table(35) := '726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A666F6375733A696E64657465726D696E617465202B206C6162656C3A6265666F72652C0A2E75742D50726F7065727479456469746F72202E612D5072';
wwv_flow_api.g_varchar2_table(36) := '6F70657274792D726164696F2D696E7075745B747970653D22726164696F225D3A666F6375733A636865636B6564202B206C6162656C3A6265666F72652C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D';
wwv_flow_api.g_varchar2_table(37) := '696E7075745B747970653D22726164696F225D3A666F6375733A696E64657465726D696E617465202B206C6162656C3A6265666F7265207B0A2020626F726465722D636F6C6F723A20233337374535353B0A20206261636B67726F756E642D636F6C6F72';
wwv_flow_api.g_varchar2_table(38) := '3A20233337374535353B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A696E64657465726D696E617465202B206C6162656C3A6265';
wwv_flow_api.g_varchar2_table(39) := '666F72652C0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A636865636B6564202B206C6162656C3A6265666F7265207B0A2020626F7264';
wwv_flow_api.g_varchar2_table(40) := '65722D636F6C6F723A20233637363035423B0A20206261636B67726F756E642D636F6C6F723A20233637363035423B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B74797065';
wwv_flow_api.g_varchar2_table(41) := '3D22636865636B626F78225D3A696E64657465726D696E617465202B206C6162656C3A6166746572207B0A20206261636B67726F756E642D636F6C6F723A20234643464246413B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70';
wwv_flow_api.g_varchar2_table(42) := '657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A636865636B6564202B206C6162656C3A6166746572207B0A20206261636B67726F756E642D696D6167653A2075726C28222E2E2F6173736574732F63686563';
wwv_flow_api.g_varchar2_table(43) := '6B626F782D636865636B65642E73766722293B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D3A636865636B6564202B206C6162656C3A6265666F72';
wwv_flow_api.g_varchar2_table(44) := '65207B0A2020626F726465722D636F6C6F723A20726762612831362C2031352C2031342C20302E36293B0A20206261636B67726F756E642D636F6C6F723A20726762612831362C2031352C2031342C20302E36293B0A7D0A2E75742D50726F7065727479';
wwv_flow_api.g_varchar2_table(45) := '456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A636865636B6564202B206C6162656C207B0A20206261636B67726F756E642D636F6C6F';
wwv_flow_api.g_varchar2_table(46) := '723A20234446444344383B0A20202D7765626B69742D626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E312920696E7365742C20302032707820317078207267626128302C20302C20302C20302E30352920';
wwv_flow_api.g_varchar2_table(47) := '696E7365743B0A2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E312920696E7365742C20302032707820317078207267626128302C20302C20302C20302E30352920696E7365743B0A7D0A2E75742D';
wwv_flow_api.g_varchar2_table(48) := '50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A666F637573202B206C6162656C207B0A2020626F726465722D636F';
wwv_flow_api.g_varchar2_table(49) := '6C6F723A20302031707820327078207267626128302C20302C20302C20302E31292021696D706F7274616E743B0A20206261636B67726F756E642D636F6C6F723A20234446444344383B0A20202D7765626B69742D626F782D736861646F773A20302030';
wwv_flow_api.g_varchar2_table(50) := '20302031707820302031707820327078207267626128302C20302C20302C20302E312920696E7365742C20302031707820327078207267626128302C20302C20302C20302E31293B0A2020626F782D736861646F773A2030203020302031707820302031';
wwv_flow_api.g_varchar2_table(51) := '707820327078207267626128302C20302C20302C20302E312920696E7365742C20302031707820327078207267626128302C20302C20302C20302E31293B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D72616469';
wwv_flow_api.g_varchar2_table(52) := '6F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A6E6F74283A636865636B6564293A686F766572202B206C6162656C207B0A20202D7765626B69742D626F782D736861646F773A20302030203020';
wwv_flow_api.g_varchar2_table(53) := '317078207267626128302C20302C20302C20302E31352920696E7365742C20302031707820327078207267626128302C20302C20302C20302E31293B0A2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C2030';
wwv_flow_api.g_varchar2_table(54) := '2E31352920696E7365742C20302031707820327078207267626128302C20302C20302C20302E31293B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D';
wwv_flow_api.g_varchar2_table(55) := '50726F70657274792D726164696F2D696E7075743A686F7665723A616374697665202B206C6162656C207B0A20202D7765626B69742D626F782D736861646F773A2030203020302031707820302031707820327078207267626128302C20302C20302C20';
wwv_flow_api.g_varchar2_table(56) := '302E312920696E7365742C20302031707820327078207267626128302C20302C20302C20302E31293B0A2020626F782D736861646F773A2030203020302031707820302031707820327078207267626128302C20302C20302C20302E312920696E736574';
wwv_flow_api.g_varchar2_table(57) := '2C20302031707820327078207267626128302C20302C20302C20302E31293B0A20206261636B67726F756E642D636F6C6F723A20234536453345303B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636F6C6F7250';
wwv_flow_api.g_varchar2_table(58) := '726576696577207B0A20202D7765626B69742D626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E312920696E7365743B0A2020626F782D736861646F773A20302030203020317078207267626128302C2030';
wwv_flow_api.g_varchar2_table(59) := '2C20302C20302E312920696E7365743B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D6368616E676564202E612D50726F70657274792D6C6162656C436F6E7461696E65723A6265666F7265207B0A202062';
wwv_flow_api.g_varchar2_table(60) := '61636B67726F756E642D636F6C6F723A20233337374535353B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F72207B0A2020782D6261636B67726F756E642D636F6C6F723A20234536453345303B0A7D0A';
wwv_flow_api.g_varchar2_table(61) := '2E75742D50726F7065727479456469746F72202E75692D6469616C6F67202E612D50726F7065727479456469746F72207B0A2020782D6261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0A7D0A2E75742D50726F706572747945';
wwv_flow_api.g_varchar2_table(62) := '6469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702C0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465722C0A2E75';
wwv_flow_api.g_varchar2_table(63) := '742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D626F6479207B0A2020626F726465722D636F6C6F723A20234536453345303B0A7D0A2E75742D50726F7065727479456469746F';
wwv_flow_api.g_varchar2_table(64) := '72202E612D50726F7065727479456469746F722D70726F706572747947726F7570207B0A2020782D6261636B67726F756E642D636F6C6F723A20234637463546333B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F706572747945';
wwv_flow_api.g_varchar2_table(65) := '6469746F722D70726F706572747947726F75703A666F6375732D77697468696E2C0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702E6861732D666F637573207B0A202078';
wwv_flow_api.g_varchar2_table(66) := '2D6261636B67726F756E642D636F6C6F723A2072676261283232342C203234352C203231382C20302E33293B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865';
wwv_flow_api.g_varchar2_table(67) := '61646572202E612D49636F6E207B0A2020636F6C6F723A20234643464246413B0A20206261636B67726F756E642D636F6C6F723A20234138413239423B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F72';
wwv_flow_api.g_varchar2_table(68) := '2D70726F706572747947726F75702D7469746C65207B0A2020636F6C6F723A20233130304630453B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D626F6479202E';
wwv_flow_api.g_varchar2_table(69) := '612D50726F7065727479207B0A2020626F726465722D636F6C6F723A20234536453345303B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465722E6973';
wwv_flow_api.g_varchar2_table(70) := '2D666F6375736564207B0A20202D7765626B69742D626F782D736861646F773A20726762612835312C2035312C2035312C20302E31293B0A2020626F782D736861646F773A20726762612835312C2035312C2035312C20302E31293B0A7D0A2E75742D50';
wwv_flow_api.g_varchar2_table(71) := '726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465722E69732D666F6375736564202E612D49636F6E207B0A2020782D6261636B67726F756E642D636F6C6F723A2023333737';
wwv_flow_api.g_varchar2_table(72) := '4535353B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D6D657373616765207B0A2020636F6C6F723A20726762612831362C2031352C2031342C20302E36293B0A7D0A2E75742D50726F7065727479';
wwv_flow_api.g_varchar2_table(73) := '456469746F72202E612D50726F7065727479456469746F722D6D65737361676554657874207B0A2020636F6C6F723A20726762612831362C2031352C2031342C20302E38293B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F7065';
wwv_flow_api.g_varchar2_table(74) := '7274792D686967686C69676874207B0A20206261636B67726F756E642D636F6C6F723A20234645454443333B0A20202D7765626B69742D626F782D736861646F773A20302031707820317078202D31707820726762612835312C2035312C2035312C2030';
wwv_flow_api.g_varchar2_table(75) := '2E31293B0A2020626F782D736861646F773A20302031707820317078202D31707820726762612835312C2035312C2035312C20302E31293B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6E6F74466F756E64207B';
wwv_flow_api.g_varchar2_table(76) := '0A2020636F6C6F723A20726762612831362C2031352C2031342C20302E36293B0A7D0A2E75742D50726F7065727479456469746F72202E612D50726F706572747947726F75702D6974656D207B0A2020626F726465722D746F702D636F6C6F723A202343';
wwv_flow_api.g_varchar2_table(77) := '42433542463B0A7D0A';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(776881932522146573)
,p_plugin_id=>wwv_flow_api.id(776877005555146556)
,p_file_name=>'css/style.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '7B2276657273696F6E223A332C22736F7572636573223A5B227374796C652E637373225D2C226E616D6573223A5B5D2C226D617070696E6773223A22414141412C34432C434143452C67442C434145462C79442C434143452C612C434145462C38444141';
wwv_flow_api.g_varchar2_table(2) := '38442C4F2C43414335442C612C434145462C6D442C434143452C75422C434151462C6F432C434143412C6F442C434143412C6D432C434152412C32442C434143452C612C434145462C75442C434143452C75422C43414F462C36432C434143412C6F432C';
wwv_flow_api.g_varchar2_table(3) := '434143452C75422C434145462C6F432C434143452C30422C434143412C612C434143412C6F422C434143412C32432C434143412C6D432C434145462C30432C434143452C75422C434143412C32432C434143412C6D432C434145462C30432C434143452C';
wwv_flow_api.g_varchar2_table(4) := '71422C434143412C75422C434143412C32432C434143412C6D432C434143412C6B422C434143412C69422C434143412C6F422C434145462C7745414177452C6B432C43414978452C7945414179452C6B432C43414876452C73452C434143412C38442C43';
wwv_flow_api.g_varchar2_table(5) := '414D462C67452C434143452C612C434145462C34442C434143452C75442C434143412C2B432C434143412C30422C434145462C32452C434143452C38422C434145462C79452C434143452C38422C434145462C77442C434143452C71422C434145462C79';
wwv_flow_api.g_varchar2_table(6) := '452C434143412C6D452C434143452C71422C434143412C6F422C434145462C2B452C434143412C75462C434143412C79452C434143412C69462C434143452C6F422C434143412C32432C434143412C6D432C434145462C75462C434143412C36462C4341';
wwv_flow_api.g_varchar2_table(7) := '43412C69462C434143412C75462C434143452C6F422C434143412C77422C434147462C69462C434144412C75462C434145452C6F422C434143412C77422C434145462C73462C434143452C77422C434145462C67462C434143452C6F442C434145462C32';
wwv_flow_api.g_varchar2_table(8) := '452C434143452C38422C434143412C6B432C434145462C30462C434143452C77422C434143412C69462C434143412C79452C434145462C77462C434143452C2B432C434143412C77422C434143412C6F462C434143412C34452C434145462C6946414169';
wwv_flow_api.g_varchar2_table(9) := '462C71422C4341432F452C32452C434143412C6D452C434145462C2B462C434143452C6F462C434143412C34452C434143412C77422C434145462C32432C434143452C69442C434143412C79432C434145462C32452C434143452C77422C434145462C6F';
wwv_flow_api.g_varchar2_table(10) := '432C434143452C30422C434145462C2B432C434143452C38422C434145462C6B442C434145412C75442C434144412C79442C434145452C6F422C434145462C6B442C434143452C30422C434147462C34442C434144412C2B442C434145452C75432C4341';
wwv_flow_api.g_varchar2_table(11) := '45462C69452C434143452C612C434143412C77422C434145462C77442C434143452C612C434145462C6D452C434143452C6F422C434145462C6F452C434143452C6F432C434143412C34422C434145462C34452C434143452C30422C434145462C34432C';
wwv_flow_api.g_varchar2_table(12) := '434143452C75422C434145462C67442C434143452C75422C434145462C77432C434143452C77422C434143412C6D442C434143412C32432C434145462C75432C434143452C75422C434145462C77432C434143452C7742222C2266696C65223A22737479';
wwv_flow_api.g_varchar2_table(13) := '6C652E637373222C22736F7572636573436F6E74656E74223A5B222E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C642D2D73656C656374207B5C6E20206261636B67726F756E642D696D6167653A2075726C285C';
wwv_flow_api.g_varchar2_table(14) := '222E2E2F6173736574732F73656C6563742D6172726F772E7376675C22293B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D6572726F72202E612D50726F70657274792D6C6162656C207B5C6E202063';
wwv_flow_api.g_varchar2_table(15) := '6F6C6F723A20233130304630453B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D6572726F72202E612D50726F70657274792D6669656C643A6E6F74283A666F63757329207B5C6E2020636F6C6F723A';
wwv_flow_api.g_varchar2_table(16) := '20234337343633343B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D6572726F72202E69636F6E2D6572726F72207B5C6E2020636F6C6F723A20234337343633342021696D706F7274616E743B5C6E7D';
wwv_flow_api.g_varchar2_table(17) := '5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D7761726E696E67202E612D50726F70657274792D6C6162656C207B5C6E2020636F6C6F723A20233130304630453B5C6E7D5C6E2E75742D50726F706572747945';
wwv_flow_api.g_varchar2_table(18) := '6469746F72202E612D50726F70657274792E69732D7761726E696E67202E69636F6E2D7761726E696E67207B5C6E2020636F6C6F723A20234438393734442021696D706F7274616E743B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E61';
wwv_flow_api.g_varchar2_table(19) := '2D50726F70657274792D6C6162656C2C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D7365744974656D734865616465722D6865616465722C5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065';
wwv_flow_api.g_varchar2_table(20) := '7274792D756E6974207B5C6E2020636F6C6F723A20233130304630453B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D6C6162656C2C5C6E2E75742D50726F7065727479456469746F72';
wwv_flow_api.g_varchar2_table(21) := '202E612D50726F70657274792D726164696F207B5C6E2020636F6C6F723A20726762612831362C2031352C2031342C20302E38293B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C64207B5C6E2020';
wwv_flow_api.g_varchar2_table(22) := '782D6261636B67726F756E642D636F6C6F723A20234643464246413B5C6E2020636F6C6F723A20233130304630453B5C6E2020626F726465722D636F6C6F723A20234536453345303B5C6E20202D7765626B69742D626F782D736861646F773A20302031';
wwv_flow_api.g_varchar2_table(23) := '707820327078207267626128302C20302C20302C20302E31293B5C6E2020626F782D736861646F773A20302031707820327078207267626128302C20302C20302C20302E31293B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D5072';
wwv_flow_api.g_varchar2_table(24) := '6F70657274792D6669656C643A686F766572207B5C6E2020782D6261636B67726F756E642D636F6C6F723A20234646464646463B5C6E20202D7765626B69742D626F782D736861646F773A20302031707820327078207267626128302C20302C20302C20';
wwv_flow_api.g_varchar2_table(25) := '302E31293B5C6E2020626F782D736861646F773A20302031707820327078207267626128302C20302C20302C20302E31293B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C643A666F637573207B5C';
wwv_flow_api.g_varchar2_table(26) := '6E20206F75746C696E652D636F6C6F723A20233337374535353B5C6E2020782D6261636B67726F756E642D636F6C6F723A20234646464646463B5C6E20202D7765626B69742D626F782D736861646F773A20302031707820327078207267626128302C20';
wwv_flow_api.g_varchar2_table(27) := '302C20302C20302E31293B5C6E2020626F782D736861646F773A20302031707820327078207267626128302C20302C20302C20302E31293B5C6E20206F75746C696E652D6F66667365743A203270783B5C6E20206F75746C696E652D77696474683A2032';
wwv_flow_api.g_varchar2_table(28) := '70783B5C6E20206F75746C696E652D7374796C653A20646F747465643B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D6572726F722E69732D616374697665202E612D50726F70657274792D6669656C';
wwv_flow_api.g_varchar2_table(29) := '643A6E6F74282E612D50726F70657274792D6669656C642D2D7465787461726561293A666F637573207B5C6E20202D7765626B69742D626F782D736861646F773A20302030203020317078202345333531334320696E7365742C20302031707820327078';
wwv_flow_api.g_varchar2_table(30) := '20726762612835312C2035312C2035312C20302E31293B5C6E2020626F782D736861646F773A20302030203020317078202345333531334320696E7365742C2030203170782032707820726762612835312C2035312C2035312C20302E31293B5C6E7D5C';
wwv_flow_api.g_varchar2_table(31) := '6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D736861646F772E69732D616374697665202E612D50726F70657274792D6669656C643A6E6F74282E612D50726F70657274792D6669656C642D2D74657874617265';
wwv_flow_api.g_varchar2_table(32) := '61293A666F637573207B5C6E20202D7765626B69742D626F782D736861646F773A20302030203020317078202345333531334320696E7365742C2030203170782032707820726762612835312C2035312C2035312C20302E31293B5C6E2020626F782D73';
wwv_flow_api.g_varchar2_table(33) := '6861646F773A20302030203020317078202345333531334320696E7365742C2030203170782032707820726762612835312C2035312C2035312C20302E31293B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792E';
wwv_flow_api.g_varchar2_table(34) := '69732D7661726961626C65202E612D49636F6E2E69636F6E2D7661726961626C65207B5C6E2020636F6C6F723A20233746424546323B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D7661726961626C';
wwv_flow_api.g_varchar2_table(35) := '65202E612D50726F70657274792D6669656C64207B5C6E20202D7765626B69742D626F782D736861646F773A203020302030203170782072676261283132372C203139302C203234322C20302E352920696E7365743B5C6E2020626F782D736861646F77';
wwv_flow_api.g_varchar2_table(36) := '3A203020302030203170782072676261283132372C203139302C203234322C20302E352920696E7365743B5C6E2020782D6261636B67726F756E642D636F6C6F723A20236633663966653B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E';
wwv_flow_api.g_varchar2_table(37) := '612D50726F70657274792E69732D7761726E696E67202E612D50726F70657274792D6669656C642D2D74657874617265613A666F637573207B5C6E2020626F726465722D636F6C6F723A20234641434436322021696D706F7274616E743B5C6E7D5C6E2E';
wwv_flow_api.g_varchar2_table(38) := '75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D6572726F72202E612D50726F70657274792D6669656C642D2D74657874617265613A666F637573207B5C6E2020626F726465722D636F6C6F723A202345333531334320';
wwv_flow_api.g_varchar2_table(39) := '21696D706F7274616E743B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461696E6572202E612D427574746F6E207B5C6E20206261636B67726F756E642D636F6C6F723A2023464646';
wwv_flow_api.g_varchar2_table(40) := '4646463B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D202B206C6162656C3A6265666F72652C5C6E2E75742D50726F7065';
wwv_flow_api.g_varchar2_table(41) := '727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D202B206C6162656C3A6265666F7265207B5C6E20206261636B67726F756E642D636F6C6F723A20234646464646463B5C6E2020';
wwv_flow_api.g_varchar2_table(42) := '626F726465722D636F6C6F723A20234446444344383B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D3A666F637573202B20';
wwv_flow_api.g_varchar2_table(43) := '6C6162656C3A6265666F72652C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D3A696E64657465726D696E617465202B206C616265';
wwv_flow_api.g_varchar2_table(44) := '6C3A6265666F72652C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D3A666F637573202B206C6162656C3A6265666F72652C5C6E2E75742D50726F';
wwv_flow_api.g_varchar2_table(45) := '7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D3A696E64657465726D696E617465202B206C6162656C3A6265666F7265207B5C6E2020626F726465722D636F6C6F723A20';
wwv_flow_api.g_varchar2_table(46) := '233337374535353B5C6E20202D7765626B69742D626F782D736861646F773A207267626128302C20302C20302C20302E3129203020317078203170783B5C6E2020626F782D736861646F773A207267626128302C20302C20302C20302E31292030203170';
wwv_flow_api.g_varchar2_table(47) := '78203170783B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D3A666F6375733A636865636B6564202B206C6162656C3A6265';
wwv_flow_api.g_varchar2_table(48) := '666F72652C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D3A666F6375733A696E64657465726D696E617465202B206C6162656C3A';
wwv_flow_api.g_varchar2_table(49) := '6265666F72652C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D3A666F6375733A636865636B6564202B206C6162656C3A6265666F72652C5C6E2E';
wwv_flow_api.g_varchar2_table(50) := '75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D3A666F6375733A696E64657465726D696E617465202B206C6162656C3A6265666F7265207B5C6E2020626F';
wwv_flow_api.g_varchar2_table(51) := '726465722D636F6C6F723A20233337374535353B5C6E20206261636B67726F756E642D636F6C6F723A20233337374535353B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E707574';
wwv_flow_api.g_varchar2_table(52) := '5B747970653D5C22636865636B626F785C225D3A696E64657465726D696E617465202B206C6162656C3A6265666F72652C5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970';
wwv_flow_api.g_varchar2_table(53) := '653D5C22636865636B626F785C225D3A636865636B6564202B206C6162656C3A6265666F7265207B5C6E2020626F726465722D636F6C6F723A20233637363035423B5C6E20206261636B67726F756E642D636F6C6F723A20233637363035423B5C6E7D5C';
wwv_flow_api.g_varchar2_table(54) := '6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D3A696E64657465726D696E617465202B206C6162656C3A6166746572207B5C6E202062';
wwv_flow_api.g_varchar2_table(55) := '61636B67726F756E642D636F6C6F723A20234643464246413B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D5C22636865636B626F785C225D3A636865636B';
wwv_flow_api.g_varchar2_table(56) := '6564202B206C6162656C3A6166746572207B5C6E20206261636B67726F756E642D696D6167653A2075726C285C222E2E2F6173736574732F636865636B626F782D636865636B65642E7376675C22293B5C6E7D5C6E2E75742D50726F7065727479456469';
wwv_flow_api.g_varchar2_table(57) := '746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D5C22726164696F5C225D3A636865636B6564202B206C6162656C3A6265666F7265207B5C6E2020626F726465722D636F6C6F723A20726762612831362C2031352C2031';
wwv_flow_api.g_varchar2_table(58) := '342C20302E36293B5C6E20206261636B67726F756E642D636F6C6F723A20726762612831362C2031352C2031342C20302E36293B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D';
wwv_flow_api.g_varchar2_table(59) := '627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A636865636B6564202B206C6162656C207B5C6E20206261636B67726F756E642D636F6C6F723A20234446444344383B5C6E20202D7765626B69742D626F782D736861';
wwv_flow_api.g_varchar2_table(60) := '646F773A20302030203020317078207267626128302C20302C20302C20302E312920696E7365742C20302032707820317078207267626128302C20302C20302C20302E30352920696E7365743B5C6E2020626F782D736861646F773A2030203020302031';
wwv_flow_api.g_varchar2_table(61) := '7078207267626128302C20302C20302C20302E312920696E7365742C20302032707820317078207267626128302C20302C20302C20302E30352920696E7365743B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479';
wwv_flow_api.g_varchar2_table(62) := '2D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A666F637573202B206C6162656C207B5C6E2020626F726465722D636F6C6F723A20302031707820327078207267626128302C20302C';
wwv_flow_api.g_varchar2_table(63) := '20302C20302E31292021696D706F7274616E743B5C6E20206261636B67726F756E642D636F6C6F723A20234446444344383B5C6E20202D7765626B69742D626F782D736861646F773A203020302030203170782030203170782032707820726762612830';
wwv_flow_api.g_varchar2_table(64) := '2C20302C20302C20302E312920696E7365742C20302031707820327078207267626128302C20302C20302C20302E31293B5C6E2020626F782D736861646F773A2030203020302031707820302031707820327078207267626128302C20302C20302C2030';
wwv_flow_api.g_varchar2_table(65) := '2E312920696E7365742C20302031707820327078207267626128302C20302C20302C20302E31293B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E61';
wwv_flow_api.g_varchar2_table(66) := '2D50726F70657274792D726164696F2D696E7075743A6E6F74283A636865636B6564293A686F766572202B206C6162656C207B5C6E20202D7765626B69742D626F782D736861646F773A20302030203020317078207267626128302C20302C20302C2030';
wwv_flow_api.g_varchar2_table(67) := '2E31352920696E7365742C20302031707820327078207267626128302C20302C20302C20302E31293B5C6E2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E31352920696E7365742C20302031707820';
wwv_flow_api.g_varchar2_table(68) := '327078207267626128302C20302C20302C20302E31293B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D69';
wwv_flow_api.g_varchar2_table(69) := '6E7075743A686F7665723A616374697665202B206C6162656C207B5C6E20202D7765626B69742D626F782D736861646F773A2030203020302031707820302031707820327078207267626128302C20302C20302C20302E312920696E7365742C20302031';
wwv_flow_api.g_varchar2_table(70) := '707820327078207267626128302C20302C20302C20302E31293B5C6E2020626F782D736861646F773A2030203020302031707820302031707820327078207267626128302C20302C20302C20302E312920696E7365742C20302031707820327078207267';
wwv_flow_api.g_varchar2_table(71) := '626128302C20302C20302C20302E31293B5C6E20206261636B67726F756E642D636F6C6F723A20234536453345303B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636F6C6F7250726576696577207B5C6E20';
wwv_flow_api.g_varchar2_table(72) := '202D7765626B69742D626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E312920696E7365743B5C6E2020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E3129';
wwv_flow_api.g_varchar2_table(73) := '20696E7365743B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D6368616E676564202E612D50726F70657274792D6C6162656C436F6E7461696E65723A6265666F7265207B5C6E20206261636B67726F';
wwv_flow_api.g_varchar2_table(74) := '756E642D636F6C6F723A20233337374535353B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F72207B5C6E2020782D6261636B67726F756E642D636F6C6F723A20234536453345303B5C6E7D5C6E2E';
wwv_flow_api.g_varchar2_table(75) := '75742D50726F7065727479456469746F72202E75692D6469616C6F67202E612D50726F7065727479456469746F72207B5C6E2020782D6261636B67726F756E642D636F6C6F723A207472616E73706172656E743B5C6E7D5C6E2E75742D50726F70657274';
wwv_flow_api.g_varchar2_table(76) := '79456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702C5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465722C';
wwv_flow_api.g_varchar2_table(77) := '5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D626F6479207B5C6E2020626F726465722D636F6C6F723A20234536453345303B5C6E7D5C6E2E75742D50726F706572';
wwv_flow_api.g_varchar2_table(78) := '7479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F7570207B5C6E2020782D6261636B67726F756E642D636F6C6F723A20234637463546333B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E61';
wwv_flow_api.g_varchar2_table(79) := '2D50726F7065727479456469746F722D70726F706572747947726F75703A666F6375732D77697468696E2C5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702E6861732D';
wwv_flow_api.g_varchar2_table(80) := '666F637573207B5C6E2020782D6261636B67726F756E642D636F6C6F723A2072676261283232342C203234352C203231382C20302E33293B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D7072';
wwv_flow_api.g_varchar2_table(81) := '6F706572747947726F75702D686561646572202E612D49636F6E207B5C6E2020636F6C6F723A20234643464246413B5C6E20206261636B67726F756E642D636F6C6F723A20234138413239423B5C6E7D5C6E2E75742D50726F7065727479456469746F72';
wwv_flow_api.g_varchar2_table(82) := '202E612D50726F7065727479456469746F722D70726F706572747947726F75702D7469746C65207B5C6E2020636F6C6F723A20233130304630453B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F72';
wwv_flow_api.g_varchar2_table(83) := '2D70726F706572747947726F75702D626F6479202E612D50726F7065727479207B5C6E2020626F726465722D636F6C6F723A20234536453345303B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F72';
wwv_flow_api.g_varchar2_table(84) := '2D70726F706572747947726F75702D6865616465722E69732D666F6375736564207B5C6E20202D7765626B69742D626F782D736861646F773A20726762612835312C2035312C2035312C20302E31293B5C6E2020626F782D736861646F773A2072676261';
wwv_flow_api.g_varchar2_table(85) := '2835312C2035312C2035312C20302E31293B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465722E69732D666F6375736564202E612D49636F6E20';
wwv_flow_api.g_varchar2_table(86) := '7B5C6E2020782D6261636B67726F756E642D636F6C6F723A20233337374535353B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D6D657373616765207B5C6E2020636F6C6F723A207267626128';
wwv_flow_api.g_varchar2_table(87) := '31362C2031352C2031342C20302E36293B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D6D65737361676554657874207B5C6E2020636F6C6F723A20726762612831362C2031352C2031342C20';
wwv_flow_api.g_varchar2_table(88) := '302E38293B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D686967686C69676874207B5C6E20206261636B67726F756E642D636F6C6F723A20234645454443333B5C6E20202D7765626B69742D626F782D7368';
wwv_flow_api.g_varchar2_table(89) := '61646F773A20302031707820317078202D31707820726762612835312C2035312C2035312C20302E31293B5C6E2020626F782D736861646F773A20302031707820317078202D31707820726762612835312C2035312C2035312C20302E31293B5C6E7D5C';
wwv_flow_api.g_varchar2_table(90) := '6E2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6E6F74466F756E64207B5C6E2020636F6C6F723A20726762612831362C2031352C2031342C20302E36293B5C6E7D5C6E2E75742D50726F7065727479456469746F72202E';
wwv_flow_api.g_varchar2_table(91) := '612D50726F706572747947726F75702D6974656D207B5C6E2020626F726465722D746F702D636F6C6F723A20234342433542463B5C6E7D5C6E225D7D';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(776882396133146573)
,p_plugin_id=>wwv_flow_api.id(776877005555146556)
,p_file_name=>'css/style.css.map'
,p_mime_type=>'application/json'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2E75742D50726F7065727479456469746F72207B0A202020202E612D50726F70657274792D6669656C642D2D73656C656374207B0A202020206261636B67726F756E642D696D6167653A2075726C28222E2E2F6173736574732F73656C6563742D617272';
wwv_flow_api.g_varchar2_table(2) := '6F772E73766722293B0A202020207D0A0A202020202E612D50726F70657274792E69732D6572726F72202E612D50726F70657274792D6C6162656C207B0A20202020636F6C6F723A20233130304630453B0A202020207D0A0A202020202E612D50726F70';
wwv_flow_api.g_varchar2_table(3) := '657274792E69732D6572726F72202E612D50726F70657274792D6669656C643A6E6F74283A666F63757329207B0A20202020636F6C6F723A20234337343633343B0A202020207D0A0A202020202E612D50726F70657274792E69732D6572726F72202E69';
wwv_flow_api.g_varchar2_table(4) := '636F6E2D6572726F72207B0A20202020636F6C6F723A20234337343633342021696D706F7274616E743B0A202020207D0A0A202020202E612D50726F70657274792E69732D7761726E696E67202E612D50726F70657274792D6C6162656C207B0A202020';
wwv_flow_api.g_varchar2_table(5) := '20636F6C6F723A20233130304630453B0A202020207D0A0A202020202E612D50726F70657274792E69732D7761726E696E67202E69636F6E2D7761726E696E67207B0A20202020636F6C6F723A20234438393734442021696D706F7274616E743B0A2020';
wwv_flow_api.g_varchar2_table(6) := '20207D0A0A202020202E612D50726F70657274792D6C6162656C2C0A202020202E612D50726F70657274792D7365744974656D734865616465722D6865616465722C0A202020202E612D50726F70657274792D756E6974207B0A20202020636F6C6F723A';
wwv_flow_api.g_varchar2_table(7) := '20233130304630453B0A202020207D0A0A202020202E612D50726F70657274792D636865636B626F782D6C6162656C2C0A202020202E612D50726F70657274792D726164696F207B0A20202020636F6C6F723A20726762612831362C2031352C2031342C';
wwv_flow_api.g_varchar2_table(8) := '20302E38293B0A202020207D0A0A202020202E612D50726F70657274792D6669656C64207B0A20202020782D6261636B67726F756E642D636F6C6F723A20234643464246413B0A20202020636F6C6F723A20233130304630453B0A20202020626F726465';
wwv_flow_api.g_varchar2_table(9) := '722D636F6C6F723A20234536453345303B0A202020202D7765626B69742D626F782D736861646F773A20302031707820327078207267626128302C20302C20302C20302E31293B0A202020202020202020202020626F782D736861646F773A2030203170';
wwv_flow_api.g_varchar2_table(10) := '7820327078207267626128302C20302C20302C20302E31293B0A202020207D0A0A202020202E612D50726F70657274792D6669656C643A686F766572207B0A20202020782D6261636B67726F756E642D636F6C6F723A20234646464646463B0A20202020';
wwv_flow_api.g_varchar2_table(11) := '2D7765626B69742D626F782D736861646F773A20302031707820327078207267626128302C20302C20302C20302E31293B0A202020202020202020202020626F782D736861646F773A20302031707820327078207267626128302C20302C20302C20302E';
wwv_flow_api.g_varchar2_table(12) := '31293B0A202020207D0A0A202020202E612D50726F70657274792D6669656C643A666F637573207B0A202020206F75746C696E652D636F6C6F723A20233337374535353B0A20202020782D6261636B67726F756E642D636F6C6F723A2023464646464646';
wwv_flow_api.g_varchar2_table(13) := '3B0A202020202D7765626B69742D626F782D736861646F773A20302031707820327078207267626128302C20302C20302C20302E31293B0A202020202020202020202020626F782D736861646F773A20302031707820327078207267626128302C20302C';
wwv_flow_api.g_varchar2_table(14) := '20302C20302E31293B0A202020206F75746C696E652D6F66667365743A203270783B0A202020206F75746C696E652D77696474683A203270783B0A202020206F75746C696E652D7374796C653A20646F747465643B0A202020207D0A0A202020202E612D';
wwv_flow_api.g_varchar2_table(15) := '50726F70657274792E69732D6572726F722E69732D616374697665202E612D50726F70657274792D6669656C643A6E6F74282E612D50726F70657274792D6669656C642D2D7465787461726561293A666F637573207B0A202020202D7765626B69742D62';
wwv_flow_api.g_varchar2_table(16) := '6F782D736861646F773A20302030203020317078202345333531334320696E7365742C2030203170782032707820726762612835312C2035312C2035312C20302E31293B0A202020202020202020202020626F782D736861646F773A2030203020302031';
wwv_flow_api.g_varchar2_table(17) := '7078202345333531334320696E7365742C2030203170782032707820726762612835312C2035312C2035312C20302E31293B0A202020207D0A0A202020202E612D50726F70657274792E69732D736861646F772E69732D616374697665202E612D50726F';
wwv_flow_api.g_varchar2_table(18) := '70657274792D6669656C643A6E6F74282E612D50726F70657274792D6669656C642D2D7465787461726561293A666F637573207B0A202020202D7765626B69742D626F782D736861646F773A20302030203020317078202345333531334320696E736574';
wwv_flow_api.g_varchar2_table(19) := '2C2030203170782032707820726762612835312C2035312C2035312C20302E31293B0A202020202020202020202020626F782D736861646F773A20302030203020317078202345333531334320696E7365742C2030203170782032707820726762612835';
wwv_flow_api.g_varchar2_table(20) := '312C2035312C2035312C20302E31293B0A202020207D0A0A202020202E612D50726F70657274792E69732D7661726961626C65202E612D49636F6E2E69636F6E2D7661726961626C65207B0A20202020636F6C6F723A20233746424546323B0A20202020';
wwv_flow_api.g_varchar2_table(21) := '7D0A0A202020202E612D50726F70657274792E69732D7661726961626C65202E612D50726F70657274792D6669656C64207B0A202020202D7765626B69742D626F782D736861646F773A203020302030203170782072676261283132372C203139302C20';
wwv_flow_api.g_varchar2_table(22) := '3234322C20302E352920696E7365743B0A202020202020202020202020626F782D736861646F773A203020302030203170782072676261283132372C203139302C203234322C20302E352920696E7365743B0A20202020782D6261636B67726F756E642D';
wwv_flow_api.g_varchar2_table(23) := '636F6C6F723A20236633663966653B0A202020207D0A0A202020202E612D50726F70657274792E69732D7761726E696E67202E612D50726F70657274792D6669656C642D2D74657874617265613A666F637573207B0A20202020626F726465722D636F6C';
wwv_flow_api.g_varchar2_table(24) := '6F723A20234641434436322021696D706F7274616E743B0A202020207D0A0A202020202E612D50726F70657274792E69732D6572726F72202E612D50726F70657274792D6669656C642D2D74657874617265613A666F637573207B0A20202020626F7264';
wwv_flow_api.g_varchar2_table(25) := '65722D636F6C6F723A20234533353133432021696D706F7274616E743B0A202020207D0A0A202020202E612D50726F70657274792D627574746F6E436F6E7461696E6572202E612D427574746F6E207B0A202020206261636B67726F756E642D636F6C6F';
wwv_flow_api.g_varchar2_table(26) := '723A20234646464646463B0A202020207D0A0A202020202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D202B206C6162656C3A6265666F72652C0A202020202E612D50726F70657274792D72';
wwv_flow_api.g_varchar2_table(27) := '6164696F2D696E7075745B747970653D22726164696F225D202B206C6162656C3A6265666F7265207B0A202020206261636B67726F756E642D636F6C6F723A20234646464646463B0A20202020626F726465722D636F6C6F723A20234446444344383B0A';
wwv_flow_api.g_varchar2_table(28) := '202020207D0A0A202020202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A666F637573202B206C6162656C3A6265666F72652C0A202020202E612D50726F70657274792D636865636B626F';
wwv_flow_api.g_varchar2_table(29) := '782D696E7075745B747970653D22636865636B626F78225D3A696E64657465726D696E617465202B206C6162656C3A6265666F72652C0A202020202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D3A666F63';
wwv_flow_api.g_varchar2_table(30) := '7573202B206C6162656C3A6265666F72652C0A202020202E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D3A696E64657465726D696E617465202B206C6162656C3A6265666F7265207B0A20202020626F7264';
wwv_flow_api.g_varchar2_table(31) := '65722D636F6C6F723A20233337374535353B0A202020202D7765626B69742D626F782D736861646F773A207267626128302C20302C20302C20302E3129203020317078203170783B0A202020202020202020202020626F782D736861646F773A20726762';
wwv_flow_api.g_varchar2_table(32) := '6128302C20302C20302C20302E3129203020317078203170783B0A202020207D0A0A202020202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A666F6375733A636865636B6564202B206C61';
wwv_flow_api.g_varchar2_table(33) := '62656C3A6265666F72652C0A202020202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A666F6375733A696E64657465726D696E617465202B206C6162656C3A6265666F72652C0A20202020';
wwv_flow_api.g_varchar2_table(34) := '2E612D50726F70657274792D726164696F2D696E7075745B747970653D22726164696F225D3A666F6375733A636865636B6564202B206C6162656C3A6265666F72652C0A202020202E612D50726F70657274792D726164696F2D696E7075745B74797065';
wwv_flow_api.g_varchar2_table(35) := '3D22726164696F225D3A666F6375733A696E64657465726D696E617465202B206C6162656C3A6265666F7265207B0A20202020626F726465722D636F6C6F723A20233337374535353B0A202020206261636B67726F756E642D636F6C6F723A2023333737';
wwv_flow_api.g_varchar2_table(36) := '4535353B0A202020207D0A0A202020202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A696E64657465726D696E617465202B206C6162656C3A6265666F72652C202E612D50726F70657274';
wwv_flow_api.g_varchar2_table(37) := '792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A636865636B6564202B206C6162656C3A6265666F7265207B0A20202020626F726465722D636F6C6F723A20233637363035423B0A202020206261636B67726F756E64';
wwv_flow_api.g_varchar2_table(38) := '2D636F6C6F723A20233637363035423B0A202020207D0A0A202020202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A696E64657465726D696E617465202B206C6162656C3A616674657220';
wwv_flow_api.g_varchar2_table(39) := '7B0A202020206261636B67726F756E642D636F6C6F723A20234643464246413B0A202020207D0A0A202020202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D22636865636B626F78225D3A636865636B6564202B206C61';
wwv_flow_api.g_varchar2_table(40) := '62656C3A6166746572207B0A202020206261636B67726F756E642D696D6167653A2075726C28222E2E2F6173736574732F636865636B626F782D636865636B65642E73766722293B0A202020207D0A0A202020202E612D50726F70657274792D72616469';
wwv_flow_api.g_varchar2_table(41) := '6F2D696E7075745B747970653D22726164696F225D3A636865636B6564202B206C6162656C3A6265666F7265207B0A20202020626F726465722D636F6C6F723A20726762612831362C2031352C2031342C20302E36293B0A202020206261636B67726F75';
wwv_flow_api.g_varchar2_table(42) := '6E642D636F6C6F723A20726762612831362C2031352C2031342C20302E36293B0A202020207D0A0A202020202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075';
wwv_flow_api.g_varchar2_table(43) := '743A636865636B6564202B206C6162656C207B0A202020206261636B67726F756E642D636F6C6F723A20234446444344383B0A202020202D7765626B69742D626F782D736861646F773A20302030203020317078207267626128302C20302C20302C2030';
wwv_flow_api.g_varchar2_table(44) := '2E312920696E7365742C20302032707820317078207267626128302C20302C20302C20302E30352920696E7365743B0A202020202020202020202020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E3129';
wwv_flow_api.g_varchar2_table(45) := '20696E7365742C20302032707820317078207267626128302C20302C20302C20302E30352920696E7365743B0A202020207D0A0A202020202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274';
wwv_flow_api.g_varchar2_table(46) := '792D726164696F2D696E7075743A666F637573202B206C6162656C207B0A20202020626F726465722D636F6C6F723A20302031707820327078207267626128302C20302C20302C20302E31292021696D706F7274616E743B0A202020206261636B67726F';
wwv_flow_api.g_varchar2_table(47) := '756E642D636F6C6F723A20234446444344383B0A202020202D7765626B69742D626F782D736861646F773A2030203020302031707820302031707820327078207267626128302C20302C20302C20302E312920696E7365742C2030203170782032707820';
wwv_flow_api.g_varchar2_table(48) := '7267626128302C20302C20302C20302E31293B0A202020202020202020202020626F782D736861646F773A2030203020302031707820302031707820327078207267626128302C20302C20302C20302E312920696E7365742C2030203170782032707820';
wwv_flow_api.g_varchar2_table(49) := '7267626128302C20302C20302C20302E31293B0A202020207D0A0A202020202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A6E6F74283A636865636B65';
wwv_flow_api.g_varchar2_table(50) := '64293A686F766572202B206C6162656C207B0A202020202D7765626B69742D626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E31352920696E7365742C20302031707820327078207267626128302C20302C';
wwv_flow_api.g_varchar2_table(51) := '20302C20302E31293B0A202020202020202020202020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E31352920696E7365742C20302031707820327078207267626128302C20302C20302C20302E31293B';
wwv_flow_api.g_varchar2_table(52) := '0A202020207D0A0A202020202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A686F7665723A616374697665202B206C6162656C207B0A202020202D7765';
wwv_flow_api.g_varchar2_table(53) := '626B69742D626F782D736861646F773A2030203020302031707820302031707820327078207267626128302C20302C20302C20302E312920696E7365742C20302031707820327078207267626128302C20302C20302C20302E31293B0A20202020202020';
wwv_flow_api.g_varchar2_table(54) := '2020202020626F782D736861646F773A2030203020302031707820302031707820327078207267626128302C20302C20302C20302E312920696E7365742C20302031707820327078207267626128302C20302C20302C20302E31293B0A20202020626163';
wwv_flow_api.g_varchar2_table(55) := '6B67726F756E642D636F6C6F723A20234536453345303B0A202020207D0A0A202020202E612D50726F70657274792D636F6C6F7250726576696577207B0A202020202D7765626B69742D626F782D736861646F773A203020302030203170782072676261';
wwv_flow_api.g_varchar2_table(56) := '28302C20302C20302C20302E312920696E7365743B0A202020202020202020202020626F782D736861646F773A20302030203020317078207267626128302C20302C20302C20302E312920696E7365743B0A202020207D0A0A202020202E612D50726F70';
wwv_flow_api.g_varchar2_table(57) := '657274792E69732D6368616E676564202E612D50726F70657274792D6C6162656C436F6E7461696E65723A6265666F7265207B0A202020206261636B67726F756E642D636F6C6F723A20233337374535353B0A202020207D0A0A202020202E612D50726F';
wwv_flow_api.g_varchar2_table(58) := '7065727479456469746F72207B0A20202020782D6261636B67726F756E642D636F6C6F723A20234536453345303B0A202020207D0A0A202020202E75692D6469616C6F67202E612D50726F7065727479456469746F72207B0A20202020782D6261636B67';
wwv_flow_api.g_varchar2_table(59) := '726F756E642D636F6C6F723A207472616E73706172656E743B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D70726F706572747947726F75702C0A202020202E612D50726F7065727479456469746F722D70726F7065727479';
wwv_flow_api.g_varchar2_table(60) := '47726F75702D6865616465722C0A202020202E612D50726F7065727479456469746F722D70726F706572747947726F75702D626F6479207B0A20202020626F726465722D636F6C6F723A20234536453345303B0A202020207D0A0A202020202E612D5072';
wwv_flow_api.g_varchar2_table(61) := '6F7065727479456469746F722D70726F706572747947726F7570207B0A20202020782D6261636B67726F756E642D636F6C6F723A20234637463546333B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D70726F706572747947';
wwv_flow_api.g_varchar2_table(62) := '726F75703A666F6375732D77697468696E2C202E612D50726F7065727479456469746F722D70726F706572747947726F75702E6861732D666F637573207B0A20202020782D6261636B67726F756E642D636F6C6F723A2072676261283232342C20323435';
wwv_flow_api.g_varchar2_table(63) := '2C203231382C20302E33293B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572202E612D49636F6E207B0A20202020636F6C6F723A20234643464246413B0A20202020626163';
wwv_flow_api.g_varchar2_table(64) := '6B67726F756E642D636F6C6F723A20234138413239423B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D70726F706572747947726F75702D7469746C65207B0A20202020636F6C6F723A20233130304630453B0A202020207D';
wwv_flow_api.g_varchar2_table(65) := '0A0A202020202E612D50726F7065727479456469746F722D70726F706572747947726F75702D626F6479202E612D50726F7065727479207B0A20202020626F726465722D636F6C6F723A20234536453345303B0A202020207D0A0A202020202E612D5072';
wwv_flow_api.g_varchar2_table(66) := '6F7065727479456469746F722D70726F706572747947726F75702D6865616465722E69732D666F6375736564207B0A202020202D7765626B69742D626F782D736861646F773A20726762612835312C2035312C2035312C20302E31293B0A202020202020';
wwv_flow_api.g_varchar2_table(67) := '202020202020626F782D736861646F773A20726762612835312C2035312C2035312C20302E31293B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465722E69732D666F63757365';
wwv_flow_api.g_varchar2_table(68) := '64202E612D49636F6E207B0A20202020782D6261636B67726F756E642D636F6C6F723A20233337374535353B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D6D657373616765207B0A20202020636F6C6F723A207267626128';
wwv_flow_api.g_varchar2_table(69) := '31362C2031352C2031342C20302E36293B0A202020207D0A0A202020202E612D50726F7065727479456469746F722D6D65737361676554657874207B0A20202020636F6C6F723A20726762612831362C2031352C2031342C20302E38293B0A202020207D';
wwv_flow_api.g_varchar2_table(70) := '0A0A202020202E612D50726F70657274792D686967686C69676874207B0A202020206261636B67726F756E642D636F6C6F723A20234645454443333B0A202020202D7765626B69742D626F782D736861646F773A20302031707820317078202D31707820';
wwv_flow_api.g_varchar2_table(71) := '726762612835312C2035312C2035312C20302E31293B0A202020202020202020202020626F782D736861646F773A20302031707820317078202D31707820726762612835312C2035312C2035312C20302E31293B0A202020207D0A0A202020202E612D50';
wwv_flow_api.g_varchar2_table(72) := '726F70657274792D6E6F74466F756E64207B0A20202020636F6C6F723A20726762612831362C2031352C2031342C20302E36293B0A202020207D0A0A202020202E612D50726F706572747947726F75702D6974656D207B0A20202020626F726465722D74';
wwv_flow_api.g_varchar2_table(73) := '6F702D636F6C6F723A20234342433542463B0A202020207D0A7D';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(776882772926146573)
,p_plugin_id=>wwv_flow_api.id(776877005555146556)
,p_file_name=>'css/style.less'
,p_mime_type=>'text/plain'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C642D2D73656C6563747B6261636B67726F756E642D696D6167653A75726C282E2E2F6173736574732F73656C6563742D6172726F772E737667297D2E75742D5072';
wwv_flow_api.g_varchar2_table(2) := '6F7065727479456469746F72202E612D50726F70657274792E69732D6572726F72202E612D50726F70657274792D6C6162656C7B636F6C6F723A233130306630657D2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D';
wwv_flow_api.g_varchar2_table(3) := '6572726F72202E612D50726F70657274792D6669656C643A6E6F74283A666F637573297B636F6C6F723A236337343633347D2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D6572726F72202E69636F6E2D6572726F';
wwv_flow_api.g_varchar2_table(4) := '727B636F6C6F723A2363373436333421696D706F7274616E747D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6C6162656C2C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D736574497465';
wwv_flow_api.g_varchar2_table(5) := '6D734865616465722D6865616465722C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D756E69742C2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D7761726E696E67202E612D50726F';
wwv_flow_api.g_varchar2_table(6) := '70657274792D6C6162656C7B636F6C6F723A233130306630657D2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D7761726E696E67202E69636F6E2D7761726E696E677B636F6C6F723A2364383937346421696D706F';
wwv_flow_api.g_varchar2_table(7) := '7274616E747D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D6C6162656C2C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F7B636F6C6F723A7267626128';
wwv_flow_api.g_varchar2_table(8) := '31362C31352C31342C2E38297D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C647B782D6261636B67726F756E642D636F6C6F723A236663666266613B636F6C6F723A233130306630653B626F726465722D636F';
wwv_flow_api.g_varchar2_table(9) := '6C6F723A236536653365303B2D7765626B69742D626F782D736861646F773A302031707820327078207267626128302C302C302C2E31293B626F782D736861646F773A302031707820327078207267626128302C302C302C2E31297D2E75742D50726F70';
wwv_flow_api.g_varchar2_table(10) := '65727479456469746F72202E612D50726F70657274792D6669656C643A686F7665727B782D6261636B67726F756E642D636F6C6F723A236666663B2D7765626B69742D626F782D736861646F773A302031707820327078207267626128302C302C302C2E';
wwv_flow_api.g_varchar2_table(11) := '31293B626F782D736861646F773A302031707820327078207267626128302C302C302C2E31297D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6669656C643A666F6375737B6F75746C696E652D636F6C6F723A23333737';
wwv_flow_api.g_varchar2_table(12) := '6535353B782D6261636B67726F756E642D636F6C6F723A236666663B2D7765626B69742D626F782D736861646F773A302031707820327078207267626128302C302C302C2E31293B626F782D736861646F773A302031707820327078207267626128302C';
wwv_flow_api.g_varchar2_table(13) := '302C302C2E31293B6F75746C696E652D6F66667365743A3270783B6F75746C696E652D77696474683A3270783B6F75746C696E652D7374796C653A646F747465647D2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D';
wwv_flow_api.g_varchar2_table(14) := '6572726F722E69732D616374697665202E612D50726F70657274792D6669656C643A6E6F74282E612D50726F70657274792D6669656C642D2D7465787461726561293A666F6375732C2E75742D50726F7065727479456469746F72202E612D50726F7065';
wwv_flow_api.g_varchar2_table(15) := '7274792E69732D736861646F772E69732D616374697665202E612D50726F70657274792D6669656C643A6E6F74282E612D50726F70657274792D6669656C642D2D7465787461726561293A666F6375737B2D7765626B69742D626F782D736861646F773A';
wwv_flow_api.g_varchar2_table(16) := '302030203020317078202365333531336320696E7365742C30203170782032707820726762612835312C35312C35312C2E31293B626F782D736861646F773A302030203020317078202365333531336320696E7365742C30203170782032707820726762';
wwv_flow_api.g_varchar2_table(17) := '612835312C35312C35312C2E31297D2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D7661726961626C65202E612D49636F6E2E69636F6E2D7661726961626C657B636F6C6F723A233766626566327D2E75742D5072';
wwv_flow_api.g_varchar2_table(18) := '6F7065727479456469746F72202E612D50726F70657274792E69732D7661726961626C65202E612D50726F70657274792D6669656C647B2D7765626B69742D626F782D736861646F773A3020302030203170782072676261283132372C3139302C323432';
wwv_flow_api.g_varchar2_table(19) := '2C2E352920696E7365743B626F782D736861646F773A3020302030203170782072676261283132372C3139302C3234322C2E352920696E7365743B782D6261636B67726F756E642D636F6C6F723A236633663966657D2E75742D50726F70657274794564';
wwv_flow_api.g_varchar2_table(20) := '69746F72202E612D50726F70657274792E69732D7761726E696E67202E612D50726F70657274792D6669656C642D2D74657874617265613A666F6375737B626F726465722D636F6C6F723A2366616364363221696D706F7274616E747D2E75742D50726F';
wwv_flow_api.g_varchar2_table(21) := '7065727479456469746F72202E612D50726F70657274792E69732D6572726F72202E612D50726F70657274792D6669656C642D2D74657874617265613A666F6375737B626F726465722D636F6C6F723A2365333531336321696D706F7274616E747D2E75';
wwv_flow_api.g_varchar2_table(22) := '742D50726F7065727479456469746F72202E612D50726F70657274792D627574746F6E436F6E7461696E6572202E612D427574746F6E7B6261636B67726F756E642D636F6C6F723A236666667D2E75742D50726F7065727479456469746F72202E612D50';
wwv_flow_api.g_varchar2_table(23) := '726F70657274792D636865636B626F782D696E7075745B747970653D636865636B626F785D2B6C6162656C3A6265666F72652C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D72';
wwv_flow_api.g_varchar2_table(24) := '6164696F5D2B6C6162656C3A6265666F72657B6261636B67726F756E642D636F6C6F723A236666663B626F726465722D636F6C6F723A236466646364387D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F';
wwv_flow_api.g_varchar2_table(25) := '782D696E7075745B747970653D636865636B626F785D3A666F6375732B6C6162656C3A6265666F72652C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D636865636B626F';
wwv_flow_api.g_varchar2_table(26) := '785D3A696E64657465726D696E6174652B6C6162656C3A6265666F72652C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D726164696F5D3A666F6375732B6C6162656C3A626566';
wwv_flow_api.g_varchar2_table(27) := '6F72652C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D726164696F5D3A696E64657465726D696E6174652B6C6162656C3A6265666F72657B626F726465722D636F6C6F723A23';
wwv_flow_api.g_varchar2_table(28) := '3337376535353B2D7765626B69742D626F782D736861646F773A7267626128302C302C302C2E3129203020317078203170783B626F782D736861646F773A7267626128302C302C302C2E3129203020317078203170787D2E75742D50726F706572747945';
wwv_flow_api.g_varchar2_table(29) := '6469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D636865636B626F785D3A666F6375733A636865636B65642B6C6162656C3A6265666F72652C2E75742D50726F7065727479456469746F72202E612D50726F';
wwv_flow_api.g_varchar2_table(30) := '70657274792D636865636B626F782D696E7075745B747970653D636865636B626F785D3A666F6375733A696E64657465726D696E6174652B6C6162656C3A6265666F72652C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D';
wwv_flow_api.g_varchar2_table(31) := '726164696F2D696E7075745B747970653D726164696F5D3A666F6375733A636865636B65642B6C6162656C3A6265666F72652C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D72';
wwv_flow_api.g_varchar2_table(32) := '6164696F5D3A666F6375733A696E64657465726D696E6174652B6C6162656C3A6265666F72657B626F726465722D636F6C6F723A233337376535353B6261636B67726F756E642D636F6C6F723A233337376535357D2E75742D50726F7065727479456469';
wwv_flow_api.g_varchar2_table(33) := '746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D636865636B626F785D3A636865636B65642B6C6162656C3A6265666F72652C2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6368';
wwv_flow_api.g_varchar2_table(34) := '65636B626F782D696E7075745B747970653D636865636B626F785D3A696E64657465726D696E6174652B6C6162656C3A6265666F72657B626F726465722D636F6C6F723A233637363035623B6261636B67726F756E642D636F6C6F723A23363736303562';
wwv_flow_api.g_varchar2_table(35) := '7D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D636865636B626F785D3A696E64657465726D696E6174652B6C6162656C3A61667465727B6261636B67726F756E642D63';
wwv_flow_api.g_varchar2_table(36) := '6F6C6F723A236663666266617D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636865636B626F782D696E7075745B747970653D636865636B626F785D3A636865636B65642B6C6162656C3A61667465727B6261636B6772';
wwv_flow_api.g_varchar2_table(37) := '6F756E642D696D6167653A75726C282E2E2F6173736574732F636865636B626F782D636865636B65642E737667297D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F2D696E7075745B747970653D726164696F';
wwv_flow_api.g_varchar2_table(38) := '5D3A636865636B65642B6C6162656C3A6265666F72657B626F726465722D636F6C6F723A726762612831362C31352C31342C2E36293B6261636B67726F756E642D636F6C6F723A726762612831362C31352C31342C2E36297D2E75742D50726F70657274';
wwv_flow_api.g_varchar2_table(39) := '79456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A636865636B65642B6C6162656C7B6261636B67726F756E642D636F6C6F723A236466';
wwv_flow_api.g_varchar2_table(40) := '646364383B2D7765626B69742D626F782D736861646F773A302030203020317078207267626128302C302C302C2E312920696E7365742C302032707820317078207267626128302C302C302C2E30352920696E7365743B626F782D736861646F773A3020';
wwv_flow_api.g_varchar2_table(41) := '30203020317078207267626128302C302C302C2E312920696E7365742C302032707820317078207267626128302C302C302C2E30352920696E7365747D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F';
wwv_flow_api.g_varchar2_table(42) := '75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A666F6375732B6C6162656C7B626F726465722D636F6C6F723A302031707820327078207267626128302C302C302C2E312921696D706F7274616E743B6261';
wwv_flow_api.g_varchar2_table(43) := '636B67726F756E642D636F6C6F723A236466646364383B2D7765626B69742D626F782D736861646F773A30203020302031707820302031707820327078207267626128302C302C302C2E312920696E7365742C302031707820327078207267626128302C';
wwv_flow_api.g_varchar2_table(44) := '302C302C2E31293B626F782D736861646F773A30203020302031707820302031707820327078207267626128302C302C302C2E312920696E7365742C302031707820327078207267626128302C302C302C2E31297D2E75742D50726F7065727479456469';
wwv_flow_api.g_varchar2_table(45) := '746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164696F2D696E7075743A6E6F74283A636865636B6564293A686F7665722B6C6162656C7B2D7765626B69742D626F782D';
wwv_flow_api.g_varchar2_table(46) := '736861646F773A302030203020317078207267626128302C302C302C2E31352920696E7365742C302031707820327078207267626128302C302C302C2E31293B626F782D736861646F773A302030203020317078207267626128302C302C302C2E313529';
wwv_flow_api.g_varchar2_table(47) := '20696E7365742C302031707820327078207267626128302C302C302C2E31297D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D726164696F47726F75702D2D627574746F6E536574202E612D50726F70657274792D726164';
wwv_flow_api.g_varchar2_table(48) := '696F2D696E7075743A686F7665723A6163746976652B6C6162656C7B2D7765626B69742D626F782D736861646F773A30203020302031707820302031707820327078207267626128302C302C302C2E312920696E7365742C302031707820327078207267';
wwv_flow_api.g_varchar2_table(49) := '626128302C302C302C2E31293B626F782D736861646F773A30203020302031707820302031707820327078207267626128302C302C302C2E312920696E7365742C302031707820327078207267626128302C302C302C2E31293B6261636B67726F756E64';
wwv_flow_api.g_varchar2_table(50) := '2D636F6C6F723A236536653365307D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D636F6C6F72507265766965777B2D7765626B69742D626F782D736861646F773A302030203020317078207267626128302C302C302C2E';
wwv_flow_api.g_varchar2_table(51) := '312920696E7365743B626F782D736861646F773A302030203020317078207267626128302C302C302C2E312920696E7365747D2E75742D50726F7065727479456469746F72202E612D50726F70657274792E69732D6368616E676564202E612D50726F70';
wwv_flow_api.g_varchar2_table(52) := '657274792D6C6162656C436F6E7461696E65723A6265666F72657B6261636B67726F756E642D636F6C6F723A233337376535357D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F727B782D6261636B67726F756E';
wwv_flow_api.g_varchar2_table(53) := '642D636F6C6F723A236536653365307D2E75742D50726F7065727479456469746F72202E75692D6469616C6F67202E612D50726F7065727479456469746F727B782D6261636B67726F756E642D636F6C6F723A7472616E73706172656E747D2E75742D50';
wwv_flow_api.g_varchar2_table(54) := '726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702C2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D626F64';
wwv_flow_api.g_varchar2_table(55) := '792C2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465727B626F726465722D636F6C6F723A236536653365307D2E75742D50726F7065727479456469746F7220';
wwv_flow_api.g_varchar2_table(56) := '2E612D50726F7065727479456469746F722D70726F706572747947726F75707B782D6261636B67726F756E642D636F6C6F723A236637663566337D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F70';
wwv_flow_api.g_varchar2_table(57) := '6572747947726F75702E6861732D666F6375732C2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75703A666F6375732D77697468696E7B782D6261636B67726F756E642D636F6C';
wwv_flow_api.g_varchar2_table(58) := '6F723A72676261283232342C3234352C3231382C2E33297D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D686561646572202E612D49636F6E7B636F6C6F723A23666366';
wwv_flow_api.g_varchar2_table(59) := '6266613B6261636B67726F756E642D636F6C6F723A236138613239627D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D7469746C657B636F6C6F723A233130306630657D';
wwv_flow_api.g_varchar2_table(60) := '2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D626F6479202E612D50726F70657274797B626F726465722D636F6C6F723A236536653365307D2E75742D50726F70657274';
wwv_flow_api.g_varchar2_table(61) := '79456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465722E69732D666F63757365647B2D7765626B69742D626F782D736861646F773A726762612835312C35312C35312C2E31293B626F782D73';
wwv_flow_api.g_varchar2_table(62) := '6861646F773A726762612835312C35312C35312C2E31297D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D70726F706572747947726F75702D6865616465722E69732D666F6375736564202E612D49636F6E';
wwv_flow_api.g_varchar2_table(63) := '7B782D6261636B67726F756E642D636F6C6F723A233337376535357D2E75742D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D6D6573736167657B636F6C6F723A726762612831362C31352C31342C2E36297D2E7574';
wwv_flow_api.g_varchar2_table(64) := '2D50726F7065727479456469746F72202E612D50726F7065727479456469746F722D6D657373616765546578747B636F6C6F723A726762612831362C31352C31342C2E38297D2E75742D50726F7065727479456469746F72202E612D50726F7065727479';
wwv_flow_api.g_varchar2_table(65) := '2D686967686C696768747B6261636B67726F756E642D636F6C6F723A236665656463333B2D7765626B69742D626F782D736861646F773A302031707820317078202D31707820726762612835312C35312C35312C2E31293B626F782D736861646F773A30';
wwv_flow_api.g_varchar2_table(66) := '2031707820317078202D31707820726762612835312C35312C35312C2E31297D2E75742D50726F7065727479456469746F72202E612D50726F70657274792D6E6F74466F756E647B636F6C6F723A726762612831362C31352C31342C2E36297D2E75742D';
wwv_flow_api.g_varchar2_table(67) := '50726F7065727479456469746F72202E612D50726F706572747947726F75702D6974656D7B626F726465722D746F702D636F6C6F723A236362633562667D0A2F2A2320736F757263654D617070696E6755524C3D7374796C652E6373732E6D61702A2F';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(776883123310146574)
,p_plugin_id=>wwv_flow_api.id(776877005555146556)
,p_file_name=>'css/style.min.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '77696E646F772E617065782E7468656D65343264656D6F203D20617065782E7468656D65343264656D6F207C7C207B7D3B0A0A617065782E7468656D65343264656D6F2E696E69745072657669657754656D706C6174654F7074696F6E73203D2066756E';
wwv_flow_api.g_varchar2_table(2) := '6374696F6E2873656C6563746F722C206461746129207B0A202020200A202020206C657420656C656D656E74243B0A202020206C6574207472793124203D202428602E6C746F247B646174612E636F6D706F6E656E7449647D5F3160293B0A202020206C';
wwv_flow_api.g_varchar2_table(3) := '6574207472793024203D202428602E6C746F247B646174612E636F6D706F6E656E7449647D5F3060293B0A2020202069662874727931242E6C656E677468297B0A2020202020202020656C656D656E7424203D2074727931243B0A202020207D20656C73';
wwv_flow_api.g_varchar2_table(4) := '65207B0A2020202020202020656C656D656E7424203D2074727930243B0A202020207D0A0A20202020617065782E74656D706C6174654F7074696F6E7348656C7065722E61646447656E6572616C50726F70657274795479706528293B0A0A2020202063';
wwv_flow_api.g_varchar2_table(5) := '6F6E73742070726F70657274696573203D20617065782E74656D706C6174654F7074696F6E7348656C7065722E67657450726F70657274696573280A2020202020202020646174612C0A202020202020202028646174612E63757272656E7456616C7565';
wwv_flow_api.g_varchar2_table(6) := '73207C7C202727292E73706C697428273A27290A20202020293B0A0A20202020242873656C6563746F72292E70726F7065727479456469746F72287B0A2020202020202020646174613A207B0A20202020202020202020202070726F7065727479536574';
wwv_flow_api.g_varchar2_table(7) := '3A205B7B0A20202020202020202020202020202020646973706C617947726F757049643A2022636F6D6D6F6E222C0A20202020202020202020202020202020646973706C617947726F75705469746C653A2027436F6D6D6F6E272C0A2020202020202020';
wwv_flow_api.g_varchar2_table(8) := '202020202020202070726F706572746965733A2070726F706572746965732E636F6D6D6F6E0A2020202020202020202020207D2C207B0A20202020202020202020202020202020646973706C617947726F757049643A2022616476616E636564222C0A20';
wwv_flow_api.g_varchar2_table(9) := '202020202020202020202020202020646973706C617947726F75705469746C653A2027416476616E636564272C0A2020202020202020202020202020202070726F706572746965733A2070726F706572746965732E616476616E6365640A202020202020';
wwv_flow_api.g_varchar2_table(10) := '2020202020207D5D0A20202020202020207D2C0A20202020202020206368616E67653A2066756E6374696F6E2028704576656E742C20704461746129207B0A20202020202020202020202076617220676574436C6173736573203D2066756E6374696F6E';
wwv_flow_api.g_varchar2_table(11) := '202876616C756529207B0A202020202020202020202020202020207661722068617344656661756C74203D2066616C73653B0A2020202020202020202020202020202076617220636C6173736573203D202876616C7565207C7C202222292E73706C6974';
wwv_flow_api.g_varchar2_table(12) := '28223A22292E66696C7465722866756E6374696F6E2028636C6173734E616D6529207B0A202020202020202020202020202020202020202069662028636C6173734E616D65203D3D3D20222344454641554C54232229207B0A2020202020202020202020';
wwv_flow_api.g_varchar2_table(13) := '2020202020202020202020202068617344656661756C74203D20747275653B0A20202020202020202020202020202020202020202020202072657475726E2066616C73653B0A20202020202020202020202020202020202020207D0A2020202020202020';
wwv_flow_api.g_varchar2_table(14) := '20202020202020202020202072657475726E20747275653B0A202020202020202020202020202020207D292E6A6F696E28222022293B0A202020202020202020202020202020206966202868617344656661756C7429207B0A2020202020202020202020';
wwv_flow_api.g_varchar2_table(15) := '202020202020202020636C6173736573202B3D20222022202B20646174612E64656661756C7456616C7565732E6A6F696E28222022293B0A202020202020202020202020202020207D0A2020202020202020202020202020202072657475726E20636C61';
wwv_flow_api.g_varchar2_table(16) := '737365733B0A2020202020202020202020207D3B0A202020202020202020202020766172206170706C795374617475735374796C696E67203D2066756E6374696F6E202829207B0A20202020202020202020202020202020766172206170706C79537461';
wwv_flow_api.g_varchar2_table(17) := '747573546F50726F7065727479203D2066756E6374696F6E202870726F70657274792429207B0A20202020202020202020202020202020202020206966202870446174612E70726F70657274792E76616C7565203D3D3D2070446174612E70726F706572';
wwv_flow_api.g_varchar2_table(18) := '74792E6F726967696E616C56616C756529207B0A20202020202020202020202020202020202020202020202070726F7065727479242E72656D6F7665436C617373282269732D6368616E67656422292E72656D6F7665436C61737328226861732D776172';
wwv_flow_api.g_varchar2_table(19) := '6E696E6722293B0A20202020202020202020202020202020202020207D20656C7365207B0A20202020202020202020202020202020202020202020202070726F7065727479242E616464436C617373282269732D6368616E67656422293B0A2020202020';
wwv_flow_api.g_varchar2_table(20) := '202020202020202020202020202020202020206966202870446174612E70726F70657274792E72657175697265735F72656C6F616429207B0A2020202020202020202020202020202020202020202020202020202070726F7065727479242E616464436C';
wwv_flow_api.g_varchar2_table(21) := '61737328226861732D7761726E696E6722293B0A2020202020202020202020202020202020202020202020207D0A20202020202020202020202020202020202020207D0A202020202020202020202020202020207D3B0A20202020202020202020202020';
wwv_flow_api.g_varchar2_table(22) := '2020206170706C79537461747573546F50726F70657274792870446174612E70726F706572747924293B0A2020202020202020202020207D3B0A202020202020202020202020766172206E6577436C6173736573203D20676574436C6173736573287044';
wwv_flow_api.g_varchar2_table(23) := '6174612E70726F70657274792E76616C7565293B0A202020202020202020202020766172206F6C64436C6173736573203D20676574436C61737365732870446174612E70726576696F757356616C7565293B0A2020202020202020202020206170706C79';
wwv_flow_api.g_varchar2_table(24) := '5374617475735374796C696E6728293B0A202020202020202020202020656C656D656E74242E72656D6F7665436C617373286F6C64436C6173736573293B0A202020202020202020202020656C656D656E74242E616464436C617373286E6577436C6173';
wwv_flow_api.g_varchar2_table(25) := '736573293B0A20202020202020207D0A202020207D293B0A0A7D3B0A';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(776883506609146574)
,p_plugin_id=>wwv_flow_api.id(776877005555146556)
,p_file_name=>'js/script.js'
,p_mime_type=>'application/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '7B2276657273696F6E223A332C22736F7572636573223A5B227363726970742E6A73225D2C226E616D6573223A5B2277696E646F77222C2261706578222C227468656D65343264656D6F222C22696E69745072657669657754656D706C6174654F707469';
wwv_flow_api.g_varchar2_table(2) := '6F6E73222C2273656C6563746F72222C2264617461222C22656C656D656E7424222C227472793124222C2224222C22636F6D706F6E656E744964222C227472793024222C226C656E677468222C2274656D706C6174654F7074696F6E7348656C70657222';
wwv_flow_api.g_varchar2_table(3) := '2C2261646447656E6572616C50726F706572747954797065222C2270726F70657274696573222C2267657450726F70657274696573222C2263757272656E7456616C756573222C2273706C6974222C2270726F7065727479456469746F72222C2270726F';
wwv_flow_api.g_varchar2_table(4) := '7065727479536574222C22646973706C617947726F75704964222C22646973706C617947726F75705469746C65222C22636F6D6D6F6E222C22616476616E636564222C226368616E6765222C22704576656E74222C227044617461222C2270726F706572';
wwv_flow_api.g_varchar2_table(5) := '747924222C22676574436C6173736573222C2276616C7565222C2268617344656661756C74222C22636C6173736573222C2266696C746572222C22636C6173734E616D65222C226A6F696E222C2264656661756C7456616C756573222C226E6577436C61';
wwv_flow_api.g_varchar2_table(6) := '73736573222C2270726F7065727479222C226F6C64436C6173736573222C2270726576696F757356616C7565222C226F726967696E616C56616C7565222C2272656D6F7665436C617373222C22616464436C617373222C2272657175697265735F72656C';
wwv_flow_api.g_varchar2_table(7) := '6F6164225D2C226D617070696E6773223A2241414141412C4F41414F432C4B41414B432C59414163442C4B41414B432C614141652C4741453943442C4B41414B432C59414159432C3242414136422C53414153432C45414155432C47414537442C494141';
wwv_flow_api.g_varchar2_table(8) := '49432C45414341432C45414151432C454141452C4F41414F482C4541414B492C694241437442432C45414151462C454141452C4F41414F482C4541414B492C694241457442482C45414444432C4541414D492C4F41434D4A2C45414541472C4541476654';
wwv_flow_api.g_varchar2_table(9) := '2C4B41414B572C734241417342432C7942414533422C4D41414D432C45414161622C4B41414B572C734241417342472C6341433143562C47414343412C4541414B572C65414169422C49414149432C4D41414D2C4D41477243542C454141454A2C474141';
wwv_flow_api.g_varchar2_table(10) := '55632C654141652C4341437642622C4B41414D2C43414346632C594141612C434141432C43414356432C65414167422C5341436842432C6B4241416D422C5341436E42502C57414159412C45414157512C51414378422C43414343462C65414167422C57';
wwv_flow_api.g_varchar2_table(11) := '41436842432C6B4241416D422C5741436E42502C57414159412C45414157532C5941472F42432C4F4141512C53414155432C45414151432C47414374422C4941653043432C4541667443432C454141612C53414155432C47414376422C49414149432C47';
wwv_flow_api.g_varchar2_table(12) := '4141612C45414362432C47414157462C474141532C494141495A2C4D41414D2C4B41414B652C5141414F2C53414155432C47414370442C4D41416B422C63414164412C49414341482C474141612C4741434E2C4D41475A492C4B41414B2C4B4149522C4F';
wwv_flow_api.g_varchar2_table(13) := '4148494A2C49414341432C474141572C4941414D31422C4541414B38422C63414163442C4B41414B2C4D41457443482C474165504B2C45414161522C45414157462C4541414D572C53414153522C4F41437643532C45414161562C45414157462C454141';
wwv_flow_api.g_varchar2_table(14) := '4D612C654162515A2C4541556842442C4541414D432C5541547042442C4541414D572C53414153522C51414155482C4541414D572C53414153472C6341437843622C45414155632C594141592C63414163412C594141592C674241456844642C45414155';
wwv_flow_api.g_varchar2_table(15) := '652C534141532C6341436668422C4541414D572C534141534D2C694241436668422C45414155652C534141532C674241536E4370432C454141536D432C59414159482C474143724268432C454141536F432C534141534E222C2266696C65223A22736372';
wwv_flow_api.g_varchar2_table(16) := '6970742E6A73227D';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(776883900720146574)
,p_plugin_id=>wwv_flow_api.id(776877005555146556)
,p_file_name=>'js/script.js.map'
,p_mime_type=>'application/json'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '77696E646F772E617065782E7468656D65343264656D6F3D617065782E7468656D65343264656D6F7C7C7B7D2C617065782E7468656D65343264656D6F2E696E69745072657669657754656D706C6174654F7074696F6E733D66756E6374696F6E28652C';
wwv_flow_api.g_varchar2_table(2) := '72297B6C657420612C6F3D2428602E6C746F247B722E636F6D706F6E656E7449647D5F3160292C703D2428602E6C746F247B722E636F6D706F6E656E7449647D5F3060293B613D6F2E6C656E6774683F6F3A702C617065782E74656D706C6174654F7074';
wwv_flow_api.g_varchar2_table(3) := '696F6E7348656C7065722E61646447656E6572616C50726F70657274795479706528293B636F6E737420743D617065782E74656D706C6174654F7074696F6E7348656C7065722E67657450726F7065727469657328722C28722E63757272656E7456616C';
wwv_flow_api.g_varchar2_table(4) := '7565737C7C2222292E73706C697428223A2229293B242865292E70726F7065727479456469746F72287B646174613A7B70726F70657274795365743A5B7B646973706C617947726F757049643A22636F6D6D6F6E222C646973706C617947726F75705469';
wwv_flow_api.g_varchar2_table(5) := '746C653A22436F6D6D6F6E222C70726F706572746965733A742E636F6D6D6F6E7D2C7B646973706C617947726F757049643A22616476616E636564222C646973706C617947726F75705469746C653A22416476616E636564222C70726F70657274696573';
wwv_flow_api.g_varchar2_table(6) := '3A742E616476616E6365647D5D7D2C6368616E67653A66756E6374696F6E28652C6F297B76617220702C743D66756E6374696F6E2865297B76617220613D21312C6F3D28657C7C2222292E73706C697428223A22292E66696C746572282866756E637469';
wwv_flow_api.g_varchar2_table(7) := '6F6E2865297B72657475726E222344454641554C542322213D3D657C7C28613D21302C2131297D29292E6A6F696E28222022293B72657475726E20612626286F2B3D2220222B722E64656661756C7456616C7565732E6A6F696E2822202229292C6F7D2C';
wwv_flow_api.g_varchar2_table(8) := '6E3D74286F2E70726F70657274792E76616C7565292C693D74286F2E70726576696F757356616C7565293B703D6F2E70726F7065727479242C6F2E70726F70657274792E76616C75653D3D3D6F2E70726F70657274792E6F726967696E616C56616C7565';
wwv_flow_api.g_varchar2_table(9) := '3F702E72656D6F7665436C617373282269732D6368616E67656422292E72656D6F7665436C61737328226861732D7761726E696E6722293A28702E616464436C617373282269732D6368616E67656422292C6F2E70726F70657274792E72657175697265';
wwv_flow_api.g_varchar2_table(10) := '735F72656C6F61642626702E616464436C61737328226861732D7761726E696E672229292C612E72656D6F7665436C6173732869292C612E616464436C617373286E297D7D297D3B0A2F2F2320736F757263654D617070696E6755524C3D736372697074';
wwv_flow_api.g_varchar2_table(11) := '2E6A732E6D6170';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(776884396196146574)
,p_plugin_id=>wwv_flow_api.id(776877005555146556)
,p_file_name=>'js/script.min.js'
,p_mime_type=>'application/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_disp_template_options
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(808180558331983447)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_display_name=>'Display Template Options'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function is_default (',
'  p_template_type   in varchar2,',
'  p_template_name   in varchar2,',
'  p_css             in varchar2',
') return varchar2',
'is',
'    l_vc_arr2       APEX_APPLICATION_GLOBAL.VC_ARR2;',
'    stmt            varchar2(4000);',
'    l_table_name    varchar2(255);',
'    l_def_opt       varchar2(255);',
'    l_preset_opt    varchar2(255);',
'    l_flag          varchar2(1) := ''N'';',
'    ',
'begin',
'',
'  if p_template_type = ''REGION'' then',
'    l_table_name := ''APEX_APPLICATION_TEMP_REGION'';',
'  elsif p_template_type = ''BUTTON'' then',
'    l_table_name := ''APEX_APPLICATION_TEMP_BUTTON'';',
'  elsif p_template_type = ''PAGE'' then',
'    l_table_name := ''APEX_APPLICATION_TEMP_PAGE'';',
'  elsif p_template_type = ''REPORT'' then',
'    l_table_name := ''APEX_APPLICATION_TEMP_REPORT'';',
'  elsif p_template_type = ''FIELD'' then',
'    l_table_name := ''APEX_APPLICATION_TEMP_LABEL'';',
'  elsif p_template_type = ''LIST'' then',
'    l_table_name := ''APEX_APPLICATION_TEMP_LIST'';',
'  end if;',
'    ',
'  stmt := ''begin ',
'            select default_template_options, preset_template_options ',
'              into :into_bind_default, :into_bind_preset  from  '' ',
'                || l_table_name ',
'                || '' where template_name = :bind_name and application_id = ''||v(''APP_ID'')||''; end;'';',
'  ',
'   execute immediate stmt',
'               using out l_def_opt,',
'                     out l_preset_opt, ',
'                      IN p_template_name;',
'',
'    ',
'    if l_def_opt = p_css then',
'      l_flag :=''Y'';',
'    else',
'      l_vc_arr2 := APEX_UTIL.STRING_TO_TABLE(l_preset_opt);',
'      FOR z IN 1..l_vc_arr2.count LOOP',
'          if p_css = l_vc_arr2(z) then',
'            l_flag := ''Y'';',
'          end if;',
'      END LOOP;',
'    end if;',
'    ',
'    return l_flag;',
'    ',
'    exception when others then return ''N'';',
'    ',
'end is_default;',
'',
'',
'FUNCTION render(',
'    p_region              IN apex_plugin.t_region,',
'    p_plugin              IN apex_plugin.t_plugin,',
'    p_is_printer_friendly IN BOOLEAN )',
'  RETURN apex_plugin.t_region_render_result',
'IS',
'  p_template_type               varchar2(100) := p_region.attribute_01;',
'  p_template_name               varchar2(100) := COALESCE( p_region.attribute_02,',
'                                                           p_region.attribute_03,',
'                                                           p_region.attribute_04,',
'                                                           p_region.attribute_05,',
'                                                           p_region.attribute_06,',
'                                                           p_region.attribute_07);',
'  l_output_li                   clob;',
'  l_advanced_html               varchar2(100);',
'  l_advanced_class              varchar2(100);',
'  l_is_default_class            varchar2(100);',
'  l_default_icon                varchar2(100);',
'  l_general_icon                varchar2(100);',
'',
'  l_is_default                  varchar2(1);',
'  is_postfix_added              boolean := false;',
'  is_default_added_for_global   boolean := false;',
'  is_default_found              boolean := false;',
'  is_outside_set                boolean := true;',
'  l_rows                        clob;',
'',
'BEGIN',
'',
'    for c1 in ( select distinct',
'                    o.application_id,',
'                    nvl(g.display_name, ''General'') as group_name,',
'                    nvl(g.display_sequence, 0) display_sequence,',
'                    nvl(g.is_advanced, ''N'') is_advanced,',
'                    ''N'' as is_global,',
'                    g.null_text as default_text,',
'                    g.help_text,',
'                    o.group_id',
'                from apex_appl_template_options o,',
'                    apex_appl_template_opt_groups g',
'                where o.application_id = v(''APP_ID'')',
'                    and o.group_id         = g.template_opt_group_id (+)',
'                    and o.theme_number     = 42',
'                    and case p_template_type',
'                            when ''BUTTON'' then o.button_template',
'                            when ''REPORT'' then o.report_template',
'                            when ''REGION'' then o.region_template',
'                            when ''LIST''   then o.list_template',
'                            when ''PAGE''   then o.page_template',
'                        end = p_template_name',
'                union all',
'                select distinct',
'                    o.application_id,',
'                    nvl(g.display_name, ''General'') as group_name,',
'                    nvl(g.display_sequence, 0) display_sequence,',
'                    nvl(g.is_advanced, ''N'') is_advanced,',
'                    ''Y'' as is_global,',
'                    g.null_text as default_text,',
'                    g.help_text,',
'                    o.group_id',
'                from apex_appl_template_options o,',
'                    apex_appl_template_opt_groups g',
'                where o.application_id   = v(''APP_ID'')',
'                    and o.group_id = g.template_opt_group_id (+)',
'                    and o.theme_number = 42',
'                    and virtual_template_id is null',
'                    and o.template_types = p_template_type',
'                order by is_advanced,',
'                    display_sequence,',
'                    group_name ) loop',
'        -- Are we advanced?',
'        if c1.is_advanced = ''Y'' then',
'            l_advanced_html    := ''<span class="dm-TO-groupType">Advanced</span>'';',
'            l_advanced_class   := '' is-advanced'';',
'        end if;',
'        -- Emit the header',
'        l_output_li := l_output_li||''<li class="dm-TO-group''||l_advanced_class||'' row">',
'            <div class="dm-TO-info col col-4">''||l_advanced_html||',
'            ''<h3 class="dm-TO-groupTitle">''||c1.group_name||''</h3>',
'            <p class="dm-TO-groupDesc">'' || c1.help_text || ''</p>',
'            </div><div class="dm-TO-body col col-8">',
'            <ul class="dm-TO-optionsList container">'';',
'',
'        -- Do the rows',
'        is_default_found := false;',
'        l_rows           := null;',
'',
'        for c2 in ( select case p_template_type',
'                            when ''BUTTON'' then button_template',
'                            when ''REPORT'' then report_template',
'                            when ''FIELD''  then field_template',
'                            when ''REGION'' then region_template',
'                            when ''LIST''   then list_template',
'                            when ''PAGE''   then page_template',
'                        end as template_type,',
'                        o.display_name,',
'                        o.css_classes,',
'                        o.help_text,',
'                        nvl(o.display_sequence, 0) display_sequence',
'                    from apex_appl_template_options o',
'                    where o.application_id = c1.application_id',
'                        and o.theme_number = 42',
'                        and case p_template_type',
'                                when ''BUTTON'' then o.button_template',
'                                when ''REPORT'' then o.report_template',
'                                when ''REGION'' then o.region_template',
'                                when ''LIST''   then o.list_template',
'                                when ''PAGE''   then o.page_template',
'                            end = p_template_name',
'                        and ( (c1.group_id is null and o.group_id is null)',
'                            or o.group_id = c1.group_id )',
'                    union all',
'                    select ''Global'' as template_type,',
'                        o.display_name,',
'                        o.css_classes,',
'                        o.help_text,',
'                        nvl(o.display_sequence, 0) display_sequence',
'                    from apex_appl_template_options o',
'                    where o.application_id = c1.application_id',
'                        and o.theme_number = 42',
'                        and o.virtual_template_id is null',
'                        and o.template_types = p_template_type',
'                        and ( (c1.group_id is null and o.group_id is null)',
'                            or o.group_id = c1.group_id )',
'                    order by display_sequence ) loop',
'                    ',
'            if is_default(p_template_type, c2.template_type, c2.css_classes) = ''Y'' then',
'                is_default_found    := true;',
'                l_is_default_class  := ''is-default'';',
'                l_default_icon      := ''<span class="t-Icon fa fa-check-circle"></span>'';',
'                l_general_icon      := null;',
'            else',
'                l_is_default_class  := null;',
'                l_default_icon      := null;',
'                if c1.group_name = ''General'' then',
'                  l_general_icon    := ''<span class="t-Icon fa fa-square-o"></span>'';',
'                else',
'                  l_general_icon := null;',
'                end if;',
'            end if;',
'            ',
'            l_rows := l_rows || ''<li class="dm-TO-options '' || l_is_default_class || '' row">',
'                                <div class="dm-TO-option col col-4">'' || l_default_icon || l_general_icon || c2.display_name || ''</div>',
'                                <div class="dm-TO-desc col col-8">'' || c2.help_text ||''</div>',
'                              </li>'';',
'        end loop;',
'',
'        if is_default_found = false then',
'            if c1.default_text is not null then',
'                l_rows := ''<li class="dm-TO-options is-default row">',
'                                <div class="dm-TO-option col col-4"><span class="t-Icon fa fa-check-circle"></span>'' || c1.default_text || ''</div>',
'                                <div class="dm-TO-desc col col-8"></div>',
'                              </li>'' || l_rows;',
'            else',
'                l_rows := ''<li class="dm-TO-options is-default row">',
'                    <div class="dm-TO-option col col-4"><span class="t-Icon fa fa-check-square"></span>Use Template Defaults</div>',
'                    <div class="dm-TO-desc col col-8"></div>',
'                  </li>'' || l_rows;',
'            end if;',
'        end if;',
'            ',
'        l_output_li := l_output_li || l_rows;',
'        l_output_li := l_output_li || ''</ul></div></li>'';',
'    end loop;',
'',
'    sys.htp.p(''<div class="dm-TO"><ul class="dm-TO-list container">'' || l_output_li || ''</ul></div>'');',
'    return null;',
'END render;',
''))
,p_api_version=>1
,p_render_function=>'render'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(823033390057708888)
,p_plugin_id=>wwv_flow_api.id(808180558331983447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Template Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUTTON'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823037512102740417)
,p_plugin_attribute_id=>wwv_flow_api.id(823033390057708888)
,p_display_sequence=>10
,p_display_value=>'BUTTON'
,p_return_value=>'BUTTON'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823037950320740869)
,p_plugin_attribute_id=>wwv_flow_api.id(823033390057708888)
,p_display_sequence=>20
,p_display_value=>'REPORT'
,p_return_value=>'REPORT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823039524085771184)
,p_plugin_attribute_id=>wwv_flow_api.id(823033390057708888)
,p_display_sequence=>30
,p_display_value=>'FIELD'
,p_return_value=>'FIELD'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823039954491771597)
,p_plugin_attribute_id=>wwv_flow_api.id(823033390057708888)
,p_display_sequence=>40
,p_display_value=>'REGION'
,p_return_value=>'REGION'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823040360957772040)
,p_plugin_attribute_id=>wwv_flow_api.id(823033390057708888)
,p_display_sequence=>50
,p_display_value=>'LIST'
,p_return_value=>'LIST'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823040752870772577)
,p_plugin_attribute_id=>wwv_flow_api.id(823033390057708888)
,p_display_sequence=>60
,p_display_value=>'PAGE'
,p_return_value=>'PAGE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(823034000947718905)
,p_plugin_id=>wwv_flow_api.id(808180558331983447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Region'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'Alert'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(823033390057708888)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'REGION'
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823038953543763025)
,p_plugin_attribute_id=>wwv_flow_api.id(823034000947718905)
,p_display_sequence=>10
,p_display_value=>'Alert'
,p_return_value=>'Alert'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823045746594845103)
,p_plugin_attribute_id=>wwv_flow_api.id(823034000947718905)
,p_display_sequence=>20
,p_display_value=>'Hero'
,p_return_value=>'Hero'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(212180175634127842)
,p_plugin_attribute_id=>wwv_flow_api.id(823034000947718905)
,p_display_sequence=>21
,p_display_value=>'Inline Drawer'
,p_return_value=>'Inline Drawer'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(210194939364690813)
,p_plugin_attribute_id=>wwv_flow_api.id(823034000947718905)
,p_display_sequence=>25
,p_display_value=>'Inline Popup'
,p_return_value=>'Inline Popup'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823046182555845862)
,p_plugin_attribute_id=>wwv_flow_api.id(823034000947718905)
,p_display_sequence=>30
,p_display_value=>'Inline Dialog'
,p_return_value=>'Inline Dialog'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823046581875846577)
,p_plugin_attribute_id=>wwv_flow_api.id(823034000947718905)
,p_display_sequence=>40
,p_display_value=>'Collapsible'
,p_return_value=>'Collapsible'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823046918104847089)
,p_plugin_attribute_id=>wwv_flow_api.id(823034000947718905)
,p_display_sequence=>50
,p_display_value=>'Buttons Container'
,p_return_value=>'Buttons Container'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823047490234847725)
,p_plugin_attribute_id=>wwv_flow_api.id(823034000947718905)
,p_display_sequence=>60
,p_display_value=>'Tabs Container'
,p_return_value=>'Tabs Container'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823047835559848224)
,p_plugin_attribute_id=>wwv_flow_api.id(823034000947718905)
,p_display_sequence=>70
,p_display_value=>'Title Bar'
,p_return_value=>'Title Bar'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823048227162848609)
,p_plugin_attribute_id=>wwv_flow_api.id(823034000947718905)
,p_display_sequence=>80
,p_display_value=>'Standard'
,p_return_value=>'Standard'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823048697502849086)
,p_plugin_attribute_id=>wwv_flow_api.id(823034000947718905)
,p_display_sequence=>90
,p_display_value=>'Carousel Container'
,p_return_value=>'Carousel Container'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823049069689849527)
,p_plugin_attribute_id=>wwv_flow_api.id(823034000947718905)
,p_display_sequence=>100
,p_display_value=>'Interactive Report'
,p_return_value=>'Interactive Report'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823049510693850101)
,p_plugin_attribute_id=>wwv_flow_api.id(823034000947718905)
,p_display_sequence=>110
,p_display_value=>'Wizard Container'
,p_return_value=>'Wizard Container'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2199876750823529983)
,p_plugin_attribute_id=>wwv_flow_api.id(823034000947718905)
,p_display_sequence=>120
,p_display_value=>'Blank with Attributes'
,p_return_value=>'Blank with Attributes'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(823073294173864568)
,p_plugin_id=>wwv_flow_api.id(808180558331983447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Page'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'Modal Dialog'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(823033390057708888)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE'
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823073817001864938)
,p_plugin_attribute_id=>wwv_flow_api.id(823073294173864568)
,p_display_sequence=>10
,p_display_value=>'Modal Dialog'
,p_return_value=>'Modal Dialog'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(212217881708810090)
,p_plugin_attribute_id=>wwv_flow_api.id(823073294173864568)
,p_display_sequence=>15
,p_display_value=>'Drawer'
,p_return_value=>'Drawer'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823074280607865458)
,p_plugin_attribute_id=>wwv_flow_api.id(823073294173864568)
,p_display_sequence=>20
,p_display_value=>'Wizard Modal Dialog'
,p_return_value=>'Wizard Modal Dialog'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(823075516629874833)
,p_plugin_id=>wwv_flow_api.id(808180558331983447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'List'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'Wizard Progress'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(823033390057708888)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LIST'
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823076194435875579)
,p_plugin_attribute_id=>wwv_flow_api.id(823075516629874833)
,p_display_sequence=>10
,p_display_value=>'Wizard Progress'
,p_return_value=>'Wizard Progress'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823076596813875841)
,p_plugin_attribute_id=>wwv_flow_api.id(823075516629874833)
,p_display_sequence=>20
,p_display_value=>'Top Navigation Menu'
,p_return_value=>'Top Navigation Menu'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823076972491876781)
,p_plugin_attribute_id=>wwv_flow_api.id(823075516629874833)
,p_display_sequence=>30
,p_display_value=>'Links List'
,p_return_value=>'Links List'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823077454907877558)
,p_plugin_attribute_id=>wwv_flow_api.id(823075516629874833)
,p_display_sequence=>40
,p_display_value=>'Menu Bar'
,p_return_value=>'Menu Bar'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823077901514878094)
,p_plugin_attribute_id=>wwv_flow_api.id(823075516629874833)
,p_display_sequence=>50
,p_display_value=>'Badge List'
,p_return_value=>'Badge List'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823078328093878516)
,p_plugin_attribute_id=>wwv_flow_api.id(823075516629874833)
,p_display_sequence=>60
,p_display_value=>'Media List'
,p_return_value=>'Media List'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823078761986878944)
,p_plugin_attribute_id=>wwv_flow_api.id(823075516629874833)
,p_display_sequence=>70
,p_display_value=>'Cards'
,p_return_value=>'Cards'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823079125883879358)
,p_plugin_attribute_id=>wwv_flow_api.id(823075516629874833)
,p_display_sequence=>80
,p_display_value=>'Tabs'
,p_return_value=>'Tabs'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737134508194738569)
,p_plugin_attribute_id=>wwv_flow_api.id(823075516629874833)
,p_display_sequence=>90
,p_display_value=>'Side Navigation Menu'
,p_return_value=>'Side Navigation Menu'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737147367827739764)
,p_plugin_attribute_id=>wwv_flow_api.id(823075516629874833)
,p_display_sequence=>100
,p_display_value=>'Top Navigation Tabs'
,p_return_value=>'Top Navigation Tabs'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(823081886408890801)
,p_plugin_id=>wwv_flow_api.id(808180558331983447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Report'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'Standard'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(823033390057708888)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'REPORT'
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823082493882891283)
,p_plugin_attribute_id=>wwv_flow_api.id(823081886408890801)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'Standard'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823082831912891686)
,p_plugin_attribute_id=>wwv_flow_api.id(823081886408890801)
,p_display_sequence=>20
,p_display_value=>'Cards'
,p_return_value=>'Cards'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823083279872892128)
,p_plugin_attribute_id=>wwv_flow_api.id(823081886408890801)
,p_display_sequence=>30
,p_display_value=>'Timeline'
,p_return_value=>'Timeline'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823083693760892515)
,p_plugin_attribute_id=>wwv_flow_api.id(823081886408890801)
,p_display_sequence=>40
,p_display_value=>'Badge List'
,p_return_value=>'Badge List'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823084041437892910)
,p_plugin_attribute_id=>wwv_flow_api.id(823081886408890801)
,p_display_sequence=>50
,p_display_value=>'Comments'
,p_return_value=>'Comments'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823084506456893484)
,p_plugin_attribute_id=>wwv_flow_api.id(823081886408890801)
,p_display_sequence=>60
,p_display_value=>'Value Attribute Pairs - Row'
,p_return_value=>'Value Attribute Pairs - Row'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823084974421893910)
,p_plugin_attribute_id=>wwv_flow_api.id(823081886408890801)
,p_display_sequence=>70
,p_display_value=>'Value Attribute Pairs - Column'
,p_return_value=>'Value Attribute Pairs - Column'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(360878897464270468)
,p_plugin_attribute_id=>wwv_flow_api.id(823081886408890801)
,p_display_sequence=>80
,p_display_value=>'Content Row'
,p_return_value=>'Content Row'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(776296439077232470)
,p_plugin_attribute_id=>wwv_flow_api.id(823081886408890801)
,p_display_sequence=>90
,p_display_value=>'Contextual Info'
,p_return_value=>'Contextual Info'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(823085368895900725)
,p_plugin_id=>wwv_flow_api.id(808180558331983447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Button'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'Text with Icon'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(823033390057708888)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'BUTTON'
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823085953858901844)
,p_plugin_attribute_id=>wwv_flow_api.id(823085368895900725)
,p_display_sequence=>10
,p_display_value=>'Text with Icon'
,p_return_value=>'Text with Icon'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823095249812003861)
,p_plugin_attribute_id=>wwv_flow_api.id(823085368895900725)
,p_display_sequence=>20
,p_display_value=>'Icon Only'
,p_return_value=>'-'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823095633327004906)
,p_plugin_attribute_id=>wwv_flow_api.id(823085368895900725)
,p_display_sequence=>30
,p_display_value=>'Text Only'
,p_return_value=>'-'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(823088048062913500)
,p_plugin_id=>wwv_flow_api.id(808180558331983447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Field'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'Field'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(823033390057708888)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FIELD'
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(823090315167933226)
,p_plugin_attribute_id=>wwv_flow_api.id(823088048062913500)
,p_display_sequence=>10
,p_display_value=>'Field'
,p_return_value=>'Field'
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_how_to_instructions
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1645378874274309670)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_display_name=>'How To Instructions'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'procedure concat (',
'    p_result in out nocopy varchar2,',
'    p_text   in            varchar2 )',
'is',
'begin',
'    if p_text is not null then',
'        p_result := p_result || p_text; ',
'    end if;',
'end concat;',
'',
'function yes_or_no (',
'    p_true_or_false in boolean )',
'    return varchar2',
'is',
'begin',
'    return case when     p_true_or_false then ''Yes''',
'                when not p_true_or_false then ''No''',
'                else null',
'           end;',
'end yes_or_no;',
'',
'procedure tr_td (',
'  l_result in out nocopy varchar2,',
'  l_label  in            varchar2,',
'  l_text   in            varchar2)',
'is',
'  l_text_print varchar2(32767);',
'begin ',
'    if l_label is not null and l_text is not null then',
'        l_text_print := l_text;',
'        if l_text = ''Y'' or l_text= ''N'' then',
'            l_text_print := yes_or_no(l_text = ''Y'');',
'        end if;',
'        concat(l_result, ''<li class="dm-Instructions-listItem"><span class="dm-Instructions-label">'' || l_label || ''</span><span class="dm-Instructions-value">'' || l_text_print || ''</span></li>'');',
'    end if;',
'end tr_td;',
'',
'',
'procedure append_item (',
'    p_result in out nocopy varchar2,',
'    p_text   in            varchar2,',
'    p_prefix in            varchar2 )',
'is',
'begin',
'    if p_text is not null then',
'        concat( p_result, ''<div>'' || p_prefix || '' <strong>'' || p_text || ''</strong></div>''); ',
'    end if;',
'end append_item;',
'',
'procedure write_section_header (',
'  l_result       in out nocopy varchar2,',
'  l_header_title in            varchar2 )',
'is',
'begin',
'  concat(l_result, ''<table><tr><th colspan="2">'' || l_header_title || ''</th></tr>'');',
'end write_section_header;',
'',
'function get_grid_options (',
'    p_table_name in varchar2,',
'    p_id_column  in varchar2,',
'    p_id_value   in number )',
'    return varchar2',
'is',
'    l_result                  varchar2( 32767 );',
'    l_new_grid                varchar(3);',
'    l_new_grid_row            varchar(3);',
'    l_new_grid_column         varchar(3);',
'    l_grid_column             number;',
'    l_grid_column_span        number;',
'    l_grid_column_attributes  varchar(255);',
'    l_grid_column_css_classes varchar(255);',
'begin',
'    execute immediate',
'        ''select new_grid, new_grid_column, grid_column, grid_column_span, grid_column_attributes, grid_column_css_classes from '' || p_table_name || '' where '' || p_id_column || ''= :id''',
'       into l_new_grid, l_new_grid_column, l_grid_column, l_grid_column_span, l_grid_column_attributes, l_grid_column_css_classes',
'      using in p_id_value;',
'',
'    concat(l_result, ''<ul class="dm-Instructions-list">'');',
'    tr_td(l_result, ''New Grid'', yes_or_no(l_new_grid = ''Yes''));',
'    tr_td(l_result, ''New Grid Row'', yes_or_no(l_new_grid_row = ''Yes''));',
'    tr_td(l_result, ''New Grid Column'', yes_or_no(l_new_grid_column = ''Yes''));',
'    if l_grid_column is null then',
'      tr_td(l_result, ''Grid Column'', ''Automatic'');',
'    else',
'      tr_td(l_result, ''Grid Column'', l_grid_column);',
'    end if; ',
'    if l_grid_column_span is null then',
'      tr_td(l_result, ''Grid Column Span'', ''Automatic'');',
'    else',
'      tr_td(l_result, ''Grid Column Span'', l_grid_column_span);',
'    end if; ',
'    tr_td(l_result, ''Column Attributes'', l_grid_column_attributes);',
'    tr_td(l_result, ''Column CSS Classes'', l_grid_column_css_classes);',
'    return l_result || ''</ul>'';',
'end get_grid_options;',
'',
'',
'function get_template_option_descr (',
'    p_template_id      in number,',
'    p_template_type    in varchar2,',
'    p_template_options in varchar2 )',
'    return varchar2',
'is',
'    l_options            wwv_flow_global.vc_arr2;',
'    l_result             varchar2( 32767 ) := ''<ul class="dm-Instructions-list">'';',
'    l_has_result         boolean := false;',
'    l_label              varchar2( 32767 ) := null;',
'    l_text               varchar2( 32767 ) := null;',
'    l_group_display_name apex_appl_template_opt_groups.display_name%type;',
'    l_display_name       apex_appl_template_options.display_name%type;',
'    l_is_advanced        apex_appl_template_opt_groups.is_advanced%type;',
'begin',
'    l_options := wwv_flow_utilities.string_to_table2( p_template_options );',
'',
'    for i in 1 .. l_options.count loop',
'        if l_options(i) = ''#DEFAULT#'' then',
'            l_label:= ''Use Default'';',
'            l_text := ''<strong>Yes</strong>'';',
'        else',
'            /* if the first entry isn''t the #DEFAULT# placeholder, we still want to show that default has to be set to No */',
'            if i = 1 then',
'                tr_td(l_result, ''Use Default'', ''<strong>No</strong>'');',
'            end if;',
'            begin',
'               l_text := l_options( i );',
'               select g.display_name as group_display_name,',
'                      o.display_name,',
'                      g.is_advanced',
'                 into l_group_display_name,',
'                      l_display_name,',
'                      l_is_advanced',
'                 from apex_appl_template_options o,',
'                      apex_appl_template_opt_groups g',
'                where o.application_id = apex_application.g_flow_id',
'                  and o.theme_number   = 42',
'                  and (  ( o.virtual_template_type = p_template_type and o.virtual_template_id = p_template_id )',
'                      or ( o.virtual_template_id is null and o.template_types = p_template_type )',
'                      )',
'                  and o.css_classes    = l_options( i )',
'                  and g.template_opt_group_id (+) = o.group_id;',
'                if l_group_display_name is not null then',
'                    if l_is_advanced = ''Y'' then',
'                        l_label := ''Advanced '' || l_group_display_name;',
'                    else',
'                        l_label := l_group_display_name;',
'                    end if;',
'                    l_text := l_display_name;',
'                else',
'                    l_label := l_display_name;',
'                    l_text := ''Yes'';',
'                end if;',
'            exception when no_data_found then',
'                l_text := ''Unknown Option '' || l_options( i );',
'            end;',
'        end if;',
'        --concat(l_result, l_label);',
'        --concat(l_result, l_text);',
'        tr_td(l_result, l_label, l_text);',
'        l_label := null;',
'        l_text := null;',
'    end loop;',
'    return l_result || ''</ul>'';',
'end get_template_option_descr;',
'',
'function get_region_items_descr (',
'    p_region_id         in number,',
'    p_show_grid_options in boolean )',
'    return varchar2',
'is',
'    l_result    varchar2( 32767 ) := ''<div class="dm-Instructions-title">Region Items<div>'';',
'    l_has_items boolean := false;',
'begin',
'    for l_item in ( select item_id,',
'                           item_name,',
'                           display_as,',
'                           item_template_options,',
'                           item_source_type,',
'                           item_default_type,',
'                           item_data_type',
'                      from apex_application_page_items',
'                     where region_id = p_region_id',
'                     order by display_sequence )',
'    loop',
'        l_has_items := true;',
'        l_result := l_result || ',
'             ''<div><span class="how-to-page-item-title">'' || l_item.display_as || '' <strong>'' ||  l_item.item_name || ''</strong></span><div>Template Options'' || ',
'             get_template_option_descr(',
'                 p_template_options => l_item.item_template_options,',
'                 p_template_type    => ''THEME'',',
'                 p_template_id      => 1',
'             ) || ''</div></div>'';',
'      if p_show_grid_options then',
'          l_result := l_result || ''Grid Options: '' ||',
'                      get_grid_options(',
'                          p_table_name => ''apex_application_page_items'',',
'                          p_id_column  => ''item_id'',',
'                          p_id_value   => l_item.item_id);',
'      end if;',
'      --concat(l_result, ''</div>'');',
'      concat(l_result, l_item.item_source_type || '' - '' || l_item.item_default_type || '' - '' || l_item.item_data_type);',
'      end loop;',
'    concat(l_result, ''</div></div>'');',
'    if not l_has_items then',
'       l_result := null;',
'    end if;',
'    return l_result;',
'end get_region_items_descr;',
'',
'function get_region_buttons_descr (',
'    p_region_id      in number )',
'    return varchar2',
'is',
'    l_result      varchar2( 32767 ) := ''<h4 class="dm-Instructions-subTitle">Region Buttons</h4>'';',
'    l_has_buttons boolean := false;',
'begin',
'    for l_button in ( select button_name,',
'                             button_template,',
'                             display_position,',
'                             button_css_classes,',
'                             icon_css_classes,',
'                             button_template_options,',
'                             button_template_id',
'                        from apex_application_page_buttons',
'                       where region_id = p_region_id',
'                       order by button_sequence )',
'    loop',
'       l_has_buttons := true;',
'       l_result := l_result || ',
'            ''<div class="dm-Instructions-buttonRow"><ul class="dm-Instructions-list"><li class="dm-Instructions-listItem"><span class="dm-Instructions-label">'' || l_button.button_template || ''</span><span class="dm-Instructions-value">'' ||  l_button.'
||'button_name || ''</span></li></ul></div>'' || ',
'            get_template_option_descr(',
'                p_template_options => l_button.button_template_options,',
'                p_template_type    => ''BUTTON'',',
'                p_template_id      => l_button.button_template_id );',
'        concat(l_result, ''<ul class="dm-Instructions-list">'');',
'        tr_td(l_result, ''Button Template'', l_button.button_template);',
'        tr_td(l_result, ''Button Position'', l_button.display_position);',
'        concat(l_result, ''</ul>'');',
'        concat(l_result, ''</div>'');',
'    end loop;',
'    concat(l_result, ''</div></div>'');',
'',
'    if not l_has_buttons then',
'       l_result := null;',
'    end if;',
'    return l_result;',
'end get_region_buttons_descr;',
'',
'function get_plugin_attributes (',
'    p_plugin_name in varchar2,',
'    p_plugin_type in varchar2,',
'    p_values      in apex_application_global.vc_arr2 )',
'    return varchar2',
'is',
'    c_application_id constant number := case when p_plugin_name like ''NATIVE_%'' then 4411 else apex_application.g_flow_id end;',
'',
'    l_result         varchar2( 32767 ) := ''<ul class="dm-Instructions-list">'';',
'    l_display_value  varchar2( 255 );',
'    l_has_attributes boolean := false;',
'begin',
'    for l_attribute in ( select plugin_attribute_id,',
'                                prompt,',
'                                attribute_sequence as attribute_no,',
'                                attribute_type,',
'                                default_value',
'                           from apex_appl_plugins p,',
'                                apex_appl_plugin_attributes a',
'                          where p.application_id  = c_application_id',
'                            and p.name            = substr( p_plugin_name, 8 )',
'                            and p.plugin_type     = p_plugin_type',
'                            and a.plugin_id       = p.plugin_id',
'                            and a.attribute_scope = ''Component''',
'                          order by a.display_sequence )',
'    loop',
'        if not p_values.exists ( l_attribute.attribute_no ) then',
'            continue;',
'        end if;',
'',
'        l_display_value := p_values( l_attribute.attribute_no );',
'',
'        -- No need to show the attribute if it''s the default',
'        if l_display_value = l_attribute.default_value then',
'            continue;',
'        end if;',
'',
'        l_has_attributes := true;',
'        if l_attribute.attribute_type = ''Select List'' then',
'            begin',
'                select display_value',
'                  into l_display_value',
'                  from apex_appl_plugin_attr_values',
'                 where plugin_attribute_id = l_attribute.plugin_attribute_id',
'                   and return_value        = l_display_value;',
'            exception when no_data_found then',
'                l_display_value := l_display_value || ''***'';',
'            end;',
'        end if;',
'        tr_td(l_result, apex_escape.html( l_attribute.prompt ), apex_escape.html( l_display_value ));',
'        --concat( l_result, ''<li>'' || apex_escape.html( l_attribute.prompt ) || '':'' || apex_escape.html( l_display_value ) || ''</li>'' );',
'    end loop;',
'    if not l_has_attributes then',
'        l_result := null;',
'    else',
'        concat( l_result, ''</ul>'' );',
'    end if;',
'    return l_result;',
'end get_plugin_attributes;',
'',
'procedure show_region_descr (',
'    p_region_id               in number,',
'    p_show_template_options   in boolean,',
'    p_show_grid               in boolean,',
'    p_show_sub_regions        in boolean,',
'    p_show_title              in boolean,',
'    p_show_select_region_type in boolean',
')',
'is',
'    l_has_subregions boolean := false;',
'    l_values         apex_application_global.vc_arr2;',
'begin',
'    for l_region in ( select region_name,',
'                             source_type,',
'                             source_type_plugin_name,',
'                             template,',
'                             template_id,',
'                             region_template_options,',
'                             list_template_override,',
'                             list_template_override_id,',
'                             breadcrumb_template,',
'                             breadcrumb_template_id,',
'                             component_template_options,',
'                             report_template,',
'                             report_template_id,',
'                             condition_type',
'                        from apex_application_page_regions',
'                       where region_id = p_region_id )',
'    loop',
'        if l_region.condition_type = ''Never'' then',
'            continue;',
'        end if;',
'',
'        -- get all plug-in attributes',
'        l_values.delete;',
'        for i in ( select attribute_01,',
'                                      attribute_02,',
'                                      attribute_03,',
'                                      attribute_04,',
'                                      attribute_05,',
'                                      attribute_06,',
'                                      attribute_07,',
'                                      attribute_08,',
'                                      attribute_09,',
'                                      attribute_10,',
'                                      attribute_11,',
'                                      attribute_12,',
'                                      attribute_13,',
'                                      attribute_14,',
'                                      attribute_15,',
'                                      attribute_16,',
'                                      attribute_17,',
'                                      attribute_18,',
'                                      attribute_19,',
'                                      attribute_20,',
'                                      attribute_21,',
'                                      attribute_22,',
'                                      attribute_23,',
'                                      attribute_24,',
'                                      attribute_25',
'               from apex_application_page_regions',
'              where region_id = p_region_id )',
'          loop',
'              l_values(1) := i.attribute_01;',
'              l_values(2) := i.attribute_02;',
'              l_values(3) := i.attribute_03;',
'              l_values(4) := i.attribute_04;',
'              l_values(5) := i.attribute_05;',
'              l_values(6) := i.attribute_06;',
'              l_values(7) := i.attribute_07;',
'              l_values(8) := i.attribute_08;',
'              l_values(9) := i.attribute_09;',
'              l_values(10) := i.attribute_10;',
'              l_values(11) := i.attribute_11;',
'              l_values(12) := i.attribute_12;',
'              l_values(13) := i.attribute_13;',
'              l_values(14) := i.attribute_14;',
'              l_values(15) := i.attribute_15;',
'              l_values(16) := i.attribute_16;',
'              l_values(17) := i.attribute_17;',
'              l_values(18) := i.attribute_18;',
'              l_values(19) := i.attribute_19;',
'              l_values(20) := i.attribute_20;',
'              l_values(21) := i.attribute_21;',
'              l_values(22) := i.attribute_22;',
'              l_values(23) := i.attribute_23;',
'              l_values(24) := i.attribute_24;',
'              l_values(25) := i.attribute_25;',
'          end loop;',
'        ',
'        if p_show_title then',
'            sys.htp.p(''<h3>'' || l_region.region_name || ''</h3>'' );',
'        end if;',
'        sys.htp.p( ''<div class="dm-Instructions-section">'' );',
'        if p_show_template_options then',
'            if p_show_select_region_type then',
'                sys.htp.p( ''<div>Select <b>'' || l_region.source_type || ''</b> for Region Type.</div>'' );',
'            end if;',
'            --sys.htp.p( ''<div>Select <b>'' || l_region.template || ''</b> as Region Template.</div>'' );',
'            sys.htp.p(',
'                ''<h3 class="dm-Instructions-title">Region Template Options</h3> '' ||',
'                get_template_option_descr(',
'                    p_template_id      => l_region.template_id,',
'                    p_template_type    => ''REGION'',',
'                    p_template_options => l_region.region_template_options )',
'                );',
'        end if;',
'        if l_region.source_type_plugin_name = ''NATIVE_LIST'' then',
'            --sys.htp.p( ''<div>Use the list template  <b>'' || l_region.list_template_override || ''</b></div>'' );',
'            sys.htp.p(',
'                ''<h3 class="dm-Instructions-title">List Template Options</h3> '' ||',
'                get_template_option_descr(',
'                    p_template_id      => l_region.list_template_override_id,',
'                    p_template_type    => ''LIST'',',
'                    p_template_options => l_region.component_template_options )',
'                );',
'        elsif l_region.source_type_plugin_name = ''NATIVE_BREADCRUMB'' then',
'            --sys.htp.p( ''<div>Breadcrumb Template: '' || l_region.breadcrumb_template || ''</div>'' );',
'            sys.htp.p(',
'                ''<h3 class="dm-Instructions-title">Breadcrumb Template Options</h3> '' ||',
'                get_template_option_descr(',
'                    p_template_id      => l_region.breadcrumb_template_id,',
'                    p_template_type    => ''BREADCRUMB'',',
'                    p_template_options => l_region.component_template_options )',
'                    );',
'        elsif l_region.source_type_plugin_name = ''NATIVE_SQL_REPORT'' then',
'           -- sys.htp.p( ''<div>Report: '' || l_region.report_template || ''</div>'' );',
'            sys.htp.p(',
'                ''<h3 class="dm-Instructions-title">Report Template Options</h3> '' ||',
'                get_template_option_descr(',
'                    p_template_id      => l_region.report_template_id,',
'                    p_template_type    => ''REPORT'',',
'                    p_template_options => l_region.component_template_options )',
'                    );',
'        elsif l_region.source_type_plugin_name = ''NATIVE_IR'' then',
'            --sys.htp.p( ''<div>Interactive Report: '' || l_region.report_template || ''</div>'' );',
'            null;',
'        elsif l_region.source_type_plugin_name = ''NATIVE_CSS_CALENDAR'' then',
'            sys.htp.p(',
'                ''<div>'' ||',
'                get_plugin_attributes(',
'                    p_plugin_name => l_region.source_type_plugin_name,',
'                    p_plugin_type => ''Region Type'',',
'                    p_values      => l_values ) ||',
'                ''</div>'' );',
'        end if;',
'        sys.htp.p( ''</div>'' );',
'        if p_show_grid then',
'            sys.htp.p(',
'                ''<div class="dm-Instructions-section"><h3 class="dm-Instructions-title">Grid Options: '' ||',
'                get_grid_options(',
'                    p_table_name => ''apex_application_page_regions'',',
'                    p_id_column  => ''region_id'',',
'                    p_id_value   => p_region_id ) ||',
'                ''</h3></div>'');',
'        end if;',
'        -- sys.htp.p( ''<div class="dm-Instructions-section">'' );',
'        -- sys.htp.p(get_region_items_descr( p_region_id, p_show_grid ));',
'        -- sys.htp.p( ''</div>'' );',
'        -- sys.htp.p( ''<div class="dm-Instructions-section">'' );',
'        -- sys.htp.p(get_region_buttons_descr( p_region_id ));',
'        -- sys.htp.p( ''</div>'' );',
'        if p_show_sub_regions then',
'            for l_sub_region in ( select region_id',
'                                    from apex_application_page_regions',
'                                   where parent_region_id = p_region_id',
'                                   order by display_sequence )',
'            loop',
'                  if not l_has_subregions then',
'                      sys.htp.p( ''<div class="dm-Instructions-section dm-Instructions-section--sub">'' );',
'                      l_has_subregions := true;',
'                  end if;',
'                  show_region_descr(',
'                      p_region_id               => l_sub_region.region_id,',
'                      p_show_template_options   => p_show_template_options,',
'                      p_show_grid               => p_show_grid,',
'                      p_show_sub_regions        => p_show_sub_regions,',
'                      p_show_title              => p_show_title,',
'                      p_show_select_region_type => p_show_select_region_type );',
'            end loop;',
'            if l_has_subregions = true then',
'                sys.htp.p( ''</div>'' );',
'            end if;',
'        end if;',
'    end loop;',
'',
'end show_region_descr;',
'',
'',
'function render (',
'    p_region              in apex_plugin.t_region,',
'    p_plugin              in apex_plugin.t_plugin,',
'    p_is_printer_friendly in boolean )',
'    return apex_plugin.t_region_render_result',
'is',
'begin',
'    for l_region in ( select r2.region_id',
'                        from apex_application_page_regions r1,',
'                             apex_application_page_regions r2',
'                       where r1.region_id        = p_region.id',
'                         and r2.parent_region_id = r1.parent_region_id',
'                         and r2.region_id       <> r1.region_id )',
'    loop',
'        show_region_descr(',
'            p_region_id               => l_region.region_id,',
'            p_show_template_options   => ( p_region.attribute_01 = ''Y'' ),',
'            p_show_grid               => ( p_region.attribute_02 = ''Y'' ),',
'            p_show_sub_regions        => ( p_region.attribute_03 = ''Y'' ),',
'            p_show_title              => ( p_region.attribute_04 = ''Y'' ),',
'            p_show_select_region_type => ( p_region.attribute_05 = ''Y'' )',
'            );',
'    end loop;',
'',
'    return null;',
'end render;'))
,p_api_version=>1
,p_render_function=>'render'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1687619288674340180)
,p_plugin_id=>wwv_flow_api.id(1645378874274309670)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Show Region Template Options'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1688273989223831255)
,p_plugin_id=>wwv_flow_api.id(1645378874274309670)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Show Grid Values'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1689429149513534602)
,p_plugin_id=>wwv_flow_api.id(1645378874274309670)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Show Sub Regions'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1689442314595663907)
,p_plugin_id=>wwv_flow_api.id(1645378874274309670)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Show Region Title'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712328418313712311)
,p_plugin_id=>wwv_flow_api.id(1645378874274309670)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Show Select Region Type'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1687619288674340180)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(821272323468330288)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>42
,p_home_url=>'f?p=&APP_ID.:100:&SESSION.'
,p_login_url=>'f?p=&APP_ID.:LOGIN:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_global_page_id=>0
,p_navigation_list_id=>wwv_flow_api.id(404960847609814309)
,p_navigation_list_position=>'SIDE'
,p_navigation_list_template_id=>wwv_flow_api.id(1018710602436487872)
,p_nav_list_template_options=>'#DEFAULT#:js-defaultCollapsed:js-navCollapsed--hidden:t-TreeNav--styleA'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#pkgapp_ui/css/5.0#MIN#.css',
'#THEME_IMAGES#css/Demo#MIN#.css',
'#PRISMJS_DIRECTORY#prism.css'))
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#THEME_IMAGES#demo/demo.js',
'#APP_IMAGES#utDevMode.js',
'#PRISMJS_DIRECTORY#prism.js'))
,p_nav_bar_type=>'LIST'
,p_nav_bar_list_id=>wwv_flow_api.id(1398847823861474656)
,p_nav_bar_list_template_id=>wwv_flow_api.id(1398514441042912293)
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00000
begin
wwv_flow_api.create_page(
 p_id=>0
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Page Zero'
,p_alias=>'PAGE-ZERO'
,p_step_title=>'Page Zero'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_protection_level=>'D'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210922153557'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3082211826105906231)
,p_plug_name=>'Woops.'
,p_icon_css_classes=>'fa-emoji-grin-sweat'
,p_region_template_options=>'#DEFAULT#:t-Alert--wizard:t-Alert--customIcons:t-Alert--info'
,p_plug_template=>wwv_flow_api.id(591654834181983844)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'You''ve stumbled on a page that doesn''t exist.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'CURRENT_PAGE_IN_CONDITION'
,p_plug_display_when_condition=>'400,403,404,406,5001,5002,5003,5004,5005,6306,700,701'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00100
begin
wwv_flow_api.create_page(
 p_id=>100
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Home '
,p_alias=>'HOME'
,p_step_title=>'Oracle APEX Universal Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_inline_css=>'.t-Header,.t-Footer {display: none;}'
,p_step_template=>wwv_flow_api.id(1530046751615002521)
,p_page_css_classes=>'dm-Home dm-Page dm-Page--center ut-bg'
,p_page_template_options=>'#DEFAULT#:t-PageBody--noContentPadding'
,p_page_is_public_y_n=>'Y'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2015299727112052604)
,p_plug_name=>'Hero Region'
,p_region_css_classes=>'dm-Hero'
,p_region_template_options=>'#DEFAULT#:margin-bottom-lg'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="dm-Logo app-sample-universal-theme"></span>',
'<h1><span>Oracle APEX </span>Universal Theme</h1>',
'<p class="margin-top-md u-tC">Universal Theme is a responsive, versatile, and customizable user interface for your APEX apps. It is designed uniquely for Oracle APEX to make it easy for developers to build beautiful, modern applications, at any scale'
||', for any purpose, that work on any device. </p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2015299814283052605)
,p_plug_name=>'Navigation'
,p_region_name=>'nav_icons'
,p_region_sub_css_classes=>'nav-icons'
,p_region_template_options=>'#DEFAULT#:margin-bottom-lg'
,p_component_template_options=>'#DEFAULT#:t-Cards--featured force-fa-lg:t-Cards--displayIcons:t-Cards--3cols:t-Cards--hideBody:t-Cards--iconsRounded:t-Cards--animColorFill'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_list_id=>wwv_flow_api.id(404960847609814309)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(831948007433695437)
,p_name=>'Format Icons'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(831948103975695438)
,p_event_id=>wwv_flow_api.id(831948007433695437)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$(".nav-icons").removeClass("force-fa-lg").find(".t-Icon").addClass("fa-2x");'
);
end;
/
prompt --application/pages/page_00300
begin
wwv_flow_api.create_page(
 p_id=>300
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Grid Layout'
,p_alias=>'GRID-LAYOUT'
,p_step_title=>'Grid Layout - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.u-Report small {display: block;}',
'.text-nowrap {white-space: nowrap;}'))
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364817488434107779)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1391858395538720788)
,p_plug_name=>'Column Modifier Classes'
,p_region_css_classes=>'margin-top-xl'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You can fine tune the responsive behavior of the components on your page by modifying the <strong>Column CSS Classes</strong> property of your regions.</p>',
'',
'<table class="u-Report u-Report--stretch">',
'    <thead>',
'        <tr>',
'            <th></th>',
'            <th><small>&le;640px</small></th>',
'            <th><small>&gt;640 and &lt;768px</small></th>',
'            <th><small>&ge;768px and &lt;992px</small></th>',
'            <th><small>&ge;992px and &lt;1200px</small></th>',
'            <th><small>&ge;1200px</small></th>',
'        </tr>',
'    </thead>',
'    <tbody>',
'        <tr>',
'            <th class="text-nowrap" scope="row">Class prefix</th>',
'            <td><code>.col-xxs-</code></td>',
'            <td><code>.col-xs-</code></td>',
'            <td><code>.col-sm-</code></td>',
'            <td><code>.col-md-</code></td>',
'            <td><code>.col-lg-</code></td>',
'        </tr>',
'    </tbody>',
'</table>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1391858551507720790)
,p_plug_name=>'Overview'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Universal Theme uses a 12-column flexible grid for arranging page components and is based on the <a href="http://getbootstrap.com/" target="_blank">Bootstrap</a> grid system.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364816815966107772)
,p_plug_name=>'View Layout Columns'
,p_parent_plug_id=>wwv_flow_api.id(1391858551507720790)
,p_region_css_classes=>'margin-bottom-xl'
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--info:t-Alert--removeHeading js-removeLandmark'
,p_plug_template=>wwv_flow_api.id(591654834181983844)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>Click the <b>Toggle Layout Columns</b> button to overlay the grid behind this page.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1515420815675817004)
,p_plug_name=>'Grid Layout Container'
,p_parent_plug_id=>wwv_flow_api.id(1391858551507720790)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364813833721107743)
,p_plug_name=>'Region 2'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364814009089107744)
,p_plug_name=>'Region 4'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364814047057107745)
,p_plug_name=>'Region 6'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364814123257107746)
,p_plug_name=>'Region 8'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364814300015107747)
,p_plug_name=>'Region 10'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>160
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364814415097107748)
,p_plug_name=>'Region 1'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364814433008107749)
,p_plug_name=>'Region 3'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364814543844107750)
,p_plug_name=>'Region 5'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364814659998107751)
,p_plug_name=>'Region 7'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364814773692107752)
,p_plug_name=>'Region 9'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364814892942107753)
,p_plug_name=>'Region 11'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>170
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364814953012107754)
,p_plug_name=>'Region 12'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>180
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364815095339107755)
,p_plug_name=>'Region 1'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>190
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364815140361107756)
,p_plug_name=>'Region 2'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>200
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364815221052107757)
,p_plug_name=>'Region 3'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>210
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364815375714107758)
,p_plug_name=>'Region 4'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>220
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364815459560107759)
,p_plug_name=>'Region 5'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>230
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364815555965107760)
,p_plug_name=>'Region 6'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>240
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364815617091107761)
,p_plug_name=>'Region 1'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>250
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364815768618107762)
,p_plug_name=>'Region 2'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>260
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364815836674107763)
,p_plug_name=>'Region 3'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>270
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364815983433107764)
,p_plug_name=>'Region 4'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>280
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364816290558107767)
,p_plug_name=>'Region 1'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>290
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364816375522107768)
,p_plug_name=>'Region 2'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>300
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364816490757107769)
,p_plug_name=>'Region 3'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>310
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364816587180107770)
,p_plug_name=>'Region 1'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>320
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364816657802107771)
,p_plug_name=>'Region 2'
,p_parent_plug_id=>wwv_flow_api.id(1515420815675817004)
,p_region_css_classes=>'dm-Grid-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>330
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(713382252223885774)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1364816815966107772)
,p_button_name=>'TOGGLE_GRID_LAYOUT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Toggle Layout Columns'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(713385993518885780)
,p_name=>'Toggle Grid Layout'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(713382252223885774)
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'apex.jQuery(''body'').hasClass(''grid-debug-on'')'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(713386427737885781)
,p_event_id=>wwv_flow_api.id(713385993518885780)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REMOVE_CLASS'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'body'
,p_attribute_01=>'grid-debug-on'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(713386919137885782)
,p_event_id=>wwv_flow_api.id(713385993518885780)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ADD_CLASS'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(713382252223885774)
,p_attribute_01=>'is-active'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(713387477809885782)
,p_event_id=>wwv_flow_api.id(713385993518885780)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ADD_CLASS'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'body'
,p_attribute_01=>'grid-debug-on'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(713387929121885783)
,p_event_id=>wwv_flow_api.id(713385993518885780)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REMOVE_CLASS'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(713382252223885774)
,p_attribute_01=>'is-active'
);
end;
/
prompt --application/pages/page_00400
begin
wwv_flow_api.create_page(
 p_id=>400
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Design'
,p_alias=>'DESIGN'
,p_step_title=>'Design - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3000967705093695623)
,p_plug_name=>'Design'
,p_icon_css_classes=>'fa-pencil'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1224989219520090364)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00401
begin
wwv_flow_api.create_page(
 p_id=>401
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Design Overview'
,p_alias=>'DESIGN-OVERVIEW'
,p_step_title=>'Design Overview - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(766161687376482427)
,p_plug_name=>'Design'
,p_icon_css_classes=>'fa-lg fa-design u-color-3'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1224989219520090364)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(873485800997520031)
,p_plug_name=>'Key Principles'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>There are three key aspects of Universal Theme that make it ideally suited for Application Express development: Responsive Design, Versatile UI Components, and Easy Customization.</p>',
'',
'<h3 class="margin-top-lg"><span class="fa fa-number-1 fa-lg u-color-3-txt"></span> Responsive Design</h3>',
'<p>Universal Theme has been designed from the very beginning to work just as well on small screen devices (phones, tablet) as it does on larger screen devices (laptops, desktops).</p>',
'<p>This means that the UI components in Universal Theme work across varying screen resolutions while maintaining the same or similar functionality.  In addition, Universal Theme takes full advantage of ultra high screen resolutions by utilizing vecto'
||'r graphics where possible, and relying upon CSS3 features for UI styling.</p>',
'',
'<h3 class="margin-top-lg"><span class="fa fa-number-2 fa-lg u-color-3-txt"></span> Versatile UI</h3>',
'<p>Universal Theme provides the components / building blocks necessary to build practically any type of business application UI.</p>',
'<p>From Cards, Forms, Menus, Tabs, Reports, and so much more, these components have been developed with the best practices following common and popular UI patterns. You can browse all of the components provided with Universal Theme by navigating to t'
||'he Components section of this application.</p>',
'',
'<h3 class="margin-top-lg"><span class="fa fa-number-3 fa-lg u-color-3-txt"></span> Easy Customization</h3>',
'<p>Even for the most basic of requirements, theming and customization is a key and necessary ingredient to the success of your application.</p>',
'<p>With Universal Theme, you can effortlessly customize and fully control the look and feel of your applications without becoming an expert in UI design, HTML, CSS, or JavaScript. Using Theme Roller and Template Options, you can easily customize your'
||' application to fit your company''s brand, and customize the look and feel of various components using Template Options. All of this is possible during runtime, so what you see is what you really get.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1752384660634560279)
,p_plug_name=>'What is Universal Theme?'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Universal Theme is a user interface for Application Express that enables developers to build modern web applications without requiring extensive knowledge of HTML, CSS, or JavaScript. With some working knowledge of Application Express, you can use'
||' Universal Theme to easily build a responsive application that is highly accessible, easily customizable, and easy to maintain.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00402
begin
wwv_flow_api.create_page(
 p_id=>402
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Colors'
,p_alias=>'COLORS'
,p_step_title=>'Colors - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(844155314244515514)
,p_plug_name=>'Stateful Colors'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Stateful colors are used for convey additional meaning for a given UI component. For example, you may choose to color a warning alert with a yellow tint.</p>',
'',
'<p>There are 6 stateful colors: normal, hot, informational, danger, warning, and success. You may customize these colors by modifying the Status Colors within Theme Roller.</p>',
'',
'<div class="color-blocks color-blocks--large">',
'  <div class="color-block u-normal">Normal State</div>',
'  <div class="color-block u-hot">Hot State</div>',
'  <div class="color-block u-info">Info State</div>',
'</div>',
'<div class="color-blocks color-blocks--large">',
'  <div class="color-block u-danger">Danger State</div>',
'  <div class="color-block u-warning">Warning</div>',
'  <div class="color-block u-success">Success</div>',
'</div>',
'',
'<p><strong>Note:</strong> Color alone should not be used to convey information as it may not always be accessible.</strong></p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1644963483147523074)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3064597545922501763)
,p_plug_name=>'Introduction'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Universal Theme uses a consistent set of colors across the included components. These colors can be grouped into two palettes: <strong>General Colors</strong> and <strong>Stateful Colors</strong>.</p>',
'<p>You can learn how to use these colors in your own custom UI components by viewing the <a href="f?p=&APP_ID.:6302:&APP_SESSION.">CSS modifier classes</a> in the <a href="f?p=&APP_ID.:6000:&APP_SESSION.">Reference</a> section.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3064597770745502788)
,p_plug_name=>'General Colors'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>General colors are used for adding color accents to several application components such as Charts, Cards, and and more.</p>',
'',
'<p>There are 15 primary colors which are modified to become slightly lighter or darker to create a total of 45 color options. You can customize these colors by modifying the Color Palette within Theme Roller.</p>',
'',
'<p><strong>Primary Colors</strong></p>',
'',
'<div class="color-blocks">',
'  <div class="color-block u-color-1">1</div>',
'  <div class="color-block u-color-2">2</div>',
'  <div class="color-block u-color-3">3</div>',
'  <div class="color-block u-color-4">4</div>',
'  <div class="color-block u-color-5">5</div>',
'  <div class="color-block u-color-6">6</div>',
'  <div class="color-block u-color-7">7</div>',
'  <div class="color-block u-color-8">8</div>',
'  <div class="color-block u-color-9">9</div>',
'  <div class="color-block u-color-10">10</div>',
'  <div class="color-block u-color-11">11</div>',
'  <div class="color-block u-color-12">12</div>',
'  <div class="color-block u-color-13">13</div>',
'  <div class="color-block u-color-14">14</div>',
'  <div class="color-block u-color-15">15</div>',
'</div>',
'',
'<p><strong>Primary Colors - Lighter</strong></p>',
'',
'<div class="color-blocks">',
'  <div class="color-block u-color-16">16</div>',
'  <div class="color-block u-color-17">17</div>',
'  <div class="color-block u-color-18">18</div>',
'  <div class="color-block u-color-19">19</div>',
'  <div class="color-block u-color-20">20</div>',
'  <div class="color-block u-color-21">21</div>',
'  <div class="color-block u-color-22">22</div>',
'  <div class="color-block u-color-23">23</div>',
'  <div class="color-block u-color-24">24</div>',
'  <div class="color-block u-color-25">25</div>',
'  <div class="color-block u-color-26">26</div>',
'  <div class="color-block u-color-27">27</div>',
'  <div class="color-block u-color-28">28</div>',
'  <div class="color-block u-color-29">29</div>',
'  <div class="color-block u-color-30">30</div>',
'</div>',
'',
'<p><strong>Primary Colors - Darker</strong></p>',
'<div class="color-blocks">',
'  <div class="color-block u-color-31">31</div>',
'  <div class="color-block u-color-32">32</div>',
'  <div class="color-block u-color-33">33</div>',
'  <div class="color-block u-color-34">34</div>',
'  <div class="color-block u-color-35">35</div>',
'  <div class="color-block u-color-36">36</div>',
'  <div class="color-block u-color-37">37</div>',
'  <div class="color-block u-color-38">38</div>',
'  <div class="color-block u-color-39">39</div>',
'  <div class="color-block u-color-40">40</div>',
'  <div class="color-block u-color-41">41</div>',
'  <div class="color-block u-color-42">42</div>',
'  <div class="color-block u-color-43">43</div>',
'  <div class="color-block u-color-44">44</div>',
'  <div class="color-block u-color-45">45</div>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00403
begin
wwv_flow_api.create_page(
 p_id=>403
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Customization'
,p_alias=>'CUSTOMIZATION'
,p_step_title=>'Customization - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2523767231244575200)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_00404
begin
wwv_flow_api.create_page(
 p_id=>404
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Data Entry'
,p_alias=>'DATA-ENTRY'
,p_step_title=>'Data Entry - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3402572660921631388)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_00406
begin
wwv_flow_api.create_page(
 p_id=>406
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Notifications and Messaging'
,p_alias=>'NOTIFICATIONS-AND-MESSAGING'
,p_step_title=>'Notifications and Messaging - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4281379858328693354)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_00407
begin
wwv_flow_api.create_page(
 p_id=>407
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Navigation'
,p_alias=>'NAVIGATION'
,p_step_title=>'Navigation - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(825274670975768716)
,p_plug_name=>'Menu Bar'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>The <b>Top Navigation Menu</b> template renders your application navigation as a menu bar, similar to what you find on most desktop applications. This is commonly used for more complex applications with several layers of hierarchy within the navig'
||'ation.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(825274744458768717)
,p_plug_name=>'Tabs'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The <b>Top Navigation Tabs</b> template renders your application navigation as tabs and is ideally suited for simple applications where you have approximately 6 or fewer tabs.</p>',
'',
'<p>This navigation template will automatically be positioned to the bottom of the screen for small screen or mobile devices so it is more comfortable to access.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(825274890092768718)
,p_plug_name=>'Mega Menu'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The <b>Top Navigation Mega Menu</b> template renders your application navigation in a popup panel that can be opened or closed from the header menu button.</p>',
'<p>Mega menus are especially useful when you want to display all navigation items at once to your user, and is a very common pattern you will see across the web.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(825274979178768719)
,p_plug_name=>'Side Tree Navigation'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>The <b>Side Navigation Menu</b> template renders your application navigation in a collapsible side panel. The navigation items are rendered as tree nodes that can be expanded.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1515421145173817007)
,p_plug_name=>'Overview'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Navigation is an important part of your application and can determine the how your users navigate within your application.  There are two navigation concepts that are key for Universal Theme: Navigation Menus and Navigation Bar.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1515421235412817008)
,p_plug_name=>'Navigation Menus'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The primary navigation structure for your application is defined as a <b>Navigation Menu</b> and is based on the <b>List</b> component in APEX. Navigation Menus are hierarchical and can be any level deep.  This navigation control and can be both d'
||'ynamic (based on a query), or static (based on static list entries).  In addition, you can choose to position your navigation to the top or side of your screen.</p>',
'',
'<p>To change your application''s Navigation Menu settings, navigate to Shared Components &rarr; User Interface Defaults and then click on the edit icon next to the Desktop User Interface. From here, you can navigate to the Navigation Menu region and c'
||'hange the options listed.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1515421395231817009)
,p_plug_name=>'Navigation Bar'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Navigation Bar is positioned near the end of the application''s header, and typically contains links for user authentication, help, feedback, and other global items.</p>',
'',
'<p>Navigation Bars are also based on the <b>List</b> component in APEX. However, as of APEX 5.1, you may only have a two-level deep menu.</p>',
'',
'<p>To change your application''s Navigation Bar settings, navigate to Shared Components &rarr; User Interface Defaults and then click on the edit icon next to the Desktop User Interface. From here, you can navigate to the Navigation Bar region and cha'
||'nge the options listed.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5160189184423760318)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(825275040568768720)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(825274670975768716)
,p_button_name=>'OPEN_PREVIEW_MENU_BAR'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Open Preview'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-external-link'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(825275356397768723)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(825274744458768717)
,p_button_name=>'OPEN_PREVIEW_TABS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Open Preview'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-external-link'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(825275634824768726)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(825274890092768718)
,p_button_name=>'OPEN_PREVIEW_MEGA_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Open Preview'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-external-link'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(825275953185768729)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(825274979178768719)
,p_button_name=>'OPEN_PREVIEW_SIDE_TREE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Open Preview'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-external-link'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(825276267651768732)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(825274890092768718)
,p_button_name=>'OPEN_PREVIEW_MEGA_MENU_2'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Open Preview - Variation 2'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-external-link'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(825275127324768721)
,p_name=>'Menu Bar Preview'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(825275040568768720)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(825275254228768722)
,p_event_id=>wwv_flow_api.id(825275127324768721)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.theme42demo.openSamplePage(''f?p=&APP_ID.:1120:&APP_SESSION.'',''Menu Bar Preview'');'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(825275489623768724)
,p_name=>'Tabs Preview'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(825275356397768723)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(825275551621768725)
,p_event_id=>wwv_flow_api.id(825275489623768724)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.theme42demo.openSamplePage(''f?p=&APP_ID.:1121:&APP_SESSION.'',''Tabs Preview'');'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(825275730412768727)
,p_name=>'Mega Menu Preview'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(825275634824768726)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(825275890793768728)
,p_event_id=>wwv_flow_api.id(825275730412768727)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.theme42demo.openSamplePage(''f?p=&APP_ID.:1122:&APP_SESSION.'',''Mega Menu Preview'');'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(825276322976768733)
,p_name=>'Mega Menu Preview_2'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(825276267651768732)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(825276424543768734)
,p_event_id=>wwv_flow_api.id(825276322976768733)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.theme42demo.openSamplePage(''f?p=&APP_ID.:1124:&APP_SESSION.'',''Mega Menu Preview 2'');'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(825276056291768730)
,p_name=>'Side Nav Preview'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(825275953185768729)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(825276128083768731)
,p_event_id=>wwv_flow_api.id(825276056291768730)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.theme42demo.openSamplePage(''f?p=&APP_ID.:1123:&APP_SESSION.'',''Side Navigation Menu Preview'');'
);
end;
/
prompt --application/pages/page_00420
begin
wwv_flow_api.create_page(
 p_id=>420
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Mobile Patterns'
,p_alias=>'MOBILE-PATTERNS'
,p_step_title=>'Mobile Patterns'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(606904582240638640)
,p_plug_name=>'Mobile Patterns'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_component_template_options=>'t-MediaList--showIcons:u-colors'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(608043492397034627)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2307050152134014008)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3726684214908992697)
,p_plug_name=>'Introduction'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>'<p>Here are a number of common UI patterns that may be useful if you are building apps that will primarily be used on small screen devices.  These mobile design patterns are especially optimized for maximum usability when using a hand held device suc'
||'h as a smart phone or small tablet, and may incorporate other features such as touch gestures and more.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00421
begin
wwv_flow_api.create_page(
 p_id=>421
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Navigation'
,p_alias=>'NAVIGATION2'
,p_step_title=>'Navigation'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(606904609891638641)
,p_plug_name=>'Side Menu'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>This common navigation pattern is typically referred to as a <b>hamburger menu</b>, drawer menu, or tree navigation and is well suited for applications that have many navigation items, or require nested navigation. On small screens, you simply tap'
||' on the hamburger icon near the top left (or top right when using right-to-left languages) corner of your screen and the menu will slide out. You can make a selection and immediately navigate to the selected item.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(606904726197638642)
,p_plug_name=>'Instructions'
,p_parent_plug_id=>wwv_flow_api.id(606904609891638641)
,p_region_css_classes=>'dm-Hero-steps'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>Steps</strong></p>',
'',
'<ul>',
'  <li>Go to Shared Components &rarr; User Interface Attributes &rarr; Edit Desktop</li>',
'  <li>Scroll to Navigation Menu and set <b>Position</b> to Side</li>',
'  <li>Set the <b>List Template</b> to Side Navigation Menu</li>',
'</ul>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(606905024109638645)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(606904609891638641)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3:margin-top-md'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'LIST'
,p_attribute_04=>'Side Navigation Menu'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1928343924705643460)
,p_plug_name=>'Side Menu Sample'
,p_parent_plug_id=>wwv_flow_api.id(606904609891638641)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="dm-Icon dm-Icon--page side-nav-one-column"></span>',
'<button class="t-Button t-Button--icon t-Button--iconRight" onclick="apex.theme42demo.openMobileSamplePage(''f?p=&APP_ID.:1101:&APP_SESSION.'',''Page with Side Menu'')" type="button">View Sample</span>',
'</button>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1928343394258643448)
,p_plug_name=>'Tab Menu'
,p_region_name=>'standard'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Tabs are another very common navigation pattern for small screen devices.  These tabs will automatically position themselves near the top or bottom of the screen depending on the device screensize.  On small screens, the tabs menu will be displaye'
||'d at the bottom of the screen allowing for comfortable use with one hand. On larger screens, the tabs will be near the top of the screen.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(606904861448638643)
,p_plug_name=>'Instructions'
,p_parent_plug_id=>wwv_flow_api.id(1928343394258643448)
,p_region_css_classes=>'dm-Hero-steps'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>Steps</strong></p>',
'',
'<ul>',
'  <li>Go to Shared Components &rarr; User Interface Attributes &rarr; Edit Desktop</li>',
'  <li>Scroll to Navigation Menu and set <b>Position</b> to Top</li>',
'  <li>Set the <b>List Template</b> to Top Navigation Tabs</li>',
'</ul>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(606904972531638644)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(1928343394258643448)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3:margin-top-md'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'LIST'
,p_attribute_04=>'Top Navigation Tabs'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1928344381816643460)
,p_plug_name=>'Tab Menu Sample'
,p_parent_plug_id=>wwv_flow_api.id(1928343394258643448)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="dm-Icon dm-Icon--page top-nav-one-column"></span>',
'<button class="t-Button t-Button--icon t-Button--iconRight" onclick="apex.theme42demo.openMobileSamplePage(''f?p=&APP_ID.:1115:&APP_SESSION.'',''Page with Tabs Menu'')" type="button">View Sample</span>',
'</button>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2980695377329534171)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4400329440104512860)
,p_plug_name=>'Overview'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>'<p>Navigation within your application is critical to its success. When building applications for mobile, it is important to keep in mind the complexity of the application you are developing and which navigation pattern makes most sense for your speci'
||'fic use case. Here are two of the mobile-friendly navigation patterns available in Universal Theme and when to pick one over the other.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00422
begin
wwv_flow_api.create_page(
 p_id=>422
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Headers and Footers'
,p_alias=>'HEADERS-AND-FOOTERS'
,p_step_title=>'Headers and Footers'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(606905233065638647)
,p_plug_name=>'Mobile Page Footer'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You can configure a <b>Buttons Container</b> region so that it sticks to the bottom of the page for small screen devices.  This could be useful for when you want to have one set of buttons for a given page and position them to the bottom when a sm'
||'all screen device is used.</p>',
'',
'<p><b>Steps</b></p>',
'<ol>',
'  <li>Create a Region with the region template set to <b>Buttons Container</b></li>',
'  <li>Modify the Template Options for this region and check the <b>Stick to Bottom on Mobile</b> option</li>',
'</ol>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(756694554592321910)
,p_plug_name=>'Page Footer Examples'
,p_parent_plug_id=>wwv_flow_api.id(606905233065638647)
,p_icon_css_classes=>'fa-mouse-pointer'
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--customIcons:t-Alert--info:t-Alert--removeHeading js-removeLandmark:margin-top-md'
,p_plug_template=>wwv_flow_api.id(591654834181983844)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<b>Page Footer Examples</b>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1354777993915433145)
,p_plug_name=>'Mobile Page Header'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The <b>Breadcrumb Bar</b> region position on any given Page Template within Universal Theme is designed to persist on large screens as the user scrolls.  This is the position where the Breadcrumbs component, or Hero region, is typically placed.</p'
||'>',
'',
'<p>By default, the contents of this region are not stuck to the top of the screen for small screen devices as it can take away valuable screen realestate on small screens. However, if you wish to persist this header to always be visible on a given pa'
||'ge, you can add the following JavaScript API call to make this happen.</p>',
'',
'<p><b>Steps</b></p>',
'<ol>',
'  <li>Select the Page in Page Designer</li>',
'  <li>Modify the Template Options for the page and check the <b>Sticky Header on Mobile</b> option</li>',
'</ol>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(756694239498321907)
,p_plug_name=>'Page Header Examples'
,p_parent_plug_id=>wwv_flow_api.id(1354777993915433145)
,p_icon_css_classes=>'fa-mouse-pointer'
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--customIcons:t-Alert--info:t-Alert--removeHeading js-removeLandmark:margin-top-md'
,p_plug_template=>wwv_flow_api.id(591654834181983844)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<b>Page Header Examples</b>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3728568761353328675)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5148202824128307364)
,p_plug_name=>'Overview'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>'<p>Many mobile apps share a common pattern for placement of buttons and other content. This content is typically positioned on the header or footer of the page which is easily accessible and on screen for quick actions. This page explains how you can'
||' apply this pattern for your own apps.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(756694311439321908)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(756694239498321907)
,p_button_name=>'HEADER_1'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:t-Button--link:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Header Example 1'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.theme42demo.openMobileSamplePage(''f?p=&APP_ID.:1116:&APP_SESSION.:sample1'',''Sticky Page Header'');'
,p_icon_css_classes=>'fa-external-link-square'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(756694842125321913)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(756694554592321910)
,p_button_name=>'FOOTER_1'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:t-Button--link:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Footer Example 1'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.theme42demo.openMobileSamplePage(''f?p=&APP_ID.:1117:&APP_SESSION.:sample1'',''Sticky Page Header'');'
,p_icon_css_classes=>'fa-external-link-square'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(756694455465321909)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(756694239498321907)
,p_button_name=>'HEADER_2'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:t-Button--link:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Header Example 2'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.theme42demo.openMobileSamplePage(''f?p=&APP_ID.:1116:&APP_SESSION.:sample2'',''Sticky Page Header'');'
,p_icon_css_classes=>'fa-external-link-square'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(756694985660321914)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(756694554592321910)
,p_button_name=>'FOOTER_2'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:t-Button--link:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Footer Example 2'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.theme42demo.openMobileSamplePage(''f?p=&APP_ID.:1117:&APP_SESSION.:sample2'',''Sticky Page Header'');'
,p_icon_css_classes=>'fa-external-link-square'
);
end;
/
prompt --application/pages/page_00423
begin
wwv_flow_api.create_page(
 p_id=>423
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Data Entry'
,p_alias=>'DATA-ENTRY2'
,p_step_title=>'Data Entry'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(756696138389321926)
,p_plug_name=>'Good Design Practices'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Here are some good design practices to follow when designing pages and apps for small screen devices.</p>',
'',
'<ul class="dm-UL">',
'<li><strong>Limit the number of fields to fill out</strong><br />',
'      Fewer fields to complete means a higher successrate of users completing the form. Whenever possible, use smart defaults, and employ HTML5 apis such as <a href="https://developer.mozilla.org/en-US/docs/Web/API/Geolocation/Using_geolocation" targ'
||'et="_blank">geolocation</a> to capture location data rather than asking the user to enter it manually.</li>',
'<li><strong>Use radio buttons in place of select lists when possible</strong><br />',
'      You can improve the usability of your form by replacing select lists which have a few options to a radio button.  This will result in fewer taps to see the available options as they will already be displayed on screen.  You can go even further '
||'by setting the <a href="f?p=&APP_ID.:1204">Display as Pill Button</a> template option to provide a more user friendly control.</li>',
'<li><strong>Position submit buttons near the end of the form</strong><br />',
'      This simple trick will make it far more easier to reach and tap on the submit button.</li>',
'<li><strong>Avoid using heavy controls and widgets</strong><br />',
'      While it may be tempting to use Interactive Grid on a phone, there may be alternatives that provide better usability and mobile performance. When in doubt, try to avoid large controls like Interactive Grids on mobile screens and instead try to '
||'optimize for user experience.</li>',
'</ul>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2111529969112116668)
,p_plug_name=>'Form Design'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When designing your data entry screens for mobile, consider using the <b>Floating Labels</b> field templates for your page items.  These templates are especially optimized for mobile use cases as they provide a much larger tap area to gain focus a'
||'nd provides larger text for improved readibility.  The field label will automatically shrink as a value is populated, but still remaining on screen so context is not lost.</p>',
'',
'<p>Be sure to visit the <a href="f?p=&APP_ID.:1603">Components &rarr; Forms &rarr; Floating Labels</a> page for additional examples.</p>',
'',
'<p><b>Steps</b></p>',
'<ol>',
'  <li>Select the page item in Page Designer</li>',
'  <li>Modify the Template property under Appearance</li>',
'  <li>Select either the <b>Optional - Floating</b> or <b>Required - Floating</b> template from the select list.</li>',
'</ol>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1513446214695005430)
,p_plug_name=>'Mobile Form Example'
,p_parent_plug_id=>wwv_flow_api.id(2111529969112116668)
,p_icon_css_classes=>'fa-mouse-pointer'
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--customIcons:t-Alert--info:t-Alert--removeHeading js-removeLandmark:margin-top-md'
,p_plug_template=>wwv_flow_api.id(591654834181983844)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<b>Mobile Form Examples</b>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4485320736550012198)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5904954799324990887)
,p_plug_name=>'Overview'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>'<p>Data entry is a key component of many APEX apps and should be very carefully considered when designing screens for mobile use cases.  This page outlines a few patterns that Universal Theme provides as well as some general guidelines when designing'
||' forms and data entry pages for small screens.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(756752904920683542)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1513446214695005430)
,p_button_name=>'FORM_1'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:t-Button--link:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Form Sample 1'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.theme42demo.openMobileSamplePage(''f?p=&APP_ID.:1604:&APP_SESSION.:sample1'',''Sticky Page Header'');'
,p_icon_css_classes=>'fa-external-link-square'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(756753360272683543)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1513446214695005430)
,p_button_name=>'FORM_2'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:t-Button--link:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Form Sample 2'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.theme42demo.openMobileSamplePage(''f?p=&APP_ID.:1604:&APP_SESSION.:sample2'',''Sticky Page Header'');'
,p_icon_css_classes=>'fa-external-link-square'
);
end;
/
prompt --application/pages/page_00424
begin
wwv_flow_api.create_page(
 p_id=>424
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Touch Gestures'
,p_alias=>'TOUCH-GESTURES'
,p_step_title=>'Touch Gestures'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(790286805160406320)
,p_plug_name=>'Press'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(790286978766406321)
,p_plug_name=>'Touch Region'
,p_region_name=>'press_region'
,p_parent_plug_id=>wwv_flow_api.id(790286805160406320)
,p_region_css_classes=>'touch-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="anim-icon">',
'<span class="fa fa-hand-pointer-o fa-lg js-event-icon" aria-hidden="true"></span> <span class="js-event-text">Press me!</span>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(790287072207406322)
,p_plug_name=>'Details'
,p_parent_plug_id=>wwv_flow_api.id(790286805160406320)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><b>Notable <code>press</code> event data</b></p>',
'<ul>',
'  <li><code>this.data.pointerType</code> type of pointer (mouse or touch)</li>',
'</ul>',
'<p>Note: <code>press</code> events can also be triggered by clicking and holding</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(790287185097406323)
,p_plug_name=>'Swipe'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(790287205991406324)
,p_plug_name=>'Touch Region'
,p_region_name=>'swipe_region'
,p_parent_plug_id=>wwv_flow_api.id(790287185097406323)
,p_region_css_classes=>'touch-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="anim-icon">',
'<span class="fa fa-hand-pointer-o fa-lg js-event-icon" aria-hidden="true"></span> <span class="js-event-text">Swipe me!</span>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(790287322919406325)
,p_plug_name=>'Details'
,p_parent_plug_id=>wwv_flow_api.id(790287185097406323)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><b>Notable <code>swipe</code> event data</b></p>',
'<ul>',
'  <li><code>this.data.offsetDirection</code> swipe direction (2 left, 4 right)</li>',
'  <li><code>this.data.distance</code> distance of the swipe gesture</li>',
'  <li><code>this.data.pointerType</code> type of pointer (mouse or touch)</li>',
'</ul>',
'<p>Note: <code>swipe</code> events can also be triggered by clicking and quickly moving the cursor to the right or left</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(790287498277406326)
,p_plug_name=>'Pan'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(790287523852406327)
,p_plug_name=>'Touch Region'
,p_region_name=>'pan_region'
,p_parent_plug_id=>wwv_flow_api.id(790287498277406326)
,p_region_css_classes=>'touch-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="anim-icon">',
'<span class="fa fa-hand-pointer-o fa-lg js-event-icon" aria-hidden="true"></span> <span class="js-event-text">Pan me!</span>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(790287628781406328)
,p_plug_name=>'Details'
,p_parent_plug_id=>wwv_flow_api.id(790287498277406326)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><b>Notable <code>pan</code> event data</b></p>',
'<ul>',
'  <li><code>this.data.offsetDirection</code> swipe direction (2 left, 4 right, 8 up, 16 down)</li>',
'  <li><code>this.data.isFinal</code> returns <code>true</code> if it is the last input</li>',
'  <li><code>this.data.pointerType</code> type of pointer (mouse or touch)</li>',
'</ul>',
'<p>Note: <code>pan</code> events can also be triggered by clicking and dragging</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1513525009799595890)
,p_plug_name=>'Tap'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(768342462273393721)
,p_plug_name=>'Touch Region'
,p_region_name=>'tap_region'
,p_parent_plug_id=>wwv_flow_api.id(1513525009799595890)
,p_region_css_classes=>'touch-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="anim-icon">',
'<span class="fa fa-hand-pointer-o fa-lg js-event-icon" aria-hidden="true"></span> <span class="js-event-text">Tap me!</span>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(768342534459393722)
,p_plug_name=>'Details'
,p_parent_plug_id=>wwv_flow_api.id(1513525009799595890)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><b>Notable <code>tap</code> event data</b></p>',
'<ul>',
'  <li><code>this.data.tapCount</code> number of times the screen was tapped</li>',
'  <li><code>this.data.pointerType</code> type of pointer (mouse or touch)</li>',
'</ul>',
'<p>Note: <code>tap</code> events can also be triggered by clicking</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2868358840522390632)
,p_plug_name=>'Available Gestures'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>APEX 18.1 provides declarative support for the following touch gestures via Dynamic Actions:</p>',
'',
'<ul>',
'  <li>tap and double tap</li>',
'  <li>press</li>',
'  <li>swipe</li>',
'  <li>pan</li>',
'</ul>',
'',
'<p>Note: While APEX wraps these touch events to make them accessible via Dynamic Actions, the underlying touch support is powered using the <a href="http://hammerjs.github.io/" target="_blank">hammer.js</a> library.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5242149607960286162)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6661783670735264851)
,p_plug_name=>'Overview'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>'<p>Adding touch support to your APEX apps help provide an improved and more natural mobile experience. This is especially important if your apps are more likely to be used on touch devices, such as smartphones or tablest. This page walks you through '
||'how you can use declarative touch events, introduced in APEX 18.1, to build touch friendly UIs.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(756697923515321944)
,p_name=>'Tap'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(768342462273393721)
,p_bind_type=>'bind'
,p_bind_event_type=>'apextap'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(756698098440321945)
,p_event_id=>wwv_flow_api.id(756697923515321944)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var tapCount = this.data.tapCount;',
'var touchRegion$ = $(this.triggeringElement);',
'touchRegion$.find(".js-event-text").text("Tapped " + tapCount + " times!");',
'',
'var animationEvent = ''webkitAnimationEnd oanimationend msAnimationEnd animationend'';',
'touchRegion$.addClass(''is-active'');',
'touchRegion$.one(animationEvent, function(event) {',
'    touchRegion$.removeClass(''is-active'');',
'});'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(756698344331321948)
,p_name=>'Press'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(790286978766406321)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexpress'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(756698461288321949)
,p_event_id=>wwv_flow_api.id(756698344331321948)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var touchRegion$ = $(this.triggeringElement);',
'touchRegion$.find(".js-event-text").text("Pressed!");',
'',
'var animationEvent = ''webkitAnimationEnd oanimationend msAnimationEnd animationend'';',
'',
'touchRegion$.addClass(''is-active'');',
'touchRegion$.find(".js-event-icon").removeClass("fa-hand-pointer-o").addClass("fa-hand-grab-o");',
'touchRegion$.one(animationEvent, function(event) {',
'    touchRegion$.removeClass(''is-active'').find(".js-event-icon").addClass("fa-hand-pointer-o").removeClass("fa-hand-grab-o");',
'});'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(768341253404393709)
,p_name=>'Swipe'
,p_event_sequence=>40
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(790287205991406324)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexswipe'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(768341323051393710)
,p_event_id=>wwv_flow_api.id(768341253404393709)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var touchRegion$ = $(this.triggeringElement);',
'var text$ = touchRegion$.find(".js-event-text");',
'var icon$ = touchRegion$.find(".js-event-icon");',
'var swipeDir = this.data.offsetDirection;',
'',
'var message, icon;',
'',
'if (swipeDir === 2) {',
'    message = ''Swiped Left!''',
'    icon = ''fa-hand-o-left''',
'} else if (swipeDir === 4) {',
'    message = ''Swiped Right!''',
'    icon = ''fa-hand-o-right''',
'}',
'',
'text$.text(message);',
'',
'icon$.removeClass("fa-hand-pointer-o fa-hand-o-right fa-hand-o-left").addClass(icon);',
'var animationEvent = ''webkitAnimationEnd oanimationend msAnimationEnd animationend'';',
'touchRegion$.addClass(''is-active'');',
'touchRegion$.one(animationEvent, function(event) {',
'    touchRegion$.removeClass(''is-active'');',
'});'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(768341424992393711)
,p_name=>'Pan'
,p_event_sequence=>50
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(790287523852406327)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexpan'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(768341575041393712)
,p_event_id=>wwv_flow_api.id(768341424992393711)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var touchRegion$ = $(this.triggeringElement);',
'var text$ = touchRegion$.find(".js-event-text");',
'var icon$ = touchRegion$.find(".js-event-icon");',
'var swipeDir = this.data.offsetDirection;',
'',
'var offsetX = (touchRegion$.outerWidth() / 2) - 24;',
'',
'var message, icon;',
'',
'if (swipeDir === 2) {',
'    message = ''Panning Left!''',
'    icon = ''fa-hand-o-left''',
'} else if (swipeDir === 4) {',
'    message = ''Panning Right!''',
'    icon = ''fa-hand-o-right''',
'}',
'',
'if (this.data.isFinal ) {',
'    icon$.css("position","static");',
'} else {',
'    icon$.css({',
'        position: "absolute",',
'        left: this.data.deltaX + offsetX',
'    })',
'}',
'',
'// reset icon after 1000 ms',
'setTimeout(function(){',
'    icon$.css("position","static");',
'}, 1000);',
'',
'text$.text(message);',
'icon$.removeClass("fa-hand-pointer-o fa-hand-o-right fa-hand-o-left fa-hand-o-up fa-hand-o-down").addClass(icon);'))
);
end;
/
prompt --application/pages/page_00425
begin
wwv_flow_api.create_page(
 p_id=>425
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'jQuery Mobile Components'
,p_alias=>'JQUERY-MOBILE-COMPONENTS'
,p_step_title=>'jQuery Mobile Components'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(790288487018406336)
,p_plug_name=>'Column Toggle Report'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The column toggle table mode selectively hides columns at narrower widths as a sensible default but also offers a menu to let users manually control which columns they want to see.',
'',
'<p>The Column Toggle Report provides a responsive table-based report that can selectively hide columns based on the width of the screen. There is also a column selection control where you can manually set the columns to display. This component is ide'
||'ally suited for display tabular data in an easily consumable manner for small screen devices.</p>',
'',
'<p>Be sure to visit the <a href="f?p=&APP_ID.:1720">Components &rarr; Data Tables and Reports &rarr; Column Toggle Report</a> page for additional examples.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(790288503092406337)
,p_plug_name=>'Column Toggle Examples'
,p_parent_plug_id=>wwv_flow_api.id(790288487018406336)
,p_icon_css_classes=>'fa-mouse-pointer'
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--customIcons:t-Alert--info:t-Alert--removeHeading js-removeLandmark:margin-top-md'
,p_plug_template=>wwv_flow_api.id(591654834181983844)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<b>Column Toggle Examples</b>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(790511944527235906)
,p_plug_name=>'Reflow Report'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Reflow Report provides another responsive table-based report where on small screens, the table columns become stacked and each row becomes a block of data.',
'This is an alternative display to the Column Toggle Report and can be useful when you want to display all columns of a tabular report in a way that works well for small screens.</p>',
'',
'<p>Be sure to visit the <a href="f?p=&APP_ID.:1710">Components &rarr; Data Tables and Reports &rarr; Reflow Report</a> page for additional examples.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(790512059163235907)
,p_plug_name=>'Reflow Report Examples'
,p_parent_plug_id=>wwv_flow_api.id(790511944527235906)
,p_icon_css_classes=>'fa-mouse-pointer'
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--customIcons:t-Alert--info:t-Alert--removeHeading js-removeLandmark:margin-top-md'
,p_plug_template=>wwv_flow_api.id(591654834181983844)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<b>Reflow Report Examples</b>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2901995465613168183)
,p_plug_name=>'List View'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The List View component provides a simple list-based user interface that has a wide range of features. This component has built in search, list dividers, counters, nested lists, and more.</p>',
'',
'<p>Be sure to visit the <a href="f?p=&APP_ID.:1700">Components &rarr; List View</a> page for additional examples.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2303911711196056945)
,p_plug_name=>'List View Examples'
,p_parent_plug_id=>wwv_flow_api.id(2901995465613168183)
,p_icon_css_classes=>'fa-mouse-pointer'
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--customIcons:t-Alert--info:t-Alert--removeHeading js-removeLandmark:margin-top-md'
,p_plug_template=>wwv_flow_api.id(591654834181983844)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<b>List View Examples</b>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5275786233051063713)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6695420295826042402)
,p_plug_name=>'Overview'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>'<p>APEX 18.1 introduces three new Region Types that have been ported from the jQuery Mobile user interface. These components are light weight, mobile friendly, and can help to simplify your apps transition from jQuery Mobile to Universal Theme.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790288682680406338)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(790288503092406337)
,p_button_name=>'COL_TOGGLE_1'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:t-Button--link:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Example 1'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.theme42demo.openMobileSamplePage(''f?p=&APP_ID.:1721:&APP_SESSION.:sample1'',''Column Toggle Report'');'
,p_icon_css_classes=>'fa-external-link-square'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790466406120051534)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2303911711196056945)
,p_button_name=>'LIST_1'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:t-Button--link:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Example 1'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.theme42demo.openMobileSamplePage(''f?p=&APP_ID.:1701:&APP_SESSION.:sample1'',''List View'');'
,p_icon_css_classes=>'fa-external-link-square'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790512163100235908)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(790512059163235907)
,p_button_name=>'REFLOW_1'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:t-Button--link:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Example 1'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.theme42demo.openMobileSamplePage(''f?p=&APP_ID.:1711:&APP_SESSION.:sample1'',''Reflow Report'');'
,p_icon_css_classes=>'fa-external-link-square'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790288729450406339)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(790288503092406337)
,p_button_name=>'COL_TOGGLE_2'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:t-Button--link:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Example 2'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.theme42demo.openMobileSamplePage(''f?p=&APP_ID.:1721:&APP_SESSION.:sample2'',''Column Toggle Report'');'
,p_icon_css_classes=>'fa-external-link-square'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790512266399235909)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(790512059163235907)
,p_button_name=>'REFLOW_2'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:t-Button--link:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Example 2'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.theme42demo.openMobileSamplePage(''f?p=&APP_ID.:1711:&APP_SESSION.:sample2'',''Reflow Report'');'
,p_icon_css_classes=>'fa-external-link-square'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790466803294051534)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2303911711196056945)
,p_button_name=>'LIST_2'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:t-Button--link:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Example 2'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.theme42demo.openMobileSamplePage(''f?p=&APP_ID.:1701:&APP_SESSION.:sample2'',''List View'');'
,p_icon_css_classes=>'fa-external-link-square'
);
end;
/
prompt --application/pages/page_00500
begin
wwv_flow_api.create_page(
 p_id=>500
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Getting Started'
,p_alias=>'GETTING-STARTED'
,p_step_title=>'Getting Started - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(480456949718117288)
,p_plug_name=>'How do I start using Universal Theme?'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>It is easy to get started using Universal Theme. Just follow the Create Application wizard to get something up and running. From here you can start to build out your application, start customizing it using Template Options and Theme Roller, and le'
||'arn all about it in this very app.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2122543010035810118)
,p_plug_name=>'Getting Started'
,p_icon_css_classes=>'fa-lg fa-mouse-pointer u-color-1'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1224989219520090364)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2152195088034275439)
,p_plug_name=>'Explore Universal Theme'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_component_template_options=>'#DEFAULT#:t-Cards--featured force-fa-lg:t-Cards--displayIcons:t-Cards--3cols:t-Cards--hideBody:t-Cards--animColorFill'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(2199914850856725555)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_00600
begin
wwv_flow_api.create_page(
 p_id=>600
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'About'
,p_alias=>'ABOUT'
,p_step_title=>'About - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210920132731'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(480671031654352774)
,p_plug_name=>'Hero'
,p_region_css_classes=>'dm-Hero dm-Hero--primary'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<h1>About</h1>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(480671561256352791)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(480954877218755872)
,p_plug_name=>'Region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693720241683042113)
,p_name=>'P600_PICK_FILES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(480954877218755872)
,p_prompt=>'Pick files'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'SESSION'
,p_attribute_10=>'Y'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693720306661042114)
,p_name=>'P600_PICK_FILE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(480954877218755872)
,p_prompt=>'Pick files'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'SESSION'
,p_attribute_10=>'N'
,p_attribute_12=>'INLINE'
);
end;
/
prompt --application/pages/page_00700
begin
wwv_flow_api.create_page(
 p_id=>700
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Layout'
,p_alias=>'LAYOUT'
,p_step_title=>'Layout - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1644987997495870601)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(390432996821898105)
,p_branch_name=>'Redirect to Grid Layout Page'
,p_branch_action=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:NONE::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00701
begin
wwv_flow_api.create_page(
 p_id=>701
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Responsive Design'
,p_alias=>'RESPONSIVE-DESIGN'
,p_step_title=>'Responsive Design - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2523817529264280284)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_01100
begin
wwv_flow_api.create_page(
 p_id=>1100
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Pages'
,p_alias=>'PAGES'
,p_step_title=>'Pages - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_javascript_code_onload=>'apex.theme42demo.jump(''&REQUEST.'');'
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_page_comment=>'apex.theme42demo.noNavigate();'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(879725051497769501)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208177424805979201)
,p_plug_name=>'Standard Page'
,p_region_name=>'standard'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The default page template. Ideal for home pages, dashboards, large reports, and other layouts where maximum screen real-estate is desired.<p>',
'<p class="dm-Hero-steps">Set <strong>Standard</strong> as the Page Template</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208177955252979213)
,p_plug_name=>'Standard Page with Side Navigation'
,p_parent_plug_id=>wwv_flow_api.id(1208177424805979201)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="dm-Icon dm-Icon--page side-nav-one-column"></span>',
'<button class="t-Button t-Button--icon t-Button--iconRight" onclick="apex.theme42demo.openSamplePage(''f?p=&APP_ID.:1101:&APP_SESSION.'',''Standard with Side Navigation'')" type="button">View Sample</span>',
'</button>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208178412363979213)
,p_plug_name=>'Standard Page with Top Navigation'
,p_parent_plug_id=>wwv_flow_api.id(1208177424805979201)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="dm-Icon dm-Icon--page top-nav-one-column"></span>',
'<button class="t-Button t-Button--icon t-Button--iconRight" onclick="apex.theme42demo.openSamplePage(''f?p=&APP_ID.:1102:&APP_SESSION.'',''Standard with Top Navigation'')" type="button">View Sample</span>',
'</button>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208510599141392012)
,p_plug_name=>'Left Side Column'
,p_region_name=>'left_side'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Features a left-side display position for search filters, charts, and other interactive widgets.<p>',
'<p class="dm-Hero-steps">Set <strong>Left Side Column</strong> as the Page Template</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208516421329446152)
,p_plug_name=>'Left Side Column with Side Navigation'
,p_parent_plug_id=>wwv_flow_api.id(1208510599141392012)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="dm-Icon dm-Icon--page side-nav-left-column"></span>',
'<button class="t-Button t-Button--icon t-Button--iconRight" onclick="apex.theme42demo.openSamplePage(''f?p=&APP_ID.:1103:&APP_SESSION.'',''Left Side Column Page with Side Navigation'')" type="button">View Sample</span>',
'</button>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208516914292446153)
,p_plug_name=>'Left Side Column with Top Navigation'
,p_parent_plug_id=>wwv_flow_api.id(1208510599141392012)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="dm-Icon dm-Icon--page top-nav-left-column"></span>',
'<button class="t-Button t-Button--icon t-Button--iconRight" onclick="apex.theme42demo.openSamplePage(''f?p=&APP_ID.:1104:&APP_SESSION.'',''Left Side Column Page with Top Navigation'')" type="button">View Sample</span>',
'</button>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208582755068851134)
,p_plug_name=>'Right Side Column'
,p_region_name=>'right_side'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page template features a collapsible right-side display position and is especially useful for displaying action-oriented controls such as buttons or lists.<p>',
'<p class="dm-Hero-steps">Set <strong>Right Side Column</strong> as the Page Template</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208588399024861465)
,p_plug_name=>'Right Side Column with Side Navigation'
,p_parent_plug_id=>wwv_flow_api.id(1208582755068851134)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="dm-Icon dm-Icon--page side-nav-right-column"></span>',
'<button class="t-Button t-Button--icon t-Button--iconRight" onclick="apex.theme42demo.openSamplePage(''f?p=&APP_ID.:1105:&APP_SESSION.'',''Right Side Column Page with Side Navigation'')" type="button">View Sample</span>',
'</button>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208588921163861465)
,p_plug_name=>'Right Side Column with Top Navigation'
,p_parent_plug_id=>wwv_flow_api.id(1208582755068851134)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="dm-Icon dm-Icon--page top-nav-right-column"></span>',
'<button class="t-Button t-Button--icon t-Button--iconRight" onclick="apex.theme42demo.openSamplePage(''f?p=&APP_ID.:1106:&APP_SESSION.'',''Right Side Column Page with Top Navigation'')" type="button">View Sample</span>',
'</button>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208592780290878079)
,p_plug_name=>'Both Side Column'
,p_region_name=>'both_sides'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page template features both the left side column and the collapsible right-side column and is well suited for very complex pages.<p>',
'<p class="dm-Hero-steps">Set <strong>Left and Right Side Columns</strong> as the Page Template</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208598100460891250)
,p_plug_name=>'Side Columns Page with Side Navigation'
,p_parent_plug_id=>wwv_flow_api.id(1208592780290878079)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="dm-Icon dm-Icon--page side-nav-side-columns"></span>',
'<button class="t-Button t-Button--icon t-Button--iconRight" onclick="apex.theme42demo.openSamplePage(''f?p=&APP_ID.:1109:&APP_SESSION.'',''Left and Right Side Columns Page with Side Navigation'')" type="button">View Sample</span>',
'</button>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208598434970891250)
,p_plug_name=>'Side Columns Page with Top Navigation'
,p_parent_plug_id=>wwv_flow_api.id(1208592780290878079)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="dm-Icon dm-Icon--page top-nav-side-columns"></span>',
'<button class="t-Button t-Button--icon t-Button--iconRight" onclick="apex.theme42demo.openSamplePage(''f?p=&APP_ID.:1110:&APP_SESSION.'',''Left and Right Side Columns Page with Top Navigation'')" type="button">View Sample</span>',
'</button>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208604537937911419)
,p_plug_name=>'Marquee Detail'
,p_region_name=>'master_detail'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page template features a collapsible right side column and a title-bar area which contains primary information. This page template is well suited for displaying information about a master record with detailed reports or charts in the body.<p>',
'<p class="dm-Hero-steps">Set <strong>Marquee Detail</strong> as the Page Template</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208618639365930634)
,p_plug_name=>'Master Detail Page with Side Navigation'
,p_parent_plug_id=>wwv_flow_api.id(1208604537937911419)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="dm-Icon dm-Icon--page side-nav-master-detail-page"></span>',
'<button class="t-Button t-Button--icon t-Button--iconRight" onclick="apex.theme42demo.openSamplePage(''f?p=&APP_ID.:1107:&APP_SESSION.'',''Master Detail Page with Side Navigation'')" type="button">View Sample</span>',
'</button>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208619170202930635)
,p_plug_name=>'Right Column Page with Top Navigation'
,p_parent_plug_id=>wwv_flow_api.id(1208604537937911419)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>160
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="dm-Icon dm-Icon--page top-nav-master-detail-page"></span>',
'<button class="t-Button t-Button--icon t-Button--iconRight" onclick="apex.theme42demo.openSamplePage(''f?p=&APP_ID.:1108:&APP_SESSION.'',''Master Detail Page with Top Navigation'')" type="button">View Sample</span>',
'</button>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208636311646946895)
,p_plug_name=>'Dialog'
,p_region_name=>'dialog'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>These page templates can be loaded as either modal or non-modal (pop-up) dialogs and are very useful for displaying commonly used forms, reports, and other components.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208640476642953023)
,p_plug_name=>'Standard Dialog Page'
,p_parent_plug_id=>wwv_flow_api.id(1208636311646946895)
,p_region_css_classes=>'dm-Hero-screenshot'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p class="dm-Hero-steps dm-Hero-steps--slim">Set <strong>Standard Dialog</strong> as the Page Template</p>',
'<span class="dm-Icon dm-Icon--page standard-dialog"></span>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208641280982953025)
,p_plug_name=>'Wizard Dialog Page'
,p_parent_plug_id=>wwv_flow_api.id(1208636311646946895)
,p_region_css_classes=>'dm-Hero-screenshot'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>160
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p class="dm-Hero-steps dm-Hero-steps--slim">Set <strong>Wizard Dialog</strong> as the Page Template</p>',
'<span class="dm-Icon dm-Icon--page wizard-dialog"></span>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208659039984989922)
,p_plug_name=>'Other'
,p_region_name=>'other'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The <strong>Login</strong> page template provides an elegant user interface for your app''s log in page.<p>',
'<p>The <strong>Minimal Page</strong> page template is useful for single page applications or pages where where navigation is not necessary.<p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208663557461994609)
,p_plug_name=>'Minimal Page Template'
,p_parent_plug_id=>wwv_flow_api.id(1208659039984989922)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p class="dm-Hero-steps dm-Hero-steps--slim">Set <strong>Minimal (No  Navigation)</strong> as the Page Template</p>',
'<span class="dm-Icon dm-Icon--page minimal-page"></span>',
'<button class="t-Button t-Button--icon t-Button--iconRight" onclick="apex.theme42demo.openSamplePage(''f?p=&APP_ID.:1113:&APP_SESSION.'',''Minimal Page without Navigation'')" type="button">View Sample</span>',
'</button>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1208664067487994609)
,p_plug_name=>'Login Page Template'
,p_parent_plug_id=>wwv_flow_api.id(1208659039984989922)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>160
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p class="dm-Hero-steps dm-Hero-steps--slim">Set <strong>Login</strong> as the Page Template</p>',
'<span class="dm-Icon dm-Icon--page login-page"></span>',
'<button class="t-Button t-Button--icon t-Button--iconRight" onclick="apex.theme42demo.openSamplePage(''f?p=&APP_ID.:1114:&APP_SESSION.'',''Login Page'')" type="button">View Sample</span>',
'</button>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885099481441050902)
,p_plug_name=>'Overview'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Page Templates define the layout and purpose of your pages. This page shows samples of all the available page templates. Universal Theme supports two types of Navigation Menus: tree-based navigation on the side, and tab-like navigation on the top.'
||'</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(791529844939869733)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1208640476642953023)
,p_button_name=>'STD_DIALOG_VIEW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'View Sample'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1111:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(791530539726869734)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1208641280982953025)
,p_button_name=>'WIZ_DIALOG_VIEW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'View Sample'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1112:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1917934323891455542)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(879725051497769501)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Page Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:page:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-file-o'
);
end;
/
prompt --application/pages/page_01101
begin
wwv_flow_api.create_page(
 p_id=>1101
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Standard Page Template with Side Navigation'
,p_alias=>'STANDARD-PAGE-TEMPLATE-WITH-SIDE-NAVIGATION'
,p_step_title=>'Standard Page Template with Side Navigation - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'apex.theme42demo.noNavigate();'
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'SIDE'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(1018710602436487872)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1773976052307980488)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1773976524495980524)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885101514886050923)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885101681922050924)
,p_plug_name=>'Region C'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_01102
begin
wwv_flow_api.create_page(
 p_id=>1102
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Standard Page Template with Top Navigation'
,p_alias=>'STANDARD-PAGE-TEMPLATE-WITH-TOP-NAVIGATION'
,p_step_title=>'Standard Page Template with Top Navigation - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'apex.theme42demo.noNavigate();'
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'TOP'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(1077726089382032168)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885099751850050905)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885101715079050925)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885101828783050926)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885245355685551804)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
end;
/
prompt --application/pages/page_01103
begin
wwv_flow_api.create_page(
 p_id=>1103
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Left Column Page with Side Navigation '
,p_alias=>'LEFT-COLUMN-PAGE-WITH-SIDE-NAVIGATION'
,p_step_title=>'Left Column Page with Side Navigation- &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'apex.theme42demo.noNavigate();'
,p_step_template=>wwv_flow_api.id(1077614758642401794)
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'SIDE'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(1018710602436487872)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885101080098050918)
,p_plug_name=>'Side Region'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Side Region</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885103837640050946)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885103913944050947)
,p_plug_name=>'Region C'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885257828714625667)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885259067967625674)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
end;
/
prompt --application/pages/page_01104
begin
wwv_flow_api.create_page(
 p_id=>1104
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Left Column Page with Top Navigation'
,p_alias=>'LEFT-COLUMN-PAGE-WITH-TOP-NAVIGATION'
,p_step_title=>'Left Column Page with Top Navigation - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'apex.theme42demo.noNavigate();'
,p_step_template=>wwv_flow_api.id(1077614758642401794)
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'TOP'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(1077726089382032168)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885104081496050948)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885104191890050949)
,p_plug_name=>'Region C'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885265682494727198)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885266423191727202)
,p_plug_name=>'Side Region'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Side Region</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885267243543727203)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
end;
/
prompt --application/pages/page_01105
begin
wwv_flow_api.create_page(
 p_id=>1105
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Right Column Page with Side Navigation'
,p_alias=>'RIGHT-COLUMN-PAGE-WITH-SIDE-NAVIGATION'
,p_step_title=>'Right Column Page with Side Navigation - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'apex.theme42demo.noNavigate();'
,p_step_template=>wwv_flow_api.id(1077618304322444671)
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'SIDE'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(1018710602436487872)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885104227154050950)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1890858497587160975)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1890858852526160976)
,p_plug_name=>'Side Region'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Side Region</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1890860048222160978)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1897788679843086001)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_01106
begin
wwv_flow_api.create_page(
 p_id=>1106
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Right Column Page with Top Navigation'
,p_alias=>'RIGHT-COLUMN-PAGE-WITH-TOP-NAVIGATION'
,p_step_title=>'Right Column Page with Top Navigation - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'apex.theme42demo.noNavigate();'
,p_step_template=>wwv_flow_api.id(1077618304322444671)
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'TOP'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(1077726089382032168)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1890862418217172583)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1890862818128172585)
,p_plug_name=>'Side Region'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Side Region</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1890864003005172586)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1897788897680086003)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1897788957351086004)
,p_plug_name=>'Region C'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_01107
begin
wwv_flow_api.create_page(
 p_id=>1107
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Marquee Detail Page with Side Navigation'
,p_alias=>'MARQUEE-DETAIL-PAGE-WITH-SIDE-NAVIGATION'
,p_step_title=>'Marquee Detail Page with Side Navigation - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'apex.theme42demo.noNavigate();'
,p_step_template=>wwv_flow_api.id(549332834543365415)
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'SIDE'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(1018710602436487872)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885101187334050919)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885101219323050920)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder h320'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885101388924050921)
,p_plug_name=>'Main Content'
,p_region_css_classes=>'dm-Placeholder h240'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-report"></span>',
'<h3>Main Content Report</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885101422359050922)
,p_plug_name=>'Region C'
,p_region_css_classes=>'dm-Placeholder h320'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1890866935589211371)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder h320'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1890867353532211373)
,p_plug_name=>'Side Content'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Side Region</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1890868575399211375)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
end;
/
prompt --application/pages/page_01108
begin
wwv_flow_api.create_page(
 p_id=>1108
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Marquee Detail Page with Top Navigation'
,p_alias=>'MARQUEE-DETAIL-PAGE-WITH-TOP-NAVIGATION'
,p_step_title=>'Marquee Detail Page with Top Navigation - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'apex.theme42demo.noNavigate();'
,p_step_template=>wwv_flow_api.id(549332834543365415)
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'TOP'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(1077726089382032168)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1891236182800396749)
,p_plug_name=>'Main Content'
,p_region_css_classes=>'dm-Placeholder h240'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-report"></span>',
'<h3>Main Content Report</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1891236566190396749)
,p_plug_name=>'Region C'
,p_region_css_classes=>'dm-Placeholder h320'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1891236990097396750)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1891237342508396750)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder h320'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1891237786108396758)
,p_plug_name=>'Side Content'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Side Region</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1891238103880396759)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder h320'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1891239365191396761)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
end;
/
prompt --application/pages/page_01109
begin
wwv_flow_api.create_page(
 p_id=>1109
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Side Columns Page with Side Navigation'
,p_alias=>'SIDE-COLUMNS-PAGE-WITH-SIDE-NAVIGATION'
,p_step_title=>'Side Columns Page with Side Navigation - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'apex.theme42demo.noNavigate();'
,p_step_template=>wwv_flow_api.id(1077621880644450151)
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'SIDE'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(1018710602436487872)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885103503851050943)
,p_plug_name=>'Side Content'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Left Side Region</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885103641333050944)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1885103709302050945)
,p_plug_name=>'Region C'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1897718715135999477)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1897719107181999481)
,p_plug_name=>'Side Content'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Right Side Region</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1897720315230999483)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
end;
/
prompt --application/pages/page_01110
begin
wwv_flow_api.create_page(
 p_id=>1110
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Side Columns Page with Top Navigation'
,p_alias=>'SIDE-COLUMNS-PAGE-WITH-TOP-NAVIGATION'
,p_step_title=>'Side Columns Page with Top Navigation - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'apex.theme42demo.noNavigate();'
,p_step_template=>wwv_flow_api.id(1077621880644450151)
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'TOP'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(1077726089382032168)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1897730832631021070)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1897731211761021071)
,p_plug_name=>'Region C'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1897732004510021072)
,p_plug_name=>'Side Content'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Left Side Region</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1897732462096021072)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1897732879666021072)
,p_plug_name=>'Side Content'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Right Side Region</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1897733616582021074)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
end;
/
prompt --application/pages/page_01111
begin
wwv_flow_api.create_page(
 p_id=>1111
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Standard Dialog Page'
,p_alias=>'STANDARD-DIALOG-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Standard Dialog Page - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(651378991620880020)
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'TOP'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(1077726089382032168)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1897789529396086010)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1897789666099086011)
,p_plug_name=>'Region C'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1898476875759595924)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_01112
begin
wwv_flow_api.create_page(
 p_id=>1112
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Wizard Dialog Page'
,p_alias=>'WIZARD-DIALOG-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Wizard Dialog Page - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(672766417768219611)
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'TOP'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(1077726089382032168)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1898625483273662544)
,p_plug_name=>'Wizard Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-WizardSteps--displayLabels'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(561122940005233277)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(561120526789187584)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1898625892787662544)
,p_plug_name=>'Region Footer'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(677400524731372757)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1898626629544662545)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1898627034847662546)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1898626281059662545)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1898625892787662544)
,p_button_name=>'NEXT_STEP'
,p_button_static_id=>'next_button'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--large:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'fa-chevron-right'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1897789993983086014)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1898625892787662544)
,p_button_name=>'PREV_STEP'
,p_button_static_id=>'prev_button'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--large'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'fa-chevron-left'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1898627448622662546)
,p_name=>'Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#prev_button, #next_button'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1898627994032662547)
,p_event_id=>wwv_flow_api.id(1898627448622662546)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01113
begin
wwv_flow_api.create_page(
 p_id=>1113
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Minimal Page Template'
,p_alias=>'MINIMAL-PAGE-TEMPLATE'
,p_step_title=>'Minimal Page Template - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(1530046751615002521)
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'TOP'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(1077726089382032168)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1899236298329120711)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1899236693537120715)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1899237456403120715)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1899238137245120733)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
end;
/
prompt --application/pages/page_01114
begin
wwv_flow_api.create_page(
 p_id=>1114
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Login Page Template'
,p_alias=>'LOGIN-PAGE-TEMPLATE'
,p_step_title=>'Login Page Template - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(652129338145143712)
,p_page_template_options=>'#DEFAULT#:t-LoginPage--bg3'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'TOP'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(1077726089382032168)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1899240689882125402)
,p_plug_name=>'Login Region'
,p_icon_css_classes=>'app-sample-universal-theme'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1225129382632869472)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1897790784065086022)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1899240689882125402)
,p_button_name=>'P1114_LOGIN'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Log In'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1897790557366086020)
,p_name=>'P1114_USER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1899240689882125402)
,p_prompt=>'User Name'
,p_placeholder=>'username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(591757292230152601)
,p_item_icon_css_classes=>'fa-user'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1897790694922086021)
,p_name=>'P1114_PASSWORD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1899240689882125402)
,p_prompt=>'Password'
,p_placeholder=>'password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_tag_css_classes=>'icon-login-password'
,p_field_template=>wwv_flow_api.id(591757292230152601)
,p_item_icon_css_classes=>'fa-key'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_01115
begin
wwv_flow_api.create_page(
 p_id=>1115
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Standard Page Template with Tabs Navigation'
,p_alias=>'STANDARD-PAGE-TEMPLATE-WITH-TABS-NAVIGATION'
,p_step_title=>'Standard Page Template with Tabs Navigation'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'apex.theme42demo.noNavigate();'
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'TOP'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(5429749254678674)
,p_nav_list_template_options=>'#DEFAULT#:t-NavTabs--inlineLabels-lg:t-NavTabs--displayLabels-sm'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2506928802273694723)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2506929274461694759)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2618054264851765158)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2618054431887765159)
,p_plug_name=>'Region C'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_01116
begin
wwv_flow_api.create_page(
 p_id=>1116
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Sticky Mobile Header'
,p_alias=>'STICKY-MOBILE-HEADER'
,p_step_title=>'Sticky Mobile Header'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'apex.theme42demo.noNavigate();'
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_template_options=>'#DEFAULT#:js-pageStickyMobileHeader'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'TOP'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(5429749254678674)
,p_nav_list_template_options=>'#DEFAULT#:t-NavTabs--inlineLabels-lg:t-NavTabs--displayLabels-sm'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(606905183851638646)
,p_plug_name=>'Page Header'
,p_icon_css_classes=>'fa-check-circle u-color-1'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1224989219520090364)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'sample1'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(756693698683321901)
,p_plug_name=>'Header Buttons'
,p_region_template_options=>'#DEFAULT#:t-ButtonRegion--slimPadding:t-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(677400524731372757)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source=>'Mobile Page Header'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'sample2'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3254836868438555553)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder h480'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3365962331016625988)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder h480'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3365962498052625989)
,p_plug_name=>'Region C'
,p_region_css_classes=>'dm-Placeholder h480'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(756693854783321903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(756693698683321901)
,p_button_name=>'EDIT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--link'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Edit'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(756693974166321904)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(606905183851638646)
,p_button_name=>'ACTIONS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Actions'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-angle-down'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(756693794498321902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(756693698683321901)
,p_button_name=>'BACK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--link'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-chevron-circle-left'
);
end;
/
prompt --application/pages/page_01117
begin
wwv_flow_api.create_page(
 p_id=>1117
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Sticky Mobile Footer'
,p_alias=>'STICKY-MOBILE-FOOTER'
,p_step_title=>'Sticky Mobile Footer'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'apex.theme42demo.noNavigate();'
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_template_options=>'#DEFAULT#:js-pageStickyMobileHeader'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'SIDE'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(1018710602436487872)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(756677873894197561)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(756695034650321915)
,p_plug_name=>'Page Footer 2'
,p_region_css_classes=>'u-tC'
,p_region_template_options=>'#DEFAULT#:t-ButtonRegion--stickToBottom:t-ButtonRegion--slimPadding'
,p_plug_template=>wwv_flow_api.id(677400524731372757)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'Page Footer'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'sample2'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1363581342422836136)
,p_plug_name=>'Page Footer 1'
,p_region_template_options=>'#DEFAULT#:t-ButtonRegion--stickToBottom:t-ButtonRegion--slimPadding'
,p_plug_template=>wwv_flow_api.id(677400524731372757)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'sample1'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4011513027009753043)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder h480'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4122638489587823478)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder h480'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4122638656623823479)
,p_plug_name=>'Region C'
,p_region_css_classes=>'dm-Placeholder h480'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(606905426347638649)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1363581342422836136)
,p_button_name=>'MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Menu'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-bars'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(756695154452321916)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(756695034650321915)
,p_button_name=>'BUTTON_B'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Button B'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-pencil-square-o'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(756695245524321917)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(756695034650321915)
,p_button_name=>'BUTTON_A'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--link'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Button A'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-list-ul'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(606905539573638650)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1363581342422836136)
,p_button_name=>'PREVIOUS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--link:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-chevron-circle-left'
);
end;
/
prompt --application/pages/page_01120
begin
wwv_flow_api.create_page(
 p_id=>1120
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Navigation Menu - Menu Bar Preview'
,p_alias=>'NAVIGATION-MENU-BAR-PREVIEW'
,p_step_title=>'Navigation Menu - Menu Bar Preview'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'apex.theme42demo.noNavigate();'
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'TOP'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(1077726089382032168)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210920102538'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2725924818969798061)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2725926782198798081)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2725926895902798082)
,p_plug_name=>'Region C'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2726070422805298960)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
end;
/
prompt --application/pages/page_01121
begin
wwv_flow_api.create_page(
 p_id=>1121
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Navigation Menu - Tabs Preview'
,p_alias=>'NAVIGATION-MENU-TABS-PREVIEW'
,p_step_title=>'Navigation Menu - Tabs Preview'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'apex.theme42demo.noNavigate();'
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'TOP'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(5429749254678674)
,p_nav_list_template_options=>'#DEFAULT#:t-NavTabs--inlineLabels-lg:t-NavTabs--displayLabels-sm'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210920102512'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3567217454592581413)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3567219417821581433)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3567219531525581434)
,p_plug_name=>'Region C'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3567363058428082312)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
end;
/
prompt --application/pages/page_01122
begin
wwv_flow_api.create_page(
 p_id=>1122
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Navigation Menu - Mega Menu Preview'
,p_alias=>'NAVIGATION-MENU-MEGA-MENU-PREVIEW'
,p_step_title=>'Navigation Menu - Mega Menu Preview'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'apex.theme42demo.noNavigate();'
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'TOP'
,p_navigation_list_id=>wwv_flow_api.id(842010198961843152)
,p_navigation_list_template_id=>wwv_flow_api.id(217865321596155171)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210920102604'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3567923741416599925)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3567925704645599945)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3567925818349599946)
,p_plug_name=>'Region C'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3568069345252100824)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
end;
/
prompt --application/pages/page_01123
begin
wwv_flow_api.create_page(
 p_id=>1123
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Navigation Menu - Side Tree Navigation Preview'
,p_alias=>'NAVIGATION-MENU-SIDE-TREE-NAVIGATION-PREVIEW'
,p_step_title=>'Navigation Menu - Side Tree Navigation Preview'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'apex.theme42demo.noNavigate();'
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'SIDE'
,p_navigation_list_id=>wwv_flow_api.id(1885182092683398328)
,p_navigation_list_template_id=>wwv_flow_api.id(1018710602436487872)
,p_nav_list_template_options=>'#DEFAULT#:js-navCollapsed--hidden:t-TreeNav--styleA'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210920102635'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4409924890825410758)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4409926854054410778)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4409926967758410779)
,p_plug_name=>'Region C'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4410070494660911657)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
end;
/
prompt --application/pages/page_01124
begin
wwv_flow_api.create_page(
 p_id=>1124
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Navigation Menu - Mega Menu Preview 2'
,p_alias=>'NAVIGATION-MENU-MEGA-MENU-PREVIEW-2'
,p_step_title=>'Navigation Menu - Mega Menu Preview 2'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'apex.theme42demo.noNavigate();'
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'TOP'
,p_navigation_list_id=>wwv_flow_api.id(842010198961843152)
,p_navigation_list_template_id=>wwv_flow_api.id(217865321596155171)
,p_nav_list_template_options=>'#DEFAULT#:js-menu-callout'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210920102619'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4409929726054429774)
,p_plug_name=>'Region A'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4409931689283429794)
,p_plug_name=>'Region B'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4409931802987429795)
,p_plug_name=>'Region C'
,p_region_css_classes=>'dm-Placeholder h180'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4410075329889930673)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
end;
/
prompt --application/pages/page_01201
begin
wwv_flow_api.create_page(
 p_id=>1201
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Regions - Standard'
,p_alias=>'STANDARD-REGION'
,p_step_title=>'Standard Region - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.button-bar .t-Region-buttons.t-Region-buttons--top {',
'  border-bottom: 1px solid rgba(0,0,0,.1);',
'  background-color: rgba(0,0,0,.05);',
'}'))
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405001279057846486)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The generic region template. It works well with all widgets and can be heavily customized.</p>',
'<p class="dm-Hero-steps">Set <strong>Standard </strong> as Region Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405001723120846493)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405002281522846494)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405002796728846494)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405003240543846495)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(405002796728846494)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405003740688846495)
,p_plug_name=>'Standard Region Template'
,p_parent_plug_id=>wwv_flow_api.id(405003240543846495)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-Placeholder h180"> ',
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region Body</h3>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405004218770846496)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405003240543846495)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405004734816846497)
,p_plug_name=>'2. Hidden Heading'
,p_parent_plug_id=>wwv_flow_api.id(405002796728846494)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405005223088846497)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405004734816846497)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>80
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405005744401846498)
,p_plug_name=>'Standard Region Template'
,p_parent_plug_id=>wwv_flow_api.id(405004734816846497)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody:t-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-Placeholder h180"> ',
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region Body</h3>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405006286304846498)
,p_plug_name=>'3. Icon in Region Header'
,p_parent_plug_id=>wwv_flow_api.id(405002796728846494)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405006786681846499)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405006286304846498)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>120
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405007218246846499)
,p_plug_name=>'Standard Region Template'
,p_parent_plug_id=>wwv_flow_api.id(405006286304846498)
,p_icon_css_classes=>'fa-line-chart'
,p_region_template_options=>'#DEFAULT#:t-Region--showIcon:i-h240:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>100
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-Placeholder h180"> ',
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region Body</h3>',
'</div>',
'<div class="dm-Placeholder h180"> ',
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region Body</h3>',
'</div>',
'<div class="dm-Placeholder h180"> ',
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region Body</h3>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405007792785846500)
,p_plug_name=>'4. Variation B'
,p_parent_plug_id=>wwv_flow_api.id(405002796728846494)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405008227709846500)
,p_plug_name=>'Standard Region Template'
,p_parent_plug_id=>wwv_flow_api.id(405007792785846500)
,p_region_template_options=>'#DEFAULT#:js-showMaximizeButton:i-h240:t-Region--accent2:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-Placeholder h180"> ',
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region Body</h3>',
'</div>',
'<div class="dm-Placeholder h180"> ',
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region Body</h3>',
'</div>',
'<div class="dm-Placeholder h180"> ',
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region Body</h3>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405008772612846502)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405007792785846500)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405009288923846503)
,p_plug_name=>'Button Positions'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(481014591124886801)
,p_plug_name=>'About'
,p_parent_plug_id=>wwv_flow_api.id(405009288923846503)
,p_region_template_options=>'#DEFAULT#:margin-bottom-sm'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p class="dm-Hero-steps">The following region shows all possible button positions.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(481014652070886802)
,p_plug_name=>'Region Title'
,p_parent_plug_id=>wwv_flow_api.id(405009288923846503)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405015006685846510)
,p_plug_name=>'Use Cases'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405009717585846503)
,p_plug_name=>'Region with Button Bar'
,p_parent_plug_id=>wwv_flow_api.id(405015006685846510)
,p_region_css_classes=>'button-bar'
,p_icon_css_classes=>'fa-window-user'
,p_region_template_options=>'#DEFAULT#:t-Region--showIcon:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This region demonstrates a button bar that can be used to navigate between widgets, and also display menu buttons.</p>',
'',
'<p>This region also has a custom style applied to the button container. You can style these "button containers" relatively easily by adding some custom CSS to the page. <br />',
'For example, the class <strong>button-bar</strong> has been applied to the region in Page Designer, and the following CSS has been added to the page:</p>',
'',
'<code>',
'.button-bar .t-Region-buttons.t-Region-buttons--top {',
'  border-bottom: 1px solid rgba(0,0,0,.1);',
'  background-color: rgba(0,0,0,.05);',
'}',
'</code>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405015549018846511)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(481014728072886803)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(481014652070886802)
,p_button_name=>'Change_1'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Change'
,p_button_position=>'CHANGE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(481014852273886804)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(481014652070886802)
,p_button_name=>'Close_1'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Close'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(481014949174886805)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(481014652070886802)
,p_button_name=>'Copy_1'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Copy'
,p_button_position=>'COPY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(481015019928886806)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(481014652070886802)
,p_button_name=>'Create_1'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(481015180805886807)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(481014652070886802)
,p_button_name=>'Delete_1'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(481015246460886808)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(481014652070886802)
,p_button_name=>'Edit_1'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Edit'
,p_button_position=>'EDIT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(481015327855886809)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(481014652070886802)
,p_button_name=>'Help_1'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Help'
,p_button_position=>'HELP'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(481015629798886812)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(481014652070886802)
,p_button_name=>'Next_1_1'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405013311816846508)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(405009717585846503)
,p_button_name=>'Next_2'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--small:t-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Previous'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'fa-angle-left'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405013730859846509)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(405009717585846503)
,p_button_name=>'Next_1'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--small:t-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'fa-angle-right'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405014104372846509)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(405009717585846503)
,p_button_name=>'Save'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--small'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1917870983654289187)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_api.id(405002281522846494)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:region:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-window-alt-2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(481015887399886814)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(481014652070886802)
,p_button_name=>'Previous_1'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405014533297846509)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(405009717585846503)
,p_button_name=>'Menu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--small:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Menu Button'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'fa-angle-down'
);
end;
/
prompt --application/pages/page_01202
begin
wwv_flow_api.create_page(
 p_id=>1202
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Region - Alert'
,p_alias=>'ALERT-REGION'
,p_step_title=>'Alert - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405030026238865667)
,p_plug_name=>'Button Positions'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405030534855865669)
,p_plug_name=>'Alert Region with Buttons'
,p_parent_plug_id=>wwv_flow_api.id(405030026238865667)
,p_region_template_options=>'#DEFAULT#:t-Alert--wizard:t-Alert--customIcons:t-Alert--success'
,p_plug_template=>wwv_flow_api.id(591654834181983844)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>Your request has been submitted successfully. Please check again later in 30 minutes.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405032626695865671)
,p_plug_name=>'Use Cases'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(430900888269155819)
,p_plug_name=>'Order Created Successfully'
,p_parent_plug_id=>wwv_flow_api.id(405032626695865671)
,p_icon_css_classes=>'fa-check-circle'
,p_region_template_options=>'#DEFAULT#:t-Alert--colorBG:t-Alert--wizard:t-Alert--customIcons:t-Alert--success'
,p_plug_template=>wwv_flow_api.id(591654834181983844)
,p_plug_display_sequence=>180
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>A confirmation email has been sent to you. This order will be delivered in one week.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(430901183258155822)
,p_plug_name=>'Access Denied'
,p_parent_plug_id=>wwv_flow_api.id(405032626695865671)
,p_icon_css_classes=>'fa-warning'
,p_region_template_options=>'#DEFAULT#:t-Alert--colorBG:t-Alert--wizard:t-Alert--customIcons:t-Alert--danger'
,p_plug_template=>wwv_flow_api.id(591654834181983844)
,p_plug_display_sequence=>190
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>You have insufficient privilege. Please contact your Administrator for more information.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405033676790865672)
,p_plug_name=>'Overview'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use the Alert region template to display alerts, confirmations, and other action-oriented messages within the context of a page.</p>',
'<p class="dm-Hero-steps">Set <strong>Alert </strong> as Region Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405034198676865672)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405034650920865673)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'JUMP'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405035186562865673)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405035677557865673)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(405035186562865673)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405036191818865674)
,p_plug_name=>'Alert Region'
,p_parent_plug_id=>wwv_flow_api.id(405035677557865673)
,p_region_template_options=>'#DEFAULT#:t-Alert--defaultIcons:t-Alert--warning:t-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(591654834181983844)
,p_plug_display_sequence=>140
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Region Body'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405036658445865675)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405035677557865673)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405037115772865675)
,p_plug_name=>'2. Wizard Style'
,p_parent_plug_id=>wwv_flow_api.id(405035186562865673)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405037686380865676)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405037115772865675)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>190
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405038189844865677)
,p_plug_name=>'Alert Region'
,p_parent_plug_id=>wwv_flow_api.id(405037115772865675)
,p_region_template_options=>'#DEFAULT#:t-Alert--colorBG:t-Alert--wizard:t-Alert--defaultIcons:t-Alert--warning'
,p_plug_template=>wwv_flow_api.id(591654834181983844)
,p_plug_display_sequence=>170
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-Placeholder dm-Placeholder--slim"> ',
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region Body</h3>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405038673707865677)
,p_plug_name=>'3. Custom Icon'
,p_parent_plug_id=>wwv_flow_api.id(405035186562865673)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405039109779865678)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405038673707865677)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>210
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405039698654865678)
,p_plug_name=>'Alert Region'
,p_parent_plug_id=>wwv_flow_api.id(405038673707865677)
,p_icon_css_classes=>'fa-cog'
,p_region_template_options=>'#DEFAULT#:t-Alert--customIcons:t-Alert--info:t-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(591654834181983844)
,p_plug_display_sequence=>200
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-Placeholder dm-Placeholder--slim"> ',
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region Body</h3>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(766161226059482423)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'REGION'
,p_attribute_02=>'Alert'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405030971068865669)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(405030534855865669)
,p_button_name=>'Close'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Close'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405031334493865669)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(405030534855865669)
,p_button_name=>'Create'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(430901013868155821)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(430900888269155819)
,p_button_name=>'Continue'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Continue Shopping'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(389368688647558720)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(405034198676865672)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:region:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-window-alt-2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(430901219380155823)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(430901183258155822)
,p_button_name=>'Contact'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Contact Administrator'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(430900933877155820)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(430900888269155819)
,p_button_name=>'View'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'View Order'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-chevron-right'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405031704189865670)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(405030534855865669)
,p_button_name=>'Next'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405032137845865670)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(405030534855865669)
,p_button_name=>'Previous'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
end;
/
prompt --application/pages/page_01203
begin
wwv_flow_api.create_page(
 p_id=>1203
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Region - Hero'
,p_alias=>'HERO-REGION'
,p_step_title=>'Hero Region - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405052695327003708)
,p_plug_name=>'Button Positions'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(404406547571489329)
,p_plug_name=>'Hero Region With Buttons'
,p_parent_plug_id=>wwv_flow_api.id(405052695327003708)
,p_icon_css_classes=>'fa-pie-chart'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1224989219520090364)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405055158500003711)
,p_plug_name=>'Use Cases'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405055601712003711)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405056193248003712)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Capture your users'' attention on homepage, dashboard, and other introductory-style pages. This region template displays an icon, heading and sub headings, and buttons.</p>',
'<p class="dm-Hero-steps">Set <strong>Hero </strong> as Region Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405056618535003713)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405057183508003713)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405057660846003713)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405078149280135513)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(405057660846003713)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>230
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405078697563135514)
,p_plug_name=>'Hero Region Template'
,p_parent_plug_id=>wwv_flow_api.id(405078149280135513)
,p_icon_css_classes=>'app-sample-universal-theme'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1224989219520090364)
,p_plug_display_sequence=>240
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>Region Body</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405079110421135514)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405078149280135513)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>250
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405079628962135515)
,p_plug_name=>'2. Custom Icon'
,p_parent_plug_id=>wwv_flow_api.id(405057660846003713)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>260
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405080170071135515)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405079628962135515)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>280
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405080603894135515)
,p_plug_name=>'Hero Region Template'
,p_parent_plug_id=>wwv_flow_api.id(405079628962135515)
,p_icon_css_classes=>'fa-area-chart'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1224989219520090364)
,p_plug_display_sequence=>270
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>Region Body</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405054264010003710)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(404406547571489329)
,p_button_name=>'Button'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Button'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1917874487212313185)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(405056618535003713)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:region:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-window-alt-2'
);
end;
/
prompt --application/pages/page_01204
begin
wwv_flow_api.create_page(
 p_id=>1204
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Region - Button Container'
,p_alias=>'BUTTON-CONTAINER-REGION'
,p_step_title=>'Button Container - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405102577413686799)
,p_plug_name=>'Use Cases'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405103093799686799)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405103508324686800)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Button Groups are a series of buttons that appear together to make a single conrol.  You can create button groups in APEX using the button component, or as a customized radio group page item.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405104083056686801)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405104570099686801)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405110226728724407)
,p_plug_name=>'Using Page Buttons'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You can turn a set of buttons into a button group simply by modifying the template options. Follow these instructions to create a simple button group of the following three buttons.</p>',
'<div class="dm-Hero-steps margin-bottom-md">',
'<strong>Step 1.</strong> Create three buttons in the same button position<br>',
'<strong>Step 2.</strong> Update each of the buttons'' Template Options as follows<br>',
'<ol>',
'  <li>Button A: set <em>Button Set</em> to <b>First Button</b></li>',
'  <li>Button B: set <em>Button Set</em> to <b>Inner Button</b></li>',
'  <li>Button C: set <em>Button Set</em> to <b>Last Button</b></li>',
'</ol>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405104970129686802)
,p_plug_name=>'Additional Example'
,p_parent_plug_id=>wwv_flow_api.id(405110226728724407)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3:margin-top-lg'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>You can have any number of buttons within a button group.  Here is an example of a music player toolbar styled the same method.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2152193383509275422)
,p_plug_name=>'Using Page Items'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You can also style the <strong>radio button</strong> or <strong>checkbox</strong> items to appear as a Button Group. This is particularly useful when you want to use store the selection in Session State and if you want to Dynamic Actions to perfor'
||'m some client side behavior as you interact with the control.</p>',
'<p>For example, in several Packaged Apps, this technique is used to switch between different displays of the same data.</p>',
'<p>Follow the instrutions below to convert a Radio Group item into a Button Group.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2152194026178275429)
,p_plug_name=>'Step 1'
,p_parent_plug_id=>wwv_flow_api.id(2152193383509275422)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-Hero-steps">',
'<strong>Step 1.</strong> Create a Radio Group item and set the following properties:<br>',
'<ol>',
'  <li>Set <em>Number of Columns</em> to the number of buttons you want to have in the button group. In this example, it is set to 3.</li>',
'  <li>Under <strong>List of Values</strong>, make sure that <em>Display Extra Values</em> and <em>Display Null Value</em> are set to <strong>No</strong></li>',
'</ol>',
'<p>After competing this step, you should have a button group that looks like the item below.</p>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2152194171836275430)
,p_plug_name=>'Step 2'
,p_parent_plug_id=>wwv_flow_api.id(2152193383509275422)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-Hero-steps">',
'<p><strong>Step 2.</strong> Update the Radio Group item''s Template Options and set <em>Item Group Display</em> to <strong>Display as Pill Button</strong></p>',
'<p>That''s it. Your Radio Group item will now appear as a Button Group.</p>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405111569535724409)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(405110226728724407)
,p_button_name=>'BTN_GRP_A'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Button A'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-angle-left'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2152192663941275415)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(405110226728724407)
,p_button_name=>'BTN_GRP_B'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--pill'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Button B'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-angle-left'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405111907244724409)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(405110226728724407)
,p_button_name=>'BTN_GRP_C'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Button C'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-angle-right'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2152192730436275416)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(405104970129686802)
,p_button_name=>'BTN_GRP_2A'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Previous'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-step-backward'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2152192829930275417)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(405104970129686802)
,p_button_name=>'BTN_GRP_2B'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--pill'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Rewind'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-backward'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2152193196109275420)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(405104970129686802)
,p_button_name=>'BTN_GRP_2C'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--pill'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Play'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-play'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2152193271849275421)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(405104970129686802)
,p_button_name=>'BTN_GRP_2D'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--pill'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Stop'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-stop'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2152192959102275418)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(405104970129686802)
,p_button_name=>'BTN_GRP_2E'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--pill'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Forward'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-forward'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2152193034453275419)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_api.id(405104970129686802)
,p_button_name=>'BTN_GRP_2F'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Next'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-step-forward'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1917874743798315882)
,p_button_sequence=>130
,p_button_plug_id=>wwv_flow_api.id(405104083056686801)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Button Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:button:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-button'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2152193751719275426)
,p_name=>'P1204_RADIO_A'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2152194026178275429)
,p_item_default=>'A'
,p_prompt=>'Radio Group'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Option A;A,Option B;B,Option C;C'
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#:margin-top-md'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2152194255538275431)
,p_name=>'P1204_RADIO_B'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2152194171836275430)
,p_item_default=>'A'
,p_prompt=>'Radio Button Group'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Option A;A,Option B;B,Option C;C'
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#:margin-top-md:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
end;
/
prompt --application/pages/page_01205
begin
wwv_flow_api.create_page(
 p_id=>1205
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Region - Carousel'
,p_alias=>'CAROUSEL-REGION'
,p_step_title=>'Carousel Region - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405179639694156564)
,p_plug_name=>'Use Cases'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405180198055156564)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405180664967156565)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Show off one sub region at a time. For example, displaying a report and a chart, a slideshow, or different views of the same data.</p>',
'<p class="dm-Hero-steps">Set <strong>Carousel Container</strong> as Region Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405181163279156566)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405181667338156566)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405182113971156566)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405192271255165690)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(405182113971156566)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>400
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405192787677165690)
,p_plug_name=>'Carousel Region'
,p_parent_plug_id=>wwv_flow_api.id(405192271255165690)
,p_region_template_options=>'#DEFAULT#:t-Region--hiddenOverflow'
,p_plug_template=>wwv_flow_api.id(1418258663404351882)
,p_plug_display_sequence=>410
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405193236108165691)
,p_plug_name=>'Region A'
,p_parent_plug_id=>wwv_flow_api.id(405192787677165690)
,p_region_css_classes=>'dm-ColorBlock u-color-1 h200'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>420
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405193784157165691)
,p_plug_name=>'Region B'
,p_parent_plug_id=>wwv_flow_api.id(405192787677165690)
,p_region_css_classes=>'dm-ColorBlock u-color-2 h200'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>430
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405194257246165692)
,p_plug_name=>'Region C'
,p_parent_plug_id=>wwv_flow_api.id(405192787677165690)
,p_region_css_classes=>'dm-ColorBlock u-color-3 h200'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>440
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405194783904165692)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405192271255165690)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>450
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405195226267165693)
,p_plug_name=>'2. Spin and Cycle'
,p_parent_plug_id=>wwv_flow_api.id(405182113971156566)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>810
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405195754410165693)
,p_plug_name=>'Carousel Region'
,p_parent_plug_id=>wwv_flow_api.id(405195226267165693)
,p_region_template_options=>'t-Region--carouselSpin:js-cycle5s:t-Region--hiddenOverflow'
,p_plug_template=>wwv_flow_api.id(1418258663404351882)
,p_plug_display_sequence=>410
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405196298963165694)
,p_plug_name=>'Region A'
,p_parent_plug_id=>wwv_flow_api.id(405195754410165693)
,p_region_css_classes=>'dm-ColorBlock u-color-4 h200'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>420
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405196702552165695)
,p_plug_name=>'Region C'
,p_parent_plug_id=>wwv_flow_api.id(405195754410165693)
,p_region_css_classes=>'dm-ColorBlock u-color-6 h200'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>440
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405197216513165695)
,p_plug_name=>'Region B'
,p_parent_plug_id=>wwv_flow_api.id(405195754410165693)
,p_region_css_classes=>'dm-ColorBlock u-color-5 h200'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>430
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405197722102165696)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405195226267165693)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>450
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405198253897165696)
,p_plug_name=>'3. Remember Slide'
,p_parent_plug_id=>wwv_flow_api.id(405182113971156566)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>820
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405198718058165696)
,p_plug_name=>'Carousel Region'
,p_parent_plug_id=>wwv_flow_api.id(405198253897165696)
,p_region_template_options=>'#DEFAULT#:js-useLocalStorage:t-Region--hiddenOverflow'
,p_plug_template=>wwv_flow_api.id(1418258663404351882)
,p_plug_display_sequence=>410
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405199255923165697)
,p_plug_name=>'Region A'
,p_parent_plug_id=>wwv_flow_api.id(405198718058165696)
,p_region_css_classes=>'dm-ColorBlock u-color-7 h200'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>420
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405199723225165698)
,p_plug_name=>'Region C'
,p_parent_plug_id=>wwv_flow_api.id(405198718058165696)
,p_region_css_classes=>'dm-ColorBlock u-color-9 h200'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>440
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405200247907165698)
,p_plug_name=>'Region B'
,p_parent_plug_id=>wwv_flow_api.id(405198718058165696)
,p_region_css_classes=>'dm-ColorBlock u-color-8 h200'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>430
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405200768144165699)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405198253897165696)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>450
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405187617287156572)
,p_plug_name=>'Button Positions'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405188182953156572)
,p_plug_name=>'Carousel Region with Buttons'
,p_parent_plug_id=>wwv_flow_api.id(405187617287156572)
,p_region_template_options=>'#DEFAULT#:t-Region--carouselSlide:js-cycle10s:t-Region--hiddenOverflow'
,p_plug_template=>wwv_flow_api.id(1418258663404351882)
,p_plug_display_sequence=>370
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(404406709752489331)
,p_plug_name=>'Region A'
,p_parent_plug_id=>wwv_flow_api.id(405188182953156572)
,p_region_css_classes=>'dm-ColorBlock u-color-7 h200'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region A</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(404406814520489332)
,p_plug_name=>'Region B'
,p_parent_plug_id=>wwv_flow_api.id(405188182953156572)
,p_region_css_classes=>'dm-ColorBlock u-color-8 h200'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region B</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(404406906359489333)
,p_plug_name=>'Region C'
,p_parent_plug_id=>wwv_flow_api.id(405188182953156572)
,p_region_css_classes=>'dm-ColorBlock u-color-9 h200'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region C</h3>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(714379152428623415)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'REGION'
,p_attribute_02=>'Carousel Container'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405188538219156573)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(405188182953156572)
,p_button_name=>'BTN_BP_CHG'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Change'
,p_button_position=>'CHANGE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405188959895156573)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(405188182953156572)
,p_button_name=>'BTN_BP_CLOSE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Close'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(404407071977489334)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(405188182953156572)
,p_button_name=>'BTN_BP_COY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Copy'
,p_button_position=>'COPY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405189351884156575)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(405188182953156572)
,p_button_name=>'BTN_BP_CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405189703444156575)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(405188182953156572)
,p_button_name=>'BTN_BP_DEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405190166572156575)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(405188182953156572)
,p_button_name=>'BTN_BP_EDIT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Edit'
,p_button_position=>'EDIT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(404407126038489335)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(405188182953156572)
,p_button_name=>'BTN_BP_HELP'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Help'
,p_button_position=>'HELP'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405190523812156576)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(405188182953156572)
,p_button_name=>'BTN_BP_NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1917875079922318142)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(405181163279156566)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:region:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-window-alt-2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405190989343156576)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(405188182953156572)
,p_button_name=>'BTN_BP_PREV'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
);
end;
/
prompt --application/pages/page_01206
begin
wwv_flow_api.create_page(
 p_id=>1206
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Region - Collapsible'
,p_alias=>'COLLAPSIBLE-REGION'
,p_step_title=>'Collapsible Region - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405224560308328320)
,p_plug_name=>'Button Positions'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(404407372971489337)
,p_plug_name=>'Collapsible Region With Buttons'
,p_parent_plug_id=>wwv_flow_api.id(405224560308328320)
,p_region_template_options=>'#DEFAULT#:is-expanded:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(1215306280710140812)
,p_plug_display_sequence=>480
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-Placeholder h180">',
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region Body</h3>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405225927915328322)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'REGION'
,p_attribute_02=>'Collapsible'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405226928846328323)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Allow your users to toggle the visibility of a region''s content on the page.</p>',
'<p class="dm-Hero-steps">Set <strong>Collapsible</strong> as Region Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405227422312328324)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405227909448328325)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405228474578328325)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405234650779342794)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(405228474578328325)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>470
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405235122404342795)
,p_plug_name=>'Collapsible Region'
,p_parent_plug_id=>wwv_flow_api.id(405234650779342794)
,p_region_template_options=>'#DEFAULT#:is-expanded:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(1215306280710140812)
,p_plug_display_sequence=>480
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-Placeholder h180"> ',
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region Body</h3>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405235617069342795)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405234650779342794)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>490
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405236161874342796)
,p_plug_name=>'2. Collapsed State'
,p_parent_plug_id=>wwv_flow_api.id(405228474578328325)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>490
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405236637618342796)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405236161874342796)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>520
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405237146074342796)
,p_plug_name=>'Collapsible Region'
,p_parent_plug_id=>wwv_flow_api.id(405236161874342796)
,p_region_template_options=>'#DEFAULT#:is-collapsed:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(1215306280710140812)
,p_plug_display_sequence=>510
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-Placeholder h180"> ',
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region Body</h3>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405237658075342797)
,p_plug_name=>'3. Scrolling Body'
,p_parent_plug_id=>wwv_flow_api.id(405228474578328325)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>500
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405238120566342797)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405237658075342797)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>550
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405238653128342798)
,p_plug_name=>'Collapsible Region'
,p_parent_plug_id=>wwv_flow_api.id(405237658075342797)
,p_region_template_options=>'#DEFAULT#:i-h240:is-expanded:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(1215306280710140812)
,p_plug_display_sequence=>540
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-Placeholder h180"> ',
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region Body</h3>',
'</div>',
'<div class="dm-Placeholder h180"> ',
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region Body</h3>',
'</div>',
'<div class="dm-Placeholder h180"> ',
'<span class="a-Icon icon-template-region"></span>',
'<h3>Region Body</h3>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(404407995755489343)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(404407372971489337)
,p_button_name=>'CHANGE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Change'
,p_button_position=>'CHANGE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(404407740692489341)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(404407372971489337)
,p_button_name=>'CLOSE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Close'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(404407616626489340)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(404407372971489337)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Copy'
,p_button_position=>'COPY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(404407504503489339)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(404407372971489337)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(404407839496489342)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(404407372971489337)
,p_button_name=>'EDIT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Edit'
,p_button_position=>'EDIT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(404407415611489338)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(404407372971489337)
,p_button_name=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1917876366807319419)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(405227422312328324)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:region:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-window-alt-2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405225431126328322)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(404407372971489337)
,p_button_name=>'PREVIOUS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
);
end;
/
prompt --application/pages/page_01207
begin
wwv_flow_api.create_page(
 p_id=>1207
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Region - Title Bar'
,p_alias=>'TITLE-BAR-REGION'
,p_step_title=>'Title Bar Region - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405252320527407085)
,p_plug_name=>'Button Positions'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405252886954407086)
,p_plug_name=>'Title Bar Region With Buttons'
,p_parent_plug_id=>wwv_flow_api.id(405252320527407085)
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useRegionTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405253751579407087)
,p_plug_name=>'Use Cases'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405254226058407087)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405254725161407088)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Group breadcrumbs, page title, and primary page actions at the top of the page.</p>',
'<p class="dm-Hero-steps">Set <strong>Title Bar</strong> as Region Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405255296881407088)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405255714876407089)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405256223595407090)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405262176746415655)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(405256223595407090)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>570
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405262648114415656)
,p_plug_name=>'Title Bar Region'
,p_parent_plug_id=>wwv_flow_api.id(405262176746415655)
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>580
,p_plug_display_point=>'SUB_REGIONS'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405263111255415656)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405262176746415655)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>590
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405263626968415656)
,p_plug_name=>'2. Breadcrumbs and Region Title'
,p_parent_plug_id=>wwv_flow_api.id(405256223595407090)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>600
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405264149819415657)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405263626968415656)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>620
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405264611465415657)
,p_plug_name=>'Title Bar Region'
,p_parent_plug_id=>wwv_flow_api.id(405263626968415656)
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useRegionTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>610
,p_plug_display_point=>'SUB_REGIONS'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405265171156415658)
,p_plug_name=>'3. Compact Breadcrumb'
,p_parent_plug_id=>wwv_flow_api.id(405256223595407090)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>630
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405265633868415658)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405265171156415658)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>660
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405266107605415658)
,p_plug_name=>'Title Bar Region'
,p_parent_plug_id=>wwv_flow_api.id(405265171156415658)
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--compactTitle:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>640
,p_plug_display_point=>'SUB_REGIONS'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(446737730203201423)
,p_plug_name=>'4. Region Title Only'
,p_parent_plug_id=>wwv_flow_api.id(405256223595407090)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>640
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(446737815470201424)
,p_plug_name=>'Title Bar Region'
,p_parent_plug_id=>wwv_flow_api.id(446737730203201423)
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'t-BreadcrumbRegion--useRegionTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>650
,p_plug_display_point=>'SUB_REGIONS'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(446737944986201425)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(446737730203201423)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>670
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(404408108233489345)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(405252886954407086)
,p_button_name=>'CHANGE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Change'
,p_button_position=>'CHANGE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(404408431619489348)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(405252886954407086)
,p_button_name=>'CLOSE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Close'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(404408626241489350)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(405252886954407086)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Copy'
,p_button_position=>'COPY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405290497214637801)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(405252886954407086)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(404408336984489347)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(405252886954407086)
,p_button_name=>'DELETE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--simple'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(404408517381489349)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(405252886954407086)
,p_button_name=>'EDIT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Edit'
,p_button_position=>'EDIT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(404408270324489346)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(405252886954407086)
,p_button_name=>'HELP'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Help'
,p_button_position=>'HELP'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(404408094568489344)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(405252886954407086)
,p_button_name=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1917876682940320286)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(405255296881407088)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:region:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-window-alt-2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405253228440407086)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(405252886954407086)
,p_button_name=>'PREVIOUS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
);
end;
/
prompt --application/pages/page_01208
begin
wwv_flow_api.create_page(
 p_id=>1208
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Region - Wizard'
,p_alias=>'WIZARD-REGION'
,p_step_title=>'Wizards - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405309432336757803)
,p_plug_name=>'Wizard Progress List'
,p_region_name=>'wizard_list'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The <strong>Wizard Progress</strong> List Template is used to display the total steps of a wizard along with a marker of the current step the user is on. This list has several options, and can be used in both horizontal or vertical orientations.</'
||'p>',
'<p class="dm-Hero-steps">Set <strong>Wizard Progress</strong> as the List Template</p>',
'<p>The completed steps are marked with a green check mark where as the active step is indicated in the theme''s accent color.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(215423676855524498)
,p_plug_name=>'Example 3'
,p_parent_plug_id=>wwv_flow_api.id(405309432336757803)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(215423823319524499)
,p_plug_name=>'Step Links'
,p_parent_plug_id=>wwv_flow_api.id(215423676855524498)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--padded:t-ContentBlock--h3:t-ContentBlock--lightBG:margin-top-md:margin-bottom-sm'
,p_component_template_options=>'#DEFAULT#:js-wizardProgressLinks:t-WizardSteps--displayLabels'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(561122940005233277)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(561120526789187584)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(215423887463524500)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(215423676855524498)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285420640551520212)
,p_plug_name=>'Example 1'
,p_parent_plug_id=>wwv_flow_api.id(405309432336757803)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285420390386520209)
,p_plug_name=>'Default Example'
,p_parent_plug_id=>wwv_flow_api.id(2285420640551520212)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--padded:t-ContentBlock--h3:t-ContentBlock--lightBG:margin-top-md:margin-bottom-sm'
,p_component_template_options=>'#DEFAULT#:t-WizardSteps--displayLabels'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(561122940005233277)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(561120526789187584)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285420558768520211)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(2285420640551520212)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285420786074520213)
,p_plug_name=>'Example 2'
,p_parent_plug_id=>wwv_flow_api.id(405309432336757803)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285420865418520214)
,p_plug_name=>'Simple Example'
,p_parent_plug_id=>wwv_flow_api.id(2285420786074520213)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--padded:t-ContentBlock--h3:t-ContentBlock--lightBG:margin-top-md:margin-bottom-sm'
,p_component_template_options=>'#DEFAULT#:t-WizardSteps--hideLabels'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(561122940005233277)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(561120526789187584)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285420989147520215)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(2285420786074520213)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285421062733520216)
,p_plug_name=>'Example 4'
,p_parent_plug_id=>wwv_flow_api.id(405309432336757803)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285421178426520217)
,p_plug_name=>'Vertical Example'
,p_parent_plug_id=>wwv_flow_api.id(2285421062733520216)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--padded:t-ContentBlock--h3:t-ContentBlock--lightBG:margin-top-md:margin-bottom-sm'
,p_component_template_options=>'#DEFAULT#:t-WizardSteps--vertical:t-WizardSteps--displayLabels'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(561122940005233277)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(561120526789187584)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285421282214520218)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(2285421062733520216)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285421336144520219)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(405309432336757803)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'LIST'
,p_attribute_04=>'Wizard Progress'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405310423108757804)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>1
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Wizards can be very useful in simplifying complex flows into smaller, more manageable steps.  This page describes full page Wizards, modal dialog Wizards, and the Wizard Progress list template.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405310948005757805)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405311451848757806)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405311973911757806)
,p_plug_name=>'Full Page Wizard'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A full page wizard is useful when you want to maximize on screen realestate and a modal dialog is not appropriate.  In order to create a full page wizard shown below, you will use Wizard Container region template for your Wizard Progress list, and'
||' as the container for your form regions.</p>',
'<div class="dm-Hero-steps margin-bottom-md">',
'<p><strong>Step 1.</strong> Set <strong>Wizard Container</strong> as Region Template.</p>',
'<p><strong>Step 2.</strong> Set <strong>Wizard Steps</strong> as List Template.</p>',
'<p><strong>Step 3.</strong> Create a sub-region within the Wizard Container to store your form items and other content to be place in your wizard body.</p>',
'</div>',
'<p>Use the <strong>Create Wizard</strong> page wizard to create a set of pages which have the same user interface. Simply set Page Mode to Normal and follow the steps. </p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405308006979757801)
,p_plug_name=>'Button Positions'
,p_parent_plug_id=>wwv_flow_api.id(405311973911757806)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405308534972757802)
,p_plug_name=>'Wizard Region With Buttons'
,p_parent_plug_id=>wwv_flow_api.id(405308006979757801)
,p_region_template_options=>'#DEFAULT#:t-Wizard--hideStepsXSmall'
,p_component_template_options=>'#DEFAULT#:t-WizardSteps--displayLabels'
,p_plug_template=>wwv_flow_api.id(670020401234384587)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(561122940005233277)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(561120526789187584)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405290720103637804)
,p_plug_name=>'Wizard Form Sub Region'
,p_parent_plug_id=>wwv_flow_api.id(405308534972757802)
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>Sub Region with Form Items</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405316516426767075)
,p_plug_name=>'Example 1'
,p_parent_plug_id=>wwv_flow_api.id(405311973911757806)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405317043897767076)
,p_plug_name=>'Wizard'
,p_parent_plug_id=>wwv_flow_api.id(405316516426767075)
,p_region_template_options=>'#DEFAULT#:t-Wizard--hideStepsSmall'
,p_component_template_options=>'#DEFAULT#:t-WizardSteps--displayCurrentLabelOnly'
,p_plug_template=>wwv_flow_api.id(670020401234384587)
,p_plug_display_sequence=>680
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(561122940005233277)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(561120526789187584)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405318382897767077)
,p_plug_name=>'Wizard Form Sub Region'
,p_parent_plug_id=>wwv_flow_api.id(405317043897767076)
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>690
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>Sub Region with Form Items</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405318832432767078)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405316516426767075)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>700
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405319376323767078)
,p_plug_name=>'Example 2'
,p_parent_plug_id=>wwv_flow_api.id(405311973911757806)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405319816506767079)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405319376323767078)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>740
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405320372653767079)
,p_plug_name=>'Wizard Title'
,p_parent_plug_id=>wwv_flow_api.id(405319376323767078)
,p_region_template_options=>'#DEFAULT#:t-Wizard--showTitle:t-Wizard--hideStepsXSmall'
,p_component_template_options=>'#DEFAULT#:t-WizardSteps--displayCurrentLabelOnly'
,p_plug_template=>wwv_flow_api.id(670020401234384587)
,p_plug_display_sequence=>720
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(561122940005233277)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(561120526789187584)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405321609129767080)
,p_plug_name=>'Wizard Form Sub Region'
,p_parent_plug_id=>wwv_flow_api.id(405320372653767079)
,p_region_css_classes=>'dm-Placeholder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>730
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>Sub Region with Form Items</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285421481770520220)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(405311973911757806)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'REGION'
,p_attribute_02=>'Wizard Container'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285420150781520207)
,p_plug_name=>'Modal Dialog Wizard'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>21
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A modal dialog wizard can be used to perform a complex flow while maintaining context of the page.</p>',
'<div class="dm-Hero-steps margin-bottom-md">',
'  <p><strong>Step 1.</strong> Use the Create Page wizard and select <strong>Wizard</strong>.</p>',
'  <p><strong>Step 2.</strong> Enter the number of pages you want in the wizard, and then set Page Mode to <strong>Modal Dialog</strong></p>',
'  <p><strong>Step 3.</strong> Follow the rest of the steps in the wizard to completion.</p>',
'</div>',
'<p>Now you have a modal dialog wizard created with the page numbers you specified in the creation wiard.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2285420233112520208)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2285420150781520207)
,p_button_name=>'OPEN_MODAL_WIZ'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Open Modal Dialog Wizard'
,p_button_redirect_url=>'f?p=&APP_ID.:1920:&SESSION.::&DEBUG.:RP::'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405290642317637803)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(405308534972757802)
,p_button_name=>'CLOSE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Close'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405308965949757802)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(405308534972757802)
,p_button_name=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405317455381767076)
,p_button_sequence=>140
,p_button_plug_id=>wwv_flow_api.id(405317043897767076)
,p_button_name=>'DEF_WIZ_NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'fa-angle-right'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405320732953767080)
,p_button_sequence=>160
,p_button_plug_id=>wwv_flow_api.id(405320372653767079)
,p_button_name=>'DEF_WIZ2_NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'fa-angle-right'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1917876966542321340)
,p_button_sequence=>190
,p_button_plug_id=>wwv_flow_api.id(405310948005757805)
,p_button_name=>'REGION_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:region:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-window-alt-2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2285421530693520221)
,p_button_sequence=>200
,p_button_plug_id=>wwv_flow_api.id(405310948005757805)
,p_button_name=>'LIST_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'List Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:lists:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-list'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2285421623744520222)
,p_button_sequence=>210
,p_button_plug_id=>wwv_flow_api.id(405310948005757805)
,p_button_name=>'PAGE_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Page Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:list:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-file-o'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405290570276637802)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(405308534972757802)
,p_button_name=>'PREVIOUS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405317878580767077)
,p_button_sequence=>130
,p_button_plug_id=>wwv_flow_api.id(405317043897767076)
,p_button_name=>'DEF_WIZ_PREV'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'fa-angle-left'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405321187724767080)
,p_button_sequence=>150
,p_button_plug_id=>wwv_flow_api.id(405320372653767079)
,p_button_name=>'DEF_WIZ2_PREV'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'fa-angle-left'
);
end;
/
prompt --application/pages/page_01250
begin
wwv_flow_api.create_page(
 p_id=>1250
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Button Container'
,p_alias=>'BUTTON-CONTAINER'
,p_step_title=>'Button Container'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2152192505332275414)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2587538964030645944)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'REGION'
,p_attribute_02=>'Buttons Container'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2587539480416645944)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2587539894941645945)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Organize your button bars, toolbars, and simple horizontal forms.</p>',
'<p class="dm-Hero-steps">Set <strong>Buttons Container</strong> as Region Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2587540956716645946)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2587541356746645947)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2587546613345683552)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(2587541356746645947)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>300
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2587547151000683552)
,p_plug_name=>'Button Region Template'
,p_parent_plug_id=>wwv_flow_api.id(2587546613345683552)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(677400524731372757)
,p_plug_display_sequence=>310
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-Placeholder dm-Placeholder--slim"> ',
'Region Body',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2587548821684683554)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(2587546613345683552)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>320
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2587549365916683555)
,p_plug_name=>'2. Variation'
,p_parent_plug_id=>wwv_flow_api.id(2587541356746645947)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>330
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2587549818417683555)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(2587549365916683555)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>350
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2587550354648683556)
,p_plug_name=>'Button Region Template'
,p_parent_plug_id=>wwv_flow_api.id(2587549365916683555)
,p_region_template_options=>'#DEFAULT#:t-ButtonRegion--noPadding:t-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(677400524731372757)
,p_plug_display_sequence=>340
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-Placeholder dm-Placeholder--slim"> ',
'Region Body',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2587551606083683557)
,p_plug_name=>'Button Positions'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>All possible positions in a Button Position Region.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2587552643415683557)
,p_plug_name=>'Button Region Template'
,p_parent_plug_id=>wwv_flow_api.id(2587551606083683557)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(677400524731372757)
,p_plug_display_sequence=>370
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2182443222422959184)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(2587552643415683557)
,p_button_name=>'BTN_BP_CHG'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Change'
,p_button_position=>'CHANGE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2182443629591959186)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(2587552643415683557)
,p_button_name=>'BTN_BP_CLOSE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Close'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2182439413483959178)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2587547151000683552)
,p_button_name=>'BTN_BR_CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2182444053991959186)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(2587552643415683557)
,p_button_name=>'BTN_BP_CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2182444477223959187)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_api.id(2587552643415683557)
,p_button_name=>'BTN_BP_DEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2182444835219959187)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(2587552643415683557)
,p_button_name=>'BTN_BP_EDIT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Edit'
,p_button_position=>'EDIT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2182437860891959175)
,p_button_sequence=>130
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Template'
,p_button_position=>'LEGACY_ORPHAN_COMPONENTS'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:region:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-window-alt-2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2182441810599959182)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(2587550354648683556)
,p_button_name=>'BTN_V1_NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'fa-angle-right'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2182445282229959187)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(2587552643415683557)
,p_button_name=>'BTN_BP_NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2182466063235972047)
,p_button_sequence=>140
,p_button_plug_id=>wwv_flow_api.id(2152192505332275414)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:region:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-window-alt-2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2182439894237959179)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2587547151000683552)
,p_button_name=>'BTN_BR_PREV'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'fa-angle-left'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2182440275363959180)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2587547151000683552)
,p_button_name=>'BTN_BR_NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Next'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'fa-angle-right'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2182442288578959183)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(2587550354648683556)
,p_button_name=>'BTN_V1_PREV'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'fa-angle-left'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2182445642335959188)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_api.id(2587552643415683557)
,p_button_name=>'BTN_BP_PREV'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
);
end;
/
prompt --application/pages/page_01300
begin
wwv_flow_api.create_page(
 p_id=>1300
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Lists'
,p_alias=>'LISTS'
,p_step_title=>'Lists - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.ts-Placeholder {',
'height: 240px;',
'line-height: 240px;',
'text-align: center;',
'background-color: #D0D0D0;',
'color: #404040;',
'border-radius: 2px;',
'margin-bottom: 48px;',
'}',
'.ts-Container {',
'max-width: 1024px;',
'min-height: 50vh;',
'}',
'',
'.dm-Hero--wrapper.dm-Hero--secondary > .container {',
'  max-width:100%;',
'}'))
,p_page_css_classes=>'dm-Page dm-Page--center '
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(476443260316647359)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_component_template_options=>'#DEFAULT#:u-colors'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>410
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(476573383197691871)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1900876059749692314)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Lists are a very versatile component within APEX and can be used as the foundation for any number of UI components.  This page introduces you to the two List Templates which are especially useful for navigation.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2152194714081275436)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_01301
begin
wwv_flow_api.create_page(
 p_id=>1301
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Lists - Media List '
,p_alias=>'MEDIA-LIST'
,p_step_title=>'Media List - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(340247661504216332)
,p_plug_name=>'List Template Customization'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405765235297895008)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(340247661504216332)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'LIST'
,p_attribute_04=>'Media List'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405779799702940458)
,p_plug_name=>'Substitution Strings'
,p_parent_plug_id=>wwv_flow_api.id(340247661504216332)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl class="t-AVPList  t-AVPList--leftAligned">',
'<dt class="t-AVPList-label">',
'#A01#',
'</dt>',
'<dd class="t-AVPList-value">',
'  The description of the media list item. ',
'</dd>',
'',
'<dt class="t-AVPList-label">',
'#A02#',
'</dt>',
'<dd class="t-AVPList-value">',
'  The badge of the media list item.',
'</dd>',
'<dt class="t-AVPList-label">',
'   #A03#',
'</dt>',
'<dd class="t-AVPList-value">',
'   HTML Attributes for the clickable link inside of the list item.',
'</dd>',
'',
'<dt class="t-AVPList-label">',
'   #A04#',
'</dt>',
'<dd class="t-AVPList-value">',
'   HTML Attributes for the list item. ',
'</dd>',
'',
'<dt class="t-AVPList-label">',
'   #A05#',
'</dt>',
'<dd class="t-AVPList-value">',
'   Class attribute for the link element. ',
'</dd>',
'',
'<dt class="t-AVPList-label">',
'   #A06#',
'</dt>',
'<dd class="t-AVPList-value">',
'   Color class',
'</dd>',
'',
'</dl>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(340247786657216333)
,p_plug_name=>'Report Template Customization'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(340247856093216334)
,p_plug_name=>'Substitution Strings'
,p_parent_plug_id=>wwv_flow_api.id(340247786657216333)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl class="t-AVPList  t-AVPList--leftAligned">',
'    <dt class="t-AVPList-label">',
'        #LIST_CLASS#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        CSS class of the list',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #LINK#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Link',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #LINK_CLASS#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Class attribute for the link element',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #LINK_ATTR#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        HTML Attributes for the list item',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #ICON_COLOR_CLASS#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        CSS class for the icon color',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #ICON_CLASS#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        CSS class for the icon',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #LIST_TITLE#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        List title',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #LIST_TEXT#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        List text',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #LIST_BADGE#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        The badge of the list item.',
'    </dd>',
'</dl>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4291097818810787670)
,p_plug_name=>'Sample Report Query'
,p_parent_plug_id=>wwv_flow_api.id(340247786657216333)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre class="dm-Code lang-sql"><code>select',
'  id,',
'  project list_title,',
'  ''Created by: '' || created_by list_text,',
'  '' '' list_class,',
'  null link, ',
'  ''target="_blank"'' link_attr,',
'  ''u-color-'' || to_char( ora_hash(created_by,44) + 1 ) icon_color_class,',
'  ''fa fa-cloud'' icon_class,',
'  apex_util.get_since(updated) list_badge',
'from eba_UT_chart_projects</code></pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405766200502895009)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Media List template is a very common design pattern that has an icon, heading, description, and a badge. With Universal Theme, you can style both <strong>Lists</strong> or <strong>Classic Reports</strong> regions to appear as a Media List by s'
||'etting the appropriate template.</p>',
'<p class="dm-Hero-steps">For Classic Reports, set <strong>Media List</strong> as the Report Template.</p>',
'<p class="dm-Hero-steps">For Lists, set <strong>Media List</strong> as the List Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405766747983895010)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405767241670895010)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405767756269895011)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-TabsRegion-mod--simple'
,p_plug_template=>wwv_flow_api.id(1774143203700285855)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(340247448034216330)
,p_plug_name=>'List Examples'
,p_parent_plug_id=>wwv_flow_api.id(405767756269895011)
,p_icon_css_classes=>'fa-bars'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405780759909940460)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(340247448034216330)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3:margin-top-md'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405781262920940461)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405780759909940460)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405781786870940461)
,p_plug_name=>'Media List Template'
,p_parent_plug_id=>wwv_flow_api.id(405780759909940460)
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#:u-colors'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(620486248054927814)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405782206484940462)
,p_plug_name=>'2. Variation A'
,p_parent_plug_id=>wwv_flow_api.id(340247448034216330)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405782602026940462)
,p_plug_name=>'Media List Template'
,p_parent_plug_id=>wwv_flow_api.id(405782206484940462)
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--scrollBody'
,p_component_template_options=>'t-MediaList--showIcons:t-MediaList--showDesc:t-MediaList--showBadges:t-MediaList--large force-fa-lg:t-MediaList--cols t-MediaList--2cols'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(620486248054927814)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405783137846940463)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405782206484940462)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>80
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405783697769940464)
,p_plug_name=>'3. Variation B'
,p_parent_plug_id=>wwv_flow_api.id(340247448034216330)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405784128924940464)
,p_plug_name=>'Media List Template'
,p_parent_plug_id=>wwv_flow_api.id(405783697769940464)
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--scrollBody'
,p_component_template_options=>'t-MediaList--showIcons:t-MediaList--showBadges:u-colors:t-MediaList--large force-fa-lg:t-MediaList--cols t-MediaList--3cols'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(620486248054927814)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405784664041940465)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(405783697769940464)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>110
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(340247537322216331)
,p_plug_name=>'Report Examples'
,p_parent_plug_id=>wwv_flow_api.id(405767756269895011)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(498901492768926712)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(340247537322216331)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3:margin-top-md'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(340248092951216336)
,p_name=>'1. Default Report'
,p_parent_plug_id=>wwv_flow_api.id(498901492768926712)
,p_template=>wwv_flow_api.id(2623330321607852408)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--hideHeader:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#:u-colors:t-MediaList--stack'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  project list_title,',
'  apex_util.get_since(updated) list_text,',
'  '' '' list_class,',
'  null link, ',
'  ''target="_blank"'' link_attr,',
'  null icon_color_class,',
'  ''fa fa-cloud'' icon_class',
'from eba_UT_chart_projects',
'order by updated desc'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(644575648490092151)
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(340248125329216337)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(340248866933216344)
,p_query_column_id=>2
,p_column_alias=>'LIST_TITLE'
,p_column_display_sequence=>2
,p_column_heading=>'List Title'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(340248907313216345)
,p_query_column_id=>3
,p_column_alias=>'LIST_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'List Text'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(340249061572216346)
,p_query_column_id=>4
,p_column_alias=>'LIST_CLASS'
,p_column_display_sequence=>4
,p_column_heading=>'List Class'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(340249178829216347)
,p_query_column_id=>5
,p_column_alias=>'LINK'
,p_column_display_sequence=>5
,p_column_heading=>'Link'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(340249208584216348)
,p_query_column_id=>6
,p_column_alias=>'LINK_ATTR'
,p_column_display_sequence=>6
,p_column_heading=>'Link Attr'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(340249326639216349)
,p_query_column_id=>7
,p_column_alias=>'ICON_COLOR_CLASS'
,p_column_display_sequence=>7
,p_column_heading=>'Icon Color Class'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(340249421406216350)
,p_query_column_id=>8
,p_column_alias=>'ICON_CLASS'
,p_column_display_sequence=>8
,p_column_heading=>'Icon Class'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(498901542686926713)
,p_plug_name=>'2. Variation A'
,p_parent_plug_id=>wwv_flow_api.id(340247537322216331)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3:margin-top-md'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(498901646871926714)
,p_name=>'2. Variation A Report'
,p_parent_plug_id=>wwv_flow_api.id(498901542686926713)
,p_template=>wwv_flow_api.id(2623330321607852408)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#:t-MediaList--showBadges:u-colors:t-MediaList--cols t-MediaList--2cols:t-MediaList--large force-fa-lg'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  project list_title,',
'  ''Created by: '' || created_by list_text,',
'  '' '' list_class,',
'  null link, ',
'  ''target="_blank"'' link_attr,',
'  null icon_color_class,',
'  ''fa fa-cloud'' icon_class,',
'  apex_util.get_since(updated) list_badge',
'from eba_UT_chart_projects',
'order by updated desc'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(644575648490092151)
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498901791222926715)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498901824758926716)
,p_query_column_id=>2
,p_column_alias=>'LIST_TITLE'
,p_column_display_sequence=>2
,p_column_heading=>'List Title'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498901938261926717)
,p_query_column_id=>3
,p_column_alias=>'LIST_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'List Text'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498902024853926718)
,p_query_column_id=>4
,p_column_alias=>'LIST_CLASS'
,p_column_display_sequence=>4
,p_column_heading=>'List Class'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498902107052926719)
,p_query_column_id=>5
,p_column_alias=>'LINK'
,p_column_display_sequence=>5
,p_column_heading=>'Link'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498902257882926720)
,p_query_column_id=>6
,p_column_alias=>'LINK_ATTR'
,p_column_display_sequence=>6
,p_column_heading=>'Link Attr'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498902380405926721)
,p_query_column_id=>7
,p_column_alias=>'ICON_COLOR_CLASS'
,p_column_display_sequence=>7
,p_column_heading=>'Icon Color Class'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498902405465926722)
,p_query_column_id=>8
,p_column_alias=>'ICON_CLASS'
,p_column_display_sequence=>8
,p_column_heading=>'Icon Class'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498902505015926723)
,p_query_column_id=>9
,p_column_alias=>'LIST_BADGE'
,p_column_display_sequence=>9
,p_column_heading=>'List Badge'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(498902685175926724)
,p_plug_name=>'3. Variation B'
,p_parent_plug_id=>wwv_flow_api.id(340247537322216331)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3:margin-top-md'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(498903718388926735)
,p_name=>'3. Variation B'
,p_parent_plug_id=>wwv_flow_api.id(498902685175926724)
,p_template=>wwv_flow_api.id(2623330321607852408)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--hideHeader:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#:u-colors:t-MediaList--cols t-MediaList--3cols:t-MediaList--large force-fa-lg'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  project list_title,',
'  ''Created by: '' || created_by list_text,',
'  '' '' list_class,',
'  null link, ',
'  ''target="_blank"'' link_attr,',
'  null icon_color_class,',
'  ''fa fa-cloud'' icon_class,',
'  apex_util.get_since(updated) list_badge',
'from eba_UT_chart_projects',
'order by updated desc'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(644575648490092151)
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498903809343926736)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498903947034926737)
,p_query_column_id=>2
,p_column_alias=>'LIST_TITLE'
,p_column_display_sequence=>2
,p_column_heading=>'List Title'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498904052134926738)
,p_query_column_id=>3
,p_column_alias=>'LIST_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'List Text'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498904187842926739)
,p_query_column_id=>4
,p_column_alias=>'LIST_CLASS'
,p_column_display_sequence=>4
,p_column_heading=>'List Class'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498904207516926740)
,p_query_column_id=>5
,p_column_alias=>'LINK'
,p_column_display_sequence=>5
,p_column_heading=>'Link'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498904327134926741)
,p_query_column_id=>6
,p_column_alias=>'LINK_ATTR'
,p_column_display_sequence=>6
,p_column_heading=>'Link Attr'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498904422552926742)
,p_query_column_id=>7
,p_column_alias=>'ICON_COLOR_CLASS'
,p_column_display_sequence=>7
,p_column_heading=>'Icon Color Class'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498904559507926743)
,p_query_column_id=>8
,p_column_alias=>'ICON_CLASS'
,p_column_display_sequence=>8
,p_column_heading=>'Icon Class'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498904688940926744)
,p_query_column_id=>9
,p_column_alias=>'LIST_BADGE'
,p_column_display_sequence=>9
,p_column_heading=>'List Badge'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1920950537376774207)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(405766747983895010)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'List Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:lists:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-bars'
);
end;
/
prompt --application/pages/page_01303
begin
wwv_flow_api.create_page(
 p_id=>1303
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Lists - Links'
,p_alias=>'LINKS-LIST'
,p_step_title=>'Links List - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415721545425475666)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'LIST'
,p_attribute_04=>'Links List'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415722596587475680)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This list template provides a list of links which can be used for navigation and other action-oriented tasks. You can optionally show badges, icons, sub list items, and more.</p>',
'<p class="dm-Hero-steps">Set <strong>Links List</strong> as the List Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415723045323475680)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415723564467475681)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415724062008475681)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415734426926486397)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(415724062008475681)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>230
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415734946605486397)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(415734426926486397)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>250
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415735470831486398)
,p_plug_name=>'Links List Template'
,p_parent_plug_id=>wwv_flow_api.id(415734426926486397)
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--scrollBody:t-Region--removeHeader js-removeLandmark'
,p_component_template_options=>'#DEFAULT#:t-LinksList--showArrow'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>240
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(1905596320814687297)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(2623332529225852414)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415735911301486398)
,p_plug_name=>'2. Variation A'
,p_parent_plug_id=>wwv_flow_api.id(415724062008475681)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>260
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415736440589486399)
,p_plug_name=>'Links List Template'
,p_parent_plug_id=>wwv_flow_api.id(415735911301486398)
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--scrollBody:t-Region--removeHeader js-removeLandmark'
,p_component_template_options=>'#DEFAULT#:t-LinksList--showBadge:t-LinksList--showIcons'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>270
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(1905596320814687297)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(2623332529225852414)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415736949349486399)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(415735911301486398)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>280
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415737426869486399)
,p_plug_name=>'3. Variation B'
,p_parent_plug_id=>wwv_flow_api.id(415724062008475681)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>270
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415737972713486400)
,p_plug_name=>'Links List Template'
,p_parent_plug_id=>wwv_flow_api.id(415737426869486399)
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--scrollBody:t-Region--removeHeader js-removeLandmark'
,p_component_template_options=>'#DEFAULT#:t-LinksList--showTopIcons'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>300
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(1905725173247765454)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(2623332529225852414)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415738409222486400)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(415737426869486399)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>310
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415733443824486396)
,p_plug_name=>'Substitution Strings'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl class="t-AVPList  t-AVPList--leftAligned">',
'',
'',
'<dt class="t-AVPList-label">',
'#A01#',
'</dt>',
'<dd class="t-AVPList-value">',
'  The badge ',
'</dd>',
'',
'<dt class="t-AVPList-label">',
'  #A02#',
'</dt>',
'<dd class="t-AVPList-value">',
'  HTML Attributes for the link inside of the Links List item.',
'</dd>',
'',
'<dt class="t-AVPList-label">',
'   #A03#',
'</dt>',
'<dd class="t-AVPList-value">',
'   HTML Attributes for the Links List item.',
'</dd>',
'',
'</dl>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1920951120400776920)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(415723045323475680)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:lists:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-bars'
);
end;
/
prompt --application/pages/page_01304
begin
wwv_flow_api.create_page(
 p_id=>1304
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'List - Badges'
,p_alias=>'BADGES-LIST'
,p_step_title=>'Badges List - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415743561628532116)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415744044861532117)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415744533521532120)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415757247334541348)
,p_plug_name=>'Substitution Strings'
,p_parent_plug_id=>wwv_flow_api.id(415744533521532120)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>370
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl class="t-AVPList  t-AVPList--leftAligned">',
'<dt class="t-AVPList-label">',
'#A01#',
'</dt>',
'<dd class="t-AVPList-value">',
'  The text of the link inside of the Badge List item. ',
'</dd>',
'<dt class="t-AVPList-label">',
'   #A02#',
'</dt>',
'<dd class="t-AVPList-value">',
'   Classes for the Badge List Item',
'</dd>',
'<dt class="t-AVPList-label">',
'#A03#',
'</dt>',
'<dd class="t-AVPList-value">',
'  HTML Attributes for the link inside of the Badge List item.',
'</dd>',
'</dl>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415758279692541349)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(415744533521532120)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>330
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415758740706541350)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(415758279692541349)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>350
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415759239614541350)
,p_plug_name=>'Badge List Template'
,p_parent_plug_id=>wwv_flow_api.id(415758279692541349)
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#:u-colors:t-BadgeList--circular:t-BadgeList--cols t-BadgeList--3cols:t-BadgeList--large'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>340
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(637608094510847311)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(614901035349879760)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415759705098541350)
,p_plug_name=>'2. Variation A'
,p_parent_plug_id=>wwv_flow_api.id(415744533521532120)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>360
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415760230957541351)
,p_plug_name=>'Badge List Template'
,p_parent_plug_id=>wwv_flow_api.id(415759705098541350)
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#:t-BadgeList--dash:t-BadgeList--cols t-BadgeList--3cols:t-BadgeList--medium'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>370
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(637608094510847311)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(614901035349879760)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415760758680541351)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(415759705098541350)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>380
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415750978903532127)
,p_plug_name=>'Use Cases'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415751498263532127)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415751908580532128)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This list template is useful for displaying badges or counters.</p>',
'<p class="dm-Hero-steps">Set <strong>Badge List</strong> as the List Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(714379078720623414)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'LIST'
,p_attribute_04=>'Badge List'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1920951465574778334)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(415743561628532116)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'List Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:lists:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-bars'
);
end;
/
prompt --application/pages/page_01305
begin
wwv_flow_api.create_page(
 p_id=>1305
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'List - Menu Bar'
,p_alias=>'MENU-BAR-LIST'
,p_step_title=>'Menu Bar List - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415767214774701350)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This list template is used to display a menu bar control and is useful for building pages with advanced interaction.  Note that the region containing the menu bar must be sufficiently tall to accomodate the menus. </p>',
'<p class="dm-Hero-steps">Set <strong>Menu Bar</strong> as the List Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415767747368701351)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415768283127701351)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415768707795701352)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415776515307708102)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(415768707795701352)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415777023720708102)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(415776515307708102)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415777540600708102)
,p_plug_name=>'Menu Bar List Template'
,p_parent_plug_id=>wwv_flow_api.id(415776515307708102)
,p_region_css_classes=>'i-h240'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--noUI:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#:js-menu-callout'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(1905952052314948882)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(561127424267431983)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415778017626708103)
,p_plug_name=>'2. Variation A'
,p_parent_plug_id=>wwv_flow_api.id(415768707795701352)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415778536045708103)
,p_plug_name=>'Menu Bar List Template'
,p_parent_plug_id=>wwv_flow_api.id(415778017626708103)
,p_region_css_classes=>'i-h240'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--noUI:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(2505356324704497838)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(561127424267431983)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415779069203708104)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(415778017626708103)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>80
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415775552183708101)
,p_plug_name=>'Substitution Strings'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3:t-ContentBlock--lightBG'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl class="t-AVPList  t-AVPList--leftAligned">',
'<dt class="t-AVPList-label">',
'   #A01#',
'</dt>',
'<dd class="t-AVPList-value">',
'   ID of the Menu Item',
'</dd>',
'',
'<dt class="t-AVPList-label">',
'  #A02#',
'</dt>',
'<dd class="t-AVPList-value">',
'  True/False flag for whether or not this Menu Item and its children are disabled. ',
'</dd>',
'',
'<dt class="t-AVPList-label">',
'   #A03#',
'</dt>',
'<dd class="t-AVPList-value">',
'   True/False flag for whether or not this Menu Item and its children should be hidden.',
'</dd>',
'',
'<dt class="t-AVPList-label">',
'#A04#',
'</dt>',
'<dd class="t-AVPList-value">',
'  The text of the link inside of the Menu item. ',
'</dd>',
'',
'<dt class="t-AVPList-label">',
'#A05#',
'</dt>',
'<dd class="t-AVPList-value">',
'  Key command and/or shortcut to access this menu without tapping or clicking.',
'</dd>',
'',
'',
'</dl>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1920951786946779417)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(415767747368701351)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'List Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:lists:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-bars'
);
end;
/
prompt --application/pages/page_01306
begin
wwv_flow_api.create_page(
 p_id=>1306
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Menu Popup'
,p_alias=>'MENU-POPUP'
,p_step_title=>'Menu Popup - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2152191209205275401)
,p_plug_name=>'Customized Menu'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--padded:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This example shows a customized menu which has icons and a separator item that can help group menu items together. This menu also has a callout that points to the menu button.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2152192426884275413)
,p_plug_name=>'Customized Menu'
,p_region_name=>'customized'
,p_parent_plug_id=>wwv_flow_api.id(2152191209205275401)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:js-addActions:js-menu-callout'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(2152333587573851637)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(2044682192514224742)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2471718521967924187)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You can easily create a popup menu in your application by using Lists and associating a button with the menu.  To create a popup menu in your application, you must first have a list region on your page which contains the menu items.  Then you need'
||' to associate a button on your page with the menu so it will open the menu when clicked.</p>',
'',
'<div class="dm-Hero-steps">',
'<strong>Step 1. Create a Menu list region</strong><br>',
'<ol>',
'  <li>Create a List Region</li>',
'  <li>Set the Region Template to <em>Blank with Attributes</em></li>',
'  <li>Set the Static ID to <em>actions</em></li>',
'  <li>Set the List Template for this region to <em>Menu Popup</em></li>',
'</ol>',
'',
'<strong>Step 2. Associate a Button to open the menu</strong><br>',
'<ol>',
'  <li>Create a Button on the page</li>',
'  <li>Update Behavior to <em>Defined by Dynamic Action</em></li>',
'  <li>Update CSS Classes to add the class <em>js-menuButton</em></li>',
'  <li>Update Custom Attributes to add <em>data-menu="<strong>actions</strong>_menu"</em></li>',
'</ol>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2471719054561924188)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2471719590320924188)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2471720014988924189)
,p_plug_name=>'Multi Level Menu Example'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--padded:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Pop up menus can have many levels. This menu demonstrates a menu with several sub menus.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2063079111171416749)
,p_plug_name=>'Menu Popup'
,p_region_name=>'actions'
,p_parent_plug_id=>wwv_flow_api.id(2471720014988924189)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(2151851130486915930)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(2044682192514224742)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2063079248490416750)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2471720014988924189)
,p_button_name=>'MENU_BUTTON'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Menu Button'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-menuButton'
,p_icon_css_classes=>'fa-angle-down'
,p_button_cattributes=>'data-menu="actions_menu"'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2152191304446275402)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2152191209205275401)
,p_button_name=>'MENU_BUTTON_1'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Menu Button'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-menuButton'
,p_icon_css_classes=>'fa-angle-down'
,p_button_cattributes=>'data-menu="customized_menu"'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2055955367239222883)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2471719054561924188)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'List Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:lists:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-bars'
);
end;
/
prompt --application/pages/page_01307
begin
wwv_flow_api.create_page(
 p_id=>1307
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Contextual Info'
,p_alias=>'CONTEXTUAL-INFO'
,p_step_title=>'Contextual Info'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.dm-ContentWell {',
'    background-color: rgba(255, 255, 255, 0.5);',
'    box-shadow: 0 0 0 1px rgb(0 0 0 / 10%) inset;',
'    border-radius: 2px;',
'    overflow: auto;',
'    padding: 8px;',
'}'))
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1190945233487401436)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1190945716720401437)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1190946205380401440)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(598617615497554343)
,p_plug_name=>'3. Variation B'
,p_parent_plug_id=>wwv_flow_api.id(1190946205380401440)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>370
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(598617777353554344)
,p_name=>'Variation B Example'
,p_parent_plug_id=>wwv_flow_api.id(598617615497554343)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>380
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-ContextualInfo-item--stacked'
,p_new_grid_row=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>'select task_name, status from eba_ut_chart_tasks fetch first 1 rows only'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(666744069198116681)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(598617812798554345)
,p_query_column_id=>1
,p_column_alias=>'TASK_NAME'
,p_column_display_sequence=>10
,p_column_heading=>'Task Name:'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(598617985336554346)
,p_query_column_id=>2
,p_column_alias=>'STATUS'
,p_column_display_sequence=>20
,p_column_heading=>'Status:'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(598618027470554347)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(598617615497554343)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>400
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(598618178062554348)
,p_plug_name=>'4. Variation C'
,p_parent_plug_id=>wwv_flow_api.id(1190946205380401440)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>380
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(598618203792554349)
,p_name=>'Variation C Example'
,p_parent_plug_id=>wwv_flow_api.id(598618178062554348)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>10
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-ContextualInfo-label--stacked'
,p_new_grid_row=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>'select task_name, status from eba_ut_chart_tasks fetch first 1 rows only'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(666744069198116681)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(598618349617554350)
,p_query_column_id=>1
,p_column_alias=>'TASK_NAME'
,p_column_display_sequence=>10
,p_column_heading=>'Task Name:'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(776848259825258301)
,p_query_column_id=>2
,p_column_alias=>'STATUS'
,p_column_display_sequence=>20
,p_column_heading=>'Status:'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(776848352483258302)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(598618178062554348)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1190959951551410669)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(1190946205380401440)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>330
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1190960412565410670)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(1190959951551410669)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1191363662504582044)
,p_name=>'Default_Report'
,p_region_name=>'default_report'
,p_parent_plug_id=>wwv_flow_api.id(1190959951551410669)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>10
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>'select task_name, status from eba_ut_chart_tasks fetch first 1 rows only'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(666744069198116681)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(598617465419554341)
,p_query_column_id=>1
,p_column_alias=>'TASK_NAME'
,p_column_display_sequence=>10
,p_column_heading=>'Task Name:'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(598617588270554342)
,p_query_column_id=>2
,p_column_alias=>'STATUS'
,p_column_display_sequence=>20
,p_column_heading=>'Status:'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1190961376957410670)
,p_plug_name=>'2. Variation A'
,p_parent_plug_id=>wwv_flow_api.id(1190946205380401440)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>360
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1190962430539410671)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(1190961376957410670)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1191367517829588117)
,p_name=>'Variation A Example'
,p_parent_plug_id=>wwv_flow_api.id(1190961376957410670)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>10
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-ContextualInfo-item--stacked:t-ContextualInfo-label--stacked'
,p_new_grid_row=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>'select task_name, status from eba_ut_chart_tasks fetch first 1 rows only'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(666744069198116681)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(598617255004554339)
,p_query_column_id=>1
,p_column_alias=>'TASK_NAME'
,p_column_display_sequence=>10
,p_column_heading=>'Task Name:'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(598617353484554340)
,p_query_column_id=>2
,p_column_alias=>'STATUS'
,p_column_display_sequence=>20
,p_column_heading=>'Status:'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1190952650762401447)
,p_plug_name=>'Use Cases'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1190953170122401447)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1190953580439401448)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This list template is useful for displaying key value pairs.</p>',
'<p class="dm-Hero-steps">Set <strong>Contextual Info</strong> as the Report Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1489580750579492734)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'REPORT'
,p_attribute_05=>'Contextual Info'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(775202598489869434)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1190945233487401436)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Report Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:reports:&DEBUG.:RP,::'
,p_icon_css_classes=>'fa-bars'
);
end;
/
prompt --application/pages/page_01401
begin
wwv_flow_api.create_page(
 p_id=>1401
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Reports - Standard'
,p_alias=>'STANDARD-REPORTS'
,p_step_title=>'Standard Reports - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415787505339821811)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'REPORT'
,p_attribute_05=>'Standard'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415788583884821812)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This is the default report template used for displaying tabular data.</p>',
'<p class="dm-Hero-steps">Set <strong>Standard</strong> as the Report Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415789023296821813)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415789590898821813)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415790001376821814)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415805058167864751)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(415790001376821814)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>330
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415805540429864751)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(415805058167864751)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>360
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(415806095646864752)
,p_name=>'Table Report Template'
,p_parent_plug_id=>wwv_flow_api.id(415805058167864751)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>340
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'t-Report--stretch:#DEFAULT#:t-Report--altRowsDefault:t-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  task_name,',
'  start_date,',
'  status,',
'  assigned_to',
'from eba_ut_chart_tasks'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1089625725920080767)
,p_query_num_rows=>6
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(415806497754864754)
,p_query_column_id=>1
,p_column_alias=>'TASK_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Task name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(415806880828864756)
,p_query_column_id=>2
,p_column_alias=>'START_DATE'
,p_column_display_sequence=>2
,p_column_heading=>'Start date'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(415807229072864756)
,p_query_column_id=>3
,p_column_alias=>'STATUS'
,p_column_display_sequence=>3
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(415807680991864757)
,p_query_column_id=>4
,p_column_alias=>'ASSIGNED_TO'
,p_column_display_sequence=>4
,p_column_heading=>'Assigned to'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415808161238864757)
,p_plug_name=>'2. Variation A'
,p_parent_plug_id=>wwv_flow_api.id(415790001376821814)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>350
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(415808669535864758)
,p_name=>'Table Report Template'
,p_parent_plug_id=>wwv_flow_api.id(415808161238864757)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>370
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-Report--stretch:t-Report--altRowsDefault:t-Report--horizontalBorders:t-Report--rowHighlight'
,p_new_grid_row=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  task_name,',
'  start_date,',
'  status,',
'  assigned_to',
'from eba_ut_chart_tasks'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1089625725920080767)
,p_query_num_rows=>6
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(415809027022864758)
,p_query_column_id=>1
,p_column_alias=>'TASK_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Task name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(415809417522864759)
,p_query_column_id=>2
,p_column_alias=>'START_DATE'
,p_column_display_sequence=>2
,p_column_heading=>'Start date'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(415809824736864759)
,p_query_column_id=>3
,p_column_alias=>'STATUS'
,p_column_display_sequence=>3
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(415810226951864759)
,p_query_column_id=>4
,p_column_alias=>'ASSIGNED_TO'
,p_column_display_sequence=>4
,p_column_heading=>'Assigned to'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415810760370864760)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(415808161238864757)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>380
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415811260784864760)
,p_plug_name=>'3. Variation B'
,p_parent_plug_id=>wwv_flow_api.id(415790001376821814)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>360
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(415811769892864760)
,p_name=>'Table Report Template'
,p_parent_plug_id=>wwv_flow_api.id(415811260784864760)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>370
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-Report--stretch:t-Report--staticRowColors:t-Report--rowHighlightOff:t-Report--verticalBorders'
,p_new_grid_row=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  task_name,',
'  start_date,',
'  status,',
'  assigned_to',
'from eba_ut_chart_tasks'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1089625725920080767)
,p_query_num_rows=>6
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(415812176491864761)
,p_query_column_id=>1
,p_column_alias=>'TASK_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Task name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(415812534417864761)
,p_query_column_id=>2
,p_column_alias=>'START_DATE'
,p_column_display_sequence=>2
,p_column_heading=>'Start date'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(415812935218864761)
,p_query_column_id=>3
,p_column_alias=>'STATUS'
,p_column_display_sequence=>3
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(415813328143864762)
,p_query_column_id=>4
,p_column_alias=>'ASSIGNED_TO'
,p_column_display_sequence=>4
,p_column_heading=>'Assigned to'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415813839343864762)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(415811260784864760)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>380
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1920953725595802290)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(415789023296821813)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Report Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:reports:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-table'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2056021017916853817)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_api.id(415789023296821813)
,p_button_name=>'REGION_TYPE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Type'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6308:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'fa-list'
);
end;
/
prompt --application/pages/page_01402
begin
wwv_flow_api.create_page(
 p_id=>1402
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Reports - Interactive Report'
,p_alias=>'INTERACTIVE-REPORT'
,p_step_title=>'Interactive Report - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415938462585117770)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'REGION'
,p_attribute_02=>'Interactive Report'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415939445074117771)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Interactive Reports provide powerful features for customizing your report such as searching, filtering, sorting, highlighting, group-by, pivot, aggregations, calculations, charting, and more.</p>',
'<p class="dm-Hero-steps">Create a new Region with <strong>Interactive Report</strong> as the region type.</p>',
'',
'<p>You can further enhance Interactive Reports by using the <strong>Interactive Report</strong> region template, and enable template options such as <strong>Show Maximize Button</strong>.</p>',
'<p class="dm-Hero-steps">Set <strong>Interactive Report</strong> as the region template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415939963420117772)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415940489376117772)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415940952951117773)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415957209854171599)
,p_plug_name=>'1. Simple'
,p_parent_plug_id=>wwv_flow_api.id(415940952951117773)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415957716764171599)
,p_plug_name=>'Simple Interactive Report'
,p_parent_plug_id=>wwv_flow_api.id(415957209854171599)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(651498026300583706)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  task_name,',
'  start_date,',
'  status,',
'  assigned_to',
'from eba_ut_chart_tasks'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(415958145470171602)
,p_max_row_count=>'1000000'
,p_max_rows_per_page=>'6'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_icon_view_columns_per_row=>1
,p_owner=>'SHAKEEB'
,p_internal_uid=>415958145470171602
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(415958229451171607)
,p_db_column_name=>'TASK_NAME'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Task name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(415958691395171610)
,p_db_column_name=>'START_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Start date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(415959044102171610)
,p_db_column_name=>'STATUS'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(415959445220171610)
,p_db_column_name=>'ASSIGNED_TO'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Assigned to'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_rpt(
 p_id=>wwv_flow_api.id(415959886706171611)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'4159599'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'TASK_NAME:START_DATE:STATUS:ASSIGNED_TO'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415960334725171616)
,p_plug_name=>'2. Customized'
,p_parent_plug_id=>wwv_flow_api.id(415940952951117773)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>This Interactive Report has been customized with cell highlighting and a control break on the <i>Assigned To</i> column.  In addition, the region template has the <i>Show Maximize Button</i> template option enabled, allowing you to maximize this r'
||'eport to fill the screen.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415960875040171617)
,p_plug_name=>'Customized Interactive Report'
,p_parent_plug_id=>wwv_flow_api.id(415960334725171616)
,p_region_template_options=>'#DEFAULT#:js-showMaximizeButton'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(651498026300583706)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  task_name,',
'  start_date,',
'  status,',
'  case status ',
'    when ''Open'' then ''fa-clock-o is-open''',
'    when ''Closed'' then ''fa-check-circle is-closed''',
'    when ''On-Hold'' then ''fa-exclamation-circle is-holding''',
'    when ''Pending'' then ''fa-exclamation-triangle is-pending''',
'  end status_icon,',
'  assigned_to',
'from eba_ut_chart_tasks',
'order by 2'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(415961249439171617)
,p_max_row_count=>'1000000'
,p_max_rows_per_page=>'6'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#app_ui/img/icons/apex-edit-pencil.png" class="apex-edit-pencil" alt="">'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SHAKEEB'
,p_internal_uid=>415961249439171617
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(415961311193171617)
,p_db_column_name=>'TASK_NAME'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Task name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(415961783254171618)
,p_db_column_name=>'START_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Start date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(415962148662171618)
,p_db_column_name=>'STATUS'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(415962598373171618)
,p_db_column_name=>'ASSIGNED_TO'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Assigned to'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(415962987619171619)
,p_db_column_name=>'STATUS_ICON'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Status icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_rpt(
 p_id=>wwv_flow_api.id(415963371136171619)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'4159634'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>5
,p_report_columns=>'TASK_NAME:START_DATE:STATUS:ASSIGNED_TO:STATUS_ICON'
,p_sort_column_1=>'START_DATE'
,p_sort_direction_1=>'ASC'
,p_break_on=>'ASSIGNED_TO'
,p_break_enabled_on=>'ASSIGNED_TO'
);
wwv_flow_api.create_worksheet_condition(
 p_id=>wwv_flow_api.id(415963862629171620)
,p_report_id=>wwv_flow_api.id(415963371136171619)
,p_name=>'Closed Projects'
,p_condition_type=>'HIGHLIGHT'
,p_allow_delete=>'Y'
,p_column_name=>'STATUS'
,p_operator=>'='
,p_expr=>'Closed'
,p_condition_sql=>' (case when ("STATUS" = #APXWS_EXPR#) then #APXWS_HL_ID# end) '
,p_condition_display=>'#APXWS_COL_NAME# = ''Closed''  '
,p_enabled=>'Y'
,p_highlight_sequence=>10
,p_column_bg_color=>'#CBFACB'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415964327621171621)
,p_plug_name=>'3. Icon View'
,p_parent_plug_id=>wwv_flow_api.id(415940952951117773)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415964829783171621)
,p_plug_name=>'Icon Interactive Report'
,p_parent_plug_id=>wwv_flow_api.id(415964327621171621)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(651498026300583706)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  task_name,',
'  start_date,',
'  status,',
'  case status ',
'    when ''Open'' then ''fa-clock-o is-open''',
'    when ''Closed'' then ''fa-check-circle is-closed''',
'    when ''On-Hold'' then ''fa-exclamation-circle is-holding''',
'    when ''Pending'' then ''fa-exclamation-triangle is-pending''',
'  end status_icon,',
'  assigned_to',
'from eba_ut_chart_tasks',
'order by 2'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(415965239106171622)
,p_max_row_count=>'1000000'
,p_max_rows_per_page=>'6'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-IRR-icon">',
'  <span class="fa #STATUS_ICON#"></span>',
'  <span class="dm-IRR-iconLabel">#TASK_NAME#</span>',
'</div>'))
,p_icon_view_columns_per_row=>6
,p_owner=>'SHAKEEB'
,p_internal_uid=>415965239106171622
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(415965316868171622)
,p_db_column_name=>'TASK_NAME'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Task name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(415965785342171623)
,p_db_column_name=>'START_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Start date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(415966141083171624)
,p_db_column_name=>'STATUS'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Status'
,p_column_html_expression=>'<span class="fa #STATUS_ICON#"></span> #STATUS#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(415966525454171624)
,p_db_column_name=>'ASSIGNED_TO'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Assigned to'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(415966965555171625)
,p_db_column_name=>'STATUS_ICON'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Status icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_rpt(
 p_id=>wwv_flow_api.id(415967308850171625)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'4159674'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>5
,p_view_mode=>'ICON'
,p_report_columns=>'TASK_NAME:START_DATE:STATUS:ASSIGNED_TO:STATUS_ICON'
,p_sort_column_1=>'ASSIGNED_TO'
,p_sort_direction_1=>'ASC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(415950726004117785)
,p_plug_name=>'Button Positions'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>You can place buttons in the toolbar by setting the button position to <strong>Right of Interactive Report Search Bar</strong>.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405292039780637817)
,p_plug_name=>'Interactive Report with Buttons'
,p_parent_plug_id=>wwv_flow_api.id(415950726004117785)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(651498026300583706)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  task_name,',
'  start_date,',
'  status,',
'  assigned_to,',
'  case status ',
'    when ''Open'' then ''fa-clock-o is-open''',
'    when ''Closed'' then ''fa-check-circle is-closed''',
'    when ''On-Hold'' then ''fa-exclamation-circle is-holding''',
'    when ''Pending'' then ''fa-exclamation-triangle is-pending''',
'  end status_icon',
'  ',
'from eba_ut_chart_tasks'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(405292196447637818)
,p_max_row_count=>'1000000'
,p_max_rows_per_page=>'6'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'KYLE'
,p_internal_uid=>405292196447637818
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(405292216723637819)
,p_db_column_name=>'TASK_NAME'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Task name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(405292307781637820)
,p_db_column_name=>'START_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Start date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(405292405684637821)
,p_db_column_name=>'STATUS'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Status'
,p_column_html_expression=>'<span class="fa #STATUS_ICON#"></span> #STATUS#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(405292581870637822)
,p_db_column_name=>'ASSIGNED_TO'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Assigned to'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(696199521179857820)
,p_db_column_name=>'STATUS_ICON'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Status icon'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_rpt(
 p_id=>wwv_flow_api.id(416107540418550027)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'4161076'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'TASK_NAME:START_DATE:STATUS:ASSIGNED_TO:STATUS_ICON'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1920955192116808999)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(415939963420117772)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Report Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:reports:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-table'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2056021694920860221)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(415939963420117772)
,p_button_name=>'REGION_TYPE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Type'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6308:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'fa-list'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(415952820746117788)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(405292039780637817)
,p_button_name=>'RIGHT_OF_IR_BAR'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Right of Search Bar'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
);
end;
/
prompt --application/pages/page_01403
begin
wwv_flow_api.create_page(
 p_id=>1403
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Value Attribute Pairs'
,p_alias=>'VALUE-ATTR-PAIRS-REPORT'
,p_step_title=>'Value Attribute Pairs - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416110729737571196)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416111155756571233)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This report template is useful for displaying attribute value / key value pairs and works well with both Row or Column based queries.</p>',
'<p class="dm-Hero-steps">Set <strong>Value Attribute Pairs - Row </strong> as the Report Template for Row-based Queries.</p>',
'<p class="dm-Hero-steps">Set <strong>Value Attribute Pairs - Column </strong> as the Report Template for generic Column-based Queries.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416111634383571234)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416112197686571235)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416112672429571237)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416130805686579647)
,p_plug_name=>'1. Row Based'
,p_parent_plug_id=>wwv_flow_api.id(416112672429571237)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>130
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<h3 class="demo-title-h3">1. Row Based</h3>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416131396156579648)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(416130805686579647)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>160
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(416131867979579648)
,p_name=>'Value Attribute Pairs (Row Based)'
,p_parent_plug_id=>wwv_flow_api.id(416130805686579647)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>140
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-AVPList--rightAligned'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>'select task_name, status from eba_ut_chart_tasks'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(651486509760474849)
,p_query_num_rows=>6
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416132247759579650)
,p_query_column_id=>1
,p_column_alias=>'TASK_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Task name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416132625589579651)
,p_query_column_id=>2
,p_column_alias=>'STATUS'
,p_column_display_sequence=>2
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416133131382579651)
,p_plug_name=>'Column Based'
,p_parent_plug_id=>wwv_flow_api.id(416112672429571237)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>160
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<h3 class="demo-title-h3">2. Column Based</h3>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(416133664396579652)
,p_name=>'Value Attribute Pairs (Column Based)'
,p_parent_plug_id=>wwv_flow_api.id(416133131382579651)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>170
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-AVPList--leftAligned'
,p_new_grid_row=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  id,',
'  project, ',
'  created, ',
'  created_by, ',
'  updated, ',
'  updated_by',
'from eba_ut_chart_projects'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(651486824354474850)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416134067226579652)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416134415070579652)
,p_query_column_id=>2
,p_column_alias=>'PROJECT'
,p_column_display_sequence=>2
,p_column_heading=>'Project'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416134856975579653)
,p_query_column_id=>3
,p_column_alias=>'CREATED'
,p_column_display_sequence=>3
,p_column_heading=>'Created'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416135224395579653)
,p_query_column_id=>4
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>4
,p_column_heading=>'Created by'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416135613527579654)
,p_query_column_id=>5
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>5
,p_column_heading=>'Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416136007881579654)
,p_query_column_id=>6
,p_column_alias=>'UPDATED_BY'
,p_column_display_sequence=>6
,p_column_heading=>'Updated by'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416136552851579654)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(416133131382579651)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>180
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416123988850571298)
,p_plug_name=>'Use Cases'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416124354490571300)
,p_plug_name=>'Button Positions'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(405292656149637823)
,p_name=>'Value Attribute Pairs with Buttons'
,p_parent_plug_id=>wwv_flow_api.id(416124354490571300)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>10
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-AVPList--rightAligned'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>'select task_name, status from eba_ut_chart_tasks'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(651486509760474849)
,p_query_num_rows=>6
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(405292726119637824)
,p_query_column_id=>1
,p_column_alias=>'TASK_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Task name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(405292814751637825)
,p_query_column_id=>2
,p_column_alias=>'STATUS'
,p_column_display_sequence=>2
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405293068441637827)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(405292656149637823)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1920957543160823351)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(416111634383571234)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Report Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:reports:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-table'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405292904484637826)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(405292656149637823)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
);
end;
/
prompt --application/pages/page_01405
begin
wwv_flow_api.create_page(
 p_id=>1405
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Reports - Comments'
,p_alias=>'COMMENTS-REPORT'
,p_step_title=>'Comments Report - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416197110778740474)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This report template is used to display user comments and status updates.</p>',
'<p class="dm-Hero-steps">Set <strong>Comments</strong> as the Report Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416197641539740475)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416198195388740475)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416198617049740476)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416238472789767394)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(416198617049740476)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>400
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416238933810767394)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(416238472789767394)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>430
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(416239445573767395)
,p_name=>'Comments Report Default'
,p_parent_plug_id=>wwv_flow_api.id(416238472789767394)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>410
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-Comments--chat'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  p.id,',
'  apex_string.get_initials(p.created_by) USER_ICON,',
'  p.created COMMENT_DATE,',
'  lower(p.created_by) USER_NAME,',
'  '' '' COMMENT_TEXT,',
'  ''Delete'' ACTIONS,',
'  '' '' ATTRIBUTE_1,',
'  '' '' ATTRIBUTE_2,',
'  '' '' ATTRIBUTE_3,',
'  '' '' ATTRIBUTE_4,',
'  t.created task_created,',
'  t.created_by task_owner,',
'  t.task_name task_name,',
'  ''u-color-''||ora_hash(p.created_by,45) icon_modifier',
'from',
'  eba_ut_chart_tasks t,',
'  eba_ut_chart_projects p',
'where',
'  t.project = p.id',
'order by t.created'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1164140200812557328)
,p_query_num_rows=>6
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416239851865767395)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416240201466767397)
,p_query_column_id=>2
,p_column_alias=>'USER_ICON'
,p_column_display_sequence=>2
,p_column_heading=>'User icon'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416240626210767397)
,p_query_column_id=>3
,p_column_alias=>'COMMENT_DATE'
,p_column_display_sequence=>3
,p_column_heading=>'Comment date'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416241094104767397)
,p_query_column_id=>4
,p_column_alias=>'USER_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'User name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416241420073767398)
,p_query_column_id=>5
,p_column_alias=>'COMMENT_TEXT'
,p_column_display_sequence=>5
,p_column_heading=>'Comment text'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#TASK_NAME# - #TASK_OWNER# (#TASK_CREATED#)'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416241807934767398)
,p_query_column_id=>6
,p_column_alias=>'ACTIONS'
,p_column_display_sequence=>6
,p_column_heading=>'Actions'
,p_use_as_row_header=>'N'
,p_column_link=>'javascript:alert(''Implement delete for comment ID: '' + #ID#)'
,p_column_linktext=>'#ACTIONS#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416242254035767398)
,p_query_column_id=>7
,p_column_alias=>'ATTRIBUTE_1'
,p_column_display_sequence=>7
,p_column_heading=>'Attribute 1'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416242640453767399)
,p_query_column_id=>8
,p_column_alias=>'ATTRIBUTE_2'
,p_column_display_sequence=>8
,p_column_heading=>'Attribute 2'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416243073347767399)
,p_query_column_id=>9
,p_column_alias=>'ATTRIBUTE_3'
,p_column_display_sequence=>9
,p_column_heading=>'Attribute 3'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416243485515767399)
,p_query_column_id=>10
,p_column_alias=>'ATTRIBUTE_4'
,p_column_display_sequence=>10
,p_column_heading=>'Attribute 4'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416243892899767399)
,p_query_column_id=>11
,p_column_alias=>'TASK_CREATED'
,p_column_display_sequence=>11
,p_column_heading=>'Task created'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416244212356767400)
,p_query_column_id=>12
,p_column_alias=>'TASK_OWNER'
,p_column_display_sequence=>12
,p_column_heading=>'Task owner'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416244650393767400)
,p_query_column_id=>13
,p_column_alias=>'TASK_NAME'
,p_column_display_sequence=>13
,p_column_heading=>'Task name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416245084525767400)
,p_query_column_id=>14
,p_column_alias=>'ICON_MODIFIER'
,p_column_display_sequence=>14
,p_column_heading=>'Icon modifier'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'u-color #ICON_MODIFIER#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416245570718767401)
,p_plug_name=>'2. Variation A'
,p_parent_plug_id=>wwv_flow_api.id(416198617049740476)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>420
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416246057935767401)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(416245570718767401)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(416246589468767402)
,p_name=>'Comments Report Variation A'
,p_parent_plug_id=>wwv_flow_api.id(416245570718767401)
,p_display_sequence=>10
,p_component_template_options=>'#DEFAULT#:t-Comments--basic'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  p.id,',
'  apex_string.get_initials(p.created_by) USER_ICON,',
'  p.created COMMENT_DATE,',
'  lower(p.created_by) USER_NAME,',
'  '' '' COMMENT_TEXT,',
'  '' '' ACTIONS,',
'  '' '' ATTRIBUTE_1,',
'  '' '' ATTRIBUTE_2,',
'  '' '' ATTRIBUTE_3,',
'  '' '' ATTRIBUTE_4,',
'  t.created task_created,',
'  t.created_by task_owner,',
'  t.task_name task_name,',
'  ''u-color-''||ora_hash(p.created_by,45) icon_modifier',
'from',
'  eba_ut_chart_tasks t,',
'  eba_ut_chart_projects p',
'where',
'  t.project = p.id',
'order by t.created'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1164140200812557328)
,p_query_num_rows=>6
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416246918236767402)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416247354939767402)
,p_query_column_id=>2
,p_column_alias=>'USER_ICON'
,p_column_display_sequence=>2
,p_column_heading=>'User icon'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416247785739767403)
,p_query_column_id=>3
,p_column_alias=>'COMMENT_DATE'
,p_column_display_sequence=>3
,p_column_heading=>'Comment date'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416248140281767403)
,p_query_column_id=>4
,p_column_alias=>'USER_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'User name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416248576697767404)
,p_query_column_id=>5
,p_column_alias=>'COMMENT_TEXT'
,p_column_display_sequence=>5
,p_column_heading=>'Comment text'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#TASK_NAME# - #TASK_OWNER# (#TASK_CREATED#)'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416248911917767404)
,p_query_column_id=>6
,p_column_alias=>'ACTIONS'
,p_column_display_sequence=>6
,p_column_heading=>'Actions'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416249315484767404)
,p_query_column_id=>7
,p_column_alias=>'ATTRIBUTE_1'
,p_column_display_sequence=>7
,p_column_heading=>'Attribute 1'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416249745989767404)
,p_query_column_id=>8
,p_column_alias=>'ATTRIBUTE_2'
,p_column_display_sequence=>8
,p_column_heading=>'Attribute 2'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416250143282767405)
,p_query_column_id=>9
,p_column_alias=>'ATTRIBUTE_3'
,p_column_display_sequence=>9
,p_column_heading=>'Attribute 3'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416250592054767405)
,p_query_column_id=>10
,p_column_alias=>'ATTRIBUTE_4'
,p_column_display_sequence=>10
,p_column_heading=>'Attribute 4'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416250924887767405)
,p_query_column_id=>11
,p_column_alias=>'TASK_CREATED'
,p_column_display_sequence=>11
,p_column_heading=>'Task created'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416251384523767406)
,p_query_column_id=>12
,p_column_alias=>'TASK_OWNER'
,p_column_display_sequence=>12
,p_column_heading=>'Task owner'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416251736977767406)
,p_query_column_id=>13
,p_column_alias=>'TASK_NAME'
,p_column_display_sequence=>13
,p_column_heading=>'Task name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416252142670767406)
,p_query_column_id=>14
,p_column_alias=>'ICON_MODIFIER'
,p_column_display_sequence=>14
,p_column_heading=>'Icon modifier'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'u-color #ICON_MODIFIER#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416215422280740496)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'REPORT'
,p_attribute_05=>'Comments'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(915210795544378412)
,p_plug_name=>'Substution Strings'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-ContentWell">',
'<dl class="t-AVPList  t-AVPList--leftAligned">',
'    <dt class="t-AVPList-label">',
'        #COMMENT_MODIFIERS#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        CSS Class-based modifiers for a comment item',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #ICON_MODIFIER#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        CSS Class-based modifiers for comment icon',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #USER_ICON#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        CSS Class-based modifiers for user icon',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #USER_NAME#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        User name',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #COMMENT_DATE#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Date of the comment',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #ACTIONS#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Actions for the comment',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #COMMENT_TEXT#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Text of the comment',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #ATTRIBUTE_1#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Additional attribute 1',
'    </dd>',
'    <dt class="t-AVPList-label">',
'       #ATTRIBUTE_2#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Additional attribute 2',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #ATTRIBUTE_3#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Additional attribute 3',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #ATTRIBUTE_4#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Additional attribute 4',
'    </dd>',
'</dl>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1702446335272649525)
,p_plug_name=>'Sample Query'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre class="dm-Code lang-sql"><code>select',
'  user_icon, -- use apex_string.get_initials(str) to get initials',
'  comment_date,',
'  user_name,',
'  comment_text,',
'  '' '' comment_modifiers,',
'  ''u-color-''||ora_hash(user_name,45) icon_modifier,',
'  ''Edit'' actions,',
'  '' '' attribute_1,',
'  '' '' attribute_2,',
'  '' '' attribute_3,',
'  '' '' attribute_4',
'from',
'  dual</code></pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1920956028246813285)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(416197641539740475)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Report Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:reports:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-table'
);
end;
/
prompt --application/pages/page_01406
begin
wwv_flow_api.create_page(
 p_id=>1406
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Reports - Timeline'
,p_alias=>'TIMELINE-REPORTS'
,p_step_title=>'Activity Timeline - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416278877139820019)
,p_plug_name=>'Overview'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>Timeline</strong> is a Classic Report template that is useful for displaying a series of events. It can be used to showcase the history of a given widget, recent updates, or new interactions within an application.</p>',
'<p class="dm-Hero-steps">Set <strong>Timeline</strong> as the Report Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416279341776820020)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416279808417820020)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'JUMP'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416295511453820041)
,p_plug_name=>'Sample Query'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre class="dm-Code lang-sql"><code>select',
'  substr(username,0,2) user_avatar,',
'  ''u-color-''|| ( ora_hash(username,45) + 1 ) user_color,',
'  user_name,',
'  event_date,',
'  event_type,',
'  event_title,',
'  event_desc,',
'  case status ',
'    when ''open'' then ''fa fa-clock-o''',
'    when ''closed'' then ''fa fa-check-circle-o''',
'    when ''on-hold'' then ''fa fa-exclamation-circle''',
'    when ''pending'' then ''fa fa-exclamation-triangle''',
'  end event_icon,',
'  case status ',
'    when ''open'' then ''is-new''',
'    when ''closed'' then ''is-removed''',
'    when ''on-hold'' then ''is-updated''',
'    when ''pending'' then ''is-updated''',
'  end event_status,',
'  url event_link',
'from dual</code></pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416332902410830288)
,p_plug_name=>'Substution Strings'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-ContentWell">',
'<dl class="t-AVPList  t-AVPList--leftAligned">',
'    <dt class="t-AVPList-label">',
'        #EVENT_MODIFIERS#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        CSS Class-based modifiers for an event item',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #EVENT_ATTRIBUTES#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Custom attributes for an event item',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #USER_COLOR#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Color applied to a user initials using u-color-XX classes or custom classes',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #USER_AVATAR#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        User initials or image',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #USER_NAME#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        User name',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #EVENT_DATE#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Date of event displayed below user name',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #EVENT_STATUS#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Type of event. Substitute with "is-new", "is-updated" or "is-removed" for default styling.',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #EVENT_ICON#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Icon of event type.',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #EVENT_TITLE#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Name of event',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #EVENT_DESC#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Description of event displayed below event name',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #EVENT_LINK#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Link for the event',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #EVENT_TYPE#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Type of the event',
'    </dd>',
'</dl>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(766161362753482424)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'REPORT'
,p_attribute_05=>'Timeline'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(844155280971515513)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416320344862830277)
,p_plug_name=>'Example: Default'
,p_parent_plug_id=>wwv_flow_api.id(844155280971515513)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(416320811411830277)
,p_name=>'Timeline Report Default'
,p_parent_plug_id=>wwv_flow_api.id(416320344862830277)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>420
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-Report--hideNoPagination'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  p.id,',
'  substr(p.created_by,0,2) USER_AVATAR,',
'  p.created EVENT_DATE,',
'  lower(p.created_by) USER_NAME,',
'  t.task_name EVENT_TITLE,',
'  t.created created,',
'  lower(t.created_by) owner,',
'  null EVENT_DESC,',
'  case status ',
'    when ''Open'' then ''fa fa-clock-o''',
'    when ''Closed'' then ''fa fa-check-circle-o''',
'    when ''On-Hold'' then ''fa fa-exclamation-circle''',
'    when ''Pending'' then ''fa fa-exclamation-triangle''',
'  end EVENT_ICON,',
'  case status ',
'    when ''Open'' then ''is-new''',
'    when ''Closed'' then ''is-removed''',
'    when ''On-Hold'' then ''is-updated''',
'    when ''Pending'' then ''is-updated''',
'  end EVENT_STATUS,',
'  status EVENT_TYPE,',
'  ''u-color-''||( ora_hash(p.created_by,44) + 1 ) USER_COLOR',
'from',
'  eba_ut_chart_tasks t,',
'  eba_ut_chart_projects p',
'where',
'  t.project = p.id',
'order by p.created'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(65791776421862960)
,p_query_num_rows=>6
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416321274752830278)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416321647785830278)
,p_query_column_id=>2
,p_column_alias=>'USER_AVATAR'
,p_column_display_sequence=>3
,p_column_heading=>'User avatar'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416322055778830279)
,p_query_column_id=>3
,p_column_alias=>'EVENT_DATE'
,p_column_display_sequence=>4
,p_column_heading=>'Event date'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416322457431830279)
,p_query_column_id=>4
,p_column_alias=>'USER_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'User name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416322824015830279)
,p_query_column_id=>5
,p_column_alias=>'EVENT_TITLE'
,p_column_display_sequence=>5
,p_column_heading=>'Event title'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416323242186830280)
,p_query_column_id=>6
,p_column_alias=>'CREATED'
,p_column_display_sequence=>11
,p_column_heading=>'Created'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416323656605830280)
,p_query_column_id=>7
,p_column_alias=>'OWNER'
,p_column_display_sequence=>12
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416324083446830280)
,p_query_column_id=>8
,p_column_alias=>'EVENT_DESC'
,p_column_display_sequence=>6
,p_column_heading=>'Event desc'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#CREATED#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416324470118830281)
,p_query_column_id=>9
,p_column_alias=>'EVENT_ICON'
,p_column_display_sequence=>7
,p_column_heading=>'Event icon'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416324847873830281)
,p_query_column_id=>10
,p_column_alias=>'EVENT_STATUS'
,p_column_display_sequence=>8
,p_column_heading=>'Event status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416325276682830281)
,p_query_column_id=>11
,p_column_alias=>'EVENT_TYPE'
,p_column_display_sequence=>10
,p_column_heading=>'Event type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416325610369830282)
,p_query_column_id=>12
,p_column_alias=>'USER_COLOR'
,p_column_display_sequence=>9
,p_column_heading=>'User color'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416326184786830282)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(416320344862830277)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>440
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416326610455830282)
,p_plug_name=>'Example: Compact'
,p_parent_plug_id=>wwv_flow_api.id(844155280971515513)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(416327185859830283)
,p_name=>'Timeline Report Compact'
,p_parent_plug_id=>wwv_flow_api.id(416326610455830282)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>10
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-Timeline--compact'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  p.id,',
'  substr(p.created_by,0,2) USER_AVATAR,',
'  p.created EVENT_DATE,',
'  lower(p.created_by) USER_NAME,',
'  t.task_name EVENT_TITLE,',
'  t.created created,',
'  lower(t.created_by) owner,',
'  null EVENT_DESC,',
'  case status ',
'    when ''Open'' then ''fa fa-clock-o''',
'    when ''Closed'' then ''fa fa-check-circle-o''',
'    when ''On-Hold'' then ''fa fa-exclamation-circle''',
'    when ''Pending'' then ''fa fa-exclamation-triangle''',
'  end EVENT_ICON,',
'  case status ',
'    when ''Open'' then ''is-new''',
'    when ''Closed'' then ''is-removed''',
'    when ''On-Hold'' then ''is-updated''',
'    when ''Pending'' then ''is-updated''',
'  end EVENT_STATUS,',
'  status EVENT_TYPE,',
'  ''u-color-''||( ora_hash(p.created_by,44) + 1 ) USER_COLOR',
'from',
'  eba_ut_chart_tasks t,',
'  eba_ut_chart_projects p',
'where',
'  t.project = p.id',
'order by p.created'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(65791776421862960)
,p_query_num_rows=>6
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416327582423830283)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416327933667830284)
,p_query_column_id=>2
,p_column_alias=>'USER_AVATAR'
,p_column_display_sequence=>3
,p_column_heading=>'User avatar'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416328387776830284)
,p_query_column_id=>3
,p_column_alias=>'EVENT_DATE'
,p_column_display_sequence=>4
,p_column_heading=>'Event date'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416328774092830285)
,p_query_column_id=>4
,p_column_alias=>'USER_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'User name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416329180055830285)
,p_query_column_id=>5
,p_column_alias=>'EVENT_TITLE'
,p_column_display_sequence=>5
,p_column_heading=>'Event title'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416329576168830285)
,p_query_column_id=>6
,p_column_alias=>'CREATED'
,p_column_display_sequence=>11
,p_column_heading=>'Created'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416329949959830286)
,p_query_column_id=>7
,p_column_alias=>'OWNER'
,p_column_display_sequence=>12
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416330335698830286)
,p_query_column_id=>8
,p_column_alias=>'EVENT_DESC'
,p_column_display_sequence=>6
,p_column_heading=>'Event desc'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#CREATED#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416330703594830286)
,p_query_column_id=>9
,p_column_alias=>'EVENT_ICON'
,p_column_display_sequence=>7
,p_column_heading=>'Event icon'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416331194768830287)
,p_query_column_id=>10
,p_column_alias=>'EVENT_STATUS'
,p_column_display_sequence=>8
,p_column_heading=>'Event status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416331541523830287)
,p_query_column_id=>11
,p_column_alias=>'EVENT_TYPE'
,p_column_display_sequence=>10
,p_column_heading=>'Event type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(416331982492830287)
,p_query_column_id=>12
,p_column_alias=>'USER_COLOR'
,p_column_display_sequence=>9
,p_column_heading=>'User color'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416332431968830288)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(416326610455830282)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1920956324926814610)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(416279341776820020)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Report Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:reports:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-table'
);
end;
/
prompt --application/pages/page_01407
begin
wwv_flow_api.create_page(
 p_id=>1407
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Reports - Content Row'
,p_alias=>'CONTENT-ROW-REPORT'
,p_step_title=>'Content Row - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(766547583396564363)
,p_plug_name=>'Overview'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>Content Row</strong> is a Classic Report template that is suitable for displaying most types of content. This report features a column for selection such as a checkbox or radio button, an icon, title and description, miscellaneous attribut'
||'es, and actions.</p>',
'<p class="dm-Hero-steps">Set <strong>Content Row</strong> as the Report Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(766548048033564364)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(766548514674564364)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'JUMP'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(766564217710564385)
,p_plug_name=>'Sample Query'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre class="dm-Code lang-sql"><code>select',
'  null item_classes,',
'  null selection,',
'  ''fa fa-cloud'' icon_class,',
'  null icon_html,',
'  null title,',
'  null description,',
'  null misc,',
'  null actions',
'from',
'  dual</code></pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(766601608667574632)
,p_plug_name=>'Substution Strings'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-ContentWell">',
'<dl class="t-AVPList  t-AVPList--leftAligned">',
'    <dt class="t-AVPList-label">',
'        #ITEM_CLASSES#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        CSS Class-based modifiers for the content row item',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #SELECTION#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Use this to add a checkbox or radio button for selection',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #ICON_CLASS#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Icon of the content row. Please prefix with "fa" when using Font APEX.',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #ICON_HTML#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Use this to display custom HTML in place of the icon, for example an image tag.',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #TITLE#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Title column, typically the link ',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #DESCRIPTION#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Description or text of the content',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #MISC#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        This displays adjacent actions column and can be used for showing user information or last updated date.',
'    </dd>',
'    <dt class="t-AVPList-label">',
'        #ACTIONS#',
'    </dt>',
'    <dd class="t-AVPList-value">',
'        Use this to display a button or other actions',
'    </dd>',
'</dl>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1116430069010226768)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'REPORT'
,p_attribute_05=>'Content Row'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1194423987228259857)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(330458807218724845)
,p_plug_name=>'Example: Custom 1'
,p_parent_plug_id=>wwv_flow_api.id(1194423987228259857)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(330458917640724846)
,p_name=>'Content Row Report Custom 1'
,p_parent_plug_id=>wwv_flow_api.id(330458807218724845)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>10
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-Report--hideNoPagination:t-ContentRow--hideIcon:t-ContentRow--hideActions'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  null item_classes,',
'  APEX_ITEM.CHECKBOX2(p_idx => 1, p_value => t.id) selection,',
'  case t.status ',
'    when ''Open'' then ''fa fa-lg fa-exclamation-circle-o''',
'    when ''Closed'' then ''fa fa-lg fa-check-circle u-success-text''',
'    when ''On-Hold'' then ''fa fa-lg fa-minus-circle u-danger-text''',
'    when ''Pending'' then ''fa fa-lg fa-exclamation-triangle u-warning-text''',
'  end icon_class,',
'  null icon_html,',
'  t.task_name title,',
'  ''Project: '' || p.project description,',
'  t.status misc,',
'  null actions',
'from',
'  eba_ut_chart_tasks t,',
'  eba_ut_chart_projects p',
'where',
'  t.project = p.id',
'order by p.created'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(350261643030073247)
,p_query_num_rows=>6
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(330459068329724847)
,p_query_column_id=>1
,p_column_alias=>'ITEM_CLASSES'
,p_column_display_sequence=>1
,p_column_heading=>'Item Classes'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(330459196356724848)
,p_query_column_id=>2
,p_column_alias=>'SELECTION'
,p_column_display_sequence=>2
,p_column_heading=>'Selection'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(330459278365724849)
,p_query_column_id=>3
,p_column_alias=>'ICON_CLASS'
,p_column_display_sequence=>3
,p_column_heading=>'Icon Class'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(330459345249724850)
,p_query_column_id=>4
,p_column_alias=>'ICON_HTML'
,p_column_display_sequence=>4
,p_column_heading=>'Icon Html'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350300209093877501)
,p_query_column_id=>5
,p_column_alias=>'TITLE'
,p_column_display_sequence=>5
,p_column_heading=>'Title'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350300343378877502)
,p_query_column_id=>6
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>6
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350300414223877503)
,p_query_column_id=>7
,p_column_alias=>'MISC'
,p_column_display_sequence=>7
,p_column_heading=>'Misc'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350300516658877504)
,p_query_column_id=>8
,p_column_alias=>'ACTIONS'
,p_column_display_sequence=>8
,p_column_heading=>'Actions'
,p_use_as_row_header=>'N'
,p_column_link=>'#'
,p_column_linktext=>'<span class="t-Icon fa fa-edit" aria-hidden="true"></span>Edit'
,p_column_link_attr=>'class="t-Button t-Button--icon t-Button--iconLeft"'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(350300618327877505)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(330458807218724845)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(350301370893877512)
,p_plug_name=>'Example: Custom 2'
,p_parent_plug_id=>wwv_flow_api.id(1194423987228259857)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>Using an image for the icon_html placeholder.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(350301470378877513)
,p_name=>'Content Row Report Custom 2'
,p_parent_plug_id=>wwv_flow_api.id(350301370893877512)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>20
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  null item_classes,',
'  null selection,',
'  null icon_class,',
'  ''<img src="#APP_IMAGES#img/app_user.jpg" alt="" />'' icon_html,',
'  t.task_name title,',
'  ''Project: '' || p.project description,',
'  null misc,',
'  null actions',
'from',
'  eba_ut_chart_tasks t,',
'  eba_ut_chart_projects p',
'where',
'  t.project = p.id',
'order by p.created'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(350261643030073247)
,p_query_num_rows=>6
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350301570546877514)
,p_query_column_id=>1
,p_column_alias=>'ITEM_CLASSES'
,p_column_display_sequence=>1
,p_column_heading=>'Item Classes'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350301637834877515)
,p_query_column_id=>2
,p_column_alias=>'SELECTION'
,p_column_display_sequence=>2
,p_column_heading=>'Selection'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350301749336877516)
,p_query_column_id=>3
,p_column_alias=>'ICON_CLASS'
,p_column_display_sequence=>3
,p_column_heading=>'Icon Class'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350301858753877517)
,p_query_column_id=>4
,p_column_alias=>'ICON_HTML'
,p_column_display_sequence=>4
,p_column_heading=>'Icon Html'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350301954468877518)
,p_query_column_id=>5
,p_column_alias=>'TITLE'
,p_column_display_sequence=>5
,p_column_heading=>'Title'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350302073062877519)
,p_query_column_id=>6
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>6
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350302134553877520)
,p_query_column_id=>7
,p_column_alias=>'MISC'
,p_column_display_sequence=>7
,p_column_heading=>'Misc'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350302216732877521)
,p_query_column_id=>8
,p_column_alias=>'ACTIONS'
,p_column_display_sequence=>8
,p_column_heading=>'Actions'
,p_use_as_row_header=>'N'
,p_column_link=>'#'
,p_column_linktext=>'<span class="t-Icon fa fa-edit" aria-hidden="true"></span>Edit'
,p_column_link_attr=>'class="t-Button t-Button--icon t-Button--iconLeft"'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(350302327986877522)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(350301370893877512)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(766589051119574621)
,p_plug_name=>'Example: Default'
,p_parent_plug_id=>wwv_flow_api.id(1194423987228259857)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(766589517668574621)
,p_name=>'Content Row Report Default'
,p_parent_plug_id=>wwv_flow_api.id(766589051119574621)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>420
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-Report--hideNoPagination'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  null item_classes,',
'  null selection,',
'  case t.status ',
'    when ''Open'' then ''fa fa-lg fa-exclamation-circle-o''',
'    when ''Closed'' then ''fa fa-lg fa-check-circle u-success-text''',
'    when ''On-Hold'' then ''fa fa-lg fa-minus-circle u-danger-text''',
'    when ''Pending'' then ''fa fa-lg fa-exclamation-triangle u-warning-text''',
'  end icon_class,',
'  null icon_html,',
'  t.task_name title,',
'  ''Project: '' || p.project description,',
'  t.status misc,',
'  null actions',
'from',
'  eba_ut_chart_tasks t,',
'  eba_ut_chart_projects p',
'where',
'  t.project = p.id',
'order by p.created'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(350261643030073247)
,p_query_num_rows=>6
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(330457179049724828)
,p_query_column_id=>1
,p_column_alias=>'ITEM_CLASSES'
,p_column_display_sequence=>1
,p_column_heading=>'Item Classes'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(330457208742724829)
,p_query_column_id=>2
,p_column_alias=>'SELECTION'
,p_column_display_sequence=>2
,p_column_heading=>'Selection'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(330457379027724830)
,p_query_column_id=>3
,p_column_alias=>'ICON_CLASS'
,p_column_display_sequence=>3
,p_column_heading=>'Icon Class'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(330457432680724831)
,p_query_column_id=>4
,p_column_alias=>'ICON_HTML'
,p_column_display_sequence=>4
,p_column_heading=>'Icon Html'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(330457525173724832)
,p_query_column_id=>5
,p_column_alias=>'TITLE'
,p_column_display_sequence=>5
,p_column_heading=>'Title'
,p_use_as_row_header=>'N'
,p_column_link=>'#'
,p_column_linktext=>'#TITLE#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(330457683026724833)
,p_query_column_id=>6
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>6
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(330457730314724834)
,p_query_column_id=>7
,p_column_alias=>'MISC'
,p_column_display_sequence=>7
,p_column_heading=>'Misc'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(330457819928724835)
,p_query_column_id=>8
,p_column_alias=>'ACTIONS'
,p_column_display_sequence=>8
,p_column_heading=>'Actions'
,p_use_as_row_header=>'N'
,p_column_link=>'#'
,p_column_linktext=>'<span class="t-Icon fa fa-edit" aria-hidden="true"></span>Edit'
,p_column_link_attr=>'class="t-Button t-Button--icon t-Button--iconLeft t-Button--link"'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(766594891043574626)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(766589051119574621)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>440
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(766595316712574626)
,p_plug_name=>'Example: Compact'
,p_parent_plug_id=>wwv_flow_api.id(1194423987228259857)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(350303641382877535)
,p_name=>'Content Row Report Compact'
,p_parent_plug_id=>wwv_flow_api.id(766595316712574626)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>10
,p_region_css_classes=>'dm-ContentWell'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-ContentRow--styleCompact:t-ContentRow--hideDescription'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  null item_classes,',
'  null selection,',
'  case t.status ',
'    when ''Open'' then ''fa fa-exclamation-circle-o''',
'    when ''Closed'' then ''fa fa-check-circle u-success-text''',
'    when ''On-Hold'' then ''fa fa-minus-circle u-danger-text''',
'    when ''Pending'' then ''fa fa-exclamation-triangle u-warning-text''',
'  end icon_class,',
'  null icon_html,',
'  t.task_name title,',
'  ''Project: '' || p.project description,',
'  t.status misc,',
'  null actions',
'from',
'  eba_ut_chart_tasks t,',
'  eba_ut_chart_projects p',
'where',
'  t.project = p.id',
'order by p.created'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(350261643030073247)
,p_query_num_rows=>6
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350303766039877536)
,p_query_column_id=>1
,p_column_alias=>'ITEM_CLASSES'
,p_column_display_sequence=>1
,p_column_heading=>'Item Classes'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350303852292877537)
,p_query_column_id=>2
,p_column_alias=>'SELECTION'
,p_column_display_sequence=>2
,p_column_heading=>'Selection'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350303977178877538)
,p_query_column_id=>3
,p_column_alias=>'ICON_CLASS'
,p_column_display_sequence=>3
,p_column_heading=>'Icon Class'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350304043991877539)
,p_query_column_id=>4
,p_column_alias=>'ICON_HTML'
,p_column_display_sequence=>4
,p_column_heading=>'Icon Html'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350304161362877540)
,p_query_column_id=>5
,p_column_alias=>'TITLE'
,p_column_display_sequence=>5
,p_column_heading=>'Title'
,p_use_as_row_header=>'N'
,p_column_link=>'#'
,p_column_linktext=>'#TITLE#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350304253935877541)
,p_query_column_id=>6
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>6
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350304307058877542)
,p_query_column_id=>7
,p_column_alias=>'MISC'
,p_column_display_sequence=>7
,p_column_heading=>'Misc'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(350304468574877543)
,p_query_column_id=>8
,p_column_alias=>'ACTIONS'
,p_column_display_sequence=>8
,p_column_heading=>'Actions'
,p_use_as_row_header=>'N'
,p_column_link=>'#'
,p_column_linktext=>'<span class="t-Icon fa fa-edit" aria-hidden="true"></span>Edit'
,p_column_link_attr=>'class="t-Button t-Button--icon t-Button--iconLeft t-Button--link t-Button--small"'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(766601138225574632)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(766595316712574626)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(350270078645744414)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(766548048033564364)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Report Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:reports:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-table'
);
end;
/
prompt --application/pages/page_01410
begin
wwv_flow_api.create_page(
 p_id=>1410
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Interactive Grid'
,p_alias=>'INTERACTIVE-GRID'
,p_step_title=>'Interactive Grid - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2015606505110607143)
,p_plug_name=>'Example'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(246615468901698828)
,p_plug_name=>'Basic Reporting'
,p_parent_plug_id=>wwv_flow_api.id(2015606505110607143)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(651498026300583706)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    task_name,',
'    status,',
'    start_date,',
'    end_date,',
'    assigned_to,',
'    cost,',
'    budget,',
'    updated_by,',
'    updated',
'from',
'    EBA_UT_chart_tasks'))
,p_plug_source_type=>'NATIVE_IG'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(246615681470698830)
,p_name=>'TASK_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TASK_NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Task name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>10
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(246615730135698831)
,p_name=>'STATUS'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'STATUS'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Status'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>20
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(246615898044698832)
,p_name=>'START_DATE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'START_DATE'
,p_data_type=>'DATE'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DATE_PICKER'
,p_heading=>'Start date'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>30
,p_value_alignment=>'CENTER'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_date_ranges=>'ALL'
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(246615996169698833)
,p_name=>'END_DATE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'END_DATE'
,p_data_type=>'DATE'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DATE_PICKER'
,p_heading=>'End date'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>40
,p_value_alignment=>'CENTER'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_date_ranges=>'ALL'
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(246616067799698834)
,p_name=>'ASSIGNED_TO'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ASSIGNED_TO'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Assigned to'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(246616132219698835)
,p_name=>'COST'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COST'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Cost'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>60
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(246616211198698836)
,p_name=>'BUDGET'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'BUDGET'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Budget'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>70
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(246616368176698837)
,p_name=>'UPDATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'UPDATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Updated by'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(246616492294698838)
,p_name=>'UPDATED'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'UPDATED'
,p_data_type=>'TIMESTAMP_LTZ'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DATE_PICKER'
,p_heading=>'Updated'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>90
,p_value_alignment=>'CENTER'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_date_ranges=>'ALL'
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(246615572384698829)
,p_internal_uid=>246615572384698829
,p_is_editable=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_max_row_count=>100000
,p_show_nulls_as=>'-'
,p_select_first_row=>true
,p_fixed_row_height=>true
,p_pagination_type=>'SET'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'CSV:HTML'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_api.create_ig_report(
 p_id=>wwv_flow_api.id(280180635299574537)
,p_interactive_grid_id=>wwv_flow_api.id(246615572384698829)
,p_static_id=>'15009'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_api.create_ig_report_view(
 p_id=>wwv_flow_api.id(280180796016574537)
,p_report_id=>wwv_flow_api.id(280180635299574537)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_api.create_ig_report_column(
 p_id=>wwv_flow_api.id(280181246958574554)
,p_view_id=>wwv_flow_api.id(280180796016574537)
,p_display_seq=>1
,p_column_id=>wwv_flow_api.id(246615681470698830)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_api.create_ig_report_column(
 p_id=>wwv_flow_api.id(280181679027574586)
,p_view_id=>wwv_flow_api.id(280180796016574537)
,p_display_seq=>2
,p_column_id=>wwv_flow_api.id(246615730135698831)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_api.create_ig_report_column(
 p_id=>wwv_flow_api.id(280182161838574589)
,p_view_id=>wwv_flow_api.id(280180796016574537)
,p_display_seq=>3
,p_column_id=>wwv_flow_api.id(246615898044698832)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_api.create_ig_report_column(
 p_id=>wwv_flow_api.id(280182607826574591)
,p_view_id=>wwv_flow_api.id(280180796016574537)
,p_display_seq=>4
,p_column_id=>wwv_flow_api.id(246615996169698833)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_api.create_ig_report_column(
 p_id=>wwv_flow_api.id(280183157538574592)
,p_view_id=>wwv_flow_api.id(280180796016574537)
,p_display_seq=>5
,p_column_id=>wwv_flow_api.id(246616067799698834)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_api.create_ig_report_column(
 p_id=>wwv_flow_api.id(280183621784574594)
,p_view_id=>wwv_flow_api.id(280180796016574537)
,p_display_seq=>6
,p_column_id=>wwv_flow_api.id(246616132219698835)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_api.create_ig_report_column(
 p_id=>wwv_flow_api.id(280184130498574595)
,p_view_id=>wwv_flow_api.id(280180796016574537)
,p_display_seq=>7
,p_column_id=>wwv_flow_api.id(246616211198698836)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_api.create_ig_report_column(
 p_id=>wwv_flow_api.id(280184663346574596)
,p_view_id=>wwv_flow_api.id(280180796016574537)
,p_display_seq=>8
,p_column_id=>wwv_flow_api.id(246616368176698837)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_api.create_ig_report_column(
 p_id=>wwv_flow_api.id(280185101202574598)
,p_view_id=>wwv_flow_api.id(280180796016574537)
,p_display_seq=>9
,p_column_id=>wwv_flow_api.id(246616492294698838)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3405023729648589271)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6482137048911026441)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6482137069756028837)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Interactive Grid includes all the features you expect for powerful reporting, including fixed headers, frozen columns, scroll pagination, multiple filters, sorting, aggregates, computations, and more.</p>',
'<p>For more examples, please install the <strong>Sample Interactive Grids</strong> from Packaged Apps > Sample Apps.</p>',
'<p class="dm-Hero-steps">Set <strong>Interactive Grid</strong> as Region type.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2056021361160855666)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(3405023729648589271)
,p_button_name=>'REGION_TYPE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Type'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6308:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'fa-list'
);
end;
/
prompt --application/pages/page_01500
begin
wwv_flow_api.create_page(
 p_id=>1500
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Buttons'
,p_alias=>'BUTTONS'
,p_step_title=>'Buttons - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.ts-Placeholder {',
'height: 240px;',
'line-height: 240px;',
'text-align: center;',
'background-color: #D0D0D0;',
'color: #404040;',
'border-radius: 2px;',
'margin-bottom: 48px;',
'}',
'.ts-Container {',
'max-width: 1024px;',
'min-height: 50vh;',
'}',
'',
'.a-HowTo-value ul {',
' margin-top: 0px;',
'}',
'.a-ButtonTemplate {',
' width: 90%;',
' margin:auto;',
'}'))
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(385717785512249023)
,p_plug_name=>'Breadcrumbs'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(476511362977668594)
,p_plug_name=>'Button Types'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_component_template_options=>'#DEFAULT#:u-colors'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(476584406006772879)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1910994260220394533)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Universal Theme provides several options for adding buttons to your applications. This page introduces you to the three button templates and the various template options.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_01501
begin
wwv_flow_api.create_page(
 p_id=>1501
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Button - Text Only'
,p_alias=>'TEXT-BUTTON'
,p_step_title=>'Text Only Buttons - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_inline_css=>'.dm-ContentWell {overflow: hidden;}'
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405352497984967107)
,p_plug_name=>'Use Cases'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405352900324967107)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405353465442967108)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This is your standard button in Universal Theme</p>',
'<p class="dm-Hero-steps">Set <strong>Text</strong> as the Button Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405353909513967109)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405354493181967109)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405354938482967109)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405363612275977464)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(405354938482967109)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>370
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'BUTTON'
,p_attribute_06=>'-'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405364686147977466)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(405354938482967109)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--padded:t-ContentBlock--h3:t-ContentBlock--lightBG'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>330
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405365636991977467)
,p_plug_name=>'Buttons'
,p_parent_plug_id=>wwv_flow_api.id(405364686147977466)
,p_region_css_classes=>'dm-ContentWell dm-ContentWell--buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'t-Report--altRowsDefault:t-Report--rowHighlight'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>340
,p_plug_grid_column_span=>8
,p_plug_display_column=>3
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_row_template=>wwv_flow_api.id(1089625725920080767)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405368568387977469)
,p_plug_name=>'2. Variations'
,p_parent_plug_id=>wwv_flow_api.id(405354938482967109)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--padded:t-ContentBlock--h3:t-ContentBlock--lightBG'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>360
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405369523778977470)
,p_plug_name=>'Buttons'
,p_parent_plug_id=>wwv_flow_api.id(405368568387977469)
,p_region_css_classes=>'dm-ContentWell dm-ContentWell--buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_grid_column_span=>8
,p_plug_display_column=>3
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405366026870977467)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(405365636991977467)
,p_button_name=>'TB-DEF-SML-1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--small'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Small Button'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405369914474977470)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(405369523778977470)
,p_button_name=>'TB-STT-1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Default Style'
,p_button_css_classes=>'w80p'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405366401807977467)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(405365636991977467)
,p_button_name=>'TB-DEF-SML-2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--small'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Small Hot Button'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405370344705977470)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(405369523778977470)
,p_button_name=>'TB-STT-2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--simple'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Simple Style'
,p_button_css_classes=>'w80p'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405366874916977468)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(405365636991977467)
,p_button_name=>'TB-DEF-1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Default Button'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790514694747235933)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(405369523778977470)
,p_button_name=>'TB-STT-2_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--link'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Link Style'
,p_button_css_classes=>'w80p'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405367237314977468)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(405365636991977467)
,p_button_name=>'TB-DEF-2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Default Hot Button'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405370763185977471)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(405369523778977470)
,p_button_name=>'TB-STT-3'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Default Hot'
,p_button_css_classes=>'w80p'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405367687588977468)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(405365636991977467)
,p_button_name=>'TB-DEF-LRG-1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--large'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Large Button'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405371191891977471)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(405369523778977470)
,p_button_name=>'TB-STT-4'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--simple'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Simple Hot'
,p_button_css_classes=>'w80p'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405368092292977469)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(405365636991977467)
,p_button_name=>'TB-DEF-LRG-2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--large'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Large Hot Button'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790514770479235934)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(405369523778977470)
,p_button_name=>'TB-STT-4_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--link'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Link Hot'
,p_button_css_classes=>'w80p'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405371564461977471)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(405369523778977470)
,p_button_name=>'TB-STT-5'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--warning'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Default Warning'
,p_button_css_classes=>'w80p'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405371918635977471)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(405369523778977470)
,p_button_name=>'TB-STT-6'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--simple:t-Button--warning'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Simple Warning'
,p_button_css_classes=>'w80p'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790514870726235935)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(405369523778977470)
,p_button_name=>'TB-STT-6_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--warning:t-Button--link'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Link Warning'
,p_button_css_classes=>'w80p'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405372373072977472)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(405369523778977470)
,p_button_name=>'TB-STT-7'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--success'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Default Success'
,p_button_css_classes=>'w80p'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405372750515977472)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_api.id(405369523778977470)
,p_button_name=>'TB-STT-8'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--simple:t-Button--success'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Simple Success'
,p_button_css_classes=>'w80p'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790514980352235936)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_api.id(405369523778977470)
,p_button_name=>'TB-STT-8_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--success:t-Button--link'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Link Success'
,p_button_css_classes=>'w80p'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405373124780977472)
,p_button_sequence=>130
,p_button_plug_id=>wwv_flow_api.id(405369523778977470)
,p_button_name=>'TB-STT-9'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--danger'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Default Danger'
,p_button_css_classes=>'w80p'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405373540653977473)
,p_button_sequence=>140
,p_button_plug_id=>wwv_flow_api.id(405369523778977470)
,p_button_name=>'TB-STT-10'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--simple:t-Button--danger'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Simple Danger'
,p_button_css_classes=>'w80p'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790515076049235937)
,p_button_sequence=>150
,p_button_plug_id=>wwv_flow_api.id(405369523778977470)
,p_button_name=>'TB-STT-10_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--danger:t-Button--link'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Link Danger'
,p_button_css_classes=>'w80p'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405373979889977473)
,p_button_sequence=>160
,p_button_plug_id=>wwv_flow_api.id(405369523778977470)
,p_button_name=>'TB-STT-11'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--primary'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Default Primary'
,p_button_css_classes=>'w80p'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405374326932977473)
,p_button_sequence=>170
,p_button_plug_id=>wwv_flow_api.id(405369523778977470)
,p_button_name=>'TB-STT-12'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--simple:t-Button--primary'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Simple Primary'
,p_button_css_classes=>'w80p'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790515121926235938)
,p_button_sequence=>180
,p_button_plug_id=>wwv_flow_api.id(405369523778977470)
,p_button_name=>'TB-STT-12_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--primary:t-Button--link'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Link Primary'
,p_button_css_classes=>'w80p'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1920961510411865274)
,p_button_sequence=>150
,p_button_plug_id=>wwv_flow_api.id(405353909513967109)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Button Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:buttons:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-button'
);
end;
/
prompt --application/pages/page_01502
begin
wwv_flow_api.create_page(
 p_id=>1502
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Button - Icon Only'
,p_alias=>'ICON-BUTTON'
,p_step_title=>'Icon Only Button - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_inline_css=>'.dm-ContentWell {overflow: hidden;}'
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405391628848043696)
,p_plug_name=>'Use Cases'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405392092497043697)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405392505831043697)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This is an icon only button useful for easily recognized actions.</p>',
'<p class="dm-Hero-steps">Set <strong> Icon</strong> as the Button Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405393071732043698)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405393591907043699)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405394013582043699)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405406260175074446)
,p_plug_name=>'2. Variations'
,p_parent_plug_id=>wwv_flow_api.id(405394013582043699)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--padded:t-ContentBlock--h3:t-ContentBlock--lightBG'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>260
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405407295350074447)
,p_plug_name=>'Buttons'
,p_parent_plug_id=>wwv_flow_api.id(405406260175074446)
,p_region_css_classes=>'dm-ContentWell dm-ContentWell--buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_grid_column_span=>8
,p_plug_display_column=>3
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405412542151074453)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(405394013582043699)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--padded:t-ContentBlock--h3:t-ContentBlock--lightBG'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>230
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405413599655074454)
,p_plug_name=>'Buttons'
,p_parent_plug_id=>wwv_flow_api.id(405412542151074453)
,p_region_css_classes=>'dm-ContentWell dm-ContentWell--buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'t-Report--altRowsDefault:t-Report--rowHighlight'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_grid_column_span=>8
,p_plug_display_column=>3
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_row_template=>wwv_flow_api.id(1089625725920080767)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405413086276074453)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'BUTTON'
,p_attribute_06=>'-'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405407639574074447)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(405407295350074447)
,p_button_name=>'TB-STT-1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Default Style'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405413991151074454)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(405413599655074454)
,p_button_name=>'TB-DEF-SML-1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--tiny'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Small Button'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405408045538074448)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(405407295350074447)
,p_button_name=>'TB-STT-2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--simple'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Simple Style'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790513908281235926)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(405413599655074454)
,p_button_name=>'TB-DEF-SML-2_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--tiny'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Icon Only - Small Hot Button'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790513882435235925)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(405413599655074454)
,p_button_name=>'TB-DEF-SML-1_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--small'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Small Button'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790514007926235927)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(405407295350074447)
,p_button_name=>'TB-STT-2_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--link'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Simple Style'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405408482746074448)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(405407295350074447)
,p_button_name=>'TB-STT-3'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Icon Only - Default Hot'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405414393502074454)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(405413599655074454)
,p_button_name=>'TB-DEF-SML-2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--small'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Icon Only - Small Hot Button'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405408844506074448)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(405407295350074447)
,p_button_name=>'TB-STT-4'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--simple'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Icon Only - Simple Hot'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405414783499074455)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(405413599655074454)
,p_button_name=>'TB-DEF-1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Default Button'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405415152534074455)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(405413599655074454)
,p_button_name=>'TB-DEF-2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Icon Only - Default Hot Button'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790514174863235928)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(405407295350074447)
,p_button_name=>'TB-STT-4_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--link'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Icon Only - Simple Hot'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405409209224074449)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(405407295350074447)
,p_button_name=>'TB-STT-5'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--warning'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Default Warning'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-warning'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405415521320074455)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(405413599655074454)
,p_button_name=>'TB-DEF-LRG-1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--large'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Large Button'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405409696644074449)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(405407295350074447)
,p_button_name=>'TB-STT-6'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--simple:t-Button--warning'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Simple Warning'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-warning'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405415914265074455)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(405413599655074454)
,p_button_name=>'TB-DEF-LRG-2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--large'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Icon Only - Large Hot Button'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790514245735235929)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(405407295350074447)
,p_button_name=>'TB-STT-6_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--warning:t-Button--link'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Simple Warning'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-warning'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405410032861074450)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(405407295350074447)
,p_button_name=>'TB-STT-7'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--success'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Default Success'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405410451964074450)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_api.id(405407295350074447)
,p_button_name=>'TB-STT-8'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--simple:t-Button--success'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Simple Success'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790514374860235930)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_api.id(405407295350074447)
,p_button_name=>'TB-STT-8_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--success:t-Button--link'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Simple Success'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405410897527074451)
,p_button_sequence=>130
,p_button_plug_id=>wwv_flow_api.id(405407295350074447)
,p_button_name=>'TB-STT-9'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--danger'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Default Danger'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-exclamation-diamond'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405411232959074451)
,p_button_sequence=>140
,p_button_plug_id=>wwv_flow_api.id(405407295350074447)
,p_button_name=>'TB-STT-10'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--simple:t-Button--danger'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Simple Danger'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-exclamation-diamond'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790514425746235931)
,p_button_sequence=>150
,p_button_plug_id=>wwv_flow_api.id(405407295350074447)
,p_button_name=>'TB-STT-10_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--danger:t-Button--link'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Simple Danger'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-exclamation-diamond'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405411681799074451)
,p_button_sequence=>160
,p_button_plug_id=>wwv_flow_api.id(405407295350074447)
,p_button_name=>'TB-STT-11'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--primary'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Default Primary'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-info-square'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405412039276074452)
,p_button_sequence=>170
,p_button_plug_id=>wwv_flow_api.id(405407295350074447)
,p_button_name=>'TB-STT-12'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--simple:t-Button--primary'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Simple Primary'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-info-square'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790514526354235932)
,p_button_sequence=>180
,p_button_plug_id=>wwv_flow_api.id(405407295350074447)
,p_button_name=>'TB-STT-12_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--primary:t-Button--link'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only - Simple Primary'
,p_button_css_classes=>'w40p'
,p_icon_css_classes=>'fa-info-square'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1920962358216875296)
,p_button_sequence=>150
,p_button_plug_id=>wwv_flow_api.id(405393071732043698)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Button Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:buttons:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-button'
);
end;
/
prompt --application/pages/page_01503
begin
wwv_flow_api.create_page(
 p_id=>1503
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Button - Text With Icon'
,p_alias=>'TEXT-WITH-ICON-BUTTON'
,p_step_title=>'Text with Icon Button - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_inline_css=>'.dm-ContentWell {overflow: hidden;}'
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405709552163782674)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405710031830782692)
,p_plug_name=>'Use Cases'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405710405617782694)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This template enables you to display an icon next to your button label. You can easily position the icon to the right or left of the label using Template Options.</p>',
'<p class="dm-Hero-steps">Set <strong>Text with Icon</strong> as the Button Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405710903523782695)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405711462522782696)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405711924235782697)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405723829419788382)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(405711924235782697)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--padded:t-ContentBlock--h3:t-ContentBlock--lightBG'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>130
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405724811239788383)
,p_plug_name=>'Buttons'
,p_parent_plug_id=>wwv_flow_api.id(405723829419788382)
,p_region_css_classes=>'dm-ContentWell dm-ContentWell--buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'t-Report--altRowsDefault:t-Report--rowHighlight'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_grid_column_span=>8
,p_plug_display_column=>3
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_row_template=>wwv_flow_api.id(1089625725920080767)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405728816672788388)
,p_plug_name=>'2. Variations'
,p_parent_plug_id=>wwv_flow_api.id(405711924235782697)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--padded:t-ContentBlock--h3:t-ContentBlock--lightBG'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>160
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405729872431788388)
,p_plug_name=>'Buttons'
,p_parent_plug_id=>wwv_flow_api.id(405728816672788388)
,p_region_css_classes=>'dm-ContentWell dm-ContentWell--buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_grid_column_span=>8
,p_plug_display_column=>3
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405722808953788381)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'BUTTON'
,p_attribute_06=>'Text with Icon'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405730246449788389)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(405729872431788388)
,p_button_name=>'TB-STT-1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Default Style'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405730655133788389)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(405729872431788388)
,p_button_name=>'TB-STT-2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--simple:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Simple Style'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790513396799235920)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(405724811239788383)
,p_button_name=>'TB-DEF-SML-1_2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--tiny:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Tiny'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405725633110788385)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(405724811239788383)
,p_button_name=>'TB-DEF-SML-1_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--tiny:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Tiny'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790512499666235911)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(405729872431788388)
,p_button_name=>'TB-STT-2_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--link:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Link Style'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405731092143788389)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(405729872431788388)
,p_button_name=>'TB-STT-3'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Default Hot'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405725932109788386)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(405724811239788383)
,p_button_name=>'TB-DEF-SML-2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--tiny:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Tiny Hot'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405731427875788390)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(405729872431788388)
,p_button_name=>'TB-STT-4'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--simple:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Simple Hot'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790512522945235912)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(405729872431788388)
,p_button_name=>'TB-STT-4_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--link:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Link Hot'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405725270315788384)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(405724811239788383)
,p_button_name=>'TB-DEF-SML-1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--small:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Small'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405731862654788390)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(405729872431788388)
,p_button_name=>'TB-STT-5'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--warning:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Default Warning'
,p_icon_css_classes=>'fa-warning'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405732266212788390)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(405729872431788388)
,p_button_name=>'TB-STT-6'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--warning:t-Button--simple:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Simple Warning'
,p_icon_css_classes=>'fa-warning'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790513495043235921)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(405724811239788383)
,p_button_name=>'TB-DEF-SML-1_1_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--small:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Small'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790512694853235913)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(405729872431788388)
,p_button_name=>'TB-STT-6_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--warning:t-Button--link:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Link Warning'
,p_icon_css_classes=>'fa-warning'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790513511175235922)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(405724811239788383)
,p_button_name=>'TB-DEF-SML-2_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--small:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Small Hot'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405726345963788386)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(405724811239788383)
,p_button_name=>'TB-DEF-1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Default'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405732670403788390)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(405729872431788388)
,p_button_name=>'TB-STT-7'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--success:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Default Success'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405726716545788386)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_api.id(405724811239788383)
,p_button_name=>'TB-DEF-1_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Default'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405733055682788391)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_api.id(405729872431788388)
,p_button_name=>'TB-STT-8'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--success:t-Button--simple:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Simple Success'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405727134130788386)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_api.id(405724811239788383)
,p_button_name=>'TB-DEF-2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Default Hot'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790512733487235914)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_api.id(405729872431788388)
,p_button_name=>'TB-STT-8_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--success:t-Button--link:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Link Success'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405727518014788387)
,p_button_sequence=>130
,p_button_plug_id=>wwv_flow_api.id(405724811239788383)
,p_button_name=>'TB-DEF-LRG-1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--large:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Large'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405733428774788392)
,p_button_sequence=>130
,p_button_plug_id=>wwv_flow_api.id(405729872431788388)
,p_button_name=>'TB-STT-9'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--danger:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Default Danger'
,p_icon_css_classes=>'fa-exclamation-diamond'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405727952398788387)
,p_button_sequence=>140
,p_button_plug_id=>wwv_flow_api.id(405724811239788383)
,p_button_name=>'TB-DEF-LRG-1_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--large:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Large'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405733820495788392)
,p_button_sequence=>140
,p_button_plug_id=>wwv_flow_api.id(405729872431788388)
,p_button_name=>'TB-STT-10'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--danger:t-Button--simple:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Simple Danger'
,p_icon_css_classes=>'fa-exclamation-diamond'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405728336888788387)
,p_button_sequence=>150
,p_button_plug_id=>wwv_flow_api.id(405724811239788383)
,p_button_name=>'TB-DEF-LRG-2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--large:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Large Hot'
,p_icon_css_classes=>'fa-check-circle'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790512891450235915)
,p_button_sequence=>150
,p_button_plug_id=>wwv_flow_api.id(405729872431788388)
,p_button_name=>'TB-STT-10_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--danger:t-Button--link:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Link Danger'
,p_icon_css_classes=>'fa-exclamation-diamond'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405734271669788393)
,p_button_sequence=>160
,p_button_plug_id=>wwv_flow_api.id(405729872431788388)
,p_button_name=>'TB-STT-11'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--primary:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Default Primary'
,p_icon_css_classes=>'fa-info-square'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(405734661423788393)
,p_button_sequence=>170
,p_button_plug_id=>wwv_flow_api.id(405729872431788388)
,p_button_name=>'TB-STT-12'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--primary:t-Button--simple:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Simple Primary'
,p_icon_css_classes=>'fa-info-square'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(790512976793235916)
,p_button_sequence=>180
,p_button_plug_id=>wwv_flow_api.id(405729872431788388)
,p_button_name=>'TB-STT-12_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--primary:t-Button--link:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Link Primary'
,p_icon_css_classes=>'fa-info-square'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1920962835933878005)
,p_button_sequence=>150
,p_button_plug_id=>wwv_flow_api.id(405710903523782695)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Button Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:buttons:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-button'
);
end;
/
prompt --application/pages/page_01600
begin
wwv_flow_api.create_page(
 p_id=>1600
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Forms'
,p_alias=>'FORMS'
,p_step_title=>'Forms - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.ts-Placeholder {',
'height: 240px;',
'line-height: 240px;',
'text-align: center;',
'background-color: #D0D0D0;',
'color: #404040;',
'border-radius: 2px;',
'margin-bottom: 48px;',
'}',
'.ts-Container {',
'max-width: 1024px;',
'min-height: 50vh;',
'}'))
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(476511715876669640)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_component_template_options=>'#DEFAULT#:u-colors'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>810
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(476588768580793809)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1910807372454215494)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--showBreadcrumb:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>790
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1910807715429215495)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Universal Theme enables easy form design by allowing developers to declaratively control form layout, field templates, and label column widths. This page introduces you to forms, field templates, and template options.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_01601
begin
wwv_flow_api.create_page(
 p_id=>1601
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Forms - Form Modifiers'
,p_alias=>'FORM-MODIFIERS'
,p_step_title=>'Form Modifiers - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416344554817887956)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>This is a basic form which can be customized using Template Options of the Region they are in.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416345074151887956)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416345594507887957)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416346014109887957)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416386964230908899)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(416346014109887957)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>750
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416387446086908900)
,p_plug_name=>'How To'
,p_parent_plug_id=>wwv_flow_api.id(416386964230908899)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>760
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416387901782908900)
,p_plug_name=>'Form Region'
,p_parent_plug_id=>wwv_flow_api.id(416386964230908899)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416392015436908911)
,p_plug_name=>'5. Labels Above'
,p_parent_plug_id=>wwv_flow_api.id(416346014109887957)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>800
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416392581802908911)
,p_plug_name=>'How To'
,p_parent_plug_id=>wwv_flow_api.id(416392015436908911)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416393049196908912)
,p_plug_name=>'Form Region'
,p_parent_plug_id=>wwv_flow_api.id(416392015436908911)
,p_region_template_options=>'#DEFAULT#:t-Form--large:t-Form--stretchInputs:t-Form--leftLabels:t-Form--labelsAbove'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416397122908908916)
,p_plug_name=>'3. Large Form'
,p_parent_plug_id=>wwv_flow_api.id(416346014109887957)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>780
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416397687229908917)
,p_plug_name=>'Form Region'
,p_parent_plug_id=>wwv_flow_api.id(416397122908908916)
,p_region_template_options=>'#DEFAULT#:t-Form--large'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416401758055908921)
,p_plug_name=>'How To'
,p_parent_plug_id=>wwv_flow_api.id(416397122908908916)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416402298625908921)
,p_plug_name=>'4. Stretch Items'
,p_parent_plug_id=>wwv_flow_api.id(416346014109887957)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>790
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416402785875908923)
,p_plug_name=>'Form Region'
,p_parent_plug_id=>wwv_flow_api.id(416402298625908921)
,p_region_template_options=>'#DEFAULT#:t-Form--large:t-Form--stretchInputs'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416406821302908927)
,p_plug_name=>'How To'
,p_parent_plug_id=>wwv_flow_api.id(416402298625908921)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416407360021908928)
,p_plug_name=>'2. Left Aligned Labels'
,p_parent_plug_id=>wwv_flow_api.id(416346014109887957)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>770
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416407802754908928)
,p_plug_name=>'Form Region'
,p_parent_plug_id=>wwv_flow_api.id(416407360021908928)
,p_region_template_options=>'#DEFAULT#:t-Form--leftLabels'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416411995770908932)
,p_plug_name=>'How To'
,p_parent_plug_id=>wwv_flow_api.id(416407360021908928)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416361266494887973)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'REGION'
,p_attribute_02=>'Blank with Attributes'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1920963137529884470)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(416345074151887956)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Form Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:forms:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-forms'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416388325875908901)
,p_name=>'P1601_TASK_NAME_2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(416387901782908900)
,p_prompt=>'Task Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416388753779908907)
,p_name=>'P1601_TASK_DESC_2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(416387901782908900)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416389124282908907)
,p_name=>'P1601_CATEGORY_2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(416387901782908900)
,p_prompt=>'Category'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Bugs;D,Features;S,Todos;M,'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416389551005908908)
,p_name=>'P1601_PRIORITY_2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(416387901782908900)
,p_prompt=>'Priority'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:High;1,Medium;2,Low;3'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416389969985908909)
,p_name=>'P1601_ASSIGNEE_2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(416387901782908900)
,p_prompt=>'Assigned To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416390326301908909)
,p_name=>'P1601_CONTRIBUTOR_2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(416387901782908900)
,p_prompt=>'Contributor'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416390768987908909)
,p_name=>'P1601_COMMITED_2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(416387901782908900)
,p_prompt=>'Commited'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416391174440908910)
,p_name=>'P1601_START_DATE_2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(416387901782908900)
,p_prompt=>'Start Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416391513701908910)
,p_name=>'P1601_END_DATE_2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(416387901782908900)
,p_prompt=>'End Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416393493844908912)
,p_name=>'P1601_TASK_NAME_1_1_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(416393049196908912)
,p_prompt=>'Task Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416393853541908912)
,p_name=>'P1601_TASK_DESC_1_1_1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(416393049196908912)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416394273296908913)
,p_name=>'P1601_CATEGORY_1_1_1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(416393049196908912)
,p_prompt=>'Category'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Bugs;D,Features;S,Todos;M,'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416394609245908913)
,p_name=>'P1601_PRIORITY_1_1_1'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(416393049196908912)
,p_prompt=>'Priority'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:High;1,Medium;2,Low;3'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416395007287908913)
,p_name=>'P1601_ASSIGNEE_1_1_1'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(416393049196908912)
,p_prompt=>'Assigned To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416395477626908914)
,p_name=>'P1601_CONTRIBUTOR_1_1_1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(416393049196908912)
,p_prompt=>'Contributor'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416395891473908915)
,p_name=>'P1601_COMMITED_1_1_1'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(416393049196908912)
,p_prompt=>'Commited'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416396275739908915)
,p_name=>'P1601_START_DATE_1_1_1'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(416393049196908912)
,p_prompt=>'Start Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416396649933908915)
,p_name=>'P1601_END_DATE_1_1_1'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(416393049196908912)
,p_prompt=>'End Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416398048680908918)
,p_name=>'P1601_TASK_NAME_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(416397687229908917)
,p_prompt=>'Task Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416398458733908918)
,p_name=>'P1601_TASK_DESC_1'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(416397687229908917)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416398858067908918)
,p_name=>'P1601_CATEGORY_1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(416397687229908917)
,p_prompt=>'Category'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Bugs;D,Features;S,Todos;M,'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416399296266908919)
,p_name=>'P1601_PRIORITY_1'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(416397687229908917)
,p_prompt=>'Priority'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:High;1,Medium;2,Low;3'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416399626713908919)
,p_name=>'P1601_ASSIGNEE_1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(416397687229908917)
,p_prompt=>'Assigned To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416400094923908919)
,p_name=>'P1601_CONTRIBUTOR_1'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(416397687229908917)
,p_prompt=>'Contributor'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416400411477908920)
,p_name=>'P1601_COMMITED_1'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(416397687229908917)
,p_prompt=>'Commited'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416400807466908920)
,p_name=>'P1601_START_DATE_1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(416397687229908917)
,p_prompt=>'Start Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416401292756908921)
,p_name=>'P1601_END_DATE_1'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(416397687229908917)
,p_prompt=>'End Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416403131222908924)
,p_name=>'P1601_TASK_NAME_1_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(416402785875908923)
,p_prompt=>'Task Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416403554890908924)
,p_name=>'P1601_TASK_DESC_1_1'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(416402785875908923)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416403953179908924)
,p_name=>'P1601_CATEGORY_1_1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(416402785875908923)
,p_prompt=>'Category'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Bugs;D,Features;S,Todos;M,'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416404399571908925)
,p_name=>'P1601_PRIORITY_1_1'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(416402785875908923)
,p_prompt=>'Priority'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:High;1,Medium;2,Low;3'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416404739298908926)
,p_name=>'P1601_ASSIGNEE_1_1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(416402785875908923)
,p_prompt=>'Assigned To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416405106745908926)
,p_name=>'P1601_CONTRIBUTOR_1_1'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(416402785875908923)
,p_prompt=>'Contributor'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416405540180908926)
,p_name=>'P1601_COMMITED_1_1'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(416402785875908923)
,p_prompt=>'Commited'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416405989955908927)
,p_name=>'P1601_START_DATE_1_1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(416402785875908923)
,p_prompt=>'Start Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416406385192908927)
,p_name=>'P1601_END_DATE_1_1'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(416402785875908923)
,p_prompt=>'End Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416408262954908929)
,p_name=>'P1601_TASK_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(416407802754908928)
,p_prompt=>'Task Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416408687052908929)
,p_name=>'P1601_TASK_DESC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(416407802754908928)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416409059479908929)
,p_name=>'P1601_CATEGORY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(416407802754908928)
,p_prompt=>'Category'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Bugs;D,Features;S,Todos;M,'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416409444149908930)
,p_name=>'P1601_PRIORITY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(416407802754908928)
,p_prompt=>'Priority'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:High;1,Medium;2,Low;3'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416409851025908930)
,p_name=>'P1601_ASSIGNEE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(416407802754908928)
,p_prompt=>'Assigned To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416410219121908930)
,p_name=>'P1601_CONTRIBUTOR'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(416407802754908928)
,p_prompt=>'Contributor'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416410623930908931)
,p_name=>'P1601_COMMITED'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(416407802754908928)
,p_prompt=>'Commited'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416411014647908931)
,p_name=>'P1601_START_DATE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(416407802754908928)
,p_prompt=>'Start Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416411495457908931)
,p_name=>'P1601_END_DATE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(416407802754908928)
,p_prompt=>'End Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
end;
/
prompt --application/pages/page_01602
begin
wwv_flow_api.create_page(
 p_id=>1602
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Forms - Multi Column Layout'
,p_alias=>'FORMS-MULTI-COLUMN-LAYOUT'
,p_step_title=>'Forms - Multi Column Layout - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416473530421131234)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'REGION'
,p_attribute_02=>'Blank with Attributes'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416479932468131240)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416480477331131241)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>These examples show how complex form layout can achieved in Universal Theme.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416480906765131241)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416481407014131241)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416526030261140656)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(416481407014131241)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>760
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416526595004140657)
,p_plug_name=>'Form Region'
,p_parent_plug_id=>wwv_flow_api.id(416526030261140656)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416530284983140660)
,p_plug_name=>'How To'
,p_parent_plug_id=>wwv_flow_api.id(416526030261140656)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416530789963140661)
,p_plug_name=>'2. Left Aligned Labels'
,p_parent_plug_id=>wwv_flow_api.id(416481407014131241)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>770
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416531200755140661)
,p_plug_name=>'How To'
,p_parent_plug_id=>wwv_flow_api.id(416530789963140661)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416531715468140662)
,p_plug_name=>'Form Region'
,p_parent_plug_id=>wwv_flow_api.id(416530789963140661)
,p_region_template_options=>'#DEFAULT#:t-Form--leftLabels'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416535434242140665)
,p_plug_name=>'3. Large Form'
,p_parent_plug_id=>wwv_flow_api.id(416481407014131241)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>780
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416535939966140666)
,p_plug_name=>'Form Region'
,p_parent_plug_id=>wwv_flow_api.id(416535434242140665)
,p_region_template_options=>'#DEFAULT#:t-Form--large:t-Form--leftLabels'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416539661314140669)
,p_plug_name=>'How To'
,p_parent_plug_id=>wwv_flow_api.id(416535434242140665)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416540168702140669)
,p_plug_name=>'4. Stretch Items'
,p_parent_plug_id=>wwv_flow_api.id(416481407014131241)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>790
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416540626732140670)
,p_plug_name=>'Form Region'
,p_parent_plug_id=>wwv_flow_api.id(416540168702140669)
,p_region_template_options=>'#DEFAULT#:t-Form--large:t-Form--stretchInputs:t-Form--leftLabels'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416544389268140673)
,p_plug_name=>'How To'
,p_parent_plug_id=>wwv_flow_api.id(416540168702140669)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416544835455140673)
,p_plug_name=>'5. Labels Above'
,p_parent_plug_id=>wwv_flow_api.id(416481407014131241)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>800
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416545331191140674)
,p_plug_name=>'Form Region'
,p_parent_plug_id=>wwv_flow_api.id(416544835455140673)
,p_region_template_options=>'#DEFAULT#:t-Form--large:t-Form--stretchInputs:t-Form--leftLabels:t-Form--labelsAbove'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(416549034221140679)
,p_plug_name=>'How To'
,p_parent_plug_id=>wwv_flow_api.id(416544835455140673)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1920963864944890028)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(416479932468131240)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Form Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:forms:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-forms'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416526915467140658)
,p_name=>'P1602_TASK_NAME_2_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(416526595004140657)
,p_prompt=>'Task Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416527396515140658)
,p_name=>'P1602_TASK_DESC_2_1'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(416526595004140657)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416527754196140658)
,p_name=>'P1602_CATEGORY_2_1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(416526595004140657)
,p_prompt=>'Category'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Bugs;D,Features;S,Todos;M,'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416528197727140659)
,p_name=>'P1602_PRIORITY_2_1'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(416526595004140657)
,p_prompt=>'Priority'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:High;1,Medium;2,Low;3'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_begin_on_new_line=>'N'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416528583276140659)
,p_name=>'P1602_ASSIGNEE_2_1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(416526595004140657)
,p_prompt=>'Assigned To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416528933664140659)
,p_name=>'P1602_CONTRIBUTOR_2_1'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(416526595004140657)
,p_prompt=>'Contributor'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416529362426140660)
,p_name=>'P1602_START_DATE_2_1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(416526595004140657)
,p_prompt=>'Start Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>15
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416529780157140660)
,p_name=>'P1602_END_DATE_2_1'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(416526595004140657)
,p_prompt=>'End Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416532191431140662)
,p_name=>'P1602_TASK_NAME_2_1_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(416531715468140662)
,p_prompt=>'Task Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416532563853140663)
,p_name=>'P1602_TASK_DESC_2_1_1'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(416531715468140662)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416532931211140663)
,p_name=>'P1602_CATEGORY_2_1_1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(416531715468140662)
,p_prompt=>'Category'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Bugs;D,Features;S,Todos;M,'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416533328018140663)
,p_name=>'P1602_PRIORITY_2_1_1'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(416531715468140662)
,p_prompt=>'Priority'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:High;1,Medium;2,Low;3'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_begin_on_new_line=>'N'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416533780850140664)
,p_name=>'P1602_ASSIGNEE_2_1_1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(416531715468140662)
,p_prompt=>'Assigned To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416534156365140664)
,p_name=>'P1602_CONTRIBUTOR_2_1_1'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(416531715468140662)
,p_prompt=>'Contributor'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416534578143140664)
,p_name=>'P1602_START_DATE_2_1_1'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(416531715468140662)
,p_prompt=>'Start Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>15
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416534919946140665)
,p_name=>'P1602_END_DATE_2_1_1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(416531715468140662)
,p_prompt=>'End Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416536397567140666)
,p_name=>'P1602_TASK_NAME_2_1_1_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(416535939966140666)
,p_prompt=>'Task Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416536793104140666)
,p_name=>'P1602_TASK_DESC_2_1_1_1'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(416535939966140666)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416537168446140667)
,p_name=>'P1602_CATEGORY_2_1_1_1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(416535939966140666)
,p_prompt=>'Category'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Bugs;D,Features;S,Todos;M,'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416537562478140667)
,p_name=>'P1602_PRIORITY_2_1_1_1'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(416535939966140666)
,p_prompt=>'Priority'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:High;1,Medium;2,Low;3'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_begin_on_new_line=>'N'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416537913321140667)
,p_name=>'P1602_ASSIGNEE_2_1_1_1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(416535939966140666)
,p_prompt=>'Assigned To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416538394655140668)
,p_name=>'P1602_CONTRIBUTOR_2_1_1_1'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(416535939966140666)
,p_prompt=>'Contributor'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416538710762140668)
,p_name=>'P1602_START_DATE_2_1_1_1'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(416535939966140666)
,p_prompt=>'Start Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>15
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416539192972140668)
,p_name=>'P1602_END_DATE_2_1_1_1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(416535939966140666)
,p_prompt=>'End Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416541069288140670)
,p_name=>'P1602_TASK_NAME_2_1_1_1_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(416540626732140670)
,p_prompt=>'Task Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416541456321140670)
,p_name=>'P1602_TASK_DESC_2_1_1_1_1'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(416540626732140670)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416541853666140671)
,p_name=>'P1602_CATEGORY_2_1_1_1_1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(416540626732140670)
,p_prompt=>'Category'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Bugs;D,Features;S,Todos;M,'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416542255062140671)
,p_name=>'P1602_PRIORITY_2_1_1_1_1'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(416540626732140670)
,p_prompt=>'Priority'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:High;1,Medium;2,Low;3'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_begin_on_new_line=>'N'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416542677680140671)
,p_name=>'P1602_ASSIGNEE_2_1_1_1_1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(416540626732140670)
,p_prompt=>'Assigned To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416543005902140672)
,p_name=>'P1602_CONTRIBUTOR_2_1_1_1_1'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(416540626732140670)
,p_prompt=>'Contributor'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416543467068140672)
,p_name=>'P1602_START_DATE_2_1_1_1_1'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(416540626732140670)
,p_prompt=>'Start Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416543842629140672)
,p_name=>'P1602_END_DATE_2_1_1_1_1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(416540626732140670)
,p_prompt=>'End Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416545713285140674)
,p_name=>'P1602_TASK_NAME_2_1_1_1_1_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(416545331191140674)
,p_prompt=>'Task Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416546177657140675)
,p_name=>'P1602_TASK_DESC_2_1_1_1_1_1'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(416545331191140674)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416546517303140675)
,p_name=>'P1602_CATEGORY_2_1_1_1_1_1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(416545331191140674)
,p_prompt=>'Category'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Bugs;D,Features;S,Todos;M,'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416546996415140675)
,p_name=>'P1602_PRIORITY_2_1_1_1_1_1'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(416545331191140674)
,p_prompt=>'Priority'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:High;1,Medium;2,Low;3'
,p_cHeight=>1
,p_tag_css_classes=>'mnw180'
,p_begin_on_new_line=>'N'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416547305637140676)
,p_name=>'P1602_ASSIGNEE_2_1_1_1_1_1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(416545331191140674)
,p_prompt=>'Assigned To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416547799868140676)
,p_name=>'P1602_CONTRIBUTOR_2_1_1_1_1_1'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(416545331191140674)
,p_prompt=>'Contributor'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416548117531140678)
,p_name=>'P1602_START_DATE_2_1_1_1_1_1'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(416545331191140674)
,p_prompt=>'Start Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416548548935140678)
,p_name=>'P1602_END_DATE_2_1_1_1_1_1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(416545331191140674)
,p_prompt=>'End Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_grid_label_column_span=>2
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'button'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
end;
/
prompt --application/pages/page_01603
begin
wwv_flow_api.create_page(
 p_id=>1603
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Forms - Floating Labels'
,p_alias=>'FLOATING-LABELS'
,p_step_title=>'Forms - Floating Labels - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(875339881318549659)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This form style features labels that automatically shrink as data is entered. They are ideally suited for mobile devices as it features a larger interaction area making it easier to tap, but is also suitable for any form.</p>',
'<p>Note that only some item types support the floating label style. Item types such as checkboxes and radio buttons will place the label above the inputs, but the label will not shrink.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(875340400652549659)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(875340921008549660)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(875341340610549660)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(446739090887201436)
,p_plug_name=>'3. Formatted Form'
,p_parent_plug_id=>wwv_flow_api.id(875341340610549660)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>780
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(446739187932201437)
,p_plug_name=>'Form Region'
,p_parent_plug_id=>wwv_flow_api.id(446739090887201436)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(875382290731570602)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(875341340610549660)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>750
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(875403129255570631)
,p_plug_name=>'Form Region'
,p_parent_plug_id=>wwv_flow_api.id(875382290731570602)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(875402686522570631)
,p_plug_name=>'2. Large Size'
,p_parent_plug_id=>wwv_flow_api.id(875341340610549660)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>770
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(446738066507201426)
,p_plug_name=>'Form Region'
,p_parent_plug_id=>wwv_flow_api.id(875402686522570631)
,p_region_template_options=>'#DEFAULT#:t-Form--large'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(875407322271570635)
,p_plug_name=>'How To'
,p_parent_plug_id=>wwv_flow_api.id(875402686522570631)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(459019823733661740)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(875340400652549659)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Form Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:forms:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-forms'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446738169251201427)
,p_name=>'P1603_TASK_NAME_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(446738066507201426)
,p_prompt=>'Task Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(160093532401945979)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446738278685201428)
,p_name=>'P1603_TASK_DESC_1'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(446738066507201426)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446738382250201429)
,p_name=>'P1603_CATEGORY_1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(446738066507201426)
,p_prompt=>'Category'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Bugs;D,Features;S,Todos;M,'
,p_lov_display_null=>'YES'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446738461255201430)
,p_name=>'P1603_PRIORITY_1'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(446738066507201426)
,p_prompt=>'Priority'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:High;1,Medium;2,Low;3'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446738519418201431)
,p_name=>'P1603_ASSIGNEE_1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(446738066507201426)
,p_prompt=>'Assigned To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446738690268201432)
,p_name=>'P1603_CONTRIBUTOR_1'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(446738066507201426)
,p_prompt=>'Contributor'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446738770105201433)
,p_name=>'P1603_START_DATE_1'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(446738066507201426)
,p_prompt=>'Start Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'both'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446738854282201434)
,p_name=>'P1603_END_DATE_1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(446738066507201426)
,p_prompt=>'End Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(160093532401945979)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'both'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446738917959201435)
,p_name=>'P1603_COMMITED_1'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(446738066507201426)
,p_prompt=>'Commited'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(160093532401945979)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446739299277201438)
,p_name=>'P1603_TASK_NAME_1_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(446739187932201437)
,p_prompt=>'Task Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(160093532401945979)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--xlarge'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446739368561201439)
,p_name=>'P1603_TASK_DESC_1_1'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(446739187932201437)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446739434680201440)
,p_name=>'P1603_CATEGORY_1_1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(446739187932201437)
,p_prompt=>'Category'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Bugs;D,Features;S,Todos;M,'
,p_lov_display_null=>'YES'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_icon_css_classes=>'fa-shapes'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446739540168201441)
,p_name=>'P1603_PRIORITY_1_1'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(446739187932201437)
,p_prompt=>'Priority'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:High;1,Medium;2,Low;3'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_icon_css_classes=>'fa-exclamation-diamond'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446739625712201442)
,p_name=>'P1603_ASSIGNEE_1_1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(446739187932201437)
,p_prompt=>'Assigned To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_icon_css_classes=>'fa-user'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446739797413201443)
,p_name=>'P1603_CONTRIBUTOR_1_1'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(446739187932201437)
,p_prompt=>'Contributor'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_icon_css_classes=>'fa-users'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446739802945201444)
,p_name=>'P1603_START_DATE_1_1'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(446739187932201437)
,p_prompt=>'Start Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'both'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446739900980201445)
,p_name=>'P1603_END_DATE_1_1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(446739187932201437)
,p_prompt=>'End Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(160093532401945979)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'both'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446740056323201446)
,p_name=>'P1603_COMMITED_1_1'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(446739187932201437)
,p_prompt=>'Commited'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(160093532401945979)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(458997571821661721)
,p_name=>'P1603_TASK_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(875403129255570631)
,p_prompt=>'Task Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(160093532401945979)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(458998095995661723)
,p_name=>'P1603_TASK_DESC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(875403129255570631)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(458998479476661723)
,p_name=>'P1603_CATEGORY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(875403129255570631)
,p_prompt=>'Category'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Bugs;D,Features;S,Todos;M,'
,p_lov_display_null=>'YES'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(458998833872661724)
,p_name=>'P1603_PRIORITY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(875403129255570631)
,p_prompt=>'Priority'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:High;1,Medium;2,Low;3'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(458999228770661724)
,p_name=>'P1603_ASSIGNEE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(875403129255570631)
,p_prompt=>'Assigned To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(458999692781661724)
,p_name=>'P1603_CONTRIBUTOR'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(875403129255570631)
,p_prompt=>'Contributor'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459000074471661724)
,p_name=>'P1603_COMMITED'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(875403129255570631)
,p_prompt=>'Commited'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(160093532401945979)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459000452152661725)
,p_name=>'P1603_START_DATE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(875403129255570631)
,p_prompt=>'Start Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'both'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459000851345661725)
,p_name=>'P1603_END_DATE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(875403129255570631)
,p_prompt=>'End Date'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(160093532401945979)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'both'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
end;
/
prompt --application/pages/page_01604
begin
wwv_flow_api.create_page(
 p_id=>1604
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Mobile Forms Example'
,p_alias=>'MOBILE-FORMS-EXAMPLE'
,p_step_title=>'Mobile Forms Example'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.theme42demo.noNavigate();',
'apex.theme42.util.stickyMobileHeader();',
''))
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(756695956058321924)
,p_plug_name=>'Mobile Form'
,p_icon_css_classes=>'fa-forms'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1224989219520090364)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1632195092873481521)
,p_plug_name=>'Create Task'
,p_region_css_classes=>'margin-md'
,p_region_template_options=>'#DEFAULT#:t-Form--stretchInputs'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'sample2'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4768277334731506774)
,p_plug_name=>'Form Sample 1'
,p_region_css_classes=>'margin-md'
,p_region_template_options=>'#DEFAULT#:t-Form--large'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'sample1'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(756765069671753733)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1632195092873481521)
,p_button_name=>'CREATE_TASK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--large:t-Button--stretch:t-Button--padTop'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Task'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(756695833266321923)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(4768277334731506774)
,p_button_name=>'CREATE_ACCOUNT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--large:t-Button--stretch:t-Button--padTop'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Account'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(756695328598321918)
,p_name=>'P1604_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4768277334731506774)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_icon_css_classes=>'fa-user'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(756695567418321920)
,p_name=>'P1604_EMAIL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4768277334731506774)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Email'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(160093532401945979)
,p_item_icon_css_classes=>'fa-at'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(756695648827321921)
,p_name=>'P1604_NOTIFICATIONS_YN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(4768277334731506774)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Receive Notifications'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:Accept the Terms and Conditions;AGREE_Y,Subscribe to Newsletter;EMAIL_Y'
,p_grid_label_column_span=>0
,p_field_template=>wwv_flow_api.id(591757292230152601)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(756695775182321922)
,p_name=>'P1604_COMPANY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(4768277334731506774)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Company'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_icon_css_classes=>'fa-building-o'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(756792200906910892)
,p_name=>'P1604_TASK_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1632195092873481521)
,p_prompt=>'Task Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(160093532401945979)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(756792638360910897)
,p_name=>'P1604_TASK_DESC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1632195092873481521)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(756793001955910897)
,p_name=>'P1604_CATEGORY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1632195092873481521)
,p_item_default=>'B'
,p_prompt=>'Category'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Bug;B,Enhancement;ER,Todo;TD,'
,p_grid_column_css_classes=>'col-xxs-6'
,p_field_template=>wwv_flow_api.id(160093532401945979)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--large:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(756793408207910899)
,p_name=>'P1604_PRIORITY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1632195092873481521)
,p_item_default=>'2'
,p_prompt=>'Priority'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:High;1,Medium;2,Low;3'
,p_begin_on_new_line=>'N'
,p_grid_column_css_classes=>'col-xxs-6'
,p_field_template=>wwv_flow_api.id(160093532401945979)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--large:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(756793882334910899)
,p_name=>'P1604_ASSIGNEE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1632195092873481521)
,p_prompt=>'Assigned To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(756794637546910900)
,p_name=>'P1604_START_DATE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(1632195092873481521)
,p_prompt=>'Start Date'
,p_source=>'sysdate'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_grid_column_css_classes=>'col-xxs-6'
,p_field_template=>wwv_flow_api.id(160093352808944961)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'both'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(756795018756910901)
,p_name=>'P1604_END_DATE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(1632195092873481521)
,p_prompt=>'End Date'
,p_source=>'sysdate + 7'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DATE_PICKER'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_grid_column_css_classes=>'col-xxs-6'
,p_field_template=>wwv_flow_api.id(160093532401945979)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_04=>'both'
,p_attribute_05=>'N'
,p_attribute_07=>'NONE'
);
end;
/
prompt --application/pages/page_01700
begin
wwv_flow_api.create_page(
 p_id=>1700
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Region - List View'
,p_alias=>'LIST-VIEW-REGION'
,p_step_title=>'List View - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(720909458196235958)
,p_plug_name=>'Overview'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The List View component provides a simple list-based user interface that has a wide range of features. This component has built in search, list dividers, counters, nested lists, and more.</p>',
'<p class="dm-Hero-steps">Set <strong>List View</strong> as Region Type.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(720910432326235959)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'JUMP'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(720910967968235959)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(720911458963235959)
,p_plug_name=>'1. Default'
,p_parent_plug_id=>wwv_flow_api.id(720910967968235959)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(720911973224235960)
,p_plug_name=>'Projects List'
,p_parent_plug_id=>wwv_flow_api.id(720911458963235959)
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--scrollBody'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>140
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       (select project from EBA_UT_CHART_PROJECTS p where p.id = t.project) PROJECT,',
'       TASK_NAME,',
'       START_DATE,',
'       END_DATE,',
'       STATUS',
'  from EBA_UT_CHART_TASKS t'))
,p_plug_source_type=>'NATIVE_JQM_LIST_VIEW'
,p_plug_query_num_rows=>5
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_02=>'TASK_NAME'
,p_attribute_16=>'#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(720912897178235961)
,p_plug_name=>'2. With List Divider and Badge'
,p_parent_plug_id=>wwv_flow_api.id(720910967968235959)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(720913971250235963)
,p_plug_name=>'Departments'
,p_parent_plug_id=>wwv_flow_api.id(720912897178235961)
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--scrollBody'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>170
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       (select project from EBA_UT_CHART_PROJECTS p where p.id = t.project) PROJECT,',
'       TASK_NAME,',
'       START_DATE,',
'       END_DATE,',
'       STATUS',
'  from EBA_UT_CHART_TASKS t'))
,p_plug_source_type=>'NATIVE_JQM_LIST_VIEW'
,p_plug_query_num_rows=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'DIVIDER'
,p_attribute_02=>'TASK_NAME'
,p_attribute_08=>'STATUS'
,p_attribute_14=>'PROJECT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(720999513800865287)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(315965601708999616)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(720999513800865287)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Type'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6308:&SESSION.:region:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-window-alt-2'
);
end;
/
prompt --application/pages/page_01701
begin
wwv_flow_api.create_page(
 p_id=>1701
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Region - List View Mobile Example'
,p_alias=>'REGION-LIST-VIEW-MOBILE-EXAMPLE'
,p_step_title=>'Region - List View Mobile Example'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'TOP'
,p_navigation_list_id=>wwv_flow_api.id(404960847609814309)
,p_navigation_list_template_id=>wwv_flow_api.id(5429749254678674)
,p_nav_list_template_options=>'#DEFAULT#:t-NavTabs--inlineLabels-lg:t-NavTabs--hiddenLabels-sm'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1511381494544322149)
,p_plug_name=>'Projects List'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>50
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       (select project from EBA_UT_CHART_PROJECTS p where p.id = t.project) PROJECT,',
'       TASK_NAME,',
'       START_DATE,',
'       END_DATE,',
'       STATUS',
'  from EBA_UT_CHART_TASKS t'))
,p_plug_source_type=>'NATIVE_JQM_LIST_VIEW'
,p_plug_query_num_rows=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'sample1'
,p_attribute_01=>'INSET'
,p_attribute_02=>'TASK_NAME'
,p_attribute_16=>'#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1511383492570322152)
,p_plug_name=>'Departments'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>60
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       (select project from EBA_UT_CHART_PROJECTS p where p.id = t.project) PROJECT,',
'       TASK_NAME,',
'       START_DATE,',
'       END_DATE,',
'       STATUS',
'  from EBA_UT_CHART_TASKS t'))
,p_plug_source_type=>'NATIVE_JQM_LIST_VIEW'
,p_plug_query_num_rows=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'sample2'
,p_attribute_01=>'DIVIDER:SEARCH:INSET'
,p_attribute_02=>'TASK_NAME'
,p_attribute_08=>'STATUS'
,p_attribute_14=>'PROJECT'
,p_attribute_18=>'SERVER_EXACT_IGNORE'
);
end;
/
prompt --application/pages/page_01710
begin
wwv_flow_api.create_page(
 p_id=>1710
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Reflow Report'
,p_alias=>'REFLOW-REPORT'
,p_step_title=>'Reflow Report - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1036806395800746020)
,p_plug_name=>'Overview'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Reflow Report provides another responsive table-based report where on small screens, the table columns become stacked and each row becomes a block of data.',
'This is an alternative display to the Column Toggle Report and can be useful when you want to display all columns of a tabular report in a way that works well for small screens.</p>',
'<p class="dm-Hero-steps">Choose <strong>Reflow Report</strong> as Region type.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1036807369930746021)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'JUMP'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1036807905572746021)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(315952945649890523)
,p_plug_name=>'2. No Stripes'
,p_parent_plug_id=>wwv_flow_api.id(1036807905572746021)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>Display a responsive report which transforms from columns to rows to display reports on smaller browser (screen) sizes.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(339858409938111805)
,p_plug_name=>'Tasks'
,p_parent_plug_id=>wwv_flow_api.id(315952945649890523)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'TABLE'
,p_query_table=>'EBA_UT_CHART_TASKS'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_JQM_REFLOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STROKE'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339858540620111806)
,p_name=>'ID'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>10
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339858628405111807)
,p_name=>'PROJECT'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>20
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339858701631111808)
,p_name=>'ROW_VERSION_NUMBER'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>30
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339858808281111809)
,p_name=>'CREATED'
,p_data_type=>'TIMESTAMP_LTZ'
,p_is_visible=>false
,p_display_sequence=>40
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339858995165111810)
,p_name=>'CREATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_visible=>false
,p_display_sequence=>50
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339859036842111811)
,p_name=>'UPDATED'
,p_data_type=>'TIMESTAMP_LTZ'
,p_is_visible=>false
,p_display_sequence=>60
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339859145745111812)
,p_name=>'UPDATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_visible=>false
,p_display_sequence=>70
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339859212878111813)
,p_name=>'PARENT_TASK'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>80
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339859365478111814)
,p_name=>'TASK_NAME'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Task Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339859408321111815)
,p_name=>'START_DATE'
,p_data_type=>'DATE'
,p_is_visible=>true
,p_heading=>'Start Date'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>100
,p_value_alignment=>'CENTER'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339859502957111816)
,p_name=>'END_DATE'
,p_data_type=>'DATE'
,p_is_visible=>true
,p_heading=>'End Date'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>110
,p_value_alignment=>'CENTER'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339859642104111817)
,p_name=>'STATUS'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Status'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339859737602111818)
,p_name=>'ASSIGNED_TO'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Assigned To'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339859888155111819)
,p_name=>'COST'
,p_data_type=>'NUMBER'
,p_is_visible=>true
,p_heading=>'Cost'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>140
,p_value_alignment=>'RIGHT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_format_mask=>'FML999G999G999G999G990D00'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339859949326111820)
,p_name=>'BUDGET'
,p_data_type=>'NUMBER'
,p_is_visible=>true
,p_heading=>'Budget'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>150
,p_value_alignment=>'RIGHT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_format_mask=>'FML999G999G999G999G990D00'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1036808396567746021)
,p_plug_name=>'1. Standard'
,p_parent_plug_id=>wwv_flow_api.id(1036807905572746021)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>Display a responsive report which transforms from columns to rows to display reports on smaller browser (screen) sizes.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1036808910828746022)
,p_plug_name=>'Tasks'
,p_parent_plug_id=>wwv_flow_api.id(1036808396567746021)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>140
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'TABLE'
,p_query_table=>'EBA_UT_CHART_TASKS'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_JQM_REFLOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STRIPE:STROKE'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(315953912893890533)
,p_name=>'ID'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>10
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(315954078276890534)
,p_name=>'PROJECT'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>30
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(315954184029890535)
,p_name=>'ROW_VERSION_NUMBER'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>40
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(315954239092890536)
,p_name=>'CREATED'
,p_data_type=>'TIMESTAMP_LTZ'
,p_is_visible=>false
,p_display_sequence=>50
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(315954366421890537)
,p_name=>'CREATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_visible=>false
,p_display_sequence=>60
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(315954445206890538)
,p_name=>'UPDATED'
,p_data_type=>'TIMESTAMP_LTZ'
,p_is_visible=>false
,p_display_sequence=>70
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(315954533716890539)
,p_name=>'UPDATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_visible=>false
,p_display_sequence=>80
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(315955361324890547)
,p_name=>'PARENT_TASK'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>90
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(315955435705890548)
,p_name=>'TASK_NAME'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Task Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>20
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(315955506034890549)
,p_name=>'START_DATE'
,p_data_type=>'DATE'
,p_is_visible=>true
,p_heading=>'Start Date'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>100
,p_value_alignment=>'CENTER'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(315955666105890550)
,p_name=>'END_DATE'
,p_data_type=>'DATE'
,p_is_visible=>true
,p_heading=>'End Date'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>110
,p_value_alignment=>'CENTER'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339858060196111801)
,p_name=>'STATUS'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Status'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339858103376111802)
,p_name=>'ASSIGNED_TO'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Assigned To'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339858231319111803)
,p_name=>'COST'
,p_data_type=>'NUMBER'
,p_is_visible=>true
,p_heading=>'Cost'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>140
,p_value_alignment=>'RIGHT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_format_mask=>'FML999G999G999G999G990D00'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339858331406111804)
,p_name=>'BUDGET'
,p_data_type=>'NUMBER'
,p_is_visible=>true
,p_heading=>'Budget'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>150
,p_value_alignment=>'RIGHT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_format_mask=>'FML999G999G999G999G990D00'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1037473738616182910)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(316474523027317624)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1037473738616182910)
,p_button_name=>'TYPE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Type'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6308:&SESSION.:region:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-window-alt-2'
);
end;
/
prompt --application/pages/page_01711
begin
wwv_flow_api.create_page(
 p_id=>1711
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Reflow Report - Mobile Examples'
,p_alias=>'REFLOW-REPORT-MOBILE-EXAMPLES'
,p_step_title=>'Reflow Report - Mobile Examples'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'TOP'
,p_navigation_list_id=>wwv_flow_api.id(404960847609814309)
,p_navigation_list_template_id=>wwv_flow_api.id(5429749254678674)
,p_nav_list_template_options=>'#DEFAULT#:t-NavTabs--inlineLabels-lg:t-NavTabs--hiddenLabels-sm'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1130404380125416051)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>60
,p_query_type=>'TABLE'
,p_query_table=>'EBA_UT_CHART_TASKS'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_JQM_REFLOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'sample2'
,p_attribute_01=>'STRIPE:STROKE'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130404510807416052)
,p_name=>'ID'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>10
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130404598592416053)
,p_name=>'PROJECT'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>20
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130404671818416054)
,p_name=>'ROW_VERSION_NUMBER'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>30
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130404778468416055)
,p_name=>'CREATED'
,p_data_type=>'TIMESTAMP_LTZ'
,p_is_visible=>false
,p_display_sequence=>40
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130404965352416056)
,p_name=>'CREATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_visible=>false
,p_display_sequence=>50
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130405007029416057)
,p_name=>'UPDATED'
,p_data_type=>'TIMESTAMP_LTZ'
,p_is_visible=>false
,p_display_sequence=>60
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130405115932416058)
,p_name=>'UPDATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_visible=>false
,p_display_sequence=>70
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130405183065416059)
,p_name=>'PARENT_TASK'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>80
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130405335665416060)
,p_name=>'TASK_NAME'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Task Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130405378508416061)
,p_name=>'START_DATE'
,p_data_type=>'DATE'
,p_is_visible=>true
,p_heading=>'Start Date'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>100
,p_value_alignment=>'CENTER'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130405473144416062)
,p_name=>'END_DATE'
,p_data_type=>'DATE'
,p_is_visible=>true
,p_heading=>'End Date'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>110
,p_value_alignment=>'CENTER'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130405612291416063)
,p_name=>'STATUS'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Status'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130405707789416064)
,p_name=>'ASSIGNED_TO'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Assigned To'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130405858342416065)
,p_name=>'COST'
,p_data_type=>'NUMBER'
,p_is_visible=>true
,p_heading=>'Cost'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>140
,p_value_alignment=>'RIGHT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_format_mask=>'FML999G999G999G999G990D00'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130405919513416066)
,p_name=>'BUDGET'
,p_data_type=>'NUMBER'
,p_is_visible=>true
,p_heading=>'Budget'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>150
,p_value_alignment=>'RIGHT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_format_mask=>'FML999G999G999G999G990D00'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1827354881016050268)
,p_plug_name=>'Tasks'
,p_icon_css_classes=>'fa-tasks u-color-4'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--showIcon:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>50
,p_query_type=>'TABLE'
,p_query_table=>'EBA_UT_CHART_TASKS'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_JQM_REFLOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'sample1'
,p_attribute_01=>'STRIPE'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1106499883081194779)
,p_name=>'ID'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>10
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1106500048464194780)
,p_name=>'PROJECT'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>30
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1106500154217194781)
,p_name=>'ROW_VERSION_NUMBER'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>40
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1106500209280194782)
,p_name=>'CREATED'
,p_data_type=>'TIMESTAMP_LTZ'
,p_is_visible=>false
,p_display_sequence=>50
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1106500336609194783)
,p_name=>'CREATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_visible=>false
,p_display_sequence=>60
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1106500415394194784)
,p_name=>'UPDATED'
,p_data_type=>'TIMESTAMP_LTZ'
,p_is_visible=>false
,p_display_sequence=>70
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1106500503904194785)
,p_name=>'UPDATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_visible=>false
,p_display_sequence=>80
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1106501331512194793)
,p_name=>'PARENT_TASK'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>90
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1106501405893194794)
,p_name=>'TASK_NAME'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Task Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>20
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1106501476222194795)
,p_name=>'START_DATE'
,p_data_type=>'DATE'
,p_is_visible=>true
,p_heading=>'Start Date'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>100
,p_value_alignment=>'CENTER'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1106501636293194796)
,p_name=>'END_DATE'
,p_data_type=>'DATE'
,p_is_visible=>true
,p_heading=>'End Date'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>110
,p_value_alignment=>'CENTER'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130404030383416047)
,p_name=>'STATUS'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Status'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130404073563416048)
,p_name=>'ASSIGNED_TO'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Assigned To'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130404201506416049)
,p_name=>'COST'
,p_data_type=>'NUMBER'
,p_is_visible=>true
,p_heading=>'Cost'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>140
,p_value_alignment=>'RIGHT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_format_mask=>'FML999G999G999G999G990D00'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130404301593416050)
,p_name=>'BUDGET'
,p_data_type=>'NUMBER'
,p_is_visible=>true
,p_heading=>'Budget'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>150
,p_value_alignment=>'RIGHT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_format_mask=>'FML999G999G999G999G990D00'
,p_escape_on_http_output=>true
);
end;
/
prompt --application/pages/page_01720
begin
wwv_flow_api.create_page(
 p_id=>1720
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Column Toggle Report'
,p_alias=>'COLUMN-TOGGLE-REPORT'
,p_step_title=>'Column Toggle Report - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1037474424010183594)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1352775648989803925)
,p_plug_name=>'Overview'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use the Column Toggle Report to let user quickly choose columns to display when screen size is limited.</p>',
'<p class="dm-Hero-steps">Choose <strong>Column Toggle Report</strong> as Region type.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1352776623119803926)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'JUMP'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1352777158761803926)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(315951191150890505)
,p_plug_name=>'2. No Stripes'
,p_parent_plug_id=>wwv_flow_api.id(1352777158761803926)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>Display a report where end users can select the columns to display at runtime. End users can then change the columns based on the width and orientation of the screen they are using to display the report.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(340244632295216302)
,p_plug_name=>'Tasks'
,p_parent_plug_id=>wwv_flow_api.id(315951191150890505)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'TABLE'
,p_query_table=>'EBA_UT_CHART_TASKS'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_JQM_COLUMN_TOGGLE'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STROKE'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(340244747287216303)
,p_name=>'ID'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>10
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(340244868464216304)
,p_name=>'PROJECT'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>20
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(340244985652216305)
,p_name=>'PARENT_TASK'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>30
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(340245037681216306)
,p_name=>'TASK_NAME'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Task Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(340245185051216307)
,p_name=>'ROW_VERSION_NUMBER'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>50
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(340245243800216308)
,p_name=>'START_DATE'
,p_data_type=>'DATE'
,p_is_visible=>true
,p_heading=>'Start Date'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>60
,p_value_alignment=>'CENTER'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(340245358285216309)
,p_name=>'END_DATE'
,p_data_type=>'DATE'
,p_is_visible=>true
,p_heading=>'End Date'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>70
,p_value_alignment=>'CENTER'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(340245452874216310)
,p_name=>'STATUS'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Status'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(340245548324216311)
,p_name=>'ASSIGNED_TO'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Assigned To'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(340245660288216312)
,p_name=>'COST'
,p_data_type=>'NUMBER'
,p_is_visible=>true
,p_heading=>'Cost'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>100
,p_value_alignment=>'RIGHT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_format_mask=>'FML999G999G999G999G990D00'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(340245786281216313)
,p_name=>'BUDGET'
,p_data_type=>'NUMBER'
,p_is_visible=>true
,p_heading=>'Budget'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>110
,p_value_alignment=>'RIGHT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_format_mask=>'FML999G999G999G999G990D00'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(340245804690216314)
,p_name=>'CREATED'
,p_data_type=>'TIMESTAMP_LTZ'
,p_is_visible=>false
,p_display_sequence=>120
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(340245932189216315)
,p_name=>'CREATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_visible=>false
,p_display_sequence=>130
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(340246092532216316)
,p_name=>'UPDATED'
,p_data_type=>'TIMESTAMP_LTZ'
,p_is_visible=>false
,p_display_sequence=>140
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(340246186602216317)
,p_name=>'UPDATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_visible=>false
,p_display_sequence=>150
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1352779087971803928)
,p_plug_name=>'1. Standard'
,p_parent_plug_id=>wwv_flow_api.id(1352777158761803926)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>Display a report where end users can select the columns to display at runtime. End users can then change the columns based on the width and orientation of the screen they are using to display the report.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1377021238376952009)
,p_plug_name=>'Tasks'
,p_parent_plug_id=>wwv_flow_api.id(1352779087971803928)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'TABLE'
,p_query_table=>'EBA_UT_CHART_TASKS'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_JQM_COLUMN_TOGGLE'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STRIPE:STROKE'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339860029009111821)
,p_name=>'ID'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>10
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339860108423111822)
,p_name=>'PROJECT'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>20
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339860202057111823)
,p_name=>'PARENT_TASK'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>30
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339860335846111824)
,p_name=>'TASK_NAME'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Task Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339860463910111825)
,p_name=>'ROW_VERSION_NUMBER'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>50
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339860533952111826)
,p_name=>'START_DATE'
,p_data_type=>'DATE'
,p_is_visible=>true
,p_heading=>'Start Date'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>60
,p_value_alignment=>'CENTER'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339860663110111827)
,p_name=>'END_DATE'
,p_data_type=>'DATE'
,p_is_visible=>true
,p_heading=>'End Date'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>70
,p_value_alignment=>'CENTER'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339860768215111828)
,p_name=>'STATUS'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Status'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339860848965111829)
,p_name=>'ASSIGNED_TO'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Assigned To'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339860939645111830)
,p_name=>'COST'
,p_data_type=>'NUMBER'
,p_is_visible=>true
,p_heading=>'Cost'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>100
,p_value_alignment=>'RIGHT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_format_mask=>'FML999G999G999G999G990D00'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339861049299111831)
,p_name=>'BUDGET'
,p_data_type=>'NUMBER'
,p_is_visible=>true
,p_heading=>'Budget'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>110
,p_value_alignment=>'RIGHT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_format_mask=>'FML999G999G999G999G990D00'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339861105195111832)
,p_name=>'CREATED'
,p_data_type=>'TIMESTAMP_LTZ'
,p_is_visible=>false
,p_display_sequence=>120
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339861261188111833)
,p_name=>'CREATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_visible=>false
,p_display_sequence=>130
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339861301650111834)
,p_name=>'UPDATED'
,p_data_type=>'TIMESTAMP_LTZ'
,p_is_visible=>false
,p_display_sequence=>140
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(339861497885111835)
,p_name=>'UPDATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_visible=>false
,p_display_sequence=>150
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(316475204184318307)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1037474424010183594)
,p_button_name=>'TYPE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Type'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6308:&SESSION.:region:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-window-alt-2'
);
end;
/
prompt --application/pages/page_01721
begin
wwv_flow_api.create_page(
 p_id=>1721
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Column Toggle Report - Mobile Examples'
,p_alias=>'COLUMN-TOGGLE-REPORT-MOBILE-EXAMPLES'
,p_step_title=>'Column Toggle Report - Mobile Examples'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.example1 button.a-Table-columntoggleBtn {',
'    margin: 12px;',
'    display: block;',
'    width: calc(100% - 24px);',
'}'))
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_overwrite_navigation_list=>'Y'
,p_navigation_list_position=>'TOP'
,p_navigation_list_id=>wwv_flow_api.id(404960847609814309)
,p_navigation_list_template_id=>wwv_flow_api.id(5429749254678674)
,p_nav_list_template_options=>'#DEFAULT#:t-NavTabs--inlineLabels-lg:t-NavTabs--hiddenLabels-sm'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(790288847925406340)
,p_plug_name=>'Example 2'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>40
,p_query_type=>'TABLE'
,p_query_table=>'EBA_UT_CHART_TASKS'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_JQM_COLUMN_TOGGLE'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'sample2'
,p_attribute_01=>'STRIPE:STROKE'
,p_attribute_04=>'Select Columns'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(790288992140406341)
,p_name=>'ID'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>10
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(790289017734406342)
,p_name=>'PROJECT'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>20
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(790289152285406343)
,p_name=>'PARENT_TASK'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>30
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(790289284635406344)
,p_name=>'TASK_NAME'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Task Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(790289308963406345)
,p_name=>'ROW_VERSION_NUMBER'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>50
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(790289425023406346)
,p_name=>'START_DATE'
,p_data_type=>'DATE'
,p_is_visible=>true
,p_heading=>'Start Date'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>60
,p_value_alignment=>'CENTER'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'4'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(790289572704406347)
,p_name=>'END_DATE'
,p_data_type=>'DATE'
,p_is_visible=>true
,p_heading=>'End Date'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>70
,p_value_alignment=>'CENTER'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'4'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(790289695143406348)
,p_name=>'STATUS'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Status'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(790289770872406349)
,p_name=>'ASSIGNED_TO'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Assigned To'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'3'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(790289821327406350)
,p_name=>'COST'
,p_data_type=>'NUMBER'
,p_is_visible=>true
,p_heading=>'Cost'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>100
,p_value_alignment=>'RIGHT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'5'
,p_format_mask=>'FML999G999G999G999G990D00'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(790511423857235901)
,p_name=>'BUDGET'
,p_data_type=>'NUMBER'
,p_is_visible=>true
,p_heading=>'Budget'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>110
,p_value_alignment=>'RIGHT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'5'
,p_format_mask=>'FML999G999G999G999G990D00'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(790511569365235902)
,p_name=>'CREATED'
,p_data_type=>'TIMESTAMP_LTZ'
,p_is_visible=>false
,p_display_sequence=>120
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'6'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(790511664152235903)
,p_name=>'CREATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_visible=>false
,p_display_sequence=>130
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'6'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(790511796818235904)
,p_name=>'UPDATED'
,p_data_type=>'TIMESTAMP_LTZ'
,p_is_visible=>false
,p_display_sequence=>140
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'6'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(790511885224235905)
,p_name=>'UPDATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_visible=>false
,p_display_sequence=>150
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'6'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2167508167089159725)
,p_plug_name=>'Tasks'
,p_region_css_classes=>'example1'
,p_icon_css_classes=>'fa-check-square-o u-color-4'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--showIcon:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>30
,p_query_type=>'TABLE'
,p_query_table=>'EBA_UT_CHART_TASKS'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_JQM_COLUMN_TOGGLE'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'sample1'
,p_attribute_01=>'STROKE'
,p_attribute_04=>'Select Columns'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130346957721319537)
,p_name=>'ID'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>10
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130347037135319538)
,p_name=>'PROJECT'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>20
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130347130769319539)
,p_name=>'PARENT_TASK'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>30
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130347264558319540)
,p_name=>'TASK_NAME'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Task Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130347392622319541)
,p_name=>'ROW_VERSION_NUMBER'
,p_data_type=>'NUMBER'
,p_is_visible=>false
,p_display_sequence=>50
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130347462664319542)
,p_name=>'START_DATE'
,p_data_type=>'DATE'
,p_is_visible=>true
,p_heading=>'Start Date'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>60
,p_value_alignment=>'CENTER'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'4'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130347591822319543)
,p_name=>'END_DATE'
,p_data_type=>'DATE'
,p_is_visible=>true
,p_heading=>'End Date'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>70
,p_value_alignment=>'CENTER'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'4'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130347696927319544)
,p_name=>'STATUS'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Status'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'1'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130347777677319545)
,p_name=>'ASSIGNED_TO'
,p_data_type=>'VARCHAR2'
,p_is_visible=>true
,p_heading=>'Assigned To'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'3'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130347868357319546)
,p_name=>'COST'
,p_data_type=>'NUMBER'
,p_is_visible=>true
,p_heading=>'Cost'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>100
,p_value_alignment=>'RIGHT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'5'
,p_format_mask=>'FML999G999G999G999G990D00'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130347978011319547)
,p_name=>'BUDGET'
,p_data_type=>'NUMBER'
,p_is_visible=>true
,p_heading=>'Budget'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>110
,p_value_alignment=>'RIGHT'
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'5'
,p_format_mask=>'FML999G999G999G999G990D00'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130348033907319548)
,p_name=>'CREATED'
,p_data_type=>'TIMESTAMP_LTZ'
,p_is_visible=>false
,p_display_sequence=>120
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'6'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130348189900319549)
,p_name=>'CREATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_visible=>false
,p_display_sequence=>130
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'6'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130348230362319550)
,p_name=>'UPDATED'
,p_data_type=>'TIMESTAMP_LTZ'
,p_is_visible=>false
,p_display_sequence=>140
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'6'
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1130348426597319551)
,p_name=>'UPDATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_visible=>false
,p_display_sequence=>150
,p_attribute_01=>'PLAIN'
,p_attribute_08=>'N'
,p_attribute_25=>'6'
,p_escape_on_http_output=>true
);
end;
/
prompt --application/pages/page_01800
begin
wwv_flow_api.create_page(
 p_id=>1800
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Calendars'
,p_alias=>'CALENDARS'
,p_step_title=>'Calendars - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.ts-Placeholder {',
'height: 240px;',
'line-height: 240px;',
'text-align: center;',
'background-color: #D0D0D0;',
'color: #404040;',
'border-radius: 2px;',
'margin-bottom: 48px;',
'}',
'.ts-Container {',
'max-width: 1024px;',
'min-height: 50vh;',
'}'))
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1909144173928031707)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'JUMP'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1909148466926031712)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--showBreadcrumb:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1909148891703031712)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This calendar is based on the Full Calendar library and supports drag and drop, multiple views, and more.</p>',
'<p class="dm-Hero-steps">Use the new <strong>Calendar</strong> native region type to display calendars within your applications.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1909157209595031727)
,p_plug_name=>'Calendar'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1911663188746700804)
,p_plug_name=>'Tasks Calendar'
,p_parent_plug_id=>wwv_flow_api.id(1909157209595031727)
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  task_name,',
'  start_date,',
'  end_date,',
'  status,',
'  assigned_to,',
'  case STATUS',
'     when ''Open''    then ''apex-cal-green''',
'     when ''Pending'' then ''apex-cal-yellow''',
'     when ''Closed''  then ''apex-cal-red''',
'     when ''On-Hold'' then ''apex-cal-black''',
'  end as css_class',
'from ',
'  eba_ut_chart_tasks'))
,p_lazy_loading=>true
,p_plug_source_type=>'NATIVE_CSS_CALENDAR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'START_DATE'
,p_attribute_03=>'TASK_NAME'
,p_attribute_07=>'N'
,p_attribute_11=>'month:week:day:list:navigation'
,p_attribute_13=>'Y'
,p_attribute_14=>'CSS_CLASS'
,p_attribute_17=>'Y'
,p_attribute_18=>'00'
,p_attribute_19=>'Y'
,p_attribute_20=>'9'
,p_attribute_21=>'10'
,p_attribute_22=>'Y'
,p_attribute_23=>'3'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2055998980371592081)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1909148466926031712)
,p_button_name=>'REGION_TYPE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Type'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6308:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'fa-list'
);
end;
/
prompt --application/pages/page_01901
begin
wwv_flow_api.create_page(
 p_id=>1901
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Tree'
,p_alias=>'TREE'
,p_step_title=>'Tree - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105541'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1702447159622649533)
,p_plug_name=>'Sample Query'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre class="dm-Code lang-sql"><code>select case when connect_by_isleaf = 1 then 0 when level = 1 then 1 else -1 end as status,',
'        level,',
'        TASK_NAME as title,',
'        ''icon-tree-folder'' as icon,',
'        id as value,',
'        TASK_NAME as tooltip,',
'        null  as link ',
'   from EBA_UT_CHART_TASKS',
'  start with PARENT_TASK is null',
'connect by prior PROJECT = PARENT_TASK',
'  order siblings by TASK_NAME</code></pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1702447250555649534)
,p_plug_name=>'Example'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when connect_by_isleaf = 1 then 0 when level = 1 then 1 else -1 end as status,',
'        level,',
'        TASK_NAME as title,',
'        ''icon-tree-folder'' as icon,',
'        id as value,',
'        TASK_NAME as tooltip,',
'        null  as link ',
'   from EBA_UT_CHART_TASKS',
'  start with PARENT_TASK is null',
'connect by prior PROJECT = PARENT_TASK',
'  order siblings by TASK_NAME'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_JSTREE'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_02=>'S'
,p_attribute_04=>'N'
,p_attribute_08=>'a-Icon'
,p_attribute_10=>'TITLE'
,p_attribute_11=>'LEVEL'
,p_attribute_12=>'ICON'
,p_attribute_15=>'STATUS'
,p_attribute_20=>'VALUE'
,p_attribute_23=>'LEVEL'
,p_attribute_24=>'LINK'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4285836151047951726)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4446435629762932401)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>Tree</strong> is a hierarchical navigational control based on a SQL query executed at runtime.</p>',
'<p class="dm-Hero-steps">Set <strong>Tree</strong> as the Region type.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4446436922789939830)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2056001026293601886)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4285836151047951726)
,p_button_name=>'REGION_TYPE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Type'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6308:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'fa-list'
);
end;
/
prompt --application/pages/page_01902
begin
wwv_flow_api.create_page(
 p_id=>1902
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Charts'
,p_alias=>'CHARTS'
,p_step_title=>'Charts - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2015604679278607124)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2015604921533607127)
,p_plug_name=>'1. Bar'
,p_parent_plug_id=>wwv_flow_api.id(2015604679278607124)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--padded:t-ContentBlock--h3:t-ContentBlock--lightBG'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(2015605038869607128)
,p_region_id=>wwv_flow_api.id(2015604921533607127)
,p_chart_type=>'bar'
,p_height=>'200'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'none'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(2015605157579607129)
,p_chart_id=>wwv_flow_api.id(2015605038869607128)
,p_seq=>10
,p_name=>'Series 1'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    rownum  as value,',
'    ''label'' as label',
'from',
'    dual',
'connect by level <= 12'))
,p_items_value_column_name=>'VALUE'
,p_items_label_column_name=>'LABEL'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(2015605363426607131)
,p_chart_id=>wwv_flow_api.id(2015605038869607128)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(2015605259238607130)
,p_chart_id=>wwv_flow_api.id(2015605038869607128)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2015605954466607137)
,p_plug_name=>'Chart SQL Query'
,p_parent_plug_id=>wwv_flow_api.id(2015604921533607127)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre class="dm-Code lang-sql"><code>select',
'    rownum  as value,',
'    ''label'' as label',
'from',
'    dual',
'connect by level <= 12</code></pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2015605471589607132)
,p_plug_name=>'2. Dial Gauge'
,p_parent_plug_id=>wwv_flow_api.id(2015604679278607124)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--padded:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(2015605563534607133)
,p_region_id=>wwv_flow_api.id(2015605471589607132)
,p_chart_type=>'dial'
,p_height=>'200'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_text_type=>'number'
,p_value_position=>'auto'
,p_value_format_scaling=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_indicator_size=>1
,p_gauge_inner_radius=>.7
,p_gauge_plot_area=>'on'
,p_gauge_start_angle=>180
,p_gauge_angle_extent=>180
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(2015605622238607134)
,p_chart_id=>wwv_flow_api.id(2015605563534607133)
,p_seq=>10
,p_name=>'Series 1'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT',
'    80 value, ',
'    100 max_value ',
'FROM',
'    dual'))
,p_items_value_column_name=>'VALUE'
,p_items_max_value=>'MAX_VALUE'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2015606083486607138)
,p_plug_name=>'Chart SQL Query'
,p_parent_plug_id=>wwv_flow_api.id(2015605471589607132)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre class="dm-Code lang-sql"><code>SELECT',
'    80 value, ',
'    100 max_value ',
'FROM',
'    dual</code></pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2015606166139607139)
,p_plug_name=>'3. Donut'
,p_parent_plug_id=>wwv_flow_api.id(2015604679278607124)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--padded:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(2015606204863607140)
,p_region_id=>wwv_flow_api.id(2015606166139607139)
,p_chart_type=>'donut'
,p_height=>'200'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'none'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_value_format_scaling=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_pie_other_threshold=>0
,p_pie_selection_effect=>'highlight'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(2015606336570607141)
,p_chart_id=>wwv_flow_api.id(2015606204863607140)
,p_seq=>10
,p_name=>'Series 1'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    rownum  as value,',
'    rownum || '' label'' as label',
'from',
'    dual',
'connect by level <= 3'))
,p_items_value_column_name=>'VALUE'
,p_items_label_column_name=>'LABEL'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2015606415675607142)
,p_plug_name=>'Chart SQL Query'
,p_parent_plug_id=>wwv_flow_api.id(2015606166139607139)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre class="dm-Code lang-sql"><code>select',
'    rownum  as value,',
'    rownum || '' label'' as label',
'from',
'    dual',
'connect by level <= 3</code></pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4285880422848271170)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4456396713782550099)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Charts are based on Oracle JavaScript Extension Toolkit (JET) Data Visualizations.<br>For more examples, please install the <strong>Sample Charts</strong>  from Packaged Apps > Sample Apps.</p>',
'<p class="dm-Hero-steps">Set <strong>Chart</strong> as Region type and provide SQL query. In Region attributes, select a type out of 15 types, e.g. "Bar".</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4456397004269548323)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2055999299194593496)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4285880422848271170)
,p_button_name=>'REGION_TYPE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Type'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6308:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'fa-list'
);
end;
/
prompt --application/pages/page_01903
begin
wwv_flow_api.create_page(
 p_id=>1903
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Help Text'
,p_alias=>'HELP-TEXT'
,p_step_title=>'Help Text - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Help created in Application Builder displays on a dedicated Help page. To access Help, users click a link that takes them to a dedicated Help page. This Help page displays page and item Help topics specific to the page they are viewing.</p>',
'<p>To define item Help text for a page:</p>',
'<ol>',
'<li>Navigate to the Page Definition for the page for which you want to add page Help.</li>',
'<li>Under Page, click the Edit page attributes icon to view the existing page attributes.</li>',
'<li>Scroll down to Help Text</li>',
'<li>Enter your Help text in the field provided.</li>',
'<li>Click Apply Change.</li>',
'</ol>'))
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1702448081830649542)
,p_plug_name=>'Help Example'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_HELP_TEXT'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5166996004786994991)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8476944365397289376)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8476944510481292664)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>Help Text</strong> regions enable you to provide page-level help.</p>',
'<p class="dm-Hero-steps">Set <strong>Help Text</strong> as the Region type.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2055999552999595152)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(5166996004786994991)
,p_button_name=>'REGION_TYPE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Type'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6308:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'fa-list'
);
end;
/
prompt --application/pages/page_01904
begin
wwv_flow_api.create_page(
 p_id=>1904
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Map Chart'
,p_alias=>'MAP-CHART'
,p_step_title=>'Map Chart - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2025747468768536719)
,p_plug_name=>'Example'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'Please install the <strong>Sample Charts</strong> application from Packaged Apps > Sample Apps to see an example of the Map Chart.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4471769101943063661)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>Map Charts</strong> use the AnyChart Flash Map component and are useful for visualizing geographically related data.</p>',
'<p class="dm-Hero-steps">Set <strong>Map Chart</strong> as the Region type.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4471770082187063831)
,p_plug_name=>'Region Display Selector'
,p_region_name=>'dialog_fixed'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6048113307162729652)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2055999837818596891)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(6048113307162729652)
,p_button_name=>'REGION_TYPE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Type'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6308:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'fa-list'
);
end;
/
prompt --application/pages/page_01905
begin
wwv_flow_api.create_page(
 p_id=>1905
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Static Content'
,p_alias=>'STATIC-CONTENT'
,p_step_title=>'Static Content - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4446441173349043097)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The <strong>Static Content</strong> Region Type is a very basic region component which can be used for many purposes.  It is one of the most versatile components available for controlling the layout of your page, or for organizing regions and form'
||' items.  It can also be used to render HTML directly within your APEX application.</p>',
'<p class="dm-Hero-steps">Set <strong>Static Content</strong> as the Region type.</p>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4446441489535041405)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6929234200377470237)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2056000748033601095)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(6929234200377470237)
,p_button_name=>'REGION_TYPE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Type'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6308:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'fa-list'
);
end;
/
prompt --application/pages/page_01906
begin
wwv_flow_api.create_page(
 p_id=>1906
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Modal Dialogs and Popups'
,p_alias=>'MODAL-DIALOGS-AND-POPUPS'
,p_step_title=>'Modal Dialogs and Popups - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2152194857912275437)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4498504332644980288)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_component_template_options=>'#DEFAULT#:u-colors'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(2011053202038416818)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5932987235526706220)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Modal dialogs, inline dialogs, and inline popups are a great way to get user input, display information, and speed up user interactions without changing context or leaving the current page.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_01907
begin
wwv_flow_api.create_page(
 p_id=>1907
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Tabs and Region Display Selector'
,p_alias=>'TABS-AND-REGION-DISPLAY-SELECTOR'
,p_step_title=>'Tabs and Region Display Selector - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_javascript_code_onload=>'apex.theme42demo.jump(''&REQUEST.'');'
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285421700128520223)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The <strong>Region Display Selector</strong> is a Region component that provides a page level navigation control for other regions on the with the <em>Region Display Selector</em> property set to <strong>Yes</strong>.  It can be configured to work'
||' in two modes:</p>',
'<ul>',
'  <li><strong>View Single Region</strong> Show regions as tabs. Selecting a tab will make the corresponding region visible and hide the other selections.</li>',
'  <li><strong>Scroll Window</strong> Always display all the regions on the page. Selecting a tab will scroll your window to the corresponding region.</li>',
'</ul>',
'<p>Follow the instructions below to add a Region Display Selector to your own pages:</p>',
'<div class="dm-Hero-steps  margin-bottom-md">',
'<p><strong>Step 1</strong> Create a <strong>Region Display Selector</strong> region and place it in the <strong>Breadcrumb</strong> region position on your page.</p>',
'<p><strong>Step 2</strong> Modify the other regions on the page and set the <em>Region Display Selector</em> property to <strong>Yes</strong> for the regions you want to appear in the Region Display Selector.</p>',
'</div>',
'<p><strong>Tip:</strong> You can find examples of how to use the Region Display Selector in several of the Packaged Apps bundled with Application Express.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285421868806520224)
,p_plug_name=>'Tabs Region'
,p_region_name=>'tab_container'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The <strong>Tabs Container</strong> Region Template can be used to create a set tabs within your page.  Simply place sub regions within the Tabs Container and they will appear as a tab.</p>',
'<p>This control is useful when you want to display different regions or information, but utilise the same space on a page.</p>',
'',
'<p>Follow the instructions below to add a tabs component your own pages:</p>',
'<div class="dm-Hero-steps  margin-bottom-md">',
'<p><strong>Step 1</strong> Create a new Static Content region and set the Template to <strong>Tabs Container</strong>.</p>',
'<p><strong>Step 2</strong> Create or move sub regions into the Tabs Container, one for each tab you want to have.</p>',
'</div>',
'<p><strong>Tip:</strong> You can easily nest tabs by creating another Tabs Container region within a sub region of an existing Tabs Container region.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2025746929774536714)
,p_plug_name=>'Example 1'
,p_parent_plug_id=>wwv_flow_api.id(2285421868806520224)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2025746410148536709)
,p_plug_name=>'Tabs Container'
,p_parent_plug_id=>wwv_flow_api.id(2025746929774536714)
,p_region_template_options=>'#DEFAULT#:t-TabsRegion-mod--simple'
,p_plug_template=>wwv_flow_api.id(1774143203700285855)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2025746550532536710)
,p_plug_name=>'Tab 1'
,p_parent_plug_id=>wwv_flow_api.id(2025746410148536709)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Content 1'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2025746643523536711)
,p_plug_name=>'Tab 2'
,p_parent_plug_id=>wwv_flow_api.id(2025746410148536709)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Content 2'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2025746742675536712)
,p_plug_name=>'Tab 3'
,p_parent_plug_id=>wwv_flow_api.id(2025746410148536709)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Content 3'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285422747461520233)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(2025746929774536714)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285422081111520226)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(2285421868806520224)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'REGION'
,p_attribute_02=>'Tabs Container'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285422150076520227)
,p_plug_name=>'Example 2'
,p_parent_plug_id=>wwv_flow_api.id(2285421868806520224)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285422202988520228)
,p_plug_name=>'Tabs Container'
,p_parent_plug_id=>wwv_flow_api.id(2285422150076520227)
,p_region_template_options=>'#DEFAULT#:t-TabsRegion-mod--pill:t-TabsRegion-mod--large'
,p_plug_template=>wwv_flow_api.id(1774143203700285855)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285422309965520229)
,p_plug_name=>'Tab 1'
,p_parent_plug_id=>wwv_flow_api.id(2285422202988520228)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Content 1'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285422455922520230)
,p_plug_name=>'Tab 2'
,p_parent_plug_id=>wwv_flow_api.id(2285422202988520228)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Content 2'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285422560012520231)
,p_plug_name=>'Tab 3'
,p_parent_plug_id=>wwv_flow_api.id(2285422202988520228)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Content 3'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285422906352520235)
,p_plug_name=>'Tab 4 - Nested'
,p_parent_plug_id=>wwv_flow_api.id(2285422202988520228)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285423010854520236)
,p_plug_name=>'Nested Container'
,p_parent_plug_id=>wwv_flow_api.id(2285422906352520235)
,p_region_template_options=>'#DEFAULT#:t-TabsRegion-mod--simple'
,p_plug_template=>wwv_flow_api.id(1774143203700285855)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285423193766520237)
,p_plug_name=>'Nested Region A'
,p_parent_plug_id=>wwv_flow_api.id(2285423010854520236)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dolore accusamus quidem saepe in voluptate ad ea quis maxime consectetur voluptatum eos, laboriosam voluptates cupiditate atque obcaecati numquam fuga, explicabo illo.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285423286595520238)
,p_plug_name=>'Nested Region B'
,p_parent_plug_id=>wwv_flow_api.id(2285423010854520236)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Similique ducimus, rerum illo ea provident a. Veniam voluptates sed quidem incidunt, dolores vel eveniet. Vel officiis facere, totam fuga voluptatum obcaecati!</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285422630439520232)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(2285422150076520227)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285421972161520225)
,p_plug_name=>'Tabs List'
,p_region_name=>'tab_list'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The <strong>Tabs</strong> List Template can be used to create a set tabs where each tab links to another page.  This is especially useful for applications that require nested or complex navigation hierarchies.</p>',
'',
'<p>Follow the instructions below to add a tabs component your own pages:</p>',
'<p class="dm-Hero-steps">Set <strong>Tabs</strong> as the List Template</p>',
'<p><strong>Tip:</strong> You can add icons to these tabs simply by modifying the icon attribute of the list entry.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285423484801520240)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(2285421972161520225)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'LIST'
,p_attribute_04=>'Tabs'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285423674580520242)
,p_plug_name=>'Example 1 Container'
,p_parent_plug_id=>wwv_flow_api.id(2285421972161520225)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2025746121407536706)
,p_plug_name=>'Example 1'
,p_parent_plug_id=>wwv_flow_api.id(2285423674580520242)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_component_template_options=>'#DEFAULT#:t-Tabs--simple'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(2285543718406476760)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1840624874773603093)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285423518786520241)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(2285423674580520242)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285423769316520243)
,p_plug_name=>'Example 2 Container'
,p_parent_plug_id=>wwv_flow_api.id(2285421972161520225)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285423811793520244)
,p_plug_name=>'Example 2'
,p_parent_plug_id=>wwv_flow_api.id(2285423769316520243)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_component_template_options=>'#DEFAULT#:t-Tabs--inlineIcons:t-Tabs--simple'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(2285543718406476760)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1840624874773603093)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285423920511520245)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(2285423769316520243)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285424057433520246)
,p_plug_name=>'Example 3 Container'
,p_parent_plug_id=>wwv_flow_api.id(2285421972161520225)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285424124953520247)
,p_plug_name=>'Example 3'
,p_parent_plug_id=>wwv_flow_api.id(2285424057433520246)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_component_template_options=>'#DEFAULT#:t-Tabs--large:t-Tabs--pill:t-Tabs--iconsAbove:t-Tabs--fillLabels'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(2285543718406476760)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1840624874773603093)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285424234718520248)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(2285424057433520246)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4459495255936548240)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>You can use Tabs and the Region Display Selector within your application pages to improve navigation, flow and usability of your pages.  These components are grouped together as they provide similar functionality, but have different implementation'
||'s and use cases.  This page will outline the three distinct methods you can use to apply these components to your page.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4459495563049546423)
,p_plug_name=>'Region Display Selector'
,p_region_name=>'dialog_fixed'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8691554008245997760)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2056000407641600156)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(8691554008245997760)
,p_button_name=>'REGION_TYPE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Type'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6308:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'fa-list'
);
end;
/
prompt --application/pages/page_01908
begin
wwv_flow_api.create_page(
 p_id=>1908
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'PL/SQL Dynamic Content'
,p_alias=>'PL-SQL-DYNAMIC-CONTENT'
,p_step_title=>'PL/SQL Dynamic Content - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1702447676863649538)
,p_plug_name=>'Example'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'',
' cursor c_tasks is',
'   select task_name, assigned_to',
'     from eba_ut_chart_tasks',
'    where rownum < 5;',
' ',
'begin',
'  sys.htp.p(''<ul>'');',
'  for a in c_tasks loop',
'    sys.htp.p(''<li>'' || a.task_name || '' ('' || a.assigned_to || '')</li>'' );',
'   end loop;',
'  sys.htp.p(''</ul>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1702447989861649541)
,p_plug_name=>'Sample Code'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre class="dm-Code lang-sql"><code>declare',
'',
' cursor c_tasks is',
'   select task_name, assigned_to',
'     from eba_ut_chart_tasks',
'    where rownum < 5;',
' ',
'begin',
'  sys.htp.p(''&lt;ul&gt;'');',
'  for a in c_tasks loop',
'    sys.htp.p(''&lt;li&gt;'' || a.task_name || '' ('' || a.assigned_to || '')&lt;/li&gt;'' );',
'   end loop;',
'  sys.htp.p(''&lt;/ul&gt;'');',
'end;</code></pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6461668201538518380)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>PL/SQL Dynamic Content</strong> region is based on PL/SQL enable you to render any HTML or text using the PL/SQL Web Toolkit.</p>',
'<p class="dm-Hero-steps">Set <strong>PL/SQL Dynamic Content</strong> as the Region type.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6461668277496515863)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9572720551226200363)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2056000172183598344)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(9572720551226200363)
,p_button_name=>'REGION_TYPE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Type'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6308:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'fa-list'
);
end;
/
prompt --application/pages/page_01909
begin
wwv_flow_api.create_page(
 p_id=>1909
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Updating Universal Theme'
,p_alias=>'UPDATING-UNIVERSAL-THEME'
,p_step_title=>'Updating Universal Theme - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(431032219555845082)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210920101650'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(390434387448898119)
,p_plug_name=>'2. Re-apply your Theme Style'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Once you refresh Universal Theme, the current theme style for your application will be reset to <b>Vita</b>.</p>',
'',
'<p>If your application was using a custom theme style, please follow these steps to set your custom theme style as current:</p>',
'',
'<ol>',
'<li>Run your application</li>',
'<li>Open <b>Theme Roller</b> from the Developer Toolbar</li>',
'<li>Select your custom theme style from the <b>Style</b> select list</li>',
'<li>Click <b>Save</b></li>',
'<li>Click <b>Save</b> again in the Save confirmation dialog, then click <b>OK</b></li>',
'<li>In Theme Roller, click <b>Set as Current</b>, then click <b>OK</b></li>',
'<li>Close Theme Roller</li>',
'</ol>',
'',
'<p><b>NOTE:</b> It is crucial that you re-save your custom theme style. This is necessary because Theme Roller will need to re-compile the css based upon the latest changes to the underlying theme.</p>',
'',
'<p>That''s it. Your custom theme style has been re-applied to your application and set as the current theme style.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(390434490967898120)
,p_plug_name=>'Lost Subscriptions'
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--info'
,p_plug_template=>wwv_flow_api.id(591654834181983844)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>It is recommended that Universal Theme remain subscribed so that you can easily refresh it to receive updates upon new releases of APEX.  If for some reason your application was unsubscribed or unlocked, you can restore the subscription by followi'
||'ng these steps.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(390434508065898121)
,p_plug_name=>'Restoring Universal Theme Subscription'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Follow these steps to restore the Universal Theme subscription and refresh it based on the latest release.</p>',
'<p><b>NOTE:</b> You will lose any changes or customizations made to templates within Universal Theme.</p>',
'',
'<ol>',
'<li>Navigate to <strong>Shared Components</strong> &rarr; <strong>Themes</strong></li>',
'<li>Verify that the <strong>Subscribed From</strong> column for Universal Theme says <strong>Theme Repository</strong></li>',
'<li>Click on <strong>Restore Theme Subscription</strong> from the side bar.</li>',
'<li>Set <b>Theme Source</b> to <b>Oracle Theme</b></li>',
'<li>Set <b>Master Theme</b> to <b>42. Universal Theme</b></li>',
'<li>Set <b>Match Template</b> to <b>By Template Identifier</b></li>',
'<li>Click <strong>Restore Subscription</strong></li>',
'</ol>',
'',
'<p>This process will refresh the Universal Theme in your application based on the master copy from the release of APEX.  Your theme style will also be reset to Vita. If you were using a custom theme stle, you can follow the steps outlined above to re'
||'-apply your custom theme style.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1093647605104550537)
,p_plug_name=>'Overview'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:margin-bottom-lg'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>You can easily update your applicaion to use the latest version of Universal Theme and keep current with the latest features, enhancements and bug fixes.  Simply follow the steps outlined on this page to get your application''s theme refreshed.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1093647770693550538)
,p_plug_name=>'Backup Reminder'
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--info'
,p_plug_template=>wwv_flow_api.id(591654834181983844)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Before you begin, please create back up your application.  You can do this by exporting your application, or by creating a copy of it.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1093647860663550539)
,p_plug_name=>'1. Refresh Universal Theme'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>First, you will need to <b>refresh</b> Universal Theme in your application so it is updated to the most current version.</p>',
'<ol>',
'<li>Navigate to <strong>Shared Components</strong> &rarr; <strong>Themes</strong></li>',
'<li>Verify that the <strong>Subscribed From</strong> column for Universal Theme says <strong>Theme Repository</strong></li>',
'<li>Click on <strong>Universal Theme</strong></li>',
'<li>Click <strong>Verify</strong> in the Theme Subscription region header</li>',
'<li>Click <strong>Verify</strong> in the Verify Theme Subscription Dialog</li>',
'<li>Click <strong>Refresh Theme</strong></li>',
'<li>Click <strong>OK</strong></li>',
'</ol>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10453888391712414965)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_01910
begin
wwv_flow_api.create_page(
 p_id=>1910
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Page Dialog'
,p_alias=>'PAGE-DIALOG'
,p_step_title=>'Page Dialog - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2015602841227607106)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285419695776520202)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'PAGE'
,p_attribute_03=>'Modal Dialog'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285419917187520205)
,p_plug_name=>'Region Positions'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>Drawer Header</strong><br/>',
'This region position is anchored to the top and is useful for components such as a wizard progress bar.</p>',
'<p><strong>Content Body</strong><br/>',
'Place all of your content regions in this position.</p>',
'<p><strong>Drawer Footer</strong><br/>',
'This region position is anchored to the bottom of the drawer and is useful for placing buttons using the Buttons Container region template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6462573061756922034)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A <strong>modal dialog</strong> is an overlay window positioned within the same browser window. A modal dialog remains active and focused until the user has finished with it and closes it. While a modal dialog is active, the user is unable to inte'
||'ract with the rest of the page until the dialog is closed.</p>',
'<p class="dm-Hero-steps">Set <strong>Modal Dialog</strong> as the Page Mode under Page Definition.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6462573077324919729)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10453889787106422574)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2015602956835607107)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2015602841227607106)
,p_button_name=>'OPEN_AUTO_SIZE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Dialog with Auto Size'
,p_button_redirect_url=>'f?p=&APP_ID.:1912:&SESSION.::&DEBUG.:RP,::'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2015603194405607109)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2015602841227607106)
,p_button_name=>'OPEN_FIXED'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Dialog with Fixed Size'
,p_button_redirect_url=>'f?p=&APP_ID.:1913:&SESSION.::&DEBUG.:RP::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(214824033067335124)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2015602841227607106)
,p_button_name=>'OPEN_FIT_DIALOG'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Fit to Screen Dialog'
,p_button_redirect_url=>'f?p=&APP_ID.:1914:&SESSION.::&DEBUG.:RP::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
end;
/
prompt --application/pages/page_01911
begin
wwv_flow_api.create_page(
 p_id=>1911
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Inline Dialog'
,p_alias=>'INLINE-DIALOG'
,p_step_title=>'Inline Dialog - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285419514506520201)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'REGION'
,p_attribute_02=>'Inline Dialog'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4043733018686239105)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4043735567424251206)
,p_plug_name=>'Auto Height'
,p_region_name=>'dialog_auto'
,p_region_template_options=>'#DEFAULT#:js-dialog-autoheight:js-dialog-size600x400'
,p_plug_template=>wwv_flow_api.id(1223645131968329858)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4043735597388251207)
,p_plug_name=>'Collapsible Content'
,p_parent_plug_id=>wwv_flow_api.id(4043735567424251206)
,p_region_template_options=>'#DEFAULT#:is-expanded:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(1215306280710140812)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'In its Template Options, check "Auto Height".'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4043736888413252362)
,p_plug_name=>'Fixed Height'
,p_region_name=>'dialog_fixed'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_api.id(1223645131968329858)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source=>'In its Template Options, uncheck "Auto Height" and pick a dialog size from the select list.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8485571368293322206)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8485571635100325198)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>An <strong>inline dialog</strong> displays a region on the current page within a modal dialog. </p>',
'<p class="dm-Hero-steps">Create a region, set its "Position" attribute to Inline Dialogs, and use <strong>Inline Dialog</strong> as its Region template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11335061679586658112)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2028130884954632011)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4043733018686239105)
,p_button_name=>'OPEN_AUTO_SIZE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Inline Dialog with Auto Size'
,p_button_redirect_url=>'javascript:openModal(''dialog_auto'')'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2028130450455632009)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4043733018686239105)
,p_button_name=>'OPEN_FIXED'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:t-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Inline Dialog with Fixed Size'
,p_button_redirect_url=>'javascript:openModal(''dialog_fixed'')'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2028131738436644088)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4043735567424251206)
,p_button_name=>'CANCEL_1'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:closeModal(''dialog_fixed'')'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2028133197697645245)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(4043736888413252362)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:closeModal(''dialog_fixed'')'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2028133583850645246)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4043736888413252362)
,p_button_name=>'OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'OK'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2028132159828644089)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4043735567424251206)
,p_button_name=>'OK_1'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'OK'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
end;
/
prompt --application/pages/page_01912
begin
wwv_flow_api.create_page(
 p_id=>1912
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Modal Dialog Demo'
,p_alias=>'MODAL-DIALOG-DEMO'
,p_page_mode=>'MODAL'
,p_step_title=>'Auto Sizing Modal Dialog'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2015603053528607108)
,p_plug_name=>'Collapsible Region'
,p_region_template_options=>'#DEFAULT#:js-useLocalStorage:is-collapsed:t-Region--scrollBody:margin-top-md'
,p_plug_template=>wwv_flow_api.id(1215306280710140812)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Veniam dolorum velit eos illum, voluptatem repellat animi dolores! Tempora fugit natus, odio vitae fuga amet commodi, architecto eaque aperiam hic! Illo!</li>',
'  <li>Quidem dolorem totam consectetur, quis esse sequi non in praesentium illum fugit, provident voluptate perspiciatis voluptas a natus magnam sed accusamus omnis? Reiciendis dignissimos doloremque rem blanditiis. Reprehenderit, facere, velit!</li>',
'  <li>Harum, modi eum suscipit numquam, molestiae laudantium. Ratione enim maiores placeat consequatur sed quam repellat, corporis ducimus magnam, aspernatur quas iusto reprehenderit assumenda ut architecto vel nostrum consequuntur velit sit.</li>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2015603784073607115)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>This dialog will automatically expand to fit its contents.  Try it out by by expanding the region below.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_01913
begin
wwv_flow_api.create_page(
 p_id=>1913
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Modal Dialog Demo - Fixed Size'
,p_alias=>'MODAL-DIALOG-DEMO-FIXED-SIZE'
,p_page_mode=>'MODAL'
,p_step_title=>'Fixed Height Modal Dialog'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'400'
,p_page_is_public_y_n=>'Y'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4035115758792705581)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:js-useLocalStorage:is-expanded:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(1215306280710140812)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This modal dialog has a fixed height of 400px and will not automatically resize to fit its contents.  This type of dialog is useful for wizards where the navigation buttons should remain in a constant position.</p>',
'<p>To set a height for a modal dialog page, simply set the "Height" property for the page in the Property Editor.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_01914
begin
wwv_flow_api.create_page(
 p_id=>1914
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Modal Dialog Demo - Fit Window'
,p_alias=>'MODAL-DIALOG-DEMO-FIT-WINDOW'
,p_page_mode=>'MODAL'
,p_step_title=>'Stretch to Fit Window'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_template_options=>'#DEFAULT#:ui-dialog--stretch'
,p_page_is_public_y_n=>'Y'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105542'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4301032495115192571)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>This modal dialog page stretches to fit the window and is useful for displaying large reports, charts, and other information where maximum screen real estate is desired.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4301032659963192573)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(677400524731372757)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2285430589168585497)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4301032659963192573)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2285430120596585495)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4301032659963192573)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2285431584199585518)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2285430589168585497)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2285432010437585521)
,p_event_id=>wwv_flow_api.id(2285431584199585518)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01915
begin
wwv_flow_api.create_page(
 p_id=>1915
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Inline Popup'
,p_alias=>'INLINE-POPUP'
,p_step_title=>'Inline Popup'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(391405771022988101)
,p_plug_name=>'Popup with Callout'
,p_region_name=>'popup_callout'
,p_region_template_options=>'#DEFAULT#:js-dialog-autoheight:js-popup-callout:js-dialog-size600x400'
,p_region_attributes=>'data-parent-element="#btn_popup_callout"'
,p_plug_template=>wwv_flow_api.id(36340727081178326)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source=>'This popup has a callout arrow that points to the button or element that this popup was opened from.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2498094077018757645)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'REGION'
,p_attribute_02=>'Inline Popup'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4256407581198476549)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4256410129936488650)
,p_plug_name=>'Auto Height Popup'
,p_region_name=>'dialog_auto'
,p_region_template_options=>'#DEFAULT#:js-dialog-autoheight:js-popup-noOverlay:js-popup-callout:js-dialog-size480x320'
,p_plug_template=>wwv_flow_api.id(36340727081178326)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4256410159900488651)
,p_plug_name=>'Collapsible Content'
,p_parent_plug_id=>wwv_flow_api.id(4256410129936488650)
,p_region_template_options=>'#DEFAULT#:is-expanded:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(1215306280710140812)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi vel ullamcorper metus. Duis interdum est eu accumsan lobortis. Quisque eu urna a odio feugiat ultrices ac id eros. Donec tristique nulla vitae tortor convallis, in commodo dui fermentu'
||'m. Donec aliquet odio non lacus hendrerit, id elementum augue vehicula. Quisque tincidunt ex mauris. Duis scelerisque congue libero, quis eleifend est vulputate nec. Suspendisse molestie tortor eget malesuada maximus. Aliquam pharetra sem vitae conse'
||'ctetur rhoncus. Ut pharetra, neque ut elementum sagittis, ex ipsum tempus urna, pharetra ultricies justo nunc vel diam. Ut tristique placerat justo, a ornare diam. Fusce at metus id turpis bibendum ornare. Maecenas gravida nibh eu nibh eleifend, ac s'
||'ollicitudin ante lobortis. Donec non erat feugiat, auctor nunc sed, laoreet orci.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4256411450925489806)
,p_plug_name=>'Fixed Height Popup'
,p_region_name=>'dialog_fixed'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_api.id(36340727081178326)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source=>'In its Template Options, uncheck "Auto Height" and pick a dialog size from the select list.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8698245930805559650)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8698246197612562642)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>An <strong>inline popup</strong> displays a region on the current page within a small popup component. It is similar to a dialog, however does not have a header bar, title, or close button. </p>',
'<p class="dm-Hero-steps">Create a region, set its "Position" attribute to Inline Dialogs, and use <strong>Inline Popup</strong> as its Region template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11547736242098895556)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(210164546898558130)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4256407581198476549)
,p_button_name=>'OPEN_AUTO_SIZE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Inline Popup with Auto Size'
,p_warn_on_unsaved_changes=>null
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(210164982495558133)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4256407581198476549)
,p_button_name=>'OPEN_FIXED'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Inline Popup with Fixed Size'
,p_warn_on_unsaved_changes=>null
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(391406059658988104)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(4256407581198476549)
,p_button_name=>'OPEN_CALLOUT'
,p_button_static_id=>'btn_popup_callout'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Inline Popup with Fixed Size'
,p_warn_on_unsaved_changes=>null
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(210165678938558136)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4256410129936488650)
,p_button_name=>'CANCEL_1'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-close-button'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(210167102044558140)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4256411450925489806)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-close-button'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(210166108401558137)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4256410129936488650)
,p_button_name=>'OK_1'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'OK'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-close-button'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(210167440962558141)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4256411450925489806)
,p_button_name=>'OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'OK'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-close-button'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(391405962813988103)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(391405771022988101)
,p_button_name=>'OK_2'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'OK'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-close-button'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183021443163069800)
,p_name=>'Open Auto Size Popup'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(210164546898558130)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183021603596069801)
,p_event_id=>wwv_flow_api.id(183021443163069800)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4256410129936488650)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183021698559069802)
,p_name=>'Open Fixed Popup'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(210164982495558133)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183021812185069803)
,p_event_id=>wwv_flow_api.id(183021698559069802)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4256411450925489806)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183021839389069804)
,p_name=>'Close Auto Height Popup'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(210165678938558136)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183021944059069805)
,p_event_id=>wwv_flow_api.id(183021839389069804)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4256410129936488650)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183022059784069806)
,p_name=>'Close Fixed Popup'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(210167102044558140)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183022131110069807)
,p_event_id=>wwv_flow_api.id(183022059784069806)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4256411450925489806)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(391406186000988105)
,p_name=>'Open Inline Popup with Callout'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(391406059658988104)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(391406213394988106)
,p_event_id=>wwv_flow_api.id(391406186000988105)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(391405771022988101)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(391406577780988109)
,p_name=>'Close Callout Popup'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(391405962813988103)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(391406690282988110)
,p_event_id=>wwv_flow_api.id(391406577780988109)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(391405771022988101)
);
end;
/
prompt --application/pages/page_01916
begin
wwv_flow_api.create_page(
 p_id=>1916
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Inline Drawer'
,p_alias=>'INLINE-DRAWER'
,p_step_title=>'Inline Drawer'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2497375725302686318)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'REGION'
,p_attribute_02=>'Inline Drawer'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4255689229482405222)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4255691778220417323)
,p_plug_name=>'Auto Width'
,p_region_name=>'drawer_auto'
,p_region_template_options=>'#DEFAULT#:js-dialog-nosize:js-dialog-class-t-Drawer--pullOutStart'
,p_plug_template=>wwv_flow_api.id(211944521729302482)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source=>'Set the Template Option Size to "None".'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4255693099209418479)
,p_plug_name=>'Fixed Width'
,p_region_name=>'drawer_fixed'
,p_region_template_options=>'#DEFAULT#:js-dialog-class-t-Drawer--md:js-dialog-class-t-Drawer--pullOutEnd'
,p_plug_template=>wwv_flow_api.id(211944521729302482)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source=>'This is a drawer that is using the Extra Large size.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8697527579089488323)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8697527845896491315)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>An <strong>inline drawer</strong> displays a region on the current page within a modal dialog that pulls out from the sides of the screen. </p>',
'<p class="dm-Hero-steps">Create a region, set its "Position" attribute to Inline Dialogs, and use <strong>Inline Drawer</strong> as its Region template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11547017890382824229)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(211957722230166037)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4255689229482405222)
,p_button_name=>'OPEN_AUTO_SIZE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Inline Drawer with Auto Size'
,p_button_redirect_url=>'javascript:openModal(''drawer_auto'')'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(211958106206166034)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4255689229482405222)
,p_button_name=>'OPEN_FIXED'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:t-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Inline Drawer with Fixed Size'
,p_button_redirect_url=>'javascript:openModal(''drawer_fixed'')'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(211958856364166033)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4255691778220417323)
,p_button_name=>'CANCEL_1'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:closeModal(''dialog_fixed'')'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(211960215554166030)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(4255693099209418479)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:closeModal(''dialog_fixed'')'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(211960608070166028)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4255693099209418479)
,p_button_name=>'OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'OK'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(211959209265166033)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4255691778220417323)
,p_button_name=>'OK_1'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'OK'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
end;
/
prompt --application/pages/page_01917
begin
wwv_flow_api.create_page(
 p_id=>1917
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Page Drawer'
,p_alias=>'PAGE-DRAWER'
,p_step_title=>'Page Drawer'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105541'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2230418975722000175)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2500235830270913271)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'PAGE'
,p_attribute_03=>'Drawer'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2500236051681913274)
,p_plug_name=>'Region Positions'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>Dialog Header</strong><br/>',
'This region position is anchored to the top and is useful for components such as a wizard progress bar.</p>',
'<p><strong>Content Body</strong><br/>',
'Place all of your content regions in this position.</p>',
'<p><strong>Dialog Footer</strong><br/>',
'This region position is anchored to the bottom of the dialog and is useful for placing buttons using the Buttons Container region template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6677389196251315103)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A <strong>drawer</strong> is an overlay window positioned attached to the side of the same browser window. A drawer remains active and focused until the user has finished with it and closes it. While a drawer is active, the user is unable to inter'
||'act with the rest of the page until the drawer is closed.</p>',
'<p class="dm-Hero-steps">Set <strong>Modal Dialog</strong> as the Page Mode under Page Definition.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6677389211819312798)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10668705921600815643)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(214817101103392989)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2230418975722000175)
,p_button_name=>'OPEN_AUTO_SIZE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Drawer with Auto Size'
,p_button_redirect_url=>'f?p=&APP_ID.:1918:&SESSION.::&DEBUG.:RP,::'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(214817568210392959)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2230418975722000175)
,p_button_name=>'OPEN_FIXED'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Drawer with Fixed Size'
,p_button_redirect_url=>'f?p=&APP_ID.:1919:&SESSION.::&DEBUG.:RP,::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
end;
/
prompt --application/pages/page_01918
begin
wwv_flow_api.create_page(
 p_id=>1918
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Drawer Demo'
,p_alias=>'DRAWER-DEMO'
,p_page_mode=>'MODAL'
,p_step_title=>'Drawer Demo'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_step_template=>wwv_flow_api.id(212157975711187152)
,p_page_template_options=>'#DEFAULT#:js-dialog-class-t-Drawer--pullOutStart:js-dialog-class-t-Drawer--sm'
,p_page_is_public_y_n=>'Y'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105541'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2230424179779959875)
,p_plug_name=>'Collapsible Region'
,p_region_template_options=>'#DEFAULT#:js-useLocalStorage:is-collapsed:t-Region--scrollBody:margin-top-md'
,p_plug_template=>wwv_flow_api.id(1215306280710140812)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Veniam dolorum velit eos illum, voluptatem repellat animi dolores! Tempora fugit natus, odio vitae fuga amet commodi, architecto eaque aperiam hic! Illo!</li>',
'  <li>Quidem dolorem totam consectetur, quis esse sequi non in praesentium illum fugit, provident voluptate perspiciatis voluptas a natus magnam sed accusamus omnis? Reiciendis dignissimos doloremque rem blanditiis. Reprehenderit, facere, velit!</li>',
'  <li>Harum, modi eum suscipit numquam, molestiae laudantium. Ratione enim maiores placeat consequatur sed quam repellat, corporis ducimus magnam, aspernatur quas iusto reprehenderit assumenda ut architecto vel nostrum consequuntur velit sit.</li>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2230424910324959882)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>This drawer will automatically expand to fit its contents.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_01919
begin
wwv_flow_api.create_page(
 p_id=>1919
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Drawer Demo - Fixed Size'
,p_alias=>'DRAWER-DEMO-FIXED-SIZE'
,p_page_mode=>'MODAL'
,p_step_title=>'Drawer Demo - Fixed Size'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_step_template=>wwv_flow_api.id(212157975711187152)
,p_page_template_options=>'#DEFAULT#:js-dialog-class-t-Drawer--pullOutEnd'
,p_page_is_public_y_n=>'Y'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2445247394761307005)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This drawer has a fixed width of 400px and will not automatically resize to fit its contents.  This type of drawer is useful for wizards where the navigation buttons should remain in a constant position.</p>',
'<p>To set a width for a drawer page, simply set the "Width" property for the page in the Property Editor.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_01920
begin
wwv_flow_api.create_page(
 p_id=>1920
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Step 1'
,p_alias=>'STEP-1'
,p_page_mode=>'MODAL'
,p_step_title=>'Step 1'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(672766417768219611)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'400'
,p_page_is_public_y_n=>'Y'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105541'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285451371091797902)
,p_plug_name=>'Wizard Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'t-WizardSteps--displayLabels'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(2285450736180797899)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(561120526789187584)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285451401525797902)
,p_plug_name=>'Step 1'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_source=>'<p>This is step 1 of the sample modal dialog wizard.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285451532760797902)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(677400524731372757)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2285453489686797913)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2285451532760797902)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2285453765696797913)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2285451532760797902)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'fa-chevron-right'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2285455400714797920)
,p_branch_name=>'Go To Page 1921'
,p_branch_action=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2285453765696797913)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2285453857570797914)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2285453489686797913)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2285454604188797918)
,p_event_id=>wwv_flow_api.id(2285453857570797914)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01921
begin
wwv_flow_api.create_page(
 p_id=>1921
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Step 2'
,p_alias=>'STEP-2'
,p_page_mode=>'MODAL'
,p_step_title=>'Step 2'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(672766417768219611)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'400'
,p_page_is_public_y_n=>'Y'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105541'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285456106276797921)
,p_plug_name=>'Wizard Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'t-WizardSteps--displayLabels'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(2285450736180797899)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(561120526789187584)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285456273828797921)
,p_plug_name=>'Step 2'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_source=>'This is step 2.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285456307600797921)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(677400524731372757)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2285458244800797923)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2285456307600797921)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2285458570312797923)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2285456307600797921)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'fa-chevron-right'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2285458479857797923)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2285456307600797921)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'fa-chevron-left'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2285460968338797925)
,p_branch_action=>'f?p=&APP_ID.:1922:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2285458570312797923)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2285460288083797924)
,p_branch_action=>'f?p=&APP_ID.:1920:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2285458479857797923)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2285458624162797923)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2285458244800797923)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2285459400679797924)
,p_event_id=>wwv_flow_api.id(2285458624162797923)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01922
begin
wwv_flow_api.create_page(
 p_id=>1922
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Step 3'
,p_alias=>'STEP-3'
,p_page_mode=>'MODAL'
,p_step_title=>'Step 3'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(672766417768219611)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'400'
,p_page_is_public_y_n=>'Y'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105541'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285461658637797926)
,p_plug_name=>'Wizard Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'t-WizardSteps--displayLabels'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(2285450736180797899)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(561120526789187584)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285461752429797926)
,p_plug_name=>'Step 3'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_source=>'This is step 3'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2285461831031797926)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(677400524731372757)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2285463771494797927)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2285461831031797926)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2285463875184797927)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(2285461831031797926)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Finish'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2285463905622797927)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2285461831031797926)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'fa-chevron-left'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2285465786566797929)
,p_branch_action=>'f?p=&APP_ID.:1921:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2285463905622797927)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2285464182102797927)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2285463771494797927)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2285464907322797928)
,p_event_id=>wwv_flow_api.id(2285464182102797927)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2285466407935797930)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_02000
begin
wwv_flow_api.create_page(
 p_id=>2000
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Migration Guide'
,p_alias=>'MIGRATION-GUIDE'
,p_step_title=>'Migration Guide - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(431032219555845082)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105541'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107376527283374054)
,p_plug_name=>'Migrating from Other Themes'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:margin-top-lg'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>This guide will cover the steps involved in migrating to the Universal Theme. It will cover the pros and cons of Universal Theme, and how to go through the Theme Switch wizard. This guide also covers the post-migration phase: the immediate tasks, '
||'some best practices for working with Universal Theme, and a list of common problems and solutions encountered during and after the upgrade.  Please note that this guide assumes you have a working knowledge of Application Express fundamentals.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(349882008097259924)
,p_plug_name=>'Migration Guide List from Other Themes'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--hideHeader:t-Region--scrollBody'
,p_component_template_options=>'t-MediaList--showIcons:u-colors'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(558263404439591029)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(606904371121638638)
,p_plug_name=>'Migrating from jQuery Mobile'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:margin-top-lg'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>If you were using the jQuery Mobile user interface for your APEX apps then now is a good time to transition to the Universal Theme. Learn how you can use Universal Theme to deliver a polished small screen experience and the UI patterns to use for '
||'mobile use cases.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(606904440014638639)
,p_plug_name=>'Migrating from jQuery Mobile List'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--hideHeader:t-Region--scrollBody'
,p_component_template_options=>'t-MediaList--showIcons:u-colors'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(654287896600461596)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1515423123007817027)
,p_plug_name=>'Updating Universal Theme'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>If you are already using Universal Theme in your applications, you can easily take advantage of new features and updates without having to go through a lot of work.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1515423248136817028)
,p_plug_name=>'Updating Universal Theme List'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--hideHeader:t-Region--scrollBody'
,p_component_template_options=>'t-MediaList--showIcons:u-colors'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(1566181754433295518)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2124444736165886981)
,p_plug_name=>'Migration Guides'
,p_icon_css_classes=>'fa-lg fa-tasks u-color-11'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1224989219520090364)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_02010
begin
wwv_flow_api.create_page(
 p_id=>2010
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Why Migrate'
,p_alias=>'WHY-MIGRATE'
,p_step_title=>'Why Migrate - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(431032219555845082)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(430899132855155802)
,p_plug_name=>'Cons'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Because migrating to Universal Theme, from older themes, will take development effort and significant time reviewing migrated pages, you should consider the downsides of migrating before moving forward.</p>',
'<ol>',
'  <li>',
'  <p><strong>Different UI</strong>',
'    <br />While Universal Theme is designed to be fully accessible and aesthetically pleasing, users who are completely comfortable with the older theme''s UI, may not immediately like the new theme. Further, training material developed in-house will '
||'need to be upgraded as the look of the pages will undoubtedly change significantly.</p>',
'    <p>This is not a technical issue, since Universal Theme is not a departure from the traditional APEX workflow, but an enhancement on top of your existing processes. Application content, such as pages, regions, buttons, and items, will not be chan'
||'ged as a result of migrating, other than their appearance.</p></li>',
'    <li><p><strong>Regressions</strong>',
'      <br />Some templates carried over from previous themes may not have strict <em>one-to-one</em> equivalents. Some of your custom CSS/JS modifications that were not directly supported in APEX may also no longer work as expected on your pages. The'
||'se and other issues are covered in <strong>Post-Migration Tasks</strong>, <strong>Best Practices</strong>, and <strong>Common Issues After Upgrading</strong> sections below.</p></li>',
'    <li><p><strong>Custom Themes / Templates</strong>',
'        <br />If you have developed a completely custom theme, then migrating to Universal Theme may require significant effort. Similarly, if you defined custom templates then you may find difficulties finding a similar template in the Universal The'
||'me. However, you may find using the new template options and theme roller will make many of your customizations redundant. If not, you will need to manually define custom templates and reapply your custom CSS and HTML post-migration.</p></li>',
'</ol>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(430899211618155803)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(431021834304724247)
,p_plug_name=>'Pros'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Universal Theme has a number of new features, improvements, and optimizations when compared to themes provided with previous releases of Application Express.  Additionally, Universal Theme utilizes several key UI features of Application Express 5 '
||'and provides a number of new Templates and Template Options that greatly expand the customizability of your application''s UI.</p>',
'',
'<p>Universal Theme provides improvements in almost every facet of defining the User Interface of your applications, and there a number of reasons why it is important to migrate to it immediately.  However, you must first understand your users and see'
||' whether a drastic change in User Interface is appropriate.</p>',
'<p>',
'Below is a quick fact-by-fact look at the many reasons for why you should migrate, and the few reasons why you may not want to migrate to Universal Theme.</p>',
'',
'<h3>Improvements</h3>',
'<ol>',
'<li><strong>Cleaner Templates</strong>',
'<p>Universal Theme has fewer, but more capable templates which can be customized with Template Options. It is quicker and easier to modify the presentation by changing Template Options, rather than by having to select a new template. Template Options'
||' allow for additional visual flourishes and, in some cases, new functionality.',
'<img src="#THEME_IMAGES#demo/img/Image_0.png" /></p></li>',
'',
'<li><strong>Improved Grid Support and Responsive Behavior</strong>',
'<p>',
'Theme 25 introduced Grid Layout support in APEX 4.2, but used a fixed grid which was not easily customizable. Universal Theme introduces a flexible, fluid grid system which can be nested many times over, and is based off the Bootstrap grid.<img src="'
||'#THEME_IMAGES#demo/img/Image_1.png" />',
'</p></li>',
'',
'<li><strong>Mobile Ready</strong>',
'',
'<p>Because of Universal Theme''s improved grid support, applications are responsive out-of-the-box. Therefore, they run well on any mobile device running a modern browser. For example, you will notice that tapping is significantly sped up (no delay in'
||' clicking) in Universal Theme apps compared with legacy ones. </p></li>',
'',
'<li><strong>Future-proofing</strong>',
'',
'<p>While legacy and older themes are supported in APEX 5, Universal Theme is the primary theme. With future releases of Application Express you will be be able to readily upgrade the Universal Theme to take advantages of the new functionality provide'
||'d. Migrating to Universal Theme is a simple means of ensuring your apps provide the most modern and up-to-date user experience for your users.</p></li>',
'</ol>',
'',
'<h3>New Features</h3>',
'<ol>',
'<li><strong>Theme Roller</strong>',
'<p>Older themes required you to to stick with one color and one set of styling. The only means of having your own styling was to override the defaults with CSS or switch to a new theme entirely. Universal Theme addresses this pain point by allowing y'
||'ou to quickly generate a new style for your app, using a GUI.',
'<div class=''two-images-one-row''><img src="#THEME_IMAGES#demo/img/Image_2.png" /><img src="#THEME_IMAGES#demo/img/Image_3.png" /></div>',
'</p></li>',
'',
'<li><strong>Navigation Lists</strong>',
'<p>In Universal theme, you now have the choice between using a top or side navigation menu. Older themes only supported tabs, which always consumed vertical screen real estate. Placing the menu on the side, and allowing it to be collapdsed, works bet'
||'ter for most applications, especially when displayed on widescreen monitors.',
'<img src="#THEME_IMAGES#demo/img/Image_4.png" />',
'</p></li>',
'',
'<li><strong>New UI Components</strong>',
'<p>Universal Theme has built-in templates for a variety of common UI components which are not available in other themes. For example, there are templates for easily creating carousels, tabs, menus, cards, and much more.',
'<img src="#THEME_IMAGES#demo/img/Image_5.png" />',
'</p></li>',
'',
'<li><strong>Maximize/Restore</strong>',
'',
'<p>Universal Theme enables Interactive Reports, Classic Reports, and Standard Regions to be "maximized". With the maximize button template option enabled, end users can now focus on a single region, and scroll through large amounts of data without se'
||'eing other content on the page. This makes it far easier for end users to review these large regions which are often very wide and long. Older themes do not have support for this feature.',
'<img src="#THEME_IMAGES#demo/img/Image_6.png" />',
'</p></li>',
'</ol>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(431025302387724258)
,p_plug_name=>'Introduction'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This guide shows how to convert to the Universal Theme in Application Express 5. It covers:</p>',
'',
'<ul>',
'    <li>The Pro and Cons of Universal Theme</li>',
'    <li>Migration Steps (Theme Switch Wizard)</li>',
'    <li>Post-migration</li>',
'    <li>Best practices</li>',
'    <li>Common problems and solutions</li>',
'</ul>',
'',
'<p>Please note that this guide assumes you have a working knowledge of Application Express fundamentals.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(431025822045724260)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
end;
/
prompt --application/pages/page_02020
begin
wwv_flow_api.create_page(
 p_id=>2020
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Migration Steps'
,p_alias=>'MIGRATION-STEPS'
,p_step_title=>'Migration Steps - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(431032219555845082)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(435209143871906456)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(435212071162916095)
,p_plug_name=>'Before Migration'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_grid_column_css_classes=>'how-to'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>It is <strong>strongly</strong> recommended to take an export of your application before beginning the migration process.</p>',
'',
'<p>This will enable you to easily revert back to the original application if necessary, before making any changes to your application and its metadata.<br />',
'Once you have migrated to the Universal Theme, you can not easily switch it back to the original legacy theme.<br />',
'Additionally, if you re-import the original application, under a different Application ID, you can refer to this application to review how the application looked previously, as opposed to how it looks using the Universal Theme.</p>',
'',
'<p>If you haven''t done so already, you should:</p>',
'',
'<p>Use the Application Utilities > Upgrade Application to update certain built-in widgets in your legacy applications to the latest provided by APEX 5, e.g. FlashChart to AnyChart.</p>',
'',
'<p>This will ensure that those widgets take full advantage of the responsiveness of Universal Theme.</p>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(435212405485917038)
,p_plug_name=>'Creating the Theme'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To create Universal Theme in your application, go to Shared Components, click on Themes and follow the steps below:</p>',
'<p class="dm-Hero-steps"><strong>Note:</strong> If you have already installed the Universal Theme into your application, proceed to the Second Step: <em>Switch to Universal Theme</em>.</p>',
'<ol>',
'  <li><p>Click <strong>Create Theme</strong></p><p>You need to install the Universal Theme into your application to get started.</p>',
'  <p><img src="#THEME_IMAGES#demo/img/Image_7.png" /></p></li>',
'  <li><p>Select <strong>From the Repository.</strong></p>',
'  <p><img src="#THEME_IMAGES#demo/img/Image_8.png" /></p></li>',
'  <li><p>Select <strong>Desktop</strong> as the User Interface.</p>',
'  <p><img src="#THEME_IMAGES#demo/img/Image_9.png" /></p></li>',
'  <li><p>Choose <strong>Standard Themes</strong> as the Theme Type, and <strong>Universal Theme (Theme 42)</strong> as the Theme. </p>',
'  <p> <img src="#THEME_IMAGES#demo/img/Image_10.png" /></p></li>',
'  <li><p>Review your changes and click <strong>Create</strong>.</p>',
'  <p><img src="#THEME_IMAGES#demo/img/Image_11.png" /></p></li>',
'</ol>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(435212850907917862)
,p_plug_name=>'Switching the Theme'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p class="dm-Hero-steps"><strong>Note:</strong> Not until you have completed Step 4 below will your application be irreversibly changed. Reverting back to a Tab-based application will be very difficult, which is why it is strongly recommended you hav'
||'e a backup of the application before proceeding further.</p>',
'<ol>',
'  <li><p>Click <strong>Switch Theme</strong></p>',
'  <p><img src="#THEME_IMAGES#demo/img/Image_12.png" /></p></li>',
'  <li><p>Select the current desktop theme, and then select <strong>42. Universal Theme</strong>.',
'    <br />Depending on your application, you may choose to set the <strong>Reset Grid</strong> option to either <strong>Reset fixed region positions</strong> or <strong>Reset all region and item grid positions</strong>.',
'    <br />Reset fixed region positions will maintain your current region positions, where possible, during migration. <em>This is the recommended approach</em>.',
'    <br />Reset all region and item grid positions will ensure item and region positioning will be reset and will force regions and items to stack on top of each other.',
'    <br />Make sure that <strong>Map Template Classes</strong> is set to <strong>No</strong>',
'  <br />Press <strong>Next</strong> to continue.</p>',
'  <p><img src="#THEME_IMAGES#demo/img/Image_13.png" /></p></li>',
'  <li><p>Verify that<strong> </strong>the mappings for your templates and Universal Theme templates are correct.',
'    <br />Use the <a href="f?p=&APP_ID.:2040:&SESSION."><strong>Universal Theme Migration Bookmarklet</strong></a> to automatically assign the right mapping, or check out the full mapping guide located at the end of this guide.',
'    <br />Most of the inconsistencies will be from new templates that Universal theme provides.',
'  <br />Try to choose the template that best matches your existing template. You may want to browse the components in the Universal Theme Sample Application to get a sense of the new templates and their various configurations. </p>',
'  <p><img src="#THEME_IMAGES#demo/img/Image_14.png" /></p></li>',
'  <li><p>Click <strong>Switch Theme</strong>.</p>',
'  <p> <img src="#THEME_IMAGES#demo/img/Image_15.png" /></p></li>',
'</ol>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_02030
begin
wwv_flow_api.create_page(
 p_id=>2030
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Post Migration'
,p_alias=>'POST-MIGRATION'
,p_step_title=>'Post Migration - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(431032219555845082)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(435220508486129008)
,p_plug_name=>'Post Migration'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Unlike the previous steps, the following tasks do not have to be completed in any particular order.',
'<br />Instead, it is advised that you carry them out before making new enhancements to your application, to ensure that any issues relating to the migration are not complicated by changes in functionality.</p>',
'<ol>',
'  <li>',
'    <p>While it is not necessary to remove your older theme for your freshly migrated app to work, your older theme no longer serves any functional purpose.',
'    <br />If you haven''t created any custom templates in your older theme (which you''d want to copy over), or if you don''t need to keep the older theme for reference, consider deleting the older theme.</p>',
'  </li>',
'  <li>',
'    <p>Ensure that the list items for <strong>Navigation Menu</strong> are correct, and that the <em>Current For</em> attributes are properly set.',
'    <br />Your tabs will be converted into a list format. If the current for attributes are not set correctly, the navigation links will not be selected when you navigate to each of the pages. </p>',
'    <p><img src="#THEME_IMAGES#demo/img/Image_16.png"/></p>',
'  </li>',
'  <li>',
'    <p>Decide if you want to stick with <strong>Side Navigation</strong> or change to the <strong>Top Menu </strong>as the application''s primary means of navigation.</p>',
'    <p>If you choose to stick with side navigation, it is recommended to select <em>Navigation Icons</em> for each menu entry, otherwise each page will have the same default page icon.',
'      <br />By going to Shared Components > Navigation Menu > List Entry, you can choose from a variety of pre-built icons, allowing you to choose the best match for each page type.',
'    <br />Please note that these icons will only appear if you are using side navigagtion.</p>',
'    <p>To change to <strong>Top Menu</strong> you will need to navigate to Shared Component > User Interface Attributes > Edit Universal Theme. Then change <strong>Position</strong> to <em>Top</em> and <strong>List Template</strong> to <em>Top Menu N'
||'avigation</em>, and then apply changes.</p>',
'    <p><img src="#THEME_IMAGES#demo/img/Image_17.png"/></p>',
'  </li>',
'  <li>',
'    <p><img src="#THEME_IMAGES#demo/img/Image_18.png"/></p>',
'  </li>',
'</ol>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(435221066689129009)
,p_plug_name=>'Best Practices'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>While most migrations will be relatively painless, there is no set path for how dealing with issues arise as a result of this change. Consider the following pointers for how to exhaustively find and resolve such problems in your new Universal Them'
||'e Application.</p>',
'<ol>',
'  <li><p><strong>Visually review the migrated application.</strong><br />',
'    - Run each page of your application, or at least a good cross section of different pages to make sure that there are no obvious display issues.<br />',
'    - If you have installed your original application under a different Application Id, perform side-by-side comparisons on a wide selection of pages, to ensure different page elements, such as buttons, and the overall page layout are not too diverge'
||'nt.</p>',
'  </li>',
'  <li><p><strong>Check non-standard components.</strong><br />',
'    - Be sure to check any pages where you implemented your own JavaScript to ensure the page still operates correctly. Many of the default class names for elements were changed, and some of the inline scripts that you have augmented your pages with '
||'may no longer be needed. <br />',
'    - Review any pages or templates where you have added any CSS libraries. If necessary, reapply the CSS libraries into the migrated application.<br />',
'    - Review all plug-ins used throughout your application to ensure they are still functioning correctly. Some plug-ins from third parties may not work correctly with Application Express 5. If so, you may need to remove the plug-in or search for an '
||'APEX 5.0 compatible plug-in.</p>',
'  </li>',
'  <li><p><strong>Ask your users to test your app.</strong><br />',
'    - After testing the application yourself, the next step is to ask your users to use the new migrated application to ensure they are comfortable with the new user interface, and can readily use the application.<br />',
'    - Determine from your end users if any end user training material or application documentation needs to be revised before releasing the new application into production.</p>',
'  </li>',
'</ol>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(435223507032129017)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(589350585091837147)
,p_plug_name=>'Post Debugging'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Once you have brought your application up to a "functional" state, you should consider a few more simple improvements you can readily make to your application, so that you can take full advantage of the new features in both Application Express 5 a'
||'nd Universal Theme. For example, you may want to prototype some different layout options, with a select group of users, to see if existing pages can be readily improved by simply changing some Template Options.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_02040
begin
wwv_flow_api.create_page(
 p_id=>2040
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Bookmarklet'
,p_alias=>'BOOKMARKLET'
,p_step_title=>'Bookmarklet - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(431032219555845082)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var current_url = window.location.href; ',
'var s = ''f'' + window.location.search;',
'var js_url = current_url.replace(s,'''') + ''#APP_IMAGES#bookmarklet.js'';',
'var href = ''javascript:(function(){(function(){if(window.apex.jQuery===undefined){alert("To use this bookmarklet, you need to, first, drag it into your bookmark bars and then click on it on page 386 of the theme switch wizard!");return;}apex.jQuery.g'
||'etScript("'' + js_url + ''").done(function(script,textStatus){console.log(textStatus);}).fail(function(jqxhr,settings,exception){});})();})();'';',
'document.getElementById(''codeOut'').href = href;'))
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(431043910495209539)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(431045291219212296)
,p_plug_name=>'Bookmarklet for Template Mapping'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>There is not always an equivalent template in Universal Theme for all templates from previous themes. For this reason, the APEX Development Team has created a bookmarklet to assist you with mapping your older templates to your newer templates in t'
||'he Verify Compatibility step of the Switch Theme wizard.</p>',
'<p>It supports mappings from the 3 most popular legacy themes, Theme 24, 25, and 26. It also supports any themes that are based off these legacy themes, i.e.: if your theme was based on one of those themes. When utilized then the bookmarklet will do '
||'most of the mappings correctly to produce the best results from the migration.</p>',
'<p class="dm-Hero-steps">Installation: <strong>Drag</strong> the link below into your bookmarks bar:</p>',
'',
'<div class="dm-bookmarklet">',
'<a id="codeOut" href=''javascript:(function(){(function(){if(window.apex.jQuery===undefined){alert("To use this bookmarklet, you need to, first, drag it into your bookmark bars and then click on it on page 386 of the theme switch wizard!");return;}ape'
||'x.jQuery.getScript("#APP_IMAGES#bookmarklet.js").done(function(script,textStatus){console.log(textStatus);}).fail(function(jqxhr,settings,exception){});})();})();''>Universal Theme Migration Helper V1.1</a>',
'<table class="u-Report">',
'    <thead>',
'        <tr>',
'            <th>',
'                Version',
'            </th>',
'            <th>',
'                Date',
'            </th>',
'            <th>',
'                Changes',
'            </th>',
'        </tr>',
'    </thead>',
'    <tbody>',
'        <tr>',
'            <td>',
'                1.1',
'            </td>',
'            <td>',
'                6/19/15',
'            </td>',
'            <td>',
'                Theme 21, 22, 23 support<br>Internet Explorer Support. <br> Auto Updating',
'            </td>',
'        </tr>',
'        <tr>',
'            <td>',
'                1.01',
'            </td>',
'            <td>',
'                5/13/15',
'            </td>',
'            <td>',
'                Firefox Support',
'            </td>',
'        </tr>',
'        <tr>',
'            <td>',
'                1.0',
'            </td>',
'            <td>',
'',
'            </td>',
'            <td>',
'                Initial Release',
'            </td>',
'        </tr>',
'    </tbody>',
'</table>',
'</div>',
'',
'<p class="dm-Hero-steps">Usage: On Switch Theme page, click on the bookmarklet to update the template mappings.</p>',
'<p><img src="#THEME_IMAGES#demo/img/Image_19.png" /></p>',
'<p>If the theme you are migrating from is supported, then it will automatically match the templates of your older theme to the correct templates in Universal Theme, highlighted in green.</p>',
'<p><img src="#THEME_IMAGES#demo/img/Image_20.png" /></p>',
'<p>Once the mapping process has completed, any errors you encounter will be displayed On an error page.<br />',
'  You can try clicking on the <strong>Map to a Different Theme</strong> button, to try re-mapping with an alternate theme available within the book marklet.<br />',
'If the expected mapping can not be found in the select list for that template, then it will be highlighted in orange.</p>',
'<p><img src="#THEME_IMAGES#demo/img/Image_21.png" /></p>',
'<p>Typically receiving any errors either means your custom templates did not strictly match the theme you chose,<br />',
'or that you have not set <strong>Match Template Classes</strong> to "<strong>No</strong>" in the previous step.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_02050
begin
wwv_flow_api.create_page(
 p_id=>2050
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'FAQ'
,p_alias=>'FAQ'
,p_step_title=>'FAQ - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(431032219555845082)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(430899352664155804)
,p_plug_name=>'After Upgrading'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ol>',
'  <li>',
'    <strong>Problem</strong>',
'    <p> When running my app on a certain page, I get the error message "Label column span grid setting for this page item is invalid."</p>',
'        <p><img src="#THEME_IMAGES#demo/img/Image_24.png" /></p>',
'    <strong>Solution</strong>',
'    <p> In this example, with a label column span of 3 plus each item''s column span of 1, all 4 together means that the content is 16 columns wide. This exceeds the 12 columns supported by the Universal Theme which results in this error being thrown '
||'before the page is rendered in your browser. To Fix: navigate to the page item specified in the error message in page designer or component view, and reduce the number of label column spans that your elements consume. </p>',
'  </li>',
'  <li>',
'    <strong>Problem</strong>',
'    <p>My content is no longer placed in multiple columns</p>',
'    <div class=''two-images-one-row''>',
'      <img src="#THEME_IMAGES#demo/img/Image_25.png" />',
'      <img src="#THEME_IMAGES#demo/img/Image_26.png" />',
'    </div>',
'    <strong>Solution</strong>',
'    <p>If you reset all the grid positions that your app previously used, then your content will be placed in one column after upgrading. To recreate the columned layout you had before, just drag the regions into new columns with Page Designer.</p>',
'    <img src="#THEME_IMAGES#demo/img/Image_27.png" />',
'    <p>You can also "fine-tune" the grid and column spans using the right side bar to get a layout that resembles your original theme.</p>',
'  </li>',
'  <li>',
'    <strong>Problem</strong>',
'    <p> My navigation bar is not a list </strong> </p>',
'    <img src="#THEME_IMAGES#demo/img/Image_29.png" />',
'    <strong> Solution </strong>',
'    <p> In order to add menus and have fine grain control of your Navigation Bar, i.e., your upper right hand corner links, it will need to be converted from the "Classic" implementation to a "List" based one. To do so, you must first create a new li'
||'st which contains entries such as your user name (&APP_USER.), a sign out link, and any other app-wide links you would like to have.',
'      Once this list is created, navigate to "Shared Components -> User Interface Attributes -> Edit Desktop -> Navigation Bar" and change the Implementation from "Classic" to "List".  "Select the List you created earlier, and set List Template to Na'
||'vigation Bar". Your app will now be using a list-based navigation bar.',
'      <img src="#THEME_IMAGES#demo/img/Image_30.png" />',
'    With a list-based Navigation Bar, you can then add sub-entries which will appear in a drop down menu.</p>',
'  </li>',
'</ol>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(431271817557902926)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(431273412256908120)
,p_plug_name=>'When Upgrading'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ol>',
'  <li>',
'    <strong>Problem</strong>',
'    <p>Warning: You must have at least two themes installed to be able to switch. Please create a new theme and attempt this action again.</p>',
'    <p><img src="#THEME_IMAGES#demo/img/Image_22.png" /></p>',
'    <strong>Solution</strong>',
'    <p>Create the Universal Theme in your application, as outlined above, before trying to switch your theme. Please <u>start the guide from step #1.</u></p>',
'  </li>',
'  <li>',
'    <strong>Problem</strong>',
'    <p>This application cannot be converted to a theme using list-based navigation, as it uses two levels of tabs. Please update the application and set current tabs settings to use only one level of tabs prior to switching the theme. (Go to error)</'
||'p>',
'    <p><img src="#THEME_IMAGES#demo/img/Image_23.png" /></p>',
'    <strong>Solution</strong>',
'    <p> Because two-level tabs are not supported in Universal Theme, you must re-design your existing apps to use only one level of tabs, and then switch. If doing so proves too complicated, try deleting the parent tabs, conducting the theme switch, '
||'and then re-creating navigation using a navigation menu post. To delete the parent tabs, you must go to "Shared Components >  Tabs > Edit Tabs > Manage Parent Tabs " and click on each of the parent tabs to access the button to delete them.</p>',
'  </li>',
'</ol>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_02060
begin
wwv_flow_api.create_page(
 p_id=>2060
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Migrating from jQuery Mobile'
,p_alias=>'MIGRATING-FROM-JQUERY-MOBILE'
,p_step_title=>'Migrating from jQuery Mobile'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(431032219555845082)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(606904283719638637)
,p_plug_name=>'Mobile UI Patterns'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Here are a number of Mobile UI Patterns you can follow as you build your next mobile app.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(790512378531235910)
,p_plug_name=>'Mobile UI Patterns'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--scrollBody'
,p_component_template_options=>'t-MediaList--showIcons:u-colors'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(608043492397034627)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1693511225138594619)
,p_plug_name=>'Overview'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Here are a few tips and best practices for transitioning your applications from the jQuery Mobile user interface to the Universal Theme.  </p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1693511390727594620)
,p_plug_name=>'jQuery Mobile is no longer supported'
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--info:margin-bottom-lg'
,p_plug_template=>wwv_flow_api.id(591654834181983844)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Please note that jQuery Mobile applications are desupported.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1693511480697594621)
,p_plug_name=>'Responsive Design and Mobile UI Patterns'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Universal Theme is designed to be responsive, so it will look and feel great on any screen size device. However, the patterns you use for your application may change depending on the your use cases. Here are some commonly asked questions that may '
||'provide some guidance as you build your next app.</p>',
'',
'<ul class="dm-UL">',
'  <li>',
'      <p><strong>How can I migrate my jQuery Mobile app to Universal Theme?</strong><br />',
'      For most apps, perhaps the simplest solution may be to start with a blank slate using Universal Theme.  Identify the key flows of your mobile app, and then reimagine them using all the features and functionality of Universal Theme.  This may be'
||' the perfect opportunity to experiment with the capabilities of Universal Theme and how you can use them to build an incredible small screen experience.</p>',
'  </li>',
'  <li>',
'      <p><strong>Should I build a separate app for mobile and desktop?</strong><br />',
'      This may be unnecessary for most cases. Unless your app will be primarily used on small screen devices, it may be better to optimize the UI of your app for the mobile use case rather than creating a separate app.  However, if you have a very sp'
||'ecific mobile use case, then by all means, build a separate app that is mobile-optimized and applies mobile UI patterns to provide a great small screen experience.</p>',
'  </li>',
'  <li>',
'      <p><strong>What are some things I should keep in mind as I develop my next mobile app?</strong><br />',
'      That''s a great question! First -- who are your users? What type of devices do they use? What is the primary usecase of your application? What is the setting in which your application is used? There are several things to consider before you writ'
||'e a single line of code. The more you understand your users and use cases, the more successful you will be with your APEX app.</p>',
'  </li>',
'</ul>',
'     '))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11053752011746459047)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_03000
begin
wwv_flow_api.create_page(
 p_id=>3000
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Components'
,p_alias=>'COMPONENTS'
,p_step_title=>'Components - &APP_TITLE.'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(558267481408623838)
,p_plug_name=>'Components'
,p_icon_css_classes=>'fa-lg fa-shapes u-color-15'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1224989219520090364)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(844155503380515516)
,p_plug_name=>'Component Types'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:u-colors:t-Cards--featured t-Cards--block force-fa-lg:t-Cards--displayIcons:t-Cards--4cols:t-Cards--hideBody:t-Cards--animColorFill'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(1725945334801719893)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_03100
begin
wwv_flow_api.create_page(
 p_id=>3100
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Card Templates'
,p_alias=>'CARD-TEMPLATES'
,p_step_title=>'Card Templates'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2063075723360416715)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-TabsRegion-mod--simple'
,p_plug_template=>wwv_flow_api.id(1774143203700285855)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2495651602672318768)
,p_plug_name=>'List Examples'
,p_parent_plug_id=>wwv_flow_api.id(2063075723360416715)
,p_icon_css_classes=>'fa-bars'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(385802524861148801)
,p_plug_name=>'1. Block'
,p_parent_plug_id=>wwv_flow_api.id(2495651602672318768)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3:margin-top-md'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(385802658263148802)
,p_plug_name=>'Cards List Template'
,p_parent_plug_id=>wwv_flow_api.id(385802524861148801)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:u-colors:t-Cards--displaySubtitle:t-Cards--featured t-Cards--block force-fa-lg:t-Cards--displayIcons:t-Cards--cols:t-Cards--desc-2ln:t-Cards--animColorFill'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>150
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(1905294320111585320)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(385802781884148803)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(385802524861148801)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>170
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2495696800400938254)
,p_plug_name=>'4. Compact'
,p_parent_plug_id=>wwv_flow_api.id(2495651602672318768)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2495697367994938254)
,p_plug_name=>'Cards List Template'
,p_parent_plug_id=>wwv_flow_api.id(2495696800400938254)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:u-colors:t-Cards--displaySubtitle:t-Cards--compact:t-Cards--displayIcons:t-Cards--cols:t-Cards--desc-2ln:t-Cards--animColorFill'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>200
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(1905294320111585320)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2495697852826938255)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(2495696800400938254)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>210
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2495698280309938255)
,p_plug_name=>'2. Featured'
,p_parent_plug_id=>wwv_flow_api.id(2495651602672318768)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3:margin-top-md'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2495698774572938256)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(2495698280309938255)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>160
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2495699358080938257)
,p_plug_name=>'Cards List Template'
,p_parent_plug_id=>wwv_flow_api.id(2495698280309938255)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:u-colors:t-Cards--displaySubtitle:t-Cards--featured force-fa-lg:t-Cards--displayIcons:t-Cards--cols:t-Cards--desc-2ln:t-Cards--animColorFill'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>140
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(1905294320111585320)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2495699792622938257)
,p_plug_name=>'3. Basic'
,p_parent_plug_id=>wwv_flow_api.id(2495651602672318768)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2495700284390938258)
,p_plug_name=>'Cards List Template'
,p_parent_plug_id=>wwv_flow_api.id(2495699792622938257)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:u-colors:t-Cards--displaySubtitle:t-Cards--basic:t-Cards--displayInitials:t-Cards--cols:t-Cards--desc-2ln:t-Cards--animColorFill'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>170
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(1905294320111585320)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1437740873962425604)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2495700814341938258)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(2495699792622938257)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>180
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2505913900974944152)
,p_plug_name=>'Report Examples'
,p_parent_plug_id=>wwv_flow_api.id(2063075723360416715)
,p_icon_css_classes=>'fa-table'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(385802812042148804)
,p_plug_name=>'1. Block'
,p_parent_plug_id=>wwv_flow_api.id(2505913900974944152)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3:margin-top-md'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(385802997358148805)
,p_name=>'Cards Report Template'
,p_parent_plug_id=>wwv_flow_api.id(385802812042148804)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>250
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:u-colors:t-Cards--featured t-Cards--block force-fa-lg:t-Cards--displayIcons:t-Cards--cols:t-Cards--animColorFill'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  project card_title,',
'  upper(substr(project,0,2)) card_initials,',
'  null card_text,',
'  null card_subtext,',
'  ''fa-cloud'' card_icon, ',
'  lower(created_by) created_by,',
'  created,',
'  lower(updated_by) updated_by,',
'  updated',
'from eba_UT_chart_projects',
'order by 2'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1525953837592492828)
,p_query_num_rows=>4
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(385803015069148806)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(385803152190148807)
,p_query_column_id=>2
,p_column_alias=>'CARD_TITLE'
,p_column_display_sequence=>2
,p_column_heading=>'Card title'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(385803236074148808)
,p_query_column_id=>3
,p_column_alias=>'CARD_INITIALS'
,p_column_display_sequence=>3
,p_column_heading=>'Card initials'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(385803306960148809)
,p_query_column_id=>4
,p_column_alias=>'CARD_TEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Card text'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'Created by #CREATED_BY# (#CREATED#)'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(385803412943148810)
,p_query_column_id=>5
,p_column_alias=>'CARD_SUBTEXT'
,p_column_display_sequence=>5
,p_column_heading=>'Card subtext'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'Updated #UPDATED#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(385803926256148815)
,p_query_column_id=>6
,p_column_alias=>'CARD_ICON'
,p_column_display_sequence=>10
,p_column_heading=>'Card Icon'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(385803561106148811)
,p_query_column_id=>7
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(385803654418148812)
,p_query_column_id=>8
,p_column_alias=>'CREATED'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(385803752208148813)
,p_query_column_id=>9
,p_column_alias=>'UPDATED_BY'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(385803811142148814)
,p_query_column_id=>10
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>9
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(385804098790148816)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(385802812042148804)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>270
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2505930530861961097)
,p_plug_name=>'2. Featured'
,p_parent_plug_id=>wwv_flow_api.id(2505913900974944152)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3:margin-top-md'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2505931011319961098)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(2505930530861961097)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>260
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2505931576763961099)
,p_name=>'Cards Report Template'
,p_parent_plug_id=>wwv_flow_api.id(2505930530861961097)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>240
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:u-colors:t-Cards--featured force-fa-lg:t-Cards--displayIcons:t-Cards--cols:t-Cards--animColorFill'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  project card_title,',
'  upper(substr(project,0,2)) card_initials,',
'  null card_text,',
'  null card_subtext,',
'  ''fa-cloud'' card_icon, ',
'  created_by,',
'  created,',
'  updated_by,',
'  updated',
'from eba_UT_chart_projects',
'order by 2'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1525953837592492828)
,p_query_num_rows=>4
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089759493642286766)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089759898649286766)
,p_query_column_id=>2
,p_column_alias=>'CARD_TITLE'
,p_column_display_sequence=>2
,p_column_heading=>'Card title'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089760233431286766)
,p_query_column_id=>3
,p_column_alias=>'CARD_INITIALS'
,p_column_display_sequence=>3
,p_column_heading=>'Card initials'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089760657948286767)
,p_query_column_id=>4
,p_column_alias=>'CARD_TEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Card text'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'Created by #CREATED_BY# (#CREATED#)'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089761099185286767)
,p_query_column_id=>5
,p_column_alias=>'CARD_SUBTEXT'
,p_column_display_sequence=>5
,p_column_heading=>'Card subtext'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'Updated #UPDATED#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(305881685581471942)
,p_query_column_id=>6
,p_column_alias=>'CARD_ICON'
,p_column_display_sequence=>10
,p_column_heading=>'Card Icon'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089761422314286768)
,p_query_column_id=>7
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089761883273286768)
,p_query_column_id=>8
,p_column_alias=>'CREATED'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089762241702286769)
,p_query_column_id=>9
,p_column_alias=>'UPDATED_BY'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089759094495286765)
,p_query_column_id=>10
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>9
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2505935611153961104)
,p_plug_name=>'3. Basic'
,p_parent_plug_id=>wwv_flow_api.id(2505913900974944152)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2505936184123961105)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(2505935611153961104)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2505936634835961105)
,p_name=>'Cards Report Template'
,p_parent_plug_id=>wwv_flow_api.id(2505935611153961104)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-Cards--basic:t-Cards--displayInitials:t-Cards--cols:u-colors'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  project card_title,',
'  upper(substr(project,0,2)) card_initials,',
'  null card_text,',
'  null card_subtext,',
'  created_by,',
'  created,',
'  updated_by,',
'  updated',
'from eba_UT_chart_projects',
'order by 2'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1525953837592492828)
,p_query_num_rows=>4
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089763553737286772)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>9
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089763928898286772)
,p_query_column_id=>2
,p_column_alias=>'CARD_TITLE'
,p_column_display_sequence=>1
,p_column_heading=>'Card title'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089764354238286772)
,p_query_column_id=>3
,p_column_alias=>'CARD_INITIALS'
,p_column_display_sequence=>2
,p_column_heading=>'Card initials'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089764736548286773)
,p_query_column_id=>4
,p_column_alias=>'CARD_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Card text'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'Created by #CREATED_BY# (#CREATED#)'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089765113228286773)
,p_query_column_id=>5
,p_column_alias=>'CARD_SUBTEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Card subtext'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'Updated #UPDATED#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089765545186286775)
,p_query_column_id=>6
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>5
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089765952900286775)
,p_query_column_id=>7
,p_column_alias=>'CREATED'
,p_column_display_sequence=>6
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089766342988286776)
,p_query_column_id=>8
,p_column_alias=>'UPDATED_BY'
,p_column_display_sequence=>7
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089766723623286776)
,p_query_column_id=>9
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>8
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2505940730351961109)
,p_plug_name=>'4. Compact'
,p_parent_plug_id=>wwv_flow_api.id(2505913900974944152)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2505941187886961110)
,p_plug_name=>'Demo How To'
,p_parent_plug_id=>wwv_flow_api.id(2505940730351961109)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HOW_TO_INSTRUCTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2505941777178961110)
,p_name=>'Cards Report Template'
,p_parent_plug_id=>wwv_flow_api.id(2505940730351961109)
,p_template=>wwv_flow_api.id(3052412050530173647)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:t-Cards--compact:u-colors:t-Cards--displayInitials:t-Cards--cols'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  project card_title,',
'  upper(substr(project,0,2)) card_initials,',
'  null card_text,',
'  null card_subtext,',
'  created_by,',
'  created,',
'  updated_by,',
'  updated',
'from eba_UT_chart_projects',
'order by 2'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1525953837592492828)
,p_query_num_rows=>4
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089768068810286778)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>9
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089768414937286779)
,p_query_column_id=>2
,p_column_alias=>'CARD_TITLE'
,p_column_display_sequence=>1
,p_column_heading=>'Card title'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089768872930286779)
,p_query_column_id=>3
,p_column_alias=>'CARD_INITIALS'
,p_column_display_sequence=>2
,p_column_heading=>'Card initials'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089769206879286780)
,p_query_column_id=>4
,p_column_alias=>'CARD_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Card text'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'Created by #CREATED_BY# (#CREATED#)'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089769660729286780)
,p_query_column_id=>5
,p_column_alias=>'CARD_SUBTEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Card subtext'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'Updated #UPDATED#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089770030339286781)
,p_query_column_id=>6
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>5
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089770439186286781)
,p_query_column_id=>7
,p_column_alias=>'CREATED'
,p_column_display_sequence=>6
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089770809601286781)
,p_query_column_id=>8
,p_column_alias=>'UPDATED_BY'
,p_column_display_sequence=>7
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2089771294358286782)
,p_query_column_id=>9
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>8
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2152191525616275404)
,p_plug_name=>'List Template Customization'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2152191494733275403)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(2152191525616275404)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'LIST'
,p_attribute_04=>'Cards'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2495695956478938253)
,p_plug_name=>'Custom Attributes'
,p_parent_plug_id=>wwv_flow_api.id(2152191525616275404)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3:t-ContentBlock--lightBG'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl class="t-AVPList  t-AVPList--leftAligned">',
'  <dt class="t-AVPList-label">#A01#</dt><dd class="t-AVPList-value">Description</dd>',
'  <dt class="t-AVPList-label">#A02#</dt><dd class="t-AVPList-value">Secondary Information</dd>',
'  <dt class="t-AVPList-label">#A03#</dt><dd class="t-AVPList-value">Initials</dd>',
'  <dt class="t-AVPList-label">#A04#</dt><dd class="t-AVPList-value">List Item CSS Classes</dd>',
'  <dt class="t-AVPList-label">#A05#</dt><dd class="t-AVPList-value">Link Attributes</dd>',
'  <dt class="t-AVPList-label">#A06#</dt><dd class="t-AVPList-value">Card Color Class</dd>',
'  <dt class="t-AVPList-label">#A07#</dt><dd class="t-AVPList-value">Subtitle</dd>',
'</dl>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2152191687654275405)
,p_plug_name=>'Report Template Customization'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(340247393517216329)
,p_plug_name=>'Substitution Strings'
,p_parent_plug_id=>wwv_flow_api.id(2152191687654275405)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3:t-ContentBlock--lightBG'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl class="t-AVPList  t-AVPList--leftAligned">',
'  <dt class="t-AVPList-label">#CARD_MODIFIERS#</dt><dd class="t-AVPList-value">Card CSS Class</dd>',
'  <dt class="t-AVPList-label">#CARD_COLOR#</dt><dd class="t-AVPList-value">Card Color Class</dd>',
'  <dt class="t-AVPList-label">#CARD_ICON#</dt><dd class="t-AVPList-value">Icon</dd>',
'  <dt class="t-AVPList-label">#CARD_INITIALS#</dt><dd class="t-AVPList-value">Initials</dd>',
'  <dt class="t-AVPList-label">#CARD_TITLE#</dt><dd class="t-AVPList-value">Title</dd>',
'  <dt class="t-AVPList-label">#CARD_LINK#</dt><dd class="t-AVPList-value">Link</dd>',
'  <dt class="t-AVPList-label">#CARD_SUBTITLE#</dt><dd class="t-AVPList-value">Subtitle</dd>',
'  <dt class="t-AVPList-label">#CARD_TEXT#</dt><dd class="t-AVPList-value">Description text</dd>',
'  <dt class="t-AVPList-label">#CARD_SUBTEXT#</dt><dd class="t-AVPList-value">Secondary description text</dd>',
'</dl>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2152191701186275406)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(2152191687654275405)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DISP_TEMPLATE_OPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'REPORT'
,p_attribute_05=>'Cards'
);
end;
/
begin
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3792202003307936264)
,p_plug_name=>'Sample Report Query'
,p_parent_plug_id=>wwv_flow_api.id(2152191687654275405)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre class="dm-Code lang-sql"><code>select',
'  -- data',
'  card_title,       -- title',
'  card_subtitle,    -- subtitle, set template option to see',
'  card_text,        -- card body text',
'  card_subtext,     -- card secondary text, positioned near bottom',
'',
'  -- ui and other attributes',
'  card_modifiers,   -- card item modifiers',
'  card_link,        -- card link, use apex_page.get_url(...)',
'  card_color,       -- color modifier, e.g. u-color-1 or u-warning',
'  card_icon,        -- icon class, e.g. fa-cloud',
'  card_initials     -- 2 or 3 letters, use apex_string.get_initials(...)',
'from dual</code></pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2505911908097944150)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2505912434627944151)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Cards are useful for presenting a variety of information in small blocks and can be heavily customized. They can be displayed in three styles, with icons or initials, and you can control the layout. With Universal Theme, you can style both <strong'
||'>Lists</strong> or <strong>Classic Reports</strong> regions to appear as cards by setting the appropriate template.</p>',
'<p class="dm-Hero-steps">For Classic Reports, set <strong>Cards</strong> as the Report Template.</p>',
'<p class="dm-Hero-steps">For Lists, set <strong>Cards</strong> as the List Template.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2505912922896944151)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2505913429895944152)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2505920661268944159)
,p_plug_name=>'Use Cases'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2089756800534286759)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2505912922896944151)
,p_button_name=>'TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Report Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:reports:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-table'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2089777720164292666)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(2505912922896944151)
,p_button_name=>'LIST_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'List Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6307:&SESSION.:lists:&DEBUG.:RP::'
,p_icon_css_classes=>'fa-bars'
);
end;
/
prompt --application/pages/page_03110
begin
wwv_flow_api.create_page(
 p_id=>3110
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Card Regions'
,p_alias=>'CARD-REGIONS'
,p_step_title=>'Card Regions'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>'.te_padding {padding: 8px 0px 8px 8px;}'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(761087834994584702)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3797453955494976146)
,p_plug_name=>'Pagination Demo'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3673175484831412991)
,p_plug_name=>'Conferences (Pagination)'
,p_parent_plug_id=>wwv_flow_api.id(3797453955494976146)
,p_region_template_options=>'#DEFAULT#:t-CardsRegion--styleC'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(623695900776932839)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       ID,',
'       CATEGORY,',
'       TITLE,',
'       SUBTITLE,',
'       BODY as agenda,',
'       SECONDARY_BODY as speakers,',
'       ICON_CLASS,',
'       BADGE,',
'       ''#APP_IMAGES#'' || IMAGE_URL as IMAGE,',
'       to_char(START_DATE, ''fmDDfm Month YYYY fmHHfm:MI PM'') || '' - '' || to_char(END_DATE, ''fmHHfm:MI PM'') as EVENT_DATE',
'  from EBA_UT_DEMO_CARDS',
' where CATEGORY = ''conference''',
'   and ID >= 4;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_CARDS'
,p_plug_query_num_rows=>2
,p_plug_query_num_rows_type=>'SET'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_show_total_row_count=>false
);
wwv_flow_api.create_card(
 p_id=>wwv_flow_api.id(761077786455584688)
,p_region_id=>wwv_flow_api.id(3673175484831412991)
,p_layout_type=>'GRID'
,p_grid_column_count=>2
,p_title_adv_formatting=>false
,p_title_column_name=>'TITLE'
,p_sub_title_adv_formatting=>false
,p_sub_title_column_name=>'SUBTITLE'
,p_body_adv_formatting=>false
,p_body_column_name=>'AGENDA'
,p_second_body_adv_formatting=>false
,p_second_body_column_name=>'EVENT_DATE'
,p_icon_source_type=>'DYNAMIC_CLASS'
,p_icon_class_column_name=>'ICON_CLASS'
,p_icon_css_classes=>'fa'
,p_icon_position=>'START'
,p_badge_column_name=>'BADGE'
,p_badge_label=>'Fee:'
,p_media_adv_formatting=>false
,p_media_source_type=>'STATIC_URL'
,p_media_url=>'&IMAGE.'
,p_media_display_position=>'BODY'
,p_media_sizing=>'COVER'
,p_media_description=>'&TITLE.'
,p_pk1_column_name=>'ID'
);
wwv_flow_api.create_card_action(
 p_id=>wwv_flow_api.id(761078245377584689)
,p_card_id=>wwv_flow_api.id(761077786455584688)
,p_action_type=>'BUTTON'
,p_position=>'PRIMARY'
,p_display_sequence=>10
,p_label=>'Details'
,p_link_target_type=>'REDIRECT_URL'
,p_link_target=>'#'
,p_button_display_type=>'TEXT'
,p_is_hot=>true
);
wwv_flow_api.create_card_action(
 p_id=>wwv_flow_api.id(761078822831584691)
,p_card_id=>wwv_flow_api.id(761077786455584688)
,p_action_type=>'BUTTON'
,p_position=>'SECONDARY'
,p_display_sequence=>20
,p_label=>'Favorite'
,p_link_target_type=>'REDIRECT_URL'
,p_link_target=>'#'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'fa-heart-o'
,p_is_hot=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3797455862345976165)
,p_plug_name=>'Pagination Demo Region Configuration'
,p_parent_plug_id=>wwv_flow_api.id(3797453955494976146)
,p_region_template_options=>'#DEFAULT#:is-collapsed:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(1215306280710140812)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h4>Region</h4>',
'<b>Type</b>: Cards<br>',
'<b>Grid Columns</b>: 2<br>',
'<b>Pagination</b>: enabled with 2 entries.<br>',
'<br>',
'<h4>Card Attributes</h4>',
'Top area has an <i>icon class, title, subtitle</i> and <i>badge</i> information.',
'Below the media is a paragraph as the <i>body</i> and a small timestamp as <i>secondary body</i>.<br>',
'<br>',
'<h4>Media</h4>',
'<b>Source</b>: Image URL<br>',
'<b>Position</b>: Body<br>',
'<b>Appearance</b>: Auto<br>',
'<b>Sizing</b>: Cover<br>',
'<br>',
'<h4>Actions</h4>',
'<ol>',
'<li>Button in Primary position that opens a modal page.</li>',
'<li>Button in Secondary position, only icon.</li>',
'</ol>',
'<br>',
'<h4>Live Template Options</h4>',
'<b>Style</b>: C'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3797454077822976147)
,p_plug_name=>'Backgrounds Demo'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3793143587242278342)
,p_plug_name=>'Conferences (Backgrounds)'
,p_parent_plug_id=>wwv_flow_api.id(3797454077822976147)
,p_region_template_options=>'#DEFAULT#:t-CardsRegion--styleA'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(623695900776932839)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       ID,',
'       CATEGORY,',
'       TITLE,',
'       SUBTITLE,',
'       BODY as agenda,',
'       SECONDARY_BODY as speakers,',
'       ICON_CLASS,',
'       BADGE,',
'       ''#APP_IMAGES#'' || IMAGE_URL as IMAGE,',
'       to_char(START_DATE, ''fmDDfm Month YYYY fmHHfm:MI PM'') as START_DATE,',
'       to_char(END_DATE, ''fmHHfm:MI PM'') as END_DATE',
'  from EBA_UT_DEMO_CARDS',
' where CATEGORY = ''conference''',
'   and ID < 4;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_CARDS'
,p_plug_query_num_rows_type=>'SCROLL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_show_total_row_count=>false
);
wwv_flow_api.create_card(
 p_id=>wwv_flow_api.id(761080365836584693)
,p_region_id=>wwv_flow_api.id(3793143587242278342)
,p_layout_type=>'GRID'
,p_grid_column_count=>3
,p_title_adv_formatting=>false
,p_title_column_name=>'TITLE'
,p_sub_title_adv_formatting=>false
,p_sub_title_column_name=>'SUBTITLE'
,p_body_adv_formatting=>false
,p_body_column_name=>'AGENDA'
,p_second_body_adv_formatting=>false
,p_icon_source_type=>'DYNAMIC_CLASS'
,p_icon_class_column_name=>'ICON_CLASS'
,p_icon_css_classes=>'fa'
,p_icon_position=>'START'
,p_badge_column_name=>'BADGE'
,p_badge_label=>'Fee:'
,p_media_adv_formatting=>false
,p_media_source_type=>'STATIC_URL'
,p_media_url=>'&IMAGE.'
,p_media_display_position=>'BACKGROUND'
,p_media_sizing=>'COVER'
,p_media_description=>'&TITLE.'
,p_pk1_column_name=>'ID'
);
wwv_flow_api.create_card_action(
 p_id=>wwv_flow_api.id(761080860688584693)
,p_card_id=>wwv_flow_api.id(761080365836584693)
,p_action_type=>'BUTTON'
,p_position=>'PRIMARY'
,p_display_sequence=>20
,p_label=>'Details'
,p_link_target_type=>'REDIRECT_URL'
,p_link_target=>'#'
,p_button_display_type=>'TEXT'
,p_is_hot=>true
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3797455971771976166)
,p_plug_name=>'Backgrounds Demo Region Configuration'
,p_parent_plug_id=>wwv_flow_api.id(3797454077822976147)
,p_region_template_options=>'#DEFAULT#:is-collapsed:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(1215306280710140812)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h4>Region</h4>',
'<b>Type</b>: Cards<br>',
'<b>Grid Columns</b>: 3<br>',
'<b>Pagination</b>: scroll (default)<br>',
'<br>',
'<h4>Card Attributes</h4>',
'Top area has an <i>icon class, title, subtitle</i> and <i>badge</i> information.',
'Media is set as background, on top is a paragraph as the <i>body</i> with no <i>secondary body</i>.<br>',
'<br>',
'<h4>Media</h4>',
'<b>Source</b>: Image URL<br>',
'<b>Position</b>: As Background Image<br>',
'<b>Appearance</b>: Auto<br>',
'<b>Sizing</b>: Cover<br>',
'<br>',
'<h4>Actions</h4>',
'<ol>',
'<li>Button in Primary position that opens a modal page.</li>',
'</ol>',
'<br>',
'<h4>Live Template Options</h4>',
'<b>Style</b>: A'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3797454413485976150)
,p_plug_name=>'Widescreen Image Demo'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3793143789858278344)
,p_plug_name=>'Workshops (Widescreen)'
,p_parent_plug_id=>wwv_flow_api.id(3797454413485976150)
,p_region_template_options=>'#DEFAULT#:t-CardsRegion--styleB'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(623695900776932839)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       ID,',
'       CATEGORY,',
'       TITLE,',
'       SUBTITLE,',
'       BODY as agenda,',
'       SECONDARY_BODY as speakers,',
'       ICON_CLASS,',
'       BADGE,',
'       ''#APP_IMAGES#'' || IMAGE_URL as IMAGE,',
'       to_char(START_DATE, ''fmDDfm Month YYYY fmHHfm:MI PM'') as START_DATE,',
'       to_char(END_DATE, ''fmHHfm:MI PM'') as END_DATE',
'  from EBA_UT_DEMO_CARDS',
' where CATEGORY = ''workshop''',
'   and ID < 10;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_CARDS'
,p_plug_query_num_rows_type=>'SCROLL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_show_total_row_count=>false
);
wwv_flow_api.create_card(
 p_id=>wwv_flow_api.id(761082396859584695)
,p_region_id=>wwv_flow_api.id(3793143789858278344)
,p_layout_type=>'GRID'
,p_grid_column_count=>3
,p_title_adv_formatting=>false
,p_title_column_name=>'TITLE'
,p_sub_title_adv_formatting=>false
,p_sub_title_column_name=>'SUBTITLE'
,p_body_adv_formatting=>false
,p_body_column_name=>'AGENDA'
,p_second_body_adv_formatting=>false
,p_icon_source_type=>'DYNAMIC_CLASS'
,p_icon_class_column_name=>'ICON_CLASS'
,p_icon_css_classes=>'fa'
,p_icon_position=>'START'
,p_badge_column_name=>'BADGE'
,p_badge_label=>'Fee:'
,p_media_adv_formatting=>false
,p_media_source_type=>'DYNAMIC_URL'
,p_media_url_column_name=>'IMAGE'
,p_media_display_position=>'FIRST'
,p_media_appearance=>'WIDESCREEN'
,p_media_sizing=>'COVER'
,p_media_description=>'&TITLE.'
,p_pk1_column_name=>'ID'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3797456262658976169)
,p_plug_name=>'Widescreen Image Demo Region Configuration'
,p_parent_plug_id=>wwv_flow_api.id(3797454413485976150)
,p_region_template_options=>'#DEFAULT#:is-collapsed:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(1215306280710140812)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h4>Region</h4>',
'<b>Type</b>: Cards<br>',
'<b>Grid Columns</b>: 3<br>',
'<b>Pagination</b>: scroll (default)<br>',
'<br>',
'<h4>Card Attributes</h4>',
'From top to bottom there is an <i>image, icon, title, subtitle, badge</i> and <i>body</i> information.<br>',
'<br>',
'<h4>Media</h4>',
'<b>Source</b>: URL Column<br>',
'<b>Position</b>: First<br>',
'<b>Appearance</b>: Widescreen<br>',
'<b>Sizing</b>: Cover<br>',
'<br>',
'<h4>Actions</h4>',
'<ol>',
'<li>Entire Card as a link.</li>',
'</ol>',
'<br>',
'<h4>Live Template Options</h4>',
'<b>Style</b>: B'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3797454607851976152)
,p_plug_name=>'Block Cards Demo'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3797453745916976144)
,p_plug_name=>'Workshops (Block Cards)'
,p_parent_plug_id=>wwv_flow_api.id(3797454607851976152)
,p_region_template_options=>'#DEFAULT#:t-CardsRegion--styleB'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(623695900776932839)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       ID,',
'       CATEGORY,',
'       TITLE,',
'       SUBTITLE,',
'       BODY as agenda,',
'       SECONDARY_BODY as speakers,',
'       ICON_CLASS,',
'       BADGE,',
'       ''#APP_IMAGES#'' || IMAGE_URL as IMAGE,',
'       to_char(START_DATE, ''fmDDfm Month YYYY fmHHfm:MI PM'') as START_DATE,',
'       to_char(END_DATE, ''fmHHfm:MI PM'') as END_DATE',
'  from EBA_UT_DEMO_CARDS',
' where CATEGORY = ''workshop''',
'   and ID >= 9;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_CARDS'
,p_plug_query_num_rows_type=>'SCROLL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_show_total_row_count=>false
);
wwv_flow_api.create_card(
 p_id=>wwv_flow_api.id(761083708837584696)
,p_region_id=>wwv_flow_api.id(3797453745916976144)
,p_layout_type=>'GRID'
,p_title_adv_formatting=>false
,p_title_column_name=>'TITLE'
,p_sub_title_adv_formatting=>false
,p_sub_title_column_name=>'SUBTITLE'
,p_body_adv_formatting=>false
,p_second_body_adv_formatting=>false
,p_icon_source_type=>'DYNAMIC_CLASS'
,p_icon_class_column_name=>'ICON_CLASS'
,p_icon_css_classes=>'fa'
,p_icon_position=>'TOP'
,p_media_adv_formatting=>false
,p_pk1_column_name=>'ID'
);
wwv_flow_api.create_card_action(
 p_id=>wwv_flow_api.id(761084204122584696)
,p_card_id=>wwv_flow_api.id(761083708837584696)
,p_action_type=>'FULL_CARD'
,p_display_sequence=>10
,p_link_target_type=>'REDIRECT_URL'
,p_link_target=>'#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3797456368486976170)
,p_plug_name=>'Block Cards Demo Region Configuration'
,p_parent_plug_id=>wwv_flow_api.id(3797454607851976152)
,p_region_template_options=>'#DEFAULT#:is-collapsed:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(1215306280710140812)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h4>Region</h4>',
'<b>Type</b>: Cards<br>',
'<b>Grid Columns</b>: Auto<br>',
'<b>Pagination</b>: scroll (default)<br>',
'<br>',
'<h4>Card Attributes</h4>',
'From top to bottom there is an <i>icon, title</i> and <i>subtitle</i>. No Media.<br>',
'<br>',
'<h4>Icon</h4>',
'<b>Source</b>: Icon Class Column<br>',
'<b>Position</b>: Top<br>',
'<br>',
'<h4>Actions</h4>',
'<ol>',
'<li>Entire Card as a link.</li>',
'</ol>',
'<br>',
'<h4>Live Template Options</h4>',
'<b>Style</b>: B',
'<b>Label Alignment</b>: Right'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3797455166430976158)
,p_plug_name=>'Badges Demo'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3797455415006976160)
,p_plug_name=>'Badges'
,p_parent_plug_id=>wwv_flow_api.id(3797455166430976158)
,p_region_template_options=>'#DEFAULT#:t-CardsRegion--styleB'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(623695900776932839)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       ID,',
'       CATEGORY,',
'       TITLE,',
'       SUBTITLE,',
'       BODY,',
'       SECONDARY_BODY,',
'       ICON_CLASS,',
'       BADGE,',
'       ''#APP_IMAGES#'' || IMAGE_URL as IMAGE,',
'       to_char(START_DATE, ''fmDDfm Month YYYY fmHHfm:MI PM'') as START_DATE,',
'       to_char(END_DATE, ''fmHHfm:MI PM'') as END_DATE',
'  from EBA_UT_DEMO_CARDS',
' where CATEGORY = ''badge'';'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_CARDS'
,p_plug_query_num_rows_type=>'SCROLL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_show_total_row_count=>false
);
wwv_flow_api.create_card(
 p_id=>wwv_flow_api.id(761085797278584698)
,p_region_id=>wwv_flow_api.id(3797455415006976160)
,p_layout_type=>'GRID'
,p_grid_column_count=>3
,p_title_adv_formatting=>false
,p_title_column_name=>'TITLE'
,p_sub_title_adv_formatting=>false
,p_sub_title_column_name=>'BODY'
,p_body_adv_formatting=>false
,p_body_column_name=>'SUBTITLE'
,p_second_body_adv_formatting=>false
,p_icon_source_type=>'URL'
,p_icon_image_url=>'&IMAGE.'
,p_icon_position=>'START'
,p_icon_description=>'&TITLE.'
,p_media_adv_formatting=>false
,p_pk1_column_name=>'ID'
);
wwv_flow_api.create_card_action(
 p_id=>wwv_flow_api.id(761086297896584698)
,p_card_id=>wwv_flow_api.id(761085797278584698)
,p_action_type=>'FULL_CARD'
,p_display_sequence=>10
,p_link_target_type=>'REDIRECT_URL'
,p_link_target=>'#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3797456056075976167)
,p_plug_name=>'Badges Demo Region Configuration'
,p_parent_plug_id=>wwv_flow_api.id(3797455166430976158)
,p_region_template_options=>'#DEFAULT#:is-collapsed:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(1215306280710140812)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h4>Region</h4>',
'<b>Type</b>: Cards<br>',
'<b>Grid Columns</b>: 3<br>',
'<b>Pagination</b>: scroll (default)<br>',
'<br>',
'<h4>Card Attributes</h4>',
'From top to bottom there is an <i>icon with image URL, title, subtitle</i> and <i>body</i> information.',
'Media is not set.<br>',
'<br>',
'<h4>Icon</h4>',
'<b>Source</b>: Image URL<br>',
'<b>Position</b>: Start<br>',
'<br>',
'<h4>Actions</h4>',
'<ol>',
'<li>Entire Card as a link.</li>',
'</ol>',
'<br>',
'<h4>Live Template Options</h4>',
'<b>Style</b>: B'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6277114526670879267)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Cards Regions are useful for presenting a variety of information in small blocks and can be heavily customized. They can be displayed in three styles, with icons or initials, images as part of the body or as the background, to enhance each card pr'
||'esentation and you can control the layout.<br><br>',
'Actions can be added to each card''s image, title, subtitle, as new buttons or even using the entire card to enhance user experience. This is an entirely <b>new region type</b>.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6277331922574234083)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7563618996717183449)
,p_plug_name=>'Sample Cards Query'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre class="dm-Code lang-sql te_padding"><code>select',
'  -- data',
'  card_primary_key,    -- primary key',
'  card_secondary_key,  -- secondary key if needed',
'  card_title,          -- title',
'  card_subtitle,       -- subtitle',
'  card_body,           -- card body text',
'  card_secondary_body, -- card secondary text, positioned near bottom',
'',
'  -- ui and other attributes',
'  card_icon,           -- icon class, e.g. fa-cloud',
'  card_badge,          -- badge, can be a small text',
'  card_image           -- image url, url or blob columns',
'from dual</code></pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_03400
begin
wwv_flow_api.create_page(
 p_id=>3400
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Data Tables and Reports'
,p_alias=>'DATA-TABLES-AND-REPORTS'
,p_step_title=>'Data Tables and Reports - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2152194682393275435)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2487457205748649855)
,p_plug_name=>'Report Types'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_component_template_options=>'#DEFAULT#:u-colors'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(2010946567680071816)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3921939815288375177)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>There are a number of ways you can report and display data using Application Express and Universal Theme.  Select an option below to learn more.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_03810
begin
wwv_flow_api.create_page(
 p_id=>3810
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Breadcrumb'
,p_alias=>'BREADCRUMB'
,p_step_title=>'Breadcrumb - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(405064482015020227)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1722816239735373050)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2015602676755607104)
,p_plug_name=>'Within a Blank Region'
,p_parent_plug_id=>wwv_flow_api.id(1722816239735373050)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--padded:t-ContentBlock--h3:t-ContentBlock--lightBG'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2015602472757607102)
,p_plug_name=>'Blank Region'
,p_parent_plug_id=>wwv_flow_api.id(2015602676755607104)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2015602749194607105)
,p_plug_name=>'Within the Title Bar Template'
,p_parent_plug_id=>wwv_flow_api.id(1722816239735373050)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3:t-ContentBlock--lightBG'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2015602344081607101)
,p_plug_name=>'Title Bar'
,p_parent_plug_id=>wwv_flow_api.id(2015602749194607105)
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3402630210197692879)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4446948850005072941)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A <strong>Breadcrumb</strong> is a hierarchical list of links that indicates where the user is within the application from a hierarchical perspective.  It is useful for providing navigational context to end users, and an easy way to navigate back '
||'to the home.  Within Universal Theme, the application breadcrumb has a special location for placement and should be used with the <a href="f?p=&APP_ID.:1207:&APP_SESSION.">Title Bar</a> region template in most cases.</p>',
'<p class="dm-Hero-steps">Set <strong>Breadcrumb</strong> as the Region type</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4446949166727071290)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2055996114853483259)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(3402630210197692879)
,p_button_name=>'REGION_TYPE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Region Type'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6308:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'fa-list'
);
end;
/
prompt --application/pages/page_04000
begin
wwv_flow_api.create_page(
 p_id=>4000
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Icons'
,p_alias=>'ICONS'
,p_step_title=>'Icons - &APP_TITLE.'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#THEME_IMAGES#demo/icons#MIN#.js',
'#THEME_IMAGES#demo/iconSearch#MIN#.js'))
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#P4000_SEARCH").on("keyup",function(){apex.theme42demo.renderIcons({debounce: 250, filterString: this.value});});',
'var returnIcon = function(c){return;};'))
,p_javascript_code_onload=>'apex.theme42demo.renderIcons({});'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.highlight {',
'    background-color: #ffef9a;',
'    color: #635c34;',
'    padding: 2px 0;',
'    box-shadow: 0 0 0 1px rgba(0, 0, 0, 0.05) inset, 0 1px 1px -1px rgba(0, 0, 0, 0.1);',
'    border-radius: 2px;',
'    transition: .1s ease;',
'}',
'.icon-list {',
'    max-height: 280px;',
'    overflow: auto;',
'    white-space: pre-line;',
'    font-family: monospace;',
'    padding: 8px;',
'    background: rgba(0,0,0,.1);',
'    border: 1px solid rgba(0,0,0,.1);',
'    border-radius: 4px;',
'}'))
,p_page_css_classes=>'dm-Page'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(349882396322259927)
,p_plug_name=>'Icons'
,p_region_name=>'icons'
,p_region_css_classes=>'dm-Search'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(349883229141259936)
,p_plug_name=>'Search'
,p_region_template_options=>'#DEFAULT#:margin-bottom-sm'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(349883301202259937)
,p_plug_name=>'Icon Builder Dialog'
,p_region_name=>'icon_dialog'
,p_region_css_classes=>'dm-IconDialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-autoheight:js-dialog-size720x480'
,p_plug_template=>wwv_flow_api.id(1223645131968329858)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(517887344069372819)
,p_plug_name=>'Icon Builder'
,p_parent_plug_id=>wwv_flow_api.id(349883301202259937)
,p_region_css_classes=>'dm-IconDialog-builder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(349884034203259944)
,p_plug_name=>'Icon Instructions'
,p_parent_plug_id=>wwv_flow_api.id(517887344069372819)
,p_region_css_classes=>'dm-IconDialog-infoWrap'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-IconDialog-info row">',
'    <span class="dm-IconDialog-infoTitle col col-3">HTML <button type="button" title="Copy HTML Markup" class="t-Button t-Button--icon t-Button--tiny t-Button--link t-Button--iconLeft" data-clipboard-source="#icon_code"><span aria-hidden="true" class'
||'="t-Icon t-Icon--left fa fa-synonym"></span>Copy</button></span>',
'    <div class="dm-IconDialog-infoBody col col-9">',
'        <code id="icon_code"></code>',
'    </div>',
'</div>',
'<div class="dm-IconDialog-info row">',
'    <span class="dm-IconDialog-infoTitle col col-3">Icon <button type="button" title="Copy Icon Class" class="t-Button t-Button--icon t-Button--tiny t-Button--link t-Button--iconLeft" data-clipboard-source="#icon_classes"><span aria-hidden="true" cla'
||'ss="t-Icon t-Icon--left fa fa-synonym"></span>Copy</button> </span>',
'    <div class="dm-IconDialog-infoBody col col-9">',
'        <code id="icon_classes"></code>',
'        <small>Enter in the Icon property for Buttons, Regions, and other components.</small>',
'    </div>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(517886366768372809)
,p_plug_name=>'Icon Form'
,p_parent_plug_id=>wwv_flow_api.id(517887344069372819)
,p_region_template_options=>'#DEFAULT#:t-Form--stretchInputs'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_grid_column_span=>6
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(517887286192372818)
,p_plug_name=>'Icon Preview'
,p_parent_plug_id=>wwv_flow_api.id(517887344069372819)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div id="icon_preview" class="dm-IconDialog-preview"><span></span></div>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(558385722004194470)
,p_plug_name=>'About Font APEX'
,p_region_name=>'about_font_apex'
,p_region_template_options=>'#DEFAULT#:js-dialog-autoheight:js-dialog-size600x400'
,p_plug_template=>wwv_flow_api.id(1223645131968329858)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h3>What is Font APEX?</h3>',
'<p>Font APEX is the icon library for Oracle APEX and Universal Theme.  It was originally designed as a replacement for Font Awesome 4.*, the web''s leading icon library, and therefore contains almost all of the Font Awesome icons, re-drawn originally '
||'on a 16x16 grid as line-icons.  We wanted to make it a seamless switch to go from Font Awesome to Font APEX, and therefore use the same "fa" prefix for the icons, making it easier than ever to move to entirely new icon library.</p>',
'',
'<p>Font APEX 2 expands upon the original Font APEX by providing the complete set of Font APEX icons at a larger size.  There are now two families of icons in Font APEX: small and large. Small icons are based on a 16x16 grid and ideally suited for but'
||'tons and menus. Large icons are based on a 32x32 grid and well suited for places where you need to provide a larger graphic, such as cards, media lists, and hero regions.</p>',
'',
'<p>Many APEX components will automatically use the large or small icons based on the context (such as Template Options), so all you need to do is focus on the icon you want.  For example, when using Cards, the Block and Featured template option will '
||'automatically show the larger versions of icons where the Basic and Compact template options will use icons from the smaller set.</p>',
'',
'<p>There are over 1200 icons in Font APEX, and there are 25 modifiers you can place on top of any existing icons so you can customize any icon to fit your needs.</p>',
'',
'<h3>Change Log</h3>',
'<p><b>Font APEX 2.2</b> was released as part of APEX 21.1 and includes 95 new icons for medical apps, map markers, and additional file types, as well as 16 updates to existing icons.  See full list below:</p>',
'<p><b>New Icons</b></p>',
'<div class="icon-list margin-bottom-md">fa-2d-mode',
'fa-3d-mode',
'fa-404',
'fa-4k',
'fa-abacus',
'fa-accessor-more',
'fa-accessor-one',
'fa-accordion',
'fa-alarm-check',
'fa-alarm-clock',
'fa-alarm-minus',
'fa-alarm-plus',
'fa-alarm-snooze',
'fa-alarm-times',
'fa-analytics',
'fa-badge',
'fa-badge-check',
'fa-badge-dollar',
'fa-badge-percent',
'fa-biohazard',
'fa-bug-slash',
'fa-file-brackets',
'fa-file-csv',
'fa-file-json',
'fa-file-medical',
'fa-file-prescription',
'fa-file-signature',
'fa-flag-pennant',
'fa-flag-pennant-o',
'fa-flag-swallowtail',
'fa-flag-swallowtail-o',
'fa-frown',
'fa-heat-map',
'fa-line-map',
'fa-location',
'fa-location-arrow-solid',
'fa-location-circle',
'fa-location-circle-solid',
'fa-location-slash',
'fa-map-marker-camera',
'fa-map-marker-camera-o',
'fa-map-marker-check',
'fa-map-marker-check-o',
'fa-map-marker-face-frown',
'fa-map-marker-face-frown-o',
'fa-map-marker-face-meh',
'fa-map-marker-face-meh-o',
'fa-map-marker-face-smile',
'fa-map-marker-face-smile-o',
'fa-map-marker-s',
'fa-map-marker-shine',
'fa-map-marker-shine-o',
'fa-map-marker-slash',
'fa-map-marker-slash-o',
'fa-map-markers',
'fa-map-markers-o',
'fa-map-pin-circle',
'fa-map-pin-circle-o',
'fa-map-pin-heart',
'fa-map-pin-heart-o',
'fa-map-pin-triangle',
'fa-map-pin-triangle-o',
'fa-medical-mask',
'fa-medication',
'fa-medication-pill',
'fa-medication-pill-bottle',
'fa-medication-pills',
'fa-meh',
'fa-nurse',
'fa-podium',
'fa-prescription',
'fa-prescription-sheet',
'fa-presentation',
'fa-radiation',
'fa-size-l',
'fa-size-m',
'fa-size-s',
'fa-size-xl',
'fa-size-xs',
'fa-size-xxl',
'fa-smile',
'fa-sort-amount-asc-alt',
'fa-sort-amount-desc-alt',
'fa-syringe',
'fa-tasks-alt',
'fa-text-color',
'fa-traffic-light',
'fa-traffic-light-go',
'fa-traffic-light-stop',
'fa-user-slash',
'fa-users-alt',
'fa-vial',
'fa-vials',
'fa-workflow',
'fa-x-ray</div>',
'',
'<p><b>Updated Icons</b></p>',
'<div class="icon-list">bug',
'crosshairs',
'frown-o',
'location-arrow',
'map-marker',
'meh-o',
'pause-circle',
'pause-circle-o',
'play-circle',
'play-circle-o',
'smile-o',
'sort-amount-asc',
'sort-amount-desc',
'stop-circle',
'stop-circle-o',
'user-md</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2880276168635562187)
,p_plug_name=>'Icons'
,p_icon_css_classes=>'fa-lg fa-apex u-color-9'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1224989219520090364)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(349883989532259943)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(517887286192372818)
,p_button_name=>'RESET_ICON'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--small:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Reset Icon'
,p_button_css_classes=>'dm-IconDialog-resetButton'
,p_icon_css_classes=>'fa-refresh'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1515421727652817013)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2880276168635562187)
,p_button_name=>'ABOUT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--noUI:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'About Font APEX'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'fa-info-circle'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(349882606928259930)
,p_name=>'P4000_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(349883229141259936)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Search Icons'
,p_placeholder=>'Search Font APEX Icons...'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_css_classes=>'t-Form-searchField'
,p_grid_label_column_span=>0
,p_field_template=>wwv_flow_api.id(591757292230152601)
,p_item_icon_css_classes=>'fa-search'
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--stretchInputs:t-Form-fieldContainer--xlarge'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(349883610605259940)
,p_name=>'P4000_ROTATE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(517886366768372809)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Rotate'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Rotate 90;fa-rotate-90,Rotate 180;fa-rotate-180,Rotate 270;fa-rotate-270,Flip Horizontal;fa-flip-horizontal,Flip Vertical;fa-flip-vertical'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Normal'
,p_cHeight=>1
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(385717579943249021)
,p_name=>'P4000_SIZE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(349883229141259936)
,p_item_default=>'SMALL'
,p_prompt=>'Size'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Small;SMALL,Large;LARGE'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_grid_label_column_span=>0
,p_field_template=>wwv_flow_api.id(591757292230152601)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--stretchInputs:t-Form-fieldContainer--xlarge:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(517886424106372810)
,p_name=>'P4000_ICON_SIZE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(517886366768372809)
,p_use_cache_before_default=>'NO'
,p_item_default=>'null'
,p_prompt=>'Scale'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC:1x;null,2x;fa-2x,3x;fa-3x,4x;fa-4x,5x;fa-5x'
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(517886530500372811)
,p_name=>'P4000_ANIMATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(517886366768372809)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Animation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FONT_ANIMATIONS'
,p_lov=>'.'||wwv_flow_api.id(562737530366047618)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Static'
,p_cHeight=>1
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(517887152483372817)
,p_name=>'P4000_ICONCLASS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(349883301202259937)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(756696232994321927)
,p_name=>'P4000_FA_SIZE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(517886366768372809)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Size'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Small;SMALL,Large;LARGE'
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(873486298805520035)
,p_name=>'P4000_MODIFIER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(517886366768372809)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Modifier'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'STATIC2:',
'25 Percent;fam-25-percent,',
'50 Percent;fam-50-percent,',
'75 Percent;fam-75-percent,',
'100 Percent;fam-100-percent,',
'Arrow Down;fam-arrow-down,',
'Arrow Left;fam-arrow-left,',
'Arrow Right;fam-arrow-right,',
'Arrow Up;fam-arrow-up,',
'Blank;fam-blank,',
'Check;fam-check,',
'Circle;fam-circle,',
'Clock;fam-clock,',
'Ellipsis H;fam-ellipsis-h,',
'Ellipsis V;fam-ellipsis-v,',
'Heart;fam-heart,',
'Information;fam-information,',
'Minus;fam-minus,',
'Pause;fam-pause,',
'Play;fam-play,',
'Plus;fam-plus,',
'Sleep;fam-sleep,',
'Star;fam-star,',
'Stop;fam-stop,',
'Warning;fam-warning,',
'X;fam-x'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_cHeight=>1
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(873486307070520036)
,p_name=>'P4000_MODIFIER_STATUS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(517886366768372809)
,p_use_cache_before_default=>'NO'
,p_item_default=>'fam-is-success'
,p_prompt=>'Status'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'STATIC2:',
'Success;fam-is-success,',
'Warning;fam-is-warning,',
'Danger;fam-is-danger,',
'Info;fam-is-info,',
'Disabled;fam-is-disabled'))
,p_cHeight=>1
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(349882921191259933)
,p_name=>'Cancel Enter'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4000_SEARCH'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.browserEvent.keyCode == 13'
,p_bind_type=>'bind'
,p_bind_event_type=>'keypress'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(349883091481259934)
,p_event_id=>wwv_flow_api.id(349882921191259933)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CANCEL_EVENT'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(349883416534259938)
,p_name=>'Show Icon Preview Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.dm-Search-result'
,p_bind_type=>'live'
,p_bind_delegate_to_selector=>'#icons'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(349883523325259939)
,p_event_id=>wwv_flow_api.id(349883416534259938)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var $j = apex.jQuery,',
'    iconClass = $j(this.triggeringElement).find(''.dm-Search-class'').text();',
'$s(''P4000_ICONCLASS'',iconClass);',
'$j("#icon_dialog").dialog({',
'    title: "Icon: " + iconClass',
'}).dialog("open");',
'apex.theme42demo.renderIconPreview();',
'$j(''#P4000_ICON_SIZE'').focus();'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(517886735740372813)
,p_name=>'Apply Modifier to Icon'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4000_ICON_SIZE,P4000_ANIMATION,P4000_ROTATE,P4000_MODIFIER,P4000_MODIFIER_STATUS'
,p_bind_type=>'live'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(517886876005372814)
,p_event_id=>wwv_flow_api.id(517886735740372813)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.theme42demo.renderIconPreview();'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(349884140544259945)
,p_name=>'Reset Icon Settings'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(349883989532259943)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(349884218574259946)
,p_event_id=>wwv_flow_api.id(349884140544259945)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4000_ANIMATION,P4000_ROTATE,P4000_MODIFIER'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(756697293099321937)
,p_event_id=>wwv_flow_api.id(349884140544259945)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$s(''P4000_ICON_SIZE'',''null'');',
'apex.theme42demo.renderIconPreview();'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(714379453470623418)
,p_name=>'Toggle Modifier Status'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4000_MODIFIER'
,p_condition_element=>'P4000_MODIFIER'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(714379568314623419)
,p_event_id=>wwv_flow_api.id(714379453470623418)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4000_MODIFIER_STATUS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(714379657356623420)
,p_event_id=>wwv_flow_api.id(714379453470623418)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4000_MODIFIER_STATUS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(714379708387623421)
,p_event_id=>wwv_flow_api.id(714379453470623418)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4000_MODIFIER_STATUS'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1515421837091817014)
,p_name=>'Open About Dialog'
,p_event_sequence=>80
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1515421727652817013)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1515421977380817015)
,p_event_id=>wwv_flow_api.id(1515421837091817014)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(558385722004194470)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(340246582941216321)
,p_name=>'Toggle Icon Size'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4000_SIZE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(340246691636216322)
,p_event_id=>wwv_flow_api.id(340246582941216321)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var size = $v(''P4000_SIZE''),',
'    icons$ = $( ''#icons'' ),',
'    L_CLASS = ''force-fa-lg'';',
'if ( size === ''LARGE'' ) {',
'    icons$.addClass( L_CLASS );',
'} else {',
'    icons$.removeClass( L_CLASS );',
'}'))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(756697066134321935)
,p_event_id=>wwv_flow_api.id(340246582941216321)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4000_FA_SIZE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v(''P4000_SIZE'');'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(756696358795321928)
,p_name=>'Set Icon Size'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4000_FA_SIZE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(756696456005321929)
,p_event_id=>wwv_flow_api.id(756696358795321928)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$s(''P4000_SIZE'',$v(''P4000_FA_SIZE''));',
'apex.theme42demo.renderIconPreview();',
''))
);
end;
/
prompt --application/pages/page_05000
begin
wwv_flow_api.create_page(
 p_id=>5000
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Design Patterns'
,p_alias=>'DESIGN-PATTERNS'
,p_step_title=>'Design Patterns - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
'.dm-Migration-region {',
'  max-width: 80%;',
'  margin: 0 auto;',
'}',
'.dm-Migration-region > h1 {',
'  margin-top: 16vh;',
'}',
'.dm-Migration-region > h2 {',
'  margin-top: 8vh;',
'}',
'.dm-Migration-region > h3 {',
'  margin-top: 4vh;',
'  font-size: 2.0rem;',
'}',
'.dm-Migration-region ul {',
'  margin: 0;',
'  padding: 0;',
'  list-style-type: decimal;',
'}',
'.dm-Migration-region li {',
'  margin-left: 24px;',
'  margin-bottom: 4vh;',
'}',
'iframe {',
'  border: 0px;',
'  margin: auto;',
'  display: block;',
'  height: 180px;',
'  width: 500px;',
'}',
'.t-Body img {',
'  max-width: 75%;',
'  clip: rect(0, 0, 100px, 0);',
'  margin: auto;',
'  display: block;',
'  border-radius: 2px;',
'}',
'.two-images-one-row {',
'  text-align: center;',
'}',
'.two-images-one-row img {',
'  max-width: 49%;',
'  display: inline-block;',
'  vertical-align: bottom;',
'}',
'blockquote {',
'  font-size: 1.8rem;',
'  line-height: 1.8rem;',
'}',
'',
'.bookmarklet-changelog {',
'    text-align:right; ',
'    font-size:.8em; ',
'    font-style:italic; ',
'    margin-top: -20px;',
'    width: 200px;',
'    margin: auto;',
'}',
'.bookmarklet-changelog b {',
'    float:left;',
'    display:inline-block;',
'}',
'*/'))
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1364857770132189237)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1481006885724224351)
,p_plug_name=>'More Info'
,p_region_css_classes=>'dm-Migration-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h1>More information</h1>',
'<p>If for whatever reason this guide fails in providing adequate assistance,  please reach out to us on the Oracle Technology Network (OTN) <a href="http://forums.oracle.com/forums/forum.jspa?forumID=137" target="_blank">discussion forum</a> or on Tw'
||'itter (<a href="https://twitter.com/hashtag/orclapex" target="_blank">#orclapex</a>). Any specific problem you have is likely to be encountered by others. Notifying us will help to improve this guide with additional information and facts relating to '
||'Universal Theme migration.</p>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1481011965822224358)
,p_plug_name=>'Why Migrate?'
,p_region_css_classes=>'dm-Migration-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_grid_column_span=>12
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h1>Why should I migrate to Universal Theme?</h1>',
'<p>Universal Theme has a number of new features, improvements, and optimizations when compared to themes provided with previous releases of Application Express.  Additionally, Universal Theme utilizes several key UI features of Application Express 5 '
||'and provides a number of new Templates and Template Options that greatly expand the customizability of your application''s UI.</p>',
'',
'<p>Universal Theme provides improvements in almost every facet of defining the User Interface of your applications, and there a number of reasons why it is important to migrate to it immediately.  However, you must first understand your users and see'
||' whether a drastic change in User Interface is appropriate.</p>',
'<p>',
'Below is a quick fact-by-fact look at the many reasons for why you should migrate, and the few reasons why you may not want to migrate to Universal Theme.</p>',
'',
'<h2>Pros</h2>',
'<h3>Improvements</h3>',
'<ul>',
'<li>Cleaner Templates',
'<p><img src="#THEME_IMAGES#demo/img/Image_0.png" /></p>',
'',
'<p>Universal Theme has fewer, but more capable templates which can be customized with Template Options. It is quicker and easier to modify the presentation by changing Template Options, rather than by having to select a new template. Template Options'
||' allow for additional visual flourishes and, in some cases, new functionality. </p></li>',
'',
'<li>Improved Grid Support and Responsive Behavior',
'<p><img src="#THEME_IMAGES#demo/img/Image_1.png" />',
'Theme 25 introduced Grid Layout support in APEX 4.2, but used a fixed grid which was not easily customizable. Universal Theme introduces a flexible, fluid grid system which can be nested many times over, and is based off the Bootstrap grid.</p></li>',
'',
'<li>Mobile Ready',
'',
'<p>Because of Universal Theme''s improved grid support, applications are responsive out-of-the-box. Therefore, they run well on any mobile device running a modern browser. For example, you will notice that tapping is significantly sped up (no delay in'
||' clicking) in Universal Theme apps compared with legacy ones. </p></li>',
'',
'<li>Future-proofing',
'',
'<p>While legacy and older themes are supported in APEX 5, Universal Theme is the primary theme. With future releases of Application Express you will be be able to readily upgrade the Universal Theme to take advantages of the new functionality provide'
||'d. Migrating to Universal Theme is a simple means of ensuring your apps provide the most modern and up-to-date user experience for your users.</p></li>',
'</ul>',
'<h3>New Features</h3>',
'<ul>',
'<li>Theme Roller',
'',
'<div class=''two-images-one-row''><img src="#THEME_IMAGES#demo/img/Image_2.png" /><img src="#THEME_IMAGES#demo/img/Image_3.png" /></div>',
'',
'',
'<p>Older themes required you to to stick with one color and one set of styling. The only means of having your own styling was to override the defaults with CSS or switch to a new theme entirely. Universal Theme addresses this pain point by allowing y'
||'ou to quickly generate a new style for your app, using a GUI. </p></li>',
'',
'<li>Navigation Lists',
'<p><img src="#THEME_IMAGES#demo/img/Image_4.png" /></p>',
'<p>In Universal theme, you now have the choice between using a top or side navigation menu. Older themes only supported tabs, which always consumed vertical screen real estate. Placing the menu on the side, and allowing it to be collapdsed, works bet'
||'ter for most applications, especially when displayed on widescreen monitors.</p></li>',
'',
'<li>New UI Components',
'',
'<p><img src="#THEME_IMAGES#demo/img/Image_5.png" /></p>',
'<p>Universal Theme has built-in templates for a variety of common UI components which are not available in other themes. For example, there are templates for easily creating carousels, tabs, menus, cards, and much more.</p></li>',
'',
'<li>Maximize/Restore',
'',
'',
'<p><img src="#THEME_IMAGES#demo/img/Image_6.png" /></p>',
'',
'<p>Universal Theme enables Interactive Reports, Classic Reports, and Standard Regions to be "maximized". With the maximize button template option enabled, end users can now focus on a single region, and scroll through large amounts of data without se'
||'eing other content on the page. This makes it far easier for end users to review these large regions which are often very wide and long. Older themes do not have support for this feature. </p></li>',
'</ul>',
'',
'<h2>Cons</h2>',
'',
'<p>Because migrating to Universal Theme, from older themes, will take development effort and significant time reviewing migrated pages, you should consider the downsides of migrating before moving forward.</p>',
'<ul>',
'<li>Different UI.',
'',
'<p>While Universal Theme is designed to be fully accessible and aesthetically pleasing, users who are completely comfortable with the older theme''s UI, may not immediately like the new theme. Further, training material developed in-house will need to'
||' be upgraded as the look of the pages will undoubtedly change significantly.</p>',
'<p>This is not a technical issue, since Universal Theme is not a departure from the traditional APEX workflow, but an enhancement on top of your existing processes. Application content, such as pages, regions, buttons, and items, will not be changed '
||'as a result of migrating, other than their appearance.</p></li>',
'',
'<li>Regressions',
'',
'<p>Some templates carried over from previous themes may not have strict <em>one-to-one</em> equivalents. Some of your custom CSS/JS modifications that were not directly supported in APEX may also no longer work as expected on your pages. These and ot'
||'her issues are covered in <strong>Post-Migration Tasks</strong>, <strong>Best Practices</strong>, and <strong>Common Issues After Upgrading</strong> sections below.</p></li>',
'',
'<li>Custom Themes / Templates',
'',
'<p>If you have developed a completely custom theme, then migrating to Universal Theme may require significant effort. Similarly, if you defined custom templates then you may find difficulties finding a similar template in the Universal Theme. However'
||', you may find using the new template options and theme roller will make many of your customizations redundant. If not, you will need to manually define custom templates and reapply your custom CSS and HTML post-migration.</p></li>',
'',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1481012378845224359)
,p_plug_name=>'Steps to Migrate'
,p_region_css_classes=>'dm-Migration-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_grid_column_css_classes=>'how-to'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h1>How do I migrate to Universal Theme?</h1>',
'',
'<p>Before beginning the migration process, it is <strong>strongly</strong> recommended to take an export of your application. This will enable you to easily revert back to the original application if necessary, before making any changes to your appli'
||'cation and its metadata. Once you have migrated to the Universal Theme, you can not easily switch it back to the original legacy theme. Additionally, if you re-import the original application, under a different Application ID, you can refer to this a'
||'pplication to review how the application looked previously, as opposed to how it looks using the Universal Theme.</p>',
'',
'<p>If you haven''t done so already, you should use the Application Utilities > Upgrade Application to update certain built-in widgets in your legacy applications to the latest provided by APEX 5, e.g. FlashChart to AnyChart . This will ensure that tho'
||'se widgets take full advantage of the responsiveness of Universal Theme.</p>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1481012825529224361)
,p_plug_name=>'Bookmarklet'
,p_region_css_classes=>'dm-Migration-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h1>Bookmarklet</h1>',
'<p>There is not always an equivalent template in Universal Theme for all templates from previous themes. For this reason, the APEX Development Team has created a bookmarklet to assist you with mapping your older templates to your newer templates in t'
||'he Verify Compatibility step of the Switch Theme wizard.</p>',
'',
'<p> The  Universal Theme Migration bookmarklet supports mappings from the 3 most popular legacy themes, Theme 24, 25, and 26. It also supports any themes that are based off these legacy themes, i.e.: if your theme was based on one of those themes. Wh'
||'en utilized then the bookmarklet will do most of the mappings correctly to produce the best results from the migration.</p>',
'',
'<p>To install the bookmarklet, drag the bookmark into your bookmarks bar.</p>',
'',
'<iframe id="bookmarkletIframe" src="#APP_IMAGES#bookmarklet.html"></iframe> ',
'',
'<p>Then, on the Verify Compatibility page, where you perform the template mappings, click on the Universal Theme Migration bookmarklet to attempt to update the template mappings. If the theme you are migrating from is supported, then it will automati'
||'cally match the templates of your older theme to the correct templates in Universal Theme.</p>',
'<p><img src="#THEME_IMAGES#demo/img/Image_19.png" /></p>',
'<p>If your theme is mapped properly, each of the select list values that were successfully altered will be highlighted in green. </p>',
'<p><img src="#THEME_IMAGES#demo/img/Image_20.png" /></p>',
'',
'<p>Once the mapping process has completed, any errors you encounter will be displayed On an error page. You can try clicking on the <b>Map to a Different Theme</b> button, to try re-mapping with an alternate theme available within the book marklet. I'
||'f the expected mapping can not be found in the select list for that template, then it  will be highlighted in orange.</p>',
'<p>   <img src="#THEME_IMAGES#demo/img/Image_21.png" /></p>',
'',
'<p>Typically receiving any errors either means your custom templates did not strictly match the theme you chose, or that you have not set <b>Match Template Classes</b> to "<b>No</b>" in the previous step.</p>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1481013196795224362)
,p_plug_name=>'FAQ'
,p_region_css_classes=>'dm-Migration-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h1>Frequently Asked Questions</h1>',
'<h2>When Upgrading</h2>',
'<ul>',
'  <li>',
'    <strong>Problem</strong>',
'    <p>Warning: You must have at least two themes installed to be able to switch. Please create a new theme and attempt this action again.</p>',
'    <p><img src="#THEME_IMAGES#demo/img/Image_22.png" /></p>',
'    <strong>Solution</strong>',
'    <p>Create the Universal Theme in your application, as outlined above, before trying to switch your theme. Please <u>start the guide from step #1.</u></p>',
'  </li>',
'  <li>',
'    <strong>Problem</strong> ',
'    <p>This application cannot be converted to a theme using list-based navigation, as it uses two levels of tabs. Please update the application and set current tabs settings to use only one level of tabs prior to switching the theme. (Go to error)</'
||'p>',
'<p><img src="#THEME_IMAGES#demo/img/Image_23.png" /></p>',
'<strong>Solution</strong>',
'<p> Because two-level tabs are not supported in Universal Theme, you must re-design your existing apps to use only one level of tabs, and then switch. If doing so proves too complicated, try deleting the parent tabs, conducting the theme switch, and '
||'then re-creating navigation using a navigation menu post. To delete the parent tabs, you must go to "Shared Components >  Tabs > Edit Tabs > Manage Parent Tabs " and click on each of the parent tabs to access the button to delete them.</p>',
'</li>',
'</ul>',
'',
'<h2>After Upgrading</h2>',
'<ul>',
'<li>',
'<strong>Problem</strong>',
'<p> When running my app on a certain page, I get the error message "Label column span grid setting for this page item is invalid."</p>',
'<strong>Solution</strong>',
'<p><img src="#THEME_IMAGES#demo/img/Image_24.png" /></p>',
'<p> In this example, with a label column span of 3 plus each item''s column span of 1, all 4 together means that the content is 16 columns wide. This exceeds the 12 columns supported by the Universal Theme which results in this error being thrown befo'
||'re the page is rendered in your browser. To Fix: navigate to the page item specified in the error message in page designer or component view, and reduce the number of label column spans that your elements consume. </p>',
'</li>',
'<li>',
'<strong>Problem</strong> ',
'<p>My content is no longer placed in multiple columns</p>',
'<div class=''two-images-one-row''>',
'<img src="#THEME_IMAGES#demo/img/Image_25.png" />',
'<img src="#THEME_IMAGES#demo/img/Image_26.png" />',
'</div>',
'<strong>Solution</strong> ',
'<p>If you reset all the grid positions that your app previously used, then your content will be placed in one column after upgrading. To recreate the columned layout you had before, just drag the regions into new columns with Page Designer.</p>',
'<img src="#THEME_IMAGES#demo/img/Image_27.png" />',
'<p>You can also "fine-tune" the grid and column spans using the right side bar to get a layout that resembles your original theme.</p>',
'</li>',
'<li>',
'<strong>Problem</strong>',
'<p> My navigation bar is not a list </strong> </p>',
'<img src="#THEME_IMAGES#demo/img/Image_29.png" />',
'<strong> Solution </strong>',
'<p> In order to add menus and have fine grain control of your Navigation Bar, i.e., your upper right hand corner links, it will need to be converted from the "Classic" implementation to a "List" based one. To do so, you must first create a new list w'
||'hich contains entries such as your user name (&APP_USER.), a sign out link, and any other app-wide links you would like to have.',
'',
'Once this list is created, navigate to "Shared Components -> User Interface Attributes -> Edit Desktop -> Navigation Bar" and change the Implementation from "Classic" to "List".  "Select the List you created earlier, and set List Template to Navigati'
||'on Bar". Your app will now be using a list-based navigation bar.',
'<img src="#THEME_IMAGES#demo/img/Image_30.png" />',
'With a list-based Navigation Bar, you can then add sub-entries which will appear in a drop down menu.</p>',
'',
'',
'',
'',
'',
'</li>',
'',
'',
'</ul>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1481013600038224362)
,p_plug_name=>'Creating UT in your App'
,p_region_css_classes=>'dm-Migration-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>First: Create Universal Theme in your application</h2>',
'<p>From Shared Components, click on Themes and follow the steps below:</p>',
'<p><b>Note:</b> If you have already installed the Universal THeme into your application proceed to the second step, <em>Switch to Universal Theme</em>.</p>',
'<ol>',
'    <li><p>Click <b>Create Theme</b></p><p>You need to install the Universal Theme into your application to get started.</p>',
'        <p><img src="#THEME_IMAGES#demo/img/Image_7.png" /></p></li>',
'    <li><p>Select <b>From the Repository.</b></p>',
'        <p><img src="#THEME_IMAGES#demo/img/Image_8.png" /></p></li>',
'    <li><p>Select <b>Desktop</b> as the User Interface.</p>',
'        <p><img src="#THEME_IMAGES#demo/img/Image_9.png" /></p></li>',
'    <li><p>Choose <b>Standard Themes</b> as the Theme Type, and <b>Universal Theme (Theme 42)</b> as the Theme. </p>',
'        <p> <img src="#THEME_IMAGES#demo/img/Image_10.png" /></p></li>',
'    <li><p>Review your changes and click <b>Create</b>.</p>',
'        <p><img src="#THEME_IMAGES#demo/img/Image_11.png" /></p></li>',
'</ol>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1481013979777224363)
,p_plug_name=>'Switching to UT'
,p_region_css_classes=>'dm-Migration-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2>Second: Switch to Universal Theme.</h2>',
'<p><b>Note:</b> Not until you have completed Step 4 below will your application be irreversibly changed. Reverting back to a Tab-based application will be very difficult, which is why it is strongly recommended you have a backup of the application be'
||'fore proceeding further.</p>',
'<ol>',
'  <li><p>Click <b>Switch Theme</b></p>',
'    <p><img src="#THEME_IMAGES#demo/img/Image_12.png" /></p></li>',
'  <li><p>Select the current desktop theme, and then select <b>42. Universal Theme</b>. ',
'    <p>Depending on your application, you may choose to set the <b>Reset Grid</b> option to either <b>Reset fixed region positions</b> or <b>Reset all region and item grid positions</b>.</p>',
'     <p>Reset fixed region positions will maintain your current region positions, where possible, during migration. <em>This is the recommended approach</em>.</p>',
'     <p>Reset all region and item grid positions will ensure item and region positioning will be reset and will force regions and items to stack on top of each other.</p>',
'     <p>Make sure that <b>Map Template Classes</b> is set to <b>No</b></p>',
'     <p>Press <b>Next</b> to continue.</p>',
'     <p><img src="#THEME_IMAGES#demo/img/Image_13.png" /></p></li>',
'   <li><p>Verify that<b> </b>the mappings for your templates and Universal Theme templates are correct. Use the <b>Universal Theme Migration Bookmarklet</b> helper below, to automatically assign the right mapping, or check out the full mapping guide '
||'located at the end of this guide.</p>',
'     <p>Most of the inconsistencies will be from new templates that Universal theme provides. Try to choose the template that best matches your existing template. You may want to browse the components in the Universal Theme Sample Application to get '
||'a sense of the new templates and their various configurations. </p>',
'     <p><img src="#THEME_IMAGES#demo/img/Image_14.png" /></p></li>',
'   <li><p>Click <b>Switch Theme</b>.</p>',
'     <p> <img src="#THEME_IMAGES#demo/img/Image_15.png" /></p></li>',
'</ol>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1481014410881224363)
,p_plug_name=>'Post Migration'
,p_region_css_classes=>'dm-Migration-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h1>Final steps: Post migration tasks</h1>',
'<p>Unlike the previous steps, the following tasks do not have to be completed in any particular order. Instead, it is advised that you carry them out before making new enhancements to your application, to ensure that any issues relating to the migrat'
||'ion are not complicated by changes in functionality.</p>',
'<ul>',
'    <li>',
'    <p>While it is not necessary to remove your older theme for your freshly migrated app to work, your older theme no longer serves any functional purpose. If you haven''t created any custom templates in your older theme (which you''d want to copy ove'
||'r), or if you don''t need to keep the older theme for reference, consider deleting the older theme.</p>',
'  </li>',
'  <li>',
'    <p>Ensure that the list items for <b>Navigation Menu</b> are correct, and that the <em>Current For</em> attributes are properly set.</p>',
'    <p>Your tabs will be converted into a list format. If the current for attributes are not set correctly, the navigation links will not be selected when you navigate to each of the pages. </p>',
'    <p><img src="#THEME_IMAGES#demo/img/Image_16.png"/></p>',
'  </li>',
'  <li>',
'    <p>Decide if you want to stick with <b>Side Navigation</b> or change to the <b>Top Menu </b>as the application''s primary means of navigation.</p>',
'    <p>If you choose to stick with side navigation, it is recommended to select <em>Navigation Icons</em> for each menu entry, otherwise each page will have the same default page icon. By going to Shared Components > Navigation Menu > List Entry, you'
||' can choose from a variety of pre-built icons, allowing you to choose the best match for each page type. Please note that these icons will only appear if you are using side navigagtion.</p>',
'    <p>To change to <b>Top Menu</b> you will need to navigate to Shared Component > User Interface Attributes > Edit Universal Theme. Then change <b>Position</b> to <em>Top</em> and <b>List Template</b> to <em>Top Menu Navigation</em>, and then apply'
||' changes.</p>',
'    <p><img src="#THEME_IMAGES#demo/img/Image_17.png"/></p>',
'  </li>',
'  <li>',
'    <p><img src="#THEME_IMAGES#demo/img/Image_18.png"/></p>',
'  </li>',
'</ul>',
'',
'<h2>Best Practices for managing post-migration issues</h2>',
'<p>While most migrations will be relatively painless, there is no set path for how dealing with issues arise as a result of this change. Consider the following pointers for how to exhaustively find and resolve such problems in your new Universal Them'
||'e Application.</p>',
'<ol>',
'  <li>Visually review the migrated application.<br/>',
'    - Run each page of your application, or at least a good cross section of different pages to make sure that there are no obvious display issues.<br/>',
'    - If you have installed your original application under a different Application Id, perform side-by-side comparisons on a wide selection of pages, to ensure different page elements, such as buttons, and the overall page layout are not too diverge'
||'nt.',
'  </li>',
'  <li>Check non-standard components.<br/>',
'    - Be sure to check any pages where you implemented your own JavaScript to ensure the page still operates correctly. Many of the default class names for elements were changed, and some of the inline scripts that you have augmented your pages with '
||'may no longer be needed. <br/>',
'    - Review any pages or templates where you have added any CSS libraries. If necessary, reapply the CSS libraries into the migrated application.<br/>',
'    - Review all plug-ins used throughout your application to ensure they are still functioning correctly. Some plug-ins from third parties may not work correctly with Application Express 5. If so, you may need to remove the plug-in or search for an '
||'APEX 5.0 compatible plug-in.',
'  </li>',
'  <li>Ask your users to test your app.<br/>',
'    - After testing the application yourself, the next step is to ask your users to use the new migrated application to ensure they are comfortable with the new user interface, and can readily use the application.<br/>',
'    - Determine from your end users if any end user training material or application documentation needs to be revised before releasing the new application into production.',
'  </li>',
'</ol>',
'',
'<h3>After Debugging</h3>',
'<p>Once you have brought your application up to a "functional" state, you should consider a few more simple improvements you can readily make to your application, so that you can take full advantage of the new features in both Application Express 5 a'
||'nd Universal Theme. For example, you may want to prototype some different layout options, with a select group of users, to see if existing pages can be readily improved by simply changing some Template Options.</p>',
'',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1481014754041224364)
,p_plug_name=>'Best Practices on Common UI Patterns'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>We can increase usability by following design patterns when building applications. This page showcases some of the most common design patterns in for enterprise applications, and instructions on how to apply them for your own flows.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1723520234855110234)
,p_plug_name=>'Design Patterns List'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--hideHeader:t-Region--scrollBody'
,p_component_template_options=>'t-MediaList--showIcons:u-colors:t-MediaList--cols t-MediaList--2cols'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(713419631491967228)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_05001
begin
wwv_flow_api.create_page(
 p_id=>5001
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Login Page'
,p_alias=>'LOGIN-PAGE'
,p_step_title=>'Login Page - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2523782757150866852)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_05002
begin
wwv_flow_api.create_page(
 p_id=>5002
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Home and Dashboard'
,p_alias=>'HOME-AND-DASHBOARD'
,p_step_title=>'Home and Dashboard - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3402604831916224922)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_05003
begin
wwv_flow_api.create_page(
 p_id=>5003
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Filter Page'
,p_alias=>'FILTER-PAGE'
,p_step_title=>'Filter Page - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4281427923886587488)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_05004
begin
wwv_flow_api.create_page(
 p_id=>5004
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Marquee Page'
,p_alias=>'MARQUEE-PAGE'
,p_step_title=>'Marquee Page - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5160252137453962761)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_05005
begin
wwv_flow_api.create_page(
 p_id=>5005
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Modal Dialogs'
,p_alias=>'MODAL-DIALOGS'
,p_step_title=>'Modal Dialogs - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(558266987012620477)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6039077381072342015)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_06000
begin
wwv_flow_api.create_page(
 p_id=>6000
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Reference'
,p_alias=>'REFERENCE'
,p_step_title=>'Reference - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(766160418673482415)
,p_plug_name=>'Miscellaneous'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_component_template_options=>'#DEFAULT#:u-colors'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(790289546548048869)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1392158920146906412)
,p_plug_name=>'Tools'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_component_template_options=>'#DEFAULT#:u-colors'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(713405900484911743)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1392159086004906413)
,p_plug_name=>'JavaScript Utilities'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_component_template_options=>'#DEFAULT#:u-colors'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(713407327666911744)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1394346143594323490)
,p_plug_name=>'Reference'
,p_icon_css_classes=>'fa-lg fa-cogs u-color-13'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1224989219520090364)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1753008608317244487)
,p_plug_name=>'CSS Utilities'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_component_template_options=>'#DEFAULT#:u-colors'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(713403702397911733)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_06100
begin
wwv_flow_api.create_page(
 p_id=>6100
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Button Builder'
,p_alias=>'BUTTON-BUILDER'
,p_step_title=>'Button Builder - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(713639924515207048)
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#THEME_IMAGES#demo/icons#MIN#.js',
'#THEME_IMAGES#demo/iconSearch#MIN#.js',
'#THEME_IMAGES#demo/buttonBuilder#MIN#.js'))
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var detached;',
'',
'var returnIcon = function (cl) {',
'    $s(''P6100_ICON_CLASS'', cl);',
'    apex.jQuery(''#icon_picker_dialog'').dialog(''close'');',
'};'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(function($){',
'   apex.theme42demo.renderButtons();',
'',
'    $(".icon-preview").stickyWidget({toggleWidth: true});',
'',
'    // for icon dialogs',
'    $(''#icons'').on( "dialogclose", function( event, ui ) {',
'        $(''#icons-wrapper'').remove();',
'    });',
'',
'    $("#P6100_SEARCH").on("keyup",function(){',
'        apex.theme42demo.renderIcons({debounce: 250, filterString: this.value});',
'    }); ',
'})(apex.jQuery);'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.event-name { background: rgba(147, 180, 197, 0.25); padding: 6px 8px; border-radius: 3px; text-shadow: 1px 1px #fff; }',
'.event-name:hover { color: #000; background: #eee }',
'.is-hidden { display: none; }',
'.icon-preview { height: 128px; display: flex; align-items: center; justify-content: center; background: #FFF; border-radius: 2px; box-shadow: 0 1px 1px rgba(0, 0, 0, .05), 0 0 0 1px rgba(0, 0, 0, 0.1) inset; }',
'.instructions { font-size: 11px; line-height: 16px; color: #767676; display: block; margin: 0; }',
'.dm-IconDialog-info.row {margin-left: 0;margin-right: 0;}',
'.button-instructions {margin-top: 12px;}',
'.icon-preview button {transition: all .2s ease}',
'body .ui-widget-content a {',
'  color: inherit;',
'}',
'.dm-Search-category:first-child {',
'margin-top: 0;}',
'#icon_picker {max-height: 400px; overflow: auto;}',
'#icon_picker .dm-Search-title {font-size:1.6rem}',
'.highlight {',
'    background-color: #ffef9a;',
'    padding: 2px 0;',
'    box-shadow: 0 0 0 1px rgba(0, 0, 0, 0.05) inset, 0 1px 1px -1px rgba(0, 0, 0, 0.1);',
'    border-radius: 2px;',
'    transition: .1s ease;',
'}'))
,p_page_css_classes=>'dm-Page'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(696199621498857821)
,p_plug_name=>'Preview'
,p_region_css_classes=>'icon-preview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" id="TEXT_ONLY" class="t-Button">My Button</button>',
'',
'<button class="t-Button t-Button--noLabel t-Button--icon" type="button" id="ICON_ONLY" title="Icon Only" aria-label="Icon Only"><span class="t-Icon " aria-hidden="true"></span></button>',
'',
'<button class="t-Button t-Button--icon t-Button--iconLeft" type="button" id="TEXT_W_ICON"><span class="t-Icon t-Icon--left " aria-hidden="true"></span>My Button<span class="t-Icon t-Icon--right " aria-hidden="true"></span></button>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1063557098392817872)
,p_plug_name=>'Usage Instructions'
,p_region_css_classes=>'button-instructions'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this page to build buttons for use in your reports. Simply specify a column as a <strong>Link</strong> and then enter the following properties for Link Text and Link Attributes.</p>',
'<div class="dm-IconDialog-info row">',
'    <span class="dm-IconDialog-infoTitle col col-3">Link Text</span>',
'    <div class="dm-IconDialog-infoBody col col-9">',
'        <code id="button_code_link_text"></code>',
'        <p class="instructions">Enter this in the Link Text property for a Link Column in your report.</p>',
'    </div>',
'</div>',
'<div class="dm-IconDialog-info row">',
'    <span class="dm-IconDialog-infoTitle col col-3">Link Attributes</span>',
'    <div class="dm-IconDialog-infoBody col col-9">',
'        <code id="button_code_link_attr"></code>',
'        <p class="instructions">Enter these attributes in the Link Attributes property for a Link Column in your report.</p>',
'    </div>',
'</div>',
'<div class="dm-IconDialog-info row">',
'    <span class="dm-IconDialog-infoTitle col col-3">Entire Markup</span>',
'    <div class="dm-IconDialog-infoBody col col-9">',
'        <code id="button_code_whole"></code>',
'        <p class="instructions">Full HTML markup.</p>',
'    </div>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1409837052515052076)
,p_plug_name=>'Builder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>40
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(696200438571857829)
,p_plug_name=>'Appearance'
,p_parent_plug_id=>wwv_flow_api.id(1409837052515052076)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(696200523414857830)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_api.id(1409837052515052076)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(714048467550570319)
,p_plug_name=>'Advanced'
,p_parent_plug_id=>wwv_flow_api.id(696200523414857830)
,p_region_template_options=>'#DEFAULT#:is-collapsed:t-Region--noUI:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(1215306280710140812)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p class="instructions">Spacing options provide a way to manage whitespace around the buttons. These are especially useful when buttons are placed adjacent to one another, or next to other components.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1427078124008507302)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3646450985234108612)
,p_plug_name=>'Icon Picker'
,p_region_name=>'icon_picker_dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size720x480'
,p_plug_template=>wwv_flow_api.id(1223645131968329858)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(766159448881482405)
,p_plug_name=>'Icons'
,p_region_name=>'icons'
,p_parent_plug_id=>wwv_flow_api.id(3646450985234108612)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1116160161408532792)
,p_plug_name=>'Search'
,p_parent_plug_id=>wwv_flow_api.id(3646450985234108612)
,p_region_template_options=>'#DEFAULT#:t-Form--stretchInputs'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(732462317103763731)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(696200438571857829)
,p_button_name=>'ICON_DIALOG_BUTTON'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Icon dialog button'
,p_button_redirect_url=>'f?p=&APP_ID.:6101:&SESSION.::&DEBUG.:RP::'
,p_button_condition_type=>'NEVER'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(696199728213857822)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(696199621498857821)
,p_button_name=>'TEXT_ONLY'
,p_button_static_id=>'TEXT_ONLY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_image_alt=>'Text Only'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(696201360858857838)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(696199621498857821)
,p_button_name=>'ICON_ONLY'
,p_button_static_id=>'ICON_ONLY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(900079107762114354)
,p_button_image_alt=>'Icon Only'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(696201455444857839)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(696199621498857821)
,p_button_name=>'TEXT_W_ICON'
,p_button_static_id=>'TEXT_W_ICON'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(633800930240492718)
,p_button_image_alt=>'Text with Icon'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(696199824067857823)
,p_name=>'P6100_HOT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(696200438571857829)
,p_item_default=>'default'
,p_prompt=>'Hot'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Yes;t-Button--hot,No;default'
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(696199932613857824)
,p_name=>'P6100_BUTTON_TEMPLATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(696200438571857829)
,p_item_default=>'TEXT_ONLY'
,p_prompt=>'Button Template'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Text;TEXT_ONLY,Text with Icon;TEXT_W_ICON,Icon;ICON_ONLY'
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(696200074196857825)
,p_name=>'P6100_SIZE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(696200523414857830)
,p_item_default=>'default'
,p_prompt=>'Size'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Tiny;t-Button--tiny,Small;t-Button--small,Default;default,Large;t-Button--large'
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--radioButtonGroup'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(696200189596857826)
,p_name=>'P6100_STYLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(696200523414857830)
,p_item_default=>'default'
,p_prompt=>'Style'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Default;default,Simple;t-Button--simple,Remove UI Decorations;t-Button--noUI,Display as Link;t-Button--link'
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#::'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(696200297733857827)
,p_name=>'P6100_ICON_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(696200438571857829)
,p_item_default=>'fa-check-circle'
,p_prompt=>'Icon Class'
,p_post_element_text=>'<button id="open_dialog" type="button" class="t-Button t-Button--small t-Button--pillEnd" title="Icon Picker"><span aria-hidden="true" class="t-Icon fa fa-chevron-up"></span></button>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(696200371673857828)
,p_name=>'P6100_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(696200523414857830)
,p_item_default=>'default'
,p_prompt=>'Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Normal;default,Primary;t-Button--primary,Warning;t-Button--warning,Danger;t-Button--danger,Success;t-Button--success'
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#::'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'6'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(696200656871857831)
,p_name=>'P6100_BUTTON_SET'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(714048467550570319)
,p_item_default=>'default'
,p_prompt=>'Button Set'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC:Default;default,First Button;t-Button--pillStart,Inner Button;t-Button--pill,Last Button;t-Button--pillEnd'
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Use these options if you would like to arrange multiple buttons into a pill or button set. You can then set the first button of the set to "First Button" and the last button to "Last Button." Any buttons in the middle can be set to "Inner Button."'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'6'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(696200759545857832)
,p_name=>'P6100_WIDTH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(714048467550570319)
,p_item_default=>'default'
,p_prompt=>'Width'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC:Auto - Default;default,Stretch;t-Button--stretch'
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#::'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'6'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(696200897244857833)
,p_name=>'P6100_SPACING_LEFT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(714048467550570319)
,p_item_default=>'default'
,p_prompt=>'Spacing Left'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Small;t-Button--padleft,Default;default,Large;t-Button--gapLeft'
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#::'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'6'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(696200937898857834)
,p_name=>'P6100_SPACING_RIGHT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(714048467550570319)
,p_item_default=>'default'
,p_prompt=>'Spacing Right'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Small;t-Button--padRight,Default;default,Large;t-Button--gapRight'
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#::'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'6'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(696201036549857835)
,p_name=>'P6100_SPACING_TOP'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(714048467550570319)
,p_item_default=>'default'
,p_prompt=>'Spacing Top'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Small;t-Button--padTop,Default;default,Large;t-Button--gapTop'
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#::'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'6'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(696201190141857836)
,p_name=>'P6100_SPACING_BOTTOM'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(714048467550570319)
,p_item_default=>'default'
,p_prompt=>'Spacing Bottom'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Small;t-Button--padBottom,Default;default,Large;t-Button--gapBottom'
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#::'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'6'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(696202112560857846)
,p_name=>'P6100_ICON_POSITION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(696200523414857830)
,p_item_default=>'t-Button--iconLeft'
,p_prompt=>'Icon Position'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Left;t-Button--iconLeft,Right;t-Button--iconRight'
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(756742866085976306)
,p_name=>'P6100_BUTTON_LABEL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(696200438571857829)
,p_item_default=>'My Button'
,p_prompt=>'Button Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_grid_label_column_span=>3
,p_field_template=>wwv_flow_api.id(869572400154599626)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(766280852320297398)
,p_name=>'P6100_SEARCH'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(1116160161408532792)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Search Icons'
,p_placeholder=>'Search Font APEX Icons...'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_grid_label_column_span=>0
,p_field_template=>wwv_flow_api.id(591757292230152601)
,p_item_icon_css_classes=>'fa-search'
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--large'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(696201567051857840)
,p_name=>'Render Button'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6100_BUTTON_TEMPLATE ,P6100_SIZE ,P6100_BUTTON_SET ,P6100_HOT ,P6100_TYPE ,P6100_WIDTH ,P6100_STYLE ,P6100_SPACING_LEFT ,P6100_ICON_CLASS ,P6100_SPACING_RIGHT ,P6100_SPACING_TOP ,P6100_SPACING_BOTTOM,P6100_ICON_POSITION,P6100_BUTTON_LABEL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(696201664452857841)
,p_event_id=>wwv_flow_api.id(696201567051857840)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.theme42demo.renderButtons();'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(756742994519976307)
,p_name=>'Populate Link Text'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6100_BUTTON_LABEL'
,p_bind_type=>'bind'
,p_bind_event_type=>'keyup'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(756743019494976308)
,p_event_id=>wwv_flow_api.id(756742994519976307)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var $j = apex.jQuery,',
'    v = $j(this.triggeringElement).val();',
'$j(''.icon-preview .t-Button'').first().text(v);',
'$j(''.icon-preview .t-Button'').last().contents().filter(function(){ ',
'  return this.nodeType == 3; ',
'})[0].nodeValue = v',
'$j(''#button_code_link_text'').text(v);',
'apex.theme42demo.renderButtons();'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(766159083204482401)
,p_name=>'Show Icon Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#open_dialog'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(766159337533482404)
,p_event_id=>wwv_flow_api.id(766159083204482401)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(''#icon_picker_dialog'').dialog(''open'');',
'apex.theme42demo.renderIcons({filterString: $v(''P6100_SEARCH'')});'))
);
end;
/
prompt --application/pages/page_06200
begin
wwv_flow_api.create_page(
 p_id=>6200
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'JavaScript Events'
,p_alias=>'JAVASCRIPT-EVENTS'
,p_step_title=>'JavaScript Events - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(713639924515207048)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'code.event-name {',
'    background: rgba(147, 180, 197, 0.25);',
'    padding: 6px 8px;',
'    border-radius: 3px;',
'    text-shadow: 1px 1px #fff;',
'}',
'',
'code.event-name:hover {',
'    color: #000;',
'    background:#eee',
'}'))
,p_page_css_classes=>'dm-Page'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(696199022014857815)
,p_plug_name=>'API List'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ol class="event-list">',
'    <li>',
'        <p><code class="event-name">theme42ready</code> is triggered after the initialization of Universal Theme:</p>',
'<pre class="dm-Code lang-js"><code>apex.jQuery(window).on(''<strong>theme42ready</strong>'', function() {',
'    console.log(''Do something after UI elements are rendered on the page.'');',
'});</code></pre>',
'        ',
'    </li>',
'    <li>',
'        <p>',
'<code class="event-name">theme42layoutchanged</code> is triggered when left navigation menu is expanded or collapsed.</p>',
'<pre class="dm-Code lang-js"><code>apex.jQuery("#t_TreeNav").on(''<strong>theme42layoutchanged</strong>'', function(event, obj) {',
'    console.log(''Left menu action: '' + obj.action);   // obj.action will return expand or collapse',
'});</code></pre>',
'    </li>',
'    <li>',
'        <p><code class="event-name">apexwindowresized</code> is triggered by the browser window resize or the maximize/restore action of a region.</p>',
'<pre class="dm-Code lang-js"><code>apex.jQuery(window).on(''<strong>apexwindowresized</strong>'', function() {',
'    console.log(''Window resized.'');',
'});</code></pre>',
'    </li>',
'</ol>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(696199129018857816)
,p_plug_name=>'Introduction'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    You can extending Universal Theme by attaching handlers to its events.',
'</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(713440093508313041)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
end;
/
prompt --application/pages/page_06201
begin
wwv_flow_api.create_page(
 p_id=>6201
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'JavaScript APIs'
,p_alias=>'JAVASCRIPT-APIS'
,p_step_title=>'JavaScript APIs - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(713639924515207048)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'code.event-name {',
'    background: rgba(147, 180, 197, 0.25);',
'    padding: 6px 8px;',
'    border-radius: 3px;',
'    text-shadow: 1px 1px #fff;',
'}',
'',
'code.event-name:hover {',
'    color: #000;',
'    background:#eee',
'}'))
,p_page_css_classes=>'dm-Page'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2872653104102214716)
,p_plug_name=>'API List'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ol class="event-list">',
'    <li class="margin-bottom-md">',
'        <p><code class="event-name">apex.theme42.util.configAPEXMsgs( pOptions )</code></p><p>Configure the display behavior of success messages. You can use this API to programmatically determine how long the success message is displayed before auto'
||'matically dismissing itself.</p>',
'<pre class="dm-Code lang-js"><code>apex.jQuery(function() {',
'  apex.theme42.util.configAPEXMsgs({',
'    autoDismiss: true,',
'    duration: 5000  // duration is optional (Default is 3000 milliseconds)',
'  });',
'});</code></pre>',
'<p><small>Note: The previous name for this API, <code>apex.theme42.configureSuccessMessages</code>, is deprecated and will be removed in a future release.  Please update your application to use the new name.</small></p>',
'    </li>',
'    ',
'    <li class="margin-bottom-md">',
'        <p><code class="event-name">apex.theme42.util.scrollTo( pId )</code></p>',
'        <p>Enables smooth scrolling to the specified anchor, taking into account the sticky top height so the content is not partially blocked.</p>',
'<pre class="dm-Code lang-js"><code>// Example 1: Simply call it to scroll to an region',
'apex.theme42.util.scrollTo( ''my_region'' );',
'',
'// Example 2: Use smooth scroll for all anchor links such as href="#my_content".',
'apex.jQuery(function() {',
'  $( "a[href^=''#'']" ).click(function( e ) {',
'    e.preventDefault();',
'    apex.theme42.util.scrollTo( apex.jQuery( this ).attr( ''href'' ) );',
'  });',
'});</code></pre>',
'    </li>',
'</ol>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2872653211106214717)
,p_plug_name=>'Introduction'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>'<p>Universal Theme provides the following JavaScript APIs that you may find useful in your applications.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2889894175595669942)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
end;
/
prompt --application/pages/page_06301
begin
wwv_flow_api.create_page(
 p_id=>6301
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Responsive Utilities'
,p_alias=>'RESPONSIVE-UTILITIES'
,p_step_title=>'Responsive Utilities - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(713639924515207048)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'code.event-name {',
'    background: rgba(147, 180, 197, 0.25);',
'    padding: 6px 8px;',
'    border-radius: 3px;',
'    text-shadow: 1px 1px #fff;',
'}',
'',
'code.event-name:hover {',
'    color: #000;',
'    background:#eee',
'}'))
,p_page_css_classes=>'dm-Page'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(109707274980854005)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre class="dm-Code lang-html"><code>&lt;div class="hidden-xs-up"&gt;',
'  This is displayed for screens below 640px only.',
'&lt;/div&gt;',
'',
'&lt;div class="hidden-sm-down"&gt;',
'  This is hidden for small screens, and only visible when the screen is at least 992px wide.',
'&lt;/div&gt;</code></pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1193588892315178618)
,p_plug_name=>'Classes'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use the <span class="class">hidden-<span class="class-var">xxx</span>-up</span> class to hide a given component when the viewport size is at the specified breakpoint or wider.</p>',
'',
'<p>Similarly, use the <span class="class">hidden-<span class="class-var">xxx</span>-down</span> class to hide a given component when the viewport size is at the specified breakpoint or narrower.</p>',
'',
'<table class="u-Report u-Report--staticBG u-Report--stretch dm-Report--doc  dm-Report--grid">',
'  <thead>',
'    <tr>',
'      <th></th>',
'      <th>XXS Screens <small class="breakpoint">&le;640px</small></th>',
'      <th>XS Screens <small class="breakpoint">&gt;640 and &lt;768px</small></th>',
'      <th>Small Screens <small class="breakpoint">&ge;768px and &lt;992px</small></th>',
'      <th>Medium Screens <small class="breakpoint">&ge;992px and &lt;1200px</small></th>',
'      <th>Large Screens <small class="breakpoint">&ge;1200px</small></th>',
'    </tr>',
'  </thead>',
'  <tbody>',
'    <tr>',
'      <th scope="row"><span class="class">hidden-<span class="class-var">xxs</span>-down</span></th>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-visible">Visible</td>',
'      <td class="display-visible">Visible</td>',
'      <td class="display-visible">Visible</td>',
'      <td class="display-visible">Visible</td>',
'    </tr>',
'    <tr>',
'      <th scope="row"><span class="class">hidden-<span class="class-var">xs</span>-down</span></th>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-visible">Visible</td>',
'      <td class="display-visible">Visible</td>',
'      <td class="display-visible">Visible</td>',
'    </tr>',
'    <tr>',
'      <th scope="row"><span class="class">hidden-<span class="class-var">sm</span>-down</span></th>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-visible">Visible</td>',
'      <td class="display-visible">Visible</td>',
'    </tr>',
'    <tr>',
'      <th scope="row"><span class="class">hidden-<span class="class-var">md</span>-down</span></th>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-visible">Visible</td>',
'    </tr>',
'    <tr>',
'      <th scope="row"><span class="class">hidden-<span class="class-var">lg</span>-down</span></th>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'    </tr>',
'    <tr>',
'      <th scope="row"><span class="class">hidden-<span class="class-var">xxs</span>-up</span></th>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'    </tr>',
'    <tr>',
'      <th scope="row"><span class="class">hidden-<span class="class-var">xs</span>-up</span></th>',
'      <td class="display-visible">Visible</td>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'    </tr>',
'    <tr>',
'      <th scope="row"><span class="class">hidden-<span class="class-var">sm</span>-up</span></th>',
'      <td class="display-visible">Visible</td>',
'      <td class="display-visible">Visible</td>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'    </tr>',
'    <tr>',
'      <th scope="row"><span class="class">hidden-<span class="class-var">md</span>-up</span></th>',
'      <td class="display-visible">Visible</td>',
'      <td class="display-visible">Visible</td>',
'      <td class="display-visible">Visible</td>',
'      <td class="display-hidden">Hidden</td>',
'      <td class="display-hidden">Hidden</td>',
'    </tr>',
'    <tr>',
'      <th scope="row"><span class="class">hidden-<span class="class-var">lg</span>-up</span></th>',
'      <td class="display-visible">Visible</td>',
'      <td class="display-visible">Visible</td>',
'      <td class="display-visible">Visible</td>',
'      <td class="display-visible">Visible</td>',
'      <td class="display-hidden">Hidden</td>',
'    </tr>',
'  </tbody>',
'</table>',
'<p><small>Note: These helper utilities are available in Oracle APEX 18.2 and later.</small></p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1193589106772178620)
,p_plug_name=>'Breakpoints'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Universal Theme uses the following breakpoints for responsive styles. You can apply these helper classes using the <span class="class">hidden-<span class="class-var">xxx</span>-up</span> or <span class="class">hidden-<span class="class-var">xxx</s'
||'pan>-down</span> helper classes.</p>',
'',
'</p>',
'<table class="u-Report u-Report--staticBG u-Report--stretch dm-Report--doc">',
'  <thead>',
'    <tr>',
'      <th style="width: 30%" class="u-textStart">Name</th>',
'      <th style="width: 30%" class="u-textStart">Class Variable</th>',
'      <th class="u-textStart">Details</th>',
'    </tr>',
'  </thead>',
'  <tbody>',
'    <tr>',
'      <td>XXS Screens</td>',
'      <td><span class="class-var">xxs</span></td>',
'      <td><span class="class-desc">640px and below</span></td></tr>',
'    <tr>',
'      <td>XS Screens</td> ',
'      <td><span class="class-var">xs</span></td> ',
'      <td><span class="class-desc">641px to 767px</span></td></tr>',
'    <tr>',
'      <td>Small Screens</td> ',
'      <td><span class="class-var">sm</span></td> ',
'      <td><span class="class-desc">768px to 991px</span></td></tr>',
'    <tr>',
'      <td>Medium Screens</td> ',
'      <td><span class="class-var">md</span></td> ',
'      <td><span class="class-desc">992px to 1199px</span></td></tr>',
'    <tr>',
'      <td>Large Screens</td> ',
'      <td><span class="class-var">lg</span></td> ',
'      <td><span class="class-desc">1200px and above</span></td></tr>',
'  </tbody>',
'</table>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1433110640562986542)
,p_plug_name=>'Introduction'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>'You can use the following helper classes anywhere in your app to fine-tune the responsive behavior of your page and components. For most Oracle APEX components, you can simply populate the <b>CSS Classes</b> property to apply these modifiers to your '
||'page components.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1450351605052441767)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
end;
/
prompt --application/pages/page_06302
begin
wwv_flow_api.create_page(
 p_id=>6302
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Color and Status Modifiers'
,p_alias=>'COLOR-AND-STATUS-MODIFIERS'
,p_step_title=>'Color and Status Modifiers - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(713639924515207048)
,p_page_css_classes=>'dm-Page'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(779666229173887410)
,p_name=>'General Utility Classes'
,p_template=>wwv_flow_api.id(2623330321607852408)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_sub_css_classes=>'colors-table'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#:t-Report--stretch:t-Report--staticRowColors:t-Report--rowHighlightOff:t-Report--horizontalBorders'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT LEVEL num, null color, null color_text, null color_bg, null color_bd',
'  FROM DUAL',
'CONNECT BY LEVEL <= 45',
'order by 1'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1089625725920080767)
,p_query_num_rows=>45
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(779666895445887416)
,p_query_column_id=>1
,p_column_alias=>'NUM'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(779666999541887417)
,p_query_column_id=>2
,p_column_alias=>'COLOR'
,p_column_display_sequence=>2
,p_column_heading=>'Block'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span class="color-cell-block u-color-#NUM#">u-color-#NUM#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(779666511158887413)
,p_query_column_id=>3
,p_column_alias=>'COLOR_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Text'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span class="color-cell-block color-text u-color-#NUM#-text">u-color-#NUM#-text</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(779666665566887414)
,p_query_column_id=>4
,p_column_alias=>'COLOR_BG'
,p_column_display_sequence=>4
,p_column_heading=>'Background'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span class="color-cell-block color-background u-color-#NUM#-bg">u-color-#NUM#-bg</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(779666762552887415)
,p_query_column_id=>5
,p_column_alias=>'COLOR_BD'
,p_column_display_sequence=>5
,p_column_heading=>'Border'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span class="color-cell-block color-border u-color-#NUM#-border">u-color-#NUM#-border</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1515422096948817016)
,p_plug_name=>'Stateful Color Utilities'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>'<p>Universal Theme provides 6 stateful colors: normal, hot, informational, danger, warning, and success. Here are the CSS modifier classes you can use to apply these states to your own UI controls.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1515422119141817017)
,p_name=>'Stateful Utility Classes'
,p_template=>wwv_flow_api.id(2623330321607852408)
,p_display_sequence=>60
,p_region_sub_css_classes=>'colors-table'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#:t-Report--stretch:t-Report--staticRowColors:t-Report--rowHighlightOff:t-Report--horizontalBorders'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 seq, ''Normal'' status_label, ''u-normal'' status, null color, null color_text, null color_bg, null color_bd from dual',
'union all',
'select 2 seq, ''Hot'' status_label, ''u-hot'' status, null color, null color_text, null color_bg, null color_bd from dual',
'union all',
'select 3 seq, ''Warning'' status_label, ''u-warning'' status, null color, null color_text, null color_bg, null color_bd from dual',
'union all',
'select 4 seq, ''Danger'' status_label, ''u-danger'' status, null color, null color_text, null color_bg, null color_bd from dual',
'union all',
'select 5 seq, ''Info'' status_label, ''u-info'' status, null color, null color_text, null color_bg, null color_bd from dual',
'union all',
'select 6 seq, ''Success'' status_label, ''u-success'' status, null color, null color_text, null color_bg, null color_bd from dual',
'order by 1'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1089625725920080767)
,p_query_num_rows=>45
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1515422961277817025)
,p_query_column_id=>1
,p_column_alias=>'SEQ'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1515422800079817024)
,p_query_column_id=>2
,p_column_alias=>'STATUS_LABEL'
,p_column_display_sequence=>1
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1515422738389817023)
,p_query_column_id=>3
,p_column_alias=>'STATUS'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1515422648734817022)
,p_query_column_id=>4
,p_column_alias=>'COLOR'
,p_column_display_sequence=>2
,p_column_heading=>'Block'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span class="color-cell-block #STATUS#">#STATUS#</span>'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1515422379448817019)
,p_query_column_id=>5
,p_column_alias=>'COLOR_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Text'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span class="color-cell-block color-text #STATUS#-text">#STATUS#-text</span>'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1515422458927817020)
,p_query_column_id=>6
,p_column_alias=>'COLOR_BG'
,p_column_display_sequence=>4
,p_column_heading=>'Background'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span class="color-cell-block color-background #STATUS#-bg">#STATUS#-bg</span>'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1515422559640817021)
,p_query_column_id=>7
,p_column_alias=>'COLOR_BD'
,p_column_display_sequence=>5
,p_column_heading=>'Border'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span class="color-cell-block color-border #STATUS#-border">#STATUS#-border</span>'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2185661311632319791)
,p_plug_name=>'General Color Utilities'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>'<p>While many components within Universal Theme automatically make use of these colors, you can use them in several custom components as well.  Universal Theme provides a number of CSS utility classes that can be used to apply this color palette to a'
||'ny HTML markup.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2202902383125775017)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
);
end;
/
prompt --application/pages/page_06303
begin
wwv_flow_api.create_page(
 p_id=>6303
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Layout Modifiers'
,p_alias=>'LAYOUT-MODIFIERS'
,p_step_title=>'Layout Modifiers - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585577546928652760)
,p_plug_name=>'Floats'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h1'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>To float an element, you can use the <span class="class tag">u-pull<span class="class-var">Direction</span></span> utility classes.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1083164782523677867)
,p_plug_name=>'Classes'
,p_parent_plug_id=>wwv_flow_api.id(585577546928652760)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="u-Report u-Report--staticBG u-Report--stretch dm-Report--doc">',
'  <thead>',
'    <tr>',
'      <th style="width: 30%" class="u-textStart">Class</th>',
'      <th class="u-textStart">Description</th>',
'    </tr>',
'  </thead>',
'  <tbody>',
'    <tr><td><span class="class">u-pull<span class="class-value">Left</span></span></td><td>Float to left</td></tr>',
'    <tr><td><span class="class">u-pull<span class="class-value">Right</span></span></td><td>Float to right</td></tr>',
'  </tbody>',
'</table>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1083164879810677868)
,p_plug_name=>'Examples'
,p_parent_plug_id=>wwv_flow_api.id(585577546928652760)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre class="dm-Code lang-html"><code>&lt;button class="u-pullLeft"&gt;Foo&lt;/button&gt; &lt;!-- Float button to the left --&gt;',
'&lt;div class="u-pullRight"&gt;Hello World&lt;/div&gt; &lt;!-- Float div to the right --&gt;</code></pre>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585577682224652761)
,p_plug_name=>'Margin'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h1'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Margin classes can be added to help add spacing around your elements.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1083165479182677874)
,p_plug_name=>'Options'
,p_parent_plug_id=>wwv_flow_api.id(585577682224652761)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use the following class name structure with the options listed below to add spacing around your element.</p>',
'<p><span class="class tag">margin-<span class="class-var">direction</span>-<span class="class-var">spacing</span></span></p>',
'',
'<table class="u-Report u-Report--staticBG u-Report--stretch dm-Report--doc">',
'  <thead>',
'    <tr>',
'      <th style="width: 30%" class="u-textStart">Variable</th>',
'      <th class="u-textStart">Values</th>',
'      <th class="u-textStart">Description</th>',
'    </tr>',
'  </thead>',
'  <tbody>',
'    <tr>',
'        <td>Direction</td>',
'        <td>',
'            <span class="class-value">top</span> <br />',
'            <span class="class-value">right</span> <br />',
'            <span class="class-value">bottom</span> <br />',
'            <span class="class-value">left</span>',
'        </td>',
'        <td>Where the margin should be positioned</td>',
'    </tr>',
'    <tr>',
'        <td>Spacing</td>',
'        <td>',
'            <span class="class-value">none</span> <span class="class-desc">0 px</span><br />',
'            <span class="class-value">sm</span>   <span class="class-desc">8 px</span><br />',
'            <span class="class-value">md</span>   <span class="class-desc">16 px</span><br />',
'            <span class="class-value">lg</span>   <span class="class-desc">32 px</span>',
'        </td>',
'        <td>',
'            The amount of spacing in pixels. ',
'        </td>',
'    </tr>',
'',
'  </tbody>',
'</table>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1083165632510677875)
,p_plug_name=>'Examples'
,p_parent_plug_id=>wwv_flow_api.id(585577682224652761)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre class="dm-Code lang-html"><code>&lt;h1 class="margin-auto"&gt;Centered Heading Text&lt;/h1&gt;',
'&lt;p class="margin-top-lg"&gt;Content with a large margin on top.&lt;/p&gt;</code></pre>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1083165693639677876)
,p_plug_name=>'Other Classes'
,p_parent_plug_id=>wwv_flow_api.id(585577682224652761)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use these classes to adjust spacing around all sides of your element.</p>',
'<table class="u-Report u-Report--staticBG u-Report--stretch dm-Report--doc">',
'  <thead>',
'    <tr>',
'      <th style="width: 30%" class="u-textStart">Class</th>',
'      <th class="u-textStart">Description</th>',
'    </tr>',
'  </thead>',
'  <tbody>',
'    <tr><td><span class="class">margin-<span class="class-value">none</span></span></td><td>No margin</td></tr>',
'    <tr><td><span class="class">margin-<span class="class-value">sm</span></span></td><td>8 px margin</td></tr>',
'    <tr><td><span class="class">margin-<span class="class-value">md</span></span></td><td>16 px margin</td></tr>',
'    <tr><td><span class="class">margin-<span class="class-value">lg</span></span></td><td>32 px margin</td></tr>',
'    <tr><td><span class="class">margin-<span class="class-value">auto</span></span></td><td>aligns content into the center</td></tr>',
'  </tbody>',
'</table>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585577866307652763)
,p_plug_name=>'Width'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Text</p>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585579018127652774)
,p_plug_name=>'Options'
,p_parent_plug_id=>wwv_flow_api.id(585577866307652763)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="u-Report u-Report--staticBG u-Report--stretch dm-Report--doc">',
'  <thead>',
'    <tr>',
'      <th style="width: 30%" class="u-textStart">Classes</th>',
'      <th class="u-textStart">Values</th>',
'      <th class="u-textStart">Description</th>',
'    </tr>',
'  </thead>',
'  <tbody>',
'    <tr>',
'        <td><span class="class tag">w<span class="class-value">amount</span></span></td>',
'        <td>',
'            <span class="class">10-800</span> <span class="class-desc">px</span>',
'        </td>',
'        <td>Sets the element''s width to specified value. Sizes in 10px increments.</td>',
'    </tr>',
'    <tr>',
'        <td><span class="class tag">w<span class="class-value">percentage</span>p</span></td>',
'        <td>',
'            <span class="class">5-100</span> <span class="class-desc">%</span>',
'        </td>',
'        <td>Sets the element''s width to specified percentage. Percentages in 5% increments</td>',
'    </tr>',
'    <tr>',
'        <td><span class="class tag">mnw<span class="class-value">amount</span></span></td>',
'        <td>',
'            <span class="class">10-800</span> <span class="class-desc">px</span>',
'        </td>',
'        <td>Sets the element''s min-width to specified value. Sizes in 10px increments</td>',
'    </tr>',
'    <tr>',
'        <td><span class="class tag">mxw<span class="class-value">amount</span></span></td>',
'        <td>',
'            <span class="class">10-800</span> <span class="class-desc">px</span>',
'        </td>',
'        <td>Sets the element''s max-width to specified value. Sizes in 10px increments</td>',
'    </tr>',
'  </tbody>',
'</table>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585579078295652775)
,p_plug_name=>'Examples'
,p_parent_plug_id=>wwv_flow_api.id(585577866307652763)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<pre class="dm-Code lang-html"><code>&lt;div class="w95p mxw800"&gt;This region will be 95% wide with a max-widht of 800px.&lt;/div&gt;</code></pre>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585577970422652764)
,p_plug_name=>'Height'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Text</p>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585579179555652776)
,p_plug_name=>'Options'
,p_parent_plug_id=>wwv_flow_api.id(585577970422652764)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="u-Report u-Report--staticBG u-Report--stretch dm-Report--doc">',
'  <thead>',
'    <tr>',
'      <th style="width: 30%" class="u-textStart">Classes</th>',
'      <th class="u-textStart">Values</th>',
'      <th class="u-textStart">Description</th>',
'    </tr>',
'  </thead>',
'  <tbody>',
'    <tr>',
'        <td><span class="class">h<span class="class-value">amount</span></span></td>',
'        <td>',
'            <span class="class-value">10-800</span> <span class="class-desc">px</span>',
'        </td>',
'        <td>Sets the element''s height to specified value. Sizes in 10px increments</td>',
'    </tr>',
'    <tr>',
'        <td><span class="class">mxh<span class="class-value">amount</span></span></td>',
'        <td>',
'            <span class="class-value">10-800</span> <span class="class-desc">px</span>',
'        </td>',
'        <td>Sets the element''s max-height to specified value. Sizes in 10px increments</td>',
'    </tr>',
'  </tbody>',
'</table>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585579267858652777)
,p_plug_name=>'Examples'
,p_parent_plug_id=>wwv_flow_api.id(585577970422652764)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<pre class="dm-Code lang-html"><code>&lt;div class="h400"&gt;This region would be 400px tall.&lt;/div&gt;</code></pre>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585578441586652769)
,p_plug_name=>'Vertical Alignment'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h1'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>To vertically-align the contents of an element you can use the <span class="class tag">u-align<span class="class-var">Direction</span></span> utility class.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1083165326356677872)
,p_plug_name=>'Classes'
,p_parent_plug_id=>wwv_flow_api.id(585578441586652769)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="u-Report u-Report--staticBG u-Report--stretch dm-Report--doc">',
'  <thead>',
'    <tr>',
'      <th style="width: 30%" class="u-textStart">Class</th>',
'      <th class="u-textStart">Description</th>',
'    </tr>',
'  </thead>',
'  <tbody>',
'    <tr><td><span class="class">u-align<span class="class-value">Top</span></span></td><td>Vertically align to the top</td></tr>',
'    <tr><td><span class="class">u-align<span class="class-value">Middle</span></span></td><td>Vertically align to the middle</td></tr>',
'    <tr><td><span class="class">u-align<span class="class-value">Baseline</span></span></td><td>Vertically align to the text baseline</td></tr>',
'    <tr><td><span class="class">u-align<span class="class-value">Bottom</span></span></td><td>Vertically align to the bottom</td></tr>',
'  </tbody>',
'</table>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1083165356842677873)
,p_plug_name=>'Examples'
,p_parent_plug_id=>wwv_flow_api.id(585578441586652769)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre class="dm-Code lang-html"><code>&lt;table&gt;',
'  &lt;tbody&gt;',
'    &lt;tr&gt;',
'      &lt;td class="u-alignTop"&gt;Hello World!&lt;/td&gt;',
'      &lt;td class="u-alignMiddle"&gt;I''m in the middle!&lt;/td&gt;',
'    &lt;/tr&gt;',
'  &lt;/tbody&gt;',
'&lt;/table&gt;</code></pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585578629380652770)
,p_plug_name=>'Padding'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h1'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Padding classes can be added to help add spacing within your elements.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585578642487652771)
,p_plug_name=>'Options'
,p_parent_plug_id=>wwv_flow_api.id(585578629380652770)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use the following class name structure with the options listed below to add spacing around your element.</p>',
'<p><span class="class tag">padding-<span class="class-var">direction</span>-<span class="class-var">spacing</span></span></p>',
'',
'<table class="u-Report u-Report--staticBG u-Report--stretch dm-Report--doc">',
'  <thead>',
'    <tr>',
'      <th style="width: 30%" class="u-textStart">Variable</th>',
'      <th class="u-textStart">Values</th>',
'      <th class="u-textStart">Description</th>',
'    </tr>',
'  </thead>',
'  <tbody>',
'    <tr>',
'        <td>Direction</td>',
'        <td>',
'            <span class="class-value">top</span> <br />',
'            <span class="class-value">right</span> <br />',
'            <span class="class-value">bottom</span> <br />',
'            <span class="class-value">left</span>',
'        </td>',
'        <td>Where the padding should be positioned</td>',
'    </tr>',
'    <tr>',
'        <td>Spacing</td>',
'        <td>',
'            <span class="class-value">none</span> <span class="class-desc">0 px</span><br />',
'            <span class="class-value">sm</span>   <span class="class-desc">8 px</span><br />',
'            <span class="class-value">md</span>   <span class="class-desc">16 px</span><br />',
'            <span class="class-value">lg</span>   <span class="class-desc">32 px</span>',
'        </td>',
'        <td>',
'            The amount of spacing in pixels. ',
'        </td>',
'    </tr>',
'',
'  </tbody>',
'</table>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585578803880652772)
,p_plug_name=>'Other Classes'
,p_parent_plug_id=>wwv_flow_api.id(585578629380652770)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use these classes to adjust spacing within all sides of your element.</p>',
'<table class="u-Report u-Report--staticBG u-Report--stretch dm-Report--doc">',
'  <thead>',
'    <tr>',
'      <th style="width: 30%" class="u-textStart">Class</th>',
'      <th class="u-textStart">Description</th>',
'    </tr>',
'  </thead>',
'  <tbody>',
'    <tr><td><span class="class">padding-<span class="class-value">none</span></span></td><td>No padding</td></tr>',
'    <tr><td><span class="class">padding-<span class="class-value">sm</span></span></td><td>8 px padding</td></tr>',
'    <tr><td><span class="class">padding-<span class="class-value">md</span></span></td><td>16 px padding</td></tr>',
'    <tr><td><span class="class">padding-<span class="class-value">lg</span></span></td><td>32 px padding</td></tr>',
'  </tbody>',
'</table>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585578852382652773)
,p_plug_name=>'Examples'
,p_parent_plug_id=>wwv_flow_api.id(585578629380652770)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre class="dm-Code lang-html"><code>&lt;button class="padding-lg"&gt;Large button&lt;/button&gt;',
'&lt;div class="padding-left-md"&gt;Little bit of padding on the side.&lt;/div&gt;</code></pre>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1067859625786004021)
,p_plug_name=>'Introduction'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h1'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>You can use the following utility classes anywhere in your app to fine-tune the layout of your page and components. For most Oracle APEX components, you can simply populate the <b>CSS Classes</b> property to apply these modifiers to your page comp'
||'onents.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1083165132535677870)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3913193530895552122)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_06304
begin
wwv_flow_api.create_page(
 p_id=>6304
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Content Modifiers'
,p_alias=>'CONTENT-MODIFIERS'
,p_step_title=>'Content Modifiers - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.class,',
'.class-value,',
'.class-desc {',
'    display: inline-block;',
'    font-size: 12px;',
'    font-family: ''Menlo'',''Consolas'',monospace;',
'}',
'.class {',
'    color: #9C27B0;',
'}',
'.class.tag {',
'    padding: 4px 8px;',
'    background-color: #FFF;',
'    border-radius: 2px;',
'    box-shadow: inset rgba(225, 190, 231, .25) 0 0 0 1px;',
'}',
'.class-value {',
'    color: #008676;',
'    min-width: 40px;',
'}',
'.class-var {',
'    font-weight: bold;',
'    color: #008676;',
'}',
'.dm-Report--doc {',
'    background: #FFF;',
'    border: 1px solid rgba(0,0,0,.05);',
'}',
'.dm-Report--doc th, ',
'.dm-Report--doc td {',
'    padding: 8px;',
'    min-height: 32px;',
'    background-color: transparent;',
'    border-width: 0 0 1px 0;',
'    border-style: solid;',
'    border-color: rgba(0,0,0,.05);',
'}',
'.dm-Report--doc td {',
'    vertical-align: top;',
'}',
'.dm-Report--doc tr:last-child td {',
'    border-bottom-width: 0;',
'}',
'.dm-Report--doc .class {',
'    min-width: 40px;',
'}',
'.dm-Report--doc .class-desc {',
'    width: 48px;',
'    text-align: right;',
'    color: rgba(0,0,0,.55);',
'    border-radius: 2px;',
'}'))
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585594300128673104)
,p_plug_name=>'Accessibility'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>These classes can help you build more accessible apps and help you design a more usable experience for all users.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585595731955673118)
,p_plug_name=>'Classes'
,p_parent_plug_id=>wwv_flow_api.id(585594300128673104)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="u-Report u-Report--staticBG u-Report--stretch dm-Report--doc">',
'  <thead>',
'    <tr>',
'      <th style="width: 30%" class="u-textStart">Class</th>',
'      <th class="u-textStart">Description</th>',
'    </tr>',
'  </thead>',
'  <tbody>',
'    <tr><td><span class="class">u-VisuallyHidden</span></td><td>This will make any text visually hidden, but still accessible for screen readers and other assistive technologies.</td></tr>',
'  </tbody>',
'</table>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585595318840673114)
,p_plug_name=>'Text Transform'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h1'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>These classes are useful when you want to control the text case for a given component. For example, an input field where you want characters to display in upper case. </p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585595341563673115)
,p_plug_name=>'Classes'
,p_parent_plug_id=>wwv_flow_api.id(585595318840673114)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="u-Report u-Report--staticBG u-Report--stretch dm-Report--doc">',
'  <thead>',
'    <tr>',
'      <th style="width: 30%" class="u-textStart">Class</th>',
'      <th class="u-textStart">Description</th>',
'    </tr>',
'  </thead>',
'  <tbody>',
'    <tr><td><span class="class">u-text<span class="class-value">Upper</span></span></td><td class="u-textUpper">Sets the text to use all uppercase</td></tr>',
'    <tr><td><span class="class">u-text<span class="class-value">Lower</span></span></td><td class="u-textLower">Sets the text to use all lowercase</td></tr>',
'    <tr><td><span class="class">u-text<span class="class-value">InitCap</span></span></td><td class="u-textInitCap">Sets the first letter in each word to use uppercase</td></tr>',
'  </tbody>',
'</table>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585595490785673116)
,p_plug_name=>'Text Style'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h1'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>Use these classes as simple modifiers to control the text style of a given component. For example, you may want to use the <span class="class tag">u-bold</span> to make the text of a button have a stronger weight.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585595611779673117)
,p_plug_name=>'Classes'
,p_parent_plug_id=>wwv_flow_api.id(585595490785673116)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="u-Report u-Report--staticBG u-Report--stretch dm-Report--doc">',
'  <thead>',
'    <tr>',
'      <th style="width: 30%" class="u-textStart">Class</th>',
'      <th class="u-textStart">Description</th>',
'    </tr>',
'  </thead>',
'  <tbody>',
'    <tr><td><span class="class">u-bold</span></td><td class="u-bold">Bolds text</td></tr>',
'    <tr><td><span class="class">u-italics</span></td><td class="u-italics">Italicize text</td></tr>',
'    <tr><td><span class="class">u-underline</span></td><td class="u-underline">Underlines text</td></tr>',
'    <tr><td><span class="class">u-fixedFont</span></td><td class="u-fixedFont">Use a fixed-letter-space font</td></tr>',
'  </tbody>',
'</table>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1067859705517004022)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1922209187092703219)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1075550368691899521)
,p_plug_name=>'Introduction'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h1'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>You can use the following utility classes anywhere in your app to fine-tune the layout of your page and components. For most Oracle APEX components, you can simply populate the <b>CSS Classes</b> property to apply these modifiers to your page comp'
||'onents.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1673811976926149621)
,p_plug_name=>'Text Alignment'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h1'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>These classes are direction aware, meaning the text direction will be based on the direction of the language. For example, text using the <span class="class tag">u-text<span class="class-var">Start</span></span> class will align text to the left f'
||'or Left-to-Right languages, and will align text to the right for Right-to-Left languages.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2171399212521174728)
,p_plug_name=>'Classes'
,p_parent_plug_id=>wwv_flow_api.id(1673811976926149621)
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="u-Report u-Report--staticBG u-Report--stretch dm-Report--doc">',
'  <thead>',
'    <tr>',
'      <th style="width: 30%" class="u-textStart">Class</th>',
'      <th class="u-textStart">Description</th>',
'    </tr>',
'  </thead>',
'  <tbody>',
'    <tr><td><span class="class">u-text<span class="class-value">Start</span></span></td><td class="u-textStart">Align text to the start of the container</td></tr>',
'    <tr><td><span class="class">u-text<span class="class-value">Center</span></span></td><td class="u-textCenter">Align text to the center of the container</td></tr>',
'    <tr><td><span class="class">u-text<span class="class-value">End</span></span></td><td class="u-textEnd">Align text to the end of the container</td></tr>',
'  </tbody>',
'</table>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4794578675920547029)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_06305
begin
wwv_flow_api.create_page(
 p_id=>6305
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Change Log'
,p_alias=>'CHANGE-LOG'
,p_step_title=>'Change Log - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(713639924515207048)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5167872910997496892)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_06306
begin
wwv_flow_api.create_page(
 p_id=>6306
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'FAQ'
,p_alias=>'FAQ2'
,p_step_title=>'FAQ - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(713639924515207048)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4286505466790534595)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_06307
begin
wwv_flow_api.create_page(
 p_id=>6307
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Component Templates'
,p_alias=>'COMPONENT-TEMPLATES'
,p_step_title=>'Component Templates - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(713639924515207048)
,p_javascript_code_onload=>'apex.theme42demo.jump( ''&REQUEST.'' );'
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(389368754295558721)
,p_plug_name=>'Page Templates'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(1725945334801719893)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(2623332529225852414)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1722815299066373040)
,p_plug_name=>'Regions'
,p_region_name=>'region'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_component_template_options=>'#DEFAULT#:u-colors'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(476431339368267518)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1722815399874373041)
,p_plug_name=>'Lists'
,p_region_name=>'lists'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_component_template_options=>'#DEFAULT#:u-colors'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(476573383197691871)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1722815436196373042)
,p_plug_name=>'Reports'
,p_region_name=>'reports'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_component_template_options=>'#DEFAULT#:u-colors'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(476579719264733455)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1722815521042373043)
,p_plug_name=>'Buttons'
,p_region_name=>'buttons'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_component_template_options=>'#DEFAULT#:u-colors'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(476584406006772879)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1722815663970373044)
,p_plug_name=>'Forms'
,p_region_name=>'forms'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_component_template_options=>'#DEFAULT#:u-colors'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(476588768580793809)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2152194512864275434)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3309913966122190451)
,p_plug_name=>'Pages'
,p_region_name=>'page'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h2:t-ContentBlock--lightBG'
,p_component_template_options=>'#DEFAULT#:u-colors'
,p_plug_template=>wwv_flow_api.id(873087052820635270)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(1917756475003302943)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6976655967260354359)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1722815816623373046)
,p_name=>'Jumping'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'NEVER'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1722815969084373047)
,p_event_id=>wwv_flow_api.id(1722815816623373046)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(6976655967260354359)
);
end;
/
prompt --application/pages/page_06308
begin
wwv_flow_api.create_page(
 p_id=>6308
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Region Types'
,p_alias=>'REGION-TYPES'
,p_step_title=>'Region Types - &APP_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(713639924515207048)
,p_step_template=>wwv_flow_api.id(2623327345562852400)
,p_page_css_classes=>'dm-Page dm-Page--center'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2152194482718275433)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1082434711915925186)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_menu_id=>wwv_flow_api.id(1725934084712570512)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(2623334730651852421)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3778718605227475097)
,p_plug_name=>'Region Types'
,p_region_name=>'forms'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#:u-colors'
,p_plug_template=>wwv_flow_api.id(2623330321607852408)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(2055911789926116545)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(618966256865274517)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2055906316963102119)
,p_name=>'Jumping'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'NEVER'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2055906741751102122)
,p_event_id=>wwv_flow_api.id(2055906316963102119)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'REGION'
);
end;
/
prompt --application/pages/page_09999
begin
wwv_flow_api.create_page(
 p_id=>9999
,p_user_interface_id=>wwv_flow_api.id(821272323468330288)
,p_name=>'Login Page'
,p_alias=>'LOGIN-PAGE2'
,p_step_title=>'Login Page'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(652129338145143712)
,p_page_template_options=>'#DEFAULT#:t-LoginPage--split:t-LoginPage--bg3'
,p_page_is_public_y_n=>'Y'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210827105544'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(477289393058659768)
,p_plug_name=>'UT - Login Test'
,p_icon_css_classes=>'app-sample-universal-theme'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1225129382632869472)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(477294021274659870)
,p_plug_name=>'Language Selector'
,p_parent_plug_id=>wwv_flow_api.id(477289393058659768)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(3052412050530173647)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'apex_lang.emit_language_selector_list;'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_num_rows=>15
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(238650022512834093)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(477289393058659768)
,p_button_name=>'LOGIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2623334346116852418)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Sign In'
,p_button_position=>'NEXT'
,p_button_alignment=>'LEFT'
,p_grid_new_row=>'Y'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(238650481877834102)
,p_name=>'P9999_USERNAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(477289393058659768)
,p_prompt=>'username'
,p_placeholder=>'Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>100
,p_field_template=>wwv_flow_api.id(591757292230152601)
,p_item_icon_css_classes=>'fa-user'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(238650856819834107)
,p_name=>'P9999_PASSWORD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(477289393058659768)
,p_prompt=>'password'
,p_placeholder=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>40
,p_cMaxlength=>100
,p_field_template=>wwv_flow_api.id(591757292230152601)
,p_item_icon_css_classes=>'fa-key'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(238651232125834108)
,p_name=>'P9999_REMEMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(477289393058659768)
,p_prompt=>'Remember Username'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC:Remember username;Y'
,p_field_template=>wwv_flow_api.id(591757292230152601)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If you select this checkbox, the application will save your username in a persistent browser cookie named "LOGIN_USERNAME_COOKIE".',
'When you go to the login page the next time,',
'the username field will be automatically populated with this value.',
'</p>',
'<p>',
'If you deselect this checkbox and your username is already saved in the cookie,',
'the application will overwrite it with an empty value.',
'You can also use your browser''s developer tools to completely remove the cookie.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(238652876241834124)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Username Cookie'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_authentication.send_login_username_cookie (',
'    p_username => lower(:P9999_USERNAME),',
'    p_consent  => :P9999_REMEMBER = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(238652465580834122)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Login'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_authentication.login(',
'    p_username => :P9999_USERNAME,',
'    p_password => :P9999_PASSWORD );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(238653680508834124)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Page(s) Cache'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(238653242175834124)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Username Cookie'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P9999_USERNAME := apex_authentication.get_login_username_cookie;',
':P9999_REMEMBER := case when :P9999_USERNAME is not null then ''Y'' end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/deployment/definition
begin
wwv_flow_api.create_install(
 p_id=>wwv_flow_api.id(2024243276378746659)
,p_welcome_message=>'This application installer will guide you through the process of creating your database objects and seed data.'
,p_configuration_message=>'You can configure the following attributes of your application.'
,p_build_options_message=>'You can choose to include the following build options.'
,p_validation_message=>'The following validations will be performed to ensure your system is compatible with this application.'
,p_install_message=>'Please confirm that you would like to install this application''s supporting objects.'
,p_upgrade_message=>'The application installer has detected that this application''s supporting objects were previously installed.  This wizard will guide you through the process of upgrading these supporting objects.'
,p_upgrade_confirm_message=>'Please confirm that you would like to install this application''s supporting objects.'
,p_upgrade_success_message=>'Your application''s supporting objects have been installed.'
,p_upgrade_failure_message=>'Installation of database objects and seed data has failed.'
,p_deinstall_success_message=>'Deinstallation complete.'
,p_deinstall_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'drop table EBA_UT_chart_projects       cascade constraints;',
'drop table EBA_UT_chart_tasks          cascade constraints;',
'drop table EBA_UT_demo_cards           cascade constraints;'))
,p_required_free_kb=>100
,p_required_sys_privs=>'CREATE PROCEDURE:CREATE TABLE:CREATE TRIGGER:CREATE VIEW'
,p_required_names_available=>'EBA_UT_CHART_PROJECTS:EBA_UT_CHART_TASKS:EBA_UT_DEMO_CARDS'
);
end;
/
prompt --application/deployment/install/upgrade_add_cards_demo_table_and_data
begin
wwv_flow_api.create_install_script(
 p_id=>wwv_flow_api.id(748951837537058684)
,p_install_id=>wwv_flow_api.id(2024243276378746659)
,p_name=>'Add Cards Demo Table and Data'
,p_sequence=>10
,p_script_type=>'UPGRADE'
,p_condition_type=>'NOT_EXISTS'
,p_condition=>'select null from user_tables where table_name = ''EBA_UT_DEMO_CARDS'''
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'create table eba_ut_demo_cards (',
'    id                             number               not null',
'                                                        constraint eba_ut_demo_cards_id_pk',
'                                                        primary key,',
'    category                       varchar2(255 char)   not null,',
'    title                          varchar2(255 char)   not null,',
'    subtitle                       varchar2(255 char)   not null,',
'    body                           varchar2(4000 char)  not null,',
'    secondary_body                 varchar2(4000 char),',
'    icon_class                     varchar2(255 char),',
'    badge                          varchar2(255 char),',
'    image_url                      varchar2(255 char)   not null,',
'    start_date                     timestamp with time zone,',
'    end_date                       timestamp with time zone',
')',
'/',
'',
'create or replace trigger biu_eba_ut_demo_cards',
'   before insert or update on eba_ut_demo_cards',
'   for each row ',
'begin  ',
'   if :new."ID" is null then',
'     select to_number(sys_guid(),''XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'') into :new.id from dual;',
'   end if;',
'end;',
'/',
'',
'alter trigger biu_eba_ut_demo_cards enable',
'/',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(1, ''conference'', ''Accessibility'', ''Creating Accessible Apps'', ''This conference breaks down all aspects of creating accessible web applications. We focus on the latest World Wide Web Consortium (W3C) standards in sessions discussing tables, labels, f'
||'orms, images, color contrast, links, page structure, screen reader testing, and Voluntary Product Accessibility Templates (VPATs). The conference starts at 8am  and ends at 4pm. Lunch will be served, with vegan options for those interested.'', ''<ul>',
'<li>8am-9am: Tables</li>',
'<li>9am-10am: Labels and Forms</li>',
'<li>10am-11am: Images and Color Contrast</li>',
'<li>11am-Noon: Links and Page Structure</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Screen Reader Analyzation</li>',
'<li>2pm-3pm: Voluntary Product Accessibility Templates (VPATs)</li>',
'<li>3pm-4pm: Review and Q&A</li>',
'</ul>'', ''fa-universal-access'', ''200.00'', ''img/adaptable.jpg'',',
'cast(trunc(sysdate + 10) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 10) as timestamp with time zone) + interval ''16'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(2, ''conference'', ''Security'', ''Creating Secure Apps'', ''This conference discusses all aspects of securing/hardening a web application. You''''ll learn how to protect against Cross Side Scripting vulnerabilities and SQL Injection attacks. Other topics di'
||'scussed are virus protection, VPNs and port sniffing, phishing and malware, and handling data breaches. The conference starts at 8am and ends at 4pm. Lunch will be served, with vegan options for those interested.'', ''<ul>',
'<li>8am-9am: Cross Side Scripting</li>',
'<li>9am-10am: SQL Injection</li>',
'<li>10am-11am: Virus Protection</li>',
'<li>11am-Noon: VPNs and Port Sniffing</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Phishing and Malware</li>',
'<li>2pm-3pm: Handling Data Breaches</li>',
'<li>3pm-4pm: Review and Q&A</li>',
'</ul>'', ''fa-lock'', ''200.00'', ''img/discovery.jpg'',',
'cast(trunc(sysdate + 20) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 20) as timestamp with time zone) + interval ''16'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(3, ''conference'', ''Responsive Design'', ''Creating Responsive Apps'', ''This conference discusses all aspects of making a web application responsive. We will discuss topics like responsive design, minimalism, parallax vs. infinite scrolling, cross-browse'
||'r compatibility, typography, and CSS animations. The conference starts at 8am and ends at 4pm. Lunch will be served, with vegan options for those interested.'', ''<ul>',
'<li>8am-9am: Responsive Design</li>',
'<li>9am-10am: Minimalism</li>',
'<li>10am-11am: Parallax vs. Infinite Scrolling</li>',
'<li>11am-Noon: Cross-Browser Compatibility</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Typography</li>',
'<li>2pm-3pm: CSS Animations</li>',
'<li>3pm-4pm: Review and Q&A</li>',
'</ul>'', ''fa-arrows-h'', ''200.00'', ''img/construction-and-engineering.jpg'',',
'cast(trunc(sysdate + 30) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 30) as timestamp with time zone) + interval ''16'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(4, ''conference'', ''Slack Integration'', ''Integrate Slack Into Your Apps'', ''This conference shows how to integrate Slack into your web application. We will discuss topics like the Slack API, channels, channel topics vs. descriptions, markdown, and thir'
||'d party vendor integration. The conference starts at 8am and ends at 3pm. Lunch will be served, with vegan options for those interested.'', ''<ul>',
'<li>8am-9am: Slack API</li>',
'<li>9am-10am: Channels</li>',
'<li>10am-11am: Channel Topics vs. Descriptions</li>',
'<li>11am-Noon: Markdown</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: 3rd Party Vendor Integration</li>',
'<li>2pm-3pm: Review and Q&A</li>',
'</ul>'', ''fa-comment-o'', ''200.00'', ''img/diversity.jpg'',',
'cast(trunc(sysdate + 40) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 40) as timestamp with time zone) + interval ''15'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(5, ''conference'', ''Blockchain'', ''Understanding Blockchain'', ''This conference will cover high value payments, enhancements in transactions including IoT and Supply Chain Automation. Bring your own Laptop. The conference starts at 8am and ends at 5pm. '
||'Lunch will be provided. If you have special dietary requirements, please send an email to the organizers.'', ''<ul>',
'<li>8am-9am: Introduction to Blockchain</li>',
'<li>9am-10am: High Value Payments</li>',
'<li>10am-11am: Enhancements in Transactions</li>',
'<li>11am-Noon: Data and Finances</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Mobility and IoT</li>',
'<li>2pm-3pm: Standards for Blockchain Adoption</li>',
'<li>3pm-4pm: Supply Chain Automation with Blockchain</li>',
'<li>4pm-5pm: Review and Q&A</li>',
'</ul>'', ''fa-cubes'', ''300.00'', ''img/blockchain.jpg'',',
'cast(trunc(sysdate + 50) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 50) as timestamp with time zone) + interval ''17'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(6, ''conference'', ''Localizations'', ''Preparing your app for a global audience'', ''This conference focuses on important considerations needed to ensure an application can reach a global audience, it covers the difference between automated and manual tra'
||'nslations, User eXperience analysis, handling of sensitive data during translations, and some standards and definitions important for the target markets. Lunch will be at noon. It starts at 8 am and ends at 3 pm.'', ''<ul>',
'<li>8am-9am: Global Audience Analysis</li>',
'<li>9am-10am: Automated vs Manual Translations</li>',
'<li>10am-11am: UX Considerations</li>',
'<li>11am-Noon: Sensitive Data Translations</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Localization Standards and Definitions</li>',
'<li>2pm-3pm: Review and Q&A</li>',
'</ul>'', ''fa-language'', ''140.00'', ''img/best-in-class.jpg'',',
'cast(trunc(sysdate + 60) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 60) as timestamp with time zone) + interval ''15'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(7, ''workshop'', ''Big Data'', ''Performant Searching Against Data Warehouses'', ''This small workshop covers data volume management, its analysis, integration and visualization. It also encompases cost-effective solutions for our potential customers. It s'
||'tarts at 8 am and ends at 2 pm. Lunch is included just before the Q&A.'', ''<ul>',
'<li>8am-9am: Data Volume Management</li>',
'<li>9am-10am: Analysis of Unstructured Data</li>',
'<li>10am-11am: Data Integration and Visualization</li>',
'<li>11am-Noon: Cost-Effective Solutions</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Q&A</li>',
'</ul>'', ''fa-database-wrench'', ''100.00'', ''img/analyze.jpg'', ',
'cast(trunc(sysdate + 15) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 15) as timestamp with time zone) + interval ''14'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(8, ''workshop'', ''Cloud Services'', ''Which Cloud Service Fits Your Needs'', ''In this workshop we will cover protection of your data, containerized apps, shared block storage and cloud tiering when using Oracle Cloud Services. There is focus on optimizin'
||'g work loads and usage analysis. It starts at 8 am and ends at 4 pm. Lunch is served at noon with vegan and meat options.'', ''<ul>',
'<li>8am-9am: Data Protection</li>',
'<li>9am-10am: Legacy to Containerized Apps</li>',
'<li>10am-11am: Shared Block Storage</li>',
'<li>11am-Noon: Cloud Tiering</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Optimizing Work Loads</li>',
'<li>2pm-3pm: Cloud Usage Analysis</li>',
'<li>3pm-4pm: Review and Q&A</li>',
'</ul>'', ''fa-cloud-new'', ''240.00'', ''img/emerging-tech.jpg'',',
'cast(trunc(sysdate + 25) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 25) as timestamp with time zone) + interval ''16'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(9, ''workshop'', ''Quantum Computing'', ''Storing Data in Qubits'', ''In this workshop, the topic of Quantum Computing as a strategy for the future development of applications and services is covered. It will include neural networks, advanced machine learn'
||'ing, natural language processing, quantum simulations and modern applications. It starts at 8 am and ends at 4 pm. Lunch will be served.'', ''<ul>',
'<li>8am-9am: Introduction to Quantum Computing</li>',
'<li>9am-10am: Neural Networks</li>',
'<li>10am-11am: Advanced Machine Learning</li>',
'<li>11am-Noon: Natural Language Processing</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Quantum Simulations</li>',
'<li>2pm-3pm: Modern Applications</li>',
'<li>3pm-4pm: Review and Q&A & Anthony Rayner</li>',
'</ul>'', ''fa-function'', ''350.00'', ''img/ai.jpg'',',
'cast(trunc(sysdate + 35) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 35) as timestamp with time zone) + interval ''16'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(10, ''workshop'', ''HIPAA Compliance'', ''Ensuring Your App Meets HIPAA Compliancies'', ''HIPPA compliance is required for any application that deals with sensitive data such as medical history of patients. In this workshop you will understand the requirem'
||'ents that must be met before release, with special focus on personal sensitive data. It starts at 9 am and ends at 3 pm with lunch served at noon.'', ''<ul>',
'<li>9am-10am: Introduction to HIPAA</li>',
'<li>10am-11am: HIPAA Compliance Checklist</li>',
'<li>11am-Noon: Restricted Personal Data</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: App-Focused Risk Assessment</li>',
'<li>2pm-3pm: Review and Q&A</li>',
'</ul>'', ''fa-medkit'', ''140.00'', ''img/hr.jpg'',',
'cast(trunc(sysdate + 45) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 45) as timestamp with time zone) + interval ''15'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(11, ''workshop'', ''Automated Testing'', ''Validate App Functionality Before Release'', ''This workshop covers automated build tools from you can setup unit, acceptance and UI testing. We will cover continuous integration and version control systems relate'
||'d to automated testing. A manager will provide insight on how to prepare your software quality assurance team to cover all bases before, during and after tests, thus ensuring a release without bugs.'', ''<ul>',
'<li>8am-9am: Automated Build Tools</li>',
'<li>9am-10am: Unit, Acceptance and UI Testing</li>',
'<li>10am-11am: Continuous Integration (CI)</li>',
'<li>11am-Noon: Version Control Systems</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Coding Standards</li>',
'<li>2pm-3pm: Managing Integrated Testing Projects</li>',
'<li>3pm-4pm: Review and Q&A</li>',
'</ul>'', ''fa-check-square-o'', ''300.00'', ''img/chatbots.jpg'',',
'cast(trunc(sysdate + 55) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 55) as timestamp with time zone) + interval ''16'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(12, ''workshop'', ''Database Modeling'', ''Design Data Models With Referential Integrity'', ''This workshop covers several design patterns for data modeling, including graphs and classic models. There will be software tools available for the hands-on lab, '
||'so bring your laptop. It will start at 8 am and ends at 4 pm. Lunch will be served, with vegan options for those interested.'', ''<ul>',
'<li>8am-9am: Data Models Overview</li>',
'<li>9am-10am: Graph Data Models</li>',
'<li>10am-11am: Classic Data Modeling</li>',
'<li>11am-Noon: Performance-Driven Analysis</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Software Tools for Data Modeling</li>',
'<li>2pm-3pm: Data Models Hands-on Lab</li>',
'<li>3pm-4pm: Review and Q&A</li>',
'</ul>'', ''fa-database'', ''220.00'', ''img/collaboration.jpg'',',
'cast(trunc(sysdate + 65) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 65) as timestamp with time zone) + interval ''16'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(13, ''badge'', ''Fernanda Mendez'', ''Product Manager'', ''fernanda.mendez@yourcompany.com'', null, null, null, ''img/persona-female01-apex.png'', null, null);',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(14, ''badge'', ''Krist Grohl'', ''Quality Manager'', ''k.grohl@yourcompany.com'', null, null, null, ''img/persona-male03.png'', null, null);',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(15, ''badge'', ''Charles Statman'', ''QA Specialist'', ''charlie.s@yourcompany.com'', null, null, null, ''img/persona-male01-apex.png'', null, null);',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(16, ''badge'', ''Susan Parrish'', ''Software Developer'', ''susan.parrish@yourcompany.com'', null, null, null, ''img/persona-female04-oracle.png'', null, null);',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(17, ''badge'', ''Johnnathan Brie'', ''Team Lead'', ''johnathan.b@yourcompany.com'', null, null, null, ''img/persona-male04-apex.png'', null, null);',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(18, ''badge'', ''Diana Flores'', ''CFO'', ''diana.flores@yourcompany.com'', null, null, null, ''img/persona-female03.png'', null, null);'))
);
end;
/
prompt --application/deployment/install/install_create_tables
begin
wwv_flow_api.create_install_script(
 p_id=>wwv_flow_api.id(2024244233377754866)
,p_install_id=>wwv_flow_api.id(2024243276378746659)
,p_name=>'Create Tables'
,p_sequence=>10
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ALTER SESSION SET PLSCOPE_SETTINGS = ''IDENTIFIERS:NONE'';',
'',
'',
'create table  EBA_UT_chart_projects (',
'    id                   number         not null',
'                                        constraint EBA_UT_charts_proj_pk',
'                                        primary key,',
'    project              varchar2(30)   not null,',
'    row_version_number   number,',
'    created              timestamp,',
'    created_by           varchar2(255),',
'    updated              timestamp,',
'    updated_by           varchar2(255)',
'   )',
'/',
'',
'REM EBA_UT_chart_tasks    ',
'create table  EBA_UT_chart_tasks (',
'    id                       number         not null',
'                                            constraint EBA_UT_chart_tasks_pk',
'                                            primary key,',
'    project                  number         constraint EBA_UT_chart_tasks_fk',
'                                            references EBA_UT_chart_projects on delete cascade,',
'    parent_task              number,',
'    task_name                varchar2(255),',
'    row_version_number       number,',
'    start_date               date,',
'    end_date                 date,',
'    status                   varchar2(30),',
'    assigned_to              varchar2(30),',
'    cost                     number,',
'    budget                   number,',
'    created                  timestamp,',
'    created_by               varchar2(255),',
'    updated                  timestamp,',
'    updated_by               varchar2(255)',
'   )',
'/',
'',
'create index EBA_UT_chart_tasks_idx1 on EBA_UT_chart_tasks (project);',
'/',
'',
'',
'create or replace trigger biu_EBA_UT_chart_proj ',
'   before insert or update on EBA_UT_chart_projects',
'   for each row ',
'begin  ',
'   if :new."ID" is null then',
'     select to_number(sys_guid(),''XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'') into :new.id from dual;',
'   end if;',
'   if inserting then',
'       :new.created := localtimestamp;',
'       :new.created_by := nvl(wwv_flow.g_user,user);',
'       :new.updated := localtimestamp;',
'       :new.updated_by := nvl(wwv_flow.g_user,user);',
'   end if;',
'   if inserting or updating then',
'       :new.updated := localtimestamp;',
'       :new.updated_by := nvl(wwv_flow.g_user,user);',
'   end if;',
'   if inserting then',
'       :new.row_version_number := 1;',
'   elsif updating then',
'       :new.row_version_number := nvl(:old.row_version_number,1) + 1;',
'   end if;',
'end;',
'/',
'    ',
'alter trigger biu_EBA_UT_chart_proj enable',
'/',
'    ',
'create or replace trigger biu_EBA_UT_chart_tasks',
'   before insert or update on EBA_UT_chart_tasks',
'   for each row',
'begin  ',
'   if :new."ID" is null then',
'     select to_number(sys_guid(),''XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'') into :new.id from dual;',
'   end if;',
'   if inserting then',
'       :new.created := localtimestamp;',
'       :new.created_by := nvl(wwv_flow.g_user,user);',
'       :new.updated := localtimestamp;',
'       :new.updated_by := nvl(wwv_flow.g_user,user);',
'   end if;',
'   if inserting or updating then',
'       :new.updated := localtimestamp;',
'       :new.updated_by := nvl(wwv_flow.g_user,user);',
'   end if;',
'   if inserting then',
'       :new.row_version_number := 1;',
'   elsif updating then',
'       :new.row_version_number := nvl(:old.row_version_number,1) + 1;',
'   end if;',
'end;',
'/',
'    ',
'alter trigger biu_EBA_UT_chart_tasks enable',
'/',
'',
'create table eba_ut_demo_cards (',
'    id                             number               not null',
'                                                        constraint eba_ut_demo_cards_id_pk',
'                                                        primary key,',
'    category                       varchar2(255 char)   not null,',
'    title                          varchar2(255 char)   not null,',
'    subtitle                       varchar2(255 char)   not null,',
'    body                           varchar2(4000 char)  not null,',
'    secondary_body                 varchar2(4000 char),',
'    icon_class                     varchar2(255 char),',
'    badge                          varchar2(255 char),',
'    image_url                      varchar2(255 char)   not null,',
'    start_date                     timestamp with time zone,',
'    end_date                       timestamp with time zone',
')',
'/',
'',
'create or replace trigger biu_eba_ut_demo_cards',
'   before insert or update on eba_ut_demo_cards',
'   for each row ',
'begin  ',
'   if :new."ID" is null then',
'     select to_number(sys_guid(),''XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'') into :new.id from dual;',
'   end if;',
'end;',
'/',
'',
'alter trigger biu_eba_ut_demo_cards enable',
'/',
'',
'insert into EBA_UT_chart_projects (ID,PROJECT) values (1,''Maintain Support Systems'');',
'insert into EBA_UT_chart_projects (ID,PROJECT) values (2,''Load Software'');',
'insert into EBA_UT_chart_projects (ID,PROJECT) values (3,''Email Integration'');',
'insert into EBA_UT_chart_projects (ID,PROJECT) values (4,''Documentation'');',
'insert into EBA_UT_chart_projects (ID,PROJECT) values (5,''Training'');',
'insert into EBA_UT_chart_projects (ID,PROJECT) values (6,''Bug Tracker'');',
'insert into EBA_UT_chart_projects (ID,PROJECT) values (7,''Migrate Old Systems'');',
'insert into EBA_UT_chart_projects (ID,PROJECT) values (8,''Software Projects Tracking'');',
'insert into EBA_UT_chart_projects (ID,PROJECT) values (9,''Public Website'');',
'insert into EBA_UT_chart_projects (ID,PROJECT) values (10,''Early Adopter Release'');',
'insert into EBA_UT_chart_projects (ID,PROJECT) values (11,''Environment Configuration'');',
'insert into EBA_UT_chart_projects (ID,PROJECT) values (12,''Customer Satisfaction Survey'');',
'insert into EBA_UT_chart_projects (ID,PROJECT) values (13,''Convert Excel Spreadsheet'');',
'insert into EBA_UT_chart_projects (ID,PROJECT) values (14,''Upgrade Equipment'');',
'    ',
'',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (74,14,''Decommission servers'',to_date(''01-02-12'',''DD-MM-RR''),to_date(''30-04-12'',''DD-MM-RR''),''Pending'',''Al Bines'',0,500,nul'
||'l);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (75,6,''Measure effectiveness of improved QA'',to_date(''01-02-12'',''DD-MM-RR''),to_date(''02-03-12'',''DD-MM-RR''),''Pending'',''Myra'
||' Sutcliff'',0,1500,18);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (76,10,''Response to Customer Feedback'',to_date(''01-02-12'',''DD-MM-RR''),to_date(''25-05-12'',''DD-MM-RR''),''Pending'',''Russ Saund'
||'ers'',0,6000,33);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (77,10,''User acceptance testing'',to_date(''16-02-12'',''DD-MM-RR''),to_date(''20-05-12'',''DD-MM-RR''),''Pending'',''Russ Saunders'',0'
||',2500,33);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (78,10,''End-user Training'',to_date(''20-03-12'',''DD-MM-RR''),to_date(''01-06-12'',''DD-MM-RR''),''Pending'',''Myra Sutcliff'',0,2500,'
||'79);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (79,10,''Rollout sample applications'',to_date(''23-05-12'',''DD-MM-RR''),to_date(''03-06-12'',''DD-MM-RR''),''Pending'',''Pam King'',0,'
||'500,32);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (72,14,''Installation'',to_date(''03-02-12'',''DD-MM-RR''),to_date(''04-03-12'',''DD-MM-RR''),''Pending'',''Mark Nile'',0,1500,67);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (73,14,''Notify users'',to_date(''06-03-12'',''DD-MM-RR''),to_date(''09-03-12'',''DD-MM-RR''),''Pending'',''Mark Nile'',0,200,67);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (34,10,''Plan production release schedule'',to_date(''22-12-11'',''DD-MM-RR''),to_date(''22-12-11'',''DD-MM-RR''),''Closed'',''Pam King'
||''',100,100,32);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (37,12,''Complete questionnaire'',to_date(''18-12-11'',''DD-MM-RR''),to_date(''01-01-11'',''DD-MM-RR''),''On-Hold'',''Irene Jones'',1200'
||',800,38);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (59,11,''Select servers for Development, Test, Production'',to_date(''03-11-11'',''DD-MM-RR''),to_date(''08-11-11'',''DD-MM-RR''),''C'
||'losed'',''James Cassidy'',200,600,61);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (3,1,''HR Support Systems'',to_date(''01-11-11'',''DD-MM-RR''),to_date(''12-03-12'',''DD-MM-RR''),''Closed'',''Al Bines'',300,500,null);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (1,1,''HR software upgrades'',to_date(''01-11-11'',''DD-MM-RR''),to_date(''27-02-12'',''DD-MM-RR''),''On-Hold'',''Pam King'',8000,7000,3'
||');',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (2,1,''Arrange for vacation coverage'',to_date(''01-11-11'',''DD-MM-RR''),to_date(''31-12-11'',''DD-MM-RR''),''On-Hold'',''Russ Sanders'
||''',9500,7000,3);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (4,3,''Complete plan'',to_date(''08-11-11'',''DD-MM-RR''),to_date(''14-12-11'',''DD-MM-RR''),''Closed'',''Mark Nile'',3000,1500,44);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (5,3,''Check software licenses'',to_date(''12-12-11'',''DD-MM-RR''),to_date(''13-12-11'',''DD-MM-RR''),''Closed'',''Mark Nile'',200,200,'
||'44);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (6,5,''Create training workspace'',to_date(''01-12-11'',''DD-MM-RR''),to_date(''08-12-11'',''DD-MM-RR''),''Closed'',''James Cassidy'',50'
||'0,700,36);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (7,5,''Publish links to self-study courses'',to_date(''01-12-11'',''DD-MM-RR''),to_date(''01-12-11'',''DD-MM-RR''),''Closed'',''John Wa'
||'tson'',100,100,36);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (8,2,''Identify point solutions required'',to_date(''03-12-11'',''DD-MM-RR''),to_date(''05-12-11'',''DD-MM-RR''),''Closed'',''John Wats'
||'on'',200,300,49);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (9,2,''Install in development'',to_date(''07-12-11'',''DD-MM-RR''),to_date(''07-12-11'',''DD-MM-RR''),''Closed'',''John Watson'',100,100'
||',49);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (15,4,''Identify owners'',to_date(''19-11-11'',''DD-MM-RR''),to_date(''22-11-11'',''DD-MM-RR''),''Closed'',''Hank Davis'',250,300,17);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (16,4,''Initial Draft Review'',to_date(''23-11-11'',''DD-MM-RR''),to_date(''23-11-11'',''DD-MM-RR''),''Closed'',''Hank Davis'',100,100,1'
||'7);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (17,4,''Monitor Review Comments'',to_date(''23-11-11'',''DD-MM-RR''),to_date(''31-12-11'',''DD-MM-RR''),''Closed'',''Hank Davis'',450,50'
||'0,null);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (18,6,''Implement bug tracking software'',to_date(''15-11-11'',''DD-MM-RR''),to_date(''15-11-11'',''DD-MM-RR''),''Closed'',''Myra Sutcl'
||'iff'',100,100,null);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (19,6,''Review automated testing tools'',to_date(''16-11-11'',''DD-MM-RR''),to_date(''15-12-11'',''DD-MM-RR''),''Closed'',''Myra Sutcli'
||'ff'',2750,1500,18);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (20,7,''Identify pilot applications'',to_date(''10-11-11'',''DD-MM-RR''),to_date(''15-11-11'',''DD-MM-RR''),''Closed'',''Mark Nile'',300'
||',500,53);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (21,7,''Migrate pilot applications to '',to_date(''20-11-11'',''DD-MM-RR''),to_date(''25-11-11'',''DD-MM-RR''),''Closed'',''Mark Nile'','
||'500,500,53);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (22,8,''Customize Software Projects software'',to_date(''15-12-12'',''DD-MM-RR''),to_date(''20-01-12'',''DD-MM-RR''),''Open'',''Tom Sue'
||'ss'',600,1000,28);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (23,7,''Post-migration review'',to_date(''01-12-11'',''DD-MM-RR''),to_date(''01-12-11'',''DD-MM-RR''),''Closed'',''Mark Nile'',100,100,5'
||'3);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (24,7,''User acceptance testing'',to_date(''03-12-11'',''DD-MM-RR''),to_date(''04-12-11'',''DD-MM-RR''),''Closed'',''Mark Nile'',600,200'
||',23);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (25,8,''Enter base data (Projects, Milestones, etc.)'',to_date(''10-12-11'',''DD-MM-RR''),to_date(''11-12-11'',''DD-MM-RR''),''Closed'
||''',''Tom Suess'',200,200,28);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (26,8,''Load current tasks and enhancements'',to_date(''12-12-11'',''DD-MM-RR''),to_date(''16-12-11'',''DD-MM-RR''),''Closed'',''Tom Su'
||'ess'',400,500,28);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (27,6,''Document quality assurance procedures'',to_date(''16-12-11'',''DD-MM-RR''),to_date(''19-01-12'',''DD-MM-RR''),''On-Hold'',''Myr'
||'a Sutcliff'',3500,4000,18);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (28,8,''Conduct project kickoff meeting'',to_date(''05-12-11'',''DD-MM-RR''),to_date(''05-12-11'',''DD-MM-RR''),''Closed'',''Pam King'','
||'100,100,null);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (29,9,''Determine host server'',to_date(''06-12-11'',''DD-MM-RR''),to_date(''07-12-11'',''DD-MM-RR''),''Closed'',''Tiger Scott'',200,200'
||',40);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (30,9,''Check software licenses'',to_date(''07-12-11'',''DD-MM-RR''),to_date(''07-12-11'',''DD-MM-RR''),''Closed'',''Tom Suess'',100,100'
||',40);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (31,10,''Identify pilot users'',to_date(''05-12-11'',''DD-MM-RR''),to_date(''06-12-11'',''DD-MM-RR''),''Closed'',''Scott Spencer'',200,2'
||'00,33);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (32,10,''Software Deliverable'',to_date(''07-12-11'',''DD-MM-RR''),to_date(''20-12-11'',''DD-MM-RR''),''Closed'',''Scott Spencer'',400,5'
||'00,33);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (33,10,''Early Adopter Release'',to_date(''21-12-11'',''DD-MM-RR''),to_date(''21-12-11'',''DD-MM-RR''),''Closed'',''Pam King'',100,100,n'
||'ull);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (35,11,''Determine midtier configuration(s)'',to_date(''02-11-11'',''DD-MM-RR''),to_date(''02-11-11'',''DD-MM-RR''),''Closed'',''James '
||'Cassidy'',100,100,61);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (36,5,''Manage Training Activities'',to_date(''28-11-11'',''DD-MM-RR''),to_date(''03-02-12'',''DD-MM-RR''),''On-Hold'',''John Watson'',1'
||'000,2000,null);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (38,12,''Review feedback'',to_date(''09-01-12'',''DD-MM-RR''),to_date(''15-01-12'',''DD-MM-RR''),''On-Hold'',''Irene Jones'',200,400,nul'
||'l);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (39,12,''Plan rollout schedule'',to_date(''16-01-12'',''DD-MM-RR''),to_date(''24-01-12'',''DD-MM-RR''),''On-Hold'',''Irene Jones'',0,750'
||',38);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (40,9,''Plan rollout schedule'',to_date(''10-12-11'',''DD-MM-RR''),to_date(''02-01-12'',''DD-MM-RR''),''On-Hold'',''Al Bines'',300,1000,'
||'null);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (41,9,''Develop web pages'',to_date(''10-01-12'',''DD-MM-RR''),to_date(''15-02-12'',''DD-MM-RR''),''On-Hold'',''Tiger Scott'',800,2000,4'
||'0);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (42,9,''Purchase additional software licenses, if needed'',to_date(''17-02-12'',''DD-MM-RR''),to_date(''17-02-12'',''DD-MM-RR''),''On'
||'-Hold'',''Tom Suess'',0,100,40);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (43,1,''Investigate new Virus Protection software'',to_date(''29-12-11'',''DD-MM-RR''),to_date(''13-01-12'',''DD-MM-RR''),''Open'',''Pa'
||'m King'',1700,1500,3);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (44,3,''Get RFPs for new server'',to_date(''13-12-11'',''DD-MM-RR''),to_date(''03-01-12'',''DD-MM-RR''),''Open'',''Mark Nile'',2000,1000'
||',null);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (45,13,''Collect mission-critical spreadsheets'',to_date(''15-12-11'',''DD-MM-RR''),to_date(''15-02-12'',''DD-MM-RR''),''Open'',''Pam K'
||'ing'',2500,4000,46);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (46,13,''Create  applications from spreadsheets'',to_date(''15-12-11'',''DD-MM-RR''),to_date(''30-05-12'',''DD-MM-RR''),''Open'',''Pam '
||'King'',6000,10000,null);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (47,13,''Lock spreadsheets'',to_date(''15-12-11'',''DD-MM-RR''),to_date(''30-05-12'',''DD-MM-RR''),''Open'',''Pam King'',1000,800,46);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (48,13,''Send links to previous spreadsheet owners'',to_date(''16-12-11'',''DD-MM-RR''),to_date(''01-06-12'',''DD-MM-RR''),''Open'',''P'
||'am King'',1000,1500,46);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (49,2,''Customize solutions'',to_date(''08-12-11'',''DD-MM-RR''),to_date(''01-03-12'',''DD-MM-RR''),''Open'',''John Watson'',1500,4000,n'
||'ull);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (50,2,''Train developers / users'',to_date(''10-01-12'',''DD-MM-RR''),to_date(''25-03-12'',''DD-MM-RR''),''Pending'',''John Watson'',0,8'
||'000,49);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (51,2,''Implement in Production'',to_date(''27-12-11'',''DD-MM-RR''),to_date(''03-05-12'',''DD-MM-RR''),''Open'',''John Watson'',200,150'
||'0,49);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (52,7,''Migrate applications'',to_date(''15-12-11'',''DD-MM-RR''),to_date(''20-02-12'',''DD-MM-RR''),''Open'',''Mark Nile'',1000,8000,53'
||');',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (53,7,''Plan migration schedule'',to_date(''22-12-11'',''DD-MM-RR''),to_date(''03-03-12'',''DD-MM-RR''),''Open'',''Mark Nile'',1500,6000'
||',null);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (54,10,''Publish Feedback application'',to_date(''26-12-11'',''DD-MM-RR''),to_date(''04-05-12'',''DD-MM-RR''),''Open'',''Pam King'',300,'
||'12000,33);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (55,6,''Train developers on tracking bugs'',to_date(''20-01-12'',''DD-MM-RR''),to_date(''10-03-12'',''DD-MM-RR''),''On-Hold'',''Myra Su'
||'tcliff'',0,2000,18);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (56,7,''End-user Training'',to_date(''28-12-11'',''DD-MM-RR''),to_date(''22-02-12'',''DD-MM-RR''),''Open'',''John Watson'',0,2000,53);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (57,11,''Identify server requirements'',to_date(''01-11-11'',''DD-MM-RR''),to_date(''02-11-11'',''DD-MM-RR''),''Closed'',''John Watson'''
||',100,200,61);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (58,11,''Specify security authentication scheme(s)'',to_date(''03-11-11'',''DD-MM-RR''),to_date(''05-11-11'',''DD-MM-RR''),''Closed'','
||'''John Watson'',200,300,61);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (60,11,''Create pilot workspace'',to_date(''10-11-11'',''DD-MM-RR''),to_date(''10-11-11'',''DD-MM-RR''),''Closed'',''John Watson'',100,1'
||'00,61);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (61,11,''Configure Workspace provisioning'',to_date(''10-11-11'',''DD-MM-RR''),to_date(''10-11-11'',''DD-MM-RR''),''Closed'',''John Wat'
||'son'',200,100,null);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (62,11,''Run installation'',to_date(''11-11-11'',''DD-MM-RR''),to_date(''11-11-11'',''DD-MM-RR''),''Closed'',''James Cassidy'',100,100,5'
||'7);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (64,14,''Obtain equipment specifications'',to_date(''03-01-12'',''DD-MM-RR''),to_date(''06-01-12'',''DD-MM-RR''),''Pending'',''James Ca'
||'ssidy'',0,500,67);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (65,3,''Purchase backup server'',to_date(''12-01-12'',''DD-MM-RR''),to_date(''07-02-12'',''DD-MM-RR''),''Pending'',''Mark Nile'',0,3000,'
||'44);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (66,14,''Identify integration points'',to_date(''08-01-12'',''DD-MM-RR''),to_date(''28-01-12'',''DD-MM-RR''),''Pending'',''Mark Nile'',0'
||',2000,67);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (67,14,''Decommission machines'',to_date(''08-01-12'',''DD-MM-RR''),to_date(''08-01-12'',''DD-MM-RR''),''Pending'',''Scott Spencer'',0,1'
||'00,null);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (68,14,''Map data usage'',to_date(''20-01-12'',''DD-MM-RR''),to_date(''03-03-12'',''DD-MM-RR''),''Pending'',''Mark Nile'',0,8000,67);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (69,14,''Purchase new machines'',to_date(''24-02-12'',''DD-MM-RR''),to_date(''20-03-12'',''DD-MM-RR''),''Pending'',''John Watson'',0,250'
||'0,67);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (70,14,''Import data'',to_date(''25-02-12'',''DD-MM-RR''),to_date(''23-03-12'',''DD-MM-RR''),''Pending'',''John Watson'',0,1000,67);',
'    insert into EBA_UT_chart_tasks (ID,PROJECT,TASK_NAME,START_DATE,END_DATE,STATUS,ASSIGNED_TO,COST,BUDGET,PARENT_TASK) values (71,14,''Convert processes'',to_date(''02-02-12'',''DD-MM-RR''),to_date(''01-04-12'',''DD-MM-RR''),''Pending'',''Pam King'',0,3000,67);',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(1, ''conference'', ''Accessibility'', ''Creating Accessible Apps'', ''This conference breaks down all aspects of creating accessible web applications. We focus on the latest World Wide Web Consortium (W3C) standards in sessions discussing tables, labels, f'
||'orms, images, color contrast, links, page structure, screen reader testing, and Voluntary Product Accessibility Templates (VPATs). The conference starts at 8am  and ends at 4pm. Lunch will be served, with vegan options for those interested.'', ''<ul>',
'<li>8am-9am: Tables</li>',
'<li>9am-10am: Labels and Forms</li>',
'<li>10am-11am: Images and Color Contrast</li>',
'<li>11am-Noon: Links and Page Structure</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Screen Reader Analyzation</li>',
'<li>2pm-3pm: Voluntary Product Accessibility Templates (VPATs)</li>',
'<li>3pm-4pm: Review and Q&A</li>',
'</ul>'', ''fa-universal-access'', ''200.00'', ''img/adaptable.jpg'',',
'cast(trunc(sysdate + 10) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 10) as timestamp with time zone) + interval ''16'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(2, ''conference'', ''Security'', ''Creating Secure Apps'', ''This conference discusses all aspects of securing/hardening a web application. You''''ll learn how to protect against Cross Side Scripting vulnerabilities and SQL Injection attacks. Other topics di'
||'scussed are virus protection, VPNs and port sniffing, phishing and malware, and handling data breaches. The conference starts at 8am and ends at 4pm. Lunch will be served, with vegan options for those interested.'', ''<ul>',
'<li>8am-9am: Cross Side Scripting</li>',
'<li>9am-10am: SQL Injection</li>',
'<li>10am-11am: Virus Protection</li>',
'<li>11am-Noon: VPNs and Port Sniffing</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Phishing and Malware</li>',
'<li>2pm-3pm: Handling Data Breaches</li>',
'<li>3pm-4pm: Review and Q&A</li>',
'</ul>'', ''fa-lock'', ''200.00'', ''img/discovery.jpg'',',
'cast(trunc(sysdate + 20) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 20) as timestamp with time zone) + interval ''16'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(3, ''conference'', ''Responsive Design'', ''Creating Responsive Apps'', ''This conference discusses all aspects of making a web application responsive. We will discuss topics like responsive design, minimalism, parallax vs. infinite scrolling, cross-browse'
||'r compatibility, typography, and CSS animations. The conference starts at 8am and ends at 4pm. Lunch will be served, with vegan options for those interested.'', ''<ul>',
'<li>8am-9am: Responsive Design</li>',
'<li>9am-10am: Minimalism</li>',
'<li>10am-11am: Parallax vs. Infinite Scrolling</li>',
'<li>11am-Noon: Cross-Browser Compatibility</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Typography</li>',
'<li>2pm-3pm: CSS Animations</li>',
'<li>3pm-4pm: Review and Q&A</li>',
'</ul>'', ''fa-arrows-h'', ''200.00'', ''img/construction-and-engineering.jpg'',',
'cast(trunc(sysdate + 30) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 30) as timestamp with time zone) + interval ''16'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(4, ''conference'', ''Slack Integration'', ''Integrate Slack Into Your Apps'', ''This conference shows how to integrate Slack into your web application. We will discuss topics like the Slack API, channels, channel topics vs. descriptions, markdown, and thir'
||'d party vendor integration. The conference starts at 8am and ends at 3pm. Lunch will be served, with vegan options for those interested.'', ''<ul>',
'<li>8am-9am: Slack API</li>',
'<li>9am-10am: Channels</li>',
'<li>10am-11am: Channel Topics vs. Descriptions</li>',
'<li>11am-Noon: Markdown</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: 3rd Party Vendor Integration</li>',
'<li>2pm-3pm: Review and Q&A</li>',
'</ul>'', ''fa-comment-o'', ''200.00'', ''img/diversity.jpg'',',
'cast(trunc(sysdate + 40) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 40) as timestamp with time zone) + interval ''15'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(5, ''conference'', ''Blockchain'', ''Understanding Blockchain'', ''This conference will cover high value payments, enhancements in transactions including IoT and Supply Chain Automation. Bring your own Laptop. The conference starts at 8am and ends at 5pm. '
||'Lunch will be provided. If you have special dietary requirements, please send an email to the organizers.'', ''<ul>',
'<li>8am-9am: Introduction to Blockchain</li>',
'<li>9am-10am: High Value Payments</li>',
'<li>10am-11am: Enhancements in Transactions</li>',
'<li>11am-Noon: Data and Finances</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Mobility and IoT</li>',
'<li>2pm-3pm: Standards for Blockchain Adoption</li>',
'<li>3pm-4pm: Supply Chain Automation with Blockchain</li>',
'<li>4pm-5pm: Review and Q&A</li>',
'</ul>'', ''fa-cubes'', ''300.00'', ''img/blockchain.jpg'',',
'cast(trunc(sysdate + 50) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 50) as timestamp with time zone) + interval ''17'' hour',
');',
'',
'in'))
);
end;
/
begin
wwv_flow_api.append_to_install_script(
 p_id=>wwv_flow_api.id(2024244233377754866)
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(6, ''conference'', ''Localizations'', ''Preparing your app for a global audience'', ''This conference focuses on important considerations needed to ensure an application can reach a global audience, it covers the difference between automated and manual tra'
||'nslations, User eXperience analysis, handling of sensitive data during translations, and some standards and definitions important for the target markets. Lunch will be at noon. It starts at 8 am and ends at 3 pm.'', ''<ul>',
'<li>8am-9am: Global Audience Analysis</li>',
'<li>9am-10am: Automated vs Manual Translations</li>',
'<li>10am-11am: UX Considerations</li>',
'<li>11am-Noon: Sensitive Data Translations</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Localization Standards and Definitions</li>',
'<li>2pm-3pm: Review and Q&A</li>',
'</ul>'', ''fa-language'', ''140.00'', ''img/best-in-class.jpg'',',
'cast(trunc(sysdate + 60) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 60) as timestamp with time zone) + interval ''15'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(7, ''workshop'', ''Big Data'', ''Performant Searching Against Data Warehouses'', ''This small workshop covers data volume management, its analysis, integration and visualization. It also encompases cost-effective solutions for our potential customers. It s'
||'tarts at 8 am and ends at 2 pm. Lunch is included just before the Q&A.'', ''<ul>',
'<li>8am-9am: Data Volume Management</li>',
'<li>9am-10am: Analysis of Unstructured Data</li>',
'<li>10am-11am: Data Integration and Visualization</li>',
'<li>11am-Noon: Cost-Effective Solutions</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Q&A</li>',
'</ul>'', ''fa-database-wrench'', ''100.00'', ''img/analyze.jpg'', ',
'cast(trunc(sysdate + 15) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 15) as timestamp with time zone) + interval ''14'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(8, ''workshop'', ''Cloud Services'', ''Which Cloud Service Fits Your Needs'', ''In this workshop we will cover protection of your data, containerized apps, shared block storage and cloud tiering when using Oracle Cloud Services. There is focus on optimizin'
||'g work loads and usage analysis. It starts at 8 am and ends at 4 pm. Lunch is served at noon with vegan and meat options.'', ''<ul>',
'<li>8am-9am: Data Protection</li>',
'<li>9am-10am: Legacy to Containerized Apps</li>',
'<li>10am-11am: Shared Block Storage</li>',
'<li>11am-Noon: Cloud Tiering</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Optimizing Work Loads</li>',
'<li>2pm-3pm: Cloud Usage Analysis</li>',
'<li>3pm-4pm: Review and Q&A</li>',
'</ul>'', ''fa-cloud-new'', ''240.00'', ''img/emerging-tech.jpg'',',
'cast(trunc(sysdate + 25) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 25) as timestamp with time zone) + interval ''16'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(9, ''workshop'', ''Quantum Computing'', ''Storing Data in Qubits'', ''In this workshop, the topic of Quantum Computing as a strategy for the future development of applications and services is covered. It will include neural networks, advanced machine learn'
||'ing, natural language processing, quantum simulations and modern applications. It starts at 8 am and ends at 4 pm. Lunch will be served.'', ''<ul>',
'<li>8am-9am: Introduction to Quantum Computing</li>',
'<li>9am-10am: Neural Networks</li>',
'<li>10am-11am: Advanced Machine Learning</li>',
'<li>11am-Noon: Natural Language Processing</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Quantum Simulations</li>',
'<li>2pm-3pm: Modern Applications</li>',
'<li>3pm-4pm: Review and Q&A & Anthony Rayner</li>',
'</ul>'', ''fa-function'', ''350.00'', ''img/ai.jpg'',',
'cast(trunc(sysdate + 35) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 35) as timestamp with time zone) + interval ''16'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(10, ''workshop'', ''HIPAA Compliance'', ''Ensuring Your App Meets HIPAA Compliancies'', ''HIPPA compliance is required for any application that deals with sensitive data such as medical history of patients. In this workshop you will understand the requirem'
||'ents that must be met before release, with special focus on personal sensitive data. It starts at 9 am and ends at 3 pm with lunch served at noon.'', ''<ul>',
'<li>9am-10am: Introduction to HIPAA</li>',
'<li>10am-11am: HIPAA Compliance Checklist</li>',
'<li>11am-Noon: Restricted Personal Data</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: App-Focused Risk Assessment</li>',
'<li>2pm-3pm: Review and Q&A</li>',
'</ul>'', ''fa-medkit'', ''140.00'', ''img/hr.jpg'',',
'cast(trunc(sysdate + 45) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 45) as timestamp with time zone) + interval ''15'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(11, ''workshop'', ''Automated Testing'', ''Validate App Functionality Before Release'', ''This workshop covers automated build tools from you can setup unit, acceptance and UI testing. We will cover continuous integration and version control systems relate'
||'d to automated testing. A manager will provide insight on how to prepare your software quality assurance team to cover all bases before, during and after tests, thus ensuring a release without bugs.'', ''<ul>',
'<li>8am-9am: Automated Build Tools</li>',
'<li>9am-10am: Unit, Acceptance and UI Testing</li>',
'<li>10am-11am: Continuous Integration (CI)</li>',
'<li>11am-Noon: Version Control Systems</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Coding Standards</li>',
'<li>2pm-3pm: Managing Integrated Testing Projects</li>',
'<li>3pm-4pm: Review and Q&A</li>',
'</ul>'', ''fa-check-square-o'', ''300.00'', ''img/chatbots.jpg'',',
'cast(trunc(sysdate + 55) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 55) as timestamp with time zone) + interval ''16'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(12, ''workshop'', ''Database Modeling'', ''Design Data Models With Referential Integrity'', ''This workshop covers several design patterns for data modeling, including graphs and classic models. There will be software tools available for the hands-on lab, '
||'so bring your laptop. It will start at 8 am and ends at 4 pm. Lunch will be served, with vegan options for those interested.'', ''<ul>',
'<li>8am-9am: Data Models Overview</li>',
'<li>9am-10am: Graph Data Models</li>',
'<li>10am-11am: Classic Data Modeling</li>',
'<li>11am-Noon: Performance-Driven Analysis</li>',
'<li>Noon-1pm: Lunch</li>',
'<li>1pm-2pm: Software Tools for Data Modeling</li>',
'<li>2pm-3pm: Data Models Hands-on Lab</li>',
'<li>3pm-4pm: Review and Q&A</li>',
'</ul>'', ''fa-database'', ''220.00'', ''img/collaboration.jpg'',',
'cast(trunc(sysdate + 65) as timestamp with time zone) + interval ''8'' hour,',
'cast(trunc(sysdate + 65) as timestamp with time zone) + interval ''16'' hour',
');',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(13, ''badge'', ''Fernanda Mendez'', ''Product Manager'', ''fernanda.mendez@yourcompany.com'', null, null, null, ''img/persona-female01-apex.png'', null, null);',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(14, ''badge'', ''Krist Grohl'', ''Quality Manager'', ''k.grohl@yourcompany.com'', null, null, null, ''img/persona-male03.png'', null, null);',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(15, ''badge'', ''Charles Statman'', ''QA Specialist'', ''charlie.s@yourcompany.com'', null, null, null, ''img/persona-male01-apex.png'', null, null);',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(16, ''badge'', ''Susan Parrish'', ''Software Developer'', ''susan.parrish@yourcompany.com'', null, null, null, ''img/persona-female04-oracle.png'', null, null);',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(17, ''badge'', ''Johnnathan Brie'', ''Team Lead'', ''johnathan.b@yourcompany.com'', null, null, null, ''img/persona-male04-apex.png'', null, null);',
'',
'insert into eba_ut_demo_cards (id, category, title, subtitle, body, secondary_body, icon_class, badge, image_url, start_date, end_date)',
'values',
'(18, ''badge'', ''Diana Flores'', ''CFO'', ''diana.flores@yourcompany.com'', null, null, null, ''img/persona-female03.png'', null, null);',
'',
'update EBA_UT_chart_tasks',
'   set start_date = start_date + (SYSDATE - TO_DATE(''01012012'',''MMDDYYYY'')),',
'       end_date = end_date + (SYSDATE - TO_DATE(''01012012'',''MMDDYYYY''))',
'/',
'',
''))
);
null;
end;
/
prompt --application/deployment/checks
begin
null;
end;
/
prompt --application/deployment/buildoptions
begin
null;
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
