/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojlogger',["exports"],function(o){"use strict";const n={LEVEL_NONE:0,LEVEL_ERROR:1,LEVEL_WARN:2,LEVEL_INFO:3,LEVEL_LOG:4,_METHOD_ERROR:"error",_METHOD_WARN:"warn",_METHOD_INFO:"info",_METHOD_LOG:"log"};n._defaultOptions={level:n.LEVEL_ERROR,writer:null},n._options=n._defaultOptions,n.error=function(o,t){n._write(n.LEVEL_ERROR,n._METHOD_ERROR,arguments)},n.info=function(o,t){n._write(n.LEVEL_INFO,n._METHOD_INFO,arguments)},n.warn=function(o,t){n._write(n.LEVEL_WARN,n._METHOD_WARN,arguments)},n.log=function(o,t){n._write(n.LEVEL_LOG,n._METHOD_LOG,arguments)},n.option=function(o,t){var i,E,e={};if(0===arguments.length){for(E=Object.keys(n._options),i=0;i<E.length;i++)e[E[i]]=n._options[E[i]];return e}if("string"==typeof o&&void 0===t)return void 0===n._options[o]?null:n._options[o];if("string"==typeof o)n._options[o]=t;else{var _=o;for(E=Object.keys(_),i=0;i<E.length;i++)n.option(E[i],_[E[i]])}},n._write=function(o,t,i){if(!(n.option("level")<o)){var E=n._getWriter();if(null!=E){if(1===i.length&&i[0]instanceof Function){var e=i[0]();i=[e]}E[t]&&E[t].apply?E[t].apply(E,i):E[t]&&(E[t]=Function.prototype.bind.call(E[t],E),n._write(o,t,i))}}},n._getWriter=function(){var o=null;return n.option("writer")?o=n.option("writer"):"undefined"!=typeof window&&void 0!==window.console&&(o=window.console),o};const t=n.info,i=n.error,E=n.warn,e=n.log,_=n.option,r=n.LEVEL_ERROR,L=n.LEVEL_INFO,O=n.LEVEL_LOG,l=n.LEVEL_NONE,f=n.LEVEL_WARN;o.LEVEL_ERROR=r,o.LEVEL_INFO=L,o.LEVEL_LOG=O,o.LEVEL_NONE=l,o.LEVEL_WARN=f,o.error=i,o.info=t,o.log=e,o.option=_,o.warn=E,Object.defineProperty(o,"__esModule",{value:!0})});
//# sourceMappingURL=ojlogger.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojcore-base',["ojs/ojlogger"],function(e){"use strict";let t={};"undefined"!=typeof window?t=window:"undefined"!=typeof self&&(t=self);var n=t.oj;const r={version:"11.0.0",revision:"2021-07-01_19-42-54",noConflict:function(){t.oj=n},_registerLegacyNamespaceProp:function(e,t){this[e]=t}};t.oj=r;const o={};r._registerLegacyNamespaceProp("StringUtils",o),o._TRIM_ALL_RE=/^\s*|\s*$/g,o.isEmpty=function(e){return null===e||0===o.trim(e).length},o.isEmptyOrUndefined=function(e){return!(void 0!==e&&!o.isEmpty(e))},o.isString=function(e){return null!==e&&("string"==typeof e||e instanceof String)},o.trim=function(e){return o.isString(e)?e.replace(o._TRIM_ALL_RE,""):e},o.hashCode=function(e){var t=0;if(0===e.length)return t;for(var n=0;n<e.length;n++){t=(t<<5)-t+e.charCodeAt(n),t&=t}return t};const i=function(){};r._registerLegacyNamespaceProp("AgentUtils",i),i.BROWSER={IE:"ie",FIREFOX:"firefox",SAFARI:"safari",CHROME:"chrome",EDGE:"edge",EDGE_CHROMIUM:"edge-chromium",UNKNOWN:"unknown"},i.ENGINE={TRIDENT:"trident",WEBKIT:"webkit",GECKO:"gecko",BLINK:"blink",EDGE_HTML:"edgehtml",UNKNOWN:"unknown"},i.OS={WINDOWS:"Windows",SOLARIS:"Solaris",MAC:"Mac",UNKNOWN:"Unknown",ANDROID:"Android",IOS:"IOS",WINDOWSPHONE:"WindowsPhone",LINUX:"Linux"},i.DEVICETYPE={PHONE:"phone",TABLET:"tablet",OTHERS:"others"},i.getAgentInfo=function(e){o.isEmptyOrUndefined(e)&&(e=navigator.userAgent),e=e.toLowerCase();var t=o.hashCode(e),n=i._currAgentInfo;if(n&&n.hashCode===t)return{os:n.os,browser:n.browser,browserVersion:n.browserVersion,deviceType:n.deviceType,engine:n.engine,engineVersion:n.engineVersion,hashCode:n.hashCode};var r=i.OS.UNKNOWN,s=i.BROWSER.UNKNOWN,a=0,c=i.DEVICETYPE.OTHERS,u=i.ENGINE.UNKNOWN,l=0;return e.indexOf("iphone")>-1||e.indexOf("ipad")>-1||"MacIntel"===navigator.platform&&void 0!==navigator.standalone?r=i.OS.IOS:e.indexOf("mac")>-1?r=i.OS.MAC:e.indexOf("sunos")>-1?r=i.OS.SOLARIS:e.indexOf("android")>-1?r=i.OS.ANDROID:e.indexOf("linux")>-1?r=i.OS.LINUX:e.indexOf("windows phone")>-1?r=i.OS.WINDOWSPHONE:e.indexOf("win")>-1&&(r=i.OS.WINDOWS),r===i.OS.ANDROID?c=e.indexOf("mobile")>-1?i.DEVICETYPE.PHONE:i.DEVICETYPE.TABLET:r===i.OS.IOS&&(c=e.indexOf("iphone")>-1?i.DEVICETYPE.PHONE:i.DEVICETYPE.TABLET),e.indexOf("msie")>-1?(s=i.BROWSER.IE,a=i._parseFloatVersion(e,/msie (\d+[.]\d+)/),e.indexOf("trident")&&(u=i.ENGINE.TRIDENT,l=i._parseFloatVersion(e,/trident\/(\d+[.]\d+)/))):e.indexOf("trident")>-1?(s=i.BROWSER.IE,a=i._parseFloatVersion(e,/rv:(\d+[.]\d+)/),e.indexOf("trident")&&(u=i.ENGINE.TRIDENT,l=i._parseFloatVersion(e,/trident\/(\d+[.]\d+)/))):e.indexOf("edge")>-1?(s=i.BROWSER.EDGE,a=l=i._parseFloatVersion(e,/edge\/(\d+[.]\d+)/),u=i.ENGINE.EDGE_HTML):e.indexOf("edg")>-1?(s=i.BROWSER.EDGE_CHROMIUM,a=i._parseFloatVersion(e,/edg\/(\d+[.]\d+)/),u=i.ENGINE.BLINK,l=a):e.indexOf("chrome")>-1?(s=i.BROWSER.CHROME,(a=i._parseFloatVersion(e,/chrome\/(\d+[.]\d+)/))>=28?(u=i.ENGINE.BLINK,l=a):(u=i.ENGINE.WEBKIT,l=i._parseFloatVersion(e,/applewebkit\/(\d+[.]\d+)/))):e.indexOf("safari")>-1?(s=i.BROWSER.SAFARI,a=i._parseFloatVersion(e,/version\/(\d+[.]\d+)/),u=i.ENGINE.WEBKIT,l=i._parseFloatVersion(e,/applewebkit\/(\d+[.]\d+)/)):e.indexOf("firefox")>-1&&(s=i.BROWSER.FIREFOX,a=i._parseFloatVersion(e,/rv:(\d+[.]\d+)/),u=i.ENGINE.GECKO,l=i._parseFloatVersion(e,/gecko\/(\d+)/)),i._currAgentInfo=n={hashCode:t,os:r,browser:s,browserVersion:a,deviceType:c,engine:u,engineVersion:l},{os:n.os,browser:n.browser,browserVersion:n.browserVersion,deviceType:n.deviceType,engine:n.engine,engineVersion:n.engineVersion,hashCode:n.hashCode}},i._parseFloatVersion=function(e,t){var n=e.match(t);if(n){var r=n[1];if(r)return parseFloat(r)}return 0};const s={};r._registerLegacyNamespaceProp("Assert",s);var a="DEBUG";const c="' doesn't match prototype ";s.forceDebug=function(){s[a]=!0},s.clearDebug=function(){s[a]=!1},s.isDebug=function(){return!0===s[a]},s.assert=function(e,t){if(s[a]&&!e){var n=t||"";if(arguments.length>2){n+="(";for(var r=2;r<arguments.length;r+=1)n+=arguments[r];n+=")"}s.assertionFailed(n,1)}},s.failedInAbstractFunction=function(){s[a]&&s.assertionFailed("Abstract function called",1)},s.assertPrototype=function(e,t,n){if(s[a]){var r=t.prototype;if(null!=e)s.assertType(t,"function",null,1,!1),Object.prototype.isPrototypeOf.call(r,e)||s.assertionFailed("object '"+e+c+r,1,n);else s.assertionFailed("null object doesn't match prototype "+r,1,n)}},s.assertPrototypeOrNull=function(e,t,n){if(s[a]&&null!=e){s.assertType(t,"function",null,1,!1);var r=t.prototype;Object.prototype.isPrototypeOf.call(r,e)||s.assertionFailed("object '"+e+c+r,1,n)}},s.assertPrototypes=function(e,t,n,r){if(s[a]){var o=t.prototype,i=n.prototype,u=Object.prototype.isPrototypeOf;u.call(o,e)||u.call(i,e)||s.assertionFailed("object '"+e+c+o+" or "+i,1,r)}},s.assertDomNodeOrNull=function(e,t){s[a]&&e&&void 0===e.nodeType&&s.assertionFailed(e+" is not a DOM Node",t+1)},s.assertDomNode=function(e,t){s[a]&&(e&&void 0!==e.nodeType||s.assertionFailed(e+" is not a DOM Node",t+1))},s.assertDomElement=function(e,t){s[a]&&(s.assertDomNode(e,1),1!==e.nodeType?s.assertionFailed(e+" is not a DOM Element",1):t&&e.nodeName!==t&&s.assertionFailed(e+" is not a "+t+" Element",1))},s.assertDomElementOrNull=function(e,t){s[a]&&null!=e&&(s.assertDomNode(e,1),1!==e.nodeType?s.assertionFailed(e+" is not a DOM Element",1):t&&e.nodeName!==t&&s.assertionFailed(e+" is not a "+t+" Element",1))},s.assertType=function(e,t,n,r,o){if(s[a]&&!(null==e&&o||typeof e===t)){var i=e+" is not of type "+t;n&&(i=n+i),r||(r=0),s.assertionFailed(i,r+1)}},s.assertObject=function(e,t){s[a]&&s.assertType(e,"object",t,1,!1)},s.assertObjectOrNull=function(e,t){s[a]&&s.assertType(e,"object",t,1,!0)},s.assertNonEmptyString=function(e,t){s[a]&&(s.assertType(e,"string",t,1,!1),s.assert(e.length>0,"empty string"))},s.assertString=function(e,t){s[a]&&s.assertType(e,"string",t,1,!1)},s.assertStringOrNull=function(e,t){s[a]&&s.assertType(e,"string",t,1,!0)},s.assertFunction=function(e,t){s[a]&&s.assertType(e,"function",t,1,!1)},s.assertFunctionOrNull=function(e,t){s[a]&&s.assertType(e,"function",t,1,!0)},s.assertBoolean=function(e,t){s[a]&&s.assertType(e,"boolean",t,1,!1)},s.assertNumber=function(e,t){s[a]&&s.assertType(e,"number",t,1,!1)},s.assertNumberOrNull=function(e,t){s[a]&&s.assertType(e,"number",t,1,!0)},s.assertArray=function(e,t){s[a]&&(Array.isArray(e)||(void 0===t&&(t=e+" is not an array"),s.assertionFailed(t,1)))},s.assertArrayOrNull=function(e,t){s[a]&&null!=e&&(Array.isArray(e)||(void 0===t&&(t=e+" is not an array"),s.assertionFailed(t,1)))},s.assertNonNumeric=function(e,t){s[a]&&(isNaN(e)||(void 0===t&&(t=e+" is convertible to a number"),s.assertionFailed(t,1)))},s.assertNumeric=function(e,t){s[a]&&isNaN(e)&&(void 0===t&&(t=e+" is not convertible to a number"),s.assertionFailed(t,1))},s.assertInSet=function(e,t,n){if(null==e||void 0===t[e.toString()]){if(void 0===n){for(var r=" is not in set: {",o=Object.keys(t),i=0;i<o.length;i++){r+=o[i],r+=","}n=e+(r+="}")}s.assertionFailed(n,1)}},s.assertionFailed=function(e,t,n){t||(t=0);var r="Assertion";throw n&&(r+=" ("+n+")"),r+=" failed: ",void 0!==e&&(r+=e),new Error(r)};var u=t.__oj_Assert_DEBUG;void 0!==u&&(s[a]=u),i.getAgentInfo().browser===i.BROWSER.IE&&e.error("Internet Explorer is not supported with this version of JET.");const l={};r._registerLegacyNamespaceProp("CollectionUtils",l),l.copyInto=function(e,t,n,r,o){return l._copyIntoImpl(e,t,n,r,o,0)},l.mergeDeep=function(e,...t){if(!t.length)return e;const n=l.isPlainObject,r=l.mergeDeep,o=t.shift();return n(e)&&n(o)&&Object.keys(o).forEach(t=>{n(o[t])?(e[t]||Object.assign(e,{[t]:{}}),r(e[t],o[t])):Object.assign(e,{[t]:o[t]})}),r(e,...t)},l.isPlainObject=function(e){if(null!==e&&"object"==typeof e)try{var t=Object.prototype.hasOwnProperty;if(e.constructor&&t.call(e.constructor.prototype,"isPrototypeOf"))return!0}catch(e){}return!1},l._copyIntoImpl=function(e,t,n,r,o,i){var s;if(null==o&&(o=Number.MAX_VALUE),e&&t&&e!==t)for(var a=Object.keys(t),c=0;c<a.length;c++){var u=a[c];s=n?n(u):u;var f=t[u],d=!1;if(r&&i<o){var p=e[s];l.isPlainObject(f)&&(null==p||l.isPlainObject(p))&&(d=!0,e[s]=p||{},l._copyIntoImpl(e[s],f,n,!0,o,i+1))}d||(e[s]=f)}return e},"undefined"!=typeof window&&window.Element&&!Element.prototype.closest&&(Element.prototype.closest=function(e){var t,n=(this.document||this.ownerDocument).querySelectorAll(e),r=this;do{for(t=n.length;--t>=0&&n.item(t)!==r;);}while(t<0&&(r=r.parentElement));return r}),function(){function e(e){return function(t,n,r){return e.call(this,t,n,function(e){return"boolean"==typeof e?e:!!e&&e.capture}(r))}}if("undefined"!=typeof window&&!function(){let e=!1;try{var t=Object.defineProperty({},"passive",{get:function(){return e=!0,e}});window.addEventListener("testPassive",null,t),window.removeEventListener("testPassive",null,t)}catch(e){}return e}()){let t;window.EventTarget?t=EventTarget.prototype:window.Node&&(t=Node.prototype),t&&(t.addEventListener=e(t.addEventListener),t.removeEventListener=e(t.removeEventListener))}}(),
/**
     * @license
     * Code taken from
     * https://developer.mozilla.org/en-US/docs/Web/API/WindowOrWorkerGlobalScope/queueMicrotask
     * under "When queueMicrotask() isn't available".
     * @ignore
     */
"undefined"!=typeof window&&"function"!=typeof window.queueMicrotask&&(window.queueMicrotask=function(e){Promise.resolve().then(e).catch(function(e){setTimeout(function(){throw e})})}),function(){if("undefined"!=typeof window){var e;if(!((e=document.createEvent("Event")).initEvent("foo",!0,!0),e.preventDefault(),e.defaultPrevented)){var t=Event.prototype.preventDefault;Event.prototype.preventDefault=function(){this.cancelable&&(t.call(this),Object.defineProperty(this,"defaultPrevented",{get:function(){return!0},configurable:!0}))}}"function"!=typeof window.CustomEvent&&(n.prototype=Object.getPrototypeOf(new n("bogusEvent")),window.CustomEvent=n)}function n(e,t){t=t||{bubbles:!1,cancelable:!1,detail:void 0};var n=document.createEvent("CustomEvent");return n.initCustomEvent(e,t.bubbles,t.cancelable,t.detail),n}}(),function(){function e(e){var t=document.createEvent("FocusEvent");return t.initEvent(e,!1,!1),t}"undefined"!=typeof window&&"function"!=typeof window.FocusEvent&&(e.prototype=Object.getPrototypeOf(new e("focus")),window.FocusEvent=e)}(),function(){var e,t;"undefined"!=typeof window&&!window.setImmediate&&window.postMessage&&(window.setImmediate=function(){var t=arguments[0],o=Array.prototype.slice,i=o.call(arguments,1);s.assertFunction(t);var a=n();return e||(e=new Map),e.set(a,{callback:t,args:i}),1===e.size&&window.addEventListener("message",r),window.postMessage({id:a,message:"oj-setImmediate"},"*"),a},window.clearImmediate=o);function n(){return isNaN(t)&&(t=0),t+=1}function r(t){var n=t.data;if(n&&"oj-setImmediate"===n.message){var r=n.id,i=e.get(r);if(o(r),i){var s=i.callback,a=i.args;s.apply(window,a)}}}function o(t){e&&(e.delete(t),e.size<1&&(window.removeEventListener("message",r),e=null))}}(),"undefined"!=typeof window&&(window.Symbol?(window.Symbol.asyncIterator||(window.Symbol.asyncIterator="asyncIterator"),window.Symbol.iterator||(window.Symbol.iterator="iterator")):(window.Symbol={},window.Symbol.asyncIterator="asyncIterator",window.Symbol.iterator="iterator")),function(){if("undefined"!=typeof window&&0===new window.Set([0]).size){var e=window.Set;function t(t){var n=new e;return t&&t.forEach(n.add,n),n}t.prototype=e.prototype,t.prototype.constructor=t,window.Set=t}}(),"undefined"!=typeof window&&(window.NodeList&&!NodeList.prototype.forEach&&(NodeList.prototype.forEach=Array.prototype.forEach),window.DOMTokenList&&!DOMTokenList.prototype.forEach&&(DOMTokenList.prototype.forEach=Array.prototype.forEach)),"undefined"!=typeof window&&"undefined"!==window.Node&&("isConnected"in Node.prototype||Object.defineProperty(Node.prototype,"isConnected",{get(){return!(this.ownerDocument&&this.ownerDocument.compareDocumentPosition(this)&this.DOCUMENT_POSITION_DISCONNECTED)}}));const f=function(){this.Init()};r._registerLegacyNamespaceProp("Object",f),f.superclass=null,f._typeName="oj.Object",f._GET_FUNCTION_NAME_REGEXP=/function\s+([\w$][\w$\d]*)\s*\(/,(f.prototype={}).constructor=f,f.createSubclass=function(e,t,n){s.assertFunction(e),s.assertFunctionOrNull(t),s.assertStringOrNull(n),void 0===t&&(t=f),s.assert(e!==t,"Class can't extend itself");var r=f._tempSubclassConstructor;r.prototype=t.prototype,e.prototype=new r,e.prototype.constructor=e,e.superclass=t.prototype,n&&(e._typeName=n)},f.copyPropertiesForClass=function(e,t){s.assertFunction(e),s.assert(null!=t,"source object cannot be null");for(var n=Object.keys(t),r=0;r<n.length;r++){var o=n[r];e.prototype[o]=t[o]}},f._tempSubclassConstructor=function(){},f.prototype.getClass=function(e){if(void 0===e)e=this;else if(null===e)return null;return e.constructor},f.prototype.clone=function(){var e=new this.constructor;return l.copyInto(e,this),e},f.prototype.toString=function(){return this.toDebugString()},f.prototype.toDebugString=function(){return this.getTypeName()+" Object"},f.getTypeName=function(e){s.assertFunction(e);var t=e._typeName;if(null==t){var n=e.toString(),r=f._GET_FUNCTION_NAME_REGEXP.exec(n);t=r?r[1]:"anonymous",e._typeName=t}return t},f.prototype.getTypeName=function(){return f.getTypeName(this.constructor)},f.prototype.Init=function(){s.isDebug()&&s.assert(this.getTypeName,"Not an oj.Object");var e=this.constructor;e._initialized||f._initClasses(e)},f.ensureClassInitialization=function(e){s.assertFunction(e),e._initialized||f._initClasses(e)},f.prototype.equals=function(e){return this===e},f.createCallback=function(e,t){return s.assertFunction(t),t.bind(e)},f._initClasses=function(e){s.isDebug()&&(s.assertFunction(e),s.assert(!e._initialized)),e._initialized=!0;var t=e.superclass;if(t){var n=t.constructor;n&&!n._initialized&&f._initClasses(n)}var r=e.InitClass;r&&r.call(e)},f.compareValues=function(e,t){if(e===t)return!0;if(typeof e!==typeof t)return!1;if(null===e||null===t)return!1;if(e.constructor===t.constructor){if(Array.isArray(e))return f._compareArrayValues(e,t);if(e.constructor===Object)return f.__innerEquals(e,t);if(e.valueOf&&"function"==typeof e.valueOf)return e.valueOf()===t.valueOf()}return!1},f._compareArrayValues=function(e,t){if(e.length!==t.length)return!1;for(var n=0,r=e.length;n<r;n++)if(!f.compareValues(e[n],t[n]))return!1;return!0},f._compareIdIndexObject=function(e,t){if("number"==typeof e&&"number"==typeof t||"string"==typeof e&&"string"==typeof t)return e===t;if("object"==typeof e&&"object"==typeof t){if(e.id&&t.id)return e.id===t.id&&(!e.index||!t.index||e.index===t.index);if(e.index&&t.index)return e.index===t.index}return!1},f._compareArrayIdIndexObject=function(e,t){if(!e)return!t||0===t.length;if(!t)return!e||0===e.length;if(e.length!==t.length)return!1;for(var n=0;n<e.length;n++){for(var r=!1,o=0;o<t.length;o++)if(f._compareIdIndexObject(e[n],t[o])){r=!0;break}if(!r)return!1}return!0},f.__innerEquals=function(e,t){if(e===t)return!0;if(!(e instanceof Object&&t instanceof Object))return!1;if(e.constructor!==t.constructor)return!1;var n,r,o=Object.prototype.hasOwnProperty,i=Object.keys(e);for(r=0;r<i.length;r++)if(n=i[r],o.call(e,n)){if(!o.call(t,n))return!1;if(e[n]!==t[n]){if("object"!=typeof e[n])return!1;if(!f.compareValues(e[n],t[n]))return!1}}var s=Object.keys(t);for(r=0;r<s.length;r++)if(n=s[r],o.call(t,n)&&!o.call(e,n))return!1;return 0!==i.length||0!==s.length||JSON.stringify(e)===JSON.stringify(t)},f.isEmpty=function(e){var t;if(null==e)return!0;for(t in e)if(e.hasOwnProperty(t))return!1;return!0};r._registerLegacyNamespaceProp("__isAmdLoaderPresent",function(){return"function"==typeof define&&define.amd});const d=function(){this.Init()};f.createSubclass(d,f,"oj.EventSource"),r._registerLegacyNamespaceProp("EventSource",d),d.prototype.Init=function(){this._eventHandlers=[],d.superclass.Init.call(this)},d.prototype.on=function(e,t){for(var n=!1,r=0;r<this._eventHandlers.length;r++)if(this._eventHandlers[r].eventType===e&&this._eventHandlers[r].eventHandlerFunc===t){n=!0;break}n||this._eventHandlers.push({eventType:e,eventHandlerFunc:t})},d.prototype.off=function(e,t){for(var n=this._eventHandlers.length-1;n>=0;n--)if(this._eventHandlers[n].eventType===e&&this._eventHandlers[n].eventHandlerFunc===t){this._eventHandlers.splice(n,1);break}},d.prototype.handleEvent=function(e,t){for(var n=0;n<this._eventHandlers.length;n++){var r=this._eventHandlers[n];if(r.eventType===e&&!1===r.eventHandlerFunc.apply(this,Array.prototype.slice.call(arguments).slice(1)))return!1}return!0};const p={};r._registerLegacyNamespaceProp("KeyUtils",p),p.equals=function(e,t){return f.compareValues(e,t)};var y=t.__ojCheckpointManager;const E={};return r._registerLegacyNamespaceProp("CHECKPOINT_MANAGER",E),E.startCheckpoint=function(e,t){y&&y.startCheckpoint(e,t)},E.endCheckpoint=function(e){y&&y.endCheckpoint(e)},E.getRecord=function(e){return y?y.getRecord(e):void 0},E.matchRecords=function(e){return y?y.matchRecords(e):[]},E.dump=function(t){e.info(function(){for(var e="Checkpoint Records:",n=E.matchRecords(t),r=0;r<n.length;r++){var o=n[r];e=e+"\n"+o.name;var i=o.description;null!=i&&(e=e+" ("+i+")"),e=(e+=":\n")+"start: "+o.start+"\tduration: "+o.duration}return e})},r});
//# sourceMappingURL=ojcore-base.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojcontext',["ojs/ojcore-base","ojs/ojlogger"],function(e,t){"use strict";e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e;const s=function(e){this._description=e,this._addedWaitTs=s._getTs(),this._id=this._addedWaitTs.toString(36)+"_"+Math.random().toString(36)};e._registerLegacyNamespaceProp("BusyState",s),Object.defineProperties(s.prototype,{id:{get:function(){return this._id},enumerable:!0},description:{get:function(){if(this._description)return this._description instanceof Function?this._description():this._description.toString()},enumerable:!0}}),s.prototype.toString=function(){var e="Busy state: [description=",t=this.description;return null!==t&&(e+=t),e+=", elapsed="+(s._getTs()-this._addedWaitTs)+"]"},s._getTs=function(){return window.performance?window.performance.now():(new Date).getTime()};const o=function(e){this.Init(e)};let n;function i(){return n||(n=new Promise(function(e){window.setImmediate(function(){n=null,e(!0)})})),n}e.Object.createSubclass(o,e.Object,"oj.BusyContext"),e._registerLegacyNamespaceProp("BusyContext",o),o._defaultTimeout=Number.NaN,o.setDefaultTimeout=function(e){isNaN(e)||(o._defaultTimeout=e)},o.prototype.Init=function(e){o.superclass.Init.call(this),this._hostNode=e,this._statesMap=new Map,this._mediator={getMasterWhenReadyPromise:function(){return this._masterWhenReadyPromise||(this._masterWhenReadyPromise=new Promise(this._captureWhenReadyPromiseResolver.bind(this))),this._masterWhenReadyPromise},resolveMasterWhenReadyPromise:function(){this._masterWhenReadyPromiseResolver&&this._masterWhenReadyPromiseResolver(!0),this._masterWhenReadyPromise=null,this._masterWhenReadyPromiseResolver=null,this._masterWhenReadyPromiseRejecter=null},rejectMasterWhenReadyPromise:function(e){this._masterWhenReadyPromiseRejecter&&this._masterWhenReadyPromiseRejecter(e),this._masterWhenReadyPromise=null,this._masterWhenReadyPromiseRejecter=null,this._masterWhenReadyPromiseResolver=null},getSlaveTimeoutPromise:function(e,t,s){var o,n=new Promise(function(e,n){o=window.setTimeout(function(){n(t())},s)});return this._slaveTimeoutPromiseTimers.push(o),Promise.race([e,n]).finally(this._clearAllSlaveTimeouts.bind(this))},_clearAllSlaveTimeouts:function(){var e=this._slaveTimeoutPromiseTimers;this._slaveTimeoutPromiseTimers=[];for(var t=0;t<e.length;t++)window.clearTimeout(e[t]);return!0},_captureWhenReadyPromiseResolver:function(e,t){this._masterWhenReadyPromiseResolver=e,this._masterWhenReadyPromiseRejecter=t},_slaveTimeoutPromiseTimers:[]}},o._log=function(e){if(t.option("level")===t.LEVEL_LOG){t.log(">> Busy states: %d",e.size);var s=o._values(e);s.length>0&&t.log(s.join("\n"))}},o._values=function(e){var t=[];return e.forEach(function(e){t.push(e)}),t},o.prototype.addBusyState=function(e){t.log("BusyContext.addBusyState: start scope='%s'",this._getDebugScope());var n=this._statesMap,i=new s(e[o._DESCRIPTION]);return t.log(">> "+i),n.set(i.id,i),this._addBusyStateToParent(),t.log("BusyContext.addBusyState: end scope='%s'",this._getDebugScope()),this._removeBusyState.bind(this,i)},o.prototype.dump=function(e){t.info("BusyContext.dump: start scope='%s' %s",this._getDebugScope(),e||"");var s=this._statesMap;t.info(">> Busy states: %d",s.size);var n=o._values(s);n.length>0&&t.info(n.join("\n")),t.info("BusyContext.dump: start scope='%s' %s",this._getDebugScope(),e||"")},o.prototype.getBusyStates=function(){var e=this._statesMap;return o._values(e)},o.prototype.clear=function(){t.log("BusyContext.clear: start scope='%s'",this._getDebugScope());for(var e=this._statesMap,s=o._values(e),n=0;n<s.length;n++){var i=s[n];try{this._removeBusyState(i)}catch(e){t.log("BusyContext.clear: %o",e)}Object.defineProperty(i,o._OJ_RIP,{value:!0,enumerable:!1})}t.log("BusyContext.clear: end scope='%s'",this._getDebugScope())},o.prototype.whenReady=function(e){var s=this._getDebugScope();t.log("BusyContext.whenReady: start, scope='%s', timeout=%d",s,e);var n=this._statesMap,r=this._mediator,a=i(),u=o._BOOTSTRAP_MEDIATOR.whenReady();const l=r.getMasterWhenReadyPromise();var c=Promise.all([a,u]).then(function(){t.log("BusyContext.whenReady: bootstrap mediator ready scope=%s",s);try{o._deliverThrottledUpdates()}catch(e){throw t.error("Fatal exception delivering binding updates: %o",e),e}return 0!==n.size||this._waitingOnNextTickBusynessEval||(t.log("BusyContext.whenReady: resolved no busy states scope=%s",s),r.resolveMasterWhenReadyPromise()),t.log("BusyContext.whenReady: busy states returning master scope=%s",s),l}.bind(this));if(isNaN(e)&&!isNaN(o._defaultTimeout)&&(e=o._defaultTimeout),!isNaN(e)){c=r.getSlaveTimeoutPromise(c,function(){var i,r="whenReady timeout of "+e+"ms expired ";o._log(n);var a=o._values(n);return(i=o._BOOTSTRAP_MEDIATOR.isReady()?new Error(r+"with the following busy states: "+a.join(", ")):new Error(r+'while the application is loading. Busy state enabled by setting the "window.oj_whenReady = true;" global variable. Application bootstrap busy state is released by calling "oj.Context.getPageContext().getBusyContext().applicationBootstrapComplete();".')).busyStates=a,t.log("BusyContext.whenReady: rejected scope='%s'\n%s",s,i.message),i},e)}return t.log("BusyContext.whenReady: end scope='%s'",this._getDebugScope()),c},o.prototype.isReady=function(){t.log("BusyContext.isReady: start scope='%s'",this._getDebugScope());var e=!1;if(o._BOOTSTRAP_MEDIATOR.isReady()&&!this._waitingOnNextTickBusynessEval){var s=this._statesMap;e=0===s.size,o._log(s)}return t.log("BusyContext.isReady: end scope='%s'",this._getDebugScope()),e},o.prototype._removeBusyState=function(e){var s=this._getDebugScope();t.log("BusyContext._removeBusyState: start scope='%s'",s);var n=this._statesMap;if(e[o._OJ_RIP])t.log("Busy state has been forcefully resolved via clear:\n"+e);else{if(!n.delete(e.id))throw new Error("Busy state has already been resolved:\n"+e);t.log("BusyContext._removeBusyState: resolving busy state:\n"+e),0!==n.size||this._waitingOnNextTickBusynessEval||(this._waitingOnNextTickBusynessEval=!0,i().then(this._evalBusyness.bind(this))),t.log("BusyContext._removeBusyState: end scope='%s'",s)}},o.prototype._evalBusyness=function(){var e=this._getDebugScope();t.log("BusyContext._evalBusyness: begin scope='%s'",e);try{o._deliverThrottledUpdates()}catch(e){return t.error("Fatal exception delivering binding updates: %o",e),this._waitingOnNextTickBusynessEval=!1,void this._rejectWhenReadyPromises(e)}var s=this._statesMap,n=this._mediator;this._waitingOnNextTickBusynessEval=!1,0===s.size?(t.log("BusyContext._evalBusyness: resolving whenReady promises"),n.resolveMasterWhenReadyPromise(),this._resolveBusyStateForParent()):o._log(s),t.log("BusyContext._evalBusyness: end scope='%s'",e)},o.prototype.applicationBootstrapComplete=function(){var e=this._getDebugScope();t.log("BusyContext.applicationBootstrapComplete: begin scope='%s'",e),o._BOOTSTRAP_MEDIATOR.notifyComplete(),t.log("BusyContext.applicationBootstrapComplete: end scope='%s'",e)},o.prototype._getParentBusyContext=function(){if(this._hostNode){var t=e.Context.getContext(e.Context.getParentElement(this._hostNode));if(t)return t.getBusyContext()}return null},o.prototype._addBusyStateToParent=function(){if(!this._parentNotified){this._parentNotified=!0;var e=this._getParentBusyContext();if(e){var t={};t[o._DESCRIPTION]=this.toString.bind(this),this._parentResolveCallback=e.addBusyState(t)}}},o.prototype._resolveBusyStateForParent=function(){this._parentNotified=!1,this._parentResolveCallback&&(this._parentResolveCallback(),this._parentResolveCallback=null)},o.prototype._rejectWhenReadyPromises=function(e){this._mediator.rejectMasterWhenReadyPromise(e);const t=this._getParentBusyContext();t&&(t._rejectWhenReadyPromises(e),this._resolveBusyStateForParent())},o.prototype._getCompoundDescription=function(){return"["+o._values(this._statesMap).join(", ")+"]"},o.prototype._getDebugScope=function(){function e(e){var t="undefined";if(e)if(e.id&&e.id.length>0)t="#"+e.id;else{t=e.nodeName,e.hasAttribute("data-oj-context")&&(t+="[data-oj-context]");var s=e.getAttribute("class");s&&(t+="."+s.split(" ").join("."))}return t}return this._debugScope||(this._hostNode?this._debugScope=e(this._hostNode.parentElement)+" > "+e(this._hostNode):this._debugScope="page"),this._debugScope},o.prototype.toString=function(){var e="Busy Context: [scope=";return e+=this._getDebugScope(),e+=" states="+this._getCompoundDescription()+"]"},o._deliverThrottledUpdates=function(){e.ComponentBinding&&e.ComponentBinding.deliverChanges()},o._DESCRIPTION="description",o._OJ_RIP="__ojRip",o._BOOTSTRAP_MEDIATOR=new function(){var e,t,s;"undefined"!=typeof window&&(e=window.oj_whenReady),this.whenReady=function(){return t||(t=e?new Promise(function(e){s=e}):Promise.resolve(!0))},this.isReady=function(){return!e},this.notifyComplete=function(){s?i().then(function(){e=!1,"function"==typeof s&&s(!0),s=null}):e=!1}};const r=function(e){this.Init(e)};return e.Object.createSubclass(r,e.Object,"oj.Context"),r.prototype.Init=function(e){r.superclass.Init.call(this),this._node=e},r.getContext=function(e){for(;e;){var t=e[r._OJ_CONTEXT_INSTANCE];if(t)return t;if(e.hasAttribute(r._OJ_CONTEXT_ATTRIBUTE))return t=new r(e),Object.defineProperty(e,r._OJ_CONTEXT_INSTANCE,{value:t}),t;e=r.getParentElement(e)}return r.getPageContext()},r.getPageContext=function(){return r._pageContext||(r._pageContext=new r),r._pageContext},r.prototype.getBusyContext=function(){return this._busyContext||(this._busyContext=new o(this._node)),this._busyContext},r.setBusyContextDefaultTimeout=function(e){o.setDefaultTimeout(e)},r._OJ_CONTEXT_ATTRIBUTE="data-oj-context",r._OJ_CONTEXT_INSTANCE="__ojContextInstance",r._OJ_SURROGATE_ATTR="data-oj-surrogate-id",r.getParentElement=function(e){if(e&&e.hasAttribute(r._OJ_SURROGATE_ATTR)){var t=document.getElementById(e.getAttribute(r._OJ_SURROGATE_ATTR));if(t)return t.parentElement}return e._ojReportBusy||e.parentElement},r});
//# sourceMappingURL=ojcontext.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 *
 * This is a fork of the i18n Require.js plugin.
 * It makes minor chnages to the way the default locale is determined and to the way bundles are merged
 *
 * @license RequireJS i18n 2.0.2 Copyright (c) 2010-2012, The Dojo Foundation All Rights Reserved.
 * Available via the MIT or new BSD license.
 * see: http://github.com/requirejs/i18n for details
 */
!function(){"use strict";var e=/(^.*(^|\/)nls(\/|$))([^/]*)\/?([^/]*)/;function n(e,n,o,a,r,t,l){if(n[e]||(e=e.replace(/^zh-(Hans|Hant)-([^-]+)$/,"zh-$2")),n[e]){if(o.push(e),!0===n[e]||1===n[e]){var u=l?l+e:e;a.push(r+u+"/"+t)}return!0}return!1}function o(e){return"object"==typeof e}function a(e,n){for(var r=Object.keys(n),t=0;t<r.length;t++){var l=r[t];null==e[l]?e[l]=n[l]:o(n[l])&&o(e[l])&&a(e[l],n[l])}}define('ojL10n',["module"],function(o){var r=o.config?o.config():{};return{version:"2.0.1+",load:function(o,t,l,u){var c;(u=u||{}).locale&&(r.locale=u.locale);var i,f,s,v,g,h,p,d,y,m,L,O=e.exec(o),_=O[1],b=O[5],j=[],H={},k="";O[5]?(c=(_=O[1])+b,i=O[4]):(c=o,b=O[4],i=r.locale,"undefined"!=typeof document?(i||(i=u.isBuild?"root":document.documentElement.lang)||(i=void 0===navigator?"root":navigator.systemLanguage||navigator.language||navigator.userLanguage||"root"),r.locale=i):i="root"),f=function(e){var n,o=e.toLowerCase().split(/-|_/),a=[o[0]],r=1;for(n=1;n<o.length;n++){var t=o[n],l=t.length;if(1===l)break;switch(r){case 1:if(r=2,4===l){a.push(t.charAt(0).toUpperCase()+t.slice(1));break}case 2:r=3,a.push(t.toUpperCase());break;default:a.push(t)}}return function(e){if("zh"!==e[0]||e.length>1&&4===e[1].length)return;var n="Hans",o=e.length>1?e[1]:null;"TW"!==o&&"MO"!==o&&"HK"!==o||(n="Hant");e.splice(1,0,n)}(a),a}(i),v=r.noOverlay,g=r.defaultNoOverlayLocale;var x=r.localePrefix;for((y=r.merge)&&(h=y[_+b])&&(O=e.exec(h),p=O[1],d=O[4]),m=[],s=0;s<f.length;s++)k+=(k?"-":"")+f[s],m.push(k);u.isBuild?(j.push(c),h&&j.push(h),t(j,function(){l()})):("query"===r.includeLocale&&(c=t.toUrl(c+".js"),c+=(-1===c.indexOf("?")?"?":"&")+"loc="+i),L=[c],h&&L.push(h),t(L,function(e,o){var r=[],u=function(e,o,a){for(var t=v||!0===e.__noOverlay,l=g||e.__defaultNoOverlayLocale,u=!1,c=m.length-1;c>=0&&(!u||!t);c--)u=n(m[c],e,r,j,o,a,x);var i=1===m.length&&"root"===m[0];t&&(i||!u)&&l&&n(l,e,r,j,o,a,x),i||n("root",e,r,j,o,a,x)};u(e,_,b);var c=r.length;o&&u(o,p,d),t(j,function(){var n=function(e,n,o,l,u){for(var c=n;c<o&&r[c];c++){var i=r[c],f=x?x+i:i,s=e[i];!0!==s&&1!==s||(s=t(l+f+"/"+u)),a(H,s||{})}};n(o,c,r.length,p,d),n(e,0,c,_,b),H._ojLocale_=f.join("-"),l(H)})}))}}})}();
define('ojtranslations/nls/ojtranslations',{root:{"oj-message":{fatal:"Fatal",error:"Error",warning:"Warning",info:"Info",confirmation:"Confirmation","compact-type-summary":"{0}: {1}"},"oj-converter":{summary:"Value is not in the expected format.",detail:"Enter a value in the expected format.","plural-separator":", ",hint:{summary:"Example: {exampleValue}",detail:"Enter a value in this format: '{exampleValue}'.","detail-plural":"Enter a value in these formats: '{exampleValue}'."},optionHint:{detail:"An accepted value for option '{propertyName}' is '{propertyValueValid}'.","detail-plural":"Accepted values for option '{propertyName}' are '{propertyValueValid}'."},optionTypesMismatch:{summary:"A value for the option '{requiredPropertyName}' is required when the option '{propertyName}' is set to '{propertyValue}'."},optionTypeInvalid:{summary:"A value of the expected type was not provided for option '{propertyName}'."},optionOutOfRange:{summary:"Value {propertyValue} is out of range for the option '{propertyName}'."},optionValueInvalid:{summary:"An invalid value '{propertyValue}' was specified for the option '{propertyName}'."},number:{decimalFormatMismatch:{summary:"The provided value is not in the expected number format."},shortLongUnsupportedParse:{summary:"'short' and 'long' are not supported for converter parsing.",detail:"Change component to readonly. readonly fields do not call the converter's parse function."},currencyFormatMismatch:{summary:"The provided value is not in the expected currency format."},percentFormatMismatch:{summary:"The provided value is not in the expected percent format."},invalidNumberFormat:{summary:"The provided value is not a valid number.",detail:"Please provide valid number."}},color:{invalidFormat:{summary:"Invalid color format.",detail:"Invalid color format option specification."},invalidSyntax:{summary:"Invalid color specification.",detail:"Enter a color value that conforms to the CSS3 standard."}},datetime:{datetimeOutOfRange:{summary:"Value '{value}' is out of range for the '{propertyName}'.",detail:"Enter a value between '{minValue}' and '{maxValue}'.",hour:"hour",minute:"minute",second:"second",millisec:"millisec",month:"month",day:"day",year:"year","month name":"month name",weekday:"weekday"},dateFormatMismatch:{summary:"The provided value is not in the expected date format."},invalidTimeZoneID:{summary:"Invalid timezone id {timeZoneID} provided."},nonExistingTime:{summary:"The input time does not exist because it falls during the transition to daylight saving time."},missingTimeZoneData:{summary:"TimeZone data is missing. Please call require 'ojs/ojtimezonedata' in order to load the TimeZone data."},timeFormatMismatch:{summary:"The provided value is not in the expected time format."},datetimeFormatMismatch:{summary:"The provided value is not in the expected date and time format."},dateToWeekdayMismatch:{summary:"Day '{date}' does not fall on a '{weekday}'.",detail:"Enter a weekday that corresponds with the date."},invalidISOString:{invalidRangeSummary:"The value '{value}' is out of range for the '{propertyName}' field in the ISO 8601 string '{isoStr}'.",summary:"The provided '{isoStr}' is not a valid ISO 8601 string.",detail:"Please provide valid ISO 8601 string."}}},"oj-validator":{length:{hint:{min:"Enter {min} or more characters.",max:"Enter {max} or fewer characters.",inRange:"Enter {min} to {max} characters.",exact:"Enter {length} characters."},messageDetail:{tooShort:"Enter {min} or more characters.",tooLong:"Enter no more than {max} characters."},messageSummary:{tooShort:"There are too few characters.",tooLong:"There are too many characters."}},range:{number:{hint:{min:"Enter a number greater than or equal to {min}.",max:"Enter a number less than or equal to {max}.",inRange:"Enter a number between {min} and {max}.",exact:"Enter the number {num}."},messageDetail:{rangeUnderflow:"Enter {min} or a higher number.",rangeOverflow:"Enter {max} or a lower number.",exact:"Enter the number {num}."},messageSummary:{rangeUnderflow:"The number is too low.",rangeOverflow:"The number is too high."}},datetime:{hint:{min:"Enter a date and time on or after {min}.",max:"Enter a date and time on or before {max}.",inRange:"Enter a date and time between {min} and {max}."},messageDetail:{rangeUnderflow:"Enter a date on or after {min}.",rangeOverflow:"Enter a date on or before {max}."},messageSummary:{rangeUnderflow:"Date and time is earlier than the minimum date and time.",rangeOverflow:"Date and time is later than the maximum date and time."}},date:{hint:{min:"Enter a date on or after {min}.",max:"Enter a date on or before {max}.",inRange:"Enter a date between {min} and {max}."},messageDetail:{rangeUnderflow:"Enter a date on or after {min}.",rangeOverflow:"Enter a date on or before {max}."},messageSummary:{rangeUnderflow:"Date is earlier than the minimum date.",rangeOverflow:"Date is later than the maximum date."}},time:{hint:{min:"Enter a time on or after {min}.",max:"Enter a time on or before {max}.",inRange:"Enter a time between {min} and {max}."},messageDetail:{rangeUnderflow:"Enter a time at or after {min}.",rangeOverflow:"Enter a time at or before {max}."},messageSummary:{rangeUnderflow:"Time is earlier than the minimum time.",rangeOverflow:"Time is later than the maximum time."}}},restriction:{date:{messageSummary:"Date {value} is of a disabled entry.",messageDetail:"The date you selected isn't available. Try another date."}},regExp:{summary:"Format is incorrect.",detail:"Enter allowable values described in this regular expression: '{pattern}'."},required:{summary:"Value is required.",detail:"Enter a value."}},"oj-ojEditableValue":{loading:"Loading",requiredText:"Required",helpSourceText:"Learn more..."},"oj-ojInputDate":{done:"Done",cancel:"Cancel",prevText:"Previous",nextText:"Next",currentText:"Today",weekHeader:"Wk",tooltipCalendar:"Select Date.",tooltipCalendarTime:"Select Date Time.",tooltipCalendarDisabled:"Select Date Disabled.",tooltipCalendarTimeDisabled:"Select Date Time Disabled.",picker:"Picker",weekText:"Week",datePicker:"Date Picker",inputHelp:"Press Key down or Key up for access to Calendar.",inputHelpBoth:"Press Key down or Key up for access to Calendar and Shift + Key down or Shift Key up for access to time drop down.",dateTimeRange:{hint:{min:"",max:"",inRange:""},messageDetail:{rangeUnderflow:"",rangeOverflow:""},messageSummary:{rangeUnderflow:"",rangeOverflow:""}},dateRestriction:{hint:"",messageSummary:"",messageDetail:""}},"oj-ojInputTime":{cancelText:"Cancel",okText:"OK",currentTimeText:"Now",hourWheelLabel:"Hour",minuteWheelLabel:"Minute",ampmWheelLabel:"AMPM",tooltipTime:"Select Time.",tooltipTimeDisabled:"Select Time Disabled.",inputHelp:"Press Key down or Key up for access to time drop down.",dateTimeRange:{hint:{min:"",max:"",inRange:""},messageDetail:{rangeUnderflow:"",rangeOverflow:""},messageSummary:{rangeUnderflow:"",rangeOverflow:""}}},"oj-inputBase":{required:{hint:"",messageSummary:"",messageDetail:""},regexp:{messageSummary:"",messageDetail:""},accessibleMaxLengthExceeded:"Maximum length {len} exceeded.",accessibleMaxLengthRemaining:"{chars} characters left."},"oj-ojInputPassword":{regexp:{messageDetail:"Value must match this pattern: '{pattern}'."},accessibleShowPassword:"Show password.",accessibleHidePassword:"Hide password."},"oj-ojFilmStrip":{labelAccFilmStrip:"Displaying page {pageIndex} of {pageCount}",labelAccArrowNextPage:"Select Next to display next page",labelAccArrowPreviousPage:"Select Previous to display previous page",tipArrowNextPage:"Next",tipArrowPreviousPage:"Previous"},"oj-ojDataGrid":{accessibleSortAscending:"{id} sorted in ascending order",accessibleSortDescending:"{id} sorted in descending order",accessibleActionableMode:"Enter actionable mode.",accessibleNavigationMode:"Enter navigation mode, press F2 to enter edit or actionable mode.",accessibleEditableMode:"Enter editable mode, press escape to navigate outside the data grid.",accessibleSummaryExact:"This is a data grid with {rownum} rows and {colnum} columns",accessibleSummaryEstimate:"This is a data grid with unknown number of rows and columns",accessibleSummaryExpanded:"There are currently {num} rows expanded",accessibleRowExpanded:"Row expanded",accessibleRowCollapsed:"Row collapsed",accessibleRowSelected:"Row {row} selected",accessibleColumnSelected:"Column {column} selected",accessibleStateSelected:"selected",accessibleMultiCellSelected:"{num} cells selected",accessibleColumnSpanContext:"{extent} wide",accessibleRowSpanContext:"{extent} high",accessibleRowContext:"Row {index}",accessibleColumnContext:"Column {index}",accessibleRowHeaderContext:"Row Header {index}",accessibleColumnHeaderContext:"Column Header {index}",accessibleRowEndHeaderContext:"Row End Header {index}",accessibleColumnEndHeaderContext:"Column End Header {index}",accessibleRowHeaderLabelContext:"Row Header Label {level}",accessibleColumnHeaderLabelContext:"Column Header Label {level}",accessibleRowEndHeaderLabelContext:"Row End Header Label {level}",accessibleColumnEndHeaderLabelContext:"Column End Header Label {level}",accessibleLevelContext:"Level {level}",accessibleRangeSelectModeOn:"Add selected range of cells mode on.",accessibleRangeSelectModeOff:"Add selected range of cells mode off.",accessibleFirstRow:"You have reached the first row.",accessibleLastRow:"You have reached the last row.",accessibleFirstColumn:"You have reached the first column",accessibleLastColumn:"You have reached the last column.",accessibleSelectionAffordanceTop:"Top selection handle.",accessibleSelectionAffordanceBottom:"Bottom selection handle.",msgFetchingData:"Fetching Data...",msgNoData:"No items to display.",labelResize:"Resize",labelResizeWidth:"Resize Width",labelResizeHeight:"Resize Height",labelSortRow:"Sort Row",labelSortRowAsc:"Sort Row Ascending",labelSortRowDsc:"Sort Row Descending",labelSortCol:"Sort Column",labelSortColAsc:"Sort Column Ascending",labelSortColDsc:"Sort Column Descending",labelCut:"Cut",labelPaste:"Paste",labelEnableNonContiguous:"Enable Non-Contiguous Selection",labelDisableNonContiguous:"Disable Non-Contiguous Selection",labelResizeDialogSubmit:"OK",labelResizeDialogCancel:"Cancel",accessibleContainsControls:"Contains Controls"},"oj-ojRowExpander":{accessibleLevelDescription:"Level {level}",accessibleRowDescription:"Level {level}, Row {num} of {total}",accessibleRowExpanded:"Row expanded",accessibleRowCollapsed:"Row collapsed",accessibleStateExpanded:"expanded",accessibleStateCollapsed:"collapsed"},"oj-ojListView":{msgFetchingData:"Fetching Data...",msgNoData:"No items to display.",msgItemsAppended:"{count} items appended to the end.",indexerCharacters:"A|B|C|D|E|F|G|H|I|J|K|L|M|N|O|P|Q|R|S|T|U|V|W|X|Y|Z",accessibleReorderTouchInstructionText:"Double tap and hold.  Wait for the sound then drag to rearrange.",accessibleReorderBeforeItem:"Before {item}",accessibleReorderAfterItem:"After {item}",accessibleReorderInsideItem:"Into {item}",accessibleNavigateSkipItems:"Skipping {numSkip} items",labelCut:"Cut",labelCopy:"Copy",labelPaste:"Paste",labelPasteBefore:"Paste Before",labelPasteAfter:"Paste After"},"oj-_ojLabel":{tooltipHelp:"Help",tooltipRequired:"Required"},"oj-ojLabel":{tooltipHelp:"Help",tooltipRequired:"Required"},"oj-ojInputNumber":{required:{hint:"",messageSummary:"",messageDetail:""},numberRange:{hint:{min:"",max:"",inRange:"",exact:""},messageDetail:{rangeUnderflow:"",rangeOverflow:"",exact:""},messageSummary:{rangeUnderflow:"",rangeOverflow:""}},tooltipDecrement:"Decrement",tooltipIncrement:"Increment"},"oj-ojTable":{accessibleColumnContext:"Column {index}",accessibleColumnFooterContext:"Column Footer {index}",accessibleColumnHeaderContext:"Column Header {index}",accessibleRowContext:"Row {index}",accessibleSortable:"{id} sortable",accessibleSortAscending:"{id} sorted in ascending order",accessibleSortDescending:"{id} sorted in descending order",accessibleStateSelected:"selected",labelAccSelectionAffordanceTop:"Top selection handle",labelAccSelectionAffordanceBottom:"Bottom selection handle",labelEnableNonContiguousSelection:"Enable Non-Contiguous Selection",labelDisableNonContiguousSelection:"Disable Non-Contiguous Selection",labelResize:"Resize",labelResizePopupSubmit:"OK",labelResizePopupCancel:"Cancel",labelResizePopupSpinner:"Resize Column",labelSelectRow:"Select Row",labelEditRow:"Edit Row",labelSelectAndEditRow:"Select And Edit Row",labelSelectColumn:"Select Column",labelSort:"Sort",labelSortAsc:"Sort Ascending",labelSortDsc:"Sort Descending",msgFetchingData:"Fetching Data...",msgNoData:"No data to display.",msgInitializing:"Initializing...",msgColumnResizeWidthValidation:"Width value must be an integer.",msgScrollPolicyMaxCountSummary:"Exceeded maximum rows for table scrolling.",msgScrollPolicyMaxCountDetail:"Please reload with smaller data set.",msgStatusSortAscending:"{0} sorted in ascending order.",msgStatusSortDescending:"{0} sorted in descending order."},"oj-ojTabs":{labelCut:"Cut",labelPasteBefore:"Paste Before",labelPasteAfter:"Paste After",labelRemove:"Remove",labelReorder:"Reorder",removeCueText:"Removable"},"oj-ojCheckboxset":{readonlyNoValue:"",required:{hint:"",messageSummary:"",messageDetail:""}},"oj-ojRadioset":{readonlyNoValue:"",required:{hint:"",messageSummary:"",messageDetail:""}},"oj-ojSelect":{required:{hint:"",messageSummary:"",messageDetail:""},searchField:"Search field",noMatchesFound:"No matches found",noMoreResults:"No more results",oneMatchesFound:"One match found",moreMatchesFound:"{num} matches found",filterFurther:"More results available, please filter further."},"oj-ojSwitch":{SwitchON:"On",SwitchOFF:"Off"},"oj-ojCombobox":{required:{hint:"",messageSummary:"",messageDetail:""},noMatchesFound:"No matches found",noMoreResults:"No more results",oneMatchesFound:"One match found",moreMatchesFound:"{num} matches found",filterFurther:"More results available, please filter further."},"oj-ojSelectSingle":{required:{hint:"",messageSummary:"",messageDetail:""},noMatchesFound:"No matches found",oneMatchFound:"One match found",multipleMatchesFound:"{num} matches found",nOrMoreMatchesFound:"{num} or more matches found",cancel:"Cancel",labelAccOpenDropdown:"expand",labelAccClearValue:"clear value",noResultsLine1:"No results found",noResultsLine2:"We can't find anything matching your search."},"oj-ojInputSearch2":{cancel:"Cancel"},"oj-ojInputSearch":{required:{hint:"",messageSummary:"",messageDetail:""},noMatchesFound:"No matches found",oneMatchesFound:"One match found",moreMatchesFound:"{num} matches found"},"oj-ojTreeView":{treeViewSelectorAria:"TreeView Selector {rowKey}"},"oj-ojTree":{stateLoading:"Loading...",labelNewNode:"New Node",labelMultiSelection:"Multiple Selection",labelEdit:"Edit",labelCreate:"Create",labelCut:"Cut",labelCopy:"Copy",labelPaste:"Paste",labelPasteAfter:"Paste After",labelPasteBefore:"Paste Before",labelRemove:"Remove",labelRename:"Rename",labelNoData:"No data"},"oj-ojPagingControl":{labelAccPaging:"Pagination",labelAccPageNumber:"Page {pageNum} content loaded",labelAccNavFirstPage:"First Page",labelAccNavLastPage:"Last Page",labelAccNavNextPage:"Next Page",labelAccNavPreviousPage:"Previous Page",labelAccNavPage:"Page",labelLoadMore:"Show More...",labelLoadMoreMaxRows:"Reached Maximum Limit of {maxRows} rows",labelNavInputPage:"Page",labelNavInputPageMax:"of {pageMax}",fullMsgItemRange:"{pageFrom}-{pageTo} of {pageMax} items",fullMsgItemRangeAtLeast:"{pageFrom}-{pageTo} of at least {pageMax} items",fullMsgItemRangeApprox:"{pageFrom}-{pageTo} of approx {pageMax} items",msgItemRangeNoTotal:"{pageFrom}-{pageTo} items",fullMsgItem:"{pageTo} of {pageMax} items",fullMsgItemAtLeast:"{pageTo} of at least {pageMax} items",fullMsgItemApprox:"{pageTo} of approx {pageMax} items",msgItemNoTotal:"{pageTo} items",msgItemRangeCurrent:"{pageFrom}-{pageTo}",msgItemRangeCurrentSingle:"{pageFrom}",msgItemRangeOf:"of",msgItemRangeOfAtLeast:"of at least",msgItemRangeOfApprox:"of approx.",msgItemRangeItems:"items",tipNavInputPage:"Go To Page",tipNavPageLink:"Go To Page {pageNum}",tipNavNextPage:"Next",tipNavPreviousPage:"Previous",tipNavFirstPage:"First",tipNavLastPage:"Last",pageInvalid:{summary:"The page value entered is invalid.",detail:"Please enter a value greater than 0."},maxPageLinksInvalid:{summary:"Value for maxPageLinks is invalid.",detail:"Please enter a value greater than 4."}},"oj-ojMasonryLayout":{labelCut:"Cut",labelPasteBefore:"Paste Before",labelPasteAfter:"Paste After"},"oj-panel":{labelAccButtonExpand:"Expand",labelAccButtonCollapse:"Collapse",labelAccButtonRemove:"Remove",labelAccFlipForward:"Flip forward",labelAccFlipBack:"Flip back",tipDragToReorder:"Drag to reorder",labelAccDragToReorder:"Drag to reorder, context menu available"},"oj-ojChart":{labelDefaultGroupName:"Group {0}",labelSeries:"Series",labelGroup:"Group",labelDate:"Date",labelValue:"Value",labelTargetValue:"Target",labelX:"X",labelY:"Y",labelZ:"Z",labelPercentage:"Percentage",labelLow:"Low",labelHigh:"High",labelOpen:"Open",labelClose:"Close",labelVolume:"Volume",labelQ1:"Q1",labelQ2:"Q2",labelQ3:"Q3",labelMin:"Min",labelMax:"Max",labelOther:"Other",tooltipPan:"Pan",tooltipSelect:"Marquee select",tooltipZoom:"Marquee zoom",componentName:"Chart"},"oj-dvtBaseGauge":{componentName:"Gauge"},"oj-ojDiagram":{promotedLink:"{0} link",promotedLinks:"{0} links",promotedLinkAriaDesc:"Indirect",componentName:"Diagram"},"oj-ojGantt":{componentName:"Gantt",accessibleDurationDays:"{0} days",accessibleDurationHours:"{0} hours",accessibleTaskInfo:"Start time is {0}, end time is {1}, duration is {2}",accessibleMilestoneInfo:"Time is {0}",accessibleRowInfo:"Row {0}",accessibleTaskTypeMilestone:"Milestone",accessibleTaskTypeSummary:"Summary",accessiblePredecessorInfo:"{0} predecessors",accessibleSuccessorInfo:"{0} successors",accessibleDependencyInfo:"Dependency type {0}, connects {1} to {2}",startStartDependencyAriaDesc:"start to start",startFinishDependencyAriaDesc:"start to finish",finishStartDependencyAriaDesc:"finish to start",finishFinishDependencyAriaDesc:"finish to finish",tooltipZoomIn:"Zoom In",tooltipZoomOut:"Zoom Out",labelLevel:"Level",labelRow:"Row",labelStart:"Start",labelEnd:"End",labelDate:"Date",labelBaselineStart:"Baseline Start",labelBaselineEnd:"Baseline End",labelBaselineDate:"Baseline Date",labelLabel:"Label",labelProgress:"Progress",labelMoveBy:"Move By",labelResizeBy:"Resize By",taskMoveInitiated:"Task move initiated",taskResizeEndInitiated:"Task resize end initiated",taskResizeStartInitiated:"Task resize start initiated",taskMoveSelectionInfo:"{0} others selected",taskResizeSelectionInfo:"{0} others selected",taskMoveInitiatedInstruction:"Use the arrow keys to move",taskResizeInitiatedInstruction:"Use the arrow keys to resize",taskMoveFinalized:"Task move finalized",taskResizeFinalized:"Task resize finalized",taskMoveCancelled:"Task move cancelled",taskResizeCancelled:"Task resize cancelled",taskResizeStartHandle:"Task resize start handle",taskResizeEndHandle:"Task resize end handle"},"oj-ojLegend":{componentName:"Legend",tooltipExpand:"Expand",tooltipCollapse:"Collapse"},"oj-ojNBox":{highlightedCount:"{0}/{1}",labelOther:"Other",labelGroup:"Group",labelSize:"Size",labelAdditionalData:"Additional Data",componentName:"{0} Box"},"oj-ojPictoChart":{componentName:"Picture Chart"},"oj-ojSparkChart":{componentName:"Chart"},"oj-ojSunburst":{labelColor:"Color",labelSize:"Size",tooltipExpand:"Expand",tooltipCollapse:"Collapse",componentName:"Sunburst"},"oj-ojTagCloud":{componentName:"Tag Cloud"},"oj-ojThematicMap":{componentName:"Thematic Map",areasRegion:"Areas",linksRegion:"Links",markersRegion:"Markers"},"oj-ojTimeAxis":{componentName:"Time Axis"},"oj-ojTimeline":{componentName:"Timeline",accessibleItemDesc:"Description is {0}.",accessibleItemEnd:"End time is {0}.",accessibleItemStart:"Start time is {0}.",accessibleItemTitle:"Title is {0}.",labelSeries:"Series",tooltipZoomIn:"Zoom In",tooltipZoomOut:"Zoom Out",labelStart:"Start",labelEnd:"End",labelDate:"Date",labelTitle:"Title",labelDescription:"Description"},"oj-ojTreemap":{labelColor:"Color",labelSize:"Size",tooltipIsolate:"Isolate",tooltipRestore:"Restore",componentName:"Treemap"},"oj-dvtBaseComponent":{labelScalingSuffixThousand:"K",labelScalingSuffixMillion:"M",labelScalingSuffixBillion:"B",labelScalingSuffixTrillion:"T",labelScalingSuffixQuadrillion:"Q",labelInvalidData:"Invalid data",labelNoData:"No data to display",labelClearSelection:"Clear Selection",labelDataVisualization:"Data Visualization",stateSelected:"Selected",stateUnselected:"Unselected",stateMaximized:"Maximized",stateMinimized:"Minimized",stateExpanded:"Expanded",stateCollapsed:"Collapsed",stateIsolated:"Isolated",stateHidden:"Hidden",stateVisible:"Visible",stateDrillable:"Drillable",labelAndValue:"{0}: {1}",labelCountWithTotal:"{0} of {1}"},"oj-ojNavigationList":{defaultRootLabel:"Navigation List",hierMenuBtnLabel:"Hierarchical Menu button",selectedLabel:"selected",previousIcon:"Previous",msgFetchingData:"Fetching Data...",msgNoData:"No items to display.",overflowItemLabel:"More",accessibleReorderTouchInstructionText:"Double tap and hold.  Wait for the sound then drag to rearrange.",accessibleReorderBeforeItem:"Before {item}",accessibleReorderAfterItem:"After {item}",labelCut:"Cut",labelPasteBefore:"Paste Before",labelPasteAfter:"Paste After",labelRemove:"Remove",removeCueText:"Removable"},"oj-ojSlider":{noValue:"ojSlider has no value",maxMin:"Max must not be less than or equal to min",startEnd:"value.start must not be greater than value.end",valueRange:"Value must be within min to max range",optionNum:"{option} option is not a number",invalidStep:"Invalid step; step must be > 0",lowerValueThumb:"lower value thumb",higherValueThumb:"higher value thumb"},"oj-ojDialog":{labelCloseIcon:"Close"},"oj-ojPopup":{ariaLiveRegionInitialFocusFirstFocusable:"Entering pop-up. Press F6 to navigate between the pop-up and associated control.",ariaLiveRegionInitialFocusNone:"Pop-up opened. Press F6 to navigate between the pop-up and associated control.",ariaLiveRegionInitialFocusFirstFocusableTouch:"Entering pop-up. Pop-up can be closed by navigating to the last link within the pop-up.",ariaLiveRegionInitialFocusNoneTouch:"Pop-up opened. Navigate to the next link to establish focus within the pop-up.",ariaFocusSkipLink:"Double tap to navigate to the open pop-up.",ariaCloseSkipLink:"Double tap to close the open pop-up."},"oj-ojRefresher":{ariaRefreshLink:"Activate link to refresh content",ariaRefreshingLink:"Refreshing content",ariaRefreshCompleteLink:"Refresh complete"},"oj-ojSwipeActions":{ariaShowStartActionsDescription:"Show start actions",ariaShowEndActionsDescription:"Show end actions",ariaHideActionsDescription:"Hide actions"},"oj-ojIndexer":{indexerCharacters:"A|B|C|D|E|F|G|H|I|J|K|L|M|N|O|P|Q|R|S|T|U|V|W|X|Y|Z",indexerOthers:"#",ariaDisabledLabel:"No matching group header",ariaOthersLabel:"number",ariaInBetweenText:"Between {first} and {second}",ariaKeyboardInstructionText:"Press enter to select value.",ariaTouchInstructionText:"Double tap and hold to enter gesture mode, then drag up or down to adjust value."},"oj-ojMenu":{labelCancel:"Cancel",ariaFocusSkipLink:"Focus is within the menu, double tap or swipe to move focus to the first menu item."},"oj-ojColorSpectrum":{labelHue:"Hue",labelOpacity:"Opacity",labelSatLum:"Saturation/Luminance",labelThumbDesc:"Color spectrum four way slider."},"oj-ojColorPalette":{labelNone:"None"},"oj-ojColorPicker":{labelSwatches:"Swatches",labelCustomColors:"Custom Colors",labelPrevColor:"Previous Color",labelDefColor:"Default Color",labelDelete:"Delete",labelDeleteQ:"Delete?",labelAdd:"Add",labelAddColor:"Add color",labelMenuHex:"HEX",labelMenuRgba:"RGBa",labelMenuHsla:"HSLa",labelSliderHue:"Hue",labelSliderSaturation:"Saturation",labelSliderSat:"Sat",labelSliderLightness:"Lightness",labelSliderLum:"Luminosity",labelSliderAlpha:"Alpha",labelOpacity:"Opacity",labelSliderRed:"Red",labelSliderGreen:"Green",labelSliderBlue:"Blue"},"oj-ojFilePicker":{dropzoneText:"Drop files here or click to upload",singleFileUploadError:"Upload one file at a time.",singleFileTypeUploadError:"You can't upload files of type {fileType}.",multipleFileTypeUploadError:"You can't upload files of type: {fileTypes}.",dropzonePrimaryText:"Drag and Drop",secondaryDropzoneText:"Select a file or drop one here.",secondaryDropzoneTextMultiple:"Select or drop files here.",unknownFileType:"unknown"},"oj-ojProgressbar":{ariaIndeterminateProgressText:"In Progress"},"oj-ojMessage":{labelCloseIcon:"Close",categories:{error:"Error",warning:"Warning",info:"Information",confirmation:"Confirmation"}},"oj-ojSelector":{checkboxAriaLabel:"Checkbox Select {rowKey}",checkboxAriaLabelSelected:" selected",checkboxAriaLabelUnselected:" unselected"},"oj-ojMessages":{labelLandmark:"Messages",ariaLiveRegion:{navigationFromKeyboard:"Entering messages region. Press F6 to navigate back to prior focused element.",navigationToTouch:"Messages region has new messages. Use the voice-over rotor to navigate to the messages landmark.",navigationToKeyboard:"Messages region has new messages.  Press F6 to navigate to the most recent message region.",newMessage:"Message category {category}. {summary}. {detail}."}},"oj-ojConveyorBelt":{tipArrowNext:"Next",tipArrowPrevious:"Previous"}},ar:1,"ar-XB":1,bg:1,bs:1,"bs-Cyrl":1,cs:1,da:1,de:1,el:1,"en-XA":1,"en-XC":1,es:1,et:1,fi:1,fr:1,"fr-CA":1,he:1,hr:1,hu:1,is:1,it:1,ja:1,ko:1,lt:1,lv:1,ms:1,nl:1,no:1,pl:1,pseudo:1,pt:1,"pt-PT":1,ro:1,ru:1,sk:1,sl:1,sr:1,"sr-Latn":1,sv:1,th:1,tr:1,uk:1,vi:1,"zh-Hans":1,"zh-Hant":1});

/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojconfig',["require","exports","ojs/ojcore-base","ojL10n!ojtranslations/nls/ojtranslations"],function(e,n,o,t){"use strict";function r(e){if(e&&e.__esModule)return e;var n={};return e&&Object.keys(e).forEach(function(o){var t=Object.getOwnPropertyDescriptor(e,o);Object.defineProperty(n,o,t.get?t:{enumerable:!0,get:function(){return e[o]}})}),n.default=e,n}o=o&&Object.prototype.hasOwnProperty.call(o,"default")?o.default:o,t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t;const a={};let i=t;a.getDeviceRenderMode=function(){return document.body.getAttribute("data-oj-device-render-mode")||a.getDeviceType()},a.getDeviceType=function(){return o.AgentUtils.getAgentInfo().deviceType},a.getLocale=function(){if(o.__isAmdLoaderPresent()){o.Assert.assert(void 0!==i,"ojtranslations module must be defined");var e=i._ojLocale_;return"root"===e?"en":e}var n=a._locale;return null==n&&((n=document.documentElement.lang)||(n=void 0===navigator?"en":(navigator.language||navigator.userLanguage||"en").toLowerCase()),n=n.toLowerCase(),a._locale=n),n},a.setLocale=function(n,t){if(o.__isAmdLoaderPresent()){var s="ojL10n!ojtranslations/nls/",u=s+n+"/ojtranslations";var l=[new Promise(function(n,o){e([u],function(e){n(r(e))},o)}).then(e=>{i=e})];if(o.LocaleData){var c=s+n+"/localeElements";const t=new Promise(function(n,o){e([c],function(e){n(r(e))},o)}).then(e=>{e&&o.LocaleData.__updateBundle(Object.assign({},e.default))});if(l.push(t),o.TimezoneData){var g=o.TimezoneData.__getBundleNames().map(o=>new Promise(function(t,a){e([`${s}${n}${o}`],function(e){t(r(e))},a)}));l.push(Promise.all(g).then(e=>{e.forEach(o.TimezoneData.__mergeIntoLocaleElements)}))}}Promise.all(l).then(()=>{t&&t()})}else a._locale=n,t&&t()},a.getResourceUrl=function(e){if(null==e||/^\/|:/.test(e))return e;var n=a._resourceBaseUrl;null==n&&(n=a._getOjBaseUrl()||"");var o=n.length;return n+(0===o||"/"===n.charAt(o-1)?"":"/")+e},a.setResourceBaseUrl=function(e){a._resourceBaseUrl=e},a.setAutomationMode=function(e){a._automationMode=e},a.getAutomationMode=function(){return a._automationMode},a.getVersionInfo=function(){var e="Oracle JET Version: "+o.version+"\n";e+="Oracle JET Revision: "+o.revision+"\n";var n="undefined"!=typeof window;return n&&window.navigator&&(e+="Browser: "+window.navigator.userAgent+"\n",e+="Browser Platform: "+window.navigator.platform+"\n"),$&&($.fn&&(e+="jQuery Version: "+$.fn.jquery+"\n"),$.ui&&$.ui.version&&(e+="jQuery UI Version: "+$.ui.version+"\n")),o.ComponentBinding&&(e+="Knockout Version: "+o.ComponentBinding.__getKnockoutVersion()+"\n"),n&&window.require&&(e+="Require Version: "+window.require.version+"\n"),e},a.logVersionInfo=function(){},a._getOjBaseUrl=function(){var n=null;o.__isAmdLoaderPresent()&&(n=e.toUrl("ojs/_foo_").replace(/[^/]*$/,"../"));return n},a.__getTemplateEngine=function(){if(!a._templateEnginePromise){if(!o.__isAmdLoaderPresent())throw new Error("JET Template engine cannot be loaded without an AMD loader");a._templateEnginePromise=new Promise(function(n,o){e(["ojs/ojtemplateengine"],function(e){n(r(e))},o)}).then(e=>e.default)}return a._templateEnginePromise},a.getConfigBundle=function(){return i},a.getExpressionEvaluator=function(){return a._expressionEvaluator},a.setExpressionEvaluator=function(e){if(a._expressionEvaluator)throw new Error("JET Expression evaluator can't be set more than once.");a._expressionEvaluator=e};const s=a.getDeviceRenderMode,u=a.getDeviceType,l=a.getLocale,c=a.setLocale,g=a.getResourceUrl,d=a.setResourceBaseUrl,f=a.setAutomationMode,m=a.getAutomationMode,v=a.getVersionInfo,_=a.logVersionInfo,p=a.setExpressionEvaluator,E=a.getExpressionEvaluator,w=a.getConfigBundle,j=a.__getTemplateEngine;n.__getTemplateEngine=j,n.getAutomationMode=m,n.getConfigBundle=w,n.getDeviceRenderMode=s,n.getDeviceType=u,n.getExpressionEvaluator=E,n.getLocale=l,n.getResourceUrl=g,n.getVersionInfo=v,n.logVersionInfo=_,n.setAutomationMode=f,n.setExpressionEvaluator=p,n.setLocale=c,n.setResourceBaseUrl=d,Object.defineProperty(n,"__esModule",{value:!0})});
//# sourceMappingURL=ojconfig.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojresponsiveutils',["exports","ojs/ojcore-base","ojs/ojlogger"],function(e,o,t){"use strict";o=o&&Object.prototype.hasOwnProperty.call(o,"default")?o.default:o;const r={};o._registerLegacyNamespaceProp("ResponsiveUtils",r),r.SCREEN_RANGE={SM:"sm",MD:"md",LG:"lg",XL:"xl",XXL:"xxl"},r.FRAMEWORK_QUERY_KEY={SM_UP:"sm-up",MD_UP:"md-up",LG_UP:"lg-up",XL_UP:"xl-up",XXL_UP:"xxl-up",SM_ONLY:"sm-only",MD_ONLY:"md-only",LG_ONLY:"lg-only",XL_ONLY:"xl-only",MD_DOWN:"md-down",LG_DOWN:"lg-down",XL_DOWN:"xl-down",HIGH_RESOLUTION:"high-resolution"},r._RANGE={},r._RANGE[r.SCREEN_RANGE.SM]=0,r._RANGE[r.SCREEN_RANGE.MD]=1,r._RANGE[r.SCREEN_RANGE.LG]=2,r._RANGE[r.SCREEN_RANGE.XL]=3,r._RANGE[r.SCREEN_RANGE.XXL]=4,r._getMediaQueryFromClass=function(e){var o=document.getElementsByClassName(e).item(0);return null===o&&((o=document.createElement("meta")).className=e,document.head.appendChild(o)),window.getComputedStyle(o).getPropertyValue("font-family").replace(/^[/\\'"]+|(;\s?})+|[/\\'"]+$/g,"")},r.getFrameworkQuery=function(e){var o="oj-mq-"+e,s=r._getMediaQueryFromClass(o);return"null"===s?(t.warn("Framework query not found. Please check that the value of the theming variable$includeResponsiveMediaQueryClasses is set to true, if itis set to false the media queries are not sent down to the browser."),null):s},r.compare=function(e,o){var t=r._RANGE[e],s=r._RANGE[o];if(null==t)throw new Error("size1 param "+e+" illegal, please use one of the screen size constants like oj.ResponsiveUtils.SCREEN_RANGE.MD");if(null==s)throw new Error("size2 param "+o+" illegal, please use one of the screen size constants like oj.ResponsiveUtils.SCREEN_RANGE.MD");return t-s};const s=r.compare,l=r.getFrameworkQuery,n=r.SCREEN_RANGE,a=r.FRAMEWORK_QUERY_KEY;e.FRAMEWORK_QUERY_KEY=a,e.SCREEN_RANGE=n,e.compare=s,e.getFrameworkQuery=l,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojresponsiveutils.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojthemeutils',["exports","ojs/ojcore-base","ojs/ojlogger"],function(e,t,a){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t;const r={getThemeName:function(){return(r.parseJSONFromFontFamily("oj-theme-json")||{}).name},getThemeTargetPlatform:function(){return(r.parseJSONFromFontFamily("oj-theme-json")||{}).targetPlatform},clearCache:function(){r._cache=null,r._cssVarCache=null},parseJSONFromFontFamily:function(e){null==r._cache&&(r._cache={},r._null_cache_value={},r._headfontstring=window.getComputedStyle(document.head).getPropertyValue("font-family"));var t=r._cache[e];if(t===r._null_cache_value)return null;if(null!=t)return t;if("undefined"==typeof document)return null;var o=document.createElement("meta");o.className=e,document.head.appendChild(o);var n=window.getComputedStyle(o).getPropertyValue("font-family");if(null!=n)if(n===r._headfontstring)a.warn("parseJSONFromFontFamily: When the selector ",e," is applied the font-family read off the dom element is ",n,". The parent dom elment has the same font-family value."," This is interpreted to mean that no value was sent down for selector ",e,". Null will be returned.");else{var l=n.replace(/^['"]+|\s+|\\|(;\s?})+|['"]$/g,"");if(l)try{t=JSON.parse(l)}catch(r){var s=l.indexOf(","),c=!1;if(s>-1){l=l.substring(s+2);try{t=JSON.parse(l),c=!0}catch(e){}}if(!1===c)throw a.error("Error parsing json for selector "+e+".\nString being parsed is "+l+". Error is:\n",r),document.head.removeChild(o),r}}return document.head.removeChild(o),r._cache[e]=null==t?r._null_cache_value:t,t}};var o=e=>(r._cssVarCache||(r._cssVarCache=new Map),r._cssVarCache.has(e)||r._cssVarCache.set(e,(e=>(r._rootCSSStyles||(r._rootCSSStyles=window.getComputedStyle(document.documentElement)),r._rootCSSStyles.getPropertyValue(e).replace(/^['"\s]+|\s+|\\|(;\s?})+|['"]$/g,"")))(e)),r._cssVarCache.get(e));r.getCachedCSSVarValues=e=>e.map(e=>o(e)),r.verifyThemeVersion=()=>{};const n=r.clearCache,l=r.getThemeName,s=r.getThemeTargetPlatform,c=r.parseJSONFromFontFamily,m=r.verifyThemeVersion,i=r.getCachedCSSVarValues;e.clearCache=n,e.getCachedCSSVarValues=i,e.getThemeName=l,e.getThemeTargetPlatform=s,e.parseJSONFromFontFamily=c,e.verifyThemeVersion=m,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojthemeutils.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojtimerutils',["exports"],function(e){"use strict";const n={};function t(){}t.prototype.getPromise=function(){},t.prototype.clear=function(){},n.getTimer=function(e){return new n._TimerImpl(e)},n._TimerImpl=function(e){var n,t,i;function o(e){i=null,t(e)}this.getPromise=function(){return n},this.clear=function(){window.clearTimeout(i),i=null,o(!1)},n="undefined"==typeof window?Promise.reject():new Promise(function(n){t=n,i=window.setTimeout(o.bind(null,!0),e)})};const i=n.getTimer;e.getTimer=i,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojtimerutils.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojtranslation',["exports","ojs/ojcore-base","ojs/ojconfig"],function(e,t,r){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t;const n={setBundle:function(e){n._bundle=e},getResource:function(e){return n._getResourceString(e)},applyParameters:function(e,t){return null==e?null:n._format(e,t)},getTranslatedString:function(e,t){var r=n._getResourceString(e);if(null==r)return e;var a={};return arguments.length>2?a=Array.prototype.slice.call(arguments,1):2===arguments.length&&("object"==typeof(a=arguments[1])||a instanceof Array||(a=[a])),n.applyParameters(r,a)},getComponentTranslations:function(e){var t=n._getBundle()[e];if(null==t)return{};for(var r={},a=Object.keys(t),s=0;s<a.length;s++){var l=a[s];r[l]=t[l]}return r},_getResourceString:function(e){var r=e?e.split("."):[],a=n._getBundle();t.Assert.assertObject(a);for(var s=0;s<r.length&&null!=a;s++){a=a[r[s]]}return null!=a?a:null},_format:function(e,t){var r,n,a=e.length,s=[],l=null,o=!1,u=!1,i=!1,c=!1;for(n=0;n<a;n++){var f=e.charAt(n),g=!1;if(o)g=!0,o=!1;else switch(f){case"$":o=!0;break;case"{":c||(u||(r=!1,l=[]),u=!0);break;case"}":if(u&&l.length>0){var d=t[l.join("")];s.push(void 0===d?"null":d)}u=!1;break;case"[":u||(i?c=!0:i=!0);break;case"]":c?c=!1:i=!1;break;default:g=!0}g&&(u?","===f||" "===f?r=!0:r||l.push(f):c||s.push(f))}return s.join("")},_getBundle:function(){var e=n._bundle;if(e)return e;if(t.__isAmdLoaderPresent()){var a=r.getConfigBundle();return t.Assert.assert(void 0!==a,"ojtranslations module must be defined"),a}return{}}},a=n.setBundle,s=n.getResource,l=n.applyParameters,o=n.getTranslatedString,u=n.getComponentTranslations;e.applyParameters=l,e.getComponentTranslations=u,e.getResource=s,e.getTranslatedString=o,e.setBundle=a,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojtranslation.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojcore',["ojs/ojcore-base","ojs/ojlogger","ojs/ojcontext","ojs/ojconfig","ojs/ojresponsiveutils","ojs/ojthemeutils","ojs/ojtimerutils","ojs/ojtranslation"],function(e,o,s,r,t,a,i,c){"use strict";return e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e,s=s&&Object.prototype.hasOwnProperty.call(s,"default")?s.default:s,e._registerLegacyNamespaceProp("Logger",o),e._registerLegacyNamespaceProp("Context",s),e._registerLegacyNamespaceProp("Config",r),e._registerLegacyNamespaceProp("ResponsiveUtils",t),e._registerLegacyNamespaceProp("ThemeUtils",a),e._registerLegacyNamespaceProp("TimerUtils",i),e._registerLegacyNamespaceProp("Translations",c),e});
//# sourceMappingURL=ojcore.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojmessaging',["ojs/ojcore-base","jquery"],function(t,e){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e;const E=function(t,e,E){this.Init(t,e,E)};t._registerLegacyNamespaceProp("Message",E),E.SEVERITY_TYPE={CONFIRMATION:"confirmation",INFO:"info",WARNING:"warning",ERROR:"error",FATAL:"fatal"},E.SEVERITY_LEVEL={FATAL:5,ERROR:4,WARNING:3,INFO:2,CONFIRMATION:1},t.Object.createSubclass(E,t.Object,"Message"),E.prototype.Init=function(t,e,n){E.superclass.Init.call(this),this.summary=t,this.detail=e,this.severity=n||E.SEVERITY_TYPE.ERROR},E.getSeverityLevel=function(t){var e=t;if(e)if("string"==typeof t){var n=E._LEVEL_TO_TYPE.indexOf(e,1);e=-1===n?E.SEVERITY_LEVEL.ERROR:n}else"number"==typeof e&&(e<E.SEVERITY_LEVEL.CONFIRMATION||e>E.SEVERITY_LEVEL.FATAL)&&(e=E.SEVERITY_LEVEL.ERROR);return e||E.SEVERITY_LEVEL.ERROR},E.getSeverityType=function(t){var e=t;e&&("string"==typeof e?-1===E._LEVEL_TO_TYPE.indexOf(e,1)&&(e=E.SEVERITY_TYPE.ERROR):"number"==typeof e&&(e=e<E.SEVERITY_LEVEL.CONFIRMATION||e>E.SEVERITY_LEVEL.FATAL?E.SEVERITY_TYPE.ERROR:E._LEVEL_TO_TYPE[t]));return e||E.SEVERITY_TYPE.ERROR},E.getMaxSeverity=function(t){var n=-1;return t&&t.length>0&&e.each(t,function(t,e){var i=E.getSeverityLevel(e.severity);n=n<i?i:n}),n},E.isValid=function(t){return!(E.getMaxSeverity(t)>=E.SEVERITY_LEVEL.ERROR)},E._LEVEL_TO_TYPE=["none",E.SEVERITY_TYPE.CONFIRMATION,E.SEVERITY_TYPE.INFO,E.SEVERITY_TYPE.WARNING,E.SEVERITY_TYPE.ERROR,E.SEVERITY_TYPE.FATAL];const n=function(t,e,E,n){this.Init(t,e,E,n)};return t.Object.createSubclass(n,E,"ComponentMessage"),n._DEFAULT_OPTIONS={display:(n.DISPLAY={SHOWN:"shown",HIDDEN:"hidden"}).SHOWN,context:""},n.prototype.Init=function(t,E,i,o){n.superclass.Init.call(this,t,E,i),this._options=e.extend({},n._DEFAULT_OPTIONS,o)},n.prototype.clone=function(){return new n(this.summary,this.detail,this.severity,this._options)},n.prototype.canDisplay=function(){return!(this._options&&this._options.display&&this._options.display===n.DISPLAY.HIDDEN)},n.prototype._forceDisplayToShown=function(){return!(!this._options||n.DISPLAY.HIDDEN!==this._options.display)&&(this._options.display=n.DISPLAY.SHOWN,!0)},n.prototype._isMessageAddedByComponent=function(){return!(!this._options||!this._options.context)},E.ComponentMessage=n,E});
//# sourceMappingURL=ojmessaging.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojcustomelement-utils',["exports","ojs/ojcore-base","ojs/ojcontext","ojs/ojlogger","ojs/ojthemeutils"],function(e,t,i,r,n){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,i=i&&Object.prototype.hasOwnProperty.call(i,"default")?i.default:i;const s={};class o{static isValidCustomElementName(e){const t=o._RESERVED_TAGS.has(e),i=o._ELEMENT_NAME_REGEXP.test(e);return!t&&i&&!e.startsWith("oj-bind-",0)}static getSupportedTypes(e){if(!e)return{};let t=s[e];if(!t){t={};const i=e.toLowerCase(),r=i.match(/(?=[^|])(?:[^|]*<[^>]+>)*[^|]*/g);let n=0;r.forEach(e=>{const i=e.trim();"any"===i||"boolean"===i||"number"===i||"string"===i||"array"===i||"object"===i||"null"===i?t[i]=1:0===i.indexOf("array<")?t.array=1:0===i.indexOf("object<")?t.object=1:t.other=1,n++}),t.typeCount=n,s[i]=t}return t}static getUniqueId(e){if(e)return e;const t=o._UNIQUE+o._UNIQUE_INCR;return o._UNIQUE_INCR+=1,t}static comparePropertyValues(e,i,r){return e.writeback?t.Object.compareValues(i,r):i===r}}o._UNIQUE_INCR=0,o._UNIQUE="_oj",o._RESERVED_TAGS=new Set(["annotation-xml","color-profile","font-face","font-face-src","font-face-uri","font-face-format","font-face-name","missing-glyph"]),o._ELEMENT_NAME_REGEXP=/^[a-z][.0-9_a-z]*-[-.0-9_a-z]*$/;const a={accessKey:"accesskey",autocapitalize:"autocapitalize",autofocus:"autofocus",class:"class",contentEditable:"contenteditable",dir:"dir",draggable:"draggable",enterKeyHint:"enterkeyhint",hidden:"hidden",id:"id",inputMode:"inputmode",lang:"lang",role:"role",slot:"slot",spellcheck:"spellcheck",style:"style",tabIndex:"tabindex",translate:"translate",title:"title"};class l extends Error{constructor(e,t){super(`${e.localName} with id '${e.id||""}': ${t}`),Error.captureStackTrace&&Error.captureStackTrace(this,l),this.name="JetElementError"}}const d=/^\s*\[[^]*\]\s*$/,c=/^\s*\{[^]*\}\s*$/,p=/^(?:\{\{)([^]+)(?:\}\})$/,u=/^(?:\[\[)([^]+)(?:\]\])$/,g={};Object.keys(a).forEach(function(e){const t=a[e];e!==t&&(g[t]=e)});class h{static getExpressionInfo(e){let t,i=!1;if(e){const r=e.trim();let n=p.exec(r);t=null==n?void 0:n[1],t||(i=!0,n=u.exec(r),t=null==n?void 0:n[1])}return{downstreamOnly:i,expr:t}}static attributeToPropertyValue(e,t,i,r){if(null!=i)try{return h.coerceValue(e,t,i,r.type)}catch(i){throw new l(e,`Error while parsing parsing attribute ${t}. ${i.stack||i}`)}}static coerceValue(e,t,i,r){const n=e.tagName.toLowerCase();if(!r)throw new Error(`Unable to parse ${t}='${i}' for ${n} with id '${e.id}'.         This attribute only supports data bound values. Check the API doc for supported types`);const s=o.getSupportedTypes(r),a=d.test(i),l=c.test(i);if(s.array&&a||s.object&&l||s.any&&(a||l))try{return JSON.parse(i)}catch(r){throw new Error(`Unable to parse ${t}='${i}' for ${n} with id '${e.id}'           to a JSON Object. Check the value for correct JSON syntax, e.g. double quoted strings. ${r}`)}else{if(s.string||s.any)return i;if(s.boolean)return h.coerceBooleanValue(e,t,i,r);if(s.number&&!isNaN(i))return Number(i)}throw new Error(`Unable to parse ${t}='${i}' for ${n} with id '${e.id}'       to a ${r}.`)}static coerceBooleanValue(e,t,i,r){if(null==i||"true"===i||""===i||i.toLowerCase()===t)return!0;if("false"===i)return!1;const n=e.tagName.toLowerCase();throw new Error(`Unable to parse ${t}='${i}' for ${n} with id '${e.id}' to a ${r}.`)}static isGlobalOrData(e){return Object.prototype.hasOwnProperty.call(a,e)||e.startsWith("data-")||e.startsWith("aria-")}static getGlobalAttrForProp(e){return a[e]||e}static getGlobalPropForAttr(e){return g[e]||e}}function m(e,t){let i=e.cache;return i||(i=new Map,e.cache=i),i.has(t)||i.set(t,e(t)),i.get(t)}h.attributeToPropertyName=m.bind(null,e=>e.toLowerCase().replace(/-(.)/g,(e,t)=>t.toUpperCase())),h.propertyNameToAttribute=m.bind(null,e=>e.replace(/([A-Z])/g,e=>"-"+e.toLowerCase())),h.eventTypeToEventListenerProperty=m.bind(null,e=>"on"+e.substr(0,1).toUpperCase()+e.substr(1)),h.isEventListenerProperty=m.bind(null,e=>/^on[A-Z]/.test(e)),h.isEventListenerAttr=m.bind(null,e=>/^on-[a-z]/.test(e)),h.eventListenerPropertyToEventType=m.bind(null,e=>e.substr(2,1).toLowerCase()+e.substr(3)),h.propertyNameToChangeEventType=m.bind(null,e=>e+"Changed"),h.propertyNameToChangedCallback=m.bind(null,e=>`on${e[0].toUpperCase()}${e.substr(1)}Changed`),h.eventTriggerToEventType=m.bind(null,e=>`oj${e.substr(0,1).toUpperCase()}${e.substr(1)}`),h.eventAttrToPreactPropertyName=m.bind(null,e=>e.toLowerCase().split("-").reduce((e,t,i)=>{return i>1?e+((r=t).charAt(0).toUpperCase()+r.substr(1)):e+t;var r},""));const _=new Set;class E{static registerElement(e,t,i){const r=e.toUpperCase();if(!E._CUSTOM_ELEMENT_REGISTRY[r]){if(!t.descriptor)throw new Error(`Custom element ${e} must be registered with a descriptor.`);E._CUSTOM_ELEMENT_REGISTRY[e]=t,E._CUSTOM_ELEMENT_REGISTRY[r]=t,Object.defineProperty(i,"name",{value:E.tagNameToElementClassName(e)}),customElements.define(e,i)}}static tagNameToElementClassName(e){return e.toLowerCase().match(/-(?<match>.*)/)[0].replace(/-(.)/g,(e,t)=>t.toUpperCase())+"Element"}static isComposite(e){var t,i;return null!==(i=null===(t=E.getElementRegistration(e))||void 0===t?void 0:t.composite)&&void 0!==i&&i}static isVComponent(e){var t,i;return null!==(i=null===(t=E.getElementRegistration(e))||void 0===t?void 0:t.vcomp)&&void 0!==i&&i}static isElementRegistered(e){return null!=E._CUSTOM_ELEMENT_REGISTRY[e]}static getElementRegistration(e){var t;return null!==(t=E._CUSTOM_ELEMENT_REGISTRY[e])&&void 0!==t?t:null}static getElementDescriptor(e){var t;return(null===(t=E.getElementRegistration(e))||void 0===t?void 0:t.descriptor)||{}}static getElementProperties(e){var t,i;const r=E.getElementDescriptor(e.tagName);return(null===(i=null!==(t=r._metadata)&&void 0!==t?t:r.metadata)||void 0===i?void 0:i.properties)||{}}static getElementInfo(e){return e?`${e.tagName.toLowerCase()} with id '${e.id}'`:""}static getElementState(e){let t=e[E._ELEMENT_STATE_KEY];if(!t&&E.isElementRegistered(e.tagName)){t=new(0,E.getElementRegistration(e.tagName).stateClass)(e),Object.defineProperty(e,E._ELEMENT_STATE_KEY,{value:t})}return null!=t?t:null}static getElementBridge(e){let t=e[E._ELEMENT_BRIDGE_KEY];if(!t&&E.isElementRegistered(e.tagName)){const i=E.getElementRegistration(e.tagName).bridgeProto;t=Object.create(i);const r=E.getElementDescriptor(e.tagName);t.initializeBridge(e,r),Object.defineProperty(e,E._ELEMENT_BRIDGE_KEY,{value:t})}return null!=t?t:null}static getSlotMap(e){const t={},i=e.childNodes;for(let e=0;e<i.length;e++){const r=i[e];if(E.isSlotable(r)){const e=E.getSlotAssignment(r);t[e]||(t[e]=[]),t[e].push(r)}}return t}static getSlotAssignment(e){const t=null!=e.__oj_slots?e.__oj_slots:e.getAttribute&&e.getAttribute("slot");return t||""}static isSlotable(e){return 1===e.nodeType||3===e.nodeType&&!!e.nodeValue.trim()}static getElementProperty(e,t){if(E.isElementRegistered(e.tagName)){let i=e._vcomp;return i&&!i.isCustomElementFirst()||(i=e[E.VCOMP_INSTANCE])?E.getPropertyValue(i.props,t):e.getProperty(t)}return e[t]}static getPropertyValue(e,t){let i=e;const r=t.split(".");try{r.forEach(e=>i=i[e])}catch(e){return}return i}static allowSlotRelocation(e){E._ALLOW_RELOCATION_COUNT+=e?1:-1}static canRelocateNode(e,t){const i=E.getElementState(e);if(!i.getSlotMap()||E._ALLOW_RELOCATION_COUNT>0)return!0;const r=i.getSlotSet();if(i.isPostCreateCallbackOrComplete()&&r.has(t)){if(e.hasAttribute("data-oj-preact"))throw new l(e,t.localName+" cannot be relocated as a child of this element.");if("preact"===i.getBindingProviderType())return!1}return!0}static getClassSet(e){if(e){const t=e.split(/\s+/).filter(e=>e.length>0);if(t.length>0)return new Set(t)}return _}static convertEmptyStringToUndefined(e,t,i){if(""===i){if("preact"===E.getElementState(e).getBindingProviderType()){if(!o.getSupportedTypes(t.type).string||t.enumValues)return}}return i}}E._CUSTOM_ELEMENT_REGISTRY={},E._ELEMENT_STATE_KEY="_ojElementState",E._ELEMENT_BRIDGE_KEY="_ojBridge",E._ALLOW_RELOCATION_COUNT=0,E.VCOMP_INSTANCE=Symbol("vcompInstance");const C=Symbol("childBindingProvider"),b=Symbol("cachedBindingProvider");class v{constructor(e){this.dirtyProps=new Set,this._componentState=P.WaitingToCreate,this._outerClasses=new Set,this.Element=e}startCreationCycle(){this._isInErrorState()||(null!=this._preCreatedPromise&&this._componentState!==P.WaitingToCreate||this._updateComponentState(P.Creating),this._registerBusyState())}pauseCreationCycle(){this._resolveBusyState()}resetCreationCycle(){this._updateComponentState(P.WaitingToCreate),this._bindingProviderPromise=null,this._preCreatedPromise=null,this._createdPromise=null}isComplete(){return this._componentState===P.Complete}isCreating(){return this._componentState===P.Creating}isPostCreateCallbackOrComplete(){return this._componentState===P.PostCreateCallback||this.isComplete()}canHandleAttributes(){return!this._isInErrorState()&&this._componentState!==P.WaitingToCreate}beginApplyingBindings(){this.isComplete()||(this._bindingProviderType="knockout",this._updateComponentState(P.ApplyingBindings))}allowPropertySets(){return this._componentState===P.Creating||this._componentState===P.ApplyingBindings||this._componentState===P.BindingsApplied||this._componentState===P.PostCreateCallback||this._componentState===P.Complete}allowPropertyChangedEvents(){return this._componentState===P.BindingsApplied||this._componentState===P.PostCreateCallback||this._componentState===P.Complete}getTrackChildrenOption(){var e,t;const i=E.getElementDescriptor(this.Element.tagName).metadata;return null!==(t=null===(e=null==i?void 0:i.extension)||void 0===e?void 0:e._TRACK_CHILDREN)&&void 0!==t?t:"none"}setCreateCallback(e){this._isInErrorState()||(this._updateComponentState(P.WaitingForBindings),this._preCreatedPromise||(this._preCreatedPromise=this.GetPreCreatedPromise()),this._createdPromise=this._preCreatedPromise.then(()=>{if(!this._isInErrorState()){const t=e();return this._updateComponentState(P.PostCreateCallback),t}return Promise.reject()}),this._createdPromise.then(()=>{this._updateComponentState(P.Complete)},e=>{if(this._updateComponentState(P.Incomplete),e)throw e}))}setBindingsDisposedCallback(e){this._disposedCallback=e}resolveBindingProvider(e){this._bpClean=e.__CleanNode,this._resolveBindingProviderCallback&&(this._bindingsApplied(),this._resolveBindingProviderCallback(e),this._resolveBindingProviderCallback=null,this._rejectBindingProviderCallback=null),this._bindingProvider=e}rejectBindingProvider(e){this._rejectBindingProviderCallback&&(this._rejectBindingProviderCallback(e),this._resolveBindingProviderCallback=null,this._rejectBindingProviderCallback=null)}disposeBindingProvider(){var e;this.isComplete()?null===(e=this._disposedCallback)||void 0===e||e.call(this):(this.rejectBindingProvider(),this._updateComponentState(P.BindingsDisposed))}setBindingProviderCallback(e){this._bindingProviderCallback=e}getBindingProviderPromise(){const e=this.getBindingProviderType();if(!this._bindingProviderPromise)if(n.verifyThemeVersion(),"none"===e||"preact"===e)this._bindingsApplied(),this._bindingProviderPromise=Promise.resolve(null);else{if("knockout"!==e)throw new l(this.Element,`Unknown binding provider '${e}'.`);this._bindingProvider?(this._bindingsApplied(),this._bindingProviderPromise=Promise.resolve(this._bindingProvider)):this._bindingProviderPromise=new Promise((e,t)=>{this._resolveBindingProviderCallback=e,this._rejectBindingProviderCallback=t})}return this._bindingProviderPromise}getBindingProvider(){return this._bindingProvider}getBindingProviderType(){return this._bindingProviderType||(this._bindingProviderType=v._walkBindingProviders(this.Element)),this._bindingProviderType}getBindingProviderCleanNode(){return this._bpClean||v._NOOP}getDescriptiveText(){let e=this.GetDescriptiveValue("aria-label")||this.GetDescriptiveValue("title")||this.GetDescriptiveLabelByValue("labelled-by")||this.GetDescriptiveValue("label-hint")||this.GetDescriptiveLabelByValue("aria-labelledby");return e=e?e.trim().replace(/\s+/g," "):"",e}getSlotMap(e){return!this._slotMap&&e&&(this._slotMap=E.getSlotMap(this.Element)),this._slotMap}getSlotSet(){if(!this._slotSet){const e=Object.keys(this._slotMap);let t=[];e.forEach(e=>t=t.concat(this._slotMap[e])),this._slotSet=new Set(t)}return this._slotSet}setOuterClasses(e){this.PatchClasses(this._outerClasses,e),this._outerClasses=e}PatchClasses(e,t){e.forEach(e=>{t.has(e)||this.Element.classList.remove(e)}),t.forEach(t=>{e.has(t)||this.Element.classList.add(t)})}GetCreatedPromise(){return this._createdPromise}GetPreCreatedPromise(){let e=this.getBindingProviderPromise();return"none"!==this.getTrackChildrenOption()&&(e=e.then(e=>this._getTrackedChildrenPromises(e))),e}IsTransferAttribute(e){return!1}GetDescriptiveValue(e){const t=h.attributeToPropertyName(e),i=E.getElementProperties(this.Element);let r;return r=i&&i[t]?this.Element[t]:this.IsTransferAttribute(e)?this.GetDescriptiveTransferAttributeValue(e):this.Element.getAttribute(e),r}GetDescriptiveTransferAttributeValue(e){return""}GetDescriptiveLabelByValue(e){const t=this.GetDescriptiveValue(e);if(t){const e=document.getElementById(t);if(e)return e.textContent}return null}_updateComponentState(e){if(this._componentState!==P.BindingsDisposed){switch(e){case P.WaitingToCreate:this.Element.classList.remove("oj-complete"),this._createdPromise=null;break;case P.Complete:this.Element.classList.add("oj-complete"),this._resolveBusyState();break;case P.BindingsDisposed:case P.Incomplete:this.Element.classList.add("oj-incomplete"),this._resolveBusyState()}this._componentState=e}}_bindingsApplied(){var e;this._updateComponentState(P.BindingsApplied),null===(e=this._bindingProviderCallback)||void 0===e||e.call(this)}_registerBusyState(){const e=i.getContext(this.Element).getBusyContext();if(this._resolveCreatedBusyState)throw new l(this.Element,"Registering busy state before previous state is resolved.");this._resolveCreatedBusyState=e.addBusyState({description:E.getElementInfo(this.Element)+" is being upgraded."})}_resolveBusyState(){this._resolveCreatedBusyState&&(this._resolveCreatedBusyState(),this._resolveCreatedBusyState=null)}static _walkBindingProviders(e,t=e){var i;let r=e[b];if(r)return r;if(r=e.getAttribute("data-oj-binding-provider"),!r){const n=e.parentElement;if(null==n){if(e!==document.documentElement)throw new l(t,"Cannot determine binding provider for a disconnected subtree.");r="knockout"}else r=null!==(i=n[C])&&void 0!==i?i:v._walkBindingProviders(n,t)}return e[b]=r,r}_getTrackedChildrenPromises(e){const t=this.getTrackChildrenOption(),n=i.getContext(this.Element).getBusyContext(),s=this._getChildrenToTrack(this.Element,t,[]).map(t=>{if(!e){const e=n.addBusyState({description:`Waiting for element ${t.localName} to be defined.`}),i=setInterval(()=>{r.warn(`Waiting for element ${t.localName} to be defined.`)},2e4);return customElements.whenDefined(t.localName).then(()=>(e(),clearInterval(i),E.isElementRegistered(t.tagName)?E.getElementState(t).GetCreatedPromise():null)).catch(r=>{throw e(),clearInterval(i),new Error(`Error defining element ${t.localName} : ${r}`)})}return E.isElementRegistered(t.tagName)?E.getElementState(t).GetCreatedPromise():null});return Promise.all(s)}_getChildrenToTrack(e,t,i){const r=e.childNodes;for(let e=0;e<r.length;e++){const n=r[e];o.isValidCustomElementName(n.localName)?i.push(n):"nearestCustomElement"===t&&this._getChildrenToTrack(n,t,i)}return i}_isInErrorState(){return this._componentState===P.Incomplete||this._componentState===P.BindingsDisposed}}var P;v._NOOP=()=>{},function(e){e[e.WaitingToCreate=0]="WaitingToCreate",e[e.Creating=1]="Creating",e[e.WaitingForBindings=2]="WaitingForBindings",e[e.ApplyingBindings=3]="ApplyingBindings",e[e.BindingsApplied=4]="BindingsApplied",e[e.PostCreateCallback=5]="PostCreateCallback",e[e.Complete=6]="Complete",e[e.Incomplete=7]="Incomplete",e[e.BindingsDisposed=8]="BindingsDisposed"}(P||(P={})),e.AttributeUtils=h,e.CACHED_BINDING_PROVIDER=b,e.CHILD_BINDING_PROVIDER=C,e.CustomElementUtils=E,e.ElementState=v,e.ElementUtils=o,e.JetElementError=l,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojcustomelement-utils.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojmetadatautils',["exports","ojs/ojcore-base","ojs/ojcustomelement-utils"],function(e,t,r){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t;const o={getDefaultValue:function(e,r){let n=e.value;if(void 0===n){const t=e.properties;if(t){const r={},u=Object.keys(t);for(let e=0;e<u.length;e++){const n=o.getDefaultValue(t[u[e]]);void 0!==n&&(r[u[e]]=n)}Object.keys(r).length>0&&(e.value=r,n=r)}}return void 0!==n&&(Array.isArray(n)?n=r?o.deepFreeze(n):n.slice():null!==n&&"object"==typeof n&&(n=r?o.deepFreeze(n):t.CollectionUtils.copyInto({},n,void 0,!0))),n},getDefaultValues:function(e,t){const r={},n=Object.keys(e);let u=!1;return n.forEach(function(n){const l=o.getDefaultValue(e[n],t);void 0!==l&&(r[n]=l,u=!0)}),u?r:null},deepFreeze:function(e){if(Object.isFrozen(e))return e;if(Array.isArray(e))e=e.map(e=>o.deepFreeze(e)),Object.freeze(e);else if(null!==e&&"object"==typeof e){const t=Object.getPrototypeOf(e);null!==t&&t!==Object.prototype||(Object.keys(e).forEach(function(t){e[t]=o.deepFreeze(e[t])}),Object.freeze(e))}return e},getPropertyMetadata:function(e,t){let r=t;if(r&&e){const t=e.split(".");for(let e=0;e<t.length&&(r=r[t[e]],r&&1!==t.length&&e!==t.length-1&&r.properties);e++)r=r.properties}return r},checkEnumValues:function(e,t,r,o){if("string"==typeof r&&o){const e=o.enumValues;if(e&&-1===e.indexOf(r))throw new Error(`Invalid value '${r}' found for property '${t}'.Expected one of the following '${e.toString()}'.`)}},getFlattenedAttributes:function(e){const t=[];return o._getAttributesFromProperties("",e,t),t},_getAttributesFromProperties:function(e,t,n){if(t){Object.keys(t).forEach(u=>{const l=t[u],i=e+u;n.push(r.AttributeUtils.propertyNameToAttribute(i)),l.properties&&o._getAttributesFromProperties(i+".",l.properties,n)})}}},n=o.getDefaultValue,u=o.getDefaultValues,l=o.deepFreeze,i=o.getPropertyMetadata,s=o.checkEnumValues,c=o.getFlattenedAttributes;e.checkEnumValues=s,e.deepFreeze=l,e.getDefaultValue=n,e.getDefaultValues=u,e.getFlattenedAttributes=c,e.getPropertyMetadata=i,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojmetadatautils.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojdomutils',["exports","ojs/ojthemeutils","ojs/ojcore-base","jquery"],function(e,t,n,o){"use strict";n=n&&Object.prototype.hasOwnProperty.call(n,"default")?n.default:n,o=o&&Object.prototype.hasOwnProperty.call(o,"default")?o.default:o;const i={_HTML_START_TAG:"<html>",_HTML_END_TAG:"</html>",_LEGAL_ELEMENTS:{SPAN:1,B:1,I:1,EM:1,BR:1,HR:1,LI:1,OL:1,UL:1,P:1,TT:1,BIG:1,SMALL:1,PRE:1},_LEGAL_ATTRIBUTES:{class:1,style:1}};var r,a,s,l,c,u,f;i.isHTMLContent=function(e){return 0===e.indexOf(i._HTML_START_TAG)&&e.lastIndexOf(i._HTML_END_TAG)===e.length-7},i.cleanHtml=function(e){var t=o(document.createElement("span")).get(0);return t.innerHTML=e,e&&e.indexOf("<")>=0&&i._cleanElementHtml(t),t},i._cleanElementHtml=function(e){for(var t=e.childNodes,n=t.length-1;n>=0;n--){var r=t.item(n);if(r&&1===r.nodeType)if(i._LEGAL_ELEMENTS[r.nodeName]){for(var a=r.attributes,s=a.length-1;s>=0;s--){var l=a[s];void 0!==o(r).attr(l.name)&&(i._LEGAL_ATTRIBUTES[l.name]||r.removeAttribute(l.nodeName))}i._cleanElementHtml(r)}else r&&e.removeChild(r)}},i.isAncestor=function(e,t){for(var n=t.parentNode;n;){if(n===e)return!0;n=n.parentNode}return!1},i.isAncestorOrSelf=function(e,t){return t===e||i.isAncestor(e,t)},i.addResizeListener=function(e,t,n,o){let r=i._RSZ_TRKR;o&&(r=i._RSZ_TRKR_OBS,i._OBS_BASED.set(t,!0));let a=r.get(e);null==a&&(a=new i._ResizeTracker(e,o),r.set(e,a),a.start()),a.addListener(t,n)},i.removeResizeListener=function(e,t){const n=i._OBS_BASED.get(t)?i._RSZ_TRKR_OBS:i._RSZ_TRKR,o=n.get(e);null!=o&&(o.removeListener(t),o.isEmpty()&&(o.stop(),n.delete(e)))},i.fixResizeListeners=function(e){o(e).find(".oj-helper-detect-expansion").parent().each(function(e,t){var n=i._RSZ_TRKR.get(t);null!=n&&n.init(!0)})},i.isMetaKeyPressed=function(e){var t=n.AgentUtils.getAgentInfo();return n.AgentUtils.OS.MAC===t.os?e.metaKey:e.ctrlKey},i.dispatchEvent=function(e,t){var n="disabled",o=e[n];try{e[n]=!1,e.dispatchEvent(t)}finally{e[n]=o}},i._invokeAfterPaint=(window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||function(e){return window.setTimeout(e,0)}).bind(window),i._cancelInvokeAfterPaint=(window.cancelAnimationFrame||window.mozCancelAnimationFrame||window.webkitCancelAnimationFrame||function(e){return window.clearTimeout(e)}).bind(window),i._ResizeTracker=function(e,t){e instanceof o&&(e=e[0]);var n=e.hasAttribute("data-oj-resize-notify"),r=o.Callbacks(),a=[],s=[],l=0,c=null,u=null,f=null,d=null,g=null,h=null,v=null;function m(e){var t=!1;if(null!=d.offsetParent){var n=d.offsetWidth,o=d.offsetHeight;u===n&&f===o||(l=2,S(n,o),t=!0,e&&p(!0))}return t}function L(t){const n=t[0].borderBoxSize;p(!1,[n?(n[0]||n).inlineSize:e.offsetWidth,n?(n[0]||n).blockSize:e.offsetHeight])}function p(t,o){var s=o?o[0]:e.offsetWidth,l=o?o[1]:e.offsetHeight,u=(t,o)=>{r.fire(t,o),n&&e.dispatchEvent(new Event("oj-resize"))};r.has()&&(t?(null!==c&&i._cancelInvokeAfterPaint(c),c=i._invokeAfterPaint(function(){c=null,u(s,l)})):u(s,l));for(var f=0;f<a.length;f++)a[f].getCallback()(s,l)}function E(e){e.stopPropagation(),m(!0)||l>0&&null!=d.offsetParent&&(0===d.scrollLeft||0===d.scrollTop)&&(l-=1,S(u,f))}function S(e,t){u=e,f=t;var n=d.firstChild.style,o=1;do{n.width=e+o+"px",n.height=t+o+"px",d.scrollLeft=o,d.scrollTop=o,o+=1}while((0===d.scrollTop||0===d.scrollLeft)&&o<=5);g.scrollLeft=e,g.scrollTop=t}this.addListener=function(t,o){if(void 0===o||isNaN(o)||0===o)r.add(t);else{var l=()=>{t.apply(null,arguments),e.dispatchEvent(new Event("oj-resize"))};a.push(new i._collapsingListenerManager(n?l:t,o)),s.push(t)}},this.removeListener=function(e){var t=s.indexOf(e);t>=0?(s.splice(t,1),a.splice(t,1)[0].stop()):r.remove(e)},this.isEmpty=function(){return!r.has()&&0===s.length},this.start=function(){if(t&&window.ResizeObserver instanceof Function)(v=new ResizeObserver(L)).observe(e,{box:"border-box"});else{h=E;var n=e.childNodes[0];(d=document.createElement("div")).className="oj-helper-detect-expansion";var o=document.createElement("div");d.appendChild(o),null!=n?e.insertBefore(d,n):e.appendChild(d),d.addEventListener("scroll",h,!1),(g=document.createElement("div")).className="oj-helper-detect-contraction";var i=document.createElement("div");i.style.width="200%",i.style.height="200%",g.appendChild(i),e.insertBefore(g,d),g.addEventListener("scroll",h,!1),this.init(!1)}},this.stop=function(){null!=c&&(i._cancelInvokeAfterPaint(c),c=null),null!=v?(v.disconnect(),v=null):null!=d&&(d.removeEventListener("scroll",h),g.removeEventListener("scroll",h),d.parentNode&&e.removeChild(d),g.parentNode&&e.removeChild(g))},this.init=function(e){if(d){var t=m(e);e&&!t&&null!=d.offsetParent&&S(u,f)}}},i._RSZ_TRKR=new WeakMap,i._RSZ_TRKR_OBS=new WeakMap,i._OBS_BASED=new WeakMap,i.isValidIdentifier=function(e){return/^[A-Za-z][0-9A-Z_a-z-]*$/.test(e)},i._collapsingListenerManager=function(e,t){var n=null,o=null,i=function(){e.apply(null,n),o=null},r=function(){n=Array.prototype.slice.call(arguments),null==o&&(o=window.setTimeout(i,t))};this.getCallback=function(){return r},this.stop=function(){null!=o&&(window.clearTimeout(o),o=null)}},i.isTouchSupported=function(){return"ontouchstart"in window||navigator.msMaxTouchPoints>0||navigator.maxTouchPoints>0},i.setInKoCleanExternal=function(e){i._koCleanNode=e},i.unwrap=function(e,t){var n=i._koCleanNode;n&&e.get(0)===n||(t?t.replaceWith(e):e.unwrap())},i.isChromeEvent=function(e){if(!("clientX"in e)||!("clientY"in e))return!1;var t=n.AgentUtils.getAgentInfo();if(n.AgentUtils.OS.ANDROID===t.os||n.AgentUtils.OS.IOS===t.os)return!1;if(t.engine!==n.AgentUtils.ENGINE.GECKO&&t.engine!==n.AgentUtils.ENGINE.WEBKIT&&t.engine!==n.AgentUtils.ENGINE.BLINK&&t.browser!==n.AgentUtils.BROWSER.IE)return!1;var r="ltr"===i.getReadingDirection(),a=!r&&t.browser===n.AgentUtils.BROWSER.SAFARI,s=e.target,l=o(s),c=s.getBoundingClientRect(),u=i.getScrollBarWidth();return!(!r||"HTML"!==s.nodeName&&"visible"===l.css("overflow-x")||!(e.clientX>c.right-u))||(!r&&!a&&"HTML"===s.nodeName&&e.clientX>c.right-u||(!r&&"visible"!==l.css("overflow-x")&&e.clientX<c.left+u||("HTML"===s.nodeName||"visible"!==l.css("overflow-y"))&&e.clientY>c.bottom-u))},i.getScrollBarWidth=function(){return o.position.scrollbarWidth()},i.getReadingDirection=function(){var e=document.documentElement.getAttribute("dir");return e&&(e=e.toLowerCase()),"rtl"===e?"rtl":"ltr"},i.setScrollLeft=function(e,t){e.scrollLeft=i.calculateScrollLeft(t)},i.calculateScrollLeft=function(e){var t=e;if("rtl"===i.getReadingDirection()){var o=n.AgentUtils.getAgentInfo().browser;o!==n.AgentUtils.BROWSER.IE&&o!==n.AgentUtils.BROWSER.EDGE&&(t=-e)}return t},i.getCSSLengthAsInt=function(e){if(!isNaN(e))return parseInt(e,10);if(e&&e.length>0&&"auto"!==e){var t=parseInt(e,10);return isNaN(t)&&(t=0),t}return 0},i.getCSSLengthAsFloat=function(e){if(!isNaN(e))return parseFloat(e);if(e&&e.length>0){var t=parseFloat(e);return isNaN(t)&&(t=0),t}return 0},i.getCSSTimeUnitAsMillis=function(e){if(!isNaN(e))return parseInt(e,10);if(e&&e.length>0){var t=parseFloat(e);if(isNaN(t))t=0;else{var n,o=e+"";o.length>2&&o.endsWith("ms")?n=o.slice(-3,-2):o.length>1&&o.endsWith("s")&&(n=o.slice(-2,-1)),isNaN(n)?t=0:!o.endsWith("ms")&&o.endsWith("s")&&(t*=1e3)}return t}return 0},i._LOGICAL_PARENT_DATA="oj-logical-parent",i.getLogicalParent=function(e){if(e)return e.data(i._LOGICAL_PARENT_DATA)},i.setLogicalParent=function(e,t){e&&(null===t?e.removeData(i._LOGICAL_PARENT_DATA):e.data(i._LOGICAL_PARENT_DATA,t))},i.isLogicalAncestorOrSelf=function(e,t){n.Assert.assertDomElement(e),n.Assert.assertDomElement(t);for(var r=t;r;){if(r===e)return!0;var a=i.getLogicalParent(o(r));r=a?a[0]:r.parentNode}return!1},i.validateURL=function(e,t){var n=t||["http:","https:"],o=document.createElement("a");o.href=e;var i=o.protocol;if(null!=i&&(i=i.toLowerCase()),n.indexOf(i)<0&&""!==i)throw new Error(i+" is not a valid URL protocol")},i._suppressNativeContextMenu=function(){o(document.body).hasClass("oj-hybrid")&&!o(document.body).hasClass("oj-hybrid-show-context-menu")&&document.body.addEventListener("contextmenu",function(e){"INPUT"!==e.target.nodeName&&"TEXTAREA"!==e.target.nodeName&&e.preventDefault()},!0)},i._suppressNativeContextMenu(),i.PRESS_HOLD_THRESHOLD=750,i.recentTouchEnd=function(){var e=0;function t(){e=Date.now()}return document.addEventListener("touchend",t,!0),document.addEventListener("touchcancel",t,!0),function(){return Date.now()-e<500}}(),i.recentTouchStart=(r=0,a=i.PRESS_HOLD_THRESHOLD+50,document.addEventListener("touchstart",function(){r=Date.now()},{passive:!0,capture:!0}),function(){return Date.now()-r<a}),i.recentPointer=(l=0,c=i.PRESS_HOLD_THRESHOLD+600,document.addEventListener("mousedown",function(){var e=Date.now();(!s||e>l+i.PRESS_HOLD_THRESHOLD)&&(l=e,s=!1)},!0),document.addEventListener("touchstart",function(){l=Date.now(),s=!0},{passive:!0,capture:!0}),document.addEventListener("mouseup",function(){l=Date.now(),s=!1},!0),document.addEventListener("touchend",function(){l=Date.now(),s=!1},!0),function(){return Date.now()-l<(s?c:600)}),i.makeFocusable=(u=0,f=(t.parseJSONFromFontFamily("oj-focus-config")||{}).focusHighlightPolicy,function(e){var t=e.element,n="ojFocusable";if(e.remove){t.removeClass("oj-focus oj-focus-highlight");var r=t.data(n);if(null==r)return;var a=".ojFocusable"+(""+r).split(",").join(" .ojFocusable");t.off(a).removeData(n)}else{var s=e.afterToggle||o.noop,l=e.applyHighlight?function(t){t.addClass("oj-focus"),function(e,t){switch(e?e():f){case"all":return!0;case"none":return!1;default:return!(i.recentPointer()||t&&t())}}(e.getFocusHighlightPolicy,e.recentPointer)&&t.addClass("oj-focus-highlight"),s("focusin")}:function(e){e.addClass("oj-focus"),s("focusin")},c=!1;(e.setupHandlers||function(i,r){var a=e.component,s=function(e){i(o(e.currentTarget)),c=!0},l=function(e){c&&(r(o(e.currentTarget)),c=!1)};if(a)a._on(t,{focusin:s,focusout:l});else{var f=u;u+=1;var d=t.data(n);t.data(n,null==d?f:d+","+f);var g={},h=".ojFocusable"+f;g["focusin"+h]=s,g["focusout"+h]=l,t.on(g)}})(l,function(e){e.removeClass("oj-focus oj-focus-highlight"),s("focusout")})}}),i.getNoJQFocusHandlers=function(e,t){return{focusIn:function(t){return e(o(t))},focusOut:function(e){return t(o(e))}}};const d=i.isHTMLContent,g=i.cleanHtml,h=i.isAncestor,v=i.isAncestorOrSelf,m=i.addResizeListener,L=i.removeResizeListener,p=i.fixResizeListeners,E=i.isMetaKeyPressed,S=i.dispatchEvent,A=i.isValidIdentifier,_=i.isTouchSupported,T=i.setInKoCleanExternal,R=i.unwrap,w=i.isChromeEvent,N=i.getScrollBarWidth,O=i.getReadingDirection,C=i.setScrollLeft,H=i.calculateScrollLeft,P=i.getCSSLengthAsInt,b=i.getCSSLengthAsFloat,D=i.getCSSTimeUnitAsMillis,I=i.getLogicalParent,y=i.setLogicalParent,M=i.isLogicalAncestorOrSelf,j=i.validateURL,B=i.PRESS_HOLD_THRESHOLD,F=i.recentTouchEnd,x=i.recentTouchStart,U=i.recentPointer,z=i.getNoJQFocusHandlers,k=i.makeFocusable;e.PRESS_HOLD_THRESHOLD=B,e.addResizeListener=m,e.calculateScrollLeft=H,e.cleanHtml=g,e.dispatchEvent=S,e.fixResizeListeners=p,e.getCSSLengthAsFloat=b,e.getCSSLengthAsInt=P,e.getCSSTimeUnitAsMillis=D,e.getLogicalParent=I,e.getNoJQFocusHandlers=z,e.getReadingDirection=O,e.getScrollBarWidth=N,e.isAncestor=h,e.isAncestorOrSelf=v,e.isChromeEvent=w,e.isHTMLContent=d,e.isLogicalAncestorOrSelf=M,e.isMetaKeyPressed=E,e.isTouchSupported=_,e.isValidIdentifier=A,e.makeFocusable=k,e.recentPointer=U,e.recentTouchEnd=F,e.recentTouchStart=x,e.removeResizeListener=L,e.setInKoCleanExternal=T,e.setLogicalParent=y,e.setScrollLeft=C,e.unwrap=R,e.validateURL=j,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojdomutils.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojtrace-event',["exports"],function(e){"use strict";function t(e){var t;let n=e.type;const a=null===(t=e.detail)||void 0===t?void 0:t.value;if(null!=a)switch(n){case"validChanged":n=`${n}=${a}`;break;case"expandedChanged":"boolean"==typeof a&&(n=`${n}=${a}`)}return n}e.traceDispatchEvent=function(e){return function(n){const a=this,r=function(){var e;const t=window.GlobalTracer;return null===(e=null==t?void 0:t.get)||void 0===e?void 0:e.call(t)}();if("undefined"!=typeof window&&window.__JET_TRACER_ENABLED__&&r&&function(e){const t=null==e?void 0:e.type;if(!t||t.startsWith("ojBefore"))return!1;switch(t){case"attribute-changed":case"ojAnimateStart":case"ojAnimateEnd":case"ojTransitionStart":case"ojTransitionEnd":case"labelledByChanged":case"beforeDestroyChanged":return!1}return!0}(n)){const o={operationName:"componentEvent",trigger:{type:t(n),target:a}};return r.span(o,t=>{let r;try{return e.call(a,n)}catch(e){r=e}finally{const e={};r&&(e.error=r),t.finish(e)}})}return e.call(a,n)}},Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojtrace-event.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojbootstrap',["exports"],function(e){"use strict";var n;const t={whenDocumentReady:function(){return n||(n="loading"===document.readyState?new Promise(function(e){var n=function(){document.removeEventListener("DOMContentLoaded",n),e()};document.addEventListener("DOMContentLoaded",n)}):Promise.resolve()),n}}.whenDocumentReady;e.whenDocumentReady=t,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojbootstrap.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojcustomelement',["ojs/ojcore","ojs/ojlogger","ojs/ojcustomelement-utils","ojs/ojtrace-event","ojs/ojmetadatautils","ojs/ojbootstrap","ojs/ojcore-base"],function(e,t,r,n,i,o,s){"use strict";e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e,s=s&&Object.prototype.hasOwnProperty.call(s,"default")?s.default:s;const a={};a.proto={getClass:function(e){var t=Object.create(HTMLElement.prototype);this.InitializePrototype(t),t.dispatchEvent=n.traceDispatchEvent(HTMLElement.prototype.dispatchEvent);var i=this.GetMetadata(e);a._enumerateMetadataForKey(t,i,"properties",this.DefinePropertyCallback.bind(this)),a._enumerateMetadataForKey(t,i,"methods",this.DefineMethodCallback.bind(this)),this.AddComponentMethods(t),t.setProperties=function(e){r.CustomElementUtils.getElementBridge(this)._setProperties(this,e)},Object.defineProperty(t,"set",{value:function(e,t){this.setProperty(e,t)}}),Object.defineProperty(t,"unset",{value:function(e){this.setProperty(e,void 0)}}),t.attributeChangedCallback=this.AttributeChangedCallback,t.connectedCallback=this._connectedCallback,t.disconnectedCallback=this._detachedCallback;const o=t.appendChild;t.appendChild=function(e){return r.CustomElementUtils.canRelocateNode(this,e)?o.call(this,e):e};const s=t.insertBefore;t.insertBefore=function(e,t){return r.CustomElementUtils.canRelocateNode(this,e)?s.call(this,e,t):e},t.setAttribute=function(e,t){if("class"===e){const e=r.CustomElementUtils.getClassSet(t);r.CustomElementUtils.getElementState(this).setOuterClasses(e)}else HTMLElement.prototype.setAttribute.call(this,e,t)},t.removeAttribute=function(e){"class"===e?this.setAttribute("class",""):HTMLElement.prototype.removeAttribute.call(this,e)};var l=function(){var e=window.Reflect;return void 0!==e?e.construct(HTMLElement,[],this.constructor):HTMLElement.call(this)},u=this;return Object.defineProperty(l,"observedAttributes",{get:function(){return u.GetAttributes(i)}}),Object.defineProperty(t,"constructor",{value:l,writable:!0,configurable:!0}),l.prototype=t,Object.setPrototypeOf(l,HTMLElement),l},initializeBridge:function(e,t){this.METADATA=this.GetMetadata(t),this._eventListeners={},this.State=r.CustomElementUtils.getElementState(e)},AddComponentMethods:function(e){},AttributeChangedCallback:function(e,n,o){const s=r.AttributeUtils.attributeToPropertyName(e),l=r.CustomElementUtils.getElementBridge(this);if(n!==o||l.State.dirtyProps.has(s)){if(l.State.dirtyProps.delete(s.split(".")[0]),"disabled"===e&&l.ShouldRemoveDisabled()&&l._isDisabledAttributeRemoved())return void(null!=o&&(t.warn("Ignoring 'disabled' attribute change after component initialization. Use element property setter instead."),l._removeDisabledAttribute(this)));if(l.ShouldHandleAttributeChanged(this)){a.__CheckOverlappingAttribute(this,e),null===o&&(o=void 0);var u={detail:{attribute:e,value:o,previousValue:n}};if(this.dispatchEvent(new CustomEvent("attribute-changed",u)),!r.AttributeUtils.getExpressionInfo(o).expr){const t=i.getPropertyMetadata(s,r.CustomElementUtils.getElementProperties(this));t&&this.setProperty(s,a.__ParseAttrValue(this,e,s,o,t)),l.HandleAttributeChanged(this,e,n,o)}}}},CreateComponent:function(e){},DefineMethodCallback:function(e,t,r){},DefinePropertyCallback:function(e,t,r){},GetAttributes:function(e){return e?i.getFlattenedAttributes(e.properties):[]},GetMetadata:function(e){return e[a.DESC_KEY_META]||{}},GetAliasForProperty:function(e){return e},ShouldHandleAttributeChanged:function(e){return this.State.canHandleAttributes()},ShouldCallHandleAttributeChanged:function(e){return this.ShouldHandleAttributeChanged()},HandleAttributeChanged:function(e,t,r,n){},HandleBindingsApplied:function(e,t){},HandleDetached:function(e){},HandleReattached:function(e){},InitializeElement:function(e){},InitializePrototype:function(e){},BatchedPropertySet:function(e,t){for(var r=Object.keys(t),n=0;n<r.length;n++){var i=r[n];e.setProperty(i,t[i])}},GetEventListenerProperty:function(e){var t=r.AttributeUtils.eventListenerPropertyToEventType(e),n=this._eventListeners[t];if(n)return n.getListener()},GetProperty:function(e,t,n){var o=i.getPropertyMetadata(t,r.CustomElementUtils.getElementProperties(e));return r.AttributeUtils.isEventListenerProperty(t)||!o||-1===t.indexOf(".")?n[t]:r.CustomElementUtils.getPropertyValue(n,t)},HandlePropertyChanged:function(e,t,r,n,i,o){var s=i?"external":"internal";a.__FirePropertyChangeEvent(e,t,r,n,s,o)},PlaybackEarlyPropertySets:function(e){if(this._earlySets)for(;this._earlySets.length;){var t=this._earlySets.shift();e.setProperty(t.property,t.value)}},SaveEarlyPropertySet:function(e,t,r){return!this.State.allowPropertySets()&&(this._earlySets||(this._earlySets=[]),this._earlySets.push({property:t,value:r}),!0)},SetEventListenerProperty:function(e,t,n){var i=r.AttributeUtils.eventListenerPropertyToEventType(t),o=this._eventListeners[i];o||(o=this._createEventListenerWrapper(),this._eventListeners[i]=o,e.addEventListener(i,o)),null==n||n instanceof Function?o.setListener(n):a.__ThrowTypeError(e,t,n,"function")},SetProperty:function(t,n,o,s,l){var u=i.getPropertyMetadata(n,r.CustomElementUtils.getElementProperties(t));if(r.AttributeUtils.isEventListenerProperty(n)||!u)t[n]=o;else{var p=t.getProperty(n),c=n.split(".")[0],d=s[c];if(e.CollectionUtils.isPlainObject(d)&&(d=e.CollectionUtils.copyInto({},d,void 0,!0)),!r.ElementUtils.comparePropertyValues(u,o,p)){var h=-1!==n.indexOf(".");if(h&&(this._SKIP_PROP_CHANGE_EVENT=!0),l?this.ValidateAndSetProperty(this.GetAliasForProperty.bind(this),s,n,o,t):a.__SetProperty(this.GetAliasForProperty.bind(this),s,n,o),this._SKIP_PROP_CHANGE_EVENT=!1,h){var y={path:n,value:o,previousValue:p};this.HandlePropertyChanged(t,c,s[c],d,l,y)}return this.State.dirtyProps.add(c),{property:c,propertySet:!0,isSubproperty:h}}}return{property:null,propertySet:!1,isSubproperty:!1}},ShouldRemoveDisabled:function(){return!0},ValidateAndSetProperty:function(e,t,r,n,i){var o=this.ValidatePropertySet(i,r,n);a.__SetProperty(e,t,r,o)},ValidatePropertySet:function(e,n,o){var s=r.CustomElementUtils.getElementProperties(e),l=i.getPropertyMetadata(n,s),u=n.split(".");if(l){if(s[u[0]].readOnly)throw new r.JetElementError(e,`Read-only property '${n}' cannot be set.`);try{i.checkEnumValues(e,n,o,l)}catch(t){throw new r.JetElementError(e,t.message)}return null!=o?a.checkType(e,n,o,l):o}t.warn(r.CustomElementUtils.getElementInfo(e)+": Ignoring property set for undefined property '"+n+"'.")},PostCreate:function(e){e.hasAttribute("disabled")&&this.ShouldRemoveDisabled()&&!this._isDisabledAttributeRemoved()&&this._removeDisabledAttribute(e)},_connected:function(e){const t=this.State;if(t.isComplete())this.HandleReattached(e);else if(t.startCreationCycle(),t.isCreating()){this.InitializeElement(e),t.setBindingProviderCallback(this.PlaybackEarlyPropertySets.bind(this,e));const r=()=>{try{t.getSlotMap(!0);return(this.CreateComponent(e)||Promise.resolve()).then(this.PostCreate.bind(this,e))}catch(e){return Promise.reject(e)}};t.setCreateCallback(r)}},_connectedCallback:function(){r.CustomElementUtils.getElementBridge(this)._connected(this)},_detachedCallback:function(){const e=r.CustomElementUtils.getElementBridge(this),t=e.State;t.isComplete()?e.HandleDetached(this):t.pauseCreationCycle()},_createEventListenerWrapper:function(){var e,t=function(t){e&&e(t)};return t.setListener=function(t){e=t},t.getListener=function(){return e},t},_setProperties:function(e,t){for(var r=[],n={},i=!1,o=Object.keys(t),s=0;s<o.length;s++){var a=o[s];a.indexOf(".")>=0?r.push(a):(n[a]=t[a],i=!0)}i&&this.BatchedPropertySet(e,n);for(var l=0;l<r.length;l++){var u=r[l];e.setProperty(u,t[u])}},_isDisabledAttributeRemoved:function(){return!0===this._disabledProcessed},_removeDisabledAttribute:function(e){this._disabledProcessed=!0,e.removeAttribute("disabled")}},a._enumerateMetadataForKey=function(e,t,r,n){if(t&&t[r]){var i=t[r];Object.keys(i).forEach(function(t){n(e,t,i[t])})}},a.checkType=function(e,t,n,i){const o=i.type,s=r.ElementUtils.getSupportedTypes(o);if(1===s.typeCount&&!s.any&&!s.other){const r=typeof n;if(s.array&&!Array.isArray(n)||s.object&&"object"!==r||s.string&&"string"!==r||s.number&&("number"!==r||!isFinite(n)))a.__ThrowTypeError(e,t,n,o);else if(s.boolean)return!!n}return n},a.__ThrowTypeError=function(e,t,n,i){throw new r.JetElementError(e,`Invalid type '${typeof n}' found for property '${t}'. Expected value of type '${i}'.`)},a.__CheckOverlappingAttribute=function(e,t){var n=t.split(".");if(n.length>1)for(n.pop();n.length;){var i=n.join(".");if(e.hasAttribute(i))throw new r.JetElementError(e,`Cannot set overlapping attributes '${t}' and '${i}'.`);n.pop()}},a.__InitProperties=function(e,t){const n=r.CustomElementUtils.getElementBridge(e);var o=r.CustomElementUtils.getElementProperties(e);if(o)for(var s=e.attributes,l=0;l<s.length;l++){var u=s[l],p=r.AttributeUtils.attributeToPropertyName(u.nodeName),c=i.getPropertyMetadata(p,o);if(c&&!c.readOnly)if(a.__CheckOverlappingAttribute(e,u.nodeName),!r.AttributeUtils.getExpressionInfo(u.value).expr){var d=a.__ParseAttrValue(e,u.nodeName,p,u.value,c);n.ValidateAndSetProperty(n.GetAliasForProperty.bind(n),t,p,d,e)}}},a.__SetProperty=function(e,t,r,n){var i,o=t,s=r.split("."),a=e(s[0]);s.length>1&&!t[a]&&(o=i={});for(var l=0;l<s.length;l++){var u=e(s[l]);l===s.length-1?o[u]=n:o[u]||(o[u]={}),o=o[u]}i&&(t[a]=i[a])},a.__ParseAttrValue=function(e,t,n,i,o){if(null==i)return i;function s(n){return r.AttributeUtils.attributeToPropertyValue(e,t,n,o)}var a=r.CustomElementUtils.getElementDescriptor(e.tagName).parseFunction;return a?a(i,n,o,function(e){return s(e)}):s(i)},a.__ProcessEventListeners=function(t){var n=e.CollectionUtils.copyInto({},t,void 0,!0,1);return n.properties=n.properties||{},a._enumerateMetadataForKey(null,n,"properties",function(e,t){var i=r.AttributeUtils.propertyNameToChangeEventType(t),o=r.AttributeUtils.eventTypeToEventListenerProperty(i);n.properties[o]={_derived:!0,_eventListener:!0}}),a._enumerateMetadataForKey(null,n,"events",function(e,t){var i=r.AttributeUtils.eventTypeToEventListenerProperty(t);n.properties[i]={_derived:!0,_eventListener:!0}}),n},a.__FirePropertyChangeEvent=function(e,t,n,i,o,s){var a=r.CustomElementUtils.getElementBridge(e);if(!a._SKIP_PROP_CHANGE_EVENT){var l={};s&&(l.subproperty=s),l.value=n,l.previousValue=i,l.updatedFrom=o,a.beforePropertyChangedEvent&&a.beforePropertyChangedEvent(e,t,l),("external"!==o||a.State.isComplete())&&e.dispatchEvent(new CustomEvent(t+"Changed",{detail:l}))}},a.__DefineDynamicObjectProperty=function(e,t,r,n){Object.defineProperty(e,t,{enumerable:!0,get:r,set:n})},a.DESC_KEY_META="metadata",e._registerLegacyNamespaceProp("BaseCustomElementBridge",a),o.whenDocumentReady().then(function(){!function(){var e=document.createElement("div");e.style.border="1px solid",e.style.borderColor="red green",e.style.position="absolute",e.style.top="-999px",e.style.backgroundImage="url(data:image/gif;base64,R0lGODlhAQABAIAAAP///wAAACwAAAAAAQABAAACAkQBADs=)";var t=document.body;t.appendChild(e);var r=window.getComputedStyle(e),n=r.backgroundImage;r.borderTopColor!==r.borderRightColor&&(null==n||"none"!==n&&"url (invalid-url:)"!==n)||t.classList.add("oj-hicontrast"),t.removeChild(e)}()}),o.whenDocumentReady().then(function(){!function(){let e=[];const t=s.AgentUtils.getAgentInfo();e.push("oj-agent-os-"+t.os.toLowerCase()),e.push("oj-agent-browser-"+t.browser.toLowerCase()),document.documentElement.classList.add(...e)}()})});
//# sourceMappingURL=ojcustomelement.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojdefaultsutils',["exports","ojs/ojmetadatautils"],function(e,t){"use strict";function n(e,t,n){let l=e._defaults;if(void 0===l){const s=i(e,t,n);l=Object.create(s),a(e,l),e._defaults=l}return l}function i(e,n,i){var a;let l=e._staticDefaults;if(void 0===l){if(l=null,n){const e=n.properties,s=null===(a=n.extension)||void 0===a?void 0:a._DEFAULTS;if(s){const e=new s;l=Object.create(e)}else e&&(l=Object.create(t.getDefaultValues(e,i)))}e._staticDefaults=l}return l}function a(e,t){if(e.getDynamicDefaults){const n=e.getDynamicDefaults();if(n)for(let e in n)void 0===t[e]&&(t[e]=n[e])}}var l=Object.freeze({__proto__:null,getFrozenDefault:function(e,i,a){const l=n(i,a,!0);return t.deepFreeze(l[e])},getDefaults:n,getStaticDefaults:i,applyDynamicDefaults:a});e.DefaultsUtils=l,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojdefaultsutils.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojfocusutils',["jquery","ojs/ojcore-base","ojs/ojdomutils"],function(t,e,n){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e;const r={_TABBABLE:":tabbable,iframe",containsFocus:function(t){var e=document.activeElement;return!(!t||!e)&&n.isAncestorOrSelf(t,e)},focusElement:function(t){t.focus()},focusFirstTabStop:function(t){var e=r.getFirstTabStop(t);return e&&r.focusElement(e),e},isFirstActiveElement:function(e){var n=t(e).find(r._TABBABLE);if(null==n||0===n.length)return!1;var i=n[0];return document.activeElement===i||i.name===document.activeElement.name&&"radio"===i.type&&"radio"===document.activeElement.type},isLastActiveElement:function(e){var n=t(e).find(r._TABBABLE);if(null==n||0===n.length)return!1;var i=n[n.length-1];return document.activeElement===i||i.name===document.activeElement.name&&"radio"===i.type&&"radio"===document.activeElement.type},getFirstTabStop:function(e){var n=t(e);if(n.is(r._TABBABLE))return e;var i=n.find(r._TABBABLE);if(i&&i.length>0){if(i[0].classList.contains("oj-radio")){var o=i.filter(".oj-selected.oj-radio");return o&&o.length?o[0]:i[0]}return i[0]}return null},getLastTabStop:function(e){var n=t(e).find(r._TABBABLE);if(n&&n.length>0){if(n[n.length-1].classList.contains("oj-radio")){var i=n.filter(".oj-selected.oj-radio");return i&&i.length?i[i.length-1]:n[n.length-1]}return n[n.length-1]}return null},isFocusable:function(n){return!!t(n).is(":focusable")&&!("A"===n.nodeName&&!n.hasAttribute("tabindex")&&e.AgentUtils.getAgentInfo().browser===e.AgentUtils.BROWSER.SAFARI)}};return r});
//# sourceMappingURL=ojfocusutils.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojgestureutils',["exports","jquery","ojs/ojdomutils"],function(e,t,n){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t;const o={_EVENT_NAMESPACE:".contextMenu",stopDetectContextMenuGesture:function(e){e._clickListener&&(t(e).off(o._EVENT_NAMESPACE).removeClass("oj-menu-context-menu-launcher")[0].removeEventListener("click",e._clickListener,!0),clearTimeout(e._contextMenuPressHoldTimer),delete e._clickListener,delete e._contextMenuPressHoldTimer),e._touchStartAndMouseDownListener&&(e.removeEventListener("touchstart",e._touchStartAndMouseDownListener,{passive:!1}),delete e._touchStartAndMouseDownListener),e._touchMoveListener&&(e.removeEventListener("touchmove",e._touchMoveListener,{passive:!0}),delete e._touchMoveListener)},startDetectContextMenuGesture:function(e,u){var r,s,c,i,a=n.PRESS_HOLD_THRESHOLD,d=!1,l=!1,v=null,p=o._EVENT_NAMESPACE,h=!1;function m(n,o,r){if((d=r)&&t(e).one("touchend"+p,function(){h=!0,setTimeout(function(){h=!1},50)}),"touchstart"===v&&"contextmenu"===n.type||"contextmenu"===v&&"touchstart"===n.type||"keydown"===v&&"contextmenu"===n.type)return"keydown"===v&&"contextmenu"===n.type&&n.preventDefault(),v=null,void clearTimeout(i);n.isDefaultPrevented&&n.isDefaultPrevented()||n.originalEvent&&n.originalEvent.defaultPrevented||n.defaultPrevented||("touchstart"!==n.type&&"touchmove"!==n.type||(n.originalEvent=n),u(n,o),(n.isDefaultPrevented&&n.isDefaultPrevented()||n.defaultPrevented)&&("touchstart"!==n.type&&"contextmenu"!==n.type&&"keydown"!==n.type||(v=n.type,i=setTimeout(function(){v=null},300))))}var f=function(e){d&&(e.preventDefault(),e.stopPropagation(),d=!1)};e._clickListener=f,e.addEventListener("click",f,!0);var y=function(t){if("mousedown"!==t.type||!h){if(d=!1,"touchstart"===t.type&&1===t.touches.length){var n=t.touches[0];s=n.pageX,c=n.pageY,l=!0,r=setTimeout(m.bind(void 0,t,"touch",!0),a),e._contextMenuPressHoldTimer=r}return!0}};e._touchStartAndMouseDownListener=y,e.addEventListener("touchstart",y,{passive:!1});var _=function(e){var t=e.touches[0];return(Math.abs(s-t.pageX)>5||Math.abs(c-t.pageY)>5)&&(l=!1,clearTimeout(r)),!0};e._touchMoveListener=_,e.addEventListener("touchmove",_,{passive:!0}),t(e).on("mousedown"+p,y).on("touchend"+p+" touchcancel"+p,function(){return l=!1,clearTimeout(r),!0}).on("keydown"+p+" contextmenu"+p,function(e){("contextmenu"===e.type||121===e.keyCode&&e.shiftKey)&&m(e,l?"touch":"keydown"===e.type?"keyboard":"mouse",!1);return!0}),n.isTouchSupported()&&t(e).addClass("oj-menu-context-menu-launcher")}},u=o.startDetectContextMenuGesture,r=o.stopDetectContextMenuGesture;e.startDetectContextMenuGesture=u,e.stopDetectContextMenuGesture=r,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojgestureutils.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojcomponentcore',["exports","jqueryui-amd/widget","jqueryui-amd/unique-id","jqueryui-amd/keycode","jqueryui-amd/focusable","jqueryui-amd/tabbable","ojs/ojcore","jquery","ojs/ojmessaging","ojs/ojmetadatautils","ojs/ojcore-base","ojs/ojdomutils","ojs/ojcustomelement","ojs/ojcustomelement-utils","ojs/ojlogger","ojs/ojdefaultsutils","ojs/ojtranslation","ojs/ojfocusutils","ojs/ojgestureutils"],function(t,e,n,i,o,s,r,a,l,u,c,_,h,p,d,E,f,g,m){"use strict";r=r&&Object.prototype.hasOwnProperty.call(r,"default")?r.default:r,a=a&&Object.prototype.hasOwnProperty.call(a,"default")?a.default:a,l=l&&Object.prototype.hasOwnProperty.call(l,"default")?l.default:l,c=c&&Object.prototype.hasOwnProperty.call(c,"default")?c.default:c;
/**
   * @preserve Copyright 2013 jQuery Foundation and other contributors
   * Released under the MIT license.
   * http://jquery.org/license
   */
const v=function(t){this.Init(t)};r.Object.createSubclass(v,r.Object,"oj.ComponentMessaging"),r._registerLegacyNamespaceProp("ComponentMessaging",v),v._STRATEGY_TYPE={NONE:"none",NOTEWINDOW:"notewindow",PLACEHOLDER:"placeholder",INLINE:"inline",LABEL_EDGE_INSIDE:"inside",LABEL_EDGE_INSIDE_FORM_CNTRL:"insideformcontrol",USER_ASSISTANCE_INLINE:"userassistanceinline"},v._STRATEGY_TYPE_TO_CALLBACK={};const y="aria-describedby";v.registerMessagingStrategy=function(t,e){t&&"function"==typeof e&&(v._STRATEGY_TYPE_TO_CALLBACK[t]=e)},v.prototype.Init=function(t){v.superclass.Init.call(this),this._component=t,this._activated=!1,this._initializeMessagingStrategies()},v.prototype.activate=function(t,e,n){var i=this;r.Assert.assertObject(n),this._launcher=t,this._contentElement=e,this._messagingContent=r.CollectionUtils.copyInto(this._messagingContent||{},n),this._isActive()?this._reactivate():(a.each(this._strategies,function(t,e){e.activate(i)}),this._activated=!0)},v.prototype.update=function(t){r.Assert.assertObject(t),r.Assert.assertBoolean(this._activated),this._messagingContent=r.CollectionUtils.copyInto(this._messagingContent||{},t),this._activated&&a.each(this._strategies,function(e,n){n.shouldUpdate(t)&&n.update()})},v.prototype.deactivate=function(){a.each(this._strategies,function(t,e){e.deactivate()}),this._activated=!1,this._component=null,this._launcher=null,this._contentElement=null,this._strategies={}},v.prototype.close=function(){this._activated&&a.each(this._strategies,function(t,e){e.close()})},v.prototype._createMessagingStrategy=function(t,e){return new(v._STRATEGY_TYPE_TO_CALLBACK[t]||v._STRATEGY_TYPE_TO_CALLBACK[v._STRATEGY_TYPE.NONE])(e)},v.prototype._getComponent=function(){return this._component||null},v.prototype._getLauncher=function(){return this._launcher||null},v.prototype._getContentElement=function(){return this._contentElement||null},v.prototype._getMessagingContent=function(){return this._messagingContent||{}},v.prototype._setMessagingContent=function(t){r.Assert.assertObject(t),this._messagingContent=r.CollectionUtils.copyInto(this._messagingContent||{},t)},v.prototype._isActive=function(){return this._activated},v.prototype._getResolvedMessagingDisplayOptions=function(t){for(var e={},n=!1,i=this._component.options,o={},s=Object.keys(t),r=0;r<s.length;r++){var l=s[r],u=t[l];n=!1;var c=l+"";if(Array.isArray(u))for(var _=0;_<u.length;_++){var h=u[_];n||(n=this._resolveStrategyTypeForArtifact(c,h,i,o))}else"string"==typeof u&&(n||(n=this._resolveStrategyTypeForArtifact(c,u,i,o)));n||(o[c]=v._STRATEGY_TYPE.NONE)}return this._addLabelStrategy(o),a.each(v._STRATEGY_TYPE,function(t,n){e[n]=[]}),a.each(o,function(t,n){e[n].push(t)}),e},v.prototype._getUserAssistanceStrategyToArtifactsObj=function(){var t={},e=this._component.options.displayOptions||{},n={},i=Object.keys(e);for(let t=0;t<i.length;t++){let o=i[t],s=e[o],r=o+"";n[r]="string"==typeof s&&"none"===s?v._STRATEGY_TYPE.NONE:v._STRATEGY_TYPE.USER_ASSISTANCE_INLINE}return this._addLabelStrategy(n),Object.keys(v._STRATEGY_TYPE).forEach(function(e){let n=v._STRATEGY_TYPE[e];t[n]=[]}),Object.keys(n).forEach(function(e){let i=n[e];t[i].push(e)}),t},v.prototype._addLabelStrategy=function(t){var e=this._component._ResolveLabelEdgeStrategyType();this._resolveStrategyTypeForArtifact("labelEdge",e,this._component.options,t)||(t.labelEdge=v._STRATEGY_TYPE.NONE)},v.prototype._resolveStrategyTypeForArtifact=function(t,e,n,i){var o=!1,s=n.placeholder;switch(e){case v._STRATEGY_TYPE.PLACEHOLDER:"converterHint"===t&&(o||s||(i[t]=e,o=!0));break;case v._STRATEGY_TYPE.INLINE:"messages"===t&&(o||(i[t]=e,o=!0));break;case v._STRATEGY_TYPE.LABEL_EDGE_INSIDE:case v._STRATEGY_TYPE.LABEL_EDGE_INSIDE_FORM_CNTRL:"labelEdge"!==t||o||r.StringUtils.isEmptyOrUndefined(n.labelHint)||(i[t]=e,o=!0);break;default:o||"labelEdge"===t||(i[t]=e,o=!0)}return o},v.prototype._initializeMessagingStrategies=function(){var t=this._strategyToArtifacts(),e=t[v._STRATEGY_TYPE.NOTEWINDOW],n=t[v._STRATEGY_TYPE.NONE],i=t[v._STRATEGY_TYPE.PLACEHOLDER],o=t[v._STRATEGY_TYPE.INLINE],s=t[v._STRATEGY_TYPE.LABEL_EDGE_INSIDE],r=t[v._STRATEGY_TYPE.LABEL_EDGE_INSIDE_FORM_CNTRL],a=t[v._STRATEGY_TYPE.USER_ASSISTANCE_INLINE],l={};e.length>0&&(l[v._STRATEGY_TYPE.NOTEWINDOW]=this._createMessagingStrategy(v._STRATEGY_TYPE.NOTEWINDOW,e)),i.length>0&&0===s.length&&(l[v._STRATEGY_TYPE.PLACEHOLDER]=this._createMessagingStrategy(v._STRATEGY_TYPE.PLACEHOLDER,i)),o.length>0&&(l[v._STRATEGY_TYPE.INLINE]=this._createMessagingStrategy(v._STRATEGY_TYPE.INLINE,o)),a.length>0&&(l[v._STRATEGY_TYPE.USER_ASSISTANCE_INLINE]=this._createMessagingStrategy(v._STRATEGY_TYPE.USER_ASSISTANCE_INLINE,a)),s.length>0?l[v._STRATEGY_TYPE.LABEL_EDGE_INSIDE]=this._createMessagingStrategy(v._STRATEGY_TYPE.LABEL_EDGE_INSIDE,s):r.length>0&&(l[v._STRATEGY_TYPE.LABEL_EDGE_INSIDE_FORM_CNTRL]=this._createMessagingStrategy(v._STRATEGY_TYPE.LABEL_EDGE_INSIDE_FORM_CNTRL,r)),l[v._STRATEGY_TYPE.NONE]=this._createMessagingStrategy(v._STRATEGY_TYPE.NONE,n),this._strategies=l},v.prototype._reactivate=function(){var t,e=this._strategyToArtifacts(),n=this;a.each(e,function(e,i){e+="",t=n._strategies[e],i&&i.length>0?t?t&&t.reactivate(i):(t=n._createMessagingStrategy(e,i),n._strategies[e]=t,t.activate(n)):t&&v._STRATEGY_TYPE.NONE!==e&&(t.deactivate(),delete n._strategies[e])})},v.prototype._strategyToArtifacts=function(){let t,e=this._component._getResolvedUserAssistance();if("compact"!==e&&"displayOptions"!==e)t=this._getUserAssistanceStrategyToArtifactsObj();else{let n=this._component.options.displayOptions||{};"compact"===e?(n.messages="notewindow",n.validatorHint="notewindow",n.converterHint="notewindow",t=this._getResolvedMessagingDisplayOptions(n)):t=this._getResolvedMessagingDisplayOptions(n)}return t};const T=function(t){this.Init(t)};r.Object.createSubclass(T,r.Object,"oj.MessagingStrategy"),r._registerLegacyNamespaceProp("MessagingStrategy",T),T.prototype.Init=function(t){r.Assert.assertArray(t),T.superclass.Init.call(this),this._displayOptions=t},T.prototype.activate=function(t){this._componentMessaging=t},T.prototype.deactivate=function(){},T.prototype.close=function(){},T.prototype.reactivate=function(t){this.Init(t)},T.prototype.shouldUpdate=function(t){return!0},T.prototype.update=function(){},T.prototype.GetLauncher=function(){return this._componentMessaging._getLauncher()},T.prototype.GetContentElement=function(){return this._componentMessaging._getContentElement()},T.prototype.GetComponent=function(){return this._componentMessaging._getComponent()},T.prototype.setHasValidatorHints=function(t){this._hasValidatorHints=t},T.prototype.getHasValidatorHints=function(){return!0===this._hasValidatorHints},T.prototype.GenerateIdIfNeeded=function(t){isNaN(T._uidCounter)&&(T._uidCounter=0);var e=t;e.id||(e.id="ojms_"+T._uidCounter,T._uidCounter+=1)},T.prototype.GetMessages=function(){return this.GetValidityState().getMessages()},T.prototype.GetMaxSeverity=function(){return this.GetValidityState().getMaxSeverity()},T.prototype.GetConverterHint=function(){var t=[],e=this._getMessagingContent(),n=e&&e.converterHint;return n&&t.push(n),t},T.prototype.GetValidatorHints=function(){if(!this.getHasValidatorHints()){this.setHasValidatorHints(!0);let t=this.GetComponent();this._setMessagingContent(t._getValidatorHintsMC()),t._initAsyncValidatorMessagingHint()}var t=this._getMessagingContent();return t&&t.validatorHint||[]},T.prototype.GetTitle=function(){var t=this._getMessagingContent();return t&&t.title||""},T.prototype.GetValidityState=function(){var t=this._getMessagingContent();return t&&t.validityState||null},T.prototype.HasMessages=function(){var t=this.GetMessages();return!!(t&&t.length>0)},T.prototype.ShowMessages=function(){return-1!==this._displayOptions.indexOf("messages")},T.prototype.ShowConverterHint=function(){return-1!==this._displayOptions.indexOf("converterHint")},T.prototype.ShowValidatorHint=function(){return-1!==this._displayOptions.indexOf("validatorHint")},T.prototype.ShowTitle=function(){return-1!==this._displayOptions.indexOf("title")||-1!==this._displayOptions.indexOf("helpInstruction")},T.prototype.IsInvalid=function(){return this.GetValidityState().isInvalid()},T.prototype.AddAriaDescribedByForInlineMessaging=function(t){let e=this.GetContentElement();r.Assert.assertPrototype(e,a);let n=a(t).uniqueId()[0].getAttribute("id");e.each(function(){let t=this.getAttribute(y),e=t?t.split(/\s+/):[];-1===e.indexOf(n)&&e.push(n);let i=e.join(" ").trim();this.setAttribute(y,i)})},T.prototype.AddDescribedByToElement=function(t,e){const n=t.getAttribute("described-by");let i,o=n?n.split(/\s+/):[];-1===o.indexOf(e)&&o.push(e),i=o.join(" ").trim(),t.setAttribute("described-by",i)},T.prototype.RemoveAriaDescribedByForInlineMessaging=function(t){let e=this.GetContentElement();r.Assert.assertPrototype(e,a);let n=t.getAttribute("id");e.each(function(){let t=this.getAttribute(y),e=t?t.split(/\s+/):[],i=e.indexOf(n);-1!==i&&e.splice(i,1);let o=e.join(" ").trim();o?this.setAttribute(y,o):this.removeAttribute(y)})},T.prototype._getMessagingContent=function(){return this._componentMessaging?this._componentMessaging._getMessagingContent():{}},T.prototype._setMessagingContent=function(t){return this._componentMessaging?this._componentMessaging._setMessagingContent(t):{}};const C=function(t){this.Init(t)};v.registerMessagingStrategy(v._STRATEGY_TYPE.NONE,C),C._SELECTOR_STATE_INVALID="oj-invalid",C._SELECTOR_STATE_WARNING="oj-warning",r.Object.createSubclass(C,T,"oj.DefaultMessagingStrategy"),r._registerLegacyNamespaceProp("DefaultMessagingStrategy",C),C.prototype.update=function(){C.superclass.update.call(this);var t=this.GetLauncher(),e=this.GetMaxSeverity(),n=[],i=[],o=!1,s=this.GetComponent().widget();t&&(this.IsInvalid()?(n.push(C._SELECTOR_STATE_WARNING),i.push(C._SELECTOR_STATE_INVALID),o=!0):this.HasMessages()&&e===l.SEVERITY_LEVEL.WARNING?(n.push(C._SELECTOR_STATE_INVALID),i.push(C._SELECTOR_STATE_WARNING)):(n.push(C._SELECTOR_STATE_INVALID),n.push(C._SELECTOR_STATE_WARNING)),s.removeClass(n.join(" ")).addClass(i.join(" ")),this.GetContentElement().attr({"aria-invalid":o}))},C.prototype.deactivate=function(){this.GetComponent().widget().removeClass(C._SELECTOR_STATE_INVALID).removeClass(C._SELECTOR_STATE_WARNING),this.GetContentElement().removeAttr("aria-invalid"),C.superclass.deactivate.call(this)};const S=function(t){this.Init(t)};v.registerMessagingStrategy(v._STRATEGY_TYPE.PLACEHOLDER,S),r.Object.createSubclass(S,T,"oj.PlaceholderMessagingStrategy"),r._registerLegacyNamespaceProp("PlaceholderMessagingStrategy",S),S.prototype.Init=function(t){S.superclass.Init.call(this,t)},S.prototype.activate=function(t){S.superclass.activate.call(this,t),this._refreshPlaceholder()},S.prototype.reactivate=function(t){S.superclass.reactivate.call(this,t),this._refreshPlaceholder()},S.prototype.shouldUpdate=function(t){return!(!t||void 0===t.converterHint)},S.prototype.update=function(){S.superclass.update.call(this),this._refreshPlaceholder()},S.prototype._refreshPlaceholder=function(){var t=this.GetLauncher();if(this.ShowPlaceholderContent()&&t){var e=this.GetConverterHint(),n=e.length?e[0]:"";if(r.StringUtils.isEmptyOrUndefined(n))return;this.GetComponent().option({placeholder:n},{_context:{internalMessagingSet:!0}})}},S.prototype.ShowPlaceholderContent=function(){return this.ShowConverterHint()};const A=function(t,e){this.Init(t,e)};A.isInvalid=function(t){return l.getMaxSeverity(t)>=l.SEVERITY_LEVEL.ERROR},r.Object.createSubclass(A,r.Object,"oj.ComponentValidity"),r._registerLegacyNamespaceProp("ComponentValidity",A),A.prototype.Init=function(t,e){A.superclass.Init.call(this),this._initialize(t,e)},A.prototype.isInvalid=function(){return this._invalid},A.prototype.getMessages=function(){return this._messages},A.prototype.getMaxSeverity=function(){return this._maxSeverity},A.prototype.update=function(t,e){this._initialize(t,e)},A.prototype._initialize=function(t,e){this._compValid=t,this._compMessages=e,this._messages=this._getImmediateMessages(),this._maxSeverity=l.getMaxSeverity(this._messages),this._invalid=A.isInvalid(this._messages)},A.prototype._getImmediateMessages=function(){for(var t=this._compMessages||[],e=[],n=0;n<t.length;n++){var i=t[n];i instanceof l.ComponentMessage&&!i.canDisplay()||e.push(i)}return e};const N={};c._registerLegacyNamespaceProp("Components",N),N._OJ_CONTAINER_ATTR="data-oj-container";const b="node is not a component element";function O(t,e){if(null==t)return null;var n=1===t.nodeType,i=c.Composite&&!e?c.Composite.getContainingComposite(t):null;if(i)return i;if(n&&t.hasAttribute("data-oj-internal"))return t.parentNode instanceof Element&&t.parentNode.hasAttribute("data-oj-surrogate-id")?O(t=document.querySelector("[data-oj-popup-"+t.id+"-parent]"),e):O(t.parentNode,e);if(L(t))return t;if(n&&t.classList.contains("oj-component")){if(G(t=t.querySelector(".oj-component-initnode:not([data-oj-internal])")||t))return t}else if(n&&t.hasAttribute("data-oj-containerid"))return O(t=document.getElementById(t.getAttribute("data-oj-containerid")),e);return O(t.parentNode,e)}function P(t,e){var n=function(){var t=a(this),n=t.data("oj-component-names");if(null!=n)for(var i=0;i<n.length;i++){var o=t.data("oj-"+n[i]);null!=o&&e(o)}},i=a(t);i.hasClass("oj-component-initnode")&&n.call(t),i.find(".oj-component-initnode").each(n)}function I(t,e,n){function i(t){if(e&&t.classList.contains("oj-component-initnode")){var i=a(t),o=i.data("oj-component-names");if(null!=o)for(var s=0;s<o.length;s++){var r=i.data("oj-"+o[s]);null!=r&&e(r)}}if(n&&"oj-defer"===t.tagName.toLowerCase()){if(!t._activate)throw new Error("subtreeShown called before module ojs/ojdefer was loaded");t._activate()}}if(!function(t){for(var e=t;e;){if(e.nodeType===Node.DOCUMENT_NODE)return!1;if(e.nodeType===Node.ELEMENT_NODE&&e.classList.contains("oj-subtree-hidden"))return!0;e=e.parentNode}return!0}(t)){i(t);var o=[".oj-component-initnode"];n&&o.push("oj-defer");var s=[];o.forEach(function(t){s.push(".oj-subtree-hidden "+t),s.push(".oj-pending-subtree-hidden "+t)});for(var r=o.join(","),l=s.join(","),u=function(t,e){for(var n=[],i=0,o=0;o<e.length;o++){for(var s=e[o];i<t.length&&t[i]!==s;)n.push(t[i]),i+=1;i+=1}for(;i<t.length;)n.push(t[i]),i+=1;return n}(t.querySelectorAll(r),t.querySelectorAll(l)),c=0;c<u.length;c++)i(u[c])}}function R(t){this.getCallback=function(){return t}}function D(t,e,n){return Object.keys(e).forEach(function(i){var o=t[i]||[],s=e[i];n?o=o.concat(s):o.push(s),t[i]=o}),t}function M(t){return p.CustomElementUtils.isElementRegistered(t.tagName)}function G(t){return!!N.__GetWidgetConstructor(t)}function L(t){return M(t)||G(t)}N.setDefaultOptions=function(t){var e=N._defaultProperties||{};Object.keys(t).forEach(function(n){var i=t[n];if(!c.CollectionUtils.isPlainObject(i))throw new Error("Invalid default options");e[n]=D(e[n]||{},i,!1)}),N._defaultProperties=e},N.getDefaultOptions=function(){return N._defaultProperties||{}},N.createDynamicPropertyGetter=function(t){return new R(t)},N.getWidgetConstructor=function(t,e){return t&&!p.CustomElementUtils.isElementRegistered(t.tagName)?N.__GetWidgetConstructor(t,e):null},N.__GetWidgetConstructor=function(t,e){var n=a(t),i=n.data("oj-component-names");if(i&&(null==e?e=i[0]:i.indexOf(e)<0&&(e=void 0),null!=e)){var o=n[e];if("function"==typeof o)return o.bind(n)}return null},N.subtreeAttached=function(t){_.fixResizeListeners(t),P(t,function(t){t.__handleSubtreeAttached()})},N.subtreeDetached=function(t){P(t,function(t){t.__handleSubtreeDetached()})},N.subtreeShown=function(t,e){var n=a(t)[0];if(n.nodeType===Node.ELEMENT_NODE){var i=(e||{}).initialRender;i||_.fixResizeListeners(n),n.classList.remove("oj-subtree-hidden"),I(n,function(t){p.CustomElementUtils.allowSlotRelocation(!0);try{i?t._NotifyInitShown():t._NotifyShown()}finally{p.CustomElementUtils.allowSlotRelocation(!1)}},!0)}},N.subtreeHidden=function(t){var e=a(t)[0];e.nodeType===Node.ELEMENT_NODE&&(I(e,function(t){p.CustomElementUtils.allowSlotRelocation(!0);try{t._NotifyHidden()}finally{p.CustomElementUtils.allowSlotRelocation(!1)}},!1),e.classList.add("oj-subtree-hidden"))},N.markPendingSubtreeHidden=function(t){t.classList.add("oj-pending-subtree-hidden")},N.unmarkPendingSubtreeHidden=function(t){t.classList.remove("oj-pending-subtree-hidden")},N.isComponentInitialized=function(t,e){var n=t.data("oj-component-names");return!!(a.isArray(n)&&n.indexOf(e)>-1&&t.is(".oj-component-initnode"))},N.__getDefaultOptions=function(t){for(var e={},n=N.getDefaultOptions(),i=t.length-1;i>=0;i--){var o=n[t[i]];void 0!==o&&(e=D(e,o,!0))}return e},N.getComponentElementByNode=function(t){var e=!!(arguments.length>1&&arguments[1]);return O(t,e)},N.getSubIdByNode=function(t,e){return N.callComponentMethod(t,"getSubIdByNode",e)},N.getNodeBySubId=function(t,e){return N.callComponentMethod(t,"getNodeBySubId",e)},N.getComponentOption=function(t,e){if(!L(t))throw new Error(b);return M(t)?t.getProperty?t.getProperty.call(t,e):void 0:N.__GetWidgetConstructor(t)("option",e)},N.setComponentOption=function(t,e,n){if(!L(t))throw new Error(b);M(t)?t.setProperty&&t.setProperty.call(t,e,n):N.__GetWidgetConstructor(t)("option",e,n)},N.callComponentMethod=function(t,e,n){if(!L(t))throw new Error(b);return M(t)?t[e]?t[e].apply(t,[].slice.call(arguments,2)):void 0:N.__GetWidgetConstructor(t).apply(a(t),[].slice.call(arguments,1))};const j={};j.proto=Object.create(r.BaseCustomElementBridge.proto),r.CollectionUtils.copyInto(j.proto,{beforePropertyChangedEvent:function(t,e,n){var i=e,o=n.value;n.subproperty&&(i=n.subproperty.path,o=n.subproperty.value),this._partialRender(t,i,o)},AddComponentMethods:function(t){t.refresh=function(){p.CustomElementUtils.getElementBridge(this)._fullRender(this)},t.setProperty=function(t,e){var n=p.CustomElementUtils.getElementBridge(this);n.SaveEarlyPropertySet(this,t,e)||n.SetProperty(this,t,e,this,!0)},t.getProperty=function(t){return p.CustomElementUtils.getElementBridge(this).GetProperty(this,t,this)},t._propsProto.setProperty=function(t,e){this._BRIDGE.SetProperty(this._ELEMENT,t,e,this,!1)},t._propsProto.getProperty=function(t){return this._BRIDGE.GetProperty(this,t,this)}},CreateComponent:function(t){if(N.unmarkPendingSubtreeHidden(t),!this._INSTANCE&&this._EXTENSION._CONSTRUCTOR){var e=p.ElementUtils.getUniqueId();if(this._CONTEXT={element:t,props:this._PROPS_PROXY,unique:e},this._CONTEXT.uniqueId=t.id?t.id:e,this._INSTANCE=new this._EXTENSION._CONSTRUCTOR(this._CONTEXT),this._INSTANCE.createDOM&&this._INSTANCE.createDOM(),this._INSTANCE.updateDOM){p.CustomElementUtils.allowSlotRelocation(!0);try{this._INSTANCE.updateDOM()}finally{p.CustomElementUtils.allowSlotRelocation(!1)}}}},DefineMethodCallback:function(t,e,n){t[e]=function(){var t=p.CustomElementUtils.getElementBridge(this);if(t._INSTANCE){var i=n.internalName||e;return t._INSTANCE[i].apply(t._INSTANCE,arguments)}}},DefinePropertyCallback:function(t,e,n){function i(t,i){if(i&&(t=p.CustomElementUtils.convertEmptyStringToUndefined(this._ELEMENT,n,t)),!this._BRIDGE.SaveEarlyPropertySet(this._ELEMENT,e,t)){var o=this._BRIDGE._PROPS[e];p.ElementUtils.comparePropertyValues(n,t,o)?d.info(p.CustomElementUtils.getElementInfo(this._ELEMENT)+": Ignoring property set for property '"+e+"' with same value."):(i&&(t=this._BRIDGE.ValidatePropertySet(this._ELEMENT,e,t)),n._eventListener?(this._BRIDGE.SetEventListenerProperty(this._ELEMENT,e,t),this._BRIDGE._PROPS[e]=t):(this._BRIDGE._PROPS[e]=t,r.BaseCustomElementBridge.__FirePropertyChangeEvent(this._ELEMENT,e,t,o,i?"external":"internal"),this._BRIDGE.State.dirtyProps.add(e)))}}function o(){var t=this._BRIDGE._PROPS[e];return void 0===t&&(t=this._BRIDGE._getDefaultValue(e,n),this._BRIDGE._PROPS[e]=t),t}n._derived||r.BaseCustomElementBridge.__DefineDynamicObjectProperty(t._propsProto,e,function(){return o.bind(this)()},function(t){i.bind(this)(t,!1)}),r.BaseCustomElementBridge.__DefineDynamicObjectProperty(t,e,function(){var t=p.CustomElementUtils.getElementBridge(this);return o.bind(t._PROPS_PROXY)()},function(t){var e=p.CustomElementUtils.getElementBridge(this);i.bind(e._PROPS_PROXY)(t,!0)})},InitializeElement:function(t){r.BaseCustomElementBridge.proto.InitializeElement.call(this,t),this._EXTENSION._CONTROLS_SUBTREE_HIDDEN&&N.markPendingSubtreeHidden(t),r.BaseCustomElementBridge.__InitProperties(t,t)},InitializePrototype:function(t){r.BaseCustomElementBridge.proto.InitializePrototype.call(this,t),Object.defineProperty(t,"_propsProto",{value:{}})},initializeBridge:function(t,e){r.BaseCustomElementBridge.proto.initializeBridge.call(this,t,e),this._EXTENSION=this.METADATA.extension||{},this._PROPS={},t._propsProto&&(this._PROPS_PROXY=Object.create(t._propsProto),this._PROPS_PROXY._BRIDGE=this,this._PROPS_PROXY._ELEMENT=t)},ShouldRemoveDisabled:function(){return!0===this._EXTENSION._SHOULD_REMOVE_DISABLED},_fullRender:function(t){if(this._INSTANCE&&this._INSTANCE.updateDOM){p.CustomElementUtils.allowSlotRelocation(!0);try{this._INSTANCE.updateDOM()}finally{p.CustomElementUtils.allowSlotRelocation(!1)}}},_partialRender:function(t,e,n){if(this._INSTANCE){var i=this._INSTANCE.handlePropertyChanged;if((!i||!i(e,n))&&this._INSTANCE.updateDOM){p.CustomElementUtils.allowSlotRelocation(!0);try{this._INSTANCE.updateDOM()}finally{p.CustomElementUtils.allowSlotRelocation(!1)}}}},_getDefaultValue:function(t,e){return this._EXTENSION._CONSTRUCTOR?E.DefaultsUtils.getDefaults(this._EXTENSION._CONSTRUCTOR,this.METADATA,!1)[t]:u.getDefaultValue(e)}}),r._registerLegacyNamespaceProp("DefinitionElementBridge",j);class B extends p.ElementState{IsTransferAttribute(t){const e=p.CustomElementUtils.getElementBridge(this.Element),n=e._EXTENSION._GLOBAL_TRANSFER_ATTRS;return e._WIDGET_ELEM&&n&&n.includes(t)}GetDescriptiveTransferAttributeValue(t){return p.CustomElementUtils.getElementBridge(this.Element)._WIDGET_ELEM.getAttribute(t)}}const w={};w.proto=Object.create(r.BaseCustomElementBridge.proto),r._registerLegacyNamespaceProp("CustomElementBridge",w),r.CollectionUtils.copyInto(w.proto,{getThrottlePromise:function(){var t=this.State.getBindingProviderPromise();return t=t.then(function(t){return t?t.__GetThrottlePromise():null})},AddComponentMethods:function(t){t.setProperty=function(t,e){var n=p.CustomElementUtils.getElementBridge(this);if(!n.SaveEarlyPropertySet(this,t,e)&&!n._setEventProperty(this,t,e)&&!n._validateAndSetCopyProperty(this,t,e,null)){var i=u.getPropertyMetadata(t,p.CustomElementUtils.getElementProperties(this));i?(n._setOption(t,e,i,this),n.State.dirtyProps.add(t.split(".")[0])):this[t]=e}},t.getProperty=function(t){var e=p.CustomElementUtils.getElementBridge(this),n=u.getPropertyMetadata(t,p.CustomElementUtils.getElementProperties(this));if(p.AttributeUtils.isEventListenerProperty(t)||!n)return this[t];var i=n?n.extension:null;return i&&i._COPY_TO_INNER_ELEM?e._getCopyProperty(this,t,n):w._getPropertyAccessor(this,t)()},t.focus=function(){var t=p.CustomElementUtils.getElementBridge(this);if(t._WIDGET_INSTANCE){var e=t._WIDGET_INSTANCE.__getFocusElement();e&&(e!==this?e.focus():HTMLElement.prototype.focus.call(this))}else HTMLElement.prototype.focus.call(this)},t.blur=function(){var t=p.CustomElementUtils.getElementBridge(this);if(t._WIDGET_INSTANCE){var e=t._WIDGET_INSTANCE.__getFocusElement();e&&(e!==this?e.blur():HTMLElement.prototype.blur.call(this))}else HTMLElement.prototype.blur.call(this)}},BatchedPropertySet:function(t,e){var n,i=Object.keys(e),o={};for(n=0;n<i.length;n++){var s=i[n],r=e[s];this._setEventProperty(t,s,r)||this._validateAndSetCopyProperty(t,s,r,null)||(r=this.ValidatePropertySet(t,s,r),o[s=this.GetAliasForProperty(s)]=r)}var a=N.__GetWidgetConstructor(this._WIDGET_ELEM);if(a)a("option",o);else for(n=0;n<i.length;n++){var l=i[n];t.setProperty(l,e[l])}},CreateComponent:function(t){var e=this._INNER_DOM_FUNCTION;if(this._WIDGET_ELEM=w._getWidgetElement(t,e?e(t):this._EXTENSION._INNER_ELEM),this._WIDGET_ELEM!==t){for(var n=this._EXTENSION._GLOBAL_TRANSFER_ATTRS||[],i=0;i<n.length;i++){var o=n[i];t.hasAttribute(o)&&(this._WIDGET_ELEM.setAttribute(o,t.getAttribute(o)),this._removingTransfer=!0,t.removeAttribute(o))}this._copyProperties()}N.unmarkPendingSubtreeHidden(t);var s=a(this._WIDGET_ELEM),r=a(this._WIDGET_ELEM)[this._EXTENSION._WIDGET_NAME].bind(s);r(this._PROPS),this._WIDGET=r,this._WIDGET_INSTANCE=r("instance"),this._WRITEBACK_PROPS&&this._WIDGET_INSTANCE.__saveWritebackOptions(this._WRITEBACK_PROPS);var l=function(e){return function(n){t.dispatchEvent(new FocusEvent(e,{relatedTarget:n.relatedTarget}))}},u=this._WIDGET_INSTANCE.__getFocusElement();u&&u!==t&&(u.addEventListener("focus",l("focus")),u.addEventListener("blur",l("blur")))},DefineMethodCallback:function(t,e,n){t[e]=function(){var t=p.CustomElementUtils.getElementBridge(this),i=n.internalName||e;p.CustomElementUtils.allowSlotRelocation(!0);try{return t._WIDGET.apply(null,[i].concat([].slice.call(arguments)))}finally{p.CustomElementUtils.allowSlotRelocation(!1)}}},DefinePropertyCallback:function(t,e,n){var i=n.extension;Object.defineProperty(t,e,{enumerable:!0,get:function(){var t=p.CustomElementUtils.getElementBridge(this);return n._eventListener?t.GetEventListenerProperty(e):i&&i._COPY_TO_INNER_ELEM?t._getCopyProperty(this,e,n):w._getPropertyAccessor(this,e)()},set:function(t){var i=p.CustomElementUtils.getElementBridge(this);t=p.CustomElementUtils.convertEmptyStringToUndefined(this,n,t),i.SaveEarlyPropertySet(this,e,t)||(n._eventListener?i.SetEventListenerProperty(this,e,t):i._validateAndSetCopyProperty(this,e,t,n)||(i._setOption(e,t,n,this),i.State.dirtyProps.add(e)))}})},GetAttributes:function(t){var e=u.getFlattenedAttributes(t.properties);return t.extension._GLOBAL_TRANSFER_ATTRS&&(e=e.concat(t.extension._GLOBAL_TRANSFER_ATTRS)),t.extension._WATCHED_ATTRS&&(e=e.concat(t.extension._WATCHED_ATTRS)),e},GetAliasForProperty:function(t){var e=this._EXTENSION._ALIASED_PROPS;return e&&e[t]?e[t]:t},InitializeElement:function(t){r.BaseCustomElementBridge.proto.InitializeElement.call(this,t),this._EXTENSION._CONTROLS_SUBTREE_HIDDEN&&N.markPendingSubtreeHidden(t),r.BaseCustomElementBridge.__InitProperties(t,this._PROPS)},HandleAttributeChanged:function(t,e,n,i){var o=this._EXTENSION._GLOBAL_TRANSFER_ATTRS,s=o&&-1!==o.indexOf(e),r=this._EXTENSION._WATCHED_ATTRS,a=r&&-1!==r.indexOf(e);s&&this._WIDGET_ELEM?this._removingTransfer?this._removingTransfer&&(this._removingTransfer=!1):(this._WIDGET_ELEM.setAttribute(e,i),this._removingTransfer=!0,t.removeAttribute(e)):a&&n!==i&&this._WIDGET_INSTANCE&&this._WIDGET_INSTANCE.__handleWatchedAttribute(e,n,i)},HandleDetached:function(t){r.BaseCustomElementBridge.proto.HandleDetached.call(this,t),N.__GetWidgetConstructor(this._WIDGET_ELEM)&&this._WIDGET_INSTANCE&&this._WIDGET_INSTANCE.__handleDisconnected()},HandleReattached:function(t){r.BaseCustomElementBridge.proto.HandleReattached.call(this,t),this._WIDGET_INSTANCE&&this._WIDGET_INSTANCE.__handleConnected()},initializeBridge:function(t,e){r.BaseCustomElementBridge.proto.initializeBridge.call(this,t,e),this._INNER_DOM_FUNCTION=e.innerDomFunction,this._EXTENSION=this.METADATA.extension||{},this._PROPS=this._EXTENSION._INNER_ELEM||this._INNER_DOM_FUNCTION?{_wrapper:t}:{},this._setupPropertyAccumulator(t,this._PROPS),this._processProperties(t)},_setOption:function(t,e,n,i){let o={};if(void 0===e&&-1===t.indexOf(".")&&(o={_context:{skipEvent:!0}},e=u.getDefaultValue(n),this.State.isComplete())){const e=i[t];r.BaseCustomElementBridge.__FirePropertyChangeEvent(i,t,void 0,e,"external")}w._getPropertyAccessor(i,t,o)(e)},_copyProperties:function(){if(this._COPY_ATTRS)for(var t=0;t<this._COPY_ATTRS.length;t++){var e=this._COPY_ATTRS[t],n=p.AttributeUtils.attributeToPropertyName(e);if(Object.prototype.hasOwnProperty.call(this._PROPS,n)){var i=this._PROPS[n];this._setCopyProperty(e,i),delete this._PROPS[n]}}},_getCopyProperty:function(t,e,n){var i=p.AttributeUtils.propertyNameToAttribute(e);if(n.extension._ATTRIBUTE_ONLY){if(this._WIDGET_ELEM.hasAttribute(i)){var o=this._WIDGET_ELEM.getAttribute(i);return p.AttributeUtils.attributeToPropertyValue(t,i,o,n)}return null}return this._WIDGET_ELEM[e]},_processProperties:function(t){var e=p.CustomElementUtils.getElementProperties(t);if(e)for(var n=Object.keys(e),i=0;i<n.length;i++){var o=n[i],s=e[o];s.writeback&&(this._WRITEBACK_PROPS||(this._WRITEBACK_PROPS={}),this._WRITEBACK_PROPS[o]=!0);var r=s.extension;r&&r._COPY_TO_INNER_ELEM&&(this._COPY_ATTRS||(this._COPY_ATTRS=[]),this._COPY_ATTRS.push(o))}},_setCopyProperty:function(t,e){null==e||!1===e?this._WIDGET_ELEM.removeAttribute(t):!0===e?this._WIDGET_ELEM.setAttribute(t,""):this._WIDGET_ELEM.setAttribute(t,e)},_setupPropertyAccumulator:function(t,e){this._WIDGET=function(n,i,o){if("option"===n)return r.BaseCustomElementBridge.__SetProperty(this.GetAliasForProperty.bind(this),e,i,o),e[i];throw new p.JetElementError(t,"Cannot access methods before element is upgraded.")}},_validateAndSetCopyProperty:function(t,e,n,i){var o=p.AttributeUtils.propertyNameToAttribute(e),s=this._COPY_ATTRS&&-1!==this._COPY_ATTRS.indexOf(o);if(s)if(n=this.ValidatePropertySet(t,e,n),this._WIDGET_ELEM){i||(i=u.getPropertyMetadata(e,p.CustomElementUtils.getElementProperties(t)));var a=this._getCopyProperty(t,e,i);this._setCopyProperty(o,n),r.BaseCustomElementBridge.__FirePropertyChangeEvent(t,e,this._getCopyProperty(t,e,i),a,"external")}else this._PROPS[o]=n;return s},_setEventProperty:function(t,e,n){var i=p.AttributeUtils.isEventListenerProperty(e);return i&&(t[e]=n),i}}),w.getMetadata=function(t){return w._METADATA_MAP[t.toLowerCase()]},w.isKnownEvent=function(t,e){var n=p.CustomElementUtils.getElementBridge(t);return null!=(n.METADATA.events&&n.METADATA.events[e])},w.isKnownProperty=function(t,e){var n=p.CustomElementUtils.getElementBridge(t);return null!=(n.METADATA.properties&&n.METADATA.properties[e])},w.getPropertyForAlias=function(t,e){var n=p.CustomElementUtils.getElementBridge(t)._EXTENSION._COMPONENT_TO_ELEMENT_ALIASES;return n&&n[e]?n[e]:e},w.register=function(t,e){var n=e[r.BaseCustomElementBridge.DESC_KEY_META];n=r.BaseCustomElementBridge.__ProcessEventListeners(n),e[r.BaseCustomElementBridge.DESC_KEY_META]=n,w._METADATA_MAP[t.toLowerCase()]=n;var i=n.extension,o=i&&i._WIDGET_NAME?w.proto:j.proto;const s=i&&i._WIDGET_NAME?B:p.ElementState;var a=i._ALIASED_PROPS;a&&(i._COMPONENT_TO_ELEMENT_ALIASES={},Object.keys(a).forEach(function(t){i._COMPONENT_TO_ELEMENT_ALIASES[a[t]]=t}));const l={descriptor:e,bridgeProto:o,stateClass:s};p.CustomElementUtils.registerElement(t,l,o.getClass(e))},w._getPropertyAccessor=function(t,e,n){return function(i){var o=p.CustomElementUtils.getElementBridge(t);return 1===arguments.length?(i=o.ValidatePropertySet(t,e,i),e=o.GetAliasForProperty(e),void o._WIDGET("option",e,i,n)):(e=o.GetAliasForProperty(e),o._WIDGET("option",e))}.bind(t)},w._getWidgetElement=function(t,e){var n=t;if(e){var i=t.firstElementChild;if(i&&i.tagName.toLowerCase()===e)n=i;else{n=document.createElement(e);for(var o=[],s=t.childNodes,r=0;r<s.length;r++)o.push(s[r]);for(t.appendChild(n);o.length;){var a=o.shift();p.CustomElementUtils.getSlotAssignment(a)||n.appendChild(a)}}n.setAttribute("data-oj-internal","")}return n},w._METADATA_MAP={};class x{static isDataProvider(t){return!!t.fetchFirst}static isTreeDataProvider(t){return!!t.getChildDataProvider}}c._registerLegacyNamespaceProp("DataProviderFeatureChecker",x);var U,Y,W={isDefaultPrevented:function(){return!1},preventDefault:function(){this.isDefaultPrevented=X},stopPropagation:function(){this.isPropagationStopped=X},stopImmediatePropagation:function(){this.isImmediatePropagationStopped=X}};function H(t,e,n,i,o,s,r){var a=n,l=!1,u={};delete i[o],Object.defineProperty(i,o,{get:function(){if(l)return a;if(null!=t._settingNestedKey)return a;var n=s(r?r():o);return F([e,n,a],u)},set:function(e){a=e,null!=t._settingNestedKey?u[t._settingNestedKey]=!0:l=!0},enumerable:!0})}function k(t){if(1===t.length){var e=t[0];return e instanceof R?e.getCallback():null}for(var n=!1,i=0;i<t.length&&!n;i++){var o=t[i];null!=o&&o instanceof R&&(n=!0)}return n?function(e){var n=[];return t.forEach(function(t){null!=t&&t instanceof R?n.push(t.getCallback()(e)):n.push(t)}),F(n)}:null}function F(t,e){for(var n,i=0;i<t.length;i++){var o=t[i];if(void 0!==o)if(a.isPlainObject(o))n=V({},a.isPlainObject(n)?[n,o]:[o],i===t.length-1?null:e,null);else n=o}return n}function V(t,e,n,i){for(var o=e.length,s=0;s<o;s++)for(var r=e[s],l=Object.keys(r),u=0;u<l.length;u++){var c,_=l[u];if(c=null==n?null:null==i?_:i+"."+_,null==n||!n[c]){var h=r[_];if(void 0!==h)if(a.isPlainObject(h)){var p=a.isPlainObject(t[_])?[t[_],h]:[h];t[_]=V({},p,n,c)}else t[_]=h}}return t}function X(){return!0}function K(t){return t.getAttribute&&t.getAttribute("class")||""}a.widget("oj.baseComponent",{options:{contextMenu:null,rootAttributes:null,optionChange:void 0,destroy:void 0},refresh:function(){this._propertyContext=null,this._SetupContextMenu()},_createWidget:function(t,e){t&&(this.OuterWrapper=t._wrapper),this._originalDefaults=this.options||{},this._constructorOptions=t||{},this._super(t,e),this._AfterCreateEvent()},_SetRootAttributes:function(){var t=this.options.rootAttributes;if(t){var e=this.widget();if(null==e)return;var n=t.class;n&&e.addClass(n),t.style&&d.error("The rootAttributes.style option violates the recommended\n          Content Security Policy which disallows inline styles and is therefore ignored.\n          Use the rootAttributes.class option instead."),delete(t=a.extend({},t)).class,delete t.style,e.attr(t),delete t.id;var i=Object.keys(t);if(i.length)throw new Error("Unsupported values passed to rootAttributes option: "+i.toString())}},_create:function(){this._SaveAttributes(this.element),this._InitOptions(this._originalDefaults,this._constructorOptions),delete this._originalDefaults,delete this._constructorOptions,this._ComponentCreate(),this._AfterCreate(),this._SetupResources(),this.element.addClass("oj-component-initnode")},_InitOptions:function(t,e){this._setupDefaultOptions(t,e),this._initContextMenuOption(e)},_ComponentCreate:function(){var t,e,n;t=this.element,e=this.widgetName,(n=t.data("oj-component-names"))||(n=[],t.data("oj-component-names",n)),n.indexOf(e)<0&&n.push(e),this.activeableEventNamespace=this.eventNamespace+"activeable",this.hoverableEventNamespace=this.eventNamespace+"hoverable"},_AfterCreate:function(){this._SetRootAttributes(),this.contextMenuEventNamespace=this.eventNamespace+"contextMenu",this.activeableEventNamespace=this.eventNamespace+"activeable",this.hoverableEventNamespace=this.eventNamespace+"hoverable"},_AfterCreateEvent:a.noop,_setOptionClasses:function(){},_setOptionDisabled:function(){},_classes:function(){return""},_removeClass:function(){return this},_addClass:function(){return this},_toggleClass:function(){return this},_SaveAttributes:function(t){},_SaveAllAttributes:function(t){var e=this;this._savedAttributes=[],a.each(t,function(t,n){var i={},o={element:n,attributes:i},s=n.attributes;e._savedAttributes.push(o),a.each(s,function(t,e){var n=e.name;i[n]={attr:e.value}})})},_GetSavedAttributes:function(t){var e=this._savedAttributes;if(void 0===e)return null;for(var n=t[0],i=0,o=e.length;i<o;i++){var s=e[i];if(s.element===n)return s.attributes}return{}},_RestoreAttributes:function(){},_RestoreAllAttributes:function(){a.each(this._savedAttributes,function(t,e){var n=a(e.element),i=e.attributes;if(1===n.length){var o,s,r=e.element.attributes,l=[];for(o=0,s=r.length;o<s;o++)r[o].name in i||l.push(r[o].name);for(o=0,s=l.length;o<s;o++)n.removeAttr(l[o]);var u=Object.keys(i);for(o=0;o<u.length;o++){var c=u[o];n.attr(c,i[c].attr)}}})},_GetTranslationsSectionName:function(){return this.widgetFullName},_CompareOptionValues:function(t,e,n){return this._IsCustomElement()&&this._getWritebackOption(t)?r.Object.compareValues(e,n):e===n},getTranslatedString:function(t,e){var n={};arguments.length>2?n=Array.prototype.slice.call(arguments,1):2===arguments.length&&("object"==typeof(n=arguments[1])||n instanceof Array||(n=[n]));var i=this.option("translations."+t);return null==i?t:f.applyParameters(i.toString(),n)},getNodeBySubId:function(t){return null!=t&&null!=t.subId||!this.element?null:this.element[0]},getSubIdByNode:function(t){return null},destroy:function(){if(this._IsCustomElement())throw new Error("destroy cannot be called on a custom element");this._trigger("destroy"),_.dispatchEvent(this.element[0],new CustomEvent("_ojDestroy")),this._ReleaseResources(),this._super(),this.element.removeClass("oj-component-initnode"),this.widget().removeClass("oj-disabled"),this._removeStateClasses(this.element),function(t,e){var n=t.data("oj-component-names");if(n){var i=n.indexOf(e);i>=0&&(n.splice(i,1),0===n.length&&t.removeData("oj-component-names"))}}(this.element,this.widgetName),this._RestoreAttributes(),this._initialCmDomAttr?this.element.attr("contextmenu",this._initialCmDomAttr):this.element.removeAttr("contextmenu"),this._propertyContext=null},option:function(t,e){if(0===arguments.length)return a.widget.extend({},this.options);var n,i=arguments[0],o=i,s=null,r={};if("string"==typeof i){o={};var l=i.split(".");if(i=l.shift(),l.length){var u;s=l.join(".");try{arguments.length>1&&(this._settingNestedKey=s),u=a.widget.extend({},this.options[i]),o[i]=u}finally{this._settingNestedKey=null}for(n=0;n<l.length-1;n++)u[l[n]]=u[l[n]]||{},u=u[l[n]];if(i=l.pop(),1===arguments.length)return void 0===u[i]?null:u[i];u[i]=e}else{if(1===arguments.length)return void 0===this.options[i]?null:this.options[i];o[i]=e}r=arguments[2]||r}else r=arguments[1]||r;if(null!=s){var c={path:t,value:e};r=a.widget.extend({},r,{subkey:s,subproperty:c})}var _=r?r._context:null,h=!!_&&_.internalSet,E={},f=Object.keys(o);for(n=0;n<f.length;n++){var g=f[n],m=o[g],v=this.options[g],y=r&&r.changed;y||!this._CompareOptionValues(g,v,m)?E[g]=m:this._IsCustomElement()&&d.info(p.CustomElementUtils.getElementInfo(this.element[0])+": Ignoring property set for property '"+g+"' with same value.")}if(Object.keys(E).length>0){p.CustomElementUtils.allowSlotRelocation(!0);try{h?this._internalSetOptions(E,r):this._setOptions(E,r)}finally{p.CustomElementUtils.allowSlotRelocation(!1)}}return this},_internalSetOptions:function(t,e){for(var n=Object.keys(t),i=0;i<n.length;i++){var o=n[i],s=t[o],r=this.options[o];this.options[o]=s,this._optionChanged(o,s,r,e)}},_setOptions:function(t,e){p.CustomElementUtils.allowSlotRelocation(!0);try{for(var n=Object.keys(t),i=0;i<n.length;i++){var o=n[i],s=t[o];this._setOption(o,s,e)}}finally{p.CustomElementUtils.allowSlotRelocation(!1)}return this},_setOption:function(t,e,n){var i=this.options[t];if("disabled"===t)this.options[t]=e,this.widget().toggleClass("oj-disabled",!!e).attr("aria-disabled",e),e&&this._removeStateClasses(this.widget());else{try{var o=null==n?null:n.subkey;null!=o&&(this._settingNestedKey=o),this._super(t,e)}finally{this._settingNestedKey=null}"contextMenu"===t&&this._SetupContextMenu()}return this._optionChanged(t,e,i,n),this},_optionChanged:function(t,e,n,i){var o,s=null,r=!1,l=!1,u=null,c="external",_=null;if(i&&(s=i._context)){if(s.skipEvent)return;u=s.originalEvent,r=void 0===s.writeback?null!=u:s.writeback,l=s.readOnly,_=s.optionMetadata,o=s.extraData,s.internalSet&&(c="internal")}(_=_||{}).writeback=r?"shouldWrite":"shouldNotWrite",l&&(_.readOnly=!0);var h={option:t,previousValue:n,value:e,optionMetadata:_,updatedFrom:c},p=null==i?null:i.subkey;if(p){var d=p.split("."),E=n;d.forEach(function(t){E&&(E=E[t])});var f=i.subproperty;f.previousValue=E,h.subproperty=f}null!=o&&(h=a.extend({},o,h)),this._trigger("optionChange",u,h)},_SetupResources:function(){this._SetupContextMenu()},_ReleaseResources:function(){this._ReleaseContextMenu()},_trigger:function(t,e,n){return this._trigger2(t,e,n).proceed},_trigger2:function(t,e,n){var i=n||{};if(this._IsCustomElement())return this._triggerCustomEvent(t,e,i);var o=this.options[t],s=a.Event(e,W);return s.type=(this.widgetEventPrefix+t).toLowerCase(),s.target=this.element[0],this.element.trigger(s,i),{proceed:!(a.isFunction(o)&&!1===o.apply(this.element[0],[s].concat(i))||s.isDefaultPrevented()),event:s}},_triggerCustomEvent:function(t,e,n){var i,o,s,r={},l=this._getRootElement();if("optionChange"===t){var u=w.getPropertyForAlias(l,n.option);if(!w.isKnownProperty(l,u))return{proceed:!0,event:null};i=p.AttributeUtils.propertyNameToChangeEventType(u);for(var c=Object.keys(n),_=0;_<c.length;_++){var h=c[_];if("option"!==h)if("optionMetadata"===h)for(var d=Object.keys(n[h]),E=0;E<d.length;E++){var f=d[E];"writeback"!==f&&"component"!==f&&(r[f]=n[h][f])}else r[h]=n[h]}}else{if(i=p.AttributeUtils.eventTriggerToEventType(t),!w.isKnownEvent(l,i))return{proceed:!0,event:null};o=!0,s=!0,r=this._resolveJQueryObjects(n)}e&&(r.originalEvent=e instanceof a.Event?e.originalEvent:e);var g={detail:r};o&&(g.bubbles=!0),s&&(g.cancelable=!0);var m=new CustomEvent(i,g);return l.dispatchEvent(m),{proceed:!m.defaultPrevented,event:m}},_resolveJQueryObjects:function(t){for(var e=r.CollectionUtils.copyInto({},t),n=Object.keys(e),i=0;i<n.length;i++){var o=n[i],s=e[o];s&&s instanceof a&&(0===s.length?e[o]=null:1===s.length?e[o]=s[0]:e=s.toArray())}return e},_initContextMenuOption:function(t){var e=this.element.attr("contextmenu");this._initialCmDomAttr=e,e&&!("contextMenu"in t)&&this.option("contextMenu",document.getElementById(e),{_context:{internalSet:!0}})},_handleContextMenuGesture:function(t,e,n){if(!this._IsEffectivelyDisabled()){var i;if("OJ-MENU"===t.tagName)i=t;else{var o=N.__GetWidgetConstructor(t,"ojMenu");if(!(i=o&&o("instance")))throw new Error("Invalid JET Menu.")}this._NotifyContextMenuGesture(i,e,n),a(t).is(":visible")&&e.preventDefault()}},_SetupContextMenu:function(){var t=this._GetContextMenu();if(t||(t=this._GetDefaultContextMenu()),t&&void 0===this._contextMenuGestureInit){this._contextMenuGestureInit=t;var e=this;m.startDetectContextMenuGesture(this.widget()[0],function(n,i){e._handleContextMenuGesture(t,n,i)})}},_ReleaseContextMenu:function(){this._contextMenuGestureInit=void 0,m.stopDetectContextMenuGesture(this.widget()[0])},_GetContextMenu:function(){if(this._IsCustomElement()){var t=p.CustomElementUtils.getSlotMap(this._getRootElement()).contextMenu;if(t&&t.length>0)return t[0]}else if(this.options.contextMenu)return a(this.options.contextMenu).first()[0];return null},_NotifyContextMenuGesture:function(t,e,n){this._OpenContextMenu(e,n)},_OpenContextMenu:function(t,e,n,i,o){var s=this._GetContextMenu();if(s||(s=this._contextMenuGestureInit&&a(this._contextMenuGestureInit).is(":visible")?this._contextMenuGestureInit:this._GetDefaultContextMenu()),s){var r={mouse:{my:"start top",at:"start bottom",of:t,collision:"flipfit"},touch:{my:"start>40 center",at:"start bottom",of:t,collision:"flipfit"},keyboard:{my:"start top",at:"start bottom",of:"launcher",collision:"flipfit"}},l={launcher:this.element,position:r[e]},u={initialFocus:"menu"},c=o?a.extend(l,n,u):a.extend(!0,l,n,u);if(s.__openingContextMenu=!0,"OJ-MENU"===s.tagName)s.open(t,c,i);else{var _=N.__GetWidgetConstructor(s,"ojMenu");(_&&_("instance")).open(t,c,i);var h=function(t){t.preventDefault()};s.addEventListener("contextmenu",h),window.setTimeout(function(){s.removeEventListener("contextmenu",h)},50)}s.__openingContextMenu=!1}},_GetDefaultContextMenu:function(){return null},_removeStateClasses:function(t){t.removeClass("oj-hover oj-focus oj-focus-highlight oj-active"),t.find(".oj-hover").removeClass("oj-hover"),t.find(".oj-focus").removeClass("oj-focus"),t.find(".oj-focus-highlight").removeClass("oj-focus-highlight"),t.find(".oj-active").removeClass("oj-active")},_isRealMouseEvent:function(){return!_.recentTouchEnd()},_AddHoverable:function(t){var e;a.isPlainObject(t)?e=t.element:(e=t,t={});var n=t.afterToggle||a.noop;e.on("mouseenter"+this.hoverableEventNamespace,this._hoverStartHandler.bind(this,n)).on("mouseleave"+this.hoverableEventNamespace,this._hoverAndActiveEndHandler.bind(this,"oj-hover",n))},_RemoveHoverable:function(t){t&&t.off(this.hoverableEventNamespace)},_AddActiveable:function(t){var e;a.isPlainObject(t)?e=t.element:(e=t,t={});var n=t.afterToggle||a.noop;_.isTouchSupported()&&(e[0]&&(this._touchstartListener=this._activeStartHandler.bind(this,n),e[0].addEventListener("touchstart",this._touchstartListener,{passive:!0})),e.on("touchend"+this.activeableEventNamespace+" touchcancel"+this.activeableEventNamespace,this._hoverAndActiveEndHandler.bind(this,"oj-active",n))),e.on("mousedown"+this.activeableEventNamespace,this._activeStartHandler.bind(this,n)).on("mouseup"+this.activeableEventNamespace,this._hoverAndActiveEndHandler.bind(this,"oj-active",n)).on("mouseenter"+this.activeableEventNamespace,this._activeStartHandler.bind(this,n)).on("mouseleave"+this.activeableEventNamespace,this._hoverAndActiveEndHandler.bind(this,"oj-active",n))},_RemoveActiveable:function(t){t&&(t[0]&&(t[0].removeEventListener("touchstart",this._touchstartListener,{passive:!0}),delete this._touchstartListener),t.off(this.activeableEventNamespace),U=null)},_activeStartHandler:function(t,e){var n=a(e.currentTarget);("mouseenter"!==e.type||this._isTargetInActiveElement(e.currentTarget))&&(n.hasClass("oj-disabled")||"touchstart"!==e.type&&!this._isRealMouseEvent(e)||(n.addClass("oj-active"),t(e.type),"mousedown"===e.type&&(U=e.currentTarget,this.document.one("mouseup",function(){U=null}))))},_hoverStartHandler:function(t,e){var n=a(e.currentTarget);!n.hasClass("oj-disabled")&&this._isRealMouseEvent(e)&&(n.addClass("oj-hover"),t(e.type))},_hoverAndActiveEndHandler:function(t,e,n){("oj-active"!==t||"mouseleave"!==n.type||this._isTargetInActiveElement(n.currentTarget))&&(a(n.currentTarget).removeClass(t),e(n.type))},_isTargetInActiveElement:function(t){return U===t||null!=U&&a.contains(U,t)},_hoverable:function(){},_focusable:function(t){a.isPlainObject(t)||(t={element:t}),t.component=this,_.makeFocusable(t)},_UnregisterChildNode:function(t){if(t){a(t).off(this.eventNamespace);var e=this.bindings;e&&(this.bindings=a(e.not(t)))}},_GetReadingDirection:function(){return _.getReadingDirection()},_NotifyAttached:function(){this._propertyContext=null},_NotifyDetached:function(){this._propertyContext=null,this._removeStateClasses(this.widget())},_NotifyInitShown:function(){},_NotifyShown:function(){},_NotifyHidden:function(){},_IsEffectivelyDisabled:function(){return!(!this.options.disabled&&!this._ancestorDisabled)},__setAncestorComponentDisabled:function(t){this._ancestorDisabled=t},_getTranslationSectionLoader:function(){var t=[],e=this,n=0;this._traverseWidgetHierarchy(function(i){var o=0===n?e._GetTranslationsSectionName():i.widgetFullName;n+=1;var s=f.getComponentTranslations(o);null==s||a.isEmptyObject(s)||t.push(o)});var i=t.length;return i>0?function(){if(1===i)return f.getComponentTranslations(t[0]);for(var e={},n=i-1;n>=0;n--)a.widget.extend(e,f.getComponentTranslations(t[n]));return e}:null},_getDynamicPropertyContext:function(){if(!this._propertyContext){var t={};this._propertyContext=t;var e=this.element[0];t.containers=function(t){for(var e=t,n=[];e;){var i=e.getAttribute,o=i?i.call(e,N._OJ_CONTAINER_ATTR):null;null!=o&&n.push(o),e=e.parentNode}return n}(e),t.element=e,t.isCustomElement=this._IsCustomElement(),t.isCustomElement&&(t.customElement=this._getRootElement())}return this._propertyContext},_setupDefaultOptions:function(t,e){var n=this.options,i=this._getTranslationSectionLoader(),o=e.translations;null==i||void 0!==o&&!a.isPlainObject(o)||H(this,void 0,e.translations,n,"translations",i),this._loadGlobalDefaultOptions(t,e)},_loadGlobalDefaultOptions:function(t,e){var n=this.options,i=[];this._traverseWidgetHierarchy(function(t){i.push(t.widgetName)}),i.push("default");var o=N.__getDefaultOptions(i);if(!a.isEmptyObject(o))for(var s=this,r=function(){return s._getDynamicPropertyContext()},l=Object.keys(o),u=0;u<l.length;u++){var c=l[u],_=e[c];if(void 0===_||a.isPlainObject(_)){var h=o[c];if(h){var p=k(h);if(p)H(this,t[c],_,n,c,p,r);else{var d=[t[c]].concat(h);d.push(_),n[c]=F(d)}}}}},_traverseWidgetHierarchy:function(t){for(var e=this.constructor.prototype;null!=e&&"oj"===e.namespace;)t(e),e=Object.getPrototypeOf(e)},_getRootElement:function(){return this.OuterWrapper||this.element[0]},_IsCustomElement:function(){return p.CustomElementUtils.isElementRegistered(this._getRootElement().tagName)},_GetThrottlePromise:function(){if(this._IsCustomElement()){var t=this._getRootElement();return p.CustomElementUtils.getElementBridge(t).getThrottlePromise()}return Promise.resolve(null)},_FixRendererContext:function(t){if(this._IsCustomElement()){var e=r.CollectionUtils.copyInto({},t);return delete e.component,e.componentElement=this._getRootElement(),e}return t},_WrapCustomElementRenderer:function(t){return this._IsCustomElement()&&"function"==typeof t?function(e){var n=t(e);return n&&n.insert?n.insert:null}:t},__saveWritebackOptions:function(t){this._writebackOptions=t},_getWritebackOption:function(t){return!(!this._writebackOptions||!this._writebackOptions[t])},__handleSubtreeAttached:function(){this._IsCustomElement()||this._NotifyAttached()},__handleSubtreeDetached:function(){this._IsCustomElement()||this._NotifyDetached()},_VerifyConnectedForSetup:function(){return!1},__handleConnected:function(){this._NotifyAttached(),this.__delayConnectDisconnect(0)||this._SetupResources()},__handleDisconnected:function(){this.__delayConnectDisconnect(1)||this._ReleaseResources(),this._NotifyDetached()},__delayConnectDisconnect:function(t){return!!this._VerifyConnectedForSetup()&&(void 0===this.connectedState&&window.queueMicrotask(function(){this.connectedState===t&&(0===t?this._SetupResources():this._ReleaseResources()),this.connectedState=void 0}.bind(this)),this.connectedState=t,!0)},__handleWatchedAttribute:function(t,e,n){this._WatchedAttributeChanged(t,e,n)},_WatchedAttributeChanged:function(t,e,n){},__getFocusElement:function(){return this.GetFocusElement()},GetFocusElement:function(){return this.element[0]}}),delete a.fn.baseComponent,r.__registerWidget=function(t,e,n,i){if(a.widget(t,e,n),i){var o=t.split(".")[1];delete a.fn[o]}if("oj.oj"===t.substring(0,5)||"oj._oj"===t.substring(0,6)){var s,r=t.split("."),l=r[0],u=r[1],c=l+"-"+u;s="_"===u.substring(0,1)?"_"+l+"-"+u.substring(3):l+"-"+u.substring(2),a.expr.pseudos[s.toLowerCase()]=function(t){return!!a.data(t,c)}}},a.cleanData=(Y=a.cleanData,function(t){for(var e=[],n=0;n<t.length;n++){var i=t[n];if(null==i)break;var o=!1,s=N.__GetWidgetConstructor(i);if(s&&!(o=s("instance")._IsCustomElement())){var r=N.getComponentElementByNode(i);o=r&&p.CustomElementUtils.isElementRegistered(r.tagName)}o||e.push(i)}e.length>0&&Y(e)}),a.fn.addClass=function(t){if("function"==typeof t)return this.each(function(e){a(this).addClass(t.call(this,e,K(this)))});const e=Array.isArray(t)?t:p.CustomElementUtils.getClassSet(t);return this.each(function(){1===this.nodeType&&this.classList.add(...e)}),this},a.fn.removeClass=function(t){if("function"==typeof t)return this.each(function(e){a(this).removeClass(t.call(this,e,K(this)))});const e=Array.isArray(t)?t:p.CustomElementUtils.getClassSet(t);return this.each(function(){1===this.nodeType&&this.classList.remove(...e)}),this};const z={};r._registerLegacyNamespaceProp("Test",z),z.ready=!1,z.domNodeForLocator=function(t){var e=t;if(r.StringUtils.isString(t)){var n=t;try{e=JSON.parse(n)}catch(t){return null}}if(e&&e.element){var i=a(e.element);if(i&&i.length>0){delete e.element;var o=e;return N.getNodeBySubId(i[0],o)}}return null},z.getOpenPopupCount=function(){return r.ZOrderUtils.getOpenPopupCount()},z.findOpenPopups=function(){return r.ZOrderUtils.findOpenPopups()},z.compareStackingContexts=function(t,e){return r.ZOrderUtils.compareStackingContexts(t,e)};const q=N.subtreeAttached,J=N.subtreeDetached,Z=N.subtreeHidden,Q=N.subtreeShown,$=N.createDynamicPropertyGetter,tt=N.setDefaultOptions,et=N.getDefaultOptions,nt=N.__GetWidgetConstructor,it=N.setComponentOption,ot=N.getComponentOption,st=N.getWidgetConstructor,rt=N.isComponentInitialized,at=N.markPendingSubtreeHidden,lt=N.unmarkPendingSubtreeHidden,ut=N.__getDefaultOptions,ct=N.getComponentElementByNode,_t=N.getSubIdByNode,ht=N.getNodeBySubId,pt=N.callComponentMethod,dt=N._OJ_CONTAINER_ATTR;t.DataProviderFeatureChecker=x,t._OJ_CONTAINER_ATTR=dt,t.__GetWidgetConstructor=nt,t.__getDefaultOptions=ut,t.callComponentMethod=pt,t.createDynamicPropertyGetter=$,t.getComponentElementByNode=ct,t.getComponentOption=ot,t.getDefaultOptions=et,t.getNodeBySubId=ht,t.getSubIdByNode=_t,t.getWidgetConstructor=st,t.isComponentInitialized=rt,t.markPendingSubtreeHidden=at,t.setComponentOption=it,t.setDefaultOptions=tt,t.subtreeAttached=q,t.subtreeDetached=J,t.subtreeHidden=Z,t.subtreeShown=Q,t.unmarkPendingSubtreeHidden=lt,Object.defineProperty(t,"__esModule",{value:!0})});
//# sourceMappingURL=ojcomponentcore.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojvalidator',["ojs/ojcore"],function(t){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t;const e=function(t){this.Init(t)};return t.Object.createSubclass(e,t.Object,"oj.Validator"),e.prototype.Init=function(t){e.superclass.Init.call(this)},e});
//# sourceMappingURL=ojvalidator.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojvalidation-error',["exports","ojs/ojcore","ojs/ojmessaging"],function(e,r,t){"use strict";r=r&&Object.prototype.hasOwnProperty.call(r,"default")?r.default:r,t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t;const o=function(e,r){var o={summary:e,detail:r,severity:t.SEVERITY_LEVEL.ERROR};this.Init(o)};o.prototype=new Error,r._registerLegacyNamespaceProp("ValidatorError",o),o.prototype.Init=function(e){var r=e.detail,t=e.summary;this._message=e,this.name="Validator Error",this.message=r||t},o.prototype.getMessage=function(){return this._message};const s=function(e,r){var o={summary:e,detail:r,severity:t.SEVERITY_LEVEL.ERROR};this.Init(o)};s.prototype=new Error,r._registerLegacyNamespaceProp("ConverterError",s),s.prototype.Init=function(e){var r=e.detail,t=e.summary;this._message=e,this.name="Converter Error",this.message=r||t},s.prototype.getMessage=function(){return this._message},e.ConverterError=s,e.ValidatorError=o,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojvalidation-error.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojvalidator-required',["ojs/ojcore","ojs/ojtranslation","ojs/ojvalidator","ojs/ojvalidation-error"],function(t,e,o,r){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,o=o&&Object.prototype.hasOwnProperty.call(o,"default")?o.default:o;const i=function(t){this.Init(t)};return t.Object.createSubclass(i,o,"oj.RequiredValidator"),i._BUNDLE_KEY_DETAIL="oj-validator.required.detail",i._BUNDLE_KEY_SUMMARY="oj-validator.required.summary",i.prototype.Init=function(t){i.superclass.Init.call(this),this._options=t},i.prototype.validate=function(t){var o,i,a,n,s,l="";if(null==t||("string"==typeof t||t instanceof Array)&&0===t.length)throw this._options&&(o=this._options.messageDetail||this._options.message||null,n=this._options.messageSummary||null,l=this._options.label||""),s={label:l},a=n?e.applyParameters(n,s):e.getTranslatedString(this._getSummaryKey(),s),i=o?e.applyParameters(o,s):e.getTranslatedString(this._getDetailKey(),s),new r.ValidatorError(a,i)},i.prototype.getHint=function(){var t="";return this._options&&this._options.hint&&(t=e.getTranslatedString(this._options.hint)),t},i.prototype._getSummaryKey=function(){return i._BUNDLE_KEY_SUMMARY},i.prototype._getDetailKey=function(){return i._BUNDLE_KEY_DETAIL},i});
//# sourceMappingURL=ojvalidator-required.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojconverterutils',["ojs/ojcore-base","ojs/ojlogger"],function(e,t){"use strict";e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e;class o{}return o.getConverterInstance=function(o){let r="",a={},n=null;if(o&&("object"==typeof o&&(o.parse&&"function"==typeof o.parse||o.format&&"function"==typeof o.format?n=o:(r=o.type,a=o.options||{})),!n&&(r=r||o,r&&"string"==typeof r))){if(e.Validation&&e.Validation.converterFactory)return e.Validation.converterFactory(r).createConverter(a);t.error('oj.Validation.converterFactory is not available and it is needed to support the deprecated json format for the converters property. Please include the backward compatibility "ojvalidation-base" module.')}return n},o});
//# sourceMappingURL=ojconverterutils.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojanimation',["exports","ojs/ojcore-base","jquery","ojs/ojdomutils","ojs/ojthemeutils","ojs/ojlogger"],function(e,t,n,i,a,o){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,n=n&&Object.prototype.hasOwnProperty.call(n,"default")?n.default:n;const r={};t._registerLegacyNamespaceProp("AnimationUtils",r),r._getName=function(e,t){if(!r._nameMap){r._nameMap={};var n=r._nameMap,i=e.style;n.backfaceVisibility=void 0!==i.webkitBackfaceVisibility?"webkitBackfaceVisibility":"backfaceVisibility",n.transform=void 0!==i.webkitTransform?"webkitTransform":"transform",n.transformOrigin=void 0!==i.webkitTransformOrigin?"webkitTransformOrigin":"transformOrigin",n.transition=void 0!==i.webkitTransition?"webkitTransition":"transition",n.transitionend=void 0!==i.webkitTransition?"webkitTransitionEnd":"transitionend"}return r._nameMap[t]||t},r._getElementStyle=function(e,t){return e.style[r._getName(e,t)]},r._setElementStyle=function(e,t,n){e.style[r._getName(e,t)]=n},r._animate=function(e,t,i,a,o,s){var l=[].concat(o),f=function(n,f){var c=function(e){var t=0===e.propertyName.indexOf("-webkit-")?e.propertyName.substr(8):e.propertyName;t=r._getCamelCasePropName(t);var n=l.indexOf(t);n>-1&&(l.length>1?l.splice(n,1):u())},d=0,m=!1;function u(){m||(d&&(window.cancelAnimationFrame(d),d=0),e.removeEventListener(r._getName(e,"transitionend"),c),n&&n(!0),m=!0)}null==i&&(i={}),null==i.css&&(i.css={}),i.css.transition=r._createTransitionValue(e,o,a);var p=r._saveStyle(e,t,i,a,s||o);r._applyState(e,t,p>1),e.addEventListener(r._getName(e,"transitionend"),c);var g=a.duration,h=a.delay,v=a._skipPromise;function _(){d=0,r._applyState(e,i,p>1)}null==t?_():(a._noReflow||(r._x=e.offsetWidth),d=window.requestAnimationFrame(_));var y=r._getTotalTiming(g,h);v||setTimeout(u,y+100)};return a._skipPromise?(f(null),null):new Promise(f).then(function(){t&&t.addClass&&n(e).removeClass(t.addClass),i&&i.addClass&&n(e).removeClass(i.addClass),r._restoreStyle(e)})},r._saveCssValues=function(e,t,n,i){for(var a=Object.keys(t),o=Object.prototype.hasOwnProperty,s=0;s<a.length;s++){var l=a[s];o.call(n,l)||i&&-1!==i.indexOf(l)||(n[l]=r._getElementStyle(e,l))}},r._saveStyle=function(e,t,n,i,a){var o=e._ojSavedStyle||{},s=t&&t.css?t.css:{},l=n&&n.css?n.css:{},f=a;i&&"all"===i.persist||(f=null),r._saveCssValues(e,s,o,f),r._saveCssValues(e,l,o,f),e._ojSavedStyle=o;var c=e._ojEffectCount||0;return c+=1,e._ojEffectCount=c,c},r._restoreStyle=function(e){var t=e,n=t._ojEffectCount;if(n>1)t._ojEffectCount=n-1;else{var i=t._ojSavedStyle;if(i){for(var a=Object.keys(i),o=0;o<a.length;o++){var s=a[o];r._setElementStyle(t,s,i[s])}delete t._ojSavedStyle,delete t._ojEffectCount}}},r._getCamelCasePropName=function(e){if(e.indexOf("-")>=0){for(var t="",n=e.split("-"),i=0;i<n.length;i++){var a=n[i];a&&(t?t+=a.charAt(0).toUpperCase()+a.slice(1):t=a)}return t}return e},r._getHyphenatedPropName=function(e){var t=e.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase();return 0===t.indexOf("webkit")&&(t="-"+t),t},r._concatMultiValue=function(e,t,n,i,a){if(t.css[n]){var o=r._getElementStyle(e,n);o&&0!==o.indexOf(i)&&(t.css[n]=o+a+t.css[n])}},r._splitTransform=function(e){var t=[];if(e&&"none"!==e)for(var n=e,i=n.indexOf(")");i>0;){var a=n.substr(0,i+1);t.push(a.trim()),i=(n=n.slice(i+1)).indexOf(")")}return t},r._getTransformFuncName=function(e){var t=e.indexOf("(");return t>=1?e.substr(0,t):e},r._applyTransform=function(e,t){for(var n=r._getElementStyle(e,"transform"),i=r._splitTransform(n),a=r._splitTransform(t),o=[],s=0;s<a.length;s++){var l=r._getTransformFuncName(a[s]),f=!1;if(l)for(var c=0;c<i.length;c++)0===i[c].indexOf(l+"(")&&(i[c]=a[s],f=!0);f||o.push(a[s])}return(i=i.concat(o)).join(" ")},r._applyState=function(e,t,i){if(t){if(t.css){i&&r._concatMultiValue(e,t,"transition","all",", "),t.css.transform&&(t.css.transform=r._applyTransform(e,t.css.transform));for(var a=t.css,o=Object.keys(a),s=0;s<o.length;s++){var l=o[s];r._setElementStyle(e,l,a[l])}}t.addClass&&n(e).addClass(t.addClass),t.removeClass&&n(e).removeClass(t.removeClass)}},r._getTimingValue=function(e){var t=parseFloat(e);return isNaN(t)?0:e.indexOf("ms")>-1?t:1e3*t},r._getTotalTiming=function(e,t){var n=r._getTimingValue(e);return n>0?n+(t?r._getTimingValue(t):0):0},r._calcCssTime=function(e,t,n){for(var i=e.split(","),a=t.split(","),o=n.split(","),s=i.length,l=a.length,f=o.length,c=0,d=0;d<s;d++){var m=o[d%f],u=a[d%l],p=r._getTotalTiming(m,u);c=Math.max(c,p)}return c},r._calcEffectTime=function(e){var t,n,i,a=window.getComputedStyle(e);t=a.animationName||a.webkitAnimationName,n=a.animationDelay||a.webkitAnimationDelay,i=a.animationDuration||a.webkitAnimationDuration;var o=r._calcCssTime(t,n,i);t=a.transitionProperty||a.webkitTransitionProperty,n=a.transitionDelay||a.webkitTransitionDelay,i=a.transitionDuration||a.webkitTransitionDuration;var s=r._calcCssTime(t,n,i);return Math.max(o,s)},r._fillEmptyOptions=function(e,t){e.delay=e.delay||t.delay,e.duration=e.duration||t.duration,e.timingFunction=e.timingFunction||t.timingFunction,e.persist=e.persist||t.persist},r._triggerEvent=function(e,t,n,i){var a;if(i&&i._trigger)a=!i._trigger(t,null,n);else{var o="oj"+t.substr(0,1).toUpperCase()+t.substr(1),r=new CustomEvent(o,{detail:n,bubbles:!0,cancelable:!0}),s=i||e;s.dispatchEvent&&s.dispatchEvent(r),a=r.defaultPrevented}return a},r.startAnimation=function(e,t,i,a){return e=n(e)[0],new Promise(function(o,s){var l=n(e),f="oj-animate-"+t,c=f+"-active",d=!1,m=!1,u=function(){if(d&&m){l.removeClass(f),l.removeClass(c),r._restoreStyle(e),o(!0);var n={action:t,element:e};r._triggerEvent(e,"animateEnd",n,a)}},p=function(){d=!0,u()},g=function(){m=!0,u()};r._saveStyle(e,null,null,null,null);var h={action:t,element:e,endCallback:p};if(!r._triggerEvent(e,"animateStart",h,a)){for(var v=[].concat(i),_=[],y={},x=0;x<v.length;x++){var b,C=v[x],O="";null!=C&&"none"!==C&&("string"==typeof C?(O=C,b={}):"object"==typeof C&&(O=C.effect,b=n.extend({},C)),r._fillEmptyOptions(b,y),y=n.extend({},b)),O&&r[O]&&_.push(r[O](e,b))}_.length?Promise.all(_).then(p):p()}l.addClass(f);var w=window.requestAnimationFrame(function(){w=0,l.addClass(c);var t=r._calcEffectTime(e);t>0?setTimeout(g,t+100):g()});setTimeout(function(){w&&(window.cancelAnimationFrame(w),w=0,g())},1e3)})},r._mergeOptions=function(e,t){return null==r._defaultOptions&&(r._defaultOptions=a.parseJSONFromFontFamily("oj-animation-effect-default-options")),n.extend({duration:"400ms"},r._defaultOptions?r._defaultOptions[e]:null,t)},r._createTransitionValue=function(e,t,n){var i="";if(t)for(var a=0;a<t.length;a++){var o=r._getName(e,t[a]);i+=(a>0?", ":"")+r._getHyphenatedPropName(o)+" "+n.duration,n.timingFunction&&(i+=" "+n.timingFunction),n.delay&&(i+=" "+n.delay)}return i},r._fade=function(e,t,n,i,a){var o=r._mergeOptions(n,t),s={css:{opacity:i}},l={css:{opacity:a}};return o&&(o.startOpacity&&(s.css.opacity=o.startOpacity),o.endOpacity&&(l.css.opacity=o.endOpacity)),r._animate(e,s,l,o,["opacity"])},r.fadeIn=function(e,t){return r._fade(e,t,"fadeIn",0,1)},r.fadeOut=function(e,t){return r._fade(e,t,"fadeOut",1,0)},r.expand=function(e,t){return r._expandCollapse(e,t,!0)},r.collapse=function(e,t){return r._expandCollapse(e,t,!1)},r._wrapRowContent=function(e,t){var n,i,a=[],o=e.children,r=[],s=[];for(e._ojSavedHeight=e.style.height,i=0;i<o.length;i++){n=o[i];var l=window.getComputedStyle(n);r.push(l.padding),s.push(l.textAlign),n._ojSavedPadding=n.style.padding}for(i=0;i<o.length;i++){n=o[i];var f=document.createElement("div");f.style.overflow="hidden;";var c=document.createElement("div");for(c.style.display="table-cell",c.style.verticalAlign="middle",c.style.boxSizing="border-box",c.style.height=t,c.style.padding=r[i],c.style.textAlign=s[i],f.appendChild(c);n.firstChild;)c.appendChild(n.firstChild);n.appendChild(f),n.style.padding="0",a.push(f)}return e.style.height="0",a},r._unwrapRowContent=function(e){for(var t=e.children,n=0;n<t.length;n++){var i=t[n],a=i.children[0];if(a){var o=a.children[0];if(o)for(;o.firstChild;)i.appendChild(o.firstChild);i.removeChild(a)}i.style.padding=i._ojSavedPadding,delete i._ojSavedPadding}e.style.height=e._ojSavedHeight,delete e._ojSavedHeight},r._expandCollapseRow=function(e,t,i){var a=Promise.resolve(),o=e.offsetHeight+"px",s=r._wrapRowContent(e,o),l=n.extend({},t);if(i?l.endMaxHeight||(l.endMaxHeight=o):l.startMaxHeight||(l.startMaxHeight=o),l.persist="all",l._noReflow=!0,s.length)for(var f=0;f<s.length;f++)0===f?(l._skipPromise=!1,a=r._expandCollapse(s[f],l,i)):(l._skipPromise=!0,r._expandCollapse(s[f],l,i));return a.then(function(){null!=t&&"all"===t.persist||r._unwrapRowContent(e)})},r._getSizeLimit=function(e,t,n,i,a){var o=n;if(!o)if(i)o="0";else{var r=a?t.maxWidth:t.maxHeight;o="none"!==r?r:(a?e.offsetWidth:e.offsetHeight)+"px"}return o},r._expandCollapse=function(e,t,n){if(e&&"TR"===e.tagName)return r._expandCollapseRow(e,t,n);var i=r._mergeOptions(n?"expand":"collapse",t),a={css:{}},o={css:{}},s=i.direction||"height",l=a.css,f=o.css,c=window.getComputedStyle(e),d=[];if("both"===s||"height"===s){var m=r._getSizeLimit(e,c,i.startMaxHeight,n,!1),u=r._getSizeLimit(e,c,i.endMaxHeight,!n,!1);l.maxHeight=m,f.maxHeight=u,d.push("maxHeight")}if("both"===s||"width"===s){var p=r._getSizeLimit(e,c,i.startMaxWidth,n,!0),g=r._getSizeLimit(e,c,i.endMaxWidth,!n,!0);l.maxWidth=p,f.maxWidth=g,d.push("maxWidth")}l.overflow=i.overflow?i.overflow:"hidden";var h=[].concat(d);return h.push("overflow"),r._animate(e,a,o,i,d,h)},r.zoomIn=function(e,t){return r._zoom(e,t,!0)},r.zoomOut=function(e,t){return r._zoom(e,t,!1)},r._zoom=function(e,t,n){var i,a=r._mergeOptions(n?"zoomIn":"zoomOut",t),o={css:{}},s={css:{}},l=a.axis||"both";i="both"===l?"scale":"x"===l?"scaleX":"scaleY";var f=o.css,c=s.css;return f.transform=i+"("+(n?0:1)+") translateZ(0)",c.transform=i+"("+(n?1:0)+") translateZ(0)",f.transformOrigin=a.transformOrigin||"center",r._animate(e,o,s,a,["transform"])},r.slideIn=function(e,t){return r._slide(e,t,!0)},r.slideOut=function(e,t){return r._slide(e,t,!1)},r._slide=function(e,t,n){var a=r._mergeOptions(n?"slideIn":"slideOut",t),o={css:{}},s={css:{}},l=a.direction||"start",f="0",c="0",d=o.css,m=s.css;if(a.offsetX||a.offsetY)a.offsetX&&(f=a.offsetX),a.offsetY&&(c=a.offsetY);else{var u="rtl"===i.getReadingDirection();switch(l){case"left":f=(n?e.offsetWidth:-e.offsetWidth)+"px";break;case"right":f=(n?-e.offsetWidth:e.offsetWidth)+"px";break;case"top":c=(n?e.offsetHeight:-e.offsetHeight)+"px";break;case"bottom":c=(n?-e.offsetHeight:e.offsetHeight)+"px";break;case"end":f=(n?-e.offsetWidth:e.offsetWidth)*(u?-1:1)+"px";break;default:f=(n?e.offsetWidth:-e.offsetWidth)*(u?-1:1)+"px"}}return n?(d.transform="translate("+f+","+c+") translateZ(0)",m.transform="translate(0,0) translateZ(0)"):(d.transform="translate(0,0) translateZ(0)",m.transform="translate("+f+","+c+") translateZ(0)"),r._animate(e,o,s,a,["transform"])},r.ripple=function(e,t){var i=r._mergeOptions("ripple",t),a={css:{}},o={css:{}},s=e.offsetWidth,l=e.offsetHeight,f=n("<div>").css({position:"absolute",overflow:"hidden"}),c=n("<div class='oj-animation-effect-ripple oj-animation-rippler'>"),d="static"===window.getComputedStyle(e).position?{left:e.offsetLeft,top:e.offsetTop}:{left:0,top:0};e.insertBefore(f[0],e.firstChild),f.css({left:d.left+"px",top:d.top+"px",width:s+"px",height:l+"px"}),f.prepend(c);var m=a.css,u=o.css;return r._setRippleOptions(m,c,f,i),m.transform="scale(0) translateZ(0)",m.opacity=i.startOpacity||c.css("opacity"),u.transform="scale(1) translateZ(0)",u.opacity=i.endOpacity||0,i.persist="all",r._animate(c[0],a,o,i,["transform","opacity"]).then(function(){f.remove()})},r._setRippleOptions=function(e,t,n,i){var a=e,o=t.width(),s=n.width(),l=n.height();if(i.diameter){var f=i.diameter,c=parseInt(f,10);isNaN(c)||(o="%"===f.charAt(f.length-1)?Math.floor(Math.min(s,l)*(c/100)):c,a.width=o+"px",a.height=o+"px")}var d,m="static"===n.css("position")?n.position():{left:0,top:0};null!=(d=r._calcRippleOffset(i.offsetX,o,s,m.left))&&(a.left=d+"px"),null!=(d=r._calcRippleOffset(i.offsetY,o,l,m.top))&&(a.top=d+"px"),i.color&&(a.backgroundColor=i.color)},r._calcRippleOffset=function(e,t,n,i){var a,o=e||"50%",r=parseInt(o,10);return isNaN(r)||(a="%"===o.charAt(o.length-1)?n*(r/100)-t/2:r-t/2,a=Math.floor(a+i)),a},r._removeRipple=function(e,t){var i=t||{},a=i.removeEffect||"fadeOut",s=n(".oj-animation-rippler",e);if(0!==s.length)return a in{fadeOut:1,collapse:1,zoomOut:1,slideOut:1}?r[a](s,i).then(function(){s.remove()}):s.remove();o.warn("No rippler so returning")},r._calcBackfaceAngle=function(e){var t,n=e.match(/^([+-]?\d*\.?\d*)(.*)$/),i=parseFloat(n[1]),a=n[2];switch(a){case"deg":t=i-180+a;break;case"grad":t=i-200+a;break;case"rad":t=i-3.1416+a;break;case"turn":t=i-.5+a;break;default:o.error("Unknown angle unit in flip animation: "+a)}return t},r._flip=function(e,t,i,a,o){if(t&&"children"===t.flipTarget){var s,l=[],f=n(e).children(),c=n.extend({},t);delete c.flipTarget;var d=n.extend({},c);d.startAngle=r._calcBackfaceAngle(t.startAngle||a),d.endAngle=r._calcBackfaceAngle(t.endAngle||o);for(var m=0;m<f.length;m++)s=n(f[m]).hasClass("oj-animation-backface")?d:c,l.push(r._flip(f[m],s,i,a,o));return Promise.all(l)}var u,p={},g={},h={css:p},v={css:g},_="rotateY(",y="2000px",x="hidden",b="center";(t=r._mergeOptions(i,t))&&("x"===t.axis&&(_="rotateX("),t.startAngle&&(a=t.startAngle),t.endAngle&&(o=t.endAngle),t.perspective&&(y=t.perspective),t.backfaceVisibility&&(x=t.backfaceVisibility),t.transformOrigin&&(b=t.transformOrigin)),u="perspective("+y+") "+_;return p.transform=u+a+")",p.backfaceVisibility=x,p.transformOrigin=b,g.transform=u+o+")",r._animate(e,h,v,t,["transform"],["transform","backfaceVisibility","transformOrigin"])},r.flipIn=function(e,t){return r._flip(e,t,"flipIn","-180deg","0deg")},r.flipOut=function(e,t){return r._flip(e,t,"flipOut","0deg","180deg")},r.addTransition=function(e,t){var n=r._mergeOptions("addTransition",t);return r._animate(e,null,null,n,n.transitionProperties)},r._createHeroParent=function(){var e=document.createElement("div"),t=document.body;t.appendChild(e),e.style.position="absolute",e.style.height=t.offsetHeight+"px",e.style.width=t.offsetWidth+"px",e.style.left=t.offsetLeft+"px",e.style.top=t.offsetTop+"px",e.style.zIndex=2e3,e.className="oj-animation-host-viewport";var n=document.createElement("div");return n.className="oj-animation-host",e.appendChild(n),n},r._removeHeroParent=function(e){if(e){var t=e.parentNode;t&&t.parentNode&&t.parentNode.removeChild(t)}},r._defaultHeroCreateClonedElement=function(e){return e.fromElement.cloneNode(!0)},r._defaultHeroHideFromAndToElements=function(e){var t=e.fromElement,n=e.toElement;t.style.visibility="hidden",n.style.visibility="hidden"},r._defaultHeroAnimateClonedElement=function(e){return new Promise(function(t){var n=e.clonedElement.style;n.transformOrigin="left top",n.transform="translate(0, 0) scale(1, 1)",requestAnimationFrame(function(){n.transitionDelay=e.delay,n.transitionDuration=e.duration,n.transitionTimingFunction=e.timingFunction,n.transitionProperty="transform";var i="translate("+e.translateX+"px,"+e.translateY+"px)";i+=" scale("+e.scaleX.toFixed(2)+","+e.scaleY.toFixed(2)+")",n.transform=i;var a=r._getTimingValue(e.delay)+r._getTimingValue(e.duration);setTimeout(function(){t()},a)})})},r._defaultHeroShowToElement=function(e){e.toElement.style.visibility="visible"},r._doAnimateHero=function(e,t,n,i,a,o){var s=document.querySelector(t);if(null!=s){var l=e.getBoundingClientRect(),f=s.getBoundingClientRect(),c=f.left-l.left,d=f.top-l.top,m=f.width/l.width,u=f.height/l.height,p={fromElement:e,toElement:s,clonedElement:null,translateX:c,translateY:d,scaleX:m,scaleY:u,toElementElapsedTime:i,delay:n.delay,duration:n.duration,timingFunction:n.timingFunction},g=n.createClonedElement(p);p.clonedElement=g;var h=r._createHeroParent(),v=h.getBoundingClientRect();h.appendChild(g),g.style.position="absolute",g.style.left=l.left-v.left+"px",g.style.top=l.top-v.top+"px",n.hideFromAndToElements(p),g.style.visibility="visible",n.animateClonedElement(p).then(function(){_(),a()}).catch(function(e){_(),o(e)})}else{i+100>n.toElementWaitTime?o("toElement not found in DOM after toElementWaitTime has expired"):setTimeout(function(){r._doAnimateHero(e,t,n,i+100,a,o)},100)}function _(){n.showToElement(p),r._removeHeroParent(h)}},r.animateHero=function(e,t){var n=e,i={toElementWaitTime:5e3,createClonedElement:r._defaultHeroCreateClonedElement,hideFromAndToElements:r._defaultHeroHideFromAndToElements,animateClonedElement:r._defaultHeroAnimateClonedElement,showToElement:r._defaultHeroShowToElement,delay:"0s",duration:"400ms",timingFunction:"ease"};return Object.assign(i,t),new Promise(function(e,a){n?t.toElementSelector?r._doAnimateHero(n,t.toElementSelector,i,0,e,a):a("No options.toElementSelector specified"):a("No element specified")})};const s=r.startAnimation,l=r.fadeIn,f=r.fadeOut,c=r.expand,d=r.collapse,m=r.zoomIn,u=r.zoomOut,p=r.slideIn,g=r.slideOut,h=r.ripple,v=r.flipIn,_=r.flipOut,y=r.addTransition,x=r.animateHero;e.addTransition=y,e.animateHero=x,e.collapse=d,e.expand=c,e.fadeIn=l,e.fadeOut=f,e.flipIn=v,e.flipOut=_,e.ripple=h,e.slideIn=p,e.slideOut=g,e.startAnimation=s,e.zoomIn=m,e.zoomOut=u,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojanimation.js.map;
!function(n,l){"object"==typeof exports&&"undefined"!=typeof module?l(exports):"function"==typeof define&&define.amd?define('preact',["exports"],l):l(n.preact={})}(this,function(n){var l,u,i,t,o,f,r={},e=[],c=/acit|ex(?:s|g|n|p|$)|rph|grid|ows|mnc|ntw|ine[ch]|zoo|^ord|itera/i;function s(n,l){for(var u in l)n[u]=l[u];return n}function a(n){var l=n.parentNode;l&&l.removeChild(n)}function v(n,l,u){var i,t,o,f=arguments,r={};for(o in l)"key"==o?i=l[o]:"ref"==o?t=l[o]:r[o]=l[o];if(arguments.length>3)for(u=[u],o=3;o<arguments.length;o++)u.push(f[o]);if(null!=u&&(r.children=u),"function"==typeof n&&null!=n.defaultProps)for(o in n.defaultProps)void 0===r[o]&&(r[o]=n.defaultProps[o]);return h(n,r,i,t,null)}function h(n,u,i,t,o){var f={type:n,props:u,key:i,ref:t,__k:null,__:null,__b:0,__e:null,__d:void 0,__c:null,__h:null,constructor:void 0,__v:null==o?++l.__v:o};return null!=l.vnode&&l.vnode(f),f}function y(n){return n.children}function p(n,l){this.props=n,this.context=l}function d(n,l){if(null==l)return n.__?d(n.__,n.__.__k.indexOf(n)+1):null;for(var u;l<n.__k.length;l++)if(null!=(u=n.__k[l])&&null!=u.__e)return u.__e;return"function"==typeof n.type?d(n):null}function _(n){var l,u;if(null!=(n=n.__)&&null!=n.__c){for(n.__e=n.__c.base=null,l=0;l<n.__k.length;l++)if(null!=(u=n.__k[l])&&null!=u.__e){n.__e=n.__c.base=u.__e;break}return _(n)}}function k(n){(!n.__d&&(n.__d=!0)&&i.push(n)&&!b.__r++||o!==l.debounceRendering)&&((o=l.debounceRendering)||t)(b)}function b(){for(var n;b.__r=i.length;)n=i.sort(function(n,l){return n.__v.__b-l.__v.__b}),i=[],n.some(function(n){var l,u,i,t,o,f;n.__d&&(o=(t=(l=n).__v).__e,(f=l.__P)&&(u=[],(i=s({},t)).__v=t.__v+1,j(f,t,i,l.__n,void 0!==f.ownerSVGElement,null!=t.__h?[o]:null,u,null==o?d(t):o,t.__h),H(u,t),t.__e!=o&&_(t)))})}function m(n,l,u,i,t,o,f,c,s,a){var v,p,_,k,b,m,x,A=i&&i.__k||e,P=A.length;for(u.__k=[],v=0;v<l.length;v++)if(null!=(k=u.__k[v]=null==(k=l[v])||"boolean"==typeof k?null:"string"==typeof k||"number"==typeof k||"bigint"==typeof k?h(null,k,null,null,k):Array.isArray(k)?h(y,{children:k},null,null,null):k.__b>0?h(k.type,k.props,k.key,null,k.__v):k)){if(k.__=u,k.__b=u.__b+1,null===(_=A[v])||_&&k.key==_.key&&k.type===_.type)A[v]=void 0;else for(p=0;p<P;p++){if((_=A[p])&&k.key==_.key&&k.type===_.type){A[p]=void 0;break}_=null}j(n,k,_=_||r,t,o,f,c,s,a),b=k.__e,(p=k.ref)&&_.ref!=p&&(x||(x=[]),_.ref&&x.push(_.ref,null,k),x.push(p,k.__c||b,k)),null!=b?(null==m&&(m=b),"function"==typeof k.type&&null!=k.__k&&k.__k===_.__k?k.__d=s=g(k,s,n):s=w(n,k,_,A,b,s),a||"option"!==u.type?"function"==typeof u.type&&(u.__d=s):n.value=""):s&&_.__e==s&&s.parentNode!=n&&(s=d(_))}for(u.__e=m,v=P;v--;)null!=A[v]&&("function"==typeof u.type&&null!=A[v].__e&&A[v].__e==u.__d&&(u.__d=d(i,v+1)),z(A[v],A[v]));if(x)for(v=0;v<x.length;v++)T(x[v],x[++v],x[++v])}function g(n,l,u){var i,t;for(i=0;i<n.__k.length;i++)(t=n.__k[i])&&(t.__=n,l="function"==typeof t.type?g(t,l,u):w(u,t,t,n.__k,t.__e,l));return l}function w(n,l,u,i,t,o){var f,r,e;if(void 0!==l.__d)f=l.__d,l.__d=void 0;else if(null==u||t!=o||null==t.parentNode)n:if(null==o||o.parentNode!==n)n.appendChild(t),f=null;else{for(r=o,e=0;(r=r.nextSibling)&&e<i.length;e+=2)if(r==t)break n;n.insertBefore(t,o),f=o}return void 0!==f?f:t.nextSibling}function x(n,l,u,i,t){var o;for(o in u)"children"===o||"key"===o||o in l||P(n,o,null,u[o],i);for(o in l)t&&"function"!=typeof l[o]||"children"===o||"key"===o||"value"===o||"checked"===o||u[o]===l[o]||P(n,o,l[o],u[o],i)}function A(n,l,u){"-"===l[0]?n.setProperty(l,u):n[l]=null==u?"":"number"!=typeof u||c.test(l)?u:u+"px"}function P(n,l,u,i,t){var o;n:if("style"===l)if("string"==typeof u)n.style.cssText=u;else{if("string"==typeof i&&(n.style.cssText=i=""),i)for(l in i)u&&l in u||A(n.style,l,"");if(u)for(l in u)i&&u[l]===i[l]||A(n.style,l,u[l])}else if("o"===l[0]&&"n"===l[1])o=l!==(l=l.replace(/Capture$/,"")),l=l.toLowerCase()in n?l.toLowerCase().slice(2):l.slice(2),n.l||(n.l={}),n.l[l+o]=u,u?i||n.addEventListener(l,o?$:C,o):n.removeEventListener(l,o?$:C,o);else if("dangerouslySetInnerHTML"!==l){if(t)l=l.replace(/xlink[H:h]/,"h").replace(/sName$/,"s");else if("href"!==l&&"list"!==l&&"form"!==l&&"tabIndex"!==l&&"download"!==l&&l in n)try{n[l]=null==u?"":u;break n}catch(n){}"function"==typeof u||(null!=u&&(!1!==u||"a"===l[0]&&"r"===l[1])?n.setAttribute(l,u):n.removeAttribute(l))}}function C(n){this.l[n.type+!1](l.event?l.event(n):n)}function $(n){this.l[n.type+!0](l.event?l.event(n):n)}function j(n,u,i,t,o,f,r,e,c){var a,v,h,d,_,k,b,g,w,x,A,P=u.type;if(void 0!==u.constructor)return null;null!=i.__h&&(c=i.__h,e=u.__e=i.__e,u.__h=null,f=[e]),(a=l.__b)&&a(u);try{n:if("function"==typeof P){if(g=u.props,w=(a=P.contextType)&&t[a.__c],x=a?w?w.props.value:a.__:t,i.__c?b=(v=u.__c=i.__c).__=v.__E:("prototype"in P&&P.prototype.render?u.__c=v=new P(g,x):(u.__c=v=new p(g,x),v.constructor=P,v.render=L),w&&w.sub(v),v.props=g,v.state||(v.state={}),v.context=x,v.__n=t,h=v.__d=!0,v.__h=[]),null==v.__s&&(v.__s=v.state),null!=P.getDerivedStateFromProps&&(v.__s==v.state&&(v.__s=s({},v.__s)),s(v.__s,P.getDerivedStateFromProps(g,v.__s))),d=v.props,_=v.state,h)null==P.getDerivedStateFromProps&&null!=v.componentWillMount&&v.componentWillMount(),null!=v.componentDidMount&&v.__h.push(v.componentDidMount);else{if(null==P.getDerivedStateFromProps&&g!==d&&null!=v.componentWillReceiveProps&&v.componentWillReceiveProps(g,x),!v.__e&&null!=v.shouldComponentUpdate&&!1===v.shouldComponentUpdate(g,v.__s,x)||u.__v===i.__v){v.props=g,v.state=v.__s,u.__v!==i.__v&&(v.__d=!1),v.__v=u,u.__e=i.__e,u.__k=i.__k,u.__k.forEach(function(n){n&&(n.__=u)}),v.__h.length&&r.push(v);break n}null!=v.componentWillUpdate&&v.componentWillUpdate(g,v.__s,x),null!=v.componentDidUpdate&&v.__h.push(function(){v.componentDidUpdate(d,_,k)})}v.context=x,v.props=g,v.state=v.__s,(a=l.__r)&&a(u),v.__d=!1,v.__v=u,v.__P=n,a=v.render(v.props,v.state,v.context),v.state=v.__s,null!=v.getChildContext&&(t=s(s({},t),v.getChildContext())),h||null==v.getSnapshotBeforeUpdate||(k=v.getSnapshotBeforeUpdate(d,_)),A=null!=a&&a.type===y&&null==a.key?a.props.children:a,m(n,Array.isArray(A)?A:[A],u,i,t,o,f,r,e,c),v.base=u.__e,u.__h=null,v.__h.length&&r.push(v),b&&(v.__E=v.__=null),v.__e=!1}else null==f&&u.__v===i.__v?(u.__k=i.__k,u.__e=i.__e):u.__e=I(i.__e,u,i,t,o,f,r,c);(a=l.diffed)&&a(u)}catch(n){u.__v=null,(c||null!=f)&&(u.__e=e,u.__h=!!c,f[f.indexOf(e)]=null),l.__e(n,u,i)}}function H(n,u){l.__c&&l.__c(u,n),n.some(function(u){try{n=u.__h,u.__h=[],n.some(function(n){n.call(u)})}catch(n){l.__e(n,u.__v)}})}function I(n,l,u,i,t,o,f,c){var s,v,h,y,p=u.props,d=l.props,_=l.type,k=0;if("svg"===_&&(t=!0),null!=o)for(;k<o.length;k++)if((s=o[k])&&(s===n||(_?s.localName==_:3==s.nodeType))){n=s,o[k]=null;break}if(null==n){if(null===_)return document.createTextNode(d);n=t?document.createElementNS("http://www.w3.org/2000/svg",_):document.createElement(_,d.is&&d),o=null,c=!1}if(null===_)p===d||c&&n.data===d||(n.data=d);else{if(o=o&&e.slice.call(n.childNodes),v=(p=u.props||r).dangerouslySetInnerHTML,h=d.dangerouslySetInnerHTML,!c){if(null!=o)for(p={},y=0;y<n.attributes.length;y++)p[n.attributes[y].name]=n.attributes[y].value;(h||v)&&(h&&(v&&h.__html==v.__html||h.__html===n.innerHTML)||(n.innerHTML=h&&h.__html||""))}if(x(n,d,p,t,c),h)l.__k=[];else if(k=l.props.children,m(n,Array.isArray(k)?k:[k],l,u,i,t&&"foreignObject"!==_,o,f,n.firstChild,c),null!=o)for(k=o.length;k--;)null!=o[k]&&a(o[k]);c||("value"in d&&void 0!==(k=d.value)&&(k!==n.value||"progress"===_&&!k)&&P(n,"value",k,p.value,!1),"checked"in d&&void 0!==(k=d.checked)&&k!==n.checked&&P(n,"checked",k,p.checked,!1))}return n}function T(n,u,i){try{"function"==typeof n?n(u):n.current=u}catch(n){l.__e(n,i)}}function z(n,u,i){var t,o,f;if(l.unmount&&l.unmount(n),(t=n.ref)&&(t.current&&t.current!==n.__e||T(t,null,u)),i||"function"==typeof n.type||(i=null!=(o=n.__e)),n.__e=n.__d=void 0,null!=(t=n.__c)){if(t.componentWillUnmount)try{t.componentWillUnmount()}catch(n){l.__e(n,u)}t.base=t.__P=null}if(t=n.__k)for(f=0;f<t.length;f++)t[f]&&z(t[f],u,i);null!=o&&a(o)}function L(n,l,u){return this.constructor(n,u)}function M(n,u,i){var t,o,f;l.__&&l.__(n,u),o=(t="function"==typeof i)?null:i&&i.__k||u.__k,f=[],j(u,n=(!t&&i||u).__k=v(y,null,[n]),o||r,r,void 0!==u.ownerSVGElement,!t&&i?[i]:o?null:u.firstChild?e.slice.call(u.childNodes):null,f,!t&&i?i:o?o.__e:u.firstChild,t),H(f,n)}l={__e:function(n,l){for(var u,i,t;l=l.__;)if((u=l.__c)&&!u.__)try{if((i=u.constructor)&&null!=i.getDerivedStateFromError&&(u.setState(i.getDerivedStateFromError(n)),t=u.__d),null!=u.componentDidCatch&&(u.componentDidCatch(n),t=u.__d),t)return u.__E=u}catch(l){n=l}throw n},__v:0},u=function(n){return null!=n&&void 0===n.constructor},p.prototype.setState=function(n,l){var u;u=null!=this.__s&&this.__s!==this.state?this.__s:this.__s=s({},this.state),"function"==typeof n&&(n=n(s({},u),this.props)),n&&s(u,n),null!=n&&this.__v&&(l&&this.__h.push(l),k(this))},p.prototype.forceUpdate=function(n){this.__v&&(this.__e=!0,n&&this.__h.push(n),k(this))},p.prototype.render=y,i=[],t="function"==typeof Promise?Promise.prototype.then.bind(Promise.resolve()):setTimeout,b.__r=0,f=0,n.render=M,n.hydrate=function n(l,u){M(l,u,n)},n.createElement=v,n.h=v,n.Fragment=y,n.createRef=function(){return{current:null}},n.isValidElement=u,n.Component=p,n.cloneElement=function(n,l,u){var i,t,o,f=arguments,r=s({},n.props);for(o in l)"key"==o?i=l[o]:"ref"==o?t=l[o]:r[o]=l[o];if(arguments.length>3)for(u=[u],o=3;o<arguments.length;o++)u.push(f[o]);return null!=u&&(r.children=u),h(n.type,r,i||n.key,t||n.ref,null)},n.createContext=function(n,l){var u={__c:l="__cC"+f++,__:n,Consumer:function(n,l){return n.children(l)},Provider:function(n){var u,i;return this.getChildContext||(u=[],(i={})[l]=this,this.getChildContext=function(){return i},this.shouldComponentUpdate=function(n){this.props.value!==n.value&&u.some(k)},this.sub=function(n){u.push(n);var l=n.componentWillUnmount;n.componentWillUnmount=function(){u.splice(u.indexOf(n),1),l&&l.call(n)}}),n.children}};return u.Provider.__=u.Consumer.contextType=u},n.toChildArray=function n(l,u){return u=u||[],null==l||"boolean"==typeof l||(Array.isArray(l)?l.some(function(l){n(l,u)}):u.push(l)),u},n.options=l});
//# sourceMappingURL=preact.umd.js.map
;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojpreact-patch',["exports"],function(e){"use strict";const t=Symbol(),n=Symbol(),o=Symbol();function l(e,n){Object.defineProperty(e,"firstChild",{get(){let l=e.childNodes[0];return l?(l=l[o]||l,n&&(l=l[t]||l),l):null},enumerable:!0})}const r=Symbol();e.OJ_POPUP=o,e.OJ_REPLACER=t,e.OJ_SLOT=n,e.patchPopupParent=function(e){e[r]||(e[r]=!0,l(e,!1))},e.patchSlotParent=function(e){if(!e[r]){e[r]=!0;const t=e.insertBefore;e.insertBefore=(o,l)=>t.call(e,o,(null==l?void 0:l[n])||l),l(e,!0)}},Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojpreact-patch.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojvcomponent.js',["require","exports","preact","ojs/ojmetadatautils","ojs/ojcustomelement-utils","ojs/ojcore-base","ojs/ojpreact-patch","ojs/ojtrace-event"],function(e,t,s,n,o,r,i,l){"use strict";r=r&&Object.prototype.hasOwnProperty.call(r,"default")?r.default:r;class a{parkNode(e){this._getLot().appendChild(e),r.Components&&r.Components.subtreeHidden(e)}disposeNodes(e,t){a._iterateSlots(e,e=>{const s=e.parentElement;this._lot===s?(t(e),this._lot.removeChild(e)):s||t(e)})}disconnectNodes(e){a._iterateSlots(e,e=>{this._lot===e.parentElement&&this._lot.removeChild(e)})}reconnectNodes(e){a._iterateSlots(e,e=>{e.parentElement||this._lot.appendChild(e)})}isParked(e){return(null==e?void 0:e.parentElement)===this._lot}_getLot(){if(!this._lot){const e=document.createElement("div");e.style.display="none",document.body.appendChild(e),this._lot=e}return this._lot}static _iterateSlots(e,t){Object.keys(e).forEach(s=>{e[s].forEach(e=>{t(e)})})}}const c=new a;function p(e,t,n,r,l){const a=`_${t}_${n}_`,c=function(e,t,s){let n,r=0;return l=>{if(null!=l){r++,n&&(n[i.OJ_SLOT]=null),n=e[i.OJ_REPLACER]=l;const s=l.parentElement;i.patchSlotParent(s),s.replaceChild(e,l),t(e),l[i.OJ_SLOT]=e}else{if(r--,r<0)throw new o.JetElementError(this,"Slot replacer count underflow");0===r&&(e.remove(),s(e))}}}(e,r,l);return s.h(()=>s.h("oj-slot-replacer",{ref:c,key:a}),null)}class d extends HTMLElement{connectedCallback(){const e=this[i.OJ_SLOT];e&&this.parentElement.replaceChild(e,this)}get parentNode(){const e=this[i.OJ_SLOT];return!e||c.isParked(e)?null:e.parentNode}get nextSibling(){const e=this[i.OJ_SLOT];if(!e||c.isParked(e))return null;const t=e.nextSibling;return(null==t?void 0:t[i.OJ_REPLACER])||t}}customElements.define("oj-slot-replacer",d);const h=/acit|ex(?:s|g|n|p|$)|rph|grid|ows|mnc|ntw|ine[ch]|zoo|^ord|itera/i;function u(e,t,s){"-"===t[0]?e.setProperty(t,s):null==s?e[t]="":"number"!=typeof s||h.test(t)?e[t]=s:e[t]=s+"px"}function _(e,t,s,n,o){let r;e:if("style"===t)if("string"==typeof s)e.style.cssText=s;else{if("string"==typeof n&&(e.style.cssText=n=""),n)for(t in n)s&&t in s||u(e.style,t,"");if(s)for(t in s)n&&s[t]===n[t]||u(e.style,t,s[t])}else if("o"===t[0]&&"n"===t[1])if(r=t!==(t=t.replace(/Capture$/,"")),t=t.toLowerCase()in e?t.toLowerCase().slice(2):t.slice(2),e._listeners||(e._listeners={}),e._listeners[t+r]=s,s){if(!n){const s=r?v:m;e.addEventListener(t,s,r)}}else{const s=r?v:m;e.removeEventListener(t,s,r)}else if("dangerouslySetInnerHTML"!==t){if(o)t=t.replace(/xlink[H:h]/,"h").replace(/sName$/,"s");else if("href"!==t&&"list"!==t&&"form"!==t&&"tabIndex"!==t&&"download"!==t&&t in e)try{e[t]=null==s?"":s;break e}catch(e){}"function"==typeof s||(null!=s&&(!1!==s||"a"===t[0]&&"r"===t[1])?e.setAttribute(t,s):e.removeAttribute(t))}}function m(e){this._listeners[e.type+!1](s.options.event?s.options.event(e):e)}function v(e){this._listeners[e.type+!0](s.options.event?s.options.event(e):e)}const f=Symbol(),y=Symbol(),g=new Set,P=Symbol(),b=Symbol();class C{constructor(e,t,n,r,i,l){this.ref=s.createRef(),this._isPatching=!1,this._props={ref:this.ref},this._verifyingState=E.Unset,this._earlySets=[],this._eventQueue=[],this._isRenderQueued=!1,this._state=o.CustomElementUtils.getElementState(e),this._element=e,this._metadata=n,this._component=t,this._controlledProps=(null==i?void 0:i.length)>0?new Set(i):g,this._controlledAttrs=(null==r?void 0:r.length)>0?new Set(r):g,this._defaultProps=l,this._rootPatchCallback=this._patchRootElement.bind(this)}connectedCallback(){this._verifyConnectDisconnect(E.Connect)}disconnectedCallback(){this._verifyConnectDisconnect(E.Disconnect)}attributeChangedCallback(e,t,s){if(!this._isPatching&&this._state.canHandleAttributes()){const n=o.AttributeUtils.attributeToPropertyName(e),r=n.split(".")[0];if(this._state.dirtyProps.has(r))this._state.dirtyProps.delete(r);else if(t===s)return;null===s&&(s=void 0),"knockout"===this._state.getBindingProviderType()&&(o.AttributeUtils.isGlobalOrData(n)||this._element.dispatchEvent(new CustomEvent("attribute-changed",{detail:{attribute:e,value:s,previousValue:t}})));const[i,l,a]=this._getPropValuePair(e,s);i&&this._updatePropsAndQueueRenderAsNeeded(i,l,a)}}getProperty(e){var t;if(n.getPropertyMetadata(e,null===(t=this._metadata)||void 0===t?void 0:t.properties)){let t=o.CustomElementUtils.getPropertyValue(this._props,e);return void 0===t&&this._defaultProps&&(t=o.CustomElementUtils.getPropertyValue(this._defaultProps,e)),t}return this._element[e]}setProperty(e,t){var s;if(this._isPatching)return;const r=n.getPropertyMetadata(e,null===(s=this._metadata)||void 0===s?void 0:s.properties);r?(t=o.CustomElementUtils.convertEmptyStringToUndefined(this._element,r,t),this._state.allowPropertySets()?this._updatePropsAndQueueRenderAsNeeded(e,t,r):this._earlySets.push({property:e,value:t})):this._element[e]=t}setProperties(e){this._isPatching||Object.keys(e).forEach(t=>{this.setProperty(t,e[t])})}getProps(){return this._props}isInitialized(){return!!this._vdom}appendChildHelper(e,t){return o.CustomElementUtils.canRelocateNode(e,t)?HTMLElement.prototype.appendChild.call(e,t):t}insertBeforeHelper(e,t,s){return o.CustomElementUtils.canRelocateNode(e,t)?HTMLElement.prototype.insertBefore.call(e,t,s):t}_render(){var e;if(!this._vdom){this._initializePropsFromDom();const t=this._metadata.events;t&&this._initializeActionCallbacks(t);const s=null===(e=this._metadata.extension)||void 0===e?void 0:e._WRITEBACK_PROPS;s&&this._initializeWritebackCallbacks(s),this._playbackEarlyPropertySets()}this._vdom=s.h(this._component,this._props,null),this._vdom.props[f]=this._element,this._vdom.props[y]=this._rootPatchCallback,this._isPatching=!0,s.render(this._vdom,this._element),this._isPatching=!1}_getPropValuePair(e,t){var s,r;if("knockout"!==this._state.getBindingProviderType()||!o.AttributeUtils.getExpressionInfo(t).expr){const i=o.AttributeUtils.attributeToPropertyName(e),l=n.getPropertyMetadata(i,null===(s=this._metadata)||void 0===s?void 0:s.properties);if(l)return l.readOnly?[null,null,null]:[i,o.AttributeUtils.attributeToPropertyValue(this._element,e,t,l),l];const a=o.AttributeUtils.getGlobalPropForAttr(e);if(this._controlledProps.has(a))return[a,null!==(r=this[a])&&void 0!==r?r:t,null]}return[null,null,null]}_updatePropsAndQueueRenderAsNeeded(e,t,s,n=!0){const i=this.getProperty(e);if(s&&o.ElementUtils.comparePropertyValues(s,t,i))return;const l=e.split("."),a=l[0],c=l.length>1;let p=this.getProperty(a);if(r.CollectionUtils.isPlainObject(p)&&(p=r.CollectionUtils.copyInto({},p,void 0,!0)),n&&this._verifyProps(e,t,s),this._updateProps(l,t),!n||this._state.allowPropertyChangedEvents()&&!o.AttributeUtils.isGlobalOrData(e)){this._state.dirtyProps.add(a);const s=n?"external":"internal",o={value:this.getProperty(a),previousValue:p,updatedFrom:s};c&&(o.subproperty={path:e,value:t,previousValue:i}),this._queueFireEventsTask(new CustomEvent(a+"Changed",{detail:o}))}const d=this._oldRootProps;d&&this._controlledProps.has(e)&&(d[e]=t),this._queueRender(this._vdom&&!(null==s?void 0:s.readOnly))}_queueRender(e){e&&!this._isRenderQueued&&(this._isRenderQueued=!0,window.queueMicrotask(()=>{try{this._render()}finally{this._isRenderQueued=!1}}))}_verifyProps(e,t,s){if(s){if(s.readOnly)throw new o.JetElementError(this._element,`Read-only property '${e}' cannot be set.`);try{n.checkEnumValues(this._element,e,t,s)}catch(e){throw new o.JetElementError(this._element,e.message)}}}_updateProps(e,t){var s,n;const o=e[0];let i=this._props;if(e.length>1){const e=null!==(s=this._props[o])&&void 0!==s?s:null===(n=this._defaultProps)||void 0===n?void 0:n[o];e&&r.CollectionUtils.isPlainObject(e)?i[o]=r.CollectionUtils.copyInto({},e,void 0,!0):i[o]={}}for(;e.length;){const s=e.shift();0===e.length?i[s]=t:i[s]||(i[s]={}),i=i[s]}}_queueFireEventsTask(e){return this._eventQueue.push(e),this._queuedEvents||(this._queuedEvents=new Promise(e=>{window.queueMicrotask(()=>{try{for(;this._eventQueue.length;)this._element.dispatchEvent(this._eventQueue.shift())}finally{e(),this._queuedEvents=null}})})),this._queuedEvents}_verifyConnectDisconnect(e){this._verifyingState===E.Unset&&window.queueMicrotask(()=>{this._verifyingState===e&&(this._verifyingState===E.Connect?this._verifiedConnect():this._verifiedDisconnect()),this._verifyingState=E.Unset}),this._verifyingState=e}_verifiedConnect(){if(this._state.isComplete())this._reconnectSlots();else if(this._state.startCreationCycle(),this._state.isCreating()){const e=()=>{this._element[o.CHILD_BINDING_PROVIDER]="preact";let e=this._state.getSlotMap();if(e)this._reconnectSlots();else{e=this._state.getSlotMap(!0);const t=this._removeAndConvertSlotsToProps(e);Object.assign(this._props,t)}this._render()};this._state.setCreateCallback(e),this._state.setBindingsDisposedCallback(()=>this._handleBindingsDisposed())}}_verifiedDisconnect(){this._state.isComplete()?(this._disconnectSlots(),this._state.resetCreationCycle(),s.render(null,this._element),this._applyRef(this._oldRootRef,null),this._oldRootRef=void 0,this._vdom=null):this._state.pauseCreationCycle()}_initializePropsFromDom(){const e=this._element.attributes;for(let t=0;t<e.length;t++){const{name:s,value:n}=e[t],[o,r,i]=this._getPropValuePair(s,n);o&&(this._verifyProps(o,r,i),this._updateProps(o.split("."),r))}}_playbackEarlyPropertySets(){for(;this._earlySets.length;){const e=this._earlySets.shift();this.setProperty(e.property,e.value)}}_patchRootElement(e){var t;const s=this._oldRootProps||this._getInitialRootProps(),n=e.props;!function(e,t,s,n,o,r){let i;for(i in s)"children"===i||"key"===i||i in t||r(e,i,null,s[i],n)||_(e,i,null,s[i],n);for(i in t)o&&"function"!=typeof t[i]||"children"===i||"key"===i||"value"===i||"checked"===i||s[i]===t[i]||r(e,i,t[i],s[i],n)||_(e,i,t[i],s[i],n)}(this._element,n,s,!1,!1,C._setPropertyOverrides);const o=e.ref;this._oldRootRef!==o&&(this._applyRef(o,this._element),o&&(null===(t=this._oldRootRef)||void 0===t||t.call(this,null))),this._oldRootProps=n,this._oldRootRef=o}_applyRef(e,t){e&&("function"==typeof e?e(t):e.current=t)}static _setPropertyOverrides(e,t,s,n){if("style"===t&&"string"==typeof s)throw new Error("CSS style must be an object. CSS text is not supported");if("class"===t||"className"===t){const t=null==n?g:o.CustomElementUtils.getClassSet(n),r=null==s?g:o.CustomElementUtils.getClassSet(s);for(const s of t.values())r.has(s)||e.classList.remove(s);for(const s of r.values())t.has(s)||e.classList.add(s);return!0}if("o"===t[0]&&"n"===t[1]){const o=t!==(t=t.replace(/Capture$/,"")),r=t.toLowerCase();r in e&&(t=r),t=t.slice(2),C._getRootListeners(e,o)[t]=s;const i=o?C._eventProxyCapture:C._eventProxy;return s?n||e.addEventListener(t,i,o):e.removeEventListener(t,i,o),!0}return!1}static _getRootListeners(e,t){const s=t?b:P;let n=e[s];return n||(n=e[s]={}),n}_getInitialRootProps(){const e={};for(const t of this._controlledProps.values())t in this._props&&(e[t]=this._props[t]);return e}_removeAndConvertSlotsToProps(e){var t,s;const o=null===(t=this._metadata.extension)||void 0===t?void 0:t._DYNAMIC_SLOT,r=null==o?void 0:o.prop,i=null===(s=this._metadata)||void 0===s?void 0:s.slots,l=Object.keys(e),a={};if(l.length>0&&l.forEach(t=>{const s=e[t];s.forEach(e=>{c.parkNode(e)});const l=n.getPropertyMetadata(t,i);if(l){const e=!!(null==l?void 0:l.data),n=e||""!==t?t:"children";this._assignSlotProperty(a,n,void 0,t,e,s)}else{if(!r)return;a[r]||(a[r]={});const e=o.isTemplate;this._assignSlotProperty(a,t,r,t,e,s)}}),"knockout"===this._state.getBindingProviderType()){let e;for(;e=this._element.firstChild;)this._state.getBindingProviderCleanNode()(e),e.remove()}return a}_assignSlotProperty(e,t,s,n,r,i){var l,a;const c=s?e[s]:e;if(r){if("TEMPLATE"!==(null===(l=i[0])||void 0===l?void 0:l.nodeName))throw new o.JetElementError(this._element,`Slot content for template slot ${n} must be a template element.`);{const e=i[0];c[t]=null!==(a=e.render)&&void 0!==a?a:this._getSlotRenderer(e,t,s)}}else{const e=i.map((e,t)=>p(e,n,t,C._handleSlotMount,this._handleSlotUnmount.bind(this)));c[t]=e}}_getSlotRenderer(e,t,s){const n=this._state.getBindingProvider(),r=n?()=>{(s?this._props[s]:this._props)[t]=this._getSlotRenderer(e,t,s),this._queueRender(!0)}:null;return t=>{const s=this._state.getTemplateEngine();if(!s)throw new o.JetElementError(this._element,"Unexpected call to render a template slot");return s.execute(this._element,e,t,n,r)}}_handleBindingsDisposed(){c.disposeNodes(this._state.getSlotMap(),this._state.getBindingProviderCleanNode()),this._state.disposeTemplateCache()}_disconnectSlots(){c.disconnectNodes(this._state.getSlotMap())}_reconnectSlots(){c.reconnectNodes(this._state.getSlotMap())}_handleSlotUnmount(e){this._state.isComplete()&&c.parkNode(e)}static _handleSlotMount(e){r.Components&&r.Components.subtreeShown(e)}static _eventProxy(e){this[P][e.type](s.options.event?s.options.event(e):e)}static _eventProxyCapture(e){this[b][e.type](s.options.event?s.options.event(e):e)}_initializeActionCallbacks(e){Object.keys(e).forEach(t=>{const s=e[t],n=o.AttributeUtils.eventTypeToEventListenerProperty(t);this._props[n]=e=>{const n=Object.assign({},e),o=!!s.cancelable,r=[];o&&(n.accept=e=>{r.push(e)});const i={detail:n,bubbles:!!s.bubbles,cancelable:o},l=new CustomEvent(t,i),a=this._queueFireEventsTask(l);if(o)return a.then(()=>l.defaultPrevented?Promise.reject():Promise.all(r).then(()=>Promise.resolve(),e=>Promise.reject(e)))}})}_initializeWritebackCallbacks(e){e.forEach(e=>{var t;const s=o.AttributeUtils.propertyNameToChangedCallback(e),r=n.getPropertyMetadata(e,null===(t=this._metadata)||void 0===t?void 0:t.properties);this._props[s]=t=>{this._updatePropsAndQueueRenderAsNeeded(e,t,r,!1)}})}}var E;!function(e){e[e.Connect=0]="Connect",e[e.Disconnect=1]="Disconnect",e[e.Unset=2]="Unset"}(E||(E={}));const S=new class{constructor(){this.appendChildHelper=(e,t)=>HTMLElement.prototype.appendChild.call(e,t),this.insertBeforeHelper=(e,t,s)=>HTMLElement.prototype.insertBefore.call(e,t,s)}connectedCallback(){}disconnectedCallback(){}attributeChangedCallback(e,t,s){}getProperty(e){}setProperty(e,t){}setProperties(e){}},T=l.traceDispatchEvent(HTMLElement.prototype.dispatchEvent);class O extends HTMLElement{constructor(){super(...arguments),this.dispatchEvent=T}static get observedAttributes(){let e=[];return this.metadata.properties&&(e=e.concat(n.getFlattenedAttributes(this.metadata.properties))),this.rootObservedAttributes&&(e=e.concat(this.rootObservedAttributes)),e}connectedCallback(){this._getHelper().connectedCallback()}disconnectedCallback(){var e;null===(e=this._helper)||void 0===e||e.disconnectedCallback()}attributeChangedCallback(e,t,s){var n;null===(n=this._helper)||void 0===n||n.attributeChangedCallback(e,t,s)}getProperty(e){return this._getHelper().getProperty(e)}setProperty(e,t){this._getHelper().setProperty(e,t)}setProperties(e){this._getHelper().setProperties(e)}appendChild(e){return this._getHelper().appendChildHelper(this,e)}insertBefore(e,t){return this._getHelper().insertBeforeHelper(this,e,t)}setAttribute(e,t){if("class"===e){const e=o.CustomElementUtils.getClassSet(t);o.CustomElementUtils.getElementState(this).setOuterClasses(e)}else HTMLElement.prototype.setAttribute.call(this,e,t)}removeAttribute(e){"class"===e?this.setAttribute("class",""):HTMLElement.prototype.removeAttribute.call(this,e)}_getHelper(){return this._helper||(this.hasAttribute("data-oj-jsx")?(this.removeAttribute("data-oj-jsx"),this.classList.add("oj-complete"),this._helper=S):this._helper=new C(this,this.constructor.component,this.constructor.metadata,this.constructor.rootObservedAttributes,this.constructor.rootObservedProperties,this.constructor.defaultProps)),this._helper}}class k extends o.ElementState{getTemplateEngine(){return k._cachedTemplateEngine}getTrackChildrenOption(){return"immediate"}allowPropertyChangedEvents(){return super.allowPropertyChangedEvents()&&(e=>{var t;const s=e._getHelper();return!!(null===(t=s.isInitialized)||void 0===t?void 0:t.call(s))})(this.Element)}disposeTemplateCache(){var e;const t=this.getSlotMap(),s=Object.keys(t),r=o.CustomElementUtils.getElementDescriptor(this.Element.tagName).metadata,i=null===(e=null==r?void 0:r.extension)||void 0===e?void 0:e._DYNAMIC_SLOT,l=!!(null==i?void 0:i.isTemplate);s.filter(e=>{const t=n.getPropertyMetadata(e,null==r?void 0:r.slots);if(t){if(t.data)return!0}else if(l)return!0;return!1}).forEach(e=>{var s;const n=t[e];"TEMPLATE"===(null===(s=n[0])||void 0===s?void 0:s.nodeName)&&this.getTemplateEngine().cleanupTemplateCache(n[0])})}GetPreCreatedPromise(){const e=super.GetPreCreatedPromise();return!k._cachedTemplateEngine&&this._hasDirectTemplateChildren()?e.then(()=>this._getTemplateEnginePromise()):e}IsTransferAttribute(e){return this.Element.constructor.rootObservedAttrSet.has(e)}GetDescriptiveTransferAttributeValue(e){return((e,t)=>{var s;const n=e.getAttribute(t);if(n)return n;const o=e._getHelper();return((null===(s=o.getProps)||void 0===s?void 0:s.call(o))||{})[t]})(this.Element,e)}_getTemplateEnginePromise(){return new Promise(function(t,s){e(["ojs/ojvcomponent-template"],function(e){t(function(e){if(e&&e.__esModule)return e;var t={};return e&&Object.keys(e).forEach(function(s){var n=Object.getOwnPropertyDescriptor(e,s);Object.defineProperty(t,s,n.get?n:{enumerable:!0,get:function(){return e[s]}})}),t.default=e,t}(e))},s)}).then(e=>{k._cachedTemplateEngine=e})}_hasDirectTemplateChildren(){const e=this.Element.childNodes;for(let t=0;t<e.length;t++){if("template"===e[t].localName)return!0}return!1}}const w=()=>{throw new Error("The Root component should only be used as the top-level return from a VComponent render function.  It will be rewritten by VComponent code so Preact will never actually render it unless it appears in an invalid location.")};function A(e,t){return"className"===e||o.AttributeUtils.isGlobalOrData(e)||function(e,t){var s,n;if(null===(s=null==t?void 0:t.properties)||void 0===s?void 0:s[e])return!1;const o=e.match(R);if(o){const e=o[1].toLowerCase()+o[2];return!(null===(n=null==t?void 0:t.events)||void 0===n?void 0:n[e])}return!1}(e,t)}const R=/^on(?!.*Changed$)([A-Za-z])([A-Za-z]*)$/;"undefined"!=typeof window&&(HTMLTemplateElement.prototype.hasOwnProperty("render")||Object.defineProperty(HTMLTemplateElement.prototype,"render",{value:null,writable:!0}));const j=o.ElementUtils.getUniqueId.bind(null,null);t.Root=w,t.customElement=function(e){return function(t){var r;const i=t.metadata,l=(null===(r=null==i?void 0:i.extension)||void 0===r?void 0:r._OBSERVED_GLOBAL_PROPS)||[],a=l.map(e=>o.AttributeUtils.getGlobalAttrForProp(e));!function(e,t,n,r){const i=t.prototype.render;t.prototype.render=function(t,l,a){var c;const p=null===(c=null==n?void 0:n.extension)||void 0===c?void 0:c._READ_ONLY_PROPS;p&&p.forEach(e=>delete t[e]);const d=t[f],h=!!d;h&&o.CustomElementUtils.getElementState(d).disposeTemplateCache();let u=i.call(this,t,l,a);if(u.type===w&&(u=s.cloneElement(u),u.type=e),u.type!==e){const r={};return h?u:(r.ref=function(e){e&&(e[o.CustomElementUtils.VCOMP_INSTANCE]={props:t})},r["data-oj-jsx"]="",Object.keys(t).forEach(e=>{A(e,n)&&(r[e]=t[e])}),s.h(e,r,u))}if(!h){const e=u.props;t.style&&e.style&&(e.style=Object.assign({},t.style,e.style));const s=t.className||t.class;if(s){const t="className"in e?"className":"class",n=e[t]||"";e[t]=`${s} ${n}`}return e["data-oj-jsx"]="",Object.keys(t).forEach(s=>{s in e||r.has(s)||!A(s,n)||(e[s]=t[s])}),u}return t[y](u),s.h(s.Fragment,{},u.props.children)}}(e,t,i,new Set(l)),function(e,t,s,r,i){class l extends O{}l.metadata=t||{},l.component=s,l.rootObservedAttributes=i,l.rootObservedAttrSet=new Set(i),l.rootObservedProperties=r,l.defaultProps=s.defaultProps?n.deepFreeze(s.defaultProps):null,function(e,t){if(!t)return;for(let s in t)Object.defineProperty(e,s,{get(){return this.getProperty(s)},set(e){this.setProperty(s,e)}})}(l.prototype,null==t?void 0:t.properties),function(e,t){if(!t)return;for(let s in t)e[s]=function(){if(this._helper===S)throw new o.JetElementError(this,"Cannot access element methods when rendered as a value based element.");const e=this._helper.ref.current;if(!e)throw new o.JetElementError(this,"Cannot access methods before element is upgraded.");return e[s].apply(e,arguments)}}(l.prototype,null==t?void 0:t.methods),o.CustomElementUtils.registerElement(e,{descriptor:{metadata:t},stateClass:k,vcomp:!0},l)}(e,i,t,l,a)}},t.getUniqueId=j,t.method=function(e,t,s){},Object.defineProperty(t,"__esModule",{value:!0})});
//# sourceMappingURL=ojvcomponent.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojjquery-hammer',["ojs/ojlogger","hammerjs","jquery"],function(e,t,a){"use strict";var r;a=a&&Object.prototype.hasOwnProperty.call(a,"default")?a.default:a,t?(a.fn.ojHammer=function(e){switch(e){case"instance":return this.data("ojHammer");case"destroy":return this.each(function(){var e=a(this),t=e.data("ojHammer");t&&(t.destroy(),e.removeData("ojHammer"))});default:return this.each(function(){var r=a(this);r.data("ojHammer")||r.data("ojHammer",new t.Manager(r[0],e))})}},t.Manager.prototype.emit=(r=t.Manager.prototype.emit,function(e,t){r.call(this,e,t),a(this.element).trigger({type:e,gesture:t})})):e.warn("Hammer jQuery extension loaded without Hammer.")});
//# sourceMappingURL=ojjquery-hammer.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojpopupcore',["exports","ojs/ojcore-base","jquery","ojs/ojcomponentcore","ojs/ojlogger","ojs/ojdomutils","ojs/ojpreact-patch","jqueryui-amd/position","ojs/ojcontext","preact"],function(e,t,o,i,r,n,s,a,l,p){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,o=o&&Object.prototype.hasOwnProperty.call(o,"default")?o.default:o,l=l&&Object.prototype.hasOwnProperty.call(l,"default")?l.default:l;const c=function(e){this._tapCallback=e,this.Init()};t._registerLegacyNamespaceProp("SimpleTapRecognizer",c),t.Object.createSubclass(c,t.Object,"oj.SimpleTapRecognizer"),c.prototype.Init=function(){c.superclass.Init.call(this);var e=this._eventHandler.bind(this);this._eventHandlerCallback=e;for(var t,o=document.documentElement,i=0;i<c._TOUCHEVENTS.length;i++)"touchstart"===(t=c._TOUCHEVENTS[i])||"touchmove"===t?o.addEventListener(t,e,{passive:!1,capture:!0}):o.addEventListener(t,e,!0)},c.prototype._eventHandler=function(e){var t=this._tapCallback,o=e.type;if("touchstart"===o)this._touchStartEvent=e,this._touchStartEvent._tapStart=(new Date).getTime();else if("touchmove"===o||"touchcancel"===o)this._touchStartEvent=null;else if("touchend"===o){if(this._touchStartEvent){var i=this._touchStartEvent._tapStart;if(isNaN(i))t(this._touchStartEvent);else(new Date).getTime()-i<c._PRESSHOLDTHRESSHOLD&&t(this._touchStartEvent)}this._touchStartEvent=null}},c.prototype.destroy=function(){this._tapCallback=null;var e=this._eventHandlerCallback;this._eventHandlerCallback=null;for(var t,o=document.documentElement,i=0;i<c._TOUCHEVENTS.length;i++)"touchstart"===(t=c._TOUCHEVENTS[i])||"touchmove"===t?o.removeEventListener(t,e,{passive:!1,capture:!0}):o.removeEventListener(t,e,!0)},c._TOUCHEVENTS=["touchstart","touchmove","touchcancel","touchend"],c._PRESSHOLDTHRESSHOLD=700;const u=function(){this.Init()};t._registerLegacyNamespaceProp("PopupService",u),t.Object.createSubclass(u,t.Object,"oj.PopupService");const _=function(){this.Init()},E={};u.prototype.Init=function(){u.superclass.Init.call(this)},u.getInstance=function(e){return u._popupService||(u._popupService=new _),u._popupService},u.prototype.open=function(e){t.Assert.failedInAbstractFunction()},u.prototype.close=function(e){t.Assert.failedInAbstractFunction()},u.prototype.changeOptions=function(e){t.Assert.failedInAbstractFunction()},u.prototype.triggerOnDescendents=function(e,o,i){t.Assert.failedInAbstractFunction()},u.prototype.destroy=function(){u._popupService=null},u.MODALITY={NONE:"none",MODAL:"modal",MODELESS:"modeless"},u.EVENT={POPUP_REMOVE:"ojPopupRemove",POPUP_CLOSE:"ojPopupClose",POPUP_REFRESH:"ojPopupRefresh",POPUP_AUTODISMISS:"ojPopupAutoDismiss",POPUP_BEFORE_OPEN:"ojPopupBeforeOpen",POPUP_AFTER_OPEN:"ojPopupAfterOpen",POPUP_BEFORE_CLOSE:"ojPopupBeforeClose",POPUP_AFTER_CLOSE:"ojPopupAfterClose"},u.LAYER_LEVEL={TOP_LEVEL:"topLevel",NEAREST_ANCESTOR:"nearestAncestor"},u.OPTION={POPUP:"popup",EVENTS:"events",MODALITY:"modality",LAUNCHER:"launcher",POSITION:"position",LAYER_SELECTORS:"layerSelectors",LAYER_LEVEL:"layerLevel",CONTEXT:"context",CUSTOM_ELEMENT:"customElement"},t.__registerWidget("oj.ojSurrogate",o.oj.baseComponent,{version:"1.0.0",widgetEventPrefix:"oj",options:{beforeDestroy:null},_ComponentCreate:function(){this._super(),this.element.uniqueId()},_invokeBeforeDestroy:function(){var e=this.options.beforeDestroy;this.options.beforeDestroy=null,e&&e()},_destroy:function(){this._invokeBeforeDestroy(),this.element.removeUniqueId(),this._super()},_NotifyDetached:function(){this._invokeBeforeDestroy(),this._super()}});t.CustomElementBridge.register("oj-surrogate",{metadata:{properties:{beforeDestroy:{type:"function"}},extension:{_WIDGET_NAME:"ojSurrogate"}}}),t._registerLegacyNamespaceProp("PopupServiceImpl",_),t.Object.createSubclass(_,u,"oj.PopupServiceImpl"),_.prototype.open=function(e){t.Assert.assertObject(e);var s=e[u.OPTION.POPUP];t.Assert.assertPrototype(s,o);var a=E.getStatus(s);if(a===E.STATUS.UNKNOWN||a===E.STATUS.BEFORE_OPEN||a===E.STATUS.CLOSE){var l=e[u.OPTION.LAUNCHER];t.Assert.assertPrototype(l,o);var p=e[u.OPTION.POSITION];t.Assert.assertObjectOrNull(p);var c=e[u.OPTION.EVENTS];t.Assert.assertObject(c);var f=e[u.OPTION.MODALITY];(!f||u.MODALITY.MODELESS!==f&&u.MODALITY.MODAL!==f)&&(f=u.MODALITY.NONE);var h=e[u.OPTION.LAYER_SELECTORS];t.Assert.assertString(h);var d=e[u.OPTION.CUSTOM_ELEMENT],T=e[u.OPTION.LAYER_LEVEL];(!T||u.LAYER_LEVEL.TOP_LEVEL!==T&&u.LAYER_LEVEL.NEAREST_ANCESTOR!==T)&&(T=u.LAYER_LEVEL.NEAREST_ANCESTOR);var v=c[u.EVENT.POPUP_BEFORE_OPEN];v&&o.isFunction(v)||(v=_._defaultBeforeOpenCallback);var O=c[u.EVENT.POPUP_AFTER_OPEN];E.setStatus(s,E.STATUS.OPENING),n.setLogicalParent(s,l),E.addToAncestorLayer(s,l,f,h,T,d);var g,S=function(){try{s.removeAttr("aria-hidden"),this._assertEventSink(),i.subtreeShown(s[0])}catch(e){r.error("Error opening popup:\n%o",e)}finally{E.setStatus(s,E.STATUS.OPEN),O&&O(e);var n=E.getFirstAncestorLayer(s);if(t.Assert.assertPrototype(n,o),E.applyEvents(n,c),!E._getSurrogate(n)&&o.isFunction(c[u.EVENT.POPUP_REMOVE]))(0,c[u.EVENT.POPUP_REMOVE])()}};S=S.bind(this);try{g=v(e)}catch(e){r.error("Error before open popup:\n%o",e)}finally{g&&g instanceof Promise?g.then(S):S()}}else this._assertEventSink()},_._defaultBeforeOpenCallback=function(e){var i=e[u.OPTION.POPUP];t.Assert.assertPrototype(i,o);var r=e[u.OPTION.POSITION];i.show(),r&&i.position(r)},_.prototype.close=function(e){t.Assert.assertObject(e);var s=e[u.OPTION.POPUP];t.Assert.assertPrototype(s,o);var a=E.getOpenPopupLayer(s);t.Assert.assertPrototype(a,o);var l=e[u.OPTION.EVENTS];l?l=o.extend(E.getEvents(a),l):(l=E.getEvents(a),e[u.OPTION.EVENTS]=l);var p=E.getStatus(s);if(p!==E.STATUS.OPEN&&p!==E.STATUS.BEFORE_CLOSE||!l)this._assertEventSink();else{var c=l[u.EVENT.POPUP_BEFORE_CLOSE];c&&o.isFunction(c)||(c=_._defaultBeforeCloseCallback);var f=l[u.EVENT.POPUP_AFTER_CLOSE];E.setStatus(s,E.STATUS.CLOSING),E.applyEvents(a,{}),s.attr("aria-hidden","true");var h,d=function(){try{s.hide(),s.css({top:"auto",bottom:"auto",left:"auto",right:"auto"}),E.removeFromAncestorLayer(s),n.setLogicalParent(s,null),this._assertEventSink(),i.subtreeHidden(s[0])}catch(e){r.error("Error closing popup:\n%o",e)}finally{E.setStatus(s,E.STATUS.CLOSE),f&&o.isFunction(f)&&f(e)}};d=d.bind(this);try{h=c(e)}catch(e){r.error("Error before close popup:\n%o",e)}finally{h&&h instanceof Promise?h.then(d):d()}}},_._defaultBeforeCloseCallback=function(e){var i=e[u.OPTION.POPUP];t.Assert.assertPrototype(i,o),i.hide()},_.prototype.changeOptions=function(e){t.Assert.assertObject(e);var i=e[u.OPTION.POPUP];if(t.Assert.assertPrototype(i,o),E.getStatus(i)===E.STATUS.OPEN){var r=E.getOpenPopupLayer(i);t.Assert.assertPrototype(r,o);var n=e[u.OPTION.EVENTS];n&&E.applyEvents(r,n);var s=e[u.OPTION.MODALITY];s&&E.applyModality(r,s);var a=e[u.OPTION.LAYER_SELECTORS];t.StringUtils.isEmptyOrUndefined(a)||r.attr("class",a)}},_.prototype.triggerOnDescendents=function(e,t,o){if(E.isPopupOpen(e)){var i={};i.event=t,i.argsArray=o;var r=E.getFirstAncestorLayer(e);E.postOrderVisit(r,this._triggerOnDescendentsVisitCallback,i)}},_.prototype._triggerOnDescendentsVisitCallback=function(e,t){var i=t.event,r=t.argsArray,n=E.getEvents(e);return n&&o.isFunction(n[i])&&n[i].apply(this,r),E.VISIT_RESULT.ACCEPT},_.prototype._assertEventSink=function(){var e,t,o,i=E.hasPopupsOpen(),r=this._callbackEventFilter;if(!i&&r){for(window.removeEventListener("resize",_._refreshCallback,!0),window.removeEventListener("scroll",_._refreshCallback,!0),(t=document.documentElement).removeEventListener("mousewheel",_._refreshCallback,{passive:!0,capture:!0}),t.removeEventListener("DOMMouseScroll",_._refreshCallback,!0),this._callbackEventFilter=null,e=0;e<_._REDISTRIBUTE_EVENTS.length;e++)o=_._REDISTRIBUTE_EVENTS[e],t.removeEventListener(o,r,!0);var s=this._simpleTapRecognizer;s&&(s.destroy(),this._simpleTapRecognizer=null)}else if(i&&!r){for(window.addEventListener("resize",_._refreshCallback,!0),window.addEventListener("scroll",_._refreshCallback,!0),(t=document.documentElement).addEventListener("mousewheel",_._refreshCallback,{passive:!0,capture:!0}),t.addEventListener("DOMMouseScroll",_._refreshCallback,!0),r=this._eventFilterCallback.bind(this),this._callbackEventFilter=r,e=0;e<_._REDISTRIBUTE_EVENTS.length;e++)o=_._REDISTRIBUTE_EVENTS[e],t.addEventListener(o,r,!0);n.isTouchSupported()&&(this._simpleTapRecognizer=new c(r))}},_.prototype._eventFilterCallback=function(e){var t=o(e.target);if(E.hasPopupsOpen()){if(!n.isChromeEvent(e)&&("focus"!==e.type||t.is(":focusable"))){var i=E.getDefaultLayer();if("keydown"!==e.type||!E.hasModalDialogOpen()||n.isAncestor(i[0],t[0])){var r=E.getFirstAncestorLayer(t),s=i.find("."+_._FOCUS_WITHIN_SELECTOR).first();if(i[0]!==r[0]?r.hasClass(_._FOCUS_WITHIN_SELECTOR)||(s.length&&s.removeClass(_._FOCUS_WITHIN_SELECTOR),r.addClass(_._FOCUS_WITHIN_SELECTOR)):s.length&&s.removeClass(_._FOCUS_WITHIN_SELECTOR),"focus"!==e.type||"-1"!==t.attr("tabindex")){for(var a={},l=_._COPY_SAFE_EVENT_PROPERTIES,p={},c=0;c<l.length;c++){var u=l[c],f=e[u];void 0===f||o.isFunction(f)||(p[u]=f)}a.event=o.Event(e,p),E.postOrderVisit(i,_._redistributeVisitCallback,a)}}else E.eatEvent(e)}}else this._assertEventSink()},_._redistributeVisitCallback=function(e,t){var i=E.getEvents(e),r=t.event;return i&&o.isFunction(i[u.EVENT.POPUP_AUTODISMISS])&&i[u.EVENT.POPUP_AUTODISMISS](r),E.VISIT_RESULT.ACCEPT},_._refreshCallback=function(e){isNaN(_._refreshTimerId)&&(_._refreshTimerId=window.setTimeout(function(){_._refreshTimerId=Number.NaN;var e=E.getDefaultLayer();o.isFunction(window.requestAnimationFrame)?_._afRequestId=window.requestAnimationFrame(function(){_._afRequestId=null,E.postOrderVisit(e,_._refreshVisitCallback)}):E.postOrderVisit(e,_._refreshVisitCallback)},_._REFRESH_DELAY))},_._refreshVisitCallback=function(e,t){if(t.level>0)return E.VISIT_RESULT.REJECT;var i=E.getEvents(e);return i&&o.isFunction(i[u.EVENT.POPUP_REFRESH])&&i[u.EVENT.POPUP_REFRESH](),E.VISIT_RESULT.ACCEPT},_.prototype.destroy=function(){_.superclass.destroy.call(this)},_._FOCUS_WITHIN_SELECTOR="oj-focus-within",_._REDISTRIBUTE_EVENTS=["focus","mousedown","keydown"],_._COPY_SAFE_EVENT_PROPERTIES=["altKey","bubbles","cancelable","ctrlKey","currentTarget","eventPhase","metaKey","relatedTarget","shiftKey","target","timeStamp","view","which","button","buttons","clientX","clientY","offsetX","offsetY","pageX","pageY","screenX","screenY","toElement","char","charCode","key","keyCode"],_._REFRESH_DELAY=10,t._registerLegacyNamespaceProp("ZOrderUtils",E),E.STATUS={UNKNOWN:0,BEFORE_OPEN:.5,OPENING:1,OPEN:2,BEFORE_CLOSE:2.5,CLOSING:3,CLOSE:4},E._STATUS_DATA="oj-popup-status",E.getStatus=function(e){e instanceof Element&&(e=o(e));var t=e.data(E._STATUS_DATA);return isNaN(t)?E.STATUS.UNKNOWN:t},E.setStatus=function(e,t){e instanceof Element&&(e=o(e)),t>E.STATUS.UNKNOWN&&t<=E.STATUS.CLOSE&&e.data(E._STATUS_DATA,t)},E.getFirstAncestorLayer=function(e){if(!e)return E.getDefaultLayer();for(var t=e;t&&t.length>0&&t.attr(E._SURROGATE_ATTR)!==E._DEFAULT_LAYER_ID;){if(E._hasSurrogate(t[0]))return t;t=t.parent()}return E.getDefaultLayer()},E.getDefaultLayer=function(){var e=o(document.getElementById(E._DEFAULT_LAYER_ID));return e.length>0||((e=o("<div>")).attr("role","presentation"),e.attr("id",E._DEFAULT_LAYER_ID),e.prependTo(o(document.body))),e},E.addToAncestorLayer=function(e,r,n,s,a,l){var p=e[0];if(E._hasSurrogate(p.parentNode))throw new Error("JET Popup is already open - id: "+p.getAttribute("id"));var c=E.getFirstAncestorLayer(a===u.LAYER_LEVEL.TOP_LEVEL?null:r),_=o("<div>"),f=e.attr("id");t.StringUtils.isEmptyOrUndefined(f)?_.uniqueId():_.attr("id",[f,"layer"].join("_")),_.attr("role","presentation"),_.addClass(s),e.after(_);const h=E._createSurrogate(_,l);i.subtreeDetached(p),e.appendTo(_),e.data(E._LAYER_ID_DATA,_.attr("id")),_.appendTo(c),i.subtreeAttached(p),E._applyVDomPatch(h[0],p),E.applyModality(_,n)},E._applyVDomPatch=function(e,t){e[s.OJ_POPUP]=t,s.patchPopupParent(e.parentElement)},E._getSurrogate=function(e){var t=e.attr(E._SURROGATE_ATTR);if(t)return document.getElementById(t)},E.applyEvents=function(e,t,r){r||(r=o(E._getSurrogate(e))),e.data(E._EVENTS_DATA,t),r.length>0&&t&&o.isFunction(t[u.EVENT.POPUP_REMOVE])&&i.setComponentOption(r[0],"beforeDestroy",t[u.EVENT.POPUP_REMOVE])},E.getEvents=function(e){return e.data(E._EVENTS_DATA)},E._createSurrogate=function(e,i){var r="script";i&&(r="oj-surrogate");var n=o(document.createElement(r)),s=e.attr("id");t.StringUtils.isEmptyOrUndefined(s)||n.attr("id",[s,"surrogate"].join("_")),i&&n.attr("data-oj-binding-provider","none"),n.insertBefore(e),i||n.ojSurrogate();var a=n.attr("id");return e.attr(E._SURROGATE_ATTR,a),n},E._removeSurrogate=function(e){var t=e.attr(E._SURROGATE_ATTR);e.removeAttr(E._SURROGATE_ATTR);var r=o(document.getElementById(t)),n=r.length>0;return n&&(e.insertAfter(r),i.setComponentOption(r[0],"beforeDestroy",null),r.remove()),n},E.getOpenPopupLayer=function(e){var t=e.parent();if(!t||0===t.length){var i=e.data(E._LAYER_ID_DATA);t=o(document.getElementById(i))}return t},E.removeFromAncestorLayer=function(e){var t=E.getOpenPopupLayer(e);E.preOrderVisit(t,E._closeDescendantPopupsCallback),E._removeOverlayFromAncestorLayer(t),t.removeData(E._EVENTS_DATA),t.removeData(E._MODALITY_DATA),e.removeData(E._LAYER_ID_DATA);var o=e[0];i.subtreeDetached(o),E._removeSurrogate(t)&&o&&o.parentElement?(n.unwrap(e,t),i.subtreeAttached(o)):t.remove()},E._closeDescendantPopupsCallback=function(e,t){if(t.level>0)return E.VISIT_RESULT.REJECT;var i=e.data(E._EVENTS_DATA);return i&&o.isFunction(i[u.EVENT.POPUP_CLOSE])&&i[u.EVENT.POPUP_CLOSE](),E.VISIT_RESULT.ACCEPT},E.applyModality=function(e,o){var i=e.data(E._MODALITY_DATA);e.data(E._MODALITY_DATA,o),t.StringUtils.isEmptyOrUndefined(i)?u.MODALITY.MODAL===o?E._addOverlayToAncestorLayer(e):E._removeOverlayFromAncestorLayer(e):i!==o&&(o!==i&&o===u.MODALITY.MODAL?E._addOverlayToAncestorLayer(e):E._removeOverlayFromAncestorLayer(e)),o===u.MODALITY.MODAL?e.attr("aria-modal","true"):e.removeAttr("aria-modal")},E.hasModalDialogOpen=function(){for(var e=E.getDefaultLayer().children(),t=e.length-1;t>-1;t--){if(o(e[t]).hasClass(E._OVERLAY_SELECTOR))return!0}return!1},E._addOverlayToAncestorLayer=function(e){var i=o("<div>");i.addClass(E._OVERLAY_SELECTOR),i.addClass(e[0].className),i.attr("role","presentation");var r=e.attr("id");t.StringUtils.isEmptyOrUndefined(r)?i.uniqueId():i.attr("id",[r,"overlay"].join("_")),e.before(i);var n=i.attr("id");e.attr(E._OVERLAY_ATTR,n)},E._removeOverlayFromAncestorLayer=function(e){var i=e.attr(E._OVERLAY_ATTR);t.StringUtils.isEmptyOrUndefined(i)||(e.removeAttr(E._OVERLAY_ATTR),o(document.getElementById(i)).remove())},E.VISIT_RESULT={ACCEPT:0,REJECT:1,COMPLETE:2},E._VISIT_TRAVERSAL={PRE_ORDER:0,POST_ORDER:1},E.postOrderVisit=function(e,t,o){var i=o;o||(i={}),i.level=0,i.type=E._VISIT_TRAVERSAL.POST_ORDER,E._visitTree(e,t,i)},E.preOrderVisit=function(e,t,o){var i=o;o||(i={}),i.level=0,i.type=E._VISIT_TRAVERSAL.PRE_ORDER,E._visitTree(e,t,i)},E._visitTree=function(e,t,i){for(var r=i.level,n=e.children(),s=n.length-1;s>-1;s--){var a=o(n[s]);if(E._hasSurrogate(a[0])){var l;if(i.type===E._VISIT_TRAVERSAL.PRE_ORDER){if((l=t(a,i))===E.VISIT_RESULT.COMPLETE)return l;if(l===E.VISIT_RESULT.REJECT)break}if(i.level=r+1,l=E._visitTree(a,t,i),i.level=r,l===E.VISIT_RESULT.COMPLETE)return l;if(i.type===E._VISIT_TRAVERSAL.POST_ORDER){if((l=t(a,i))===E.VISIT_RESULT.COMPLETE)return l;if(l===E.VISIT_RESULT.REJECT)break}}}return E.VISIT_RESULT.ACCEPT},E._hasSurrogate=function(e){return!(!e||1!==e.nodeType||!e.hasAttribute(E._SURROGATE_ATTR))},E.hasPopupsOpen=function(){return E.getDefaultLayer().children().length>0},E.getOpenPopupCount=function(){var e={popupCount:0},t=E.getDefaultLayer();return E.preOrderVisit(t,E._openPopupCountCallback,e),e.popupCount},E._openPopupCountCallback=function(e,t){return t.popupCount+=1,E.VISIT_RESULT.ACCEPT},E.findOpenPopups=function(){var e={},t=[];e.popups=t;var i=E.getDefaultLayer();return E.preOrderVisit(i,E._openPopupsCallback,e),t=e.popups,o(t)},E._openPopupsCallback=function(e,t){return t.popups.push(e[0]),E.VISIT_RESULT.ACCEPT},E.isAboveTopModalLayer=function(e){if(!e||!E.hasPopupsOpen())return!0;var t=function(){var e={topLayer:null},t=E.getDefaultLayer();if(E.preOrderVisit(t,function(e,t){if(t.level>0)return E.VISIT_RESULT.REJECT;var i=t.topLayer;return i?E.compareStackingContexts(o(e),o(i))>0&&(t.topLayer=e):t.topLayer=e,E.VISIT_RESULT.ACCEPT},e),e.topLayer)return e.topLayer[0]}();if(!t)return!0;var i=function(e){var t={topModalPopup:null};if(e.hasAttribute(E._OVERLAY_ATTR)&&(t.topModalPopup=o(e)),E.postOrderVisit(o(e),function(e,t){return e[0].hasAttribute(E._OVERLAY_ATTR)?(t.topModalPopup=e,E.VISIT_RESULT.COMPLETE):E.VISIT_RESULT.ACCEPT},t),t.topModalPopup)return t.topModalPopup[0]}(t);return!i||(n.isAncestorOrSelf(i,e)||E.compareStackingContexts(o(i),o(e))<0)},E.compareStackingContexts=function(e,i){function r(e,t){var i,r=["absolute","relative","fixed"],s=e.parents(),a=[];for(i=s.length-1;i>-1;i--)a.push(o(s[i]));(s=a).push(e);var l=[],p=0;for(i=0;i<s.length;i++){var c=s[i],u=c.css("position"),_=n.getCSSLengthAsFloat(c.css("opacity")),E=n.getCSSLengthAsInt(c.css("z-index")),f=o.inArray(c[0],c.parent().children());o.inArray(u,r)>-1&&E>0?(l.push({weight:[p,E,f],order:[f]}),p+=1):_<1?(l.push({weight:[p,1,f],order:[f]}),p+=1):t&&l.push({weight:[0,0,f],order:[f]})}return l}function s(e,t){for(var o=Math.max(e.length,t.length),i=0;i<o;i++){var r=i<e.length?e[i]:0,n=i<t.length?t[i]:0;if(r!==n)return r<n?-1:1}return 0}t.Assert.assertPrototype(e,o),t.Assert.assertPrototype(i,o);var a,l,p=r(e,!1),c=r(i,!1),u=Math.max(p.length,c.length);for(a=0;a<u;a++)if(0!==(l=s(a<p.length?p[a].weight:[-1],a<c.length?c[a].weight:[-1])))return l;for(p=r(e,!0),c=r(i,!0),u=Math.max(p.length,c.length),a=0;a<u;a++)if(0!==(l=s(a<p.length?p[a].order:[-1],a<c.length?c[a].order:[-1])))return l;return 0},E.eatEvent=function(e){e.stopPropagation(),e.preventDefault()},E.isPopupOpen=function(e){var t=e.parent();return!(!t||1!==t.length||!E._hasSurrogate(t[0]))},E._EVENTS_DATA="oj-popup-events",E._MODALITY_DATA="oj-popup-modality",E._DEFAULT_LAYER_ID="__oj_zorder_container",E._SURROGATE_ATTR="data-oj-surrogate-id",E._LAYER_ID_DATA="oj-popup-layer-id",E._OVERLAY_ATTR="data-oj-overlayid",E._OVERLAY_SELECTOR="oj-component-overlay";const f={};t._registerLegacyNamespaceProp("PositionUtils",f),f.normalizeHorizontalAlignment=function(e,i){for(var r=o.extend({},e),n=0;n<f._ALIGN_RULE_PROPERTIES.length;n++){var s=f._ALIGN_RULE_PROPERTIES[n],a=r[s];if(a)if(t.StringUtils.isString(a))r[s]=a.replace("start",i?"right":"left").replace("end",i?"left":"right").replace("<",i?"+":"-").replace(">",i?"-":"+");else for(var l=0;l<f._SUB_ALIGN_RULE_PROPERTIES.length;l++){var p=f._SUB_ALIGN_RULE_PROPERTIES[l],c=a[p];t.StringUtils.isString(c)&&(a[p]=c.replace("start",i?"right":"left").replace("end",i?"left":"right").replace("<",i?"+":"-").replace(">",i?"-":"+"))}}return r},f.normalizePositionOf=function(e,t,o){return"event"===e?o:null==e||"launcher"===e?t:e},f._normalizeEventForPosition=function(e){o.each(["pageX","pageY"],function(t,o){if(e&&void 0===e[o]&&e.originalEvent){var i,r=e.originalEvent,n=r.type;if(i="touchstart"===n||"touchmove"===n?"touches":"touchend"===n?"changedTouches":null){var s=r[i][0];s&&(e[o]=s[o])}}})},f._ALIGN_RULE_PROPERTIES=["my","at"],f._SUB_ALIGN_RULE_PROPERTIES=["vertical","horizontal"],f.isAligningPositionClipped=function(e){if(e.target&&e.target.height>0&&e.target.width>0){var t=e.target.element;return!f.isWithinViewport(t)}return!1},f.isWithinViewport=function(e){function t(e,t){var o;if(["hidden","scroll","auto"].indexOf(t.overflowY)>-1){if(e.bottom-t.top<-1)return!1;if(o="auto"===t.overflowX&&t.scrollWidth>t.innerWidth||"scroll"===t.overflowX?n.getScrollBarWidth():0,t.bottom-o-e.top<1)return!1}return!(["hidden","scroll","auto"].indexOf(t.overflowX)>-1&&(o="auto"===t.overflowY&&t.scrollHeight>t.innerHeight||"scroll"===t.overflowY?n.getScrollBarWidth():0,e.right-(t.left+("rtl"===n.getReadingDirection()?o:0))<-1||e.left-(t.right-("ltr"===n.getReadingDirection()?o:0))>-1))}function i(e){var t=e[0];if(1===t.nodeType){var i=o.extend({},t.getBoundingClientRect());return i.overflowX=e.css("overflow-x"),i.overflowY=e.css("overflow-y"),i.innerHeight=e.innerHeight(),i.innerWidth=e.innerWidth(),i.scrollHeight=t.scrollHeight,i.scrollWidth=t.scrollWidth,i}return{height:0,width:0}}function r(e){return["fixed","absolute","relative","sticky"].indexOf(e.css("position"))>-1&&(!isNaN(parseInt(e.css("top"),10))||!isNaN(parseInt(e.css("bottom"),10))||!isNaN(parseInt(e.css("left"),10))||!isNaN(parseInt(e.css("right"),10)))}if(!e)return!1;if(o.isWindow(e[0])||r(e))return!0;for(var s,a=i(e),l=!0,p=e.parent();l&&p&&p.length>0&&"BODY"!==p[0].nodeName&&1===p[0].nodeType&&!r(p);){if("visible"!==(s=p).css("overflow-x")||"visible"!==s.css("overflow-y")){var c=i(p);c.height>0&&c.width>0&&(l=t(a,c))}p=p.parent()}return l},f._ANIMATION_TRANSFORM_ORIGIN_RULES={"right-top":"right top","right-middle":"right center","right-bottom":"right bottom","left-top":"left top","left-middle":"left center","left-bottom":"left bottom","center-top":"center top","center-middle":"center center","center-bottom":"center bottom"},f._ALIGN_MNEMONIC_DATA="oj-popup-align-mnemonic",f.captureTransformOriginAnimationEffectsOption=function(e,t){var o=[t.horizontal,t.vertical].join("-");e.data(f._ALIGN_MNEMONIC_DATA,o)},f.addTransformOriginAnimationEffectsOption=function(e,o){var i,r;t.StringUtils.isString(o)?(r=!0,i=o):(r=!1,i=JSON.stringify(o));var n=/#myPosition/g;if(i.match(n)){var s=e.data(f._ALIGN_MNEMONIC_DATA);t.StringUtils.isEmptyOrUndefined(s)&&(s="center-middle");var a=f._ANIMATION_TRANSFORM_ORIGIN_RULES[s];i=i.replace(n,a),o=r?i:JSON.parse(i)}return o},f._JQUI_MNEMONIC_GRP_REGX=/^(\w+)(\+|-)?(\d+)?/,f._VERTICAL_ENUM_TST_REGX=/^top$|^center$|^bottom$/,f._HORIZONTAL_ENUM_TST_REGX=/^start$|^left$|^center$|^end$|^right$/,f._COLLISION_ENUM_TST_REGX=/^none$|^flip$|^flipfit$|^fit$|^flipcenter$/,f._parsePositionNmnemonic=function(e,t){var o=[null,Number.NaN],i=f._JQUI_MNEMONIC_GRP_REGX.exec(e);if(i[1]&&t.test(i[1])&&(o[0]=i[1],i[2])){var r=parseInt(i[3],10);isNaN(r)||(r*="-"===i[2]?-1:1,o[1]=r)}return o},f._parseJSON=function(e){if(t.StringUtils.isString(e)&&/^{/.test(e)&&/}$/.test(e))try{return JSON.parse(e)}catch(e){}return null},f._coerceMyAtToJet=function(e,i,r,s){var a=f._parseJSON(i);a&&(i=a),(a=f._parseJSON(r))&&(r=a),s||(s={});var l,p=o.extend({},s),c={x:0,y:0};if(r&&"x"in r&&"y"in r&&(c.x=n.getCSSLengthAsInt(r.x),c.y=n.getCSSLengthAsInt(r.y)),t.StringUtils.isString(i)){var u=i.split(/\s/);u.length>0&&!t.StringUtils.isEmpty(u[0])&&(l=f._parsePositionNmnemonic(u[0],f._HORIZONTAL_ENUM_TST_REGX))[0]&&(p.horizontal=l[0],isNaN(l[1])||(c.x=l[1])),u.length>1&&!t.StringUtils.isEmpty(u[1])&&(l=f._parsePositionNmnemonic(u[1],f._VERTICAL_ENUM_TST_REGX))[0]&&(p.vertical=l[0],isNaN(l[1])||(c.y=l[1]))}else i&&("horizontal"in i&&(l=f._parsePositionNmnemonic(i.horizontal,f._HORIZONTAL_ENUM_TST_REGX))[0]&&(p.horizontal=l[0],isNaN(l[1])||(c.x=l[1])),"vertical"in i&&(l=f._parsePositionNmnemonic(i.vertical,f._VERTICAL_ENUM_TST_REGX))[0]&&(p.vertical=l[0],isNaN(l[1])||(c.y=l[1])));var _={};return _[e]=p,_.offset=c,_},f._coerceCollisionToJet=function(e,t){var o=t;return f._COLLISION_ENUM_TST_REGX.test(e)&&(o=e),{collision:o}},f._coerceOfToJet=function(e,i){var r=f._parseJSON(e);r&&(e=r);var s=i;if(t.StringUtils.isString(e))s=e;else if(o.isWindow(e))s="window";else if(e instanceof Element||e instanceof o){(e=o(e)).uniqueId(),s="#"+function(e){for(var t=[],o=/\w|_|-/,i=0;i<e.length;i++){var r=e.substring(i,i+1);o.test(r)?t.push(r):t.push("\\"+r)}return t.join("")}(e.attr("id"))}else e instanceof Event||e instanceof o.Event?("pageX"in e||"pageY"in e)&&((s={}).x=n.getCSSLengthAsFloat(e.pageX),s.y=n.getCSSLengthAsFloat(e.pageY)):e&&("x"in e||"y"in e)&&((s={}).x=n.getCSSLengthAsFloat(e.x),s.y=n.getCSSLengthAsFloat(e.y));return{of:s}},f.coerceToJet=function(e,t){e||(e={});var i=f._parseJSON(e);i&&(e=i),t||(t={});var r=t.my,n=t.at,s=t.collision,a=t.of,l=f._coerceMyAtToJet("my",e.my,e.offset,r),p=f._coerceMyAtToJet("at",e.at,null,n),c={offset:{x:l.offset.x+p.offset.x,y:l.offset.y+p.offset.y}};return delete l.offset,delete p.offset,o.extend({},l,p,c,f._coerceCollisionToJet(e.collision,s),f._coerceOfToJet(e.of,a),function(e,t){return{using:o.isFunction(e)?e:t}}(e.using,void 0))},f.coerceToJqUi=function(e){function i(t,o){var i=[];if(e[t][o]?i.push(e[t][o]):i.push("center"),"my"===t&&e.offset){var r="horizontal"===o?"x":"y",n=e.offset[r];isNaN(n)||0===n||(i.push(n>0?"+":""),i.push(Math.floor(n).toString()))}return i.join("")}var r={};["my","at"].forEach(function(t){if(e[t]){var o=[];o.push(i(t,"horizontal")),o.push(" "),o.push(i(t,"vertical")),r[t]=o.join("")}});var n=e.of;if(t.StringUtils.isString(n))r.of="window"===n?window:n;else if(n&&!t.StringUtils.isString(n)&&"x"in n&&"y"in n){var s=n.x,a=n.y,l=document.createEvent("MouseEvents");l.initMouseEvent("click",!0,!0,window,1,s,a,s,a,!1,!1,!1,!1,0,null),r.of=o.Event(l,{pageX:s,pageY:a})}else r.of=n;return e.collision&&(r.collision=e.collision),e.using&&(r.using=e.using),r},f.calcAvailablePopupSize=function(e,t,i){var r,s,a,l,p=o.position.getWithinInfo(i||window),c=o.position.getScrollInfo(p),u="rtl"===n.getReadingDirection(),_=u?c.width:0,E=u?0:c.width,f=t.element,h=t.target,d=p.isWindow?p.scrollLeft:0,T=p.isWindow?p.scrollTop:0,v=f.left,O=f.left+f.width,g=f.top,S=f.top+f.height,P=h.left,A=h.left+h.width,m=h.top,y=h.top+h.height,R=p.offset.left+d+_,L=p.offset.left+p.width+d-E,I=p.offset.top+T,N=p.offset.top+p.height+T-c.height;return v<P?(r=R,s=O<=P?P:O<=A?Math.min(A,L):L):v===P?P-R>L-A?(r=R,s=A):(r=P,s=L):v<A?(r=P,s=O<=A?A:L):(r=A,s=L),g<m?(a=I,l=S<=m?m:S<=y?Math.min(y,N):N):g===m?(a=m,l=N):g<y?(a=m,l=S<=y?y:N):(a=y,l=N),{width:s-r,height:l-a}},o.ui.position.flipcenter={left:function(e,t){var i=e.left;o.ui.position.flip.left.call(this,e,t);var r=t.within,s=r.isWindow?r.scrollLeft:r.offset.left,a=r.width,l=e.left-t.collisionPosition.marginLeft,p=s-l,c=l+t.collisionWidth-a-s;(p>0||c>0)&&("right"===t.at[0]?i-=t.targetWidth/2:"left"===t.at[0]&&(i+=t.targetWidth/2),i-=("rtl"===n.getReadingDirection()?-1:1)*(t.elemWidth/2),e.left=Math.max(0,i))},top:function(e,t){var i=e.top;o.ui.position.flip.top.call(this,e,t);var r=t.within,n=r.isWindow?r.scrollTop:r.offset.top,s=t.within.height,a=e.top-t.collisionPosition.marginTop,l=n-a,p=a+t.collisionHeight-s-n;(l>0||p>0)&&("top"===t.at[1]?i+=t.targetHeight/2:"bottom"===t.at[1]&&(i-=t.targetHeight/2),i+=t.elemHeight/2,e.top=Math.max(0,i))}};var h,d=o.ui.position.flip.left;o.ui.position.flip={left:d.bind(null),top:function(e,t){var o,i,r=t.within,n=r.offset.top+r.scrollTop,s=r.height,a=r.isWindow?r.scrollTop:r.offset.top,l=e.top-t.collisionPosition.marginTop,p=l-a,c=l+t.collisionHeight-s-a;o="top"===t.my[1]?-t.elemHeight:"bottom"===t.my[1]?t.elemHeight:0,i="top"===t.at[1]?t.targetHeight:"bottom"===t.at[1]?-t.targetHeight:0;var u,_,E=-2*t.offset[1];p<0?((u=e.top+o+i+E+t.collisionHeight-s-n)<0||u<Math.abs(p))&&c<0&&p>c&&(e.top+=o+i+E):c>0&&((_=e.top-t.collisionPosition.marginTop+o+i+E-a)>0||Math.abs(_)<c)&&(e.top+=o+i+E)}},o.ui.position.fit={left:function(e,t){var o,i=t.within,r=i.isWindow?i.scrollLeft:i.offset.left,n=i.width,s=e.left-t.collisionPosition.marginLeft,a=r-s,l=s+t.collisionWidth-n-r;t.collisionWidth>n?a>0&&l<=0?(o=e.left+a+t.collisionWidth-n-r,e.left+=a-o):e.left=l>0&&a<=0?r:a>l?r+n-t.collisionWidth:r:a>0?e.left+=a:l>0?e.left-=l:e.left=Math.max(e.left-s,e.left),e.left<0&&(e.left=0)},top:function(e,t){var o,i=t.within,r=i.isWindow?i.scrollTop:i.offset.top,n=t.within.height,s=e.top-t.collisionPosition.marginTop,a=r-s,l=s+t.collisionHeight-n-r;t.collisionHeight>n?a>0&&l<=0?(o=e.top+a+t.collisionHeight-n-r,e.top+=a-o):e.top=l>0&&a<=0?r:a>l?r+n-t.collisionHeight:r:a>0?e.top+=a:l>0?e.top-=l:e.top=Math.max(e.top-s,e.top),e.top<0&&(e.top=0)}};var T=o.position.getWithinInfo;o.position={getWithinInfo:T.bind(null),scrollbarWidth:function(){if(void 0!==h)return h;var e,t,i=document.createElement("div");i.style.display="block",i.style.position="absolute",i.style.width="50px",i.style.height="50px",i.style.overflow="hidden";var r=document.createElement("div");return r.style.height="100px",r.style.width="auto",i.appendChild(r),o("body").append(o(i)),e=r.offsetWidth,i.style.overflow="scroll",e===(t=r.offsetWidth)&&(t=i.clientWidth),o(i).remove(),h=e-t},getScrollInfo:function(e){var t=e.isWindow||e.isDocument?"":e.element.css("overflow-x"),i=e.isWindow||e.isDocument?"":e.element.css("overflow-y"),r="scroll"===t||"auto"===t&&e.width<e.element[0].scrollWidth;return{width:"scroll"===i||"auto"===i&&e.height<e.element[0].scrollHeight?o.position.scrollbarWidth():0,height:r?o.position.scrollbarWidth():0}}};const v=function(){this.Init()};t._registerLegacyNamespaceProp("PopupLiveRegion",v),t.Object.createSubclass(v,t.Object,"oj.PopupLiveRegion"),v.prototype.Init=function(){v.superclass.Init.call(this),isNaN(v._refCounter)?v._refCounter=1:v._refCounter+=1},v.prototype.destroy=function(){if(!isNaN(v._refCounter)&&(v._refCounter-=1)<1){var e=o(document.getElementById(v._POPUP_LIVE_REGION_ID));e.length>0&&e.remove()}},v.prototype.announce=function(e){if(!t.StringUtils.isEmpty(e)){var i=v._getLiveRegion();i.children().remove(),setTimeout(function(){o("<div>").text(e).appendTo(i)},20)}},v._getLiveRegion=function(){var e=o(document.getElementById(v._POPUP_LIVE_REGION_ID));return 0===e.length&&((e=o("<div>")).attr({id:v._POPUP_LIVE_REGION_ID,role:"log","aria-live":"polite","aria-relevant":"additions"}),e.addClass("oj-helper-hidden-accessible"),e.appendTo(document.body)),e},v._POPUP_LIVE_REGION_ID="__oj_popup_arialiveregion";const O=function(e,i,r,n,s){t.Assert.assertPrototype(e,o),t.Assert.assertString(i),t.Assert.assertFunction(r),t.Assert.assertStringOrNull(n),this._options={insertBefore:!1,preventKeyEvents:!0},s&&(this._options=Object.assign({},this._options,s)),this._sibling=e,this._message=i,this._callback=r,this._id=n,this.Init()};t._registerLegacyNamespaceProp("PopupSkipLink",O),t.Object.createSubclass(O,t.Object,"oj.PopupSkipLink"),O.prototype.Init=function(){O.superclass.Init.call(this);var e=this._sibling,t=this._callback,i=this._message,r=this._options.insertBefore,n=this._options.preventKeyEvents;this._message=null;var s=this._id;this._id=null;var a=o(document.getElementById(s));a.length<1&&(a=o("<a>").attr({tabindex:"-1",href:"#",role:"link"})),a.attr("id",s),a.addClass("oj-helper-hidden-accessible"),a.text(i),r?a.insertBefore(e):a.insertAfter(e),a.on("click",O._activateHandler.bind(this,t)),n&&a.on("keydown keyup keypress",O._keyHandler),e.data(O._SKIPLINK_ATTR,a)},O._activateHandler=function(e,t){E.eatEvent(t),window.setImmediate(e)},O._keyHandler=function(e){e.keyCode===o.ui.keyCode.ENTER&&E.eatEvent(e)},O.prototype.destroy=function(){var e=this._sibling;if(delete this._sibling,delete this._callback,e){var t=e.data(O._SKIPLINK_ATTR);e.removeData(O._SKIPLINK_ATTR),t&&(t.off("click keydown keyup keypress"),t.remove())}},O.prototype.getLink=function(){var e,t=this._sibling;return t&&(e=t.data(O._SKIPLINK_ATTR)),e},O._SKIPLINK_ATTR="oj-skiplink";const g=function(e,t,o,i){this._element=e,this._operation=t,this._widgetName=o,this._isCustomElement=!!i,this.Init()};t._registerLegacyNamespaceProp("PopupWhenReadyMediator",g),t.Object.createSubclass(g,t.Object,"oj.PopupWhenReadyMediator"),g.prototype.Init=function(){g.superclass.Init.call(this),this._resolvedQueue=[],this._callback=this._eventHandler.bind(this);var e=this._operation,t=["oj"];this._isCustomElement?(t.push(e.charAt(0).toUpperCase()),t.push(e.slice(1))):t.push(e);var o=t.join("");this._eventType=o,this._element.on(o,this._callback);var i=l.getContext(this._element[0]).getBusyContext(),r={description:this._getBusyStateDescription.bind(this,this._element,this._operation,this._widgetName)},n=i.addBusyState(r);this.AddPromiseExecutor(n),this._whenReadyPromise=new Promise(this.AddPromiseExecutor.bind(this))},g.prototype._getBusyStateDescription=function(e,t,o){return o+" identified by '"+e.attr("id")+"' is busy animating on the '"+t+"' operation."},g.prototype._deliverResolved=function(e){var t=this._resolvedQueue;this._resolvedQueue=null;var o=e||this._operation;this._operation=null;for(var i=0;i<t.length;i++)try{t[i](o)}catch(e){r.error("Error resolving whenReady promises:\n%o",e)}this._whenReadyPromise=Promise.resolve("none")},g.prototype.destroy=function(){if(this._resolvedQueue&&this._deliverResolved("none"),this._callback){var e=this._eventType;this._element.off(e,this._callback)}this._callback=null,this._element=null,this._operation=null,this._whenReadyPromise=null,this._widgetName=null,this._eventType=null},g.prototype.getWhenReadyPromise=function(){return this._whenReadyPromise},g.prototype._eventHandler=function(e){e.target===this._element[0]&&(this._element.off(e.type,this._callback),this._deliverResolved(),this._callback=null)},g.prototype._getPendingOperation=function(){return this._operation?this._operation:"none"},g.prototype.AddPromiseExecutor=function(e,t){this._resolvedQueue&&this._resolvedQueue.push(e)},g.prototype.isOperationPending=function(e,t,o,i){var n=!1,s=this._widgetName,a=this._getPendingOperation();if(t===a)r.info("An %s instance invoked a '%s' operation while pending animation of the same type of operation.  The second request will be ignored.",s,t),n=!0;else if("none"!==a){r.info("An %s instance invoked a '%s' operation while pending animation of a '%s' operation. The second request will be invoked after the pending operation completes.",s,t,a),new Promise(this.AddPromiseExecutor.bind(this)).then(function(){this[o].apply(this,i)}.bind(e)),n=!0}return n};class S extends p.Component{constructor(){super(...arguments),this._setRootRef=e=>{this._rootRef=e}}render(e){return p.h("div",{style:{display:"none"},ref:this._setRootRef},e.children)}componentDidMount(){this._popup=o(this._rootRef.firstChild);const e={[u.OPTION.POPUP]:this._popup,[u.OPTION.EVENTS]:{[u.EVENT.POPUP_AUTODISMISS]:this.props.autoDismiss,[u.EVENT.POPUP_REFRESH]:function(){this._popup.position(this._getPosition())}.bind(this)},[u.OPTION.LAYER_SELECTORS]:this.props.layerSelectors,[u.OPTION.CUSTOM_ELEMENT]:!0,[u.OPTION.LAUNCHER]:o(this._rootRef),[u.OPTION.POSITION]:this._getPosition()};u.getInstance().open(e)}componentWillUnmount(){u.getInstance().close({[u.OPTION.POPUP]:this._popup})}componentDidUpdate(){this._popup.position(this._getPosition())}_getPosition(){return f.normalizeHorizontalAlignment(this.props.position,"rtl"===n.getReadingDirection())}}S.defaultProps={autoDismiss:null,layerSelectors:"",position:{}},e.PopupLiveRegion=v,e.PopupService=u,e.PopupSkipLink=O,e.PopupWhenReadyMediator=g,e.PositionUtils=f,e.VPopup=S,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojpopupcore.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojpopup',["ojs/ojpopupcore","ojs/ojcore-base","jquery","ojs/ojcontext","ojs/ojdomutils","ojs/ojthemeutils","ojs/ojcomponentcore","ojs/ojanimation","ojs/ojfocusutils","ojs/ojcustomelement-utils"],function(e,t,i,s,o,n,r,a,l,u){"use strict";var c;t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,i=i&&Object.prototype.hasOwnProperty.call(i,"default")?i.default:i,s=s&&Object.prototype.hasOwnProperty.call(s,"default")?s.default:s,l=l&&Object.prototype.hasOwnProperty.call(l,"default")?l.default:l,function(){var c=["oj-left","oj-center","oj-right","oj-top","oj-middle","oj-bottom"],h={"right-top":"oj-right oj-top","right-middle":"oj-right oj-middle","right-bottom":"oj-right oj-bottom","left-top":"oj-left oj-top","left-middle":"oj-left oj-middle","left-bottom":"oj-left oj-bottom","center-top":"oj-center oj-top","center-middle":"oj-left oj-middle","center-bottom":"oj-center oj-bottom"};t.__registerWidget("oj.ojPopup",i.oj.baseComponent,{widgetEventPrefix:"oj",options:{animation:null,autoDismiss:"focusLoss",chrome:"default",initialFocus:"auto",position:{my:{horizontal:"start",vertical:"top"},offset:{x:0,y:0},at:{horizontal:"start",vertical:"bottom"},of:void 0,collision:"flip"},tail:"none",modality:"modeless",role:"tooltip",beforeOpen:null,open:null,beforeClose:null,close:null,focus:null,animateStart:null,animateEnd:null},_ComponentCreate:function(){this._super();var e=this._getRootStyle(),s=this.element;s.hide().addClass(e).attr("aria-hidden","true"),s.addClass("oj-component");var o=i("<div>");o.addClass([e,"content"].join("-")),o.attr("role","presentation"),o.append(s[0].childNodes),o.appendTo(s),this._content=o,this._setChrome(),this._setupFocus(s);var n=this.options;n.position=t.PositionUtils.coerceToJet(n.position)},_AfterCreate:function(){this._super(),this.element.uniqueId(),this._createTail()},_destroy:function(){t.ZOrderUtils.getStatus(this.element)===t.ZOrderUtils.STATUS.OPEN&&this._closeImplicitly(),this._setWhenReady("none"),this._destroyTail(),delete this._popupServiceEvents;var e=this.element;e.hide().attr("aria-hidden","true").removeUniqueId();var i=this._content;delete this._content,e.append(i[0].childNodes),i.remove();var s=this._closeDelayTimer;s&&(delete this._closeDelayTimer,s()),this._super()},open:function(e,i){if(!this._isOperationPending("open",[e,i])){t.ZOrderUtils.getStatus(this.element)===t.ZOrderUtils.STATUS.OPEN&&this._closeImplicitly();var s=this.element,o=t.ZOrderUtils.getStatus(s);if(o===t.ZOrderUtils.STATUS.CLOSE||o===t.ZOrderUtils.STATUS.UNKNOWN)if(t.ZOrderUtils.setStatus(s,t.ZOrderUtils.STATUS.BEFORE_OPEN),!1!==this._trigger("beforeOpen")){this._setWhenReady("open"),this._setLauncher(e);var n=this._launcher,r=this.options;(i=i||r.position).of||(this._hasPositionOfLauncherOverride=!0,i.of=n),this._setPosition(i),this._setAutoDismiss(r.autoDismiss),this._addDescribedBy(),this._IsCustomElement()&&s[0].hasAttribute("role")||s.attr("role",r.role);var a=this._getPositionAsJqUi(),l=this._getRootStyle(),u=[l,"layer"].join("-"),c=r.tail;"none"!==c&&(u+=" "+[l,"tail",c].join("-"));var h={};h[t.PopupService.OPTION.POPUP]=s,h[t.PopupService.OPTION.LAUNCHER]=n,h[t.PopupService.OPTION.POSITION]=a,h[t.PopupService.OPTION.EVENTS]=this._getPopupServiceEvents(),h[t.PopupService.OPTION.LAYER_SELECTORS]=u,h[t.PopupService.OPTION.MODALITY]=r.modality,h[t.PopupService.OPTION.CUSTOM_ELEMENT]=this._IsCustomElement(),t.PopupService.getInstance().open(h)}else t.ZOrderUtils.setStatus(this.element,o)}},_beforeOpenHandler:function(e){var i=e[t.PopupService.OPTION.POPUP],s=e[t.PopupService.OPTION.POSITION];i.show(),i.position(s),this.initialWidth=i.width(),this.initialHeight=i.height();var o=this.options.animation;if(o&&o.open){var n=o.actionPrefix,r=n?[n,"open"].join("-"):"open";return a.startAnimation(i[0],r,t.PositionUtils.addTransformOriginAnimationEffectsOption(i,o.open),this)}},_afterOpenHandler:function(e){var i=e[t.PopupService.OPTION.POPUP],s=e[t.PopupService.OPTION.LAUNCHER];this.initialWidth===i.width()&&this.initialHeight===i.height()||this._reposition(),delete this.initialWidth,delete this.initialHeight,this._registerResizeListener(i[0]),this._initVoiceOverAssist(),this._trigger("open"),this._intialFocus(),this._on(i,{keydown:this._keyHandler}),s&&s.length>0&&this._on(s,{keydown:this._keyHandler})},_GetContextMenu:function(){if(!this._IsCustomElement())return this._super();var e=u.CustomElementUtils.getSlotMap(this._content[0]).contextMenu;return e&&e.length>0?e[0]:void 0},close:function(){if(!this._isOperationPending("close",[])){var e=this.element,i=t.ZOrderUtils.getStatus(e);if(i===t.ZOrderUtils.STATUS.OPEN)if(t.ZOrderUtils.setStatus(e,t.ZOrderUtils.STATUS.BEFORE_CLOSE),!1!==this._trigger("beforeClose")||this._ignoreBeforeCloseResultant){this._setWhenReady("close");var s=this._launcher;this._off(e,"keydown"),s&&s.length>0&&this._off(s,"keydown"),this._restoreFocus(),this._destroyVoiceOverAssist();var o={};o[t.PopupService.OPTION.POPUP]=e,t.PopupService.getInstance().close(o)}else t.ZOrderUtils.setStatus(e,i)}},_beforeCloseHandler:function(e){var i=e[t.PopupService.OPTION.POPUP];this._unregisterResizeListener(i[0]);var s=this.options.animation;if(!this._ignoreBeforeCloseResultant&&s&&s.close){var o=s.actionPrefix,n=o?[o,"close"].join("-"):"close";return a.startAnimation(i[0],n,t.PositionUtils.addTransformOriginAnimationEffectsOption(i,s.close),this).then(function(){i.hide()})}i.hide()},_afterCloseHandler:function(e){(this._removeDescribedBy(),this._setAutoDismiss(),delete this._launcher,this._trigger("close"),this._hasPositionOfLauncherOverride)&&(this.options.position.of=null,delete this._hasPositionOfLauncherOverride)},isOpen:function(){var e=t.ZOrderUtils.getStatus(this.element);return e===t.ZOrderUtils.STATUS.OPENING||e===t.ZOrderUtils.STATUS.OPEN||e===t.ZOrderUtils.STATUS.BEFORE_CLOSE||e===t.ZOrderUtils.STATUS.CLOSING},refresh:function(){if(this._super(),t.ZOrderUtils.getStatus(this.element)===t.ZOrderUtils.STATUS.OPEN&&this._reposition()){var e=this.element;t.PopupService.getInstance().triggerOnDescendents(e,t.PopupService.EVENT.POPUP_REFRESH)}},_setOption:function(e,i){var s=this.options;switch(e){case"tail":i!==s.tail&&this._setTail(i);break;case"chrome":i!==s.chrome&&this._setChrome(i);break;case"position":return this._setPosition(i),void this.refresh();case"autoDismiss":t.ZOrderUtils.getStatus(this.element)===t.ZOrderUtils.STATUS.OPEN&&i!==s.autoDismiss&&this._setAutoDismiss(i);break;case"modality":if(t.ZOrderUtils.getStatus(this.element)===t.ZOrderUtils.STATUS.OPEN){var o=this.element,n={};n[t.PopupService.OPTION.POPUP]=o,n[t.PopupService.OPTION.MODALITY]=i,t.PopupService.getInstance().changeOptions(n)}}this._superApply(arguments)},_getRootStyle:function(){return"oj-popup"},_setTail:function(e){this._destroyTail(),this._createTail(e),this._reposition()},_createTail:function(e){var s=e||this.options.tail;if("none"!==s){var o=this._getRootStyle(),n=[o,"tail"].join("-"),r=[n,s].join("-"),a=i("<div>").hide();a.addClass(n).addClass(r),a.attr("role","presentation"),this._tailId=a.attr("id",this._getSubId("tail")).attr("id");var l=this.element;if(a.appendTo(l),l.addClass(r),t.ZOrderUtils.getStatus(this.element)===t.ZOrderUtils.STATUS.OPEN){var u=[o,"layer"].join("-");u+=" "+r;var c={};c[t.PopupService.OPTION.POPUP]=l,c[t.PopupService.OPTION.LAYER_SELECTORS]=u,t.PopupService.getInstance().changeOptions(c)}}},_getTail:function(){var e=this._tailId;return e?i(document.getElementById(e)):null},_destroyTail:function(){var e=this._getTail();e&&e.remove(),delete this._tailId;var i=this.options.tail,s=this._getRootStyle(),o=[s,"tail",i].join("-"),n=this.element;if(n.removeClass(o),t.ZOrderUtils.getStatus(this.element)===t.ZOrderUtils.STATUS.OPEN){var r=[s,"layer"].join("-"),a={};a[t.PopupService.OPTION.POPUP]=n,a[t.PopupService.OPTION.LAYER_SELECTORS]=r,t.PopupService.getInstance().changeOptions(a)}},_setChrome:function(e){var t=e||this.options.chrome,i=[this._getRootStyle(),"no-chrome"].join("-"),s=this.element;"default"===t&&s.hasClass(i)?s.removeClass(i):"none"!==t||s.hasClass(i)||s.addClass(i)},_setLauncher:function(e){var t=e;if(t?("string"===i.type(t)||1===t.nodeType)&&(t=i(t)):t=i(document.activeElement),t instanceof i&&t.length>1)for(var s=this.element,n=0;n<t.length;n++){var r=t[0];if(!o.isAncestorOrSelf(s[0],r)){t=i(r);break}}else t instanceof i&&!(t instanceof i&&0===t.length)||(t=i(document.activeElement));this._launcher=t},_setPosition:function(e){var i=this.options;e&&(i.position=t.PositionUtils.coerceToJet(e,i.position))},_getPositionAsJqUi:function(){var e=this.options,s=t.PositionUtils.coerceToJqUi(e.position),o="rtl"===this._GetReadingDirection(),n=(s=t.PositionUtils.normalizeHorizontalAlignment(s,o)).using;return n=i.isFunction(n)?n:null,s.using=this._usingHandler.bind(this,n),s},_resolveBusyStateAndCloseImplicitly:function(e){e(),delete this._closeDelayTimer,this._closeImplicitly()},_resolveBusyStateAndCancelDelayedClosure:function(e,t){window.clearTimeout(e),t()},_usingHandler:function(e,i,n){var r=n.element.element;if(i.top!==r.css("top")||i.left!==r.css("left")){var a=this._getTail();if(a){a.hide();for(var l=0;l<c.length;l++)a.removeClass(c[l]),r.removeClass(c[l]);if(a.removeAttr("style"),n.target&&0===n.target.height&&0===n.target.width){var u="rtl"===this._GetReadingDirection(),p=t.PositionUtils.normalizeHorizontalAlignment(this.options.position,u).my;if(!t.StringUtils.isEmptyOrUndefined(p)){var d="center"===p.horizontal?p.horizontal:n.horizontal,f="center"===p.vertical?"middle":p.vertical;n.horizontal=d,n.vertical=f}}var _=[n.horizontal,n.vertical].join("-"),v=h[_];a.addClass(v),r.addClass(v),a.show();var m,g;if("left"===n.horizontal?(m=a.outerWidth(),m-=m+o.getCSSLengthAsInt(a.css("left")),i.left+=m-2):"right"===n.horizontal&&(m=a.outerWidth(),m-=m+o.getCSSLengthAsInt(a.css("right")),i.left-=m-2),"top"===n.vertical?(g=a.outerHeight(),g-=g+o.getCSSLengthAsInt(a.css(n.vertical)),i.top+=g-2):"bottom"===n.vertical&&(g=a.outerHeight(),g-=g+o.getCSSLengthAsInt(a.css(n.vertical)),i.top-=g-2),r.css(i),"center"===n.horizontal&&"middle"!==n.vertical){var O=r.width(),S=Math.round((O/2-a.outerWidth()/2)/O*100);a.css({left:S+"%"})}else if("middle"===n.vertical){var P=r.height(),y=Math.round((P/2-a.outerHeight()/2)/P*100);a.css({top:y+"%"})}}else r.css(i);if(t.PositionUtils.captureTransformOriginAnimationEffectsOption(r,n),e&&e(i,n),"focusLoss"===this.options.autoDismiss&&t.PositionUtils.isAligningPositionClipped(n)){this._ignoreRestoreFocus=!0;var T=s.getContext(this.element[0]).getBusyContext(),E={description:["ojPopup identified by '",this.element.attr("id"),"' is pending implicit closure."].join("")},U=T.addBusyState(E),b=window.setTimeout(this._resolveBusyStateAndCloseImplicitly.bind(this,U),0);this._closeDelayTimer=this._resolveBusyStateAndCancelDelayedClosure.bind(this,b,U)}}},_reposition:function(){var e=this.element,s=this._getPositionAsJqUi();if(t.StringUtils.isString(s.of)){var o=i(s.of);if(0===o.length)return!1;s.of=o}return!(this.element.width()>window.innerWidth||this.element.height()>window.innerHeight)&&(e.position(s),!0)},_unregisterResizeListener:function(e){e&&this._resizeHandler&&(o.removeResizeListener(e,this._resizeHandler),this._resizeHandler=null)},_registerResizeListener:function(e){e&&(null==this._resizeHandler&&(this._resizeHandler=this._handleResize.bind(this)),o.addResizeListener(e,this._resizeHandler,30,!0))},_handleResize:function(){t.ZOrderUtils.getStatus(this.element)===t.ZOrderUtils.STATUS.OPEN&&this._reposition()},_intialFocus:function(e){var t=this._deriveInitialFocus();(e||"none"!==t)&&(this.GetFocusElement().focus(),this._trigger("focus"))},GetFocusElement:function(){var e=document.activeElement;if(e&&this._isFocusInPopup(e))return e;var t,s=this._deriveInitialFocus();if("none"===s&&(s="popup"),"firstFocusable"===s){for(var o=this._content.find(":focusable"),n=0;n<o.length;n++)if(l.isFocusable(o[n])){t=i(o[n]);break}t||(s="popup")}if("popup"===s){var r=this._closeSkipLink;r?t=r.getLink():(t=this.element).attr("tabindex","-1")}return t[0]},_deriveInitialFocus:function(){var e=this.options,t=e.initialFocus;"auto"===t&&(t="modal"===e.modality?o.isTouchSupported()?"popup":"firstFocusable":"none");return t},_isFocusInPopup:function(e,t){if(e||(e=document.activeElement),!e)return!1;var i=this.element;return t&&(i=i.parent()),o.isAncestorOrSelf(i[0],e)},_isFocusInLauncher:function(e){e||(e=document.activeElement);var t=this._launcher;return o.isAncestorOrSelf(t[0],e)},_restoreFocus:function(){this._ignoreRestoreFocus?delete this._ignoreRestoreFocus:this._isFocusInPopup(null,!0)&&this._launcher.focus()},_keyHandler:function(e){if(!e.isDefaultPrevented()){var t=this._content,s=e.target;if(e.keyCode===i.ui.keyCode.ESCAPE&&(this._isFocusInPopup(s)||this._isFocusInLauncher(s)))e.preventDefault(),this.close();else if(117===e.keyCode||"F6"===e.key)this._isFocusInPopup(s)?"modeless"===this.options.modality?(e.preventDefault(),this._launcher.focus()):this.close():this._isFocusInLauncher(s)&&(e.preventDefault(),this._intialFocus(!0));else if(e.keyCode===i.ui.keyCode.TAB&&this._isFocusInPopup(s)){var o=t.find(":tabbable");if(o.length>0){var n=o[0],r=o[o.length-1],a=this.element;n!==s&&a[0]!==s||!e.shiftKey?r!==s||e.shiftKey||(e.preventDefault(),r===n?(a.attr("tabindex","-1"),a.focus()):i(n).focus()):(e.preventDefault(),n===r&&n===s?(a.attr("tabindex","-1"),a.focus()):i(r).focus())}else e.preventDefault(),"modeless"===this.options.modality?this._launcher.focus():this.close()}}},_setAutoDismiss:function(e){var i=this._focusLossCallback,s=this._getPopupServiceEvents();if(i&&(delete s[t.PopupService.EVENT.POPUP_AUTODISMISS],delete this._focusLossCallback),"focusLoss"===e&&(i=this._dismissalHandler.bind(this),this._focusLossCallback=i,s[t.PopupService.EVENT.POPUP_AUTODISMISS]=i),t.ZOrderUtils.getStatus(this.element)===t.ZOrderUtils.STATUS.OPEN){var o=this.element,n={};n[t.PopupService.OPTION.POPUP]=o,n[t.PopupService.OPTION.EVENTS]=s,t.PopupService.getInstance().changeOptions(n)}},_dismissalHandler:function(e){if(t.ZOrderUtils.getStatus(this.element)===t.ZOrderUtils.STATUS.OPEN){var i=this._launcher,s=this.element.parent(),n=e.target,r=this._focusSkipLink;if(r){var a=r.getLink();if(a&&o.isAncestorOrSelf(a[0],n))return}if(!o.isAncestorOrSelf(i[0],n)&&!o.isAncestorOrSelf(s[0],n)){var u=n.getAttribute("tabindex");if(l.isFocusable(n)&&"-1"!==u){if("mousedown"===e.type||"touchstart"===e.type)return;this._ignoreRestoreFocus=!0}this.close()}}},_addDescribedBy:function(){var e=this._launcher,t=this.element.attr("id"),s=e.attr("aria-describedby"),o=s?s.split(/\s+/):[];o.push(t),s=i.trim(o.join(" ")),e.attr("aria-describedby",s)},_removeDescribedBy:function(){var e=this._launcher,t=this.element;if(e&&0!==e.length){var s=t.attr("id"),o=e.attr("aria-describedby"),n=o?o.split(/\s+/):[],r=i.inArray(s,n);-1!==r&&n.splice(r,1),(o=i.trim(n.join(" ")))?e.attr("aria-describedby",o):e.removeAttr("aria-describedby")}},_initVoiceOverAssist:function(){var i,s=t.AgentUtils.getAgentInfo().os===t.AgentUtils.OS.IOS||t.AgentUtils.getAgentInfo().os===t.AgentUtils.OS.ANDROID,o=this._liveRegion;o||(o=new e.PopupLiveRegion,this._liveRegion=o);var n=this._deriveInitialFocus();if(i=s?this.getTranslatedString("none"===n?"ariaLiveRegionInitialFocusNoneTouch":"ariaLiveRegionInitialFocusFirstFocusableTouch"):this.getTranslatedString("none"===n?"ariaLiveRegionInitialFocusNone":"ariaLiveRegionInitialFocusFirstFocusable"),o.announce(i),s){var r=this._getSubId("focusSkipLink"),a=this._launcher,l=this._intialFocus.bind(this,!0);i=this.getTranslatedString("ariaFocusSkipLink"),this._focusSkipLink=new e.PopupSkipLink(a,i,l,r);var u=this._content,c=this._getSubId("closeSkipLink");l=this._closeImplicitly.bind(this),i=this.getTranslatedString("ariaCloseSkipLink"),this._closeSkipLink=new e.PopupSkipLink(u,i,l,c)}},_destroyVoiceOverAssist:function(){this._liveRegion.destroy(),delete this._liveRegion;var e=this._focusSkipLink;e&&(e.destroy(),delete this._focusSkipLink);var t=this._closeSkipLink;t&&(t.destroy(),delete this._closeSkipLink)},_getSubId:function(e){var i=this.element.attr("id");return t.StringUtils.isEmptyOrUndefined(i)&&(i=this.uuid),[i,e].join("_")},_surrogateRemoveHandler:function(){var e=this.element;t.ZOrderUtils.getStatus(e)===t.ZOrderUtils.STATUS.OPEN&&e.remove()},_getPopupServiceEvents:function(){if(!this._popupServiceEvents){var e={};this._popupServiceEvents=e,e[t.PopupService.EVENT.POPUP_CLOSE]=this._closeImplicitly.bind(this),e[t.PopupService.EVENT.POPUP_REMOVE]=this._surrogateRemoveHandler.bind(this),e[t.PopupService.EVENT.POPUP_REFRESH]=this.refresh.bind(this),e[t.PopupService.EVENT.POPUP_BEFORE_OPEN]=this._beforeOpenHandler.bind(this),e[t.PopupService.EVENT.POPUP_AFTER_OPEN]=this._afterOpenHandler.bind(this),e[t.PopupService.EVENT.POPUP_BEFORE_CLOSE]=this._beforeCloseHandler.bind(this),e[t.PopupService.EVENT.POPUP_AFTER_CLOSE]=this._afterCloseHandler.bind(this)}return this._popupServiceEvents},_closeImplicitly:function(){this._ignoreBeforeCloseResultant=!0,this.close(),delete this._ignoreBeforeCloseResultant},_setWhenReady:function(t){var i=this._whenReadyMediator;i&&(i.destroy(),delete this._whenReadyMediator),["open","close"].indexOf(t)<0||(this._whenReadyMediator=new e.PopupWhenReadyMediator(this.element,t,"ojPopup",this._IsCustomElement()))},_isOperationPending:function(e,t){var i=this._whenReadyMediator;return!!i&&i.isOperationPending(this,e,e,t)},_setupFocus:function(e){var t=this;this._focusable({applyHighlight:!0,setupHandlers:function(s,o){t._on(e,{focus:function(e){s(i(e.currentTarget))},blur:function(e){o(i(e.currentTarget))}})}})},_NotifyDetached:function(){t.ZOrderUtils.getStatus(this.element)===t.ZOrderUtils.STATUS.OPEN&&this._closeImplicitly(),this._super()}});const p={open:"--oj-private-popup-global-open-animation-default",close:"--oj-private-popup-global-close-animation-default"};r.setDefaultOptions({ojPopup:{modality:r.createDynamicPropertyGetter(function(){return n.getCachedCSSVarValues(["--oj-private-popup-global-modality-default"])[0]}),animation:r.createDynamicPropertyGetter(function(){const e={},t=Object.keys(p),i=t.map(e=>p[e]),s=n.getCachedCSSVarValues(i);return t.forEach((t,i)=>{e[t]=JSON.parse(s[i])}),e})}})}(),(c={properties:{autoDismiss:{type:"string",enumValues:["focusLoss","none"],value:"focusLoss"},chrome:{type:"string",enumValues:["default","none"],value:"default"},initialFocus:{type:"string",enumValues:["auto","firstFocusable","none","popup"],value:"auto"},modality:{type:"string",enumValues:["modal","modeless"],value:"modeless"},position:{type:"object",properties:{at:{type:"object",properties:{horizontal:{type:"string",enumValues:["center","end","left","right","start"],value:"start"},vertical:{type:"string",enumValues:["bottom","center","top"],value:"bottom"}}},collision:{type:"string",enumValues:["fit","flip","flipcenter","flipfit","none"],value:"flip"},my:{type:"object",properties:{horizontal:{type:"string",enumValues:["center","end","left","right","start"],value:"start"},vertical:{type:"string",enumValues:["bottom","center","top"],value:"top"}}},of:{type:"string|object"},offset:{type:"object",properties:{x:{type:"number",value:0},y:{type:"number",value:0}}}}},tail:{type:"string",enumValues:["none","simple"],value:"none"},translations:{type:"object",value:{},properties:{ariaCloseSkipLink:{type:"string"},ariaFocusSkipLink:{type:"string"},ariaLiveRegionInitialFocusFirstFocusable:{type:"string"},ariaLiveRegionInitialFocusFirstFocusableTouch:{type:"string"},ariaLiveRegionInitialFocusNone:{type:"string"},ariaLiveRegionInitialFocusNoneTouch:{type:"string"}}}},methods:{close:{},getProperty:{},isOpen:{},open:{},refresh:{},setProperties:{},setProperty:{},getNodeBySubId:{},getSubIdByNode:{}},events:{ojAnimateEnd:{},ojAnimateStart:{},ojBeforeClose:{},ojBeforeOpen:{},ojClose:{},ojFocus:{},ojOpen:{}},extension:{}}).extension._WIDGET_NAME="ojPopup",c.extension._CONTROLS_SUBTREE_HIDDEN=!0,t.CustomElementBridge.register("oj-popup",{metadata:c})});
//# sourceMappingURL=ojpopup.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojlabel',["ojs/ojcore","ojs/ojjquery-hammer","ojs/ojcomponentcore","ojs/ojpopup","ojs/ojcore-base","jquery","hammerjs","ojs/ojlogger","ojs/ojcontext","ojs/ojdomutils"],function(e,t,i,o,s,n,r,l,p,a){"use strict";var u;s=s&&Object.prototype.hasOwnProperty.call(s,"default")?s.default:s,n=n&&Object.prototype.hasOwnProperty.call(n,"default")?n.default:n,p=p&&Object.prototype.hasOwnProperty.call(p,"default")?p.default:p,s.__registerWidget("oj.ojLabel",n.oj.baseComponent,{version:"1.0.0",defaultElement:"<label>",widgetEventPrefix:"oj",options:{for:null,help:{definition:null,source:null},labelId:null,showRequired:!1,rootAttributes:null},_BUNDLE_KEY:{_TOOLTIP_HELP:"tooltipHelp",_TOOLTIP_REQUIRED:"tooltipRequired"},widget:function(){return this.uiLabel},refresh:function(){this._super(),this._refreshRequired(),this._refreshHelp(),this._addIdsToDom()},_InitOptions:function(e,t){this._super(e,t),this._isCustomElement=this._IsCustomElement(),this._checkRequiredOption()},_ComponentCreate:function(){this._super(),this._touchEatClickNamespace=this.eventNamespace+"TouchEatClick",this._touchEatContextMenuNamespace=this.eventNamespace+"TouchEatContextMenu",this._helpDefPopupNamespace=this.eventNamespace+"HelpDefPopup",this._bTouchSupported=a.isTouchSupported(),this._drawOnCreate()},_AfterCreate:function(){var e,t,i,o=this,s=this.options.for,n=this.options.showRequired;if(this.OuterWrapper&&(e=this.OuterWrapper.getAttribute("data-oj-input-id"),t=this.OuterWrapper.getAttribute("data-oj-set-id")),e?this.element[0].setAttribute("for",e):t&&(this._targetElement=document.getElementById(t),(i=this._targetElement)&&(this._needsHelpIcon()&&o._addHelpSpanIdOnTarget(o.helpSpanId,i),o.options.showRequired&&o._addRequiredDescribedByOnCustomFormElement(i))),s&&this._isCustomElement){var r=p.getContext(this.OuterWrapper).getBusyContext().addBusyState({description:"The oj-label id='"+this.OuterWrapper.id+"' is looking for its form component with id "+s});Promise.resolve().then(()=>{if(o._targetElement=document.getElementById(s),o._targetElement){i=o._targetElement;var t=document.getElementById(o.helpSpanId);if(o._needsHelpIcon()?o._addHelpSpanIdOnTarget(o.helpSpanId,i):t||i.getAttribute("described-by")!==o.helpSpanId||o._removeHelpSpanIdOnTarget(o.helpSpanId,i),n&&o._addRequiredDescribedByOnCustomFormElement(i),!e)if(o._isElementCustomElement(i)){var p=o.OuterWrapper.id;o._addElementAttribute(i,p,"labelled-by")}else o.element[0].setAttribute("for",s)}else l.info("could not find an element with forOption "+s);r()})}else this._isCustomElement&&this.options.labelId&&(this._targetElement=this._getTargetElementFromLabelledAttr("aria-labelledby",this.options.labelId),(i=this._targetElement)&&this._needsHelpIcon()&&this._addHelpSpanIdOnTarget(this.helpSpanId,i))},_SaveAttributes:function(e){this._IsCustomElement()||(this._savedClasses=e.attr("class"))},_RestoreAttributes:function(){this._IsCustomElement()||(this._savedClasses?this.element.attr("class",this._savedClasses):this.element.removeAttr("class"))},_NotifyDetached:function(){this._superApply(arguments),this._handleCloseHelpDefPopup()},_NotifyHidden:function(){this._superApply(arguments),this._handleCloseHelpDefPopup()},_GetTranslationsSectionName:function(){return this._IsCustomElement(),"oj-ojLabel"},_WatchedAttributeChanged:function(e,t,i){switch(this._superApply(arguments),e){case"data-oj-input-id":this.element[0].setAttribute("for",i);break;case"data-oj-set-id":if(t&&!i){let e=document.getElementById(t);this._removeDescribedByWithPrefix(e,this.OuterWrapper.id)}else{this._targetElement=document.getElementById(i);var o=this._targetElement,s=this._needsHelpIcon(),n=this.options.showRequired;if(s||n){var r=p.getContext(this.OuterWrapper).getBusyContext(),l=r.addBusyState({description:"The oj-label is writing described-by on its target."}),a=this;Promise.resolve().then(()=>{s&&a._addHelpSpanIdOnTarget(a.helpSpanId,o),a.options.showRequired&&a._addRequiredDescribedByOnCustomFormElement(o),l()})}}}},_removeDescribedByWithPrefix:function(e,t){var i,o;o=(i=e.getAttribute("described-by"))?i.split(/\s+/):[],(i=(o=o.filter(function(e){return-1===e.indexOf(t)})).join(" ").trim())?e.setAttribute("described-by",i):e.removeAttribute("described-by")},_drawOnCreate:function(){var e,t=null;this.OuterWrapper?(this.uiLabel=n(this.OuterWrapper).append(this.element.wrap(this._createOjLabelGroupDom()).parent()),this.uiLabel.addClass("oj-label oj-component")):this.uiLabel=this.element.wrap(this._createRootDomElement()).closest(".oj-component"),this._addIdsToDom(),e=this.element[0].id,this.helpSpanId=e+"_helpIcon",this.requiredSpanId=e+"_requiredIcon",this._isCustomElement||this._moveLabelStyleClassesToRootDom(),this.options.showRequired&&this._createRequiredIconSpanDom(),this._needsHelpIcon()&&(t=this._createIconSpan(this.helpSpanId,!0),this._createHelp(t))},_addRequiredDescribedByOnCustomFormElement:function(e){e&&this._isElementCustomElementAriaRequiredUnsupported(e)&&this._addElementAttribute(e,this.requiredSpanId,"described-by")},_removeRequiredDescribedByOnCustomFormElement:function(e){e&&this._isElementCustomElementAriaRequiredUnsupported(e)&&this._removeElementAttribute(e,this.requiredSpanId,"described-by")},_addHelpSpanIdOnTarget:function(e,t){var i;i=this._getAriaAttributeForTarget(t),this._addElementAttribute(t,e,i)},_removeHelpSpanIdOnTarget:function(e,t){var i;i=this._getAriaAttributeForTarget(t),this._removeElementAttribute(t,e,i)},_getAriaAttributeForTarget:function(e){return this._isElementCustomElement(e)?"described-by":"group"===e.getAttribute("role")?"aria-labelledby":"aria-describedby"},_getTargetElementFromLabelledAttr:function(e,t){var i;return i="["+e+"~='"+t+"']",document.querySelector(i)},_isElementCustomElement:function(e){return s.Assert.assertDomElement(e),-1!==e.tagName.indexOf("-")},_isElementCustomElementAriaRequiredUnsupported:function(e){var t;s.Assert.assertDomElement(e);var i,o=["oj-radioset","oj-checkboxset"],n=o.length,r=!1;i=e.tagName.toLowerCase();for(var l=0;l<n&&!r;l++)t=o[l],0===i.indexOf(t)&&(r=!0);return r},_addElementAttribute:function(e,t,i){var o,s,n=e.getAttribute(i);-1===(s=n?n.split(/\s+/):[]).indexOf(t)&&s.push(t),o=s.join(" ").trim(),e.setAttribute(i,o)},_removeElementAttribute:function(e,t,i){var o,s,n,r=e.getAttribute(i);-1!==(s=(n=r?r.split(/\s+/):[]).indexOf(t))&&n.splice(s,1),(o=n.join(" ").trim())?e.setAttribute(i,o):e.setAttribute(i,"")},_createHelp:function(e){var t=this.options.help.definition,i=this.options.help.source,o=this._createHelpIconAnchorDomElement(t,i);n(e).prepend(o),this._attachHelpDefToIconAnchor(),this._focusable({element:o,applyHighlight:!0})},_createRequiredIconSpanDom:function(){this._createIconSpan(this.requiredSpanId,!1).appendChild(this._createRequiredIconDomElement())},_checkRequiredOption:function(){var e=this.options.showRequired;if("boolean"!=typeof e)throw new Error("Option 'showRequired' has invalid value set: "+e)},_addIdsToDom:function(){this._isCustomElement&&(this.OuterWrapper.id||n(this.OuterWrapper).uniqueId(),this._refreshLabelId()),null==this.element.attr("id")&&this.element.uniqueId()},_moveLabelStyleClassesToRootDom:function(){var e,t,i,o=this.element.attr("class");if(o){i=(e=o.split(/\s+/)).length;for(var s=0;s<i;s++)(t=e[s]).indexOf("-label")>0&&(this.uiLabel.addClass(t),this.element.removeClass(t))}},_createIconSpan:function(e,t){var i=document.createElement("span");return i.setAttribute("id",e),t?this.uiLabel.find(".oj-label-group").prepend(i):this.element.before(i),i},_createRootDomElement:function(){var e,t,i=this.options.rootAttributes,o="oj-label oj-component";return i&&(e=i.class),e&&(o=o+" "+e),(t=document.createElement("div")).className=o,t.appendChild(this._createOjLabelGroupDom()),t},_createOjLabelGroupDom:function(){var e;return(e=document.createElement("div")).className="oj-label-group",e},_createRequiredIconDomElement:function(){var e=this.getTranslatedString(this._BUNDLE_KEY._TOOLTIP_REQUIRED),t=document.createElement("span");return t.className="oj-label-required-icon oj-component-icon",t.setAttribute("role","img"),t.setAttribute("title",e),t.setAttribute("aria-label",e),t},_createHelpIconAnchorDomElement:function(e,t){var i;if((i=document.createElement("a")).setAttribute("tabindex","0"),i.setAttribute("target","_blank"),i.className="oj-label-help-icon-anchor oj-label-help-icon oj-component-icon oj-clickable-icon-nocontext",t)try{a.validateURL(t),i.setAttribute("href",t)}catch(e){throw new Error(e+". The source option ("+t+") is invalid.")}else i.setAttribute("role","img");return e?i.setAttribute("aria-label",e):i.setAttribute("aria-label",this.getTranslatedString(this._BUNDLE_KEY._TOOLTIP_HELP)),i},_attachHelpDefToIconAnchor:function(){var e,t,i,o=this;0!==(t=this.widget().find(".oj-label-help-icon-anchor")).length&&(this._bTouchSupported&&(this._eatClickOnHelpIconListener&&this.widget().off(this._touchEatClickNamespace),this._eatClickOnHelpIconListener=function(){return!1},t.on("contextmenu"+this._touchEatContextMenuNamespace,!1)),this._openPopupForHelpDefCallbackListener=function(s){null==e&&((e=o._createHelpDefPopupDiv()).on("mouseleave"+o._helpDefPopupNamespace,o._mouseleaveClosePopupForHelpDefListener),e.on("mouseenter"+o._helpDefPopupNamespace,o._clearTimeoutOnPopupMouseEnterListener),i={my:"start bottom",at:"end top",collision:"flipcenter",of:t},e.ojPopup({position:i,modality:"modeless",animation:{open:null,close:null}})),o._handleOpenHelpDefPopup(s,e,t)},this._mouseleaveClosePopupForHelpDefListener=function(i){if(null!=o._helpDefPopupDivId){const s=i.currentTarget===t[0],n=i.currentTarget===e[0];if(s||n){const t=p.getContext(o.element[0]).getBusyContext();o.helpDefClosePopupBCResolved=t.addBusyState({description:"The oj-label is closing the help popup.'"}),o.closePopupTimer=setTimeout(function(){e.ojPopup("close"),o._resolveHelpDefClosePopupTimoutBC()},200)}}},this._clearTimeoutOnPopupMouseEnterListener=function(){o.closePopupTimer&&(clearTimeout(o.closePopupTimer),o._resolveHelpDefClosePopupTimoutBC())},this._addShowHelpDefinitionEventHandlers(t))},_createHelpDefPopupDiv:function(){var e,t,i,o,s=this.options.help.definition;return o=s||this.getTranslatedString(this._BUNDLE_KEY._TOOLTIP_HELP),this._helpDefPopupDivId?(i=n(document.getElementById(this._helpDefPopupDivId))).length&&i.find(".oj-label-help-popup-container").first().text(o):((t=document.createElement("div")).className="oj-label-help-popup",t.style.display="none",(i=n(t)).uniqueId(),this._helpDefPopupDivId=i.prop("id"),(e=document.createElement("div")).className="oj-label-help-popup-container",t.appendChild(e),n(e).text(o),this.uiLabel.append(i)),i},_addShowHelpDefinitionEventHandlers:function(e){var t;e.on("focusin"+this._helpDefPopupNamespace+" mouseenter"+this._helpDefPopupNamespace,this._openPopupForHelpDefCallbackListener),e.on("mouseleave"+this._helpDefPopupNamespace,this._mouseleaveClosePopupForHelpDefListener),this._bTouchSupported&&(this.options.help.source?(t={recognizers:[[r.Press,{time:a.PRESS_HOLD_THRESHOLD}]]},e.ojHammer(t),this._on(e,{press:this._openPopupForHelpDefCallbackListener})):(t={recognizers:[[r.Tap],[r.Press,{time:a.PRESS_HOLD_THRESHOLD}]]},e.ojHammer(t),this._on(e,{press:this._openPopupForHelpDefCallbackListener,tap:this._openPopupForHelpDefCallbackListener})))},_resolveHelpDefClosePopupTimoutBC:function(){this.closePopupTimer=null,this.helpDefClosePopupBCResolved&&(this.helpDefClosePopupBCResolved(),delete this.helpDefClosePopupBCResolved)},_handleOpenHelpDefPopup:function(e,t,i){if(this.closePopupTimer&&(clearTimeout(this.closePopupTimer),this._resolveHelpDefClosePopupTimoutBC()),!t.ojPopup("isOpen"))if(this._bTouchSupported){if("press"===e.type){var o=this.widget();o.on("click"+this._touchEatClickNamespace,this._eatClickOnHelpIconListener);var s=this;t.on("ojclose",function(){o.off(s._touchEatClickNamespace)})}else t.off("ojclose");"press"!==e.type&&"tap"!==e.type&&(a.recentTouchStart()||"focusin"!==e.type&&"mouseenter"!==e.type)||t.ojPopup("open",i)}else t.ojPopup("open",i)},_handleCloseHelpDefPopup:function(){null!=this._helpDefPopupDivId&&n(document.getElementById(this._helpDefPopupDivId)).ojPopup("close")},_removeHelpDefIconEventListeners:function(e){this._bTouchSupported&&(this.widget().off(this._touchEatClickNamespace),e.off(this._touchEatContextMenuNamespace),this._eatClickOnHelpIconListener=null,this._eatContextMenuOnHelpIconListener=null,e.ojHammer("destroy")),e.off(this._helpDefPopupNamespace),null!=this._helpDefPopupDivId&&n(document.getElementById(this._helpDefPopupDivId)).off(this._helpDefPopupNamespace),this._openPopupForHelpDefCallbackListener=null,this._mouseleaveClosePopupForHelpDefListener=null},_removeHelpDefPopup:function(){var e;null!=this._helpDefPopupDivId&&((e=n(document.getElementById(this._helpDefPopupDivId))).length>0&&(e.ojPopup("destroy"),e.remove()),this._helpDefPopupDivId=null)},_needsHelpIcon:function(){var e,t,i=this.options,o=i.help.source;return(t=""!==o&&null!=o)||(t=""!==(e=i.help.definition)&&null!=e),t},_refreshHelp:function(){var e,t,i=this.helpSpanId,o=this._targetElement;1===(t=this.uiLabel.find(".oj-label-help-icon")).length&&(this._removeHelpDefIconEventListeners(t),this._removeHelpDefPopup(),t.remove()),e=document.getElementById(i),this._needsHelpIcon()?(null==e&&(e=this._createIconSpan(i,!0)),this._createHelp(e),this._isCustomElement&&o&&this._addHelpSpanIdOnTarget(i,o)):null!==e&&(e.parentNode.removeChild(e),this._isCustomElement&&o&&this._removeHelpSpanIdOnTarget(i,o))},_refreshRequired:function(){var e,t,i=this.requiredSpanId;e=document.getElementById(i),this.options.showRequired?e?(t=this.getTranslatedString(this._BUNDLE_KEY._TOOLTIP_REQUIRED),this.uiLabel.find(".oj-label-required-icon").attr("title",t)):(this._createRequiredIconSpanDom(),this._isCustomElement&&this._addRequiredDescribedByOnCustomFormElement(this._targetElement)):(null!==(e=document.getElementById(i))&&e.parentNode.removeChild(e),this._isCustomElement&&this._removeRequiredDescribedByOnCustomFormElement(this._targetElement))},_refreshFor:function(e,t){var i=this.element[0],o=this.OuterWrapper.id;if(e){i.removeAttribute("for"),this.OuterWrapper.removeAttribute("data-oj-input-id");var s=document.getElementById(e);if(s){var n=s.getAttribute("labelled-by");if(n)if(n===o)s.removeAttribute("labelled-by");else{var r=n.split(/\s+/).filter(function(e){return e!==o}).join(" ");s.setAttribute("labelled-by",r)}}}if(this._targetElement=document.getElementById(this.options.for),this._targetElement){var l=this._targetElement;this._isElementCustomElement(l)?(this._addElementAttribute(l,o,"labelled-by"),this._needsHelpIcon()&&this._addHelpSpanIdOnTarget(this.helpSpanId,l),this.options.showRequired&&this._addRequiredDescribedByOnCustomFormElement(l)):i.setAttribute("for",t)}},_refreshLabelId:function(){var e,t;(e=this.options.labelId)?this.element.attr("id",e):(t=this.uiLabel.attr("id"))&&this.element.attr("id",t+"|label")},_setOption:function(e,t){var i=this.options[e];switch(this._superApply(arguments),e){case"showRequired":this._refreshRequired();break;case"help":this._refreshHelp();break;case"for":this._isCustomElement&&this._refreshFor(i,t);break;case"labelId":this._refreshLabelId()}},getNodeBySubId:function(e){var t;return(t=this._super(e))||"oj-label-help-icon"===e.subId&&(t=this.widget().find(".oj-label-help-icon")[0]),t||null},getSubIdByNode:function(e){var t=null;return null!=e&&e===this.widget().find(".oj-label-help-icon")[0]&&(t={subId:"oj-label-help-icon"}),t||this._superApply(arguments)},_destroy:function(){var e=this.uiLabel.find(".oj-label-help-icon");return this._removeHelpDefIconEventListeners(e),this._removeHelpDefPopup(),this.helpSpanId=null,this.requiredSpanId=null,this._isCustomElement=null,a.unwrap(this.element,this.uiLabel),this._super()}}),(u={properties:{for:{type:"string"},help:{type:"object",value:{definition:null,source:null},properties:{definition:{type:"string"},source:{type:"string"}}},labelId:{type:"string"},showRequired:{type:"boolean",value:!1},translations:{type:"object",value:{},properties:{tooltipHelp:{type:"string"},tooltipRequired:{type:"string"}}}},methods:{getProperty:{},refresh:{},setProperties:{},setProperty:{},getNodeBySubId:{},getSubIdByNode:{}},extension:{}}).extension._WIDGET_NAME="ojLabel",u.extension._INNER_ELEM="label",u.extension._GLOBAL_TRANSFER_ATTRS=["accesskey"],u.extension._WATCHED_ATTRS=["data-oj-input-id","data-oj-set-id"],s.CustomElementBridge.register("oj-label",{metadata:u})});
//# sourceMappingURL=ojlabel.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojlabelledbyutils.js',["ojs/ojlabel"],function(e){"use strict";const t={CUSTOM_LABEL_ELEMENT_ID:"|label",_labelledByUpdatedForSet:function(e,a,d,l){if((a||d)&&this._IsCustomElement()){var i={callbackAdd:function(e,a,d){const l=t.CUSTOM_LABEL_ELEMENT_ID;t._addAriaLabelledBy(e,a+l),t._addSetIdOnLabel(a,d.componentId)},callbackRemove:function(e,a,d){const l=t.CUSTOM_LABEL_ELEMENT_ID;t._removeAriaLabelledBy(e,a+l),t._removeSetIdOnLabel(a,d.componentId)},args:{componentId:e}};t._byUpdatedTemplate(a,d,l,i)}},_describedByUpdated:function(e,a,d=this._GetContentElement()){if(e||a){var l={callbackAdd:function(e,a){t._addRemoveAriaBy(e,"aria-describedby",a,!0)},callbackRemove:function(e,a){t._addRemoveAriaBy(e,"aria-describedby",a,!1)}};t._byUpdatedTemplate(e,a,d,l)}},_byUpdatedTemplate:function(e,t,a,d){var l,i,n,o;if(!e&&t)for(i=t.split(/\s+/),o=0;o<i.length;o++)l=i[o],d.callbackAdd.call(this,a,l,d.args);else if(e&&!t)for(i=e.split(/\s+/),o=0;o<i.length;o++)l=i[o],d.callbackRemove.call(this,a,l,d.args);else if(e&&t){for(i=t.split(/\s+/),n=e.split(/\s+/),o=0;o<n.length;o++)l=n[o],-1===t.indexOf(l)&&d.callbackRemove.call(this,a,l,d.args);for(o=0;o<i.length;o++)l=i[o],-1===e.indexOf(l)&&d.callbackAdd.call(this,a,l,d.args)}},_addAriaLabelledBy:function(e,a){t._addRemoveAriaBy(e,"aria-labelledby",a,!0)},_removeAriaLabelledBy:function(e,a){t._addRemoveAriaBy(e,"aria-labelledby",a,!1)},_addSetIdOnLabel:function(e,t){var a=document.getElementById(e);a&&(a.getAttribute("data-oj-set-id")||a.setAttribute("data-oj-set-id",t))},_removeSetIdOnLabel:function(e){var t=document.getElementById(e);t&&t.getAttribute("data-oj-set-id")&&t.removeAttribute("data-oj-set-id")},_addRemoveAriaBy:function(e,t,a,d){e.each(function(){let e=this.getAttribute(t),l=e?e.split(/\s+/):[],i=l.indexOf(a);d&&-1===i?l.push(a):d||-1===i||l.splice(i,1);let n=l.join(" ").trim();n?this.setAttribute(t,n):this.removeAttribute(t)})}};return t});
//# sourceMappingURL=ojlabelledbyutils.js.map;
/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define('ojs/ojkeysetimpl.js',["ojs/ojcore-base"],function(t){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t;return function(e){this.NOT_A_KEY={},this.has=function(t){return this.get(t)!==this.NOT_A_KEY},this.get=function(e){var i,s,n=this.NOT_A_KEY,o=this;if(this._keys.has(e))return e;if(e!==Object(e))return this.NOT_A_KEY;if("function"==typeof Symbol&&"function"==typeof Set.prototype[Symbol.iterator])for(s=(i=this._keys[Symbol.iterator]()).next();!s.done;){if(t.KeyUtils.equals(s.value,e))return s.value;s=i.next()}else this._keys.forEach(function(i){n===o.NOT_A_KEY&&t.KeyUtils.equals(i,e)&&(n=i)});return n},this.InitializeWithKeys=function(t){this._keys=new Set(t)},this.InitializeWithKeys(e)}});
//# sourceMappingURL=ojkeysetimpl.js.map;

define("jetCommonBundle.min", function(){});
