/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojlogger","ojs/ojconverterutils-i18n","ojs/ojlocaledata","ojs/ojoratimezone","ojs/ojconverter","ojs/ojtranslation","ojs/ojconfig","ojs/ojcore-base","ojs/ojvalidation-error"],function(e,t,r,a,n,o,i,s,l,d){"use strict";o=o&&Object.prototype.hasOwnProperty.call(o,"default")?o.default:o,l=l&&Object.prototype.hasOwnProperty.call(l,"default")?l.default:l;const u=function(){var e,t={},a={},o=/(\d{1,4})\D+?(\d{1,4})/g,i=/(\d{1,4})\D+?(\d{1,4})\D+?(\d{1,4})/g,s=/^[M][^M]|[^M]M[^M]|[^M]M$|^M$/g,l=/^[L][^L]|[^L]L[^L]|[^L]L$|^L$/g,d=/^[d][^d]|[^d]d[^d]|[^d]d$|^d$|^d[^d]/,m=/(?:^|[^h])h[^h]|[^H]H[^H]|[^k]k[^k]|[^K]K[^K]|^H[^H]|^H$|[^h]h$/,c=/'.*'/,g=/'[^d]*d[^d]*'/,v=/(\d{1,2})(?:\D+?(\d{1,2}))?(?:\D+?(\d{1,2}))?(?:\D+?(\d{1,3}))?/g,p=/h|H|K|k/g,f=/([\^$.*+?|\[\](){}])/g,h=/ccccc|cccc|ccc|cc|c|EEEEE|EEEE|EEE|EE|E|dd|d|MMMMM|MMMM|MMM|MM|M|LLLLL|LLLL|LLL|LL|L|yyyy|yy|y|hh|h|HH|H|KK|K|kk|k|mm|m|ss|s|aa|a|SSS|SS|S|zzzz|zzz|zz|z|v|ZZZ|ZZ|Z|XXX|XX|X|VV|GGGGG|GGGG|GGG|GG|G/g,y={0:"sun",1:"mon",2:"tue",3:"wed",4:"thu",5:"fri",6:"sat"},O=46,I=46,k=23,U=7,M=4,b=12,E="(\\D+|\\d\\d?\\D|\\d\\d?|\\D+\\d\\d?)",x={MMM:{token:"months",style:"format",mLen:"abbreviated",matchIndex:0,key:"month",value:"short",regExp:E},MMMM:{token:"months",style:"format",mLen:"wide",matchIndex:0,key:"month",value:"long",regExp:E},MMMMM:{token:"months",style:"format",mLen:"narrow",matchIndex:0,key:"month",value:"narrow",regExp:E},LLL:{token:"months",style:"stand-alone",mLen:"abbreviated",matchIndex:1,key:"month",value:"short",regExp:E},LLLL:{token:"months",style:"stand-alone",mLen:"wide",matchIndex:1,key:"month",value:"long",regExp:E},LLLLL:{token:"months",style:"stand-alone",mLen:"narrow",matchIndex:1,key:"month",value:"narrow",regExp:E},E:{token:"days",style:"format",dLen:"abbreviated",matchIndex:0,key:"weekday",value:"short",regExp:"(\\D+|\\D+\\d\\d?)"},EE:{token:"days",style:"format",dLen:"abbreviated",matchIndex:0,key:"weekday",value:"short",regExp:"(\\D+|\\D+\\d\\d?)"},EEE:{token:"days",style:"format",dLen:"abbreviated",matchIndex:0,key:"weekday",value:"short",regExp:"(\\D+|\\D+\\d\\d?)"},EEEE:{token:"days",style:"format",dLen:"wide",matchIndex:0,key:"weekday",value:"long",regExp:"(\\D+|\\D+\\d\\d?)"},EEEEE:{token:"days",style:"format",dLen:"narrow",matchIndex:0,key:"weekday",value:"narrow",regExp:"(\\D+|\\D+\\d\\d?)"},c:{token:"days",style:"stand-alone",dLen:"abbreviated",matchIndex:1,key:"weekday",value:"short",regExp:"(\\D+|\\D+\\d\\d?)"},cc:{token:"days",style:"stand-alone",dLen:"abbreviated",matchIndex:1,key:"weekday",value:"short",regExp:"(\\D+|\\D+\\d\\d?)"},ccc:{token:"days",style:"stand-alone",dLen:"abbreviated",matchIndex:1,key:"weekday",value:"short",regExp:"(\\D+|\\D+\\d\\d?)"},cccc:{token:"days",style:"stand-alone",dLen:"wide",matchIndex:1,key:"weekday",value:"long",regExp:"(\\D+|\\D+\\d\\d?)"},ccccc:{token:"days",style:"stand-alone",dLen:"narrow",matchIndex:1,key:"weekday",value:"narrow",regExp:"(\\D+|\\D+\\d\\d?)"},h:{token:"time",timePart:"hour",start1:0,end1:11,start2:1,end2:12,key:"hour",value:"numeric",regExp:"(\\d\\d?)"},hh:{token:"time",timePart:"hour",start1:0,end1:11,start2:1,end2:12,key:"hour",value:"2-digit",regExp:"(\\d\\d?)"},K:{token:"time",timePart:"hour",start1:0,end1:11,start2:0,end2:11,key:"hour",value:"numeric",regExp:"(\\d\\d?)"},KK:{token:"time",timePart:"hour",start1:0,end1:11,start2:0,end2:11,key:"hour",value:"2-digit",regExp:"(\\d\\d?)"},H:{token:"time",timePart:"hour",start1:0,end1:23,start2:0,end2:23,key:"hour",value:"numeric",regExp:"(\\d\\d?)"},HH:{token:"time",timePart:"hour",start1:0,end1:23,start2:0,end2:23,key:"hour",value:"2-digit",regExp:"(\\d\\d?)"},k:{token:"time",timePart:"hour",start1:0,end1:23,start2:1,end2:24,key:"hour",value:"numeric",regExp:"(\\d\\d?)"},kk:{token:"time",timePart:"hour",start1:0,end1:23,start2:1,end2:24,key:"hour",value:"2-digit",regExp:"(\\d\\d?)"},m:{token:"time",timePart:"minute",start1:0,end1:59,start2:0,end2:59,key:"minute",value:"numeric",regExp:"(\\d\\d?)"},mm:{token:"time",timePart:"minute",start1:0,end1:59,start2:0,end2:59,key:"minute",value:"2-digit",regExp:"(\\d\\d?)"},s:{token:"time",timePart:"second",start1:0,end1:59,start2:0,end2:59,key:"second",value:"numeric",regExp:"(\\d\\d?)"},ss:{token:"time",timePart:"second",start1:0,end1:59,start2:0,end2:59,key:"second",value:"2-digit",regExp:"(\\d\\d?)"},S:{token:"time",timePart:"millisec",start1:0,end1:999,start2:0,end2:999,key:"millisecond",value:"numeric",regExp:"(\\d{1,3})"},SS:{token:"time",timePart:"millisec",start1:0,end1:999,start2:0,end2:999,key:"millisecond",value:"numeric",regExp:"(\\d{1,3})"},SSS:{token:"time",timePart:"millisec",start1:0,end1:999,start2:0,end2:999,key:"millisecond",value:"numeric",regExp:"(\\d{1,3})"},d:{token:"dayOfMonth",key:"day",value:"numeric",getPartIdx:2,regExp:"(\\d\\d?)"},dd:{token:"dayOfMonth",key:"day",value:"2-digit",getPartIdx:2,regExp:"(\\d\\d?)"},M:{token:"monthIndex",key:"month",value:"numeric",getPartIdx:1,regExp:"(\\d\\d?)"},MM:{token:"monthIndex",key:"month",value:"2-digit",getPartIdx:1,regExp:"(\\d\\d?)"},L:{token:"monthIndex",key:"month",value:"numeric",getPartIdx:1,regExp:"(\\d\\d?)"},LL:{token:"monthIndex",key:"month",value:"2-digit",getPartIdx:1,regExp:"(\\d\\d?)"},y:{token:"year",key:"year",value:"numeric",regExp:"(\\d{1,4})"},yy:{token:"year",key:"year",value:"2-digit",regExp:"(\\d\\d?)"},yyyy:{token:"year",key:"year",value:"numeric",regExp:"(\\d{1,4})"},a:{token:"ampm",key:"hour12",value:!0,regExp:"(\\D*)"},z:{token:"tzAbbrev",regExp:"(.+?)"},v:{token:"tzAbbrev",key:"timeZoneName",value:"short",regExp:"(.+?)"},zz:{token:"tzAbbrev",regExp:"(.+?)"},zzz:{token:"tzAbbrev",regExp:"(.+?)"},zzzz:{token:"tzFull",regExp:"(.+?)"},Z:{token:"tzhm",regExp:"([+-]?\\d{1,4})"},ZZ:{token:"tzhm",regExp:"([+-]?\\d{1,4})"},ZZZ:{token:"tzhm",regExp:"([+-]?\\d{1,4})"},X:{token:"tzh",regExp:"([+-]?\\d{1,2})"},XX:{token:"tzhm",key:"XX",regExp:"([+-]?\\d{1,4})"},XXX:{token:"tzhsepm",regExp:"([+-]?\\d{1,2}:\\d{1,2})"},VV:{token:"tzid",regExp:"(.+?)"},G:{token:"era",key:"era",value:"short",regExp:"(\\D+|\\D+\\d\\d?)"},GG:{token:"era",key:"era",value:"short",regExp:"(\\D+|\\D+\\d\\d?)"},GGG:{token:"era",key:"era",value:"short",regExp:"(\\D+|\\D+\\d\\d?)"},GGGG:{token:"era",key:"era",value:"long",regExp:"(\\D+|\\D+\\d\\d?)"},GGGGG:{token:"era",key:"era",value:"narrow",regExp:"(\\D+|\\D+\\d\\d?)"},"/":{token:"slash",regExp:"(\\/)"}};function w(e){var t=e["two-digit-year-start"];return(void 0===t||isNaN(t))&&(t=1950),t=parseInt(t,10)}function T(e){var t=e._ojLocale_,a=r.OraI18nUtils.getBCP47Region(t);return"h"===e.supplemental.prefferedHours[a]}function S(e,t,a){var n,o,i,s=r.OraI18nUtils.getLocaleElementsMainNode(t),l=r.OraI18nUtils.getGetOption(e,a),d=l("formatType","string",["date","time","datetime"],"date"),u=l("dateFormat","string",["short","medium","long","full"],"short"),m=l("timeFormat","string",["short","medium","long","full"],"short"),c=s.dates.calendars.gregorian,g=c.dateFormats,v=c.timeFormats;switch(u){case"full":n=g.full;break;case"long":n=g.long;break;case"medium":n=g.medium;break;case"short":n=g.short}switch(m){case"full":o=v.full;break;case"long":o=v.long;break;case"medium":o=v.medium;break;case"short":o=v.short}return void 0===n||"datetime"!==d&&"date"!==d||(i=n),void 0===o||"datetime"!==d&&"time"!==d||(i=i?i+" "+o:o),i}function D(e,t){for(var r=0,a=!1,n=0,o=e.length;n<o;n++){var i=e.charAt(n);switch(i){case"'":a?t.push("'"):r+=1,a=!1;break;case"\\":a&&t.push("\\"),a=!a;break;default:t.push(i),a=!1}}return r}function L(e,t,r){var a,n=void 0!==t.year||void 0!==t.month||void 0!==t.weekday||void 0!==t.day,o=void 0!==t.hour||void 0!==t.minute||void 0!==t.second;a=n&&o?"MM/dd/yy hh:mm:ss a":n?"MM/dd/yy":"hh:mm:ss a";var i=new SyntaxError("Unexpected character(s) "+r+' encountered in the pattern "'+e+' An example of a valid pattern is "'+a+'".'),s={errorCode:"optionValueInvalid",parameterMap:{propertyName:"pattern",propertyValue:e,"propertyValueHint ":a}};throw i.errorInfo=s,i}function C(e,t,a,n){for(var o,i=r.OraI18nUtils.getLocaleElementsMainNode(t).dates.calendars.gregorian.dateTimeFormats.availableFormats,s=["weekday","era","year","month","day","hour","minute","second","timeZoneName"],l={"2-digit":0,numeric:1,narrow:2,short:3,long:4},d=-1/0,u=Object.keys(i),m=0;m<u.length;m++){var c=u[m],g=!1,v={};v.pattern=i[c];for(var p=0,f=h.exec(c);null!==f;){var y=f[0];("h"!==y&&"hh"!==y||n)&&("H"!==y&&"HH"!==y||!n)?void 0!==x[y]&&(v[x[y].key]=x[y].value):g=!0,f=h.exec(c)}if(!g){for(var O=0;O<s.length;O++){var I=e[s[O]],k=v[s[O]];if(void 0===I&&void 0!==k)p-=20;else if(void 0!==I&&void 0===k)p-=120;else if(void 0!==I){var U=l[I],M=l[k],b=Math.max(Math.min(M-U,2),-2);2===b?p-=6:1===b?p-=3:-1===b?p-=6:-2===b&&(p-=8)}}p>d&&(d=p,o=v)}}return void 0!==o?o.pattern:null}function Z(e,t,r,a){return void 0!==r?(e[t]=r,a[r]):""}function _(e,t,r){var a;if(Object.keys(t).length>1)return null;for(var n=e.length;n>0;n--)if(void 0!==(a=r[e.substr(0,n)]))return a;return e}function z(e,a,n,o){var i,u,v,f=r.OraI18nUtils.getLocaleElementsMainNode(a),h=r.OraI18nUtils.getLocaleElementsMainNodeKey(a),y=r.OraI18nUtils.getGetOption(e,o),O=y("formatMatcher","string",["basic","munger"],"munger");0===Object.keys(e).length&&(e={year:"numeric",month:"numeric",day:"numeric"});var I=y("millisecond","string",["numeric","2-digit"]),k=y("second","string",["numeric","2-digit"]);void 0!==I&&(u=y("hour","string",["numeric","2-digit"]),v=y("minute","string",["numeric","2-digit"]),e.second="2-digit");var U=function(e,t,a){var n="",o="",i={},s={},l=r.OraI18nUtils.getGetOption(e,a),d=l("era","string",["narrow","short","long"]);n+=Z(i,"era",d,{narrow:"GGGGG",short:"GGG",long:"GGGG"}),n+=Z(i,"year",d=l("year","string",["2-digit","numeric"]),{"2-digit":"yy",numeric:"y"}),n+=Z(i,"month",d=l("month","string",["2-digit","numeric","narrow","short","long"]),{"2-digit":"MM",numeric:"M",narrow:"MMMMM",short:"MMM",long:"MMMM"}),n+=Z(i,"weekday",d=l("weekday","string",["narrow","short","long"]),{narrow:"EEEEE",short:"E",long:"EEEE"}),n+=Z(i,"day",d=l("day","string",["2-digit","numeric"]),{"2-digit":"dd",numeric:"d"});var u=l("hour12","boolean",[!0,!1]);return void 0===u&&(u=T(t)),o+=Z(s,"hour",d=l("hour","string",["2-digit","numeric"]),!0===u?{"2-digit":"hh",numeric:"h"}:{"2-digit":"HH",numeric:"H"}),o+=Z(s,"minute",d=l("minute","string",["2-digit","numeric"]),{"2-digit":"mm",numeric:"m"}),o+=Z(s,"second",d=l("second","string",["2-digit","numeric"]),{"2-digit":"ss",numeric:"s"}),[n,o+=Z(s,"timeZoneName",d=l("timeZoneName","string",["short","long"]),{short:"v",long:"v"}),i,s]}(e,a,o);if(void 0!==t[h]){var M=t[h].dates.calendars.gregorian.dateTimeFormats[U[0]+U[1]];if(void 0!==M)return M=D(M)}if(""===U[0]&&""===U[1])return S(e,a,o);var b=f.dates.calendars.gregorian.dateTimeFormats.availableFormats,E=b[U[0]],x=y("hour12","boolean",[!0,!1]);void 0===x&&(x=T(a)),void 0===E&&""!==U[0]&&(null===(E=_(U[0],U[2],b))&&(E=C(U[2],a,0,x)),null!==E?"basic"!==O&&(E=function(e,t,a){var n=e,o=r.OraI18nUtils.getGetOption(t,a),i=o("year","string",["2-digit","numeric"]),u={"2-digit":"yy",numeric:"yyyy"};if(void 0!==i&&(n=n.replace(/y{1,4}/,u[i])),void 0!==(i=o("month","string",["2-digit","numeric","narrow","short","long"]))){void 0!==(u={"2-digit":"MM",numeric:"M",narrow:"MMMMM",short:"MMM",long:"MMMM"})[i]&&u[i].length>2?n=(n=n.replace(/M{3,5}/,u[i])).replace(/L{3,5}/,{"2-digit":"LL",numeric:"L",narrow:"LLLLL",short:"LLL",long:"LLLL"}[i]):"2-digit"===i&&(s.lastIndex=0,s.test(e)&&(n=n.replace("M","MM")),l.test(e)&&(n=n.replace("L","LL")))}if(void 0!==(i=o("weekday","string",["narrow","short","long"]))){n=(n=n.replace(/E{1,5}/,{narrow:"EEEEE",short:"EEE",long:"EEEE"}[i])).replace(/c{1,5}/,{narrow:"ccccc",short:"ccc",long:"cccc"}[i])}if(void 0!==(i=o("day","string",["2-digit","numeric"]))&&"2-digit"===i){d.lastIndex=0,g.lastIndex=0;var m=g.test(e);!0===d.test(e)&&!1===m&&(n=n.replace("d","dd"))}return n}(E,e,o)):E=U[0]);var w=b[U[1]];return void 0===w&&""!==U[1]&&(null===(w=_(U[1],U[3],b))&&(w=C(U[3],a,0,x)),null!==w?"basic"!==O&&(w=function(e,t,a){var n=e;if("2-digit"===r.OraI18nUtils.getGetOption(t,a)("hour","string",["2-digit","numeric"])){m.lastIndex=0,c.lastIndex=0;var o=e.replace(c,""),i=m.exec(o);if(null!==i){p.lastIndex=0;var s=p.exec(i[0]),l=s[0]+s[0];n=e.replace(s[0],l)}}return n}(w,e,o)):w=U[1]),i=E||"",void 0!==w&&(""!==i?i+=" "+w:i=w),void 0===t[h]&&(t[h]={},t[h].dates={},t[h].dates.calendars={},t[h].dates.calendars.gregorian={},t[h].dates.calendars.gregorian.dateTimeFormats={}),t[h].dates.calendars.gregorian.dateTimeFormats[U[0]+U[1]]=i,i=D(i);function D(t){if(void 0!==I){var a=function(e,t){var a="symbols-numberSystem-"+r.OraI18nUtils.getNumberingSystemKey(e,t);return e.numbers[a].decimal}(f,n);a=void 0===u&&void 0===v&&void 0===k?"S":"ss"+a+"SSS",t=t.replace("ss",a),void 0===k&&(e.second=void 0)}var o=y("timeZoneName","string",["short","long"]);return void 0!==o&&(t=t.replace(/v/,{short:"z",long:"zzzz"}[o])),t}}function F(e){var t=e.split(" "),r=t[0].split("-"),a=new Date(r[0],r[1]-1,r[2]);return t.length>1&&(r=t[1].split(":"),a.setHours(r[0]),a.setMinutes(r[1])),a.getTime()}function j(e,t,r){var a=new Date(e[0],e[1]-1,e[2],e[3],e[4],e[5]).getTime(),n=t.split("/"),o=n[0],i=n[1],s=r[o];if(void 0===s)return null;if(void 0===(s=s[i]))return null;for(var l,d,u=s.length,m=0;m<u;m++){var c=s[m].usesMetazone._from,g=s[m].usesMetazone._to,v=s[m].usesMetazone._mzone;if(void 0===c&&void 0===g)return v;if(void 0===c&&void 0!==g&&a<=(d=F(g)))return v;if(void 0!==c&&void 0===g&&a>=(l=F(c)))return v;if(void 0!==c&&void 0!==g&&(l=F(c),d=F(g),a>=l&&a<d))return v}}function N(e,t,a,n,o){var i=r.OraI18nUtils.getLocaleElementsMainNode(e),s="",l=a.timeZone,d=r.OraI18nUtils.getGetOption(a,"OraDateTimeConverter")("dst","boolean",[!0,!1],!1);if(void 0===l)return s;var u,m,c=j(t,l=l.replace("Ho_Chi_Minh","Saigon"),e.supplemental.metazones),g="standard",v=!o,p=P(l,e),f=G(p,t,d,v,!0);if(void 0!==i.dates.timeZoneNames.metazone&&(u=i.dates.timeZoneNames.metazone[c]),void 0===u){var h=p.ofset(f);return h=0!==h?r.OraI18nUtils.getTimeStringFromOffset("UTC",h,!0,!0):"UTC"}m=1===n?u.long:u.short;var y=p.ofset(f);return y<p.ofset(f+1)&&(g="daylight"),void 0!==m&&void 0!==(s=m[g])?s:0===y?"UTC":r.OraI18nUtils.getTimeStringFromOffset("UTC",y,!0,!0)}function P(e,t){return n.OraTimeZone.getInstance().getZone(e,t)}function G(e,t,r,a,n){var o=Date.UTC(t[0],t[1]-1,t[2],t[3],t[4],t[5]);return e.parse(o,r,a,n)}function H(e){var t=e.split(":");return 2===t.length?(t[0]=parseInt(t[0],10),t[1]=parseInt(t[1],10)):2===e.length||3===e.length?(t[0]=parseInt(e,10),t[1]=0):(t[0]=parseInt(e.substr(0,3),10),t[1]=parseInt(e.substr(3),10)),t}function A(e,t,a,n){var o,i,s,l=a.isoStrParts,d=0===a.dateTime.indexOf("T"),u=r.OraI18nUtils.getLocaleElementsMainNode(e),m=r.OraI18nUtils.getGetOption(t,"OraDateTimeConverter.format");i=t.pattern||z(t,e,n,"OraDateTimeConverter.format"),o=[];var c=0,g=u.dates.calendars.gregorian;function v(e,t){switch(t){case 0:return e[0];case 1:return e[1];case 2:return e[2];case 3:var r=new Date(e[0],e[1]-1,e[2],e[3],e[4],e[5]);return y[r.getDay()];default:return}}function p(e,a,n,o,i){var s;switch(o.timePart){case"hour":s=11===o.end1?a[3]%12:a[3],"h"===i||"hh"===i?0===s&&(s=12):"k"!==i&&"kk"!==i||0===s&&(s=24);break;case"minute":s=a[4];break;case"second":s=void 0===t.second&&void 0!==t.millisecond?0:a[5];break;case"millisec":s=a[6]}e.push(n>1?r.OraI18nUtils.padZeros(s,n):s)}function f(t,n,o){var i,s,l,d=n.timeZone,u=m("dst","boolean",[!0,!1],!1),c=!o;if(void 0!==d)l=G(s=P(d,e),t,u,c,!0),i=-s.ofset(l);else if("local"!==a.format)switch(a.format){case"offset":var g=H(a.timeZone),v=g[0],p=g[1];i=60*v+(r.OraI18nUtils.startsWith(a.timeZone,"-")?-p:p);break;case"zulu":default:i=0}return i}var O,I,k,U,M,b=t.timeZone;for("local"!==a.format&&void 0!==b&&Ee(a,t,e);;){var E=h.lastIndex,w=h.exec(i);if(c+=D(i.slice(E,w?w.index:i.length),o),!w)break;if(c%2)o.push(w[0]);else{var T=w[0],S=T.length,C=x[T];switch(C.token){case"days":s=g[C.token][C.style][C.dLen],o.push(s[v(l,3)]);break;case"months":s=g[C.token][C.style][C.mLen],o.push(s[v(l,1)]);break;case"dayOfMonth":case"monthIndex":o.push((O=o,I=l,k=C.getPartIdx,U=S,M=void 0,M=v(I,k),void O.push(U>1?r.OraI18nUtils.padZeros(M,U):M)));break;case"year":s=l[0],2===S&&(s%=100),o.push(r.OraI18nUtils.padZeros(s,S));break;case"time":p(o,l,S,C,T);break;case"ampm":s=l[3]<12?g.dayPeriods.format.wide.am:g.dayPeriods.format.wide.pm,o.push(s);break;case"tzhm":0===(s=f(l,t,d))?"XX"===C.key?o.push("Z"):o.push("+0000"):void 0!==s&&o.push((s<=0?"-":"+")+r.OraI18nUtils.padZeros(Math.floor(Math.abs(s/60)),2)+r.OraI18nUtils.padZeros(Math.floor(Math.abs(s%60)),2));break;case"tzhsepm":0===(s=f(l,t,d))?o.push("Z"):void 0!==s&&o.push((s<=0?"-":"+")+r.OraI18nUtils.padZeros(Math.floor(Math.abs(s/60)),2)+":"+r.OraI18nUtils.padZeros(Math.floor(Math.abs(s%60)),2));break;case"tzh":0===(s=f(l,t,d))?o.push("Z"):void 0!==s&&o.push((s<=0?"-":"+")+r.OraI18nUtils.padZeros(Math.floor(Math.abs(s/60)),2));break;case"tzid":s=void 0!==b?b:"zulu"===a.format?"UTC":"",o.push(s);break;case"tzAbbrev":s=N(e,l,t,0,d),o.push(s);break;case"tzFull":s=N(e,l,t,1,d),o.push(s);break;case"era":s=g.eras.eraAbbr,o.push(s[1]);break;case"slash":o.push("/");break;default:L(i,t,T)}}}return o.join("")}function K(e,t){return e.getFullYear()===t.getFullYear()}function R(e,t){return t.getFullYear()-e.getFullYear()==1}function V(e,t){return K(e,t)&&e.getMonth()===t.getMonth()}function W(e,t){return K(e,t)?t.getMonth()-e.getMonth()==1:!!R(e,t)&&(11===e.getMonth()&&0===t.getMonth())}function X(e,t){var a=e.getDate(),n=t.getDate();return W(e,t)&&(n+=r.OraI18nUtils._getDaysInMonth(e.getFullYear,e.getMonth())),n-a}function Y(e,t){var a=e._ojLocale_,n=r.OraI18nUtils.getBCP47Region(a),o=e.supplemental.weekData.firstDay,i=o[n];void 0===i&&(i=o["001"]);var s=t-i;return s<0&&(s+=7),s}function $(e,t,r){if(!V(t,r)&&!W(t,r))return!1;var a=X(t,r)+Y(e,t.getDay());return a>=7&&a<=13}function B(e,t){return K(e,t)&&V(e,t)&&e.getDate()===t.getDate()}function q(e,t){return!(!V(e,t)&&!W(e,t))&&1===X(e,t)}function J(e,t){return q(t,e)}function Q(e,t,a){var n=r.OraI18nUtils._IsoStrParts(e),o=r.OraI18nUtils._IsoStrParts(t);return a?(n=Date.UTC(n[0],n[1]-1,n[2],0,0,0,0),o=Date.UTC(o[0],o[1]-1,o[2],0,0,0,0)):(n=Date.UTC(n[0],n[1]-1,n[2],n[3],n[4],n[5],n[6]),o=Date.UTC(o[0],o[1]-1,o[2],o[3],o[4],o[5],o[6])),n-o}function ee(e,t){return e.replace(/\{(\d+)\}/g,function(){return t[arguments[1]]})}function te(e,t,a,n){var o=r.OraI18nUtils.getLocaleElementsMainNode(n).dates.fields,i=r.OraI18nUtils.getGetOption(a,"OraDateTimeConverter.formatRelative")("dateField","string",["day","week","month","year","hour","minute","second"]),s=r.OraI18nUtils.isoToLocalDate(e),l=r.OraI18nUtils.isoToLocalDate(t);switch(i){case"day":return B(s,l)?o.day["relative-type-0"]:q(s,l)?o.day["relative-type-1"]:J(s,l)?o.day["relative-type--1"]:ae(e,t,n,"day");case"week":return function(e,t,r){if(t>r){var a=t;t=r,r=a}if(!V(t,r)&&!W(t,r))return!1;var n=X(t,r)+Y(e,t.getDay());return n>=0&&n<=6}(n,s,l)?o.week["relative-type-0"]:$(n,s,l)?o.week["relative-type-1"]:function(e,t,r){return $(e,r,t)}(n,s,l)?o.week["relative-type--1"]:ae(e,t,n,"week");case"month":return V(s,l)?o.month["relative-type-0"]:W(s,l)?o.month["relative-type-1"]:W(l,s)?o.month["relative-type--1"]:ae(e,t,n,"month");case"year":return K(s,l)?o.year["relative-type-0"]:R(s,l)?o.year["relative-type-1"]:function(e,t){return R(t,e)}(s,l)?o.year["relative-type--1"]:ae(e,t,n,"year");case"hour":return ae(e,t,n,"hour");case"minute":return ae(e,t,n,"minute");case"second":return ae(e,t,n,"second")}return null}function re(e){return e.split("-")[0]}function ae(e,t,a,n){var o,i,s,l,d=r.OraI18nUtils.getLocaleElementsMainNodeKey(a),u=r.OraI18nUtils.getLocaleElementsMainNode(a),m=re(d),c=a.supplemental.plurals,g=u.dates.fields,v=Q(t,e,!1),p=Math.abs(v),f=(o=(i=p)/864e5,l=(s=4800*o/146097)/12,{year:Math.round(l),month:Math.round(s),week:Math.round(i/6048e5),day:Math.round(i/864e5),hour:Math.round(i/36e5),minute:Math.round(i/6e4),second:Math.round(i/1e3),millisecond:i});if(null===n&&(n=(f.second<O?"second":f.minute<I&&"minute")||f.hour<k&&"hour"||f.day<U&&"day"||f.week<M&&"week"||f.month<b&&"month"||"year"),"second"===n&&f.second<O)return g[n]["relative-type-0"];var h="relativeTimePattern-count-"+c[m](f[n]),y=v<0?"relativeTime-type-past":"relativeTime-type-future",E=g[n][y][h];return void 0===E&&(h="relativeTimePattern-count-other",E=g[n][y][h]),E=ee(E,[f[n]])}function ne(e,t,a){var n=r.OraI18nUtils.dateToLocalIso(new Date);if("number"==typeof e)e=r.OraI18nUtils.dateToLocalIso(new Date(e));else{if("string"!=typeof e)return null;if(""===r.OraI18nUtils.trim(e))return null}void 0===a&&(a={formatUsing:"displayName"});var o=r.OraI18nUtils.getGetOption(a,"OraDateTimeConverter.formatRelative"),i=o("relativeTime","string",["fromNow","toNow"],"fromNow"),s=o("dateField","string",["day","week","month","year","hour","minute","second"]);if(e=function(e,t,a){var n=a.timeZone;if("local"===r.OraI18nUtils.getISOStrFormatInfo(e).format&&void 0===n)return e;var o={isoStrFormat:"zulu"};void 0!==n&&(o.timeZone=n,o.dst=!0);var i=Se(e,t,o,"en-US");return o={timeZone:r.OraI18nUtils.getLocalTimeZoneOffset(),isoStrFormat:"local"},Se(i.value,t,o,"en-US").value}(e,t,a),"toNow"===i){var l=n;n=e,e=l}return"calendar"===o("formatUsing","string",["displayName","calendar"],"displayName")?function(e,t,a,n){var o,i,s,l,d=r.OraI18nUtils.getLocaleElementsMainNode(a),u=d.dates.calendars.gregorian.dateTimeFormats.long,m=d.dates.calendars.gregorian.days.format.wide,c=d.dates.fields,g=r.OraI18nUtils.isoToLocalDate(t),v=r.OraI18nUtils.isoToLocalDate(e),p=r.OraI18nUtils.getISOStrFormatInfo(t);if(B(v,g))o=c.day["relative-type-0"];else if(q(v,g))o=c.day["relative-type-1"];else if(J(v,g))o=c.day["relative-type--1"];else{s=g.getDay(),l=y[s];var f=Q(t,e,!0);if((f/=864e5)<-1&&f>-7)o=c[l]["relative-type--1"];else{if(!(f>1&&f<7))return A(a,{year:"numeric",month:"numeric",day:"numeric"},p,"en-US");o=m[l]}}return n?o:(i=A(a,{hour:"numeric",minute:"numeric"},p,"en-US"),u=ee(u=u.replace(/'/g,""),[i,o]))}(n,e,t,o("dateOnly","boolean",[!0,!1],!1)):void 0!==s?te(n,e,a,t):ae(n,e,t,null)}function oe(e,t){var r=new Error("The weekday "+e+" does not match the date "+t),a={errorCode:"dateToWeekdayMismatch",parameterMap:{weekday:e,date:t}};throw r.errorInfo=a,r}function ie(e,t,r){var a,n;2===r?(a='The value "'+e+'" does not match the expected date-time format "'+t+'"',n="datetimeFormatMismatch"):0===r?(a='The value "'+e+'" does not match the expected date format "'+t+'"',n="dateFormatMismatch"):(a='The value "'+e+'" does not match the expected time format "'+t+'"',n="timeFormatMismatch");var o=new Error(a),i={errorCode:n,parameterMap:{value:e,format:t}};throw o.errorInfo=i,o}function se(e,t){if(t<100){var r=e%100;t+=100*Math.floor(e/100)+(t<r?100:0)}return t}function le(e,t){for(var a={sun:0,mon:1,tue:2,wed:3,thu:4,fri:5,sat:6},n=Object.keys(e),o=0;o<n.length;o++){var i=n[o];if(r.OraI18nUtils.trim(r.OraI18nUtils.toUpper(e[i]))===r.OraI18nUtils.trim(t))return a[i]}return-1}function de(e,t){for(var a=Object.keys(e),n=0;n<a.length;n++){var o=a[n];if(r.OraI18nUtils.trim(r.OraI18nUtils.toUpper(e[o]))===r.OraI18nUtils.trim(t))return n}return-1}function ue(e,t,a){var n,o,i=r.OraI18nUtils.getLocaleElementsMainNode(e),s=i.dates.calendars.gregorian.days.format,l=i.dates.calendars.gregorian.days["stand-alone"];switch(a){case 0:o=[s.abbreviated,s.wide];break;case 1:o=[l.abbreviated,l.wide]}return t=r.OraI18nUtils.toUpper(t),-1===(n=le(o[0],t))&&(n=le(o[1],t)),n}function me(e,t,a){var n,o=-1,i=r.OraI18nUtils.getLocaleElementsMainNode(e),s=i.dates.calendars.gregorian.months.format,l=i.dates.calendars.gregorian.months["stand-alone"];switch(a){case 0:n=[s.wide,s.abbreviated];break;case 1:n=[l.wide,l.abbreviated];break;case 2:n=[s.wide,s.abbreviated,l.wide,l.abbreviated];break;default:return-1}t=r.OraI18nUtils.toUpper(t);for(var d=0;d<n.length;d++)if(-1!==(o=de(n[d],t)))return o;return o}function ce(e,t,r,a,n,o,i){if(t<r||t>a){var s=new RangeError(n+" is out of range.  Enter a value between "+o+" and "+i+" for "+e),l={errorCode:"datetimeOutOfRange",parameterMap:{value:n,minValue:o,maxValue:i,propertyName:e}};throw s.errorInfo=l,s}}function ge(e,t){for(var r=0;r<e.length;r++)if(void 0!==e[r][t])return r;return 0}function ve(e,t,a,n,o){var i=r.OraI18nUtils.getLocaleElementsMainNode(n).dates.calendars.gregorian.dayPeriods.format.wide.pm;v.lastIndex=0;var s=0,l=0,d=0,u=0,m=v.exec(t);switch(null===m&&ie(t,a,o),void 0!==m[1]&&(s=parseInt(m[1],10)),void 0!==m[2]&&(l=parseInt(m[2],10)),void 0!==m[3]&&(d=parseInt(m[3],10)),void 0!==m[4]&&(u=parseInt(m[4],10)),p.lastIndex=0,(m=p.exec(a))[0]){case"h":12===s&&(s=0),ce("hour",s,0,11,s,1,12),-1!==r.OraI18nUtils.toUpper(t).indexOf(r.OraI18nUtils.toUpper(i))&&s<12&&(s+=12);break;case"K":ce("hour",s,0,11,s,0,11),-1!==r.OraI18nUtils.toUpper(t).indexOf(r.OraI18nUtils.toUpper(i))&&s<12&&(s+=12);break;case"H":ce("hour",s,0,23,s,0,23);break;case"k":24===s&&(s=0),ce("hour",s,0,23,s,1,24)}ce("minute",l,0,59,l,0,59),ce("second",d,0,59,d,0,59),ce("millisec",u,0,999,u,0,999),e.setHours(s,l,d,u)}function pe(e,t){for(var a=r.OraI18nUtils.getLocaleElementsMainNode(t),n=a.dates.calendars.gregorian.days.format,o=a.dates.calendars.gregorian.days["stand-alone"],i=[n.wide,n.abbreviated,o.wide,o.abbreviated],s=0;s<i.length;s++)for(var l=Object.keys(i[s]),d=0;d<l.length;d++){var u=i[s][l[d]];if(new RegExp(u+"\\b","i").test(e))return u}return null}function fe(e,t,a,n,s){var l=e;e=r.OraI18nUtils.toUpper(e);var d,u,m,c=r.OraI18nUtils.getLocaleElementsMainNode(n),g=c.dates.calendars.gregorian.months.format,v=c.dates.calendars.gregorian.months["stand-alone"],p=[g.wide,g.abbreviated,v.wide,v.abbreviated],f=!1;for(u=0;u<p.length;u++){d=[];var h,y=Object.keys(p[u]);for(h=0;h<y.length;h++)m=r.OraI18nUtils.toUpper(p[u][y[h]]),d.unshift({idx:h,name:m});for(d.sort(function(e,t){return t.idx-e.idx}),h=0;h<d.length;h++)if(m=d[h].name,-1!==e.indexOf(m)){f=!0,e=e.replace(m,"");break}if(f)break}if(!f)return function(e,t,a,n,o){i.lastIndex=0;var s=i.exec(e);null===s&&ie(e,t,o?2:0);var l,d,u,m,c,g,v=[{y:t.indexOf("y")},{M:t.indexOf("M")},{d:t.indexOf("d")}];v.sort(function(e,t){var r=Object.keys(e)[0],a=Object.keys(t)[0];return e[r]-t[a]});var p=ge(v,"d"),f=!1,h=!1;for(g=1;g<=3;g++){var y=s[g];(y.length>2||y>31)&&(l=y,f=!0,m=g-1)}for(f||(m=ge(v,"y"),l=s[ge(v,"y")+1]),g=0;g<3;g++)if(g!==m&&s[g+1]>12){u=s[g+1],h=!0,c=g;break}if(h){for(g=0;g<3;g++)if(g!==c&&g!==m){d=s[g+1];break}void 0===d&&(d=s[ge(v,"M")+1])}else m===ge(v,"d")?(u=s[ge(v,"y")+1],d=s[ge(v,"M")+1]):m===ge(v,"M")?(u=s[ge(v,"d")+1],d=s[ge(v,"y")+1]):(u=s[ge(v,"d")+1],d=s[ge(v,"M")+1]);d-=1;var O=r.OraI18nUtils._getDaysInMonth(l,d);h&&p!==c&&d>12&&ce("month",u,0,11,u,1,12),ce("month",d,0,11,d+1,1,12),ce("day",u,1,O,u,1,O),ce("year",l=se(w(a),parseInt(l,10)),0,9999,l,0,9999);var I=new Date(l,d,u),k=pe(e,n);if(null!==k){var U=ue(n,k,0);I.getDay()!==U&&oe(k,I.getDate())}var M={value:I,offset:"",warning:"lenient parsing was used"};if(o){var b=e.substr(i.lastIndex);0===b.length?M.value.setHours(0,0,0,0):ve(M.value,b,t,n,2)}return M.value=r.OraI18nUtils.dateToLocalIso(M.value),M}(l,t,a,n,s);var O=me(n,m,2);ce("month",O,0,11,O,1,12);var I=pe(l,n),k=new RegExp(I+"\\W","i");null!==I&&(e=e.replace(k,"")),o.lastIndex=0;var U=o.exec(e);null===U&&ie(l,t,s?2:0);var M,b,E,x=[{y:t.indexOf("y")},{d:t.indexOf("d")}];x.sort(function(e,t){var r=Object.keys(e)[0],a=Object.keys(t)[0];return e[r]-t[a]});var T=!1;for(u=1;u<=2;u++){var S=U[u];(S.length>2||S>31)&&(M=S,T=!0,E=u-1)}T||(E=ge(x,"y"),M=U[ge(x,"y")+1]),b=E===ge(x,"d")?U[ge(x,"y")+1]:U[ge(x,"d")+1],ce("year",M=se(w(a),parseInt(M,10)),0,9999,M,0,9999);var D=new Date(M,O,b);if(null!==I){var L=ue(n,I,0);D.getDay()!==L&&oe(I,D.getDate())}var C=r.OraI18nUtils._getDaysInMonth(M,O);ce("day",b,1,C,b,1,C);var Z={value:D,offset:"",warning:"lenient parsing was used"};if(s){var _=e.substr(o.lastIndex);0===_.length?Z.value.setHours(0,0,0,0):ve(Z.value,_,t,n,2)}return Z.value=r.OraI18nUtils.dateToLocalIso(Z.value),Z}function he(e,t,a,n){switch(Me(a,"OraDateTimeConverter.parse")){case 0:return fe(e,t,a,n,!1);case 1:var o=new Date;return ve(o,e,t,n,1),{value:r.OraI18nUtils.dateToLocalIso(o),offset:"",warning:"lenient parsing was used"};case 2:return fe(e,t,a,n,!0)}return null}function ye(e,t,a,n,o,i,s,l,d,u,m){var c,g=r.OraI18nUtils.getLocaleElementsMainNode(e).dates.calendars.gregorian[t][o];return ce(m,c="months"===t?me(e,a,i):ue(e,a,i),s,l,a,g[n][d],g[n][u]),c}function Oe(e,t,r,a){var n=t;n[r.timePart]=e,"h"===a||"hh"===a?12===e&&(n[r.timePart]=0):"k"!==a&&"kk"!==a||24===e&&(n[r.timePart]=0),ce(r.timePart,n[r.timePart],r.start1,r.end1,e,r.start2,r.end2)}function Ie(e,t,a,n){var o=r.OraI18nUtils.getLocaleElementsMainNode(n),i=o.dates.calendars.gregorian.eras.eraAbbr[1],s=r.OraI18nUtils.trimNumber(i);e=e.replace(i,s);var l=r.OraI18nUtils.getGetOption(a,"OraDateTimeConverter.parse")("lenientParse","string",["none","full"],"full"),d=Me(a,"OraDateTimeConverter.parse"),u=function(e,t){for(var r=e.replace(f,"\\\\$1"),a=["^"],n=[],o=0,i=0,s=h.exec(r);null!==s;){var l=r.slice(o,s.index);if(o=h.lastIndex,(i+=D(l,a))%2)a.push(s[0]);else{var d,u=s[0];void 0!==x[u]?d=x[u].regExp:L(e,t,u),d&&a.push(d),n.push(s[0])}s=h.exec(r)}D(r.slice(o),a),a.push("$");var m={regExp:a.join("").replace(/\s+/g,"\\s+"),groups:n};return m}(t,a),m=new RegExp(u.regExp).exec(e);if(null===m){if("full"===l)return he(e,t,a,n);ie(e,t,d)}for(var c,g=u.groups,v=null,p=null,y=null,O=null,I="",k=null,U=!1,M={hour:0,minute:0,second:0,millisec:0},b=o.dates.calendars.gregorian.dayPeriods.format.wide.pm,E=w(a),T=0,S=g.length;T<S;T++){var C=m[T+1];if(C){var Z=g[T],_=parseInt(C,10),z=x[Z];switch(z.token){case"months":p=ye(n,z.token,C,z.mLen,z.style,z.matchIndex,0,11,"1","12","month name");break;case"days":c=C,O=ye(n,z.token,C,z.dLen,z.style,z.matchIndex,0,6,"sun","sat","weekday");break;case"time":Oe(_,M,z,Z);break;case"dayOfMonth":if((y=_)>31&&"full"===l)try{return he(e,t,a,n)}catch(e){var F=r.OraI18nUtils._getDaysInMonth(v,p);ce("day",y,1,F,y,1,F)}break;case"monthIndex":if((p=_-1)>11&&"full"===l)try{return he(e,t,a,n)}catch(e){ce("month",p,0,11,p+1,1,12)}break;case"year":ce("year",v=se(E,_),0,9999,v,0,9999);break;case"ampm":U=-1!==r.OraI18nUtils.toUpper(C).indexOf(r.OraI18nUtils.toUpper(b));break;case"tzhm":I=C.substr(-2),I=C.substr(0,3)+":"+I;break;case"tzhsepm":I=C;break;case"tzh":I=C+":00";break;case"tzid":k=C}}}var j=new Date;null===v&&(v=j.getFullYear()),null===p&&null===y?(p=j.getMonth(),y=j.getDate()):null===y&&(y=1),ce("month",p,0,11,p+1,1,12);var N=r.OraI18nUtils._getDaysInMonth(v,p);ce("day",y,1,N,y,1,N),j.setFullYear(v,p,y),null!==O&&j.getDay()!==O&&oe(c,j.getDate()),U&&M.hour<12&&(M.hour+=12);var H=[v,p+1,y,M.hour,M.minute,M.second,M.millisec],A=r.OraI18nUtils.partsToIsoString(H);if(null!==k){var K=P(k,n),R=G(K,H,!1,!0,!0);I=-K.ofset(R),I=r.OraI18nUtils.getTimeStringFromOffset("",I,!1,!0)}return""!==I&&(A+=I),{value:A}}function ke(e,t,r){for(var a=r.replace(f,"\\\\$1"),n=["^"],o=0,i=0,s={locale:e,numberingSystem:t,calendar:"gregorian"},l=h.exec(a);null!==l;){var d=a.slice(i,l.index);if(i=h.lastIndex,(o+=D(d,n))%2==0){var u=l[0];"/"!==u&&"zzzz"!==u&&"zzz"!==u&&"zz"!==u&&"z"!==u&&(void 0!==x[u]?(void 0!==x[u].key&&(s[x[u].key]=x[u].value),"kk"===u||"HH"===u||"H"===u||"k"===u?s.hour12=!1:"KK"!==u&&"hh"!==u&&"h"!==u&&"K"!==u||(s.hour12=!0)):L(r,s,u))}l=h.exec(a)}return s}function Ue(e){var t=e.indexOf("T");return-1===t?0:t>0?2:1}function Me(e,t){if(void 0!==e.pattern)return function(e){var t=ke("","",e),r=void 0!==t.year||void 0!==t.month||void 0!==t.weekday||void 0!==t.day,a=void 0!==t.hour||void 0!==t.minute||void 0!==t.second||void 0!==t.millisecond;return r&&a?2:a?1:0}(e.pattern);var a=r.OraI18nUtils.getGetOption(e,t),n=void 0!==a("hour","string",["2-digit","numeric"])||void 0!==a("minute","string",["2-digit","numeric"])||void 0!==a("second","string",["2-digit","numeric"])||void 0!==a("millisecond","string",["numeric"]),o=void 0!==a("year","string",["2-digit","numeric"])||void 0!==a("month","string",["2-digit","numeric","narrow","short","long"])||void 0!==a("day","string",["2-digit","numeric"])||void 0!==a("weekday","string",["narrow","short","long"]);if(o&&n)return 2;if(n)return 1;if(o)return 0;var i=a("formatType","string",["date","time","datetime"],"date");return"datetime"===i?2:"time"===i?1:0}function be(e,t){var r=G(e,t,!1,!0,!1),a=e.ofset(r),n=e.ofset(r+1);return Math.max(a,n)}function Ee(e,t,a){var n,o,i,s,l=e.isoStrParts,d=e.format,u=P(t.timeZone,a);switch(n=Date.UTC(l[0],l[1]-1,l[2],l[3],l[4],l[5]),d){case"offset":var m=H(e.timeZone),c=m[0],g=m[1];o=60*c+(c<0?-g:g);break;case"zulu":o=0}n-=6e4*((i=be(u,l))+o);var v=r.OraI18nUtils.getGetOption(t,"OraDateTimeConverter")("dst","boolean",[!0,!1],!1),p=0===e.dateTime.indexOf("T");s=u.parse(n,v,!p,!1),i=-u.ofset(s),i-=o;var f=new Date(Date.UTC(l[0],l[1]-1,l[2],l[3],l[4],l[5])),h=f.getUTCMinutes()+i;f.setUTCHours(f.getUTCHours()+(h/60<<0),h%60),l[0]=f.getUTCFullYear(),l[1]=f.getUTCMonth()+1,l[2]=f.getUTCDate(),l[3]=f.getUTCHours(),l[4]=f.getUTCMinutes(),l[5]=f.getUTCSeconds()}function xe(e,t){var a,n="";switch(e){case 0:n=r.OraI18nUtils.padZeros(t[0],4)+"-"+r.OraI18nUtils.padZeros(t[1],2)+"-"+r.OraI18nUtils.padZeros(t[2],2);break;case 1:n="T"+r.OraI18nUtils.padZeros(t[3],2)+":"+r.OraI18nUtils.padZeros(t[4],2)+":"+r.OraI18nUtils.padZeros(t[5],2),(a=t[6])>0&&(n+="."+r.OraI18nUtils.trimRightZeros(r.OraI18nUtils.padZeros(a,3)));break;default:n=r.OraI18nUtils.padZeros(t[0],4)+"-"+r.OraI18nUtils.padZeros(t[1],2)+"-"+r.OraI18nUtils.padZeros(t[2],2)+"T"+r.OraI18nUtils.padZeros(t[3],2)+":"+r.OraI18nUtils.padZeros(t[4],2)+":"+r.OraI18nUtils.padZeros(t[5],2),(a=t[6])>0&&(n+="."+r.OraI18nUtils.trimRightZeros(r.OraI18nUtils.padZeros(a,3)))}return n}function we(e,t,a,n,o,i){var s=P(e,o),l=G(s,t,a,n,i),d=s.ofset(l);return r.OraI18nUtils.getTimeStringFromOffset("",d,!0,!0)}function Te(e,t,a,n){var o,i,s,l=r.OraI18nUtils.getGetOption(a,"OraDateTimeConverter.parse"),d=l("isoStrFormat","string",["zulu","offset","invariant","local","auto"],"auto"),u=l("dst","boolean",[!0,!1],!1),m=!0,c=t.isoStrParts,g=t.timeZone,v=a.timeZone,p=t.format,f=a.isoStrFormat,h=xe(e,c);if(0===e||"local"===f)return h;switch(1===e&&(m=!1),d){case"offset":void 0===v&&"offset"===p?h+=g:void 0===v&&"local"===p?h+="":void 0===v&&"zulu"===p?h+="+00:00":void 0!==v&&(h+=s=we(v,c,u,m,n,!0));break;case"zulu":var y=0;if(void 0===v){if("offset"===p){s=H(g);var O=parseInt(s[0],10),I=parseInt(s[1],10);y=-(y=60*O+(O<0?-I:I))}}else i=G(o=P(v,n),c,u,m,!0),y=s=o.ofset(i);if(0!==y){var k=new Date(Date.UTC(c[0],c[1]-1,c[2],c[3],c[4],c[5],c[6]));y=k.getUTCMinutes()+y,k.setUTCHours(k.getUTCHours()+(y/60<<0),y%60),c[0]=k.getUTCFullYear(),c[1]=k.getUTCMonth()+1,c[2]=k.getUTCDate(),c[3]=k.getUTCHours(),c[4]=k.getUTCMinutes(),c[5]=k.getUTCSeconds(),h=xe(e,c)}h+="Z";break;case"auto":void 0!==v?h+=s=we(v,c,u,m,n,!0):(s=g)&&(h+=s)}return h}function Se(e,t,a,n){var o,i,s=r.OraI18nUtils.getNumberingExtension(n);if(void 0===r.OraI18nUtils.numeringSystems[s]&&(s="latn"),"latn"!==s){for(var l=[],d=0;d<e.length;d++){var u=r.OraI18nUtils.numeringSystems[s].indexOf(e[d]);-1!==u?l.push(u):l.push(e[d])}e=l.join("")}(arguments.length<=2||void 0===a)&&(a={year:"numeric",month:"numeric",day:"numeric"});var m,c,g=r.OraI18nUtils._ISO_DATE_REGEXP.test(e),v={};return!0===g?(m=e,o=Ue(e)):(i=a.pattern||z(a,t,n,"OraDateTimeConverter.parse"),o=Me(a,"OraDateTimeConverter.parse"),m=(v=Ie(e,i,a,t)).value),c=r.OraI18nUtils.getISOStrFormatInfo(m),void 0!==a.timeZone&&"local"!==c.format&&Ee(c,a,t),m=Te(o,c,a,t),v.value=m,v}function De(e,t,r,a,n,o,i){var s=ke(a,n,o.pattern);return s.pattern=o.pattern,void 0!==e&&(s.isoStrFormat=e),void 0!==t&&(s.timeZone=t),void 0!==r&&(s.dst=r),s["two-digit-year-start"]=w(o),s.lenientParse=i("lenientParse","string",["none","full"],"full"),s}function Le(e,t,r,a,n,o,i,s){var l={locale:s,numberingSystem:i,calendar:"gregorian"};if(0===Object.keys(e).length)return l.year="numeric",l.month="numeric",l.day="numeric",l.lenientParse="full",l;void 0!==r&&(l.timeZone=r,void 0!==n&&(l.isoStrFormat=n)),function(e,t){var r=t,a=e("formatUsing","string",["displayName","calendar"]);void 0!==a&&(r.formatUsing=a),void 0!==(a=e("dateField","string",["day","week","month","year","hour","minute","second"]))&&(r.dateField=a),void 0!==(a=e("relativeTime","string",["fromNow","toNow"]))&&(r.relativeTime=a),void 0!==(a=e("dateOnly","boolean",[!0,!1]))&&(r.dateOnly=a)}(t,l);var d=function(e,t,r,a){var n,o=t,i=!1;return void 0!==r&&(o.dst=r),void 0!==(n=e("year","string",["2-digit","numeric"]))&&(o.year=n,i=!0),void 0!==(n=e("era","string",["narrow","short","long"]))&&(o.era=n,i=!0),void 0!==(n=e("month","string",["2-digit","numeric","narrow","short","long"]))&&(o.month=n,i=!0),void 0!==(n=e("day","string",["2-digit","numeric"]))&&(o.day=n,i=!0),void 0!==(n=e("weekday","string",["narrow","short","long"]))&&(o.weekday=n,i=!0),void 0!==(n=e("hour","string",["2-digit","numeric"]))&&(o.hour=n,i=!0,void 0===(n=e("hour12","boolean",[!0,!1]))&&(n=T(a)),o.hour12=n),void 0!==(n=e("minute","string",["2-digit","numeric"]))&&(o.minute=n,i=!0),void 0!==(n=e("second","string",["2-digit","numeric"]))&&(o.second=n,i=!0),void 0!==(n=e("millisecond","string",["numeric"]))&&(o.millisecond=n,i=!0),i}(t,l,a,o);if(l["two-digit-year-start"]=w(e),!d)return function(e,t,r,a){var n=e,o=S(t,r,u.resolvedOptions),i=a("formatType","string",["date","time","datetime"],"date"),s=a("dateFormat","string",["short","medium","long","full"],"short"),l=a("timeFormat","string",["short","medium","long","full"],"short");n.formatType=i,"datetime"!==i&&"date"!==i||(n.dateFormat=s),"datetime"!==i&&"time"!==i||(n.timeFormat=l),n.patternFromOptions=o,n.lenientParse=a("lenientParse","string",["none","full"],"full")}(l,e,o,t),l;if(void 0!==r){var m=t("timeZoneName","string",["short","long"]);void 0!==m&&(l.timeZoneName=m)}return l.lenientParse=t("lenientParse","string",["none","full"],"full"),l.patternFromOptions=z(l,o,s,"OraDateTimeConverter.resolvedOptions"),l}function Ce(e,t,r){return{calendar:"gregorian",locale:t,numberingSystem:r,year:"numeric",month:"numeric",day:"numeric",patternFromOptions:z({year:"numeric",month:"numeric",day:"numeric"},e,t,"OraDateTimeConverter.resolvedOptions"),lenientParse:"full"}}function Ze(e,t,a){var n,o,i;(arguments.length<3||void 0===a)&&(a=r.OraI18nUtils.getLocaleElementsMainNodeKey(e)),(arguments.length<2||void 0===t)&&(t={year:"numeric",month:"numeric",day:"numeric"});var s=r.OraI18nUtils.getGetOption(t,"OraDateTimeConverter.resolvedOptions");void 0!==t&&(o=s("isoStrFormat","string",["zulu","offset","invariant","local","auto"],"auto"),i=s("dst","boolean",[!0,!1],!1),n=t.timeZone);var l=r.OraI18nUtils.getNumberingExtension(a);return void 0===r.OraI18nUtils.numeringSystems[l]&&(l="latn"),void 0!==t&&void 0!==t.pattern?De(o,n,i,a,l,t,s):void 0!==t?Le(t,s,n,i,o,e,l,a):Ce(e,a,l)}function _e(){return{format:function(e,t,a,n){var o;if("number"==typeof e)o=r.OraI18nUtils.dateToLocalIso(new Date(e));else{if("string"!=typeof e)return null;if(""===(o=r.OraI18nUtils.trim(e)))return null}(arguments.length<=2||void 0===a)&&(a={year:"numeric",month:"numeric",day:"numeric"});var i=r.OraI18nUtils.getISOStrFormatInfo(o),s=A(t,a,i,n),l=r.OraI18nUtils.getNumberingExtension(n);if(void 0===r.OraI18nUtils.numeringSystems[l]&&(l="latn"),"latn"!==l){for(var d=[],u=0;u<s.length;u++)s[u]>="0"&&s[u]<="9"?d.push(r.OraI18nUtils.numeringSystems[l][s[u]]):d.push(s[u]);return d.join("")}return s},formatRelative:function(e,t,r){return ne(e,t,r)},parse:function(e,t,r,a){return Se(e,t,r,a)},resolvedOptions:function(e,t,r){return Ze(e,t,r)},calculateWeek:function(e){var t,a=r.OraI18nUtils._IsoStrParts(e),n=new Date(Date.UTC(a[0],a[1]-1,a[2]));return n.setUTCDate(n.getUTCDate()+4-(n.getUTCDay()||7)),t=n.getTime(),n.setUTCMonth(0),n.setUTCDate(1),Math.floor(Math.round((t-n)/864e5)/7)+1},getAvailableTimeZones:function(e){return function(e){var t=n.OraTimeZone.getInstance(),o={sensitivity:"variant"},i=r.OraI18nUtils.getLocaleElementsMainNodeKey(e),s=r.OraI18nUtils.getLocaleElementsMainNode(e),l=re(r.OraI18nUtils.getLocaleElementsMainNodeKey(e)),d=s.dates.timeZoneNames.metazone,u=s.dates.timeZoneNames.zone,m=[],c={},g=e.supplemental.timeZoneData,v=new Date,p=[v.getFullYear(),v.getMonth()+1,v.getDate(),v.getHours(),v.getMinutes(),v.getSeconds()];function f(t,a,n,o){var i,s,d=t.split("/"),u=d[0],m=d[1],c={},g=o[u];"en"===l?void 0!==d[1]&&(i=(i=(i=" "+d[1]).replace(/_/g," ")).replace("Saigon","Ho Chi Minh City")):void 0!==g&&void 0!==(i=g[m])&&void 0!==(i=i.exemplarCity)&&(i=" "+i);var v=u+"/"+m,f=e.supplemental.metazones,h=j(p,v,f);if(void 0!==n&&(h=n[h]),null!=h&&void 0!==h.long&&void 0===(s=h.long.generic)&&(s=h.long.standard),void 0===i)return null;var y="(UTC)";return 0!==a&&(y="("+(y=r.OraI18nUtils.getTimeStringFromOffset("UTC",a,!0,!0))+")"),void 0===s&&(s=""),""!==s&&(s=" - "+s),c.offsetLocName=y+i+s,c.locName=i+s,c}function h(e,t){return e.find(({displayName:e})=>e.offsetLocName===t.offsetLocName)}function y(r){for(var a,n=Object.keys(r),o=0;o<n.length;o++){var i=n[o];if(-1===i.indexOf("Etc/")&&-1===i.indexOf("Ho_Chi_Minh")){var s=f(i,a=be(t.getZone(i,e),p),d,u);if(null!==s)h(m,s)||("Asia/Saigon"===i&&(i="Asia/Ho_Chi_Minh"),m.push({id:i,displayName:s}));c[i]=a}}}var O=r.OraI18nUtils.getLocaleElementsMainNodeKey(e);if(void 0!==a[O]){var I=a[O].availableTimeZones;if(void 0!==I)return I}y(g.zones),y(g.links),m.sort(function(e,t){return c[t.id]-c[e.id]+e.displayName.locName.localeCompare(t.displayName.locName,i,o)});for(var k=m.length,U=0;U<k;U++)m[U].displayName=m[U].displayName.offsetLocName;return void 0===a[O]&&(a[O]={},a[O].availableTimeZones=m),m}(e)},compareISODates:function(e,t,a){var n=function(e,t){var a={isoStrFormat:"local"},n=r.OraI18nUtils.getISOStrFormatInfo(e),o=r.OraI18nUtils.getISOStrFormatInfo(t),i=n.format,s=o.format;return"local"===i||"local"===s||(a.isoStrFormat="zulu"),a}(e,t),o=Se(e,a,n,"en-US"),i=Se(t,a,n,"en-US"),s=o.value.replace("Z",""),l=i.value.replace("Z",""),d=r.OraI18nUtils._IsoStrParts(s);d=Date.UTC(d[0],d[1]-1,d[2],d[3],d[4],d[5],d[6]);var u=r.OraI18nUtils._IsoStrParts(l);return d-(u=Date.UTC(u[0],u[1]-1,u[2],u[3],u[4],u[5],u[6]))},isHour12:function(e){return T(e)},getTimePositioning:function(e,t,a){var n=Ze(e,t,a),o=n.pattern||n.patternFromOptions;o=(o=o.replace(/'[^']*'/g,"").replace(/[^hHkKma]*/g,"")).replace(/(h|H|k|K)+/,"h").replace(/m+/,"m");var i=re(r.OraI18nUtils.getLocaleElementsMainNodeKey(e)),s="ar"===i||"he"===i,l={},d=0,u=o.length;for(d=0;d<u;d++)l[o.charAt(d)]=d;return s&&(d=l.h,l.h=l.m,l.m=d),l}}}return{getInstance:function(){return e||(e=_e()),e}}}(),m=function(e){this.Init(e)};oj.Object.createSubclass(m,o,"oj.DateTimeConverter"),m.prototype.Init=function(e){m.superclass.Init.call(this,e)},m.prototype.format=function(e){return m.superclass.format.call(this,e)},m.prototype.isHourInDaySet=function(){oj.Assert.failedInAbstractFunction()},m.prototype.isHourInAMPMSet=function(){oj.Assert.failedInAbstractFunction()},m.prototype.isMinuteSet=function(){oj.Assert.failedInAbstractFunction()},m.prototype.isSecondSet=function(){oj.Assert.failedInAbstractFunction()},m.prototype.isMilliSecondSet=function(){oj.Assert.failedInAbstractFunction()},m.prototype.isYearSet=function(){oj.Assert.failedInAbstractFunction()},m.prototype.isMonthSet=function(){oj.Assert.failedInAbstractFunction()},m.prototype.isDaySet=function(){oj.Assert.failedInAbstractFunction()},m.prototype.isDayNameSet=function(){oj.Assert.failedInAbstractFunction()},m.prototype.calculateWeek=function(e){oj.Assert.failedInAbstractFunction()},m.prototype.parse=function(e){return m.superclass.parse.call(this,e)},m.prototype.compareISODates=function(e,t){return m.superclass.compareISODates.call(this,e,t)},m.prototype.getAvailableTimeZones=function(){return m.superclass.getAvailableTimeZones.call(this)};const c=function(e){this.Init(e)};l.Object.createSubclass(c,m,"oj.IntlDateTimeConverter"),c._DEFAULT_DATE=new Date(1998,10,29,15,45,31),c.prototype.Init=function(e){c.superclass.Init.call(this,e)},c.prototype._getWrapped=function(){return this._wrapped||(this._wrapped=u.getInstance()),this._wrapped},c.prototype.format=function(e){var t=a.__getBundle(),r=s.getLocale(),n=this.resolvedOptions();if(null==e||"string"==typeof e&&0===l.StringUtils.trim(""+e).length)return"";try{return this._getWrapped().format(e,t,n,r)}catch(t){throw this._processConverterError(t,e)}},c.prototype.formatRelative=function(e,t){var r=a.__getBundle(),n=s.getLocale();try{return this._getWrapped().formatRelative(e,r,t,n)}catch(t){throw this._processConverterError(t,e)}},c.prototype.getHint=function(){return null},c.prototype._getHintValue=function(){var e="";try{e=this.format(r.IntlConverterUtils.dateToLocalIso(c._DEFAULT_DATE))}catch(t){t instanceof d.ConverterError&&(e="")}return e},c.prototype.getOptions=function(){return c.superclass.getOptions.call(this)},c.prototype.resolvedOptions=function(){var e,r=s.getLocale(),n=this.getOptions();if(r!==this._locale||!this._resolvedOptions){e=a.__getBundle();try{if(!e)return t.error("locale bundle for the current locale %s is unavailable",r),{};this._resolvedOptions=this._getWrapped().resolvedOptions(e,n,r),this._locale=r}catch(e){throw this._processConverterError(e)}}return this._resolvedOptions},c.prototype.isHourInDaySet=function(){var e=this.resolvedOptions(),t=e.hour,r=e.hour12;return!(!t||r)},c.prototype.isHourInAMPMSet=function(){var e=this.resolvedOptions(),t=e.hour,r=e.hour12;return!(!t||!r)},c.prototype.isMinuteSet=function(){return this._isOptionSet("minute")},c.prototype.isSecondSet=function(){return this._isOptionSet("second")},c.prototype.isMilliSecondSet=function(){return this._isOptionSet("millisecond")},c.prototype.isYearSet=function(){return this._isOptionSet("year")},c.prototype.isMonthSet=function(){return this._isOptionSet("month")},c.prototype.isDaySet=function(){return this._isOptionSet("day")},c.prototype.isDayNameSet=function(){return this._isOptionSet("weekday")},c.prototype.calculateWeek=function(e){return this._getWrapped().calculateWeek(e,a.__getBundle(),s.getLocale())},c.prototype.parse=function(e){if(null==e||""===e)return null;var r=a.__getBundle(),n=s.getLocale(),o=this.resolvedOptions();try{var i=this._getWrapped().parse(e,r,o,n),l=i.value;return l&&i.warning&&t.warn("The value "+e+" was leniently parsed to represent a date "+l.toString?l.toString():l),l}catch(t){throw this._processConverterError(t,e)}},c.prototype.compareISODates=function(e,t){var r=l.StringUtils.isString;if(!r(e)||!r(t))throw new Error("Invalid arguments for compareISODates ",e,t);return this._getWrapped().compareISODates(e,t,a.__getBundle())},c.prototype._processConverterError=function(e,t){var a,n,o,s,u=e.errorInfo;if(u){var m=u.errorCode,c=u.parameterMap||{};l.Assert.assertObject(c);var g=c.propertyName;g=i.getTranslatedString("oj-converter.datetime.datetimeOutOfRange."+g),c.propertyName=g,e instanceof TypeError?"optionTypesMismatch"!==m&&"optionTypeInvalid"!==m||(o=r.IntlConverterUtils.__getConverterOptionError(m,c)):e instanceof RangeError?"optionOutOfRange"===m?o=r.IntlConverterUtils.__getConverterOptionError(m,c):"datetimeOutOfRange"===m?(a=i.getTranslatedString("oj-converter.datetime.datetimeOutOfRange.summary",{propertyName:g,value:c.value}),n=i.getTranslatedString("oj-converter.datetime.datetimeOutOfRange.detail",{minValue:c.minValue,maxValue:c.maxValue}),o=new d.ConverterError(a,n)):"isoStringOutOfRange"===m&&(a=i.getTranslatedString("oj-converter.datetime.invalidISOString.invalidRangeSummary",{isoStr:c.isoString,propertyName:g,value:c.value}),n=i.getTranslatedString("oj-converter.datetime.datetimeOutOfRange.detail",{minValue:c.minValue,maxValue:c.maxValue}),o=new d.ConverterError(a,n)):e instanceof SyntaxError?"optionValueInvalid"===m&&(o=r.IntlConverterUtils.__getConverterOptionError(m,c)):e instanceof Error&&("dateFormatMismatch"===m?s="oj-converter.datetime.dateFormatMismatch.summary":"timeFormatMismatch"===m?s="oj-converter.datetime.timeFormatMismatch.summary":"datetimeFormatMismatch"===m?s="oj-converter.datetime.datetimeFormatMismatch.summary":"invalidTimeZoneID"===m?(a=i.getTranslatedString("oj-converter.datetime.invalidTimeZoneID.summary",{timeZoneID:c.timeZoneID}),n=i.getTranslatedString("oj-converter.hint.detail",{exampleValue:this._getHintValue()}),o=new d.ConverterError(a,n)):"nonExistingTime"===m?s="oj-converter.datetime.nonExistingTime.summary":"missingTimeZoneData"===m?s="oj-converter.datetime.missingTimeZoneData.summary":"dateToWeekdayMismatch"===m?(a=i.getTranslatedString("oj-converter.datetime.dateToWeekdayMismatch.summary",{date:c.date,weekday:c.weekday}),n=i.getTranslatedString("oj-converter.datetime.dateToWeekdayMismatch.detail"),o=new d.ConverterError(a,n)):"invalidISOString"===m&&(a=i.getTranslatedString("oj-converter.datetime.invalidISOString.summary",{isoStr:c.isoStr}),n=i.getTranslatedString("oj-converter.datetime.invalidISOString.detail"),o=new d.ConverterError(a,n)),s&&(a=i.getTranslatedString(s,{value:t||c.value,format:c.format}),n=i.getTranslatedString("oj-converter.hint.detail",{exampleValue:this._getHintValue()}),o=new d.ConverterError(a,n)))}return o||(a=e.message,n=e.message,o=new d.ConverterError(a,n)),o},c.prototype._isOptionSet=function(e){return!!this.resolvedOptions()[e]},c.prototype.getAvailableTimeZones=function(){return this._getWrapped().getAvailableTimeZones(a.__getBundle())},e.DateTimeConverter=m,e.IntlDateTimeConverter=c,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojconverter-datetime.js.map