/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojcore-base","ojs/ojtranslation","jquery","ojs/ojconverterutils","ojs/ojvalidation-error","ojs/ojlogger"],function(e,t,r,n,a,o,i){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,n=n&&Object.prototype.hasOwnProperty.call(n,"default")?n.default:n,a=a&&Object.prototype.hasOwnProperty.call(a,"default")?a.default:a;const s={numeringSystems:{latn:"0123456789",arab:"٠١٢٣٤٥٦٧٨٩",thai:"๐๑๒๓๔๕๖๗๘๙"},regexTrim:/^\s+|\s+$|\u200f|\u200e/g,regexTrimNumber:/\s+|\u200f|\u200e/g,regexTrimRightZeros:/0+$/g,zeros:["0","00","000"],_ISO_DATE_REGEXP:/^[+-]?\d{4}(?:-\d{2}(?:-\d{2})?)?(?:T\d{2}:\d{2}(?::\d{2}(?:\.\d{1,3})?)?(Z|[+-]\d{2}(?::?\d{2})?)?)?$|^T\d{2}:\d{2}(?::\d{2}(?:\.\d{1,3})?)?(Z|[+-]\d{2}(?::?\d{2})?)?$/,getLocalTimeZoneOffset:function(){var e=(new Date).getTimezoneOffset();return s.getTimeStringFromOffset("Etc/GMT",e,!1,!1)},dateToLocalIso:function(e){var t=e;"number"==typeof t&&(t=new Date(t));var r=s.padZeros(t.getFullYear(),4)+"-"+s.padZeros(t.getMonth()+1,2)+"-"+s.padZeros(t.getDate(),2)+"T"+s.padZeros(t.getHours(),2)+":"+s.padZeros(t.getMinutes(),2)+":"+s.padZeros(t.getSeconds(),2);return t.getMilliseconds()>0&&(r+="."+s.trimRightZeros(s.padZeros(t.getMilliseconds(),3))),r},partsToIsoString:function(e){var t=s.padZeros(e[0],4)+"-"+s.padZeros(e[1],2)+"-"+s.padZeros(e[2],2)+"T"+s.padZeros(e[3],2)+":"+s.padZeros(e[4],2)+":"+s.padZeros(e[5],2);return e[6]>0&&(t+="."+s.trimRightZeros(s.padZeros(e[6],3))),t},isoToLocalDate:function(e){return e&&"string"==typeof e?this._isoToLocalDateIgnoreTimezone(e):null},_isoToLocalDateIgnoreTimezone:function(e){var t=s._IsoStrParts(e),r=new Date(t[0],t[1]-1,t[2],t[3],t[4],t[5],t[6]);return r.setFullYear(t[0]),r},_IsoStrParts:function(e){!1===s._ISO_DATE_REGEXP.test(e)&&s._throwInvalidISOStringSyntax(e);var t,r=e.split("T"),n=e.indexOf("T"),a=new Date,o=!1,i=[a.getFullYear(),a.getMonth()+1,a.getDate(),0,0,0,0];if(""!==r[0]){s.startsWith(r[0],"-")&&(r[0]=r[0].substr(1),o=!0);var u=r[0].split("-");for(t=0;t<u.length;t++){var l=parseInt(u[t],10);if(1===t&&(l<1||l>12)&&s._throwInvalidISOStringRange(e,"month",l,1,12),2===t){var g=s._getDaysInMonth(i[0],i[1]-1);(l<1||l>g)&&s._throwInvalidISOStringRange(e,"day",l,1,g)}i[t]=l}o&&(i[0]=-i[0])}if(-1!==n){var p=r[1].split("."),f=p[0].split(":");for(t=0;t<f.length;t++){var d=parseInt(f[t],10);0===t&&(d<0||d>24)&&s._throwInvalidISOStringRange(e,"hour",d,0,24),1===t&&(d<0||d>59)&&s._throwInvalidISOStringRange(e,"minute",d,0,59),2===t&&(d<0||d>59)&&s._throwInvalidISOStringRange(e,"second",d,0,59),i[3+t]=d}2===p.length&&p[1]&&(i[6]=parseInt(s.zeroPad(p[1],3,!1),10))}return i},getISOStrFormatInfo:function(e){var t={format:null,dateTime:null,timeZone:"",isoStrParts:null},r=s._ISO_DATE_REGEXP.exec(e);if(null===r&&s._throwInvalidISOStringSyntax(e),void 0===r[1]&&void 0===r[2])return t.format="local",t.dateTime=e,t.isoStrParts=s._IsoStrParts(t.dateTime),t;t.timeZone=void 0!==r[1]?r[1]:r[2],"Z"===t.timeZone?t.format="zulu":t.format="offset";var n=e.length,a=t.timeZone.length;return t.dateTime=e.substring(0,n-a),t.isoStrParts=s._IsoStrParts(t.dateTime),t},getISOStrFormatType:function(e){let t;const r=s._ISO_DATE_REGEXP.exec(e);if(null===r&&s._throwInvalidISOStringSyntax(e),void 0===r[1]&&void 0===r[2])return t="local",t;return t="Z"===(void 0!==r[1]?r[1]:r[2])?"zulu":"offset",t},_isLeapYear:function(e){return e%400==0||e%100!=0&&e%4==0},_getDaysInMonth:function(e,t){switch(t){case 0:case 2:case 4:case 6:case 7:case 9:case 11:return 31;case 1:return s._isLeapYear(e)?29:28;default:return 30}},_throwInvalidISOStringRange:function(e,t,r,n,a){var o=new RangeError("The string "+e+" is not a valid ISO 8601 string: "+r+" is out of range.  Enter a value between "+n+" and "+a+" for "+t),i={errorCode:"isoStringOutOfRange",parameterMap:{isoString:e,value:r,minValue:n,maxValue:a,propertyName:t}};throw o.errorInfo=i,o},_throwInvalidISOStringSyntax:function(e){var t=new Error("The string "+e+" is not a valid ISO 8601 string syntax."),r={errorCode:"invalidISOString",parameterMap:{isoStr:e}};throw t.errorInfo=r,t},trim:function(e){return(e+"").replace(s.regexTrim,"")},trimRightZeros:function(e){return(e+"").replace(s.regexTrimRightZeros,"")},trimNumber:function(e){return(e+"").replace(s.regexTrimNumber,"")},startsWith:function(e,t){return 0===e.indexOf(t)},toUpper:function(e){return e.split(" ").join(" ").toUpperCase()},padZeros:function(e,t){var r=e+"",n=!1;return e<0&&(r=r.substr(1),n=!0),t>1&&r.length<t&&(r=(r=s.zeros[t-2]+r).substr(r.length-t,t)),n&&(r="-"+r),r},zeroPad:function(e,t,r){for(var n=""+e,a=n.length;a<t;a+=1)n=r?"0"+n:n+"0";return n},getTimeStringFromOffset:function(e,t,r,n){var a=r?t>=0:t<0,o=Math.abs(t),i=Math.floor(o/60),u=o%60,l=a?"-":"+";n&&(i=s.zeroPad(i,2,!0));var g=e+l+i;return(u>0||n)&&(g+=":"+s.zeroPad(u,2,!0)),g},getNumberingSystemKey:function(e,t){if(void 0===t)return"latn";var r=s.getNumberingExtension(t),n="symbols-numberSystem-"+r;return void 0===e.numbers[n]&&(r="latn"),r},getBCP47Lang:function(e){return e.split("-")[0]},getBCP47Region:function(e){var t=e.split("-");return 3===t.length?t[2]:2===t.length&&2===t[1].length?t[1]:"001"},getNumberingExtension:function(e){var t=e||"en-US",r=t.indexOf("-u-nu-"),n="latn";return-1!==r&&(n=t.substr(r+6,4)),n},haveSamePropertiesLength:function(e){return Object.keys(e).length},getLocaleElementsMainNode:function(e){var t=e.main;return t[Object.keys(t)[0]]},getLocaleElementsMainNodeKey:function(e){var t=e.main;return Object.keys(t)[0]},_toBoolean:function(e){if("string"==typeof e)switch(e.toLowerCase().trim()){case"true":case"1":return!0;case"false":case"0":return!1;default:return e}return e},getGetOption:function(e,t){if(void 0===e)throw new Error("Internal "+t+" error. Default options missing.");return function(r,n,a,o){if(void 0!==e[r]){var i=e[r];switch(n){case"boolean":i=s._toBoolean(i);break;case"string":i=String(i);break;case"number":i=Number(i);break;default:throw new Error("Internal error. Wrong value type.")}if(void 0!==a&&-1===a.indexOf(i)){for(var u=[],l=0;l<a.length;l++)u.push(a[l]);var g="The value '"+e[r]+"' is out of range for '"+t+"' options property '"+r+"'. Valid values: "+u,p=new RangeError(g),f={errorCode:"optionOutOfRange",parameterMap:{propertyName:r,propertyValue:e[r],propertyValueValid:u,caller:t}};throw p.errorInfo=f,p}return i}return o}},matchString:function(e,t,r,n){void 0===n&&(n={sensitivity:"base",usage:"sort"});var a=s.getGetOption(n,"OraI18nUtils.matchString");n.usage=a("usage","string",["sort","search"],"sort"),n.sensitivity=a("sensitivity","string",["base","accent","case","variant"],"base");for(var o=e.length,i=t.length-1,u=0;u<o;u++)for(var l=0;l<3;l++){var g=o-u;if(g=Math.min(g,i+l),0===e.substr(u,g).localeCompare(t,r,n))return[u,u+(g-1)]}return null}};var u={fullYear:{pos:0,pad:4},month:{pos:1,pad:2},date:{pos:2,pad:2},hours:{pos:3,pad:2},minutes:{pos:4,pad:2},seconds:{pos:5,pad:2},milliseconds:{pos:6,pad:3},timeZone:{pos:7}};s.isoToDate=function(e){return new Date(this._normalizeIsoString(e))},s._copyTimeOver=function(e,t){if(!e||!t)throw new Error("Provided invalid arguments");var r=this._normalizeIsoString(t),n=e.indexOf("T"),a=r.indexOf("T");return r.substring(0,a)+(-1!==n?e.substring(n):"T00:00:00.000")},s._clearTime=function(e){return this._dateTime(e,{hours:0,minutes:0,seconds:0,milliseconds:0})},s._dateTime=function(e,t,r){if(!e||!t)throw new Error("Invalid argument invocation");var a,o,i=null,s=u,l=this.padZeros,g=this._normalizeIsoString(e),p=/(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):?(\d{2})?\.?(\d{3})?(.*)?/.exec(g);if(!p)throw new Error("Unable to capture anything");if(p=p.slice(1),Array.isArray(t)){i={};for(var f=0,d=t.length;f<d;f++){var c=t[f];if(c in s){if(o=p[a=s[c].pos],r&&"timeZone"===c)throw new Error("Dude you tried to ask timezone to be parsed");if(r){var m=parseInt(o,10);i[c]=1===a?m-1:m}else i[c]=o}}}else if(n.isPlainObject(t)){for(var v=Object.keys(t),h=0;h<v.length;h++){var y=v[h],S=s[y];a=S.pos,o=t[y],1===a&&"number"==typeof o&&(o+=1),p[a]=S.pad?l(o,S.pad):o}i=p[0]+"-"+p[1]+"-"+p[2]+"T"+p[3]+":"+p[4]+":"+p[5]+(p.length>6&&p[6]?"."+p[6]+(8===p.length&&p[7]?p[7]:""):"")}return i},s._normalizeIsoString=function(e){if(!e)throw new Error("Provided invalid arguments");var t,r=(new Date).toISOString(),n=r.substring(0,r.indexOf("T")),a=e.indexOf("T"),o=-1===a?e:e.substring(0,a);return(o=o||n)+(-1!==a?(t=e.substring(a)).split(":").length>1?t:t+":00":"T00:00:00.000")},s.formatString=function(e,t){for(var r=t.length,n=e,a=0;a<r;a++){var o="{"+a+"}";n=n.replace(o,t[a])}return n},s.getInitials=function(e,t){var r,n=0,a=0;if(void 0!==e&&e.length>0&&(n=e.charCodeAt(0)),n>=1536&&n<=1791)return"";if(n>=2304&&n<=2431)return e.charAt(0);if(n>=3584&&n<=3711)return e.charAt(0);if(n>=4352&&n<=4607||n>=12592&&n<=12687||n>=43360&&n<=43391||n>=44032&&n<=55295)return e;if(void 0!==t&&t.length>0&&(n=t.charCodeAt(0)),n>=11904&&n<=12255||n>=12288&&n<=12591||n>=12688&&n<=12799||n>=13056&&n<=19903||n>=19968&&n<=40959||n>=63744&&n<=64255)return t;if(n>=55296&&n<=56319){if(t.length<2)return"";if((a=t.charCodeAt(1))<56320||a>57343)return"";if((r=1024*(n-55296)+(a-56320)+65536)>=110592&&r<=110847||r>=127488&&r<=127743||r>=131072&&r<=173791||r>=173824&&r<=177983||r>=177984&&r<=178207||r>=178208&&r<=183983||r>=194560&&r<=195103)return t}return n="",a="",void 0!==e&&e.length>0&&(n=e.charAt(0).toUpperCase()),void 0!==t&&t.length>0&&(a=t.charAt(0).toUpperCase()),n+a};const l={isoToDate:function(e){return s.isoToDate(e)},isoToLocalDate:function(e){return s.isoToLocalDate(e)},dateToLocalIso:function(e){return s.dateToLocalIso(e)},getLocalTimeZoneOffset:function(){return s.getLocalTimeZoneOffset()},getConverterInstance:function(e){return a.getConverterInstance(e)},_minMaxIsoString:function(e,t){if(e){var r=(t=t||this.dateToLocalIso(new Date)).indexOf("T");0===e.indexOf("T")&&r>0&&(e=t.substring(0,r)+e)}return e},_getISOStrFormatType:function(e){return s.getISOStrFormatType(e)},_verifyValueMinMax:function(e,t,r){let n,a,o;if(e)try{n=l._getISOStrFormatType(e)}catch(e){i.warn("value must be an iso string: "+e)}if(t)try{a=l._getISOStrFormatType(t)}catch(e){i.warn("min must be an iso string: "+e)}if(r)try{o=l._getISOStrFormatType(r)}catch(e){i.warn("max must be an iso string: "+e)}e&&t&&r&&(n!==a||n!==o)&&i.warn(`min and max must be in the same iso string format as value.\n    value is in ${n} format.`),e&&t&&n!==a&&i.warn(`min must be in the same iso string format as value.\n    value is in ${n} format.`),e&&r&&n!==o&&i.warn(`max must be in the same iso string format as value.\n      value is in ${n} format.`),t&&r&&a!==o&&i.warn(`min and max must be in the same iso string format.\n      min is in ${a} format and max is in ${o} format.`)},__getConverterOptionError:function(e,n){t.Assert.assertObject(n);var a,i="",s="",u=n.propertyName;if("optionTypesMismatch"===e){var g=n.requiredPropertyName;a=n.requiredPropertyValueValid,i=r.getTranslatedString("oj-converter.optionTypesMismatch.summary",{propertyName:u,propertyValue:n.propertyValue,requiredPropertyName:g}),s=l._getOptionValueDetailMessage(g,a)}else"optionTypeInvalid"===e?(u=n.propertyName,a=n.propertyValueValid,i=r.getTranslatedString("oj-converter.optionTypeInvalid.summary",{propertyName:u}),s=l._getOptionValueDetailMessage(u,a)):"optionOutOfRange"===e?(i=r.getTranslatedString("oj-converter.optionOutOfRange.summary",{propertyName:u,propertyValue:n.propertyValue}),a=n.propertyValueValid,s=l._getOptionValueDetailMessage(u,a)):"optionValueInvalid"===e&&(i=r.getTranslatedString("oj-converter.optionValueInvalid.summary",{propertyName:u,propertyValue:n.propertyValue}),a=n.propertyValueHint,s=l._getOptionValueDetailMessage(u,a));return new o.ConverterError(i,s)},_getOptionValueDetailMessage:function(e,t){var n;return t?("string"==typeof t?n="oj-converter.optionHint.detail":(n="oj-converter.optionHint.detail-plural",t=t.join(r.getTranslatedString("oj-converter.plural-separator"))),r.getTranslatedString(n,{propertyName:e,propertyValueValid:t})):""},_copyTimeOver:function(e,t){return s._copyTimeOver(e,t)},_clearTime:function(e){return s._clearTime(e)},_dateTime:function(e,t,r){return s._dateTime(e,t,r)},_normalizeIsoString:function(e){return s._normalizeIsoString(e)},getInitials:function(e,t){return s.getInitials(e,t)}};e.IntlConverterUtils=l,e.OraI18nUtils=s,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojconverterutils-i18n.js.map