/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["ojs/ojcore","ojs/ojlogger","ojs/ojcustomelement-utils","ojs/ojtrace-event","ojs/ojmetadatautils","ojs/ojbootstrap","ojs/ojcore-base"],function(e,t,r,n,i,o,s){"use strict";e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e,s=s&&Object.prototype.hasOwnProperty.call(s,"default")?s.default:s;const a={};a.proto={getClass:function(e){var t=Object.create(HTMLElement.prototype);this.InitializePrototype(t),t.dispatchEvent=n.traceDispatchEvent(HTMLElement.prototype.dispatchEvent);var i=this.GetMetadata(e);a._enumerateMetadataForKey(t,i,"properties",this.DefinePropertyCallback.bind(this)),a._enumerateMetadataForKey(t,i,"methods",this.DefineMethodCallback.bind(this)),this.AddComponentMethods(t),t.setProperties=function(e){r.CustomElementUtils.getElementBridge(this)._setProperties(this,e)},Object.defineProperty(t,"set",{value:function(e,t){this.setProperty(e,t)}}),Object.defineProperty(t,"unset",{value:function(e){this.setProperty(e,void 0)}}),t.attributeChangedCallback=this.AttributeChangedCallback,t.connectedCallback=this._connectedCallback,t.disconnectedCallback=this._detachedCallback;const o=t.appendChild;t.appendChild=function(e){return r.CustomElementUtils.canRelocateNode(this,e)?o.call(this,e):e};const s=t.insertBefore;t.insertBefore=function(e,t){return r.CustomElementUtils.canRelocateNode(this,e)?s.call(this,e,t):e},t.setAttribute=function(e,t){if("class"===e){const e=r.CustomElementUtils.getClassSet(t);r.CustomElementUtils.getElementState(this).setOuterClasses(e)}else HTMLElement.prototype.setAttribute.call(this,e,t)},t.removeAttribute=function(e){"class"===e?this.setAttribute("class",""):HTMLElement.prototype.removeAttribute.call(this,e)};var l=function(){var e=window.Reflect;return void 0!==e?e.construct(HTMLElement,[],this.constructor):HTMLElement.call(this)},u=this;return Object.defineProperty(l,"observedAttributes",{get:function(){return u.GetAttributes(i)}}),Object.defineProperty(t,"constructor",{value:l,writable:!0,configurable:!0}),l.prototype=t,Object.setPrototypeOf(l,HTMLElement),l},initializeBridge:function(e,t){this.METADATA=this.GetMetadata(t),this._eventListeners={},this.State=r.CustomElementUtils.getElementState(e)},AddComponentMethods:function(e){},AttributeChangedCallback:function(e,n,o){const s=r.AttributeUtils.attributeToPropertyName(e),l=r.CustomElementUtils.getElementBridge(this);if(n!==o||l.State.dirtyProps.has(s)){if(l.State.dirtyProps.delete(s.split(".")[0]),"disabled"===e&&l.ShouldRemoveDisabled()&&l._isDisabledAttributeRemoved())return void(null!=o&&(t.warn("Ignoring 'disabled' attribute change after component initialization. Use element property setter instead."),l._removeDisabledAttribute(this)));if(l.ShouldHandleAttributeChanged(this)){a.__CheckOverlappingAttribute(this,e),null===o&&(o=void 0);var u={detail:{attribute:e,value:o,previousValue:n}};if(this.dispatchEvent(new CustomEvent("attribute-changed",u)),!r.AttributeUtils.getExpressionInfo(o).expr){const t=i.getPropertyMetadata(s,r.CustomElementUtils.getElementProperties(this));t&&this.setProperty(s,a.__ParseAttrValue(this,e,s,o,t)),l.HandleAttributeChanged(this,e,n,o)}}}},CreateComponent:function(e){},DefineMethodCallback:function(e,t,r){},DefinePropertyCallback:function(e,t,r){},GetAttributes:function(e){return e?i.getFlattenedAttributes(e.properties):[]},GetMetadata:function(e){return e[a.DESC_KEY_META]||{}},GetAliasForProperty:function(e){return e},ShouldHandleAttributeChanged:function(e){return this.State.canHandleAttributes()},ShouldCallHandleAttributeChanged:function(e){return this.ShouldHandleAttributeChanged()},HandleAttributeChanged:function(e,t,r,n){},HandleBindingsApplied:function(e,t){},HandleDetached:function(e){},HandleReattached:function(e){},InitializeElement:function(e){},InitializePrototype:function(e){},BatchedPropertySet:function(e,t){for(var r=Object.keys(t),n=0;n<r.length;n++){var i=r[n];e.setProperty(i,t[i])}},GetEventListenerProperty:function(e){var t=r.AttributeUtils.eventListenerPropertyToEventType(e),n=this._eventListeners[t];if(n)return n.getListener()},GetProperty:function(e,t,n){var o=i.getPropertyMetadata(t,r.CustomElementUtils.getElementProperties(e));return r.AttributeUtils.isEventListenerProperty(t)||!o||-1===t.indexOf(".")?n[t]:r.CustomElementUtils.getPropertyValue(n,t)},HandlePropertyChanged:function(e,t,r,n,i,o){var s=i?"external":"internal";a.__FirePropertyChangeEvent(e,t,r,n,s,o)},PlaybackEarlyPropertySets:function(e){if(this._earlySets)for(;this._earlySets.length;){var t=this._earlySets.shift();e.setProperty(t.property,t.value)}},SaveEarlyPropertySet:function(e,t,r){return!this.State.allowPropertySets()&&(this._earlySets||(this._earlySets=[]),this._earlySets.push({property:t,value:r}),!0)},SetEventListenerProperty:function(e,t,n){var i=r.AttributeUtils.eventListenerPropertyToEventType(t),o=this._eventListeners[i];o||(o=this._createEventListenerWrapper(),this._eventListeners[i]=o,e.addEventListener(i,o)),null==n||n instanceof Function?o.setListener(n):a.__ThrowTypeError(e,t,n,"function")},SetProperty:function(t,n,o,s,l){var u=i.getPropertyMetadata(n,r.CustomElementUtils.getElementProperties(t));if(r.AttributeUtils.isEventListenerProperty(n)||!u)t[n]=o;else{var p=t.getProperty(n),c=n.split(".")[0],d=s[c];if(e.CollectionUtils.isPlainObject(d)&&(d=e.CollectionUtils.copyInto({},d,void 0,!0)),!r.ElementUtils.comparePropertyValues(u,o,p)){var h=-1!==n.indexOf(".");if(h&&(this._SKIP_PROP_CHANGE_EVENT=!0),l?this.ValidateAndSetProperty(this.GetAliasForProperty.bind(this),s,n,o,t):a.__SetProperty(this.GetAliasForProperty.bind(this),s,n,o),this._SKIP_PROP_CHANGE_EVENT=!1,h){var y={path:n,value:o,previousValue:p};this.HandlePropertyChanged(t,c,s[c],d,l,y)}return this.State.dirtyProps.add(c),{property:c,propertySet:!0,isSubproperty:h}}}return{property:null,propertySet:!1,isSubproperty:!1}},ShouldRemoveDisabled:function(){return!0},ValidateAndSetProperty:function(e,t,r,n,i){var o=this.ValidatePropertySet(i,r,n);a.__SetProperty(e,t,r,o)},ValidatePropertySet:function(e,n,o){var s=r.CustomElementUtils.getElementProperties(e),l=i.getPropertyMetadata(n,s),u=n.split(".");if(l){if(s[u[0]].readOnly)throw new r.JetElementError(e,`Read-only property '${n}' cannot be set.`);try{i.checkEnumValues(e,n,o,l)}catch(t){throw new r.JetElementError(e,t.message)}return null!=o?a.checkType(e,n,o,l):o}t.warn(r.CustomElementUtils.getElementInfo(e)+": Ignoring property set for undefined property '"+n+"'.")},PostCreate:function(e){e.hasAttribute("disabled")&&this.ShouldRemoveDisabled()&&!this._isDisabledAttributeRemoved()&&this._removeDisabledAttribute(e)},_connected:function(e){const t=this.State;if(t.isComplete())this.HandleReattached(e);else if(t.startCreationCycle(),t.isCreating()){this.InitializeElement(e),t.setBindingProviderCallback(this.PlaybackEarlyPropertySets.bind(this,e));const r=()=>{try{t.getSlotMap(!0);return(this.CreateComponent(e)||Promise.resolve()).then(this.PostCreate.bind(this,e))}catch(e){return Promise.reject(e)}};t.setCreateCallback(r)}},_connectedCallback:function(){r.CustomElementUtils.getElementBridge(this)._connected(this)},_detachedCallback:function(){const e=r.CustomElementUtils.getElementBridge(this),t=e.State;t.isComplete()?e.HandleDetached(this):t.pauseCreationCycle()},_createEventListenerWrapper:function(){var e,t=function(t){e&&e(t)};return t.setListener=function(t){e=t},t.getListener=function(){return e},t},_setProperties:function(e,t){for(var r=[],n={},i=!1,o=Object.keys(t),s=0;s<o.length;s++){var a=o[s];a.indexOf(".")>=0?r.push(a):(n[a]=t[a],i=!0)}i&&this.BatchedPropertySet(e,n);for(var l=0;l<r.length;l++){var u=r[l];e.setProperty(u,t[u])}},_isDisabledAttributeRemoved:function(){return!0===this._disabledProcessed},_removeDisabledAttribute:function(e){this._disabledProcessed=!0,e.removeAttribute("disabled")}},a._enumerateMetadataForKey=function(e,t,r,n){if(t&&t[r]){var i=t[r];Object.keys(i).forEach(function(t){n(e,t,i[t])})}},a.checkType=function(e,t,n,i){const o=i.type,s=r.ElementUtils.getSupportedTypes(o);if(1===s.typeCount&&!s.any&&!s.other){const r=typeof n;if(s.array&&!Array.isArray(n)||s.object&&"object"!==r||s.string&&"string"!==r||s.number&&("number"!==r||!isFinite(n)))a.__ThrowTypeError(e,t,n,o);else if(s.boolean)return!!n}return n},a.__ThrowTypeError=function(e,t,n,i){throw new r.JetElementError(e,`Invalid type '${typeof n}' found for property '${t}'. Expected value of type '${i}'.`)},a.__CheckOverlappingAttribute=function(e,t){var n=t.split(".");if(n.length>1)for(n.pop();n.length;){var i=n.join(".");if(e.hasAttribute(i))throw new r.JetElementError(e,`Cannot set overlapping attributes '${t}' and '${i}'.`);n.pop()}},a.__InitProperties=function(e,t){const n=r.CustomElementUtils.getElementBridge(e);var o=r.CustomElementUtils.getElementProperties(e);if(o)for(var s=e.attributes,l=0;l<s.length;l++){var u=s[l],p=r.AttributeUtils.attributeToPropertyName(u.nodeName),c=i.getPropertyMetadata(p,o);if(c&&!c.readOnly)if(a.__CheckOverlappingAttribute(e,u.nodeName),!r.AttributeUtils.getExpressionInfo(u.value).expr){var d=a.__ParseAttrValue(e,u.nodeName,p,u.value,c);n.ValidateAndSetProperty(n.GetAliasForProperty.bind(n),t,p,d,e)}}},a.__SetProperty=function(e,t,r,n){var i,o=t,s=r.split("."),a=e(s[0]);s.length>1&&!t[a]&&(o=i={});for(var l=0;l<s.length;l++){var u=e(s[l]);l===s.length-1?o[u]=n:o[u]||(o[u]={}),o=o[u]}i&&(t[a]=i[a])},a.__ParseAttrValue=function(e,t,n,i,o){if(null==i)return i;function s(n){return r.AttributeUtils.attributeToPropertyValue(e,t,n,o)}var a=r.CustomElementUtils.getElementDescriptor(e.tagName).parseFunction;return a?a(i,n,o,function(e){return s(e)}):s(i)},a.__ProcessEventListeners=function(t){var n=e.CollectionUtils.copyInto({},t,void 0,!0,1);return n.properties=n.properties||{},a._enumerateMetadataForKey(null,n,"properties",function(e,t){var i=r.AttributeUtils.propertyNameToChangeEventType(t),o=r.AttributeUtils.eventTypeToEventListenerProperty(i);n.properties[o]={_derived:!0,_eventListener:!0}}),a._enumerateMetadataForKey(null,n,"events",function(e,t){var i=r.AttributeUtils.eventTypeToEventListenerProperty(t);n.properties[i]={_derived:!0,_eventListener:!0}}),n},a.__FirePropertyChangeEvent=function(e,t,n,i,o,s){var a=r.CustomElementUtils.getElementBridge(e);if(!a._SKIP_PROP_CHANGE_EVENT){var l={};s&&(l.subproperty=s),l.value=n,l.previousValue=i,l.updatedFrom=o,a.beforePropertyChangedEvent&&a.beforePropertyChangedEvent(e,t,l),("external"!==o||a.State.isComplete())&&e.dispatchEvent(new CustomEvent(t+"Changed",{detail:l}))}},a.__DefineDynamicObjectProperty=function(e,t,r,n){Object.defineProperty(e,t,{enumerable:!0,get:r,set:n})},a.DESC_KEY_META="metadata",e._registerLegacyNamespaceProp("BaseCustomElementBridge",a),o.whenDocumentReady().then(function(){!function(){var e=document.createElement("div");e.style.border="1px solid",e.style.borderColor="red green",e.style.position="absolute",e.style.top="-999px",e.style.backgroundImage="url(data:image/gif;base64,R0lGODlhAQABAIAAAP///wAAACwAAAAAAQABAAACAkQBADs=)";var t=document.body;t.appendChild(e);var r=window.getComputedStyle(e),n=r.backgroundImage;r.borderTopColor!==r.borderRightColor&&(null==n||"none"!==n&&"url (invalid-url:)"!==n)||t.classList.add("oj-hicontrast"),t.removeChild(e)}()}),o.whenDocumentReady().then(function(){!function(){let e=[];const t=s.AgentUtils.getAgentInfo();e.push("oj-agent-os-"+t.os.toLowerCase()),e.push("oj-agent-browser-"+t.browser.toLowerCase()),document.documentElement.classList.add(...e)}()})});
//# sourceMappingURL=ojcustomelement.js.map