/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","jquery","ojs/ojcore-base","ojs/ojdomutils"],function(e,t,n,l){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,n=n&&Object.prototype.hasOwnProperty.call(n,"default")?n.default:n;const r=function(){};r._TAB_INDEX="tabIndex",r._DATA_OJ_TABMOD="data-oj-tabmod",r._FOCUSABLE_ELEMENTS_QUERY="input, select, button, a[href], textarea, object, [tabIndex]:not([tabIndex='-1'])",r._FOCUSABLE_ELEMENTS_TAG=["input","select","button","a","textarea","object"],r.CHECKVIEWPORT_THRESHOLD=3,r.getFocusableElementsInNode=function(e,t){var l=[],E=n.AgentUtils.getAgentInfo(),i=!0;if(n.AgentUtils.BROWSER.IE===E.browser&&null==e.parentNode&&(i=!1),i)for(var s=e.querySelectorAll(r._FOCUSABLE_ELEMENTS_QUERY),o=s.length,a=0;a<o;a++){var u=s[a];if(!u.disabled&&(t||"none"!==u.style.display)){var _=parseInt(u.getAttribute(r._TAB_INDEX),10);(isNaN(_)||_>=0)&&l.push(u)}}return l},r.disableElement=function(e){var t=parseInt(e.getAttribute(r._TAB_INDEX),10);e.setAttribute(r._DATA_OJ_TABMOD,t),e.setAttribute(r._TAB_INDEX,-1)},r.disableAllFocusableElements=function(e,t,n){for(var l=[],E=r.getFocusableElementsInNode(e,t),i=0;i<E.length;i++)n&&E[i]===document.activeElement||(r.disableElement(E[i]),l.push(E[i]));return l},r.enableAllFocusableElements=function(e){for(var t=e.querySelectorAll("["+r._DATA_OJ_TABMOD+"]"),n=0;n<t.length;n++){var l=parseInt(t[n].getAttribute(r._DATA_OJ_TABMOD),10);t[n].removeAttribute(r._DATA_OJ_TABMOD),isNaN(l)?t[n].removeAttribute(r._TAB_INDEX):t[n].setAttribute(r._TAB_INDEX,l)}return t},r.isFromDefaultSelector=function(e){return e.target.classList.contains("oj-selectorbox")},r.getFocusableElementsIncludingDisabled=function(e){var t=[];let n=e.querySelectorAll(r._FOCUSABLE_ELEMENTS_QUERY+",["+r._DATA_OJ_TABMOD+"]");for(var l=0;l<n.length;l++){var E=n[l];E.disabled||"none"===E.style.display||t.push(E)}return t},r.isElementOrAncestorFocusable=function(e,t){return!(null==e||t&&t(e))&&(!!e.hasAttribute(r._DATA_OJ_TABMOD)||(parseInt(e.getAttribute(r._TAB_INDEX),10)>=0||(r._FOCUSABLE_ELEMENTS_TAG.indexOf(e.tagName.toLowerCase())>-1||r.isElementOrAncestorFocusable(e.parentElement,t))))},r.handleActionableTab=function(e,t){var n=r.getFocusableElementsInNode(t);return n.length>0&&e.target===n[n.length-1]&&(n[0].focus(),!0)},r.handleActionablePrevTab=function(e,t){var n=r.getFocusableElementsInNode(t);return n.length>0&&e.target===n[0]&&(n[n.length-1].focus(),!0)},r.isEventClickthroughDisabled=function(e,t){for(var n=e.target;null!=n&&n!==t;){if(r.isClickthroughDisabled(n))return!0;n=n.parentNode}return!1},r.isClickthroughDisabled=function(e){return"disabled"===e.dataset.ojClickthrough},r.getDefaultScrollBarWidth=function(e){var t;if(e&&e.style){var n=e.style.visibility,l=e.style.position,r=e.style.overflowY,E=e.style.height,i=e.style.width;e.style.visibility="hidden",e.style.position="absolute",e.style.overflowY="hidden",e.style.height="50px",e.style.width="50px";var s=e.offsetWidth-e.clientWidth;e.style.overflowY="scroll",t=e.offsetWidth-e.clientWidth-s,e.style.width=i,e.style.height=E,e.style.overflowY=r,e.style.position=l,e.style.visibility=n}return t},r.disableDefaultBrowserStyling=function(e){e.setAttribute("x-ms-format-detection","none")},r.applyMergedInlineStyles=function(e,t,n){var l=r.convertStringToStyleObj(n),E=r.convertStringToStyleObj(t),i=Object.assign({},l,E);r.applyStyleObj(e,i)},r.convertStringToStyleObj=function(e){var t={};if(e.split)for(var n=e.split(";"),l=0;l<n.length;l++){var r=n[l];if(""!==r){var E=r.split(":");2===E.length&&(t[E[0].trim()]=E[1].trim())}}return t},r.applyStyleObj=function(e,t){for(var n=Object.keys(t),l=Object.values(t),r=0;r<n.length;r++)e.style[n[r]]=l[r]},r.isMobileTouchDevice=function(){var e=n.AgentUtils.getAgentInfo();return e.os===n.AgentUtils.OS.IOS||e.os===n.AgentUtils.OS.ANDROID||e.os===n.AgentUtils.OS.WINDOWSPHONE},r.getNoJQFocusHandlers=function(e,t){return l.getNoJQFocusHandlers(e,t)},r.areKeySetsEqual=function(e,t){if(e===t)return!0;var l,r,E=e.isAddAll();if(E!==t.isAddAll())return!1;if(E?(l=e.deletedValues(),r=t.deletedValues()):(l=e.values(),r=t.values()),l.size!==r.size)return!1;for(var i=l.values(),s=r.values(),o=i.next(),a=s.next();!o.done;){if(!n.KeyUtils.equals(o.value,a.value))return!1;o=i.next(),a=s.next()}return!0},r.KEYBOARD_KEYS={_SPACEBAR:" ",_SPACEBAR_IE:"SpaceBar",_SPACEBAR_CODE:32,_ENTER:"Enter",_ENTER_CODE:13,_UP:"ArrowUp",_UP_IE:"Up",_UP_CODE:38,_DOWN:"ArrowDown",_DOWN_IE:"Down",_DOWN_CODE:40,_LEFT:"ArrowLeft",_LEFT_IE:"Left",_LEFT_CODE:37,_RIGHT:"ArrowRight",_RIGHT_IE:"Right",_RIGHT_CODE:39,_HOME:"Home",_HOME_CODE:36,_END:"End",_END_CODE:35,_TAB:"Tab",_TAB_CODE:9,_ESCAPE:"Escape",_ESCAPE_IE:"Esc",_ESCAPE_CODE:27,_F2:"F2",_F2_CODE:113,_NUM5_KEY:"5",_NUM5_KEY_CODE:53,_LETTER_A:"a",_LETTER_A_UPPERCASE:"A",_LETTER_A_CODE:65},r.isEnterKeyEvent=function(e){return e===r.KEYBOARD_KEYS._ENTER||e===r.KEYBOARD_KEYS._ENTER_CODE},r.isSpaceBarKeyEvent=function(e){return e===r.KEYBOARD_KEYS._SPACEBAR||e===r.KEYBOARD_KEYS._SPACEBAR_IE||e===r.KEYBOARD_KEYS._SPACEBAR_CODE},r.isEscapeKeyEvent=function(e){return e===r.KEYBOARD_KEYS._ESCAPE||e===r.KEYBOARD_KEYS._ESCAPE_IE||e===r.KEYBOARD_KEYS._ESCAPE_CODE},r.isTabKeyEvent=function(e){return e===r.KEYBOARD_KEYS._TAB||e===r.KEYBOARD_KEYS._TAB_CODE},r.isF2KeyEvent=function(e){return e===r.KEYBOARD_KEYS._F2||e===r.KEYBOARD_KEYS._F2_CODE},r.isHomeKeyEvent=function(e){return e===r.KEYBOARD_KEYS._HOME||e===r.KEYBOARD_KEYS._HOME_CODE},r.isEndKeyEvent=function(e){return e===r.KEYBOARD_KEYS._END||e===r.KEYBOARD_KEYS._END_CODE},r.isArrowUpKeyEvent=function(e){return e===r.KEYBOARD_KEYS._UP||e===r.KEYBOARD_KEYS._UP_IE||e===r.KEYBOARD_KEYS._UP_CODE},r.isArrowDownKeyEvent=function(e){return e===r.KEYBOARD_KEYS._DOWN||e===r.KEYBOARD_KEYS._DOWN_IE||e===r.KEYBOARD_KEYS._DOWN_CODE},r.isArrowLeftKeyEvent=function(e){return e===r.KEYBOARD_KEYS._LEFT||e===r.KEYBOARD_KEYS._LEFT_IE||e===r.KEYBOARD_KEYS._LEFT_CODE},r.isArrowRightKeyEvent=function(e){return e===r.KEYBOARD_KEYS._RIGHT||e===r.KEYBOARD_KEYS._RIGHT_IE||e===r.KEYBOARD_KEYS._RIGHT_CODE},r.isNumberFiveKeyEvent=function(e){return e===r.KEYBOARD_KEYS._NUM5_KEY||e===r.KEYBOARD_KEYS._NUM5_KEY_CODE},r.isLetterAKeyEvent=function(e){return e===r.KEYBOARD_KEYS._LETTER_A||e===r.KEYBOARD_KEYS._LETTER_A_UPPERCASE||e===r.KEYBOARD_KEYS._LETTER_A_CODE},r.getAddEventKeysResult=function(e,t,n){var l,E,i,s,o;function a(e,t){return{key:e,index:t}}var u=[...e],_=[];t.keys.forEach(function(e){_.push(e)});var c=[],A=t.addBeforeKeys?t.addBeforeKeys:t.afterKeys;null!=A&&A.forEach(function(e){c.push(e)});var K=t.indexes;if(c.length===_.length)for(var O=0;_.length!==O;)for(O=_.length,l=_.length-1;l>=0;l--)i=_[l],r.containsKey(u,i)||(null!=(E=c[l])?-1!==(o=r._indexOfKey(u,E))&&(u.splice(o,0,i),c.splice(l,1),_.splice(l,1)):n&&(u.push(i),c.splice(l,1),_.splice(l,1)));else if(null!=K&&K.length===_.length){var f=[];for(l=0;l<_.length;l++)if(i=_[l],!r.containsKey(u,i))if(null!=(s=K[l])){for(var d=!1,D=0;D<f.length;D++)if(f[D].index>s){f.splice(D,0,a(i,s)),d=!0;break}d||f.push(a(i,s))}else n&&u.push(i);for(l=0;l<f.length;l++){var v=f[l];v.index<u.length?u.splice(v.index,0,v.key):v.index===u.length&&n&&u.push(v.key)}}else n&&_.forEach(function(e){u.push(e)});return u},r.containsKey=function(e,t){for(var l=0;l<e.length;l++)if(n.KeyUtils.equals(e[l],t))return!0;return!1},r._indexOfKey=function(e,t){for(var l=0;l<e.length;l++)if(n.KeyUtils.equals(e[l],t))return l;return-1},r.calculateOffsetTop=function(e,t){for(var n=0,l=t;l&&l!==e&&e.contains(l);)n+=l.offsetTop,l=l.offsetParent;return n};const E=r.applyMergedInlineStyles,i=r.applyStyleObj,s=r.areKeySetsEqual,o=r.containsKey,a=r.convertStringToStyleObj,u=r.disableElement,_=r.disableAllFocusableElements,c=r.disableDefaultBrowserStyling,A=r.enableAllFocusableElements,K=r.getAddEventKeysResult,O=r.getDefaultScrollBarWidth,f=r.getFocusableElementsIncludingDisabled,d=r.isElementOrAncestorFocusable,D=r.getFocusableElementsInNode,v=r.getLogicalChildPopup=function(e){for(var r=n.ZOrderUtils.findOpenPopups(),E=0;E<r.length;E++){var i=r[E].firstElementChild,s=l.getLogicalParent(t(i));if(null!=s&&t(e).has(s.get(0)).length>0&&n.ZOrderUtils.getStatus(i)===n.ZOrderUtils.STATUS.OPEN)return i}return null},y=r.getNoJQFocusHandlers,b=r.handleActionablePrevTab,S=r.handleActionableTab,g=r.isArrowDownKeyEvent,h=r.isArrowLeftKeyEvent,T=r.isArrowRightKeyEvent,p=r.isArrowUpKeyEvent,Y=r.isClickthroughDisabled,B=r.isEndKeyEvent,R=r.isEnterKeyEvent,C=r.isEscapeKeyEvent,m=r.isEventClickthroughDisabled,I=r.isFromDefaultSelector,N=r.isF2KeyEvent,F=r.isHomeKeyEvent,L=r.isMobileTouchDevice,P=r.isSpaceBarKeyEvent,U=r.isTabKeyEvent,w=r.isNumberFiveKeyEvent,H=r.isLetterAKeyEvent,M=r.KEYBOARD_KEYS,j=r.CHECKVIEWPORT_THRESHOLD,x=r.calculateOffsetTop,W=r.isElementInScrollerBounds=function(e,t){var n,l;if(t===document.documentElement)n=0,l=document.documentElement.clientHeight;else{var r=t.getBoundingClientRect();n=r.top,l=r.bottom}var E=e.getBoundingClientRect();return E.top>=n&&E.bottom<=l};e.CHECKVIEWPORT_THRESHOLD=j,e.KEYBOARD_KEYS=M,e.applyMergedInlineStyles=E,e.applyStyleObj=i,e.areKeySetsEqual=s,e.calculateOffsetTop=x,e.containsKey=o,e.convertStringToStyleObj=a,e.disableAllFocusableElements=_,e.disableDefaultBrowserStyling=c,e.disableElement=u,e.enableAllFocusableElements=A,e.getAddEventKeysResult=K,e.getDefaultScrollBarWidth=O,e.getFocusableElementsInNode=D,e.getFocusableElementsIncludingDisabled=f,e.getLogicalChildPopup=v,e.getNoJQFocusHandlers=y,e.handleActionablePrevTab=b,e.handleActionableTab=S,e.isArrowDownKeyEvent=g,e.isArrowLeftKeyEvent=h,e.isArrowRightKeyEvent=T,e.isArrowUpKeyEvent=p,e.isClickthroughDisabled=Y,e.isElementInScrollerBounds=W,e.isElementOrAncestorFocusable=d,e.isEndKeyEvent=B,e.isEnterKeyEvent=R,e.isEscapeKeyEvent=C,e.isEventClickthroughDisabled=m,e.isF2KeyEvent=N,e.isFromDefaultSelector=I,e.isHomeKeyEvent=F,e.isLetterAKeyEvent=H,e.isMobileTouchDevice=L,e.isNumberFiveKeyEvent=w,e.isSpaceBarKeyEvent=P,e.isTabKeyEvent=U,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojdatacollection-common.js.map