/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojvcomponent","preact","jquery","ojs/ojanimation","ojs/ojcore-base","ojs/ojpopup","ojs/ojdrawerutils"],function(e,t,r,s,a,n,o,i){"use strict";s=s&&Object.prototype.hasOwnProperty.call(s,"default")?s.default:s;var l=function(e,t,r,s){var a,n=arguments.length,o=n<3?t:null===s?s=Object.getOwnPropertyDescriptor(t,r):s;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)o=Reflect.decorate(e,t,r,s);else for(var i=e.length-1;i>=0;i--)(a=e[i])&&(o=(n<3?a(o):n>3?a(t,r,o):a(t,r))||o);return n>3&&o&&Object.defineProperty(t,r,o),o};const d=oj,p=d.PopupService,D=d.ZOrderUtils;e.DrawerLayout=class extends r.Component{constructor(){super(...arguments),this.rootRef=r.createRef(),this.startRef=r.createRef(),this.endRef=r.createRef(),this.mainSectionRef=r.createRef(),this.state={startOpened:this.props.startOpened,endOpened:this.props.endOpened,startDisplay:this.props.startDisplay,endDisplay:this.props.endDisplay,viewportResolvedDisplayMode:this.getResolvedViewportDisplayMode(),startSelfClosed:!1,endSelfClosed:!1,lastlyOpenedDrawer:i.DrawerConstants.stringStart},this.handleKeyDown=(e,t)=>{var r,s;const a=this.getResolvedDrawerDisplayMode(e);if(t.key===i.DrawerConstants.keys.ESC&&(a===i.DrawerConstants.stringOverlay||a===i.DrawerConstants.stringFullOverlay)){const t={};t[e+"Opened"]=!1,t[e+"SelfClosed"]=!0,this.setState(t),null===(s=(r=this.props)[`on${i.DrawerUtils.capitalizeFirstChar(e)}OpenedChanged`])||void 0===s||s.call(r,!1)}},this.resizeHandler=()=>{const e=this.getResolvedViewportDisplayMode();this.state.viewportResolvedDisplayMode!=e&&this.setState({viewportResolvedDisplayMode:e})}}static getDerivedStateFromProps(e,t){const r={};return!1===t.startSelfClosed&&e.startOpened!==t.startOpened&&(r.startOpened=e.startOpened,e.startOpened&&(r.lastlyOpenedDrawer=i.DrawerConstants.stringStart)),!1===t.startOpened&&(r.startSelfClosed=!1),!1===t.endSelfClosed&&e.endOpened!==t.endOpened&&(r.endOpened=e.endOpened,e.endOpened&&(r.lastlyOpenedDrawer=i.DrawerConstants.stringEnd)),!1===t.endOpened&&(r.endSelfClosed=!1),e.startDisplay!==t.startDisplay&&(r.startDisplay=e.startDisplay),e.endDisplay!==t.endDisplay&&(r.endDisplay=e.endDisplay),r}render(e){let s=this.getDrawer(i.DrawerConstants.stringStart),a=this.getDrawer(i.DrawerConstants.stringEnd);return r.h(t.Root,{ref:this.rootRef},s,r.h("div",{ref:this.mainSectionRef,class:i.DrawerConstants.mainContentSelector},e.children),a)}getDrawer(e){if(this.isDrawerOpened(e)){const t=this.getResolvedDrawerDisplayMode(e),s=t===i.DrawerConstants.stringOverlay||t===i.DrawerConstants.stringFullOverlay,a=this.props.role||s&&"dialog",n=s?-1:void 0;return r.h("div",{ref:this.getDrawerRef(e),key:this.getResolvedDrawerDisplayMode(e),role:a,tabIndex:n,class:this.getDrawerStyleClasses(e),onKeyDown:t=>this.handleKeyDown(e,t)},this.getDrawerContent(e))}return null}getDrawerRef(e){return e===i.DrawerConstants.stringStart?this.startRef:this.endRef}getDrawerContent(e){return e===i.DrawerConstants.stringStart?this.props.start:this.props.end}getDrawerStyleClasses(e){let t;switch(this.getResolvedDrawerDisplayMode(e)){case i.DrawerConstants.stringReflow:t={[i.DrawerConstants.styleDisplayMode(i.DrawerConstants.stringReflow)]:!0};break;case i.DrawerConstants.stringOverlay:t={[i.DrawerConstants.styleDisplayMode(i.DrawerConstants.stringOverlay)]:!0};break;case i.DrawerConstants.stringFullOverlay:t={[i.DrawerConstants.styleDisplayMode(i.DrawerConstants.stringOverlay)]:!0,[i.DrawerConstants.styleDisplayMode(i.DrawerConstants.stringFullOverlay)]:!0}}return i.DrawerUtils.getStyleClassesMapAsString(Object.assign(t,i.DrawerUtils.getCommonStyleClasses(e,this.isDrawerOpened(e))))}getResolvedDrawerDisplayMode(e){const t=e+"Display";return"auto"===this.props[t]?this.state.viewportResolvedDisplayMode:this.props[t]===i.DrawerConstants.stringReflow?i.DrawerConstants.stringReflow:this.props[t]===i.DrawerConstants.stringOverlay?this.state.viewportResolvedDisplayMode===i.DrawerConstants.stringFullOverlay?i.DrawerConstants.stringFullOverlay:i.DrawerConstants.stringOverlay:void 0}getResolvedViewportDisplayMode(){const e=this.getViewportWidth();return e>=i.DrawerConstants.displayTypeChangeThreshold?i.DrawerConstants.stringReflow:e<i.DrawerConstants.displayTypeChangeThreshold&&e>=i.DrawerConstants.fullWidthDrawerChangeThreshold?i.DrawerConstants.stringOverlay:i.DrawerConstants.stringFullOverlay}getViewportWidth(){return window.innerWidth}handleFocus(e){this.state.startOpened&&e.startOpened!==this.state.startOpened&&this.setDrawerFocus(i.DrawerConstants.stringStart),this.state.endOpened&&e.endOpened!==this.state.endOpened&&this.setDrawerFocus(i.DrawerConstants.stringEnd)}setDrawerFocus(e){const t=this.getDrawerRef(e),r=t.current.querySelectorAll("[autofocus]"),{length:s,0:a}=r;if(s>0)return void a.focus();const n=t.current.querySelectorAll('button, [href], input, select, textarea, [tabindex]:not([tabindex="-1"]), video'),{length:o,0:i}=n;(o>0?i:t.current).focus()}componentDidUpdate(e,t){this.afterUpdateCheck(t)}componentDidMount(){window.addEventListener("resize",()=>{this.resizeHandler()})}componentWillUnmount(){window.removeEventListener("resize",()=>{this.resizeHandler()})}afterUpdateCheck(e){const t=this.state.lastlyOpenedDrawer===i.DrawerConstants.stringStart?i.DrawerConstants.stringEnd:i.DrawerConstants.stringStart;this.openDrawerIfNeeded(t,e),this.openDrawerIfNeeded(this.state.lastlyOpenedDrawer,e)}openDrawerIfNeeded(e,t){const r=this.edgeToStateOpenedName(e);if(this.isDrawerOpened(e)){this.getResolvedDrawerDisplayMode(e)===i.DrawerConstants.stringReflow?this.state[r]!=t[r]&&this.animateSlideIn(e):this.openOverlayDrawer(e,t)}}edgeToStateOpenedName(e){return`${e}${i.DrawerUtils.capitalizeFirstChar(i.DrawerConstants.stringOpened)}`}openOverlayDrawer(e,t){let r=!1;Array.from(document.querySelectorAll("."+i.DrawerConstants.DrawerLayoutStyleSurrogate)).forEach(t=>{t.querySelectorAll(`.${i.DrawerConstants.stringOjDrawer}${i.DrawerConstants.charDash}${e}`).length>0&&(r=!0)});const a=this.getDrawerRef(e).current;!1===r&&D.getStatus(a)===D.STATUS.OPEN&&D.setStatus(s(a),D.STATUS.CLOSE);const n=p.getInstance(),o=this.getDrawerRef(e).current;if(o){const r=s(o),a={},l=p.OPTION;a[l.POPUP]=r,a[l.LAUNCHER]=this.rootRef.current,a[l.LAYER_SELECTORS]=i.DrawerConstants.DrawerLayoutStyleSurrogate,a[l.POSITION]=this.getDrawerPosition(e);const d=p.EVENT;a[l.EVENTS]={[d.POPUP_BEFORE_OPEN]:()=>this.beforeOpenHandler(e,a,t),[d.POPUP_AFTER_OPEN]:()=>this.handleFocus(t),[d.POPUP_REFRESH]:()=>{r.position(this.getDrawerPosition(e)),this.setOverlayDrawersHeight()}},n.open(a)}}beforeOpenHandler(e,t,r){const s=t[p.OPTION.POPUP],a=t[p.OPTION.POSITION];s.show(),s.position(a),this.setOverlayDrawersHeight();const n=this.edgeToStateOpenedName(e);if(this.state[n]!=r[n])return this.animateSlideIn(e)}getDrawerPosition(e){const t=e+" top";let r={my:t,at:t,of:this.rootRef.current,collision:"none"};return oj.PositionUtils.normalizeHorizontalAlignment(r,i.DrawerUtils.isRTL())}animateSlideIn(e){return a.slideIn(this.getDrawerRef(e).current,i.DrawerUtils.getAnimationOptions(i.DrawerConstants.stringOpen,e))}setOverlayDrawersHeight(){const e=i.DrawerUtils.getElementHeight(this.mainSectionRef.current)+"px",t=this.startRef.current;t&&(t.style.height=e);const r=this.endRef.current;r&&(r.style.height=e)}isDrawerOpened(e){return this.state[this.edgeToStateOpenedName(e)]}},e.DrawerLayout.defaultProps={startOpened:!1,endOpened:!1,startDisplay:"auto",endDisplay:"auto"},e.DrawerLayout.metadata={slots:{"":{},start:{},end:{}},properties:{startOpened:{type:"boolean",writeback:!0},endOpened:{type:"boolean",writeback:!0},startDisplay:{type:"string",enumValues:["reflow","overlay","auto"]},endDisplay:{type:"string",enumValues:["reflow","overlay","auto"]}},extension:{_WRITEBACK_PROPS:["startOpened","endOpened"],_READ_ONLY_PROPS:[],_OBSERVED_GLOBAL_PROPS:["role"]}},e.DrawerLayout=l([t.customElement("oj-drawer-layout")],e.DrawerLayout),Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojdrawerlayout.js.map