/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojvcomponent","preact","jquery","ojs/ojanimation","ojs/ojcore-base","ojs/ojpopup","ojs/ojdrawerutils","hammerjs"],function(e,t,s,o,r,n,i,a,l){"use strict";o=o&&Object.prototype.hasOwnProperty.call(o,"default")?o.default:o,l=l&&Object.prototype.hasOwnProperty.call(l,"default")?l.default:l;var p=function(e,t,s,o){var r,n=arguments.length,i=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,s):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)i=Reflect.decorate(e,t,s,o);else for(var a=e.length-1;a>=0;a--)(r=e[a])&&(i=(n<3?r(i):n>3?r(t,s,i):r(t,s))||i);return n>3&&i&&Object.defineProperty(t,s,i),i};const c=oj.PopupService,h=window;e.DrawerPopup=class extends s.Component{constructor(){super(...arguments),this.state={opened:this.props.opened,selfClosed:!1},this.rootRef=s.createRef(),this.focusableItems=s.createRef(),this.isShiftKeyActive=!1,this.handleFocusout=e=>{if(!Array.from(this.focusableItems.current).find(t=>t===e.relatedTarget)){const{length:t,0:s,[t-1]:o}=this.focusableItems.current,r=this.isShiftKeyActive?o:s;e.preventDefault(),r.focus()}},this.handleKeyDown=e=>{if(e.key===a.DrawerConstants.keys.ESC&&this.selfClose(),e.key===a.DrawerConstants.keys.TAB&&"modal"===this.props.modality){this.isShiftKeyActive=e.shiftKey;const{length:t,0:s,[t-1]:o}=this.focusableItems.current;if(!t)return e.preventDefault(),void this.rootRef.current.focus();if(e.shiftKey){if(document.activeElement===s)return e.preventDefault(),void o.focus()}else if(document.activeElement===o)return e.preventDefault(),void s.focus()}},this.autoDismissHandler=e=>{e.target.closest("oj-drawer-popup")||"focus-loss"!==this.props.autoDismiss||this.selfClose()},this.handleSwipeAction=()=>{this.selfClose()}}render(e){return s.h(t.Root,{ref:this.rootRef,class:this.getPopupStyleClasses(this.props.edge),tabIndex:-1,role:this.props.role||"dialog",onKeyDown:this.handleKeyDown,onfocusout:this.handleFocusout},e.children)}selfClose(){var e,t;const s={opened:!1,selfClosed:!0};this.setState(s),null===(t=(e=this.props).onOpenedChanged)||void 0===t||t.call(e,!1)}renderDrawer(e){const t=this.props.edge,s=o(this.rootRef.current),r={},n=c.OPTION;r[n.POPUP]=s,r[n.LAUNCHER]=h,r[n.MODALITY]=this.props.modality,r[n.LAYER_SELECTORS]=a.DrawerConstants.DrawerPopupStyleSurrogate,r[n.POSITION]=this.getDrawerPosition(t);const i=c.EVENT;r[n.EVENTS]={[i.POPUP_BEFORE_OPEN]:()=>this.beforeOpenHandler(t,r),[i.POPUP_AFTER_OPEN]:()=>this.handleFocus(e),[i.POPUP_BEFORE_CLOSE]:()=>this.beforeCloseHandler(t),[i.POPUP_AUTODISMISS]:e=>this.autoDismissHandler(e),[i.POPUP_REFRESH]:()=>{s.position(this.getDrawerPosition(t))}};const l=c.getInstance();this.isDrawerOpened()?l.open(r):l.close(r)}beforeOpenHandler(e,t){const s=t[c.OPTION.POPUP],o=t[c.OPTION.POSITION];return[a.DrawerConstants.stringStart,a.DrawerConstants.stringEnd].indexOf(e)>-1&&(this.rootRef.current.style.height=window.innerHeight+"px"),a.DrawerConstants.stringBottom===e&&(this.rootRef.current.style.width=document.documentElement.clientWidth+"px"),s.show(),s.position(o),r.slideIn(this.rootRef.current,a.DrawerUtils.getAnimationOptions(a.DrawerConstants.stringOpen,e))}beforeCloseHandler(e){return r.slideOut(this.rootRef.current,a.DrawerUtils.getAnimationOptions(a.DrawerConstants.stringClose,e))}getDrawerPosition(e){let t=`${e} ${"bottom"===e?"bottom":"top"}`,s={my:t,at:t,of:window,collision:"none"};return oj.PositionUtils.normalizeHorizontalAlignment(s,a.DrawerUtils.isRTL())}isDrawerOpened(){return this.state.opened}getPopupStyleClasses(e){let t={};return"modal"===this.props.modality&&(t={[`${a.DrawerConstants.stringOjDrawer}${a.DrawerConstants.charDash}modal`]:!0}),a.DrawerUtils.getStyleClassesMapAsString(Object.assign(t,a.DrawerUtils.getCommonStyleClasses(e,this.isDrawerOpened())))}static getDerivedStateFromProps(e,t){const s={};return!1===t.selfClosed&&e.opened!==t.opened&&(s.opened=e.opened),!1===t.opened&&(s.selfClosed=!1),s}handleFocus(e){if(this.focusableItems.current=this.rootRef.current.querySelectorAll('button, [href], input, select, textarea, [tabindex]:not([tabindex="-1"]), video'),this.state.opened&&e.opened!==this.state.opened){const e=this.rootRef.current.querySelectorAll("[autofocus]"),{length:t,0:s}=e;if(t>0)return void s.focus();const{length:o,0:r}=this.focusableItems.current;(o>0?r:this.rootRef.current).focus()}}componentDidUpdate(e,t){this.renderDrawer(t),this.isDrawerOpened()&&"swipe"===this.props.closeGesture&&this.registerCloseWithSwipeListener(),!1===this.isDrawerOpened()&&t.opened&&this.unregisterCloseWithSwipeListener()}registerCloseWithSwipeListener(){this.hammerInstance=new l(h),this.props.edge===a.DrawerConstants.stringBottom&&this.hammerInstance.get("swipe").set({direction:l.DIRECTION_DOWN}),this.hammerInstance.on(this.getSwipeCloseDirection(this.props.edge),this.handleSwipeAction)}getSwipeCloseDirection(e){switch(e){case a.DrawerConstants.stringStart:return a.DrawerUtils.isRTL()?"swiperight":"swipeleft";case a.DrawerConstants.stringEnd:return a.DrawerUtils.isRTL()?"swipeleft":"swiperight";case a.DrawerConstants.stringBottom:return"swipedown"}}unregisterCloseWithSwipeListener(){this.hammerInstance&&this.hammerInstance.off(this.getSwipeCloseDirection(this.props.edge),this.handleSwipeAction)}},e.DrawerPopup.defaultProps={autoDismiss:"focus-loss",edge:"start",modality:"modal",opened:!1,closeGesture:"swipe"},e.DrawerPopup.metadata={slots:{"":{}},properties:{opened:{type:"boolean",writeback:!0},edge:{type:"string",enumValues:["start","end","bottom"]},modality:{type:"string",enumValues:["modal","modeless"]},autoDismiss:{type:"string",enumValues:["focus-loss","none"]},closeGesture:{type:"string",enumValues:["swipe","none"]}},extension:{_WRITEBACK_PROPS:["opened"],_READ_ONLY_PROPS:[],_OBSERVED_GLOBAL_PROPS:["role"]}},e.DrawerPopup=p([t.customElement("oj-drawer-popup")],e.DrawerPopup),Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojdrawerpopup.js.map