/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojconverter-number"],function(t,i){"use strict";const a=function(){};a.MINIMUM_AXIS_BUFFER=10,a.prototype.Init=function(t,i,a){this._context=t,this.Position=i.position,this._radius=i._radius,"top"===this.Position||"bottom"===this.Position?(this.StartCoord=a.x,this.EndCoord=a.x+a.w):"left"===this.Position||"right"===this.Position?(this.StartCoord=a.y,this.EndCoord=a.y+a.h):"radial"===this.Position?(this.StartCoord=0,this.EndCoord=this._radius):"tangential"===this.Position&&(i.isRTL?(this.StartCoord=2*Math.PI,this.EndCoord=0):(this.StartCoord=0,this.EndCoord=2*Math.PI)),this.MinValue=null,this.MaxValue=null,this.GlobalMin=null,this.GlobalMax=null,this.DataMin=null,this.DataMax=null,this.StartOverflow=0,this.EndOverflow=0,null==i.leftBuffer&&(i.leftBuffer=1/0),null==i.rightBuffer&&(i.rightBuffer=1/0),this.Options=i},a.prototype.getCtx=function(){return this._context},a.prototype.getOptions=function(){return this.Options},a.prototype.getValueAt=function(t){if(null==t)return null;var i=Math.min(this.StartCoord,this.EndCoord),a=Math.max(this.StartCoord,this.EndCoord);return t<i||t>a?null:this.getUnboundedValueAt(t)},a.prototype.getCoordAt=function(t){return null==t||t<this.MinValue||t>this.MaxValue?null:this.getUnboundedCoordAt(t)},a.prototype.getBoundedValueAt=function(t){if(null==t)return null;var i=t,a=Math.min(this.StartCoord,this.EndCoord),n=Math.max(this.StartCoord,this.EndCoord);return t<a?i=a:t>n&&(i=n),this.getUnboundedValueAt(i)},a.prototype.getBoundedCoordAt=function(t){if(null==t)return null;var i=t;return t<this.MinValue?i=this.MinValue:t>=this.MaxValue&&(i=this.MaxValue),this.getUnboundedCoordAt(i)},a.prototype.getUnboundedValueAt=function(t){return null},a.prototype.getUnboundedCoordAt=function(t){return null};const n=function(t,i,a,n,o,e){this.Init(t,i,a,n,o,e)};n.SCALE_NONE="none",n.SCALE_AUTO="auto",n.SCALE_THOUSAND="thousand",n.SCALE_MILLION="million",n.SCALE_BILLION="billion",n.SCALE_TRILLION="trillion",n.SCALE_QUADRILLION="quadrillion",n.SCALING_FACTOR_DIFFERENCE=3,n.prototype.Init=function(t,i,a,n,o,e){this._translations=e,this._scales={},this._scalesOrder=[],this._factorToScaleMapping={},this.InitScales(),this.InitFormatter(t,i,a,n,o)},n.prototype.InitScales=function(){var t=function(t,i,a){var n;a&&(n=this._translations?this._translations[a]:null);var o={scaleFactor:i,localizedSuffix:n};this._scales[t]=o,this._scalesOrder.push(o),this._factorToScaleMapping[i]=o},i=n.SCALING_FACTOR_DIFFERENCE;t.call(this,n.SCALE_NONE,0*i),t.call(this,n.SCALE_THOUSAND,1*i,"labelScalingSuffixThousand"),t.call(this,n.SCALE_MILLION,2*i,"labelScalingSuffixMillion"),t.call(this,n.SCALE_BILLION,3*i,"labelScalingSuffixBillion"),t.call(this,n.SCALE_TRILLION,4*i,"labelScalingSuffixTrillion"),t.call(this,n.SCALE_QUADRILLION,5*i,"labelScalingSuffixQuadrillion"),this._scalesOrder.sort(function(t,i){return t.scaleFactor<i.scaleFactor?-1:t.scaleFactor>i.scaleFactor?1:0})},n.prototype.InitFormatter=function(t,i,a,n,o){var e,s,r=!1,l=!1;if("off"!==o&&(l=!0),"number"!=typeof(s=this._getScaleFactor(n))&&(r=!0),r){var h=Math.max(Math.abs(t),Math.abs(i)),M=this._getPowerOfTen(h);s=this._findNearestLEScaleFactor(M)}if(!0===l)if(0===a&&t===i){var u=s-this._getPowerOfTen(i);e=u<=0?Math.max(u+3,0):Math.max(u,4)}else{var c=this._getPowerOfTen(a);e=Math.max(s-c,0)}this._useAutoPrecision=l,this._scaleFactor=s,this._decimalPlaces=e},n.prototype._findNearestLEScaleFactor=function(t){var i=0;if(t<=this._scalesOrder[0].scaleFactor)i=this._scalesOrder[0].scaleFactor;else if(t>=this._scalesOrder[this._scalesOrder.length-1].scaleFactor)i=this._scalesOrder[this._scalesOrder.length-1].scaleFactor;else for(var a=this._scalesOrder.length-1;a>=0;a--)if(this._scalesOrder[a].scaleFactor<=t){i=this._scalesOrder[a].scaleFactor;break}return i},n.prototype._getScaleFactor=function(t){var i,a=t||n.SCALE_AUTO,o=this._scales[a];return o&&(i=o.scaleFactor),i},n.prototype.format=function(t,a){var n=null!=t?parseFloat(t):t;if("number"==typeof n){var o=Math.pow(10,this._scaleFactor),e={style:"decimal",decimalFormat:"unit"===(a&&a.getOptions&&a.getOptions()&&a.getOptions().style)?"standard":"short",nu:"latn",useGrouping:!1},s=new i.IntlNumberConverter(e).format(o,e),r=/(\d+)(.*$)/.exec(s),l=r[2],h=Number(r[1])/o*n;if(a&&a.format)h=a.format(h);else{var M={style:"decimal",minimumFractionDigits:this._decimalPlaces,maximumFractionDigits:this._decimalPlaces};h=new i.IntlNumberConverter(M).format(h,M)}return"string"==typeof l&&0!==t&&(h+=l),h}return t},n.prototype._formatFraction=function(t){var i=t.toString();if(-1!==i.indexOf("e"))return i;if(this._decimalPlaces>0){-1===i.indexOf(".")&&(i+=".");for(var a=i.substring(i.indexOf(".")+1).length;a<this._decimalPlaces;)i+="0",a+=1}return i},n.prototype._getPowerOfTen=function(t){var i=t>=0?t:-t,a=0;if(i<1e-15)return 0;if(i===1/0)return Number.MAX_VALUE;if(i>=10)for(;i>=10;)a+=1,i/=10;else if(i<1)for(;i<1;)a-=1,i*=10;return a},n.prototype.getDecimalPlaces=function(){return this._decimalPlaces},t.BaseAxisInfo=a,t.DataAxisInfoMixin=function(){this.MAX_NUMBER_OF_GRIDS_AUTO=10,this.MINOR_TICK_COUNT=2,this.MAJOR_TICK_INCREMENT_BUFFER=1e-10,this.MIN_BAR_SIZE_IN_LOG=10,this.MixinInit=function(t){"top"===this.Position||"bottom"===this.Position?("off"!==t.tickLabel.rendered&&"off"!==t.rendered&&(this.StartOverflow=Math.max(a.MINIMUM_AXIS_BUFFER-t.leftBuffer,0),this.EndOverflow=Math.max(a.MINIMUM_AXIS_BUFFER-t.rightBuffer,0)),t.isRTL?(this.MinCoord=this.EndCoord-this.EndOverflow,this.MaxCoord=this.StartCoord+this.StartOverflow):(this.MinCoord=this.StartCoord+this.StartOverflow,this.MaxCoord=this.EndCoord-this.EndOverflow)):"tangential"===this.Position||"radial"===this.Position?(this.MinCoord=this.StartCoord,this.MaxCoord=this.EndCoord):(this.MinCoord=this.EndCoord,this.MaxCoord=this.StartCoord),this.DataMin=t.dataMin,this.DataMax=t.dataMax,this.utilsLogOptions=t._utils&&"log"===t.scale,this.IsLog=this.utilsLogOptions||"log"===t.scale&&this.DataMin>0&&this.DataMax>0,this.LinearGlobalMin=this.actualToLinear(t.min),this.LinearGlobalMax=this.actualToLinear(t.max),this.LinearMinValue=null==t.viewportMin?this.LinearGlobalMin:this.actualToLinear(t.viewportMin),this.LinearMaxValue=null==t.viewportMax?this.LinearGlobalMax:this.actualToLinear(t.viewportMax),this._dataMin=this.actualToLinear(this.DataMin),this._dataMax=this.actualToLinear(this.DataMax),this.MajorIncrement=this.actualToLinear(t.step),this.MinorIncrement=this.actualToLinear(t.minorStep),this._minMajorIncrement=this.actualToLinear(t.minStep),this.MajorTickCount=t._majorTickCount,this.MinorTickCount=t._minorTickCount,this.LogScaleUnit=t._logScaleUnit,this.ZeroBaseline=!this.IsLog&&"zero"===t.baselineScaling,this._continuousExtent=this.Options?"on"===this.Options._continuousExtent:null,this.Converter=null,null!=t.tickLabel&&(this.Converter=t.tickLabel.converter),this._calcAxisExtents(),this.GlobalMin=this.linearToActual(this.LinearGlobalMin),this.GlobalMax=this.linearToActual(this.LinearGlobalMax),this.MinValue=this.linearToActual(this.LinearMinValue),this.MaxValue=this.linearToActual(this.LinearMaxValue)},this.getBaselineCoord=function(){return this.IsLog?this.MinCoord:this.getBoundedCoordAt(0)},this.getUnboundedValueAt=function(t){if(null==t)return null;var i=(t-this.MinCoord)/(this.MaxCoord-this.MinCoord),a=this.LinearMinValue+i*(this.LinearMaxValue-this.LinearMinValue);return this.linearToActual(a)},this.getUnboundedCoordAt=function(t){return this.GetUnboundedCoordAt(this.actualToLinear(t))},this.GetUnboundedCoordAt=function(t){if(null==t)return null;var i=this.LinearMaxValue===this.LinearMinValue?0:(t-this.LinearMinValue)/(this.LinearMaxValue-this.LinearMinValue);return i=Math.max(Math.min(1e3,i),-1e3),this.MinCoord+i*(this.MaxCoord-this.MinCoord)},this.CalcMajorMinorIncr=function(t){this.MajorIncrement||(this.MajorTickCount?this.MajorIncrement=(this.LinearMaxValue-this.LinearMinValue)/this.MajorTickCount:this.MajorIncrement=Math.max(t,this._minMajorIncrement)),this.MajorTickCount||(this.MajorTickCount=(this.LinearMaxValue-this.LinearMinValue)/this.MajorIncrement,Math.ceil(this.MajorTickCount)-this.MajorTickCount<this.MAJOR_TICK_INCREMENT_BUFFER&&(this.MajorTickCount=Math.ceil(this.MajorTickCount))),this.MinorTickCount||(this.MinorIncrement?this.MinorTickCount=this.MajorIncrement/this.MinorIncrement:this.IsLog?this.MinorTickCount=this.MajorIncrement:this.MinorTickCount=this.MINOR_TICK_COUNT),this.MinorIncrement||(this.MinorIncrement=this.MajorIncrement/this.MinorTickCount)},this._calcAxisExtents=function(){this.ZeroBaseline&&(this._dataMin=Math.min(0,this._dataMin),this._dataMax=Math.max(0,this._dataMax));var t=null!=this.LinearGlobalMax?this.LinearGlobalMax:this._dataMax,i=null!=this.LinearGlobalMin?this.LinearGlobalMin:this._dataMin,a=Math.max(this._calcAxisScale(i,t),this._minMajorIncrement);this._dataMin===this._dataMax&&(0===this._dataMin?this._dataMax+=5*a:(this._dataMin-=2*a,this._dataMax+=2*a)),null==this.LinearGlobalMin&&(this.ZeroBaseline&&this._dataMin>=0?this.LinearGlobalMin=0:this._continuousExtent?this.LinearGlobalMin=this._dataMin-.1*(this._dataMax-this._dataMin):this.ZeroBaseline||null==this.LinearGlobalMax?this.LinearGlobalMin=(Math.ceil(this._dataMin/a)-1)*a:(this.LinearGlobalMin=this.LinearGlobalMax,this.LinearGlobalMin-=a*(Math.floor((this.LinearGlobalMin-this._dataMin)/a)+1)),this._dataMin>=0&&!this.IsLog&&(this.LinearGlobalMin=Math.max(this.LinearGlobalMin,0))),null==this.LinearGlobalMax&&(this.MajorTickCount?(this.LinearGlobalMax=this.LinearGlobalMin+this.MajorTickCount*a,this.LinearGlobalMax<this._dataMax&&(a=Math.max(this._calcAxisScale(i,t+a),this._minMajorIncrement),this.LinearGlobalMax=this.LinearGlobalMin+this.MajorTickCount*a)):this.ZeroBaseline&&this._dataMax<=0?this.LinearGlobalMax=0:this._continuousExtent?this.LinearGlobalMax=this._dataMax+.1*(this._dataMax-this._dataMin):this.ZeroBaseline?this.LinearGlobalMax=(Math.floor(this._dataMax/a)+1)*a:(this.LinearGlobalMax=this.LinearGlobalMin,this.LinearGlobalMax+=a*(Math.floor((this._dataMax-this.LinearGlobalMax)/a)+1)),this._dataMax<=0&&(this.LinearGlobalMax=Math.min(this.LinearGlobalMax,0))),this.LinearGlobalMax===this.LinearGlobalMin&&(this.LinearGlobalMax=100,this.LinearGlobalMin=0,a=(this.LinearGlobalMax-this.LinearGlobalMin)/this.MAX_NUMBER_OF_GRIDS_AUTO),null==this.LinearMinValue&&(this.LinearMinValue=this.LinearGlobalMin),null==this.LinearMaxValue&&(this.LinearMaxValue=this.LinearGlobalMax);var n=Math.abs(this.GetUnboundedCoordAt(this.LinearGlobalMin)-this.GetUnboundedCoordAt(this._dataMin));(this.IsLog&&n<this.MIN_BAR_SIZE_IN_LOG||this.utilsLogOptions)&&(this.LinearGlobalMin-=a,this.LinearMinValue=this.LinearGlobalMin),this.LinearMinValue===this.LinearGlobalMin&&this.LinearMaxValue===this.LinearGlobalMax||(a=this._calcAxisScale(this.LinearMinValue,this.LinearMaxValue)),this.LinearGlobalMin>this.LinearMinValue&&(this.LinearGlobalMin=this.LinearMinValue),this.LinearGlobalMax<this.LinearMaxValue&&(this.LinearGlobalMax=this.LinearMaxValue),this.CalcMajorMinorIncr(a)},this._calcAxisScale=function(t,i){if(this.MajorIncrement)return this.MajorIncrement;var a,n=i-t;if(this.IsLog){var o=Math.floor(n/8)+1;return(!this.LogScaleUnit||this.LogScaleUnit<o)&&(this.LogScaleUnit=o),this.LogScaleUnit}if(0===n)return 0===t?10:Math.pow(10,Math.floor(Math.log10(t))-1);if(this.MajorTickCount){var e=n/this.MajorTickCount,s=e/(a=Math.pow(10,Math.ceil(Math.log10(e)-1)));return(s=s>1&&s<=1.5?1.5:s>5?10:Math.ceil(s))*a}var r=Math.log10(n);a=Math.pow(10,Math.ceil(r)-2);var l=Math.round(n/a);return(l>=10&&l<=14?2:l>=15&&l<=19?3:l>=20&&l<=24?4:l>=25&&l<=45?5:l>=46&&l<=80?10:20)*a},this.linearToActual=function(t){return null==t?null:this.IsLog?Math.pow(10,t):t},this.actualToLinear=function(t){return null==t?null:this.IsLog?t>0?Math.log10(t):null:t},this.getAxisData=function(){return{isLog:this.IsLog,max:this.LinearGlobalMax,min:this.LinearGlobalMin,step:this.MajorIncrement,numSteps:this.MajorTickCount}}},t.LinearScaleAxisValueFormatter=n,Object.defineProperty(t,"__esModule",{value:!0})});
//# sourceMappingURL=ojdvt-axis.js.map