/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojdvt-toolkit","ojs/ojdvt-timecomponent","ojs/ojtimeaxis-toolkit"],function(t,e,a,i){"use strict";var n=new Object;e.Obj.createSubclass(n,e.Obj),n._DEFAULT_TIMEAXES_LABEL_STYLE=e.BaseComponentDefaults.FONT_FAMILY_ALTA_12+"color: #333333;",n._DEFAULT_ZOOM_CONTROL_DIAMETER=31,n._DEFAULT_ZOOM_CONTROL_PADDING=10.5,n._DEFAULT_ZOOM_CONTROL_SPACING=9,n._DEFAULT_STANDALONE_TASK_HEIGHT=22,n._DEFAULT_BASELINE_MARGIN_TOP=0,n._DEFAULT_BASELINE_TASK_HEIGHT=6,n._DEFAULT_SUMMARY_THICKNESS=3,n._DEFAULT_TASK_LABEL_PADDING=5,n._DEFAULT_TASK_PADDING=5,n._DEFAULT_TASK_EFFECT_MARGIN=2,n._DEFAULT_TASK_TINT_FILTER_ID="ojGanttTaskTintFilter",n._DEFAULT_TASK_SHADE_FILTER_ID="ojGanttTaskShadeFilter",n._DEFAULT_TASK_TINT_ALPHA=.3,n._DEFAULT_TASK_SHADE_ALPHA=.35,n._DEFAULT_AXIS_HEIGHT=23,n._ROW_LABELS_AXIS_GAP=0,n._ROW_LABEL_EXPAND_COLLAPSE_BUTTON_SIZE=12,n._ROW_LABEL_INDENT_SIZE=n._ROW_LABEL_EXPAND_COLLAPSE_BUTTON_SIZE+9,n._ROW_LABEL_BUTTON_CONTENT_GAP_SIZE=7,n._ROW_LABEL_CONTAINER_PADDING=8,n._DEFAULT_DEPENDENCY_LINE_INNER_COLOR="#ffffff",n._DEFAULT_DEPENDENCY_LINE_INNER_WIDTH=2,n._DEFAULT_ANIMATION_DURATION=.5,n._DEPENDENCY_LINE_ARC_RADIUS=0,n._DEPENDENCY_LINE_TASK_FLANK_LENGTH=20,n._DEPENDENCY_TRIANGLE_MARKER_HEIGHT=8,n._DEPENDENCY_TRIANGLE_MARKER_WIDTH=6,n._DEPENDENCY_ANGLE_MARKER_HEIGHT=14,n._DEPENDENCY_ANGLE_MARKER_WIDTH=8,n._DEPENDENCY_TRIANGLE_MARKER_ID="ojGanttDependencyMarkerEndTriangle",n._DEPENDENCY_ANGLE_MARKER_ID="ojGanttDependencyMarkerEndAngle",n._AUTOPAN_EDGE_THRESHOLD=20,n._DEFAULT_TASK_RESIZE_HANDLE_WIDTH=5,n._DEFAULT_TASK_RESIZE_HANDLE_WIDTH_TOUCH=20,n.getHorizontalScrollbarStyle=function(){return new e.CSSStyle(n._DEFAULT_HORIZONTAL_SCROLLBAR_STYLE)},n.getVerticalScrollbarStyle=function(){return new e.CSSStyle(n._DEFAULT_VERTICAL_SCROLLBAR_STYLE)},n.getStandaloneTaskHeight=function(t){var e=t?t._resources:null;return e&&e.taskDefaults&&null!=e.taskDefaults.height?n.getSizeInPixels(e.taskDefaults.height):n._DEFAULT_STANDALONE_TASK_HEIGHT},n.getActualTaskHeight=function(t){return n.getStandaloneTaskHeight(t)-n.getBaselineMarginTop(t)-n.getBaselineTaskHeight(t)},n.getBaselineMarginTop=function(t){var e=t?t._resources:null;return e&&e.baselineMarginTop?this.getSizeInPixels(e.baselineMarginTop):n._DEFAULT_BASELINE_MARGIN_TOP},n.getBaselineTaskHeight=function(t){var e=t?t._resources:null;return e&&e.taskDefaults&&e.taskDefaults.baseline&&null!=e.taskDefaults.baseline.height?n.getSizeInPixels(e.taskDefaults.baseline.height):n._DEFAULT_BASELINE_TASK_HEIGHT},n.getMilestoneBaselineYOffset=function(t){return n.getBaselineTaskHeight(t)},n.getSummaryThickness=function(){return n._DEFAULT_SUMMARY_THICKNESS},n.getRowPaddingTop=function(t){var e=t?t._resources:null;return e&&null!=e.rowPaddingTop?n.getSizeInPixels(e.rowPaddingTop):n._DEFAULT_TASK_PADDING},n.getRowPaddingBottom=function(t){var e=t?t._resources:null;return e&&null!=e.rowPaddingBottom?n.getSizeInPixels(e.rowPaddingBottom):n._DEFAULT_TASK_PADDING},n.getTaskPadding=function(t){var e=t?t._resources:null;return e&&null!=e.taskPaddingLeft?n.getSizeInPixels(e.taskPaddingLeft):n._DEFAULT_TASK_LABEL_PADDING},n.getTaskMargin=function(t){var e=t?t._resources:null;return e&&null!=e.taskMarginLeft?n.getSizeInPixels(e.taskMarginLeft):n._DEFAULT_TASK_LABEL_PADDING},n.getTaskLabelMargin=function(t){var e=t?t._resources:null;return e&&null!=e.taskLabelMarginLeft?n.getSizeInPixels(e.taskLabelMarginLeft):n._DEFAULT_TASK_LABEL_PADDING},n.getTaskEffectMargin=function(){return n._DEFAULT_TASK_EFFECT_MARGIN},n.getTaskTintFilterId=function(){return n._DEFAULT_TASK_TINT_FILTER_ID},n.getTaskShadeFilterId=function(){return n._DEFAULT_TASK_SHADE_FILTER_ID},n.getTaskTintAlpha=function(){return n._DEFAULT_TASK_TINT_ALPHA},n.getTaskShadeAlpha=function(){return n._DEFAULT_TASK_SHADE_ALPHA},n.getTimeAxisHeight=function(t,e){var a=t[e];if(a&&a.height)return a.height;var i=t._resources;return i&&i[e]&&null!=i[e].height?n.getSizeInPixels(i[e].height):n._DEFAULT_AXIS_HEIGHT},n.getMajorAxisLabelStyle=function(t){var a=t._resources,i=n._DEFAULT_TIMEAXES_LABEL_STYLE;return a&&(i=a.majorAxisLabelFontProp),new e.CSSStyle(i)},n.getMinorAxisLabelStyle=function(t){var a=t._resources,i=n._DEFAULT_TIMEAXES_LABEL_STYLE;return a&&(i=a.minorAxisLabelFontProp),new e.CSSStyle(i)},n.getRowAxisGap=function(){return n._ROW_LABELS_AXIS_GAP},n.getDependencyLineTaskFlankLength=function(){return n._DEPENDENCY_LINE_TASK_FLANK_LENGTH},n.getDependencyLineArcRadius=function(){return n._DEPENDENCY_LINE_ARC_RADIUS},n.getDependencyLineTriangleMarkerWidth=function(){return n._DEPENDENCY_TRIANGLE_MARKER_WIDTH},n.getDependencyLineTriangleMarkerHeight=function(){return n._DEPENDENCY_TRIANGLE_MARKER_HEIGHT},n.getDependencyLineAngleMarkerWidth=function(){return n._DEPENDENCY_ANGLE_MARKER_WIDTH},n.getDependencyLineAngleMarkerHeight=function(){return n._DEPENDENCY_ANGLE_MARKER_HEIGHT},n.getDependencyLineTriangleMarkerId=function(){return n._DEPENDENCY_TRIANGLE_MARKER_ID},n.getDependencyLineAngleMarkerId=function(){return n._DEPENDENCY_ANGLE_MARKER_ID},n.getDependencyLineAngleMarkerWidth=function(){return n._DEPENDENCY_ANGLE_MARKER_WIDTH},n.getDependencyLineAngleMarkerHeight=function(){return n._DEPENDENCY_ANGLE_MARKER_HEIGHT},n.getDependencyLineTaskGap=function(t){return n.getRowPaddingTop(t)-1},n.getAutoPanEdgeThreshold=function(){return n._AUTOPAN_EDGE_THRESHOLD},n.getTaskLabelStyle=function(t){var a=t._resources,i="";return a&&(i=a.taskLabelFontProp),new e.CSSStyle(i)},n.getRowLabelStyle=function(t){var a=t._resources,i="";return a&&(i=a.rowLabelFontProp),new e.CSSStyle(i)},n.getRowLabelPadding=function(t){var e=t?t._resources:null;return e&&null!=e.rowLabelPaddingLeft?n.getSizeInPixels(e.rowLabelPaddingLeft):n._ROW_LABEL_CONTAINER_PADDING},n.getRowLabelButtonSize=function(){return n._ROW_LABEL_EXPAND_COLLAPSE_BUTTON_SIZE},n.getRowLabelIndentSize=function(){return n._ROW_LABEL_INDENT_SIZE},n.getRowLabelButtonContentGapSize=function(){return n._ROW_LABEL_BUTTON_CONTENT_GAP_SIZE},n.getChartStrokeWidth=function(t){var a=t._resources;if(a){var i=a.chartArea;if(i){var n=i.strokeWidth;if(n)return e.CSSStyle.toNumber(n)}}return 1},n.getHorizontalGridlineWidth=function(t){return t._resources?e.CSSStyle.toNumber(t._resources.horizontalGridlineWidth):1},n.getAnimationDuration=function(t){var a,i=n._DEFAULT_ANIMATION_DURATION;return t._resources&&(a=t._resources.animationDuration)&&(i=e.CSSStyle.getTimeMilliseconds(a)/1e3),i},n.getFocusedDependencyLineInnerColor=function(t){return n._DEFAULT_DEPENDENCY_LINE_INNER_COLOR},n.getFocusedDependencyLineInnerWidth=function(t){return n._DEFAULT_DEPENDENCY_LINE_INNER_WIDTH},n.getTaskResizeHandleWidth=function(){return e.Agent.isTouchDevice()?n._DEFAULT_TASK_RESIZE_HANDLE_WIDTH_TOUCH:n._DEFAULT_TASK_RESIZE_HANDLE_WIDTH},n.getSizeInPixels=function(t,e){if("string"==typeof t){if("%"===t.slice(-1))return e*Number(t.slice(0,-1))/100;if("px"===t.slice(-2))return Number(t.slice(0,-2));t=Number(t)}return"number"==typeof t?t<=1?e*t:t:0};var s=function(t){this.Init(t)};e.Obj.createSubclass(s,e.Container),s.prototype.nodeType="dependency",s.START_START="startStart",s.START_FINISH="startFinish",s.FINISH_START="finishStart",s.FINISH_FINISH="finishFinish",s.CONFLICT_NONE=0,s.CONFLICT_PREDECESSOR=1,s.CONFLICT_SUCCESSOR=2,s.CONFLICT_BOTH=3,s.prototype.Init=function(t){s.superclass.Init.call(this,t.getCtx(),null),this._gantt=t,this._gantt.getEventManager().associate(this,this)},s.prototype.getGantt=function(){return this._gantt},s.prototype.getId=function(){return this._dependencyObj.id},s.prototype.setLayoutObject=function(t){this._dependencyObj=t},s.prototype.getLayoutObject=function(){return this._dependencyObj},s.prototype.getValue=function(t){var e;switch(t){case"type":e=this._dependencyObj.type;break;case"predecessorTaskId":e=this._dependencyObj.predecessorTaskObj.id;break;case"successorTaskId":e=this._dependencyObj.successorTaskObj.id;break;default:e=this._dependencyObj.data[t]}return e},s.prototype.getPredecessorNode=function(){return this._dependencyObj.predecessorTaskObj.node},s.prototype.getSuccessorNode=function(){return this._dependencyObj.successorTaskObj.node},s._getTaskStart=function(t,a){var i=e.Agent.isRightToLeft(t.getGantt().getCtx()),s=t.getGantt().getOptions(),r=t.getTask().getShape("main"),o=t.getTaskLabel(),l=o.getLabelOutputText(),h=o.getEffectiveLabelPosition(),d=n.getTaskLabelMargin(s),g=a?0:n.getTaskMargin(s);return i?a||null==l||null==l.getParent()||"end"!==h?t.getFinalX()+r.getFinalX()-r.getFinalWidth()-r.getPhysicalEndOffset()-g:t.getFinalX()+r.getFinalX()-r.getFinalWidth()-r.getPhysicalEndOffset()-l.getDimensions().w-2*d:a||null==l||null==l.getParent()||"start"!==h?t.getFinalX()+r.getFinalX()-r.getPhysicalStartOffset()-g:t.getFinalX()+r.getFinalX()-r.getPhysicalStartOffset()-l.getDimensions().w-2*d},s._getTaskMiddle=function(t){var e=t.getTask(),a=e.getShape("main"),i=e.isSummary("main")?t.getLayoutObject().height:a.getFinalHeight();return s._getTaskTop(t)+a.getFinalY()+Math.round(i/2)},s._getTaskEnd=function(t,a){var i=e.Agent.isRightToLeft(t.getGantt().getCtx()),s=t.getGantt().getOptions(),r=t.getTask().getShape("main"),o=t.getTaskLabel(),l=o.getLabelOutputText(),h=o.getEffectiveLabelPosition(),d=n.getTaskLabelMargin(s),g=a?0:n.getTaskMargin(s);return i?a||null==l||null==l.getParent()||"start"!==h?t.getFinalX()+r.getFinalX()+r.getPhysicalStartOffset()+g:t.getFinalX()+r.getFinalX()+r.getPhysicalStartOffset()+l.getDimensions().w+2*d:a||null==l||null==l.getParent()||"end"!==h?t.getFinalX()+r.getFinalX()+r.getFinalWidth()+r.getPhysicalEndOffset()+g:t.getFinalX()+r.getFinalX()+r.getFinalWidth()+r.getPhysicalEndOffset()+l.getDimensions().w+2*d},s._getTaskTop=function(t){return t.getFinalY()},s._getTaskBottom=function(t){return s._getTaskTop(t)+t.getFinalHeight()},s._isValidType=function(t){return t===s.START_START||t===s.START_FINISH||t===s.FINISH_START||t===s.FINISH_FINISH},s.prototype.isCustomContent=function(){var t=this._gantt.getOptions();return t.dependencyContent&&t.dependencyContent.renderer},s.prototype.getRendererContext=function(t){var e=this._gantt.getOptions(),a=this._gantt.getCtx(),i=this.getValue("type"),n=this.getPredecessorNode(),r=this.getSuccessorNode(),o=s._getRenderingTypeState(a,i),l=s._getEndPoints(n,r,o.isTypeBeginFinish,o.isTypeEndFinish,!0),h={data:this.getLayoutObject().data,itemData:e.dependencyData?this.getLayoutObject()._itemData:null,content:{predecessorX:l.predecessorX,predecessorY:l.predecessorY,successorX:l.successorX,successorY:l.successorY},state:t};return a.fixRendererContext(h)},s.prototype._renderCustomContent=function(t){var a=this.getGantt(),i=a.getOptions();this._content&&this.removeChild(this._content),this._content=new e.Container(a.getCtx()),this._content.setClassName(a.GetStyleClass("dependencyLineCustom")),this.addChild(this._content);var n=this._content.getContainerElem(),s=(0,i.dependencyContent.renderer)(this.getRendererContext(t));s&&(Array.isArray(s)?s.forEach(function(t){e.ToolkitUtils.appendChildElem(n,t)}):e.ToolkitUtils.appendChildElem(n,s))},s.prototype.render=function(t,a){a=!1!==a;this.getParent()!=t&&t.addChild(this),this.setAriaRole("img");var i=this.getGantt(),r=this.getValue("type"),o=this.getPredecessorNode(),l=this.getSuccessorNode();if(e.Agent.deferAriaCreation()||this.setAriaProperty("label",this.getAriaLabel()),this.isCustomContent())this._content&&!a||this._renderCustomContent({focused:!1});else{if("ie"!==e.Agent.browser&&"edge"!==e.Agent.browser||this._cleanup(),null!=this._line){this._line.setCmds(s._calcDepLine(i.getCtx(),o,l,r));var h=this._line.getElem()}else{var d=new e.Path(i.getCtx(),s._calcDepLine(i.getCtx(),o,l,r));0===n.getDependencyLineArcRadius()&&d.setPixelHinting(!0),h=d.getElem(),this.addChild(d);var g=new e.Stroke(n.getFocusedDependencyLineInnerColor(),1,n.getFocusedDependencyLineInnerWidth()),_=new e.Stroke("#000",1,1);d.setHoverStroke(g,_),this._line=d}var c=this.getValue("svgStyle");c&&this._line.setStyle(c);var p=i.GetStyleClass("dependencyLine"),u=this.getValue("svgClassName");u?e.ToolkitUtils.setAttrNullNS(h,"class",p+" "+u):e.ToolkitUtils.setAttrNullNS(h,"class",p)}},s.prototype._cleanup=function(){null!=this._line&&(this.removeChild(this._line),this._line=null)},s.prototype._calcConflict=function(){var t=!1,e=!1,a=this.getValue("type"),i=this.getGantt().getNavigableDependencyLinesForTask(this.getPredecessorNode(),"predecessor");if(null!=i)for(var n=0;n<i.length;n++){var r=i[n].getValue("type");(a!==s.START_START&&a!==s.START_FINISH||r!==s.START_START&&r!==s.FINISH_START)&&(a!==s.FINISH_FINISH&&a!==s.FINISH_START||r!==s.FINISH_FINISH&&r!==s.START_FINISH)||(t=!0)}if(null!=(i=this.getGantt().getNavigableDependencyLinesForTask(this.getSuccessorNode(),"successor")))for(n=0;n<i.length;n++)r=i[n].getValue("type"),(a!==s.START_START&&a!==s.FINISH_START||r!==s.START_START&&r!==s.START_FINISH)&&(a!==s.FINISH_FINISH&&a!==s.START_FINISH||r!==s.FINISH_FINISH&&r!==s.FINISH_START)||(e=!0);return t&&e?s.CONFLICT_BOTH:t?s.CONFLICT_PREDECESSOR:e?s.CONFLICT_SUCCESSOR:s.CONFLICT_NONE},s._getEndPoints=function(t,e,a,i,n){return{predecessorX:a?s._getTaskEnd(t,n):s._getTaskStart(t,n),predecessorY:s._getTaskMiddle(t),successorX:i?s._getTaskEnd(e,n):s._getTaskStart(e,n),successorY:s._getTaskMiddle(e)}},s._getRenderingTypeState=function(t,a){var i=e.Agent.isRightToLeft(t);switch(a){case s.START_START:return i?{isTypeBeginFinish:!0,isTypeEndFinish:!0}:{isTypeBeginFinish:!1,isTypeEndFinish:!1};case s.START_FINISH:return i?{isTypeBeginFinish:!0,isTypeEndFinish:!1}:{isTypeBeginFinish:!1,isTypeEndFinish:!0};case s.FINISH_START:return i?{isTypeBeginFinish:!1,isTypeEndFinish:!0}:{isTypeBeginFinish:!0,isTypeEndFinish:!1};case s.FINISH_FINISH:return i?{isTypeBeginFinish:!1,isTypeEndFinish:!1}:{isTypeBeginFinish:!0,isTypeEndFinish:!0}}return null},s._calcDepLine=function(t,e,a,i){var n=this._getRenderingTypeState(t,i);return s._calcDepLineHelper(e,a,n.isTypeBeginFinish,n.isTypeEndFinish)},s._calcDepLineHelper=function(t,a,i,r){var o=n.getDependencyLineArcRadius(),l=n.getDependencyLineTaskFlankLength(),h=s._getEndPoints(t,a,i,r,!1),d=h.predecessorX,g=h.successorX,_=h.predecessorY,c=h.successorY,p=t.getGantt().getOptions(),u=n.getDependencyLineTaskGap(p),b=c>=_?s._getTaskBottom(t)+u:s._getTaskTop(t)-u;d=Math.round(d)+.5,g=Math.round(g)+.5,_=Math.round(_)+.5,c=Math.round(c)+.5,b=Math.round(b)+.5;var f=d+(i?1:-1)*l,y=r?g+l:g-l,m=e.PathUtils.moveTo(d,_);return i&&y<f||!i&&y>f?(m+=e.PathUtils.horizontalLineTo(f+(i?-1:1)*o),c>_?(m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?1:0,f,_+o),i&&r||!i&&!r?(m+=e.PathUtils.verticalLineTo(c-o),m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?1:0,f+(i?-1:1)*o,c)):(m+=e.PathUtils.verticalLineTo(b-o),m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?1:0,f+(i?-1:1)*o,b),m+=e.PathUtils.horizontalLineTo(y+(i?1:-1)*o),m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?0:1,y,b+o),m+=e.PathUtils.verticalLineTo(c-o),m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?0:1,y+(i?1:-1)*o,c))):c<_?(m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?0:1,f,_-o),i&&r||!i&&!r?(m+=e.PathUtils.verticalLineTo(c+o),m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?0:1,f+(i?-1:1)*o,c)):(m+=e.PathUtils.verticalLineTo(b+o),m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?0:1,f+(i?-1:1)*o,b),m+=e.PathUtils.horizontalLineTo(y+(i?1:-1)*o),m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?1:0,y,b-o),m+=e.PathUtils.verticalLineTo(c+o),m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?1:0,y+(i?1:-1)*o,c))):(m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?1:0,f,_+o),m+=e.PathUtils.verticalLineTo(b-o),m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?1:0,f+(i?-1:1)*o,b),m+=e.PathUtils.horizontalLineTo(y+(i?1:-1)*o),m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?1:0,y,b-o),m+=e.PathUtils.verticalLineTo(c+o),m+=r?e.PathUtils.arcTo(o,o,Math.PI/2,0,y-o,c):e.PathUtils.arcTo(o,o,Math.PI/2,1,y+o,c))):c>_?(m+=e.PathUtils.horizontalLineTo(y+(i?-1:1)*o),m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?1:0,y,_+o),m+=e.PathUtils.verticalLineTo(c-o),m+=r?e.PathUtils.arcTo(o,o,Math.PI/2,1,y-o,c):e.PathUtils.arcTo(o,o,Math.PI/2,0,y+o,c)):c<_?(m+=e.PathUtils.horizontalLineTo(y+(i?-1:1)*o),m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?0:1,y,_-o),m+=e.PathUtils.verticalLineTo(c+o),m+=r?e.PathUtils.arcTo(o,o,Math.PI/2,0,y-o,c):e.PathUtils.arcTo(o,o,Math.PI/2,1,y+o,c)):(i&&r||!i&&!r)&&(m+=e.PathUtils.horizontalLineTo(f+(i?-1:1)*o),m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?1:0,f,_+o),m+=e.PathUtils.verticalLineTo(b-o),m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?0:1,f+(i?1:-1)*o,b),m+=e.PathUtils.horizontalLineTo(y-o),m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?0:1,y,b-o),m+=e.PathUtils.verticalLineTo(c+o),m+=e.PathUtils.arcTo(o,o,Math.PI/2,i?0:1,y+(i?-1:1)*o,c)),m+=e.PathUtils.lineTo(g,c)},s.prototype.getNextNavigable=function(t){if(t.keyCode===e.KeyboardEvent.UP_ARROW||t.keyCode===e.KeyboardEvent.DOWN_ARROW){var a=this.getKeyboardFocusTask();a||(a=this.getPredecessorNode());var i=this,n=this.getGantt().getEventManager().getKeyboardHandler();if(n&&n.getNextNavigableDependencyLine){var s=a===this.getPredecessorNode()?"successor":"predecessor",r=this.getGantt().getNavigableDependencyLinesForTask(a,s);i=n.getNextNavigableDependencyLine(a,this,t,r)}return i.setKeyboardFocusTask(a),i}return t.keyCode===e.KeyboardEvent.RIGHT_ARROW||t.keyCode===e.KeyboardEvent.LEFT_ARROW?e.Agent.isRightToLeft(this.getGantt().getCtx())?t.keyCode===e.KeyboardEvent.LEFT_ARROW?this.getSuccessorNode():this.getPredecessorNode():t.keyCode===e.KeyboardEvent.RIGHT_ARROW?this.getSuccessorNode():this.getPredecessorNode():t.type===e.MouseEvent.CLICK?this:null},s.prototype.setKeyboardFocusTask=function(t){this._keyboardNavNode=t},s.prototype.getKeyboardFocusTask=function(){return this._keyboardNavNode},s.prototype.getKeyboardBoundingBox=function(t){return this.getDimensions(t)},s.prototype.getTargetElem=function(){return this._content?this._content.getContainerElem():this._line.getElem()},s.prototype.showKeyboardFocusEffect=function(){this.isCustomContent()?(this._renderCustomContent({focused:!0}),this._isShowingKeyboardFocusEffect=!0):this._line&&(e.ToolkitUtils.addClassName(this._line.getElem(),this._gantt.GetStyleClass("focus")),this._line.showHoverEffect(),this._isShowingKeyboardFocusEffect=!0)},s.prototype.hideKeyboardFocusEffect=function(){this.isShowingKeyboardFocusEffect()&&(this.isCustomContent()?this._renderCustomContent({focused:!1}):(this._line.hideHoverEffect(),e.ToolkitUtils.removeClassName(this._line.getElem(),this._gantt.GetStyleClass("focus"))),this._isShowingKeyboardFocusEffect=!1)},s.prototype.isShowingKeyboardFocusEffect=function(){return this._isShowingKeyboardFocusEffect},s.prototype.getDatatip=function(t,e,a){return this.getAriaLabel()},s.prototype.getAriaLabel=function(){return this._dependencyObj.ariaLabel};var r=function(t,e){this.Init(t,e)};e.Obj.createSubclass(r,e.Obj),r.prototype.Init=function(t,e){this._rowAxis=t,this._gantt=t._gantt,this._contentType=e},r.prototype.render=function(t){var a=t.data;this._labelString=null!=a.label?a.label:"";var i=e.Agent.isRightToLeft(this._gantt.getCtx()),n=this._rowAxis.getAvailableWidth();this._content||(this._content="custom"===this._contentType?this._getCustomContent(t,n):this._getTextContent(t)),this._contentDisplayable=this._gantt.isRowsHierarchical()?this._addExpandCollapseButton(this._content,t):this._content,this._gantt.getEventManager().associate(this._contentDisplayable,this,!0),this._rowAxis.addChild(this._contentDisplayable);var s=this._contentDisplayable.getDimensions();"g"===this.getDisplayableType()?(this._width=i?-Math.min(0,s.x):s.x+s.w,this._width=Math.max(0,this._width),this._height=s.y+s.h):(this._width=Math.min(s.w,n.calculatedWidth),this._height=s.h)},r.prototype._getCustomContent=function(t,a){var i=t.data,s=new e.Container(this._gantt.getCtx());s.setClassName(this._gantt.GetStyleClass("rowLabel"));var r=i.labelStyle;null!=r&&s.setStyle(r);var o=this._gantt.getOptions(),l=o.rowAxis.label.renderer,h=n.getRowLabelPadding(o),d=this._gantt.getRowAxisMaxWidth();if(-1===a.width&&null!=d&&"none"===d)var g=-1;else g=this._gantt.isRowsHierarchical()?Math.max(0,a.calculatedWidth-this._rowAxis.getLabelContentIndentSize(t))-2*h:Math.max(0,a.calculatedWidth-2*h);var _=t.height,c=s.getContainerElem(),p=l(this.getRendererContext(i,g,_,c));return p&&(Array.isArray(p)?p.forEach(function(t){e.ToolkitUtils.appendChildElem(c,t)}):e.ToolkitUtils.appendChildElem(c,p)),s},r.prototype._getTextContent=function(t){var a=t.data,i=new e.OutputText(this._gantt.getCtx(),this._labelString,0,0);i.setClassName(this._gantt.GetStyleClass("rowLabel"));var n=a.labelStyle;return null!=n&&""!==n&&0!==Object.keys(n).length&&i.setStyle(n),i.setCSSStyle(this._rowAxis._getCSSStyle(n)),i},r.prototype._addExpandCollapseButton=function(t,a){var i=e.Agent.isRightToLeft(this._gantt.getCtx()),s=new e.Container(this._gantt.getCtx()),r=this._rowAxis.getLabelContentIndentSize(a),o=i?-r:r;if(i&&"text"===this._contentType&&(o-=t.getDimensions().w),t.setTranslateX(o),null!=a.expanded){var l=n.getRowLabelButtonSize(),h=r-(l+n.getRowLabelButtonContentGapSize());h=i?-(h+l):h;var d=(t.getDimensions().h-l)/2,g=this._gantt.getEventManager(),_=this._createExpandCollapseButton(this._gantt.getCtx(),this._gantt.getOptions()._resources,a.expanded?"open":"closed",h,d,l,g.onExpandCollapseButtonClick,g);this._button=_,s.addChild(_)}else this._button=null;return s.addChild(t),s},r.prototype._createExpandCollapseButton=function(t,a,i,n,s,r,o,l){var h=e.ToolkitUtils.getIconStyle(t,a[i]),d=new e.IconButton(t,"borderless",{style:h,size:r},null,null,o,l);return d.setTranslate(n,s),d.setAriaRole("button"),d.setAriaProperty("label",this.getAriaLabel()),this._gantt.getEventManager().associate(d,this),d},r.prototype.getRendererContext=function(t,e,i,n){var s=this._gantt.getOptions(),r=t.tasks,o=[];if(s.taskData)for(var l=0;l<r.length;l++)o.push(r[l]._itemData);var h={component:s._widgetConstructor,parentElement:n,rowData:a.TimeComponent.sanitizeData(t,"row"),itemData:s.taskData?o:null,maxWidth:e,maxHeight:i};return this._gantt.getCtx().fixRendererContext(h)},r.prototype.getRow=function(){return this._rowNode},r.prototype.setRow=function(t){this._rowNode=t},r.prototype.getRowIndex=function(){return this._rowIndex},r.prototype.setRowIndex=function(t){this._rowIndex=t},r.prototype.getRowLayoutObject=function(){return this._gantt.getRowLayoutObjs()[this.getRowIndex()]},r.prototype.getDisplayable=function(){return this._contentDisplayable},r.prototype.getExpandCollapseButton=function(){return this._button},r.prototype.getLabelString=function(){return this._labelString},r.prototype.getDisplayableType=function(){return this._gantt.isRowsHierarchical()||"custom"===this._contentType?"g":"text"},r.prototype.getContentType=function(){return this._contentType},r.prototype.getX=function(){return"text"===this.getDisplayableType()?this._contentDisplayable.getX():this._contentDisplayable.getTranslateX()},r.prototype.setX=function(t){"text"===this.getDisplayableType()?this._contentDisplayable.setX(t):this._contentDisplayable.setTranslateX(t)},r.prototype.getY=function(){return"text"===this.getDisplayableType()?this._contentDisplayable.getY():this._contentDisplayable.getTranslateY()},r.prototype.setY=function(t){"text"===this.getDisplayableType()?this._contentDisplayable.setY(t):this._contentDisplayable.setTranslateY(t)},r.prototype.getWidth=function(){return this._width},r.prototype.getHeight=function(){return this._height},r.prototype.getAriaLabel=function(){var t=this._gantt.getOptions().translations,a=[],i=this.getRowLayoutObject();return null!=i.expanded&&a.push(t[i.expanded?"stateExpanded":"stateCollapsed"]),e.Displayable.generateAriaLabel(t.labelLevel+" "+i.depth+", "+this.getLabelString(),a)};var o=function(t,e,a,i,n,s,r,o,l){this.Init(t,e,a,i,n,s,r,o,l)};e.Obj.createSubclass(o,e.Path),o.MAIN_TYPES=["main","mainSelect","mainHover"],o.MAIN_EFFECT_TYPES=["mainSelect","mainHover"],o.BASELINE_TYPES=["baseline","baselineSelect","baselineHover"],o.BASELINE_EFFECT_TYPES=["baselineSelect","baselineHover"],o.prototype.Init=function(t,e,a,i,n,s,r,l,h){var d;switch(this._context=t,this._x=e,this._y=a,this._w=i,this._h=n,this._r=null!=s?s:"0",this._task=r,this._type=l,this._renderState="add",this._typeCmdGeneratorMap={main:this._generateRepShapeCmd,mainSelect:this._generateRepShapeCmd,mainHover:this._generateRepShapeCmd,mainDragFeedback:this._generateRepShapeCmd,mainResizeHandleStart:this._generateRectCmd,mainResizeHandleEnd:this._generateRectCmd,mainResizeHandleDragFeedback:this._generateRectCmd,progress:this._generateRectCmd,baseline:this._generateRepShapeCmd,baselineSelect:this._generateRepShapeCmd,baselineHover:this._generateRepShapeCmd},d=this._typeCmdGeneratorMap[this._type].call(this,this._x,this._y,this._w,this._h,this._r),o.superclass.Init.call(this,t,d,h),this.applyDefaultStyleClasses(),this._type){case"mainDragFeedback":case"mainResizeHandleDragFeedback":this.setMouseEnabled(!1);case"mainResizeHandleStart":case"mainResizeHandleEnd":r.getGantt().getEventManager().associate(this,r.getContainer());case"main":case"progress":case"baseline":this.setPixelHinting(!0)}},o.prototype._generateRepShapeCmd=function(t,a,i,s,r){var l,h=e.Agent.isRightToLeft(this._context),d=(o.MAIN_EFFECT_TYPES.indexOf(this._type)>-1||o.BASELINE_EFFECT_TYPES.indexOf(this._type)>-1)*n.getTaskEffectMargin();return this._task.isMilestone(this._type)&&0===i?(l=d*Math.sqrt(2),this._generateDiamondCmd(t,a-l,s+2*l,r)):this._task.isSummary(this._type)&&"main"===this._type?this._generateSummaryCmd(t,a,i,s,r):this._generateRectCmd(h?t+d:t-d,a-d,i+2*d,s+2*d,r)},o.prototype._generateRectCmd=function(t,a,i,n,s){var r=e.Agent.isRightToLeft(this._context);return"0"===s||"0px"===s?e.PathUtils.moveTo(t,a)+e.PathUtils.horizontalLineTo(r?t-i:t+i)+e.PathUtils.verticalLineTo(a+n)+e.PathUtils.horizontalLineTo(t)+e.PathUtils.closePath():e.PathUtils.rectangleWithBorderRadius(t-r*i,a,i,n,s,Math.min(i,n),"0")},o.prototype._generateSummaryCmd=function(t,a,i,s,r){var o=e.Agent.isRightToLeft(this._context),l=n.getSummaryThickness();if("0"===r||"0px"===r)return i>2*l?e.PathUtils.moveTo(t,a+s)+e.PathUtils.verticalLineTo(a)+e.PathUtils.horizontalLineTo(o?t-i:t+i)+e.PathUtils.verticalLineTo(a+s)+e.PathUtils.horizontalLineTo(o?t-i+l:t+i-l)+e.PathUtils.verticalLineTo(a+l)+e.PathUtils.horizontalLineTo(o?t-l:t+l)+e.PathUtils.verticalLineTo(a+s)+e.PathUtils.closePath():this._generateRectCmd(t,a,i,s,r);var h=Math.min(new e.CSSStyle({"border-radius":r}).getBorderRadius(),Math.min(i,s)),d=Math.max(h-l,0);return i>2*l?e.PathUtils.moveTo(t,a+s)+e.PathUtils.verticalLineTo(a+h)+e.PathUtils.arcTo(h,h,Math.PI/2,o?0:1,o?t-h:t+h,a)+e.PathUtils.horizontalLineTo(o?t-i+h:t+i-h)+e.PathUtils.arcTo(h,h,Math.PI/2,o?0:1,o?t-i:t+i,a+h)+e.PathUtils.verticalLineTo(a+s)+e.PathUtils.horizontalLineTo(o?t-i+l:t+i-l)+e.PathUtils.verticalLineTo(a+l+d)+e.PathUtils.arcTo(d,d,Math.PI/2,o?1:0,o?t-i+l+d:t+i-l-d,a+l)+e.PathUtils.horizontalLineTo(o?t-l-d:t+l+d)+e.PathUtils.arcTo(d,d,Math.PI/2,o?1:0,o?t-l:t+l,a+l+d)+e.PathUtils.verticalLineTo(a+s)+e.PathUtils.closePath():e.PathUtils.rectangleWithBorderRadius(t-o*i,a,i,s,h+"px "+h+"px 0px 0px",Math.min(i,s),"0")},o.prototype._generateDiamondCmd=function(t,a,i,n){var s=i/2;if("0"===n||"0px"===n)return e.PathUtils.moveTo(t,a)+e.PathUtils.lineTo(t+s,a+s)+e.PathUtils.lineTo(t,a+i)+e.PathUtils.lineTo(t-s,a+s)+e.PathUtils.closePath();var r=Math.min(new e.CSSStyle({"border-radius":n}).getBorderRadius(),i/(2*Math.sqrt(2))),o=r/Math.sqrt(2),l=r,h=r;return e.PathUtils.moveTo(t-o,a+o)+e.PathUtils.arcTo(l,h,0,1,t+o,a+o)+e.PathUtils.lineTo(t+s-o,a+s-o)+e.PathUtils.arcTo(l,h,0,1,t+s-o,a+s+o)+e.PathUtils.lineTo(t+o,a+i-o)+e.PathUtils.arcTo(l,h,0,1,t-o,a+i-o)+e.PathUtils.lineTo(t-s+o,a+s+o)+e.PathUtils.arcTo(l,h,0,1,t-s+o,a+s-o)+e.PathUtils.closePath()},o.prototype.applyDefaultStyleClasses=function(){var t,a,i,n,s,r,l=this._task.getGantt(),h=l.getEventManager().IsDragSupported("tasks");"progress"===this._type?(t=l.GetStyleClass("taskProgress"),h&&(t+=" "+l.GetStyleClass("draggable")),this.setClassName(t)):o.MAIN_TYPES.indexOf(this._type)>-1?(t=l.GetStyleClass("task"),a=l.GetStyleClass("taskMilestone"),i=l.GetStyleClass("taskBar"),n=l.GetStyleClass("taskSummary"),this._task.isMilestone(this._type)&&0===this._w?t+=" "+a:this._task.isSummary(this._type)?t+=" "+n:(t+=" "+i,"main"===this._type&&null!=this._task.getProgressValue()&&(t+=" "+l.GetStyleClass("taskUnprogress"))),"mainSelect"===this._type?(this.setStyle({fill:"none",filter:"none"}),t+=" "+l.GetStyleClass("selected")):"mainHover"===this._type?(t+=" "+l.GetStyleClass("hover"),r={fill:"none"},null!=(s=this._task.getFillColor())&&(this.setStroke(e.SelectionEffectUtils.createSelectingStroke(s.fill)),r.stroke=s.fill,"none"===s.filter&&(r.filter="none")),this.setStyle(r)):"main"===this._type&&h&&(t+=" "+l.GetStyleClass("draggable")),this.setClassName(t)):o.BASELINE_TYPES.indexOf(this._type)>-1?(t=l.GetStyleClass("baseline"),a=l.GetStyleClass("baselineMilestone"),i=l.GetStyleClass("baselineBar"),this._task.isMilestone(this._type)&&0===this._w?t+=" "+a:t+=" "+i,this.setClassName(t)):"mainDragFeedback"===this._type||"mainResizeHandleDragFeedback"===this._type?(t=l.GetStyleClass("taskDragImage"),this.setClassName(t)):"mainResizeHandleStart"!==this._type&&"mainResizeHandleEnd"!==this._type||(t=l.GetStyleClass("taskResizeHandle"),this.setClassName(t+" "+this._task.getGantt().GetStyleClass("draggable")))},o.prototype.getFillColor=function(){var t,a,i,s,r,o,l,h;t=(t=null!=(t=this.getElem()).firstChild?t.firstChild:t).cloneNode(!1),(a=this._task.getGantt().getCtx().getSvgDocument()).appendChild(t);try{if(s=(i=window.getComputedStyle(t)).fill,h=Number(i.fillOpacity),o=i.filter,!(String.prototype.startsWith?s.startsWith("url("):0===s.indexOf("url("))){switch(o){case"url("+JSON.stringify("#"+n.getTaskTintFilterId())+")":case"url(#"+n.getTaskTintFilterId()+")":r=e.ColorUtils.getBrighter(s,n.getTaskTintAlpha());break;case"url("+JSON.stringify("#"+n.getTaskShadeFilterId())+")":case"url(#"+n.getTaskShadeFilterId()+")":r=e.ColorUtils.getDarker(s,n.getTaskShadeAlpha());break;default:r=s}1===h||Number.isNaN(h)||(r=e.ColorUtils.getBrighter(r,1-h)),l={fill:s,computedFill:r,filter:o}}}finally{a.removeChild(t)}return l},o.prototype.getType=function(){return this._type},o.prototype.getTask=function(){return this._task},o.prototype.getPhysicalStartOffset=function(){return(o.MAIN_TYPES.indexOf(this._type)>-1||o.BASELINE_TYPES.indexOf(this._type)>-1)&&this._task.isMilestone(this._type)?this._finalHeight/2:0},o.prototype.getPhysicalEndOffset=function(){return(o.MAIN_TYPES.indexOf(this._type)>-1||o.BASELINE_TYPES.indexOf(this._type)>-1)&&this._task.isMilestone(this._type)?this._finalHeight/2:0},o.prototype.getType=function(){return this._type},o.prototype.getRenderState=function(){return this._renderState},o.prototype.setRenderState=function(t){this._renderState=t},o.prototype.getWidth=function(){return this._w},o.prototype.getFinalWidth=function(){return this._finalWidth},o.prototype.setWidth=function(t){var e;!(o.MAIN_TYPES.indexOf(this._type)>-1||o.BASELINE_TYPES.indexOf(this._type)>-1)||0!==this._w&&0!==t||(this._w=t,this.applyDefaultStyleClasses()),this._w=t,e=this._typeCmdGeneratorMap[this._type].call(this,this._x,this._y,this._w,this._h,this._r),this.setCmds(e)},o.prototype.setFinalWidth=function(t){this._finalWidth=t},o.prototype.getHeight=function(){return this._h},o.prototype.getFinalHeight=function(){return this._finalHeight},o.prototype.setHeight=function(t){var e;this._h=t,e=this._typeCmdGeneratorMap[this._type].call(this,this._x,this._y,this._w,this._h,this._r),this.setCmds(e)},o.prototype.setFinalHeight=function(t){this._finalHeight=t},o.prototype.getX=function(){return this._x},o.prototype.getFinalX=function(){return this._finalX},o.prototype.setX=function(t){var e;this._x=t,e=this._typeCmdGeneratorMap[this._type].call(this,this._x,this._y,this._w,this._h,this._r),this.setCmds(e)},o.prototype.setFinalX=function(t){this._finalX=t},o.prototype.getY=function(){return this._y},o.prototype.getFinalY=function(){return this._finalY},o.prototype.setY=function(t){var e;this._y=t,e=this._typeCmdGeneratorMap[this._type].call(this,this._x,this._y,this._w,this._h,this._r),this.setCmds(e)},o.prototype.setFinalY=function(t){this._finalY=t},o.prototype.getBorderRadius=function(){return this._r},o.prototype.setBorderRadius=function(t){var e;this._r=null!=t?t:"0",e=this._typeCmdGeneratorMap[this._type].call(this,this._x,this._y,this._w,this._h,this._r),this.setCmds(e)},o.prototype.setDimensions=function(t,e,a,i,n){var s;!(o.MAIN_TYPES.indexOf(this._type)>-1||o.BASELINE_TYPES.indexOf(this._type)>-1)||0!==this._w&&0!==a||(this._w=a,this.applyDefaultStyleClasses()),this._x=t,this._y=e,this._w=a,this._h=i,this._r=null!=n?n:"0",s=this._typeCmdGeneratorMap[this._type].call(this,this._x,this._y,this._w,this._h,this._r),this.setCmds(s)};var l=new Object;e.Obj.createSubclass(l,e.Obj),l.getDatatipColor=function(t){var e=t.getTask().getFillColor();return e?e.fill:null},l.getDatatip=function(t,a,i){var n=t.getGantt();if(n.getEventManager().isKeyboardDnDScaleChanged()){var s=n.getEventManager().getKeyboardDnDNavigationScale(),r="move"===n.getEventManager().getKeyboardDnDMode()?"MoveBy":"ResizeBy",o=l._addDatatipRow("",n,"",r,s.charAt(0).toUpperCase()+s.slice(1),a);return l._processDatatip(o,n,a)}var h=n.getOptions().tooltip,d=h?h.renderer:null;if(a&&d){var g=n.getCtx().getTooltipManager(),_=n.getEventManager().isDnDDragging()?t.getSandboxDataContext():t.getDataContext();return g.getCustomTooltip(d,_)}var c=t.getValue("shortDesc");if(null!=c)return c;if(i&&!n.getCtx().isCustomElement()){var p=n.getOptions().valueFormats;if(!p||0===p.length){var u=t.getTask(),b=t.getValue("start"),f=t.getValue("end"),y=t.getValue("baseline","start"),m=t.getValue("baseline","end"),v=u.getProgressValue(),T=n.getOptions(),D=T.translations,S=u.isMilestone("main"),E=u.isMilestone("baseline"),C=!(null==b&&null==f),A=!(null==y&&null==m);if(C)if(S)var O=n.getTimeAxis().formatDate(new Date(null!=b?b:f),null,"general"),w=e.ResourceUtils.format(D.accessibleMilestoneInfo,[O]);else{var R=n.getTimeAxis().formatDate(new Date(b),null,"general"),k=n.getTimeAxis().formatDate(new Date(f),null,"general"),x=t.getDuration(b,f);w=e.ResourceUtils.format(D.accessibleTaskInfo,[R,k,x])}if(A)if(E)var L=n.getTimeAxis().formatDate(new Date(null!=y?y:m),null,"general"),P=D.labelBaselineDate+": "+L;else{var M=n.getTimeAxis().formatDate(new Date(y),null,"general"),I=n.getTimeAxis().formatDate(new Date(m),null,"general");P=(P=D.labelBaselineStart+": "+M)+"; "+D.labelBaselineEnd+": "+I}if(C){var j=t.getValue("label");if(null!=j)var N=D.labelLabel+": "+j;if(null!=v){var F=T._resources;if(F){var H=F.percentConverter;if(H){var B=H.format(v);if(null!=B)var U=D.labelProgress+": "+B}}}}var Y=t.getRowNode(),V=Y.getLabel();null==V&&(V=Y.getIndex()+1);var z=e.ResourceUtils.format(D.accessibleRowInfo,[V]);return w&&(z=z+"; "+w),P&&(z=z+"; "+P),N&&(z=z+"; "+N),U&&(z=z+"; "+U),z}}var G="";return G=l._addRowDatatip(G,t,a),G=l._addTaskDatatip(G,t,a),l._processDatatip(G,n,a)},l._processDatatip=function(t,e,a){return""===t?null:a?'<table class="'+e.GetStyleClass("tooltipTable")+'">'+t+"</table>":t},l._addRowDatatip=function(t,e,a){var i=e.getGantt();if(i.getEventManager().isDnDDragging())var n=e.getSandboxValue("_rowNode");else n=e.getRowNode();var s=n.getLabel();return null==s&&(s=n.getIndex()+1),l._addDatatipRow(t,i,"row","Row",s,a)},l._addTaskDatatip=function(t,e,a){var i=e.getGantt(),n=i.getEventManager().isDnDDragging()?e.getSandboxValue:e.getValue,s=e.getTask(),r=n.call(e,"start"),o=n.call(e,"end"),h=n.call(e,"baseline","start"),d=n.call(e,"baseline","end"),g=n.call(e,"label"),_=s.getProgressValue(),c=!(null==r&&null==o),p=!(null==h&&null==d),u=s.isMilestone("main"),b=s.isMilestone("baseline");return c?(u?(t=l._addDatatipRow(t,i,"date","Date",null!=r?r:o,a),b?t=l._addDatatipRow(t,i,"baselineDate","BaselineDate",null!=h?h:d,a):p&&(t=l._addDatatipRow(t,i,"baselineStart","BaselineStart",h,a),t=l._addDatatipRow(t,i,"baselineEnd","BaselineEnd",d,a))):b?(t=l._addDatatipRow(t,i,"start","Start",r,a),t=l._addDatatipRow(t,i,"end","End",o,a),t=l._addDatatipRow(t,i,"baselineDate","BaselineDate",null!=h?h:d,a)):p?(t=l._addDatatipRow(t,i,"start","Start",r,a),t=l._addDatatipRow(t,i,"baselineStart","BaselineStart",h,a),t=l._addDatatipRow(t,i,"end","End",o,a),t=l._addDatatipRow(t,i,"baselineEnd","BaselineEnd",d,a)):(t=l._addDatatipRow(t,i,"start","Start",r,a),t=l._addDatatipRow(t,i,"end","End",o,a)),t=l._addDatatipRow(t,i,"label","Label",g,a),null!=_&&(t=l._addDatatipRow(t,i,"progress","Progress",_,a))):p&&(t=l._addDatatipRow(t,i,"baselineStart","BaselineStart",h,a),t=l._addDatatipRow(t,i,"baselineEnd","BaselineEnd",d,a)),t},l._addDatatipRow=function(t,a,i,n,s,r,o){if(null==s||""===s)return t;var h,d=l.getValueFormat(a,i);return"off"===d.tooltipDisplay?t:("string"==typeof d.tooltipLabel&&(h=d.tooltipLabel),null==h&&(h=null==n?"":a.getOptions().translations["label"+n]),s=l.formatValue(a,i,d,s),r?t+'<tr><td class="'+a.GetStyleClass("tooltipLabel")+'">'+h+'</td><td class="'+a.GetStyleClass("tooltipValue")+'">'+s+"</td></tr>":(t.length>0&&(t+="<br>"),t+e.ResourceUtils.format(a.getOptions().translations.labelAndValue,[h,s])))},l.getValueFormat=function(t,e){var a=t.getOptions().valueFormats;if(!a)return{};if(a instanceof Array){for(var i={},n=0;n<a.length;n++){var s=a[n];i[s.type]=s}t.getOptions().valueFormats=i,a=i}return a[e]?a[e]:{}},l.formatValue=function(t,e,a,i){var n=a.converter;if("start"===e||"end"===e||"date"===e||"baselineStart"===e||"baselineEnd"===e||"baselineDate"===e)return t.getTimeAxis().formatDate(new Date(i),n,"general");if(n&&n.format)return n.format(i);if("progress"===e){var s=t.getOptions()._resources;if(s){var r=s.percentConverter;if(r)return r.format(i)}}return i};var h=function(t){h.superclass.constructor.call(this,t),this._gantt=this._comp};e.Obj.createSubclass(h,a.TimeComponentEventManager),h.prototype.getFocus=function(){var t=h.superclass.getFocus.call(this);if(t&&"task"===t.nodeType&&null==t.getRowNode().getParent()){for(var e=t.getLayoutObject(),a=e.rowObj,i=this._gantt.getDataLayoutManager();null==e||!i.isRoot(a)&&i.isHiddenCollapsed(a);){var n=(a=i.getParentRowObj(a)).taskObjs;e=n.length>0?n[0]:null}return e?e.node:null}return t},h.prototype.hideTooltip=function(){this._preventHideTooltip||h.superclass.hideTooltip.call(this),this._preventHideTooltip=!1},h.MOVE_TASKS_DATA_TYPE="text/_dvtdndmovetasks",h.RESIZE_TASKS_DATA_TYPE="text/_dvtdndresizetasks",h._HIGH_LEVEL_DND_NAVIGATION_SCALES=["milliseconds","seconds","minutes","hours","days","weeks","months","quarters","years"],h.KEYBOARD_MOVE="move",h.KEYBOARD_RESIZE_START="resizeStart",h.KEYBOARD_RESIZE_END="resizeEnd",h.prototype.ProcessMarqueeEvent=function(t){if(this._gantt.isMarqueeSelectEnabled()){var a=this.getSelectionHandler();if("start"===t.subtype)this._initSelection=t.ctrlKey?a.getSelectedIds():[],this._initSelectionTargets=t.ctrlKey?a.getSelection():[];else if("move"===t.subtype){var i=this._gantt.getMarqueeArtifactsContainer().stageToLocal(t._relPos);this._gantt.autoPanOnEdgeDrag(i,n.getAutoPanEdgeThreshold(),!1,!1);var s=this._gantt.getDataLayoutManager().getLayoutObjectsInBBox(new e.Rectangle(t.x,t.y,t.w,t.h)).taskObjs.map(function(t){return t.node});a.processInitialSelections(this._initSelection,this._initSelectionTargets),a.processGroupSelection(s,!0)}else"end"===t.subtype&&this.fireSelectionEvent()}},h.prototype.isDndSupported=function(){return!0},h.prototype.isDnDDragging=function(){return this._isDndDragging},h.prototype._dragStartSetup=function(){this._dragInitialX=this._gantt.getTimeZoomCanvas().getTranslateX(),this._dragInitialY=this._gantt.getDatabody().getTranslateY(),this._dragInitialViewportStart=this._gantt.getViewportStartTime(),this._dragInitialViewportEnd=this._gantt.getViewportEndTime(),this._gantt.getReferenceLinesContainer().setMouseEnabled(!1),this._gantt.getReferenceAreasContainer().setMouseEnabled(!1)},h.prototype._dragCancelCleanup=function(){if(this._dragInitialX){var t=this._gantt.getTimeZoomCanvas().getTranslateX()-this._dragInitialX,e=this._gantt.getDatabody().getTranslateY()-this._dragInitialY;0===t&&0===e||(this._gantt.panBy(t,e,!0),this._gantt.setViewportStartTime(this._dragInitialViewportStart),this._gantt.setViewportEndTime(this._dragInitialViewportEnd))}this._dragInitialX=null,this._dragInitialY=null,this._dragInitialViewportStart=null,this._dragInitialViewportEnd=null,this._gantt.getReferenceLinesContainer().setMouseEnabled(!0),this._gantt.getReferenceAreasContainer().setMouseEnabled(!0)},h.prototype._dropCleanup=function(){null==this._dragInitialViewportStart||this._dragInitialViewportStart===this._gantt.getViewportStartTime()&&this._dragInitialViewportEnd===this._gantt.getViewportEndTime()||this._gantt.dispatchEvent(this._gantt.createViewportChangeEvent()),this._dragInitialX=null,this._dragInitialY=null,this._dragInitialViewportStart=null,this._dragInitialViewportEnd=null,this._gantt.getReferenceLinesContainer().setMouseEnabled(!0),this._gantt.getReferenceAreasContainer().setMouseEnabled(!0),this._isDndDragging=!1},h.prototype.getKeyboardDnDMode=function(){return this._keyboardDnDMode},h.prototype._handleKeyboardDnDInitiation=function(t,a,i,n,s){var r=e.Agent.isRightToLeft(this._gantt.getCtx())?-1:1;this._isDndDragging=!0,this._dragStartSetup();var o=a.getTask().getShape("main");this._gantt.registerAndConstructGlassPane();var l=this._gantt.installGlassPane();this._keyboardDnDScaleRampIndex=h._HIGH_LEVEL_DND_NAVIGATION_SCALES.indexOf(this._gantt.getTimeAxis().getScale()),a.setDraggedObject(i),a.dragStartSetup();var d=a.localToStage({x:o.getFinalX()+("end"===n)*r*o.getFinalWidth(),y:o.getFinalY()});this._keyboardDnDFeedbackLocalPos=this._gantt.getDnDArtifactsContainer().stageToLocal(d),a.showDragFeedback(t,this._keyboardDnDFeedbackLocalPos,a.getRowNode(),{x:0,y:0},!0),l&&(this._preventHideTooltip=!0),this._keyboardDnDSourceObj=a,this._keyboardDnDTargetObj=a.getRowNode();var g=a.getValue("start"),_=a.getValue("end"),c=a.getValue("baseline","start")||null,p=a.getValue("baseline","end")||null;this._keyboardDnDFeedbackTime={start:g,end:_,baselineStart:c,baselineEnd:p};var u=this._gantt.getOptions().translations,b=u[s.initiated];if(this._gantt.isSelectionSupported()&&this._keyboardDnDSourceObj.isSelected()){var f=this._gantt.getSelectionHandler().getSelectedCount();f>1&&(b+=". "+e.ResourceUtils.format(u[s.selectionInfo],[f-1]))}b+=". "+u[s.instruction]+".",this._gantt.updateLiveRegionText(b)},h.prototype.handleKeyboardMoveInitiation=function(t,e){this._keyboardDnDMode=h.KEYBOARD_MOVE;var a=e.getTask().getShape("main");this._handleKeyboardDnDInitiation(t,e,a,"start",{initiated:"taskMoveInitiated",selectionInfo:"taskMoveSelectionInfo",instruction:"taskMoveInitiatedInstruction"})},h.prototype.handleKeyboardResizeStartInitiation=function(t,e){this._keyboardDnDMode=h.KEYBOARD_RESIZE_START;var a=e.getTask().getShape("mainResizeHandleStart");this._handleKeyboardDnDInitiation(t,e,a,"start",{initiated:"taskResizeStartInitiated",selectionInfo:"taskResizeSelectionInfo",instruction:"taskResizeInitiatedInstruction"})},h.prototype.handleKeyboardResizeEndInitiation=function(t,e){this._keyboardDnDMode=h.KEYBOARD_RESIZE_END;var a=e.getTask().getShape("mainResizeHandleEnd");this._handleKeyboardDnDInitiation(t,e,a,"end",{initiated:"taskResizeEndInitiated",selectionInfo:"taskResizeSelectionInfo",instruction:"taskResizeInitiatedInstruction"})},h.prototype._handleKeyboardDnDChronologically=function(t,a){var n,s,r=e.Agent.isRightToLeft(this._gantt.getCtx()),o=this.getKeyboardDnDNavigationScale(),d=this._gantt.getStartTime(),g=this._gantt.getEndTime(),_=this._gantt.getContentLength(),c=this._gantt.getTimeAxis(),p="forward"===a?"next":"previous",u=c.getAdjacentDate(this._keyboardDnDFeedbackTime.start,o,p).getTime(),b=c.getAdjacentDate(this._keyboardDnDFeedbackTime.end,o,p).getTime(),f="auto";switch(this._keyboardDnDMode){case h.KEYBOARD_MOVE:("forward"===a&&u<=g||"backward"===a&&b>=d)&&(s=i.TimeAxisUtils.getDatePosition(d,g,this._keyboardDnDFeedbackTime.start,_),this._keyboardDnDFeedbackTime.start=u,this._keyboardDnDFeedbackTime.end=b,this._keyboardDnDFeedbackTime.baselineStart&&(this._keyboardDnDFeedbackTime.baselineStart=c.getAdjacentDate(this._keyboardDnDFeedbackTime.baselineStart,o,p).getTime(),this._keyboardDnDFeedbackTime.baselineEnd=c.getAdjacentDate(this._keyboardDnDFeedbackTime.baselineEnd,o,p).getTime()),n=i.TimeAxisUtils.getDatePosition(d,g,this._keyboardDnDFeedbackTime.start,_));break;case h.KEYBOARD_RESIZE_START:var y=this._keyboardDnDSourceObj.getValue("end");("forward"===a&&u<=y||"backward"===a&&u>=d)&&(s=i.TimeAxisUtils.getDatePosition(d,g,this._keyboardDnDFeedbackTime.start,_),this._keyboardDnDFeedbackTime.start=u,n=i.TimeAxisUtils.getDatePosition(d,g,this._keyboardDnDFeedbackTime.start,_)),f="start";break;case h.KEYBOARD_RESIZE_END:var m=this._keyboardDnDSourceObj.getValue("start");("forward"===a&&b<=g||"backward"===a&&b>=m)&&(s=i.TimeAxisUtils.getDatePosition(d,g,this._keyboardDnDFeedbackTime.end,_),this._keyboardDnDFeedbackTime.end=b,n=i.TimeAxisUtils.getDatePosition(d,g,this._keyboardDnDFeedbackTime.end,_)),f="end"}null!=n&&(n=r?_-n:n,s=r?_-s:s,this._keyboardDnDFeedbackLocalPos.x+=n-s),this._keyboardDnDSourceObj.showDragFeedback(t,this._keyboardDnDFeedbackLocalPos,this._keyboardDnDTargetObj,{x:0,y:0},!0),this._keyboardDnDSourceObj.scrollIntoView(f,"auto"),this._gantt.updateLiveRegionText(e.AriaUtils.processAriaLabel(l.getDatatip(this._keyboardDnDSourceObj,!1)))},h.prototype.handleKeyboardDnDForward=function(t){this._handleKeyboardDnDChronologically(t,"forward")},h.prototype.handleKeyboardDnDBackward=function(t){this._handleKeyboardDnDChronologically(t,"backward")},h.prototype._handleKeyboardDnDScaleChange=function(t,a){this._isKeyboardDnDScaleChanged=!0,this._keyboardDnDScaleRampIndex=Math.max(0,Math.min(this._keyboardDnDScaleRampIndex+a,h._HIGH_LEVEL_DND_NAVIGATION_SCALES.length-1)),this._keyboardDnDSourceObj.showDragFeedback(t,this._keyboardDnDFeedbackLocalPos,this._keyboardDnDTargetObj,{x:0,y:0},!0),this._gantt.updateLiveRegionText(e.AriaUtils.processAriaLabel(l.getDatatip(this._keyboardDnDSourceObj,!1))),this._isKeyboardDnDScaleChanged=!1},h.prototype.isKeyboardDnDScaleChanged=function(){return this._isKeyboardDnDScaleChanged},h.prototype.getKeyboardDnDNavigationScale=function(){return h._HIGH_LEVEL_DND_NAVIGATION_SCALES[this._keyboardDnDScaleRampIndex]},h.prototype.handleKeyboardDnDScaleUp=function(t){this._handleKeyboardDnDScaleChange(t,1)},h.prototype.handleKeyboardDnDScaleDown=function(t){this._handleKeyboardDnDScaleChange(t,-1)},h.prototype._handleKeyboardMoveRowDirection=function(t,a){var i=this._gantt.getRowLayoutObjs(),s=this._keyboardDnDTargetObj.getIndex();if("above"===a&&s>0)var r=i[s-1];else"below"===a&&s<i.length-1&&(r=i[s+1]);if(r){this._gantt.getDataLayoutManager().ensureInDOM(r,"row"),this._keyboardDnDTargetObj=r.node;var o=this._gantt.getOptions(),h=this._keyboardDnDTargetObj.localToStage({x:0,y:this._keyboardDnDTargetObj.getFinalY()+n.getRowPaddingTop(o)});this._keyboardDnDFeedbackLocalPos.y=this._gantt.getDnDArtifactsContainer().stageToLocal(h).y}this._keyboardDnDSourceObj.showDragFeedback(t,this._keyboardDnDFeedbackLocalPos,this._keyboardDnDTargetObj,{x:0,y:0},!0),this._keyboardDnDSourceObj.scrollIntoView("auto","below"===a?"bottom":"top"),this._gantt.updateLiveRegionText(e.AriaUtils.processAriaLabel(l.getDatatip(this._keyboardDnDSourceObj,!1)))},h.prototype.handleKeyboardMoveRowAbove=function(t){this._handleKeyboardMoveRowDirection(t,"above")},h.prototype.handleKeyboardMoveRowBelow=function(t){this._handleKeyboardMoveRowDirection(t,"below")},h.prototype.handleKeyboardDnDFinalize=function(t){var a,i,n,s,r,o;this._dropCleanup();var l=this._gantt.getOptions().translations;if(this._keyboardDnDMode===h.KEYBOARD_MOVE){a=this._getDragDataContexts(this._keyboardDnDSourceObj),i=new Date(this._keyboardDnDFeedbackTime.start).toISOString(),n=new Date(this._keyboardDnDFeedbackTime.end).toISOString();var d=null==this._keyboardDnDFeedbackTime.baselineStart?null:new Date(this._keyboardDnDFeedbackTime.baselineStart).toISOString(),g=null==this._keyboardDnDFeedbackTime.baselineEnd?null:new Date(this._keyboardDnDFeedbackTime.baselineEnd).toISOString();s=i;var _=this._keyboardDnDTargetObj.getDataContext();r=e.EventFactory.newGanttMoveEvent(a,s,i,n,d,g,_),o=l.taskMoveFinalized}else if(this._keyboardDnDMode===h.KEYBOARD_RESIZE_END||this._keyboardDnDMode===h.KEYBOARD_RESIZE_START){var c;a=this._getDragDataContexts(this._keyboardDnDSourceObj).map(function(t){return t.dataContext}),i=new Date(this._keyboardDnDFeedbackTime.start).toISOString(),n=new Date(this._keyboardDnDFeedbackTime.end).toISOString(),this._keyboardDnDMode===h.KEYBOARD_RESIZE_END?(s=n,c="end"):this._keyboardDnDMode===h.KEYBOARD_RESIZE_START&&(s=i,c="start"),r=e.EventFactory.newGanttResizeEvent(a,s,i,n,c),o=l.taskResizeFinalized}r&&(this._gantt.dispatchEvent(r),this._gantt.updateLiveRegionText(o)),this._keyboardDnDCleanup()},h.prototype.handleKeyboardDnDCancel=function(){var t=this._gantt.getOptions().translations;this._keyboardDnDMode===h.KEYBOARD_MOVE?this._gantt.updateLiveRegionText(t.taskMoveCancelled):this._keyboardDnDMode!==h.KEYBOARD_RESIZE_END&&this._keyboardDnDMode!==h.KEYBOARD_RESIZE_START||this._gantt.updateLiveRegionText(t.taskResizeCancelled),this._dragCancelCleanup(),this._keyboardDnDCleanup()},h.prototype._keyboardDnDCleanup=function(){null!=this._keyboardDnDMode&&(this._keyboardDnDSourceObj.dragEndCleanup(),this._keyboardDnDMode=null,this._isDndDragging=!1,this._keyboardDnDSourceObj=null,this._keyboardDnDTargetObj=null,this._keyboardDnDFeedbackTime=null,this._keyboardDnDScaleRampIndex=null,this._gantt.unregisterAndDestroyGlassPane())},h.prototype.getDnDTaskSubType=function(t){if(t instanceof o){var e=t.getType();if("main"===e||"progress"===e)return"tasks";if("mainResizeHandleStart"===e||"mainResizeHandleEnd"===e)return"taskResizeHandles";if("baseline"===e)return null}return"tasks"},h.prototype.GetDragSourceType=function(t){switch(this._keyboardDnDMode){case h.KEYBOARD_MOVE:return this.IsDragSupported("tasks")?"tasks":null;case h.KEYBOARD_RESIZE_END:case h.KEYBOARD_RESIZE_START:return this.IsDragSupported("taskResizeHandles")?"taskResizeHandles":null}var a=this.DragSource.getDragObject();if(a&&"task"===a.nodeType){if(t&&"dragstart"===t.getNativeEvent().type){var i=t.getNativeEvent(),n=i.clientX,s=i.clientY,r=i.offsetX,o=i.offsetY;if(null==n&&null==s||("ie"===e.Agent.browser||"edge"===e.Agent.browser)&&isNaN(r)&&isNaN(o)){var l=t.target?t.target:a.getTask().getShape("main");a.setDraggedObject(l)}}var d=this.getDnDTaskSubType(a.getDraggedObject());return this.IsDragSupported(d)?d:null}return null},h.prototype._getDragDataContexts=function(t,a){if(t&&"task"===t.nodeType){var i=t.getDraggedObject(),n=i.getType?i.getType():null;if(null!=this.getDnDTaskSubType(i)){var s=function(t){var i=t.getDataContext();switch(a&&e.ToolkitUtils.cleanDragDataContext(i),n){case"mainResizeHandleStart":return{dataContext:i,type:"start"};case"mainResizeHandleEnd":return{dataContext:i,type:"end"}}return i},r=[s(t)];if(this._gantt.isSelectionSupported()&&t.isSelected()&&this._gantt.getSelectionHandler().getSelectedCount()>1)for(var o=this._gantt.getSelectionHandler().getSelection(),l=0;l<o.length;l++){var h=o[l];h&&"task"===h.nodeType&&h!==t&&r.push(s(h))}return r}}return null},h.prototype.GetDragDataContexts=function(t){var e=this.DragSource.getDragObject();return this._getDragDataContexts(e,t)},h.prototype.GetDropOffset=function(t){var a=this.DragSource.getDragObject();if(a&&"task"===a.nodeType&&"tasks"===this.getDnDTaskSubType(a.getDraggedObject())){var i=a.getValue("start"),n=a.getValue("end"),s=a.getTask().getTimeSpanDimensions(i,n),r=this._context.pageToStageCoords(t.pageX,t.pageY),o=this._gantt.getDnDArtifactsContainer().stageToLocal(r);return new e.Point(s.startPos-o.x,a.getFinalY()-o.y)}return new e.Point(0,0)},h.prototype._getDropObject=function(t){if(t){var e=this.GetLogicalObject(t.target),a=this._gantt.getOptions().dnd,i=this._gantt.isTaskMoveEnabled()||this._gantt.isTaskResizeEnabled(),n=a.drop.tasks&&(a.drop.tasks.dataTypes||a.drop.tasks.drop);e&&"task"===e.nodeType&&i&&!n?this._dropObj=e.getRowNode():this._dropObj=e}return this._dropObj},h.prototype.GetDropTargetType=function(t){var e=this._getDropObject(t);return null==e?null:"row"===e.nodeType?"rows":"task"===e.nodeType?"tasks":null},h.prototype.GetDropEventPayload=function(t){var a=t.getNativeEvent().dataTransfer,n=Number(a.getData(e.EventManager.DROP_OFFSET_X_DATA_TYPE))||0,s=e.Agent.isRightToLeft(this._gantt.getCtx()),r=this._getDropObject(t);if(null==r)return null;if("row"===r.nodeType||"task"===r.nodeType){var o=this._context.pageToStageCoords(t.pageX,t.pageY),l=this._gantt.getTimeZoomCanvas().stageToLocal(o),h=this._gantt.getStartTime(),d=this._gantt.getEndTime(),g=this._gantt.getContentLength(),_={value:new Date(i.TimeAxisUtils.getPositionDate(h,d,s?g-l.x:l.x,g)).toISOString(),start:null,end:null,baselineStart:null,baselineEnd:null,dataContext:r.getDataContext()},c=this.DragSource.getDragObject();if(c&&"task"===c.nodeType){var p=c.getValue("start"),u=c.getValue("end"),b=c.getValue("baseline","start")||null,f=c.getValue("baseline","end")||null,y=c.getDraggedObject(),m=this.getDnDTaskSubType(y);if("tasks"===m)_.start=i.TimeAxisUtils.getPositionDate(h,d,s?g-(l.x+n):l.x+n,g),_.end=_.start+(u-p),null==b&&null==f||(_.baselineStart=new Date(b-p+_.start).toISOString(),_.baselineEnd=new Date(f-u+_.end).toISOString()),_.start=new Date(_.start).toISOString(),_.end=new Date(_.end).toISOString();else if("taskResizeHandles"===m){"mainResizeHandleEnd"===(y.getType?y.getType():null)?(_.start=new Date(p).toISOString(),_.end=new Date(_.value).getTime()-p<0?p:_.value):(_.start=u-new Date(_.value).getTime()<0?u:_.value,_.end=new Date(u).toISOString())}}return _}return null},h.prototype.ShowDropEffect=function(t){var a=this._getDropObject(t);if(this._gantt.isTaskResizeEnabled()){var n=this.DragSource.getDragObject();if(n&&"task"===n.nodeType){var s=n.getDraggedObject();if("taskResizeHandles"===this.getDnDTaskSubType(s))return}}if(a&&"row"===a.nodeType){if("firefox"===e.Agent.browser||i.TimeAxisUtils.supportsTouch())for(var r=this._gantt.getRowLayoutObjs(),o=this._gantt.getViewportYBounds(),l=(this._gantt.getDataLayoutManager().findRowIndRange(r,o.yMin,o.yMax),0);l<r.length;l++){var h=r[l].node;if(h&&h!==a){var d=h.getBackground().getElem();e.ToolkitUtils.removeClassName(d,this._gantt.GetStyleClass("invalidDrop")),e.ToolkitUtils.removeClassName(d,this._gantt.GetStyleClass("activeDrop"))}}var g=a.getBackground().getElem();e.ToolkitUtils.addClassName(g,this._gantt.GetStyleClass("activeDrop"))}},h.prototype.ShowRejectedDropEffect=function(t){var a=this._getDropObject(t);if(this._gantt.isTaskResizeEnabled()){var i=this.DragSource.getDragObject();if(i&&"task"===i.nodeType){var n=i.getDraggedObject();if("taskResizeHandles"===this.getDnDTaskSubType(n))return}}if(a&&"row"===a.nodeType){var s=a.getBackground().getElem();e.ToolkitUtils.addClassName(s,this._gantt.GetStyleClass("invalidDrop"))}},h.prototype.ClearDropEffect=function(){var t=this._getDropObject();if(t&&"row"===t.nodeType){var a=t.getBackground().getElem();e.ToolkitUtils.removeClassName(a,this._gantt.GetStyleClass("invalidDrop")),e.ToolkitUtils.removeClassName(a,this._gantt.GetStyleClass("activeDrop"))}},h.prototype.OnDndDragStart=function(t){h.superclass.OnDndDragStart.call(this,t),this._isDndDragging&&t.preventDefault();var a=t.getNativeEvent();if(a.defaultPrevented)this._gantt.SetPanningEnabled(!0),this._gantt.SetMarqueeEnabled(!0);else{this._isDndDragging=!0,this._dragStartSetup();var i=this.DragSource.getDragObject();if(i&&"task"===i.nodeType){i.dragStartSetup(t);var n=a.dataTransfer;this._dropOffset=new e.Point(Number(n.getData(e.EventManager.DROP_OFFSET_X_DATA_TYPE))||0,Number(n.getData(e.EventManager.DROP_OFFSET_Y_DATA_TYPE))||0)}else this._dropOffset=new e.Point(0,0)}},h.prototype.OnDndDragOver=function(t){h.superclass.OnDndDragOver.call(this,t);var a=this;this._lastKnownDragOverEvent=t,a._isDndDragging=!0,this._isDragOverTicking||this._lastProcessedDragOverEvent&&this._lastKnownDragOverEvent.pageX===this._lastProcessedDragOverEvent.pageX&&this._lastKnownDragOverEvent.pageY===this._lastProcessedDragOverEvent.pageY||(requestAnimationFrame(function(){var t=a.DragSource.getDragObject();if(t&&"task"===t.nodeType&&a._isDndDragging)if(a._lastKnownDragOverEvent.getNativeEvent().defaultPrevented){var i=a._gantt.getCtx().pageToStageCoords(a._lastKnownDragOverEvent.pageX,a._lastKnownDragOverEvent.pageY),n=a._gantt.getDnDArtifactsContainer().stageToLocal(i);if(t.showDragFeedback(a._lastKnownDragOverEvent,n,a._getDropObject(),a._dropOffset),e.Agent.isTouchDevice()){var s=e.AriaUtils.processAriaLabel(l.getDatatip(t,!1));if(a._gantt.isSelectionSupported()&&t.isSelected()){var r=a._gantt.getSelectionHandler().getSelectedCount();r>1&&(s+=". "+e.ResourceUtils.format(a._gantt.getOptions().translations.taskMoveSelectionInfo,[r-1]))}a._prevScreenReaderDragText&&a._prevScreenReaderDragText===s||a._gantt.updateLiveRegionText(s),a._prevScreenReaderDragText=s}}else t.removeDragFeedbacks();a._lastProcessedDragOverEvent=a._lastKnownDragOverEvent,a._isDragOverTicking=!1}),this._isDragOverTicking=!0)},h.prototype.OnDndDragEnd=function(t){h.superclass.OnDndDragEnd.call(this,t);var a=this.DragSource.getDragObject();a&&"task"===a.nodeType&&a.dragEndCleanup(),this._isDndDragging=!1,this._dropOffset=new e.Point(0,0),"none"===t.getNativeEvent().dataTransfer.dropEffect&&this.handleKeyboardDnDCancel(),this._gantt.SetPanningEnabled(!0),this._gantt.SetMarqueeEnabled(!0)},h.prototype.OnDndDrop=function(t){h.superclass.OnDndDrop.call(this,t),this._dropCleanup();var a=t.getNativeEvent();if(a.defaultPrevented){var i=this.DragSource.getDragObject(),n=i.getDraggedObject?this.getDnDTaskSubType(i.getDraggedObject()):"tasks";if(this._gantt.isTaskMoveEnabled()&&"tasks"===n){e.Agent.isTouchDevice()&&this._gantt.updateLiveRegionText(this._gantt.getOptions().translations.taskMoveFinalized);var s=this.GetDropEventPayload(t),r=JSON.parse(a.dataTransfer.getData(h.MOVE_TASKS_DATA_TYPE)),o=s.value,l=s.start,d=s.end,g=s.baselineStart,_=s.baselineEnd,c=s.dataContext,p=e.EventFactory.newGanttMoveEvent(r,o,l,d,g,_,c);this._gantt.dispatchEvent(p)}else if(this._gantt.isTaskResizeEnabled()&&"taskResizeHandles"===n){e.Agent.isTouchDevice()&&this._gantt.updateLiveRegionText(this._gantt.getOptions().translations.taskResizeFinalized);s=this.GetDropEventPayload(t);var u=JSON.parse(a.dataTransfer.getData(h.RESIZE_TASKS_DATA_TYPE)),b=u[0].type;r=u.map(function(t){return t.dataContext}),o=s.value,l=s.start,d=s.end,p=e.EventFactory.newGanttResizeEvent(r,o,l,d,b);this._gantt.dispatchEvent(p)}}},h.prototype.IsDragSupported=function(t){if(this.isDndSupported()){var e=this._gantt.getOptions(),a=e.dnd&&e.dnd.drag?e.dnd.drag:null;return a&&a[t]&&a[t].dataTypes&&a[t].dataTypes.length>0}return!1},h.prototype.IsDropSupported=function(t){if(this.isDndSupported()){var e=this._gantt.getOptions(),a=e.dnd&&e.dnd.drop?e.dnd.drop:null;return a&&a[t]&&a[t].dataTypes}return!1},h.prototype.OnMouseDown=function(t){var e=this.GetLogicalObjectAndDisplayable(t.target);if(e.logicalObject&&"task"===e.logicalObject.nodeType){var a=this.getDnDTaskSubType(e.displayable);this.IsDragSupported(a)&&(this._gantt.SetPanningEnabled(!1),this._gantt.SetMarqueeEnabled(!1),e.logicalObject.setDraggedObject(e.displayable))}h.superclass.OnMouseDown.call(this,t)},h.prototype.onExpandCollapseButtonClick=function(t,e){var a=this.GetLogicalObject(e).getRowLayoutObject();this.toggleRowExpandCollapse(t,a)},h.prototype.toggleRowExpandCollapse=function(t,a){if(null!=a.expanded){var i,n,s=this._gantt.getOptions().expanded,r=a.id,o=a.data,l=a.taskObjs[0].data,h=l.id,d=l._itemData;s.has(r)?(n=s.delete([r]),i="collapse"):(n=s.add([r]),i="expand"),this._gantt.setRenderState({state:i,payload:a}),this._gantt.isSelectionSupported()&&this._gantt.getSelectionHandler().clearSelection();var g=e.EventFactory.newGanttExpandCollapseEvent(i,h,o,d,n);this._gantt.dispatchEvent(g)}},h.prototype.HandleImmediateTouchStartInternal=function(t){if(1===t.targetTouches.length){var e=this.GetLogicalObjectAndDisplayable(t.target);if(e.logicalObject&&"task"===e.logicalObject.nodeType){var a=this.getDnDTaskSubType(e.displayable);this.IsDragSupported(a)&&(this._gantt.SetPanningEnabled(!1),this._gantt.SetMarqueeEnabled(!1),e.logicalObject.setDraggedObject(e.displayable))}}},h.prototype.OnTouchMoveBubble=function(t){this._isDndDragging&&(this._preventHideTooltip=!0),h.superclass.OnTouchMoveBubble.call(this,t)};var d=function(t,e){this.Init(t,e)};e.Obj.createSubclass(d,a.TimeComponentKeyboardHandler),d.prototype.Init=function(t,e){d.superclass.Init.call(this,e),this._gantt=t},d._findPreviousTask=function(t,e,a,i,n){var s=a.taskObjs;if(0===s.length)return 0===i?n:d._findPreviousTask(t,e,e[i-1],i-1,n);var r=s[s.length-1];return t.getDataLayoutManager().ensureInDOM(r,"task"),r.node},d._findNextTask=function(t,e,a,i,n){var s=a.taskObjs;if(0===s.length)return i===e.length-1?n:d._findNextTask(t,e,e[i+1],i+1,n);var r=s[0];return t.getDataLayoutManager().ensureInDOM(r,"task"),r.node},d.getNextNavigable=function(t,a,i,n){if(null==a||"task"!==a.nodeType)return null;var s=a.getRowNode(),r=t.getRowLayoutObjs(),o=s.getTaskObjs(),l=e.Agent.isRightToLeft(t.getCtx()),h=s.getIndex();switch(i.keyCode){case l?e.KeyboardEvent.RIGHT_ARROW:e.KeyboardEvent.LEFT_ARROW:var g=o.map(function(t){return t.node}).indexOf(a);if(0!==g){var _=o[g-1];return t.getDataLayoutManager().ensureInDOM(_,"task"),_.node}if(h>0)return d._findPreviousTask(t,r,r[h-1],h-1,a);break;case l?e.KeyboardEvent.LEFT_ARROW:e.KeyboardEvent.RIGHT_ARROW:if((g=o.map(function(t){return t.node}).indexOf(a))!==o.length-1){_=o[g+1];return t.getDataLayoutManager().ensureInDOM(_,"task"),_.node}if(h<r.length-1)return d._findNextTask(t,r,r[h+1],h+1,a);break;case e.KeyboardEvent.UP_ARROW:if(h>0&&null!=(a=d._findPreviousTask(t,r,r[h-1],h-1,a))){_=a.getRowNode().getTaskObjs()[0];return t.getDataLayoutManager().ensureInDOM(_,"task"),_.node}break;case e.KeyboardEvent.DOWN_ARROW:if(h<r.length-1&&null!=(a=d._findNextTask(t,r,r[h+1],h+1,a))){_=a.getRowNode().getTaskObjs()[0];return t.getDataLayoutManager().ensureInDOM(_,"task"),_.node}}return a},d.prototype.isNavigationEvent=function(t){var a=!1;switch(t.keyCode){case e.KeyboardEvent.OPEN_ANGLED_BRACKET:case e.KeyboardEvent.CLOSE_ANGLED_BRACKET:a=!!t.altKey;break;default:a=d.superclass.isNavigationEvent.call(this,t)}return a},d.prototype._getDistance=function(t){var e=t.getValue("type"),a=t.getPredecessorNode(),i=t.getSuccessorNode(),n=e===s.START_START||e===s.START_FINISH?a.getValue("start"):a.getValue("end");if(e===s.START_START||e===s.FINISH_START)var r=i.getValue("start");else r=i.getValue("end");return Math.abs(r-n)},d.prototype._getDependencyComparator=function(){var t=this;return function(e,a){var i=t._getDistance(e),n=t._getDistance(a);return i<n?-1:i>n?1:0}},d.prototype.getFirstNavigableDependencyLine=function(t,a,i){var n=this._gantt.getCtx(),s=a.keyCode;if(!i||i.length<1||!t)return null;for(var r=e.Agent.isRightToLeft(this._gantt.getCtx()),o=null,l=0,h=0;h<i.length;h++){var d=i[h];if(s===e.KeyboardEvent.CLOSE_ANGLED_BRACKET)var g=r?d.getValue("predecessorTaskId"):d.getValue("successorTaskId");else g=r?d.getValue("successorTaskId"):d.getValue("predecessorTaskId");if(!e.Obj.compareValues(n,t.getId(),g)){var _=this._getDistance(d);(null==o||_<l)&&(l=_,o=d)}}return o},d.prototype.getNextNavigableDependencyLine=function(t,a,i,n){if(!n)return null;if(!a)return n[0];if(!t)return a;n.sort(this._getDependencyComparator());for(var s=i.keyCode===e.KeyboardEvent.DOWN_ARROW,r=0,o=0;o<n.length;o++){if(n[o]===a){r=s?o===n.length-1?0:o+1:0===o?n.length-1:o-1;break}}return n[r]},d.prototype.isMoveInitiationEvent=function(t){return t.keyCode===e.KeyboardEvent.M&&t.ctrlKey},d.prototype.isResizeStartInitiationEvent=function(t){return 83===t.keyCode&&t.altKey},d.prototype.isResizeEndInitiationEvent=function(t){return 69===t.keyCode&&t.altKey},d.prototype.isDnDScaleUpEvent=function(t){return this._eventManager.getKeyboardDnDMode()&&t.keyCode===e.KeyboardEvent.PAGE_UP},d.prototype.isDnDScaleDownEvent=function(t){return this._eventManager.getKeyboardDnDMode()&&t.keyCode===e.KeyboardEvent.PAGE_DOWN},d.prototype.isDnDForwardEvent=function(t){var a=e.Agent.isRightToLeft(this._gantt.getCtx());return this._eventManager.getKeyboardDnDMode()&&t.keyCode===(a?e.KeyboardEvent.LEFT_ARROW:e.KeyboardEvent.RIGHT_ARROW)},d.prototype.isDnDBackwardEvent=function(t){var a=e.Agent.isRightToLeft(this._gantt.getCtx());return this._eventManager.getKeyboardDnDMode()&&t.keyCode===(a?e.KeyboardEvent.RIGHT_ARROW:e.KeyboardEvent.LEFT_ARROW)},d.prototype.isMoveRowAboveEvent=function(t){return this._eventManager.getKeyboardDnDMode()===h.KEYBOARD_MOVE&&t.keyCode===e.KeyboardEvent.UP_ARROW},d.prototype.isMoveRowBelowEvent=function(t){return this._eventManager.getKeyboardDnDMode()===h.KEYBOARD_MOVE&&t.keyCode===e.KeyboardEvent.DOWN_ARROW},d.prototype.isDnDFinalizeEvent=function(t){return this._eventManager.getKeyboardDnDMode()&&t.keyCode===e.KeyboardEvent.ENTER},d.prototype.isDnDCancelEvent=function(t){return this._eventManager.getKeyboardDnDMode()&&t.keyCode===e.KeyboardEvent.ESCAPE},d.prototype.processKeyDown=function(t){var a=t.keyCode;if(a===e.KeyboardEvent.TAB){var i;if(i=this._eventManager.getFocus())return e.EventManager.consumeEvent(t),i;for(var n=this._gantt.getRowLayoutObjs(),s=0;s<n.length;s++){var r=n[s].taskObjs;if(r.length>0){e.EventManager.consumeEvent(t);var o=r[0];return this._gantt.getDataLayoutManager().ensureInDOM(o,"task"),o.node}}}if(this.isMoveInitiationEvent(t)&&((i=this._eventManager.getFocus())&&this._gantt.isTaskMoveEnabled()&&!this._eventManager.isDnDDragging()))return this._eventManager.handleKeyboardMoveInitiation(t,i),e.EventManager.consumeEvent(t),null;if(this.isResizeStartInitiationEvent(t)&&((i=this._eventManager.getFocus())&&this._gantt.isTaskResizeEnabled()&&!this._eventManager.isDnDDragging()))return this._eventManager.handleKeyboardResizeStartInitiation(t,i),e.EventManager.consumeEvent(t),null;if(this.isResizeEndInitiationEvent(t)&&((i=this._eventManager.getFocus())&&this._gantt.isTaskResizeEnabled()&&!this._eventManager.isDnDDragging()))return this._eventManager.handleKeyboardResizeEndInitiation(t,i),e.EventManager.consumeEvent(t),null;if(this.isDnDCancelEvent(t))return this._eventManager.handleKeyboardDnDCancel(),e.EventManager.consumeEvent(t),null;if(this.isDnDScaleUpEvent(t))return this._eventManager.handleKeyboardDnDScaleUp(t),e.EventManager.consumeEvent(t),null;if(this.isDnDScaleDownEvent(t))return this._eventManager.handleKeyboardDnDScaleDown(t),e.EventManager.consumeEvent(t),null;if(this.isDnDForwardEvent(t))return this._eventManager.handleKeyboardDnDForward(t),e.EventManager.consumeEvent(t),null;if(this.isDnDBackwardEvent(t))return this._eventManager.handleKeyboardDnDBackward(t),e.EventManager.consumeEvent(t),null;if(this.isMoveRowAboveEvent(t))return this._eventManager.handleKeyboardMoveRowAbove(t),e.EventManager.consumeEvent(t),null;if(this.isMoveRowBelowEvent(t))return this._eventManager.handleKeyboardMoveRowBelow(t),e.EventManager.consumeEvent(t),null;if(this.isDnDFinalizeEvent(t))return this._eventManager.handleKeyboardDnDFinalize(t),e.EventManager.consumeEvent(t),null;if(a===e.KeyboardEvent.SPACE&&t.ctrlKey&&t.shiftKey&&((i=this._eventManager.getFocus())&&"task"===i.nodeType))return e.EventManager.consumeEvent(t),this._eventManager.toggleRowExpandCollapse(t,i.getLayoutObject().rowObj),null;return a===e.KeyboardEvent.ESCAPE?(this._eventManager.cancelMarquee(t),null):d.superclass.processKeyDown.call(this,t)};const g=function(t,e){this.Init(t,e)};e.Obj.createSubclass(g,e.Container),g.prototype.Init=function(t,e){g.superclass.Init.call(this,t.getCtx(),null),this._gantt=t,this._task=e},g.prototype.render=function(t){const a=this._gantt.getOptions();this._content&&this.removeChild(this._content),this._content=new e.Container(this._gantt.getCtx()),this._content.setClassName(this._gantt.GetStyleClass("taskCustom")),this.addChild(this._content);const i=this._content.getContainerElem(),n=(0,a.taskContent.renderer)(this.getRendererContext(t));n&&(Array.isArray(n)?n.forEach(function(t){e.ToolkitUtils.appendChildElem(i,t)}):e.ToolkitUtils.appendChildElem(i,n));const s=new e.ClipPath,r=this._getClipPathDim();s.addRect(r.x,r.y,r.w,r.h,r.r,r.r),this.setClipPath(s)},g.prototype.destroy=function(){this.setClipPath(null),this.removeFromParent()},g.prototype.getRendererContext=function(t){const e=this._gantt.getCtx(),a=this._task.getShape("main"),i=this._task.getContainer(),n=i.getRowNode(),s=n.getLayoutObject(),r=i.getData()._itemData,o={data:i.getData(!0),rowData:n.getData(!0),itemData:r||null,content:{height:a.getHeight(),width:a.getWidth()+a.getPhysicalStartOffset()+a.getPhysicalEndOffset()},state:{expanded:!!s.expanded,focused:!!i.isShowingKeyboardFocusEffect(),hovered:t,selected:!!i.isSelected()}};return e.fixRendererContext(o)},g.prototype._getClipPathDim=function(t){const a=t||{},i=this._task.getShape("main"),n=e.Agent.isRightToLeft(this._gantt.getCtx()),s=null!=a.w?a.w:i.getWidth();return{x:n?0-s-i.getPhysicalEndOffset():0-i.getPhysicalStartOffset(),translateX:n?0+i.getPhysicalStartOffset():0-i.getPhysicalStartOffset(),y:0,translateY:0,w:s+i.getPhysicalStartOffset()+i.getPhysicalEndOffset(),h:null!=a.h?a.h:i.getHeight(),r:null!=a.r?a.r:i.getBorderRadius()}},g.prototype.setWidth=function(t){const a=new e.ClipPath,i=this._getClipPathDim({w:t});a.addRect(i.x,i.y,i.w,i.h,i.r,i.r),this.setClipPath(a)},g.prototype.setHeight=function(t){const a=new e.ClipPath,i=this._getClipPathDim({h:t});a.addRect(i.x,i.y,i.w,i.h,i.r,i.r),this.setClipPath(a)},g.prototype.setX=function(t){const a=this._getClipPathDim({x:t});this.setTranslateX(a.translateX);const i=new e.ClipPath;i.addRect(a.x,a.y,a.w,a.h,a.r,a.r),this.setClipPath(i)},g.prototype.setY=function(t){const a=this._getClipPathDim({y:t});this.setTranslateY(a.translateY);const i=new e.ClipPath;i.addRect(a.x,a.y,a.w,a.h,a.r,a.r),this.setClipPath(i)},g.prototype.setBorderRadius=function(t){const a=new e.ClipPath,i=this._getClipPathDim({r:t});a.addRect(i.x,i.y,i.w,i.h,i.r,i.r),this.setClipPath(a)},g.prototype.setDimensions=function(t,a,i,n,s){const r=this._getClipPathDim({x:t,y:a,w:i,h:n,r:s});this.setTranslate(r.translateX,r.translateY);const o=new e.ClipPath;o.addRect(r.x,r.y,r.w,r.h,r.r,r.r),this.setClipPath(o)};var _=function(t,e){this.Init(t,e)};e.Obj.createSubclass(_,e.Obj),_.prototype.Init=function(t,e){this._gantt=t,this._container=e},_.prototype.getGantt=function(){return this._gantt},_.prototype.getContainer=function(){return this._container},_.prototype.getShape=function(t){return"main"===t?this._mainShape:"progress"===t?this._progressShape:"baseline"===t?this._baselineShape:"mainResizeHandleStart"===t?this._mainHandleStart:"mainResizeHandleEnd"===t?this._mainHandleEnd:void 0},_.prototype.getSvgStyle=function(t){return null==t?this._container.getValue("svgStyle"):this._container.getValue(t,"svgStyle")},_.prototype.getSvgClassName=function(t){return null==t?this._container.getValue("svgClassName")||this._container.getValue("className"):this._container.getValue(t,"svgClassName")||this._container.getValue(t,"className")},_.prototype._applyStyles=function(t,e){var a=this.getSvgClassName(e),i=this.getSvgStyle(e);a&&(t.applyDefaultStyleClasses(),t.setClassName(t.getClassName()+" "+a)),i&&t.setStyle(i)},_.prototype.isMilestone=function(t){var e,a,i=this._container.getValue("type");return"milestone"===i||"auto"===i&&("mainDragFeedback"===t||o.MAIN_TYPES.indexOf(t)>-1?(e=this._container.getValue("start"),a=this._container.getValue("end")):o.BASELINE_TYPES.indexOf(t)>-1&&(e=this._container.getValue("baseline","start"),a=this._container.getValue("baseline","end")),null!=e&&e==a)},_.prototype.isSummary=function(t){return"main"===t&&"summary"===this._container.getValue("type")},_.prototype.getTimeSpanDimensions=function(t,a){var n,s,r=this._gantt.getStartTime(),o=this._gantt.getEndTime(),l=this._gantt.getContentLength(),h=e.Agent.isRightToLeft(this._gantt.getCtx());return null!=t||null!=a?(n=i.TimeAxisUtils.getDatePosition(r,o,t,l),s=i.TimeAxisUtils.getDatePosition(r,o,a,l),h&&(n=l-n,s=l-s),{startPos:n,endPos:s,distance:s-n}):null},_.prototype.getFillColor=function(){if(null==this._fillColor){if(null==this._mainShape)return null;this._fillColor=this._mainShape.getFillColor()}return this._fillColor},_.prototype.getFinalHeight=function(t){var e=this._container.getLayoutObject();return t?e.overallHeightNoProgress:e.overallHeight},_.prototype.showEffect=function(t){this.showMainEffect(t)},_.prototype.removeEffect=function(t,e){this.removeMainEffect(t,e)},_.prototype.render=function(t){var e=this._container.getValue("progress","height");this.renderBaseline(e),this.renderMain(e,t),this.renderProgress(e),"summary"===this._container.getValue("type")&&this._mainShape&&this._container.addChild(this._mainShape),this._mainCustomContent&&this._container.addChild(this._mainCustomContent)},_.prototype.isMainCustomContent=function(){var t=this._gantt.getOptions();return t.taskContent&&t.taskContent.renderer},_.prototype.getRenderState=function(t){return"main"===t?this._mainShape.getRenderState():"progress"===t?this._progressShape.getRenderState():"baseline"===t?this._baselineShape.getRenderState():void 0},_.prototype.renderBaseline=function(t){var e,a,i,s,r,l,h,d,g,_,c,p,u,b=this._gantt.getOptions(),f=this._container.getValue("baseline"),y=this;f?(a=this._container.getValue("baseline","start"),i=this._container.getValue("baseline","end"),(d=this.getTimeSpanDimensions(a,"milestone"===this._container.getValue("type")&&a!=i?a:i))?(l=this.getTimeSpanDimensions(this._container.getValue("start"),a),e=this.isMilestone("baseline"),g=l?l.distance:0,c=Math.abs(d.distance),p=this._container.getValue("baseline","height"),s=e?Math.max(this._container.getValue("height"),p)+n.getMilestoneBaselineYOffset(b)-p:this._container.getValue("height")+n.getBaselineMarginTop(b),_=Math.max(0,(t-this._container.getValue("height"))/2)+s,u=f.borderRadius,null==this._baselineShape?(this._baselineShape=new o(this._gantt.getCtx(),g,_,c,p,u,this,"baseline"),e?this._container.addChildAt(this._baselineShape,0):this._container.addChild(this._baselineShape),this._baselineShape.setRenderState("add")):(this._baselineShape.setRenderState("exist"),e&&this._container.addChildAt(this._baselineShape,0)),this._baselineShape.setFinalWidth(c),this._baselineShape.setFinalHeight(p),this._baselineShape.setFinalX(g),this._baselineShape.setFinalY(_),h=function(){y._applyStyles(y._baselineShape,"baseline")},r={x:g,y:_,w:c,h:p,r:u},this._gantt.getAnimationManager().preAnimateTaskBaseline(this,this._baselineShape,r,h)):this.removeBaseline()):this.removeBaseline()},_.prototype.removeBaseline=function(){var t,e=this;this._baselineShape&&(t=function(){e._container.removeChild(e._baselineShape),e._baselineShape=null},this._gantt.getAnimationManager().preAnimateTaskBaselineRemove(this._baselineShape,t))},_.prototype.renderMain=function(t,e){var a,i,n,s,r,l,h,d=this._container.getData(),_=this._container.getValue("height"),c=this._container.getValue("start"),p=this._container.getValue("end"),u=this;d&&(n=this.getTimeSpanDimensions(c,"milestone"===this._container.getValue("type")&&c!=p?c:p))?(0,s=Math.max(0,(t-_)/2),r=Math.abs(n.distance),l=this.isSummary("main")?this._container.getFinalHeight(!0):_,h=this._container.getValue("borderRadius"),null==this._mainShape?(this._mainShape=new o(this._gantt.getCtx(),0,s,r,l,h,this,"main"),this._container.addChild(this._mainShape),this._mainShape.setRenderState("add"),this.isMainCustomContent()&&(this._mainCustomContent&&this._mainCustomContent.destroy(),this._mainCustomContent=new g(this._gantt,this),this._mainCustomContent.render(!1))):this._mainShape.setRenderState("exist"),this._mainShape.setFinalWidth(r),this._mainShape.setFinalHeight(l),this._mainShape.setFinalX(0),this._mainShape.setFinalY(s),i=function(){u._fillColor=null,u._applyStyles(u._mainShape),e&&u._mainCustomContent&&"exist"===u._mainShape.getRenderState()&&u._mainCustomContent.render(!1)},a={x:0,y:s,w:r,h:l,r:h},this._gantt.getAnimationManager().preAnimateTaskMain(this,a,i)):this.removeMain()},_.prototype.showMainEffect=function(t){var e=this._mainShape.getX(),a=this._mainShape.getY(),i=this._mainShape.getWidth(),n=this._mainShape.getHeight(),s=this._mainShape.getBorderRadius(),r=function(t){var e=t.getRowNode().getLayoutObject(),a=t.getLayoutObject(),i=e.earliestOverlayTaskObj,n=t.getParent();if(i&&"overlay"!==a._overlayBehavior){var s=i.node;if(s.getParent()){var r=n.getChildIndex(s);n.addChildAt(t,r-1)}else n.addChild(t)}else n.addChild(t)};"selected"===t?null==this._mainSelectShape&&(this._mainSelectShape=new o(this._gantt.getCtx(),e,a,i,n,s,this,"mainSelect"),this._container.addChildAt(this._mainSelectShape,0),this._mainCustomContent&&this._mainCustomContent.render(!1),r(this._container)):"hover"!==t&&"focus"!==t||null==this._mainHoverShape&&(this._mainHoverShape=new o(this._gantt.getCtx(),e,a,i,n,s,this,"mainHover"),this._container.addChildAt(this._mainHoverShape,this._container.getChildIndex(this._mainShape)),this._mainCustomContent&&this._mainCustomContent.render("hover"===t),r(this._container))},_.prototype.removeMainEffect=function(t,e){if(e=void 0===e||e,"selected"===t?(null!=this._mainSelectShape&&this._container.removeChild(this._mainSelectShape),this._mainSelectShape=null):"hover"!==t&&"focus"!==t||(null!=this._mainHoverShape&&this._container.removeChild(this._mainHoverShape),this._mainHoverShape=null),this._mainCustomContent&&this._mainCustomContent.render(!1),e){var a=this._container.getRowNode().getRenderOrderTaskObjs();if(a.length<2)return;for(var i=this._container.getParent(),n=this._container.getLayoutObject(),s=this._container,r=a.indexOf(n)-1;r>=0;r--){var o=a[r].node;if(o&&!o.isSelected()&&o.getParent()){var l=i.getChildIndex(o);return void i.addChildAt(s,l)}}i.addChildAt(s,0)}},_.prototype.getMainWidth=function(){return this._mainShape.getWidth()},_.prototype.setMainWidth=function(t){this._mainShape.setWidth(t),this._mainSelectShape&&this._mainSelectShape.setWidth(t),this._mainHoverShape&&this._mainHoverShape.setWidth(t),this._mainCustomContent&&this._mainCustomContent.setWidth(t)},_.prototype.getMainHeight=function(){return this._mainShape.getHeight()},_.prototype.setMainHeight=function(t){this._mainShape.setHeight(t),this._mainSelectShape&&this._mainSelectShape.setHeight(t),this._mainHoverShape&&this._mainHoverShape.setHeight(t),this._mainCustomContent&&this._mainCustomContent.setHeight(t)},_.prototype.getMainX=function(){return this._mainShape.getX()},_.prototype.setMainX=function(t){this._mainShape.setX(t),this._mainSelectShape&&this._mainSelectShape.setX(t),this._mainHoverShape&&this._mainHoverShape.setX(t),this._mainCustomContent&&this._mainCustomContent.setX(t)},_.prototype.getMainY=function(){return this._mainShape.getY()},_.prototype.setMainY=function(t){this._mainShape.setY(t),this._mainSelectShape&&this._mainSelectShape.setY(t),this._mainHoverShape&&this._mainHoverShape.setY(t),this._mainCustomContent&&this._mainCustomContent.setY(t)},_.prototype.getMainBorderRadius=function(){return this._mainShape.getBorderRadius()},_.prototype.setMainBorderRadius=function(t){this._mainShape.setBorderRadius(t),this._mainSelectShape&&this._mainSelectShape.setBorderRadius(t),this._mainHoverShape&&this._mainHoverShape.setBorderRadius(t),this._mainCustomContent&&this._mainCustomContent.setBorderRadius(t)},_.prototype.setMainDimensions=function(t,e,a,i,n){this._mainShape.setDimensions(t,e,a,i,n),this._mainSelectShape&&this._mainSelectShape.setDimensions(t,e,a,i,n),this._mainHoverShape&&this._mainHoverShape.setDimensions(t,e,a,i,n),this._mainCustomContent&&this._mainCustomContent.setDimensions(t,e,a,i,n)},_.prototype.removeMain=function(){var t,e=this;this._mainShape&&(t=function(){e._mainCustomContent&&(e._mainCustomContent.destroy(),e._mainCustomContent=null),e.removeMainEffect("selected",!1),e._container.removeChild(e._mainShape),e._mainShape=null,e.removeProgress()},this._gantt.getAnimationManager().preAnimateTaskMainRemove(this._mainShape,this._mainSelectShape,this._mainHoverShape,this._mainCustomContent,t))},_.prototype.getProgressValue=function(){var t=this._container.getValue("progress","value");return this.isMilestone("main")||"number"!=typeof t?null:t},_.prototype.renderProgress=function(t){this._container.getValue("progress");var e,a,i,n,s,r=this._container.getValue("height"),l=this.getProgressValue(),h=this;null!==l&&this._mainShape&&!this.isMilestone("main")?(0,i=Math.max(0,(r-t)/2),n=l*this._mainShape.getFinalWidth(),s=this._container.getValue("progress","borderRadius"),null==this._progressShape?(this._progressShape=new o(this._gantt.getCtx(),0,i,n,t,s,this,"progress"),this._container.addChild(this._progressShape),this._progressShape.setRenderState("add")):this._progressShape.setRenderState("exist"),this._progressShape.setFinalWidth(n),this._progressShape.setFinalHeight(t),this._progressShape.setFinalX(0),this._progressShape.setFinalY(i),e=function(){h._applyStyles(h._progressShape,"progress")},a={x:0,y:i,w:n,h:t,r:s},this._gantt.getAnimationManager().preAnimateTaskProgress(this,this._progressShape,a,e)):this.removeProgress()},_.prototype.removeProgress=function(){var t,e=this;this._progressShape&&(t=function(){e._container.removeChild(e._progressShape),e._progressShape=null},this._gantt.getAnimationManager().preAnimateTaskProgressRemove(this._progressShape,t))},_.prototype.renderMainResizeHandles=function(t){var a,i,s,r,l,h=e.Agent.isRightToLeft(this._gantt.getCtx())?-1:1;if(this._mainShape){a=n.getTaskResizeHandleWidth(),i=this._mainShape.getX()-h*this._mainShape.getPhysicalStartOffset(),s=this._mainShape.getY(),r=this._mainShape.getWidth()+this._mainShape.getPhysicalStartOffset()+this._mainShape.getPhysicalEndOffset(),l=this._mainShape.getHeight();var d=this,g=function(t,a){if(e.Agent.isTouchDevice()||e.Agent.isEnvironmentTest()){var i=d._gantt.getOptions().translations,n="start"===a?i.taskResizeStartHandle:i.taskResizeEndHandle;t.setAriaRole("img"),t.setAriaProperty("label",n)}};this._mainHandleStart?this._mainHandleStart.setDimensions(i,s,a,l,"0"):(this._mainHandleStart=new o(this._gantt.getCtx(),i,s,a,l,"0",this,"mainResizeHandleStart"),g(this._mainHandleStart,"start")),t.addChild(this._mainHandleStart),this._mainHandleEnd?this._mainHandleEnd.setDimensions(i+h*(r-a),s,a,l,"0"):(this._mainHandleEnd=new o(this._gantt.getCtx(),i+h*(r-a),s,a,l,"0",this,"mainResizeHandleEnd"),g(this._mainHandleEnd,"end")),t.addChild(this._mainHandleEnd)}},_.prototype.removeHandles=function(t){this._mainHandleStart&&t!==this._mainHandleStart&&(this._mainHandleStart.getParent().removeChild(this._mainHandleStart),this._mainHandleStart=null),this._mainHandleEnd&&t!==this._mainHandleEnd&&(this._mainHandleEnd.getParent().removeChild(this._mainHandleEnd),this._mainHandleEnd=null)};var c=function(t,e,a){this.Init(t,e,a)};e.Obj.createSubclass(c,e.Obj),c.prototype.Init=function(t,e,a){this._gantt=t,this._container=e,this._associatedShape=a,this._renderState="add"},c.prototype.getGantt=function(){return this._gantt},c.prototype.getAssociatedShape=function(){return this._associatedShape},c.prototype.setAssociatedShape=function(t){this._associatedShape=t},c.prototype.getLabelOutputText=function(){return this._labelOutputText},c.prototype.getEffectiveLabelPosition=function(){return this._effectiveLabelPosition},c.prototype.getRenderState=function(){return this._renderState},c.prototype._applyStyles=function(t){var e;null!=t?((e=n.getTaskLabelStyle(this._gantt.getOptions())).parseInlineStyle(t),this._labelOutputText.setStyle(t)):e=this._gantt.getCache().getFromCache("baseTaskLabelCSSStyle"),this._labelOutputText.setCSSStyle(e)},c.prototype._placeLabel=function(t){var a,i,s,r,o,l,h=this._labelOutputText.getDimensions(),d=e.Agent.isRightToLeft(this._gantt.getCtx()),g=this._gantt.getOptions(),_=n.getTaskPadding(g),c=n.getTaskLabelMargin(g),p=_+c;switch("progress"!==t&&"progressStart"!==t||this.setAssociatedShape(this._container.getTask().getShape("progress")),l="main"===this._associatedShape.getType()&&this._container.getTask().isSummary("main")?this._container.getLayoutObject().height:this._associatedShape.getFinalHeight(),o=this._associatedShape.getFinalY()+(l-h.h)/2,this.setFinalY(o),s=this._associatedShape.getFinalWidth(),a=d?this._associatedShape.getPhysicalEndOffset():this._associatedShape.getPhysicalStartOffset(),i=d?this._associatedShape.getPhysicalStartOffset():this._associatedShape.getPhysicalEndOffset(),t){case"end":d?this._labelOutputText.alignRight():this._labelOutputText.alignLeft(),r=s+i+c;break;case"progress":d?this._labelOutputText.alignLeft():this._labelOutputText.alignRight(),r=s-p;break;case"oProgress":d?this._labelOutputText.alignRight():this._labelOutputText.alignLeft(),r=this._container.getTask().getShape("progress").getFinalWidth()+p;break;case"innerStart":case"progressStart":d?this._labelOutputText.alignRight():this._labelOutputText.alignLeft(),r=-a+p;break;case"innerEnd":d?this._labelOutputText.alignLeft():this._labelOutputText.alignRight(),r=s+i-p;break;case"innerCenter":this._labelOutputText.alignCenter(),r=s/2;break;case"start":d?this._labelOutputText.alignLeft():this._labelOutputText.alignRight(),r=-(a+c)}d&&(r=-r),this.setFinalX(r),this._effectiveLabelPosition=t},c.prototype._getAvailableWidth=function(t){var a,i,s,r,o,l,h,d,g,_,c,p,u,b,f,y,m,v,T,D,S,E,C=this._container.getLayoutObject(),A=this._container.getTask(),O=n.getTaskPadding(this._gantt.getOptions()),w=n.getTaskLabelMargin(this._gantt.getOptions()),R=O+w,k=e.Agent.isRightToLeft(this._gantt.getCtx()),x=this._gantt.getContentLength(),L=!1;switch(E=x-(S=k?x:0),t){case"end":case"end_ABSOLUTE":if(v="end",i=E,r=C.nextAdjacentTaskObj,o=C.nextAdjMilestoneBaselineTaskObj,r&&r.startTime<C.endTime&&r.endTime>C.endTime){m=0;break}for(;r&&r.startTime<C.endTime&&r.endTime<C.endTime;)r=r.nextAdjacentTaskObj;if(r)if((d=r.node)&&d.getParent())i=d.getTaskShapePhysicalBounds("main").startPos;else if(null!=r.startTime||null!=r.endTime){i=A.getTimeSpanDimensions(r.startTime,r.endTime).startPos}if(o)if((g=o.node)&&g.getParent())i=k?Math.max(i,g.getTaskShapePhysicalBounds("baseline").startPos):Math.min(i,g.getTaskShapePhysicalBounds("baseline").startPos);else if(null!=o.startTime||null!=o.endTime){var P=A.getTimeSpanDimensions(o.baselineStartTime,o.baselineEndTime).startPos;i=k?Math.max(i,P):Math.min(i,P)}m=Math.abs(this._container.getTaskShapePhysicalBounds("main").endPos-i)-2*w;break;case"innerCenter":case"innerStart":case"innerEnd":(r=C.nextAdjacentTaskObj)&&("innerCenter"===t?L=r.startTime<C.startTime+(C.endTime-C.startTime)/2:"innerEnd"===t&&(L=r.startTime<C.endTime));case"innerCenter_ABSOLUTE":case"innerStart_ABSOLUTE":case"innerEnd_ABSOLUTE":if("_ABSOLUTE"===t.slice(-"_ABSOLUTE".length)&&(t=t.slice(0,-"_ABSOLUTE".length)),D="number"==typeof this._container.getValue("progress","value"),!A.isMilestone("main")){if(L){m=0,v=t;break}if(c=this._container.getTaskShapePhysicalBounds("main"),f=Math.abs(c.endPos-c.startPos),D){if(T=this._labelOutputText.getDimensions(),(p=A.getShape("progress"))?(u=p.getFinalWidth(),b=p.getFinalHeight()):(u=0,b=0),y=f-u,"innerStart"===t){if(m=u-2*R,T.w<=m&&T.h<=b){v="progressStart";break}}else if("innerEnd"===t&&(m=y-2*R,T.w<m)){v="innerEnd";break}T.h<=b&&u>y?(m=u-2*R,v="progress"):(m=y-2*R,v="oProgress");break}m=f-2*R,v=t;break}m=0,v=t;break;case"start":case"start_ABSOLUTE":if(v="start",a=S,s=C.previousAdjacentTaskObj,l=C.previousAdjacentMilestoneBaselineTaskObj,s&&s.endTime>C.startTime&&s.startTime<C.startTime){m=0;break}if(s)if((h=s.node)&&h.getParent())a=h.getTaskShapePhysicalBounds("main",!0).endPos;else if(null!=s.startTime||null!=s.endTime){a=A.getTimeSpanDimensions(s.startTime,s.endTime).endPos}if(l)if((_=l.node)&&_.getParent())a=k?Math.min(a,_.getTaskShapePhysicalBounds("baseline").endPos):Math.max(a,_.getTaskShapePhysicalBounds("baseline").endPos);else if(null!=l.startTime||null!=l.endTime){var M=A.getTimeSpanDimensions(l.baselineStartTime,l.baselineEndTime).endPos;a=k?Math.max(a,M):Math.min(a,M)}m=Math.abs(a-this._container.getTaskShapePhysicalBounds("main").startPos)-2*w;break;default:return null}return[v,m]},c.prototype._preprocessLabelPosition=function(t){var e=this._container.getTask().isMilestone("main");if("string"==typeof t){if(e)switch(t){case"innerCenter":case"innerEnd":t="end";break;case"innerStart":t="start"}return[t+"_ABSOLUTE"]}return Array.isArray(t)?e?t.map(function(t){switch(t){case"innerCenter":case"innerEnd":return"end";case"innerStart":return"start";default:return t}}):t:[]},c.prototype._evaluatePosition=function(t){for(var a,i,n,s={},r=this._labelOutputText.getDimensions(),o=r.w,l=(r.h,t=this._preprocessLabelPosition(t),0),h=0;h<t.length;h++){var d=t[h];if("max"!==d){if(s[d]?g=s[d]:(g=this._getAvailableWidth(d),s[d]=g),g){if(a=g[0],o<=(i=g[1]))break;i>l&&(l=i,n=d)}}else if(null!=n){var g=s[n];a=g[0],i=g[1];break}}return null!=a&&(o>i&&e.TextUtils.fitText(this._labelOutputText,i,1/0,this._container,1),this._placeLabel(a),!0)},c.prototype.render=function(){var t,a,i=this._container.getValue("label"),n=this._container.getValue("labelPosition"),s=this._container.getValue("labelStyle"),r=this,o=this._gantt.GetStyleClass("taskLabel");this._renderState="exist",null!=i&&i.length>0&&"none"!==n&&this._associatedShape?(null==this._labelOutputText&&(this._labelOutputText=new e.OutputText(this._gantt.getCtx(),i,0,0),this._gantt.getEventManager().IsDragSupported("tasks")&&(o+=" "+this._gantt.GetStyleClass("draggable")),this._labelOutputText.setClassName(o),this._renderState="add"),null==this._labelOutputText.getParent()&&this._container.addChild(this._labelOutputText),this._labelOutputText.setTextString(i),this._applyStyles(s),this._evaluatePosition(n)?(a=function(){var t,a;switch(r._effectiveLabelPosition){case"innerCenter":case"innerEnd":case"innerStart":case"progressStart":case"progress":case"oProgress":a=r._associatedShape.getFillColor(),null!=(t=e.ColorUtils.getContrastingTextColor(a?a.computedFill:null))&&r._labelOutputText.setFill(new e.SolidFill(t))}},t={x:this.getFinalX(),y:this.getFinalY()},this._gantt.getAnimationManager().preAnimateTaskLabel(this._container,t,a)):this.remove()):this.remove()},c.prototype.remove=function(){var t,e=this;this._labelOutputText&&(t=function(){e._container.removeChild(e._labelOutputText),e._labelOutputText=null,e._effectiveLabelPosition=null},this._gantt.getAnimationManager().preAnimateTaskLabelRemove(this._labelOutputText,t))},c.prototype.getFinalX=function(){return this._finalX},c.prototype.setFinalX=function(t){this._finalX=t},c.prototype.getFinalY=function(){return this._finalY},c.prototype.setFinalY=function(t){this._finalY=t};var p=function(t){this.Init(t)};e.Obj.createSubclass(p,e.Container),p.prototype.nodeType="task",p.prototype.Init=function(t){p.superclass.Init.call(this,t.getCtx(),null),this._gantt=t,this._task=new _(t,this),this._taskLabel=new c(t,this),this._gantt.getEventManager().associate(this,this)},p.prototype.getId=function(){return this._taskObj.id},p.prototype.setLayoutObject=function(t){this._taskObj=t},p.prototype.getLayoutObject=function(){return this._taskObj},p.prototype.getData=function(t){return t?a.TimeComponent.sanitizeData(this._taskObj.data,"task"):this._taskObj.data},p.prototype.getValue=function(t,e){var a,i=this._gantt.getOptions().taskDefaults;switch(t){case"start":a=this._taskObj.startTime;break;case"end":a=this._taskObj.endTime;break;case"height":a=this._taskObj.height;break;case"baseline":if("height"===e){a=this._taskObj.baselineHeight;break}if((a=this._taskObj.data.baseline)&&null!=e)switch(e){case"start":a=this._taskObj.baselineStartTime;break;case"end":a=this._taskObj.baselineEndTime;break;default:a=null!=a[e]?a[e]:i.baseline[e]}break;case"progress":if("height"===e){a=this._taskObj.progressHeight;break}(a=this._taskObj.data.progress)&&null!=e&&(a=null!=a[e]?a[e]:i.progress[e]);break;default:a=null!=this._taskObj.data[t]?this._taskObj.data[t]:i[t]}return"shortDesc"===t&&"function"==typeof a?a(p.getShortDescContext(this)):a},p.prototype.getSandboxValue=function(t,e){var a=this.getSandboxData(),i=this._gantt.getOptions().taskDefaults,n=a[t],s=i[t];return n&&null!=e&&(n=n[e]),s&&null!=e&&(s=s[e]),null!=n?n:s},p.prototype.getSandboxData=function(){if(!this._sandboxData){this._sandboxData=e.JsonUtils.clone(a.TimeComponent.sanitizeData(this._taskObj.data,"task")),this._sandboxData._rowNode=this.getRowNode(),this._sandboxData.start=this._taskObj.startTime,this._sandboxData.end=this._taskObj.endTime,this._sandboxData.height=this._taskObj.height;var t=this._sandboxData.baseline;t&&(t.start=this._taskObj.baselineStartTime,t.end=this._taskObj.baselineEndTime,t.height=this._taskObj.baselineHeight);var i=this._sandboxData.progress;i&&(i.height=this._taskObj.progressHeight)}return this._sandboxData},p.prototype.getRowNode=function(){return this._taskObj.rowObj.node},p.prototype.getGantt=function(){return this._gantt},p.prototype.getRenderState=function(){return this._taskObj.renderState},p.prototype.getPreviousAdjacentTaskObj=function(){return this._taskObj.previousAdjacentTaskObj},p.prototype.getNextAdjacentTaskObj=function(){return this._taskObj.nextAdjacentTaskObj},p.prototype.getPrevAdjMilestoneBaselineTaskObj=function(){return this._taskObj.prevAdjMilestoneBaselineTaskObj},p.prototype.getNextAdjMilestoneBaselineTaskObj=function(){return this._taskObj.nextAdjMilestoneBaselineTaskObj},p.prototype.getTaskShapePhysicalBounds=function(t,a){var i=e.Agent.isRightToLeft(this._gantt.getCtx()),s=this._gantt.getOptions(),r=i?-1:1,o=this._task.getShape(t),l=o.getFinalX()+this.getFinalX(),h=o.getFinalWidth()+o.getPhysicalEndOffset(),d=l-r*o.getPhysicalStartOffset(),g=l+r*h;if(a){var _=this._taskLabel.getLabelOutputText();if(_&&null!=_.getParent()){var c=this._taskLabel.getEffectiveLabelPosition();"end"===c?g+=r*(n.getTaskLabelMargin(s)+_.getDimensions().w):"start"===c&&(d-=r*(n.getTaskLabelMargin(s)+_.getDimensions().w))}}return{startPos:d,endPos:g}},p.prototype.scrollIntoView=function(t,a){var i,s,r,o,l=e.Agent.isRightToLeft(this._gantt.getCtx()),d=this._gantt.getDatabody(),g=this._gantt.getOptions();this._gantt.getDataLayoutManager().ensureInDOM(this.getLayoutObject(),"task");var _,c,p=this._gantt.getEventManager().getKeyboardDnDMode();p===h.KEYBOARD_MOVE&&this._mainDragFeedbacks&&this._mainDragFeedbacks.length>0?(_=this._mainDragFeedbacks[0],c=this._gantt.getDnDArtifactsContainer()):(p===h.KEYBOARD_RESIZE_START||p===h.KEYBOARD_RESIZE_END)&&this._mainResizeHandleDragFeedbacks&&this._mainResizeHandleDragFeedbacks.length>0?(_=this._mainResizeHandleDragFeedbacks[0],c=this._gantt.getDnDArtifactsContainer()):(_=(_=this.getTask().getShape("main"))||this.getTask().getShape("baseline"),c=this),r=_.getWidth()+_.getPhysicalStartOffset()+_.getPhysicalEndOffset(),o=_.getHeight(),i=l?_.getX()-r+_.getPhysicalStartOffset():_.getX()-_.getPhysicalStartOffset(),s=_.getY();var u=d.stageToLocal(c.localToStage({x:i,y:s})),b=new e.Rectangle(u.x,u.y,r,o);this._gantt.scrollIntoView(b,t,a,n.getRowPaddingTop(g))},p.prototype.getDraggedObject=function(){return this._draggedObj},p.prototype.setDraggedObject=function(t){this._draggedObj=t},p.prototype.dragStartSetup=function(){this.hideDnDArtifacts(this._draggedObj)},p.prototype.dragEndCleanup=function(){this.hideDnDArtifacts(),this._sandboxData=null},p.prototype.showDragFeedback=function(t,a,s,r,o){var l=this._gantt.getEventManager();if(this._draggedObj&&l){var h,d,g,_,c,p,u,b,f=l.getDnDTaskSubType(this._draggedObj),y=e.Agent.isRightToLeft(this._gantt.getCtx()),m=y?1:-1,v=this._gantt.getDnDArtifactsContainer(),T=this._gantt.getStartTime(),D=this._gantt.getEndTime(),S=this._gantt.getContentLength();switch(f){case"tasks":h=o?{deltaX:0,deltaY:0}:this._gantt.autoPanOnEdgeDrag(a,n.getAutoPanEdgeThreshold(),!1,!1),d=r.x+a.x+h.deltaX,g=r.y+a.y+h.deltaY,this._renderTaskMoveDragFeedback(d,g,v);var E=this.getTask().getShape("main");_=y?S-d:d,p=y?S-(d-E.getFinalWidth()):d+E.getFinalWidth(),c=i.TimeAxisUtils.getPositionDate(T,D,_,S),u=i.TimeAxisUtils.getPositionDate(T,D,p,S),s&&(s&&"row"===s.nodeType?b=s:s&&"task"===s.nodeType&&(b=s.getRowNode())),this._showDragFeedbackTooltip(t,c,u,this._mainDragFeedbacks[0],"center",b);break;case"taskResizeHandles":h=o?{deltaX:0,deltaY:0}:this._gantt.autoPanOnEdgeDrag(a,n.getAutoPanEdgeThreshold(),!1,!0),d=a.x+h.deltaX,this._renderTaskResizeDragFeedback(d,v);var C="mainResizeHandleEnd"===this._draggedObj.getType();C?(c=this.getValue("start"),p=this._mainResizeHandleDragFeedbacks[0].getX()-m*this._mainResizeHandleDragFeedbacks[0].getWidth(),p=y?S-p:p,u=i.TimeAxisUtils.getPositionDate(T,D,p,S)):(_=this._mainResizeHandleDragFeedbacks[0].getX(),_=y?S-_:_,c=i.TimeAxisUtils.getPositionDate(T,D,_,S),u=this.getValue("end")),this._showDragFeedbackTooltip(t,c,u,this._mainResizeHandleDragFeedbacks[0],C?"end":"start")}}},p.prototype._showDragFeedbackTooltip=function(t,a,i,n,s,r){var o=e.Agent.isRightToLeft(this._gantt.getCtx()),l=this.getSandboxData();r&&(l._rowNode=r),l.start=a,l.end=i;var h,d=n.getDimensions(this.getCtx().getStage());switch(s){case"start":h=new e.Point(d.x+o*d.w,d.y);break;case"end":h=new e.Point(d.x+!o*d.w,d.y);break;default:h=d.getCenter()}var g=this.getCtx().stageToPageCoords(h.x,h.y);this._gantt.getEventManager().ProcessObjectTooltip(t,g.x,g.y,this,n.getElem())},p.prototype._renderTaskMoveDragFeedback=function(t,a,n){var s=e.Agent.isRightToLeft(this._gantt.getCtx()),r=this._gantt.getStartTime(),l=this._gantt.getEndTime(),h=this._gantt.getContentLength(),d=this.getTask().getShape("main");if(this._mainDragFeedbacks)for(var g=0;g<this._mainDragFeedbacks.length;g++){var _=this._mainDragFeedbacks[g],c=this._mainDragFeedbackOffsets[g],p=t+c.x;_.setX(p),_.setY(a+c.y),this._mainDragFeedbackStartTimes[g]=i.TimeAxisUtils.getPositionDate(r,l,s?h-p:p,h)}else{var u=new o(this._gantt.getCtx(),t,a,d.getFinalWidth(),d.getFinalHeight(),d.getBorderRadius(),this.getTask(),"mainDragFeedback");if(this._mainDragFeedbacks=[u],this._mainDragFeedbackOffsets=[new e.Point(0,0)],this._mainDragFeedbackStartTimes=[this.getValue("start")],n.addChild(u),this._gantt.isSelectionSupported()&&this.isSelected()&&this._gantt.getSelectionHandler().getSelectedCount()>1){var b=this._gantt.getSelectionHandler().getSelection();for(g=0;g<b.length;g++){var f=b[g];if(f&&"task"===f.nodeType&&f!==this){var y=f.getTask().getShape("main"),m=y.getX()+f.getTranslateX()-(d.getX()+this.getTranslateX()),v=y.getY()+f.getTranslateY()-(d.getY()+this.getTranslateY()),T=t+m,D=a+v;_=new o(this._gantt.getCtx(),T,D,y.getFinalWidth(),y.getFinalHeight(),y.getBorderRadius(),f.getTask(),"mainDragFeedback"),this._mainDragFeedbacks.push(_),this._mainDragFeedbackOffsets.push(new e.Point(m,v)),this._mainDragFeedbackStartTimes.push(f.getValue("start")),n.addChild(_)}}}}},p.prototype._renderTaskResizeDragFeedback=function(t,a){var i,n,s=e.Agent.isRightToLeft(this._gantt.getCtx()),r=s?1:-1,l=this.getTask().getShape("main"),h="mainResizeHandleEnd"===this._draggedObj.getType();h?(i=l.getFinalX()+this.getTranslateX(),n=s?Math.min(t,i):Math.max(t,i)):(i=l.getFinalX()-r*l.getFinalWidth()+this.getTranslateX(),n=s?Math.max(t,i):Math.min(t,i));var d=Math.abs(n-i),g=d-l.getFinalWidth();if(this._mainResizeHandleDragFeedbacks)for(var _=0;_<this._mainResizeHandleDragFeedbacks.length;_++){var c=this._mainResizeHandleDragFeedbacks[_],p=this._mainResizeHandleDragFeedbackSources[_],u=p.getTask().getShape("main"),b=Math.max(0,u.getFinalWidth()+g);if(!h){var f=u.getFinalX()-r*u.getFinalWidth()+p.getTranslateX();c.setX(f+r*b)}c.setWidth(b)}else{var y=new o(this._gantt.getCtx(),h?i:n,l.getFinalY()+this.getTranslateY(),d,l.getFinalHeight(),l.getBorderRadius(),this.getTask(),"mainResizeHandleDragFeedback");if(this._mainResizeHandleDragFeedbacks=[y],this._mainResizeHandleDragFeedbackSources=[this],a.addChild(y),this._gantt.isSelectionSupported()&&this.isSelected()&&this._gantt.getSelectionHandler().getSelectedCount()>1){var m=this._gantt.getSelectionHandler().getSelection();for(_=0;_<m.length;_++){var v=m[_];if(v&&"task"===v.nodeType&&v!==this){var T,D=v.getTask().getShape("main"),S=D.getFinalWidth()+g;T=h?D.getFinalX()+v.getTranslateX():D.getFinalX()-r*D.getFinalWidth()+v.getTranslateX()+r*S,c=new o(this._gantt.getCtx(),T,D.getFinalY()+v.getTranslateY(),S,D.getFinalHeight(),D.getBorderRadius(),v.getTask(),"mainResizeHandleDragFeedback"),this._mainResizeHandleDragFeedbacks.push(c),this._mainResizeHandleDragFeedbackSources.push(v),a.addChild(c)}}}}},p.prototype._updateDragFeedbacks=function(){var t,a,n=e.Agent.isRightToLeft(this._gantt.getCtx()),s=this._gantt.getStartTime(),r=this._gantt.getEndTime(),o=this._gantt.getContentLength();if(this._mainDragFeedbacks){var l=i.TimeAxisUtils.getDatePosition(s,r,this._mainDragFeedbackStartTimes[0],o);l=n?o-l:l;for(var h=0;h<this._mainDragFeedbacks.length;h++)t=this._mainDragFeedbacks[h],a=i.TimeAxisUtils.getDatePosition(s,r,this._mainDragFeedbackStartTimes[h],o),a=n?o-a:a,this._mainDragFeedbackOffsets[h].x=a-l,t.setX(a),t.setWidth(this.getTask().getShape("main").getFinalWidth()),0===h&&this._gantt.getEventManager()._keyboardDnDFeedbackLocalPos&&(this._gantt.getEventManager()._keyboardDnDFeedbackLocalPos.x=a)}if(this._mainResizeHandleDragFeedbacks)for(h=0;h<this._mainResizeHandleDragFeedbacks;h++){t=this._mainResizeHandleDragFeedbacks[h];var d=i.TimeAxisUtils.getDatePosition(s,r,this._mainResizeHandleDragFeedbackSources[h].getValue("start"),o),g=i.TimeAxisUtils.getDatePosition(s,r,this._mainResizeHandleDragFeedbackSources[h].getValue("end"),o);a=n?o-d:d,t.setX(a),t.setWidth(Math.abs(g-d)),0===h&&this._gantt.getEventManager()._keyboardDnDFeedbackLocalPos&&(this._gantt.getEventManager()._keyboardDnDFeedbackLocalPos.x=a)}},p.prototype.removeDragFeedbacks=function(){if(this._mainDragFeedbacks){for(var t=0;t<this._mainDragFeedbacks.length;t++)this._mainDragFeedbacks[t].getParent().removeChild(this._mainDragFeedbacks[t]);this._mainDragFeedbacks=null,this._mainDragFeedbackOffsets=null,this._mainDragFeedbackStartTimes=null}if(this._mainResizeHandleDragFeedbacks){for(t=0;t<this._mainResizeHandleDragFeedbacks.length;t++)this._mainResizeHandleDragFeedbacks[t].getParent().removeChild(this._mainResizeHandleDragFeedbacks[t]);this._mainResizeHandleDragFeedbacks=null,this._mainResizeHandleDragFeedbackSources=null}this._gantt.getEventManager().hideTooltip()},p.prototype.hideDnDArtifacts=function(t){this.removeDragFeedbacks()},p.prototype.getTask=function(){return this._task},p.prototype.getTaskLabel=function(){return this._taskLabel},p.prototype.render=function(t,a){var i;a=!1!==a;this.isSelectable()&&this.setCursor(e.SelectionEffectUtils.getSelectingCursor()),this.getParent()!=t&&t.addChild(this),this._task.render(a),this._getAriaTarget().setAriaRole("img"),this.refreshAriaLabel(),this._updateDragFeedbacks(),i={x:this.getFinalX(),y:this.getFinalY()},this._gantt.getAnimationManager().preAnimateTaskNode(this,i)},p.prototype.remove=function(){var t,e=this;t=function(){e.getRowNode().removeChild(e)},this._gantt.getAnimationManager().preAnimateTaskNodeRemove(this,t)},p.prototype.getPredecessorDependencies=function(){var t=this._gantt.getDataLayoutManager();return this._taskObj.predecessorDepObjs.map(function(e){return e.node||t.ensureInDOM(e,"dependency"),e.node})},p.prototype.getSuccessorDependencies=function(){var t=this._gantt.getDataLayoutManager();return this._taskObj.successorDepObjs.map(function(e){return e.node||t.ensureInDOM(e,"dependency"),e.node})},p.prototype.getFinalX=function(){return this._taskObj.x},p.prototype.getFinalY=function(){return this._taskObj.y},p.prototype.getFinalHeight=function(t){return this._task.getFinalHeight(t)},p.prototype.getDuration=function(t,a){var i=this._gantt.getOptions().translations,n=a-t,s=this._gantt.getMinorAxis().getScale();return"hours"===s||"minutes"===s||"seconds"===s?(n=Math.round(n/36e5*100)/100,e.ResourceUtils.format(i.accessibleDurationHours,[n])):(n=Math.round(n/864e5*100)/100,e.ResourceUtils.format(i.accessibleDurationDays,[n]))},p.prototype.getAriaLabel=function(){var t=[],a=this._gantt.getOptions().translations,n=this.getLayoutObject().rowObj,s="";if(this._gantt.isRowsHierarchical()&&(s=a.labelLevel+" "+n.depth+", "),null!=this._gantt.getRenderState()){var r=n.data.label;return null==r&&(r=a.labelRow+" "+n.index+1),r=s+r,null!=n.expanded&&t.push(a[n.expanded?"stateExpanded":"stateCollapsed"]),e.Displayable.generateAriaLabel(r,t)}this.isSelectable()&&t.push(a[this.isSelected()?"stateSelected":"stateUnselected"]),null!=(n=this.getLayoutObject().rowObj).expanded&&t.push(a.labelRow+" "+a[n.expanded?"stateExpanded":"stateCollapsed"]);var o=l.getDatatip(this,!1,!0);this._task.isMilestone("main")?o=a.accessibleTaskTypeMilestone+", "+o:this._task.isSummary("main")&&(o=a.accessibleTaskTypeSummary+", "+o),o=s+o;var h=this._taskObj.predecessorDepObjs,d=this._taskObj.successorDepObjs;if(h.length>0||d.length>0){var g="";if(h.length>0&&(g=e.ResourceUtils.format(a.accessiblePredecessorInfo,[h.length]),i.TimeAxisUtils.supportsTouch()||e.Agent.isEnvironmentTest()))for(var _=0;_<h.length;_++)g=g+", "+h[_].ariaLabel;if(d.length>0&&(g.length>0&&(g+=", "),g+=e.ResourceUtils.format(a.accessibleSuccessorInfo,[d.length]),i.TimeAxisUtils.supportsTouch()||e.Agent.isEnvironmentTest()))for(_=0;_<d.length;_++)g=g+", "+d[_].ariaLabel;g.length>0&&(o=o+", "+g)}var c=e.Displayable.generateAriaLabel(o,t),p=this.getAriaProperty("label");return null!=p&&p.indexOf(c)>-1?null:c},p.prototype._getAriaTarget=function(){var t=this.getTask().getShape("main");return e.Agent.isTouchDevice()&&this._gantt.isTaskResizeEnabled()&&t?t:this},p.prototype.refreshAriaLabel=function(){this._updateAriaLabel()},p.prototype._updateAriaLabel=function(){e.Agent.deferAriaCreation()||this._getAriaTarget().setAriaProperty("label",this.getAriaLabel())},p.prototype.getDataContext=function(){var t=this.getData()._itemData;return{data:this.getData(!0),rowData:this.getRowNode().getData(!0),itemData:t||null,color:l.getDatatipColor(this),component:this._gantt.getOptions()._widgetConstructor}},p.getShortDescContext=function(t){var e=t.getData()._itemData;return{data:t.getData(!0),rowData:t.getRowNode().getData(!0),itemData:e||null}},p.prototype.getSandboxDataContext=function(){var t=this.getSandboxData();if(t.start=new Date(t.start).toISOString(),t.end=new Date(t.end).toISOString(),t.baseline){var e=t.baseline.start,a=t.baseline.end;t.baseline.start=null!=e?new Date(e).toISOString():null,t.baseline.end=null!=a?new Date(a).toISOString():null}var i=this._taskObj.data._itemData;return{data:t,rowData:t._rowNode.getData(!0),itemData:i||null,color:l.getDatatipColor(this),component:this._gantt.getOptions()._widgetConstructor}},p.prototype._setSelected=function(t,e){this._selected=t,this._selected?this._task.showEffect("selected"):this._task.removeEffect("selected",e),this.refreshAriaLabel(),this._gantt.setCurrentRow(this.getRowNode().getId())},p.prototype.clearSelectionState=function(){this._setSelected(!1,!1)},p.prototype.getDatatip=function(){return l.getDatatip(this,!0)},p.prototype.getDatatipColor=function(){return l.getDatatipColor(this)},p.prototype.isSelectable=function(){return"none"!=this._gantt.getOptions().selectionMode},p.prototype.isSelected=function(){return this._selected},p.prototype.setSelected=function(t){this._setSelected(t,!0)},p.prototype.showHoverEffect=function(){this._task.showEffect("hover")},p.prototype.hideHoverEffect=function(){this._task.removeEffect("hover")},p.prototype.getNextNavigable=function(t){var a=null,i=this._gantt.getEventManager().getKeyboardHandler();if(t.type===e.MouseEvent.CLICK||i.isMultiSelectEvent(t))a=this;else if((t.keyCode===e.KeyboardEvent.OPEN_ANGLED_BRACKET||e.KeyboardEvent.CLOSE_ANGLED_BRACKET)&&t.altKey){if((i=this._gantt.getEventManager().getKeyboardHandler())&&i.getFirstNavigableDependencyLine){if(e.Agent.isRightToLeft(this.getGantt().getCtx()))var n=t.keyCode===e.KeyboardEvent.CLOSE_ANGLED_BRACKET?"predecessor":"successor";else n=t.keyCode===e.KeyboardEvent.OPEN_ANGLED_BRACKET?"predecessor":"successor";var s=this._gantt.getNavigableDependencyLinesForTask(this,n);a=i.getFirstNavigableDependencyLine(this,t,s)}a?a.setKeyboardFocusTask(this):a=this}else i.isNavigationEvent(t)&&null==this._gantt.getEventManager().getKeyboardDnDMode()&&(a=d.getNextNavigable(this._gantt,this,t));return a},p.prototype.getTargetElem=function(){return this._task.getShape("main").getElem()},p.prototype.getKeyboardBoundingBox=function(t){return this.getDimensions(t)},p.prototype.showKeyboardFocusEffect=function(){this._isShowingKeyboardFocusEffect=!0,this._task.showEffect("focus");var t=this._gantt.getViewportStartTime(),e=this._gantt.getViewportEndTime();this.scrollIntoView(),this._gantt.getViewportStartTime()===t&&this._gantt.getViewportEndTime()===e||this._gantt.dispatchEvent(this._gantt.createViewportChangeEvent())},p.prototype.hideKeyboardFocusEffect=function(){this.isShowingKeyboardFocusEffect()&&(this._isShowingKeyboardFocusEffect=!1,this.hideHoverEffect())},p.prototype.isShowingKeyboardFocusEffect=function(){return this._isShowingKeyboardFocusEffect},p.prototype.isDragAvailable=function(t){return!0},p.prototype.getDragTransferable=function(t,e){return[this.getId()]},p.prototype.getDragFeedback=function(t,e){return null};var u=function(t){this.Init(t)};e.Obj.createSubclass(u,e.Container),u.prototype.nodeType="row",u.prototype.Init=function(t){u.superclass.Init.call(this,t.getCtx(),null),this._gantt=t,this._gantt.getEventManager().associate(this,this)},u.prototype.getId=function(){return this._rowObj.id},u.prototype.getGantt=function(){return this._gantt},u.prototype.setLayoutObject=function(t){this._rowObj=t},u.prototype.getLayoutObject=function(){return this._rowObj},u.prototype.getData=function(t){return t?a.TimeComponent.sanitizeData(this._rowObj.data,"row"):this._rowObj.data},u.prototype.getIndex=function(){return this._rowObj.index},u.prototype.getFinalY=function(){return this._rowObj.y},u.prototype.getLabel=function(){return this._rowObj.data.label},u.prototype.setRowLabelContent=function(t){this._rowLabelContent=t},u.prototype.getRowLabelContent=function(){return this._rowLabelContent},u.prototype.getRowAxisHorizontalLine=function(){return this._rowAxisHorizontalLine},u.prototype.getRenderState=function(){return this._rowObj.renderState},u.prototype.getTaskObjs=function(){return this._rowObj.taskObjs},u.prototype.getRenderOrderTaskObjs=function(t){var e=t?t.sort(function(t,e){return t.startTime-e.startTime}):this._rowObj.taskObjs;if(this._rowObj.earliestOverlayTaskObj){var a=[],i=[];return e.forEach(function(t){"overlay"===t.overlapBehavior?a.push(t):i.push(t)}),i.concat(a)}return e},u.prototype._renderTasks=function(t){t&&t.tasksDelete.forEach(function(t){t.node.remove()});var e,a=this.getRenderOrderTaskObjs(t?[...t.tasksAdd,...t.tasksUpdate]:null),i=t?t.tasksAdd:new Set,n=!t||t.updateRender;for(let t=0;t<a.length;t++){var s=(d=a[t]).node;s||((s=new p(this._gantt)).setLayoutObject(d),d.node=s);var r=i.has(d);if(n||r){var o=s.getTask(),l=o.getTimeSpanDimensions(s.getValue("start"),s.getValue("end"));l||(l=o.getTimeSpanDimensions(s.getValue("baseline","start"),s.getValue("baseline","end"))),d.x=l.startPos,s.render(this,!0)}!r&&e&&i.has(e)&&this.addChild(s),e=d}var h=function(t){var e=t.node,a=e.getTaskLabel(),i=e.getTask();a.setAssociatedShape(i.getShape("main")),a.render(),this._gantt.isTaskResizeEnabled()?i.renderMainResizeHandles(e):i.removeHandles()}.bind(this);for(let t=0;t<a.length;t++){var d=a[t];r=i.has(d);if(n||r)r&&!n&&d.previousAdjacentTaskObj&&!i.has(d.previousAdjacentTaskObj)&&d.previousAdjacentTaskObj.node&&d.previousAdjacentTaskObj.node.getParent()&&h(d.previousAdjacentTaskObj),h(d);else if(i.has(d.previousAdjacentTaskObj))for(var g=d;g&&!i.has(g);){var _=g.node.getTaskLabel(),c=_.getEffectiveLabelPosition();h(g),g=c===_.getEffectiveLabelPosition()?null:g.nextAdjacentTaskObj}}},u.prototype.render=function(t,e){this._renderTasks(e),this._renderBackground(this._gantt,this._gantt.getDatabodyBackground()),this._renderHorizontalGridline(this._gantt,this),t&&(this._gantt.isRowAxisEnabled()&&this._gantt.getRowAxis()&&this._finalizeRowLabelRender(this._gantt),t.addChild(this))},u.prototype._finalizeRowLabelRender=function(t){var a=e.Agent.isRightToLeft(t.getCtx()),i=this.getRowLabelContent(),s=this.getFinalY(),r=this._rowObj.height,o=n.getRowLabelPadding(t.getOptions()),l=t.getRowAxis();if("g"===i.getDisplayableType())var h=a?l.getWidth()-o:o;else{var d=i.getDisplayable();d.isTruncated()&&d.setTextString(d.getUntruncatedTextString()),e.TextUtils.fitText(d,l.getWidth()-2*o,r,l,1),a?(d.alignRight(),h=l.getWidth()-o):h=o}var g=(s+(s+r)-i.getHeight())/2;i.setRow(this);var _={x:h,y:g},c=this.getLabelState();c&&(i.setY(c.y),i.setX(c.x)),this.recordLabelState(_),this._gantt.getAnimationManager().preAnimateRowLabel(this,i,_)},u.prototype._renderBackground=function(t,a){var i,n=this._rowObj.y,s=t.getContentLength(),r=this._rowObj.height,o="exist";this._background||(this._background=new e.Rect(t.getCtx(),0,n,s,r),this._background.setPixelHinting(!0),this._background.setClassName(t.GetStyleClass("row")),o="add",this._gantt.getEventManager().associate(this._background,this)),a.addChild(this._background),i={y:n,w:s,h:r},this._gantt.getAnimationManager().preAnimateRowBackground(this._background,i,o)},u.prototype.getBackground=function(){return this._background},u.prototype._renderHorizontalGridline=function(t,a){var i,s,r,o,l="exist",h=t.GetStyleClass("hgridline"),d=n.getHorizontalGridlineWidth(t.getOptions())%2*.5,g=this._gantt.getRowAxis(),_=this._gantt.isRowAxisEnabled()&&g;if(t.isHorizontalGridlinesVisible()){if(r=s=this._rowObj.y+this._rowObj.height+d,0,i=t.getContentLength(),this._horizontalLine||(this._horizontalLine=new e.Line(t.getCtx(),0,s,i,r),this._horizontalLine.setPixelHinting(!0),this._horizontalLine.setClassName(h,!0),a.addChild(this._horizontalLine),l="add"),o={x1:0,x2:i,y1:s,y2:r},this._gantt.getAnimationManager().preAnimateHorizontalGridline(this._horizontalLine,o,l),_){var c={x1:0,x2:g.getWidth(),y1:s,y2:r};this._rowAxisHorizontalLine||(this._rowAxisHorizontalLine=new e.Line(this._gantt.getCtx(),this._horizontalLine.getX1(),this._horizontalLine.getY1(),c.x2,this._horizontalLine.getY2()),this._rowAxisHorizontalLine.setPixelHinting(!0),this._rowAxisHorizontalLine.setClassName(h,!0)),g.addChild(this._rowAxisHorizontalLine),this._gantt.getAnimationManager().preAnimateHorizontalGridline(this._rowAxisHorizontalLine,c,l)}}else this._horizontalLine&&a.removeChild(this._horizontalLine),this._horizontalLine=null,this._rowAxisHorizontalLine&&g.removeChild(this._rowAxisHorizontalLine),this._rowAxisHorizontalLine=null},u.prototype.recordLabelState=function(t){this._rowLabelState=t},u.prototype.getLabelState=function(){return this._rowLabelState},u.prototype.remove=function(){var t,e=this;t=function(){if(e._background){var t=e._background.getParent();t&&t.removeChild(e._background)}var a=e.getParent();a&&a.removeChild(e)},this._gantt.getAnimationManager().preAnimateRowNodeRemove(this,t),this._removeRowLabel()},u.prototype._removeRowLabel=function(){var t,e,a=this.getRowLabelContent(),i=this._gantt.getRowAxis(),n=this;a&&i&&(t=a.getDisplayable())&&(null==t.getParent()&&(i.addChild(t),this._gantt.isHorizontalGridlinesVisible()&&i.addChild(this._rowAxisHorizontalLine)),e=function(){i.removeChild(t),i.removeChild(n._rowAxisHorizontalLine)},this._gantt.getAnimationManager().preAnimateRowLabelRemove(a,this._rowAxisHorizontalLine,e))},u.prototype.getDataContext=function(){return{rowData:this.getData(!0),component:this._gantt.getOptions()._widgetConstructor}};var b=function(t){this.Init(t)};e.Obj.createSubclass(b,e.Obj),b.VPC_TRANSLATE="vpc_translate",b.VPC_SCALE="vpc_scale",b.VPC_ANIMATE="vpc_animate",b.VPC_REFRESH="vpc_refresh",b.prototype.Init=function(t){this._gantt=t,this._ctx=t.getCtx(),this._rowObjs=[],this._dependencyObjs=[],this._contentHeight=0},b.prototype.clear=function(){this._rowObjs=[],this._dependencyObjs=[],this._contentHeight=0,this._prevViewport=null},b.prototype.getRowObjs=function(){return this._rowObjs},b.prototype.getDependencyObjs=function(){return this._dependencyObjs},b.prototype.getContentHeight=function(){return this._contentHeight},b.prototype._getTime=function(t){if(null==t||""===t)return null;var e=new Date(t).getTime();return isNaN(e)?null:e},b.prototype._isIntervalOverlap=function(t,e,a,i,n){return(n=!1!==n)?t<=i&&a<=e:t<i&&a<e},b.prototype._isOverlap=function(t,e){return this._isIntervalOverlap(t.overallStartTime,t.overallEndTime,e.overallStartTime,e.overallEndTime,!1)},b.prototype._calcTaskHeight=function(t){var e=this._gantt.getOptions(),a=e.taskDefaults,i=t.data,s=i.progress,r=i.baseline,o=!1,l=i.type?i.type:a.type,h=null!=i.height?i.height:a.height,d=0,g=n.getBaselineMarginTop(e);!r||null==t.baselineStartTime&&null==t.baselineEndTime||(d=null!=r.height?r.height:a.baseline.height,o="milestone"===l||"auto"===l&&t.baselineStartTime===t.baselineEndTime,null==r.height&&a.baseline.height===n.getBaselineTaskHeight(e)&&(d=o?n.getActualTaskHeight(e):a.baseline.height),null==i.height&&a.height===n.getStandaloneTaskHeight(e)&&(h=n.getActualTaskHeight(e)+o*g)),t.height=h,t.baselineHeight=d;var _=d>0?g:0,c=o?n.getMilestoneBaselineYOffset(e)+Math.max(d,h):h+_+d;if(t.overallHeightNoProgress=c,t.overallHeight=c,t.progressHeight=0,!("milestone"===l||"auto"===l&&t.startTime===t.endTime&&null!=t.startTime)&&s&&"number"==typeof s.value){var p=null!=s.height?s.height:a.progress.height;p="100%"===p?h:n.getSizeInPixels(p,h),t.progressHeight=p,h<p&&(t.overallHeight=Math.max(p,(p-h)/2+c))}},b.prototype._clearAdjacency=function(t){t.previousAdjacentTaskObj=null,t.nextAdjacentTaskObj=null,t.prevAdjMilestoneBaselineTaskObj=null,t.nextAdjMilestoneBaselineTaskObj=null},b.prototype._trackRowLevelBaselineMilestones=function(t,e){for(var a=t.taskObjs,i=[],n=0;n<e;n++)i.push([]);for(var s=0;s<a.length;s++){var r=a[s],o=this._gantt.getOptions().taskDefaults,l=r.data,h=l.type?l.type:o.type;("milestone"===h||"auto"===h&&r.baselineStartTime===r.baselineEndTime)&&i[r._rowLevel].push(r)}for(n=0;n<e;n++)i[n].sort(function(t,e){return e.baselineStartTime-t.baselineStartTime});for(s=0;s<a.length;s++){var d=i[(r=a[s])._rowLevel],g=d.length;if(g>0){var _=d[g-1],c=_.baselineStartTime,p=r.startTime,u=r.endTime;c<p?(r.prevAdjMilestoneBaselineTaskObj=_,d.pop()):c>u&&null==r.nextAdjMilestoneBaselineTaskObj?r.nextAdjMilestoneBaselineTaskObj=_:c!==p&&c!==u||d.pop()}}},b.prototype._calcRowTaskYHeight=function(t,e){for(var a,i=t.taskObjs,s=this._gantt.getOptions(),r=s.rowDefaults.height,o=s.taskDefaults.overlap.behavior,l=s.taskDefaults.overlap.offset,h=[],d=[],g=0;g<i.length;g++){var _=i[g];this._calcTaskHeight(_),this._clearAdjacency(_);var c=_.data,p=c.overlap?c.overlap.behavior:null,u=null!=p?p:o;u="auto"===u?null==r?"stack":"stagger":u,_.overlapBehavior=u;var b=l;if("overlay"===u&&null==a&&(a=_),0!==g){var f=i[g-1],y=this._isOverlap(_,f);y?E.push(_):(E=[_],h.push(E));var m=b||0,v=0;switch(u){case"stack":for(var T=!0,D=0;D<d.length;D++){var S=null;if(!this._isOverlap(_,d[D])){S=d[D],d[D]=_,T=!1;break}v+=1}T&&d.push(_),_.y=null!=b?v*b:0,S&&(_.previousAdjacentTaskObj=S,S.nextAdjacentTaskObj=_);break;case"stagger":y?(_._rowLevel=f._rowLevel,d[f._rowLevel]=_,_._staggerDirection=null!=f._staggerDirection?-f._staggerDirection:-1,_.y=f.y-_._staggerDirection*m):(d[v]=_,_._staggerDirection=1,_.y=0),_.previousAdjacentTaskObj=f,f.nextAdjacentTaskObj=_;break;case"overlay":d[v]=_,_.y=0}_._rowLevel=v}else{d.push(_),_._rowLevel=0;var E=[_];h.push(E),"stagger"===u&&(_._staggerDirection=1),_.y=0}}t.earliestOverlayTaskObj=a;var C=n.getRowPaddingTop(s),A=n.getRowPaddingBottom(s);if(null==r)if(null==b){var O=d.map(function(){return 0});i.forEach(function(t){t.overallHeight>O[t._rowLevel]&&(O[t._rowLevel]=t.overallHeight)});var w=O.map(function(t){return t+C+A}).reduce(function(t,e,a){return t.push((t[a-1]||0)+e),t},[]);i.forEach(function(t){t.y+=(w[t._rowLevel-1]||0)+C}),this._trackRowLevelBaselineMilestones(t,d.length)}else i.forEach(function(t){0===t._rowLevel&&(t.y+=C)});var R=h.map(function(t){var e=0;return t.forEach(function(t){var a=t.y+t.overallHeight;a>e&&(e=a)}),e});if(null==r){if(0===i.length)return void(t.height=n.getStandaloneTaskHeight(s)+C+A);t.height=R.reduce(function(t,e){return Math.max(t,e)})+C,h.forEach(function(e,a){e.forEach(function(e){e.y+=t.y})})}else t.height=r-e,h.forEach(function(e,a){var i=R[a],n=Number.MAX_VALUE;e.forEach(function(e){e.y+=Math.floor((t.height-e.overallHeight)/2),e.y<n&&(n=e.y)});var s=Math.floor((t.height-i)/2)-n;e.forEach(function(e){"overlay"===e.overlapBehavior?e.y+=t.y:e.y+=t.y+s})})},b.prototype._generateRowObjs=function(t){var e=this._gantt.getOptions(),a=0;this._gantt.isHorizontalGridlinesVisible()&&(a=n.getHorizontalGridlineWidth(e));for(var i=[],s=0,r=0;r<t.length;r++){var o=t[r],l=o.tasks;if(null!=l){var h={id:null!=o.id?o.id:l.length>0?l[0].id:null,data:o,index:r,y:s,renderState:"add"};null!=o._depth&&(h.depth=o._depth,h.expanded=o._expanded,h.parentRowIndex=o._parentFlatIndex,o._depth=void 0,o._expanded=void 0,o._parentFlatIndex=void 0,o._flatIndex=void 0);for(var d=[],g=0;g<l.length;g++){var _=l[g],c={id:_.id,data:_,startTime:_.start&&""!==_.start?this._getTime(_.start):this._getTime(_.end),endTime:_.end&&""!==_.end?this._getTime(_.end):this._getTime(_.start),rowObj:h,predecessorDepObjs:[],successorDepObjs:[],renderState:"add"},p=c.startTime,u=c.endTime,b=_.baseline;if(b){var f=b.start&&""!==b.start?this._getTime(b.start):this._getTime(b.end),y=b.end&&""!==b.end?this._getTime(b.end):this._getTime(b.start);null==f&&null==y||(c.baselineStartTime=f,c.baselineEndTime=y,(f<p||null==p)&&(p=f),(y>u||null==u)&&(u=y))}null!=p&&null!=u&&(c.overallStartTime=p,c.overallEndTime=u,d.push(c))}d.sort(function(t,e){return t.startTime-e.startTime}),h.taskObjs=d,i.push(h),this._calcRowTaskYHeight(h,a),s+=h.height+a}}return i},b.prototype._generateDependencyObjs=function(t,a){a=a||this._createIdObjMap(this._rowObjs,"taskObjs");for(var i=[],n=0;n<t.length;n++){var r=t[n],o=r.predecessorTaskId,l=r.successorTaskId,h=null==r.type?s.FINISH_START:r.type,d=null!=o&&a.has(o),g=null!=l&&a.has(l);if(s._isValidType(h)&&d&&g&&!e.Obj.compareValues(this._ctx,o,l)){var _,c,p=a.get(o),u=a.get(l),b=p.rowObj,f=u.rowObj;b.index<=f.index?(_=b,c=f):(_=f,c=b);var y=r.shortDesc;if(null==y){var m=this._gantt.getOptions().translations,v=m[h+"DependencyAriaDesc"];y=e.ResourceUtils.format(m.accessibleDependencyInfo,[v,o,l])}var T={id:r.id,data:r,index:n,type:h,predecessorTaskObj:p,successorTaskObj:u,rowObjTop:_,rowObjBottom:c,ariaLabel:y};p.successorDepObjs.push(T),u.predecessorDepObjs.push(T),i.push(T)}}i.sort(function(t,e){return t.rowObjTop.index-e.rowObjTop.index});for(var D=0;D<i.length-1;D++)i[D].nextTopDependencyObj=i[D+1],i[D+1].prevTopDependencyObj=i[D];return i.sort(function(t,e){return t.rowObjBottom.index-e.rowObjBottom.index}),i},b.prototype._createIdObjMap=function(t,e){for(var a=new this._ctx.ojMap,i=0;i<t.length;i++){var n=t[i];if(e)for(var s=n[e],r=0;r<s.length;r++){var o=s[r];a.set(o.id,o)}else a.set(n.id,n)}return a},b.prototype._setDifferenceRenderState=function(t,e,a,i){for(var n=0;n<t.length;n++){var s=t[n];if(i)for(var r=s[i],o=0;o<r.length;o++){var l=r[o];if(!e.has(l.id)&&(l.renderState=a,"delete"===a)){var h=l.node;if(h&&h.getParent())"delete"!==s.renderState&&h.remove()}}else if(!e.has(s.id)&&(s.renderState=a,"delete"===a)){var d=s.node;d&&d.getParent()&&d.remove()}}},b.prototype._setIntersectionRenderState=function(t,a,i){for(var n=0;n<a.length;n++){var s=a[n];if(i)for(var r=s[i],o=0;o<r.length;o++){var l=r[o],h=t.get(l.id);if(h){if(e.Obj.compareValues(this._ctx,h.rowObj.id,s.id))l.renderState="exist";else{l.renderState="migrate";var d=h.node;d&&d.getParent()&&"none"===this._gantt.getAnimationManager().getAnimationMode()&&d.getRowNode().removeChild(d)}l._oldObj=h}}else{var g=t.get(s.id);g&&(s.renderState="exist",s._oldObj=g)}}},b.prototype._addAnimationFinalStateRowObjs=function(t,e){this._animationFinalStateRowObjs=this._animationFinalStateRowObjs||new Map,this._animationFinalStateRowObjs.has(t)||this._animationFinalStateRowObjs.set(t,new Set),e&&this._animationFinalStateRowObjs.get(t).add(e)},b.prototype._prepareAnimationDOM=function(t,a,i,n,s){var r=this._gantt.getAnimationManager(),o=r.getAnimationMode();r.setAnimationMode("none"),this._animationInitialStateRowObjsDelete=[];var l=this._contentHeight,h=t[t.length-1];this._contentHeight=h.y+h.height;var d=this._gantt.scrollPositionToTranslateY(this._gantt.getOptions().scrollPosition),g=this._gantt.getViewportYBounds(d),_=g.yMin,c=g.yMax;this._contentHeight=l;for(var p=this.findRowIndRange(this._rowObjs,_,c),u=p.minRowInd,b=p.maxRowInd,f=u;f<=b;f++){var y=this._rowObjs[f];if(y){this.ensureInDOM(y,"row"),"delete"===y.renderState&&y.node.getRowLabelContent()&&this._animationInitialStateRowObjsDelete.push(y);var m=i.get(y.id);m&&this._addAnimationFinalStateRowObjs(m);for(var v=y.taskObjs,T=0;T<v.length;T++){var D=v[T],S=s.get(D.id);if(S){var E=S.rowObj;if(!e.Obj.compareValues(this._ctx,E.id,y.id)){var C=a.get(E.id);C&&this.ensureInDOM(C,"row"),this._addAnimationFinalStateRowObjs(E,S)}}}}}var A=this.findRowIndRange(t,_,c),O=A.minRowInd,w=A.maxRowInd;for(f=O;f<=w;f++){var R=t[f];if(R){this._addAnimationFinalStateRowObjs(R);var k=a.get(R.id);k&&this.ensureInDOM(k,"row");var x=R.taskObjs;for(T=0;T<x.length;T++){var L=x[T],P=n.get(L.id);if(P){var M=P.rowObj;if(!e.Obj.compareValues(this._ctx,M.id,R.id)){this.ensureInDOM(P,"task");var I=i.get(M.id);I&&this._addAnimationFinalStateRowObjs(I,L)}}}}}r.setAnimationMode(o)},b.prototype._associateOldNodesAndNewLayoutObjs=function(t){for(var e=0;e<t.length;e++){var a=t[e],i=a._oldObj;if(i){var n=i.node;n&&(a.node=n,n.setLayoutObject(a)),a._oldObj=null}for(var s=a.taskObjs,r=0;r<s.length;r++){var o=s[r],l=o._oldObj;if(l){var h=l.node;h&&(o.node=h,h.setLayoutObject(o),h.isSelected()&&h.clearSelectionState()),o._oldObj=null}}}},b.prototype.calcLayout=function(){var t=this._gantt.getOptions(),e=this._gantt.getRenderState();if(null==e)var a=this._calcRowsLayout(t);else this._expandCollapseRowObject(t,e.state,e.payload);if(this._rowObjs.length>0){var i=this._rowObjs[this._rowObjs.length-1];this._contentHeight=i.y+i.height;var n=t.dependencies;null!=n&&n.length>0&&(this._dependencyObjs=this._generateDependencyObjs(n,a))}},b.prototype._calcRowsLayout=function(t){var e=t.rows;if(null!=e&&0!==e.length){var a=e;this._gantt.isRowsHierarchical()&&(a=this._flattenRows(e,t.expanded));var i=this._generateRowObjs(a);if(this._rowObjs&&!this._gantt.isInitialRender()&&this._gantt.isLastRenderValid()){var n=this._createIdObjMap(this._rowObjs),s=this._createIdObjMap(i),r=this._createIdObjMap(this._rowObjs,"taskObjs"),o=this._createIdObjMap(i,"taskObjs");this._setDifferenceRenderState(this._rowObjs,s,"delete"),this._setDifferenceRenderState(i,n,"add"),this._setIntersectionRenderState(n,i),this._setDifferenceRenderState(this._rowObjs,o,"delete","taskObjs"),this._setDifferenceRenderState(i,r,"add","taskObjs"),this._setIntersectionRenderState(r,i,"taskObjs"),"none"!==this._gantt.getAnimationManager().getAnimationMode()&&this._prepareAnimationDOM(i,n,s,r,o),this._associateOldNodesAndNewLayoutObjs(i)}return this._rowObjs=i,o}this._rowObjs=[]},b.prototype._expandCollapseRowObject=function(t,e,a){var i=this,s=a.index,r=a.data,o=r.rows,l=t.expanded,h=this._gantt.getAnimationManager(),d=h.getAnimationMode(),g="none"!==d;if(g)var _=this._gantt.getViewportYBounds(R),c=_.yMin,p=_.yMax-c,u=function(t,e,a){h.setAnimationMode("none");for(var n=0,s=e;s<t.length;s++){var r=t[s];if(i.ensureInDOM(r,"row"),i._addAnimationFinalStateRowObjs(r),(n+=r.height)>a)break}h.setAnimationMode(d)};var b=function(t,e,a,i){for(var n=a;n<i;n++){var s=t[n];if(s.renderState=e,"delete"===e){var r=s.node;r&&r.getParent()&&r.remove()}for(var o=s.taskObjs,l=0;l<o.length;l++){o[l].renderState=e}}};if(a.expanded="expand"===e,r._expanded=a.expanded,b(this._rowObjs,"exist",0,this._rowObjs.length),"expand"===e){var f=this._flattenRows(o,l,a.index+1,a.depth+1),y=this._generateRowObjs(f);b(y,"add",0,y.length),g&&u(this._rowObjs,s,p),this._rowObjs=this._rowObjs.slice(0,s+1).concat(y,this._rowObjs.slice(s+1,this._rowObjs.length))}else{var m=this._calcFlattenedRowsLength(o,l);b(this._rowObjs,"delete",s+1,s+1+m),g&&u(this._rowObjs,s+1+m,p);var v=this._rowObjs.splice(s+1,m);g&&(this._animationInitialStateRowObjsDelete=v)}var T=0;this._gantt.isHorizontalGridlinesVisible()&&(T=n.getHorizontalGridlineWidth(t));for(var D=a.y+a.height+T,S=s+1;S<this._rowObjs.length;S++){var E=this._rowObjs[S];E.index=S;for(var C=E.taskObjs,A=0;A<C.length;A++){var O=C[A];O.y=O.y-E.y+D}E.y=D,D+=E.height+T}if(g){var w=this._rowObjs[this._rowObjs.length-1];this._contentHeight=w.y+w.height;for(var R=this._gantt.scrollPositionToTranslateY(this._gantt.getOptions().scrollPosition),k=this._gantt.getViewportYBounds(R),x=k.yMin,L=k.yMax,P=this.findRowIndRange(this._rowObjs,x,L),M=P.minRowInd,I=P.maxRowInd,j=M;j<=I;j++)this._addAnimationFinalStateRowObjs(this._rowObjs[j])}},b.prototype._flattenRows=function(t,e,a,i){a=a||0,i=i||0;var n=this._gantt.getOptions().taskData,s=function(t,e,i,r){return t.reduce(function(t,o){o._depth=r,o._parentFlatIndex=i?i._flatIndex:null,o._flatIndex=a,a+=1;var l=o.rows;if(l){if(e.has(o.id))return o._expanded=!0,t.concat(o,s(l,e,o,r+1));o._expanded=!1}else if(n){var h=n.getChildDataProvider(o.id),d=!h||"yes"===h.isEmpty();o._expanded=!!d&&null}else o._expanded=null;return t.concat(o)},[])};return s(t,e,null,i)},b.prototype._calcFlattenedRowsLength=function(t,e){var a=function(t){return t.reduce(function(t,i){var n=i.rows;return n&&e.has(i.id)?t+1+a(n):t+1},0)};return a(t)},b.prototype.isRoot=function(t){return null==t.parentRowIndex},b.prototype.isHiddenCollapsed=function(t){for(var e=0;e<this._rowObjs;e++)if(this._rowObjs[e]===t)return!1;return!0},b.prototype.getParentRowObj=function(t){var e=t.parentRowIndex;return null!=e?this._rowObjs[e]:null},b.prototype._renderRowObj=function(t,e,a){var i=this._gantt.getDatabody(),n=t.node;if("update"===a)n.render(null,e);else{if(n||((n=new u(this._gantt)).setLayoutObject(t),t.node=n),this._gantt.isRowAxisEnabled()){var s=this._gantt.getRowAxis();if(s){var o=s.getRowLabelContents(),l=t.index,h=o[l];h||((h=new r(s,s.getLabelContentType())).setRowIndex(l),o[l]=h),h.render(t),n.setRowLabelContent(h)}}n.render(i,e)}},b.prototype._renderTaskObj=function(t,e){var a=t.rowObj,i=a.node,n=t.node;e&&n&&i&&n.getParent()===i||this._renderRowObj(a,{rowObj:a,tasksAdd:new Set([t]),tasksUpdate:new Set,tasksDelete:new Set,updateRender:!e},i&&i.getParent()?"update":"add")},b.prototype._renderDependencyObj=function(t,e){var a=this._gantt.getDependenciesContainer(),i=t.node;if(i&&i.getParent())return!1;var n=this._gantt.getAnimationManager(),r=n.getAnimationMode();n.setAnimationMode("none");var o=t.predecessorTaskObj,l=t.successorTaskObj;if(this._animationFinalStateRowObjs){var h=o.rowObj,d=l.rowObj;this._animationFinalStateRowObjs.has(h)&&this._animationFinalStateRowObjs.get(h).has(o)||this.ensureInDOM(o,"task",e),this._animationFinalStateRowObjs.has(d)&&this._animationFinalStateRowObjs.get(d).has(l)||this.ensureInDOM(l,"task",e)}else this.ensureInDOM(o,"task",e),this.ensureInDOM(l,"task",e);return n.setAnimationMode(r),i||((i=new s(this._gantt)).setLayoutObject(t),t.node=i),i.render(a),!0},b.prototype.ensureInDOM=function(t,e,a){switch(e){case"row":return void this._renderRowObj(t);case"task":return void this._renderTaskObj(t,a);case"dependency":return void this._renderDependencyObj(t,!0);case"rowLabel":return void this._renderRowObj(t,{rowObj:t,tasksAdd:new Set,tasksUpdate:new Set,tasksDelete:new Set,updateRender:!1},"add")}},b.prototype._binarySearchLeftMost=function(t,e,a,i,n){if(0===t.length)return 0;for(var s=0,r=t.length;s<r;){var o=Math.floor((s+r)/2),l=i?n?t[o][i][n]:t[o][i]:t[o];l<e?s=o+1:r=o}return s<t.length&&((l=i?n?t[s][i][n]:t[s][i]:t[s])===e||"successor"===a)?s:s>0?s-1:0},b.prototype.findRowIndRange=function(t,e,a){for(var i=this._binarySearchLeftMost(t,e,"predecessor","y"),n=i,s=i;s<t.length;s++){if(!(t[s].y<=a))break;n=s}return{minRowInd:i,maxRowInd:n}},b.prototype.findTaskObjsRange=function(t,e,a,i,n){for(var s=[],r=t.taskObjs,o=0;o<r.length;o++){var l=r[o];this._isIntervalOverlap(l.overallStartTime,l.overallEndTime,e,i)&&(a&&n?s.push(l):a||n?n?l.overallStartTime>e&&s.push(l):l.overallEndTime<i&&s.push(l):l.overallStartTime>e&&l.overallEndTime<i&&s.push(l))}return s},b.prototype.findBufferTaskObjsRange=function(t,e,a){for(var i=[],n=t.taskObjs,s=0;s<n.length;s++){var r=n[s],o=r.previousAdjacentTaskObj,l=r.nextAdjacentTaskObj,h=!o&&!l&&!this._isIntervalOverlap(r.overallStartTime,r.overallEndTime,e,a),d=r.overallEndTime<e&&(!l||l&&l.overallEndTime>=e),g=r.overallStartTime>a&&(!o||o&&o.overallStartTime<=a);(h||d||g)&&i.push(r)}return i},b.prototype.getLayoutObjectsInBBox=function(t){for(var a=this.findRowIndRange(this._rowObjs,t.y,t.y+t.h),n=a.minRowInd,s=a.maxRowInd,r=e.Agent.isRightToLeft(this._gantt.getCtx()),o=this._gantt.getStartTime(),l=this._gantt.getEndTime(),h=this._gantt.getContentLength(),d=i.TimeAxisUtils.getPositionDate(o,l,r?h-(t.x+t.w):t.x,h),g=i.TimeAxisUtils.getPositionDate(o,l,r?h-t.x:t.x+t.w,h),_=[],c=[],p=n;p<=s;p++){var u=this._rowObjs[p];_.push(u);for(var b=u.taskObjs,f=0;f<b.length;f++){var y=b[f];this._isIntervalOverlap(y.overallStartTime,y.overallEndTime,d,g)&&this._isIntervalOverlap(y.y,y.y+y.height,t.y,t.y+t.h)&&c.push(b[f])}}return{rowObjs:_,taskObjs:c}},b.prototype._renderViewportDependencyLines=function(t,e){var a=this._gantt.getDependenciesContainer();if(a&&a.removeChildren(),this._dependencyObjs.length>0){for(var i=function(t,e){var a,i,n=t.predecessorTaskObj,r=t.successorTaskObj;switch(n.type){case s.START_FINISH:a=n.startTime,i=r.endTime;break;case s.START_START:a=n.startTime,i=r.startTime;break;case s.FINISH_FINISH:a=n.endTime,i=r.endTime;break;case s.FINISH_START:default:a=n.endTime,i=r.startTime}return this._isIntervalOverlap(Math.min(a,i),Math.max(a,i),e.viewStartTime,e.viewEndTime)}.bind(this),n=this._binarySearchLeftMost(this._dependencyObjs,t.minRowInd,"successor","rowObjBottom","index"),r=this._dependencyObjs[n],o=r.prevTopDependencyObj,l=e===b.VPC_TRANSLATE||e===b.VPC_REFRESH;r&&r.rowObjTop.index<=t.maxRowInd;)i(r,t)&&this._renderDependencyObj(r,l),r=r.nextTopDependencyObj;for(;o;){o.rowObjBottom.index>=t.minRowInd&&i(o,t)&&this._renderDependencyObj(o,l),o=o.prevTopDependencyObj}}},b.prototype._detachRowObjNode=function(t){var e=t.node;e&&(t.taskObjs.forEach(function(t){var e=t.node;e&&e.remove()}),e.remove())},b.prototype._prepareViewport=function(t,e){var a=this._gantt.getDatabody();e===b.VPC_REFRESH&&(this._rowObjs.forEach(this._detachRowObjNode,this),a.removeChildren(),this._gantt.getDatabodyBackground().removeChildren());var i=this._gantt.getRowAxis();this._gantt.isRowAxisEnabled()&&i&&e!==b.VPC_TRANSLATE&&e!==b.VPC_SCALE&&i.removeChildren()},b.prototype._computeViewportRenderOperations=function(t,e){var a=[],n=[],s=[];if(e===b.VPC_REFRESH)for(var r=t.minRowInd;r<=t.maxRowInd;r++){var o=this._rowObjs[r],l=this.findTaskObjsRange(o,t.viewStartTime,!0,t.viewEndTime,!0);this.findBufferTaskObjsRange(o,t.viewStartTime,t.viewEndTime).forEach(function(t){l.push(t)}),n.push({rowObj:o,tasksAdd:new Set(l),tasksUpdate:new Set,tasksDelete:new Set,updateRender:!0})}else if(e===b.VPC_ANIMATE){this._animationFinalStateRowObjs.forEach(function(e,a){var i=new Set,s=this.findTaskObjsRange(a,t.viewStartTime,!0,t.viewEndTime,!0),r=this.findBufferTaskObjsRange(a,t.viewStartTime,t.viewEndTime);s.forEach(function(t){e.has(t)||i.add(t)}),r.forEach(function(t){e.has(t)||i.add(t)}),e.forEach(function(t){i.add(t)}),this._animationFinalStateRowObjs.set(a,i),n.push({rowObj:a,tasksAdd:i,tasksUpdate:new Set,tasksDelete:new Set,updateRender:!0})},this);var h=this._gantt.getRowAxis();for(r=0;r<this._animationInitialStateRowObjsDelete.length;r++){var d=this._animationInitialStateRowObjsDelete[r].node;if(d){var g=d.getRowLabelContent();h.addChild(g.getDisplayable()),this._gantt.isHorizontalGridlinesVisible()&&h.addChild(d.getRowAxisHorizontalLine())}}}else{var _=this._gantt.getEventManager(),c=i.TimeAxisUtils.supportsTouch()&&_&&_.isDnDDragging();for(r=this._prevViewport.minRowInd;r<Math.min(t.minRowInd,this._prevViewport.maxRowInd);r++)a.push(this._rowObjs[r]);for(r=Math.max(t.maxRowInd+1,this._prevViewport.minRowInd);r<=this._prevViewport.maxRowInd;r++)a.push(this._rowObjs[r]);for(r=t.minRowInd;r<Math.min(this._prevViewport.minRowInd,t.maxRowInd);r++){o=this._rowObjs[r],l=this.findTaskObjsRange(o,t.viewStartTime,!0,t.viewEndTime,!0);this.findBufferTaskObjsRange(o,t.viewStartTime,t.viewEndTime).forEach(function(t){l.push(t)}),n.push({rowObj:o,tasksAdd:new Set(l),tasksUpdate:new Set,tasksDelete:new Set,updateRender:!0})}for(r=Math.max(this._prevViewport.maxRowInd+1,t.minRowInd);r<=t.maxRowInd;r++){o=this._rowObjs[r],l=this.findTaskObjsRange(o,t.viewStartTime,!0,t.viewEndTime,!0);this.findBufferTaskObjsRange(o,t.viewStartTime,t.viewEndTime).forEach(function(t){l.push(t)}),n.push({rowObj:o,tasksAdd:new Set(l),tasksUpdate:new Set,tasksDelete:new Set,updateRender:!0})}var p=e===b.VPC_SCALE;if(this._prevViewport.maxRowInd>=t.minRowInd&&this._prevViewport.minRowInd<=t.maxRowInd){var u=this._prevViewport.viewStartTime,f=this._prevViewport.viewEndTime,y=t.viewStartTime,m=t.viewEndTime;for(r=Math.max(t.minRowInd,this._prevViewport.minRowInd);r<=Math.min(t.maxRowInd,this._prevViewport.maxRowInd);r++){o=this._rowObjs[r];var v=new Set,T=new Set,D=new Set;u<y&&this.findTaskObjsRange(o,u,!0,Math.min(y,f),f<y).forEach(function(t){v.add(t)}),f>m&&this.findTaskObjsRange(o,Math.max(m,u),u>m,f,!0).forEach(function(t){v.add(t)}),y<u&&this.findTaskObjsRange(o,y,!0,Math.min(m,u),m<u).forEach(function(t){T.add(t)}),m>f&&this.findTaskObjsRange(o,Math.max(f,y),y>f,m,!0).forEach(function(t){T.add(t)}),f>=y&&u<=m&&(D=new Set(this.findTaskObjsRange(o,Math.max(y,u),!0,Math.min(m,f),!0))),this.findBufferTaskObjsRange(o,this._prevViewport.viewStartTime,this._prevViewport.viewEndTime).forEach(function(t){v.add(t)}),this.findBufferTaskObjsRange(o,t.viewStartTime,t.viewEndTime).forEach(function(t){T.add(t)});var S=[];v.forEach(function(t){T.has(t)&&S.push(t)}),S.forEach(function(t){D.add(t),v.delete(t),T.delete(t)}),c&&(v=new Set),s.push({rowObj:o,tasksAdd:T,tasksUpdate:D,tasksDelete:v,updateRender:p})}}}return c&&(a=[]),{rowsDelete:a,rowsAdd:n,rowsUpdate:s}},b.prototype._executeViewportRenderOperations=function(t){t.rowsDelete.forEach(this._detachRowObjNode,this),t.rowsAdd.forEach(function(t){this._renderRowObj(t.rowObj,t,"add")},this),t.rowsUpdate.forEach(function(t){this._renderRowObj(t.rowObj,t,"update")},this)},b.prototype.renderViewport=function(t,e){this._prepareViewport(t,e);var a=this._computeViewportRenderOperations(t,e);this._executeViewportRenderOperations(a),this._renderViewportDependencyLines(t,e),this._prevViewport=t,this._animationFinalStateRowObjs=null,this._animationInitialStateRowObjsDelete=[]};var f=function(t){this.Init(t)};e.Obj.createSubclass(f,e.Obj),f.prototype.Init=function(t){this._gantt=t},f.prototype.prepareForAnimations=function(){var t=this._gantt.getCtx();this._gantt.StopAnimation(),this._animationMode="none",this._animationDuration=n.getAnimationDuration(this._gantt.getOptions()),this._gantt.isInitialRender()?this._gantt.isIRAnimationEnabled&&(this._animationMode="onDisplay"):this._gantt.isDCAnimationEnabled&&(this._animationMode="dataChange"),"onDisplay"===this._animationMode?(this.fadeInElemsIR=[],this.fadeInPlayableIR=new e.AnimFadeIn(t,this.fadeInElemsIR,this._animationDuration,0),this.dimensionsPlayableIR=this._createCustomPlayable(e.Easing.linear),this.translationsPlayableIR=this._createCustomPlayable(e.Easing.cubicInOut)):"dataChange"===this._animationMode&&(this.fadeInElemsDC=[],this.fadeInPlayableDC=new e.AnimFadeIn(t,this.fadeInElemsDC,this._animationDuration,0),this.fadeOutElemsDC=[],this.fadeOutPlayableDC=new e.AnimFadeOut(t,this.fadeOutElemsDC,this._animationDuration,0),this.dimensionsPlayableDC=this._createCustomPlayable(e.Easing.linear),this.translationsPlayableDC=this._createCustomPlayable(e.Easing.cubicInOut)),this._onEnds=[]},f.prototype.getAnimationMode=function(){return this._animationMode},f.prototype.setAnimationMode=function(t){this._animationMode=t},f.prototype._createCustomPlayable=function(t){var a;return(a=new e.CustomAnimation(this._gantt.getCtx(),this._gantt,this._animationDuration)).setEasing(t),a},f.prototype.triggerAnimations=function(){var t,a;if(this._gantt.StopAnimation(),a=this._gantt.getCtx(),"onDisplay"===this._animationMode?(t=[this.fadeInPlayableIR,this.translationsPlayableIR,this.dimensionsPlayableIR],this._gantt.Animation=new e.ParallelPlayable(a,t,this._animationDuration,0)):"dataChange"===this._animationMode&&(t=[this.fadeInPlayableDC,this.translationsPlayableDC,this.dimensionsPlayableDC,this.fadeOutPlayableDC],this._gantt.Animation=new e.ParallelPlayable(a,t,this._animationDuration,0)),this._gantt.Animation){this._hideDepLines(),e.Playable.appendOnEnd(this._gantt.Animation,this._showDepLines,this),this._gantt.isDndEnabled()||(this._gantt.EventManager.removeListeners(this._gantt),this._bListenersRemoved=!0);for(var i=0;i<this._onEnds.length;i++)e.Playable.appendOnEnd(this._gantt.Animation,this._onEnds[i],this);e.Playable.appendOnEnd(this._gantt.Animation,this._onAnimationEnd,this),this._gantt.Animation.play()}},f.prototype._hideDepLines=function(){var t=this._gantt.getDependenciesContainer();null!=t&&e.ToolkitUtils.setAttrNullNS(t.getElem(),"display","none")},f.prototype._showDepLines=function(){var t=this._gantt.getDependenciesContainer();null!=t&&e.ToolkitUtils.removeAttrNullNS(t.getElem(),"display")},f.prototype._onAnimationEnd=function(){this._gantt.AnimationStopped||this._gantt.RenderComplete(),this._bListenersRemoved&&this._gantt.EventManager.addListeners(this._gantt),this._gantt.Animation=null,this._gantt.AnimationStopped=!1,this._animationMode="none",this._gantt.renderViewport(b.VPC_REFRESH,!1)},f.prototype.preAnimateGanttIR=function(t){"onDisplay"===this._animationMode&&this.fadeInElemsIR.push(t._canvas)},f.prototype.preAnimateTaskNode=function(t,a){var i,n=t.getRenderState();"dataChange"===this._animationMode?"add"===n?(t.setTranslate(a.x,a.y),this.fadeInElemsDC.push(t)):"exist"!==n&&"migrate"!==n||((i=this.translationsPlayableDC.getAnimator()).addProp(e.Animator.TYPE_NUMBER,t,t.getTranslateX,t.setTranslateX,a.x),i.addProp(e.Animator.TYPE_NUMBER,t,t.getTranslateY,t.setTranslateY,a.y)):t.setTranslate(a.x,a.y)},f.prototype.preAnimateTaskNodeRemove=function(t,e){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(t),this._onEnds.push(e)):e()},f.prototype.preAnimateTaskBaseline=function(t,a,i,n){var s,r,o=t.getRenderState("baseline");"onDisplay"===this._animationMode?(a.setDimensions(i.x,i.y,0,i.h,i.r),n(),(s=this.dimensionsPlayableIR.getAnimator()).addProp(e.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w)):"dataChange"===this._animationMode?"add"===o?(a.setDimensions(i.x,i.y,0,i.h,i.r),n(),(s=this.dimensionsPlayableDC.getAnimator()).addProp(e.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w)):"exist"===o&&((r=this.translationsPlayableDC.getAnimator()).addProp(e.Animator.TYPE_NUMBER,a,a.getX,a.setX,i.x),r.addProp(e.Animator.TYPE_NUMBER,a,a.getY,a.setY,i.y),(s=this.dimensionsPlayableDC.getAnimator()).addProp(e.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w),s.addProp(e.Animator.TYPE_NUMBER,a,a.getHeight,a.setHeight,i.h),a.setBorderRadius(i.r),this._onEnds.push(n)):(a.setDimensions(i.x,i.y,i.w,i.h,i.r),n())},f.prototype.preAnimateTaskBaselineRemove=function(t,e){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(t),this._onEnds.push(e)):e()},f.prototype.preAnimateTaskMain=function(t,a,i){var n,s,r=t.getRenderState("main");"onDisplay"===this._animationMode?(t.setMainDimensions(a.x,a.y,0,a.h,a.r),i(),(n=this.dimensionsPlayableIR.getAnimator()).addProp(e.Animator.TYPE_NUMBER,t,t.getMainWidth,t.setMainWidth,a.w)):"dataChange"===this._animationMode?"add"===r?(t.setMainDimensions(a.x,a.y,0,a.h,a.r),i(),(n=this.dimensionsPlayableDC.getAnimator()).addProp(e.Animator.TYPE_NUMBER,t,t.getMainWidth,t.setMainWidth,a.w)):"exist"===r&&((s=this.translationsPlayableDC.getAnimator()).addProp(e.Animator.TYPE_NUMBER,t,t.getMainX,t.setMainX,a.x),s.addProp(e.Animator.TYPE_NUMBER,t,t.getMainY,t.setMainY,a.y),(n=this.dimensionsPlayableDC.getAnimator()).addProp(e.Animator.TYPE_NUMBER,t,t.getMainWidth,t.setMainWidth,a.w),n.addProp(e.Animator.TYPE_NUMBER,t,t.getMainHeight,t.setMainHeight,a.h),t.setMainBorderRadius(a.r),this._onEnds.push(i)):(t.setMainDimensions(a.x,a.y,a.w,a.h,a.r),i())},f.prototype.preAnimateTaskMainRemove=function(t,e,a,i,n){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(t),e&&this.fadeOutElemsDC.push(e),a&&this.fadeOutElemsDC.push(a),i&&this.fadeOutElemsDC.push(i),this._onEnds.push(n)):n()},f.prototype.preAnimateTaskProgress=function(t,a,i,n){var s,r,o=t.getRenderState("progress");"onDisplay"===this._animationMode?(a.setDimensions(i.x,i.y,0,i.h,i.r),n(),(s=this.dimensionsPlayableIR.getAnimator()).addProp(e.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w)):"dataChange"===this._animationMode?"add"===o?(a.setDimensions(i.x,i.y,0,i.h,i.r),n(),(s=this.dimensionsPlayableDC.getAnimator()).addProp(e.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w)):"exist"===o&&((r=this.translationsPlayableDC.getAnimator()).addProp(e.Animator.TYPE_NUMBER,a,a.getX,a.setX,i.x),r.addProp(e.Animator.TYPE_NUMBER,a,a.getY,a.setY,i.y),(s=this.dimensionsPlayableDC.getAnimator()).addProp(e.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w),s.addProp(e.Animator.TYPE_NUMBER,a,a.getHeight,a.setHeight,i.h),a.setBorderRadius(i.r),this._onEnds.push(n)):(a.setDimensions(i.x,i.y,i.w,i.h,i.r),n())},f.prototype.preAnimateTaskProgressRemove=function(t,e){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(t),this._onEnds.push(e)):e()},f.prototype.preAnimateTaskLabel=function(t,a,i){var n,s=t.getTask(),r=t.getTaskLabel(),o=r.getLabelOutputText(),l=r.getRenderState(),h=s.getRenderState("main");"onDisplay"===this._animationMode?(i(),o.setY(a.y),o.setX(s.getShape("main").getX()),(n=this.translationsPlayableIR.getAnimator()).addProp(e.Animator.TYPE_NUMBER,o,o.getX,o.setX,a.x),n.addProp(e.Animator.TYPE_NUMBER,o,o.getY,o.setY,a.y)):"dataChange"===this._animationMode?"add"===l?(o.setX(a.x),o.setY(a.y),i(),"add"===h?(o.setX(s.getShape("main").getX()),(n=this.translationsPlayableDC.getAnimator()).addProp(e.Animator.TYPE_NUMBER,o,o.getX,o.setX,a.x),n.addProp(e.Animator.TYPE_NUMBER,o,o.getY,o.setY,a.y)):"exist"===h&&this.fadeInElemsDC.push(o)):"exist"===l&&((n=this.translationsPlayableDC.getAnimator()).addProp(e.Animator.TYPE_NUMBER,o,o.getX,o.setX,a.x),n.addProp(e.Animator.TYPE_NUMBER,o,o.getY,o.setY,a.y),this._onEnds.push(i)):(o.setX(a.x),o.setY(a.y),i())},f.prototype.preAnimateTaskLabelRemove=function(t,e){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(t),this._onEnds.push(e)):e()},f.prototype.preAnimateHorizontalGridline=function(t,a,i){var n;"dataChange"===this._animationMode?"add"===i?(t.setY1(a.y1),t.setY2(a.y2),t.setX1(a.x1),t.setX2(a.x2),this.fadeInElemsDC.push(t)):"exist"===i&&((n=this.translationsPlayableDC.getAnimator()).addProp(e.Animator.TYPE_NUMBER,t,t.getX1,t.setX1,a.x1),n.addProp(e.Animator.TYPE_NUMBER,t,t.getX2,t.setX2,a.x2),n.addProp(e.Animator.TYPE_NUMBER,t,t.getY1,t.setY1,a.y1),n.addProp(e.Animator.TYPE_NUMBER,t,t.getY2,t.setY2,a.y2)):(t.setY1(a.y1),t.setY2(a.y2),t.setX1(a.x1),t.setX2(a.x2))},f.prototype.preAnimateRowBackground=function(t,a,i){var n;"dataChange"===this._animationMode?("add"===i&&this.fadeInElemsDC.push(t),(n=this.dimensionsPlayableDC.getAnimator()).addProp(e.Animator.TYPE_NUMBER,t,t.getHeight,t.setHeight,a.h),n.addProp(e.Animator.TYPE_NUMBER,t,t.getWidth,t.setWidth,a.w),this.translationsPlayableDC.getAnimator().addProp(e.Animator.TYPE_NUMBER,t,t.getY,t.setY,a.y)):(t.setY(a.y),t.setHeight(a.h),t.setWidth(a.w))},f.prototype.preAnimateRowNodeRemove=function(t,e){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(t),this.fadeOutElemsDC.push(t.getBackground()),this._onEnds.push(e)):e()},f.prototype.preAnimateRowLabel=function(t,a,i){var n,s=t.getRenderState();"dataChange"===this._animationMode?"add"===s?(a.setY(i.y),a.setX(i.x),this.fadeInElemsDC.push(a.getDisplayable())):"exist"===s&&((n=this.translationsPlayableDC.getAnimator()).addProp(e.Animator.TYPE_NUMBER,a,a.getX,a.setX,i.x),n.addProp(e.Animator.TYPE_NUMBER,a,a.getY,a.setY,i.y)):(a.setY(i.y),a.setX(i.x))},f.prototype.preAnimateRowLabelRemove=function(t,e,a){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(t.getDisplayable()),this.fadeOutElemsDC.push(e),this._onEnds.push(a)):a()};var y=function(t){this._gantt=t};e.Obj.createSubclass(y,e.Automation),y.prototype.GetSubIdForDomElement=function(t){var e=this._gantt.getEventManager().GetLogicalObject(t);if(e&&e instanceof p){var a=e.getLayoutObject().rowObj;return"taskbar["+a.index+"]["+a.taskObjs.map(function(t){return t.node}).indexOf(e)+"]"}return e&&e instanceof r?"rowLabel["+e.getRowIndex()+"]":e&&e instanceof s?e.getLayoutObject().index:null},y.prototype.getDomElementForSubId=function(t){if(t===e.Automation.TOOLTIP_SUBID)return this.GetTooltipElement(this._gantt);var a=t.indexOf("["),i=t.indexOf("]"),n=t.substring(0,a);if(a>-1&&i>-1)if("taskbar"===n){var s=t.indexOf("[",a+1),r=t.indexOf("]",s+1);if(s>-1&&r>-1){var o=parseInt(t.substring(a+1,i)),l=parseInt(t.substring(s+1,r));if(isNaN(o)||isNaN(l))return null;if((_=this._gantt.getRowLayoutObjs()).length>o){var h=_[o].taskObjs;if(h.length>l){var d=h[l];this._gantt.getDataLayoutManager().ensureInDOM(d,"task",!0);var g=d.node.getTask().getShape("main");if(null!=g)return g.getElem()}}}}else if("rowLabel"===n){var _;if(o=parseInt(t.substring(a+1,i)),(_=this._gantt.getRowLayoutObjs()).length>o){var c=_[o];this._gantt.getDataLayoutManager().ensureInDOM(c,"rowLabel");var p=c.node.getRowLabelContent();if(null!=p)return p.getDisplayable().getElem()}}else if("dependency"===n){var u=parseInt(t.substring(a+1,i)),b=this._gantt.getDependencyLayoutObjs();if(b.length>u)for(var f=0;f<b.length;f++){var y=b[f];if(y.index===u){this._gantt.getDataLayoutManager().ensureInDOM(y,"dependency");var m=y.node;if(null!=m)return m.getElem()}}}return null};var m=function(t){this.Init({alta:m.VERSION_1},t)};e.Obj.createSubclass(m,e.BaseComponentDefaults),m.VERSION_1={axisPosition:"top",animationOnDataChange:"none",animationOnDisplay:"none",scrollbar:{horizontal:"off",vertical:"off"},gridlines:{horizontal:"hidden",vertical:"visible"},selectionMode:"none",scrollPosition:{y:0},rowDefaults:{height:null},taskDefaults:{labelPosition:["end","innerCenter","start","max"],borderRadius:"0",overlap:{behavior:"auto",offset:null},progress:{height:"100%",borderRadius:"0"},baseline:{borderRadius:"0"},type:"auto"},rowAxis:{rendered:"off",width:"max-content",maxWidth:"none"}},m.prototype.getNoCloneObject=function(){return{start:!0,end:!0,viewportStart:!0,viewportEnd:!0,rows:!0,dependencies:!0,referenceObjects:{value:!0},majorAxis:{scale:!0,zoomOrder:!0},minorAxis:{scale:!0,zoomOrder:!0}}},m.prototype.getAnimationDuration=function(t){return t._resources?t._resources.animationDuration:null};var v=function(){};e.Obj.createSubclass(v,e.Obj),v.prototype.parse=function(t){var e=new Object,a=function(e){var a=typeof t[e];if("number"===a||"string"===a){var i=new Date(t[e]).getTime();if(!isNaN(i))return i}return null};return e.start=a("start"),e.end=a("end"),t.viewportStart&&(e.viewStart=a("viewportStart")),t.viewportEnd&&(e.viewEnd=a("viewportEnd")),e.rows=t.rows,e.dependencies=t.dependencies,e.axisPosition="top",null!=t.axisPosition&&(e.axisPosition=t.axisPosition),e.selectionMode="none",null!=t.selectionMode&&(e.selectionMode=t.selectionMode),e.horizontalGridline="hidden",e.verticalGridline="hidden",null!=t.gridlines&&(null!=t.gridlines.horizontal&&(e.horizontalGridline=t.gridlines.horizontal),null!=t.gridlines.vertical&&(e.verticalGridline=t.gridlines.vertical)),e.xScrollbar="off",e.yScrollbar="off",t.scrollbars&&(t.scrollbars.horizontal&&(e.xScrollbar=t.scrollbars.horizontal),t.scrollbars.vertical&&(e.yScrollbar=t.scrollbars.vertical)),e.isIRAnimationEnabled="auto"===t.animationOnDisplay,e.isDCAnimationEnabled="auto"===t.animationOnDataChange,null!=t.rowAxis&&(e.rowAxisRendered=t.rowAxis.rendered,e.rowAxisWidth=t.rowAxis.width,e.rowAxisMaxWidth=t.rowAxis.maxWidth),e.referenceObjects=t.referenceObjects,e.styleClass=t.className,e.inlineStyle=t.style,e};var T=function(t){this.Init(t)};e.Obj.createSubclass(T,e.Container),T.prototype.Init=function(t){T.superclass.Init.call(this,t.getCtx()),this._gantt=t},T.prototype.getDefaultRowLabelStyle=function(t){var e=this._gantt.getOptions();return t?(this._defaultLabelCSSStyle||(this._defaultLabelCSSStyle=n.getRowLabelStyle(e)),this._defaultLabelCSSStyle):n.getRowLabelStyle(e)},T.prototype._getCSSStyle=function(t){if(null!=t&&""!==t&&0!==Object.keys(t).length){var e=this.getDefaultRowLabelStyle(!1);return e.parseInlineStyle(t),e}return this.getDefaultRowLabelStyle(!0)},T.prototype.getLabelContentType=function(){var t=this._gantt.getOptions().rowAxis;return t.label&&t.label.renderer?"custom":"text"},T.prototype._getAvailableWidth=function(t){var e,a,i=this._gantt.getRowAxisMaxWidth(),s=this._gantt.getRowAxisWidth();return null!=i&&"none"!==i&&(e=Math.min(n.getSizeInPixels(i,t),t)),e=null==e||isNaN(e)?t:e,null!=s&&"max-content"!==s&&(a=n.getSizeInPixels(this._gantt.getRowAxisWidth(),t)),{maxWidth:e,width:a=null==a||isNaN(a)?-1:a,calculatedWidth:-1!==a?Math.min(a,e):e}},T.prototype.getAvailableWidth=function(){return this._availableWidth},T.prototype.getWidth=function(){return this._width},T.prototype.getLabelContentIndentSize=function(t){return t.depth*n.getRowLabelIndentSize()+n.getRowLabelButtonSize()+n.getRowLabelButtonContentGapSize()},T.prototype._getMaxTextContentWidth=function(t,a,i){if(!this._gantt.isRowsHierarchical())return e.TextUtils.getMaxTextStringWidth(t,a,i);for(var n=this._gantt.getRowLayoutObjs(),s=0,r=0;r<a.length;r++){var o=a[r]?a[r]:"",l=i[r],h=e.TextUtils.getTextStringWidth(t,o,l),d=(null==n[r].expanded&&0===o.length?0:this.getLabelContentIndentSize(n[r]))+h;d>s&&(s=d)}return s},T.prototype.render=function(t,e){if(this._availableWidth=this._getAvailableWidth(t),e)-1!==this._availableWidth.width&&(this._width=this._availableWidth.calculatedWidth);else{this._rowLabelContents=[];var a=this.getLabelContentType(),i=this._gantt.getRowLayoutObjs();if(-1===this._availableWidth.width){if("text"===a){for(var s=[],o=[],l=0;l<i.length;l++){var h=i[l].data,d=null!=h.label?h.label:"",g=this._getCSSStyle(h.labelStyle);s.push(d),o.push(g),this._rowLabelContents.push(null)}this._width=this._getMaxTextContentWidth(this._gantt.getCtx(),s,o)}else if("custom"===a){this._width=0;for(l=0;l<i.length;l++){var _=i[l],c=new r(this,a);c.setRowIndex(l),c.render(_),this._width=Math.max(this._width,c.getWidth()),this._rowLabelContents.push(c)}}this._width+=2*n.getRowLabelPadding(this._gantt.getOptions())}else{this._width=this._availableWidth.calculatedWidth;for(l=0;l<i.length;l++)this._rowLabelContents.push(null)}this._width=Math.ceil(Math.min(this._width,this._availableWidth.maxWidth))}},T.prototype.getRowLabelContents=function(){return this._rowLabelContents},T.prototype.setBackgroundContainer=function(t){this._backgroundContainer=t},T.prototype.getBackgroundContainer=function(){return this._backgroundContainer},T.prototype.setBackgroundDivider=function(t){this._backgroundDivider=t},T.prototype.getBackgroundDivider=function(){return this._backgroundDivider},T.prototype.adjustPosition=function(){var t=e.Agent.isRightToLeft(this._gantt.getCtx()),a=this._width,i=this._gantt.getCanvasSize()-this._gantt.getAxesHeight(),s=t?this._gantt.getStartXOffset()+this._gantt.getCanvasLength()+this._gantt.getBorderWidth()+n.getRowAxisGap():0;this.setTranslateX(s);var r=new e.ClipPath;r.addRect(this.getTranslateX(),this._gantt.getDatabodyStart()+this._gantt.getStartYOffset(),a,i),this.setClipPath(r),this._backgroundContainer.setTranslateX(t?s-1:s);var o=new e.ClipPath;o.addRect(this.getTranslateX(),0,a,this._gantt._backgroundHeight),this._backgroundContainer.setClipPath(o);var l=this._gantt.getDatabodyStart()+this._gantt.getStartYOffset()+("top"!==this._gantt.getAxisPosition())*(this._gantt.getDatabodyHeight()+1);this._backgroundDivider.setY1(l),this._backgroundDivider.setY2(l)};var D=function(t,e,a){this.Init(t,e,a)};e.Obj.createSubclass(D,e.Container),D.prototype.Init=function(t,e,a){D.superclass.Init.call(this,t.getCtx(),null),this._gantt=t,this._type=e,this._refObjs=a,this._gantt.getEventManager().associate(this,this)},D.prototype._applyStyles=function(){var t=this._refObjs[0].svgStyle,e=this._refObjs[0].svgClassName;null!=t&&this._ref.setStyle(t);var a="line"===this._type?this._gantt.GetStyleClass("referenceObjectLine"):this._gantt.GetStyleClass("referenceObjectArea"),i=null!=e?a+" "+e:a;this._ref.setClassName(i,!0)},D.prototype._calcCmds=function(t){var a=e.Agent.isRightToLeft(this._gantt.getCtx()),n=this._gantt.getStartTime(),s=this._gantt.getEndTime(),r=this._gantt.getContentLength(),o="";return"line"===this._type?this._refObjs.forEach(function(l){var h=new Date(l.value).getTime(),d=i.TimeAxisUtils.getDatePosition(n,s,h,r)+(t||0);a&&(d=r-d),o+=e.PathUtils.moveTo(d,this._gantt.getDatabodyStart())+e.PathUtils.verticalLineTo(this._gantt.getDatabodyStart()+this._gantt._canvasSize-this._gantt.getAxesHeight())},this):this._refObjs.forEach(function(t){var l=new Date(t.start).getTime(),h=new Date(t.end).getTime(),d=i.TimeAxisUtils.getDatePosition(n,s,l,r),g=i.TimeAxisUtils.getDatePosition(n,s,h,r),_=a?r-g:d,c=a?r-d:g;o+=e.PathUtils.moveTo(_,this._gantt.getDatabodyStart())+e.PathUtils.horizontalLineTo(c)+e.PathUtils.verticalLineTo(this._gantt.getDatabodyStart()+this._gantt._canvasSize-this._gantt.getAxesHeight())+e.PathUtils.horizontalLineTo(_)+e.PathUtils.verticalLineTo(this._gantt.getDatabodyStart())},this),o},D.prototype.render=function(t){0!==this._refObjs.length&&(this._ref=new e.Path(this._gantt.getCtx(),this._calcCmds()),"line"===this._type&&(this._partnerRef=new e.Path(this._gantt.getCtx(),this._calcCmds(1)),this._partnerRef.setClassName(this._gantt.GetStyleClass("referenceObjectInnerLine"),!0),this.addChild(this._partnerRef)),this._applyStyles(),this.addChild(this._ref),t.addChild(this))},D.prototype.getDatatip=function(){return this._refObjs[0].shortDesc};var S={};e.Obj.createSubclass(S,e.Obj),S.renderGantt=function(t){if(S._renderBackground(t),S._renderScrollableCanvas(t),t.getAnimationManager().preAnimateGanttIR(t),t.removeEmptyText(),t.hasValidOptions()){S._prepareTaskFillFilters(t),t.renderTimeZoomCanvas(t._canvas);var e=t.getTimeZoomCanvas();if(S._renderAxes(t,e),S._renderDatabodyBackground(t,e),S._renderReferenceObjects(t,e,"area"),S._renderVerticalGridline(t,e),t.isRowAxisEnabled()&&t.getRowAxis().adjustPosition(),S._renderData(t,e,b.VPC_REFRESH),S._renderReferenceObjects(t,e,"line"),S._renderZoomControls(t),t.isMarqueeSelectEnabled())S._renderMarqueeArtifactsContainer(t,e);else{var a=t.getMarqueeArtifactsContainer();a&&(a.getParent().removeChild(a),t.setMarqueeArtifactsContainer(null))}if(t.isDndEnabled()&&S._renderDnDArtifactsContainer(t,e),null!=t.getRenderState()){var i=t.getEventManager().getFocus();i&&i instanceof p&&i.refreshAriaLabel()}t._processInitialSelections(),(t.isTimeDirScrollbarOn()||t.isContentDirScrollbarOn())&&S._renderScrollbars(t,t),t.setIsLastRenderValid(!0)}else S._renderEmptyText(t),t.setIsLastRenderValid(!1)},S._prepareTaskFillFilters=function(t){if(!document.getElementById(n.getTaskTintFilterId())){var a=n.getTaskTintAlpha(),i=e.SvgShapeUtils.createElement("filter",n.getTaskTintFilterId()),s=e.SvgShapeUtils.createElement("feColorMatrix");s.setAttribute("color-interpolation-filters","sRGB"),s.setAttribute("type","matrix"),s.setAttribute("values",1-a+" 0 0 0 "+a+" 0 "+(1-a)+" 0 0 "+a+" 0 0 "+(1-a)+" 0 "+a+" 0 0 0 1 0"),i.appendChild(s);var r=n.getTaskShadeAlpha(),o=e.SvgShapeUtils.createElement("filter",n.getTaskShadeFilterId()),l=e.SvgShapeUtils.createElement("feColorMatrix");l.setAttribute("color-interpolation-filters","sRGB"),l.setAttribute("type","matrix"),l.setAttribute("values",1-r+" 0 0 0 0 0 "+(1-r)+" 0 0 0 0 0 "+(1-r)+" 0 0 0 0 0 1 0"),o.appendChild(l),t.appendSharedDefs(i),t.appendSharedDefs(o)}},S._prerenderTimeDirScrollbar=function(t,a,i){var n=i.w,s=e.CSSStyle.toNumber(t.timeDirScrollbarStyles.getHeight());return t.setTimeDirScrollbar(new e.SimpleScrollbar(t.getCtx(),t.HandleEvent,t)),a.addChild(t.timeDirScrollbar),e.LayoutUtils.position(i,"bottom",t.timeDirScrollbar,n,s,0),new e.Dimension(n,s)},S._prerenderContentDirScrollbar=function(t,a,i){var n=e.CSSStyle.toNumber(t.contentDirScrollbarStyles.getWidth()),s=i.h;return t.setContentDirScrollbar(new e.SimpleScrollbar(t.getCtx(),t.HandleEvent,t)),a.addChild(t.contentDirScrollbar),e.LayoutUtils.position(i,e.Agent.isRightToLeft(t.getCtx())?"left":"right",t.contentDirScrollbar,n,s,0),new e.Dimension(n,s)},S._renderScrollbars=function(t,a){var i=t.getDatabody();if(null!=i){var n=t.getDatabodyStart(),s=t.getCtx(),r=t.getScrollbarPadding();if(null==t._scrollbarsCanvas?(t._scrollbarsCanvas=new e.Container(s,"sbCanvas"),a.addChild(t._scrollbarsCanvas)):t._scrollbarsCanvas.removeChildren(),t.isTimeDirScrollbarOn())var o=t.getCanvasLength(),l=t.Height-r,h=S._prerenderTimeDirScrollbar(t,t._scrollbarsCanvas,new e.Rectangle(0,0,o,l));if(t.isContentDirScrollbarOn()){o=t.Width-r,l=t.getCanvasSize()-t.getAxesHeight();var d=e.Agent.isRightToLeft(t.getCtx())?t.getScrollbarPadding():0,g=S._prerenderContentDirScrollbar(t,t._scrollbarsCanvas,new e.Rectangle(d,0,o-d,l))}if(t.timeDirScrollbar&&h){var _={};_.color=t.timeDirScrollbarStyles.getStyle(e.CSSStyle.COLOR),_.backgroundColor=t.timeDirScrollbarStyles.getStyle(e.CSSStyle.BACKGROUND_COLOR),_.min=t._start,_.max=t._end,_.isHorizontal=!0,_.isReversed=e.Agent.isRightToLeft(t.getCtx()),t.timeDirScrollbar.setTranslateX(t.getStartXOffset()),t.timeDirScrollbar.render(_,h.w,h.h),t.timeDirScrollbar.setViewportRange(t._viewStartTime,t._viewEndTime)}if(t.contentDirScrollbar&&g){(_={}).color=t.contentDirScrollbarStyles.getStyle(e.CSSStyle.COLOR),_.backgroundColor=t.contentDirScrollbarStyles.getStyle(e.CSSStyle.BACKGROUND_COLOR),_.min=-(Math.max(t.getContentHeight(),g.h)-n),_.max=n,_.isHorizontal=!1,_.isReversed=!0,t.contentDirScrollbar.setTranslateY(n+t.getStartYOffset()),t.contentDirScrollbar.render(_,g.w,g.h);var c=0;"bottom"===t.getAxisPosition()&&(c=t.getAxesHeight()),t.contentDirScrollbar.setViewportRange(i.getTranslateY()-(t.getCanvasSize()-n-c),i.getTranslateY())}}else null!=t._scrollbarsCanvas&&t._scrollbarsCanvas.removeChildren()},S.renderRowAxis=function(t,a){var i=e.Agent.isRightToLeft(t.getCtx()),s=t.getRowAxis();if(t.isRowAxisEnabled()){s||((s=new T(t)).setPixelHinting(!0),t.setRowAxis(s),s.setBackgroundContainer(new e.Container(t.getCtx()))),a&&(a.addChild(s),t.getParent().addChildAt(s.getBackgroundContainer(),0)),s.render(t.Width-n.getRowAxisGap(),null==a);var r=s.getWidth(),o=r>0?r+n.getRowAxisGap():0;t._backgroundWidth=t._backgroundWidth-o,i||(t._widthOffset=t._widthOffset+o,t.setStartXOffset(t.getStartXOffset()+o)),t._canvasLength=t._canvasLength-o;var l=s.getBackgroundContainer();l.removeChildren();var h=new e.Rect(t.getCtx(),0,0,r+1,t._backgroundHeight);h.setClassName(t.GetStyleClass("databody")),h.setPixelHinting(!0),l.addChild(h);var d=new e.Line(t.getCtx(),0,0,r,0);d.setPixelHinting(!0),d.setClassName(t.GetStyleClass("hgridline"),!0),l.addChild(d),s.setBackgroundDivider(d)}else a&&s&&(t.getParent().removeChild(s.getBackgroundContainer()),a.removeChild(s)),t.setRowAxis(null)},S._renderBackground=function(t){var a=t._backgroundWidth,i=t._backgroundHeight;t._background?(t._background.setClipPath(null),t._background.setWidth(a),t._background.setHeight(i),t._background.setX(t._widthOffset)):t._background=new e.Rect(t.getCtx(),t._widthOffset,0,a,i,"bg"),t._background.setClassName(t.GetStyleClass("databody")),t._background.setPixelHinting(!0);var n=new e.ClipPath;n.addRect(t._widthOffset,0,a,i),t._background.setClipPath(n),t._background.getParent()!=t&&t.addChild(t._background)},S._renderDatabodyBackground=function(t,a){var i=t.getDatabodyBackground();null==i&&(i=new e.Container(t.getCtx()),a.addChild(i),t.setDatabodyBackground(i)),null==t.getDatabody()&&i.setTranslateY(t.scrollPositionToTranslateY(t.getOptions().scrollPosition));var n=new e.ClipPath;n.addRect(0,t.getDatabodyStart(),t.getContentLength(),t.getDatabodyHeight()),i.setClipPath(n)},S._renderDnDArtifactsContainer=function(t,a){var i=t.getDatabody();if(i){var n=t.getDnDArtifactsContainer();null==n&&(n=new e.Container(t.getCtx()),t.setDnDArtifactsContainer(n),n.setTranslateY(i.getTranslateY())),a.addChild(n);var s=new e.ClipPath;s.addRect(0,t.getDatabodyStart(),t.getContentLength(),t.getDatabodyHeight()),n.setClipPath(s)}},S._renderMarqueeArtifactsContainer=function(t,a){var i=t.getDatabody();if(i){var n=t.getMarqueeArtifactsContainer();null==n&&(n=new e.Container(t.getCtx()),t.setMarqueeArtifactsContainer(n),n.setTranslateY(i.getTranslateY())),a.addChild(n);var s=new e.ClipPath;s.addRect(0,t.getDatabodyStart(),t.getContentLength(),t.getDatabodyHeight()),n.setClipPath(s);var r=t.getEventManager();if("multiple"===t.getOptions().selectionMode){var o=new e.Rectangle(1,1,t.getContentLength()-1,t.getContentHeight()-1),l=new e.SolidFill(""),h=new e.Stroke(""),d=new e.MarqueeHandler(n,o,o,l,h,!0,!0);r.setMarqueeSelectHandler(d)}}},S._renderScrollableCanvas=function(t){t._canvas||(t._canvas=new e.Container(t.getCtx(),"canvas"),t.addChild(t._canvas))},S._renderAxes=function(t,e,a){var i=t.getMajorAxis(),n=t.getMinorAxis(),s=t.getAxisPosition(),r=t.getOptions();if("top"===s){var o=0;i&&(S._renderAxis(t,e,i,o,t.getAxisHeight(r,"majorAxis"),a),o+=i.getSize()),n&&(S._renderAxis(t,e,n,o,t.getAxisHeight(r,"minorAxis"),a),o+=n.getSize()),t.setDatabodyStart(o)}else o=t._canvasSize,i&&(S._renderAxis(t,e,i,null,t.getAxisHeight(r,"majorAxis"),a),o-=i.getSize(),S._positionAxis(i,o)),n&&(S._renderAxis(t,e,n,o,t.getAxisHeight(r,"minorAxis"),a),o-=n.getSize(),S._positionAxis(n,o)),t.setDatabodyStart(0)},S._renderAxis=function(t,e,a,i,n,s){a.getParent()!==e&&e.addChild(a),a.render({_viewStartTime:t._viewStartTime,_viewEndTime:t._viewEndTime,_throttle:s},t.getContentLength(),n),null!=i&&S._positionAxis(a,i)},S._positionAxis=function(t,a){var i=new e.Matrix(1,0,0,1,0,a);t.setMatrix(i)},S._renderZoomControls=function(t){var a=t.getCtx(),i=t._resources,s=e.Agent.isRightToLeft(a),r={zoomInProps:{imageSize:16,class:i.zoomIn},zoomOutProps:{imageSize:16,class:i.zoomOut}};if(s)var o=t.getStartXOffset()+n._DEFAULT_ZOOM_CONTROL_PADDING;else o=t.getCanvasLength()+t.getStartXOffset()-(n._DEFAULT_ZOOM_CONTROL_PADDING+n._DEFAULT_ZOOM_CONTROL_DIAMETER);r.zoomInProps.posX=o,r.zoomOutProps.posX=o;var l=t._startY+n._DEFAULT_ZOOM_CONTROL_PADDING;if("top"===t.getAxisPosition())var h=l;else h=t._backgroundHeight-l;if("top"===t.getAxisPosition())var d=h,g=h+n._DEFAULT_ZOOM_CONTROL_DIAMETER+n._DEFAULT_ZOOM_CONTROL_SPACING;else d=h-2*n._DEFAULT_ZOOM_CONTROL_DIAMETER-n._DEFAULT_ZOOM_CONTROL_SPACING,g=h-n._DEFAULT_ZOOM_CONTROL_DIAMETER;r.zoomInProps.posY=d,r.zoomOutProps.posY=g,t.renderZoomControls(r)},S._renderEmptyText=function(t,a){if(a){var i=t.getDatabody();i&&i.getParent()&&(i.getParent().removeChild(i),t.setDatabody(null)),t.getDataLayoutManager().clear();var n=t.getOptions().translations.labelNoData;t.removeEmptyText()}else n=t.getOptions().translations.labelInvalidData,t.clearComponent();var s=t.getAxesHeight(),r=t.renderEmptyText(t._canvas,n,new e.Rectangle(t.getStartXOffset(),t.getStartYOffset()+s*("top"===t.getAxisPosition()),t.getCanvasLength(),t.getCanvasSize()-s),t.EventManager,null);r.setClassName(t.GetStyleClass("nodata")),t.setEmptyText(r)},S._renderDatabody=function(t,a){var i=t.getDatabody();null==i&&(i=new e.Container(t.getCtx(),"db"),a.addChild(i),t.setDatabody(i),i.setTranslateY(t.getDatabodyBackground().getTranslateY()));var n=new e.ClipPath;n.addRect(0,t.getDatabodyStart(),t.getContentLength(),t.getDatabodyHeight()),i.setClipPath(n)},S._renderVerticalGridline=function(t,a){var n=t.getVerticalGridlines();if(null!=n&&n.removeChildren(),t.isVerticalGridlinesVisible()){null==n&&(n=new e.Container(t.getCtx()),a.addChild(n),t.setVerticalGridlines(n));var s=t.GetStyleClass("vgridline"),r=t.getMajorAxis();(null==r||t.getOptions().minorGridline)&&(r=t.getMinorAxis());for(var o=t.getCtx(),l=e.Agent.isRightToLeft(o),h=t.getStartTime(),d=t.getEndTime(),g=t.getContentLength(),_=r.getViewportDates(r.getScale(),h,d),c=0;c<_.length;c++){var p=i.TimeAxisUtils.getDatePosition(h,d,_[c].getTime(),g);l&&(p=g-p);var u=new e.Line(t.getCtx(),p,t.getDatabodyStart(),p,t.getDatabodyStart()+t._canvasSize-t.getAxesHeight());u.setPixelHinting(!0),u.setClassName(s,!0),n.addChild(u)}}},S._renderReferenceObjects=function(t,a,i){var n="line"===i?t.getReferenceLinesContainer():t.getReferenceAreasContainer();null==n&&(n=new e.Container(t.getCtx()),a.addChild(n),"line"===i?t.setReferenceLinesContainer(n):t.setReferenceAreasContainer(n)),n.removeChildren();for(var s=function(t){return null!=t&&!isNaN(new Date(t).getTime())},r=t.getReferenceObjects().filter(function(t){return"line"===i?("line"===t.type||null==t.type)&&s(t.value):"area"===t.type&&s(t.start)&&s(t.end)}),o=0,l=0;l<r.length;){var h=r[l];(h.svgStyle||h.svgClassName||h.shortDesc)&&(new D(t,i,r.slice(o,l)).render(n),new D(t,i,[r[l]]).render(n),o=l+1),l+=1}new D(t,i,r.slice(o,l)).render(n)},S._renderData=function(t,e,a){var i=t.getOptions(),s=t.getRowLayoutObjs(),r=t.getDependencyLayoutObjs();if(0!==s.length){S._renderDatabody(t,e),r.length>0&&S._renderDependenciesContainer(t,e),t.getCache().getFromCache("baseTaskLabelCSSStyle")||t.getCache().putToCache("baseTaskLabelCSSStyle",n.getTaskLabelStyle(i)),t.setDataRegionTranslateY(t.getBoundedContentTranslateY(t.getDatabody().getTranslateY()));var o=!t.isInitialRender()&&t.isLastRenderValid()&&"none"!==t.getAnimationManager().getAnimationMode();t.renderViewport(o?b.VPC_ANIMATE:a,!0)}else S._renderEmptyText(t,!0)},S._renderDependenciesContainer=function(t,a){var i=t.getDependenciesContainer();null==i&&((i=new e.Container(t.getCtx())).setTranslateY(t.getDatabody().getTranslateY()),a.addChild(i),t.setDependenciesContainer(i),S._prepareDependencyMarkers(t));var n=new e.ClipPath;n.addRect(0,t.getDatabodyStart(),t.getContentLength(),t.getDatabodyHeight()),i.setClipPath(n)},S._prepareDependencyMarkers=function(t){if(!document.getElementById(n.getDependencyLineAngleMarkerId())){var e=S._createTriangleMarker(t),a=S._createAngleMarker(t);t.appendSharedDefs(e),t.appendSharedDefs(a)}},S._createTriangleMarker=function(t){var e=n.getDependencyLineTriangleMarkerId(),a=n.getDependencyLineTriangleMarkerWidth(),i=n.getDependencyLineTriangleMarkerHeight(),s="M0,0L"+a+","+i/2+",0,"+i+"V0Z";return this._createMarker(t,e,a,i,s)},S._createAngleMarker=function(t){var e=n.getDependencyLineAngleMarkerId(),a=n.getDependencyLineAngleMarkerWidth(),i=n.getDependencyLineAngleMarkerHeight(),s="M0,0L"+a+","+i/2+",0,"+i;return this._createMarker(t,e,a,i,s)},S._createMarker=function(t,a,i,n,s){var r=t.GetStyleClass("dependencyLineConnector"),o=e.SvgShapeUtils.createElement("marker",a);e.ToolkitUtils.setAttrNullNS(o,"class",r),e.ToolkitUtils.setAttrNullNS(o,"markerUnits","userSpaceOnUse");var l=e.SvgShapeUtils.createElement("path");return e.ToolkitUtils.setAttrNullNS(o,"viewBox","0 0 "+i+" "+n),e.ToolkitUtils.setAttrNullNS(o,"refX",i),e.ToolkitUtils.setAttrNullNS(o,"refY",n/2),e.ToolkitUtils.setAttrNullNS(o,"markerWidth",i),e.ToolkitUtils.setAttrNullNS(o,"markerHeight",n),e.ToolkitUtils.setAttrNullNS(o,"orient","auto"),e.ToolkitUtils.setAttrNullNS(l,"d",s),o.appendChild(l),o};const E=function(t,e,a){this.Init(t,e,a)};e.Obj.createSubclass(E,a.TimeComponent),E.newInstance=function(t,e,a){return new E(t,e,a)},E.prototype.Init=function(t,a,i){this._isInitialRender=!0,E.superclass.Init.call(this,t,a,i),this.Defaults=new m(t),this.EventManager=new h(this,t,a,i),this.EventManager.addListeners(this),e.Agent.isTouchDevice()?this._keyboardHandler=null:(this._keyboardHandler=new d(this,this.EventManager),this.EventManager.setKeyboardHandler(this._keyboardHandler))},E.prototype.SetOptions=function(t){null==t.taskDefaults&&(t.taskDefaults={baseline:{}}),null==t.taskDefaults.baseline&&(t.taskDefaults.baseline={}),null==t.taskDefaults.height&&(t.taskDefaults.height=n.getStandaloneTaskHeight(t)),null==t.taskDefaults.baseline.height&&(t.taskDefaults.baseline.height=n.getBaselineTaskHeight(t)),E.superclass.SetOptions.call(this,t),this.setSelectionMode(this.Options.selectionMode);var a=this.isTaskMoveEnabled(),i=this.isTaskResizeEnabled();if(a||i){this.Options.dnd=e.JsonUtils.merge(this.Options.dnd,{drag:{tasks:{dataTypes:[]},taskResizeHandles:{dataTypes:[]}},drop:{rows:{dataTypes:[]}}});var s=this,r=function(t,e){var a=s.Options.dnd.drag[e].dataTypes;Array.isArray(a)||(s.Options.dnd.drag[e].dataTypes=[a],a=s.Options.dnd.drag[e].dataTypes),a.push(t);var i=s.Options.dnd.drop.rows.dataTypes;Array.isArray(i)||(s.Options.dnd.drop.rows.dataTypes=[i],i=s.Options.dnd.drop.rows.dataTypes),i.push(t)};i&&r(h.RESIZE_TASKS_DATA_TYPE,"taskResizeHandles"),a&&r(h.MOVE_TASKS_DATA_TYPE,"tasks")}},E.prototype.getAutomation=function(){return this.Automation||(this.Automation=new y(this)),this.Automation},E.prototype.GetStyleClass=function(t){var e=this.getCtx().styleClasses;return null!=e?e[t]:t},E.prototype.Parse=function(t){return this._parser=new v,this._parser.parse(t)},E.prototype._applyParsedProperties=function(t){this._axisPosition=t.axisPosition,this._selectionMode=t.selectionMode,this._horizontalGridline=t.horizontalGridline,this._verticalGridline=t.verticalGridline,this._viewStartTime=t.viewStart,this._viewEndTime=t.viewEnd,this._rowsData=t.rows,this.isIRAnimationEnabled=t.isIRAnimationEnabled,this.isDCAnimationEnabled=t.isDCAnimationEnabled,this._rowAxisRendered=t.rowAxisRendered,this._rowAxisWidth=t.rowAxisWidth,this._rowAxisMaxWidth=t.rowAxisMaxWidth,this._referenceObjects=t.referenceObjects,E.superclass._applyParsedProperties.call(this,t)},E.prototype._bundleTimeAxisOptions=function(t,e){var a=this._resources;a.axisClass=this.GetStyleClass(e),a.axisSeparatorClass=this.GetStyleClass(e+"Ticks"),a.axisLabelClass=this.GetStyleClass(e+"Labels");var i,s={start:t.start,end:t.end,_resources:a,shortDesc:t.shortDesc,orientation:"horizontal"};if(t[e]){var r=t[e];r.scale&&(s.scale=r.scale),r.converter&&(s.converter=r.converter),r.zoomOrder&&(s.zoomOrder=r.zoomOrder)}return"majorAxis"===e?i=n.getMajorAxisLabelStyle(t):"minorAxis"===e&&(i=n.getMinorAxisLabelStyle(t)),s.labelStyle=i,s},E.prototype._getPreferredSize=function(t,a){return new e.Dimension(t,a)},E.prototype.render=function(t,e,a){if(this.getCache().clearCache(),t){E.superclass.render.call(this,t,e,a),this.isDndEnabled()?this.renderAriaLiveRegion():this.removeAriaLiveRegion(),this._animationManager=new f(this),this._animationManager.prepareForAnimations(),this._dataLayoutManager||(this._dataLayoutManager=new b(this)),this._dataLayoutManager.calcLayout(),S.renderRowAxis(this,this.getParent());var n=this.getAxisPosition();if(t.minorAxis){var s=this._bundleTimeAxisOptions(this.Options,"minorAxis");null==this._minorAxis&&(this._minorAxis=new i.TimeAxis(this.getCtx(),null,null),"top"===n?this._minorAxis.setBorderVisibility(!1,!1,!0,!1):this._minorAxis.setBorderVisibility(!0,!1,!1,!1),this._masterAxis=this._minorAxis),this._minorAxis.setCanvasSize(null);var r=this._minorAxis.getPreferredLength(s,this._canvasLength)}var o=t.majorAxis;if(o)if(o.scale){s=this._bundleTimeAxisOptions(this.Options,"majorAxis"),null==this._majorAxis&&(this._majorAxis=new i.TimeAxis(this.getCtx(),null,null),"top"===n?this._majorAxis.setBorderVisibility(!1,!1,!0,!1):this._majorAxis.setBorderVisibility(!0,!1,!1,!1),this._slaveAxis=this._majorAxis),this._majorAxis.setCanvasSize(null);var l=this._majorAxis.getPreferredLength(s,this._canvasLength);r&&l>r&&(this._masterAxis=this._majorAxis,this._slaveAxis=this._minorAxis,r=l)}else this._majorAxis=null;r&&this.setContentLength(r),this._minorAxis&&this._minorAxis.hasValidOptions()&&this.prepareViewportLength(),S.renderGantt(this),this._animationManager.triggerAnimations(),this.UpdateAriaAttributes(),this.Animation||this.RenderComplete(),this._renderState=null,this._isInitialRender=!1}else this._handleResize(e,a)},E.prototype.getAnimationManager=function(){return this._animationManager},E.prototype.getDataLayoutManager=function(){return this._dataLayoutManager},E.prototype.isRowsHierarchical=function(){var t=this.getOptions().taskData;return t&&t.getChildDataProvider||e.Agent.isEnvironmentTest()&&this.getOptions().expanded instanceof Set},E.prototype.getViewportYBounds=function(t){var e=this._backgroundHeight-this.getAxesHeight(),a=0;return null!=t?a=this._translateYToScrollPositionY(t):this._databody&&(a=this._translateYToScrollPositionY(this._databody.getTranslateY())),{yMin:a,yMax:a+e}},E.prototype.renderViewport=function(t,a){if(null!=this._databody){var i=this.getViewportYBounds(),n=this._dataLayoutManager.findRowIndRange(this.getRowLayoutObjs(),i.yMin,i.yMax),s={minRowInd:n.minRowInd,maxRowInd:n.maxRowInd,viewStartTime:this._viewStartTime,viewEndTime:this._viewEndTime};if(this._dataLayoutManager.renderViewport(s,t),a){var r=this._translateYToScrollPositionY(this._databody.getTranslateY()),o=r-this.getRowLayoutObjs()[s.minRowInd].y,l=e.EventFactory.newGanttScrollPositionChangeEvent(r,s.minRowInd,o);this.dispatchEvent(l)}}},E.prototype.isInitialRender=function(){return this._isInitialRender},E.prototype.isLastRenderValid=function(){return this._isLastRenderValid},E.prototype.setIsLastRenderValid=function(t){this._isLastRenderValid=t},E.prototype.getRenderState=function(){return this._renderState},E.prototype.setRenderState=function(t){this._renderState=t},E.prototype.isDndEnabled=function(){var t=this.isTaskMoveEnabled(),e=this.isTaskResizeEnabled();return this.getEventManager().isDndSupported()&&(t||e)},E.prototype.isTaskMoveEnabled=function(){var t=this.Options.dnd;return t&&t.move&&"enabled"===t.move.tasks},E.prototype.isTaskResizeEnabled=function(){var t=this.Options.taskDefaults;return t&&"enabled"===t.resizable},E.prototype.renderAriaLiveRegion=function(){if(!this._ariaLiveRegion){var t=this.getCtx();this._ariaLiveRegion=document.createElement("div"),this._ariaLiveRegion.id="_dvtGanttAriaLiveRegion"+t.getStage().getId(),this._ariaLiveRegion.setAttribute("aria-live","assertive"),this._ariaLiveRegion.style.clip="rect(1px, 1px, 1px, 1px)",this._ariaLiveRegion.style.height="1px",this._ariaLiveRegion.style.overflow="hidden",this._ariaLiveRegion.style.position="absolute",this._ariaLiveRegion.style.whiteSpace="nowrap",this._ariaLiveRegion.style.width="1px",t.getContainer().appendChild(this._ariaLiveRegion)}},E.prototype.getAriaLiveRegion=function(){return this._ariaLiveRegion},E.prototype.updateLiveRegionText=function(t){this._ariaLiveRegion&&(this._ariaLiveRegion.textContent=t)},E.prototype.removeAriaLiveRegion=function(){this._ariaLiveRegion&&(context.getContainer().removeChild(this._ariaLiveRegion),this._ariaLiveRegion=null)},E.prototype.scroll=function(t){if(this.getDatabody()){var e=this.scrollPositionToTranslateY(t);this.isContentDirScrollbarOn()&&this.contentDirScrollbar&&this.contentDirScrollbar.setViewportRange(e-this.getDatabodyHeight(),e),this.setDataRegionTranslateY(e),this.renderViewport(b.VPC_TRANSLATE,!0)}},E.prototype.scrollPositionToTranslateY=function(t){var e=t.rowIndex,a=this.getRowLayoutObjs(),i=0;if(null!=e){var n=a[e=Math.min(Math.max(0,e),a.length-1)];if(null!=n){var s=null!=t.offsetY?t.offsetY:0;i=n.y+s}}else null!=t.y&&(i=t.y);return this._scrollPositionYToTranslateY(i)},E.prototype._scrollPositionYToTranslateY=function(t){return this.getBoundedContentTranslateY(this.getDatabodyStart()-t)},E.prototype._translateYToScrollPositionY=function(t){return this._databody?-(t-this.getDatabodyStart()):0},E.prototype.setDataRegionTranslateY=function(t){this._databody&&this._databody.setTranslateY(t),this._databodyBackground&&this._databodyBackground.setTranslateY(t),this.isMarqueeSelectEnabled()&&this._marqueeArtifactsContainer&&this._marqueeArtifactsContainer.setTranslateY(t),this.isDndEnabled()&&this._dndArtifactsContainer&&this._dndArtifactsContainer.setTranslateY(t),this.isRowAxisEnabled()&&this.getRowAxis().setTranslateY(t+this.getStartYOffset()),this._dependenciesContainer&&this._dependenciesContainer.setTranslateY(t)},E.prototype.processScrollbarEvent=function(t,e){if(E.superclass.processScrollbarEvent.call(this,t,e),e===this.timeDirScrollbar&&S._renderAxes(this,this.getTimeZoomCanvas(),!0),e===this.contentDirScrollbar){var a=t.newMax;this.setDataRegionTranslateY(a,!0)}this.renderViewport(b.VPC_TRANSLATE,e===this.contentDirScrollbar)},E.prototype.createViewportChangeEvent=function(){var t=this._majorAxis?this._majorAxis.getScale():null,a=this._minorAxis?this._minorAxis.getScale():null;return e.EventFactory.newGanttViewportChangeEvent(this._viewStartTime,this._viewEndTime,t,a)},E.prototype._handleResize=function(t,e){this.Width=t,this.Height=e,this.applyStyleValues();var a=this.hasValidOptions();if(a&&S.renderRowAxis(this),this.prepareViewportLength(),S._renderBackground(this),a){this.renderTimeZoomCanvas(this._canvas),this.isRowAxisEnabled()&&this.getRowAxis().adjustPosition();var i=this.getTimeZoomCanvas();S._renderAxes(this,i),S._renderDatabodyBackground(this),S._renderReferenceObjects(this,i,"area"),S._renderVerticalGridline(this,i),S._renderData(this,null,b.VPC_SCALE),S._renderReferenceObjects(this,i,"line"),S._renderZoomControls(this),this.isMarqueeSelectEnabled()&&S._renderMarqueeArtifactsContainer(this,i),this.isDndEnabled()&&S._renderDnDArtifactsContainer(this,i),(this.isTimeDirScrollbarOn()||this.isContentDirScrollbarOn())&&S._renderScrollbars(this,this)}else S._renderEmptyText(this);this.Animation||this.RenderComplete()},E.prototype.applyStyleValues=function(){var t=e.Agent.isRightToLeft(this.getCtx()),a=this.getScrollbarPadding();this._borderWidth=n.getChartStrokeWidth(this.Options);var i=2*this._borderWidth;if(this._widthOffset=0,this.timeDirScrollbarStyles=this.getTimeDirScrollbarStyle(),this.contentDirScrollbarStyles=this.getContentDirScrollbarStyle(),this._backgroundWidth=this.Width,this._backgroundHeight=this.Height,this.isTimeDirScrollbarOn()&&(this._backgroundHeight=this._backgroundHeight-e.CSSStyle.toNumber(this.timeDirScrollbarStyles.getHeight())-3*a),this.isContentDirScrollbarOn()){var s=3*a+e.CSSStyle.toNumber(this.contentDirScrollbarStyles.getWidth());this._backgroundWidth=this._backgroundWidth-s,t&&(this._widthOffset=s)}this.setStartXOffset(this._widthOffset+this._borderWidth),this.setStartYOffset(this._borderWidth),this._canvasLength=this._backgroundWidth-i,this._canvasSize=this._backgroundHeight-i},E.prototype.getBorderWidth=function(){return this._borderWidth},E.prototype.HandleMouseWheel=function(t){if(E.superclass.HandleMouseWheel.call(this,t),this.hasValidOptions())if(!t||t.ctrlKey||e.Agent.isTouchDevice()){if(t.zoomWheelDelta){var i=this.getCtx().pageToStageCoords(t.pageX,t.pageY);if(this.getGraphicalAreaBounds().containsPoint(i.x,i.y)){var n=this.getContentLength()*t.zoomWheelDelta,s=t.zoomTime,r=t.zoomCompLoc;this.handleZoomWheel(n,s,r,!0)}}}else{var o=t.wheelDelta?t.wheelDelta*a.TimeComponent.SCROLL_LINE_HEIGHT:0,l=t.wheelDeltaX?t.wheelDeltaX*a.TimeComponent.SCROLL_LINE_HEIGHT:0;if(this.panBy(-l,-o),t.wheelDeltaX){var h=this.createViewportChangeEvent();this.dispatchEvent(h)}}},E.prototype.handleZoomWheel=function(t,e,a,i){t>this._masterAxis.getMaxContentLength()?(t=this._masterAxis.getMaxContentLength(),this.disableZoomButton(!0)):this.enableZoomButton(!0),this._canvasLength>t?(t=this._canvasLength,this.disableZoomButton(!1)):this.enableZoomButton(!1);var n=this.getContentLength()<=t;E.superclass.handleZoomWheel.call(this,t,e,a,i);var s=this._masterAxis.getZoomLevelLengths();if(n)for(;this._masterAxis.getZoomLevelOrder()>0&&(!this._slaveAxis||this._slaveAxis.getZoomLevelOrder()>0);){var r=s[this._masterAxis.getZoomLevelOrder()-1];if(!(this.getContentLength()>=r))break;this._masterAxis.setZoomLevelOrder(this._masterAxis.getZoomLevelOrder()-1),this._masterAxis.decreaseScale(),this._slaveAxis&&(this._slaveAxis.setZoomLevelOrder(this._slaveAxis.getZoomLevelOrder()-1),this._slaveAxis.decreaseScale())}else for(;this._masterAxis.getZoomLevelOrder()<s.length-1&&(!this._slaveAxis||this._slaveAxis.getZoomLevelOrder()<this._slaveAxis.getZoomLevelLengths().length-1)&&(r=s[this._masterAxis.getZoomLevelOrder()],this.getContentLength()<r);)this._masterAxis.setZoomLevelOrder(this._masterAxis.getZoomLevelOrder()+1),this._masterAxis.increaseScale(),this._slaveAxis&&(this._slaveAxis.setZoomLevelOrder(this._slaveAxis.getZoomLevelOrder()+1),this._slaveAxis.increaseScale());this.isTimeDirScrollbarOn()&&this.timeDirScrollbar&&this.timeDirScrollbar.setViewportRange(this._viewStartTime,this._viewEndTime);var o=this.getTimeZoomCanvas();if(S._renderAxes(this,o,!0),S._renderDatabodyBackground(this),S._renderReferenceObjects(this,o,"area"),S._renderVerticalGridline(this,o),S._renderData(this,null,b.VPC_SCALE),S._renderReferenceObjects(this,o,"line"),this.isMarqueeSelectEnabled()&&S._renderMarqueeArtifactsContainer(this,o),this.isDndEnabled()&&S._renderDnDArtifactsContainer(this,o),i){var l=this.createViewportChangeEvent();this.dispatchEvent(l)}},E.prototype.getMajorAxis=function(){return this._majorAxis},E.prototype.getMinorAxis=function(){return this._minorAxis},E.prototype.getTimeAxis=function(){return this._minorAxis?this._minorAxis:this._majorAxis},E.prototype.getDatabody=function(){return this._databody},E.prototype.setDatabody=function(t){this._databody=t},E.prototype.getDatabodyBackground=function(){return this._databodyBackground},E.prototype.setDatabodyBackground=function(t){this._databodyBackground=t},E.prototype.getDatabodyStart=function(){return this._databodyStart},E.prototype.setDatabodyStart=function(t){this._databodyStart=t},E.prototype.getDatabodyHeight=function(){return this.getCanvasSize()-this.getAxesHeight()},E.prototype.getVerticalGridlines=function(){return this._gridlines},E.prototype.setVerticalGridlines=function(t){this._gridlines=t},E.prototype.getReferenceObjects=function(){return this._referenceObjects||[]},E.prototype.getReferenceLinesContainer=function(){return this._refLinesContainer},E.prototype.setReferenceLinesContainer=function(t){this._refLinesContainer=t},E.prototype.getReferenceAreasContainer=function(){return this._refAreasContainer},E.prototype.setReferenceAreasContainer=function(t){this._refAreasContainer=t},E.prototype.getMarqueeArtifactsContainer=function(){return this._marqueeArtifactsContainer},E.prototype.setMarqueeArtifactsContainer=function(t){this._marqueeArtifactsContainer=t},E.prototype.getDnDArtifactsContainer=function(){return this._dndArtifactsContainer},E.prototype.setDnDArtifactsContainer=function(t){this._dndArtifactsContainer=t},E.prototype.setEmptyText=function(t){this._emptyText=t},E.prototype.removeEmptyText=function(){this._emptyText&&this._emptyText.getParent()&&(this._emptyText.getParent().removeChild(this._emptyText),delete this._emptyText,this._emptyText=null)},E.prototype.getRowsData=function(){return this._rowsData},E.prototype.getRowLayoutObjs=function(){return this._dataLayoutManager.getRowObjs()},E.prototype.getDependencyLayoutObjs=function(){return this._dataLayoutManager.getDependencyObjs()},E.prototype.setRows=function(t){this._rows=t},E.prototype.getCurrentRow=function(){return this._currentRow},E.prototype.setCurrentRow=function(t){this._currentRow=t},E.prototype.getAxisPosition=function(){return this._axisPosition},E.prototype.getAxisHeight=function(t,e){return n.getTimeAxisHeight(t,e)},E.prototype.getStartTime=function(){return this._start},E.prototype.getEndTime=function(){return this._end},E.prototype.getHoverBehavior=function(){return"none"},E.prototype.isHorizontalGridlinesVisible=function(){return"visible"===this._horizontalGridline},E.prototype.isVerticalGridlinesVisible=function(){return"visible"===this._verticalGridline},E.prototype.getContentHeight=function(){return this._dataLayoutManager.getContentHeight()},E.prototype.getAxesHeight=function(){var t=0;return this._majorAxis&&(t+=this._majorAxis.getSize()),this._minorAxis&&(t+=this._minorAxis.getSize()),t},E.prototype.isRowAxisEnabled=function(){return"on"===this._rowAxisRendered},E.prototype.getRowAxisWidth=function(){return this._rowAxisWidth},E.prototype.getRowAxisMaxWidth=function(){return this._rowAxisMaxWidth},E.prototype.getRowAxis=function(){return this._rowAxis},E.prototype.setRowAxis=function(t){this._rowAxis=t},E.prototype.getViewportDimensions=function(){return new e.Rectangle(this.getStartXOffset()-this.getTimeZoomCanvas().getTranslateX(),this._databodyStart-this._databody.getTranslateY(),this._canvasLength,this._canvasSize-this.getAxesHeight())},E.prototype.scrollIntoView=function(t,a,i,n){var s=e.Agent.isRightToLeft(this.getCtx()),r=this.getViewportDimensions(),o=0,l=0;a=a||"auto",i=i||"auto",n=n||0;var h=Math.min(t.x-r.x-n,0),d=Math.max(0,t.x+t.w-(r.x+r.w)+n),g=s?d:h,_=s?h:d;switch(a){case"start":o=g;break;case"end":o=_;break;default:o=(s?_<0:_>0)?_:g}var c=Math.min(t.y-r.y-n,0),p=Math.max(0,t.y+t.h-(r.y+r.h)+n);switch(i){case"top":l=c;break;case"bottom":l=p;break;default:l=c<0?c:p}this.panBy(o,l,!0)},E.prototype.autoPanOnEdgeDrag=function(t,e,a,i){var n=this.getViewportDimensions(),s=0,r=0;if(!a){var o=Math.max(t.x-n.x,0),l=Math.max(n.x+n.w-t.x,0);o<e?(s=o-e,s=Math.max(s,-n.x)):l<e&&(s=e-l,s=Math.min(s,this.getContentLength()-(n.x+n.w)))}if(!i){var h=Math.max(t.y-n.y,0),d=Math.max(n.y+n.h-t.y,0);h<e?(r=h-e,r=Math.max(r,-n.y)):d<e&&(r=e-d,r=this.getContentHeight()+this._databodyStart>=this._canvasSize?"bottom"===this.getAxisPosition()?Math.min(r,this._databody.getTranslateY()+this.getContentHeight()-n.h):Math.min(r,this._databody.getTranslateY()+this.getContentHeight()-this._canvasSize):Math.min(r,-n.y))}return this.panBy(s,r,!0),{deltaX:s,deltaY:r}},E.prototype.panBy=function(t,e,a){if(0!==t||0!==e){a=void 0!==a?a:"alta"!==this.getCtx().getThemeBehavior();var i=0!==t&&(a||Math.abs(t)>Math.abs(e)),n=this._databody&&0!==e&&(a||Math.abs(e)>Math.abs(t));if(i&&E.superclass.panBy.call(this,t,0),n){var s=this.getBoundedContentTranslateY(this._databody.getTranslateY()-e);this.isContentDirScrollbarOn()&&this.contentDirScrollbar.setViewportRange(s-this.getDatabodyHeight(),s),this.setDataRegionTranslateY(s,!0)}this.isTimeDirScrollbarOn()&&this.timeDirScrollbar&&this.timeDirScrollbar.setViewportRange(this._viewStartTime,this._viewEndTime),this.renderViewport(b.VPC_TRANSLATE,n),i&&S._renderAxes(this,this.getTimeZoomCanvas(),!0)}},E.prototype.getBoundedContentTranslateY=function(t){var e=this.getContentHeight();if(null==e)return t;var a=this.getDatabodyHeight(),i=this.getDatabodyStart(),n=i+Math.min(0,a-e);return Math.min(i,Math.max(t,n))},E.prototype.beginDragPan=function(t,e){E.superclass.beginDragPan.call(this,t,e),this._currentViewStartTime=this._viewStartTime,this._currentViewEndTime=this._viewEndTime},E.prototype.endDragPan=function(t,e){this._currentViewStartTime===this._viewStartTime&&this._currentViewEndTime===this._viewEndTime&&(this._triggerViewportChange=!1),E.superclass.endDragPan.call(this,t,e)},E.prototype.setTaskBrightness=function(t,e){null!=(t=this.findTaskNodeById(t.getId()))&&(e?t.darken():t.brighten())},E.prototype.findTaskNodeById=function(t){var a=this.getCtx(),i=this.getRows();if(i)for(var n=0;n<i.length;n++)for(var s=i[n].getTasks(),r=0;r<s.length;r++)if(e.Obj.compareValues(a,t,s[r].getId()))return s[r];return null},E.prototype.hasValidOptions=function(){var t=!this._majorAxis||this._majorAxis.hasValidOptions(),e=this._minorAxis&&this._minorAxis.hasValidOptions(),a=this._start&&this._end&&this._end>this._start,i=!this._viewStartTime||!this._viewEndTime||this._viewEndTime>this._viewStartTime,n=!this._viewStartTime||this._viewStartTime>=this._start&&this._viewStartTime<this._end,s=!this._viewEndTime||this._viewEndTime>this._start&&this._viewEndTime<=this._end;return t&&e&&a&&i&&n&&s},E.prototype.getSelectionHandler=function(){return this._selectionHandler},E.prototype.isSelectionSupported=function(){return!!this._selectionHandler},E.prototype.setSelectionMode=function(t){this._selectionHandler="single"===t?new e.SelectionHandler(this.getCtx(),e.SelectionHandler.TYPE_SINGLE):"multiple"===t?new e.SelectionHandler(this.getCtx(),e.SelectionHandler.TYPE_MULTIPLE):null,this.getEventManager().setSelectionHandler(this._selectionHandler)},E.prototype.select=function(t){this.isLastRenderValid()&&(this.Options.selection=e.JsonUtils.clone(t),this._processInitialSelections())},E.prototype._processInitialSelections=function(){var t=this.Options.selection;if(null!=t&&0!==t.length&&this.isSelectionSupported()){for(var e=new this._context.KeySetImpl(t),a=this.getRowLayoutObjs(),i=[],n=0;n<a.length;n++)for(var s=a[n].taskObjs,r=0;r<s.length;r++){var o=s[r];if(e.has(o.id)){this._dataLayoutManager.ensureInDOM(o,"task");var l=o.node;i.push(l)}}this.getSelectionHandler().processInitialSelections(t,i)}},E.prototype.getDependenciesContainer=function(){return this._dependenciesContainer},E.prototype.setDependenciesContainer=function(t){this._dependenciesContainer=t},E.prototype.setDefaultMarkerId=function(t){this._markerId=t},E.prototype.getDefaultMarkerId=function(){return this._markerId},E.prototype.getNavigableDependencyLinesForTask=function(t,e){return"successor"===e?t.getSuccessorDependencies():t.getPredecessorDependencies()},E.prototype.HandleTouchStart=function(t){},t.Gantt=E,Object.defineProperty(t,"__esModule",{value:!0})});
//# sourceMappingURL=ojgantt-toolkit.js.map