/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojcore-base","jquery","ojs/ojcomponentcore","ojs/ojlogger","ojs/ojdomutils","ojs/ojpreact-patch","jqueryui-amd/position","ojs/ojcontext","preact"],function(e,t,o,i,r,n,s,a,l,p){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,o=o&&Object.prototype.hasOwnProperty.call(o,"default")?o.default:o,l=l&&Object.prototype.hasOwnProperty.call(l,"default")?l.default:l;const c=function(e){this._tapCallback=e,this.Init()};t._registerLegacyNamespaceProp("SimpleTapRecognizer",c),t.Object.createSubclass(c,t.Object,"oj.SimpleTapRecognizer"),c.prototype.Init=function(){c.superclass.Init.call(this);var e=this._eventHandler.bind(this);this._eventHandlerCallback=e;for(var t,o=document.documentElement,i=0;i<c._TOUCHEVENTS.length;i++)"touchstart"===(t=c._TOUCHEVENTS[i])||"touchmove"===t?o.addEventListener(t,e,{passive:!1,capture:!0}):o.addEventListener(t,e,!0)},c.prototype._eventHandler=function(e){var t=this._tapCallback,o=e.type;if("touchstart"===o)this._touchStartEvent=e,this._touchStartEvent._tapStart=(new Date).getTime();else if("touchmove"===o||"touchcancel"===o)this._touchStartEvent=null;else if("touchend"===o){if(this._touchStartEvent){var i=this._touchStartEvent._tapStart;if(isNaN(i))t(this._touchStartEvent);else(new Date).getTime()-i<c._PRESSHOLDTHRESSHOLD&&t(this._touchStartEvent)}this._touchStartEvent=null}},c.prototype.destroy=function(){this._tapCallback=null;var e=this._eventHandlerCallback;this._eventHandlerCallback=null;for(var t,o=document.documentElement,i=0;i<c._TOUCHEVENTS.length;i++)"touchstart"===(t=c._TOUCHEVENTS[i])||"touchmove"===t?o.removeEventListener(t,e,{passive:!1,capture:!0}):o.removeEventListener(t,e,!0)},c._TOUCHEVENTS=["touchstart","touchmove","touchcancel","touchend"],c._PRESSHOLDTHRESSHOLD=700;const u=function(){this.Init()};t._registerLegacyNamespaceProp("PopupService",u),t.Object.createSubclass(u,t.Object,"oj.PopupService");const _=function(){this.Init()},E={};u.prototype.Init=function(){u.superclass.Init.call(this)},u.getInstance=function(e){return u._popupService||(u._popupService=new _),u._popupService},u.prototype.open=function(e){t.Assert.failedInAbstractFunction()},u.prototype.close=function(e){t.Assert.failedInAbstractFunction()},u.prototype.changeOptions=function(e){t.Assert.failedInAbstractFunction()},u.prototype.triggerOnDescendents=function(e,o,i){t.Assert.failedInAbstractFunction()},u.prototype.destroy=function(){u._popupService=null},u.MODALITY={NONE:"none",MODAL:"modal",MODELESS:"modeless"},u.EVENT={POPUP_REMOVE:"ojPopupRemove",POPUP_CLOSE:"ojPopupClose",POPUP_REFRESH:"ojPopupRefresh",POPUP_AUTODISMISS:"ojPopupAutoDismiss",POPUP_BEFORE_OPEN:"ojPopupBeforeOpen",POPUP_AFTER_OPEN:"ojPopupAfterOpen",POPUP_BEFORE_CLOSE:"ojPopupBeforeClose",POPUP_AFTER_CLOSE:"ojPopupAfterClose"},u.LAYER_LEVEL={TOP_LEVEL:"topLevel",NEAREST_ANCESTOR:"nearestAncestor"},u.OPTION={POPUP:"popup",EVENTS:"events",MODALITY:"modality",LAUNCHER:"launcher",POSITION:"position",LAYER_SELECTORS:"layerSelectors",LAYER_LEVEL:"layerLevel",CONTEXT:"context",CUSTOM_ELEMENT:"customElement"},t.__registerWidget("oj.ojSurrogate",o.oj.baseComponent,{version:"1.0.0",widgetEventPrefix:"oj",options:{beforeDestroy:null},_ComponentCreate:function(){this._super(),this.element.uniqueId()},_invokeBeforeDestroy:function(){var e=this.options.beforeDestroy;this.options.beforeDestroy=null,e&&e()},_destroy:function(){this._invokeBeforeDestroy(),this.element.removeUniqueId(),this._super()},_NotifyDetached:function(){this._invokeBeforeDestroy(),this._super()}});t.CustomElementBridge.register("oj-surrogate",{metadata:{properties:{beforeDestroy:{type:"function"}},extension:{_WIDGET_NAME:"ojSurrogate"}}}),t._registerLegacyNamespaceProp("PopupServiceImpl",_),t.Object.createSubclass(_,u,"oj.PopupServiceImpl"),_.prototype.open=function(e){t.Assert.assertObject(e);var s=e[u.OPTION.POPUP];t.Assert.assertPrototype(s,o);var a=E.getStatus(s);if(a===E.STATUS.UNKNOWN||a===E.STATUS.BEFORE_OPEN||a===E.STATUS.CLOSE){var l=e[u.OPTION.LAUNCHER];t.Assert.assertPrototype(l,o);var p=e[u.OPTION.POSITION];t.Assert.assertObjectOrNull(p);var c=e[u.OPTION.EVENTS];t.Assert.assertObject(c);var f=e[u.OPTION.MODALITY];(!f||u.MODALITY.MODELESS!==f&&u.MODALITY.MODAL!==f)&&(f=u.MODALITY.NONE);var h=e[u.OPTION.LAYER_SELECTORS];t.Assert.assertString(h);var d=e[u.OPTION.CUSTOM_ELEMENT],T=e[u.OPTION.LAYER_LEVEL];(!T||u.LAYER_LEVEL.TOP_LEVEL!==T&&u.LAYER_LEVEL.NEAREST_ANCESTOR!==T)&&(T=u.LAYER_LEVEL.NEAREST_ANCESTOR);var v=c[u.EVENT.POPUP_BEFORE_OPEN];v&&o.isFunction(v)||(v=_._defaultBeforeOpenCallback);var O=c[u.EVENT.POPUP_AFTER_OPEN];E.setStatus(s,E.STATUS.OPENING),n.setLogicalParent(s,l),E.addToAncestorLayer(s,l,f,h,T,d);var g,S=function(){try{s.removeAttr("aria-hidden"),this._assertEventSink(),i.subtreeShown(s[0])}catch(e){r.error("Error opening popup:\n%o",e)}finally{E.setStatus(s,E.STATUS.OPEN),O&&O(e);var n=E.getFirstAncestorLayer(s);if(t.Assert.assertPrototype(n,o),E.applyEvents(n,c),!E._getSurrogate(n)&&o.isFunction(c[u.EVENT.POPUP_REMOVE]))(0,c[u.EVENT.POPUP_REMOVE])()}};S=S.bind(this);try{g=v(e)}catch(e){r.error("Error before open popup:\n%o",e)}finally{g&&g instanceof Promise?g.then(S):S()}}else this._assertEventSink()},_._defaultBeforeOpenCallback=function(e){var i=e[u.OPTION.POPUP];t.Assert.assertPrototype(i,o);var r=e[u.OPTION.POSITION];i.show(),r&&i.position(r)},_.prototype.close=function(e){t.Assert.assertObject(e);var s=e[u.OPTION.POPUP];t.Assert.assertPrototype(s,o);var a=E.getOpenPopupLayer(s);t.Assert.assertPrototype(a,o);var l=e[u.OPTION.EVENTS];l?l=o.extend(E.getEvents(a),l):(l=E.getEvents(a),e[u.OPTION.EVENTS]=l);var p=E.getStatus(s);if(p!==E.STATUS.OPEN&&p!==E.STATUS.BEFORE_CLOSE||!l)this._assertEventSink();else{var c=l[u.EVENT.POPUP_BEFORE_CLOSE];c&&o.isFunction(c)||(c=_._defaultBeforeCloseCallback);var f=l[u.EVENT.POPUP_AFTER_CLOSE];E.setStatus(s,E.STATUS.CLOSING),E.applyEvents(a,{}),s.attr("aria-hidden","true");var h,d=function(){try{s.hide(),s.css({top:"auto",bottom:"auto",left:"auto",right:"auto"}),E.removeFromAncestorLayer(s),n.setLogicalParent(s,null),this._assertEventSink(),i.subtreeHidden(s[0])}catch(e){r.error("Error closing popup:\n%o",e)}finally{E.setStatus(s,E.STATUS.CLOSE),f&&o.isFunction(f)&&f(e)}};d=d.bind(this);try{h=c(e)}catch(e){r.error("Error before close popup:\n%o",e)}finally{h&&h instanceof Promise?h.then(d):d()}}},_._defaultBeforeCloseCallback=function(e){var i=e[u.OPTION.POPUP];t.Assert.assertPrototype(i,o),i.hide()},_.prototype.changeOptions=function(e){t.Assert.assertObject(e);var i=e[u.OPTION.POPUP];if(t.Assert.assertPrototype(i,o),E.getStatus(i)===E.STATUS.OPEN){var r=E.getOpenPopupLayer(i);t.Assert.assertPrototype(r,o);var n=e[u.OPTION.EVENTS];n&&E.applyEvents(r,n);var s=e[u.OPTION.MODALITY];s&&E.applyModality(r,s);var a=e[u.OPTION.LAYER_SELECTORS];t.StringUtils.isEmptyOrUndefined(a)||r.attr("class",a)}},_.prototype.triggerOnDescendents=function(e,t,o){if(E.isPopupOpen(e)){var i={};i.event=t,i.argsArray=o;var r=E.getFirstAncestorLayer(e);E.postOrderVisit(r,this._triggerOnDescendentsVisitCallback,i)}},_.prototype._triggerOnDescendentsVisitCallback=function(e,t){var i=t.event,r=t.argsArray,n=E.getEvents(e);return n&&o.isFunction(n[i])&&n[i].apply(this,r),E.VISIT_RESULT.ACCEPT},_.prototype._assertEventSink=function(){var e,t,o,i=E.hasPopupsOpen(),r=this._callbackEventFilter;if(!i&&r){for(window.removeEventListener("resize",_._refreshCallback,!0),window.removeEventListener("scroll",_._refreshCallback,!0),(t=document.documentElement).removeEventListener("mousewheel",_._refreshCallback,{passive:!0,capture:!0}),t.removeEventListener("DOMMouseScroll",_._refreshCallback,!0),this._callbackEventFilter=null,e=0;e<_._REDISTRIBUTE_EVENTS.length;e++)o=_._REDISTRIBUTE_EVENTS[e],t.removeEventListener(o,r,!0);var s=this._simpleTapRecognizer;s&&(s.destroy(),this._simpleTapRecognizer=null)}else if(i&&!r){for(window.addEventListener("resize",_._refreshCallback,!0),window.addEventListener("scroll",_._refreshCallback,!0),(t=document.documentElement).addEventListener("mousewheel",_._refreshCallback,{passive:!0,capture:!0}),t.addEventListener("DOMMouseScroll",_._refreshCallback,!0),r=this._eventFilterCallback.bind(this),this._callbackEventFilter=r,e=0;e<_._REDISTRIBUTE_EVENTS.length;e++)o=_._REDISTRIBUTE_EVENTS[e],t.addEventListener(o,r,!0);n.isTouchSupported()&&(this._simpleTapRecognizer=new c(r))}},_.prototype._eventFilterCallback=function(e){var t=o(e.target);if(E.hasPopupsOpen()){if(!n.isChromeEvent(e)&&("focus"!==e.type||t.is(":focusable"))){var i=E.getDefaultLayer();if("keydown"!==e.type||!E.hasModalDialogOpen()||n.isAncestor(i[0],t[0])){var r=E.getFirstAncestorLayer(t),s=i.find("."+_._FOCUS_WITHIN_SELECTOR).first();if(i[0]!==r[0]?r.hasClass(_._FOCUS_WITHIN_SELECTOR)||(s.length&&s.removeClass(_._FOCUS_WITHIN_SELECTOR),r.addClass(_._FOCUS_WITHIN_SELECTOR)):s.length&&s.removeClass(_._FOCUS_WITHIN_SELECTOR),"focus"!==e.type||"-1"!==t.attr("tabindex")){for(var a={},l=_._COPY_SAFE_EVENT_PROPERTIES,p={},c=0;c<l.length;c++){var u=l[c],f=e[u];void 0===f||o.isFunction(f)||(p[u]=f)}a.event=o.Event(e,p),E.postOrderVisit(i,_._redistributeVisitCallback,a)}}else E.eatEvent(e)}}else this._assertEventSink()},_._redistributeVisitCallback=function(e,t){var i=E.getEvents(e),r=t.event;return i&&o.isFunction(i[u.EVENT.POPUP_AUTODISMISS])&&i[u.EVENT.POPUP_AUTODISMISS](r),E.VISIT_RESULT.ACCEPT},_._refreshCallback=function(e){isNaN(_._refreshTimerId)&&(_._refreshTimerId=window.setTimeout(function(){_._refreshTimerId=Number.NaN;var e=E.getDefaultLayer();o.isFunction(window.requestAnimationFrame)?_._afRequestId=window.requestAnimationFrame(function(){_._afRequestId=null,E.postOrderVisit(e,_._refreshVisitCallback)}):E.postOrderVisit(e,_._refreshVisitCallback)},_._REFRESH_DELAY))},_._refreshVisitCallback=function(e,t){if(t.level>0)return E.VISIT_RESULT.REJECT;var i=E.getEvents(e);return i&&o.isFunction(i[u.EVENT.POPUP_REFRESH])&&i[u.EVENT.POPUP_REFRESH](),E.VISIT_RESULT.ACCEPT},_.prototype.destroy=function(){_.superclass.destroy.call(this)},_._FOCUS_WITHIN_SELECTOR="oj-focus-within",_._REDISTRIBUTE_EVENTS=["focus","mousedown","keydown"],_._COPY_SAFE_EVENT_PROPERTIES=["altKey","bubbles","cancelable","ctrlKey","currentTarget","eventPhase","metaKey","relatedTarget","shiftKey","target","timeStamp","view","which","button","buttons","clientX","clientY","offsetX","offsetY","pageX","pageY","screenX","screenY","toElement","char","charCode","key","keyCode"],_._REFRESH_DELAY=10,t._registerLegacyNamespaceProp("ZOrderUtils",E),E.STATUS={UNKNOWN:0,BEFORE_OPEN:.5,OPENING:1,OPEN:2,BEFORE_CLOSE:2.5,CLOSING:3,CLOSE:4},E._STATUS_DATA="oj-popup-status",E.getStatus=function(e){e instanceof Element&&(e=o(e));var t=e.data(E._STATUS_DATA);return isNaN(t)?E.STATUS.UNKNOWN:t},E.setStatus=function(e,t){e instanceof Element&&(e=o(e)),t>E.STATUS.UNKNOWN&&t<=E.STATUS.CLOSE&&e.data(E._STATUS_DATA,t)},E.getFirstAncestorLayer=function(e){if(!e)return E.getDefaultLayer();for(var t=e;t&&t.length>0&&t.attr(E._SURROGATE_ATTR)!==E._DEFAULT_LAYER_ID;){if(E._hasSurrogate(t[0]))return t;t=t.parent()}return E.getDefaultLayer()},E.getDefaultLayer=function(){var e=o(document.getElementById(E._DEFAULT_LAYER_ID));return e.length>0||((e=o("<div>")).attr("role","presentation"),e.attr("id",E._DEFAULT_LAYER_ID),e.prependTo(o(document.body))),e},E.addToAncestorLayer=function(e,r,n,s,a,l){var p=e[0];if(E._hasSurrogate(p.parentNode))throw new Error("JET Popup is already open - id: "+p.getAttribute("id"));var c=E.getFirstAncestorLayer(a===u.LAYER_LEVEL.TOP_LEVEL?null:r),_=o("<div>"),f=e.attr("id");t.StringUtils.isEmptyOrUndefined(f)?_.uniqueId():_.attr("id",[f,"layer"].join("_")),_.attr("role","presentation"),_.addClass(s),e.after(_);const h=E._createSurrogate(_,l);i.subtreeDetached(p),e.appendTo(_),e.data(E._LAYER_ID_DATA,_.attr("id")),_.appendTo(c),i.subtreeAttached(p),E._applyVDomPatch(h[0],p),E.applyModality(_,n)},E._applyVDomPatch=function(e,t){e[s.OJ_POPUP]=t,s.patchPopupParent(e.parentElement)},E._getSurrogate=function(e){var t=e.attr(E._SURROGATE_ATTR);if(t)return document.getElementById(t)},E.applyEvents=function(e,t,r){r||(r=o(E._getSurrogate(e))),e.data(E._EVENTS_DATA,t),r.length>0&&t&&o.isFunction(t[u.EVENT.POPUP_REMOVE])&&i.setComponentOption(r[0],"beforeDestroy",t[u.EVENT.POPUP_REMOVE])},E.getEvents=function(e){return e.data(E._EVENTS_DATA)},E._createSurrogate=function(e,i){var r="script";i&&(r="oj-surrogate");var n=o(document.createElement(r)),s=e.attr("id");t.StringUtils.isEmptyOrUndefined(s)||n.attr("id",[s,"surrogate"].join("_")),i&&n.attr("data-oj-binding-provider","none"),n.insertBefore(e),i||n.ojSurrogate();var a=n.attr("id");return e.attr(E._SURROGATE_ATTR,a),n},E._removeSurrogate=function(e){var t=e.attr(E._SURROGATE_ATTR);e.removeAttr(E._SURROGATE_ATTR);var r=o(document.getElementById(t)),n=r.length>0;return n&&(e.insertAfter(r),i.setComponentOption(r[0],"beforeDestroy",null),r.remove()),n},E.getOpenPopupLayer=function(e){var t=e.parent();if(!t||0===t.length){var i=e.data(E._LAYER_ID_DATA);t=o(document.getElementById(i))}return t},E.removeFromAncestorLayer=function(e){var t=E.getOpenPopupLayer(e);E.preOrderVisit(t,E._closeDescendantPopupsCallback),E._removeOverlayFromAncestorLayer(t),t.removeData(E._EVENTS_DATA),t.removeData(E._MODALITY_DATA),e.removeData(E._LAYER_ID_DATA);var o=e[0];i.subtreeDetached(o),E._removeSurrogate(t)&&o&&o.parentElement?(n.unwrap(e,t),i.subtreeAttached(o)):t.remove()},E._closeDescendantPopupsCallback=function(e,t){if(t.level>0)return E.VISIT_RESULT.REJECT;var i=e.data(E._EVENTS_DATA);return i&&o.isFunction(i[u.EVENT.POPUP_CLOSE])&&i[u.EVENT.POPUP_CLOSE](),E.VISIT_RESULT.ACCEPT},E.applyModality=function(e,o){var i=e.data(E._MODALITY_DATA);e.data(E._MODALITY_DATA,o),t.StringUtils.isEmptyOrUndefined(i)?u.MODALITY.MODAL===o?E._addOverlayToAncestorLayer(e):E._removeOverlayFromAncestorLayer(e):i!==o&&(o!==i&&o===u.MODALITY.MODAL?E._addOverlayToAncestorLayer(e):E._removeOverlayFromAncestorLayer(e)),o===u.MODALITY.MODAL?e.attr("aria-modal","true"):e.removeAttr("aria-modal")},E.hasModalDialogOpen=function(){for(var e=E.getDefaultLayer().children(),t=e.length-1;t>-1;t--){if(o(e[t]).hasClass(E._OVERLAY_SELECTOR))return!0}return!1},E._addOverlayToAncestorLayer=function(e){var i=o("<div>");i.addClass(E._OVERLAY_SELECTOR),i.addClass(e[0].className),i.attr("role","presentation");var r=e.attr("id");t.StringUtils.isEmptyOrUndefined(r)?i.uniqueId():i.attr("id",[r,"overlay"].join("_")),e.before(i);var n=i.attr("id");e.attr(E._OVERLAY_ATTR,n)},E._removeOverlayFromAncestorLayer=function(e){var i=e.attr(E._OVERLAY_ATTR);t.StringUtils.isEmptyOrUndefined(i)||(e.removeAttr(E._OVERLAY_ATTR),o(document.getElementById(i)).remove())},E.VISIT_RESULT={ACCEPT:0,REJECT:1,COMPLETE:2},E._VISIT_TRAVERSAL={PRE_ORDER:0,POST_ORDER:1},E.postOrderVisit=function(e,t,o){var i=o;o||(i={}),i.level=0,i.type=E._VISIT_TRAVERSAL.POST_ORDER,E._visitTree(e,t,i)},E.preOrderVisit=function(e,t,o){var i=o;o||(i={}),i.level=0,i.type=E._VISIT_TRAVERSAL.PRE_ORDER,E._visitTree(e,t,i)},E._visitTree=function(e,t,i){for(var r=i.level,n=e.children(),s=n.length-1;s>-1;s--){var a=o(n[s]);if(E._hasSurrogate(a[0])){var l;if(i.type===E._VISIT_TRAVERSAL.PRE_ORDER){if((l=t(a,i))===E.VISIT_RESULT.COMPLETE)return l;if(l===E.VISIT_RESULT.REJECT)break}if(i.level=r+1,l=E._visitTree(a,t,i),i.level=r,l===E.VISIT_RESULT.COMPLETE)return l;if(i.type===E._VISIT_TRAVERSAL.POST_ORDER){if((l=t(a,i))===E.VISIT_RESULT.COMPLETE)return l;if(l===E.VISIT_RESULT.REJECT)break}}}return E.VISIT_RESULT.ACCEPT},E._hasSurrogate=function(e){return!(!e||1!==e.nodeType||!e.hasAttribute(E._SURROGATE_ATTR))},E.hasPopupsOpen=function(){return E.getDefaultLayer().children().length>0},E.getOpenPopupCount=function(){var e={popupCount:0},t=E.getDefaultLayer();return E.preOrderVisit(t,E._openPopupCountCallback,e),e.popupCount},E._openPopupCountCallback=function(e,t){return t.popupCount+=1,E.VISIT_RESULT.ACCEPT},E.findOpenPopups=function(){var e={},t=[];e.popups=t;var i=E.getDefaultLayer();return E.preOrderVisit(i,E._openPopupsCallback,e),t=e.popups,o(t)},E._openPopupsCallback=function(e,t){return t.popups.push(e[0]),E.VISIT_RESULT.ACCEPT},E.isAboveTopModalLayer=function(e){if(!e||!E.hasPopupsOpen())return!0;var t=function(){var e={topLayer:null},t=E.getDefaultLayer();if(E.preOrderVisit(t,function(e,t){if(t.level>0)return E.VISIT_RESULT.REJECT;var i=t.topLayer;return i?E.compareStackingContexts(o(e),o(i))>0&&(t.topLayer=e):t.topLayer=e,E.VISIT_RESULT.ACCEPT},e),e.topLayer)return e.topLayer[0]}();if(!t)return!0;var i=function(e){var t={topModalPopup:null};if(e.hasAttribute(E._OVERLAY_ATTR)&&(t.topModalPopup=o(e)),E.postOrderVisit(o(e),function(e,t){return e[0].hasAttribute(E._OVERLAY_ATTR)?(t.topModalPopup=e,E.VISIT_RESULT.COMPLETE):E.VISIT_RESULT.ACCEPT},t),t.topModalPopup)return t.topModalPopup[0]}(t);return!i||(n.isAncestorOrSelf(i,e)||E.compareStackingContexts(o(i),o(e))<0)},E.compareStackingContexts=function(e,i){function r(e,t){var i,r=["absolute","relative","fixed"],s=e.parents(),a=[];for(i=s.length-1;i>-1;i--)a.push(o(s[i]));(s=a).push(e);var l=[],p=0;for(i=0;i<s.length;i++){var c=s[i],u=c.css("position"),_=n.getCSSLengthAsFloat(c.css("opacity")),E=n.getCSSLengthAsInt(c.css("z-index")),f=o.inArray(c[0],c.parent().children());o.inArray(u,r)>-1&&E>0?(l.push({weight:[p,E,f],order:[f]}),p+=1):_<1?(l.push({weight:[p,1,f],order:[f]}),p+=1):t&&l.push({weight:[0,0,f],order:[f]})}return l}function s(e,t){for(var o=Math.max(e.length,t.length),i=0;i<o;i++){var r=i<e.length?e[i]:0,n=i<t.length?t[i]:0;if(r!==n)return r<n?-1:1}return 0}t.Assert.assertPrototype(e,o),t.Assert.assertPrototype(i,o);var a,l,p=r(e,!1),c=r(i,!1),u=Math.max(p.length,c.length);for(a=0;a<u;a++)if(0!==(l=s(a<p.length?p[a].weight:[-1],a<c.length?c[a].weight:[-1])))return l;for(p=r(e,!0),c=r(i,!0),u=Math.max(p.length,c.length),a=0;a<u;a++)if(0!==(l=s(a<p.length?p[a].order:[-1],a<c.length?c[a].order:[-1])))return l;return 0},E.eatEvent=function(e){e.stopPropagation(),e.preventDefault()},E.isPopupOpen=function(e){var t=e.parent();return!(!t||1!==t.length||!E._hasSurrogate(t[0]))},E._EVENTS_DATA="oj-popup-events",E._MODALITY_DATA="oj-popup-modality",E._DEFAULT_LAYER_ID="__oj_zorder_container",E._SURROGATE_ATTR="data-oj-surrogate-id",E._LAYER_ID_DATA="oj-popup-layer-id",E._OVERLAY_ATTR="data-oj-overlayid",E._OVERLAY_SELECTOR="oj-component-overlay";const f={};t._registerLegacyNamespaceProp("PositionUtils",f),f.normalizeHorizontalAlignment=function(e,i){for(var r=o.extend({},e),n=0;n<f._ALIGN_RULE_PROPERTIES.length;n++){var s=f._ALIGN_RULE_PROPERTIES[n],a=r[s];if(a)if(t.StringUtils.isString(a))r[s]=a.replace("start",i?"right":"left").replace("end",i?"left":"right").replace("<",i?"+":"-").replace(">",i?"-":"+");else for(var l=0;l<f._SUB_ALIGN_RULE_PROPERTIES.length;l++){var p=f._SUB_ALIGN_RULE_PROPERTIES[l],c=a[p];t.StringUtils.isString(c)&&(a[p]=c.replace("start",i?"right":"left").replace("end",i?"left":"right").replace("<",i?"+":"-").replace(">",i?"-":"+"))}}return r},f.normalizePositionOf=function(e,t,o){return"event"===e?o:null==e||"launcher"===e?t:e},f._normalizeEventForPosition=function(e){o.each(["pageX","pageY"],function(t,o){if(e&&void 0===e[o]&&e.originalEvent){var i,r=e.originalEvent,n=r.type;if(i="touchstart"===n||"touchmove"===n?"touches":"touchend"===n?"changedTouches":null){var s=r[i][0];s&&(e[o]=s[o])}}})},f._ALIGN_RULE_PROPERTIES=["my","at"],f._SUB_ALIGN_RULE_PROPERTIES=["vertical","horizontal"],f.isAligningPositionClipped=function(e){if(e.target&&e.target.height>0&&e.target.width>0){var t=e.target.element;return!f.isWithinViewport(t)}return!1},f.isWithinViewport=function(e){function t(e,t){var o;if(["hidden","scroll","auto"].indexOf(t.overflowY)>-1){if(e.bottom-t.top<-1)return!1;if(o="auto"===t.overflowX&&t.scrollWidth>t.innerWidth||"scroll"===t.overflowX?n.getScrollBarWidth():0,t.bottom-o-e.top<1)return!1}return!(["hidden","scroll","auto"].indexOf(t.overflowX)>-1&&(o="auto"===t.overflowY&&t.scrollHeight>t.innerHeight||"scroll"===t.overflowY?n.getScrollBarWidth():0,e.right-(t.left+("rtl"===n.getReadingDirection()?o:0))<-1||e.left-(t.right-("ltr"===n.getReadingDirection()?o:0))>-1))}function i(e){var t=e[0];if(1===t.nodeType){var i=o.extend({},t.getBoundingClientRect());return i.overflowX=e.css("overflow-x"),i.overflowY=e.css("overflow-y"),i.innerHeight=e.innerHeight(),i.innerWidth=e.innerWidth(),i.scrollHeight=t.scrollHeight,i.scrollWidth=t.scrollWidth,i}return{height:0,width:0}}function r(e){return["fixed","absolute","relative","sticky"].indexOf(e.css("position"))>-1&&(!isNaN(parseInt(e.css("top"),10))||!isNaN(parseInt(e.css("bottom"),10))||!isNaN(parseInt(e.css("left"),10))||!isNaN(parseInt(e.css("right"),10)))}if(!e)return!1;if(o.isWindow(e[0])||r(e))return!0;for(var s,a=i(e),l=!0,p=e.parent();l&&p&&p.length>0&&"BODY"!==p[0].nodeName&&1===p[0].nodeType&&!r(p);){if("visible"!==(s=p).css("overflow-x")||"visible"!==s.css("overflow-y")){var c=i(p);c.height>0&&c.width>0&&(l=t(a,c))}p=p.parent()}return l},f._ANIMATION_TRANSFORM_ORIGIN_RULES={"right-top":"right top","right-middle":"right center","right-bottom":"right bottom","left-top":"left top","left-middle":"left center","left-bottom":"left bottom","center-top":"center top","center-middle":"center center","center-bottom":"center bottom"},f._ALIGN_MNEMONIC_DATA="oj-popup-align-mnemonic",f.captureTransformOriginAnimationEffectsOption=function(e,t){var o=[t.horizontal,t.vertical].join("-");e.data(f._ALIGN_MNEMONIC_DATA,o)},f.addTransformOriginAnimationEffectsOption=function(e,o){var i,r;t.StringUtils.isString(o)?(r=!0,i=o):(r=!1,i=JSON.stringify(o));var n=/#myPosition/g;if(i.match(n)){var s=e.data(f._ALIGN_MNEMONIC_DATA);t.StringUtils.isEmptyOrUndefined(s)&&(s="center-middle");var a=f._ANIMATION_TRANSFORM_ORIGIN_RULES[s];i=i.replace(n,a),o=r?i:JSON.parse(i)}return o},f._JQUI_MNEMONIC_GRP_REGX=/^(\w+)(\+|-)?(\d+)?/,f._VERTICAL_ENUM_TST_REGX=/^top$|^center$|^bottom$/,f._HORIZONTAL_ENUM_TST_REGX=/^start$|^left$|^center$|^end$|^right$/,f._COLLISION_ENUM_TST_REGX=/^none$|^flip$|^flipfit$|^fit$|^flipcenter$/,f._parsePositionNmnemonic=function(e,t){var o=[null,Number.NaN],i=f._JQUI_MNEMONIC_GRP_REGX.exec(e);if(i[1]&&t.test(i[1])&&(o[0]=i[1],i[2])){var r=parseInt(i[3],10);isNaN(r)||(r*="-"===i[2]?-1:1,o[1]=r)}return o},f._parseJSON=function(e){if(t.StringUtils.isString(e)&&/^{/.test(e)&&/}$/.test(e))try{return JSON.parse(e)}catch(e){}return null},f._coerceMyAtToJet=function(e,i,r,s){var a=f._parseJSON(i);a&&(i=a),(a=f._parseJSON(r))&&(r=a),s||(s={});var l,p=o.extend({},s),c={x:0,y:0};if(r&&"x"in r&&"y"in r&&(c.x=n.getCSSLengthAsInt(r.x),c.y=n.getCSSLengthAsInt(r.y)),t.StringUtils.isString(i)){var u=i.split(/\s/);u.length>0&&!t.StringUtils.isEmpty(u[0])&&(l=f._parsePositionNmnemonic(u[0],f._HORIZONTAL_ENUM_TST_REGX))[0]&&(p.horizontal=l[0],isNaN(l[1])||(c.x=l[1])),u.length>1&&!t.StringUtils.isEmpty(u[1])&&(l=f._parsePositionNmnemonic(u[1],f._VERTICAL_ENUM_TST_REGX))[0]&&(p.vertical=l[0],isNaN(l[1])||(c.y=l[1]))}else i&&("horizontal"in i&&(l=f._parsePositionNmnemonic(i.horizontal,f._HORIZONTAL_ENUM_TST_REGX))[0]&&(p.horizontal=l[0],isNaN(l[1])||(c.x=l[1])),"vertical"in i&&(l=f._parsePositionNmnemonic(i.vertical,f._VERTICAL_ENUM_TST_REGX))[0]&&(p.vertical=l[0],isNaN(l[1])||(c.y=l[1])));var _={};return _[e]=p,_.offset=c,_},f._coerceCollisionToJet=function(e,t){var o=t;return f._COLLISION_ENUM_TST_REGX.test(e)&&(o=e),{collision:o}},f._coerceOfToJet=function(e,i){var r=f._parseJSON(e);r&&(e=r);var s=i;if(t.StringUtils.isString(e))s=e;else if(o.isWindow(e))s="window";else if(e instanceof Element||e instanceof o){(e=o(e)).uniqueId(),s="#"+function(e){for(var t=[],o=/\w|_|-/,i=0;i<e.length;i++){var r=e.substring(i,i+1);o.test(r)?t.push(r):t.push("\\"+r)}return t.join("")}(e.attr("id"))}else e instanceof Event||e instanceof o.Event?("pageX"in e||"pageY"in e)&&((s={}).x=n.getCSSLengthAsFloat(e.pageX),s.y=n.getCSSLengthAsFloat(e.pageY)):e&&("x"in e||"y"in e)&&((s={}).x=n.getCSSLengthAsFloat(e.x),s.y=n.getCSSLengthAsFloat(e.y));return{of:s}},f.coerceToJet=function(e,t){e||(e={});var i=f._parseJSON(e);i&&(e=i),t||(t={});var r=t.my,n=t.at,s=t.collision,a=t.of,l=f._coerceMyAtToJet("my",e.my,e.offset,r),p=f._coerceMyAtToJet("at",e.at,null,n),c={offset:{x:l.offset.x+p.offset.x,y:l.offset.y+p.offset.y}};return delete l.offset,delete p.offset,o.extend({},l,p,c,f._coerceCollisionToJet(e.collision,s),f._coerceOfToJet(e.of,a),function(e,t){return{using:o.isFunction(e)?e:t}}(e.using,void 0))},f.coerceToJqUi=function(e){function i(t,o){var i=[];if(e[t][o]?i.push(e[t][o]):i.push("center"),"my"===t&&e.offset){var r="horizontal"===o?"x":"y",n=e.offset[r];isNaN(n)||0===n||(i.push(n>0?"+":""),i.push(Math.floor(n).toString()))}return i.join("")}var r={};["my","at"].forEach(function(t){if(e[t]){var o=[];o.push(i(t,"horizontal")),o.push(" "),o.push(i(t,"vertical")),r[t]=o.join("")}});var n=e.of;if(t.StringUtils.isString(n))r.of="window"===n?window:n;else if(n&&!t.StringUtils.isString(n)&&"x"in n&&"y"in n){var s=n.x,a=n.y,l=document.createEvent("MouseEvents");l.initMouseEvent("click",!0,!0,window,1,s,a,s,a,!1,!1,!1,!1,0,null),r.of=o.Event(l,{pageX:s,pageY:a})}else r.of=n;return e.collision&&(r.collision=e.collision),e.using&&(r.using=e.using),r},f.calcAvailablePopupSize=function(e,t,i){var r,s,a,l,p=o.position.getWithinInfo(i||window),c=o.position.getScrollInfo(p),u="rtl"===n.getReadingDirection(),_=u?c.width:0,E=u?0:c.width,f=t.element,h=t.target,d=p.isWindow?p.scrollLeft:0,T=p.isWindow?p.scrollTop:0,v=f.left,O=f.left+f.width,g=f.top,S=f.top+f.height,P=h.left,A=h.left+h.width,m=h.top,y=h.top+h.height,R=p.offset.left+d+_,L=p.offset.left+p.width+d-E,I=p.offset.top+T,N=p.offset.top+p.height+T-c.height;return v<P?(r=R,s=O<=P?P:O<=A?Math.min(A,L):L):v===P?P-R>L-A?(r=R,s=A):(r=P,s=L):v<A?(r=P,s=O<=A?A:L):(r=A,s=L),g<m?(a=I,l=S<=m?m:S<=y?Math.min(y,N):N):g===m?(a=m,l=N):g<y?(a=m,l=S<=y?y:N):(a=y,l=N),{width:s-r,height:l-a}},o.ui.position.flipcenter={left:function(e,t){var i=e.left;o.ui.position.flip.left.call(this,e,t);var r=t.within,s=r.isWindow?r.scrollLeft:r.offset.left,a=r.width,l=e.left-t.collisionPosition.marginLeft,p=s-l,c=l+t.collisionWidth-a-s;(p>0||c>0)&&("right"===t.at[0]?i-=t.targetWidth/2:"left"===t.at[0]&&(i+=t.targetWidth/2),i-=("rtl"===n.getReadingDirection()?-1:1)*(t.elemWidth/2),e.left=Math.max(0,i))},top:function(e,t){var i=e.top;o.ui.position.flip.top.call(this,e,t);var r=t.within,n=r.isWindow?r.scrollTop:r.offset.top,s=t.within.height,a=e.top-t.collisionPosition.marginTop,l=n-a,p=a+t.collisionHeight-s-n;(l>0||p>0)&&("top"===t.at[1]?i+=t.targetHeight/2:"bottom"===t.at[1]&&(i-=t.targetHeight/2),i+=t.elemHeight/2,e.top=Math.max(0,i))}};var h,d=o.ui.position.flip.left;o.ui.position.flip={left:d.bind(null),top:function(e,t){var o,i,r=t.within,n=r.offset.top+r.scrollTop,s=r.height,a=r.isWindow?r.scrollTop:r.offset.top,l=e.top-t.collisionPosition.marginTop,p=l-a,c=l+t.collisionHeight-s-a;o="top"===t.my[1]?-t.elemHeight:"bottom"===t.my[1]?t.elemHeight:0,i="top"===t.at[1]?t.targetHeight:"bottom"===t.at[1]?-t.targetHeight:0;var u,_,E=-2*t.offset[1];p<0?((u=e.top+o+i+E+t.collisionHeight-s-n)<0||u<Math.abs(p))&&c<0&&p>c&&(e.top+=o+i+E):c>0&&((_=e.top-t.collisionPosition.marginTop+o+i+E-a)>0||Math.abs(_)<c)&&(e.top+=o+i+E)}},o.ui.position.fit={left:function(e,t){var o,i=t.within,r=i.isWindow?i.scrollLeft:i.offset.left,n=i.width,s=e.left-t.collisionPosition.marginLeft,a=r-s,l=s+t.collisionWidth-n-r;t.collisionWidth>n?a>0&&l<=0?(o=e.left+a+t.collisionWidth-n-r,e.left+=a-o):e.left=l>0&&a<=0?r:a>l?r+n-t.collisionWidth:r:a>0?e.left+=a:l>0?e.left-=l:e.left=Math.max(e.left-s,e.left),e.left<0&&(e.left=0)},top:function(e,t){var o,i=t.within,r=i.isWindow?i.scrollTop:i.offset.top,n=t.within.height,s=e.top-t.collisionPosition.marginTop,a=r-s,l=s+t.collisionHeight-n-r;t.collisionHeight>n?a>0&&l<=0?(o=e.top+a+t.collisionHeight-n-r,e.top+=a-o):e.top=l>0&&a<=0?r:a>l?r+n-t.collisionHeight:r:a>0?e.top+=a:l>0?e.top-=l:e.top=Math.max(e.top-s,e.top),e.top<0&&(e.top=0)}};var T=o.position.getWithinInfo;o.position={getWithinInfo:T.bind(null),scrollbarWidth:function(){if(void 0!==h)return h;var e,t,i=document.createElement("div");i.style.display="block",i.style.position="absolute",i.style.width="50px",i.style.height="50px",i.style.overflow="hidden";var r=document.createElement("div");return r.style.height="100px",r.style.width="auto",i.appendChild(r),o("body").append(o(i)),e=r.offsetWidth,i.style.overflow="scroll",e===(t=r.offsetWidth)&&(t=i.clientWidth),o(i).remove(),h=e-t},getScrollInfo:function(e){var t=e.isWindow||e.isDocument?"":e.element.css("overflow-x"),i=e.isWindow||e.isDocument?"":e.element.css("overflow-y"),r="scroll"===t||"auto"===t&&e.width<e.element[0].scrollWidth;return{width:"scroll"===i||"auto"===i&&e.height<e.element[0].scrollHeight?o.position.scrollbarWidth():0,height:r?o.position.scrollbarWidth():0}}};const v=function(){this.Init()};t._registerLegacyNamespaceProp("PopupLiveRegion",v),t.Object.createSubclass(v,t.Object,"oj.PopupLiveRegion"),v.prototype.Init=function(){v.superclass.Init.call(this),isNaN(v._refCounter)?v._refCounter=1:v._refCounter+=1},v.prototype.destroy=function(){if(!isNaN(v._refCounter)&&(v._refCounter-=1)<1){var e=o(document.getElementById(v._POPUP_LIVE_REGION_ID));e.length>0&&e.remove()}},v.prototype.announce=function(e){if(!t.StringUtils.isEmpty(e)){var i=v._getLiveRegion();i.children().remove(),setTimeout(function(){o("<div>").text(e).appendTo(i)},20)}},v._getLiveRegion=function(){var e=o(document.getElementById(v._POPUP_LIVE_REGION_ID));return 0===e.length&&((e=o("<div>")).attr({id:v._POPUP_LIVE_REGION_ID,role:"log","aria-live":"polite","aria-relevant":"additions"}),e.addClass("oj-helper-hidden-accessible"),e.appendTo(document.body)),e},v._POPUP_LIVE_REGION_ID="__oj_popup_arialiveregion";const O=function(e,i,r,n,s){t.Assert.assertPrototype(e,o),t.Assert.assertString(i),t.Assert.assertFunction(r),t.Assert.assertStringOrNull(n),this._options={insertBefore:!1,preventKeyEvents:!0},s&&(this._options=Object.assign({},this._options,s)),this._sibling=e,this._message=i,this._callback=r,this._id=n,this.Init()};t._registerLegacyNamespaceProp("PopupSkipLink",O),t.Object.createSubclass(O,t.Object,"oj.PopupSkipLink"),O.prototype.Init=function(){O.superclass.Init.call(this);var e=this._sibling,t=this._callback,i=this._message,r=this._options.insertBefore,n=this._options.preventKeyEvents;this._message=null;var s=this._id;this._id=null;var a=o(document.getElementById(s));a.length<1&&(a=o("<a>").attr({tabindex:"-1",href:"#",role:"link"})),a.attr("id",s),a.addClass("oj-helper-hidden-accessible"),a.text(i),r?a.insertBefore(e):a.insertAfter(e),a.on("click",O._activateHandler.bind(this,t)),n&&a.on("keydown keyup keypress",O._keyHandler),e.data(O._SKIPLINK_ATTR,a)},O._activateHandler=function(e,t){E.eatEvent(t),window.setImmediate(e)},O._keyHandler=function(e){e.keyCode===o.ui.keyCode.ENTER&&E.eatEvent(e)},O.prototype.destroy=function(){var e=this._sibling;if(delete this._sibling,delete this._callback,e){var t=e.data(O._SKIPLINK_ATTR);e.removeData(O._SKIPLINK_ATTR),t&&(t.off("click keydown keyup keypress"),t.remove())}},O.prototype.getLink=function(){var e,t=this._sibling;return t&&(e=t.data(O._SKIPLINK_ATTR)),e},O._SKIPLINK_ATTR="oj-skiplink";const g=function(e,t,o,i){this._element=e,this._operation=t,this._widgetName=o,this._isCustomElement=!!i,this.Init()};t._registerLegacyNamespaceProp("PopupWhenReadyMediator",g),t.Object.createSubclass(g,t.Object,"oj.PopupWhenReadyMediator"),g.prototype.Init=function(){g.superclass.Init.call(this),this._resolvedQueue=[],this._callback=this._eventHandler.bind(this);var e=this._operation,t=["oj"];this._isCustomElement?(t.push(e.charAt(0).toUpperCase()),t.push(e.slice(1))):t.push(e);var o=t.join("");this._eventType=o,this._element.on(o,this._callback);var i=l.getContext(this._element[0]).getBusyContext(),r={description:this._getBusyStateDescription.bind(this,this._element,this._operation,this._widgetName)},n=i.addBusyState(r);this.AddPromiseExecutor(n),this._whenReadyPromise=new Promise(this.AddPromiseExecutor.bind(this))},g.prototype._getBusyStateDescription=function(e,t,o){return o+" identified by '"+e.attr("id")+"' is busy animating on the '"+t+"' operation."},g.prototype._deliverResolved=function(e){var t=this._resolvedQueue;this._resolvedQueue=null;var o=e||this._operation;this._operation=null;for(var i=0;i<t.length;i++)try{t[i](o)}catch(e){r.error("Error resolving whenReady promises:\n%o",e)}this._whenReadyPromise=Promise.resolve("none")},g.prototype.destroy=function(){if(this._resolvedQueue&&this._deliverResolved("none"),this._callback){var e=this._eventType;this._element.off(e,this._callback)}this._callback=null,this._element=null,this._operation=null,this._whenReadyPromise=null,this._widgetName=null,this._eventType=null},g.prototype.getWhenReadyPromise=function(){return this._whenReadyPromise},g.prototype._eventHandler=function(e){e.target===this._element[0]&&(this._element.off(e.type,this._callback),this._deliverResolved(),this._callback=null)},g.prototype._getPendingOperation=function(){return this._operation?this._operation:"none"},g.prototype.AddPromiseExecutor=function(e,t){this._resolvedQueue&&this._resolvedQueue.push(e)},g.prototype.isOperationPending=function(e,t,o,i){var n=!1,s=this._widgetName,a=this._getPendingOperation();if(t===a)r.info("An %s instance invoked a '%s' operation while pending animation of the same type of operation.  The second request will be ignored.",s,t),n=!0;else if("none"!==a){r.info("An %s instance invoked a '%s' operation while pending animation of a '%s' operation. The second request will be invoked after the pending operation completes.",s,t,a),new Promise(this.AddPromiseExecutor.bind(this)).then(function(){this[o].apply(this,i)}.bind(e)),n=!0}return n};class S extends p.Component{constructor(){super(...arguments),this._setRootRef=e=>{this._rootRef=e}}render(e){return p.h("div",{style:{display:"none"},ref:this._setRootRef},e.children)}componentDidMount(){this._popup=o(this._rootRef.firstChild);const e={[u.OPTION.POPUP]:this._popup,[u.OPTION.EVENTS]:{[u.EVENT.POPUP_AUTODISMISS]:this.props.autoDismiss,[u.EVENT.POPUP_REFRESH]:function(){this._popup.position(this._getPosition())}.bind(this)},[u.OPTION.LAYER_SELECTORS]:this.props.layerSelectors,[u.OPTION.CUSTOM_ELEMENT]:!0,[u.OPTION.LAUNCHER]:o(this._rootRef),[u.OPTION.POSITION]:this._getPosition()};u.getInstance().open(e)}componentWillUnmount(){u.getInstance().close({[u.OPTION.POPUP]:this._popup})}componentDidUpdate(){this._popup.position(this._getPosition())}_getPosition(){return f.normalizeHorizontalAlignment(this.props.position,"rtl"===n.getReadingDirection())}}S.defaultProps={autoDismiss:null,layerSelectors:"",position:{}},e.PopupLiveRegion=v,e.PopupService=u,e.PopupSkipLink=O,e.PopupWhenReadyMediator=g,e.PositionUtils=f,e.VPopup=S,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojpopupcore.js.map