/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojdvt-toolkit"],function(t,e){"use strict";var i=function(t){this.Init(t)};e.Obj.createSubclass(i,e.KeyboardHandler),i.prototype.Init=function(t){i.superclass.Init.call(this,t)},i.prototype.isSelectionEvent=function(t){return this.isNavigationEvent(t)&&!t.ctrlKey},i.prototype.isMultiSelectEvent=function(t){return t.keyCode===e.KeyboardEvent.SPACE&&t.ctrlKey},i.getNextNavigable=function(t,i,n){var o=i.keyCode===e.KeyboardEvent.RIGHT_ARROW||i.keyCode===e.KeyboardEvent.DOWN_ARROW,s=n.indexOf(t)+(o?1:-1);return s<n.length&&s>=0?n[s]:null};var n=function(t,e,i){this.Init(t,e,i)};e.Obj.createSubclass(n,e.Obj),n.prototype.Init=function(t,i,n){this._view=t,this._displayable=i,this._data=n,this._isSelected=!1,this._bSelectable=!1,n.url?(i.setAriaRole("link"),this._linkCallback=e.ToolkitUtils.getLinkCallback("_blank",n.url)):i.setAriaRole("img"),this._updateAriaLabel()},n.prototype.getId=function(){return this._data.id},n.prototype.getLabel=function(){return this._data.label},n.prototype.getValue=function(){return this._data.value},n.prototype.getShortDesc=function(){return this._data.shortDesc},n.prototype.getDatatip=function(){var t=this._view.getOptions().tooltip,e=t?t.renderer:null;return e?this._view.getCtx().getTooltipManager().getCustomTooltip(e,this.getDataContext()):this.getShortDesc()},n.prototype.getDataContext=function(){return{id:this.getId(),label:this.getLabel(),color:this.getDatatipColor(),value:this.getValue()}},n.getShortDescContext=function(t){return{id:t.getId(),label:t.getLabel(),value:t.getValue()}},n.prototype.getLinkCallback=function(){return this._linkCallback},n.prototype.getDatatipColor=function(){return this._displayable.getItemStyle().getStyle(e.CSSStyle.COLOR)},n.prototype.setSelectable=function(t){this._bSelectable=t},n.prototype.isSelectable=function(){return this._bSelectable},n.prototype.isSelected=function(){return this._isSelected},n.prototype.setSelected=function(t){this._isSelected=t,this._displayable.setSelected(t),this._updateAriaLabel()},n.prototype.showHoverEffect=function(){this._displayable.showHoverEffect()},n.prototype.hideHoverEffect=function(){this._displayable.hideHoverEffect()},n.prototype.getNextNavigable=function(t){var n=this._view.EventManager.getKeyboardHandler();return t.type===e.MouseEvent.CLICK||n.isMultiSelectEvent(t)?this:n.isNavigationEvent(t)?i.getNextNavigable(this,t,this._view.getObjects()):null},n.prototype.getKeyboardBoundingBox=function(t){return this._displayable.getDimensions(t)},n.prototype.getTargetElem=function(){return this._displayable.getElem()},n.prototype.showKeyboardFocusEffect=function(){this._isShowingKeyboardFocusEffect=!0,this.showHoverEffect()},n.prototype.hideKeyboardFocusEffect=function(){this._isShowingKeyboardFocusEffect&&(this._isShowingKeyboardFocusEffect=!1,this.hideHoverEffect())},n.prototype.isShowingKeyboardFocusEffect=function(){return this._isShowingKeyboardFocusEffect},n.prototype.getDisplayables=function(){return[this._displayable]},n.prototype.getAriaLabel=function(){var t=[];return this.isSelectable()&&t.push(this._view.getOptions().translations[this.isSelected()?"stateSelected":"stateUnselected"]),e.Displayable.generateAriaLabel(this.getShortDesc(),t,()=>n.getShortDescContext(this))},n.prototype.getCategories=function(){return this._data.categories},n.prototype._updateAriaLabel=function(){e.Agent.deferAriaCreation()||this._displayable.setAriaProperty("label",this.getAriaLabel())},n.prototype.isDragAvailable=function(t){return this._view.isDragSupported(t)},n.prototype.getDragTransferable=function(t,e){return this._view.getDragRowKeys(this)},n.prototype.getDragFeedback=function(t,e){return this._view.getDragFeedback()};var o=function(t){this._tagCloud=t};e.Obj.createSubclass(o,e.Automation),o.prototype.GetSubIdForDomElement=function(t){var e=this._tagCloud.EventManager.GetLogicalObject(t);return e&&e instanceof n?"item["+this._tagCloud.getItems().indexOf(e)+"]":null},o.prototype.getDomElementForSubId=function(t){if(t===e.Automation.TOOLTIP_SUBID)return this.GetTooltipElement(this._tagCloud);var i=t.indexOf("[");if(i>0&&"item"===t.substring(0,i)){var n=parseInt(t.substring(i+1,t.length-1)),o=this._tagCloud.getItems()[n];return o?o.getDisplayables()[0].getElem():null}return null},o.prototype.getItem=function(t){var e=this._tagCloud.getItems()[t];if(e){var i={};return i.color=e.getDatatipColor(),i.tooltip=e.getShortDesc(),i.label=e.getLabel(),i.value=e.getValue(),i.selected=e.isSelected(),i}return null},o.prototype.getItemCount=function(){return this._tagCloud.getObjects().length};var s=function(t){this.Init({alta:s.VERSION_1},t)};e.Obj.createSubclass(s,e.BaseComponentDefaults),s.VERSION_1={animationOnDisplay:"none",animationOnDataChange:"none",emptyText:null,hiddenCategories:[],hideAndShowBehavior:"none",highlightedCategories:[],highlightMatch:"all",hoverBehavior:"none",layout:"rectangular",selectionMode:"none",_statusMessageStyle:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_ALTA+"color: #333333;"),styleDefaults:{animationDuration:500,hoverBehaviorDelay:200,_style:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_ALTA+"color: #333333;")},touchResponse:"auto"};var a=function(t,e,i,n){this.Init(e,i,n,t),this._view=t};e.Obj.createSubclass(a,e.EventManager),a.prototype.OnClickInternal=function(t){var e=this.GetLogicalObject(t.target);this._handleLinkCallback(e)},a.prototype.HandleTouchClickInternal=function(t){var e=this.GetLogicalObject(t.target);this._handleLinkCallback(e)},a.prototype._handleLinkCallback=function(t){if(t instanceof n){var e=t.getLinkCallback();e&&e.call()}},a.prototype.ProcessKeyboardEvent=function(t){var i=!0,n=t.keyCode,o=this.getFocus();return n===e.KeyboardEvent.ENTER?this._handleLinkCallback(o):i=a.superclass.ProcessKeyboardEvent.call(this,t),i},a.prototype.ProcessRolloverEvent=function(t,i,n){var o=this._view.getOptions();if("dim"===o.hoverBehavior){var s=i.getCategories?i.getCategories():[];o.highlightedCategories=n?s.slice():null;var a=e.EventFactory.newCategoryHighlightEvent(o.highlightedCategories,n),r=e.CSSStyle.getTimeMilliseconds(o.styleDefaults.hoverBehaviorDelay);this.RolloverHandler.processEvent(a,this._view.getObjects(),r,"any"===o.highlightMatch)}},a.prototype.GetTouchResponse=function(){return this._view.getOptions().touchResponse};var r=new Object;e.Obj.createSubclass(r,e.Obj),r.getAnimationDuration=function(t){return t.getOptions().styleDefaults.animationDuration/1e3};var l=function(t,e,i,n,o,s,a,r,l){this.Init(t,e,i,n,o,s,a,r,l)};e.Obj.createSubclass(l,e.BackgroundOutputText),l._HOVER_OPACITY=.3,l._HOVER_SELECTED_OPACITY=.6,l.ANIMATION_DELETE_PRIORITY=0,l.ANIMATION_UPDATE_PRIORITY=1,l.ANIMATION_INSERT_PRIORITY=2,l.prototype.Init=function(t,e,i,n,o,s,a,r,h){l.superclass.Init.call(this,e,i,n,o,s,h),this._tagCloud=t,this.alignAuto(),this.TextInstance.setStyle(a),this.TextInstance.setClassName(r),s&&this._createFeedbackStyles(s)},l.prototype.setSelected=function(t){this._isSelected!==t&&(this._isSelected=t,t?this._isShowingHoverEffect?this.setCSSStyle(this._hoverSelectedStyle):this.setCSSStyle(this._selectedStyle):this.setCSSStyle(this._normalStyle))},l.prototype.showHoverEffect=function(){this._isShowingHoverEffect||(this._isShowingHoverEffect=!0,this._isSelected?this.setCSSStyle(this._hoverSelectedStyle):this.setCSSStyle(this._hoverStyle))},l.prototype.hideHoverEffect=function(){this._isSelected?this.setCSSStyle(this._selectedStyle):this.setCSSStyle(this._normalStyle),this._isShowingHoverEffect=!1},l.prototype.animateUpdate=function(t,i){var n=new e.CustomAnimation(this.getCtx(),this,r.getAnimationDuration(this._tagCloud)),o=this.getCSSStyle(),s=i.getCSSStyle(),a=!1,h=s.getStyle(e.CSSStyle.COLOR),c=o.getStyle(e.CSSStyle.COLOR);if(h!==c){var g=this;this.setCSSStyle(o.setStyle(e.CSSStyle.COLOR,h)),n.getAnimator().addProp(e.Animator.TYPE_COLOR,this,function(){return g.getCSSStyle().getStyle(e.CSSStyle.COLOR)},function(t){g.setCSSStyle(g.getCSSStyle().setStyle(e.CSSStyle.COLOR,t))},c)}var S=parseFloat(s.getStyle(e.CSSStyle.FONT_SIZE)),u=parseFloat(o.getStyle(e.CSSStyle.FONT_SIZE));if(S!==u){a=!0;var d=this;this.setFontSize(S),n.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,function(){return parseFloat(d.getCSSStyle().getStyle(e.CSSStyle.FONT_SIZE))},this.setFontSize,u)}var p=i.getX(),y=this.getX(),_=i.getHorizAlignment(),C=this.getHorizAlignment();(y!==p||a&&C!==_)&&(C!==_&&(p=l._adjustX(i,p,_)),this.setX(p),n.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getX,this.setX,y));var f=i.getY(),v=this.getY();v!==f&&(this.setY(f),n.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getY,this.setY,v)),i.setAlpha(0),t.add(n,l.ANIMATION_UPDATE_PRIORITY)},l.prototype.animateDelete=function(t){t.add(new e.AnimFadeOut(this.getCtx(),this,r.getAnimationDuration(this._tagCloud)),l.ANIMATION_DELETE_PRIORITY)},l.prototype.animateInsert=function(t){this.setAlpha(0),t.add(new e.AnimFadeIn(this.getCtx(),this,r.getAnimationDuration(this._tagCloud)),l.ANIMATION_INSERT_PRIORITY)},l.prototype.setFontSize=function(t){l.superclass.setFontSize.call(this,t),this._createFeedbackStyles(this.getCSSStyle())},l.prototype._createFeedbackStyles=function(t){this._normalStyle=t.clone();var i=this._normalStyle.getStyle(e.CSSStyle.COLOR);this._normalStyle.setStyle(e.CSSStyle.BACKGROUND_COLOR,null),this._hoverStyle=this._normalStyle.clone();var n=l._lightenColor(i,l._HOVER_OPACITY);this._hoverStyle.setStyle(e.CSSStyle.BACKGROUND_COLOR,n),this._hoverStyle.setStyle(e.CSSStyle.COLOR,e.ColorUtils.getContrastingTextColor(n)),this._selectedStyle=this._normalStyle.clone(),this._selectedStyle.setStyle(e.CSSStyle.BACKGROUND_COLOR,i),this._selectedStyle.setStyle(e.CSSStyle.COLOR,e.ColorUtils.getContrastingTextColor(i)),this._hoverSelectedStyle=this._normalStyle.clone();var o=l._lightenColor(i,l._HOVER_SELECTED_OPACITY);this._hoverSelectedStyle.setStyle(e.CSSStyle.BACKGROUND_COLOR,o),this._hoverSelectedStyle.setStyle(e.CSSStyle.COLOR,e.ColorUtils.getContrastingTextColor(o))},l.prototype.getItemStyle=function(){return this._normalStyle},l._adjustX=function(t,i,n){var o=t.getTextDimensions();return n===e.OutputText.H_ALIGN_LEFT?i+o.w:n===e.OutputText.H_ALIGN_RIGHT?i-o.w:i},l._lightenColor=function(t,i){var n=255*(1-i)+i*e.ColorUtils.getRed(t),o=255*(1-i)+i*e.ColorUtils.getGreen(t),s=255*(1-i)+i*e.ColorUtils.getBlue(t);return e.ColorUtils.makeRGB(Math.floor(n),Math.floor(o),Math.floor(s))};var h=function(){};e.Obj.createSubclass(h,e.Obj),h.getFontSizeFunction=function(t,e,i){return function(n){return t===e?12:12+Math.ceil((i-1)*(n-t)/(e-t)*12)}},h.cloudLayout=function(t,i){var n=[],o=10/180,s=10/180;t.w>t.h?o*=t.w/t.h:s*=t.h/t.w;for(var a=2*Math.PI/180,r=null,l=0,h=[],c=[],g=0;g<i.length;g++){var S=!1,u=0,d=4,p=i[g],y=p.getDimensions();l=Math.max(l,parseFloat(p.getCSSStyle().getStyle(e.CSSStyle.FONT_SIZE)));for(var _=-1;!S;){var C=u%180;void 0===h[C]&&(h[C]=Math.cos(u*a)),void 0===c[C]&&(c[C]=Math.sin(u*a));var f=o*u*h[C],v=s*u*c[C],O=new e.Rectangle(f,v,y.w,y.h);if(S=!0,-1!=_&&n[_].intersects(O)&&(S=!1),S)for(var m=0;m<g;m++)if(n[m].intersects(O)){_=m,S=!1;break}S&&(r=r?r.getUnion(O):O,_=-1,n[g]=O,p.setX(f),p.setY(-y.y+v)),3600===u?d=3:5400===u?d=2:10800===u&&(d=1),u+=d}}if(r)for(var b=Math.max(r.w/t.w,r.h/t.h),E=r.x+r.w/2,A=r.y+r.h/2,I=0;I<i.length;I++){var w=i[I];w.setX(t.x+w.getX()/b+(t.w/2-E/b)),w.setY(t.y+w.getY()/b+(t.h/2-A/b));var T=parseFloat(w.getCSSStyle().getStyle(e.CSSStyle.FONT_SIZE));w.setFontSize(T/b)}},h.rectangleLayout=function(t,i,n){for(var o=[],s=0,a=0,r=0,l=0;l<i.length;l++){var c=i[l],g=c.getDimensions();s=Math.max(s,g.w),a=Math.max(a,g.h),r=Math.max(r,parseFloat(c.getCSSStyle().getStyle(e.CSSStyle.FONT_SIZE))),o.push(new e.Dimension(g.w,g.h))}for(var S,u,d=0,p=(t.w-10)/s;p-d>.001;){S=(d+p)/2,(u=h._calculateLineBreaks(o,(t.w-10)/S)).length*(S*a+2)-2>t.h-10?p=S:d=S}S=d,(u=h._calculateLineBreaks(o,(t.w-10)/S)).push(i.length);for(l=0;l<u.length-1;l++){var y=u[l],_=u[l+1],C=0,f=0,v=!0;if(_-y>1){for(var O=0,m=y;m<_;m++)O+=o[m].w*S,f=Math.max(f,o[m].h*S);if(C=(t.w-10-O)/(_-y-1),l==u.length-2){var b=.5*f;b<C&&O+(_-y)*b<.9*(t.w-10)&&(C=b,v=!1)}}for(var E=5+(l+1)*(a*S+2)-2,A=n?t.w-5:5,I=y;I<_;I++){var w=i[I],T=parseFloat(w.getCSSStyle().getStyle(e.CSSStyle.FONT_SIZE));w.setFontSize(T*S),w.setY(t.y+E),v&&I===_-1&&I!==y?n?(w.alignLeft(),w.setX(t.x+5)):(w.alignRight(),w.setX(t.x+t.w-5)):(w.setX(t.x+A),n?(w.alignRight(),A-=o[I].w*S+C):(w.alignLeft(),A+=o[I].w*S+C))}}},h._calculateLineBreaks=function(t,e){var i=[0],n=t[0].w+2;if(t.length>1)for(var o=1;o<t.length;o++)n+t[o].w>e&&(i.push(o),n=0),n+=t[o].w+2;return i};var c={};e.Obj.createSubclass(c,e.Obj),c.render=function(t,e,i){c._renderBackground(t,e,i),c._renderLegend(t,e,i),c._adjustAvailSpace(i);var n=t.getOptions();if(n.items&&n.items.length>0){var o=c._renderItems(t,e,i);o.length>0?(t.registerItems(o),t.EventManager.setFocusObj(t.getObjects()[0])):c._renderEmptyText(t,e,i)}else c._renderEmptyText(t,e,i)},c._renderEmptyText=function(t,i,n){var o=t.getOptions(),s=o.emptyText;s||(s=o.translations.labelNoData),t.renderEmptyText(i,s,new e.Rectangle(n.x,n.y,n.w,n.h),t.EventManager,o._statusMessageStyle)},c._renderBackground=function(t,i,n){var o=new e.Rect(t.getCtx(),n.x,n.y,n.w,n.h);o.setInvisibleFill(),i.addChild(o)},c._renderItems=function(t,i,o){for(var s=t.getOptions(),a=[],r=s.items,c=Number.MAX_VALUE,g=-Number.MAX_VALUE,S=0;S<r.length;S++)c=Math.min(c,r[S].value),g=Math.max(g,r[S].value);var u=h.getFontSizeFunction(c,g,3),d=e.ArrayUtils.createBooleanMap(s.hiddenCategories),p=e.CSSStyle.getTextMeasurementProperties(),y=s.styleDefaults,_=y.svgStyle||y.style;!_||_ instanceof Object||(_=e.CSSStyle.cssStringToObject(_));for(var C=0;C<r.length;C++){var f=r[C];if(f.categories||(f.categories=[f.label]),!d||!e.ArrayUtils.hasAnyMapItem(d,f.categories)){var v=y._style.clone(),O=f.svgStyle||f.style;!O||O instanceof Object||(O=e.CSSStyle.cssStringToObject(O));var m=_&&_.color?_.color:null,b=f.color?f.color:m,E=O&&O.color?O.color:b;if(O=e.JsonUtils.merge(O,_)){for(var A=0;A<p.length;A++){var I=e.CSSStyle.cssStringToObjectProperty(p[A]);O[I]&&(v.setStyle(p[A],O[I]),delete O[I])}delete O.color}E&&v.setStyle(e.CSSStyle.COLOR,E),v.setStyle(e.CSSStyle.FONT_SIZE,u.call(null,f.value).toString());var w=f.svgClassName||f.className,T=new l(t,t.getCtx(),f.label,0,0,v,O,w,f.id),D=new n(t,T,f);t.EventManager.associate(T,D),t.registerObject(D,C),"none"!==s.selectionMode&&D.setSelectable(!0),(D.isSelectable()||f.url)&&T.setCursor(e.SelectionEffectUtils.getSelectingCursor()),a.push(T),i.addChild(T)}}return a.length>0&&("cloud"===s.layout?h.cloudLayout(o,a):h.rectangleLayout(o,a,e.Agent.isRightToLeft(t.getCtx()))),a},c._renderLegend=function(t,i,n){var o=t.getOptions(),s=o.legend;if(s&&s.sections){var a=e.JsonUtils.clone(s);a.orientation="horizontal",a.halign="center",a.hoverBehavior=o.hoverBehavior,a.hideAndShowBehavior=o.hideAndShowBehavior,a.hiddenCategories=o.hiddenCategories;var r=e.Legend.newInstance(t.getCtx(),t.processEvent,t);i.addChild(r);var l=r.getPreferredSize(a,n.w,n.h/3);r.render(a,l.w,l.h),e.LayoutUtils.position(n,"bottom",r,l.w,l.h,0),t.legend&&(t.legend.destroy(),i.removeChild(t.legend)),t.legend=r}},c._adjustAvailSpace=function(t){t.x=Math.round(t.x),t.y=Math.round(t.y),t.w=Math.round(t.w),t.h=Math.round(t.h)};const g=function(t,e,i){this.Init(t,e,i)};e.Obj.createSubclass(g,e.BaseComponent),g.newInstance=function(t,e,i){return new g(t,e,i)},g.prototype.Init=function(t,n,o){g.superclass.Init.call(this,t,n,o),this.getCtx().getStage().getElem().setAttributeNS(null,"text-rendering","geometricPrecision"),this.EventManager=new a(this,t,this.processEvent,this),this.EventManager.addListeners(this),e.Agent.isTouchDevice()||this.EventManager.setKeyboardHandler(new i(this.EventManager)),this.Defaults=new s(t),this._items=[],this._peers=[],this.legend=null},g.prototype.render=function(t,i,n){isNaN(i)||isNaN(n)||(this.Width=i,this.Height=n),this.__cleanUp(),this.SetOptions(t),this.StopAnimation(),this._oldContainer=this._container,this._oldItems=this._items,this._items=[],this._itemCollection=[],this._container=new e.Container(this.getCtx()),this.addChild(this._container),c.render(this,this._container,new e.Rectangle(0,0,this.Width,this.Height)),this.SelectionHandler&&this.SelectionHandler.processInitialSelections(this.Options.selection,this.getObjects());var o=this.Options.animationDuration,s=new e.Rectangle(0,0,this.Width,this.Height);if(this._oldContainer){if("none"!==this.Options.animationOnDataChange&&t){this._deleteContainer=new e.Container(this.getCtx()),this.addChild(this._deleteContainer);var a=new e.DataAnimationHandler(this.getCtx(),this._deleteContainer);a.constructAnimation(this._oldItems,this._items),this.Animation=a.getAnimation()}}else"none"!==this.Options.animationOnDisplay&&(this.Animation=e.BlackBoxAnimationHandler.getInAnimation(this.getCtx(),e.BlackBoxAnimationHandler.ALPHA_FADE,this._container,s,o));this.Animation?(this.EventManager.hideTooltip(),this.EventManager.removeListeners(this),this.Animation.setOnEnd(this.OnRenderEnd,this),this.Animation.play()):this.OnRenderEnd(),this.UpdateAriaAttributes()},g.prototype.registerItems=function(t){this._items=t},g.prototype.getAutomation=function(){return this.Automation||(this.Automation=new o(this)),this.Automation},g.prototype.registerObject=function(t,e){this._peers.push(t),this._itemCollection[e]=t},g.prototype.getObjects=function(){return this._peers},g.prototype.getItems=function(){return this._itemCollection},g.prototype.highlight=function(t){this.Options.highlightedCategories=e.JsonUtils.clone(t),e.CategoryRolloverHandler.highlight(t,this.getObjects(),"any"===this.Options.highlightMatch),this.legend&&this.legend.highlight(t)},g.prototype.select=function(t){this.Options.selection=e.JsonUtils.clone(t),this.SelectionHandler&&this.SelectionHandler.processInitialSelections(this.Options.selection,this.getObjects())},g.prototype.SetOptions=function(t){t?this.Options=this.Defaults.calcOptions(t):this.Options||(this.Options=this.GetDefaults());var i=this.Options.selectionMode;this.SelectionHandler="single"===i?new e.SelectionHandler(this.getCtx(),e.SelectionHandler.TYPE_SINGLE):"multiple"===i?new e.SelectionHandler(this.getCtx(),e.SelectionHandler.TYPE_MULTIPLE):null,this.EventManager.setSelectionHandler(this.SelectionHandler),e.Agent.isEnvironmentTest()&&(this.Options.animationOnDisplay="none",this.Options.animationOnDataChange="none")},g.prototype.OnRenderEnd=function(){this._oldContainer&&(this.removeChild(this._oldContainer),this._oldContainer.destroy(),this._oldContainer=null),this._deleteContainer&&(this.removeChild(this._deleteContainer),this._deleteContainer.destroy(),this._deleteContainer=null),this.Animation&&this.EventManager.addListeners(this),this.Options.highlightedCategories&&this.Options.highlightedCategories.length>0&&this.highlight(this.Options.highlightedCategories),this.AnimationStopped||this.RenderComplete(),this.Animation=null,this.AnimationStopped=!1},g.prototype.__cleanUp=function(){this.EventManager.hideTooltip(),this._peers.length=0},g.prototype.processEvent=function(t,e){var i=t.type;if("categoryHide"===i||"categoryShow"===i){var n=t.category,o=this.Options.hiddenCategories.indexOf(n);"categoryHide"===i&&o<0&&this.Options.hiddenCategories.push(n),"categoryShow"===i&&o>=0&&this.Options.hiddenCategories.splice(o,1),this.render(this.Options,this.Width,this.Height)}else"categoryHighlight"===i&&(this!==e?this.highlight(t.categories):this.legend&&this.legend!==e&&this.legend.processEvent(t,e));t&&this.dispatchEvent(t)},g.prototype.isDragSupported=function(t){return this.SelectionHandler?t[0]:null},g.prototype.getDragRowKeys=function(t){t.isSelected()||(this.SelectionHandler.processClick(t,!1),this.EventManager.fireSelectionEvent());for(var e=[],i=this.SelectionHandler.getSelection(),n=0;n<i.length;n++){var o=i[n];o instanceof DvtTagCloudObjPeer&&e.push(o.getId())}return e},g.prototype.getDragFeedback=function(){for(var t=[],e=this.SelectionHandler.getSelection(),i=0;i<e.length;i++)t=t.concat(e[i].getDisplayables());return t},t.TagCloud=g,Object.defineProperty(t,"__esModule",{value:!0})});
//# sourceMappingURL=ojtagcloud-toolkit.js.map