/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["knockout","ojs/ojcore","ojs/ojkoshared","ojs/ojhtmlutils","ojs/ojlogger","ojs/ojcustomelement-utils","preact","ojs/ojcore-base"],function(e,t,r,n,o,s,a,i){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,r=r&&Object.prototype.hasOwnProperty.call(r,"default")?r.default:r,i=i&&Object.prototype.hasOwnProperty.call(i,"default")?i.default:i;const c=Symbol("row");class l{static executeVDomTemplate(t,r){const n=e.pureComputed({read:()=>t.render(r.$current)}).extend({rateLimit:0}),o=n();l._extendTemplate(t,l._ROW_CACHE_FACTORY,e=>{t._cachedRows.forEach(t=>{let r=e(t.currentContext);l._renderNodes(r,t)})});const s=document.createElement("div"),a={currentContext:r.$current,template:t,parentStub:s,computedVNode:n,vnode:void 0,nodes:void 0};return l._renderNodes(o,a),t._cachedRows.push(a),n.subscribe(e=>{const r=t._cachedRows.find(e=>e.computedVNode===n);l._renderNodes(e,r)}),a.nodes}static _renderNodes(e,t){const r=t.parentStub;let n;if(t.nodes){const e=t.nodes;n=l._getInsertNodesFunction(e),e.forEach(e=>{r.appendChild(e)})}a.render(e,r);const o=Array.from(r.childNodes);o.forEach(e=>{var r;null===(r=e.classList)||void 0===r||r.add("oj-vdom-template-root"),e[c]=t,e[s.CACHED_BINDING_PROVIDER]="preact"}),t.vnode=e,t.nodes=o,null==n||n(o)}static clean(e){const t=e[c];if(!t.cleaned){t.cleaned=!0;const e=l._getInsertNodesFunction(t.nodes);a.render(null,t.parentStub),e(t.nodes),t.computedVNode.dispose();const r=t.template,n=r._cachedRows.indexOf(t);r._cachedRows.splice(n,1)}}static _getInsertNodesFunction(e){const t=e[e.length-1],r=t.parentNode,n=t.nextSibling;return e=>{e.forEach(e=>r.insertBefore(e,n))}}static resolveVDomTemplateProps(e,t,r,n,o,s,a){const[i,c]=l._extendTemplate(e,l._COMPUTED_PROPS_CACHE_FACTORY,e=>{for(const t of i)t.recalculateValue(e)}),d=new u(e=>l._computeProps(e,r,n,o,a),t,s,c);return i.add(d),d}static _computeProps(e,t,r,n,o){const s=e(n),a=(Array.isArray(s)?s:[s]).find(e=>e.type===t);if(!a)throw new Error("Item template must contain an element named {elementTagName}");const i={},c=a.props;return Object.keys(c).forEach(e=>{r.has(e)&&(i[e]=a.props[e])}),i}static _extendTemplate(e,t,r){if(!e._cachedRows){let n=e.render;Object.defineProperties(e,{_cachedRows:{writable:!0,value:t()},render:{enumerable:!0,get:()=>n,set(e){n=e,e&&r(e)}}})}return e._cachedRows}}l._COMPUTED_PROPS_CACHE_FACTORY=()=>{const e=new Set;return[e,e.delete.bind(e)]},l._ROW_CACHE_FACTORY=()=>[];class u{constructor(e,t,r,n){this._calculate=e,this._defaultProps=r,this._disposeCallback=n,this._value=e(t),this._merged=this._getMergedValue(this._value)}peek(){return this._merged}subscribe(e){if(this._sub)throw new Error("Resolved property observable does not support multiple subscribers");this._sub=e}dispose(){this._disposeCallback(this)}recalculateValue(e){const t=this._calculate(e),r=this._value;this._value=t,this._sub&&!i.Object.compareValues(t,r)&&(this._merged=this._getMergedValue(t),this._sub(this._merged))}_getMergedValue(e){return Object.assign({},this._defaultProps,e)}}return new function(){this.execute=function(t,r,n,o,a){var i=r.getAttribute("data-oj-as"),d=u(t,r,n,o,i);if(r.render)return l.executeVDomTemplate(r,d);var p=c(r,a);let f=p.childNodes;for(let e=0;e<f.length;e++){f[e][s.CACHED_BINDING_PROVIDER]="knockout"}return e.applyBindingsToDescendants(d,p),Array.prototype.slice.call(f,0)},this.clean=function(t){let r=t&&t.getElementsByClassName?Array.from(t.getElementsByClassName("oj-vdom-template-root")):[];return t&&t.matches&&t.matches(".oj-vdom-template-root")&&r.push(t),r.forEach(e=>{l.clean(e)}),0===r.length?e.cleanNode(t):null},this.resolveProperties=function(n,o,d,p,f,h,_,m){const v=o.render;if(v){const e=this._getResolvedDefaultProps(d,p);return l.resolveVDomTemplateProps(o,v,d,p,f,e,_)}var b=o.getAttribute("data-oj-as"),g=u(n,o,f,h,b);return function(r,n,o){return s=e.pureComputed(function(){var s={};r.evalMap.forEach(function(t,r){var a=e.utils.unwrapObservable(t(n));o&&o(r,a),s[r[0]]=function(e,t,r){if(t.length<2)return r;for(var n=e[t[0]]||{},o=n,s=t.length-1,a=1;a<s;a++){var i=t[a],c=o[i]||{};o[i]=c,o=c}return o[t[s]]=r,n}(s,r,a)});var a=t.CollectionUtils.copyInto,i=a({},r.staticMap,null,!0);return i=a(i,s,null,!0)}),a=["peek","subscribe","dispose"],i={},a.forEach(function(e){i[e]=s[e].bind(s)}),i;var s,a,i}(function(e,t,n,o,l){var u=a.get(e);if(!u){u={},a.set(e,u);var d=c(e).querySelector(n);u.evalMap=function(e,t,n){for(var o=new Map,a=e?e.attributes:[],i=0;i<a.length;i++){var c=a[i],l=s.AttributeUtils.attributeToPropertyName(c.name).split(".");if(t.has(l[0])){var u=s.AttributeUtils.getExpressionInfo(c.value).expr;u&&o.set(l,r.createBindingExpressionEvaluator(u,n))}}return o}(d,o,t),u.staticMap=i(d,o,l)}return u}(o,g,d,p,m||n),g,_)},this.defineTrackableProperty=function(t,r,n,o){!function(t,r,n,o){var s=e.observable(n);Object.defineProperty(t,r,{get:function(){return s()},set:function(e){s(e),o&&o(e)},enumerable:!0})}(t,r,n,o)};var a=new WeakMap;function i(e,t,r){var n={};if(e){var o=e.style;o.display="none",o.position="absolute",e.setAttribute("data-oj-binding-provider","none"),r.appendChild(e),t.forEach(function(t){void 0!==e[t]&&(n[t]=e[t])}),r.removeChild(e)}return n}function c(e,t){var r=document.createElement("div");t&&(r._ojReportBusy=t);for(var o=n.getTemplateContent(e),s=0;s<o.length;s++)r.appendChild(o[s]);return r}function u(t,n,s,a,i){var c=n.__ojBindingContext?n.__ojBindingContext:e.contextFor(n);return c||(o.info("Binding context not found when processing template for element with id: "+t.id+". Using binding context for element instead."),c=e.contextFor(t)),r.extendBindingContext(c,s,a,i,t)}this._getResolvedDefaultProps=function(e,t){let r=this._defaultProps.get(e);if(!r){r=i(document.createElement(e),t,document.body),this._defaultProps.set(e,r)}return r},this._defaultProps=new Map}});
//# sourceMappingURL=ojtemplateengine.js.map