/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojdvt-toolkit"],function(t,e){"use strict";var i=function(t){this.Init(t)};e.Obj.createSubclass(i,e.Obj),i.prototype.Init=function(){this._dayInMillis=864e5,this._firstDayOfWeek=0},i.prototype.setFirstDayOfWeek=function(t){this._firstDayOfWeek=t},i.prototype.getFirstDayOfWeek=function(){return this._firstDayOfWeek},i.prototype.adjustDate=function(t,e){var i=new Date(t.getTime());if("weeks"===e){i.setHours(0,0,0,0);var s=(t.getDay()-this.getFirstDayOfWeek()+7)%7;s>0&&i.setDate(i.getDate()-s)}else if("months"===e)i.setDate(1),i.setHours(0,0,0,0);else if("days"===e)i.setHours(0,0,0,0);else if("hours"===e)i.setMinutes(0,0,0);else if("minutes"===e)i.setSeconds(0,0);else if("seconds"===e)i.setMilliseconds(0);else if("quarters"===e){var r=Math.floor(i.getMonth()/3);i.setDate(1),i.setHours(0,0,0,0),i.setMonth(3*r)}else"years"===e&&(i.setMonth(0),i.setDate(1),i.setHours(0,0,0,0));return i},i.prototype.getAdjacentDate=function(t,e,i){var s="next"===i?1:-1;if("seconds"===e)return new Date(t+1e3*s);if("minutes"===e)return new Date(t+6e4*s);if("hours"===e)return new Date(t+36e5*s);var r=new Date(t);return"days"===e?r.setDate(r.getDate()+1*s):"weeks"===e?r.setDate(r.getDate()+7*s):"months"===e?r.setMonth(r.getMonth()+1*s):"quarters"===e?r.setMonth(r.getMonth()+3*s):"years"===e?r.setFullYear(r.getFullYear()+1*s):r.setYear(r.getYear()+1*s),r};var s=function(t){this.Init({alta:s.VERSION_1},t)};e.Obj.createSubclass(s,e.BaseComponentDefaults),s.VERSION_1={backgroundColor:"rgba(255,255,255,0)",borderColor:"#d9dfe3",separatorColor:"#bcc7d2",labelStyle:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_ALTA_12+"color: #333333;")},s.prototype.getNoCloneObject=function(){return{scale:!0,zoomOrder:!0}};var r=function(){};e.Obj.createSubclass(r,e.Obj),r.prototype.parse=function(t){this._startTime=new Date(t.start),this._endTime=new Date(t.end);var e=this.ParseRootAttributes();return e.inlineStyle=t.style,e.id=t.id,e.shortDesc=t.shortDesc,e.itemPosition=t._ip,e.customTimeScales=t._cts,e.customFormatScales=t._cfs,e.scale=t.scale,e.converter=t.converter,e.zoomOrder=t.zoomOrder?t.zoomOrder:null,e.orientation=t.orientation?t.orientation:"horizontal",e},r.prototype.ParseRootAttributes=function(){var t=new Object;return t.start=this._startTime.getTime(),t.end=this._endTime.getTime(),t};var n=new Object;e.Obj.createSubclass(n,e.Obj),n.DEFAULT_BORDER_WIDTH=1,n.DEFAULT_SEPARATOR_WIDTH=1,n.DEFAULT_INTERVAL_WIDTH=50,n.DEFAULT_INTERVAL_HEIGHT=21,n.DEFAULT_INTERVAL_PADDING=2,n.getAxisStyle=function(t){var e="",i=n.getBackgroudColor(t);return i&&(e=e+"background-color:"+i+";"),(i=n.getBorderColor(t))&&(e=e+"border-color:"+i+";"),(i=n.getBorderWidth())&&(e=e+"border-width:"+i+";"),e},n.getBackgroudColor=function(t){return t.backgroundColor},n.getBorderColor=function(t){return t.borderColor},n.getBorderWidth=function(){return n.DEFAULT_BORDER_WIDTH},n.getAxisLabelStyle=function(t){return t.labelStyle},n.getSeparatorColor=function(t){return t.separatorColor},n.getAxisSeparatorStyle=function(t){var e="",i=n.getSeparatorColor(t);return i&&(e=e+"color:"+i+";"),e},n.getAxisClass=function(t){return t._resources?t._resources.axisClass:void 0},n.getAxisLabelClass=function(t){return t._resources?t._resources.axisLabelClass:void 0},n.getAxisSeparatorClass=function(t){return t._resources?t._resources.axisSeparatorClass:void 0};const o={supportsTouch:function(){return e.Agent.isTouchDevice()},getDatePosition:function(t,e,i,s){var r=(i-t)*s,n=e-t;return 0===r||0===n?0:r/n},getPositionDate:function(t,e,i,s){var r=i*(e-t);return 0===r||0===s?t:r/s+t}},a={};e.Obj.createSubclass(a,e.Obj),a.renderTimeAxis=function(t,i,s,r){if(!t.hasValidOptions())return;const n=function(){t.removeChildren(),a._renderBackground(t);const r=new e.Container(t.getCtx()),n=t.getViewportDates(t.getScale(),i,s),h=n.map(function(e){return{date:e,pos:o.getDatePosition(t._start,t._end,e.getTime(),t._contentLength)}});a._renderTicks(r,t,h);const l=t.getDateLabelTexts(n,t.getScale()).slice(0,n.length-1);a._renderLabels(r,t,h,l),t._axis.addChild(r)};r?t.__isRendering||(requestAnimationFrame(function(){n(),t.__isRendering=!1}),t.__isRendering=!0):n()},a._renderBackground=function(t){const i=t.getSize(),s=t.getCtx();t._axis&&t._axis.setClipPath(null);const r=new e.ClipPath;t.isVertical()?(t._axis=new e.Path(s,e.PathUtils.roundedRectangle(0,-t.getBorderWidth("top"),i,t.getAxisLength(),0,0,0,0),"axis"),r.addRect(0,0,i,t._contentLength)):(t._axis=new e.Path(s,e.PathUtils.roundedRectangle(-t.getBorderWidth("left"),0,t.getAxisLength(),i,0,0,0,0),"axis"),r.addRect(0,0,t._contentLength,i)),t._axis.setCSSStyle(t._axisStyle);const o=t._axis.getElem();let a=t._axisStyle.getStyle("background-color");a&&e.ToolkitUtils.setAttrNullNS(o,"fill",a),a=t._axisStyle.getStyle("border-color"),a&&e.ToolkitUtils.setAttrNullNS(o,"stroke",a),a=t._axisStyle.getStyle("border-width"),a&&e.ToolkitUtils.setAttrNullNS(o,"stroke-width",a),t._axis.setPixelHinting(!0),t._axis.setClipPath(r),t.addChild(t._axis);const h=n.getAxisClass(t.Options)||"";t._axis.getElem().setAttribute("class",h),t._axis.getElem().setAttribute("stroke-dasharray",t.calcStrokeDashArray())},a._renderTicks=function(t,i,s){const r=i.getCtx(),o=e.Agent.isRightToLeft(r),a=i.isVertical()?i.getBorderWidth("left"):i.getBorderWidth("top"),h=a+i.getContentSize();let l="";for(let t=0;t<s.length-1;t++)i.isVertical()?l+=e.PathUtils.moveTo(a,s[t].pos)+e.PathUtils.horizontalLineTo(h):l+=o?e.PathUtils.moveTo(i._contentLength-s[t].pos,a)+e.PathUtils.verticalLineTo(h):e.PathUtils.moveTo(s[t].pos,a)+e.PathUtils.verticalLineTo(h);const c=new e.Path(i.getCtx(),l),u=new e.CSSStyle(n.getAxisSeparatorStyle(i.Options));c.setStroke(new e.Stroke(u.getStyle(e.CSSStyle.COLOR))),c.setPixelHinting(!0);const _=n.getAxisSeparatorClass(i.Options)||"";c.getElem().setAttribute("class",_),t.addChild(c)},a._renderLabels=function(t,i,s,r){const o=i.getCtx(),a=i.isVertical()?i.getBorderWidth("left"):i.getBorderWidth("top"),h=a+i.getContentSize(),l=e.Agent.isRightToLeft(o),c=n.getAxisLabelStyle(i.Options),u=n.getAxisLabelClass(i.Options)||"";for(let n=0;n<s.length-1;n++){const _=s[n].pos,g=s[n+1].pos,d=l?i._contentLength-(_+(g-_)/2):_+(g-_)/2,p=a+(h-a)/2,f=i.isVertical()?p:d,m=i.isVertical()?d:p,S=i.getContentSize(),T=g-_,v=i.isVertical()?S:T,y=i.isVertical()?T:S,x=new e.OutputText(o,r[n],f,0);if(x.setCSSStyle(c),x.getElem().setAttribute("class",u),x.alignCenter(),e.TextUtils.centerTextVertically(x,m),e.TextUtils.fitText(x,v,y,t),!i.isVertical())if(0===n&&s[n].date.getTime()<i._start){x.isTruncated()&&x.setTextString(x.getUntruncatedTextString());const s=x.getDimensions().w,r=g-Math.max(0,(g-_-s)/2),n=Math.max(0,r);l?(x.alignLeft(),x.setX(i._contentLength-n)):(x.alignRight(),x.setX(n));const o=e.TextUtils.fitText(x,r,y,t);if(x.isTruncated()&&o){const t=x.getTextString(),i=x.getUntruncatedTextString();if(t!==i){const t=x.getTextString().length-1,s=i.length,r=Math.max(0,s-t),n=e.OutputText.ELLIPSIS+i.substring(r,s);x.setTextString(n)}}}else if(n===s.length-2&&s[n+1].date.getTime()>i._end){x.isTruncated()&&x.setTextString(x.getUntruncatedTextString());const s=x.getDimensions().w,r=i._contentLength-_-Math.max(0,(g-_-s)/2),n=Math.max(_,_+(g-_)/2-s/2);l?(x.alignRight(),x.setX(i._contentLength-n)):(x.alignLeft(),x.setX(n)),e.TextUtils.fitText(x,r,y,t)}}};const h=function(t,e,i){this.Init(t,e,i)};e.Obj.createSubclass(h,e.BaseComponent),h.ORIENTATION_VERTICAL="vertical",h.newInstance=function(t,e,i){return new h(t,e,i)},h._VALID_SCALES=["seconds","minutes","hours","days","weeks","months","quarters","years"],h.prototype.Init=function(t,e,r){h.superclass.Init.call(this,t,e,r),this._calendar=new i,this._borderWidth=n.DEFAULT_BORDER_WIDTH,this.setBorderVisibility(!1,!1,!1,!1),this._dateToIsoWithTimeZoneConverter=t.getLocaleHelpers().dateToIsoWithTimeZoneConverter,this.Defaults=new s(t)},h.prototype.SetOptions=function(t){this.Options=this.Defaults.calcOptions(t)},h.prototype.Parse=function(t){return this._parser=new r,this._parser.parse(t)},h.prototype._applyParsedProperties=function(t){var e=t.orientation;this._isVertical=!(!e||e!==h.ORIENTATION_VERTICAL),this.setIsVertical(this._isVertical),this._shortDesc=t.shortDesc,this._zoomOrder=t.zoomOrder?t.zoomOrder.slice().reverse():[t.scale],this._customTimeScales=t.customTimeScales,this._customFormatScales=t.customFormatScales,this._start=t.start,this._end=t.end,this._inlineStyle=t.inlineStyle,this._scale=t.scale,this._converter=t.converter,this.applyStyleValues()},h.prototype.setContentLength=function(t,e){null==e&&(e=this._canvasLength),this._contentLength=e<t?t:e},h.prototype.getAxisLength=function(){return this._axisLength},h.prototype.isRTL=function(){return e.Agent.isRightToLeft(this.getCtx())},h.prototype.isVertical=function(){return this._isVertical},h.prototype.render=function(t,e,i){var s=t&&null==t._viewStartTime,r=null==t;this.Width=e,this.Height=i,this._prepareCanvasViewport(),s&&this.getPreferredLength(t,this._canvasLength),this.setContentLength(this._canvasLength),this._setAxisDimensions();var n=t&&t._viewStartTime?t._viewStartTime:this._start,o=t&&t._viewEndTime?t._viewEndTime:this._end,h=t&&t._throttle||!1;a.renderTimeAxis(this,n,o,h),(s||r)&&this.RenderComplete()},h.prototype.hasValidOptions=function(){var t=this._scale&&(-1!==h._VALID_SCALES.indexOf(this._scale)||this.isTimeComponentScale(this._scale)),e=this._scale&&this._customTimeScales&&this._customTimeScales[this._scale],i=this._start&&this._end&&this._end>this._start;return(t||e)&&i},h.prototype.isTimeComponentScale=function(t){return null!=t.getNextDate&&null!=t.getPreviousDate&&null!=t.formatter&&null!=t.name},h.prototype.isEqualScale=function(t,e){return t===e||null!=t.name&&null!=e&&t.name===e.name},h.prototype.applyStyleValues=function(){this._axisStyle=new e.CSSStyle(n.getAxisStyle(this.Options)),this._axisStyle.parseInlineStyle(this._inlineStyle);var t=this._axisStyle.getBorderWidth(),i="border:"+2*t+"px;";this._axisStyle.parseInlineStyle(i),this.setBorderWidth(t)},h.prototype._prepareCanvasViewport=function(){this._isVertical?(this._canvasLength=this.Height,this._canvasSize=this.Width):(this._canvasLength=this.Width,this._canvasSize=this.Height)},h.prototype._setAxisDimensions=function(){null!==this._canvasSize&&this.setContentSize(this._canvasSize-this.getSizeBorderWidth()),this._axisLength=this._contentLength+this.getSizeBorderWidth()-n.DEFAULT_SEPARATOR_WIDTH},h.prototype.getPreferredLength=function(t,e){this.SetOptions(t),this._resources=this.Options._resources?this.Options._resources:[],this._locale=this.Options._locale?this.Options._locale:"en-US";var i=this._resources.firstDayOfWeek?this._resources.firstDayOfWeek:0;this._calendar.setFirstDayOfWeek(i),this._dateToIsoWithTimeZoneConverter||(this._dateToIsoWithTimeZoneConverter=this.getCtx().getLocaleHelpers().dateToIsoWithTimeZoneConverter);var s=this.Parse(this.Options);if(this._applyParsedProperties(s),this.hasValidOptions()){this.setConverter(this._converter),this._isVertical?this.setDefaultConverter(this._resources.converterVert):this.setDefaultConverter(this._resources.converter),this._zoomLevelLengths=this._zoomOrder.map(function(){return 0});var r=this._zoomOrder.map(function(t,e){return e}),n=this._isVertical?{type:"range",params:{startTime:this._start,endTime:this._end}}:{type:"sparse",params:{numSections:4,numIntervalsPerSection:10}};this._maxContentLength=e,this.updateDimensions(r,n,e),null!==this._canvasSize&&(this._zoomLevelLengths[this._zoomLevelOrder]=e)}return this._contentLength},h.prototype.updateDimensions=function(t,e,i){for(var s=0;s<t.length;s++){var r=t[s];if(r>=0&&r<this._zoomOrder.length){var n,o=this._zoomOrder[r];if(this.isEqualScale(o,this._scale)&&(this._zoomLevelOrder=r),"sparse"===e.type){n=this._sampleIntervals(o,e.params.numSections,e.params.numIntervalsPerSection);var a=Object.keys(n),h=a.reduce(function(t,e){return t+(n[e]-e)},0)/a.length,l=(this._end-this._start)/h;this._maxContentLength=Math.max(this._maxContentLength,l*i)}else{n={};for(var c=this.getViewportDates(o,e.params.startTime,e.params.endTime),u=0;u<c.length-1;u++)n[c[u].getTime()]=c[u+1].getTime();this._maxContentLength=Math.max(this._maxContentLength,Object.keys(n).length*i)}this._updateZoomLevelLength(r,n)}}this.setContentLength(this._zoomLevelLengths[this._zoomLevelOrder],i)},h.prototype._updateZoomLevelLength=function(t,i){var s=this.getCtx(),r=n.getAxisLabelStyle(this.Options),o=2*n.DEFAULT_INTERVAL_PADDING,a=e.TextUtils.getTextStringHeight(this.getCtx(),r)+o,h=this._zoomOrder[t],l=n.DEFAULT_INTERVAL_WIDTH,c=1/0,u=1/0;Object.keys(i).forEach(function(t){var n=i[t],_=this.formatDate(new Date(n),null,"axis",h),g=e.TextUtils.getTextStringWidth(s,_,r)+o;l=Math.max(l,g),c=Math.min(c,(n-t)/l),u=Math.min(u,(n-t)/a)},this);var _=this._isVertical?u:c,g=(this._end-this._start)/_;this._zoomLevelLengths[t]=g,this.setContentSize(this._isVertical?l:a)},h.prototype._sampleIntervals=function(t,e,i){for(var s={},r=Math.floor((this._end-this._start)/e),n=0;n<e;n++){for(var o=this._start+r*n,a=Math.min(this._start+r*(n+1),this._end),h=this.adjustDate(o,t).getTime(),l=0;l<i&&!(h>=a);l++){var c=this.getNextDate(h,t).getTime();s[h]=c,h=c}s[h=this.adjustDate(a-1,t).getTime()]=this.getNextDate(h,t).getTime()}return s},h.prototype.getViewportDates=function(t,e,i){const s=[this.adjustDate(e,t)];for(;s[s.length-1].getTime()<i;)s.push(this.getNextDate(s[s.length-1].getTime(),t));return s},h.prototype.getDateLabelTexts=function(t,e){return t.map(function(t){return this.formatDate(t,null,"axis",e)},this)},h.prototype.setScale=function(t){this._scale=t},h.prototype.getScale=function(){return this._scale},h.prototype.increaseScale=function(){for(var t=0;t<this._zoomOrder.length-1;t++)if(this.isEqualScale(this._zoomOrder[t],this._scale))return this._scale=this._zoomOrder[t+1],!0;return!1},h.prototype.decreaseScale=function(){for(var t=1;t<this._zoomOrder.length;t++)if(this._zoomOrder[t]===this._scale)return this._scale=this._zoomOrder[t-1],!0;return!1},h.prototype.setConverter=function(t){this._converter=t},h.prototype.setDefaultConverter=function(t){this._defaultConverter=t},h.prototype.getContentSize=function(){return this._contentSize},h.prototype.setContentSize=function(t){t>this._contentSize&&(this._contentSize=t)},h.prototype.setBorderWidth=function(t){this._borderWidth=t},h.prototype.setBorderVisibility=function(t,e,i,s){this._borderTopWidth=(0|t)*this._borderWidth,this._borderRightWidth=(0|e)*this._borderWidth,this._borderBottomWidth=(0|i)*this._borderWidth,this._borderLeftWidth=(0|s)*this._borderWidth},h.prototype.calcStrokeDashArray=function(){if(this._isVertical)var t={top:this.getSize(),right:this.getAxisLength(),bottom:this.getSize(),left:this.getAxisLength()};else t={top:this.getAxisLength(),right:this.getSize(),bottom:this.getAxisLength(),left:this.getSize()};for(var e=[],i=0,s=!0,r=["top","right","bottom","left"],n=0;n<r.length;n++){this.getBorderWidth(r[n])>0===s?i+=t[r[n]]:(e.push(i),i=t[r[n]],s=!s)}return e.push(i),e.toString()},h.prototype.getSizeBorderWidth=function(){return this._borderTopWidth+this._borderBottomWidth},h.prototype.getBorderWidth=function(t){switch(t){case"top":return this._borderTopWidth;case"right":return this._borderRightWidth;case"bottom":return this._borderBottomWidth;case"left":return this._borderLeftWidth;default:return this._borderWidth}},h.prototype.getSize=function(){return this._contentSize+this.getSizeBorderWidth()},h.prototype.adjustDate=function(t,e){var i=e||this._scale;return this.isTimeComponentScale(i)?new Date(i.getPreviousDate(new Date(t))):this._calendar.adjustDate(new Date(t),i)},h.prototype.getNextDate=function(t,e){var i=e||this._scale;return this.isTimeComponentScale(i)?new Date(i.getNextDate(new Date(t))):this.getAdjacentDate(t,i,"next")},h.prototype.getAdjacentDate=function(t,e,i){var s=e||this._scale;if(this.isTimeComponentScale(s)){let e=new Date(s.getNextDate(new Date(t)));return"next"===i?e:new Date(2*t-e)}return this._calendar.getAdjacentDate(t,e,i)},h.prototype.formatDate=function(t,e,i,s){var r=s||this.getScale();if(this.isTimeComponentScale(r))return r.formatter(this._dateToIsoWithTimeZoneConverter?this._dateToIsoWithTimeZoneConverter(t):t);if("axis"===(i=i||"axis"))(e=e||this._converter)&&(e[r]?e=e[r]:e.default&&(e=e.default)),e&&e.format||!this._defaultConverter||!this._defaultConverter[r]||(e=this._defaultConverter[r]);else if(!e){var n=this._resources.defaultDateTimeConverter,o=this._resources.defaultDateConverter;e="hours"===r||"minutes"===r||"seconds"===r?n:o}return e.format(this._dateToIsoWithTimeZoneConverter?this._dateToIsoWithTimeZoneConverter(t):t)},h.prototype.getZoomOrder=function(){return this._zoomOrder},h.prototype.setIsVertical=function(t){this._contentSize=t?n.DEFAULT_INTERVAL_WIDTH:n.DEFAULT_INTERVAL_HEIGHT},h.prototype.setCanvasSize=function(t){this._canvasSize=t},h.prototype.getZoomLevelLengths=function(){return this._zoomLevelLengths},h.prototype.getMaxContentLength=function(){return this._maxContentLength},h.prototype.getZoomLevelOrder=function(){return this._zoomLevelOrder},h.prototype.setZoomLevelOrder=function(t){this._zoomLevelOrder=t},t.TimeAxis=h,t.TimeAxisUtils=o,Object.defineProperty(t,"__esModule",{value:!0})});
//# sourceMappingURL=ojtimeaxis-toolkit.js.map