/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojdvt-toolkit","ojs/ojdvt-timecomponent","ojs/ojtimeaxis-toolkit","ojs/ojdvt-overview"],function(e,t,i,s,r){"use strict";var a=function(e){this.Init(e)};t.Obj.createSubclass(a,i.TimeComponentKeyboardHandler),a.getNextNavigable=function(e,i,s){var r=e.getSeries(),n=e.getSeriesIndex(),o=t.Agent.isRightToLeft(r.getCtx()),l=r.isVertical(),h=s.length>1;if(!o&&t.KeyboardEvent.RIGHT_ARROW===i.keyCode||o&&t.KeyboardEvent.LEFT_ARROW===i.keyCode){if(!l)return a.getNextItem(e,s[n],!0);if(h&&1!==n)return a.getClosestItem(e,s[1])}else if(!o&&t.KeyboardEvent.LEFT_ARROW===i.keyCode||o&&t.KeyboardEvent.RIGHT_ARROW===i.keyCode){if(!l)return a.getNextItem(e,s[n],!1);if(h&&0!==n)return a.getClosestItem(e,s[0])}else if(t.KeyboardEvent.DOWN_ARROW===i.keyCode){if(l)return a.getNextItem(e,s[n],!0);if(h&&1!==n)return a.getClosestItem(e,s[1])}else if(t.KeyboardEvent.UP_ARROW===i.keyCode){if(l)return a.getNextItem(e,s[n],!1);if(h&&0!==n)return a.getClosestItem(e,s[0])}return null},a.getNextItem=function(e,t,i){var s=t.indexOf(e)+(i?1:-1);return s>=0&&s<t.length?t[s]:null},a.getClosestItem=function(e,t){if(t.length>0){for(var i=t[0],s=e.getLoc(),r=Math.abs(s-i.getLoc()),a=1;a<t.length;a++){var n=Math.abs(s-t[a].getLoc());n<r&&(r=n,i=t[a])}return i}return null};var n=new Object;t.Obj.createSubclass(n,t.Obj),n.getDatatipColor=function(e){var t=e.getDurationFillColor();return t||null},n.getDatatip=function(e,i,s){var r=e._timeline,a=r.getOptions().tooltip,o=a?a.renderer:null;if(i&&o){var l=r.getCtx().getTooltipManager(),h=e.getDataContext();return l.getCustomTooltip(o,h)}var _=e.getShortDesc();if(null!=_)return _;if(s&&!r.getCtx().isCustomElement()){var c=r.getOptions().translations,u=e.getStartTime(),g=r.getTimeAxis().formatDate(new Date(u),null,"general"),d=t.ResourceUtils.format(c.accessibleItemStart,[g]),m=e.getEndTime();if(m&&m!==u){var S=r.getTimeAxis().formatDate(new Date(m),null,"general");d=d+" "+t.ResourceUtils.format(c.accessibleItemEnd,[S])}var p=e.getTitle();null!=p&&""!==p&&(d=d+" "+t.ResourceUtils.format(c.accessibleItemTitle,[p]));var f=e.getDescription();return null!=f&&""!==f&&(d=d+" "+t.ResourceUtils.format(c.accessibleItemDesc,[f])),d}var v=[];return n._addItemDatatip(v,e,i),n._processDatatip(v,r,i)},n._processDatatip=function(e,i,s){return 0===e.length?null:s?t.HtmlTooltipManager.createElement("table",null,e,["oj-dvt-datatip-table"]):e.join("")},n._addItemDatatip=function(e,t,i){var s=t._timeline,r=t.getTitle();r&&n._addDatatipRow(e,s,"title","Title",r,i);var a=t.getDescription();a&&n._addDatatipRow(e,s,"description","Description",a,i);var o=t.getStartTime(),l=t.getEndTime();o&&l&&l!==o?(n._addDatatipRow(e,s,"start","Start",o,i),n._addDatatipRow(e,s,"end","End",l,i)):n._addDatatipRow(e,s,"date","Date",o,i);var h=t._series.getLabel();null==h&&(h=t._series.getId()),n._addDatatipRow(e,s,"series","Series",h,i)},n._addDatatipRow=function(e,i,s,r,a,o,l){if(null!=a&&""!==a){var h,_=i.getOptions().styleDefaults,c=n.getValueFormat(i,s),u=c.tooltipDisplay,g=i.getOptions().translations;if("off"!==u)if("string"==typeof c.tooltipLabel&&(h=c.tooltipLabel),null==h&&(h=null==r?"":g["label"+r]),a=n.formatValue(i,s,c,a),o){var d=[t.HtmlTooltipManager.createElement("td",_.tooltipLabelStyle,h,["oj-dvt-datatip-label"]),t.HtmlTooltipManager.createElement("td",_.tooltipValueStyle,a,["oj-dvt-datatip-value"])];e.push(t.HtmlTooltipManager.createElement("tr",null,d))}else e.push((e.length>0?"<br>":"")+t.ResourceUtils.format(g.labelAndValue,[h,a]))}},n.getValueFormat=function(e,t){var i=e.getOptions().valueFormats;if(!i)return{};if(i instanceof Array){for(var s={},r=0;r<i.length;r++){var a=i[r];s[a.type]=a}e.getOptions().valueFormats=s,i=s}return i[t]?i[t]:{}},n.formatValue=function(e,t,i,s){var r=i.converter;return"start"===t||"end"===t||"date"===t?e.getTimeAxis().formatDate(new Date(s),r,"general"):r&&r.format?r.format(s):s};var o=function(e,t,i){this.Init(e,t,i)};t.Obj.createSubclass(o,t.Obj),o.prototype.Init=function(e,t,i){this._timeline=e,this._seriesIndex=t,this._series=e._series[t],this._id=i.id,this._rowKey=i.rowKey,this._startTime=parseInt(i.startTime),i.endTime&&(this._endTime=parseInt(i.endTime)),this._title=i.title,this._desc=i.desc,this._thumbnail=i.thumbnail,this._shortDesc=i.shortDesc,this._style=i.style,this._data=i.data,this._durationFillColor=i.durationFillColor,this._durationSize=0,this._markerShape=i.markerShape,this._markerScaleX=i.markerScaleX,this._markerScaleY=i.markerScaleY,this._markerShortDesc=i.markerShortDesc,this._markerFillColor=i.markerFillColor,this._markerGradientFill=i.markerGradientFill,this._markerOpacity=i.markerOpacity,this._markerSD=i.markerSD,this._data=i.data,this._state={focused:!1,hovered:!1,selected:!1},this._previousState={focused:!1,hovered:!1,selected:!1}},o.prototype.getId=function(){return this._id},o.prototype.getSeries=function(){return this._series},o.prototype.getSeriesIndex=function(){return this._seriesIndex},o.prototype.getRowKey=function(){return this._rowKey},o.prototype.getStartTime=function(){return this._startTime},o.prototype.setStartTime=function(e){this._startTime=e},o.prototype.getEndTime=function(){return this._endTime},o.prototype.setEndTime=function(e){this._endTime=e},o.prototype.getTitle=function(){return this._title},o.prototype.getDescription=function(){return this._desc},o.prototype.getThumbnail=function(){return this._thumbnail},o.prototype.getShortDesc=function(){var e=this._shortDesc;return"function"==typeof e?e(o.getShortDescContext(this)):e},o.prototype.getStyle=function(){return this._style},o.prototype.setStyle=function(e){this._style=e},o.prototype.getBubble=function(){return this._displayable},o.prototype.setBubble=function(e){this._displayable=e},o.prototype.getFeeler=function(){return this._feeler},o.prototype.setFeeler=function(e){this._feeler=e},o.prototype.getDurationBar=function(){return this._durationBar},o.prototype.setDurationBar=function(e){this._durationBar=e},o.prototype.getLoc=function(){return this._loc},o.prototype.setLoc=function(e){this._loc=e},o.prototype.getSpacing=function(){return this._spacing},o.prototype.setSpacing=function(e){this._spacing=e},o.prototype.getDurationLevel=function(){return this._durationLevel},o.prototype.setDurationLevel=function(e){this._durationLevel=e},o.prototype.getDurationSize=function(){return this._durationSize},o.prototype.setDurationSize=function(e){this._durationSize=e},o.prototype.getDurationFillColor=function(){return this._durationFillColor},o.prototype.setDurationFillColor=function(e){this._durationFillColor=e},o.prototype.getLabel=function(){var e=this._timeline.getOptions().translations,i=this.getStartTime(),s=this._timeline.getTimeAxis().formatDate(new Date(i),null,"general"),r=t.ResourceUtils.format(e.accessibleItemStart,[s]),a=this.getEndTime();if(null!=a&&a!==i){var n=this._timeline.getTimeAxis().formatDate(new Date(a),null,"general");r=r+" "+t.ResourceUtils.format(e.accessibleItemEnd,[n])}var o=this.getTitle();null!=o&&""!==o&&(r=r+" "+t.ResourceUtils.format(e.accessibleItemTitle,[o]));var l=this.getDescription();return null!=l&&""!==l&&(r=r+" "+t.ResourceUtils.format(e.accessibleItemDesc,[l])),r},o.prototype.getWidth=function(){return this._w},o.prototype.setWidth=function(e){this._w=e},o.prototype.getHeight=function(){return this._h},o.prototype.setHeight=function(e){this._h=e},o.prototype.getMarkerShape=function(){return this._markerShape},o.prototype.getMarkerScaleX=function(){return this._markerScaleX},o.prototype.getMarkerScaleY=function(){return this._markerScaleY},o.prototype.getMarkerShortDesc=function(){return this._markerShortDesc},o.prototype.getMarkerFillColor=function(){return this._markerFillColor},o.prototype.getMarkerGradientFill=function(){return this._markerGradientFill},o.prototype.getMarkerOpacity=function(){return this._markerOpacity},o.prototype.getMarkerSD=function(){return this._markerSD},o.prototype.getNextNavigable=function(e){var i=this._timeline.EventManager.getKeyboardHandler();if(e.type===t.MouseEvent.CLICK||i.isMultiSelectEvent(e))return this;if(i.isNavigationEvent(e)){for(var s=[],r=0;r<this._timeline._series.length;r++)s.push(this._timeline._series[r]._items);return a.getNextNavigable(this,e,s)}return null},o.prototype.getTargetElem=function(){return this._displayable.getElem()},o.prototype.getKeyboardBoundingBox=function(e){return this._displayable.getDimensions(e)},o.prototype.showKeyboardFocusEffect=function(){this._isShowingKeyboardFocusEffect=!0,this.showHoverEffect(),this._timeline.updateScrollForItemNavigation(this)},o.prototype.hideKeyboardFocusEffect=function(){this._isShowingKeyboardFocusEffect=!1,this.hideHoverEffect()},o.prototype.isShowingKeyboardFocusEffect=function(){return this._isShowingKeyboardFocusEffect},o.prototype.getDisplayables=function(){return[this._displayable]},o.prototype.getAriaLabel=function(){var e=[];this.isSelectable()&&e.push(this._timeline.getOptions().translations[this.isSelected()?"stateSelected":"stateUnselected"]);var i=n.getDatatip(this,!1);return t.Displayable.generateAriaLabel(i,e)},o.prototype.getData=function(e){return e?i.TimeComponent.sanitizeData(this._data,"item"):this._data},o.prototype.getRendererContext=function(){var e=this.getData()._itemData;return{data:this.getData(!0),itemData:e||null,seriesData:this._series.getData(!0),previousState:this._previousState,state:this._state}},o.prototype.getDataContext=function(){var e=this.getData()._itemData;return{data:this.getData(!0),seriesData:this._series.getData(!0),itemData:e||null,color:n.getDatatipColor(this),component:this._timeline.getOptions()._widgetConstructor}},o.getShortDescContext=function(e){var t=e.getData()._itemData;return{data:e.getData(!0),seriesData:e._series.getData(!0),itemData:t||null}},o.prototype.getDatatip=function(){return n.getDatatip(this,!0)},o.prototype.getDatatipColor=function(){return n.getDatatipColor(this)},o.prototype.setSelectable=function(e){this._isSelectable=e},o.prototype.isSelectable=function(){return this._isSelectable},o.prototype.isSelected=function(){return this._isSelected},o.prototype.setSelected=function(e){this._isSelected=e,this._displayable.setSelected(e),this._updateAriaLabel(),this._timeline._hasOverview&&this._timeline._overview&&(e?(this.changeState("selected",!0,!0),this._timeline._overview.selSelectItem(this.getId())):(this.changeState("selected",!1,!0),this._timeline._overview.selUnselectItem(this.getId())))},o.prototype.changeState=function(e,t,i){i?(this._previousState=this._state,this._state={focused:!1,hovered:!1,selected:!1},this._state[e]=t):this._state[e]=t},o.prototype.showHoverEffect=function(e){var t=this._timeline.EventManager.getFocus()===this;this.changeState("focused",t,!0),this._displayable.showHoverEffect(t),this.changeState("hovered",!0),!e&&this._timeline._hasOverview&&this._timeline._overview.highlightItem(this.getId()),(this._timeline._isVertical||this._series._isRandomItemLayout)&&(this._index||(this._index=this._series._blocks[0].getChildIndex(this.getBubble())),this._series._blocks[0].addChild(this.getBubble()))},o.prototype.hideHoverEffect=function(e){var t=this._timeline.EventManager.getFocus()===this;this.changeState("focused",t,!0),this._displayable.hideHoverEffect(t),this.changeState("hovered",!1),!e&&this._timeline._hasOverview&&this._timeline._overview.unhighlightItem(this.getId()),(this._timeline._isVertical||this._series._isRandomItemLayout)&&this._index&&!this._isSelected&&this._series._blocks[0].addChildAt(this.getBubble(),this._index)},o.prototype._updateAriaLabel=function(){t.Agent.deferAriaCreation()||this._displayable.setAriaProperty("label",this.getAriaLabel())};var l=function(e){this._timeline=e};t.Obj.createSubclass(l,t.Automation),l.TIMELINE_ITEM_STRING="timelineItem",l.prototype.GetSubIdForDomElement=function(e){var t=this._timeline.EventManager.GetLogicalObject(e);if(t&&t instanceof o)for(var i=0;i<this._timeline._series.length;i++){var s=this._timeline._series[i]._items.indexOf(t);if(-1!==s)return l.TIMELINE_ITEM_STRING+"["+i+"]["+s+"]"}return null},l.prototype.getDomElementForSubId=function(e){if(e===t.Automation.TOOLTIP_SUBID)return this.GetTooltipElement(this._timeline);if(e&&this._timeline.hasValidOptions()){var i=e.indexOf("[");if(i>0&&e.substring(0,i)===l.TIMELINE_ITEM_STRING){var s=e.indexOf("]");if(s>0){var r=parseInt(e.substring(i+1,s)),a=parseInt(e.substring(s+2,e.length-1)),n=this._timeline._series[r];if(n){var o=n._items[a];if(o)return o.getDisplayables()[0].getElem()}}}}return null};var h=function(e){this.Init({alta:h.VERSION_1},e)};t.Obj.createSubclass(h,t.BaseComponentDefaults),h.VERSION_1={},h.prototype.getNoCloneObject=function(){return{majorAxis:{scale:!0},minorAxis:{scale:!0,zoomOrder:!0}}};var _=function(e){_.superclass.constructor.call(this,e)};t.Obj.createSubclass(_,i.TimeComponentEventManager),_.prototype.addListeners=function(e){if(_.superclass.addListeners.call(this,e),!t.Agent.isTouchDevice()&&("ie"===t.Agent.browser||"edge"===t.Agent.browser)){var i=this.getCtx().getStage();i.addEvtListener("mouseenter",this.OnMouseEnter,!1,this),i.addEvtListener("mouseleave",this.OnMouseLeave,!1,this)}},_.prototype.RemoveListeners=function(e){if(_.superclass.RemoveListeners.call(this,e),!t.Agent.isTouchDevice()&&("ie"===t.Agent.browser||"edge"===t.Agent.browser)){var i=this.getCtx().getStage();i.removeEvtListener("mouseenter",this.OnMouseEnter,!1,this),i.removeEvtListener("mouseleave",this.OnMouseLeave,!1,this)}},_.prototype.PreOnMouseOver=function(e){this._mouseOutTimer&&this._mouseOutTimer.isRunning()&&this._mouseOutTimer.stop(),_.superclass.PreOnMouseOver.call(this,e),"ie"===t.Agent.browser||"edge"===t.Agent.browser||this.isMouseOver||(this.isMouseOver=!0)},_.prototype.OnMouseEnter=function(e){this._mouseOutTimer&&this._mouseOutTimer.isRunning()&&this._mouseOutTimer.stop(),this.isMouseOver||(this.isMouseOver=!0)},_.prototype.OnMouseLeave=function(e){this._mouseOutTimer||(this._mouseOutTimer=new t.Timer(this.getCtx(),10,this._onMouseOutTimerEnd,this,1)),this._mouseOutTimer.reset(),this._mouseOutTimer.start()},_.prototype.PreOnMouseOut=function(e){_.superclass.PreOnMouseOut.call(this,e),"ie"!==t.Agent.browser&&"edge"!==t.Agent.browser&&(this._mouseOutTimer||(this._mouseOutTimer=new t.Timer(this.getCtx(),10,this._onMouseOutTimerEnd,this,1)),this._mouseOutTimer.reset(),this._mouseOutTimer.start())},_.prototype._onMouseOutTimerEnd=function(){this.isMouseOver=!1},_.prototype.panBy=function(e,t){var i=this.getFocus();i&&(this._comp._dragPanSeries=i._series),_.superclass.panBy.call(this,e,t)};var c=function(){};t.Obj.createSubclass(c,t.Obj),c.prototype.parse=function(e){var t=new Object;t.start=new Date(e.start).getTime(),t.end=new Date(e.end).getTime(),e.viewportStart&&(t.viewStart=new Date(e.viewportStart).getTime()),e.viewportEnd&&(t.viewEnd=new Date(e.viewportEnd).getTime()),e.selectionMode?t.selectionMode=e.selectionMode:t.selectionMode="none",t.inlineStyle=e.style,e.svgStyle&&(t.inlineStyle=e.svgStyle);var i=e.minorAxis;if(i){var s=i.scale;t.scale=s,t.customFormatScales=i._cfs}var r=e.majorAxis;r&&(t.seriesScale=r.scale,t.seriesConverter=r.converter,t.seriesCustomFormatScales=r._cfs),t.shortDesc=e.shortDesc,t.orientation=e.orientation;var a=e.referenceObjects;if(a&&a.length>0){for(var n=[],o=0;o<a.length;o++)n.push(new Date(a[o].value));t.referenceObjects=n}var l=e.overview;return null!=l&&"on"===l.rendered?t.hasOverview=!0:t.hasOverview=!1,t.itemPosition=e._ip,t.customTimeScales=e._cts,t};var u=function(){this.Init({alta:u.VERSION_1})};t.Obj.createSubclass(u,t.BaseComponentDefaults),u.VERSION_1={overviewPosition:"below",style:{borderTopStyle:"none",currentTimeIndicatorColor:"#c000d1",handleFillColor:"#ffffff",handleTextureColor:"#b3c6db",leftFilterPanelAlpha:.7,leftFilterPanelColor:"#ffffff",overviewBackgroundColor:"#e6ecf3",rightFilterPanelAlpha:.7,rightFilterPanelColor:"#ffffff",timeAxisBarColor:"#d9dfe3",timeAxisBarAlpha:0,timeIndicatorColor:"#bcc7d2",windowBackgroundAlpha:1,windowBackgroundColor:"#ffffff",windowBorderBottomColor:"#4f4f4f",windowBorderBottomStyle:"solid",windowBorderLeftColor:"#4f4f4f",windowBorderLeftStyle:"solid",windowBorderRightColor:"#4f4f4f",windowBorderRightStyle:"solid",windowBorderTopColor:"#4f4f4f",windowBorderTopStyle:"solid"},_fc:"#aadd77",_do:0,_bc:"#648baf",_bof:"0px",_bs:"solid",_bw:"1px",_dbc:"#648baf",_dbs:"solid",_dbw:"1px",_hbc:"#85bbe7",_hbs:"solid",_hbw:"2px",_hbof:"0px",_hgc:"#ebeced",_hgo:1,_hdbs:"solid",_hdbc:"#85bbe7",_hdbw:"2px",_sbs:"solid",_sbc:"#000000",_sbw:"2px",_sbof:"0px",_sbo:1,_sdbs:"solid",_sdbc:"#000000",_sdbw:"2px",_asbs:"solid",_asbc:"#000000",_asbw:"2px",_asbof:"0px",_asbo:1,_asgc:"#e4f0fa",_asgo:1,_asdbs:"solid",_asdbc:"#000000",_asdbw:"2px",_aoc:"off"};var g=function(e,t){this.Init(e,t)};t.Obj.createSubclass(g,t.Obj),g.prototype.Init=function(e,i){this._view=e,this._rowKey=i.rowKey,this._id=i.id,this._seriesId=i.seriesId,this._time=parseInt(i.time),this._endTime=null==i.endTime?null:parseInt(i.endTime),this._shape=t.SimpleMarker.CIRCLE,"square"===i.shape?this._shape=t.SimpleMarker.RECTANGLE:"plus"===i.shape?this._shape=t.SimpleMarker.PLUS:"diamond"===i.shape?this._shape=t.SimpleMarker.DIAMOND:"triangleUp"===i.shape?this._shape=t.SimpleMarker.TRIANGLE_UP:"triangleDown"===i.shape&&(this._shape=t.SimpleMarker.TRIANGLE_DOWN),this._desc=i.desc,this._color=i.color,this._gradient=i.gradient,null!=i.opacity&&(this._opacity=parseFloat(i.opacity)),null!=i.scaleX&&(this._scaleX=parseFloat(i.scaleX)),null!=i.scaleY&&(this._scaleY=parseFloat(i.scaleY)),null!=i.durationFillColor&&(this._durationFillColor=i.durationFillColor)},g.prototype.getId=function(){return this._id},g.prototype.getSeriesId=function(){return this._seriesId},g.prototype.getRowKey=function(){return this._rowKey},g.prototype.getTime=function(){return this._time},g.prototype.getEndTime=function(){return this._endTime},g.prototype.getScaleX=function(){return this._scaleX},g.prototype.getScaleY=function(){return this._scaleY},g.prototype.getDescription=function(){return this._desc},g.prototype.getColor=function(){return this._color},g.prototype.isGradient=function(){return this._gradient},g.prototype.getShape=function(){return this._shape},g.prototype.getOpacity=function(){return this._opacity},g.prototype.getDisplayable=function(){return this._displayable},g.prototype.setDisplayable=function(e){this._displayable=e},g.prototype.getX=function(){return this._x},g.prototype.setX=function(e){this._x=e},g.prototype.getY=function(){return this._y},g.prototype.setY=function(e){this._y=e};var d=new Object;t.Obj.createSubclass(d,t.Obj),d.getDefaultMarkerShape=function(e){return e._ds},d.getDefaultMarkerScaleX=function(e){return e._dsx},d.getDefaultMarkerScaleY=function(e){return e._dsy},d.getDefaultMarkerOpacity=function(e){return e._do},d.getDefaultMarkerFillColor=function(e){return e._fc},d.getDefaultMarkerPixelHinting=function(e){return e._ph},d.getDefaultMarkerBorderStyles=function(e){var t=new Object;return t._bs=e._bs,t._bc=e._bc,t._bw=e._bw,t._bof=e._bof,t._bo=e._bo,t._gc=e._gc,t._go=e._go,t._dbs=e._dbs,t._dbc=e._dbc,t._dbw=e._dbw,t._hbs=e._hbs,t._hbc=e._hbc,t._hbw=e._hbw,t._hbof=e._hbof,t._hbo=e._hbo,t._hgc=e._hgc,t._hgo=e._hgo,t._hdbs=e._hdbs,t._hdbc=e._hdbc,t._hdbw=e._hdbw,t._sbs=e._sbs,t._sbc=e._sbc,t._sbw=e._sbw,t._sbof=e._sbof,t._sbo=e._sbo,t._sgc=e._sgc,t._sgo=e._sgo,t._sdbs=e._sdbs,t._sdbc=e._sdbc,t._sdbw=e._sdbw,t._asbs=e._asbs,t._asbc=e._asbc,t._asbw=e._asbw,t._asbof=e._asbof,t._asbo=e._asbo,t._asgc=e._asgc,t._asgo=e._asgo,t._asdbs=e._asdbs,t._asdbc=e._asdbc,t._asdbw=e._asdbw,t};var m=function(e){this.Init(e)};t.Obj.createSubclass(m,r.OverviewParser),m.prototype.Init=function(e){this._view=e},m.prototype.parse=function(e){var t=this.ParseRootAttributes(e);return t.timeAxisInfo=this._parseTimeAxis(e.axisTicks),t.markers=this._parseDataNode(e.markers,t.defaultMarkerStyles),t.formattedTimeRanges=e.formattedTimeRanges,t},m.prototype.ParseRootAttributes=function(e){var t=m.superclass.ParseRootAttributes.call(this,e);t.currentTime=parseInt(e.ocd),t.orientation=e.orn,t.selectionMode=e.selmode,t.isRtl=e.rtl.toString(),t.seriesIds=e.sid,t.animationOnClick=e._aoc;var i=new Object;return i.shape=d.getDefaultMarkerShape(e),i.scaleX=d.getDefaultMarkerScaleX(e),i.scaleY=d.getDefaultMarkerScaleY(e),i.opacity=d.getDefaultMarkerOpacity(e),i.color=d.getDefaultMarkerFillColor(e),i.pixelHinting=d.getDefaultMarkerPixelHinting(e),t.defaultMarkerStyles=i,t.labelStyle=e._ls,t},m.prototype._parseDataNode=function(e,t){if(e){for(var i=[],s=0;s<e.length;s++){var r=this.ParseNodeAttributes(e[s],t),a=new g(this._view,r);i.push(a)}return i}return null},m.prototype.ParseNodeAttributes=function(e,t){var i=new Object,s="true"===e._sd;return i.id=e.tid,i.seriesId=e.sid,i.rowKey=e.rk,i.time=e.t,i.endTime=e.et,i.shape=e.s,s&&null==i.shape&&(i.shape=t.shape),i.desc=e.d,i.color=e.c,i.durationFillColor=e.dfc,s&&null==i.color&&(i.color=t.color),i.scaleX=e.sx,s&&null==i.scaleX&&(i.scaleX=t.scaleX),i.scaleY=e.sy,s&&null==i.scaleY&&(i.scaleY=t.scaleY),i.gradient=e.g,i.opacity=e.o,s&&null==i.opacity&&(i.opacity=t.opacity),i},m.prototype._parseTimeAxis=function(e){if(e){var t=new Object;return t.width=null,t.height=null,t.ticks=e,t}return null};const S=function(e,t,i){this.Init(e,t,i)};t.Obj.createSubclass(S,r.Overview),S.ENABLED_STATE="_",S.HOVER_STATE="_h",S.SELECTED_STATE="_s",S.ACTIVE_SELECTED_STATE="_as",S.BORDER_STYLE="bs",S.BORDER_COLOR="bc",S.BORDER_WIDTH="bw",S.DURATION_BORDER_STYLE="dbs",S.DURATION_BORDER_COLOR="dbc",S.DURATION_BORDER_WIDTH="dbw",S.BORDER_OFFSET="bof",S.BORDER_OPACITY="bo",S.GLOW_COLOR="gc",S.GLOW_OPACITY="go",S.FILL_COLOR="fc",S.newInstance=function(e,t,i){return new S(e,t,i)},S.prototype.Init=function(e,i,s){S.superclass.Init.call(this,e,i,s);var a=[t.ColorUtils.getPound(t.ColorUtils.getBrighter("#aadd77",.35)),"#aadd77",t.ColorUtils.getPound(t.ColorUtils.getDarker("#aadd77",.5))];r.OverviewUtils.supportsTouch()&&(a=["#aadd77"]),null!=s&&(this._durationColors=s.getOptions().styleDefaults.series.colors),this._defColors=a,this._markerBorderFill=t.SolidFill.invisibleFill(),this._markerSize=12},S.prototype.initDefaults=function(){this.Defaults=new u},S.prototype.getParser=function(e){return new m(this)},S.prototype._applyParsedProperties=function(e){S.superclass._applyParsedProperties.call(this,e),this._selectionMode=e.selectionMode,this._markers=e.markers,this._seriesIds=e.seriesIds,this._defaultMarkerStyles=e.defaultMarkerStyles,this._borderStyles=d.getDefaultMarkerBorderStyles(this.Options),e.labelStyle&&(this._labelStyle=new t.CSSStyle(e.labelStyle));if("solid"===this.getStyle(S.ENABLED_STATE,S.BORDER_STYLE))var i=parseInt(this.getStyle(S.ENABLED_STATE,S.BORDER_OFFSET),10);else i=1;if("solid"===this.getStyle(S.ACTIVE_SELECTED_STATE,S.BORDER_STYLE))var s=parseInt(this.getStyle(S.ACTIVE_SELECTED_STATE,S.BORDER_OFFSET),10);else s=1;if("solid"===this.getStyle(S.SELECTED_STATE,S.BORDER_STYLE))var r=parseInt(this.getStyle(S.SELECTED_STATE,S.BORDER_OFFSET),10);else r=1;this.isItemSelectionEnabled()?this._markerSpacingOffset=Math.max(s,r,i,1)/2+1:this._markerSpacingOffset=1,this._defOpacity=this.isVertical()?0:.75,this._defAlphas=[this._defOpacity,this._defOpacity,this._defOpacity],this._radialFill=new t.LinearGradientFill(250,this._defColors,this._defAlphas),this._linearFill=new t.LinearGradientFill(180,this._defColors,this._defAlphas);var a=this.isVertical()?0:1;this._border=new t.Stroke("#aadd77",a)},S.prototype.getSeriesIds=function(){return null==this._seriesIds?null:this._seriesIds.split(" ")},S.prototype.isItemSelectionEnabled=function(){return"none"!==this._selectionMode},S.prototype.getDrawableById=function(e){for(var i=this.getNumChildren(),s=0;s<i;s++){var r=this.getChildAt(s);if(r&&r._node&&t.Obj.compareValues(this.getCtx(),e,r._node.getId()))return r}return null},S.prototype.getItemId=function(e){return e._node?e._node.getId():e.getId().substr(5)},S.prototype.getStyle=function(e,t){return this._borderStyles[e+t]},S.prototype.getX=function(e){return null!=e._node?e._node.getX():e.getMatrix().getTx()},S.prototype.getY=function(e){return null!=e._node?e._node.getY():e.getMatrix().getTy()},S.prototype.getScaleX=function(e){var t=e.getScaleX();return null==t&&(t=this.isVertical()?(this.Width-this.getTimeAxisWidth()-4)/2:1),t},S.prototype.getScaleY=function(e){var t=e.getScaleY();return null==t&&(t=1),t},S.prototype.renderData=function(e,t){if(S.superclass.renderData.call(this,e,t),null!=this._markers){if(this.isVertical())var i=this._yMin,s=this._yMax;else i=this._xMin,s=this._xMax;for(var r=this.calculateOptimalSize(i,s,e,t,this._markerSize),a=[],n=0;n<this._markers.length;n++){var o=this._markers[n];null==o._endTime?this.addMarker(o,r):a[a.length]=o}this.prepareDurations(a),this.addDurations(a,i,s),this._markerSize=r}},S.prototype.prepareDurations=function(e){this._maxDurationY=0;var t=null;null==this._durationColorMap&&(this._durationColorMap=new Object);for(var i=0;i<e.length;i++){var s=e[i],r=s.getId(),a=s.getSeriesId();a!==t&&(this._colorCount=0,t=a),s._durationLevel=this.calculateDurationY(s,e),null==s._durationFillColor&&(null==this._durationColorMap[r]?(this._durationColorMap[r]=this._colorCount,s._durationFillColor=this._durationColors[this._colorCount],this._colorCount++,this._colorCount===this._durationColors.length&&(this._colorCount=0)):s._durationFillColor=this._durationColors[this._durationColorMap[r]])}},S.prototype.getDurationColorMap=function(){return this._durationColorMap?this._durationColorMap:null},S.prototype.calculateOptimalSize=function(e,t,i,s,a){var n=new Object;n.max=1,n.arr=[];for(var o=this.isVertical()?s:i,l=0;l<this._markers.length;l++){var h=this._markers[l];if(null!=h._endTime){var _=r.OverviewUtils.getDatePosition(e,t,h.getTime(),o);this.isHorizontalRTL()&&(_=o-_),h.setX(_)}else if(this.calculateSize(h,e,t,o,a/2,n,s),n.max>s)break}return n.max>s&&a>1?this.calculateOptimalSize(e,t,i,s,a-1):a},S.prototype.addMarker=function(e,i){var s,a,n="_mrk_"+e.getId(),o=e.getColor(),l=e.isGradient(),h=e.getOpacity();null==h&&0===(h=this._defOpacity)&&null!=o&&(h=1);var _=this.getScaleX(e),c=this.getScaleY(e),u=e.getShape();if(this.isVertical()){u=t.SimpleMarker.RECTANGLE;var g=2*_,d=2*c,m=e.getY()+g/2,p=e.getX()+d/2}else g=i*_,d=i*c,m=e.getX()+g/2,p=e.getY()+d/2;var f=new t.SimpleMarker(this.getCtx(),u,m,p,g,d,null,null,null,n);if(f._node=e,null==o&&h===this._defOpacity&&null==l)s=u===t.SimpleMarker.CIRCLE?this._radialFill:this._linearFill,a=this._border;else{var v=this._defColors;if(null!=o)if(r.OverviewUtils.supportsTouch())v=[o];else v=[t.ColorUtils.getBrighter(o,.5),o,t.ColorUtils.getDarker(o,.5)];var T=[h,h,h];s=null==l?u===t.SimpleMarker.CIRCLE?new t.LinearGradientFill(250,v,T):new t.LinearGradientFill(180,v,T):new t.SolidFill(o,T[0]),a=new t.Stroke(o,h)}f.setFill(s),f.setStroke(a),this.isItemSelectionEnabled()&&f.setSelectable(!0);var b=this.getNumChildren(),y=this.getChildAt(b-1);return b>this._lastChildIndex&&("tb"===y.getId()||"arr"===y.getId())?this.addChildAt(f,b-this._lastChildIndex):this.addChild(f),e.setDisplayable(f),this.applyState(f,S.ENABLED_STATE),!this.isVertical()&&u!==t.SimpleMarker.RECTANGLE&&u!==t.SimpleMarker.DIAMOND&&u!==t.SimpleMarker.TRIANGLE_UP&&u!==t.SimpleMarker.TRIANGLE_DOWN&&u!==t.SimpleMarker.PLUS||"false"===this._defaultMarkerStyles.pixelHinting||f.setPixelHinting(!0),f},S.prototype.addDurations=function(e,i,s){for(var a=this.getCtx(),n=this._maxDurationY;n>0;n--)for(var o=0;o<e.length;o++){var l=e[o];if(n===l._durationLevel){var h=r.OverviewUtils.getDatePosition(i,s,l.getTime(),this.isVertical()?this.Height:this.Width),_="_drn_"+l.getId(),c=9+5*l._durationLevel,u=r.OverviewUtils.getDatePosition(i,s,l.getEndTime(),this.isVertical()?this.Height:this.Width);if(this.isVertical())if(this.isRTL())var g=new t.Rect(a,0,h,c,u-h,_);else g=new t.Rect(a,this.Width-c,h,c,u-h,_);else g=this.isRTL()?new t.Rect(a,this.Width-u,this.Height-c-20,u-h,c,_):new t.Rect(a,h,this.Height-c-20,u-h,c,_);g.setFill(new t.SolidFill(l._durationFillColor));var d=new t.Stroke(this.getStyle(S.ENABLED_STATE,S.DURATION_BORDER_COLOR),1,1);g.setStroke(d),g.setPixelHinting(!0),g._node=l,this.addChild(g),l._durationBar=g,l._durationY=c-2}}this.removeChild(this._timeAxisTopBar),this.addChild(this._timeAxisTopBar)},S.prototype.calculateSize=function(e,t,i,s,a,n,o){var l=a*this.getScaleX(e)+this._markerSpacingOffset,h=a*this.getScaleY(e)+this._markerSpacingOffset,_=e.getTime(),c=r.OverviewUtils.getDatePosition(t,i,_,s);if(this.isHorizontalRTL()&&(c=s-c-2*l),this.isVertical()){var u=0;"solid"===this.getStyle(S.ENABLED_STATE,S.BORDER_STYLE)&&(u=parseInt(this.getStyle(S.ENABLED_STATE,S.BORDER_WIDTH),10)),g=this.isRTL()?u+4:this.Width-2*this.getScaleX(e)-u-4}else{var g=3;this.isOverviewAbove()&&(g+=this.getTimeAxisHeight());for(var d=0,m=[],p=0;p<n.arr.length;p++){var f=n.arr[p],v=f.getX(),T=this.getScaleX(f);Math.abs(c-v)<a*T+this._markerSpacingOffset+l&&m.push(f)}for(p=0;p<m.length;p++){var b=this.calculateY(m,e.getShape(),c,g,l,h,d,a,o);if(d=b.maxy,b.cy===g){g=b.cy;break}g=b.cy}}e.setX(c),e.setY(g),n.arr.push(e),null!=d&&d>n.max&&(n.max=d)},S.prototype.calculateY=function(e,i,s,r,a,n,o,l,h){for(var _=0;_<e.length;_++){var c=e[_],u=c.getX(),g=c.getY(),d=c.getShape(),m=this.getScaleX(c),S=this.getScaleY(c);if(i===t.SimpleMarker.CIRCLE&&d===t.SimpleMarker.CIRCLE&&a===n&&m===S)var p=Math.abs(s-u),f=l*m+this._markerSpacingOffset+a,v=Math.sqrt(f*f-p*p);else v=l*S+this._markerSpacingOffset+n;if(v>Math.abs(r-g)&&(r=g+v,o=Math.max(o,r+v),l>=1&&void 0!==h&&o>h))break}return{cy:r,maxy:o}},S.prototype.calculateDurationY=function(e,t){var i=t.length,s=e.getTime(),r=e._durationLevel;null==r&&(r=1);for(var a=0;a<i;a++){var n=t[a];if(n!==e){var o=n.getEndTime();if(null!=o){var l=n.getTime(),h=n._durationLevel;null==h&&(h=1),s>=l&&s<=o&&r===h&&(r=h+1,e._durationLevel=r,r=this.calculateDurationY(e,t))}}}return r>this._maxDurationY&&(this._maxDurationY=r),r},S.prototype.HandleShapeMouseOver=function(e){var i=S.superclass.HandleShapeMouseOver.call(this,e);if(null!=i){if(null!=i._node){var s=i._node.getDescription();null!=s&&this.getCtx().getTooltipManager().showDatatip(e.pageX,e.pageY,s,"#000000")}if(this.isItemSelectionEnabled()){var r=!1;if(null!=this._selectedMarkers)for(var a=0;a<this._selectedMarkers.length;a++)if(i===this._selectedMarkers[a]){r=!0;break}if(!r){var n=this.getItemId(i),o=t.EventFactory.newTimelineOverviewEvent("highlight",n);this.dispatchEvent(o),this.highlightMarker(i)}}}},S.prototype.HandleShapeMouseOut=function(e){var i=S.superclass.HandleShapeMouseOut.call(this,e);if(null!=i&&!this.isMovable(i)){this.getCtx().getTooltipManager().hideTooltip();var s=!1;if(null!=this._selectedMarkers)for(var r=0;r<this._selectedMarkers.length;r++)if(i===this._selectedMarkers[r]){s=!0;break}if(!s){var a=this.getItemId(i),n=t.EventFactory.newTimelineOverviewEvent("unhighlight",a);this.dispatchEvent(n),this.unhighlightMarker(i)}}},S.prototype.HandleShapeClick=function(e,i,s){var r=S.superclass.HandleShapeClick.call(this,e,i,s);null!=r&&this.HandleMarkerClick(r,e.ctrlKey||e.shiftKey||t.Agent.isTouchDevice())},S.prototype.HandleMarkerClick=function(e,t){if(this.isItemSelectionEnabled()&&(this.selectItem(e,t),null!=e._node.getTime())){var i,s=this.getSlidingWindow();this.isVertical()?(i=this.getX(e)-s.getHeight()/2,this.animateSlidingWindow(null,i)):(i=this.getX(e)-s.getWidth()/2,this.animateSlidingWindow(i))}},S.prototype.highlightItem=function(e){var t=this.getDrawableById(e);null!=t&&this.highlightMarker(t)},S.prototype.unhighlightItem=function(e){var t=this.getDrawableById(e);null!=t&&this.unhighlightMarker(t)},S.prototype.highlightMarker=function(e){if(null!=this._selectedMarkers)for(var t=0;t<this._selectedMarkers.length;t++){if(e===this._selectedMarkers[t])return}this.applyState(e,S.HOVER_STATE)},S.prototype.unhighlightMarker=function(e){if(null!=this._selectedMarkers)for(var t=0;t<this._selectedMarkers.length;t++){if(e===this._selectedMarkers[t])return}this.applyState(e,S.ENABLED_STATE)},S.prototype.selSelectItem=function(e){var t=this.getDrawableById(e);null!=t&&this.addSelectedMarker(t)},S.prototype.selUnselectItem=function(e){var t=this.getDrawableById(e);null!=t&&this.removeSelectedMarker(t)},S.prototype.selectItem=function(e,i){var s=this.getItemId(e),r=t.EventFactory.newTimelineOverviewEvent("selection",s,i);this.dispatchEvent(r)},S.prototype.addSelectedMarker=function(e){null==this._selectedMarkers&&(this._selectedMarkers=[]);var t=null;this._selectedMarkers.length>0&&(t=this._selectedMarkers[this._selectedMarkers.length-1]),this._selectedMarkers.push(e),null!=t&&this.applyState(t,S.SELECTED_STATE),this.applyState(e,S.ACTIVE_SELECTED_STATE)},S.prototype.removeSelectedMarker=function(e){if(null!=this._selectedMarkers){for(var t=-1,i=0;i<this._selectedMarkers.length;i++){if(e===this._selectedMarkers[i]){t=i;break}}-1!=t&&(this.applyState(e,S.ENABLED_STATE),this._selectedMarkers.splice(t,1))}},S.prototype.removeAllSelectedMarkers=function(){if(null!=this._selectedMarkers){for(var e=0;e<this._selectedMarkers.length;e++){var t=this._selectedMarkers[e];this.applyState(t,S.ENABLED_STATE)}delete this._selectedMarkers,this._selectedMarkers=null}},S.prototype.applyState=function(e,i){if(e instanceof t.SimpleMarker){var s=!1,r=!1;if("solid"===this.getStyle(i,S.BORDER_STYLE)){s=!0;var a=this.getStyle(i,S.BORDER_COLOR);null==a&&(a="#000000");var n=this.getStyle(i,S.GLOW_COLOR);null!=n&&"none"!==n&&(r=!0)}var o=e._borderMarker,l=e._glowMarker;s||null==o?r||null==l||(this.removeChild(l),e._glowMarker=null):(this.removeChild(o),e._borderMarker=null,null!=l&&(this.removeChild(l),e._glowMarker=null));var h=e.getType();if(s){var _=parseInt(this.getStyle(i,S.BORDER_WIDTH),10),c=parseInt(this.getStyle(i,S.BORDER_OFFSET),10);if(null==o){if(h===t.SimpleMarker.CIRCLE)var u=(e.getDimensions().w+2*c)*e.getScaleX(),g=(e.getDimensions().h+2*c)*e.getScaleY(),d=this.getX(e)-c+u/2,m=this.getY(e)-c+g/2;else this.isVertical()?(u=(e.getDimensions().w+(_+1))*e.getScaleX(),g=(e.getDimensions().h+(_+1))*e.getScaleY(),d=this.getY(e)-(_+1)/2+u/2,m=this.getX(e)-(_+1)/2+g/2):(u=(e.getDimensions().w+2*c)*e.getScaleX(),g=(e.getDimensions().h+2*c)*e.getScaleY(),d=this.getX(e)-c+u/2,m=this.getY(e)-c+g/2);o=new t.SimpleMarker(this.getCtx(),h,d,m,u,g,null,null,null,e.getId()+"_border"),this.addChildAt(o,this.getChildIndex(e)),e._borderMarker=o,o.setFill(this._markerBorderFill)}var p=new t.Stroke(a,this.getStyle(i,S.BORDER_OPACITY),_);if(o.setStroke(p),!this.isVertical()&&h!==t.SimpleMarker.RECTANGLE&&h!==t.SimpleMarker.DIAMOND&&h!==t.SimpleMarker.TRIANGLE_UP&&h!==t.SimpleMarker.TRIANGLE_DOWN&&h!==t.SimpleMarker.PLUS||"false"===this._defaultMarkerStyles.pixelHinting||o.setPixelHinting(!0),r){if(null==l){var f=c-_;h===t.SimpleMarker.CIRCLE?(u=(e.getDimensions().w+2*f)*e.getScaleX(),g=(e.getDimensions().h+2*f)*e.getScaleY(),d=this.getX(e)-f+u/2,m=this.getY(e)-f+g/2):this.isVertical()?(u=(e.getDimensions().w+3)*e.getScaleX(),g=(e.getDimensions().h+3)*e.getScaleY(),d=this.getY(e)+u/2,m=this.getX(e)-1+g/2):(u=(e.getDimensions().w+2*f)*e.getScaleX(),g=(e.getDimensions().h+2*f)*e.getScaleY(),d=this.getX(e)-f+u/2,m=this.getY(e)-f+g/2),l=new t.SimpleMarker(this.getCtx(),h,d,m,u,g,null,null,null,e.getId()+"_glow"),this.addChildAt(l,this.getChildIndex(o)),e._glowMarker=l,l.setFill(this._markerBorderFill)}var v=new t.Stroke(n,this.getStyle(i,S.GLOW_OPACITY),4);l.setStroke(v),!this.isVertical()&&h!==t.SimpleMarker.RECTANGLE&&h!==t.SimpleMarker.DIAMOND&&h!==t.SimpleMarker.TRIANGLE_UP&&h!==t.SimpleMarker.TRIANGLE_DOWN&&h!==t.SimpleMarker.PLUS||"false"===this._defaultMarkerStyles.pixelHinting||l.setPixelHinting(!0)}}}else{var T=e.getId();T&&"_drn_"===T.substring(0,5)&&this.applyDurationState(e,i)}},S.prototype.applyDurationState=function(e,i){var s=this.getStyle(i,S.DURATION_BORDER_COLOR);null==s&&(s="#000000");var r=parseInt(this.getStyle(i,S.DURATION_BORDER_WIDTH),10);e.setStroke(new t.Stroke(s,1,r))},S.prototype.getMarkers=function(){return this._markers};var p=new Object;t.Obj.createSubclass(p,t.Obj),p._DEFAULT_TIMELINE_STYLE="border:1px #d9dfe3;background-color:#f9f9f9;",p._DEFAULT_AXIS_STYLE="background-color:#f9f9f9;border:1px #d9dfe3;",p._DEFAULT_AXIS_SEPARATOR_STYLE="color:#bcc7d2;",p._DEFAULT_SERIES_STYLE="background-color:#f9f9f9;",p._DEFAULT_SERIES_LABEL_BACKGROUND_STYLE="background-color:#f9f9f9",p._DEFAULT_SERIES_LABEL_BACKGROUND_OPACITY=.8,p._DEFAULT_SERIES_LABEL_SPACING=20,p._DEFAULT_SERIES_LABEL_PADDING=2,p._DEFAULT_SERIES_AXIS_SEPARATOR_STYLE="color:#bcc7d2",p._DEFAULT_SERIES_AXIS_LABEL_BACKGROUND_STYLE="background-color:#f9f9f9",p._DEFAULT_SERIES_AXIS_LABEL_BACKGROUND_OPACITY=.8,p._DEFAULT_SERIES_AXIS_LABEL_PADDING=1,p._DEFAULT_OVERVIEW_WIDTH=60,p._DEFAULT_OVERVIEW_HEIGHT=100,p._DEFAULT_ITEM_ENABLED_STROKE_WIDTH=1,p._DEFAULT_ITEM_HOVER_STROKE_WIDTH=2,p._DEFAULT_ITEM_SELECTED_STROKE_WIDTH=2,p._DEFAULT_ITEM_INNER_FILL_COLOR="rgba(249,249,249,0)",p._DEFAULT_ITEM_ACTIVE_INNER_STROKE_COLOR="#e4f0fa",p._DEFAULT_ITEM_ENABLED_INNER_STROKE_COLOR="rgba(249,249,249,0)",p._DEFAULT_ITEM_INNER_STROKE_WIDTH=2,p._DEFAULT_BUBBLE_OFFSET=20,p._DEFAULT_BUBBLE_SPACING=15,p._DEFAULT_ITEM_CONTENT_SPACING=2,p._DEFAULT_DURATION_FEELER_OFFSET=10,p._DEFAULT_THUMBNAIL_WIDTH=32,p._DEFAULT_THUMBNAIL_HEIGHT=32,p._DEFAULT_ZOOM_CONTROL_DIAMETER=31,p._DEFAULT_ZOOM_CONTROL_PADDING=10.5,p._DEFAULT_ZOOM_CONTROL_SPACING=9,p.getItemDescriptionStyle=function(e){var i=e._series.getOptions().styleDefaults.item.descriptionStyle,s=e.getStyle();if(s){var r=new t.CSSStyle(s);i.parseInlineStyle(r)}return i},p.getItemTitleStyle=function(e){var i=e._series.getOptions().styleDefaults.item.titleStyle,s=e.getStyle();if(s){var r=new t.CSSStyle(s);i.parseInlineStyle(r)}return i},p.getReferenceObjectColor=function(e){return e.styleDefaults.referenceObject.color},p.getSeriesLabelStyle=function(e){return e.styleDefaults.series.labelStyle},p.getSeriesLabelBackgroundStyle=function(){return p._DEFAULT_SERIES_LABEL_BACKGROUND_STYLE},p.getSeriesLabelBackgroundOpacity=function(){return p._DEFAULT_SERIES_LABEL_BACKGROUND_OPACITY},p.getSeriesLabelPadding=function(){return p._DEFAULT_SERIES_LABEL_PADDING},p.getSeriesLabelSpacing=function(){return p._DEFAULT_SERIES_LABEL_SPACING},p.getEmptyTextStyle=function(e){return e.styleDefaults.series.emptyTextStyle},p.getBubbleOffset=function(){return p._DEFAULT_BUBBLE_OFFSET},p.getBubbleSpacing=function(){return p._DEFAULT_BUBBLE_SPACING},p.getItemContentSpacing=function(){return p._DEFAULT_ITEM_CONTENT_SPACING},p.getItemFillColor=function(e){var i=e.getStyle();if(i){var s=new t.CSSStyle(i).getStyle(t.CSSStyle.BACKGROUND_COLOR);if(s)return s}return e._series.getOptions().styleDefaults.item.backgroundColor},p.getItemStrokeColor=function(e){var i=e.getStyle();if(i){var s=new t.CSSStyle(i).getStyle(t.CSSStyle.BORDER_COLOR);if(s)return s}return e._series.getOptions().styleDefaults.item.borderColor},p.getItemStrokeWidth=function(){return p._DEFAULT_ITEM_ENABLED_STROKE_WIDTH},p.getItemHoverFillColor=function(e){var t=e._series.getOptions().styleDefaults.item.hoverBackgroundColor;return t||p.getItemFillColor(e)},p.getItemHoverStrokeColor=function(e){var t=e._series.getOptions().styleDefaults.item.hoverBorderColor;return t||p.getItemStrokeColor(e)},p.getItemHoverStrokeWidth=function(){return p._DEFAULT_ITEM_HOVER_STROKE_WIDTH},p.getItemSelectedFillColor=function(e){var t=e._series.getOptions().styleDefaults.item.selectedBackgroundColor;return t||p.getItemFillColor(e)},p.getItemSelectedStrokeColor=function(e){var t=e._series.getOptions().styleDefaults.item.selectedBorderColor;return t||p.getItemStrokeColor(e)},p.getItemSelectedStrokeWidth=function(){return p._DEFAULT_ITEM_SELECTED_STROKE_WIDTH},p.getSeriesStyle=function(){return p._DEFAULT_SERIES_STYLE},p.getColorsArray=function(e){return e.styleDefaults.series.colors},p.getDurationFeelerOffset=function(){return p._DEFAULT_DURATION_FEELER_OFFSET},p.getThumbnailWidth=function(){return p._DEFAULT_THUMBNAIL_WIDTH},p.getThumbnailHeight=function(){return p._DEFAULT_THUMBNAIL_HEIGHT},p.getSeriesAxisSeparatorStyle=function(){return p._DEFAULT_SERIES_AXIS_SEPARATOR_STYLE},p.getItemInnerActiveStrokeColor=function(){return p._DEFAULT_ITEM_ACTIVE_INNER_STROKE_COLOR},p.getItemInnerFillColor=function(){return p._DEFAULT_ITEM_INNER_FILL_COLOR},p.getItemInnerStrokeColor=function(){return p._DEFAULT_ITEM_ENABLED_INNER_STROKE_COLOR},p.getItemInnerStrokeWidth=function(){return p._DEFAULT_ITEM_INNER_STROKE_WIDTH},p.getTimelineStyle=function(){return p._DEFAULT_TIMELINE_STYLE},p.getOverviewWidth=function(){return p._DEFAULT_OVERVIEW_WIDTH},p.getOverviewHeight=function(){return p._DEFAULT_OVERVIEW_HEIGHT},p.getOverviewWindowBackgroundColor=function(e){return e.styleDefaults.overview.window.backgroundColor},p.getOverviewWindowBorderColor=function(e){return e.styleDefaults.overview.window.borderColor},p.getOverviewBackgroundColor=function(e){return e.styleDefaults.overview.backgroundColor},p.getOverviewLabelStyle=function(e){return e.styleDefaults.overview.labelStyle},p.getSeriesAxisLabelStyle=function(e){return e.styleDefaults.majorAxis.labelStyle},p.getSeriesAxisLabelBackgroundStyle=function(){return p._DEFAULT_SERIES_AXIS_LABEL_BACKGROUND_STYLE},p.getSeriesAxisLabelBackgroundOpacity=function(){return p._DEFAULT_SERIES_AXIS_LABEL_BACKGROUND_OPACITY},p.getAxisSeparatorStyle=function(){return p._DEFAULT_AXIS_SEPARATOR_STYLE},p.getSeriesAxisLabelPadding=function(){return p._DEFAULT_SERIES_AXIS_LABEL_PADDING},p.getAnimationDuration=function(e){return t.CSSStyle.getTimeMilliseconds(e.styleDefaults.animationDuration)/1e3},p.convertToCSSStyle=function(e){return null==e||e instanceof t.CSSStyle?e:new t.CSSStyle(e)};var f=new Object;t.Obj.createSubclass(f,t.Obj),f.renderTimeline=function(e){var t;if(f._renderBackground(e),f._renderScrollableCanvas(e),e.hasValidOptions()){e.renderTimeZoomCanvas(e._canvas);var i=e.getTimeZoomCanvas();if(f._renderSeries(e,i),f._renderSeriesLabels(e),f._renderAxis(e,i),e._hasOverview?f._renderOverview(e):e.clearOverview(),e._keyboardHandler)for(var r=0;r<e._series.length;r++)if((t=e._series[r])._items&&t._items.length>0){e.EventManager.setFocusObj(t._items[0]);break}(e.isTimeDirScrollbarOn()||e.isContentDirScrollbarOn())&&f._renderScrollbars(e),f._renderZoomControls(e),e.SelectionHandler&&e.applyInitialSelections(),s.TimeAxisUtils.supportsTouch()&&e._setAriaProperty("flowto",e._series[0].getId());for(var a=0;a<e._series.length;a++)(t=e._series[a]).triggerAnimations()}else f._renderEmptyText(e)},f._renderBackground=function(e){e._background?(e._background.setClipPath(null),e._background.setWidth(e._backgroundWidth),e._background.setHeight(e._backgroundHeight)):e._background=new t.Rect(e.getCtx(),0,0,e._backgroundWidth,e._backgroundHeight,"bg");var i=e.getBackgroundXOffset();e._background.setTranslateX(i),e._background.setCSSStyle(e._style),e._background.setPixelHinting(!0);var s=new t.ClipPath;s.addRect(i,0,e._backgroundWidth,e._backgroundHeight),e._background.setClipPath(s),e._background.getParent()!==e&&e.addChild(e._background)},f._renderScrollableCanvas=function(e){e._canvas||(e._canvas=new t.Container(e.getCtx(),"canvas"),e.addChild(e._canvas))},f._renderSeries=function(e,i){var s=e.getTimeAxis();if(e._series){var r=e.getCtx(),a=t.Agent.isRightToLeft(r),n=e._series.length,o=e.getTimeAxisVisibleSize(n);e.isVertical()||n>1&&e._canvasSize%2!=o%2&&(s.setContentSize(s.getContentSize()+1),o=e.getTimeAxisVisibleSize(n)),e._seriesSize=(e._canvasSize-o)/n;for(var l=0;l<n;l++){var h=e._series[l];h.setClipPath(null);var _=new t.ClipPath;if(e.isVertical()){if(a)var c=Math.abs(l-1);else c=l;if(a&&1===e._series.length){_.addRect(o,0,e._seriesSize,e.getContentLength());var u=new t.Matrix(1,0,0,1,o,0)}else _.addRect(c*(e._seriesSize+o),0,e._seriesSize,e.getContentLength()),u=new t.Matrix(1,0,0,1,c*(e._seriesSize+o),0);var g=e._seriesSize,d=e.getContentLength()}else _.addRect(0,l*(e._seriesSize+o),e.getContentLength(),e._seriesSize),u=new t.Matrix(1,0,0,1,0,l*(e._seriesSize+o)),g=e.getContentLength(),d=e._seriesSize;h.setClipPath(_),h.setMatrix(u),h.getParent()!==i&&i.addChild(h),h.render(e._seriesOptions[l],g,d)}}},f._renderSeriesLabels=function(e){var i,s;if(e._series){var r=e.getCtx(),a=t.Agent.isRightToLeft(r);if(e._seriesLabels)for(var n=0;n<e._seriesLabels.length;n++)e.removeChild(e._seriesLabels[n]);e._seriesLabels=[];for(var o=e._series.length,l=p.getSeriesLabelSpacing(),h=2*t.TransientButton._DEFAULT_RADIUS+6,_=2*l,c=0;c<o;c++){var u=e._series[c],g=u.getLabel();if(null!=g){var d=p.getSeriesLabelStyle(e.Options),m=new t.CSSStyle(p.getSeriesLabelBackgroundStyle());if(u._style){var S=u._style.getStyle(t.CSSStyle.BACKGROUND_COLOR);S&&m.setStyle(t.CSSStyle.BACKGROUND_COLOR,S)}var f=new t.OutputText(r,g,0,0,"sl_s"+c);if(f.setCSSStyle(d),i=f.getDimensions(),e.isVertical())var v=e._seriesSize;else v=e._canvasLength;var T=Math.min(i.w,v-(c-1)*-h-_),b=p.getSeriesLabelPadding(),y=new t.Rect(r,0,0,T+2*b,i.h+2*b,"slb_s"+c);if(y.setCSSStyle(m),y.setAlpha(p.getSeriesLabelBackgroundOpacity()),y.setCornerRadius(3),e.isVertical())E=a?Math.abs(c-1)*(e._canvasSize-T-_)+l+e._startX+(c-1)*h:c*(e._canvasSize-T-_)+l+e._startX+(c-1)*-h,O=e._startY+l;else{if(a)var E=e._canvasLength-T-l-(c-1)*-h;else E=e._startX+l+(c-1)*-h;var O=c*(e._canvasSize-i.h-_)+l+e._startY}s=new t.Matrix(1,0,0,1,E,O),f.setMatrix(s),s=new t.Matrix(1,0,0,1,E-b,O-b),y.setMatrix(s),e.addChild(y),t.TextUtils.fitText(f,T,1/0,e),e._seriesLabels.push(y),e._seriesLabels.push(f)}if(u._isEmpty){var C=u.getEmptyText();if(null!=C){var D=new t.OutputText(r,C,0,0,"et_s"+c);if(D.setCSSStyle(p.getEmptyTextStyle(e.Options)),i=D.getDimensions(),e.isVertical())w=(e._canvasLength-i.h)/2+e._startY,A=a?Math.abs(c-1)*((o-1)*e._seriesSize+e.getTimeAxisVisibleSize(o))+(e._seriesSize-i.w)/2+e._startX:c*(e._seriesSize+e.getTimeAxisVisibleSize(o))+(e._seriesSize-i.w)/2+e._startX;else var A=(e._canvasLength-i.w)/2+e._startX,w=c*(e._seriesSize+e.getTimeAxisVisibleSize(o))+(e._seriesSize-i.h)/2+e._startY;s=new t.Matrix(1,0,0,1,A,w),D.setMatrix(s),e.addChild(D),e._seriesLabels.push(D)}}}}},f._renderAxis=function(e,i,s){var r=e.getCtx(),a=t.Agent.isRightToLeft(r),n=e.getTimeAxis(),o=e._series.length,l=e.getTimeAxisSize(),h=e.getTimeAxisVisibleSize(o),_=1===o?e._canvasSize-h:e._canvasSize/o-h/2;if(a&&e.isVertical()&&1===e._series.length&&(_=0),n.getParent()!==i&&i.addChild(n),e.isVertical()){var c=new t.Matrix(1,0,0,1,_,0);n.render({_viewStartTime:e._viewStartTime,_viewEndTime:e._viewEndTime,_throttle:s},l,e.getContentLength())}else c=new t.Matrix(1,0,0,1,0,_),n.render({_viewStartTime:e._viewStartTime,_viewEndTime:e._viewEndTime,_throttle:s},e.getContentLength(),l);n.setMatrix(c),f._renderSeriesTimeAxis(e,e._fetchStartPos,e._fetchEndPos,e.getTimeZoomCanvas(),e.getContentLength())},f._renderSeriesTimeAxis=function(e,i,r,a,n){var o=e.getCtx(),l=t.Agent.isRightToLeft(o);if(e._majorAxisLabels)for(var h=0;h<e._majorAxisLabels.length;h++)a.removeChild(e._majorAxisLabels[h]);if(e._majorAxisLabels=[],e._seriesScale){var _,c,u=e._start,g=e._end;if(e._customTimeScales&&e._customTimeScales[e._seriesScale]){var d=e._customTimeScales[e._seriesScale];_=d.times,c=d.labels}else if(e._seriesCustomFormatScales&&e._seriesCustomFormatScales[e._seriesScale]){var m=e._seriesCustomFormatScales[e._seriesScale];_=m.times,c=m.labels}else{_=[],c=[];var S=s.TimeAxisUtils.getPositionDate(u,g,i,n),v=e._seriesTimeAxis.adjustDate(S),T=s.TimeAxisUtils.getDatePosition(u,g,v,n);for(_.push(v.getTime());T<r;)c.push(e._seriesTimeAxis.formatDate(v)),v=e._seriesTimeAxis.getNextDate(v.getTime()),T=s.TimeAxisUtils.getDatePosition(u,g,v,n),_.push(v.getTime())}var b=p.getSeriesAxisLabelStyle(e.Options),y=p.getSeriesAxisLabelPadding(),E=new t.CSSStyle(p.getSeriesAxisLabelBackgroundStyle());if(e._series[0]&&e._series[0]._style){var O=e._series[0]._style.getStyle(t.CSSStyle.BACKGROUND_COLOR);O&&E.setStyle(t.CSSStyle.BACKGROUND_COLOR,O)}for(var C=p.getSeriesAxisLabelBackgroundOpacity(),D=0;D<c.length;D++){var A=c[D],w=_[D];T=s.TimeAxisUtils.getDatePosition(u,g,w,n);var x=s.TimeAxisUtils.getDatePosition(u,g,_[D+1],n)-T;if(l)I=e.isVertical()?f._addLabel(o,a,e._canvasSize-5,A,x,T+18,b,"o_label"+T+"_s0",!0,E,C,y,e._majorAxisLabels,l):f._addLabel(o,a,n-(T+5),A,x,e._seriesSize-2,b,"o_label"+T+"_s0",!0,E,C,y,e._majorAxisLabels,l);else if(e.isVertical())var I=f._addLabel(o,a,5,A,x,T+18,b,"o_label"+T+"_s0",!0,E,C,y,e._majorAxisLabels,l);else I=f._addLabel(o,a,T+5,A,x,e._seriesSize-2,b,"o_label"+T+"_s0",!0,E,C,y,e._majorAxisLabels,l);I.time=_[D]}}},f._renderOverview=function(e){var i=e.getCtx(),s=t.Agent.isRightToLeft(i);if(null==e._overviewCanvas){var r=!0;e._overviewCanvas=new t.Container(i,"oCanvas")}else e._overviewCanvas.removeChildren(),e._overviewCanvas.setClipPath(null);var a,n,o,l,h=e._style.getBorderWidth(),_=h/2;e.isVertical()?(a=e._overviewSize,n=e._backgroundHeight-h,l=_,o=s?_:e._backgroundWidth-e._overviewSize-_):(a=e._backgroundWidth-h,n=e._overviewSize,l=e._backgroundHeight-e._overviewSize-_,o=_+e.getBackgroundXOffset()),e._overviewCanvas.setTranslateX(o),e._overviewCanvas.setTranslateY(l);var c=new t.ClipPath;c.addRect(o,l,a,n),e._overviewCanvas.setClipPath(c),r&&e.addChild(e._overviewCanvas),e._overview=new S(i,e.HandleEvent,e),e._overviewCanvas.addChild(e._overview);var u=e._getOverviewObject();e._overview.render(u,a,n)},f._renderScrollbars=function(e){var i=e.getCtx(),s=e.getScrollbarPadding(),r=e._series.length;if(null==e._scrollbarsCanvas?(e._scrollbarsCanvas=new t.Container(i,"sbCanvas"),e.addChild(e._scrollbarsCanvas)):(e._scrollbarsCanvas.removeChildren(),e.setTimeDirScrollbar(null),e.setContentDirScrollbar(null)),e.isTimeDirScrollbarOn()){if(e.isVertical()){if(t.Agent.isRightToLeft(e.getCtx()))var a=2*s+1;else a=e.Width-1.5*s;var n=e.getCanvasLength()}else a=e.getCanvasLength(),n=e.Height-1.5*s;var o=f._prerenderTimeDirScrollbar(e,e._scrollbarsCanvas,new t.Rectangle(0,0,a,n))}if(e.isContentDirScrollbarOn()){e.isVertical()?(a=e._seriesSize,n=e.Height-1.5*s):(a=t.Agent.isRightToLeft(e.getCtx())?2*s+1:e.Width-1.5*s,n=e._seriesSize);for(var l=[],h=0;h<r;h++)l[h]=f._prerenderContentDirScrollbar(e,e._scrollbarsCanvas,new t.Rectangle(0,0,a,n),h)}if(e.timeDirScrollbar){var _={};_.color=e.timeDirScrollbarStyles.getStyle(t.CSSStyle.COLOR),_.backgroundColor=e.timeDirScrollbarStyles.getStyle(t.CSSStyle.BACKGROUND_COLOR),_.min=e._start,_.max=e._end,e.isVertical()?(_.isReversed=!1,_.isHorizontal=!1,e.timeDirScrollbar.setTranslateY(e.getStartYOffset())):(_.isReversed=t.Agent.isRightToLeft(i),_.isHorizontal=!0,e.timeDirScrollbar.setTranslateX(e.getStartXOffset())),null!=o&&(e.timeDirScrollbar.render(_,o.w,o.h),e.timeDirScrollbar.setViewportRange(e._viewStartTime,e._viewEndTime))}if(e.contentDirScrollbar)for(h=0;h<r;h++){if((_={}).color=e.contentDirScrollbarStyles.getStyle(t.CSSStyle.COLOR),_.backgroundColor=e.contentDirScrollbarStyles.getStyle(t.CSSStyle.BACKGROUND_COLOR),_.isHorizontal=e.isVertical(),0==h){_.min=0;var c=null!=l[h]&&null!=l[h].h?l[h].h:0;_.max=Math.max(e._series[h]._maxOverflowValue,c),e.isVertical()?t.Agent.isRightToLeft(i)?(_.isReversed=!1,2===r?e.contentDirScrollbar[h].setTranslateX(e.getStartXOffset()+e._seriesSize+e.getTimeAxisVisibleSize(r)):e.contentDirScrollbar[h].setTranslateX(e.getStartXOffset()+e.getTimeAxisVisibleSize(r))):(_.isReversed=!0,e.contentDirScrollbar[h].setTranslateX(e.getStartXOffset())):(_.isReversed=!0,e.contentDirScrollbar[h].setTranslateY(e.getStartYOffset()))}else _.min=0,_.max=Math.max(e._series[h]._maxOverflowValue,l[h].h),e.isVertical()?t.Agent.isRightToLeft(i)?(_.isReversed=!0,e.contentDirScrollbar[h].setTranslateX(e.getStartXOffset())):(_.isReversed=!1,e.contentDirScrollbar[h].setTranslateX(e.getStartXOffset()+e._seriesSize+e.getTimeAxisVisibleSize(r))):(_.isReversed=!1,e.contentDirScrollbar[h].setTranslateY(e.getStartYOffset()+e._seriesSize+e.getTimeAxisVisibleSize(r)));e.contentDirScrollbar[h].render(_,l[h].w,l[h].h),e.contentDirScrollbar[h].setViewportRange(0,e._seriesSize)}},f._prerenderTimeDirScrollbar=function(e,i,s){if(e.setTimeDirScrollbar(new t.SimpleScrollbar(e.getCtx(),e.HandleEvent,e)),i.addChild(e.timeDirScrollbar),e.isVertical())var r="right",a=t.CSSStyle.toNumber(e.timeDirScrollbarStyles.getWidth()),n=s.h;else r="bottom",a=s.w,n=t.CSSStyle.toNumber(e.timeDirScrollbarStyles.getHeight());return t.LayoutUtils.position(s,r,e.timeDirScrollbar,a,n,0),new t.Dimension(a,n)},f._prerenderContentDirScrollbar=function(e,i,s,r){if(e.setContentDirScrollbar(new t.SimpleScrollbar(e.getCtx(),e.HandleEvent,e),r),i.addChild(e.contentDirScrollbar[r]),e.isVertical())var a="bottom",n=s.w,o=t.CSSStyle.toNumber(e.contentDirScrollbarStyles.getHeight());else a="right",n=t.CSSStyle.toNumber(e.contentDirScrollbarStyles.getWidth()),o=s.h;return t.LayoutUtils.position(s,a,e.contentDirScrollbar[r],n,o,0),new t.Dimension(n,o)},f._renderZoomControls=function(e){var i=e.getCtx(),s=e._resources,r=t.Agent.isRightToLeft(i),a={zoomInProps:{imageSize:16,class:s.zoomIn},zoomOutProps:{imageSize:16,class:s.zoomOut}},n=e.getStartXOffset()+p._DEFAULT_ZOOM_CONTROL_PADDING;r&&(e._isVertical&&e._hasOverview?n-=e._overviewSize:n-=e.getBackgroundXOffset(),n=e._backgroundWidth-n-p._DEFAULT_ZOOM_CONTROL_DIAMETER),a.zoomInProps.posX=n,a.zoomOutProps.posX=n;var o=e._startY+p._DEFAULT_ZOOM_CONTROL_PADDING;a.zoomInProps.posY=o,a.zoomOutProps.posY=o+p._DEFAULT_ZOOM_CONTROL_DIAMETER+p._DEFAULT_ZOOM_CONTROL_SPACING,e.renderZoomControls(a)},f._renderEmptyText=function(e){if(e.Options.series)var i=e.Options.translations.labelInvalidData;else i=e.Options.translations.labelNoData;e.clearComponent(),e.renderEmptyText(e._canvas,i,new t.Rectangle(0,0,e._backgroundWidth,e._backgroundHeight),e.EventManager,p.getEmptyTextStyle(e.Options))},f._addLabel=function(e,i,s,r,a,n,o,l,h,_,c,u,g,d){var m=new t.OutputText(e,r,s,0,l);null!=o&&m.setCSSStyle(o);var S=m.getDimensions();if(n-=S.h,m.setY(n),d&&m.setX(s-S.w),h){var p=Math.min(S.w+2*u,a);if(d)f=s-p+2*u;else var f=s;var v=new t.Rect(e,f-u,n-u,p,S.h+2*u,"ob_"+l);v.setCSSStyle(_),v.setCornerRadius(3),v.setAlpha(c),i.addChild(v),g&&g.push(v)}return t.TextUtils.fitText(m,a,1/0,i),g&&g.push(m),m};var v=function(e,t){this.Init(e,t)};t.Obj.createSubclass(v,t.Container),v.ENABLED_STATE_KEY="en",v.SELECTED_STATE_KEY="sel",v.ACTIVE_SELECTED_STATE_KEY="asel",v.HOVER_STATE_KEY="hl",v.prototype.Init=function(e,t){v.superclass.Init.call(this,e,"g",t)},v.prototype.setSelected=function(e){this._isSelected!==e&&(this._isSelected=e,e?this._isShowingHoverEffect?this.applyState(v.ACTIVE_SELECTED_STATE_KEY):this.applyState(v.SELECTED_STATE_KEY):this.applyState(v.ENABLED_STATE_KEY))},v.prototype.showHoverEffect=function(e){this._isShowingHoverEffect||(this._isShowingHoverEffect=!0,this._isSelected&&e?this.applyState(v.ACTIVE_SELECTED_STATE_KEY):this._isSelected?this.applyState(v.SELECTED_STATE_KEY):this.applyState(v.HOVER_STATE_KEY))},v.prototype.hideHoverEffect=function(e){this._isSelected&&e?this.applyState(v.ACTIVE_SELECTED_STATE_KEY):this._isSelected?this.applyState(v.SELECTED_STATE_KEY):this.applyState(v.ENABLED_STATE_KEY),this._isShowingHoverEffect=!1},v.prototype.applyState=function(e){var i=this._node,s=i.getBubble();if(null!=s){var r=s.getChildAt(0),a=r.getChildAt(0),n=i.getDurationBar();if(e===v.ACTIVE_SELECTED_STATE_KEY)var o=p.getItemSelectedFillColor(i),l=p.getItemSelectedStrokeColor(i),h=p.getItemSelectedStrokeWidth(),_=p.getItemInnerActiveStrokeColor();else e===v.SELECTED_STATE_KEY?(o=p.getItemSelectedFillColor(i),l=p.getItemSelectedStrokeColor(i),h=p.getItemSelectedStrokeWidth(),_=p.getItemInnerStrokeColor()):e===v.HOVER_STATE_KEY?(o=p.getItemHoverFillColor(i),l=p.getItemHoverStrokeColor(i),h=p.getItemHoverStrokeWidth(),_=p.getItemInnerActiveStrokeColor()):(o=p.getItemFillColor(i),l=p.getItemStrokeColor(i),h=p.getItemStrokeWidth(),_=p.getItemInnerStrokeColor());var c=p.getItemInnerStrokeWidth(),u=new t.Stroke(l,1,h),g=new t.Stroke(_,1,c);r.setSolidFill(o),r.setStroke(u),a.setStroke(g);var d=i.getFeeler();d&&d.setStroke(u),n&&n.setStroke(u)}};var T=new Object;t.Obj.createSubclass(T,t.Obj),T.renderItem=function(e,t,i,s,r,a){e._content?(T._renderBubble(e,t,i,r),T._displayBubble(e,t,s,null,!1)):(t._hasMvAnimations=!0,T._displayBubble(e,t,s,a,!0)),t.isVertical()||(e.getFeeler()&&t._allowUpdates?T._updateFeeler(e,t,s,a):T._renderFeeler(e,t,i.feelers,s,r))},T.initializeItem=function(e,t,i){e.getBubble()&&t._allowUpdates?T._updateBubble(e,t,i):T._createBubble(e,t,i)},T._createBubble=function(e,t,i){var s,r,a=T._getBubbleContent(e,t);e._timeline.getOptions().itemBubbleContentRenderer?(s=Math.max(0,a._w+a._x+10),r=a._h+a._y+10):(s=a._w+10,r=a._h+10),e.setWidth(s),e.setHeight(r),e._content=a;var n=t.calculateSpacing(e,i);e.setSpacing(n)},T._renderBubble=function(e,i,r,a){var n=i.getCtx(),o=t.Agent.isRightToLeft(n),l=e.getId(),h=e._content;e._content=null;var _=e.getWidth(),c=e.getHeight(),u="_bubble_"+l;if(i.isVertical()){var g=c/2,d=g-6,m=g+6;if(!o&&i.isInverted()||o&&!i.isInverted())var S=[0,0,0,d,-6,g,0,m,0,c,_,c,_,0,0,0],f=[2,2,2,d,-4,g,2,m,2,c-2,_-2,c-2,_-2,2,2,2];else S=[0,0,0,c,_,c,_,m,_+6,g,_,d,_,0,0,0],f=[2,2,2,c-2,_-2,c-2,_-2,m,_+4,g,_-2,d,_-2,2,2,2]}else d=(g=o?_-p.getBubbleOffset():p.getBubbleOffset())-6,m=g+6,i.isInverted()?(S=[0,0,d,0,g,-6,m,0,_,0,_,c,0,c,0,0],f=[2,2,d,2,g,-4,m,2,_-2,2,_-2,c-2,2,c-2,2,2]):(S=[0,0,0,c,d,c,g,c+6,m,c,_,c,_,0,0,0],f=[2,2,2,c-2,d,c-2,g,c+4,m,c-2,_-2,c-2,_-2,2,2,2]);var T=new t.Polygon(n,S,u),b=new t.Polygon(n,f,u+"_i");(b.setSolidFill(p.getItemInnerFillColor()),o)?e._timeline.getOptions().itemBubbleContentRenderer?h.setTranslate(_-5-2*h._x,5):h.setTranslate(5,5):h.setTranslate(5,5);T.addChild(b),T.addChild(h);var y=new v(n,"_bt_"+l);a&&(y.setAlpha(0),a.push(y)),y.addChild(T),s.TimeAxisUtils.supportsTouch()&&t.ToolkitUtils.setAttrNullNS(y._elem,"id",y._id),y._node=e,e.setBubble(y),y.applyState(v.ENABLED_STATE_KEY),y.setClassName("oj-timeline-item-bubble"),e.getLoc()>=0&&r.addChild(y),y.setAriaRole("img"),i._callbackObj.EventManager.associate(y,e)},T._displayBubble=function(e,i,s,r,a){var n,o,l=i.getCtx(),h=t.Agent.isRightToLeft(l),_=e.getLoc(),c=e.getWidth(),u=e.getHeight(),g=e.getSpacing(),d=e.getBubble();a&&d.applyState(v.ENABLED_STATE_KEY),i.isVertical()?(o=_-u/2,h&&i.isInverted()||!h&&!i.isInverted()?n=i._size-(c+i._initialSpacing)+s:(n=i._initialSpacing,s=0)):(n=h?i._length-_-c+p.getBubbleOffset():_-p.getBubbleOffset(),i.isInverted()?(o=i.isTopToBottom()?g:i.Height-g-u+s+i._initialSpacing-p.getBubbleSpacing(),s=0):o=i.isTopToBottom()?g-i._initialSpacing+p.getBubbleSpacing():i.Height-g-u+s),r?(i.isVertical()?d.setTranslateX(d.getTranslateX()+i._canvasOffsetX+s):d.setTranslateY(d.getTranslateY()+i._canvasOffsetY+s),r.addProp(t.Animator.TYPE_NUMBER,d,d.getTranslateX,d.setTranslateX,n),r.addProp(t.Animator.TYPE_NUMBER,d,d.getTranslateY,d.setTranslateY,o)):d.setTranslate(n,o),e._updateAriaLabel()},T._getBubbleContent=function(e,i){var s,r=i.getCtx(),a=t.Agent.isRightToLeft(r),n=e.getTitle(),o=e.getDescription(),l=e.getThumbnail(),h=new t.Container(r),_=0,c=0,u=0,g=0,d=0,m=e._timeline.getOptions().itemBubbleContentRenderer;if(m&&(s=m(e.getRendererContext()))){var S=h.getContainerElem();Array.isArray(s)?s.forEach(function(e){t.ToolkitUtils.appendChildElem(S,e)}):t.ToolkitUtils.appendChildElem(S,s);var f=i._blocks[i._blocks.length-1];f.setClassName("oj-timeline-item-bubble"),f.addChild(h);var v=h.getDimensions();return h._w=v.w,h._h=v.h,h._x=a?v.w+v.x:v.x,h._y=v.y,f.removeChild(h),h}if(a){if(n&&((O=new t.OutputText(r,n,0,0)).setCSSStyle(p.getItemTitleStyle(e)),_=(C=O.getDimensions()).w,c=d=C.h,h.addChild(O)),o){(D=new t.OutputText(r,o,0,c)).setCSSStyle(p.getItemDescriptionStyle(e));var T=(C=D.getDimensions()).w;0!==_&&T!==_?T>_?(O.setX(T-_),_=T):D.setX(_-T):_=T,d=c+C.h,h.addChild(D)}l&&(b=p.getThumbnailWidth(),y=p.getThumbnailHeight(),_=0===_?0:_+p.getItemContentSpacing(),(E=new t.Image(r,l,_,0,b,y,"_tn")).setMouseEnabled(!1),h.addChild(E),u=b,g=y),h._w=_+u}else{if(l){var b=p.getThumbnailWidth(),y=p.getThumbnailHeight(),E=new t.Image(r,l,0,0,b,y,"_tn");E.setMouseEnabled(!1),h.addChild(E),_=b+p.getItemContentSpacing(),g=y}if(n){var O=new t.OutputText(r,n,_,0);O.setCSSStyle(p.getItemTitleStyle(e));var C=O.getDimensions();u=C.w,c=d=C.h,h.addChild(O)}if(o){var D=new t.OutputText(r,o,_,c);D.setCSSStyle(p.getItemDescriptionStyle(e)),C=D.getDimensions(),u=Math.max(u,C.w),d=c+C.h,h.addChild(D)}h._w=0===u?Math.max(_-p.getItemContentSpacing(),0):_+u}return h._h=Math.max(g,d),h},T._updateBubble=function(e,t,i){var s=t.calculateSpacing(e,i);e.setSpacing(s)},T._renderFeeler=function(e,i,s,r,a){var n,o=i.getCtx(),l=t.Agent.isRightToLeft(o),h=e.getId(),_=e.getLoc(),c=e.getSpacing(),u="_feeler_"+h;if(i.isInverted())g=e.getDurationSize(),d=i.isTopToBottom()?c:i.Height-c-e.getHeight()+r+i._initialSpacing-p.getBubbleSpacing();else{var g=i.Height+r-e.getDurationSize();if(i.isTopToBottom())d=c-i._initialSpacing+p.getBubbleSpacing()+e.getHeight();else var d=i.Height-c+r}n=l?i._length-_:_;var m=new t.Line(o,n,g,n,d,u);a&&(m.setAlpha(0),a.push(m)),s.addChild(m);var S=p.getItemStrokeWidth(),f=p.getItemStrokeColor(e),v=new t.Stroke(f,1,S);m.setStroke(v),m._node=e,e.setFeeler(m)},T._updateFeeler=function(e,i,s,r){if(i.isVertical())e.setFeeler(null);else{var a,n=i.getCtx(),o=t.Agent.isRightToLeft(n),l=e.getFeeler();if(i.isInverted())h=e.getDurationSize(),_=i.isTopToBottom()?e.getSpacing():i.Height-e.getSpacing()-e.getHeight()+s+i._initialSpacing-p.getBubbleSpacing(),s=0;else{var h=i.Height+s-e.getDurationSize();if(i.isTopToBottom())_=e.getSpacing()-i._initialSpacing+p.getBubbleSpacing()+e.getHeight();else var _=i.Height-e.getSpacing()+s}a=o?i._length-e.getLoc():e.getLoc(),r?(l.setY1(l.getY1()+i._canvasOffsetY+s),l.setY2(l.getY2()+i._canvasOffsetY+s),r.addProp(t.Animator.TYPE_NUMBER,l,l.getX1,l.setX1,a),r.addProp(t.Animator.TYPE_NUMBER,l,l.getY1,l.setY1,h),r.addProp(t.Animator.TYPE_NUMBER,l,l.getX2,l.setX2,a),r.addProp(t.Animator.TYPE_NUMBER,l,l.getY2,l.setY2,_)):(l.setX1(a),l.setY1(h),l.setX2(a),l.setY2(_))}},T.renderDuration=function(e,t,i,s,r,a){e.getDurationBar()?T._updateDuration(e,t,s,a):T._renderDuration(e,t,i,s,r)},T._renderDuration=function(e,i,r,a,n){var o=i.getCtx(),l=t.Agent.isRightToLeft(o),h=e.getStartTime(),_=e.getEndTime(),c=s.TimeAxisUtils.getDatePosition(i._start,i._end,h,i._length),u="_duration_"+e.getId(),g=22+10*e.getDurationLevel(),d=s.TimeAxisUtils.getDatePosition(i._start,i._end,_,i._length);if(i.isVertical()){if(!l&&!i.isInverted()||l&&i.isInverted())var m=new t.Rect(o,i._size-g+5,c,g,d-c,u);else m=new t.Rect(o,-5,c,g,d-c,u),a=0;m.setTranslateX(a),m.setY(c),m.setWidth(g),m.setHeight(d-c)}else{var S=d-c;if(l)f=i._length-c-S;else var f=c;i.isInverted()?(m=new t.Rect(o,f,-5,S,g,u)).setTranslateY(0):(m=new t.Rect(o,f,i._size-g+5,S,g,u)).setTranslateY(a)}n&&(m.setAlpha(0),n.push(m)),m.setCornerRadius(5),m.setSolidFill(e.getDurationFillColor());var v=p.getItemStrokeWidth(),T=p.getItemStrokeColor(e),b=new t.Stroke(T,1,v);m.setStroke(b),m._node=e,i._callbackObj.EventManager.associate(m,e),r.addChild(m),e.setDurationBar(m)},T._updateDuration=function(e,i,r,a){var n=i.getCtx(),o=t.Agent.isRightToLeft(n),l=e.getDurationBar();if(null!=l){var h=s.TimeAxisUtils.getDatePosition(i._start,i._end,e.getStartTime(),i._length),_=22+10*e.getDurationLevel(),c=s.TimeAxisUtils.getDatePosition(i._start,i._end,e.getEndTime(),i._length);if(i.isVertical()){var u=0;if(!o&&!i.isInverted()||o&&i.isInverted())var g=i._size-_+5;else g=-5,r=0;var d=r,m=h,S=_,p=c-h}else{d=0;var f=c-h;g=o?i._length-h-f:h,i.isInverted()?(r=0,u=0,m=-5,S=f,p=_):(u=r,m=i._size-_+5,S=f,p=_)}a?(i.isVertical()?l.setTranslateX(l.getTranslateX()+i._canvasOffsetX+r):l.setTranslateY(l.getTranslateY()+i._canvasOffsetY+r),a.addProp(t.Animator.TYPE_NUMBER,l,l.getTranslateX,l.setTranslateX,d),a.addProp(t.Animator.TYPE_NUMBER,l,l.getTranslateY,l.setTranslateY,u),a.addProp(t.Animator.TYPE_NUMBER,l,l.getX,l.setX,g),a.addProp(t.Animator.TYPE_NUMBER,l,l.getY,l.setY,m),a.addProp(t.Animator.TYPE_NUMBER,l,l.getWidth,l.setWidth,S),a.addProp(t.Animator.TYPE_NUMBER,l,l.getHeight,l.setHeight,p)):(l.setTranslateX(d),l.setTranslateY(u),l.setX(g),l.setY(m),l.setWidth(S),l.setHeight(p))}};var b=function(e){this._context=e};t.Obj.createSubclass(b,t.Obj),b.prototype.parse=function(e,t){var i=this.buildData(e),s=new Object;return s.start=new Date(e.start).getTime(),s.end=new Date(e.end).getTime(),s.inlineStyle=e.style,e.svgStyle&&(s.inlineStyle=e.svgStyle),s.scale=e.scale,s.timeAxis=e.timeAxis,s.label=e.label,s.emptyText=e.emptyText,s.isIRAnimationEnabled="auto"===e.animationOnDisplay,s.isDCAnimationEnabled="auto"===e.animationOnDataChange,s.items=this._parseDataNode(e.timeline,e.index,i.data,t,s.start,s.end),s.rtl="false",s.isRandomItemLayout=e._isRandomItemLayout,s.customTimeScales=e._cts,s.customFormatScales=e._cfs,null==e.itemLayout||"auto"===e.itemLayout?s.isTopToBottom=e.inverted:s.isTopToBottom="topToBottom"===e.itemLayout,s.data=e._data,s},b.prototype.buildData=function(e){var t={},i=[],s=e.items;if(s)for(var r=0;r<s.length;r++){var a=s[r];i.push(a)}return t.data=i,t},b.prototype._parseDataNode=function(e,t,i,s,r,a){var n=[],l=e._series[t];if(i)for(var h=0;h<i.length;h++){var _=this.ParseNodeAttributes(i[h],r,a);if(_){if(l._allowUpdates){var c=this._findExistingItem(_,s);if(c){var u=s.indexOf(c);s.splice(u,1),c.setSpacing(null),c.setDurationLevel(null),c.setLoc(null),c.setSelected(!1),c.setStartTime(_.startTime),c.setEndTime(_.endTime),c.setStyle(_.style)}else(c=new o(e,t,_)).setSelectable(!0)}else(c=new o(e,t,_)).setSelectable(!0);for(var g=c.getStartTime(),d=!0,m=0;m<n.length;m++)if(g<n[m].getStartTime()){n.splice(m,0,c),d=!1;break}d&&n.push(c)}}return n},b.prototype._findExistingItem=function(e,i){if(i)for(var s=0;s<i.length;s++){var r=i[s];if(t.Obj.compareValues(this._context,e.id,r.getId())&&e.title===r.getTitle()&&e.desc===r.getDescription()&&e.thumbnail===r.getThumbnail())return r}return null},b.prototype.getDate=function(e){return null==e?null:e.getTime?e.getTime():isNaN(e)?new Date(e).getTime()+0:e},b.prototype.ParseNodeAttributes=function(e,t,i){var s=new Object;return s.id=e.id,s.rowKey=s.id,s.startTime=this.getDate(e.start),s.endTime=this.getDate(e.end),(s.endTime?s.endTime:s.startTime)<t||s.startTime>i?null:(s.title=e.title,s.desc=e.description,s.thumbnail=e.thumbnail,s.shortDesc=e.shortDesc,s.data=e,s.style=e.style,e.svgStyle&&(s.style=e.svgStyle),s.durationFillColor=e.durationFillColor,s.markerShape=e._markerShape,s.markerScaleX=e._markerScaleX,s.markerScaleY=e._markerScaleY,s.markerShortDesc=e._markerShortDesc,s.markerFillColor=e._markerFillColor,s.markerGradientFill=e._markerGradientFill,s.markerOpacity=e._markerOpacity,null==e._markerSD||e._markerSD?s.markerSD="true":s.markerSD="false",s.data=e,s)};var y=new Object;t.Obj.createSubclass(y,t.Obj),y.renderSeries=function(e,i,s){if(y._renderBackground(e,i,s),y._renderScrollableCanvas(e),y._renderReferenceObjects(e,e._canvas),y._renderSeriesTicks(e),null!=e._items){if(0===e._blocks.length){var r=e.getCtx(),a=new t.Container(r,"itemBlock_"+e._fetchStartPos+"_"+e._fetchEndPos);a.startPos=e._fetchStartPos,a.endPos=e._fetchEndPos;var n=new t.Container(r,"feelers");a.addChild(n),a.feelers=n;var o=new t.Container(r,"durations");a.addChild(o),a.durations=o,e._canvas.addChild(a),e._blocks.push(a)}else a=e._blocks[0];e.prepareDurations(e._items),e.prepareItems(e._items),e._isInitialRender?(e._isIRAnimationEnabled?e._frAnimationElems=[]:e._frAnimationElems=null,e._mvAnimator=null,e._rmAnimationElems=null):e._allowUpdates&&e._isDCAnimationEnabled?(e._frAnimationElems=[],e._mvAnimator=new t.Animator(e.getCtx(),p.getAnimationDuration(e.Options),0,t.Easing.cubicInOut),e._rmAnimationElems=[]):(e._frAnimationElems=null,e._mvAnimator=null,e._rmAnimationElems=null),e._hasMvAnimations=!1;var l=Math.max(0,e._maxOverflowValue-e._size);e._overflowOffset=l,y._adjustBackground(e,l),e._oldItems&&y._removeItems(e._oldItems,e,a,e._rmAnimationElems),e._oldItems=null,e.isVertical()&&a.feelers.removeChildren(),y._renderItems(e._items,e,a,e._fetchStartPos,e._fetchEndPos,l,e._frAnimationElems,e._mvAnimator),e._callbackObj.SelectionHandler&&a.setCursor(t.SelectionEffectUtils.getSelectingCursor()),y._updateReferenceObjects(e),y._updateSeriesTicks(e)}},y.updateSeriesForZoom=function(e){y._updateItemsForZoom(e._items,e),y._updateReferenceObjects(e),y._updateSeriesTicks(e)},y._renderBackground=function(e,i,s){if(e._background){var r=!1;e._background.setWidth(i),e._background.setHeight(s)}else r=!0,e._background=new t.Rect(e.getCtx(),0,0,i,s,"bg");e._background.setCSSStyle(e._style),e._background.setPixelHinting(!0),r&&e.addChild(e._background)},y._adjustBackground=function(e,i){var s=e.getCtx(),r=t.Agent.isRightToLeft(s);i>0&&(e.isVertical()?e._background.setWidth(e._maxOverflowValue):e._background.setHeight(e._maxOverflowValue)),e.isVertical()?(!e.isInverted()&&!r||e.isInverted()&&r)&&(e._background.setTranslateY(0),e._background.setTranslateX(-i),e.setHScrollPos(i)):e.isInverted()||(e._background.setTranslateX(0),e._background.setTranslateY(-i),e.setVScrollPos(i))},y._renderScrollableCanvas=function(e){if(e._canvas)return e._canvasOffsetX=e._canvas.getTranslateX(),e._canvasOffsetY=e._canvas.getTranslateY(),e._canvas.setTranslateX(0),void e._canvas.setTranslateY(0);e._canvas=new t.Container(e.getCtx(),"canvas"),e.addChild(e._canvas)},y._renderItems=function(e,t,i,r,a,n,o,l){for(var h,_=0;_<e.length;_++){h=e[_];var c=s.TimeAxisUtils.getDatePosition(t._start,t._end,h.getStartTime(),t._length);c>=r&&c<=a&&T.renderItem(h,t,i,n,o,l)}if(s.TimeAxisUtils.supportsTouch())for(var u=0;u<e.length-1;u++){var g=(h=e[u]).getBubble();if(g){var d=e[u+1];if(!d.getBubble())break;g._setAriaProperty("flowto","_bt_"+d.getId())}}y._renderDurations(e,t,i,n,o,l)},y._updateItemsForZoom=function(e,t){var i,r;if(null!=e&&0!==e.length){var a=t._fetchStartPos,n=t._fetchEndPos,o=t._blocks[0];for(o.startPos=a,o.endPos=n,t.isVertical()?t._initialSpacing=20*(t._maxDurationSize>0?1:0)+p.getBubbleSpacing()+10*t._maxDurationSize:t._initialSpacing=20+p.getBubbleSpacing()+10*t._maxDurationSize,r=0;r<e.length;r++){var l=(i=e[r]).getStartTime(),h=s.TimeAxisUtils.getDatePosition(t._start,t._end,l,t._length),_=i.getEndTime();if(_&&_!==l){var c=s.TimeAxisUtils.getDatePosition(t._start,t._end,_,t._length)-h;h+=Math.min(p.getDurationFeelerOffset(),c/2)}i.setLoc(h),t._isRandomItemLayout||i.setSpacing(null)}for(r=0;r<e.length;r++){var u=(i=e[r]).getStartTime();u>=t._start&&u<=t._end&&T._updateBubble(i,t,r)}var g=Math.max(0,t._maxOverflowValue-t._size);for(y._adjustBackground(t,g),r=0;r<e.length;r++)i=e[r],T._displayBubble(i,t,g,null,!1),T._updateFeeler(i,t,g,null),T._updateDuration(i,t,g,null)}},y._renderDurations=function(e,t,i,s,r,a){for(var n=i.durations,o=t._maxDurationSize;o>0;o--)for(var l=0;l<e.length;l++){var h=e[l],_=h.getStartTime(),c=h.getEndTime();c&&c!==_&&o===h.getDurationLevel()&&T.renderDuration(h,t,n,s,r,a)}},y._renderSeriesTicks=function(e){if(null==e._seriesTicks?(e._seriesTicks=new t.Container(e.getCtx()),e._canvas.addChild(e._seriesTicks)):(e._seriesTicks.removeChildren(),e._seriesTicksArray=[]),e._scale&&e._timeAxis){var i=new t.CSSStyle(p.getSeriesAxisSeparatorStyle());if(e._axisStyleDefaults){var s=e._axisStyleDefaults.separatorColor;s&&i.parseInlineStyle("color:"+s+";")}e._separatorStroke=new t.Stroke(i.getStyle(t.CSSStyle.COLOR),1,1,!1,{dashArray:"3"}),y._renderSeriesTimeAxis(e,e._fetchStartPos,e._fetchEndPos,e._seriesTicks)}},y._updateSeriesTicks=function(e){for(var i=e.getCtx(),r=t.Agent.isRightToLeft(i),a=0;a<e._seriesTicksArray.length;a++){var n=e._seriesTicksArray[a];if(!e.isVertical()&&r)var o=e._length-s.TimeAxisUtils.getDatePosition(e._start,e._end,n.time,e._length);else o=s.TimeAxisUtils.getDatePosition(e._start,e._end,n.time,e._length);e.isVertical()?(n.setX1(0),n.setY1(o),n.setX2(e._maxOverflowValue),n.setY2(o)):(n.setX1(o),n.setY1(0),n.setX2(o),n.setY2(e._maxOverflowValue))}},y._renderSeriesTimeAxis=function(e,i,r,a){var n,o=e.getCtx(),l=t.Agent.isRightToLeft(o),h=e._start,_=e._end;if(e._customTimeScales&&e._customTimeScales[e._scale])n=e._customTimeScales[e._scale].times;else if(e._customFormatScales&&e._customFormatScales[e._scale]){n=e._customFormatScales[e._scale].times}else{n=[];var c=s.TimeAxisUtils.getPositionDate(h,_,i,e._length),u=e._timeAxis.adjustDate(c),g=s.TimeAxisUtils.getDatePosition(h,_,u,e._length);for(n.push(u.getTime());g<r;)u=e._timeAxis.getNextDate(u.getTime()),g=s.TimeAxisUtils.getDatePosition(h,_,u,e._length),n.push(u.getTime())}for(var d=0;d<n.length-1;d++){var m=n[d];if(g=s.TimeAxisUtils.getDatePosition(h,_,m,e._length),!e.isVertical()&&l)var S=e._length-g;else S=g;if(e.isVertical())var p=0,f=S,v=e._maxOverflowValue,T=S;else p=S,f=0,v=S,T=e._maxOverflowValue;var b=e.addTick(a,p,v,f,T,e._separatorStroke,"o_tick"+g);b.time=m,e._seriesTicksArray.push(b)}},y._renderReferenceObjects=function(e,i){var r=e.getCtx(),a=t.Agent.isRightToLeft(r);null==e._refObjectsContainer&&(e._refObjectsContainer=new t.Container(r),i.addChild(e._refObjectsContainer));var n=e._referenceObjects;if(n)for(var o=Math.min(1,n.length),l=0;l<o;l++){var h=n[l];if(h){var _=s.TimeAxisUtils.getDatePosition(e._start,e._end,h,e._length);if(0===e._renderedReferenceObjects.length){if(e.isVertical())var c=new t.Line(r,0,_,e._maxOverflowValue,_,"zoomOrder[i]");else a&&(_=e._length-_),c=new t.Line(r,_,0,_,e._maxOverflowValue,"zoomOrder[i]");var u=new t.Stroke(p.getReferenceObjectColor(e.Options));c.setStroke(u),c.setPixelHinting(!0),c.date=h,e._refObjectsContainer.addChild(c),e._renderedReferenceObjects[l]=c}else(c=e._renderedReferenceObjects[l]).date=h,_=s.TimeAxisUtils.getDatePosition(e._start,e._end,c.date,e._length),e.isVertical()?(c.setX1(0),c.setY1(_),c.setX2(e._maxOverflowValue),c.setY2(_)):(a&&(_=e._length-_),c.setX1(_),c.setY1(0),c.setX2(_),c.setY2(e._maxOverflowValue))}}else e._refObjectsContainer.removeChildren(),e._renderedReferenceObjects=[]},y._updateReferenceObjects=function(e){for(var i=e.getCtx(),r=t.Agent.isRightToLeft(i),a=0;a<e._renderedReferenceObjects.length;a++){var n=e._renderedReferenceObjects[a],o=s.TimeAxisUtils.getDatePosition(e._start,e._end,n.date,e._length);e.isVertical()?(n.setX1(0),n.setY1(o),n.setX2(e._maxOverflowValue),n.setY2(o)):(r&&(o=e._length-o),n.setX1(o),n.setY1(0),n.setX2(o),n.setY2(e._maxOverflowValue))}},y._removeItems=function(e,t,i,s){if(s)y._animateItemRemoval(e,t,s);else for(var r=0;r<e.length;r++){var a=e[r],n=a.getBubble();if(i.removeChild(n),!t.isVertical()){var o=i.feelers,l=a.getFeeler();o.removeChild(l)}var h=a.getStartTime(),_=a.getEndTime();if(_&&_!==h){var c=i.durations,u=a.getDurationBar();c.removeChild(u)}}},y._animateItemRemoval=function(e,t,i){for(var s=0;s<e.length;s++){var r=e[s],a=r.getBubble();if(t.isVertical()?a.setTranslateX(a.getTranslateX()+t._canvasOffsetX+t._overflowOffset):a.setTranslateY(a.getTranslateY()+t._canvasOffsetY+t._overflowOffset),i.push(a),!t.isVertical()){var n=r.getFeeler();n.setTranslateY(n.getTranslateY()+t._canvasOffsetY+t._overflowOffset),i.push(n)}var o=r.getStartTime(),l=r.getEndTime();if(l&&l!==o){var h=r.getDurationBar();t.isVertical()?h.setTranslateX(h.getTranslateX()+t._canvasOffsetX+t._overflowOffset):h.setTranslateY(h.getTranslateY()+t._canvasOffsetY+t._overflowOffset),i.push(h)}}};var E=function(e,t,i){this.Init(e,t,i)};t.Obj.createSubclass(E,t.BaseComponent),E.prototype.Init=function(e,t,i){E.superclass.Init.call(this,e),this._callback=t,this._callbackObj=i,this._blocks=[],this._renderedReferenceObjects=[],this._seriesTicksArray=[]},E.prototype.triggerAnimations=function(){var e=this.getCtx();if(this._rmAnimationElems&&0!==this._rmAnimationElems.length){this._callbackObj.EventManager.removeListeners(this._callbackObj);var i=new t.ParallelPlayable(e,new t.AnimFadeOut(e,this._rmAnimationElems,p.getAnimationDuration(this.Options)));t.Playable.appendOnEnd(i,this._onRmAnimationEnd,this),this._callbackObj.Animation=i,i.play()}else if(this._mvAnimator&&this._hasMvAnimations)this._callbackObj.EventManager.removeListeners(this._callbackObj),t.Playable.appendOnEnd(this._mvAnimator,this._onMvAnimationEnd,this),this._callbackObj.Animation=this._mvAnimator,this._mvAnimator.play();else if(this._frAnimationElems&&0!==this._frAnimationElems.length){this._callbackObj.EventManager.removeListeners(this._callbackObj);var s=new t.ParallelPlayable(e,new t.AnimFadeIn(e,this._frAnimationElems,p.getAnimationDuration(this.Options),(this._isInitialRender,0)));t.Playable.appendOnEnd(s,this._onAnimationEnd,this),this._callbackObj.Animation=s,s.play()}},E.prototype._onRmAnimationEnd=function(){for(var e=0;e<this._rmAnimationElems.length;e++){var i=this._rmAnimationElems[e],s=i.getParent();s&&s.removeChild(i)}this._mvAnimator&&this._hasMvAnimations?(this._callbackObj.Animation=this._mvAnimator,t.Playable.appendOnEnd(this._mvAnimator,this._onMvAnimationEnd,this),this._mvAnimator.play()):this._onMvAnimationEnd()},E.prototype._onMvAnimationEnd=function(){if(this._frAnimationElems&&0!==this._frAnimationElems.length){var e=new t.ParallelPlayable(this.getCtx(),new t.AnimFadeIn(this.getCtx(),this._frAnimationElems,p.getAnimationDuration(this.Options),(this._isInitialRender,0)));t.Playable.appendOnEnd(e,this._onAnimationEnd,this),this._callbackObj.Animation=e,e.play()}else this._onAnimationEnd()},E.prototype._onAnimationEnd=function(){this._callbackObj.onAnimationEnd()},E.prototype.render=function(e,i,r){if(e){this.SetOptions(e),this.Width?this._isInitialRender=!1:this._isInitialRender=!0,this.Width=i,this.Height=r;var a=this.Options.orientation;if(a&&a===s.TimeAxis.ORIENTATION_VERTICAL?(this._isVertical?this._allowUpdates=!0:this._allowUpdates=!1,this._isVertical=!0):(this._isVertical?this._allowUpdates=!1:this._allowUpdates=!0,this._isVertical=!1),this.Options){var n=this.Parse(this.Options);this._applyParsedProperties(n)}this._fetchStartPos=0,this._isVertical?(this._fetchEndPos=r,this._maxOverflowValue=i,this._length=r,this._size=i):(this._fetchEndPos=i,this._maxOverflowValue=r,this._length=i,this._size=r),this._isInverted=this.Options.inverted,this._colorCount=0,this._maxDurationSize=0,y.renderSeries(this,i,r),s.TimeAxisUtils.supportsTouch()&&this._items.length>0&&this._setAriaProperty("flowto","_bt_"+this._items[0].getId());var o=this.GetComponentDescription();o&&(t.ToolkitUtils.setAttrNullNS(this.getElem(),"role","img"),t.ToolkitUtils.setAttrNullNS(this.getElem(),"aria-label",t.AriaUtils.processAriaLabel(o)))}else this._handleResize(i,r)},E.prototype.GetComponentDescription=function(){var e=this.Options.translations,i=[e.labelSeries];return this._label?i.push(this._label):i.push(this.Options.index+1),t.ResourceUtils.format(e.labelAndValue,i)},E.prototype._handleResize=function(e,t){this._canvas.setTranslateY(0),this._canvas.setTranslateX(0),this.Width=e,this.Height=t,this._fetchStartPos=0,this._isVertical?(this._fetchEndPos=t,this._maxOverflowValue=e,this._length=t,this._size=e):(this._fetchEndPos=e,this._maxOverflowValue=t,this._length=e,this._size=t),this._background.setWidth(e),this._background.setHeight(t),y.updateSeriesForZoom(this)},E.prototype.applyStyleValues=function(){if(this._style=new t.CSSStyle(p.getSeriesStyle()),this._seriesStyleDefaults=this.Options.seriesStyleDefaults,this._axisStyleDefaults=this.Options.axisStyleDefaults,this._colors=p.getColorsArray(this.Options),this._referenceObjects=this.Options.referenceObjects,this._seriesStyleDefaults){var e=this._seriesStyleDefaults.backgroundColor;e&&this._style.parseInlineStyle("background-color:"+e+";")}this._style.parseInlineStyle(this._inlineStyle)},E.prototype.SetOptions=function(e){this.Options=e},E.prototype.Parse=function(e){return this._parser=new b(this.getCtx()),this._parser.parse(e,this._items)},E.prototype._applyParsedProperties=function(e){this._items&&(this._oldItems=this._items),this._items=e.items,this._items&&this._items.length>0?this._isEmpty=!1:this._isEmpty=!0,this._isIRAnimationEnabled=e.isIRAnimationEnabled,this._isDCAnimationEnabled=e.isDCAnimationEnabled,this._label=e.label,this._timeAxis=e.timeAxis,this._emptyText=e.emptyText,null==this._emptyText&&(this._emptyText=this.Options.translations.labelNoData),this._isTopToBottom=e.isTopToBottom,this._isRandomItemLayout=e.isRandomItemLayout,this._customTimeScales=e.customTimeScales,this._customFormatScales=e.customFormatScales,this._start=e.start,this._end=e.end,this._inlineStyle=e.inlineStyle,this._scale=e.scale,this._converter=e.converter,this._data=e.data,this.applyStyleValues()},E.prototype.calculateSpacing=function(e,t){var i,s,r;if(null!=this._items&&0!==this._items.length){var a=this._maxOverflowValue,n=e.getSpacing();if(this._isRandomItemLayout){if(null==n){var o=e.getHeight(),l=this._initialSpacing,h=this._maxOverflowValue-o-l;h<0&&(h=0),n=Math.round(Math.random()*h)+l,this._maxOverflowValue<n+o&&(this._maxOverflowValue=n+o+p.getBubbleSpacing())}return n}if(null==n&&(n=this._initialSpacing),this._isVertical)for(i=0;i<t;i++)a<n+(r=(s=this._items[i]).getWidth()+10)&&(a=n+r);else{var _=e.getLoc(),c=e.getWidth()+10,u=p.getBubbleSpacing(),g=[];for(i=0;i<t;i++){r=(s=this._items[i]).getWidth()+10;var d=s.getLoc();(_>=d&&_<=d+r||d>=_&&d<=_+c)&&g.push(s)}for(i=0;i<g.length;i++){for(var m=!1,S=0;S<g.length;S++){var f=(s=g[S]).getHeight(),v=s.getSpacing();if(n>=v&&n<=v+f){n=v+f+u,e.setSpacing(n),m=!0;break}}if(!m)break}a<n+f&&(a=n+f)}return a>this._maxOverflowValue&&(this._maxOverflowValue=a+p.getBubbleSpacing()),n}},E.prototype.calculateDurationSize=function(e,t){var i,s;if(null!=this._items&&0!==this._items.length){var r=e.getStartTime(),a=e.getEndTime();if(a&&a!==r){var n=e.getDurationLevel();null==n&&(n=1);var o=[];for(i=0;i<t;i++){var l=(s=this._items[i]).getStartTime(),h=s.getEndTime();h&&h!==l&&r>=l&&r<=h&&o.push(s)}for(i=0;i<o.length;i++){for(var _=!1,c=0;c<o.length;c++){var u=(s=o[c]).getDurationLevel();if(n===u){n=u+1,e.setDurationLevel(n),_=!0;break}}if(!_)break}return n>this._maxDurationSize&&(this._maxDurationSize=n),n}}},E.prototype.prepareDurations=function(e){for(var t=0;t<this._items.length;t++){var i=this._items[t],s=i.getStartTime(),r=i.getEndTime();r&&r!==s&&(i.setDurationLevel(this.calculateDurationSize(i,t)),i.setDurationSize(22+10*i.getDurationLevel()-5),null==i.getDurationFillColor()&&(i.setDurationFillColor(this._colors[this._colorCount]),this._colorCount++,this._colorCount===this._colors.length&&(this._colorCount=0)))}},E.prototype.prepareItems=function(e){var t,i,r;for(this.isVertical()?this._initialSpacing=20*(this._maxDurationSize>0?1:0)+p.getBubbleSpacing()+10*this._maxDurationSize:this._initialSpacing=20+p.getBubbleSpacing()+10*this._maxDurationSize,t=0;t<e.length;t++){i=e[t],r=s.TimeAxisUtils.getDatePosition(this._start,this._end,i.getStartTime(),this._length);var a=i.getEndTime();if(a&&a!==i.getStartTime()){var n=s.TimeAxisUtils.getDatePosition(this._start,this._end,a,this._length)-r;r+=Math.min(p.getDurationFeelerOffset(),n/2)}i.setLoc(r)}for(t=0;t<this._items.length;t++)i=this._items[t],(r=s.TimeAxisUtils.getDatePosition(this._start,this._end,i.getStartTime(),this._length))>=this._fetchStartPos&&r<=this._fetchEndPos&&T.initializeItem(i,this,t)},E.prototype.getData=function(e){if(e){var t={emptyText:this._data.emptyText,id:this._data.id,itemLayout:this._data.itemLayout,label:this._data.label,svgStyle:this._data.svgStyle,items:this._data.items};return i.TimeComponent.sanitizeData(t,"series")}return this._data},E.prototype.getLabel=function(){return this._label},E.prototype.getEmptyText=function(){return this._emptyText},E.prototype.findItem=function(e){if(null!=this._items)for(var i=0;i<this._items.length;i++){var s=this._items[i];if(t.Obj.compareValues(this.getCtx(),s.getId(),e))return s}return null},E.prototype.isInverted=function(){return this._isInverted},E.prototype.isTopToBottom=function(){return this._isTopToBottom},E.prototype.isVertical=function(){return this._isVertical},E.prototype.addTick=function(e,i,s,r,a,n,o){var l=new t.Line(this.getCtx(),i,r,s,a,o);return l.setStroke(n),l.setPixelHinting(!0),e.addChild(l),l},E.prototype.setVScrollPos=function(e){null!=this._canvas&&this._canvas.setTranslateY(0-e)},E.prototype.setHScrollPos=function(e){null!=this._canvas&&this._canvas.setTranslateX(0-e)};const O=function(e,t,i){this.Init(e,t,i)};t.Obj.createSubclass(O,i.TimeComponent),O.newInstance=function(e,t,i){return new O(e,t,i)},O.prototype.Init=function(e,i,s){O.superclass.Init.call(this,e,i,s),this.Defaults=new h(e),this.EventManager=new _(this,e,i,s),this.EventManager.addListeners(this),t.Agent.isTouchDevice()?this._keyboardHandler=null:(this._keyboardHandler=new a(this.EventManager),this.EventManager.setKeyboardHandler(this._keyboardHandler))},O.prototype.Parse=function(e){return this._parser=new c,this._parser.parse(e)},O.prototype._applyParsedProperties=function(e){var i=this.Options.orientation;i&&i===s.TimeAxis.ORIENTATION_VERTICAL?this._isVertical=!0:this._isVertical=!1,this._hasOverview=e.hasOverview,this._viewStartTime=e.viewStart,this._viewEndTime=e.viewEnd,this._selectionMode=e.selectionMode,"single"===this._selectionMode?this.SelectionHandler=new t.SelectionHandler(this.getCtx(),t.SelectionHandler.TYPE_SINGLE):"multiple"===this._selectionMode?this.SelectionHandler=new t.SelectionHandler(this.getCtx(),t.SelectionHandler.TYPE_MULTIPLE):this.SelectionHandler=null,this.EventManager.setSelectionHandler(this.SelectionHandler),this._shortDesc=e.shortDesc,this._referenceObjects=e.referenceObjects,this._seriesScale=e.seriesScale,this._seriesScale?(this._seriesConverter=e.seriesConverter,this._seriesTimeAxis=new s.TimeAxis(this.getCtx(),null,null),this._seriesTimeAxis.setIsVertical(this._isVertical),this._seriesTimeAxis.setScale(this._seriesScale),this._seriesTimeAxis.setConverter(this._seriesConverter),this._seriesCustomFormatScales=e.seriesCustomFormatScales,this._isVertical?this._seriesTimeAxis.setDefaultConverter(this._resources.converterVert):this._seriesTimeAxis.setDefaultConverter(this._resources.converter)):this._seriesTimeAxis=null,this._defaultInversions=[!1,!0],this._itemPosition=e.itemPosition,this._customTimeScales=e.customTimeScales,this._customFormatScales=e.customFormatScales,this._scale=e.scale,O.superclass._applyParsedProperties.call(this,e)},O.prototype.getTimeAxis=function(){return this._timeAxis},O.prototype.getTimeAxisSize=function(){return this._timeAxis.getSize()},O.prototype.getTimeAxisVisibleSize=function(e){return this._hasOverview||1!==e?this.getTimeAxisSize():this.getTimeAxisSize()-this._timeAxis.getBorderWidth()},O.prototype.select=function(e){this.Options.selection=t.JsonUtils.clone(e),this.SelectionHandler&&this.applyInitialSelections()},O.prototype._bundleTimeAxisOptions=function(e){if(this._timeAxisOptions={start:e.start,end:e.end,_resources:e._resources,shortDesc:e.shortDesc,_tzo:e._tzo,_ip:e._ip,_cts:this._customTimeScales,_cfs:this._customFormatScales,orientation:e.orientation},e.styleDefaults&&e.styleDefaults.minorAxis){var t=e.styleDefaults.minorAxis;this._timeAxisOptions.backgroundColor=t.backgroundColor,this._timeAxisOptions.borderColor=t.borderColor,this._timeAxisOptions.separatorColor=t.separatorColor,this._timeAxisOptions.labelStyle=t.labelStyle}if(e.minorAxis){var i=e.minorAxis;this._timeAxisOptions.scale=i.scale,this._timeAxisOptions.converter=i.converter,this._timeAxisOptions.zoomOrder=i.zoomOrder,this._timeAxisOptions.style=i.style,i.svgStyle&&(this._timeAxisOptions.style=i.svgStyle)}},O.prototype.render=function(e,t,i){if(e){if(O.superclass.render.call(this,e,t,i),this.StopAnimation(),this._fetchStartPos=0,this._isVertical?this._fetchEndPos=i:this._fetchEndPos=t,this.Options.styleDefaults&&(this.Options.styleDefaults.item.descriptionStyle=p.convertToCSSStyle(this.Options.styleDefaults.item.descriptionStyle),this.Options.styleDefaults.item.titleStyle=p.convertToCSSStyle(this.Options.styleDefaults.item.titleStyle),this.Options.styleDefaults.majorAxis.labelStyle=p.convertToCSSStyle(this.Options.styleDefaults.majorAxis.labelStyle),this.Options.styleDefaults.minorAxis.labelStyle=p.convertToCSSStyle(this.Options.styleDefaults.minorAxis.labelStyle),this.Options.styleDefaults.overview.labelStyle=p.convertToCSSStyle(this.Options.styleDefaults.overview.labelStyle),this.Options.styleDefaults.series.emptyTextStyle=p.convertToCSSStyle(this.Options.styleDefaults.series.emptyTextStyle),this.Options.styleDefaults.series.labelStyle=p.convertToCSSStyle(this.Options.styleDefaults.series.labelStyle),this.Options.styleDefaults.tooltipLabelStyle=p.convertToCSSStyle(this.Options.styleDefaults.tooltipLabelStyle),this.Options.styleDefaults.tooltipValueStyle=p.convertToCSSStyle(this.Options.styleDefaults.tooltipValueStyle),this._majorAxisStyleDefaults=this.Options.styleDefaults.majorAxis,this._seriesStyleDefaults=this.Options.styleDefaults.series),this._scale){this._bundleTimeAxisOptions(this.Options),this.applyAxisStyleValues(),this._timeAxis||(this._timeAxis=new s.TimeAxis(this.getCtx(),null,null)),this._isVertical?this._timeAxis.setBorderVisibility(!1,!0,!1,!0):this._timeAxis.setBorderVisibility(!0,!1,!0,!1),this._timeAxis.setCanvasSize(null);var r=this._timeAxis.getPreferredLength(this._timeAxisOptions,this._canvasLength);r&&this.setContentLength(r),this._timeAxis.hasValidOptions()&&this.prepareViewportLength()}this._populateSeries(),f.renderTimeline(this),this.UpdateAriaAttributes(),s.TimeAxisUtils.supportsTouch()||this.getCtx().setKeyboardFocusArray([this]),this.Animation||this.RenderComplete()}else this._handleResize(t,i)},O.prototype.hasValidSeriesItems=function(){for(var e=0;e<this._seriesOptions.length;e++){var t=this._seriesOptions[e];if(t.items)for(var i=0;i<t.items.length;i++){var s=t.items[i],r=new Date(s.start).getTime();if(!r)return!1;if(s.hasOwnProperty("end")){var a=new Date(s.end).getTime();if(!isNaN(a)&&a<r)return!1}}}return!0},O.prototype.hasValidOptions=function(){var e=this._scale&&(-1!==s.TimeAxis._VALID_SCALES.indexOf(this._scale)||this.isTimeComponentScale(this._scale)),t=this._scale&&this._customTimeScales&&this._customTimeScales[this._scale],i=this._start&&this._end&&this._end>this._start,r=this._series&&this._series.length>0,a=!!r&&this.hasValidSeriesItems(),n=!this._seriesScale||(-1!==s.TimeAxis._VALID_SCALES.indexOf(this._seriesScale)||this.isTimeComponentScale(this._seriesScale)),o=!this._seriesScale||this._customTimeScales&&this._customTimeScales[this._seriesScale],l=!this._viewStartTime||!this._viewEndTime||this._viewEndTime>this._viewStartTime,h=!this._viewStartTime||this._viewStartTime>=this._start&&this._viewStartTime<this._end,_=!this._viewEndTime||this._viewEndTime>this._start&&this._viewEndTime<=this._end;return(e||t)&&(n||o)&&i&&r&&a&&l&&h&&_},O.prototype.isTimeComponentScale=function(e){return null!=e.getNextDate&&null!=e.getPreviousDate&&null!=e.formatter&&null!=e.name},O.prototype.GetComponentDescription=function(){return this._shortDesc?this._shortDesc:this.Options.translations.componentName},O.prototype.applyStyleValues=function(){if(this._style=new t.CSSStyle(p.getTimelineStyle()),this.Options.styleDefaults){var e=this.Options.styleDefaults.borderColor;e&&this._style.parseInlineStyle("border-color:"+e+";")}if(this._hasOverview){this._overviewSize=this._isVertical?p.getOverviewWidth():p.getOverviewHeight();var i=this.Options.overview,s=i.svgStyle?i.svgStyle:i.style;if(s){var r=new t.CSSStyle(s),a=this._isVertical?r.getWidth():r.getHeight();null!=a&&(this._overviewSize=t.CSSStyle.toNumber(a))}}O.superclass.applyStyleValues.call(this);var n=this._style.getBorderWidth(),o=2*n,l="border:"+o+"px;";this._style.parseInlineStyle(l),this.setStartXOffset(n),this.setStartYOffset(n),this.setBackgroundXOffset(0);var h=3*this.getScrollbarPadding();this.timeDirScrollbarStyles=this.getTimeDirScrollbarStyle(),this.contentDirScrollbarStyles=this.getContentDirScrollbarStyle(),this._backgroundWidth=this.Width,this._backgroundHeight=this.Height,this._isVertical?(this.isContentDirScrollbarOn()&&(this._backgroundHeight=this._backgroundHeight-t.CSSStyle.toNumber(this.contentDirScrollbarStyles.getHeight())-h),this._canvasLength=this._backgroundHeight-o,this._hasOverview?(this._canvasSize=this._backgroundWidth-this._overviewSize-o,this.isRTL()&&this.setStartXOffset(n+this._overviewSize)):(this.isTimeDirScrollbarOn()&&(this._backgroundWidth=this._backgroundWidth-t.CSSStyle.toNumber(this.timeDirScrollbarStyles.getWidth())-h),this._canvasSize=this._backgroundWidth-o,this.isRTL()&&(this.setBackgroundXOffset(this.Width-this._backgroundWidth),this.setStartXOffset(this.getStartXOffset()+this.getBackgroundXOffset())))):(this.isContentDirScrollbarOn()&&(this._backgroundWidth=this._backgroundWidth-t.CSSStyle.toNumber(this.contentDirScrollbarStyles.getWidth())-h),this._canvasLength=this._backgroundWidth-o,this.isRTL()&&(this.setBackgroundXOffset(this.Width-this._backgroundWidth),this.setStartXOffset(this.getStartXOffset()+this.getBackgroundXOffset())),this._hasOverview?this._canvasSize=this._backgroundHeight-this._overviewSize-o:(this.isTimeDirScrollbarOn()&&(this._backgroundHeight=this._backgroundHeight-t.CSSStyle.toNumber(this.timeDirScrollbarStyles.getHeight())-h),this._canvasSize=this._backgroundHeight-o))},O.prototype.applyAxisStyleValues=function(){if(this._seriesStyleDefaults&&this._seriesStyleDefaults.backgroundColor){var e=this._seriesStyleDefaults.backgroundColor,i=t.ColorUtils.getRed(e),s=t.ColorUtils.getGreen(e),r=t.ColorUtils.getBlue(e);this._seriesBackgroundOverlayStyle="background-color:rgba("+i+","+s+","+r+",0.8);"}},O.prototype._populateSeries=function(){var e,t=this.Options.series;if(t){var i=Math.min(t.length,2);if(this._seriesOptions=[],this._series){if(i!==this._series.length){for(e=0;e<this._series.length;e++)this._timeZoomCanvas.removeChild(this._series[e]);this._series=[]}}else this._series=[];for(e=0;e<i;e++){var s=t[e];if(s.start=this._start,s.end=this._end,s.inverted=this._defaultInversions[e],s.orientation=this.Options.orientation,s.referenceObjects=this._referenceObjects,s.timeline=this,s.index=e,s.animationOnDisplay=this.Options.animationOnDisplay,s.animationOnDataChange=this.Options.animationOnDataChange,this.Options.majorAxis&&(s.scale=this.Options.majorAxis.scale,s.timeAxis=this._seriesTimeAxis,s._cfs=this._seriesCustomFormatScales),s.styleDefaults=this.Options.styleDefaults,this.Options.styleDefaults&&(s.seriesStyleDefaults=this._seriesStyleDefaults,s.axisStyleDefaults=this._majorAxisStyleDefaults),s._isRandomItemLayout="random"===this._itemPosition,s._cts=this.Options._cts,s._data=t[e],s.translations=this.Options.translations,this._seriesOptions.push(s),null==this._series[e]){var r=new E(this.getCtx(),this.HandleEvent,this);this._series.push(r)}}}else this._series=[]},O.prototype.onAnimationEnd=function(){this.AnimationStopped||this.RenderComplete(),this.EventManager.addListeners(this),this.Animation=null,this.AnimationStopped=!1},O.prototype._getOverviewObject=function(){var e=new Object;e.width=this._contentLength,e.selmode=this._selectionMode,e.rtl=this.isRTL(),e.sid="ts1";var t=p.getOverviewWindowBackgroundColor(this.Options);e._wbc=t,e._hfc=t;var i=p.getOverviewWindowBorderColor(this.Options);return e._wbtc=i,e._wbrc=i,e._wbbc=i,e._wblc=i,e._ls=p.getOverviewLabelStyle(this.Options).toString(),e._obc=p.getOverviewBackgroundColor(this.Options),e._ctic=p.getReferenceObjectColor(this.Options),this._referenceObjects&&this._referenceObjects.length>0&&this._referenceObjects[0]&&(e.ocd=this._referenceObjects[0].getTime()),this._isVertical?(e.orn="vertical",e.yMin=this._start,e.yMax=this._end,e.y1=this._viewStartTime,e.y2=this._viewEndTime):(e.orn="horizontal",e.xMin=this._start,e.xMax=this._end,e.x1=this._viewStartTime,e.x2=this._viewEndTime,e._ds="square",e._dsx="1.3d",e._dsy="0.9d"),this._resources.overviewHandleVert&&(e._vhbc=this._resources.overviewHandleVert,e._vhs=16),this._resources.overviewHandleHor&&(e._hbc=this._resources.overviewHandleHor,e._hs=16),e.axisTicks=this._getOverviewAxisOptions(),e.markers=this._getOverviewMarkerOptions(),e},O.prototype._getOverviewAxisOptions=function(){var e=[];if(this._seriesTimeAxis){var t,i;if(this._customTimeScales&&this._customTimeScales[this._seriesScale]){var r=this._customTimeScales[this._seriesScale];t=r.times,i=r.labels}else if(this._seriesCustomFormatScales&&this._seriesCustomFormatScales[this._seriesScale]){var a=this._seriesCustomFormatScales[this._seriesScale];t=a.times,i=a.labels}else{t=[],i=[];for(var n=this._start,o=this._end,l=this._isVertical?this.Height:this.Width,h=s.TimeAxisUtils.getPositionDate(n,o,this._fetchStartPos,l),_=this._seriesTimeAxis.adjustDate(h),c=s.TimeAxisUtils.getDatePosition(n,o,_,l);c<this._fetchEndPos;)i.push(this._seriesTimeAxis.formatDate(_)),t.push(_.getTime()),_=this._seriesTimeAxis.getNextDate(_.getTime()),c=s.TimeAxisUtils.getDatePosition(n,o,_,l)}for(var u=0;u<i.length;u++){var g=new Object;g.time=t[u],g.label=i[u],e.push(g)}}return e},O.prototype._getOverviewMarkerOptions=function(){if(this._series){for(var e=[],t=this._series.length,i=0;i<t;i++)for(var s=this._series[i]._items,r=0;r<s.length;r++){var a=s[r],n=new Object;n.rk=r,n.sid=i,n.tid=a.getId(),n.t=a.getStartTime(),n._sd=a.getMarkerSD(),this._isVertical||(a.getMarkerShape()&&(n.s=a.getMarkerShape()),a.getMarkerScaleX()&&(n.sx=a.getMarkerScaleX()),a.getMarkerScaleY()&&(n.sy=a.getMarkerScaleY())),a.getMarkerShortDesc()&&(n.d=a.getMarkerShortDesc()),a.getMarkerFillColor()&&(n.c=a.getMarkerFillColor()),a.getMarkerGradientFill()&&(n.g=a.getMarkerGradientFill()),a.getMarkerOpacity()&&(n.o=a.getMarkerOpacity());var o=a.getEndTime();if(o){n.et=o;var l=a.getDurationFillColor();l&&(n.dfc=l)}e.push(n)}return e}},O.prototype.createViewportChangeEvent=function(){var e=this._timeAxis.getScale();return"string"!=typeof e&&(e=e.name),t.EventFactory.newTimelineViewportChangeEvent(this._viewStartTime,this._viewEndTime,e)},O.prototype.HandleTouchStart=function(e){1===e.touches.length&&(this._dragPanSeries=this._findSeries(e.target))},O.prototype.HandleMouseWheel=function(e){if(O.superclass.HandleMouseWheel.call(this,e),this.hasValidOptions()&&e.zoomWheelDelta){var t=this.getCtx().pageToStageCoords(e.pageX,e.pageY);if(this.getGraphicalAreaBounds().containsPoint(t.x,t.y)){var i=this.getContentLength()*e.zoomWheelDelta,s=e.zoomTime,r=e.zoomCompLoc;this.handleZoomWheel(i,s,r,!0)}}},O.prototype.handleZoomWheel=function(e,t,i,s){var r;e>this._timeAxis.getMaxContentLength()?(e=this._timeAxis.getMaxContentLength(),this.disableZoomButton(!0)):this.enableZoomButton(!0),this._canvasLength>e?(e=this._canvasLength,this.disableZoomButton(!1)):this.enableZoomButton(!1);var a=this.getContentLength()<=e;O.superclass.handleZoomWheel.call(this,e,t,i,s);var n=this._timeAxis.getZoomLevelLengths();if(a)for(;this._timeAxis.getZoomLevelOrder()>0&&(r=n[this._timeAxis.getZoomLevelOrder()-1],this.getContentLength()>=r);)this._timeAxis.setZoomLevelOrder(this._timeAxis.getZoomLevelOrder()-1),this._timeAxis.decreaseScale();else for(;this._timeAxis.getZoomLevelOrder()<n.length-1&&(r=n[this._timeAxis.getZoomLevelOrder()],this.getContentLength()<r);)this._timeAxis.setZoomLevelOrder(this._timeAxis.getZoomLevelOrder()+1),this._timeAxis.increaseScale();if(this._hasOverview&&(this._isVertical?this._overview.setViewportRange(null,null,this._viewStartTime,this._viewEndTime):this._overview.setViewportRange(this._viewStartTime,this._viewEndTime,null,null)),this.isTimeDirScrollbarOn()&&this.timeDirScrollbar.setViewportRange(this._viewStartTime,this._viewEndTime),this.applyAxisStyleValues(),f._renderAxis(this,this._timeZoomCanvas,!0),this.updateSeries(),this.isContentDirScrollbarOn())for(var o=0;o<this._series.length;o++)this.contentDirScrollbar[o].setViewportRange(0,this._seriesSize,0,Math.max(this._series[o]._maxOverflowValue,this._seriesSize));s&&this.dispatchEvent(this.createViewportChangeEvent())},O.prototype.updateSeries=function(){if(this._series){var e=this._series.length,i=this.getTimeAxisVisibleSize(e);this._seriesSize=(this._canvasSize-i)/e;for(var s=0;s<e;s++){var r=this._series[s];r.setClipPath(null);var a=new t.ClipPath;if(this._isVertical){if(this.isRTL())var n=Math.abs(s-1);else n=s;if(this.isRTL()&&1===this._series.length){a.addRect(i,0,this._seriesSize,this.getContentLength());var o=new t.Matrix(1,0,0,1,i,0)}else a.addRect(n*(this._seriesSize+i),0,this._seriesSize,this.getContentLength()),o=new t.Matrix(1,0,0,1,n*(this._seriesSize+i),0);var l=this._seriesSize,h=this.getContentLength()}else a.addRect(0,s*(this._seriesSize+i),this.getContentLength(),this._seriesSize),o=new t.Matrix(1,0,0,1,0,s*(this._seriesSize+i)),l=this.getContentLength(),h=this._seriesSize;r.setClipPath(a),r.setMatrix(o),r.render(null,l,h)}}},O.prototype._handleResize=function(e,t){if(this.Width=e,this.Height=t,this.applyStyleValues(),this._fetchStartPos=0,this._isVertical?this._fetchEndPos=t:this._fetchEndPos=e,this.prepareViewportLength(),f._renderBackground(this),this.hasValidOptions()){if(this.renderTimeZoomCanvas(this._canvas),this.applyAxisStyleValues(),this.updateSeries(),f._renderAxis(this,this._timeZoomCanvas),f._renderSeriesLabels(this),f._renderZoomControls(this),this._hasOverview&&(f._renderOverview(this),this.SelectionHandler)){var i=this.SelectionHandler.getSelectedIds();if(i&&0!==i.length)for(var s=0;s<i.length;s++)this._overview.selSelectItem(i[s])}(this.isTimeDirScrollbarOn()||this.isContentDirScrollbarOn())&&f._renderScrollbars(this)}else f._renderEmptyText(this);this.Animation||this.RenderComplete()},O.prototype.HandleKeyDown=function(e){t.KeyboardEvent.RIGHT_ARROW!==e.keyCode&&t.KeyboardEvent.LEFT_ARROW!==e.keyCode&&t.KeyboardEvent.DOWN_ARROW!==e.keyCode&&t.KeyboardEvent.UP_ARROW!==e.keyCode||this.updateScrollForItemNavigation(this.EventManager.getFocus())},O.prototype.HandleMouseDown=function(e){this._dragPanSeries=this._findSeries(e.target)},O.prototype.endDragPan=function(){this._dragPanSeries=null,this.endPan()},O.prototype.endPan=function(){this._triggerViewportChange&&(this._triggerViewportChange=!1,this.dispatchEvent(this.createViewportChangeEvent()))},O.prototype.panBy=function(e,t){var i,s=this._series.length,r=this.getTimeAxisVisibleSize(s);if(this._isVertical){if(this._dragPanSeries){var a=this._dragPanSeries.getTranslateX()-e;if(this._series.length>1&&(!this.isRTL()&&this._dragPanSeries._isInverted||this.isRTL()&&!this._dragPanSeries._isInverted))var n=r+2*this._dragPanSeries.Width-this._dragPanSeries._maxOverflowValue,o=this._dragPanSeries.Width+r;else this.isRTL()&&!this._dragPanSeries._isInverted?(n=this._dragPanSeries.Width-this._dragPanSeries._maxOverflowValue+r,o=r):(n=0,o=this._dragPanSeries._maxOverflowValue-this._dragPanSeries.Width);a<n?a=n:a>o&&(a=o),this._dragPanSeries.setTranslateX(a),this.isContentDirScrollbarOn()&&(this._series[0]===this._dragPanSeries?this.isRTL()?(i=2===s?this.getTimeAxisVisibleSize()+this._seriesSize-a:this.getTimeAxisVisibleSize()-a,this.contentDirScrollbar[0].setViewportRange(i,i+this._seriesSize)):this.contentDirScrollbar[0].setViewportRange(a,a+this._seriesSize):this.isRTL()?this.contentDirScrollbar[1].setViewportRange(a,a+this._seriesSize):(i=this.getTimeAxisVisibleSize()+this._seriesSize-a,this.contentDirScrollbar[1].setViewportRange(i,i+this._seriesSize)))}this.panZoomCanvasBy(t),this._hasOverview&&this._overview.setViewportRange(null,null,this._viewStartTime,this._viewEndTime),this.isTimeDirScrollbarOn()&&this.timeDirScrollbar.setViewportRange(this._viewStartTime,this._viewEndTime),f._renderAxis(this,this._timeZoomCanvas,!0)}else if(this.panZoomCanvasBy(e),this._hasOverview&&this._overview.setViewportRange(this._viewStartTime,this._viewEndTime,null,null),this.isTimeDirScrollbarOn()&&this.timeDirScrollbar.setViewportRange(this._viewStartTime,this._viewEndTime),f._renderAxis(this,this._timeZoomCanvas,!0),this._dragPanSeries){var l=this._dragPanSeries.getTranslateY()-t;if(this._dragPanSeries._isInverted)var h=r+2*this._dragPanSeries.Height-this._dragPanSeries._maxOverflowValue,_=this._dragPanSeries.Height+r;else h=0,_=this._dragPanSeries._maxOverflowValue-this._dragPanSeries.Height;l<h?l=h:l>_&&(l=_),this._dragPanSeries.setTranslateY(l),this.isContentDirScrollbarOn()&&(this._series[0]===this._dragPanSeries?this.contentDirScrollbar[0].setViewportRange(l,l+this._seriesSize):(i=this.getTimeAxisVisibleSize()+this._seriesSize-l,this.contentDirScrollbar[1].setViewportRange(i,i+this._seriesSize)))}},O.prototype.HandleEvent=function(e,i){var s,r,a,n,o,l,h,_,c,u=e.type;if("dvtSimpleScrollbar"===u)e=this.processScrollbarEvent(e,i);else if("selection"===u)this.dispatchEvent(e);else if("overview"===u){if("rangeChanging"===(n=e.subtype)||"rangeChange"===n){var g=this._viewEndTime-this._viewStartTime;this._isVertical?(this._viewStartTime=e.newY1,this._viewEndTime=e.newY2):(this._viewStartTime=e.newX1,this._viewEndTime=e.newX2);var d=this._viewEndTime-this._viewStartTime;if(d>0){a=this._canvasLength/d,this.setContentLength(a*(this._end-this._start)),this.setRelativeStartPos(a*(this._start-this._viewStartTime));var m=this._timeAxis.getZoomLevelLengths();if(g>d){for(r=m[(s=m.length)-1];this.getContentLength()>=r&&s>0;)r=m[--s-1];s===m.length&&s--,this._timeAxis.setZoomLevelOrder(s),this._timeAxis.setScale(this._timeAxis.getZoomOrder()[s])}else{for(r=m[s=0];this.getContentLength()<r&&s<m.length-1;)r=m[++s];this._timeAxis.setZoomLevelOrder(s),this._timeAxis.setScale(this._timeAxis.getZoomOrder()[s])}this.applyAxisStyleValues(),f._renderAxis(this,this._timeZoomCanvas,!0),this.updateSeries(),this.applyTimeZoomCanvasPosition()}"rangeChange"===n&&this.dispatchEvent(this.createViewportChangeEvent())}"scrollPos"!==n&&"scrollTime"!==n||(this._isVertical?(this._viewStartTime=e.newY1,this._viewEndTime=e.newY2):(this._viewStartTime=e.newX1,this._viewEndTime=e.newX2),a=this.getContentLength()/(this._end-this._start),this.setRelativeStartPos(a*(this._start-this._viewStartTime)),this.applyTimeZoomCanvasPosition(),f._renderAxis(this,this._timeZoomCanvas,!0),this.dispatchEvent(this.createViewportChangeEvent()))}else if("timeline"===u)if("selection"===(n=e.subtype)){var S=e.itemId,p=e.isMultiSelect&&"multiple"===this._selectionMode;for(o=0;o<this._series.length;o++)for(h=this._series[o],l=0;l<h._items.length;l++)if(_=h._items[l],t.Obj.compareValues(this.getCtx(),_.getId(),S)){this.EventManager.setFocusObj(_),this.updateScrollForItemSelection(_),this.SelectionHandler._addToSelection(_,p)&&this.EventManager.fireSelectionEvent(_);break}}else if("highlight"===n){for(c=e.itemId,o=0;o<this._series.length;o++)for(h=this._series[o],l=0;l<h._items.length;l++)if(_=h._items[l],t.Obj.compareValues(this.getCtx(),_.getId(),c)){_.showHoverEffect(!0);break}}else if("unhighlight"===n)for(c=e.itemId,o=0;o<this._series.length;o++)for(h=this._series[o],l=0;l<h._items.length;l++)if(_=h._items[l],t.Obj.compareValues(this.getCtx(),_.getId(),c)){_.hideHoverEffect(!0);break}},O.prototype.processScrollbarEvent=function(e,t){O.superclass.processScrollbarEvent.call(this,e,t),t===this.timeDirScrollbar&&f._renderAxis(this,this._timeZoomCanvas,!0);var i=e.newMin;t===this.contentDirScrollbar[0]?this.isVertical()?2===this._series.length?this._series[0].setTranslateX(this.isRTL()?this.getTimeAxisVisibleSize()+this._seriesSize-i:i):this._series[0].setTranslateX(this.isRTL()?this.getTimeAxisVisibleSize()-i:i):this._series[0].setTranslateY(i):t===this.contentDirScrollbar[1]&&(this.isVertical()?this._series[1].setTranslateX(this.isRTL()?i:this.getTimeAxisVisibleSize()+this._seriesSize-i):this._series[1].setTranslateY(this.getTimeAxisVisibleSize()+this._seriesSize-i))},O.prototype.updateScrollForItemSelection=function(e){var t=this._viewEndTime-this._viewStartTime;this._viewStartTime=e.getStartTime()-t/2,this._viewStartTime<this._start?this._viewStartTime=this._start:this._viewStartTime+t>this._end&&(this._viewStartTime=this._end-t),this._viewEndTime=this._viewStartTime+t;var i=this.getContentLength()/(this._end-this._start);this.setRelativeStartPos(i*(this._start-this._viewStartTime)),this.applyTimeZoomCanvasPosition(),f._renderAxis(this,this._timeZoomCanvas),this.dispatchEvent(this.createViewportChangeEvent())},O.prototype.updateScrollForItemNavigation=function(e){var t=this._isVertical?e.getHeight():e.getWidth(),i=p.getItemHoverStrokeWidth(),s=e.getLoc()-(this._isVertical?t/2+i:p.getBubbleOffset()+i),r=this.getRelativeStartPos();this.isRTL()&&!this._isVertical&&(s-=i);var a=s+t+2*i,n=r-this._canvasLength;-s>r?r=-s:-a<n&&(r=-a+this._canvasLength);var o=this.getContentLength()/(this._end-this._start),l=this._viewEndTime-this._viewStartTime;this._viewStartTime=this._start-r/o,this._viewStartTime<this._start&&(this._viewStartTime=this._start,r=(this._start-this._viewStartTime)*o),this._viewEndTime=this._viewStartTime+l,this._viewEndTime>this._end&&(this._viewEndTime=this._end,this._viewStartTime=this._viewEndTime-l,r=(this._start-this._viewStartTime)*o),this.setRelativeStartPos(r),this.applyTimeZoomCanvasPosition(),this._hasOverview&&(this._isVertical?this._overview.setViewportRange(null,null,this._viewStartTime,this._viewEndTime):this._overview.setViewportRange(this._viewStartTime,this._viewEndTime,null,null)),this.isTimeDirScrollbarOn()&&this.timeDirScrollbar.setViewportRange(this._viewStartTime,this._viewEndTime),f._renderAxis(this,this._timeZoomCanvas),this.dispatchEvent(this.createViewportChangeEvent())},O.prototype.applyInitialSelections=function(){if(this.Options.selection)for(var e=[],t=0;t<this._series.length;t++)for(var i=this._series[t],s=0;s<i._items.length;s++)e.push(i._items[s]);this.SelectionHandler.processInitialSelections(this.Options.selection,e)},O.prototype._findSeries=function(e){if(this.hasValidOptions()&&e&&e!==this){var t=e.getId();return e===this._series[0]||this._series.length>1&&e===this._series[1]?e:t&&"_s0"===t.substring(t.length-3,t.length)?this._series[0]:t&&"_s1"===t.substring(t.length-3,t.length)?this._series[1]:this._findSeries(e.getParent())}return null},O.prototype._findDrawable=function(e){if(e){var t=e.getId();if(t&&"_duration_"===t.substring(0,10)&&e._node)return e;var i=e.getParent();if(i){if(t&&"zoom"===t.substring(0,4))return e;if(t&&"_bubble_"===t.substring(0,8)&&i._node)return i;var s=i.getParent();if(s){if(t&&"_bubble_"===t.substring(0,8)&&s._node)return s;if((t=s.getId())&&"_bubble_"===t.substring(0,8)&&s.getParent())return s.getParent()}}}return null},O.prototype.getAutomation=function(){return this.Automation||(this.Automation=new l(this)),this.Automation},O.prototype.clearComponent=function(){O.superclass.clearComponent.call(this),this.clearOverview()},O.prototype.clearOverview=function(){this._overviewCanvas&&(this.removeChild(this._overviewCanvas),this._overviewCanvas=null)},O.prototype.isTimeDirScrollbarOn=function(){return!this._hasOverview},O.prototype.isContentDirScrollbarOn=function(){return!0},O.prototype.getBackgroundXOffset=function(){return this._backgroundX},O.prototype.setBackgroundXOffset=function(e){this._backgroundX=e},e.Timeline=O,e.TimelineOverview=S,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojtimeline-toolkit.js.map