/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["require","ojs/ojcore-base","jquery","ojs/ojcontext","ojs/ojthemeutils","ojs/ojcomponentcore","ojs/ojanimation","ojs/ojdomutils","ojs/ojlogger","ojs/ojconfig","ojs/ojkeyset","ojs/ojselector","ojdnd","ojs/ojcustomelement-utils","ojs/ojdatacollection-common","ojs/ojtranslation"],function(e,t,n,s,i,a,r,o,l,d,h,c,_,u,E,p){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,n=n&&Object.prototype.hasOwnProperty.call(n,"default")?n.default:n,s=s&&Object.prototype.hasOwnProperty.call(s,"default")?s.default:s;class f{constructor(e,t={keyAttributes:"id",childrenAttribute:"children"},n=(e=>new Map(e)),s=(e=>new Set(e))){this.data=e,this.createOptimizedKeyMap=n,this.createOptimizedKeySet=s,this.keyAttr=t.keyAttributes,this.childrenAttr=t.childrenAttribute;const i=(e,t,n)=>{e.forEach(e=>{n.add(e[this.keyAttr]),e[this.childrenAttr]&&e[this.childrenAttr].length>0&&(t.set(e[this.keyAttr],e),i(e[this.childrenAttr],t,n))})};this.parentKeyNodeMap=this.createOptimizedKeyMap(),this.allKeys=this.createOptimizedKeySet(),i(this.data,this.parentKeyNodeMap,this.allKeys)}computeSelection(e,t=new h.KeySetImpl){const n=this.normalizeKeySet(e),s=this.normalizeKeySet(t),i=n.delete(s.values()),a=s.delete(n.values()),r=this.reduceToLeaves(a.values()),o={selectedLeaves:this.createOptimizedKeySet(new Set([...[...n.values()].filter(e=>!this.parentKeyNodeMap.has(e)),...this.reduceToLeaves(i.values())].filter(e=>!r.has(e)))),selectedParents:this.createOptimizedKeySet(),partialParents:this.createOptimizedKeySet()};return this.assignParentSelection({children:this.data},{selected:0,partial:0},o),o.selected=this.createOptimizedKeySet([...o.selectedLeaves.values(),...o.selectedParents.values()]),{selected:new h.KeySetImpl(o.selected),selectedLeaves:new h.KeySetImpl(o.selectedLeaves),selectedParents:new h.KeySetImpl(o.selectedParents),partialParents:new h.KeySetImpl(o.partialParents)}}reduceToLeaves(e){const t=(e,n)=>{this.parentKeyNodeMap.has(e[this.keyAttr])?e[this.childrenAttr].forEach(e=>t(e,n)):n.add(e[this.keyAttr])},n=this.createOptimizedKeySet();return e.forEach(e=>this.parentKeyNodeMap.has(e)?t(this.parentKeyNodeMap.get(e),n):n.add(e),this),n}assignParentSelection(e,t,n){if(void 0!==e[this.keyAttr]&&!this.parentKeyNodeMap.has(e[this.keyAttr]))n.selectedLeaves.has(e[this.keyAttr])&&(t.selected+=1);else{const s={selected:0,partial:0};if(e[this.childrenAttr].forEach(e=>this.assignParentSelection(e,s,n)),void 0===e[this.keyAttr]||s.selected+s.partial===0)return;s.selected===e[this.childrenAttr].length?(n.selectedParents.add(e[this.keyAttr]),t.selected+=1):(n.partialParents.add(e[this.keyAttr]),t.partial+=1)}}normalizeKeySet(e){return e.isAddAll()?new h.KeySetImpl(this.allKeys).delete(e.deletedValues()):e}}t.__registerWidget("oj.ojTreeView",n.oj.baseComponent,{version:"1.0.0",defaultElement:"<div>",widgetEventPrefix:"oj",options:{currentItem:null,data:null,dnd:{drag:null,drop:null},expanded:new h.KeySetImpl,item:{focusable:null,renderer:null,selectable:null},scrollPolicyOptions:{maxCount:500},selected:new h.KeySetImpl,selection:[],selectionMode:"none",animateEnd:null,animateStart:null,beforeCollapse:null,beforeCurrentItem:null,beforeExpand:null,collapse:null,expand:null},classNames:{depth0:"oj-treeview-depth-0",depth1:"oj-treeview-depth-1",depth2:"oj-treeview-depth-2",depth3:"oj-treeview-depth-3",depth4:"oj-treeview-depth-4",depth5:"oj-treeview-depth-5",depth6:"oj-treeview-depth-6",depth7:"oj-treeview-depth-7",depth8:"oj-treeview-depth-8",depth9:"oj-treeview-depth-9",depth10:"oj-treeview-depth-10",depth11:"oj-treeview-depth-11",depth12:"oj-treeview-depth-12",depth13:"oj-treeview-depth-13",depth14:"oj-treeview-depth-14",depth15:"oj-treeview-depth-15"},constants:{MAX_STYLE_DEPTH:15,PERIOD:".",OJ_COMPLETE:"oj-complete",OJ_TREEVIEW_LIST:"oj-treeview-list",ERROR_FETCHING_DATA:"Error fetching data: ",OJ_ITEM_DATA:"oj-item-data",OJ_ITEM_METADATA:"oj-item-metadata",OJ_TREEVIEW_ITEM_CONTENT:"oj-treeview-item-content",OJ_TREEVIEW_SELECTOR:"oj-treeview-selector",OJ_COMPONENT_ICON:"oj-component-icon",OJ_DRAGGABLE:"oj-draggable",OJ_TREEVIEW_SPACER:"oj-treeview-spacer",OJ_TREEVIEW_LEAF:"oj-treeview-leaf",OJ_TREEVIEW_DISCLOSURE_ICON:"oj-treeview-disclosure-icon",OJ_DEFAULT:"oj-default",OJ_EXPANDED:"oj-expanded",OJ_TREEVIEW_SKELETON_CONTAINER:"oj-treeview-skeleton-container",OJ_COLLAPSED:"oj-collapsed",OJ_TREEVIEW_ANIMATED:"oj-treeview-animated",OJ_SELECTED:"oj-selected",OJ_TREEVIEW_DRAG_SOURCE:"oj-treeview-drag-source",OJ_TREEVIEW_SKELETON_CONTENT:"oj-treeview-skeleton-content",OJ_ANIMATION_SKELETON:"oj-animation-skeleton",OJ_TREEVIEW_ITEM:"oj-treeview-item",OJ_HOVER:"oj-hover",OJ_CLICKABLE_ICON_NOCONTEXT:"oj-clickable-icon-nocontext",OJ_TREEVIEW_DROPLINE:"oj-treeview-drop-line",OJ_TREEVIEW_SELECT_SINGLE:"oj-treeview-select-single",OJ_TREEVIEW_ICON:"oj-treeview-icon",OJ_TREEVIEW_DRAG_IMAGE:"oj-treeview-drag-image",OJ_TREEVIEW_DRAG_IMAGE_ITEM:"oj-treeview-drag-image-item",OJ_FOCUS:"oj-focus",OJ_TREEVIEW_DROP_ZONE:"oj-treeview-drop-zone",OJ_FOCUS_HIGHLIGHT:"oj-focus-highlight",OJ_ANIMATION_SKELETON_FADE_IN:"oj-animation-skeleton-fade-in",OJ_TREEVIEW_SKELETON_CHILD:"oj-treeview-skeleton-child",OJ_TREEVIEW_SKELETON_CARROT:"oj-treeview-skeleton-carrot",OJ_TREEVIEW_SKELETON_ITEM:"oj-treeview-skeleton-item",OJ_TREEVIEW_SKELETON_LEAF:"oj-treeview-skeleton-leaf",OJ_TREEVIEW_ITEM_ICON:"oj-treeview-item-icon",OJ_TREEVIEW_CSS_VARS:{expandAnimation:"--oj-private-tree-view-global-expand-animation",collapseAnimation:"--oj-private-tree-view-global-collapse-animation",dataFadeInDuration:"--oj-private-tree-view-global-data-fadein-duration",multipleSelectionAffordance:"--oj-private-tree-view-global-selection-affordance-default",loadIndicator:"--oj-private-tree-view-global-load-indicator-default",showIndicatorDelay:"--oj-private-core-global-loading-indicator-delay-duration"}},_ComponentCreate:function(){this._super()},_AfterCreate:function(){this._super(),this._initRender(),this._render()},_CompareOptionValues:function(e,n,s){switch(e){case"selection":return n&&void 0===n.inverted&&(n.inverted=!1),s&&void 0===s.inverted&&(s.inverted=!1),(!n||!s||n.inverted===s.inverted)&&t.Object.compareValues(n,s);case"selected":return E.areKeySetsEqual(n,s);default:return this._super(e,n,s)}},_initRender:function(){var e=this;this._on(this.element,{click:function(t){e._handleClick(t)},mouseover:function(t){e._handleMouseOver(t)},mouseout:function(t){e._handleMouseOut(t)},mousedown:function(t){e._handleMouseDown(t)},mouseup:function(t){e._handleMouseUp(t)},keydown:function(t){e._handleKeyDown(t)},dragstart:function(t){e._handleDragStart(t)},drag:function(t){e._handleDragSourceEvent(t,"drag")},dragend:function(t){e._handleDragSourceEvent(t,"dragEnd")},dragenter:function(t){e._handleDropTargetEvent(t,"dragEnter")},dragover:function(t){e._handleDropTargetEvent(t,"dragOver")},dragleave:function(t){e._handleDropTargetEvent(t,"dragLeave")},drop:function(t){e._handleDropTargetEvent(t,"drop")}}),o.isTouchSupported()&&(this.element[0].addEventListener("touchstart",function(t){e.touchStartEvent=t},{passive:!0}),this.element[0].addEventListener("touchmove",function(t){!0===e.ojTreeViewDragEvent&&t.preventDefault()},{passive:!1}),this.element[0].addEventListener("touchcancel",function(){e.touchStartEvent=null,e.ojTreeViewDragEvent=!1}),this.element[0].addEventListener("touchend",function(t){e.touchStartEvent&&t.changedTouches.length&&document.elementFromPoint(t.changedTouches[0].clientX,t.changedTouches[0].clientY)!==e.touchStartEvent.target&&(e.touchStartEvent=null),e.ojTreeViewDragEvent=!1,e._handleMouseOut(t)})),this._dropLine=document.createElement("div"),this._dropLine.classList.add(this.constants.OJ_TREEVIEW_DROPLINE),this.element[0].appendChild(this._dropLine),this._dropLine.style.display="none",this._refreshId=0,this._uiExpanded=new h.KeySetImpl,this.m_fetching=new Set,this._expandedChildrenMap=new Map,this._syncSelectionState()},_syncSelectionState:function(){var e=h.KeySetUtils.toArray(this.options.selected),t=h.KeySetUtils.toKeySet(this.options.selection);e.length>0||e.inverted?this._userOptionChange("selection",e,null):(this.options.selection.length>0||this.options.selection.inverted)&&this._userOptionChange("selected",t,null)},_render:function(){var e=this;this.element[0].classList.remove(this.constants.OJ_COMPLETE),this._keyList=new Set;var t,n=this.element[0].querySelectorAll("ul");if(this.options.data){for(t=0;t<n.length;t++)n[t].parentNode.removeChild(n[t]);this._fetchChildren(null,function(t){var n=t.values[0];e._truncateIfOverMaxCount(n.value);var s={fetchListResult:n.value,parentElem:e.element[0]};e._renderItems(s).then(function(){e._resetFocus(),e.element[0].classList.add(e.constants.OJ_COMPLETE),e._decorateTree(),e._lastSelectedItem=null})})}else{for(t=0;t<n.length;t++)n[t].classList.add(this.constants.OJ_TREEVIEW_LIST),n[t].setAttribute("role","group");var s=this.element[0].querySelectorAll("li");for(t=0;t<s.length;t++){var i=this._getItemContent(s[t]);if(i){var a=this._getItemDisclosureIcon(i);a&&i.removeChild(a)}e._decorateItem(s[t])}this._resetFocus(),this.element[0].classList.add(this.constants.OJ_COMPLETE),this._decorateTree(),this._lastSelectedItem=null}},_getDataProvider:function(){var n;if(null==this.m_dataSource){if(n=this.options.data,!t.DataProviderFeatureChecker.isTreeDataProvider(n)){var s=new Promise(function(t,n){e(["ojs/ojtreedataprovideradapter"],function(e){t(function(e){if(e&&e.__esModule)return e;var t={};return e&&Object.keys(e).forEach(function(n){var s=Object.getOwnPropertyDescriptor(e,n);Object.defineProperty(t,n,s.get?s:{enumerable:!0,get:function(){return e[n]}})}),t.default=e,t}(e))},n)});if(!s)throw new Error("Error adapting a TreeDataSource");return s.then(e=>new e.default(n))}}else n=this.m_dataSource;return Promise.resolve(n)},_fetchChildren:function(e,t){var n=this,s=n._addBusyState("getting data provider",e),i=n._getDataProvider(),a=this._refreshId;i.then(function(i){if(s(),n._refreshId===a){n.m_dataSource=i;var r=null===e?i:i.getChildDataProvider(e);if(null!=r){var o=n._addBusyState("fetching data",e),d=n._getShowStatusDelay();n._isSkeletonSupported()&&(n._skeletonTimeout=setTimeout(function(){var t=n._expandedChildrenMap.get(null);if(null===e)n._renderInitialSkeletons();else if(!t&&!n._isParentSkeletonRendered(e)&&!n._isLeafOnlySelectionEnabled()){var s=n._getItemByKey(e);n._getSubtree(s)||n._renderChildSkeletons(e)}},d));var h=n._loadTemplateEngine();n._clientId=n._clientId||Symbol();var c={clientId:n._clientId,size:-1},_=r.fetchFirst(c)[Symbol.asyncIterator](),u=_.next(),E=function(t){if(t[0].done){if(n._clearSkeletonTimeout(),n._isLeafOnlySelectionEnabled()&&n._buildRawData(e,t[0]),n._isSkeletonSupported()){for(var s=[],i=t[0].value.data,r=0;r<i.length;r++){var d=t[0].value.metadata[r].key;n._isInitExpanded(d)&&n.m_dataSource.getChildDataProvider(d)&&s.push(d)}n._expandedChildrenMap.set(e,s);var h=n._expandedChildrenMap.get(e);if(h){var c=h.indexOf(e);c>-1&&h.splice(c,1)}if(!h||0===h.length)return{values:t,shouldRemoveSkeleton:!0}}return{values:t,shouldRemoveSkeleton:!1}}return _.next().then(function(e){return n._refreshId!==a?null:(t[0].done=e.done,t[0].value.data=t[0].value.data.concat(e.value.data),t[0].value.metadata=t[0].value.metadata.concat(e.value.metadata),E(t))},function(e){l.error(n.constants.ERROR_FETCHING_DATA+e),o()})};Promise.all([u,h]).then(function(e){return n._refreshId!==a?null:E(e)},function(e){return Promise.reject(e)}).then(function(e){n._refreshId===a?(t(e),o()):o()},function(e){l.error(n.constants.ERROR_FETCHING_DATA+e);var t=n._getSkeletonContainer(n.element[0]);n._isSkeletonSupported()&&t&&n._removeSkeleton(null),o()})}}},function(e){l.error(n.constants.ERROR_FETCHING_DATA+e),s(),n._expandedChildrenMap=new Map,n.m_fetching=new Set})},_clearSkeletonTimeout:function(){this._skeletonTimeout&&(clearTimeout(this._skeletonTimeout),this._skeletonTimeout=null)},_buildRawData:function(e,t){null===e?this._rawData=t.value.metadata:this._findParentAndAddChildren(this._rawData,t.value.metadata,e)},_findParentAndAddChildren:function(e,t,n){for(var s=0;s<e.length;s++){if(e[s].key===n)return void(e[s].children=t);e[s].children&&this._findParentAndAddChildren(e[s].children,t,n)}},_isParentSkeletonRendered:function(e){for(var t=this._getItemByKey(e),n=this._getParents(t,this.constants.PERIOD+this.constants.OJ_TREEVIEW_ITEM),s=0;s<n.length;s++){var i=this._getKey(n[s]);if(this._expandedChildrenMap.get(i))return!0}return!1},_getShowStatusDelay:function(){var e=this._getOptionDefaults(),t=parseInt(e.showIndicatorDelay,10);return isNaN(t)?0:t},_renderItems:function(e){return new Promise(function(t){var n=document.createElement("ul");n.classList.add(this.constants.OJ_TREEVIEW_LIST),n.setAttribute("role","group");var s=this._getSkeletonContainer(this.element[0]);(s&&this._isSkeletonSupported()||this._isLeafOnlySelectionEnabled())&&(n.style.display="none"),e.parentElem.appendChild(n);for(var i=0;i<e.fetchListResult.data.length;i++)this._renderItem(n,e.fetchListResult,i);s&&this._isSkeletonSupported()&&!this._isLeafOnlySelectionEnabled()?this._toggleParentDisplay(e.parentElem,t):t()}.bind(this))},_getScrollPolicyOptions:function(){return this.options.scrollPolicyOptions},_validateScrollPolicyOptions:function(e){var t=this._getScrollPolicyOptions(),n=this._getTreeViewItemCount()+e;return t.maxCount<n&&l.error("ScrollPolicyOptions max count of ["+t.maxCount+"] has been reached."),n-t.maxCount},_truncateIfOverMaxCount:function(e){var t=e.data.length,n=this._validateScrollPolicyOptions(t);n===t?(e.data=[],e.metadata=[]):n>0&&(e.data.splice(-n,t),e.metadata.splice(-n,t))},_toggleParentDisplay:function(e,t){var n=this._getKey(e);e===this.element[0]&&(n=null);var s=this._expandedChildrenMap.get(n);if(s&&s.length>0)t();else{let e=null;for(e of this._expandedChildrenMap.keys()){var i,a,r=this._expandedChildrenMap.get(e);null===e?(i=this.element[0],a=this._getRoot()):(i=this._getItemByKey(e),a=this._getSubtree(i),this._setItemExpanded(i)),a&&0===r.length&&this._resolveNoChildren(e,i,a,t);for(var o=r.length-1;o>=0;o--)r[o]===n&&a&&(r.splice(o,1),0===r.length&&this._resolveNoChildren(e,i,a,t))}t()}},_resolveNoChildren:function(e,t,n,s){this._expandedChildrenMap.delete(e),this._getSkeletonContainer(t)&&!this._isLeafOnlySelectionEnabled()?this._foundSkeleton(e,n,s):this._isLeafOnlySelectionEnabled()||(n&&(n.style.display="block"),this._toggleParentDisplay(t,s))},_foundSkeleton:function(e,t,n){this._removeSkeleton(e).then(function(){t&&(t.style.display="block");var e=this._getOptionDefaults();r.fadeIn(t,{duration:e.dataFadeInDuration}),n()}.bind(this))},_renderItem:function(e,t,s,i,r){var o,l,d=t.data[s],h=t.metadata[s],c=h.key;if(!r){if(this._keyList.has(c))throw new Error("JET TreeView nodes should not have duplicated keys: "+c);this._keyList.add(c)}var _=document.createElement("li");if(r){var u=this._getItemByKey(c);if(!u)return;e=u.parentNode;var E=this._getSubtree(u);u.parentNode.replaceChild(_,u)}else null==i||i>=e.children.length?e.appendChild(_):e.insertBefore(_,e.children[i]);var p={parentElement:n(_),index:s,data:d,datasource:this.options.data,parentKey:this._getKey(this._getParentItem(_)),metadata:h,component:a.__GetWidgetConstructor(this.element)};this._FixRendererContext&&(p=this._FixRendererContext(p));var f=this.m_dataSource.getChildDataProvider(c);h.leaf=null===f,h.depth=this._getDepth(_);var m=Object.keys(h);for(o=0;o<m.length;o++){var v=m[o];p[v]=h[v]}var g=this.options.item.renderer;g=this._WrapCustomElementRenderer(g);var I=this._getItemTemplate(),y=this._getTemplateEngine();if(null!=g){var S=g.call(this,p);null!=S&&(null===S.parentNode||S.parentNode instanceof DocumentFragment?_.appendChild(S):null!=S.parentNode||S.toString&&((l=document.createElement("span")).appendChild(document.createTextNode(S.toString())),_.appendChild(l)))}else if(null!=I&&null!=y){var O=this.element[0],T=y.execute(O,I,p,null);for(o=0;o<T.length;o++){if("LI"===T[o].tagName){_.parentNode.replaceChild(T[o],_);break}_.appendChild(T[o])}}else(l=document.createElement("span")).appendChild(document.createTextNode(null==d?"":d.toString())),_.appendChild(l);r&&E&&_.appendChild(E),_=e.children[null!=i?i:s],p.parentElement=n(_),_.hasAttribute("id")||_.setAttribute("id",this._getUniqueItemId()),_[this.constants.OJ_ITEM_DATA]=d,_[this.constants.OJ_ITEM_METADATA]=h,this._decorateItem(_)},_getDepth:function(e){for(var t=0,n=e;n&&n!==this.element[0];)n=n.parentElement.parentElement,t+=1;return t},_loadTemplateEngine:function(){var e=this;return null!=this._getItemTemplate()&&null==e.options.item.renderer?new Promise(function(t){d.__getTemplateEngine().then(function(n){e.m_engine=n,t(n)},function(e){throw new Error("Error loading template engine: "+e)})}):Promise.resolve(null)},_getTemplateEngine:function(){return this.m_engine},_getItemTemplate:function(){if(void 0===this.m_template){this.m_template=null;var e=this._getSlotMap().itemTemplate;e&&e.length>0&&"template"===e[0].tagName.toLowerCase()&&(this.m_template=e[0])}return this.m_template},_getSlotMap:function(){return u.CustomElementUtils.getSlotMap(this.element[0])},_decorateTree:function(){var e=this,t=this._getRoot();if(t){this._focusable({element:n(t),applyHighlight:!0,setupHandlers:function(t,n){e._focusInHandler=t,e._focusOutHandler=n}}),t.setAttribute("tabIndex",0),n(t).on("focus",function(){e._focusInHandler(n(e._getItemContent(e._currentItem)))}).on("blur",function(){e._focusOutHandler(n(e._getItemContent(e._currentItem)))}),t.setAttribute("role","tree"),t.setAttribute("aria-labelledby",this.element[0].getAttribute("id"));var s=this.options.selectionMode;"none"!==s?t.setAttribute("aria-multiselectable",this._isMultiSelectionEnabled()||this._isLeafOnlySelectionEnabled()?"true":"false"):t.removeAttribute("aria-multiselectable"),"single"===s&&this.element[0].classList.add(this.constants.OJ_TREEVIEW_SELECT_SINGLE),this.element[0].setAttribute("tabIndex",-1),this.element[0].addEventListener("focus",()=>{this._getRoot().focus()}),this.element[0].addEventListener("blur",()=>{this._getRoot().blur()})}},_isMultiSelectionEnabled:function(){return"multiple"===this.options.selectionMode},_isLeafOnlySelectionEnabled:function(){return"leafOnly"===this.options.selectionMode},_isDefaultCheckBoxesEnabled:function(){return"selector"===this._getOptionDefaults().multipleSelectionAffordance&&(this._isMultiSelectionEnabled()||this._isLeafOnlySelectionEnabled())},_refreshSelectionItems:function(){if("none"!==this.options.selectionMode){var e,t,n=this._getSelected(),s=Array.from(this._getItemsInSelectedKeySet(n));if(n.isAddAll())for(e=0;e<s.length;e++){t=s[e];var i=this._getKey(t);n.has(i)&&this._isActionable(t,"select")?this._setSelected(t):this._setUnselected(t)}else{var a=this._getSelectedItemContents();for(e=a.length-1;e>=0;e--){var r=a[e].parentElement,o=s.indexOf(r);-1!==o?s.splice(o,1):this._setUnselected(r)}for(e=0;e<s.length;e++)t=s[e],this._setSelected(t)}this._isLeafOnlySelectionEnabled()&&this._updateIndeterminateState(this._selectedKeysets.partialParents)}},_getItemsInSelectedKeySet:function(e){var t=[];return e.isAddAll()?this._getItems():(e.values().forEach(e=>{var n=this._getItemByKey(e);n&&this._isActionable(n,"select")&&t.push(n)}),t)},_decorateItem:function(e){var t;e.classList.add(this.constants.OJ_TREEVIEW_ITEM),e.setAttribute("role","treeitem");var n=this._getKey(e),i=this._getItemContent(e);if(!i){if((i=document.createElement("div")).classList.add(this.constants.OJ_TREEVIEW_ITEM_CONTENT),this._isDefaultCheckBoxesEnabled()&&this._isActionable(e,"focus")&&this._isActionable(e,"select")){var a=document.createElement("span");a.classList.add(this.constants.OJ_TREEVIEW_SELECTOR);var r=document.createElement("oj-selector");this._getSelected().has(n)?r.selectedKeys=new h.KeySetImpl([n]):r.selectedKeys=new h.KeySetImpl,r.setAttribute("data-oj-binding-provider","none"),r.setAttribute("selection-mode","multiple"),r.setAttribute("aria-label",p.getTranslatedString("oj-ojTreeView.treeViewSelectorAria",{rowKey:n})),r.addEventListener("selectedKeysChanged",function(e){if("internal"===e.detail.updatedFrom){var t=this._getItemByKey(e.target.rowKey);this._focus(t,e);var n=this._getSelected();n=n.has(e.target.rowKey)?n.delete([e.target.rowKey]):n.add([e.target.rowKey]),this._userSelectedOptionChange(n,e)}}.bind(this)),r.rowKey=n,a.appendChild(r),i.appendChild(a),s.getContext(r).getBusyContext().whenReady().then(()=>{E.disableAllFocusableElements(r)})}if(e.firstChild)do{i.appendChild(e.firstChild)}while(e.childNodes.length>0);e.appendChild(i);var o=i.getElementsByTagName("ul")[0];o&&e.appendChild(o);var l=i.querySelectorAll(this.constants.PERIOD+this.constants.OJ_TREEVIEW_ITEM_ICON);for(t=0;t<l.length;t++)l[t].classList.add(this.constants.OJ_TREEVIEW_ICON),l[t].classList.add(this.constants.OJ_COMPONENT_ICON)}this._select(e),i.setAttribute("draggable",this._isDnD()?"true":"false");var d=this._getItemDisclosureIcon(i);d||(d=document.createElement("ins"),this._addTreeViewIconClass(d),i.insertBefore(d,i.children[0]));var c=this._getItemSpacer(i);c||(c=document.createElement("span"),this._addTreeviewSpacerClass(c),i.insertBefore(c,d)),this._addIndentation(e,c),this._isDnD()&&(e.classList.add(this.constants.OJ_DRAGGABLE),i.classList.add(this.constants.OJ_DRAGGABLE)),this._isLeaf(e)?this._addTreeviewLeafClass(e):(this._isInitExpanded(n)?this._expand(e,!1):this._collapse(e,!1),this._addDisclosureClasses(d))},_addIndentation:function(e,t){var n=this._getDepth(e);this._isLeaf(e)||(n-=1),n<this.constants.MAX_STYLE_DEPTH?this._appendSpacerClass(n,t):(this._appendSpacerClass(1,t),t.style.width=t.offsetWidth*n+"px")},_removeIndentation:function(e){e.style.removeProperty("width"),e.removeAttribute("class"),e.classList.add(this.constants.OJ_TREEVIEW_SPACER)},_appendSpacerClass:function(e,t){t.classList.add(this.classNames["depth"+e])},_addTreeviewSpacerClass:function(e){e.classList.add(this.constants.OJ_TREEVIEW_SPACER)},_addTreeViewIconClass:function(e){e.classList.add(this.constants.OJ_TREEVIEW_ICON)},_addTreeviewLeafClass:function(e){e.classList.add(this.constants.OJ_TREEVIEW_LEAF)},_removeTreeviewLeafClass:function(e){e.classList.remove(this.constants.OJ_TREEVIEW_LEAF)},_addDisclosureClasses:function(e){e.classList.add(this.constants.OJ_TREEVIEW_DISCLOSURE_ICON),e.classList.add(this.constants.OJ_COMPONENT_ICON),e.classList.add(this.constants.OJ_CLICKABLE_ICON_NOCONTEXT),e.classList.add(this.constants.OJ_DEFAULT)},_removeDisclosureClasses:function(e){e.classList.remove(this.constants.OJ_TREEVIEW_DISCLOSURE_ICON),e.classList.remove(this.constants.OJ_COMPONENT_ICON),e.classList.remove(this.constants.OJ_CLICKABLE_ICON_NOCONTEXT),e.classList.remove(this.constants.OJ_DEFAULT)},_getItems:function(){return this.element[0].querySelectorAll(this.constants.PERIOD+this.constants.OJ_TREEVIEW_ITEM)},_getKey:function(e){if(!e)return null;var t=e[this.constants.OJ_ITEM_METADATA];return t?t.key:e.getAttribute("id")},_getItemByKey:function(e){for(var n,s=this.element[0].getElementsByTagName("li"),i=0;i<s.length;i++){var a=s[i][this.constants.OJ_ITEM_METADATA];if(a&&t.Object.compareValues(a.key,e)){n=s[i];break}}if(n)return n;if("string"==typeof e){var r=document.getElementById(e),o=this._getRoot();if(o&&r&&o.contains(r))return r}},_getItemContent:function(e){if(!e)return null;for(var t=e.children,n=0;n<t.length;n++)if(e.children[n].classList&&e.children[n].classList.contains(this.constants.OJ_TREEVIEW_ITEM_CONTENT))return e.children[n];return null},_getChildItems:function(e){var t=[],n=e.getElementsByClassName(this.constants.OJ_TREEVIEW_LIST)[0];if(n)for(var s=n.children,i=0;i<s.length;i++)t.push(s[i]);return t},_getParentItem:function(e){var t=this._getParents(e,".oj-treeview-list")[0];return this._getParents(t,this.constants.PERIOD+this.constants.OJ_TREEVIEW_ITEM)[0]},_getSubtree:function(e){return e.getElementsByClassName(this.constants.OJ_TREEVIEW_LIST)[0]},_getRoot:function(){return this.element[0].getElementsByClassName(this.constants.OJ_TREEVIEW_LIST)[0]},_isLeaf:function(e){if(!e)return null;var t=e[this.constants.OJ_ITEM_METADATA];return!(t?!t.leaf:void 0!==this._getSubtree(e))},_isInitExpanded:function(e,t){var n=null!=t?t:this.options.expanded;return!(!n||!n.has)&&n.has(e)},_isExpanded:function(e){return e.classList.contains(this.constants.OJ_EXPANDED)},_isDisclosing:function(e){return!(!e||!this.m_disclosing)&&this.m_disclosing.indexOf(e)>-1},_setDisclosing:function(e,t){if(null!=e)if(null==this.m_disclosing&&(this.m_disclosing=[]),t)this.m_disclosing.push(e);else for(var n=this.m_disclosing.indexOf(e);n>-1;)this.m_disclosing.splice(n,1),n=this.m_disclosing.indexOf(e)},_expand:function(e,t,n,s){var i=this;if(!(this._isExpanded(e)||this._isLeaf(e)||t&&this._isDisclosing(this._getKey(e)))){if(t&&!this._trigger("beforeExpand",n,this._getEventPayload(e))&&!1!==s)return;this._lastSelectedItem=null;var a=this._getSubtree(e),r=i._getKey(e);if(!a)return this._uiExpanded=this._uiExpanded.add([r]),void this._fetchChildren(r,function(s){if((!i._isExpanded(e)||i._isSkeletonSupported())&&(i._isInitExpanded(r)||i._isInitExpanded(r,i._uiExpanded))){var o=s.values[0];i._truncateIfOverMaxCount(o.value);var l=e.getElementsByClassName(i.constants.OJ_TREEVIEW_SKELETON_CONTAINER).length,d={fetchListResult:o.value,parentElem:e};i._isSkeletonSupported()&&l>0&&s.shouldRemoveSkeleton&&!i._isLeafOnlySelectionEnabled()?i._renderItems(d).then(function(){var t=e.offsetHeight,s=3*t,r=t*o.value.data.length;a=i._getSubtree(e);var l={startMaxHeight:s+"px",endMaxHeight:r+"px"};r>s?i._animateSkeletonRemoval("expand",e,a,l,n):r<s?i._animateSkeletonRemoval("collapse",e,a,l,n):i._animateSkeletonRemoval("fadeIn",e,a,l,n)}):i._isSkeletonSupported()&&l>0?i._renderItems(d).then(function(){i._setExpandedState(i,e,n),i.isReady()&&i._isLeafOnlySelectionEnabled()&&i._initLeafOnlySelectionMode()}):i._renderItems(d).then(function(){i._expandAfterFetch(e,t,n),i.isReady()&&i._isLeafOnlySelectionEnabled()&&i._initLeafOnlySelectionMode()})}});i._expandAfterFetch(e,t,n)}},_initLeafOnlySelectionMode:function(){let e=e=>new Map(e);this.options.data.createOptimizedKeyMap&&(e=e=>this.options.data.createOptimizedKeyMap(e));let t=e=>new Set(e);this.options.data.createOptimizedKeySet&&(t=e=>this.options.data.createOptimizedKeySet(e)),this.treeviewSelectionManager=new f(this._rawData,{keyAttributes:"key",childrenAttribute:"children"},e,t),this._userSelectedOptionChange(this._filterOutParentKeys(this._getSelected()),null,!0);var n=this._getRoot();this._getSkeletonContainer(this.element[0])?this._removeSkeleton(null).then(function(){n&&(n.style.display="block");var e=this._getOptionDefaults();r.fadeIn(n,{duration:e.dataFadeInDuration})}.bind(this)):n&&(n.style.display="block")},_setItemExpanded:function(e){e.classList.remove(this.constants.OJ_COLLAPSED),e.classList.add(this.constants.OJ_EXPANDED),this._setAriaExpanded(e,"true")},_animateSkeletonRemoval:function(e,t,n,s,i){var a=this._getKey(t);this._removeSkeleton(a).then(function(){this._setItemExpanded(t);var o=this,l=this._getOptionDefaults();n.style.display="block",r.fadeIn(n,{duration:l.dataFadeInDuration}).then(function(){var r=this._addBusyState("animating skeleton removal",a);t.classList.add(this.constants.OJ_TREEVIEW_ANIMATED),this._setDisclosing(this._getKey(t),!0),"expand"===e?this._startAnimation(n,"expand",s).then(this._resolveAnimationPromise(o,t,i,r)):"collapse"===e?this._startAnimation(n,"collapse",s).then(this._resolveAnimationPromise(o,t,i,r)):this._resolveAnimationPromise(o,t,i,r)()}.bind(this))}.bind(this))},_expandAfterFetch:function(e,t,n){this._setItemExpanded(e);var s=this._getKey(e),i=this._getSubtree(e);if(i&&(i.style.display="block"),t){var a=this._addBusyState("animating expand",s);e.classList.add(this.constants.OJ_TREEVIEW_ANIMATED),this._setDisclosing(s,!0),this._startAnimation(i,"expand").then(this._resolveAnimationPromise(this,e,n,a))}},_setExpandedState:function(e,t,n){e._setDisclosing(e._getKey(t),!1),t.classList.remove(e.constants.OJ_TREEVIEW_ANIMATED),e._trigger("expand",n,e._getEventPayload(t));var s=e.options.expanded.add([e._getKey(t)]);e._userOptionChange("expanded",s,n)},_resolveAnimationPromise:function(e,t,n,s){return function(){this._setExpandedState(e,t,n),s()}.bind(this)},_collapse:function(e,t,n,s){var i=this,a=this._getKey(e);if(!(e.classList.contains(this.constants.OJ_COLLAPSED)||this._isLeaf(e)||t&&this._isDisclosing(a))){if(e.contains(this._currentItem)){var r=e;this._isActionable(r,"focus")||(r=this._getPreviousActionableItem(e,"focus"))||(r=this._getNextActionableItem(e,"focus")),r?this._focus(r,n):(this.options.currentItem=null,this._resetFocus())}if(t){if(!this._trigger("beforeCollapse",n,this._getEventPayload(e))&&!1!==s)return;this._setDisclosing(a,!0)}e.classList.remove(this.constants.OJ_EXPANDED),e.classList.add(this.constants.OJ_COLLAPSED),this._setAriaExpanded(e,"false"),this._lastSelectedItem=null;var o=this._getSubtree(e);if(t){var l=this._addBusyState("animating collapse",a);e.classList.add(this.constants.OJ_TREEVIEW_ANIMATED),this._uiExpanded=this._uiExpanded.delete([a]),this._startAnimation(o,"collapse").then(function(){i._setDisclosing(a,!1),o.style.display="none",e.classList.remove(i.constants.OJ_TREEVIEW_ANIMATED),i._trigger("collapse",n,i._getEventPayload(e));var t=i.options.expanded.delete([a]);i._userOptionChange("expanded",t,n),l()})}else o&&(o.style.display="none");this._isLeafOnlySelectionEnabled()&&!o&&this._fetchChildren(a,function(t){var n=t.values[0];i._truncateIfOverMaxCount(n.value);var s={fetchListResult:n.value,parentElem:e};i._renderItems(s).then(function(){i.isReady()&&i._isLeafOnlySelectionEnabled()&&i._initLeafOnlySelectionMode()})})}},_startAnimation:function(e,t,n){var s={};null==s[t]&&(s[t]=JSON.parse(this._getOptionDefaults()[t+"Animation"]));var i=s[t];return n&&("expand"!==i.effect&&"collapse"!==i.effect||Object.assign(i,n)),r.startAnimation(e,t,i,this)},_getEventPayload:function(e){return{key:this._getKey(e),item:e}},_isActionable:function(e,t){var n=this.options.item[t+"able"];return!1!==n&&("function"!=typeof n||n(this.getContextByNode(e)))},_isSelected:function(e){var t=this.options.selectionMode,n=this._getSelected();if("none"===t)return!1;var s=this._getKey(e);return n.has(s)},_getSelected:function(){return this._isLeafOnlySelectionEnabled()&&this._selectedKeysets?this._selectedKeysets.selected:this.options.selected},_select:function(e,t){if("none"!==this.options.selectionMode&&this._isActionable(e,"focus")&&this._isActionable(e,"select")){var n=this._isSelected(e);if(t){var s=t.key||t.keyCode,i=t.originalEvent.sourceCapabilities&&t.originalEvent.sourceCapabilities.firesTouchEvents,a=o.isTouchSupported()&&(i||null!=this.touchStartEvent&&this.touchStartEvent.target===t.target),r=o.isMetaKeyPressed(t),l=E.isArrowUpKeyEvent(s)||E.isArrowDownKeyEvent(s),d=this._getKey(e),c=new h.KeySetImpl;if((this._isMultiSelectionEnabled()||this._isLeafOnlySelectionEnabled())&&t.shiftKey&&!l){r?c=this._getSelected():this._clearSelection();for(var _=this._lastSelectedItem,u=_&&_.offsetTop<e.offsetTop?this._getNextActionableItem.bind(this):this._getPreviousActionableItem.bind(this);_&&_!==e;){var p=this._getKey(_);c.has(p)||(c=c.add([p]),this._setSelected(_)),_=u(_,"select")}n=!0,c=c.add([d])}else(this._isMultiSelectionEnabled()||this._isLeafOnlySelectionEnabled())&&(r||a||l)?(n=!n,c=this._getSelected(),c=n?c.add([d]):c.delete([d])):(a||E.isSpaceBarKeyEvent(s))&&n?(n=!1,c=new h.KeySetImpl):(n=!0,c=new h.KeySetImpl([d]));this._userSelectedOptionChange(c,t,!r&&!l&&!a),this._lastSelectedItem=e}n?this._setSelected(e):this._setUnselected(e)}},_getSelectorByItem:function(e){return e.getElementsByTagName("oj-selector")[0]},_updateIndeterminateState:function(e){if(this._isDefaultCheckBoxesEnabled()){var t,n,s=Array.from(this.element[0].getElementsByClassName("oj-indeterminate")),i=Array.from(e.values());for(n=s.length-1;n>=0;n--){var a=(t=s[n].parentElement).rowKey,r=i.indexOf(a);-1!==r?i.splice(r,1):t.indeterminate=!1}for(n=0;n<i.length;n++){var o=this._getItemByKey(i[n]);(t=this._getSelectorByItem(o)).indeterminate=!0}}},_setSelected:function(e){this._getItemContent(e).classList.add(this.constants.OJ_SELECTED),e.setAttribute("aria-selected","true");var t=this._getKey(e);this._setupSelector(t,e,!1)},_setUnselected:function(e){this._getItemContent(e).classList.remove(this.constants.OJ_SELECTED),e.setAttribute("aria-selected","false");var t=this._getKey(e);this._setupSelector(t,e,!0)},_clearSelection:function(){for(var e=this._getSelectedItemContents(),t=e.length-1;t>=0;t--)this._setUnselected(e[t].parentElement)},_setupSelector:function(e,t,n){if(this._isDefaultCheckBoxesEnabled()){var s=this._getSelectorByItem(t),i=n?[]:[e];s&&(s.selectedKeys=new h.KeySetImpl(i))}},_getSelectedItemContents:function(){return this.element[0].querySelectorAll(this.constants.PERIOD+this.constants.OJ_TREEVIEW_ITEM_CONTENT+this.constants.PERIOD+this.constants.OJ_SELECTED)},_focus:function(e,t){if(this._isActionable(e,"focus")){if(t){var s=this._getEventPayload(e);if(this._currentItem&&(s.previousKey=this._getKey(this._currentItem),s.previousItem=this._currentItem),!this._trigger("beforeCurrentItem",t,s))return;this._userOptionChange("currentItem",this._getKey(e),t)}this._focusOutHandler(n(this._getItemContent(this._currentItem))),this._focusInHandler(n(this._getItemContent(e))),this._setCurrentItem(e)}},_resetFocus:function(){if(this.options.currentItem){var e=this._getItemByKey(this.options.currentItem);if(e)return void this._setCurrentItem(e)}var t=this._getItems()[0];this._isActionable(t,"focus")||(t=this._getNextActionableItem(t,"focus")),this._setCurrentItem(t),this._userOptionChange("currentItem",this._getKey(this._currentItem),null)},_setCurrentItem:function(e){this._currentItem=e;var t=this._getRoot();t&&e&&t.setAttribute("aria-activedescendant",this._getItemId(e))},_getItemId:function(e){return e.getAttribute("id")},_getUniqueItemId:function(){return u.ElementUtils.getUniqueId(this.element[0].getAttribute("id")).concat("_"+this._getTreeViewItemCount())},_getTreeViewItemCount:function(){return this._getItems().length},_addBusyState:function(e,t){var n=s.getContext(this.element[0]).getBusyContext(),i=this.element.attr("id"),a=n.addBusyState({description:"The component identified by '"+i+"', "+e});return this.m_fetching.add(t),function(){this.m_fetching.delete(t),a(),Promise.resolve(this._processEventQueue())}.bind(this)},_userOptionChange:function(e,t,n){this.option(e,t,{_context:{originalEvent:n,writeback:!0,internalSet:!0}})},_userSelectedOptionChange:function(e,t,n){let s=e;if(this._isLeafOnlySelectionEnabled()){let e=n?this._getEmptyKeySet(s):this._getSelected();this._selectedKeysets=this.treeviewSelectionManager.computeSelection(s,e),s=this._selectedKeysets.selectedLeaves}this._userOptionChange("selected",s,t),this._userOptionChange("selection",h.KeySetUtils.toArray(s),t),this._refreshSelectionItems()},_getEmptyKeySet:function(e){return e.isAddAll()?new h.AllKeySetImpl:new h.KeySetImpl},_filterOutParentKeys:function(e){if(e.isAddAll()){let t=new h.AllKeySetImpl,n=[...e.deletedValues()].filter(e=>!this.treeviewSelectionManager.parentKeyNodeMap.has(e));return t=t.delete(n),t}return new h.KeySetImpl([...e.values()].filter(e=>!this.treeviewSelectionManager.parentKeyNodeMap.has(e)))},_getDragOptions:function(){return((this.options.dnd||{}).drag||{}).items||{}},_getDropOptions:function(){return((this.options.dnd||{}).drop||{}).items||{}},_getClosestItem:function(e){return this._closest(e,this.constants.PERIOD+this.constants.OJ_TREEVIEW_ITEM)},_getClosestItemContent:function(e){return this._closest(e,".oj-treeview-item-content")},_getClosestDisclosureIcon:function(e){return this._closest(e,".oj-treeview-disclosure-icon")},_handleClick:function(e){if(!E.isFromDefaultSelector(e)){var t,n=this._getClosestDisclosureIcon(e.target);if(n){t=this._getClosestItem(n);var s=this._getKey(t);if(this.m_fetching.has(s))return;return this._isExpanded(t)?this._collapse(t,!0,e):this._expand(t,!0,e),void(this.touchStartEvent=null)}var i=this._getClosestItemContent(e.target);if(i)return t=i.parentNode,this._select(t,e),this._focus(t,e),void(this.touchStartEvent=null);"none"!==this.options.selectionMode&&(this._clearSelection(),this._lastSelectedItem=null,this._userSelectedOptionChange(new h.KeySetImpl,e)),this.touchStartEvent=null}},_isDnD:function(){var e=this._getDragOptions();return Object.keys(e).length>0},_handleMouseOver:function(e){if((!o.isTouchSupported()||!this.touchStartEvent)&&("none"!==this.options.selectionMode||this._isDnD())){var t=this._getClosestDisclosureIcon(e.target);t||(t=this._getClosestItemContent(e.target)),t&&(t.classList.remove(this.constants.OJ_DEFAULT),t.classList.add(this.constants.OJ_HOVER))}},_handleMouseOut:function(e){var t=this._getClosestDisclosureIcon(e.target);t&&t.classList.remove(this.constants.OJ_SELECTED),t||(t=this._getClosestItemContent(e.target)),t&&(t.classList.add(this.constants.OJ_DEFAULT),t.classList.remove(this.constants.OJ_HOVER))},_handleMouseDown:function(e){if(!E.isFromDefaultSelector(e)){var t=this._getClosestDisclosureIcon(e.target);t&&t.classList.add(this.constants.OJ_SELECTED)}},_handleMouseUp:function(e){var t=this._getClosestDisclosureIcon(e.target);t&&t.classList.remove(this.constants.OJ_SELECTED)},_handleKeyDown:function(e){var t,n=this._currentItem,s=e.key||e.keyCode;if(E.isArrowUpKeyEvent(s)||E.isArrowDownKeyEvent(s))(t=E.isArrowDownKeyEvent(s)?this._getNextActionableItem(n,"focus"):this._getPreviousActionableItem(n,"focus"))&&(e.preventDefault(),this._isSelected(n)&&e.shiftKey&&this._select(this._isSelected(t)?n:t,e),this._scrollToVisible(t,s),this._focus(t,e));else if(E.isArrowLeftKeyEvent(s)||E.isArrowRightKeyEvent(s)){var i="rtl"===this._GetReadingDirection(),a=!i&&E.isArrowRightKeyEvent(s)||i&&E.isArrowLeftKeyEvent(s);!a||this._isLeaf(n)||this._isExpanded(n)?a||this._isLeaf(n)||!this._isExpanded(n)?(t=a?this._getNextActionableItem(n,"focus"):this._getPreviousActionableItem(n,"focus"))&&(e.preventDefault(),this._focus(t,e)):(e.preventDefault(),this._collapse(n,!0,e)):(e.preventDefault(),this._expand(n,!0,e))}else if(E.isEnterKeyEvent(s)||E.isSpaceBarKeyEvent(s))e.preventDefault(),this._select(n,e);else if(E.isLetterAKeyEvent(s)&&o.isMetaKeyPressed(e)&&(this._isLeafOnlySelectionEnabled()||this._isMultiSelectionEnabled())){e.preventDefault();for(var r=this._getItems(),l=new h.AllKeySetImpl,d=0;d<r.length;d++)this._isActionable(r[d],"select")&&this._setSelected(r[d]);this._userSelectedOptionChange(l,e)}},_scrollToVisible:function(e,t){var n,s=this._getItemSpacer(e).offsetHeight,i=this.element[0],a=i.scrollTop,r=s,o=a,l=a+this.element[0].offsetHeight;n=e.offsetTop-this.element[0].offsetTop,E.isArrowUpKeyEvent(t)&&(n+=r),n<o?i.scrollTop=a+(n-o-1):n>l&&(i.scrollTop=a+(n-l+1))},_getNextItem:function(e){if(!this._isLeaf(e)&&this._isExpanded(e)){var t=this._getChildItems(e)[0];if(t)return t}for(var n=e;n;){var s=this._getNextSibling(n,this.constants.PERIOD+this.constants.OJ_TREEVIEW_ITEM);if(s)return s;n=this._getParentItem(n)}return null},_getNextActionableItem:function(e,t){for(;null!=e;)if(null!=(e=this._getNextItem(e))&&this._isActionable(e,t))return e;return null},_getPreviousItem:function(e){for(var t=this._getPreviousSibling(e,this.constants.PERIOD+this.constants.OJ_TREEVIEW_ITEM);t;){if(this._isLeaf(t)||!this._isExpanded(t))return t;var n=this._getChildItems(t),s=n[n.length-1];if(!s)return t;t=s}var i=this._getParentItem(e);return i||null},_getPreviousActionableItem:function(e,t){for(;null!=e;)if(null!=(e=this._getPreviousItem(e))&&this._isActionable(e,t))return e;return null},_handleDragStart:function(e){o.isTouchSupported()&&(this.ojTreeViewDragEvent=!0);var n=this,s="rtl"===this._GetReadingDirection(),i=this._getClosestItem(e.target);if(i){var a,r=[];if(this._isSelected(i)){var l=this.options.selection;for(a=0;a<l.length;a++){var d=this._getItemByKey(l[a]);d&&r.push(d)}}else this._select(i,e),r.push(i);var h=this._getDragOptions(),c=e.originalEvent.dataTransfer,_=document.createElement("ul");_.classList.add(this.constants.OJ_TREEVIEW_DRAG_IMAGE),_.classList.add(this.constants.OJ_TREEVIEW_LIST),t.AgentUtils.getAgentInfo().browser===t.AgentUtils.BROWSER.SAFARI&&(_.style.position="absolute");var u,E=[],p=1/0,f=1/0;for(r.forEach(function(e){const t=e[n.constants.OJ_ITEM_DATA];t?E.push(t):E.push(e.parentElement.innerHTML);var i=n._getItemSpacer(e),a=e.getBoundingClientRect(),r=a.top,o=void 0===i?0:i.offsetWidth;if(s){for(var l=n._getItemContent(e).children,d=0,h=0;h<l.length;h++)d+=l[h].offsetWidth;o=n._getTreeviewWidth()+a.x-d-o}r+=document.body.scrollTop,o+=document.body.scrollLeft;var c=e.cloneNode(!0);c.style.top=r+"px",c.style.left=o+"px",e.classList.add(n.constants.OJ_TREEVIEW_DRAG_SOURCE),c.classList.add(n.constants.OJ_TREEVIEW_DRAG_IMAGE),c.classList.add(n.constants.OJ_TREEVIEW_DRAG_IMAGE_ITEM);var u=n._getSubtree(c);u&&c.removeChild(u);var m=n._getItemContent(c);n._setUnselected(c),m.classList.remove(n.constants.OJ_FOCUS),m.classList.remove(n.constants.OJ_HOVER),m.classList.remove(n.constants.OJ_FOCUS_HIGHLIGHT),m.classList.remove(n.constants.OJ_DRAGGABLE);var v=c.getElementsByClassName(n.constants.OJ_TREEVIEW_SPACER)[0];if(v){var g=document.createElement("span");n._addTreeviewSpacerClass(g),m.insertBefore(g,v),m.removeChild(v)}if(n._isDefaultCheckBoxesEnabled()&&n._isActionable(e,"focus")&&n._isActionable(e,"select")){var I=c.getElementsByClassName(n.constants.OJ_TREEVIEW_SELECTOR)[0];I.firstChild.selectedKeys=n.options.selected,I.firstChild.rowKey=n._getKey(e)}r<p&&(p=r),o<f&&(f=o),_.appendChild(c)}),a=0;a<_.children.length;a++)(u=_.children[a]).style.top=parseFloat(u.style.top)-p+"px",u.style.left=parseFloat(u.style.left)-f+"px";var m=h.dataTypes,v="string"==typeof m?[m]:m||[];for(a=0;a<v.length;a++)c.setData(v[a],JSON.stringify(E));document.body.appendChild(_),c.setDragImage(_,e.pageX-f,e.pageY-p),setTimeout(function(){_.parentElement.removeChild(_)},0);var g=h.dragStart;g&&g(e.originalEvent,{items:E})}},_handleDragSourceEvent:function(e,t){"dragEnd"===t&&(this._removeGhostElements(),this._dropLine.style.display="none"),"dragEnd"===t&&o.isTouchSupported()&&(this.ojTreeViewDragEvent=!1);var n=this._getDragOptions()[t];n&&n(e.originalEvent)},_getTreeviewWidth:function(){return this.element[0].offsetWidth},_getItemSpacer:function(e){return e.getElementsByClassName(this.constants.OJ_TREEVIEW_SPACER)[0]},_handleDropTargetEvent:function(e,t){var n=this._getDropOptions(),s=n.dataTypes,i="string"==typeof s?[s]:s||[],a=n[t],r=this._getClosestItem(e.target);if(r){var l=this._getItemSpacer(r),d=l.getBoundingClientRect(),h=l.offsetTop+d.height/2,c="inside",_=e.originalEvent.clientY-d.top;_<.25*d.height?c="before":_>.75*d.height&&(c=this._isExpanded(r)?"first":"after"),a&&a(e.originalEvent,{item:r,position:c});for(var u=0;u<i.length;u++){var E=e.originalEvent.dataTransfer.types;if(E&&E.indexOf(i[u])>=0){e.preventDefault();break}}if("dragEnter"!==t&&"dragOver"!==t||!e.originalEvent.defaultPrevented){if("drop"===t&&(this._removeGhostElements(),this._dropLine.style.display="none",this._removeDropClass(r)),"drop"===t&&o.isTouchSupported()&&(this.ojTreeViewDragEvent=!1),"dragLeave"===t){var p=r.offsetWidth;if("DIV"===e.target.nodeName&&e.target.classList.contains(this.constants.OJ_TREEVIEW_ITEM_CONTENT)&&(e.offsetX>=p||e.offsetX<=0))this._dropLine.style.display="none",this._removeDropClass(r);else if(e.offsetY>=r.offsetHeight||e.offsetY<=0){var f=this._getItems();if(f.length>0){var m=f[0];(r===f[f.length-1]&&"after"===c||r===m&&"before"===c)&&(this._dropLine.style.display="none")}else 0===f.length&&(this._dropLine.style.display="none")}"inside"!==c&&this._removeDropClass(r)}}else{var v="rtl"===this._GetReadingDirection(),g=h;if("before"===c?g-=d.height/2:"after"!==c&&"first"!==c||(g+=d.height/2),"inside"!==c){var I,y=this._getParentItem(r);y&&this._isLeaf(r)?(I=d.width,I-=this._getItemDisclosureIcon(y).offsetHeight):y&&!this._isLeaf(r)?(I=d.width,"first"===c&&(I+=this._getItemDisclosureIcon(r).offsetHeight)):y||(I=0,"first"===c&&(I+=this._getItemDisclosureIcon(r).offsetHeight)),this._removeDropClass(r);var S=this._getTreeviewWidth()-parseInt(I,10)+"px",O=v?"0px":I+"px";this._dropLine.style.width=S,this._dropLine.style.left=O,this._dropLine.style.top=g+"px",this._dropLine.style.display=""}else this._dropLine.style.display="none",this._addDropClass(r)}}},_addDropClass:function(e){this._getItemContent(e).classList.add(this.constants.OJ_TREEVIEW_DROP_ZONE)},_removeDropClass:function(e){this._getItemContent(e).classList.remove(this.constants.OJ_TREEVIEW_DROP_ZONE)},_removeGhostElements:function(){for(var e=this.element[0].querySelectorAll(this.constants.PERIOD+this.constants.OJ_TREEVIEW_DRAG_SOURCE),t=e.length-1;t>=0;t--)e[t].classList.remove(this.constants.OJ_TREEVIEW_DRAG_SOURCE)},_NotifyContextMenuGesture:function(e,t,n){if("keyboard"===n){var s=this._currentItem?this._getItemContent(this._currentItem):this.element,i={launcher:this._getRoot(),initialFocus:"menu",position:{my:"start top",at:"start bottom",of:s}};this._OpenContextMenu(t,n,i)}else if(!this.ojTreeViewDragEvent){var a=this._getClosestItem(t.target);a&&(this._setCurrentItem(a),this._userOptionChange("currentItem",this._getKey(this._currentItem),t),this._superApply(arguments))}},refresh:function(){this._super(),this._refreshId+=1,delete this.m_template,delete this.m_engine,delete this.m_dataSource,this._expandedChildrenMap=new Map,this.m_fetching=new Set,this._render()},getNodeBySubId:function(e){if(null==e)return this.element?this.element[0]:null;var t,n=e.key,s=e.subId,i=this._getItemByKey(n);return"oj-treeview-disclosure"===s&&i?t=i.getElementsByClassName(this.constants.OJ_TREEVIEW_DISCLOSURE_ICON)[0]:s===this.constants.OJ_TREEVIEW_ITEM&&i&&(t=i.getElementsByClassName(this.constants.OJ_TREEVIEW_ITEM_CONTENT)[0]),t||null},getSubIdByNode:function(e){if(!this.element[0].contains(e))return null;var t,n=this._getClosestDisclosureIcon(e),s=this._getClosestItem(e);if(n)t="oj-treeview-disclosure";else{if(!s)return null;t=this.constants.OJ_TREEVIEW_ITEM}return{subId:t,key:this._getKey(s)}},getContextByNode:function(e){if(!this.element[0].contains(e))return null;var t,n=this._getClosestItem(e);if(!n)return null;var s=n.parentNode.children,i=[];for(t=0;t<s.length;t++)s[t].classList.contains(this.constants.OJ_TREEVIEW_ITEM)&&i.push(s[t]);var r={subId:this.constants.OJ_TREEVIEW_ITEM,index:i.indexOf(n),parentKey:this._getKey(this._getParentItem(n))};r.component=a.__GetWidgetConstructor(this.element),this._FixRendererContext&&(r=this._FixRendererContext(r));var o=n[this.constants.OJ_ITEM_METADATA];if(o){r.metadata=o,r.data=n[this.constants.OJ_ITEM_DATA],r.datasource=this.options.data;var l=Object.keys(o);for(t=0;t<l.length;t++){var d=l[t];r[d]=o[d]}}else r.key=this._getKey(n),r.leaf=this._isLeaf(n),r.depth=this._getParents(n,".oj-treeview-list").length;return r},_setOption:function(e,t,n){var s,i,a=this;if(this._isLeafOnlySelectionEnabled()&&(!this._isLeafOnlySelectionEnabled()||"selected"===e&&"selection"===e)||this._superApply(arguments),"expanded"===e)for(this._uiExpanded=a._uiExpanded.clear(),this._expandedChildrenMap=new Map,i=this._getItems(),s=0;s<i.length;s++){var r=this._getKey(i[s]);a._isInitExpanded(r)?a._expand(i[s],!0):a._collapse(i[s],!0)}else if("selected"===e){if(this._isLeafOnlySelectionEnabled()){let e=t;e=this._filterOutParentKeys(e);let n=this._getEmptyKeySet(e);this._selectedKeysets=this.treeviewSelectionManager.computeSelection(e,n),t=this._selectedKeysets.selectedLeaves,arguments[1]=t,this._superApply(arguments)}var o=h.KeySetUtils.toArray(t);this._userOptionChange("selection",o,null),this._refreshSelectionItems()}else if("selection"===e){var l=h.KeySetUtils.toKeySet(t);if(this._isLeafOnlySelectionEnabled()){let e=l;e=this._filterOutParentKeys(e);let t=this._getEmptyKeySet(e);this._selectedKeysets=this.treeviewSelectionManager.computeSelection(e,t),l=this._selectedKeysets.selectedLeaves,arguments[1]=h.KeySetUtils.toArray(l),this._superApply(arguments)}this._userOptionChange("selected",l,null),this._refreshSelectionItems()}else"currentItem"===e?this._resetFocus():"data"===e?(this._removeDataProviderEventListeners(),this.options.data=t,this._addDataProviderEventListeners(),this.refresh()):this.refresh()},_SetupResources:function(){this._super(),this._addDataProviderEventListeners()},_ReleaseResources:function(){this._super(),this._removeDataProviderEventListeners()},_destroy:function(){this._removeDataProviderEventListeners(),this._super()},_addDataProviderEventListeners:function(){var e=this.options.data;e&&t.DataProviderFeatureChecker.isTreeDataProvider(e)&&(this.m_handleModelMutateEventListener=this.handleModelMutateEvent.bind(this),this.m_handleModelRefreshEventListener=this.handleModelRefreshEvent.bind(this),e.addEventListener("mutate",this.m_handleModelMutateEventListener),e.addEventListener("refresh",this.m_handleModelRefreshEventListener))},_removeDataProviderEventListeners:function(){var e=this.options.data;e&&t.DataProviderFeatureChecker.isTreeDataProvider(e)&&(e.removeEventListener("mutate",this.m_handleModelMutateEventListener),e.removeEventListener("refresh",this.m_handleModelRefreshEventListener))},handleModelMutateEvent:function(e){this._isLeafOnlySelectionEnabled()?l.error("Mutations are not supported in selectionMode: leafOnly  "):this.isReady()?(null!=e.detail.remove&&this.handleModelRemoveEvent(e),null!=e.detail.add&&this.handleModelAddEvent(e),null!=e.detail.update&&this.handleModelChangeEvent(e),this._processEventQueue()):this._pushToEventQueue(e)},_pushToEventQueue:function(e){null==this.m_eventQueue&&(this.m_eventQueue=[]),this.m_eventQueue.push(e)},_clearEventQueue:function(){null!=this.m_eventQueue&&(this.m_eventQueue.length=0)},_processEventQueue:function(){var e;if(this.isReady()&&null!=this.m_eventQueue&&this.m_eventQueue.length>0){for(var t=0;t<this.m_eventQueue.length;t++)if("refresh"===(e=this.m_eventQueue[t]).type)return void this.handleModelRefreshEvent(e);"mutate"===(e=this.m_eventQueue.shift()).type&&this.handleModelMutateEvent(e)}},isReady:function(){return 0===this.m_fetching.size},handleModelRemoveEvent:function(e){var t=this,n=e.detail.remove.keys,s=[];if(null!=n&&0!==n.size&&(n.forEach(function(n){(!e.detail.add||e.detail.add&&!e.options.detail.add.keys.has(n))&&(s=s.concat(t._removeAllChildrenOfParentKey(n)))}),0!==s.length)){var i=this._getSelected();if(null!=i){var a=i.delete(s);i!==a&&this._userSelectedOptionChange(a,e)}var r=this.options.expanded;if(null!=r){var o=r.delete(s);this._uiExpanded.delete(s),r!==o&&this._userOptionChange("expanded",o,null)}this._resetFocus()}},_changeNodeToLeaf:function(e,t){if(e!==this.element[0]){e.removeChild(t),e[this.constants.OJ_ITEM_METADATA].leaf=!0,e.classList.add(this.constants.OJ_TREEVIEW_LEAF),e.classList.remove(this.constants.OJ_EXPANDED),e.removeAttribute("aria-expanded"),e.classList.remove(this.constants.OJ_COLLAPSED);var n=this._getItemSpacer(e);this._removeIndentation(n),this._addIndentation(e,n);var s=this._getKey(e),i=[];i.push(s);var a=this.options.expanded;if(null!=a){var r=a.delete(i);this._uiExpanded.delete(i),a!==r&&this._userOptionChange("expanded",r,null)}var o=this._getItemDisclosureIcon(e);this._removeDisclosureClasses(o)}},_changeNodeToParent:function(e){e[this.constants.OJ_ITEM_METADATA].leaf=!1,e.classList.remove(this.constants.OJ_TREEVIEW_LEAF),e.classList.add(this.constants.OJ_COLLAPSED),this._setAriaExpanded(e,"false");var t=this._getItemSpacer(e);this._removeIndentation(t),this._addIndentation(e,t);var n=this._getItemDisclosureIcon(e);this._addDisclosureClasses(n)},_setAriaExpanded:function(e,t){e.setAttribute("aria-expanded",t)},_getItemDisclosureIcon:function(e){return e.getElementsByTagName("ins")[0]},_removeAllChildrenOfParentKey:function(e){var t=this,n=[],s=this._getItemByKey(e);if(s){this._getChildItems(s).forEach(function(e){var s=t._getKey(e),i=t._removeAllChildrenOfParentKey(s);n=n.concat(i)});var i=s.parentNode;i.removeChild(s),this._keyList.delete(e),n.push(e),0===i.getElementsByTagName("li").length&&t._changeNodeToLeaf(i.parentNode,i)}return n},_isLeafIcon:function(e){return e.classList.contains(this.constants.OJ_TREEVIEW_LEAF)},handleModelReorder:function(e,t,n){var s=this._getItemByKey(t),i=s.parentElement,a=this._getItemByKey(e),r=a.parentElement,o=a.parentNode;r.removeChild(a),0===r.getElementsByTagName("li").length&&this._changeNodeToLeaf(o.parentNode,o),n?i.insertBefore(a,s.nextSibling):i.insertBefore(a,s)},getLastItemKey(e){return this._getKey(e[e.length-1])},handleModelAddEvent:function(e){var t=e.detail.add;this._truncateIfOverMaxCount(t);var n,s=t.data,i=t.metadata,a=[],r=t.parentKeys,o=t.indexes,l=0,d=this;e.detail.add.keys.forEach(function(n){if(!e.detail.remove||e.detail.remove&&!e.options.detail.remove.keys.has(n))a.push(n);else if(t.addBeforeKeys&&t.addBeforeKeys[l]&&0!==t.addBeforeKeys.length)this.handleModelReorder(n,t.addBeforeKeys[l],!1);else{var s;if(t.parentKeys&&t.parentKeys[l]&&0!==t.parentKeys.length){var i=this._getItemByKey(t.parentKeys[l]),r=this._getChildItems(i);s=this.getLastItemKey(r)}else{var o=this._getItems();s=this.getLastItemKey(o)}s&&this.handleModelReorder(n,s,!0)}l+=1}.bind(this)),r.forEach(function(e){var t=d._getItemByKey(e);t&&d._isLeafIcon(t)&&d._changeNodeToParent(t)});var h=t.addBeforeKeys?t.addBeforeKeys:t.afterKeys;if(h&&(n=[],h.forEach(function(e){n.push(e)})),null!=s&&a.length>0&&s.length>0&&a.length===s.length&&(null==o||o.length===s.length))for(l=0;l<s.length;l++){var c,_=null==o?this._getIndex(n,l)+1:o[l],u=r[l],E=this._getItemByKey(u);null==u?(c=this._getRoot())&&this._renderItem(c,{data:[s[l]],metadata:[i[l]]},0,_):E&&(c=this._getSubtree(E))&&this._renderItem(c,{data:[s[l]],metadata:[i[l]]},0,_)}},handleModelChangeEvent:function(e){var t=e.detail.update,n=t.data,s=t.metadata,i=[];t.keys.forEach(function(e){i.push(e)});for(var a=0;a<n.length;a++){var r=this._getItemByKey(i[a]);if(null!=r){var o=this._indexToParent(r);this._renderItem(null,{data:[n[a]],metadata:[s[a]]},0,o,!0)}}this._resetFocus()},_indexToParent:function(e){for(var t=0,n=0;n<e.parentNode.children.length;n++)if(e.parentNode.children[n]===e){t=n;break}return t},handleModelRefreshEvent:function(e){this.isReady()?(this._clearEventQueue(),this.refresh()):this._pushToEventQueue(e)},_isSkeletonSupported:function(){return"skeleton"===this._getOptionDefaults().loadIndicator},_getOptionDefaults:function(){if(null==this.defaultOptions){this.defaultOptions={};const e=Object.keys(this.constants.OJ_TREEVIEW_CSS_VARS),t=e.map(e=>this.constants.OJ_TREEVIEW_CSS_VARS[e]),n=i.getCachedCSSVarValues(t);e.forEach((e,t)=>{this.defaultOptions[e]=n[t]})}return this.defaultOptions},_renderChildSkeletons:function(e){var t=this._getItemByKey(e);this._removeExistingSkeletons(t);var n=this._getItemDisclosureIcon(t).offsetWidth,s="rtl"===this._GetReadingDirection(),i=this._buildThreeItemedSkeleton(),a=this._buildSkeletonContainer(),r=n,o=this._getDepth(t);s?a.style.marginRight=r+n/o+"px":a.style.marginLeft=r+n/o+"px",a.appendChild(i),t.appendChild(a)},_renderInitialSkeletons:function(){this._removeExistingSkeletons(this.element[0]);var e=this._buildThreeItemedSkeleton(),t=this._buildTwoItemedSkeleton(),n=this._buildSkeletonContainer();n.appendChild(e),n.appendChild(t),this.element[0].classList.add(this.constants.OJ_COMPLETE),this.element[0].appendChild(n);var s=n.offsetHeight,i=this.element[0].offsetHeight,a=s/5,r=0;if(s<i)do{r%2==0?(s+=3*a,n.appendChild(this._buildThreeItemedSkeleton())):(s+=2*a,n.appendChild(this._buildTwoItemedSkeleton())),r+=1}while(s<=i);if(s>i){var o=n.querySelectorAll(this.constants.PERIOD+this.constants.OJ_TREEVIEW_SKELETON_CONTENT);for(r=o.length-1;r>=0&&(s-=a,n.removeChild(o[r]),!(s<=i));r--);}},_removeExistingSkeletons:function(e){for(var t=e.querySelectorAll(this.constants.PERIOD+this.constants.OJ_TREEVIEW_SKELETON_CONTAINER),n=0;n<t.length;n++)e.removeChild(t[n])},_getSkeletonContainer:function(e){return e.getElementsByClassName(this.constants.OJ_TREEVIEW_SKELETON_CONTAINER)[0]},_removeSkeleton:function(e){return new Promise(function(t){var n,s=this._addBusyState("removing skeleton",e);(n=null===e?this._getSkeletonContainer(this.element[0]):this._getSkeletonContainer(this._getItemByKey(e)))?r.fadeOut(n,{duration:"100ms"}).then(function(){n.parentElement&&n.parentElement.removeChild(n),s(),t()}):(s(),t())}.bind(this))},_buildThreeItemedSkeleton:function(){var e=this._buildTwoItemedSkeleton(),t=this._buildSkeletonLeafContent();return e.appendChild(t),e},_buildTwoItemedSkeleton:function(){var e=new DocumentFragment,t=this._buildSkeletonContent(!1);e.appendChild(t);var n=this._buildSkeletonContent(!0);return e.appendChild(n),e},_buildSkeletonContainer:function(){var e=document.createElement("div");return e.classList.add(this.constants.OJ_TREEVIEW_SKELETON_CONTAINER),e.classList.add(this.constants.OJ_ANIMATION_SKELETON_FADE_IN),e},_buildSkeletonContent:function(e){var t=document.createElement("div");t.classList.add(this.constants.OJ_TREEVIEW_SKELETON_CONTENT);var n=this._buildSkeletonCarrot();return e&&n.classList.add(this.constants.OJ_TREEVIEW_SKELETON_CHILD),t.appendChild(n),t.appendChild(this._buildSkeletonItem()),t},_buildSkeletonCarrot:function(){var e=document.createElement("div");return e.classList.add(this.constants.OJ_TREEVIEW_SKELETON_CARROT),e.classList.add(this.constants.OJ_ANIMATION_SKELETON),e},_buildSkeletonItem:function(){var e=document.createElement("div");return e.classList.add(this.constants.OJ_TREEVIEW_SKELETON_ITEM),e.classList.add(this.constants.OJ_ANIMATION_SKELETON),e},_buildSkeletonLeafContent:function(){var e=document.createElement("div");return e.classList.add(this.constants.OJ_TREEVIEW_SKELETON_CONTENT),e.appendChild(this._buildSkeletonLeafItem()),e},_buildSkeletonLeafItem:function(){var e=document.createElement("div");return e.classList.add(this.constants.OJ_TREEVIEW_SKELETON_LEAF),e.classList.add(this.constants.OJ_ANIMATION_SKELETON),e},_closest:function(e,t){if(!e)return null;if(!e.closest){do{if(this._matches(e,t))return e;e=e.parentElement||e.parentNode}while(null!==e&&1===e.nodeType);return null}return e.closest(t)},_getParents:function(e,t){for(var n=[];e&&e!==document;e=e.parentNode)this._matches(e,t)&&n.push(e);return n},_getNextSibling:function(e,t){var n=e.nextElementSibling;if(!t)return n;for(;n;){if(this._matches(n,t))return n;n=n.nextElementSibling}return null},_getPreviousSibling:function(e,t){var n=e.previousElementSibling;if(!t)return n;for(;n;){if(this._matches(n,t))return n;n=n.previousElementSibling}return null},_matches:function(e,t){return e.matches||(e.matches=Element.prototype.msMatchesSelector||Element.prototype.webkitMatchesSelector),e.matches(t)}});var m={properties:{currentItem:{type:"any",writeback:!0,readOnly:!0},data:{type:"object",extension:{webelement:{exceptionStatus:[{type:"deprecated",since:"11.0.0",description:"Data sets from a DataProvider cannot be sent to WebDriverJS; use ViewModels or page variables instead."}]}}},dnd:{type:"object",properties:{drag:{type:"object",properties:{items:{type:"object",properties:{dataTypes:{type:"string|Array<string>"},drag:{type:"function"},dragEnd:{type:"function"},dragStart:{type:"function"}}}}},drop:{type:"object",properties:{items:{type:"object",properties:{dataTypes:{type:"string|Array<string>"},dragEnter:{type:"function"},dragLeave:{type:"function"},dragOver:{type:"function"},drop:{type:"function"}}}}}}},expanded:{type:"KeySet",writeback:!0},item:{type:"object",properties:{focusable:{type:"function"},renderer:{type:"function"},selectable:{type:"function"}}},scrollPolicyOptions:{type:"Object<number>",properties:{maxCount:{type:"number",value:500}}},selected:{type:"KeySet",writeback:!0},selection:{type:"Array<any>",writeback:!0,value:[]},selectionMode:{type:"string",enumValues:["leafOnly","multiple","none","single"],value:"none"},translations:{type:"object",value:{},properties:{treeViewSelectorAria:{type:"string"}}}},methods:{getContextByNode:{},getProperty:{},refresh:{},setProperties:{},setProperty:{},getNodeBySubId:{},getSubIdByNode:{}},events:{ojAnimateEnd:{},ojAnimateStart:{},ojBeforeCollapse:{},ojBeforeCurrentItem:{},ojBeforeExpand:{},ojCollapse:{},ojExpand:{}},extension:{}};m.extension._WIDGET_NAME="ojTreeView",t.CustomElementBridge.register("oj-tree-view",{metadata:m})});
//# sourceMappingURL=ojtreeview.js.map