/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojcore-base","ojs/ojlogger","ojs/ojdatacollection-common","ojs/ojcachediteratorresultsdataprovider","ojs/ojdomscroller"],function(e,t,a,n,r,s){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,r=r&&Object.prototype.hasOwnProperty.call(r,"default")?r.default:r,s=s&&Object.prototype.hasOwnProperty.call(s,"default")?s.default:s;class i{constructor(e,t,a){this.root=e,this.dataProvider=t,this.callback=a,this.validKeyTypes=["string","number"],this.fetching=0,this.getKey=function(e){return e.key?e.key:"number"===e.dataset.ojKeyType?Number(e.dataset.ojKey):e.dataset.ojKey},t&&(this.modelEventHandler=this._handleModelEvent.bind(this),t.addEventListener("mutate",this.modelEventHandler),t.addEventListener("refresh",this.modelEventHandler))}setFetching(e){const t=e?this.fetching+1:this.fetching-1;this.fetching=Math.max(0,t)}isFetching(){return 0!==this.fetching}addBusyState(e){return null!=this.callback?this.callback.addBusyState("DataProviderContentHandler "+e):()=>{}}destroy(){this.callback=null,this.dataProvider&&this.modelEventHandler&&(this.dataProvider.removeEventListener("mutate",this.modelEventHandler),this.dataProvider.removeEventListener("refresh",this.modelEventHandler))}render(e){return this.renderFetchedData(e)}postRender(){}getDataProvider(){return this.dataProvider}setDataProvider(e){this.dataProvider=e}isReady(){return!this.fetching}verifyKey(e){return this.validKeyTypes.indexOf(typeof e)>-1}handleModelRefresh(){this.callback.setData(null),this.fetchRows()}handleItemsAdded(e){}handleItemsRemoved(e){}handleItemsUpdated(e){}_handleModelEvent(e){if("refresh"===e.type)this.handleModelRefresh();else if("mutate"===e.type){if(null==this.callback.getData())return;const t=e.detail;t.add&&this.handleItemsAdded(t.add),t.remove&&(this.handleItemsRemoved(t.remove),t.remove.keys.forEach(e=>{var a;(null===(a=t.add)||void 0===a?void 0:a.keys.has(e))||this.callback.handleItemRemoved(e)})),t.update&&this.handleItemsUpdated(t.update)}}}var l;(l=e.VirtualizationStrategy||(e.VirtualizationStrategy={}))[l.HIGH_WATER_MARK=0]="HIGH_WATER_MARK",l[l.VIEWPORT_ONLY=1]="VIEWPORT_ONLY";class o{constructor(e,t,a,n,r){this.element=e,this.dataProvider=t,this.asyncIterator=a,this.callback=n,this.options=r,this._handleScroll=e=>{const t=this.element,a=this._getScrollTop(t),n=t.scrollHeight-t.clientHeight;n>0&&this._handleScrollerScrollTop(a,n)},this._handleModelEvent=e=>{if("mutate"===e.type){const t=e.detail;if(t.add){let e=t.add.indexes;const a=t.add.addBeforeKeys;if(null!=a){const n=Array.from(t.add.keys);e=this._handleModelInsert(a,n)}null!=e&&(e=e.sort((e,t)=>e-t),this._handleItemsAddedOrRemoved(e,"added"),this.rowCount=this.rowCount+e.length)}if(t.remove){const e=Array.from(t.remove.keys);let a=this._handleModelDelete(e);a=a.sort((e,t)=>t-e),this._handleItemsAddedOrRemoved(a,"removed"),this.rowCount=Math.max(0,this.rowCount-a.length)}}},this.initialScrollTop=this.element.scrollTop,this.scrollListener=this._handleScroll.bind(this),this._getScrollEventElement().addEventListener("scroll",this.scrollListener),this.modelEventListener=this._handleModelEvent.bind(this),t.addEventListener("mutate",this.modelEventListener),this.fetchSize=r.fetchSize>0?r.fetchSize:25,this.maxCount=r.maxCount>0?r.maxCount:500,this.rowCount=null!=r.keys?r.keys.length:this.fetchSize,this.viewportSize=-1,this.viewportPixelSize=this.element.offsetHeight,this.currentScrollTop=0,this.currentRenderedPoint={startIndex:0,endIndex:isNaN(this.rowCount)?this.fetchSize:this.rowCount,maxCountLimit:!1,done:!1,keys:r.keys},this.lastFetchTrigger=0,this.checkViewportCount=0}checkViewport(){if(this.currentRenderedPoint.done||this.currentRenderedPoint.maxCountLimit)return!0;const e=this._isRangeValid(0,this.currentRenderedPoint.end);return e?this.checkViewportCount=0:(this.checkViewportCount+=1,this.checkViewportCount===n.CHECKVIEWPORT_THRESHOLD&&a.warn("Viewport not satisfied after multiple fetch, make sure the component is height constrained or specify a scroller."),this._doFetch()),e}setAsyncIterator(e){this.asyncIterator=e}_isRenderingViewportOnly(t){return this.options.strategy===e.VirtualizationStrategy.VIEWPORT_ONLY&&void 0!==t.getIndexForRange}setViewportRange(e,t){null!=this.currentRenderedPoint.start&&null!=this.currentRenderedPoint.end||(this.currentRenderedPoint.start=e,this.currentRenderedPoint.end=t,this._log(`got pixel range: ${e} to ${t} for renderedPoint: ${this.currentRenderedPoint.startIndex} ${this.currentRenderedPoint.endIndex}`)),this._checkRenderedPoints()&&(this.fetchPromise=null,this.currentScrollTop>=this.lastFetchTrigger&&(this.nextFetchTrigger=void 0))}destroy(){this._getScrollEventElement().removeEventListener("scroll",this.scrollListener),this.dataProvider.removeEventListener("mutate",this.modelEventListener)}_getScrollEventElement(){return this.element===document.body||this.element===document.documentElement?window:this.element}_getScrollTop(e){return e===document.documentElement&&(void 0===this.useBodyScrollTop&&(this.useBodyScrollTop=this.initialScrollTop===e.scrollTop),this.useBodyScrollTop)?0+document.body.scrollTop:0+e.scrollTop}_setRangeLocal(e,t,a,n,r,s){this._log(`rendering row: ${e} to ${t} covering range: ${null==a?"unknown":a} to ${null==n?"unknown":n}`),this.callback.beforeFetchByOffset(e,t),this.currentRenderedPoint={startIndex:e,endIndex:t,start:a,end:n,maxCountLimit:r,done:s,keys:[]};const i={offset:e,size:t-e};this.fetchByOffsetPromise=this.dataProvider.fetchByOffset(i).then(i=>{let l=!0;if(null!=a&&null!=n&&(l=this._isRangeValid(a,n)),l){this._log(`fetchByOffset ${e} to ${t} returned and result is still applicable`);const a=[],n=[],l=this.currentRenderedPoint.keys;i.results.forEach(e=>{a.push(e.data),n.push(e.metadata),l.push(e.metadata.key)});const o={};o.startIndex=e,o.maxCountLimit=r,o.done=s,o.value={},o.value.data=a,o.value.metadata=n,this.callback.fetchSuccess(o),this.fetchByOffsetPromise=null}else this._log(`fetchByOffset ${e} to ${t} returned but result is NO LONGER applicable`),this.fetchByOffsetPromise=null,this.callback.fetchError("notValid"),this._checkRenderedPoints()})}_handleScrollerScrollTop(e,t){if(this.currentScrollTop=e,!this.fetchPromise&&this.asyncIterator){if(isNaN(this.nextFetchTrigger)&&this.lastMaxScrollTop!==t&&(this.nextFetchTrigger=Math.max(0,(t-e)/2),this.lastFetchTrigger=e,this.lastMaxScrollTop=t,this._log("next fetch trigger point: "+Math.round(this.nextFetchTrigger))),null!=this.nextFetchTrigger&&e-this.lastFetchTrigger>this.nextFetchTrigger)return void this._doFetch();if(t-e<1)return void this._doFetch()}this.fetchPromise&&e>this.lastFetchTrigger||this._checkRenderedPoints()}_isRangeValid(e,t){const a=this.currentScrollTop;return this.viewportPixelSize=this.element.clientHeight,a>=e&&a+this.viewportPixelSize<=t}_checkRenderedPoints(){if(null==this.currentRenderedPoint.start||null==this.currentRenderedPoint.end)return!0;if(this._isRangeValid(this.currentRenderedPoint.start,this.currentRenderedPoint.end))return!0;if(this._isRenderingViewportOnly(this.callback)){const e=this.callback,t=Math.max(0,this.currentScrollTop-this.viewportPixelSize),a=Math.min(this.currentScrollTop+2*this.viewportPixelSize),n=e.getIndexForRange(t,a),r=Math.max(0,n.startIndex),s=null==n.endIndex?this.rowCount:Math.min(this.rowCount,n.endIndex);if(r<this.currentRenderedPoint.startIndex||s>this.currentRenderedPoint.endIndex){const e=s===this.lastIndex,n=s===this.maxCount;return this._setRangeLocal(r,s,t,a,n,e),!1}}return!0}_doFetch(){this._log("fetching next set of rows from asyncIterator");this.callback.beforeFetchNext()?(-1===this.viewportSize&&(this.viewportSize=this.currentRenderedPoint.endIndex-this.currentRenderedPoint.startIndex),this.fetchPromise=this._fetchMoreRows().then(e=>{if(e.maxCountLimit){this._log("reached max count");const t=e.size>0?null:this.currentRenderedPoint.start,a=e.size>0?null:this.currentRenderedPoint.end;this._setRangeLocal(this.currentRenderedPoint.startIndex,this.maxCount,t,a,!0,!1),this.fetchPromise=null,this.asyncIterator=null}else if(e.size>0||!0===e.done){let t=0;this._isRenderingViewportOnly(this.callback)&&(t=this.callback.getIndexForPosition(this.currentScrollTop));const a=t,n=this.currentRenderedPoint.endIndex+e.size;e.done&&(this.lastIndex=n),this._setRangeLocal(a,n,null,null,!1,e.done)}else this.fetchPromise=null,this.asyncIterator=null,this.callback.fetchSuccess(null)},e=>{this.callback.fetchError(e),this.fetchPromise=null,this.nextFetchTrigger=void 0})):(this._log("fetch is aborted due to beforeFetchCallback returning false"),this.nextFetchTrigger=void 0)}_fetchMoreRows(){if(!this.fetchPromise){const e=this.maxCount-this.rowCount;return e>0&&!this.currentRenderedPoint.done&&null!=this.asyncIterator?(this.fetchPromise=this.asyncIterator.next().then(t=>{let a;return this.fetchPromise=null,null!=t&&(a={done:t.done,maxCountLimit:t.maxCountLimit},null!=t.value&&(a.size=t.value.data.length,this.rowCount+=t.value.data.length,e<this.fetchSize&&(a.maxCountLimit=!0,t.value.data.length>e&&(a.size=e))),a.maxCountLimit&&(this.asyncIterator=null)),Promise.resolve(a)}),this.fetchPromise):Promise.resolve({maxCount:this.maxCount})}return this.fetchPromise}_handleModelInsert(e,t){const a=this.currentRenderedPoint.keys;e.forEach((e,n)=>{const r=a.indexOf(e),s=t[n];r>-1&&a.splice(r,0,s)});const n=[],r=this.currentRenderedPoint.startIndex;return t.forEach(e=>{const t=a.indexOf(e);t>-1?n.push(t+r):this.currentRenderedPoint.done=!1}),n.length>0&&(this.currentRenderedPoint.start=null,this.currentRenderedPoint.end=null),n}_handleModelDelete(e){const t=[],a=this.currentRenderedPoint.startIndex,n=this.currentRenderedPoint.keys,r=[];return e.forEach(e=>{const s=n.indexOf(e);s>-1&&(t.push(a+s),r.push(e))}),r.forEach(e=>{n.splice(n.indexOf(e),1)}),t.length>0&&(this.currentRenderedPoint.start=null,this.currentRenderedPoint.end=null),t}_updateRenderedPoint(e,t,a){e<t.startIndex?"added"===a?(t.startIndex=t.startIndex+1,t.endIndex=t.endIndex+1):"removed"===a&&(t.startIndex=t.startIndex-1,t.endIndex=t.endIndex-1):e<=t.endIndex&&("added"===a?t.endIndex=t.endIndex+1:"removed"===a&&(t.endIndex=t.endIndex-1))}_handleItemsAddedOrRemoved(e,t){e.forEach(e=>{this._updateRenderedPoint(e,this.currentRenderedPoint,t)})}_log(e){a.info("[VirtualizeDomScroller]=> "+e)}}class d extends i{constructor(t,a,n,r,i){super(t,a,n),this.root=t,this.dataProvider=a,this.callback=n,this.scrollPolicy=r,this.scrollPolicyOptions=i,this.fetchRows=()=>{if(this.isReady()){const e={clientId:this._clientId};e.size=this._isLoadMoreOnScroll()?this.getFetchSize():-1;const t=this.getDataProvider().fetchFirst(e)[Symbol.asyncIterator]();this._cachedIteratorsAndResults.root={iterator:t,cache:null};const a={value:{data:[],metadata:[]}};this._fetchNextFromIterator(t,null,e,a).then(e=>{this._setNewData(e)},()=>{this._setNewData(null)})}},this._fetchNextFromIterator=(e,t,a,n)=>{if(null==e)return Promise.resolve();this.setFetching(!0);const r=this.addBusyState("call next on iterator"),s=e.next(),i=a.size,l=t=>{if(t.done||-1!==i)return t;return e.next().then(function(e){return t.done=e.done,t.value.data=t.value.data.concat(e.value.data),t.value.metadata=t.value.metadata.concat(t.value.metadata),l(t)},function(e){return Promise.reject(e)})};return s.then(e=>l(e),e=>Promise.reject(e)).then(e=>{if(this.isFetching()){if(r(),this.setFetching(!1),null==this.callback||null==e)return;return this.initialFetch=!0,e.done&&this._cachedIteratorsAndResults[null===t?"root":t]&&(this._cachedIteratorsAndResults[null===t?"root":t].iterator=null),this.handleNextItemInResults(a,t,e,n)}},e=>(r(),this._handleFetchError(e),Promise.reject(e)))},this._setNewData=e=>{null!=this.callback&&this.callback.updateData(function(t){let a,n,r,s;return null==e?(n=[],r=[],s=!0):(n=e.value.data,r=e.value.metadata,s=this._checkIteratorAndCache()),a=null==t?{value:{data:n,metadata:r},done:s}:{value:{data:t.value.data.concat(n),metadata:t.value.metadata.concat(r)},done:s},{renderedData:a}}.bind(this))},this._checkIteratorAndCache=()=>{const e=this._cachedIteratorsAndResults,t=Object.keys(e).map(function(t){return e[t]});let a=!0;return t.forEach(function(e){!e||null==e.iterator&&null==e.cache||(a=!1)}),a},this.fetchMoreRows=()=>{if(this.isReady()){const e=this._getLastEntryMetadata();let t=e.key;!e.isLeaf&&this._isExpanded(t)||(t=e.parentKey);const a={};a.size=this._isLoadMoreOnScroll()?this.getFetchSize():-1;const n=this._cachedIteratorsAndResults[null===t?"root":t];let r=null,s=null;null!=n&&(r=n.cache,s=n.iterator);const i={value:{data:[],metadata:[]}};return this.handleNextItemInResults(a,t,r,i).then(()=>{let e,n=this._cachedIteratorsAndResults[null===t?"root":t];return null!=n&&(e=n.iterator),this._fetchFromAncestors(a,t,e,i)},e=>Promise.reject(e))}return Promise.resolve()},this._fetchFromAncestors=(e,t,a,n)=>{const r=this;if(r._checkFinalResults(e,n))return n.done=this._checkIteratorAndCache(),Promise.resolve(n);return this._fetchNextFromIterator(a,t,e,n).then(function(t,a){if(r._checkFinalResults(e,a)||null===t)return a.done=this._checkIteratorAndCache(),Promise.resolve(a);const n=r._getItemByKey(t,a).metadata.parentKey,s=this._cachedIteratorsAndResults[null===n?"root":n];let i=null,l=null;return null!=s&&(i=s.cache,l=s.iterator),this.handleNextItemInResults(e,n,i,a).then(this._fetchFromAncestors.bind(this,e,n,l,a))}.bind(this,t,n),e=>Promise.reject(e))},this._getLastEntryMetadata=()=>{const e=this.callback.getData();if(e&&e.value.metadata.length){const t=e.value.metadata;return t[t.length-1]}return null},this._isExpanded=e=>this.callback.getExpanded().has(e),this.getChildDataProvider=e=>null==e?this.dataProvider:this.dataProvider.getChildDataProvider(e),this.handleNextItemInResults=(e,t,a,n)=>{if(null===a||0===a.value.data.length||this._checkFinalResults(e,n))return null!=a&&a.value.data.length?this._cachedIteratorsAndResults[null===t?"root":t]&&(this._cachedIteratorsAndResults[null===t?"root":t].cache=a):this._cachedIteratorsAndResults[null===t?"root":t]&&(this._cachedIteratorsAndResults[null===t?"root":t].cache=null),this._checkFinalResults(e,n)||null==this._cachedIteratorsAndResults[null===t?"root":t].iterator?(n.done=this._checkIteratorAndCache(),Promise.resolve(n)):this._fetchNextFromIterator(this._cachedIteratorsAndResults[null===t?"root":t].iterator,t,e,n);const r=a.value.data.shift(),s=a.value.metadata.shift(),i=this._updateMetadata(s,t,n);if(n.value.data.push(r),n.value.metadata.push(i),this._isExpanded(i.key)){const e=this.getChildDataProvider(i.key);if(null!=e){const r={clientId:this._clientId};r.size=this._isLoadMoreOnScroll()?this.getFetchSize():-1;const s=e.fetchFirst(r)[Symbol.asyncIterator]();this._cachedIteratorsAndResults[null===i.key?"root":i.key]={iterator:s,cache:null};return this._fetchNextFromIterator(s,i.key,r,n).then(this.handleNextItemInResults.bind(this,r,t,a,n))}}return this.handleNextItemInResults(e,t,a,n)},this._checkFinalResults=(e,t)=>t.value.data.length>=e.size&&-1!==e.size,this._updateMetadata=(e,t,a)=>{let n=0;const r=this._getLastItemByParentKey(t,a),s=null==r?0:r.metadata.indexFromParent+1,i=null===this.getChildDataProvider(e.key);if(null!=t){n=this._getItemByKey(t,a).metadata.treeDepth+1}const l=this._isExpanded(e.key);return{key:e.key,isLeaf:i,parentKey:t,indexFromParent:s,treeDepth:n,expanded:l}},this._getIndexByKey=(e,t)=>{let a=-1;return t.some(function(t,n){if(t.key===e)return a=n,!0}),a},this._getLastItemByParentKey=(e,t)=>{let a=null;if(t&&t.value.metadata.slice().reverse().some(function(n,r){if(n.parentKey===e)return a={data:t.value.data[r],metadata:n},!0}),a)return a;const n=this.callback.getData();return n&&n.value.metadata.slice().reverse().some(function(t,r){if(t.parentKey===e)return a={data:n.value.data[r],metadata:t},!0}),a},this._getItemByKey=(e,t)=>{let a=null;if(t&&t.value.metadata.some(function(n,r){if(n.key===e)return a={data:t.value.data[r],metadata:n},!0}),a)return a;const n=this.callback.getData();return n&&n.value.metadata.some(function(t,r){if(t.key===e)return a={data:n.value.data[r],metadata:t},!0}),a},this.expand=e=>{const t=this.getChildDataProvider(e);if(null===t)return;const a=setTimeout(function(){var t;(null===(t=this.callback)||void 0===t?void 0:t.getExpandingKeys().has(e))&&this.callback.updateSkeletonKeys(e)}.bind(this),250),n=this.getFetchSize();let r={clientId:this._clientId,size:n},s=t.fetchFirst(r)[Symbol.asyncIterator]();return this._cachedIteratorsAndResults[e]={iterator:s,cache:null},this._fetchNextFromIterator(s,e,r,{value:{data:[],metadata:[]}}).then(function(t){null!=this.callback&&this.callback.updateExpand(function(r,s,i,l){if(a&&clearTimeout(a),s.has(e)&&(s=s.delete([e])),!i.has(e)||!l.has(e))return{expandedSkeletonKeys:s};if(null==t)return{expandedSkeletonKeys:s,expandingKeys:i.delete([e])};let o,d,h,c=t.value.data,u=t.value.metadata;if(r){let t=r.value.data,a=r.value.metadata,s=this._getIndexByKey(e,a);if(-1!==s){const e=c.length;let i=t.slice(0,s+1).concat(c),l=a.slice(0,s+1).concat(u),m=r.done;e<n?(i=i.concat(t.slice(s+1)),l=l.concat(a.slice(s+1))):(d=t.slice(s+1),h=a.slice(s+1),d.length>0&&(m=!1,null!=this.domScroller&&this.domScroller.setAsyncIterator({next:this.fetchMoreRows.bind(this)}))),o={value:{data:i,metadata:l},done:m}}}return null==o&&(o={value:{data:c,metadata:u},done:!0}),null!=d&&this._recacheData(d,h),{expandedSkeletonKeys:s,expandingKeys:i=i.delete([e]),renderedData:o}}.bind(this))}.bind(this))},this._recacheData=(e,t)=>{for(let a=e.length-1;a>=0;a--){const n=e[a],r=t[a],s=r.parentKey,i=this._cachedIteratorsAndResults[null===s?"root":s].cache;null==i?this._cachedIteratorsAndResults[null===s?"root":s].cache={done:!1,value:{data:[n],metadata:[r]}}:(i.value.data.unshift(n),i.value.metadata.unshift(r))}},this._registerDomScroller=()=>{const t={asyncIterator:{next:this.fetchMoreRows.bind(this)},fetchSize:this.getFetchSize(),fetchTrigger:this.callback.getSkeletonHeight()*this.getLoadMoreCount(),maxCount:this._getMaxCount(),initialRowCount:this.getFetchSize(),strategy:e.VirtualizationStrategy.HIGH_WATER_MARK,isOverflow:this._getOverflowFunc(),success:this.handleFetchSuccess.bind(this),error:()=>{this._setNewData(null)},beforeFetch:()=>this.handleBeforeFetchNext(),beforeFetchByOffset:()=>{this.handleBeforeFetchByOffset()}};this.domScroller=new s(this._getScroller(),this.getDataProvider(),t)},this.getLoadMoreCount=()=>0,this._getOverflowFunc=()=>this._getScroller()!==this.root?this._isLastItemInViewport.bind(this):null,this._isLastItemInViewport=()=>{const e="."+this.callback.getItemStyleClass()+", ."+this.callback.getGroupStyleClass(),t=this.root.querySelectorAll(e),a=t[t.length-1];if(a){const e=a.getBoundingClientRect();if(e.top>=0&&e.bottom<=document.documentElement.clientHeight)return!1}return!0},this._cachedIteratorsAndResults={},this._clientId=Symbol(),this.fetchRows()}postRender(){this.initialFetch=!1}destroy(){super.destroy(),this.domScroller&&this.domScroller.destroy()}_isLoadMoreOnScroll(){return"loadMoreOnScroll"===this.scrollPolicy}_getScroller(){const e=this.scrollPolicyOptions.scroller;return null!=e?e:this.root}getFetchSize(){return this.scrollPolicyOptions.fetchSize}_getMaxCount(){return this.scrollPolicyOptions.maxCount}isInitialFetch(){return this.initialFetch}renderSkeletonsForLoadMore(){}renderSkeletonsForExpand(e){}renderFetchedData(e){if(null==this.callback)return;const t=this._renderOutOfRangeData();if(null==e||null==e.value)return t;const n=e.value.data,r=e.value.metadata;return n.length===r.length?(t.push(this.renderData(n,r)),this._isLoadMoreOnScroll()&&(e.done||(0===n.length&&a.info("handleFetchedData: zero data returned while done flag is false"),e.maxCountLimit||(null==this.domScroller&&this._registerDomScroller(),t.push(this.renderSkeletonsForLoadMore()))),e.maxCountLimit&&this._handleScrollerMaxRowCount()),t):void 0}handleBeforeFetchNext(){return!this.isFetching()}handleBeforeFetchByOffset(){}handleFetchSuccess(e){null!=e&&this._setNewData(e)}_handleFetchError(e){this.setFetching(!1),a.error("iterating dataprovider content handler fetch error :"+e)}_handleScrollerMaxRowCount(){}renderData(e,t){if(null==this.callback)return null;let n=[];const r=this.callback.getSkeletonKeys();for(let s=0;s<e.length;s++){if(null==e[s]||null==t[s])continue;if(!this.verifyKey(t[s].key)){a.error("encounted a key with invalid data type.  Acceptable data types for key are: "+this.validKeyTypes),n=[];break}const i=this.addItem(t[s],s,e[s],!0);i&&(n.push(i),r.has(t[s].key)&&n.push(this.renderSkeletonsForExpand(t[s].key)))}return n}_renderOutOfRangeData(){return[]}_handleItemsMutated(e,t,a,n){null!=this.callback&&this.callback.updateData(function(r,s){let i=s;const l={startIndex:r.startIndex,done:r.done,value:{data:r.value.data.slice(0),metadata:r.value.metadata.slice(0)}},o=Array.from(e[t]),d=o.map(e=>this._findIndex(r.value.metadata,e));this.domScroller&&a(d);const h=isNaN(r.startIndex)?0:r.startIndex,c=Math.max(h+r.value.data.length,this.getFetchSize());let u=!1;if(d.forEach((t,a)=>{const r=o[a],s=null!=e.data?e.data[a]:null,d=null!=e.metadata?e.metadata[a]:null;if(t>=h&&t<=c){const e=n(l,r,t,s,d,i);null!=e&&(i=e),u=!0}}),u)return i!==s?{renderedData:l,expandingKeys:i}:{renderedData:l}}.bind(this))}_findIndex(e,a){for(let n=0;n<e.length;n++)if(t.KeyUtils.equals(a,e[n].key))return n;return-1}handleModelRefresh(){this.domScroller&&this.domScroller.destroy(),this.domScroller=null,this._cachedIteratorsAndResults={},super.handleModelRefresh()}handleItemsAdded(e){null!=this.callback&&(this.callback.updateData(function(t,a){const n={startIndex:t.startIndex,done:t.done,maxCountLimit:t.maxCountLimit,value:{data:t.value.data.slice(0),metadata:t.value.metadata.slice(0)}};let r=e.indexes;const s=e.addBeforeKeys,i=e.parentKeys,l=[];let o;return null==r&&null==s&&null==i?n.done&&!n.maxCountLimit&&(n.value.data.push(e.data),o=this._updateMetadata(e.metadata,null,n),n.value.metadata.push(o)):null!=i&&(null==r&&(r=[]),i.forEach(function(t,a){const i=e.data[a],d=e.metadata[a];let h=-1;if(null===t||this._isExpanded(t)&&this._getItemByKey(t))if(null!=s)if(null!=s[a]){h=this._findIndex(n.value.metadata,s[a])}else{const e=this._getLastItemByParentKey(t,n);if(e&&(h=this._findIndex(n.value.metadata,e.metadata.key),h>-1&&(h+=1)),null==e||-1===h)return}else if(null!=r){const e=this._findIndex(n.value.metadata,t);h=-1===e?r[a]+1:e+r[a]+1}else h=this._findIndex(n.value.metadata,this._getLastItemByParentKey(t).metadata.key)+1;h>-1?(n.value.data.splice(h,0,i),o=this._updateMetadata(d,t,n),n.value.metadata.splice(h,0,o),-1===r.indexOf(h)&&r.push(h),this._isExpanded(d.key)&&l.push(d.key)):this._isExpanded(t)&&n.done&&!n.maxCountLimit&&(n.value.data.push(i),n.value.metadata.push(d))}.bind(this))),this.domScroller&&this.domScroller.handleItemsAdded&&this.domScroller.handleItemsAdded(r),{expandingKeys:a.add(l),renderedData:n}}.bind(this)),super.handleItemsAdded(e))}handleItemsRemoved(e){this._handleItemsMutated(e,"keys",e=>{this.domScroller.handleItemsRemoved&&this.domScroller.handleItemsRemoved(e)},(e,t)=>{const a=this._findIndex(e.value.metadata,t);if(a>-1){const t=d.getLocalDescendentCount(e.value.metadata,a)+1;e.value.data.splice(a,t),e.value.metadata.splice(a,t)}}),super.handleItemsRemoved(e)}handleCurrentRangeItemUpdated(){}handleItemsUpdated(e){this._handleItemsMutated(e,"keys",e=>{this.domScroller.handleItemsUpdated&&this.domScroller.handleItemsUpdated(e)},(e,t,a,n,r,s)=>{const i=e.value.metadata[a],l=i.isLeaf,o=this._updateMetadata(r,i.parentKey,{value:{data:[n],metadata:[r]}});return l&&!o.isLeaf&&(s=s.add([o.key])),e.value.data.splice(a,1,n),e.value.metadata.splice(a,1,o),this.handleCurrentRangeItemUpdated(),s}),super.handleItemsUpdated(e)}checkViewport(){if(this.domScroller&&this.isReady()){const e=this.domScroller.checkViewport();null!=e&&this.fetchPromise!==e&&(this.fetchPromise=e,e.then(function(e){this.fetchPromise=null,null!=e&&this.handleFetchSuccess(e)}.bind(this)))}}collapse(e){e.forEach(function(e){null!=this._cachedIteratorsAndResults[e]&&(this._cachedIteratorsAndResults[e].iterator=null,this._cachedIteratorsAndResults[e].cache=null)}.bind(this))}}d.getLocalDescendentCount=(e,t)=>{let a=0;const n=e[t].treeDepth,r=e.length;for(let s=t+1;s<r;s++){if(!(e[s].treeDepth>n))return a;a+=1}return a};class h extends HTMLElement{}e.IteratingDataProviderContentHandler=class extends i{constructor(t,a,n,r,s){super(t,a,n),this.root=t,this.dataProvider=a,this.callback=n,this.scrollPolicy=r,this.scrollPolicyOptions=s,this.fetchRows=()=>{if(this.isReady()){this.setFetching(!0);const e={clientId:this._clientId};e.size=this._isLoadMoreOnScroll()?this.getFetchSize():-1,this.dataProviderAsyncIterator=this.getDataProvider().fetchFirst(e)[Symbol.asyncIterator]();const t=this.addBusyState("call next on iterator"),a=this.dataProviderAsyncIterator.next(),n=e.size,r=e=>{if(e.done||-1!==n||"function"==typeof this.getDataProvider().getPageCount)return e;return this.dataProviderAsyncIterator.next().then(function(t){return e.done=t.done,e.value.data=e.value.data.concat(t.value.data),e.value.metadata=e.value.metadata.concat(t.value.metadata),r(e)},function(e){this.fetchError(e)})};a.then(e=>r(e),e=>(t(),this.setFetching(!1),this.fetchError(e),Promise.reject(e))).then(e=>{if(e){if(t(),null==this.callback)return;this.initialFetch=!0,this.callback.setData(e)}},e=>{if(null!=this.callback){const t={error:e,done:!0,value:{data:[],metadata:[]}};this.callback.setData(t)}})}},this._registerDomScroller=t=>{let a={fetchSize:this.getFetchSize(),maxCount:this._getMaxCount(),keys:t,strategy:this.isRenderingViewportOnly()?e.VirtualizationStrategy.VIEWPORT_ONLY:e.VirtualizationStrategy.HIGH_WATER_MARK};this.domScroller=new o(this._getScroller(),this.getDataProvider(),this.dataProviderAsyncIterator,this,a)},this._clientId=Symbol(),this.fetchRows()}getDataProvider(){if(null==this.wrappedDataProvider){const e=this.dataProvider.getCapability("fetchCapability");null==e||null==e.caching||"none"==e.caching?this.wrappedDataProvider=new r(this.dataProvider):this.wrappedDataProvider=this.dataProvider}return this.wrappedDataProvider}setDataProvider(e){this.wrappedDataProvider=null,this.dataProvider=e}postRender(){this.initialFetch=!1}destroy(){super.destroy(),this.domScroller&&this.domScroller.destroy()}isRenderingViewportOnly(){return!1}_isLoadMoreOnScroll(){return"loadMoreOnScroll"===this.scrollPolicy}_getScroller(){const e=this.scrollPolicyOptions.scroller;return null!=e?e:this.root}getFetchSize(){return this.scrollPolicyOptions.fetchSize}_getMaxCount(){return this.scrollPolicyOptions.maxCount}isInitialFetch(){return this.initialFetch}checkViewport(){this.domScroller&&this.domScroller.checkViewport()}renderSkeletonsForLoadMore(){}renderFetchedData(e){if(null==this.callback)return;const t=[];if(null==e||null==e.value)return t;const n=e.value.data,r=e.value.metadata,s=void 0===e.startIndex?0:e.startIndex;if(n.length===r.length){if(t.push(this.renderData(n,r,s)),this._isLoadMoreOnScroll()){if(!e.done&&(0===n.length&&a.info("handleFetchedData: zero data returned while done flag is false"),!e.maxCountLimit)){if(null==this.domScroller){const e=r.map(e=>e.key);this._registerDomScroller(e)}t.push(this.renderSkeletonsForLoadMore())}e.maxCountLimit&&this._handleScrollerMaxRowCount()}return this.setFetching(!1),t}}beforeFetchNext(){return null==this.domScrollerFetchResolve&&(this.domScrollerFetchResolve=this.addBusyState("dom scroller call next on iterator"),!0)}beforeFetchByOffset(e,t){return null==this.domScrollerFetchResolve&&(this.domScrollerFetchResolve=this.addBusyState("dom scroller call next on iterator")),!0}fetchSuccess(e){this.domScrollerFetchResolve(),this.domScrollerFetchResolve=null,null!=e&&null!=this.callback&&this.callback.setData(e)}fetchError(e){this.domScrollerFetchResolve&&(this.domScrollerFetchResolve(),this.domScrollerFetchResolve=null),"notValid"!==e&&a.error("an error occurred during data fetch, reason: "+e)}_handleScrollerMaxRowCount(){}renderData(e,t,n){if(null==this.callback)return null;let r=[];for(let s=0;s<e.length;s++){if(null==e[s]||null==t[s])continue;if(!this.verifyKey(t[s].key)){a.error("encounted a key with invalid data type.  Acceptable data types for key are: "+this.validKeyTypes),r=[];break}const i=this.addItem(t[s].key,s+n,e[s],!0);i&&r.push(i)}return r}_handleItemsMutated(e,t,a){this.callback.updateData(function(n){const r={startIndex:n.startIndex,done:n.done,value:{data:n.value.data.slice(0),metadata:n.value.metadata.slice(0)}};let s=e.indexes;const i=Array.from(e[t]);null==s&&(s=i.map(e=>this._findIndex(n.value.metadata,e)));const l=isNaN(n.startIndex)?0:n.startIndex,o=Math.max(l+n.value.data.length,this.getFetchSize());return s.forEach((t,n)=>{const s=i[n],d=null!=e.data?e.data[n]:null,h=null!=e.metadata?e.metadata[n]:null;t>=l&&t<=o&&a(r,s,t,d,h)}),{renderedData:r}}.bind(this))}_findIndex(e,a){for(let n=0;n<e.length;n++)if(t.KeyUtils.equals(a,e[n].key))return n;return-1}handleModelRefresh(){this.domScroller&&this.domScroller.destroy(),this.domScroller=null,super.handleModelRefresh()}handleItemsAdded(e){this.callback.updateData(function(t){let a={startIndex:t.startIndex,done:t.done,maxCountLimit:t.maxCountLimit,value:{data:t.value.data.slice(0),metadata:t.value.metadata.slice(0)}};const n=e.indexes,r=e.addBeforeKeys,s=e.keys;if(null==n&&null==r)a.done&&!a.maxCountLimit&&(a.value.data.push(e.data),a.value.metadata.push(e.metadata));else{let t=0;s.forEach(function(){const s=e.data[t],i=e.metadata[t];let l=-1;null!=n&&null!=n[t]?l=n[t]:null!=r&&null!=r[t]&&(l=this._findIndex(a.value.metadata,r[t])),l>-1&&l<a.value.data.length?(a.value.data.splice(l,0,s),a.value.metadata.splice(l,0,i)):a.done&&!a.maxCountLimit&&(a.done=!1,null==this.domScroller?this._registerDomScroller([]):this.domScroller.setAsyncIterator(this.dataProviderAsyncIterator)),t++}.bind(this))}return{renderedData:a}}.bind(this)),super.handleItemsAdded(e)}handleItemsRemoved(e){this._handleItemsMutated(e,"keys",(e,t)=>{const a=this._findIndex(e.value.metadata,t);a>-1&&(e.value.data.splice(a,1),e.value.metadata.splice(a,1))}),super.handleItemsRemoved(e)}handleCurrentRangeItemUpdated(e){}handleItemsUpdated(e){this._handleItemsMutated(e,"keys",(e,t,a,n,r)=>{e.value.data.splice(a,1,n),e.value.metadata.splice(a,1,r),this.handleCurrentRangeItemUpdated(t)}),super.handleItemsUpdated(e)}},e.IteratingTreeDataProviderContentHandler=d,e.KeyedElement=h,e.VirtualizeDomScroller=o,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojvcollection.js.map