/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojlogger","ojs/ojhtmlutils","ojs/ojcspexpressionevaluator","ojs/ojcustomelement-utils","preact","ojs/ojvcomponent-template","ojs/ojcontext","ojs/ojdataproviderhandler"],function(e,t,r,a,s,o,n,i,l){"use strict";a=a&&Object.prototype.hasOwnProperty.call(a,"default")?a.default:a,i=i&&Object.prototype.hasOwnProperty.call(i,"default")?i.default:i;class c extends o.Component{constructor(e){super(e),this._resolveConfig=e=>{e.then(t=>{e===this.props.config&&this.setState({view:this._getFragment(t.view),data:t.data})})},this._getFragment=e=>{const t=new DocumentFragment;return e.forEach(e=>{t.appendChild(e.cloneNode(this))}),t},this.state={view:null,data:null}}componentDidMount(){this._resolveConfig(this.props.config)}componentDidUpdate(e,t){this.props.config!==e.config&&this._resolveConfig(this.props.config)}render(){return o.h(o.Fragment,null,this.state.view&&this.state.data?n.executeFragment(null,this.state.view,this.state.data,this.forceUpdate.bind(this),this.props.bindingProvider):null)}}class u extends o.Component{constructor(e){super(e),this._addBusyState=e=>i.getContext(this.props.componentElement).getBusyContext().addBusyState({description:e}),this.BindForEachWithDP=l.withDataProvider(p,"data")}render(e){return Array.isArray(e.data)?o.h(d,{data:e.data,itemRenderer:e.itemRenderer}):o.h(this.BindForEachWithDP,{addBusyState:this._addBusyState,data:e.data,itemRenderer:e.itemRenderer})}}class p extends o.Component{render(e){const t=e.data.map(e=>e.data);return o.h(d,{data:t,itemRenderer:e.itemRenderer})}}class d extends o.Component{render(){const e=this.props.data;return o.h(o.Fragment,null,e?e.map((e,t)=>this.props.itemRenderer({data:e,index:t,observableIndex:()=>t})):[])}}const h=Symbol(),_=Symbol(),m=Symbol();class v{constructor(){this._templateAstCache=new WeakMap,this._cspEvaluator=new a}static cleanupTemplateCache(e){e&&e._cachedRows&&(e._cachedRows.forEach(e=>e.dispose()),e._cachedRows=[])}executeFragment(e,t,r,a,o){var n;let i=o;return i||(i=e?null===(n=s.CustomElementUtils.getElementState(e))||void 0===n?void 0:n.getBindingProvider():null),this._execute({[h]:i,[_]:e},t,r,a)}execute(e,t,r,a,s){const o=t.getAttribute("data-oj-as"),n=this._getContext(a,e,t,r,o);return this._execute({[h]:a,[_]:e},t,n,s)}_execute(e,t,r,a){const s=this._getAstViaCache(e,t),n=e[h];if(n){t._cachedRows||Object.defineProperties(t,{_cachedRows:{writable:!0,value:[]}});const e=n.__KoComputed(()=>{if(n.__KoIsInitial())return this._cspEvaluator.evaluate(s,{$context:r,$h:o.h,BindDom:c});v.cleanupTemplateCache(t),a()});return t._cachedRows.push(e),e()}return this._cspEvaluator.evaluate(s,{$context:r,$h:o.h,BindDom:c})}_getContext(e,r,a,s,o){if(e){let n=e.__ContextFor(a);return n||(t.info(`Binding context not found when processing template for element with id: ${r.id}. Using binding context for element instead.`),n=e.__ContextFor(r)),e.__ExtendBindingContext(n,s,null,o,r)}const n={$current:s};return o&&(n[o]=s),n}_getAstViaCache(e,t){let a=this._templateAstCache.get(t);if(!a){if(11===t.nodeType)a=this._createAst(e,Array.from(t.childNodes));else{const s=r.getTemplateContent(t)[0];a=this._createAst(e,Array.from(s.childNodes))}this._templateAstCache.set(t,a)}return a}_createAst(e,t){const r={type:9,elements:[]};return r.elements=Array.prototype.reduce.call(t,(t,r)=>{const a=this._processSpecialNodes(e,r);return a?t.push(a):3===r.nodeType?t.push({type:3,value:r.nodeValue}):1===r.nodeType&&t.push(this._createElementNode(e,r)),t},[]),r}_processSpecialNodes(e,t){if(1===t.nodeType)switch(t.tagName.toLowerCase()){case"oj-bind-text":return this._createExpressionNode(e,t.getAttribute("value"));case"oj-bind-if":return this._createIfExpressionNode(e,t);case"oj-bind-for-each":return this._createBindForEachExpressionNode(e,t);case"oj-bind-dom":return this._createBindDomExpressionNode(e,t);case"oj-defer":return this._createDeferNode(e,t)}return null}_createDeferContent(e,t,r){const a={view:t,data:r},s={config:Promise.resolve(a),bindingProvider:e[h]};return o.h(c,s)}_createDeferNode(e,t){let r,a=this._createDeferContent(e,[],{});const s=[{key:"ref",value:{type:3,value:e=>{e?(r=e,o.render(a,r)):o.render(null,r)}}},{key:"_activateSubtree",value:this._createCallNodeWithContext(r=>s=>{a=this._createDeferContent(e,Array.from(t.childNodes),r),o.render(a,s)})}];let n=this._getElementProps(e,t);return n=n.concat(s),{type:4,callee:{type:1,name:"$h"},arguments:[{type:3,value:"oj-defer"},{type:10,properties:n}]}}_createIfExpressionNode(e,t){if(!t.hasAttribute("test"))throw new Error("Missing the retuired 'test' attribute on <oj-bind-if>");return{type:5,operator:"...",argument:{type:8,test:this._createExpressionNode(e,t.getAttribute("test")),consequent:this._createAst(e,Array.from(t.childNodes)),alternate:{type:3,value:[]}}}}_createBindForEachExpressionNode(e,t){const r=t.getElementsByTagName("template")[0];if(!r)throw new Error("Template not found: oj-bind-for-each requires a single template element as its direct child");return this._createComponentNode(e,t,u,[{key:"itemRenderer",value:this._createNestedTemplateRendererNode(e,r)},{key:"componentElement",value:{type:3,value:e[_]}}])}_createNestedTemplateRendererNode(e,t){const r=t.getAttribute("data-oj-as"),a={[h]:e[h],[_]:e[_],[m]:(e,t)=>"function"!=typeof t||"$current.observableIndex"!==e&&e!==r+".observableIndex"?t:t()},s=this._getAstViaCache(a,t);return this._createCallNodeWithContext(e=>t=>{const a={$current:t};null!=r&&(a[r]=t);const n=Object.assign({},e,a);return this._cspEvaluator.evaluate(s,{$context:n,$h:o.h})})}_createElementNode(e,t,r,a){var s=this._getElementProps(e,t);return s=a?s.concat(a):s,{type:4,callee:{type:1,name:"$h"},arguments:[{type:3,value:r||t.tagName.toLowerCase()},{type:10,properties:s},this._createAst(e,Array.from(t.childNodes))]}}_createBindDomExpressionNode(e,t){if(!t.hasAttribute("config"))throw new Error("Missing the required 'config' attribute on <oj-bind-dom>");const r=t.attributes.config.value;return this._createComponentNode(e,t,c,[this._createPropertyNode(e,"config",r,e=>Promise.resolve(e)),{key:"bindingProvider",value:{type:3,value:e[h]}}])}_createComponentNode(e,t,r,a){let s=this._getElementProps(e,t);return s=a?s.concat(a):s,{type:4,callee:{type:1,name:"$h"},arguments:[{type:3,value:r},{type:10,properties:s}]}}_createPropertyNode(e,t,r,a){return{key:t,value:this._createExpressionNode(e,r,a)}}_postprocessClassNameValue(e){let t;return t=Array.isArray(e)?e.join(" "):"string"!=typeof e?Object.keys(e).reduce((t,r)=>(e[r]&&t.push(r),t),[]).join(" "):e,t}_getElementProps(e,t){let r;const a=[],o=[],n=new Map,i=Array.prototype.reduce.call(t.attributes,(t,i)=>{let l=i.name;const c=i.value;if(l.startsWith(":")){l=l.substring(1);const o=l.split(".");2===o.length&&"style"===o[0]?a.push({k:o[1],v:c}):"style"===l?r=c:"class"===l?t.push(this._createPropertyNode(e,"className",c,this._postprocessClassNameValue)):(l=s.AttributeUtils.isGlobalOrData(l)?s.AttributeUtils.getGlobalPropForAttr(l):s.AttributeUtils.attributeToPropertyName(l),t.push(this._createPropertyNode(e,l,c)))}else{const r=s.AttributeUtils.getExpressionInfo(c);if(s.AttributeUtils.isEventListenerAttr(l))l=s.AttributeUtils.eventAttrToPreactPropertyName(l),n.set(l,c);else if(s.AttributeUtils.isGlobalOrData(l))t.push(this._createPropertyNode(e,s.AttributeUtils.getGlobalPropForAttr(l),c));else{const a=l.indexOf(".")>=0;r.expr?t.push({key:a?l:s.AttributeUtils.attributeToPropertyName(l),value:this._createExpressionEvaluator(e,r.expr)}):t.push({key:l.toUpperCase(),value:{type:3,value:c}})}r.downstreamOnly||o.push({name:l,value:r.expr})}return t},[]);if(null!=r){if(a.length>0)throw new Error("Binding the entire style attribute as well as the individual style properties on the same element is not supported");i.push(this._createPropertyNode(e,"style",r))}else a.length>0&&i.push({key:"style",value:{type:10,properties:a.map(t=>this._createPropertyNode(e,s.AttributeUtils.attributeToPropertyName(t.k),t.v))}});return o.forEach(t=>{var r;const a=`on${t.name}Changed`,o=n.get(a);o&&n.delete(a),i.push(this._createWritebackPropertyNode(e,a,t.value,null===(r=s.AttributeUtils.getExpressionInfo(o))||void 0===r?void 0:r.expr))}),n.forEach((e,t)=>{const r=s.AttributeUtils.getExpressionInfo(e);r.expr&&i.push(this._createEventListenerPropertyNode(t,r.expr))}),i}_createWritebackPropertyNode(e,t,r,a){let s,o;return{key:t,value:this._createCallNodeWithContext(t=>n=>{s||(s=this._cspEvaluator.createEvaluator(r).evaluate);const i=s([t,t.$data]);if(e[h]&&e[h].__IsObservable(i))i(n.detail.value);else{const e=this._getPropertyWriterExpression(r);if(null!==e){const r=this._cspEvaluator.createEvaluator(e).evaluate;this._getWriter(r([t.$data||{},t]))(n.detail.value)}}a&&!o&&(o=this._cspEvaluator.createEvaluator(a).evaluate);const l=o?o([t,t.$data]):null;l&&l(n,t.$current||t.$data,t)})}}_createEventListenerPropertyNode(e,t){let r;return{key:e,value:this._createCallNodeWithContext(e=>a=>{r||(r=this._cspEvaluator.createEvaluator(t).evaluate);const s=r([e,e.$data]);s&&s(a,e.$current||e.$data,e)})}}_createExpressionNode(e,t,r){const a=s.AttributeUtils.getExpressionInfo(t);return a.expr?this._createExpressionEvaluator(e,a.expr,r):{type:3,value:t}}_createExpressionEvaluator(e,t,r){const a=this._cspEvaluator.createEvaluator(t).evaluate;return this._createCallNodeWithContext(s=>{const o=e[h],n=o?o.__UnwrapObservable(s):s,i=a([n,n.$data]);let l=o?o.__UnwrapObservable(i):i;return e[m]&&(l=e[m](t,l)),r?r(l):l})}_createCallNodeWithContext(e){return{type:4,callee:{type:3,value:e},arguments:[{type:1,name:"$context"}]}}_getWriter(e){return e._ko_property_writers}_getPropertyWriterExpression(e){if(null==e||["true","false","null","undefined"].indexOf(e)>=0)return null;const t=(e=e.trim()).match(/^(?:[$_a-z][$\w]*|(.+)(\.\s*[$_a-z][$\w]*|\[.+\]))$/i);if(null===t)return null;return`{_ko_property_writers: function(v){${t[1]?`Object(${t[1]})${t[2]}`:e}=v;}}`}}const y=new v,g=y.executeFragment.bind(y),f=y.execute.bind(y),b=v.cleanupTemplateCache;e.cleanupTemplateCache=b,e.execute=f,e.executeFragment=g,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojvcomponent-template.js.map